/* Copyright Statement:
*
* This software/firmware and related documentation ("MediaTek Software") are
* protected under relevant copyright laws. The information contained herein is
* confidential and proprietary to MediaTek Inc. and/or its licensors. Without
* the prior written permission of MediaTek inc. and/or its licensors, any
* reproduction, modification, use or disclosure of MediaTek Software, and
* information contained herein, in whole or in part, shall be strictly
* prohibited.
*
* Copyright  (C) [2020]  MediaTek Inc. All rights reserved.
*
* BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
* THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
* RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
* ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
* WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
* WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
* NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
* RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
* INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
* TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
* RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
* OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
* SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
* RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
* STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
* ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
* RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
* MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
* CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
*
* The following software/firmware and/or related documentation ("MediaTek
* Software") have been modified by MediaTek Inc. All revisions are subject to
* any receiver's applicable license agreements with MediaTek Inc.
*/

#ifndef _DTBO_H_
#define _DTBO_H_

#define DEFAULT_DTB_PART	"bootdata"
#ifdef CONFIG_MULTIPLE_DTB_SELECTION
#define KEY_BUFFER_SIZE  32
#define STRING_BUFFER_SIZE  256
#define DIGIT_NUM  10
#define ANDROID_BOOTARGS_DTBO_IDX	"androidboot.dtbo_idx"

#define DTBO_DEF_ENV_NAME	"dtbo_cfg_part"
#define DTBO_DEF_PART	"bootdata"
#define MAPPING_CFG_ENV_NAME	"dtbo_mapping_cfg"
#define MAPPING_CFG_DEF_PATH	"dtbo_mapping.ini"
#define WHITELIST_ENV_NAME	"dtbo_whitelist"
#define WHITELIST_DEF_PATH	"dtb/dtbo_whitelist.ini"
#define CFG_SEL_ENV_NAME	"dtbo_cfg_sel"
#define CFG_SEL_DEF_PATH	"dtb/mt5896_h2v1.ini"

#ifdef CONFIG_DATA_SEPARATION
#define DTB_OVERLAY_SECTION	"Boot"
#define MAPPING_CFG_KEY	"m_pboot_mapping_cfg_File"
#define WHITELIST_KEY	"m_pboot_whitelist_File"
#define CFG_SEL_KEY	"m_pboot_cfg_sel_File"
#endif

enum INI_FILE_TYPE{
    DTB_MAPPING = 0,
    WHITELIST,
    CFG_SELECT,
    INI_TYPE_NOT_SUPPORT
};

int get_dtbo_cfg_selection(char *partition, char *cfg_name, char *type, char *setting);
int set_dtbo_cfg_selection(char *partition, char *cfg_name);
int ls_dtbo_cfg(char *partition);

typedef struct{
	int dtbo_id;
	struct list_head list;
}DTBO_IDX_T;

#else
typedef enum {
	DEVICE_BOARD,
	DEVICE_MAX,
}E_DEVICE_TYPE;

int is_device_id_valid(int device_id);
int get_device_id(int device_type);
#endif
int dtbo_selection_and_overlay(void);
int get_dtbo_img_size(unsigned long dtbo_img_addr, unsigned long *dtbo_img_size);
int verify_dtbo_img(unsigned char *auth_data, unsigned char *sign_data, unsigned long auth_size);

#endif

