/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to MediaTek Inc. and/or its licensors. Without
 * the prior written permission of MediaTek inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of MediaTek Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * Copyright  (C) [2022]  MediaTek Inc. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
 * SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
 * MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek
 * Software") have been modified by MediaTek Inc. All revisions are subject to
 * any receiver's applicable license agreements with MediaTek Inc.
 */

#include <common.h>
#include <command.h>
#include <debug_impl.h>

//=====================================================================================================
//
#define EFUSE_2     2

int mdrv_efuse_read_subbank_reg_U32( unsigned char u8SubBank, unsigned int * pu32RegVal);

int do_efuse_test(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    int ret = 0;
    unsigned short u16SubBank;
    unsigned int u32RegVal = 0;
    int i_rtn;


    //UBOOT_TRACE("IN\n");

    printf("{%s,%d} efuse test ...\n", __func__, __LINE__ );

    for( u16SubBank = 0; u16SubBank <= 0xFF; u16SubBank += 1 )
    {
        printf("--------------------------- Read u8SubBank:0x%X --------------------------\n", u16SubBank );
        //printf("{%s,%d} call mdrv_efuse_read_subbank_reg_U32( u8SubBank:0x%X,)\n", __func__, __LINE__, u8SubBank );

        u32RegVal = 0;
        i_rtn = mdrv_efuse_read_subbank_reg_U32( u16SubBank, &u32RegVal);
        if( i_rtn != 0 )
        {
            printf("{%s,%d} mdrv_efuse_read_subbank_reg_U32( u8SubBank:0x%X,) => i_rtn:%d\n", __func__, __LINE__, u16SubBank, i_rtn );
        }
        else
        {
            printf("{%s,%d} mdrv_efuse_read_subbank_reg_U32( u8SubBank:0x%X,) => Val:0x%X\n", __func__, __LINE__, u16SubBank, u32RegVal );
        }
    }


    //UBOOT_TRACE("OK\n");

    return ret;
}

U_BOOT_CMD(
    efuse_test, EFUSE_2, 1,    do_efuse_test,
    "efuse_test - Test read efuse\n",
    NULL
);


