/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to MediaTek Inc. and/or its licensors. Without
 * the prior written permission of MediaTek inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of MediaTek Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * Copyright  (C) [2020]  MediaTek Inc. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
 * SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
 * MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek
 * Software") have been modified by MediaTek Inc. All revisions are subject to
 * any receiver's applicable license agreements with MediaTek Inc.
 */

#include <common.h>
#include <command.h>
#include <debug_impl.h>
#include <standby_impl.h>
#include <iniutility.h>
#include <standby_mode.h>
#include <upgrade_utility.h>
//-------------------------------------------------------------------------------------------------
//  Global Variables
//-------------------------------------------------------------------------------------------------
#define COMMAND_ARGUMENT_NUM_TWO    2

int do_run_standby_mode (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    int ret = 0;
    char *usb_upgrade_complete = NULL;
    /*int qhb_mode = standby_mode_get_mode();*/
    int enter_standby = standby_mode_is_enter_standby();
    int second_standby_mode = standby_mode_get_second_standby_mode();

    UBOOT_TRACE("start\n");
    UBOOT_DEBUG("second_standby_mode =%d  enter_standby=%d\n", second_standby_mode, enter_standby);
    if (standby_mode_enter_standby())
    {
        ret = mtk_standby_mode_framework();
        if(ret != 0)
        {
            UBOOT_ERROR("do_run_standby_mode failure\n");
            return ret;
        }
    }

    usb_upgrade_complete = env_get(ENV_UPGRADE_COMPLETE);
    if (usb_upgrade_complete != NULL && strncmp(usb_upgrade_complete, "1", 1) == 0)
    {
        env_set(ENV_UPGRADE_COMPLETE, NULL);
        env_save();
    }

    UBOOT_TRACE("end\n");
    return 0;
}

U_BOOT_CMD(
    standby, 2, 1,    do_run_standby_mode,
    "standby  - run standby mode framework\n",
    NULL
);

int do_standby_init(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    int ret = 0;

    UBOOT_TRACE("start\n");
    ret = standby_init();
    if (ret != 0)
    {
        UBOOT_ERROR("standby_init failure, can not read data from standby_mode.ini\n");
    }

    UBOOT_TRACE("end\n");
    return 0;
}

U_BOOT_CMD(
    standbyinit, COMMAND_ARGUMENT_NUM_TWO, 1,    do_standby_init,
    "standbyinit  - Get standby mode information\n",
    NULL
);
