/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to MediaTek Inc. and/or its licensors. Without
 * the prior written permission of MediaTek inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of MediaTek Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * Copyright  (C) [2020]  MediaTek Inc. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
 * SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
 * MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek
 * Software") have been modified by MediaTek Inc. All revisions are subject to
 * any receiver's applicable license agreements with MediaTek Inc.
 */

#include <common.h>
#include <command.h>
#include <time.h>

#include "debug_impl.h"
#include "cm4_impl.h"

#define VAD_DEVNODE "/vad_rproc"
#define VAD_MAXARGS (2)
#define VAD_REP (1)

int do_boot_vad (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    unsigned int start = 0, end = 0;
    int ret = 0;

    UBOOT_TRACE("do command: boot_vad.\n");
    start = get_timer(0);
    ret = cm4_loader(VAD_DEVNODE);
    end = get_timer(0);
    UBOOT_INFO("\n[boot_vad][start:%u][end:%u][total time:%u].\n", start, end, end - start);
    return ret;
}

U_BOOT_CMD(
    boot_vad, VAD_MAXARGS, VAD_REP, do_boot_vad,
    "boot coprocessor with vad\n",
    NULL
);

int do_stop_vad(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    unsigned int start = 0, end = 0;
    int ret = 0;

    UBOOT_TRACE("do command: stop_vad.\n");
    start = get_timer(0);
    ret = cm4_stop(VAD_DEVNODE);
    end = get_timer(0);
    UBOOT_INFO("\n[stop_vad][start:%u][end:%u][total time:%u].\n", start, end, end - start);
    return ret;
}

U_BOOT_CMD(
    stop_vad, VAD_MAXARGS, VAD_REP, do_stop_vad,
    "stop coprocessor with vad\n",
    NULL
);
