/* SPDX-License-Identifier: GPL-2.0-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2 of the GNU General Public License ("GPLv2 License")
 * or BSD License.
 *
 * GPLv2 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
#ifndef _MDRV_FCIC_H_
#define _MDRV_FCIC_H_

#define FCIC_CHECKSUM_SIZE    4
#define FCIC_CRC_SIZE         4
#define FCIC_EXTRA_SIZE      (FCIC_CHECKSUM_SIZE + FCIC_CRC_SIZE)

#if(CONFIG_DEMURA_FCIC_SQ1819)
#define FCIC_DATA_START      0x00000
#else
#define FCIC_DATA_START      0x60000
#endif

// Assuming FCICBin Store from Flash address(0x0000)
typedef struct
{
    // Offset: 0x00 ~ 0x03
    MS_U32 BinCRC;

    // Offset: 0x04 ~ 0x07
    MS_U32 LutFlashAddr;

    // Offset: 0x08 ~ 0x0B
    MS_U32 LutSize;

    // Offset: 0x0C ~ 0x0F
    MS_U32 VendorIdSize;

    // Offset: 0x10 ~ 0x13
    MS_U32 FileSize;

    // Offset: 0x14 ~ 0x40
    MS_U32 reserve[11];
} FCICBinHeader;


MS_BOOL MDrv_FCIC_SetIOMapBase(void);
MS_BOOL MDrv_FCIC_Checksum(MS_U8 *lut_buf, MS_U32 offset, MS_U32 lut_len);
MS_BOOL MDrv_FCIC_Set_BDMA(MS_PHYADDR lut_phyAddr, MS_U32 lut_size);
void MDrv_FCIC_TurnOn(MS_BOOL bOnOff);

#endif  //_MDRV_FCIC_H_
