/*------------------------------------------------------------------------------
* MediaTek Inc. (C) 2020. All rights reserved.
*
* Copyright Statement:
*
* This software/firmware and related documentation ("MediaTek Software") are
* protected under relevant copyright laws. The information contained herein is
* confidential and proprietary to MediaTek Inc. and/or its licensors. Without
* the prior written permission of MediaTek inc. and/or its licensors, any
* reproduction, modification, use or disclosure of MediaTek Software, and
* information contained herein, in whole or in part, shall be strictly
* prohibited.
*
* BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
* THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
* RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
* ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
* WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
* WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
* NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
* RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
* INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
* TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
* RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
* OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
* SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
* RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
* STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
* ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
* RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
* MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
* CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
*
* The following software/firmware and/or related documentation ("MediaTek
* Software") have been modified by MediaTek Inc. All revisions are subject to
* any receiver's applicable license agreements with MediaTek Inc.
*----------------------------------------------------------------------------*/

////////////////////////////////////////////////////////////////////////////////////////////////////
// file   osalHVD.h
// @brief  HVD Driver Interface
// @author MediaTek Inc.
////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////
// Modify from osalHVD_EX.h BY Apple.Chen //
////////////////////////////////////////////

#ifndef __OSAL_MVOP_H__
#define __OSAL_MVOP_H__

#include "MsOS.h"

//#if defined( MSOS_TYPE_LINUX) || defined( MSOS_TYPE_ECOS) || defined( MSOS_TYPE_NOS)
//    #define HVD_ENABLE_MSOS_SYSTEM_CALL     1
//#endif


//#define HVD_ISR_VECTOR          E_INT_IRQ_SVD_HVD
#define OSAL_MVOP_MUTEX_TIMEOUT  MSOS_WAIT_FOREVER



MS_S32 OSAL_MVOP_MutexCreate(MS_U8* pu8Name);
MS_BOOL OSAL_MVOP_MutexObtain(MS_S32 s32MutexId, MS_U32 u32Timeout);
MS_BOOL OSAL_MVOP_MutexRelease(MS_S32 s32MutexId);
MS_BOOL OSAL_MVOP_MutexDelete(MS_S32 s32MutexId);

//MS_BOOL OSAL_HVD_ISR_Attach(void* pfnISRCB);
//MS_BOOL OSAL_HVD_ISR_Detach(void);
//MS_BOOL OSAL_HVD_ISR_Enable(void);
//MS_BOOL OSAL_HVD_ISR_Disable(void);

#endif //#ifndef __OSAL_HVD_H__

