//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////
#ifndef _DRV_PQ_HSYBIN_H_
#define _DRV_PQ_HSYBIN_H_

#ifdef __cplusplus
extern "C"
{
#endif
//-------------------------------------------------------------------------------------------------
//  Macro and Define
//-------------------------------------------------------------------------------------------------
#if (ENABLE_PQ_BIN_HSY)
/* HSY Bin >> Header (S)*/
//enum
#define LEN_CONFIG                               0x00000002
#define MAIN_BIN                                 0x00000001
#define COLOR_SPACE_MASK                         0x000003f0
#define COLOR_SPACE_BT_709                       0x00000010
#define COLOR_SPACE_SRGB                         0x00000020
#define COLOR_SPACE_DOLBY                        0x00000030
#define COLOR_SPACE_XVYCC                        0x00000040
#define COLOR_SPACE_BT_470_6                     0x00000050
#define COLOR_SPACE_BT_601_625                   0x00000060
#define COLOR_SPACE_PAL                          0x00000070
#define COLOR_SPACE_SECAM                        0x00000080
#define COLOR_SPACE_BT_601_525                   0x00000090
#define COLOR_SPACE_NTSC                         0x000000a0
#define COLOR_SPACE_SMPTE_170M                   0x000000b0
#define COLOR_SPACE_SMPTE_240M                   0x000000c0
#define COLOR_SPACE_GENERIC_FILM                 0x000000d0
#define COLOR_SPACE_BT2020_CL                    0x000000e0
#define COLOR_SPACE_BT2020_NCL                   0x000000f0
#define COLOR_SPACE_CIEXYZ                       0x00000100
#define COLOR_SPACE_P3                           0x00000110
#define COLOR_SPACE_ADOBERGB                     0x00000120
#define SET_COLOR_SPACE(_config,_filter) do{_config[0] &=0xfffffc0f;_config[0] |=_filter;} while(0)
#define DIMENSION_MASK                           0xc0000000
#define DIMENSION_2D                             0x40000000
#define DIMENSION_3D                             0x80000000
#define SET_DIMENSION(_config,_filter) do{_config[0] &=0x3fffffff;_config[0] |=_filter;} while(0)
#define FRAME_RATE_MASK                          0x3e000000
#define FRAME_RATE_24                            0x02000000
#define FRAME_RATE_30                            0x04000000
#define FRAME_RATE_50                            0x06000000
#define FRAME_RATE_60                            0x08000000
#define FRAME_RATE_120                           0x0a000000
#define FRAME_RATE_144                           0x0c000000
#define FRAME_RATE_240                           0x0e000000
#define SET_FRAME_RATE(_config,_filter) do{_config[0] &=0xc1ffffff;_config[0] |=_filter;} while(0)
#define GRULE_IDX_MASK                           0xfc000000
#define GRULE_IDX_PICTUREMODE_AUTO               0x04000000
#define GRULE_IDX_PICTUREMODE_GAME               0x08000000
#define GRULE_IDX_PICTUREMODE_LIGHTNESS          0x0c000000
#define GRULE_IDX_PICTUREMODE_NATURAL            0x10000000
#define GRULE_IDX_PICTUREMODE_PC                 0x14000000
#define GRULE_IDX_PICTUREMODE_SOFT               0x18000000
#define GRULE_IDX_PICTUREMODE_SPORTS             0x1c000000
#define GRULE_IDX_PICTUREMODE_STANDARD           0x20000000
#define GRULE_IDX_PICTUREMODE_USER               0x24000000
#define GRULE_IDX_PICTUREMODE_VIVID              0x28000000
#define GRULE_IDX_PICTUREMODE_AI_PQ              0x2c000000
#define GRULE_IDX_PICTUREMODE_OFF                0x30000000
#define SET_GRULE_IDX(_config,_filter) do{_config[1] &=0x03ffffff;_config[1] |=_filter;} while(0)
#define HDR_SDR_MASK                             0x00003c00
#define HDR_SDR_HDR                              0x00000400
#define HDR_SDR_SDR                              0x00000800
#define HDR_SDR_HLG                              0x00000c00
#define HDR_SDR_DOLBY                            0x00001000
#define HDR_SDR_TECHNICOLOR                      0x00001400
#define SET_HDR_SDR(_config,_filter) do{_config[0] &=0xffffc3ff;_config[0] |=_filter;} while(0)
#define RESOLUTION_MASK                          0x0000000f
#define RESOLUTION_480                           0x00000001
#define RESOLUTION_576                           0x00000002
#define RESOLUTION_720                           0x00000003
#define RESOLUTION_1080                          0x00000004
#define RESOLUTION_FHD                           0x00000005
#define RESOLUTION_4K2K                          0x00000006
#define RESOLUTION_8K4K                          0x00000007
#define SET_RESOLUTION(_config,_filter) do{_config[0] &=0xfffffff0;_config[0] |=_filter;} while(0)
#define RGB_YUV_MASK                             0x0000c000
#define RGB_YUV_RGB                              0x00004000
#define RGB_YUV_YUV                              0x00008000
#define SET_RGB_YUV(_config,_filter) do{_config[0] &=0xffff3fff;_config[0] |=_filter;} while(0)
#define SCALING_RATIO_MASK                       0x0000000f
#define SCALING_RATIO_1                          0x00000001
#define SCALING_RATIO_2                          0x00000002
#define SCALING_RATIO_3                          0x00000003
#define SCALING_RATIO_4                          0x00000004
#define SCALING_RATIO_5                          0x00000005
#define SCALING_RATIO_6                          0x00000006
#define SCALING_RATIO_7                          0x00000007
#define SCALING_RATIO_8                          0x00000008
#define SCALING_RATIO_9                          0x00000009
#define SCALING_RATIO_10                         0x0000000a
#define SET_SCALING_RATIO(_config,_filter) do{_config[1] &=0xfffffff0;_config[1] |=_filter;} while(0)
#define SCANNING_MASK                            0x000c0000
#define SCANNING_INTERLACED                      0x00040000
#define SCANNING_PROGRESSIVE                     0x00080000
#define SET_SCANNING(_config,_filter) do{_config[0] &=0xfff3ffff;_config[0] |=_filter;} while(0)
#define SOURCE_MASK                              0x01f00000
#define SOURCE_HDMI                              0x00100000
#define SOURCE_AV                                0x00200000
#define SOURCE_LVDS                              0x00300000
#define SOURCE_DTV                               0x00400000
#define SOURCE_SCART                             0x00500000
#define SOURCE_PC                                0x00600000
#define SOURCE_DVI                               0x00700000
#define SOURCE_MM_PHOTO                          0x00800000
#define SOURCE_MM_ONLINE                         0x00900000
#define SOURCE_MM_VIDEO                          0x00a00000
#define SOURCE_ATV                               0x00b00000
#define SOURCE_YPBPR                             0x00c00000
#define SET_SOURCE(_config,_filter) do{_config[0] &=0xfe0fffff;_config[0] |=_filter;} while(0)
#define SPECIAL_MASK                             0x03ff0000
#define SET_SPECIAL(_config,_filter) do{_config[1] &=0xfc00ffff;_config[1] |=_filter;} while(0)
#define SUBSAMPLE_MASK                           0x00030000
#define SUBSAMPLE_444                            0x00010000
#define SUBSAMPLE_422                            0x00020000
#define SUBSAMPLE_420                            0x00030000
#define SET_SUBSAMPLE(_config,_filter) do{_config[0] &=0xfffcffff;_config[0] |=_filter;} while(0)
#define TOTAL_WINDOW_MASK                        0x0000fc00
#define TOTAL_WINDOW_0                           0x00000400
#define TOTAL_WINDOW_1                           0x00000800
#define TOTAL_WINDOW_2                           0x00000c00
#define TOTAL_WINDOW_3                           0x00001000
#define TOTAL_WINDOW_4                           0x00001400
#define TOTAL_WINDOW_5                           0x00001800
#define TOTAL_WINDOW_6                           0x00001c00
#define TOTAL_WINDOW_7                           0x00002000
#define TOTAL_WINDOW_8                           0x00002400
#define TOTAL_WINDOW_9                           0x00002800
#define TOTAL_WINDOW_10                          0x00002c00
#define TOTAL_WINDOW_11                          0x00003000
#define TOTAL_WINDOW_12                          0x00003400
#define TOTAL_WINDOW_13                          0x00003800
#define TOTAL_WINDOW_14                          0x00003c00
#define TOTAL_WINDOW_15                          0x00004000
#define TOTAL_WINDOW_16                          0x00004400
#define SET_TOTAL_WINDOW(_config,_filter) do{_config[1] &=0xffff03ff;_config[1] |=_filter;} while(0)
#define WINDOW_ID_MASK                           0x000003f0
#define WINDOW_ID_0                              0x00000010
#define WINDOW_ID_1                              0x00000020
#define WINDOW_ID_2                              0x00000030
#define WINDOW_ID_3                              0x00000040
#define WINDOW_ID_4                              0x00000050
#define WINDOW_ID_5                              0x00000060
#define WINDOW_ID_6                              0x00000070
#define WINDOW_ID_7                              0x00000080
#define WINDOW_ID_8                              0x00000090
#define WINDOW_ID_9                              0x000000a0
#define WINDOW_ID_10                             0x000000b0
#define WINDOW_ID_11                             0x000000c0
#define WINDOW_ID_12                             0x000000d0
#define WINDOW_ID_13                             0x000000e0
#define WINDOW_ID_14                             0x000000f0
#define WINDOW_ID_15                             0x00000100
#define WINDOW_ID_16                             0x00000110
#define SET_WINDOW_ID(_config,_filter) do{_config[1] &=0xfffffc0f;_config[1] |=_filter;} while(0)
#define GRULE_PICTUREMODE                        0x00000000
#define COMPARE(_label,_rule) (((_rule.pu32Mask[0]&_label[0])==_rule.pu32Label[0]) && ((_rule.pu32Mask[1]&_label[1])==_rule.pu32Label[1]))
/* HSY Bin >> Header (E) */
#endif

#ifdef __cplusplus
}
#endif

#endif /* _DRV_PQ_HSYBIN_H_ */
