//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// (!¡±MStar Confidential Information!¡L) by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////
//==============================================================================
#ifndef MHAL_PQ_H
#define MHAL_PQ_H

#define MEMFMT24BIT_YC10BIT_MOT     0xBB
#define MEMFMT24BIT_YC8BIT_MOT      0xAA
#define MEMFMT24BIT_YC10BIT         0x99
#define MEMFMT24BIT_YC8BIT          0x88
#define MEMFMT24BIT_CLEAR           0x00
#define MEMFMT20BIT_YCM             0x66
#define MEMFMT20BIT_YCL             0x55
#define MEMFMT20BIT_YC              0x44
#define MEMFMT16BIT_YC              0x00
#define MEMFMT12BIT_YM              0xDD
#define MEMFMT30BIT_RGBL            0x33
#define MEMFMT24BIT_RGB             0x11
#define IP_OP_ENABLE_FMT            0x300

#define SC_FILTER_Y_SRAM1               (0x00)
#define SC_FILTER_Y_SRAM2               (0x01)
#define SC_FILTER_Y_SRAM3               (0x02)
#define SC_FILTER_Y_SRAM4               (0x03)
#define SC_FILTER_C_SRAM1               (0x04)
#define SC_FILTER_C_SRAM2               (0x05)
#define SC_FILTER_C_SRAM3               (0x06)
#define SC_FILTER_C_SRAM4               (0x07)
#define SC_FILTER_SRAM_COLOR_INDEX      (0x08)
#define SC_FILTER_SRAM_COLOR_GAIN_SNR   (0x09)
#define SC_FILTER_SRAM_COLOR_GAIN_DNR   (0x0A)
#define SC_FILTER_SRAM_ICC_CRD          (0x0B)
#define SC_FILTER_SRAM_IHC_CRD          (0x0C)
#define SC_FILTER_SRAM_XVYCC_DE_GAMMA   (0x0D)
#define SC_FILTER_SRAM_XVYCC_GAMMA      (0x0E)
#define SC_FILTER_SRAM_PEAKING_CAG      (0x0F)
#define SC_FILTER_HFR_Y_SRAM1           (0x10)
#define SC_FILTER_HFR_Y_SRAM2           (0x11)
#define SC_FILTER_HFR_Y_SRAM3           (0x12)
#define SC_FILTER_HFR_Y_SRAM4           (0x13)
#define SC_FILTER_HFR_C_SRAM1           (0x14)
#define SC_FILTER_HFR_C_SRAM2           (0x15)
#define SC_FILTER_HFR_C_SRAM3           (0x16)
#define SC_FILTER_HFR_C_SRAM4           (0x17)
#define SC_FILTER_FO_Y_SRAM1            (0x18)
#define SC_FILTER_FO_Y_SRAM2            (0x19)
#define SC_FILTER_FO_Y_SRAM3            (0x1A)
#define SC_FILTER_FO_Y_SRAM4            (0x1B)
#define SC_FILTER_FO_C_SRAM1            (0x1C)
#define SC_FILTER_FO_C_SRAM2            (0x1D)
#define SC_FILTER_FO_C_SRAM3            (0x1E)
#define SC_FILTER_FO_C_SRAM4            (0x1F)


#define SUPPORT_SCMI_V2                 (TRUE)
#define SUPPORT_DYNAMIC_MEM_FMT         (TRUE)
#define SUPPORT_AUTODOWNLOAD_HVSP       (TRUE)
#define SUPPORT_HVSP_DS_RULE            (TRUE)
#define SUPPORT_AUTODOWNLOAD_ICC_IHC    (TRUE)
#define PQ_SUPPORT_DEVICE_NUM           (1)
#define SUPPORT_SCALER_EX               (TRUE)
#define HSD_IP2_RESET_PATCH             (TRUE) //sync with xc
#define SUPPORT_HALF_PQ_DELAY           (TRUE)

#define PQ_IP_NULL                  (0xFFFF)
#define PQ_TAB_IP_NULL              (0xFFFF)
#define PQ_IP_NUM_NULL              (0xFFFF)
#define PQ_GRULE_LEVEL_NULL         (0xFFFF)

#define Y2Y_709_601_VERSION 1

#define REG_CHIP_REVISION           0x1ECF

#define PQ_CFD_INFO
#define PQ_CFD_INFO_VERSION 1
#define  PQ_STR_DTV_ENABLE_THREAD (0)

#define XC_PQ_FRC_FrameDelay_Count    (6)         ///FRC delay 6Frame in Buffer
#define XC_PQ_FRC_MEMC_BYPASS_RW_DIFF_COUNT  (2)  ///FRC MEMC BYPASS RW Diff
#define XC_PQ_FRC_RW_DIFF_COUNT              (6)  ///FRC RW Diff
#define XC_PQ_FRC_RW_DIFF_COUNT_DECIMAL      (0)  ///FRC RW Diff Decimal Part
#define XC_PQ_FRC_R2_Outputfreq              (0)  //FRC-R2 output freq
#define XC_PQ_FRC_R2_Inputfreq               (0)  //FRC-R2 input freq

//Check VR reg                      ((Sclaer Base|Reg) << 8            | Mask)
#define DS_XRULE_CHECK_DNR          ((BK_SCALER_BASE|REG_SC_BK06_21_L)<<8 | 0x02)
#define DS_XRULE_CHECK_UCNR         ((BK_SCALER_BASE|REG_SC_BK2A_07_H)<<8 | 0x80)
#define DS_XRULE_CHECK_BWS_BP       ((BK_SCALER_BASE|REG_SC_BK08_01_L)<<8 | 0x01)
#define DS_XRULE_CHECK_BWS_EN       ((BK_SCALER_BASE|REG_SC_BK08_10_L)<<8 | 0x01)
#define DS_XRULE_CHECK_UCDI         ((BK_SCALER_BASE|REG_SC_BK2A_02_L)<<8 | 0x80)
#define DS_XRULE_CHECK_FILM         ((BK_SCALER_BASE|REG_SC_BK0A_10_H)<<8 | 0xC0)
#define DS_XRULE_CHECK_FILMANY      ((BK_SCALER_BASE|REG_SC_BK0A_24_H)<<8 | 0x80)
#define DS_XRULE_CHECK_UCCTL        ((BK_SCALER_BASE|REG_SC_BK2A_02_H)<<8 | 0x80)
#define DS_XRULE_CHECK_FILM32_MASK  (0x80)
#define DS_XRULE_CHECK_FILM22_MASK  (0x40)

typedef enum
{
    E_PQ_CFD_ANALOG_YUV_NTSC,   // 0
    E_PQ_CFD_ANALOG_YUV_PAL,    // 1
    E_PQ_CFD_ANALOG_YUV_SECAM,  // 2
    E_PQ_CFD_ANALOG_RGB_NTSC,   // 3
    E_PQ_CFD_ANALOG_RGB_PAL,    // 4
    E_PQ_CFD_YPBPR_SD,          // 5
    E_PQ_CFD_YPBPR_FHD,         // 6
    E_PQ_CFD_DVI,               // 7
    E_PQ_CFD_VGA,               // 8
    E_PQ_CFD_PHOTO,             // 9
    E_PQ_CFD_PHOTO_RGB,         // 10
    E_PQ_CFD_MM,                // 11
    E_PQ_CFD_DTV,               // 12
    E_PQ_CFD_HDMI,              // 13
    E_PQ_CFD_MAX,               // 14
} EN_PQ_CFD_INPUT_SOURCE_INFO_INDEX;

typedef struct
{
    MS_U16 u16IPIdx;
    MS_U16 u16TableIdx;
    MS_U16 u16GruleMaxIPNum;
    MS_U16 u16GruleLevel;
    MS_U16 u16GruleLevelNum;
    MS_U16 u16GruleLevelMain;
    MS_U16 u16GruleLevelMainNum;
    PQ_ENGINE_TYPE enPQEngineType;
}ST_PQ_IPInfo;

typedef struct
{
    MS_U16 u16Client;
    MS_U16 u16Entry;
    MS_U16 u16ReadData[10];
    MS_BOOL bReadRIU;
    MS_BOOL bHWSupported;
} ST_PQ_AUTODOWNLOAD_SRAM_WITH_RIU;

typedef enum
{
    E_PQ_TEST_NONE = 0,
    E_PQ_TEST_PASS,
    E_PQ_TEST_FAIL,
    E_PQ_TEST_NOT_SUPPORTED,
    E_PQ_TEST_MAX
} EN_PQ_TEST_STATUS;

void Hal_PQ_init_riu_base(void *pInstance,MS_U32 u32riu_base);
MS_U8 Hal_PQ_get_sync_flag(void *pInstance,MS_BOOL bMainWin);
MS_U8 Hal_PQ_get_input_vsync_value(void *pInstance,MS_BOOL bMainWin);
MS_U8 Hal_PQ_get_output_vsync_value(void *pInstance,MS_BOOL bMainWin);
MS_U8 Hal_PQ_get_input_vsync_polarity(void *pInstance,MS_BOOL bMainWin);
void Hal_PQ_set_memfmt_doublebuffer(void *pInstance,MS_BOOL bEn);
void Hal_PQ_set_mem_fmt(void *pInstance,MS_BOOL bMainWin, MS_U16 u16val, MS_U16 u16Mask);
void Hal_PQ_set_mem_fmt_en(void *pInstance,MS_BOOL bMainWin, MS_U16 u16val, MS_U16 u16Mask);
void Hal_PQ_set_420upSample(void *pInstance,MS_U16 u16value);
void Hal_PQ_set_force_y_motion(void *pInstance,MS_BOOL bMainWin, MS_U16 u16value);
MS_U8 Hal_PQ_get_force_y_motion(void *pInstance,MS_BOOL bMainWin);
void Hal_PQ_set_force_c_motion(void *pInstance,MS_BOOL bMainWin, MS_U16 u16value);
MS_U8 Hal_PQ_get_force_c_motion(void *pInstance,MS_BOOL bMainWin);
void Hal_PQ_set_dipf_temporal(void *pInstance,MS_BOOL bMainWin, MS_U16 u16val);
MS_U16 Hal_PQ_get_dipf_temporal(void *pInstance,MS_BOOL bMainWin);
void Hal_PQ_set_dipf_spatial(void *pInstance,MS_BOOL bMainWin, MS_U16 u16val);
MS_U8 Hal_PQ_get_dipf_spatial(void *pInstance,MS_BOOL bMainWin);
void Hal_PQ_set_vsp_sram_filter(void *pInstance,MS_U8 u8vale);
MS_U8 Hal_PQ_get_vsp_sram_filter(void *pInstance);
void Hal_PQ_set_dnr(void *pInstance,MS_BOOL bMainWin, MS_U8 u8val);
MS_U8 Hal_PQ_get_dnr(void *pInstance,MS_BOOL bMainWin);
void Hal_PQ_set_presnr(void *pInstance,MS_BOOL bMainWin, MS_U8 u8val);
MS_U8 Hal_PQ_get_presnr(void *pInstance,MS_BOOL bMainWin);
void Hal_PQ_set_film(void *pInstance,MS_BOOL bMainWin, MS_U16 u16val);
MS_U8 Hal_PQ_get_film(void *pInstance,MS_BOOL bMainWin);
void Hal_PQ_set_c_sram_table(void *pInstance,MS_U8 u8sramtype, void *pData);
void Hal_PQ_set_y_sram_table(void *pInstance,MS_U8 u8sramtype, void *pData);
void Hal_PQ_set_sram_color_index_table(void *pInstance,MS_U8 u8sramtype, void *pData);
void Hal_PQ_set_sram_color_gain_snr_table(void *pInstance,MS_U8 u8sramtype, void *pData);
void Hal_PQ_set_sram_color_gain_dnr_table(void *pInstance,MS_U8 u8sramtype, void *pData);
MS_U16 Hal_PQ_get_hnonlinear_idx(void *pInstance,MS_HNONLINEAR_TYPE etype);
MS_U8 Hal_PQ_get_madi_fbl_mode(void *pInstance,MS_BOOL bMemFmt422,MS_BOOL bInterlace);
MS_U16 Hal_PQ_get_sram_size(void *pInstance,MS_U16 u16sramtype);
void Hal_PQ_OPWriteOff_Enable(void *pInstance,MS_BOOL bEna);
void Hal_PQ_set_sram_ihc_crd_table(void *pInstance,MS_U8 u8sramtype, void *pData);
void Hal_PQ_set_sram_icc_crd_table(void *pInstance,MS_U8 u8sramtype, void *pData);
MS_U16 Hal_PQ_get_rw_method(void *pInstance,MS_BOOL bMainWin);
void Hal_PQ_set_rw_method(void *pInstance,MS_BOOL bMainWin, MS_U16 u16method);
void Hal_PQ_set_xvycc_matrix_coefficient(void *pInstance,MS_S32 pData[][3], MS_BOOL bMainWin);
void Hal_PQ_set_xvycc_matrix_enable(void *pInstance,MS_BOOL bEnable, MS_BOOL bMainWin);
MS_BOOL HAL_PQ_user_mode_control(void *pInstance);
void HAL_PQ_set_SelectCSC(void *pInstance,MS_U16 u16selection, MS_BOOL  bMainWin);
void Hal_PQ_set_sram_xvycc_gamma_table(void *pInstance,MS_U8 u8sramtype, void *pData);
MS_U16 Hal_PQ_get_dnr_whole_reg(void *pInstance, MS_BOOL bMainWin);
void Hal_PQ_Set2StepScaling(void *pInstance, MS_BOOL bEnable);
MS_BOOL Hal_PQ_get_cfd_info(MS_U16 u16PqIndex, MS_U8 *pu8ColorFormat, MS_U8 *pu8ColorDataFormat, MS_BOOL *pbIsFullRange, MS_U8 *pu8ColorPrimaries, MS_U8 *pu8TransferCharacteristics, MS_U8 *pu8MatrixCoefficients);
MS_BOOL Hal_PQ_get_cfd_info_simplified_index(MS_U16 u16PqIndex, MS_U8 *pu8ColorFormat, MS_U8 *pu8ColorDataFormat, MS_BOOL *pbIsFullRange, MS_U8 *pu8ColorPrimaries, MS_U8 *pu8TransferCharacteristics, MS_U8 *pu8MatrixCoefficients);
void Hal_PQ_set_sram_peaking_cag_table(void *pInstance,MS_U8 u8sramtype, void *pData);
MS_U16 MHal_PQ_GetPQDelayAvg(MS_PQ_INPUT_SOURCE_TYPE enInputSource);
#define Hal_PQ_set_c_sram_table_Main2(arg...)
#define Hal_PQ_set_y_sram_table_Main2(arg...)
void Hal_PQ_set_UFSC_c_sram_table(void *pInstance, MS_U8 u8sramtype, void *pData);
void Hal_PQ_set_UFSC_y_sram_table(void *pInstance, MS_U8 u8sramtype, void *pData);
void Hal_PQ_set_UFSC_sram_ihc_crd_table(void *pInstance, MS_U8 u8sramtype, void *pData);
void Hal_PQ_set_UFSC_sram_icc_crd_table(void *pInstance, MS_U8 u8sramtype, void *pData);
void Hal_PQ_ICC_IHC_FireADL(void);
MS_U8 MHal_PQ_Check_UI_VR(void *pInstance, MS_U32 u32RegAddr, MS_U8 u8Mask, MS_U8 u8Value, EN_PQ_TABTYPE enTableType);
MS_BOOL Hal_PQ_SupportFastDisp_Setting(MS_BOOL bEnable, MS_U8 u8Level, MS_U8 u8PQNum);
void Hal_PQ_get_FastDisp_en(MS_BOOL *bEnable);
void MHal_PQ_RemappingIP(void *pInstance, ST_PQ_IPInfo stIPInfo, ST_PQ_IPInfo *pstUpdatedIPInfo, MS_BOOL bMainWin);
void MHal_PQ_RemappingGruleIP(void *pInstance, ST_PQ_IPInfo stIPInfo, ST_PQ_IPInfo *pstUpdatedIPInfo, MS_BOOL bMainWin);
MS_BOOL MHal_PQ_IsSupportMADiVR(void);
MS_BOOL MHal_PQ_SetMADiVRInfo(ST_PQ_MADI_VR_INFO* pstPQMADiVRInfo);
void MHal_PQ_SetBitPerPixelForCmp(MS_U8 *pu8BitsPerPixel, MS_U8 u8CmpBitsPerPixel, MS_BOOL bMainWin);
MS_BOOL MHal_PQ_DS_Write_Y_SRAM_TABLE(void *pInstance, void *pAddr, MS_U8 u8sramtype);
MS_BOOL MHal_PQ_DS_Write_C_SRAM_TABLE(void *pInstance, void *pAddr, MS_U8 u8sramtype);
#define MHal_PQ_SetABFPatch(args...)
#define Hal_PQ_Check_Need_DMA_Delay(args...) (FALSE)
#define MHal_PQ_UCMEnable(args...) (FALSE)
#define MHal_PQ_UCMFrameNum(args...) (0)
#define MHal_PQ_UCMRWDiff(args...) (0)
#define MHal_PQ_IsControlPathSetting(args...) (FALSE)
#define Hal_PQ_set_hfr_y_sram_table(args...)
#define Hal_PQ_set_hfr_c_sram_table(args...)
#define Hal_PQ_set_fo_c_sram_table(args...)
#define Hal_PQ_set_fo_y_sram_table(args...)
MS_BOOL MHal_PQ_IP_Support(EN_PQ_IP_LIST eIPName);
MS_U16 MHal_PQ_Get_IPNum(EN_PQ_IP_LIST eIPName);
MS_BOOL MHal_PQ_MMDSXRuleMapping(void* pInstance,PQ_WIN enWindow, MS_U16* pu16XRuleType, PQ_ENGINE_TYPE* penPQEngineType);
MS_BOOL MHal_PQ_Support_GroupIPBIN(void);
MS_U16 MHal_PQ_InputSourceUnLock(PQ_WIN enWindow, MS_U16 u16SrcType,MS_BOOL bIsInterlaced,MS_U16 u16Input_VFreq);
#define MHal_PQ_IsSwitchSubBank(args...) (FALSE)
MS_BOOL MHal_PQ_IsSourceUnLock(MS_U16 u16SrcType);
#define MHal_PQ_IsEnablePIPPOP(args...) (FALSE)
#define MHal_PQ_Get_IPIndex(args...) (PQ_IP_NULL)
#define MHal_PQ_Get_TableIndex(args...) (PQ_TAB_IP_NULL)
MS_BOOL MHal_PQBin_GeneralSetPanelIdx(void *pInstance,PQ_BIN_TYPE enPQBinType, MS_U16 u16PnlIdx);
MS_U16 MHal_PQBin_GeneralGetPanelIdx(void *pInstance,PQ_BIN_TYPE enPQBinType);
MS_U16 MHal_PQ_Get_GRuleIPIndex(PQ_WIN enWindow, EN_PQ_GRULE_IP enGRuleIP);
MS_U16 MHal_PQ_Get_GRuleNum(PQ_WIN enWindow, EN_PQ_GRULE_IP enGRuleIP);
MS_U16 MHal_PQ_Get_GRuleIPNum(PQ_WIN enWindow, EN_PQ_GRULE_IP enGRuleIP);
MS_BOOL MHal_PQ_SetPQInfoToVR(ST_PQ_SET_VR_INFO stPQSetVRInfo);
MS_U16 MHal_PQ_Get_XRuleIPType(PQ_WIN enWindow, EN_PQ_XRULE_IP enPQXRuleIP);
MS_U16 MHal_PQ_Get_HVSPXRuleIPIndex(PQ_WIN enWindow, EN_PQ_HVSP_DS_SETTING_IP enSettingIP);
MS_BOOL MHal_PQ_Function_Control(PQ_WIN enWindow,EN_PQ_FUNCTION_INFO_INDEX enFunctionIndex ,MS_BOOL bEnable);
MS_BOOL MHal_PQ_Get_Function_Control_Info(PQ_WIN enWindow,EN_PQ_FUNCTION_INFO_INDEX enFunctionIndex);
#define MHal_PQ_GetFastPlayByMemcCap(args...) (FALSE)
#define MHal_PQ_GetFRCRWDiffCount(args...)
MS_U16 MHal_PQ_GetTMOModeLevelIndex(void* pInstance, PQ_WIN enWindow,MS_PQ_HDR_GRULE_INDEX  enHDRGRuleLevelIndex, MS_U16 u16Width, MS_U16 u16Height);
MS_U16 MHal_PQ_GetSWDRModeLevelIndex(void* pInstance, PQ_WIN enWindow, MS_PQ_SWDR_GRULE_INDEX eSWDRGRuleLevelIndex);
MS_U16 MHal_PQ_GetDLCSettingModeLevelIndex(void* pInstance, PQ_WIN enWindow, EN_PQ_DLC_GRULE_INDEX enDLCGRuleLevelIndex);
MS_BOOL Hal_PQ_Autodownload_ReadSRAMwithRIU(ST_PQ_AUTODOWNLOAD_SRAM_WITH_RIU* stReadSRAMInfo);
MS_BOOL Hal_PQ_TestAutodownload(MS_U16 u16Client, EN_PQ_TEST_STATUS* penTestReport);
MS_BOOL MHal_PQ_Fire_HVSPXRule_ADL(void);
MS_BOOL MHal_PQ_IsHalfPQDelaySupport(PQ_INPUT_SOURCE_TYPE enInputSourceType);
void Hal_PQ_ResumeYCSram(void *pInstance);
MS_BOOL MHal_PQ_IsMMDSByPass(PQ_WIN enWindow);
#define MHal_PQ_HVSP_RIUWriteSRAMControl(args...) (TRUE)
MS_U16 MHal_PQ_GetHSVPHSizeCondition(void);
#define MHal_PQ_IsNeedWriteHSY2SRAM(args...) (FALSE)
#define MHal_PQ_WriteHSY2SRAM(args...) (TRUE)
MS_BOOL MHal_PQ_EnableCFDHSVPUpdate(MS_BOOL bEnable);
#endif