//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
//
/// @file  regSYS.h
/// @brief Hardware register definition for Video Decoder
/// @author MStar Semiconductor Inc.
//
///////////////////////////////////////////////////////////////////////////////////
#ifndef _REG_SYS_H_
#define _REG_SYS_H_

////////////////////////////////////////////////////////////////////////////////
// Constant & Macro Definition
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
// Base Address
//------------------------------------------------------------------------------
#define BANK_EXTRIU             (0x3000)
#define BANK_PM_TOP             (0x001E)
#define BANK_PM_MISC            (0x002E)
#define BANK_REG_PIU_MISC_0     (0x003C)
#define BANK_CHIP_TOP           (0x101E)
#define BANK_TS_SAMPLE          (0x110A)
#define BANK_ANA_MISC           (0x1128)
#define BANK_PCM                (0x1034)
#define BANK_CLK_GEN1           (0x1033)
#define BANK_GPIO_FUNC_MUX      (0x3229)
#define REG_RTC_BASE            (0x1200)

//------------------------------------------------------------------------------
// MCU and PIU Reg
//------------------------------------------------------------------------------
#define REG_TOP_SW_RST          ((BANK_PM_MISC  << 8) + (0x2E << 1))
#define REG_CHIP_ID             ((BANK_PM_TOP << 8) + (0x00 * 2))
#define REG_CHIP_REV_VER        ((BANK_PM_TOP << 8) + (0x01 * 2))

#define REG_TSOUT_CFG           ((BANK_GPIO_FUNC_MUX << 8) + (0x03 * 2))
#define REG_TS_CFG              ((BANK_GPIO_FUNC_MUX << 8) + (0x00 * 2))
#define REG_TS_CFG2             ((BANK_GPIO_FUNC_MUX << 8) + (0x01 * 2))

#define REG_TV_TOOL_DUMP        ((BANK_REG_PIU_MISC_0 << 8) + (0x27 * 2))

#define REG_PCM                 ((BANK_GPIO_FUNC_MUX << 8) + (0x08 * 2))
#define REG_PCM_CD              ((BANK_PCM << 8 ) + (0x28 * 2))

#define REG_TS0_TS1_CLK_SAMPLE  ((BANK_TS_SAMPLE << 8) + (0x00 * 2))
    #define CLK_TS_PHASE_ADJ_CNT_MASK 0x1F
    #define CLK_CLK_SAMPLE_SHIFT 8
#define REG_TS2_TS3_CLK_SAMPLE  ((BANK_TS_SAMPLE << 8) + (0x01 * 2))
#define REG_TS4_TS5_CLK_SAMPLE  ((BANK_TS_SAMPLE << 8) + (0x02 * 2))
#define REG_TS_OUT_CLK_SAMPLE   ((BANK_TS_SAMPLE << 8) + (0x03 * 2))
#define REG_S2P_OUT_CLK_SAMPLE  ((BANK_TS_SAMPLE << 8) + (0x04 * 2))

#define REG_BRICK_TERMINATOR    (REG_RTC_BASE + (0x10 << 1))

#define REG_DID_KEY_BASE        (0x3800)
#define REG_DEVICE_ID_0         (REG_DID_KEY_BASE + (0x00 << 1))
#define REG_DEVICE_ID_1         (REG_DID_KEY_BASE + (0x01 << 1))
#define REG_DEVICE_ID_2         (REG_DID_KEY_BASE + (0x02 << 1))
#define REG_DEVICE_ID_3         (REG_DID_KEY_BASE + (0x04 << 1))
#define REG_DEVICE_ID_4         (REG_DID_KEY_BASE + (0x05 << 1))
#define REG_DEVICE_ID_5         (REG_DID_KEY_BASE + (0x06 << 1))
#define REG_DID_KEY_READ        (REG_DID_KEY_BASE + (0x70 << 1))
#define REG_EFUSE_CID           (REG_DID_KEY_BASE + (0x43 << 1))

//efuse 32*32
#define REG_RESERVED4_15_0            0x2050UL   //0X28
#define REG_RESERVED4_31_16           0x2052UL   //0X29
#define REG_EFUSE_128_RD_15_0         0x2058UL   //0X2c
#define REG_EFUSE_128_RD_31_16        0x205AUL   //0X2d
#define REG_EFUSE_32_RD_15_0          0x205CUL   //0X2e
#define REG_EFUSE_32_RD_31_16         0x205EUL   //0X2f
#define FLAG_EFUSE_DATA_BUSY          0x2000UL   //0x28[13], 1: Busy, 0:Idle
                                                 //0x29[13], 1: Busy, 0:Idle
#define REG_EFUSE_PPM_50_15_0         0x20A0UL   //0x50
#define REG_EFUSE_PPM_51_15_0         0x20A2UL   //0x51
#define REG_EFUSE_PPM_52_15_0         0x20A4UL   //0x52
#define REG_EFUSE_PPM_53_15_0         0x20A6UL   //0x53
#define REG_EFUSE_PPM_54_15_0         0x20A8UL   //0x54
#define REG_EFUSE_PPM_55_15_0         0x20AAUL   //0x55
#define REG_EFUSE_PPM_56_15_0         0x20ACUL   //0x56
#define REG_EFUSE_PPM_57_15_0         0x20AEUL   //0x57
#define REG_EFUSE_TTS_SUBBANK         0x6A
#define REG_EFUSE_SECURE_IC_04_15_0   0x2008UL   //0x04
#define REG_EFUSE_SECURE_IC_07_15_0   0x200EUL   //0x07
//------------------------------------------------------------------------------
// AGC Reg
//------------------------------------------------------------------------------
#define REG_HK_DMD_SWITCH       ((BANK_CHIP_TOP << 8) + (0x1C * 2))
#define REG_IFAGC_TRISTATE      ((BANK_ANA_MISC << 8) + (0x18 * 2))
#define REG_RFAGC_TRISTATE      ((BANK_ANA_MISC << 8) + (0x36 * 2))

//------------------------------------------------------------------------------
// Demod TS Clock Phase Reg
//------------------------------------------------------------------------------
#define REG_PHASE_ENABLE        ((BANK_CLK_GEN1 << 8) + (0x00 * 2))
#define REG_PHASE_NUMBER        ((BANK_CLK_GEN1 << 8) + (0x05 * 2))
#define REG_TS_RESET            ((BANK_CLK_GEN1 << 8) + (0x01 * 2))

//------------------------------------------------------------------------------
// Smart Card Pad MUX Reg
//------------------------------------------------------------------------------
#define REG_SM_CONFIG           ((BANK_GPIO_FUNC_MUX << 8) + (0x0A * 2))

#endif // _REG_SYS_H_
