//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
//-------------------------------------------------------------------------------------------------
//  Include Files
//-------------------------------------------------------------------------------------------------
#include "MsCommon.h"
#include "regCHIP.h"
#include "halCHIP.h"
#include "drvSYS.h"
#include "halSYS.h"
#include "regSYS.h"
#include "drvMMIO.h"
#include "drvIPAUTH.h"

#ifdef MSOS_TYPE_LINUX
#include "drvSYS_priv.h"
#endif

#if defined(MSOS_TYPE_LINUX_KERNEL)
#include <linux/string.h>
#include <linux/fs.h>
#include <asm/uaccess.h>
#elif defined(MSOS_TYPE_LINUX)
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#endif

#include "ULog.h"

//-------------------------------------------------------------------------------------------------
//  Driver Compiler Options
//-------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------
//  Local Defines
//-------------------------------------------------------------------------------------------------
#define BIT0    (0x0001UL)
#define BIT1    (0x0002UL)
#define BIT2    (0x0004UL)
#define BIT3    (0x0008UL)
#define BIT4    (0x0010UL)
#define BIT5    (0x0020UL)
#define BIT6    (0x0040UL)
#define BIT7    (0x0080UL)
#define BIT8    (0x0100UL)
#define BIT9    (0x0200UL)
#define BIT10   (0x0400UL)
#define BIT11   (0x0800UL)
#define BIT12   (0x1000UL)
#define BIT13   (0x2000UL)
#define BIT14   (0x4000UL)
#define BIT15   (0x8000UL)
#define BIT16   (0x00010000UL)
#define BIT17   (0x00020000UL)
#define BIT18   (0x00040000UL)
#define BIT19   (0x00080000UL)
#define BIT20   (0x00100000UL)
#define BIT21   (0x00200000UL)
#define BIT22   (0x00400000UL)
#define BIT23   (0x00800000UL)
#define BIT24   (0x01000000UL)
#define BIT25   (0x02000000UL)
#define BIT26   (0x04000000UL)
#define BIT27   (0x08000000UL)
#define BIT28   (0x10000000UL)
#define BIT29   (0x20000000UL)
#define BIT30   (0x40000000UL)
#define BIT31   (0x80000000UL)

#define SYS_READ_BYTE(addr)         (READ_BYTE(virtSysBase + (addr)))
#define SYS_WRITE_BYTE(addr, val)   {WRITE_BYTE(virtSysBase + (addr), val)}

//-------------------------------------------------------------------------------------------------
//  Local Structures
//-------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------
//  Global Variables
//-------------------------------------------------------------------------------------------------
#ifdef MSOS_TYPE_LINUX
extern SYS_IO_PROC  g_SysIoProc;
#endif

//-------------------------------------------------------------------------------------------------
//  Local Variables
//-------------------------------------------------------------------------------------------------
static MS_VIRT      virtSysBase = 0;
static MS_VIRT      virtSysBaseExtRIU = 0;
static MS_VIRT      _gMIO_efuse_MapBase = 0;

static SYS_Info     stSysInfo;
static MS_VIRT      virtChipType = E_SYS_CHIP_TV;

static SYS_EFUSE_VIRTUAL_SUB_BANK _aEfuseVirtualSubBank[SYS_EFUSE_SUB_BANK_CNT_MAX] = {
    [0] = {
            .u8SubBank = 0x52,
            .u32Value = 0
          },
    [1] = {
            .u8SubBank = 0x5F,
            .u32Value = 0
          },
    [2] = {
            .u8SubBank = 0x66,
            .u32Value = 0
          },
    [3] = {
            .u8SubBank = 0x67,
            .u32Value = 0
          },
    [4] = {
            .u8SubBank = 0x6E,
            .u32Value = 0
          },
    [5] = {
            .u8SubBank = 0x6F,
            .u32Value = 0
          },
};

//-------------------------------------------------------------------------------------------------
//  Debug Functions
//-------------------------------------------------------------------------------------------------
#define SYS_INFO(fmt, args...)  ULOGD("SYS", "[INFO ][%s][%d]" fmt, __FUNCTION__, __LINE__, ## args)
#define SYS_WARN(fmt, args...)  ULOGD("SYS", "[WARN ][%s][%d]" fmt, __FUNCTION__, __LINE__, ## args)
#define SYS_ERROR(fmt, args...) ULOGD("SYS", "[ERROR][%s][%d]" fmt, __FUNCTION__, __LINE__, ## args)

//-------------------------------------------------------------------------------------------------
//  Local Functions
//-------------------------------------------------------------------------------------------------
static MS_U8 HAL_SYS_ReadByte(MS_U32 u32RegAddr)
{
    MS_VIRT virtBase = 0;

    virtBase = (((u32RegAddr >> 8) < BANK_EXTRIU) ? virtSysBase : virtSysBaseExtRIU);
    if (virtBase == 0)
    {
        SYS_ERROR("Invalid parameters.\n");
        return 0;
    }
    u32RegAddr = (((u32RegAddr >> 8) < BANK_EXTRIU) ? u32RegAddr : (u32RegAddr - (BANK_EXTRIU << 8)));
    return ((volatile MS_U8 *)(virtBase))[(u32RegAddr << 1) - (u32RegAddr & 1)];
}

static MS_U16 HAL_SYS_Read2Byte(MS_U32 u32RegAddr)
{
    MS_VIRT virtBase = 0;

    virtBase = (((u32RegAddr >> 8) < BANK_EXTRIU) ? virtSysBase : virtSysBaseExtRIU);
    if (virtBase == 0)
    {
        SYS_ERROR("Invalid parameters.\n");
        return 0;
    }
    u32RegAddr = (((u32RegAddr >> 8) < BANK_EXTRIU) ? u32RegAddr : (u32RegAddr - (BANK_EXTRIU << 8)));
    return ((volatile MS_U16 *)(virtBase))[u32RegAddr];
}

static void HAL_SYS_WriteByte(MS_U32 u32RegAddr, MS_U8 u8Val)
{
    MS_VIRT virtBase = 0;

    virtBase = (((u32RegAddr >> 8) < BANK_EXTRIU) ? virtSysBase : virtSysBaseExtRIU);
    if (virtBase == 0)
    {
        SYS_ERROR("Invalid parameters.\n");
        return;
    }
    u32RegAddr = (((u32RegAddr >> 8) < BANK_EXTRIU) ? u32RegAddr : (u32RegAddr - (BANK_EXTRIU << 8)));
    ((volatile MS_U8 *)(virtBase))[(u32RegAddr << 1) - (u32RegAddr & 1)] = u8Val;
}

static void HAL_SYS_Write2Byte(MS_U32 u32RegAddr, MS_U16 u16Val)
{
    MS_VIRT virtBase = 0;

    virtBase = (((u32RegAddr >> 8) < BANK_EXTRIU) ? virtSysBase : virtSysBaseExtRIU);
    if (virtBase == 0)
    {
        SYS_ERROR("Invalid parameters.\n");
        return;
    }
    u32RegAddr = (((u32RegAddr >> 8) < BANK_EXTRIU) ? u32RegAddr : (u32RegAddr - (BANK_EXTRIU << 8)));
    ((volatile MS_U16 *)(virtBase))[u32RegAddr] = u16Val;
}

//-------------------------------------------------------------------------------------------------
//  Global Functions
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
// SYS Init
//-------------------------------------------------------------------------------------------------
void SYS_Init(MS_VIRT virtBase)
{
    virtSysBase = virtBase;

    stSysInfo.Chip.DeviceId     = HAL_SYS_Read2Byte(REG_CHIP_ID);
    stSysInfo.Chip.Version      = (HAL_SYS_Read2Byte(REG_CHIP_REV_VER) & CHIP_VERSION_MASK)  >> CHIP_VERSION_SHFT;
    stSysInfo.Chip.Revision     = (HAL_SYS_Read2Byte(REG_CHIP_REV_VER) & CHIP_REVISION_MASK) >> CHIP_REVISION_SHFT;
    stSysInfo.Chip.MIU1Base     = (MS_PHY)HAL_MIU1_BASE;
    stSysInfo.Chip.MIU1BusBase  = HAL_MIU1_BUS_BASE;
}

void HAL_SYS_SetExtRIUBase(MS_VIRT virtBase)
{
    virtSysBaseExtRIU = virtBase;
}

void HAL_SYS_SetOtpIOMapBase(MS_VIRT virtBase)
{
    /* Not support */
}

//-------------------------------------------------------------------------------------------------
// DEBUG
//-------------------------------------------------------------------------------------------------
MS_BOOL HAL_SYS_DisableDebugPort(void)
{
    HAL_SYS_WriteByte(REG_TV_TOOL_DUMP, (HAL_SYS_ReadByte(REG_TV_TOOL_DUMP) | BIT0));
    return TRUE;
}

MS_BOOL HAL_SYS_EnableDebugPort(void)
{
    HAL_SYS_WriteByte(REG_TV_TOOL_DUMP, (HAL_SYS_ReadByte(REG_TV_TOOL_DUMP) & ~(BIT0)));
    return TRUE;
}

//-------------------------------------------------------------------------------------------------
//  INFO
//-------------------------------------------------------------------------------------------------
MS_U8 SYS_GetChipVer(void)
{
    return stSysInfo.Chip.Version;
}

MS_U8 SYS_GetChipRev(void)
{
    return stSysInfo.Chip.Revision;
}

MS_U16 SYS_GetChipID(void)
{
    return stSysInfo.Chip.DeviceId;
}

const SYS_Info* SYS_GetInfo(void)
{
    return (const SYS_Info*)&stSysInfo;
}

//-------------------------------------------------------------------------------------------------
// CHIP TYPE
//-------------------------------------------------------------------------------------------------
E_SYS_CHIP_TYPE HAL_SYS_GetChipType(void)
{
    return (E_SYS_CHIP_TYPE)virtChipType;
}

void HAL_SYS_SetChipType(E_SYS_CHIP_TYPE eType)
{
    /* Not support */
    //virtChipType = eType;
}

//-------------------------------------------------------------------------------------------------
// RESET
//-------------------------------------------------------------------------------------------------
void HAL_SYS_ResetChip(void)
{
    HAL_SYS_Write2Byte(REG_TOP_SW_RST, 0x79);
}

void SYS_ResetCPU(void)
{
/*
    // Switch CPU to XTAL clk
    TOP_REG(REG_TOP_MCU_USB_STC0) = (TOP_REG(REG_TOP_MCU_USB_STC0) & ~(TOP_MCU_CLK_MASK)) | TOP_MCU_CLK_DFT;

    // Reset CPU
    TOP_REG(REG_TOP_RESET_CPU0) = 0x029F;
    TOP_REG(REG_TOP_RESET_CPU0) = 0x029F | TOP_RESET_CPU0;
*/
}

//-------------------------------------------------------------------------------------------------
// WOL
//-------------------------------------------------------------------------------------------------
void HAL_SYS_EnableWkEventWOL(void)
{
    SYS_INFO("Not support\n");
}

void HAL_SYS_DisableWkEventWOL(void)
{
    SYS_INFO("Not support\n");
}

void HAL_SYS_ResetStatusWOL(void)
{
    SYS_INFO("Not support\n");
}

MS_BOOL HAL_SYS_GetStatusWOL(void)
{
    SYS_INFO("Not support\n");
    return FALSE;
}

//-------------------------------------------------------------------------------------------------
// PAD MUTEX TABLE
//-------------------------------------------------------------------------------------------------
MS_BOOL HAL_SYS_SetPadMux(SYS_PAD_MUX_SET ePadMuxType,SYS_PAD_SEL ePadSel)
{
    MS_BOOL ret = TRUE;
    MS_U16  u16data = 0;

    if ((ePadMuxType >= E_PAD_SET_MAX) || (ePadSel >= E_PAD_SEL_MAX))
    {
        return FALSE;
    }

    switch (ePadMuxType)
    {
        case E_TS0_PAD_SET:
            u16data = HAL_SYS_Read2Byte(REG_TS_CFG) & ~(BIT2 | BIT1 | BIT0);
            switch (ePadSel)
            {
                case E_PARALLEL_IN:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT0);
                    break;
                case E_SERIAL_IN:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT1);
                    break;
                case E_SERIAL_IN_3_WIRE:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT2);
                    break;
                case E_MSPI_PAD_ON:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT0 | BIT1);
                    break;
                default:
                    return FALSE;
            }
            break;

        case E_TS1_PAD_SET:
            u16data = HAL_SYS_Read2Byte(REG_TS_CFG) & ~(BIT6 | BIT5 | BIT4);
            switch (ePadSel)
            {
                case E_PARALLEL_IN:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT4);
                    break;
                case E_PARALLEL_OUT:
                case E_PARALLEL_OUT_INTDMD:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT5);
                    break;
                case E_SERIAL_IN:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT5 | BIT4);
                    break;
                case E_SERIAL_IN_3_WIRE:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT6);
                    break;
                case E_MSPI_PAD_ON:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT4 | BIT6);
                    break;
                default:
                    return FALSE;
            }
            break;

        case E_TS2_PAD_SET:
            u16data = HAL_SYS_Read2Byte(REG_TS_CFG) & ~(BIT10 | BIT9 | BIT8);
            switch (ePadSel)
            {
                case E_PARALLEL_IN:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT8);
                    break;
                case E_SERIAL_IN:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT9);
                    break;
                case E_SERIAL_IN_3_WIRE:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT9 | BIT8);
                    break;
                case E_MSPI_PAD_ON:
                    HAL_SYS_Write2Byte(REG_TS_CFG, u16data | BIT10);
                    break;
                default:
                    return FALSE;
            }
            break;
        case E_TS4_PAD_SET:
            u16data = HAL_SYS_Read2Byte(REG_TS_CFG2) & ~(BIT2 | BIT1 | BIT0);
            switch (ePadSel)
            {
                case E_SERIAL_IN:
                    HAL_SYS_Write2Byte(REG_TS_CFG2, u16data | BIT0);
                    break;
                default:
                    return FALSE;
            }
            break;

        case E_TSO_PAD_SET:
            // reg_ts1config priority higher than reg_ts_out_mode
            u16data = HAL_SYS_Read2Byte(REG_TS_CFG) & ~(BIT6 | BIT5 | BIT4);
            HAL_SYS_Write2Byte(REG_TS_CFG, u16data);

            u16data = HAL_SYS_Read2Byte(REG_TSOUT_CFG) & ~(BIT2 | BIT1 | BIT0);
            switch (ePadSel)
            {
                case E_PARALLEL_OUT_TSO:
                    HAL_SYS_Write2Byte(REG_TSOUT_CFG, u16data | BIT1);
                    break;
                case E_PARALLEL_OUT_SER2PAR:
                    HAL_SYS_Write2Byte(REG_TSOUT_CFG, u16data | BIT1 | BIT0);
                    break;
                case E_PARALLEL_OUT_SER2PAR1:
                    HAL_SYS_Write2Byte(REG_TSOUT_CFG, u16data | BIT2);
                    break;
                default:
                    return FALSE;
            }
            break;

        case E_CA_CI_PAD_SET:
            switch (ePadSel)
            {
                case E_CA_CI_PAD_CI:
                    HAL_SYS_Write2Byte(REG_PCM, (HAL_SYS_Read2Byte(REG_PCM) | BIT8));//reg_pcm2ctrlconfig
                    HAL_SYS_Write2Byte(REG_PCM, (HAL_SYS_Read2Byte(REG_PCM) | BIT0));//reg_pcmadconfig
                    HAL_SYS_Write2Byte(REG_PCM, (HAL_SYS_Read2Byte(REG_PCM) | BIT4));//reg_pcmctrlconfig
                    break;
                case E_CA_CI_PAD_NONE:
                    HAL_SYS_Write2Byte(REG_PCM, (HAL_SYS_Read2Byte(REG_PCM) & ~BIT8));//reg_pcm2ctrlconfig
                    HAL_SYS_Write2Byte(REG_PCM, (HAL_SYS_Read2Byte(REG_PCM) & ~BIT0));//reg_pcmadconfig
                    HAL_SYS_Write2Byte(REG_PCM, (HAL_SYS_Read2Byte(REG_PCM) & ~BIT4));//reg_pcmctrlconfig
                    break;
                default:
                    return FALSE;
            }
            break;

        case E_SC_PAD_SET:
            u16data =  HAL_SYS_Read2Byte(REG_SM_CONFIG) & ~(BIT1|BIT0);//reg_sm_config
            switch (ePadSel)
            {
                case E_SC_PAD_PCM:
                    u16data |= BIT0;
                    HAL_SYS_Write2Byte(REG_SM_CONFIG, u16data);
                    HAL_SYS_Write2Byte(REG_PCM, (HAL_SYS_Read2Byte(REG_PCM) & ~BIT4));//reg_pcmctrlconfig
                    break;
                case E_SC_PAD_TS1:
                    u16data |= BIT1;
                    HAL_SYS_Write2Byte(REG_SM_CONFIG, u16data);
                    HAL_SYS_Write2Byte(REG_TS_CFG, (HAL_SYS_Read2Byte(REG_TS_CFG) & ~(BIT4|BIT5|BIT6)));//reg_ts1config
                    HAL_SYS_Write2Byte(REG_TSOUT_CFG, (HAL_SYS_Read2Byte(REG_TSOUT_CFG) & ~(BIT0|BIT1|BIT2)));//reg_ts_out_mode
                    break;
                case E_SC_PAD_NONE:
                    HAL_SYS_Write2Byte(REG_SM_CONFIG, u16data);
                    break;
                default:
                    return FALSE;
            }
            break;

        default:
            ret = FALSE;
            break;
    }

    return ret;
}

MS_BOOL HAL_SYS_PadMuxTableSuspend(void)
{
    SYS_INFO("Not support\n");
    return FALSE;
}

MS_BOOL HAL_SYS_PadMuxTableResume(void)
{
    SYS_INFO("Not support\n");
    return FALSE;
}

//-------------------------------------------------------------------------------------------------
// TS CLOCK
//-------------------------------------------------------------------------------------------------
MS_BOOL HAL_SYS_SetTSOutClockPhase(MS_U16 u16Val)
{
    if(u16Val > 32)
    {
        return FALSE;
    }

    if(virtSysBase == 0)
    {
        return FALSE;
    }

    // Disable TS module work
    HAL_SYS_Write2Byte(REG_TS_RESET, (HAL_SYS_Read2Byte(REG_TS_RESET) | BIT0));
    //Demod TS output clock phase tuning number.
    HAL_SYS_Write2Byte(REG_PHASE_NUMBER, (HAL_SYS_Read2Byte(REG_PHASE_NUMBER) & ~(BIT12 | BIT11 | BIT10 | BIT9 | BIT8)) | (u16Val << 8));
    //Enable Demod TS output clock phase tuning.
    HAL_SYS_Write2Byte(REG_PHASE_ENABLE, HAL_SYS_Read2Byte(REG_PHASE_ENABLE) | BIT14);
    // Enable TS module work
    HAL_SYS_Write2Byte(REG_TS_RESET, (HAL_SYS_Read2Byte(REG_TS_RESET) & ~(BIT0)));

    return TRUE;
}

MS_BOOL HAL_SYS_SetTSClockPhase(SYS_PAD_MUX_SET ePadMuxType, MS_U16 u16Val)
{
    MS_U16 u16data = 0;

    if(ePadMuxType >= E_PAD_SET_MAX)
    {
        return FALSE;
    }

    if(u16Val > CLK_TS_PHASE_ADJ_CNT_MASK)
    {
        return FALSE;
    }

    if(virtSysBase == 0)
    {
        return FALSE;
    }

    switch (ePadMuxType)
    {
        case E_TS0_PAD_SET:
            u16data = HAL_SYS_Read2Byte(REG_TS_CFG) & (BIT2 | BIT1 | BIT0);
            if (u16data == BIT0) // parallel in
                HAL_SYS_Write2Byte(REG_TS0_TS1_CLK_SAMPLE, (u16Val & CLK_TS_PHASE_ADJ_CNT_MASK) | BIT5);
            else
                HAL_SYS_Write2Byte(REG_TS0_TS1_CLK_SAMPLE, (u16Val & CLK_TS_PHASE_ADJ_CNT_MASK) & ~(BIT6|BIT5));
            break;
        case E_TS1_PAD_SET:
            u16data = HAL_SYS_Read2Byte(REG_TS_CFG) & (BIT6 | BIT5 | BIT4);
            if (u16data == BIT4) // parallel in
                HAL_SYS_Write2Byte(REG_TS0_TS1_CLK_SAMPLE, ((u16Val & CLK_TS_PHASE_ADJ_CNT_MASK)<<CLK_CLK_SAMPLE_SHIFT) | BIT13);
            else
                HAL_SYS_Write2Byte(REG_TS0_TS1_CLK_SAMPLE, ((u16Val & CLK_TS_PHASE_ADJ_CNT_MASK)<<CLK_CLK_SAMPLE_SHIFT) & ~(BIT14|BIT13));
            break;
        case E_TS2_PAD_SET:
            u16data = HAL_SYS_Read2Byte(REG_TS_CFG) & (BIT10 | BIT9 | BIT8);
            if (u16data == BIT8) // parallel in
                HAL_SYS_Write2Byte(REG_TS2_TS3_CLK_SAMPLE, (u16Val & CLK_TS_PHASE_ADJ_CNT_MASK) | BIT5);
            else
                HAL_SYS_Write2Byte(REG_TS2_TS3_CLK_SAMPLE, (u16Val & CLK_TS_PHASE_ADJ_CNT_MASK) & ~(BIT6|BIT5));
            break;
        case E_TS4_PAD_SET:
                HAL_SYS_Write2Byte(REG_TS4_TS5_CLK_SAMPLE, (u16Val & CLK_TS_PHASE_ADJ_CNT_MASK) & ~(BIT6|BIT5));
            break;
        case E_TSO_PAD_SET:
            u16data = HAL_SYS_Read2Byte(REG_TSOUT_CFG) & (BIT2 | BIT1 | BIT0);
            if (u16data == BIT1) // ts out
                HAL_SYS_Write2Byte(REG_TS_OUT_CLK_SAMPLE, (u16Val & CLK_TS_PHASE_ADJ_CNT_MASK) | BIT5);
            else if (u16data == (BIT1 | BIT0)) // s2p
                HAL_SYS_Write2Byte(REG_S2P_OUT_CLK_SAMPLE, (u16Val & CLK_TS_PHASE_ADJ_CNT_MASK) | BIT5);
            else if (u16data == BIT2) // s2p1
                HAL_SYS_Write2Byte(REG_S2P_OUT_CLK_SAMPLE, ((u16Val & CLK_TS_PHASE_ADJ_CNT_MASK)<<CLK_CLK_SAMPLE_SHIFT) | BIT13);
            else
            {
                HAL_SYS_Write2Byte(REG_TS_OUT_CLK_SAMPLE, (u16Val & CLK_TS_PHASE_ADJ_CNT_MASK) & ~(BIT6|BIT5));
                HAL_SYS_Write2Byte(REG_S2P_OUT_CLK_SAMPLE, (u16Val & CLK_TS_PHASE_ADJ_CNT_MASK) & ~(BIT14|BIT13|BIT6|BIT5));
            }
            break;
        default:
            return FALSE;
    }

    return TRUE;
}

//-------------------------------------------------------------------------------------------------
// DOLBY
//-------------------------------------------------------------------------------------------------
MS_U32 HAL_SYS_QueryDolbyHashInfo(E_SYS_DOLBY_HASH_INFO index)
{

    MS_U16 hash_rdata_lo = 0;
    MS_U32 u32Ret = 0;
    MS_U32 u32timeout_count = 0;

    if (_gMIO_efuse_MapBase == 0)
    {
        MS_VIRT  dwEfuseIoBaseAddress = 0;
        MS_PHY  dwEfuseIoBaseSize = 0;

        if (MDrv_MMIO_GetBASE(&dwEfuseIoBaseAddress, &dwEfuseIoBaseSize, MS_MODULE_PM) == FALSE)
        {
            SYS_ERROR("Get IO Base Address Failed\n");
            MS_ASSERT(0);
            return 0;
        }

        HAL_SYS_SetEfuseIOMapBase(dwEfuseIoBaseAddress);
    }

    //Bank 2, 0x29 = 2008
    HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_31_16, (0X4 * 2) | 0x2000UL);

    while ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_31_16) & FLAG_EFUSE_DATA_BUSY) != 0)
    {
        if (u32timeout_count++ > MAX_TIMEOUT_COUNT)
        {
            SYS_ERROR("Read time out\n");
            return 0;
        }
        MsOS_DelayTaskUs(10);
    }

    hash_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_32_RD_15_0);

    switch (index)
    {
        case E_SYS_DOLBY_VERSION:
            //Bank 2 [12:10], [3:0],
            u32Ret = (MS_U32)(((hash_rdata_lo >> 10) & (0x7)) << 0x4);
            u32Ret = u32Ret | (MS_U32)(((hash_rdata_lo)& 0xF));
            break;

        case E_SYS_DOLBY_CONTROL_BIT:
            //Bank 2 [13]
            u32Ret = (MS_U32)((hash_rdata_lo >> 13) & (0x01)); //Bank 2 [13]
            break;

        case E_SYS_DOLBY_REVERSE_BIT:
            //Bank 2 [14]
            u32Ret = (MS_U32)((hash_rdata_lo >> 14) & (0x01)); // Bank 2 [14]
            break;

        default:
            SYS_ERROR("Unknown Cmd: 0x%X\n", index);
            break;
    }

    return u32Ret;
}

//-------------------------------------------------------------------------------------------------
// BRICK TERMINATOR
//-------------------------------------------------------------------------------------------------
MS_U16 HAL_SYS_ReadBrickTerminatorStatus(void)
{
    MS_U16 u16Status = 0;

    u16Status = HAL_SYS_Read2Byte(REG_BRICK_TERMINATOR);

    return u16Status;
}

void HAL_SYS_WriteBrickTerminatorStatus(MS_U16 u16Status)
{
    HAL_SYS_Write2Byte(REG_BRICK_TERMINATOR, u16Status);
}

//-------------------------------------------------------------------------------------------------
// EFUSE
//-------------------------------------------------------------------------------------------------
void HAL_SYS_SetEfuseIOMapBase(MS_VIRT virtBase)
{
    _gMIO_efuse_MapBase = virtBase;
}

MS_U16 HAL_SYS_EfuseRead2Byte(MS_U32 u32RegAddr)
{
    return ((volatile MS_U16*)(_gMIO_efuse_MapBase))[u32RegAddr];
}

MS_U16 HAL_SYS_EfuseWrite2Byte(MS_U32 u32RegAddr, MS_U16 u16Val)
{
    return ((volatile MS_U16*)(_gMIO_efuse_MapBase))[u32RegAddr] = u16Val;
}

void HAL_SYS_GetEfuseDid(MS_U16 *u16efuse_did)
{
    // efuse_outc [47:0]
    u16efuse_did[0] = HAL_SYS_Read2Byte(REG_DEVICE_ID_0);
    u16efuse_did[1] = HAL_SYS_Read2Byte(REG_DEVICE_ID_1);
    u16efuse_did[2] = HAL_SYS_Read2Byte(REG_DEVICE_ID_2);

    // efuse_outd [39:0]
    u16efuse_did[3] = HAL_SYS_Read2Byte(REG_DEVICE_ID_3);
    u16efuse_did[4] = HAL_SYS_Read2Byte(REG_DEVICE_ID_4);
    u16efuse_did[5] = HAL_SYS_Read2Byte(REG_DEVICE_ID_5);
}

MS_BOOL HAL_SYS_ReadEfuseHDCPKey(MS_U16 u16ReadAddr, MS_U32 *u32HDCPKey)
{
    MS_U16 hdcp_rdata_lo = 0;
    MS_U16 hdcp_rdata_hi = 0;
    MS_U32 u32timeout_count = 0;
    if(_gMIO_efuse_MapBase == 0)
    {
        MS_VIRT  dwEfuseIoBaseAddress = 0;
        MS_PHY  dwEfuseIoBaseSize = 0;

        if(MDrv_MMIO_GetBASE(&dwEfuseIoBaseAddress, &dwEfuseIoBaseSize, MS_MODULE_PM) == FALSE)
        {
            SYS_ERROR("Get IO Base Address Failed\n");
            MS_ASSERT(0);
            return FALSE;
        }

        HAL_SYS_SetEfuseIOMapBase(dwEfuseIoBaseAddress);
    }

    if(u16ReadAddr > 75)
    {
        SYS_ERROR("Read Address overflow\n");
        MS_ASSERT(0);
        return FALSE;
    }


    HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, (0X4*u16ReadAddr) | 0x2000 );

    while ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) & FLAG_EFUSE_DATA_BUSY) != 0)
    {
        if (u32timeout_count++ > MAX_TIMEOUT_COUNT)
        {
            SYS_ERROR("Read time out\n");
            return 0;
        }
        MsOS_DelayTaskUs(10);
    }

    hdcp_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_15_0);
    hdcp_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

    *u32HDCPKey = (MS_U32)((hdcp_rdata_hi<<16)|hdcp_rdata_lo);
    return TRUE;
}

//-------------------------------------------------------------------------------------------------
// MISC
//-------------------------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////
/// @brief \b Function  \b Name: HAL_SYS_GetMemcConfg
/// @brief \b Function  \b Description: Query the result of config MEMC
/// @param <IN>         \b eSource:
/// @param <IN>         \b eTiming:
/// @param <OUT>        \b retEnMemc:
/// @param <RET>        \b E_SYS_ReturnValue:
/// @param <GLOBAL>     \b None:
////////////////////////////////////////////////////////////////////////////////
MS_U32 HAL_SYS_GetMemcConfg(MS_U32 eSource, MS_U32 eTiming, MS_BOOL *retEnMemc)
{
    SYS_INFO("Not support\n");
    return E_SYS_NOT_SUPPORT;
}

////////////////////////////////////////////////////////////////////////////////
/// @brief \b Function  \b Name: HAL_SYS_GetMemcLevel
/// @brief \b Function  \b Description: Query the result of config MEMC Level
/// @param <IN>         \b eSource:
/// @param <IN>         \b eTiming:
/// @param <OUT>        \b retSt:
/// @param <RET>        \b E_SYS_ReturnValue:
/// @param <GLOBAL>     \b None:
////////////////////////////////////////////////////////////////////////////////
MS_U32 HAL_SYS_GetMemcLevel(MS_U32 eSource, MS_U32 eTiming, MS_U32 *retSt)
{
    MS_U32 eRet = E_SYS_OK;

    switch (eSource)
    {
        case E_HALSYS_SOURCE_MM:
        case E_HALSYS_SOURCE_DTV:
            switch (eTiming)
            {
                case E_HALSYS_INPUT_FHD24_25_30:
                    *retSt = E_SYS_MEMC_4X;
                    break;
                case E_HALSYS_INPUT_FHD48:
                case E_HALSYS_INPUT_FHD50_60:
                case E_HALSYS_INPUT_4K2K24_25_30:
                    *retSt = E_SYS_MEMC_2X;
                    break;
                case E_HALSYS_INPUT_4K2K48:
                case E_HALSYS_INPUT_4K2K50_60:
                    *retSt = E_SYS_MEMC_OFF;
                     break;
                default:
                    eRet = E_SYS_NOT_SUPPORT;
                    break;
            }
            break;

        case E_HALSYS_SOURCE_HDMI:
            switch (eTiming)
            {
                case E_HALSYS_INPUT_FHD24_25_30:
                    *retSt = E_SYS_MEMC_4X;
                    break;
                case E_HALSYS_INPUT_FHD48:
                case E_HALSYS_INPUT_FHD50_60:
                case E_HALSYS_INPUT_4K2K24_25_30:
                    *retSt = E_SYS_MEMC_2X;
                    break;
                case E_HALSYS_INPUT_4K2K48:
                case E_HALSYS_INPUT_4K2K50_60:
                    *retSt = E_SYS_MEMC_OFF;
                    break;
                default:
                    eRet = E_SYS_NOT_SUPPORT;
                    break;
            }
            break;

        default:
            eRet = E_SYS_NOT_SUPPORT;
            break;
    }

    return eRet;
}

////////////////////////////////////////////////////////////////////////////////
/// @brief \b Function  \b Name: HAL_SYS_GetXcByPartConfg
/// @brief \b Function  \b Description: Query the result of config Bypart XC
/// @param <IN>         \b eSource:
/// @param <IN>         \b eInputTiming:
/// @param <IN>         \b eOutputTiming:
/// @param <OUT>        \b retEn:
/// @param <RET>        \b E_SYS_ReturnValue:
/// @param <GLOBAL>     \b None:
////////////////////////////////////////////////////////////////////////////////
MS_U32  HAL_SYS_GetXcByPartConfg (MS_U32 eSource, MS_U32 eInputTiming, MS_U32 eOutputTiming, MS_BOOL *retEn)
{
    SYS_INFO("Not support\n");
    return E_SYS_NOT_SUPPORT;
}

//-------------------------------------------------------------------------------------------------
void HAL_SYS_RFAGC_Tristate(MS_BOOL bEnable)
{
    MS_BOOL     bDmdAccessPreEnabled = TRUE;
    MS_U16      wReadRegisterData = 0;

    wReadRegisterData = HAL_SYS_Read2Byte(REG_HK_DMD_SWITCH);

    if ((wReadRegisterData & (BIT9 | BIT8)) != 0)
    {
        HAL_SYS_Write2Byte(REG_HK_DMD_SWITCH, (wReadRegisterData & ~(BIT9 | BIT8)));
        bDmdAccessPreEnabled = FALSE;
    }

    if (bEnable == TRUE)
    {
        HAL_SYS_Write2Byte(REG_RFAGC_TRISTATE, (HAL_SYS_Read2Byte(REG_RFAGC_TRISTATE) & ~(BIT0)));
    }
    else
    {
        HAL_SYS_Write2Byte(REG_RFAGC_TRISTATE, (HAL_SYS_Read2Byte(REG_RFAGC_TRISTATE) | (BIT0)));
    }

    if (bDmdAccessPreEnabled == FALSE)
    {
        HAL_SYS_Write2Byte(REG_HK_DMD_SWITCH, wReadRegisterData);
    }
}

void HAL_SYS_IFAGC_Tristate(MS_BOOL bEnable)
{
    MS_BOOL     bDmdAccessPreEnabled = TRUE;
    MS_U16      wReadRegisterData = 0;

    wReadRegisterData = HAL_SYS_Read2Byte(REG_HK_DMD_SWITCH);

    if ((wReadRegisterData & (BIT9 | BIT8)) != 0)
    {
        HAL_SYS_Write2Byte(REG_HK_DMD_SWITCH, (wReadRegisterData & ~(BIT9 | BIT8)));
        bDmdAccessPreEnabled = FALSE;
    }

    if (bEnable == TRUE)
    {
        HAL_SYS_Write2Byte(REG_IFAGC_TRISTATE, (HAL_SYS_Read2Byte(REG_IFAGC_TRISTATE) & ~(BIT0)));
    }
    else
    {
        HAL_SYS_Write2Byte(REG_IFAGC_TRISTATE, (HAL_SYS_Read2Byte(REG_IFAGC_TRISTATE) | (BIT0)));
    }

    if (bDmdAccessPreEnabled == FALSE)
    {
        HAL_SYS_Write2Byte(REG_HK_DMD_SWITCH, wReadRegisterData);
    }
}

void HAL_SYS_SetAGCPadMux(SYS_AGC_PAD_SET eAgcPadMux)
{
    MS_BOOL     bDmdAccessPreEnabled = TRUE;
    MS_U16      wReadRegisterData = 0;

    wReadRegisterData = HAL_SYS_Read2Byte(REG_HK_DMD_SWITCH);

    if ((wReadRegisterData & (BIT9 | BIT8)) != 0)
    {
        HAL_SYS_Write2Byte(REG_HK_DMD_SWITCH, (wReadRegisterData & ~(BIT9 | BIT8)));
        bDmdAccessPreEnabled = FALSE;
    }

    switch (eAgcPadMux)
    {
        case E_SYS_ATV_AGC_PAD_SET:             // ATV Mode
            HAL_SYS_RFAGC_Tristate(TRUE);
            HAL_SYS_IFAGC_Tristate(TRUE);
            break;

        case E_SYS_DTV_AGC_PAD_SET:             // DTV Mode
            HAL_SYS_RFAGC_Tristate(TRUE);
            HAL_SYS_IFAGC_Tristate(FALSE);
            break;

        case E_SYS_DTV_AGC_PAD_SET_ALL_OFF:     // DTV Mode
            HAL_SYS_RFAGC_Tristate(TRUE);
            HAL_SYS_IFAGC_Tristate(TRUE);
            break;

        default:
            SYS_ERROR("Invalid AGC Pad Selection\n");
            break;
    }

    if (bDmdAccessPreEnabled == FALSE)
    {
        HAL_SYS_Write2Byte(REG_HK_DMD_SWITCH, wReadRegisterData);
    }
}

//-------------------------------------------------------------------------------------------------
MS_BOOL HAL_SYS_SetPCMCardDetectMode(SYS_PCM_CD_MODE ePCMCDMode)
{
    MS_BOOL bRet = TRUE;

    if (ePCMCDMode >= E_PCM_CD_MAX)
    {
        bRet = FALSE;
    }
    else
    {
        switch (ePCMCDMode)
        {
            case E_PCM_CD_SINGLE:
                HAL_SYS_Write2Byte(REG_PCM_CD, (HAL_SYS_Read2Byte(REG_PCM_CD) & ~(BIT8)));
                break;
            case E_PCM_CD_OR:
                HAL_SYS_Write2Byte(REG_PCM_CD, (HAL_SYS_Read2Byte(REG_PCM_CD) | BIT8));//reg_pcm_or_cd12_en
                break;
            default:
                bRet = FALSE;
                break;
        }
    }

    return bRet;
}

//-------------------------------------------------------------------------------------------------
MS_BOOL HAL_SYS_CheckEfuseReadDone(void)
{
    MS_U32 u32timeout_count = 0;
    while ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) & FLAG_EFUSE_DATA_BUSY) != 0)
    {
        if (u32timeout_count++ > MAX_TIMEOUT_COUNT)
        {
            printf ("[Error] %s(%d) Read time out!!\n", __FUNCTION__, __LINE__);
            return FALSE;
        }
        MsOS_DelayTaskUs(10);
    }
    return TRUE;
}

MS_BOOL HAL_SYS_Query(E_SYS_QUERY id)
{
    MS_BOOL bRet = FALSE;
    MS_BOOL bRetChecked = FALSE;
    MS_U32 u32TimeOutCount = 0;

    //
    // get efuse settings
    //

    if(_gMIO_efuse_MapBase == 0)
    {
        MS_VIRT  dwEfuseIoBaseAddress = 0;
        MS_PHY  dwEfuseIoBaseSize = 0;

        if(MDrv_MMIO_GetBASE(&dwEfuseIoBaseAddress, &dwEfuseIoBaseSize, MS_MODULE_PM) == FALSE)
        {
            SYS_ERROR("Get IO Base Address Failed\n");
            MS_ASSERT(0);
            return FALSE;
        }

        HAL_SYS_SetEfuseIOMapBase(dwEfuseIoBaseAddress);
    }

    //
    // code flow : while loop ( write regA -> read regB -> check regA )
    // break condition : write regA = check regA
    // time out 10000 times
    //
    while(bRetChecked == FALSE)
    {
        // check time out
        if (u32TimeOutCount++ >= MAX_TIMEOUT_COUNT)
        {
            printf ("[Error] %s(%d) mutex time out!!\n", __FUNCTION__, __LINE__);
            bRet = TRUE;
            break;
        }
        // delay for staggered multi-thread
        MsOS_DelayTaskUs(10);
        //
        // determine
        //
        switch (id)
        {
            case E_SYS_QUERY_SECURED_IC_SUPPORTED:
                bRet = (((HAL_SYS_Read2Byte(REG_EFUSE_SECURE_IC_04_15_0) & (BIT1))>>1) & ((HAL_SYS_Read2Byte(REG_EFUSE_SECURE_IC_07_15_0) & (BIT15))>>15)) == 0x0 ? FALSE : TRUE;
                //SYS_INFO("%s, Reg: 0x%x, Ret: 0x%x\n", __TIME__, HAL_SYS_Read2Byte(0x0038E0), bRet);
                bRetChecked = TRUE;

                break;
//*****PPM*****//
#ifndef CONFIG_PURE_SN
        //PPM subbank 0x67[7]
            case E_SYS_QUERY_IWEDIA_OPEN_BROWSER_SUPPORTED:
            {
                /* ppm reg 0x56 bit7 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_56_15_0);
                bRet = (u16_rdata_lo & BIT7) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;
                break;
            }

        //PPM subbank 0x66[3:1]
            case E_SYS_QUERY_GINGA_NCL_SUPPORTED:
            {
                /* ppm reg 0x54 bit[3:1] */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_54_15_0);
                bRet = (u16_rdata_lo & (BIT3|BIT2|BIT1)) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;
                break;
            }
#endif /* CONFIG_PURE_SN */
        //PPM subbank 0x66[11]
            case E_SYS_QUERY_BML_SUPPORTED:
            {
                /* ppm reg 0x54 bit11 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_54_15_0);
                bRet = (u16_rdata_lo & BIT11) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;
                break;
            }
        //PPM subbank 0x66[10:8]
            case E_SYS_QUERY_TTS_SUPPORTED:
            {
                /* tts at ppm reg 0x54 bit10-8 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_54_15_0);
                bRet = ((u16_rdata_lo & (BIT10|BIT9|BIT8)) >> 8);
                bRetChecked = TRUE;
                break;
            }
        //PPM subbank 0x67[8]
            case E_SYS_QUERY_IWEDIA_HBBTV_SUPPORTED:
            {
                /* ppm reg 0x56 bit8 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_56_15_0);
                bRet = (u16_rdata_lo & BIT8) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;
                break;
            }
        //PPM subbank 0x67[9]
            case E_SYS_QUERY_FOXXUM_TV_STORE_SUPPORTED:
            {
                /* ppm reg 0x56 bit9 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_56_15_0);
                bRet = (u16_rdata_lo & BIT9) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;
                break;
            }
        //PPM subbank 0x67[19]
            case E_SYS_QUERY_PLAY_RDY_SUPPORTED:
            {
                /* ppm reg 0x57 bit3 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_57_15_0);
                bRet = (u16_rdata_lo & BIT3) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;
                break;
            }
        //PPM subbank 0x67[24]
            case E_SYS_QUERY_ANDROID_SUPPORTED:
            {
                /* ppm reg 0x57 bit8 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_57_15_0);
                bRet = (u16_rdata_lo & BIT8) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;
                break;
            }
        //PPM subbank 0x6E[29]
            case E_SYS_QUERY_AV_1_SUPPORTED:
            {
                /* ppm reg 0x51 bit13 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_51_15_0);
                bRet = (u16_rdata_lo & BIT13) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;
                break;
            }
        //PPM subbank 0x6E[20]
            case E_SYS_QUERY_HVD_UHD_SUPPORTED:
            {
                /* AIPQ at ppm reg 0x51 bit4 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_51_15_0);
                bRet = (u16_rdata_lo & BIT4) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;

                break;
            }
        //PPM subbank 0x6E[21]
            case E_SYS_QUERY_EVD_UHD_SUPPORTED:
            {
                /* AIPQ at ppm reg 0x51 bit5 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_51_15_0);
                bRet = (u16_rdata_lo & BIT5) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;

                break;
            }
        //PPM subbank 0x6E[22]
            case E_SYS_QUERY_MDLA_SUPPORTED:
            {
                /* mdla at ppm reg 0x51 bit6 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_51_15_0);
                bRet = (u16_rdata_lo & BIT6) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;

                break;
            }
        //PPM subbank 0x6E[24]
            case E_SYS_QUERY_VB1_SUPPORTED:
            {
                /* AIPQ at ppm reg 0x51 bit8 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_51_15_0);
                bRet = (u16_rdata_lo & BIT8) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;

                break;
            }
        //PPM subbank 0x6E[25]
            case E_SYS_QUERY_TCON_SUPPORTED:
            {
                /* AIPQ at ppm reg 0x51 bit9 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_51_15_0);
                bRet = (u16_rdata_lo & BIT9) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;

                break;
            }
        //PPM subbank 0x6E[26]
            case E_SYS_QUERY_GPU_AIPQ_SUPPORTED:
            {
                /* AIPQ at ppm reg 0x51 bit10 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_51_15_0);
                bRet = (u16_rdata_lo & BIT10) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;

                break;
            }
        //PPM subbank 0x6E[27]
            case E_SYS_QUERY_HDMI_2X_SUPPORTED:
            {
                /* AIPQ at ppm reg 0x51 bit11 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_51_15_0);
                bRet = (u16_rdata_lo & BIT11) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;

                break;
            }
            case E_SYS_QUERY_MEMC_60_SUPPORTED:
            {
                /* not support memc 60 on m7332 */
                bRet = FALSE;
                bRetChecked = TRUE;

                break;
            }
            case E_SYS_QUERY_MEMC_120_SUPPORTED:
            {
                /* not support memc 120 on m7332 */
                bRet = FALSE;
                bRetChecked = TRUE;

                break;
            }
        //PPM subbank 0x6F[2]
            case E_SYS_QUERY_AIAQ_SCENE_DETECTION_SUPPORTED:
            {
                /* AIAQ at ppm reg 0x52 bit2 */
                MS_U16 u16_rdata_lo;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_52_15_0);
                bRet = (u16_rdata_lo & BIT2) == 0x0 ? TRUE : FALSE;
                bRetChecked = TRUE;

                break;
            }
//*****NON-PPM*****//
        // NON-PPM subbank 0x52[0]
            case E_SYS_QUERY_MPLL_LVDS_CLK_OLD_MODE_SUPPORTED:
            {
                MS_U16 u16_rdata_lo = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x52 << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_15_0);

                /* 52 bit0, 0 old mode; 1 new mode */
                bRet = (u16_rdata_lo & BIT0) == 0x0 ? TRUE : FALSE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x52)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x52[2:1]
            case E_SYS_QUERY_ADCPLL_CLK_SHORT_PATH_SUPPORTED:
            {
                MS_U16 u16_rdata_lo = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x52 << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_15_0);

                /* 52 bit2   bit1
                      0      0      short path
                      0      1      long path
                      1      0      no die gas path
                      1      1      reserved */
                if ((u16_rdata_lo & BIT2) && (u16_rdata_lo & BIT1))
                {
                    printf ("[Error] %s(%d) 0x52=0x%x, invalid option\n", __FUNCTION__, __LINE__, u16_rdata_lo);
                    bRet = FALSE;
                }
                else if (!(u16_rdata_lo & BIT2) && !(u16_rdata_lo & BIT1))
                    bRet = TRUE;
                else
                    bRet = FALSE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x52)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x52[2:1]
            case E_SYS_QUERY_ADCPLL_CLK_LONG_PATH_SUPPORTED:
            {
                MS_U16 u16_rdata_lo = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x52 << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_15_0);

                /* 52 bit2   bit1
                      0      0      short path
                      0      1      long path
                      1      0      no die gas path
                      1      1      reserved */
                if ((u16_rdata_lo & BIT2) && (u16_rdata_lo & BIT1))
                {
                    printf ("[Error] %s(%d) 0x52=0x%x, invalid option\n", __FUNCTION__, __LINE__, u16_rdata_lo);
                    bRet = FALSE;
                }
                else if (!(u16_rdata_lo & BIT2) && (u16_rdata_lo & BIT1))
                    bRet = TRUE;
                else
                    bRet = FALSE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x52)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x52[2:1]
            case E_SYS_QUERY_ADCPLL_CLK_GAS_PATH_SUPPORTED:
            {
                MS_U16 u16_rdata_lo = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x52 << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_15_0);

                /* 52 bit2   bit1
                      0      0      short path
                      0      1      long path
                      1      0      no die gas path
                      1      1      reserved */
                if ((u16_rdata_lo & BIT2) && (u16_rdata_lo & BIT1))
                {
                    printf ("[Error] %s(%d) 0x52=0x%x, invalid option\n", __FUNCTION__, __LINE__, u16_rdata_lo);
                    bRet = FALSE;
                }
                else if ((u16_rdata_lo & BIT2) && !(u16_rdata_lo & BIT1))
                    bRet = TRUE;
                else
                    bRet = FALSE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x52)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x52[3]
            case E_SYS_QUERY_HDMI_MODE_SUPPORTED:
            {
                MS_U16 u16_rdata_lo = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x52 << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_15_0);

                /* 52 bit3, 0 use over speed; 1 use normal speed */
                bRet = (u16_rdata_lo & BIT3) == 0x0 ? FALSE : TRUE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x52)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x52[4]
            case E_SYS_QUERY_HDMI_DLEV_TARGET_128MV_SUPPORTED:
            {
                MS_U16 u16_rdata_lo = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x52 << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_15_0);

                /* 52 bit3, 0 128mV; 1 152mV */
                bRet = (u16_rdata_lo & BIT4) == 0x0 ? TRUE : FALSE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x52)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[3:0]
            case E_SYS_QUERY_VDD_SELECT_SUPPORTED:
            {
                MS_U16 u16_rdata_lo = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_15_0);

                /* 5F bit3,2,1,0 */
                bRet = (u16_rdata_lo & (BIT3|BIT2|BIT1|BIT0));

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[7:4]
            case E_SYS_QUERY_VDD_CPU_SELECT_SUPPORTED:
            {
                MS_U16 u16_rdata_lo = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_lo = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_15_0);

                /* 5F bit7,6,5,4 */
                bRet = ((u16_rdata_lo & (BIT7|BIT6|BIT5|BIT4)) >> 4);

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[16]
            case E_SYS_QUERY_HVD_MODE_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);
                /* 5F bit16(0), 0 432/648(624)MHz; 1 499/648(624)MHz */
                bRet = (u16_rdata_hi & BIT0) == 0x0 ? FALSE : TRUE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[17]
            case E_SYS_QUERY_ROM_BOOT_DC_AC_CHECK_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

                /* 5F bit17(1), 0 DC on as AC mode for USB upgrade; 1 DC on as DC mode for USB upgrade */
                bRet = (u16_rdata_hi & BIT1) == 0x0 ? FALSE : TRUE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[18]
            case E_SYS_QUERY_DVFS_MODE_CHECK_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

                /* 5F bit18(2), 0 use OSC/SIDD value; 1 use efuse value */
                bRet = (u16_rdata_hi & BIT2) == 0x0 ? FALSE : TRUE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[19]
            case E_SYS_QUERY_CLK_MCU_PM_DEGLITCH_MUX_SELECT_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

                /* 5F bit19(3), 0 default 24MHz, 1 216MHz */
                bRet = (u16_rdata_hi & BIT3) == 0x0 ? FALSE : TRUE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[20]
            case E_SYS_QUERY_LZMA_SELECT_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

                /* 5F bit20(4), 0 use sw patch; 1 not use sw patch */
                bRet = (u16_rdata_hi & BIT4) == 0x0 ? FALSE : TRUE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[21]
            case E_SYS_QUERY_MIU_STR_SELECT_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

                /* 5F bit21(5), 0 manual STR; 1 auto STR */
                bRet = (u16_rdata_hi & BIT5) == 0x0 ? FALSE : TRUE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[22]
            case E_SYS_QUERY_GOP_DYNAMIC_TYPE_PATCH_SELECT_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

                /* 5F bit22(6), 0 enable patch; 1 disable patch */
                bRet = (u16_rdata_hi & BIT6) == 0x0 ? FALSE : TRUE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[23]
            case E_SYS_QUERY_MVOP_MODE_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

                /* 5F bit23(7), 0 use patch; 1 not use patch */
                bRet = (u16_rdata_hi & BIT7) == 0x0 ? FALSE : TRUE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[24]
            case E_SYS_QUERY_NRDI_MODE_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

                /* 5F bit24(8), 0 FB<->FBL switch drop 1 frame; 1 FB<->FBL switch not drop 1 frame */
                bRet = (u16_rdata_hi & BIT8) == 0x0 ? FALSE : TRUE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[25]
            case E_SYS_QUERY_MIU_SINGLE_COMMAND_ACCESS_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

                /* 5F bit25(9), 0 use tee to access; 1 use tee or ree to access */
                bRet = (u16_rdata_hi & BIT9) == 0x0 ? FALSE : TRUE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[26]
            case E_SYS_QUERY_MIU_RETRY_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

                /* 5F bit26(10), 0 support re-try; 1 disable re-try */
                bRet = (u16_rdata_hi & BIT10) == 0x0 ? TRUE : FALSE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
        // NON-PPM subbank 0x5F[27]
            case E_SYS_QUERY_AUDIO_SW_RESET_PATCH_SUPPORTED:
            {
                MS_U16 u16_rdata_hi = 0;

                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((0x5F << EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                    return FALSE;

                u16_rdata_hi = HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16);

                /* 5F bit27(11), 0 use SW patch; 1 not use SW patch */
                bRet = (u16_rdata_hi & BIT11) == 0x0 ? TRUE : FALSE;

                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == 0x5F)
                    bRetChecked = TRUE;

                break;
            }
            default:
            {
                SYS_ERROR("Unknown query!\n");
                bRet = TRUE;
                bRetChecked = TRUE;

                break;
            }
        }
    }

    return bRet;
}

static void HAL_SYS_PrintVirtualEfuse(void)
{
    MS_U32 u32Index;
    printf("Virtual Efuse Value\n");
    for(u32Index = 0; u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX; u32Index++)
    {
        printf("Sub_Bank:[0x%X], Value:[0x%X]\n",_aEfuseVirtualSubBank[u32Index].u8SubBank, _aEfuseVirtualSubBank[u32Index].u32Value);
    }
    return;
}

static char* HAL_SYS_OpenVirtualFile(void)
{
    char *pchBuffer;
    MS_U32 u32Rst;
#if defined(MSOS_TYPE_LINUX_KERNEL)
    long lFileSize;
    mm_segment_t cur_mm_seg;
    struct file *pFile = NULL;
    loff_t pos;

    pFile = filp_open((const char*)HASH_EFUSE_DATA_FILE_AN, O_RDONLY, 0);
    if(IS_ERR(pFile))
    {
        printk(KERN_NOTICE "[NOTICE] %s(%d) Open Virtual efuse file (AN PATH) failed\n", __FUNCTION__, __LINE__);
        pFile = filp_open((const char*)HASH_EFUSE_DATA_FILE_MI, O_RDONLY, 0);
        if(IS_ERR(pFile))
        {
            printk(KERN_NOTICE "[NOTICE] %s(%d) Open Virtual efuse file (MI PATH) failed\n", __FUNCTION__, __LINE__);
            return NULL;
        }
    }

    vfs_llseek(pFile, 0, SEEK_END);
    lFileSize = pFile->f_pos;
    if (lFileSize <= 0)
    {
        filp_close(pFile, NULL);
        printk(KERN_WARNING "[WARNING] %s(%d) Virtual efuse file is Empty\n", __FUNCTION__, __LINE__);
        return NULL;
    }

    pos = vfs_llseek(pFile, 0, SEEK_SET);
    pchBuffer = (char*)vmalloc(lFileSize);
    if(pchBuffer == NULL)
    {
        filp_close(pFile, NULL);
        printk(KERN_WARNING "[WARNING] %s(%d) Allocate buffer failed\n", __FUNCTION__, __LINE__);
        return NULL;
    }

    cur_mm_seg = get_fs();
    set_fs(KERNEL_DS);
    u32Rst = vfs_read(pFile, pchBuffer, lFileSize, &pos);
    set_fs(cur_mm_seg);
    if(u32Rst != (MS_U32)lFileSize)
    {
        vfree(pchBuffer);
        filp_close(pFile, NULL);
        printk(KERN_WARNING "[WARNING] %s(%d) Read virtual efuse file error\n", __FUNCTION__, __LINE__);
        return NULL;
    }
    filp_close(pFile, NULL);
    printk(KERN_NOTICE "[NOTICE] %s(%d) Read Virtual efuse file success\n", __FUNCTION__, __LINE__);
#elif defined(MSOS_TYPE_LINUX)
    FILE *pFile = NULL;
    MS_S32 size;
    pFile = fopen((const char*)HASH_EFUSE_DATA_FILE_AN, "r");
    if(pFile == NULL)
    {
        printf("[NOTICE] %s(%d) Open Virtual efuse file (AN PATH) failed\n", __FUNCTION__, __LINE__);
        pFile = fopen((const char*)HASH_EFUSE_DATA_FILE_MI, "r");
        if(pFile == NULL)
        {
            printf("[NOTICE] %s(%d) Open Virtual efuse file (MI PATH) failed\n", __FUNCTION__, __LINE__);
            return NULL;
        }
    }
    fseek(pFile, 0, SEEK_END);
    size = ftell(pFile);
    if (size <= 0)
    {
        fclose(pFile);
        printf("[WARNING] %s(%d) Virtual efuse file is Empty\n", __FUNCTION__, __LINE__);
        return NULL;
    }
    rewind(pFile);
    pchBuffer = (char*) malloc(sizeof(char)*(MS_U32)size);
    if(pchBuffer == NULL)
    {
        fclose(pFile);
        printf("[WARNING] %s(%d) Allocate buffer failed\n", __FUNCTION__, __LINE__);
        return NULL;
    }
    u32Rst = fread(pchBuffer, 1, (MS_U32)size, pFile);
    if(u32Rst != (MS_U32)size)
    {
        printf("[WARNING] %s(%d) Read virtual efuse file error\n", __FUNCTION__, __LINE__);
        free(pchBuffer);
        fclose(pFile);
        return NULL;
    }
    fclose(pFile);
    printf("[NOTICE] %s(%d) Read Virtual efuse file success\n", __FUNCTION__, __LINE__);
#endif
    return pchBuffer;
}

static MS_U32 HAL_SYS_GetEFSUESubBankValue(MS_U32 u32Subbank)
{
    MS_BOOL bRetChecked = FALSE;
    MS_U32 u32Ret = 0;
    MS_U32 u32TimeOutCount = 0;
    if(u32Subbank >= 0x0 || u32Subbank <= 0xFF)
    {
        if(u32Subbank == 0x66)
        {
            u32Ret = (HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_55_15_0)<<16) + HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_54_15_0);
        }
        else if(u32Subbank == 0x67)
        {
            u32Ret = (HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_57_15_0)<<16) + HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_56_15_0);
        }
        else if(u32Subbank == 0x6E)
        {
            u32Ret = (HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_51_15_0)<<16) + HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_50_15_0);
        }
        else if(u32Subbank == 0x6F)
        {
            u32Ret = (HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_53_15_0)<<16) + HAL_SYS_EfuseRead2Byte(REG_EFUSE_PPM_52_15_0);
        }
        else
        {
            while(bRetChecked == FALSE)
            {
                if (u32TimeOutCount++ >= MAX_TIMEOUT_COUNT)
                {
                    printf ("[Error] %s(%d) mutex time out!!\n", __FUNCTION__, __LINE__);
                    u32Ret = 0;
                    break;
                }
                // delay for staggered multi-thread
                MsOS_DelayTaskUs(10);
                HAL_SYS_EfuseWrite2Byte(REG_RESERVED4_15_0, ((u32Subbank<<EFUSE_SHIFT) | FLAG_EFUSE_DATA_BUSY));
                if(HAL_SYS_CheckEfuseReadDone() == FALSE)
                {
                    u32Ret = 0;
                    break;
                }

                u32Ret = (HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_31_16)<<16) + HAL_SYS_EfuseRead2Byte(REG_EFUSE_128_RD_15_0);
                if( ((HAL_SYS_EfuseRead2Byte(REG_RESERVED4_15_0) >> EFUSE_SHIFT) & 0xFF) == (MS_U16)u32Subbank)
                    bRetChecked = TRUE;
            }
        }
        if(u32Subbank == 0x71)
        {
            u32Ret = (u32Ret | ((HAL_SYS_Read2Byte(REG_EFUSE_CID) >> 8) << 16));
        }
    }

    return u32Ret;
}

static MS_BOOL HAL_SYS_SetVirtualValue(MS_U32 u32Subbank, MS_U32 u32Offset, MS_U32 u32Value)
{
    MS_BOOL bRet = FALSE;
    MS_U32  u32Index;
    if(u32Offset > 32)
    {
        printf("Input Value ERROR : offset should be 0 to 31 (%d)\n", u32Offset);
        return bRet;
    }
    if(u32Value > 1)
    {
        printf("Input Value ERROR : value should be 0 or 1 (%d)\n", u32Value);
        return bRet;
    }
    for(u32Index = 0; u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX; u32Index++)
    {
        if(_aEfuseVirtualSubBank[u32Index].u8SubBank == (MS_U8)u32Subbank)
        {
            _aEfuseVirtualSubBank[u32Index].u32Value = (u32Value == 0x0) ? _aEfuseVirtualSubBank[u32Index].u32Value & (u32Value<<u32Offset) : _aEfuseVirtualSubBank[u32Index].u32Value | (u32Value<<u32Offset);
            break;
        }
    }
    if(u32Index == SYS_EFUSE_SUB_BANK_CNT_MAX)
    {
        printf("Input Value ERROR : virtual subbank not support : 0x%X\n", u32Subbank);
        return bRet;
    }
    bRet = TRUE;
    return bRet;
}

static MS_BOOL HAL_SYS_ParsingVirtualValue(char *pchBuffer)
{
    MS_BOOL bRet = FALSE;
    char *pchfind_line;
    char *pchfind_char;
    MS_U32 u32Index, u32Subbank, u32Offset, u32Value, u32Lines = 1;
    if(pchBuffer != NULL)
    {
        pchfind_line = strsep(&pchBuffer,"\n");
        while(pchfind_line && strncmp(pchfind_line, "END", 3) != 0)
        {
            u32Subbank = 0, u32Offset = 0, u32Value = 0, u32Index = 0;
            if(strncmp(pchfind_line, "hashkey", 7) == 0)
            {
                pchfind_line = strsep(&pchBuffer,"\n");
                continue;
            }
            pchfind_char = strsep(&pchfind_line," ");
            while(pchfind_char)
            {
                if(u32Index == 0)
                {
#if defined(MSOS_TYPE_LINUX_KERNEL)
                    u32Subbank = (MS_U32)simple_strtol(pchfind_char, NULL, 16);
#elif defined(MSOS_TYPE_LINUX)
                    u32Subbank = (MS_U32)strtol(pchfind_char, NULL, 16);
#endif
                }
                else if(u32Index == 1)
                {
#if defined(MSOS_TYPE_LINUX_KERNEL)
                    u32Offset = (MS_U32)simple_strtol(pchfind_char, NULL, 10);
#elif defined(MSOS_TYPE_LINUX)
                    u32Offset = (MS_U32)strtol(pchfind_char, NULL, 10);
#endif
                }
                else if(u32Index == 2)
                {
#if defined(MSOS_TYPE_LINUX_KERNEL)
                    u32Value = (MS_U32)simple_strtol(pchfind_char, NULL, 2);
#elif defined(MSOS_TYPE_LINUX)
                    u32Value = (MS_U32)strtol(pchfind_char, NULL, 2);
#endif
                }
                else
                {
                    break;
                }
                u32Index++;
                pchfind_char = strsep(&pchfind_line," ");
            }
            if(HAL_SYS_SetVirtualValue(u32Subbank, u32Offset, u32Value) == FALSE)
            {
                printf("LINE%d something wrong\n", u32Lines);
            }
            pchfind_line = strsep(&pchBuffer,"\n");
            u32Lines++;
        }
        bRet = TRUE;
    }
    return bRet;
}

static void HAL_SYS_InitVirtualSubbank(void)
{
    MS_U32 u32Index;
    for(u32Index = 0; u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX; u32Index++)
    {
        _aEfuseVirtualSubBank[u32Index].u32Value = HAL_SYS_GetEFSUESubBankValue((MS_U32)_aEfuseVirtualSubBank[u32Index].u8SubBank);
    }
    return;
}

MS_BOOL HAL_SYS_VirtualInit(void)
{
    MS_BOOL bRet = FALSE;
    char *pchBuffer;
    //
    // get efuse settings
    //

    if(_gMIO_efuse_MapBase == 0)
    {
        MS_VIRT  dwEfuseIoBaseAddress = 0;
        MS_PHY  dwEfuseIoBaseSize = 0;

        if(MDrv_MMIO_GetBASE(&dwEfuseIoBaseAddress, &dwEfuseIoBaseSize, MS_MODULE_PM) == FALSE)
        {
            SYS_ERROR("Get IO Base Address Failed\n");
            MS_ASSERT(0);
            return bRet;
        }

        HAL_SYS_SetEfuseIOMapBase(dwEfuseIoBaseAddress);
    }

    pchBuffer = HAL_SYS_OpenVirtualFile();
    HAL_SYS_InitVirtualSubbank();
    bRet = HAL_SYS_ParsingVirtualValue(pchBuffer);
    HAL_SYS_PrintVirtualEfuse();
    if(pchBuffer != NULL)
    {
#if defined(MSOS_TYPE_LINUX_KERNEL)
        vfree(pchBuffer);
#elif defined(MSOS_TYPE_LINUX)
        free(pchBuffer);
#endif
    }
    return bRet;
}

static MS_U32 HAL_SYS_FindVirtualEfuseIndex(MS_U32 u32SubBank)
{
    MS_U32 u32Ret = SYS_EFUSE_SUB_BANK_CNT_MAX;
    MS_U32 u32Index;

    for(u32Index = 0; u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX; u32Index++)
    {
        if(_aEfuseVirtualSubBank[u32Index].u8SubBank == (MS_U8)u32SubBank)
        {
            u32Ret = u32Index;
            break;
        }
    }
    return u32Ret;
}

MS_BOOL HAL_SYS_VirtualQuery(E_SYS_QUERY id)
{
    MS_BOOL bRet = FALSE;
    MS_U32  u32Index;
    switch (id)
    {
#ifndef CONFIG_PURE_SN
    //PPM subbank 0x67[7]
        case E_SYS_QUERY_IWEDIA_OPEN_BROWSER_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x67);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT7) == 0x0 ? TRUE : FALSE;
            }
            break;
        }

    //PPM subbank 0x66[3:1]
        case E_SYS_QUERY_GINGA_NCL_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x66);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & (BIT3|BIT2|BIT1)) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
#endif /* CONFIG_PURE_SN */
    //PPM subbank 0x66[11]
        case E_SYS_QUERY_BML_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x66);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT11) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x66[10:8]
        case E_SYS_QUERY_TTS_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x66);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = ((_aEfuseVirtualSubBank[u32Index].u32Value & (BIT10|BIT9|BIT8)) >> 8);
            }
            break;
        }
    //PPM subbank 0x67[8]
        case E_SYS_QUERY_IWEDIA_HBBTV_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x67);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT8) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x67[9]
        case E_SYS_QUERY_FOXXUM_TV_STORE_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x67);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT9) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x67[19]
        case E_SYS_QUERY_PLAY_RDY_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x67);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT19) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x67[24]
        case E_SYS_QUERY_ANDROID_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x67);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT24) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x6E[29]
        case E_SYS_QUERY_AV_1_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x6E);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT29) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x6E[20]
        case E_SYS_QUERY_HVD_UHD_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x6E);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT20) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x6E[21]
        case E_SYS_QUERY_EVD_UHD_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x6E);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT21) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x6E[22]
        case E_SYS_QUERY_MDLA_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x6E);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT22) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x6E[24]
        case E_SYS_QUERY_VB1_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x6E);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT24) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x6E[25]
        case E_SYS_QUERY_TCON_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x6E);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT25) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x6E[26]
        case E_SYS_QUERY_GPU_AIPQ_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x6E);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT26) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    //PPM subbank 0x6E[27]
        case E_SYS_QUERY_HDMI_2X_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x6E);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT27) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
        case E_SYS_QUERY_MEMC_60_SUPPORTED:
        {
            /* not support memc 60 on m7332 */
            bRet = FALSE;
            break;
        }
        case E_SYS_QUERY_MEMC_120_SUPPORTED:
        {
            /* not support memc 120 on m7632 */
            bRet = FALSE;
            break;
        }
    //PPM subbank 0x6F[2]
        case E_SYS_QUERY_AIAQ_SCENE_DETECTION_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x6F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT2) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
//*****NON-PPM*****//
    // NON-PPM subbank 0x52[0]
        case E_SYS_QUERY_MPLL_LVDS_CLK_OLD_MODE_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x52);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT0) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    // NON-PPM subbank 0x52[2:1]
        case E_SYS_QUERY_ADCPLL_CLK_SHORT_PATH_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x52);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
            /* 52 bit2   bit1
                  0      0      short path
                  0      1      long path
                  1      0      no die gas path
                  1      1      reserved */
                if ((_aEfuseVirtualSubBank[u32Index].u32Value & BIT2) && (_aEfuseVirtualSubBank[u32Index].u32Value & BIT1))
                {
                    printf("[Error] %s(%d) 0x52=0x%x, invalid option\n", __FUNCTION__, __LINE__, _aEfuseVirtualSubBank[u32Index].u32Value);
                    bRet = FALSE;
                }
                else if(!(_aEfuseVirtualSubBank[u32Index].u32Value & BIT2) && !(_aEfuseVirtualSubBank[u32Index].u32Value & BIT1))
                    bRet = TRUE;
                else
                    bRet = FALSE;
            }

            break;
        }
    // NON-PPM subbank 0x52[2:1]
        case E_SYS_QUERY_ADCPLL_CLK_LONG_PATH_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x52);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
            /* 52 bit2   bit1
                  0      0      short path
                  0      1      long path
                  1      0      no die gas path
                  1      1      reserved */
                if ((_aEfuseVirtualSubBank[u32Index].u32Value & BIT2) && (_aEfuseVirtualSubBank[u32Index].u32Value & BIT1))
                {
                    printf("[Error] %s(%d) 0x52=0x%x, invalid option\n", __FUNCTION__, __LINE__, _aEfuseVirtualSubBank[u32Index].u32Value);
                    bRet = FALSE;
                }
                else if(!(_aEfuseVirtualSubBank[u32Index].u32Value & BIT2) && (_aEfuseVirtualSubBank[u32Index].u32Value & BIT1))
                    bRet = TRUE;
                else
                    bRet = FALSE;
            }

            break;
        }
    // NON-PPM subbank 0x52[2:1]
        case E_SYS_QUERY_ADCPLL_CLK_GAS_PATH_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x52);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
            /* 52 bit2   bit1
                  0      0      short path
                  0      1      long path
                  1      0      no die gas path
                  1      1      reserved */
                if ((_aEfuseVirtualSubBank[u32Index].u32Value & BIT2) && (_aEfuseVirtualSubBank[u32Index].u32Value & BIT1))
                {
                    printf("[Error] %s(%d) 0x52=0x%x, invalid option\n", __FUNCTION__, __LINE__, _aEfuseVirtualSubBank[u32Index].u32Value);
                    bRet = FALSE;
                }
                else if((_aEfuseVirtualSubBank[u32Index].u32Value & BIT2) && !(_aEfuseVirtualSubBank[u32Index].u32Value & BIT1))
                    bRet = TRUE;
                else
                    bRet = FALSE;
            }

            break;
        }
    // NON-PPM subbank 0x52[3]
        case E_SYS_QUERY_HDMI_MODE_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x52);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT3) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    // NON-PPM subbank 0x52[4]
        case E_SYS_QUERY_HDMI_DLEV_TARGET_128MV_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x52);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT4) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[3:0]
        case E_SYS_QUERY_VDD_SELECT_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & (BIT3|BIT2|BIT1|BIT0));
            }
            break;
        }
    // NON-PPM subbank 0x5F[7:4]
        case E_SYS_QUERY_VDD_CPU_SELECT_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = ((_aEfuseVirtualSubBank[u32Index].u32Value & (BIT7|BIT6|BIT5|BIT4)) >> 4);
            }
            break;
        }
    // NON-PPM subbank 0x5F[16]
        case E_SYS_QUERY_HVD_MODE_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT16) == 0x0 ? FALSE : TRUE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[17]
        case E_SYS_QUERY_ROM_BOOT_DC_AC_CHECK_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT17) == 0x0 ? FALSE : TRUE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[18]
        case E_SYS_QUERY_DVFS_MODE_CHECK_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT18) == 0x0 ? FALSE : TRUE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[19]
        case E_SYS_QUERY_CLK_MCU_PM_DEGLITCH_MUX_SELECT_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT19) == 0x0 ? FALSE : TRUE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[20]
        case E_SYS_QUERY_LZMA_SELECT_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT20) == 0x0 ? FALSE : TRUE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[21]
        case E_SYS_QUERY_MIU_STR_SELECT_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT21) == 0x0 ? FALSE : TRUE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[22]
        case E_SYS_QUERY_GOP_DYNAMIC_TYPE_PATCH_SELECT_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT22) == 0x0 ? FALSE : TRUE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[23]
        case E_SYS_QUERY_MVOP_MODE_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT23) == 0x0 ? FALSE : TRUE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[24]
        case E_SYS_QUERY_NRDI_MODE_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT24) == 0x0 ? FALSE : TRUE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[25]
        case E_SYS_QUERY_MIU_SINGLE_COMMAND_ACCESS_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT25) == 0x0 ? FALSE : TRUE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[26]
        case E_SYS_QUERY_MIU_RETRY_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT26) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
    // NON-PPM subbank 0x5F[27]
        case E_SYS_QUERY_AUDIO_SW_RESET_PATCH_SUPPORTED:
        {
            u32Index = HAL_SYS_FindVirtualEfuseIndex((MS_U32)0x5F);
            if(u32Index < SYS_EFUSE_SUB_BANK_CNT_MAX)
            {
                bRet = (_aEfuseVirtualSubBank[u32Index].u32Value & BIT27) == 0x0 ? TRUE : FALSE;
            }
            break;
        }
        default:
        {
            SYS_ERROR("Unknown query!\n");
            bRet = TRUE;

            break;
        }
    }
    return bRet;
}
//-------------------------------------------------------------------------------------------------
MS_U32 HAL_SYS_ReadRSAKey(MS_U16 u16ReadAddr)
{
    return FALSE;
}

E_SYS_PACKAGE_TYPE HAL_SYS_GetPackageType(void)
{
    return E_SYS_PACKAGE_UNKNOWN;
}
