//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
#ifndef _API_XC_PRIVATE_H_
#define _API_XC_PRIVATE_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include "apiXC.h"

//-------------------------------------------------------------------------------------------------
//  Type and Structure
//-------------------------------------------------------------------------------------------------

typedef enum
{
    E_XC_2DMLOAD_MAIN_XC,
    E_XC_2DMLOAD_MAIN_HDR,
    E_XC_2DMLOAD_SUB_XC,
    E_XC_2DMLOAD_SUB_HDR,

    E_XC_2DMLOAD_MAX,
} EN_XC_2DMLOAD_CLIENT;

typedef enum
{
    E_XC_2DMLOAD_TRIGGER_BY_OP_SYNC,
    E_XC_2DMLOAD_TRIGGER_BY_IP_MAIN_SYNC,
    E_XC_2DMLOAD_TRIGGER_BY_IP_SUB_SYNC,
    E_XC_2DMLOAD_TRIGGER_BY_SW,
    E_XC_2DMLOAD_TRIGGER_BY_OP2_SYNC,

    E_XC_2DMLOAD_TRIGGER_MAX,
}EN_XC_2DMLOAD_TRIGGER;

typedef struct __attribute__((packed))
{
    /// Reg Bank (IN)
    MS_U32 u32Bank;
    /// Reg Address (IN)
    MS_U32 u32Addr;
    /// Reg Data (IN)
    MS_U16 u16Data;
    ///Reg Mask (IN)
    MS_U16 u16Mask;
}ST_XC_REGISTER;

typedef struct __attribute__((packed))
{
    EN_XC_2DMLOAD_CLIENT enMloadClient;
    EN_XC_2DMLOAD_TRIGGER enMloadTrigger;

    ST_XC_REGISTER * pstReg;
#if !defined (__aarch64__)
    MS_U32 u32AlignDummy; ///Dummy data
#endif
    MS_U32 u32Count;
}ST_XC_MENULOAD_INFO,*pstXC_MENULOAD_INFO;

typedef enum
{
    E_DS_IP,
    E_DS_OP,
}EN_DS_REG_IP_OP_SEL;

typedef enum
{
    E_DS_XC,
    E_DS_MVOP,
    E_DS_GOP,
}EN_DS_REG_SOURCE_SEL;

typedef enum
{
    E_XC_TEST_WRITE_DSCMD,
    E_XC_TEST_FUNCTION_MAX,
}EN_TEST_FUNCTION;

typedef struct
{
    MS_U32  u32Version;                          //Structure version
    MS_U16  u16Length;                           //Structure length

    SCALER_WIN eWindow;
    MS_U32 u32CmdRegAddr;
    MS_U16 u16CmdRegValue;
    EN_DS_REG_IP_OP_SEL IPOP_Sel;
    EN_DS_REG_SOURCE_SEL Source_Select;
    MS_BOOL bDsEnable;
}ST_XC_WRITE_CMD;

typedef struct
{
    MS_U32  u32Version;                          //Structure version
    MS_U32  u32Length;                           //Structure length

    EN_TEST_FUNCTION enTestFunction;
    ST_XC_WRITE_CMD stXCWriteCmd;
}ST_XC_TEST_FUNCTION;

typedef struct DLL_PACKED
{
    ST_XC_WRITE_CMD *pstXCWriteCmd;
    E_APIXC_ReturnValue eReturnValue;
} stXC_WRITE_CMD, *pstXC_WRITE_CMD;

typedef struct
{
    SCALER_WIN eWindow;
    E_APIXC_ReturnValue eReturnValue;
} stXC_SWDSFIRE, *pstXC_SWDSFIRE;

typedef struct
{
    SCALER_WIN eWindow;
    MS_U32 *pu32BufferSize;
    E_APIXC_ReturnValue eReturnValue;
} stXC_GETDNRBUFFERSIZE, *pstXC_GETDNRBUFFERSIZE;

typedef struct DLL_PACKED
{
    XC_HDR_OTT_SHARE_MEMORY_INFO *pstShareMemInfo;
    E_APIXC_ReturnValue eReturnValue;
} stXC_GETOTTSHMINFO, *pstXC_GETOTTSHMINFO;

typedef struct
{
    ST_XC_MENULOAD_INFO *pstMenuloadInfo;
    SCALER_WIN enWindow;
    E_APIXC_ReturnValue eReturnValue;
} stXC_WRITEANDFIREREGINVSYNCBLANK, *pstXC_WRITEANDFIREREGINVSYNCBLANK;

typedef struct DLL_PACKED
{
    ST_XC_TEST_FUNCTION *pstXCTestFunction;
    E_APIXC_ReturnValue enReturnValue;
}stXC_TEST_FUNCTION, *pstXC_TEST_FUNCTION;

E_APIXC_ReturnValue MApi_XC_WriteCommand(ST_XC_WRITE_CMD *pstXCWriteCmd);
E_APIXC_ReturnValue MApi_XC_SWDS_Fire(SCALER_WIN eWindow);
E_APIXC_ReturnValue MApi_XC_GetDNRBufferSize(SCALER_WIN eWindow, MS_U32 *pu32BufferSize);
E_APIXC_ReturnValue MApi_XC_EnableCaptureMode(MS_BOOL bEnable);
E_APIXC_ReturnValue MApi_XC_GetOttShareMemoryInfo(XC_HDR_OTT_SHARE_MEMORY_INFO *pstShareMemInfo);
E_APIXC_ReturnValue MApi_XC_WriteAndFireReginVsyncBlank(ST_XC_MENULOAD_INFO *pstMenuloadInfo,SCALER_WIN enWindow);

//for midgard test case use
E_APIXC_ReturnValue MApi_XC_TestFunction(ST_XC_TEST_FUNCTION *pstXCTestFunction);

#ifdef __cplusplus
}
#endif

#endif // _API_XC_PRIV_H_
