//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2010 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
/// file    Mdrv_ld_edge2d.c
/// @brief  local dimming Edge2D table
/// @author MStar Semiconductor Inc.
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "mdrv_ld_edge2d.h"

#if  (LD_ENABLE==1)
MS_U8 Tbl_LD_Edge2D_LG32inch_LR10[] =
{
 229,  15,   1,
 222,  19,   2,
 210,  29,   2,
 194,  39,   3,
 180,  45,   5,
 168,  44,   5,
 147,  43,   5,
 113,  34,   5,
  70,  24,   4,
  38,  14,   3,
  22,   9,   2,
  14,   6,   1,
  10,   4,   1,
   6,   3,   1,
   5,   2,   0,
   4,   2,   0,
 170,  71,   4,
 158,  81,   5,
 151,  83,   7,
 147,  83,   8,
 135,  82,  12,
 124,  79,  15,
 114,  72,  11,
  85,  54,  10,
  54,  36,   9,
  29,  17,   6,
  16,  12,   3,
  10,   8,   2,
   6,   5,   2,
   5,   4,   1,
   4,   3,   1,
   3,   2,   0,
  32, 198,  13,
  60, 167,  15,
  57, 159,  23,
  59, 146,  28,
  59, 133,  34,
  65, 118,  34,
  57, 101,  32,
  50,  75,  26,
  33,  46,  14,
  19,  25,  10,
  11,  14,   6,
   8,   9,   4,
   5,   6,   3,
   4,   4,   2,
   3,   3,   1,
   2,   3,   1,
  10, 183,  49,
  15, 154,  71,
  20, 140,  75,
  27, 120,  82,
  31, 107,  82,
  32, 104,  69,
  31,  88,  62,
  27,  66,  50,
  17,  41,  29,
  10,  23,  17,
   7,  13,  11,
   5,   7,   7,
   3,   5,   4,
   2,   3,   2,
   2,   2,   2,
   1,   2,   2,
   3,  35, 197,
   4,  52, 173,
   6,  59, 157,
   8,  59, 143,
   9,  58, 136,
  10,  55, 124,
  11,  49, 107,
   9,  42,  78,
   7,  24,  45,
   5,  14,  24,
   3,   8,  12,
   2,   5,   7,
   1,   3,   6,
   1,   3,   4,
   1,   2,   3,
   1,   2,   2,
   1,  10, 192,
   1,  14, 168,
   2,  18, 150,
   2,  27, 133,
   3,  28, 120,
   4,  29, 115,
   4,  26, 103,
   4,  23,  77,
   3,  15,  47,
   2,   9,  25,
   2,   5,  14,
   1,   4,   9,
   1,   2,   6,
   1,   2,   3,
   0,   1,   3,
   0,   1,   2,
   0,   3,  47,
   0,   4,  60,
   1,   6,  63,
   1,   7,  70,
   1,   9,  70,
   1,  10,  69,
   2,  12,  63,
   2,  10,  48,
   1,   7,  29,
   1,   4,  16,
   1,   2,   9,
   0,   2,   6,
   0,   1,   4,
   0,   1,   3,
   0,   0,   2,
   0,   0,   2,
   0,   1,   9,
   0,   1,  10,
   0,   1,  16,
   0,   2,  19,
   0,   3,  22,
   0,   3,  23,
   0,   3,  24,
   0,   3,  23,
   0,   2,  15,
   0,   1,  10,
   0,   1,   7,
   0,   1,   4,
   0,   0,   3,
   0,   0,   2,
   0,   0,   1,
   0,   0,   1,
   0,   0,   3,
   0,   0,   3,
   0,   0,   4,
   0,   0,   6,
   0,   1,   8,
   0,   1,   9,
   0,   1,   8,
   0,   1,   7,
   0,   1,   7,
   0,   1,   5,
   0,   0,   3,
   0,   0,   2,
   0,   0,   1,
   0,   0,   1,
   0,   0,   0,
   0,   0,   0,
   0,   0,   1,
   0,   0,   1,
   0,   0,   1,
   0,   0,   2,
   0,   0,   2,
   0,   0,   3,
   0,   0,   3,
   0,   0,   3,
   0,   0,   2,
   0,   0,   2,
   0,   0,   1,
   0,   0,   1,
   0,   0,   1,
   0,   0,   0,
   0,   0,   0,
   0,   0,   0,
};


MS_U8 Tbl_LD_Edge2D_LG37inch_LR10[] =
{
 229,  15,   1,
 222,  19,   2,
 210,  29,   2,
 194,  39,   3,
 180,  45,   5,
 168,  44,   5,
 147,  43,   5,
 113,  34,   5,
  70,  24,   4,
  38,  14,   3,
  22,   9,   2,
  14,   6,   1,
  10,   4,   1,
   6,   3,   1,
   5,   2,   0,
   4,   2,   0,
 170,  71,   4,
 158,  81,   5,
 151,  83,   7,
 147,  83,   8,
 135,  82,  12,
 124,  79,  15,
 114,  72,  11,
  85,  54,  10,
  54,  36,   9,
  29,  17,   6,
  16,  12,   3,
  10,   8,   2,
   6,   5,   2,
   5,   4,   1,
   4,   3,   1,
   3,   2,   0,
  32, 198,  13,
  60, 167,  15,
  57, 159,  23,
  59, 146,  28,
  59, 133,  34,
  65, 118,  34,
  57, 101,  32,
  50,  75,  26,
  33,  46,  14,
  19,  25,  10,
  11,  14,   6,
   8,   9,   4,
   5,   6,   3,
   4,   4,   2,
   3,   3,   1,
   2,   3,   1,
  10, 183,  49,
  15, 154,  71,
  20, 140,  75,
  27, 120,  82,
  31, 107,  82,
  32, 104,  69,
  31,  88,  62,
  27,  66,  50,
  17,  41,  29,
  10,  23,  17,
   7,  13,  11,
   5,   7,   7,
   3,   5,   4,
   2,   3,   2,
   2,   2,   2,
   1,   2,   2,
   3,  35, 197,
   4,  52, 173,
   6,  59, 157,
   8,  59, 143,
   9,  58, 136,
  10,  55, 124,
  11,  49, 107,
   9,  42,  78,
   7,  24,  45,
   5,  14,  24,
   3,   8,  12,
   2,   5,   7,
   1,   3,   6,
   1,   3,   4,
   1,   2,   3,
   1,   2,   2,
   1,  10, 192,
   1,  14, 168,
   2,  18, 150,
   2,  27, 133,
   3,  28, 120,
   4,  29, 115,
   4,  26, 103,
   4,  23,  77,
   3,  15,  47,
   2,   9,  25,
   2,   5,  14,
   1,   4,   9,
   1,   2,   6,
   1,   2,   3,
   0,   1,   3,
   0,   1,   2,
   0,   3,  47,
   0,   4,  60,
   1,   6,  63,
   1,   7,  70,
   1,   9,  70,
   1,  10,  69,
   2,  12,  63,
   2,  10,  48,
   1,   7,  29,
   1,   4,  16,
   1,   2,   9,
   0,   2,   6,
   0,   1,   4,
   0,   1,   3,
   0,   0,   2,
   0,   0,   2,
   0,   1,   9,
   0,   1,  10,
   0,   1,  16,
   0,   2,  19,
   0,   3,  22,
   0,   3,  23,
   0,   3,  24,
   0,   3,  23,
   0,   2,  15,
   0,   1,  10,
   0,   1,   7,
   0,   1,   4,
   0,   0,   3,
   0,   0,   2,
   0,   0,   1,
   0,   0,   1,
   0,   0,   3,
   0,   0,   3,
   0,   0,   4,
   0,   0,   6,
   0,   1,   8,
   0,   1,   9,
   0,   1,   8,
   0,   1,   7,
   0,   1,   7,
   0,   1,   5,
   0,   0,   3,
   0,   0,   2,
   0,   0,   1,
   0,   0,   1,
   0,   0,   0,
   0,   0,   0,
   0,   0,   1,
   0,   0,   1,
   0,   0,   1,
   0,   0,   2,
   0,   0,   2,
   0,   0,   3,
   0,   0,   3,
   0,   0,   3,
   0,   0,   2,
   0,   0,   2,
   0,   0,   1,
   0,   0,   1,
   0,   0,   1,
   0,   0,   0,
   0,   0,   0,
   0,   0,   0
};


MS_U8 Tbl_LD_Edge2D_LG42inch_LR16[] =
{
    229      ,18    ,  4     ,  0     ,
    226      ,20    ,  4     ,  0     ,
    224      ,22    ,  4     ,  0     ,
    217      ,28    ,  4     ,  0     ,
    209      ,33    ,  4     ,  0     ,
    203      ,36    ,  4     ,  0     ,
    195      ,38    ,  6     ,  0     ,
    184      ,42    ,  6     ,  0     ,
    173      ,42    ,  7     ,  0     ,
    158      ,41    ,  6     ,  0     ,
    135      ,40    ,  7     ,  0     ,
    108      ,32    ,  5     ,  0     ,
    78      ,27    ,  4     ,  0     ,
    51      ,20    ,  3     ,  0     ,
    34      ,14    ,  2     ,  0     ,
    23      ,10    ,  1     ,  0     ,
    15      ,7    ,  1     ,  0     ,
    11      ,5    ,  0     ,  0     ,
    8      ,4    ,  0     ,  0     ,
    6      ,3    ,  0     ,  0     ,
    4      ,1    ,  0     ,  0     ,
    4      ,1    ,  0     ,  0     ,
    4      ,1    ,  0     ,  0     ,
    4     ,1    ,  0     ,  0    ,
    177      ,63    ,  7     ,  1     ,
    169      ,69    ,  7     ,  1     ,
    165      ,72    ,  8     ,  1     ,
    158      ,77    ,  9     ,  1     ,
    155      ,76    ,  10     ,  1     ,
    148      ,78    ,  11     ,  1     ,
    140      ,76    ,  14     ,  2     ,
    136      ,72    ,  13     ,  3     ,
    126      ,74    ,  12     ,  3     ,
    115      ,67    ,  13     ,  3     ,
    97      ,61    ,  13     ,  3     ,
    77      ,51    ,  11     ,  2     ,
    60      ,42    ,  9     ,  2     ,
    43      ,30    ,  7     ,  1     ,
    29      ,21    ,  5     ,  1     ,
    20      ,15    ,  4     ,  1     ,
    15      ,12    ,  3     ,  1     ,
    10      ,8    ,  3     ,  1     ,
    9      ,6    ,  2     ,  1     ,
    6      ,5    ,  1     ,  0     ,
    5      ,4    ,  1     ,  0     ,
    4      ,4    ,  1     ,  0     ,
    4      ,3    ,  1     ,  0     ,
    3     ,3    ,  1     ,  0    ,
    44      ,179    ,  17     ,  4     ,
    57      ,168    ,  16     ,  4     ,
    62      ,160    ,  17     ,  4     ,
    68      ,148    ,  20     ,  4     ,
    67      ,143    ,  24     ,  4     ,
    65      ,135    ,  26     ,  5     ,
    69      ,126    ,  27     ,  6     ,
    64      ,120    ,  28     ,  7     ,
    64      ,109    ,  28     ,  6     ,
    63      ,97    ,  27     ,  6     ,
    55      ,84    ,  25     ,  6     ,
    45      ,70    ,  22     ,  5     ,
    35      ,54    ,  18     ,  4     ,
    26      ,39    ,  13     ,  4     ,
    20      ,27    ,  10     ,  3     ,
    14      ,20    ,  7     ,  3     ,
    11      ,14    ,  6     ,  2     ,
    9      ,11    ,  5     ,  2     ,
    7      ,9    ,  4     ,  2     ,
    5      ,7    ,  3     ,  1     ,
    4      ,6    ,  3     ,  1     ,
    4      ,5    ,  2     ,  1     ,
    3      ,4    ,  2     ,  1     ,
    3     ,4    ,  2     ,  1    ,
    13      ,159    ,  65     ,  7     ,
    17      ,154    ,  63     ,  8     ,
    18      ,146    ,  70     ,  8     ,
    20      ,140    ,  68     ,  10     ,
    23      ,130    ,  71     ,  11     ,
    24      ,122    ,  72     ,  12     ,
    27      ,120    ,  66     ,  13     ,
    29      ,110    ,  65     ,  13     ,
    28      ,101    ,  64     ,  13     ,
    26      ,91    ,  61     ,  13     ,
    23      ,78    ,  50     ,  12     ,
    21      ,63    ,  42     ,  11     ,
    18      ,50    ,  33     ,  9     ,
    15      ,36    ,  24     ,  7     ,
    10      ,25    ,  17     ,  5     ,
    9      ,18    ,  13     ,  4     ,
    6      ,13    ,  10     ,  4     ,
    6      ,10    ,  7     ,  3     ,
    5      ,9    ,  6     ,  3     ,
    4      ,7    ,  5     ,  2     ,
    3      ,6    ,  4     ,  2     ,
    3      ,5    ,  3     ,  1     ,
    3      ,5    ,  3     ,  1     ,
    3     ,4    ,  3     ,  1    ,
    7      ,41    ,  176     ,  18     ,
    7      ,52    ,  160     ,  20     ,
    8      ,55    ,  153     ,  21     ,
    8      ,60    ,  143     ,  25     ,
    10      ,61    ,  133     ,  29     ,
    10      ,59    ,  127     ,  30     ,
    11      ,60    ,  119     ,  31     ,
    11      ,58    ,  111     ,  31     ,
    13      ,56    ,  103     ,  30     ,
    12      ,53    ,  90     ,  28     ,
    12      ,45    ,  77     ,  27     ,
    11      ,39    ,  61     ,  22     ,
    9      ,30    ,  46     ,  19     ,
    8      ,23    ,  33     ,  14     ,
    7      ,17    ,  23     ,  11     ,
    5      ,12    ,  17     ,  8     ,
    4      ,10    ,  12     ,  6     ,
    4      ,7    ,  9     ,  5     ,
    3      ,7    ,  8     ,  4     ,
    3      ,5    ,  6     ,  3     ,
    3      ,4    ,  5     ,  3     ,
    3      ,4    ,  4     ,  2     ,
    3      ,3    ,  4     ,  2     ,
    3     ,3    ,  4     ,  2    ,
    3      ,14    ,  149     ,  72     ,
    3      ,15    ,  143     ,  75     ,
    4      ,16    ,  134     ,  80     ,
    4      ,20    ,  125     ,  81     ,
    4      ,22    ,  120     ,  80     ,
    5      ,23    ,  115     ,  78     ,
    5      ,23    ,  110     ,  75     ,
    6      ,24    ,  103     ,  72     ,
    7      ,25    ,  95     ,  67     ,
    7      ,24    ,  83     ,  62     ,
    7      ,22    ,  74     ,  51     ,
    6      ,20    ,  57     ,  43     ,
    6      ,17    ,  44     ,  33     ,
    5      ,14    ,  32     ,  23     ,
    4      ,9    ,  22     ,  16     ,
    3      ,7    ,  15     ,  12     ,
    3      ,6    ,  11     ,  9     ,
    3      ,5    ,  9     ,  7     ,
    2      ,5    ,  7     ,  6     ,
    2      ,4    ,  6     ,  5     ,
    2      ,3    ,  5     ,  4     ,
    2      ,3    ,  4     ,  3     ,
    2      ,2    ,  4     ,  3     ,
    2     ,2    ,  3     ,  2    ,
    1      ,7    ,  44     ,  175     ,
    1      ,7    ,  47     ,  164     ,
    2      ,7    ,  59     ,  150     ,
    2      ,8    ,  58     ,  144     ,
    2      ,9    ,  64     ,  131     ,
    3      ,9    ,  64     ,  125     ,
    3      ,11    ,  62     ,  118     ,
    3      ,11    ,  60     ,  110     ,
    3      ,12    ,  58     ,  101     ,
    4      ,11    ,  51     ,  92     ,
    4      ,11    ,  43     ,  78     ,
    4      ,10    ,  37     ,  62     ,
    4      ,9    ,  31     ,  46     ,
    3      ,8    ,  23     ,  33     ,
    3      ,6    ,  16     ,  23     ,
    2      ,5    ,  11     ,  15     ,
    3      ,4    ,  9     ,  11     ,
    3      ,3    ,  7     ,  9     ,
    2      ,3    ,  6     ,  6     ,
    2      ,2    ,  5     ,  6     ,
    2      ,2    ,  4     ,  5     ,
    2      ,2    ,  3     ,  4     ,
    2      ,2    ,  3     ,  4     ,
    2     ,1    ,  2     ,  3    ,
    0      ,2    ,  17     ,  167  ,
    0      ,2    ,  17     ,  152     ,
    0      ,3    ,  18     ,  149     ,
    1      ,3    ,  21     ,  139     ,
    1      ,4    ,  24     ,  129     ,
    1      ,5    ,  23     ,  122     ,
    1      ,6    ,  27     ,  114     ,
    2      ,5    ,  27     ,  108     ,
    2      ,6    ,  27     ,  98     ,
    2      ,5    ,  26     ,  88     ,
    3      ,6    ,  23     ,  73     ,
    3      ,5    ,  19     ,  58     ,
    3      ,5    ,  17     ,  45     ,
    2      ,5    ,  13     ,  32     ,
    2      ,4    ,  9     ,  21     ,
    2      ,3    ,  7     ,  15     ,
    2      ,3    ,  6     ,  12     ,
    2      ,2    ,  5     ,  8     ,
    1      ,2    ,  4     ,  7     ,
    1      ,2    ,  3     ,  5     ,
    1      ,1    ,  2     ,  5     ,
    1      ,1    ,  2     ,  4     ,
    0      ,1    ,  2     ,  3     ,
    0     ,1    ,  2     ,  3    ,
    0      ,1    ,  7     ,  49     ,
    0      ,1    ,  7     ,  64     ,
    0      ,1    ,  8     ,  62     ,
    0      ,1    ,  8     ,  65     ,
    0      ,2    ,  10     ,  65     ,
    1      ,2    ,  11     ,  66     ,
    1      ,3    ,  11     ,  64     ,
    1      ,3    ,  12     ,  60     ,
    1      ,3    ,  12     ,  57     ,
    2      ,3    ,  12     ,  56     ,
    2      ,3    ,  12     ,  49     ,
    1      ,4    ,  10     ,  41     ,
    1      ,3    ,  9     ,  30     ,
    1      ,3    ,  7     ,  22     ,
    1      ,2    ,  5     ,  16     ,
    1      ,2    ,  5     ,  12     ,
    1      ,3    ,  4     ,  9     ,
    1      ,2    ,  3     ,  6     ,
    1      ,2    ,  2     ,  6     ,
    1      ,1    ,  2     ,  5     ,
    0      ,1    ,  2     ,  4     ,
    0      ,1    ,  1     ,  3     ,
    0      ,1    ,  1     ,  2     ,
    0     ,1    ,  1     ,  2    ,
    0      ,0    ,  2     ,  14     ,
    0      ,0    ,  3     ,  17     ,
    0      ,0    ,  3     ,  18     ,
    0      ,0    ,  3     ,  23     ,
    0     ,0    ,  4     ,  26     ,
    0     ,1    ,  5     ,  26     ,
    0     ,1    ,  5     ,  27     ,
    0     ,1    ,  5     ,  29     ,
    0     ,2    ,  6     ,  28     ,
    0     ,2    ,  6     ,  27     ,
    0     ,2    ,  6     ,  26     ,
    0     ,1    ,  6     ,  22     ,
    0     ,1    ,  5     ,  17     ,
    0     ,2    ,  5     ,  14     ,
    0     ,2    ,  3     ,  9     ,
    0     ,1    ,  3     ,  7     ,
    0     ,1    ,  3     ,  6     ,
    0     ,1    ,  2     ,  4     ,
    0     ,1    ,  2     ,  4     ,
    0     ,1    ,  1     ,  3     ,
    0     ,0    ,  1     ,  3     ,
    0     ,0    ,  1     ,  3     ,
    0     ,0    ,  1     ,  2     ,
    0     ,0    ,  1     ,  2    ,
    0     ,0    ,  1     ,  6     ,
    0     ,0    ,  1     ,  6     ,
    0     ,0    ,  1     ,  7     ,
    0     ,0    ,  1     ,  8     ,
    0     ,0    ,  2     ,  9     ,
    0     ,0    ,  2     ,  10     ,
    0     ,0    ,  3     ,  10     ,
    0     ,1    ,  3     ,  11     ,
    0     ,1    ,  3     ,  11     ,
    0     ,2    ,  3     ,  12     ,
    0     ,2    ,  4     ,  11     ,
    0     ,1    ,  4     ,  11     ,
    0     ,1    ,  3     ,  9     ,
    0     ,2    ,  3     ,  7     ,
    0     ,2    ,  2     ,  6     ,
    0     ,1    ,  2     ,  5     ,
    0     ,1    ,  2     ,  3     ,
    0     ,0    ,  2     ,  3     ,
    0     ,0    ,  1     ,  2     ,
    0     ,0    ,  1     ,  2     ,
    0     ,0    ,  1     ,  2     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1    ,
    0     ,0    ,  0     ,  2     ,
    0     ,0    ,  0     ,  3     ,
    0     ,0    ,  0     ,  3     ,
    0     ,0    ,  0     ,  3     ,
    0     ,0    ,  1     ,  4     ,
    0     ,0    ,  1     ,  5     ,
    0     ,0    ,  1     ,  4     ,
    0     ,0    ,  2     ,  5     ,
    0     ,1    ,  2     ,  6     ,
    0     ,1    ,  2     ,  7     ,
    0     ,2    ,  2     ,  6     ,
    0     ,2    ,  2     ,  5     ,
    0     ,2    ,  2     ,  5     ,
    0     ,1    ,  2     ,  4     ,
    0     ,1    ,  2     ,  3     ,
    0     ,1    ,  2     ,  3     ,
    0     ,1    ,  1     ,  3     ,
    0     ,0    ,  1     ,  2     ,
    0     ,0    ,  1     ,  2     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1    ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  2     ,
    0     ,0    ,  0     ,  2     ,
    0     ,0    ,  0     ,  3     ,
    0     ,0    ,  0     ,  3     ,
    0     ,0    ,  1     ,  3     ,
    0     ,0    ,  2     ,  3     ,
    0     ,0    ,  2     ,  3     ,
    0     ,0    ,  1     ,  2     ,
    0     ,0    ,  1     ,  2     ,
    0     ,0    ,  1     ,  2     ,
    0     ,0    ,  1     ,  2     ,
    0     ,0    ,  1     ,  2     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  2     ,
    0     ,0    ,  0     ,  2     ,
    0     ,0    ,  0     ,  2     ,
    0     ,0    ,  0     ,  2     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  1     ,  1     ,
    0     ,0    ,  1     ,  1     ,
    0     ,0    ,  1     ,  1     ,
    0     ,0    ,  1     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  1     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  1    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0    ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0     ,
    0     ,0    ,  0     ,  0
};


MS_U8 Tbl_LD_Edge2D_LG47inch_LR16[] =
{
    239,    2,    2,    1,
    238,    3,    2,    1,
    235,    3,    2,    1,
    234,    4,    2,    2,
    229,    4,    3,    2,
    222,    5,    4,    2,
    215,    5,    5,    3,
    208,    5,    4,    3,
    176,    12,    6,    4,
    162,    21,    4,    4,
    144,    15,    4,    4,
    120,    17,    5,    4,
    82,    13,    4,    4,
    63,    13,    3,    3,
    44,    9,    2,    3,
    38,    9,    2,    3,
    21,    5,    1,    2,
    18,    3,    1,    2,
    13,    2,    1,    2,
    10,    2,    0,    1,
    8,    2,    0,    1,
    7,    1,    1,    1,
    5,    1,    1,    1,
    5,    1,    1,    1,
    211,    29,    3,    2,
    202,    37,    4,    2,
    193,    42,    5,    2,
    187,    44,    6,    3,
    182,    45,    6,    3,
    177,    46,    7,    3,
    172,    42,    7,    5,
    164,    41,    8,    5,
    154,    43,    8,    6,
    141,    42,    10,    6,
    121,    34,    9,    6,
    98,    30,    8,    6,
    75,    23,    6,    5,
    55,    18,    4,    4,
    34,    11,    4,    4,
    27,    8,    2,    3,
    22,    7,    2,    3,
    16,    5,    2,    2,
    12,    4,    1,    2,
    9,    3,    1,    2,
    8,    2,    1,    1,
    7,    2,    1,    1,
    5,    1,    1,    1,
    5,    1,    1,    1,
    105,    115,    12,    7,
    101,    117,    16,    7,
    109,    108,    15,    8,
    98,    110,    16,    10,
    112,    95,    16,    10,
    127,    78,    13,    12,
    124,    66,    17,    14,
    115,    71,    19,    12,
    112,    63,    19,    13,
    100,    61,    17,    11,
    86,    49,    18,    13,
    63,    43,    16,    12,
    59,    35,    9,    10,
    45,    24,    6,    8,
    34,    13,    5,    7,
    24,    10,    4,    5,
    18,    8,    3,    4,
    16,    7,    3,    4,
    12,    4,    2,    3,
    9,    4,    2,    3,
    10,    3,    1,    3,
    7,    2,    1,    2,
    6,    1,    0,    2,
    7,    2,    1,    2,
    39,    140,    39,    20,
    51,    123,    34,    24,
    69,    82,    48,    29,
    76,    59,    54,    36,
    72,    75,    46,    33,
    73,    76,    43,    31,
    68,    76,    42,    32,
    66,    68,    41,    35,
    73,    48,    37,    36,
    75,    23,    30,    39,
    64,    22,    30,    35,
    53,    29,    24,    29,
    40,    25,    18,    25,
    36,    20,    14,    21,
    29,    16,    11,    17,
    18,    11,    8,    12,
    14,    7,    4,    9,
    12,    4,    3,    8,
    11,    3,    2,    6,
    9,    2,    2,    6,
    10,    1,    2,    5,
    8,    2,    2,    5,
    7,    1,    1,    5,
    5,    1,    1,    4,
    21,    58,    96,    49,
    24,    61,    88,    52,
    23,    57,    80,    65,
    25,    49,    74,    74,
    31,    44,    69,    75,
    30,    53,    60,    70,
    33,    52,    46,    77,
    32,    49,    44,    77,
    30,    52,    42,    69,
    28,    48,    39,    64,
    26,    37,    32,    61,
    24,    29,    26,    51,
    20,    21,    19,    43,
    15,    17,    13,    31,
    12,    12,    6,    26,
    11,    9,    5,    17,
    9,    8,    4,    13,
    7,    6,    4,    12,
    6,    5,    4,    10,
    6,    3,    3,    8,
    5,    3,    3,    7,
    5,    3,    2,    7,
    4,    3,    1,    8,
    5,    2,    2,    7,
    6,    10,    82,    125,
    7,    11,    66,    140,
    8,    13,    64,    136,
    8,    16,    55,    141,
    10,    16,    53,    134,
    12,    20,    56,    119,
    11,    18,    51,    124,
    12,    14,    48,    121,
    12,    13,    44,    115,
    12,    16,    38,    104,
    11,    15,    24,    100,
    10,    14,    23,    77,
    9,    11,    17,    60,
    7,    9,    12,    43,
    6,    6,    8,    31,
    5,    4,    6,    22,
    4,    3,    5,    17,
    4,    2,    4,    13,
    3,    2,    2,    12,
    3,    2,    2,    9,
    2,    2,    1,    7,
    2,    2,    1,    7,
    2,    1,    1,    6,
    3,    1,    1,    6,
    2,    4,    11,    205,
    3,    5,    17,    190,
    3,    4,    15,    191,
    3,    4,    17,    180,
    3,    6,    20,    172,
    4,    6,    20,    162,
    4,    7,    19,    155,
    5,    7,    17,    151,
    5,    6,    15,    143,
    5,    5,    17,    123,
    5,    6,    14,    110,
    4,    5,    12,    91,
    4,    5,    9,    66,
    3,    4,    6,    48,
    3,    3,    5,    36,
    3,    3,    2,    24,
    2,    2,    2,    16,
    1,    1,    2,    12,
    1,    1,    2,    10,
    1,    1,    1,    8,
    1,    1,    1,    7,
    1,    1,    1,    6,
    1,    1,    1,    6,
    1,    1,    1,    4,
    1,    2,    5,    175,
    1,    2,    6,    163,
    1,    2,    7,    159,
    1,    2,    8,    154,
    1,    3,    6,    146,
    2,    3,    10,    139,
    2,    3,    9,    132,
    2,    3,    9,    127,
    2,    3,    9,    121,
    2,    3,    9,    111,
    2,    3,    9,    101,
    2,    2,    6,    79,
    2,    2,    5,    57,
    2,    2,    4,    34,
    1,    1,    3,    28,
    1,    1,    2,    19,
    1,    1,    2,    14,
    1,    1,    1,    10,
    1,    1,    1,    10,
    1,    0,    1,    7,
    1,    0,    0,    6,
    1,    0,    0,    5,
    1,    0,    0,    5,
    1,    0,    0,    4,
    0,    1,    2,    59,
    0,    1,    3,    67,
    0,    1,    3,    69,
    1,    1,    3,    72,
    0,    1,    3,    78,
    1,    2,    4,    74,
    1,    2,    4,    80,
    1,    2,    4,    78,
    1,    1,    4,    74,
    1,    1,    4,    68,
    1,    1,    4,    66,
    1,    1,    3,    50,
    1,    1,    2,    39,
    1,    1,    2,    24,
    0,    1,    2,    21,
    1,    1,    1,    15,
    0,    0,    1,    10,
    0,    0,    1,    8,
    0,    0,    1,    8,
    0,    0,    1,    6,
    0,    0,    0,    5,
    0,    0,    0,    5,
    0,    0,    1,    4,
    0,    0,    0,    3,
    0,    1,    1,    22,
    0,    1,    1,    24,
    0,    0,    2,    28,
    0,    1,    2,    33,
    0,    0,    2,    34,
    0,    0,    3,    40,
    0,    1,    3,    43,
    0,    1,    3,    43,
    0,    1,    2,    41,
    0,    1,    2,    37,
    0,    1,    2,    36,
    0,    1,    1,    31,
    0,    1,    1,    24,
    0,    1,    1,    19,
    0,    1,    1,    16,
    0,    0,    1,    10,
    0,    0,    0,    8,
    0,    0,    1,    6,
    0,    0,    0,    5,
    0,    0,    0,    5,
    0,    0,    1,    4,
    0,    0,    0,    4,
    0,    0,    1,    4,
    0,    0,    0,    3,
    0,    0,    1,    14,
    0,    1,    1,    16,
    0,    1,    1,    16,
    0,    0,    1,    17,
    0,    0,    1,    20,
    0,    0,    2,    21,
    0,    0,    1,    21,
    0,    0,    1,    22,
    0,    1,    2,    23,
    0,    0,    1,    20,
    0,    1,    1,    20,
    0,    1,    1,    17,
    0,    0,    1,    15,
    1,    1,    1,    10,
    1,    0,    1,    9,
    0,    0,    1,    7,
    0,    0,    0,    6,
    0,    0,    0,    5,
    0,    0,    0,    5,
    0,    0,    0,    4,
    1,    1,    0,    4,
    1,    0,    0,    3,
    0,    0,    0,    3,
    0,    0,    0,    3,
    1,    1,    1,    9,
    0,    0,    0,    9,
    0,    0,    1,    9,
    0,    0,    0,    9,
    0,    0,    1,    11,
    0,    1,    1,    12,
    0,    0,    1,    13,
    0,    0,    1,    13,
    0,    0,    1,    12,
    0,    1,    1,    11,
    0,    0,    1,    12,
    0,    1,    1,    11,
    0,    0,    0,    9,
    1,    1,    1,    7,
    0,    1,    0,    7,
    0,    0,    0,    5,
    0,    0,    0,    5,
    0,    0,    0,    3,
    0,    0,    0,    3,
    0,    0,    0,    3,
    0,    0,    0,    3,
    0,    0,    1,    3,
    0,    0,    0,    3,
    0,    0,    0,    3,
    0,    0,    0,    4,
    0,    0,    0,    4,
    0,    1,    1,    5,
    0,    0,    0,    6,
    0,    0,    0,    5,
    0,    0,    0,    6,
    0,    1,    1,    6,
    0,    0,    0,    6,
    0,    0,    1,    7,
    0,    1,    1,    8,
    0,    0,    0,    7,
    0,    1,    1,    6,
    1,    0,    0,    4,
    0,    0,    0,    5,
    0,    0,    0,    5,
    0,    0,    0,    4,
    0,    0,    0,    3,
    0,    0,    0,    3,
    0,    0,    0,    2,
    0,    1,    0,    3,
    1,    1,    1,    3,
    0,    0,    0,    2,
    0,    0,    0,    3,
    1,    0,    0,    2,
    0,    0,    0,    2,
    0,    0,    0,    2,
    0,    0,    0,    1,
    0,    0,    0,    2,
    0,    0,    0,    2,
    0,    0,    0,    2,
    0,    0,    0,    3,
    0,    0,    0,    3,
    0,    0,    0,    3,
    0,    1,    0,    3,
    0,    0,    0,    3,
    0,    0,    0,    3,
    1,    0,    1,    3,
    0,    0,    0,    2,
    0,    0,    0,    2,
    0,    0,    0,    2,
    0,    0,    0,    2,
    0,    0,    0,    2,
    0,    1,    0,    1,
    0,    1,    0,    2,
    0,    0,    0,    2,
    0,    0,    0,    1,
    0,    1,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    2,
    0,    0,    0,    2,
    0,    0,    0,    2,
    0,    0,    0,    2,
    0,    0,    0,    1,
    0,    0,    0,    2,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    1,    0,    2,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    1,
    0,    0,    0,    0,
    0,    0,    0,    1,
    1,    1,    0,    1,
    1,    0,    0,    1,
    1,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    1,    0,    1,    2,
    0,    1,    0,    2,
    1,    0,    1,    2,
    1,    1,    1,    2,
    0,    1,    1,    2,
    0,    0,    1,    1,
    0,    0,    0,    1,
    1,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    1,    0,    0,    1,
    0,    0,    0,    1,
    1,    0,    0,    1,
};



MS_U8 Tbl_LD_Edge2D_LG55inch_LR12[] =
{
     234,   6,   0
    , 231,   7,   0
    , 227,  10,   0
    , 220,  15,   1
    , 214,  18,   1
    , 206,  22,   2
    , 197,  26,   2
    , 185,  27,   2
    , 173,  28,   2
    , 156,  28,   3
    , 136,  28,   3
    , 112,  26,   3
    ,  85,  22,   2
    ,  63,  18,   2
    ,  46,  14,   2
    ,  33,  11,   2
    ,  24,   9,   1
    ,  17,   7,   1
    ,  13,   6,   1
    ,  10,   5,   1
    ,   9,   4,   1
    ,   7,   4,   1
    ,   7,   3,   0
    ,   6,   3,   0
    , 224,  14,   1
    , 220,  18,   1
    , 210,  26,   1
    , 201,  33,   1
    , 193,  37,   2
    , 187,  39,   3
    , 178,  42,   3
    , 165,  46,   4
    , 156,  44,   4
    , 139,  44,   4
    , 122,  41,   4
    , 101,  36,   4
    ,  76,  30,   4
    ,  57,  24,   3
    ,  41,  19,   3
    ,  30,  15,   2
    ,  23,  12,   2
    ,  16,   9,   2
    ,  13,   8,   1
    ,  11,   7,   1
    ,   9,   6,   1
    ,   8,   5,   1
    ,   7,   5,   1
    ,   7,   4,   1
    , 175,  59,   2
    , 166,  67,   2
    , 162,  70,   2
    , 151,  77,   4
    , 142,  82,   5
    , 138,  80,   6
    , 132,  80,   7
    , 123,  80,   7
    , 115,  76,   8
    , 103,  71,   8
    ,  90,  64,   8
    ,  75,  55,   7
    ,  60,  45,   7
    ,  46,  35,   6
    ,  34,  27,   5
    ,  25,  21,   4
    ,  19,  17,   4
    ,  15,  13,   3
    ,  12,  11,   3
    ,  10,   9,   2
    ,   8,   8,   2
    ,   7,   7,   2
    ,   7,   6,   2
    ,   6,   6,   2
    ,  45, 183,   5
    ,  58, 169,   6
    ,  67, 157,   8
    ,  70, 149,  11
    ,  74, 140,  13
    ,  72, 135,  15
    ,  72, 127,  16
    ,  73, 118,  16
    ,  67, 110,  17
    ,  62, 100,  17
    ,  55,  88,  17
    ,  48,  73,  15
    ,  38,  60,  14
    ,  31,  46,  11
    ,  23,  36,  10
    ,  18,  29,   8
    ,  14,  22,   6
    ,  11,  17,   6
    ,   9,  14,   4
    ,   8,  12,   4
    ,   7,  10,   3
    ,   6,   9,   3
    ,   5,   8,   3
    ,   5,   8,   3
    ,  13, 204,  15
    ,  18, 194,  20
    ,  21, 179,  31
    ,  25, 170,  32
    ,  28, 160,  36
    ,  29, 152,  38
    ,  31, 143,  39
    ,  33, 132,  38
    ,  32, 121,  39
    ,  31, 108,  37
    ,  28,  93,  34
    ,  26,  78,  28
    ,  22,  66,  25
    ,  19,  51,  20
    ,  15,  39,  16
    ,  11,  30,  13
    ,  10,  23,  10
    ,   7,  18,   9
    ,   6,  15,   7
    ,   5,  13,   7
    ,   4,  11,   6
    ,   4,   9,   5
    ,   4,   9,   4
    ,   4,   8,   4
    ,   5, 169,  57
    ,   5, 147,  77
    ,   7, 144,  76
    ,   9, 136,  79
    ,  11, 128,  82
    ,  12, 123,  81
    ,  12, 115,  82
    ,  15, 109,  74
    ,  15, 103,  71
    ,  14,  92,  66
    ,  13,  79,  61
    ,  13,  67,  50
    ,  12,  56,  41
    ,   9,  43,  33
    ,   8,  34,  25
    ,   6,  26,  20
    ,   6,  21,  16
    ,   4,  16,  13
    ,   4,  13,  10
    ,   3,  11,   9
    ,   3,  10,   8
    ,   3,   9,   7
    ,   2,   8,   6
    ,   2,   8,   6
    ,   2,  43, 184
    ,   2,  63, 161
    ,   2,  63, 158
    ,   3,  67, 147
    ,   4,  66, 141
    ,   5,  68, 134
    ,   5,  70, 124
    ,   6,  69, 116
    ,   6,  66, 108
    ,   6,  60,  98
    ,   6,  54,  85
    ,   6,  46,  72
    ,   5,  38,  58
    ,   5,  31,  45
    ,   4,  23,  33
    ,   3,  19,  25
    ,   3,  15,  20
    ,   3,  13,  17
    ,   2,  10,  14
    ,   2,   9,  12
    ,   2,   8,  10
    ,   1,   7,   9
    ,   1,   6,   8
    ,   1,   6,   7
    ,   1,  13, 207
    ,   1,  18, 197
    ,   1,  22, 183
    ,   1,  28, 171
    ,   2,  29, 161
    ,   2,  29, 154
    ,   2,  32, 142
    ,   2,  32, 132
    ,   3,  31, 125
    ,   3,  30, 111
    ,   3,  29,  96
    ,   3,  26,  80
    ,   3,  22,  64
    ,   2,  19,  49
    ,   2,  16,  38
    ,   2,  12,  29
    ,   1,  10,  23
    ,   1,   8,  18
    ,   1,   7,  15
    ,   1,   6,  13
    ,   1,   5,  11
    ,   1,   5,   9
    ,   1,   4,   8
    ,   1,   4,   8
    ,   0,   4, 173
    ,   0,   5, 155
    ,   0,   7, 148
    ,   0,  10, 144
    ,   0,  12, 135
    ,   1,  13, 128
    ,   1,  14, 124
    ,   1,  15, 118
    ,   1,  15, 107
    ,   1,  15,  95
    ,   1,  14,  81
    ,   1,  13,  66
    ,   1,  12,  58
    ,   1,  10,  44
    ,   1,   8,  34
    ,   1,   7,  25
    ,   1,   6,  20
    ,   1,   5,  17
    ,   0,   4,  13
    ,   0,   4,  11
    ,   0,   4,  10
    ,   0,   3,   9
    ,   0,   3,   8
    ,   0,   3,   8
    ,   0,   2,  51
    ,   0,   2,  67
    ,   0,   3,  70
    ,   0,   3,  68
    ,   0,   5,  71
    ,   0,   5,  73
    ,   0,   5,  69
    ,   0,   6,  65
    ,   0,   6,  65
    ,   1,   7,  62
    ,   1,   6,  54
    ,   1,   6,  47
    ,   1,   6,  38
    ,   1,   5,  31
    ,   0,   4,  22
    ,   0,   3,  18
    ,   0,   3,  15
    ,   0,   2,  12
    ,   0,   2,  10
    ,   0,   2,   9
    ,   0,   2,   8
    ,   0,   2,   7
    ,   0,   2,   6
    ,   0,   2,   6
    ,   0,   1,  12
    ,   0,   1,  16
    ,   0,   1,  23
    ,   0,   1,  26
    ,   0,   2,  30
    ,   0,   2,  32
    ,   0,   2,  34
    ,   0,   3,  35
    ,   0,   3,  32
    ,   0,   3,  29
    ,   0,   3,  28
    ,   0,   3,  25
    ,   0,   3,  22
    ,   0,   2,  17
    ,   0,   2,  14
    ,   0,   2,  11
    ,   0,   1,   9
    ,   0,   1,   7
    ,   0,   1,   6
    ,   0,   1,   5
    ,   0,   1,   4
    ,   0,   1,   4
    ,   0,   1,   4
    ,   0,   1,   3
    ,   0,   0,   4
    ,   0,   0,   5
    ,   0,   0,   7
    ,   0,   0,   9
    ,   0,   1,  12
    ,   0,   1,  12
    ,   0,   1,  13
    ,   0,   1,  13
    ,   0,   1,  14
    ,   0,   1,  14
    ,   0,   1,  13
    ,   0,   1,  12
    ,   0,   1,  10
    ,   0,   1,   9
    ,   0,   1,   7
    ,   0,   1,   6
    ,   0,   1,   5
    ,   0,   0,   4
    ,   0,   0,   4
    ,   0,   0,   3
    ,   0,   0,   3
    ,   0,   0,   3
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   3
    ,   0,   0,   4
    ,   0,   0,   5
    ,   0,   0,   5
    ,   0,   0,   6
    ,   0,   0,   5
    ,   0,   0,   6
    ,   0,   0,   6
    ,   0,   0,   5
    ,   0,   0,   5
    ,   0,   0,   4
    ,   0,   0,   3
    ,   0,   0,   3
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   0
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   3
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   2
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   1
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,   0,   0,   0
    ,

};

MS_U8 Tbl_LD_Edge2D_LG55inch_LR16[] =
{
    212,    21,    3,    0,
    208,    22,    3,    1,
    201,    29,    3,    1,
    190,    33,    4,    1,
    181,    39,    6,    1,
    174,    41,    6,    1,
    169,    41,    6,    1,
    159,    43,    7,    2,
    150,    40,    8,    2,
    136,    41,    8,    2,
    119,    40,    6,    2,
    100,    33,    6,    2,
    76,    26,    5,    2,
    56,    20,    5,    2,
    41,    16,    5,    3,
    30,    13,    4,    2,
    23,    10,    3,    2,
    18,    8,    3,    2,
    15,    8,    3,    2,
    12,    6,    2,    2,
    11,    6,    2,    1,
    10,    5,    2,    1,
    9,    5,    2,    1,
    8,    4,    2,    1,
    154,    72,    6,    1,
    156,    69,    6,    1,
    149,    75,    8,    1,
    139,    80,    10,    2,
    133,    81,    12,    2,
    127,    85,    12,    2,
    123,    82,    14,    2,
    116,    80,    16,    2,
    112,    74,    15,    2,
    103,    69,    14,    3,
    89,    61,    14,    2,
    74,    52,    13,    2,
    57,    41,    10,    2,
    43,    31,    8,    2,
    31,    22,    7,    2,
    24,    17,    5,    2,
    17,    12,    4,    2,
    14,    10,    4,    2,
    11,    8,    3,    1,
    10,    7,    2,    1,
    8,    6,    2,    2,
    8,    5,    2,    1,
    7,    5,    2,    1,
    6,    4,    2,    1,
    37,    176,    18,    2,
    53,    157,    20,    3,
    61,    150,    20,    3,
    59,    143,    27,    4,
    63,    132,    31,    4,
    66,    125,    33,    4,
    64,    120,    34,    4,
    65,    112,    34,    5,
    60,    105,    35,    5,
    59,    94,    32,    5,
    51,    82,    29,    5,
    47,    67,    23,    5,
    35,    51,    18,    4,
    28,    37,    15,    3,
    20,    25,    12,    3,
    15,    18,    9,    2,
    12,    13,    6,    2,
    9,    10,    5,    2,
    8,    9,    4,    2,
    7,    7,    4,    2,
    6,    6,    3,    1,
    5,    5,    3,    1,
    5,    5,    3,    1,
    5,    5,    3,    1,
    12,    142,    75,    5,
    16,    140,    69,    7,
    18,    128,    79,    8,
    19,    127,    75,    9,
    19,    120,    80,    10,
    23,    114,    79,    11,
    23,    111,    73,    13,
    26,    102,    74,    14,
    24,    96,    72,    13,
    24,    87,    67,    14,
    23,    77,    55,    13,
    18,    64,    45,    11,
    17,    48,    35,    9,
    14,    35,    25,    7,
    10,    24,    18,    5,
    9,    17,    13,    4,
    7,    13,    9,    3,
    6,    10,    8,    3,
    5,    8,    6,    2,
    4,    7,    5,    2,
    4,    6,    4,    2,
    3,    5,    4,    2,
    3,    5,    4,    2,
    3,    4,    3,    2,
    5,    42,    169,    20,
    6,    48,    156,    22,
    6,    57,    144,    25,
    7,    55,    140,    29,
    8,    59,    129,    33,
    9,    57,    127,    32,
    9,    60,    121,    32,
    11,    63,    110,    32,
    11,    56,    106,    32,
    10,    54,    94,    32,
    11,    47,    81,    29,
    9,    41,    65,    24,
    8,    31,    49,    18,
    7,    23,    34,    13,
    5,    17,    24,    9,
    5,    12,    16,    7,
    4,    9,    12,    5,
    3,    7,    9,    4,
    3,    6,    7,    4,
    3,    5,    6,    3,
    2,    4,    5,    3,
    2,    4,    4,    3,
    2,    4,    4,    2,
    2,    3,    4,    2,
    2,    14,    154,    65,
    2,    15,    139,    77,
    2,    17,    139,    72,
    3,    20,    125,    82,
    3,    21,    124,    78,
    4,    25,    117,    77,
    4,    25,    112,    76,
    4,    24,    108,    74,
    4,    26,    103,    65,
    4,    25,    91,    66,
    4,    24,    80,    57,
    4,    20,    64,    46,
    4,    15,    50,    33,
    3,    12,    33,    23,
    3,    9,    22,    16,
    3,    7,    16,    11,
    2,    6,    11,    8,
    2,    4,    8,    6,
    2,    4,    7,    5,
    2,    3,    6,    4,
    2,    3,    5,    3,
    2,    3,    4,    3,
    1,    3,    4,    3,
    1,    2,    4,    3,
    1,    5,    36,    185,
    1,    5,    46,    174,
    1,    6,    51,    164,
    1,    7,    55,    153,
    1,    8,    58,    143,
    1,    8,    63,    137,
    2,    10,    61,    132,
    2,    10,    65,    120,
    2,    10,    63,    111,
    2,    9,    59,    103,
    2,    9,    51,    90,
    2,    8,    41,    72,
    2,    7,    32,    49,
    2,    6,    21,    32,
    2,    5,    14,    20,
    2,    4,    10,    13,
    1,    3,    7,    9,
    1,    3,    6,    7,
    1,    3,    5,    6,
    1,    2,    4,    5,
    1,    2,    3,    4,
    1,    2,    3,    4,
    1,    2,    3,    3,
    1,    2,    3,    3,
    0,    2,    13,    173,
    0,    2,    13,    163,
    1,    2,    17,    153,
    1,    3,    21,    146,
    1,    3,    22,    135,
    1,    3,    25,    124,
    1,    4,    28,    118,
    1,    4,    29,    113,
    1,    4,    28,    107,
    1,    4,    25,    99,
    1,    4,    24,    86,
    1,    4,    21,    68,
    1,    3,    14,    47,
    1,    3,    11,    28,
    1,    3,    8,    18,
    1,    2,    6,    12,
    1,    2,    5,    8,
    1,    2,    4,    6,
    1,    2,    4,    5,
    1,    2,    3,    4,
    1,    2,    3,    4,
    1,    1,    2,    4,
    1,    2,    3,    4,
    1,    1,    2,    3,
    1,    1,    5,    42,
    1,    1,    5,    53,
    1,    1,    6,    58,
    0,    1,    7,    60,
    0,    1,    8,    66,
    0,    1,    8,    72,
    0,    2,    9,    70,
    1,    2,    10,    68,
    1,    2,    11,    65,
    1,    2,    11,    61,
    1,    2,    10,    55,
    1,    2,    9,    44,
    1,    2,    7,    29,
    1,    2,    6,    20,
    1,    2,    4,    12,
    1,    1,    3,    9,
    1,    1,    3,    6,
    1,    1,    2,    5,
    1,    1,    2,    4,
    1,    1,    2,    4,
    1,    1,    2,    3,
    1,    1,    2,    3,
    1,    1,    2,    3,
    2,    2,    2,    3,
    0,    0,    2,    11,
    0,    0,    2,    13,
    0,    0,    3,    16,
    0,    0,    3,    19,
    0,    0,    3,    22,
    0,    1,    3,    21,
    0,    1,    4,    21,
    0,    1,    4,    25,
    0,    1,    4,    26,
    1,    1,    4,    25,
    1,    1,    4,    21,
    1,    1,    4,    18,
    1,    1,    3,    13,
    1,    1,    3,    9,
    1,    1,    2,    7,
    1,    1,    2,    5,
    1,    1,    2,    4,
    1,    1,    2,    3,
    1,    1,    2,    3,
    1,    1,    1,    3,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    2,
    0,    0,    1,    4,
    0,    0,    1,    5,
    0,    0,    1,    6,
    0,    0,    1,    6,
    0,    0,    1,    6,
    0,    0,    1,    7,
    0,    0,    2,    8,
    0,    0,    2,    9,
    0,    0,    2,    10,
    0,    0,    2,    8,
    0,    1,    2,    9,
    1,    1,    2,    7,
    1,    1,    2,    6,
    1,    1,    2,    5,
    1,    1,    2,    4,
    1,    1,    2,    3,
    1,    1,    2,    3,
    1,    1,    2,    2,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    1,
    1,    1,    1,    1,
    0,    0,    1,    2,
    1,    1,    1,    2,
    0,    1,    1,    2,
    0,    0,    1,    2,
    0,    0,    1,    3,
    0,    0,    1,    3,
    0,    0,    1,    3,
    0,    0,    1,    3,
    0,    0,    1,    4,
    0,    0,    1,    4,
    0,    0,    1,    4,
    1,    1,    1,    3,
    1,    1,    1,    3,
    1,    1,    1,    3,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    1,
    1,    1,    1,    2,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    0,    0,    1,    1,
    0,    0,    1,    1,
    0,    0,    0,    1,
    0,    0,    1,    1,
    0,    0,    0,    2,
    0,    0,    1,    2,
    0,    0,    1,    2,
    0,    0,    1,    2,
    0,    0,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    2,    1,    1,    1,
    2,    1,    1,    2,
    0,    0,    0,    1,
    1,    1,    1,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    1,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    1,    1,
    0,    0,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    2,    1,    1,    1,
    2,    2,    1,    2,
    0,    0,    0,    0,
    1,    1,    0,    1,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    1,    0,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    2,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    2,    1,    1,    1,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    0,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    0,    1,
    0,    0,    1,    1,
    0,    0,    1,    1,
    0,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    1,    1,    1,    1,
    2,    1,    1,    2,
    2,    2,    1,    2,
    1,    1,    1,    2,
    1,    1,    1,    2,
    1,    1,    0,    1,
    1,    1,    1,    1,
    1,    1,    0,    1,
};

MS_U8 Tbl_LD_Edge2D_CMO42inch_LR16[] =
{
     226,  15,   2,   0
    , 220,  21,   3,   0
    , 213,  27,   3,   0
    , 201,  36,   4,   0
    , 188,  47,   6,   1
    , 177,  51,   8,   1
    , 165,  55,  10,   2
    , 155,  57,  12,   2
    , 145,  55,  13,   3
    , 131,  54,  14,   4
    , 115,  48,  13,   4
    ,  90,  38,  11,   4
    ,  60,  27,   8,   3
    ,  36,  16,   6,   2
    ,  22,  11,   4,   2
    ,  14,   7,   3,   1
    ,   9,   5,   2,   1
    ,   6,   4,   2,   1
    ,   4,   3,   1,   1
    ,   3,   2,   1,   0
    ,   2,   2,   1,   0
    ,   2,   1,   1,   0
    ,   2,   1,   0,   0
    ,   2,   1,   0,   0
    , 193,  48,   4,   0
    , 174,  66,   5,   1
    , 163,  74,   7,   1
    , 155,  79,   9,   1
    , 143,  85,  12,   1
    , 139,  84,  14,   2
    , 129,  86,  18,   3
    , 122,  85,  20,   4
    , 117,  81,  20,   4
    , 106,  77,  21,   5
    ,  91,  68,  19,   5
    ,  69,  53,  16,   4
    ,  51,  38,  12,   3
    ,  30,  22,   7,   2
    ,  18,  14,   5,   2
    ,  11,   8,   3,   1
    ,   7,   6,   2,   1
    ,   5,   4,   2,   1
    ,   3,   3,   1,   0
    ,   2,   2,   1,   0
    ,   2,   2,   1,   0
    ,   1,   1,   0,   0
    ,   1,   1,   0,   0
    ,   1,   1,   0,   0
    ,  57, 174,  13,   2
    ,  70, 158,  16,   2
    ,  77, 145,  21,   2
    ,  80, 133,  27,   3
    ,  81, 127,  31,   3
    ,  76, 121,  38,   5
    ,  78, 115,  37,   6
    ,  70, 111,  42,   8
    ,  71, 104,  40,   8
    ,  67,  95,  37,   8
    ,  58,  82,  33,   8
    ,  45,  65,  27,   7
    ,  31,  45,  20,   5
    ,  19,  28,  13,   4
    ,  11,  16,   8,   2
    ,   7,  10,   5,   2
    ,   5,   7,   3,   1
    ,   3,   5,   2,   1
    ,   2,   3,   2,   1
    ,   2,   2,   1,   0
    ,   1,   2,   1,   0
    ,   1,   1,   1,   0
    ,   1,   1,   1,   0
    ,   1,   1,   1,   0
    ,  11, 161,  68,   5
    ,  17, 156,  67,   5
    ,  22, 142,  74,   6
    ,  26, 127,  80,   9
    ,  30, 121,  79,  11
    ,  32, 113,  80,  14
    ,  34, 107,  78,  16
    ,  36, 103,  74,  17
    ,  33,  95,  73,  18
    ,  32,  87,  68,  18
    ,  31,  78,  57,  15
    ,  24,  60,  45,  13
    ,  16,  40,  33,  10
    ,  10,  25,  19,   6
    ,   6,  15,  12,   4
    ,   4,  10,   8,   3
    ,   3,   6,   5,   2
    ,   2,   4,   3,   1
    ,   2,   3,   3,   1
    ,   1,   2,   2,   1
    ,   1,   2,   2,   1
    ,   1,   1,   1,   0
    ,   1,   1,   1,   0
    ,   1,   1,   1,   0
    ,   5,  47, 179,  13
    ,   6,  62, 160,  17
    ,   7,  70, 146,  20
    ,   8,  67, 138,  28
    ,  10,  67, 128,  33
    ,  12,  70, 118,  35
    ,  13,  67, 112,  38
    ,  15,  67, 105,  36
    ,  16,  66,  97,  35
    ,  15,  58,  90,  36
    ,  13,  50,  78,  32
    ,  11,  40,  61,  26
    ,   8,  28,  42,  18
    ,   5,  18,  26,  12
    ,   3,  11,  15,   7
    ,   2,   7,   9,   4
    ,   2,   4,   6,   3
    ,   1,   3,   4,   2
    ,   1,   2,   3,   2
    ,   1,   2,   2,   1
    ,   0,   1,   2,   1
    ,   0,   1,   1,   1
    ,   0,   1,   1,   1
    ,   0,   1,   1,   1
    ,   1,  10, 161,  69
    ,   2,  15, 151,  72
    ,   2,  20, 143,  72
    ,   3,  23, 128,  81
    ,   3,  27, 118,  83
    ,   5,  30, 112,  78
    ,   6,  33, 108,  74
    ,   7,  36, 102,  68
    ,   7,  34,  95,  68
    ,   7,  31,  86,  63
    ,   6,  27,  73,  56
    ,   6,  22,  58,  44
    ,   4,  16,  40,  31
    ,   3,  10,  25,  20
    ,   2,   6,  15,  12
    ,   1,   4,  10,   7
    ,   1,   3,   6,   5
    ,   1,   2,   4,   4
    ,   0,   1,   3,   3
    ,   0,   1,   3,   2
    ,   0,   1,   2,   2
    ,   0,   1,   2,   1
    ,   0,   1,   1,   1
    ,   0,   0,   1,   1
    ,   1,   4,  40, 186
    ,   1,   5,  64, 154
    ,   1,   6,  68, 143
    ,   1,   9,  75, 130
    ,   1,  11,  77, 119
    ,   2,  14,  77, 110
    ,   3,  16,  77, 102
    ,   3,  17,  74,  94
    ,   3,  16,  68,  92
    ,   3,  16,  63,  84
    ,   3,  15,  54,  73
    ,   3,  11,  42,  58
    ,   2,   8,  30,  42
    ,   1,   5,  18,  27
    ,   1,   4,  11,  16
    ,   1,   2,   7,  10
    ,   0,   2,   5,   7
    ,   0,   1,   3,   4
    ,   0,   1,   2,   3
    ,   0,   1,   2,   3
    ,   0,   0,   1,   2
    ,   0,   0,   1,   2
    ,   0,   0,   1,   1
    ,   0,   0,   1,   1
    ,   0,   1,  10, 183
    ,   0,   2,  14, 158
    ,   0,   2,  20, 143
    ,   0,   2,  23, 128
    ,   0,   3,  29, 120
    ,   1,   4,  31, 111
    ,   1,   5,  33, 106
    ,   1,   6,  34,  99
    ,   1,   7,  34,  92
    ,   2,   7,  32,  84
    ,   2,   7,  29,  72
    ,   1,   5,  23,  57
    ,   1,   4,  16,  39
    ,   1,   3,  11,  26
    ,   1,   2,   7,  15
    ,   0,   1,   4,  10
    ,   0,   1,   3,   7
    ,   0,   1,   2,   5
    ,   0,   0,   2,   4
    ,   0,   0,   1,   3
    ,   0,   0,   1,   2
    ,   0,   0,   1,   2
    ,   0,   0,   1,   2
    ,   0,   0,   1,   2
    ,   0,   0,   4,  44
    ,   0,   1,   5,  63
    ,   0,   1,   6,  70
    ,   0,   1,   9,  78
    ,   0,   1,  11,  75
    ,   0,   2,  14,  75
    ,   0,   2,  15,  72
    ,   0,   3,  16,  70
    ,   1,   3,  16,  66
    ,   1,   3,  16,  61
    ,   1,   3,  15,  53
    ,   1,   3,  13,  42
    ,   1,   2,   9,  29
    ,   0,   2,   6,  18
    ,   0,   1,   4,  11
    ,   0,   1,   3,   7
    ,   0,   0,   2,   5
    ,   0,   0,   1,   4
    ,   0,   0,   1,   3
    ,   0,   0,   1,   2
    ,   0,   0,   1,   2
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   1,  13
    ,   0,   0,   2,  18
    ,   0,   0,   2,  24
    ,   0,   0,   2,  25
    ,   0,   0,   3,  28
    ,   0,   0,   4,  30
    ,   0,   1,   5,  32
    ,   0,   1,   6,  34
    ,   0,   1,   7,  33
    ,   0,   1,   7,  31
    ,   0,   2,   7,  28
    ,   0,   1,   6,  22
    ,   0,   1,   4,  16
    ,   0,   1,   3,  10
    ,   0,   0,   2,   7
    ,   0,   0,   1,   4
    ,   0,   0,   1,   3
    ,   0,   0,   1,   2
    ,   0,   0,   0,   2
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   3
    ,   0,   0,   0,   4
    ,   0,   0,   1,   5
    ,   0,   0,   1,   7
    ,   0,   0,   1,   9
    ,   0,   0,   1,  12
    ,   0,   0,   2,  13
    ,   0,   0,   3,  14
    ,   0,   0,   3,  15
    ,   0,   1,   3,  16
    ,   0,   1,   3,  14
    ,   0,   1,   3,  12
    ,   0,   1,   2,   8
    ,   0,   0,   2,   6
    ,   0,   0,   1,   4
    ,   0,   0,   1,   2
    ,   0,   0,   0,   2
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   1
    ,   0,   0,   0,   2
    ,   0,   0,   0,   2
    ,   0,   0,   0,   2
    ,   0,   0,   0,   3
    ,   0,   0,   0,   4
    ,   0,   0,   1,   5
    ,   0,   0,   1,   6
    ,   0,   0,   1,   7
    ,   0,   0,   2,   7
    ,   0,   0,   2,   6
    ,   0,   0,   1,   6
    ,   0,   0,   1,   4
    ,   0,   0,   1,   3
    ,   0,   0,   1,   2
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   2
    ,   0,   0,   0,   2
    ,   0,   0,   0,   3
    ,   0,   0,   1,   3
    ,   0,   0,   1,   3
    ,   0,   0,   1,   3
    ,   0,   0,   0,   2
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   2
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   1
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   1
    ,   0,   0,   0,   2
    ,   0,   0,   0,   2
    ,   0,   0,   1,   2
    ,   0,   0,   1,   2
    ,   0,   1,   1,   2
    ,   0,   1,   1,   2
    ,   1,   1,   1,   2
    ,   1,   1,   1,   1
    ,   1,   1,   1,   1
    ,   1,   0,   1,   1
    ,   0,   0,   0,   0
    ,   0,   0,   0,   1
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,   0,   0,   0,   0
    ,
};
#endif

