//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all 
// or part of MStar Software is expressly prohibited, unless prior written 
// permission has been granted by MStar. 
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.  
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software. 
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s 
//    confidential information in strictest confidence and not disclose to any
//    third party.  
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.  
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or 
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.  
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2010 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
/// file    Mdrv_ld_Gamma.c
/// @brief  local dimming gamma table
/// @author MStar Semiconductor Inc.
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "mdrv_ld_gamma.h"

#if  (LD_ENABLE==1)
const MS_U8 gamma_linear[64]=
{

  0    ,
  4    ,
  8    ,
  12   ,
  16   ,
  20   ,
  24   ,
  28   ,
  32   ,
  36   ,
  40   ,
  44   ,
  48   ,
  52   ,
  56   ,
  60   ,
  64   ,
  68   ,
  72   ,
  76   ,
  80   ,
  85   ,
  89   ,
  93   ,
  97   ,
  101  ,
  105  ,
  109  ,
  113  ,
  117  ,
  121  ,
  125  ,
  129  ,
  133  ,
  137  ,
  141  ,
  145  ,
  149  ,
  153  ,
  157  ,
  161  ,
  165  ,
  170  ,
  174  ,
  178  ,
  182  ,
  186  ,
  190  ,
  194  ,
  198  ,
  202  ,
  206  ,
  210  ,
  214  ,
  218  ,
  222  ,
  226  ,
  230  ,
  234  ,
  238  ,
  242  ,
  246  ,
  250  ,
  255
};


const MS_U8 gamma_0dot6[64]=
{
  0      ,
  21     ,
  32     ,
  41     ,
  48     ,
  55     ,
  62     ,
  68     ,
  73     ,
  79     ,
  84     ,
  89     ,
  94     ,
  98     ,
  103     ,
  107     ,
  112     ,
  116     ,
  120     ,
  124     ,
  128     ,
  131     ,
  135     ,
  139     ,
  142     ,
  146     ,
  149     ,
  153     ,
  156     ,
  160     ,
  163     ,
  166     ,
  169     ,
  172     ,
  176     ,
  179     ,
  182     ,
  185     ,
  188     ,
  191     ,
  194     ,
  197     ,
  199     ,
  202     ,
  205     ,
  208     ,
  211     ,
  213     ,
  216     ,
  219     ,
  221     ,
  224     ,
  227     ,
  229     ,
  232     ,
  235     ,
  237     ,
  240     ,
  242     ,
  245     ,
  247     ,
  250     ,
  252     ,
  255
};

const MS_U8 gamma_0dot4[64]=
{
   0      ,
   48       ,
   64       ,
   75       ,
   84       ,
   92       ,
   99       ,
   105     ,
   111     ,
   117     ,
   122     ,
   126     ,
   131     ,
   135     ,
   139     ,
   143     ,
   147     ,
   151     ,
   154     ,
   157     ,
   161     ,
   164     ,
   167     ,
   170     ,
   173     ,
   176     ,
   178     ,
   181     ,
   184     ,
   186     ,
   189     ,
   192     ,
   194     ,
   196     ,
   199     ,
   201     ,
   203     ,
   206     ,
   208     ,
   210     ,
   212     ,
   214     ,
   216     ,
   218     ,
   220     ,
   222     ,
   224     ,
   226     ,
   228     ,
   230     ,
   232     ,
   234     ,
   236     ,
   237     ,
   239     ,
   241     ,
   243     ,
   244     ,
   246     ,
   248     ,
   250     ,
   251     ,
   253     ,
   255
};


const MS_U8 gamma_1dot2[64]=
{
    0        ,
    1        ,
    4        ,
    6        ,
    9        ,
    12        ,
    15        ,
    18        ,
    21        ,
    24        ,
    28        ,
    31        ,
    34        ,
    38        ,
    41        ,
    45        ,
    49        ,
    52        ,
    56        ,
    60        ,
    64        ,
    68        ,
    72        ,
    76        ,
    80        ,
    84        ,
    88        ,
    92        ,
    96        ,
    100     ,
    104     ,
    108     ,
    113     ,
    117     ,
    121     ,
    125     ,
    130     ,
    134     ,
    139     ,
    143     ,
    147     ,
    152     ,
    156     ,
    161     ,
    165     ,
    170     ,
    174     ,
    179     ,
    184     ,
    188     ,
    193     ,
    197     ,
    202     ,
    207     ,
    211     ,
    216     ,
    221     ,
    226     ,
    230     ,
    235     ,
    240     ,
    245     ,
    250     ,
    255
};


const MS_U8 gamma_1dot4[64]=
{
  0       ,
  0       ,
  2       ,
  3       ,
  5       ,
  7       ,
  9       ,
  11      ,
  14      ,
  16      ,
  19      ,
  22      ,
  25      ,
  27      ,
  31      ,
  34      ,
  37      ,
  40      ,
  44      ,
  47      ,
  51      ,
  54      ,
  58      ,
  62      ,
  66      ,
  69      ,
  73      ,
  77      ,
  81      ,
  86      ,
  90      ,
  94      ,
  98      ,
  103      ,
  107      ,
  111      ,
  116      ,
  121      ,
  125      ,
  130      ,
  135      ,
  139      ,
  144      ,
  149      ,
  154      ,
  159      ,
  164      ,
  169      ,
  174      ,
  179      ,
  184      ,
  189      ,
  194      ,
  200      ,
  205      ,
  210      ,
  216      ,
  221      ,
  227      ,
  232      ,
  238      ,
  243      ,
  249      ,
  255
};


const MS_U8 gamma_0dot9[64] =
{
    0      ,
    6      ,
    11     ,
    16     ,
    21     ,
    26     ,
    30     ,
    35     ,
    39     ,
    44     ,
    48     ,
    53     ,
    57     ,
    61     ,
    65     ,
    70     ,
    74     ,
    78     ,
    82     ,
    86     ,
    90     ,
    94     ,
    98     ,
    102    ,
    106    ,
    110    ,
    114    ,
    118    ,
    122    ,
    126    ,
    130    ,
    134    ,
    138    ,
    142    ,
    146    ,
    150    ,
    154    ,
    157    ,
    161    ,
    165    ,
    169    ,
    173    ,
    177    ,
    180    ,
    184    ,
    188    ,
    192    ,
    195    ,
    199    ,
    203    ,
    207    ,
    210    ,
    214    ,
    218    ,
    221    ,
    225    ,
    229    ,
    233    ,
    236    ,
    240    ,
    244    ,
    247    ,
    251    ,
    255
} ;


const MS_U8 gamma_0dot8[64] =
{
    0    ,
    9    ,
    16   ,
    22   ,
    28   ,
    33   ,
    38   ,
    43   ,
    48   ,
    53   ,
    58   ,
    63   ,
    67   ,
    72   ,
    76   ,
    80   ,
    85   ,
    89   ,
    93   ,
    97   ,
    101  ,
    105  ,
    109  ,
    113  ,
    117  ,
    121  ,
    125  ,
    129  ,
    133  ,
    137  ,
    140  ,
    144  ,
    148  ,
    152  ,
    155  ,
    159  ,
    162  ,
    166  ,
    170  ,
    173  ,
    177  ,
    180  ,
    184  ,
    187  ,
    191  ,
    194  ,
    198  ,
    201  ,
    205  ,
    208  ,
    211  ,
    215  ,
    218  ,
    222  ,
    225  ,
    228  ,
    232  ,
    235  ,
    238  ,
    241  ,
    245  ,
    248  ,
    251  ,
    255
} ;


const MS_U8 gamma_0dot75[64]=
{
    0       ,
    11       ,
    19       ,
    25       ,
    32       ,
    38       ,
    43       ,
    49       ,
    54       ,
    59       ,
    64       ,
    68       ,
    73       ,
    78       ,
    82       ,
    86       ,
    91       ,
    95       ,
    99       ,
    103    ,
    107    ,
    111    ,
    115    ,
    119    ,
    123    ,
    127    ,
    131    ,
    135    ,
    138    ,
    142    ,
    146    ,
    149    ,
    153    ,
    157    ,
    160    ,
    164    ,
    167    ,
    171    ,
    174    ,
    177    ,
    181    ,
    184    ,
    188    ,
    191    ,
    194    ,
    198    ,
    201    ,
    204    ,
    207    ,
    211    ,
    214    ,
    217    ,
    220    ,
    223    ,
    227    ,
    230    ,
    233    ,
    236    ,
    239    ,
    242    ,
    245    ,
    248    ,
    251    ,
    255


};

const MS_U8 LGE_sample3[64]=
{
    0     ,
    6     ,
    14    ,
    21    ,
    29    ,
    40    ,
    52    ,
    68    ,
    80    ,
    97    ,
    117   ,
    129   ,
    145   ,
    153   ,
    165   ,
    174   ,
    182   ,
    190   ,
    198   ,
    204   ,
    209   ,
    216   ,
    221   ,
    226   ,
    230   ,
    234   ,
    238   ,
    242   ,
    246   ,
    248   ,
    250   ,
    251   ,
    253   ,
    254   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255
};


const MS_U8 LGE_sampleTHX[64]=
{
    0,
    2,
    4,
    6,
    9,
    20,
    24,
    28,
    32,
    36,
    40,
    44,
    48,
    52,
    56,
    60,
    64,
    68,
    72,
    76,
    80,
    85,
    89,
    93,
    97,
    101,
    105,
    109,
    113,
    117,
    121,
    125,
    129,
    133,
    137,
    141,
    145,
    149,
    153,
    157,
    161,
    165,
    170,
    174,
    178,
    182,
    186,
    190,
    194,
    198,
    202,
    206,
    210,
    214,
    218,
    222,
    255,
    255,
    255,
    255,
    255,
    255,
    255,
    255
};


const MS_U8 gamma_0dot78[64]=
{
    0       ,
    10       ,
    17       ,
    23       ,
    29       ,
    35       ,
    40       ,
    45       ,
    50       ,
    55       ,
    60       ,
    65       ,
    69       ,
    74       ,
    78       ,
    83       ,
    87       ,
    91       ,
    95       ,
    100    ,
    104    ,
    108    ,
    112    ,
    116    ,
    120    ,
    124    ,
    127    ,
    131    ,
    135    ,
    139    ,
    142    ,
    146    ,
    150    ,
    153    ,
    157    ,
    161    ,
    164    ,
    168    ,
    171    ,
    175    ,
    178    ,
    182    ,
    185    ,
    189    ,
    192    ,
    196    ,
    199    ,
    202    ,
    206    ,
    209    ,
    212    ,
    216    ,
    219    ,
    222    ,
    226    ,
    229    ,
    232    ,
    235    ,
    239    ,
    242    ,
    245    ,
    248    ,
    251    ,
    255

};

const MS_U8 gamma_0dot7[64]=
{
    0      ,
    14     ,
    22     ,
    30     ,
    37     ,
    43     ,
    49     ,
    54     ,
    60     ,
    65     ,
    70     ,
    75     ,
    79     ,
    84     ,
    88     ,
    93     ,
    97     ,
    101    ,
    106    ,
    110    ,
    114    ,
    118    ,
    122    ,
    125    ,
    129    ,
    133    ,
    137    ,
    140    ,
    144    ,
    148    ,
    151    ,
    155    ,
    158    ,
    162    ,
    165    ,
    168    ,
    172    ,
    175    ,
    178    ,
    182    ,
    185    ,
    188    ,
    191    ,
    195    ,
    198    ,
    201    ,
    204    ,
    207    ,
    210    ,
    213    ,
    216    ,
    219    ,
    222    ,
    225    ,
    228    ,
    231    ,
    234    ,
    237    ,
    240    ,
    243    ,
    246    ,
    249    ,
    252    ,
    255
};


const MS_U8 gamma_dark_higher[64]=
{
  0    ,
  18    ,
  21    ,
  22   ,
  23   ,
  24   ,
  26   ,
  28   ,
  32   ,
  36   ,
  40   ,
  44   ,
  48   ,
  52   ,
  56   ,
  60   ,
  64   ,
  68   ,
  72   ,
  76   ,
  80   ,
  85   ,
  89   ,
  93   ,
  97   ,
  101  ,
  105  ,
  109  ,
  113  ,
  117  ,
  121  ,
  125  ,
  129  ,
  133  ,
  137  ,
  141  ,
  145  ,
  149  ,
  153  ,
  157  ,
  161  ,
  165  ,
  170  ,
  174  ,
  178  ,
  182  ,
  186  ,
  190  ,
  194  ,
  198  ,
  202  ,
  206  ,
  210  ,
  214  ,
  218  ,
  222  ,
  226  ,
  230  ,
  234  ,
  238  ,
  242  ,
  246  ,
  250  ,
  255
};


const MS_U8 LGE_sample1_adjust[64*9]=
{
    0    ,0     ,0     ,0        ,0        ,0        ,0     ,0     ,0       ,
    36    ,14  ,8     ,6        ,5        ,5        ,3     ,0     ,0       ,
    48    ,21  ,14    ,11     ,10     ,9        ,6     ,1     ,0       ,
    57    ,27  ,18    ,15     ,13     ,12     ,8     ,2     ,1       ,
    69    ,35  ,25    ,21     ,19     ,18     ,13  ,5     ,2       ,
    77    ,42  ,31    ,27     ,24     ,23     ,17  ,7     ,3       ,
    87    ,51  ,39    ,34     ,31     ,29     ,22  ,10    ,6       ,
    96    ,59  ,46    ,40     ,38     ,36     ,28  ,13    ,8       ,
    103 ,66  ,52    ,47     ,44     ,42     ,33  ,17    ,10    ,
    110 ,72  ,59    ,53     ,50     ,48     ,39  ,20    ,13    ,
    117 ,79  ,65    ,59     ,55     ,53     ,44  ,24    ,16    ,
    122 ,85  ,71    ,64     ,61     ,59     ,49  ,28    ,19    ,
    128 ,91  ,76    ,70     ,66     ,64     ,54  ,32    ,23    ,
    133 ,96  ,82    ,75     ,72     ,69     ,59  ,36    ,26    ,
    138 ,101 ,87    ,81     ,77     ,75     ,64  ,40    ,30    ,
    142 ,107 ,92    ,86     ,82     ,80     ,69  ,44    ,33    ,
    147 ,112 ,97    ,91     ,87     ,85     ,74  ,49    ,37    ,
    151 ,116 ,102    ,96     ,92     ,90     ,79  ,53    ,41    ,
    155 ,121 ,107    ,101    ,97     ,94     ,83  ,57    ,45    ,
    159 ,126 ,112    ,105    ,102    ,99     ,88  ,62    ,49    ,
    163 ,130 ,116    ,110    ,106    ,104    ,93  ,66    ,53    ,
    166 ,135 ,121    ,115    ,111    ,109    ,98  ,71    ,57    ,
    170 ,139 ,125    ,119    ,116    ,113    ,102 ,76    ,62    ,
    173 ,143 ,130    ,124    ,120    ,118    ,107 ,80    ,66    ,
    177 ,147 ,134    ,128    ,125    ,123    ,112 ,85    ,71    ,
    180 ,151 ,139    ,133    ,129    ,127    ,116 ,90    ,75    ,
    183 ,155 ,143    ,137    ,134    ,132    ,121 ,94    ,80    ,
    186 ,159 ,147    ,141    ,138    ,136    ,126 ,99    ,85    ,
    189 ,163 ,151    ,146    ,142    ,140    ,130 ,104    ,90    ,
    192 ,167 ,155    ,150    ,147    ,145    ,135 ,109    ,95    ,
    195 ,170 ,159    ,154    ,151    ,149    ,139 ,114    ,100   ,
    198 ,174 ,163    ,158    ,155    ,153    ,144 ,119    ,105   ,
    200 ,178 ,167    ,162    ,160    ,158    ,148 ,124    ,110   ,
    203 ,181 ,171    ,167    ,164    ,162    ,153 ,129    ,115   ,
    206 ,185 ,175    ,171    ,168    ,166    ,157 ,134    ,121   ,
    208 ,188 ,179    ,175    ,172    ,170    ,162 ,139    ,126   ,
    211 ,192 ,183    ,179    ,176    ,174    ,166 ,144    ,131   ,
    213 ,195 ,187    ,183    ,180    ,179    ,171 ,150    ,137   ,
    216 ,198 ,190    ,187    ,184    ,183    ,175 ,155    ,142   ,
    218 ,202 ,194    ,190    ,188    ,187    ,180 ,160    ,148   ,
    220 ,205 ,198    ,194    ,192    ,191    ,184 ,165    ,154   ,
    223 ,208 ,202    ,198    ,196    ,195    ,189 ,171    ,160   ,
    225 ,212 ,205    ,202    ,200    ,199    ,193 ,176    ,165   ,
    227 ,215 ,209    ,206    ,204    ,203    ,197 ,181    ,171   ,
    229 ,218 ,212    ,210    ,208    ,207    ,202 ,187    ,177   ,
    232 ,221 ,216    ,213    ,212    ,211    ,206 ,192    ,183   ,
    234 ,224 ,219    ,217    ,216    ,215    ,210 ,197    ,189   ,
    236 ,227 ,223    ,221    ,220    ,219    ,215 ,203    ,195   ,
    238 ,230 ,226    ,225    ,223    ,223    ,219 ,208    ,201   ,
    240 ,233 ,230    ,228    ,227    ,227    ,223 ,214    ,208   ,
    242 ,236 ,233    ,232    ,231    ,230    ,228 ,219    ,214   ,
    244 ,239 ,237    ,236    ,235    ,234    ,232 ,225    ,220   ,
    246 ,242 ,240    ,239    ,239    ,238    ,236 ,230    ,227   ,
    248 ,245 ,244    ,243    ,242    ,242    ,240 ,236    ,233   ,
    250 ,248 ,247    ,246    ,246    ,246    ,245 ,242    ,240   ,
    252 ,251 ,250    ,250    ,250    ,250    ,249 ,247    ,246   ,
    255 ,255 ,255    ,255    ,255    ,255    ,255 ,255    ,255   ,
    255 ,255 ,255    ,255    ,255    ,255    ,255 ,255    ,255   ,
    255 ,255 ,255    ,255    ,255    ,255    ,255 ,255    ,255   ,
    255 ,255 ,255    ,255    ,255    ,255    ,255 ,255    ,255   ,
    255 ,255 ,255    ,255    ,255    ,255    ,255 ,255    ,255   ,
    255 ,255 ,255    ,255    ,255    ,255    ,255 ,255    ,255   ,
    255 ,255 ,255    ,255    ,255    ,255    ,255 ,255    ,255   ,
    255 ,255 ,255    ,255    ,255    ,255    ,255 ,255    ,255
};


const MS_U8 LGE_sample2_adjust[64*9]=
{
    0    ,0        ,0       ,0       ,0        ,0       , 0       ,0       ,0    ,
    33    ,12        ,7       ,5       ,4        ,4       , 2       ,0       ,0    ,
    44    ,18        ,11       ,9       ,8        ,7       , 5       ,1       ,0    ,
    52    ,23        ,15       ,13       ,11        ,10       , 7       ,2       ,0    ,
    57    ,27        ,18       ,15       ,13        ,12       , 8       ,2       ,1    ,
    64    ,32        ,22       ,19       ,17        ,16       , 11       ,4       ,2    ,
    75    ,41        ,30       ,25       ,23        ,22       , 16       ,6       ,3    ,
    84    ,48        ,37       ,32       ,29        ,28       , 21       ,9       ,5    ,
    92    ,55        ,43       ,38       ,35        ,33       , 26       ,12       ,7    ,
    102    ,64        ,51       ,45       ,42        ,40       , 32       ,16       ,10   ,
    110    ,72        ,59       ,53       ,49        ,47       , 38       ,20       ,13   ,
    118    ,80        ,66       ,60       ,56        ,54       , 45       ,25       ,17   ,
    125    ,87        ,73       ,66       ,63        ,61       , 51       ,30       ,21   ,
    131    ,94        ,79       ,73       ,69        ,67       , 57       ,34       ,25   ,
    137    ,100    ,86       ,79       ,76        ,73       , 63       ,39       ,29   ,
    142    ,106    ,92       ,86       ,82        ,80       , 69       ,44       ,33   ,
    148    ,112    ,98       ,92       ,88        ,86       , 75       ,49       ,38   ,
    153    ,118    ,104    ,97       ,94        ,91       , 80       ,55       ,42   ,
    157    ,124    ,110    ,103    ,100    ,97       , 86       ,60       ,47   ,
    162    ,129    ,115    ,109    ,105    ,103    ,92       ,65       ,52   ,
    166    ,134    ,121    ,115    ,111    ,109    ,98       ,71       ,57   ,
    171    ,140    ,126    ,120    ,116    ,114    ,103    ,76       ,62   ,
    175    ,145    ,132    ,125    ,122    ,120    ,109    ,82       ,68   ,
    178    ,149    ,137    ,131    ,127    ,125    ,114    ,88       ,73   ,
    182    ,154    ,142    ,136    ,133    ,130    ,120    ,93       ,79   ,
    186    ,159    ,147    ,141    ,138    ,136    ,126    ,99       ,85   ,
    190    ,164    ,152    ,146    ,143    ,141    ,131    ,105    ,91  ,
    193    ,168    ,157    ,151    ,148    ,146    ,137    ,111    ,97  ,
    196    ,172    ,162    ,157    ,153    ,152    ,142    ,117    ,103 ,
    200    ,177    ,166    ,161    ,159    ,157    ,147    ,123    ,109 ,
    203    ,181    ,171    ,166    ,164    ,162    ,153    ,129    ,115 ,
    206    ,185    ,176    ,171    ,169    ,167    ,158    ,135    ,121 ,
    209    ,190    ,180    ,176    ,174    ,172    ,164    ,141    ,128 ,
    212    ,194    ,185    ,181    ,178    ,177    ,169    ,147    ,135 ,
    215    ,198    ,190    ,186    ,183    ,182    ,174    ,154    ,141 ,
    218    ,202    ,194    ,190    ,188    ,187    ,180    ,160    ,148 ,
    221    ,206    ,198    ,195    ,193    ,192    ,185    ,166    ,155 ,
    224    ,210    ,203    ,200    ,198    ,196    ,190    ,173    ,162 ,
    226    ,213    ,207    ,204    ,202    ,201    ,195    ,179    ,169 ,
    229    ,217    ,212    ,209    ,207    ,206    ,201    ,185    ,176 ,
    232    ,221    ,216    ,213    ,212    ,211    ,206    ,192    ,183 ,
    234    ,225    ,220    ,218        ,216    ,216    ,211    ,198    ,190 ,
    237    ,228    ,224    ,222        ,221    ,220    ,216    ,205    ,198 ,
    239    ,232    ,228    ,227        ,226    ,225    ,221    ,211    ,205 ,
    242    ,236    ,233    ,231        ,230    ,230    ,227    ,218    ,212 ,
    244    ,239    ,237    ,235        ,235    ,234    ,232    ,225    ,220 ,
    247    ,243    ,241    ,240        ,239    ,239    ,237    ,231    ,228 ,
    249    ,246    ,245    ,244        ,244    ,243    ,242    ,238    ,235 ,
    251    ,250    ,249    ,248        ,248    ,248    ,247    ,245    ,243 ,
    254    ,253    ,253    ,253        ,253    ,253    ,252    ,252    ,251 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255        ,255    ,255    ,255    ,255    ,255
};


const MS_U8 LGE_sample7_adjust[64*9]=
{
    0    ,0        ,0        ,0        ,0        ,0        ,0        ,0        ,0   ,
    19    ,5        ,2        ,2        ,1        ,1        ,0        ,0        ,0   ,
    30    ,10        ,6        ,4        ,3        ,3        ,2        ,0        ,0   ,
    39    ,15        ,9        ,7        ,6        ,6        ,3        ,0        ,0   ,
    48    ,21        ,14        ,11        ,10        ,9        ,6        ,1        ,0   ,
    57    ,27        ,18        ,15        ,13        ,12        ,8        ,2        ,1   ,
    64    ,32        ,22        ,19        ,17        ,16        ,11        ,4        ,2   ,
    71    ,37        ,27        ,23        ,21        ,19        ,14        ,5        ,2   ,
    77    ,42        ,31        ,27        ,24        ,23        ,17        ,7        ,3   ,
    84    ,48        ,37        ,32        ,29        ,28        ,21        ,9        ,5   ,
    90    ,53        ,41        ,36        ,33        ,31        ,24        ,11        ,6   ,
    95    ,58        ,45        ,40        ,37        ,35        ,27        ,13        ,8   ,
    102    ,65        ,52        ,46        ,43        ,41        ,33        ,16        ,10  ,
    108    ,71        ,57        ,51        ,48        ,46        ,37        ,19        ,12  ,
    116    ,78        ,64        ,58        ,54        ,52        ,43        ,24        ,16  ,
    122    ,84        ,70        ,64        ,60        ,58        ,48        ,28        ,19  ,
    128    ,90        ,76        ,70        ,66        ,64        ,54        ,32        ,22  ,
    133    ,97        ,82        ,76        ,72        ,70        ,59        ,36        ,26  ,
    139    ,102    ,88        ,81        ,78        ,76        ,65        ,41        ,30  ,
    144    ,108    ,94        ,87        ,83        ,81        ,70        ,46        ,34  ,
    149    ,113    ,99        ,93        ,89        ,87        ,76        ,50        ,38  ,
    153    ,119    ,105    ,98        ,94        ,92        ,81        ,55        ,43  ,
    158    ,124    ,110    ,103    ,100    ,97        ,86        ,60        ,47  ,
    162    ,129    ,115    ,109    ,105    ,103    ,92        ,65        ,52  ,
    166    ,134    ,120    ,114    ,110    ,108    ,97        ,70        ,57  ,
    170    ,139    ,125    ,119    ,115    ,113    ,102    ,75        ,61  ,
    173    ,143    ,130    ,124    ,120    ,118    ,107    ,80        ,66  ,
    177    ,148    ,135    ,129    ,125    ,123    ,113    ,86        ,71  ,
    181    ,152    ,140    ,134    ,130    ,128    ,118    ,91        ,77  ,
    184    ,157    ,144    ,139    ,135    ,133    ,123    ,96        ,82  ,
    187    ,161    ,149    ,143    ,140    ,138    ,128    ,102    ,87  ,
    191    ,165    ,154    ,148    ,145    ,143    ,133    ,107    ,93  ,
    194    ,169    ,158    ,153    ,150    ,148    ,138    ,113    ,98  ,
    197    ,173    ,163    ,157    ,154    ,153    ,143    ,118    ,104 ,
    200    ,177    ,167    ,162    ,159    ,157    ,148    ,124    ,110 ,
    203    ,181    ,171    ,167    ,164    ,162    ,153    ,129    ,115 ,
    206    ,185    ,176    ,171    ,168    ,167    ,158    ,135    ,121 ,
    209    ,189    ,180    ,176    ,173    ,171    ,163    ,140    ,127 ,
    212    ,193    ,184    ,180    ,177    ,176    ,168    ,146    ,133 ,
    214    ,197    ,188    ,184    ,182    ,180    ,173    ,152    ,139 ,
    217    ,200    ,193    ,189    ,186    ,185    ,178    ,158    ,146 ,
    220    ,204    ,197    ,193    ,191    ,189    ,183    ,163    ,152 ,
    222    ,208    ,201    ,197    ,195    ,194    ,188    ,169    ,158 ,
    225    ,211    ,205    ,202    ,200    ,198    ,192    ,175    ,165 ,
    227    ,215    ,209    ,206    ,204    ,203    ,197    ,181    ,171 ,
    230    ,218    ,213    ,210    ,208    ,207    ,202    ,187    ,178 ,
    232    ,222    ,217    ,214    ,213    ,212    ,207    ,193    ,184 ,
    235    ,225    ,221    ,218    ,217    ,216    ,212    ,199    ,191 ,
    237    ,228    ,224    ,222    ,221    ,220    ,216    ,205    ,198 ,
    239    ,232    ,228    ,227    ,225    ,225    ,221    ,211    ,205 ,
    241    ,235    ,232    ,231    ,230    ,229    ,226    ,217    ,212 ,
    244    ,238    ,236    ,235    ,234    ,233    ,231    ,223    ,219 ,
    246    ,242    ,240    ,239    ,238    ,238    ,236    ,230    ,226 ,
    248    ,245    ,243    ,243    ,242    ,242    ,240    ,236    ,233 ,
    250    ,248    ,247    ,247    ,246    ,246    ,245    ,242    ,240 ,
    252    ,251    ,251    ,251    ,250    ,250    ,250    ,248    ,247 ,
    255    ,255    ,255    ,255    ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255    ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255    ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255    ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255    ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255    ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255    ,255    ,255    ,255    ,255    ,255 ,
    255    ,255    ,255    ,255    ,255    ,255    ,255    ,255    ,255
};


const MS_U8 LGE_sample1_0dot81[64]=
{
    0      ,
    5      ,
    8      ,
    12      ,
    18      ,
    22      ,
    29      ,
    35      ,
    41      ,
    47      ,
    52      ,
    58      ,
    63      ,
    68      ,
    73      ,
    79      ,
    84      ,
    88      ,
    93      ,
    98      ,
    103   ,
    108   ,
    112   ,
    117   ,
    121   ,
    126   ,
    130   ,
    135   ,
    139   ,
    144   ,
    148   ,
    152   ,
    157   ,
    161   ,
    165   ,
    169   ,
    174   ,
    178   ,
    182   ,
    186   ,
    190   ,
    194   ,
    198   ,
    202   ,
    206   ,
    210   ,
    214   ,
    218   ,
    222   ,
    226   ,
    230   ,
    234   ,
    238   ,
    242   ,
    246   ,
    250   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255   ,
    255
};
#endif
