//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////
//==============================================================================
// [Mdrv_mux.c]
// Date: 20090225
// Descriptions: Add a new mux layer for HW setting
//==============================================================================

#define  MDRV_MUX_C

#ifndef UNUSED
#define UNUSED(x) (void)(x)
#endif

#include "MsCommon.h"
#include "drvXC_IOPort.h"
#include "apiXC.h"
#include "apiXC_Adc.h"
#include "apiXC_Auto.h"
#include "apiXC_PCMonitor.h"
#include "drvXC_ADC_Internal.h"
#include "mhal_mux.h"
#include "drv_sc_display.h"
#include "drv_sc_ip.h"
#include "apiXC_PCMonitor.h"
#include "drv_sc_ip.h"

void MDrv_XC_mux_set_sync_port_by_dataport(void *pInstance, E_MUX_INPUTPORT src_port )
{
    Hal_SC_set_sync_port_by_dataport(pInstance, src_port);
}

void MDrv_XC_mux_dispatch(void *pInstance, E_MUX_INPUTPORT src , E_MUX_OUTPUTPORT dest)
{
    Hal_SC_mux_dispatch(pInstance, src, dest);
}

void MDrv_XC_mux_turnoff_ymux(void *pInstance)
{
    Hal_SC_mux_set_adc_y_mux(pInstance, 0x0F);
}

void MDrv_XC_mux_turnoff_cmux(void *pInstance)
{
    Hal_SC_mux_set_adc_c_mux(pInstance, 0x0F);
}

void MDrv_SC_EnableCLK_for_DIP(void *pInstance, MS_BOOL bEnable)
{
    Hal_SC_EnableCLK_for_DIP(pInstance, bEnable);
}

E_MUX_INPUTPORT MDrv_XC_Mux_GetHDMIPort(void *pInstance, INPUT_SOURCE_TYPE_t src )
{
    // Get Inputport
    E_MUX_INPUTPORT enPorts[4] = {INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT};
    MS_U8 u8Port_count = 0;
    XC_LOG_TRACE(XC_DBGLEVEL_FUNCTION_TRACE, "Entry\n");

    if ( !IsSrcTypeHDMI(src) )
    {
        XC_LOG_TRACE(XC_DBGLEVEL_FUNCTION_TRACE, "Exit\n");
        return INPUT_PORT_NONE_PORT;
    }

    // Need refine.
    MDrv_XC_Mux_GetPort(pInstance, src , enPorts , &u8Port_count );
    XC_LOG_TRACE(XC_DBGLEVEL_FUNCTION_TRACE, "Exit\n");
    return (enPorts[0]);
}

MS_U8 MDrv_XC_MUX_MapInputSourceToVDYMuxPORT(void *pInstance, INPUT_SOURCE_TYPE_t u8InputSourceType )
{
    MS_U8 u8Checksrc = INPUT_PORT_NONE_PORT;
    E_MUX_INPUTPORT enPorts[3] ={INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT};
    MS_U8 u8Port_count = 0;
    XC_LOG_TRACE(XC_DBGLEVEL_FUNCTION_TRACE, "Entry\n");

    MDrv_XC_Mux_GetPort(pInstance, u8InputSourceType, enPorts , &u8Port_count );
    if(IsSrcTypeAV(u8InputSourceType)
       || IsSrcTypeSV(u8InputSourceType)
       || IsSrcTypeYPbPr(u8InputSourceType)
       || IsSrcTypeHDMI(u8InputSourceType))
    {
        u8Checksrc = enPorts[0];
    }
    else if(IsSrcTypeVga(u8InputSourceType)
       || IsSrcTypeScart(u8InputSourceType))
    {
        u8Checksrc = enPorts[1];
    }
    else if(IsSrcTypeStorage(u8InputSourceType))
    {
        u8Checksrc = INPUT_PORT_MVOP;
    }
    else
    {
        //XC_LOG_TRACE(XC_DBGLEVEL_MUX, "no such kind of VD Y Mux Port for the input source type:%u\n",u8InputSourceType);
    }
    XC_LOG_TRACE(XC_DBGLEVEL_FUNCTION_TRACE, "Exit\n");

    return u8Checksrc;
}

void MDrv_XC_mux_SetScalerIndexInformationToADC(void *pInstance, MS_U8 u8ScalerIndex, MS_U16 u16InputSourceType)
{
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
    Hal_SC_mux_SetScalerIndexInformationToADC(pInstance,u8ScalerIndex,u16InputSourceType);
#else
    UNUSED(pInstance);
    UNUSED(u8ScalerIndex);
    UNUSED(u16InputSourceType);
#endif
}

MS_BOOL MDrv_XC_IsFSSEnabled(void *pInstance, SCALER_WIN eWindow)
{
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    return MHal_XC_IsFSSEnabled(pInstance, eWindow);
#else
    return FALSE;
#endif
}

void MDrv_XC_SetFSSSource(void *pInstance, E_MUX_INPUTPORT enSrcPort, MS_BOOL bHDMI420)
{
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    MHal_XC_SetFSSSource(pInstance, enSrcPort, bHDMI420);
#endif
}

void MDrv_XC_SetFSSEnable(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)

    MHal_XC_SetFSSEnable(pInstance, bEnable, eWindow);
    //REG_IPMUX_71_L will be setted "0", when system resume.But FSS is enable by MHal_XC_SetFSSEnable.
    //then the ipmux will be setted "ADCA",So need to set input port  "INPUT_PORT_MAX.
    MDrv_XC_SetFSSSource(pInstance,INPUT_PORT_MAX,FALSE);

    if(bEnable)
    {
       //start offline monitor when system init
       //dump mux val for every ip1
        MDrv_XC_SetIP1SignalSource(pInstance, INPUT_SOURCE_VGA, MAX_WINDOW);
        MDrv_XC_SetIP1SignalSource(pInstance, INPUT_SOURCE_YPBPR, MAX_WINDOW);
        MDrv_XC_SetIP1SignalSource(pInstance, INPUT_SOURCE_YPBPR_MAX, MAX_WINDOW);
        MDrv_XC_SetIP1SignalSource(pInstance, INPUT_SOURCE_HDMI, MAX_WINDOW);
        MDrv_XC_SetIP1SignalSource(pInstance, INPUT_SOURCE_HDMI2, MAX_WINDOW);
        MDrv_XC_SetIP1SignalSource(pInstance, INPUT_SOURCE_HDMI3, MAX_WINDOW);
        MDrv_XC_SetIP1SignalSource(pInstance, INPUT_SOURCE_HDMI4, MAX_WINDOW);

        // reset ip
        MDrv_XC_reset_ip(pInstance, MAIN_WINDOW, INPUT_SOURCE_VGA);
        MDrv_XC_reset_ip(pInstance, MAIN_WINDOW, INPUT_SOURCE_YPBPR);
        MDrv_XC_reset_ip(pInstance, MAIN_WINDOW, INPUT_SOURCE_YPBPR_MAX);
        MDrv_XC_reset_ip(pInstance, MAIN_WINDOW, INPUT_SOURCE_HDMI);
        MDrv_XC_reset_ip(pInstance, MAIN_WINDOW, INPUT_SOURCE_HDMI2);
        MDrv_XC_reset_ip(pInstance, MAIN_WINDOW, INPUT_SOURCE_HDMI3);
        MDrv_XC_reset_ip(pInstance, MAIN_WINDOW, INPUT_SOURCE_HDMI4);

        // restart ip
        MDrv_XC_PCMonitor_Restart(pInstance, MAX_WINDOW, INPUT_SOURCE_VGA);
        MDrv_XC_PCMonitor_Restart(pInstance, MAX_WINDOW, INPUT_SOURCE_YPBPR);
        MDrv_XC_PCMonitor_Restart(pInstance, MAX_WINDOW, INPUT_SOURCE_HDMI);
        MDrv_XC_PCMonitor_Restart(pInstance, MAX_WINDOW, INPUT_SOURCE_HDMI2);
        MDrv_XC_PCMonitor_Restart(pInstance, MAX_WINDOW, INPUT_SOURCE_HDMI3);
        MDrv_XC_PCMonitor_Restart(pInstance, MAX_WINDOW, INPUT_SOURCE_HDMI4);

        // enable offline for all of support source
        MDrv_XC_PCMonitor_Offline(pInstance, MAX_WINDOW, INPUT_SOURCE_NONE, ENABLE);
    }
#endif
}

#undef MDRV_MUX_C
