//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

/******************************************************************************/
/*                           Header Files                                     */
/******************************************************************************/
#ifndef MSOS_TYPE_NUTTX
// Common Definition
#include "MsCommon.h"
#include "mhal_xc_chip_config.h"
#include "utopia.h"
#include "drvXC_IOPort.h"
#include "apiXC.h"
#include "apiXC_Adc.h"
#include "apiXC_Auto.h"
#include "apiXC_ModeParse.h"
#include "drv_sc_display.h"
#include "drv_sc_isr.h"
#include "apiXC_PCMonitor.h"
#include "drvXC_HDMI_if.h"
#include "mvideo_context.h"
#include "drv_sc_ip.h"
#if (LD_ENABLE==1)
#include "mdrv_ld.h"
#include "mdrv_ldalgo.h"
#endif
#include "mdrv_sc_3d.h"
#include "drv_sc_menuload.h"
#include "drvXC_ADC_Internal.h"
#include "mhal_sc.h"
#if FRC_INSIDE
#include "mdrv_frc.h"
#include "mhal_frc.h"
#endif
#include "XC_private.h"
#include "apiXC_v2.h"
#include "mhal_offline.h"
#include "xc_hwreg_utility2.h"
#include "drv_sc_mux.h"
#include "mhal_mux.h"
#include "utopia_dapi.h"
#ifdef MSOS_TYPE_LINUX_KERNEL
#include <linux/string.h>
#else
#include <string.h>
#endif


//----------------------------
//
//----------------------------
#define    AIS_Debug(x)    //x
#define    INVALID_VALUE 0xFF
extern MS_BOOL gbOfflineDetectDbg;
extern MS_BOOL gbOfflineDetectEnable;
extern INPUT_SOURCE_TYPE_t genOfflineSource;

//------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
MS_U8 MDrv_XC_GetOffLineDetection(void *pInstance, INPUT_SOURCE_TYPE_t u8InputSourceType )
{
    MS_U8 u8CheckSrc = INPUT_PORT_NONE_PORT;
    MS_BOOL bRet = FALSE;
    u8CheckSrc = MDrv_XC_MUX_MapInputSourceToVDYMuxPORT(pInstance, u8InputSourceType);
    if(genOfflineSource != INPUT_SOURCE_NONE)
    {
        if(genOfflineSource == INPUT_SOURCE_VGA)
        {
            if((u8InputSourceType != genOfflineSource) && (u8InputSourceType != INPUT_SOURCE_CVBS_MAX))
            {
                return bRet;
            }
        }
        else if((genOfflineSource >= INPUT_SOURCE_CVBS) && (genOfflineSource < INPUT_SOURCE_CVBS_MAX))
        {
            if((u8InputSourceType != genOfflineSource) && (u8InputSourceType != INPUT_SOURCE_CVBS_MAX))
            {
                return bRet;
            }
        }
        else if((genOfflineSource >= INPUT_SOURCE_YPBPR) && (genOfflineSource < INPUT_SOURCE_YPBPR_MAX))
        {
            if((u8InputSourceType != genOfflineSource) && (u8InputSourceType != INPUT_SOURCE_YPBPR_MAX))
            {
                return bRet;
            }
        }
        else if((genOfflineSource >= INPUT_SOURCE_HDMI) && (genOfflineSource < INPUT_SOURCE_HDMI_MAX))
        {
            if((u8InputSourceType != genOfflineSource) && (u8InputSourceType != INPUT_SOURCE_YPBPR_MAX))
            {
                return bRet;
            }
        }
        else
        {
            return bRet;
        }
    }

    if(MHal_XC_IsSupportAdcOfflineByIp(pInstance) && !Hal_XC_IsDirectGetOffline(pInstance))
    {
        MS_U8 u8TimingInputStatus = FALSE;
        XC_PCMONITOR_HK_INFO stPCMonitorInfo;
        memset(&stPCMonitorInfo, 0x00, sizeof(XC_PCMONITOR_HK_INFO));

        if(MHal_XC_IsADCOffineSource(pInstance, u8InputSourceType, MAX_WINDOW))
        {
            // VD path, get signal from ADC_OFFLINE IP1
            u8TimingInputStatus = Hal_XC_GetOffLineDetection(pInstance, u8CheckSrc, u8InputSourceType);
        }
        else if(IsSrcTypeYPbPr(u8InputSourceType) || IsSrcTypeHDMI(u8InputSourceType))
        {
            // pc monitor path, get from pc monitor offline detect
            stPCMonitorInfo = MDrv_XC_PCMonitor_GetStatus(pInstance, MAX_WINDOW, u8InputSourceType);
            u8TimingInputStatus = (stPCMonitorInfo.eCurrentState != E_XC_PCMONITOR_STABLE_NOSYNC) ? 1 : 0;
        }
        else
        {
            // mvop path, no plan to implement in this function,
            u8TimingInputStatus = 0;
        }
        return u8TimingInputStatus;
    }
    else
    {
        bRet = Hal_XC_GetOffLineDetection(pInstance, u8CheckSrc, u8InputSourceType);
        if(gbOfflineDetectDbg == TRUE)
        {
            printf("[offline]%s %d u8InputSourceType:%d u8CheckSrc=%u ret:%d\n", __FUNCTION__, __LINE__, u8InputSourceType, u8CheckSrc, bRet);
        }
        return bRet;
    }
}

//------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
void MDrv_XC_SetOffLineDetection (void *pInstance, INPUT_SOURCE_TYPE_t u8InputSourceType )
{
    MS_U8 u8CheckSrc = INPUT_PORT_NONE_PORT;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    XC_OPTEE_MUX_DATA st_xc_mux_data;
    memset(&st_xc_mux_data,0,sizeof(st_xc_mux_data));

    if(genOfflineSource != INPUT_SOURCE_NONE)
    {
        if(genOfflineSource == INPUT_SOURCE_VGA)
        {
            if((u8InputSourceType != genOfflineSource) && (u8InputSourceType != INPUT_SOURCE_CVBS_MAX))
            {
                return;
            }
        }
        else if((genOfflineSource >= INPUT_SOURCE_CVBS) && (genOfflineSource < INPUT_SOURCE_CVBS_MAX))
        {
            if((u8InputSourceType != genOfflineSource) && (u8InputSourceType != INPUT_SOURCE_CVBS_MAX))
            {
                return;
            }
        }
        else if((genOfflineSource >= INPUT_SOURCE_YPBPR) && (genOfflineSource < INPUT_SOURCE_YPBPR_MAX))
        {
            if((u8InputSourceType != genOfflineSource) && (u8InputSourceType != INPUT_SOURCE_YPBPR_MAX))
            {
                return;
            }
        }
        else if((genOfflineSource >= INPUT_SOURCE_HDMI) && (genOfflineSource < INPUT_SOURCE_HDMI_MAX))
        {
            if((u8InputSourceType != genOfflineSource) && (u8InputSourceType != INPUT_SOURCE_YPBPR_MAX))
            {
                return;
            }
        }
        else
        {
            return;
        }
    }
    _XC_SEMAPHORE_ENTRY(pInstance,E_XC_ID_VAR);
    if(MHal_XC_IsSupportAdcOfflineByIp(pInstance))
    {
        if(MHal_XC_IsADCOffineSource(pInstance, u8InputSourceType, MAX_WINDOW))
        {
            MDrv_XC_SetIP1SignalSource(pInstance, u8InputSourceType, MAX_WINDOW);
        }
        else
        {
            // keep vd and vga source to set offline sog mux
            _XC_SEMAPHORE_RETURN(pInstance,E_XC_ID_VAR);
            return;
        }
    }
    _XC_SEMAPHORE_RETURN(pInstance,E_XC_ID_VAR);

    _XC_ENTRY(pInstance);

    u8CheckSrc = MDrv_XC_MUX_MapInputSourceToVDYMuxPORT(pInstance, u8InputSourceType);
    if(gbOfflineDetectDbg == TRUE)
    {
        printf("[offline]%s %d u8InputSourceType:%d u8CheckSrc=%u\n", __FUNCTION__, __LINE__, u8InputSourceType, u8CheckSrc);
    }

    Hal_XC_SetOfflineDetectClk(pInstance);

    if (u8CheckSrc == INPUT_PORT_NONE_PORT)
    {
        Hal_XC_OffLineExit(pInstance);
    }
    _XC_RETURN(pInstance);

    if ((u8CheckSrc >= (MS_U8)INPUT_PORT_YMUX_CVBS0) &&
        (u8CheckSrc <= (MS_U8)INPUT_PORT_YMUX_CVBS7))
    {
        MsOS_DelayTask(10);

        _XC_ENTRY(pInstance);
        AIS_Debug(printf("MDrv_SetOffLineToSog VD Related Signal!\n");)
        Hal_XC_SetOffLineToSog_AV(pInstance, u8CheckSrc - INPUT_PORT_YMUX_CVBS0);
        _XC_RETURN(pInstance);

        if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
        {
            MDrv_XC_OPTEE_Mux(pInstance, E_XC_OPTEE_SET_MUX, &st_xc_mux_data);
        }

        MsOS_DelayTask(10);

        _XC_ENTRY(pInstance);
        Hal_XC_OffLineInit(pInstance);
        _XC_RETURN(pInstance);

        MsOS_DelayTask(20);

        _XC_ENTRY(pInstance);
        Hal_XC_WaitForHVCleared_AV(pInstance, u8CheckSrc - INPUT_PORT_YMUX_CVBS0, u8InputSourceType);
        Hal_XC_TurnOnDetectClkPath(pInstance, SC_SUBWIN_IPMUX_ADC_B);
        _XC_RETURN(pInstance);
        if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
        {
            MDrv_XC_OPTEE_Mux(pInstance, E_XC_OPTEE_SET_MUX, &st_xc_mux_data);
        }

        MsOS_DelayTask(50);
    }
    else if((u8CheckSrc >= (MS_U8)INPUT_PORT_ANALOG0)&&
           (u8CheckSrc <= (MS_U8)INPUT_PORT_ANALOG4))
    {
        MsOS_DelayTask(10);

        _XC_ENTRY(pInstance);
        AIS_Debug(printf("MDrv_SetOffLineToSog_YUV Component!\n");)
        Hal_XC_SetOffLineToSog_YUV(pInstance, u8CheckSrc - INPUT_PORT_ANALOG0);
        _XC_RETURN(pInstance);

        if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
        {
            MDrv_XC_OPTEE_Mux(pInstance, E_XC_OPTEE_SET_MUX, &st_xc_mux_data);
        }

        MsOS_DelayTask(10);

        _XC_ENTRY(pInstance);
        Hal_XC_OffLineInit(pInstance);
        _XC_RETURN(pInstance);

        MsOS_DelayTask(20);

        _XC_ENTRY(pInstance);
        Hal_XC_WaitForHVCleared(pInstance, u8CheckSrc - INPUT_PORT_ANALOG0, u8InputSourceType);
        Hal_XC_TurnOnDetectClkPath(pInstance, SC_SUBWIN_IPMUX_ADC_B);
        _XC_RETURN(pInstance);

        if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
        {
            MDrv_XC_OPTEE_Mux(pInstance, E_XC_OPTEE_SET_MUX, &st_xc_mux_data);
        }

        MsOS_DelayTask(50);
    }
    else if((u8CheckSrc >= INPUT_PORT_YMUX_RY0 )&&(u8CheckSrc <= INPUT_PORT_YMUX_RY2 ))
    {
        MsOS_DelayTask(10);
        _XC_ENTRY(pInstance);
        AIS_Debug(printf("MDrv_SetOffLineToSog_CVBS&YUV share port Component!\n");)
        Hal_XC_SetOffLineToSog_YUV(pInstance, u8CheckSrc - INPUT_PORT_YMUX_RY0);
        _XC_RETURN(pInstance);

        if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
        {
            MDrv_XC_OPTEE_Mux(pInstance, E_XC_OPTEE_SET_MUX, &st_xc_mux_data);
        }

        MsOS_DelayTask(10);

        _XC_ENTRY(pInstance);
        Hal_XC_OffLineInit(pInstance);
        _XC_RETURN(pInstance);
        MsOS_DelayTask(20);
        _XC_ENTRY(pInstance);
        Hal_XC_WaitForHVCleared(pInstance, u8CheckSrc - INPUT_PORT_YMUX_RY0, u8InputSourceType);
        Hal_XC_TurnOnDetectClkPath(pInstance, SC_SUBWIN_IPMUX_ADC_B);
        _XC_RETURN(pInstance);

        if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
        {
            MDrv_XC_OPTEE_Mux(pInstance, E_XC_OPTEE_SET_MUX, &st_xc_mux_data);
        }

        MsOS_DelayTask(50);
    }
    else if ((u8CheckSrc >= INPUT_PORT_ANALOG0_SYNC)  &&
             (u8CheckSrc <= (MS_U8)INPUT_PORT_ANALOG4_SYNC) )
    {
        MsOS_DelayTask(10);

        _XC_ENTRY(pInstance);
        AIS_Debug(printf("MDrv_SetOffLineToHV VGA!\n");)
        Hal_XC_SetOffLineToHv(pInstance, u8CheckSrc - INPUT_PORT_ANALOG0_SYNC);
        _XC_RETURN(pInstance);

        if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
        {
            MDrv_XC_OPTEE_Mux(pInstance, E_XC_OPTEE_SET_MUX, &st_xc_mux_data);
        }

        MsOS_DelayTask(20);

        _XC_ENTRY(pInstance);
        Hal_XC_WaitForHVCleared(pInstance, u8CheckSrc - INPUT_PORT_ANALOG0_SYNC, u8InputSourceType);
        Hal_XC_TurnOnDetectClkPath(pInstance, SC_SUBWIN_IPMUX_ADC_B);
        _XC_RETURN(pInstance);

        if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
        {
            MDrv_XC_OPTEE_Mux(pInstance, E_XC_OPTEE_SET_MUX, &st_xc_mux_data);
        }

        MsOS_DelayTask(50);
    }
    else if ((u8CheckSrc >= INPUT_PORT_DVI0) && (u8CheckSrc <= INPUT_PORT_DVI3))
    {
        AIS_Debug(printf("MDrv_SetOffLineToHDMI 1~3!\n");)
        _XC_ENTRY(pInstance);
        Hal_XC_SetOffLineToHDMI(pInstance, u8CheckSrc);
        _XC_RETURN(pInstance);

#if(XC_SUPPORT_FASTSWITCH_BY_IP1GP == FALSE)
        MsOS_DelayTask(10);
        _XC_ENTRY(pInstance);
        Hal_XC_SetOfflineOfVsPol(pInstance);
        _XC_RETURN(pInstance);
#endif
    }
    else if (u8CheckSrc == INPUT_PORT_MVOP )
    {
        AIS_Debug(printf("MDrv_SetOffLineToUSB!\n");)
        Hal_XC_SetOffLineToUSB(pInstance, u8CheckSrc);
    }
    else if((u8CheckSrc >= INPUT_PORT_YMUX_G0) && (u8CheckSrc <= INPUT_PORT_YMUX_G2))
    {
        MsOS_DelayTask(10);

        _XC_ENTRY(pInstance);
        AIS_Debug(printf("MDrv_SetOffLineToSog VD2 Related Signal!\n");)
        Hal_XC_SetOffLineToSog_AV2(pInstance, u8CheckSrc - INPUT_PORT_YMUX_G0);
        _XC_RETURN(pInstance);

        if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
        {
            MDrv_XC_OPTEE_Mux(pInstance, E_XC_OPTEE_SET_MUX, &st_xc_mux_data);
        }

        MsOS_DelayTask(10);

        _XC_ENTRY(pInstance);
        Hal_XC_OffLineInit(pInstance);
        _XC_RETURN(pInstance);

        MsOS_DelayTask(20);

        _XC_ENTRY(pInstance);
        Hal_XC_WaitForHVCleared(pInstance, u8CheckSrc - INPUT_PORT_YMUX_G0, u8InputSourceType);
        Hal_XC_TurnOnDetectClkPath(pInstance, SC_SUBWIN_IPMUX_ADC_B);
        _XC_RETURN(pInstance);

        if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
        {
            MDrv_XC_OPTEE_Mux(pInstance, E_XC_OPTEE_SET_MUX, &st_xc_mux_data);
        }

        MsOS_DelayTask(50);

    }
}

MS_BOOL MDrv_XC_SetOffLineSogThreshold(void *pInstance, MS_U8 u8Threshold)
{
    return Hal_XC_SetOffLineSogThreshold(pInstance, u8Threshold);
}

MS_BOOL MDrv_XC_SetOffLineSogBW(void *pInstance, MS_U8 u8BW)
{
    return Hal_XC_SetOffLineSogBW(pInstance, u8BW);
}

//-------------------------------------------------------------------------------------------------
/// Get Offline detection status to specific input source
/// @param  u8InputSourceType                \b IN: the specific input source type to do offline detection
//-------------------------------------------------------------------------------------------------
MS_U8 MApi_XC_GetOffLineDetection_U2( void* pInstance, INPUT_SOURCE_TYPE_t u8InputSourceType )
{
    MS_U8 u8Ret = 0;
    _XC_ENTRY(pInstance);
    u8Ret = MDrv_XC_GetOffLineDetection(pInstance, u8InputSourceType);
    _XC_RETURN(pInstance);
    return u8Ret;
}
#ifndef UTOPIAXP_REMOVE_WRAPPER
MS_U8 MApi_XC_GetOffLineDetection( INPUT_SOURCE_TYPE_t u8InputSourceType )
{
    if (pu32XCInst == NULL)
    {
        printf("[%s,%5d]No instance existed, please get an instance by calling MApi_XC_Init() first\n",__FUNCTION__,__LINE__);
        return 0;
    }

    stXC_GET_OFFLINE_DETECTION XCArgs;
    XCArgs.u8InputSourceType = u8InputSourceType;
    XCArgs.u8ReturnValue = 0;

    if(UtopiaIoctl(pu32XCInst, E_XC_CMD_GET_OFFLINE_DETECTION, (void*)&XCArgs) != UTOPIA_STATUS_SUCCESS)
    {
        printf("Obtain XC engine fail\n");
        return 0;
    }
    else
    {
        return XCArgs.u8ReturnValue;
    }
}
#endif
//-------------------------------------------------------------------------------------------------
/// Set Offline detection to specific input source
/// @param  u8InputSourceType                \b IN: the specific input source type to do offline detection
//-------------------------------------------------------------------------------------------------
void MApi_XC_SetOffLineDetection_U2 ( void* pInstance, INPUT_SOURCE_TYPE_t u8InputSourceType )
{
    if(gbOfflineDetectEnable == FALSE)
    {
        return;
    }
    MDrv_XC_SetOffLineDetection(pInstance, u8InputSourceType);
}
#ifndef UTOPIAXP_REMOVE_WRAPPER
void MApi_XC_SetOffLineDetection ( INPUT_SOURCE_TYPE_t u8InputSourceType )
{
    if (pu32XCInst == NULL)
    {
        printf("[%s,%5d]No instance existed, please get an instance by calling MApi_XC_Init() first\n",__FUNCTION__,__LINE__);
        return;
    }

    stXC_SET_OFFLINE_DETECTION XCArgs;
    XCArgs.u8InputSourceType = u8InputSourceType;

    if(UtopiaIoctl(pu32XCInst, E_XC_CMD_SET_OFFLINE_DETECTION, (void*)&XCArgs) != UTOPIA_STATUS_SUCCESS)
    {
        printf("Obtain XC engine fail\n");
        return;
    }
    else
    {
        return;
    }
}
#endif
//-------------------------------------------------------------------------------------------------
/// Set Offline detection Sog Threshold
/// @param  u8Threshold                \b IN: threshold value t2,u3,u4: 0~31 other chip: 0~255
/// @Return TRUE: Successful FALSE: Fail
//-------------------------------------------------------------------------------------------------
MS_BOOL MApi_XC_SetOffLineSogThreshold_U2(void* pInstance, MS_U8 u8Threshold)
{
    MS_BOOL bRet = FALSE;
    _XC_ENTRY(pInstance);
    bRet = MDrv_XC_SetOffLineSogThreshold(pInstance, u8Threshold);
    _XC_RETURN(pInstance);
    return bRet;
}
#ifndef UTOPIAXP_REMOVE_WRAPPER
MS_BOOL MApi_XC_SetOffLineSogThreshold(MS_U8 u8Threshold)
{
    if (pu32XCInst == NULL)
    {
        printf("[%s,%5d]No instance existed, please get an instance by calling MApi_XC_Init() first\n",__FUNCTION__,__LINE__);
        return FALSE;
    }

    stXC_SET_OFFLINE_SOG_THRESHOLD XCArgs;
    XCArgs.u8Threshold = u8Threshold;
    XCArgs.bReturnValue = FALSE;

    if(UtopiaIoctl(pu32XCInst, E_XC_CMD_SET_OFFLINE_SOG_THRESHOLD, (void*)&XCArgs) != UTOPIA_STATUS_SUCCESS)
    {
        printf("Obtain XC engine fail\n");
        return FALSE;
    }
    else
    {
        return XCArgs.bReturnValue;
    }
}
#endif
//-------------------------------------------------------------------------------------------------
/// Set Offline Detection Sog filter bandwidth
/// @param  u8BW                \b IN: bandwidth value t2,u3,u4: 0~7 other chip: 0~31
/// @Return TRUE: Successful FALSE: Fail
//-------------------------------------------------------------------------------------------------
MS_BOOL MApi_XC_SetOffLineSogBW_U2(void* pInstance, MS_U8 u8BW)
{
    MS_BOOL bRet = FALSE;
    _XC_ENTRY(pInstance);
    bRet = MDrv_XC_SetOffLineSogBW(pInstance, u8BW);
    _XC_RETURN(pInstance);
    return bRet;
}
#ifndef UTOPIAXP_REMOVE_WRAPPER
MS_BOOL MApi_XC_SetOffLineSogBW(MS_U8 u8BW)
{
    if (pu32XCInst == NULL)
    {
        printf("[%s,%5d]No instance existed, please get an instance by calling MApi_XC_Init() first\n",__FUNCTION__,__LINE__);
        return FALSE;
    }

    stXC_SET_OFFLINE_SOG_BW XCArgs;
    XCArgs.u8BW = u8BW;
    XCArgs.bReturnValue = FALSE;

    if(UtopiaIoctl(pu32XCInst, E_XC_CMD_SET_OFFLINE_SOG_BW, (void*)&XCArgs) != UTOPIA_STATUS_SUCCESS)
    {
        printf("Obtain XC engine fail\n");
        return FALSE;
    }
    else
    {
        return XCArgs.bReturnValue;
    }
}
#endif
MS_BOOL MApi_XC_OffLineInit_U2(void* pInstance)
{
    _XC_ENTRY(pInstance);
    Hal_XC_OffLineInit(pInstance);
    MDrv_XC_SetOffLineSogThreshold(pInstance, 0x40);
    MDrv_XC_SetOffLineSogBW(pInstance, 0x1F);
    _XC_RETURN(pInstance);
    return TRUE;
}
#ifndef UTOPIAXP_REMOVE_WRAPPER
MS_BOOL MApi_XC_OffLineInit(void)
{
    if (pu32XCInst == NULL)
    {
        printf("[%s,%5d]No instance existed, please get an instance by calling MApi_XC_Init() first\n",__FUNCTION__,__LINE__);
        return FALSE;
    }

    stXC_SET_OFFLINE_INIT XCArgs;
    XCArgs.bReturnValue = FALSE;

    if(UtopiaIoctl(pu32XCInst, E_XC_CMD_SET_OFFLINE_INIT, (void*)&XCArgs) != UTOPIA_STATUS_SUCCESS)
    {
        printf("Obtain XC engine fail\n");
        return FALSE;
    }
    else
    {
        return XCArgs.bReturnValue;
    }
}
#endif
MS_U16 MApi_XC_GetOffLineInfo_U2(void *pInstance, INPUT_SOURCE_TYPE_t u8InputSourceType)
{
    MS_U16 u16Status = 0;
    MS_U8 u8CheckSrc = INPUT_PORT_NONE_PORT;
    MS_U16 u16InputSrc = INPUT_SOURCE_NONE;

    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));


    if((u8InputSourceType>=INPUT_SOURCE_HDMI)&&(u8InputSourceType<=INPUT_SOURCE_HDMI4))
    {
        u16InputSrc = u8InputSourceType - INPUT_SOURCE_HDMI;
        u8CheckSrc = pXCResourcePrivate->u16HDMI_PortInfo[u16InputSrc];
    }
    else if((u8InputSourceType>=INPUT_SOURCE_DVI)&&(u8InputSourceType<=INPUT_SOURCE_DVI4))
    {
        u16InputSrc = u8InputSourceType - INPUT_SOURCE_DVI;
        u8CheckSrc = pXCResourcePrivate->u16HDMI_PortInfo[u16InputSrc];
    }

    Hal_XC_SetOfflineDetectClk(pInstance);

    if ((u8CheckSrc >= INPUT_PORT_DVI0) && (u8CheckSrc <= INPUT_PORT_DVI3))
    {
        AIS_Debug(printf("MDrv_SetOffLineToHDMI 1~3!\n");)
 #if(XC_SUPPORT_FASTSWITCH_BY_IP1GP == FALSE)
        u16Status = Hal_XC_GetOffLineOfVsPol(pInstance, u8CheckSrc);
 #else
        XC_IP_SYNC_STATUS stXC_Sync_Status = {0,0,0};
        MDrv_XC_ip_get_sync_status(pInstance, &stXC_Sync_Status, u8CheckSrc, MAX_WINDOW, u8InputSourceType);
        u16Status = (MS_U16)(stXC_Sync_Status.u8SyncStatus & BIT(0));
 #endif
    }
    else
    {
        u16Status = INVALID_VALUE;
    }
    AIS_Debug(printf("[%s][%d]u8InputSourceType=%d, u8CheckSrc = %d\n",__FUNCTION__,__LINE__,u8InputSourceType,u8CheckSrc));

    return u16Status;
}

MS_U16 MApi_XC_GetOffLineInfo(INPUT_SOURCE_TYPE_t u8InputSourceType )
{
    if (pu32XCInst == NULL)
    {
        printf("[%s,%5d]No instance existed, please get an instance by calling MApi_XC_Init() first\n",__FUNCTION__,__LINE__);
        return 0;
    }

    stXC_GET_OFFLINE_INFO XCArgs;
    XCArgs.u8InputSourceType = u8InputSourceType;
    XCArgs.u16ReturnValue = 0;

    if(UtopiaIoctl(pu32XCInst, E_XC_CMD_GET_OFFLINE_INFO, (void*)&XCArgs) != UTOPIA_STATUS_SUCCESS)
    {
        printf("Obtain XC engine fail\n");
        return 0;
    }
    else
    {
        return XCArgs.u16ReturnValue;
    }
}
#endif
