//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
///
/// @file   halPNL_test_curve.h
/// @brief  Panel Driver Interface
/// @author MStar Semiconductor Inc.
///////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _HAL_PNL_TEST_CURVE_H_
#define _HAL_PNL_TEST_CURVE_H_

#ifdef __cplusplus
extern "C" {
#endif

#define OPEN_YMY_TEST_CASE (FALSE)

MS_U16 u16PanelGamma_R0[1024]={
0x000,0x000,0x000,0x000,0x000,0x000,0x000,0x001,0x001,0x001,
0x001,0x001,0x002,0x002,0x002,0x002,0x003,0x003,0x003,0x003,
0x004,0x004,0x004,0x005,0x005,0x005,0x006,0x006,0x006,0x007,
0x007,0x007,0x008,0x008,0x009,0x009,0x009,0x00a,0x00a,0x00b,
0x00b,0x00b,0x00c,0x00c,0x00d,0x00d,0x00e,0x00e,0x00f,0x00f,
0x010,0x010,0x011,0x011,0x012,0x012,0x013,0x014,0x014,0x015,
0x015,0x016,0x017,0x017,0x018,0x018,0x019,0x01a,0x01a,0x01b,
0x01c,0x01c,0x01d,0x01e,0x01e,0x01f,0x020,0x020,0x021,0x022,
0x023,0x023,0x024,0x025,0x026,0x026,0x027,0x028,0x029,0x02a,
0x02a,0x02b,0x02c,0x02d,0x02e,0x02f,0x02f,0x030,0x031,0x032,
0x033,0x034,0x035,0x036,0x037,0x038,0x038,0x039,0x03a,0x03b,
0x03c,0x03d,0x03e,0x03f,0x040,0x041,0x042,0x043,0x044,0x045,
0x046,0x047,0x048,0x049,0x04b,0x04c,0x04d,0x04e,0x04f,0x050,
0x051,0x052,0x053,0x054,0x056,0x057,0x058,0x059,0x05a,0x05b,
0x05d,0x05e,0x05f,0x060,0x062,0x063,0x064,0x065,0x066,0x068,
0x069,0x06a,0x06c,0x06d,0x06e,0x06f,0x071,0x072,0x073,0x075,
0x076,0x077,0x079,0x07a,0x07c,0x07d,0x07e,0x080,0x081,0x082,
0x084,0x085,0x087,0x088,0x08a,0x08b,0x08d,0x08e,0x090,0x091,
0x092,0x094,0x095,0x097,0x099,0x09a,0x09c,0x09d,0x09f,0x0a0,
0x0a2,0x0a3,0x0a5,0x0a7,0x0a8,0x0aa,0x0ab,0x0ad,0x0af,0x0b0,
0x0b2,0x0b4,0x0b5,0x0b7,0x0b9,0x0ba,0x0bc,0x0be,0x0bf,0x0c1,
0x0c3,0x0c4,0x0c6,0x0c8,0x0ca,0x0cb,0x0cd,0x0cf,0x0d1,0x0d3,
0x0d4,0x0d6,0x0d8,0x0da,0x0dc,0x0dd,0x0df,0x0e1,0x0e3,0x0e5,
0x0e7,0x0e9,0x0eb,0x0ec,0x0ee,0x0f0,0x0f2,0x0f4,0x0f6,0x0f8,
0x0fa,0x0fc,0x0fe,0x100,0x102,0x104,0x106,0x108,0x10a,0x10c,
0x10e,0x110,0x112,0x114,0x116,0x118,0x11a,0x11c,0x11e,0x120,
0x122,0x124,0x127,0x129,0x12b,0x12d,0x12f,0x131,0x133,0x136,
0x138,0x13a,0x13c,0x13e,0x141,0x143,0x145,0x147,0x149,0x14c,
0x14e,0x150,0x152,0x155,0x157,0x159,0x15c,0x15e,0x160,0x162,
0x165,0x167,0x169,0x16c,0x16e,0x171,0x173,0x175,0x178,0x17a,
0x17c,0x17f,0x181,0x184,0x186,0x189,0x18b,0x18d,0x190,0x192,
0x195,0x197,0x19a,0x19c,0x19f,0x1a1,0x1a4,0x1a6,0x1a9,0x1ab,
0x1ae,0x1b1,0x1b3,0x1b6,0x1b8,0x1bb,0x1bd,0x1c0,0x1c3,0x1c5,
0x1c8,0x1cb,0x1cd,0x1d0,0x1d2,0x1d5,0x1d8,0x1da,0x1dd,0x1e0,
0x1e3,0x1e5,0x1e8,0x1eb,0x1ed,0x1f0,0x1f3,0x1f6,0x1f8,0x1fb,
0x1fe,0x201,0x204,0x206,0x209,0x20c,0x20f,0x212,0x214,0x217,
0x21a,0x21d,0x220,0x223,0x226,0x229,0x22b,0x22e,0x231,0x234,
0x237,0x23a,0x23d,0x240,0x243,0x246,0x249,0x24c,0x24f,0x252,
0x255,0x258,0x25b,0x25e,0x261,0x264,0x267,0x26a,0x26d,0x270,
0x273,0x276,0x279,0x27d,0x280,0x283,0x286,0x289,0x28c,0x28f,
0x292,0x296,0x299,0x29c,0x29f,0x2a2,0x2a6,0x2a9,0x2ac,0x2af,
0x2b2,0x2b6,0x2b9,0x2bc,0x2bf,0x2c3,0x2c6,0x2c9,0x2cd,0x2d0,
0x2d3,0x2d6,0x2da,0x2dd,0x2e0,0x2e4,0x2e7,0x2ea,0x2ee,0x2f1,
0x2f5,0x2f8,0x2fb,0x2ff,0x302,0x306,0x309,0x30c,0x310,0x313,
0x317,0x31a,0x31e,0x321,0x325,0x328,0x32c,0x32f,0x333,0x336,
0x33a,0x33d,0x341,0x344,0x348,0x34c,0x34f,0x353,0x356,0x35a,
0x35e,0x361,0x365,0x368,0x36c,0x370,0x373,0x377,0x37b,0x37e,
0x382,0x386,0x389,0x38d,0x391,0x395,0x398,0x39c,0x3a0,0x3a3,
0x3a7,0x3ab,0x3af,0x3b3,0x3b6,0x3ba,0x3be,0x3c2,0x3c6,0x3c9,
0x3cd,0x3d1,0x3d5,0x3d9,0x3dd,0x3e1,0x3e4,0x3e8,0x3ec,0x3f0,
0x3f4,0x3f8,0x3fc,0x400,0x404,0x408,0x40c,0x410,0x414,0x418,
0x41c,0x420,0x424,0x428,0x42c,0x430,0x434,0x438,0x43c,0x440,
0x444,0x448,0x44c,0x450,0x454,0x458,0x45c,0x460,0x465,0x469,
0x46d,0x471,0x475,0x479,0x47d,0x482,0x486,0x48a,0x48e,0x492,
0x497,0x49b,0x49f,0x4a3,0x4a7,0x4ac,0x4b0,0x4b4,0x4b9,0x4bd,
0x4c1,0x4c5,0x4ca,0x4ce,0x4d2,0x4d7,0x4db,0x4df,0x4e4,0x4e8,
0x4ec,0x4f1,0x4f5,0x4fa,0x4fe,0x502,0x507,0x50b,0x510,0x514,
0x518,0x51d,0x521,0x526,0x52a,0x52f,0x533,0x538,0x53c,0x541,
0x545,0x54a,0x54e,0x553,0x557,0x55c,0x560,0x565,0x56a,0x56e,
0x573,0x577,0x57c,0x581,0x585,0x58a,0x58e,0x593,0x598,0x59c,
0x5a1,0x5a6,0x5aa,0x5af,0x5b4,0x5b9,0x5bd,0x5c2,0x5c7,0x5cb,
0x5d0,0x5d5,0x5da,0x5de,0x5e3,0x5e8,0x5ed,0x5f2,0x5f6,0x5fb,
0x600,0x605,0x60a,0x60e,0x613,0x618,0x61d,0x622,0x627,0x62c,
0x631,0x635,0x63a,0x63f,0x644,0x649,0x64e,0x653,0x658,0x65d,
0x662,0x667,0x66c,0x671,0x676,0x67b,0x680,0x685,0x68a,0x68f,
0x694,0x699,0x69e,0x6a3,0x6a8,0x6ad,0x6b2,0x6b7,0x6bd,0x6c2,
0x6c7,0x6cc,0x6d1,0x6d6,0x6db,0x6e0,0x6e6,0x6eb,0x6f0,0x6f5,
0x6fa,0x700,0x705,0x70a,0x70f,0x714,0x71a,0x71f,0x724,0x729,
0x72f,0x734,0x739,0x73f,0x744,0x749,0x74e,0x754,0x759,0x75e,
0x764,0x769,0x76f,0x774,0x779,0x77f,0x784,0x789,0x78f,0x794,
0x79a,0x79f,0x7a5,0x7aa,0x7af,0x7b5,0x7ba,0x7c0,0x7c5,0x7cb,
0x7d0,0x7d6,0x7db,0x7e1,0x7e6,0x7ec,0x7f1,0x7f7,0x7fd,0x802,
0x808,0x80d,0x813,0x818,0x81e,0x824,0x829,0x82f,0x835,0x83a,
0x840,0x845,0x84b,0x851,0x856,0x85c,0x862,0x868,0x86d,0x873,
0x879,0x87e,0x884,0x88a,0x890,0x895,0x89b,0x8a1,0x8a7,0x8ad,
0x8b2,0x8b8,0x8be,0x8c4,0x8ca,0x8cf,0x8d5,0x8db,0x8e1,0x8e7,
0x8ed,0x8f3,0x8f8,0x8fe,0x904,0x90a,0x910,0x916,0x91c,0x922,
0x928,0x92e,0x934,0x93a,0x940,0x946,0x94c,0x952,0x958,0x95e,
0x964,0x96a,0x970,0x976,0x97c,0x982,0x988,0x98e,0x994,0x99a,
0x9a0,0x9a7,0x9ad,0x9b3,0x9b9,0x9bf,0x9c5,0x9cb,0x9d1,0x9d8,
0x9de,0x9e4,0x9ea,0x9f0,0x9f7,0x9fd,0xa03,0xa09,0xa0f,0xa16,
0xa1c,0xa22,0xa28,0xa2f,0xa35,0xa3b,0xa42,0xa48,0xa4e,0xa55,
0xa5b,0xa61,0xa68,0xa6e,0xa74,0xa7b,0xa81,0xa87,0xa8e,0xa94,
0xa9b,0xaa1,0xaa7,0xaae,0xab4,0xabb,0xac1,0xac8,0xace,0xad5,
0xadb,0xae1,0xae8,0xaee,0xaf5,0xafc,0xb02,0xb09,0xb0f,0xb16,
0xb1c,0xb23,0xb29,0xb30,0xb36,0xb3d,0xb44,0xb4a,0xb51,0xb58,
0xb5e,0xb65,0xb6b,0xb72,0xb79,0xb7f,0xb86,0xb8d,0xb93,0xb9a,
0xba1,0xba8,0xbae,0xbb5,0xbbc,0xbc2,0xbc9,0xbd0,0xbd7,0xbde,
0xbe4,0xbeb,0xbf2,0xbf9,0xbff,0xc06,0xc0d,0xc14,0xc1b,0xc22,
0xc28,0xc2f,0xc36,0xc3d,0xc44,0xc4b,0xc52,0xc59,0xc60,0xc67,
0xc6d,0xc74,0xc7b,0xc82,0xc89,0xc90,0xc97,0xc9e,0xca5,0xcac,
0xcb3,0xcba,0xcc1,0xcc8,0xccf,0xcd6,0xcdd,0xce4,0xcec,0xcf3,
0xcfa,0xd01,0xd08,0xd0f,0xd16,0xd1d,0xd24,0xd2b,0xd33,0xd3a,
0xd41,0xd48,0xd4f,0xd56,0xd5e,0xd65,0xd6c,0xd73,0xd7a,0xd82,
0xd89,0xd90,0xd97,0xd9f,0xda6,0xdad,0xdb4,0xdbc,0xdc3,0xdca,
0xdd2,0xdd9,0xde0,0xde8,0xdef,0xdf6,0xdfe,0xe05,0xe0c,0xe14,
0xe1b,0xe23,0xe2a,0xe31,0xe39,0xe40,0xe48,0xe4f,0xe56,0xe5e,
0xe65,0xe6d,0xe74,0xe7c,0xe83,0xe8b,0xe92,0xe9a,0xea1,0xea9,
0xeb0,0xeb8,0xebf,0xec7,0xecf,0xed6,0xede,0xee5,0xeed,0xef5,
0xefc,0xf04,0xf0b,0xf13,0xf1b,0xf22,0xf2a,0xf32,0xf39,0xf41,
0xf49,0xf50,0xf58,0xf60,0xf67,0xf6f,0xf77,0xf7f,0xf86,0xf8e,
0xf96,0xf9e,0xfa5,0xfad,0xfb5,0xfbd,0xfc5,0xfcc,0xfd4,0xfdc,
0xfe4,0xfec,0xff4,0xffc};

MS_U16 u16PanelGamma_G0[1024]={
0x000,0x000,0x000,0x000,0x000,0x000,0x000,0x001,0x001,0x001,
0x001,0x001,0x002,0x002,0x002,0x002,0x003,0x003,0x003,0x003,
0x004,0x004,0x004,0x005,0x005,0x005,0x006,0x006,0x006,0x007,
0x007,0x007,0x008,0x008,0x009,0x009,0x009,0x00a,0x00a,0x00b,
0x00b,0x00b,0x00c,0x00c,0x00d,0x00d,0x00e,0x00e,0x00f,0x00f,
0x010,0x010,0x011,0x011,0x012,0x012,0x013,0x014,0x014,0x015,
0x015,0x016,0x017,0x017,0x018,0x018,0x019,0x01a,0x01a,0x01b,
0x01c,0x01c,0x01d,0x01e,0x01e,0x01f,0x020,0x020,0x021,0x022,
0x023,0x023,0x024,0x025,0x026,0x026,0x027,0x028,0x029,0x02a,
0x02a,0x02b,0x02c,0x02d,0x02e,0x02f,0x02f,0x030,0x031,0x032,
0x033,0x034,0x035,0x036,0x037,0x038,0x038,0x039,0x03a,0x03b,
0x03c,0x03d,0x03e,0x03f,0x040,0x041,0x042,0x043,0x044,0x045,
0x046,0x047,0x048,0x049,0x04b,0x04c,0x04d,0x04e,0x04f,0x050,
0x051,0x052,0x053,0x054,0x056,0x057,0x058,0x059,0x05a,0x05b,
0x05d,0x05e,0x05f,0x060,0x062,0x063,0x064,0x065,0x066,0x068,
0x069,0x06a,0x06c,0x06d,0x06e,0x06f,0x071,0x072,0x073,0x075,
0x076,0x077,0x079,0x07a,0x07c,0x07d,0x07e,0x080,0x081,0x082,
0x084,0x085,0x087,0x088,0x08a,0x08b,0x08d,0x08e,0x090,0x091,
0x092,0x094,0x095,0x097,0x099,0x09a,0x09c,0x09d,0x09f,0x0a0,
0x0a2,0x0a3,0x0a5,0x0a7,0x0a8,0x0aa,0x0ab,0x0ad,0x0af,0x0b0,
0x0b2,0x0b4,0x0b5,0x0b7,0x0b9,0x0ba,0x0bc,0x0be,0x0bf,0x0c1,
0x0c3,0x0c4,0x0c6,0x0c8,0x0ca,0x0cb,0x0cd,0x0cf,0x0d1,0x0d3,
0x0d4,0x0d6,0x0d8,0x0da,0x0dc,0x0dd,0x0df,0x0e1,0x0e3,0x0e5,
0x0e7,0x0e9,0x0eb,0x0ec,0x0ee,0x0f0,0x0f2,0x0f4,0x0f6,0x0f8,
0x0fa,0x0fc,0x0fe,0x100,0x102,0x104,0x106,0x108,0x10a,0x10c,
0x10e,0x110,0x112,0x114,0x116,0x118,0x11a,0x11c,0x11e,0x120,
0x122,0x124,0x127,0x129,0x12b,0x12d,0x12f,0x131,0x133,0x136,
0x138,0x13a,0x13c,0x13e,0x141,0x143,0x145,0x147,0x149,0x14c,
0x14e,0x150,0x152,0x155,0x157,0x159,0x15c,0x15e,0x160,0x162,
0x165,0x167,0x169,0x16c,0x16e,0x171,0x173,0x175,0x178,0x17a,
0x17c,0x17f,0x181,0x184,0x186,0x189,0x18b,0x18d,0x190,0x192,
0x195,0x197,0x19a,0x19c,0x19f,0x1a1,0x1a4,0x1a6,0x1a9,0x1ab,
0x1ae,0x1b1,0x1b3,0x1b6,0x1b8,0x1bb,0x1bd,0x1c0,0x1c3,0x1c5,
0x1c8,0x1cb,0x1cd,0x1d0,0x1d2,0x1d5,0x1d8,0x1da,0x1dd,0x1e0,
0x1e3,0x1e5,0x1e8,0x1eb,0x1ed,0x1f0,0x1f3,0x1f6,0x1f8,0x1fb,
0x1fe,0x201,0x204,0x206,0x209,0x20c,0x20f,0x212,0x214,0x217,
0x21a,0x21d,0x220,0x223,0x226,0x229,0x22b,0x22e,0x231,0x234,
0x237,0x23a,0x23d,0x240,0x243,0x246,0x249,0x24c,0x24f,0x252,
0x255,0x258,0x25b,0x25e,0x261,0x264,0x267,0x26a,0x26d,0x270,
0x273,0x276,0x279,0x27d,0x280,0x283,0x286,0x289,0x28c,0x28f,
0x292,0x296,0x299,0x29c,0x29f,0x2a2,0x2a6,0x2a9,0x2ac,0x2af,
0x2b2,0x2b6,0x2b9,0x2bc,0x2bf,0x2c3,0x2c6,0x2c9,0x2cd,0x2d0,
0x2d3,0x2d6,0x2da,0x2dd,0x2e0,0x2e4,0x2e7,0x2ea,0x2ee,0x2f1,
0x2f5,0x2f8,0x2fb,0x2ff,0x302,0x306,0x309,0x30c,0x310,0x313,
0x317,0x31a,0x31e,0x321,0x325,0x328,0x32c,0x32f,0x333,0x336,
0x33a,0x33d,0x341,0x344,0x348,0x34c,0x34f,0x353,0x356,0x35a,
0x35e,0x361,0x365,0x368,0x36c,0x370,0x373,0x377,0x37b,0x37e,
0x382,0x386,0x389,0x38d,0x391,0x395,0x398,0x39c,0x3a0,0x3a3,
0x3a7,0x3ab,0x3af,0x3b3,0x3b6,0x3ba,0x3be,0x3c2,0x3c6,0x3c9,
0x3cd,0x3d1,0x3d5,0x3d9,0x3dd,0x3e1,0x3e4,0x3e8,0x3ec,0x3f0,
0x3f4,0x3f8,0x3fc,0x400,0x404,0x408,0x40c,0x410,0x414,0x418,
0x41c,0x420,0x424,0x428,0x42c,0x430,0x434,0x438,0x43c,0x440,
0x444,0x448,0x44c,0x450,0x454,0x458,0x45c,0x460,0x465,0x469,
0x46d,0x471,0x475,0x479,0x47d,0x482,0x486,0x48a,0x48e,0x492,
0x497,0x49b,0x49f,0x4a3,0x4a7,0x4ac,0x4b0,0x4b4,0x4b9,0x4bd,
0x4c1,0x4c5,0x4ca,0x4ce,0x4d2,0x4d7,0x4db,0x4df,0x4e4,0x4e8,
0x4ec,0x4f1,0x4f5,0x4fa,0x4fe,0x502,0x507,0x50b,0x510,0x514,
0x518,0x51d,0x521,0x526,0x52a,0x52f,0x533,0x538,0x53c,0x541,
0x545,0x54a,0x54e,0x553,0x557,0x55c,0x560,0x565,0x56a,0x56e,
0x573,0x577,0x57c,0x581,0x585,0x58a,0x58e,0x593,0x598,0x59c,
0x5a1,0x5a6,0x5aa,0x5af,0x5b4,0x5b9,0x5bd,0x5c2,0x5c7,0x5cb,
0x5d0,0x5d5,0x5da,0x5de,0x5e3,0x5e8,0x5ed,0x5f2,0x5f6,0x5fb,
0x600,0x605,0x60a,0x60e,0x613,0x618,0x61d,0x622,0x627,0x62c,
0x631,0x635,0x63a,0x63f,0x644,0x649,0x64e,0x653,0x658,0x65d,
0x662,0x667,0x66c,0x671,0x676,0x67b,0x680,0x685,0x68a,0x68f,
0x694,0x699,0x69e,0x6a3,0x6a8,0x6ad,0x6b2,0x6b7,0x6bd,0x6c2,
0x6c7,0x6cc,0x6d1,0x6d6,0x6db,0x6e0,0x6e6,0x6eb,0x6f0,0x6f5,
0x6fa,0x700,0x705,0x70a,0x70f,0x714,0x71a,0x71f,0x724,0x729,
0x72f,0x734,0x739,0x73f,0x744,0x749,0x74e,0x754,0x759,0x75e,
0x764,0x769,0x76f,0x774,0x779,0x77f,0x784,0x789,0x78f,0x794,
0x79a,0x79f,0x7a5,0x7aa,0x7af,0x7b5,0x7ba,0x7c0,0x7c5,0x7cb,
0x7d0,0x7d6,0x7db,0x7e1,0x7e6,0x7ec,0x7f1,0x7f7,0x7fd,0x802,
0x808,0x80d,0x813,0x818,0x81e,0x824,0x829,0x82f,0x835,0x83a,
0x840,0x845,0x84b,0x851,0x856,0x85c,0x862,0x868,0x86d,0x873,
0x879,0x87e,0x884,0x88a,0x890,0x895,0x89b,0x8a1,0x8a7,0x8ad,
0x8b2,0x8b8,0x8be,0x8c4,0x8ca,0x8cf,0x8d5,0x8db,0x8e1,0x8e7,
0x8ed,0x8f3,0x8f8,0x8fe,0x904,0x90a,0x910,0x916,0x91c,0x922,
0x928,0x92e,0x934,0x93a,0x940,0x946,0x94c,0x952,0x958,0x95e,
0x964,0x96a,0x970,0x976,0x97c,0x982,0x988,0x98e,0x994,0x99a,
0x9a0,0x9a7,0x9ad,0x9b3,0x9b9,0x9bf,0x9c5,0x9cb,0x9d1,0x9d8,
0x9de,0x9e4,0x9ea,0x9f0,0x9f7,0x9fd,0xa03,0xa09,0xa0f,0xa16,
0xa1c,0xa22,0xa28,0xa2f,0xa35,0xa3b,0xa42,0xa48,0xa4e,0xa55,
0xa5b,0xa61,0xa68,0xa6e,0xa74,0xa7b,0xa81,0xa87,0xa8e,0xa94,
0xa9b,0xaa1,0xaa7,0xaae,0xab4,0xabb,0xac1,0xac8,0xace,0xad5,
0xadb,0xae1,0xae8,0xaee,0xaf5,0xafc,0xb02,0xb09,0xb0f,0xb16,
0xb1c,0xb23,0xb29,0xb30,0xb36,0xb3d,0xb44,0xb4a,0xb51,0xb58,
0xb5e,0xb65,0xb6b,0xb72,0xb79,0xb7f,0xb86,0xb8d,0xb93,0xb9a,
0xba1,0xba8,0xbae,0xbb5,0xbbc,0xbc2,0xbc9,0xbd0,0xbd7,0xbde,
0xbe4,0xbeb,0xbf2,0xbf9,0xbff,0xc06,0xc0d,0xc14,0xc1b,0xc22,
0xc28,0xc2f,0xc36,0xc3d,0xc44,0xc4b,0xc52,0xc59,0xc60,0xc67,
0xc6d,0xc74,0xc7b,0xc82,0xc89,0xc90,0xc97,0xc9e,0xca5,0xcac,
0xcb3,0xcba,0xcc1,0xcc8,0xccf,0xcd6,0xcdd,0xce4,0xcec,0xcf3,
0xcfa,0xd01,0xd08,0xd0f,0xd16,0xd1d,0xd24,0xd2b,0xd33,0xd3a,
0xd41,0xd48,0xd4f,0xd56,0xd5e,0xd65,0xd6c,0xd73,0xd7a,0xd82,
0xd89,0xd90,0xd97,0xd9f,0xda6,0xdad,0xdb4,0xdbc,0xdc3,0xdca,
0xdd2,0xdd9,0xde0,0xde8,0xdef,0xdf6,0xdfe,0xe05,0xe0c,0xe14,
0xe1b,0xe23,0xe2a,0xe31,0xe39,0xe40,0xe48,0xe4f,0xe56,0xe5e,
0xe65,0xe6d,0xe74,0xe7c,0xe83,0xe8b,0xe92,0xe9a,0xea1,0xea9,
0xeb0,0xeb8,0xebf,0xec7,0xecf,0xed6,0xede,0xee5,0xeed,0xef5,
0xefc,0xf04,0xf0b,0xf13,0xf1b,0xf22,0xf2a,0xf32,0xf39,0xf41,
0xf49,0xf50,0xf58,0xf60,0xf67,0xf6f,0xf77,0xf7f,0xf86,0xf8e,
0xf96,0xf9e,0xfa5,0xfad,0xfb5,0xfbd,0xfc5,0xfcc,0xfd4,0xfdc,
0xfe4,0xfec,0xff4,0xffc};

MS_U16 u16PanelGamma_B0[1024]={
0x000,0x000,0x000,0x000,0x000,0x000,0x000,0x001,0x001,0x001,
0x001,0x001,0x002,0x002,0x002,0x002,0x003,0x003,0x003,0x003,
0x004,0x004,0x004,0x005,0x005,0x005,0x006,0x006,0x006,0x007,
0x007,0x007,0x008,0x008,0x009,0x009,0x009,0x00a,0x00a,0x00b,
0x00b,0x00b,0x00c,0x00c,0x00d,0x00d,0x00e,0x00e,0x00f,0x00f,
0x010,0x010,0x011,0x011,0x012,0x012,0x013,0x014,0x014,0x015,
0x015,0x016,0x017,0x017,0x018,0x018,0x019,0x01a,0x01a,0x01b,
0x01c,0x01c,0x01d,0x01e,0x01e,0x01f,0x020,0x020,0x021,0x022,
0x023,0x023,0x024,0x025,0x026,0x026,0x027,0x028,0x029,0x02a,
0x02a,0x02b,0x02c,0x02d,0x02e,0x02f,0x02f,0x030,0x031,0x032,
0x033,0x034,0x035,0x036,0x037,0x038,0x038,0x039,0x03a,0x03b,
0x03c,0x03d,0x03e,0x03f,0x040,0x041,0x042,0x043,0x044,0x045,
0x046,0x047,0x048,0x049,0x04b,0x04c,0x04d,0x04e,0x04f,0x050,
0x051,0x052,0x053,0x054,0x056,0x057,0x058,0x059,0x05a,0x05b,
0x05d,0x05e,0x05f,0x060,0x062,0x063,0x064,0x065,0x066,0x068,
0x069,0x06a,0x06c,0x06d,0x06e,0x06f,0x071,0x072,0x073,0x075,
0x076,0x077,0x079,0x07a,0x07c,0x07d,0x07e,0x080,0x081,0x082,
0x084,0x085,0x087,0x088,0x08a,0x08b,0x08d,0x08e,0x090,0x091,
0x092,0x094,0x095,0x097,0x099,0x09a,0x09c,0x09d,0x09f,0x0a0,
0x0a2,0x0a3,0x0a5,0x0a7,0x0a8,0x0aa,0x0ab,0x0ad,0x0af,0x0b0,
0x0b2,0x0b4,0x0b5,0x0b7,0x0b9,0x0ba,0x0bc,0x0be,0x0bf,0x0c1,
0x0c3,0x0c4,0x0c6,0x0c8,0x0ca,0x0cb,0x0cd,0x0cf,0x0d1,0x0d3,
0x0d4,0x0d6,0x0d8,0x0da,0x0dc,0x0dd,0x0df,0x0e1,0x0e3,0x0e5,
0x0e7,0x0e9,0x0eb,0x0ec,0x0ee,0x0f0,0x0f2,0x0f4,0x0f6,0x0f8,
0x0fa,0x0fc,0x0fe,0x100,0x102,0x104,0x106,0x108,0x10a,0x10c,
0x10e,0x110,0x112,0x114,0x116,0x118,0x11a,0x11c,0x11e,0x120,
0x122,0x124,0x127,0x129,0x12b,0x12d,0x12f,0x131,0x133,0x136,
0x138,0x13a,0x13c,0x13e,0x141,0x143,0x145,0x147,0x149,0x14c,
0x14e,0x150,0x152,0x155,0x157,0x159,0x15c,0x15e,0x160,0x162,
0x165,0x167,0x169,0x16c,0x16e,0x171,0x173,0x175,0x178,0x17a,
0x17c,0x17f,0x181,0x184,0x186,0x189,0x18b,0x18d,0x190,0x192,
0x195,0x197,0x19a,0x19c,0x19f,0x1a1,0x1a4,0x1a6,0x1a9,0x1ab,
0x1ae,0x1b1,0x1b3,0x1b6,0x1b8,0x1bb,0x1bd,0x1c0,0x1c3,0x1c5,
0x1c8,0x1cb,0x1cd,0x1d0,0x1d2,0x1d5,0x1d8,0x1da,0x1dd,0x1e0,
0x1e3,0x1e5,0x1e8,0x1eb,0x1ed,0x1f0,0x1f3,0x1f6,0x1f8,0x1fb,
0x1fe,0x201,0x204,0x206,0x209,0x20c,0x20f,0x212,0x214,0x217,
0x21a,0x21d,0x220,0x223,0x226,0x229,0x22b,0x22e,0x231,0x234,
0x237,0x23a,0x23d,0x240,0x243,0x246,0x249,0x24c,0x24f,0x252,
0x255,0x258,0x25b,0x25e,0x261,0x264,0x267,0x26a,0x26d,0x270,
0x273,0x276,0x279,0x27d,0x280,0x283,0x286,0x289,0x28c,0x28f,
0x292,0x296,0x299,0x29c,0x29f,0x2a2,0x2a6,0x2a9,0x2ac,0x2af,
0x2b2,0x2b6,0x2b9,0x2bc,0x2bf,0x2c3,0x2c6,0x2c9,0x2cd,0x2d0,
0x2d3,0x2d6,0x2da,0x2dd,0x2e0,0x2e4,0x2e7,0x2ea,0x2ee,0x2f1,
0x2f5,0x2f8,0x2fb,0x2ff,0x302,0x306,0x309,0x30c,0x310,0x313,
0x317,0x31a,0x31e,0x321,0x325,0x328,0x32c,0x32f,0x333,0x336,
0x33a,0x33d,0x341,0x344,0x348,0x34c,0x34f,0x353,0x356,0x35a,
0x35e,0x361,0x365,0x368,0x36c,0x370,0x373,0x377,0x37b,0x37e,
0x382,0x386,0x389,0x38d,0x391,0x395,0x398,0x39c,0x3a0,0x3a3,
0x3a7,0x3ab,0x3af,0x3b3,0x3b6,0x3ba,0x3be,0x3c2,0x3c6,0x3c9,
0x3cd,0x3d1,0x3d5,0x3d9,0x3dd,0x3e1,0x3e4,0x3e8,0x3ec,0x3f0,
0x3f4,0x3f8,0x3fc,0x400,0x404,0x408,0x40c,0x410,0x414,0x418,
0x41c,0x420,0x424,0x428,0x42c,0x430,0x434,0x438,0x43c,0x440,
0x444,0x448,0x44c,0x450,0x454,0x458,0x45c,0x460,0x465,0x469,
0x46d,0x471,0x475,0x479,0x47d,0x482,0x486,0x48a,0x48e,0x492,
0x497,0x49b,0x49f,0x4a3,0x4a7,0x4ac,0x4b0,0x4b4,0x4b9,0x4bd,
0x4c1,0x4c5,0x4ca,0x4ce,0x4d2,0x4d7,0x4db,0x4df,0x4e4,0x4e8,
0x4ec,0x4f1,0x4f5,0x4fa,0x4fe,0x502,0x507,0x50b,0x510,0x514,
0x518,0x51d,0x521,0x526,0x52a,0x52f,0x533,0x538,0x53c,0x541,
0x545,0x54a,0x54e,0x553,0x557,0x55c,0x560,0x565,0x56a,0x56e,
0x573,0x577,0x57c,0x581,0x585,0x58a,0x58e,0x593,0x598,0x59c,
0x5a1,0x5a6,0x5aa,0x5af,0x5b4,0x5b9,0x5bd,0x5c2,0x5c7,0x5cb,
0x5d0,0x5d5,0x5da,0x5de,0x5e3,0x5e8,0x5ed,0x5f2,0x5f6,0x5fb,
0x600,0x605,0x60a,0x60e,0x613,0x618,0x61d,0x622,0x627,0x62c,
0x631,0x635,0x63a,0x63f,0x644,0x649,0x64e,0x653,0x658,0x65d,
0x662,0x667,0x66c,0x671,0x676,0x67b,0x680,0x685,0x68a,0x68f,
0x694,0x699,0x69e,0x6a3,0x6a8,0x6ad,0x6b2,0x6b7,0x6bd,0x6c2,
0x6c7,0x6cc,0x6d1,0x6d6,0x6db,0x6e0,0x6e6,0x6eb,0x6f0,0x6f5,
0x6fa,0x700,0x705,0x70a,0x70f,0x714,0x71a,0x71f,0x724,0x729,
0x72f,0x734,0x739,0x73f,0x744,0x749,0x74e,0x754,0x759,0x75e,
0x764,0x769,0x76f,0x774,0x779,0x77f,0x784,0x789,0x78f,0x794,
0x79a,0x79f,0x7a5,0x7aa,0x7af,0x7b5,0x7ba,0x7c0,0x7c5,0x7cb,
0x7d0,0x7d6,0x7db,0x7e1,0x7e6,0x7ec,0x7f1,0x7f7,0x7fd,0x802,
0x808,0x80d,0x813,0x818,0x81e,0x824,0x829,0x82f,0x835,0x83a,
0x840,0x845,0x84b,0x851,0x856,0x85c,0x862,0x868,0x86d,0x873,
0x879,0x87e,0x884,0x88a,0x890,0x895,0x89b,0x8a1,0x8a7,0x8ad,
0x8b2,0x8b8,0x8be,0x8c4,0x8ca,0x8cf,0x8d5,0x8db,0x8e1,0x8e7,
0x8ed,0x8f3,0x8f8,0x8fe,0x904,0x90a,0x910,0x916,0x91c,0x922,
0x928,0x92e,0x934,0x93a,0x940,0x946,0x94c,0x952,0x958,0x95e,
0x964,0x96a,0x970,0x976,0x97c,0x982,0x988,0x98e,0x994,0x99a,
0x9a0,0x9a7,0x9ad,0x9b3,0x9b9,0x9bf,0x9c5,0x9cb,0x9d1,0x9d8,
0x9de,0x9e4,0x9ea,0x9f0,0x9f7,0x9fd,0xa03,0xa09,0xa0f,0xa16,
0xa1c,0xa22,0xa28,0xa2f,0xa35,0xa3b,0xa42,0xa48,0xa4e,0xa55,
0xa5b,0xa61,0xa68,0xa6e,0xa74,0xa7b,0xa81,0xa87,0xa8e,0xa94,
0xa9b,0xaa1,0xaa7,0xaae,0xab4,0xabb,0xac1,0xac8,0xace,0xad5,
0xadb,0xae1,0xae8,0xaee,0xaf5,0xafc,0xb02,0xb09,0xb0f,0xb16,
0xb1c,0xb23,0xb29,0xb30,0xb36,0xb3d,0xb44,0xb4a,0xb51,0xb58,
0xb5e,0xb65,0xb6b,0xb72,0xb79,0xb7f,0xb86,0xb8d,0xb93,0xb9a,
0xba1,0xba8,0xbae,0xbb5,0xbbc,0xbc2,0xbc9,0xbd0,0xbd7,0xbde,
0xbe4,0xbeb,0xbf2,0xbf9,0xbff,0xc06,0xc0d,0xc14,0xc1b,0xc22,
0xc28,0xc2f,0xc36,0xc3d,0xc44,0xc4b,0xc52,0xc59,0xc60,0xc67,
0xc6d,0xc74,0xc7b,0xc82,0xc89,0xc90,0xc97,0xc9e,0xca5,0xcac,
0xcb3,0xcba,0xcc1,0xcc8,0xccf,0xcd6,0xcdd,0xce4,0xcec,0xcf3,
0xcfa,0xd01,0xd08,0xd0f,0xd16,0xd1d,0xd24,0xd2b,0xd33,0xd3a,
0xd41,0xd48,0xd4f,0xd56,0xd5e,0xd65,0xd6c,0xd73,0xd7a,0xd82,
0xd89,0xd90,0xd97,0xd9f,0xda6,0xdad,0xdb4,0xdbc,0xdc3,0xdca,
0xdd2,0xdd9,0xde0,0xde8,0xdef,0xdf6,0xdfe,0xe05,0xe0c,0xe14,
0xe1b,0xe23,0xe2a,0xe31,0xe39,0xe40,0xe48,0xe4f,0xe56,0xe5e,
0xe65,0xe6d,0xe74,0xe7c,0xe83,0xe8b,0xe92,0xe9a,0xea1,0xea9,
0xeb0,0xeb8,0xebf,0xec7,0xecf,0xed6,0xede,0xee5,0xeed,0xef5,
0xefc,0xf04,0xf0b,0xf13,0xf1b,0xf22,0xf2a,0xf32,0xf39,0xf41,
0xf49,0xf50,0xf58,0xf60,0xf67,0xf6f,0xf77,0xf7f,0xf86,0xf8e,
0xf96,0xf9e,0xfa5,0xfad,0xfb5,0xfbd,0xfc5,0xfcc,0xfd4,0xfdc,
0xfe4,0xfec,0xff4,0xffc};

MS_U16 u16PanelGamma_W0[1024]={0};



#define OD_CURVE_GOLDEN_ENTRY_NUM  (1089)
MS_U16 u16ODCurve[OD_CURVE_GOLDEN_ENTRY_NUM]={
0x90,0x80,0xb0,0xa0,0xd0,0xc0,0xf0,0xe0,0x10,0x90,
0x30,0x20,0x50,0x40,0x70,0x60,0x90,0x80,0xb0,0xa0,
0xd0,0xc0,0xf0,0xe0,0x10,0x00,0x30,0x20,0x50,0x40,
0x70,0x60,0x90,0x80,0xb0,0xa0,0xd0,0xc0,0xf0,0xe0,
0x10,0x00,0x30,0x20,0x50,0x40,0x70,0x60,0x90,0x80,
0xb0,0xa0,0xd0,0xc0,0xf0,0xe0,0x10,0x00,0x30,0x20,
0x50,0x40,0x70,0x60,0x90,0x80,0xb0,0xa0,0xd0,0xc0,
0xf0,0xe0,0x10,0x00,0x30,0x20,0x50,0x40,0x70,0x60,
0x90,0x80,0xb0,0xa0,0xd0,0xc0,0xf0,0xe0,0x10,0x00,
0x30,0x20,0x50,0x40,0x70,0x60,0x90,0x80,0xb0,0xa0,
0xd0,0xc0,0xf0,0xe0,0x10,0x00,0x30,0x20,0x50,0x40,
0x70,0x60,0x90,0x80,0xb0,0xa0,0xd0,0xc0,0xf0,0xe0,
0x10,0x00,0x30,0x20,0x50,0x40,0x70,0x60,0x90,0x80,
0xb0,0xa0,0xd0,0xc0,0xf0,0xe0,0x10,0x00,0x30,0x20,
0x50,0x40,0x70,0x60,0x90,0x80,0xb0,0xa0,0xd0,0xc0,
0xf0,0xe0,0x10,0x00,0x30,0x20,0x50,0x40,0x70,0x60,
0x90,0x80,0xb0,0xa0,0xd0,0xc0,0xf0,0xe0,0x10,0x00,
0x30,0x20,0x50,0x40,0x70,0x60,0x90,0x80,0xb0,0xa0,
0xd0,0xc0,0xf0,0xe0,0x10,0x00,0x30,0x20,0x50,0x40,
0x70,0x60,0x90,0x80,0xb0,0xa0,0xd0,0xc0,0xf0,0xe0,
0x10,0x00,0x30,0x20,0x50,0x40,0x70,0x60,0x90,0x80,
0xb0,0xa0,0xd0,0xc0,0xf0,0xe0,0x10,0x00,0x30,0x20,
0x50,0x40,0x70,0x60,0x90,0x80,0xb0,0xa0,0xd0,0xc0,
0xf0,0xe0,0x10,0x00,0x30,0x20,0x50,0x40,0x70,0x60,
0x90,0x80,0xb0,0xa0,0xd0,0xc0,0xf0,0xe0,0x10,0x00,
0x30,0x20,0x50,0x40,0x70,0x60,0x90,0x80,0xb0,0xa0,
0xd0,0xc0,0xf0,0xe0,0x10,0x00,0x30,0x20,0x50,0x40,
0x70,0x60,0x6f,0x6f,0x6f,0x6f,0x6f,0x6f,0x6f,0x6f,
0x6f,0x6f,0x6f,0x6f,0x6f,0x6f,0x6f,0x6f,0x90,0x30,
0x20,0x10,0x00,0x70,0x60,0x50,0x40,0xb0,0xa0,0x90,
0x80,0xf0,0xe0,0xd0,0xc0,0x30,0x20,0x10,0x38,0x70,
0x60,0x50,0x40,0xb0,0xa0,0x90,0x80,0xf0,0xe0,0xd0,
0xc0,0x30,0x20,0x10,0x00,0x70,0x60,0x50,0x40,0xb0,
0xa0,0x90,0x80,0xf0,0xe0,0xd0,0xc0,0x30,0x20,0x10,
0x00,0x70,0x60,0x50,0x40,0xb0,0xa0,0x90,0x80,0xf0,
0xe0,0xd0,0xc0,0x30,0x20,0x10,0x00,0x70,0x60,0x50,
0x40,0xb0,0xa0,0x90,0x80,0xf0,0xe0,0xd0,0xc0,0x30,
0x20,0x10,0x00,0x70,0x60,0x50,0x40,0xb0,0xa0,0x90,
0x80,0xf0,0xe0,0xd0,0xc0,0x30,0x20,0x10,0x00,0x70,
0x60,0x50,0x40,0xb0,0xa0,0x90,0x80,0xf0,0xe0,0xd0,
0xc0,0x30,0x20,0x10,0x00,0x70,0x60,0x50,0x40,0xb0,
0xa0,0x90,0x80,0xf0,0xe0,0xd0,0xc0,0x30,0x20,0x10,
0x00,0x70,0x60,0x50,0x40,0xb0,0xa0,0x90,0x80,0xf0,
0xe0,0xd0,0xc0,0x30,0x20,0x10,0x00,0x70,0x60,0x50,
0x40,0xb0,0xa0,0x90,0x80,0xf0,0xe0,0xd0,0xc0,0x30,
0x20,0x10,0x00,0x70,0x60,0x50,0x40,0xb0,0xa0,0x90,
0x80,0xf0,0xe0,0xd0,0xc0,0x30,0x20,0x10,0x00,0x70,
0x60,0x50,0x40,0xb0,0xa0,0x90,0x80,0xf0,0xe0,0xd0,
0xc0,0x30,0x20,0x10,0x00,0x70,0x60,0x50,0x40,0xb0,
0xa0,0x90,0x80,0xf0,0xe0,0xd0,0xc0,0x30,0x20,0x10,
0x00,0x70,0x60,0x50,0x40,0xb0,0xa0,0x90,0x80,0xf0,
0xe0,0xd0,0xc0,0x30,0x20,0x10,0x00,0x70,0x60,0x50,
0x40,0xb0,0xa0,0x90,0x80,0xf0,0xe0,0xd0,0xc0,0x30,
0x20,0x10,0x00,0x70,0x60,0x50,0x40,0xb0,0xa0,0x90,
0x80,0xf0,0xe0,0xd0,0xc0,0x30,0x20,0x10,0x00,0x70,
0x60,0x50,0x40,0xb0,0xa0,0x90,0x80,0xf0,0xe0,0xd0,
0xc0,0xd0,0xc0,0xf0,0xe0,0x90,0x80,0xb0,0xa0,0x50,
0x40,0x70,0x60,0x10,0x00,0x30,0x20,0xd0,0xc0,0xf0,
0xe0,0x90,0x80,0xb0,0xa0,0x50,0x40,0x70,0x60,0x10,
0xd0,0x30,0x20,0xd0,0xc0,0xf0,0xe0,0x90,0x80,0xb0,
0xa0,0x50,0x40,0x70,0x60,0x10,0x00,0x30,0x20,0xd0,
0xc0,0xf0,0xe0,0x90,0x80,0xb0,0xa0,0x50,0x40,0x70,
0x60,0x10,0x00,0x30,0x20,0xd0,0xc0,0xf0,0xe0,0x90,
0x80,0xb0,0xa0,0x50,0x40,0x70,0x60,0x10,0x00,0x30,
0x20,0xd0,0xc0,0xf0,0xe0,0x90,0x80,0xb0,0xa0,0x50,
0x40,0x70,0x60,0x10,0x00,0x30,0x20,0xd0,0xc0,0xf0,
0xe0,0x90,0x80,0xb0,0xa0,0x50,0x40,0x70,0x60,0x10,
0x00,0x30,0x20,0xd0,0xc0,0xf0,0xe0,0x90,0x80,0xb0,
0xa0,0x50,0x40,0x70,0x60,0x10,0x00,0x30,0x20,0xd0,
0xc0,0xf0,0xe0,0x90,0x80,0xb0,0xa0,0x50,0x40,0x70,
0x60,0x10,0x00,0x30,0x20,0xd0,0xc0,0xf0,0xe0,0x90,
0x80,0xb0,0xa0,0x50,0x40,0x70,0x60,0x10,0x00,0x30,
0x20,0xd0,0xc0,0xf0,0xe0,0x90,0x80,0xb0,0xa0,0x50,
0x40,0x70,0x60,0x10,0x00,0x30,0x20,0xd0,0xc0,0xf0,
0xe0,0x90,0x80,0xb0,0xa0,0x50,0x40,0x70,0x60,0x10,
0x00,0x30,0x20,0xd0,0xc0,0xf0,0xe0,0x90,0x80,0xb0,
0xa0,0x50,0x40,0x70,0x60,0x10,0x00,0x30,0x20,0xd0,
0xc0,0xf0,0xe0,0x90,0x80,0xb0,0xa0,0x50,0x40,0x70,
0x60,0x10,0x00,0x30,0x20,0xd0,0xc0,0xf0,0xe0,0x90,
0x80,0xb0,0xa0,0x50,0x40,0x70,0x60,0x10,0x00,0x30,
0x20,0xd0,0xc0,0xf0,0xe0,0x90,0x80,0xb0,0xa0,0x50,
0x40,0x70,0x60,0x10,0x00,0x30,0x20,0x2f,0x2f,0x2f,
0x2f,0x2f,0x2f,0x2f,0x2f,0x2f,0x2f,0x2f,0x2f,0x2f,
0x2f,0x2f,0x2f,0x70,0x60,0x50,0x40,0x30,0x20,0x10,
0x00,0xf0,0xe0,0xd0,0xc0,0xb0,0xa0,0x90,0x80,0x70,
0x60,0x50,0x40,0x30,0x20,0x10,0x00,0xf0,0xe0,0xd0,
0xc0,0xb0,0xa0,0x90,0x80,0x70,0x60,0x50,0x40,0x30,
0x20,0x10,0x78,0xf0,0xe0,0xd0,0xc0,0xb0,0xa0,0x90,
0x80,0x70,0x60,0x50,0x40,0x30,0x20,0x10,0x00,0xf0,
0xe0,0xd0,0xc0,0xb0,0xa0,0x90,0x80,0x70,0x60,0x50,
0x40,0x30,0x20,0x10,0x00,0xf0,0xe0,0xd0,0xc0,0xb0,
0xa0,0x90,0x80,0x70,0x60,0x50,0x40,0x30,0x20,0x10,
0x00,0xf0,0xe0,0xd0,0xc0,0xb0,0xa0,0x90,0x80,0x70,
0x60,0x50,0x40,0x30,0x20,0x10,0x00,0xf0,0xe0,0xd0,
0xc0,0xb0,0xa0,0x90,0x80,0x70,0x60,0x50,0x40,0x30,
0x20,0x10,0x00,0xf0,0xe0,0xd0,0xc0,0xb0,0xa0,0x90,
0x80,0x70,0x60,0x50,0x40,0x30,0x20,0x10,0x00,0xf0,
0xe0,0xd0,0xc0,0xb0,0xa0,0x90,0x80,0x70,0x60,0x50,
0x40,0x30,0x20,0x10,0x00,0xf0,0xe0,0xd0,0xc0,0xb0,
0xa0,0x90,0x80,0x70,0x60,0x50,0x40,0x30,0x20,0x10,
0x00,0xf0,0xe0,0xd0,0xc0,0xb0,0xa0,0x90,0x80,0x70,
0x60,0x50,0x40,0x30,0x20,0x10,0x00,0xf0,0xe0,0xd0,
0xc0,0xb0,0xa0,0x90,0x80,0x70,0x60,0x50,0x40,0x30,
0x20,0x10,0x00,0xf0,0xe0,0xd0,0xc0,0xb0,0xa0,0x90,
0x80,0x70,0x60,0x50,0x40,0x30,0x20,0x10,0x00,0xf0,
0xe0,0xd0,0xc0,0xb0,0xa0,0x90,0x80,0x70,0x60,0x50,
0x40,0x30,0x20,0x10,0x00,0xf0,0xe0,0xd0,0xc0,0xb0,
0xa0,0x90,0x80,0x70,0x60,0x50,0x40,0x30,0x20,0x10,
0x00,0xf0,0xe0,0xd0,0xc0,0xb0,0xa0,0x90,0x80};



#ifdef __cplusplus
}
#endif

#endif // _HAL_PNL_TEST_CURVE_H_

