//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef _HWREG_DIP_H_
#define _HWREG_DIP_H_

//TrustZone
#define REG_TZPC_NONPM_BASE      0x123900UL
#define REG_TZPC_NONPM_DIP       (REG_TZPC_NONPM_BASE + (0x74<<1) )
#define REG_TZPC_NONPM_DWIN0     (REG_TZPC_NONPM_BASE + (0x79<<1) )

//CLOCK
#define REG_CLOCK_BASE                      (0x100B00UL)

#define REG_MFDEC_LINEBUFFER                (REG_CLOCK_BASE + (0x57<<1) )
#define MFDEC_MAIN_LB                       (BMASK(3:0))
#define ENABLE_MFDEC_LB                     (0)
#define MFDEC_SUB_LB                        (BMASK(7:4))

//MVOP clock
#define REG_CKG_MVOP                        (REG_CLOCK_BASE + (0x4C<<1) )
    #define CKG_MVOP_CLK_MASK               (BMASK(4:2))
    #define CKG_MVOP_320MHZ                 (4 << 2)

//DIP engine clock
#define REG_CKG_DIP_FCLK                (REG_CLOCK_BASE + (0x52<<1) )
    #define CKG_DIP_FCLK_SHIFT          (10)
    #define CKG_DIP_FCLK_MASK           (BMASK(12:10))
    #define CKG_DIP_FCLK_170MHZ         (0 << CKG_DIP_FCLK_SHIFT)
    #define CKG_DIP_FCLK_345MHZ         (2 << CKG_DIP_FCLK_SHIFT)
    #define CKG_DIP_FCLK_216MHZ         (3 << CKG_DIP_FCLK_SHIFT)
    #define CKG_DIP_FCLK_192MHZ         (4 << CKG_DIP_FCLK_SHIFT)
    #define CKG_DIP_FCLK_240MHZ         (5 << CKG_DIP_FCLK_SHIFT)
    #define CKG_DIP_FCLK_320MHZ         (6 << CKG_DIP_FCLK_SHIFT)

//DIP clock
#define REG_CKG_DIP                        (REG_CLOCK_BASE + (0x59<<1) )
    #define CKG_DIP_GATED                  BIT(0)
    #define CKG_DIP_INVERT                 BIT(1)
    #define CKG_DIP_CLK_MASK_SHIFT         2
    #define CKG_DIP_CLK_MASK               BMASK(5:2)
    #define CKG_DIP_CLK_ADC                (0 << CKG_DIP_CLK_MASK_SHIFT)
    #define CKG_DIP_CLK_HDMI               (1 << CKG_DIP_CLK_MASK_SHIFT)
    #define CKG_DIP_CLK_VD                 (2 << CKG_DIP_CLK_MASK_SHIFT)
    #define CKG_DIP_CLK_MVOP               (3 << CKG_DIP_CLK_MASK_SHIFT)
    #define CKG_DIP_CLK_IP_MAIN            (4 << CKG_DIP_CLK_MASK_SHIFT)
    #define CKG_DIP_CLK_OP                 (7 << CKG_DIP_CLK_MASK_SHIFT)
    #define CKG_DIP_CLK_IP_SUB             (4 << CKG_DIP_CLK_MASK_SHIFT)
    #define CKG_DIP_CLK_SC2_OP             (7 << CKG_DIP_CLK_MASK_SHIFT)
    #define CKG_DIP_CLK_HDMI2              (13 << CKG_DIP_CLK_MASK_SHIFT)
    #define CKG_DIP_CLK_HDMI3              (11 << CKG_DIP_CLK_MASK_SHIFT)
    #define CKG_DIP_CLK_HDMI4              (12 << CKG_DIP_CLK_MASK_SHIFT)

//DWIN0 clock
#define REG_CKG_DWIN0                      (REG_CLOCK_BASE + (0x5F<<1) )
    #define CKG_DWIN0_GATED                BIT(0)
    #define CKG_DWIN0_INVERT               BIT(1)
    #define CKG_DWIN0_CLK_MASK_SHIFT       2
    #define CKG_DWIN0_CLK_MASK             BMASK(4:2)
    #define CKG_DWIN0_CLK_HDMI             (6 << CKG_DWIN0_CLK_MASK_SHIFT)
    #define CKG_DWIN0_CLK_MVOP             (2 << CKG_DWIN0_CLK_MASK_SHIFT)
    #define CKG_DWIN0_CLK_IP_MAIN          (0 << CKG_DWIN0_CLK_MASK_SHIFT)
    #define CKG_DWIN0_CLK_OP               (1 << CKG_DWIN0_CLK_MASK_SHIFT)
    #define CKG_DWIN0_CLK_IP_SUB           (0 << CKG_DWIN0_CLK_MASK_SHIFT)
    #define CKG_DWIN0_CLK_SC2_OP           (1 << CKG_DWIN0_CLK_MASK_SHIFT)
    #define CKG_DWIN0_CLK_MVOP_SUB         (3 << CKG_DWIN0_CLK_MASK_SHIFT)
#define CKG_DWIN0_VD_HDMI_CLK_MASK_SHIFT   1
#define CKG_DWIN0_VD_HDMI_CLK_MASK         BMASK(4:1)
#define CKG_DWIN0_SEL_HDMI_CLK             (5 << CKG_DWIN0_VD_HDMI_CLK_MASK_SHIFT)
#define CKG_DWIN0_SEL_VD_CLK               (1 << CKG_DWIN0_VD_HDMI_CLK_MASK_SHIFT)
#define CKG_DWIN0_SEL_FS_VD_CLK            (2 << CKG_DWIN0_VD_HDMI_CLK_MASK_SHIFT)
#define CKG_DWIN0_SEL_HDMI2_CLK            (7 << CKG_DWIN0_VD_HDMI_CLK_MASK_SHIFT)
#define CKG_DWIN0_SEL_HDMI3_CLK            (14 << CKG_DWIN0_VD_HDMI_CLK_MASK_SHIFT)
#define CKG_DWIN0_SEL_HDMI4_CLK            (15 << CKG_DWIN0_VD_HDMI_CLK_MASK_SHIFT)
#define CKG_DWIN0_SEL_FS_COMPONENT_CLK     (0 << CKG_DWIN0_VD_HDMI_CLK_MASK_SHIFT)

//DWIN1 clock
#define REG_CKG_DWIN1                      (REG_CLOCK_BASE + (0x5F<<1)+1 )
    #define CKG_DWIN1_GATED                BIT(0)
    #define CKG_DWIN1_INVERT               BIT(1)
    #define CKG_DWIN1_CLK_MASK_SHIFT       2
    #define CKG_DWIN1_CLK_MASK             BMASK(4:2)
    #define CKG_DWIN1_CLK_HDMI             (6 << CKG_DWIN1_CLK_MASK_SHIFT)
    #define CKG_DWIN1_CLK_MVOP             (2 << CKG_DWIN1_CLK_MASK_SHIFT)
    #define CKG_DWIN1_CLK_IP_MAIN          (0 << CKG_DWIN1_CLK_MASK_SHIFT)
    #define CKG_DWIN1_CLK_OP               (1 << CKG_DWIN1_CLK_MASK_SHIFT)
    #define CKG_DWIN1_CLK_IP_SUB           (0 << CKG_DWIN1_CLK_MASK_SHIFT)
    #define CKG_DWIN1_CLK_SC2_OP           (1 << CKG_DWIN1_CLK_MASK_SHIFT)
#define CKG_DWIN1_VD_HDMI_CLK_MASK_SHIFT   1
#define CKG_DWIN1_VD_HDMI_CLK_MASK         BMASK(4:1)
#define CKG_DWIN1_SEL_HDMI_CLK             (1 << CKG_DWIN1_VD_HDMI_CLK_MASK_SHIFT)
#define CKG_DWIN1_SEL_VD_CLK               (1 << CKG_DWIN1_VD_HDMI_CLK_MASK_SHIFT)


//DIP mux
#define DIP_DIP_MUX_HDMI                   (1)
#define DIP_DIP_MUX_VD                     (2)
#define DIP_DIP_MUX_MVOP                   (3)
#define DIP_DIP_MUX_IP_MAIN                (4)
#define DIP_DIP_MUX_OP                     (7)
#define DIP_DIP_MUX_IP_SUB                 (4)
#define DIP_DIP_MUX_SC2_OP                 (7)
#define DIP_DIP_MUX_FS                     (0xE)
#define DIP_DIP_FS_SHIFT                   (12)
#define DIP_DIP_FS_MSAK                    BMASK(15:12)
#define DIP_DIP_MUX_FS_COMPONENT           (0 << DIP_DIP_FS_SHIFT)
#define DIP_DIP_MUX_FS_HDMI                (1 << DIP_DIP_FS_SHIFT)
#define DIP_DIP_MUX_FS_HDMI2               (4 << DIP_DIP_FS_SHIFT)
#define DIP_DIP_MUX_FS_HDMI3               (7 << DIP_DIP_FS_SHIFT)
#define DIP_DIP_MUX_FS_HDMI4               (8 << DIP_DIP_FS_SHIFT)

//DWIN0 mux
#define DIP_DWIN0_MUX_HDMI                 (1)
#define DIP_DWIN0_MUX_VD                   (2)
#define DIP_DWIN0_MUX_MVOP                 (3)
#define DIP_DWIN0_MUX_IP_MAIN              (4)
#define DIP_DWIN0_MUX_OP                   (7)
#define DIP_DWIN0_MUX_IP_SUB               (4)
#define DIP_DWIN0_MUX_SC2_OP               (7)
#define DIP_DWIN0_MUX_MVOP_SUB             (8)
#define DIP_DWIN0_MUX_FS                   (0xE)
#define DIP_DWIN0_FS_SHIFT                 (12)
#define DIP_DWIN0_FS_MSAK                  BMASK(15:12)
#define DIP_DWIN0_MUX_FS_VD                (2 << DIP_DWIN0_FS_SHIFT)
#define DIP_DWIN0_MUX_FS_HDMI              (1 << DIP_DIP_FS_SHIFT)
#define DIP_DWIN0_MUX_FS_HDMI2             (4 << DIP_DIP_FS_SHIFT)
#define DIP_DWIN0_MUX_FS_HDMI3             (7 << DIP_DIP_FS_SHIFT)
#define DIP_DWIN0_MUX_FS_HDMI4             (8 << DIP_DIP_FS_SHIFT)
#define DIP_DWIN0_MUX_FS_COMPONENT         (0 << DIP_DIP_FS_SHIFT)

//DWIN1 mux
#define DIP_DWIN1_MUX_HDMI                 (1)
#define DIP_DWIN1_MUX_VD                   (2)
#define DIP_DWIN1_MUX_MVOP                 (3)
#define DIP_DWIN1_MUX_IP_MAIN              (4)
#define DIP_DWIN1_MUX_OP                   (7)
#define DIP_DWIN1_MUX_IP_SUB               (4)
#define DIP_DWIN1_MUX_SC2_OP               (7)

//DIPR
#define REG_DIPR_BASE                     (0x121000UL)
#define REG_DIPR_BK1210_01                (REG_DIPR_BASE + (0x01<<1))
#define REG_DIPR_BK1210_02                (REG_DIPR_BASE + (0x02<<1))
#define REG_DIPR_BK1210_03                (REG_DIPR_BASE + (0x03<<1))
#define REG_DIPR_BK1210_04                (REG_DIPR_BASE + (0x04<<1))
#define REG_DIPR_BK1210_05                (REG_DIPR_BASE + (0x05<<1))
#define REG_DIPR_BK1210_06                (REG_DIPR_BASE + (0x06<<1))
#define REG_DIPR_BK1210_07                (REG_DIPR_BASE + (0x07<<1))
#define REG_DIPR_BK1210_09                (REG_DIPR_BASE + (0x09<<1))
#define REG_DIPR_BK1210_0F                (REG_DIPR_BASE + (0x0F<<1))
#define REG_DIPR_BK1210_10                (REG_DIPR_BASE + (0x10<<1))
#define REG_DIPR_BK1210_11                (REG_DIPR_BASE + (0x11<<1))
#define REG_DIPR_BK1210_14                (REG_DIPR_BASE + (0x14<<1))
#define REG_DIPR_BK1210_16                (REG_DIPR_BASE + (0x16<<1))
#define REG_DIPR_BK1210_19                (REG_DIPR_BASE + (0x19<<1))
#define REG_DIPR_BK1210_1A                (REG_DIPR_BASE + (0x1A<<1))
#define REG_DIPR_BK1210_1B                (REG_DIPR_BASE + (0x1B<<1))
#define REG_DIPR_BK1210_34                (REG_DIPR_BASE + (0x34<<1))
#define REG_DIPR_BK1210_35                (REG_DIPR_BASE + (0x35<<1))

#define REG_MVOP_MAIN_BASE                (0x101400UL)
#define REG_MVOP_2P_MODE                  (REG_MVOP_MAIN_BASE + (0x53<<1))

//DDI1_EXT_BK38
#define REG_DDI1_EXT38_BASE               (0x333800UL)
#define REG_DDI1_EXT38_08                 ((REG_DDI1_EXT38_BASE) + (0x08<<1))
#define REG_DDI1_EXT38_09                 ((REG_DDI1_EXT38_BASE) + (0x09<<1))
#define REG_DDI1_EXT38_0A                 ((REG_DDI1_EXT38_BASE) + (0x0A<<1))
#define REG_DDI1_EXT38_0B                 ((REG_DDI1_EXT38_BASE) + (0x0B<<1))
#define REG_DDI1_EXT38_0C                 ((REG_DDI1_EXT38_BASE) + (0x0C<<1))
#define REG_DDI1_EXT38_0E                 ((REG_DDI1_EXT38_BASE) + (0x0E<<1))
#define REG_DDI1_EXT38_20                 ((REG_DDI1_EXT38_BASE) + (0x20<<1))
#define REG_DDI1_EXT38_21                 ((REG_DDI1_EXT38_BASE) + (0x21<<1))
#define REG_DDI1_EXT38_22                 ((REG_DDI1_EXT38_BASE) + (0x22<<1))
#define REG_DDI1_EXT38_23                 ((REG_DDI1_EXT38_BASE) + (0x23<<1))
#define REG_DDI1_EXT38_24                 ((REG_DDI1_EXT38_BASE) + (0x24<<1))
#define REG_DDI1_EXT38_25                 ((REG_DDI1_EXT38_BASE) + (0x25<<1))
#define REG_DDI1_EXT38_26                 ((REG_DDI1_EXT38_BASE) + (0x26<<1))
#define REG_DDI1_EXT38_27                 ((REG_DDI1_EXT38_BASE) + (0x27<<1))
#define REG_DDI1_EXT38_40                 ((REG_DDI1_EXT38_BASE) + (0x40<<1))
#define REG_DDI1_EXT38_41                 ((REG_DDI1_EXT38_BASE) + (0x41<<1))

#endif
