//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////
//==============================================================================
// [mhal_mux.c]
// Date: 20090220
// Descriptions: Add a new mux layer for HW setting
//==============================================================================

#define  MHAL_MUX_C


//-------------------------------------------------------------------------------------------------
//  Include Files
//-------------------------------------------------------------------------------------------------

// Common Definition
#include "MsCommon.h"
#include "MsOS.h"
#include "mhal_xc_chip_config.h"
#include "utopia_dapi.h"
// Registers
#include "drvXC_IOPort.h"
#include "xc_hwreg_utility2.h"
#include "hwreg_adc_atop.h"
#include "hwreg_adc_dtop.h"
//#include "hwreg_chiptop.h"
#include "hwreg_hdmi.h"
#include "hwreg_pm_sleep.h"//alex_tung
#include "hwreg_ipmux.h"

#include "apiXC.h"

#include "xc_Analog_Reg.h"

#include "mhal_mux.h"
#include "drv_sc_display.h"
#include "drv_sc_isr.h"
#include "apiXC_Adc.h"
#include "apiXC_Auto.h"
#include "apiXC_PCMonitor.h"
#include "apiXC_ModeParse.h"
#include "drvXC_ADC_Internal.h"
#if (LD_ENABLE==1)
#include "mdrv_ld.h"
#include "mdrv_ldalgo.h"
#endif
#include "mdrv_sc_3d.h"
#include "drv_sc_menuload.h"
#include "mvideo_context.h"
#include "drv_sc_ip.h"
#include "mhal_adc.h"
#include "drvXC_HDMI_if.h"
#include "drvXC_HDMI_Internal.h"
#include "mhal_sc.h"
#include "mhal_hdmi.h"
#if FRC_INSIDE
#include "mdrv_frc.h"
#include "mhal_frc.h"
#endif
#include "XC_private.h"
#include "drv_sc_mux.h"
//-------------------------------------------------------------------------------------------------
//  Driver Compiler Options
//-------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------
//  Local Defines
//-------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------
//  Local Structures
//-------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------
//  Global Variables
//-------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------
//  Local Variables
//-------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------
//  Debug Functions
//-------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------
//  Local Functions
//-------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------
//  Global Functions
//-------------------------------------------------------------------------------------------------


/******************************************************************************/
/// MUX
/******************************************************************************/
void Hal_SC_mux_set_dvi_mux(void *pInstance, MS_U8 PortId, E_OUTPUT_PORT_TYPE enDstPort)
{
    //DVI port 0: input A
    //DVI port 1: input B
    //DVI port 2: input C
    //DVI port 3: input D

    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(pXCResourcePrivate->stdrvXC_MVideo_Context.g_bIsIMMESWITCH)
    {
        if(PortId==HAL_DVI_IP_A) // DVI port 0
        {
            // Setup display port
            //W2BYTEMSK(REG_HDMI2_DUAL_0_50_L, 0, BMASK(1:0)); // switch display port to port 0
            W2BYTEMSK(REG_COMBO_GP_TOP_4B_L, 0, BMASK(1:0)); // switch audio data path to port 0
            W2BYTEMSK(REG_COMBO_GP_TOP_08_L, 0, BMASK(1:0)); // switch audio clock path to port 0
            W2BYTEMSK(REG_COMBO_GP_TOP_06_L, 0, BMASK(7:6)); // switch EM packet clock path to port 0
            W2BYTEMSK(REG_COMBO_GP_TOP_68_L, (4 << 8), BMASK(10:8)); // switch EM packet data path to port 0
        }
        else if(PortId==HAL_DVI_IP_B) // DVI port 1
        {
            // Setup display port
            //W2BYTEMSK(REG_HDMI2_DUAL_0_50_L, BIT(0), BMASK(1:0)); // switch display port to port 1
            W2BYTEMSK(REG_COMBO_GP_TOP_4B_L, BIT(0), BMASK(1:0)); // switch audio data path to port 1
            W2BYTEMSK(REG_COMBO_GP_TOP_08_L, BIT(0), BMASK(1:0)); // switch audio clock path to port 1
            W2BYTEMSK(REG_COMBO_GP_TOP_06_L, BIT(6), BMASK(7:6)); // switch EM packet clock path to port 1
            W2BYTEMSK(REG_COMBO_GP_TOP_68_L, (5 << 8), BMASK(10:8)); // switch EM packet data path to port 1
        }
        else if(PortId==HAL_DVI_IP_C) // DVI port 2
        {
            // Setup display port
            //W2BYTEMSK(REG_HDMI2_DUAL_0_50_L, BIT(1), BMASK(1:0)); // switch display port to port 2
            W2BYTEMSK(REG_COMBO_GP_TOP_4B_L, BIT(1), BMASK(1:0)); // switch audio data path to port 2
            W2BYTEMSK(REG_COMBO_GP_TOP_08_L, BIT(1), BMASK(1:0)); // switch audio clock path to port 2
            W2BYTEMSK(REG_COMBO_GP_TOP_06_L, BIT(7), BMASK(7:6)); // switch EM packet clock path to port 2
            W2BYTEMSK(REG_COMBO_GP_TOP_68_L, (6 << 8), BMASK(10:8)); // switch EM packet data path to port 2
        }
        else if(PortId==HAL_DVI_IP_D) // DVI port 3
        {
            // Setup display port
            //W2BYTEMSK(REG_HDMI2_DUAL_0_50_L, BMASK(1:0), BMASK(1:0)); // switch display port to port 3
            W2BYTEMSK(REG_COMBO_GP_TOP_4B_L, BMASK(1:0), BMASK(1:0)); // switch audio path data to port 3
            W2BYTEMSK(REG_COMBO_GP_TOP_08_L, BMASK(1:0), BMASK(1:0)); // switch audio clock path to port 3
            W2BYTEMSK(REG_COMBO_GP_TOP_06_L, BMASK(7:6), BMASK(7:6)); // switch EM packet clock path to port 3
            W2BYTEMSK(REG_COMBO_GP_TOP_68_L, (7 << 8), BMASK(10:8)); // switch EM packet data path to port 3
        }
    }
}

void MHal_XC_SetDviMux(void *pInstance, MS_U8 PortId)
{
    // DVI port 0: input A
    // DVI port 1: input B
    // DVI port 2: input C
    // DVI port 3: input D

    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(PortId < NUMBER_OF_DVI_PORT)
    {
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKDF_18_L, PortId, BMASK(1:0)); // source
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKDF_18_L, PortId<<2, BMASK(3:2)); // data
    }
}

MS_U8 MHal_XC_GetDviMux(void)
{
    return (MS_U8)SC_EXT_R2BYTEMSK(0, REG_SC_EXT_BKDF_18_L, BMASK(3:2));
}

void Hal_SC_mux_set_analog_mux(MS_U8 PortId)
{
    // 0x2501
    //W2BYTEMSK(REG_ADC_ATOP_01_L, PortId & 0x03, 0x03);
    return;
}

void Hal_SC_mux_set_mainwin_ip_mux(void *pInstance, MS_U8 u8Data_Mux, MS_U8 u8Clk_Mux)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    ///pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt = 0;
    if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
    {
        MS_U16 u16Delayms = 0;
        while((pXCResourcePrivate->sthal_Optee.op_tee_mux.bfire == TRUE) && u16Delayms < 200)
        {
            MsOS_DelayTask(1);
            u16Delayms++;
        }
        if (pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt < OP_TEE_XC_REG_MAX_CNT)
        {
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_data[pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt].bk = REG_IPMUX_01_L;
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_data[pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt].value = (u8Data_Mux << 4) | (MDrv_ReadRegBit(REG_IPMUX_01_L, 0x0F));
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_data[pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt].mask = 0xFF;
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt++;
        }
        else
        {
            printf("op_tee_mux.regs_cnt too small\n");
        }
    }
    MDrv_WriteByteMask(REG_IPMUX_01_L, u8Data_Mux << 4, 0xF0);
    MDrv_WriteByteMask(REG_CKG_IDCLK2, u8Clk_Mux << 2, CKG_IDCLK2_MASK);
}

MS_BOOL Hal_SC_mux_get_mainwin_ip_mux(void *pInstance, MS_U8 *pU8Data_Mux, MS_U8 *pU8Clk_Mux)
{
    MS_BOOL bRet = FALSE;
    if(pU8Data_Mux && pU8Clk_Mux)
    {
        *pU8Data_Mux = (MDrv_ReadRegBit(REG_IPMUX_01_L, 0xF0)) >> 4;
        *pU8Clk_Mux = (MDrv_ReadRegBit(REG_CKG_IDCLK2, CKG_IDCLK2_MASK)) >> 2;
        bRet = TRUE;
    }
    else
    {
        bRet = FALSE;
    }
    return bRet;
}

void Hal_SC_set_subwin_ip_mux(void *pInstance, MS_U8 u8Data_Mux, MS_U8 u8Clk_Mux)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    ///pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt = 0;
    if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
    {
        MS_U16 u16Delayms = 0;
        while((pXCResourcePrivate->sthal_Optee.op_tee_mux.bfire == TRUE) && u16Delayms < 200)
        {
            MsOS_DelayTask(1);
            u16Delayms++;
        }
        if (pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt < OP_TEE_XC_REG_MAX_CNT)
        {
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_data[pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt].bk = REG_IPMUX_01_L;
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_data[pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt].value = (u8Data_Mux | ((MDrv_ReadRegBit(REG_IPMUX_01_L, 0xF0))<<4));
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_data[pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt].mask = 0xFF;
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt++;
        }
        else
        {
            printf("op_tee_mux.regs_cnt too small\n");
        }
    }
    MDrv_WriteByteMask(REG_IPMUX_01_L, u8Data_Mux, 0x0F);
    MDrv_WriteByteMask(REG_CKG_IDCLK1, u8Clk_Mux << 2, CKG_IDCLK1_MASK);
}

void Hal_SC_mux_set_dipwin_ip_mux(void *pInstance, MS_U8 u8Data_Mux, MS_U8 u8Clk_Mux)
{
    MDrv_WriteByteMask(REG_IPMUX_02_L, u8Data_Mux << 4, 0xF0);
    MDrv_WriteByteMask(REG_CKG_IDCLK3, u8Clk_Mux << 2, CKG_IDCLK3_MASK);
}

void Hal_SC2_mux_set_mainwin_ip_mux(void *pInstance, MS_U8 u8Data_Mux, MS_U8 u8Clk_Mux)
{
    printf("[%s][%d]U8Data_Mux=%x, U8Clk_Mux=%x\n", __FUNCTION__, __LINE__, u8Data_Mux, u8Clk_Mux);
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    ////pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt = 0;
    if (MDrv_XC_OPTEE_IsAnyPipe_Active(pInstance))
    {
        MS_U16 u16Delayms = 0;
        while((pXCResourcePrivate->sthal_Optee.op_tee_mux.bfire == TRUE) && u16Delayms < 200)
        {
            MsOS_DelayTask(1);
            u16Delayms++;
        }
        if (pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt < OP_TEE_XC_REG_MAX_CNT)
        {
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_data[pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt].bk = REG_IPMUX_61_L;
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_data[pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt].value = (u8Data_Mux << 4);
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_data[pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt].mask = 0xF0;
            pXCResourcePrivate->sthal_Optee.op_tee_mux.regs_cnt++;
        }
        else
        {
            printf("op_tee_mux.regs_cnt too small\n");
        }
    }
    MDrv_WriteByteMask(REG_IPMUX_61_L, u8Data_Mux << 4, 0xF0);
    MDrv_WriteByteMask(REG_CKG_S2_IDCLK2, u8Clk_Mux << 2, CKG_S2_IDCLK2_MASK);
    // open idclk
    MDrv_WriteRegBit(REG_CKG_S2_IDCLK2, DISABLE, CKG_S2_IDCLK2_GATED);
}

MS_BOOL Hal_SC2_mux_get_mainwin_ip_mux(void *pInstance, MS_U8 *pU8Data_Mux, MS_U8 *pU8Clk_Mux)
{
    MS_BOOL bRet = FALSE;

    if(pU8Data_Mux && pU8Clk_Mux)
    {
        *pU8Data_Mux = (MDrv_ReadRegBit(REG_IPMUX_61_L, 0xF0)) >> 4;
        *pU8Clk_Mux = (MDrv_ReadRegBit(REG_CKG_S2_IDCLK2, CKG_S2_IDCLK2_MASK)) >> 2;
        bRet = TRUE;
    }
    else
    {
        bRet = FALSE;
    }

    return bRet;
}

// Used for backward compatibility
void Hal_SC_set_sync_port_by_dataport(void *pInstance, E_MUX_INPUTPORT src_port )
{
    E_MUX_INPUTPORT sync_port;
    switch ( src_port)
    {
        case INPUT_PORT_ANALOG0:
            sync_port = INPUT_PORT_ANALOG0_SYNC;
            break;

        case INPUT_PORT_ANALOG1:
            sync_port = INPUT_PORT_ANALOG1_SYNC;
            break;

        case INPUT_PORT_ANALOG2:
            sync_port = INPUT_PORT_ANALOG2_SYNC;
            break;
        default:
            sync_port = INPUT_PORT_ANALOG0_SYNC;
    }
    // Src -> ( IPmux )
    Hal_ADC_set_mux(pInstance, sync_port);
}
/******************************************************************************/
///Dispatch Port
///@param src \b IN: source type
///@param dest \b IN: pixel clock
/******************************************************************************/
void Hal_SC_mux_dispatch(void *pInstance, E_MUX_INPUTPORT src_port , E_MUX_OUTPUTPORT dest_port)
{
    MS_U8 _src = (MS_U8) src_port;
    MS_U8 _dest = (MS_U8) dest_port;

    SC_IDCLK_TYPE enSC0HdmiIndex = SC_CLK_HDMI_DVI_P0;
    SC2_IDCLK_TYPE enSC2HdmiIndex  = SC2_CLK_HDMI_DVI_P0;

    // Hal level in T2 is following MsCommon.h directly.
    // It is unnecessary to add a mapping function.
    E_INPUT_PORT_TYPE src = (E_INPUT_PORT_TYPE) _src;
    E_OUTPUT_PORT_TYPE dest = (E_OUTPUT_PORT_TYPE) _dest;

    printf("[%s][%d]src_port=%u, dest_port=%u\n", __FUNCTION__, __LINE__, src_port , dest_port);

#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP == TRUE)
    if (!(src >= HAL_INPUTPORT_ANALOG_SYNC0 && src < (HAL_INPUTPORT_ANALOG_SYNC0 + NUMBER_OF_ANALOG_PORT)) &&
        !(src >= HAL_INPUTPORT_ANALOG0 && src < (HAL_INPUTPORT_ANALOG0 + NUMBER_OF_ANALOG_PORT)))
    {
        //set adc mux to ypbpr at beginning for fss
        MS_U8 u8Port_count = 0, u8Index = 0 ;
        E_MUX_INPUTPORT enPorts[3] = {INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT};

        MDrv_XC_Mux_GetPort(pInstance, INPUT_SOURCE_YPBPR , enPorts , &u8Port_count );

        for (u8Index = 0 ;u8Index < u8Port_count ; u8Index++ )
        {
            Hal_ADC_set_mux(pInstance, enPorts[u8Index]);
        }
    }
#endif

    // If src is sync port. set adc only.
    if ( src >= HAL_INPUTPORT_ANALOG_SYNC0 && src < (HAL_INPUTPORT_ANALOG_SYNC0 + NUMBER_OF_ANALOG_PORT ) )
    {
        Hal_ADC_set_mux(pInstance, src_port);
    }

    // Src = Analog 0ort 0 ~ Max number of analog port
    else if ( src >= HAL_INPUTPORT_ANALOG0  && src < (HAL_INPUTPORT_ANALOG0 + NUMBER_OF_ANALOG_PORT ))
    {
#if (PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB == 0)
        // For Monaco VGA source unstable/nosignal issue
        if (MDrv_ReadByte(REG_CHIP_REVISION) < 1)// Monaco U02 will fix this.
        {
            SCALER_WIN eWindow = MAIN_WINDOW;
            if (dest == HAL_OUTPUTPORT_SCALER_SUB_WINDOW1 )
            {
                eWindow = SUB_WINDOW;
            }
            MDrv_XC_CheckSubWinForFSS(pInstance, &eWindow);
            Hal_SC_ip_set_input_sync_sample_mode(pInstance, GLITCH_REMOVAL, eWindow );
        }
#endif
        // Src -> ( IPmux )
        Hal_ADC_set_mux(pInstance, src_port);

        // IPmux -> Dest
        if ( dest == HAL_OUTPUTPORT_SCALER_MAIN_WINDOW )
        {
            Hal_SC_mux_set_mainwin_ip_mux(pInstance, SC_MAINWIN_IPMUX_ADC_A, SC_CLK_ADC_A);
        }
        else if (dest == HAL_OUTPUTPORT_SCALER_SUB_WINDOW1 )
        {
            Hal_SC_set_subwin_ip_mux(pInstance, SC_SUBWIN_IPMUX_ADC_A, SC_CLK_ADC_A);
        }
        else if (dest == HAL_OUTPUTPORT_DIP_WINDOW)
        {
            Hal_SC_mux_set_dipwin_ip_mux(pInstance, SC_DWIN_IPMUX_ADC_A, SC_CLK_ADC_A);
        }
        else if ( dest == HAL_OUTPUTPORT_SCALER2_MAIN_WINDOW )
        {
            Hal_SC2_mux_set_mainwin_ip_mux(pInstance, SC2_MAINWIN_IPMUX_ADC_A, SC2_CLK_ADC_A);
        }
        else
        {
            //Undefined
        }

    }

    // Src = Y mux port 0 ~ Max number of Y mux port
    else if (  src >= HAL_INPUTPORT_YMUX_CVBS0 && src < (HAL_INPUTPORT_YMUX_CVBS0 + NUMBER_OF_CVBS_PORT) )
    {
        // IPmux -> Dest
        if ( dest == HAL_OUTPUTPORT_SCALER_MAIN_WINDOW )
        {
            Hal_SC_mux_set_mainwin_ip_mux(pInstance, SC_MAINWIN_IPMUX_VD, SC_CLK_VD);
            // Src -> ( IPmux )
            Hal_ADC_set_mux(pInstance, src_port);
        }
        else if (dest == HAL_OUTPUTPORT_SCALER_SUB_WINDOW1 )
        {
            Hal_SC_set_subwin_ip_mux(pInstance, SC_SUBWIN_IPMUX_VD , SC_CLK_VD);
            // Src -> ( IPmux )
            Hal_ADC_set_mux(pInstance, src_port);
        }
        else if ( dest == HAL_OUTPUTPORT_CVBS1 )
        {
            Hal_ADC_set_CVBSOMux(pInstance, E_ADC_CVBSO_PORT_1, src_port);
        }
        else if ( dest == HAL_OUTPUTPORT_CVBS2 )
        {
            Hal_ADC_set_CVBSOMux(pInstance, E_ADC_CVBSO_PORT_2, src_port);
        }
        else if (dest == HAL_OUTPUTPORT_DIP_WINDOW)
        {
            Hal_SC_mux_set_dipwin_ip_mux(pInstance, SC_DWIN_IPMUX_VD, SC_CLK_VD);
            // Src -> ( IPmux )
            Hal_ADC_set_mux(pInstance, src_port);
        }
        else if ( dest == HAL_OUTPUTPORT_SCALER2_MAIN_WINDOW )
        {
            Hal_SC2_mux_set_mainwin_ip_mux(pInstance, SC2_MAINWIN_IPMUX_VD, SC2_CLK_VD);
            // Src -> ( IPmux )
            Hal_ADC_set_mux(pInstance, src_port);
        }
        else
        {
            Hal_ADC_set_mux(pInstance, src_port);
        }
    }

    // Src = C mux port 0 ~ Max number of C mux port
    else if ( src >= HAL_INPUTPORT_CMUX_CVBS0 && src < (HAL_INPUTPORT_CMUX_CVBS0 + NUMBER_OF_CVBS_PORT) )
    {
        // IPmux -> Dest
        if ( dest == HAL_OUTPUTPORT_SCALER_MAIN_WINDOW )
        {
            // Src -> ( IPmux )
            Hal_ADC_set_mux(pInstance, src_port);
            ; // Controlled by Ymux
        }
        else if (dest == HAL_OUTPUTPORT_SCALER_SUB_WINDOW1 )
        {
            // Src -> ( IPmux )
            Hal_ADC_set_mux(pInstance, src_port);
            ; // Controlled by Ymux
        }
        else if ( dest == HAL_OUTPUTPORT_CVBS1 )
        {
            Hal_ADC_set_CVBSOMux(pInstance, E_ADC_CVBSO_PORT_1, src_port);
        }
        else if ( dest == HAL_OUTPUTPORT_CVBS2 )
        {
            Hal_ADC_set_CVBSOMux(pInstance, E_ADC_CVBSO_PORT_2, src_port);
        }
        else if ( dest == HAL_OUTPUTPORT_DIP_WINDOW )
        {
            // Src -> ( IPmux )
            Hal_ADC_set_mux(pInstance, src_port);
            // Controlled by Ymux
        }
		else if ( dest == HAL_OUTPUTPORT_SCALER2_MAIN_WINDOW )
		{
			// Src -> ( IPmux )
			Hal_ADC_set_mux(pInstance, src_port);
			; // Controlled by Ymux
		}
        else
        {
            // Src -> ( IPmux )
            Hal_ADC_set_mux(pInstance, src_port);
            //Undefined
        }

    }

    // Src = DVI port 0 ~ Max number of DVI port
    else if ( src >= HAL_INPUTPORT_DVI0 && src < (HAL_INPUTPORT_DVI0 + NUMBER_OF_DVI_PORT) )
    {
        printf("[%s][%d]\n", __FUNCTION__, __LINE__);
        // Src -> ( IPmux )
        MHal_XC_SetDviMux(pInstance, src - HAL_INPUTPORT_DVI0);
        Hal_SC_mux_set_dvi_mux(pInstance, src - HAL_INPUTPORT_DVI0, dest); //alex_tung

#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        switch(src)
        {
            case HAL_INPUTPORT_DVI0:
                enSC0HdmiIndex  = SC_CLK_HDMI_DVI_P0;
                enSC2HdmiIndex  = SC2_CLK_HDMI_DVI_P0;
                break;
            case HAL_INPUTPORT_DVI1:
                enSC0HdmiIndex = SC_CLK_HDMI_DVI_P1;
                enSC2HdmiIndex = SC2_CLK_HDMI_DVI_P1;
                break;
            case HAL_INPUTPORT_DVI2:
                enSC0HdmiIndex = SC_CLK_HDMI_DVI_P2;
                enSC2HdmiIndex = SC2_CLK_HDMI_DVI_P2;
                break;
            case HAL_INPUTPORT_DVI3:
                enSC0HdmiIndex = SC_CLK_HDMI_DVI_P3;
                enSC2HdmiIndex = SC2_CLK_HDMI_DVI_P3;
                break;
            default:
                enSC0HdmiIndex = SC_CLK_HDMI_DVI_P0;
                enSC2HdmiIndex = SC2_CLK_HDMI_DVI_P0;
                break;
        }
#else
        enSC0HdmiIndex  = SC_CLK_HDMI_DVI;
        enSC2HdmiIndex  = SC2_CLK_HDMI_DVI;
#endif

        // IPmux -> Dest
        if ( dest == HAL_OUTPUTPORT_SCALER_MAIN_WINDOW )
        {
            Hal_SC_mux_set_mainwin_ip_mux(pInstance, SC_MAINWIN_IPMUX_HDMI_DVI, enSC0HdmiIndex);
        }
        else if (dest == HAL_OUTPUTPORT_SCALER_SUB_WINDOW1 )
        {
            Hal_SC_set_subwin_ip_mux(pInstance, SC_SUBWIN_IPMUX_HDMI_DVI, enSC0HdmiIndex);
        }
        else if (dest == HAL_OUTPUTPORT_DIP_WINDOW )
        {
            Hal_SC_mux_set_dipwin_ip_mux(pInstance, SC_DWIN_IPMUX_HDMI_DVI , enSC0HdmiIndex);
        }
        else if ( dest == HAL_OUTPUTPORT_SCALER2_MAIN_WINDOW )
        {
            Hal_SC2_mux_set_mainwin_ip_mux(pInstance, SC2_MAINWIN_IPMUX_HDMI_DVI, enSC2HdmiIndex);
        }
        else
        {
            // Undefeined
        }
    }

    else if ( src >= HAL_INPUTPORT_MVOP && src < (HAL_INPUTPORT_MVOP + NUMBER_OF_MVOP_PORT) )
    {
        // Src -> ( IPmux )
        // No source mux need to set in T2 (only one MVD).

        // IPmux -> Dest
        if ( dest == HAL_OUTPUTPORT_SCALER_MAIN_WINDOW )
        {
            if (src == HAL_INPUTPORT_MVOP)
                Hal_SC_mux_set_mainwin_ip_mux(pInstance, SC_MAINWIN_IPMUX_MVOP, SC_CLK_DC0);
            else if (src == HAL_INPUTPORT_MVOP2)
                Hal_SC_mux_set_mainwin_ip_mux(pInstance, SC_MAINWIN_IPMUX_MVOP2, SC_CLK_DC1);

        }
        else if (dest == HAL_OUTPUTPORT_SCALER_SUB_WINDOW1 )
        {
            if (src == HAL_INPUTPORT_MVOP)
                Hal_SC_set_subwin_ip_mux(pInstance, SC_SUBWIN_IPMUX_MVOP , SC_CLK_DC0);
            else if (src == HAL_INPUTPORT_MVOP2)
                Hal_SC_set_subwin_ip_mux(pInstance, SC_SUBWIN_IPMUX_MVOP2 , SC_CLK_DC1);

        }
        else if (dest == HAL_OUTPUTPORT_DIP_WINDOW )
        {
            if (src == HAL_INPUTPORT_MVOP)
                Hal_SC_mux_set_dipwin_ip_mux(pInstance, SC_DWIN_IPMUX_MVOP , SC_CLK_DC0);
            else if (src == HAL_INPUTPORT_MVOP2)
                Hal_SC_mux_set_dipwin_ip_mux(pInstance, SC_DWIN_IPMUX_MVOP2 , SC_CLK_DC1);
        }
        else if ( dest == HAL_OUTPUTPORT_SCALER2_MAIN_WINDOW )
        {
            if (src == HAL_INPUTPORT_MVOP)
                Hal_SC2_mux_set_mainwin_ip_mux(pInstance, SC2_MAINWIN_IPMUX_MVOP, SC2_CLK_DC0);
            else if (src == HAL_INPUTPORT_MVOP2)
                Hal_SC2_mux_set_mainwin_ip_mux(pInstance, SC2_MAINWIN_IPMUX_MVOP2, SC2_CLK_DC1);

        }
        else
        {
            // Undefeined ( set in ADC table )
        }

    }
    else if( src >= HAL_INPUTPORT_YMUX_RY0 && src < (HAL_INPUTPORT_YMUX_RY0 + NUMBER_OF_RY_PORT))
    {
       // IPmux -> Dest
        if ( dest == HAL_OUTPUTPORT_SCALER_MAIN_WINDOW )
        {
            Hal_ADC_set_mux(pInstance,src_port);
        }
        else if (dest == HAL_OUTPUTPORT_SCALER_SUB_WINDOW1 )
        {
            Hal_ADC_set_mux(pInstance,src_port);
        }
        else if ( dest == HAL_OUTPUTPORT_CVBS1 )
        {
            Hal_ADC_set_CVBSOMux(pInstance,E_ADC_CVBSO_PORT_1, src_port);
        }
        else if ( dest == HAL_OUTPUTPORT_CVBS2 )
        {
            Hal_ADC_set_CVBSOMux(pInstance,E_ADC_CVBSO_PORT_2, src_port);
        }
        else
        {
            Hal_ADC_set_mux(pInstance,src_port);
        }
    }
    else if ( src >= HAL_INPUTPORT_SCALER_OP && src < (HAL_INPUTPORT_SCALER_OP + NUMBER_OF_SCALER_OP_PORT) )
    {
        // Src -> ( IPmux )

        // IPmux -> Dest
        if ( dest == HAL_OUTPUTPORT_SCALER_MAIN_WINDOW )
        {
            Hal_SC_mux_set_mainwin_ip_mux(pInstance, SC_MAINWIN_IPMUX_CAPTURE, SC_CLK_ODCLK);
        }
        else if (dest == HAL_OUTPUTPORT_SCALER_SUB_WINDOW1 )
        {
            Hal_SC_set_subwin_ip_mux(pInstance, SC_SUBWIN_IPMUX_CAPTURE, SC_CLK_ODCLK);
        }
        else if (dest == HAL_OUTPUTPORT_DIP_WINDOW )
        {
            Hal_SC_mux_set_dipwin_ip_mux(pInstance, SC_DWIN_IPMUX_CAPTURE , SC_CLK_ODCLK);
        }
        else if ( dest == HAL_OUTPUTPORT_SCALER2_MAIN_WINDOW )
        {
            Hal_SC2_mux_set_mainwin_ip_mux(pInstance, SC2_MAINWIN_IPMUX_CAPTURE, SC2_CLK_ODCLK);
        }
        else
        {
            // Undefeined
        }
    }
}
void Hal_SC_EnableCLK_for_DIP(void *pInstance, MS_BOOL bEnable)
{
    // Enable DIP window clock
     if(bEnable)
     {
         // Enable IDClk3
         MDrv_WriteRegBit(REG_CKG_IDCLK3, DISABLE, CKG_IDCLK3_INVERT);                   // Not Invert
         MDrv_WriteRegBit(REG_CKG_IDCLK3, DISABLE, CKG_IDCLK3_GATED);                    // Enable clock
     }
     else
     {
         // Disable IDClk3
         MDrv_WriteRegBit(REG_CKG_IDCLK3, ENABLE, CKG_IDCLK3_INVERT);                   // Not Invert
         MDrv_WriteRegBit(REG_CKG_IDCLK3, ENABLE, CKG_IDCLK3_GATED);                    // Enable clock
     }
}

/******************************************************************************/
///This function set Scaler Index Information to ADC.let ADC send correct data to scaler.
///@param  u8ScalerIndex \b Scaler Index.
/******************************************************************************/
void Hal_SC_mux_SetScalerIndexInformationToADC(void *UNUSED_PARA(pInstance), MS_U8 UNUSED_PARA(u8ScalerIndex), MS_U16 UNUSED_PARA(u16InputSourceType))
{
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
    W2BYTEMSK(REG_IPMUX_35_L, u8ScalerIndex , BIT(0));
#endif
}

EN_XC_INPUT_FSS_TYPE MHal_XC_GetFSSMuxPort(void *pInstance, E_INPUT_PORT_TYPE enSrcPort)
{
    MS_U8 _u8Src = (MS_U8) enSrcPort;
    E_INPUT_PORT_TYPE enSrc = (E_INPUT_PORT_TYPE) _u8Src;

    EN_XC_INPUT_FSS_TYPE enSrcType = E_XC_INPUT_FSS_MAX;

    if((enSrc >= HAL_INPUTPORT_ANALOG0) && (enSrc < (HAL_INPUTPORT_ANALOG0 + NUMBER_OF_ANALOG_PORT)))
    {
        enSrcType = E_XC_INPUT_FSS_ADCA;
    }
    else if((enSrc >= HAL_INPUTPORT_ANALOG_SYNC0) && (enSrc < (HAL_INPUTPORT_ANALOG_SYNC0 + NUMBER_OF_ANALOG_SYNC_PORT)))
    {
        ///in original case, this case only dump adc table.
        ///in FSS case, switch to adc mux
        enSrcType = E_XC_INPUT_FSS_ADCA;
    }
    else if(enSrc == HAL_INPUTPORT_DVI0)
    {
        enSrcType = E_XC_INPUT_FSS_HDMI_P0;
    }
    else if(enSrc == HAL_INPUTPORT_DVI1)
    {
        enSrcType = E_XC_INPUT_FSS_HDMI_P1;
    }
    else if(enSrc == HAL_INPUTPORT_DVI2)
    {
        enSrcType = E_XC_INPUT_FSS_HDMI_P2;
    }
    else if(enSrc == HAL_INPUTPORT_DVI3)
    {
        enSrcType = E_XC_INPUT_FSS_HDMI_P3;
    }
    else if((enSrc >= HAL_INPUTPORT_YMUX_CVBS0) && (enSrc < (HAL_INPUTPORT_YMUX_CVBS0 + NUMBER_OF_CVBS_PORT)))
    {
        enSrcType = E_XC_INPUT_FSS_VD;
    }
    else if(enSrc == HAL_INPUTPORT_MVOP)
    {
        enSrcType = E_XC_INPUT_FSS_MVOP0;
    }
    else if(enSrc == HAL_INPUTPORT_MVOP2)
    {
        enSrcType = E_XC_INPUT_FSS_MVOP1;
    }
    else
    {
        enSrcType = E_XC_INPUT_FSS_MAX;
    }

    return enSrcType;
}

EN_XC_INPUT_FSS_TYPE MHal_XC_InputSrcToFssSrc(void *pInstance, INPUT_SOURCE_TYPE_t enInputSrcType)
{
    EN_XC_INPUT_FSS_TYPE enFSSSrcType = E_XC_INPUT_FSS_MAX;

    switch(enInputSrcType)
    {
        case INPUT_SOURCE_VGA:
        case INPUT_SOURCE_VGA2:
        case INPUT_SOURCE_VGA3:
        case INPUT_SOURCE_YPBPR:
        case INPUT_SOURCE_YPBPR2:
        case INPUT_SOURCE_YPBPR3:
            enFSSSrcType = E_XC_INPUT_FSS_ADCA;
            break;
        case INPUT_SOURCE_YPBPR_MAX:
            enFSSSrcType = E_XC_INPUT_FSS_ADC_OFFLINE;
            break;
        case INPUT_SOURCE_HDMI:
        case INPUT_SOURCE_DVI:
        case INPUT_SOURCE_HDMI2:
        case INPUT_SOURCE_DVI2:
        case INPUT_SOURCE_HDMI3:
        case INPUT_SOURCE_DVI3:
        case INPUT_SOURCE_HDMI4:
        case INPUT_SOURCE_DVI4:
        {
            E_MUX_INPUTPORT enMuxPort = INPUT_PORT_NONE_PORT;

            enMuxPort = MDrv_XC_Mux_GetHDMIPort(pInstance, enInputSrcType);
            enFSSSrcType = MHal_XC_GetFSSMuxPort(pInstance, (E_INPUT_PORT_TYPE)enMuxPort);
            break;
        }
        case INPUT_SOURCE_TV:
        case INPUT_SOURCE_CVBS:
        case INPUT_SOURCE_CVBS2:
        case INPUT_SOURCE_CVBS3:
        case INPUT_SOURCE_CVBS4:
        case INPUT_SOURCE_CVBS5:
        case INPUT_SOURCE_CVBS6:
        case INPUT_SOURCE_CVBS7:
        case INPUT_SOURCE_CVBS8:
        case INPUT_SOURCE_SVIDEO:
        case INPUT_SOURCE_SVIDEO2:
        case INPUT_SOURCE_SVIDEO3:
        case INPUT_SOURCE_SVIDEO4:
        case INPUT_SOURCE_SCART:
        case INPUT_SOURCE_SCART2:
            enFSSSrcType = E_XC_INPUT_FSS_VD;
            break;
        case INPUT_SOURCE_DTV:
        case INPUT_SOURCE_STORAGE:
        case INPUT_SOURCE_KTV:
        case INPUT_SOURCE_JPEG:
            enFSSSrcType = E_XC_INPUT_FSS_MVOP0;
            break;
        case INPUT_SOURCE_DTV2:
        case INPUT_SOURCE_STORAGE2:
            enFSSSrcType = E_XC_INPUT_FSS_MVOP1;
            break;
        default:
            enFSSSrcType = E_XC_INPUT_FSS_MAX;
            break;
    }

    return enFSSSrcType;
}

INPUT_SOURCE_TYPE_t MHal_XC_FssSrcToInputSrc(void *pInstance, EN_XC_INPUT_FSS_TYPE enFssSrc)
{
    INPUT_SOURCE_TYPE_t enInputSrcType = INPUT_SOURCE_NONE;

    switch(enFssSrc)
    {
        case E_XC_INPUT_FSS_ADCA:
            enInputSrcType = INPUT_SOURCE_YPBPR;
            break;
        case E_XC_INPUT_FSS_HDMI_P0:
        case E_XC_INPUT_FSS_HDMI_P1:
        case E_XC_INPUT_FSS_HDMI_P2:
        case E_XC_INPUT_FSS_HDMI_P3:
        {
            E_INPUT_PORT_TYPE enMuxPort = HAL_INPUTPORT_NONE;
            INPUT_SOURCE_TYPE_t enInputSourcePort = INPUT_SOURCE_HDMI;

            //Transfer FSS port to corresponding MUX port
            if(enFssSrc == E_XC_INPUT_FSS_HDMI_P0)
            {
                enMuxPort = HAL_INPUTPORT_DVI0;
            }
            else if(enFssSrc == E_XC_INPUT_FSS_HDMI_P1)
            {
                enMuxPort = HAL_INPUTPORT_DVI1;
            }
            else if(enFssSrc == E_XC_INPUT_FSS_HDMI_P2)
            {
                enMuxPort = HAL_INPUTPORT_DVI2;
            }
            else
            {
                enMuxPort = HAL_INPUTPORT_DVI3;
            }

            //Transfer MUX port to corresponding Input Source port
            for(enInputSourcePort = INPUT_SOURCE_HDMI; enInputSourcePort <= INPUT_SOURCE_HDMI4; enInputSourcePort++)
            {
                if(MDrv_XC_Mux_GetHDMIPort(pInstance, enInputSourcePort) == enMuxPort)
                {
                    enInputSrcType = enInputSourcePort;
                }
            }
            break;
        }
        case E_XC_INPUT_FSS_VD:
            enInputSrcType = INPUT_SOURCE_TV;
            break;
        case E_XC_INPUT_FSS_MVOP0:
            enInputSrcType = INPUT_SOURCE_DTV;
            break;
        case E_XC_INPUT_FSS_MVOP1:
            enInputSrcType = INPUT_SOURCE_DTV2;
            break;
        case E_XC_INPUT_FSS_ADC_OFFLINE:
            enInputSrcType = INPUT_SOURCE_YPBPR_MAX;
            break;
        default:
            enInputSrcType = INPUT_SOURCE_NONE;
            break;
    }
    return enInputSrcType;
}

/******************************************************************************/
///This function set Scaler Index
///@param
// IP1GP_enable 0x102E_73 [0]:SC0, [1]:SC2
/******************************************************************************/
MS_BOOL MHal_XC_IsFSSEnabled(void *pInstance, SCALER_WIN eWindow)
{
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    return pXCResourcePrivate->stdrvXC_MVideo_Context.bIsFSSEnabled;
#else
    return FALSE;
#endif
}

/******************************************************************************/
///This function set Scaler Index
///@param
// IP1GP_enable 0x102E_73 [0]:SC0, [1]:SC2
/******************************************************************************/
void MHal_XC_SetFSSEnable(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(psXCInstPri != NULL)
    {
        UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

        pXCResourcePrivate->stdrvXC_MVideo_Context.enFSSSrcType = INPUT_SOURCE_NONE;
        pXCResourcePrivate->stdrvXC_MVideo_Context.bIsFSSEnabled = bEnable;

        XC_LOG_TRACE(XC_DBGLEVEL_MUX, "u32DeviceID[%u] bEnable[%u]\n", psXCInstPri->u32DeviceID, bEnable);

#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
        if(psXCInstPri->u32DeviceID == E_XC_DEVICE1)
        {
            if(bEnable)
            {
                MDrv_WriteByteMask(REG_IPMUX_73_L, BIT(1), BIT(1));
                MDrv_WriteByteMask(REG_IPMUX_35_L, BIT(1), BIT(1));
            }
            else
            {
                MDrv_WriteByteMask(REG_IPMUX_73_L, 0x00, BIT(1));
                MDrv_WriteByteMask(REG_IPMUX_35_L, 0x00, BIT(1));
            }
        }
        else
#endif
        if(psXCInstPri->u32DeviceID == E_XC_DEVICE0)
        {
            if(bEnable)
            {
                MDrv_WriteByteMask(REG_IPMUX_73_L, BIT(0), BIT(0));
                MDrv_WriteByteMask(REG_IPMUX_35_L, BIT(1), BIT(1));
            }
            else
            {
                MDrv_WriteByteMask(REG_IPMUX_73_L, 0x00, BIT(0));
                MDrv_WriteByteMask(REG_IPMUX_35_L, 0x00, BIT(1));
            }
        }
    }

    return;
}

EN_XC_INPUT_FSS_TYPE genFSSSrcType[E_XC_DEVICE_MAX] = {E_XC_INPUT_FSS_MAX, E_XC_INPUT_FSS_MAX};

/******************************************************************************/
///This function get Scaler Index
///@param
// IP1GP_enable 0x102E_73 [0]:SC0, [1]:SC2
/******************************************************************************/
EN_XC_INPUT_FSS_TYPE MHal_XC_GetFssSource(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    EN_XC_INPUT_FSS_TYPE _enFSSSrcType = MHal_XC_InputSrcToFssSrc(pInstance, pXCResourcePrivate->stdrvXC_MVideo_Context.enFSSSrcType);

    if(_enFSSSrcType==E_XC_INPUT_FSS_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_FSS_TRANSFER, "u32DeviceID[%tu] enFSSSrcType[%u] genFssSrcType[%u]\n", (ptrdiff_t)(psXCInstPri->u32DeviceID), _enFSSSrcType, genFSSSrcType[psXCInstPri->u32DeviceID]);
        return genFSSSrcType[psXCInstPri->u32DeviceID];
    }
    else
    {
        XC_LOG_TRACE(XC_DBGLEVEL_FSS_TRANSFER, "u32DeviceID[%tu] enFSSSrcType[%u] genFssSrcType[%u]\n", (ptrdiff_t)(psXCInstPri->u32DeviceID), _enFSSSrcType, genFSSSrcType[psXCInstPri->u32DeviceID]);
        return _enFSSSrcType;
    }
}

/******************************************************************************/
///This function set Scaler Index
///@param
// reg_ipmux_sel 0x102E_71 [3:0]:SC0, [7:4]:SC2
/******************************************************************************/
void MHal_XC_SetFSSSource(void *pInstance, E_MUX_INPUTPORT enSrcPort, MS_BOOL bHDMI420)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(psXCInstPri != NULL)
    {
        XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
        UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
        EN_XC_INPUT_FSS_TYPE _enFSSSrcType = E_XC_INPUT_FSS_ADCA;   //initialize to 0

        if(bHDMI420 == TRUE)
        {
            if(IsFSSSrcTypeHDMI(genFSSSrcType[psXCInstPri->u32DeviceID]))
            {
                _enFSSSrcType = E_XC_INPUT_FSS_HDMI_420;
            }
            else
            {
                _enFSSSrcType = genFSSSrcType[psXCInstPri->u32DeviceID];
            }
        }
        else
        {
            genFSSSrcType[psXCInstPri->u32DeviceID] = MHal_XC_GetFSSMuxPort(pInstance, (MS_S32)enSrcPort);
            pXCResourcePrivate->stdrvXC_MVideo_Context.enFSSSrcType = MHal_XC_FssSrcToInputSrc(pInstance, genFSSSrcType[psXCInstPri->u32DeviceID]);
            _enFSSSrcType = genFSSSrcType[psXCInstPri->u32DeviceID];
        }

        XC_LOG_TRACE(XC_DBGLEVEL_MUX, "u32DeviceID[%lu] enSrcPort[%u] genFSSSrcType[%u] bHDMI420[%d\\n", psXCInstPri->u32DeviceID, enSrcPort, genFSSSrcType[psXCInstPri->u32DeviceID], bHDMI420);

        if(psXCInstPri->u32DeviceID == E_XC_DEVICE0)
        {
            if(IsFSSDisableType(_enFSSSrcType))
            {
                MDrv_WriteByteMask(REG_IPMUX_73_L, 0x00, BIT(0));
                MDrv_WriteByteMask(REG_IPMUX_35_L, 0x00, BIT(1));
            }
            else
            {
                MDrv_WriteByteMask(REG_IPMUX_73_L, BIT(0), BIT(0));
                MDrv_WriteByteMask(REG_IPMUX_35_L, BIT(1), BIT(1));
            }
            MDrv_WriteByteMask(REG_IPMUX_71_L, _enFSSSrcType , BMASK(3:0));
        }
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
        else //if(psXCInstPri->u32DeviceID == E_XC_DEVICE1)
        {
            if(IsFSSDisableType(_enFSSSrcType))
            {
                MDrv_WriteByteMask(REG_IPMUX_73_L, 0x00, BIT(1));
                MDrv_WriteByteMask(REG_IPMUX_35_L, 0x00, BIT(1));
            }
            else
            {
                MDrv_WriteByteMask(REG_IPMUX_73_L, BIT(1), BIT(1));
                MDrv_WriteByteMask(REG_IPMUX_35_L, BIT(1), BIT(1));
            }
            MDrv_WriteByteMask(REG_IPMUX_71_L, (_enFSSSrcType<<4) , BMASK(7:4));
        }
#endif
    }
    else
    {
        XC_LOG_TRACE(XC_DBGLEVEL_FSS_TRANSFER,"[MHal_XC_SetFSSSource] fail to set source! \n");
    }
}


#undef MHAL_MUX_C
