/*------------------------------------------------------------------------------
 * MediaTek Inc. (C) 2018. All rights reserved.
 *
 * Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to MediaTek Inc. and/or its licensors. Without
 * the prior written permission of MediaTek inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of MediaTek Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
 * SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
 * MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek
 * Software") have been modified by MediaTek Inc. All revisions are subject to
 * any receiver's applicable license agreements with MediaTek Inc.
 *----------------------------------------------------------------------------*/

#ifndef _API_AI_TYPE_H_
#define _API_AI_TYPE_H_

#ifdef __cplusplus
extern "C" {
#endif

#define AIPQ_MODEL_NUM_MAX                 (32)
#define AIPQ_SHM_MODEL_NAME_NUM_MAX      (32)

typedef struct
{
    MS_U8 u8FrameIndex;

    MS_U32 u32AICondition;
    /// is result update
    MS_BOOL bIsUpdate;
} ST_AIPQ_SHM_AIPQ_RESULT;

typedef struct
{
    MS_U32 u32Version;
    MS_U32 u32AIModelID;
    MS_U32 u32AIResultSize;
    MS_U32 u32AIResultCount;
}ST_AIPQ_SHM_BLOCK_HEADER;

typedef struct
{
    MS_U32 u32AIModelID;
    char chModelName[AIPQ_SHM_MODEL_NAME_NUM_MAX];
    MS_U32 u32BlockOffset;
}ST_AIPQ_SHM_BLOCK_INFO;

typedef struct
{
    MS_U32 u32Version;
    MS_U32 u32AIBlockNum;  // model id number
    ST_AIPQ_SHM_BLOCK_INFO stAIBlockInfo[AIPQ_MODEL_NUM_MAX];
}ST_AIPQ_SHM_COM_HEADER;

#ifdef __cplusplus
}
#endif

//------------------------------------------------------------------
#endif // _API_AIPQ_TYPE_H_
//------------------------------------------------------------------