/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to MediaTek Inc. and/or its licensors. Without
 * the prior written permission of MediaTek inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of MediaTek Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * Copyright  (C) [2020]  MediaTek Inc. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
 * SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
 * MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek
 * Software") have been modified by MediaTek Inc. All revisions are subject to
 * any receiver's applicable license agreements with MediaTek Inc.
 */

#include <common.h>
#include <command.h>
#include <debug_impl.h>
#include <smp/thread_info.h>
#include <smp/thread.h>

extern thread_t *panel_pre_init_thread_id;
extern thread_t *panel_mute_true_thread_id;
extern thread_t *panel_panel_enable_thread_id;
extern thread_t *panel_mute_false_thread_id;
extern thread_t *panel_post_init_thread_id;
extern thread_t *show_logo_thread_id;

void *panel_pre_init_thread_entry(void *args)
{
    int ret = -1;

    ret = run_command("panel_pre_init", 0);
    if (ret < 0)
    {
        UBOOT_ERROR("panel_pre_init command task execute failure.\n");
    }

    return NULL;
}

void *panel_mute_enable_thread_entry(void *args)
{
    int ret = -1;

    if (panel_pre_init_thread_id)
    {
        thread_join(panel_pre_init_thread_id, NULL);
    }

    ret = run_command("panel_mute 1", 0);
    if (ret < 0)
    {
        UBOOT_ERROR("panel_mute command task execute failure.\n");
    }

    return NULL;
}

void *panel_enable_thread_entry(void *args)
{
    int ret = -1;

    if (panel_mute_true_thread_id)
    {
        thread_join(panel_mute_true_thread_id, NULL);
    }

    ret = run_command("panel_enable 1", 0);
    if (ret < 0)
    {
        UBOOT_ERROR("panel_enable command task execute failure.\n");
    }

    return NULL;
}

void *panel_mute_disable_thread_entry(void *args)
{
    int ret = -1;

    if (show_logo_thread_id)
    {
        thread_join(show_logo_thread_id, NULL);
    }

    ret = run_command("panel_mute 0", 0);
    if (ret < 0)
    {
        UBOOT_ERROR("panel_mute command task execute failure.\n");
    }

    return NULL;
}

void *panel_post_init_thread_entry(void *args)
{
    int ret = -1;

    if (panel_mute_false_thread_id)
    {
        thread_join(panel_mute_false_thread_id, NULL);
    }

    ret = run_command("panel_post_init", 0);
    if (ret < 0)
    {
        UBOOT_ERROR("panel_post_init command task execute failure.\n");
    }

    return NULL;
}
