/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to MediaTek Inc. and/or its licensors. Without
 * the prior written permission of MediaTek inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of MediaTek Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * Copyright  (C) [2020]  MediaTek Inc. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
 * SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
 * MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek
 * Software") have been modified by MediaTek Inc. All revisions are subject to
 * any receiver's applicable license agreements with MediaTek Inc.
 */

#ifndef _BOOT_IMPL_
#define _BOOT_IMPL_

#define BOOT_MODE_RECOVERY_STR "boot-recovery"
#define BOOT_MODE_RECOVERY_QUIESCENT_STR "boot-recovery,quiescent"
#define BOOT_MODE_RECOVERY_WIPE_DATA "recovery\n--wipe_data\n"
#define BOOT_MODE_QUIESCENT_STR "boot-quiescent"
#if defined(CONFIG_FASTBOOT)
#define BOOT_MODE_FASTBOOTD_STR "boot-fastboot"
#define BOOT_MODE_BOOTLOADER_STR "bootonce-bootloader"
#endif

#define ERASE_FIRST_4K_TO_SPEEDUP
#define USERDATA_PARTITON_NAME   "userdata"
#define METADATA_PARTITON_NAME   "metadata"
#define CLEAN_BUFFER_ADDR   0x27000000UL
#ifndef ERASE_FIRST_4K_TO_SPEEDUP
#define CLEAN_BUFFER_SIZE   0x10000000UL
#else
#define CLEAN_BUFFER_SIZE   0x1000UL
#endif

typedef enum
{
    EN_BOOT_MODE_UNKNOWN,
    EN_BOOT_MODE_NORMAL,
    EN_BOOT_MODE_RECOVERY,
    EN_BOOT_MODE_FORCEUGRADE,
    EN_BOOT_MODE_USB_UPGRADE,
    EN_BOOT_MODE_NET_UPGRADE,
    EN_BOOT_MODE_OAD_UPGRADE,
    EN_BOOT_MODE_UPDATELOGIC_UPGRADE,
    EN_BOOT_MODE_ENV_UPGRADE,
    EN_BOOT_MODE_USB_RECOVRY_UPGRADE,
    EN_BOOT_MODE_OTA_UPGRADE,
    EN_BOOT_MODE_RECOVRY_WIPE_DATA,
    EN_BOOT_MODE_RECOVRY_WIPE_CACHE,
    EN_BOOT_MODE_UART_DEBUG,
    EN_BOOT_MODE_SYSTEM_RESTORE,
    EN_BOOT_MODE_FASTBOOT,
    EN_BOOT_MODE_FORCEPOWERON,
}EN_BOOT_MODE;

int get_boot_mode_flag(void);
int boot_mode_check(void);
int upgrade_mode_check(void);
int get_kernel_start(unsigned long long *);
#if defined(CONFIG_BOOT_IR)
int bootir_mode_check(void);
#endif
int set_recovery(void);
int wipe_user_data(void);
int wipe_user_data_in_uboot(void);
#endif
