/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to MediaTek Inc. and/or its licensors. Without
 * the prior written permission of MediaTek inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of MediaTek Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * Copyright  (C) [2020]  MediaTek Inc. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
 * SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
 * MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek
 * Software") have been modified by MediaTek Inc. All revisions are subject to
 * any receiver's applicable license agreements with MediaTek Inc.
 */

#ifndef _MTK_DTS_PARSER_HEADER_
#define _MTK_DTS_PARSER_HEADER_

#define DTS_SHIFT_32_BIT  32

struct fdt_content
{
    char *field;
    int len;
    __be32 *attribute;
};

struct dts_mmap
{
    unsigned long long address;
    unsigned long long size;
};

void integer_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void string_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void mmap_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void jpd_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void gop_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void pwm_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void panel_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void cus_panel_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
#ifdef CONFIG_ENABLE_CUST_IC_UPDATE
void cust_pmic_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void cust_pgamma_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void cust_levelshift_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void cust_vcomic_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);

void cust_pmic_sub_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void cust_pgamma_sub_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void cust_levelshift_sub_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void cust_vcomic_sub_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);

void cust_tcon_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
#endif
void ldm_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);

void board_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
void misc_dt_parser(struct fdt_content *fdt_data, void *out, const char *field_target);
int parse_dt(const char *tag_target, void (*parser_cb)(struct fdt_content *, void*, const char*), void *out, const char *field_target);

#endif
