//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>

#ifndef __FDE_REG_H__
#define __FDE_REG_H__

#define FDE_AES_KEY                     GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x00)	//0x0~0xF
#define FDE_AES_IV                      GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x10)	//0x10~0x17
#define FDE_AES_CTR                     GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x18)	//0x18~0x1F
#define FDE_AES_BUSY                    GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x20)	
#define FDE_AES_CONTROL0                GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x30)	
#define FDE_AES_CONTROL1                GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x31)	

#define FDE_AES_XEX_HW_T_CALC_KICK      GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x34)
#define FDE_AES_SW_RESET                GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x38)

#define FDE_AES_XEX_HW_T_CALC_KEY       GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x40)	//0x40~0x4F

#define FDE_AES_DATA_UNIT0              GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x50)
#define FDE_AES_DATA_UNIT1              GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x51)

#define FDE_AES_FUN                     GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x60)
#define FDE_AES_DBG_BUS                 GET_REG_ADDR(FDE_REG_BASE_ADDR, 0x61)


//FDE_AES_BUSY 0x20
#define BIT_AES_BUSY                    BIT0
//FDE_AES_CONTROL0 0x30
#define BIT_ENC_OR_DEC              BIT0
#define ENABLE_ENC					0
#define ENABLE_DEC					1
#define BIT_MASK_AES_MODE			(BIT2|BIT3|BIT4|BIT5|BIT6)
#define BIT_AES_MODE_SHIFT			2
#define ECB_MODE				    0	//set 0
#define CBC_MODE				    1
#define CTR_MODE				    2
#define OFB_MODE				    5
#define CFB_MODE				    6
#define XTS_MODE				    8



#define BIT_MASK_KEY_SIZE			(BIT12|BIT13)
#define BIT_KEY_128BIT_SIZE			BIT_MASK_KEY_SIZE
#define BIT_KEY_192BIT_SIZE			BIT12
#define BIT_KEY_256BIT_SIZE			BIT13

//FDE_AES_XEX_HW_T_CALC_KICK  0x34
#define BIT_AES_XEX_HW_T_CALC_KICK  BIT0

//FDE_AES_SW_RESET  0x38
#define BIT_AES_SW_RESET            BIT0

//FDE_AES_FUN  0x60
#define BIT_AES_FUNC_EN             BIT0
#define BIT_AES_SWAP                BIT1
#define BIT_AES_AUTO_CONFIG         BIT2
#define BIT_AES_AUTO_CONFIG_CMDQ    BIT3
#define BIT_AES_SWITCH_ON			BIT4


#endif
