/* Copyright Statement:
 *
 * This software/firmware and related documentation ("MediaTek Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to MediaTek Inc. and/or its licensors. Without
 * the prior written permission of MediaTek inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of MediaTek Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * Copyright  (C) [2020]  MediaTek Inc. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
 * RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE MEDIATEK SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN MEDIATEK
 * SOFTWARE. MEDIATEK SHALL ALSO NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE
 * MEDIATEK SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
 *
 * The following software/firmware and/or related documentation ("MediaTek
 * Software") have been modified by MediaTek Inc. All revisions are subject to
 * any receiver's applicable license agreements with MediaTek Inc.
 */

#ifndef _DRV_RSA_H_
#define _DRV_RSA_H_

#ifdef __cplusplus
extern "C"
{
#endif

//-------------------------------------------------------------------------------------------------
// Defines
//-------------------------------------------------------------------------------------------------
#define RSA_DELAY_10 10
#define RSA_TIMEOUT_VALUE 1200000

typedef enum
{
    E_DRV_RSA1024_PUBLIC = 0,
    E_DRV_RSA1024_PRIVATE,
    E_DRV_RSA2048_PUBLIC,
    E_DRV_RSA2048_PRIVATE,
    E_DRV_RSA256_PUBLIC,
    E_DRV_RSA256_PRIVATE,
} Drv_RSAMode;

typedef enum
{
    E_DRV_RSA256_KeyLen = 32,
    E_DRV_RSA1024_KeyLen = 128,
    E_DRV_RSA2048_KeyLen = 256,
} Drv_RSAKeyLen;

#define RSA_INPUT_SIZE               256
#define RSA_UNIT_SIZE                4

//--------------------------------------------------------------------------------------------------
//  Type and Structure
//--------------------------------------------------------------------------------------------------
typedef struct
{
    unsigned int KeyN[64];
    unsigned int KeyE[64];

}Drv_RSAKey;

typedef struct
{
    unsigned int Sig[64];

}Drv_RSASig;

typedef struct
{
    unsigned int RSAOut[64];

}Drv_RSAOut;

//--------------------------------------------------------------------------------------------------
//  Function Prototype
//--------------------------------------------------------------------------------------------------
int HW_RSA_Calculate(Drv_RSASig *pstSign, Drv_RSAKey *pstKey, Drv_RSAMode eMode);
int HW_RSA_IsFinished(void);
int HW_RSA_Output(Drv_RSAMode eMode, Drv_RSAOut *pstRSAOut);
int _HW_RSA_Calculate(Drv_RSASig *pstSign, Drv_RSAKey *pstKey, Drv_RSAMode eMode);
int _HW_RSA_IsFinished(void);
int _HW_RSA_Output(Drv_RSAMode eMode, Drv_RSAOut *pstRSAOut);

#endif // #ifndef _DRV_RSA_H_