//<MStar Software>
//$Revision:: 17057  $
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef _COLOR_REG_H_
#define _COLOR_REG_H_


///////////////////////////////////////////////////////
// Scaler Bank
///////////////////////////////////////////////////////

#define REG_BANK_RESET              0x00
#define REG_BANK_GOPINT             0x00
#define REG_BANK_IP1F2              0x01
#define REG_BANK_IP2F2              0x02
#define REG_BANK_IP1F1              0x03
#define REG_BANK_IP2F1              0x04
#define REG_BANK_OPM                0x05
#define REG_BANK_DNR                0x06
#define REG_BANK_OP1                0x07
#define REG_BANK_OP1PIP             0x08
#define REG_BANK_OP1HVSP            0x09
#define REG_BANK_FILM               0x0A
#define REG_BANK_ELA                0x0B
#define REG_BANK_ACE                0x0C
#define REG_BANK_HD                 0x0E
#define REG_BANK_S_VOP              0x0F
#define REG_BANK_VOP                0x10
#define REG_BANK_TCON               0x11
#define REG_BANK_SCMI               0x12
#define REG_BANK_OD                 0x16
#define REG_BANK_SRAM               0x17
#define REG_BANK_VIP                0x18
#define REG_BANK_VPS                0x19
#define REG_BANK_DLC                0x1A
#define REG_BANK_OP1PIPEXT          0x1B
#define REG_BANK_SmoothFilter       0x1C
#define REG_BANK_MFC                0x1D
#define REG_BANK_PIP                0x20
#define REG_BANK_EODI               0x21
#define REG_BANK_MADI               0x22
#define REG_BANK_HVSP               0x23
#define REG_BANK_DMS                0x26
#define REG_BANK_PRED               0x28

// Scaler Base
#define BK_IPMUX_BASE               0x2E00
//#define BK_SCALER_BASE              0x102F00
#define BK_MOD_BASE                 0x3200
#define BK_TCON_BASE                0x3000
#define BK_LPLL_BASE                0x3100

#define REG_GOP_BANK             0x101FFE

#define MAKE_ADDR(_x_)          (0x100000 | _x_)

// MVOP Base
#define VOP_MPG_JPG_SWITCH          0x1440
#define VOP_UV_SHIFT                0x1460



#define _PK_L_(bank, addr)   (((MS_U16)bank << 8) | (MS_U16)(addr*2))
#define _PK_H_(bank, addr)   (((MS_U16)bank << 8) | (MS_U16)(addr*2+1))



#define REG_TABLE_END      0xFFFFFF

//----------------------------------------------
#define REG_SC_BK00_00_L      _PK_L_(0x00, 0x00)
#define REG_SC_BK00_00_H      _PK_H_(0x00, 0x00)
#define REG_SC_BK00_01_L      _PK_L_(0x00, 0x01)
#define REG_SC_BK00_01_H      _PK_H_(0x00, 0x01)
#define REG_SC_BK00_02_L      _PK_L_(0x00, 0x02)
#define REG_SC_BK00_02_H      _PK_H_(0x00, 0x02)
#define REG_SC_BK00_03_L      _PK_L_(0x00, 0x03)
#define REG_SC_BK00_03_H      _PK_H_(0x00, 0x03)
#define REG_SC_BK00_04_L      _PK_L_(0x00, 0x04)
#define REG_SC_BK00_04_H      _PK_H_(0x00, 0x04)
#define REG_SC_BK00_05_L      _PK_L_(0x00, 0x05)
#define REG_SC_BK00_05_H      _PK_H_(0x00, 0x05)
#define REG_SC_BK00_06_L      _PK_L_(0x00, 0x06)
#define REG_SC_BK00_06_H      _PK_H_(0x00, 0x06)
#define REG_SC_BK00_07_L      _PK_L_(0x00, 0x07)
#define REG_SC_BK00_07_H      _PK_H_(0x00, 0x07)
#define REG_SC_BK00_08_L      _PK_L_(0x00, 0x08)
#define REG_SC_BK00_08_H      _PK_H_(0x00, 0x08)
#define REG_SC_BK00_09_L      _PK_L_(0x00, 0x09)
#define REG_SC_BK00_09_H      _PK_H_(0x00, 0x09)
#define REG_SC_BK00_0A_L      _PK_L_(0x00, 0x0A)
#define REG_SC_BK00_0A_H      _PK_H_(0x00, 0x0A)
#define REG_SC_BK00_0B_L      _PK_L_(0x00, 0x0B)
#define REG_SC_BK00_0B_H      _PK_H_(0x00, 0x0B)
#define REG_SC_BK00_0C_L      _PK_L_(0x00, 0x0C)
#define REG_SC_BK00_0C_H      _PK_H_(0x00, 0x0C)
#define REG_SC_BK00_0D_L      _PK_L_(0x00, 0x0D)
#define REG_SC_BK00_0D_H      _PK_H_(0x00, 0x0D)
#define REG_SC_BK00_0E_L      _PK_L_(0x00, 0x0E)
#define REG_SC_BK00_0E_H      _PK_H_(0x00, 0x0E)
#define REG_SC_BK00_0F_L      _PK_L_(0x00, 0x0F)
#define REG_SC_BK00_0F_H      _PK_H_(0x00, 0x0F)
#define REG_SC_BK00_10_L      _PK_L_(0x00, 0x10)
#define REG_SC_BK00_10_H      _PK_H_(0x00, 0x10)
#define REG_SC_BK00_11_L      _PK_L_(0x00, 0x11)
#define REG_SC_BK00_11_H      _PK_H_(0x00, 0x11)
#define REG_SC_BK00_12_L      _PK_L_(0x00, 0x12)
#define REG_SC_BK00_12_H      _PK_H_(0x00, 0x12)
#define REG_SC_BK00_13_L      _PK_L_(0x00, 0x13)
#define REG_SC_BK00_13_H      _PK_H_(0x00, 0x13)
#define REG_SC_BK00_14_L      _PK_L_(0x00, 0x14)
#define REG_SC_BK00_14_H      _PK_H_(0x00, 0x14)
#define REG_SC_BK00_15_L      _PK_L_(0x00, 0x15)
#define REG_SC_BK00_15_H      _PK_H_(0x00, 0x15)
#define REG_SC_BK00_16_L      _PK_L_(0x00, 0x16)
#define REG_SC_BK00_16_H      _PK_H_(0x00, 0x16)
#define REG_SC_BK00_17_L      _PK_L_(0x00, 0x17)
#define REG_SC_BK00_17_H      _PK_H_(0x00, 0x17)
#define REG_SC_BK00_18_L      _PK_L_(0x00, 0x18)
#define REG_SC_BK00_18_H      _PK_H_(0x00, 0x18)
#define REG_SC_BK00_19_L      _PK_L_(0x00, 0x19)
#define REG_SC_BK00_19_H      _PK_H_(0x00, 0x19)
#define REG_SC_BK00_1A_L      _PK_L_(0x00, 0x1A)
#define REG_SC_BK00_1A_H      _PK_H_(0x00, 0x1A)
#define REG_SC_BK00_1B_L      _PK_L_(0x00, 0x1B)
#define REG_SC_BK00_1B_H      _PK_H_(0x00, 0x1B)
#define REG_SC_BK00_1C_L      _PK_L_(0x00, 0x1C)
#define REG_SC_BK00_1C_H      _PK_H_(0x00, 0x1C)
#define REG_SC_BK00_1D_L      _PK_L_(0x00, 0x1D)
#define REG_SC_BK00_1D_H      _PK_H_(0x00, 0x1D)
#define REG_SC_BK00_1E_L      _PK_L_(0x00, 0x1E)
#define REG_SC_BK00_1E_H      _PK_H_(0x00, 0x1E)
#define REG_SC_BK00_1F_L      _PK_L_(0x00, 0x1F)
#define REG_SC_BK00_1F_H      _PK_H_(0x00, 0x1F)
#define REG_SC_BK00_20_L      _PK_L_(0x00, 0x20)
#define REG_SC_BK00_20_H      _PK_H_(0x00, 0x20)
#define REG_SC_BK00_21_L      _PK_L_(0x00, 0x21)
#define REG_SC_BK00_21_H      _PK_H_(0x00, 0x21)
#define REG_SC_BK00_22_L      _PK_L_(0x00, 0x22)
#define REG_SC_BK00_22_H      _PK_H_(0x00, 0x22)
#define REG_SC_BK00_23_L      _PK_L_(0x00, 0x23)
#define REG_SC_BK00_23_H      _PK_H_(0x00, 0x23)
#define REG_SC_BK00_24_L      _PK_L_(0x00, 0x24)
#define REG_SC_BK00_24_H      _PK_H_(0x00, 0x24)
#define REG_SC_BK00_25_L      _PK_L_(0x00, 0x25)
#define REG_SC_BK00_25_H      _PK_H_(0x00, 0x25)
#define REG_SC_BK00_26_L      _PK_L_(0x00, 0x26)
#define REG_SC_BK00_26_H      _PK_H_(0x00, 0x26)
#define REG_SC_BK00_27_L      _PK_L_(0x00, 0x27)
#define REG_SC_BK00_27_H      _PK_H_(0x00, 0x27)
#define REG_SC_BK00_28_L      _PK_L_(0x00, 0x28)
#define REG_SC_BK00_28_H      _PK_H_(0x00, 0x28)
#define REG_SC_BK00_29_L      _PK_L_(0x00, 0x29)
#define REG_SC_BK00_29_H      _PK_H_(0x00, 0x29)
#define REG_SC_BK00_2A_L      _PK_L_(0x00, 0x2A)
#define REG_SC_BK00_2A_H      _PK_H_(0x00, 0x2A)
#define REG_SC_BK00_2B_L      _PK_L_(0x00, 0x2B)
#define REG_SC_BK00_2B_H      _PK_H_(0x00, 0x2B)
#define REG_SC_BK00_2C_L      _PK_L_(0x00, 0x2C)
#define REG_SC_BK00_2C_H      _PK_H_(0x00, 0x2C)
#define REG_SC_BK00_2D_L      _PK_L_(0x00, 0x2D)
#define REG_SC_BK00_2D_H      _PK_H_(0x00, 0x2D)
#define REG_SC_BK00_2E_L      _PK_L_(0x00, 0x2E)
#define REG_SC_BK00_2E_H      _PK_H_(0x00, 0x2E)
#define REG_SC_BK00_2F_L      _PK_L_(0x00, 0x2F)
#define REG_SC_BK00_2F_H      _PK_H_(0x00, 0x2F)
#define REG_SC_BK00_30_L      _PK_L_(0x00, 0x30)
#define REG_SC_BK00_30_H      _PK_H_(0x00, 0x30)
#define REG_SC_BK00_31_L      _PK_L_(0x00, 0x31)
#define REG_SC_BK00_31_H      _PK_H_(0x00, 0x31)
#define REG_SC_BK00_32_L      _PK_L_(0x00, 0x32)
#define REG_SC_BK00_32_H      _PK_H_(0x00, 0x32)
#define REG_SC_BK00_33_L      _PK_L_(0x00, 0x33)
#define REG_SC_BK00_33_H      _PK_H_(0x00, 0x33)
#define REG_SC_BK00_34_L      _PK_L_(0x00, 0x34)
#define REG_SC_BK00_34_H      _PK_H_(0x00, 0x34)
#define REG_SC_BK00_35_L      _PK_L_(0x00, 0x35)
#define REG_SC_BK00_35_H      _PK_H_(0x00, 0x35)
#define REG_SC_BK00_36_L      _PK_L_(0x00, 0x36)
#define REG_SC_BK00_36_H      _PK_H_(0x00, 0x36)
#define REG_SC_BK00_37_L      _PK_L_(0x00, 0x37)
#define REG_SC_BK00_37_H      _PK_H_(0x00, 0x37)
#define REG_SC_BK00_38_L      _PK_L_(0x00, 0x38)
#define REG_SC_BK00_38_H      _PK_H_(0x00, 0x38)
#define REG_SC_BK00_39_L      _PK_L_(0x00, 0x39)
#define REG_SC_BK00_39_H      _PK_H_(0x00, 0x39)
#define REG_SC_BK00_3A_L      _PK_L_(0x00, 0x3A)
#define REG_SC_BK00_3A_H      _PK_H_(0x00, 0x3A)
#define REG_SC_BK00_3B_L      _PK_L_(0x00, 0x3B)
#define REG_SC_BK00_3B_H      _PK_H_(0x00, 0x3B)
#define REG_SC_BK00_3C_L      _PK_L_(0x00, 0x3C)
#define REG_SC_BK00_3C_H      _PK_H_(0x00, 0x3C)
#define REG_SC_BK00_3D_L      _PK_L_(0x00, 0x3D)
#define REG_SC_BK00_3D_H      _PK_H_(0x00, 0x3D)
#define REG_SC_BK00_3E_L      _PK_L_(0x00, 0x3E)
#define REG_SC_BK00_3E_H      _PK_H_(0x00, 0x3E)
#define REG_SC_BK00_3F_L      _PK_L_(0x00, 0x3F)
#define REG_SC_BK00_3F_H      _PK_H_(0x00, 0x3F)
#define REG_SC_BK00_40_L      _PK_L_(0x00, 0x40)
#define REG_SC_BK00_40_H      _PK_H_(0x00, 0x40)
#define REG_SC_BK00_41_L      _PK_L_(0x00, 0x41)
#define REG_SC_BK00_41_H      _PK_H_(0x00, 0x41)
#define REG_SC_BK00_42_L      _PK_L_(0x00, 0x42)
#define REG_SC_BK00_42_H      _PK_H_(0x00, 0x42)
#define REG_SC_BK00_43_L      _PK_L_(0x00, 0x43)
#define REG_SC_BK00_43_H      _PK_H_(0x00, 0x43)
#define REG_SC_BK00_44_L      _PK_L_(0x00, 0x44)
#define REG_SC_BK00_44_H      _PK_H_(0x00, 0x44)
#define REG_SC_BK00_45_L      _PK_L_(0x00, 0x45)
#define REG_SC_BK00_45_H      _PK_H_(0x00, 0x45)
#define REG_SC_BK00_46_L      _PK_L_(0x00, 0x46)
#define REG_SC_BK00_46_H      _PK_H_(0x00, 0x46)
#define REG_SC_BK00_47_L      _PK_L_(0x00, 0x47)
#define REG_SC_BK00_47_H      _PK_H_(0x00, 0x47)
#define REG_SC_BK00_48_L      _PK_L_(0x00, 0x48)
#define REG_SC_BK00_48_H      _PK_H_(0x00, 0x48)
#define REG_SC_BK00_49_L      _PK_L_(0x00, 0x49)
#define REG_SC_BK00_49_H      _PK_H_(0x00, 0x49)
#define REG_SC_BK00_4A_L      _PK_L_(0x00, 0x4A)
#define REG_SC_BK00_4A_H      _PK_H_(0x00, 0x4A)
#define REG_SC_BK00_4B_L      _PK_L_(0x00, 0x4B)
#define REG_SC_BK00_4B_H      _PK_H_(0x00, 0x4B)
#define REG_SC_BK00_4C_L      _PK_L_(0x00, 0x4C)
#define REG_SC_BK00_4C_H      _PK_H_(0x00, 0x4C)
#define REG_SC_BK00_4D_L      _PK_L_(0x00, 0x4D)
#define REG_SC_BK00_4D_H      _PK_H_(0x00, 0x4D)
#define REG_SC_BK00_4E_L      _PK_L_(0x00, 0x4E)
#define REG_SC_BK00_4E_H      _PK_H_(0x00, 0x4E)
#define REG_SC_BK00_4F_L      _PK_L_(0x00, 0x4F)
#define REG_SC_BK00_4F_H      _PK_H_(0x00, 0x4F)
#define REG_SC_BK00_50_L      _PK_L_(0x00, 0x50)
#define REG_SC_BK00_50_H      _PK_H_(0x00, 0x50)
#define REG_SC_BK00_51_L      _PK_L_(0x00, 0x51)
#define REG_SC_BK00_51_H      _PK_H_(0x00, 0x51)
#define REG_SC_BK00_52_L      _PK_L_(0x00, 0x52)
#define REG_SC_BK00_52_H      _PK_H_(0x00, 0x52)
#define REG_SC_BK00_53_L      _PK_L_(0x00, 0x53)
#define REG_SC_BK00_53_H      _PK_H_(0x00, 0x53)
#define REG_SC_BK00_54_L      _PK_L_(0x00, 0x54)
#define REG_SC_BK00_54_H      _PK_H_(0x00, 0x54)
#define REG_SC_BK00_55_L      _PK_L_(0x00, 0x55)
#define REG_SC_BK00_55_H      _PK_H_(0x00, 0x55)
#define REG_SC_BK00_56_L      _PK_L_(0x00, 0x56)
#define REG_SC_BK00_56_H      _PK_H_(0x00, 0x56)
#define REG_SC_BK00_57_L      _PK_L_(0x00, 0x57)
#define REG_SC_BK00_57_H      _PK_H_(0x00, 0x57)
#define REG_SC_BK00_58_L      _PK_L_(0x00, 0x58)
#define REG_SC_BK00_58_H      _PK_H_(0x00, 0x58)
#define REG_SC_BK00_59_L      _PK_L_(0x00, 0x59)
#define REG_SC_BK00_59_H      _PK_H_(0x00, 0x59)
#define REG_SC_BK00_5A_L      _PK_L_(0x00, 0x5A)
#define REG_SC_BK00_5A_H      _PK_H_(0x00, 0x5A)
#define REG_SC_BK00_5B_L      _PK_L_(0x00, 0x5B)
#define REG_SC_BK00_5B_H      _PK_H_(0x00, 0x5B)
#define REG_SC_BK00_5C_L      _PK_L_(0x00, 0x5C)
#define REG_SC_BK00_5C_H      _PK_H_(0x00, 0x5C)
#define REG_SC_BK00_5D_L      _PK_L_(0x00, 0x5D)
#define REG_SC_BK00_5D_H      _PK_H_(0x00, 0x5D)
#define REG_SC_BK00_5E_L      _PK_L_(0x00, 0x5E)
#define REG_SC_BK00_5E_H      _PK_H_(0x00, 0x5E)
#define REG_SC_BK00_5F_L      _PK_L_(0x00, 0x5F)
#define REG_SC_BK00_5F_H      _PK_H_(0x00, 0x5F)
#define REG_SC_BK00_60_L      _PK_L_(0x00, 0x60)
#define REG_SC_BK00_60_H      _PK_H_(0x00, 0x60)
#define REG_SC_BK00_61_L      _PK_L_(0x00, 0x61)
#define REG_SC_BK00_61_H      _PK_H_(0x00, 0x61)
#define REG_SC_BK00_62_L      _PK_L_(0x00, 0x62)
#define REG_SC_BK00_62_H      _PK_H_(0x00, 0x62)
#define REG_SC_BK00_63_L      _PK_L_(0x00, 0x63)
#define REG_SC_BK00_63_H      _PK_H_(0x00, 0x63)
#define REG_SC_BK00_64_L      _PK_L_(0x00, 0x64)
#define REG_SC_BK00_64_H      _PK_H_(0x00, 0x64)
#define REG_SC_BK00_65_L      _PK_L_(0x00, 0x65)
#define REG_SC_BK00_65_H      _PK_H_(0x00, 0x65)
#define REG_SC_BK00_66_L      _PK_L_(0x00, 0x66)
#define REG_SC_BK00_66_H      _PK_H_(0x00, 0x66)
#define REG_SC_BK00_67_L      _PK_L_(0x00, 0x67)
#define REG_SC_BK00_67_H      _PK_H_(0x00, 0x67)
#define REG_SC_BK00_68_L      _PK_L_(0x00, 0x68)
#define REG_SC_BK00_68_H      _PK_H_(0x00, 0x68)
#define REG_SC_BK00_69_L      _PK_L_(0x00, 0x69)
#define REG_SC_BK00_69_H      _PK_H_(0x00, 0x69)
#define REG_SC_BK00_6A_L      _PK_L_(0x00, 0x6A)
#define REG_SC_BK00_6A_H      _PK_H_(0x00, 0x6A)
#define REG_SC_BK00_6B_L      _PK_L_(0x00, 0x6B)
#define REG_SC_BK00_6B_H      _PK_H_(0x00, 0x6B)
#define REG_SC_BK00_6C_L      _PK_L_(0x00, 0x6C)
#define REG_SC_BK00_6C_H      _PK_H_(0x00, 0x6C)
#define REG_SC_BK00_6D_L      _PK_L_(0x00, 0x6D)
#define REG_SC_BK00_6D_H      _PK_H_(0x00, 0x6D)
#define REG_SC_BK00_6E_L      _PK_L_(0x00, 0x6E)
#define REG_SC_BK00_6E_H      _PK_H_(0x00, 0x6E)
#define REG_SC_BK00_6F_L      _PK_L_(0x00, 0x6F)
#define REG_SC_BK00_6F_H      _PK_H_(0x00, 0x6F)
#define REG_SC_BK00_70_L      _PK_L_(0x00, 0x70)
#define REG_SC_BK00_70_H      _PK_H_(0x00, 0x70)
#define REG_SC_BK00_71_L      _PK_L_(0x00, 0x71)
#define REG_SC_BK00_71_H      _PK_H_(0x00, 0x71)
#define REG_SC_BK00_72_L      _PK_L_(0x00, 0x72)
#define REG_SC_BK00_72_H      _PK_H_(0x00, 0x72)
#define REG_SC_BK00_73_L      _PK_L_(0x00, 0x73)
#define REG_SC_BK00_73_H      _PK_H_(0x00, 0x73)
#define REG_SC_BK00_74_L      _PK_L_(0x00, 0x74)
#define REG_SC_BK00_74_H      _PK_H_(0x00, 0x74)
#define REG_SC_BK00_75_L      _PK_L_(0x00, 0x75)
#define REG_SC_BK00_75_H      _PK_H_(0x00, 0x75)
#define REG_SC_BK00_76_L      _PK_L_(0x00, 0x76)
#define REG_SC_BK00_76_H      _PK_H_(0x00, 0x76)
#define REG_SC_BK00_77_L      _PK_L_(0x00, 0x77)
#define REG_SC_BK00_77_H      _PK_H_(0x00, 0x77)
#define REG_SC_BK00_78_L      _PK_L_(0x00, 0x78)
#define REG_SC_BK00_78_H      _PK_H_(0x00, 0x78)
#define REG_SC_BK00_79_L      _PK_L_(0x00, 0x79)
#define REG_SC_BK00_79_H      _PK_H_(0x00, 0x79)
#define REG_SC_BK00_7A_L      _PK_L_(0x00, 0x7A)
#define REG_SC_BK00_7A_H      _PK_H_(0x00, 0x7A)
#define REG_SC_BK00_7B_L      _PK_L_(0x00, 0x7B)
#define REG_SC_BK00_7B_H      _PK_H_(0x00, 0x7B)
#define REG_SC_BK00_7C_L      _PK_L_(0x00, 0x7C)
#define REG_SC_BK00_7C_H      _PK_H_(0x00, 0x7C)
#define REG_SC_BK00_7D_L      _PK_L_(0x00, 0x7D)
#define REG_SC_BK00_7D_H      _PK_H_(0x00, 0x7D)
#define REG_SC_BK00_7E_L      _PK_L_(0x00, 0x7E)
#define REG_SC_BK00_7E_H      _PK_H_(0x00, 0x7E)
#define REG_SC_BK00_7F_L      _PK_L_(0x00, 0x7F)
#define REG_SC_BK00_7F_H      _PK_H_(0x00, 0x7F)
//----------------------------------------------
#define REG_SC_BK01_00_L      _PK_L_(0x01, 0x00)
#define REG_SC_BK01_00_H      _PK_H_(0x01, 0x00)
#define REG_SC_BK01_01_L      _PK_L_(0x01, 0x01)
#define REG_SC_BK01_01_H      _PK_H_(0x01, 0x01)
#define REG_SC_BK01_02_L      _PK_L_(0x01, 0x02)
#define REG_SC_BK01_02_H      _PK_H_(0x01, 0x02)
#define REG_SC_BK01_03_L      _PK_L_(0x01, 0x03)
#define REG_SC_BK01_03_H      _PK_H_(0x01, 0x03)
#define REG_SC_BK01_04_L      _PK_L_(0x01, 0x04)
#define REG_SC_BK01_04_H      _PK_H_(0x01, 0x04)
#define REG_SC_BK01_05_L      _PK_L_(0x01, 0x05)
#define REG_SC_BK01_05_H      _PK_H_(0x01, 0x05)
#define REG_SC_BK01_06_L      _PK_L_(0x01, 0x06)
#define REG_SC_BK01_06_H      _PK_H_(0x01, 0x06)
#define REG_SC_BK01_07_L      _PK_L_(0x01, 0x07)
#define REG_SC_BK01_07_H      _PK_H_(0x01, 0x07)
#define REG_SC_BK01_08_L      _PK_L_(0x01, 0x08)
#define REG_SC_BK01_08_H      _PK_H_(0x01, 0x08)
#define REG_SC_BK01_09_L      _PK_L_(0x01, 0x09)
#define REG_SC_BK01_09_H      _PK_H_(0x01, 0x09)
#define REG_SC_BK01_0A_L      _PK_L_(0x01, 0x0A)
#define REG_SC_BK01_0A_H      _PK_H_(0x01, 0x0A)
#define REG_SC_BK01_0B_L      _PK_L_(0x01, 0x0B)
#define REG_SC_BK01_0B_H      _PK_H_(0x01, 0x0B)
#define REG_SC_BK01_0C_L      _PK_L_(0x01, 0x0C)
#define REG_SC_BK01_0C_H      _PK_H_(0x01, 0x0C)
#define REG_SC_BK01_0D_L      _PK_L_(0x01, 0x0D)
#define REG_SC_BK01_0D_H      _PK_H_(0x01, 0x0D)
#define REG_SC_BK01_0E_L      _PK_L_(0x01, 0x0E)
#define REG_SC_BK01_0E_H      _PK_H_(0x01, 0x0E)
#define REG_SC_BK01_0F_L      _PK_L_(0x01, 0x0F)
#define REG_SC_BK01_0F_H      _PK_H_(0x01, 0x0F)
#define REG_SC_BK01_10_L      _PK_L_(0x01, 0x10)
#define REG_SC_BK01_10_H      _PK_H_(0x01, 0x10)
#define REG_SC_BK01_11_L      _PK_L_(0x01, 0x11)
#define REG_SC_BK01_11_H      _PK_H_(0x01, 0x11)
#define REG_SC_BK01_12_L      _PK_L_(0x01, 0x12)
#define REG_SC_BK01_12_H      _PK_H_(0x01, 0x12)
#define REG_SC_BK01_13_L      _PK_L_(0x01, 0x13)
#define REG_SC_BK01_13_H      _PK_H_(0x01, 0x13)
#define REG_SC_BK01_14_L      _PK_L_(0x01, 0x14)
#define REG_SC_BK01_14_H      _PK_H_(0x01, 0x14)
#define REG_SC_BK01_15_L      _PK_L_(0x01, 0x15)
#define REG_SC_BK01_15_H      _PK_H_(0x01, 0x15)
#define REG_SC_BK01_16_L      _PK_L_(0x01, 0x16)
#define REG_SC_BK01_16_H      _PK_H_(0x01, 0x16)
#define REG_SC_BK01_17_L      _PK_L_(0x01, 0x17)
#define REG_SC_BK01_17_H      _PK_H_(0x01, 0x17)
#define REG_SC_BK01_18_L      _PK_L_(0x01, 0x18)
#define REG_SC_BK01_18_H      _PK_H_(0x01, 0x18)
#define REG_SC_BK01_19_L      _PK_L_(0x01, 0x19)
#define REG_SC_BK01_19_H      _PK_H_(0x01, 0x19)
#define REG_SC_BK01_1A_L      _PK_L_(0x01, 0x1A)
#define REG_SC_BK01_1A_H      _PK_H_(0x01, 0x1A)
#define REG_SC_BK01_1B_L      _PK_L_(0x01, 0x1B)
#define REG_SC_BK01_1B_H      _PK_H_(0x01, 0x1B)
#define REG_SC_BK01_1C_L      _PK_L_(0x01, 0x1C)
#define REG_SC_BK01_1C_H      _PK_H_(0x01, 0x1C)
#define REG_SC_BK01_1D_L      _PK_L_(0x01, 0x1D)
#define REG_SC_BK01_1D_H      _PK_H_(0x01, 0x1D)
#define REG_SC_BK01_1E_L      _PK_L_(0x01, 0x1E)
#define REG_SC_BK01_1E_H      _PK_H_(0x01, 0x1E)
#define REG_SC_BK01_1F_L      _PK_L_(0x01, 0x1F)
#define REG_SC_BK01_1F_H      _PK_H_(0x01, 0x1F)
#define REG_SC_BK01_20_L      _PK_L_(0x01, 0x20)
#define REG_SC_BK01_20_H      _PK_H_(0x01, 0x20)
#define REG_SC_BK01_21_L      _PK_L_(0x01, 0x21)
#define REG_SC_BK01_21_H      _PK_H_(0x01, 0x21)
#define REG_SC_BK01_22_L      _PK_L_(0x01, 0x22)
#define REG_SC_BK01_22_H      _PK_H_(0x01, 0x22)
#define REG_SC_BK01_23_L      _PK_L_(0x01, 0x23)
#define REG_SC_BK01_23_H      _PK_H_(0x01, 0x23)
#define REG_SC_BK01_24_L      _PK_L_(0x01, 0x24)
#define REG_SC_BK01_24_H      _PK_H_(0x01, 0x24)
#define REG_SC_BK01_25_L      _PK_L_(0x01, 0x25)
#define REG_SC_BK01_25_H      _PK_H_(0x01, 0x25)
#define REG_SC_BK01_26_L      _PK_L_(0x01, 0x26)
#define REG_SC_BK01_26_H      _PK_H_(0x01, 0x26)
#define REG_SC_BK01_27_L      _PK_L_(0x01, 0x27)
#define REG_SC_BK01_27_H      _PK_H_(0x01, 0x27)
#define REG_SC_BK01_28_L      _PK_L_(0x01, 0x28)
#define REG_SC_BK01_28_H      _PK_H_(0x01, 0x28)
#define REG_SC_BK01_29_L      _PK_L_(0x01, 0x29)
#define REG_SC_BK01_29_H      _PK_H_(0x01, 0x29)
#define REG_SC_BK01_2A_L      _PK_L_(0x01, 0x2A)
#define REG_SC_BK01_2A_H      _PK_H_(0x01, 0x2A)
#define REG_SC_BK01_2B_L      _PK_L_(0x01, 0x2B)
#define REG_SC_BK01_2B_H      _PK_H_(0x01, 0x2B)
#define REG_SC_BK01_2C_L      _PK_L_(0x01, 0x2C)
#define REG_SC_BK01_2C_H      _PK_H_(0x01, 0x2C)
#define REG_SC_BK01_2D_L      _PK_L_(0x01, 0x2D)
#define REG_SC_BK01_2D_H      _PK_H_(0x01, 0x2D)
#define REG_SC_BK01_2E_L      _PK_L_(0x01, 0x2E)
#define REG_SC_BK01_2E_H      _PK_H_(0x01, 0x2E)
#define REG_SC_BK01_2F_L      _PK_L_(0x01, 0x2F)
#define REG_SC_BK01_2F_H      _PK_H_(0x01, 0x2F)
#define REG_SC_BK01_30_L      _PK_L_(0x01, 0x30)
#define REG_SC_BK01_30_H      _PK_H_(0x01, 0x30)
#define REG_SC_BK01_31_L      _PK_L_(0x01, 0x31)
#define REG_SC_BK01_31_H      _PK_H_(0x01, 0x31)
#define REG_SC_BK01_32_L      _PK_L_(0x01, 0x32)
#define REG_SC_BK01_32_H      _PK_H_(0x01, 0x32)
#define REG_SC_BK01_33_L      _PK_L_(0x01, 0x33)
#define REG_SC_BK01_33_H      _PK_H_(0x01, 0x33)
#define REG_SC_BK01_34_L      _PK_L_(0x01, 0x34)
#define REG_SC_BK01_34_H      _PK_H_(0x01, 0x34)
#define REG_SC_BK01_35_L      _PK_L_(0x01, 0x35)
#define REG_SC_BK01_35_H      _PK_H_(0x01, 0x35)
#define REG_SC_BK01_36_L      _PK_L_(0x01, 0x36)
#define REG_SC_BK01_36_H      _PK_H_(0x01, 0x36)
#define REG_SC_BK01_37_L      _PK_L_(0x01, 0x37)
#define REG_SC_BK01_37_H      _PK_H_(0x01, 0x37)
#define REG_SC_BK01_38_L      _PK_L_(0x01, 0x38)
#define REG_SC_BK01_38_H      _PK_H_(0x01, 0x38)
#define REG_SC_BK01_39_L      _PK_L_(0x01, 0x39)
#define REG_SC_BK01_39_H      _PK_H_(0x01, 0x39)
#define REG_SC_BK01_3A_L      _PK_L_(0x01, 0x3A)
#define REG_SC_BK01_3A_H      _PK_H_(0x01, 0x3A)
#define REG_SC_BK01_3B_L      _PK_L_(0x01, 0x3B)
#define REG_SC_BK01_3B_H      _PK_H_(0x01, 0x3B)
#define REG_SC_BK01_3C_L      _PK_L_(0x01, 0x3C)
#define REG_SC_BK01_3C_H      _PK_H_(0x01, 0x3C)
#define REG_SC_BK01_3D_L      _PK_L_(0x01, 0x3D)
#define REG_SC_BK01_3D_H      _PK_H_(0x01, 0x3D)
#define REG_SC_BK01_3E_L      _PK_L_(0x01, 0x3E)
#define REG_SC_BK01_3E_H      _PK_H_(0x01, 0x3E)
#define REG_SC_BK01_3F_L      _PK_L_(0x01, 0x3F)
#define REG_SC_BK01_3F_H      _PK_H_(0x01, 0x3F)
#define REG_SC_BK01_40_L      _PK_L_(0x01, 0x40)
#define REG_SC_BK01_40_H      _PK_H_(0x01, 0x40)
#define REG_SC_BK01_41_L      _PK_L_(0x01, 0x41)
#define REG_SC_BK01_41_H      _PK_H_(0x01, 0x41)
#define REG_SC_BK01_42_L      _PK_L_(0x01, 0x42)
#define REG_SC_BK01_42_H      _PK_H_(0x01, 0x42)
#define REG_SC_BK01_43_L      _PK_L_(0x01, 0x43)
#define REG_SC_BK01_43_H      _PK_H_(0x01, 0x43)
#define REG_SC_BK01_44_L      _PK_L_(0x01, 0x44)
#define REG_SC_BK01_44_H      _PK_H_(0x01, 0x44)
#define REG_SC_BK01_45_L      _PK_L_(0x01, 0x45)
#define REG_SC_BK01_45_H      _PK_H_(0x01, 0x45)
#define REG_SC_BK01_46_L      _PK_L_(0x01, 0x46)
#define REG_SC_BK01_46_H      _PK_H_(0x01, 0x46)
#define REG_SC_BK01_47_L      _PK_L_(0x01, 0x47)
#define REG_SC_BK01_47_H      _PK_H_(0x01, 0x47)
#define REG_SC_BK01_48_L      _PK_L_(0x01, 0x48)
#define REG_SC_BK01_48_H      _PK_H_(0x01, 0x48)
#define REG_SC_BK01_49_L      _PK_L_(0x01, 0x49)
#define REG_SC_BK01_49_H      _PK_H_(0x01, 0x49)
#define REG_SC_BK01_4A_L      _PK_L_(0x01, 0x4A)
#define REG_SC_BK01_4A_H      _PK_H_(0x01, 0x4A)
#define REG_SC_BK01_4B_L      _PK_L_(0x01, 0x4B)
#define REG_SC_BK01_4B_H      _PK_H_(0x01, 0x4B)
#define REG_SC_BK01_4C_L      _PK_L_(0x01, 0x4C)
#define REG_SC_BK01_4C_H      _PK_H_(0x01, 0x4C)
#define REG_SC_BK01_4D_L      _PK_L_(0x01, 0x4D)
#define REG_SC_BK01_4D_H      _PK_H_(0x01, 0x4D)
#define REG_SC_BK01_4E_L      _PK_L_(0x01, 0x4E)
#define REG_SC_BK01_4E_H      _PK_H_(0x01, 0x4E)
#define REG_SC_BK01_4F_L      _PK_L_(0x01, 0x4F)
#define REG_SC_BK01_4F_H      _PK_H_(0x01, 0x4F)
#define REG_SC_BK01_50_L      _PK_L_(0x01, 0x50)
#define REG_SC_BK01_50_H      _PK_H_(0x01, 0x50)
#define REG_SC_BK01_51_L      _PK_L_(0x01, 0x51)
#define REG_SC_BK01_51_H      _PK_H_(0x01, 0x51)
#define REG_SC_BK01_52_L      _PK_L_(0x01, 0x52)
#define REG_SC_BK01_52_H      _PK_H_(0x01, 0x52)
#define REG_SC_BK01_53_L      _PK_L_(0x01, 0x53)
#define REG_SC_BK01_53_H      _PK_H_(0x01, 0x53)
#define REG_SC_BK01_54_L      _PK_L_(0x01, 0x54)
#define REG_SC_BK01_54_H      _PK_H_(0x01, 0x54)
#define REG_SC_BK01_55_L      _PK_L_(0x01, 0x55)
#define REG_SC_BK01_55_H      _PK_H_(0x01, 0x55)
#define REG_SC_BK01_56_L      _PK_L_(0x01, 0x56)
#define REG_SC_BK01_56_H      _PK_H_(0x01, 0x56)
#define REG_SC_BK01_57_L      _PK_L_(0x01, 0x57)
#define REG_SC_BK01_57_H      _PK_H_(0x01, 0x57)
#define REG_SC_BK01_58_L      _PK_L_(0x01, 0x58)
#define REG_SC_BK01_58_H      _PK_H_(0x01, 0x58)
#define REG_SC_BK01_59_L      _PK_L_(0x01, 0x59)
#define REG_SC_BK01_59_H      _PK_H_(0x01, 0x59)
#define REG_SC_BK01_5A_L      _PK_L_(0x01, 0x5A)
#define REG_SC_BK01_5A_H      _PK_H_(0x01, 0x5A)
#define REG_SC_BK01_5B_L      _PK_L_(0x01, 0x5B)
#define REG_SC_BK01_5B_H      _PK_H_(0x01, 0x5B)
#define REG_SC_BK01_5C_L      _PK_L_(0x01, 0x5C)
#define REG_SC_BK01_5C_H      _PK_H_(0x01, 0x5C)
#define REG_SC_BK01_5D_L      _PK_L_(0x01, 0x5D)
#define REG_SC_BK01_5D_H      _PK_H_(0x01, 0x5D)
#define REG_SC_BK01_5E_L      _PK_L_(0x01, 0x5E)
#define REG_SC_BK01_5E_H      _PK_H_(0x01, 0x5E)
#define REG_SC_BK01_5F_L      _PK_L_(0x01, 0x5F)
#define REG_SC_BK01_5F_H      _PK_H_(0x01, 0x5F)
#define REG_SC_BK01_60_L      _PK_L_(0x01, 0x60)
#define REG_SC_BK01_60_H      _PK_H_(0x01, 0x60)
#define REG_SC_BK01_61_L      _PK_L_(0x01, 0x61)
#define REG_SC_BK01_61_H      _PK_H_(0x01, 0x61)
#define REG_SC_BK01_62_L      _PK_L_(0x01, 0x62)
#define REG_SC_BK01_62_H      _PK_H_(0x01, 0x62)
#define REG_SC_BK01_63_L      _PK_L_(0x01, 0x63)
#define REG_SC_BK01_63_H      _PK_H_(0x01, 0x63)
#define REG_SC_BK01_64_L      _PK_L_(0x01, 0x64)
#define REG_SC_BK01_64_H      _PK_H_(0x01, 0x64)
#define REG_SC_BK01_65_L      _PK_L_(0x01, 0x65)
#define REG_SC_BK01_65_H      _PK_H_(0x01, 0x65)
#define REG_SC_BK01_66_L      _PK_L_(0x01, 0x66)
#define REG_SC_BK01_66_H      _PK_H_(0x01, 0x66)
#define REG_SC_BK01_67_L      _PK_L_(0x01, 0x67)
#define REG_SC_BK01_67_H      _PK_H_(0x01, 0x67)
#define REG_SC_BK01_68_L      _PK_L_(0x01, 0x68)
#define REG_SC_BK01_68_H      _PK_H_(0x01, 0x68)
#define REG_SC_BK01_69_L      _PK_L_(0x01, 0x69)
#define REG_SC_BK01_69_H      _PK_H_(0x01, 0x69)
#define REG_SC_BK01_6A_L      _PK_L_(0x01, 0x6A)
#define REG_SC_BK01_6A_H      _PK_H_(0x01, 0x6A)
#define REG_SC_BK01_6B_L      _PK_L_(0x01, 0x6B)
#define REG_SC_BK01_6B_H      _PK_H_(0x01, 0x6B)
#define REG_SC_BK01_6C_L      _PK_L_(0x01, 0x6C)
#define REG_SC_BK01_6C_H      _PK_H_(0x01, 0x6C)
#define REG_SC_BK01_6D_L      _PK_L_(0x01, 0x6D)
#define REG_SC_BK01_6D_H      _PK_H_(0x01, 0x6D)
#define REG_SC_BK01_6E_L      _PK_L_(0x01, 0x6E)
#define REG_SC_BK01_6E_H      _PK_H_(0x01, 0x6E)
#define REG_SC_BK01_6F_L      _PK_L_(0x01, 0x6F)
#define REG_SC_BK01_6F_H      _PK_H_(0x01, 0x6F)
#define REG_SC_BK01_70_L      _PK_L_(0x01, 0x70)
#define REG_SC_BK01_70_H      _PK_H_(0x01, 0x70)
#define REG_SC_BK01_71_L      _PK_L_(0x01, 0x71)
#define REG_SC_BK01_71_H      _PK_H_(0x01, 0x71)
#define REG_SC_BK01_72_L      _PK_L_(0x01, 0x72)
#define REG_SC_BK01_72_H      _PK_H_(0x01, 0x72)
#define REG_SC_BK01_73_L      _PK_L_(0x01, 0x73)
#define REG_SC_BK01_73_H      _PK_H_(0x01, 0x73)
#define REG_SC_BK01_74_L      _PK_L_(0x01, 0x74)
#define REG_SC_BK01_74_H      _PK_H_(0x01, 0x74)
#define REG_SC_BK01_75_L      _PK_L_(0x01, 0x75)
#define REG_SC_BK01_75_H      _PK_H_(0x01, 0x75)
#define REG_SC_BK01_76_L      _PK_L_(0x01, 0x76)
#define REG_SC_BK01_76_H      _PK_H_(0x01, 0x76)
#define REG_SC_BK01_77_L      _PK_L_(0x01, 0x77)
#define REG_SC_BK01_77_H      _PK_H_(0x01, 0x77)
#define REG_SC_BK01_78_L      _PK_L_(0x01, 0x78)
#define REG_SC_BK01_78_H      _PK_H_(0x01, 0x78)
#define REG_SC_BK01_79_L      _PK_L_(0x01, 0x79)
#define REG_SC_BK01_79_H      _PK_H_(0x01, 0x79)
#define REG_SC_BK01_7A_L      _PK_L_(0x01, 0x7A)
#define REG_SC_BK01_7A_H      _PK_H_(0x01, 0x7A)
#define REG_SC_BK01_7B_L      _PK_L_(0x01, 0x7B)
#define REG_SC_BK01_7B_H      _PK_H_(0x01, 0x7B)
#define REG_SC_BK01_7C_L      _PK_L_(0x01, 0x7C)
#define REG_SC_BK01_7C_H      _PK_H_(0x01, 0x7C)
#define REG_SC_BK01_7D_L      _PK_L_(0x01, 0x7D)
#define REG_SC_BK01_7D_H      _PK_H_(0x01, 0x7D)
#define REG_SC_BK01_7E_L      _PK_L_(0x01, 0x7E)
#define REG_SC_BK01_7E_H      _PK_H_(0x01, 0x7E)
#define REG_SC_BK01_7F_L      _PK_L_(0x01, 0x7F)
#define REG_SC_BK01_7F_H      _PK_H_(0x01, 0x7F)
//----------------------------------------------
#define REG_SC_BK02_00_L      _PK_L_(0x02, 0x00)
#define REG_SC_BK02_00_H      _PK_H_(0x02, 0x00)
#define REG_SC_BK02_01_L      _PK_L_(0x02, 0x01)
#define REG_SC_BK02_01_H      _PK_H_(0x02, 0x01)
#define REG_SC_BK02_02_L      _PK_L_(0x02, 0x02)
#define REG_SC_BK02_02_H      _PK_H_(0x02, 0x02)
#define REG_SC_BK02_03_L      _PK_L_(0x02, 0x03)
#define REG_SC_BK02_03_H      _PK_H_(0x02, 0x03)
#define REG_SC_BK02_04_L      _PK_L_(0x02, 0x04)
#define REG_SC_BK02_04_H      _PK_H_(0x02, 0x04)
#define REG_SC_BK02_05_L      _PK_L_(0x02, 0x05)
#define REG_SC_BK02_05_H      _PK_H_(0x02, 0x05)
#define REG_SC_BK02_06_L      _PK_L_(0x02, 0x06)
#define REG_SC_BK02_06_H      _PK_H_(0x02, 0x06)
#define REG_SC_BK02_07_L      _PK_L_(0x02, 0x07)
#define REG_SC_BK02_07_H      _PK_H_(0x02, 0x07)
#define REG_SC_BK02_08_L      _PK_L_(0x02, 0x08)
#define REG_SC_BK02_08_H      _PK_H_(0x02, 0x08)
#define REG_SC_BK02_09_L      _PK_L_(0x02, 0x09)
#define REG_SC_BK02_09_H      _PK_H_(0x02, 0x09)
#define REG_SC_BK02_0A_L      _PK_L_(0x02, 0x0A)
#define REG_SC_BK02_0A_H      _PK_H_(0x02, 0x0A)
#define REG_SC_BK02_0B_L      _PK_L_(0x02, 0x0B)
#define REG_SC_BK02_0B_H      _PK_H_(0x02, 0x0B)
#define REG_SC_BK02_0C_L      _PK_L_(0x02, 0x0C)
#define REG_SC_BK02_0C_H      _PK_H_(0x02, 0x0C)
#define REG_SC_BK02_0D_L      _PK_L_(0x02, 0x0D)
#define REG_SC_BK02_0D_H      _PK_H_(0x02, 0x0D)
#define REG_SC_BK02_0E_L      _PK_L_(0x02, 0x0E)
#define REG_SC_BK02_0E_H      _PK_H_(0x02, 0x0E)
#define REG_SC_BK02_0F_L      _PK_L_(0x02, 0x0F)
#define REG_SC_BK02_0F_H      _PK_H_(0x02, 0x0F)
#define REG_SC_BK02_10_L      _PK_L_(0x02, 0x10)
#define REG_SC_BK02_10_H      _PK_H_(0x02, 0x10)
#define REG_SC_BK02_11_L      _PK_L_(0x02, 0x11)
#define REG_SC_BK02_11_H      _PK_H_(0x02, 0x11)
#define REG_SC_BK02_12_L      _PK_L_(0x02, 0x12)
#define REG_SC_BK02_12_H      _PK_H_(0x02, 0x12)
#define REG_SC_BK02_13_L      _PK_L_(0x02, 0x13)
#define REG_SC_BK02_13_H      _PK_H_(0x02, 0x13)
#define REG_SC_BK02_14_L      _PK_L_(0x02, 0x14)
#define REG_SC_BK02_14_H      _PK_H_(0x02, 0x14)
#define REG_SC_BK02_15_L      _PK_L_(0x02, 0x15)
#define REG_SC_BK02_15_H      _PK_H_(0x02, 0x15)
#define REG_SC_BK02_16_L      _PK_L_(0x02, 0x16)
#define REG_SC_BK02_16_H      _PK_H_(0x02, 0x16)
#define REG_SC_BK02_17_L      _PK_L_(0x02, 0x17)
#define REG_SC_BK02_17_H      _PK_H_(0x02, 0x17)
#define REG_SC_BK02_18_L      _PK_L_(0x02, 0x18)
#define REG_SC_BK02_18_H      _PK_H_(0x02, 0x18)
#define REG_SC_BK02_19_L      _PK_L_(0x02, 0x19)
#define REG_SC_BK02_19_H      _PK_H_(0x02, 0x19)
#define REG_SC_BK02_1A_L      _PK_L_(0x02, 0x1A)
#define REG_SC_BK02_1A_H      _PK_H_(0x02, 0x1A)
#define REG_SC_BK02_1B_L      _PK_L_(0x02, 0x1B)
#define REG_SC_BK02_1B_H      _PK_H_(0x02, 0x1B)
#define REG_SC_BK02_1C_L      _PK_L_(0x02, 0x1C)
#define REG_SC_BK02_1C_H      _PK_H_(0x02, 0x1C)
#define REG_SC_BK02_1D_L      _PK_L_(0x02, 0x1D)
#define REG_SC_BK02_1D_H      _PK_H_(0x02, 0x1D)
#define REG_SC_BK02_1E_L      _PK_L_(0x02, 0x1E)
#define REG_SC_BK02_1E_H      _PK_H_(0x02, 0x1E)
#define REG_SC_BK02_1F_L      _PK_L_(0x02, 0x1F)
#define REG_SC_BK02_1F_H      _PK_H_(0x02, 0x1F)
#define REG_SC_BK02_20_L      _PK_L_(0x02, 0x20)
#define REG_SC_BK02_20_H      _PK_H_(0x02, 0x20)
#define REG_SC_BK02_21_L      _PK_L_(0x02, 0x21)
#define REG_SC_BK02_21_H      _PK_H_(0x02, 0x21)
#define REG_SC_BK02_22_L      _PK_L_(0x02, 0x22)
#define REG_SC_BK02_22_H      _PK_H_(0x02, 0x22)
#define REG_SC_BK02_23_L      _PK_L_(0x02, 0x23)
#define REG_SC_BK02_23_H      _PK_H_(0x02, 0x23)
#define REG_SC_BK02_24_L      _PK_L_(0x02, 0x24)
#define REG_SC_BK02_24_H      _PK_H_(0x02, 0x24)
#define REG_SC_BK02_25_L      _PK_L_(0x02, 0x25)
#define REG_SC_BK02_25_H      _PK_H_(0x02, 0x25)
#define REG_SC_BK02_26_L      _PK_L_(0x02, 0x26)
#define REG_SC_BK02_26_H      _PK_H_(0x02, 0x26)
#define REG_SC_BK02_27_L      _PK_L_(0x02, 0x27)
#define REG_SC_BK02_27_H      _PK_H_(0x02, 0x27)
#define REG_SC_BK02_28_L      _PK_L_(0x02, 0x28)
#define REG_SC_BK02_28_H      _PK_H_(0x02, 0x28)
#define REG_SC_BK02_29_L      _PK_L_(0x02, 0x29)
#define REG_SC_BK02_29_H      _PK_H_(0x02, 0x29)
#define REG_SC_BK02_2A_L      _PK_L_(0x02, 0x2A)
#define REG_SC_BK02_2A_H      _PK_H_(0x02, 0x2A)
#define REG_SC_BK02_2B_L      _PK_L_(0x02, 0x2B)
#define REG_SC_BK02_2B_H      _PK_H_(0x02, 0x2B)
#define REG_SC_BK02_2C_L      _PK_L_(0x02, 0x2C)
#define REG_SC_BK02_2C_H      _PK_H_(0x02, 0x2C)
#define REG_SC_BK02_2D_L      _PK_L_(0x02, 0x2D)
#define REG_SC_BK02_2D_H      _PK_H_(0x02, 0x2D)
#define REG_SC_BK02_2E_L      _PK_L_(0x02, 0x2E)
#define REG_SC_BK02_2E_H      _PK_H_(0x02, 0x2E)
#define REG_SC_BK02_2F_L      _PK_L_(0x02, 0x2F)
#define REG_SC_BK02_2F_H      _PK_H_(0x02, 0x2F)
#define REG_SC_BK02_30_L      _PK_L_(0x02, 0x30)
#define REG_SC_BK02_30_H      _PK_H_(0x02, 0x30)
#define REG_SC_BK02_31_L      _PK_L_(0x02, 0x31)
#define REG_SC_BK02_31_H      _PK_H_(0x02, 0x31)
#define REG_SC_BK02_32_L      _PK_L_(0x02, 0x32)
#define REG_SC_BK02_32_H      _PK_H_(0x02, 0x32)
#define REG_SC_BK02_33_L      _PK_L_(0x02, 0x33)
#define REG_SC_BK02_33_H      _PK_H_(0x02, 0x33)
#define REG_SC_BK02_34_L      _PK_L_(0x02, 0x34)
#define REG_SC_BK02_34_H      _PK_H_(0x02, 0x34)
#define REG_SC_BK02_35_L      _PK_L_(0x02, 0x35)
#define REG_SC_BK02_35_H      _PK_H_(0x02, 0x35)
#define REG_SC_BK02_36_L      _PK_L_(0x02, 0x36)
#define REG_SC_BK02_36_H      _PK_H_(0x02, 0x36)
#define REG_SC_BK02_37_L      _PK_L_(0x02, 0x37)
#define REG_SC_BK02_37_H      _PK_H_(0x02, 0x37)
#define REG_SC_BK02_38_L      _PK_L_(0x02, 0x38)
#define REG_SC_BK02_38_H      _PK_H_(0x02, 0x38)
#define REG_SC_BK02_39_L      _PK_L_(0x02, 0x39)
#define REG_SC_BK02_39_H      _PK_H_(0x02, 0x39)
#define REG_SC_BK02_3A_L      _PK_L_(0x02, 0x3A)
#define REG_SC_BK02_3A_H      _PK_H_(0x02, 0x3A)
#define REG_SC_BK02_3B_L      _PK_L_(0x02, 0x3B)
#define REG_SC_BK02_3B_H      _PK_H_(0x02, 0x3B)
#define REG_SC_BK02_3C_L      _PK_L_(0x02, 0x3C)
#define REG_SC_BK02_3C_H      _PK_H_(0x02, 0x3C)
#define REG_SC_BK02_3D_L      _PK_L_(0x02, 0x3D)
#define REG_SC_BK02_3D_H      _PK_H_(0x02, 0x3D)
#define REG_SC_BK02_3E_L      _PK_L_(0x02, 0x3E)
#define REG_SC_BK02_3E_H      _PK_H_(0x02, 0x3E)
#define REG_SC_BK02_3F_L      _PK_L_(0x02, 0x3F)
#define REG_SC_BK02_3F_H      _PK_H_(0x02, 0x3F)
#define REG_SC_BK02_40_L      _PK_L_(0x02, 0x40)
#define REG_SC_BK02_40_H      _PK_H_(0x02, 0x40)
#define REG_SC_BK02_41_L      _PK_L_(0x02, 0x41)
#define REG_SC_BK02_41_H      _PK_H_(0x02, 0x41)
#define REG_SC_BK02_42_L      _PK_L_(0x02, 0x42)
#define REG_SC_BK02_42_H      _PK_H_(0x02, 0x42)
#define REG_SC_BK02_43_L      _PK_L_(0x02, 0x43)
#define REG_SC_BK02_43_H      _PK_H_(0x02, 0x43)
#define REG_SC_BK02_44_L      _PK_L_(0x02, 0x44)
#define REG_SC_BK02_44_H      _PK_H_(0x02, 0x44)
#define REG_SC_BK02_45_L      _PK_L_(0x02, 0x45)
#define REG_SC_BK02_45_H      _PK_H_(0x02, 0x45)
#define REG_SC_BK02_46_L      _PK_L_(0x02, 0x46)
#define REG_SC_BK02_46_H      _PK_H_(0x02, 0x46)
#define REG_SC_BK02_47_L      _PK_L_(0x02, 0x47)
#define REG_SC_BK02_47_H      _PK_H_(0x02, 0x47)
#define REG_SC_BK02_48_L      _PK_L_(0x02, 0x48)
#define REG_SC_BK02_48_H      _PK_H_(0x02, 0x48)
#define REG_SC_BK02_49_L      _PK_L_(0x02, 0x49)
#define REG_SC_BK02_49_H      _PK_H_(0x02, 0x49)
#define REG_SC_BK02_4A_L      _PK_L_(0x02, 0x4A)
#define REG_SC_BK02_4A_H      _PK_H_(0x02, 0x4A)
#define REG_SC_BK02_4B_L      _PK_L_(0x02, 0x4B)
#define REG_SC_BK02_4B_H      _PK_H_(0x02, 0x4B)
#define REG_SC_BK02_4C_L      _PK_L_(0x02, 0x4C)
#define REG_SC_BK02_4C_H      _PK_H_(0x02, 0x4C)
#define REG_SC_BK02_4D_L      _PK_L_(0x02, 0x4D)
#define REG_SC_BK02_4D_H      _PK_H_(0x02, 0x4D)
#define REG_SC_BK02_4E_L      _PK_L_(0x02, 0x4E)
#define REG_SC_BK02_4E_H      _PK_H_(0x02, 0x4E)
#define REG_SC_BK02_4F_L      _PK_L_(0x02, 0x4F)
#define REG_SC_BK02_4F_H      _PK_H_(0x02, 0x4F)
#define REG_SC_BK02_50_L      _PK_L_(0x02, 0x50)
#define REG_SC_BK02_50_H      _PK_H_(0x02, 0x50)
#define REG_SC_BK02_51_L      _PK_L_(0x02, 0x51)
#define REG_SC_BK02_51_H      _PK_H_(0x02, 0x51)
#define REG_SC_BK02_52_L      _PK_L_(0x02, 0x52)
#define REG_SC_BK02_52_H      _PK_H_(0x02, 0x52)
#define REG_SC_BK02_53_L      _PK_L_(0x02, 0x53)
#define REG_SC_BK02_53_H      _PK_H_(0x02, 0x53)
#define REG_SC_BK02_54_L      _PK_L_(0x02, 0x54)
#define REG_SC_BK02_54_H      _PK_H_(0x02, 0x54)
#define REG_SC_BK02_55_L      _PK_L_(0x02, 0x55)
#define REG_SC_BK02_55_H      _PK_H_(0x02, 0x55)
#define REG_SC_BK02_56_L      _PK_L_(0x02, 0x56)
#define REG_SC_BK02_56_H      _PK_H_(0x02, 0x56)
#define REG_SC_BK02_57_L      _PK_L_(0x02, 0x57)
#define REG_SC_BK02_57_H      _PK_H_(0x02, 0x57)
#define REG_SC_BK02_58_L      _PK_L_(0x02, 0x58)
#define REG_SC_BK02_58_H      _PK_H_(0x02, 0x58)
#define REG_SC_BK02_59_L      _PK_L_(0x02, 0x59)
#define REG_SC_BK02_59_H      _PK_H_(0x02, 0x59)
#define REG_SC_BK02_5A_L      _PK_L_(0x02, 0x5A)
#define REG_SC_BK02_5A_H      _PK_H_(0x02, 0x5A)
#define REG_SC_BK02_5B_L      _PK_L_(0x02, 0x5B)
#define REG_SC_BK02_5B_H      _PK_H_(0x02, 0x5B)
#define REG_SC_BK02_5C_L      _PK_L_(0x02, 0x5C)
#define REG_SC_BK02_5C_H      _PK_H_(0x02, 0x5C)
#define REG_SC_BK02_5D_L      _PK_L_(0x02, 0x5D)
#define REG_SC_BK02_5D_H      _PK_H_(0x02, 0x5D)
#define REG_SC_BK02_5E_L      _PK_L_(0x02, 0x5E)
#define REG_SC_BK02_5E_H      _PK_H_(0x02, 0x5E)
#define REG_SC_BK02_5F_L      _PK_L_(0x02, 0x5F)
#define REG_SC_BK02_5F_H      _PK_H_(0x02, 0x5F)
#define REG_SC_BK02_60_L      _PK_L_(0x02, 0x60)
#define REG_SC_BK02_60_H      _PK_H_(0x02, 0x60)
#define REG_SC_BK02_61_L      _PK_L_(0x02, 0x61)
#define REG_SC_BK02_61_H      _PK_H_(0x02, 0x61)
#define REG_SC_BK02_62_L      _PK_L_(0x02, 0x62)
#define REG_SC_BK02_62_H      _PK_H_(0x02, 0x62)
#define REG_SC_BK02_63_L      _PK_L_(0x02, 0x63)
#define REG_SC_BK02_63_H      _PK_H_(0x02, 0x63)
#define REG_SC_BK02_64_L      _PK_L_(0x02, 0x64)
#define REG_SC_BK02_64_H      _PK_H_(0x02, 0x64)
#define REG_SC_BK02_65_L      _PK_L_(0x02, 0x65)
#define REG_SC_BK02_65_H      _PK_H_(0x02, 0x65)
#define REG_SC_BK02_66_L      _PK_L_(0x02, 0x66)
#define REG_SC_BK02_66_H      _PK_H_(0x02, 0x66)
#define REG_SC_BK02_67_L      _PK_L_(0x02, 0x67)
#define REG_SC_BK02_67_H      _PK_H_(0x02, 0x67)
#define REG_SC_BK02_68_L      _PK_L_(0x02, 0x68)
#define REG_SC_BK02_68_H      _PK_H_(0x02, 0x68)
#define REG_SC_BK02_69_L      _PK_L_(0x02, 0x69)
#define REG_SC_BK02_69_H      _PK_H_(0x02, 0x69)
#define REG_SC_BK02_6A_L      _PK_L_(0x02, 0x6A)
#define REG_SC_BK02_6A_H      _PK_H_(0x02, 0x6A)
#define REG_SC_BK02_6B_L      _PK_L_(0x02, 0x6B)
#define REG_SC_BK02_6B_H      _PK_H_(0x02, 0x6B)
#define REG_SC_BK02_6C_L      _PK_L_(0x02, 0x6C)
#define REG_SC_BK02_6C_H      _PK_H_(0x02, 0x6C)
#define REG_SC_BK02_6D_L      _PK_L_(0x02, 0x6D)
#define REG_SC_BK02_6D_H      _PK_H_(0x02, 0x6D)
#define REG_SC_BK02_6E_L      _PK_L_(0x02, 0x6E)
#define REG_SC_BK02_6E_H      _PK_H_(0x02, 0x6E)
#define REG_SC_BK02_6F_L      _PK_L_(0x02, 0x6F)
#define REG_SC_BK02_6F_H      _PK_H_(0x02, 0x6F)
#define REG_SC_BK02_70_L      _PK_L_(0x02, 0x70)
#define REG_SC_BK02_70_H      _PK_H_(0x02, 0x70)
#define REG_SC_BK02_71_L      _PK_L_(0x02, 0x71)
#define REG_SC_BK02_71_H      _PK_H_(0x02, 0x71)
#define REG_SC_BK02_72_L      _PK_L_(0x02, 0x72)
#define REG_SC_BK02_72_H      _PK_H_(0x02, 0x72)
#define REG_SC_BK02_73_L      _PK_L_(0x02, 0x73)
#define REG_SC_BK02_73_H      _PK_H_(0x02, 0x73)
#define REG_SC_BK02_74_L      _PK_L_(0x02, 0x74)
#define REG_SC_BK02_74_H      _PK_H_(0x02, 0x74)
#define REG_SC_BK02_75_L      _PK_L_(0x02, 0x75)
#define REG_SC_BK02_75_H      _PK_H_(0x02, 0x75)
#define REG_SC_BK02_76_L      _PK_L_(0x02, 0x76)
#define REG_SC_BK02_76_H      _PK_H_(0x02, 0x76)
#define REG_SC_BK02_77_L      _PK_L_(0x02, 0x77)
#define REG_SC_BK02_77_H      _PK_H_(0x02, 0x77)
#define REG_SC_BK02_78_L      _PK_L_(0x02, 0x78)
#define REG_SC_BK02_78_H      _PK_H_(0x02, 0x78)
#define REG_SC_BK02_79_L      _PK_L_(0x02, 0x79)
#define REG_SC_BK02_79_H      _PK_H_(0x02, 0x79)
#define REG_SC_BK02_7A_L      _PK_L_(0x02, 0x7A)
#define REG_SC_BK02_7A_H      _PK_H_(0x02, 0x7A)
#define REG_SC_BK02_7B_L      _PK_L_(0x02, 0x7B)
#define REG_SC_BK02_7B_H      _PK_H_(0x02, 0x7B)
#define REG_SC_BK02_7C_L      _PK_L_(0x02, 0x7C)
#define REG_SC_BK02_7C_H      _PK_H_(0x02, 0x7C)
#define REG_SC_BK02_7D_L      _PK_L_(0x02, 0x7D)
#define REG_SC_BK02_7D_H      _PK_H_(0x02, 0x7D)
#define REG_SC_BK02_7E_L      _PK_L_(0x02, 0x7E)
#define REG_SC_BK02_7E_H      _PK_H_(0x02, 0x7E)
#define REG_SC_BK02_7F_L      _PK_L_(0x02, 0x7F)
#define REG_SC_BK02_7F_H      _PK_H_(0x02, 0x7F)
//----------------------------------------------
#define REG_SC_BK03_00_L      _PK_L_(0x03, 0x00)
#define REG_SC_BK03_00_H      _PK_H_(0x03, 0x00)
#define REG_SC_BK03_01_L      _PK_L_(0x03, 0x01)
#define REG_SC_BK03_01_H      _PK_H_(0x03, 0x01)
#define REG_SC_BK03_02_L      _PK_L_(0x03, 0x02)
#define REG_SC_BK03_02_H      _PK_H_(0x03, 0x02)
#define REG_SC_BK03_03_L      _PK_L_(0x03, 0x03)
#define REG_SC_BK03_03_H      _PK_H_(0x03, 0x03)
#define REG_SC_BK03_04_L      _PK_L_(0x03, 0x04)
#define REG_SC_BK03_04_H      _PK_H_(0x03, 0x04)
#define REG_SC_BK03_05_L      _PK_L_(0x03, 0x05)
#define REG_SC_BK03_05_H      _PK_H_(0x03, 0x05)
#define REG_SC_BK03_06_L      _PK_L_(0x03, 0x06)
#define REG_SC_BK03_06_H      _PK_H_(0x03, 0x06)
#define REG_SC_BK03_07_L      _PK_L_(0x03, 0x07)
#define REG_SC_BK03_07_H      _PK_H_(0x03, 0x07)
#define REG_SC_BK03_08_L      _PK_L_(0x03, 0x08)
#define REG_SC_BK03_08_H      _PK_H_(0x03, 0x08)
#define REG_SC_BK03_09_L      _PK_L_(0x03, 0x09)
#define REG_SC_BK03_09_H      _PK_H_(0x03, 0x09)
#define REG_SC_BK03_0A_L      _PK_L_(0x03, 0x0A)
#define REG_SC_BK03_0A_H      _PK_H_(0x03, 0x0A)
#define REG_SC_BK03_0B_L      _PK_L_(0x03, 0x0B)
#define REG_SC_BK03_0B_H      _PK_H_(0x03, 0x0B)
#define REG_SC_BK03_0C_L      _PK_L_(0x03, 0x0C)
#define REG_SC_BK03_0C_H      _PK_H_(0x03, 0x0C)
#define REG_SC_BK03_0D_L      _PK_L_(0x03, 0x0D)
#define REG_SC_BK03_0D_H      _PK_H_(0x03, 0x0D)
#define REG_SC_BK03_0E_L      _PK_L_(0x03, 0x0E)
#define REG_SC_BK03_0E_H      _PK_H_(0x03, 0x0E)
#define REG_SC_BK03_0F_L      _PK_L_(0x03, 0x0F)
#define REG_SC_BK03_0F_H      _PK_H_(0x03, 0x0F)
#define REG_SC_BK03_10_L      _PK_L_(0x03, 0x10)
#define REG_SC_BK03_10_H      _PK_H_(0x03, 0x10)
#define REG_SC_BK03_11_L      _PK_L_(0x03, 0x11)
#define REG_SC_BK03_11_H      _PK_H_(0x03, 0x11)
#define REG_SC_BK03_12_L      _PK_L_(0x03, 0x12)
#define REG_SC_BK03_12_H      _PK_H_(0x03, 0x12)
#define REG_SC_BK03_13_L      _PK_L_(0x03, 0x13)
#define REG_SC_BK03_13_H      _PK_H_(0x03, 0x13)
#define REG_SC_BK03_14_L      _PK_L_(0x03, 0x14)
#define REG_SC_BK03_14_H      _PK_H_(0x03, 0x14)
#define REG_SC_BK03_15_L      _PK_L_(0x03, 0x15)
#define REG_SC_BK03_15_H      _PK_H_(0x03, 0x15)
#define REG_SC_BK03_16_L      _PK_L_(0x03, 0x16)
#define REG_SC_BK03_16_H      _PK_H_(0x03, 0x16)
#define REG_SC_BK03_17_L      _PK_L_(0x03, 0x17)
#define REG_SC_BK03_17_H      _PK_H_(0x03, 0x17)
#define REG_SC_BK03_18_L      _PK_L_(0x03, 0x18)
#define REG_SC_BK03_18_H      _PK_H_(0x03, 0x18)
#define REG_SC_BK03_19_L      _PK_L_(0x03, 0x19)
#define REG_SC_BK03_19_H      _PK_H_(0x03, 0x19)
#define REG_SC_BK03_1A_L      _PK_L_(0x03, 0x1A)
#define REG_SC_BK03_1A_H      _PK_H_(0x03, 0x1A)
#define REG_SC_BK03_1B_L      _PK_L_(0x03, 0x1B)
#define REG_SC_BK03_1B_H      _PK_H_(0x03, 0x1B)
#define REG_SC_BK03_1C_L      _PK_L_(0x03, 0x1C)
#define REG_SC_BK03_1C_H      _PK_H_(0x03, 0x1C)
#define REG_SC_BK03_1D_L      _PK_L_(0x03, 0x1D)
#define REG_SC_BK03_1D_H      _PK_H_(0x03, 0x1D)
#define REG_SC_BK03_1E_L      _PK_L_(0x03, 0x1E)
#define REG_SC_BK03_1E_H      _PK_H_(0x03, 0x1E)
#define REG_SC_BK03_1F_L      _PK_L_(0x03, 0x1F)
#define REG_SC_BK03_1F_H      _PK_H_(0x03, 0x1F)
#define REG_SC_BK03_20_L      _PK_L_(0x03, 0x20)
#define REG_SC_BK03_20_H      _PK_H_(0x03, 0x20)
#define REG_SC_BK03_21_L      _PK_L_(0x03, 0x21)
#define REG_SC_BK03_21_H      _PK_H_(0x03, 0x21)
#define REG_SC_BK03_22_L      _PK_L_(0x03, 0x22)
#define REG_SC_BK03_22_H      _PK_H_(0x03, 0x22)
#define REG_SC_BK03_23_L      _PK_L_(0x03, 0x23)
#define REG_SC_BK03_23_H      _PK_H_(0x03, 0x23)
#define REG_SC_BK03_24_L      _PK_L_(0x03, 0x24)
#define REG_SC_BK03_24_H      _PK_H_(0x03, 0x24)
#define REG_SC_BK03_25_L      _PK_L_(0x03, 0x25)
#define REG_SC_BK03_25_H      _PK_H_(0x03, 0x25)
#define REG_SC_BK03_26_L      _PK_L_(0x03, 0x26)
#define REG_SC_BK03_26_H      _PK_H_(0x03, 0x26)
#define REG_SC_BK03_27_L      _PK_L_(0x03, 0x27)
#define REG_SC_BK03_27_H      _PK_H_(0x03, 0x27)
#define REG_SC_BK03_28_L      _PK_L_(0x03, 0x28)
#define REG_SC_BK03_28_H      _PK_H_(0x03, 0x28)
#define REG_SC_BK03_29_L      _PK_L_(0x03, 0x29)
#define REG_SC_BK03_29_H      _PK_H_(0x03, 0x29)
#define REG_SC_BK03_2A_L      _PK_L_(0x03, 0x2A)
#define REG_SC_BK03_2A_H      _PK_H_(0x03, 0x2A)
#define REG_SC_BK03_2B_L      _PK_L_(0x03, 0x2B)
#define REG_SC_BK03_2B_H      _PK_H_(0x03, 0x2B)
#define REG_SC_BK03_2C_L      _PK_L_(0x03, 0x2C)
#define REG_SC_BK03_2C_H      _PK_H_(0x03, 0x2C)
#define REG_SC_BK03_2D_L      _PK_L_(0x03, 0x2D)
#define REG_SC_BK03_2D_H      _PK_H_(0x03, 0x2D)
#define REG_SC_BK03_2E_L      _PK_L_(0x03, 0x2E)
#define REG_SC_BK03_2E_H      _PK_H_(0x03, 0x2E)
#define REG_SC_BK03_2F_L      _PK_L_(0x03, 0x2F)
#define REG_SC_BK03_2F_H      _PK_H_(0x03, 0x2F)
#define REG_SC_BK03_30_L      _PK_L_(0x03, 0x30)
#define REG_SC_BK03_30_H      _PK_H_(0x03, 0x30)
#define REG_SC_BK03_31_L      _PK_L_(0x03, 0x31)
#define REG_SC_BK03_31_H      _PK_H_(0x03, 0x31)
#define REG_SC_BK03_32_L      _PK_L_(0x03, 0x32)
#define REG_SC_BK03_32_H      _PK_H_(0x03, 0x32)
#define REG_SC_BK03_33_L      _PK_L_(0x03, 0x33)
#define REG_SC_BK03_33_H      _PK_H_(0x03, 0x33)
#define REG_SC_BK03_34_L      _PK_L_(0x03, 0x34)
#define REG_SC_BK03_34_H      _PK_H_(0x03, 0x34)
#define REG_SC_BK03_35_L      _PK_L_(0x03, 0x35)
#define REG_SC_BK03_35_H      _PK_H_(0x03, 0x35)
#define REG_SC_BK03_36_L      _PK_L_(0x03, 0x36)
#define REG_SC_BK03_36_H      _PK_H_(0x03, 0x36)
#define REG_SC_BK03_37_L      _PK_L_(0x03, 0x37)
#define REG_SC_BK03_37_H      _PK_H_(0x03, 0x37)
#define REG_SC_BK03_38_L      _PK_L_(0x03, 0x38)
#define REG_SC_BK03_38_H      _PK_H_(0x03, 0x38)
#define REG_SC_BK03_39_L      _PK_L_(0x03, 0x39)
#define REG_SC_BK03_39_H      _PK_H_(0x03, 0x39)
#define REG_SC_BK03_3A_L      _PK_L_(0x03, 0x3A)
#define REG_SC_BK03_3A_H      _PK_H_(0x03, 0x3A)
#define REG_SC_BK03_3B_L      _PK_L_(0x03, 0x3B)
#define REG_SC_BK03_3B_H      _PK_H_(0x03, 0x3B)
#define REG_SC_BK03_3C_L      _PK_L_(0x03, 0x3C)
#define REG_SC_BK03_3C_H      _PK_H_(0x03, 0x3C)
#define REG_SC_BK03_3D_L      _PK_L_(0x03, 0x3D)
#define REG_SC_BK03_3D_H      _PK_H_(0x03, 0x3D)
#define REG_SC_BK03_3E_L      _PK_L_(0x03, 0x3E)
#define REG_SC_BK03_3E_H      _PK_H_(0x03, 0x3E)
#define REG_SC_BK03_3F_L      _PK_L_(0x03, 0x3F)
#define REG_SC_BK03_3F_H      _PK_H_(0x03, 0x3F)
#define REG_SC_BK03_40_L      _PK_L_(0x03, 0x40)
#define REG_SC_BK03_40_H      _PK_H_(0x03, 0x40)
#define REG_SC_BK03_41_L      _PK_L_(0x03, 0x41)
#define REG_SC_BK03_41_H      _PK_H_(0x03, 0x41)
#define REG_SC_BK03_42_L      _PK_L_(0x03, 0x42)
#define REG_SC_BK03_42_H      _PK_H_(0x03, 0x42)
#define REG_SC_BK03_43_L      _PK_L_(0x03, 0x43)
#define REG_SC_BK03_43_H      _PK_H_(0x03, 0x43)
#define REG_SC_BK03_44_L      _PK_L_(0x03, 0x44)
#define REG_SC_BK03_44_H      _PK_H_(0x03, 0x44)
#define REG_SC_BK03_45_L      _PK_L_(0x03, 0x45)
#define REG_SC_BK03_45_H      _PK_H_(0x03, 0x45)
#define REG_SC_BK03_46_L      _PK_L_(0x03, 0x46)
#define REG_SC_BK03_46_H      _PK_H_(0x03, 0x46)
#define REG_SC_BK03_47_L      _PK_L_(0x03, 0x47)
#define REG_SC_BK03_47_H      _PK_H_(0x03, 0x47)
#define REG_SC_BK03_48_L      _PK_L_(0x03, 0x48)
#define REG_SC_BK03_48_H      _PK_H_(0x03, 0x48)
#define REG_SC_BK03_49_L      _PK_L_(0x03, 0x49)
#define REG_SC_BK03_49_H      _PK_H_(0x03, 0x49)
#define REG_SC_BK03_4A_L      _PK_L_(0x03, 0x4A)
#define REG_SC_BK03_4A_H      _PK_H_(0x03, 0x4A)
#define REG_SC_BK03_4B_L      _PK_L_(0x03, 0x4B)
#define REG_SC_BK03_4B_H      _PK_H_(0x03, 0x4B)
#define REG_SC_BK03_4C_L      _PK_L_(0x03, 0x4C)
#define REG_SC_BK03_4C_H      _PK_H_(0x03, 0x4C)
#define REG_SC_BK03_4D_L      _PK_L_(0x03, 0x4D)
#define REG_SC_BK03_4D_H      _PK_H_(0x03, 0x4D)
#define REG_SC_BK03_4E_L      _PK_L_(0x03, 0x4E)
#define REG_SC_BK03_4E_H      _PK_H_(0x03, 0x4E)
#define REG_SC_BK03_4F_L      _PK_L_(0x03, 0x4F)
#define REG_SC_BK03_4F_H      _PK_H_(0x03, 0x4F)
#define REG_SC_BK03_50_L      _PK_L_(0x03, 0x50)
#define REG_SC_BK03_50_H      _PK_H_(0x03, 0x50)
#define REG_SC_BK03_51_L      _PK_L_(0x03, 0x51)
#define REG_SC_BK03_51_H      _PK_H_(0x03, 0x51)
#define REG_SC_BK03_52_L      _PK_L_(0x03, 0x52)
#define REG_SC_BK03_52_H      _PK_H_(0x03, 0x52)
#define REG_SC_BK03_53_L      _PK_L_(0x03, 0x53)
#define REG_SC_BK03_53_H      _PK_H_(0x03, 0x53)
#define REG_SC_BK03_54_L      _PK_L_(0x03, 0x54)
#define REG_SC_BK03_54_H      _PK_H_(0x03, 0x54)
#define REG_SC_BK03_55_L      _PK_L_(0x03, 0x55)
#define REG_SC_BK03_55_H      _PK_H_(0x03, 0x55)
#define REG_SC_BK03_56_L      _PK_L_(0x03, 0x56)
#define REG_SC_BK03_56_H      _PK_H_(0x03, 0x56)
#define REG_SC_BK03_57_L      _PK_L_(0x03, 0x57)
#define REG_SC_BK03_57_H      _PK_H_(0x03, 0x57)
#define REG_SC_BK03_58_L      _PK_L_(0x03, 0x58)
#define REG_SC_BK03_58_H      _PK_H_(0x03, 0x58)
#define REG_SC_BK03_59_L      _PK_L_(0x03, 0x59)
#define REG_SC_BK03_59_H      _PK_H_(0x03, 0x59)
#define REG_SC_BK03_5A_L      _PK_L_(0x03, 0x5A)
#define REG_SC_BK03_5A_H      _PK_H_(0x03, 0x5A)
#define REG_SC_BK03_5B_L      _PK_L_(0x03, 0x5B)
#define REG_SC_BK03_5B_H      _PK_H_(0x03, 0x5B)
#define REG_SC_BK03_5C_L      _PK_L_(0x03, 0x5C)
#define REG_SC_BK03_5C_H      _PK_H_(0x03, 0x5C)
#define REG_SC_BK03_5D_L      _PK_L_(0x03, 0x5D)
#define REG_SC_BK03_5D_H      _PK_H_(0x03, 0x5D)
#define REG_SC_BK03_5E_L      _PK_L_(0x03, 0x5E)
#define REG_SC_BK03_5E_H      _PK_H_(0x03, 0x5E)
#define REG_SC_BK03_5F_L      _PK_L_(0x03, 0x5F)
#define REG_SC_BK03_5F_H      _PK_H_(0x03, 0x5F)
#define REG_SC_BK03_60_L      _PK_L_(0x03, 0x60)
#define REG_SC_BK03_60_H      _PK_H_(0x03, 0x60)
#define REG_SC_BK03_61_L      _PK_L_(0x03, 0x61)
#define REG_SC_BK03_61_H      _PK_H_(0x03, 0x61)
#define REG_SC_BK03_62_L      _PK_L_(0x03, 0x62)
#define REG_SC_BK03_62_H      _PK_H_(0x03, 0x62)
#define REG_SC_BK03_63_L      _PK_L_(0x03, 0x63)
#define REG_SC_BK03_63_H      _PK_H_(0x03, 0x63)
#define REG_SC_BK03_64_L      _PK_L_(0x03, 0x64)
#define REG_SC_BK03_64_H      _PK_H_(0x03, 0x64)
#define REG_SC_BK03_65_L      _PK_L_(0x03, 0x65)
#define REG_SC_BK03_65_H      _PK_H_(0x03, 0x65)
#define REG_SC_BK03_66_L      _PK_L_(0x03, 0x66)
#define REG_SC_BK03_66_H      _PK_H_(0x03, 0x66)
#define REG_SC_BK03_67_L      _PK_L_(0x03, 0x67)
#define REG_SC_BK03_67_H      _PK_H_(0x03, 0x67)
#define REG_SC_BK03_68_L      _PK_L_(0x03, 0x68)
#define REG_SC_BK03_68_H      _PK_H_(0x03, 0x68)
#define REG_SC_BK03_69_L      _PK_L_(0x03, 0x69)
#define REG_SC_BK03_69_H      _PK_H_(0x03, 0x69)
#define REG_SC_BK03_6A_L      _PK_L_(0x03, 0x6A)
#define REG_SC_BK03_6A_H      _PK_H_(0x03, 0x6A)
#define REG_SC_BK03_6B_L      _PK_L_(0x03, 0x6B)
#define REG_SC_BK03_6B_H      _PK_H_(0x03, 0x6B)
#define REG_SC_BK03_6C_L      _PK_L_(0x03, 0x6C)
#define REG_SC_BK03_6C_H      _PK_H_(0x03, 0x6C)
#define REG_SC_BK03_6D_L      _PK_L_(0x03, 0x6D)
#define REG_SC_BK03_6D_H      _PK_H_(0x03, 0x6D)
#define REG_SC_BK03_6E_L      _PK_L_(0x03, 0x6E)
#define REG_SC_BK03_6E_H      _PK_H_(0x03, 0x6E)
#define REG_SC_BK03_6F_L      _PK_L_(0x03, 0x6F)
#define REG_SC_BK03_6F_H      _PK_H_(0x03, 0x6F)
#define REG_SC_BK03_70_L      _PK_L_(0x03, 0x70)
#define REG_SC_BK03_70_H      _PK_H_(0x03, 0x70)
#define REG_SC_BK03_71_L      _PK_L_(0x03, 0x71)
#define REG_SC_BK03_71_H      _PK_H_(0x03, 0x71)
#define REG_SC_BK03_72_L      _PK_L_(0x03, 0x72)
#define REG_SC_BK03_72_H      _PK_H_(0x03, 0x72)
#define REG_SC_BK03_73_L      _PK_L_(0x03, 0x73)
#define REG_SC_BK03_73_H      _PK_H_(0x03, 0x73)
#define REG_SC_BK03_74_L      _PK_L_(0x03, 0x74)
#define REG_SC_BK03_74_H      _PK_H_(0x03, 0x74)
#define REG_SC_BK03_75_L      _PK_L_(0x03, 0x75)
#define REG_SC_BK03_75_H      _PK_H_(0x03, 0x75)
#define REG_SC_BK03_76_L      _PK_L_(0x03, 0x76)
#define REG_SC_BK03_76_H      _PK_H_(0x03, 0x76)
#define REG_SC_BK03_77_L      _PK_L_(0x03, 0x77)
#define REG_SC_BK03_77_H      _PK_H_(0x03, 0x77)
#define REG_SC_BK03_78_L      _PK_L_(0x03, 0x78)
#define REG_SC_BK03_78_H      _PK_H_(0x03, 0x78)
#define REG_SC_BK03_79_L      _PK_L_(0x03, 0x79)
#define REG_SC_BK03_79_H      _PK_H_(0x03, 0x79)
#define REG_SC_BK03_7A_L      _PK_L_(0x03, 0x7A)
#define REG_SC_BK03_7A_H      _PK_H_(0x03, 0x7A)
#define REG_SC_BK03_7B_L      _PK_L_(0x03, 0x7B)
#define REG_SC_BK03_7B_H      _PK_H_(0x03, 0x7B)
#define REG_SC_BK03_7C_L      _PK_L_(0x03, 0x7C)
#define REG_SC_BK03_7C_H      _PK_H_(0x03, 0x7C)
#define REG_SC_BK03_7D_L      _PK_L_(0x03, 0x7D)
#define REG_SC_BK03_7D_H      _PK_H_(0x03, 0x7D)
#define REG_SC_BK03_7E_L      _PK_L_(0x03, 0x7E)
#define REG_SC_BK03_7E_H      _PK_H_(0x03, 0x7E)
#define REG_SC_BK03_7F_L      _PK_L_(0x03, 0x7F)
#define REG_SC_BK03_7F_H      _PK_H_(0x03, 0x7F)
//----------------------------------------------
#define REG_SC_BK04_00_L      _PK_L_(0x04, 0x00)
#define REG_SC_BK04_00_H      _PK_H_(0x04, 0x00)
#define REG_SC_BK04_01_L      _PK_L_(0x04, 0x01)
#define REG_SC_BK04_01_H      _PK_H_(0x04, 0x01)
#define REG_SC_BK04_02_L      _PK_L_(0x04, 0x02)
#define REG_SC_BK04_02_H      _PK_H_(0x04, 0x02)
#define REG_SC_BK04_03_L      _PK_L_(0x04, 0x03)
#define REG_SC_BK04_03_H      _PK_H_(0x04, 0x03)
#define REG_SC_BK04_04_L      _PK_L_(0x04, 0x04)
#define REG_SC_BK04_04_H      _PK_H_(0x04, 0x04)
#define REG_SC_BK04_05_L      _PK_L_(0x04, 0x05)
#define REG_SC_BK04_05_H      _PK_H_(0x04, 0x05)
#define REG_SC_BK04_06_L      _PK_L_(0x04, 0x06)
#define REG_SC_BK04_06_H      _PK_H_(0x04, 0x06)
#define REG_SC_BK04_07_L      _PK_L_(0x04, 0x07)
#define REG_SC_BK04_07_H      _PK_H_(0x04, 0x07)
#define REG_SC_BK04_08_L      _PK_L_(0x04, 0x08)
#define REG_SC_BK04_08_H      _PK_H_(0x04, 0x08)
#define REG_SC_BK04_09_L      _PK_L_(0x04, 0x09)
#define REG_SC_BK04_09_H      _PK_H_(0x04, 0x09)
#define REG_SC_BK04_0A_L      _PK_L_(0x04, 0x0A)
#define REG_SC_BK04_0A_H      _PK_H_(0x04, 0x0A)
#define REG_SC_BK04_0B_L      _PK_L_(0x04, 0x0B)
#define REG_SC_BK04_0B_H      _PK_H_(0x04, 0x0B)
#define REG_SC_BK04_0C_L      _PK_L_(0x04, 0x0C)
#define REG_SC_BK04_0C_H      _PK_H_(0x04, 0x0C)
#define REG_SC_BK04_0D_L      _PK_L_(0x04, 0x0D)
#define REG_SC_BK04_0D_H      _PK_H_(0x04, 0x0D)
#define REG_SC_BK04_0E_L      _PK_L_(0x04, 0x0E)
#define REG_SC_BK04_0E_H      _PK_H_(0x04, 0x0E)
#define REG_SC_BK04_0F_L      _PK_L_(0x04, 0x0F)
#define REG_SC_BK04_0F_H      _PK_H_(0x04, 0x0F)
#define REG_SC_BK04_10_L      _PK_L_(0x04, 0x10)
#define REG_SC_BK04_10_H      _PK_H_(0x04, 0x10)
#define REG_SC_BK04_11_L      _PK_L_(0x04, 0x11)
#define REG_SC_BK04_11_H      _PK_H_(0x04, 0x11)
#define REG_SC_BK04_12_L      _PK_L_(0x04, 0x12)
#define REG_SC_BK04_12_H      _PK_H_(0x04, 0x12)
#define REG_SC_BK04_13_L      _PK_L_(0x04, 0x13)
#define REG_SC_BK04_13_H      _PK_H_(0x04, 0x13)
#define REG_SC_BK04_14_L      _PK_L_(0x04, 0x14)
#define REG_SC_BK04_14_H      _PK_H_(0x04, 0x14)
#define REG_SC_BK04_15_L      _PK_L_(0x04, 0x15)
#define REG_SC_BK04_15_H      _PK_H_(0x04, 0x15)
#define REG_SC_BK04_16_L      _PK_L_(0x04, 0x16)
#define REG_SC_BK04_16_H      _PK_H_(0x04, 0x16)
#define REG_SC_BK04_17_L      _PK_L_(0x04, 0x17)
#define REG_SC_BK04_17_H      _PK_H_(0x04, 0x17)
#define REG_SC_BK04_18_L      _PK_L_(0x04, 0x18)
#define REG_SC_BK04_18_H      _PK_H_(0x04, 0x18)
#define REG_SC_BK04_19_L      _PK_L_(0x04, 0x19)
#define REG_SC_BK04_19_H      _PK_H_(0x04, 0x19)
#define REG_SC_BK04_1A_L      _PK_L_(0x04, 0x1A)
#define REG_SC_BK04_1A_H      _PK_H_(0x04, 0x1A)
#define REG_SC_BK04_1B_L      _PK_L_(0x04, 0x1B)
#define REG_SC_BK04_1B_H      _PK_H_(0x04, 0x1B)
#define REG_SC_BK04_1C_L      _PK_L_(0x04, 0x1C)
#define REG_SC_BK04_1C_H      _PK_H_(0x04, 0x1C)
#define REG_SC_BK04_1D_L      _PK_L_(0x04, 0x1D)
#define REG_SC_BK04_1D_H      _PK_H_(0x04, 0x1D)
#define REG_SC_BK04_1E_L      _PK_L_(0x04, 0x1E)
#define REG_SC_BK04_1E_H      _PK_H_(0x04, 0x1E)
#define REG_SC_BK04_1F_L      _PK_L_(0x04, 0x1F)
#define REG_SC_BK04_1F_H      _PK_H_(0x04, 0x1F)
#define REG_SC_BK04_20_L      _PK_L_(0x04, 0x20)
#define REG_SC_BK04_20_H      _PK_H_(0x04, 0x20)
#define REG_SC_BK04_21_L      _PK_L_(0x04, 0x21)
#define REG_SC_BK04_21_H      _PK_H_(0x04, 0x21)
#define REG_SC_BK04_22_L      _PK_L_(0x04, 0x22)
#define REG_SC_BK04_22_H      _PK_H_(0x04, 0x22)
#define REG_SC_BK04_23_L      _PK_L_(0x04, 0x23)
#define REG_SC_BK04_23_H      _PK_H_(0x04, 0x23)
#define REG_SC_BK04_24_L      _PK_L_(0x04, 0x24)
#define REG_SC_BK04_24_H      _PK_H_(0x04, 0x24)
#define REG_SC_BK04_25_L      _PK_L_(0x04, 0x25)
#define REG_SC_BK04_25_H      _PK_H_(0x04, 0x25)
#define REG_SC_BK04_26_L      _PK_L_(0x04, 0x26)
#define REG_SC_BK04_26_H      _PK_H_(0x04, 0x26)
#define REG_SC_BK04_27_L      _PK_L_(0x04, 0x27)
#define REG_SC_BK04_27_H      _PK_H_(0x04, 0x27)
#define REG_SC_BK04_28_L      _PK_L_(0x04, 0x28)
#define REG_SC_BK04_28_H      _PK_H_(0x04, 0x28)
#define REG_SC_BK04_29_L      _PK_L_(0x04, 0x29)
#define REG_SC_BK04_29_H      _PK_H_(0x04, 0x29)
#define REG_SC_BK04_2A_L      _PK_L_(0x04, 0x2A)
#define REG_SC_BK04_2A_H      _PK_H_(0x04, 0x2A)
#define REG_SC_BK04_2B_L      _PK_L_(0x04, 0x2B)
#define REG_SC_BK04_2B_H      _PK_H_(0x04, 0x2B)
#define REG_SC_BK04_2C_L      _PK_L_(0x04, 0x2C)
#define REG_SC_BK04_2C_H      _PK_H_(0x04, 0x2C)
#define REG_SC_BK04_2D_L      _PK_L_(0x04, 0x2D)
#define REG_SC_BK04_2D_H      _PK_H_(0x04, 0x2D)
#define REG_SC_BK04_2E_L      _PK_L_(0x04, 0x2E)
#define REG_SC_BK04_2E_H      _PK_H_(0x04, 0x2E)
#define REG_SC_BK04_2F_L      _PK_L_(0x04, 0x2F)
#define REG_SC_BK04_2F_H      _PK_H_(0x04, 0x2F)
#define REG_SC_BK04_30_L      _PK_L_(0x04, 0x30)
#define REG_SC_BK04_30_H      _PK_H_(0x04, 0x30)
#define REG_SC_BK04_31_L      _PK_L_(0x04, 0x31)
#define REG_SC_BK04_31_H      _PK_H_(0x04, 0x31)
#define REG_SC_BK04_32_L      _PK_L_(0x04, 0x32)
#define REG_SC_BK04_32_H      _PK_H_(0x04, 0x32)
#define REG_SC_BK04_33_L      _PK_L_(0x04, 0x33)
#define REG_SC_BK04_33_H      _PK_H_(0x04, 0x33)
#define REG_SC_BK04_34_L      _PK_L_(0x04, 0x34)
#define REG_SC_BK04_34_H      _PK_H_(0x04, 0x34)
#define REG_SC_BK04_35_L      _PK_L_(0x04, 0x35)
#define REG_SC_BK04_35_H      _PK_H_(0x04, 0x35)
#define REG_SC_BK04_36_L      _PK_L_(0x04, 0x36)
#define REG_SC_BK04_36_H      _PK_H_(0x04, 0x36)
#define REG_SC_BK04_37_L      _PK_L_(0x04, 0x37)
#define REG_SC_BK04_37_H      _PK_H_(0x04, 0x37)
#define REG_SC_BK04_38_L      _PK_L_(0x04, 0x38)
#define REG_SC_BK04_38_H      _PK_H_(0x04, 0x38)
#define REG_SC_BK04_39_L      _PK_L_(0x04, 0x39)
#define REG_SC_BK04_39_H      _PK_H_(0x04, 0x39)
#define REG_SC_BK04_3A_L      _PK_L_(0x04, 0x3A)
#define REG_SC_BK04_3A_H      _PK_H_(0x04, 0x3A)
#define REG_SC_BK04_3B_L      _PK_L_(0x04, 0x3B)
#define REG_SC_BK04_3B_H      _PK_H_(0x04, 0x3B)
#define REG_SC_BK04_3C_L      _PK_L_(0x04, 0x3C)
#define REG_SC_BK04_3C_H      _PK_H_(0x04, 0x3C)
#define REG_SC_BK04_3D_L      _PK_L_(0x04, 0x3D)
#define REG_SC_BK04_3D_H      _PK_H_(0x04, 0x3D)
#define REG_SC_BK04_3E_L      _PK_L_(0x04, 0x3E)
#define REG_SC_BK04_3E_H      _PK_H_(0x04, 0x3E)
#define REG_SC_BK04_3F_L      _PK_L_(0x04, 0x3F)
#define REG_SC_BK04_3F_H      _PK_H_(0x04, 0x3F)
#define REG_SC_BK04_40_L      _PK_L_(0x04, 0x40)
#define REG_SC_BK04_40_H      _PK_H_(0x04, 0x40)
#define REG_SC_BK04_41_L      _PK_L_(0x04, 0x41)
#define REG_SC_BK04_41_H      _PK_H_(0x04, 0x41)
#define REG_SC_BK04_42_L      _PK_L_(0x04, 0x42)
#define REG_SC_BK04_42_H      _PK_H_(0x04, 0x42)
#define REG_SC_BK04_43_L      _PK_L_(0x04, 0x43)
#define REG_SC_BK04_43_H      _PK_H_(0x04, 0x43)
#define REG_SC_BK04_44_L      _PK_L_(0x04, 0x44)
#define REG_SC_BK04_44_H      _PK_H_(0x04, 0x44)
#define REG_SC_BK04_45_L      _PK_L_(0x04, 0x45)
#define REG_SC_BK04_45_H      _PK_H_(0x04, 0x45)
#define REG_SC_BK04_46_L      _PK_L_(0x04, 0x46)
#define REG_SC_BK04_46_H      _PK_H_(0x04, 0x46)
#define REG_SC_BK04_47_L      _PK_L_(0x04, 0x47)
#define REG_SC_BK04_47_H      _PK_H_(0x04, 0x47)
#define REG_SC_BK04_48_L      _PK_L_(0x04, 0x48)
#define REG_SC_BK04_48_H      _PK_H_(0x04, 0x48)
#define REG_SC_BK04_49_L      _PK_L_(0x04, 0x49)
#define REG_SC_BK04_49_H      _PK_H_(0x04, 0x49)
#define REG_SC_BK04_4A_L      _PK_L_(0x04, 0x4A)
#define REG_SC_BK04_4A_H      _PK_H_(0x04, 0x4A)
#define REG_SC_BK04_4B_L      _PK_L_(0x04, 0x4B)
#define REG_SC_BK04_4B_H      _PK_H_(0x04, 0x4B)
#define REG_SC_BK04_4C_L      _PK_L_(0x04, 0x4C)
#define REG_SC_BK04_4C_H      _PK_H_(0x04, 0x4C)
#define REG_SC_BK04_4D_L      _PK_L_(0x04, 0x4D)
#define REG_SC_BK04_4D_H      _PK_H_(0x04, 0x4D)
#define REG_SC_BK04_4E_L      _PK_L_(0x04, 0x4E)
#define REG_SC_BK04_4E_H      _PK_H_(0x04, 0x4E)
#define REG_SC_BK04_4F_L      _PK_L_(0x04, 0x4F)
#define REG_SC_BK04_4F_H      _PK_H_(0x04, 0x4F)
#define REG_SC_BK04_50_L      _PK_L_(0x04, 0x50)
#define REG_SC_BK04_50_H      _PK_H_(0x04, 0x50)
#define REG_SC_BK04_51_L      _PK_L_(0x04, 0x51)
#define REG_SC_BK04_51_H      _PK_H_(0x04, 0x51)
#define REG_SC_BK04_52_L      _PK_L_(0x04, 0x52)
#define REG_SC_BK04_52_H      _PK_H_(0x04, 0x52)
#define REG_SC_BK04_53_L      _PK_L_(0x04, 0x53)
#define REG_SC_BK04_53_H      _PK_H_(0x04, 0x53)
#define REG_SC_BK04_54_L      _PK_L_(0x04, 0x54)
#define REG_SC_BK04_54_H      _PK_H_(0x04, 0x54)
#define REG_SC_BK04_55_L      _PK_L_(0x04, 0x55)
#define REG_SC_BK04_55_H      _PK_H_(0x04, 0x55)
#define REG_SC_BK04_56_L      _PK_L_(0x04, 0x56)
#define REG_SC_BK04_56_H      _PK_H_(0x04, 0x56)
#define REG_SC_BK04_57_L      _PK_L_(0x04, 0x57)
#define REG_SC_BK04_57_H      _PK_H_(0x04, 0x57)
#define REG_SC_BK04_58_L      _PK_L_(0x04, 0x58)
#define REG_SC_BK04_58_H      _PK_H_(0x04, 0x58)
#define REG_SC_BK04_59_L      _PK_L_(0x04, 0x59)
#define REG_SC_BK04_59_H      _PK_H_(0x04, 0x59)
#define REG_SC_BK04_5A_L      _PK_L_(0x04, 0x5A)
#define REG_SC_BK04_5A_H      _PK_H_(0x04, 0x5A)
#define REG_SC_BK04_5B_L      _PK_L_(0x04, 0x5B)
#define REG_SC_BK04_5B_H      _PK_H_(0x04, 0x5B)
#define REG_SC_BK04_5C_L      _PK_L_(0x04, 0x5C)
#define REG_SC_BK04_5C_H      _PK_H_(0x04, 0x5C)
#define REG_SC_BK04_5D_L      _PK_L_(0x04, 0x5D)
#define REG_SC_BK04_5D_H      _PK_H_(0x04, 0x5D)
#define REG_SC_BK04_5E_L      _PK_L_(0x04, 0x5E)
#define REG_SC_BK04_5E_H      _PK_H_(0x04, 0x5E)
#define REG_SC_BK04_5F_L      _PK_L_(0x04, 0x5F)
#define REG_SC_BK04_5F_H      _PK_H_(0x04, 0x5F)
#define REG_SC_BK04_60_L      _PK_L_(0x04, 0x60)
#define REG_SC_BK04_60_H      _PK_H_(0x04, 0x60)
#define REG_SC_BK04_61_L      _PK_L_(0x04, 0x61)
#define REG_SC_BK04_61_H      _PK_H_(0x04, 0x61)
#define REG_SC_BK04_62_L      _PK_L_(0x04, 0x62)
#define REG_SC_BK04_62_H      _PK_H_(0x04, 0x62)
#define REG_SC_BK04_63_L      _PK_L_(0x04, 0x63)
#define REG_SC_BK04_63_H      _PK_H_(0x04, 0x63)
#define REG_SC_BK04_64_L      _PK_L_(0x04, 0x64)
#define REG_SC_BK04_64_H      _PK_H_(0x04, 0x64)
#define REG_SC_BK04_65_L      _PK_L_(0x04, 0x65)
#define REG_SC_BK04_65_H      _PK_H_(0x04, 0x65)
#define REG_SC_BK04_66_L      _PK_L_(0x04, 0x66)
#define REG_SC_BK04_66_H      _PK_H_(0x04, 0x66)
#define REG_SC_BK04_67_L      _PK_L_(0x04, 0x67)
#define REG_SC_BK04_67_H      _PK_H_(0x04, 0x67)
#define REG_SC_BK04_68_L      _PK_L_(0x04, 0x68)
#define REG_SC_BK04_68_H      _PK_H_(0x04, 0x68)
#define REG_SC_BK04_69_L      _PK_L_(0x04, 0x69)
#define REG_SC_BK04_69_H      _PK_H_(0x04, 0x69)
#define REG_SC_BK04_6A_L      _PK_L_(0x04, 0x6A)
#define REG_SC_BK04_6A_H      _PK_H_(0x04, 0x6A)
#define REG_SC_BK04_6B_L      _PK_L_(0x04, 0x6B)
#define REG_SC_BK04_6B_H      _PK_H_(0x04, 0x6B)
#define REG_SC_BK04_6C_L      _PK_L_(0x04, 0x6C)
#define REG_SC_BK04_6C_H      _PK_H_(0x04, 0x6C)
#define REG_SC_BK04_6D_L      _PK_L_(0x04, 0x6D)
#define REG_SC_BK04_6D_H      _PK_H_(0x04, 0x6D)
#define REG_SC_BK04_6E_L      _PK_L_(0x04, 0x6E)
#define REG_SC_BK04_6E_H      _PK_H_(0x04, 0x6E)
#define REG_SC_BK04_6F_L      _PK_L_(0x04, 0x6F)
#define REG_SC_BK04_6F_H      _PK_H_(0x04, 0x6F)
#define REG_SC_BK04_70_L      _PK_L_(0x04, 0x70)
#define REG_SC_BK04_70_H      _PK_H_(0x04, 0x70)
#define REG_SC_BK04_71_L      _PK_L_(0x04, 0x71)
#define REG_SC_BK04_71_H      _PK_H_(0x04, 0x71)
#define REG_SC_BK04_72_L      _PK_L_(0x04, 0x72)
#define REG_SC_BK04_72_H      _PK_H_(0x04, 0x72)
#define REG_SC_BK04_73_L      _PK_L_(0x04, 0x73)
#define REG_SC_BK04_73_H      _PK_H_(0x04, 0x73)
#define REG_SC_BK04_74_L      _PK_L_(0x04, 0x74)
#define REG_SC_BK04_74_H      _PK_H_(0x04, 0x74)
#define REG_SC_BK04_75_L      _PK_L_(0x04, 0x75)
#define REG_SC_BK04_75_H      _PK_H_(0x04, 0x75)
#define REG_SC_BK04_76_L      _PK_L_(0x04, 0x76)
#define REG_SC_BK04_76_H      _PK_H_(0x04, 0x76)
#define REG_SC_BK04_77_L      _PK_L_(0x04, 0x77)
#define REG_SC_BK04_77_H      _PK_H_(0x04, 0x77)
#define REG_SC_BK04_78_L      _PK_L_(0x04, 0x78)
#define REG_SC_BK04_78_H      _PK_H_(0x04, 0x78)
#define REG_SC_BK04_79_L      _PK_L_(0x04, 0x79)
#define REG_SC_BK04_79_H      _PK_H_(0x04, 0x79)
#define REG_SC_BK04_7A_L      _PK_L_(0x04, 0x7A)
#define REG_SC_BK04_7A_H      _PK_H_(0x04, 0x7A)
#define REG_SC_BK04_7B_L      _PK_L_(0x04, 0x7B)
#define REG_SC_BK04_7B_H      _PK_H_(0x04, 0x7B)
#define REG_SC_BK04_7C_L      _PK_L_(0x04, 0x7C)
#define REG_SC_BK04_7C_H      _PK_H_(0x04, 0x7C)
#define REG_SC_BK04_7D_L      _PK_L_(0x04, 0x7D)
#define REG_SC_BK04_7D_H      _PK_H_(0x04, 0x7D)
#define REG_SC_BK04_7E_L      _PK_L_(0x04, 0x7E)
#define REG_SC_BK04_7E_H      _PK_H_(0x04, 0x7E)
#define REG_SC_BK04_7F_L      _PK_L_(0x04, 0x7F)
#define REG_SC_BK04_7F_H      _PK_H_(0x04, 0x7F)
//----------------------------------------------
#define REG_SC_BK05_00_L      _PK_L_(0x05, 0x00)
#define REG_SC_BK05_00_H      _PK_H_(0x05, 0x00)
#define REG_SC_BK05_01_L      _PK_L_(0x05, 0x01)
#define REG_SC_BK05_01_H      _PK_H_(0x05, 0x01)
#define REG_SC_BK05_02_L      _PK_L_(0x05, 0x02)
#define REG_SC_BK05_02_H      _PK_H_(0x05, 0x02)
#define REG_SC_BK05_03_L      _PK_L_(0x05, 0x03)
#define REG_SC_BK05_03_H      _PK_H_(0x05, 0x03)
#define REG_SC_BK05_04_L      _PK_L_(0x05, 0x04)
#define REG_SC_BK05_04_H      _PK_H_(0x05, 0x04)
#define REG_SC_BK05_05_L      _PK_L_(0x05, 0x05)
#define REG_SC_BK05_05_H      _PK_H_(0x05, 0x05)
#define REG_SC_BK05_06_L      _PK_L_(0x05, 0x06)
#define REG_SC_BK05_06_H      _PK_H_(0x05, 0x06)
#define REG_SC_BK05_07_L      _PK_L_(0x05, 0x07)
#define REG_SC_BK05_07_H      _PK_H_(0x05, 0x07)
#define REG_SC_BK05_08_L      _PK_L_(0x05, 0x08)
#define REG_SC_BK05_08_H      _PK_H_(0x05, 0x08)
#define REG_SC_BK05_09_L      _PK_L_(0x05, 0x09)
#define REG_SC_BK05_09_H      _PK_H_(0x05, 0x09)
#define REG_SC_BK05_0A_L      _PK_L_(0x05, 0x0A)
#define REG_SC_BK05_0A_H      _PK_H_(0x05, 0x0A)
#define REG_SC_BK05_0B_L      _PK_L_(0x05, 0x0B)
#define REG_SC_BK05_0B_H      _PK_H_(0x05, 0x0B)
#define REG_SC_BK05_0C_L      _PK_L_(0x05, 0x0C)
#define REG_SC_BK05_0C_H      _PK_H_(0x05, 0x0C)
#define REG_SC_BK05_0D_L      _PK_L_(0x05, 0x0D)
#define REG_SC_BK05_0D_H      _PK_H_(0x05, 0x0D)
#define REG_SC_BK05_0E_L      _PK_L_(0x05, 0x0E)
#define REG_SC_BK05_0E_H      _PK_H_(0x05, 0x0E)
#define REG_SC_BK05_0F_L      _PK_L_(0x05, 0x0F)
#define REG_SC_BK05_0F_H      _PK_H_(0x05, 0x0F)
#define REG_SC_BK05_10_L      _PK_L_(0x05, 0x10)
#define REG_SC_BK05_10_H      _PK_H_(0x05, 0x10)
#define REG_SC_BK05_11_L      _PK_L_(0x05, 0x11)
#define REG_SC_BK05_11_H      _PK_H_(0x05, 0x11)
#define REG_SC_BK05_12_L      _PK_L_(0x05, 0x12)
#define REG_SC_BK05_12_H      _PK_H_(0x05, 0x12)
#define REG_SC_BK05_13_L      _PK_L_(0x05, 0x13)
#define REG_SC_BK05_13_H      _PK_H_(0x05, 0x13)
#define REG_SC_BK05_14_L      _PK_L_(0x05, 0x14)
#define REG_SC_BK05_14_H      _PK_H_(0x05, 0x14)
#define REG_SC_BK05_15_L      _PK_L_(0x05, 0x15)
#define REG_SC_BK05_15_H      _PK_H_(0x05, 0x15)
#define REG_SC_BK05_16_L      _PK_L_(0x05, 0x16)
#define REG_SC_BK05_16_H      _PK_H_(0x05, 0x16)
#define REG_SC_BK05_17_L      _PK_L_(0x05, 0x17)
#define REG_SC_BK05_17_H      _PK_H_(0x05, 0x17)
#define REG_SC_BK05_18_L      _PK_L_(0x05, 0x18)
#define REG_SC_BK05_18_H      _PK_H_(0x05, 0x18)
#define REG_SC_BK05_19_L      _PK_L_(0x05, 0x19)
#define REG_SC_BK05_19_H      _PK_H_(0x05, 0x19)
#define REG_SC_BK05_1A_L      _PK_L_(0x05, 0x1A)
#define REG_SC_BK05_1A_H      _PK_H_(0x05, 0x1A)
#define REG_SC_BK05_1B_L      _PK_L_(0x05, 0x1B)
#define REG_SC_BK05_1B_H      _PK_H_(0x05, 0x1B)
#define REG_SC_BK05_1C_L      _PK_L_(0x05, 0x1C)
#define REG_SC_BK05_1C_H      _PK_H_(0x05, 0x1C)
#define REG_SC_BK05_1D_L      _PK_L_(0x05, 0x1D)
#define REG_SC_BK05_1D_H      _PK_H_(0x05, 0x1D)
#define REG_SC_BK05_1E_L      _PK_L_(0x05, 0x1E)
#define REG_SC_BK05_1E_H      _PK_H_(0x05, 0x1E)
#define REG_SC_BK05_1F_L      _PK_L_(0x05, 0x1F)
#define REG_SC_BK05_1F_H      _PK_H_(0x05, 0x1F)
#define REG_SC_BK05_20_L      _PK_L_(0x05, 0x20)
#define REG_SC_BK05_20_H      _PK_H_(0x05, 0x20)
#define REG_SC_BK05_21_L      _PK_L_(0x05, 0x21)
#define REG_SC_BK05_21_H      _PK_H_(0x05, 0x21)
#define REG_SC_BK05_22_L      _PK_L_(0x05, 0x22)
#define REG_SC_BK05_22_H      _PK_H_(0x05, 0x22)
#define REG_SC_BK05_23_L      _PK_L_(0x05, 0x23)
#define REG_SC_BK05_23_H      _PK_H_(0x05, 0x23)
#define REG_SC_BK05_24_L      _PK_L_(0x05, 0x24)
#define REG_SC_BK05_24_H      _PK_H_(0x05, 0x24)
#define REG_SC_BK05_25_L      _PK_L_(0x05, 0x25)
#define REG_SC_BK05_25_H      _PK_H_(0x05, 0x25)
#define REG_SC_BK05_26_L      _PK_L_(0x05, 0x26)
#define REG_SC_BK05_26_H      _PK_H_(0x05, 0x26)
#define REG_SC_BK05_27_L      _PK_L_(0x05, 0x27)
#define REG_SC_BK05_27_H      _PK_H_(0x05, 0x27)
#define REG_SC_BK05_28_L      _PK_L_(0x05, 0x28)
#define REG_SC_BK05_28_H      _PK_H_(0x05, 0x28)
#define REG_SC_BK05_29_L      _PK_L_(0x05, 0x29)
#define REG_SC_BK05_29_H      _PK_H_(0x05, 0x29)
#define REG_SC_BK05_2A_L      _PK_L_(0x05, 0x2A)
#define REG_SC_BK05_2A_H      _PK_H_(0x05, 0x2A)
#define REG_SC_BK05_2B_L      _PK_L_(0x05, 0x2B)
#define REG_SC_BK05_2B_H      _PK_H_(0x05, 0x2B)
#define REG_SC_BK05_2C_L      _PK_L_(0x05, 0x2C)
#define REG_SC_BK05_2C_H      _PK_H_(0x05, 0x2C)
#define REG_SC_BK05_2D_L      _PK_L_(0x05, 0x2D)
#define REG_SC_BK05_2D_H      _PK_H_(0x05, 0x2D)
#define REG_SC_BK05_2E_L      _PK_L_(0x05, 0x2E)
#define REG_SC_BK05_2E_H      _PK_H_(0x05, 0x2E)
#define REG_SC_BK05_2F_L      _PK_L_(0x05, 0x2F)
#define REG_SC_BK05_2F_H      _PK_H_(0x05, 0x2F)
#define REG_SC_BK05_30_L      _PK_L_(0x05, 0x30)
#define REG_SC_BK05_30_H      _PK_H_(0x05, 0x30)
#define REG_SC_BK05_31_L      _PK_L_(0x05, 0x31)
#define REG_SC_BK05_31_H      _PK_H_(0x05, 0x31)
#define REG_SC_BK05_32_L      _PK_L_(0x05, 0x32)
#define REG_SC_BK05_32_H      _PK_H_(0x05, 0x32)
#define REG_SC_BK05_33_L      _PK_L_(0x05, 0x33)
#define REG_SC_BK05_33_H      _PK_H_(0x05, 0x33)
#define REG_SC_BK05_34_L      _PK_L_(0x05, 0x34)
#define REG_SC_BK05_34_H      _PK_H_(0x05, 0x34)
#define REG_SC_BK05_35_L      _PK_L_(0x05, 0x35)
#define REG_SC_BK05_35_H      _PK_H_(0x05, 0x35)
#define REG_SC_BK05_36_L      _PK_L_(0x05, 0x36)
#define REG_SC_BK05_36_H      _PK_H_(0x05, 0x36)
#define REG_SC_BK05_37_L      _PK_L_(0x05, 0x37)
#define REG_SC_BK05_37_H      _PK_H_(0x05, 0x37)
#define REG_SC_BK05_38_L      _PK_L_(0x05, 0x38)
#define REG_SC_BK05_38_H      _PK_H_(0x05, 0x38)
#define REG_SC_BK05_39_L      _PK_L_(0x05, 0x39)
#define REG_SC_BK05_39_H      _PK_H_(0x05, 0x39)
#define REG_SC_BK05_3A_L      _PK_L_(0x05, 0x3A)
#define REG_SC_BK05_3A_H      _PK_H_(0x05, 0x3A)
#define REG_SC_BK05_3B_L      _PK_L_(0x05, 0x3B)
#define REG_SC_BK05_3B_H      _PK_H_(0x05, 0x3B)
#define REG_SC_BK05_3C_L      _PK_L_(0x05, 0x3C)
#define REG_SC_BK05_3C_H      _PK_H_(0x05, 0x3C)
#define REG_SC_BK05_3D_L      _PK_L_(0x05, 0x3D)
#define REG_SC_BK05_3D_H      _PK_H_(0x05, 0x3D)
#define REG_SC_BK05_3E_L      _PK_L_(0x05, 0x3E)
#define REG_SC_BK05_3E_H      _PK_H_(0x05, 0x3E)
#define REG_SC_BK05_3F_L      _PK_L_(0x05, 0x3F)
#define REG_SC_BK05_3F_H      _PK_H_(0x05, 0x3F)
#define REG_SC_BK05_40_L      _PK_L_(0x05, 0x40)
#define REG_SC_BK05_40_H      _PK_H_(0x05, 0x40)
#define REG_SC_BK05_41_L      _PK_L_(0x05, 0x41)
#define REG_SC_BK05_41_H      _PK_H_(0x05, 0x41)
#define REG_SC_BK05_42_L      _PK_L_(0x05, 0x42)
#define REG_SC_BK05_42_H      _PK_H_(0x05, 0x42)
#define REG_SC_BK05_43_L      _PK_L_(0x05, 0x43)
#define REG_SC_BK05_43_H      _PK_H_(0x05, 0x43)
#define REG_SC_BK05_44_L      _PK_L_(0x05, 0x44)
#define REG_SC_BK05_44_H      _PK_H_(0x05, 0x44)
#define REG_SC_BK05_45_L      _PK_L_(0x05, 0x45)
#define REG_SC_BK05_45_H      _PK_H_(0x05, 0x45)
#define REG_SC_BK05_46_L      _PK_L_(0x05, 0x46)
#define REG_SC_BK05_46_H      _PK_H_(0x05, 0x46)
#define REG_SC_BK05_47_L      _PK_L_(0x05, 0x47)
#define REG_SC_BK05_47_H      _PK_H_(0x05, 0x47)
#define REG_SC_BK05_48_L      _PK_L_(0x05, 0x48)
#define REG_SC_BK05_48_H      _PK_H_(0x05, 0x48)
#define REG_SC_BK05_49_L      _PK_L_(0x05, 0x49)
#define REG_SC_BK05_49_H      _PK_H_(0x05, 0x49)
#define REG_SC_BK05_4A_L      _PK_L_(0x05, 0x4A)
#define REG_SC_BK05_4A_H      _PK_H_(0x05, 0x4A)
#define REG_SC_BK05_4B_L      _PK_L_(0x05, 0x4B)
#define REG_SC_BK05_4B_H      _PK_H_(0x05, 0x4B)
#define REG_SC_BK05_4C_L      _PK_L_(0x05, 0x4C)
#define REG_SC_BK05_4C_H      _PK_H_(0x05, 0x4C)
#define REG_SC_BK05_4D_L      _PK_L_(0x05, 0x4D)
#define REG_SC_BK05_4D_H      _PK_H_(0x05, 0x4D)
#define REG_SC_BK05_4E_L      _PK_L_(0x05, 0x4E)
#define REG_SC_BK05_4E_H      _PK_H_(0x05, 0x4E)
#define REG_SC_BK05_4F_L      _PK_L_(0x05, 0x4F)
#define REG_SC_BK05_4F_H      _PK_H_(0x05, 0x4F)
#define REG_SC_BK05_50_L      _PK_L_(0x05, 0x50)
#define REG_SC_BK05_50_H      _PK_H_(0x05, 0x50)
#define REG_SC_BK05_51_L      _PK_L_(0x05, 0x51)
#define REG_SC_BK05_51_H      _PK_H_(0x05, 0x51)
#define REG_SC_BK05_52_L      _PK_L_(0x05, 0x52)
#define REG_SC_BK05_52_H      _PK_H_(0x05, 0x52)
#define REG_SC_BK05_53_L      _PK_L_(0x05, 0x53)
#define REG_SC_BK05_53_H      _PK_H_(0x05, 0x53)
#define REG_SC_BK05_54_L      _PK_L_(0x05, 0x54)
#define REG_SC_BK05_54_H      _PK_H_(0x05, 0x54)
#define REG_SC_BK05_55_L      _PK_L_(0x05, 0x55)
#define REG_SC_BK05_55_H      _PK_H_(0x05, 0x55)
#define REG_SC_BK05_56_L      _PK_L_(0x05, 0x56)
#define REG_SC_BK05_56_H      _PK_H_(0x05, 0x56)
#define REG_SC_BK05_57_L      _PK_L_(0x05, 0x57)
#define REG_SC_BK05_57_H      _PK_H_(0x05, 0x57)
#define REG_SC_BK05_58_L      _PK_L_(0x05, 0x58)
#define REG_SC_BK05_58_H      _PK_H_(0x05, 0x58)
#define REG_SC_BK05_59_L      _PK_L_(0x05, 0x59)
#define REG_SC_BK05_59_H      _PK_H_(0x05, 0x59)
#define REG_SC_BK05_5A_L      _PK_L_(0x05, 0x5A)
#define REG_SC_BK05_5A_H      _PK_H_(0x05, 0x5A)
#define REG_SC_BK05_5B_L      _PK_L_(0x05, 0x5B)
#define REG_SC_BK05_5B_H      _PK_H_(0x05, 0x5B)
#define REG_SC_BK05_5C_L      _PK_L_(0x05, 0x5C)
#define REG_SC_BK05_5C_H      _PK_H_(0x05, 0x5C)
#define REG_SC_BK05_5D_L      _PK_L_(0x05, 0x5D)
#define REG_SC_BK05_5D_H      _PK_H_(0x05, 0x5D)
#define REG_SC_BK05_5E_L      _PK_L_(0x05, 0x5E)
#define REG_SC_BK05_5E_H      _PK_H_(0x05, 0x5E)
#define REG_SC_BK05_5F_L      _PK_L_(0x05, 0x5F)
#define REG_SC_BK05_5F_H      _PK_H_(0x05, 0x5F)
#define REG_SC_BK05_60_L      _PK_L_(0x05, 0x60)
#define REG_SC_BK05_60_H      _PK_H_(0x05, 0x60)
#define REG_SC_BK05_61_L      _PK_L_(0x05, 0x61)
#define REG_SC_BK05_61_H      _PK_H_(0x05, 0x61)
#define REG_SC_BK05_62_L      _PK_L_(0x05, 0x62)
#define REG_SC_BK05_62_H      _PK_H_(0x05, 0x62)
#define REG_SC_BK05_63_L      _PK_L_(0x05, 0x63)
#define REG_SC_BK05_63_H      _PK_H_(0x05, 0x63)
#define REG_SC_BK05_64_L      _PK_L_(0x05, 0x64)
#define REG_SC_BK05_64_H      _PK_H_(0x05, 0x64)
#define REG_SC_BK05_65_L      _PK_L_(0x05, 0x65)
#define REG_SC_BK05_65_H      _PK_H_(0x05, 0x65)
#define REG_SC_BK05_66_L      _PK_L_(0x05, 0x66)
#define REG_SC_BK05_66_H      _PK_H_(0x05, 0x66)
#define REG_SC_BK05_67_L      _PK_L_(0x05, 0x67)
#define REG_SC_BK05_67_H      _PK_H_(0x05, 0x67)
#define REG_SC_BK05_68_L      _PK_L_(0x05, 0x68)
#define REG_SC_BK05_68_H      _PK_H_(0x05, 0x68)
#define REG_SC_BK05_69_L      _PK_L_(0x05, 0x69)
#define REG_SC_BK05_69_H      _PK_H_(0x05, 0x69)
#define REG_SC_BK05_6A_L      _PK_L_(0x05, 0x6A)
#define REG_SC_BK05_6A_H      _PK_H_(0x05, 0x6A)
#define REG_SC_BK05_6B_L      _PK_L_(0x05, 0x6B)
#define REG_SC_BK05_6B_H      _PK_H_(0x05, 0x6B)
#define REG_SC_BK05_6C_L      _PK_L_(0x05, 0x6C)
#define REG_SC_BK05_6C_H      _PK_H_(0x05, 0x6C)
#define REG_SC_BK05_6D_L      _PK_L_(0x05, 0x6D)
#define REG_SC_BK05_6D_H      _PK_H_(0x05, 0x6D)
#define REG_SC_BK05_6E_L      _PK_L_(0x05, 0x6E)
#define REG_SC_BK05_6E_H      _PK_H_(0x05, 0x6E)
#define REG_SC_BK05_6F_L      _PK_L_(0x05, 0x6F)
#define REG_SC_BK05_6F_H      _PK_H_(0x05, 0x6F)
#define REG_SC_BK05_70_L      _PK_L_(0x05, 0x70)
#define REG_SC_BK05_70_H      _PK_H_(0x05, 0x70)
#define REG_SC_BK05_71_L      _PK_L_(0x05, 0x71)
#define REG_SC_BK05_71_H      _PK_H_(0x05, 0x71)
#define REG_SC_BK05_72_L      _PK_L_(0x05, 0x72)
#define REG_SC_BK05_72_H      _PK_H_(0x05, 0x72)
#define REG_SC_BK05_73_L      _PK_L_(0x05, 0x73)
#define REG_SC_BK05_73_H      _PK_H_(0x05, 0x73)
#define REG_SC_BK05_74_L      _PK_L_(0x05, 0x74)
#define REG_SC_BK05_74_H      _PK_H_(0x05, 0x74)
#define REG_SC_BK05_75_L      _PK_L_(0x05, 0x75)
#define REG_SC_BK05_75_H      _PK_H_(0x05, 0x75)
#define REG_SC_BK05_76_L      _PK_L_(0x05, 0x76)
#define REG_SC_BK05_76_H      _PK_H_(0x05, 0x76)
#define REG_SC_BK05_77_L      _PK_L_(0x05, 0x77)
#define REG_SC_BK05_77_H      _PK_H_(0x05, 0x77)
#define REG_SC_BK05_78_L      _PK_L_(0x05, 0x78)
#define REG_SC_BK05_78_H      _PK_H_(0x05, 0x78)
#define REG_SC_BK05_79_L      _PK_L_(0x05, 0x79)
#define REG_SC_BK05_79_H      _PK_H_(0x05, 0x79)
#define REG_SC_BK05_7A_L      _PK_L_(0x05, 0x7A)
#define REG_SC_BK05_7A_H      _PK_H_(0x05, 0x7A)
#define REG_SC_BK05_7B_L      _PK_L_(0x05, 0x7B)
#define REG_SC_BK05_7B_H      _PK_H_(0x05, 0x7B)
#define REG_SC_BK05_7C_L      _PK_L_(0x05, 0x7C)
#define REG_SC_BK05_7C_H      _PK_H_(0x05, 0x7C)
#define REG_SC_BK05_7D_L      _PK_L_(0x05, 0x7D)
#define REG_SC_BK05_7D_H      _PK_H_(0x05, 0x7D)
#define REG_SC_BK05_7E_L      _PK_L_(0x05, 0x7E)
#define REG_SC_BK05_7E_H      _PK_H_(0x05, 0x7E)
#define REG_SC_BK05_7F_L      _PK_L_(0x05, 0x7F)
#define REG_SC_BK05_7F_H      _PK_H_(0x05, 0x7F)
//----------------------------------------------
#define REG_SC_BK06_00_L      _PK_L_(0x06, 0x00)
#define REG_SC_BK06_00_H      _PK_H_(0x06, 0x00)
#define REG_SC_BK06_01_L      _PK_L_(0x06, 0x01)
#define REG_SC_BK06_01_H      _PK_H_(0x06, 0x01)
#define REG_SC_BK06_02_L      _PK_L_(0x06, 0x02)
#define REG_SC_BK06_02_H      _PK_H_(0x06, 0x02)
#define REG_SC_BK06_03_L      _PK_L_(0x06, 0x03)
#define REG_SC_BK06_03_H      _PK_H_(0x06, 0x03)
#define REG_SC_BK06_04_L      _PK_L_(0x06, 0x04)
#define REG_SC_BK06_04_H      _PK_H_(0x06, 0x04)
#define REG_SC_BK06_05_L      _PK_L_(0x06, 0x05)
#define REG_SC_BK06_05_H      _PK_H_(0x06, 0x05)
#define REG_SC_BK06_06_L      _PK_L_(0x06, 0x06)
#define REG_SC_BK06_06_H      _PK_H_(0x06, 0x06)
#define REG_SC_BK06_07_L      _PK_L_(0x06, 0x07)
#define REG_SC_BK06_07_H      _PK_H_(0x06, 0x07)
#define REG_SC_BK06_08_L      _PK_L_(0x06, 0x08)
#define REG_SC_BK06_08_H      _PK_H_(0x06, 0x08)
#define REG_SC_BK06_09_L      _PK_L_(0x06, 0x09)
#define REG_SC_BK06_09_H      _PK_H_(0x06, 0x09)
#define REG_SC_BK06_0A_L      _PK_L_(0x06, 0x0A)
#define REG_SC_BK06_0A_H      _PK_H_(0x06, 0x0A)
#define REG_SC_BK06_0B_L      _PK_L_(0x06, 0x0B)
#define REG_SC_BK06_0B_H      _PK_H_(0x06, 0x0B)
#define REG_SC_BK06_0C_L      _PK_L_(0x06, 0x0C)
#define REG_SC_BK06_0C_H      _PK_H_(0x06, 0x0C)
#define REG_SC_BK06_0D_L      _PK_L_(0x06, 0x0D)
#define REG_SC_BK06_0D_H      _PK_H_(0x06, 0x0D)
#define REG_SC_BK06_0E_L      _PK_L_(0x06, 0x0E)
#define REG_SC_BK06_0E_H      _PK_H_(0x06, 0x0E)
#define REG_SC_BK06_0F_L      _PK_L_(0x06, 0x0F)
#define REG_SC_BK06_0F_H      _PK_H_(0x06, 0x0F)
#define REG_SC_BK06_10_L      _PK_L_(0x06, 0x10)
#define REG_SC_BK06_10_H      _PK_H_(0x06, 0x10)
#define REG_SC_BK06_11_L      _PK_L_(0x06, 0x11)
#define REG_SC_BK06_11_H      _PK_H_(0x06, 0x11)
#define REG_SC_BK06_12_L      _PK_L_(0x06, 0x12)
#define REG_SC_BK06_12_H      _PK_H_(0x06, 0x12)
#define REG_SC_BK06_13_L      _PK_L_(0x06, 0x13)
#define REG_SC_BK06_13_H      _PK_H_(0x06, 0x13)
#define REG_SC_BK06_14_L      _PK_L_(0x06, 0x14)
#define REG_SC_BK06_14_H      _PK_H_(0x06, 0x14)
#define REG_SC_BK06_15_L      _PK_L_(0x06, 0x15)
#define REG_SC_BK06_15_H      _PK_H_(0x06, 0x15)
#define REG_SC_BK06_16_L      _PK_L_(0x06, 0x16)
#define REG_SC_BK06_16_H      _PK_H_(0x06, 0x16)
#define REG_SC_BK06_17_L      _PK_L_(0x06, 0x17)
#define REG_SC_BK06_17_H      _PK_H_(0x06, 0x17)
#define REG_SC_BK06_18_L      _PK_L_(0x06, 0x18)
#define REG_SC_BK06_18_H      _PK_H_(0x06, 0x18)
#define REG_SC_BK06_19_L      _PK_L_(0x06, 0x19)
#define REG_SC_BK06_19_H      _PK_H_(0x06, 0x19)
#define REG_SC_BK06_1A_L      _PK_L_(0x06, 0x1A)
#define REG_SC_BK06_1A_H      _PK_H_(0x06, 0x1A)
#define REG_SC_BK06_1B_L      _PK_L_(0x06, 0x1B)
#define REG_SC_BK06_1B_H      _PK_H_(0x06, 0x1B)
#define REG_SC_BK06_1C_L      _PK_L_(0x06, 0x1C)
#define REG_SC_BK06_1C_H      _PK_H_(0x06, 0x1C)
#define REG_SC_BK06_1D_L      _PK_L_(0x06, 0x1D)
#define REG_SC_BK06_1D_H      _PK_H_(0x06, 0x1D)
#define REG_SC_BK06_1E_L      _PK_L_(0x06, 0x1E)
#define REG_SC_BK06_1E_H      _PK_H_(0x06, 0x1E)
#define REG_SC_BK06_1F_L      _PK_L_(0x06, 0x1F)
#define REG_SC_BK06_1F_H      _PK_H_(0x06, 0x1F)
#define REG_SC_BK06_20_L      _PK_L_(0x06, 0x20)
#define REG_SC_BK06_20_H      _PK_H_(0x06, 0x20)
#define REG_SC_BK06_21_L      _PK_L_(0x06, 0x21)
#define REG_SC_BK06_21_H      _PK_H_(0x06, 0x21)
#define REG_SC_BK06_22_L      _PK_L_(0x06, 0x22)
#define REG_SC_BK06_22_H      _PK_H_(0x06, 0x22)
#define REG_SC_BK06_23_L      _PK_L_(0x06, 0x23)
#define REG_SC_BK06_23_H      _PK_H_(0x06, 0x23)
#define REG_SC_BK06_24_L      _PK_L_(0x06, 0x24)
#define REG_SC_BK06_24_H      _PK_H_(0x06, 0x24)
#define REG_SC_BK06_25_L      _PK_L_(0x06, 0x25)
#define REG_SC_BK06_25_H      _PK_H_(0x06, 0x25)
#define REG_SC_BK06_26_L      _PK_L_(0x06, 0x26)
#define REG_SC_BK06_26_H      _PK_H_(0x06, 0x26)
#define REG_SC_BK06_27_L      _PK_L_(0x06, 0x27)
#define REG_SC_BK06_27_H      _PK_H_(0x06, 0x27)
#define REG_SC_BK06_28_L      _PK_L_(0x06, 0x28)
#define REG_SC_BK06_28_H      _PK_H_(0x06, 0x28)
#define REG_SC_BK06_29_L      _PK_L_(0x06, 0x29)
#define REG_SC_BK06_29_H      _PK_H_(0x06, 0x29)
#define REG_SC_BK06_2A_L      _PK_L_(0x06, 0x2A)
#define REG_SC_BK06_2A_H      _PK_H_(0x06, 0x2A)
#define REG_SC_BK06_2B_L      _PK_L_(0x06, 0x2B)
#define REG_SC_BK06_2B_H      _PK_H_(0x06, 0x2B)
#define REG_SC_BK06_2C_L      _PK_L_(0x06, 0x2C)
#define REG_SC_BK06_2C_H      _PK_H_(0x06, 0x2C)
#define REG_SC_BK06_2D_L      _PK_L_(0x06, 0x2D)
#define REG_SC_BK06_2D_H      _PK_H_(0x06, 0x2D)
#define REG_SC_BK06_2E_L      _PK_L_(0x06, 0x2E)
#define REG_SC_BK06_2E_H      _PK_H_(0x06, 0x2E)
#define REG_SC_BK06_2F_L      _PK_L_(0x06, 0x2F)
#define REG_SC_BK06_2F_H      _PK_H_(0x06, 0x2F)
#define REG_SC_BK06_30_L      _PK_L_(0x06, 0x30)
#define REG_SC_BK06_30_H      _PK_H_(0x06, 0x30)
#define REG_SC_BK06_31_L      _PK_L_(0x06, 0x31)
#define REG_SC_BK06_31_H      _PK_H_(0x06, 0x31)
#define REG_SC_BK06_32_L      _PK_L_(0x06, 0x32)
#define REG_SC_BK06_32_H      _PK_H_(0x06, 0x32)
#define REG_SC_BK06_33_L      _PK_L_(0x06, 0x33)
#define REG_SC_BK06_33_H      _PK_H_(0x06, 0x33)
#define REG_SC_BK06_34_L      _PK_L_(0x06, 0x34)
#define REG_SC_BK06_34_H      _PK_H_(0x06, 0x34)
#define REG_SC_BK06_35_L      _PK_L_(0x06, 0x35)
#define REG_SC_BK06_35_H      _PK_H_(0x06, 0x35)
#define REG_SC_BK06_36_L      _PK_L_(0x06, 0x36)
#define REG_SC_BK06_36_H      _PK_H_(0x06, 0x36)
#define REG_SC_BK06_37_L      _PK_L_(0x06, 0x37)
#define REG_SC_BK06_37_H      _PK_H_(0x06, 0x37)
#define REG_SC_BK06_38_L      _PK_L_(0x06, 0x38)
#define REG_SC_BK06_38_H      _PK_H_(0x06, 0x38)
#define REG_SC_BK06_39_L      _PK_L_(0x06, 0x39)
#define REG_SC_BK06_39_H      _PK_H_(0x06, 0x39)
#define REG_SC_BK06_3A_L      _PK_L_(0x06, 0x3A)
#define REG_SC_BK06_3A_H      _PK_H_(0x06, 0x3A)
#define REG_SC_BK06_3B_L      _PK_L_(0x06, 0x3B)
#define REG_SC_BK06_3B_H      _PK_H_(0x06, 0x3B)
#define REG_SC_BK06_3C_L      _PK_L_(0x06, 0x3C)
#define REG_SC_BK06_3C_H      _PK_H_(0x06, 0x3C)
#define REG_SC_BK06_3D_L      _PK_L_(0x06, 0x3D)
#define REG_SC_BK06_3D_H      _PK_H_(0x06, 0x3D)
#define REG_SC_BK06_3E_L      _PK_L_(0x06, 0x3E)
#define REG_SC_BK06_3E_H      _PK_H_(0x06, 0x3E)
#define REG_SC_BK06_3F_L      _PK_L_(0x06, 0x3F)
#define REG_SC_BK06_3F_H      _PK_H_(0x06, 0x3F)
#define REG_SC_BK06_40_L      _PK_L_(0x06, 0x40)
#define REG_SC_BK06_40_H      _PK_H_(0x06, 0x40)
#define REG_SC_BK06_41_L      _PK_L_(0x06, 0x41)
#define REG_SC_BK06_41_H      _PK_H_(0x06, 0x41)
#define REG_SC_BK06_42_L      _PK_L_(0x06, 0x42)
#define REG_SC_BK06_42_H      _PK_H_(0x06, 0x42)
#define REG_SC_BK06_43_L      _PK_L_(0x06, 0x43)
#define REG_SC_BK06_43_H      _PK_H_(0x06, 0x43)
#define REG_SC_BK06_44_L      _PK_L_(0x06, 0x44)
#define REG_SC_BK06_44_H      _PK_H_(0x06, 0x44)
#define REG_SC_BK06_45_L      _PK_L_(0x06, 0x45)
#define REG_SC_BK06_45_H      _PK_H_(0x06, 0x45)
#define REG_SC_BK06_46_L      _PK_L_(0x06, 0x46)
#define REG_SC_BK06_46_H      _PK_H_(0x06, 0x46)
#define REG_SC_BK06_47_L      _PK_L_(0x06, 0x47)
#define REG_SC_BK06_47_H      _PK_H_(0x06, 0x47)
#define REG_SC_BK06_48_L      _PK_L_(0x06, 0x48)
#define REG_SC_BK06_48_H      _PK_H_(0x06, 0x48)
#define REG_SC_BK06_49_L      _PK_L_(0x06, 0x49)
#define REG_SC_BK06_49_H      _PK_H_(0x06, 0x49)
#define REG_SC_BK06_4A_L      _PK_L_(0x06, 0x4A)
#define REG_SC_BK06_4A_H      _PK_H_(0x06, 0x4A)
#define REG_SC_BK06_4B_L      _PK_L_(0x06, 0x4B)
#define REG_SC_BK06_4B_H      _PK_H_(0x06, 0x4B)
#define REG_SC_BK06_4C_L      _PK_L_(0x06, 0x4C)
#define REG_SC_BK06_4C_H      _PK_H_(0x06, 0x4C)
#define REG_SC_BK06_4D_L      _PK_L_(0x06, 0x4D)
#define REG_SC_BK06_4D_H      _PK_H_(0x06, 0x4D)
#define REG_SC_BK06_4E_L      _PK_L_(0x06, 0x4E)
#define REG_SC_BK06_4E_H      _PK_H_(0x06, 0x4E)
#define REG_SC_BK06_4F_L      _PK_L_(0x06, 0x4F)
#define REG_SC_BK06_4F_H      _PK_H_(0x06, 0x4F)
#define REG_SC_BK06_50_L      _PK_L_(0x06, 0x50)
#define REG_SC_BK06_50_H      _PK_H_(0x06, 0x50)
#define REG_SC_BK06_51_L      _PK_L_(0x06, 0x51)
#define REG_SC_BK06_51_H      _PK_H_(0x06, 0x51)
#define REG_SC_BK06_52_L      _PK_L_(0x06, 0x52)
#define REG_SC_BK06_52_H      _PK_H_(0x06, 0x52)
#define REG_SC_BK06_53_L      _PK_L_(0x06, 0x53)
#define REG_SC_BK06_53_H      _PK_H_(0x06, 0x53)
#define REG_SC_BK06_54_L      _PK_L_(0x06, 0x54)
#define REG_SC_BK06_54_H      _PK_H_(0x06, 0x54)
#define REG_SC_BK06_55_L      _PK_L_(0x06, 0x55)
#define REG_SC_BK06_55_H      _PK_H_(0x06, 0x55)
#define REG_SC_BK06_56_L      _PK_L_(0x06, 0x56)
#define REG_SC_BK06_56_H      _PK_H_(0x06, 0x56)
#define REG_SC_BK06_57_L      _PK_L_(0x06, 0x57)
#define REG_SC_BK06_57_H      _PK_H_(0x06, 0x57)
#define REG_SC_BK06_58_L      _PK_L_(0x06, 0x58)
#define REG_SC_BK06_58_H      _PK_H_(0x06, 0x58)
#define REG_SC_BK06_59_L      _PK_L_(0x06, 0x59)
#define REG_SC_BK06_59_H      _PK_H_(0x06, 0x59)
#define REG_SC_BK06_5A_L      _PK_L_(0x06, 0x5A)
#define REG_SC_BK06_5A_H      _PK_H_(0x06, 0x5A)
#define REG_SC_BK06_5B_L      _PK_L_(0x06, 0x5B)
#define REG_SC_BK06_5B_H      _PK_H_(0x06, 0x5B)
#define REG_SC_BK06_5C_L      _PK_L_(0x06, 0x5C)
#define REG_SC_BK06_5C_H      _PK_H_(0x06, 0x5C)
#define REG_SC_BK06_5D_L      _PK_L_(0x06, 0x5D)
#define REG_SC_BK06_5D_H      _PK_H_(0x06, 0x5D)
#define REG_SC_BK06_5E_L      _PK_L_(0x06, 0x5E)
#define REG_SC_BK06_5E_H      _PK_H_(0x06, 0x5E)
#define REG_SC_BK06_5F_L      _PK_L_(0x06, 0x5F)
#define REG_SC_BK06_5F_H      _PK_H_(0x06, 0x5F)
#define REG_SC_BK06_60_L      _PK_L_(0x06, 0x60)
#define REG_SC_BK06_60_H      _PK_H_(0x06, 0x60)
#define REG_SC_BK06_61_L      _PK_L_(0x06, 0x61)
#define REG_SC_BK06_61_H      _PK_H_(0x06, 0x61)
#define REG_SC_BK06_62_L      _PK_L_(0x06, 0x62)
#define REG_SC_BK06_62_H      _PK_H_(0x06, 0x62)
#define REG_SC_BK06_63_L      _PK_L_(0x06, 0x63)
#define REG_SC_BK06_63_H      _PK_H_(0x06, 0x63)
#define REG_SC_BK06_64_L      _PK_L_(0x06, 0x64)
#define REG_SC_BK06_64_H      _PK_H_(0x06, 0x64)
#define REG_SC_BK06_65_L      _PK_L_(0x06, 0x65)
#define REG_SC_BK06_65_H      _PK_H_(0x06, 0x65)
#define REG_SC_BK06_66_L      _PK_L_(0x06, 0x66)
#define REG_SC_BK06_66_H      _PK_H_(0x06, 0x66)
#define REG_SC_BK06_67_L      _PK_L_(0x06, 0x67)
#define REG_SC_BK06_67_H      _PK_H_(0x06, 0x67)
#define REG_SC_BK06_68_L      _PK_L_(0x06, 0x68)
#define REG_SC_BK06_68_H      _PK_H_(0x06, 0x68)
#define REG_SC_BK06_69_L      _PK_L_(0x06, 0x69)
#define REG_SC_BK06_69_H      _PK_H_(0x06, 0x69)
#define REG_SC_BK06_6A_L      _PK_L_(0x06, 0x6A)
#define REG_SC_BK06_6A_H      _PK_H_(0x06, 0x6A)
#define REG_SC_BK06_6B_L      _PK_L_(0x06, 0x6B)
#define REG_SC_BK06_6B_H      _PK_H_(0x06, 0x6B)
#define REG_SC_BK06_6C_L      _PK_L_(0x06, 0x6C)
#define REG_SC_BK06_6C_H      _PK_H_(0x06, 0x6C)
#define REG_SC_BK06_6D_L      _PK_L_(0x06, 0x6D)
#define REG_SC_BK06_6D_H      _PK_H_(0x06, 0x6D)
#define REG_SC_BK06_6E_L      _PK_L_(0x06, 0x6E)
#define REG_SC_BK06_6E_H      _PK_H_(0x06, 0x6E)
#define REG_SC_BK06_6F_L      _PK_L_(0x06, 0x6F)
#define REG_SC_BK06_6F_H      _PK_H_(0x06, 0x6F)
#define REG_SC_BK06_70_L      _PK_L_(0x06, 0x70)
#define REG_SC_BK06_70_H      _PK_H_(0x06, 0x70)
#define REG_SC_BK06_71_L      _PK_L_(0x06, 0x71)
#define REG_SC_BK06_71_H      _PK_H_(0x06, 0x71)
#define REG_SC_BK06_72_L      _PK_L_(0x06, 0x72)
#define REG_SC_BK06_72_H      _PK_H_(0x06, 0x72)
#define REG_SC_BK06_73_L      _PK_L_(0x06, 0x73)
#define REG_SC_BK06_73_H      _PK_H_(0x06, 0x73)
#define REG_SC_BK06_74_L      _PK_L_(0x06, 0x74)
#define REG_SC_BK06_74_H      _PK_H_(0x06, 0x74)
#define REG_SC_BK06_75_L      _PK_L_(0x06, 0x75)
#define REG_SC_BK06_75_H      _PK_H_(0x06, 0x75)
#define REG_SC_BK06_76_L      _PK_L_(0x06, 0x76)
#define REG_SC_BK06_76_H      _PK_H_(0x06, 0x76)
#define REG_SC_BK06_77_L      _PK_L_(0x06, 0x77)
#define REG_SC_BK06_77_H      _PK_H_(0x06, 0x77)
#define REG_SC_BK06_78_L      _PK_L_(0x06, 0x78)
#define REG_SC_BK06_78_H      _PK_H_(0x06, 0x78)
#define REG_SC_BK06_79_L      _PK_L_(0x06, 0x79)
#define REG_SC_BK06_79_H      _PK_H_(0x06, 0x79)
#define REG_SC_BK06_7A_L      _PK_L_(0x06, 0x7A)
#define REG_SC_BK06_7A_H      _PK_H_(0x06, 0x7A)
#define REG_SC_BK06_7B_L      _PK_L_(0x06, 0x7B)
#define REG_SC_BK06_7B_H      _PK_H_(0x06, 0x7B)
#define REG_SC_BK06_7C_L      _PK_L_(0x06, 0x7C)
#define REG_SC_BK06_7C_H      _PK_H_(0x06, 0x7C)
#define REG_SC_BK06_7D_L      _PK_L_(0x06, 0x7D)
#define REG_SC_BK06_7D_H      _PK_H_(0x06, 0x7D)
#define REG_SC_BK06_7E_L      _PK_L_(0x06, 0x7E)
#define REG_SC_BK06_7E_H      _PK_H_(0x06, 0x7E)
#define REG_SC_BK06_7F_L      _PK_L_(0x06, 0x7F)
#define REG_SC_BK06_7F_H      _PK_H_(0x06, 0x7F)
//----------------------------------------------
#define REG_SC_BK07_00_L      _PK_L_(0x07, 0x00)
#define REG_SC_BK07_00_H      _PK_H_(0x07, 0x00)
#define REG_SC_BK07_01_L      _PK_L_(0x07, 0x01)
#define REG_SC_BK07_01_H      _PK_H_(0x07, 0x01)
#define REG_SC_BK07_02_L      _PK_L_(0x07, 0x02)
#define REG_SC_BK07_02_H      _PK_H_(0x07, 0x02)
#define REG_SC_BK07_03_L      _PK_L_(0x07, 0x03)
#define REG_SC_BK07_03_H      _PK_H_(0x07, 0x03)
#define REG_SC_BK07_04_L      _PK_L_(0x07, 0x04)
#define REG_SC_BK07_04_H      _PK_H_(0x07, 0x04)
#define REG_SC_BK07_05_L      _PK_L_(0x07, 0x05)
#define REG_SC_BK07_05_H      _PK_H_(0x07, 0x05)
#define REG_SC_BK07_06_L      _PK_L_(0x07, 0x06)
#define REG_SC_BK07_06_H      _PK_H_(0x07, 0x06)
#define REG_SC_BK07_07_L      _PK_L_(0x07, 0x07)
#define REG_SC_BK07_07_H      _PK_H_(0x07, 0x07)
#define REG_SC_BK07_08_L      _PK_L_(0x07, 0x08)
#define REG_SC_BK07_08_H      _PK_H_(0x07, 0x08)
#define REG_SC_BK07_09_L      _PK_L_(0x07, 0x09)
#define REG_SC_BK07_09_H      _PK_H_(0x07, 0x09)
#define REG_SC_BK07_0A_L      _PK_L_(0x07, 0x0A)
#define REG_SC_BK07_0A_H      _PK_H_(0x07, 0x0A)
#define REG_SC_BK07_0B_L      _PK_L_(0x07, 0x0B)
#define REG_SC_BK07_0B_H      _PK_H_(0x07, 0x0B)
#define REG_SC_BK07_0C_L      _PK_L_(0x07, 0x0C)
#define REG_SC_BK07_0C_H      _PK_H_(0x07, 0x0C)
#define REG_SC_BK07_0D_L      _PK_L_(0x07, 0x0D)
#define REG_SC_BK07_0D_H      _PK_H_(0x07, 0x0D)
#define REG_SC_BK07_0E_L      _PK_L_(0x07, 0x0E)
#define REG_SC_BK07_0E_H      _PK_H_(0x07, 0x0E)
#define REG_SC_BK07_0F_L      _PK_L_(0x07, 0x0F)
#define REG_SC_BK07_0F_H      _PK_H_(0x07, 0x0F)
#define REG_SC_BK07_10_L      _PK_L_(0x07, 0x10)
#define REG_SC_BK07_10_H      _PK_H_(0x07, 0x10)
#define REG_SC_BK07_11_L      _PK_L_(0x07, 0x11)
#define REG_SC_BK07_11_H      _PK_H_(0x07, 0x11)
#define REG_SC_BK07_12_L      _PK_L_(0x07, 0x12)
#define REG_SC_BK07_12_H      _PK_H_(0x07, 0x12)
#define REG_SC_BK07_13_L      _PK_L_(0x07, 0x13)
#define REG_SC_BK07_13_H      _PK_H_(0x07, 0x13)
#define REG_SC_BK07_14_L      _PK_L_(0x07, 0x14)
#define REG_SC_BK07_14_H      _PK_H_(0x07, 0x14)
#define REG_SC_BK07_15_L      _PK_L_(0x07, 0x15)
#define REG_SC_BK07_15_H      _PK_H_(0x07, 0x15)
#define REG_SC_BK07_16_L      _PK_L_(0x07, 0x16)
#define REG_SC_BK07_16_H      _PK_H_(0x07, 0x16)
#define REG_SC_BK07_17_L      _PK_L_(0x07, 0x17)
#define REG_SC_BK07_17_H      _PK_H_(0x07, 0x17)
#define REG_SC_BK07_18_L      _PK_L_(0x07, 0x18)
#define REG_SC_BK07_18_H      _PK_H_(0x07, 0x18)
#define REG_SC_BK07_19_L      _PK_L_(0x07, 0x19)
#define REG_SC_BK07_19_H      _PK_H_(0x07, 0x19)
#define REG_SC_BK07_1A_L      _PK_L_(0x07, 0x1A)
#define REG_SC_BK07_1A_H      _PK_H_(0x07, 0x1A)
#define REG_SC_BK07_1B_L      _PK_L_(0x07, 0x1B)
#define REG_SC_BK07_1B_H      _PK_H_(0x07, 0x1B)
#define REG_SC_BK07_1C_L      _PK_L_(0x07, 0x1C)
#define REG_SC_BK07_1C_H      _PK_H_(0x07, 0x1C)
#define REG_SC_BK07_1D_L      _PK_L_(0x07, 0x1D)
#define REG_SC_BK07_1D_H      _PK_H_(0x07, 0x1D)
#define REG_SC_BK07_1E_L      _PK_L_(0x07, 0x1E)
#define REG_SC_BK07_1E_H      _PK_H_(0x07, 0x1E)
#define REG_SC_BK07_1F_L      _PK_L_(0x07, 0x1F)
#define REG_SC_BK07_1F_H      _PK_H_(0x07, 0x1F)
#define REG_SC_BK07_20_L      _PK_L_(0x07, 0x20)
#define REG_SC_BK07_20_H      _PK_H_(0x07, 0x20)
#define REG_SC_BK07_21_L      _PK_L_(0x07, 0x21)
#define REG_SC_BK07_21_H      _PK_H_(0x07, 0x21)
#define REG_SC_BK07_22_L      _PK_L_(0x07, 0x22)
#define REG_SC_BK07_22_H      _PK_H_(0x07, 0x22)
#define REG_SC_BK07_23_L      _PK_L_(0x07, 0x23)
#define REG_SC_BK07_23_H      _PK_H_(0x07, 0x23)
#define REG_SC_BK07_24_L      _PK_L_(0x07, 0x24)
#define REG_SC_BK07_24_H      _PK_H_(0x07, 0x24)
#define REG_SC_BK07_25_L      _PK_L_(0x07, 0x25)
#define REG_SC_BK07_25_H      _PK_H_(0x07, 0x25)
#define REG_SC_BK07_26_L      _PK_L_(0x07, 0x26)
#define REG_SC_BK07_26_H      _PK_H_(0x07, 0x26)
#define REG_SC_BK07_27_L      _PK_L_(0x07, 0x27)
#define REG_SC_BK07_27_H      _PK_H_(0x07, 0x27)
#define REG_SC_BK07_28_L      _PK_L_(0x07, 0x28)
#define REG_SC_BK07_28_H      _PK_H_(0x07, 0x28)
#define REG_SC_BK07_29_L      _PK_L_(0x07, 0x29)
#define REG_SC_BK07_29_H      _PK_H_(0x07, 0x29)
#define REG_SC_BK07_2A_L      _PK_L_(0x07, 0x2A)
#define REG_SC_BK07_2A_H      _PK_H_(0x07, 0x2A)
#define REG_SC_BK07_2B_L      _PK_L_(0x07, 0x2B)
#define REG_SC_BK07_2B_H      _PK_H_(0x07, 0x2B)
#define REG_SC_BK07_2C_L      _PK_L_(0x07, 0x2C)
#define REG_SC_BK07_2C_H      _PK_H_(0x07, 0x2C)
#define REG_SC_BK07_2D_L      _PK_L_(0x07, 0x2D)
#define REG_SC_BK07_2D_H      _PK_H_(0x07, 0x2D)
#define REG_SC_BK07_2E_L      _PK_L_(0x07, 0x2E)
#define REG_SC_BK07_2E_H      _PK_H_(0x07, 0x2E)
#define REG_SC_BK07_2F_L      _PK_L_(0x07, 0x2F)
#define REG_SC_BK07_2F_H      _PK_H_(0x07, 0x2F)
#define REG_SC_BK07_30_L      _PK_L_(0x07, 0x30)
#define REG_SC_BK07_30_H      _PK_H_(0x07, 0x30)
#define REG_SC_BK07_31_L      _PK_L_(0x07, 0x31)
#define REG_SC_BK07_31_H      _PK_H_(0x07, 0x31)
#define REG_SC_BK07_32_L      _PK_L_(0x07, 0x32)
#define REG_SC_BK07_32_H      _PK_H_(0x07, 0x32)
#define REG_SC_BK07_33_L      _PK_L_(0x07, 0x33)
#define REG_SC_BK07_33_H      _PK_H_(0x07, 0x33)
#define REG_SC_BK07_34_L      _PK_L_(0x07, 0x34)
#define REG_SC_BK07_34_H      _PK_H_(0x07, 0x34)
#define REG_SC_BK07_35_L      _PK_L_(0x07, 0x35)
#define REG_SC_BK07_35_H      _PK_H_(0x07, 0x35)
#define REG_SC_BK07_36_L      _PK_L_(0x07, 0x36)
#define REG_SC_BK07_36_H      _PK_H_(0x07, 0x36)
#define REG_SC_BK07_37_L      _PK_L_(0x07, 0x37)
#define REG_SC_BK07_37_H      _PK_H_(0x07, 0x37)
#define REG_SC_BK07_38_L      _PK_L_(0x07, 0x38)
#define REG_SC_BK07_38_H      _PK_H_(0x07, 0x38)
#define REG_SC_BK07_39_L      _PK_L_(0x07, 0x39)
#define REG_SC_BK07_39_H      _PK_H_(0x07, 0x39)
#define REG_SC_BK07_3A_L      _PK_L_(0x07, 0x3A)
#define REG_SC_BK07_3A_H      _PK_H_(0x07, 0x3A)
#define REG_SC_BK07_3B_L      _PK_L_(0x07, 0x3B)
#define REG_SC_BK07_3B_H      _PK_H_(0x07, 0x3B)
#define REG_SC_BK07_3C_L      _PK_L_(0x07, 0x3C)
#define REG_SC_BK07_3C_H      _PK_H_(0x07, 0x3C)
#define REG_SC_BK07_3D_L      _PK_L_(0x07, 0x3D)
#define REG_SC_BK07_3D_H      _PK_H_(0x07, 0x3D)
#define REG_SC_BK07_3E_L      _PK_L_(0x07, 0x3E)
#define REG_SC_BK07_3E_H      _PK_H_(0x07, 0x3E)
#define REG_SC_BK07_3F_L      _PK_L_(0x07, 0x3F)
#define REG_SC_BK07_3F_H      _PK_H_(0x07, 0x3F)
#define REG_SC_BK07_40_L      _PK_L_(0x07, 0x40)
#define REG_SC_BK07_40_H      _PK_H_(0x07, 0x40)
#define REG_SC_BK07_41_L      _PK_L_(0x07, 0x41)
#define REG_SC_BK07_41_H      _PK_H_(0x07, 0x41)
#define REG_SC_BK07_42_L      _PK_L_(0x07, 0x42)
#define REG_SC_BK07_42_H      _PK_H_(0x07, 0x42)
#define REG_SC_BK07_43_L      _PK_L_(0x07, 0x43)
#define REG_SC_BK07_43_H      _PK_H_(0x07, 0x43)
#define REG_SC_BK07_44_L      _PK_L_(0x07, 0x44)
#define REG_SC_BK07_44_H      _PK_H_(0x07, 0x44)
#define REG_SC_BK07_45_L      _PK_L_(0x07, 0x45)
#define REG_SC_BK07_45_H      _PK_H_(0x07, 0x45)
#define REG_SC_BK07_46_L      _PK_L_(0x07, 0x46)
#define REG_SC_BK07_46_H      _PK_H_(0x07, 0x46)
#define REG_SC_BK07_47_L      _PK_L_(0x07, 0x47)
#define REG_SC_BK07_47_H      _PK_H_(0x07, 0x47)
#define REG_SC_BK07_48_L      _PK_L_(0x07, 0x48)
#define REG_SC_BK07_48_H      _PK_H_(0x07, 0x48)
#define REG_SC_BK07_49_L      _PK_L_(0x07, 0x49)
#define REG_SC_BK07_49_H      _PK_H_(0x07, 0x49)
#define REG_SC_BK07_4A_L      _PK_L_(0x07, 0x4A)
#define REG_SC_BK07_4A_H      _PK_H_(0x07, 0x4A)
#define REG_SC_BK07_4B_L      _PK_L_(0x07, 0x4B)
#define REG_SC_BK07_4B_H      _PK_H_(0x07, 0x4B)
#define REG_SC_BK07_4C_L      _PK_L_(0x07, 0x4C)
#define REG_SC_BK07_4C_H      _PK_H_(0x07, 0x4C)
#define REG_SC_BK07_4D_L      _PK_L_(0x07, 0x4D)
#define REG_SC_BK07_4D_H      _PK_H_(0x07, 0x4D)
#define REG_SC_BK07_4E_L      _PK_L_(0x07, 0x4E)
#define REG_SC_BK07_4E_H      _PK_H_(0x07, 0x4E)
#define REG_SC_BK07_4F_L      _PK_L_(0x07, 0x4F)
#define REG_SC_BK07_4F_H      _PK_H_(0x07, 0x4F)
#define REG_SC_BK07_50_L      _PK_L_(0x07, 0x50)
#define REG_SC_BK07_50_H      _PK_H_(0x07, 0x50)
#define REG_SC_BK07_51_L      _PK_L_(0x07, 0x51)
#define REG_SC_BK07_51_H      _PK_H_(0x07, 0x51)
#define REG_SC_BK07_52_L      _PK_L_(0x07, 0x52)
#define REG_SC_BK07_52_H      _PK_H_(0x07, 0x52)
#define REG_SC_BK07_53_L      _PK_L_(0x07, 0x53)
#define REG_SC_BK07_53_H      _PK_H_(0x07, 0x53)
#define REG_SC_BK07_54_L      _PK_L_(0x07, 0x54)
#define REG_SC_BK07_54_H      _PK_H_(0x07, 0x54)
#define REG_SC_BK07_55_L      _PK_L_(0x07, 0x55)
#define REG_SC_BK07_55_H      _PK_H_(0x07, 0x55)
#define REG_SC_BK07_56_L      _PK_L_(0x07, 0x56)
#define REG_SC_BK07_56_H      _PK_H_(0x07, 0x56)
#define REG_SC_BK07_57_L      _PK_L_(0x07, 0x57)
#define REG_SC_BK07_57_H      _PK_H_(0x07, 0x57)
#define REG_SC_BK07_58_L      _PK_L_(0x07, 0x58)
#define REG_SC_BK07_58_H      _PK_H_(0x07, 0x58)
#define REG_SC_BK07_59_L      _PK_L_(0x07, 0x59)
#define REG_SC_BK07_59_H      _PK_H_(0x07, 0x59)
#define REG_SC_BK07_5A_L      _PK_L_(0x07, 0x5A)
#define REG_SC_BK07_5A_H      _PK_H_(0x07, 0x5A)
#define REG_SC_BK07_5B_L      _PK_L_(0x07, 0x5B)
#define REG_SC_BK07_5B_H      _PK_H_(0x07, 0x5B)
#define REG_SC_BK07_5C_L      _PK_L_(0x07, 0x5C)
#define REG_SC_BK07_5C_H      _PK_H_(0x07, 0x5C)
#define REG_SC_BK07_5D_L      _PK_L_(0x07, 0x5D)
#define REG_SC_BK07_5D_H      _PK_H_(0x07, 0x5D)
#define REG_SC_BK07_5E_L      _PK_L_(0x07, 0x5E)
#define REG_SC_BK07_5E_H      _PK_H_(0x07, 0x5E)
#define REG_SC_BK07_5F_L      _PK_L_(0x07, 0x5F)
#define REG_SC_BK07_5F_H      _PK_H_(0x07, 0x5F)
#define REG_SC_BK07_60_L      _PK_L_(0x07, 0x60)
#define REG_SC_BK07_60_H      _PK_H_(0x07, 0x60)
#define REG_SC_BK07_61_L      _PK_L_(0x07, 0x61)
#define REG_SC_BK07_61_H      _PK_H_(0x07, 0x61)
#define REG_SC_BK07_62_L      _PK_L_(0x07, 0x62)
#define REG_SC_BK07_62_H      _PK_H_(0x07, 0x62)
#define REG_SC_BK07_63_L      _PK_L_(0x07, 0x63)
#define REG_SC_BK07_63_H      _PK_H_(0x07, 0x63)
#define REG_SC_BK07_64_L      _PK_L_(0x07, 0x64)
#define REG_SC_BK07_64_H      _PK_H_(0x07, 0x64)
#define REG_SC_BK07_65_L      _PK_L_(0x07, 0x65)
#define REG_SC_BK07_65_H      _PK_H_(0x07, 0x65)
#define REG_SC_BK07_66_L      _PK_L_(0x07, 0x66)
#define REG_SC_BK07_66_H      _PK_H_(0x07, 0x66)
#define REG_SC_BK07_67_L      _PK_L_(0x07, 0x67)
#define REG_SC_BK07_67_H      _PK_H_(0x07, 0x67)
#define REG_SC_BK07_68_L      _PK_L_(0x07, 0x68)
#define REG_SC_BK07_68_H      _PK_H_(0x07, 0x68)
#define REG_SC_BK07_69_L      _PK_L_(0x07, 0x69)
#define REG_SC_BK07_69_H      _PK_H_(0x07, 0x69)
#define REG_SC_BK07_6A_L      _PK_L_(0x07, 0x6A)
#define REG_SC_BK07_6A_H      _PK_H_(0x07, 0x6A)
#define REG_SC_BK07_6B_L      _PK_L_(0x07, 0x6B)
#define REG_SC_BK07_6B_H      _PK_H_(0x07, 0x6B)
#define REG_SC_BK07_6C_L      _PK_L_(0x07, 0x6C)
#define REG_SC_BK07_6C_H      _PK_H_(0x07, 0x6C)
#define REG_SC_BK07_6D_L      _PK_L_(0x07, 0x6D)
#define REG_SC_BK07_6D_H      _PK_H_(0x07, 0x6D)
#define REG_SC_BK07_6E_L      _PK_L_(0x07, 0x6E)
#define REG_SC_BK07_6E_H      _PK_H_(0x07, 0x6E)
#define REG_SC_BK07_6F_L      _PK_L_(0x07, 0x6F)
#define REG_SC_BK07_6F_H      _PK_H_(0x07, 0x6F)
#define REG_SC_BK07_70_L      _PK_L_(0x07, 0x70)
#define REG_SC_BK07_70_H      _PK_H_(0x07, 0x70)
#define REG_SC_BK07_71_L      _PK_L_(0x07, 0x71)
#define REG_SC_BK07_71_H      _PK_H_(0x07, 0x71)
#define REG_SC_BK07_72_L      _PK_L_(0x07, 0x72)
#define REG_SC_BK07_72_H      _PK_H_(0x07, 0x72)
#define REG_SC_BK07_73_L      _PK_L_(0x07, 0x73)
#define REG_SC_BK07_73_H      _PK_H_(0x07, 0x73)
#define REG_SC_BK07_74_L      _PK_L_(0x07, 0x74)
#define REG_SC_BK07_74_H      _PK_H_(0x07, 0x74)
#define REG_SC_BK07_75_L      _PK_L_(0x07, 0x75)
#define REG_SC_BK07_75_H      _PK_H_(0x07, 0x75)
#define REG_SC_BK07_76_L      _PK_L_(0x07, 0x76)
#define REG_SC_BK07_76_H      _PK_H_(0x07, 0x76)
#define REG_SC_BK07_77_L      _PK_L_(0x07, 0x77)
#define REG_SC_BK07_77_H      _PK_H_(0x07, 0x77)
#define REG_SC_BK07_78_L      _PK_L_(0x07, 0x78)
#define REG_SC_BK07_78_H      _PK_H_(0x07, 0x78)
#define REG_SC_BK07_79_L      _PK_L_(0x07, 0x79)
#define REG_SC_BK07_79_H      _PK_H_(0x07, 0x79)
#define REG_SC_BK07_7A_L      _PK_L_(0x07, 0x7A)
#define REG_SC_BK07_7A_H      _PK_H_(0x07, 0x7A)
#define REG_SC_BK07_7B_L      _PK_L_(0x07, 0x7B)
#define REG_SC_BK07_7B_H      _PK_H_(0x07, 0x7B)
#define REG_SC_BK07_7C_L      _PK_L_(0x07, 0x7C)
#define REG_SC_BK07_7C_H      _PK_H_(0x07, 0x7C)
#define REG_SC_BK07_7D_L      _PK_L_(0x07, 0x7D)
#define REG_SC_BK07_7D_H      _PK_H_(0x07, 0x7D)
#define REG_SC_BK07_7E_L      _PK_L_(0x07, 0x7E)
#define REG_SC_BK07_7E_H      _PK_H_(0x07, 0x7E)
#define REG_SC_BK07_7F_L      _PK_L_(0x07, 0x7F)
#define REG_SC_BK07_7F_H      _PK_H_(0x07, 0x7F)
//----------------------------------------------
#define REG_SC_BK08_00_L      _PK_L_(0x08, 0x00)
#define REG_SC_BK08_00_H      _PK_H_(0x08, 0x00)
#define REG_SC_BK08_01_L      _PK_L_(0x08, 0x01)
#define REG_SC_BK08_01_H      _PK_H_(0x08, 0x01)
#define REG_SC_BK08_02_L      _PK_L_(0x08, 0x02)
#define REG_SC_BK08_02_H      _PK_H_(0x08, 0x02)
#define REG_SC_BK08_03_L      _PK_L_(0x08, 0x03)
#define REG_SC_BK08_03_H      _PK_H_(0x08, 0x03)
#define REG_SC_BK08_04_L      _PK_L_(0x08, 0x04)
#define REG_SC_BK08_04_H      _PK_H_(0x08, 0x04)
#define REG_SC_BK08_05_L      _PK_L_(0x08, 0x05)
#define REG_SC_BK08_05_H      _PK_H_(0x08, 0x05)
#define REG_SC_BK08_06_L      _PK_L_(0x08, 0x06)
#define REG_SC_BK08_06_H      _PK_H_(0x08, 0x06)
#define REG_SC_BK08_07_L      _PK_L_(0x08, 0x07)
#define REG_SC_BK08_07_H      _PK_H_(0x08, 0x07)
#define REG_SC_BK08_08_L      _PK_L_(0x08, 0x08)
#define REG_SC_BK08_08_H      _PK_H_(0x08, 0x08)
#define REG_SC_BK08_09_L      _PK_L_(0x08, 0x09)
#define REG_SC_BK08_09_H      _PK_H_(0x08, 0x09)
#define REG_SC_BK08_0A_L      _PK_L_(0x08, 0x0A)
#define REG_SC_BK08_0A_H      _PK_H_(0x08, 0x0A)
#define REG_SC_BK08_0B_L      _PK_L_(0x08, 0x0B)
#define REG_SC_BK08_0B_H      _PK_H_(0x08, 0x0B)
#define REG_SC_BK08_0C_L      _PK_L_(0x08, 0x0C)
#define REG_SC_BK08_0C_H      _PK_H_(0x08, 0x0C)
#define REG_SC_BK08_0D_L      _PK_L_(0x08, 0x0D)
#define REG_SC_BK08_0D_H      _PK_H_(0x08, 0x0D)
#define REG_SC_BK08_0E_L      _PK_L_(0x08, 0x0E)
#define REG_SC_BK08_0E_H      _PK_H_(0x08, 0x0E)
#define REG_SC_BK08_0F_L      _PK_L_(0x08, 0x0F)
#define REG_SC_BK08_0F_H      _PK_H_(0x08, 0x0F)
#define REG_SC_BK08_10_L      _PK_L_(0x08, 0x10)
#define REG_SC_BK08_10_H      _PK_H_(0x08, 0x10)
#define REG_SC_BK08_11_L      _PK_L_(0x08, 0x11)
#define REG_SC_BK08_11_H      _PK_H_(0x08, 0x11)
#define REG_SC_BK08_12_L      _PK_L_(0x08, 0x12)
#define REG_SC_BK08_12_H      _PK_H_(0x08, 0x12)
#define REG_SC_BK08_13_L      _PK_L_(0x08, 0x13)
#define REG_SC_BK08_13_H      _PK_H_(0x08, 0x13)
#define REG_SC_BK08_14_L      _PK_L_(0x08, 0x14)
#define REG_SC_BK08_14_H      _PK_H_(0x08, 0x14)
#define REG_SC_BK08_15_L      _PK_L_(0x08, 0x15)
#define REG_SC_BK08_15_H      _PK_H_(0x08, 0x15)
#define REG_SC_BK08_16_L      _PK_L_(0x08, 0x16)
#define REG_SC_BK08_16_H      _PK_H_(0x08, 0x16)
#define REG_SC_BK08_17_L      _PK_L_(0x08, 0x17)
#define REG_SC_BK08_17_H      _PK_H_(0x08, 0x17)
#define REG_SC_BK08_18_L      _PK_L_(0x08, 0x18)
#define REG_SC_BK08_18_H      _PK_H_(0x08, 0x18)
#define REG_SC_BK08_19_L      _PK_L_(0x08, 0x19)
#define REG_SC_BK08_19_H      _PK_H_(0x08, 0x19)
#define REG_SC_BK08_1A_L      _PK_L_(0x08, 0x1A)
#define REG_SC_BK08_1A_H      _PK_H_(0x08, 0x1A)
#define REG_SC_BK08_1B_L      _PK_L_(0x08, 0x1B)
#define REG_SC_BK08_1B_H      _PK_H_(0x08, 0x1B)
#define REG_SC_BK08_1C_L      _PK_L_(0x08, 0x1C)
#define REG_SC_BK08_1C_H      _PK_H_(0x08, 0x1C)
#define REG_SC_BK08_1D_L      _PK_L_(0x08, 0x1D)
#define REG_SC_BK08_1D_H      _PK_H_(0x08, 0x1D)
#define REG_SC_BK08_1E_L      _PK_L_(0x08, 0x1E)
#define REG_SC_BK08_1E_H      _PK_H_(0x08, 0x1E)
#define REG_SC_BK08_1F_L      _PK_L_(0x08, 0x1F)
#define REG_SC_BK08_1F_H      _PK_H_(0x08, 0x1F)
#define REG_SC_BK08_20_L      _PK_L_(0x08, 0x20)
#define REG_SC_BK08_20_H      _PK_H_(0x08, 0x20)
#define REG_SC_BK08_21_L      _PK_L_(0x08, 0x21)
#define REG_SC_BK08_21_H      _PK_H_(0x08, 0x21)
#define REG_SC_BK08_22_L      _PK_L_(0x08, 0x22)
#define REG_SC_BK08_22_H      _PK_H_(0x08, 0x22)
#define REG_SC_BK08_23_L      _PK_L_(0x08, 0x23)
#define REG_SC_BK08_23_H      _PK_H_(0x08, 0x23)
#define REG_SC_BK08_24_L      _PK_L_(0x08, 0x24)
#define REG_SC_BK08_24_H      _PK_H_(0x08, 0x24)
#define REG_SC_BK08_25_L      _PK_L_(0x08, 0x25)
#define REG_SC_BK08_25_H      _PK_H_(0x08, 0x25)
#define REG_SC_BK08_26_L      _PK_L_(0x08, 0x26)
#define REG_SC_BK08_26_H      _PK_H_(0x08, 0x26)
#define REG_SC_BK08_27_L      _PK_L_(0x08, 0x27)
#define REG_SC_BK08_27_H      _PK_H_(0x08, 0x27)
#define REG_SC_BK08_28_L      _PK_L_(0x08, 0x28)
#define REG_SC_BK08_28_H      _PK_H_(0x08, 0x28)
#define REG_SC_BK08_29_L      _PK_L_(0x08, 0x29)
#define REG_SC_BK08_29_H      _PK_H_(0x08, 0x29)
#define REG_SC_BK08_2A_L      _PK_L_(0x08, 0x2A)
#define REG_SC_BK08_2A_H      _PK_H_(0x08, 0x2A)
#define REG_SC_BK08_2B_L      _PK_L_(0x08, 0x2B)
#define REG_SC_BK08_2B_H      _PK_H_(0x08, 0x2B)
#define REG_SC_BK08_2C_L      _PK_L_(0x08, 0x2C)
#define REG_SC_BK08_2C_H      _PK_H_(0x08, 0x2C)
#define REG_SC_BK08_2D_L      _PK_L_(0x08, 0x2D)
#define REG_SC_BK08_2D_H      _PK_H_(0x08, 0x2D)
#define REG_SC_BK08_2E_L      _PK_L_(0x08, 0x2E)
#define REG_SC_BK08_2E_H      _PK_H_(0x08, 0x2E)
#define REG_SC_BK08_2F_L      _PK_L_(0x08, 0x2F)
#define REG_SC_BK08_2F_H      _PK_H_(0x08, 0x2F)
#define REG_SC_BK08_30_L      _PK_L_(0x08, 0x30)
#define REG_SC_BK08_30_H      _PK_H_(0x08, 0x30)
#define REG_SC_BK08_31_L      _PK_L_(0x08, 0x31)
#define REG_SC_BK08_31_H      _PK_H_(0x08, 0x31)
#define REG_SC_BK08_32_L      _PK_L_(0x08, 0x32)
#define REG_SC_BK08_32_H      _PK_H_(0x08, 0x32)
#define REG_SC_BK08_33_L      _PK_L_(0x08, 0x33)
#define REG_SC_BK08_33_H      _PK_H_(0x08, 0x33)
#define REG_SC_BK08_34_L      _PK_L_(0x08, 0x34)
#define REG_SC_BK08_34_H      _PK_H_(0x08, 0x34)
#define REG_SC_BK08_35_L      _PK_L_(0x08, 0x35)
#define REG_SC_BK08_35_H      _PK_H_(0x08, 0x35)
#define REG_SC_BK08_36_L      _PK_L_(0x08, 0x36)
#define REG_SC_BK08_36_H      _PK_H_(0x08, 0x36)
#define REG_SC_BK08_37_L      _PK_L_(0x08, 0x37)
#define REG_SC_BK08_37_H      _PK_H_(0x08, 0x37)
#define REG_SC_BK08_38_L      _PK_L_(0x08, 0x38)
#define REG_SC_BK08_38_H      _PK_H_(0x08, 0x38)
#define REG_SC_BK08_39_L      _PK_L_(0x08, 0x39)
#define REG_SC_BK08_39_H      _PK_H_(0x08, 0x39)
#define REG_SC_BK08_3A_L      _PK_L_(0x08, 0x3A)
#define REG_SC_BK08_3A_H      _PK_H_(0x08, 0x3A)
#define REG_SC_BK08_3B_L      _PK_L_(0x08, 0x3B)
#define REG_SC_BK08_3B_H      _PK_H_(0x08, 0x3B)
#define REG_SC_BK08_3C_L      _PK_L_(0x08, 0x3C)
#define REG_SC_BK08_3C_H      _PK_H_(0x08, 0x3C)
#define REG_SC_BK08_3D_L      _PK_L_(0x08, 0x3D)
#define REG_SC_BK08_3D_H      _PK_H_(0x08, 0x3D)
#define REG_SC_BK08_3E_L      _PK_L_(0x08, 0x3E)
#define REG_SC_BK08_3E_H      _PK_H_(0x08, 0x3E)
#define REG_SC_BK08_3F_L      _PK_L_(0x08, 0x3F)
#define REG_SC_BK08_3F_H      _PK_H_(0x08, 0x3F)
#define REG_SC_BK08_40_L      _PK_L_(0x08, 0x40)
#define REG_SC_BK08_40_H      _PK_H_(0x08, 0x40)
#define REG_SC_BK08_41_L      _PK_L_(0x08, 0x41)
#define REG_SC_BK08_41_H      _PK_H_(0x08, 0x41)
#define REG_SC_BK08_42_L      _PK_L_(0x08, 0x42)
#define REG_SC_BK08_42_H      _PK_H_(0x08, 0x42)
#define REG_SC_BK08_43_L      _PK_L_(0x08, 0x43)
#define REG_SC_BK08_43_H      _PK_H_(0x08, 0x43)
#define REG_SC_BK08_44_L      _PK_L_(0x08, 0x44)
#define REG_SC_BK08_44_H      _PK_H_(0x08, 0x44)
#define REG_SC_BK08_45_L      _PK_L_(0x08, 0x45)
#define REG_SC_BK08_45_H      _PK_H_(0x08, 0x45)
#define REG_SC_BK08_46_L      _PK_L_(0x08, 0x46)
#define REG_SC_BK08_46_H      _PK_H_(0x08, 0x46)
#define REG_SC_BK08_47_L      _PK_L_(0x08, 0x47)
#define REG_SC_BK08_47_H      _PK_H_(0x08, 0x47)
#define REG_SC_BK08_48_L      _PK_L_(0x08, 0x48)
#define REG_SC_BK08_48_H      _PK_H_(0x08, 0x48)
#define REG_SC_BK08_49_L      _PK_L_(0x08, 0x49)
#define REG_SC_BK08_49_H      _PK_H_(0x08, 0x49)
#define REG_SC_BK08_4A_L      _PK_L_(0x08, 0x4A)
#define REG_SC_BK08_4A_H      _PK_H_(0x08, 0x4A)
#define REG_SC_BK08_4B_L      _PK_L_(0x08, 0x4B)
#define REG_SC_BK08_4B_H      _PK_H_(0x08, 0x4B)
#define REG_SC_BK08_4C_L      _PK_L_(0x08, 0x4C)
#define REG_SC_BK08_4C_H      _PK_H_(0x08, 0x4C)
#define REG_SC_BK08_4D_L      _PK_L_(0x08, 0x4D)
#define REG_SC_BK08_4D_H      _PK_H_(0x08, 0x4D)
#define REG_SC_BK08_4E_L      _PK_L_(0x08, 0x4E)
#define REG_SC_BK08_4E_H      _PK_H_(0x08, 0x4E)
#define REG_SC_BK08_4F_L      _PK_L_(0x08, 0x4F)
#define REG_SC_BK08_4F_H      _PK_H_(0x08, 0x4F)
#define REG_SC_BK08_50_L      _PK_L_(0x08, 0x50)
#define REG_SC_BK08_50_H      _PK_H_(0x08, 0x50)
#define REG_SC_BK08_51_L      _PK_L_(0x08, 0x51)
#define REG_SC_BK08_51_H      _PK_H_(0x08, 0x51)
#define REG_SC_BK08_52_L      _PK_L_(0x08, 0x52)
#define REG_SC_BK08_52_H      _PK_H_(0x08, 0x52)
#define REG_SC_BK08_53_L      _PK_L_(0x08, 0x53)
#define REG_SC_BK08_53_H      _PK_H_(0x08, 0x53)
#define REG_SC_BK08_54_L      _PK_L_(0x08, 0x54)
#define REG_SC_BK08_54_H      _PK_H_(0x08, 0x54)
#define REG_SC_BK08_55_L      _PK_L_(0x08, 0x55)
#define REG_SC_BK08_55_H      _PK_H_(0x08, 0x55)
#define REG_SC_BK08_56_L      _PK_L_(0x08, 0x56)
#define REG_SC_BK08_56_H      _PK_H_(0x08, 0x56)
#define REG_SC_BK08_57_L      _PK_L_(0x08, 0x57)
#define REG_SC_BK08_57_H      _PK_H_(0x08, 0x57)
#define REG_SC_BK08_58_L      _PK_L_(0x08, 0x58)
#define REG_SC_BK08_58_H      _PK_H_(0x08, 0x58)
#define REG_SC_BK08_59_L      _PK_L_(0x08, 0x59)
#define REG_SC_BK08_59_H      _PK_H_(0x08, 0x59)
#define REG_SC_BK08_5A_L      _PK_L_(0x08, 0x5A)
#define REG_SC_BK08_5A_H      _PK_H_(0x08, 0x5A)
#define REG_SC_BK08_5B_L      _PK_L_(0x08, 0x5B)
#define REG_SC_BK08_5B_H      _PK_H_(0x08, 0x5B)
#define REG_SC_BK08_5C_L      _PK_L_(0x08, 0x5C)
#define REG_SC_BK08_5C_H      _PK_H_(0x08, 0x5C)
#define REG_SC_BK08_5D_L      _PK_L_(0x08, 0x5D)
#define REG_SC_BK08_5D_H      _PK_H_(0x08, 0x5D)
#define REG_SC_BK08_5E_L      _PK_L_(0x08, 0x5E)
#define REG_SC_BK08_5E_H      _PK_H_(0x08, 0x5E)
#define REG_SC_BK08_5F_L      _PK_L_(0x08, 0x5F)
#define REG_SC_BK08_5F_H      _PK_H_(0x08, 0x5F)
#define REG_SC_BK08_60_L      _PK_L_(0x08, 0x60)
#define REG_SC_BK08_60_H      _PK_H_(0x08, 0x60)
#define REG_SC_BK08_61_L      _PK_L_(0x08, 0x61)
#define REG_SC_BK08_61_H      _PK_H_(0x08, 0x61)
#define REG_SC_BK08_62_L      _PK_L_(0x08, 0x62)
#define REG_SC_BK08_62_H      _PK_H_(0x08, 0x62)
#define REG_SC_BK08_63_L      _PK_L_(0x08, 0x63)
#define REG_SC_BK08_63_H      _PK_H_(0x08, 0x63)
#define REG_SC_BK08_64_L      _PK_L_(0x08, 0x64)
#define REG_SC_BK08_64_H      _PK_H_(0x08, 0x64)
#define REG_SC_BK08_65_L      _PK_L_(0x08, 0x65)
#define REG_SC_BK08_65_H      _PK_H_(0x08, 0x65)
#define REG_SC_BK08_66_L      _PK_L_(0x08, 0x66)
#define REG_SC_BK08_66_H      _PK_H_(0x08, 0x66)
#define REG_SC_BK08_67_L      _PK_L_(0x08, 0x67)
#define REG_SC_BK08_67_H      _PK_H_(0x08, 0x67)
#define REG_SC_BK08_68_L      _PK_L_(0x08, 0x68)
#define REG_SC_BK08_68_H      _PK_H_(0x08, 0x68)
#define REG_SC_BK08_69_L      _PK_L_(0x08, 0x69)
#define REG_SC_BK08_69_H      _PK_H_(0x08, 0x69)
#define REG_SC_BK08_6A_L      _PK_L_(0x08, 0x6A)
#define REG_SC_BK08_6A_H      _PK_H_(0x08, 0x6A)
#define REG_SC_BK08_6B_L      _PK_L_(0x08, 0x6B)
#define REG_SC_BK08_6B_H      _PK_H_(0x08, 0x6B)
#define REG_SC_BK08_6C_L      _PK_L_(0x08, 0x6C)
#define REG_SC_BK08_6C_H      _PK_H_(0x08, 0x6C)
#define REG_SC_BK08_6D_L      _PK_L_(0x08, 0x6D)
#define REG_SC_BK08_6D_H      _PK_H_(0x08, 0x6D)
#define REG_SC_BK08_6E_L      _PK_L_(0x08, 0x6E)
#define REG_SC_BK08_6E_H      _PK_H_(0x08, 0x6E)
#define REG_SC_BK08_6F_L      _PK_L_(0x08, 0x6F)
#define REG_SC_BK08_6F_H      _PK_H_(0x08, 0x6F)
#define REG_SC_BK08_70_L      _PK_L_(0x08, 0x70)
#define REG_SC_BK08_70_H      _PK_H_(0x08, 0x70)
#define REG_SC_BK08_71_L      _PK_L_(0x08, 0x71)
#define REG_SC_BK08_71_H      _PK_H_(0x08, 0x71)
#define REG_SC_BK08_72_L      _PK_L_(0x08, 0x72)
#define REG_SC_BK08_72_H      _PK_H_(0x08, 0x72)
#define REG_SC_BK08_73_L      _PK_L_(0x08, 0x73)
#define REG_SC_BK08_73_H      _PK_H_(0x08, 0x73)
#define REG_SC_BK08_74_L      _PK_L_(0x08, 0x74)
#define REG_SC_BK08_74_H      _PK_H_(0x08, 0x74)
#define REG_SC_BK08_75_L      _PK_L_(0x08, 0x75)
#define REG_SC_BK08_75_H      _PK_H_(0x08, 0x75)
#define REG_SC_BK08_76_L      _PK_L_(0x08, 0x76)
#define REG_SC_BK08_76_H      _PK_H_(0x08, 0x76)
#define REG_SC_BK08_77_L      _PK_L_(0x08, 0x77)
#define REG_SC_BK08_77_H      _PK_H_(0x08, 0x77)
#define REG_SC_BK08_78_L      _PK_L_(0x08, 0x78)
#define REG_SC_BK08_78_H      _PK_H_(0x08, 0x78)
#define REG_SC_BK08_79_L      _PK_L_(0x08, 0x79)
#define REG_SC_BK08_79_H      _PK_H_(0x08, 0x79)
#define REG_SC_BK08_7A_L      _PK_L_(0x08, 0x7A)
#define REG_SC_BK08_7A_H      _PK_H_(0x08, 0x7A)
#define REG_SC_BK08_7B_L      _PK_L_(0x08, 0x7B)
#define REG_SC_BK08_7B_H      _PK_H_(0x08, 0x7B)
#define REG_SC_BK08_7C_L      _PK_L_(0x08, 0x7C)
#define REG_SC_BK08_7C_H      _PK_H_(0x08, 0x7C)
#define REG_SC_BK08_7D_L      _PK_L_(0x08, 0x7D)
#define REG_SC_BK08_7D_H      _PK_H_(0x08, 0x7D)
#define REG_SC_BK08_7E_L      _PK_L_(0x08, 0x7E)
#define REG_SC_BK08_7E_H      _PK_H_(0x08, 0x7E)
#define REG_SC_BK08_7F_L      _PK_L_(0x08, 0x7F)
#define REG_SC_BK08_7F_H      _PK_H_(0x08, 0x7F)
//----------------------------------------------
#define REG_SC_BK09_00_L      _PK_L_(0x09, 0x00)
#define REG_SC_BK09_00_H      _PK_H_(0x09, 0x00)
#define REG_SC_BK09_01_L      _PK_L_(0x09, 0x01)
#define REG_SC_BK09_01_H      _PK_H_(0x09, 0x01)
#define REG_SC_BK09_02_L      _PK_L_(0x09, 0x02)
#define REG_SC_BK09_02_H      _PK_H_(0x09, 0x02)
#define REG_SC_BK09_03_L      _PK_L_(0x09, 0x03)
#define REG_SC_BK09_03_H      _PK_H_(0x09, 0x03)
#define REG_SC_BK09_04_L      _PK_L_(0x09, 0x04)
#define REG_SC_BK09_04_H      _PK_H_(0x09, 0x04)
#define REG_SC_BK09_05_L      _PK_L_(0x09, 0x05)
#define REG_SC_BK09_05_H      _PK_H_(0x09, 0x05)
#define REG_SC_BK09_06_L      _PK_L_(0x09, 0x06)
#define REG_SC_BK09_06_H      _PK_H_(0x09, 0x06)
#define REG_SC_BK09_07_L      _PK_L_(0x09, 0x07)
#define REG_SC_BK09_07_H      _PK_H_(0x09, 0x07)
#define REG_SC_BK09_08_L      _PK_L_(0x09, 0x08)
#define REG_SC_BK09_08_H      _PK_H_(0x09, 0x08)
#define REG_SC_BK09_09_L      _PK_L_(0x09, 0x09)
#define REG_SC_BK09_09_H      _PK_H_(0x09, 0x09)
#define REG_SC_BK09_0A_L      _PK_L_(0x09, 0x0A)
#define REG_SC_BK09_0A_H      _PK_H_(0x09, 0x0A)
#define REG_SC_BK09_0B_L      _PK_L_(0x09, 0x0B)
#define REG_SC_BK09_0B_H      _PK_H_(0x09, 0x0B)
#define REG_SC_BK09_0C_L      _PK_L_(0x09, 0x0C)
#define REG_SC_BK09_0C_H      _PK_H_(0x09, 0x0C)
#define REG_SC_BK09_0D_L      _PK_L_(0x09, 0x0D)
#define REG_SC_BK09_0D_H      _PK_H_(0x09, 0x0D)
#define REG_SC_BK09_0E_L      _PK_L_(0x09, 0x0E)
#define REG_SC_BK09_0E_H      _PK_H_(0x09, 0x0E)
#define REG_SC_BK09_0F_L      _PK_L_(0x09, 0x0F)
#define REG_SC_BK09_0F_H      _PK_H_(0x09, 0x0F)
#define REG_SC_BK09_10_L      _PK_L_(0x09, 0x10)
#define REG_SC_BK09_10_H      _PK_H_(0x09, 0x10)
#define REG_SC_BK09_11_L      _PK_L_(0x09, 0x11)
#define REG_SC_BK09_11_H      _PK_H_(0x09, 0x11)
#define REG_SC_BK09_12_L      _PK_L_(0x09, 0x12)
#define REG_SC_BK09_12_H      _PK_H_(0x09, 0x12)
#define REG_SC_BK09_13_L      _PK_L_(0x09, 0x13)
#define REG_SC_BK09_13_H      _PK_H_(0x09, 0x13)
#define REG_SC_BK09_14_L      _PK_L_(0x09, 0x14)
#define REG_SC_BK09_14_H      _PK_H_(0x09, 0x14)
#define REG_SC_BK09_15_L      _PK_L_(0x09, 0x15)
#define REG_SC_BK09_15_H      _PK_H_(0x09, 0x15)
#define REG_SC_BK09_16_L      _PK_L_(0x09, 0x16)
#define REG_SC_BK09_16_H      _PK_H_(0x09, 0x16)
#define REG_SC_BK09_17_L      _PK_L_(0x09, 0x17)
#define REG_SC_BK09_17_H      _PK_H_(0x09, 0x17)
#define REG_SC_BK09_18_L      _PK_L_(0x09, 0x18)
#define REG_SC_BK09_18_H      _PK_H_(0x09, 0x18)
#define REG_SC_BK09_19_L      _PK_L_(0x09, 0x19)
#define REG_SC_BK09_19_H      _PK_H_(0x09, 0x19)
#define REG_SC_BK09_1A_L      _PK_L_(0x09, 0x1A)
#define REG_SC_BK09_1A_H      _PK_H_(0x09, 0x1A)
#define REG_SC_BK09_1B_L      _PK_L_(0x09, 0x1B)
#define REG_SC_BK09_1B_H      _PK_H_(0x09, 0x1B)
#define REG_SC_BK09_1C_L      _PK_L_(0x09, 0x1C)
#define REG_SC_BK09_1C_H      _PK_H_(0x09, 0x1C)
#define REG_SC_BK09_1D_L      _PK_L_(0x09, 0x1D)
#define REG_SC_BK09_1D_H      _PK_H_(0x09, 0x1D)
#define REG_SC_BK09_1E_L      _PK_L_(0x09, 0x1E)
#define REG_SC_BK09_1E_H      _PK_H_(0x09, 0x1E)
#define REG_SC_BK09_1F_L      _PK_L_(0x09, 0x1F)
#define REG_SC_BK09_1F_H      _PK_H_(0x09, 0x1F)
#define REG_SC_BK09_20_L      _PK_L_(0x09, 0x20)
#define REG_SC_BK09_20_H      _PK_H_(0x09, 0x20)
#define REG_SC_BK09_21_L      _PK_L_(0x09, 0x21)
#define REG_SC_BK09_21_H      _PK_H_(0x09, 0x21)
#define REG_SC_BK09_22_L      _PK_L_(0x09, 0x22)
#define REG_SC_BK09_22_H      _PK_H_(0x09, 0x22)
#define REG_SC_BK09_23_L      _PK_L_(0x09, 0x23)
#define REG_SC_BK09_23_H      _PK_H_(0x09, 0x23)
#define REG_SC_BK09_24_L      _PK_L_(0x09, 0x24)
#define REG_SC_BK09_24_H      _PK_H_(0x09, 0x24)
#define REG_SC_BK09_25_L      _PK_L_(0x09, 0x25)
#define REG_SC_BK09_25_H      _PK_H_(0x09, 0x25)
#define REG_SC_BK09_26_L      _PK_L_(0x09, 0x26)
#define REG_SC_BK09_26_H      _PK_H_(0x09, 0x26)
#define REG_SC_BK09_27_L      _PK_L_(0x09, 0x27)
#define REG_SC_BK09_27_H      _PK_H_(0x09, 0x27)
#define REG_SC_BK09_28_L      _PK_L_(0x09, 0x28)
#define REG_SC_BK09_28_H      _PK_H_(0x09, 0x28)
#define REG_SC_BK09_29_L      _PK_L_(0x09, 0x29)
#define REG_SC_BK09_29_H      _PK_H_(0x09, 0x29)
#define REG_SC_BK09_2A_L      _PK_L_(0x09, 0x2A)
#define REG_SC_BK09_2A_H      _PK_H_(0x09, 0x2A)
#define REG_SC_BK09_2B_L      _PK_L_(0x09, 0x2B)
#define REG_SC_BK09_2B_H      _PK_H_(0x09, 0x2B)
#define REG_SC_BK09_2C_L      _PK_L_(0x09, 0x2C)
#define REG_SC_BK09_2C_H      _PK_H_(0x09, 0x2C)
#define REG_SC_BK09_2D_L      _PK_L_(0x09, 0x2D)
#define REG_SC_BK09_2D_H      _PK_H_(0x09, 0x2D)
#define REG_SC_BK09_2E_L      _PK_L_(0x09, 0x2E)
#define REG_SC_BK09_2E_H      _PK_H_(0x09, 0x2E)
#define REG_SC_BK09_2F_L      _PK_L_(0x09, 0x2F)
#define REG_SC_BK09_2F_H      _PK_H_(0x09, 0x2F)
#define REG_SC_BK09_30_L      _PK_L_(0x09, 0x30)
#define REG_SC_BK09_30_H      _PK_H_(0x09, 0x30)
#define REG_SC_BK09_31_L      _PK_L_(0x09, 0x31)
#define REG_SC_BK09_31_H      _PK_H_(0x09, 0x31)
#define REG_SC_BK09_32_L      _PK_L_(0x09, 0x32)
#define REG_SC_BK09_32_H      _PK_H_(0x09, 0x32)
#define REG_SC_BK09_33_L      _PK_L_(0x09, 0x33)
#define REG_SC_BK09_33_H      _PK_H_(0x09, 0x33)
#define REG_SC_BK09_34_L      _PK_L_(0x09, 0x34)
#define REG_SC_BK09_34_H      _PK_H_(0x09, 0x34)
#define REG_SC_BK09_35_L      _PK_L_(0x09, 0x35)
#define REG_SC_BK09_35_H      _PK_H_(0x09, 0x35)
#define REG_SC_BK09_36_L      _PK_L_(0x09, 0x36)
#define REG_SC_BK09_36_H      _PK_H_(0x09, 0x36)
#define REG_SC_BK09_37_L      _PK_L_(0x09, 0x37)
#define REG_SC_BK09_37_H      _PK_H_(0x09, 0x37)
#define REG_SC_BK09_38_L      _PK_L_(0x09, 0x38)
#define REG_SC_BK09_38_H      _PK_H_(0x09, 0x38)
#define REG_SC_BK09_39_L      _PK_L_(0x09, 0x39)
#define REG_SC_BK09_39_H      _PK_H_(0x09, 0x39)
#define REG_SC_BK09_3A_L      _PK_L_(0x09, 0x3A)
#define REG_SC_BK09_3A_H      _PK_H_(0x09, 0x3A)
#define REG_SC_BK09_3B_L      _PK_L_(0x09, 0x3B)
#define REG_SC_BK09_3B_H      _PK_H_(0x09, 0x3B)
#define REG_SC_BK09_3C_L      _PK_L_(0x09, 0x3C)
#define REG_SC_BK09_3C_H      _PK_H_(0x09, 0x3C)
#define REG_SC_BK09_3D_L      _PK_L_(0x09, 0x3D)
#define REG_SC_BK09_3D_H      _PK_H_(0x09, 0x3D)
#define REG_SC_BK09_3E_L      _PK_L_(0x09, 0x3E)
#define REG_SC_BK09_3E_H      _PK_H_(0x09, 0x3E)
#define REG_SC_BK09_3F_L      _PK_L_(0x09, 0x3F)
#define REG_SC_BK09_3F_H      _PK_H_(0x09, 0x3F)
#define REG_SC_BK09_40_L      _PK_L_(0x09, 0x40)
#define REG_SC_BK09_40_H      _PK_H_(0x09, 0x40)
#define REG_SC_BK09_41_L      _PK_L_(0x09, 0x41)
#define REG_SC_BK09_41_H      _PK_H_(0x09, 0x41)
#define REG_SC_BK09_42_L      _PK_L_(0x09, 0x42)
#define REG_SC_BK09_42_H      _PK_H_(0x09, 0x42)
#define REG_SC_BK09_43_L      _PK_L_(0x09, 0x43)
#define REG_SC_BK09_43_H      _PK_H_(0x09, 0x43)
#define REG_SC_BK09_44_L      _PK_L_(0x09, 0x44)
#define REG_SC_BK09_44_H      _PK_H_(0x09, 0x44)
#define REG_SC_BK09_45_L      _PK_L_(0x09, 0x45)
#define REG_SC_BK09_45_H      _PK_H_(0x09, 0x45)
#define REG_SC_BK09_46_L      _PK_L_(0x09, 0x46)
#define REG_SC_BK09_46_H      _PK_H_(0x09, 0x46)
#define REG_SC_BK09_47_L      _PK_L_(0x09, 0x47)
#define REG_SC_BK09_47_H      _PK_H_(0x09, 0x47)
#define REG_SC_BK09_48_L      _PK_L_(0x09, 0x48)
#define REG_SC_BK09_48_H      _PK_H_(0x09, 0x48)
#define REG_SC_BK09_49_L      _PK_L_(0x09, 0x49)
#define REG_SC_BK09_49_H      _PK_H_(0x09, 0x49)
#define REG_SC_BK09_4A_L      _PK_L_(0x09, 0x4A)
#define REG_SC_BK09_4A_H      _PK_H_(0x09, 0x4A)
#define REG_SC_BK09_4B_L      _PK_L_(0x09, 0x4B)
#define REG_SC_BK09_4B_H      _PK_H_(0x09, 0x4B)
#define REG_SC_BK09_4C_L      _PK_L_(0x09, 0x4C)
#define REG_SC_BK09_4C_H      _PK_H_(0x09, 0x4C)
#define REG_SC_BK09_4D_L      _PK_L_(0x09, 0x4D)
#define REG_SC_BK09_4D_H      _PK_H_(0x09, 0x4D)
#define REG_SC_BK09_4E_L      _PK_L_(0x09, 0x4E)
#define REG_SC_BK09_4E_H      _PK_H_(0x09, 0x4E)
#define REG_SC_BK09_4F_L      _PK_L_(0x09, 0x4F)
#define REG_SC_BK09_4F_H      _PK_H_(0x09, 0x4F)
#define REG_SC_BK09_50_L      _PK_L_(0x09, 0x50)
#define REG_SC_BK09_50_H      _PK_H_(0x09, 0x50)
#define REG_SC_BK09_51_L      _PK_L_(0x09, 0x51)
#define REG_SC_BK09_51_H      _PK_H_(0x09, 0x51)
#define REG_SC_BK09_52_L      _PK_L_(0x09, 0x52)
#define REG_SC_BK09_52_H      _PK_H_(0x09, 0x52)
#define REG_SC_BK09_53_L      _PK_L_(0x09, 0x53)
#define REG_SC_BK09_53_H      _PK_H_(0x09, 0x53)
#define REG_SC_BK09_54_L      _PK_L_(0x09, 0x54)
#define REG_SC_BK09_54_H      _PK_H_(0x09, 0x54)
#define REG_SC_BK09_55_L      _PK_L_(0x09, 0x55)
#define REG_SC_BK09_55_H      _PK_H_(0x09, 0x55)
#define REG_SC_BK09_56_L      _PK_L_(0x09, 0x56)
#define REG_SC_BK09_56_H      _PK_H_(0x09, 0x56)
#define REG_SC_BK09_57_L      _PK_L_(0x09, 0x57)
#define REG_SC_BK09_57_H      _PK_H_(0x09, 0x57)
#define REG_SC_BK09_58_L      _PK_L_(0x09, 0x58)
#define REG_SC_BK09_58_H      _PK_H_(0x09, 0x58)
#define REG_SC_BK09_59_L      _PK_L_(0x09, 0x59)
#define REG_SC_BK09_59_H      _PK_H_(0x09, 0x59)
#define REG_SC_BK09_5A_L      _PK_L_(0x09, 0x5A)
#define REG_SC_BK09_5A_H      _PK_H_(0x09, 0x5A)
#define REG_SC_BK09_5B_L      _PK_L_(0x09, 0x5B)
#define REG_SC_BK09_5B_H      _PK_H_(0x09, 0x5B)
#define REG_SC_BK09_5C_L      _PK_L_(0x09, 0x5C)
#define REG_SC_BK09_5C_H      _PK_H_(0x09, 0x5C)
#define REG_SC_BK09_5D_L      _PK_L_(0x09, 0x5D)
#define REG_SC_BK09_5D_H      _PK_H_(0x09, 0x5D)
#define REG_SC_BK09_5E_L      _PK_L_(0x09, 0x5E)
#define REG_SC_BK09_5E_H      _PK_H_(0x09, 0x5E)
#define REG_SC_BK09_5F_L      _PK_L_(0x09, 0x5F)
#define REG_SC_BK09_5F_H      _PK_H_(0x09, 0x5F)
#define REG_SC_BK09_60_L      _PK_L_(0x09, 0x60)
#define REG_SC_BK09_60_H      _PK_H_(0x09, 0x60)
#define REG_SC_BK09_61_L      _PK_L_(0x09, 0x61)
#define REG_SC_BK09_61_H      _PK_H_(0x09, 0x61)
#define REG_SC_BK09_62_L      _PK_L_(0x09, 0x62)
#define REG_SC_BK09_62_H      _PK_H_(0x09, 0x62)
#define REG_SC_BK09_63_L      _PK_L_(0x09, 0x63)
#define REG_SC_BK09_63_H      _PK_H_(0x09, 0x63)
#define REG_SC_BK09_64_L      _PK_L_(0x09, 0x64)
#define REG_SC_BK09_64_H      _PK_H_(0x09, 0x64)
#define REG_SC_BK09_65_L      _PK_L_(0x09, 0x65)
#define REG_SC_BK09_65_H      _PK_H_(0x09, 0x65)
#define REG_SC_BK09_66_L      _PK_L_(0x09, 0x66)
#define REG_SC_BK09_66_H      _PK_H_(0x09, 0x66)
#define REG_SC_BK09_67_L      _PK_L_(0x09, 0x67)
#define REG_SC_BK09_67_H      _PK_H_(0x09, 0x67)
#define REG_SC_BK09_68_L      _PK_L_(0x09, 0x68)
#define REG_SC_BK09_68_H      _PK_H_(0x09, 0x68)
#define REG_SC_BK09_69_L      _PK_L_(0x09, 0x69)
#define REG_SC_BK09_69_H      _PK_H_(0x09, 0x69)
#define REG_SC_BK09_6A_L      _PK_L_(0x09, 0x6A)
#define REG_SC_BK09_6A_H      _PK_H_(0x09, 0x6A)
#define REG_SC_BK09_6B_L      _PK_L_(0x09, 0x6B)
#define REG_SC_BK09_6B_H      _PK_H_(0x09, 0x6B)
#define REG_SC_BK09_6C_L      _PK_L_(0x09, 0x6C)
#define REG_SC_BK09_6C_H      _PK_H_(0x09, 0x6C)
#define REG_SC_BK09_6D_L      _PK_L_(0x09, 0x6D)
#define REG_SC_BK09_6D_H      _PK_H_(0x09, 0x6D)
#define REG_SC_BK09_6E_L      _PK_L_(0x09, 0x6E)
#define REG_SC_BK09_6E_H      _PK_H_(0x09, 0x6E)
#define REG_SC_BK09_6F_L      _PK_L_(0x09, 0x6F)
#define REG_SC_BK09_6F_H      _PK_H_(0x09, 0x6F)
#define REG_SC_BK09_70_L      _PK_L_(0x09, 0x70)
#define REG_SC_BK09_70_H      _PK_H_(0x09, 0x70)
#define REG_SC_BK09_71_L      _PK_L_(0x09, 0x71)
#define REG_SC_BK09_71_H      _PK_H_(0x09, 0x71)
#define REG_SC_BK09_72_L      _PK_L_(0x09, 0x72)
#define REG_SC_BK09_72_H      _PK_H_(0x09, 0x72)
#define REG_SC_BK09_73_L      _PK_L_(0x09, 0x73)
#define REG_SC_BK09_73_H      _PK_H_(0x09, 0x73)
#define REG_SC_BK09_74_L      _PK_L_(0x09, 0x74)
#define REG_SC_BK09_74_H      _PK_H_(0x09, 0x74)
#define REG_SC_BK09_75_L      _PK_L_(0x09, 0x75)
#define REG_SC_BK09_75_H      _PK_H_(0x09, 0x75)
#define REG_SC_BK09_76_L      _PK_L_(0x09, 0x76)
#define REG_SC_BK09_76_H      _PK_H_(0x09, 0x76)
#define REG_SC_BK09_77_L      _PK_L_(0x09, 0x77)
#define REG_SC_BK09_77_H      _PK_H_(0x09, 0x77)
#define REG_SC_BK09_78_L      _PK_L_(0x09, 0x78)
#define REG_SC_BK09_78_H      _PK_H_(0x09, 0x78)
#define REG_SC_BK09_79_L      _PK_L_(0x09, 0x79)
#define REG_SC_BK09_79_H      _PK_H_(0x09, 0x79)
#define REG_SC_BK09_7A_L      _PK_L_(0x09, 0x7A)
#define REG_SC_BK09_7A_H      _PK_H_(0x09, 0x7A)
#define REG_SC_BK09_7B_L      _PK_L_(0x09, 0x7B)
#define REG_SC_BK09_7B_H      _PK_H_(0x09, 0x7B)
#define REG_SC_BK09_7C_L      _PK_L_(0x09, 0x7C)
#define REG_SC_BK09_7C_H      _PK_H_(0x09, 0x7C)
#define REG_SC_BK09_7D_L      _PK_L_(0x09, 0x7D)
#define REG_SC_BK09_7D_H      _PK_H_(0x09, 0x7D)
#define REG_SC_BK09_7E_L      _PK_L_(0x09, 0x7E)
#define REG_SC_BK09_7E_H      _PK_H_(0x09, 0x7E)
#define REG_SC_BK09_7F_L      _PK_L_(0x09, 0x7F)
#define REG_SC_BK09_7F_H      _PK_H_(0x09, 0x7F)
//----------------------------------------------
#define REG_SC_BK0A_00_L      _PK_L_(0x0A, 0x00)
#define REG_SC_BK0A_00_H      _PK_H_(0x0A, 0x00)
#define REG_SC_BK0A_01_L      _PK_L_(0x0A, 0x01)
#define REG_SC_BK0A_01_H      _PK_H_(0x0A, 0x01)
#define REG_SC_BK0A_02_L      _PK_L_(0x0A, 0x02)
#define REG_SC_BK0A_02_H      _PK_H_(0x0A, 0x02)
#define REG_SC_BK0A_03_L      _PK_L_(0x0A, 0x03)
#define REG_SC_BK0A_03_H      _PK_H_(0x0A, 0x03)
#define REG_SC_BK0A_04_L      _PK_L_(0x0A, 0x04)
#define REG_SC_BK0A_04_H      _PK_H_(0x0A, 0x04)
#define REG_SC_BK0A_05_L      _PK_L_(0x0A, 0x05)
#define REG_SC_BK0A_05_H      _PK_H_(0x0A, 0x05)
#define REG_SC_BK0A_06_L      _PK_L_(0x0A, 0x06)
#define REG_SC_BK0A_06_H      _PK_H_(0x0A, 0x06)
#define REG_SC_BK0A_07_L      _PK_L_(0x0A, 0x07)
#define REG_SC_BK0A_07_H      _PK_H_(0x0A, 0x07)
#define REG_SC_BK0A_08_L      _PK_L_(0x0A, 0x08)
#define REG_SC_BK0A_08_H      _PK_H_(0x0A, 0x08)
#define REG_SC_BK0A_09_L      _PK_L_(0x0A, 0x09)
#define REG_SC_BK0A_09_H      _PK_H_(0x0A, 0x09)
#define REG_SC_BK0A_0A_L      _PK_L_(0x0A, 0x0A)
#define REG_SC_BK0A_0A_H      _PK_H_(0x0A, 0x0A)
#define REG_SC_BK0A_0B_L      _PK_L_(0x0A, 0x0B)
#define REG_SC_BK0A_0B_H      _PK_H_(0x0A, 0x0B)
#define REG_SC_BK0A_0C_L      _PK_L_(0x0A, 0x0C)
#define REG_SC_BK0A_0C_H      _PK_H_(0x0A, 0x0C)
#define REG_SC_BK0A_0D_L      _PK_L_(0x0A, 0x0D)
#define REG_SC_BK0A_0D_H      _PK_H_(0x0A, 0x0D)
#define REG_SC_BK0A_0E_L      _PK_L_(0x0A, 0x0E)
#define REG_SC_BK0A_0E_H      _PK_H_(0x0A, 0x0E)
#define REG_SC_BK0A_0F_L      _PK_L_(0x0A, 0x0F)
#define REG_SC_BK0A_0F_H      _PK_H_(0x0A, 0x0F)
#define REG_SC_BK0A_10_L      _PK_L_(0x0A, 0x10)
#define REG_SC_BK0A_10_H      _PK_H_(0x0A, 0x10)
#define REG_SC_BK0A_11_L      _PK_L_(0x0A, 0x11)
#define REG_SC_BK0A_11_H      _PK_H_(0x0A, 0x11)
#define REG_SC_BK0A_12_L      _PK_L_(0x0A, 0x12)
#define REG_SC_BK0A_12_H      _PK_H_(0x0A, 0x12)
#define REG_SC_BK0A_13_L      _PK_L_(0x0A, 0x13)
#define REG_SC_BK0A_13_H      _PK_H_(0x0A, 0x13)
#define REG_SC_BK0A_14_L      _PK_L_(0x0A, 0x14)
#define REG_SC_BK0A_14_H      _PK_H_(0x0A, 0x14)
#define REG_SC_BK0A_15_L      _PK_L_(0x0A, 0x15)
#define REG_SC_BK0A_15_H      _PK_H_(0x0A, 0x15)
#define REG_SC_BK0A_16_L      _PK_L_(0x0A, 0x16)
#define REG_SC_BK0A_16_H      _PK_H_(0x0A, 0x16)
#define REG_SC_BK0A_17_L      _PK_L_(0x0A, 0x17)
#define REG_SC_BK0A_17_H      _PK_H_(0x0A, 0x17)
#define REG_SC_BK0A_18_L      _PK_L_(0x0A, 0x18)
#define REG_SC_BK0A_18_H      _PK_H_(0x0A, 0x18)
#define REG_SC_BK0A_19_L      _PK_L_(0x0A, 0x19)
#define REG_SC_BK0A_19_H      _PK_H_(0x0A, 0x19)
#define REG_SC_BK0A_1A_L      _PK_L_(0x0A, 0x1A)
#define REG_SC_BK0A_1A_H      _PK_H_(0x0A, 0x1A)
#define REG_SC_BK0A_1B_L      _PK_L_(0x0A, 0x1B)
#define REG_SC_BK0A_1B_H      _PK_H_(0x0A, 0x1B)
#define REG_SC_BK0A_1C_L      _PK_L_(0x0A, 0x1C)
#define REG_SC_BK0A_1C_H      _PK_H_(0x0A, 0x1C)
#define REG_SC_BK0A_1D_L      _PK_L_(0x0A, 0x1D)
#define REG_SC_BK0A_1D_H      _PK_H_(0x0A, 0x1D)
#define REG_SC_BK0A_1E_L      _PK_L_(0x0A, 0x1E)
#define REG_SC_BK0A_1E_H      _PK_H_(0x0A, 0x1E)
#define REG_SC_BK0A_1F_L      _PK_L_(0x0A, 0x1F)
#define REG_SC_BK0A_1F_H      _PK_H_(0x0A, 0x1F)
#define REG_SC_BK0A_20_L      _PK_L_(0x0A, 0x20)
#define REG_SC_BK0A_20_H      _PK_H_(0x0A, 0x20)
#define REG_SC_BK0A_21_L      _PK_L_(0x0A, 0x21)
#define REG_SC_BK0A_21_H      _PK_H_(0x0A, 0x21)
#define REG_SC_BK0A_22_L      _PK_L_(0x0A, 0x22)
#define REG_SC_BK0A_22_H      _PK_H_(0x0A, 0x22)
#define REG_SC_BK0A_23_L      _PK_L_(0x0A, 0x23)
#define REG_SC_BK0A_23_H      _PK_H_(0x0A, 0x23)
#define REG_SC_BK0A_24_L      _PK_L_(0x0A, 0x24)
#define REG_SC_BK0A_24_H      _PK_H_(0x0A, 0x24)
#define REG_SC_BK0A_25_L      _PK_L_(0x0A, 0x25)
#define REG_SC_BK0A_25_H      _PK_H_(0x0A, 0x25)
#define REG_SC_BK0A_26_L      _PK_L_(0x0A, 0x26)
#define REG_SC_BK0A_26_H      _PK_H_(0x0A, 0x26)
#define REG_SC_BK0A_27_L      _PK_L_(0x0A, 0x27)
#define REG_SC_BK0A_27_H      _PK_H_(0x0A, 0x27)
#define REG_SC_BK0A_28_L      _PK_L_(0x0A, 0x28)
#define REG_SC_BK0A_28_H      _PK_H_(0x0A, 0x28)
#define REG_SC_BK0A_29_L      _PK_L_(0x0A, 0x29)
#define REG_SC_BK0A_29_H      _PK_H_(0x0A, 0x29)
#define REG_SC_BK0A_2A_L      _PK_L_(0x0A, 0x2A)
#define REG_SC_BK0A_2A_H      _PK_H_(0x0A, 0x2A)
#define REG_SC_BK0A_2B_L      _PK_L_(0x0A, 0x2B)
#define REG_SC_BK0A_2B_H      _PK_H_(0x0A, 0x2B)
#define REG_SC_BK0A_2C_L      _PK_L_(0x0A, 0x2C)
#define REG_SC_BK0A_2C_H      _PK_H_(0x0A, 0x2C)
#define REG_SC_BK0A_2D_L      _PK_L_(0x0A, 0x2D)
#define REG_SC_BK0A_2D_H      _PK_H_(0x0A, 0x2D)
#define REG_SC_BK0A_2E_L      _PK_L_(0x0A, 0x2E)
#define REG_SC_BK0A_2E_H      _PK_H_(0x0A, 0x2E)
#define REG_SC_BK0A_2F_L      _PK_L_(0x0A, 0x2F)
#define REG_SC_BK0A_2F_H      _PK_H_(0x0A, 0x2F)
#define REG_SC_BK0A_30_L      _PK_L_(0x0A, 0x30)
#define REG_SC_BK0A_30_H      _PK_H_(0x0A, 0x30)
#define REG_SC_BK0A_31_L      _PK_L_(0x0A, 0x31)
#define REG_SC_BK0A_31_H      _PK_H_(0x0A, 0x31)
#define REG_SC_BK0A_32_L      _PK_L_(0x0A, 0x32)
#define REG_SC_BK0A_32_H      _PK_H_(0x0A, 0x32)
#define REG_SC_BK0A_33_L      _PK_L_(0x0A, 0x33)
#define REG_SC_BK0A_33_H      _PK_H_(0x0A, 0x33)
#define REG_SC_BK0A_34_L      _PK_L_(0x0A, 0x34)
#define REG_SC_BK0A_34_H      _PK_H_(0x0A, 0x34)
#define REG_SC_BK0A_35_L      _PK_L_(0x0A, 0x35)
#define REG_SC_BK0A_35_H      _PK_H_(0x0A, 0x35)
#define REG_SC_BK0A_36_L      _PK_L_(0x0A, 0x36)
#define REG_SC_BK0A_36_H      _PK_H_(0x0A, 0x36)
#define REG_SC_BK0A_37_L      _PK_L_(0x0A, 0x37)
#define REG_SC_BK0A_37_H      _PK_H_(0x0A, 0x37)
#define REG_SC_BK0A_38_L      _PK_L_(0x0A, 0x38)
#define REG_SC_BK0A_38_H      _PK_H_(0x0A, 0x38)
#define REG_SC_BK0A_39_L      _PK_L_(0x0A, 0x39)
#define REG_SC_BK0A_39_H      _PK_H_(0x0A, 0x39)
#define REG_SC_BK0A_3A_L      _PK_L_(0x0A, 0x3A)
#define REG_SC_BK0A_3A_H      _PK_H_(0x0A, 0x3A)
#define REG_SC_BK0A_3B_L      _PK_L_(0x0A, 0x3B)
#define REG_SC_BK0A_3B_H      _PK_H_(0x0A, 0x3B)
#define REG_SC_BK0A_3C_L      _PK_L_(0x0A, 0x3C)
#define REG_SC_BK0A_3C_H      _PK_H_(0x0A, 0x3C)
#define REG_SC_BK0A_3D_L      _PK_L_(0x0A, 0x3D)
#define REG_SC_BK0A_3D_H      _PK_H_(0x0A, 0x3D)
#define REG_SC_BK0A_3E_L      _PK_L_(0x0A, 0x3E)
#define REG_SC_BK0A_3E_H      _PK_H_(0x0A, 0x3E)
#define REG_SC_BK0A_3F_L      _PK_L_(0x0A, 0x3F)
#define REG_SC_BK0A_3F_H      _PK_H_(0x0A, 0x3F)
#define REG_SC_BK0A_40_L      _PK_L_(0x0A, 0x40)
#define REG_SC_BK0A_40_H      _PK_H_(0x0A, 0x40)
#define REG_SC_BK0A_41_L      _PK_L_(0x0A, 0x41)
#define REG_SC_BK0A_41_H      _PK_H_(0x0A, 0x41)
#define REG_SC_BK0A_42_L      _PK_L_(0x0A, 0x42)
#define REG_SC_BK0A_42_H      _PK_H_(0x0A, 0x42)
#define REG_SC_BK0A_43_L      _PK_L_(0x0A, 0x43)
#define REG_SC_BK0A_43_H      _PK_H_(0x0A, 0x43)
#define REG_SC_BK0A_44_L      _PK_L_(0x0A, 0x44)
#define REG_SC_BK0A_44_H      _PK_H_(0x0A, 0x44)
#define REG_SC_BK0A_45_L      _PK_L_(0x0A, 0x45)
#define REG_SC_BK0A_45_H      _PK_H_(0x0A, 0x45)
#define REG_SC_BK0A_46_L      _PK_L_(0x0A, 0x46)
#define REG_SC_BK0A_46_H      _PK_H_(0x0A, 0x46)
#define REG_SC_BK0A_47_L      _PK_L_(0x0A, 0x47)
#define REG_SC_BK0A_47_H      _PK_H_(0x0A, 0x47)
#define REG_SC_BK0A_48_L      _PK_L_(0x0A, 0x48)
#define REG_SC_BK0A_48_H      _PK_H_(0x0A, 0x48)
#define REG_SC_BK0A_49_L      _PK_L_(0x0A, 0x49)
#define REG_SC_BK0A_49_H      _PK_H_(0x0A, 0x49)
#define REG_SC_BK0A_4A_L      _PK_L_(0x0A, 0x4A)
#define REG_SC_BK0A_4A_H      _PK_H_(0x0A, 0x4A)
#define REG_SC_BK0A_4B_L      _PK_L_(0x0A, 0x4B)
#define REG_SC_BK0A_4B_H      _PK_H_(0x0A, 0x4B)
#define REG_SC_BK0A_4C_L      _PK_L_(0x0A, 0x4C)
#define REG_SC_BK0A_4C_H      _PK_H_(0x0A, 0x4C)
#define REG_SC_BK0A_4D_L      _PK_L_(0x0A, 0x4D)
#define REG_SC_BK0A_4D_H      _PK_H_(0x0A, 0x4D)
#define REG_SC_BK0A_4E_L      _PK_L_(0x0A, 0x4E)
#define REG_SC_BK0A_4E_H      _PK_H_(0x0A, 0x4E)
#define REG_SC_BK0A_4F_L      _PK_L_(0x0A, 0x4F)
#define REG_SC_BK0A_4F_H      _PK_H_(0x0A, 0x4F)
#define REG_SC_BK0A_50_L      _PK_L_(0x0A, 0x50)
#define REG_SC_BK0A_50_H      _PK_H_(0x0A, 0x50)
#define REG_SC_BK0A_51_L      _PK_L_(0x0A, 0x51)
#define REG_SC_BK0A_51_H      _PK_H_(0x0A, 0x51)
#define REG_SC_BK0A_52_L      _PK_L_(0x0A, 0x52)
#define REG_SC_BK0A_52_H      _PK_H_(0x0A, 0x52)
#define REG_SC_BK0A_53_L      _PK_L_(0x0A, 0x53)
#define REG_SC_BK0A_53_H      _PK_H_(0x0A, 0x53)
#define REG_SC_BK0A_54_L      _PK_L_(0x0A, 0x54)
#define REG_SC_BK0A_54_H      _PK_H_(0x0A, 0x54)
#define REG_SC_BK0A_55_L      _PK_L_(0x0A, 0x55)
#define REG_SC_BK0A_55_H      _PK_H_(0x0A, 0x55)
#define REG_SC_BK0A_56_L      _PK_L_(0x0A, 0x56)
#define REG_SC_BK0A_56_H      _PK_H_(0x0A, 0x56)
#define REG_SC_BK0A_57_L      _PK_L_(0x0A, 0x57)
#define REG_SC_BK0A_57_H      _PK_H_(0x0A, 0x57)
#define REG_SC_BK0A_58_L      _PK_L_(0x0A, 0x58)
#define REG_SC_BK0A_58_H      _PK_H_(0x0A, 0x58)
#define REG_SC_BK0A_59_L      _PK_L_(0x0A, 0x59)
#define REG_SC_BK0A_59_H      _PK_H_(0x0A, 0x59)
#define REG_SC_BK0A_5A_L      _PK_L_(0x0A, 0x5A)
#define REG_SC_BK0A_5A_H      _PK_H_(0x0A, 0x5A)
#define REG_SC_BK0A_5B_L      _PK_L_(0x0A, 0x5B)
#define REG_SC_BK0A_5B_H      _PK_H_(0x0A, 0x5B)
#define REG_SC_BK0A_5C_L      _PK_L_(0x0A, 0x5C)
#define REG_SC_BK0A_5C_H      _PK_H_(0x0A, 0x5C)
#define REG_SC_BK0A_5D_L      _PK_L_(0x0A, 0x5D)
#define REG_SC_BK0A_5D_H      _PK_H_(0x0A, 0x5D)
#define REG_SC_BK0A_5E_L      _PK_L_(0x0A, 0x5E)
#define REG_SC_BK0A_5E_H      _PK_H_(0x0A, 0x5E)
#define REG_SC_BK0A_5F_L      _PK_L_(0x0A, 0x5F)
#define REG_SC_BK0A_5F_H      _PK_H_(0x0A, 0x5F)
#define REG_SC_BK0A_60_L      _PK_L_(0x0A, 0x60)
#define REG_SC_BK0A_60_H      _PK_H_(0x0A, 0x60)
#define REG_SC_BK0A_61_L      _PK_L_(0x0A, 0x61)
#define REG_SC_BK0A_61_H      _PK_H_(0x0A, 0x61)
#define REG_SC_BK0A_62_L      _PK_L_(0x0A, 0x62)
#define REG_SC_BK0A_62_H      _PK_H_(0x0A, 0x62)
#define REG_SC_BK0A_63_L      _PK_L_(0x0A, 0x63)
#define REG_SC_BK0A_63_H      _PK_H_(0x0A, 0x63)
#define REG_SC_BK0A_64_L      _PK_L_(0x0A, 0x64)
#define REG_SC_BK0A_64_H      _PK_H_(0x0A, 0x64)
#define REG_SC_BK0A_65_L      _PK_L_(0x0A, 0x65)
#define REG_SC_BK0A_65_H      _PK_H_(0x0A, 0x65)
#define REG_SC_BK0A_66_L      _PK_L_(0x0A, 0x66)
#define REG_SC_BK0A_66_H      _PK_H_(0x0A, 0x66)
#define REG_SC_BK0A_67_L      _PK_L_(0x0A, 0x67)
#define REG_SC_BK0A_67_H      _PK_H_(0x0A, 0x67)
#define REG_SC_BK0A_68_L      _PK_L_(0x0A, 0x68)
#define REG_SC_BK0A_68_H      _PK_H_(0x0A, 0x68)
#define REG_SC_BK0A_69_L      _PK_L_(0x0A, 0x69)
#define REG_SC_BK0A_69_H      _PK_H_(0x0A, 0x69)
#define REG_SC_BK0A_6A_L      _PK_L_(0x0A, 0x6A)
#define REG_SC_BK0A_6A_H      _PK_H_(0x0A, 0x6A)
#define REG_SC_BK0A_6B_L      _PK_L_(0x0A, 0x6B)
#define REG_SC_BK0A_6B_H      _PK_H_(0x0A, 0x6B)
#define REG_SC_BK0A_6C_L      _PK_L_(0x0A, 0x6C)
#define REG_SC_BK0A_6C_H      _PK_H_(0x0A, 0x6C)
#define REG_SC_BK0A_6D_L      _PK_L_(0x0A, 0x6D)
#define REG_SC_BK0A_6D_H      _PK_H_(0x0A, 0x6D)
#define REG_SC_BK0A_6E_L      _PK_L_(0x0A, 0x6E)
#define REG_SC_BK0A_6E_H      _PK_H_(0x0A, 0x6E)
#define REG_SC_BK0A_6F_L      _PK_L_(0x0A, 0x6F)
#define REG_SC_BK0A_6F_H      _PK_H_(0x0A, 0x6F)
#define REG_SC_BK0A_70_L      _PK_L_(0x0A, 0x70)
#define REG_SC_BK0A_70_H      _PK_H_(0x0A, 0x70)
#define REG_SC_BK0A_71_L      _PK_L_(0x0A, 0x71)
#define REG_SC_BK0A_71_H      _PK_H_(0x0A, 0x71)
#define REG_SC_BK0A_72_L      _PK_L_(0x0A, 0x72)
#define REG_SC_BK0A_72_H      _PK_H_(0x0A, 0x72)
#define REG_SC_BK0A_73_L      _PK_L_(0x0A, 0x73)
#define REG_SC_BK0A_73_H      _PK_H_(0x0A, 0x73)
#define REG_SC_BK0A_74_L      _PK_L_(0x0A, 0x74)
#define REG_SC_BK0A_74_H      _PK_H_(0x0A, 0x74)
#define REG_SC_BK0A_75_L      _PK_L_(0x0A, 0x75)
#define REG_SC_BK0A_75_H      _PK_H_(0x0A, 0x75)
#define REG_SC_BK0A_76_L      _PK_L_(0x0A, 0x76)
#define REG_SC_BK0A_76_H      _PK_H_(0x0A, 0x76)
#define REG_SC_BK0A_77_L      _PK_L_(0x0A, 0x77)
#define REG_SC_BK0A_77_H      _PK_H_(0x0A, 0x77)
#define REG_SC_BK0A_78_L      _PK_L_(0x0A, 0x78)
#define REG_SC_BK0A_78_H      _PK_H_(0x0A, 0x78)
#define REG_SC_BK0A_79_L      _PK_L_(0x0A, 0x79)
#define REG_SC_BK0A_79_H      _PK_H_(0x0A, 0x79)
#define REG_SC_BK0A_7A_L      _PK_L_(0x0A, 0x7A)
#define REG_SC_BK0A_7A_H      _PK_H_(0x0A, 0x7A)
#define REG_SC_BK0A_7B_L      _PK_L_(0x0A, 0x7B)
#define REG_SC_BK0A_7B_H      _PK_H_(0x0A, 0x7B)
#define REG_SC_BK0A_7C_L      _PK_L_(0x0A, 0x7C)
#define REG_SC_BK0A_7C_H      _PK_H_(0x0A, 0x7C)
#define REG_SC_BK0A_7D_L      _PK_L_(0x0A, 0x7D)
#define REG_SC_BK0A_7D_H      _PK_H_(0x0A, 0x7D)
#define REG_SC_BK0A_7E_L      _PK_L_(0x0A, 0x7E)
#define REG_SC_BK0A_7E_H      _PK_H_(0x0A, 0x7E)
#define REG_SC_BK0A_7F_L      _PK_L_(0x0A, 0x7F)
#define REG_SC_BK0A_7F_H      _PK_H_(0x0A, 0x7F)
//----------------------------------------------
#define REG_SC_BK0B_00_L      _PK_L_(0x0B, 0x00)
#define REG_SC_BK0B_00_H      _PK_H_(0x0B, 0x00)
#define REG_SC_BK0B_01_L      _PK_L_(0x0B, 0x01)
#define REG_SC_BK0B_01_H      _PK_H_(0x0B, 0x01)
#define REG_SC_BK0B_02_L      _PK_L_(0x0B, 0x02)
#define REG_SC_BK0B_02_H      _PK_H_(0x0B, 0x02)
#define REG_SC_BK0B_03_L      _PK_L_(0x0B, 0x03)
#define REG_SC_BK0B_03_H      _PK_H_(0x0B, 0x03)
#define REG_SC_BK0B_04_L      _PK_L_(0x0B, 0x04)
#define REG_SC_BK0B_04_H      _PK_H_(0x0B, 0x04)
#define REG_SC_BK0B_05_L      _PK_L_(0x0B, 0x05)
#define REG_SC_BK0B_05_H      _PK_H_(0x0B, 0x05)
#define REG_SC_BK0B_06_L      _PK_L_(0x0B, 0x06)
#define REG_SC_BK0B_06_H      _PK_H_(0x0B, 0x06)
#define REG_SC_BK0B_07_L      _PK_L_(0x0B, 0x07)
#define REG_SC_BK0B_07_H      _PK_H_(0x0B, 0x07)
#define REG_SC_BK0B_08_L      _PK_L_(0x0B, 0x08)
#define REG_SC_BK0B_08_H      _PK_H_(0x0B, 0x08)
#define REG_SC_BK0B_09_L      _PK_L_(0x0B, 0x09)
#define REG_SC_BK0B_09_H      _PK_H_(0x0B, 0x09)
#define REG_SC_BK0B_0A_L      _PK_L_(0x0B, 0x0A)
#define REG_SC_BK0B_0A_H      _PK_H_(0x0B, 0x0A)
#define REG_SC_BK0B_0B_L      _PK_L_(0x0B, 0x0B)
#define REG_SC_BK0B_0B_H      _PK_H_(0x0B, 0x0B)
#define REG_SC_BK0B_0C_L      _PK_L_(0x0B, 0x0C)
#define REG_SC_BK0B_0C_H      _PK_H_(0x0B, 0x0C)
#define REG_SC_BK0B_0D_L      _PK_L_(0x0B, 0x0D)
#define REG_SC_BK0B_0D_H      _PK_H_(0x0B, 0x0D)
#define REG_SC_BK0B_0E_L      _PK_L_(0x0B, 0x0E)
#define REG_SC_BK0B_0E_H      _PK_H_(0x0B, 0x0E)
#define REG_SC_BK0B_0F_L      _PK_L_(0x0B, 0x0F)
#define REG_SC_BK0B_0F_H      _PK_H_(0x0B, 0x0F)
#define REG_SC_BK0B_10_L      _PK_L_(0x0B, 0x10)
#define REG_SC_BK0B_10_H      _PK_H_(0x0B, 0x10)
#define REG_SC_BK0B_11_L      _PK_L_(0x0B, 0x11)
#define REG_SC_BK0B_11_H      _PK_H_(0x0B, 0x11)
#define REG_SC_BK0B_12_L      _PK_L_(0x0B, 0x12)
#define REG_SC_BK0B_12_H      _PK_H_(0x0B, 0x12)
#define REG_SC_BK0B_13_L      _PK_L_(0x0B, 0x13)
#define REG_SC_BK0B_13_H      _PK_H_(0x0B, 0x13)
#define REG_SC_BK0B_14_L      _PK_L_(0x0B, 0x14)
#define REG_SC_BK0B_14_H      _PK_H_(0x0B, 0x14)
#define REG_SC_BK0B_15_L      _PK_L_(0x0B, 0x15)
#define REG_SC_BK0B_15_H      _PK_H_(0x0B, 0x15)
#define REG_SC_BK0B_16_L      _PK_L_(0x0B, 0x16)
#define REG_SC_BK0B_16_H      _PK_H_(0x0B, 0x16)
#define REG_SC_BK0B_17_L      _PK_L_(0x0B, 0x17)
#define REG_SC_BK0B_17_H      _PK_H_(0x0B, 0x17)
#define REG_SC_BK0B_18_L      _PK_L_(0x0B, 0x18)
#define REG_SC_BK0B_18_H      _PK_H_(0x0B, 0x18)
#define REG_SC_BK0B_19_L      _PK_L_(0x0B, 0x19)
#define REG_SC_BK0B_19_H      _PK_H_(0x0B, 0x19)
#define REG_SC_BK0B_1A_L      _PK_L_(0x0B, 0x1A)
#define REG_SC_BK0B_1A_H      _PK_H_(0x0B, 0x1A)
#define REG_SC_BK0B_1B_L      _PK_L_(0x0B, 0x1B)
#define REG_SC_BK0B_1B_H      _PK_H_(0x0B, 0x1B)
#define REG_SC_BK0B_1C_L      _PK_L_(0x0B, 0x1C)
#define REG_SC_BK0B_1C_H      _PK_H_(0x0B, 0x1C)
#define REG_SC_BK0B_1D_L      _PK_L_(0x0B, 0x1D)
#define REG_SC_BK0B_1D_H      _PK_H_(0x0B, 0x1D)
#define REG_SC_BK0B_1E_L      _PK_L_(0x0B, 0x1E)
#define REG_SC_BK0B_1E_H      _PK_H_(0x0B, 0x1E)
#define REG_SC_BK0B_1F_L      _PK_L_(0x0B, 0x1F)
#define REG_SC_BK0B_1F_H      _PK_H_(0x0B, 0x1F)
#define REG_SC_BK0B_20_L      _PK_L_(0x0B, 0x20)
#define REG_SC_BK0B_20_H      _PK_H_(0x0B, 0x20)
#define REG_SC_BK0B_21_L      _PK_L_(0x0B, 0x21)
#define REG_SC_BK0B_21_H      _PK_H_(0x0B, 0x21)
#define REG_SC_BK0B_22_L      _PK_L_(0x0B, 0x22)
#define REG_SC_BK0B_22_H      _PK_H_(0x0B, 0x22)
#define REG_SC_BK0B_23_L      _PK_L_(0x0B, 0x23)
#define REG_SC_BK0B_23_H      _PK_H_(0x0B, 0x23)
#define REG_SC_BK0B_24_L      _PK_L_(0x0B, 0x24)
#define REG_SC_BK0B_24_H      _PK_H_(0x0B, 0x24)
#define REG_SC_BK0B_25_L      _PK_L_(0x0B, 0x25)
#define REG_SC_BK0B_25_H      _PK_H_(0x0B, 0x25)
#define REG_SC_BK0B_26_L      _PK_L_(0x0B, 0x26)
#define REG_SC_BK0B_26_H      _PK_H_(0x0B, 0x26)
#define REG_SC_BK0B_27_L      _PK_L_(0x0B, 0x27)
#define REG_SC_BK0B_27_H      _PK_H_(0x0B, 0x27)
#define REG_SC_BK0B_28_L      _PK_L_(0x0B, 0x28)
#define REG_SC_BK0B_28_H      _PK_H_(0x0B, 0x28)
#define REG_SC_BK0B_29_L      _PK_L_(0x0B, 0x29)
#define REG_SC_BK0B_29_H      _PK_H_(0x0B, 0x29)
#define REG_SC_BK0B_2A_L      _PK_L_(0x0B, 0x2A)
#define REG_SC_BK0B_2A_H      _PK_H_(0x0B, 0x2A)
#define REG_SC_BK0B_2B_L      _PK_L_(0x0B, 0x2B)
#define REG_SC_BK0B_2B_H      _PK_H_(0x0B, 0x2B)
#define REG_SC_BK0B_2C_L      _PK_L_(0x0B, 0x2C)
#define REG_SC_BK0B_2C_H      _PK_H_(0x0B, 0x2C)
#define REG_SC_BK0B_2D_L      _PK_L_(0x0B, 0x2D)
#define REG_SC_BK0B_2D_H      _PK_H_(0x0B, 0x2D)
#define REG_SC_BK0B_2E_L      _PK_L_(0x0B, 0x2E)
#define REG_SC_BK0B_2E_H      _PK_H_(0x0B, 0x2E)
#define REG_SC_BK0B_2F_L      _PK_L_(0x0B, 0x2F)
#define REG_SC_BK0B_2F_H      _PK_H_(0x0B, 0x2F)
#define REG_SC_BK0B_30_L      _PK_L_(0x0B, 0x30)
#define REG_SC_BK0B_30_H      _PK_H_(0x0B, 0x30)
#define REG_SC_BK0B_31_L      _PK_L_(0x0B, 0x31)
#define REG_SC_BK0B_31_H      _PK_H_(0x0B, 0x31)
#define REG_SC_BK0B_32_L      _PK_L_(0x0B, 0x32)
#define REG_SC_BK0B_32_H      _PK_H_(0x0B, 0x32)
#define REG_SC_BK0B_33_L      _PK_L_(0x0B, 0x33)
#define REG_SC_BK0B_33_H      _PK_H_(0x0B, 0x33)
#define REG_SC_BK0B_34_L      _PK_L_(0x0B, 0x34)
#define REG_SC_BK0B_34_H      _PK_H_(0x0B, 0x34)
#define REG_SC_BK0B_35_L      _PK_L_(0x0B, 0x35)
#define REG_SC_BK0B_35_H      _PK_H_(0x0B, 0x35)
#define REG_SC_BK0B_36_L      _PK_L_(0x0B, 0x36)
#define REG_SC_BK0B_36_H      _PK_H_(0x0B, 0x36)
#define REG_SC_BK0B_37_L      _PK_L_(0x0B, 0x37)
#define REG_SC_BK0B_37_H      _PK_H_(0x0B, 0x37)
#define REG_SC_BK0B_38_L      _PK_L_(0x0B, 0x38)
#define REG_SC_BK0B_38_H      _PK_H_(0x0B, 0x38)
#define REG_SC_BK0B_39_L      _PK_L_(0x0B, 0x39)
#define REG_SC_BK0B_39_H      _PK_H_(0x0B, 0x39)
#define REG_SC_BK0B_3A_L      _PK_L_(0x0B, 0x3A)
#define REG_SC_BK0B_3A_H      _PK_H_(0x0B, 0x3A)
#define REG_SC_BK0B_3B_L      _PK_L_(0x0B, 0x3B)
#define REG_SC_BK0B_3B_H      _PK_H_(0x0B, 0x3B)
#define REG_SC_BK0B_3C_L      _PK_L_(0x0B, 0x3C)
#define REG_SC_BK0B_3C_H      _PK_H_(0x0B, 0x3C)
#define REG_SC_BK0B_3D_L      _PK_L_(0x0B, 0x3D)
#define REG_SC_BK0B_3D_H      _PK_H_(0x0B, 0x3D)
#define REG_SC_BK0B_3E_L      _PK_L_(0x0B, 0x3E)
#define REG_SC_BK0B_3E_H      _PK_H_(0x0B, 0x3E)
#define REG_SC_BK0B_3F_L      _PK_L_(0x0B, 0x3F)
#define REG_SC_BK0B_3F_H      _PK_H_(0x0B, 0x3F)
#define REG_SC_BK0B_40_L      _PK_L_(0x0B, 0x40)
#define REG_SC_BK0B_40_H      _PK_H_(0x0B, 0x40)
#define REG_SC_BK0B_41_L      _PK_L_(0x0B, 0x41)
#define REG_SC_BK0B_41_H      _PK_H_(0x0B, 0x41)
#define REG_SC_BK0B_42_L      _PK_L_(0x0B, 0x42)
#define REG_SC_BK0B_42_H      _PK_H_(0x0B, 0x42)
#define REG_SC_BK0B_43_L      _PK_L_(0x0B, 0x43)
#define REG_SC_BK0B_43_H      _PK_H_(0x0B, 0x43)
#define REG_SC_BK0B_44_L      _PK_L_(0x0B, 0x44)
#define REG_SC_BK0B_44_H      _PK_H_(0x0B, 0x44)
#define REG_SC_BK0B_45_L      _PK_L_(0x0B, 0x45)
#define REG_SC_BK0B_45_H      _PK_H_(0x0B, 0x45)
#define REG_SC_BK0B_46_L      _PK_L_(0x0B, 0x46)
#define REG_SC_BK0B_46_H      _PK_H_(0x0B, 0x46)
#define REG_SC_BK0B_47_L      _PK_L_(0x0B, 0x47)
#define REG_SC_BK0B_47_H      _PK_H_(0x0B, 0x47)
#define REG_SC_BK0B_48_L      _PK_L_(0x0B, 0x48)
#define REG_SC_BK0B_48_H      _PK_H_(0x0B, 0x48)
#define REG_SC_BK0B_49_L      _PK_L_(0x0B, 0x49)
#define REG_SC_BK0B_49_H      _PK_H_(0x0B, 0x49)
#define REG_SC_BK0B_4A_L      _PK_L_(0x0B, 0x4A)
#define REG_SC_BK0B_4A_H      _PK_H_(0x0B, 0x4A)
#define REG_SC_BK0B_4B_L      _PK_L_(0x0B, 0x4B)
#define REG_SC_BK0B_4B_H      _PK_H_(0x0B, 0x4B)
#define REG_SC_BK0B_4C_L      _PK_L_(0x0B, 0x4C)
#define REG_SC_BK0B_4C_H      _PK_H_(0x0B, 0x4C)
#define REG_SC_BK0B_4D_L      _PK_L_(0x0B, 0x4D)
#define REG_SC_BK0B_4D_H      _PK_H_(0x0B, 0x4D)
#define REG_SC_BK0B_4E_L      _PK_L_(0x0B, 0x4E)
#define REG_SC_BK0B_4E_H      _PK_H_(0x0B, 0x4E)
#define REG_SC_BK0B_4F_L      _PK_L_(0x0B, 0x4F)
#define REG_SC_BK0B_4F_H      _PK_H_(0x0B, 0x4F)
#define REG_SC_BK0B_50_L      _PK_L_(0x0B, 0x50)
#define REG_SC_BK0B_50_H      _PK_H_(0x0B, 0x50)
#define REG_SC_BK0B_51_L      _PK_L_(0x0B, 0x51)
#define REG_SC_BK0B_51_H      _PK_H_(0x0B, 0x51)
#define REG_SC_BK0B_52_L      _PK_L_(0x0B, 0x52)
#define REG_SC_BK0B_52_H      _PK_H_(0x0B, 0x52)
#define REG_SC_BK0B_53_L      _PK_L_(0x0B, 0x53)
#define REG_SC_BK0B_53_H      _PK_H_(0x0B, 0x53)
#define REG_SC_BK0B_54_L      _PK_L_(0x0B, 0x54)
#define REG_SC_BK0B_54_H      _PK_H_(0x0B, 0x54)
#define REG_SC_BK0B_55_L      _PK_L_(0x0B, 0x55)
#define REG_SC_BK0B_55_H      _PK_H_(0x0B, 0x55)
#define REG_SC_BK0B_56_L      _PK_L_(0x0B, 0x56)
#define REG_SC_BK0B_56_H      _PK_H_(0x0B, 0x56)
#define REG_SC_BK0B_57_L      _PK_L_(0x0B, 0x57)
#define REG_SC_BK0B_57_H      _PK_H_(0x0B, 0x57)
#define REG_SC_BK0B_58_L      _PK_L_(0x0B, 0x58)
#define REG_SC_BK0B_58_H      _PK_H_(0x0B, 0x58)
#define REG_SC_BK0B_59_L      _PK_L_(0x0B, 0x59)
#define REG_SC_BK0B_59_H      _PK_H_(0x0B, 0x59)
#define REG_SC_BK0B_5A_L      _PK_L_(0x0B, 0x5A)
#define REG_SC_BK0B_5A_H      _PK_H_(0x0B, 0x5A)
#define REG_SC_BK0B_5B_L      _PK_L_(0x0B, 0x5B)
#define REG_SC_BK0B_5B_H      _PK_H_(0x0B, 0x5B)
#define REG_SC_BK0B_5C_L      _PK_L_(0x0B, 0x5C)
#define REG_SC_BK0B_5C_H      _PK_H_(0x0B, 0x5C)
#define REG_SC_BK0B_5D_L      _PK_L_(0x0B, 0x5D)
#define REG_SC_BK0B_5D_H      _PK_H_(0x0B, 0x5D)
#define REG_SC_BK0B_5E_L      _PK_L_(0x0B, 0x5E)
#define REG_SC_BK0B_5E_H      _PK_H_(0x0B, 0x5E)
#define REG_SC_BK0B_5F_L      _PK_L_(0x0B, 0x5F)
#define REG_SC_BK0B_5F_H      _PK_H_(0x0B, 0x5F)
#define REG_SC_BK0B_60_L      _PK_L_(0x0B, 0x60)
#define REG_SC_BK0B_60_H      _PK_H_(0x0B, 0x60)
#define REG_SC_BK0B_61_L      _PK_L_(0x0B, 0x61)
#define REG_SC_BK0B_61_H      _PK_H_(0x0B, 0x61)
#define REG_SC_BK0B_62_L      _PK_L_(0x0B, 0x62)
#define REG_SC_BK0B_62_H      _PK_H_(0x0B, 0x62)
#define REG_SC_BK0B_63_L      _PK_L_(0x0B, 0x63)
#define REG_SC_BK0B_63_H      _PK_H_(0x0B, 0x63)
#define REG_SC_BK0B_64_L      _PK_L_(0x0B, 0x64)
#define REG_SC_BK0B_64_H      _PK_H_(0x0B, 0x64)
#define REG_SC_BK0B_65_L      _PK_L_(0x0B, 0x65)
#define REG_SC_BK0B_65_H      _PK_H_(0x0B, 0x65)
#define REG_SC_BK0B_66_L      _PK_L_(0x0B, 0x66)
#define REG_SC_BK0B_66_H      _PK_H_(0x0B, 0x66)
#define REG_SC_BK0B_67_L      _PK_L_(0x0B, 0x67)
#define REG_SC_BK0B_67_H      _PK_H_(0x0B, 0x67)
#define REG_SC_BK0B_68_L      _PK_L_(0x0B, 0x68)
#define REG_SC_BK0B_68_H      _PK_H_(0x0B, 0x68)
#define REG_SC_BK0B_69_L      _PK_L_(0x0B, 0x69)
#define REG_SC_BK0B_69_H      _PK_H_(0x0B, 0x69)
#define REG_SC_BK0B_6A_L      _PK_L_(0x0B, 0x6A)
#define REG_SC_BK0B_6A_H      _PK_H_(0x0B, 0x6A)
#define REG_SC_BK0B_6B_L      _PK_L_(0x0B, 0x6B)
#define REG_SC_BK0B_6B_H      _PK_H_(0x0B, 0x6B)
#define REG_SC_BK0B_6C_L      _PK_L_(0x0B, 0x6C)
#define REG_SC_BK0B_6C_H      _PK_H_(0x0B, 0x6C)
#define REG_SC_BK0B_6D_L      _PK_L_(0x0B, 0x6D)
#define REG_SC_BK0B_6D_H      _PK_H_(0x0B, 0x6D)
#define REG_SC_BK0B_6E_L      _PK_L_(0x0B, 0x6E)
#define REG_SC_BK0B_6E_H      _PK_H_(0x0B, 0x6E)
#define REG_SC_BK0B_6F_L      _PK_L_(0x0B, 0x6F)
#define REG_SC_BK0B_6F_H      _PK_H_(0x0B, 0x6F)
#define REG_SC_BK0B_70_L      _PK_L_(0x0B, 0x70)
#define REG_SC_BK0B_70_H      _PK_H_(0x0B, 0x70)
#define REG_SC_BK0B_71_L      _PK_L_(0x0B, 0x71)
#define REG_SC_BK0B_71_H      _PK_H_(0x0B, 0x71)
#define REG_SC_BK0B_72_L      _PK_L_(0x0B, 0x72)
#define REG_SC_BK0B_72_H      _PK_H_(0x0B, 0x72)
#define REG_SC_BK0B_73_L      _PK_L_(0x0B, 0x73)
#define REG_SC_BK0B_73_H      _PK_H_(0x0B, 0x73)
#define REG_SC_BK0B_74_L      _PK_L_(0x0B, 0x74)
#define REG_SC_BK0B_74_H      _PK_H_(0x0B, 0x74)
#define REG_SC_BK0B_75_L      _PK_L_(0x0B, 0x75)
#define REG_SC_BK0B_75_H      _PK_H_(0x0B, 0x75)
#define REG_SC_BK0B_76_L      _PK_L_(0x0B, 0x76)
#define REG_SC_BK0B_76_H      _PK_H_(0x0B, 0x76)
#define REG_SC_BK0B_77_L      _PK_L_(0x0B, 0x77)
#define REG_SC_BK0B_77_H      _PK_H_(0x0B, 0x77)
#define REG_SC_BK0B_78_L      _PK_L_(0x0B, 0x78)
#define REG_SC_BK0B_78_H      _PK_H_(0x0B, 0x78)
#define REG_SC_BK0B_79_L      _PK_L_(0x0B, 0x79)
#define REG_SC_BK0B_79_H      _PK_H_(0x0B, 0x79)
#define REG_SC_BK0B_7A_L      _PK_L_(0x0B, 0x7A)
#define REG_SC_BK0B_7A_H      _PK_H_(0x0B, 0x7A)
#define REG_SC_BK0B_7B_L      _PK_L_(0x0B, 0x7B)
#define REG_SC_BK0B_7B_H      _PK_H_(0x0B, 0x7B)
#define REG_SC_BK0B_7C_L      _PK_L_(0x0B, 0x7C)
#define REG_SC_BK0B_7C_H      _PK_H_(0x0B, 0x7C)
#define REG_SC_BK0B_7D_L      _PK_L_(0x0B, 0x7D)
#define REG_SC_BK0B_7D_H      _PK_H_(0x0B, 0x7D)
#define REG_SC_BK0B_7E_L      _PK_L_(0x0B, 0x7E)
#define REG_SC_BK0B_7E_H      _PK_H_(0x0B, 0x7E)
#define REG_SC_BK0B_7F_L      _PK_L_(0x0B, 0x7F)
#define REG_SC_BK0B_7F_H      _PK_H_(0x0B, 0x7F)
//----------------------------------------------
#define REG_SC_BK0C_00_L      _PK_L_(0x0C, 0x00)
#define REG_SC_BK0C_00_H      _PK_H_(0x0C, 0x00)
#define REG_SC_BK0C_01_L      _PK_L_(0x0C, 0x01)
#define REG_SC_BK0C_01_H      _PK_H_(0x0C, 0x01)
#define REG_SC_BK0C_02_L      _PK_L_(0x0C, 0x02)
#define REG_SC_BK0C_02_H      _PK_H_(0x0C, 0x02)
#define REG_SC_BK0C_03_L      _PK_L_(0x0C, 0x03)
#define REG_SC_BK0C_03_H      _PK_H_(0x0C, 0x03)
#define REG_SC_BK0C_04_L      _PK_L_(0x0C, 0x04)
#define REG_SC_BK0C_04_H      _PK_H_(0x0C, 0x04)
#define REG_SC_BK0C_05_L      _PK_L_(0x0C, 0x05)
#define REG_SC_BK0C_05_H      _PK_H_(0x0C, 0x05)
#define REG_SC_BK0C_06_L      _PK_L_(0x0C, 0x06)
#define REG_SC_BK0C_06_H      _PK_H_(0x0C, 0x06)
#define REG_SC_BK0C_07_L      _PK_L_(0x0C, 0x07)
#define REG_SC_BK0C_07_H      _PK_H_(0x0C, 0x07)
#define REG_SC_BK0C_08_L      _PK_L_(0x0C, 0x08)
#define REG_SC_BK0C_08_H      _PK_H_(0x0C, 0x08)
#define REG_SC_BK0C_09_L      _PK_L_(0x0C, 0x09)
#define REG_SC_BK0C_09_H      _PK_H_(0x0C, 0x09)
#define REG_SC_BK0C_0A_L      _PK_L_(0x0C, 0x0A)
#define REG_SC_BK0C_0A_H      _PK_H_(0x0C, 0x0A)
#define REG_SC_BK0C_0B_L      _PK_L_(0x0C, 0x0B)
#define REG_SC_BK0C_0B_H      _PK_H_(0x0C, 0x0B)
#define REG_SC_BK0C_0C_L      _PK_L_(0x0C, 0x0C)
#define REG_SC_BK0C_0C_H      _PK_H_(0x0C, 0x0C)
#define REG_SC_BK0C_0D_L      _PK_L_(0x0C, 0x0D)
#define REG_SC_BK0C_0D_H      _PK_H_(0x0C, 0x0D)
#define REG_SC_BK0C_0E_L      _PK_L_(0x0C, 0x0E)
#define REG_SC_BK0C_0E_H      _PK_H_(0x0C, 0x0E)
#define REG_SC_BK0C_0F_L      _PK_L_(0x0C, 0x0F)
#define REG_SC_BK0C_0F_H      _PK_H_(0x0C, 0x0F)
#define REG_SC_BK0C_10_L      _PK_L_(0x0C, 0x10)
#define REG_SC_BK0C_10_H      _PK_H_(0x0C, 0x10)
#define REG_SC_BK0C_11_L      _PK_L_(0x0C, 0x11)
#define REG_SC_BK0C_11_H      _PK_H_(0x0C, 0x11)
#define REG_SC_BK0C_12_L      _PK_L_(0x0C, 0x12)
#define REG_SC_BK0C_12_H      _PK_H_(0x0C, 0x12)
#define REG_SC_BK0C_13_L      _PK_L_(0x0C, 0x13)
#define REG_SC_BK0C_13_H      _PK_H_(0x0C, 0x13)
#define REG_SC_BK0C_14_L      _PK_L_(0x0C, 0x14)
#define REG_SC_BK0C_14_H      _PK_H_(0x0C, 0x14)
#define REG_SC_BK0C_15_L      _PK_L_(0x0C, 0x15)
#define REG_SC_BK0C_15_H      _PK_H_(0x0C, 0x15)
#define REG_SC_BK0C_16_L      _PK_L_(0x0C, 0x16)
#define REG_SC_BK0C_16_H      _PK_H_(0x0C, 0x16)
#define REG_SC_BK0C_17_L      _PK_L_(0x0C, 0x17)
#define REG_SC_BK0C_17_H      _PK_H_(0x0C, 0x17)
#define REG_SC_BK0C_18_L      _PK_L_(0x0C, 0x18)
#define REG_SC_BK0C_18_H      _PK_H_(0x0C, 0x18)
#define REG_SC_BK0C_19_L      _PK_L_(0x0C, 0x19)
#define REG_SC_BK0C_19_H      _PK_H_(0x0C, 0x19)
#define REG_SC_BK0C_1A_L      _PK_L_(0x0C, 0x1A)
#define REG_SC_BK0C_1A_H      _PK_H_(0x0C, 0x1A)
#define REG_SC_BK0C_1B_L      _PK_L_(0x0C, 0x1B)
#define REG_SC_BK0C_1B_H      _PK_H_(0x0C, 0x1B)
#define REG_SC_BK0C_1C_L      _PK_L_(0x0C, 0x1C)
#define REG_SC_BK0C_1C_H      _PK_H_(0x0C, 0x1C)
#define REG_SC_BK0C_1D_L      _PK_L_(0x0C, 0x1D)
#define REG_SC_BK0C_1D_H      _PK_H_(0x0C, 0x1D)
#define REG_SC_BK0C_1E_L      _PK_L_(0x0C, 0x1E)
#define REG_SC_BK0C_1E_H      _PK_H_(0x0C, 0x1E)
#define REG_SC_BK0C_1F_L      _PK_L_(0x0C, 0x1F)
#define REG_SC_BK0C_1F_H      _PK_H_(0x0C, 0x1F)
#define REG_SC_BK0C_20_L      _PK_L_(0x0C, 0x20)
#define REG_SC_BK0C_20_H      _PK_H_(0x0C, 0x20)
#define REG_SC_BK0C_21_L      _PK_L_(0x0C, 0x21)
#define REG_SC_BK0C_21_H      _PK_H_(0x0C, 0x21)
#define REG_SC_BK0C_22_L      _PK_L_(0x0C, 0x22)
#define REG_SC_BK0C_22_H      _PK_H_(0x0C, 0x22)
#define REG_SC_BK0C_23_L      _PK_L_(0x0C, 0x23)
#define REG_SC_BK0C_23_H      _PK_H_(0x0C, 0x23)
#define REG_SC_BK0C_24_L      _PK_L_(0x0C, 0x24)
#define REG_SC_BK0C_24_H      _PK_H_(0x0C, 0x24)
#define REG_SC_BK0C_25_L      _PK_L_(0x0C, 0x25)
#define REG_SC_BK0C_25_H      _PK_H_(0x0C, 0x25)
#define REG_SC_BK0C_26_L      _PK_L_(0x0C, 0x26)
#define REG_SC_BK0C_26_H      _PK_H_(0x0C, 0x26)
#define REG_SC_BK0C_27_L      _PK_L_(0x0C, 0x27)
#define REG_SC_BK0C_27_H      _PK_H_(0x0C, 0x27)
#define REG_SC_BK0C_28_L      _PK_L_(0x0C, 0x28)
#define REG_SC_BK0C_28_H      _PK_H_(0x0C, 0x28)
#define REG_SC_BK0C_29_L      _PK_L_(0x0C, 0x29)
#define REG_SC_BK0C_29_H      _PK_H_(0x0C, 0x29)
#define REG_SC_BK0C_2A_L      _PK_L_(0x0C, 0x2A)
#define REG_SC_BK0C_2A_H      _PK_H_(0x0C, 0x2A)
#define REG_SC_BK0C_2B_L      _PK_L_(0x0C, 0x2B)
#define REG_SC_BK0C_2B_H      _PK_H_(0x0C, 0x2B)
#define REG_SC_BK0C_2C_L      _PK_L_(0x0C, 0x2C)
#define REG_SC_BK0C_2C_H      _PK_H_(0x0C, 0x2C)
#define REG_SC_BK0C_2D_L      _PK_L_(0x0C, 0x2D)
#define REG_SC_BK0C_2D_H      _PK_H_(0x0C, 0x2D)
#define REG_SC_BK0C_2E_L      _PK_L_(0x0C, 0x2E)
#define REG_SC_BK0C_2E_H      _PK_H_(0x0C, 0x2E)
#define REG_SC_BK0C_2F_L      _PK_L_(0x0C, 0x2F)
#define REG_SC_BK0C_2F_H      _PK_H_(0x0C, 0x2F)
#define REG_SC_BK0C_30_L      _PK_L_(0x0C, 0x30)
#define REG_SC_BK0C_30_H      _PK_H_(0x0C, 0x30)
#define REG_SC_BK0C_31_L      _PK_L_(0x0C, 0x31)
#define REG_SC_BK0C_31_H      _PK_H_(0x0C, 0x31)
#define REG_SC_BK0C_32_L      _PK_L_(0x0C, 0x32)
#define REG_SC_BK0C_32_H      _PK_H_(0x0C, 0x32)
#define REG_SC_BK0C_33_L      _PK_L_(0x0C, 0x33)
#define REG_SC_BK0C_33_H      _PK_H_(0x0C, 0x33)
#define REG_SC_BK0C_34_L      _PK_L_(0x0C, 0x34)
#define REG_SC_BK0C_34_H      _PK_H_(0x0C, 0x34)
#define REG_SC_BK0C_35_L      _PK_L_(0x0C, 0x35)
#define REG_SC_BK0C_35_H      _PK_H_(0x0C, 0x35)
#define REG_SC_BK0C_36_L      _PK_L_(0x0C, 0x36)
#define REG_SC_BK0C_36_H      _PK_H_(0x0C, 0x36)
#define REG_SC_BK0C_37_L      _PK_L_(0x0C, 0x37)
#define REG_SC_BK0C_37_H      _PK_H_(0x0C, 0x37)
#define REG_SC_BK0C_38_L      _PK_L_(0x0C, 0x38)
#define REG_SC_BK0C_38_H      _PK_H_(0x0C, 0x38)
#define REG_SC_BK0C_39_L      _PK_L_(0x0C, 0x39)
#define REG_SC_BK0C_39_H      _PK_H_(0x0C, 0x39)
#define REG_SC_BK0C_3A_L      _PK_L_(0x0C, 0x3A)
#define REG_SC_BK0C_3A_H      _PK_H_(0x0C, 0x3A)
#define REG_SC_BK0C_3B_L      _PK_L_(0x0C, 0x3B)
#define REG_SC_BK0C_3B_H      _PK_H_(0x0C, 0x3B)
#define REG_SC_BK0C_3C_L      _PK_L_(0x0C, 0x3C)
#define REG_SC_BK0C_3C_H      _PK_H_(0x0C, 0x3C)
#define REG_SC_BK0C_3D_L      _PK_L_(0x0C, 0x3D)
#define REG_SC_BK0C_3D_H      _PK_H_(0x0C, 0x3D)
#define REG_SC_BK0C_3E_L      _PK_L_(0x0C, 0x3E)
#define REG_SC_BK0C_3E_H      _PK_H_(0x0C, 0x3E)
#define REG_SC_BK0C_3F_L      _PK_L_(0x0C, 0x3F)
#define REG_SC_BK0C_3F_H      _PK_H_(0x0C, 0x3F)
#define REG_SC_BK0C_40_L      _PK_L_(0x0C, 0x40)
#define REG_SC_BK0C_40_H      _PK_H_(0x0C, 0x40)
#define REG_SC_BK0C_41_L      _PK_L_(0x0C, 0x41)
#define REG_SC_BK0C_41_H      _PK_H_(0x0C, 0x41)
#define REG_SC_BK0C_42_L      _PK_L_(0x0C, 0x42)
#define REG_SC_BK0C_42_H      _PK_H_(0x0C, 0x42)
#define REG_SC_BK0C_43_L      _PK_L_(0x0C, 0x43)
#define REG_SC_BK0C_43_H      _PK_H_(0x0C, 0x43)
#define REG_SC_BK0C_44_L      _PK_L_(0x0C, 0x44)
#define REG_SC_BK0C_44_H      _PK_H_(0x0C, 0x44)
#define REG_SC_BK0C_45_L      _PK_L_(0x0C, 0x45)
#define REG_SC_BK0C_45_H      _PK_H_(0x0C, 0x45)
#define REG_SC_BK0C_46_L      _PK_L_(0x0C, 0x46)
#define REG_SC_BK0C_46_H      _PK_H_(0x0C, 0x46)
#define REG_SC_BK0C_47_L      _PK_L_(0x0C, 0x47)
#define REG_SC_BK0C_47_H      _PK_H_(0x0C, 0x47)
#define REG_SC_BK0C_48_L      _PK_L_(0x0C, 0x48)
#define REG_SC_BK0C_48_H      _PK_H_(0x0C, 0x48)
#define REG_SC_BK0C_49_L      _PK_L_(0x0C, 0x49)
#define REG_SC_BK0C_49_H      _PK_H_(0x0C, 0x49)
#define REG_SC_BK0C_4A_L      _PK_L_(0x0C, 0x4A)
#define REG_SC_BK0C_4A_H      _PK_H_(0x0C, 0x4A)
#define REG_SC_BK0C_4B_L      _PK_L_(0x0C, 0x4B)
#define REG_SC_BK0C_4B_H      _PK_H_(0x0C, 0x4B)
#define REG_SC_BK0C_4C_L      _PK_L_(0x0C, 0x4C)
#define REG_SC_BK0C_4C_H      _PK_H_(0x0C, 0x4C)
#define REG_SC_BK0C_4D_L      _PK_L_(0x0C, 0x4D)
#define REG_SC_BK0C_4D_H      _PK_H_(0x0C, 0x4D)
#define REG_SC_BK0C_4E_L      _PK_L_(0x0C, 0x4E)
#define REG_SC_BK0C_4E_H      _PK_H_(0x0C, 0x4E)
#define REG_SC_BK0C_4F_L      _PK_L_(0x0C, 0x4F)
#define REG_SC_BK0C_4F_H      _PK_H_(0x0C, 0x4F)
#define REG_SC_BK0C_50_L      _PK_L_(0x0C, 0x50)
#define REG_SC_BK0C_50_H      _PK_H_(0x0C, 0x50)
#define REG_SC_BK0C_51_L      _PK_L_(0x0C, 0x51)
#define REG_SC_BK0C_51_H      _PK_H_(0x0C, 0x51)
#define REG_SC_BK0C_52_L      _PK_L_(0x0C, 0x52)
#define REG_SC_BK0C_52_H      _PK_H_(0x0C, 0x52)
#define REG_SC_BK0C_53_L      _PK_L_(0x0C, 0x53)
#define REG_SC_BK0C_53_H      _PK_H_(0x0C, 0x53)
#define REG_SC_BK0C_54_L      _PK_L_(0x0C, 0x54)
#define REG_SC_BK0C_54_H      _PK_H_(0x0C, 0x54)
#define REG_SC_BK0C_55_L      _PK_L_(0x0C, 0x55)
#define REG_SC_BK0C_55_H      _PK_H_(0x0C, 0x55)
#define REG_SC_BK0C_56_L      _PK_L_(0x0C, 0x56)
#define REG_SC_BK0C_56_H      _PK_H_(0x0C, 0x56)
#define REG_SC_BK0C_57_L      _PK_L_(0x0C, 0x57)
#define REG_SC_BK0C_57_H      _PK_H_(0x0C, 0x57)
#define REG_SC_BK0C_58_L      _PK_L_(0x0C, 0x58)
#define REG_SC_BK0C_58_H      _PK_H_(0x0C, 0x58)
#define REG_SC_BK0C_59_L      _PK_L_(0x0C, 0x59)
#define REG_SC_BK0C_59_H      _PK_H_(0x0C, 0x59)
#define REG_SC_BK0C_5A_L      _PK_L_(0x0C, 0x5A)
#define REG_SC_BK0C_5A_H      _PK_H_(0x0C, 0x5A)
#define REG_SC_BK0C_5B_L      _PK_L_(0x0C, 0x5B)
#define REG_SC_BK0C_5B_H      _PK_H_(0x0C, 0x5B)
#define REG_SC_BK0C_5C_L      _PK_L_(0x0C, 0x5C)
#define REG_SC_BK0C_5C_H      _PK_H_(0x0C, 0x5C)
#define REG_SC_BK0C_5D_L      _PK_L_(0x0C, 0x5D)
#define REG_SC_BK0C_5D_H      _PK_H_(0x0C, 0x5D)
#define REG_SC_BK0C_5E_L      _PK_L_(0x0C, 0x5E)
#define REG_SC_BK0C_5E_H      _PK_H_(0x0C, 0x5E)
#define REG_SC_BK0C_5F_L      _PK_L_(0x0C, 0x5F)
#define REG_SC_BK0C_5F_H      _PK_H_(0x0C, 0x5F)
#define REG_SC_BK0C_60_L      _PK_L_(0x0C, 0x60)
#define REG_SC_BK0C_60_H      _PK_H_(0x0C, 0x60)
#define REG_SC_BK0C_61_L      _PK_L_(0x0C, 0x61)
#define REG_SC_BK0C_61_H      _PK_H_(0x0C, 0x61)
#define REG_SC_BK0C_62_L      _PK_L_(0x0C, 0x62)
#define REG_SC_BK0C_62_H      _PK_H_(0x0C, 0x62)
#define REG_SC_BK0C_63_L      _PK_L_(0x0C, 0x63)
#define REG_SC_BK0C_63_H      _PK_H_(0x0C, 0x63)
#define REG_SC_BK0C_64_L      _PK_L_(0x0C, 0x64)
#define REG_SC_BK0C_64_H      _PK_H_(0x0C, 0x64)
#define REG_SC_BK0C_65_L      _PK_L_(0x0C, 0x65)
#define REG_SC_BK0C_65_H      _PK_H_(0x0C, 0x65)
#define REG_SC_BK0C_66_L      _PK_L_(0x0C, 0x66)
#define REG_SC_BK0C_66_H      _PK_H_(0x0C, 0x66)
#define REG_SC_BK0C_67_L      _PK_L_(0x0C, 0x67)
#define REG_SC_BK0C_67_H      _PK_H_(0x0C, 0x67)
#define REG_SC_BK0C_68_L      _PK_L_(0x0C, 0x68)
#define REG_SC_BK0C_68_H      _PK_H_(0x0C, 0x68)
#define REG_SC_BK0C_69_L      _PK_L_(0x0C, 0x69)
#define REG_SC_BK0C_69_H      _PK_H_(0x0C, 0x69)
#define REG_SC_BK0C_6A_L      _PK_L_(0x0C, 0x6A)
#define REG_SC_BK0C_6A_H      _PK_H_(0x0C, 0x6A)
#define REG_SC_BK0C_6B_L      _PK_L_(0x0C, 0x6B)
#define REG_SC_BK0C_6B_H      _PK_H_(0x0C, 0x6B)
#define REG_SC_BK0C_6C_L      _PK_L_(0x0C, 0x6C)
#define REG_SC_BK0C_6C_H      _PK_H_(0x0C, 0x6C)
#define REG_SC_BK0C_6D_L      _PK_L_(0x0C, 0x6D)
#define REG_SC_BK0C_6D_H      _PK_H_(0x0C, 0x6D)
#define REG_SC_BK0C_6E_L      _PK_L_(0x0C, 0x6E)
#define REG_SC_BK0C_6E_H      _PK_H_(0x0C, 0x6E)
#define REG_SC_BK0C_6F_L      _PK_L_(0x0C, 0x6F)
#define REG_SC_BK0C_6F_H      _PK_H_(0x0C, 0x6F)
#define REG_SC_BK0C_70_L      _PK_L_(0x0C, 0x70)
#define REG_SC_BK0C_70_H      _PK_H_(0x0C, 0x70)
#define REG_SC_BK0C_71_L      _PK_L_(0x0C, 0x71)
#define REG_SC_BK0C_71_H      _PK_H_(0x0C, 0x71)
#define REG_SC_BK0C_72_L      _PK_L_(0x0C, 0x72)
#define REG_SC_BK0C_72_H      _PK_H_(0x0C, 0x72)
#define REG_SC_BK0C_73_L      _PK_L_(0x0C, 0x73)
#define REG_SC_BK0C_73_H      _PK_H_(0x0C, 0x73)
#define REG_SC_BK0C_74_L      _PK_L_(0x0C, 0x74)
#define REG_SC_BK0C_74_H      _PK_H_(0x0C, 0x74)
#define REG_SC_BK0C_75_L      _PK_L_(0x0C, 0x75)
#define REG_SC_BK0C_75_H      _PK_H_(0x0C, 0x75)
#define REG_SC_BK0C_76_L      _PK_L_(0x0C, 0x76)
#define REG_SC_BK0C_76_H      _PK_H_(0x0C, 0x76)
#define REG_SC_BK0C_77_L      _PK_L_(0x0C, 0x77)
#define REG_SC_BK0C_77_H      _PK_H_(0x0C, 0x77)
#define REG_SC_BK0C_78_L      _PK_L_(0x0C, 0x78)
#define REG_SC_BK0C_78_H      _PK_H_(0x0C, 0x78)
#define REG_SC_BK0C_79_L      _PK_L_(0x0C, 0x79)
#define REG_SC_BK0C_79_H      _PK_H_(0x0C, 0x79)
#define REG_SC_BK0C_7A_L      _PK_L_(0x0C, 0x7A)
#define REG_SC_BK0C_7A_H      _PK_H_(0x0C, 0x7A)
#define REG_SC_BK0C_7B_L      _PK_L_(0x0C, 0x7B)
#define REG_SC_BK0C_7B_H      _PK_H_(0x0C, 0x7B)
#define REG_SC_BK0C_7C_L      _PK_L_(0x0C, 0x7C)
#define REG_SC_BK0C_7C_H      _PK_H_(0x0C, 0x7C)
#define REG_SC_BK0C_7D_L      _PK_L_(0x0C, 0x7D)
#define REG_SC_BK0C_7D_H      _PK_H_(0x0C, 0x7D)
#define REG_SC_BK0C_7E_L      _PK_L_(0x0C, 0x7E)
#define REG_SC_BK0C_7E_H      _PK_H_(0x0C, 0x7E)
#define REG_SC_BK0C_7F_L      _PK_L_(0x0C, 0x7F)
#define REG_SC_BK0C_7F_H      _PK_H_(0x0C, 0x7F)
//----------------------------------------------
#define REG_SC_BK0D_00_L      _PK_L_(0x0D, 0x00)
#define REG_SC_BK0D_00_H      _PK_H_(0x0D, 0x00)
#define REG_SC_BK0D_01_L      _PK_L_(0x0D, 0x01)
#define REG_SC_BK0D_01_H      _PK_H_(0x0D, 0x01)
#define REG_SC_BK0D_02_L      _PK_L_(0x0D, 0x02)
#define REG_SC_BK0D_02_H      _PK_H_(0x0D, 0x02)
#define REG_SC_BK0D_03_L      _PK_L_(0x0D, 0x03)
#define REG_SC_BK0D_03_H      _PK_H_(0x0D, 0x03)
#define REG_SC_BK0D_04_L      _PK_L_(0x0D, 0x04)
#define REG_SC_BK0D_04_H      _PK_H_(0x0D, 0x04)
#define REG_SC_BK0D_05_L      _PK_L_(0x0D, 0x05)
#define REG_SC_BK0D_05_H      _PK_H_(0x0D, 0x05)
#define REG_SC_BK0D_06_L      _PK_L_(0x0D, 0x06)
#define REG_SC_BK0D_06_H      _PK_H_(0x0D, 0x06)
#define REG_SC_BK0D_07_L      _PK_L_(0x0D, 0x07)
#define REG_SC_BK0D_07_H      _PK_H_(0x0D, 0x07)
#define REG_SC_BK0D_08_L      _PK_L_(0x0D, 0x08)
#define REG_SC_BK0D_08_H      _PK_H_(0x0D, 0x08)
#define REG_SC_BK0D_09_L      _PK_L_(0x0D, 0x09)
#define REG_SC_BK0D_09_H      _PK_H_(0x0D, 0x09)
#define REG_SC_BK0D_0A_L      _PK_L_(0x0D, 0x0A)
#define REG_SC_BK0D_0A_H      _PK_H_(0x0D, 0x0A)
#define REG_SC_BK0D_0B_L      _PK_L_(0x0D, 0x0B)
#define REG_SC_BK0D_0B_H      _PK_H_(0x0D, 0x0B)
#define REG_SC_BK0D_0C_L      _PK_L_(0x0D, 0x0C)
#define REG_SC_BK0D_0C_H      _PK_H_(0x0D, 0x0C)
#define REG_SC_BK0D_0D_L      _PK_L_(0x0D, 0x0D)
#define REG_SC_BK0D_0D_H      _PK_H_(0x0D, 0x0D)
#define REG_SC_BK0D_0E_L      _PK_L_(0x0D, 0x0E)
#define REG_SC_BK0D_0E_H      _PK_H_(0x0D, 0x0E)
#define REG_SC_BK0D_0F_L      _PK_L_(0x0D, 0x0F)
#define REG_SC_BK0D_0F_H      _PK_H_(0x0D, 0x0F)
#define REG_SC_BK0D_10_L      _PK_L_(0x0D, 0x10)
#define REG_SC_BK0D_10_H      _PK_H_(0x0D, 0x10)
#define REG_SC_BK0D_11_L      _PK_L_(0x0D, 0x11)
#define REG_SC_BK0D_11_H      _PK_H_(0x0D, 0x11)
#define REG_SC_BK0D_12_L      _PK_L_(0x0D, 0x12)
#define REG_SC_BK0D_12_H      _PK_H_(0x0D, 0x12)
#define REG_SC_BK0D_13_L      _PK_L_(0x0D, 0x13)
#define REG_SC_BK0D_13_H      _PK_H_(0x0D, 0x13)
#define REG_SC_BK0D_14_L      _PK_L_(0x0D, 0x14)
#define REG_SC_BK0D_14_H      _PK_H_(0x0D, 0x14)
#define REG_SC_BK0D_15_L      _PK_L_(0x0D, 0x15)
#define REG_SC_BK0D_15_H      _PK_H_(0x0D, 0x15)
#define REG_SC_BK0D_16_L      _PK_L_(0x0D, 0x16)
#define REG_SC_BK0D_16_H      _PK_H_(0x0D, 0x16)
#define REG_SC_BK0D_17_L      _PK_L_(0x0D, 0x17)
#define REG_SC_BK0D_17_H      _PK_H_(0x0D, 0x17)
#define REG_SC_BK0D_18_L      _PK_L_(0x0D, 0x18)
#define REG_SC_BK0D_18_H      _PK_H_(0x0D, 0x18)
#define REG_SC_BK0D_19_L      _PK_L_(0x0D, 0x19)
#define REG_SC_BK0D_19_H      _PK_H_(0x0D, 0x19)
#define REG_SC_BK0D_1A_L      _PK_L_(0x0D, 0x1A)
#define REG_SC_BK0D_1A_H      _PK_H_(0x0D, 0x1A)
#define REG_SC_BK0D_1B_L      _PK_L_(0x0D, 0x1B)
#define REG_SC_BK0D_1B_H      _PK_H_(0x0D, 0x1B)
#define REG_SC_BK0D_1C_L      _PK_L_(0x0D, 0x1C)
#define REG_SC_BK0D_1C_H      _PK_H_(0x0D, 0x1C)
#define REG_SC_BK0D_1D_L      _PK_L_(0x0D, 0x1D)
#define REG_SC_BK0D_1D_H      _PK_H_(0x0D, 0x1D)
#define REG_SC_BK0D_1E_L      _PK_L_(0x0D, 0x1E)
#define REG_SC_BK0D_1E_H      _PK_H_(0x0D, 0x1E)
#define REG_SC_BK0D_1F_L      _PK_L_(0x0D, 0x1F)
#define REG_SC_BK0D_1F_H      _PK_H_(0x0D, 0x1F)
#define REG_SC_BK0D_20_L      _PK_L_(0x0D, 0x20)
#define REG_SC_BK0D_20_H      _PK_H_(0x0D, 0x20)
#define REG_SC_BK0D_21_L      _PK_L_(0x0D, 0x21)
#define REG_SC_BK0D_21_H      _PK_H_(0x0D, 0x21)
#define REG_SC_BK0D_22_L      _PK_L_(0x0D, 0x22)
#define REG_SC_BK0D_22_H      _PK_H_(0x0D, 0x22)
#define REG_SC_BK0D_23_L      _PK_L_(0x0D, 0x23)
#define REG_SC_BK0D_23_H      _PK_H_(0x0D, 0x23)
#define REG_SC_BK0D_24_L      _PK_L_(0x0D, 0x24)
#define REG_SC_BK0D_24_H      _PK_H_(0x0D, 0x24)
#define REG_SC_BK0D_25_L      _PK_L_(0x0D, 0x25)
#define REG_SC_BK0D_25_H      _PK_H_(0x0D, 0x25)
#define REG_SC_BK0D_26_L      _PK_L_(0x0D, 0x26)
#define REG_SC_BK0D_26_H      _PK_H_(0x0D, 0x26)
#define REG_SC_BK0D_27_L      _PK_L_(0x0D, 0x27)
#define REG_SC_BK0D_27_H      _PK_H_(0x0D, 0x27)
#define REG_SC_BK0D_28_L      _PK_L_(0x0D, 0x28)
#define REG_SC_BK0D_28_H      _PK_H_(0x0D, 0x28)
#define REG_SC_BK0D_29_L      _PK_L_(0x0D, 0x29)
#define REG_SC_BK0D_29_H      _PK_H_(0x0D, 0x29)
#define REG_SC_BK0D_2A_L      _PK_L_(0x0D, 0x2A)
#define REG_SC_BK0D_2A_H      _PK_H_(0x0D, 0x2A)
#define REG_SC_BK0D_2B_L      _PK_L_(0x0D, 0x2B)
#define REG_SC_BK0D_2B_H      _PK_H_(0x0D, 0x2B)
#define REG_SC_BK0D_2C_L      _PK_L_(0x0D, 0x2C)
#define REG_SC_BK0D_2C_H      _PK_H_(0x0D, 0x2C)
#define REG_SC_BK0D_2D_L      _PK_L_(0x0D, 0x2D)
#define REG_SC_BK0D_2D_H      _PK_H_(0x0D, 0x2D)
#define REG_SC_BK0D_2E_L      _PK_L_(0x0D, 0x2E)
#define REG_SC_BK0D_2E_H      _PK_H_(0x0D, 0x2E)
#define REG_SC_BK0D_2F_L      _PK_L_(0x0D, 0x2F)
#define REG_SC_BK0D_2F_H      _PK_H_(0x0D, 0x2F)
#define REG_SC_BK0D_30_L      _PK_L_(0x0D, 0x30)
#define REG_SC_BK0D_30_H      _PK_H_(0x0D, 0x30)
#define REG_SC_BK0D_31_L      _PK_L_(0x0D, 0x31)
#define REG_SC_BK0D_31_H      _PK_H_(0x0D, 0x31)
#define REG_SC_BK0D_32_L      _PK_L_(0x0D, 0x32)
#define REG_SC_BK0D_32_H      _PK_H_(0x0D, 0x32)
#define REG_SC_BK0D_33_L      _PK_L_(0x0D, 0x33)
#define REG_SC_BK0D_33_H      _PK_H_(0x0D, 0x33)
#define REG_SC_BK0D_34_L      _PK_L_(0x0D, 0x34)
#define REG_SC_BK0D_34_H      _PK_H_(0x0D, 0x34)
#define REG_SC_BK0D_35_L      _PK_L_(0x0D, 0x35)
#define REG_SC_BK0D_35_H      _PK_H_(0x0D, 0x35)
#define REG_SC_BK0D_36_L      _PK_L_(0x0D, 0x36)
#define REG_SC_BK0D_36_H      _PK_H_(0x0D, 0x36)
#define REG_SC_BK0D_37_L      _PK_L_(0x0D, 0x37)
#define REG_SC_BK0D_37_H      _PK_H_(0x0D, 0x37)
#define REG_SC_BK0D_38_L      _PK_L_(0x0D, 0x38)
#define REG_SC_BK0D_38_H      _PK_H_(0x0D, 0x38)
#define REG_SC_BK0D_39_L      _PK_L_(0x0D, 0x39)
#define REG_SC_BK0D_39_H      _PK_H_(0x0D, 0x39)
#define REG_SC_BK0D_3A_L      _PK_L_(0x0D, 0x3A)
#define REG_SC_BK0D_3A_H      _PK_H_(0x0D, 0x3A)
#define REG_SC_BK0D_3B_L      _PK_L_(0x0D, 0x3B)
#define REG_SC_BK0D_3B_H      _PK_H_(0x0D, 0x3B)
#define REG_SC_BK0D_3C_L      _PK_L_(0x0D, 0x3C)
#define REG_SC_BK0D_3C_H      _PK_H_(0x0D, 0x3C)
#define REG_SC_BK0D_3D_L      _PK_L_(0x0D, 0x3D)
#define REG_SC_BK0D_3D_H      _PK_H_(0x0D, 0x3D)
#define REG_SC_BK0D_3E_L      _PK_L_(0x0D, 0x3E)
#define REG_SC_BK0D_3E_H      _PK_H_(0x0D, 0x3E)
#define REG_SC_BK0D_3F_L      _PK_L_(0x0D, 0x3F)
#define REG_SC_BK0D_3F_H      _PK_H_(0x0D, 0x3F)
#define REG_SC_BK0D_40_L      _PK_L_(0x0D, 0x40)
#define REG_SC_BK0D_40_H      _PK_H_(0x0D, 0x40)
#define REG_SC_BK0D_41_L      _PK_L_(0x0D, 0x41)
#define REG_SC_BK0D_41_H      _PK_H_(0x0D, 0x41)
#define REG_SC_BK0D_42_L      _PK_L_(0x0D, 0x42)
#define REG_SC_BK0D_42_H      _PK_H_(0x0D, 0x42)
#define REG_SC_BK0D_43_L      _PK_L_(0x0D, 0x43)
#define REG_SC_BK0D_43_H      _PK_H_(0x0D, 0x43)
#define REG_SC_BK0D_44_L      _PK_L_(0x0D, 0x44)
#define REG_SC_BK0D_44_H      _PK_H_(0x0D, 0x44)
#define REG_SC_BK0D_45_L      _PK_L_(0x0D, 0x45)
#define REG_SC_BK0D_45_H      _PK_H_(0x0D, 0x45)
#define REG_SC_BK0D_46_L      _PK_L_(0x0D, 0x46)
#define REG_SC_BK0D_46_H      _PK_H_(0x0D, 0x46)
#define REG_SC_BK0D_47_L      _PK_L_(0x0D, 0x47)
#define REG_SC_BK0D_47_H      _PK_H_(0x0D, 0x47)
#define REG_SC_BK0D_48_L      _PK_L_(0x0D, 0x48)
#define REG_SC_BK0D_48_H      _PK_H_(0x0D, 0x48)
#define REG_SC_BK0D_49_L      _PK_L_(0x0D, 0x49)
#define REG_SC_BK0D_49_H      _PK_H_(0x0D, 0x49)
#define REG_SC_BK0D_4A_L      _PK_L_(0x0D, 0x4A)
#define REG_SC_BK0D_4A_H      _PK_H_(0x0D, 0x4A)
#define REG_SC_BK0D_4B_L      _PK_L_(0x0D, 0x4B)
#define REG_SC_BK0D_4B_H      _PK_H_(0x0D, 0x4B)
#define REG_SC_BK0D_4C_L      _PK_L_(0x0D, 0x4C)
#define REG_SC_BK0D_4C_H      _PK_H_(0x0D, 0x4C)
#define REG_SC_BK0D_4D_L      _PK_L_(0x0D, 0x4D)
#define REG_SC_BK0D_4D_H      _PK_H_(0x0D, 0x4D)
#define REG_SC_BK0D_4E_L      _PK_L_(0x0D, 0x4E)
#define REG_SC_BK0D_4E_H      _PK_H_(0x0D, 0x4E)
#define REG_SC_BK0D_4F_L      _PK_L_(0x0D, 0x4F)
#define REG_SC_BK0D_4F_H      _PK_H_(0x0D, 0x4F)
#define REG_SC_BK0D_50_L      _PK_L_(0x0D, 0x50)
#define REG_SC_BK0D_50_H      _PK_H_(0x0D, 0x50)
#define REG_SC_BK0D_51_L      _PK_L_(0x0D, 0x51)
#define REG_SC_BK0D_51_H      _PK_H_(0x0D, 0x51)
#define REG_SC_BK0D_52_L      _PK_L_(0x0D, 0x52)
#define REG_SC_BK0D_52_H      _PK_H_(0x0D, 0x52)
#define REG_SC_BK0D_53_L      _PK_L_(0x0D, 0x53)
#define REG_SC_BK0D_53_H      _PK_H_(0x0D, 0x53)
#define REG_SC_BK0D_54_L      _PK_L_(0x0D, 0x54)
#define REG_SC_BK0D_54_H      _PK_H_(0x0D, 0x54)
#define REG_SC_BK0D_55_L      _PK_L_(0x0D, 0x55)
#define REG_SC_BK0D_55_H      _PK_H_(0x0D, 0x55)
#define REG_SC_BK0D_56_L      _PK_L_(0x0D, 0x56)
#define REG_SC_BK0D_56_H      _PK_H_(0x0D, 0x56)
#define REG_SC_BK0D_57_L      _PK_L_(0x0D, 0x57)
#define REG_SC_BK0D_57_H      _PK_H_(0x0D, 0x57)
#define REG_SC_BK0D_58_L      _PK_L_(0x0D, 0x58)
#define REG_SC_BK0D_58_H      _PK_H_(0x0D, 0x58)
#define REG_SC_BK0D_59_L      _PK_L_(0x0D, 0x59)
#define REG_SC_BK0D_59_H      _PK_H_(0x0D, 0x59)
#define REG_SC_BK0D_5A_L      _PK_L_(0x0D, 0x5A)
#define REG_SC_BK0D_5A_H      _PK_H_(0x0D, 0x5A)
#define REG_SC_BK0D_5B_L      _PK_L_(0x0D, 0x5B)
#define REG_SC_BK0D_5B_H      _PK_H_(0x0D, 0x5B)
#define REG_SC_BK0D_5C_L      _PK_L_(0x0D, 0x5C)
#define REG_SC_BK0D_5C_H      _PK_H_(0x0D, 0x5C)
#define REG_SC_BK0D_5D_L      _PK_L_(0x0D, 0x5D)
#define REG_SC_BK0D_5D_H      _PK_H_(0x0D, 0x5D)
#define REG_SC_BK0D_5E_L      _PK_L_(0x0D, 0x5E)
#define REG_SC_BK0D_5E_H      _PK_H_(0x0D, 0x5E)
#define REG_SC_BK0D_5F_L      _PK_L_(0x0D, 0x5F)
#define REG_SC_BK0D_5F_H      _PK_H_(0x0D, 0x5F)
#define REG_SC_BK0D_60_L      _PK_L_(0x0D, 0x60)
#define REG_SC_BK0D_60_H      _PK_H_(0x0D, 0x60)
#define REG_SC_BK0D_61_L      _PK_L_(0x0D, 0x61)
#define REG_SC_BK0D_61_H      _PK_H_(0x0D, 0x61)
#define REG_SC_BK0D_62_L      _PK_L_(0x0D, 0x62)
#define REG_SC_BK0D_62_H      _PK_H_(0x0D, 0x62)
#define REG_SC_BK0D_63_L      _PK_L_(0x0D, 0x63)
#define REG_SC_BK0D_63_H      _PK_H_(0x0D, 0x63)
#define REG_SC_BK0D_64_L      _PK_L_(0x0D, 0x64)
#define REG_SC_BK0D_64_H      _PK_H_(0x0D, 0x64)
#define REG_SC_BK0D_65_L      _PK_L_(0x0D, 0x65)
#define REG_SC_BK0D_65_H      _PK_H_(0x0D, 0x65)
#define REG_SC_BK0D_66_L      _PK_L_(0x0D, 0x66)
#define REG_SC_BK0D_66_H      _PK_H_(0x0D, 0x66)
#define REG_SC_BK0D_67_L      _PK_L_(0x0D, 0x67)
#define REG_SC_BK0D_67_H      _PK_H_(0x0D, 0x67)
#define REG_SC_BK0D_68_L      _PK_L_(0x0D, 0x68)
#define REG_SC_BK0D_68_H      _PK_H_(0x0D, 0x68)
#define REG_SC_BK0D_69_L      _PK_L_(0x0D, 0x69)
#define REG_SC_BK0D_69_H      _PK_H_(0x0D, 0x69)
#define REG_SC_BK0D_6A_L      _PK_L_(0x0D, 0x6A)
#define REG_SC_BK0D_6A_H      _PK_H_(0x0D, 0x6A)
#define REG_SC_BK0D_6B_L      _PK_L_(0x0D, 0x6B)
#define REG_SC_BK0D_6B_H      _PK_H_(0x0D, 0x6B)
#define REG_SC_BK0D_6C_L      _PK_L_(0x0D, 0x6C)
#define REG_SC_BK0D_6C_H      _PK_H_(0x0D, 0x6C)
#define REG_SC_BK0D_6D_L      _PK_L_(0x0D, 0x6D)
#define REG_SC_BK0D_6D_H      _PK_H_(0x0D, 0x6D)
#define REG_SC_BK0D_6E_L      _PK_L_(0x0D, 0x6E)
#define REG_SC_BK0D_6E_H      _PK_H_(0x0D, 0x6E)
#define REG_SC_BK0D_6F_L      _PK_L_(0x0D, 0x6F)
#define REG_SC_BK0D_6F_H      _PK_H_(0x0D, 0x6F)
#define REG_SC_BK0D_70_L      _PK_L_(0x0D, 0x70)
#define REG_SC_BK0D_70_H      _PK_H_(0x0D, 0x70)
#define REG_SC_BK0D_71_L      _PK_L_(0x0D, 0x71)
#define REG_SC_BK0D_71_H      _PK_H_(0x0D, 0x71)
#define REG_SC_BK0D_72_L      _PK_L_(0x0D, 0x72)
#define REG_SC_BK0D_72_H      _PK_H_(0x0D, 0x72)
#define REG_SC_BK0D_73_L      _PK_L_(0x0D, 0x73)
#define REG_SC_BK0D_73_H      _PK_H_(0x0D, 0x73)
#define REG_SC_BK0D_74_L      _PK_L_(0x0D, 0x74)
#define REG_SC_BK0D_74_H      _PK_H_(0x0D, 0x74)
#define REG_SC_BK0D_75_L      _PK_L_(0x0D, 0x75)
#define REG_SC_BK0D_75_H      _PK_H_(0x0D, 0x75)
#define REG_SC_BK0D_76_L      _PK_L_(0x0D, 0x76)
#define REG_SC_BK0D_76_H      _PK_H_(0x0D, 0x76)
#define REG_SC_BK0D_77_L      _PK_L_(0x0D, 0x77)
#define REG_SC_BK0D_77_H      _PK_H_(0x0D, 0x77)
#define REG_SC_BK0D_78_L      _PK_L_(0x0D, 0x78)
#define REG_SC_BK0D_78_H      _PK_H_(0x0D, 0x78)
#define REG_SC_BK0D_79_L      _PK_L_(0x0D, 0x79)
#define REG_SC_BK0D_79_H      _PK_H_(0x0D, 0x79)
#define REG_SC_BK0D_7A_L      _PK_L_(0x0D, 0x7A)
#define REG_SC_BK0D_7A_H      _PK_H_(0x0D, 0x7A)
#define REG_SC_BK0D_7B_L      _PK_L_(0x0D, 0x7B)
#define REG_SC_BK0D_7B_H      _PK_H_(0x0D, 0x7B)
#define REG_SC_BK0D_7C_L      _PK_L_(0x0D, 0x7C)
#define REG_SC_BK0D_7C_H      _PK_H_(0x0D, 0x7C)
#define REG_SC_BK0D_7D_L      _PK_L_(0x0D, 0x7D)
#define REG_SC_BK0D_7D_H      _PK_H_(0x0D, 0x7D)
#define REG_SC_BK0D_7E_L      _PK_L_(0x0D, 0x7E)
#define REG_SC_BK0D_7E_H      _PK_H_(0x0D, 0x7E)
#define REG_SC_BK0D_7F_L      _PK_L_(0x0D, 0x7F)
#define REG_SC_BK0D_7F_H      _PK_H_(0x0D, 0x7F)
//----------------------------------------------
#define REG_SC_BK0E_00_L      _PK_L_(0x0E, 0x00)
#define REG_SC_BK0E_00_H      _PK_H_(0x0E, 0x00)
#define REG_SC_BK0E_01_L      _PK_L_(0x0E, 0x01)
#define REG_SC_BK0E_01_H      _PK_H_(0x0E, 0x01)
#define REG_SC_BK0E_02_L      _PK_L_(0x0E, 0x02)
#define REG_SC_BK0E_02_H      _PK_H_(0x0E, 0x02)
#define REG_SC_BK0E_03_L      _PK_L_(0x0E, 0x03)
#define REG_SC_BK0E_03_H      _PK_H_(0x0E, 0x03)
#define REG_SC_BK0E_04_L      _PK_L_(0x0E, 0x04)
#define REG_SC_BK0E_04_H      _PK_H_(0x0E, 0x04)
#define REG_SC_BK0E_05_L      _PK_L_(0x0E, 0x05)
#define REG_SC_BK0E_05_H      _PK_H_(0x0E, 0x05)
#define REG_SC_BK0E_06_L      _PK_L_(0x0E, 0x06)
#define REG_SC_BK0E_06_H      _PK_H_(0x0E, 0x06)
#define REG_SC_BK0E_07_L      _PK_L_(0x0E, 0x07)
#define REG_SC_BK0E_07_H      _PK_H_(0x0E, 0x07)
#define REG_SC_BK0E_08_L      _PK_L_(0x0E, 0x08)
#define REG_SC_BK0E_08_H      _PK_H_(0x0E, 0x08)
#define REG_SC_BK0E_09_L      _PK_L_(0x0E, 0x09)
#define REG_SC_BK0E_09_H      _PK_H_(0x0E, 0x09)
#define REG_SC_BK0E_0A_L      _PK_L_(0x0E, 0x0A)
#define REG_SC_BK0E_0A_H      _PK_H_(0x0E, 0x0A)
#define REG_SC_BK0E_0B_L      _PK_L_(0x0E, 0x0B)
#define REG_SC_BK0E_0B_H      _PK_H_(0x0E, 0x0B)
#define REG_SC_BK0E_0C_L      _PK_L_(0x0E, 0x0C)
#define REG_SC_BK0E_0C_H      _PK_H_(0x0E, 0x0C)
#define REG_SC_BK0E_0D_L      _PK_L_(0x0E, 0x0D)
#define REG_SC_BK0E_0D_H      _PK_H_(0x0E, 0x0D)
#define REG_SC_BK0E_0E_L      _PK_L_(0x0E, 0x0E)
#define REG_SC_BK0E_0E_H      _PK_H_(0x0E, 0x0E)
#define REG_SC_BK0E_0F_L      _PK_L_(0x0E, 0x0F)
#define REG_SC_BK0E_0F_H      _PK_H_(0x0E, 0x0F)
#define REG_SC_BK0E_10_L      _PK_L_(0x0E, 0x10)
#define REG_SC_BK0E_10_H      _PK_H_(0x0E, 0x10)
#define REG_SC_BK0E_11_L      _PK_L_(0x0E, 0x11)
#define REG_SC_BK0E_11_H      _PK_H_(0x0E, 0x11)
#define REG_SC_BK0E_12_L      _PK_L_(0x0E, 0x12)
#define REG_SC_BK0E_12_H      _PK_H_(0x0E, 0x12)
#define REG_SC_BK0E_13_L      _PK_L_(0x0E, 0x13)
#define REG_SC_BK0E_13_H      _PK_H_(0x0E, 0x13)
#define REG_SC_BK0E_14_L      _PK_L_(0x0E, 0x14)
#define REG_SC_BK0E_14_H      _PK_H_(0x0E, 0x14)
#define REG_SC_BK0E_15_L      _PK_L_(0x0E, 0x15)
#define REG_SC_BK0E_15_H      _PK_H_(0x0E, 0x15)
#define REG_SC_BK0E_16_L      _PK_L_(0x0E, 0x16)
#define REG_SC_BK0E_16_H      _PK_H_(0x0E, 0x16)
#define REG_SC_BK0E_17_L      _PK_L_(0x0E, 0x17)
#define REG_SC_BK0E_17_H      _PK_H_(0x0E, 0x17)
#define REG_SC_BK0E_18_L      _PK_L_(0x0E, 0x18)
#define REG_SC_BK0E_18_H      _PK_H_(0x0E, 0x18)
#define REG_SC_BK0E_19_L      _PK_L_(0x0E, 0x19)
#define REG_SC_BK0E_19_H      _PK_H_(0x0E, 0x19)
#define REG_SC_BK0E_1A_L      _PK_L_(0x0E, 0x1A)
#define REG_SC_BK0E_1A_H      _PK_H_(0x0E, 0x1A)
#define REG_SC_BK0E_1B_L      _PK_L_(0x0E, 0x1B)
#define REG_SC_BK0E_1B_H      _PK_H_(0x0E, 0x1B)
#define REG_SC_BK0E_1C_L      _PK_L_(0x0E, 0x1C)
#define REG_SC_BK0E_1C_H      _PK_H_(0x0E, 0x1C)
#define REG_SC_BK0E_1D_L      _PK_L_(0x0E, 0x1D)
#define REG_SC_BK0E_1D_H      _PK_H_(0x0E, 0x1D)
#define REG_SC_BK0E_1E_L      _PK_L_(0x0E, 0x1E)
#define REG_SC_BK0E_1E_H      _PK_H_(0x0E, 0x1E)
#define REG_SC_BK0E_1F_L      _PK_L_(0x0E, 0x1F)
#define REG_SC_BK0E_1F_H      _PK_H_(0x0E, 0x1F)
#define REG_SC_BK0E_20_L      _PK_L_(0x0E, 0x20)
#define REG_SC_BK0E_20_H      _PK_H_(0x0E, 0x20)
#define REG_SC_BK0E_21_L      _PK_L_(0x0E, 0x21)
#define REG_SC_BK0E_21_H      _PK_H_(0x0E, 0x21)
#define REG_SC_BK0E_22_L      _PK_L_(0x0E, 0x22)
#define REG_SC_BK0E_22_H      _PK_H_(0x0E, 0x22)
#define REG_SC_BK0E_23_L      _PK_L_(0x0E, 0x23)
#define REG_SC_BK0E_23_H      _PK_H_(0x0E, 0x23)
#define REG_SC_BK0E_24_L      _PK_L_(0x0E, 0x24)
#define REG_SC_BK0E_24_H      _PK_H_(0x0E, 0x24)
#define REG_SC_BK0E_25_L      _PK_L_(0x0E, 0x25)
#define REG_SC_BK0E_25_H      _PK_H_(0x0E, 0x25)
#define REG_SC_BK0E_26_L      _PK_L_(0x0E, 0x26)
#define REG_SC_BK0E_26_H      _PK_H_(0x0E, 0x26)
#define REG_SC_BK0E_27_L      _PK_L_(0x0E, 0x27)
#define REG_SC_BK0E_27_H      _PK_H_(0x0E, 0x27)
#define REG_SC_BK0E_28_L      _PK_L_(0x0E, 0x28)
#define REG_SC_BK0E_28_H      _PK_H_(0x0E, 0x28)
#define REG_SC_BK0E_29_L      _PK_L_(0x0E, 0x29)
#define REG_SC_BK0E_29_H      _PK_H_(0x0E, 0x29)
#define REG_SC_BK0E_2A_L      _PK_L_(0x0E, 0x2A)
#define REG_SC_BK0E_2A_H      _PK_H_(0x0E, 0x2A)
#define REG_SC_BK0E_2B_L      _PK_L_(0x0E, 0x2B)
#define REG_SC_BK0E_2B_H      _PK_H_(0x0E, 0x2B)
#define REG_SC_BK0E_2C_L      _PK_L_(0x0E, 0x2C)
#define REG_SC_BK0E_2C_H      _PK_H_(0x0E, 0x2C)
#define REG_SC_BK0E_2D_L      _PK_L_(0x0E, 0x2D)
#define REG_SC_BK0E_2D_H      _PK_H_(0x0E, 0x2D)
#define REG_SC_BK0E_2E_L      _PK_L_(0x0E, 0x2E)
#define REG_SC_BK0E_2E_H      _PK_H_(0x0E, 0x2E)
#define REG_SC_BK0E_2F_L      _PK_L_(0x0E, 0x2F)
#define REG_SC_BK0E_2F_H      _PK_H_(0x0E, 0x2F)
#define REG_SC_BK0E_30_L      _PK_L_(0x0E, 0x30)
#define REG_SC_BK0E_30_H      _PK_H_(0x0E, 0x30)
#define REG_SC_BK0E_31_L      _PK_L_(0x0E, 0x31)
#define REG_SC_BK0E_31_H      _PK_H_(0x0E, 0x31)
#define REG_SC_BK0E_32_L      _PK_L_(0x0E, 0x32)
#define REG_SC_BK0E_32_H      _PK_H_(0x0E, 0x32)
#define REG_SC_BK0E_33_L      _PK_L_(0x0E, 0x33)
#define REG_SC_BK0E_33_H      _PK_H_(0x0E, 0x33)
#define REG_SC_BK0E_34_L      _PK_L_(0x0E, 0x34)
#define REG_SC_BK0E_34_H      _PK_H_(0x0E, 0x34)
#define REG_SC_BK0E_35_L      _PK_L_(0x0E, 0x35)
#define REG_SC_BK0E_35_H      _PK_H_(0x0E, 0x35)
#define REG_SC_BK0E_36_L      _PK_L_(0x0E, 0x36)
#define REG_SC_BK0E_36_H      _PK_H_(0x0E, 0x36)
#define REG_SC_BK0E_37_L      _PK_L_(0x0E, 0x37)
#define REG_SC_BK0E_37_H      _PK_H_(0x0E, 0x37)
#define REG_SC_BK0E_38_L      _PK_L_(0x0E, 0x38)
#define REG_SC_BK0E_38_H      _PK_H_(0x0E, 0x38)
#define REG_SC_BK0E_39_L      _PK_L_(0x0E, 0x39)
#define REG_SC_BK0E_39_H      _PK_H_(0x0E, 0x39)
#define REG_SC_BK0E_3A_L      _PK_L_(0x0E, 0x3A)
#define REG_SC_BK0E_3A_H      _PK_H_(0x0E, 0x3A)
#define REG_SC_BK0E_3B_L      _PK_L_(0x0E, 0x3B)
#define REG_SC_BK0E_3B_H      _PK_H_(0x0E, 0x3B)
#define REG_SC_BK0E_3C_L      _PK_L_(0x0E, 0x3C)
#define REG_SC_BK0E_3C_H      _PK_H_(0x0E, 0x3C)
#define REG_SC_BK0E_3D_L      _PK_L_(0x0E, 0x3D)
#define REG_SC_BK0E_3D_H      _PK_H_(0x0E, 0x3D)
#define REG_SC_BK0E_3E_L      _PK_L_(0x0E, 0x3E)
#define REG_SC_BK0E_3E_H      _PK_H_(0x0E, 0x3E)
#define REG_SC_BK0E_3F_L      _PK_L_(0x0E, 0x3F)
#define REG_SC_BK0E_3F_H      _PK_H_(0x0E, 0x3F)
#define REG_SC_BK0E_40_L      _PK_L_(0x0E, 0x40)
#define REG_SC_BK0E_40_H      _PK_H_(0x0E, 0x40)
#define REG_SC_BK0E_41_L      _PK_L_(0x0E, 0x41)
#define REG_SC_BK0E_41_H      _PK_H_(0x0E, 0x41)
#define REG_SC_BK0E_42_L      _PK_L_(0x0E, 0x42)
#define REG_SC_BK0E_42_H      _PK_H_(0x0E, 0x42)
#define REG_SC_BK0E_43_L      _PK_L_(0x0E, 0x43)
#define REG_SC_BK0E_43_H      _PK_H_(0x0E, 0x43)
#define REG_SC_BK0E_44_L      _PK_L_(0x0E, 0x44)
#define REG_SC_BK0E_44_H      _PK_H_(0x0E, 0x44)
#define REG_SC_BK0E_45_L      _PK_L_(0x0E, 0x45)
#define REG_SC_BK0E_45_H      _PK_H_(0x0E, 0x45)
#define REG_SC_BK0E_46_L      _PK_L_(0x0E, 0x46)
#define REG_SC_BK0E_46_H      _PK_H_(0x0E, 0x46)
#define REG_SC_BK0E_47_L      _PK_L_(0x0E, 0x47)
#define REG_SC_BK0E_47_H      _PK_H_(0x0E, 0x47)
#define REG_SC_BK0E_48_L      _PK_L_(0x0E, 0x48)
#define REG_SC_BK0E_48_H      _PK_H_(0x0E, 0x48)
#define REG_SC_BK0E_49_L      _PK_L_(0x0E, 0x49)
#define REG_SC_BK0E_49_H      _PK_H_(0x0E, 0x49)
#define REG_SC_BK0E_4A_L      _PK_L_(0x0E, 0x4A)
#define REG_SC_BK0E_4A_H      _PK_H_(0x0E, 0x4A)
#define REG_SC_BK0E_4B_L      _PK_L_(0x0E, 0x4B)
#define REG_SC_BK0E_4B_H      _PK_H_(0x0E, 0x4B)
#define REG_SC_BK0E_4C_L      _PK_L_(0x0E, 0x4C)
#define REG_SC_BK0E_4C_H      _PK_H_(0x0E, 0x4C)
#define REG_SC_BK0E_4D_L      _PK_L_(0x0E, 0x4D)
#define REG_SC_BK0E_4D_H      _PK_H_(0x0E, 0x4D)
#define REG_SC_BK0E_4E_L      _PK_L_(0x0E, 0x4E)
#define REG_SC_BK0E_4E_H      _PK_H_(0x0E, 0x4E)
#define REG_SC_BK0E_4F_L      _PK_L_(0x0E, 0x4F)
#define REG_SC_BK0E_4F_H      _PK_H_(0x0E, 0x4F)
#define REG_SC_BK0E_50_L      _PK_L_(0x0E, 0x50)
#define REG_SC_BK0E_50_H      _PK_H_(0x0E, 0x50)
#define REG_SC_BK0E_51_L      _PK_L_(0x0E, 0x51)
#define REG_SC_BK0E_51_H      _PK_H_(0x0E, 0x51)
#define REG_SC_BK0E_52_L      _PK_L_(0x0E, 0x52)
#define REG_SC_BK0E_52_H      _PK_H_(0x0E, 0x52)
#define REG_SC_BK0E_53_L      _PK_L_(0x0E, 0x53)
#define REG_SC_BK0E_53_H      _PK_H_(0x0E, 0x53)
#define REG_SC_BK0E_54_L      _PK_L_(0x0E, 0x54)
#define REG_SC_BK0E_54_H      _PK_H_(0x0E, 0x54)
#define REG_SC_BK0E_55_L      _PK_L_(0x0E, 0x55)
#define REG_SC_BK0E_55_H      _PK_H_(0x0E, 0x55)
#define REG_SC_BK0E_56_L      _PK_L_(0x0E, 0x56)
#define REG_SC_BK0E_56_H      _PK_H_(0x0E, 0x56)
#define REG_SC_BK0E_57_L      _PK_L_(0x0E, 0x57)
#define REG_SC_BK0E_57_H      _PK_H_(0x0E, 0x57)
#define REG_SC_BK0E_58_L      _PK_L_(0x0E, 0x58)
#define REG_SC_BK0E_58_H      _PK_H_(0x0E, 0x58)
#define REG_SC_BK0E_59_L      _PK_L_(0x0E, 0x59)
#define REG_SC_BK0E_59_H      _PK_H_(0x0E, 0x59)
#define REG_SC_BK0E_5A_L      _PK_L_(0x0E, 0x5A)
#define REG_SC_BK0E_5A_H      _PK_H_(0x0E, 0x5A)
#define REG_SC_BK0E_5B_L      _PK_L_(0x0E, 0x5B)
#define REG_SC_BK0E_5B_H      _PK_H_(0x0E, 0x5B)
#define REG_SC_BK0E_5C_L      _PK_L_(0x0E, 0x5C)
#define REG_SC_BK0E_5C_H      _PK_H_(0x0E, 0x5C)
#define REG_SC_BK0E_5D_L      _PK_L_(0x0E, 0x5D)
#define REG_SC_BK0E_5D_H      _PK_H_(0x0E, 0x5D)
#define REG_SC_BK0E_5E_L      _PK_L_(0x0E, 0x5E)
#define REG_SC_BK0E_5E_H      _PK_H_(0x0E, 0x5E)
#define REG_SC_BK0E_5F_L      _PK_L_(0x0E, 0x5F)
#define REG_SC_BK0E_5F_H      _PK_H_(0x0E, 0x5F)
#define REG_SC_BK0E_60_L      _PK_L_(0x0E, 0x60)
#define REG_SC_BK0E_60_H      _PK_H_(0x0E, 0x60)
#define REG_SC_BK0E_61_L      _PK_L_(0x0E, 0x61)
#define REG_SC_BK0E_61_H      _PK_H_(0x0E, 0x61)
#define REG_SC_BK0E_62_L      _PK_L_(0x0E, 0x62)
#define REG_SC_BK0E_62_H      _PK_H_(0x0E, 0x62)
#define REG_SC_BK0E_63_L      _PK_L_(0x0E, 0x63)
#define REG_SC_BK0E_63_H      _PK_H_(0x0E, 0x63)
#define REG_SC_BK0E_64_L      _PK_L_(0x0E, 0x64)
#define REG_SC_BK0E_64_H      _PK_H_(0x0E, 0x64)
#define REG_SC_BK0E_65_L      _PK_L_(0x0E, 0x65)
#define REG_SC_BK0E_65_H      _PK_H_(0x0E, 0x65)
#define REG_SC_BK0E_66_L      _PK_L_(0x0E, 0x66)
#define REG_SC_BK0E_66_H      _PK_H_(0x0E, 0x66)
#define REG_SC_BK0E_67_L      _PK_L_(0x0E, 0x67)
#define REG_SC_BK0E_67_H      _PK_H_(0x0E, 0x67)
#define REG_SC_BK0E_68_L      _PK_L_(0x0E, 0x68)
#define REG_SC_BK0E_68_H      _PK_H_(0x0E, 0x68)
#define REG_SC_BK0E_69_L      _PK_L_(0x0E, 0x69)
#define REG_SC_BK0E_69_H      _PK_H_(0x0E, 0x69)
#define REG_SC_BK0E_6A_L      _PK_L_(0x0E, 0x6A)
#define REG_SC_BK0E_6A_H      _PK_H_(0x0E, 0x6A)
#define REG_SC_BK0E_6B_L      _PK_L_(0x0E, 0x6B)
#define REG_SC_BK0E_6B_H      _PK_H_(0x0E, 0x6B)
#define REG_SC_BK0E_6C_L      _PK_L_(0x0E, 0x6C)
#define REG_SC_BK0E_6C_H      _PK_H_(0x0E, 0x6C)
#define REG_SC_BK0E_6D_L      _PK_L_(0x0E, 0x6D)
#define REG_SC_BK0E_6D_H      _PK_H_(0x0E, 0x6D)
#define REG_SC_BK0E_6E_L      _PK_L_(0x0E, 0x6E)
#define REG_SC_BK0E_6E_H      _PK_H_(0x0E, 0x6E)
#define REG_SC_BK0E_6F_L      _PK_L_(0x0E, 0x6F)
#define REG_SC_BK0E_6F_H      _PK_H_(0x0E, 0x6F)
#define REG_SC_BK0E_70_L      _PK_L_(0x0E, 0x70)
#define REG_SC_BK0E_70_H      _PK_H_(0x0E, 0x70)
#define REG_SC_BK0E_71_L      _PK_L_(0x0E, 0x71)
#define REG_SC_BK0E_71_H      _PK_H_(0x0E, 0x71)
#define REG_SC_BK0E_72_L      _PK_L_(0x0E, 0x72)
#define REG_SC_BK0E_72_H      _PK_H_(0x0E, 0x72)
#define REG_SC_BK0E_73_L      _PK_L_(0x0E, 0x73)
#define REG_SC_BK0E_73_H      _PK_H_(0x0E, 0x73)
#define REG_SC_BK0E_74_L      _PK_L_(0x0E, 0x74)
#define REG_SC_BK0E_74_H      _PK_H_(0x0E, 0x74)
#define REG_SC_BK0E_75_L      _PK_L_(0x0E, 0x75)
#define REG_SC_BK0E_75_H      _PK_H_(0x0E, 0x75)
#define REG_SC_BK0E_76_L      _PK_L_(0x0E, 0x76)
#define REG_SC_BK0E_76_H      _PK_H_(0x0E, 0x76)
#define REG_SC_BK0E_77_L      _PK_L_(0x0E, 0x77)
#define REG_SC_BK0E_77_H      _PK_H_(0x0E, 0x77)
#define REG_SC_BK0E_78_L      _PK_L_(0x0E, 0x78)
#define REG_SC_BK0E_78_H      _PK_H_(0x0E, 0x78)
#define REG_SC_BK0E_79_L      _PK_L_(0x0E, 0x79)
#define REG_SC_BK0E_79_H      _PK_H_(0x0E, 0x79)
#define REG_SC_BK0E_7A_L      _PK_L_(0x0E, 0x7A)
#define REG_SC_BK0E_7A_H      _PK_H_(0x0E, 0x7A)
#define REG_SC_BK0E_7B_L      _PK_L_(0x0E, 0x7B)
#define REG_SC_BK0E_7B_H      _PK_H_(0x0E, 0x7B)
#define REG_SC_BK0E_7C_L      _PK_L_(0x0E, 0x7C)
#define REG_SC_BK0E_7C_H      _PK_H_(0x0E, 0x7C)
#define REG_SC_BK0E_7D_L      _PK_L_(0x0E, 0x7D)
#define REG_SC_BK0E_7D_H      _PK_H_(0x0E, 0x7D)
#define REG_SC_BK0E_7E_L      _PK_L_(0x0E, 0x7E)
#define REG_SC_BK0E_7E_H      _PK_H_(0x0E, 0x7E)
#define REG_SC_BK0E_7F_L      _PK_L_(0x0E, 0x7F)
#define REG_SC_BK0E_7F_H      _PK_H_(0x0E, 0x7F)
//----------------------------------------------
#define REG_SC_BK0F_00_L      _PK_L_(0x0F, 0x00)
#define REG_SC_BK0F_00_H      _PK_H_(0x0F, 0x00)
#define REG_SC_BK0F_01_L      _PK_L_(0x0F, 0x01)
#define REG_SC_BK0F_01_H      _PK_H_(0x0F, 0x01)
#define REG_SC_BK0F_02_L      _PK_L_(0x0F, 0x02)
#define REG_SC_BK0F_02_H      _PK_H_(0x0F, 0x02)
#define REG_SC_BK0F_03_L      _PK_L_(0x0F, 0x03)
#define REG_SC_BK0F_03_H      _PK_H_(0x0F, 0x03)
#define REG_SC_BK0F_04_L      _PK_L_(0x0F, 0x04)
#define REG_SC_BK0F_04_H      _PK_H_(0x0F, 0x04)
#define REG_SC_BK0F_05_L      _PK_L_(0x0F, 0x05)
#define REG_SC_BK0F_05_H      _PK_H_(0x0F, 0x05)
#define REG_SC_BK0F_06_L      _PK_L_(0x0F, 0x06)
#define REG_SC_BK0F_06_H      _PK_H_(0x0F, 0x06)
#define REG_SC_BK0F_07_L      _PK_L_(0x0F, 0x07)
#define REG_SC_BK0F_07_H      _PK_H_(0x0F, 0x07)
#define REG_SC_BK0F_08_L      _PK_L_(0x0F, 0x08)
#define REG_SC_BK0F_08_H      _PK_H_(0x0F, 0x08)
#define REG_SC_BK0F_09_L      _PK_L_(0x0F, 0x09)
#define REG_SC_BK0F_09_H      _PK_H_(0x0F, 0x09)
#define REG_SC_BK0F_0A_L      _PK_L_(0x0F, 0x0A)
#define REG_SC_BK0F_0A_H      _PK_H_(0x0F, 0x0A)
#define REG_SC_BK0F_0B_L      _PK_L_(0x0F, 0x0B)
#define REG_SC_BK0F_0B_H      _PK_H_(0x0F, 0x0B)
#define REG_SC_BK0F_0C_L      _PK_L_(0x0F, 0x0C)
#define REG_SC_BK0F_0C_H      _PK_H_(0x0F, 0x0C)
#define REG_SC_BK0F_0D_L      _PK_L_(0x0F, 0x0D)
#define REG_SC_BK0F_0D_H      _PK_H_(0x0F, 0x0D)
#define REG_SC_BK0F_0E_L      _PK_L_(0x0F, 0x0E)
#define REG_SC_BK0F_0E_H      _PK_H_(0x0F, 0x0E)
#define REG_SC_BK0F_0F_L      _PK_L_(0x0F, 0x0F)
#define REG_SC_BK0F_0F_H      _PK_H_(0x0F, 0x0F)
#define REG_SC_BK0F_10_L      _PK_L_(0x0F, 0x10)
#define REG_SC_BK0F_10_H      _PK_H_(0x0F, 0x10)
#define REG_SC_BK0F_11_L      _PK_L_(0x0F, 0x11)
#define REG_SC_BK0F_11_H      _PK_H_(0x0F, 0x11)
#define REG_SC_BK0F_12_L      _PK_L_(0x0F, 0x12)
#define REG_SC_BK0F_12_H      _PK_H_(0x0F, 0x12)
#define REG_SC_BK0F_13_L      _PK_L_(0x0F, 0x13)
#define REG_SC_BK0F_13_H      _PK_H_(0x0F, 0x13)
#define REG_SC_BK0F_14_L      _PK_L_(0x0F, 0x14)
#define REG_SC_BK0F_14_H      _PK_H_(0x0F, 0x14)
#define REG_SC_BK0F_15_L      _PK_L_(0x0F, 0x15)
#define REG_SC_BK0F_15_H      _PK_H_(0x0F, 0x15)
#define REG_SC_BK0F_16_L      _PK_L_(0x0F, 0x16)
#define REG_SC_BK0F_16_H      _PK_H_(0x0F, 0x16)
#define REG_SC_BK0F_17_L      _PK_L_(0x0F, 0x17)
#define REG_SC_BK0F_17_H      _PK_H_(0x0F, 0x17)
#define REG_SC_BK0F_18_L      _PK_L_(0x0F, 0x18)
#define REG_SC_BK0F_18_H      _PK_H_(0x0F, 0x18)
#define REG_SC_BK0F_19_L      _PK_L_(0x0F, 0x19)
#define REG_SC_BK0F_19_H      _PK_H_(0x0F, 0x19)
#define REG_SC_BK0F_1A_L      _PK_L_(0x0F, 0x1A)
#define REG_SC_BK0F_1A_H      _PK_H_(0x0F, 0x1A)
#define REG_SC_BK0F_1B_L      _PK_L_(0x0F, 0x1B)
#define REG_SC_BK0F_1B_H      _PK_H_(0x0F, 0x1B)
#define REG_SC_BK0F_1C_L      _PK_L_(0x0F, 0x1C)
#define REG_SC_BK0F_1C_H      _PK_H_(0x0F, 0x1C)
#define REG_SC_BK0F_1D_L      _PK_L_(0x0F, 0x1D)
#define REG_SC_BK0F_1D_H      _PK_H_(0x0F, 0x1D)
#define REG_SC_BK0F_1E_L      _PK_L_(0x0F, 0x1E)
#define REG_SC_BK0F_1E_H      _PK_H_(0x0F, 0x1E)
#define REG_SC_BK0F_1F_L      _PK_L_(0x0F, 0x1F)
#define REG_SC_BK0F_1F_H      _PK_H_(0x0F, 0x1F)
#define REG_SC_BK0F_20_L      _PK_L_(0x0F, 0x20)
#define REG_SC_BK0F_20_H      _PK_H_(0x0F, 0x20)
#define REG_SC_BK0F_21_L      _PK_L_(0x0F, 0x21)
#define REG_SC_BK0F_21_H      _PK_H_(0x0F, 0x21)
#define REG_SC_BK0F_22_L      _PK_L_(0x0F, 0x22)
#define REG_SC_BK0F_22_H      _PK_H_(0x0F, 0x22)
#define REG_SC_BK0F_23_L      _PK_L_(0x0F, 0x23)
#define REG_SC_BK0F_23_H      _PK_H_(0x0F, 0x23)
#define REG_SC_BK0F_24_L      _PK_L_(0x0F, 0x24)
#define REG_SC_BK0F_24_H      _PK_H_(0x0F, 0x24)
#define REG_SC_BK0F_25_L      _PK_L_(0x0F, 0x25)
#define REG_SC_BK0F_25_H      _PK_H_(0x0F, 0x25)
#define REG_SC_BK0F_26_L      _PK_L_(0x0F, 0x26)
#define REG_SC_BK0F_26_H      _PK_H_(0x0F, 0x26)
#define REG_SC_BK0F_27_L      _PK_L_(0x0F, 0x27)
#define REG_SC_BK0F_27_H      _PK_H_(0x0F, 0x27)
#define REG_SC_BK0F_28_L      _PK_L_(0x0F, 0x28)
#define REG_SC_BK0F_28_H      _PK_H_(0x0F, 0x28)
#define REG_SC_BK0F_29_L      _PK_L_(0x0F, 0x29)
#define REG_SC_BK0F_29_H      _PK_H_(0x0F, 0x29)
#define REG_SC_BK0F_2A_L      _PK_L_(0x0F, 0x2A)
#define REG_SC_BK0F_2A_H      _PK_H_(0x0F, 0x2A)
#define REG_SC_BK0F_2B_L      _PK_L_(0x0F, 0x2B)
#define REG_SC_BK0F_2B_H      _PK_H_(0x0F, 0x2B)
#define REG_SC_BK0F_2C_L      _PK_L_(0x0F, 0x2C)
#define REG_SC_BK0F_2C_H      _PK_H_(0x0F, 0x2C)
#define REG_SC_BK0F_2D_L      _PK_L_(0x0F, 0x2D)
#define REG_SC_BK0F_2D_H      _PK_H_(0x0F, 0x2D)
#define REG_SC_BK0F_2E_L      _PK_L_(0x0F, 0x2E)
#define REG_SC_BK0F_2E_H      _PK_H_(0x0F, 0x2E)
#define REG_SC_BK0F_2F_L      _PK_L_(0x0F, 0x2F)
#define REG_SC_BK0F_2F_H      _PK_H_(0x0F, 0x2F)
#define REG_SC_BK0F_30_L      _PK_L_(0x0F, 0x30)
#define REG_SC_BK0F_30_H      _PK_H_(0x0F, 0x30)
#define REG_SC_BK0F_31_L      _PK_L_(0x0F, 0x31)
#define REG_SC_BK0F_31_H      _PK_H_(0x0F, 0x31)
#define REG_SC_BK0F_32_L      _PK_L_(0x0F, 0x32)
#define REG_SC_BK0F_32_H      _PK_H_(0x0F, 0x32)
#define REG_SC_BK0F_33_L      _PK_L_(0x0F, 0x33)
#define REG_SC_BK0F_33_H      _PK_H_(0x0F, 0x33)
#define REG_SC_BK0F_34_L      _PK_L_(0x0F, 0x34)
#define REG_SC_BK0F_34_H      _PK_H_(0x0F, 0x34)
#define REG_SC_BK0F_35_L      _PK_L_(0x0F, 0x35)
#define REG_SC_BK0F_35_H      _PK_H_(0x0F, 0x35)
#define REG_SC_BK0F_36_L      _PK_L_(0x0F, 0x36)
#define REG_SC_BK0F_36_H      _PK_H_(0x0F, 0x36)
#define REG_SC_BK0F_37_L      _PK_L_(0x0F, 0x37)
#define REG_SC_BK0F_37_H      _PK_H_(0x0F, 0x37)
#define REG_SC_BK0F_38_L      _PK_L_(0x0F, 0x38)
#define REG_SC_BK0F_38_H      _PK_H_(0x0F, 0x38)
#define REG_SC_BK0F_39_L      _PK_L_(0x0F, 0x39)
#define REG_SC_BK0F_39_H      _PK_H_(0x0F, 0x39)
#define REG_SC_BK0F_3A_L      _PK_L_(0x0F, 0x3A)
#define REG_SC_BK0F_3A_H      _PK_H_(0x0F, 0x3A)
#define REG_SC_BK0F_3B_L      _PK_L_(0x0F, 0x3B)
#define REG_SC_BK0F_3B_H      _PK_H_(0x0F, 0x3B)
#define REG_SC_BK0F_3C_L      _PK_L_(0x0F, 0x3C)
#define REG_SC_BK0F_3C_H      _PK_H_(0x0F, 0x3C)
#define REG_SC_BK0F_3D_L      _PK_L_(0x0F, 0x3D)
#define REG_SC_BK0F_3D_H      _PK_H_(0x0F, 0x3D)
#define REG_SC_BK0F_3E_L      _PK_L_(0x0F, 0x3E)
#define REG_SC_BK0F_3E_H      _PK_H_(0x0F, 0x3E)
#define REG_SC_BK0F_3F_L      _PK_L_(0x0F, 0x3F)
#define REG_SC_BK0F_3F_H      _PK_H_(0x0F, 0x3F)
#define REG_SC_BK0F_40_L      _PK_L_(0x0F, 0x40)
#define REG_SC_BK0F_40_H      _PK_H_(0x0F, 0x40)
#define REG_SC_BK0F_41_L      _PK_L_(0x0F, 0x41)
#define REG_SC_BK0F_41_H      _PK_H_(0x0F, 0x41)
#define REG_SC_BK0F_42_L      _PK_L_(0x0F, 0x42)
#define REG_SC_BK0F_42_H      _PK_H_(0x0F, 0x42)
#define REG_SC_BK0F_43_L      _PK_L_(0x0F, 0x43)
#define REG_SC_BK0F_43_H      _PK_H_(0x0F, 0x43)
#define REG_SC_BK0F_44_L      _PK_L_(0x0F, 0x44)
#define REG_SC_BK0F_44_H      _PK_H_(0x0F, 0x44)
#define REG_SC_BK0F_45_L      _PK_L_(0x0F, 0x45)
#define REG_SC_BK0F_45_H      _PK_H_(0x0F, 0x45)
#define REG_SC_BK0F_46_L      _PK_L_(0x0F, 0x46)
#define REG_SC_BK0F_46_H      _PK_H_(0x0F, 0x46)
#define REG_SC_BK0F_47_L      _PK_L_(0x0F, 0x47)
#define REG_SC_BK0F_47_H      _PK_H_(0x0F, 0x47)
#define REG_SC_BK0F_48_L      _PK_L_(0x0F, 0x48)
#define REG_SC_BK0F_48_H      _PK_H_(0x0F, 0x48)
#define REG_SC_BK0F_49_L      _PK_L_(0x0F, 0x49)
#define REG_SC_BK0F_49_H      _PK_H_(0x0F, 0x49)
#define REG_SC_BK0F_4A_L      _PK_L_(0x0F, 0x4A)
#define REG_SC_BK0F_4A_H      _PK_H_(0x0F, 0x4A)
#define REG_SC_BK0F_4B_L      _PK_L_(0x0F, 0x4B)
#define REG_SC_BK0F_4B_H      _PK_H_(0x0F, 0x4B)
#define REG_SC_BK0F_4C_L      _PK_L_(0x0F, 0x4C)
#define REG_SC_BK0F_4C_H      _PK_H_(0x0F, 0x4C)
#define REG_SC_BK0F_4D_L      _PK_L_(0x0F, 0x4D)
#define REG_SC_BK0F_4D_H      _PK_H_(0x0F, 0x4D)
#define REG_SC_BK0F_4E_L      _PK_L_(0x0F, 0x4E)
#define REG_SC_BK0F_4E_H      _PK_H_(0x0F, 0x4E)
#define REG_SC_BK0F_4F_L      _PK_L_(0x0F, 0x4F)
#define REG_SC_BK0F_4F_H      _PK_H_(0x0F, 0x4F)
#define REG_SC_BK0F_50_L      _PK_L_(0x0F, 0x50)
#define REG_SC_BK0F_50_H      _PK_H_(0x0F, 0x50)
#define REG_SC_BK0F_51_L      _PK_L_(0x0F, 0x51)
#define REG_SC_BK0F_51_H      _PK_H_(0x0F, 0x51)
#define REG_SC_BK0F_52_L      _PK_L_(0x0F, 0x52)
#define REG_SC_BK0F_52_H      _PK_H_(0x0F, 0x52)
#define REG_SC_BK0F_53_L      _PK_L_(0x0F, 0x53)
#define REG_SC_BK0F_53_H      _PK_H_(0x0F, 0x53)
#define REG_SC_BK0F_54_L      _PK_L_(0x0F, 0x54)
#define REG_SC_BK0F_54_H      _PK_H_(0x0F, 0x54)
#define REG_SC_BK0F_55_L      _PK_L_(0x0F, 0x55)
#define REG_SC_BK0F_55_H      _PK_H_(0x0F, 0x55)
#define REG_SC_BK0F_56_L      _PK_L_(0x0F, 0x56)
#define REG_SC_BK0F_56_H      _PK_H_(0x0F, 0x56)
#define REG_SC_BK0F_57_L      _PK_L_(0x0F, 0x57)
#define REG_SC_BK0F_57_H      _PK_H_(0x0F, 0x57)
#define REG_SC_BK0F_58_L      _PK_L_(0x0F, 0x58)
#define REG_SC_BK0F_58_H      _PK_H_(0x0F, 0x58)
#define REG_SC_BK0F_59_L      _PK_L_(0x0F, 0x59)
#define REG_SC_BK0F_59_H      _PK_H_(0x0F, 0x59)
#define REG_SC_BK0F_5A_L      _PK_L_(0x0F, 0x5A)
#define REG_SC_BK0F_5A_H      _PK_H_(0x0F, 0x5A)
#define REG_SC_BK0F_5B_L      _PK_L_(0x0F, 0x5B)
#define REG_SC_BK0F_5B_H      _PK_H_(0x0F, 0x5B)
#define REG_SC_BK0F_5C_L      _PK_L_(0x0F, 0x5C)
#define REG_SC_BK0F_5C_H      _PK_H_(0x0F, 0x5C)
#define REG_SC_BK0F_5D_L      _PK_L_(0x0F, 0x5D)
#define REG_SC_BK0F_5D_H      _PK_H_(0x0F, 0x5D)
#define REG_SC_BK0F_5E_L      _PK_L_(0x0F, 0x5E)
#define REG_SC_BK0F_5E_H      _PK_H_(0x0F, 0x5E)
#define REG_SC_BK0F_5F_L      _PK_L_(0x0F, 0x5F)
#define REG_SC_BK0F_5F_H      _PK_H_(0x0F, 0x5F)
#define REG_SC_BK0F_60_L      _PK_L_(0x0F, 0x60)
#define REG_SC_BK0F_60_H      _PK_H_(0x0F, 0x60)
#define REG_SC_BK0F_61_L      _PK_L_(0x0F, 0x61)
#define REG_SC_BK0F_61_H      _PK_H_(0x0F, 0x61)
#define REG_SC_BK0F_62_L      _PK_L_(0x0F, 0x62)
#define REG_SC_BK0F_62_H      _PK_H_(0x0F, 0x62)
#define REG_SC_BK0F_63_L      _PK_L_(0x0F, 0x63)
#define REG_SC_BK0F_63_H      _PK_H_(0x0F, 0x63)
#define REG_SC_BK0F_64_L      _PK_L_(0x0F, 0x64)
#define REG_SC_BK0F_64_H      _PK_H_(0x0F, 0x64)
#define REG_SC_BK0F_65_L      _PK_L_(0x0F, 0x65)
#define REG_SC_BK0F_65_H      _PK_H_(0x0F, 0x65)
#define REG_SC_BK0F_66_L      _PK_L_(0x0F, 0x66)
#define REG_SC_BK0F_66_H      _PK_H_(0x0F, 0x66)
#define REG_SC_BK0F_67_L      _PK_L_(0x0F, 0x67)
#define REG_SC_BK0F_67_H      _PK_H_(0x0F, 0x67)
#define REG_SC_BK0F_68_L      _PK_L_(0x0F, 0x68)
#define REG_SC_BK0F_68_H      _PK_H_(0x0F, 0x68)
#define REG_SC_BK0F_69_L      _PK_L_(0x0F, 0x69)
#define REG_SC_BK0F_69_H      _PK_H_(0x0F, 0x69)
#define REG_SC_BK0F_6A_L      _PK_L_(0x0F, 0x6A)
#define REG_SC_BK0F_6A_H      _PK_H_(0x0F, 0x6A)
#define REG_SC_BK0F_6B_L      _PK_L_(0x0F, 0x6B)
#define REG_SC_BK0F_6B_H      _PK_H_(0x0F, 0x6B)
#define REG_SC_BK0F_6C_L      _PK_L_(0x0F, 0x6C)
#define REG_SC_BK0F_6C_H      _PK_H_(0x0F, 0x6C)
#define REG_SC_BK0F_6D_L      _PK_L_(0x0F, 0x6D)
#define REG_SC_BK0F_6D_H      _PK_H_(0x0F, 0x6D)
#define REG_SC_BK0F_6E_L      _PK_L_(0x0F, 0x6E)
#define REG_SC_BK0F_6E_H      _PK_H_(0x0F, 0x6E)
#define REG_SC_BK0F_6F_L      _PK_L_(0x0F, 0x6F)
#define REG_SC_BK0F_6F_H      _PK_H_(0x0F, 0x6F)
#define REG_SC_BK0F_70_L      _PK_L_(0x0F, 0x70)
#define REG_SC_BK0F_70_H      _PK_H_(0x0F, 0x70)
#define REG_SC_BK0F_71_L      _PK_L_(0x0F, 0x71)
#define REG_SC_BK0F_71_H      _PK_H_(0x0F, 0x71)
#define REG_SC_BK0F_72_L      _PK_L_(0x0F, 0x72)
#define REG_SC_BK0F_72_H      _PK_H_(0x0F, 0x72)
#define REG_SC_BK0F_73_L      _PK_L_(0x0F, 0x73)
#define REG_SC_BK0F_73_H      _PK_H_(0x0F, 0x73)
#define REG_SC_BK0F_74_L      _PK_L_(0x0F, 0x74)
#define REG_SC_BK0F_74_H      _PK_H_(0x0F, 0x74)
#define REG_SC_BK0F_75_L      _PK_L_(0x0F, 0x75)
#define REG_SC_BK0F_75_H      _PK_H_(0x0F, 0x75)
#define REG_SC_BK0F_76_L      _PK_L_(0x0F, 0x76)
#define REG_SC_BK0F_76_H      _PK_H_(0x0F, 0x76)
#define REG_SC_BK0F_77_L      _PK_L_(0x0F, 0x77)
#define REG_SC_BK0F_77_H      _PK_H_(0x0F, 0x77)
#define REG_SC_BK0F_78_L      _PK_L_(0x0F, 0x78)
#define REG_SC_BK0F_78_H      _PK_H_(0x0F, 0x78)
#define REG_SC_BK0F_79_L      _PK_L_(0x0F, 0x79)
#define REG_SC_BK0F_79_H      _PK_H_(0x0F, 0x79)
#define REG_SC_BK0F_7A_L      _PK_L_(0x0F, 0x7A)
#define REG_SC_BK0F_7A_H      _PK_H_(0x0F, 0x7A)
#define REG_SC_BK0F_7B_L      _PK_L_(0x0F, 0x7B)
#define REG_SC_BK0F_7B_H      _PK_H_(0x0F, 0x7B)
#define REG_SC_BK0F_7C_L      _PK_L_(0x0F, 0x7C)
#define REG_SC_BK0F_7C_H      _PK_H_(0x0F, 0x7C)
#define REG_SC_BK0F_7D_L      _PK_L_(0x0F, 0x7D)
#define REG_SC_BK0F_7D_H      _PK_H_(0x0F, 0x7D)
#define REG_SC_BK0F_7E_L      _PK_L_(0x0F, 0x7E)
#define REG_SC_BK0F_7E_H      _PK_H_(0x0F, 0x7E)
#define REG_SC_BK0F_7F_L      _PK_L_(0x0F, 0x7F)
#define REG_SC_BK0F_7F_H      _PK_H_(0x0F, 0x7F)
//----------------------------------------------
#define REG_SC_BK10_00_L      _PK_L_(0x10, 0x00)
#define REG_SC_BK10_00_H      _PK_H_(0x10, 0x00)
#define REG_SC_BK10_01_L      _PK_L_(0x10, 0x01)
#define REG_SC_BK10_01_H      _PK_H_(0x10, 0x01)
#define REG_SC_BK10_02_L      _PK_L_(0x10, 0x02)
#define REG_SC_BK10_02_H      _PK_H_(0x10, 0x02)
#define REG_SC_BK10_03_L      _PK_L_(0x10, 0x03)
#define REG_SC_BK10_03_H      _PK_H_(0x10, 0x03)
#define REG_SC_BK10_04_L      _PK_L_(0x10, 0x04)
#define REG_SC_BK10_04_H      _PK_H_(0x10, 0x04)
#define REG_SC_BK10_05_L      _PK_L_(0x10, 0x05)
#define REG_SC_BK10_05_H      _PK_H_(0x10, 0x05)
#define REG_SC_BK10_06_L      _PK_L_(0x10, 0x06)
#define REG_SC_BK10_06_H      _PK_H_(0x10, 0x06)
#define REG_SC_BK10_07_L      _PK_L_(0x10, 0x07)
#define REG_SC_BK10_07_H      _PK_H_(0x10, 0x07)
#define REG_SC_BK10_08_L      _PK_L_(0x10, 0x08)
#define REG_SC_BK10_08_H      _PK_H_(0x10, 0x08)
#define REG_SC_BK10_09_L      _PK_L_(0x10, 0x09)
#define REG_SC_BK10_09_H      _PK_H_(0x10, 0x09)
#define REG_SC_BK10_0A_L      _PK_L_(0x10, 0x0A)
#define REG_SC_BK10_0A_H      _PK_H_(0x10, 0x0A)
#define REG_SC_BK10_0B_L      _PK_L_(0x10, 0x0B)
#define REG_SC_BK10_0B_H      _PK_H_(0x10, 0x0B)
#define REG_SC_BK10_0C_L      _PK_L_(0x10, 0x0C)
#define REG_SC_BK10_0C_H      _PK_H_(0x10, 0x0C)
#define REG_SC_BK10_0D_L      _PK_L_(0x10, 0x0D)
#define REG_SC_BK10_0D_H      _PK_H_(0x10, 0x0D)
#define REG_SC_BK10_0E_L      _PK_L_(0x10, 0x0E)
#define REG_SC_BK10_0E_H      _PK_H_(0x10, 0x0E)
#define REG_SC_BK10_0F_L      _PK_L_(0x10, 0x0F)
#define REG_SC_BK10_0F_H      _PK_H_(0x10, 0x0F)
#define REG_SC_BK10_10_L      _PK_L_(0x10, 0x10)
#define REG_SC_BK10_10_H      _PK_H_(0x10, 0x10)
#define REG_SC_BK10_11_L      _PK_L_(0x10, 0x11)
#define REG_SC_BK10_11_H      _PK_H_(0x10, 0x11)
#define REG_SC_BK10_12_L      _PK_L_(0x10, 0x12)
#define REG_SC_BK10_12_H      _PK_H_(0x10, 0x12)
#define REG_SC_BK10_13_L      _PK_L_(0x10, 0x13)
#define REG_SC_BK10_13_H      _PK_H_(0x10, 0x13)
#define REG_SC_BK10_14_L      _PK_L_(0x10, 0x14)
#define REG_SC_BK10_14_H      _PK_H_(0x10, 0x14)
#define REG_SC_BK10_15_L      _PK_L_(0x10, 0x15)
#define REG_SC_BK10_15_H      _PK_H_(0x10, 0x15)
#define REG_SC_BK10_16_L      _PK_L_(0x10, 0x16)
#define REG_SC_BK10_16_H      _PK_H_(0x10, 0x16)
#define REG_SC_BK10_17_L      _PK_L_(0x10, 0x17)
#define REG_SC_BK10_17_H      _PK_H_(0x10, 0x17)
#define REG_SC_BK10_18_L      _PK_L_(0x10, 0x18)
#define REG_SC_BK10_18_H      _PK_H_(0x10, 0x18)
#define REG_SC_BK10_19_L      _PK_L_(0x10, 0x19)
#define REG_SC_BK10_19_H      _PK_H_(0x10, 0x19)
#define REG_SC_BK10_1A_L      _PK_L_(0x10, 0x1A)
#define REG_SC_BK10_1A_H      _PK_H_(0x10, 0x1A)
#define REG_SC_BK10_1B_L      _PK_L_(0x10, 0x1B)
#define REG_SC_BK10_1B_H      _PK_H_(0x10, 0x1B)
#define REG_SC_BK10_1C_L      _PK_L_(0x10, 0x1C)
#define REG_SC_BK10_1C_H      _PK_H_(0x10, 0x1C)
#define REG_SC_BK10_1D_L      _PK_L_(0x10, 0x1D)
#define REG_SC_BK10_1D_H      _PK_H_(0x10, 0x1D)
#define REG_SC_BK10_1E_L      _PK_L_(0x10, 0x1E)
#define REG_SC_BK10_1E_H      _PK_H_(0x10, 0x1E)
#define REG_SC_BK10_1F_L      _PK_L_(0x10, 0x1F)
#define REG_SC_BK10_1F_H      _PK_H_(0x10, 0x1F)
#define REG_SC_BK10_20_L      _PK_L_(0x10, 0x20)
#define REG_SC_BK10_20_H      _PK_H_(0x10, 0x20)
#define REG_SC_BK10_21_L      _PK_L_(0x10, 0x21)
#define REG_SC_BK10_21_H      _PK_H_(0x10, 0x21)
#define REG_SC_BK10_22_L      _PK_L_(0x10, 0x22)
#define REG_SC_BK10_22_H      _PK_H_(0x10, 0x22)
#define REG_SC_BK10_23_L      _PK_L_(0x10, 0x23)
#define REG_SC_BK10_23_H      _PK_H_(0x10, 0x23)
#define REG_SC_BK10_24_L      _PK_L_(0x10, 0x24)
#define REG_SC_BK10_24_H      _PK_H_(0x10, 0x24)
#define REG_SC_BK10_25_L      _PK_L_(0x10, 0x25)
#define REG_SC_BK10_25_H      _PK_H_(0x10, 0x25)
#define REG_SC_BK10_26_L      _PK_L_(0x10, 0x26)
#define REG_SC_BK10_26_H      _PK_H_(0x10, 0x26)
#define REG_SC_BK10_27_L      _PK_L_(0x10, 0x27)
#define REG_SC_BK10_27_H      _PK_H_(0x10, 0x27)
#define REG_SC_BK10_28_L      _PK_L_(0x10, 0x28)
#define REG_SC_BK10_28_H      _PK_H_(0x10, 0x28)
#define REG_SC_BK10_29_L      _PK_L_(0x10, 0x29)
#define REG_SC_BK10_29_H      _PK_H_(0x10, 0x29)
#define REG_SC_BK10_2A_L      _PK_L_(0x10, 0x2A)
#define REG_SC_BK10_2A_H      _PK_H_(0x10, 0x2A)
#define REG_SC_BK10_2B_L      _PK_L_(0x10, 0x2B)
#define REG_SC_BK10_2B_H      _PK_H_(0x10, 0x2B)
#define REG_SC_BK10_2C_L      _PK_L_(0x10, 0x2C)
#define REG_SC_BK10_2C_H      _PK_H_(0x10, 0x2C)
#define REG_SC_BK10_2D_L      _PK_L_(0x10, 0x2D)
#define REG_SC_BK10_2D_H      _PK_H_(0x10, 0x2D)
#define REG_SC_BK10_2E_L      _PK_L_(0x10, 0x2E)
#define REG_SC_BK10_2E_H      _PK_H_(0x10, 0x2E)
#define REG_SC_BK10_2F_L      _PK_L_(0x10, 0x2F)
#define REG_SC_BK10_2F_H      _PK_H_(0x10, 0x2F)
#define REG_SC_BK10_30_L      _PK_L_(0x10, 0x30)
#define REG_SC_BK10_30_H      _PK_H_(0x10, 0x30)
#define REG_SC_BK10_31_L      _PK_L_(0x10, 0x31)
#define REG_SC_BK10_31_H      _PK_H_(0x10, 0x31)
#define REG_SC_BK10_32_L      _PK_L_(0x10, 0x32)
#define REG_SC_BK10_32_H      _PK_H_(0x10, 0x32)
#define REG_SC_BK10_33_L      _PK_L_(0x10, 0x33)
#define REG_SC_BK10_33_H      _PK_H_(0x10, 0x33)
#define REG_SC_BK10_34_L      _PK_L_(0x10, 0x34)
#define REG_SC_BK10_34_H      _PK_H_(0x10, 0x34)
#define REG_SC_BK10_35_L      _PK_L_(0x10, 0x35)
#define REG_SC_BK10_35_H      _PK_H_(0x10, 0x35)
#define REG_SC_BK10_36_L      _PK_L_(0x10, 0x36)
#define REG_SC_BK10_36_H      _PK_H_(0x10, 0x36)
#define REG_SC_BK10_37_L      _PK_L_(0x10, 0x37)
#define REG_SC_BK10_37_H      _PK_H_(0x10, 0x37)
#define REG_SC_BK10_38_L      _PK_L_(0x10, 0x38)
#define REG_SC_BK10_38_H      _PK_H_(0x10, 0x38)
#define REG_SC_BK10_39_L      _PK_L_(0x10, 0x39)
#define REG_SC_BK10_39_H      _PK_H_(0x10, 0x39)
#define REG_SC_BK10_3A_L      _PK_L_(0x10, 0x3A)
#define REG_SC_BK10_3A_H      _PK_H_(0x10, 0x3A)
#define REG_SC_BK10_3B_L      _PK_L_(0x10, 0x3B)
#define REG_SC_BK10_3B_H      _PK_H_(0x10, 0x3B)
#define REG_SC_BK10_3C_L      _PK_L_(0x10, 0x3C)
#define REG_SC_BK10_3C_H      _PK_H_(0x10, 0x3C)
#define REG_SC_BK10_3D_L      _PK_L_(0x10, 0x3D)
#define REG_SC_BK10_3D_H      _PK_H_(0x10, 0x3D)
#define REG_SC_BK10_3E_L      _PK_L_(0x10, 0x3E)
#define REG_SC_BK10_3E_H      _PK_H_(0x10, 0x3E)
#define REG_SC_BK10_3F_L      _PK_L_(0x10, 0x3F)
#define REG_SC_BK10_3F_H      _PK_H_(0x10, 0x3F)
#define REG_SC_BK10_40_L      _PK_L_(0x10, 0x40)
#define REG_SC_BK10_40_H      _PK_H_(0x10, 0x40)
#define REG_SC_BK10_41_L      _PK_L_(0x10, 0x41)
#define REG_SC_BK10_41_H      _PK_H_(0x10, 0x41)
#define REG_SC_BK10_42_L      _PK_L_(0x10, 0x42)
#define REG_SC_BK10_42_H      _PK_H_(0x10, 0x42)
#define REG_SC_BK10_43_L      _PK_L_(0x10, 0x43)
#define REG_SC_BK10_43_H      _PK_H_(0x10, 0x43)
#define REG_SC_BK10_44_L      _PK_L_(0x10, 0x44)
#define REG_SC_BK10_44_H      _PK_H_(0x10, 0x44)
#define REG_SC_BK10_45_L      _PK_L_(0x10, 0x45)
#define REG_SC_BK10_45_H      _PK_H_(0x10, 0x45)
#define REG_SC_BK10_46_L      _PK_L_(0x10, 0x46)
#define REG_SC_BK10_46_H      _PK_H_(0x10, 0x46)
#define REG_SC_BK10_47_L      _PK_L_(0x10, 0x47)
#define REG_SC_BK10_47_H      _PK_H_(0x10, 0x47)
#define REG_SC_BK10_48_L      _PK_L_(0x10, 0x48)
#define REG_SC_BK10_48_H      _PK_H_(0x10, 0x48)
#define REG_SC_BK10_49_L      _PK_L_(0x10, 0x49)
#define REG_SC_BK10_49_H      _PK_H_(0x10, 0x49)
#define REG_SC_BK10_4A_L      _PK_L_(0x10, 0x4A)
#define REG_SC_BK10_4A_H      _PK_H_(0x10, 0x4A)
#define REG_SC_BK10_4B_L      _PK_L_(0x10, 0x4B)
#define REG_SC_BK10_4B_H      _PK_H_(0x10, 0x4B)
#define REG_SC_BK10_4C_L      _PK_L_(0x10, 0x4C)
#define REG_SC_BK10_4C_H      _PK_H_(0x10, 0x4C)
#define REG_SC_BK10_4D_L      _PK_L_(0x10, 0x4D)
#define REG_SC_BK10_4D_H      _PK_H_(0x10, 0x4D)
#define REG_SC_BK10_4E_L      _PK_L_(0x10, 0x4E)
#define REG_SC_BK10_4E_H      _PK_H_(0x10, 0x4E)
#define REG_SC_BK10_4F_L      _PK_L_(0x10, 0x4F)
#define REG_SC_BK10_4F_H      _PK_H_(0x10, 0x4F)
#define REG_SC_BK10_50_L      _PK_L_(0x10, 0x50)
#define REG_SC_BK10_50_H      _PK_H_(0x10, 0x50)
#define REG_SC_BK10_51_L      _PK_L_(0x10, 0x51)
#define REG_SC_BK10_51_H      _PK_H_(0x10, 0x51)
#define REG_SC_BK10_52_L      _PK_L_(0x10, 0x52)
#define REG_SC_BK10_52_H      _PK_H_(0x10, 0x52)
#define REG_SC_BK10_53_L      _PK_L_(0x10, 0x53)
#define REG_SC_BK10_53_H      _PK_H_(0x10, 0x53)
#define REG_SC_BK10_54_L      _PK_L_(0x10, 0x54)
#define REG_SC_BK10_54_H      _PK_H_(0x10, 0x54)
#define REG_SC_BK10_55_L      _PK_L_(0x10, 0x55)
#define REG_SC_BK10_55_H      _PK_H_(0x10, 0x55)
#define REG_SC_BK10_56_L      _PK_L_(0x10, 0x56)
#define REG_SC_BK10_56_H      _PK_H_(0x10, 0x56)
#define REG_SC_BK10_57_L      _PK_L_(0x10, 0x57)
#define REG_SC_BK10_57_H      _PK_H_(0x10, 0x57)
#define REG_SC_BK10_58_L      _PK_L_(0x10, 0x58)
#define REG_SC_BK10_58_H      _PK_H_(0x10, 0x58)
#define REG_SC_BK10_59_L      _PK_L_(0x10, 0x59)
#define REG_SC_BK10_59_H      _PK_H_(0x10, 0x59)
#define REG_SC_BK10_5A_L      _PK_L_(0x10, 0x5A)
#define REG_SC_BK10_5A_H      _PK_H_(0x10, 0x5A)
#define REG_SC_BK10_5B_L      _PK_L_(0x10, 0x5B)
#define REG_SC_BK10_5B_H      _PK_H_(0x10, 0x5B)
#define REG_SC_BK10_5C_L      _PK_L_(0x10, 0x5C)
#define REG_SC_BK10_5C_H      _PK_H_(0x10, 0x5C)
#define REG_SC_BK10_5D_L      _PK_L_(0x10, 0x5D)
#define REG_SC_BK10_5D_H      _PK_H_(0x10, 0x5D)
#define REG_SC_BK10_5E_L      _PK_L_(0x10, 0x5E)
#define REG_SC_BK10_5E_H      _PK_H_(0x10, 0x5E)
#define REG_SC_BK10_5F_L      _PK_L_(0x10, 0x5F)
#define REG_SC_BK10_5F_H      _PK_H_(0x10, 0x5F)
#define REG_SC_BK10_60_L      _PK_L_(0x10, 0x60)
#define REG_SC_BK10_60_H      _PK_H_(0x10, 0x60)
#define REG_SC_BK10_61_L      _PK_L_(0x10, 0x61)
#define REG_SC_BK10_61_H      _PK_H_(0x10, 0x61)
#define REG_SC_BK10_62_L      _PK_L_(0x10, 0x62)
#define REG_SC_BK10_62_H      _PK_H_(0x10, 0x62)
#define REG_SC_BK10_63_L      _PK_L_(0x10, 0x63)
#define REG_SC_BK10_63_H      _PK_H_(0x10, 0x63)
#define REG_SC_BK10_64_L      _PK_L_(0x10, 0x64)
#define REG_SC_BK10_64_H      _PK_H_(0x10, 0x64)
#define REG_SC_BK10_65_L      _PK_L_(0x10, 0x65)
#define REG_SC_BK10_65_H      _PK_H_(0x10, 0x65)
#define REG_SC_BK10_66_L      _PK_L_(0x10, 0x66)
#define REG_SC_BK10_66_H      _PK_H_(0x10, 0x66)
#define REG_SC_BK10_67_L      _PK_L_(0x10, 0x67)
#define REG_SC_BK10_67_H      _PK_H_(0x10, 0x67)
#define REG_SC_BK10_68_L      _PK_L_(0x10, 0x68)
#define REG_SC_BK10_68_H      _PK_H_(0x10, 0x68)
#define REG_SC_BK10_69_L      _PK_L_(0x10, 0x69)
#define REG_SC_BK10_69_H      _PK_H_(0x10, 0x69)
#define REG_SC_BK10_6A_L      _PK_L_(0x10, 0x6A)
#define REG_SC_BK10_6A_H      _PK_H_(0x10, 0x6A)
#define REG_SC_BK10_6B_L      _PK_L_(0x10, 0x6B)
#define REG_SC_BK10_6B_H      _PK_H_(0x10, 0x6B)
#define REG_SC_BK10_6C_L      _PK_L_(0x10, 0x6C)
#define REG_SC_BK10_6C_H      _PK_H_(0x10, 0x6C)
#define REG_SC_BK10_6D_L      _PK_L_(0x10, 0x6D)
#define REG_SC_BK10_6D_H      _PK_H_(0x10, 0x6D)
#define REG_SC_BK10_6E_L      _PK_L_(0x10, 0x6E)
#define REG_SC_BK10_6E_H      _PK_H_(0x10, 0x6E)
#define REG_SC_BK10_6F_L      _PK_L_(0x10, 0x6F)
#define REG_SC_BK10_6F_H      _PK_H_(0x10, 0x6F)
#define REG_SC_BK10_70_L      _PK_L_(0x10, 0x70)
#define REG_SC_BK10_70_H      _PK_H_(0x10, 0x70)
#define REG_SC_BK10_71_L      _PK_L_(0x10, 0x71)
#define REG_SC_BK10_71_H      _PK_H_(0x10, 0x71)
#define REG_SC_BK10_72_L      _PK_L_(0x10, 0x72)
#define REG_SC_BK10_72_H      _PK_H_(0x10, 0x72)
#define REG_SC_BK10_73_L      _PK_L_(0x10, 0x73)
#define REG_SC_BK10_73_H      _PK_H_(0x10, 0x73)
#define REG_SC_BK10_74_L      _PK_L_(0x10, 0x74)
#define REG_SC_BK10_74_H      _PK_H_(0x10, 0x74)
#define REG_SC_BK10_75_L      _PK_L_(0x10, 0x75)
#define REG_SC_BK10_75_H      _PK_H_(0x10, 0x75)
#define REG_SC_BK10_76_L      _PK_L_(0x10, 0x76)
#define REG_SC_BK10_76_H      _PK_H_(0x10, 0x76)
#define REG_SC_BK10_77_L      _PK_L_(0x10, 0x77)
#define REG_SC_BK10_77_H      _PK_H_(0x10, 0x77)
#define REG_SC_BK10_78_L      _PK_L_(0x10, 0x78)
#define REG_SC_BK10_78_H      _PK_H_(0x10, 0x78)
#define REG_SC_BK10_79_L      _PK_L_(0x10, 0x79)
#define REG_SC_BK10_79_H      _PK_H_(0x10, 0x79)
#define REG_SC_BK10_7A_L      _PK_L_(0x10, 0x7A)
#define REG_SC_BK10_7A_H      _PK_H_(0x10, 0x7A)
#define REG_SC_BK10_7B_L      _PK_L_(0x10, 0x7B)
#define REG_SC_BK10_7B_H      _PK_H_(0x10, 0x7B)
#define REG_SC_BK10_7C_L      _PK_L_(0x10, 0x7C)
#define REG_SC_BK10_7C_H      _PK_H_(0x10, 0x7C)
#define REG_SC_BK10_7D_L      _PK_L_(0x10, 0x7D)
#define REG_SC_BK10_7D_H      _PK_H_(0x10, 0x7D)
#define REG_SC_BK10_7E_L      _PK_L_(0x10, 0x7E)
#define REG_SC_BK10_7E_H      _PK_H_(0x10, 0x7E)
#define REG_SC_BK10_7F_L      _PK_L_(0x10, 0x7F)
#define REG_SC_BK10_7F_H      _PK_H_(0x10, 0x7F)
//----------------------------------------------
#define REG_SC_BK11_00_L      _PK_L_(0x11, 0x00)
#define REG_SC_BK11_00_H      _PK_H_(0x11, 0x00)
#define REG_SC_BK11_01_L      _PK_L_(0x11, 0x01)
#define REG_SC_BK11_01_H      _PK_H_(0x11, 0x01)
#define REG_SC_BK11_02_L      _PK_L_(0x11, 0x02)
#define REG_SC_BK11_02_H      _PK_H_(0x11, 0x02)
#define REG_SC_BK11_03_L      _PK_L_(0x11, 0x03)
#define REG_SC_BK11_03_H      _PK_H_(0x11, 0x03)
#define REG_SC_BK11_04_L      _PK_L_(0x11, 0x04)
#define REG_SC_BK11_04_H      _PK_H_(0x11, 0x04)
#define REG_SC_BK11_05_L      _PK_L_(0x11, 0x05)
#define REG_SC_BK11_05_H      _PK_H_(0x11, 0x05)
#define REG_SC_BK11_06_L      _PK_L_(0x11, 0x06)
#define REG_SC_BK11_06_H      _PK_H_(0x11, 0x06)
#define REG_SC_BK11_07_L      _PK_L_(0x11, 0x07)
#define REG_SC_BK11_07_H      _PK_H_(0x11, 0x07)
#define REG_SC_BK11_08_L      _PK_L_(0x11, 0x08)
#define REG_SC_BK11_08_H      _PK_H_(0x11, 0x08)
#define REG_SC_BK11_09_L      _PK_L_(0x11, 0x09)
#define REG_SC_BK11_09_H      _PK_H_(0x11, 0x09)
#define REG_SC_BK11_0A_L      _PK_L_(0x11, 0x0A)
#define REG_SC_BK11_0A_H      _PK_H_(0x11, 0x0A)
#define REG_SC_BK11_0B_L      _PK_L_(0x11, 0x0B)
#define REG_SC_BK11_0B_H      _PK_H_(0x11, 0x0B)
#define REG_SC_BK11_0C_L      _PK_L_(0x11, 0x0C)
#define REG_SC_BK11_0C_H      _PK_H_(0x11, 0x0C)
#define REG_SC_BK11_0D_L      _PK_L_(0x11, 0x0D)
#define REG_SC_BK11_0D_H      _PK_H_(0x11, 0x0D)
#define REG_SC_BK11_0E_L      _PK_L_(0x11, 0x0E)
#define REG_SC_BK11_0E_H      _PK_H_(0x11, 0x0E)
#define REG_SC_BK11_0F_L      _PK_L_(0x11, 0x0F)
#define REG_SC_BK11_0F_H      _PK_H_(0x11, 0x0F)
#define REG_SC_BK11_10_L      _PK_L_(0x11, 0x10)
#define REG_SC_BK11_10_H      _PK_H_(0x11, 0x10)
#define REG_SC_BK11_11_L      _PK_L_(0x11, 0x11)
#define REG_SC_BK11_11_H      _PK_H_(0x11, 0x11)
#define REG_SC_BK11_12_L      _PK_L_(0x11, 0x12)
#define REG_SC_BK11_12_H      _PK_H_(0x11, 0x12)
#define REG_SC_BK11_13_L      _PK_L_(0x11, 0x13)
#define REG_SC_BK11_13_H      _PK_H_(0x11, 0x13)
#define REG_SC_BK11_14_L      _PK_L_(0x11, 0x14)
#define REG_SC_BK11_14_H      _PK_H_(0x11, 0x14)
#define REG_SC_BK11_15_L      _PK_L_(0x11, 0x15)
#define REG_SC_BK11_15_H      _PK_H_(0x11, 0x15)
#define REG_SC_BK11_16_L      _PK_L_(0x11, 0x16)
#define REG_SC_BK11_16_H      _PK_H_(0x11, 0x16)
#define REG_SC_BK11_17_L      _PK_L_(0x11, 0x17)
#define REG_SC_BK11_17_H      _PK_H_(0x11, 0x17)
#define REG_SC_BK11_18_L      _PK_L_(0x11, 0x18)
#define REG_SC_BK11_18_H      _PK_H_(0x11, 0x18)
#define REG_SC_BK11_19_L      _PK_L_(0x11, 0x19)
#define REG_SC_BK11_19_H      _PK_H_(0x11, 0x19)
#define REG_SC_BK11_1A_L      _PK_L_(0x11, 0x1A)
#define REG_SC_BK11_1A_H      _PK_H_(0x11, 0x1A)
#define REG_SC_BK11_1B_L      _PK_L_(0x11, 0x1B)
#define REG_SC_BK11_1B_H      _PK_H_(0x11, 0x1B)
#define REG_SC_BK11_1C_L      _PK_L_(0x11, 0x1C)
#define REG_SC_BK11_1C_H      _PK_H_(0x11, 0x1C)
#define REG_SC_BK11_1D_L      _PK_L_(0x11, 0x1D)
#define REG_SC_BK11_1D_H      _PK_H_(0x11, 0x1D)
#define REG_SC_BK11_1E_L      _PK_L_(0x11, 0x1E)
#define REG_SC_BK11_1E_H      _PK_H_(0x11, 0x1E)
#define REG_SC_BK11_1F_L      _PK_L_(0x11, 0x1F)
#define REG_SC_BK11_1F_H      _PK_H_(0x11, 0x1F)
#define REG_SC_BK11_20_L      _PK_L_(0x11, 0x20)
#define REG_SC_BK11_20_H      _PK_H_(0x11, 0x20)
#define REG_SC_BK11_21_L      _PK_L_(0x11, 0x21)
#define REG_SC_BK11_21_H      _PK_H_(0x11, 0x21)
#define REG_SC_BK11_22_L      _PK_L_(0x11, 0x22)
#define REG_SC_BK11_22_H      _PK_H_(0x11, 0x22)
#define REG_SC_BK11_23_L      _PK_L_(0x11, 0x23)
#define REG_SC_BK11_23_H      _PK_H_(0x11, 0x23)
#define REG_SC_BK11_24_L      _PK_L_(0x11, 0x24)
#define REG_SC_BK11_24_H      _PK_H_(0x11, 0x24)
#define REG_SC_BK11_25_L      _PK_L_(0x11, 0x25)
#define REG_SC_BK11_25_H      _PK_H_(0x11, 0x25)
#define REG_SC_BK11_26_L      _PK_L_(0x11, 0x26)
#define REG_SC_BK11_26_H      _PK_H_(0x11, 0x26)
#define REG_SC_BK11_27_L      _PK_L_(0x11, 0x27)
#define REG_SC_BK11_27_H      _PK_H_(0x11, 0x27)
#define REG_SC_BK11_28_L      _PK_L_(0x11, 0x28)
#define REG_SC_BK11_28_H      _PK_H_(0x11, 0x28)
#define REG_SC_BK11_29_L      _PK_L_(0x11, 0x29)
#define REG_SC_BK11_29_H      _PK_H_(0x11, 0x29)
#define REG_SC_BK11_2A_L      _PK_L_(0x11, 0x2A)
#define REG_SC_BK11_2A_H      _PK_H_(0x11, 0x2A)
#define REG_SC_BK11_2B_L      _PK_L_(0x11, 0x2B)
#define REG_SC_BK11_2B_H      _PK_H_(0x11, 0x2B)
#define REG_SC_BK11_2C_L      _PK_L_(0x11, 0x2C)
#define REG_SC_BK11_2C_H      _PK_H_(0x11, 0x2C)
#define REG_SC_BK11_2D_L      _PK_L_(0x11, 0x2D)
#define REG_SC_BK11_2D_H      _PK_H_(0x11, 0x2D)
#define REG_SC_BK11_2E_L      _PK_L_(0x11, 0x2E)
#define REG_SC_BK11_2E_H      _PK_H_(0x11, 0x2E)
#define REG_SC_BK11_2F_L      _PK_L_(0x11, 0x2F)
#define REG_SC_BK11_2F_H      _PK_H_(0x11, 0x2F)
#define REG_SC_BK11_30_L      _PK_L_(0x11, 0x30)
#define REG_SC_BK11_30_H      _PK_H_(0x11, 0x30)
#define REG_SC_BK11_31_L      _PK_L_(0x11, 0x31)
#define REG_SC_BK11_31_H      _PK_H_(0x11, 0x31)
#define REG_SC_BK11_32_L      _PK_L_(0x11, 0x32)
#define REG_SC_BK11_32_H      _PK_H_(0x11, 0x32)
#define REG_SC_BK11_33_L      _PK_L_(0x11, 0x33)
#define REG_SC_BK11_33_H      _PK_H_(0x11, 0x33)
#define REG_SC_BK11_34_L      _PK_L_(0x11, 0x34)
#define REG_SC_BK11_34_H      _PK_H_(0x11, 0x34)
#define REG_SC_BK11_35_L      _PK_L_(0x11, 0x35)
#define REG_SC_BK11_35_H      _PK_H_(0x11, 0x35)
#define REG_SC_BK11_36_L      _PK_L_(0x11, 0x36)
#define REG_SC_BK11_36_H      _PK_H_(0x11, 0x36)
#define REG_SC_BK11_37_L      _PK_L_(0x11, 0x37)
#define REG_SC_BK11_37_H      _PK_H_(0x11, 0x37)
#define REG_SC_BK11_38_L      _PK_L_(0x11, 0x38)
#define REG_SC_BK11_38_H      _PK_H_(0x11, 0x38)
#define REG_SC_BK11_39_L      _PK_L_(0x11, 0x39)
#define REG_SC_BK11_39_H      _PK_H_(0x11, 0x39)
#define REG_SC_BK11_3A_L      _PK_L_(0x11, 0x3A)
#define REG_SC_BK11_3A_H      _PK_H_(0x11, 0x3A)
#define REG_SC_BK11_3B_L      _PK_L_(0x11, 0x3B)
#define REG_SC_BK11_3B_H      _PK_H_(0x11, 0x3B)
#define REG_SC_BK11_3C_L      _PK_L_(0x11, 0x3C)
#define REG_SC_BK11_3C_H      _PK_H_(0x11, 0x3C)
#define REG_SC_BK11_3D_L      _PK_L_(0x11, 0x3D)
#define REG_SC_BK11_3D_H      _PK_H_(0x11, 0x3D)
#define REG_SC_BK11_3E_L      _PK_L_(0x11, 0x3E)
#define REG_SC_BK11_3E_H      _PK_H_(0x11, 0x3E)
#define REG_SC_BK11_3F_L      _PK_L_(0x11, 0x3F)
#define REG_SC_BK11_3F_H      _PK_H_(0x11, 0x3F)
#define REG_SC_BK11_40_L      _PK_L_(0x11, 0x40)
#define REG_SC_BK11_40_H      _PK_H_(0x11, 0x40)
#define REG_SC_BK11_41_L      _PK_L_(0x11, 0x41)
#define REG_SC_BK11_41_H      _PK_H_(0x11, 0x41)
#define REG_SC_BK11_42_L      _PK_L_(0x11, 0x42)
#define REG_SC_BK11_42_H      _PK_H_(0x11, 0x42)
#define REG_SC_BK11_43_L      _PK_L_(0x11, 0x43)
#define REG_SC_BK11_43_H      _PK_H_(0x11, 0x43)
#define REG_SC_BK11_44_L      _PK_L_(0x11, 0x44)
#define REG_SC_BK11_44_H      _PK_H_(0x11, 0x44)
#define REG_SC_BK11_45_L      _PK_L_(0x11, 0x45)
#define REG_SC_BK11_45_H      _PK_H_(0x11, 0x45)
#define REG_SC_BK11_46_L      _PK_L_(0x11, 0x46)
#define REG_SC_BK11_46_H      _PK_H_(0x11, 0x46)
#define REG_SC_BK11_47_L      _PK_L_(0x11, 0x47)
#define REG_SC_BK11_47_H      _PK_H_(0x11, 0x47)
#define REG_SC_BK11_48_L      _PK_L_(0x11, 0x48)
#define REG_SC_BK11_48_H      _PK_H_(0x11, 0x48)
#define REG_SC_BK11_49_L      _PK_L_(0x11, 0x49)
#define REG_SC_BK11_49_H      _PK_H_(0x11, 0x49)
#define REG_SC_BK11_4A_L      _PK_L_(0x11, 0x4A)
#define REG_SC_BK11_4A_H      _PK_H_(0x11, 0x4A)
#define REG_SC_BK11_4B_L      _PK_L_(0x11, 0x4B)
#define REG_SC_BK11_4B_H      _PK_H_(0x11, 0x4B)
#define REG_SC_BK11_4C_L      _PK_L_(0x11, 0x4C)
#define REG_SC_BK11_4C_H      _PK_H_(0x11, 0x4C)
#define REG_SC_BK11_4D_L      _PK_L_(0x11, 0x4D)
#define REG_SC_BK11_4D_H      _PK_H_(0x11, 0x4D)
#define REG_SC_BK11_4E_L      _PK_L_(0x11, 0x4E)
#define REG_SC_BK11_4E_H      _PK_H_(0x11, 0x4E)
#define REG_SC_BK11_4F_L      _PK_L_(0x11, 0x4F)
#define REG_SC_BK11_4F_H      _PK_H_(0x11, 0x4F)
#define REG_SC_BK11_50_L      _PK_L_(0x11, 0x50)
#define REG_SC_BK11_50_H      _PK_H_(0x11, 0x50)
#define REG_SC_BK11_51_L      _PK_L_(0x11, 0x51)
#define REG_SC_BK11_51_H      _PK_H_(0x11, 0x51)
#define REG_SC_BK11_52_L      _PK_L_(0x11, 0x52)
#define REG_SC_BK11_52_H      _PK_H_(0x11, 0x52)
#define REG_SC_BK11_53_L      _PK_L_(0x11, 0x53)
#define REG_SC_BK11_53_H      _PK_H_(0x11, 0x53)
#define REG_SC_BK11_54_L      _PK_L_(0x11, 0x54)
#define REG_SC_BK11_54_H      _PK_H_(0x11, 0x54)
#define REG_SC_BK11_55_L      _PK_L_(0x11, 0x55)
#define REG_SC_BK11_55_H      _PK_H_(0x11, 0x55)
#define REG_SC_BK11_56_L      _PK_L_(0x11, 0x56)
#define REG_SC_BK11_56_H      _PK_H_(0x11, 0x56)
#define REG_SC_BK11_57_L      _PK_L_(0x11, 0x57)
#define REG_SC_BK11_57_H      _PK_H_(0x11, 0x57)
#define REG_SC_BK11_58_L      _PK_L_(0x11, 0x58)
#define REG_SC_BK11_58_H      _PK_H_(0x11, 0x58)
#define REG_SC_BK11_59_L      _PK_L_(0x11, 0x59)
#define REG_SC_BK11_59_H      _PK_H_(0x11, 0x59)
#define REG_SC_BK11_5A_L      _PK_L_(0x11, 0x5A)
#define REG_SC_BK11_5A_H      _PK_H_(0x11, 0x5A)
#define REG_SC_BK11_5B_L      _PK_L_(0x11, 0x5B)
#define REG_SC_BK11_5B_H      _PK_H_(0x11, 0x5B)
#define REG_SC_BK11_5C_L      _PK_L_(0x11, 0x5C)
#define REG_SC_BK11_5C_H      _PK_H_(0x11, 0x5C)
#define REG_SC_BK11_5D_L      _PK_L_(0x11, 0x5D)
#define REG_SC_BK11_5D_H      _PK_H_(0x11, 0x5D)
#define REG_SC_BK11_5E_L      _PK_L_(0x11, 0x5E)
#define REG_SC_BK11_5E_H      _PK_H_(0x11, 0x5E)
#define REG_SC_BK11_5F_L      _PK_L_(0x11, 0x5F)
#define REG_SC_BK11_5F_H      _PK_H_(0x11, 0x5F)
#define REG_SC_BK11_60_L      _PK_L_(0x11, 0x60)
#define REG_SC_BK11_60_H      _PK_H_(0x11, 0x60)
#define REG_SC_BK11_61_L      _PK_L_(0x11, 0x61)
#define REG_SC_BK11_61_H      _PK_H_(0x11, 0x61)
#define REG_SC_BK11_62_L      _PK_L_(0x11, 0x62)
#define REG_SC_BK11_62_H      _PK_H_(0x11, 0x62)
#define REG_SC_BK11_63_L      _PK_L_(0x11, 0x63)
#define REG_SC_BK11_63_H      _PK_H_(0x11, 0x63)
#define REG_SC_BK11_64_L      _PK_L_(0x11, 0x64)
#define REG_SC_BK11_64_H      _PK_H_(0x11, 0x64)
#define REG_SC_BK11_65_L      _PK_L_(0x11, 0x65)
#define REG_SC_BK11_65_H      _PK_H_(0x11, 0x65)
#define REG_SC_BK11_66_L      _PK_L_(0x11, 0x66)
#define REG_SC_BK11_66_H      _PK_H_(0x11, 0x66)
#define REG_SC_BK11_67_L      _PK_L_(0x11, 0x67)
#define REG_SC_BK11_67_H      _PK_H_(0x11, 0x67)
#define REG_SC_BK11_68_L      _PK_L_(0x11, 0x68)
#define REG_SC_BK11_68_H      _PK_H_(0x11, 0x68)
#define REG_SC_BK11_69_L      _PK_L_(0x11, 0x69)
#define REG_SC_BK11_69_H      _PK_H_(0x11, 0x69)
#define REG_SC_BK11_6A_L      _PK_L_(0x11, 0x6A)
#define REG_SC_BK11_6A_H      _PK_H_(0x11, 0x6A)
#define REG_SC_BK11_6B_L      _PK_L_(0x11, 0x6B)
#define REG_SC_BK11_6B_H      _PK_H_(0x11, 0x6B)
#define REG_SC_BK11_6C_L      _PK_L_(0x11, 0x6C)
#define REG_SC_BK11_6C_H      _PK_H_(0x11, 0x6C)
#define REG_SC_BK11_6D_L      _PK_L_(0x11, 0x6D)
#define REG_SC_BK11_6D_H      _PK_H_(0x11, 0x6D)
#define REG_SC_BK11_6E_L      _PK_L_(0x11, 0x6E)
#define REG_SC_BK11_6E_H      _PK_H_(0x11, 0x6E)
#define REG_SC_BK11_6F_L      _PK_L_(0x11, 0x6F)
#define REG_SC_BK11_6F_H      _PK_H_(0x11, 0x6F)
#define REG_SC_BK11_70_L      _PK_L_(0x11, 0x70)
#define REG_SC_BK11_70_H      _PK_H_(0x11, 0x70)
#define REG_SC_BK11_71_L      _PK_L_(0x11, 0x71)
#define REG_SC_BK11_71_H      _PK_H_(0x11, 0x71)
#define REG_SC_BK11_72_L      _PK_L_(0x11, 0x72)
#define REG_SC_BK11_72_H      _PK_H_(0x11, 0x72)
#define REG_SC_BK11_73_L      _PK_L_(0x11, 0x73)
#define REG_SC_BK11_73_H      _PK_H_(0x11, 0x73)
#define REG_SC_BK11_74_L      _PK_L_(0x11, 0x74)
#define REG_SC_BK11_74_H      _PK_H_(0x11, 0x74)
#define REG_SC_BK11_75_L      _PK_L_(0x11, 0x75)
#define REG_SC_BK11_75_H      _PK_H_(0x11, 0x75)
#define REG_SC_BK11_76_L      _PK_L_(0x11, 0x76)
#define REG_SC_BK11_76_H      _PK_H_(0x11, 0x76)
#define REG_SC_BK11_77_L      _PK_L_(0x11, 0x77)
#define REG_SC_BK11_77_H      _PK_H_(0x11, 0x77)
#define REG_SC_BK11_78_L      _PK_L_(0x11, 0x78)
#define REG_SC_BK11_78_H      _PK_H_(0x11, 0x78)
#define REG_SC_BK11_79_L      _PK_L_(0x11, 0x79)
#define REG_SC_BK11_79_H      _PK_H_(0x11, 0x79)
#define REG_SC_BK11_7A_L      _PK_L_(0x11, 0x7A)
#define REG_SC_BK11_7A_H      _PK_H_(0x11, 0x7A)
#define REG_SC_BK11_7B_L      _PK_L_(0x11, 0x7B)
#define REG_SC_BK11_7B_H      _PK_H_(0x11, 0x7B)
#define REG_SC_BK11_7C_L      _PK_L_(0x11, 0x7C)
#define REG_SC_BK11_7C_H      _PK_H_(0x11, 0x7C)
#define REG_SC_BK11_7D_L      _PK_L_(0x11, 0x7D)
#define REG_SC_BK11_7D_H      _PK_H_(0x11, 0x7D)
#define REG_SC_BK11_7E_L      _PK_L_(0x11, 0x7E)
#define REG_SC_BK11_7E_H      _PK_H_(0x11, 0x7E)
#define REG_SC_BK11_7F_L      _PK_L_(0x11, 0x7F)
#define REG_SC_BK11_7F_H      _PK_H_(0x11, 0x7F)
//----------------------------------------------
#define REG_SC_BK12_00_L      _PK_L_(0x12, 0x00)
#define REG_SC_BK12_00_H      _PK_H_(0x12, 0x00)
#define REG_SC_BK12_01_L      _PK_L_(0x12, 0x01)
#define REG_SC_BK12_01_H      _PK_H_(0x12, 0x01)
#define REG_SC_BK12_02_L      _PK_L_(0x12, 0x02)
#define REG_SC_BK12_02_H      _PK_H_(0x12, 0x02)
#define REG_SC_BK12_03_L      _PK_L_(0x12, 0x03)
#define REG_SC_BK12_03_H      _PK_H_(0x12, 0x03)
#define REG_SC_BK12_04_L      _PK_L_(0x12, 0x04)
#define REG_SC_BK12_04_H      _PK_H_(0x12, 0x04)
#define REG_SC_BK12_05_L      _PK_L_(0x12, 0x05)
#define REG_SC_BK12_05_H      _PK_H_(0x12, 0x05)
#define REG_SC_BK12_06_L      _PK_L_(0x12, 0x06)
#define REG_SC_BK12_06_H      _PK_H_(0x12, 0x06)
#define REG_SC_BK12_07_L      _PK_L_(0x12, 0x07)
#define REG_SC_BK12_07_H      _PK_H_(0x12, 0x07)
#define REG_SC_BK12_08_L      _PK_L_(0x12, 0x08)
#define REG_SC_BK12_08_H      _PK_H_(0x12, 0x08)
#define REG_SC_BK12_09_L      _PK_L_(0x12, 0x09)
#define REG_SC_BK12_09_H      _PK_H_(0x12, 0x09)
#define REG_SC_BK12_0A_L      _PK_L_(0x12, 0x0A)
#define REG_SC_BK12_0A_H      _PK_H_(0x12, 0x0A)
#define REG_SC_BK12_0B_L      _PK_L_(0x12, 0x0B)
#define REG_SC_BK12_0B_H      _PK_H_(0x12, 0x0B)
#define REG_SC_BK12_0C_L      _PK_L_(0x12, 0x0C)
#define REG_SC_BK12_0C_H      _PK_H_(0x12, 0x0C)
#define REG_SC_BK12_0D_L      _PK_L_(0x12, 0x0D)
#define REG_SC_BK12_0D_H      _PK_H_(0x12, 0x0D)
#define REG_SC_BK12_0E_L      _PK_L_(0x12, 0x0E)
#define REG_SC_BK12_0E_H      _PK_H_(0x12, 0x0E)
#define REG_SC_BK12_0F_L      _PK_L_(0x12, 0x0F)
#define REG_SC_BK12_0F_H      _PK_H_(0x12, 0x0F)
#define REG_SC_BK12_10_L      _PK_L_(0x12, 0x10)
#define REG_SC_BK12_10_H      _PK_H_(0x12, 0x10)
#define REG_SC_BK12_11_L      _PK_L_(0x12, 0x11)
#define REG_SC_BK12_11_H      _PK_H_(0x12, 0x11)
#define REG_SC_BK12_12_L      _PK_L_(0x12, 0x12)
#define REG_SC_BK12_12_H      _PK_H_(0x12, 0x12)
#define REG_SC_BK12_13_L      _PK_L_(0x12, 0x13)
#define REG_SC_BK12_13_H      _PK_H_(0x12, 0x13)
#define REG_SC_BK12_14_L      _PK_L_(0x12, 0x14)
#define REG_SC_BK12_14_H      _PK_H_(0x12, 0x14)
#define REG_SC_BK12_15_L      _PK_L_(0x12, 0x15)
#define REG_SC_BK12_15_H      _PK_H_(0x12, 0x15)
#define REG_SC_BK12_16_L      _PK_L_(0x12, 0x16)
#define REG_SC_BK12_16_H      _PK_H_(0x12, 0x16)
#define REG_SC_BK12_17_L      _PK_L_(0x12, 0x17)
#define REG_SC_BK12_17_H      _PK_H_(0x12, 0x17)
#define REG_SC_BK12_18_L      _PK_L_(0x12, 0x18)
#define REG_SC_BK12_18_H      _PK_H_(0x12, 0x18)
#define REG_SC_BK12_19_L      _PK_L_(0x12, 0x19)
#define REG_SC_BK12_19_H      _PK_H_(0x12, 0x19)
#define REG_SC_BK12_1A_L      _PK_L_(0x12, 0x1A)
#define REG_SC_BK12_1A_H      _PK_H_(0x12, 0x1A)
#define REG_SC_BK12_1B_L      _PK_L_(0x12, 0x1B)
#define REG_SC_BK12_1B_H      _PK_H_(0x12, 0x1B)
#define REG_SC_BK12_1C_L      _PK_L_(0x12, 0x1C)
#define REG_SC_BK12_1C_H      _PK_H_(0x12, 0x1C)
#define REG_SC_BK12_1D_L      _PK_L_(0x12, 0x1D)
#define REG_SC_BK12_1D_H      _PK_H_(0x12, 0x1D)
#define REG_SC_BK12_1E_L      _PK_L_(0x12, 0x1E)
#define REG_SC_BK12_1E_H      _PK_H_(0x12, 0x1E)
#define REG_SC_BK12_1F_L      _PK_L_(0x12, 0x1F)
#define REG_SC_BK12_1F_H      _PK_H_(0x12, 0x1F)
#define REG_SC_BK12_20_L      _PK_L_(0x12, 0x20)
#define REG_SC_BK12_20_H      _PK_H_(0x12, 0x20)
#define REG_SC_BK12_21_L      _PK_L_(0x12, 0x21)
#define REG_SC_BK12_21_H      _PK_H_(0x12, 0x21)
#define REG_SC_BK12_22_L      _PK_L_(0x12, 0x22)
#define REG_SC_BK12_22_H      _PK_H_(0x12, 0x22)
#define REG_SC_BK12_23_L      _PK_L_(0x12, 0x23)
#define REG_SC_BK12_23_H      _PK_H_(0x12, 0x23)
#define REG_SC_BK12_24_L      _PK_L_(0x12, 0x24)
#define REG_SC_BK12_24_H      _PK_H_(0x12, 0x24)
#define REG_SC_BK12_25_L      _PK_L_(0x12, 0x25)
#define REG_SC_BK12_25_H      _PK_H_(0x12, 0x25)
#define REG_SC_BK12_26_L      _PK_L_(0x12, 0x26)
#define REG_SC_BK12_26_H      _PK_H_(0x12, 0x26)
#define REG_SC_BK12_27_L      _PK_L_(0x12, 0x27)
#define REG_SC_BK12_27_H      _PK_H_(0x12, 0x27)
#define REG_SC_BK12_28_L      _PK_L_(0x12, 0x28)
#define REG_SC_BK12_28_H      _PK_H_(0x12, 0x28)
#define REG_SC_BK12_29_L      _PK_L_(0x12, 0x29)
#define REG_SC_BK12_29_H      _PK_H_(0x12, 0x29)
#define REG_SC_BK12_2A_L      _PK_L_(0x12, 0x2A)
#define REG_SC_BK12_2A_H      _PK_H_(0x12, 0x2A)
#define REG_SC_BK12_2B_L      _PK_L_(0x12, 0x2B)
#define REG_SC_BK12_2B_H      _PK_H_(0x12, 0x2B)
#define REG_SC_BK12_2C_L      _PK_L_(0x12, 0x2C)
#define REG_SC_BK12_2C_H      _PK_H_(0x12, 0x2C)
#define REG_SC_BK12_2D_L      _PK_L_(0x12, 0x2D)
#define REG_SC_BK12_2D_H      _PK_H_(0x12, 0x2D)
#define REG_SC_BK12_2E_L      _PK_L_(0x12, 0x2E)
#define REG_SC_BK12_2E_H      _PK_H_(0x12, 0x2E)
#define REG_SC_BK12_2F_L      _PK_L_(0x12, 0x2F)
#define REG_SC_BK12_2F_H      _PK_H_(0x12, 0x2F)
#define REG_SC_BK12_30_L      _PK_L_(0x12, 0x30)
#define REG_SC_BK12_30_H      _PK_H_(0x12, 0x30)
#define REG_SC_BK12_31_L      _PK_L_(0x12, 0x31)
#define REG_SC_BK12_31_H      _PK_H_(0x12, 0x31)
#define REG_SC_BK12_32_L      _PK_L_(0x12, 0x32)
#define REG_SC_BK12_32_H      _PK_H_(0x12, 0x32)
#define REG_SC_BK12_33_L      _PK_L_(0x12, 0x33)
#define REG_SC_BK12_33_H      _PK_H_(0x12, 0x33)
#define REG_SC_BK12_34_L      _PK_L_(0x12, 0x34)
#define REG_SC_BK12_34_H      _PK_H_(0x12, 0x34)
#define REG_SC_BK12_35_L      _PK_L_(0x12, 0x35)
#define REG_SC_BK12_35_H      _PK_H_(0x12, 0x35)
#define REG_SC_BK12_36_L      _PK_L_(0x12, 0x36)
#define REG_SC_BK12_36_H      _PK_H_(0x12, 0x36)
#define REG_SC_BK12_37_L      _PK_L_(0x12, 0x37)
#define REG_SC_BK12_37_H      _PK_H_(0x12, 0x37)
#define REG_SC_BK12_38_L      _PK_L_(0x12, 0x38)
#define REG_SC_BK12_38_H      _PK_H_(0x12, 0x38)
#define REG_SC_BK12_39_L      _PK_L_(0x12, 0x39)
#define REG_SC_BK12_39_H      _PK_H_(0x12, 0x39)
#define REG_SC_BK12_3A_L      _PK_L_(0x12, 0x3A)
#define REG_SC_BK12_3A_H      _PK_H_(0x12, 0x3A)
#define REG_SC_BK12_3B_L      _PK_L_(0x12, 0x3B)
#define REG_SC_BK12_3B_H      _PK_H_(0x12, 0x3B)
#define REG_SC_BK12_3C_L      _PK_L_(0x12, 0x3C)
#define REG_SC_BK12_3C_H      _PK_H_(0x12, 0x3C)
#define REG_SC_BK12_3D_L      _PK_L_(0x12, 0x3D)
#define REG_SC_BK12_3D_H      _PK_H_(0x12, 0x3D)
#define REG_SC_BK12_3E_L      _PK_L_(0x12, 0x3E)
#define REG_SC_BK12_3E_H      _PK_H_(0x12, 0x3E)
#define REG_SC_BK12_3F_L      _PK_L_(0x12, 0x3F)
#define REG_SC_BK12_3F_H      _PK_H_(0x12, 0x3F)
#define REG_SC_BK12_40_L      _PK_L_(0x12, 0x40)
#define REG_SC_BK12_40_H      _PK_H_(0x12, 0x40)
#define REG_SC_BK12_41_L      _PK_L_(0x12, 0x41)
#define REG_SC_BK12_41_H      _PK_H_(0x12, 0x41)
#define REG_SC_BK12_42_L      _PK_L_(0x12, 0x42)
#define REG_SC_BK12_42_H      _PK_H_(0x12, 0x42)
#define REG_SC_BK12_43_L      _PK_L_(0x12, 0x43)
#define REG_SC_BK12_43_H      _PK_H_(0x12, 0x43)
#define REG_SC_BK12_44_L      _PK_L_(0x12, 0x44)
#define REG_SC_BK12_44_H      _PK_H_(0x12, 0x44)
#define REG_SC_BK12_45_L      _PK_L_(0x12, 0x45)
#define REG_SC_BK12_45_H      _PK_H_(0x12, 0x45)
#define REG_SC_BK12_46_L      _PK_L_(0x12, 0x46)
#define REG_SC_BK12_46_H      _PK_H_(0x12, 0x46)
#define REG_SC_BK12_47_L      _PK_L_(0x12, 0x47)
#define REG_SC_BK12_47_H      _PK_H_(0x12, 0x47)
#define REG_SC_BK12_48_L      _PK_L_(0x12, 0x48)
#define REG_SC_BK12_48_H      _PK_H_(0x12, 0x48)
#define REG_SC_BK12_49_L      _PK_L_(0x12, 0x49)
#define REG_SC_BK12_49_H      _PK_H_(0x12, 0x49)
#define REG_SC_BK12_4A_L      _PK_L_(0x12, 0x4A)
#define REG_SC_BK12_4A_H      _PK_H_(0x12, 0x4A)
#define REG_SC_BK12_4B_L      _PK_L_(0x12, 0x4B)
#define REG_SC_BK12_4B_H      _PK_H_(0x12, 0x4B)
#define REG_SC_BK12_4C_L      _PK_L_(0x12, 0x4C)
#define REG_SC_BK12_4C_H      _PK_H_(0x12, 0x4C)
#define REG_SC_BK12_4D_L      _PK_L_(0x12, 0x4D)
#define REG_SC_BK12_4D_H      _PK_H_(0x12, 0x4D)
#define REG_SC_BK12_4E_L      _PK_L_(0x12, 0x4E)
#define REG_SC_BK12_4E_H      _PK_H_(0x12, 0x4E)
#define REG_SC_BK12_4F_L      _PK_L_(0x12, 0x4F)
#define REG_SC_BK12_4F_H      _PK_H_(0x12, 0x4F)
#define REG_SC_BK12_50_L      _PK_L_(0x12, 0x50)
#define REG_SC_BK12_50_H      _PK_H_(0x12, 0x50)
#define REG_SC_BK12_51_L      _PK_L_(0x12, 0x51)
#define REG_SC_BK12_51_H      _PK_H_(0x12, 0x51)
#define REG_SC_BK12_52_L      _PK_L_(0x12, 0x52)
#define REG_SC_BK12_52_H      _PK_H_(0x12, 0x52)
#define REG_SC_BK12_53_L      _PK_L_(0x12, 0x53)
#define REG_SC_BK12_53_H      _PK_H_(0x12, 0x53)
#define REG_SC_BK12_54_L      _PK_L_(0x12, 0x54)
#define REG_SC_BK12_54_H      _PK_H_(0x12, 0x54)
#define REG_SC_BK12_55_L      _PK_L_(0x12, 0x55)
#define REG_SC_BK12_55_H      _PK_H_(0x12, 0x55)
#define REG_SC_BK12_56_L      _PK_L_(0x12, 0x56)
#define REG_SC_BK12_56_H      _PK_H_(0x12, 0x56)
#define REG_SC_BK12_57_L      _PK_L_(0x12, 0x57)
#define REG_SC_BK12_57_H      _PK_H_(0x12, 0x57)
#define REG_SC_BK12_58_L      _PK_L_(0x12, 0x58)
#define REG_SC_BK12_58_H      _PK_H_(0x12, 0x58)
#define REG_SC_BK12_59_L      _PK_L_(0x12, 0x59)
#define REG_SC_BK12_59_H      _PK_H_(0x12, 0x59)
#define REG_SC_BK12_5A_L      _PK_L_(0x12, 0x5A)
#define REG_SC_BK12_5A_H      _PK_H_(0x12, 0x5A)
#define REG_SC_BK12_5B_L      _PK_L_(0x12, 0x5B)
#define REG_SC_BK12_5B_H      _PK_H_(0x12, 0x5B)
#define REG_SC_BK12_5C_L      _PK_L_(0x12, 0x5C)
#define REG_SC_BK12_5C_H      _PK_H_(0x12, 0x5C)
#define REG_SC_BK12_5D_L      _PK_L_(0x12, 0x5D)
#define REG_SC_BK12_5D_H      _PK_H_(0x12, 0x5D)
#define REG_SC_BK12_5E_L      _PK_L_(0x12, 0x5E)
#define REG_SC_BK12_5E_H      _PK_H_(0x12, 0x5E)
#define REG_SC_BK12_5F_L      _PK_L_(0x12, 0x5F)
#define REG_SC_BK12_5F_H      _PK_H_(0x12, 0x5F)
#define REG_SC_BK12_60_L      _PK_L_(0x12, 0x60)
#define REG_SC_BK12_60_H      _PK_H_(0x12, 0x60)
#define REG_SC_BK12_61_L      _PK_L_(0x12, 0x61)
#define REG_SC_BK12_61_H      _PK_H_(0x12, 0x61)
#define REG_SC_BK12_62_L      _PK_L_(0x12, 0x62)
#define REG_SC_BK12_62_H      _PK_H_(0x12, 0x62)
#define REG_SC_BK12_63_L      _PK_L_(0x12, 0x63)
#define REG_SC_BK12_63_H      _PK_H_(0x12, 0x63)
#define REG_SC_BK12_64_L      _PK_L_(0x12, 0x64)
#define REG_SC_BK12_64_H      _PK_H_(0x12, 0x64)
#define REG_SC_BK12_65_L      _PK_L_(0x12, 0x65)
#define REG_SC_BK12_65_H      _PK_H_(0x12, 0x65)
#define REG_SC_BK12_66_L      _PK_L_(0x12, 0x66)
#define REG_SC_BK12_66_H      _PK_H_(0x12, 0x66)
#define REG_SC_BK12_67_L      _PK_L_(0x12, 0x67)
#define REG_SC_BK12_67_H      _PK_H_(0x12, 0x67)
#define REG_SC_BK12_68_L      _PK_L_(0x12, 0x68)
#define REG_SC_BK12_68_H      _PK_H_(0x12, 0x68)
#define REG_SC_BK12_69_L      _PK_L_(0x12, 0x69)
#define REG_SC_BK12_69_H      _PK_H_(0x12, 0x69)
#define REG_SC_BK12_6A_L      _PK_L_(0x12, 0x6A)
#define REG_SC_BK12_6A_H      _PK_H_(0x12, 0x6A)
#define REG_SC_BK12_6B_L      _PK_L_(0x12, 0x6B)
#define REG_SC_BK12_6B_H      _PK_H_(0x12, 0x6B)
#define REG_SC_BK12_6C_L      _PK_L_(0x12, 0x6C)
#define REG_SC_BK12_6C_H      _PK_H_(0x12, 0x6C)
#define REG_SC_BK12_6D_L      _PK_L_(0x12, 0x6D)
#define REG_SC_BK12_6D_H      _PK_H_(0x12, 0x6D)
#define REG_SC_BK12_6E_L      _PK_L_(0x12, 0x6E)
#define REG_SC_BK12_6E_H      _PK_H_(0x12, 0x6E)
#define REG_SC_BK12_6F_L      _PK_L_(0x12, 0x6F)
#define REG_SC_BK12_6F_H      _PK_H_(0x12, 0x6F)
#define REG_SC_BK12_70_L      _PK_L_(0x12, 0x70)
#define REG_SC_BK12_70_H      _PK_H_(0x12, 0x70)
#define REG_SC_BK12_71_L      _PK_L_(0x12, 0x71)
#define REG_SC_BK12_71_H      _PK_H_(0x12, 0x71)
#define REG_SC_BK12_72_L      _PK_L_(0x12, 0x72)
#define REG_SC_BK12_72_H      _PK_H_(0x12, 0x72)
#define REG_SC_BK12_73_L      _PK_L_(0x12, 0x73)
#define REG_SC_BK12_73_H      _PK_H_(0x12, 0x73)
#define REG_SC_BK12_74_L      _PK_L_(0x12, 0x74)
#define REG_SC_BK12_74_H      _PK_H_(0x12, 0x74)
#define REG_SC_BK12_75_L      _PK_L_(0x12, 0x75)
#define REG_SC_BK12_75_H      _PK_H_(0x12, 0x75)
#define REG_SC_BK12_76_L      _PK_L_(0x12, 0x76)
#define REG_SC_BK12_76_H      _PK_H_(0x12, 0x76)
#define REG_SC_BK12_77_L      _PK_L_(0x12, 0x77)
#define REG_SC_BK12_77_H      _PK_H_(0x12, 0x77)
#define REG_SC_BK12_78_L      _PK_L_(0x12, 0x78)
#define REG_SC_BK12_78_H      _PK_H_(0x12, 0x78)
#define REG_SC_BK12_79_L      _PK_L_(0x12, 0x79)
#define REG_SC_BK12_79_H      _PK_H_(0x12, 0x79)
#define REG_SC_BK12_7A_L      _PK_L_(0x12, 0x7A)
#define REG_SC_BK12_7A_H      _PK_H_(0x12, 0x7A)
#define REG_SC_BK12_7B_L      _PK_L_(0x12, 0x7B)
#define REG_SC_BK12_7B_H      _PK_H_(0x12, 0x7B)
#define REG_SC_BK12_7C_L      _PK_L_(0x12, 0x7C)
#define REG_SC_BK12_7C_H      _PK_H_(0x12, 0x7C)
#define REG_SC_BK12_7D_L      _PK_L_(0x12, 0x7D)
#define REG_SC_BK12_7D_H      _PK_H_(0x12, 0x7D)
#define REG_SC_BK12_7E_L      _PK_L_(0x12, 0x7E)
#define REG_SC_BK12_7E_H      _PK_H_(0x12, 0x7E)
#define REG_SC_BK12_7F_L      _PK_L_(0x12, 0x7F)
#define REG_SC_BK12_7F_H      _PK_H_(0x12, 0x7F)
//----------------------------------------------
#define REG_SC_BK13_00_L      _PK_L_(0x13, 0x00)
#define REG_SC_BK13_00_H      _PK_H_(0x13, 0x00)
#define REG_SC_BK13_01_L      _PK_L_(0x13, 0x01)
#define REG_SC_BK13_01_H      _PK_H_(0x13, 0x01)
#define REG_SC_BK13_02_L      _PK_L_(0x13, 0x02)
#define REG_SC_BK13_02_H      _PK_H_(0x13, 0x02)
#define REG_SC_BK13_03_L      _PK_L_(0x13, 0x03)
#define REG_SC_BK13_03_H      _PK_H_(0x13, 0x03)
#define REG_SC_BK13_04_L      _PK_L_(0x13, 0x04)
#define REG_SC_BK13_04_H      _PK_H_(0x13, 0x04)
#define REG_SC_BK13_05_L      _PK_L_(0x13, 0x05)
#define REG_SC_BK13_05_H      _PK_H_(0x13, 0x05)
#define REG_SC_BK13_06_L      _PK_L_(0x13, 0x06)
#define REG_SC_BK13_06_H      _PK_H_(0x13, 0x06)
#define REG_SC_BK13_07_L      _PK_L_(0x13, 0x07)
#define REG_SC_BK13_07_H      _PK_H_(0x13, 0x07)
#define REG_SC_BK13_08_L      _PK_L_(0x13, 0x08)
#define REG_SC_BK13_08_H      _PK_H_(0x13, 0x08)
#define REG_SC_BK13_09_L      _PK_L_(0x13, 0x09)
#define REG_SC_BK13_09_H      _PK_H_(0x13, 0x09)
#define REG_SC_BK13_0A_L      _PK_L_(0x13, 0x0A)
#define REG_SC_BK13_0A_H      _PK_H_(0x13, 0x0A)
#define REG_SC_BK13_0B_L      _PK_L_(0x13, 0x0B)
#define REG_SC_BK13_0B_H      _PK_H_(0x13, 0x0B)
#define REG_SC_BK13_0C_L      _PK_L_(0x13, 0x0C)
#define REG_SC_BK13_0C_H      _PK_H_(0x13, 0x0C)
#define REG_SC_BK13_0D_L      _PK_L_(0x13, 0x0D)
#define REG_SC_BK13_0D_H      _PK_H_(0x13, 0x0D)
#define REG_SC_BK13_0E_L      _PK_L_(0x13, 0x0E)
#define REG_SC_BK13_0E_H      _PK_H_(0x13, 0x0E)
#define REG_SC_BK13_0F_L      _PK_L_(0x13, 0x0F)
#define REG_SC_BK13_0F_H      _PK_H_(0x13, 0x0F)
#define REG_SC_BK13_10_L      _PK_L_(0x13, 0x10)
#define REG_SC_BK13_10_H      _PK_H_(0x13, 0x10)
#define REG_SC_BK13_11_L      _PK_L_(0x13, 0x11)
#define REG_SC_BK13_11_H      _PK_H_(0x13, 0x11)
#define REG_SC_BK13_12_L      _PK_L_(0x13, 0x12)
#define REG_SC_BK13_12_H      _PK_H_(0x13, 0x12)
#define REG_SC_BK13_13_L      _PK_L_(0x13, 0x13)
#define REG_SC_BK13_13_H      _PK_H_(0x13, 0x13)
#define REG_SC_BK13_14_L      _PK_L_(0x13, 0x14)
#define REG_SC_BK13_14_H      _PK_H_(0x13, 0x14)
#define REG_SC_BK13_15_L      _PK_L_(0x13, 0x15)
#define REG_SC_BK13_15_H      _PK_H_(0x13, 0x15)
#define REG_SC_BK13_16_L      _PK_L_(0x13, 0x16)
#define REG_SC_BK13_16_H      _PK_H_(0x13, 0x16)
#define REG_SC_BK13_17_L      _PK_L_(0x13, 0x17)
#define REG_SC_BK13_17_H      _PK_H_(0x13, 0x17)
#define REG_SC_BK13_18_L      _PK_L_(0x13, 0x18)
#define REG_SC_BK13_18_H      _PK_H_(0x13, 0x18)
#define REG_SC_BK13_19_L      _PK_L_(0x13, 0x19)
#define REG_SC_BK13_19_H      _PK_H_(0x13, 0x19)
#define REG_SC_BK13_1A_L      _PK_L_(0x13, 0x1A)
#define REG_SC_BK13_1A_H      _PK_H_(0x13, 0x1A)
#define REG_SC_BK13_1B_L      _PK_L_(0x13, 0x1B)
#define REG_SC_BK13_1B_H      _PK_H_(0x13, 0x1B)
#define REG_SC_BK13_1C_L      _PK_L_(0x13, 0x1C)
#define REG_SC_BK13_1C_H      _PK_H_(0x13, 0x1C)
#define REG_SC_BK13_1D_L      _PK_L_(0x13, 0x1D)
#define REG_SC_BK13_1D_H      _PK_H_(0x13, 0x1D)
#define REG_SC_BK13_1E_L      _PK_L_(0x13, 0x1E)
#define REG_SC_BK13_1E_H      _PK_H_(0x13, 0x1E)
#define REG_SC_BK13_1F_L      _PK_L_(0x13, 0x1F)
#define REG_SC_BK13_1F_H      _PK_H_(0x13, 0x1F)
#define REG_SC_BK13_20_L      _PK_L_(0x13, 0x20)
#define REG_SC_BK13_20_H      _PK_H_(0x13, 0x20)
#define REG_SC_BK13_21_L      _PK_L_(0x13, 0x21)
#define REG_SC_BK13_21_H      _PK_H_(0x13, 0x21)
#define REG_SC_BK13_22_L      _PK_L_(0x13, 0x22)
#define REG_SC_BK13_22_H      _PK_H_(0x13, 0x22)
#define REG_SC_BK13_23_L      _PK_L_(0x13, 0x23)
#define REG_SC_BK13_23_H      _PK_H_(0x13, 0x23)
#define REG_SC_BK13_24_L      _PK_L_(0x13, 0x24)
#define REG_SC_BK13_24_H      _PK_H_(0x13, 0x24)
#define REG_SC_BK13_25_L      _PK_L_(0x13, 0x25)
#define REG_SC_BK13_25_H      _PK_H_(0x13, 0x25)
#define REG_SC_BK13_26_L      _PK_L_(0x13, 0x26)
#define REG_SC_BK13_26_H      _PK_H_(0x13, 0x26)
#define REG_SC_BK13_27_L      _PK_L_(0x13, 0x27)
#define REG_SC_BK13_27_H      _PK_H_(0x13, 0x27)
#define REG_SC_BK13_28_L      _PK_L_(0x13, 0x28)
#define REG_SC_BK13_28_H      _PK_H_(0x13, 0x28)
#define REG_SC_BK13_29_L      _PK_L_(0x13, 0x29)
#define REG_SC_BK13_29_H      _PK_H_(0x13, 0x29)
#define REG_SC_BK13_2A_L      _PK_L_(0x13, 0x2A)
#define REG_SC_BK13_2A_H      _PK_H_(0x13, 0x2A)
#define REG_SC_BK13_2B_L      _PK_L_(0x13, 0x2B)
#define REG_SC_BK13_2B_H      _PK_H_(0x13, 0x2B)
#define REG_SC_BK13_2C_L      _PK_L_(0x13, 0x2C)
#define REG_SC_BK13_2C_H      _PK_H_(0x13, 0x2C)
#define REG_SC_BK13_2D_L      _PK_L_(0x13, 0x2D)
#define REG_SC_BK13_2D_H      _PK_H_(0x13, 0x2D)
#define REG_SC_BK13_2E_L      _PK_L_(0x13, 0x2E)
#define REG_SC_BK13_2E_H      _PK_H_(0x13, 0x2E)
#define REG_SC_BK13_2F_L      _PK_L_(0x13, 0x2F)
#define REG_SC_BK13_2F_H      _PK_H_(0x13, 0x2F)
#define REG_SC_BK13_30_L      _PK_L_(0x13, 0x30)
#define REG_SC_BK13_30_H      _PK_H_(0x13, 0x30)
#define REG_SC_BK13_31_L      _PK_L_(0x13, 0x31)
#define REG_SC_BK13_31_H      _PK_H_(0x13, 0x31)
#define REG_SC_BK13_32_L      _PK_L_(0x13, 0x32)
#define REG_SC_BK13_32_H      _PK_H_(0x13, 0x32)
#define REG_SC_BK13_33_L      _PK_L_(0x13, 0x33)
#define REG_SC_BK13_33_H      _PK_H_(0x13, 0x33)
#define REG_SC_BK13_34_L      _PK_L_(0x13, 0x34)
#define REG_SC_BK13_34_H      _PK_H_(0x13, 0x34)
#define REG_SC_BK13_35_L      _PK_L_(0x13, 0x35)
#define REG_SC_BK13_35_H      _PK_H_(0x13, 0x35)
#define REG_SC_BK13_36_L      _PK_L_(0x13, 0x36)
#define REG_SC_BK13_36_H      _PK_H_(0x13, 0x36)
#define REG_SC_BK13_37_L      _PK_L_(0x13, 0x37)
#define REG_SC_BK13_37_H      _PK_H_(0x13, 0x37)
#define REG_SC_BK13_38_L      _PK_L_(0x13, 0x38)
#define REG_SC_BK13_38_H      _PK_H_(0x13, 0x38)
#define REG_SC_BK13_39_L      _PK_L_(0x13, 0x39)
#define REG_SC_BK13_39_H      _PK_H_(0x13, 0x39)
#define REG_SC_BK13_3A_L      _PK_L_(0x13, 0x3A)
#define REG_SC_BK13_3A_H      _PK_H_(0x13, 0x3A)
#define REG_SC_BK13_3B_L      _PK_L_(0x13, 0x3B)
#define REG_SC_BK13_3B_H      _PK_H_(0x13, 0x3B)
#define REG_SC_BK13_3C_L      _PK_L_(0x13, 0x3C)
#define REG_SC_BK13_3C_H      _PK_H_(0x13, 0x3C)
#define REG_SC_BK13_3D_L      _PK_L_(0x13, 0x3D)
#define REG_SC_BK13_3D_H      _PK_H_(0x13, 0x3D)
#define REG_SC_BK13_3E_L      _PK_L_(0x13, 0x3E)
#define REG_SC_BK13_3E_H      _PK_H_(0x13, 0x3E)
#define REG_SC_BK13_3F_L      _PK_L_(0x13, 0x3F)
#define REG_SC_BK13_3F_H      _PK_H_(0x13, 0x3F)
#define REG_SC_BK13_40_L      _PK_L_(0x13, 0x40)
#define REG_SC_BK13_40_H      _PK_H_(0x13, 0x40)
#define REG_SC_BK13_41_L      _PK_L_(0x13, 0x41)
#define REG_SC_BK13_41_H      _PK_H_(0x13, 0x41)
#define REG_SC_BK13_42_L      _PK_L_(0x13, 0x42)
#define REG_SC_BK13_42_H      _PK_H_(0x13, 0x42)
#define REG_SC_BK13_43_L      _PK_L_(0x13, 0x43)
#define REG_SC_BK13_43_H      _PK_H_(0x13, 0x43)
#define REG_SC_BK13_44_L      _PK_L_(0x13, 0x44)
#define REG_SC_BK13_44_H      _PK_H_(0x13, 0x44)
#define REG_SC_BK13_45_L      _PK_L_(0x13, 0x45)
#define REG_SC_BK13_45_H      _PK_H_(0x13, 0x45)
#define REG_SC_BK13_46_L      _PK_L_(0x13, 0x46)
#define REG_SC_BK13_46_H      _PK_H_(0x13, 0x46)
#define REG_SC_BK13_47_L      _PK_L_(0x13, 0x47)
#define REG_SC_BK13_47_H      _PK_H_(0x13, 0x47)
#define REG_SC_BK13_48_L      _PK_L_(0x13, 0x48)
#define REG_SC_BK13_48_H      _PK_H_(0x13, 0x48)
#define REG_SC_BK13_49_L      _PK_L_(0x13, 0x49)
#define REG_SC_BK13_49_H      _PK_H_(0x13, 0x49)
#define REG_SC_BK13_4A_L      _PK_L_(0x13, 0x4A)
#define REG_SC_BK13_4A_H      _PK_H_(0x13, 0x4A)
#define REG_SC_BK13_4B_L      _PK_L_(0x13, 0x4B)
#define REG_SC_BK13_4B_H      _PK_H_(0x13, 0x4B)
#define REG_SC_BK13_4C_L      _PK_L_(0x13, 0x4C)
#define REG_SC_BK13_4C_H      _PK_H_(0x13, 0x4C)
#define REG_SC_BK13_4D_L      _PK_L_(0x13, 0x4D)
#define REG_SC_BK13_4D_H      _PK_H_(0x13, 0x4D)
#define REG_SC_BK13_4E_L      _PK_L_(0x13, 0x4E)
#define REG_SC_BK13_4E_H      _PK_H_(0x13, 0x4E)
#define REG_SC_BK13_4F_L      _PK_L_(0x13, 0x4F)
#define REG_SC_BK13_4F_H      _PK_H_(0x13, 0x4F)
#define REG_SC_BK13_50_L      _PK_L_(0x13, 0x50)
#define REG_SC_BK13_50_H      _PK_H_(0x13, 0x50)
#define REG_SC_BK13_51_L      _PK_L_(0x13, 0x51)
#define REG_SC_BK13_51_H      _PK_H_(0x13, 0x51)
#define REG_SC_BK13_52_L      _PK_L_(0x13, 0x52)
#define REG_SC_BK13_52_H      _PK_H_(0x13, 0x52)
#define REG_SC_BK13_53_L      _PK_L_(0x13, 0x53)
#define REG_SC_BK13_53_H      _PK_H_(0x13, 0x53)
#define REG_SC_BK13_54_L      _PK_L_(0x13, 0x54)
#define REG_SC_BK13_54_H      _PK_H_(0x13, 0x54)
#define REG_SC_BK13_55_L      _PK_L_(0x13, 0x55)
#define REG_SC_BK13_55_H      _PK_H_(0x13, 0x55)
#define REG_SC_BK13_56_L      _PK_L_(0x13, 0x56)
#define REG_SC_BK13_56_H      _PK_H_(0x13, 0x56)
#define REG_SC_BK13_57_L      _PK_L_(0x13, 0x57)
#define REG_SC_BK13_57_H      _PK_H_(0x13, 0x57)
#define REG_SC_BK13_58_L      _PK_L_(0x13, 0x58)
#define REG_SC_BK13_58_H      _PK_H_(0x13, 0x58)
#define REG_SC_BK13_59_L      _PK_L_(0x13, 0x59)
#define REG_SC_BK13_59_H      _PK_H_(0x13, 0x59)
#define REG_SC_BK13_5A_L      _PK_L_(0x13, 0x5A)
#define REG_SC_BK13_5A_H      _PK_H_(0x13, 0x5A)
#define REG_SC_BK13_5B_L      _PK_L_(0x13, 0x5B)
#define REG_SC_BK13_5B_H      _PK_H_(0x13, 0x5B)
#define REG_SC_BK13_5C_L      _PK_L_(0x13, 0x5C)
#define REG_SC_BK13_5C_H      _PK_H_(0x13, 0x5C)
#define REG_SC_BK13_5D_L      _PK_L_(0x13, 0x5D)
#define REG_SC_BK13_5D_H      _PK_H_(0x13, 0x5D)
#define REG_SC_BK13_5E_L      _PK_L_(0x13, 0x5E)
#define REG_SC_BK13_5E_H      _PK_H_(0x13, 0x5E)
#define REG_SC_BK13_5F_L      _PK_L_(0x13, 0x5F)
#define REG_SC_BK13_5F_H      _PK_H_(0x13, 0x5F)
#define REG_SC_BK13_60_L      _PK_L_(0x13, 0x60)
#define REG_SC_BK13_60_H      _PK_H_(0x13, 0x60)
#define REG_SC_BK13_61_L      _PK_L_(0x13, 0x61)
#define REG_SC_BK13_61_H      _PK_H_(0x13, 0x61)
#define REG_SC_BK13_62_L      _PK_L_(0x13, 0x62)
#define REG_SC_BK13_62_H      _PK_H_(0x13, 0x62)
#define REG_SC_BK13_63_L      _PK_L_(0x13, 0x63)
#define REG_SC_BK13_63_H      _PK_H_(0x13, 0x63)
#define REG_SC_BK13_64_L      _PK_L_(0x13, 0x64)
#define REG_SC_BK13_64_H      _PK_H_(0x13, 0x64)
#define REG_SC_BK13_65_L      _PK_L_(0x13, 0x65)
#define REG_SC_BK13_65_H      _PK_H_(0x13, 0x65)
#define REG_SC_BK13_66_L      _PK_L_(0x13, 0x66)
#define REG_SC_BK13_66_H      _PK_H_(0x13, 0x66)
#define REG_SC_BK13_67_L      _PK_L_(0x13, 0x67)
#define REG_SC_BK13_67_H      _PK_H_(0x13, 0x67)
#define REG_SC_BK13_68_L      _PK_L_(0x13, 0x68)
#define REG_SC_BK13_68_H      _PK_H_(0x13, 0x68)
#define REG_SC_BK13_69_L      _PK_L_(0x13, 0x69)
#define REG_SC_BK13_69_H      _PK_H_(0x13, 0x69)
#define REG_SC_BK13_6A_L      _PK_L_(0x13, 0x6A)
#define REG_SC_BK13_6A_H      _PK_H_(0x13, 0x6A)
#define REG_SC_BK13_6B_L      _PK_L_(0x13, 0x6B)
#define REG_SC_BK13_6B_H      _PK_H_(0x13, 0x6B)
#define REG_SC_BK13_6C_L      _PK_L_(0x13, 0x6C)
#define REG_SC_BK13_6C_H      _PK_H_(0x13, 0x6C)
#define REG_SC_BK13_6D_L      _PK_L_(0x13, 0x6D)
#define REG_SC_BK13_6D_H      _PK_H_(0x13, 0x6D)
#define REG_SC_BK13_6E_L      _PK_L_(0x13, 0x6E)
#define REG_SC_BK13_6E_H      _PK_H_(0x13, 0x6E)
#define REG_SC_BK13_6F_L      _PK_L_(0x13, 0x6F)
#define REG_SC_BK13_6F_H      _PK_H_(0x13, 0x6F)
#define REG_SC_BK13_70_L      _PK_L_(0x13, 0x70)
#define REG_SC_BK13_70_H      _PK_H_(0x13, 0x70)
#define REG_SC_BK13_71_L      _PK_L_(0x13, 0x71)
#define REG_SC_BK13_71_H      _PK_H_(0x13, 0x71)
#define REG_SC_BK13_72_L      _PK_L_(0x13, 0x72)
#define REG_SC_BK13_72_H      _PK_H_(0x13, 0x72)
#define REG_SC_BK13_73_L      _PK_L_(0x13, 0x73)
#define REG_SC_BK13_73_H      _PK_H_(0x13, 0x73)
#define REG_SC_BK13_74_L      _PK_L_(0x13, 0x74)
#define REG_SC_BK13_74_H      _PK_H_(0x13, 0x74)
#define REG_SC_BK13_75_L      _PK_L_(0x13, 0x75)
#define REG_SC_BK13_75_H      _PK_H_(0x13, 0x75)
#define REG_SC_BK13_76_L      _PK_L_(0x13, 0x76)
#define REG_SC_BK13_76_H      _PK_H_(0x13, 0x76)
#define REG_SC_BK13_77_L      _PK_L_(0x13, 0x77)
#define REG_SC_BK13_77_H      _PK_H_(0x13, 0x77)
#define REG_SC_BK13_78_L      _PK_L_(0x13, 0x78)
#define REG_SC_BK13_78_H      _PK_H_(0x13, 0x78)
#define REG_SC_BK13_79_L      _PK_L_(0x13, 0x79)
#define REG_SC_BK13_79_H      _PK_H_(0x13, 0x79)
#define REG_SC_BK13_7A_L      _PK_L_(0x13, 0x7A)
#define REG_SC_BK13_7A_H      _PK_H_(0x13, 0x7A)
#define REG_SC_BK13_7B_L      _PK_L_(0x13, 0x7B)
#define REG_SC_BK13_7B_H      _PK_H_(0x13, 0x7B)
#define REG_SC_BK13_7C_L      _PK_L_(0x13, 0x7C)
#define REG_SC_BK13_7C_H      _PK_H_(0x13, 0x7C)
#define REG_SC_BK13_7D_L      _PK_L_(0x13, 0x7D)
#define REG_SC_BK13_7D_H      _PK_H_(0x13, 0x7D)
#define REG_SC_BK13_7E_L      _PK_L_(0x13, 0x7E)
#define REG_SC_BK13_7E_H      _PK_H_(0x13, 0x7E)
#define REG_SC_BK13_7F_L      _PK_L_(0x13, 0x7F)
#define REG_SC_BK13_7F_H      _PK_H_(0x13, 0x7F)
//----------------------------------------------
#define REG_SC_BK14_00_L      _PK_L_(0x14, 0x00)
#define REG_SC_BK14_00_H      _PK_H_(0x14, 0x00)
#define REG_SC_BK14_01_L      _PK_L_(0x14, 0x01)
#define REG_SC_BK14_01_H      _PK_H_(0x14, 0x01)
#define REG_SC_BK14_02_L      _PK_L_(0x14, 0x02)
#define REG_SC_BK14_02_H      _PK_H_(0x14, 0x02)
#define REG_SC_BK14_03_L      _PK_L_(0x14, 0x03)
#define REG_SC_BK14_03_H      _PK_H_(0x14, 0x03)
#define REG_SC_BK14_04_L      _PK_L_(0x14, 0x04)
#define REG_SC_BK14_04_H      _PK_H_(0x14, 0x04)
#define REG_SC_BK14_05_L      _PK_L_(0x14, 0x05)
#define REG_SC_BK14_05_H      _PK_H_(0x14, 0x05)
#define REG_SC_BK14_06_L      _PK_L_(0x14, 0x06)
#define REG_SC_BK14_06_H      _PK_H_(0x14, 0x06)
#define REG_SC_BK14_07_L      _PK_L_(0x14, 0x07)
#define REG_SC_BK14_07_H      _PK_H_(0x14, 0x07)
#define REG_SC_BK14_08_L      _PK_L_(0x14, 0x08)
#define REG_SC_BK14_08_H      _PK_H_(0x14, 0x08)
#define REG_SC_BK14_09_L      _PK_L_(0x14, 0x09)
#define REG_SC_BK14_09_H      _PK_H_(0x14, 0x09)
#define REG_SC_BK14_0A_L      _PK_L_(0x14, 0x0A)
#define REG_SC_BK14_0A_H      _PK_H_(0x14, 0x0A)
#define REG_SC_BK14_0B_L      _PK_L_(0x14, 0x0B)
#define REG_SC_BK14_0B_H      _PK_H_(0x14, 0x0B)
#define REG_SC_BK14_0C_L      _PK_L_(0x14, 0x0C)
#define REG_SC_BK14_0C_H      _PK_H_(0x14, 0x0C)
#define REG_SC_BK14_0D_L      _PK_L_(0x14, 0x0D)
#define REG_SC_BK14_0D_H      _PK_H_(0x14, 0x0D)
#define REG_SC_BK14_0E_L      _PK_L_(0x14, 0x0E)
#define REG_SC_BK14_0E_H      _PK_H_(0x14, 0x0E)
#define REG_SC_BK14_0F_L      _PK_L_(0x14, 0x0F)
#define REG_SC_BK14_0F_H      _PK_H_(0x14, 0x0F)
#define REG_SC_BK14_10_L      _PK_L_(0x14, 0x10)
#define REG_SC_BK14_10_H      _PK_H_(0x14, 0x10)
#define REG_SC_BK14_11_L      _PK_L_(0x14, 0x11)
#define REG_SC_BK14_11_H      _PK_H_(0x14, 0x11)
#define REG_SC_BK14_12_L      _PK_L_(0x14, 0x12)
#define REG_SC_BK14_12_H      _PK_H_(0x14, 0x12)
#define REG_SC_BK14_13_L      _PK_L_(0x14, 0x13)
#define REG_SC_BK14_13_H      _PK_H_(0x14, 0x13)
#define REG_SC_BK14_14_L      _PK_L_(0x14, 0x14)
#define REG_SC_BK14_14_H      _PK_H_(0x14, 0x14)
#define REG_SC_BK14_15_L      _PK_L_(0x14, 0x15)
#define REG_SC_BK14_15_H      _PK_H_(0x14, 0x15)
#define REG_SC_BK14_16_L      _PK_L_(0x14, 0x16)
#define REG_SC_BK14_16_H      _PK_H_(0x14, 0x16)
#define REG_SC_BK14_17_L      _PK_L_(0x14, 0x17)
#define REG_SC_BK14_17_H      _PK_H_(0x14, 0x17)
#define REG_SC_BK14_18_L      _PK_L_(0x14, 0x18)
#define REG_SC_BK14_18_H      _PK_H_(0x14, 0x18)
#define REG_SC_BK14_19_L      _PK_L_(0x14, 0x19)
#define REG_SC_BK14_19_H      _PK_H_(0x14, 0x19)
#define REG_SC_BK14_1A_L      _PK_L_(0x14, 0x1A)
#define REG_SC_BK14_1A_H      _PK_H_(0x14, 0x1A)
#define REG_SC_BK14_1B_L      _PK_L_(0x14, 0x1B)
#define REG_SC_BK14_1B_H      _PK_H_(0x14, 0x1B)
#define REG_SC_BK14_1C_L      _PK_L_(0x14, 0x1C)
#define REG_SC_BK14_1C_H      _PK_H_(0x14, 0x1C)
#define REG_SC_BK14_1D_L      _PK_L_(0x14, 0x1D)
#define REG_SC_BK14_1D_H      _PK_H_(0x14, 0x1D)
#define REG_SC_BK14_1E_L      _PK_L_(0x14, 0x1E)
#define REG_SC_BK14_1E_H      _PK_H_(0x14, 0x1E)
#define REG_SC_BK14_1F_L      _PK_L_(0x14, 0x1F)
#define REG_SC_BK14_1F_H      _PK_H_(0x14, 0x1F)
#define REG_SC_BK14_20_L      _PK_L_(0x14, 0x20)
#define REG_SC_BK14_20_H      _PK_H_(0x14, 0x20)
#define REG_SC_BK14_21_L      _PK_L_(0x14, 0x21)
#define REG_SC_BK14_21_H      _PK_H_(0x14, 0x21)
#define REG_SC_BK14_22_L      _PK_L_(0x14, 0x22)
#define REG_SC_BK14_22_H      _PK_H_(0x14, 0x22)
#define REG_SC_BK14_23_L      _PK_L_(0x14, 0x23)
#define REG_SC_BK14_23_H      _PK_H_(0x14, 0x23)
#define REG_SC_BK14_24_L      _PK_L_(0x14, 0x24)
#define REG_SC_BK14_24_H      _PK_H_(0x14, 0x24)
#define REG_SC_BK14_25_L      _PK_L_(0x14, 0x25)
#define REG_SC_BK14_25_H      _PK_H_(0x14, 0x25)
#define REG_SC_BK14_26_L      _PK_L_(0x14, 0x26)
#define REG_SC_BK14_26_H      _PK_H_(0x14, 0x26)
#define REG_SC_BK14_27_L      _PK_L_(0x14, 0x27)
#define REG_SC_BK14_27_H      _PK_H_(0x14, 0x27)
#define REG_SC_BK14_28_L      _PK_L_(0x14, 0x28)
#define REG_SC_BK14_28_H      _PK_H_(0x14, 0x28)
#define REG_SC_BK14_29_L      _PK_L_(0x14, 0x29)
#define REG_SC_BK14_29_H      _PK_H_(0x14, 0x29)
#define REG_SC_BK14_2A_L      _PK_L_(0x14, 0x2A)
#define REG_SC_BK14_2A_H      _PK_H_(0x14, 0x2A)
#define REG_SC_BK14_2B_L      _PK_L_(0x14, 0x2B)
#define REG_SC_BK14_2B_H      _PK_H_(0x14, 0x2B)
#define REG_SC_BK14_2C_L      _PK_L_(0x14, 0x2C)
#define REG_SC_BK14_2C_H      _PK_H_(0x14, 0x2C)
#define REG_SC_BK14_2D_L      _PK_L_(0x14, 0x2D)
#define REG_SC_BK14_2D_H      _PK_H_(0x14, 0x2D)
#define REG_SC_BK14_2E_L      _PK_L_(0x14, 0x2E)
#define REG_SC_BK14_2E_H      _PK_H_(0x14, 0x2E)
#define REG_SC_BK14_2F_L      _PK_L_(0x14, 0x2F)
#define REG_SC_BK14_2F_H      _PK_H_(0x14, 0x2F)
#define REG_SC_BK14_30_L      _PK_L_(0x14, 0x30)
#define REG_SC_BK14_30_H      _PK_H_(0x14, 0x30)
#define REG_SC_BK14_31_L      _PK_L_(0x14, 0x31)
#define REG_SC_BK14_31_H      _PK_H_(0x14, 0x31)
#define REG_SC_BK14_32_L      _PK_L_(0x14, 0x32)
#define REG_SC_BK14_32_H      _PK_H_(0x14, 0x32)
#define REG_SC_BK14_33_L      _PK_L_(0x14, 0x33)
#define REG_SC_BK14_33_H      _PK_H_(0x14, 0x33)
#define REG_SC_BK14_34_L      _PK_L_(0x14, 0x34)
#define REG_SC_BK14_34_H      _PK_H_(0x14, 0x34)
#define REG_SC_BK14_35_L      _PK_L_(0x14, 0x35)
#define REG_SC_BK14_35_H      _PK_H_(0x14, 0x35)
#define REG_SC_BK14_36_L      _PK_L_(0x14, 0x36)
#define REG_SC_BK14_36_H      _PK_H_(0x14, 0x36)
#define REG_SC_BK14_37_L      _PK_L_(0x14, 0x37)
#define REG_SC_BK14_37_H      _PK_H_(0x14, 0x37)
#define REG_SC_BK14_38_L      _PK_L_(0x14, 0x38)
#define REG_SC_BK14_38_H      _PK_H_(0x14, 0x38)
#define REG_SC_BK14_39_L      _PK_L_(0x14, 0x39)
#define REG_SC_BK14_39_H      _PK_H_(0x14, 0x39)
#define REG_SC_BK14_3A_L      _PK_L_(0x14, 0x3A)
#define REG_SC_BK14_3A_H      _PK_H_(0x14, 0x3A)
#define REG_SC_BK14_3B_L      _PK_L_(0x14, 0x3B)
#define REG_SC_BK14_3B_H      _PK_H_(0x14, 0x3B)
#define REG_SC_BK14_3C_L      _PK_L_(0x14, 0x3C)
#define REG_SC_BK14_3C_H      _PK_H_(0x14, 0x3C)
#define REG_SC_BK14_3D_L      _PK_L_(0x14, 0x3D)
#define REG_SC_BK14_3D_H      _PK_H_(0x14, 0x3D)
#define REG_SC_BK14_3E_L      _PK_L_(0x14, 0x3E)
#define REG_SC_BK14_3E_H      _PK_H_(0x14, 0x3E)
#define REG_SC_BK14_3F_L      _PK_L_(0x14, 0x3F)
#define REG_SC_BK14_3F_H      _PK_H_(0x14, 0x3F)
#define REG_SC_BK14_40_L      _PK_L_(0x14, 0x40)
#define REG_SC_BK14_40_H      _PK_H_(0x14, 0x40)
#define REG_SC_BK14_41_L      _PK_L_(0x14, 0x41)
#define REG_SC_BK14_41_H      _PK_H_(0x14, 0x41)
#define REG_SC_BK14_42_L      _PK_L_(0x14, 0x42)
#define REG_SC_BK14_42_H      _PK_H_(0x14, 0x42)
#define REG_SC_BK14_43_L      _PK_L_(0x14, 0x43)
#define REG_SC_BK14_43_H      _PK_H_(0x14, 0x43)
#define REG_SC_BK14_44_L      _PK_L_(0x14, 0x44)
#define REG_SC_BK14_44_H      _PK_H_(0x14, 0x44)
#define REG_SC_BK14_45_L      _PK_L_(0x14, 0x45)
#define REG_SC_BK14_45_H      _PK_H_(0x14, 0x45)
#define REG_SC_BK14_46_L      _PK_L_(0x14, 0x46)
#define REG_SC_BK14_46_H      _PK_H_(0x14, 0x46)
#define REG_SC_BK14_47_L      _PK_L_(0x14, 0x47)
#define REG_SC_BK14_47_H      _PK_H_(0x14, 0x47)
#define REG_SC_BK14_48_L      _PK_L_(0x14, 0x48)
#define REG_SC_BK14_48_H      _PK_H_(0x14, 0x48)
#define REG_SC_BK14_49_L      _PK_L_(0x14, 0x49)
#define REG_SC_BK14_49_H      _PK_H_(0x14, 0x49)
#define REG_SC_BK14_4A_L      _PK_L_(0x14, 0x4A)
#define REG_SC_BK14_4A_H      _PK_H_(0x14, 0x4A)
#define REG_SC_BK14_4B_L      _PK_L_(0x14, 0x4B)
#define REG_SC_BK14_4B_H      _PK_H_(0x14, 0x4B)
#define REG_SC_BK14_4C_L      _PK_L_(0x14, 0x4C)
#define REG_SC_BK14_4C_H      _PK_H_(0x14, 0x4C)
#define REG_SC_BK14_4D_L      _PK_L_(0x14, 0x4D)
#define REG_SC_BK14_4D_H      _PK_H_(0x14, 0x4D)
#define REG_SC_BK14_4E_L      _PK_L_(0x14, 0x4E)
#define REG_SC_BK14_4E_H      _PK_H_(0x14, 0x4E)
#define REG_SC_BK14_4F_L      _PK_L_(0x14, 0x4F)
#define REG_SC_BK14_4F_H      _PK_H_(0x14, 0x4F)
#define REG_SC_BK14_50_L      _PK_L_(0x14, 0x50)
#define REG_SC_BK14_50_H      _PK_H_(0x14, 0x50)
#define REG_SC_BK14_51_L      _PK_L_(0x14, 0x51)
#define REG_SC_BK14_51_H      _PK_H_(0x14, 0x51)
#define REG_SC_BK14_52_L      _PK_L_(0x14, 0x52)
#define REG_SC_BK14_52_H      _PK_H_(0x14, 0x52)
#define REG_SC_BK14_53_L      _PK_L_(0x14, 0x53)
#define REG_SC_BK14_53_H      _PK_H_(0x14, 0x53)
#define REG_SC_BK14_54_L      _PK_L_(0x14, 0x54)
#define REG_SC_BK14_54_H      _PK_H_(0x14, 0x54)
#define REG_SC_BK14_55_L      _PK_L_(0x14, 0x55)
#define REG_SC_BK14_55_H      _PK_H_(0x14, 0x55)
#define REG_SC_BK14_56_L      _PK_L_(0x14, 0x56)
#define REG_SC_BK14_56_H      _PK_H_(0x14, 0x56)
#define REG_SC_BK14_57_L      _PK_L_(0x14, 0x57)
#define REG_SC_BK14_57_H      _PK_H_(0x14, 0x57)
#define REG_SC_BK14_58_L      _PK_L_(0x14, 0x58)
#define REG_SC_BK14_58_H      _PK_H_(0x14, 0x58)
#define REG_SC_BK14_59_L      _PK_L_(0x14, 0x59)
#define REG_SC_BK14_59_H      _PK_H_(0x14, 0x59)
#define REG_SC_BK14_5A_L      _PK_L_(0x14, 0x5A)
#define REG_SC_BK14_5A_H      _PK_H_(0x14, 0x5A)
#define REG_SC_BK14_5B_L      _PK_L_(0x14, 0x5B)
#define REG_SC_BK14_5B_H      _PK_H_(0x14, 0x5B)
#define REG_SC_BK14_5C_L      _PK_L_(0x14, 0x5C)
#define REG_SC_BK14_5C_H      _PK_H_(0x14, 0x5C)
#define REG_SC_BK14_5D_L      _PK_L_(0x14, 0x5D)
#define REG_SC_BK14_5D_H      _PK_H_(0x14, 0x5D)
#define REG_SC_BK14_5E_L      _PK_L_(0x14, 0x5E)
#define REG_SC_BK14_5E_H      _PK_H_(0x14, 0x5E)
#define REG_SC_BK14_5F_L      _PK_L_(0x14, 0x5F)
#define REG_SC_BK14_5F_H      _PK_H_(0x14, 0x5F)
#define REG_SC_BK14_60_L      _PK_L_(0x14, 0x60)
#define REG_SC_BK14_60_H      _PK_H_(0x14, 0x60)
#define REG_SC_BK14_61_L      _PK_L_(0x14, 0x61)
#define REG_SC_BK14_61_H      _PK_H_(0x14, 0x61)
#define REG_SC_BK14_62_L      _PK_L_(0x14, 0x62)
#define REG_SC_BK14_62_H      _PK_H_(0x14, 0x62)
#define REG_SC_BK14_63_L      _PK_L_(0x14, 0x63)
#define REG_SC_BK14_63_H      _PK_H_(0x14, 0x63)
#define REG_SC_BK14_64_L      _PK_L_(0x14, 0x64)
#define REG_SC_BK14_64_H      _PK_H_(0x14, 0x64)
#define REG_SC_BK14_65_L      _PK_L_(0x14, 0x65)
#define REG_SC_BK14_65_H      _PK_H_(0x14, 0x65)
#define REG_SC_BK14_66_L      _PK_L_(0x14, 0x66)
#define REG_SC_BK14_66_H      _PK_H_(0x14, 0x66)
#define REG_SC_BK14_67_L      _PK_L_(0x14, 0x67)
#define REG_SC_BK14_67_H      _PK_H_(0x14, 0x67)
#define REG_SC_BK14_68_L      _PK_L_(0x14, 0x68)
#define REG_SC_BK14_68_H      _PK_H_(0x14, 0x68)
#define REG_SC_BK14_69_L      _PK_L_(0x14, 0x69)
#define REG_SC_BK14_69_H      _PK_H_(0x14, 0x69)
#define REG_SC_BK14_6A_L      _PK_L_(0x14, 0x6A)
#define REG_SC_BK14_6A_H      _PK_H_(0x14, 0x6A)
#define REG_SC_BK14_6B_L      _PK_L_(0x14, 0x6B)
#define REG_SC_BK14_6B_H      _PK_H_(0x14, 0x6B)
#define REG_SC_BK14_6C_L      _PK_L_(0x14, 0x6C)
#define REG_SC_BK14_6C_H      _PK_H_(0x14, 0x6C)
#define REG_SC_BK14_6D_L      _PK_L_(0x14, 0x6D)
#define REG_SC_BK14_6D_H      _PK_H_(0x14, 0x6D)
#define REG_SC_BK14_6E_L      _PK_L_(0x14, 0x6E)
#define REG_SC_BK14_6E_H      _PK_H_(0x14, 0x6E)
#define REG_SC_BK14_6F_L      _PK_L_(0x14, 0x6F)
#define REG_SC_BK14_6F_H      _PK_H_(0x14, 0x6F)
#define REG_SC_BK14_70_L      _PK_L_(0x14, 0x70)
#define REG_SC_BK14_70_H      _PK_H_(0x14, 0x70)
#define REG_SC_BK14_71_L      _PK_L_(0x14, 0x71)
#define REG_SC_BK14_71_H      _PK_H_(0x14, 0x71)
#define REG_SC_BK14_72_L      _PK_L_(0x14, 0x72)
#define REG_SC_BK14_72_H      _PK_H_(0x14, 0x72)
#define REG_SC_BK14_73_L      _PK_L_(0x14, 0x73)
#define REG_SC_BK14_73_H      _PK_H_(0x14, 0x73)
#define REG_SC_BK14_74_L      _PK_L_(0x14, 0x74)
#define REG_SC_BK14_74_H      _PK_H_(0x14, 0x74)
#define REG_SC_BK14_75_L      _PK_L_(0x14, 0x75)
#define REG_SC_BK14_75_H      _PK_H_(0x14, 0x75)
#define REG_SC_BK14_76_L      _PK_L_(0x14, 0x76)
#define REG_SC_BK14_76_H      _PK_H_(0x14, 0x76)
#define REG_SC_BK14_77_L      _PK_L_(0x14, 0x77)
#define REG_SC_BK14_77_H      _PK_H_(0x14, 0x77)
#define REG_SC_BK14_78_L      _PK_L_(0x14, 0x78)
#define REG_SC_BK14_78_H      _PK_H_(0x14, 0x78)
#define REG_SC_BK14_79_L      _PK_L_(0x14, 0x79)
#define REG_SC_BK14_79_H      _PK_H_(0x14, 0x79)
#define REG_SC_BK14_7A_L      _PK_L_(0x14, 0x7A)
#define REG_SC_BK14_7A_H      _PK_H_(0x14, 0x7A)
#define REG_SC_BK14_7B_L      _PK_L_(0x14, 0x7B)
#define REG_SC_BK14_7B_H      _PK_H_(0x14, 0x7B)
#define REG_SC_BK14_7C_L      _PK_L_(0x14, 0x7C)
#define REG_SC_BK14_7C_H      _PK_H_(0x14, 0x7C)
#define REG_SC_BK14_7D_L      _PK_L_(0x14, 0x7D)
#define REG_SC_BK14_7D_H      _PK_H_(0x14, 0x7D)
#define REG_SC_BK14_7E_L      _PK_L_(0x14, 0x7E)
#define REG_SC_BK14_7E_H      _PK_H_(0x14, 0x7E)
#define REG_SC_BK14_7F_L      _PK_L_(0x14, 0x7F)
#define REG_SC_BK14_7F_H      _PK_H_(0x14, 0x7F)
//----------------------------------------------
#define REG_SC_BK15_00_L      _PK_L_(0x15, 0x00)
#define REG_SC_BK15_00_H      _PK_H_(0x15, 0x00)
#define REG_SC_BK15_01_L      _PK_L_(0x15, 0x01)
#define REG_SC_BK15_01_H      _PK_H_(0x15, 0x01)
#define REG_SC_BK15_02_L      _PK_L_(0x15, 0x02)
#define REG_SC_BK15_02_H      _PK_H_(0x15, 0x02)
#define REG_SC_BK15_03_L      _PK_L_(0x15, 0x03)
#define REG_SC_BK15_03_H      _PK_H_(0x15, 0x03)
#define REG_SC_BK15_04_L      _PK_L_(0x15, 0x04)
#define REG_SC_BK15_04_H      _PK_H_(0x15, 0x04)
#define REG_SC_BK15_05_L      _PK_L_(0x15, 0x05)
#define REG_SC_BK15_05_H      _PK_H_(0x15, 0x05)
#define REG_SC_BK15_06_L      _PK_L_(0x15, 0x06)
#define REG_SC_BK15_06_H      _PK_H_(0x15, 0x06)
#define REG_SC_BK15_07_L      _PK_L_(0x15, 0x07)
#define REG_SC_BK15_07_H      _PK_H_(0x15, 0x07)
#define REG_SC_BK15_08_L      _PK_L_(0x15, 0x08)
#define REG_SC_BK15_08_H      _PK_H_(0x15, 0x08)
#define REG_SC_BK15_09_L      _PK_L_(0x15, 0x09)
#define REG_SC_BK15_09_H      _PK_H_(0x15, 0x09)
#define REG_SC_BK15_0A_L      _PK_L_(0x15, 0x0A)
#define REG_SC_BK15_0A_H      _PK_H_(0x15, 0x0A)
#define REG_SC_BK15_0B_L      _PK_L_(0x15, 0x0B)
#define REG_SC_BK15_0B_H      _PK_H_(0x15, 0x0B)
#define REG_SC_BK15_0C_L      _PK_L_(0x15, 0x0C)
#define REG_SC_BK15_0C_H      _PK_H_(0x15, 0x0C)
#define REG_SC_BK15_0D_L      _PK_L_(0x15, 0x0D)
#define REG_SC_BK15_0D_H      _PK_H_(0x15, 0x0D)
#define REG_SC_BK15_0E_L      _PK_L_(0x15, 0x0E)
#define REG_SC_BK15_0E_H      _PK_H_(0x15, 0x0E)
#define REG_SC_BK15_0F_L      _PK_L_(0x15, 0x0F)
#define REG_SC_BK15_0F_H      _PK_H_(0x15, 0x0F)
#define REG_SC_BK15_10_L      _PK_L_(0x15, 0x10)
#define REG_SC_BK15_10_H      _PK_H_(0x15, 0x10)
#define REG_SC_BK15_11_L      _PK_L_(0x15, 0x11)
#define REG_SC_BK15_11_H      _PK_H_(0x15, 0x11)
#define REG_SC_BK15_12_L      _PK_L_(0x15, 0x12)
#define REG_SC_BK15_12_H      _PK_H_(0x15, 0x12)
#define REG_SC_BK15_13_L      _PK_L_(0x15, 0x13)
#define REG_SC_BK15_13_H      _PK_H_(0x15, 0x13)
#define REG_SC_BK15_14_L      _PK_L_(0x15, 0x14)
#define REG_SC_BK15_14_H      _PK_H_(0x15, 0x14)
#define REG_SC_BK15_15_L      _PK_L_(0x15, 0x15)
#define REG_SC_BK15_15_H      _PK_H_(0x15, 0x15)
#define REG_SC_BK15_16_L      _PK_L_(0x15, 0x16)
#define REG_SC_BK15_16_H      _PK_H_(0x15, 0x16)
#define REG_SC_BK15_17_L      _PK_L_(0x15, 0x17)
#define REG_SC_BK15_17_H      _PK_H_(0x15, 0x17)
#define REG_SC_BK15_18_L      _PK_L_(0x15, 0x18)
#define REG_SC_BK15_18_H      _PK_H_(0x15, 0x18)
#define REG_SC_BK15_19_L      _PK_L_(0x15, 0x19)
#define REG_SC_BK15_19_H      _PK_H_(0x15, 0x19)
#define REG_SC_BK15_1A_L      _PK_L_(0x15, 0x1A)
#define REG_SC_BK15_1A_H      _PK_H_(0x15, 0x1A)
#define REG_SC_BK15_1B_L      _PK_L_(0x15, 0x1B)
#define REG_SC_BK15_1B_H      _PK_H_(0x15, 0x1B)
#define REG_SC_BK15_1C_L      _PK_L_(0x15, 0x1C)
#define REG_SC_BK15_1C_H      _PK_H_(0x15, 0x1C)
#define REG_SC_BK15_1D_L      _PK_L_(0x15, 0x1D)
#define REG_SC_BK15_1D_H      _PK_H_(0x15, 0x1D)
#define REG_SC_BK15_1E_L      _PK_L_(0x15, 0x1E)
#define REG_SC_BK15_1E_H      _PK_H_(0x15, 0x1E)
#define REG_SC_BK15_1F_L      _PK_L_(0x15, 0x1F)
#define REG_SC_BK15_1F_H      _PK_H_(0x15, 0x1F)
#define REG_SC_BK15_20_L      _PK_L_(0x15, 0x20)
#define REG_SC_BK15_20_H      _PK_H_(0x15, 0x20)
#define REG_SC_BK15_21_L      _PK_L_(0x15, 0x21)
#define REG_SC_BK15_21_H      _PK_H_(0x15, 0x21)
#define REG_SC_BK15_22_L      _PK_L_(0x15, 0x22)
#define REG_SC_BK15_22_H      _PK_H_(0x15, 0x22)
#define REG_SC_BK15_23_L      _PK_L_(0x15, 0x23)
#define REG_SC_BK15_23_H      _PK_H_(0x15, 0x23)
#define REG_SC_BK15_24_L      _PK_L_(0x15, 0x24)
#define REG_SC_BK15_24_H      _PK_H_(0x15, 0x24)
#define REG_SC_BK15_25_L      _PK_L_(0x15, 0x25)
#define REG_SC_BK15_25_H      _PK_H_(0x15, 0x25)
#define REG_SC_BK15_26_L      _PK_L_(0x15, 0x26)
#define REG_SC_BK15_26_H      _PK_H_(0x15, 0x26)
#define REG_SC_BK15_27_L      _PK_L_(0x15, 0x27)
#define REG_SC_BK15_27_H      _PK_H_(0x15, 0x27)
#define REG_SC_BK15_28_L      _PK_L_(0x15, 0x28)
#define REG_SC_BK15_28_H      _PK_H_(0x15, 0x28)
#define REG_SC_BK15_29_L      _PK_L_(0x15, 0x29)
#define REG_SC_BK15_29_H      _PK_H_(0x15, 0x29)
#define REG_SC_BK15_2A_L      _PK_L_(0x15, 0x2A)
#define REG_SC_BK15_2A_H      _PK_H_(0x15, 0x2A)
#define REG_SC_BK15_2B_L      _PK_L_(0x15, 0x2B)
#define REG_SC_BK15_2B_H      _PK_H_(0x15, 0x2B)
#define REG_SC_BK15_2C_L      _PK_L_(0x15, 0x2C)
#define REG_SC_BK15_2C_H      _PK_H_(0x15, 0x2C)
#define REG_SC_BK15_2D_L      _PK_L_(0x15, 0x2D)
#define REG_SC_BK15_2D_H      _PK_H_(0x15, 0x2D)
#define REG_SC_BK15_2E_L      _PK_L_(0x15, 0x2E)
#define REG_SC_BK15_2E_H      _PK_H_(0x15, 0x2E)
#define REG_SC_BK15_2F_L      _PK_L_(0x15, 0x2F)
#define REG_SC_BK15_2F_H      _PK_H_(0x15, 0x2F)
#define REG_SC_BK15_30_L      _PK_L_(0x15, 0x30)
#define REG_SC_BK15_30_H      _PK_H_(0x15, 0x30)
#define REG_SC_BK15_31_L      _PK_L_(0x15, 0x31)
#define REG_SC_BK15_31_H      _PK_H_(0x15, 0x31)
#define REG_SC_BK15_32_L      _PK_L_(0x15, 0x32)
#define REG_SC_BK15_32_H      _PK_H_(0x15, 0x32)
#define REG_SC_BK15_33_L      _PK_L_(0x15, 0x33)
#define REG_SC_BK15_33_H      _PK_H_(0x15, 0x33)
#define REG_SC_BK15_34_L      _PK_L_(0x15, 0x34)
#define REG_SC_BK15_34_H      _PK_H_(0x15, 0x34)
#define REG_SC_BK15_35_L      _PK_L_(0x15, 0x35)
#define REG_SC_BK15_35_H      _PK_H_(0x15, 0x35)
#define REG_SC_BK15_36_L      _PK_L_(0x15, 0x36)
#define REG_SC_BK15_36_H      _PK_H_(0x15, 0x36)
#define REG_SC_BK15_37_L      _PK_L_(0x15, 0x37)
#define REG_SC_BK15_37_H      _PK_H_(0x15, 0x37)
#define REG_SC_BK15_38_L      _PK_L_(0x15, 0x38)
#define REG_SC_BK15_38_H      _PK_H_(0x15, 0x38)
#define REG_SC_BK15_39_L      _PK_L_(0x15, 0x39)
#define REG_SC_BK15_39_H      _PK_H_(0x15, 0x39)
#define REG_SC_BK15_3A_L      _PK_L_(0x15, 0x3A)
#define REG_SC_BK15_3A_H      _PK_H_(0x15, 0x3A)
#define REG_SC_BK15_3B_L      _PK_L_(0x15, 0x3B)
#define REG_SC_BK15_3B_H      _PK_H_(0x15, 0x3B)
#define REG_SC_BK15_3C_L      _PK_L_(0x15, 0x3C)
#define REG_SC_BK15_3C_H      _PK_H_(0x15, 0x3C)
#define REG_SC_BK15_3D_L      _PK_L_(0x15, 0x3D)
#define REG_SC_BK15_3D_H      _PK_H_(0x15, 0x3D)
#define REG_SC_BK15_3E_L      _PK_L_(0x15, 0x3E)
#define REG_SC_BK15_3E_H      _PK_H_(0x15, 0x3E)
#define REG_SC_BK15_3F_L      _PK_L_(0x15, 0x3F)
#define REG_SC_BK15_3F_H      _PK_H_(0x15, 0x3F)
#define REG_SC_BK15_40_L      _PK_L_(0x15, 0x40)
#define REG_SC_BK15_40_H      _PK_H_(0x15, 0x40)
#define REG_SC_BK15_41_L      _PK_L_(0x15, 0x41)
#define REG_SC_BK15_41_H      _PK_H_(0x15, 0x41)
#define REG_SC_BK15_42_L      _PK_L_(0x15, 0x42)
#define REG_SC_BK15_42_H      _PK_H_(0x15, 0x42)
#define REG_SC_BK15_43_L      _PK_L_(0x15, 0x43)
#define REG_SC_BK15_43_H      _PK_H_(0x15, 0x43)
#define REG_SC_BK15_44_L      _PK_L_(0x15, 0x44)
#define REG_SC_BK15_44_H      _PK_H_(0x15, 0x44)
#define REG_SC_BK15_45_L      _PK_L_(0x15, 0x45)
#define REG_SC_BK15_45_H      _PK_H_(0x15, 0x45)
#define REG_SC_BK15_46_L      _PK_L_(0x15, 0x46)
#define REG_SC_BK15_46_H      _PK_H_(0x15, 0x46)
#define REG_SC_BK15_47_L      _PK_L_(0x15, 0x47)
#define REG_SC_BK15_47_H      _PK_H_(0x15, 0x47)
#define REG_SC_BK15_48_L      _PK_L_(0x15, 0x48)
#define REG_SC_BK15_48_H      _PK_H_(0x15, 0x48)
#define REG_SC_BK15_49_L      _PK_L_(0x15, 0x49)
#define REG_SC_BK15_49_H      _PK_H_(0x15, 0x49)
#define REG_SC_BK15_4A_L      _PK_L_(0x15, 0x4A)
#define REG_SC_BK15_4A_H      _PK_H_(0x15, 0x4A)
#define REG_SC_BK15_4B_L      _PK_L_(0x15, 0x4B)
#define REG_SC_BK15_4B_H      _PK_H_(0x15, 0x4B)
#define REG_SC_BK15_4C_L      _PK_L_(0x15, 0x4C)
#define REG_SC_BK15_4C_H      _PK_H_(0x15, 0x4C)
#define REG_SC_BK15_4D_L      _PK_L_(0x15, 0x4D)
#define REG_SC_BK15_4D_H      _PK_H_(0x15, 0x4D)
#define REG_SC_BK15_4E_L      _PK_L_(0x15, 0x4E)
#define REG_SC_BK15_4E_H      _PK_H_(0x15, 0x4E)
#define REG_SC_BK15_4F_L      _PK_L_(0x15, 0x4F)
#define REG_SC_BK15_4F_H      _PK_H_(0x15, 0x4F)
#define REG_SC_BK15_50_L      _PK_L_(0x15, 0x50)
#define REG_SC_BK15_50_H      _PK_H_(0x15, 0x50)
#define REG_SC_BK15_51_L      _PK_L_(0x15, 0x51)
#define REG_SC_BK15_51_H      _PK_H_(0x15, 0x51)
#define REG_SC_BK15_52_L      _PK_L_(0x15, 0x52)
#define REG_SC_BK15_52_H      _PK_H_(0x15, 0x52)
#define REG_SC_BK15_53_L      _PK_L_(0x15, 0x53)
#define REG_SC_BK15_53_H      _PK_H_(0x15, 0x53)
#define REG_SC_BK15_54_L      _PK_L_(0x15, 0x54)
#define REG_SC_BK15_54_H      _PK_H_(0x15, 0x54)
#define REG_SC_BK15_55_L      _PK_L_(0x15, 0x55)
#define REG_SC_BK15_55_H      _PK_H_(0x15, 0x55)
#define REG_SC_BK15_56_L      _PK_L_(0x15, 0x56)
#define REG_SC_BK15_56_H      _PK_H_(0x15, 0x56)
#define REG_SC_BK15_57_L      _PK_L_(0x15, 0x57)
#define REG_SC_BK15_57_H      _PK_H_(0x15, 0x57)
#define REG_SC_BK15_58_L      _PK_L_(0x15, 0x58)
#define REG_SC_BK15_58_H      _PK_H_(0x15, 0x58)
#define REG_SC_BK15_59_L      _PK_L_(0x15, 0x59)
#define REG_SC_BK15_59_H      _PK_H_(0x15, 0x59)
#define REG_SC_BK15_5A_L      _PK_L_(0x15, 0x5A)
#define REG_SC_BK15_5A_H      _PK_H_(0x15, 0x5A)
#define REG_SC_BK15_5B_L      _PK_L_(0x15, 0x5B)
#define REG_SC_BK15_5B_H      _PK_H_(0x15, 0x5B)
#define REG_SC_BK15_5C_L      _PK_L_(0x15, 0x5C)
#define REG_SC_BK15_5C_H      _PK_H_(0x15, 0x5C)
#define REG_SC_BK15_5D_L      _PK_L_(0x15, 0x5D)
#define REG_SC_BK15_5D_H      _PK_H_(0x15, 0x5D)
#define REG_SC_BK15_5E_L      _PK_L_(0x15, 0x5E)
#define REG_SC_BK15_5E_H      _PK_H_(0x15, 0x5E)
#define REG_SC_BK15_5F_L      _PK_L_(0x15, 0x5F)
#define REG_SC_BK15_5F_H      _PK_H_(0x15, 0x5F)
#define REG_SC_BK15_60_L      _PK_L_(0x15, 0x60)
#define REG_SC_BK15_60_H      _PK_H_(0x15, 0x60)
#define REG_SC_BK15_61_L      _PK_L_(0x15, 0x61)
#define REG_SC_BK15_61_H      _PK_H_(0x15, 0x61)
#define REG_SC_BK15_62_L      _PK_L_(0x15, 0x62)
#define REG_SC_BK15_62_H      _PK_H_(0x15, 0x62)
#define REG_SC_BK15_63_L      _PK_L_(0x15, 0x63)
#define REG_SC_BK15_63_H      _PK_H_(0x15, 0x63)
#define REG_SC_BK15_64_L      _PK_L_(0x15, 0x64)
#define REG_SC_BK15_64_H      _PK_H_(0x15, 0x64)
#define REG_SC_BK15_65_L      _PK_L_(0x15, 0x65)
#define REG_SC_BK15_65_H      _PK_H_(0x15, 0x65)
#define REG_SC_BK15_66_L      _PK_L_(0x15, 0x66)
#define REG_SC_BK15_66_H      _PK_H_(0x15, 0x66)
#define REG_SC_BK15_67_L      _PK_L_(0x15, 0x67)
#define REG_SC_BK15_67_H      _PK_H_(0x15, 0x67)
#define REG_SC_BK15_68_L      _PK_L_(0x15, 0x68)
#define REG_SC_BK15_68_H      _PK_H_(0x15, 0x68)
#define REG_SC_BK15_69_L      _PK_L_(0x15, 0x69)
#define REG_SC_BK15_69_H      _PK_H_(0x15, 0x69)
#define REG_SC_BK15_6A_L      _PK_L_(0x15, 0x6A)
#define REG_SC_BK15_6A_H      _PK_H_(0x15, 0x6A)
#define REG_SC_BK15_6B_L      _PK_L_(0x15, 0x6B)
#define REG_SC_BK15_6B_H      _PK_H_(0x15, 0x6B)
#define REG_SC_BK15_6C_L      _PK_L_(0x15, 0x6C)
#define REG_SC_BK15_6C_H      _PK_H_(0x15, 0x6C)
#define REG_SC_BK15_6D_L      _PK_L_(0x15, 0x6D)
#define REG_SC_BK15_6D_H      _PK_H_(0x15, 0x6D)
#define REG_SC_BK15_6E_L      _PK_L_(0x15, 0x6E)
#define REG_SC_BK15_6E_H      _PK_H_(0x15, 0x6E)
#define REG_SC_BK15_6F_L      _PK_L_(0x15, 0x6F)
#define REG_SC_BK15_6F_H      _PK_H_(0x15, 0x6F)
#define REG_SC_BK15_70_L      _PK_L_(0x15, 0x70)
#define REG_SC_BK15_70_H      _PK_H_(0x15, 0x70)
#define REG_SC_BK15_71_L      _PK_L_(0x15, 0x71)
#define REG_SC_BK15_71_H      _PK_H_(0x15, 0x71)
#define REG_SC_BK15_72_L      _PK_L_(0x15, 0x72)
#define REG_SC_BK15_72_H      _PK_H_(0x15, 0x72)
#define REG_SC_BK15_73_L      _PK_L_(0x15, 0x73)
#define REG_SC_BK15_73_H      _PK_H_(0x15, 0x73)
#define REG_SC_BK15_74_L      _PK_L_(0x15, 0x74)
#define REG_SC_BK15_74_H      _PK_H_(0x15, 0x74)
#define REG_SC_BK15_75_L      _PK_L_(0x15, 0x75)
#define REG_SC_BK15_75_H      _PK_H_(0x15, 0x75)
#define REG_SC_BK15_76_L      _PK_L_(0x15, 0x76)
#define REG_SC_BK15_76_H      _PK_H_(0x15, 0x76)
#define REG_SC_BK15_77_L      _PK_L_(0x15, 0x77)
#define REG_SC_BK15_77_H      _PK_H_(0x15, 0x77)
#define REG_SC_BK15_78_L      _PK_L_(0x15, 0x78)
#define REG_SC_BK15_78_H      _PK_H_(0x15, 0x78)
#define REG_SC_BK15_79_L      _PK_L_(0x15, 0x79)
#define REG_SC_BK15_79_H      _PK_H_(0x15, 0x79)
#define REG_SC_BK15_7A_L      _PK_L_(0x15, 0x7A)
#define REG_SC_BK15_7A_H      _PK_H_(0x15, 0x7A)
#define REG_SC_BK15_7B_L      _PK_L_(0x15, 0x7B)
#define REG_SC_BK15_7B_H      _PK_H_(0x15, 0x7B)
#define REG_SC_BK15_7C_L      _PK_L_(0x15, 0x7C)
#define REG_SC_BK15_7C_H      _PK_H_(0x15, 0x7C)
#define REG_SC_BK15_7D_L      _PK_L_(0x15, 0x7D)
#define REG_SC_BK15_7D_H      _PK_H_(0x15, 0x7D)
#define REG_SC_BK15_7E_L      _PK_L_(0x15, 0x7E)
#define REG_SC_BK15_7E_H      _PK_H_(0x15, 0x7E)
#define REG_SC_BK15_7F_L      _PK_L_(0x15, 0x7F)
#define REG_SC_BK15_7F_H      _PK_H_(0x15, 0x7F)
//----------------------------------------------
#define REG_SC_BK16_00_L      _PK_L_(0x16, 0x00)
#define REG_SC_BK16_00_H      _PK_H_(0x16, 0x00)
#define REG_SC_BK16_01_L      _PK_L_(0x16, 0x01)
#define REG_SC_BK16_01_H      _PK_H_(0x16, 0x01)
#define REG_SC_BK16_02_L      _PK_L_(0x16, 0x02)
#define REG_SC_BK16_02_H      _PK_H_(0x16, 0x02)
#define REG_SC_BK16_03_L      _PK_L_(0x16, 0x03)
#define REG_SC_BK16_03_H      _PK_H_(0x16, 0x03)
#define REG_SC_BK16_04_L      _PK_L_(0x16, 0x04)
#define REG_SC_BK16_04_H      _PK_H_(0x16, 0x04)
#define REG_SC_BK16_05_L      _PK_L_(0x16, 0x05)
#define REG_SC_BK16_05_H      _PK_H_(0x16, 0x05)
#define REG_SC_BK16_06_L      _PK_L_(0x16, 0x06)
#define REG_SC_BK16_06_H      _PK_H_(0x16, 0x06)
#define REG_SC_BK16_07_L      _PK_L_(0x16, 0x07)
#define REG_SC_BK16_07_H      _PK_H_(0x16, 0x07)
#define REG_SC_BK16_08_L      _PK_L_(0x16, 0x08)
#define REG_SC_BK16_08_H      _PK_H_(0x16, 0x08)
#define REG_SC_BK16_09_L      _PK_L_(0x16, 0x09)
#define REG_SC_BK16_09_H      _PK_H_(0x16, 0x09)
#define REG_SC_BK16_0A_L      _PK_L_(0x16, 0x0A)
#define REG_SC_BK16_0A_H      _PK_H_(0x16, 0x0A)
#define REG_SC_BK16_0B_L      _PK_L_(0x16, 0x0B)
#define REG_SC_BK16_0B_H      _PK_H_(0x16, 0x0B)
#define REG_SC_BK16_0C_L      _PK_L_(0x16, 0x0C)
#define REG_SC_BK16_0C_H      _PK_H_(0x16, 0x0C)
#define REG_SC_BK16_0D_L      _PK_L_(0x16, 0x0D)
#define REG_SC_BK16_0D_H      _PK_H_(0x16, 0x0D)
#define REG_SC_BK16_0E_L      _PK_L_(0x16, 0x0E)
#define REG_SC_BK16_0E_H      _PK_H_(0x16, 0x0E)
#define REG_SC_BK16_0F_L      _PK_L_(0x16, 0x0F)
#define REG_SC_BK16_0F_H      _PK_H_(0x16, 0x0F)
#define REG_SC_BK16_10_L      _PK_L_(0x16, 0x10)
#define REG_SC_BK16_10_H      _PK_H_(0x16, 0x10)
#define REG_SC_BK16_11_L      _PK_L_(0x16, 0x11)
#define REG_SC_BK16_11_H      _PK_H_(0x16, 0x11)
#define REG_SC_BK16_12_L      _PK_L_(0x16, 0x12)
#define REG_SC_BK16_12_H      _PK_H_(0x16, 0x12)
#define REG_SC_BK16_13_L      _PK_L_(0x16, 0x13)
#define REG_SC_BK16_13_H      _PK_H_(0x16, 0x13)
#define REG_SC_BK16_14_L      _PK_L_(0x16, 0x14)
#define REG_SC_BK16_14_H      _PK_H_(0x16, 0x14)
#define REG_SC_BK16_15_L      _PK_L_(0x16, 0x15)
#define REG_SC_BK16_15_H      _PK_H_(0x16, 0x15)
#define REG_SC_BK16_16_L      _PK_L_(0x16, 0x16)
#define REG_SC_BK16_16_H      _PK_H_(0x16, 0x16)
#define REG_SC_BK16_17_L      _PK_L_(0x16, 0x17)
#define REG_SC_BK16_17_H      _PK_H_(0x16, 0x17)
#define REG_SC_BK16_18_L      _PK_L_(0x16, 0x18)
#define REG_SC_BK16_18_H      _PK_H_(0x16, 0x18)
#define REG_SC_BK16_19_L      _PK_L_(0x16, 0x19)
#define REG_SC_BK16_19_H      _PK_H_(0x16, 0x19)
#define REG_SC_BK16_1A_L      _PK_L_(0x16, 0x1A)
#define REG_SC_BK16_1A_H      _PK_H_(0x16, 0x1A)
#define REG_SC_BK16_1B_L      _PK_L_(0x16, 0x1B)
#define REG_SC_BK16_1B_H      _PK_H_(0x16, 0x1B)
#define REG_SC_BK16_1C_L      _PK_L_(0x16, 0x1C)
#define REG_SC_BK16_1C_H      _PK_H_(0x16, 0x1C)
#define REG_SC_BK16_1D_L      _PK_L_(0x16, 0x1D)
#define REG_SC_BK16_1D_H      _PK_H_(0x16, 0x1D)
#define REG_SC_BK16_1E_L      _PK_L_(0x16, 0x1E)
#define REG_SC_BK16_1E_H      _PK_H_(0x16, 0x1E)
#define REG_SC_BK16_1F_L      _PK_L_(0x16, 0x1F)
#define REG_SC_BK16_1F_H      _PK_H_(0x16, 0x1F)
#define REG_SC_BK16_20_L      _PK_L_(0x16, 0x20)
#define REG_SC_BK16_20_H      _PK_H_(0x16, 0x20)
#define REG_SC_BK16_21_L      _PK_L_(0x16, 0x21)
#define REG_SC_BK16_21_H      _PK_H_(0x16, 0x21)
#define REG_SC_BK16_22_L      _PK_L_(0x16, 0x22)
#define REG_SC_BK16_22_H      _PK_H_(0x16, 0x22)
#define REG_SC_BK16_23_L      _PK_L_(0x16, 0x23)
#define REG_SC_BK16_23_H      _PK_H_(0x16, 0x23)
#define REG_SC_BK16_24_L      _PK_L_(0x16, 0x24)
#define REG_SC_BK16_24_H      _PK_H_(0x16, 0x24)
#define REG_SC_BK16_25_L      _PK_L_(0x16, 0x25)
#define REG_SC_BK16_25_H      _PK_H_(0x16, 0x25)
#define REG_SC_BK16_26_L      _PK_L_(0x16, 0x26)
#define REG_SC_BK16_26_H      _PK_H_(0x16, 0x26)
#define REG_SC_BK16_27_L      _PK_L_(0x16, 0x27)
#define REG_SC_BK16_27_H      _PK_H_(0x16, 0x27)
#define REG_SC_BK16_28_L      _PK_L_(0x16, 0x28)
#define REG_SC_BK16_28_H      _PK_H_(0x16, 0x28)
#define REG_SC_BK16_29_L      _PK_L_(0x16, 0x29)
#define REG_SC_BK16_29_H      _PK_H_(0x16, 0x29)
#define REG_SC_BK16_2A_L      _PK_L_(0x16, 0x2A)
#define REG_SC_BK16_2A_H      _PK_H_(0x16, 0x2A)
#define REG_SC_BK16_2B_L      _PK_L_(0x16, 0x2B)
#define REG_SC_BK16_2B_H      _PK_H_(0x16, 0x2B)
#define REG_SC_BK16_2C_L      _PK_L_(0x16, 0x2C)
#define REG_SC_BK16_2C_H      _PK_H_(0x16, 0x2C)
#define REG_SC_BK16_2D_L      _PK_L_(0x16, 0x2D)
#define REG_SC_BK16_2D_H      _PK_H_(0x16, 0x2D)
#define REG_SC_BK16_2E_L      _PK_L_(0x16, 0x2E)
#define REG_SC_BK16_2E_H      _PK_H_(0x16, 0x2E)
#define REG_SC_BK16_2F_L      _PK_L_(0x16, 0x2F)
#define REG_SC_BK16_2F_H      _PK_H_(0x16, 0x2F)
#define REG_SC_BK16_30_L      _PK_L_(0x16, 0x30)
#define REG_SC_BK16_30_H      _PK_H_(0x16, 0x30)
#define REG_SC_BK16_31_L      _PK_L_(0x16, 0x31)
#define REG_SC_BK16_31_H      _PK_H_(0x16, 0x31)
#define REG_SC_BK16_32_L      _PK_L_(0x16, 0x32)
#define REG_SC_BK16_32_H      _PK_H_(0x16, 0x32)
#define REG_SC_BK16_33_L      _PK_L_(0x16, 0x33)
#define REG_SC_BK16_33_H      _PK_H_(0x16, 0x33)
#define REG_SC_BK16_34_L      _PK_L_(0x16, 0x34)
#define REG_SC_BK16_34_H      _PK_H_(0x16, 0x34)
#define REG_SC_BK16_35_L      _PK_L_(0x16, 0x35)
#define REG_SC_BK16_35_H      _PK_H_(0x16, 0x35)
#define REG_SC_BK16_36_L      _PK_L_(0x16, 0x36)
#define REG_SC_BK16_36_H      _PK_H_(0x16, 0x36)
#define REG_SC_BK16_37_L      _PK_L_(0x16, 0x37)
#define REG_SC_BK16_37_H      _PK_H_(0x16, 0x37)
#define REG_SC_BK16_38_L      _PK_L_(0x16, 0x38)
#define REG_SC_BK16_38_H      _PK_H_(0x16, 0x38)
#define REG_SC_BK16_39_L      _PK_L_(0x16, 0x39)
#define REG_SC_BK16_39_H      _PK_H_(0x16, 0x39)
#define REG_SC_BK16_3A_L      _PK_L_(0x16, 0x3A)
#define REG_SC_BK16_3A_H      _PK_H_(0x16, 0x3A)
#define REG_SC_BK16_3B_L      _PK_L_(0x16, 0x3B)
#define REG_SC_BK16_3B_H      _PK_H_(0x16, 0x3B)
#define REG_SC_BK16_3C_L      _PK_L_(0x16, 0x3C)
#define REG_SC_BK16_3C_H      _PK_H_(0x16, 0x3C)
#define REG_SC_BK16_3D_L      _PK_L_(0x16, 0x3D)
#define REG_SC_BK16_3D_H      _PK_H_(0x16, 0x3D)
#define REG_SC_BK16_3E_L      _PK_L_(0x16, 0x3E)
#define REG_SC_BK16_3E_H      _PK_H_(0x16, 0x3E)
#define REG_SC_BK16_3F_L      _PK_L_(0x16, 0x3F)
#define REG_SC_BK16_3F_H      _PK_H_(0x16, 0x3F)
#define REG_SC_BK16_40_L      _PK_L_(0x16, 0x40)
#define REG_SC_BK16_40_H      _PK_H_(0x16, 0x40)
#define REG_SC_BK16_41_L      _PK_L_(0x16, 0x41)
#define REG_SC_BK16_41_H      _PK_H_(0x16, 0x41)
#define REG_SC_BK16_42_L      _PK_L_(0x16, 0x42)
#define REG_SC_BK16_42_H      _PK_H_(0x16, 0x42)
#define REG_SC_BK16_43_L      _PK_L_(0x16, 0x43)
#define REG_SC_BK16_43_H      _PK_H_(0x16, 0x43)
#define REG_SC_BK16_44_L      _PK_L_(0x16, 0x44)
#define REG_SC_BK16_44_H      _PK_H_(0x16, 0x44)
#define REG_SC_BK16_45_L      _PK_L_(0x16, 0x45)
#define REG_SC_BK16_45_H      _PK_H_(0x16, 0x45)
#define REG_SC_BK16_46_L      _PK_L_(0x16, 0x46)
#define REG_SC_BK16_46_H      _PK_H_(0x16, 0x46)
#define REG_SC_BK16_47_L      _PK_L_(0x16, 0x47)
#define REG_SC_BK16_47_H      _PK_H_(0x16, 0x47)
#define REG_SC_BK16_48_L      _PK_L_(0x16, 0x48)
#define REG_SC_BK16_48_H      _PK_H_(0x16, 0x48)
#define REG_SC_BK16_49_L      _PK_L_(0x16, 0x49)
#define REG_SC_BK16_49_H      _PK_H_(0x16, 0x49)
#define REG_SC_BK16_4A_L      _PK_L_(0x16, 0x4A)
#define REG_SC_BK16_4A_H      _PK_H_(0x16, 0x4A)
#define REG_SC_BK16_4B_L      _PK_L_(0x16, 0x4B)
#define REG_SC_BK16_4B_H      _PK_H_(0x16, 0x4B)
#define REG_SC_BK16_4C_L      _PK_L_(0x16, 0x4C)
#define REG_SC_BK16_4C_H      _PK_H_(0x16, 0x4C)
#define REG_SC_BK16_4D_L      _PK_L_(0x16, 0x4D)
#define REG_SC_BK16_4D_H      _PK_H_(0x16, 0x4D)
#define REG_SC_BK16_4E_L      _PK_L_(0x16, 0x4E)
#define REG_SC_BK16_4E_H      _PK_H_(0x16, 0x4E)
#define REG_SC_BK16_4F_L      _PK_L_(0x16, 0x4F)
#define REG_SC_BK16_4F_H      _PK_H_(0x16, 0x4F)
#define REG_SC_BK16_50_L      _PK_L_(0x16, 0x50)
#define REG_SC_BK16_50_H      _PK_H_(0x16, 0x50)
#define REG_SC_BK16_51_L      _PK_L_(0x16, 0x51)
#define REG_SC_BK16_51_H      _PK_H_(0x16, 0x51)
#define REG_SC_BK16_52_L      _PK_L_(0x16, 0x52)
#define REG_SC_BK16_52_H      _PK_H_(0x16, 0x52)
#define REG_SC_BK16_53_L      _PK_L_(0x16, 0x53)
#define REG_SC_BK16_53_H      _PK_H_(0x16, 0x53)
#define REG_SC_BK16_54_L      _PK_L_(0x16, 0x54)
#define REG_SC_BK16_54_H      _PK_H_(0x16, 0x54)
#define REG_SC_BK16_55_L      _PK_L_(0x16, 0x55)
#define REG_SC_BK16_55_H      _PK_H_(0x16, 0x55)
#define REG_SC_BK16_56_L      _PK_L_(0x16, 0x56)
#define REG_SC_BK16_56_H      _PK_H_(0x16, 0x56)
#define REG_SC_BK16_57_L      _PK_L_(0x16, 0x57)
#define REG_SC_BK16_57_H      _PK_H_(0x16, 0x57)
#define REG_SC_BK16_58_L      _PK_L_(0x16, 0x58)
#define REG_SC_BK16_58_H      _PK_H_(0x16, 0x58)
#define REG_SC_BK16_59_L      _PK_L_(0x16, 0x59)
#define REG_SC_BK16_59_H      _PK_H_(0x16, 0x59)
#define REG_SC_BK16_5A_L      _PK_L_(0x16, 0x5A)
#define REG_SC_BK16_5A_H      _PK_H_(0x16, 0x5A)
#define REG_SC_BK16_5B_L      _PK_L_(0x16, 0x5B)
#define REG_SC_BK16_5B_H      _PK_H_(0x16, 0x5B)
#define REG_SC_BK16_5C_L      _PK_L_(0x16, 0x5C)
#define REG_SC_BK16_5C_H      _PK_H_(0x16, 0x5C)
#define REG_SC_BK16_5D_L      _PK_L_(0x16, 0x5D)
#define REG_SC_BK16_5D_H      _PK_H_(0x16, 0x5D)
#define REG_SC_BK16_5E_L      _PK_L_(0x16, 0x5E)
#define REG_SC_BK16_5E_H      _PK_H_(0x16, 0x5E)
#define REG_SC_BK16_5F_L      _PK_L_(0x16, 0x5F)
#define REG_SC_BK16_5F_H      _PK_H_(0x16, 0x5F)
#define REG_SC_BK16_60_L      _PK_L_(0x16, 0x60)
#define REG_SC_BK16_60_H      _PK_H_(0x16, 0x60)
#define REG_SC_BK16_61_L      _PK_L_(0x16, 0x61)
#define REG_SC_BK16_61_H      _PK_H_(0x16, 0x61)
#define REG_SC_BK16_62_L      _PK_L_(0x16, 0x62)
#define REG_SC_BK16_62_H      _PK_H_(0x16, 0x62)
#define REG_SC_BK16_63_L      _PK_L_(0x16, 0x63)
#define REG_SC_BK16_63_H      _PK_H_(0x16, 0x63)
#define REG_SC_BK16_64_L      _PK_L_(0x16, 0x64)
#define REG_SC_BK16_64_H      _PK_H_(0x16, 0x64)
#define REG_SC_BK16_65_L      _PK_L_(0x16, 0x65)
#define REG_SC_BK16_65_H      _PK_H_(0x16, 0x65)
#define REG_SC_BK16_66_L      _PK_L_(0x16, 0x66)
#define REG_SC_BK16_66_H      _PK_H_(0x16, 0x66)
#define REG_SC_BK16_67_L      _PK_L_(0x16, 0x67)
#define REG_SC_BK16_67_H      _PK_H_(0x16, 0x67)
#define REG_SC_BK16_68_L      _PK_L_(0x16, 0x68)
#define REG_SC_BK16_68_H      _PK_H_(0x16, 0x68)
#define REG_SC_BK16_69_L      _PK_L_(0x16, 0x69)
#define REG_SC_BK16_69_H      _PK_H_(0x16, 0x69)
#define REG_SC_BK16_6A_L      _PK_L_(0x16, 0x6A)
#define REG_SC_BK16_6A_H      _PK_H_(0x16, 0x6A)
#define REG_SC_BK16_6B_L      _PK_L_(0x16, 0x6B)
#define REG_SC_BK16_6B_H      _PK_H_(0x16, 0x6B)
#define REG_SC_BK16_6C_L      _PK_L_(0x16, 0x6C)
#define REG_SC_BK16_6C_H      _PK_H_(0x16, 0x6C)
#define REG_SC_BK16_6D_L      _PK_L_(0x16, 0x6D)
#define REG_SC_BK16_6D_H      _PK_H_(0x16, 0x6D)
#define REG_SC_BK16_6E_L      _PK_L_(0x16, 0x6E)
#define REG_SC_BK16_6E_H      _PK_H_(0x16, 0x6E)
#define REG_SC_BK16_6F_L      _PK_L_(0x16, 0x6F)
#define REG_SC_BK16_6F_H      _PK_H_(0x16, 0x6F)
#define REG_SC_BK16_70_L      _PK_L_(0x16, 0x70)
#define REG_SC_BK16_70_H      _PK_H_(0x16, 0x70)
#define REG_SC_BK16_71_L      _PK_L_(0x16, 0x71)
#define REG_SC_BK16_71_H      _PK_H_(0x16, 0x71)
#define REG_SC_BK16_72_L      _PK_L_(0x16, 0x72)
#define REG_SC_BK16_72_H      _PK_H_(0x16, 0x72)
#define REG_SC_BK16_73_L      _PK_L_(0x16, 0x73)
#define REG_SC_BK16_73_H      _PK_H_(0x16, 0x73)
#define REG_SC_BK16_74_L      _PK_L_(0x16, 0x74)
#define REG_SC_BK16_74_H      _PK_H_(0x16, 0x74)
#define REG_SC_BK16_75_L      _PK_L_(0x16, 0x75)
#define REG_SC_BK16_75_H      _PK_H_(0x16, 0x75)
#define REG_SC_BK16_76_L      _PK_L_(0x16, 0x76)
#define REG_SC_BK16_76_H      _PK_H_(0x16, 0x76)
#define REG_SC_BK16_77_L      _PK_L_(0x16, 0x77)
#define REG_SC_BK16_77_H      _PK_H_(0x16, 0x77)
#define REG_SC_BK16_78_L      _PK_L_(0x16, 0x78)
#define REG_SC_BK16_78_H      _PK_H_(0x16, 0x78)
#define REG_SC_BK16_79_L      _PK_L_(0x16, 0x79)
#define REG_SC_BK16_79_H      _PK_H_(0x16, 0x79)
#define REG_SC_BK16_7A_L      _PK_L_(0x16, 0x7A)
#define REG_SC_BK16_7A_H      _PK_H_(0x16, 0x7A)
#define REG_SC_BK16_7B_L      _PK_L_(0x16, 0x7B)
#define REG_SC_BK16_7B_H      _PK_H_(0x16, 0x7B)
#define REG_SC_BK16_7C_L      _PK_L_(0x16, 0x7C)
#define REG_SC_BK16_7C_H      _PK_H_(0x16, 0x7C)
#define REG_SC_BK16_7D_L      _PK_L_(0x16, 0x7D)
#define REG_SC_BK16_7D_H      _PK_H_(0x16, 0x7D)
#define REG_SC_BK16_7E_L      _PK_L_(0x16, 0x7E)
#define REG_SC_BK16_7E_H      _PK_H_(0x16, 0x7E)
#define REG_SC_BK16_7F_L      _PK_L_(0x16, 0x7F)
#define REG_SC_BK16_7F_H      _PK_H_(0x16, 0x7F)
//----------------------------------------------
#define REG_SC_BK17_00_L      _PK_L_(0x17, 0x00)
#define REG_SC_BK17_00_H      _PK_H_(0x17, 0x00)
#define REG_SC_BK17_01_L      _PK_L_(0x17, 0x01)
#define REG_SC_BK17_01_H      _PK_H_(0x17, 0x01)
#define REG_SC_BK17_02_L      _PK_L_(0x17, 0x02)
#define REG_SC_BK17_02_H      _PK_H_(0x17, 0x02)
#define REG_SC_BK17_03_L      _PK_L_(0x17, 0x03)
#define REG_SC_BK17_03_H      _PK_H_(0x17, 0x03)
#define REG_SC_BK17_04_L      _PK_L_(0x17, 0x04)
#define REG_SC_BK17_04_H      _PK_H_(0x17, 0x04)
#define REG_SC_BK17_05_L      _PK_L_(0x17, 0x05)
#define REG_SC_BK17_05_H      _PK_H_(0x17, 0x05)
#define REG_SC_BK17_06_L      _PK_L_(0x17, 0x06)
#define REG_SC_BK17_06_H      _PK_H_(0x17, 0x06)
#define REG_SC_BK17_07_L      _PK_L_(0x17, 0x07)
#define REG_SC_BK17_07_H      _PK_H_(0x17, 0x07)
#define REG_SC_BK17_08_L      _PK_L_(0x17, 0x08)
#define REG_SC_BK17_08_H      _PK_H_(0x17, 0x08)
#define REG_SC_BK17_09_L      _PK_L_(0x17, 0x09)
#define REG_SC_BK17_09_H      _PK_H_(0x17, 0x09)
#define REG_SC_BK17_0A_L      _PK_L_(0x17, 0x0A)
#define REG_SC_BK17_0A_H      _PK_H_(0x17, 0x0A)
#define REG_SC_BK17_0B_L      _PK_L_(0x17, 0x0B)
#define REG_SC_BK17_0B_H      _PK_H_(0x17, 0x0B)
#define REG_SC_BK17_0C_L      _PK_L_(0x17, 0x0C)
#define REG_SC_BK17_0C_H      _PK_H_(0x17, 0x0C)
#define REG_SC_BK17_0D_L      _PK_L_(0x17, 0x0D)
#define REG_SC_BK17_0D_H      _PK_H_(0x17, 0x0D)
#define REG_SC_BK17_0E_L      _PK_L_(0x17, 0x0E)
#define REG_SC_BK17_0E_H      _PK_H_(0x17, 0x0E)
#define REG_SC_BK17_0F_L      _PK_L_(0x17, 0x0F)
#define REG_SC_BK17_0F_H      _PK_H_(0x17, 0x0F)
#define REG_SC_BK17_10_L      _PK_L_(0x17, 0x10)
#define REG_SC_BK17_10_H      _PK_H_(0x17, 0x10)
#define REG_SC_BK17_11_L      _PK_L_(0x17, 0x11)
#define REG_SC_BK17_11_H      _PK_H_(0x17, 0x11)
#define REG_SC_BK17_12_L      _PK_L_(0x17, 0x12)
#define REG_SC_BK17_12_H      _PK_H_(0x17, 0x12)
#define REG_SC_BK17_13_L      _PK_L_(0x17, 0x13)
#define REG_SC_BK17_13_H      _PK_H_(0x17, 0x13)
#define REG_SC_BK17_14_L      _PK_L_(0x17, 0x14)
#define REG_SC_BK17_14_H      _PK_H_(0x17, 0x14)
#define REG_SC_BK17_15_L      _PK_L_(0x17, 0x15)
#define REG_SC_BK17_15_H      _PK_H_(0x17, 0x15)
#define REG_SC_BK17_16_L      _PK_L_(0x17, 0x16)
#define REG_SC_BK17_16_H      _PK_H_(0x17, 0x16)
#define REG_SC_BK17_17_L      _PK_L_(0x17, 0x17)
#define REG_SC_BK17_17_H      _PK_H_(0x17, 0x17)
#define REG_SC_BK17_18_L      _PK_L_(0x17, 0x18)
#define REG_SC_BK17_18_H      _PK_H_(0x17, 0x18)
#define REG_SC_BK17_19_L      _PK_L_(0x17, 0x19)
#define REG_SC_BK17_19_H      _PK_H_(0x17, 0x19)
#define REG_SC_BK17_1A_L      _PK_L_(0x17, 0x1A)
#define REG_SC_BK17_1A_H      _PK_H_(0x17, 0x1A)
#define REG_SC_BK17_1B_L      _PK_L_(0x17, 0x1B)
#define REG_SC_BK17_1B_H      _PK_H_(0x17, 0x1B)
#define REG_SC_BK17_1C_L      _PK_L_(0x17, 0x1C)
#define REG_SC_BK17_1C_H      _PK_H_(0x17, 0x1C)
#define REG_SC_BK17_1D_L      _PK_L_(0x17, 0x1D)
#define REG_SC_BK17_1D_H      _PK_H_(0x17, 0x1D)
#define REG_SC_BK17_1E_L      _PK_L_(0x17, 0x1E)
#define REG_SC_BK17_1E_H      _PK_H_(0x17, 0x1E)
#define REG_SC_BK17_1F_L      _PK_L_(0x17, 0x1F)
#define REG_SC_BK17_1F_H      _PK_H_(0x17, 0x1F)
#define REG_SC_BK17_20_L      _PK_L_(0x17, 0x20)
#define REG_SC_BK17_20_H      _PK_H_(0x17, 0x20)
#define REG_SC_BK17_21_L      _PK_L_(0x17, 0x21)
#define REG_SC_BK17_21_H      _PK_H_(0x17, 0x21)
#define REG_SC_BK17_22_L      _PK_L_(0x17, 0x22)
#define REG_SC_BK17_22_H      _PK_H_(0x17, 0x22)
#define REG_SC_BK17_23_L      _PK_L_(0x17, 0x23)
#define REG_SC_BK17_23_H      _PK_H_(0x17, 0x23)
#define REG_SC_BK17_24_L      _PK_L_(0x17, 0x24)
#define REG_SC_BK17_24_H      _PK_H_(0x17, 0x24)
#define REG_SC_BK17_25_L      _PK_L_(0x17, 0x25)
#define REG_SC_BK17_25_H      _PK_H_(0x17, 0x25)
#define REG_SC_BK17_26_L      _PK_L_(0x17, 0x26)
#define REG_SC_BK17_26_H      _PK_H_(0x17, 0x26)
#define REG_SC_BK17_27_L      _PK_L_(0x17, 0x27)
#define REG_SC_BK17_27_H      _PK_H_(0x17, 0x27)
#define REG_SC_BK17_28_L      _PK_L_(0x17, 0x28)
#define REG_SC_BK17_28_H      _PK_H_(0x17, 0x28)
#define REG_SC_BK17_29_L      _PK_L_(0x17, 0x29)
#define REG_SC_BK17_29_H      _PK_H_(0x17, 0x29)
#define REG_SC_BK17_2A_L      _PK_L_(0x17, 0x2A)
#define REG_SC_BK17_2A_H      _PK_H_(0x17, 0x2A)
#define REG_SC_BK17_2B_L      _PK_L_(0x17, 0x2B)
#define REG_SC_BK17_2B_H      _PK_H_(0x17, 0x2B)
#define REG_SC_BK17_2C_L      _PK_L_(0x17, 0x2C)
#define REG_SC_BK17_2C_H      _PK_H_(0x17, 0x2C)
#define REG_SC_BK17_2D_L      _PK_L_(0x17, 0x2D)
#define REG_SC_BK17_2D_H      _PK_H_(0x17, 0x2D)
#define REG_SC_BK17_2E_L      _PK_L_(0x17, 0x2E)
#define REG_SC_BK17_2E_H      _PK_H_(0x17, 0x2E)
#define REG_SC_BK17_2F_L      _PK_L_(0x17, 0x2F)
#define REG_SC_BK17_2F_H      _PK_H_(0x17, 0x2F)
#define REG_SC_BK17_30_L      _PK_L_(0x17, 0x30)
#define REG_SC_BK17_30_H      _PK_H_(0x17, 0x30)
#define REG_SC_BK17_31_L      _PK_L_(0x17, 0x31)
#define REG_SC_BK17_31_H      _PK_H_(0x17, 0x31)
#define REG_SC_BK17_32_L      _PK_L_(0x17, 0x32)
#define REG_SC_BK17_32_H      _PK_H_(0x17, 0x32)
#define REG_SC_BK17_33_L      _PK_L_(0x17, 0x33)
#define REG_SC_BK17_33_H      _PK_H_(0x17, 0x33)
#define REG_SC_BK17_34_L      _PK_L_(0x17, 0x34)
#define REG_SC_BK17_34_H      _PK_H_(0x17, 0x34)
#define REG_SC_BK17_35_L      _PK_L_(0x17, 0x35)
#define REG_SC_BK17_35_H      _PK_H_(0x17, 0x35)
#define REG_SC_BK17_36_L      _PK_L_(0x17, 0x36)
#define REG_SC_BK17_36_H      _PK_H_(0x17, 0x36)
#define REG_SC_BK17_37_L      _PK_L_(0x17, 0x37)
#define REG_SC_BK17_37_H      _PK_H_(0x17, 0x37)
#define REG_SC_BK17_38_L      _PK_L_(0x17, 0x38)
#define REG_SC_BK17_38_H      _PK_H_(0x17, 0x38)
#define REG_SC_BK17_39_L      _PK_L_(0x17, 0x39)
#define REG_SC_BK17_39_H      _PK_H_(0x17, 0x39)
#define REG_SC_BK17_3A_L      _PK_L_(0x17, 0x3A)
#define REG_SC_BK17_3A_H      _PK_H_(0x17, 0x3A)
#define REG_SC_BK17_3B_L      _PK_L_(0x17, 0x3B)
#define REG_SC_BK17_3B_H      _PK_H_(0x17, 0x3B)
#define REG_SC_BK17_3C_L      _PK_L_(0x17, 0x3C)
#define REG_SC_BK17_3C_H      _PK_H_(0x17, 0x3C)
#define REG_SC_BK17_3D_L      _PK_L_(0x17, 0x3D)
#define REG_SC_BK17_3D_H      _PK_H_(0x17, 0x3D)
#define REG_SC_BK17_3E_L      _PK_L_(0x17, 0x3E)
#define REG_SC_BK17_3E_H      _PK_H_(0x17, 0x3E)
#define REG_SC_BK17_3F_L      _PK_L_(0x17, 0x3F)
#define REG_SC_BK17_3F_H      _PK_H_(0x17, 0x3F)
#define REG_SC_BK17_40_L      _PK_L_(0x17, 0x40)
#define REG_SC_BK17_40_H      _PK_H_(0x17, 0x40)
#define REG_SC_BK17_41_L      _PK_L_(0x17, 0x41)
#define REG_SC_BK17_41_H      _PK_H_(0x17, 0x41)
#define REG_SC_BK17_42_L      _PK_L_(0x17, 0x42)
#define REG_SC_BK17_42_H      _PK_H_(0x17, 0x42)
#define REG_SC_BK17_43_L      _PK_L_(0x17, 0x43)
#define REG_SC_BK17_43_H      _PK_H_(0x17, 0x43)
#define REG_SC_BK17_44_L      _PK_L_(0x17, 0x44)
#define REG_SC_BK17_44_H      _PK_H_(0x17, 0x44)
#define REG_SC_BK17_45_L      _PK_L_(0x17, 0x45)
#define REG_SC_BK17_45_H      _PK_H_(0x17, 0x45)
#define REG_SC_BK17_46_L      _PK_L_(0x17, 0x46)
#define REG_SC_BK17_46_H      _PK_H_(0x17, 0x46)
#define REG_SC_BK17_47_L      _PK_L_(0x17, 0x47)
#define REG_SC_BK17_47_H      _PK_H_(0x17, 0x47)
#define REG_SC_BK17_48_L      _PK_L_(0x17, 0x48)
#define REG_SC_BK17_48_H      _PK_H_(0x17, 0x48)
#define REG_SC_BK17_49_L      _PK_L_(0x17, 0x49)
#define REG_SC_BK17_49_H      _PK_H_(0x17, 0x49)
#define REG_SC_BK17_4A_L      _PK_L_(0x17, 0x4A)
#define REG_SC_BK17_4A_H      _PK_H_(0x17, 0x4A)
#define REG_SC_BK17_4B_L      _PK_L_(0x17, 0x4B)
#define REG_SC_BK17_4B_H      _PK_H_(0x17, 0x4B)
#define REG_SC_BK17_4C_L      _PK_L_(0x17, 0x4C)
#define REG_SC_BK17_4C_H      _PK_H_(0x17, 0x4C)
#define REG_SC_BK17_4D_L      _PK_L_(0x17, 0x4D)
#define REG_SC_BK17_4D_H      _PK_H_(0x17, 0x4D)
#define REG_SC_BK17_4E_L      _PK_L_(0x17, 0x4E)
#define REG_SC_BK17_4E_H      _PK_H_(0x17, 0x4E)
#define REG_SC_BK17_4F_L      _PK_L_(0x17, 0x4F)
#define REG_SC_BK17_4F_H      _PK_H_(0x17, 0x4F)
#define REG_SC_BK17_50_L      _PK_L_(0x17, 0x50)
#define REG_SC_BK17_50_H      _PK_H_(0x17, 0x50)
#define REG_SC_BK17_51_L      _PK_L_(0x17, 0x51)
#define REG_SC_BK17_51_H      _PK_H_(0x17, 0x51)
#define REG_SC_BK17_52_L      _PK_L_(0x17, 0x52)
#define REG_SC_BK17_52_H      _PK_H_(0x17, 0x52)
#define REG_SC_BK17_53_L      _PK_L_(0x17, 0x53)
#define REG_SC_BK17_53_H      _PK_H_(0x17, 0x53)
#define REG_SC_BK17_54_L      _PK_L_(0x17, 0x54)
#define REG_SC_BK17_54_H      _PK_H_(0x17, 0x54)
#define REG_SC_BK17_55_L      _PK_L_(0x17, 0x55)
#define REG_SC_BK17_55_H      _PK_H_(0x17, 0x55)
#define REG_SC_BK17_56_L      _PK_L_(0x17, 0x56)
#define REG_SC_BK17_56_H      _PK_H_(0x17, 0x56)
#define REG_SC_BK17_57_L      _PK_L_(0x17, 0x57)
#define REG_SC_BK17_57_H      _PK_H_(0x17, 0x57)
#define REG_SC_BK17_58_L      _PK_L_(0x17, 0x58)
#define REG_SC_BK17_58_H      _PK_H_(0x17, 0x58)
#define REG_SC_BK17_59_L      _PK_L_(0x17, 0x59)
#define REG_SC_BK17_59_H      _PK_H_(0x17, 0x59)
#define REG_SC_BK17_5A_L      _PK_L_(0x17, 0x5A)
#define REG_SC_BK17_5A_H      _PK_H_(0x17, 0x5A)
#define REG_SC_BK17_5B_L      _PK_L_(0x17, 0x5B)
#define REG_SC_BK17_5B_H      _PK_H_(0x17, 0x5B)
#define REG_SC_BK17_5C_L      _PK_L_(0x17, 0x5C)
#define REG_SC_BK17_5C_H      _PK_H_(0x17, 0x5C)
#define REG_SC_BK17_5D_L      _PK_L_(0x17, 0x5D)
#define REG_SC_BK17_5D_H      _PK_H_(0x17, 0x5D)
#define REG_SC_BK17_5E_L      _PK_L_(0x17, 0x5E)
#define REG_SC_BK17_5E_H      _PK_H_(0x17, 0x5E)
#define REG_SC_BK17_5F_L      _PK_L_(0x17, 0x5F)
#define REG_SC_BK17_5F_H      _PK_H_(0x17, 0x5F)
#define REG_SC_BK17_60_L      _PK_L_(0x17, 0x60)
#define REG_SC_BK17_60_H      _PK_H_(0x17, 0x60)
#define REG_SC_BK17_61_L      _PK_L_(0x17, 0x61)
#define REG_SC_BK17_61_H      _PK_H_(0x17, 0x61)
#define REG_SC_BK17_62_L      _PK_L_(0x17, 0x62)
#define REG_SC_BK17_62_H      _PK_H_(0x17, 0x62)
#define REG_SC_BK17_63_L      _PK_L_(0x17, 0x63)
#define REG_SC_BK17_63_H      _PK_H_(0x17, 0x63)
#define REG_SC_BK17_64_L      _PK_L_(0x17, 0x64)
#define REG_SC_BK17_64_H      _PK_H_(0x17, 0x64)
#define REG_SC_BK17_65_L      _PK_L_(0x17, 0x65)
#define REG_SC_BK17_65_H      _PK_H_(0x17, 0x65)
#define REG_SC_BK17_66_L      _PK_L_(0x17, 0x66)
#define REG_SC_BK17_66_H      _PK_H_(0x17, 0x66)
#define REG_SC_BK17_67_L      _PK_L_(0x17, 0x67)
#define REG_SC_BK17_67_H      _PK_H_(0x17, 0x67)
#define REG_SC_BK17_68_L      _PK_L_(0x17, 0x68)
#define REG_SC_BK17_68_H      _PK_H_(0x17, 0x68)
#define REG_SC_BK17_69_L      _PK_L_(0x17, 0x69)
#define REG_SC_BK17_69_H      _PK_H_(0x17, 0x69)
#define REG_SC_BK17_6A_L      _PK_L_(0x17, 0x6A)
#define REG_SC_BK17_6A_H      _PK_H_(0x17, 0x6A)
#define REG_SC_BK17_6B_L      _PK_L_(0x17, 0x6B)
#define REG_SC_BK17_6B_H      _PK_H_(0x17, 0x6B)
#define REG_SC_BK17_6C_L      _PK_L_(0x17, 0x6C)
#define REG_SC_BK17_6C_H      _PK_H_(0x17, 0x6C)
#define REG_SC_BK17_6D_L      _PK_L_(0x17, 0x6D)
#define REG_SC_BK17_6D_H      _PK_H_(0x17, 0x6D)
#define REG_SC_BK17_6E_L      _PK_L_(0x17, 0x6E)
#define REG_SC_BK17_6E_H      _PK_H_(0x17, 0x6E)
#define REG_SC_BK17_6F_L      _PK_L_(0x17, 0x6F)
#define REG_SC_BK17_6F_H      _PK_H_(0x17, 0x6F)
#define REG_SC_BK17_70_L      _PK_L_(0x17, 0x70)
#define REG_SC_BK17_70_H      _PK_H_(0x17, 0x70)
#define REG_SC_BK17_71_L      _PK_L_(0x17, 0x71)
#define REG_SC_BK17_71_H      _PK_H_(0x17, 0x71)
#define REG_SC_BK17_72_L      _PK_L_(0x17, 0x72)
#define REG_SC_BK17_72_H      _PK_H_(0x17, 0x72)
#define REG_SC_BK17_73_L      _PK_L_(0x17, 0x73)
#define REG_SC_BK17_73_H      _PK_H_(0x17, 0x73)
#define REG_SC_BK17_74_L      _PK_L_(0x17, 0x74)
#define REG_SC_BK17_74_H      _PK_H_(0x17, 0x74)
#define REG_SC_BK17_75_L      _PK_L_(0x17, 0x75)
#define REG_SC_BK17_75_H      _PK_H_(0x17, 0x75)
#define REG_SC_BK17_76_L      _PK_L_(0x17, 0x76)
#define REG_SC_BK17_76_H      _PK_H_(0x17, 0x76)
#define REG_SC_BK17_77_L      _PK_L_(0x17, 0x77)
#define REG_SC_BK17_77_H      _PK_H_(0x17, 0x77)
#define REG_SC_BK17_78_L      _PK_L_(0x17, 0x78)
#define REG_SC_BK17_78_H      _PK_H_(0x17, 0x78)
#define REG_SC_BK17_79_L      _PK_L_(0x17, 0x79)
#define REG_SC_BK17_79_H      _PK_H_(0x17, 0x79)
#define REG_SC_BK17_7A_L      _PK_L_(0x17, 0x7A)
#define REG_SC_BK17_7A_H      _PK_H_(0x17, 0x7A)
#define REG_SC_BK17_7B_L      _PK_L_(0x17, 0x7B)
#define REG_SC_BK17_7B_H      _PK_H_(0x17, 0x7B)
#define REG_SC_BK17_7C_L      _PK_L_(0x17, 0x7C)
#define REG_SC_BK17_7C_H      _PK_H_(0x17, 0x7C)
#define REG_SC_BK17_7D_L      _PK_L_(0x17, 0x7D)
#define REG_SC_BK17_7D_H      _PK_H_(0x17, 0x7D)
#define REG_SC_BK17_7E_L      _PK_L_(0x17, 0x7E)
#define REG_SC_BK17_7E_H      _PK_H_(0x17, 0x7E)
#define REG_SC_BK17_7F_L      _PK_L_(0x17, 0x7F)
#define REG_SC_BK17_7F_H      _PK_H_(0x17, 0x7F)
//----------------------------------------------
#define REG_SC_BK18_00_L      _PK_L_(0x18, 0x00)
#define REG_SC_BK18_00_H      _PK_H_(0x18, 0x00)
#define REG_SC_BK18_01_L      _PK_L_(0x18, 0x01)
#define REG_SC_BK18_01_H      _PK_H_(0x18, 0x01)
#define REG_SC_BK18_02_L      _PK_L_(0x18, 0x02)
#define REG_SC_BK18_02_H      _PK_H_(0x18, 0x02)
#define REG_SC_BK18_03_L      _PK_L_(0x18, 0x03)
#define REG_SC_BK18_03_H      _PK_H_(0x18, 0x03)
#define REG_SC_BK18_04_L      _PK_L_(0x18, 0x04)
#define REG_SC_BK18_04_H      _PK_H_(0x18, 0x04)
#define REG_SC_BK18_05_L      _PK_L_(0x18, 0x05)
#define REG_SC_BK18_05_H      _PK_H_(0x18, 0x05)
#define REG_SC_BK18_06_L      _PK_L_(0x18, 0x06)
#define REG_SC_BK18_06_H      _PK_H_(0x18, 0x06)
#define REG_SC_BK18_07_L      _PK_L_(0x18, 0x07)
#define REG_SC_BK18_07_H      _PK_H_(0x18, 0x07)
#define REG_SC_BK18_08_L      _PK_L_(0x18, 0x08)
#define REG_SC_BK18_08_H      _PK_H_(0x18, 0x08)
#define REG_SC_BK18_09_L      _PK_L_(0x18, 0x09)
#define REG_SC_BK18_09_H      _PK_H_(0x18, 0x09)
#define REG_SC_BK18_0A_L      _PK_L_(0x18, 0x0A)
#define REG_SC_BK18_0A_H      _PK_H_(0x18, 0x0A)
#define REG_SC_BK18_0B_L      _PK_L_(0x18, 0x0B)
#define REG_SC_BK18_0B_H      _PK_H_(0x18, 0x0B)
#define REG_SC_BK18_0C_L      _PK_L_(0x18, 0x0C)
#define REG_SC_BK18_0C_H      _PK_H_(0x18, 0x0C)
#define REG_SC_BK18_0D_L      _PK_L_(0x18, 0x0D)
#define REG_SC_BK18_0D_H      _PK_H_(0x18, 0x0D)
#define REG_SC_BK18_0E_L      _PK_L_(0x18, 0x0E)
#define REG_SC_BK18_0E_H      _PK_H_(0x18, 0x0E)
#define REG_SC_BK18_0F_L      _PK_L_(0x18, 0x0F)
#define REG_SC_BK18_0F_H      _PK_H_(0x18, 0x0F)
#define REG_SC_BK18_10_L      _PK_L_(0x18, 0x10)
#define REG_SC_BK18_10_H      _PK_H_(0x18, 0x10)
#define REG_SC_BK18_11_L      _PK_L_(0x18, 0x11)
#define REG_SC_BK18_11_H      _PK_H_(0x18, 0x11)
#define REG_SC_BK18_12_L      _PK_L_(0x18, 0x12)
#define REG_SC_BK18_12_H      _PK_H_(0x18, 0x12)
#define REG_SC_BK18_13_L      _PK_L_(0x18, 0x13)
#define REG_SC_BK18_13_H      _PK_H_(0x18, 0x13)
#define REG_SC_BK18_14_L      _PK_L_(0x18, 0x14)
#define REG_SC_BK18_14_H      _PK_H_(0x18, 0x14)
#define REG_SC_BK18_15_L      _PK_L_(0x18, 0x15)
#define REG_SC_BK18_15_H      _PK_H_(0x18, 0x15)
#define REG_SC_BK18_16_L      _PK_L_(0x18, 0x16)
#define REG_SC_BK18_16_H      _PK_H_(0x18, 0x16)
#define REG_SC_BK18_17_L      _PK_L_(0x18, 0x17)
#define REG_SC_BK18_17_H      _PK_H_(0x18, 0x17)
#define REG_SC_BK18_18_L      _PK_L_(0x18, 0x18)
#define REG_SC_BK18_18_H      _PK_H_(0x18, 0x18)
#define REG_SC_BK18_19_L      _PK_L_(0x18, 0x19)
#define REG_SC_BK18_19_H      _PK_H_(0x18, 0x19)
#define REG_SC_BK18_1A_L      _PK_L_(0x18, 0x1A)
#define REG_SC_BK18_1A_H      _PK_H_(0x18, 0x1A)
#define REG_SC_BK18_1B_L      _PK_L_(0x18, 0x1B)
#define REG_SC_BK18_1B_H      _PK_H_(0x18, 0x1B)
#define REG_SC_BK18_1C_L      _PK_L_(0x18, 0x1C)
#define REG_SC_BK18_1C_H      _PK_H_(0x18, 0x1C)
#define REG_SC_BK18_1D_L      _PK_L_(0x18, 0x1D)
#define REG_SC_BK18_1D_H      _PK_H_(0x18, 0x1D)
#define REG_SC_BK18_1E_L      _PK_L_(0x18, 0x1E)
#define REG_SC_BK18_1E_H      _PK_H_(0x18, 0x1E)
#define REG_SC_BK18_1F_L      _PK_L_(0x18, 0x1F)
#define REG_SC_BK18_1F_H      _PK_H_(0x18, 0x1F)
#define REG_SC_BK18_20_L      _PK_L_(0x18, 0x20)
#define REG_SC_BK18_20_H      _PK_H_(0x18, 0x20)
#define REG_SC_BK18_21_L      _PK_L_(0x18, 0x21)
#define REG_SC_BK18_21_H      _PK_H_(0x18, 0x21)
#define REG_SC_BK18_22_L      _PK_L_(0x18, 0x22)
#define REG_SC_BK18_22_H      _PK_H_(0x18, 0x22)
#define REG_SC_BK18_23_L      _PK_L_(0x18, 0x23)
#define REG_SC_BK18_23_H      _PK_H_(0x18, 0x23)
#define REG_SC_BK18_24_L      _PK_L_(0x18, 0x24)
#define REG_SC_BK18_24_H      _PK_H_(0x18, 0x24)
#define REG_SC_BK18_25_L      _PK_L_(0x18, 0x25)
#define REG_SC_BK18_25_H      _PK_H_(0x18, 0x25)
#define REG_SC_BK18_26_L      _PK_L_(0x18, 0x26)
#define REG_SC_BK18_26_H      _PK_H_(0x18, 0x26)
#define REG_SC_BK18_27_L      _PK_L_(0x18, 0x27)
#define REG_SC_BK18_27_H      _PK_H_(0x18, 0x27)
#define REG_SC_BK18_28_L      _PK_L_(0x18, 0x28)
#define REG_SC_BK18_28_H      _PK_H_(0x18, 0x28)
#define REG_SC_BK18_29_L      _PK_L_(0x18, 0x29)
#define REG_SC_BK18_29_H      _PK_H_(0x18, 0x29)
#define REG_SC_BK18_2A_L      _PK_L_(0x18, 0x2A)
#define REG_SC_BK18_2A_H      _PK_H_(0x18, 0x2A)
#define REG_SC_BK18_2B_L      _PK_L_(0x18, 0x2B)
#define REG_SC_BK18_2B_H      _PK_H_(0x18, 0x2B)
#define REG_SC_BK18_2C_L      _PK_L_(0x18, 0x2C)
#define REG_SC_BK18_2C_H      _PK_H_(0x18, 0x2C)
#define REG_SC_BK18_2D_L      _PK_L_(0x18, 0x2D)
#define REG_SC_BK18_2D_H      _PK_H_(0x18, 0x2D)
#define REG_SC_BK18_2E_L      _PK_L_(0x18, 0x2E)
#define REG_SC_BK18_2E_H      _PK_H_(0x18, 0x2E)
#define REG_SC_BK18_2F_L      _PK_L_(0x18, 0x2F)
#define REG_SC_BK18_2F_H      _PK_H_(0x18, 0x2F)
#define REG_SC_BK18_30_L      _PK_L_(0x18, 0x30)
#define REG_SC_BK18_30_H      _PK_H_(0x18, 0x30)
#define REG_SC_BK18_31_L      _PK_L_(0x18, 0x31)
#define REG_SC_BK18_31_H      _PK_H_(0x18, 0x31)
#define REG_SC_BK18_32_L      _PK_L_(0x18, 0x32)
#define REG_SC_BK18_32_H      _PK_H_(0x18, 0x32)
#define REG_SC_BK18_33_L      _PK_L_(0x18, 0x33)
#define REG_SC_BK18_33_H      _PK_H_(0x18, 0x33)
#define REG_SC_BK18_34_L      _PK_L_(0x18, 0x34)
#define REG_SC_BK18_34_H      _PK_H_(0x18, 0x34)
#define REG_SC_BK18_35_L      _PK_L_(0x18, 0x35)
#define REG_SC_BK18_35_H      _PK_H_(0x18, 0x35)
#define REG_SC_BK18_36_L      _PK_L_(0x18, 0x36)
#define REG_SC_BK18_36_H      _PK_H_(0x18, 0x36)
#define REG_SC_BK18_37_L      _PK_L_(0x18, 0x37)
#define REG_SC_BK18_37_H      _PK_H_(0x18, 0x37)
#define REG_SC_BK18_38_L      _PK_L_(0x18, 0x38)
#define REG_SC_BK18_38_H      _PK_H_(0x18, 0x38)
#define REG_SC_BK18_39_L      _PK_L_(0x18, 0x39)
#define REG_SC_BK18_39_H      _PK_H_(0x18, 0x39)
#define REG_SC_BK18_3A_L      _PK_L_(0x18, 0x3A)
#define REG_SC_BK18_3A_H      _PK_H_(0x18, 0x3A)
#define REG_SC_BK18_3B_L      _PK_L_(0x18, 0x3B)
#define REG_SC_BK18_3B_H      _PK_H_(0x18, 0x3B)
#define REG_SC_BK18_3C_L      _PK_L_(0x18, 0x3C)
#define REG_SC_BK18_3C_H      _PK_H_(0x18, 0x3C)
#define REG_SC_BK18_3D_L      _PK_L_(0x18, 0x3D)
#define REG_SC_BK18_3D_H      _PK_H_(0x18, 0x3D)
#define REG_SC_BK18_3E_L      _PK_L_(0x18, 0x3E)
#define REG_SC_BK18_3E_H      _PK_H_(0x18, 0x3E)
#define REG_SC_BK18_3F_L      _PK_L_(0x18, 0x3F)
#define REG_SC_BK18_3F_H      _PK_H_(0x18, 0x3F)
#define REG_SC_BK18_40_L      _PK_L_(0x18, 0x40)
#define REG_SC_BK18_40_H      _PK_H_(0x18, 0x40)
#define REG_SC_BK18_41_L      _PK_L_(0x18, 0x41)
#define REG_SC_BK18_41_H      _PK_H_(0x18, 0x41)
#define REG_SC_BK18_42_L      _PK_L_(0x18, 0x42)
#define REG_SC_BK18_42_H      _PK_H_(0x18, 0x42)
#define REG_SC_BK18_43_L      _PK_L_(0x18, 0x43)
#define REG_SC_BK18_43_H      _PK_H_(0x18, 0x43)
#define REG_SC_BK18_44_L      _PK_L_(0x18, 0x44)
#define REG_SC_BK18_44_H      _PK_H_(0x18, 0x44)
#define REG_SC_BK18_45_L      _PK_L_(0x18, 0x45)
#define REG_SC_BK18_45_H      _PK_H_(0x18, 0x45)
#define REG_SC_BK18_46_L      _PK_L_(0x18, 0x46)
#define REG_SC_BK18_46_H      _PK_H_(0x18, 0x46)
#define REG_SC_BK18_47_L      _PK_L_(0x18, 0x47)
#define REG_SC_BK18_47_H      _PK_H_(0x18, 0x47)
#define REG_SC_BK18_48_L      _PK_L_(0x18, 0x48)
#define REG_SC_BK18_48_H      _PK_H_(0x18, 0x48)
#define REG_SC_BK18_49_L      _PK_L_(0x18, 0x49)
#define REG_SC_BK18_49_H      _PK_H_(0x18, 0x49)
#define REG_SC_BK18_4A_L      _PK_L_(0x18, 0x4A)
#define REG_SC_BK18_4A_H      _PK_H_(0x18, 0x4A)
#define REG_SC_BK18_4B_L      _PK_L_(0x18, 0x4B)
#define REG_SC_BK18_4B_H      _PK_H_(0x18, 0x4B)
#define REG_SC_BK18_4C_L      _PK_L_(0x18, 0x4C)
#define REG_SC_BK18_4C_H      _PK_H_(0x18, 0x4C)
#define REG_SC_BK18_4D_L      _PK_L_(0x18, 0x4D)
#define REG_SC_BK18_4D_H      _PK_H_(0x18, 0x4D)
#define REG_SC_BK18_4E_L      _PK_L_(0x18, 0x4E)
#define REG_SC_BK18_4E_H      _PK_H_(0x18, 0x4E)
#define REG_SC_BK18_4F_L      _PK_L_(0x18, 0x4F)
#define REG_SC_BK18_4F_H      _PK_H_(0x18, 0x4F)
#define REG_SC_BK18_50_L      _PK_L_(0x18, 0x50)
#define REG_SC_BK18_50_H      _PK_H_(0x18, 0x50)
#define REG_SC_BK18_51_L      _PK_L_(0x18, 0x51)
#define REG_SC_BK18_51_H      _PK_H_(0x18, 0x51)
#define REG_SC_BK18_52_L      _PK_L_(0x18, 0x52)
#define REG_SC_BK18_52_H      _PK_H_(0x18, 0x52)
#define REG_SC_BK18_53_L      _PK_L_(0x18, 0x53)
#define REG_SC_BK18_53_H      _PK_H_(0x18, 0x53)
#define REG_SC_BK18_54_L      _PK_L_(0x18, 0x54)
#define REG_SC_BK18_54_H      _PK_H_(0x18, 0x54)
#define REG_SC_BK18_55_L      _PK_L_(0x18, 0x55)
#define REG_SC_BK18_55_H      _PK_H_(0x18, 0x55)
#define REG_SC_BK18_56_L      _PK_L_(0x18, 0x56)
#define REG_SC_BK18_56_H      _PK_H_(0x18, 0x56)
#define REG_SC_BK18_57_L      _PK_L_(0x18, 0x57)
#define REG_SC_BK18_57_H      _PK_H_(0x18, 0x57)
#define REG_SC_BK18_58_L      _PK_L_(0x18, 0x58)
#define REG_SC_BK18_58_H      _PK_H_(0x18, 0x58)
#define REG_SC_BK18_59_L      _PK_L_(0x18, 0x59)
#define REG_SC_BK18_59_H      _PK_H_(0x18, 0x59)
#define REG_SC_BK18_5A_L      _PK_L_(0x18, 0x5A)
#define REG_SC_BK18_5A_H      _PK_H_(0x18, 0x5A)
#define REG_SC_BK18_5B_L      _PK_L_(0x18, 0x5B)
#define REG_SC_BK18_5B_H      _PK_H_(0x18, 0x5B)
#define REG_SC_BK18_5C_L      _PK_L_(0x18, 0x5C)
#define REG_SC_BK18_5C_H      _PK_H_(0x18, 0x5C)
#define REG_SC_BK18_5D_L      _PK_L_(0x18, 0x5D)
#define REG_SC_BK18_5D_H      _PK_H_(0x18, 0x5D)
#define REG_SC_BK18_5E_L      _PK_L_(0x18, 0x5E)
#define REG_SC_BK18_5E_H      _PK_H_(0x18, 0x5E)
#define REG_SC_BK18_5F_L      _PK_L_(0x18, 0x5F)
#define REG_SC_BK18_5F_H      _PK_H_(0x18, 0x5F)
#define REG_SC_BK18_60_L      _PK_L_(0x18, 0x60)
#define REG_SC_BK18_60_H      _PK_H_(0x18, 0x60)
#define REG_SC_BK18_61_L      _PK_L_(0x18, 0x61)
#define REG_SC_BK18_61_H      _PK_H_(0x18, 0x61)
#define REG_SC_BK18_62_L      _PK_L_(0x18, 0x62)
#define REG_SC_BK18_62_H      _PK_H_(0x18, 0x62)
#define REG_SC_BK18_63_L      _PK_L_(0x18, 0x63)
#define REG_SC_BK18_63_H      _PK_H_(0x18, 0x63)
#define REG_SC_BK18_64_L      _PK_L_(0x18, 0x64)
#define REG_SC_BK18_64_H      _PK_H_(0x18, 0x64)
#define REG_SC_BK18_65_L      _PK_L_(0x18, 0x65)
#define REG_SC_BK18_65_H      _PK_H_(0x18, 0x65)
#define REG_SC_BK18_66_L      _PK_L_(0x18, 0x66)
#define REG_SC_BK18_66_H      _PK_H_(0x18, 0x66)
#define REG_SC_BK18_67_L      _PK_L_(0x18, 0x67)
#define REG_SC_BK18_67_H      _PK_H_(0x18, 0x67)
#define REG_SC_BK18_68_L      _PK_L_(0x18, 0x68)
#define REG_SC_BK18_68_H      _PK_H_(0x18, 0x68)
#define REG_SC_BK18_69_L      _PK_L_(0x18, 0x69)
#define REG_SC_BK18_69_H      _PK_H_(0x18, 0x69)
#define REG_SC_BK18_6A_L      _PK_L_(0x18, 0x6A)
#define REG_SC_BK18_6A_H      _PK_H_(0x18, 0x6A)
#define REG_SC_BK18_6B_L      _PK_L_(0x18, 0x6B)
#define REG_SC_BK18_6B_H      _PK_H_(0x18, 0x6B)
#define REG_SC_BK18_6C_L      _PK_L_(0x18, 0x6C)
#define REG_SC_BK18_6C_H      _PK_H_(0x18, 0x6C)
#define REG_SC_BK18_6D_L      _PK_L_(0x18, 0x6D)
#define REG_SC_BK18_6D_H      _PK_H_(0x18, 0x6D)
#define REG_SC_BK18_6E_L      _PK_L_(0x18, 0x6E)
#define REG_SC_BK18_6E_H      _PK_H_(0x18, 0x6E)
#define REG_SC_BK18_6F_L      _PK_L_(0x18, 0x6F)
#define REG_SC_BK18_6F_H      _PK_H_(0x18, 0x6F)
#define REG_SC_BK18_70_L      _PK_L_(0x18, 0x70)
#define REG_SC_BK18_70_H      _PK_H_(0x18, 0x70)
#define REG_SC_BK18_71_L      _PK_L_(0x18, 0x71)
#define REG_SC_BK18_71_H      _PK_H_(0x18, 0x71)
#define REG_SC_BK18_72_L      _PK_L_(0x18, 0x72)
#define REG_SC_BK18_72_H      _PK_H_(0x18, 0x72)
#define REG_SC_BK18_73_L      _PK_L_(0x18, 0x73)
#define REG_SC_BK18_73_H      _PK_H_(0x18, 0x73)
#define REG_SC_BK18_74_L      _PK_L_(0x18, 0x74)
#define REG_SC_BK18_74_H      _PK_H_(0x18, 0x74)
#define REG_SC_BK18_75_L      _PK_L_(0x18, 0x75)
#define REG_SC_BK18_75_H      _PK_H_(0x18, 0x75)
#define REG_SC_BK18_76_L      _PK_L_(0x18, 0x76)
#define REG_SC_BK18_76_H      _PK_H_(0x18, 0x76)
#define REG_SC_BK18_77_L      _PK_L_(0x18, 0x77)
#define REG_SC_BK18_77_H      _PK_H_(0x18, 0x77)
#define REG_SC_BK18_78_L      _PK_L_(0x18, 0x78)
#define REG_SC_BK18_78_H      _PK_H_(0x18, 0x78)
#define REG_SC_BK18_79_L      _PK_L_(0x18, 0x79)
#define REG_SC_BK18_79_H      _PK_H_(0x18, 0x79)
#define REG_SC_BK18_7A_L      _PK_L_(0x18, 0x7A)
#define REG_SC_BK18_7A_H      _PK_H_(0x18, 0x7A)
#define REG_SC_BK18_7B_L      _PK_L_(0x18, 0x7B)
#define REG_SC_BK18_7B_H      _PK_H_(0x18, 0x7B)
#define REG_SC_BK18_7C_L      _PK_L_(0x18, 0x7C)
#define REG_SC_BK18_7C_H      _PK_H_(0x18, 0x7C)
#define REG_SC_BK18_7D_L      _PK_L_(0x18, 0x7D)
#define REG_SC_BK18_7D_H      _PK_H_(0x18, 0x7D)
#define REG_SC_BK18_7E_L      _PK_L_(0x18, 0x7E)
#define REG_SC_BK18_7E_H      _PK_H_(0x18, 0x7E)
#define REG_SC_BK18_7F_L      _PK_L_(0x18, 0x7F)
#define REG_SC_BK18_7F_H      _PK_H_(0x18, 0x7F)
//----------------------------------------------
#define REG_SC_BK19_00_L      _PK_L_(0x19, 0x00)
#define REG_SC_BK19_00_H      _PK_H_(0x19, 0x00)
#define REG_SC_BK19_01_L      _PK_L_(0x19, 0x01)
#define REG_SC_BK19_01_H      _PK_H_(0x19, 0x01)
#define REG_SC_BK19_02_L      _PK_L_(0x19, 0x02)
#define REG_SC_BK19_02_H      _PK_H_(0x19, 0x02)
#define REG_SC_BK19_03_L      _PK_L_(0x19, 0x03)
#define REG_SC_BK19_03_H      _PK_H_(0x19, 0x03)
#define REG_SC_BK19_04_L      _PK_L_(0x19, 0x04)
#define REG_SC_BK19_04_H      _PK_H_(0x19, 0x04)
#define REG_SC_BK19_05_L      _PK_L_(0x19, 0x05)
#define REG_SC_BK19_05_H      _PK_H_(0x19, 0x05)
#define REG_SC_BK19_06_L      _PK_L_(0x19, 0x06)
#define REG_SC_BK19_06_H      _PK_H_(0x19, 0x06)
#define REG_SC_BK19_07_L      _PK_L_(0x19, 0x07)
#define REG_SC_BK19_07_H      _PK_H_(0x19, 0x07)
#define REG_SC_BK19_08_L      _PK_L_(0x19, 0x08)
#define REG_SC_BK19_08_H      _PK_H_(0x19, 0x08)
#define REG_SC_BK19_09_L      _PK_L_(0x19, 0x09)
#define REG_SC_BK19_09_H      _PK_H_(0x19, 0x09)
#define REG_SC_BK19_0A_L      _PK_L_(0x19, 0x0A)
#define REG_SC_BK19_0A_H      _PK_H_(0x19, 0x0A)
#define REG_SC_BK19_0B_L      _PK_L_(0x19, 0x0B)
#define REG_SC_BK19_0B_H      _PK_H_(0x19, 0x0B)
#define REG_SC_BK19_0C_L      _PK_L_(0x19, 0x0C)
#define REG_SC_BK19_0C_H      _PK_H_(0x19, 0x0C)
#define REG_SC_BK19_0D_L      _PK_L_(0x19, 0x0D)
#define REG_SC_BK19_0D_H      _PK_H_(0x19, 0x0D)
#define REG_SC_BK19_0E_L      _PK_L_(0x19, 0x0E)
#define REG_SC_BK19_0E_H      _PK_H_(0x19, 0x0E)
#define REG_SC_BK19_0F_L      _PK_L_(0x19, 0x0F)
#define REG_SC_BK19_0F_H      _PK_H_(0x19, 0x0F)
#define REG_SC_BK19_10_L      _PK_L_(0x19, 0x10)
#define REG_SC_BK19_10_H      _PK_H_(0x19, 0x10)
#define REG_SC_BK19_11_L      _PK_L_(0x19, 0x11)
#define REG_SC_BK19_11_H      _PK_H_(0x19, 0x11)
#define REG_SC_BK19_12_L      _PK_L_(0x19, 0x12)
#define REG_SC_BK19_12_H      _PK_H_(0x19, 0x12)
#define REG_SC_BK19_13_L      _PK_L_(0x19, 0x13)
#define REG_SC_BK19_13_H      _PK_H_(0x19, 0x13)
#define REG_SC_BK19_14_L      _PK_L_(0x19, 0x14)
#define REG_SC_BK19_14_H      _PK_H_(0x19, 0x14)
#define REG_SC_BK19_15_L      _PK_L_(0x19, 0x15)
#define REG_SC_BK19_15_H      _PK_H_(0x19, 0x15)
#define REG_SC_BK19_16_L      _PK_L_(0x19, 0x16)
#define REG_SC_BK19_16_H      _PK_H_(0x19, 0x16)
#define REG_SC_BK19_17_L      _PK_L_(0x19, 0x17)
#define REG_SC_BK19_17_H      _PK_H_(0x19, 0x17)
#define REG_SC_BK19_18_L      _PK_L_(0x19, 0x18)
#define REG_SC_BK19_18_H      _PK_H_(0x19, 0x18)
#define REG_SC_BK19_19_L      _PK_L_(0x19, 0x19)
#define REG_SC_BK19_19_H      _PK_H_(0x19, 0x19)
#define REG_SC_BK19_1A_L      _PK_L_(0x19, 0x1A)
#define REG_SC_BK19_1A_H      _PK_H_(0x19, 0x1A)
#define REG_SC_BK19_1B_L      _PK_L_(0x19, 0x1B)
#define REG_SC_BK19_1B_H      _PK_H_(0x19, 0x1B)
#define REG_SC_BK19_1C_L      _PK_L_(0x19, 0x1C)
#define REG_SC_BK19_1C_H      _PK_H_(0x19, 0x1C)
#define REG_SC_BK19_1D_L      _PK_L_(0x19, 0x1D)
#define REG_SC_BK19_1D_H      _PK_H_(0x19, 0x1D)
#define REG_SC_BK19_1E_L      _PK_L_(0x19, 0x1E)
#define REG_SC_BK19_1E_H      _PK_H_(0x19, 0x1E)
#define REG_SC_BK19_1F_L      _PK_L_(0x19, 0x1F)
#define REG_SC_BK19_1F_H      _PK_H_(0x19, 0x1F)
#define REG_SC_BK19_20_L      _PK_L_(0x19, 0x20)
#define REG_SC_BK19_20_H      _PK_H_(0x19, 0x20)
#define REG_SC_BK19_21_L      _PK_L_(0x19, 0x21)
#define REG_SC_BK19_21_H      _PK_H_(0x19, 0x21)
#define REG_SC_BK19_22_L      _PK_L_(0x19, 0x22)
#define REG_SC_BK19_22_H      _PK_H_(0x19, 0x22)
#define REG_SC_BK19_23_L      _PK_L_(0x19, 0x23)
#define REG_SC_BK19_23_H      _PK_H_(0x19, 0x23)
#define REG_SC_BK19_24_L      _PK_L_(0x19, 0x24)
#define REG_SC_BK19_24_H      _PK_H_(0x19, 0x24)
#define REG_SC_BK19_25_L      _PK_L_(0x19, 0x25)
#define REG_SC_BK19_25_H      _PK_H_(0x19, 0x25)
#define REG_SC_BK19_26_L      _PK_L_(0x19, 0x26)
#define REG_SC_BK19_26_H      _PK_H_(0x19, 0x26)
#define REG_SC_BK19_27_L      _PK_L_(0x19, 0x27)
#define REG_SC_BK19_27_H      _PK_H_(0x19, 0x27)
#define REG_SC_BK19_28_L      _PK_L_(0x19, 0x28)
#define REG_SC_BK19_28_H      _PK_H_(0x19, 0x28)
#define REG_SC_BK19_29_L      _PK_L_(0x19, 0x29)
#define REG_SC_BK19_29_H      _PK_H_(0x19, 0x29)
#define REG_SC_BK19_2A_L      _PK_L_(0x19, 0x2A)
#define REG_SC_BK19_2A_H      _PK_H_(0x19, 0x2A)
#define REG_SC_BK19_2B_L      _PK_L_(0x19, 0x2B)
#define REG_SC_BK19_2B_H      _PK_H_(0x19, 0x2B)
#define REG_SC_BK19_2C_L      _PK_L_(0x19, 0x2C)
#define REG_SC_BK19_2C_H      _PK_H_(0x19, 0x2C)
#define REG_SC_BK19_2D_L      _PK_L_(0x19, 0x2D)
#define REG_SC_BK19_2D_H      _PK_H_(0x19, 0x2D)
#define REG_SC_BK19_2E_L      _PK_L_(0x19, 0x2E)
#define REG_SC_BK19_2E_H      _PK_H_(0x19, 0x2E)
#define REG_SC_BK19_2F_L      _PK_L_(0x19, 0x2F)
#define REG_SC_BK19_2F_H      _PK_H_(0x19, 0x2F)
#define REG_SC_BK19_30_L      _PK_L_(0x19, 0x30)
#define REG_SC_BK19_30_H      _PK_H_(0x19, 0x30)
#define REG_SC_BK19_31_L      _PK_L_(0x19, 0x31)
#define REG_SC_BK19_31_H      _PK_H_(0x19, 0x31)
#define REG_SC_BK19_32_L      _PK_L_(0x19, 0x32)
#define REG_SC_BK19_32_H      _PK_H_(0x19, 0x32)
#define REG_SC_BK19_33_L      _PK_L_(0x19, 0x33)
#define REG_SC_BK19_33_H      _PK_H_(0x19, 0x33)
#define REG_SC_BK19_34_L      _PK_L_(0x19, 0x34)
#define REG_SC_BK19_34_H      _PK_H_(0x19, 0x34)
#define REG_SC_BK19_35_L      _PK_L_(0x19, 0x35)
#define REG_SC_BK19_35_H      _PK_H_(0x19, 0x35)
#define REG_SC_BK19_36_L      _PK_L_(0x19, 0x36)
#define REG_SC_BK19_36_H      _PK_H_(0x19, 0x36)
#define REG_SC_BK19_37_L      _PK_L_(0x19, 0x37)
#define REG_SC_BK19_37_H      _PK_H_(0x19, 0x37)
#define REG_SC_BK19_38_L      _PK_L_(0x19, 0x38)
#define REG_SC_BK19_38_H      _PK_H_(0x19, 0x38)
#define REG_SC_BK19_39_L      _PK_L_(0x19, 0x39)
#define REG_SC_BK19_39_H      _PK_H_(0x19, 0x39)
#define REG_SC_BK19_3A_L      _PK_L_(0x19, 0x3A)
#define REG_SC_BK19_3A_H      _PK_H_(0x19, 0x3A)
#define REG_SC_BK19_3B_L      _PK_L_(0x19, 0x3B)
#define REG_SC_BK19_3B_H      _PK_H_(0x19, 0x3B)
#define REG_SC_BK19_3C_L      _PK_L_(0x19, 0x3C)
#define REG_SC_BK19_3C_H      _PK_H_(0x19, 0x3C)
#define REG_SC_BK19_3D_L      _PK_L_(0x19, 0x3D)
#define REG_SC_BK19_3D_H      _PK_H_(0x19, 0x3D)
#define REG_SC_BK19_3E_L      _PK_L_(0x19, 0x3E)
#define REG_SC_BK19_3E_H      _PK_H_(0x19, 0x3E)
#define REG_SC_BK19_3F_L      _PK_L_(0x19, 0x3F)
#define REG_SC_BK19_3F_H      _PK_H_(0x19, 0x3F)
#define REG_SC_BK19_40_L      _PK_L_(0x19, 0x40)
#define REG_SC_BK19_40_H      _PK_H_(0x19, 0x40)
#define REG_SC_BK19_41_L      _PK_L_(0x19, 0x41)
#define REG_SC_BK19_41_H      _PK_H_(0x19, 0x41)
#define REG_SC_BK19_42_L      _PK_L_(0x19, 0x42)
#define REG_SC_BK19_42_H      _PK_H_(0x19, 0x42)
#define REG_SC_BK19_43_L      _PK_L_(0x19, 0x43)
#define REG_SC_BK19_43_H      _PK_H_(0x19, 0x43)
#define REG_SC_BK19_44_L      _PK_L_(0x19, 0x44)
#define REG_SC_BK19_44_H      _PK_H_(0x19, 0x44)
#define REG_SC_BK19_45_L      _PK_L_(0x19, 0x45)
#define REG_SC_BK19_45_H      _PK_H_(0x19, 0x45)
#define REG_SC_BK19_46_L      _PK_L_(0x19, 0x46)
#define REG_SC_BK19_46_H      _PK_H_(0x19, 0x46)
#define REG_SC_BK19_47_L      _PK_L_(0x19, 0x47)
#define REG_SC_BK19_47_H      _PK_H_(0x19, 0x47)
#define REG_SC_BK19_48_L      _PK_L_(0x19, 0x48)
#define REG_SC_BK19_48_H      _PK_H_(0x19, 0x48)
#define REG_SC_BK19_49_L      _PK_L_(0x19, 0x49)
#define REG_SC_BK19_49_H      _PK_H_(0x19, 0x49)
#define REG_SC_BK19_4A_L      _PK_L_(0x19, 0x4A)
#define REG_SC_BK19_4A_H      _PK_H_(0x19, 0x4A)
#define REG_SC_BK19_4B_L      _PK_L_(0x19, 0x4B)
#define REG_SC_BK19_4B_H      _PK_H_(0x19, 0x4B)
#define REG_SC_BK19_4C_L      _PK_L_(0x19, 0x4C)
#define REG_SC_BK19_4C_H      _PK_H_(0x19, 0x4C)
#define REG_SC_BK19_4D_L      _PK_L_(0x19, 0x4D)
#define REG_SC_BK19_4D_H      _PK_H_(0x19, 0x4D)
#define REG_SC_BK19_4E_L      _PK_L_(0x19, 0x4E)
#define REG_SC_BK19_4E_H      _PK_H_(0x19, 0x4E)
#define REG_SC_BK19_4F_L      _PK_L_(0x19, 0x4F)
#define REG_SC_BK19_4F_H      _PK_H_(0x19, 0x4F)
#define REG_SC_BK19_50_L      _PK_L_(0x19, 0x50)
#define REG_SC_BK19_50_H      _PK_H_(0x19, 0x50)
#define REG_SC_BK19_51_L      _PK_L_(0x19, 0x51)
#define REG_SC_BK19_51_H      _PK_H_(0x19, 0x51)
#define REG_SC_BK19_52_L      _PK_L_(0x19, 0x52)
#define REG_SC_BK19_52_H      _PK_H_(0x19, 0x52)
#define REG_SC_BK19_53_L      _PK_L_(0x19, 0x53)
#define REG_SC_BK19_53_H      _PK_H_(0x19, 0x53)
#define REG_SC_BK19_54_L      _PK_L_(0x19, 0x54)
#define REG_SC_BK19_54_H      _PK_H_(0x19, 0x54)
#define REG_SC_BK19_55_L      _PK_L_(0x19, 0x55)
#define REG_SC_BK19_55_H      _PK_H_(0x19, 0x55)
#define REG_SC_BK19_56_L      _PK_L_(0x19, 0x56)
#define REG_SC_BK19_56_H      _PK_H_(0x19, 0x56)
#define REG_SC_BK19_57_L      _PK_L_(0x19, 0x57)
#define REG_SC_BK19_57_H      _PK_H_(0x19, 0x57)
#define REG_SC_BK19_58_L      _PK_L_(0x19, 0x58)
#define REG_SC_BK19_58_H      _PK_H_(0x19, 0x58)
#define REG_SC_BK19_59_L      _PK_L_(0x19, 0x59)
#define REG_SC_BK19_59_H      _PK_H_(0x19, 0x59)
#define REG_SC_BK19_5A_L      _PK_L_(0x19, 0x5A)
#define REG_SC_BK19_5A_H      _PK_H_(0x19, 0x5A)
#define REG_SC_BK19_5B_L      _PK_L_(0x19, 0x5B)
#define REG_SC_BK19_5B_H      _PK_H_(0x19, 0x5B)
#define REG_SC_BK19_5C_L      _PK_L_(0x19, 0x5C)
#define REG_SC_BK19_5C_H      _PK_H_(0x19, 0x5C)
#define REG_SC_BK19_5D_L      _PK_L_(0x19, 0x5D)
#define REG_SC_BK19_5D_H      _PK_H_(0x19, 0x5D)
#define REG_SC_BK19_5E_L      _PK_L_(0x19, 0x5E)
#define REG_SC_BK19_5E_H      _PK_H_(0x19, 0x5E)
#define REG_SC_BK19_5F_L      _PK_L_(0x19, 0x5F)
#define REG_SC_BK19_5F_H      _PK_H_(0x19, 0x5F)
#define REG_SC_BK19_60_L      _PK_L_(0x19, 0x60)
#define REG_SC_BK19_60_H      _PK_H_(0x19, 0x60)
#define REG_SC_BK19_61_L      _PK_L_(0x19, 0x61)
#define REG_SC_BK19_61_H      _PK_H_(0x19, 0x61)
#define REG_SC_BK19_62_L      _PK_L_(0x19, 0x62)
#define REG_SC_BK19_62_H      _PK_H_(0x19, 0x62)
#define REG_SC_BK19_63_L      _PK_L_(0x19, 0x63)
#define REG_SC_BK19_63_H      _PK_H_(0x19, 0x63)
#define REG_SC_BK19_64_L      _PK_L_(0x19, 0x64)
#define REG_SC_BK19_64_H      _PK_H_(0x19, 0x64)
#define REG_SC_BK19_65_L      _PK_L_(0x19, 0x65)
#define REG_SC_BK19_65_H      _PK_H_(0x19, 0x65)
#define REG_SC_BK19_66_L      _PK_L_(0x19, 0x66)
#define REG_SC_BK19_66_H      _PK_H_(0x19, 0x66)
#define REG_SC_BK19_67_L      _PK_L_(0x19, 0x67)
#define REG_SC_BK19_67_H      _PK_H_(0x19, 0x67)
#define REG_SC_BK19_68_L      _PK_L_(0x19, 0x68)
#define REG_SC_BK19_68_H      _PK_H_(0x19, 0x68)
#define REG_SC_BK19_69_L      _PK_L_(0x19, 0x69)
#define REG_SC_BK19_69_H      _PK_H_(0x19, 0x69)
#define REG_SC_BK19_6A_L      _PK_L_(0x19, 0x6A)
#define REG_SC_BK19_6A_H      _PK_H_(0x19, 0x6A)
#define REG_SC_BK19_6B_L      _PK_L_(0x19, 0x6B)
#define REG_SC_BK19_6B_H      _PK_H_(0x19, 0x6B)
#define REG_SC_BK19_6C_L      _PK_L_(0x19, 0x6C)
#define REG_SC_BK19_6C_H      _PK_H_(0x19, 0x6C)
#define REG_SC_BK19_6D_L      _PK_L_(0x19, 0x6D)
#define REG_SC_BK19_6D_H      _PK_H_(0x19, 0x6D)
#define REG_SC_BK19_6E_L      _PK_L_(0x19, 0x6E)
#define REG_SC_BK19_6E_H      _PK_H_(0x19, 0x6E)
#define REG_SC_BK19_6F_L      _PK_L_(0x19, 0x6F)
#define REG_SC_BK19_6F_H      _PK_H_(0x19, 0x6F)
#define REG_SC_BK19_70_L      _PK_L_(0x19, 0x70)
#define REG_SC_BK19_70_H      _PK_H_(0x19, 0x70)
#define REG_SC_BK19_71_L      _PK_L_(0x19, 0x71)
#define REG_SC_BK19_71_H      _PK_H_(0x19, 0x71)
#define REG_SC_BK19_72_L      _PK_L_(0x19, 0x72)
#define REG_SC_BK19_72_H      _PK_H_(0x19, 0x72)
#define REG_SC_BK19_73_L      _PK_L_(0x19, 0x73)
#define REG_SC_BK19_73_H      _PK_H_(0x19, 0x73)
#define REG_SC_BK19_74_L      _PK_L_(0x19, 0x74)
#define REG_SC_BK19_74_H      _PK_H_(0x19, 0x74)
#define REG_SC_BK19_75_L      _PK_L_(0x19, 0x75)
#define REG_SC_BK19_75_H      _PK_H_(0x19, 0x75)
#define REG_SC_BK19_76_L      _PK_L_(0x19, 0x76)
#define REG_SC_BK19_76_H      _PK_H_(0x19, 0x76)
#define REG_SC_BK19_77_L      _PK_L_(0x19, 0x77)
#define REG_SC_BK19_77_H      _PK_H_(0x19, 0x77)
#define REG_SC_BK19_78_L      _PK_L_(0x19, 0x78)
#define REG_SC_BK19_78_H      _PK_H_(0x19, 0x78)
#define REG_SC_BK19_79_L      _PK_L_(0x19, 0x79)
#define REG_SC_BK19_79_H      _PK_H_(0x19, 0x79)
#define REG_SC_BK19_7A_L      _PK_L_(0x19, 0x7A)
#define REG_SC_BK19_7A_H      _PK_H_(0x19, 0x7A)
#define REG_SC_BK19_7B_L      _PK_L_(0x19, 0x7B)
#define REG_SC_BK19_7B_H      _PK_H_(0x19, 0x7B)
#define REG_SC_BK19_7C_L      _PK_L_(0x19, 0x7C)
#define REG_SC_BK19_7C_H      _PK_H_(0x19, 0x7C)
#define REG_SC_BK19_7D_L      _PK_L_(0x19, 0x7D)
#define REG_SC_BK19_7D_H      _PK_H_(0x19, 0x7D)
#define REG_SC_BK19_7E_L      _PK_L_(0x19, 0x7E)
#define REG_SC_BK19_7E_H      _PK_H_(0x19, 0x7E)
#define REG_SC_BK19_7F_L      _PK_L_(0x19, 0x7F)
#define REG_SC_BK19_7F_H      _PK_H_(0x19, 0x7F)
//----------------------------------------------
#define REG_SC_BK1A_00_L      _PK_L_(0x1A, 0x00)
#define REG_SC_BK1A_00_H      _PK_H_(0x1A, 0x00)
#define REG_SC_BK1A_01_L      _PK_L_(0x1A, 0x01)
#define REG_SC_BK1A_01_H      _PK_H_(0x1A, 0x01)
#define REG_SC_BK1A_02_L      _PK_L_(0x1A, 0x02)
#define REG_SC_BK1A_02_H      _PK_H_(0x1A, 0x02)
#define REG_SC_BK1A_03_L      _PK_L_(0x1A, 0x03)
#define REG_SC_BK1A_03_H      _PK_H_(0x1A, 0x03)
#define REG_SC_BK1A_04_L      _PK_L_(0x1A, 0x04)
#define REG_SC_BK1A_04_H      _PK_H_(0x1A, 0x04)
#define REG_SC_BK1A_05_L      _PK_L_(0x1A, 0x05)
#define REG_SC_BK1A_05_H      _PK_H_(0x1A, 0x05)
#define REG_SC_BK1A_06_L      _PK_L_(0x1A, 0x06)
#define REG_SC_BK1A_06_H      _PK_H_(0x1A, 0x06)
#define REG_SC_BK1A_07_L      _PK_L_(0x1A, 0x07)
#define REG_SC_BK1A_07_H      _PK_H_(0x1A, 0x07)
#define REG_SC_BK1A_08_L      _PK_L_(0x1A, 0x08)
#define REG_SC_BK1A_08_H      _PK_H_(0x1A, 0x08)
#define REG_SC_BK1A_09_L      _PK_L_(0x1A, 0x09)
#define REG_SC_BK1A_09_H      _PK_H_(0x1A, 0x09)
#define REG_SC_BK1A_0A_L      _PK_L_(0x1A, 0x0A)
#define REG_SC_BK1A_0A_H      _PK_H_(0x1A, 0x0A)
#define REG_SC_BK1A_0B_L      _PK_L_(0x1A, 0x0B)
#define REG_SC_BK1A_0B_H      _PK_H_(0x1A, 0x0B)
#define REG_SC_BK1A_0C_L      _PK_L_(0x1A, 0x0C)
#define REG_SC_BK1A_0C_H      _PK_H_(0x1A, 0x0C)
#define REG_SC_BK1A_0D_L      _PK_L_(0x1A, 0x0D)
#define REG_SC_BK1A_0D_H      _PK_H_(0x1A, 0x0D)
#define REG_SC_BK1A_0E_L      _PK_L_(0x1A, 0x0E)
#define REG_SC_BK1A_0E_H      _PK_H_(0x1A, 0x0E)
#define REG_SC_BK1A_0F_L      _PK_L_(0x1A, 0x0F)
#define REG_SC_BK1A_0F_H      _PK_H_(0x1A, 0x0F)
#define REG_SC_BK1A_10_L      _PK_L_(0x1A, 0x10)
#define REG_SC_BK1A_10_H      _PK_H_(0x1A, 0x10)
#define REG_SC_BK1A_11_L      _PK_L_(0x1A, 0x11)
#define REG_SC_BK1A_11_H      _PK_H_(0x1A, 0x11)
#define REG_SC_BK1A_12_L      _PK_L_(0x1A, 0x12)
#define REG_SC_BK1A_12_H      _PK_H_(0x1A, 0x12)
#define REG_SC_BK1A_13_L      _PK_L_(0x1A, 0x13)
#define REG_SC_BK1A_13_H      _PK_H_(0x1A, 0x13)
#define REG_SC_BK1A_14_L      _PK_L_(0x1A, 0x14)
#define REG_SC_BK1A_14_H      _PK_H_(0x1A, 0x14)
#define REG_SC_BK1A_15_L      _PK_L_(0x1A, 0x15)
#define REG_SC_BK1A_15_H      _PK_H_(0x1A, 0x15)
#define REG_SC_BK1A_16_L      _PK_L_(0x1A, 0x16)
#define REG_SC_BK1A_16_H      _PK_H_(0x1A, 0x16)
#define REG_SC_BK1A_17_L      _PK_L_(0x1A, 0x17)
#define REG_SC_BK1A_17_H      _PK_H_(0x1A, 0x17)
#define REG_SC_BK1A_18_L      _PK_L_(0x1A, 0x18)
#define REG_SC_BK1A_18_H      _PK_H_(0x1A, 0x18)
#define REG_SC_BK1A_19_L      _PK_L_(0x1A, 0x19)
#define REG_SC_BK1A_19_H      _PK_H_(0x1A, 0x19)
#define REG_SC_BK1A_1A_L      _PK_L_(0x1A, 0x1A)
#define REG_SC_BK1A_1A_H      _PK_H_(0x1A, 0x1A)
#define REG_SC_BK1A_1B_L      _PK_L_(0x1A, 0x1B)
#define REG_SC_BK1A_1B_H      _PK_H_(0x1A, 0x1B)
#define REG_SC_BK1A_1C_L      _PK_L_(0x1A, 0x1C)
#define REG_SC_BK1A_1C_H      _PK_H_(0x1A, 0x1C)
#define REG_SC_BK1A_1D_L      _PK_L_(0x1A, 0x1D)
#define REG_SC_BK1A_1D_H      _PK_H_(0x1A, 0x1D)
#define REG_SC_BK1A_1E_L      _PK_L_(0x1A, 0x1E)
#define REG_SC_BK1A_1E_H      _PK_H_(0x1A, 0x1E)
#define REG_SC_BK1A_1F_L      _PK_L_(0x1A, 0x1F)
#define REG_SC_BK1A_1F_H      _PK_H_(0x1A, 0x1F)
#define REG_SC_BK1A_20_L      _PK_L_(0x1A, 0x20)
#define REG_SC_BK1A_20_H      _PK_H_(0x1A, 0x20)
#define REG_SC_BK1A_21_L      _PK_L_(0x1A, 0x21)
#define REG_SC_BK1A_21_H      _PK_H_(0x1A, 0x21)
#define REG_SC_BK1A_22_L      _PK_L_(0x1A, 0x22)
#define REG_SC_BK1A_22_H      _PK_H_(0x1A, 0x22)
#define REG_SC_BK1A_23_L      _PK_L_(0x1A, 0x23)
#define REG_SC_BK1A_23_H      _PK_H_(0x1A, 0x23)
#define REG_SC_BK1A_24_L      _PK_L_(0x1A, 0x24)
#define REG_SC_BK1A_24_H      _PK_H_(0x1A, 0x24)
#define REG_SC_BK1A_25_L      _PK_L_(0x1A, 0x25)
#define REG_SC_BK1A_25_H      _PK_H_(0x1A, 0x25)
#define REG_SC_BK1A_26_L      _PK_L_(0x1A, 0x26)
#define REG_SC_BK1A_26_H      _PK_H_(0x1A, 0x26)
#define REG_SC_BK1A_27_L      _PK_L_(0x1A, 0x27)
#define REG_SC_BK1A_27_H      _PK_H_(0x1A, 0x27)
#define REG_SC_BK1A_28_L      _PK_L_(0x1A, 0x28)
#define REG_SC_BK1A_28_H      _PK_H_(0x1A, 0x28)
#define REG_SC_BK1A_29_L      _PK_L_(0x1A, 0x29)
#define REG_SC_BK1A_29_H      _PK_H_(0x1A, 0x29)
#define REG_SC_BK1A_2A_L      _PK_L_(0x1A, 0x2A)
#define REG_SC_BK1A_2A_H      _PK_H_(0x1A, 0x2A)
#define REG_SC_BK1A_2B_L      _PK_L_(0x1A, 0x2B)
#define REG_SC_BK1A_2B_H      _PK_H_(0x1A, 0x2B)
#define REG_SC_BK1A_2C_L      _PK_L_(0x1A, 0x2C)
#define REG_SC_BK1A_2C_H      _PK_H_(0x1A, 0x2C)
#define REG_SC_BK1A_2D_L      _PK_L_(0x1A, 0x2D)
#define REG_SC_BK1A_2D_H      _PK_H_(0x1A, 0x2D)
#define REG_SC_BK1A_2E_L      _PK_L_(0x1A, 0x2E)
#define REG_SC_BK1A_2E_H      _PK_H_(0x1A, 0x2E)
#define REG_SC_BK1A_2F_L      _PK_L_(0x1A, 0x2F)
#define REG_SC_BK1A_2F_H      _PK_H_(0x1A, 0x2F)
#define REG_SC_BK1A_30_L      _PK_L_(0x1A, 0x30)
#define REG_SC_BK1A_30_H      _PK_H_(0x1A, 0x30)
#define REG_SC_BK1A_31_L      _PK_L_(0x1A, 0x31)
#define REG_SC_BK1A_31_H      _PK_H_(0x1A, 0x31)
#define REG_SC_BK1A_32_L      _PK_L_(0x1A, 0x32)
#define REG_SC_BK1A_32_H      _PK_H_(0x1A, 0x32)
#define REG_SC_BK1A_33_L      _PK_L_(0x1A, 0x33)
#define REG_SC_BK1A_33_H      _PK_H_(0x1A, 0x33)
#define REG_SC_BK1A_34_L      _PK_L_(0x1A, 0x34)
#define REG_SC_BK1A_34_H      _PK_H_(0x1A, 0x34)
#define REG_SC_BK1A_35_L      _PK_L_(0x1A, 0x35)
#define REG_SC_BK1A_35_H      _PK_H_(0x1A, 0x35)
#define REG_SC_BK1A_36_L      _PK_L_(0x1A, 0x36)
#define REG_SC_BK1A_36_H      _PK_H_(0x1A, 0x36)
#define REG_SC_BK1A_37_L      _PK_L_(0x1A, 0x37)
#define REG_SC_BK1A_37_H      _PK_H_(0x1A, 0x37)
#define REG_SC_BK1A_38_L      _PK_L_(0x1A, 0x38)
#define REG_SC_BK1A_38_H      _PK_H_(0x1A, 0x38)
#define REG_SC_BK1A_39_L      _PK_L_(0x1A, 0x39)
#define REG_SC_BK1A_39_H      _PK_H_(0x1A, 0x39)
#define REG_SC_BK1A_3A_L      _PK_L_(0x1A, 0x3A)
#define REG_SC_BK1A_3A_H      _PK_H_(0x1A, 0x3A)
#define REG_SC_BK1A_3B_L      _PK_L_(0x1A, 0x3B)
#define REG_SC_BK1A_3B_H      _PK_H_(0x1A, 0x3B)
#define REG_SC_BK1A_3C_L      _PK_L_(0x1A, 0x3C)
#define REG_SC_BK1A_3C_H      _PK_H_(0x1A, 0x3C)
#define REG_SC_BK1A_3D_L      _PK_L_(0x1A, 0x3D)
#define REG_SC_BK1A_3D_H      _PK_H_(0x1A, 0x3D)
#define REG_SC_BK1A_3E_L      _PK_L_(0x1A, 0x3E)
#define REG_SC_BK1A_3E_H      _PK_H_(0x1A, 0x3E)
#define REG_SC_BK1A_3F_L      _PK_L_(0x1A, 0x3F)
#define REG_SC_BK1A_3F_H      _PK_H_(0x1A, 0x3F)
#define REG_SC_BK1A_40_L      _PK_L_(0x1A, 0x40)
#define REG_SC_BK1A_40_H      _PK_H_(0x1A, 0x40)
#define REG_SC_BK1A_41_L      _PK_L_(0x1A, 0x41)
#define REG_SC_BK1A_41_H      _PK_H_(0x1A, 0x41)
#define REG_SC_BK1A_42_L      _PK_L_(0x1A, 0x42)
#define REG_SC_BK1A_42_H      _PK_H_(0x1A, 0x42)
#define REG_SC_BK1A_43_L      _PK_L_(0x1A, 0x43)
#define REG_SC_BK1A_43_H      _PK_H_(0x1A, 0x43)
#define REG_SC_BK1A_44_L      _PK_L_(0x1A, 0x44)
#define REG_SC_BK1A_44_H      _PK_H_(0x1A, 0x44)
#define REG_SC_BK1A_45_L      _PK_L_(0x1A, 0x45)
#define REG_SC_BK1A_45_H      _PK_H_(0x1A, 0x45)
#define REG_SC_BK1A_46_L      _PK_L_(0x1A, 0x46)
#define REG_SC_BK1A_46_H      _PK_H_(0x1A, 0x46)
#define REG_SC_BK1A_47_L      _PK_L_(0x1A, 0x47)
#define REG_SC_BK1A_47_H      _PK_H_(0x1A, 0x47)
#define REG_SC_BK1A_48_L      _PK_L_(0x1A, 0x48)
#define REG_SC_BK1A_48_H      _PK_H_(0x1A, 0x48)
#define REG_SC_BK1A_49_L      _PK_L_(0x1A, 0x49)
#define REG_SC_BK1A_49_H      _PK_H_(0x1A, 0x49)
#define REG_SC_BK1A_4A_L      _PK_L_(0x1A, 0x4A)
#define REG_SC_BK1A_4A_H      _PK_H_(0x1A, 0x4A)
#define REG_SC_BK1A_4B_L      _PK_L_(0x1A, 0x4B)
#define REG_SC_BK1A_4B_H      _PK_H_(0x1A, 0x4B)
#define REG_SC_BK1A_4C_L      _PK_L_(0x1A, 0x4C)
#define REG_SC_BK1A_4C_H      _PK_H_(0x1A, 0x4C)
#define REG_SC_BK1A_4D_L      _PK_L_(0x1A, 0x4D)
#define REG_SC_BK1A_4D_H      _PK_H_(0x1A, 0x4D)
#define REG_SC_BK1A_4E_L      _PK_L_(0x1A, 0x4E)
#define REG_SC_BK1A_4E_H      _PK_H_(0x1A, 0x4E)
#define REG_SC_BK1A_4F_L      _PK_L_(0x1A, 0x4F)
#define REG_SC_BK1A_4F_H      _PK_H_(0x1A, 0x4F)
#define REG_SC_BK1A_50_L      _PK_L_(0x1A, 0x50)
#define REG_SC_BK1A_50_H      _PK_H_(0x1A, 0x50)
#define REG_SC_BK1A_51_L      _PK_L_(0x1A, 0x51)
#define REG_SC_BK1A_51_H      _PK_H_(0x1A, 0x51)
#define REG_SC_BK1A_52_L      _PK_L_(0x1A, 0x52)
#define REG_SC_BK1A_52_H      _PK_H_(0x1A, 0x52)
#define REG_SC_BK1A_53_L      _PK_L_(0x1A, 0x53)
#define REG_SC_BK1A_53_H      _PK_H_(0x1A, 0x53)
#define REG_SC_BK1A_54_L      _PK_L_(0x1A, 0x54)
#define REG_SC_BK1A_54_H      _PK_H_(0x1A, 0x54)
#define REG_SC_BK1A_55_L      _PK_L_(0x1A, 0x55)
#define REG_SC_BK1A_55_H      _PK_H_(0x1A, 0x55)
#define REG_SC_BK1A_56_L      _PK_L_(0x1A, 0x56)
#define REG_SC_BK1A_56_H      _PK_H_(0x1A, 0x56)
#define REG_SC_BK1A_57_L      _PK_L_(0x1A, 0x57)
#define REG_SC_BK1A_57_H      _PK_H_(0x1A, 0x57)
#define REG_SC_BK1A_58_L      _PK_L_(0x1A, 0x58)
#define REG_SC_BK1A_58_H      _PK_H_(0x1A, 0x58)
#define REG_SC_BK1A_59_L      _PK_L_(0x1A, 0x59)
#define REG_SC_BK1A_59_H      _PK_H_(0x1A, 0x59)
#define REG_SC_BK1A_5A_L      _PK_L_(0x1A, 0x5A)
#define REG_SC_BK1A_5A_H      _PK_H_(0x1A, 0x5A)
#define REG_SC_BK1A_5B_L      _PK_L_(0x1A, 0x5B)
#define REG_SC_BK1A_5B_H      _PK_H_(0x1A, 0x5B)
#define REG_SC_BK1A_5C_L      _PK_L_(0x1A, 0x5C)
#define REG_SC_BK1A_5C_H      _PK_H_(0x1A, 0x5C)
#define REG_SC_BK1A_5D_L      _PK_L_(0x1A, 0x5D)
#define REG_SC_BK1A_5D_H      _PK_H_(0x1A, 0x5D)
#define REG_SC_BK1A_5E_L      _PK_L_(0x1A, 0x5E)
#define REG_SC_BK1A_5E_H      _PK_H_(0x1A, 0x5E)
#define REG_SC_BK1A_5F_L      _PK_L_(0x1A, 0x5F)
#define REG_SC_BK1A_5F_H      _PK_H_(0x1A, 0x5F)
#define REG_SC_BK1A_60_L      _PK_L_(0x1A, 0x60)
#define REG_SC_BK1A_60_H      _PK_H_(0x1A, 0x60)
#define REG_SC_BK1A_61_L      _PK_L_(0x1A, 0x61)
#define REG_SC_BK1A_61_H      _PK_H_(0x1A, 0x61)
#define REG_SC_BK1A_62_L      _PK_L_(0x1A, 0x62)
#define REG_SC_BK1A_62_H      _PK_H_(0x1A, 0x62)
#define REG_SC_BK1A_63_L      _PK_L_(0x1A, 0x63)
#define REG_SC_BK1A_63_H      _PK_H_(0x1A, 0x63)
#define REG_SC_BK1A_64_L      _PK_L_(0x1A, 0x64)
#define REG_SC_BK1A_64_H      _PK_H_(0x1A, 0x64)
#define REG_SC_BK1A_65_L      _PK_L_(0x1A, 0x65)
#define REG_SC_BK1A_65_H      _PK_H_(0x1A, 0x65)
#define REG_SC_BK1A_66_L      _PK_L_(0x1A, 0x66)
#define REG_SC_BK1A_66_H      _PK_H_(0x1A, 0x66)
#define REG_SC_BK1A_67_L      _PK_L_(0x1A, 0x67)
#define REG_SC_BK1A_67_H      _PK_H_(0x1A, 0x67)
#define REG_SC_BK1A_68_L      _PK_L_(0x1A, 0x68)
#define REG_SC_BK1A_68_H      _PK_H_(0x1A, 0x68)
#define REG_SC_BK1A_69_L      _PK_L_(0x1A, 0x69)
#define REG_SC_BK1A_69_H      _PK_H_(0x1A, 0x69)
#define REG_SC_BK1A_6A_L      _PK_L_(0x1A, 0x6A)
#define REG_SC_BK1A_6A_H      _PK_H_(0x1A, 0x6A)
#define REG_SC_BK1A_6B_L      _PK_L_(0x1A, 0x6B)
#define REG_SC_BK1A_6B_H      _PK_H_(0x1A, 0x6B)
#define REG_SC_BK1A_6C_L      _PK_L_(0x1A, 0x6C)
#define REG_SC_BK1A_6C_H      _PK_H_(0x1A, 0x6C)
#define REG_SC_BK1A_6D_L      _PK_L_(0x1A, 0x6D)
#define REG_SC_BK1A_6D_H      _PK_H_(0x1A, 0x6D)
#define REG_SC_BK1A_6E_L      _PK_L_(0x1A, 0x6E)
#define REG_SC_BK1A_6E_H      _PK_H_(0x1A, 0x6E)
#define REG_SC_BK1A_6F_L      _PK_L_(0x1A, 0x6F)
#define REG_SC_BK1A_6F_H      _PK_H_(0x1A, 0x6F)
#define REG_SC_BK1A_70_L      _PK_L_(0x1A, 0x70)
#define REG_SC_BK1A_70_H      _PK_H_(0x1A, 0x70)
#define REG_SC_BK1A_71_L      _PK_L_(0x1A, 0x71)
#define REG_SC_BK1A_71_H      _PK_H_(0x1A, 0x71)
#define REG_SC_BK1A_72_L      _PK_L_(0x1A, 0x72)
#define REG_SC_BK1A_72_H      _PK_H_(0x1A, 0x72)
#define REG_SC_BK1A_73_L      _PK_L_(0x1A, 0x73)
#define REG_SC_BK1A_73_H      _PK_H_(0x1A, 0x73)
#define REG_SC_BK1A_74_L      _PK_L_(0x1A, 0x74)
#define REG_SC_BK1A_74_H      _PK_H_(0x1A, 0x74)
#define REG_SC_BK1A_75_L      _PK_L_(0x1A, 0x75)
#define REG_SC_BK1A_75_H      _PK_H_(0x1A, 0x75)
#define REG_SC_BK1A_76_L      _PK_L_(0x1A, 0x76)
#define REG_SC_BK1A_76_H      _PK_H_(0x1A, 0x76)
#define REG_SC_BK1A_77_L      _PK_L_(0x1A, 0x77)
#define REG_SC_BK1A_77_H      _PK_H_(0x1A, 0x77)
#define REG_SC_BK1A_78_L      _PK_L_(0x1A, 0x78)
#define REG_SC_BK1A_78_H      _PK_H_(0x1A, 0x78)
#define REG_SC_BK1A_79_L      _PK_L_(0x1A, 0x79)
#define REG_SC_BK1A_79_H      _PK_H_(0x1A, 0x79)
#define REG_SC_BK1A_7A_L      _PK_L_(0x1A, 0x7A)
#define REG_SC_BK1A_7A_H      _PK_H_(0x1A, 0x7A)
#define REG_SC_BK1A_7B_L      _PK_L_(0x1A, 0x7B)
#define REG_SC_BK1A_7B_H      _PK_H_(0x1A, 0x7B)
#define REG_SC_BK1A_7C_L      _PK_L_(0x1A, 0x7C)
#define REG_SC_BK1A_7C_H      _PK_H_(0x1A, 0x7C)
#define REG_SC_BK1A_7D_L      _PK_L_(0x1A, 0x7D)
#define REG_SC_BK1A_7D_H      _PK_H_(0x1A, 0x7D)
#define REG_SC_BK1A_7E_L      _PK_L_(0x1A, 0x7E)
#define REG_SC_BK1A_7E_H      _PK_H_(0x1A, 0x7E)
#define REG_SC_BK1A_7F_L      _PK_L_(0x1A, 0x7F)
#define REG_SC_BK1A_7F_H      _PK_H_(0x1A, 0x7F)
//----------------------------------------------
#define REG_SC_BK1B_00_L      _PK_L_(0x1B, 0x00)
#define REG_SC_BK1B_00_H      _PK_H_(0x1B, 0x00)
#define REG_SC_BK1B_01_L      _PK_L_(0x1B, 0x01)
#define REG_SC_BK1B_01_H      _PK_H_(0x1B, 0x01)
#define REG_SC_BK1B_02_L      _PK_L_(0x1B, 0x02)
#define REG_SC_BK1B_02_H      _PK_H_(0x1B, 0x02)
#define REG_SC_BK1B_03_L      _PK_L_(0x1B, 0x03)
#define REG_SC_BK1B_03_H      _PK_H_(0x1B, 0x03)
#define REG_SC_BK1B_04_L      _PK_L_(0x1B, 0x04)
#define REG_SC_BK1B_04_H      _PK_H_(0x1B, 0x04)
#define REG_SC_BK1B_05_L      _PK_L_(0x1B, 0x05)
#define REG_SC_BK1B_05_H      _PK_H_(0x1B, 0x05)
#define REG_SC_BK1B_06_L      _PK_L_(0x1B, 0x06)
#define REG_SC_BK1B_06_H      _PK_H_(0x1B, 0x06)
#define REG_SC_BK1B_07_L      _PK_L_(0x1B, 0x07)
#define REG_SC_BK1B_07_H      _PK_H_(0x1B, 0x07)
#define REG_SC_BK1B_08_L      _PK_L_(0x1B, 0x08)
#define REG_SC_BK1B_08_H      _PK_H_(0x1B, 0x08)
#define REG_SC_BK1B_09_L      _PK_L_(0x1B, 0x09)
#define REG_SC_BK1B_09_H      _PK_H_(0x1B, 0x09)
#define REG_SC_BK1B_0A_L      _PK_L_(0x1B, 0x0A)
#define REG_SC_BK1B_0A_H      _PK_H_(0x1B, 0x0A)
#define REG_SC_BK1B_0B_L      _PK_L_(0x1B, 0x0B)
#define REG_SC_BK1B_0B_H      _PK_H_(0x1B, 0x0B)
#define REG_SC_BK1B_0C_L      _PK_L_(0x1B, 0x0C)
#define REG_SC_BK1B_0C_H      _PK_H_(0x1B, 0x0C)
#define REG_SC_BK1B_0D_L      _PK_L_(0x1B, 0x0D)
#define REG_SC_BK1B_0D_H      _PK_H_(0x1B, 0x0D)
#define REG_SC_BK1B_0E_L      _PK_L_(0x1B, 0x0E)
#define REG_SC_BK1B_0E_H      _PK_H_(0x1B, 0x0E)
#define REG_SC_BK1B_0F_L      _PK_L_(0x1B, 0x0F)
#define REG_SC_BK1B_0F_H      _PK_H_(0x1B, 0x0F)
#define REG_SC_BK1B_10_L      _PK_L_(0x1B, 0x10)
#define REG_SC_BK1B_10_H      _PK_H_(0x1B, 0x10)
#define REG_SC_BK1B_11_L      _PK_L_(0x1B, 0x11)
#define REG_SC_BK1B_11_H      _PK_H_(0x1B, 0x11)
#define REG_SC_BK1B_12_L      _PK_L_(0x1B, 0x12)
#define REG_SC_BK1B_12_H      _PK_H_(0x1B, 0x12)
#define REG_SC_BK1B_13_L      _PK_L_(0x1B, 0x13)
#define REG_SC_BK1B_13_H      _PK_H_(0x1B, 0x13)
#define REG_SC_BK1B_14_L      _PK_L_(0x1B, 0x14)
#define REG_SC_BK1B_14_H      _PK_H_(0x1B, 0x14)
#define REG_SC_BK1B_15_L      _PK_L_(0x1B, 0x15)
#define REG_SC_BK1B_15_H      _PK_H_(0x1B, 0x15)
#define REG_SC_BK1B_16_L      _PK_L_(0x1B, 0x16)
#define REG_SC_BK1B_16_H      _PK_H_(0x1B, 0x16)
#define REG_SC_BK1B_17_L      _PK_L_(0x1B, 0x17)
#define REG_SC_BK1B_17_H      _PK_H_(0x1B, 0x17)
#define REG_SC_BK1B_18_L      _PK_L_(0x1B, 0x18)
#define REG_SC_BK1B_18_H      _PK_H_(0x1B, 0x18)
#define REG_SC_BK1B_19_L      _PK_L_(0x1B, 0x19)
#define REG_SC_BK1B_19_H      _PK_H_(0x1B, 0x19)
#define REG_SC_BK1B_1A_L      _PK_L_(0x1B, 0x1A)
#define REG_SC_BK1B_1A_H      _PK_H_(0x1B, 0x1A)
#define REG_SC_BK1B_1B_L      _PK_L_(0x1B, 0x1B)
#define REG_SC_BK1B_1B_H      _PK_H_(0x1B, 0x1B)
#define REG_SC_BK1B_1C_L      _PK_L_(0x1B, 0x1C)
#define REG_SC_BK1B_1C_H      _PK_H_(0x1B, 0x1C)
#define REG_SC_BK1B_1D_L      _PK_L_(0x1B, 0x1D)
#define REG_SC_BK1B_1D_H      _PK_H_(0x1B, 0x1D)
#define REG_SC_BK1B_1E_L      _PK_L_(0x1B, 0x1E)
#define REG_SC_BK1B_1E_H      _PK_H_(0x1B, 0x1E)
#define REG_SC_BK1B_1F_L      _PK_L_(0x1B, 0x1F)
#define REG_SC_BK1B_1F_H      _PK_H_(0x1B, 0x1F)
#define REG_SC_BK1B_20_L      _PK_L_(0x1B, 0x20)
#define REG_SC_BK1B_20_H      _PK_H_(0x1B, 0x20)
#define REG_SC_BK1B_21_L      _PK_L_(0x1B, 0x21)
#define REG_SC_BK1B_21_H      _PK_H_(0x1B, 0x21)
#define REG_SC_BK1B_22_L      _PK_L_(0x1B, 0x22)
#define REG_SC_BK1B_22_H      _PK_H_(0x1B, 0x22)
#define REG_SC_BK1B_23_L      _PK_L_(0x1B, 0x23)
#define REG_SC_BK1B_23_H      _PK_H_(0x1B, 0x23)
#define REG_SC_BK1B_24_L      _PK_L_(0x1B, 0x24)
#define REG_SC_BK1B_24_H      _PK_H_(0x1B, 0x24)
#define REG_SC_BK1B_25_L      _PK_L_(0x1B, 0x25)
#define REG_SC_BK1B_25_H      _PK_H_(0x1B, 0x25)
#define REG_SC_BK1B_26_L      _PK_L_(0x1B, 0x26)
#define REG_SC_BK1B_26_H      _PK_H_(0x1B, 0x26)
#define REG_SC_BK1B_27_L      _PK_L_(0x1B, 0x27)
#define REG_SC_BK1B_27_H      _PK_H_(0x1B, 0x27)
#define REG_SC_BK1B_28_L      _PK_L_(0x1B, 0x28)
#define REG_SC_BK1B_28_H      _PK_H_(0x1B, 0x28)
#define REG_SC_BK1B_29_L      _PK_L_(0x1B, 0x29)
#define REG_SC_BK1B_29_H      _PK_H_(0x1B, 0x29)
#define REG_SC_BK1B_2A_L      _PK_L_(0x1B, 0x2A)
#define REG_SC_BK1B_2A_H      _PK_H_(0x1B, 0x2A)
#define REG_SC_BK1B_2B_L      _PK_L_(0x1B, 0x2B)
#define REG_SC_BK1B_2B_H      _PK_H_(0x1B, 0x2B)
#define REG_SC_BK1B_2C_L      _PK_L_(0x1B, 0x2C)
#define REG_SC_BK1B_2C_H      _PK_H_(0x1B, 0x2C)
#define REG_SC_BK1B_2D_L      _PK_L_(0x1B, 0x2D)
#define REG_SC_BK1B_2D_H      _PK_H_(0x1B, 0x2D)
#define REG_SC_BK1B_2E_L      _PK_L_(0x1B, 0x2E)
#define REG_SC_BK1B_2E_H      _PK_H_(0x1B, 0x2E)
#define REG_SC_BK1B_2F_L      _PK_L_(0x1B, 0x2F)
#define REG_SC_BK1B_2F_H      _PK_H_(0x1B, 0x2F)
#define REG_SC_BK1B_30_L      _PK_L_(0x1B, 0x30)
#define REG_SC_BK1B_30_H      _PK_H_(0x1B, 0x30)
#define REG_SC_BK1B_31_L      _PK_L_(0x1B, 0x31)
#define REG_SC_BK1B_31_H      _PK_H_(0x1B, 0x31)
#define REG_SC_BK1B_32_L      _PK_L_(0x1B, 0x32)
#define REG_SC_BK1B_32_H      _PK_H_(0x1B, 0x32)
#define REG_SC_BK1B_33_L      _PK_L_(0x1B, 0x33)
#define REG_SC_BK1B_33_H      _PK_H_(0x1B, 0x33)
#define REG_SC_BK1B_34_L      _PK_L_(0x1B, 0x34)
#define REG_SC_BK1B_34_H      _PK_H_(0x1B, 0x34)
#define REG_SC_BK1B_35_L      _PK_L_(0x1B, 0x35)
#define REG_SC_BK1B_35_H      _PK_H_(0x1B, 0x35)
#define REG_SC_BK1B_36_L      _PK_L_(0x1B, 0x36)
#define REG_SC_BK1B_36_H      _PK_H_(0x1B, 0x36)
#define REG_SC_BK1B_37_L      _PK_L_(0x1B, 0x37)
#define REG_SC_BK1B_37_H      _PK_H_(0x1B, 0x37)
#define REG_SC_BK1B_38_L      _PK_L_(0x1B, 0x38)
#define REG_SC_BK1B_38_H      _PK_H_(0x1B, 0x38)
#define REG_SC_BK1B_39_L      _PK_L_(0x1B, 0x39)
#define REG_SC_BK1B_39_H      _PK_H_(0x1B, 0x39)
#define REG_SC_BK1B_3A_L      _PK_L_(0x1B, 0x3A)
#define REG_SC_BK1B_3A_H      _PK_H_(0x1B, 0x3A)
#define REG_SC_BK1B_3B_L      _PK_L_(0x1B, 0x3B)
#define REG_SC_BK1B_3B_H      _PK_H_(0x1B, 0x3B)
#define REG_SC_BK1B_3C_L      _PK_L_(0x1B, 0x3C)
#define REG_SC_BK1B_3C_H      _PK_H_(0x1B, 0x3C)
#define REG_SC_BK1B_3D_L      _PK_L_(0x1B, 0x3D)
#define REG_SC_BK1B_3D_H      _PK_H_(0x1B, 0x3D)
#define REG_SC_BK1B_3E_L      _PK_L_(0x1B, 0x3E)
#define REG_SC_BK1B_3E_H      _PK_H_(0x1B, 0x3E)
#define REG_SC_BK1B_3F_L      _PK_L_(0x1B, 0x3F)
#define REG_SC_BK1B_3F_H      _PK_H_(0x1B, 0x3F)
#define REG_SC_BK1B_40_L      _PK_L_(0x1B, 0x40)
#define REG_SC_BK1B_40_H      _PK_H_(0x1B, 0x40)
#define REG_SC_BK1B_41_L      _PK_L_(0x1B, 0x41)
#define REG_SC_BK1B_41_H      _PK_H_(0x1B, 0x41)
#define REG_SC_BK1B_42_L      _PK_L_(0x1B, 0x42)
#define REG_SC_BK1B_42_H      _PK_H_(0x1B, 0x42)
#define REG_SC_BK1B_43_L      _PK_L_(0x1B, 0x43)
#define REG_SC_BK1B_43_H      _PK_H_(0x1B, 0x43)
#define REG_SC_BK1B_44_L      _PK_L_(0x1B, 0x44)
#define REG_SC_BK1B_44_H      _PK_H_(0x1B, 0x44)
#define REG_SC_BK1B_45_L      _PK_L_(0x1B, 0x45)
#define REG_SC_BK1B_45_H      _PK_H_(0x1B, 0x45)
#define REG_SC_BK1B_46_L      _PK_L_(0x1B, 0x46)
#define REG_SC_BK1B_46_H      _PK_H_(0x1B, 0x46)
#define REG_SC_BK1B_47_L      _PK_L_(0x1B, 0x47)
#define REG_SC_BK1B_47_H      _PK_H_(0x1B, 0x47)
#define REG_SC_BK1B_48_L      _PK_L_(0x1B, 0x48)
#define REG_SC_BK1B_48_H      _PK_H_(0x1B, 0x48)
#define REG_SC_BK1B_49_L      _PK_L_(0x1B, 0x49)
#define REG_SC_BK1B_49_H      _PK_H_(0x1B, 0x49)
#define REG_SC_BK1B_4A_L      _PK_L_(0x1B, 0x4A)
#define REG_SC_BK1B_4A_H      _PK_H_(0x1B, 0x4A)
#define REG_SC_BK1B_4B_L      _PK_L_(0x1B, 0x4B)
#define REG_SC_BK1B_4B_H      _PK_H_(0x1B, 0x4B)
#define REG_SC_BK1B_4C_L      _PK_L_(0x1B, 0x4C)
#define REG_SC_BK1B_4C_H      _PK_H_(0x1B, 0x4C)
#define REG_SC_BK1B_4D_L      _PK_L_(0x1B, 0x4D)
#define REG_SC_BK1B_4D_H      _PK_H_(0x1B, 0x4D)
#define REG_SC_BK1B_4E_L      _PK_L_(0x1B, 0x4E)
#define REG_SC_BK1B_4E_H      _PK_H_(0x1B, 0x4E)
#define REG_SC_BK1B_4F_L      _PK_L_(0x1B, 0x4F)
#define REG_SC_BK1B_4F_H      _PK_H_(0x1B, 0x4F)
#define REG_SC_BK1B_50_L      _PK_L_(0x1B, 0x50)
#define REG_SC_BK1B_50_H      _PK_H_(0x1B, 0x50)
#define REG_SC_BK1B_51_L      _PK_L_(0x1B, 0x51)
#define REG_SC_BK1B_51_H      _PK_H_(0x1B, 0x51)
#define REG_SC_BK1B_52_L      _PK_L_(0x1B, 0x52)
#define REG_SC_BK1B_52_H      _PK_H_(0x1B, 0x52)
#define REG_SC_BK1B_53_L      _PK_L_(0x1B, 0x53)
#define REG_SC_BK1B_53_H      _PK_H_(0x1B, 0x53)
#define REG_SC_BK1B_54_L      _PK_L_(0x1B, 0x54)
#define REG_SC_BK1B_54_H      _PK_H_(0x1B, 0x54)
#define REG_SC_BK1B_55_L      _PK_L_(0x1B, 0x55)
#define REG_SC_BK1B_55_H      _PK_H_(0x1B, 0x55)
#define REG_SC_BK1B_56_L      _PK_L_(0x1B, 0x56)
#define REG_SC_BK1B_56_H      _PK_H_(0x1B, 0x56)
#define REG_SC_BK1B_57_L      _PK_L_(0x1B, 0x57)
#define REG_SC_BK1B_57_H      _PK_H_(0x1B, 0x57)
#define REG_SC_BK1B_58_L      _PK_L_(0x1B, 0x58)
#define REG_SC_BK1B_58_H      _PK_H_(0x1B, 0x58)
#define REG_SC_BK1B_59_L      _PK_L_(0x1B, 0x59)
#define REG_SC_BK1B_59_H      _PK_H_(0x1B, 0x59)
#define REG_SC_BK1B_5A_L      _PK_L_(0x1B, 0x5A)
#define REG_SC_BK1B_5A_H      _PK_H_(0x1B, 0x5A)
#define REG_SC_BK1B_5B_L      _PK_L_(0x1B, 0x5B)
#define REG_SC_BK1B_5B_H      _PK_H_(0x1B, 0x5B)
#define REG_SC_BK1B_5C_L      _PK_L_(0x1B, 0x5C)
#define REG_SC_BK1B_5C_H      _PK_H_(0x1B, 0x5C)
#define REG_SC_BK1B_5D_L      _PK_L_(0x1B, 0x5D)
#define REG_SC_BK1B_5D_H      _PK_H_(0x1B, 0x5D)
#define REG_SC_BK1B_5E_L      _PK_L_(0x1B, 0x5E)
#define REG_SC_BK1B_5E_H      _PK_H_(0x1B, 0x5E)
#define REG_SC_BK1B_5F_L      _PK_L_(0x1B, 0x5F)
#define REG_SC_BK1B_5F_H      _PK_H_(0x1B, 0x5F)
#define REG_SC_BK1B_60_L      _PK_L_(0x1B, 0x60)
#define REG_SC_BK1B_60_H      _PK_H_(0x1B, 0x60)
#define REG_SC_BK1B_61_L      _PK_L_(0x1B, 0x61)
#define REG_SC_BK1B_61_H      _PK_H_(0x1B, 0x61)
#define REG_SC_BK1B_62_L      _PK_L_(0x1B, 0x62)
#define REG_SC_BK1B_62_H      _PK_H_(0x1B, 0x62)
#define REG_SC_BK1B_63_L      _PK_L_(0x1B, 0x63)
#define REG_SC_BK1B_63_H      _PK_H_(0x1B, 0x63)
#define REG_SC_BK1B_64_L      _PK_L_(0x1B, 0x64)
#define REG_SC_BK1B_64_H      _PK_H_(0x1B, 0x64)
#define REG_SC_BK1B_65_L      _PK_L_(0x1B, 0x65)
#define REG_SC_BK1B_65_H      _PK_H_(0x1B, 0x65)
#define REG_SC_BK1B_66_L      _PK_L_(0x1B, 0x66)
#define REG_SC_BK1B_66_H      _PK_H_(0x1B, 0x66)
#define REG_SC_BK1B_67_L      _PK_L_(0x1B, 0x67)
#define REG_SC_BK1B_67_H      _PK_H_(0x1B, 0x67)
#define REG_SC_BK1B_68_L      _PK_L_(0x1B, 0x68)
#define REG_SC_BK1B_68_H      _PK_H_(0x1B, 0x68)
#define REG_SC_BK1B_69_L      _PK_L_(0x1B, 0x69)
#define REG_SC_BK1B_69_H      _PK_H_(0x1B, 0x69)
#define REG_SC_BK1B_6A_L      _PK_L_(0x1B, 0x6A)
#define REG_SC_BK1B_6A_H      _PK_H_(0x1B, 0x6A)
#define REG_SC_BK1B_6B_L      _PK_L_(0x1B, 0x6B)
#define REG_SC_BK1B_6B_H      _PK_H_(0x1B, 0x6B)
#define REG_SC_BK1B_6C_L      _PK_L_(0x1B, 0x6C)
#define REG_SC_BK1B_6C_H      _PK_H_(0x1B, 0x6C)
#define REG_SC_BK1B_6D_L      _PK_L_(0x1B, 0x6D)
#define REG_SC_BK1B_6D_H      _PK_H_(0x1B, 0x6D)
#define REG_SC_BK1B_6E_L      _PK_L_(0x1B, 0x6E)
#define REG_SC_BK1B_6E_H      _PK_H_(0x1B, 0x6E)
#define REG_SC_BK1B_6F_L      _PK_L_(0x1B, 0x6F)
#define REG_SC_BK1B_6F_H      _PK_H_(0x1B, 0x6F)
#define REG_SC_BK1B_70_L      _PK_L_(0x1B, 0x70)
#define REG_SC_BK1B_70_H      _PK_H_(0x1B, 0x70)
#define REG_SC_BK1B_71_L      _PK_L_(0x1B, 0x71)
#define REG_SC_BK1B_71_H      _PK_H_(0x1B, 0x71)
#define REG_SC_BK1B_72_L      _PK_L_(0x1B, 0x72)
#define REG_SC_BK1B_72_H      _PK_H_(0x1B, 0x72)
#define REG_SC_BK1B_73_L      _PK_L_(0x1B, 0x73)
#define REG_SC_BK1B_73_H      _PK_H_(0x1B, 0x73)
#define REG_SC_BK1B_74_L      _PK_L_(0x1B, 0x74)
#define REG_SC_BK1B_74_H      _PK_H_(0x1B, 0x74)
#define REG_SC_BK1B_75_L      _PK_L_(0x1B, 0x75)
#define REG_SC_BK1B_75_H      _PK_H_(0x1B, 0x75)
#define REG_SC_BK1B_76_L      _PK_L_(0x1B, 0x76)
#define REG_SC_BK1B_76_H      _PK_H_(0x1B, 0x76)
#define REG_SC_BK1B_77_L      _PK_L_(0x1B, 0x77)
#define REG_SC_BK1B_77_H      _PK_H_(0x1B, 0x77)
#define REG_SC_BK1B_78_L      _PK_L_(0x1B, 0x78)
#define REG_SC_BK1B_78_H      _PK_H_(0x1B, 0x78)
#define REG_SC_BK1B_79_L      _PK_L_(0x1B, 0x79)
#define REG_SC_BK1B_79_H      _PK_H_(0x1B, 0x79)
#define REG_SC_BK1B_7A_L      _PK_L_(0x1B, 0x7A)
#define REG_SC_BK1B_7A_H      _PK_H_(0x1B, 0x7A)
#define REG_SC_BK1B_7B_L      _PK_L_(0x1B, 0x7B)
#define REG_SC_BK1B_7B_H      _PK_H_(0x1B, 0x7B)
#define REG_SC_BK1B_7C_L      _PK_L_(0x1B, 0x7C)
#define REG_SC_BK1B_7C_H      _PK_H_(0x1B, 0x7C)
#define REG_SC_BK1B_7D_L      _PK_L_(0x1B, 0x7D)
#define REG_SC_BK1B_7D_H      _PK_H_(0x1B, 0x7D)
#define REG_SC_BK1B_7E_L      _PK_L_(0x1B, 0x7E)
#define REG_SC_BK1B_7E_H      _PK_H_(0x1B, 0x7E)
#define REG_SC_BK1B_7F_L      _PK_L_(0x1B, 0x7F)
#define REG_SC_BK1B_7F_H      _PK_H_(0x1B, 0x7F)
//----------------------------------------------
#define REG_SC_BK1C_00_L      _PK_L_(0x1C, 0x00)
#define REG_SC_BK1C_00_H      _PK_H_(0x1C, 0x00)
#define REG_SC_BK1C_01_L      _PK_L_(0x1C, 0x01)
#define REG_SC_BK1C_01_H      _PK_H_(0x1C, 0x01)
#define REG_SC_BK1C_02_L      _PK_L_(0x1C, 0x02)
#define REG_SC_BK1C_02_H      _PK_H_(0x1C, 0x02)
#define REG_SC_BK1C_03_L      _PK_L_(0x1C, 0x03)
#define REG_SC_BK1C_03_H      _PK_H_(0x1C, 0x03)
#define REG_SC_BK1C_04_L      _PK_L_(0x1C, 0x04)
#define REG_SC_BK1C_04_H      _PK_H_(0x1C, 0x04)
#define REG_SC_BK1C_05_L      _PK_L_(0x1C, 0x05)
#define REG_SC_BK1C_05_H      _PK_H_(0x1C, 0x05)
#define REG_SC_BK1C_06_L      _PK_L_(0x1C, 0x06)
#define REG_SC_BK1C_06_H      _PK_H_(0x1C, 0x06)
#define REG_SC_BK1C_07_L      _PK_L_(0x1C, 0x07)
#define REG_SC_BK1C_07_H      _PK_H_(0x1C, 0x07)
#define REG_SC_BK1C_08_L      _PK_L_(0x1C, 0x08)
#define REG_SC_BK1C_08_H      _PK_H_(0x1C, 0x08)
#define REG_SC_BK1C_09_L      _PK_L_(0x1C, 0x09)
#define REG_SC_BK1C_09_H      _PK_H_(0x1C, 0x09)
#define REG_SC_BK1C_0A_L      _PK_L_(0x1C, 0x0A)
#define REG_SC_BK1C_0A_H      _PK_H_(0x1C, 0x0A)
#define REG_SC_BK1C_0B_L      _PK_L_(0x1C, 0x0B)
#define REG_SC_BK1C_0B_H      _PK_H_(0x1C, 0x0B)
#define REG_SC_BK1C_0C_L      _PK_L_(0x1C, 0x0C)
#define REG_SC_BK1C_0C_H      _PK_H_(0x1C, 0x0C)
#define REG_SC_BK1C_0D_L      _PK_L_(0x1C, 0x0D)
#define REG_SC_BK1C_0D_H      _PK_H_(0x1C, 0x0D)
#define REG_SC_BK1C_0E_L      _PK_L_(0x1C, 0x0E)
#define REG_SC_BK1C_0E_H      _PK_H_(0x1C, 0x0E)
#define REG_SC_BK1C_0F_L      _PK_L_(0x1C, 0x0F)
#define REG_SC_BK1C_0F_H      _PK_H_(0x1C, 0x0F)
#define REG_SC_BK1C_10_L      _PK_L_(0x1C, 0x10)
#define REG_SC_BK1C_10_H      _PK_H_(0x1C, 0x10)
#define REG_SC_BK1C_11_L      _PK_L_(0x1C, 0x11)
#define REG_SC_BK1C_11_H      _PK_H_(0x1C, 0x11)
#define REG_SC_BK1C_12_L      _PK_L_(0x1C, 0x12)
#define REG_SC_BK1C_12_H      _PK_H_(0x1C, 0x12)
#define REG_SC_BK1C_13_L      _PK_L_(0x1C, 0x13)
#define REG_SC_BK1C_13_H      _PK_H_(0x1C, 0x13)
#define REG_SC_BK1C_14_L      _PK_L_(0x1C, 0x14)
#define REG_SC_BK1C_14_H      _PK_H_(0x1C, 0x14)
#define REG_SC_BK1C_15_L      _PK_L_(0x1C, 0x15)
#define REG_SC_BK1C_15_H      _PK_H_(0x1C, 0x15)
#define REG_SC_BK1C_16_L      _PK_L_(0x1C, 0x16)
#define REG_SC_BK1C_16_H      _PK_H_(0x1C, 0x16)
#define REG_SC_BK1C_17_L      _PK_L_(0x1C, 0x17)
#define REG_SC_BK1C_17_H      _PK_H_(0x1C, 0x17)
#define REG_SC_BK1C_18_L      _PK_L_(0x1C, 0x18)
#define REG_SC_BK1C_18_H      _PK_H_(0x1C, 0x18)
#define REG_SC_BK1C_19_L      _PK_L_(0x1C, 0x19)
#define REG_SC_BK1C_19_H      _PK_H_(0x1C, 0x19)
#define REG_SC_BK1C_1A_L      _PK_L_(0x1C, 0x1A)
#define REG_SC_BK1C_1A_H      _PK_H_(0x1C, 0x1A)
#define REG_SC_BK1C_1B_L      _PK_L_(0x1C, 0x1B)
#define REG_SC_BK1C_1B_H      _PK_H_(0x1C, 0x1B)
#define REG_SC_BK1C_1C_L      _PK_L_(0x1C, 0x1C)
#define REG_SC_BK1C_1C_H      _PK_H_(0x1C, 0x1C)
#define REG_SC_BK1C_1D_L      _PK_L_(0x1C, 0x1D)
#define REG_SC_BK1C_1D_H      _PK_H_(0x1C, 0x1D)
#define REG_SC_BK1C_1E_L      _PK_L_(0x1C, 0x1E)
#define REG_SC_BK1C_1E_H      _PK_H_(0x1C, 0x1E)
#define REG_SC_BK1C_1F_L      _PK_L_(0x1C, 0x1F)
#define REG_SC_BK1C_1F_H      _PK_H_(0x1C, 0x1F)
#define REG_SC_BK1C_20_L      _PK_L_(0x1C, 0x20)
#define REG_SC_BK1C_20_H      _PK_H_(0x1C, 0x20)
#define REG_SC_BK1C_21_L      _PK_L_(0x1C, 0x21)
#define REG_SC_BK1C_21_H      _PK_H_(0x1C, 0x21)
#define REG_SC_BK1C_22_L      _PK_L_(0x1C, 0x22)
#define REG_SC_BK1C_22_H      _PK_H_(0x1C, 0x22)
#define REG_SC_BK1C_23_L      _PK_L_(0x1C, 0x23)
#define REG_SC_BK1C_23_H      _PK_H_(0x1C, 0x23)
#define REG_SC_BK1C_24_L      _PK_L_(0x1C, 0x24)
#define REG_SC_BK1C_24_H      _PK_H_(0x1C, 0x24)
#define REG_SC_BK1C_25_L      _PK_L_(0x1C, 0x25)
#define REG_SC_BK1C_25_H      _PK_H_(0x1C, 0x25)
#define REG_SC_BK1C_26_L      _PK_L_(0x1C, 0x26)
#define REG_SC_BK1C_26_H      _PK_H_(0x1C, 0x26)
#define REG_SC_BK1C_27_L      _PK_L_(0x1C, 0x27)
#define REG_SC_BK1C_27_H      _PK_H_(0x1C, 0x27)
#define REG_SC_BK1C_28_L      _PK_L_(0x1C, 0x28)
#define REG_SC_BK1C_28_H      _PK_H_(0x1C, 0x28)
#define REG_SC_BK1C_29_L      _PK_L_(0x1C, 0x29)
#define REG_SC_BK1C_29_H      _PK_H_(0x1C, 0x29)
#define REG_SC_BK1C_2A_L      _PK_L_(0x1C, 0x2A)
#define REG_SC_BK1C_2A_H      _PK_H_(0x1C, 0x2A)
#define REG_SC_BK1C_2B_L      _PK_L_(0x1C, 0x2B)
#define REG_SC_BK1C_2B_H      _PK_H_(0x1C, 0x2B)
#define REG_SC_BK1C_2C_L      _PK_L_(0x1C, 0x2C)
#define REG_SC_BK1C_2C_H      _PK_H_(0x1C, 0x2C)
#define REG_SC_BK1C_2D_L      _PK_L_(0x1C, 0x2D)
#define REG_SC_BK1C_2D_H      _PK_H_(0x1C, 0x2D)
#define REG_SC_BK1C_2E_L      _PK_L_(0x1C, 0x2E)
#define REG_SC_BK1C_2E_H      _PK_H_(0x1C, 0x2E)
#define REG_SC_BK1C_2F_L      _PK_L_(0x1C, 0x2F)
#define REG_SC_BK1C_2F_H      _PK_H_(0x1C, 0x2F)
#define REG_SC_BK1C_30_L      _PK_L_(0x1C, 0x30)
#define REG_SC_BK1C_30_H      _PK_H_(0x1C, 0x30)
#define REG_SC_BK1C_31_L      _PK_L_(0x1C, 0x31)
#define REG_SC_BK1C_31_H      _PK_H_(0x1C, 0x31)
#define REG_SC_BK1C_32_L      _PK_L_(0x1C, 0x32)
#define REG_SC_BK1C_32_H      _PK_H_(0x1C, 0x32)
#define REG_SC_BK1C_33_L      _PK_L_(0x1C, 0x33)
#define REG_SC_BK1C_33_H      _PK_H_(0x1C, 0x33)
#define REG_SC_BK1C_34_L      _PK_L_(0x1C, 0x34)
#define REG_SC_BK1C_34_H      _PK_H_(0x1C, 0x34)
#define REG_SC_BK1C_35_L      _PK_L_(0x1C, 0x35)
#define REG_SC_BK1C_35_H      _PK_H_(0x1C, 0x35)
#define REG_SC_BK1C_36_L      _PK_L_(0x1C, 0x36)
#define REG_SC_BK1C_36_H      _PK_H_(0x1C, 0x36)
#define REG_SC_BK1C_37_L      _PK_L_(0x1C, 0x37)
#define REG_SC_BK1C_37_H      _PK_H_(0x1C, 0x37)
#define REG_SC_BK1C_38_L      _PK_L_(0x1C, 0x38)
#define REG_SC_BK1C_38_H      _PK_H_(0x1C, 0x38)
#define REG_SC_BK1C_39_L      _PK_L_(0x1C, 0x39)
#define REG_SC_BK1C_39_H      _PK_H_(0x1C, 0x39)
#define REG_SC_BK1C_3A_L      _PK_L_(0x1C, 0x3A)
#define REG_SC_BK1C_3A_H      _PK_H_(0x1C, 0x3A)
#define REG_SC_BK1C_3B_L      _PK_L_(0x1C, 0x3B)
#define REG_SC_BK1C_3B_H      _PK_H_(0x1C, 0x3B)
#define REG_SC_BK1C_3C_L      _PK_L_(0x1C, 0x3C)
#define REG_SC_BK1C_3C_H      _PK_H_(0x1C, 0x3C)
#define REG_SC_BK1C_3D_L      _PK_L_(0x1C, 0x3D)
#define REG_SC_BK1C_3D_H      _PK_H_(0x1C, 0x3D)
#define REG_SC_BK1C_3E_L      _PK_L_(0x1C, 0x3E)
#define REG_SC_BK1C_3E_H      _PK_H_(0x1C, 0x3E)
#define REG_SC_BK1C_3F_L      _PK_L_(0x1C, 0x3F)
#define REG_SC_BK1C_3F_H      _PK_H_(0x1C, 0x3F)
#define REG_SC_BK1C_40_L      _PK_L_(0x1C, 0x40)
#define REG_SC_BK1C_40_H      _PK_H_(0x1C, 0x40)
#define REG_SC_BK1C_41_L      _PK_L_(0x1C, 0x41)
#define REG_SC_BK1C_41_H      _PK_H_(0x1C, 0x41)
#define REG_SC_BK1C_42_L      _PK_L_(0x1C, 0x42)
#define REG_SC_BK1C_42_H      _PK_H_(0x1C, 0x42)
#define REG_SC_BK1C_43_L      _PK_L_(0x1C, 0x43)
#define REG_SC_BK1C_43_H      _PK_H_(0x1C, 0x43)
#define REG_SC_BK1C_44_L      _PK_L_(0x1C, 0x44)
#define REG_SC_BK1C_44_H      _PK_H_(0x1C, 0x44)
#define REG_SC_BK1C_45_L      _PK_L_(0x1C, 0x45)
#define REG_SC_BK1C_45_H      _PK_H_(0x1C, 0x45)
#define REG_SC_BK1C_46_L      _PK_L_(0x1C, 0x46)
#define REG_SC_BK1C_46_H      _PK_H_(0x1C, 0x46)
#define REG_SC_BK1C_47_L      _PK_L_(0x1C, 0x47)
#define REG_SC_BK1C_47_H      _PK_H_(0x1C, 0x47)
#define REG_SC_BK1C_48_L      _PK_L_(0x1C, 0x48)
#define REG_SC_BK1C_48_H      _PK_H_(0x1C, 0x48)
#define REG_SC_BK1C_49_L      _PK_L_(0x1C, 0x49)
#define REG_SC_BK1C_49_H      _PK_H_(0x1C, 0x49)
#define REG_SC_BK1C_4A_L      _PK_L_(0x1C, 0x4A)
#define REG_SC_BK1C_4A_H      _PK_H_(0x1C, 0x4A)
#define REG_SC_BK1C_4B_L      _PK_L_(0x1C, 0x4B)
#define REG_SC_BK1C_4B_H      _PK_H_(0x1C, 0x4B)
#define REG_SC_BK1C_4C_L      _PK_L_(0x1C, 0x4C)
#define REG_SC_BK1C_4C_H      _PK_H_(0x1C, 0x4C)
#define REG_SC_BK1C_4D_L      _PK_L_(0x1C, 0x4D)
#define REG_SC_BK1C_4D_H      _PK_H_(0x1C, 0x4D)
#define REG_SC_BK1C_4E_L      _PK_L_(0x1C, 0x4E)
#define REG_SC_BK1C_4E_H      _PK_H_(0x1C, 0x4E)
#define REG_SC_BK1C_4F_L      _PK_L_(0x1C, 0x4F)
#define REG_SC_BK1C_4F_H      _PK_H_(0x1C, 0x4F)
#define REG_SC_BK1C_50_L      _PK_L_(0x1C, 0x50)
#define REG_SC_BK1C_50_H      _PK_H_(0x1C, 0x50)
#define REG_SC_BK1C_51_L      _PK_L_(0x1C, 0x51)
#define REG_SC_BK1C_51_H      _PK_H_(0x1C, 0x51)
#define REG_SC_BK1C_52_L      _PK_L_(0x1C, 0x52)
#define REG_SC_BK1C_52_H      _PK_H_(0x1C, 0x52)
#define REG_SC_BK1C_53_L      _PK_L_(0x1C, 0x53)
#define REG_SC_BK1C_53_H      _PK_H_(0x1C, 0x53)
#define REG_SC_BK1C_54_L      _PK_L_(0x1C, 0x54)
#define REG_SC_BK1C_54_H      _PK_H_(0x1C, 0x54)
#define REG_SC_BK1C_55_L      _PK_L_(0x1C, 0x55)
#define REG_SC_BK1C_55_H      _PK_H_(0x1C, 0x55)
#define REG_SC_BK1C_56_L      _PK_L_(0x1C, 0x56)
#define REG_SC_BK1C_56_H      _PK_H_(0x1C, 0x56)
#define REG_SC_BK1C_57_L      _PK_L_(0x1C, 0x57)
#define REG_SC_BK1C_57_H      _PK_H_(0x1C, 0x57)
#define REG_SC_BK1C_58_L      _PK_L_(0x1C, 0x58)
#define REG_SC_BK1C_58_H      _PK_H_(0x1C, 0x58)
#define REG_SC_BK1C_59_L      _PK_L_(0x1C, 0x59)
#define REG_SC_BK1C_59_H      _PK_H_(0x1C, 0x59)
#define REG_SC_BK1C_5A_L      _PK_L_(0x1C, 0x5A)
#define REG_SC_BK1C_5A_H      _PK_H_(0x1C, 0x5A)
#define REG_SC_BK1C_5B_L      _PK_L_(0x1C, 0x5B)
#define REG_SC_BK1C_5B_H      _PK_H_(0x1C, 0x5B)
#define REG_SC_BK1C_5C_L      _PK_L_(0x1C, 0x5C)
#define REG_SC_BK1C_5C_H      _PK_H_(0x1C, 0x5C)
#define REG_SC_BK1C_5D_L      _PK_L_(0x1C, 0x5D)
#define REG_SC_BK1C_5D_H      _PK_H_(0x1C, 0x5D)
#define REG_SC_BK1C_5E_L      _PK_L_(0x1C, 0x5E)
#define REG_SC_BK1C_5E_H      _PK_H_(0x1C, 0x5E)
#define REG_SC_BK1C_5F_L      _PK_L_(0x1C, 0x5F)
#define REG_SC_BK1C_5F_H      _PK_H_(0x1C, 0x5F)
#define REG_SC_BK1C_60_L      _PK_L_(0x1C, 0x60)
#define REG_SC_BK1C_60_H      _PK_H_(0x1C, 0x60)
#define REG_SC_BK1C_61_L      _PK_L_(0x1C, 0x61)
#define REG_SC_BK1C_61_H      _PK_H_(0x1C, 0x61)
#define REG_SC_BK1C_62_L      _PK_L_(0x1C, 0x62)
#define REG_SC_BK1C_62_H      _PK_H_(0x1C, 0x62)
#define REG_SC_BK1C_63_L      _PK_L_(0x1C, 0x63)
#define REG_SC_BK1C_63_H      _PK_H_(0x1C, 0x63)
#define REG_SC_BK1C_64_L      _PK_L_(0x1C, 0x64)
#define REG_SC_BK1C_64_H      _PK_H_(0x1C, 0x64)
#define REG_SC_BK1C_65_L      _PK_L_(0x1C, 0x65)
#define REG_SC_BK1C_65_H      _PK_H_(0x1C, 0x65)
#define REG_SC_BK1C_66_L      _PK_L_(0x1C, 0x66)
#define REG_SC_BK1C_66_H      _PK_H_(0x1C, 0x66)
#define REG_SC_BK1C_67_L      _PK_L_(0x1C, 0x67)
#define REG_SC_BK1C_67_H      _PK_H_(0x1C, 0x67)
#define REG_SC_BK1C_68_L      _PK_L_(0x1C, 0x68)
#define REG_SC_BK1C_68_H      _PK_H_(0x1C, 0x68)
#define REG_SC_BK1C_69_L      _PK_L_(0x1C, 0x69)
#define REG_SC_BK1C_69_H      _PK_H_(0x1C, 0x69)
#define REG_SC_BK1C_6A_L      _PK_L_(0x1C, 0x6A)
#define REG_SC_BK1C_6A_H      _PK_H_(0x1C, 0x6A)
#define REG_SC_BK1C_6B_L      _PK_L_(0x1C, 0x6B)
#define REG_SC_BK1C_6B_H      _PK_H_(0x1C, 0x6B)
#define REG_SC_BK1C_6C_L      _PK_L_(0x1C, 0x6C)
#define REG_SC_BK1C_6C_H      _PK_H_(0x1C, 0x6C)
#define REG_SC_BK1C_6D_L      _PK_L_(0x1C, 0x6D)
#define REG_SC_BK1C_6D_H      _PK_H_(0x1C, 0x6D)
#define REG_SC_BK1C_6E_L      _PK_L_(0x1C, 0x6E)
#define REG_SC_BK1C_6E_H      _PK_H_(0x1C, 0x6E)
#define REG_SC_BK1C_6F_L      _PK_L_(0x1C, 0x6F)
#define REG_SC_BK1C_6F_H      _PK_H_(0x1C, 0x6F)
#define REG_SC_BK1C_70_L      _PK_L_(0x1C, 0x70)
#define REG_SC_BK1C_70_H      _PK_H_(0x1C, 0x70)
#define REG_SC_BK1C_71_L      _PK_L_(0x1C, 0x71)
#define REG_SC_BK1C_71_H      _PK_H_(0x1C, 0x71)
#define REG_SC_BK1C_72_L      _PK_L_(0x1C, 0x72)
#define REG_SC_BK1C_72_H      _PK_H_(0x1C, 0x72)
#define REG_SC_BK1C_73_L      _PK_L_(0x1C, 0x73)
#define REG_SC_BK1C_73_H      _PK_H_(0x1C, 0x73)
#define REG_SC_BK1C_74_L      _PK_L_(0x1C, 0x74)
#define REG_SC_BK1C_74_H      _PK_H_(0x1C, 0x74)
#define REG_SC_BK1C_75_L      _PK_L_(0x1C, 0x75)
#define REG_SC_BK1C_75_H      _PK_H_(0x1C, 0x75)
#define REG_SC_BK1C_76_L      _PK_L_(0x1C, 0x76)
#define REG_SC_BK1C_76_H      _PK_H_(0x1C, 0x76)
#define REG_SC_BK1C_77_L      _PK_L_(0x1C, 0x77)
#define REG_SC_BK1C_77_H      _PK_H_(0x1C, 0x77)
#define REG_SC_BK1C_78_L      _PK_L_(0x1C, 0x78)
#define REG_SC_BK1C_78_H      _PK_H_(0x1C, 0x78)
#define REG_SC_BK1C_79_L      _PK_L_(0x1C, 0x79)
#define REG_SC_BK1C_79_H      _PK_H_(0x1C, 0x79)
#define REG_SC_BK1C_7A_L      _PK_L_(0x1C, 0x7A)
#define REG_SC_BK1C_7A_H      _PK_H_(0x1C, 0x7A)
#define REG_SC_BK1C_7B_L      _PK_L_(0x1C, 0x7B)
#define REG_SC_BK1C_7B_H      _PK_H_(0x1C, 0x7B)
#define REG_SC_BK1C_7C_L      _PK_L_(0x1C, 0x7C)
#define REG_SC_BK1C_7C_H      _PK_H_(0x1C, 0x7C)
#define REG_SC_BK1C_7D_L      _PK_L_(0x1C, 0x7D)
#define REG_SC_BK1C_7D_H      _PK_H_(0x1C, 0x7D)
#define REG_SC_BK1C_7E_L      _PK_L_(0x1C, 0x7E)
#define REG_SC_BK1C_7E_H      _PK_H_(0x1C, 0x7E)
#define REG_SC_BK1C_7F_L      _PK_L_(0x1C, 0x7F)
#define REG_SC_BK1C_7F_H      _PK_H_(0x1C, 0x7F)
//----------------------------------------------
#define REG_SC_BK1D_00_L      _PK_L_(0x1D, 0x00)
#define REG_SC_BK1D_00_H      _PK_H_(0x1D, 0x00)
#define REG_SC_BK1D_01_L      _PK_L_(0x1D, 0x01)
#define REG_SC_BK1D_01_H      _PK_H_(0x1D, 0x01)
#define REG_SC_BK1D_02_L      _PK_L_(0x1D, 0x02)
#define REG_SC_BK1D_02_H      _PK_H_(0x1D, 0x02)
#define REG_SC_BK1D_03_L      _PK_L_(0x1D, 0x03)
#define REG_SC_BK1D_03_H      _PK_H_(0x1D, 0x03)
#define REG_SC_BK1D_04_L      _PK_L_(0x1D, 0x04)
#define REG_SC_BK1D_04_H      _PK_H_(0x1D, 0x04)
#define REG_SC_BK1D_05_L      _PK_L_(0x1D, 0x05)
#define REG_SC_BK1D_05_H      _PK_H_(0x1D, 0x05)
#define REG_SC_BK1D_06_L      _PK_L_(0x1D, 0x06)
#define REG_SC_BK1D_06_H      _PK_H_(0x1D, 0x06)
#define REG_SC_BK1D_07_L      _PK_L_(0x1D, 0x07)
#define REG_SC_BK1D_07_H      _PK_H_(0x1D, 0x07)
#define REG_SC_BK1D_08_L      _PK_L_(0x1D, 0x08)
#define REG_SC_BK1D_08_H      _PK_H_(0x1D, 0x08)
#define REG_SC_BK1D_09_L      _PK_L_(0x1D, 0x09)
#define REG_SC_BK1D_09_H      _PK_H_(0x1D, 0x09)
#define REG_SC_BK1D_0A_L      _PK_L_(0x1D, 0x0A)
#define REG_SC_BK1D_0A_H      _PK_H_(0x1D, 0x0A)
#define REG_SC_BK1D_0B_L      _PK_L_(0x1D, 0x0B)
#define REG_SC_BK1D_0B_H      _PK_H_(0x1D, 0x0B)
#define REG_SC_BK1D_0C_L      _PK_L_(0x1D, 0x0C)
#define REG_SC_BK1D_0C_H      _PK_H_(0x1D, 0x0C)
#define REG_SC_BK1D_0D_L      _PK_L_(0x1D, 0x0D)
#define REG_SC_BK1D_0D_H      _PK_H_(0x1D, 0x0D)
#define REG_SC_BK1D_0E_L      _PK_L_(0x1D, 0x0E)
#define REG_SC_BK1D_0E_H      _PK_H_(0x1D, 0x0E)
#define REG_SC_BK1D_0F_L      _PK_L_(0x1D, 0x0F)
#define REG_SC_BK1D_0F_H      _PK_H_(0x1D, 0x0F)
#define REG_SC_BK1D_10_L      _PK_L_(0x1D, 0x10)
#define REG_SC_BK1D_10_H      _PK_H_(0x1D, 0x10)
#define REG_SC_BK1D_11_L      _PK_L_(0x1D, 0x11)
#define REG_SC_BK1D_11_H      _PK_H_(0x1D, 0x11)
#define REG_SC_BK1D_12_L      _PK_L_(0x1D, 0x12)
#define REG_SC_BK1D_12_H      _PK_H_(0x1D, 0x12)
#define REG_SC_BK1D_13_L      _PK_L_(0x1D, 0x13)
#define REG_SC_BK1D_13_H      _PK_H_(0x1D, 0x13)
#define REG_SC_BK1D_14_L      _PK_L_(0x1D, 0x14)
#define REG_SC_BK1D_14_H      _PK_H_(0x1D, 0x14)
#define REG_SC_BK1D_15_L      _PK_L_(0x1D, 0x15)
#define REG_SC_BK1D_15_H      _PK_H_(0x1D, 0x15)
#define REG_SC_BK1D_16_L      _PK_L_(0x1D, 0x16)
#define REG_SC_BK1D_16_H      _PK_H_(0x1D, 0x16)
#define REG_SC_BK1D_17_L      _PK_L_(0x1D, 0x17)
#define REG_SC_BK1D_17_H      _PK_H_(0x1D, 0x17)
#define REG_SC_BK1D_18_L      _PK_L_(0x1D, 0x18)
#define REG_SC_BK1D_18_H      _PK_H_(0x1D, 0x18)
#define REG_SC_BK1D_19_L      _PK_L_(0x1D, 0x19)
#define REG_SC_BK1D_19_H      _PK_H_(0x1D, 0x19)
#define REG_SC_BK1D_1A_L      _PK_L_(0x1D, 0x1A)
#define REG_SC_BK1D_1A_H      _PK_H_(0x1D, 0x1A)
#define REG_SC_BK1D_1B_L      _PK_L_(0x1D, 0x1B)
#define REG_SC_BK1D_1B_H      _PK_H_(0x1D, 0x1B)
#define REG_SC_BK1D_1C_L      _PK_L_(0x1D, 0x1C)
#define REG_SC_BK1D_1C_H      _PK_H_(0x1D, 0x1C)
#define REG_SC_BK1D_1D_L      _PK_L_(0x1D, 0x1D)
#define REG_SC_BK1D_1D_H      _PK_H_(0x1D, 0x1D)
#define REG_SC_BK1D_1E_L      _PK_L_(0x1D, 0x1E)
#define REG_SC_BK1D_1E_H      _PK_H_(0x1D, 0x1E)
#define REG_SC_BK1D_1F_L      _PK_L_(0x1D, 0x1F)
#define REG_SC_BK1D_1F_H      _PK_H_(0x1D, 0x1F)
#define REG_SC_BK1D_20_L      _PK_L_(0x1D, 0x20)
#define REG_SC_BK1D_20_H      _PK_H_(0x1D, 0x20)
#define REG_SC_BK1D_21_L      _PK_L_(0x1D, 0x21)
#define REG_SC_BK1D_21_H      _PK_H_(0x1D, 0x21)
#define REG_SC_BK1D_22_L      _PK_L_(0x1D, 0x22)
#define REG_SC_BK1D_22_H      _PK_H_(0x1D, 0x22)
#define REG_SC_BK1D_23_L      _PK_L_(0x1D, 0x23)
#define REG_SC_BK1D_23_H      _PK_H_(0x1D, 0x23)
#define REG_SC_BK1D_24_L      _PK_L_(0x1D, 0x24)
#define REG_SC_BK1D_24_H      _PK_H_(0x1D, 0x24)
#define REG_SC_BK1D_25_L      _PK_L_(0x1D, 0x25)
#define REG_SC_BK1D_25_H      _PK_H_(0x1D, 0x25)
#define REG_SC_BK1D_26_L      _PK_L_(0x1D, 0x26)
#define REG_SC_BK1D_26_H      _PK_H_(0x1D, 0x26)
#define REG_SC_BK1D_27_L      _PK_L_(0x1D, 0x27)
#define REG_SC_BK1D_27_H      _PK_H_(0x1D, 0x27)
#define REG_SC_BK1D_28_L      _PK_L_(0x1D, 0x28)
#define REG_SC_BK1D_28_H      _PK_H_(0x1D, 0x28)
#define REG_SC_BK1D_29_L      _PK_L_(0x1D, 0x29)
#define REG_SC_BK1D_29_H      _PK_H_(0x1D, 0x29)
#define REG_SC_BK1D_2A_L      _PK_L_(0x1D, 0x2A)
#define REG_SC_BK1D_2A_H      _PK_H_(0x1D, 0x2A)
#define REG_SC_BK1D_2B_L      _PK_L_(0x1D, 0x2B)
#define REG_SC_BK1D_2B_H      _PK_H_(0x1D, 0x2B)
#define REG_SC_BK1D_2C_L      _PK_L_(0x1D, 0x2C)
#define REG_SC_BK1D_2C_H      _PK_H_(0x1D, 0x2C)
#define REG_SC_BK1D_2D_L      _PK_L_(0x1D, 0x2D)
#define REG_SC_BK1D_2D_H      _PK_H_(0x1D, 0x2D)
#define REG_SC_BK1D_2E_L      _PK_L_(0x1D, 0x2E)
#define REG_SC_BK1D_2E_H      _PK_H_(0x1D, 0x2E)
#define REG_SC_BK1D_2F_L      _PK_L_(0x1D, 0x2F)
#define REG_SC_BK1D_2F_H      _PK_H_(0x1D, 0x2F)
#define REG_SC_BK1D_30_L      _PK_L_(0x1D, 0x30)
#define REG_SC_BK1D_30_H      _PK_H_(0x1D, 0x30)
#define REG_SC_BK1D_31_L      _PK_L_(0x1D, 0x31)
#define REG_SC_BK1D_31_H      _PK_H_(0x1D, 0x31)
#define REG_SC_BK1D_32_L      _PK_L_(0x1D, 0x32)
#define REG_SC_BK1D_32_H      _PK_H_(0x1D, 0x32)
#define REG_SC_BK1D_33_L      _PK_L_(0x1D, 0x33)
#define REG_SC_BK1D_33_H      _PK_H_(0x1D, 0x33)
#define REG_SC_BK1D_34_L      _PK_L_(0x1D, 0x34)
#define REG_SC_BK1D_34_H      _PK_H_(0x1D, 0x34)
#define REG_SC_BK1D_35_L      _PK_L_(0x1D, 0x35)
#define REG_SC_BK1D_35_H      _PK_H_(0x1D, 0x35)
#define REG_SC_BK1D_36_L      _PK_L_(0x1D, 0x36)
#define REG_SC_BK1D_36_H      _PK_H_(0x1D, 0x36)
#define REG_SC_BK1D_37_L      _PK_L_(0x1D, 0x37)
#define REG_SC_BK1D_37_H      _PK_H_(0x1D, 0x37)
#define REG_SC_BK1D_38_L      _PK_L_(0x1D, 0x38)
#define REG_SC_BK1D_38_H      _PK_H_(0x1D, 0x38)
#define REG_SC_BK1D_39_L      _PK_L_(0x1D, 0x39)
#define REG_SC_BK1D_39_H      _PK_H_(0x1D, 0x39)
#define REG_SC_BK1D_3A_L      _PK_L_(0x1D, 0x3A)
#define REG_SC_BK1D_3A_H      _PK_H_(0x1D, 0x3A)
#define REG_SC_BK1D_3B_L      _PK_L_(0x1D, 0x3B)
#define REG_SC_BK1D_3B_H      _PK_H_(0x1D, 0x3B)
#define REG_SC_BK1D_3C_L      _PK_L_(0x1D, 0x3C)
#define REG_SC_BK1D_3C_H      _PK_H_(0x1D, 0x3C)
#define REG_SC_BK1D_3D_L      _PK_L_(0x1D, 0x3D)
#define REG_SC_BK1D_3D_H      _PK_H_(0x1D, 0x3D)
#define REG_SC_BK1D_3E_L      _PK_L_(0x1D, 0x3E)
#define REG_SC_BK1D_3E_H      _PK_H_(0x1D, 0x3E)
#define REG_SC_BK1D_3F_L      _PK_L_(0x1D, 0x3F)
#define REG_SC_BK1D_3F_H      _PK_H_(0x1D, 0x3F)
#define REG_SC_BK1D_40_L      _PK_L_(0x1D, 0x40)
#define REG_SC_BK1D_40_H      _PK_H_(0x1D, 0x40)
#define REG_SC_BK1D_41_L      _PK_L_(0x1D, 0x41)
#define REG_SC_BK1D_41_H      _PK_H_(0x1D, 0x41)
#define REG_SC_BK1D_42_L      _PK_L_(0x1D, 0x42)
#define REG_SC_BK1D_42_H      _PK_H_(0x1D, 0x42)
#define REG_SC_BK1D_43_L      _PK_L_(0x1D, 0x43)
#define REG_SC_BK1D_43_H      _PK_H_(0x1D, 0x43)
#define REG_SC_BK1D_44_L      _PK_L_(0x1D, 0x44)
#define REG_SC_BK1D_44_H      _PK_H_(0x1D, 0x44)
#define REG_SC_BK1D_45_L      _PK_L_(0x1D, 0x45)
#define REG_SC_BK1D_45_H      _PK_H_(0x1D, 0x45)
#define REG_SC_BK1D_46_L      _PK_L_(0x1D, 0x46)
#define REG_SC_BK1D_46_H      _PK_H_(0x1D, 0x46)
#define REG_SC_BK1D_47_L      _PK_L_(0x1D, 0x47)
#define REG_SC_BK1D_47_H      _PK_H_(0x1D, 0x47)
#define REG_SC_BK1D_48_L      _PK_L_(0x1D, 0x48)
#define REG_SC_BK1D_48_H      _PK_H_(0x1D, 0x48)
#define REG_SC_BK1D_49_L      _PK_L_(0x1D, 0x49)
#define REG_SC_BK1D_49_H      _PK_H_(0x1D, 0x49)
#define REG_SC_BK1D_4A_L      _PK_L_(0x1D, 0x4A)
#define REG_SC_BK1D_4A_H      _PK_H_(0x1D, 0x4A)
#define REG_SC_BK1D_4B_L      _PK_L_(0x1D, 0x4B)
#define REG_SC_BK1D_4B_H      _PK_H_(0x1D, 0x4B)
#define REG_SC_BK1D_4C_L      _PK_L_(0x1D, 0x4C)
#define REG_SC_BK1D_4C_H      _PK_H_(0x1D, 0x4C)
#define REG_SC_BK1D_4D_L      _PK_L_(0x1D, 0x4D)
#define REG_SC_BK1D_4D_H      _PK_H_(0x1D, 0x4D)
#define REG_SC_BK1D_4E_L      _PK_L_(0x1D, 0x4E)
#define REG_SC_BK1D_4E_H      _PK_H_(0x1D, 0x4E)
#define REG_SC_BK1D_4F_L      _PK_L_(0x1D, 0x4F)
#define REG_SC_BK1D_4F_H      _PK_H_(0x1D, 0x4F)
#define REG_SC_BK1D_50_L      _PK_L_(0x1D, 0x50)
#define REG_SC_BK1D_50_H      _PK_H_(0x1D, 0x50)
#define REG_SC_BK1D_51_L      _PK_L_(0x1D, 0x51)
#define REG_SC_BK1D_51_H      _PK_H_(0x1D, 0x51)
#define REG_SC_BK1D_52_L      _PK_L_(0x1D, 0x52)
#define REG_SC_BK1D_52_H      _PK_H_(0x1D, 0x52)
#define REG_SC_BK1D_53_L      _PK_L_(0x1D, 0x53)
#define REG_SC_BK1D_53_H      _PK_H_(0x1D, 0x53)
#define REG_SC_BK1D_54_L      _PK_L_(0x1D, 0x54)
#define REG_SC_BK1D_54_H      _PK_H_(0x1D, 0x54)
#define REG_SC_BK1D_55_L      _PK_L_(0x1D, 0x55)
#define REG_SC_BK1D_55_H      _PK_H_(0x1D, 0x55)
#define REG_SC_BK1D_56_L      _PK_L_(0x1D, 0x56)
#define REG_SC_BK1D_56_H      _PK_H_(0x1D, 0x56)
#define REG_SC_BK1D_57_L      _PK_L_(0x1D, 0x57)
#define REG_SC_BK1D_57_H      _PK_H_(0x1D, 0x57)
#define REG_SC_BK1D_58_L      _PK_L_(0x1D, 0x58)
#define REG_SC_BK1D_58_H      _PK_H_(0x1D, 0x58)
#define REG_SC_BK1D_59_L      _PK_L_(0x1D, 0x59)
#define REG_SC_BK1D_59_H      _PK_H_(0x1D, 0x59)
#define REG_SC_BK1D_5A_L      _PK_L_(0x1D, 0x5A)
#define REG_SC_BK1D_5A_H      _PK_H_(0x1D, 0x5A)
#define REG_SC_BK1D_5B_L      _PK_L_(0x1D, 0x5B)
#define REG_SC_BK1D_5B_H      _PK_H_(0x1D, 0x5B)
#define REG_SC_BK1D_5C_L      _PK_L_(0x1D, 0x5C)
#define REG_SC_BK1D_5C_H      _PK_H_(0x1D, 0x5C)
#define REG_SC_BK1D_5D_L      _PK_L_(0x1D, 0x5D)
#define REG_SC_BK1D_5D_H      _PK_H_(0x1D, 0x5D)
#define REG_SC_BK1D_5E_L      _PK_L_(0x1D, 0x5E)
#define REG_SC_BK1D_5E_H      _PK_H_(0x1D, 0x5E)
#define REG_SC_BK1D_5F_L      _PK_L_(0x1D, 0x5F)
#define REG_SC_BK1D_5F_H      _PK_H_(0x1D, 0x5F)
#define REG_SC_BK1D_60_L      _PK_L_(0x1D, 0x60)
#define REG_SC_BK1D_60_H      _PK_H_(0x1D, 0x60)
#define REG_SC_BK1D_61_L      _PK_L_(0x1D, 0x61)
#define REG_SC_BK1D_61_H      _PK_H_(0x1D, 0x61)
#define REG_SC_BK1D_62_L      _PK_L_(0x1D, 0x62)
#define REG_SC_BK1D_62_H      _PK_H_(0x1D, 0x62)
#define REG_SC_BK1D_63_L      _PK_L_(0x1D, 0x63)
#define REG_SC_BK1D_63_H      _PK_H_(0x1D, 0x63)
#define REG_SC_BK1D_64_L      _PK_L_(0x1D, 0x64)
#define REG_SC_BK1D_64_H      _PK_H_(0x1D, 0x64)
#define REG_SC_BK1D_65_L      _PK_L_(0x1D, 0x65)
#define REG_SC_BK1D_65_H      _PK_H_(0x1D, 0x65)
#define REG_SC_BK1D_66_L      _PK_L_(0x1D, 0x66)
#define REG_SC_BK1D_66_H      _PK_H_(0x1D, 0x66)
#define REG_SC_BK1D_67_L      _PK_L_(0x1D, 0x67)
#define REG_SC_BK1D_67_H      _PK_H_(0x1D, 0x67)
#define REG_SC_BK1D_68_L      _PK_L_(0x1D, 0x68)
#define REG_SC_BK1D_68_H      _PK_H_(0x1D, 0x68)
#define REG_SC_BK1D_69_L      _PK_L_(0x1D, 0x69)
#define REG_SC_BK1D_69_H      _PK_H_(0x1D, 0x69)
#define REG_SC_BK1D_6A_L      _PK_L_(0x1D, 0x6A)
#define REG_SC_BK1D_6A_H      _PK_H_(0x1D, 0x6A)
#define REG_SC_BK1D_6B_L      _PK_L_(0x1D, 0x6B)
#define REG_SC_BK1D_6B_H      _PK_H_(0x1D, 0x6B)
#define REG_SC_BK1D_6C_L      _PK_L_(0x1D, 0x6C)
#define REG_SC_BK1D_6C_H      _PK_H_(0x1D, 0x6C)
#define REG_SC_BK1D_6D_L      _PK_L_(0x1D, 0x6D)
#define REG_SC_BK1D_6D_H      _PK_H_(0x1D, 0x6D)
#define REG_SC_BK1D_6E_L      _PK_L_(0x1D, 0x6E)
#define REG_SC_BK1D_6E_H      _PK_H_(0x1D, 0x6E)
#define REG_SC_BK1D_6F_L      _PK_L_(0x1D, 0x6F)
#define REG_SC_BK1D_6F_H      _PK_H_(0x1D, 0x6F)
#define REG_SC_BK1D_70_L      _PK_L_(0x1D, 0x70)
#define REG_SC_BK1D_70_H      _PK_H_(0x1D, 0x70)
#define REG_SC_BK1D_71_L      _PK_L_(0x1D, 0x71)
#define REG_SC_BK1D_71_H      _PK_H_(0x1D, 0x71)
#define REG_SC_BK1D_72_L      _PK_L_(0x1D, 0x72)
#define REG_SC_BK1D_72_H      _PK_H_(0x1D, 0x72)
#define REG_SC_BK1D_73_L      _PK_L_(0x1D, 0x73)
#define REG_SC_BK1D_73_H      _PK_H_(0x1D, 0x73)
#define REG_SC_BK1D_74_L      _PK_L_(0x1D, 0x74)
#define REG_SC_BK1D_74_H      _PK_H_(0x1D, 0x74)
#define REG_SC_BK1D_75_L      _PK_L_(0x1D, 0x75)
#define REG_SC_BK1D_75_H      _PK_H_(0x1D, 0x75)
#define REG_SC_BK1D_76_L      _PK_L_(0x1D, 0x76)
#define REG_SC_BK1D_76_H      _PK_H_(0x1D, 0x76)
#define REG_SC_BK1D_77_L      _PK_L_(0x1D, 0x77)
#define REG_SC_BK1D_77_H      _PK_H_(0x1D, 0x77)
#define REG_SC_BK1D_78_L      _PK_L_(0x1D, 0x78)
#define REG_SC_BK1D_78_H      _PK_H_(0x1D, 0x78)
#define REG_SC_BK1D_79_L      _PK_L_(0x1D, 0x79)
#define REG_SC_BK1D_79_H      _PK_H_(0x1D, 0x79)
#define REG_SC_BK1D_7A_L      _PK_L_(0x1D, 0x7A)
#define REG_SC_BK1D_7A_H      _PK_H_(0x1D, 0x7A)
#define REG_SC_BK1D_7B_L      _PK_L_(0x1D, 0x7B)
#define REG_SC_BK1D_7B_H      _PK_H_(0x1D, 0x7B)
#define REG_SC_BK1D_7C_L      _PK_L_(0x1D, 0x7C)
#define REG_SC_BK1D_7C_H      _PK_H_(0x1D, 0x7C)
#define REG_SC_BK1D_7D_L      _PK_L_(0x1D, 0x7D)
#define REG_SC_BK1D_7D_H      _PK_H_(0x1D, 0x7D)
#define REG_SC_BK1D_7E_L      _PK_L_(0x1D, 0x7E)
#define REG_SC_BK1D_7E_H      _PK_H_(0x1D, 0x7E)
#define REG_SC_BK1D_7F_L      _PK_L_(0x1D, 0x7F)
#define REG_SC_BK1D_7F_H      _PK_H_(0x1D, 0x7F)
//----------------------------------------------
#define REG_SC_BK1E_00_L      _PK_L_(0x1E, 0x00)
#define REG_SC_BK1E_00_H      _PK_H_(0x1E, 0x00)
#define REG_SC_BK1E_01_L      _PK_L_(0x1E, 0x01)
#define REG_SC_BK1E_01_H      _PK_H_(0x1E, 0x01)
#define REG_SC_BK1E_02_L      _PK_L_(0x1E, 0x02)
#define REG_SC_BK1E_02_H      _PK_H_(0x1E, 0x02)
#define REG_SC_BK1E_03_L      _PK_L_(0x1E, 0x03)
#define REG_SC_BK1E_03_H      _PK_H_(0x1E, 0x03)
#define REG_SC_BK1E_04_L      _PK_L_(0x1E, 0x04)
#define REG_SC_BK1E_04_H      _PK_H_(0x1E, 0x04)
#define REG_SC_BK1E_05_L      _PK_L_(0x1E, 0x05)
#define REG_SC_BK1E_05_H      _PK_H_(0x1E, 0x05)
#define REG_SC_BK1E_06_L      _PK_L_(0x1E, 0x06)
#define REG_SC_BK1E_06_H      _PK_H_(0x1E, 0x06)
#define REG_SC_BK1E_07_L      _PK_L_(0x1E, 0x07)
#define REG_SC_BK1E_07_H      _PK_H_(0x1E, 0x07)
#define REG_SC_BK1E_08_L      _PK_L_(0x1E, 0x08)
#define REG_SC_BK1E_08_H      _PK_H_(0x1E, 0x08)
#define REG_SC_BK1E_09_L      _PK_L_(0x1E, 0x09)
#define REG_SC_BK1E_09_H      _PK_H_(0x1E, 0x09)
#define REG_SC_BK1E_0A_L      _PK_L_(0x1E, 0x0A)
#define REG_SC_BK1E_0A_H      _PK_H_(0x1E, 0x0A)
#define REG_SC_BK1E_0B_L      _PK_L_(0x1E, 0x0B)
#define REG_SC_BK1E_0B_H      _PK_H_(0x1E, 0x0B)
#define REG_SC_BK1E_0C_L      _PK_L_(0x1E, 0x0C)
#define REG_SC_BK1E_0C_H      _PK_H_(0x1E, 0x0C)
#define REG_SC_BK1E_0D_L      _PK_L_(0x1E, 0x0D)
#define REG_SC_BK1E_0D_H      _PK_H_(0x1E, 0x0D)
#define REG_SC_BK1E_0E_L      _PK_L_(0x1E, 0x0E)
#define REG_SC_BK1E_0E_H      _PK_H_(0x1E, 0x0E)
#define REG_SC_BK1E_0F_L      _PK_L_(0x1E, 0x0F)
#define REG_SC_BK1E_0F_H      _PK_H_(0x1E, 0x0F)
#define REG_SC_BK1E_10_L      _PK_L_(0x1E, 0x10)
#define REG_SC_BK1E_10_H      _PK_H_(0x1E, 0x10)
#define REG_SC_BK1E_11_L      _PK_L_(0x1E, 0x11)
#define REG_SC_BK1E_11_H      _PK_H_(0x1E, 0x11)
#define REG_SC_BK1E_12_L      _PK_L_(0x1E, 0x12)
#define REG_SC_BK1E_12_H      _PK_H_(0x1E, 0x12)
#define REG_SC_BK1E_13_L      _PK_L_(0x1E, 0x13)
#define REG_SC_BK1E_13_H      _PK_H_(0x1E, 0x13)
#define REG_SC_BK1E_14_L      _PK_L_(0x1E, 0x14)
#define REG_SC_BK1E_14_H      _PK_H_(0x1E, 0x14)
#define REG_SC_BK1E_15_L      _PK_L_(0x1E, 0x15)
#define REG_SC_BK1E_15_H      _PK_H_(0x1E, 0x15)
#define REG_SC_BK1E_16_L      _PK_L_(0x1E, 0x16)
#define REG_SC_BK1E_16_H      _PK_H_(0x1E, 0x16)
#define REG_SC_BK1E_17_L      _PK_L_(0x1E, 0x17)
#define REG_SC_BK1E_17_H      _PK_H_(0x1E, 0x17)
#define REG_SC_BK1E_18_L      _PK_L_(0x1E, 0x18)
#define REG_SC_BK1E_18_H      _PK_H_(0x1E, 0x18)
#define REG_SC_BK1E_19_L      _PK_L_(0x1E, 0x19)
#define REG_SC_BK1E_19_H      _PK_H_(0x1E, 0x19)
#define REG_SC_BK1E_1A_L      _PK_L_(0x1E, 0x1A)
#define REG_SC_BK1E_1A_H      _PK_H_(0x1E, 0x1A)
#define REG_SC_BK1E_1B_L      _PK_L_(0x1E, 0x1B)
#define REG_SC_BK1E_1B_H      _PK_H_(0x1E, 0x1B)
#define REG_SC_BK1E_1C_L      _PK_L_(0x1E, 0x1C)
#define REG_SC_BK1E_1C_H      _PK_H_(0x1E, 0x1C)
#define REG_SC_BK1E_1D_L      _PK_L_(0x1E, 0x1D)
#define REG_SC_BK1E_1D_H      _PK_H_(0x1E, 0x1D)
#define REG_SC_BK1E_1E_L      _PK_L_(0x1E, 0x1E)
#define REG_SC_BK1E_1E_H      _PK_H_(0x1E, 0x1E)
#define REG_SC_BK1E_1F_L      _PK_L_(0x1E, 0x1F)
#define REG_SC_BK1E_1F_H      _PK_H_(0x1E, 0x1F)
#define REG_SC_BK1E_20_L      _PK_L_(0x1E, 0x20)
#define REG_SC_BK1E_20_H      _PK_H_(0x1E, 0x20)
#define REG_SC_BK1E_21_L      _PK_L_(0x1E, 0x21)
#define REG_SC_BK1E_21_H      _PK_H_(0x1E, 0x21)
#define REG_SC_BK1E_22_L      _PK_L_(0x1E, 0x22)
#define REG_SC_BK1E_22_H      _PK_H_(0x1E, 0x22)
#define REG_SC_BK1E_23_L      _PK_L_(0x1E, 0x23)
#define REG_SC_BK1E_23_H      _PK_H_(0x1E, 0x23)
#define REG_SC_BK1E_24_L      _PK_L_(0x1E, 0x24)
#define REG_SC_BK1E_24_H      _PK_H_(0x1E, 0x24)
#define REG_SC_BK1E_25_L      _PK_L_(0x1E, 0x25)
#define REG_SC_BK1E_25_H      _PK_H_(0x1E, 0x25)
#define REG_SC_BK1E_26_L      _PK_L_(0x1E, 0x26)
#define REG_SC_BK1E_26_H      _PK_H_(0x1E, 0x26)
#define REG_SC_BK1E_27_L      _PK_L_(0x1E, 0x27)
#define REG_SC_BK1E_27_H      _PK_H_(0x1E, 0x27)
#define REG_SC_BK1E_28_L      _PK_L_(0x1E, 0x28)
#define REG_SC_BK1E_28_H      _PK_H_(0x1E, 0x28)
#define REG_SC_BK1E_29_L      _PK_L_(0x1E, 0x29)
#define REG_SC_BK1E_29_H      _PK_H_(0x1E, 0x29)
#define REG_SC_BK1E_2A_L      _PK_L_(0x1E, 0x2A)
#define REG_SC_BK1E_2A_H      _PK_H_(0x1E, 0x2A)
#define REG_SC_BK1E_2B_L      _PK_L_(0x1E, 0x2B)
#define REG_SC_BK1E_2B_H      _PK_H_(0x1E, 0x2B)
#define REG_SC_BK1E_2C_L      _PK_L_(0x1E, 0x2C)
#define REG_SC_BK1E_2C_H      _PK_H_(0x1E, 0x2C)
#define REG_SC_BK1E_2D_L      _PK_L_(0x1E, 0x2D)
#define REG_SC_BK1E_2D_H      _PK_H_(0x1E, 0x2D)
#define REG_SC_BK1E_2E_L      _PK_L_(0x1E, 0x2E)
#define REG_SC_BK1E_2E_H      _PK_H_(0x1E, 0x2E)
#define REG_SC_BK1E_2F_L      _PK_L_(0x1E, 0x2F)
#define REG_SC_BK1E_2F_H      _PK_H_(0x1E, 0x2F)
#define REG_SC_BK1E_30_L      _PK_L_(0x1E, 0x30)
#define REG_SC_BK1E_30_H      _PK_H_(0x1E, 0x30)
#define REG_SC_BK1E_31_L      _PK_L_(0x1E, 0x31)
#define REG_SC_BK1E_31_H      _PK_H_(0x1E, 0x31)
#define REG_SC_BK1E_32_L      _PK_L_(0x1E, 0x32)
#define REG_SC_BK1E_32_H      _PK_H_(0x1E, 0x32)
#define REG_SC_BK1E_33_L      _PK_L_(0x1E, 0x33)
#define REG_SC_BK1E_33_H      _PK_H_(0x1E, 0x33)
#define REG_SC_BK1E_34_L      _PK_L_(0x1E, 0x34)
#define REG_SC_BK1E_34_H      _PK_H_(0x1E, 0x34)
#define REG_SC_BK1E_35_L      _PK_L_(0x1E, 0x35)
#define REG_SC_BK1E_35_H      _PK_H_(0x1E, 0x35)
#define REG_SC_BK1E_36_L      _PK_L_(0x1E, 0x36)
#define REG_SC_BK1E_36_H      _PK_H_(0x1E, 0x36)
#define REG_SC_BK1E_37_L      _PK_L_(0x1E, 0x37)
#define REG_SC_BK1E_37_H      _PK_H_(0x1E, 0x37)
#define REG_SC_BK1E_38_L      _PK_L_(0x1E, 0x38)
#define REG_SC_BK1E_38_H      _PK_H_(0x1E, 0x38)
#define REG_SC_BK1E_39_L      _PK_L_(0x1E, 0x39)
#define REG_SC_BK1E_39_H      _PK_H_(0x1E, 0x39)
#define REG_SC_BK1E_3A_L      _PK_L_(0x1E, 0x3A)
#define REG_SC_BK1E_3A_H      _PK_H_(0x1E, 0x3A)
#define REG_SC_BK1E_3B_L      _PK_L_(0x1E, 0x3B)
#define REG_SC_BK1E_3B_H      _PK_H_(0x1E, 0x3B)
#define REG_SC_BK1E_3C_L      _PK_L_(0x1E, 0x3C)
#define REG_SC_BK1E_3C_H      _PK_H_(0x1E, 0x3C)
#define REG_SC_BK1E_3D_L      _PK_L_(0x1E, 0x3D)
#define REG_SC_BK1E_3D_H      _PK_H_(0x1E, 0x3D)
#define REG_SC_BK1E_3E_L      _PK_L_(0x1E, 0x3E)
#define REG_SC_BK1E_3E_H      _PK_H_(0x1E, 0x3E)
#define REG_SC_BK1E_3F_L      _PK_L_(0x1E, 0x3F)
#define REG_SC_BK1E_3F_H      _PK_H_(0x1E, 0x3F)
#define REG_SC_BK1E_40_L      _PK_L_(0x1E, 0x40)
#define REG_SC_BK1E_40_H      _PK_H_(0x1E, 0x40)
#define REG_SC_BK1E_41_L      _PK_L_(0x1E, 0x41)
#define REG_SC_BK1E_41_H      _PK_H_(0x1E, 0x41)
#define REG_SC_BK1E_42_L      _PK_L_(0x1E, 0x42)
#define REG_SC_BK1E_42_H      _PK_H_(0x1E, 0x42)
#define REG_SC_BK1E_43_L      _PK_L_(0x1E, 0x43)
#define REG_SC_BK1E_43_H      _PK_H_(0x1E, 0x43)
#define REG_SC_BK1E_44_L      _PK_L_(0x1E, 0x44)
#define REG_SC_BK1E_44_H      _PK_H_(0x1E, 0x44)
#define REG_SC_BK1E_45_L      _PK_L_(0x1E, 0x45)
#define REG_SC_BK1E_45_H      _PK_H_(0x1E, 0x45)
#define REG_SC_BK1E_46_L      _PK_L_(0x1E, 0x46)
#define REG_SC_BK1E_46_H      _PK_H_(0x1E, 0x46)
#define REG_SC_BK1E_47_L      _PK_L_(0x1E, 0x47)
#define REG_SC_BK1E_47_H      _PK_H_(0x1E, 0x47)
#define REG_SC_BK1E_48_L      _PK_L_(0x1E, 0x48)
#define REG_SC_BK1E_48_H      _PK_H_(0x1E, 0x48)
#define REG_SC_BK1E_49_L      _PK_L_(0x1E, 0x49)
#define REG_SC_BK1E_49_H      _PK_H_(0x1E, 0x49)
#define REG_SC_BK1E_4A_L      _PK_L_(0x1E, 0x4A)
#define REG_SC_BK1E_4A_H      _PK_H_(0x1E, 0x4A)
#define REG_SC_BK1E_4B_L      _PK_L_(0x1E, 0x4B)
#define REG_SC_BK1E_4B_H      _PK_H_(0x1E, 0x4B)
#define REG_SC_BK1E_4C_L      _PK_L_(0x1E, 0x4C)
#define REG_SC_BK1E_4C_H      _PK_H_(0x1E, 0x4C)
#define REG_SC_BK1E_4D_L      _PK_L_(0x1E, 0x4D)
#define REG_SC_BK1E_4D_H      _PK_H_(0x1E, 0x4D)
#define REG_SC_BK1E_4E_L      _PK_L_(0x1E, 0x4E)
#define REG_SC_BK1E_4E_H      _PK_H_(0x1E, 0x4E)
#define REG_SC_BK1E_4F_L      _PK_L_(0x1E, 0x4F)
#define REG_SC_BK1E_4F_H      _PK_H_(0x1E, 0x4F)
#define REG_SC_BK1E_50_L      _PK_L_(0x1E, 0x50)
#define REG_SC_BK1E_50_H      _PK_H_(0x1E, 0x50)
#define REG_SC_BK1E_51_L      _PK_L_(0x1E, 0x51)
#define REG_SC_BK1E_51_H      _PK_H_(0x1E, 0x51)
#define REG_SC_BK1E_52_L      _PK_L_(0x1E, 0x52)
#define REG_SC_BK1E_52_H      _PK_H_(0x1E, 0x52)
#define REG_SC_BK1E_53_L      _PK_L_(0x1E, 0x53)
#define REG_SC_BK1E_53_H      _PK_H_(0x1E, 0x53)
#define REG_SC_BK1E_54_L      _PK_L_(0x1E, 0x54)
#define REG_SC_BK1E_54_H      _PK_H_(0x1E, 0x54)
#define REG_SC_BK1E_55_L      _PK_L_(0x1E, 0x55)
#define REG_SC_BK1E_55_H      _PK_H_(0x1E, 0x55)
#define REG_SC_BK1E_56_L      _PK_L_(0x1E, 0x56)
#define REG_SC_BK1E_56_H      _PK_H_(0x1E, 0x56)
#define REG_SC_BK1E_57_L      _PK_L_(0x1E, 0x57)
#define REG_SC_BK1E_57_H      _PK_H_(0x1E, 0x57)
#define REG_SC_BK1E_58_L      _PK_L_(0x1E, 0x58)
#define REG_SC_BK1E_58_H      _PK_H_(0x1E, 0x58)
#define REG_SC_BK1E_59_L      _PK_L_(0x1E, 0x59)
#define REG_SC_BK1E_59_H      _PK_H_(0x1E, 0x59)
#define REG_SC_BK1E_5A_L      _PK_L_(0x1E, 0x5A)
#define REG_SC_BK1E_5A_H      _PK_H_(0x1E, 0x5A)
#define REG_SC_BK1E_5B_L      _PK_L_(0x1E, 0x5B)
#define REG_SC_BK1E_5B_H      _PK_H_(0x1E, 0x5B)
#define REG_SC_BK1E_5C_L      _PK_L_(0x1E, 0x5C)
#define REG_SC_BK1E_5C_H      _PK_H_(0x1E, 0x5C)
#define REG_SC_BK1E_5D_L      _PK_L_(0x1E, 0x5D)
#define REG_SC_BK1E_5D_H      _PK_H_(0x1E, 0x5D)
#define REG_SC_BK1E_5E_L      _PK_L_(0x1E, 0x5E)
#define REG_SC_BK1E_5E_H      _PK_H_(0x1E, 0x5E)
#define REG_SC_BK1E_5F_L      _PK_L_(0x1E, 0x5F)
#define REG_SC_BK1E_5F_H      _PK_H_(0x1E, 0x5F)
#define REG_SC_BK1E_60_L      _PK_L_(0x1E, 0x60)
#define REG_SC_BK1E_60_H      _PK_H_(0x1E, 0x60)
#define REG_SC_BK1E_61_L      _PK_L_(0x1E, 0x61)
#define REG_SC_BK1E_61_H      _PK_H_(0x1E, 0x61)
#define REG_SC_BK1E_62_L      _PK_L_(0x1E, 0x62)
#define REG_SC_BK1E_62_H      _PK_H_(0x1E, 0x62)
#define REG_SC_BK1E_63_L      _PK_L_(0x1E, 0x63)
#define REG_SC_BK1E_63_H      _PK_H_(0x1E, 0x63)
#define REG_SC_BK1E_64_L      _PK_L_(0x1E, 0x64)
#define REG_SC_BK1E_64_H      _PK_H_(0x1E, 0x64)
#define REG_SC_BK1E_65_L      _PK_L_(0x1E, 0x65)
#define REG_SC_BK1E_65_H      _PK_H_(0x1E, 0x65)
#define REG_SC_BK1E_66_L      _PK_L_(0x1E, 0x66)
#define REG_SC_BK1E_66_H      _PK_H_(0x1E, 0x66)
#define REG_SC_BK1E_67_L      _PK_L_(0x1E, 0x67)
#define REG_SC_BK1E_67_H      _PK_H_(0x1E, 0x67)
#define REG_SC_BK1E_68_L      _PK_L_(0x1E, 0x68)
#define REG_SC_BK1E_68_H      _PK_H_(0x1E, 0x68)
#define REG_SC_BK1E_69_L      _PK_L_(0x1E, 0x69)
#define REG_SC_BK1E_69_H      _PK_H_(0x1E, 0x69)
#define REG_SC_BK1E_6A_L      _PK_L_(0x1E, 0x6A)
#define REG_SC_BK1E_6A_H      _PK_H_(0x1E, 0x6A)
#define REG_SC_BK1E_6B_L      _PK_L_(0x1E, 0x6B)
#define REG_SC_BK1E_6B_H      _PK_H_(0x1E, 0x6B)
#define REG_SC_BK1E_6C_L      _PK_L_(0x1E, 0x6C)
#define REG_SC_BK1E_6C_H      _PK_H_(0x1E, 0x6C)
#define REG_SC_BK1E_6D_L      _PK_L_(0x1E, 0x6D)
#define REG_SC_BK1E_6D_H      _PK_H_(0x1E, 0x6D)
#define REG_SC_BK1E_6E_L      _PK_L_(0x1E, 0x6E)
#define REG_SC_BK1E_6E_H      _PK_H_(0x1E, 0x6E)
#define REG_SC_BK1E_6F_L      _PK_L_(0x1E, 0x6F)
#define REG_SC_BK1E_6F_H      _PK_H_(0x1E, 0x6F)
#define REG_SC_BK1E_70_L      _PK_L_(0x1E, 0x70)
#define REG_SC_BK1E_70_H      _PK_H_(0x1E, 0x70)
#define REG_SC_BK1E_71_L      _PK_L_(0x1E, 0x71)
#define REG_SC_BK1E_71_H      _PK_H_(0x1E, 0x71)
#define REG_SC_BK1E_72_L      _PK_L_(0x1E, 0x72)
#define REG_SC_BK1E_72_H      _PK_H_(0x1E, 0x72)
#define REG_SC_BK1E_73_L      _PK_L_(0x1E, 0x73)
#define REG_SC_BK1E_73_H      _PK_H_(0x1E, 0x73)
#define REG_SC_BK1E_74_L      _PK_L_(0x1E, 0x74)
#define REG_SC_BK1E_74_H      _PK_H_(0x1E, 0x74)
#define REG_SC_BK1E_75_L      _PK_L_(0x1E, 0x75)
#define REG_SC_BK1E_75_H      _PK_H_(0x1E, 0x75)
#define REG_SC_BK1E_76_L      _PK_L_(0x1E, 0x76)
#define REG_SC_BK1E_76_H      _PK_H_(0x1E, 0x76)
#define REG_SC_BK1E_77_L      _PK_L_(0x1E, 0x77)
#define REG_SC_BK1E_77_H      _PK_H_(0x1E, 0x77)
#define REG_SC_BK1E_78_L      _PK_L_(0x1E, 0x78)
#define REG_SC_BK1E_78_H      _PK_H_(0x1E, 0x78)
#define REG_SC_BK1E_79_L      _PK_L_(0x1E, 0x79)
#define REG_SC_BK1E_79_H      _PK_H_(0x1E, 0x79)
#define REG_SC_BK1E_7A_L      _PK_L_(0x1E, 0x7A)
#define REG_SC_BK1E_7A_H      _PK_H_(0x1E, 0x7A)
#define REG_SC_BK1E_7B_L      _PK_L_(0x1E, 0x7B)
#define REG_SC_BK1E_7B_H      _PK_H_(0x1E, 0x7B)
#define REG_SC_BK1E_7C_L      _PK_L_(0x1E, 0x7C)
#define REG_SC_BK1E_7C_H      _PK_H_(0x1E, 0x7C)
#define REG_SC_BK1E_7D_L      _PK_L_(0x1E, 0x7D)
#define REG_SC_BK1E_7D_H      _PK_H_(0x1E, 0x7D)
#define REG_SC_BK1E_7E_L      _PK_L_(0x1E, 0x7E)
#define REG_SC_BK1E_7E_H      _PK_H_(0x1E, 0x7E)
#define REG_SC_BK1E_7F_L      _PK_L_(0x1E, 0x7F)
#define REG_SC_BK1E_7F_H      _PK_H_(0x1E, 0x7F)
//----------------------------------------------
#define REG_SC_BK1F_00_L      _PK_L_(0x1F, 0x00)
#define REG_SC_BK1F_00_H      _PK_H_(0x1F, 0x00)
#define REG_SC_BK1F_01_L      _PK_L_(0x1F, 0x01)
#define REG_SC_BK1F_01_H      _PK_H_(0x1F, 0x01)
#define REG_SC_BK1F_02_L      _PK_L_(0x1F, 0x02)
#define REG_SC_BK1F_02_H      _PK_H_(0x1F, 0x02)
#define REG_SC_BK1F_03_L      _PK_L_(0x1F, 0x03)
#define REG_SC_BK1F_03_H      _PK_H_(0x1F, 0x03)
#define REG_SC_BK1F_04_L      _PK_L_(0x1F, 0x04)
#define REG_SC_BK1F_04_H      _PK_H_(0x1F, 0x04)
#define REG_SC_BK1F_05_L      _PK_L_(0x1F, 0x05)
#define REG_SC_BK1F_05_H      _PK_H_(0x1F, 0x05)
#define REG_SC_BK1F_06_L      _PK_L_(0x1F, 0x06)
#define REG_SC_BK1F_06_H      _PK_H_(0x1F, 0x06)
#define REG_SC_BK1F_07_L      _PK_L_(0x1F, 0x07)
#define REG_SC_BK1F_07_H      _PK_H_(0x1F, 0x07)
#define REG_SC_BK1F_08_L      _PK_L_(0x1F, 0x08)
#define REG_SC_BK1F_08_H      _PK_H_(0x1F, 0x08)
#define REG_SC_BK1F_09_L      _PK_L_(0x1F, 0x09)
#define REG_SC_BK1F_09_H      _PK_H_(0x1F, 0x09)
#define REG_SC_BK1F_0A_L      _PK_L_(0x1F, 0x0A)
#define REG_SC_BK1F_0A_H      _PK_H_(0x1F, 0x0A)
#define REG_SC_BK1F_0B_L      _PK_L_(0x1F, 0x0B)
#define REG_SC_BK1F_0B_H      _PK_H_(0x1F, 0x0B)
#define REG_SC_BK1F_0C_L      _PK_L_(0x1F, 0x0C)
#define REG_SC_BK1F_0C_H      _PK_H_(0x1F, 0x0C)
#define REG_SC_BK1F_0D_L      _PK_L_(0x1F, 0x0D)
#define REG_SC_BK1F_0D_H      _PK_H_(0x1F, 0x0D)
#define REG_SC_BK1F_0E_L      _PK_L_(0x1F, 0x0E)
#define REG_SC_BK1F_0E_H      _PK_H_(0x1F, 0x0E)
#define REG_SC_BK1F_0F_L      _PK_L_(0x1F, 0x0F)
#define REG_SC_BK1F_0F_H      _PK_H_(0x1F, 0x0F)
#define REG_SC_BK1F_10_L      _PK_L_(0x1F, 0x10)
#define REG_SC_BK1F_10_H      _PK_H_(0x1F, 0x10)
#define REG_SC_BK1F_11_L      _PK_L_(0x1F, 0x11)
#define REG_SC_BK1F_11_H      _PK_H_(0x1F, 0x11)
#define REG_SC_BK1F_12_L      _PK_L_(0x1F, 0x12)
#define REG_SC_BK1F_12_H      _PK_H_(0x1F, 0x12)
#define REG_SC_BK1F_13_L      _PK_L_(0x1F, 0x13)
#define REG_SC_BK1F_13_H      _PK_H_(0x1F, 0x13)
#define REG_SC_BK1F_14_L      _PK_L_(0x1F, 0x14)
#define REG_SC_BK1F_14_H      _PK_H_(0x1F, 0x14)
#define REG_SC_BK1F_15_L      _PK_L_(0x1F, 0x15)
#define REG_SC_BK1F_15_H      _PK_H_(0x1F, 0x15)
#define REG_SC_BK1F_16_L      _PK_L_(0x1F, 0x16)
#define REG_SC_BK1F_16_H      _PK_H_(0x1F, 0x16)
#define REG_SC_BK1F_17_L      _PK_L_(0x1F, 0x17)
#define REG_SC_BK1F_17_H      _PK_H_(0x1F, 0x17)
#define REG_SC_BK1F_18_L      _PK_L_(0x1F, 0x18)
#define REG_SC_BK1F_18_H      _PK_H_(0x1F, 0x18)
#define REG_SC_BK1F_19_L      _PK_L_(0x1F, 0x19)
#define REG_SC_BK1F_19_H      _PK_H_(0x1F, 0x19)
#define REG_SC_BK1F_1A_L      _PK_L_(0x1F, 0x1A)
#define REG_SC_BK1F_1A_H      _PK_H_(0x1F, 0x1A)
#define REG_SC_BK1F_1B_L      _PK_L_(0x1F, 0x1B)
#define REG_SC_BK1F_1B_H      _PK_H_(0x1F, 0x1B)
#define REG_SC_BK1F_1C_L      _PK_L_(0x1F, 0x1C)
#define REG_SC_BK1F_1C_H      _PK_H_(0x1F, 0x1C)
#define REG_SC_BK1F_1D_L      _PK_L_(0x1F, 0x1D)
#define REG_SC_BK1F_1D_H      _PK_H_(0x1F, 0x1D)
#define REG_SC_BK1F_1E_L      _PK_L_(0x1F, 0x1E)
#define REG_SC_BK1F_1E_H      _PK_H_(0x1F, 0x1E)
#define REG_SC_BK1F_1F_L      _PK_L_(0x1F, 0x1F)
#define REG_SC_BK1F_1F_H      _PK_H_(0x1F, 0x1F)
#define REG_SC_BK1F_20_L      _PK_L_(0x1F, 0x20)
#define REG_SC_BK1F_20_H      _PK_H_(0x1F, 0x20)
#define REG_SC_BK1F_21_L      _PK_L_(0x1F, 0x21)
#define REG_SC_BK1F_21_H      _PK_H_(0x1F, 0x21)
#define REG_SC_BK1F_22_L      _PK_L_(0x1F, 0x22)
#define REG_SC_BK1F_22_H      _PK_H_(0x1F, 0x22)
#define REG_SC_BK1F_23_L      _PK_L_(0x1F, 0x23)
#define REG_SC_BK1F_23_H      _PK_H_(0x1F, 0x23)
#define REG_SC_BK1F_24_L      _PK_L_(0x1F, 0x24)
#define REG_SC_BK1F_24_H      _PK_H_(0x1F, 0x24)
#define REG_SC_BK1F_25_L      _PK_L_(0x1F, 0x25)
#define REG_SC_BK1F_25_H      _PK_H_(0x1F, 0x25)
#define REG_SC_BK1F_26_L      _PK_L_(0x1F, 0x26)
#define REG_SC_BK1F_26_H      _PK_H_(0x1F, 0x26)
#define REG_SC_BK1F_27_L      _PK_L_(0x1F, 0x27)
#define REG_SC_BK1F_27_H      _PK_H_(0x1F, 0x27)
#define REG_SC_BK1F_28_L      _PK_L_(0x1F, 0x28)
#define REG_SC_BK1F_28_H      _PK_H_(0x1F, 0x28)
#define REG_SC_BK1F_29_L      _PK_L_(0x1F, 0x29)
#define REG_SC_BK1F_29_H      _PK_H_(0x1F, 0x29)
#define REG_SC_BK1F_2A_L      _PK_L_(0x1F, 0x2A)
#define REG_SC_BK1F_2A_H      _PK_H_(0x1F, 0x2A)
#define REG_SC_BK1F_2B_L      _PK_L_(0x1F, 0x2B)
#define REG_SC_BK1F_2B_H      _PK_H_(0x1F, 0x2B)
#define REG_SC_BK1F_2C_L      _PK_L_(0x1F, 0x2C)
#define REG_SC_BK1F_2C_H      _PK_H_(0x1F, 0x2C)
#define REG_SC_BK1F_2D_L      _PK_L_(0x1F, 0x2D)
#define REG_SC_BK1F_2D_H      _PK_H_(0x1F, 0x2D)
#define REG_SC_BK1F_2E_L      _PK_L_(0x1F, 0x2E)
#define REG_SC_BK1F_2E_H      _PK_H_(0x1F, 0x2E)
#define REG_SC_BK1F_2F_L      _PK_L_(0x1F, 0x2F)
#define REG_SC_BK1F_2F_H      _PK_H_(0x1F, 0x2F)
#define REG_SC_BK1F_30_L      _PK_L_(0x1F, 0x30)
#define REG_SC_BK1F_30_H      _PK_H_(0x1F, 0x30)
#define REG_SC_BK1F_31_L      _PK_L_(0x1F, 0x31)
#define REG_SC_BK1F_31_H      _PK_H_(0x1F, 0x31)
#define REG_SC_BK1F_32_L      _PK_L_(0x1F, 0x32)
#define REG_SC_BK1F_32_H      _PK_H_(0x1F, 0x32)
#define REG_SC_BK1F_33_L      _PK_L_(0x1F, 0x33)
#define REG_SC_BK1F_33_H      _PK_H_(0x1F, 0x33)
#define REG_SC_BK1F_34_L      _PK_L_(0x1F, 0x34)
#define REG_SC_BK1F_34_H      _PK_H_(0x1F, 0x34)
#define REG_SC_BK1F_35_L      _PK_L_(0x1F, 0x35)
#define REG_SC_BK1F_35_H      _PK_H_(0x1F, 0x35)
#define REG_SC_BK1F_36_L      _PK_L_(0x1F, 0x36)
#define REG_SC_BK1F_36_H      _PK_H_(0x1F, 0x36)
#define REG_SC_BK1F_37_L      _PK_L_(0x1F, 0x37)
#define REG_SC_BK1F_37_H      _PK_H_(0x1F, 0x37)
#define REG_SC_BK1F_38_L      _PK_L_(0x1F, 0x38)
#define REG_SC_BK1F_38_H      _PK_H_(0x1F, 0x38)
#define REG_SC_BK1F_39_L      _PK_L_(0x1F, 0x39)
#define REG_SC_BK1F_39_H      _PK_H_(0x1F, 0x39)
#define REG_SC_BK1F_3A_L      _PK_L_(0x1F, 0x3A)
#define REG_SC_BK1F_3A_H      _PK_H_(0x1F, 0x3A)
#define REG_SC_BK1F_3B_L      _PK_L_(0x1F, 0x3B)
#define REG_SC_BK1F_3B_H      _PK_H_(0x1F, 0x3B)
#define REG_SC_BK1F_3C_L      _PK_L_(0x1F, 0x3C)
#define REG_SC_BK1F_3C_H      _PK_H_(0x1F, 0x3C)
#define REG_SC_BK1F_3D_L      _PK_L_(0x1F, 0x3D)
#define REG_SC_BK1F_3D_H      _PK_H_(0x1F, 0x3D)
#define REG_SC_BK1F_3E_L      _PK_L_(0x1F, 0x3E)
#define REG_SC_BK1F_3E_H      _PK_H_(0x1F, 0x3E)
#define REG_SC_BK1F_3F_L      _PK_L_(0x1F, 0x3F)
#define REG_SC_BK1F_3F_H      _PK_H_(0x1F, 0x3F)
#define REG_SC_BK1F_40_L      _PK_L_(0x1F, 0x40)
#define REG_SC_BK1F_40_H      _PK_H_(0x1F, 0x40)
#define REG_SC_BK1F_41_L      _PK_L_(0x1F, 0x41)
#define REG_SC_BK1F_41_H      _PK_H_(0x1F, 0x41)
#define REG_SC_BK1F_42_L      _PK_L_(0x1F, 0x42)
#define REG_SC_BK1F_42_H      _PK_H_(0x1F, 0x42)
#define REG_SC_BK1F_43_L      _PK_L_(0x1F, 0x43)
#define REG_SC_BK1F_43_H      _PK_H_(0x1F, 0x43)
#define REG_SC_BK1F_44_L      _PK_L_(0x1F, 0x44)
#define REG_SC_BK1F_44_H      _PK_H_(0x1F, 0x44)
#define REG_SC_BK1F_45_L      _PK_L_(0x1F, 0x45)
#define REG_SC_BK1F_45_H      _PK_H_(0x1F, 0x45)
#define REG_SC_BK1F_46_L      _PK_L_(0x1F, 0x46)
#define REG_SC_BK1F_46_H      _PK_H_(0x1F, 0x46)
#define REG_SC_BK1F_47_L      _PK_L_(0x1F, 0x47)
#define REG_SC_BK1F_47_H      _PK_H_(0x1F, 0x47)
#define REG_SC_BK1F_48_L      _PK_L_(0x1F, 0x48)
#define REG_SC_BK1F_48_H      _PK_H_(0x1F, 0x48)
#define REG_SC_BK1F_49_L      _PK_L_(0x1F, 0x49)
#define REG_SC_BK1F_49_H      _PK_H_(0x1F, 0x49)
#define REG_SC_BK1F_4A_L      _PK_L_(0x1F, 0x4A)
#define REG_SC_BK1F_4A_H      _PK_H_(0x1F, 0x4A)
#define REG_SC_BK1F_4B_L      _PK_L_(0x1F, 0x4B)
#define REG_SC_BK1F_4B_H      _PK_H_(0x1F, 0x4B)
#define REG_SC_BK1F_4C_L      _PK_L_(0x1F, 0x4C)
#define REG_SC_BK1F_4C_H      _PK_H_(0x1F, 0x4C)
#define REG_SC_BK1F_4D_L      _PK_L_(0x1F, 0x4D)
#define REG_SC_BK1F_4D_H      _PK_H_(0x1F, 0x4D)
#define REG_SC_BK1F_4E_L      _PK_L_(0x1F, 0x4E)
#define REG_SC_BK1F_4E_H      _PK_H_(0x1F, 0x4E)
#define REG_SC_BK1F_4F_L      _PK_L_(0x1F, 0x4F)
#define REG_SC_BK1F_4F_H      _PK_H_(0x1F, 0x4F)
#define REG_SC_BK1F_50_L      _PK_L_(0x1F, 0x50)
#define REG_SC_BK1F_50_H      _PK_H_(0x1F, 0x50)
#define REG_SC_BK1F_51_L      _PK_L_(0x1F, 0x51)
#define REG_SC_BK1F_51_H      _PK_H_(0x1F, 0x51)
#define REG_SC_BK1F_52_L      _PK_L_(0x1F, 0x52)
#define REG_SC_BK1F_52_H      _PK_H_(0x1F, 0x52)
#define REG_SC_BK1F_53_L      _PK_L_(0x1F, 0x53)
#define REG_SC_BK1F_53_H      _PK_H_(0x1F, 0x53)
#define REG_SC_BK1F_54_L      _PK_L_(0x1F, 0x54)
#define REG_SC_BK1F_54_H      _PK_H_(0x1F, 0x54)
#define REG_SC_BK1F_55_L      _PK_L_(0x1F, 0x55)
#define REG_SC_BK1F_55_H      _PK_H_(0x1F, 0x55)
#define REG_SC_BK1F_56_L      _PK_L_(0x1F, 0x56)
#define REG_SC_BK1F_56_H      _PK_H_(0x1F, 0x56)
#define REG_SC_BK1F_57_L      _PK_L_(0x1F, 0x57)
#define REG_SC_BK1F_57_H      _PK_H_(0x1F, 0x57)
#define REG_SC_BK1F_58_L      _PK_L_(0x1F, 0x58)
#define REG_SC_BK1F_58_H      _PK_H_(0x1F, 0x58)
#define REG_SC_BK1F_59_L      _PK_L_(0x1F, 0x59)
#define REG_SC_BK1F_59_H      _PK_H_(0x1F, 0x59)
#define REG_SC_BK1F_5A_L      _PK_L_(0x1F, 0x5A)
#define REG_SC_BK1F_5A_H      _PK_H_(0x1F, 0x5A)
#define REG_SC_BK1F_5B_L      _PK_L_(0x1F, 0x5B)
#define REG_SC_BK1F_5B_H      _PK_H_(0x1F, 0x5B)
#define REG_SC_BK1F_5C_L      _PK_L_(0x1F, 0x5C)
#define REG_SC_BK1F_5C_H      _PK_H_(0x1F, 0x5C)
#define REG_SC_BK1F_5D_L      _PK_L_(0x1F, 0x5D)
#define REG_SC_BK1F_5D_H      _PK_H_(0x1F, 0x5D)
#define REG_SC_BK1F_5E_L      _PK_L_(0x1F, 0x5E)
#define REG_SC_BK1F_5E_H      _PK_H_(0x1F, 0x5E)
#define REG_SC_BK1F_5F_L      _PK_L_(0x1F, 0x5F)
#define REG_SC_BK1F_5F_H      _PK_H_(0x1F, 0x5F)
#define REG_SC_BK1F_60_L      _PK_L_(0x1F, 0x60)
#define REG_SC_BK1F_60_H      _PK_H_(0x1F, 0x60)
#define REG_SC_BK1F_61_L      _PK_L_(0x1F, 0x61)
#define REG_SC_BK1F_61_H      _PK_H_(0x1F, 0x61)
#define REG_SC_BK1F_62_L      _PK_L_(0x1F, 0x62)
#define REG_SC_BK1F_62_H      _PK_H_(0x1F, 0x62)
#define REG_SC_BK1F_63_L      _PK_L_(0x1F, 0x63)
#define REG_SC_BK1F_63_H      _PK_H_(0x1F, 0x63)
#define REG_SC_BK1F_64_L      _PK_L_(0x1F, 0x64)
#define REG_SC_BK1F_64_H      _PK_H_(0x1F, 0x64)
#define REG_SC_BK1F_65_L      _PK_L_(0x1F, 0x65)
#define REG_SC_BK1F_65_H      _PK_H_(0x1F, 0x65)
#define REG_SC_BK1F_66_L      _PK_L_(0x1F, 0x66)
#define REG_SC_BK1F_66_H      _PK_H_(0x1F, 0x66)
#define REG_SC_BK1F_67_L      _PK_L_(0x1F, 0x67)
#define REG_SC_BK1F_67_H      _PK_H_(0x1F, 0x67)
#define REG_SC_BK1F_68_L      _PK_L_(0x1F, 0x68)
#define REG_SC_BK1F_68_H      _PK_H_(0x1F, 0x68)
#define REG_SC_BK1F_69_L      _PK_L_(0x1F, 0x69)
#define REG_SC_BK1F_69_H      _PK_H_(0x1F, 0x69)
#define REG_SC_BK1F_6A_L      _PK_L_(0x1F, 0x6A)
#define REG_SC_BK1F_6A_H      _PK_H_(0x1F, 0x6A)
#define REG_SC_BK1F_6B_L      _PK_L_(0x1F, 0x6B)
#define REG_SC_BK1F_6B_H      _PK_H_(0x1F, 0x6B)
#define REG_SC_BK1F_6C_L      _PK_L_(0x1F, 0x6C)
#define REG_SC_BK1F_6C_H      _PK_H_(0x1F, 0x6C)
#define REG_SC_BK1F_6D_L      _PK_L_(0x1F, 0x6D)
#define REG_SC_BK1F_6D_H      _PK_H_(0x1F, 0x6D)
#define REG_SC_BK1F_6E_L      _PK_L_(0x1F, 0x6E)
#define REG_SC_BK1F_6E_H      _PK_H_(0x1F, 0x6E)
#define REG_SC_BK1F_6F_L      _PK_L_(0x1F, 0x6F)
#define REG_SC_BK1F_6F_H      _PK_H_(0x1F, 0x6F)
#define REG_SC_BK1F_70_L      _PK_L_(0x1F, 0x70)
#define REG_SC_BK1F_70_H      _PK_H_(0x1F, 0x70)
#define REG_SC_BK1F_71_L      _PK_L_(0x1F, 0x71)
#define REG_SC_BK1F_71_H      _PK_H_(0x1F, 0x71)
#define REG_SC_BK1F_72_L      _PK_L_(0x1F, 0x72)
#define REG_SC_BK1F_72_H      _PK_H_(0x1F, 0x72)
#define REG_SC_BK1F_73_L      _PK_L_(0x1F, 0x73)
#define REG_SC_BK1F_73_H      _PK_H_(0x1F, 0x73)
#define REG_SC_BK1F_74_L      _PK_L_(0x1F, 0x74)
#define REG_SC_BK1F_74_H      _PK_H_(0x1F, 0x74)
#define REG_SC_BK1F_75_L      _PK_L_(0x1F, 0x75)
#define REG_SC_BK1F_75_H      _PK_H_(0x1F, 0x75)
#define REG_SC_BK1F_76_L      _PK_L_(0x1F, 0x76)
#define REG_SC_BK1F_76_H      _PK_H_(0x1F, 0x76)
#define REG_SC_BK1F_77_L      _PK_L_(0x1F, 0x77)
#define REG_SC_BK1F_77_H      _PK_H_(0x1F, 0x77)
#define REG_SC_BK1F_78_L      _PK_L_(0x1F, 0x78)
#define REG_SC_BK1F_78_H      _PK_H_(0x1F, 0x78)
#define REG_SC_BK1F_79_L      _PK_L_(0x1F, 0x79)
#define REG_SC_BK1F_79_H      _PK_H_(0x1F, 0x79)
#define REG_SC_BK1F_7A_L      _PK_L_(0x1F, 0x7A)
#define REG_SC_BK1F_7A_H      _PK_H_(0x1F, 0x7A)
#define REG_SC_BK1F_7B_L      _PK_L_(0x1F, 0x7B)
#define REG_SC_BK1F_7B_H      _PK_H_(0x1F, 0x7B)
#define REG_SC_BK1F_7C_L      _PK_L_(0x1F, 0x7C)
#define REG_SC_BK1F_7C_H      _PK_H_(0x1F, 0x7C)
#define REG_SC_BK1F_7D_L      _PK_L_(0x1F, 0x7D)
#define REG_SC_BK1F_7D_H      _PK_H_(0x1F, 0x7D)
#define REG_SC_BK1F_7E_L      _PK_L_(0x1F, 0x7E)
#define REG_SC_BK1F_7E_H      _PK_H_(0x1F, 0x7E)
#define REG_SC_BK1F_7F_L      _PK_L_(0x1F, 0x7F)
#define REG_SC_BK1F_7F_H      _PK_H_(0x1F, 0x7F)
//----------------------------------------------
#define REG_SC_BK20_00_L      _PK_L_(0x20, 0x00)
#define REG_SC_BK20_00_H      _PK_H_(0x20, 0x00)
#define REG_SC_BK20_01_L      _PK_L_(0x20, 0x01)
#define REG_SC_BK20_01_H      _PK_H_(0x20, 0x01)
#define REG_SC_BK20_02_L      _PK_L_(0x20, 0x02)
#define REG_SC_BK20_02_H      _PK_H_(0x20, 0x02)
#define REG_SC_BK20_03_L      _PK_L_(0x20, 0x03)
#define REG_SC_BK20_03_H      _PK_H_(0x20, 0x03)
#define REG_SC_BK20_04_L      _PK_L_(0x20, 0x04)
#define REG_SC_BK20_04_H      _PK_H_(0x20, 0x04)
#define REG_SC_BK20_05_L      _PK_L_(0x20, 0x05)
#define REG_SC_BK20_05_H      _PK_H_(0x20, 0x05)
#define REG_SC_BK20_06_L      _PK_L_(0x20, 0x06)
#define REG_SC_BK20_06_H      _PK_H_(0x20, 0x06)
#define REG_SC_BK20_07_L      _PK_L_(0x20, 0x07)
#define REG_SC_BK20_07_H      _PK_H_(0x20, 0x07)
#define REG_SC_BK20_08_L      _PK_L_(0x20, 0x08)
#define REG_SC_BK20_08_H      _PK_H_(0x20, 0x08)
#define REG_SC_BK20_09_L      _PK_L_(0x20, 0x09)
#define REG_SC_BK20_09_H      _PK_H_(0x20, 0x09)
#define REG_SC_BK20_0A_L      _PK_L_(0x20, 0x0A)
#define REG_SC_BK20_0A_H      _PK_H_(0x20, 0x0A)
#define REG_SC_BK20_0B_L      _PK_L_(0x20, 0x0B)
#define REG_SC_BK20_0B_H      _PK_H_(0x20, 0x0B)
#define REG_SC_BK20_0C_L      _PK_L_(0x20, 0x0C)
#define REG_SC_BK20_0C_H      _PK_H_(0x20, 0x0C)
#define REG_SC_BK20_0D_L      _PK_L_(0x20, 0x0D)
#define REG_SC_BK20_0D_H      _PK_H_(0x20, 0x0D)
#define REG_SC_BK20_0E_L      _PK_L_(0x20, 0x0E)
#define REG_SC_BK20_0E_H      _PK_H_(0x20, 0x0E)
#define REG_SC_BK20_0F_L      _PK_L_(0x20, 0x0F)
#define REG_SC_BK20_0F_H      _PK_H_(0x20, 0x0F)
#define REG_SC_BK20_10_L      _PK_L_(0x20, 0x10)
#define REG_SC_BK20_10_H      _PK_H_(0x20, 0x10)
#define REG_SC_BK20_11_L      _PK_L_(0x20, 0x11)
#define REG_SC_BK20_11_H      _PK_H_(0x20, 0x11)
#define REG_SC_BK20_12_L      _PK_L_(0x20, 0x12)
#define REG_SC_BK20_12_H      _PK_H_(0x20, 0x12)
#define REG_SC_BK20_13_L      _PK_L_(0x20, 0x13)
#define REG_SC_BK20_13_H      _PK_H_(0x20, 0x13)
#define REG_SC_BK20_14_L      _PK_L_(0x20, 0x14)
#define REG_SC_BK20_14_H      _PK_H_(0x20, 0x14)
#define REG_SC_BK20_15_L      _PK_L_(0x20, 0x15)
#define REG_SC_BK20_15_H      _PK_H_(0x20, 0x15)
#define REG_SC_BK20_16_L      _PK_L_(0x20, 0x16)
#define REG_SC_BK20_16_H      _PK_H_(0x20, 0x16)
#define REG_SC_BK20_17_L      _PK_L_(0x20, 0x17)
#define REG_SC_BK20_17_H      _PK_H_(0x20, 0x17)
#define REG_SC_BK20_18_L      _PK_L_(0x20, 0x18)
#define REG_SC_BK20_18_H      _PK_H_(0x20, 0x18)
#define REG_SC_BK20_19_L      _PK_L_(0x20, 0x19)
#define REG_SC_BK20_19_H      _PK_H_(0x20, 0x19)
#define REG_SC_BK20_1A_L      _PK_L_(0x20, 0x1A)
#define REG_SC_BK20_1A_H      _PK_H_(0x20, 0x1A)
#define REG_SC_BK20_1B_L      _PK_L_(0x20, 0x1B)
#define REG_SC_BK20_1B_H      _PK_H_(0x20, 0x1B)
#define REG_SC_BK20_1C_L      _PK_L_(0x20, 0x1C)
#define REG_SC_BK20_1C_H      _PK_H_(0x20, 0x1C)
#define REG_SC_BK20_1D_L      _PK_L_(0x20, 0x1D)
#define REG_SC_BK20_1D_H      _PK_H_(0x20, 0x1D)
#define REG_SC_BK20_1E_L      _PK_L_(0x20, 0x1E)
#define REG_SC_BK20_1E_H      _PK_H_(0x20, 0x1E)
#define REG_SC_BK20_1F_L      _PK_L_(0x20, 0x1F)
#define REG_SC_BK20_1F_H      _PK_H_(0x20, 0x1F)
#define REG_SC_BK20_20_L      _PK_L_(0x20, 0x20)
#define REG_SC_BK20_20_H      _PK_H_(0x20, 0x20)
#define REG_SC_BK20_21_L      _PK_L_(0x20, 0x21)
#define REG_SC_BK20_21_H      _PK_H_(0x20, 0x21)
#define REG_SC_BK20_22_L      _PK_L_(0x20, 0x22)
#define REG_SC_BK20_22_H      _PK_H_(0x20, 0x22)
#define REG_SC_BK20_23_L      _PK_L_(0x20, 0x23)
#define REG_SC_BK20_23_H      _PK_H_(0x20, 0x23)
#define REG_SC_BK20_24_L      _PK_L_(0x20, 0x24)
#define REG_SC_BK20_24_H      _PK_H_(0x20, 0x24)
#define REG_SC_BK20_25_L      _PK_L_(0x20, 0x25)
#define REG_SC_BK20_25_H      _PK_H_(0x20, 0x25)
#define REG_SC_BK20_26_L      _PK_L_(0x20, 0x26)
#define REG_SC_BK20_26_H      _PK_H_(0x20, 0x26)
#define REG_SC_BK20_27_L      _PK_L_(0x20, 0x27)
#define REG_SC_BK20_27_H      _PK_H_(0x20, 0x27)
#define REG_SC_BK20_28_L      _PK_L_(0x20, 0x28)
#define REG_SC_BK20_28_H      _PK_H_(0x20, 0x28)
#define REG_SC_BK20_29_L      _PK_L_(0x20, 0x29)
#define REG_SC_BK20_29_H      _PK_H_(0x20, 0x29)
#define REG_SC_BK20_2A_L      _PK_L_(0x20, 0x2A)
#define REG_SC_BK20_2A_H      _PK_H_(0x20, 0x2A)
#define REG_SC_BK20_2B_L      _PK_L_(0x20, 0x2B)
#define REG_SC_BK20_2B_H      _PK_H_(0x20, 0x2B)
#define REG_SC_BK20_2C_L      _PK_L_(0x20, 0x2C)
#define REG_SC_BK20_2C_H      _PK_H_(0x20, 0x2C)
#define REG_SC_BK20_2D_L      _PK_L_(0x20, 0x2D)
#define REG_SC_BK20_2D_H      _PK_H_(0x20, 0x2D)
#define REG_SC_BK20_2E_L      _PK_L_(0x20, 0x2E)
#define REG_SC_BK20_2E_H      _PK_H_(0x20, 0x2E)
#define REG_SC_BK20_2F_L      _PK_L_(0x20, 0x2F)
#define REG_SC_BK20_2F_H      _PK_H_(0x20, 0x2F)
#define REG_SC_BK20_30_L      _PK_L_(0x20, 0x30)
#define REG_SC_BK20_30_H      _PK_H_(0x20, 0x30)
#define REG_SC_BK20_31_L      _PK_L_(0x20, 0x31)
#define REG_SC_BK20_31_H      _PK_H_(0x20, 0x31)
#define REG_SC_BK20_32_L      _PK_L_(0x20, 0x32)
#define REG_SC_BK20_32_H      _PK_H_(0x20, 0x32)
#define REG_SC_BK20_33_L      _PK_L_(0x20, 0x33)
#define REG_SC_BK20_33_H      _PK_H_(0x20, 0x33)
#define REG_SC_BK20_34_L      _PK_L_(0x20, 0x34)
#define REG_SC_BK20_34_H      _PK_H_(0x20, 0x34)
#define REG_SC_BK20_35_L      _PK_L_(0x20, 0x35)
#define REG_SC_BK20_35_H      _PK_H_(0x20, 0x35)
#define REG_SC_BK20_36_L      _PK_L_(0x20, 0x36)
#define REG_SC_BK20_36_H      _PK_H_(0x20, 0x36)
#define REG_SC_BK20_37_L      _PK_L_(0x20, 0x37)
#define REG_SC_BK20_37_H      _PK_H_(0x20, 0x37)
#define REG_SC_BK20_38_L      _PK_L_(0x20, 0x38)
#define REG_SC_BK20_38_H      _PK_H_(0x20, 0x38)
#define REG_SC_BK20_39_L      _PK_L_(0x20, 0x39)
#define REG_SC_BK20_39_H      _PK_H_(0x20, 0x39)
#define REG_SC_BK20_3A_L      _PK_L_(0x20, 0x3A)
#define REG_SC_BK20_3A_H      _PK_H_(0x20, 0x3A)
#define REG_SC_BK20_3B_L      _PK_L_(0x20, 0x3B)
#define REG_SC_BK20_3B_H      _PK_H_(0x20, 0x3B)
#define REG_SC_BK20_3C_L      _PK_L_(0x20, 0x3C)
#define REG_SC_BK20_3C_H      _PK_H_(0x20, 0x3C)
#define REG_SC_BK20_3D_L      _PK_L_(0x20, 0x3D)
#define REG_SC_BK20_3D_H      _PK_H_(0x20, 0x3D)
#define REG_SC_BK20_3E_L      _PK_L_(0x20, 0x3E)
#define REG_SC_BK20_3E_H      _PK_H_(0x20, 0x3E)
#define REG_SC_BK20_3F_L      _PK_L_(0x20, 0x3F)
#define REG_SC_BK20_3F_H      _PK_H_(0x20, 0x3F)
#define REG_SC_BK20_40_L      _PK_L_(0x20, 0x40)
#define REG_SC_BK20_40_H      _PK_H_(0x20, 0x40)
#define REG_SC_BK20_41_L      _PK_L_(0x20, 0x41)
#define REG_SC_BK20_41_H      _PK_H_(0x20, 0x41)
#define REG_SC_BK20_42_L      _PK_L_(0x20, 0x42)
#define REG_SC_BK20_42_H      _PK_H_(0x20, 0x42)
#define REG_SC_BK20_43_L      _PK_L_(0x20, 0x43)
#define REG_SC_BK20_43_H      _PK_H_(0x20, 0x43)
#define REG_SC_BK20_44_L      _PK_L_(0x20, 0x44)
#define REG_SC_BK20_44_H      _PK_H_(0x20, 0x44)
#define REG_SC_BK20_45_L      _PK_L_(0x20, 0x45)
#define REG_SC_BK20_45_H      _PK_H_(0x20, 0x45)
#define REG_SC_BK20_46_L      _PK_L_(0x20, 0x46)
#define REG_SC_BK20_46_H      _PK_H_(0x20, 0x46)
#define REG_SC_BK20_47_L      _PK_L_(0x20, 0x47)
#define REG_SC_BK20_47_H      _PK_H_(0x20, 0x47)
#define REG_SC_BK20_48_L      _PK_L_(0x20, 0x48)
#define REG_SC_BK20_48_H      _PK_H_(0x20, 0x48)
#define REG_SC_BK20_49_L      _PK_L_(0x20, 0x49)
#define REG_SC_BK20_49_H      _PK_H_(0x20, 0x49)
#define REG_SC_BK20_4A_L      _PK_L_(0x20, 0x4A)
#define REG_SC_BK20_4A_H      _PK_H_(0x20, 0x4A)
#define REG_SC_BK20_4B_L      _PK_L_(0x20, 0x4B)
#define REG_SC_BK20_4B_H      _PK_H_(0x20, 0x4B)
#define REG_SC_BK20_4C_L      _PK_L_(0x20, 0x4C)
#define REG_SC_BK20_4C_H      _PK_H_(0x20, 0x4C)
#define REG_SC_BK20_4D_L      _PK_L_(0x20, 0x4D)
#define REG_SC_BK20_4D_H      _PK_H_(0x20, 0x4D)
#define REG_SC_BK20_4E_L      _PK_L_(0x20, 0x4E)
#define REG_SC_BK20_4E_H      _PK_H_(0x20, 0x4E)
#define REG_SC_BK20_4F_L      _PK_L_(0x20, 0x4F)
#define REG_SC_BK20_4F_H      _PK_H_(0x20, 0x4F)
#define REG_SC_BK20_50_L      _PK_L_(0x20, 0x50)
#define REG_SC_BK20_50_H      _PK_H_(0x20, 0x50)
#define REG_SC_BK20_51_L      _PK_L_(0x20, 0x51)
#define REG_SC_BK20_51_H      _PK_H_(0x20, 0x51)
#define REG_SC_BK20_52_L      _PK_L_(0x20, 0x52)
#define REG_SC_BK20_52_H      _PK_H_(0x20, 0x52)
#define REG_SC_BK20_53_L      _PK_L_(0x20, 0x53)
#define REG_SC_BK20_53_H      _PK_H_(0x20, 0x53)
#define REG_SC_BK20_54_L      _PK_L_(0x20, 0x54)
#define REG_SC_BK20_54_H      _PK_H_(0x20, 0x54)
#define REG_SC_BK20_55_L      _PK_L_(0x20, 0x55)
#define REG_SC_BK20_55_H      _PK_H_(0x20, 0x55)
#define REG_SC_BK20_56_L      _PK_L_(0x20, 0x56)
#define REG_SC_BK20_56_H      _PK_H_(0x20, 0x56)
#define REG_SC_BK20_57_L      _PK_L_(0x20, 0x57)
#define REG_SC_BK20_57_H      _PK_H_(0x20, 0x57)
#define REG_SC_BK20_58_L      _PK_L_(0x20, 0x58)
#define REG_SC_BK20_58_H      _PK_H_(0x20, 0x58)
#define REG_SC_BK20_59_L      _PK_L_(0x20, 0x59)
#define REG_SC_BK20_59_H      _PK_H_(0x20, 0x59)
#define REG_SC_BK20_5A_L      _PK_L_(0x20, 0x5A)
#define REG_SC_BK20_5A_H      _PK_H_(0x20, 0x5A)
#define REG_SC_BK20_5B_L      _PK_L_(0x20, 0x5B)
#define REG_SC_BK20_5B_H      _PK_H_(0x20, 0x5B)
#define REG_SC_BK20_5C_L      _PK_L_(0x20, 0x5C)
#define REG_SC_BK20_5C_H      _PK_H_(0x20, 0x5C)
#define REG_SC_BK20_5D_L      _PK_L_(0x20, 0x5D)
#define REG_SC_BK20_5D_H      _PK_H_(0x20, 0x5D)
#define REG_SC_BK20_5E_L      _PK_L_(0x20, 0x5E)
#define REG_SC_BK20_5E_H      _PK_H_(0x20, 0x5E)
#define REG_SC_BK20_5F_L      _PK_L_(0x20, 0x5F)
#define REG_SC_BK20_5F_H      _PK_H_(0x20, 0x5F)
#define REG_SC_BK20_60_L      _PK_L_(0x20, 0x60)
#define REG_SC_BK20_60_H      _PK_H_(0x20, 0x60)
#define REG_SC_BK20_61_L      _PK_L_(0x20, 0x61)
#define REG_SC_BK20_61_H      _PK_H_(0x20, 0x61)
#define REG_SC_BK20_62_L      _PK_L_(0x20, 0x62)
#define REG_SC_BK20_62_H      _PK_H_(0x20, 0x62)
#define REG_SC_BK20_63_L      _PK_L_(0x20, 0x63)
#define REG_SC_BK20_63_H      _PK_H_(0x20, 0x63)
#define REG_SC_BK20_64_L      _PK_L_(0x20, 0x64)
#define REG_SC_BK20_64_H      _PK_H_(0x20, 0x64)
#define REG_SC_BK20_65_L      _PK_L_(0x20, 0x65)
#define REG_SC_BK20_65_H      _PK_H_(0x20, 0x65)
#define REG_SC_BK20_66_L      _PK_L_(0x20, 0x66)
#define REG_SC_BK20_66_H      _PK_H_(0x20, 0x66)
#define REG_SC_BK20_67_L      _PK_L_(0x20, 0x67)
#define REG_SC_BK20_67_H      _PK_H_(0x20, 0x67)
#define REG_SC_BK20_68_L      _PK_L_(0x20, 0x68)
#define REG_SC_BK20_68_H      _PK_H_(0x20, 0x68)
#define REG_SC_BK20_69_L      _PK_L_(0x20, 0x69)
#define REG_SC_BK20_69_H      _PK_H_(0x20, 0x69)
#define REG_SC_BK20_6A_L      _PK_L_(0x20, 0x6A)
#define REG_SC_BK20_6A_H      _PK_H_(0x20, 0x6A)
#define REG_SC_BK20_6B_L      _PK_L_(0x20, 0x6B)
#define REG_SC_BK20_6B_H      _PK_H_(0x20, 0x6B)
#define REG_SC_BK20_6C_L      _PK_L_(0x20, 0x6C)
#define REG_SC_BK20_6C_H      _PK_H_(0x20, 0x6C)
#define REG_SC_BK20_6D_L      _PK_L_(0x20, 0x6D)
#define REG_SC_BK20_6D_H      _PK_H_(0x20, 0x6D)
#define REG_SC_BK20_6E_L      _PK_L_(0x20, 0x6E)
#define REG_SC_BK20_6E_H      _PK_H_(0x20, 0x6E)
#define REG_SC_BK20_6F_L      _PK_L_(0x20, 0x6F)
#define REG_SC_BK20_6F_H      _PK_H_(0x20, 0x6F)
#define REG_SC_BK20_70_L      _PK_L_(0x20, 0x70)
#define REG_SC_BK20_70_H      _PK_H_(0x20, 0x70)
#define REG_SC_BK20_71_L      _PK_L_(0x20, 0x71)
#define REG_SC_BK20_71_H      _PK_H_(0x20, 0x71)
#define REG_SC_BK20_72_L      _PK_L_(0x20, 0x72)
#define REG_SC_BK20_72_H      _PK_H_(0x20, 0x72)
#define REG_SC_BK20_73_L      _PK_L_(0x20, 0x73)
#define REG_SC_BK20_73_H      _PK_H_(0x20, 0x73)
#define REG_SC_BK20_74_L      _PK_L_(0x20, 0x74)
#define REG_SC_BK20_74_H      _PK_H_(0x20, 0x74)
#define REG_SC_BK20_75_L      _PK_L_(0x20, 0x75)
#define REG_SC_BK20_75_H      _PK_H_(0x20, 0x75)
#define REG_SC_BK20_76_L      _PK_L_(0x20, 0x76)
#define REG_SC_BK20_76_H      _PK_H_(0x20, 0x76)
#define REG_SC_BK20_77_L      _PK_L_(0x20, 0x77)
#define REG_SC_BK20_77_H      _PK_H_(0x20, 0x77)
#define REG_SC_BK20_78_L      _PK_L_(0x20, 0x78)
#define REG_SC_BK20_78_H      _PK_H_(0x20, 0x78)
#define REG_SC_BK20_79_L      _PK_L_(0x20, 0x79)
#define REG_SC_BK20_79_H      _PK_H_(0x20, 0x79)
#define REG_SC_BK20_7A_L      _PK_L_(0x20, 0x7A)
#define REG_SC_BK20_7A_H      _PK_H_(0x20, 0x7A)
#define REG_SC_BK20_7B_L      _PK_L_(0x20, 0x7B)
#define REG_SC_BK20_7B_H      _PK_H_(0x20, 0x7B)
#define REG_SC_BK20_7C_L      _PK_L_(0x20, 0x7C)
#define REG_SC_BK20_7C_H      _PK_H_(0x20, 0x7C)
#define REG_SC_BK20_7D_L      _PK_L_(0x20, 0x7D)
#define REG_SC_BK20_7D_H      _PK_H_(0x20, 0x7D)
#define REG_SC_BK20_7E_L      _PK_L_(0x20, 0x7E)
#define REG_SC_BK20_7E_H      _PK_H_(0x20, 0x7E)
#define REG_SC_BK20_7F_L      _PK_L_(0x20, 0x7F)
#define REG_SC_BK20_7F_H      _PK_H_(0x20, 0x7F)
//----------------------------------------------
#define REG_SC_BK21_00_L      _PK_L_(0x21, 0x00)
#define REG_SC_BK21_00_H      _PK_H_(0x21, 0x00)
#define REG_SC_BK21_01_L      _PK_L_(0x21, 0x01)
#define REG_SC_BK21_01_H      _PK_H_(0x21, 0x01)
#define REG_SC_BK21_02_L      _PK_L_(0x21, 0x02)
#define REG_SC_BK21_02_H      _PK_H_(0x21, 0x02)
#define REG_SC_BK21_03_L      _PK_L_(0x21, 0x03)
#define REG_SC_BK21_03_H      _PK_H_(0x21, 0x03)
#define REG_SC_BK21_04_L      _PK_L_(0x21, 0x04)
#define REG_SC_BK21_04_H      _PK_H_(0x21, 0x04)
#define REG_SC_BK21_05_L      _PK_L_(0x21, 0x05)
#define REG_SC_BK21_05_H      _PK_H_(0x21, 0x05)
#define REG_SC_BK21_06_L      _PK_L_(0x21, 0x06)
#define REG_SC_BK21_06_H      _PK_H_(0x21, 0x06)
#define REG_SC_BK21_07_L      _PK_L_(0x21, 0x07)
#define REG_SC_BK21_07_H      _PK_H_(0x21, 0x07)
#define REG_SC_BK21_08_L      _PK_L_(0x21, 0x08)
#define REG_SC_BK21_08_H      _PK_H_(0x21, 0x08)
#define REG_SC_BK21_09_L      _PK_L_(0x21, 0x09)
#define REG_SC_BK21_09_H      _PK_H_(0x21, 0x09)
#define REG_SC_BK21_0A_L      _PK_L_(0x21, 0x0A)
#define REG_SC_BK21_0A_H      _PK_H_(0x21, 0x0A)
#define REG_SC_BK21_0B_L      _PK_L_(0x21, 0x0B)
#define REG_SC_BK21_0B_H      _PK_H_(0x21, 0x0B)
#define REG_SC_BK21_0C_L      _PK_L_(0x21, 0x0C)
#define REG_SC_BK21_0C_H      _PK_H_(0x21, 0x0C)
#define REG_SC_BK21_0D_L      _PK_L_(0x21, 0x0D)
#define REG_SC_BK21_0D_H      _PK_H_(0x21, 0x0D)
#define REG_SC_BK21_0E_L      _PK_L_(0x21, 0x0E)
#define REG_SC_BK21_0E_H      _PK_H_(0x21, 0x0E)
#define REG_SC_BK21_0F_L      _PK_L_(0x21, 0x0F)
#define REG_SC_BK21_0F_H      _PK_H_(0x21, 0x0F)
#define REG_SC_BK21_10_L      _PK_L_(0x21, 0x10)
#define REG_SC_BK21_10_H      _PK_H_(0x21, 0x10)
#define REG_SC_BK21_11_L      _PK_L_(0x21, 0x11)
#define REG_SC_BK21_11_H      _PK_H_(0x21, 0x11)
#define REG_SC_BK21_12_L      _PK_L_(0x21, 0x12)
#define REG_SC_BK21_12_H      _PK_H_(0x21, 0x12)
#define REG_SC_BK21_13_L      _PK_L_(0x21, 0x13)
#define REG_SC_BK21_13_H      _PK_H_(0x21, 0x13)
#define REG_SC_BK21_14_L      _PK_L_(0x21, 0x14)
#define REG_SC_BK21_14_H      _PK_H_(0x21, 0x14)
#define REG_SC_BK21_15_L      _PK_L_(0x21, 0x15)
#define REG_SC_BK21_15_H      _PK_H_(0x21, 0x15)
#define REG_SC_BK21_16_L      _PK_L_(0x21, 0x16)
#define REG_SC_BK21_16_H      _PK_H_(0x21, 0x16)
#define REG_SC_BK21_17_L      _PK_L_(0x21, 0x17)
#define REG_SC_BK21_17_H      _PK_H_(0x21, 0x17)
#define REG_SC_BK21_18_L      _PK_L_(0x21, 0x18)
#define REG_SC_BK21_18_H      _PK_H_(0x21, 0x18)
#define REG_SC_BK21_19_L      _PK_L_(0x21, 0x19)
#define REG_SC_BK21_19_H      _PK_H_(0x21, 0x19)
#define REG_SC_BK21_1A_L      _PK_L_(0x21, 0x1A)
#define REG_SC_BK21_1A_H      _PK_H_(0x21, 0x1A)
#define REG_SC_BK21_1B_L      _PK_L_(0x21, 0x1B)
#define REG_SC_BK21_1B_H      _PK_H_(0x21, 0x1B)
#define REG_SC_BK21_1C_L      _PK_L_(0x21, 0x1C)
#define REG_SC_BK21_1C_H      _PK_H_(0x21, 0x1C)
#define REG_SC_BK21_1D_L      _PK_L_(0x21, 0x1D)
#define REG_SC_BK21_1D_H      _PK_H_(0x21, 0x1D)
#define REG_SC_BK21_1E_L      _PK_L_(0x21, 0x1E)
#define REG_SC_BK21_1E_H      _PK_H_(0x21, 0x1E)
#define REG_SC_BK21_1F_L      _PK_L_(0x21, 0x1F)
#define REG_SC_BK21_1F_H      _PK_H_(0x21, 0x1F)
#define REG_SC_BK21_20_L      _PK_L_(0x21, 0x20)
#define REG_SC_BK21_20_H      _PK_H_(0x21, 0x20)
#define REG_SC_BK21_21_L      _PK_L_(0x21, 0x21)
#define REG_SC_BK21_21_H      _PK_H_(0x21, 0x21)
#define REG_SC_BK21_22_L      _PK_L_(0x21, 0x22)
#define REG_SC_BK21_22_H      _PK_H_(0x21, 0x22)
#define REG_SC_BK21_23_L      _PK_L_(0x21, 0x23)
#define REG_SC_BK21_23_H      _PK_H_(0x21, 0x23)
#define REG_SC_BK21_24_L      _PK_L_(0x21, 0x24)
#define REG_SC_BK21_24_H      _PK_H_(0x21, 0x24)
#define REG_SC_BK21_25_L      _PK_L_(0x21, 0x25)
#define REG_SC_BK21_25_H      _PK_H_(0x21, 0x25)
#define REG_SC_BK21_26_L      _PK_L_(0x21, 0x26)
#define REG_SC_BK21_26_H      _PK_H_(0x21, 0x26)
#define REG_SC_BK21_27_L      _PK_L_(0x21, 0x27)
#define REG_SC_BK21_27_H      _PK_H_(0x21, 0x27)
#define REG_SC_BK21_28_L      _PK_L_(0x21, 0x28)
#define REG_SC_BK21_28_H      _PK_H_(0x21, 0x28)
#define REG_SC_BK21_29_L      _PK_L_(0x21, 0x29)
#define REG_SC_BK21_29_H      _PK_H_(0x21, 0x29)
#define REG_SC_BK21_2A_L      _PK_L_(0x21, 0x2A)
#define REG_SC_BK21_2A_H      _PK_H_(0x21, 0x2A)
#define REG_SC_BK21_2B_L      _PK_L_(0x21, 0x2B)
#define REG_SC_BK21_2B_H      _PK_H_(0x21, 0x2B)
#define REG_SC_BK21_2C_L      _PK_L_(0x21, 0x2C)
#define REG_SC_BK21_2C_H      _PK_H_(0x21, 0x2C)
#define REG_SC_BK21_2D_L      _PK_L_(0x21, 0x2D)
#define REG_SC_BK21_2D_H      _PK_H_(0x21, 0x2D)
#define REG_SC_BK21_2E_L      _PK_L_(0x21, 0x2E)
#define REG_SC_BK21_2E_H      _PK_H_(0x21, 0x2E)
#define REG_SC_BK21_2F_L      _PK_L_(0x21, 0x2F)
#define REG_SC_BK21_2F_H      _PK_H_(0x21, 0x2F)
#define REG_SC_BK21_30_L      _PK_L_(0x21, 0x30)
#define REG_SC_BK21_30_H      _PK_H_(0x21, 0x30)
#define REG_SC_BK21_31_L      _PK_L_(0x21, 0x31)
#define REG_SC_BK21_31_H      _PK_H_(0x21, 0x31)
#define REG_SC_BK21_32_L      _PK_L_(0x21, 0x32)
#define REG_SC_BK21_32_H      _PK_H_(0x21, 0x32)
#define REG_SC_BK21_33_L      _PK_L_(0x21, 0x33)
#define REG_SC_BK21_33_H      _PK_H_(0x21, 0x33)
#define REG_SC_BK21_34_L      _PK_L_(0x21, 0x34)
#define REG_SC_BK21_34_H      _PK_H_(0x21, 0x34)
#define REG_SC_BK21_35_L      _PK_L_(0x21, 0x35)
#define REG_SC_BK21_35_H      _PK_H_(0x21, 0x35)
#define REG_SC_BK21_36_L      _PK_L_(0x21, 0x36)
#define REG_SC_BK21_36_H      _PK_H_(0x21, 0x36)
#define REG_SC_BK21_37_L      _PK_L_(0x21, 0x37)
#define REG_SC_BK21_37_H      _PK_H_(0x21, 0x37)
#define REG_SC_BK21_38_L      _PK_L_(0x21, 0x38)
#define REG_SC_BK21_38_H      _PK_H_(0x21, 0x38)
#define REG_SC_BK21_39_L      _PK_L_(0x21, 0x39)
#define REG_SC_BK21_39_H      _PK_H_(0x21, 0x39)
#define REG_SC_BK21_3A_L      _PK_L_(0x21, 0x3A)
#define REG_SC_BK21_3A_H      _PK_H_(0x21, 0x3A)
#define REG_SC_BK21_3B_L      _PK_L_(0x21, 0x3B)
#define REG_SC_BK21_3B_H      _PK_H_(0x21, 0x3B)
#define REG_SC_BK21_3C_L      _PK_L_(0x21, 0x3C)
#define REG_SC_BK21_3C_H      _PK_H_(0x21, 0x3C)
#define REG_SC_BK21_3D_L      _PK_L_(0x21, 0x3D)
#define REG_SC_BK21_3D_H      _PK_H_(0x21, 0x3D)
#define REG_SC_BK21_3E_L      _PK_L_(0x21, 0x3E)
#define REG_SC_BK21_3E_H      _PK_H_(0x21, 0x3E)
#define REG_SC_BK21_3F_L      _PK_L_(0x21, 0x3F)
#define REG_SC_BK21_3F_H      _PK_H_(0x21, 0x3F)
#define REG_SC_BK21_40_L      _PK_L_(0x21, 0x40)
#define REG_SC_BK21_40_H      _PK_H_(0x21, 0x40)
#define REG_SC_BK21_41_L      _PK_L_(0x21, 0x41)
#define REG_SC_BK21_41_H      _PK_H_(0x21, 0x41)
#define REG_SC_BK21_42_L      _PK_L_(0x21, 0x42)
#define REG_SC_BK21_42_H      _PK_H_(0x21, 0x42)
#define REG_SC_BK21_43_L      _PK_L_(0x21, 0x43)
#define REG_SC_BK21_43_H      _PK_H_(0x21, 0x43)
#define REG_SC_BK21_44_L      _PK_L_(0x21, 0x44)
#define REG_SC_BK21_44_H      _PK_H_(0x21, 0x44)
#define REG_SC_BK21_45_L      _PK_L_(0x21, 0x45)
#define REG_SC_BK21_45_H      _PK_H_(0x21, 0x45)
#define REG_SC_BK21_46_L      _PK_L_(0x21, 0x46)
#define REG_SC_BK21_46_H      _PK_H_(0x21, 0x46)
#define REG_SC_BK21_47_L      _PK_L_(0x21, 0x47)
#define REG_SC_BK21_47_H      _PK_H_(0x21, 0x47)
#define REG_SC_BK21_48_L      _PK_L_(0x21, 0x48)
#define REG_SC_BK21_48_H      _PK_H_(0x21, 0x48)
#define REG_SC_BK21_49_L      _PK_L_(0x21, 0x49)
#define REG_SC_BK21_49_H      _PK_H_(0x21, 0x49)
#define REG_SC_BK21_4A_L      _PK_L_(0x21, 0x4A)
#define REG_SC_BK21_4A_H      _PK_H_(0x21, 0x4A)
#define REG_SC_BK21_4B_L      _PK_L_(0x21, 0x4B)
#define REG_SC_BK21_4B_H      _PK_H_(0x21, 0x4B)
#define REG_SC_BK21_4C_L      _PK_L_(0x21, 0x4C)
#define REG_SC_BK21_4C_H      _PK_H_(0x21, 0x4C)
#define REG_SC_BK21_4D_L      _PK_L_(0x21, 0x4D)
#define REG_SC_BK21_4D_H      _PK_H_(0x21, 0x4D)
#define REG_SC_BK21_4E_L      _PK_L_(0x21, 0x4E)
#define REG_SC_BK21_4E_H      _PK_H_(0x21, 0x4E)
#define REG_SC_BK21_4F_L      _PK_L_(0x21, 0x4F)
#define REG_SC_BK21_4F_H      _PK_H_(0x21, 0x4F)
#define REG_SC_BK21_50_L      _PK_L_(0x21, 0x50)
#define REG_SC_BK21_50_H      _PK_H_(0x21, 0x50)
#define REG_SC_BK21_51_L      _PK_L_(0x21, 0x51)
#define REG_SC_BK21_51_H      _PK_H_(0x21, 0x51)
#define REG_SC_BK21_52_L      _PK_L_(0x21, 0x52)
#define REG_SC_BK21_52_H      _PK_H_(0x21, 0x52)
#define REG_SC_BK21_53_L      _PK_L_(0x21, 0x53)
#define REG_SC_BK21_53_H      _PK_H_(0x21, 0x53)
#define REG_SC_BK21_54_L      _PK_L_(0x21, 0x54)
#define REG_SC_BK21_54_H      _PK_H_(0x21, 0x54)
#define REG_SC_BK21_55_L      _PK_L_(0x21, 0x55)
#define REG_SC_BK21_55_H      _PK_H_(0x21, 0x55)
#define REG_SC_BK21_56_L      _PK_L_(0x21, 0x56)
#define REG_SC_BK21_56_H      _PK_H_(0x21, 0x56)
#define REG_SC_BK21_57_L      _PK_L_(0x21, 0x57)
#define REG_SC_BK21_57_H      _PK_H_(0x21, 0x57)
#define REG_SC_BK21_58_L      _PK_L_(0x21, 0x58)
#define REG_SC_BK21_58_H      _PK_H_(0x21, 0x58)
#define REG_SC_BK21_59_L      _PK_L_(0x21, 0x59)
#define REG_SC_BK21_59_H      _PK_H_(0x21, 0x59)
#define REG_SC_BK21_5A_L      _PK_L_(0x21, 0x5A)
#define REG_SC_BK21_5A_H      _PK_H_(0x21, 0x5A)
#define REG_SC_BK21_5B_L      _PK_L_(0x21, 0x5B)
#define REG_SC_BK21_5B_H      _PK_H_(0x21, 0x5B)
#define REG_SC_BK21_5C_L      _PK_L_(0x21, 0x5C)
#define REG_SC_BK21_5C_H      _PK_H_(0x21, 0x5C)
#define REG_SC_BK21_5D_L      _PK_L_(0x21, 0x5D)
#define REG_SC_BK21_5D_H      _PK_H_(0x21, 0x5D)
#define REG_SC_BK21_5E_L      _PK_L_(0x21, 0x5E)
#define REG_SC_BK21_5E_H      _PK_H_(0x21, 0x5E)
#define REG_SC_BK21_5F_L      _PK_L_(0x21, 0x5F)
#define REG_SC_BK21_5F_H      _PK_H_(0x21, 0x5F)
#define REG_SC_BK21_60_L      _PK_L_(0x21, 0x60)
#define REG_SC_BK21_60_H      _PK_H_(0x21, 0x60)
#define REG_SC_BK21_61_L      _PK_L_(0x21, 0x61)
#define REG_SC_BK21_61_H      _PK_H_(0x21, 0x61)
#define REG_SC_BK21_62_L      _PK_L_(0x21, 0x62)
#define REG_SC_BK21_62_H      _PK_H_(0x21, 0x62)
#define REG_SC_BK21_63_L      _PK_L_(0x21, 0x63)
#define REG_SC_BK21_63_H      _PK_H_(0x21, 0x63)
#define REG_SC_BK21_64_L      _PK_L_(0x21, 0x64)
#define REG_SC_BK21_64_H      _PK_H_(0x21, 0x64)
#define REG_SC_BK21_65_L      _PK_L_(0x21, 0x65)
#define REG_SC_BK21_65_H      _PK_H_(0x21, 0x65)
#define REG_SC_BK21_66_L      _PK_L_(0x21, 0x66)
#define REG_SC_BK21_66_H      _PK_H_(0x21, 0x66)
#define REG_SC_BK21_67_L      _PK_L_(0x21, 0x67)
#define REG_SC_BK21_67_H      _PK_H_(0x21, 0x67)
#define REG_SC_BK21_68_L      _PK_L_(0x21, 0x68)
#define REG_SC_BK21_68_H      _PK_H_(0x21, 0x68)
#define REG_SC_BK21_69_L      _PK_L_(0x21, 0x69)
#define REG_SC_BK21_69_H      _PK_H_(0x21, 0x69)
#define REG_SC_BK21_6A_L      _PK_L_(0x21, 0x6A)
#define REG_SC_BK21_6A_H      _PK_H_(0x21, 0x6A)
#define REG_SC_BK21_6B_L      _PK_L_(0x21, 0x6B)
#define REG_SC_BK21_6B_H      _PK_H_(0x21, 0x6B)
#define REG_SC_BK21_6C_L      _PK_L_(0x21, 0x6C)
#define REG_SC_BK21_6C_H      _PK_H_(0x21, 0x6C)
#define REG_SC_BK21_6D_L      _PK_L_(0x21, 0x6D)
#define REG_SC_BK21_6D_H      _PK_H_(0x21, 0x6D)
#define REG_SC_BK21_6E_L      _PK_L_(0x21, 0x6E)
#define REG_SC_BK21_6E_H      _PK_H_(0x21, 0x6E)
#define REG_SC_BK21_6F_L      _PK_L_(0x21, 0x6F)
#define REG_SC_BK21_6F_H      _PK_H_(0x21, 0x6F)
#define REG_SC_BK21_70_L      _PK_L_(0x21, 0x70)
#define REG_SC_BK21_70_H      _PK_H_(0x21, 0x70)
#define REG_SC_BK21_71_L      _PK_L_(0x21, 0x71)
#define REG_SC_BK21_71_H      _PK_H_(0x21, 0x71)
#define REG_SC_BK21_72_L      _PK_L_(0x21, 0x72)
#define REG_SC_BK21_72_H      _PK_H_(0x21, 0x72)
#define REG_SC_BK21_73_L      _PK_L_(0x21, 0x73)
#define REG_SC_BK21_73_H      _PK_H_(0x21, 0x73)
#define REG_SC_BK21_74_L      _PK_L_(0x21, 0x74)
#define REG_SC_BK21_74_H      _PK_H_(0x21, 0x74)
#define REG_SC_BK21_75_L      _PK_L_(0x21, 0x75)
#define REG_SC_BK21_75_H      _PK_H_(0x21, 0x75)
#define REG_SC_BK21_76_L      _PK_L_(0x21, 0x76)
#define REG_SC_BK21_76_H      _PK_H_(0x21, 0x76)
#define REG_SC_BK21_77_L      _PK_L_(0x21, 0x77)
#define REG_SC_BK21_77_H      _PK_H_(0x21, 0x77)
#define REG_SC_BK21_78_L      _PK_L_(0x21, 0x78)
#define REG_SC_BK21_78_H      _PK_H_(0x21, 0x78)
#define REG_SC_BK21_79_L      _PK_L_(0x21, 0x79)
#define REG_SC_BK21_79_H      _PK_H_(0x21, 0x79)
#define REG_SC_BK21_7A_L      _PK_L_(0x21, 0x7A)
#define REG_SC_BK21_7A_H      _PK_H_(0x21, 0x7A)
#define REG_SC_BK21_7B_L      _PK_L_(0x21, 0x7B)
#define REG_SC_BK21_7B_H      _PK_H_(0x21, 0x7B)
#define REG_SC_BK21_7C_L      _PK_L_(0x21, 0x7C)
#define REG_SC_BK21_7C_H      _PK_H_(0x21, 0x7C)
#define REG_SC_BK21_7D_L      _PK_L_(0x21, 0x7D)
#define REG_SC_BK21_7D_H      _PK_H_(0x21, 0x7D)
#define REG_SC_BK21_7E_L      _PK_L_(0x21, 0x7E)
#define REG_SC_BK21_7E_H      _PK_H_(0x21, 0x7E)
#define REG_SC_BK21_7F_L      _PK_L_(0x21, 0x7F)
#define REG_SC_BK21_7F_H      _PK_H_(0x21, 0x7F)
//----------------------------------------------
#define REG_SC_BK22_00_L      _PK_L_(0x22, 0x00)
#define REG_SC_BK22_00_H      _PK_H_(0x22, 0x00)
#define REG_SC_BK22_01_L      _PK_L_(0x22, 0x01)
#define REG_SC_BK22_01_H      _PK_H_(0x22, 0x01)
#define REG_SC_BK22_02_L      _PK_L_(0x22, 0x02)
#define REG_SC_BK22_02_H      _PK_H_(0x22, 0x02)
#define REG_SC_BK22_03_L      _PK_L_(0x22, 0x03)
#define REG_SC_BK22_03_H      _PK_H_(0x22, 0x03)
#define REG_SC_BK22_04_L      _PK_L_(0x22, 0x04)
#define REG_SC_BK22_04_H      _PK_H_(0x22, 0x04)
#define REG_SC_BK22_05_L      _PK_L_(0x22, 0x05)
#define REG_SC_BK22_05_H      _PK_H_(0x22, 0x05)
#define REG_SC_BK22_06_L      _PK_L_(0x22, 0x06)
#define REG_SC_BK22_06_H      _PK_H_(0x22, 0x06)
#define REG_SC_BK22_07_L      _PK_L_(0x22, 0x07)
#define REG_SC_BK22_07_H      _PK_H_(0x22, 0x07)
#define REG_SC_BK22_08_L      _PK_L_(0x22, 0x08)
#define REG_SC_BK22_08_H      _PK_H_(0x22, 0x08)
#define REG_SC_BK22_09_L      _PK_L_(0x22, 0x09)
#define REG_SC_BK22_09_H      _PK_H_(0x22, 0x09)
#define REG_SC_BK22_0A_L      _PK_L_(0x22, 0x0A)
#define REG_SC_BK22_0A_H      _PK_H_(0x22, 0x0A)
#define REG_SC_BK22_0B_L      _PK_L_(0x22, 0x0B)
#define REG_SC_BK22_0B_H      _PK_H_(0x22, 0x0B)
#define REG_SC_BK22_0C_L      _PK_L_(0x22, 0x0C)
#define REG_SC_BK22_0C_H      _PK_H_(0x22, 0x0C)
#define REG_SC_BK22_0D_L      _PK_L_(0x22, 0x0D)
#define REG_SC_BK22_0D_H      _PK_H_(0x22, 0x0D)
#define REG_SC_BK22_0E_L      _PK_L_(0x22, 0x0E)
#define REG_SC_BK22_0E_H      _PK_H_(0x22, 0x0E)
#define REG_SC_BK22_0F_L      _PK_L_(0x22, 0x0F)
#define REG_SC_BK22_0F_H      _PK_H_(0x22, 0x0F)
#define REG_SC_BK22_10_L      _PK_L_(0x22, 0x10)
#define REG_SC_BK22_10_H      _PK_H_(0x22, 0x10)
#define REG_SC_BK22_11_L      _PK_L_(0x22, 0x11)
#define REG_SC_BK22_11_H      _PK_H_(0x22, 0x11)
#define REG_SC_BK22_12_L      _PK_L_(0x22, 0x12)
#define REG_SC_BK22_12_H      _PK_H_(0x22, 0x12)
#define REG_SC_BK22_13_L      _PK_L_(0x22, 0x13)
#define REG_SC_BK22_13_H      _PK_H_(0x22, 0x13)
#define REG_SC_BK22_14_L      _PK_L_(0x22, 0x14)
#define REG_SC_BK22_14_H      _PK_H_(0x22, 0x14)
#define REG_SC_BK22_15_L      _PK_L_(0x22, 0x15)
#define REG_SC_BK22_15_H      _PK_H_(0x22, 0x15)
#define REG_SC_BK22_16_L      _PK_L_(0x22, 0x16)
#define REG_SC_BK22_16_H      _PK_H_(0x22, 0x16)
#define REG_SC_BK22_17_L      _PK_L_(0x22, 0x17)
#define REG_SC_BK22_17_H      _PK_H_(0x22, 0x17)
#define REG_SC_BK22_18_L      _PK_L_(0x22, 0x18)
#define REG_SC_BK22_18_H      _PK_H_(0x22, 0x18)
#define REG_SC_BK22_19_L      _PK_L_(0x22, 0x19)
#define REG_SC_BK22_19_H      _PK_H_(0x22, 0x19)
#define REG_SC_BK22_1A_L      _PK_L_(0x22, 0x1A)
#define REG_SC_BK22_1A_H      _PK_H_(0x22, 0x1A)
#define REG_SC_BK22_1B_L      _PK_L_(0x22, 0x1B)
#define REG_SC_BK22_1B_H      _PK_H_(0x22, 0x1B)
#define REG_SC_BK22_1C_L      _PK_L_(0x22, 0x1C)
#define REG_SC_BK22_1C_H      _PK_H_(0x22, 0x1C)
#define REG_SC_BK22_1D_L      _PK_L_(0x22, 0x1D)
#define REG_SC_BK22_1D_H      _PK_H_(0x22, 0x1D)
#define REG_SC_BK22_1E_L      _PK_L_(0x22, 0x1E)
#define REG_SC_BK22_1E_H      _PK_H_(0x22, 0x1E)
#define REG_SC_BK22_1F_L      _PK_L_(0x22, 0x1F)
#define REG_SC_BK22_1F_H      _PK_H_(0x22, 0x1F)
#define REG_SC_BK22_20_L      _PK_L_(0x22, 0x20)
#define REG_SC_BK22_20_H      _PK_H_(0x22, 0x20)
#define REG_SC_BK22_21_L      _PK_L_(0x22, 0x21)
#define REG_SC_BK22_21_H      _PK_H_(0x22, 0x21)
#define REG_SC_BK22_22_L      _PK_L_(0x22, 0x22)
#define REG_SC_BK22_22_H      _PK_H_(0x22, 0x22)
#define REG_SC_BK22_23_L      _PK_L_(0x22, 0x23)
#define REG_SC_BK22_23_H      _PK_H_(0x22, 0x23)
#define REG_SC_BK22_24_L      _PK_L_(0x22, 0x24)
#define REG_SC_BK22_24_H      _PK_H_(0x22, 0x24)
#define REG_SC_BK22_25_L      _PK_L_(0x22, 0x25)
#define REG_SC_BK22_25_H      _PK_H_(0x22, 0x25)
#define REG_SC_BK22_26_L      _PK_L_(0x22, 0x26)
#define REG_SC_BK22_26_H      _PK_H_(0x22, 0x26)
#define REG_SC_BK22_27_L      _PK_L_(0x22, 0x27)
#define REG_SC_BK22_27_H      _PK_H_(0x22, 0x27)
#define REG_SC_BK22_28_L      _PK_L_(0x22, 0x28)
#define REG_SC_BK22_28_H      _PK_H_(0x22, 0x28)
#define REG_SC_BK22_29_L      _PK_L_(0x22, 0x29)
#define REG_SC_BK22_29_H      _PK_H_(0x22, 0x29)
#define REG_SC_BK22_2A_L      _PK_L_(0x22, 0x2A)
#define REG_SC_BK22_2A_H      _PK_H_(0x22, 0x2A)
#define REG_SC_BK22_2B_L      _PK_L_(0x22, 0x2B)
#define REG_SC_BK22_2B_H      _PK_H_(0x22, 0x2B)
#define REG_SC_BK22_2C_L      _PK_L_(0x22, 0x2C)
#define REG_SC_BK22_2C_H      _PK_H_(0x22, 0x2C)
#define REG_SC_BK22_2D_L      _PK_L_(0x22, 0x2D)
#define REG_SC_BK22_2D_H      _PK_H_(0x22, 0x2D)
#define REG_SC_BK22_2E_L      _PK_L_(0x22, 0x2E)
#define REG_SC_BK22_2E_H      _PK_H_(0x22, 0x2E)
#define REG_SC_BK22_2F_L      _PK_L_(0x22, 0x2F)
#define REG_SC_BK22_2F_H      _PK_H_(0x22, 0x2F)
#define REG_SC_BK22_30_L      _PK_L_(0x22, 0x30)
#define REG_SC_BK22_30_H      _PK_H_(0x22, 0x30)
#define REG_SC_BK22_31_L      _PK_L_(0x22, 0x31)
#define REG_SC_BK22_31_H      _PK_H_(0x22, 0x31)
#define REG_SC_BK22_32_L      _PK_L_(0x22, 0x32)
#define REG_SC_BK22_32_H      _PK_H_(0x22, 0x32)
#define REG_SC_BK22_33_L      _PK_L_(0x22, 0x33)
#define REG_SC_BK22_33_H      _PK_H_(0x22, 0x33)
#define REG_SC_BK22_34_L      _PK_L_(0x22, 0x34)
#define REG_SC_BK22_34_H      _PK_H_(0x22, 0x34)
#define REG_SC_BK22_35_L      _PK_L_(0x22, 0x35)
#define REG_SC_BK22_35_H      _PK_H_(0x22, 0x35)
#define REG_SC_BK22_36_L      _PK_L_(0x22, 0x36)
#define REG_SC_BK22_36_H      _PK_H_(0x22, 0x36)
#define REG_SC_BK22_37_L      _PK_L_(0x22, 0x37)
#define REG_SC_BK22_37_H      _PK_H_(0x22, 0x37)
#define REG_SC_BK22_38_L      _PK_L_(0x22, 0x38)
#define REG_SC_BK22_38_H      _PK_H_(0x22, 0x38)
#define REG_SC_BK22_39_L      _PK_L_(0x22, 0x39)
#define REG_SC_BK22_39_H      _PK_H_(0x22, 0x39)
#define REG_SC_BK22_3A_L      _PK_L_(0x22, 0x3A)
#define REG_SC_BK22_3A_H      _PK_H_(0x22, 0x3A)
#define REG_SC_BK22_3B_L      _PK_L_(0x22, 0x3B)
#define REG_SC_BK22_3B_H      _PK_H_(0x22, 0x3B)
#define REG_SC_BK22_3C_L      _PK_L_(0x22, 0x3C)
#define REG_SC_BK22_3C_H      _PK_H_(0x22, 0x3C)
#define REG_SC_BK22_3D_L      _PK_L_(0x22, 0x3D)
#define REG_SC_BK22_3D_H      _PK_H_(0x22, 0x3D)
#define REG_SC_BK22_3E_L      _PK_L_(0x22, 0x3E)
#define REG_SC_BK22_3E_H      _PK_H_(0x22, 0x3E)
#define REG_SC_BK22_3F_L      _PK_L_(0x22, 0x3F)
#define REG_SC_BK22_3F_H      _PK_H_(0x22, 0x3F)
#define REG_SC_BK22_40_L      _PK_L_(0x22, 0x40)
#define REG_SC_BK22_40_H      _PK_H_(0x22, 0x40)
#define REG_SC_BK22_41_L      _PK_L_(0x22, 0x41)
#define REG_SC_BK22_41_H      _PK_H_(0x22, 0x41)
#define REG_SC_BK22_42_L      _PK_L_(0x22, 0x42)
#define REG_SC_BK22_42_H      _PK_H_(0x22, 0x42)
#define REG_SC_BK22_43_L      _PK_L_(0x22, 0x43)
#define REG_SC_BK22_43_H      _PK_H_(0x22, 0x43)
#define REG_SC_BK22_44_L      _PK_L_(0x22, 0x44)
#define REG_SC_BK22_44_H      _PK_H_(0x22, 0x44)
#define REG_SC_BK22_45_L      _PK_L_(0x22, 0x45)
#define REG_SC_BK22_45_H      _PK_H_(0x22, 0x45)
#define REG_SC_BK22_46_L      _PK_L_(0x22, 0x46)
#define REG_SC_BK22_46_H      _PK_H_(0x22, 0x46)
#define REG_SC_BK22_47_L      _PK_L_(0x22, 0x47)
#define REG_SC_BK22_47_H      _PK_H_(0x22, 0x47)
#define REG_SC_BK22_48_L      _PK_L_(0x22, 0x48)
#define REG_SC_BK22_48_H      _PK_H_(0x22, 0x48)
#define REG_SC_BK22_49_L      _PK_L_(0x22, 0x49)
#define REG_SC_BK22_49_H      _PK_H_(0x22, 0x49)
#define REG_SC_BK22_4A_L      _PK_L_(0x22, 0x4A)
#define REG_SC_BK22_4A_H      _PK_H_(0x22, 0x4A)
#define REG_SC_BK22_4B_L      _PK_L_(0x22, 0x4B)
#define REG_SC_BK22_4B_H      _PK_H_(0x22, 0x4B)
#define REG_SC_BK22_4C_L      _PK_L_(0x22, 0x4C)
#define REG_SC_BK22_4C_H      _PK_H_(0x22, 0x4C)
#define REG_SC_BK22_4D_L      _PK_L_(0x22, 0x4D)
#define REG_SC_BK22_4D_H      _PK_H_(0x22, 0x4D)
#define REG_SC_BK22_4E_L      _PK_L_(0x22, 0x4E)
#define REG_SC_BK22_4E_H      _PK_H_(0x22, 0x4E)
#define REG_SC_BK22_4F_L      _PK_L_(0x22, 0x4F)
#define REG_SC_BK22_4F_H      _PK_H_(0x22, 0x4F)
#define REG_SC_BK22_50_L      _PK_L_(0x22, 0x50)
#define REG_SC_BK22_50_H      _PK_H_(0x22, 0x50)
#define REG_SC_BK22_51_L      _PK_L_(0x22, 0x51)
#define REG_SC_BK22_51_H      _PK_H_(0x22, 0x51)
#define REG_SC_BK22_52_L      _PK_L_(0x22, 0x52)
#define REG_SC_BK22_52_H      _PK_H_(0x22, 0x52)
#define REG_SC_BK22_53_L      _PK_L_(0x22, 0x53)
#define REG_SC_BK22_53_H      _PK_H_(0x22, 0x53)
#define REG_SC_BK22_54_L      _PK_L_(0x22, 0x54)
#define REG_SC_BK22_54_H      _PK_H_(0x22, 0x54)
#define REG_SC_BK22_55_L      _PK_L_(0x22, 0x55)
#define REG_SC_BK22_55_H      _PK_H_(0x22, 0x55)
#define REG_SC_BK22_56_L      _PK_L_(0x22, 0x56)
#define REG_SC_BK22_56_H      _PK_H_(0x22, 0x56)
#define REG_SC_BK22_57_L      _PK_L_(0x22, 0x57)
#define REG_SC_BK22_57_H      _PK_H_(0x22, 0x57)
#define REG_SC_BK22_58_L      _PK_L_(0x22, 0x58)
#define REG_SC_BK22_58_H      _PK_H_(0x22, 0x58)
#define REG_SC_BK22_59_L      _PK_L_(0x22, 0x59)
#define REG_SC_BK22_59_H      _PK_H_(0x22, 0x59)
#define REG_SC_BK22_5A_L      _PK_L_(0x22, 0x5A)
#define REG_SC_BK22_5A_H      _PK_H_(0x22, 0x5A)
#define REG_SC_BK22_5B_L      _PK_L_(0x22, 0x5B)
#define REG_SC_BK22_5B_H      _PK_H_(0x22, 0x5B)
#define REG_SC_BK22_5C_L      _PK_L_(0x22, 0x5C)
#define REG_SC_BK22_5C_H      _PK_H_(0x22, 0x5C)
#define REG_SC_BK22_5D_L      _PK_L_(0x22, 0x5D)
#define REG_SC_BK22_5D_H      _PK_H_(0x22, 0x5D)
#define REG_SC_BK22_5E_L      _PK_L_(0x22, 0x5E)
#define REG_SC_BK22_5E_H      _PK_H_(0x22, 0x5E)
#define REG_SC_BK22_5F_L      _PK_L_(0x22, 0x5F)
#define REG_SC_BK22_5F_H      _PK_H_(0x22, 0x5F)
#define REG_SC_BK22_60_L      _PK_L_(0x22, 0x60)
#define REG_SC_BK22_60_H      _PK_H_(0x22, 0x60)
#define REG_SC_BK22_61_L      _PK_L_(0x22, 0x61)
#define REG_SC_BK22_61_H      _PK_H_(0x22, 0x61)
#define REG_SC_BK22_62_L      _PK_L_(0x22, 0x62)
#define REG_SC_BK22_62_H      _PK_H_(0x22, 0x62)
#define REG_SC_BK22_63_L      _PK_L_(0x22, 0x63)
#define REG_SC_BK22_63_H      _PK_H_(0x22, 0x63)
#define REG_SC_BK22_64_L      _PK_L_(0x22, 0x64)
#define REG_SC_BK22_64_H      _PK_H_(0x22, 0x64)
#define REG_SC_BK22_65_L      _PK_L_(0x22, 0x65)
#define REG_SC_BK22_65_H      _PK_H_(0x22, 0x65)
#define REG_SC_BK22_66_L      _PK_L_(0x22, 0x66)
#define REG_SC_BK22_66_H      _PK_H_(0x22, 0x66)
#define REG_SC_BK22_67_L      _PK_L_(0x22, 0x67)
#define REG_SC_BK22_67_H      _PK_H_(0x22, 0x67)
#define REG_SC_BK22_68_L      _PK_L_(0x22, 0x68)
#define REG_SC_BK22_68_H      _PK_H_(0x22, 0x68)
#define REG_SC_BK22_69_L      _PK_L_(0x22, 0x69)
#define REG_SC_BK22_69_H      _PK_H_(0x22, 0x69)
#define REG_SC_BK22_6A_L      _PK_L_(0x22, 0x6A)
#define REG_SC_BK22_6A_H      _PK_H_(0x22, 0x6A)
#define REG_SC_BK22_6B_L      _PK_L_(0x22, 0x6B)
#define REG_SC_BK22_6B_H      _PK_H_(0x22, 0x6B)
#define REG_SC_BK22_6C_L      _PK_L_(0x22, 0x6C)
#define REG_SC_BK22_6C_H      _PK_H_(0x22, 0x6C)
#define REG_SC_BK22_6D_L      _PK_L_(0x22, 0x6D)
#define REG_SC_BK22_6D_H      _PK_H_(0x22, 0x6D)
#define REG_SC_BK22_6E_L      _PK_L_(0x22, 0x6E)
#define REG_SC_BK22_6E_H      _PK_H_(0x22, 0x6E)
#define REG_SC_BK22_6F_L      _PK_L_(0x22, 0x6F)
#define REG_SC_BK22_6F_H      _PK_H_(0x22, 0x6F)
#define REG_SC_BK22_70_L      _PK_L_(0x22, 0x70)
#define REG_SC_BK22_70_H      _PK_H_(0x22, 0x70)
#define REG_SC_BK22_71_L      _PK_L_(0x22, 0x71)
#define REG_SC_BK22_71_H      _PK_H_(0x22, 0x71)
#define REG_SC_BK22_72_L      _PK_L_(0x22, 0x72)
#define REG_SC_BK22_72_H      _PK_H_(0x22, 0x72)
#define REG_SC_BK22_73_L      _PK_L_(0x22, 0x73)
#define REG_SC_BK22_73_H      _PK_H_(0x22, 0x73)
#define REG_SC_BK22_74_L      _PK_L_(0x22, 0x74)
#define REG_SC_BK22_74_H      _PK_H_(0x22, 0x74)
#define REG_SC_BK22_75_L      _PK_L_(0x22, 0x75)
#define REG_SC_BK22_75_H      _PK_H_(0x22, 0x75)
#define REG_SC_BK22_76_L      _PK_L_(0x22, 0x76)
#define REG_SC_BK22_76_H      _PK_H_(0x22, 0x76)
#define REG_SC_BK22_77_L      _PK_L_(0x22, 0x77)
#define REG_SC_BK22_77_H      _PK_H_(0x22, 0x77)
#define REG_SC_BK22_78_L      _PK_L_(0x22, 0x78)
#define REG_SC_BK22_78_H      _PK_H_(0x22, 0x78)
#define REG_SC_BK22_79_L      _PK_L_(0x22, 0x79)
#define REG_SC_BK22_79_H      _PK_H_(0x22, 0x79)
#define REG_SC_BK22_7A_L      _PK_L_(0x22, 0x7A)
#define REG_SC_BK22_7A_H      _PK_H_(0x22, 0x7A)
#define REG_SC_BK22_7B_L      _PK_L_(0x22, 0x7B)
#define REG_SC_BK22_7B_H      _PK_H_(0x22, 0x7B)
#define REG_SC_BK22_7C_L      _PK_L_(0x22, 0x7C)
#define REG_SC_BK22_7C_H      _PK_H_(0x22, 0x7C)
#define REG_SC_BK22_7D_L      _PK_L_(0x22, 0x7D)
#define REG_SC_BK22_7D_H      _PK_H_(0x22, 0x7D)
#define REG_SC_BK22_7E_L      _PK_L_(0x22, 0x7E)
#define REG_SC_BK22_7E_H      _PK_H_(0x22, 0x7E)
#define REG_SC_BK22_7F_L      _PK_L_(0x22, 0x7F)
#define REG_SC_BK22_7F_H      _PK_H_(0x22, 0x7F)
//----------------------------------------------
#define REG_SC_BK23_00_L      _PK_L_(0x23, 0x00)
#define REG_SC_BK23_00_H      _PK_H_(0x23, 0x00)
#define REG_SC_BK23_01_L      _PK_L_(0x23, 0x01)
#define REG_SC_BK23_01_H      _PK_H_(0x23, 0x01)
#define REG_SC_BK23_02_L      _PK_L_(0x23, 0x02)
#define REG_SC_BK23_02_H      _PK_H_(0x23, 0x02)
#define REG_SC_BK23_03_L      _PK_L_(0x23, 0x03)
#define REG_SC_BK23_03_H      _PK_H_(0x23, 0x03)
#define REG_SC_BK23_04_L      _PK_L_(0x23, 0x04)
#define REG_SC_BK23_04_H      _PK_H_(0x23, 0x04)
#define REG_SC_BK23_05_L      _PK_L_(0x23, 0x05)
#define REG_SC_BK23_05_H      _PK_H_(0x23, 0x05)
#define REG_SC_BK23_06_L      _PK_L_(0x23, 0x06)
#define REG_SC_BK23_06_H      _PK_H_(0x23, 0x06)
#define REG_SC_BK23_07_L      _PK_L_(0x23, 0x07)
#define REG_SC_BK23_07_H      _PK_H_(0x23, 0x07)
#define REG_SC_BK23_08_L      _PK_L_(0x23, 0x08)
#define REG_SC_BK23_08_H      _PK_H_(0x23, 0x08)
#define REG_SC_BK23_09_L      _PK_L_(0x23, 0x09)
#define REG_SC_BK23_09_H      _PK_H_(0x23, 0x09)
#define REG_SC_BK23_0A_L      _PK_L_(0x23, 0x0A)
#define REG_SC_BK23_0A_H      _PK_H_(0x23, 0x0A)
#define REG_SC_BK23_0B_L      _PK_L_(0x23, 0x0B)
#define REG_SC_BK23_0B_H      _PK_H_(0x23, 0x0B)
#define REG_SC_BK23_0C_L      _PK_L_(0x23, 0x0C)
#define REG_SC_BK23_0C_H      _PK_H_(0x23, 0x0C)
#define REG_SC_BK23_0D_L      _PK_L_(0x23, 0x0D)
#define REG_SC_BK23_0D_H      _PK_H_(0x23, 0x0D)
#define REG_SC_BK23_0E_L      _PK_L_(0x23, 0x0E)
#define REG_SC_BK23_0E_H      _PK_H_(0x23, 0x0E)
#define REG_SC_BK23_0F_L      _PK_L_(0x23, 0x0F)
#define REG_SC_BK23_0F_H      _PK_H_(0x23, 0x0F)
#define REG_SC_BK23_10_L      _PK_L_(0x23, 0x10)
#define REG_SC_BK23_10_H      _PK_H_(0x23, 0x10)
#define REG_SC_BK23_11_L      _PK_L_(0x23, 0x11)
#define REG_SC_BK23_11_H      _PK_H_(0x23, 0x11)
#define REG_SC_BK23_12_L      _PK_L_(0x23, 0x12)
#define REG_SC_BK23_12_H      _PK_H_(0x23, 0x12)
#define REG_SC_BK23_13_L      _PK_L_(0x23, 0x13)
#define REG_SC_BK23_13_H      _PK_H_(0x23, 0x13)
#define REG_SC_BK23_14_L      _PK_L_(0x23, 0x14)
#define REG_SC_BK23_14_H      _PK_H_(0x23, 0x14)
#define REG_SC_BK23_15_L      _PK_L_(0x23, 0x15)
#define REG_SC_BK23_15_H      _PK_H_(0x23, 0x15)
#define REG_SC_BK23_16_L      _PK_L_(0x23, 0x16)
#define REG_SC_BK23_16_H      _PK_H_(0x23, 0x16)
#define REG_SC_BK23_17_L      _PK_L_(0x23, 0x17)
#define REG_SC_BK23_17_H      _PK_H_(0x23, 0x17)
#define REG_SC_BK23_18_L      _PK_L_(0x23, 0x18)
#define REG_SC_BK23_18_H      _PK_H_(0x23, 0x18)
#define REG_SC_BK23_19_L      _PK_L_(0x23, 0x19)
#define REG_SC_BK23_19_H      _PK_H_(0x23, 0x19)
#define REG_SC_BK23_1A_L      _PK_L_(0x23, 0x1A)
#define REG_SC_BK23_1A_H      _PK_H_(0x23, 0x1A)
#define REG_SC_BK23_1B_L      _PK_L_(0x23, 0x1B)
#define REG_SC_BK23_1B_H      _PK_H_(0x23, 0x1B)
#define REG_SC_BK23_1C_L      _PK_L_(0x23, 0x1C)
#define REG_SC_BK23_1C_H      _PK_H_(0x23, 0x1C)
#define REG_SC_BK23_1D_L      _PK_L_(0x23, 0x1D)
#define REG_SC_BK23_1D_H      _PK_H_(0x23, 0x1D)
#define REG_SC_BK23_1E_L      _PK_L_(0x23, 0x1E)
#define REG_SC_BK23_1E_H      _PK_H_(0x23, 0x1E)
#define REG_SC_BK23_1F_L      _PK_L_(0x23, 0x1F)
#define REG_SC_BK23_1F_H      _PK_H_(0x23, 0x1F)
#define REG_SC_BK23_20_L      _PK_L_(0x23, 0x20)
#define REG_SC_BK23_20_H      _PK_H_(0x23, 0x20)
#define REG_SC_BK23_21_L      _PK_L_(0x23, 0x21)
#define REG_SC_BK23_21_H      _PK_H_(0x23, 0x21)
#define REG_SC_BK23_22_L      _PK_L_(0x23, 0x22)
#define REG_SC_BK23_22_H      _PK_H_(0x23, 0x22)
#define REG_SC_BK23_23_L      _PK_L_(0x23, 0x23)
#define REG_SC_BK23_23_H      _PK_H_(0x23, 0x23)
#define REG_SC_BK23_24_L      _PK_L_(0x23, 0x24)
#define REG_SC_BK23_24_H      _PK_H_(0x23, 0x24)
#define REG_SC_BK23_25_L      _PK_L_(0x23, 0x25)
#define REG_SC_BK23_25_H      _PK_H_(0x23, 0x25)
#define REG_SC_BK23_26_L      _PK_L_(0x23, 0x26)
#define REG_SC_BK23_26_H      _PK_H_(0x23, 0x26)
#define REG_SC_BK23_27_L      _PK_L_(0x23, 0x27)
#define REG_SC_BK23_27_H      _PK_H_(0x23, 0x27)
#define REG_SC_BK23_28_L      _PK_L_(0x23, 0x28)
#define REG_SC_BK23_28_H      _PK_H_(0x23, 0x28)
#define REG_SC_BK23_29_L      _PK_L_(0x23, 0x29)
#define REG_SC_BK23_29_H      _PK_H_(0x23, 0x29)
#define REG_SC_BK23_2A_L      _PK_L_(0x23, 0x2A)
#define REG_SC_BK23_2A_H      _PK_H_(0x23, 0x2A)
#define REG_SC_BK23_2B_L      _PK_L_(0x23, 0x2B)
#define REG_SC_BK23_2B_H      _PK_H_(0x23, 0x2B)
#define REG_SC_BK23_2C_L      _PK_L_(0x23, 0x2C)
#define REG_SC_BK23_2C_H      _PK_H_(0x23, 0x2C)
#define REG_SC_BK23_2D_L      _PK_L_(0x23, 0x2D)
#define REG_SC_BK23_2D_H      _PK_H_(0x23, 0x2D)
#define REG_SC_BK23_2E_L      _PK_L_(0x23, 0x2E)
#define REG_SC_BK23_2E_H      _PK_H_(0x23, 0x2E)
#define REG_SC_BK23_2F_L      _PK_L_(0x23, 0x2F)
#define REG_SC_BK23_2F_H      _PK_H_(0x23, 0x2F)
#define REG_SC_BK23_30_L      _PK_L_(0x23, 0x30)
#define REG_SC_BK23_30_H      _PK_H_(0x23, 0x30)
#define REG_SC_BK23_31_L      _PK_L_(0x23, 0x31)
#define REG_SC_BK23_31_H      _PK_H_(0x23, 0x31)
#define REG_SC_BK23_32_L      _PK_L_(0x23, 0x32)
#define REG_SC_BK23_32_H      _PK_H_(0x23, 0x32)
#define REG_SC_BK23_33_L      _PK_L_(0x23, 0x33)
#define REG_SC_BK23_33_H      _PK_H_(0x23, 0x33)
#define REG_SC_BK23_34_L      _PK_L_(0x23, 0x34)
#define REG_SC_BK23_34_H      _PK_H_(0x23, 0x34)
#define REG_SC_BK23_35_L      _PK_L_(0x23, 0x35)
#define REG_SC_BK23_35_H      _PK_H_(0x23, 0x35)
#define REG_SC_BK23_36_L      _PK_L_(0x23, 0x36)
#define REG_SC_BK23_36_H      _PK_H_(0x23, 0x36)
#define REG_SC_BK23_37_L      _PK_L_(0x23, 0x37)
#define REG_SC_BK23_37_H      _PK_H_(0x23, 0x37)
#define REG_SC_BK23_38_L      _PK_L_(0x23, 0x38)
#define REG_SC_BK23_38_H      _PK_H_(0x23, 0x38)
#define REG_SC_BK23_39_L      _PK_L_(0x23, 0x39)
#define REG_SC_BK23_39_H      _PK_H_(0x23, 0x39)
#define REG_SC_BK23_3A_L      _PK_L_(0x23, 0x3A)
#define REG_SC_BK23_3A_H      _PK_H_(0x23, 0x3A)
#define REG_SC_BK23_3B_L      _PK_L_(0x23, 0x3B)
#define REG_SC_BK23_3B_H      _PK_H_(0x23, 0x3B)
#define REG_SC_BK23_3C_L      _PK_L_(0x23, 0x3C)
#define REG_SC_BK23_3C_H      _PK_H_(0x23, 0x3C)
#define REG_SC_BK23_3D_L      _PK_L_(0x23, 0x3D)
#define REG_SC_BK23_3D_H      _PK_H_(0x23, 0x3D)
#define REG_SC_BK23_3E_L      _PK_L_(0x23, 0x3E)
#define REG_SC_BK23_3E_H      _PK_H_(0x23, 0x3E)
#define REG_SC_BK23_3F_L      _PK_L_(0x23, 0x3F)
#define REG_SC_BK23_3F_H      _PK_H_(0x23, 0x3F)
#define REG_SC_BK23_40_L      _PK_L_(0x23, 0x40)
#define REG_SC_BK23_40_H      _PK_H_(0x23, 0x40)
#define REG_SC_BK23_41_L      _PK_L_(0x23, 0x41)
#define REG_SC_BK23_41_H      _PK_H_(0x23, 0x41)
#define REG_SC_BK23_42_L      _PK_L_(0x23, 0x42)
#define REG_SC_BK23_42_H      _PK_H_(0x23, 0x42)
#define REG_SC_BK23_43_L      _PK_L_(0x23, 0x43)
#define REG_SC_BK23_43_H      _PK_H_(0x23, 0x43)
#define REG_SC_BK23_44_L      _PK_L_(0x23, 0x44)
#define REG_SC_BK23_44_H      _PK_H_(0x23, 0x44)
#define REG_SC_BK23_45_L      _PK_L_(0x23, 0x45)
#define REG_SC_BK23_45_H      _PK_H_(0x23, 0x45)
#define REG_SC_BK23_46_L      _PK_L_(0x23, 0x46)
#define REG_SC_BK23_46_H      _PK_H_(0x23, 0x46)
#define REG_SC_BK23_47_L      _PK_L_(0x23, 0x47)
#define REG_SC_BK23_47_H      _PK_H_(0x23, 0x47)
#define REG_SC_BK23_48_L      _PK_L_(0x23, 0x48)
#define REG_SC_BK23_48_H      _PK_H_(0x23, 0x48)
#define REG_SC_BK23_49_L      _PK_L_(0x23, 0x49)
#define REG_SC_BK23_49_H      _PK_H_(0x23, 0x49)
#define REG_SC_BK23_4A_L      _PK_L_(0x23, 0x4A)
#define REG_SC_BK23_4A_H      _PK_H_(0x23, 0x4A)
#define REG_SC_BK23_4B_L      _PK_L_(0x23, 0x4B)
#define REG_SC_BK23_4B_H      _PK_H_(0x23, 0x4B)
#define REG_SC_BK23_4C_L      _PK_L_(0x23, 0x4C)
#define REG_SC_BK23_4C_H      _PK_H_(0x23, 0x4C)
#define REG_SC_BK23_4D_L      _PK_L_(0x23, 0x4D)
#define REG_SC_BK23_4D_H      _PK_H_(0x23, 0x4D)
#define REG_SC_BK23_4E_L      _PK_L_(0x23, 0x4E)
#define REG_SC_BK23_4E_H      _PK_H_(0x23, 0x4E)
#define REG_SC_BK23_4F_L      _PK_L_(0x23, 0x4F)
#define REG_SC_BK23_4F_H      _PK_H_(0x23, 0x4F)
#define REG_SC_BK23_50_L      _PK_L_(0x23, 0x50)
#define REG_SC_BK23_50_H      _PK_H_(0x23, 0x50)
#define REG_SC_BK23_51_L      _PK_L_(0x23, 0x51)
#define REG_SC_BK23_51_H      _PK_H_(0x23, 0x51)
#define REG_SC_BK23_52_L      _PK_L_(0x23, 0x52)
#define REG_SC_BK23_52_H      _PK_H_(0x23, 0x52)
#define REG_SC_BK23_53_L      _PK_L_(0x23, 0x53)
#define REG_SC_BK23_53_H      _PK_H_(0x23, 0x53)
#define REG_SC_BK23_54_L      _PK_L_(0x23, 0x54)
#define REG_SC_BK23_54_H      _PK_H_(0x23, 0x54)
#define REG_SC_BK23_55_L      _PK_L_(0x23, 0x55)
#define REG_SC_BK23_55_H      _PK_H_(0x23, 0x55)
#define REG_SC_BK23_56_L      _PK_L_(0x23, 0x56)
#define REG_SC_BK23_56_H      _PK_H_(0x23, 0x56)
#define REG_SC_BK23_57_L      _PK_L_(0x23, 0x57)
#define REG_SC_BK23_57_H      _PK_H_(0x23, 0x57)
#define REG_SC_BK23_58_L      _PK_L_(0x23, 0x58)
#define REG_SC_BK23_58_H      _PK_H_(0x23, 0x58)
#define REG_SC_BK23_59_L      _PK_L_(0x23, 0x59)
#define REG_SC_BK23_59_H      _PK_H_(0x23, 0x59)
#define REG_SC_BK23_5A_L      _PK_L_(0x23, 0x5A)
#define REG_SC_BK23_5A_H      _PK_H_(0x23, 0x5A)
#define REG_SC_BK23_5B_L      _PK_L_(0x23, 0x5B)
#define REG_SC_BK23_5B_H      _PK_H_(0x23, 0x5B)
#define REG_SC_BK23_5C_L      _PK_L_(0x23, 0x5C)
#define REG_SC_BK23_5C_H      _PK_H_(0x23, 0x5C)
#define REG_SC_BK23_5D_L      _PK_L_(0x23, 0x5D)
#define REG_SC_BK23_5D_H      _PK_H_(0x23, 0x5D)
#define REG_SC_BK23_5E_L      _PK_L_(0x23, 0x5E)
#define REG_SC_BK23_5E_H      _PK_H_(0x23, 0x5E)
#define REG_SC_BK23_5F_L      _PK_L_(0x23, 0x5F)
#define REG_SC_BK23_5F_H      _PK_H_(0x23, 0x5F)
#define REG_SC_BK23_60_L      _PK_L_(0x23, 0x60)
#define REG_SC_BK23_60_H      _PK_H_(0x23, 0x60)
#define REG_SC_BK23_61_L      _PK_L_(0x23, 0x61)
#define REG_SC_BK23_61_H      _PK_H_(0x23, 0x61)
#define REG_SC_BK23_62_L      _PK_L_(0x23, 0x62)
#define REG_SC_BK23_62_H      _PK_H_(0x23, 0x62)
#define REG_SC_BK23_63_L      _PK_L_(0x23, 0x63)
#define REG_SC_BK23_63_H      _PK_H_(0x23, 0x63)
#define REG_SC_BK23_64_L      _PK_L_(0x23, 0x64)
#define REG_SC_BK23_64_H      _PK_H_(0x23, 0x64)
#define REG_SC_BK23_65_L      _PK_L_(0x23, 0x65)
#define REG_SC_BK23_65_H      _PK_H_(0x23, 0x65)
#define REG_SC_BK23_66_L      _PK_L_(0x23, 0x66)
#define REG_SC_BK23_66_H      _PK_H_(0x23, 0x66)
#define REG_SC_BK23_67_L      _PK_L_(0x23, 0x67)
#define REG_SC_BK23_67_H      _PK_H_(0x23, 0x67)
#define REG_SC_BK23_68_L      _PK_L_(0x23, 0x68)
#define REG_SC_BK23_68_H      _PK_H_(0x23, 0x68)
#define REG_SC_BK23_69_L      _PK_L_(0x23, 0x69)
#define REG_SC_BK23_69_H      _PK_H_(0x23, 0x69)
#define REG_SC_BK23_6A_L      _PK_L_(0x23, 0x6A)
#define REG_SC_BK23_6A_H      _PK_H_(0x23, 0x6A)
#define REG_SC_BK23_6B_L      _PK_L_(0x23, 0x6B)
#define REG_SC_BK23_6B_H      _PK_H_(0x23, 0x6B)
#define REG_SC_BK23_6C_L      _PK_L_(0x23, 0x6C)
#define REG_SC_BK23_6C_H      _PK_H_(0x23, 0x6C)
#define REG_SC_BK23_6D_L      _PK_L_(0x23, 0x6D)
#define REG_SC_BK23_6D_H      _PK_H_(0x23, 0x6D)
#define REG_SC_BK23_6E_L      _PK_L_(0x23, 0x6E)
#define REG_SC_BK23_6E_H      _PK_H_(0x23, 0x6E)
#define REG_SC_BK23_6F_L      _PK_L_(0x23, 0x6F)
#define REG_SC_BK23_6F_H      _PK_H_(0x23, 0x6F)
#define REG_SC_BK23_70_L      _PK_L_(0x23, 0x70)
#define REG_SC_BK23_70_H      _PK_H_(0x23, 0x70)
#define REG_SC_BK23_71_L      _PK_L_(0x23, 0x71)
#define REG_SC_BK23_71_H      _PK_H_(0x23, 0x71)
#define REG_SC_BK23_72_L      _PK_L_(0x23, 0x72)
#define REG_SC_BK23_72_H      _PK_H_(0x23, 0x72)
#define REG_SC_BK23_73_L      _PK_L_(0x23, 0x73)
#define REG_SC_BK23_73_H      _PK_H_(0x23, 0x73)
#define REG_SC_BK23_74_L      _PK_L_(0x23, 0x74)
#define REG_SC_BK23_74_H      _PK_H_(0x23, 0x74)
#define REG_SC_BK23_75_L      _PK_L_(0x23, 0x75)
#define REG_SC_BK23_75_H      _PK_H_(0x23, 0x75)
#define REG_SC_BK23_76_L      _PK_L_(0x23, 0x76)
#define REG_SC_BK23_76_H      _PK_H_(0x23, 0x76)
#define REG_SC_BK23_77_L      _PK_L_(0x23, 0x77)
#define REG_SC_BK23_77_H      _PK_H_(0x23, 0x77)
#define REG_SC_BK23_78_L      _PK_L_(0x23, 0x78)
#define REG_SC_BK23_78_H      _PK_H_(0x23, 0x78)
#define REG_SC_BK23_79_L      _PK_L_(0x23, 0x79)
#define REG_SC_BK23_79_H      _PK_H_(0x23, 0x79)
#define REG_SC_BK23_7A_L      _PK_L_(0x23, 0x7A)
#define REG_SC_BK23_7A_H      _PK_H_(0x23, 0x7A)
#define REG_SC_BK23_7B_L      _PK_L_(0x23, 0x7B)
#define REG_SC_BK23_7B_H      _PK_H_(0x23, 0x7B)
#define REG_SC_BK23_7C_L      _PK_L_(0x23, 0x7C)
#define REG_SC_BK23_7C_H      _PK_H_(0x23, 0x7C)
#define REG_SC_BK23_7D_L      _PK_L_(0x23, 0x7D)
#define REG_SC_BK23_7D_H      _PK_H_(0x23, 0x7D)
#define REG_SC_BK23_7E_L      _PK_L_(0x23, 0x7E)
#define REG_SC_BK23_7E_H      _PK_H_(0x23, 0x7E)
#define REG_SC_BK23_7F_L      _PK_L_(0x23, 0x7F)
#define REG_SC_BK23_7F_H      _PK_H_(0x23, 0x7F)
//----------------------------------------------
#define REG_SC_BK24_00_L      _PK_L_(0x24, 0x00)
#define REG_SC_BK24_00_H      _PK_H_(0x24, 0x00)
#define REG_SC_BK24_01_L      _PK_L_(0x24, 0x01)
#define REG_SC_BK24_01_H      _PK_H_(0x24, 0x01)
#define REG_SC_BK24_02_L      _PK_L_(0x24, 0x02)
#define REG_SC_BK24_02_H      _PK_H_(0x24, 0x02)
#define REG_SC_BK24_03_L      _PK_L_(0x24, 0x03)
#define REG_SC_BK24_03_H      _PK_H_(0x24, 0x03)
#define REG_SC_BK24_04_L      _PK_L_(0x24, 0x04)
#define REG_SC_BK24_04_H      _PK_H_(0x24, 0x04)
#define REG_SC_BK24_05_L      _PK_L_(0x24, 0x05)
#define REG_SC_BK24_05_H      _PK_H_(0x24, 0x05)
#define REG_SC_BK24_06_L      _PK_L_(0x24, 0x06)
#define REG_SC_BK24_06_H      _PK_H_(0x24, 0x06)
#define REG_SC_BK24_07_L      _PK_L_(0x24, 0x07)
#define REG_SC_BK24_07_H      _PK_H_(0x24, 0x07)
#define REG_SC_BK24_08_L      _PK_L_(0x24, 0x08)
#define REG_SC_BK24_08_H      _PK_H_(0x24, 0x08)
#define REG_SC_BK24_09_L      _PK_L_(0x24, 0x09)
#define REG_SC_BK24_09_H      _PK_H_(0x24, 0x09)
#define REG_SC_BK24_0A_L      _PK_L_(0x24, 0x0A)
#define REG_SC_BK24_0A_H      _PK_H_(0x24, 0x0A)
#define REG_SC_BK24_0B_L      _PK_L_(0x24, 0x0B)
#define REG_SC_BK24_0B_H      _PK_H_(0x24, 0x0B)
#define REG_SC_BK24_0C_L      _PK_L_(0x24, 0x0C)
#define REG_SC_BK24_0C_H      _PK_H_(0x24, 0x0C)
#define REG_SC_BK24_0D_L      _PK_L_(0x24, 0x0D)
#define REG_SC_BK24_0D_H      _PK_H_(0x24, 0x0D)
#define REG_SC_BK24_0E_L      _PK_L_(0x24, 0x0E)
#define REG_SC_BK24_0E_H      _PK_H_(0x24, 0x0E)
#define REG_SC_BK24_0F_L      _PK_L_(0x24, 0x0F)
#define REG_SC_BK24_0F_H      _PK_H_(0x24, 0x0F)
#define REG_SC_BK24_10_L      _PK_L_(0x24, 0x10)
#define REG_SC_BK24_10_H      _PK_H_(0x24, 0x10)
#define REG_SC_BK24_11_L      _PK_L_(0x24, 0x11)
#define REG_SC_BK24_11_H      _PK_H_(0x24, 0x11)
#define REG_SC_BK24_12_L      _PK_L_(0x24, 0x12)
#define REG_SC_BK24_12_H      _PK_H_(0x24, 0x12)
#define REG_SC_BK24_13_L      _PK_L_(0x24, 0x13)
#define REG_SC_BK24_13_H      _PK_H_(0x24, 0x13)
#define REG_SC_BK24_14_L      _PK_L_(0x24, 0x14)
#define REG_SC_BK24_14_H      _PK_H_(0x24, 0x14)
#define REG_SC_BK24_15_L      _PK_L_(0x24, 0x15)
#define REG_SC_BK24_15_H      _PK_H_(0x24, 0x15)
#define REG_SC_BK24_16_L      _PK_L_(0x24, 0x16)
#define REG_SC_BK24_16_H      _PK_H_(0x24, 0x16)
#define REG_SC_BK24_17_L      _PK_L_(0x24, 0x17)
#define REG_SC_BK24_17_H      _PK_H_(0x24, 0x17)
#define REG_SC_BK24_18_L      _PK_L_(0x24, 0x18)
#define REG_SC_BK24_18_H      _PK_H_(0x24, 0x18)
#define REG_SC_BK24_19_L      _PK_L_(0x24, 0x19)
#define REG_SC_BK24_19_H      _PK_H_(0x24, 0x19)
#define REG_SC_BK24_1A_L      _PK_L_(0x24, 0x1A)
#define REG_SC_BK24_1A_H      _PK_H_(0x24, 0x1A)
#define REG_SC_BK24_1B_L      _PK_L_(0x24, 0x1B)
#define REG_SC_BK24_1B_H      _PK_H_(0x24, 0x1B)
#define REG_SC_BK24_1C_L      _PK_L_(0x24, 0x1C)
#define REG_SC_BK24_1C_H      _PK_H_(0x24, 0x1C)
#define REG_SC_BK24_1D_L      _PK_L_(0x24, 0x1D)
#define REG_SC_BK24_1D_H      _PK_H_(0x24, 0x1D)
#define REG_SC_BK24_1E_L      _PK_L_(0x24, 0x1E)
#define REG_SC_BK24_1E_H      _PK_H_(0x24, 0x1E)
#define REG_SC_BK24_1F_L      _PK_L_(0x24, 0x1F)
#define REG_SC_BK24_1F_H      _PK_H_(0x24, 0x1F)
#define REG_SC_BK24_20_L      _PK_L_(0x24, 0x20)
#define REG_SC_BK24_20_H      _PK_H_(0x24, 0x20)
#define REG_SC_BK24_21_L      _PK_L_(0x24, 0x21)
#define REG_SC_BK24_21_H      _PK_H_(0x24, 0x21)
#define REG_SC_BK24_22_L      _PK_L_(0x24, 0x22)
#define REG_SC_BK24_22_H      _PK_H_(0x24, 0x22)
#define REG_SC_BK24_23_L      _PK_L_(0x24, 0x23)
#define REG_SC_BK24_23_H      _PK_H_(0x24, 0x23)
#define REG_SC_BK24_24_L      _PK_L_(0x24, 0x24)
#define REG_SC_BK24_24_H      _PK_H_(0x24, 0x24)
#define REG_SC_BK24_25_L      _PK_L_(0x24, 0x25)
#define REG_SC_BK24_25_H      _PK_H_(0x24, 0x25)
#define REG_SC_BK24_26_L      _PK_L_(0x24, 0x26)
#define REG_SC_BK24_26_H      _PK_H_(0x24, 0x26)
#define REG_SC_BK24_27_L      _PK_L_(0x24, 0x27)
#define REG_SC_BK24_27_H      _PK_H_(0x24, 0x27)
#define REG_SC_BK24_28_L      _PK_L_(0x24, 0x28)
#define REG_SC_BK24_28_H      _PK_H_(0x24, 0x28)
#define REG_SC_BK24_29_L      _PK_L_(0x24, 0x29)
#define REG_SC_BK24_29_H      _PK_H_(0x24, 0x29)
#define REG_SC_BK24_2A_L      _PK_L_(0x24, 0x2A)
#define REG_SC_BK24_2A_H      _PK_H_(0x24, 0x2A)
#define REG_SC_BK24_2B_L      _PK_L_(0x24, 0x2B)
#define REG_SC_BK24_2B_H      _PK_H_(0x24, 0x2B)
#define REG_SC_BK24_2C_L      _PK_L_(0x24, 0x2C)
#define REG_SC_BK24_2C_H      _PK_H_(0x24, 0x2C)
#define REG_SC_BK24_2D_L      _PK_L_(0x24, 0x2D)
#define REG_SC_BK24_2D_H      _PK_H_(0x24, 0x2D)
#define REG_SC_BK24_2E_L      _PK_L_(0x24, 0x2E)
#define REG_SC_BK24_2E_H      _PK_H_(0x24, 0x2E)
#define REG_SC_BK24_2F_L      _PK_L_(0x24, 0x2F)
#define REG_SC_BK24_2F_H      _PK_H_(0x24, 0x2F)
#define REG_SC_BK24_30_L      _PK_L_(0x24, 0x30)
#define REG_SC_BK24_30_H      _PK_H_(0x24, 0x30)
#define REG_SC_BK24_31_L      _PK_L_(0x24, 0x31)
#define REG_SC_BK24_31_H      _PK_H_(0x24, 0x31)
#define REG_SC_BK24_32_L      _PK_L_(0x24, 0x32)
#define REG_SC_BK24_32_H      _PK_H_(0x24, 0x32)
#define REG_SC_BK24_33_L      _PK_L_(0x24, 0x33)
#define REG_SC_BK24_33_H      _PK_H_(0x24, 0x33)
#define REG_SC_BK24_34_L      _PK_L_(0x24, 0x34)
#define REG_SC_BK24_34_H      _PK_H_(0x24, 0x34)
#define REG_SC_BK24_35_L      _PK_L_(0x24, 0x35)
#define REG_SC_BK24_35_H      _PK_H_(0x24, 0x35)
#define REG_SC_BK24_36_L      _PK_L_(0x24, 0x36)
#define REG_SC_BK24_36_H      _PK_H_(0x24, 0x36)
#define REG_SC_BK24_37_L      _PK_L_(0x24, 0x37)
#define REG_SC_BK24_37_H      _PK_H_(0x24, 0x37)
#define REG_SC_BK24_38_L      _PK_L_(0x24, 0x38)
#define REG_SC_BK24_38_H      _PK_H_(0x24, 0x38)
#define REG_SC_BK24_39_L      _PK_L_(0x24, 0x39)
#define REG_SC_BK24_39_H      _PK_H_(0x24, 0x39)
#define REG_SC_BK24_3A_L      _PK_L_(0x24, 0x3A)
#define REG_SC_BK24_3A_H      _PK_H_(0x24, 0x3A)
#define REG_SC_BK24_3B_L      _PK_L_(0x24, 0x3B)
#define REG_SC_BK24_3B_H      _PK_H_(0x24, 0x3B)
#define REG_SC_BK24_3C_L      _PK_L_(0x24, 0x3C)
#define REG_SC_BK24_3C_H      _PK_H_(0x24, 0x3C)
#define REG_SC_BK24_3D_L      _PK_L_(0x24, 0x3D)
#define REG_SC_BK24_3D_H      _PK_H_(0x24, 0x3D)
#define REG_SC_BK24_3E_L      _PK_L_(0x24, 0x3E)
#define REG_SC_BK24_3E_H      _PK_H_(0x24, 0x3E)
#define REG_SC_BK24_3F_L      _PK_L_(0x24, 0x3F)
#define REG_SC_BK24_3F_H      _PK_H_(0x24, 0x3F)
#define REG_SC_BK24_40_L      _PK_L_(0x24, 0x40)
#define REG_SC_BK24_40_H      _PK_H_(0x24, 0x40)
#define REG_SC_BK24_41_L      _PK_L_(0x24, 0x41)
#define REG_SC_BK24_41_H      _PK_H_(0x24, 0x41)
#define REG_SC_BK24_42_L      _PK_L_(0x24, 0x42)
#define REG_SC_BK24_42_H      _PK_H_(0x24, 0x42)
#define REG_SC_BK24_43_L      _PK_L_(0x24, 0x43)
#define REG_SC_BK24_43_H      _PK_H_(0x24, 0x43)
#define REG_SC_BK24_44_L      _PK_L_(0x24, 0x44)
#define REG_SC_BK24_44_H      _PK_H_(0x24, 0x44)
#define REG_SC_BK24_45_L      _PK_L_(0x24, 0x45)
#define REG_SC_BK24_45_H      _PK_H_(0x24, 0x45)
#define REG_SC_BK24_46_L      _PK_L_(0x24, 0x46)
#define REG_SC_BK24_46_H      _PK_H_(0x24, 0x46)
#define REG_SC_BK24_47_L      _PK_L_(0x24, 0x47)
#define REG_SC_BK24_47_H      _PK_H_(0x24, 0x47)
#define REG_SC_BK24_48_L      _PK_L_(0x24, 0x48)
#define REG_SC_BK24_48_H      _PK_H_(0x24, 0x48)
#define REG_SC_BK24_49_L      _PK_L_(0x24, 0x49)
#define REG_SC_BK24_49_H      _PK_H_(0x24, 0x49)
#define REG_SC_BK24_4A_L      _PK_L_(0x24, 0x4A)
#define REG_SC_BK24_4A_H      _PK_H_(0x24, 0x4A)
#define REG_SC_BK24_4B_L      _PK_L_(0x24, 0x4B)
#define REG_SC_BK24_4B_H      _PK_H_(0x24, 0x4B)
#define REG_SC_BK24_4C_L      _PK_L_(0x24, 0x4C)
#define REG_SC_BK24_4C_H      _PK_H_(0x24, 0x4C)
#define REG_SC_BK24_4D_L      _PK_L_(0x24, 0x4D)
#define REG_SC_BK24_4D_H      _PK_H_(0x24, 0x4D)
#define REG_SC_BK24_4E_L      _PK_L_(0x24, 0x4E)
#define REG_SC_BK24_4E_H      _PK_H_(0x24, 0x4E)
#define REG_SC_BK24_4F_L      _PK_L_(0x24, 0x4F)
#define REG_SC_BK24_4F_H      _PK_H_(0x24, 0x4F)
#define REG_SC_BK24_50_L      _PK_L_(0x24, 0x50)
#define REG_SC_BK24_50_H      _PK_H_(0x24, 0x50)
#define REG_SC_BK24_51_L      _PK_L_(0x24, 0x51)
#define REG_SC_BK24_51_H      _PK_H_(0x24, 0x51)
#define REG_SC_BK24_52_L      _PK_L_(0x24, 0x52)
#define REG_SC_BK24_52_H      _PK_H_(0x24, 0x52)
#define REG_SC_BK24_53_L      _PK_L_(0x24, 0x53)
#define REG_SC_BK24_53_H      _PK_H_(0x24, 0x53)
#define REG_SC_BK24_54_L      _PK_L_(0x24, 0x54)
#define REG_SC_BK24_54_H      _PK_H_(0x24, 0x54)
#define REG_SC_BK24_55_L      _PK_L_(0x24, 0x55)
#define REG_SC_BK24_55_H      _PK_H_(0x24, 0x55)
#define REG_SC_BK24_56_L      _PK_L_(0x24, 0x56)
#define REG_SC_BK24_56_H      _PK_H_(0x24, 0x56)
#define REG_SC_BK24_57_L      _PK_L_(0x24, 0x57)
#define REG_SC_BK24_57_H      _PK_H_(0x24, 0x57)
#define REG_SC_BK24_58_L      _PK_L_(0x24, 0x58)
#define REG_SC_BK24_58_H      _PK_H_(0x24, 0x58)
#define REG_SC_BK24_59_L      _PK_L_(0x24, 0x59)
#define REG_SC_BK24_59_H      _PK_H_(0x24, 0x59)
#define REG_SC_BK24_5A_L      _PK_L_(0x24, 0x5A)
#define REG_SC_BK24_5A_H      _PK_H_(0x24, 0x5A)
#define REG_SC_BK24_5B_L      _PK_L_(0x24, 0x5B)
#define REG_SC_BK24_5B_H      _PK_H_(0x24, 0x5B)
#define REG_SC_BK24_5C_L      _PK_L_(0x24, 0x5C)
#define REG_SC_BK24_5C_H      _PK_H_(0x24, 0x5C)
#define REG_SC_BK24_5D_L      _PK_L_(0x24, 0x5D)
#define REG_SC_BK24_5D_H      _PK_H_(0x24, 0x5D)
#define REG_SC_BK24_5E_L      _PK_L_(0x24, 0x5E)
#define REG_SC_BK24_5E_H      _PK_H_(0x24, 0x5E)
#define REG_SC_BK24_5F_L      _PK_L_(0x24, 0x5F)
#define REG_SC_BK24_5F_H      _PK_H_(0x24, 0x5F)
#define REG_SC_BK24_60_L      _PK_L_(0x24, 0x60)
#define REG_SC_BK24_60_H      _PK_H_(0x24, 0x60)
#define REG_SC_BK24_61_L      _PK_L_(0x24, 0x61)
#define REG_SC_BK24_61_H      _PK_H_(0x24, 0x61)
#define REG_SC_BK24_62_L      _PK_L_(0x24, 0x62)
#define REG_SC_BK24_62_H      _PK_H_(0x24, 0x62)
#define REG_SC_BK24_63_L      _PK_L_(0x24, 0x63)
#define REG_SC_BK24_63_H      _PK_H_(0x24, 0x63)
#define REG_SC_BK24_64_L      _PK_L_(0x24, 0x64)
#define REG_SC_BK24_64_H      _PK_H_(0x24, 0x64)
#define REG_SC_BK24_65_L      _PK_L_(0x24, 0x65)
#define REG_SC_BK24_65_H      _PK_H_(0x24, 0x65)
#define REG_SC_BK24_66_L      _PK_L_(0x24, 0x66)
#define REG_SC_BK24_66_H      _PK_H_(0x24, 0x66)
#define REG_SC_BK24_67_L      _PK_L_(0x24, 0x67)
#define REG_SC_BK24_67_H      _PK_H_(0x24, 0x67)
#define REG_SC_BK24_68_L      _PK_L_(0x24, 0x68)
#define REG_SC_BK24_68_H      _PK_H_(0x24, 0x68)
#define REG_SC_BK24_69_L      _PK_L_(0x24, 0x69)
#define REG_SC_BK24_69_H      _PK_H_(0x24, 0x69)
#define REG_SC_BK24_6A_L      _PK_L_(0x24, 0x6A)
#define REG_SC_BK24_6A_H      _PK_H_(0x24, 0x6A)
#define REG_SC_BK24_6B_L      _PK_L_(0x24, 0x6B)
#define REG_SC_BK24_6B_H      _PK_H_(0x24, 0x6B)
#define REG_SC_BK24_6C_L      _PK_L_(0x24, 0x6C)
#define REG_SC_BK24_6C_H      _PK_H_(0x24, 0x6C)
#define REG_SC_BK24_6D_L      _PK_L_(0x24, 0x6D)
#define REG_SC_BK24_6D_H      _PK_H_(0x24, 0x6D)
#define REG_SC_BK24_6E_L      _PK_L_(0x24, 0x6E)
#define REG_SC_BK24_6E_H      _PK_H_(0x24, 0x6E)
#define REG_SC_BK24_6F_L      _PK_L_(0x24, 0x6F)
#define REG_SC_BK24_6F_H      _PK_H_(0x24, 0x6F)
#define REG_SC_BK24_70_L      _PK_L_(0x24, 0x70)
#define REG_SC_BK24_70_H      _PK_H_(0x24, 0x70)
#define REG_SC_BK24_71_L      _PK_L_(0x24, 0x71)
#define REG_SC_BK24_71_H      _PK_H_(0x24, 0x71)
#define REG_SC_BK24_72_L      _PK_L_(0x24, 0x72)
#define REG_SC_BK24_72_H      _PK_H_(0x24, 0x72)
#define REG_SC_BK24_73_L      _PK_L_(0x24, 0x73)
#define REG_SC_BK24_73_H      _PK_H_(0x24, 0x73)
#define REG_SC_BK24_74_L      _PK_L_(0x24, 0x74)
#define REG_SC_BK24_74_H      _PK_H_(0x24, 0x74)
#define REG_SC_BK24_75_L      _PK_L_(0x24, 0x75)
#define REG_SC_BK24_75_H      _PK_H_(0x24, 0x75)
#define REG_SC_BK24_76_L      _PK_L_(0x24, 0x76)
#define REG_SC_BK24_76_H      _PK_H_(0x24, 0x76)
#define REG_SC_BK24_77_L      _PK_L_(0x24, 0x77)
#define REG_SC_BK24_77_H      _PK_H_(0x24, 0x77)
#define REG_SC_BK24_78_L      _PK_L_(0x24, 0x78)
#define REG_SC_BK24_78_H      _PK_H_(0x24, 0x78)
#define REG_SC_BK24_79_L      _PK_L_(0x24, 0x79)
#define REG_SC_BK24_79_H      _PK_H_(0x24, 0x79)
#define REG_SC_BK24_7A_L      _PK_L_(0x24, 0x7A)
#define REG_SC_BK24_7A_H      _PK_H_(0x24, 0x7A)
#define REG_SC_BK24_7B_L      _PK_L_(0x24, 0x7B)
#define REG_SC_BK24_7B_H      _PK_H_(0x24, 0x7B)
#define REG_SC_BK24_7C_L      _PK_L_(0x24, 0x7C)
#define REG_SC_BK24_7C_H      _PK_H_(0x24, 0x7C)
#define REG_SC_BK24_7D_L      _PK_L_(0x24, 0x7D)
#define REG_SC_BK24_7D_H      _PK_H_(0x24, 0x7D)
#define REG_SC_BK24_7E_L      _PK_L_(0x24, 0x7E)
#define REG_SC_BK24_7E_H      _PK_H_(0x24, 0x7E)
#define REG_SC_BK24_7F_L      _PK_L_(0x24, 0x7F)
#define REG_SC_BK24_7F_H      _PK_H_(0x24, 0x7F)
//----------------------------------------------
#define REG_SC_BK25_00_L      _PK_L_(0x25, 0x00)
#define REG_SC_BK25_00_H      _PK_H_(0x25, 0x00)
#define REG_SC_BK25_01_L      _PK_L_(0x25, 0x01)
#define REG_SC_BK25_01_H      _PK_H_(0x25, 0x01)
#define REG_SC_BK25_02_L      _PK_L_(0x25, 0x02)
#define REG_SC_BK25_02_H      _PK_H_(0x25, 0x02)
#define REG_SC_BK25_03_L      _PK_L_(0x25, 0x03)
#define REG_SC_BK25_03_H      _PK_H_(0x25, 0x03)
#define REG_SC_BK25_04_L      _PK_L_(0x25, 0x04)
#define REG_SC_BK25_04_H      _PK_H_(0x25, 0x04)
#define REG_SC_BK25_05_L      _PK_L_(0x25, 0x05)
#define REG_SC_BK25_05_H      _PK_H_(0x25, 0x05)
#define REG_SC_BK25_06_L      _PK_L_(0x25, 0x06)
#define REG_SC_BK25_06_H      _PK_H_(0x25, 0x06)
#define REG_SC_BK25_07_L      _PK_L_(0x25, 0x07)
#define REG_SC_BK25_07_H      _PK_H_(0x25, 0x07)
#define REG_SC_BK25_08_L      _PK_L_(0x25, 0x08)
#define REG_SC_BK25_08_H      _PK_H_(0x25, 0x08)
#define REG_SC_BK25_09_L      _PK_L_(0x25, 0x09)
#define REG_SC_BK25_09_H      _PK_H_(0x25, 0x09)
#define REG_SC_BK25_0A_L      _PK_L_(0x25, 0x0A)
#define REG_SC_BK25_0A_H      _PK_H_(0x25, 0x0A)
#define REG_SC_BK25_0B_L      _PK_L_(0x25, 0x0B)
#define REG_SC_BK25_0B_H      _PK_H_(0x25, 0x0B)
#define REG_SC_BK25_0C_L      _PK_L_(0x25, 0x0C)
#define REG_SC_BK25_0C_H      _PK_H_(0x25, 0x0C)
#define REG_SC_BK25_0D_L      _PK_L_(0x25, 0x0D)
#define REG_SC_BK25_0D_H      _PK_H_(0x25, 0x0D)
#define REG_SC_BK25_0E_L      _PK_L_(0x25, 0x0E)
#define REG_SC_BK25_0E_H      _PK_H_(0x25, 0x0E)
#define REG_SC_BK25_0F_L      _PK_L_(0x25, 0x0F)
#define REG_SC_BK25_0F_H      _PK_H_(0x25, 0x0F)
#define REG_SC_BK25_10_L      _PK_L_(0x25, 0x10)
#define REG_SC_BK25_10_H      _PK_H_(0x25, 0x10)
#define REG_SC_BK25_11_L      _PK_L_(0x25, 0x11)
#define REG_SC_BK25_11_H      _PK_H_(0x25, 0x11)
#define REG_SC_BK25_12_L      _PK_L_(0x25, 0x12)
#define REG_SC_BK25_12_H      _PK_H_(0x25, 0x12)
#define REG_SC_BK25_13_L      _PK_L_(0x25, 0x13)
#define REG_SC_BK25_13_H      _PK_H_(0x25, 0x13)
#define REG_SC_BK25_14_L      _PK_L_(0x25, 0x14)
#define REG_SC_BK25_14_H      _PK_H_(0x25, 0x14)
#define REG_SC_BK25_15_L      _PK_L_(0x25, 0x15)
#define REG_SC_BK25_15_H      _PK_H_(0x25, 0x15)
#define REG_SC_BK25_16_L      _PK_L_(0x25, 0x16)
#define REG_SC_BK25_16_H      _PK_H_(0x25, 0x16)
#define REG_SC_BK25_17_L      _PK_L_(0x25, 0x17)
#define REG_SC_BK25_17_H      _PK_H_(0x25, 0x17)
#define REG_SC_BK25_18_L      _PK_L_(0x25, 0x18)
#define REG_SC_BK25_18_H      _PK_H_(0x25, 0x18)
#define REG_SC_BK25_19_L      _PK_L_(0x25, 0x19)
#define REG_SC_BK25_19_H      _PK_H_(0x25, 0x19)
#define REG_SC_BK25_1A_L      _PK_L_(0x25, 0x1A)
#define REG_SC_BK25_1A_H      _PK_H_(0x25, 0x1A)
#define REG_SC_BK25_1B_L      _PK_L_(0x25, 0x1B)
#define REG_SC_BK25_1B_H      _PK_H_(0x25, 0x1B)
#define REG_SC_BK25_1C_L      _PK_L_(0x25, 0x1C)
#define REG_SC_BK25_1C_H      _PK_H_(0x25, 0x1C)
#define REG_SC_BK25_1D_L      _PK_L_(0x25, 0x1D)
#define REG_SC_BK25_1D_H      _PK_H_(0x25, 0x1D)
#define REG_SC_BK25_1E_L      _PK_L_(0x25, 0x1E)
#define REG_SC_BK25_1E_H      _PK_H_(0x25, 0x1E)
#define REG_SC_BK25_1F_L      _PK_L_(0x25, 0x1F)
#define REG_SC_BK25_1F_H      _PK_H_(0x25, 0x1F)
#define REG_SC_BK25_20_L      _PK_L_(0x25, 0x20)
#define REG_SC_BK25_20_H      _PK_H_(0x25, 0x20)
#define REG_SC_BK25_21_L      _PK_L_(0x25, 0x21)
#define REG_SC_BK25_21_H      _PK_H_(0x25, 0x21)
#define REG_SC_BK25_22_L      _PK_L_(0x25, 0x22)
#define REG_SC_BK25_22_H      _PK_H_(0x25, 0x22)
#define REG_SC_BK25_23_L      _PK_L_(0x25, 0x23)
#define REG_SC_BK25_23_H      _PK_H_(0x25, 0x23)
#define REG_SC_BK25_24_L      _PK_L_(0x25, 0x24)
#define REG_SC_BK25_24_H      _PK_H_(0x25, 0x24)
#define REG_SC_BK25_25_L      _PK_L_(0x25, 0x25)
#define REG_SC_BK25_25_H      _PK_H_(0x25, 0x25)
#define REG_SC_BK25_26_L      _PK_L_(0x25, 0x26)
#define REG_SC_BK25_26_H      _PK_H_(0x25, 0x26)
#define REG_SC_BK25_27_L      _PK_L_(0x25, 0x27)
#define REG_SC_BK25_27_H      _PK_H_(0x25, 0x27)
#define REG_SC_BK25_28_L      _PK_L_(0x25, 0x28)
#define REG_SC_BK25_28_H      _PK_H_(0x25, 0x28)
#define REG_SC_BK25_29_L      _PK_L_(0x25, 0x29)
#define REG_SC_BK25_29_H      _PK_H_(0x25, 0x29)
#define REG_SC_BK25_2A_L      _PK_L_(0x25, 0x2A)
#define REG_SC_BK25_2A_H      _PK_H_(0x25, 0x2A)
#define REG_SC_BK25_2B_L      _PK_L_(0x25, 0x2B)
#define REG_SC_BK25_2B_H      _PK_H_(0x25, 0x2B)
#define REG_SC_BK25_2C_L      _PK_L_(0x25, 0x2C)
#define REG_SC_BK25_2C_H      _PK_H_(0x25, 0x2C)
#define REG_SC_BK25_2D_L      _PK_L_(0x25, 0x2D)
#define REG_SC_BK25_2D_H      _PK_H_(0x25, 0x2D)
#define REG_SC_BK25_2E_L      _PK_L_(0x25, 0x2E)
#define REG_SC_BK25_2E_H      _PK_H_(0x25, 0x2E)
#define REG_SC_BK25_2F_L      _PK_L_(0x25, 0x2F)
#define REG_SC_BK25_2F_H      _PK_H_(0x25, 0x2F)
#define REG_SC_BK25_30_L      _PK_L_(0x25, 0x30)
#define REG_SC_BK25_30_H      _PK_H_(0x25, 0x30)
#define REG_SC_BK25_31_L      _PK_L_(0x25, 0x31)
#define REG_SC_BK25_31_H      _PK_H_(0x25, 0x31)
#define REG_SC_BK25_32_L      _PK_L_(0x25, 0x32)
#define REG_SC_BK25_32_H      _PK_H_(0x25, 0x32)
#define REG_SC_BK25_33_L      _PK_L_(0x25, 0x33)
#define REG_SC_BK25_33_H      _PK_H_(0x25, 0x33)
#define REG_SC_BK25_34_L      _PK_L_(0x25, 0x34)
#define REG_SC_BK25_34_H      _PK_H_(0x25, 0x34)
#define REG_SC_BK25_35_L      _PK_L_(0x25, 0x35)
#define REG_SC_BK25_35_H      _PK_H_(0x25, 0x35)
#define REG_SC_BK25_36_L      _PK_L_(0x25, 0x36)
#define REG_SC_BK25_36_H      _PK_H_(0x25, 0x36)
#define REG_SC_BK25_37_L      _PK_L_(0x25, 0x37)
#define REG_SC_BK25_37_H      _PK_H_(0x25, 0x37)
#define REG_SC_BK25_38_L      _PK_L_(0x25, 0x38)
#define REG_SC_BK25_38_H      _PK_H_(0x25, 0x38)
#define REG_SC_BK25_39_L      _PK_L_(0x25, 0x39)
#define REG_SC_BK25_39_H      _PK_H_(0x25, 0x39)
#define REG_SC_BK25_3A_L      _PK_L_(0x25, 0x3A)
#define REG_SC_BK25_3A_H      _PK_H_(0x25, 0x3A)
#define REG_SC_BK25_3B_L      _PK_L_(0x25, 0x3B)
#define REG_SC_BK25_3B_H      _PK_H_(0x25, 0x3B)
#define REG_SC_BK25_3C_L      _PK_L_(0x25, 0x3C)
#define REG_SC_BK25_3C_H      _PK_H_(0x25, 0x3C)
#define REG_SC_BK25_3D_L      _PK_L_(0x25, 0x3D)
#define REG_SC_BK25_3D_H      _PK_H_(0x25, 0x3D)
#define REG_SC_BK25_3E_L      _PK_L_(0x25, 0x3E)
#define REG_SC_BK25_3E_H      _PK_H_(0x25, 0x3E)
#define REG_SC_BK25_3F_L      _PK_L_(0x25, 0x3F)
#define REG_SC_BK25_3F_H      _PK_H_(0x25, 0x3F)
#define REG_SC_BK25_40_L      _PK_L_(0x25, 0x40)
#define REG_SC_BK25_40_H      _PK_H_(0x25, 0x40)
#define REG_SC_BK25_41_L      _PK_L_(0x25, 0x41)
#define REG_SC_BK25_41_H      _PK_H_(0x25, 0x41)
#define REG_SC_BK25_42_L      _PK_L_(0x25, 0x42)
#define REG_SC_BK25_42_H      _PK_H_(0x25, 0x42)
#define REG_SC_BK25_43_L      _PK_L_(0x25, 0x43)
#define REG_SC_BK25_43_H      _PK_H_(0x25, 0x43)
#define REG_SC_BK25_44_L      _PK_L_(0x25, 0x44)
#define REG_SC_BK25_44_H      _PK_H_(0x25, 0x44)
#define REG_SC_BK25_45_L      _PK_L_(0x25, 0x45)
#define REG_SC_BK25_45_H      _PK_H_(0x25, 0x45)
#define REG_SC_BK25_46_L      _PK_L_(0x25, 0x46)
#define REG_SC_BK25_46_H      _PK_H_(0x25, 0x46)
#define REG_SC_BK25_47_L      _PK_L_(0x25, 0x47)
#define REG_SC_BK25_47_H      _PK_H_(0x25, 0x47)
#define REG_SC_BK25_48_L      _PK_L_(0x25, 0x48)
#define REG_SC_BK25_48_H      _PK_H_(0x25, 0x48)
#define REG_SC_BK25_49_L      _PK_L_(0x25, 0x49)
#define REG_SC_BK25_49_H      _PK_H_(0x25, 0x49)
#define REG_SC_BK25_4A_L      _PK_L_(0x25, 0x4A)
#define REG_SC_BK25_4A_H      _PK_H_(0x25, 0x4A)
#define REG_SC_BK25_4B_L      _PK_L_(0x25, 0x4B)
#define REG_SC_BK25_4B_H      _PK_H_(0x25, 0x4B)
#define REG_SC_BK25_4C_L      _PK_L_(0x25, 0x4C)
#define REG_SC_BK25_4C_H      _PK_H_(0x25, 0x4C)
#define REG_SC_BK25_4D_L      _PK_L_(0x25, 0x4D)
#define REG_SC_BK25_4D_H      _PK_H_(0x25, 0x4D)
#define REG_SC_BK25_4E_L      _PK_L_(0x25, 0x4E)
#define REG_SC_BK25_4E_H      _PK_H_(0x25, 0x4E)
#define REG_SC_BK25_4F_L      _PK_L_(0x25, 0x4F)
#define REG_SC_BK25_4F_H      _PK_H_(0x25, 0x4F)
#define REG_SC_BK25_50_L      _PK_L_(0x25, 0x50)
#define REG_SC_BK25_50_H      _PK_H_(0x25, 0x50)
#define REG_SC_BK25_51_L      _PK_L_(0x25, 0x51)
#define REG_SC_BK25_51_H      _PK_H_(0x25, 0x51)
#define REG_SC_BK25_52_L      _PK_L_(0x25, 0x52)
#define REG_SC_BK25_52_H      _PK_H_(0x25, 0x52)
#define REG_SC_BK25_53_L      _PK_L_(0x25, 0x53)
#define REG_SC_BK25_53_H      _PK_H_(0x25, 0x53)
#define REG_SC_BK25_54_L      _PK_L_(0x25, 0x54)
#define REG_SC_BK25_54_H      _PK_H_(0x25, 0x54)
#define REG_SC_BK25_55_L      _PK_L_(0x25, 0x55)
#define REG_SC_BK25_55_H      _PK_H_(0x25, 0x55)
#define REG_SC_BK25_56_L      _PK_L_(0x25, 0x56)
#define REG_SC_BK25_56_H      _PK_H_(0x25, 0x56)
#define REG_SC_BK25_57_L      _PK_L_(0x25, 0x57)
#define REG_SC_BK25_57_H      _PK_H_(0x25, 0x57)
#define REG_SC_BK25_58_L      _PK_L_(0x25, 0x58)
#define REG_SC_BK25_58_H      _PK_H_(0x25, 0x58)
#define REG_SC_BK25_59_L      _PK_L_(0x25, 0x59)
#define REG_SC_BK25_59_H      _PK_H_(0x25, 0x59)
#define REG_SC_BK25_5A_L      _PK_L_(0x25, 0x5A)
#define REG_SC_BK25_5A_H      _PK_H_(0x25, 0x5A)
#define REG_SC_BK25_5B_L      _PK_L_(0x25, 0x5B)
#define REG_SC_BK25_5B_H      _PK_H_(0x25, 0x5B)
#define REG_SC_BK25_5C_L      _PK_L_(0x25, 0x5C)
#define REG_SC_BK25_5C_H      _PK_H_(0x25, 0x5C)
#define REG_SC_BK25_5D_L      _PK_L_(0x25, 0x5D)
#define REG_SC_BK25_5D_H      _PK_H_(0x25, 0x5D)
#define REG_SC_BK25_5E_L      _PK_L_(0x25, 0x5E)
#define REG_SC_BK25_5E_H      _PK_H_(0x25, 0x5E)
#define REG_SC_BK25_5F_L      _PK_L_(0x25, 0x5F)
#define REG_SC_BK25_5F_H      _PK_H_(0x25, 0x5F)
#define REG_SC_BK25_60_L      _PK_L_(0x25, 0x60)
#define REG_SC_BK25_60_H      _PK_H_(0x25, 0x60)
#define REG_SC_BK25_61_L      _PK_L_(0x25, 0x61)
#define REG_SC_BK25_61_H      _PK_H_(0x25, 0x61)
#define REG_SC_BK25_62_L      _PK_L_(0x25, 0x62)
#define REG_SC_BK25_62_H      _PK_H_(0x25, 0x62)
#define REG_SC_BK25_63_L      _PK_L_(0x25, 0x63)
#define REG_SC_BK25_63_H      _PK_H_(0x25, 0x63)
#define REG_SC_BK25_64_L      _PK_L_(0x25, 0x64)
#define REG_SC_BK25_64_H      _PK_H_(0x25, 0x64)
#define REG_SC_BK25_65_L      _PK_L_(0x25, 0x65)
#define REG_SC_BK25_65_H      _PK_H_(0x25, 0x65)
#define REG_SC_BK25_66_L      _PK_L_(0x25, 0x66)
#define REG_SC_BK25_66_H      _PK_H_(0x25, 0x66)
#define REG_SC_BK25_67_L      _PK_L_(0x25, 0x67)
#define REG_SC_BK25_67_H      _PK_H_(0x25, 0x67)
#define REG_SC_BK25_68_L      _PK_L_(0x25, 0x68)
#define REG_SC_BK25_68_H      _PK_H_(0x25, 0x68)
#define REG_SC_BK25_69_L      _PK_L_(0x25, 0x69)
#define REG_SC_BK25_69_H      _PK_H_(0x25, 0x69)
#define REG_SC_BK25_6A_L      _PK_L_(0x25, 0x6A)
#define REG_SC_BK25_6A_H      _PK_H_(0x25, 0x6A)
#define REG_SC_BK25_6B_L      _PK_L_(0x25, 0x6B)
#define REG_SC_BK25_6B_H      _PK_H_(0x25, 0x6B)
#define REG_SC_BK25_6C_L      _PK_L_(0x25, 0x6C)
#define REG_SC_BK25_6C_H      _PK_H_(0x25, 0x6C)
#define REG_SC_BK25_6D_L      _PK_L_(0x25, 0x6D)
#define REG_SC_BK25_6D_H      _PK_H_(0x25, 0x6D)
#define REG_SC_BK25_6E_L      _PK_L_(0x25, 0x6E)
#define REG_SC_BK25_6E_H      _PK_H_(0x25, 0x6E)
#define REG_SC_BK25_6F_L      _PK_L_(0x25, 0x6F)
#define REG_SC_BK25_6F_H      _PK_H_(0x25, 0x6F)
#define REG_SC_BK25_70_L      _PK_L_(0x25, 0x70)
#define REG_SC_BK25_70_H      _PK_H_(0x25, 0x70)
#define REG_SC_BK25_71_L      _PK_L_(0x25, 0x71)
#define REG_SC_BK25_71_H      _PK_H_(0x25, 0x71)
#define REG_SC_BK25_72_L      _PK_L_(0x25, 0x72)
#define REG_SC_BK25_72_H      _PK_H_(0x25, 0x72)
#define REG_SC_BK25_73_L      _PK_L_(0x25, 0x73)
#define REG_SC_BK25_73_H      _PK_H_(0x25, 0x73)
#define REG_SC_BK25_74_L      _PK_L_(0x25, 0x74)
#define REG_SC_BK25_74_H      _PK_H_(0x25, 0x74)
#define REG_SC_BK25_75_L      _PK_L_(0x25, 0x75)
#define REG_SC_BK25_75_H      _PK_H_(0x25, 0x75)
#define REG_SC_BK25_76_L      _PK_L_(0x25, 0x76)
#define REG_SC_BK25_76_H      _PK_H_(0x25, 0x76)
#define REG_SC_BK25_77_L      _PK_L_(0x25, 0x77)
#define REG_SC_BK25_77_H      _PK_H_(0x25, 0x77)
#define REG_SC_BK25_78_L      _PK_L_(0x25, 0x78)
#define REG_SC_BK25_78_H      _PK_H_(0x25, 0x78)
#define REG_SC_BK25_79_L      _PK_L_(0x25, 0x79)
#define REG_SC_BK25_79_H      _PK_H_(0x25, 0x79)
#define REG_SC_BK25_7A_L      _PK_L_(0x25, 0x7A)
#define REG_SC_BK25_7A_H      _PK_H_(0x25, 0x7A)
#define REG_SC_BK25_7B_L      _PK_L_(0x25, 0x7B)
#define REG_SC_BK25_7B_H      _PK_H_(0x25, 0x7B)
#define REG_SC_BK25_7C_L      _PK_L_(0x25, 0x7C)
#define REG_SC_BK25_7C_H      _PK_H_(0x25, 0x7C)
#define REG_SC_BK25_7D_L      _PK_L_(0x25, 0x7D)
#define REG_SC_BK25_7D_H      _PK_H_(0x25, 0x7D)
#define REG_SC_BK25_7E_L      _PK_L_(0x25, 0x7E)
#define REG_SC_BK25_7E_H      _PK_H_(0x25, 0x7E)
#define REG_SC_BK25_7F_L      _PK_L_(0x25, 0x7F)
#define REG_SC_BK25_7F_H      _PK_H_(0x25, 0x7F)
//----------------------------------------------
#define REG_SC_BK26_00_L      _PK_L_(0x26, 0x00)
#define REG_SC_BK26_00_H      _PK_H_(0x26, 0x00)
#define REG_SC_BK26_01_L      _PK_L_(0x26, 0x01)
#define REG_SC_BK26_01_H      _PK_H_(0x26, 0x01)
#define REG_SC_BK26_02_L      _PK_L_(0x26, 0x02)
#define REG_SC_BK26_02_H      _PK_H_(0x26, 0x02)
#define REG_SC_BK26_03_L      _PK_L_(0x26, 0x03)
#define REG_SC_BK26_03_H      _PK_H_(0x26, 0x03)
#define REG_SC_BK26_04_L      _PK_L_(0x26, 0x04)
#define REG_SC_BK26_04_H      _PK_H_(0x26, 0x04)
#define REG_SC_BK26_05_L      _PK_L_(0x26, 0x05)
#define REG_SC_BK26_05_H      _PK_H_(0x26, 0x05)
#define REG_SC_BK26_06_L      _PK_L_(0x26, 0x06)
#define REG_SC_BK26_06_H      _PK_H_(0x26, 0x06)
#define REG_SC_BK26_07_L      _PK_L_(0x26, 0x07)
#define REG_SC_BK26_07_H      _PK_H_(0x26, 0x07)
#define REG_SC_BK26_08_L      _PK_L_(0x26, 0x08)
#define REG_SC_BK26_08_H      _PK_H_(0x26, 0x08)
#define REG_SC_BK26_09_L      _PK_L_(0x26, 0x09)
#define REG_SC_BK26_09_H      _PK_H_(0x26, 0x09)
#define REG_SC_BK26_0A_L      _PK_L_(0x26, 0x0A)
#define REG_SC_BK26_0A_H      _PK_H_(0x26, 0x0A)
#define REG_SC_BK26_0B_L      _PK_L_(0x26, 0x0B)
#define REG_SC_BK26_0B_H      _PK_H_(0x26, 0x0B)
#define REG_SC_BK26_0C_L      _PK_L_(0x26, 0x0C)
#define REG_SC_BK26_0C_H      _PK_H_(0x26, 0x0C)
#define REG_SC_BK26_0D_L      _PK_L_(0x26, 0x0D)
#define REG_SC_BK26_0D_H      _PK_H_(0x26, 0x0D)
#define REG_SC_BK26_0E_L      _PK_L_(0x26, 0x0E)
#define REG_SC_BK26_0E_H      _PK_H_(0x26, 0x0E)
#define REG_SC_BK26_0F_L      _PK_L_(0x26, 0x0F)
#define REG_SC_BK26_0F_H      _PK_H_(0x26, 0x0F)
#define REG_SC_BK26_10_L      _PK_L_(0x26, 0x10)
#define REG_SC_BK26_10_H      _PK_H_(0x26, 0x10)
#define REG_SC_BK26_11_L      _PK_L_(0x26, 0x11)
#define REG_SC_BK26_11_H      _PK_H_(0x26, 0x11)
#define REG_SC_BK26_12_L      _PK_L_(0x26, 0x12)
#define REG_SC_BK26_12_H      _PK_H_(0x26, 0x12)
#define REG_SC_BK26_13_L      _PK_L_(0x26, 0x13)
#define REG_SC_BK26_13_H      _PK_H_(0x26, 0x13)
#define REG_SC_BK26_14_L      _PK_L_(0x26, 0x14)
#define REG_SC_BK26_14_H      _PK_H_(0x26, 0x14)
#define REG_SC_BK26_15_L      _PK_L_(0x26, 0x15)
#define REG_SC_BK26_15_H      _PK_H_(0x26, 0x15)
#define REG_SC_BK26_16_L      _PK_L_(0x26, 0x16)
#define REG_SC_BK26_16_H      _PK_H_(0x26, 0x16)
#define REG_SC_BK26_17_L      _PK_L_(0x26, 0x17)
#define REG_SC_BK26_17_H      _PK_H_(0x26, 0x17)
#define REG_SC_BK26_18_L      _PK_L_(0x26, 0x18)
#define REG_SC_BK26_18_H      _PK_H_(0x26, 0x18)
#define REG_SC_BK26_19_L      _PK_L_(0x26, 0x19)
#define REG_SC_BK26_19_H      _PK_H_(0x26, 0x19)
#define REG_SC_BK26_1A_L      _PK_L_(0x26, 0x1A)
#define REG_SC_BK26_1A_H      _PK_H_(0x26, 0x1A)
#define REG_SC_BK26_1B_L      _PK_L_(0x26, 0x1B)
#define REG_SC_BK26_1B_H      _PK_H_(0x26, 0x1B)
#define REG_SC_BK26_1C_L      _PK_L_(0x26, 0x1C)
#define REG_SC_BK26_1C_H      _PK_H_(0x26, 0x1C)
#define REG_SC_BK26_1D_L      _PK_L_(0x26, 0x1D)
#define REG_SC_BK26_1D_H      _PK_H_(0x26, 0x1D)
#define REG_SC_BK26_1E_L      _PK_L_(0x26, 0x1E)
#define REG_SC_BK26_1E_H      _PK_H_(0x26, 0x1E)
#define REG_SC_BK26_1F_L      _PK_L_(0x26, 0x1F)
#define REG_SC_BK26_1F_H      _PK_H_(0x26, 0x1F)
#define REG_SC_BK26_20_L      _PK_L_(0x26, 0x20)
#define REG_SC_BK26_20_H      _PK_H_(0x26, 0x20)
#define REG_SC_BK26_21_L      _PK_L_(0x26, 0x21)
#define REG_SC_BK26_21_H      _PK_H_(0x26, 0x21)
#define REG_SC_BK26_22_L      _PK_L_(0x26, 0x22)
#define REG_SC_BK26_22_H      _PK_H_(0x26, 0x22)
#define REG_SC_BK26_23_L      _PK_L_(0x26, 0x23)
#define REG_SC_BK26_23_H      _PK_H_(0x26, 0x23)
#define REG_SC_BK26_24_L      _PK_L_(0x26, 0x24)
#define REG_SC_BK26_24_H      _PK_H_(0x26, 0x24)
#define REG_SC_BK26_25_L      _PK_L_(0x26, 0x25)
#define REG_SC_BK26_25_H      _PK_H_(0x26, 0x25)
#define REG_SC_BK26_26_L      _PK_L_(0x26, 0x26)
#define REG_SC_BK26_26_H      _PK_H_(0x26, 0x26)
#define REG_SC_BK26_27_L      _PK_L_(0x26, 0x27)
#define REG_SC_BK26_27_H      _PK_H_(0x26, 0x27)
#define REG_SC_BK26_28_L      _PK_L_(0x26, 0x28)
#define REG_SC_BK26_28_H      _PK_H_(0x26, 0x28)
#define REG_SC_BK26_29_L      _PK_L_(0x26, 0x29)
#define REG_SC_BK26_29_H      _PK_H_(0x26, 0x29)
#define REG_SC_BK26_2A_L      _PK_L_(0x26, 0x2A)
#define REG_SC_BK26_2A_H      _PK_H_(0x26, 0x2A)
#define REG_SC_BK26_2B_L      _PK_L_(0x26, 0x2B)
#define REG_SC_BK26_2B_H      _PK_H_(0x26, 0x2B)
#define REG_SC_BK26_2C_L      _PK_L_(0x26, 0x2C)
#define REG_SC_BK26_2C_H      _PK_H_(0x26, 0x2C)
#define REG_SC_BK26_2D_L      _PK_L_(0x26, 0x2D)
#define REG_SC_BK26_2D_H      _PK_H_(0x26, 0x2D)
#define REG_SC_BK26_2E_L      _PK_L_(0x26, 0x2E)
#define REG_SC_BK26_2E_H      _PK_H_(0x26, 0x2E)
#define REG_SC_BK26_2F_L      _PK_L_(0x26, 0x2F)
#define REG_SC_BK26_2F_H      _PK_H_(0x26, 0x2F)
#define REG_SC_BK26_30_L      _PK_L_(0x26, 0x30)
#define REG_SC_BK26_30_H      _PK_H_(0x26, 0x30)
#define REG_SC_BK26_31_L      _PK_L_(0x26, 0x31)
#define REG_SC_BK26_31_H      _PK_H_(0x26, 0x31)
#define REG_SC_BK26_32_L      _PK_L_(0x26, 0x32)
#define REG_SC_BK26_32_H      _PK_H_(0x26, 0x32)
#define REG_SC_BK26_33_L      _PK_L_(0x26, 0x33)
#define REG_SC_BK26_33_H      _PK_H_(0x26, 0x33)
#define REG_SC_BK26_34_L      _PK_L_(0x26, 0x34)
#define REG_SC_BK26_34_H      _PK_H_(0x26, 0x34)
#define REG_SC_BK26_35_L      _PK_L_(0x26, 0x35)
#define REG_SC_BK26_35_H      _PK_H_(0x26, 0x35)
#define REG_SC_BK26_36_L      _PK_L_(0x26, 0x36)
#define REG_SC_BK26_36_H      _PK_H_(0x26, 0x36)
#define REG_SC_BK26_37_L      _PK_L_(0x26, 0x37)
#define REG_SC_BK26_37_H      _PK_H_(0x26, 0x37)
#define REG_SC_BK26_38_L      _PK_L_(0x26, 0x38)
#define REG_SC_BK26_38_H      _PK_H_(0x26, 0x38)
#define REG_SC_BK26_39_L      _PK_L_(0x26, 0x39)
#define REG_SC_BK26_39_H      _PK_H_(0x26, 0x39)
#define REG_SC_BK26_3A_L      _PK_L_(0x26, 0x3A)
#define REG_SC_BK26_3A_H      _PK_H_(0x26, 0x3A)
#define REG_SC_BK26_3B_L      _PK_L_(0x26, 0x3B)
#define REG_SC_BK26_3B_H      _PK_H_(0x26, 0x3B)
#define REG_SC_BK26_3C_L      _PK_L_(0x26, 0x3C)
#define REG_SC_BK26_3C_H      _PK_H_(0x26, 0x3C)
#define REG_SC_BK26_3D_L      _PK_L_(0x26, 0x3D)
#define REG_SC_BK26_3D_H      _PK_H_(0x26, 0x3D)
#define REG_SC_BK26_3E_L      _PK_L_(0x26, 0x3E)
#define REG_SC_BK26_3E_H      _PK_H_(0x26, 0x3E)
#define REG_SC_BK26_3F_L      _PK_L_(0x26, 0x3F)
#define REG_SC_BK26_3F_H      _PK_H_(0x26, 0x3F)
#define REG_SC_BK26_40_L      _PK_L_(0x26, 0x40)
#define REG_SC_BK26_40_H      _PK_H_(0x26, 0x40)
#define REG_SC_BK26_41_L      _PK_L_(0x26, 0x41)
#define REG_SC_BK26_41_H      _PK_H_(0x26, 0x41)
#define REG_SC_BK26_42_L      _PK_L_(0x26, 0x42)
#define REG_SC_BK26_42_H      _PK_H_(0x26, 0x42)
#define REG_SC_BK26_43_L      _PK_L_(0x26, 0x43)
#define REG_SC_BK26_43_H      _PK_H_(0x26, 0x43)
#define REG_SC_BK26_44_L      _PK_L_(0x26, 0x44)
#define REG_SC_BK26_44_H      _PK_H_(0x26, 0x44)
#define REG_SC_BK26_45_L      _PK_L_(0x26, 0x45)
#define REG_SC_BK26_45_H      _PK_H_(0x26, 0x45)
#define REG_SC_BK26_46_L      _PK_L_(0x26, 0x46)
#define REG_SC_BK26_46_H      _PK_H_(0x26, 0x46)
#define REG_SC_BK26_47_L      _PK_L_(0x26, 0x47)
#define REG_SC_BK26_47_H      _PK_H_(0x26, 0x47)
#define REG_SC_BK26_48_L      _PK_L_(0x26, 0x48)
#define REG_SC_BK26_48_H      _PK_H_(0x26, 0x48)
#define REG_SC_BK26_49_L      _PK_L_(0x26, 0x49)
#define REG_SC_BK26_49_H      _PK_H_(0x26, 0x49)
#define REG_SC_BK26_4A_L      _PK_L_(0x26, 0x4A)
#define REG_SC_BK26_4A_H      _PK_H_(0x26, 0x4A)
#define REG_SC_BK26_4B_L      _PK_L_(0x26, 0x4B)
#define REG_SC_BK26_4B_H      _PK_H_(0x26, 0x4B)
#define REG_SC_BK26_4C_L      _PK_L_(0x26, 0x4C)
#define REG_SC_BK26_4C_H      _PK_H_(0x26, 0x4C)
#define REG_SC_BK26_4D_L      _PK_L_(0x26, 0x4D)
#define REG_SC_BK26_4D_H      _PK_H_(0x26, 0x4D)
#define REG_SC_BK26_4E_L      _PK_L_(0x26, 0x4E)
#define REG_SC_BK26_4E_H      _PK_H_(0x26, 0x4E)
#define REG_SC_BK26_4F_L      _PK_L_(0x26, 0x4F)
#define REG_SC_BK26_4F_H      _PK_H_(0x26, 0x4F)
#define REG_SC_BK26_50_L      _PK_L_(0x26, 0x50)
#define REG_SC_BK26_50_H      _PK_H_(0x26, 0x50)
#define REG_SC_BK26_51_L      _PK_L_(0x26, 0x51)
#define REG_SC_BK26_51_H      _PK_H_(0x26, 0x51)
#define REG_SC_BK26_52_L      _PK_L_(0x26, 0x52)
#define REG_SC_BK26_52_H      _PK_H_(0x26, 0x52)
#define REG_SC_BK26_53_L      _PK_L_(0x26, 0x53)
#define REG_SC_BK26_53_H      _PK_H_(0x26, 0x53)
#define REG_SC_BK26_54_L      _PK_L_(0x26, 0x54)
#define REG_SC_BK26_54_H      _PK_H_(0x26, 0x54)
#define REG_SC_BK26_55_L      _PK_L_(0x26, 0x55)
#define REG_SC_BK26_55_H      _PK_H_(0x26, 0x55)
#define REG_SC_BK26_56_L      _PK_L_(0x26, 0x56)
#define REG_SC_BK26_56_H      _PK_H_(0x26, 0x56)
#define REG_SC_BK26_57_L      _PK_L_(0x26, 0x57)
#define REG_SC_BK26_57_H      _PK_H_(0x26, 0x57)
#define REG_SC_BK26_58_L      _PK_L_(0x26, 0x58)
#define REG_SC_BK26_58_H      _PK_H_(0x26, 0x58)
#define REG_SC_BK26_59_L      _PK_L_(0x26, 0x59)
#define REG_SC_BK26_59_H      _PK_H_(0x26, 0x59)
#define REG_SC_BK26_5A_L      _PK_L_(0x26, 0x5A)
#define REG_SC_BK26_5A_H      _PK_H_(0x26, 0x5A)
#define REG_SC_BK26_5B_L      _PK_L_(0x26, 0x5B)
#define REG_SC_BK26_5B_H      _PK_H_(0x26, 0x5B)
#define REG_SC_BK26_5C_L      _PK_L_(0x26, 0x5C)
#define REG_SC_BK26_5C_H      _PK_H_(0x26, 0x5C)
#define REG_SC_BK26_5D_L      _PK_L_(0x26, 0x5D)
#define REG_SC_BK26_5D_H      _PK_H_(0x26, 0x5D)
#define REG_SC_BK26_5E_L      _PK_L_(0x26, 0x5E)
#define REG_SC_BK26_5E_H      _PK_H_(0x26, 0x5E)
#define REG_SC_BK26_5F_L      _PK_L_(0x26, 0x5F)
#define REG_SC_BK26_5F_H      _PK_H_(0x26, 0x5F)
#define REG_SC_BK26_60_L      _PK_L_(0x26, 0x60)
#define REG_SC_BK26_60_H      _PK_H_(0x26, 0x60)
#define REG_SC_BK26_61_L      _PK_L_(0x26, 0x61)
#define REG_SC_BK26_61_H      _PK_H_(0x26, 0x61)
#define REG_SC_BK26_62_L      _PK_L_(0x26, 0x62)
#define REG_SC_BK26_62_H      _PK_H_(0x26, 0x62)
#define REG_SC_BK26_63_L      _PK_L_(0x26, 0x63)
#define REG_SC_BK26_63_H      _PK_H_(0x26, 0x63)
#define REG_SC_BK26_64_L      _PK_L_(0x26, 0x64)
#define REG_SC_BK26_64_H      _PK_H_(0x26, 0x64)
#define REG_SC_BK26_65_L      _PK_L_(0x26, 0x65)
#define REG_SC_BK26_65_H      _PK_H_(0x26, 0x65)
#define REG_SC_BK26_66_L      _PK_L_(0x26, 0x66)
#define REG_SC_BK26_66_H      _PK_H_(0x26, 0x66)
#define REG_SC_BK26_67_L      _PK_L_(0x26, 0x67)
#define REG_SC_BK26_67_H      _PK_H_(0x26, 0x67)
#define REG_SC_BK26_68_L      _PK_L_(0x26, 0x68)
#define REG_SC_BK26_68_H      _PK_H_(0x26, 0x68)
#define REG_SC_BK26_69_L      _PK_L_(0x26, 0x69)
#define REG_SC_BK26_69_H      _PK_H_(0x26, 0x69)
#define REG_SC_BK26_6A_L      _PK_L_(0x26, 0x6A)
#define REG_SC_BK26_6A_H      _PK_H_(0x26, 0x6A)
#define REG_SC_BK26_6B_L      _PK_L_(0x26, 0x6B)
#define REG_SC_BK26_6B_H      _PK_H_(0x26, 0x6B)
#define REG_SC_BK26_6C_L      _PK_L_(0x26, 0x6C)
#define REG_SC_BK26_6C_H      _PK_H_(0x26, 0x6C)
#define REG_SC_BK26_6D_L      _PK_L_(0x26, 0x6D)
#define REG_SC_BK26_6D_H      _PK_H_(0x26, 0x6D)
#define REG_SC_BK26_6E_L      _PK_L_(0x26, 0x6E)
#define REG_SC_BK26_6E_H      _PK_H_(0x26, 0x6E)
#define REG_SC_BK26_6F_L      _PK_L_(0x26, 0x6F)
#define REG_SC_BK26_6F_H      _PK_H_(0x26, 0x6F)
#define REG_SC_BK26_70_L      _PK_L_(0x26, 0x70)
#define REG_SC_BK26_70_H      _PK_H_(0x26, 0x70)
#define REG_SC_BK26_71_L      _PK_L_(0x26, 0x71)
#define REG_SC_BK26_71_H      _PK_H_(0x26, 0x71)
#define REG_SC_BK26_72_L      _PK_L_(0x26, 0x72)
#define REG_SC_BK26_72_H      _PK_H_(0x26, 0x72)
#define REG_SC_BK26_73_L      _PK_L_(0x26, 0x73)
#define REG_SC_BK26_73_H      _PK_H_(0x26, 0x73)
#define REG_SC_BK26_74_L      _PK_L_(0x26, 0x74)
#define REG_SC_BK26_74_H      _PK_H_(0x26, 0x74)
#define REG_SC_BK26_75_L      _PK_L_(0x26, 0x75)
#define REG_SC_BK26_75_H      _PK_H_(0x26, 0x75)
#define REG_SC_BK26_76_L      _PK_L_(0x26, 0x76)
#define REG_SC_BK26_76_H      _PK_H_(0x26, 0x76)
#define REG_SC_BK26_77_L      _PK_L_(0x26, 0x77)
#define REG_SC_BK26_77_H      _PK_H_(0x26, 0x77)
#define REG_SC_BK26_78_L      _PK_L_(0x26, 0x78)
#define REG_SC_BK26_78_H      _PK_H_(0x26, 0x78)
#define REG_SC_BK26_79_L      _PK_L_(0x26, 0x79)
#define REG_SC_BK26_79_H      _PK_H_(0x26, 0x79)
#define REG_SC_BK26_7A_L      _PK_L_(0x26, 0x7A)
#define REG_SC_BK26_7A_H      _PK_H_(0x26, 0x7A)
#define REG_SC_BK26_7B_L      _PK_L_(0x26, 0x7B)
#define REG_SC_BK26_7B_H      _PK_H_(0x26, 0x7B)
#define REG_SC_BK26_7C_L      _PK_L_(0x26, 0x7C)
#define REG_SC_BK26_7C_H      _PK_H_(0x26, 0x7C)
#define REG_SC_BK26_7D_L      _PK_L_(0x26, 0x7D)
#define REG_SC_BK26_7D_H      _PK_H_(0x26, 0x7D)
#define REG_SC_BK26_7E_L      _PK_L_(0x26, 0x7E)
#define REG_SC_BK26_7E_H      _PK_H_(0x26, 0x7E)
#define REG_SC_BK26_7F_L      _PK_L_(0x26, 0x7F)
#define REG_SC_BK26_7F_H      _PK_H_(0x26, 0x7F)
//----------------------------------------------
#define REG_SC_BK27_00_L      _PK_L_(0x27, 0x00)
#define REG_SC_BK27_00_H      _PK_H_(0x27, 0x00)
#define REG_SC_BK27_01_L      _PK_L_(0x27, 0x01)
#define REG_SC_BK27_01_H      _PK_H_(0x27, 0x01)
#define REG_SC_BK27_02_L      _PK_L_(0x27, 0x02)
#define REG_SC_BK27_02_H      _PK_H_(0x27, 0x02)
#define REG_SC_BK27_03_L      _PK_L_(0x27, 0x03)
#define REG_SC_BK27_03_H      _PK_H_(0x27, 0x03)
#define REG_SC_BK27_04_L      _PK_L_(0x27, 0x04)
#define REG_SC_BK27_04_H      _PK_H_(0x27, 0x04)
#define REG_SC_BK27_05_L      _PK_L_(0x27, 0x05)
#define REG_SC_BK27_05_H      _PK_H_(0x27, 0x05)
#define REG_SC_BK27_06_L      _PK_L_(0x27, 0x06)
#define REG_SC_BK27_06_H      _PK_H_(0x27, 0x06)
#define REG_SC_BK27_07_L      _PK_L_(0x27, 0x07)
#define REG_SC_BK27_07_H      _PK_H_(0x27, 0x07)
#define REG_SC_BK27_08_L      _PK_L_(0x27, 0x08)
#define REG_SC_BK27_08_H      _PK_H_(0x27, 0x08)
#define REG_SC_BK27_09_L      _PK_L_(0x27, 0x09)
#define REG_SC_BK27_09_H      _PK_H_(0x27, 0x09)
#define REG_SC_BK27_0A_L      _PK_L_(0x27, 0x0A)
#define REG_SC_BK27_0A_H      _PK_H_(0x27, 0x0A)
#define REG_SC_BK27_0B_L      _PK_L_(0x27, 0x0B)
#define REG_SC_BK27_0B_H      _PK_H_(0x27, 0x0B)
#define REG_SC_BK27_0C_L      _PK_L_(0x27, 0x0C)
#define REG_SC_BK27_0C_H      _PK_H_(0x27, 0x0C)
#define REG_SC_BK27_0D_L      _PK_L_(0x27, 0x0D)
#define REG_SC_BK27_0D_H      _PK_H_(0x27, 0x0D)
#define REG_SC_BK27_0E_L      _PK_L_(0x27, 0x0E)
#define REG_SC_BK27_0E_H      _PK_H_(0x27, 0x0E)
#define REG_SC_BK27_0F_L      _PK_L_(0x27, 0x0F)
#define REG_SC_BK27_0F_H      _PK_H_(0x27, 0x0F)
#define REG_SC_BK27_10_L      _PK_L_(0x27, 0x10)
#define REG_SC_BK27_10_H      _PK_H_(0x27, 0x10)
#define REG_SC_BK27_11_L      _PK_L_(0x27, 0x11)
#define REG_SC_BK27_11_H      _PK_H_(0x27, 0x11)
#define REG_SC_BK27_12_L      _PK_L_(0x27, 0x12)
#define REG_SC_BK27_12_H      _PK_H_(0x27, 0x12)
#define REG_SC_BK27_13_L      _PK_L_(0x27, 0x13)
#define REG_SC_BK27_13_H      _PK_H_(0x27, 0x13)
#define REG_SC_BK27_14_L      _PK_L_(0x27, 0x14)
#define REG_SC_BK27_14_H      _PK_H_(0x27, 0x14)
#define REG_SC_BK27_15_L      _PK_L_(0x27, 0x15)
#define REG_SC_BK27_15_H      _PK_H_(0x27, 0x15)
#define REG_SC_BK27_16_L      _PK_L_(0x27, 0x16)
#define REG_SC_BK27_16_H      _PK_H_(0x27, 0x16)
#define REG_SC_BK27_17_L      _PK_L_(0x27, 0x17)
#define REG_SC_BK27_17_H      _PK_H_(0x27, 0x17)
#define REG_SC_BK27_18_L      _PK_L_(0x27, 0x18)
#define REG_SC_BK27_18_H      _PK_H_(0x27, 0x18)
#define REG_SC_BK27_19_L      _PK_L_(0x27, 0x19)
#define REG_SC_BK27_19_H      _PK_H_(0x27, 0x19)
#define REG_SC_BK27_1A_L      _PK_L_(0x27, 0x1A)
#define REG_SC_BK27_1A_H      _PK_H_(0x27, 0x1A)
#define REG_SC_BK27_1B_L      _PK_L_(0x27, 0x1B)
#define REG_SC_BK27_1B_H      _PK_H_(0x27, 0x1B)
#define REG_SC_BK27_1C_L      _PK_L_(0x27, 0x1C)
#define REG_SC_BK27_1C_H      _PK_H_(0x27, 0x1C)
#define REG_SC_BK27_1D_L      _PK_L_(0x27, 0x1D)
#define REG_SC_BK27_1D_H      _PK_H_(0x27, 0x1D)
#define REG_SC_BK27_1E_L      _PK_L_(0x27, 0x1E)
#define REG_SC_BK27_1E_H      _PK_H_(0x27, 0x1E)
#define REG_SC_BK27_1F_L      _PK_L_(0x27, 0x1F)
#define REG_SC_BK27_1F_H      _PK_H_(0x27, 0x1F)
#define REG_SC_BK27_20_L      _PK_L_(0x27, 0x20)
#define REG_SC_BK27_20_H      _PK_H_(0x27, 0x20)
#define REG_SC_BK27_21_L      _PK_L_(0x27, 0x21)
#define REG_SC_BK27_21_H      _PK_H_(0x27, 0x21)
#define REG_SC_BK27_22_L      _PK_L_(0x27, 0x22)
#define REG_SC_BK27_22_H      _PK_H_(0x27, 0x22)
#define REG_SC_BK27_23_L      _PK_L_(0x27, 0x23)
#define REG_SC_BK27_23_H      _PK_H_(0x27, 0x23)
#define REG_SC_BK27_24_L      _PK_L_(0x27, 0x24)
#define REG_SC_BK27_24_H      _PK_H_(0x27, 0x24)
#define REG_SC_BK27_25_L      _PK_L_(0x27, 0x25)
#define REG_SC_BK27_25_H      _PK_H_(0x27, 0x25)
#define REG_SC_BK27_26_L      _PK_L_(0x27, 0x26)
#define REG_SC_BK27_26_H      _PK_H_(0x27, 0x26)
#define REG_SC_BK27_27_L      _PK_L_(0x27, 0x27)
#define REG_SC_BK27_27_H      _PK_H_(0x27, 0x27)
#define REG_SC_BK27_28_L      _PK_L_(0x27, 0x28)
#define REG_SC_BK27_28_H      _PK_H_(0x27, 0x28)
#define REG_SC_BK27_29_L      _PK_L_(0x27, 0x29)
#define REG_SC_BK27_29_H      _PK_H_(0x27, 0x29)
#define REG_SC_BK27_2A_L      _PK_L_(0x27, 0x2A)
#define REG_SC_BK27_2A_H      _PK_H_(0x27, 0x2A)
#define REG_SC_BK27_2B_L      _PK_L_(0x27, 0x2B)
#define REG_SC_BK27_2B_H      _PK_H_(0x27, 0x2B)
#define REG_SC_BK27_2C_L      _PK_L_(0x27, 0x2C)
#define REG_SC_BK27_2C_H      _PK_H_(0x27, 0x2C)
#define REG_SC_BK27_2D_L      _PK_L_(0x27, 0x2D)
#define REG_SC_BK27_2D_H      _PK_H_(0x27, 0x2D)
#define REG_SC_BK27_2E_L      _PK_L_(0x27, 0x2E)
#define REG_SC_BK27_2E_H      _PK_H_(0x27, 0x2E)
#define REG_SC_BK27_2F_L      _PK_L_(0x27, 0x2F)
#define REG_SC_BK27_2F_H      _PK_H_(0x27, 0x2F)
#define REG_SC_BK27_30_L      _PK_L_(0x27, 0x30)
#define REG_SC_BK27_30_H      _PK_H_(0x27, 0x30)
#define REG_SC_BK27_31_L      _PK_L_(0x27, 0x31)
#define REG_SC_BK27_31_H      _PK_H_(0x27, 0x31)
#define REG_SC_BK27_32_L      _PK_L_(0x27, 0x32)
#define REG_SC_BK27_32_H      _PK_H_(0x27, 0x32)
#define REG_SC_BK27_33_L      _PK_L_(0x27, 0x33)
#define REG_SC_BK27_33_H      _PK_H_(0x27, 0x33)
#define REG_SC_BK27_34_L      _PK_L_(0x27, 0x34)
#define REG_SC_BK27_34_H      _PK_H_(0x27, 0x34)
#define REG_SC_BK27_35_L      _PK_L_(0x27, 0x35)
#define REG_SC_BK27_35_H      _PK_H_(0x27, 0x35)
#define REG_SC_BK27_36_L      _PK_L_(0x27, 0x36)
#define REG_SC_BK27_36_H      _PK_H_(0x27, 0x36)
#define REG_SC_BK27_37_L      _PK_L_(0x27, 0x37)
#define REG_SC_BK27_37_H      _PK_H_(0x27, 0x37)
#define REG_SC_BK27_38_L      _PK_L_(0x27, 0x38)
#define REG_SC_BK27_38_H      _PK_H_(0x27, 0x38)
#define REG_SC_BK27_39_L      _PK_L_(0x27, 0x39)
#define REG_SC_BK27_39_H      _PK_H_(0x27, 0x39)
#define REG_SC_BK27_3A_L      _PK_L_(0x27, 0x3A)
#define REG_SC_BK27_3A_H      _PK_H_(0x27, 0x3A)
#define REG_SC_BK27_3B_L      _PK_L_(0x27, 0x3B)
#define REG_SC_BK27_3B_H      _PK_H_(0x27, 0x3B)
#define REG_SC_BK27_3C_L      _PK_L_(0x27, 0x3C)
#define REG_SC_BK27_3C_H      _PK_H_(0x27, 0x3C)
#define REG_SC_BK27_3D_L      _PK_L_(0x27, 0x3D)
#define REG_SC_BK27_3D_H      _PK_H_(0x27, 0x3D)
#define REG_SC_BK27_3E_L      _PK_L_(0x27, 0x3E)
#define REG_SC_BK27_3E_H      _PK_H_(0x27, 0x3E)
#define REG_SC_BK27_3F_L      _PK_L_(0x27, 0x3F)
#define REG_SC_BK27_3F_H      _PK_H_(0x27, 0x3F)
#define REG_SC_BK27_40_L      _PK_L_(0x27, 0x40)
#define REG_SC_BK27_40_H      _PK_H_(0x27, 0x40)
#define REG_SC_BK27_41_L      _PK_L_(0x27, 0x41)
#define REG_SC_BK27_41_H      _PK_H_(0x27, 0x41)
#define REG_SC_BK27_42_L      _PK_L_(0x27, 0x42)
#define REG_SC_BK27_42_H      _PK_H_(0x27, 0x42)
#define REG_SC_BK27_43_L      _PK_L_(0x27, 0x43)
#define REG_SC_BK27_43_H      _PK_H_(0x27, 0x43)
#define REG_SC_BK27_44_L      _PK_L_(0x27, 0x44)
#define REG_SC_BK27_44_H      _PK_H_(0x27, 0x44)
#define REG_SC_BK27_45_L      _PK_L_(0x27, 0x45)
#define REG_SC_BK27_45_H      _PK_H_(0x27, 0x45)
#define REG_SC_BK27_46_L      _PK_L_(0x27, 0x46)
#define REG_SC_BK27_46_H      _PK_H_(0x27, 0x46)
#define REG_SC_BK27_47_L      _PK_L_(0x27, 0x47)
#define REG_SC_BK27_47_H      _PK_H_(0x27, 0x47)
#define REG_SC_BK27_48_L      _PK_L_(0x27, 0x48)
#define REG_SC_BK27_48_H      _PK_H_(0x27, 0x48)
#define REG_SC_BK27_49_L      _PK_L_(0x27, 0x49)
#define REG_SC_BK27_49_H      _PK_H_(0x27, 0x49)
#define REG_SC_BK27_4A_L      _PK_L_(0x27, 0x4A)
#define REG_SC_BK27_4A_H      _PK_H_(0x27, 0x4A)
#define REG_SC_BK27_4B_L      _PK_L_(0x27, 0x4B)
#define REG_SC_BK27_4B_H      _PK_H_(0x27, 0x4B)
#define REG_SC_BK27_4C_L      _PK_L_(0x27, 0x4C)
#define REG_SC_BK27_4C_H      _PK_H_(0x27, 0x4C)
#define REG_SC_BK27_4D_L      _PK_L_(0x27, 0x4D)
#define REG_SC_BK27_4D_H      _PK_H_(0x27, 0x4D)
#define REG_SC_BK27_4E_L      _PK_L_(0x27, 0x4E)
#define REG_SC_BK27_4E_H      _PK_H_(0x27, 0x4E)
#define REG_SC_BK27_4F_L      _PK_L_(0x27, 0x4F)
#define REG_SC_BK27_4F_H      _PK_H_(0x27, 0x4F)
#define REG_SC_BK27_50_L      _PK_L_(0x27, 0x50)
#define REG_SC_BK27_50_H      _PK_H_(0x27, 0x50)
#define REG_SC_BK27_51_L      _PK_L_(0x27, 0x51)
#define REG_SC_BK27_51_H      _PK_H_(0x27, 0x51)
#define REG_SC_BK27_52_L      _PK_L_(0x27, 0x52)
#define REG_SC_BK27_52_H      _PK_H_(0x27, 0x52)
#define REG_SC_BK27_53_L      _PK_L_(0x27, 0x53)
#define REG_SC_BK27_53_H      _PK_H_(0x27, 0x53)
#define REG_SC_BK27_54_L      _PK_L_(0x27, 0x54)
#define REG_SC_BK27_54_H      _PK_H_(0x27, 0x54)
#define REG_SC_BK27_55_L      _PK_L_(0x27, 0x55)
#define REG_SC_BK27_55_H      _PK_H_(0x27, 0x55)
#define REG_SC_BK27_56_L      _PK_L_(0x27, 0x56)
#define REG_SC_BK27_56_H      _PK_H_(0x27, 0x56)
#define REG_SC_BK27_57_L      _PK_L_(0x27, 0x57)
#define REG_SC_BK27_57_H      _PK_H_(0x27, 0x57)
#define REG_SC_BK27_58_L      _PK_L_(0x27, 0x58)
#define REG_SC_BK27_58_H      _PK_H_(0x27, 0x58)
#define REG_SC_BK27_59_L      _PK_L_(0x27, 0x59)
#define REG_SC_BK27_59_H      _PK_H_(0x27, 0x59)
#define REG_SC_BK27_5A_L      _PK_L_(0x27, 0x5A)
#define REG_SC_BK27_5A_H      _PK_H_(0x27, 0x5A)
#define REG_SC_BK27_5B_L      _PK_L_(0x27, 0x5B)
#define REG_SC_BK27_5B_H      _PK_H_(0x27, 0x5B)
#define REG_SC_BK27_5C_L      _PK_L_(0x27, 0x5C)
#define REG_SC_BK27_5C_H      _PK_H_(0x27, 0x5C)
#define REG_SC_BK27_5D_L      _PK_L_(0x27, 0x5D)
#define REG_SC_BK27_5D_H      _PK_H_(0x27, 0x5D)
#define REG_SC_BK27_5E_L      _PK_L_(0x27, 0x5E)
#define REG_SC_BK27_5E_H      _PK_H_(0x27, 0x5E)
#define REG_SC_BK27_5F_L      _PK_L_(0x27, 0x5F)
#define REG_SC_BK27_5F_H      _PK_H_(0x27, 0x5F)
#define REG_SC_BK27_60_L      _PK_L_(0x27, 0x60)
#define REG_SC_BK27_60_H      _PK_H_(0x27, 0x60)
#define REG_SC_BK27_61_L      _PK_L_(0x27, 0x61)
#define REG_SC_BK27_61_H      _PK_H_(0x27, 0x61)
#define REG_SC_BK27_62_L      _PK_L_(0x27, 0x62)
#define REG_SC_BK27_62_H      _PK_H_(0x27, 0x62)
#define REG_SC_BK27_63_L      _PK_L_(0x27, 0x63)
#define REG_SC_BK27_63_H      _PK_H_(0x27, 0x63)
#define REG_SC_BK27_64_L      _PK_L_(0x27, 0x64)
#define REG_SC_BK27_64_H      _PK_H_(0x27, 0x64)
#define REG_SC_BK27_65_L      _PK_L_(0x27, 0x65)
#define REG_SC_BK27_65_H      _PK_H_(0x27, 0x65)
#define REG_SC_BK27_66_L      _PK_L_(0x27, 0x66)
#define REG_SC_BK27_66_H      _PK_H_(0x27, 0x66)
#define REG_SC_BK27_67_L      _PK_L_(0x27, 0x67)
#define REG_SC_BK27_67_H      _PK_H_(0x27, 0x67)
#define REG_SC_BK27_68_L      _PK_L_(0x27, 0x68)
#define REG_SC_BK27_68_H      _PK_H_(0x27, 0x68)
#define REG_SC_BK27_69_L      _PK_L_(0x27, 0x69)
#define REG_SC_BK27_69_H      _PK_H_(0x27, 0x69)
#define REG_SC_BK27_6A_L      _PK_L_(0x27, 0x6A)
#define REG_SC_BK27_6A_H      _PK_H_(0x27, 0x6A)
#define REG_SC_BK27_6B_L      _PK_L_(0x27, 0x6B)
#define REG_SC_BK27_6B_H      _PK_H_(0x27, 0x6B)
#define REG_SC_BK27_6C_L      _PK_L_(0x27, 0x6C)
#define REG_SC_BK27_6C_H      _PK_H_(0x27, 0x6C)
#define REG_SC_BK27_6D_L      _PK_L_(0x27, 0x6D)
#define REG_SC_BK27_6D_H      _PK_H_(0x27, 0x6D)
#define REG_SC_BK27_6E_L      _PK_L_(0x27, 0x6E)
#define REG_SC_BK27_6E_H      _PK_H_(0x27, 0x6E)
#define REG_SC_BK27_6F_L      _PK_L_(0x27, 0x6F)
#define REG_SC_BK27_6F_H      _PK_H_(0x27, 0x6F)
#define REG_SC_BK27_70_L      _PK_L_(0x27, 0x70)
#define REG_SC_BK27_70_H      _PK_H_(0x27, 0x70)
#define REG_SC_BK27_71_L      _PK_L_(0x27, 0x71)
#define REG_SC_BK27_71_H      _PK_H_(0x27, 0x71)
#define REG_SC_BK27_72_L      _PK_L_(0x27, 0x72)
#define REG_SC_BK27_72_H      _PK_H_(0x27, 0x72)
#define REG_SC_BK27_73_L      _PK_L_(0x27, 0x73)
#define REG_SC_BK27_73_H      _PK_H_(0x27, 0x73)
#define REG_SC_BK27_74_L      _PK_L_(0x27, 0x74)
#define REG_SC_BK27_74_H      _PK_H_(0x27, 0x74)
#define REG_SC_BK27_75_L      _PK_L_(0x27, 0x75)
#define REG_SC_BK27_75_H      _PK_H_(0x27, 0x75)
#define REG_SC_BK27_76_L      _PK_L_(0x27, 0x76)
#define REG_SC_BK27_76_H      _PK_H_(0x27, 0x76)
#define REG_SC_BK27_77_L      _PK_L_(0x27, 0x77)
#define REG_SC_BK27_77_H      _PK_H_(0x27, 0x77)
#define REG_SC_BK27_78_L      _PK_L_(0x27, 0x78)
#define REG_SC_BK27_78_H      _PK_H_(0x27, 0x78)
#define REG_SC_BK27_79_L      _PK_L_(0x27, 0x79)
#define REG_SC_BK27_79_H      _PK_H_(0x27, 0x79)
#define REG_SC_BK27_7A_L      _PK_L_(0x27, 0x7A)
#define REG_SC_BK27_7A_H      _PK_H_(0x27, 0x7A)
#define REG_SC_BK27_7B_L      _PK_L_(0x27, 0x7B)
#define REG_SC_BK27_7B_H      _PK_H_(0x27, 0x7B)
#define REG_SC_BK27_7C_L      _PK_L_(0x27, 0x7C)
#define REG_SC_BK27_7C_H      _PK_H_(0x27, 0x7C)
#define REG_SC_BK27_7D_L      _PK_L_(0x27, 0x7D)
#define REG_SC_BK27_7D_H      _PK_H_(0x27, 0x7D)
#define REG_SC_BK27_7E_L      _PK_L_(0x27, 0x7E)
#define REG_SC_BK27_7E_H      _PK_H_(0x27, 0x7E)
#define REG_SC_BK27_7F_L      _PK_L_(0x27, 0x7F)
#define REG_SC_BK27_7F_H      _PK_H_(0x27, 0x7F)
//----------------------------------------------
#define REG_SC_BK28_00_L      _PK_L_(0x28, 0x00)
#define REG_SC_BK28_00_H      _PK_H_(0x28, 0x00)
#define REG_SC_BK28_01_L      _PK_L_(0x28, 0x01)
#define REG_SC_BK28_01_H      _PK_H_(0x28, 0x01)
#define REG_SC_BK28_02_L      _PK_L_(0x28, 0x02)
#define REG_SC_BK28_02_H      _PK_H_(0x28, 0x02)
#define REG_SC_BK28_03_L      _PK_L_(0x28, 0x03)
#define REG_SC_BK28_03_H      _PK_H_(0x28, 0x03)
#define REG_SC_BK28_04_L      _PK_L_(0x28, 0x04)
#define REG_SC_BK28_04_H      _PK_H_(0x28, 0x04)
#define REG_SC_BK28_05_L      _PK_L_(0x28, 0x05)
#define REG_SC_BK28_05_H      _PK_H_(0x28, 0x05)
#define REG_SC_BK28_06_L      _PK_L_(0x28, 0x06)
#define REG_SC_BK28_06_H      _PK_H_(0x28, 0x06)
#define REG_SC_BK28_07_L      _PK_L_(0x28, 0x07)
#define REG_SC_BK28_07_H      _PK_H_(0x28, 0x07)
#define REG_SC_BK28_08_L      _PK_L_(0x28, 0x08)
#define REG_SC_BK28_08_H      _PK_H_(0x28, 0x08)
#define REG_SC_BK28_09_L      _PK_L_(0x28, 0x09)
#define REG_SC_BK28_09_H      _PK_H_(0x28, 0x09)
#define REG_SC_BK28_0A_L      _PK_L_(0x28, 0x0A)
#define REG_SC_BK28_0A_H      _PK_H_(0x28, 0x0A)
#define REG_SC_BK28_0B_L      _PK_L_(0x28, 0x0B)
#define REG_SC_BK28_0B_H      _PK_H_(0x28, 0x0B)
#define REG_SC_BK28_0C_L      _PK_L_(0x28, 0x0C)
#define REG_SC_BK28_0C_H      _PK_H_(0x28, 0x0C)
#define REG_SC_BK28_0D_L      _PK_L_(0x28, 0x0D)
#define REG_SC_BK28_0D_H      _PK_H_(0x28, 0x0D)
#define REG_SC_BK28_0E_L      _PK_L_(0x28, 0x0E)
#define REG_SC_BK28_0E_H      _PK_H_(0x28, 0x0E)
#define REG_SC_BK28_0F_L      _PK_L_(0x28, 0x0F)
#define REG_SC_BK28_0F_H      _PK_H_(0x28, 0x0F)
#define REG_SC_BK28_10_L      _PK_L_(0x28, 0x10)
#define REG_SC_BK28_10_H      _PK_H_(0x28, 0x10)
#define REG_SC_BK28_11_L      _PK_L_(0x28, 0x11)
#define REG_SC_BK28_11_H      _PK_H_(0x28, 0x11)
#define REG_SC_BK28_12_L      _PK_L_(0x28, 0x12)
#define REG_SC_BK28_12_H      _PK_H_(0x28, 0x12)
#define REG_SC_BK28_13_L      _PK_L_(0x28, 0x13)
#define REG_SC_BK28_13_H      _PK_H_(0x28, 0x13)
#define REG_SC_BK28_14_L      _PK_L_(0x28, 0x14)
#define REG_SC_BK28_14_H      _PK_H_(0x28, 0x14)
#define REG_SC_BK28_15_L      _PK_L_(0x28, 0x15)
#define REG_SC_BK28_15_H      _PK_H_(0x28, 0x15)
#define REG_SC_BK28_16_L      _PK_L_(0x28, 0x16)
#define REG_SC_BK28_16_H      _PK_H_(0x28, 0x16)
#define REG_SC_BK28_17_L      _PK_L_(0x28, 0x17)
#define REG_SC_BK28_17_H      _PK_H_(0x28, 0x17)
#define REG_SC_BK28_18_L      _PK_L_(0x28, 0x18)
#define REG_SC_BK28_18_H      _PK_H_(0x28, 0x18)
#define REG_SC_BK28_19_L      _PK_L_(0x28, 0x19)
#define REG_SC_BK28_19_H      _PK_H_(0x28, 0x19)
#define REG_SC_BK28_1A_L      _PK_L_(0x28, 0x1A)
#define REG_SC_BK28_1A_H      _PK_H_(0x28, 0x1A)
#define REG_SC_BK28_1B_L      _PK_L_(0x28, 0x1B)
#define REG_SC_BK28_1B_H      _PK_H_(0x28, 0x1B)
#define REG_SC_BK28_1C_L      _PK_L_(0x28, 0x1C)
#define REG_SC_BK28_1C_H      _PK_H_(0x28, 0x1C)
#define REG_SC_BK28_1D_L      _PK_L_(0x28, 0x1D)
#define REG_SC_BK28_1D_H      _PK_H_(0x28, 0x1D)
#define REG_SC_BK28_1E_L      _PK_L_(0x28, 0x1E)
#define REG_SC_BK28_1E_H      _PK_H_(0x28, 0x1E)
#define REG_SC_BK28_1F_L      _PK_L_(0x28, 0x1F)
#define REG_SC_BK28_1F_H      _PK_H_(0x28, 0x1F)
#define REG_SC_BK28_20_L      _PK_L_(0x28, 0x20)
#define REG_SC_BK28_20_H      _PK_H_(0x28, 0x20)
#define REG_SC_BK28_21_L      _PK_L_(0x28, 0x21)
#define REG_SC_BK28_21_H      _PK_H_(0x28, 0x21)
#define REG_SC_BK28_22_L      _PK_L_(0x28, 0x22)
#define REG_SC_BK28_22_H      _PK_H_(0x28, 0x22)
#define REG_SC_BK28_23_L      _PK_L_(0x28, 0x23)
#define REG_SC_BK28_23_H      _PK_H_(0x28, 0x23)
#define REG_SC_BK28_24_L      _PK_L_(0x28, 0x24)
#define REG_SC_BK28_24_H      _PK_H_(0x28, 0x24)
#define REG_SC_BK28_25_L      _PK_L_(0x28, 0x25)
#define REG_SC_BK28_25_H      _PK_H_(0x28, 0x25)
#define REG_SC_BK28_26_L      _PK_L_(0x28, 0x26)
#define REG_SC_BK28_26_H      _PK_H_(0x28, 0x26)
#define REG_SC_BK28_27_L      _PK_L_(0x28, 0x27)
#define REG_SC_BK28_27_H      _PK_H_(0x28, 0x27)
#define REG_SC_BK28_28_L      _PK_L_(0x28, 0x28)
#define REG_SC_BK28_28_H      _PK_H_(0x28, 0x28)
#define REG_SC_BK28_29_L      _PK_L_(0x28, 0x29)
#define REG_SC_BK28_29_H      _PK_H_(0x28, 0x29)
#define REG_SC_BK28_2A_L      _PK_L_(0x28, 0x2A)
#define REG_SC_BK28_2A_H      _PK_H_(0x28, 0x2A)
#define REG_SC_BK28_2B_L      _PK_L_(0x28, 0x2B)
#define REG_SC_BK28_2B_H      _PK_H_(0x28, 0x2B)
#define REG_SC_BK28_2C_L      _PK_L_(0x28, 0x2C)
#define REG_SC_BK28_2C_H      _PK_H_(0x28, 0x2C)
#define REG_SC_BK28_2D_L      _PK_L_(0x28, 0x2D)
#define REG_SC_BK28_2D_H      _PK_H_(0x28, 0x2D)
#define REG_SC_BK28_2E_L      _PK_L_(0x28, 0x2E)
#define REG_SC_BK28_2E_H      _PK_H_(0x28, 0x2E)
#define REG_SC_BK28_2F_L      _PK_L_(0x28, 0x2F)
#define REG_SC_BK28_2F_H      _PK_H_(0x28, 0x2F)
#define REG_SC_BK28_30_L      _PK_L_(0x28, 0x30)
#define REG_SC_BK28_30_H      _PK_H_(0x28, 0x30)
#define REG_SC_BK28_31_L      _PK_L_(0x28, 0x31)
#define REG_SC_BK28_31_H      _PK_H_(0x28, 0x31)
#define REG_SC_BK28_32_L      _PK_L_(0x28, 0x32)
#define REG_SC_BK28_32_H      _PK_H_(0x28, 0x32)
#define REG_SC_BK28_33_L      _PK_L_(0x28, 0x33)
#define REG_SC_BK28_33_H      _PK_H_(0x28, 0x33)
#define REG_SC_BK28_34_L      _PK_L_(0x28, 0x34)
#define REG_SC_BK28_34_H      _PK_H_(0x28, 0x34)
#define REG_SC_BK28_35_L      _PK_L_(0x28, 0x35)
#define REG_SC_BK28_35_H      _PK_H_(0x28, 0x35)
#define REG_SC_BK28_36_L      _PK_L_(0x28, 0x36)
#define REG_SC_BK28_36_H      _PK_H_(0x28, 0x36)
#define REG_SC_BK28_37_L      _PK_L_(0x28, 0x37)
#define REG_SC_BK28_37_H      _PK_H_(0x28, 0x37)
#define REG_SC_BK28_38_L      _PK_L_(0x28, 0x38)
#define REG_SC_BK28_38_H      _PK_H_(0x28, 0x38)
#define REG_SC_BK28_39_L      _PK_L_(0x28, 0x39)
#define REG_SC_BK28_39_H      _PK_H_(0x28, 0x39)
#define REG_SC_BK28_3A_L      _PK_L_(0x28, 0x3A)
#define REG_SC_BK28_3A_H      _PK_H_(0x28, 0x3A)
#define REG_SC_BK28_3B_L      _PK_L_(0x28, 0x3B)
#define REG_SC_BK28_3B_H      _PK_H_(0x28, 0x3B)
#define REG_SC_BK28_3C_L      _PK_L_(0x28, 0x3C)
#define REG_SC_BK28_3C_H      _PK_H_(0x28, 0x3C)
#define REG_SC_BK28_3D_L      _PK_L_(0x28, 0x3D)
#define REG_SC_BK28_3D_H      _PK_H_(0x28, 0x3D)
#define REG_SC_BK28_3E_L      _PK_L_(0x28, 0x3E)
#define REG_SC_BK28_3E_H      _PK_H_(0x28, 0x3E)
#define REG_SC_BK28_3F_L      _PK_L_(0x28, 0x3F)
#define REG_SC_BK28_3F_H      _PK_H_(0x28, 0x3F)
#define REG_SC_BK28_40_L      _PK_L_(0x28, 0x40)
#define REG_SC_BK28_40_H      _PK_H_(0x28, 0x40)
#define REG_SC_BK28_41_L      _PK_L_(0x28, 0x41)
#define REG_SC_BK28_41_H      _PK_H_(0x28, 0x41)
#define REG_SC_BK28_42_L      _PK_L_(0x28, 0x42)
#define REG_SC_BK28_42_H      _PK_H_(0x28, 0x42)
#define REG_SC_BK28_43_L      _PK_L_(0x28, 0x43)
#define REG_SC_BK28_43_H      _PK_H_(0x28, 0x43)
#define REG_SC_BK28_44_L      _PK_L_(0x28, 0x44)
#define REG_SC_BK28_44_H      _PK_H_(0x28, 0x44)
#define REG_SC_BK28_45_L      _PK_L_(0x28, 0x45)
#define REG_SC_BK28_45_H      _PK_H_(0x28, 0x45)
#define REG_SC_BK28_46_L      _PK_L_(0x28, 0x46)
#define REG_SC_BK28_46_H      _PK_H_(0x28, 0x46)
#define REG_SC_BK28_47_L      _PK_L_(0x28, 0x47)
#define REG_SC_BK28_47_H      _PK_H_(0x28, 0x47)
#define REG_SC_BK28_48_L      _PK_L_(0x28, 0x48)
#define REG_SC_BK28_48_H      _PK_H_(0x28, 0x48)
#define REG_SC_BK28_49_L      _PK_L_(0x28, 0x49)
#define REG_SC_BK28_49_H      _PK_H_(0x28, 0x49)
#define REG_SC_BK28_4A_L      _PK_L_(0x28, 0x4A)
#define REG_SC_BK28_4A_H      _PK_H_(0x28, 0x4A)
#define REG_SC_BK28_4B_L      _PK_L_(0x28, 0x4B)
#define REG_SC_BK28_4B_H      _PK_H_(0x28, 0x4B)
#define REG_SC_BK28_4C_L      _PK_L_(0x28, 0x4C)
#define REG_SC_BK28_4C_H      _PK_H_(0x28, 0x4C)
#define REG_SC_BK28_4D_L      _PK_L_(0x28, 0x4D)
#define REG_SC_BK28_4D_H      _PK_H_(0x28, 0x4D)
#define REG_SC_BK28_4E_L      _PK_L_(0x28, 0x4E)
#define REG_SC_BK28_4E_H      _PK_H_(0x28, 0x4E)
#define REG_SC_BK28_4F_L      _PK_L_(0x28, 0x4F)
#define REG_SC_BK28_4F_H      _PK_H_(0x28, 0x4F)
#define REG_SC_BK28_50_L      _PK_L_(0x28, 0x50)
#define REG_SC_BK28_50_H      _PK_H_(0x28, 0x50)
#define REG_SC_BK28_51_L      _PK_L_(0x28, 0x51)
#define REG_SC_BK28_51_H      _PK_H_(0x28, 0x51)
#define REG_SC_BK28_52_L      _PK_L_(0x28, 0x52)
#define REG_SC_BK28_52_H      _PK_H_(0x28, 0x52)
#define REG_SC_BK28_53_L      _PK_L_(0x28, 0x53)
#define REG_SC_BK28_53_H      _PK_H_(0x28, 0x53)
#define REG_SC_BK28_54_L      _PK_L_(0x28, 0x54)
#define REG_SC_BK28_54_H      _PK_H_(0x28, 0x54)
#define REG_SC_BK28_55_L      _PK_L_(0x28, 0x55)
#define REG_SC_BK28_55_H      _PK_H_(0x28, 0x55)
#define REG_SC_BK28_56_L      _PK_L_(0x28, 0x56)
#define REG_SC_BK28_56_H      _PK_H_(0x28, 0x56)
#define REG_SC_BK28_57_L      _PK_L_(0x28, 0x57)
#define REG_SC_BK28_57_H      _PK_H_(0x28, 0x57)
#define REG_SC_BK28_58_L      _PK_L_(0x28, 0x58)
#define REG_SC_BK28_58_H      _PK_H_(0x28, 0x58)
#define REG_SC_BK28_59_L      _PK_L_(0x28, 0x59)
#define REG_SC_BK28_59_H      _PK_H_(0x28, 0x59)
#define REG_SC_BK28_5A_L      _PK_L_(0x28, 0x5A)
#define REG_SC_BK28_5A_H      _PK_H_(0x28, 0x5A)
#define REG_SC_BK28_5B_L      _PK_L_(0x28, 0x5B)
#define REG_SC_BK28_5B_H      _PK_H_(0x28, 0x5B)
#define REG_SC_BK28_5C_L      _PK_L_(0x28, 0x5C)
#define REG_SC_BK28_5C_H      _PK_H_(0x28, 0x5C)
#define REG_SC_BK28_5D_L      _PK_L_(0x28, 0x5D)
#define REG_SC_BK28_5D_H      _PK_H_(0x28, 0x5D)
#define REG_SC_BK28_5E_L      _PK_L_(0x28, 0x5E)
#define REG_SC_BK28_5E_H      _PK_H_(0x28, 0x5E)
#define REG_SC_BK28_5F_L      _PK_L_(0x28, 0x5F)
#define REG_SC_BK28_5F_H      _PK_H_(0x28, 0x5F)
#define REG_SC_BK28_60_L      _PK_L_(0x28, 0x60)
#define REG_SC_BK28_60_H      _PK_H_(0x28, 0x60)
#define REG_SC_BK28_61_L      _PK_L_(0x28, 0x61)
#define REG_SC_BK28_61_H      _PK_H_(0x28, 0x61)
#define REG_SC_BK28_62_L      _PK_L_(0x28, 0x62)
#define REG_SC_BK28_62_H      _PK_H_(0x28, 0x62)
#define REG_SC_BK28_63_L      _PK_L_(0x28, 0x63)
#define REG_SC_BK28_63_H      _PK_H_(0x28, 0x63)
#define REG_SC_BK28_64_L      _PK_L_(0x28, 0x64)
#define REG_SC_BK28_64_H      _PK_H_(0x28, 0x64)
#define REG_SC_BK28_65_L      _PK_L_(0x28, 0x65)
#define REG_SC_BK28_65_H      _PK_H_(0x28, 0x65)
#define REG_SC_BK28_66_L      _PK_L_(0x28, 0x66)
#define REG_SC_BK28_66_H      _PK_H_(0x28, 0x66)
#define REG_SC_BK28_67_L      _PK_L_(0x28, 0x67)
#define REG_SC_BK28_67_H      _PK_H_(0x28, 0x67)
#define REG_SC_BK28_68_L      _PK_L_(0x28, 0x68)
#define REG_SC_BK28_68_H      _PK_H_(0x28, 0x68)
#define REG_SC_BK28_69_L      _PK_L_(0x28, 0x69)
#define REG_SC_BK28_69_H      _PK_H_(0x28, 0x69)
#define REG_SC_BK28_6A_L      _PK_L_(0x28, 0x6A)
#define REG_SC_BK28_6A_H      _PK_H_(0x28, 0x6A)
#define REG_SC_BK28_6B_L      _PK_L_(0x28, 0x6B)
#define REG_SC_BK28_6B_H      _PK_H_(0x28, 0x6B)
#define REG_SC_BK28_6C_L      _PK_L_(0x28, 0x6C)
#define REG_SC_BK28_6C_H      _PK_H_(0x28, 0x6C)
#define REG_SC_BK28_6D_L      _PK_L_(0x28, 0x6D)
#define REG_SC_BK28_6D_H      _PK_H_(0x28, 0x6D)
#define REG_SC_BK28_6E_L      _PK_L_(0x28, 0x6E)
#define REG_SC_BK28_6E_H      _PK_H_(0x28, 0x6E)
#define REG_SC_BK28_6F_L      _PK_L_(0x28, 0x6F)
#define REG_SC_BK28_6F_H      _PK_H_(0x28, 0x6F)
#define REG_SC_BK28_70_L      _PK_L_(0x28, 0x70)
#define REG_SC_BK28_70_H      _PK_H_(0x28, 0x70)
#define REG_SC_BK28_71_L      _PK_L_(0x28, 0x71)
#define REG_SC_BK28_71_H      _PK_H_(0x28, 0x71)
#define REG_SC_BK28_72_L      _PK_L_(0x28, 0x72)
#define REG_SC_BK28_72_H      _PK_H_(0x28, 0x72)
#define REG_SC_BK28_73_L      _PK_L_(0x28, 0x73)
#define REG_SC_BK28_73_H      _PK_H_(0x28, 0x73)
#define REG_SC_BK28_74_L      _PK_L_(0x28, 0x74)
#define REG_SC_BK28_74_H      _PK_H_(0x28, 0x74)
#define REG_SC_BK28_75_L      _PK_L_(0x28, 0x75)
#define REG_SC_BK28_75_H      _PK_H_(0x28, 0x75)
#define REG_SC_BK28_76_L      _PK_L_(0x28, 0x76)
#define REG_SC_BK28_76_H      _PK_H_(0x28, 0x76)
#define REG_SC_BK28_77_L      _PK_L_(0x28, 0x77)
#define REG_SC_BK28_77_H      _PK_H_(0x28, 0x77)
#define REG_SC_BK28_78_L      _PK_L_(0x28, 0x78)
#define REG_SC_BK28_78_H      _PK_H_(0x28, 0x78)
#define REG_SC_BK28_79_L      _PK_L_(0x28, 0x79)
#define REG_SC_BK28_79_H      _PK_H_(0x28, 0x79)
#define REG_SC_BK28_7A_L      _PK_L_(0x28, 0x7A)
#define REG_SC_BK28_7A_H      _PK_H_(0x28, 0x7A)
#define REG_SC_BK28_7B_L      _PK_L_(0x28, 0x7B)
#define REG_SC_BK28_7B_H      _PK_H_(0x28, 0x7B)
#define REG_SC_BK28_7C_L      _PK_L_(0x28, 0x7C)
#define REG_SC_BK28_7C_H      _PK_H_(0x28, 0x7C)
#define REG_SC_BK28_7D_L      _PK_L_(0x28, 0x7D)
#define REG_SC_BK28_7D_H      _PK_H_(0x28, 0x7D)
#define REG_SC_BK28_7E_L      _PK_L_(0x28, 0x7E)
#define REG_SC_BK28_7E_H      _PK_H_(0x28, 0x7E)
#define REG_SC_BK28_7F_L      _PK_L_(0x28, 0x7F)
#define REG_SC_BK28_7F_H      _PK_H_(0x28, 0x7F)
//----------------------------------------------
#define REG_SC_BK2A_00_L      _PK_L_(0x2A, 0x00)
#define REG_SC_BK2A_00_H      _PK_H_(0x2A, 0x00)
#define REG_SC_BK2A_01_L      _PK_L_(0x2A, 0x01)
#define REG_SC_BK2A_01_H      _PK_H_(0x2A, 0x01)
#define REG_SC_BK2A_02_L      _PK_L_(0x2A, 0x02)
#define REG_SC_BK2A_02_H      _PK_H_(0x2A, 0x02)
#define REG_SC_BK2A_03_L      _PK_L_(0x2A, 0x03)
#define REG_SC_BK2A_03_H      _PK_H_(0x2A, 0x03)
#define REG_SC_BK2A_04_L      _PK_L_(0x2A, 0x04)
#define REG_SC_BK2A_04_H      _PK_H_(0x2A, 0x04)
#define REG_SC_BK2A_05_L      _PK_L_(0x2A, 0x05)
#define REG_SC_BK2A_05_H      _PK_H_(0x2A, 0x05)
#define REG_SC_BK2A_06_L      _PK_L_(0x2A, 0x06)
#define REG_SC_BK2A_06_H      _PK_H_(0x2A, 0x06)
#define REG_SC_BK2A_07_L      _PK_L_(0x2A, 0x07)
#define REG_SC_BK2A_07_H      _PK_H_(0x2A, 0x07)
#define REG_SC_BK2A_08_L      _PK_L_(0x2A, 0x08)
#define REG_SC_BK2A_08_H      _PK_H_(0x2A, 0x08)
#define REG_SC_BK2A_09_L      _PK_L_(0x2A, 0x09)
#define REG_SC_BK2A_09_H      _PK_H_(0x2A, 0x09)
#define REG_SC_BK2A_0A_L      _PK_L_(0x2A, 0x0A)
#define REG_SC_BK2A_0A_H      _PK_H_(0x2A, 0x0A)
#define REG_SC_BK2A_0B_L      _PK_L_(0x2A, 0x0B)
#define REG_SC_BK2A_0B_H      _PK_H_(0x2A, 0x0B)
#define REG_SC_BK2A_0C_L      _PK_L_(0x2A, 0x0C)
#define REG_SC_BK2A_0C_H      _PK_H_(0x2A, 0x0C)
#define REG_SC_BK2A_0D_L      _PK_L_(0x2A, 0x0D)
#define REG_SC_BK2A_0D_H      _PK_H_(0x2A, 0x0D)
#define REG_SC_BK2A_0E_L      _PK_L_(0x2A, 0x0E)
#define REG_SC_BK2A_0E_H      _PK_H_(0x2A, 0x0E)
#define REG_SC_BK2A_0F_L      _PK_L_(0x2A, 0x0F)
#define REG_SC_BK2A_0F_H      _PK_H_(0x2A, 0x0F)
#define REG_SC_BK2A_10_L      _PK_L_(0x2A, 0x10)
#define REG_SC_BK2A_10_H      _PK_H_(0x2A, 0x10)
#define REG_SC_BK2A_11_L      _PK_L_(0x2A, 0x11)
#define REG_SC_BK2A_11_H      _PK_H_(0x2A, 0x11)
#define REG_SC_BK2A_12_L      _PK_L_(0x2A, 0x12)
#define REG_SC_BK2A_12_H      _PK_H_(0x2A, 0x12)
#define REG_SC_BK2A_13_L      _PK_L_(0x2A, 0x13)
#define REG_SC_BK2A_13_H      _PK_H_(0x2A, 0x13)
#define REG_SC_BK2A_14_L      _PK_L_(0x2A, 0x14)
#define REG_SC_BK2A_14_H      _PK_H_(0x2A, 0x14)
#define REG_SC_BK2A_15_L      _PK_L_(0x2A, 0x15)
#define REG_SC_BK2A_15_H      _PK_H_(0x2A, 0x15)
#define REG_SC_BK2A_16_L      _PK_L_(0x2A, 0x16)
#define REG_SC_BK2A_16_H      _PK_H_(0x2A, 0x16)
#define REG_SC_BK2A_17_L      _PK_L_(0x2A, 0x17)
#define REG_SC_BK2A_17_H      _PK_H_(0x2A, 0x17)
#define REG_SC_BK2A_18_L      _PK_L_(0x2A, 0x18)
#define REG_SC_BK2A_18_H      _PK_H_(0x2A, 0x18)
#define REG_SC_BK2A_19_L      _PK_L_(0x2A, 0x19)
#define REG_SC_BK2A_19_H      _PK_H_(0x2A, 0x19)
#define REG_SC_BK2A_1A_L      _PK_L_(0x2A, 0x1A)
#define REG_SC_BK2A_1A_H      _PK_H_(0x2A, 0x1A)
#define REG_SC_BK2A_1B_L      _PK_L_(0x2A, 0x1B)
#define REG_SC_BK2A_1B_H      _PK_H_(0x2A, 0x1B)
#define REG_SC_BK2A_1C_L      _PK_L_(0x2A, 0x1C)
#define REG_SC_BK2A_1C_H      _PK_H_(0x2A, 0x1C)
#define REG_SC_BK2A_1D_L      _PK_L_(0x2A, 0x1D)
#define REG_SC_BK2A_1D_H      _PK_H_(0x2A, 0x1D)
#define REG_SC_BK2A_1E_L      _PK_L_(0x2A, 0x1E)
#define REG_SC_BK2A_1E_H      _PK_H_(0x2A, 0x1E)
#define REG_SC_BK2A_1F_L      _PK_L_(0x2A, 0x1F)
#define REG_SC_BK2A_1F_H      _PK_H_(0x2A, 0x1F)
#define REG_SC_BK2A_20_L      _PK_L_(0x2A, 0x20)
#define REG_SC_BK2A_20_H      _PK_H_(0x2A, 0x20)
#define REG_SC_BK2A_21_L      _PK_L_(0x2A, 0x21)
#define REG_SC_BK2A_21_H      _PK_H_(0x2A, 0x21)
#define REG_SC_BK2A_22_L      _PK_L_(0x2A, 0x22)
#define REG_SC_BK2A_22_H      _PK_H_(0x2A, 0x22)
#define REG_SC_BK2A_23_L      _PK_L_(0x2A, 0x23)
#define REG_SC_BK2A_23_H      _PK_H_(0x2A, 0x23)
#define REG_SC_BK2A_24_L      _PK_L_(0x2A, 0x24)
#define REG_SC_BK2A_24_H      _PK_H_(0x2A, 0x24)
#define REG_SC_BK2A_25_L      _PK_L_(0x2A, 0x25)
#define REG_SC_BK2A_25_H      _PK_H_(0x2A, 0x25)
#define REG_SC_BK2A_26_L      _PK_L_(0x2A, 0x26)
#define REG_SC_BK2A_26_H      _PK_H_(0x2A, 0x26)
#define REG_SC_BK2A_27_L      _PK_L_(0x2A, 0x27)
#define REG_SC_BK2A_27_H      _PK_H_(0x2A, 0x27)
#define REG_SC_BK2A_28_L      _PK_L_(0x2A, 0x28)
#define REG_SC_BK2A_28_H      _PK_H_(0x2A, 0x28)
#define REG_SC_BK2A_29_L      _PK_L_(0x2A, 0x29)
#define REG_SC_BK2A_29_H      _PK_H_(0x2A, 0x29)
#define REG_SC_BK2A_2A_L      _PK_L_(0x2A, 0x2A)
#define REG_SC_BK2A_2A_H      _PK_H_(0x2A, 0x2A)
#define REG_SC_BK2A_2B_L      _PK_L_(0x2A, 0x2B)
#define REG_SC_BK2A_2B_H      _PK_H_(0x2A, 0x2B)
#define REG_SC_BK2A_2C_L      _PK_L_(0x2A, 0x2C)
#define REG_SC_BK2A_2C_H      _PK_H_(0x2A, 0x2C)
#define REG_SC_BK2A_2D_L      _PK_L_(0x2A, 0x2D)
#define REG_SC_BK2A_2D_H      _PK_H_(0x2A, 0x2D)
#define REG_SC_BK2A_2E_L      _PK_L_(0x2A, 0x2E)
#define REG_SC_BK2A_2E_H      _PK_H_(0x2A, 0x2E)
#define REG_SC_BK2A_2F_L      _PK_L_(0x2A, 0x2F)
#define REG_SC_BK2A_2F_H      _PK_H_(0x2A, 0x2F)
#define REG_SC_BK2A_30_L      _PK_L_(0x2A, 0x30)
#define REG_SC_BK2A_30_H      _PK_H_(0x2A, 0x30)
#define REG_SC_BK2A_31_L      _PK_L_(0x2A, 0x31)
#define REG_SC_BK2A_31_H      _PK_H_(0x2A, 0x31)
#define REG_SC_BK2A_32_L      _PK_L_(0x2A, 0x32)
#define REG_SC_BK2A_32_H      _PK_H_(0x2A, 0x32)
#define REG_SC_BK2A_33_L      _PK_L_(0x2A, 0x33)
#define REG_SC_BK2A_33_H      _PK_H_(0x2A, 0x33)
#define REG_SC_BK2A_34_L      _PK_L_(0x2A, 0x34)
#define REG_SC_BK2A_34_H      _PK_H_(0x2A, 0x34)
#define REG_SC_BK2A_35_L      _PK_L_(0x2A, 0x35)
#define REG_SC_BK2A_35_H      _PK_H_(0x2A, 0x35)
#define REG_SC_BK2A_36_L      _PK_L_(0x2A, 0x36)
#define REG_SC_BK2A_36_H      _PK_H_(0x2A, 0x36)
#define REG_SC_BK2A_37_L      _PK_L_(0x2A, 0x37)
#define REG_SC_BK2A_37_H      _PK_H_(0x2A, 0x37)
#define REG_SC_BK2A_38_L      _PK_L_(0x2A, 0x38)
#define REG_SC_BK2A_38_H      _PK_H_(0x2A, 0x38)
#define REG_SC_BK2A_39_L      _PK_L_(0x2A, 0x39)
#define REG_SC_BK2A_39_H      _PK_H_(0x2A, 0x39)
#define REG_SC_BK2A_3A_L      _PK_L_(0x2A, 0x3A)
#define REG_SC_BK2A_3A_H      _PK_H_(0x2A, 0x3A)
#define REG_SC_BK2A_3B_L      _PK_L_(0x2A, 0x3B)
#define REG_SC_BK2A_3B_H      _PK_H_(0x2A, 0x3B)
#define REG_SC_BK2A_3C_L      _PK_L_(0x2A, 0x3C)
#define REG_SC_BK2A_3C_H      _PK_H_(0x2A, 0x3C)
#define REG_SC_BK2A_3D_L      _PK_L_(0x2A, 0x3D)
#define REG_SC_BK2A_3D_H      _PK_H_(0x2A, 0x3D)
#define REG_SC_BK2A_3E_L      _PK_L_(0x2A, 0x3E)
#define REG_SC_BK2A_3E_H      _PK_H_(0x2A, 0x3E)
#define REG_SC_BK2A_3F_L      _PK_L_(0x2A, 0x3F)
#define REG_SC_BK2A_3F_H      _PK_H_(0x2A, 0x3F)
#define REG_SC_BK2A_40_L      _PK_L_(0x2A, 0x40)
#define REG_SC_BK2A_40_H      _PK_H_(0x2A, 0x40)
#define REG_SC_BK2A_41_L      _PK_L_(0x2A, 0x41)
#define REG_SC_BK2A_41_H      _PK_H_(0x2A, 0x41)
#define REG_SC_BK2A_42_L      _PK_L_(0x2A, 0x42)
#define REG_SC_BK2A_42_H      _PK_H_(0x2A, 0x42)
#define REG_SC_BK2A_43_L      _PK_L_(0x2A, 0x43)
#define REG_SC_BK2A_43_H      _PK_H_(0x2A, 0x43)
#define REG_SC_BK2A_44_L      _PK_L_(0x2A, 0x44)
#define REG_SC_BK2A_44_H      _PK_H_(0x2A, 0x44)
#define REG_SC_BK2A_45_L      _PK_L_(0x2A, 0x45)
#define REG_SC_BK2A_45_H      _PK_H_(0x2A, 0x45)
#define REG_SC_BK2A_46_L      _PK_L_(0x2A, 0x46)
#define REG_SC_BK2A_46_H      _PK_H_(0x2A, 0x46)
#define REG_SC_BK2A_47_L      _PK_L_(0x2A, 0x47)
#define REG_SC_BK2A_47_H      _PK_H_(0x2A, 0x47)
#define REG_SC_BK2A_48_L      _PK_L_(0x2A, 0x48)
#define REG_SC_BK2A_48_H      _PK_H_(0x2A, 0x48)
#define REG_SC_BK2A_49_L      _PK_L_(0x2A, 0x49)
#define REG_SC_BK2A_49_H      _PK_H_(0x2A, 0x49)
#define REG_SC_BK2A_4A_L      _PK_L_(0x2A, 0x4A)
#define REG_SC_BK2A_4A_H      _PK_H_(0x2A, 0x4A)
#define REG_SC_BK2A_4B_L      _PK_L_(0x2A, 0x4B)
#define REG_SC_BK2A_4B_H      _PK_H_(0x2A, 0x4B)
#define REG_SC_BK2A_4C_L      _PK_L_(0x2A, 0x4C)
#define REG_SC_BK2A_4C_H      _PK_H_(0x2A, 0x4C)
#define REG_SC_BK2A_4D_L      _PK_L_(0x2A, 0x4D)
#define REG_SC_BK2A_4D_H      _PK_H_(0x2A, 0x4D)
#define REG_SC_BK2A_4E_L      _PK_L_(0x2A, 0x4E)
#define REG_SC_BK2A_4E_H      _PK_H_(0x2A, 0x4E)
#define REG_SC_BK2A_4F_L      _PK_L_(0x2A, 0x4F)
#define REG_SC_BK2A_4F_H      _PK_H_(0x2A, 0x4F)
#define REG_SC_BK2A_50_L      _PK_L_(0x2A, 0x50)
#define REG_SC_BK2A_50_H      _PK_H_(0x2A, 0x50)
#define REG_SC_BK2A_51_L      _PK_L_(0x2A, 0x51)
#define REG_SC_BK2A_51_H      _PK_H_(0x2A, 0x51)
#define REG_SC_BK2A_52_L      _PK_L_(0x2A, 0x52)
#define REG_SC_BK2A_52_H      _PK_H_(0x2A, 0x52)
#define REG_SC_BK2A_53_L      _PK_L_(0x2A, 0x53)
#define REG_SC_BK2A_53_H      _PK_H_(0x2A, 0x53)
#define REG_SC_BK2A_54_L      _PK_L_(0x2A, 0x54)
#define REG_SC_BK2A_54_H      _PK_H_(0x2A, 0x54)
#define REG_SC_BK2A_55_L      _PK_L_(0x2A, 0x55)
#define REG_SC_BK2A_55_H      _PK_H_(0x2A, 0x55)
#define REG_SC_BK2A_56_L      _PK_L_(0x2A, 0x56)
#define REG_SC_BK2A_56_H      _PK_H_(0x2A, 0x56)
#define REG_SC_BK2A_57_L      _PK_L_(0x2A, 0x57)
#define REG_SC_BK2A_57_H      _PK_H_(0x2A, 0x57)
#define REG_SC_BK2A_58_L      _PK_L_(0x2A, 0x58)
#define REG_SC_BK2A_58_H      _PK_H_(0x2A, 0x58)
#define REG_SC_BK2A_59_L      _PK_L_(0x2A, 0x59)
#define REG_SC_BK2A_59_H      _PK_H_(0x2A, 0x59)
#define REG_SC_BK2A_5A_L      _PK_L_(0x2A, 0x5A)
#define REG_SC_BK2A_5A_H      _PK_H_(0x2A, 0x5A)
#define REG_SC_BK2A_5B_L      _PK_L_(0x2A, 0x5B)
#define REG_SC_BK2A_5B_H      _PK_H_(0x2A, 0x5B)
#define REG_SC_BK2A_5C_L      _PK_L_(0x2A, 0x5C)
#define REG_SC_BK2A_5C_H      _PK_H_(0x2A, 0x5C)
#define REG_SC_BK2A_5D_L      _PK_L_(0x2A, 0x5D)
#define REG_SC_BK2A_5D_H      _PK_H_(0x2A, 0x5D)
#define REG_SC_BK2A_5E_L      _PK_L_(0x2A, 0x5E)
#define REG_SC_BK2A_5E_H      _PK_H_(0x2A, 0x5E)
#define REG_SC_BK2A_5F_L      _PK_L_(0x2A, 0x5F)
#define REG_SC_BK2A_5F_H      _PK_H_(0x2A, 0x5F)
#define REG_SC_BK2A_60_L      _PK_L_(0x2A, 0x60)
#define REG_SC_BK2A_60_H      _PK_H_(0x2A, 0x60)
#define REG_SC_BK2A_61_L      _PK_L_(0x2A, 0x61)
#define REG_SC_BK2A_61_H      _PK_H_(0x2A, 0x61)
#define REG_SC_BK2A_62_L      _PK_L_(0x2A, 0x62)
#define REG_SC_BK2A_62_H      _PK_H_(0x2A, 0x62)
#define REG_SC_BK2A_63_L      _PK_L_(0x2A, 0x63)
#define REG_SC_BK2A_63_H      _PK_H_(0x2A, 0x63)
#define REG_SC_BK2A_64_L      _PK_L_(0x2A, 0x64)
#define REG_SC_BK2A_64_H      _PK_H_(0x2A, 0x64)
#define REG_SC_BK2A_65_L      _PK_L_(0x2A, 0x65)
#define REG_SC_BK2A_65_H      _PK_H_(0x2A, 0x65)
#define REG_SC_BK2A_66_L      _PK_L_(0x2A, 0x66)
#define REG_SC_BK2A_66_H      _PK_H_(0x2A, 0x66)
#define REG_SC_BK2A_67_L      _PK_L_(0x2A, 0x67)
#define REG_SC_BK2A_67_H      _PK_H_(0x2A, 0x67)
#define REG_SC_BK2A_68_L      _PK_L_(0x2A, 0x68)
#define REG_SC_BK2A_68_H      _PK_H_(0x2A, 0x68)
#define REG_SC_BK2A_69_L      _PK_L_(0x2A, 0x69)
#define REG_SC_BK2A_69_H      _PK_H_(0x2A, 0x69)
#define REG_SC_BK2A_6A_L      _PK_L_(0x2A, 0x6A)
#define REG_SC_BK2A_6A_H      _PK_H_(0x2A, 0x6A)
#define REG_SC_BK2A_6B_L      _PK_L_(0x2A, 0x6B)
#define REG_SC_BK2A_6B_H      _PK_H_(0x2A, 0x6B)
#define REG_SC_BK2A_6C_L      _PK_L_(0x2A, 0x6C)
#define REG_SC_BK2A_6C_H      _PK_H_(0x2A, 0x6C)
#define REG_SC_BK2A_6D_L      _PK_L_(0x2A, 0x6D)
#define REG_SC_BK2A_6D_H      _PK_H_(0x2A, 0x6D)
#define REG_SC_BK2A_6E_L      _PK_L_(0x2A, 0x6E)
#define REG_SC_BK2A_6E_H      _PK_H_(0x2A, 0x6E)
#define REG_SC_BK2A_6F_L      _PK_L_(0x2A, 0x6F)
#define REG_SC_BK2A_6F_H      _PK_H_(0x2A, 0x6F)
#define REG_SC_BK2A_70_L      _PK_L_(0x2A, 0x70)
#define REG_SC_BK2A_70_H      _PK_H_(0x2A, 0x70)
#define REG_SC_BK2A_71_L      _PK_L_(0x2A, 0x71)
#define REG_SC_BK2A_71_H      _PK_H_(0x2A, 0x71)
#define REG_SC_BK2A_72_L      _PK_L_(0x2A, 0x72)
#define REG_SC_BK2A_72_H      _PK_H_(0x2A, 0x72)
#define REG_SC_BK2A_73_L      _PK_L_(0x2A, 0x73)
#define REG_SC_BK2A_73_H      _PK_H_(0x2A, 0x73)
#define REG_SC_BK2A_74_L      _PK_L_(0x2A, 0x74)
#define REG_SC_BK2A_74_H      _PK_H_(0x2A, 0x74)
#define REG_SC_BK2A_75_L      _PK_L_(0x2A, 0x75)
#define REG_SC_BK2A_75_H      _PK_H_(0x2A, 0x75)
#define REG_SC_BK2A_76_L      _PK_L_(0x2A, 0x76)
#define REG_SC_BK2A_76_H      _PK_H_(0x2A, 0x76)
#define REG_SC_BK2A_77_L      _PK_L_(0x2A, 0x77)
#define REG_SC_BK2A_77_H      _PK_H_(0x2A, 0x77)
#define REG_SC_BK2A_78_L      _PK_L_(0x2A, 0x78)
#define REG_SC_BK2A_78_H      _PK_H_(0x2A, 0x78)
#define REG_SC_BK2A_79_L      _PK_L_(0x2A, 0x79)
#define REG_SC_BK2A_79_H      _PK_H_(0x2A, 0x79)
#define REG_SC_BK2A_7A_L      _PK_L_(0x2A, 0x7A)
#define REG_SC_BK2A_7A_H      _PK_H_(0x2A, 0x7A)
#define REG_SC_BK2A_7B_L      _PK_L_(0x2A, 0x7B)
#define REG_SC_BK2A_7B_H      _PK_H_(0x2A, 0x7B)
#define REG_SC_BK2A_7C_L      _PK_L_(0x2A, 0x7C)
#define REG_SC_BK2A_7C_H      _PK_H_(0x2A, 0x7C)
#define REG_SC_BK2A_7D_L      _PK_L_(0x2A, 0x7D)
#define REG_SC_BK2A_7D_H      _PK_H_(0x2A, 0x7D)
#define REG_SC_BK2A_7E_L      _PK_L_(0x2A, 0x7E)
#define REG_SC_BK2A_7E_H      _PK_H_(0x2A, 0x7E)
#define REG_SC_BK2A_7F_L      _PK_L_(0x2A, 0x7F)
#define REG_SC_BK2A_7F_H      _PK_H_(0x2A, 0x7F)
//----------------------------------------------
#define REG_SC_BK2B_00_L      _PK_L_(0x2B, 0x00)
#define REG_SC_BK2B_00_H      _PK_H_(0x2B, 0x00)
#define REG_SC_BK2B_01_L      _PK_L_(0x2B, 0x01)
#define REG_SC_BK2B_01_H      _PK_H_(0x2B, 0x01)
#define REG_SC_BK2B_02_L      _PK_L_(0x2B, 0x02)
#define REG_SC_BK2B_02_H      _PK_H_(0x2B, 0x02)
#define REG_SC_BK2B_03_L      _PK_L_(0x2B, 0x03)
#define REG_SC_BK2B_03_H      _PK_H_(0x2B, 0x03)
#define REG_SC_BK2B_04_L      _PK_L_(0x2B, 0x04)
#define REG_SC_BK2B_04_H      _PK_H_(0x2B, 0x04)
#define REG_SC_BK2B_05_L      _PK_L_(0x2B, 0x05)
#define REG_SC_BK2B_05_H      _PK_H_(0x2B, 0x05)
#define REG_SC_BK2B_06_L      _PK_L_(0x2B, 0x06)
#define REG_SC_BK2B_06_H      _PK_H_(0x2B, 0x06)
#define REG_SC_BK2B_07_L      _PK_L_(0x2B, 0x07)
#define REG_SC_BK2B_07_H      _PK_H_(0x2B, 0x07)
#define REG_SC_BK2B_08_L      _PK_L_(0x2B, 0x08)
#define REG_SC_BK2B_08_H      _PK_H_(0x2B, 0x08)
#define REG_SC_BK2B_09_L      _PK_L_(0x2B, 0x09)
#define REG_SC_BK2B_09_H      _PK_H_(0x2B, 0x09)
#define REG_SC_BK2B_0A_L      _PK_L_(0x2B, 0x0A)
#define REG_SC_BK2B_0A_H      _PK_H_(0x2B, 0x0A)
#define REG_SC_BK2B_0B_L      _PK_L_(0x2B, 0x0B)
#define REG_SC_BK2B_0B_H      _PK_H_(0x2B, 0x0B)
#define REG_SC_BK2B_0C_L      _PK_L_(0x2B, 0x0C)
#define REG_SC_BK2B_0C_H      _PK_H_(0x2B, 0x0C)
#define REG_SC_BK2B_0D_L      _PK_L_(0x2B, 0x0D)
#define REG_SC_BK2B_0D_H      _PK_H_(0x2B, 0x0D)
#define REG_SC_BK2B_0E_L      _PK_L_(0x2B, 0x0E)
#define REG_SC_BK2B_0E_H      _PK_H_(0x2B, 0x0E)
#define REG_SC_BK2B_0F_L      _PK_L_(0x2B, 0x0F)
#define REG_SC_BK2B_0F_H      _PK_H_(0x2B, 0x0F)
#define REG_SC_BK2B_10_L      _PK_L_(0x2B, 0x10)
#define REG_SC_BK2B_10_H      _PK_H_(0x2B, 0x10)
#define REG_SC_BK2B_11_L      _PK_L_(0x2B, 0x11)
#define REG_SC_BK2B_11_H      _PK_H_(0x2B, 0x11)
#define REG_SC_BK2B_12_L      _PK_L_(0x2B, 0x12)
#define REG_SC_BK2B_12_H      _PK_H_(0x2B, 0x12)
#define REG_SC_BK2B_13_L      _PK_L_(0x2B, 0x13)
#define REG_SC_BK2B_13_H      _PK_H_(0x2B, 0x13)
#define REG_SC_BK2B_14_L      _PK_L_(0x2B, 0x14)
#define REG_SC_BK2B_14_H      _PK_H_(0x2B, 0x14)
#define REG_SC_BK2B_15_L      _PK_L_(0x2B, 0x15)
#define REG_SC_BK2B_15_H      _PK_H_(0x2B, 0x15)
#define REG_SC_BK2B_16_L      _PK_L_(0x2B, 0x16)
#define REG_SC_BK2B_16_H      _PK_H_(0x2B, 0x16)
#define REG_SC_BK2B_17_L      _PK_L_(0x2B, 0x17)
#define REG_SC_BK2B_17_H      _PK_H_(0x2B, 0x17)
#define REG_SC_BK2B_18_L      _PK_L_(0x2B, 0x18)
#define REG_SC_BK2B_18_H      _PK_H_(0x2B, 0x18)
#define REG_SC_BK2B_19_L      _PK_L_(0x2B, 0x19)
#define REG_SC_BK2B_19_H      _PK_H_(0x2B, 0x19)
#define REG_SC_BK2B_1A_L      _PK_L_(0x2B, 0x1A)
#define REG_SC_BK2B_1A_H      _PK_H_(0x2B, 0x1A)
#define REG_SC_BK2B_1B_L      _PK_L_(0x2B, 0x1B)
#define REG_SC_BK2B_1B_H      _PK_H_(0x2B, 0x1B)
#define REG_SC_BK2B_1C_L      _PK_L_(0x2B, 0x1C)
#define REG_SC_BK2B_1C_H      _PK_H_(0x2B, 0x1C)
#define REG_SC_BK2B_1D_L      _PK_L_(0x2B, 0x1D)
#define REG_SC_BK2B_1D_H      _PK_H_(0x2B, 0x1D)
#define REG_SC_BK2B_1E_L      _PK_L_(0x2B, 0x1E)
#define REG_SC_BK2B_1E_H      _PK_H_(0x2B, 0x1E)
#define REG_SC_BK2B_1F_L      _PK_L_(0x2B, 0x1F)
#define REG_SC_BK2B_1F_H      _PK_H_(0x2B, 0x1F)
#define REG_SC_BK2B_20_L      _PK_L_(0x2B, 0x20)
#define REG_SC_BK2B_20_H      _PK_H_(0x2B, 0x20)
#define REG_SC_BK2B_21_L      _PK_L_(0x2B, 0x21)
#define REG_SC_BK2B_21_H      _PK_H_(0x2B, 0x21)
#define REG_SC_BK2B_22_L      _PK_L_(0x2B, 0x22)
#define REG_SC_BK2B_22_H      _PK_H_(0x2B, 0x22)
#define REG_SC_BK2B_23_L      _PK_L_(0x2B, 0x23)
#define REG_SC_BK2B_23_H      _PK_H_(0x2B, 0x23)
#define REG_SC_BK2B_24_L      _PK_L_(0x2B, 0x24)
#define REG_SC_BK2B_24_H      _PK_H_(0x2B, 0x24)
#define REG_SC_BK2B_25_L      _PK_L_(0x2B, 0x25)
#define REG_SC_BK2B_25_H      _PK_H_(0x2B, 0x25)
#define REG_SC_BK2B_26_L      _PK_L_(0x2B, 0x26)
#define REG_SC_BK2B_26_H      _PK_H_(0x2B, 0x26)
#define REG_SC_BK2B_27_L      _PK_L_(0x2B, 0x27)
#define REG_SC_BK2B_27_H      _PK_H_(0x2B, 0x27)
#define REG_SC_BK2B_28_L      _PK_L_(0x2B, 0x28)
#define REG_SC_BK2B_28_H      _PK_H_(0x2B, 0x28)
#define REG_SC_BK2B_29_L      _PK_L_(0x2B, 0x29)
#define REG_SC_BK2B_29_H      _PK_H_(0x2B, 0x29)
#define REG_SC_BK2B_2A_L      _PK_L_(0x2B, 0x2A)
#define REG_SC_BK2B_2A_H      _PK_H_(0x2B, 0x2A)
#define REG_SC_BK2B_2B_L      _PK_L_(0x2B, 0x2B)
#define REG_SC_BK2B_2B_H      _PK_H_(0x2B, 0x2B)
#define REG_SC_BK2B_2C_L      _PK_L_(0x2B, 0x2C)
#define REG_SC_BK2B_2C_H      _PK_H_(0x2B, 0x2C)
#define REG_SC_BK2B_2D_L      _PK_L_(0x2B, 0x2D)
#define REG_SC_BK2B_2D_H      _PK_H_(0x2B, 0x2D)
#define REG_SC_BK2B_2E_L      _PK_L_(0x2B, 0x2E)
#define REG_SC_BK2B_2E_H      _PK_H_(0x2B, 0x2E)
#define REG_SC_BK2B_2F_L      _PK_L_(0x2B, 0x2F)
#define REG_SC_BK2B_2F_H      _PK_H_(0x2B, 0x2F)
#define REG_SC_BK2B_30_L      _PK_L_(0x2B, 0x30)
#define REG_SC_BK2B_30_H      _PK_H_(0x2B, 0x30)
#define REG_SC_BK2B_31_L      _PK_L_(0x2B, 0x31)
#define REG_SC_BK2B_31_H      _PK_H_(0x2B, 0x31)
#define REG_SC_BK2B_32_L      _PK_L_(0x2B, 0x32)
#define REG_SC_BK2B_32_H      _PK_H_(0x2B, 0x32)
#define REG_SC_BK2B_33_L      _PK_L_(0x2B, 0x33)
#define REG_SC_BK2B_33_H      _PK_H_(0x2B, 0x33)
#define REG_SC_BK2B_34_L      _PK_L_(0x2B, 0x34)
#define REG_SC_BK2B_34_H      _PK_H_(0x2B, 0x34)
#define REG_SC_BK2B_35_L      _PK_L_(0x2B, 0x35)
#define REG_SC_BK2B_35_H      _PK_H_(0x2B, 0x35)
#define REG_SC_BK2B_36_L      _PK_L_(0x2B, 0x36)
#define REG_SC_BK2B_36_H      _PK_H_(0x2B, 0x36)
#define REG_SC_BK2B_37_L      _PK_L_(0x2B, 0x37)
#define REG_SC_BK2B_37_H      _PK_H_(0x2B, 0x37)
#define REG_SC_BK2B_38_L      _PK_L_(0x2B, 0x38)
#define REG_SC_BK2B_38_H      _PK_H_(0x2B, 0x38)
#define REG_SC_BK2B_39_L      _PK_L_(0x2B, 0x39)
#define REG_SC_BK2B_39_H      _PK_H_(0x2B, 0x39)
#define REG_SC_BK2B_3A_L      _PK_L_(0x2B, 0x3A)
#define REG_SC_BK2B_3A_H      _PK_H_(0x2B, 0x3A)
#define REG_SC_BK2B_3B_L      _PK_L_(0x2B, 0x3B)
#define REG_SC_BK2B_3B_H      _PK_H_(0x2B, 0x3B)
#define REG_SC_BK2B_3C_L      _PK_L_(0x2B, 0x3C)
#define REG_SC_BK2B_3C_H      _PK_H_(0x2B, 0x3C)
#define REG_SC_BK2B_3D_L      _PK_L_(0x2B, 0x3D)
#define REG_SC_BK2B_3D_H      _PK_H_(0x2B, 0x3D)
#define REG_SC_BK2B_3E_L      _PK_L_(0x2B, 0x3E)
#define REG_SC_BK2B_3E_H      _PK_H_(0x2B, 0x3E)
#define REG_SC_BK2B_3F_L      _PK_L_(0x2B, 0x3F)
#define REG_SC_BK2B_3F_H      _PK_H_(0x2B, 0x3F)
#define REG_SC_BK2B_40_L      _PK_L_(0x2B, 0x40)
#define REG_SC_BK2B_40_H      _PK_H_(0x2B, 0x40)
#define REG_SC_BK2B_41_L      _PK_L_(0x2B, 0x41)
#define REG_SC_BK2B_41_H      _PK_H_(0x2B, 0x41)
#define REG_SC_BK2B_42_L      _PK_L_(0x2B, 0x42)
#define REG_SC_BK2B_42_H      _PK_H_(0x2B, 0x42)
#define REG_SC_BK2B_43_L      _PK_L_(0x2B, 0x43)
#define REG_SC_BK2B_43_H      _PK_H_(0x2B, 0x43)
#define REG_SC_BK2B_44_L      _PK_L_(0x2B, 0x44)
#define REG_SC_BK2B_44_H      _PK_H_(0x2B, 0x44)
#define REG_SC_BK2B_45_L      _PK_L_(0x2B, 0x45)
#define REG_SC_BK2B_45_H      _PK_H_(0x2B, 0x45)
#define REG_SC_BK2B_46_L      _PK_L_(0x2B, 0x46)
#define REG_SC_BK2B_46_H      _PK_H_(0x2B, 0x46)
#define REG_SC_BK2B_47_L      _PK_L_(0x2B, 0x47)
#define REG_SC_BK2B_47_H      _PK_H_(0x2B, 0x47)
#define REG_SC_BK2B_48_L      _PK_L_(0x2B, 0x48)
#define REG_SC_BK2B_48_H      _PK_H_(0x2B, 0x48)
#define REG_SC_BK2B_49_L      _PK_L_(0x2B, 0x49)
#define REG_SC_BK2B_49_H      _PK_H_(0x2B, 0x49)
#define REG_SC_BK2B_4A_L      _PK_L_(0x2B, 0x4A)
#define REG_SC_BK2B_4A_H      _PK_H_(0x2B, 0x4A)
#define REG_SC_BK2B_4B_L      _PK_L_(0x2B, 0x4B)
#define REG_SC_BK2B_4B_H      _PK_H_(0x2B, 0x4B)
#define REG_SC_BK2B_4C_L      _PK_L_(0x2B, 0x4C)
#define REG_SC_BK2B_4C_H      _PK_H_(0x2B, 0x4C)
#define REG_SC_BK2B_4D_L      _PK_L_(0x2B, 0x4D)
#define REG_SC_BK2B_4D_H      _PK_H_(0x2B, 0x4D)
#define REG_SC_BK2B_4E_L      _PK_L_(0x2B, 0x4E)
#define REG_SC_BK2B_4E_H      _PK_H_(0x2B, 0x4E)
#define REG_SC_BK2B_4F_L      _PK_L_(0x2B, 0x4F)
#define REG_SC_BK2B_4F_H      _PK_H_(0x2B, 0x4F)
#define REG_SC_BK2B_50_L      _PK_L_(0x2B, 0x50)
#define REG_SC_BK2B_50_H      _PK_H_(0x2B, 0x50)
#define REG_SC_BK2B_51_L      _PK_L_(0x2B, 0x51)
#define REG_SC_BK2B_51_H      _PK_H_(0x2B, 0x51)
#define REG_SC_BK2B_52_L      _PK_L_(0x2B, 0x52)
#define REG_SC_BK2B_52_H      _PK_H_(0x2B, 0x52)
#define REG_SC_BK2B_53_L      _PK_L_(0x2B, 0x53)
#define REG_SC_BK2B_53_H      _PK_H_(0x2B, 0x53)
#define REG_SC_BK2B_54_L      _PK_L_(0x2B, 0x54)
#define REG_SC_BK2B_54_H      _PK_H_(0x2B, 0x54)
#define REG_SC_BK2B_55_L      _PK_L_(0x2B, 0x55)
#define REG_SC_BK2B_55_H      _PK_H_(0x2B, 0x55)
#define REG_SC_BK2B_56_L      _PK_L_(0x2B, 0x56)
#define REG_SC_BK2B_56_H      _PK_H_(0x2B, 0x56)
#define REG_SC_BK2B_57_L      _PK_L_(0x2B, 0x57)
#define REG_SC_BK2B_57_H      _PK_H_(0x2B, 0x57)
#define REG_SC_BK2B_58_L      _PK_L_(0x2B, 0x58)
#define REG_SC_BK2B_58_H      _PK_H_(0x2B, 0x58)
#define REG_SC_BK2B_59_L      _PK_L_(0x2B, 0x59)
#define REG_SC_BK2B_59_H      _PK_H_(0x2B, 0x59)
#define REG_SC_BK2B_5A_L      _PK_L_(0x2B, 0x5A)
#define REG_SC_BK2B_5A_H      _PK_H_(0x2B, 0x5A)
#define REG_SC_BK2B_5B_L      _PK_L_(0x2B, 0x5B)
#define REG_SC_BK2B_5B_H      _PK_H_(0x2B, 0x5B)
#define REG_SC_BK2B_5C_L      _PK_L_(0x2B, 0x5C)
#define REG_SC_BK2B_5C_H      _PK_H_(0x2B, 0x5C)
#define REG_SC_BK2B_5D_L      _PK_L_(0x2B, 0x5D)
#define REG_SC_BK2B_5D_H      _PK_H_(0x2B, 0x5D)
#define REG_SC_BK2B_5E_L      _PK_L_(0x2B, 0x5E)
#define REG_SC_BK2B_5E_H      _PK_H_(0x2B, 0x5E)
#define REG_SC_BK2B_5F_L      _PK_L_(0x2B, 0x5F)
#define REG_SC_BK2B_5F_H      _PK_H_(0x2B, 0x5F)
#define REG_SC_BK2B_60_L      _PK_L_(0x2B, 0x60)
#define REG_SC_BK2B_60_H      _PK_H_(0x2B, 0x60)
#define REG_SC_BK2B_61_L      _PK_L_(0x2B, 0x61)
#define REG_SC_BK2B_61_H      _PK_H_(0x2B, 0x61)
#define REG_SC_BK2B_62_L      _PK_L_(0x2B, 0x62)
#define REG_SC_BK2B_62_H      _PK_H_(0x2B, 0x62)
#define REG_SC_BK2B_63_L      _PK_L_(0x2B, 0x63)
#define REG_SC_BK2B_63_H      _PK_H_(0x2B, 0x63)
#define REG_SC_BK2B_64_L      _PK_L_(0x2B, 0x64)
#define REG_SC_BK2B_64_H      _PK_H_(0x2B, 0x64)
#define REG_SC_BK2B_65_L      _PK_L_(0x2B, 0x65)
#define REG_SC_BK2B_65_H      _PK_H_(0x2B, 0x65)
#define REG_SC_BK2B_66_L      _PK_L_(0x2B, 0x66)
#define REG_SC_BK2B_66_H      _PK_H_(0x2B, 0x66)
#define REG_SC_BK2B_67_L      _PK_L_(0x2B, 0x67)
#define REG_SC_BK2B_67_H      _PK_H_(0x2B, 0x67)
#define REG_SC_BK2B_68_L      _PK_L_(0x2B, 0x68)
#define REG_SC_BK2B_68_H      _PK_H_(0x2B, 0x68)
#define REG_SC_BK2B_69_L      _PK_L_(0x2B, 0x69)
#define REG_SC_BK2B_69_H      _PK_H_(0x2B, 0x69)
#define REG_SC_BK2B_6A_L      _PK_L_(0x2B, 0x6A)
#define REG_SC_BK2B_6A_H      _PK_H_(0x2B, 0x6A)
#define REG_SC_BK2B_6B_L      _PK_L_(0x2B, 0x6B)
#define REG_SC_BK2B_6B_H      _PK_H_(0x2B, 0x6B)
#define REG_SC_BK2B_6C_L      _PK_L_(0x2B, 0x6C)
#define REG_SC_BK2B_6C_H      _PK_H_(0x2B, 0x6C)
#define REG_SC_BK2B_6D_L      _PK_L_(0x2B, 0x6D)
#define REG_SC_BK2B_6D_H      _PK_H_(0x2B, 0x6D)
#define REG_SC_BK2B_6E_L      _PK_L_(0x2B, 0x6E)
#define REG_SC_BK2B_6E_H      _PK_H_(0x2B, 0x6E)
#define REG_SC_BK2B_6F_L      _PK_L_(0x2B, 0x6F)
#define REG_SC_BK2B_6F_H      _PK_H_(0x2B, 0x6F)
#define REG_SC_BK2B_70_L      _PK_L_(0x2B, 0x70)
#define REG_SC_BK2B_70_H      _PK_H_(0x2B, 0x70)
#define REG_SC_BK2B_71_L      _PK_L_(0x2B, 0x71)
#define REG_SC_BK2B_71_H      _PK_H_(0x2B, 0x71)
#define REG_SC_BK2B_72_L      _PK_L_(0x2B, 0x72)
#define REG_SC_BK2B_72_H      _PK_H_(0x2B, 0x72)
#define REG_SC_BK2B_73_L      _PK_L_(0x2B, 0x73)
#define REG_SC_BK2B_73_H      _PK_H_(0x2B, 0x73)
#define REG_SC_BK2B_74_L      _PK_L_(0x2B, 0x74)
#define REG_SC_BK2B_74_H      _PK_H_(0x2B, 0x74)
#define REG_SC_BK2B_75_L      _PK_L_(0x2B, 0x75)
#define REG_SC_BK2B_75_H      _PK_H_(0x2B, 0x75)
#define REG_SC_BK2B_76_L      _PK_L_(0x2B, 0x76)
#define REG_SC_BK2B_76_H      _PK_H_(0x2B, 0x76)
#define REG_SC_BK2B_77_L      _PK_L_(0x2B, 0x77)
#define REG_SC_BK2B_77_H      _PK_H_(0x2B, 0x77)
#define REG_SC_BK2B_78_L      _PK_L_(0x2B, 0x78)
#define REG_SC_BK2B_78_H      _PK_H_(0x2B, 0x78)
#define REG_SC_BK2B_79_L      _PK_L_(0x2B, 0x79)
#define REG_SC_BK2B_79_H      _PK_H_(0x2B, 0x79)
#define REG_SC_BK2B_7A_L      _PK_L_(0x2B, 0x7A)
#define REG_SC_BK2B_7A_H      _PK_H_(0x2B, 0x7A)
#define REG_SC_BK2B_7B_L      _PK_L_(0x2B, 0x7B)
#define REG_SC_BK2B_7B_H      _PK_H_(0x2B, 0x7B)
#define REG_SC_BK2B_7C_L      _PK_L_(0x2B, 0x7C)
#define REG_SC_BK2B_7C_H      _PK_H_(0x2B, 0x7C)
#define REG_SC_BK2B_7D_L      _PK_L_(0x2B, 0x7D)
#define REG_SC_BK2B_7D_H      _PK_H_(0x2B, 0x7D)
#define REG_SC_BK2B_7E_L      _PK_L_(0x2B, 0x7E)
#define REG_SC_BK2B_7E_H      _PK_H_(0x2B, 0x7E)
#define REG_SC_BK2B_7F_L      _PK_L_(0x2B, 0x7F)
#define REG_SC_BK2B_7F_H      _PK_H_(0x2B, 0x7F)
//----------------------------------------------
#define REG_SC_BK2C_00_L      _PK_L_(0x2C, 0x00)
#define REG_SC_BK2C_00_H      _PK_H_(0x2C, 0x00)
#define REG_SC_BK2C_01_L      _PK_L_(0x2C, 0x01)
#define REG_SC_BK2C_01_H      _PK_H_(0x2C, 0x01)
#define REG_SC_BK2C_02_L      _PK_L_(0x2C, 0x02)
#define REG_SC_BK2C_02_H      _PK_H_(0x2C, 0x02)
#define REG_SC_BK2C_03_L      _PK_L_(0x2C, 0x03)
#define REG_SC_BK2C_03_H      _PK_H_(0x2C, 0x03)
#define REG_SC_BK2C_04_L      _PK_L_(0x2C, 0x04)
#define REG_SC_BK2C_04_H      _PK_H_(0x2C, 0x04)
#define REG_SC_BK2C_05_L      _PK_L_(0x2C, 0x05)
#define REG_SC_BK2C_05_H      _PK_H_(0x2C, 0x05)
#define REG_SC_BK2C_06_L      _PK_L_(0x2C, 0x06)
#define REG_SC_BK2C_06_H      _PK_H_(0x2C, 0x06)
#define REG_SC_BK2C_07_L      _PK_L_(0x2C, 0x07)
#define REG_SC_BK2C_07_H      _PK_H_(0x2C, 0x07)
#define REG_SC_BK2C_08_L      _PK_L_(0x2C, 0x08)
#define REG_SC_BK2C_08_H      _PK_H_(0x2C, 0x08)
#define REG_SC_BK2C_09_L      _PK_L_(0x2C, 0x09)
#define REG_SC_BK2C_09_H      _PK_H_(0x2C, 0x09)
#define REG_SC_BK2C_0A_L      _PK_L_(0x2C, 0x0A)
#define REG_SC_BK2C_0A_H      _PK_H_(0x2C, 0x0A)
#define REG_SC_BK2C_0B_L      _PK_L_(0x2C, 0x0B)
#define REG_SC_BK2C_0B_H      _PK_H_(0x2C, 0x0B)
#define REG_SC_BK2C_0C_L      _PK_L_(0x2C, 0x0C)
#define REG_SC_BK2C_0C_H      _PK_H_(0x2C, 0x0C)
#define REG_SC_BK2C_0D_L      _PK_L_(0x2C, 0x0D)
#define REG_SC_BK2C_0D_H      _PK_H_(0x2C, 0x0D)
#define REG_SC_BK2C_0E_L      _PK_L_(0x2C, 0x0E)
#define REG_SC_BK2C_0E_H      _PK_H_(0x2C, 0x0E)
#define REG_SC_BK2C_0F_L      _PK_L_(0x2C, 0x0F)
#define REG_SC_BK2C_0F_H      _PK_H_(0x2C, 0x0F)
#define REG_SC_BK2C_10_L      _PK_L_(0x2C, 0x10)
#define REG_SC_BK2C_10_H      _PK_H_(0x2C, 0x10)
#define REG_SC_BK2C_11_L      _PK_L_(0x2C, 0x11)
#define REG_SC_BK2C_11_H      _PK_H_(0x2C, 0x11)
#define REG_SC_BK2C_12_L      _PK_L_(0x2C, 0x12)
#define REG_SC_BK2C_12_H      _PK_H_(0x2C, 0x12)
#define REG_SC_BK2C_13_L      _PK_L_(0x2C, 0x13)
#define REG_SC_BK2C_13_H      _PK_H_(0x2C, 0x13)
#define REG_SC_BK2C_14_L      _PK_L_(0x2C, 0x14)
#define REG_SC_BK2C_14_H      _PK_H_(0x2C, 0x14)
#define REG_SC_BK2C_15_L      _PK_L_(0x2C, 0x15)
#define REG_SC_BK2C_15_H      _PK_H_(0x2C, 0x15)
#define REG_SC_BK2C_16_L      _PK_L_(0x2C, 0x16)
#define REG_SC_BK2C_16_H      _PK_H_(0x2C, 0x16)
#define REG_SC_BK2C_17_L      _PK_L_(0x2C, 0x17)
#define REG_SC_BK2C_17_H      _PK_H_(0x2C, 0x17)
#define REG_SC_BK2C_18_L      _PK_L_(0x2C, 0x18)
#define REG_SC_BK2C_18_H      _PK_H_(0x2C, 0x18)
#define REG_SC_BK2C_19_L      _PK_L_(0x2C, 0x19)
#define REG_SC_BK2C_19_H      _PK_H_(0x2C, 0x19)
#define REG_SC_BK2C_1A_L      _PK_L_(0x2C, 0x1A)
#define REG_SC_BK2C_1A_H      _PK_H_(0x2C, 0x1A)
#define REG_SC_BK2C_1B_L      _PK_L_(0x2C, 0x1B)
#define REG_SC_BK2C_1B_H      _PK_H_(0x2C, 0x1B)
#define REG_SC_BK2C_1C_L      _PK_L_(0x2C, 0x1C)
#define REG_SC_BK2C_1C_H      _PK_H_(0x2C, 0x1C)
#define REG_SC_BK2C_1D_L      _PK_L_(0x2C, 0x1D)
#define REG_SC_BK2C_1D_H      _PK_H_(0x2C, 0x1D)
#define REG_SC_BK2C_1E_L      _PK_L_(0x2C, 0x1E)
#define REG_SC_BK2C_1E_H      _PK_H_(0x2C, 0x1E)
#define REG_SC_BK2C_1F_L      _PK_L_(0x2C, 0x1F)
#define REG_SC_BK2C_1F_H      _PK_H_(0x2C, 0x1F)
#define REG_SC_BK2C_20_L      _PK_L_(0x2C, 0x20)
#define REG_SC_BK2C_20_H      _PK_H_(0x2C, 0x20)
#define REG_SC_BK2C_21_L      _PK_L_(0x2C, 0x21)
#define REG_SC_BK2C_21_H      _PK_H_(0x2C, 0x21)
#define REG_SC_BK2C_22_L      _PK_L_(0x2C, 0x22)
#define REG_SC_BK2C_22_H      _PK_H_(0x2C, 0x22)
#define REG_SC_BK2C_23_L      _PK_L_(0x2C, 0x23)
#define REG_SC_BK2C_23_H      _PK_H_(0x2C, 0x23)
#define REG_SC_BK2C_24_L      _PK_L_(0x2C, 0x24)
#define REG_SC_BK2C_24_H      _PK_H_(0x2C, 0x24)
#define REG_SC_BK2C_25_L      _PK_L_(0x2C, 0x25)
#define REG_SC_BK2C_25_H      _PK_H_(0x2C, 0x25)
#define REG_SC_BK2C_26_L      _PK_L_(0x2C, 0x26)
#define REG_SC_BK2C_26_H      _PK_H_(0x2C, 0x26)
#define REG_SC_BK2C_27_L      _PK_L_(0x2C, 0x27)
#define REG_SC_BK2C_27_H      _PK_H_(0x2C, 0x27)
#define REG_SC_BK2C_28_L      _PK_L_(0x2C, 0x28)
#define REG_SC_BK2C_28_H      _PK_H_(0x2C, 0x28)
#define REG_SC_BK2C_29_L      _PK_L_(0x2C, 0x29)
#define REG_SC_BK2C_29_H      _PK_H_(0x2C, 0x29)
#define REG_SC_BK2C_2A_L      _PK_L_(0x2C, 0x2A)
#define REG_SC_BK2C_2A_H      _PK_H_(0x2C, 0x2A)
#define REG_SC_BK2C_2B_L      _PK_L_(0x2C, 0x2B)
#define REG_SC_BK2C_2B_H      _PK_H_(0x2C, 0x2B)
#define REG_SC_BK2C_2C_L      _PK_L_(0x2C, 0x2C)
#define REG_SC_BK2C_2C_H      _PK_H_(0x2C, 0x2C)
#define REG_SC_BK2C_2D_L      _PK_L_(0x2C, 0x2D)
#define REG_SC_BK2C_2D_H      _PK_H_(0x2C, 0x2D)
#define REG_SC_BK2C_2E_L      _PK_L_(0x2C, 0x2E)
#define REG_SC_BK2C_2E_H      _PK_H_(0x2C, 0x2E)
#define REG_SC_BK2C_2F_L      _PK_L_(0x2C, 0x2F)
#define REG_SC_BK2C_2F_H      _PK_H_(0x2C, 0x2F)
#define REG_SC_BK2C_30_L      _PK_L_(0x2C, 0x30)
#define REG_SC_BK2C_30_H      _PK_H_(0x2C, 0x30)
#define REG_SC_BK2C_31_L      _PK_L_(0x2C, 0x31)
#define REG_SC_BK2C_31_H      _PK_H_(0x2C, 0x31)
#define REG_SC_BK2C_32_L      _PK_L_(0x2C, 0x32)
#define REG_SC_BK2C_32_H      _PK_H_(0x2C, 0x32)
#define REG_SC_BK2C_33_L      _PK_L_(0x2C, 0x33)
#define REG_SC_BK2C_33_H      _PK_H_(0x2C, 0x33)
#define REG_SC_BK2C_34_L      _PK_L_(0x2C, 0x34)
#define REG_SC_BK2C_34_H      _PK_H_(0x2C, 0x34)
#define REG_SC_BK2C_35_L      _PK_L_(0x2C, 0x35)
#define REG_SC_BK2C_35_H      _PK_H_(0x2C, 0x35)
#define REG_SC_BK2C_36_L      _PK_L_(0x2C, 0x36)
#define REG_SC_BK2C_36_H      _PK_H_(0x2C, 0x36)
#define REG_SC_BK2C_37_L      _PK_L_(0x2C, 0x37)
#define REG_SC_BK2C_37_H      _PK_H_(0x2C, 0x37)
#define REG_SC_BK2C_38_L      _PK_L_(0x2C, 0x38)
#define REG_SC_BK2C_38_H      _PK_H_(0x2C, 0x38)
#define REG_SC_BK2C_39_L      _PK_L_(0x2C, 0x39)
#define REG_SC_BK2C_39_H      _PK_H_(0x2C, 0x39)
#define REG_SC_BK2C_3A_L      _PK_L_(0x2C, 0x3A)
#define REG_SC_BK2C_3A_H      _PK_H_(0x2C, 0x3A)
#define REG_SC_BK2C_3B_L      _PK_L_(0x2C, 0x3B)
#define REG_SC_BK2C_3B_H      _PK_H_(0x2C, 0x3B)
#define REG_SC_BK2C_3C_L      _PK_L_(0x2C, 0x3C)
#define REG_SC_BK2C_3C_H      _PK_H_(0x2C, 0x3C)
#define REG_SC_BK2C_3D_L      _PK_L_(0x2C, 0x3D)
#define REG_SC_BK2C_3D_H      _PK_H_(0x2C, 0x3D)
#define REG_SC_BK2C_3E_L      _PK_L_(0x2C, 0x3E)
#define REG_SC_BK2C_3E_H      _PK_H_(0x2C, 0x3E)
#define REG_SC_BK2C_3F_L      _PK_L_(0x2C, 0x3F)
#define REG_SC_BK2C_3F_H      _PK_H_(0x2C, 0x3F)
#define REG_SC_BK2C_40_L      _PK_L_(0x2C, 0x40)
#define REG_SC_BK2C_40_H      _PK_H_(0x2C, 0x40)
#define REG_SC_BK2C_41_L      _PK_L_(0x2C, 0x41)
#define REG_SC_BK2C_41_H      _PK_H_(0x2C, 0x41)
#define REG_SC_BK2C_42_L      _PK_L_(0x2C, 0x42)
#define REG_SC_BK2C_42_H      _PK_H_(0x2C, 0x42)
#define REG_SC_BK2C_43_L      _PK_L_(0x2C, 0x43)
#define REG_SC_BK2C_43_H      _PK_H_(0x2C, 0x43)
#define REG_SC_BK2C_44_L      _PK_L_(0x2C, 0x44)
#define REG_SC_BK2C_44_H      _PK_H_(0x2C, 0x44)
#define REG_SC_BK2C_45_L      _PK_L_(0x2C, 0x45)
#define REG_SC_BK2C_45_H      _PK_H_(0x2C, 0x45)
#define REG_SC_BK2C_46_L      _PK_L_(0x2C, 0x46)
#define REG_SC_BK2C_46_H      _PK_H_(0x2C, 0x46)
#define REG_SC_BK2C_47_L      _PK_L_(0x2C, 0x47)
#define REG_SC_BK2C_47_H      _PK_H_(0x2C, 0x47)
#define REG_SC_BK2C_48_L      _PK_L_(0x2C, 0x48)
#define REG_SC_BK2C_48_H      _PK_H_(0x2C, 0x48)
#define REG_SC_BK2C_49_L      _PK_L_(0x2C, 0x49)
#define REG_SC_BK2C_49_H      _PK_H_(0x2C, 0x49)
#define REG_SC_BK2C_4A_L      _PK_L_(0x2C, 0x4A)
#define REG_SC_BK2C_4A_H      _PK_H_(0x2C, 0x4A)
#define REG_SC_BK2C_4B_L      _PK_L_(0x2C, 0x4B)
#define REG_SC_BK2C_4B_H      _PK_H_(0x2C, 0x4B)
#define REG_SC_BK2C_4C_L      _PK_L_(0x2C, 0x4C)
#define REG_SC_BK2C_4C_H      _PK_H_(0x2C, 0x4C)
#define REG_SC_BK2C_4D_L      _PK_L_(0x2C, 0x4D)
#define REG_SC_BK2C_4D_H      _PK_H_(0x2C, 0x4D)
#define REG_SC_BK2C_4E_L      _PK_L_(0x2C, 0x4E)
#define REG_SC_BK2C_4E_H      _PK_H_(0x2C, 0x4E)
#define REG_SC_BK2C_4F_L      _PK_L_(0x2C, 0x4F)
#define REG_SC_BK2C_4F_H      _PK_H_(0x2C, 0x4F)
#define REG_SC_BK2C_50_L      _PK_L_(0x2C, 0x50)
#define REG_SC_BK2C_50_H      _PK_H_(0x2C, 0x50)
#define REG_SC_BK2C_51_L      _PK_L_(0x2C, 0x51)
#define REG_SC_BK2C_51_H      _PK_H_(0x2C, 0x51)
#define REG_SC_BK2C_52_L      _PK_L_(0x2C, 0x52)
#define REG_SC_BK2C_52_H      _PK_H_(0x2C, 0x52)
#define REG_SC_BK2C_53_L      _PK_L_(0x2C, 0x53)
#define REG_SC_BK2C_53_H      _PK_H_(0x2C, 0x53)
#define REG_SC_BK2C_54_L      _PK_L_(0x2C, 0x54)
#define REG_SC_BK2C_54_H      _PK_H_(0x2C, 0x54)
#define REG_SC_BK2C_55_L      _PK_L_(0x2C, 0x55)
#define REG_SC_BK2C_55_H      _PK_H_(0x2C, 0x55)
#define REG_SC_BK2C_56_L      _PK_L_(0x2C, 0x56)
#define REG_SC_BK2C_56_H      _PK_H_(0x2C, 0x56)
#define REG_SC_BK2C_57_L      _PK_L_(0x2C, 0x57)
#define REG_SC_BK2C_57_H      _PK_H_(0x2C, 0x57)
#define REG_SC_BK2C_58_L      _PK_L_(0x2C, 0x58)
#define REG_SC_BK2C_58_H      _PK_H_(0x2C, 0x58)
#define REG_SC_BK2C_59_L      _PK_L_(0x2C, 0x59)
#define REG_SC_BK2C_59_H      _PK_H_(0x2C, 0x59)
#define REG_SC_BK2C_5A_L      _PK_L_(0x2C, 0x5A)
#define REG_SC_BK2C_5A_H      _PK_H_(0x2C, 0x5A)
#define REG_SC_BK2C_5B_L      _PK_L_(0x2C, 0x5B)
#define REG_SC_BK2C_5B_H      _PK_H_(0x2C, 0x5B)
#define REG_SC_BK2C_5C_L      _PK_L_(0x2C, 0x5C)
#define REG_SC_BK2C_5C_H      _PK_H_(0x2C, 0x5C)
#define REG_SC_BK2C_5D_L      _PK_L_(0x2C, 0x5D)
#define REG_SC_BK2C_5D_H      _PK_H_(0x2C, 0x5D)
#define REG_SC_BK2C_5E_L      _PK_L_(0x2C, 0x5E)
#define REG_SC_BK2C_5E_H      _PK_H_(0x2C, 0x5E)
#define REG_SC_BK2C_5F_L      _PK_L_(0x2C, 0x5F)
#define REG_SC_BK2C_5F_H      _PK_H_(0x2C, 0x5F)
#define REG_SC_BK2C_60_L      _PK_L_(0x2C, 0x60)
#define REG_SC_BK2C_60_H      _PK_H_(0x2C, 0x60)
#define REG_SC_BK2C_61_L      _PK_L_(0x2C, 0x61)
#define REG_SC_BK2C_61_H      _PK_H_(0x2C, 0x61)
#define REG_SC_BK2C_62_L      _PK_L_(0x2C, 0x62)
#define REG_SC_BK2C_62_H      _PK_H_(0x2C, 0x62)
#define REG_SC_BK2C_63_L      _PK_L_(0x2C, 0x63)
#define REG_SC_BK2C_63_H      _PK_H_(0x2C, 0x63)
#define REG_SC_BK2C_64_L      _PK_L_(0x2C, 0x64)
#define REG_SC_BK2C_64_H      _PK_H_(0x2C, 0x64)
#define REG_SC_BK2C_65_L      _PK_L_(0x2C, 0x65)
#define REG_SC_BK2C_65_H      _PK_H_(0x2C, 0x65)
#define REG_SC_BK2C_66_L      _PK_L_(0x2C, 0x66)
#define REG_SC_BK2C_66_H      _PK_H_(0x2C, 0x66)
#define REG_SC_BK2C_67_L      _PK_L_(0x2C, 0x67)
#define REG_SC_BK2C_67_H      _PK_H_(0x2C, 0x67)
#define REG_SC_BK2C_68_L      _PK_L_(0x2C, 0x68)
#define REG_SC_BK2C_68_H      _PK_H_(0x2C, 0x68)
#define REG_SC_BK2C_69_L      _PK_L_(0x2C, 0x69)
#define REG_SC_BK2C_69_H      _PK_H_(0x2C, 0x69)
#define REG_SC_BK2C_6A_L      _PK_L_(0x2C, 0x6A)
#define REG_SC_BK2C_6A_H      _PK_H_(0x2C, 0x6A)
#define REG_SC_BK2C_6B_L      _PK_L_(0x2C, 0x6B)
#define REG_SC_BK2C_6B_H      _PK_H_(0x2C, 0x6B)
#define REG_SC_BK2C_6C_L      _PK_L_(0x2C, 0x6C)
#define REG_SC_BK2C_6C_H      _PK_H_(0x2C, 0x6C)
#define REG_SC_BK2C_6D_L      _PK_L_(0x2C, 0x6D)
#define REG_SC_BK2C_6D_H      _PK_H_(0x2C, 0x6D)
#define REG_SC_BK2C_6E_L      _PK_L_(0x2C, 0x6E)
#define REG_SC_BK2C_6E_H      _PK_H_(0x2C, 0x6E)
#define REG_SC_BK2C_6F_L      _PK_L_(0x2C, 0x6F)
#define REG_SC_BK2C_6F_H      _PK_H_(0x2C, 0x6F)
#define REG_SC_BK2C_70_L      _PK_L_(0x2C, 0x70)
#define REG_SC_BK2C_70_H      _PK_H_(0x2C, 0x70)
#define REG_SC_BK2C_71_L      _PK_L_(0x2C, 0x71)
#define REG_SC_BK2C_71_H      _PK_H_(0x2C, 0x71)
#define REG_SC_BK2C_72_L      _PK_L_(0x2C, 0x72)
#define REG_SC_BK2C_72_H      _PK_H_(0x2C, 0x72)
#define REG_SC_BK2C_73_L      _PK_L_(0x2C, 0x73)
#define REG_SC_BK2C_73_H      _PK_H_(0x2C, 0x73)
#define REG_SC_BK2C_74_L      _PK_L_(0x2C, 0x74)
#define REG_SC_BK2C_74_H      _PK_H_(0x2C, 0x74)
#define REG_SC_BK2C_75_L      _PK_L_(0x2C, 0x75)
#define REG_SC_BK2C_75_H      _PK_H_(0x2C, 0x75)
#define REG_SC_BK2C_76_L      _PK_L_(0x2C, 0x76)
#define REG_SC_BK2C_76_H      _PK_H_(0x2C, 0x76)
#define REG_SC_BK2C_77_L      _PK_L_(0x2C, 0x77)
#define REG_SC_BK2C_77_H      _PK_H_(0x2C, 0x77)
#define REG_SC_BK2C_78_L      _PK_L_(0x2C, 0x78)
#define REG_SC_BK2C_78_H      _PK_H_(0x2C, 0x78)
#define REG_SC_BK2C_79_L      _PK_L_(0x2C, 0x79)
#define REG_SC_BK2C_79_H      _PK_H_(0x2C, 0x79)
#define REG_SC_BK2C_7A_L      _PK_L_(0x2C, 0x7A)
#define REG_SC_BK2C_7A_H      _PK_H_(0x2C, 0x7A)
#define REG_SC_BK2C_7B_L      _PK_L_(0x2C, 0x7B)
#define REG_SC_BK2C_7B_H      _PK_H_(0x2C, 0x7B)
#define REG_SC_BK2C_7C_L      _PK_L_(0x2C, 0x7C)
#define REG_SC_BK2C_7C_H      _PK_H_(0x2C, 0x7C)
#define REG_SC_BK2C_7D_L      _PK_L_(0x2C, 0x7D)
#define REG_SC_BK2C_7D_H      _PK_H_(0x2C, 0x7D)
#define REG_SC_BK2C_7E_L      _PK_L_(0x2C, 0x7E)
#define REG_SC_BK2C_7E_H      _PK_H_(0x2C, 0x7E)
#define REG_SC_BK2C_7F_L      _PK_L_(0x2C, 0x7F)
#define REG_SC_BK2C_7F_H      _PK_H_(0x2C, 0x7F)
//----------------------------------------------
#define REG_SC_BK2D_00_L      _PK_L_(0x2D, 0x00)
#define REG_SC_BK2D_00_H      _PK_H_(0x2D, 0x00)
#define REG_SC_BK2D_01_L      _PK_L_(0x2D, 0x01)
#define REG_SC_BK2D_01_H      _PK_H_(0x2D, 0x01)
#define REG_SC_BK2D_02_L      _PK_L_(0x2D, 0x02)
#define REG_SC_BK2D_02_H      _PK_H_(0x2D, 0x02)
#define REG_SC_BK2D_03_L      _PK_L_(0x2D, 0x03)
#define REG_SC_BK2D_03_H      _PK_H_(0x2D, 0x03)
#define REG_SC_BK2D_04_L      _PK_L_(0x2D, 0x04)
#define REG_SC_BK2D_04_H      _PK_H_(0x2D, 0x04)
#define REG_SC_BK2D_05_L      _PK_L_(0x2D, 0x05)
#define REG_SC_BK2D_05_H      _PK_H_(0x2D, 0x05)
#define REG_SC_BK2D_06_L      _PK_L_(0x2D, 0x06)
#define REG_SC_BK2D_06_H      _PK_H_(0x2D, 0x06)
#define REG_SC_BK2D_07_L      _PK_L_(0x2D, 0x07)
#define REG_SC_BK2D_07_H      _PK_H_(0x2D, 0x07)
#define REG_SC_BK2D_08_L      _PK_L_(0x2D, 0x08)
#define REG_SC_BK2D_08_H      _PK_H_(0x2D, 0x08)
#define REG_SC_BK2D_09_L      _PK_L_(0x2D, 0x09)
#define REG_SC_BK2D_09_H      _PK_H_(0x2D, 0x09)
#define REG_SC_BK2D_0A_L      _PK_L_(0x2D, 0x0A)
#define REG_SC_BK2D_0A_H      _PK_H_(0x2D, 0x0A)
#define REG_SC_BK2D_0B_L      _PK_L_(0x2D, 0x0B)
#define REG_SC_BK2D_0B_H      _PK_H_(0x2D, 0x0B)
#define REG_SC_BK2D_0C_L      _PK_L_(0x2D, 0x0C)
#define REG_SC_BK2D_0C_H      _PK_H_(0x2D, 0x0C)
#define REG_SC_BK2D_0D_L      _PK_L_(0x2D, 0x0D)
#define REG_SC_BK2D_0D_H      _PK_H_(0x2D, 0x0D)
#define REG_SC_BK2D_0E_L      _PK_L_(0x2D, 0x0E)
#define REG_SC_BK2D_0E_H      _PK_H_(0x2D, 0x0E)
#define REG_SC_BK2D_0F_L      _PK_L_(0x2D, 0x0F)
#define REG_SC_BK2D_0F_H      _PK_H_(0x2D, 0x0F)
#define REG_SC_BK2D_10_L      _PK_L_(0x2D, 0x10)
#define REG_SC_BK2D_10_H      _PK_H_(0x2D, 0x10)
#define REG_SC_BK2D_11_L      _PK_L_(0x2D, 0x11)
#define REG_SC_BK2D_11_H      _PK_H_(0x2D, 0x11)
#define REG_SC_BK2D_12_L      _PK_L_(0x2D, 0x12)
#define REG_SC_BK2D_12_H      _PK_H_(0x2D, 0x12)
#define REG_SC_BK2D_13_L      _PK_L_(0x2D, 0x13)
#define REG_SC_BK2D_13_H      _PK_H_(0x2D, 0x13)
#define REG_SC_BK2D_14_L      _PK_L_(0x2D, 0x14)
#define REG_SC_BK2D_14_H      _PK_H_(0x2D, 0x14)
#define REG_SC_BK2D_15_L      _PK_L_(0x2D, 0x15)
#define REG_SC_BK2D_15_H      _PK_H_(0x2D, 0x15)
#define REG_SC_BK2D_16_L      _PK_L_(0x2D, 0x16)
#define REG_SC_BK2D_16_H      _PK_H_(0x2D, 0x16)
#define REG_SC_BK2D_17_L      _PK_L_(0x2D, 0x17)
#define REG_SC_BK2D_17_H      _PK_H_(0x2D, 0x17)
#define REG_SC_BK2D_18_L      _PK_L_(0x2D, 0x18)
#define REG_SC_BK2D_18_H      _PK_H_(0x2D, 0x18)
#define REG_SC_BK2D_19_L      _PK_L_(0x2D, 0x19)
#define REG_SC_BK2D_19_H      _PK_H_(0x2D, 0x19)
#define REG_SC_BK2D_1A_L      _PK_L_(0x2D, 0x1A)
#define REG_SC_BK2D_1A_H      _PK_H_(0x2D, 0x1A)
#define REG_SC_BK2D_1B_L      _PK_L_(0x2D, 0x1B)
#define REG_SC_BK2D_1B_H      _PK_H_(0x2D, 0x1B)
#define REG_SC_BK2D_1C_L      _PK_L_(0x2D, 0x1C)
#define REG_SC_BK2D_1C_H      _PK_H_(0x2D, 0x1C)
#define REG_SC_BK2D_1D_L      _PK_L_(0x2D, 0x1D)
#define REG_SC_BK2D_1D_H      _PK_H_(0x2D, 0x1D)
#define REG_SC_BK2D_1E_L      _PK_L_(0x2D, 0x1E)
#define REG_SC_BK2D_1E_H      _PK_H_(0x2D, 0x1E)
#define REG_SC_BK2D_1F_L      _PK_L_(0x2D, 0x1F)
#define REG_SC_BK2D_1F_H      _PK_H_(0x2D, 0x1F)
#define REG_SC_BK2D_20_L      _PK_L_(0x2D, 0x20)
#define REG_SC_BK2D_20_H      _PK_H_(0x2D, 0x20)
#define REG_SC_BK2D_21_L      _PK_L_(0x2D, 0x21)
#define REG_SC_BK2D_21_H      _PK_H_(0x2D, 0x21)
#define REG_SC_BK2D_22_L      _PK_L_(0x2D, 0x22)
#define REG_SC_BK2D_22_H      _PK_H_(0x2D, 0x22)
#define REG_SC_BK2D_23_L      _PK_L_(0x2D, 0x23)
#define REG_SC_BK2D_23_H      _PK_H_(0x2D, 0x23)
#define REG_SC_BK2D_24_L      _PK_L_(0x2D, 0x24)
#define REG_SC_BK2D_24_H      _PK_H_(0x2D, 0x24)
#define REG_SC_BK2D_25_L      _PK_L_(0x2D, 0x25)
#define REG_SC_BK2D_25_H      _PK_H_(0x2D, 0x25)
#define REG_SC_BK2D_26_L      _PK_L_(0x2D, 0x26)
#define REG_SC_BK2D_26_H      _PK_H_(0x2D, 0x26)
#define REG_SC_BK2D_27_L      _PK_L_(0x2D, 0x27)
#define REG_SC_BK2D_27_H      _PK_H_(0x2D, 0x27)
#define REG_SC_BK2D_28_L      _PK_L_(0x2D, 0x28)
#define REG_SC_BK2D_28_H      _PK_H_(0x2D, 0x28)
#define REG_SC_BK2D_29_L      _PK_L_(0x2D, 0x29)
#define REG_SC_BK2D_29_H      _PK_H_(0x2D, 0x29)
#define REG_SC_BK2D_2A_L      _PK_L_(0x2D, 0x2A)
#define REG_SC_BK2D_2A_H      _PK_H_(0x2D, 0x2A)
#define REG_SC_BK2D_2B_L      _PK_L_(0x2D, 0x2B)
#define REG_SC_BK2D_2B_H      _PK_H_(0x2D, 0x2B)
#define REG_SC_BK2D_2C_L      _PK_L_(0x2D, 0x2C)
#define REG_SC_BK2D_2C_H      _PK_H_(0x2D, 0x2C)
#define REG_SC_BK2D_2D_L      _PK_L_(0x2D, 0x2D)
#define REG_SC_BK2D_2D_H      _PK_H_(0x2D, 0x2D)
#define REG_SC_BK2D_2E_L      _PK_L_(0x2D, 0x2E)
#define REG_SC_BK2D_2E_H      _PK_H_(0x2D, 0x2E)
#define REG_SC_BK2D_2F_L      _PK_L_(0x2D, 0x2F)
#define REG_SC_BK2D_2F_H      _PK_H_(0x2D, 0x2F)
#define REG_SC_BK2D_30_L      _PK_L_(0x2D, 0x30)
#define REG_SC_BK2D_30_H      _PK_H_(0x2D, 0x30)
#define REG_SC_BK2D_31_L      _PK_L_(0x2D, 0x31)
#define REG_SC_BK2D_31_H      _PK_H_(0x2D, 0x31)
#define REG_SC_BK2D_32_L      _PK_L_(0x2D, 0x32)
#define REG_SC_BK2D_32_H      _PK_H_(0x2D, 0x32)
#define REG_SC_BK2D_33_L      _PK_L_(0x2D, 0x33)
#define REG_SC_BK2D_33_H      _PK_H_(0x2D, 0x33)
#define REG_SC_BK2D_34_L      _PK_L_(0x2D, 0x34)
#define REG_SC_BK2D_34_H      _PK_H_(0x2D, 0x34)
#define REG_SC_BK2D_35_L      _PK_L_(0x2D, 0x35)
#define REG_SC_BK2D_35_H      _PK_H_(0x2D, 0x35)
#define REG_SC_BK2D_36_L      _PK_L_(0x2D, 0x36)
#define REG_SC_BK2D_36_H      _PK_H_(0x2D, 0x36)
#define REG_SC_BK2D_37_L      _PK_L_(0x2D, 0x37)
#define REG_SC_BK2D_37_H      _PK_H_(0x2D, 0x37)
#define REG_SC_BK2D_38_L      _PK_L_(0x2D, 0x38)
#define REG_SC_BK2D_38_H      _PK_H_(0x2D, 0x38)
#define REG_SC_BK2D_39_L      _PK_L_(0x2D, 0x39)
#define REG_SC_BK2D_39_H      _PK_H_(0x2D, 0x39)
#define REG_SC_BK2D_3A_L      _PK_L_(0x2D, 0x3A)
#define REG_SC_BK2D_3A_H      _PK_H_(0x2D, 0x3A)
#define REG_SC_BK2D_3B_L      _PK_L_(0x2D, 0x3B)
#define REG_SC_BK2D_3B_H      _PK_H_(0x2D, 0x3B)
#define REG_SC_BK2D_3C_L      _PK_L_(0x2D, 0x3C)
#define REG_SC_BK2D_3C_H      _PK_H_(0x2D, 0x3C)
#define REG_SC_BK2D_3D_L      _PK_L_(0x2D, 0x3D)
#define REG_SC_BK2D_3D_H      _PK_H_(0x2D, 0x3D)
#define REG_SC_BK2D_3E_L      _PK_L_(0x2D, 0x3E)
#define REG_SC_BK2D_3E_H      _PK_H_(0x2D, 0x3E)
#define REG_SC_BK2D_3F_L      _PK_L_(0x2D, 0x3F)
#define REG_SC_BK2D_3F_H      _PK_H_(0x2D, 0x3F)
#define REG_SC_BK2D_40_L      _PK_L_(0x2D, 0x40)
#define REG_SC_BK2D_40_H      _PK_H_(0x2D, 0x40)
#define REG_SC_BK2D_41_L      _PK_L_(0x2D, 0x41)
#define REG_SC_BK2D_41_H      _PK_H_(0x2D, 0x41)
#define REG_SC_BK2D_42_L      _PK_L_(0x2D, 0x42)
#define REG_SC_BK2D_42_H      _PK_H_(0x2D, 0x42)
#define REG_SC_BK2D_43_L      _PK_L_(0x2D, 0x43)
#define REG_SC_BK2D_43_H      _PK_H_(0x2D, 0x43)
#define REG_SC_BK2D_44_L      _PK_L_(0x2D, 0x44)
#define REG_SC_BK2D_44_H      _PK_H_(0x2D, 0x44)
#define REG_SC_BK2D_45_L      _PK_L_(0x2D, 0x45)
#define REG_SC_BK2D_45_H      _PK_H_(0x2D, 0x45)
#define REG_SC_BK2D_46_L      _PK_L_(0x2D, 0x46)
#define REG_SC_BK2D_46_H      _PK_H_(0x2D, 0x46)
#define REG_SC_BK2D_47_L      _PK_L_(0x2D, 0x47)
#define REG_SC_BK2D_47_H      _PK_H_(0x2D, 0x47)
#define REG_SC_BK2D_48_L      _PK_L_(0x2D, 0x48)
#define REG_SC_BK2D_48_H      _PK_H_(0x2D, 0x48)
#define REG_SC_BK2D_49_L      _PK_L_(0x2D, 0x49)
#define REG_SC_BK2D_49_H      _PK_H_(0x2D, 0x49)
#define REG_SC_BK2D_4A_L      _PK_L_(0x2D, 0x4A)
#define REG_SC_BK2D_4A_H      _PK_H_(0x2D, 0x4A)
#define REG_SC_BK2D_4B_L      _PK_L_(0x2D, 0x4B)
#define REG_SC_BK2D_4B_H      _PK_H_(0x2D, 0x4B)
#define REG_SC_BK2D_4C_L      _PK_L_(0x2D, 0x4C)
#define REG_SC_BK2D_4C_H      _PK_H_(0x2D, 0x4C)
#define REG_SC_BK2D_4D_L      _PK_L_(0x2D, 0x4D)
#define REG_SC_BK2D_4D_H      _PK_H_(0x2D, 0x4D)
#define REG_SC_BK2D_4E_L      _PK_L_(0x2D, 0x4E)
#define REG_SC_BK2D_4E_H      _PK_H_(0x2D, 0x4E)
#define REG_SC_BK2D_4F_L      _PK_L_(0x2D, 0x4F)
#define REG_SC_BK2D_4F_H      _PK_H_(0x2D, 0x4F)
#define REG_SC_BK2D_50_L      _PK_L_(0x2D, 0x50)
#define REG_SC_BK2D_50_H      _PK_H_(0x2D, 0x50)
#define REG_SC_BK2D_51_L      _PK_L_(0x2D, 0x51)
#define REG_SC_BK2D_51_H      _PK_H_(0x2D, 0x51)
#define REG_SC_BK2D_52_L      _PK_L_(0x2D, 0x52)
#define REG_SC_BK2D_52_H      _PK_H_(0x2D, 0x52)
#define REG_SC_BK2D_53_L      _PK_L_(0x2D, 0x53)
#define REG_SC_BK2D_53_H      _PK_H_(0x2D, 0x53)
#define REG_SC_BK2D_54_L      _PK_L_(0x2D, 0x54)
#define REG_SC_BK2D_54_H      _PK_H_(0x2D, 0x54)
#define REG_SC_BK2D_55_L      _PK_L_(0x2D, 0x55)
#define REG_SC_BK2D_55_H      _PK_H_(0x2D, 0x55)
#define REG_SC_BK2D_56_L      _PK_L_(0x2D, 0x56)
#define REG_SC_BK2D_56_H      _PK_H_(0x2D, 0x56)
#define REG_SC_BK2D_57_L      _PK_L_(0x2D, 0x57)
#define REG_SC_BK2D_57_H      _PK_H_(0x2D, 0x57)
#define REG_SC_BK2D_58_L      _PK_L_(0x2D, 0x58)
#define REG_SC_BK2D_58_H      _PK_H_(0x2D, 0x58)
#define REG_SC_BK2D_59_L      _PK_L_(0x2D, 0x59)
#define REG_SC_BK2D_59_H      _PK_H_(0x2D, 0x59)
#define REG_SC_BK2D_5A_L      _PK_L_(0x2D, 0x5A)
#define REG_SC_BK2D_5A_H      _PK_H_(0x2D, 0x5A)
#define REG_SC_BK2D_5B_L      _PK_L_(0x2D, 0x5B)
#define REG_SC_BK2D_5B_H      _PK_H_(0x2D, 0x5B)
#define REG_SC_BK2D_5C_L      _PK_L_(0x2D, 0x5C)
#define REG_SC_BK2D_5C_H      _PK_H_(0x2D, 0x5C)
#define REG_SC_BK2D_5D_L      _PK_L_(0x2D, 0x5D)
#define REG_SC_BK2D_5D_H      _PK_H_(0x2D, 0x5D)
#define REG_SC_BK2D_5E_L      _PK_L_(0x2D, 0x5E)
#define REG_SC_BK2D_5E_H      _PK_H_(0x2D, 0x5E)
#define REG_SC_BK2D_5F_L      _PK_L_(0x2D, 0x5F)
#define REG_SC_BK2D_5F_H      _PK_H_(0x2D, 0x5F)
#define REG_SC_BK2D_60_L      _PK_L_(0x2D, 0x60)
#define REG_SC_BK2D_60_H      _PK_H_(0x2D, 0x60)
#define REG_SC_BK2D_61_L      _PK_L_(0x2D, 0x61)
#define REG_SC_BK2D_61_H      _PK_H_(0x2D, 0x61)
#define REG_SC_BK2D_62_L      _PK_L_(0x2D, 0x62)
#define REG_SC_BK2D_62_H      _PK_H_(0x2D, 0x62)
#define REG_SC_BK2D_63_L      _PK_L_(0x2D, 0x63)
#define REG_SC_BK2D_63_H      _PK_H_(0x2D, 0x63)
#define REG_SC_BK2D_64_L      _PK_L_(0x2D, 0x64)
#define REG_SC_BK2D_64_H      _PK_H_(0x2D, 0x64)
#define REG_SC_BK2D_65_L      _PK_L_(0x2D, 0x65)
#define REG_SC_BK2D_65_H      _PK_H_(0x2D, 0x65)
#define REG_SC_BK2D_66_L      _PK_L_(0x2D, 0x66)
#define REG_SC_BK2D_66_H      _PK_H_(0x2D, 0x66)
#define REG_SC_BK2D_67_L      _PK_L_(0x2D, 0x67)
#define REG_SC_BK2D_67_H      _PK_H_(0x2D, 0x67)
#define REG_SC_BK2D_68_L      _PK_L_(0x2D, 0x68)
#define REG_SC_BK2D_68_H      _PK_H_(0x2D, 0x68)
#define REG_SC_BK2D_69_L      _PK_L_(0x2D, 0x69)
#define REG_SC_BK2D_69_H      _PK_H_(0x2D, 0x69)
#define REG_SC_BK2D_6A_L      _PK_L_(0x2D, 0x6A)
#define REG_SC_BK2D_6A_H      _PK_H_(0x2D, 0x6A)
#define REG_SC_BK2D_6B_L      _PK_L_(0x2D, 0x6B)
#define REG_SC_BK2D_6B_H      _PK_H_(0x2D, 0x6B)
#define REG_SC_BK2D_6C_L      _PK_L_(0x2D, 0x6C)
#define REG_SC_BK2D_6C_H      _PK_H_(0x2D, 0x6C)
#define REG_SC_BK2D_6D_L      _PK_L_(0x2D, 0x6D)
#define REG_SC_BK2D_6D_H      _PK_H_(0x2D, 0x6D)
#define REG_SC_BK2D_6E_L      _PK_L_(0x2D, 0x6E)
#define REG_SC_BK2D_6E_H      _PK_H_(0x2D, 0x6E)
#define REG_SC_BK2D_6F_L      _PK_L_(0x2D, 0x6F)
#define REG_SC_BK2D_6F_H      _PK_H_(0x2D, 0x6F)
#define REG_SC_BK2D_70_L      _PK_L_(0x2D, 0x70)
#define REG_SC_BK2D_70_H      _PK_H_(0x2D, 0x70)
#define REG_SC_BK2D_71_L      _PK_L_(0x2D, 0x71)
#define REG_SC_BK2D_71_H      _PK_H_(0x2D, 0x71)
#define REG_SC_BK2D_72_L      _PK_L_(0x2D, 0x72)
#define REG_SC_BK2D_72_H      _PK_H_(0x2D, 0x72)
#define REG_SC_BK2D_73_L      _PK_L_(0x2D, 0x73)
#define REG_SC_BK2D_73_H      _PK_H_(0x2D, 0x73)
#define REG_SC_BK2D_74_L      _PK_L_(0x2D, 0x74)
#define REG_SC_BK2D_74_H      _PK_H_(0x2D, 0x74)
#define REG_SC_BK2D_75_L      _PK_L_(0x2D, 0x75)
#define REG_SC_BK2D_75_H      _PK_H_(0x2D, 0x75)
#define REG_SC_BK2D_76_L      _PK_L_(0x2D, 0x76)
#define REG_SC_BK2D_76_H      _PK_H_(0x2D, 0x76)
#define REG_SC_BK2D_77_L      _PK_L_(0x2D, 0x77)
#define REG_SC_BK2D_77_H      _PK_H_(0x2D, 0x77)
#define REG_SC_BK2D_78_L      _PK_L_(0x2D, 0x78)
#define REG_SC_BK2D_78_H      _PK_H_(0x2D, 0x78)
#define REG_SC_BK2D_79_L      _PK_L_(0x2D, 0x79)
#define REG_SC_BK2D_79_H      _PK_H_(0x2D, 0x79)
#define REG_SC_BK2D_7A_L      _PK_L_(0x2D, 0x7A)
#define REG_SC_BK2D_7A_H      _PK_H_(0x2D, 0x7A)
#define REG_SC_BK2D_7B_L      _PK_L_(0x2D, 0x7B)
#define REG_SC_BK2D_7B_H      _PK_H_(0x2D, 0x7B)
#define REG_SC_BK2D_7C_L      _PK_L_(0x2D, 0x7C)
#define REG_SC_BK2D_7C_H      _PK_H_(0x2D, 0x7C)
#define REG_SC_BK2D_7D_L      _PK_L_(0x2D, 0x7D)
#define REG_SC_BK2D_7D_H      _PK_H_(0x2D, 0x7D)
#define REG_SC_BK2D_7E_L      _PK_L_(0x2D, 0x7E)
#define REG_SC_BK2D_7E_H      _PK_H_(0x2D, 0x7E)
#define REG_SC_BK2D_7F_L      _PK_L_(0x2D, 0x7F)
#define REG_SC_BK2D_7F_H      _PK_H_(0x2D, 0x7F)
//----------------------------------------------
#define REG_SC_BK2E_00_L      _PK_L_(0x2E, 0x00)
#define REG_SC_BK2E_00_H      _PK_H_(0x2E, 0x00)
#define REG_SC_BK2E_01_L      _PK_L_(0x2E, 0x01)
#define REG_SC_BK2E_01_H      _PK_H_(0x2E, 0x01)
#define REG_SC_BK2E_02_L      _PK_L_(0x2E, 0x02)
#define REG_SC_BK2E_02_H      _PK_H_(0x2E, 0x02)
#define REG_SC_BK2E_03_L      _PK_L_(0x2E, 0x03)
#define REG_SC_BK2E_03_H      _PK_H_(0x2E, 0x03)
#define REG_SC_BK2E_04_L      _PK_L_(0x2E, 0x04)
#define REG_SC_BK2E_04_H      _PK_H_(0x2E, 0x04)
#define REG_SC_BK2E_05_L      _PK_L_(0x2E, 0x05)
#define REG_SC_BK2E_05_H      _PK_H_(0x2E, 0x05)
#define REG_SC_BK2E_06_L      _PK_L_(0x2E, 0x06)
#define REG_SC_BK2E_06_H      _PK_H_(0x2E, 0x06)
#define REG_SC_BK2E_07_L      _PK_L_(0x2E, 0x07)
#define REG_SC_BK2E_07_H      _PK_H_(0x2E, 0x07)
#define REG_SC_BK2E_08_L      _PK_L_(0x2E, 0x08)
#define REG_SC_BK2E_08_H      _PK_H_(0x2E, 0x08)
#define REG_SC_BK2E_09_L      _PK_L_(0x2E, 0x09)
#define REG_SC_BK2E_09_H      _PK_H_(0x2E, 0x09)
#define REG_SC_BK2E_0A_L      _PK_L_(0x2E, 0x0A)
#define REG_SC_BK2E_0A_H      _PK_H_(0x2E, 0x0A)
#define REG_SC_BK2E_0B_L      _PK_L_(0x2E, 0x0B)
#define REG_SC_BK2E_0B_H      _PK_H_(0x2E, 0x0B)
#define REG_SC_BK2E_0C_L      _PK_L_(0x2E, 0x0C)
#define REG_SC_BK2E_0C_H      _PK_H_(0x2E, 0x0C)
#define REG_SC_BK2E_0D_L      _PK_L_(0x2E, 0x0D)
#define REG_SC_BK2E_0D_H      _PK_H_(0x2E, 0x0D)
#define REG_SC_BK2E_0E_L      _PK_L_(0x2E, 0x0E)
#define REG_SC_BK2E_0E_H      _PK_H_(0x2E, 0x0E)
#define REG_SC_BK2E_0F_L      _PK_L_(0x2E, 0x0F)
#define REG_SC_BK2E_0F_H      _PK_H_(0x2E, 0x0F)
#define REG_SC_BK2E_10_L      _PK_L_(0x2E, 0x10)
#define REG_SC_BK2E_10_H      _PK_H_(0x2E, 0x10)
#define REG_SC_BK2E_11_L      _PK_L_(0x2E, 0x11)
#define REG_SC_BK2E_11_H      _PK_H_(0x2E, 0x11)
#define REG_SC_BK2E_12_L      _PK_L_(0x2E, 0x12)
#define REG_SC_BK2E_12_H      _PK_H_(0x2E, 0x12)
#define REG_SC_BK2E_13_L      _PK_L_(0x2E, 0x13)
#define REG_SC_BK2E_13_H      _PK_H_(0x2E, 0x13)
#define REG_SC_BK2E_14_L      _PK_L_(0x2E, 0x14)
#define REG_SC_BK2E_14_H      _PK_H_(0x2E, 0x14)
#define REG_SC_BK2E_15_L      _PK_L_(0x2E, 0x15)
#define REG_SC_BK2E_15_H      _PK_H_(0x2E, 0x15)
#define REG_SC_BK2E_16_L      _PK_L_(0x2E, 0x16)
#define REG_SC_BK2E_16_H      _PK_H_(0x2E, 0x16)
#define REG_SC_BK2E_17_L      _PK_L_(0x2E, 0x17)
#define REG_SC_BK2E_17_H      _PK_H_(0x2E, 0x17)
#define REG_SC_BK2E_18_L      _PK_L_(0x2E, 0x18)
#define REG_SC_BK2E_18_H      _PK_H_(0x2E, 0x18)
#define REG_SC_BK2E_19_L      _PK_L_(0x2E, 0x19)
#define REG_SC_BK2E_19_H      _PK_H_(0x2E, 0x19)
#define REG_SC_BK2E_1A_L      _PK_L_(0x2E, 0x1A)
#define REG_SC_BK2E_1A_H      _PK_H_(0x2E, 0x1A)
#define REG_SC_BK2E_1B_L      _PK_L_(0x2E, 0x1B)
#define REG_SC_BK2E_1B_H      _PK_H_(0x2E, 0x1B)
#define REG_SC_BK2E_1C_L      _PK_L_(0x2E, 0x1C)
#define REG_SC_BK2E_1C_H      _PK_H_(0x2E, 0x1C)
#define REG_SC_BK2E_1D_L      _PK_L_(0x2E, 0x1D)
#define REG_SC_BK2E_1D_H      _PK_H_(0x2E, 0x1D)
#define REG_SC_BK2E_1E_L      _PK_L_(0x2E, 0x1E)
#define REG_SC_BK2E_1E_H      _PK_H_(0x2E, 0x1E)
#define REG_SC_BK2E_1F_L      _PK_L_(0x2E, 0x1F)
#define REG_SC_BK2E_1F_H      _PK_H_(0x2E, 0x1F)
#define REG_SC_BK2E_20_L      _PK_L_(0x2E, 0x20)
#define REG_SC_BK2E_20_H      _PK_H_(0x2E, 0x20)
#define REG_SC_BK2E_21_L      _PK_L_(0x2E, 0x21)
#define REG_SC_BK2E_21_H      _PK_H_(0x2E, 0x21)
#define REG_SC_BK2E_22_L      _PK_L_(0x2E, 0x22)
#define REG_SC_BK2E_22_H      _PK_H_(0x2E, 0x22)
#define REG_SC_BK2E_23_L      _PK_L_(0x2E, 0x23)
#define REG_SC_BK2E_23_H      _PK_H_(0x2E, 0x23)
#define REG_SC_BK2E_24_L      _PK_L_(0x2E, 0x24)
#define REG_SC_BK2E_24_H      _PK_H_(0x2E, 0x24)
#define REG_SC_BK2E_25_L      _PK_L_(0x2E, 0x25)
#define REG_SC_BK2E_25_H      _PK_H_(0x2E, 0x25)
#define REG_SC_BK2E_26_L      _PK_L_(0x2E, 0x26)
#define REG_SC_BK2E_26_H      _PK_H_(0x2E, 0x26)
#define REG_SC_BK2E_27_L      _PK_L_(0x2E, 0x27)
#define REG_SC_BK2E_27_H      _PK_H_(0x2E, 0x27)
#define REG_SC_BK2E_28_L      _PK_L_(0x2E, 0x28)
#define REG_SC_BK2E_28_H      _PK_H_(0x2E, 0x28)
#define REG_SC_BK2E_29_L      _PK_L_(0x2E, 0x29)
#define REG_SC_BK2E_29_H      _PK_H_(0x2E, 0x29)
#define REG_SC_BK2E_2A_L      _PK_L_(0x2E, 0x2A)
#define REG_SC_BK2E_2A_H      _PK_H_(0x2E, 0x2A)
#define REG_SC_BK2E_2B_L      _PK_L_(0x2E, 0x2B)
#define REG_SC_BK2E_2B_H      _PK_H_(0x2E, 0x2B)
#define REG_SC_BK2E_2C_L      _PK_L_(0x2E, 0x2C)
#define REG_SC_BK2E_2C_H      _PK_H_(0x2E, 0x2C)
#define REG_SC_BK2E_2D_L      _PK_L_(0x2E, 0x2D)
#define REG_SC_BK2E_2D_H      _PK_H_(0x2E, 0x2D)
#define REG_SC_BK2E_2E_L      _PK_L_(0x2E, 0x2E)
#define REG_SC_BK2E_2E_H      _PK_H_(0x2E, 0x2E)
#define REG_SC_BK2E_2F_L      _PK_L_(0x2E, 0x2F)
#define REG_SC_BK2E_2F_H      _PK_H_(0x2E, 0x2F)
#define REG_SC_BK2E_30_L      _PK_L_(0x2E, 0x30)
#define REG_SC_BK2E_30_H      _PK_H_(0x2E, 0x30)
#define REG_SC_BK2E_31_L      _PK_L_(0x2E, 0x31)
#define REG_SC_BK2E_31_H      _PK_H_(0x2E, 0x31)
#define REG_SC_BK2E_32_L      _PK_L_(0x2E, 0x32)
#define REG_SC_BK2E_32_H      _PK_H_(0x2E, 0x32)
#define REG_SC_BK2E_33_L      _PK_L_(0x2E, 0x33)
#define REG_SC_BK2E_33_H      _PK_H_(0x2E, 0x33)
#define REG_SC_BK2E_34_L      _PK_L_(0x2E, 0x34)
#define REG_SC_BK2E_34_H      _PK_H_(0x2E, 0x34)
#define REG_SC_BK2E_35_L      _PK_L_(0x2E, 0x35)
#define REG_SC_BK2E_35_H      _PK_H_(0x2E, 0x35)
#define REG_SC_BK2E_36_L      _PK_L_(0x2E, 0x36)
#define REG_SC_BK2E_36_H      _PK_H_(0x2E, 0x36)
#define REG_SC_BK2E_37_L      _PK_L_(0x2E, 0x37)
#define REG_SC_BK2E_37_H      _PK_H_(0x2E, 0x37)
#define REG_SC_BK2E_38_L      _PK_L_(0x2E, 0x38)
#define REG_SC_BK2E_38_H      _PK_H_(0x2E, 0x38)
#define REG_SC_BK2E_39_L      _PK_L_(0x2E, 0x39)
#define REG_SC_BK2E_39_H      _PK_H_(0x2E, 0x39)
#define REG_SC_BK2E_3A_L      _PK_L_(0x2E, 0x3A)
#define REG_SC_BK2E_3A_H      _PK_H_(0x2E, 0x3A)
#define REG_SC_BK2E_3B_L      _PK_L_(0x2E, 0x3B)
#define REG_SC_BK2E_3B_H      _PK_H_(0x2E, 0x3B)
#define REG_SC_BK2E_3C_L      _PK_L_(0x2E, 0x3C)
#define REG_SC_BK2E_3C_H      _PK_H_(0x2E, 0x3C)
#define REG_SC_BK2E_3D_L      _PK_L_(0x2E, 0x3D)
#define REG_SC_BK2E_3D_H      _PK_H_(0x2E, 0x3D)
#define REG_SC_BK2E_3E_L      _PK_L_(0x2E, 0x3E)
#define REG_SC_BK2E_3E_H      _PK_H_(0x2E, 0x3E)
#define REG_SC_BK2E_3F_L      _PK_L_(0x2E, 0x3F)
#define REG_SC_BK2E_3F_H      _PK_H_(0x2E, 0x3F)
#define REG_SC_BK2E_40_L      _PK_L_(0x2E, 0x40)
#define REG_SC_BK2E_40_H      _PK_H_(0x2E, 0x40)
#define REG_SC_BK2E_41_L      _PK_L_(0x2E, 0x41)
#define REG_SC_BK2E_41_H      _PK_H_(0x2E, 0x41)
#define REG_SC_BK2E_42_L      _PK_L_(0x2E, 0x42)
#define REG_SC_BK2E_42_H      _PK_H_(0x2E, 0x42)
#define REG_SC_BK2E_43_L      _PK_L_(0x2E, 0x43)
#define REG_SC_BK2E_43_H      _PK_H_(0x2E, 0x43)
#define REG_SC_BK2E_44_L      _PK_L_(0x2E, 0x44)
#define REG_SC_BK2E_44_H      _PK_H_(0x2E, 0x44)
#define REG_SC_BK2E_45_L      _PK_L_(0x2E, 0x45)
#define REG_SC_BK2E_45_H      _PK_H_(0x2E, 0x45)
#define REG_SC_BK2E_46_L      _PK_L_(0x2E, 0x46)
#define REG_SC_BK2E_46_H      _PK_H_(0x2E, 0x46)
#define REG_SC_BK2E_47_L      _PK_L_(0x2E, 0x47)
#define REG_SC_BK2E_47_H      _PK_H_(0x2E, 0x47)
#define REG_SC_BK2E_48_L      _PK_L_(0x2E, 0x48)
#define REG_SC_BK2E_48_H      _PK_H_(0x2E, 0x48)
#define REG_SC_BK2E_49_L      _PK_L_(0x2E, 0x49)
#define REG_SC_BK2E_49_H      _PK_H_(0x2E, 0x49)
#define REG_SC_BK2E_4A_L      _PK_L_(0x2E, 0x4A)
#define REG_SC_BK2E_4A_H      _PK_H_(0x2E, 0x4A)
#define REG_SC_BK2E_4B_L      _PK_L_(0x2E, 0x4B)
#define REG_SC_BK2E_4B_H      _PK_H_(0x2E, 0x4B)
#define REG_SC_BK2E_4C_L      _PK_L_(0x2E, 0x4C)
#define REG_SC_BK2E_4C_H      _PK_H_(0x2E, 0x4C)
#define REG_SC_BK2E_4D_L      _PK_L_(0x2E, 0x4D)
#define REG_SC_BK2E_4D_H      _PK_H_(0x2E, 0x4D)
#define REG_SC_BK2E_4E_L      _PK_L_(0x2E, 0x4E)
#define REG_SC_BK2E_4E_H      _PK_H_(0x2E, 0x4E)
#define REG_SC_BK2E_4F_L      _PK_L_(0x2E, 0x4F)
#define REG_SC_BK2E_4F_H      _PK_H_(0x2E, 0x4F)
#define REG_SC_BK2E_50_L      _PK_L_(0x2E, 0x50)
#define REG_SC_BK2E_50_H      _PK_H_(0x2E, 0x50)
#define REG_SC_BK2E_51_L      _PK_L_(0x2E, 0x51)
#define REG_SC_BK2E_51_H      _PK_H_(0x2E, 0x51)
#define REG_SC_BK2E_52_L      _PK_L_(0x2E, 0x52)
#define REG_SC_BK2E_52_H      _PK_H_(0x2E, 0x52)
#define REG_SC_BK2E_53_L      _PK_L_(0x2E, 0x53)
#define REG_SC_BK2E_53_H      _PK_H_(0x2E, 0x53)
#define REG_SC_BK2E_54_L      _PK_L_(0x2E, 0x54)
#define REG_SC_BK2E_54_H      _PK_H_(0x2E, 0x54)
#define REG_SC_BK2E_55_L      _PK_L_(0x2E, 0x55)
#define REG_SC_BK2E_55_H      _PK_H_(0x2E, 0x55)
#define REG_SC_BK2E_56_L      _PK_L_(0x2E, 0x56)
#define REG_SC_BK2E_56_H      _PK_H_(0x2E, 0x56)
#define REG_SC_BK2E_57_L      _PK_L_(0x2E, 0x57)
#define REG_SC_BK2E_57_H      _PK_H_(0x2E, 0x57)
#define REG_SC_BK2E_58_L      _PK_L_(0x2E, 0x58)
#define REG_SC_BK2E_58_H      _PK_H_(0x2E, 0x58)
#define REG_SC_BK2E_59_L      _PK_L_(0x2E, 0x59)
#define REG_SC_BK2E_59_H      _PK_H_(0x2E, 0x59)
#define REG_SC_BK2E_5A_L      _PK_L_(0x2E, 0x5A)
#define REG_SC_BK2E_5A_H      _PK_H_(0x2E, 0x5A)
#define REG_SC_BK2E_5B_L      _PK_L_(0x2E, 0x5B)
#define REG_SC_BK2E_5B_H      _PK_H_(0x2E, 0x5B)
#define REG_SC_BK2E_5C_L      _PK_L_(0x2E, 0x5C)
#define REG_SC_BK2E_5C_H      _PK_H_(0x2E, 0x5C)
#define REG_SC_BK2E_5D_L      _PK_L_(0x2E, 0x5D)
#define REG_SC_BK2E_5D_H      _PK_H_(0x2E, 0x5D)
#define REG_SC_BK2E_5E_L      _PK_L_(0x2E, 0x5E)
#define REG_SC_BK2E_5E_H      _PK_H_(0x2E, 0x5E)
#define REG_SC_BK2E_5F_L      _PK_L_(0x2E, 0x5F)
#define REG_SC_BK2E_5F_H      _PK_H_(0x2E, 0x5F)
#define REG_SC_BK2E_60_L      _PK_L_(0x2E, 0x60)
#define REG_SC_BK2E_60_H      _PK_H_(0x2E, 0x60)
#define REG_SC_BK2E_61_L      _PK_L_(0x2E, 0x61)
#define REG_SC_BK2E_61_H      _PK_H_(0x2E, 0x61)
#define REG_SC_BK2E_62_L      _PK_L_(0x2E, 0x62)
#define REG_SC_BK2E_62_H      _PK_H_(0x2E, 0x62)
#define REG_SC_BK2E_63_L      _PK_L_(0x2E, 0x63)
#define REG_SC_BK2E_63_H      _PK_H_(0x2E, 0x63)
#define REG_SC_BK2E_64_L      _PK_L_(0x2E, 0x64)
#define REG_SC_BK2E_64_H      _PK_H_(0x2E, 0x64)
#define REG_SC_BK2E_65_L      _PK_L_(0x2E, 0x65)
#define REG_SC_BK2E_65_H      _PK_H_(0x2E, 0x65)
#define REG_SC_BK2E_66_L      _PK_L_(0x2E, 0x66)
#define REG_SC_BK2E_66_H      _PK_H_(0x2E, 0x66)
#define REG_SC_BK2E_67_L      _PK_L_(0x2E, 0x67)
#define REG_SC_BK2E_67_H      _PK_H_(0x2E, 0x67)
#define REG_SC_BK2E_68_L      _PK_L_(0x2E, 0x68)
#define REG_SC_BK2E_68_H      _PK_H_(0x2E, 0x68)
#define REG_SC_BK2E_69_L      _PK_L_(0x2E, 0x69)
#define REG_SC_BK2E_69_H      _PK_H_(0x2E, 0x69)
#define REG_SC_BK2E_6A_L      _PK_L_(0x2E, 0x6A)
#define REG_SC_BK2E_6A_H      _PK_H_(0x2E, 0x6A)
#define REG_SC_BK2E_6B_L      _PK_L_(0x2E, 0x6B)
#define REG_SC_BK2E_6B_H      _PK_H_(0x2E, 0x6B)
#define REG_SC_BK2E_6C_L      _PK_L_(0x2E, 0x6C)
#define REG_SC_BK2E_6C_H      _PK_H_(0x2E, 0x6C)
#define REG_SC_BK2E_6D_L      _PK_L_(0x2E, 0x6D)
#define REG_SC_BK2E_6D_H      _PK_H_(0x2E, 0x6D)
#define REG_SC_BK2E_6E_L      _PK_L_(0x2E, 0x6E)
#define REG_SC_BK2E_6E_H      _PK_H_(0x2E, 0x6E)
#define REG_SC_BK2E_6F_L      _PK_L_(0x2E, 0x6F)
#define REG_SC_BK2E_6F_H      _PK_H_(0x2E, 0x6F)
#define REG_SC_BK2E_70_L      _PK_L_(0x2E, 0x70)
#define REG_SC_BK2E_70_H      _PK_H_(0x2E, 0x70)
#define REG_SC_BK2E_71_L      _PK_L_(0x2E, 0x71)
#define REG_SC_BK2E_71_H      _PK_H_(0x2E, 0x71)
#define REG_SC_BK2E_72_L      _PK_L_(0x2E, 0x72)
#define REG_SC_BK2E_72_H      _PK_H_(0x2E, 0x72)
#define REG_SC_BK2E_73_L      _PK_L_(0x2E, 0x73)
#define REG_SC_BK2E_73_H      _PK_H_(0x2E, 0x73)
#define REG_SC_BK2E_74_L      _PK_L_(0x2E, 0x74)
#define REG_SC_BK2E_74_H      _PK_H_(0x2E, 0x74)
#define REG_SC_BK2E_75_L      _PK_L_(0x2E, 0x75)
#define REG_SC_BK2E_75_H      _PK_H_(0x2E, 0x75)
#define REG_SC_BK2E_76_L      _PK_L_(0x2E, 0x76)
#define REG_SC_BK2E_76_H      _PK_H_(0x2E, 0x76)
#define REG_SC_BK2E_77_L      _PK_L_(0x2E, 0x77)
#define REG_SC_BK2E_77_H      _PK_H_(0x2E, 0x77)
#define REG_SC_BK2E_78_L      _PK_L_(0x2E, 0x78)
#define REG_SC_BK2E_78_H      _PK_H_(0x2E, 0x78)
#define REG_SC_BK2E_79_L      _PK_L_(0x2E, 0x79)
#define REG_SC_BK2E_79_H      _PK_H_(0x2E, 0x79)
#define REG_SC_BK2E_7A_L      _PK_L_(0x2E, 0x7A)
#define REG_SC_BK2E_7A_H      _PK_H_(0x2E, 0x7A)
#define REG_SC_BK2E_7B_L      _PK_L_(0x2E, 0x7B)
#define REG_SC_BK2E_7B_H      _PK_H_(0x2E, 0x7B)
#define REG_SC_BK2E_7C_L      _PK_L_(0x2E, 0x7C)
#define REG_SC_BK2E_7C_H      _PK_H_(0x2E, 0x7C)
#define REG_SC_BK2E_7D_L      _PK_L_(0x2E, 0x7D)
#define REG_SC_BK2E_7D_H      _PK_H_(0x2E, 0x7D)
#define REG_SC_BK2E_7E_L      _PK_L_(0x2E, 0x7E)
#define REG_SC_BK2E_7E_H      _PK_H_(0x2E, 0x7E)
#define REG_SC_BK2E_7F_L      _PK_L_(0x2E, 0x7F)
#define REG_SC_BK2E_7F_H      _PK_H_(0x2E, 0x7F)
//----------------------------------------------
#define REG_SC_BK30_00_L      _PK_L_(0x30, 0x00)
#define REG_SC_BK30_00_H      _PK_H_(0x30, 0x00)
#define REG_SC_BK30_01_L      _PK_L_(0x30, 0x01)
#define REG_SC_BK30_01_H      _PK_H_(0x30, 0x01)
#define REG_SC_BK30_02_L      _PK_L_(0x30, 0x02)
#define REG_SC_BK30_02_H      _PK_H_(0x30, 0x02)
#define REG_SC_BK30_03_L      _PK_L_(0x30, 0x03)
#define REG_SC_BK30_03_H      _PK_H_(0x30, 0x03)
#define REG_SC_BK30_04_L      _PK_L_(0x30, 0x04)
#define REG_SC_BK30_04_H      _PK_H_(0x30, 0x04)
#define REG_SC_BK30_05_L      _PK_L_(0x30, 0x05)
#define REG_SC_BK30_05_H      _PK_H_(0x30, 0x05)
#define REG_SC_BK30_06_L      _PK_L_(0x30, 0x06)
#define REG_SC_BK30_06_H      _PK_H_(0x30, 0x06)
#define REG_SC_BK30_07_L      _PK_L_(0x30, 0x07)
#define REG_SC_BK30_07_H      _PK_H_(0x30, 0x07)
#define REG_SC_BK30_08_L      _PK_L_(0x30, 0x08)
#define REG_SC_BK30_08_H      _PK_H_(0x30, 0x08)
#define REG_SC_BK30_09_L      _PK_L_(0x30, 0x09)
#define REG_SC_BK30_09_H      _PK_H_(0x30, 0x09)
#define REG_SC_BK30_0A_L      _PK_L_(0x30, 0x0A)
#define REG_SC_BK30_0A_H      _PK_H_(0x30, 0x0A)
#define REG_SC_BK30_0B_L      _PK_L_(0x30, 0x0B)
#define REG_SC_BK30_0B_H      _PK_H_(0x30, 0x0B)
#define REG_SC_BK30_0C_L      _PK_L_(0x30, 0x0C)
#define REG_SC_BK30_0C_H      _PK_H_(0x30, 0x0C)
#define REG_SC_BK30_0D_L      _PK_L_(0x30, 0x0D)
#define REG_SC_BK30_0D_H      _PK_H_(0x30, 0x0D)
#define REG_SC_BK30_0E_L      _PK_L_(0x30, 0x0E)
#define REG_SC_BK30_0E_H      _PK_H_(0x30, 0x0E)
#define REG_SC_BK30_0F_L      _PK_L_(0x30, 0x0F)
#define REG_SC_BK30_0F_H      _PK_H_(0x30, 0x0F)
#define REG_SC_BK30_10_L      _PK_L_(0x30, 0x10)
#define REG_SC_BK30_10_H      _PK_H_(0x30, 0x10)
#define REG_SC_BK30_11_L      _PK_L_(0x30, 0x11)
#define REG_SC_BK30_11_H      _PK_H_(0x30, 0x11)
#define REG_SC_BK30_12_L      _PK_L_(0x30, 0x12)
#define REG_SC_BK30_12_H      _PK_H_(0x30, 0x12)
#define REG_SC_BK30_13_L      _PK_L_(0x30, 0x13)
#define REG_SC_BK30_13_H      _PK_H_(0x30, 0x13)
#define REG_SC_BK30_14_L      _PK_L_(0x30, 0x14)
#define REG_SC_BK30_14_H      _PK_H_(0x30, 0x14)
#define REG_SC_BK30_15_L      _PK_L_(0x30, 0x15)
#define REG_SC_BK30_15_H      _PK_H_(0x30, 0x15)
#define REG_SC_BK30_16_L      _PK_L_(0x30, 0x16)
#define REG_SC_BK30_16_H      _PK_H_(0x30, 0x16)
#define REG_SC_BK30_17_L      _PK_L_(0x30, 0x17)
#define REG_SC_BK30_17_H      _PK_H_(0x30, 0x17)
#define REG_SC_BK30_18_L      _PK_L_(0x30, 0x18)
#define REG_SC_BK30_18_H      _PK_H_(0x30, 0x18)
#define REG_SC_BK30_19_L      _PK_L_(0x30, 0x19)
#define REG_SC_BK30_19_H      _PK_H_(0x30, 0x19)
#define REG_SC_BK30_1A_L      _PK_L_(0x30, 0x1A)
#define REG_SC_BK30_1A_H      _PK_H_(0x30, 0x1A)
#define REG_SC_BK30_1B_L      _PK_L_(0x30, 0x1B)
#define REG_SC_BK30_1B_H      _PK_H_(0x30, 0x1B)
#define REG_SC_BK30_1C_L      _PK_L_(0x30, 0x1C)
#define REG_SC_BK30_1C_H      _PK_H_(0x30, 0x1C)
#define REG_SC_BK30_1D_L      _PK_L_(0x30, 0x1D)
#define REG_SC_BK30_1D_H      _PK_H_(0x30, 0x1D)
#define REG_SC_BK30_1E_L      _PK_L_(0x30, 0x1E)
#define REG_SC_BK30_1E_H      _PK_H_(0x30, 0x1E)
#define REG_SC_BK30_1F_L      _PK_L_(0x30, 0x1F)
#define REG_SC_BK30_1F_H      _PK_H_(0x30, 0x1F)
#define REG_SC_BK30_20_L      _PK_L_(0x30, 0x20)
#define REG_SC_BK30_20_H      _PK_H_(0x30, 0x20)
#define REG_SC_BK30_21_L      _PK_L_(0x30, 0x21)
#define REG_SC_BK30_21_H      _PK_H_(0x30, 0x21)
#define REG_SC_BK30_22_L      _PK_L_(0x30, 0x22)
#define REG_SC_BK30_22_H      _PK_H_(0x30, 0x22)
#define REG_SC_BK30_23_L      _PK_L_(0x30, 0x23)
#define REG_SC_BK30_23_H      _PK_H_(0x30, 0x23)
#define REG_SC_BK30_24_L      _PK_L_(0x30, 0x24)
#define REG_SC_BK30_24_H      _PK_H_(0x30, 0x24)
#define REG_SC_BK30_25_L      _PK_L_(0x30, 0x25)
#define REG_SC_BK30_25_H      _PK_H_(0x30, 0x25)
#define REG_SC_BK30_26_L      _PK_L_(0x30, 0x26)
#define REG_SC_BK30_26_H      _PK_H_(0x30, 0x26)
#define REG_SC_BK30_27_L      _PK_L_(0x30, 0x27)
#define REG_SC_BK30_27_H      _PK_H_(0x30, 0x27)
#define REG_SC_BK30_28_L      _PK_L_(0x30, 0x28)
#define REG_SC_BK30_28_H      _PK_H_(0x30, 0x28)
#define REG_SC_BK30_29_L      _PK_L_(0x30, 0x29)
#define REG_SC_BK30_29_H      _PK_H_(0x30, 0x29)
#define REG_SC_BK30_2A_L      _PK_L_(0x30, 0x2A)
#define REG_SC_BK30_2A_H      _PK_H_(0x30, 0x2A)
#define REG_SC_BK30_2B_L      _PK_L_(0x30, 0x2B)
#define REG_SC_BK30_2B_H      _PK_H_(0x30, 0x2B)
#define REG_SC_BK30_2C_L      _PK_L_(0x30, 0x2C)
#define REG_SC_BK30_2C_H      _PK_H_(0x30, 0x2C)
#define REG_SC_BK30_2D_L      _PK_L_(0x30, 0x2D)
#define REG_SC_BK30_2D_H      _PK_H_(0x30, 0x2D)
#define REG_SC_BK30_2E_L      _PK_L_(0x30, 0x2E)
#define REG_SC_BK30_2E_H      _PK_H_(0x30, 0x2E)
#define REG_SC_BK30_2F_L      _PK_L_(0x30, 0x2F)
#define REG_SC_BK30_2F_H      _PK_H_(0x30, 0x2F)
#define REG_SC_BK30_30_L      _PK_L_(0x30, 0x30)
#define REG_SC_BK30_30_H      _PK_H_(0x30, 0x30)
#define REG_SC_BK30_31_L      _PK_L_(0x30, 0x31)
#define REG_SC_BK30_31_H      _PK_H_(0x30, 0x31)
#define REG_SC_BK30_32_L      _PK_L_(0x30, 0x32)
#define REG_SC_BK30_32_H      _PK_H_(0x30, 0x32)
#define REG_SC_BK30_33_L      _PK_L_(0x30, 0x33)
#define REG_SC_BK30_33_H      _PK_H_(0x30, 0x33)
#define REG_SC_BK30_34_L      _PK_L_(0x30, 0x34)
#define REG_SC_BK30_34_H      _PK_H_(0x30, 0x34)
#define REG_SC_BK30_35_L      _PK_L_(0x30, 0x35)
#define REG_SC_BK30_35_H      _PK_H_(0x30, 0x35)
#define REG_SC_BK30_36_L      _PK_L_(0x30, 0x36)
#define REG_SC_BK30_36_H      _PK_H_(0x30, 0x36)
#define REG_SC_BK30_37_L      _PK_L_(0x30, 0x37)
#define REG_SC_BK30_37_H      _PK_H_(0x30, 0x37)
#define REG_SC_BK30_38_L      _PK_L_(0x30, 0x38)
#define REG_SC_BK30_38_H      _PK_H_(0x30, 0x38)
#define REG_SC_BK30_39_L      _PK_L_(0x30, 0x39)
#define REG_SC_BK30_39_H      _PK_H_(0x30, 0x39)
#define REG_SC_BK30_3A_L      _PK_L_(0x30, 0x3A)
#define REG_SC_BK30_3A_H      _PK_H_(0x30, 0x3A)
#define REG_SC_BK30_3B_L      _PK_L_(0x30, 0x3B)
#define REG_SC_BK30_3B_H      _PK_H_(0x30, 0x3B)
#define REG_SC_BK30_3C_L      _PK_L_(0x30, 0x3C)
#define REG_SC_BK30_3C_H      _PK_H_(0x30, 0x3C)
#define REG_SC_BK30_3D_L      _PK_L_(0x30, 0x3D)
#define REG_SC_BK30_3D_H      _PK_H_(0x30, 0x3D)
#define REG_SC_BK30_3E_L      _PK_L_(0x30, 0x3E)
#define REG_SC_BK30_3E_H      _PK_H_(0x30, 0x3E)
#define REG_SC_BK30_3F_L      _PK_L_(0x30, 0x3F)
#define REG_SC_BK30_3F_H      _PK_H_(0x30, 0x3F)
#define REG_SC_BK30_40_L      _PK_L_(0x30, 0x40)
#define REG_SC_BK30_40_H      _PK_H_(0x30, 0x40)
#define REG_SC_BK30_41_L      _PK_L_(0x30, 0x41)
#define REG_SC_BK30_41_H      _PK_H_(0x30, 0x41)
#define REG_SC_BK30_42_L      _PK_L_(0x30, 0x42)
#define REG_SC_BK30_42_H      _PK_H_(0x30, 0x42)
#define REG_SC_BK30_43_L      _PK_L_(0x30, 0x43)
#define REG_SC_BK30_43_H      _PK_H_(0x30, 0x43)
#define REG_SC_BK30_44_L      _PK_L_(0x30, 0x44)
#define REG_SC_BK30_44_H      _PK_H_(0x30, 0x44)
#define REG_SC_BK30_45_L      _PK_L_(0x30, 0x45)
#define REG_SC_BK30_45_H      _PK_H_(0x30, 0x45)
#define REG_SC_BK30_46_L      _PK_L_(0x30, 0x46)
#define REG_SC_BK30_46_H      _PK_H_(0x30, 0x46)
#define REG_SC_BK30_47_L      _PK_L_(0x30, 0x47)
#define REG_SC_BK30_47_H      _PK_H_(0x30, 0x47)
#define REG_SC_BK30_48_L      _PK_L_(0x30, 0x48)
#define REG_SC_BK30_48_H      _PK_H_(0x30, 0x48)
#define REG_SC_BK30_49_L      _PK_L_(0x30, 0x49)
#define REG_SC_BK30_49_H      _PK_H_(0x30, 0x49)
#define REG_SC_BK30_4A_L      _PK_L_(0x30, 0x4A)
#define REG_SC_BK30_4A_H      _PK_H_(0x30, 0x4A)
#define REG_SC_BK30_4B_L      _PK_L_(0x30, 0x4B)
#define REG_SC_BK30_4B_H      _PK_H_(0x30, 0x4B)
#define REG_SC_BK30_4C_L      _PK_L_(0x30, 0x4C)
#define REG_SC_BK30_4C_H      _PK_H_(0x30, 0x4C)
#define REG_SC_BK30_4D_L      _PK_L_(0x30, 0x4D)
#define REG_SC_BK30_4D_H      _PK_H_(0x30, 0x4D)
#define REG_SC_BK30_4E_L      _PK_L_(0x30, 0x4E)
#define REG_SC_BK30_4E_H      _PK_H_(0x30, 0x4E)
#define REG_SC_BK30_4F_L      _PK_L_(0x30, 0x4F)
#define REG_SC_BK30_4F_H      _PK_H_(0x30, 0x4F)
#define REG_SC_BK30_50_L      _PK_L_(0x30, 0x50)
#define REG_SC_BK30_50_H      _PK_H_(0x30, 0x50)
#define REG_SC_BK30_51_L      _PK_L_(0x30, 0x51)
#define REG_SC_BK30_51_H      _PK_H_(0x30, 0x51)
#define REG_SC_BK30_52_L      _PK_L_(0x30, 0x52)
#define REG_SC_BK30_52_H      _PK_H_(0x30, 0x52)
#define REG_SC_BK30_53_L      _PK_L_(0x30, 0x53)
#define REG_SC_BK30_53_H      _PK_H_(0x30, 0x53)
#define REG_SC_BK30_54_L      _PK_L_(0x30, 0x54)
#define REG_SC_BK30_54_H      _PK_H_(0x30, 0x54)
#define REG_SC_BK30_55_L      _PK_L_(0x30, 0x55)
#define REG_SC_BK30_55_H      _PK_H_(0x30, 0x55)
#define REG_SC_BK30_56_L      _PK_L_(0x30, 0x56)
#define REG_SC_BK30_56_H      _PK_H_(0x30, 0x56)
#define REG_SC_BK30_57_L      _PK_L_(0x30, 0x57)
#define REG_SC_BK30_57_H      _PK_H_(0x30, 0x57)
#define REG_SC_BK30_58_L      _PK_L_(0x30, 0x58)
#define REG_SC_BK30_58_H      _PK_H_(0x30, 0x58)
#define REG_SC_BK30_59_L      _PK_L_(0x30, 0x59)
#define REG_SC_BK30_59_H      _PK_H_(0x30, 0x59)
#define REG_SC_BK30_5A_L      _PK_L_(0x30, 0x5A)
#define REG_SC_BK30_5A_H      _PK_H_(0x30, 0x5A)
#define REG_SC_BK30_5B_L      _PK_L_(0x30, 0x5B)
#define REG_SC_BK30_5B_H      _PK_H_(0x30, 0x5B)
#define REG_SC_BK30_5C_L      _PK_L_(0x30, 0x5C)
#define REG_SC_BK30_5C_H      _PK_H_(0x30, 0x5C)
#define REG_SC_BK30_5D_L      _PK_L_(0x30, 0x5D)
#define REG_SC_BK30_5D_H      _PK_H_(0x30, 0x5D)
#define REG_SC_BK30_5E_L      _PK_L_(0x30, 0x5E)
#define REG_SC_BK30_5E_H      _PK_H_(0x30, 0x5E)
#define REG_SC_BK30_5F_L      _PK_L_(0x30, 0x5F)
#define REG_SC_BK30_5F_H      _PK_H_(0x30, 0x5F)
#define REG_SC_BK30_60_L      _PK_L_(0x30, 0x60)
#define REG_SC_BK30_60_H      _PK_H_(0x30, 0x60)
#define REG_SC_BK30_61_L      _PK_L_(0x30, 0x61)
#define REG_SC_BK30_61_H      _PK_H_(0x30, 0x61)
#define REG_SC_BK30_62_L      _PK_L_(0x30, 0x62)
#define REG_SC_BK30_62_H      _PK_H_(0x30, 0x62)
#define REG_SC_BK30_63_L      _PK_L_(0x30, 0x63)
#define REG_SC_BK30_63_H      _PK_H_(0x30, 0x63)
#define REG_SC_BK30_64_L      _PK_L_(0x30, 0x64)
#define REG_SC_BK30_64_H      _PK_H_(0x30, 0x64)
#define REG_SC_BK30_65_L      _PK_L_(0x30, 0x65)
#define REG_SC_BK30_65_H      _PK_H_(0x30, 0x65)
#define REG_SC_BK30_66_L      _PK_L_(0x30, 0x66)
#define REG_SC_BK30_66_H      _PK_H_(0x30, 0x66)
#define REG_SC_BK30_67_L      _PK_L_(0x30, 0x67)
#define REG_SC_BK30_67_H      _PK_H_(0x30, 0x67)
#define REG_SC_BK30_68_L      _PK_L_(0x30, 0x68)
#define REG_SC_BK30_68_H      _PK_H_(0x30, 0x68)
#define REG_SC_BK30_69_L      _PK_L_(0x30, 0x69)
#define REG_SC_BK30_69_H      _PK_H_(0x30, 0x69)
#define REG_SC_BK30_6A_L      _PK_L_(0x30, 0x6A)
#define REG_SC_BK30_6A_H      _PK_H_(0x30, 0x6A)
#define REG_SC_BK30_6B_L      _PK_L_(0x30, 0x6B)
#define REG_SC_BK30_6B_H      _PK_H_(0x30, 0x6B)
#define REG_SC_BK30_6C_L      _PK_L_(0x30, 0x6C)
#define REG_SC_BK30_6C_H      _PK_H_(0x30, 0x6C)
#define REG_SC_BK30_6D_L      _PK_L_(0x30, 0x6D)
#define REG_SC_BK30_6D_H      _PK_H_(0x30, 0x6D)
#define REG_SC_BK30_6E_L      _PK_L_(0x30, 0x6E)
#define REG_SC_BK30_6E_H      _PK_H_(0x30, 0x6E)
#define REG_SC_BK30_6F_L      _PK_L_(0x30, 0x6F)
#define REG_SC_BK30_6F_H      _PK_H_(0x30, 0x6F)
#define REG_SC_BK30_70_L      _PK_L_(0x30, 0x70)
#define REG_SC_BK30_70_H      _PK_H_(0x30, 0x70)
#define REG_SC_BK30_71_L      _PK_L_(0x30, 0x71)
#define REG_SC_BK30_71_H      _PK_H_(0x30, 0x71)
#define REG_SC_BK30_72_L      _PK_L_(0x30, 0x72)
#define REG_SC_BK30_72_H      _PK_H_(0x30, 0x72)
#define REG_SC_BK30_73_L      _PK_L_(0x30, 0x73)
#define REG_SC_BK30_73_H      _PK_H_(0x30, 0x73)
#define REG_SC_BK30_74_L      _PK_L_(0x30, 0x74)
#define REG_SC_BK30_74_H      _PK_H_(0x30, 0x74)
#define REG_SC_BK30_75_L      _PK_L_(0x30, 0x75)
#define REG_SC_BK30_75_H      _PK_H_(0x30, 0x75)
#define REG_SC_BK30_76_L      _PK_L_(0x30, 0x76)
#define REG_SC_BK30_76_H      _PK_H_(0x30, 0x76)
#define REG_SC_BK30_77_L      _PK_L_(0x30, 0x77)
#define REG_SC_BK30_77_H      _PK_H_(0x30, 0x77)
#define REG_SC_BK30_78_L      _PK_L_(0x30, 0x78)
#define REG_SC_BK30_78_H      _PK_H_(0x30, 0x78)
#define REG_SC_BK30_79_L      _PK_L_(0x30, 0x79)
#define REG_SC_BK30_79_H      _PK_H_(0x30, 0x79)
#define REG_SC_BK30_7A_L      _PK_L_(0x30, 0x7A)
#define REG_SC_BK30_7A_H      _PK_H_(0x30, 0x7A)
#define REG_SC_BK30_7B_L      _PK_L_(0x30, 0x7B)
#define REG_SC_BK30_7B_H      _PK_H_(0x30, 0x7B)
#define REG_SC_BK30_7C_L      _PK_L_(0x30, 0x7C)
#define REG_SC_BK30_7C_H      _PK_H_(0x30, 0x7C)
#define REG_SC_BK30_7D_L      _PK_L_(0x30, 0x7D)
#define REG_SC_BK30_7D_H      _PK_H_(0x30, 0x7D)
#define REG_SC_BK30_7E_L      _PK_L_(0x30, 0x7E)
#define REG_SC_BK30_7E_H      _PK_H_(0x30, 0x7E)
#define REG_SC_BK30_7F_L      _PK_L_(0x30, 0x7F)
#define REG_SC_BK30_7F_H      _PK_H_(0x30, 0x7F)
//----------------------------------------------
#define REG_SC_BK31_00_L      _PK_L_(0x31, 0x00)
#define REG_SC_BK31_00_H      _PK_H_(0x31, 0x00)
#define REG_SC_BK31_01_L      _PK_L_(0x31, 0x01)
#define REG_SC_BK31_01_H      _PK_H_(0x31, 0x01)
#define REG_SC_BK31_02_L      _PK_L_(0x31, 0x02)
#define REG_SC_BK31_02_H      _PK_H_(0x31, 0x02)
#define REG_SC_BK31_03_L      _PK_L_(0x31, 0x03)
#define REG_SC_BK31_03_H      _PK_H_(0x31, 0x03)
#define REG_SC_BK31_04_L      _PK_L_(0x31, 0x04)
#define REG_SC_BK31_04_H      _PK_H_(0x31, 0x04)
#define REG_SC_BK31_05_L      _PK_L_(0x31, 0x05)
#define REG_SC_BK31_05_H      _PK_H_(0x31, 0x05)
#define REG_SC_BK31_06_L      _PK_L_(0x31, 0x06)
#define REG_SC_BK31_06_H      _PK_H_(0x31, 0x06)
#define REG_SC_BK31_07_L      _PK_L_(0x31, 0x07)
#define REG_SC_BK31_07_H      _PK_H_(0x31, 0x07)
#define REG_SC_BK31_08_L      _PK_L_(0x31, 0x08)
#define REG_SC_BK31_08_H      _PK_H_(0x31, 0x08)
#define REG_SC_BK31_09_L      _PK_L_(0x31, 0x09)
#define REG_SC_BK31_09_H      _PK_H_(0x31, 0x09)
#define REG_SC_BK31_0A_L      _PK_L_(0x31, 0x0A)
#define REG_SC_BK31_0A_H      _PK_H_(0x31, 0x0A)
#define REG_SC_BK31_0B_L      _PK_L_(0x31, 0x0B)
#define REG_SC_BK31_0B_H      _PK_H_(0x31, 0x0B)
#define REG_SC_BK31_0C_L      _PK_L_(0x31, 0x0C)
#define REG_SC_BK31_0C_H      _PK_H_(0x31, 0x0C)
#define REG_SC_BK31_0D_L      _PK_L_(0x31, 0x0D)
#define REG_SC_BK31_0D_H      _PK_H_(0x31, 0x0D)
#define REG_SC_BK31_0E_L      _PK_L_(0x31, 0x0E)
#define REG_SC_BK31_0E_H      _PK_H_(0x31, 0x0E)
#define REG_SC_BK31_0F_L      _PK_L_(0x31, 0x0F)
#define REG_SC_BK31_0F_H      _PK_H_(0x31, 0x0F)
#define REG_SC_BK31_10_L      _PK_L_(0x31, 0x10)
#define REG_SC_BK31_10_H      _PK_H_(0x31, 0x10)
#define REG_SC_BK31_11_L      _PK_L_(0x31, 0x11)
#define REG_SC_BK31_11_H      _PK_H_(0x31, 0x11)
#define REG_SC_BK31_12_L      _PK_L_(0x31, 0x12)
#define REG_SC_BK31_12_H      _PK_H_(0x31, 0x12)
#define REG_SC_BK31_13_L      _PK_L_(0x31, 0x13)
#define REG_SC_BK31_13_H      _PK_H_(0x31, 0x13)
#define REG_SC_BK31_14_L      _PK_L_(0x31, 0x14)
#define REG_SC_BK31_14_H      _PK_H_(0x31, 0x14)
#define REG_SC_BK31_15_L      _PK_L_(0x31, 0x15)
#define REG_SC_BK31_15_H      _PK_H_(0x31, 0x15)
#define REG_SC_BK31_16_L      _PK_L_(0x31, 0x16)
#define REG_SC_BK31_16_H      _PK_H_(0x31, 0x16)
#define REG_SC_BK31_17_L      _PK_L_(0x31, 0x17)
#define REG_SC_BK31_17_H      _PK_H_(0x31, 0x17)
#define REG_SC_BK31_18_L      _PK_L_(0x31, 0x18)
#define REG_SC_BK31_18_H      _PK_H_(0x31, 0x18)
#define REG_SC_BK31_19_L      _PK_L_(0x31, 0x19)
#define REG_SC_BK31_19_H      _PK_H_(0x31, 0x19)
#define REG_SC_BK31_1A_L      _PK_L_(0x31, 0x1A)
#define REG_SC_BK31_1A_H      _PK_H_(0x31, 0x1A)
#define REG_SC_BK31_1B_L      _PK_L_(0x31, 0x1B)
#define REG_SC_BK31_1B_H      _PK_H_(0x31, 0x1B)
#define REG_SC_BK31_1C_L      _PK_L_(0x31, 0x1C)
#define REG_SC_BK31_1C_H      _PK_H_(0x31, 0x1C)
#define REG_SC_BK31_1D_L      _PK_L_(0x31, 0x1D)
#define REG_SC_BK31_1D_H      _PK_H_(0x31, 0x1D)
#define REG_SC_BK31_1E_L      _PK_L_(0x31, 0x1E)
#define REG_SC_BK31_1E_H      _PK_H_(0x31, 0x1E)
#define REG_SC_BK31_1F_L      _PK_L_(0x31, 0x1F)
#define REG_SC_BK31_1F_H      _PK_H_(0x31, 0x1F)
#define REG_SC_BK31_20_L      _PK_L_(0x31, 0x20)
#define REG_SC_BK31_20_H      _PK_H_(0x31, 0x20)
#define REG_SC_BK31_21_L      _PK_L_(0x31, 0x21)
#define REG_SC_BK31_21_H      _PK_H_(0x31, 0x21)
#define REG_SC_BK31_22_L      _PK_L_(0x31, 0x22)
#define REG_SC_BK31_22_H      _PK_H_(0x31, 0x22)
#define REG_SC_BK31_23_L      _PK_L_(0x31, 0x23)
#define REG_SC_BK31_23_H      _PK_H_(0x31, 0x23)
#define REG_SC_BK31_24_L      _PK_L_(0x31, 0x24)
#define REG_SC_BK31_24_H      _PK_H_(0x31, 0x24)
#define REG_SC_BK31_25_L      _PK_L_(0x31, 0x25)
#define REG_SC_BK31_25_H      _PK_H_(0x31, 0x25)
#define REG_SC_BK31_26_L      _PK_L_(0x31, 0x26)
#define REG_SC_BK31_26_H      _PK_H_(0x31, 0x26)
#define REG_SC_BK31_27_L      _PK_L_(0x31, 0x27)
#define REG_SC_BK31_27_H      _PK_H_(0x31, 0x27)
#define REG_SC_BK31_28_L      _PK_L_(0x31, 0x28)
#define REG_SC_BK31_28_H      _PK_H_(0x31, 0x28)
#define REG_SC_BK31_29_L      _PK_L_(0x31, 0x29)
#define REG_SC_BK31_29_H      _PK_H_(0x31, 0x29)
#define REG_SC_BK31_2A_L      _PK_L_(0x31, 0x2A)
#define REG_SC_BK31_2A_H      _PK_H_(0x31, 0x2A)
#define REG_SC_BK31_2B_L      _PK_L_(0x31, 0x2B)
#define REG_SC_BK31_2B_H      _PK_H_(0x31, 0x2B)
#define REG_SC_BK31_2C_L      _PK_L_(0x31, 0x2C)
#define REG_SC_BK31_2C_H      _PK_H_(0x31, 0x2C)
#define REG_SC_BK31_2D_L      _PK_L_(0x31, 0x2D)
#define REG_SC_BK31_2D_H      _PK_H_(0x31, 0x2D)
#define REG_SC_BK31_2E_L      _PK_L_(0x31, 0x2E)
#define REG_SC_BK31_2E_H      _PK_H_(0x31, 0x2E)
#define REG_SC_BK31_2F_L      _PK_L_(0x31, 0x2F)
#define REG_SC_BK31_2F_H      _PK_H_(0x31, 0x2F)
#define REG_SC_BK31_30_L      _PK_L_(0x31, 0x30)
#define REG_SC_BK31_30_H      _PK_H_(0x31, 0x30)
#define REG_SC_BK31_31_L      _PK_L_(0x31, 0x31)
#define REG_SC_BK31_31_H      _PK_H_(0x31, 0x31)
#define REG_SC_BK31_32_L      _PK_L_(0x31, 0x32)
#define REG_SC_BK31_32_H      _PK_H_(0x31, 0x32)
#define REG_SC_BK31_33_L      _PK_L_(0x31, 0x33)
#define REG_SC_BK31_33_H      _PK_H_(0x31, 0x33)
#define REG_SC_BK31_34_L      _PK_L_(0x31, 0x34)
#define REG_SC_BK31_34_H      _PK_H_(0x31, 0x34)
#define REG_SC_BK31_35_L      _PK_L_(0x31, 0x35)
#define REG_SC_BK31_35_H      _PK_H_(0x31, 0x35)
#define REG_SC_BK31_36_L      _PK_L_(0x31, 0x36)
#define REG_SC_BK31_36_H      _PK_H_(0x31, 0x36)
#define REG_SC_BK31_37_L      _PK_L_(0x31, 0x37)
#define REG_SC_BK31_37_H      _PK_H_(0x31, 0x37)
#define REG_SC_BK31_38_L      _PK_L_(0x31, 0x38)
#define REG_SC_BK31_38_H      _PK_H_(0x31, 0x38)
#define REG_SC_BK31_39_L      _PK_L_(0x31, 0x39)
#define REG_SC_BK31_39_H      _PK_H_(0x31, 0x39)
#define REG_SC_BK31_3A_L      _PK_L_(0x31, 0x3A)
#define REG_SC_BK31_3A_H      _PK_H_(0x31, 0x3A)
#define REG_SC_BK31_3B_L      _PK_L_(0x31, 0x3B)
#define REG_SC_BK31_3B_H      _PK_H_(0x31, 0x3B)
#define REG_SC_BK31_3C_L      _PK_L_(0x31, 0x3C)
#define REG_SC_BK31_3C_H      _PK_H_(0x31, 0x3C)
#define REG_SC_BK31_3D_L      _PK_L_(0x31, 0x3D)
#define REG_SC_BK31_3D_H      _PK_H_(0x31, 0x3D)
#define REG_SC_BK31_3E_L      _PK_L_(0x31, 0x3E)
#define REG_SC_BK31_3E_H      _PK_H_(0x31, 0x3E)
#define REG_SC_BK31_3F_L      _PK_L_(0x31, 0x3F)
#define REG_SC_BK31_3F_H      _PK_H_(0x31, 0x3F)
#define REG_SC_BK31_40_L      _PK_L_(0x31, 0x40)
#define REG_SC_BK31_40_H      _PK_H_(0x31, 0x40)
#define REG_SC_BK31_41_L      _PK_L_(0x31, 0x41)
#define REG_SC_BK31_41_H      _PK_H_(0x31, 0x41)
#define REG_SC_BK31_42_L      _PK_L_(0x31, 0x42)
#define REG_SC_BK31_42_H      _PK_H_(0x31, 0x42)
#define REG_SC_BK31_43_L      _PK_L_(0x31, 0x43)
#define REG_SC_BK31_43_H      _PK_H_(0x31, 0x43)
#define REG_SC_BK31_44_L      _PK_L_(0x31, 0x44)
#define REG_SC_BK31_44_H      _PK_H_(0x31, 0x44)
#define REG_SC_BK31_45_L      _PK_L_(0x31, 0x45)
#define REG_SC_BK31_45_H      _PK_H_(0x31, 0x45)
#define REG_SC_BK31_46_L      _PK_L_(0x31, 0x46)
#define REG_SC_BK31_46_H      _PK_H_(0x31, 0x46)
#define REG_SC_BK31_47_L      _PK_L_(0x31, 0x47)
#define REG_SC_BK31_47_H      _PK_H_(0x31, 0x47)
#define REG_SC_BK31_48_L      _PK_L_(0x31, 0x48)
#define REG_SC_BK31_48_H      _PK_H_(0x31, 0x48)
#define REG_SC_BK31_49_L      _PK_L_(0x31, 0x49)
#define REG_SC_BK31_49_H      _PK_H_(0x31, 0x49)
#define REG_SC_BK31_4A_L      _PK_L_(0x31, 0x4A)
#define REG_SC_BK31_4A_H      _PK_H_(0x31, 0x4A)
#define REG_SC_BK31_4B_L      _PK_L_(0x31, 0x4B)
#define REG_SC_BK31_4B_H      _PK_H_(0x31, 0x4B)
#define REG_SC_BK31_4C_L      _PK_L_(0x31, 0x4C)
#define REG_SC_BK31_4C_H      _PK_H_(0x31, 0x4C)
#define REG_SC_BK31_4D_L      _PK_L_(0x31, 0x4D)
#define REG_SC_BK31_4D_H      _PK_H_(0x31, 0x4D)
#define REG_SC_BK31_4E_L      _PK_L_(0x31, 0x4E)
#define REG_SC_BK31_4E_H      _PK_H_(0x31, 0x4E)
#define REG_SC_BK31_4F_L      _PK_L_(0x31, 0x4F)
#define REG_SC_BK31_4F_H      _PK_H_(0x31, 0x4F)
#define REG_SC_BK31_50_L      _PK_L_(0x31, 0x50)
#define REG_SC_BK31_50_H      _PK_H_(0x31, 0x50)
#define REG_SC_BK31_51_L      _PK_L_(0x31, 0x51)
#define REG_SC_BK31_51_H      _PK_H_(0x31, 0x51)
#define REG_SC_BK31_52_L      _PK_L_(0x31, 0x52)
#define REG_SC_BK31_52_H      _PK_H_(0x31, 0x52)
#define REG_SC_BK31_53_L      _PK_L_(0x31, 0x53)
#define REG_SC_BK31_53_H      _PK_H_(0x31, 0x53)
#define REG_SC_BK31_54_L      _PK_L_(0x31, 0x54)
#define REG_SC_BK31_54_H      _PK_H_(0x31, 0x54)
#define REG_SC_BK31_55_L      _PK_L_(0x31, 0x55)
#define REG_SC_BK31_55_H      _PK_H_(0x31, 0x55)
#define REG_SC_BK31_56_L      _PK_L_(0x31, 0x56)
#define REG_SC_BK31_56_H      _PK_H_(0x31, 0x56)
#define REG_SC_BK31_57_L      _PK_L_(0x31, 0x57)
#define REG_SC_BK31_57_H      _PK_H_(0x31, 0x57)
#define REG_SC_BK31_58_L      _PK_L_(0x31, 0x58)
#define REG_SC_BK31_58_H      _PK_H_(0x31, 0x58)
#define REG_SC_BK31_59_L      _PK_L_(0x31, 0x59)
#define REG_SC_BK31_59_H      _PK_H_(0x31, 0x59)
#define REG_SC_BK31_5A_L      _PK_L_(0x31, 0x5A)
#define REG_SC_BK31_5A_H      _PK_H_(0x31, 0x5A)
#define REG_SC_BK31_5B_L      _PK_L_(0x31, 0x5B)
#define REG_SC_BK31_5B_H      _PK_H_(0x31, 0x5B)
#define REG_SC_BK31_5C_L      _PK_L_(0x31, 0x5C)
#define REG_SC_BK31_5C_H      _PK_H_(0x31, 0x5C)
#define REG_SC_BK31_5D_L      _PK_L_(0x31, 0x5D)
#define REG_SC_BK31_5D_H      _PK_H_(0x31, 0x5D)
#define REG_SC_BK31_5E_L      _PK_L_(0x31, 0x5E)
#define REG_SC_BK31_5E_H      _PK_H_(0x31, 0x5E)
#define REG_SC_BK31_5F_L      _PK_L_(0x31, 0x5F)
#define REG_SC_BK31_5F_H      _PK_H_(0x31, 0x5F)
#define REG_SC_BK31_60_L      _PK_L_(0x31, 0x60)
#define REG_SC_BK31_60_H      _PK_H_(0x31, 0x60)
#define REG_SC_BK31_61_L      _PK_L_(0x31, 0x61)
#define REG_SC_BK31_61_H      _PK_H_(0x31, 0x61)
#define REG_SC_BK31_62_L      _PK_L_(0x31, 0x62)
#define REG_SC_BK31_62_H      _PK_H_(0x31, 0x62)
#define REG_SC_BK31_63_L      _PK_L_(0x31, 0x63)
#define REG_SC_BK31_63_H      _PK_H_(0x31, 0x63)
#define REG_SC_BK31_64_L      _PK_L_(0x31, 0x64)
#define REG_SC_BK31_64_H      _PK_H_(0x31, 0x64)
#define REG_SC_BK31_65_L      _PK_L_(0x31, 0x65)
#define REG_SC_BK31_65_H      _PK_H_(0x31, 0x65)
#define REG_SC_BK31_66_L      _PK_L_(0x31, 0x66)
#define REG_SC_BK31_66_H      _PK_H_(0x31, 0x66)
#define REG_SC_BK31_67_L      _PK_L_(0x31, 0x67)
#define REG_SC_BK31_67_H      _PK_H_(0x31, 0x67)
#define REG_SC_BK31_68_L      _PK_L_(0x31, 0x68)
#define REG_SC_BK31_68_H      _PK_H_(0x31, 0x68)
#define REG_SC_BK31_69_L      _PK_L_(0x31, 0x69)
#define REG_SC_BK31_69_H      _PK_H_(0x31, 0x69)
#define REG_SC_BK31_6A_L      _PK_L_(0x31, 0x6A)
#define REG_SC_BK31_6A_H      _PK_H_(0x31, 0x6A)
#define REG_SC_BK31_6B_L      _PK_L_(0x31, 0x6B)
#define REG_SC_BK31_6B_H      _PK_H_(0x31, 0x6B)
#define REG_SC_BK31_6C_L      _PK_L_(0x31, 0x6C)
#define REG_SC_BK31_6C_H      _PK_H_(0x31, 0x6C)
#define REG_SC_BK31_6D_L      _PK_L_(0x31, 0x6D)
#define REG_SC_BK31_6D_H      _PK_H_(0x31, 0x6D)
#define REG_SC_BK31_6E_L      _PK_L_(0x31, 0x6E)
#define REG_SC_BK31_6E_H      _PK_H_(0x31, 0x6E)
#define REG_SC_BK31_6F_L      _PK_L_(0x31, 0x6F)
#define REG_SC_BK31_6F_H      _PK_H_(0x31, 0x6F)
#define REG_SC_BK31_70_L      _PK_L_(0x31, 0x70)
#define REG_SC_BK31_70_H      _PK_H_(0x31, 0x70)
#define REG_SC_BK31_71_L      _PK_L_(0x31, 0x71)
#define REG_SC_BK31_71_H      _PK_H_(0x31, 0x71)
#define REG_SC_BK31_72_L      _PK_L_(0x31, 0x72)
#define REG_SC_BK31_72_H      _PK_H_(0x31, 0x72)
#define REG_SC_BK31_73_L      _PK_L_(0x31, 0x73)
#define REG_SC_BK31_73_H      _PK_H_(0x31, 0x73)
#define REG_SC_BK31_74_L      _PK_L_(0x31, 0x74)
#define REG_SC_BK31_74_H      _PK_H_(0x31, 0x74)
#define REG_SC_BK31_75_L      _PK_L_(0x31, 0x75)
#define REG_SC_BK31_75_H      _PK_H_(0x31, 0x75)
#define REG_SC_BK31_76_L      _PK_L_(0x31, 0x76)
#define REG_SC_BK31_76_H      _PK_H_(0x31, 0x76)
#define REG_SC_BK31_77_L      _PK_L_(0x31, 0x77)
#define REG_SC_BK31_77_H      _PK_H_(0x31, 0x77)
#define REG_SC_BK31_78_L      _PK_L_(0x31, 0x78)
#define REG_SC_BK31_78_H      _PK_H_(0x31, 0x78)
#define REG_SC_BK31_79_L      _PK_L_(0x31, 0x79)
#define REG_SC_BK31_79_H      _PK_H_(0x31, 0x79)
#define REG_SC_BK31_7A_L      _PK_L_(0x31, 0x7A)
#define REG_SC_BK31_7A_H      _PK_H_(0x31, 0x7A)
#define REG_SC_BK31_7B_L      _PK_L_(0x31, 0x7B)
#define REG_SC_BK31_7B_H      _PK_H_(0x31, 0x7B)
#define REG_SC_BK31_7C_L      _PK_L_(0x31, 0x7C)
#define REG_SC_BK31_7C_H      _PK_H_(0x31, 0x7C)
#define REG_SC_BK31_7D_L      _PK_L_(0x31, 0x7D)
#define REG_SC_BK31_7D_H      _PK_H_(0x31, 0x7D)
#define REG_SC_BK31_7E_L      _PK_L_(0x31, 0x7E)
#define REG_SC_BK31_7E_H      _PK_H_(0x31, 0x7E)
#define REG_SC_BK31_7F_L      _PK_L_(0x31, 0x7F)
#define REG_SC_BK31_7F_H      _PK_H_(0x31, 0x7F)
//----------------------------------------------
#define REG_SC_BK32_00_L      _PK_L_(0x32, 0x00)
#define REG_SC_BK32_00_H      _PK_H_(0x32, 0x00)
#define REG_SC_BK32_01_L      _PK_L_(0x32, 0x01)
#define REG_SC_BK32_01_H      _PK_H_(0x32, 0x01)
#define REG_SC_BK32_02_L      _PK_L_(0x32, 0x02)
#define REG_SC_BK32_02_H      _PK_H_(0x32, 0x02)
#define REG_SC_BK32_03_L      _PK_L_(0x32, 0x03)
#define REG_SC_BK32_03_H      _PK_H_(0x32, 0x03)
#define REG_SC_BK32_04_L      _PK_L_(0x32, 0x04)
#define REG_SC_BK32_04_H      _PK_H_(0x32, 0x04)
#define REG_SC_BK32_05_L      _PK_L_(0x32, 0x05)
#define REG_SC_BK32_05_H      _PK_H_(0x32, 0x05)
#define REG_SC_BK32_06_L      _PK_L_(0x32, 0x06)
#define REG_SC_BK32_06_H      _PK_H_(0x32, 0x06)
#define REG_SC_BK32_07_L      _PK_L_(0x32, 0x07)
#define REG_SC_BK32_07_H      _PK_H_(0x32, 0x07)
#define REG_SC_BK32_08_L      _PK_L_(0x32, 0x08)
#define REG_SC_BK32_08_H      _PK_H_(0x32, 0x08)
#define REG_SC_BK32_09_L      _PK_L_(0x32, 0x09)
#define REG_SC_BK32_09_H      _PK_H_(0x32, 0x09)
#define REG_SC_BK32_0A_L      _PK_L_(0x32, 0x0A)
#define REG_SC_BK32_0A_H      _PK_H_(0x32, 0x0A)
#define REG_SC_BK32_0B_L      _PK_L_(0x32, 0x0B)
#define REG_SC_BK32_0B_H      _PK_H_(0x32, 0x0B)
#define REG_SC_BK32_0C_L      _PK_L_(0x32, 0x0C)
#define REG_SC_BK32_0C_H      _PK_H_(0x32, 0x0C)
#define REG_SC_BK32_0D_L      _PK_L_(0x32, 0x0D)
#define REG_SC_BK32_0D_H      _PK_H_(0x32, 0x0D)
#define REG_SC_BK32_0E_L      _PK_L_(0x32, 0x0E)
#define REG_SC_BK32_0E_H      _PK_H_(0x32, 0x0E)
#define REG_SC_BK32_0F_L      _PK_L_(0x32, 0x0F)
#define REG_SC_BK32_0F_H      _PK_H_(0x32, 0x0F)
#define REG_SC_BK32_10_L      _PK_L_(0x32, 0x10)
#define REG_SC_BK32_10_H      _PK_H_(0x32, 0x10)
#define REG_SC_BK32_11_L      _PK_L_(0x32, 0x11)
#define REG_SC_BK32_11_H      _PK_H_(0x32, 0x11)
#define REG_SC_BK32_12_L      _PK_L_(0x32, 0x12)
#define REG_SC_BK32_12_H      _PK_H_(0x32, 0x12)
#define REG_SC_BK32_13_L      _PK_L_(0x32, 0x13)
#define REG_SC_BK32_13_H      _PK_H_(0x32, 0x13)
#define REG_SC_BK32_14_L      _PK_L_(0x32, 0x14)
#define REG_SC_BK32_14_H      _PK_H_(0x32, 0x14)
#define REG_SC_BK32_15_L      _PK_L_(0x32, 0x15)
#define REG_SC_BK32_15_H      _PK_H_(0x32, 0x15)
#define REG_SC_BK32_16_L      _PK_L_(0x32, 0x16)
#define REG_SC_BK32_16_H      _PK_H_(0x32, 0x16)
#define REG_SC_BK32_17_L      _PK_L_(0x32, 0x17)
#define REG_SC_BK32_17_H      _PK_H_(0x32, 0x17)
#define REG_SC_BK32_18_L      _PK_L_(0x32, 0x18)
#define REG_SC_BK32_18_H      _PK_H_(0x32, 0x18)
#define REG_SC_BK32_19_L      _PK_L_(0x32, 0x19)
#define REG_SC_BK32_19_H      _PK_H_(0x32, 0x19)
#define REG_SC_BK32_1A_L      _PK_L_(0x32, 0x1A)
#define REG_SC_BK32_1A_H      _PK_H_(0x32, 0x1A)
#define REG_SC_BK32_1B_L      _PK_L_(0x32, 0x1B)
#define REG_SC_BK32_1B_H      _PK_H_(0x32, 0x1B)
#define REG_SC_BK32_1C_L      _PK_L_(0x32, 0x1C)
#define REG_SC_BK32_1C_H      _PK_H_(0x32, 0x1C)
#define REG_SC_BK32_1D_L      _PK_L_(0x32, 0x1D)
#define REG_SC_BK32_1D_H      _PK_H_(0x32, 0x1D)
#define REG_SC_BK32_1E_L      _PK_L_(0x32, 0x1E)
#define REG_SC_BK32_1E_H      _PK_H_(0x32, 0x1E)
#define REG_SC_BK32_1F_L      _PK_L_(0x32, 0x1F)
#define REG_SC_BK32_1F_H      _PK_H_(0x32, 0x1F)
#define REG_SC_BK32_20_L      _PK_L_(0x32, 0x20)
#define REG_SC_BK32_20_H      _PK_H_(0x32, 0x20)
#define REG_SC_BK32_21_L      _PK_L_(0x32, 0x21)
#define REG_SC_BK32_21_H      _PK_H_(0x32, 0x21)
#define REG_SC_BK32_22_L      _PK_L_(0x32, 0x22)
#define REG_SC_BK32_22_H      _PK_H_(0x32, 0x22)
#define REG_SC_BK32_23_L      _PK_L_(0x32, 0x23)
#define REG_SC_BK32_23_H      _PK_H_(0x32, 0x23)
#define REG_SC_BK32_24_L      _PK_L_(0x32, 0x24)
#define REG_SC_BK32_24_H      _PK_H_(0x32, 0x24)
#define REG_SC_BK32_25_L      _PK_L_(0x32, 0x25)
#define REG_SC_BK32_25_H      _PK_H_(0x32, 0x25)
#define REG_SC_BK32_26_L      _PK_L_(0x32, 0x26)
#define REG_SC_BK32_26_H      _PK_H_(0x32, 0x26)
#define REG_SC_BK32_27_L      _PK_L_(0x32, 0x27)
#define REG_SC_BK32_27_H      _PK_H_(0x32, 0x27)
#define REG_SC_BK32_28_L      _PK_L_(0x32, 0x28)
#define REG_SC_BK32_28_H      _PK_H_(0x32, 0x28)
#define REG_SC_BK32_29_L      _PK_L_(0x32, 0x29)
#define REG_SC_BK32_29_H      _PK_H_(0x32, 0x29)
#define REG_SC_BK32_2A_L      _PK_L_(0x32, 0x2A)
#define REG_SC_BK32_2A_H      _PK_H_(0x32, 0x2A)
#define REG_SC_BK32_2B_L      _PK_L_(0x32, 0x2B)
#define REG_SC_BK32_2B_H      _PK_H_(0x32, 0x2B)
#define REG_SC_BK32_2C_L      _PK_L_(0x32, 0x2C)
#define REG_SC_BK32_2C_H      _PK_H_(0x32, 0x2C)
#define REG_SC_BK32_2D_L      _PK_L_(0x32, 0x2D)
#define REG_SC_BK32_2D_H      _PK_H_(0x32, 0x2D)
#define REG_SC_BK32_2E_L      _PK_L_(0x32, 0x2E)
#define REG_SC_BK32_2E_H      _PK_H_(0x32, 0x2E)
#define REG_SC_BK32_2F_L      _PK_L_(0x32, 0x2F)
#define REG_SC_BK32_2F_H      _PK_H_(0x32, 0x2F)
#define REG_SC_BK32_30_L      _PK_L_(0x32, 0x30)
#define REG_SC_BK32_30_H      _PK_H_(0x32, 0x30)
#define REG_SC_BK32_31_L      _PK_L_(0x32, 0x31)
#define REG_SC_BK32_31_H      _PK_H_(0x32, 0x31)
#define REG_SC_BK32_32_L      _PK_L_(0x32, 0x32)
#define REG_SC_BK32_32_H      _PK_H_(0x32, 0x32)
#define REG_SC_BK32_33_L      _PK_L_(0x32, 0x33)
#define REG_SC_BK32_33_H      _PK_H_(0x32, 0x33)
#define REG_SC_BK32_34_L      _PK_L_(0x32, 0x34)
#define REG_SC_BK32_34_H      _PK_H_(0x32, 0x34)
#define REG_SC_BK32_35_L      _PK_L_(0x32, 0x35)
#define REG_SC_BK32_35_H      _PK_H_(0x32, 0x35)
#define REG_SC_BK32_36_L      _PK_L_(0x32, 0x36)
#define REG_SC_BK32_36_H      _PK_H_(0x32, 0x36)
#define REG_SC_BK32_37_L      _PK_L_(0x32, 0x37)
#define REG_SC_BK32_37_H      _PK_H_(0x32, 0x37)
#define REG_SC_BK32_38_L      _PK_L_(0x32, 0x38)
#define REG_SC_BK32_38_H      _PK_H_(0x32, 0x38)
#define REG_SC_BK32_39_L      _PK_L_(0x32, 0x39)
#define REG_SC_BK32_39_H      _PK_H_(0x32, 0x39)
#define REG_SC_BK32_3A_L      _PK_L_(0x32, 0x3A)
#define REG_SC_BK32_3A_H      _PK_H_(0x32, 0x3A)
#define REG_SC_BK32_3B_L      _PK_L_(0x32, 0x3B)
#define REG_SC_BK32_3B_H      _PK_H_(0x32, 0x3B)
#define REG_SC_BK32_3C_L      _PK_L_(0x32, 0x3C)
#define REG_SC_BK32_3C_H      _PK_H_(0x32, 0x3C)
#define REG_SC_BK32_3D_L      _PK_L_(0x32, 0x3D)
#define REG_SC_BK32_3D_H      _PK_H_(0x32, 0x3D)
#define REG_SC_BK32_3E_L      _PK_L_(0x32, 0x3E)
#define REG_SC_BK32_3E_H      _PK_H_(0x32, 0x3E)
#define REG_SC_BK32_3F_L      _PK_L_(0x32, 0x3F)
#define REG_SC_BK32_3F_H      _PK_H_(0x32, 0x3F)
#define REG_SC_BK32_40_L      _PK_L_(0x32, 0x40)
#define REG_SC_BK32_40_H      _PK_H_(0x32, 0x40)
#define REG_SC_BK32_41_L      _PK_L_(0x32, 0x41)
#define REG_SC_BK32_41_H      _PK_H_(0x32, 0x41)
#define REG_SC_BK32_42_L      _PK_L_(0x32, 0x42)
#define REG_SC_BK32_42_H      _PK_H_(0x32, 0x42)
#define REG_SC_BK32_43_L      _PK_L_(0x32, 0x43)
#define REG_SC_BK32_43_H      _PK_H_(0x32, 0x43)
#define REG_SC_BK32_44_L      _PK_L_(0x32, 0x44)
#define REG_SC_BK32_44_H      _PK_H_(0x32, 0x44)
#define REG_SC_BK32_45_L      _PK_L_(0x32, 0x45)
#define REG_SC_BK32_45_H      _PK_H_(0x32, 0x45)
#define REG_SC_BK32_46_L      _PK_L_(0x32, 0x46)
#define REG_SC_BK32_46_H      _PK_H_(0x32, 0x46)
#define REG_SC_BK32_47_L      _PK_L_(0x32, 0x47)
#define REG_SC_BK32_47_H      _PK_H_(0x32, 0x47)
#define REG_SC_BK32_48_L      _PK_L_(0x32, 0x48)
#define REG_SC_BK32_48_H      _PK_H_(0x32, 0x48)
#define REG_SC_BK32_49_L      _PK_L_(0x32, 0x49)
#define REG_SC_BK32_49_H      _PK_H_(0x32, 0x49)
#define REG_SC_BK32_4A_L      _PK_L_(0x32, 0x4A)
#define REG_SC_BK32_4A_H      _PK_H_(0x32, 0x4A)
#define REG_SC_BK32_4B_L      _PK_L_(0x32, 0x4B)
#define REG_SC_BK32_4B_H      _PK_H_(0x32, 0x4B)
#define REG_SC_BK32_4C_L      _PK_L_(0x32, 0x4C)
#define REG_SC_BK32_4C_H      _PK_H_(0x32, 0x4C)
#define REG_SC_BK32_4D_L      _PK_L_(0x32, 0x4D)
#define REG_SC_BK32_4D_H      _PK_H_(0x32, 0x4D)
#define REG_SC_BK32_4E_L      _PK_L_(0x32, 0x4E)
#define REG_SC_BK32_4E_H      _PK_H_(0x32, 0x4E)
#define REG_SC_BK32_4F_L      _PK_L_(0x32, 0x4F)
#define REG_SC_BK32_4F_H      _PK_H_(0x32, 0x4F)
#define REG_SC_BK32_50_L      _PK_L_(0x32, 0x50)
#define REG_SC_BK32_50_H      _PK_H_(0x32, 0x50)
#define REG_SC_BK32_51_L      _PK_L_(0x32, 0x51)
#define REG_SC_BK32_51_H      _PK_H_(0x32, 0x51)
#define REG_SC_BK32_52_L      _PK_L_(0x32, 0x52)
#define REG_SC_BK32_52_H      _PK_H_(0x32, 0x52)
#define REG_SC_BK32_53_L      _PK_L_(0x32, 0x53)
#define REG_SC_BK32_53_H      _PK_H_(0x32, 0x53)
#define REG_SC_BK32_54_L      _PK_L_(0x32, 0x54)
#define REG_SC_BK32_54_H      _PK_H_(0x32, 0x54)
#define REG_SC_BK32_55_L      _PK_L_(0x32, 0x55)
#define REG_SC_BK32_55_H      _PK_H_(0x32, 0x55)
#define REG_SC_BK32_56_L      _PK_L_(0x32, 0x56)
#define REG_SC_BK32_56_H      _PK_H_(0x32, 0x56)
#define REG_SC_BK32_57_L      _PK_L_(0x32, 0x57)
#define REG_SC_BK32_57_H      _PK_H_(0x32, 0x57)
#define REG_SC_BK32_58_L      _PK_L_(0x32, 0x58)
#define REG_SC_BK32_58_H      _PK_H_(0x32, 0x58)
#define REG_SC_BK32_59_L      _PK_L_(0x32, 0x59)
#define REG_SC_BK32_59_H      _PK_H_(0x32, 0x59)
#define REG_SC_BK32_5A_L      _PK_L_(0x32, 0x5A)
#define REG_SC_BK32_5A_H      _PK_H_(0x32, 0x5A)
#define REG_SC_BK32_5B_L      _PK_L_(0x32, 0x5B)
#define REG_SC_BK32_5B_H      _PK_H_(0x32, 0x5B)
#define REG_SC_BK32_5C_L      _PK_L_(0x32, 0x5C)
#define REG_SC_BK32_5C_H      _PK_H_(0x32, 0x5C)
#define REG_SC_BK32_5D_L      _PK_L_(0x32, 0x5D)
#define REG_SC_BK32_5D_H      _PK_H_(0x32, 0x5D)
#define REG_SC_BK32_5E_L      _PK_L_(0x32, 0x5E)
#define REG_SC_BK32_5E_H      _PK_H_(0x32, 0x5E)
#define REG_SC_BK32_5F_L      _PK_L_(0x32, 0x5F)
#define REG_SC_BK32_5F_H      _PK_H_(0x32, 0x5F)
#define REG_SC_BK32_60_L      _PK_L_(0x32, 0x60)
#define REG_SC_BK32_60_H      _PK_H_(0x32, 0x60)
#define REG_SC_BK32_61_L      _PK_L_(0x32, 0x61)
#define REG_SC_BK32_61_H      _PK_H_(0x32, 0x61)
#define REG_SC_BK32_62_L      _PK_L_(0x32, 0x62)
#define REG_SC_BK32_62_H      _PK_H_(0x32, 0x62)
#define REG_SC_BK32_63_L      _PK_L_(0x32, 0x63)
#define REG_SC_BK32_63_H      _PK_H_(0x32, 0x63)
#define REG_SC_BK32_64_L      _PK_L_(0x32, 0x64)
#define REG_SC_BK32_64_H      _PK_H_(0x32, 0x64)
#define REG_SC_BK32_65_L      _PK_L_(0x32, 0x65)
#define REG_SC_BK32_65_H      _PK_H_(0x32, 0x65)
#define REG_SC_BK32_66_L      _PK_L_(0x32, 0x66)
#define REG_SC_BK32_66_H      _PK_H_(0x32, 0x66)
#define REG_SC_BK32_67_L      _PK_L_(0x32, 0x67)
#define REG_SC_BK32_67_H      _PK_H_(0x32, 0x67)
#define REG_SC_BK32_68_L      _PK_L_(0x32, 0x68)
#define REG_SC_BK32_68_H      _PK_H_(0x32, 0x68)
#define REG_SC_BK32_69_L      _PK_L_(0x32, 0x69)
#define REG_SC_BK32_69_H      _PK_H_(0x32, 0x69)
#define REG_SC_BK32_6A_L      _PK_L_(0x32, 0x6A)
#define REG_SC_BK32_6A_H      _PK_H_(0x32, 0x6A)
#define REG_SC_BK32_6B_L      _PK_L_(0x32, 0x6B)
#define REG_SC_BK32_6B_H      _PK_H_(0x32, 0x6B)
#define REG_SC_BK32_6C_L      _PK_L_(0x32, 0x6C)
#define REG_SC_BK32_6C_H      _PK_H_(0x32, 0x6C)
#define REG_SC_BK32_6D_L      _PK_L_(0x32, 0x6D)
#define REG_SC_BK32_6D_H      _PK_H_(0x32, 0x6D)
#define REG_SC_BK32_6E_L      _PK_L_(0x32, 0x6E)
#define REG_SC_BK32_6E_H      _PK_H_(0x32, 0x6E)
#define REG_SC_BK32_6F_L      _PK_L_(0x32, 0x6F)
#define REG_SC_BK32_6F_H      _PK_H_(0x32, 0x6F)
#define REG_SC_BK32_70_L      _PK_L_(0x32, 0x70)
#define REG_SC_BK32_70_H      _PK_H_(0x32, 0x70)
#define REG_SC_BK32_71_L      _PK_L_(0x32, 0x71)
#define REG_SC_BK32_71_H      _PK_H_(0x32, 0x71)
#define REG_SC_BK32_72_L      _PK_L_(0x32, 0x72)
#define REG_SC_BK32_72_H      _PK_H_(0x32, 0x72)
#define REG_SC_BK32_73_L      _PK_L_(0x32, 0x73)
#define REG_SC_BK32_73_H      _PK_H_(0x32, 0x73)
#define REG_SC_BK32_74_L      _PK_L_(0x32, 0x74)
#define REG_SC_BK32_74_H      _PK_H_(0x32, 0x74)
#define REG_SC_BK32_75_L      _PK_L_(0x32, 0x75)
#define REG_SC_BK32_75_H      _PK_H_(0x32, 0x75)
#define REG_SC_BK32_76_L      _PK_L_(0x32, 0x76)
#define REG_SC_BK32_76_H      _PK_H_(0x32, 0x76)
#define REG_SC_BK32_77_L      _PK_L_(0x32, 0x77)
#define REG_SC_BK32_77_H      _PK_H_(0x32, 0x77)
#define REG_SC_BK32_78_L      _PK_L_(0x32, 0x78)
#define REG_SC_BK32_78_H      _PK_H_(0x32, 0x78)
#define REG_SC_BK32_79_L      _PK_L_(0x32, 0x79)
#define REG_SC_BK32_79_H      _PK_H_(0x32, 0x79)
#define REG_SC_BK32_7A_L      _PK_L_(0x32, 0x7A)
#define REG_SC_BK32_7A_H      _PK_H_(0x32, 0x7A)
#define REG_SC_BK32_7B_L      _PK_L_(0x32, 0x7B)
#define REG_SC_BK32_7B_H      _PK_H_(0x32, 0x7B)
#define REG_SC_BK32_7C_L      _PK_L_(0x32, 0x7C)
#define REG_SC_BK32_7C_H      _PK_H_(0x32, 0x7C)
#define REG_SC_BK32_7D_L      _PK_L_(0x32, 0x7D)
#define REG_SC_BK32_7D_H      _PK_H_(0x32, 0x7D)
#define REG_SC_BK32_7E_L      _PK_L_(0x32, 0x7E)
#define REG_SC_BK32_7E_H      _PK_H_(0x32, 0x7E)
#define REG_SC_BK32_7F_L      _PK_L_(0x32, 0x7F)
#define REG_SC_BK32_7F_H      _PK_H_(0x32, 0x7F)
//----------------------------------------------
#define REG_SC_BK33_00_L      _PK_L_(0x33, 0x00)
#define REG_SC_BK33_00_H      _PK_H_(0x33, 0x00)
#define REG_SC_BK33_01_L      _PK_L_(0x33, 0x01)
#define REG_SC_BK33_01_H      _PK_H_(0x33, 0x01)
#define REG_SC_BK33_02_L      _PK_L_(0x33, 0x02)
#define REG_SC_BK33_02_H      _PK_H_(0x33, 0x02)
#define REG_SC_BK33_03_L      _PK_L_(0x33, 0x03)
#define REG_SC_BK33_03_H      _PK_H_(0x33, 0x03)
#define REG_SC_BK33_04_L      _PK_L_(0x33, 0x04)
#define REG_SC_BK33_04_H      _PK_H_(0x33, 0x04)
#define REG_SC_BK33_05_L      _PK_L_(0x33, 0x05)
#define REG_SC_BK33_05_H      _PK_H_(0x33, 0x05)
#define REG_SC_BK33_06_L      _PK_L_(0x33, 0x06)
#define REG_SC_BK33_06_H      _PK_H_(0x33, 0x06)
#define REG_SC_BK33_07_L      _PK_L_(0x33, 0x07)
#define REG_SC_BK33_07_H      _PK_H_(0x33, 0x07)
#define REG_SC_BK33_08_L      _PK_L_(0x33, 0x08)
#define REG_SC_BK33_08_H      _PK_H_(0x33, 0x08)
#define REG_SC_BK33_09_L      _PK_L_(0x33, 0x09)
#define REG_SC_BK33_09_H      _PK_H_(0x33, 0x09)
#define REG_SC_BK33_0A_L      _PK_L_(0x33, 0x0A)
#define REG_SC_BK33_0A_H      _PK_H_(0x33, 0x0A)
#define REG_SC_BK33_0B_L      _PK_L_(0x33, 0x0B)
#define REG_SC_BK33_0B_H      _PK_H_(0x33, 0x0B)
#define REG_SC_BK33_0C_L      _PK_L_(0x33, 0x0C)
#define REG_SC_BK33_0C_H      _PK_H_(0x33, 0x0C)
#define REG_SC_BK33_0D_L      _PK_L_(0x33, 0x0D)
#define REG_SC_BK33_0D_H      _PK_H_(0x33, 0x0D)
#define REG_SC_BK33_0E_L      _PK_L_(0x33, 0x0E)
#define REG_SC_BK33_0E_H      _PK_H_(0x33, 0x0E)
#define REG_SC_BK33_0F_L      _PK_L_(0x33, 0x0F)
#define REG_SC_BK33_0F_H      _PK_H_(0x33, 0x0F)
#define REG_SC_BK33_10_L      _PK_L_(0x33, 0x10)
#define REG_SC_BK33_10_H      _PK_H_(0x33, 0x10)
#define REG_SC_BK33_11_L      _PK_L_(0x33, 0x11)
#define REG_SC_BK33_11_H      _PK_H_(0x33, 0x11)
#define REG_SC_BK33_12_L      _PK_L_(0x33, 0x12)
#define REG_SC_BK33_12_H      _PK_H_(0x33, 0x12)
#define REG_SC_BK33_13_L      _PK_L_(0x33, 0x13)
#define REG_SC_BK33_13_H      _PK_H_(0x33, 0x13)
#define REG_SC_BK33_14_L      _PK_L_(0x33, 0x14)
#define REG_SC_BK33_14_H      _PK_H_(0x33, 0x14)
#define REG_SC_BK33_15_L      _PK_L_(0x33, 0x15)
#define REG_SC_BK33_15_H      _PK_H_(0x33, 0x15)
#define REG_SC_BK33_16_L      _PK_L_(0x33, 0x16)
#define REG_SC_BK33_16_H      _PK_H_(0x33, 0x16)
#define REG_SC_BK33_17_L      _PK_L_(0x33, 0x17)
#define REG_SC_BK33_17_H      _PK_H_(0x33, 0x17)
#define REG_SC_BK33_18_L      _PK_L_(0x33, 0x18)
#define REG_SC_BK33_18_H      _PK_H_(0x33, 0x18)
#define REG_SC_BK33_19_L      _PK_L_(0x33, 0x19)
#define REG_SC_BK33_19_H      _PK_H_(0x33, 0x19)
#define REG_SC_BK33_1A_L      _PK_L_(0x33, 0x1A)
#define REG_SC_BK33_1A_H      _PK_H_(0x33, 0x1A)
#define REG_SC_BK33_1B_L      _PK_L_(0x33, 0x1B)
#define REG_SC_BK33_1B_H      _PK_H_(0x33, 0x1B)
#define REG_SC_BK33_1C_L      _PK_L_(0x33, 0x1C)
#define REG_SC_BK33_1C_H      _PK_H_(0x33, 0x1C)
#define REG_SC_BK33_1D_L      _PK_L_(0x33, 0x1D)
#define REG_SC_BK33_1D_H      _PK_H_(0x33, 0x1D)
#define REG_SC_BK33_1E_L      _PK_L_(0x33, 0x1E)
#define REG_SC_BK33_1E_H      _PK_H_(0x33, 0x1E)
#define REG_SC_BK33_1F_L      _PK_L_(0x33, 0x1F)
#define REG_SC_BK33_1F_H      _PK_H_(0x33, 0x1F)
#define REG_SC_BK33_20_L      _PK_L_(0x33, 0x20)
#define REG_SC_BK33_20_H      _PK_H_(0x33, 0x20)
#define REG_SC_BK33_21_L      _PK_L_(0x33, 0x21)
#define REG_SC_BK33_21_H      _PK_H_(0x33, 0x21)
#define REG_SC_BK33_22_L      _PK_L_(0x33, 0x22)
#define REG_SC_BK33_22_H      _PK_H_(0x33, 0x22)
#define REG_SC_BK33_23_L      _PK_L_(0x33, 0x23)
#define REG_SC_BK33_23_H      _PK_H_(0x33, 0x23)
#define REG_SC_BK33_24_L      _PK_L_(0x33, 0x24)
#define REG_SC_BK33_24_H      _PK_H_(0x33, 0x24)
#define REG_SC_BK33_25_L      _PK_L_(0x33, 0x25)
#define REG_SC_BK33_25_H      _PK_H_(0x33, 0x25)
#define REG_SC_BK33_26_L      _PK_L_(0x33, 0x26)
#define REG_SC_BK33_26_H      _PK_H_(0x33, 0x26)
#define REG_SC_BK33_27_L      _PK_L_(0x33, 0x27)
#define REG_SC_BK33_27_H      _PK_H_(0x33, 0x27)
#define REG_SC_BK33_28_L      _PK_L_(0x33, 0x28)
#define REG_SC_BK33_28_H      _PK_H_(0x33, 0x28)
#define REG_SC_BK33_29_L      _PK_L_(0x33, 0x29)
#define REG_SC_BK33_29_H      _PK_H_(0x33, 0x29)
#define REG_SC_BK33_2A_L      _PK_L_(0x33, 0x2A)
#define REG_SC_BK33_2A_H      _PK_H_(0x33, 0x2A)
#define REG_SC_BK33_2B_L      _PK_L_(0x33, 0x2B)
#define REG_SC_BK33_2B_H      _PK_H_(0x33, 0x2B)
#define REG_SC_BK33_2C_L      _PK_L_(0x33, 0x2C)
#define REG_SC_BK33_2C_H      _PK_H_(0x33, 0x2C)
#define REG_SC_BK33_2D_L      _PK_L_(0x33, 0x2D)
#define REG_SC_BK33_2D_H      _PK_H_(0x33, 0x2D)
#define REG_SC_BK33_2E_L      _PK_L_(0x33, 0x2E)
#define REG_SC_BK33_2E_H      _PK_H_(0x33, 0x2E)
#define REG_SC_BK33_2F_L      _PK_L_(0x33, 0x2F)
#define REG_SC_BK33_2F_H      _PK_H_(0x33, 0x2F)
#define REG_SC_BK33_30_L      _PK_L_(0x33, 0x30)
#define REG_SC_BK33_30_H      _PK_H_(0x33, 0x30)
#define REG_SC_BK33_31_L      _PK_L_(0x33, 0x31)
#define REG_SC_BK33_31_H      _PK_H_(0x33, 0x31)
#define REG_SC_BK33_32_L      _PK_L_(0x33, 0x32)
#define REG_SC_BK33_32_H      _PK_H_(0x33, 0x32)
#define REG_SC_BK33_33_L      _PK_L_(0x33, 0x33)
#define REG_SC_BK33_33_H      _PK_H_(0x33, 0x33)
#define REG_SC_BK33_34_L      _PK_L_(0x33, 0x34)
#define REG_SC_BK33_34_H      _PK_H_(0x33, 0x34)
#define REG_SC_BK33_35_L      _PK_L_(0x33, 0x35)
#define REG_SC_BK33_35_H      _PK_H_(0x33, 0x35)
#define REG_SC_BK33_36_L      _PK_L_(0x33, 0x36)
#define REG_SC_BK33_36_H      _PK_H_(0x33, 0x36)
#define REG_SC_BK33_37_L      _PK_L_(0x33, 0x37)
#define REG_SC_BK33_37_H      _PK_H_(0x33, 0x37)
#define REG_SC_BK33_38_L      _PK_L_(0x33, 0x38)
#define REG_SC_BK33_38_H      _PK_H_(0x33, 0x38)
#define REG_SC_BK33_39_L      _PK_L_(0x33, 0x39)
#define REG_SC_BK33_39_H      _PK_H_(0x33, 0x39)
#define REG_SC_BK33_3A_L      _PK_L_(0x33, 0x3A)
#define REG_SC_BK33_3A_H      _PK_H_(0x33, 0x3A)
#define REG_SC_BK33_3B_L      _PK_L_(0x33, 0x3B)
#define REG_SC_BK33_3B_H      _PK_H_(0x33, 0x3B)
#define REG_SC_BK33_3C_L      _PK_L_(0x33, 0x3C)
#define REG_SC_BK33_3C_H      _PK_H_(0x33, 0x3C)
#define REG_SC_BK33_3D_L      _PK_L_(0x33, 0x3D)
#define REG_SC_BK33_3D_H      _PK_H_(0x33, 0x3D)
#define REG_SC_BK33_3E_L      _PK_L_(0x33, 0x3E)
#define REG_SC_BK33_3E_H      _PK_H_(0x33, 0x3E)
#define REG_SC_BK33_3F_L      _PK_L_(0x33, 0x3F)
#define REG_SC_BK33_3F_H      _PK_H_(0x33, 0x3F)
#define REG_SC_BK33_40_L      _PK_L_(0x33, 0x40)
#define REG_SC_BK33_40_H      _PK_H_(0x33, 0x40)
#define REG_SC_BK33_41_L      _PK_L_(0x33, 0x41)
#define REG_SC_BK33_41_H      _PK_H_(0x33, 0x41)
#define REG_SC_BK33_42_L      _PK_L_(0x33, 0x42)
#define REG_SC_BK33_42_H      _PK_H_(0x33, 0x42)
#define REG_SC_BK33_43_L      _PK_L_(0x33, 0x43)
#define REG_SC_BK33_43_H      _PK_H_(0x33, 0x43)
#define REG_SC_BK33_44_L      _PK_L_(0x33, 0x44)
#define REG_SC_BK33_44_H      _PK_H_(0x33, 0x44)
#define REG_SC_BK33_45_L      _PK_L_(0x33, 0x45)
#define REG_SC_BK33_45_H      _PK_H_(0x33, 0x45)
#define REG_SC_BK33_46_L      _PK_L_(0x33, 0x46)
#define REG_SC_BK33_46_H      _PK_H_(0x33, 0x46)
#define REG_SC_BK33_47_L      _PK_L_(0x33, 0x47)
#define REG_SC_BK33_47_H      _PK_H_(0x33, 0x47)
#define REG_SC_BK33_48_L      _PK_L_(0x33, 0x48)
#define REG_SC_BK33_48_H      _PK_H_(0x33, 0x48)
#define REG_SC_BK33_49_L      _PK_L_(0x33, 0x49)
#define REG_SC_BK33_49_H      _PK_H_(0x33, 0x49)
#define REG_SC_BK33_4A_L      _PK_L_(0x33, 0x4A)
#define REG_SC_BK33_4A_H      _PK_H_(0x33, 0x4A)
#define REG_SC_BK33_4B_L      _PK_L_(0x33, 0x4B)
#define REG_SC_BK33_4B_H      _PK_H_(0x33, 0x4B)
#define REG_SC_BK33_4C_L      _PK_L_(0x33, 0x4C)
#define REG_SC_BK33_4C_H      _PK_H_(0x33, 0x4C)
#define REG_SC_BK33_4D_L      _PK_L_(0x33, 0x4D)
#define REG_SC_BK33_4D_H      _PK_H_(0x33, 0x4D)
#define REG_SC_BK33_4E_L      _PK_L_(0x33, 0x4E)
#define REG_SC_BK33_4E_H      _PK_H_(0x33, 0x4E)
#define REG_SC_BK33_4F_L      _PK_L_(0x33, 0x4F)
#define REG_SC_BK33_4F_H      _PK_H_(0x33, 0x4F)
#define REG_SC_BK33_50_L      _PK_L_(0x33, 0x50)
#define REG_SC_BK33_50_H      _PK_H_(0x33, 0x50)
#define REG_SC_BK33_51_L      _PK_L_(0x33, 0x51)
#define REG_SC_BK33_51_H      _PK_H_(0x33, 0x51)
#define REG_SC_BK33_52_L      _PK_L_(0x33, 0x52)
#define REG_SC_BK33_52_H      _PK_H_(0x33, 0x52)
#define REG_SC_BK33_53_L      _PK_L_(0x33, 0x53)
#define REG_SC_BK33_53_H      _PK_H_(0x33, 0x53)
#define REG_SC_BK33_54_L      _PK_L_(0x33, 0x54)
#define REG_SC_BK33_54_H      _PK_H_(0x33, 0x54)
#define REG_SC_BK33_55_L      _PK_L_(0x33, 0x55)
#define REG_SC_BK33_55_H      _PK_H_(0x33, 0x55)
#define REG_SC_BK33_56_L      _PK_L_(0x33, 0x56)
#define REG_SC_BK33_56_H      _PK_H_(0x33, 0x56)
#define REG_SC_BK33_57_L      _PK_L_(0x33, 0x57)
#define REG_SC_BK33_57_H      _PK_H_(0x33, 0x57)
#define REG_SC_BK33_58_L      _PK_L_(0x33, 0x58)
#define REG_SC_BK33_58_H      _PK_H_(0x33, 0x58)
#define REG_SC_BK33_59_L      _PK_L_(0x33, 0x59)
#define REG_SC_BK33_59_H      _PK_H_(0x33, 0x59)
#define REG_SC_BK33_5A_L      _PK_L_(0x33, 0x5A)
#define REG_SC_BK33_5A_H      _PK_H_(0x33, 0x5A)
#define REG_SC_BK33_5B_L      _PK_L_(0x33, 0x5B)
#define REG_SC_BK33_5B_H      _PK_H_(0x33, 0x5B)
#define REG_SC_BK33_5C_L      _PK_L_(0x33, 0x5C)
#define REG_SC_BK33_5C_H      _PK_H_(0x33, 0x5C)
#define REG_SC_BK33_5D_L      _PK_L_(0x33, 0x5D)
#define REG_SC_BK33_5D_H      _PK_H_(0x33, 0x5D)
#define REG_SC_BK33_5E_L      _PK_L_(0x33, 0x5E)
#define REG_SC_BK33_5E_H      _PK_H_(0x33, 0x5E)
#define REG_SC_BK33_5F_L      _PK_L_(0x33, 0x5F)
#define REG_SC_BK33_5F_H      _PK_H_(0x33, 0x5F)
#define REG_SC_BK33_60_L      _PK_L_(0x33, 0x60)
#define REG_SC_BK33_60_H      _PK_H_(0x33, 0x60)
#define REG_SC_BK33_61_L      _PK_L_(0x33, 0x61)
#define REG_SC_BK33_61_H      _PK_H_(0x33, 0x61)
#define REG_SC_BK33_62_L      _PK_L_(0x33, 0x62)
#define REG_SC_BK33_62_H      _PK_H_(0x33, 0x62)
#define REG_SC_BK33_63_L      _PK_L_(0x33, 0x63)
#define REG_SC_BK33_63_H      _PK_H_(0x33, 0x63)
#define REG_SC_BK33_64_L      _PK_L_(0x33, 0x64)
#define REG_SC_BK33_64_H      _PK_H_(0x33, 0x64)
#define REG_SC_BK33_65_L      _PK_L_(0x33, 0x65)
#define REG_SC_BK33_65_H      _PK_H_(0x33, 0x65)
#define REG_SC_BK33_66_L      _PK_L_(0x33, 0x66)
#define REG_SC_BK33_66_H      _PK_H_(0x33, 0x66)
#define REG_SC_BK33_67_L      _PK_L_(0x33, 0x67)
#define REG_SC_BK33_67_H      _PK_H_(0x33, 0x67)
#define REG_SC_BK33_68_L      _PK_L_(0x33, 0x68)
#define REG_SC_BK33_68_H      _PK_H_(0x33, 0x68)
#define REG_SC_BK33_69_L      _PK_L_(0x33, 0x69)
#define REG_SC_BK33_69_H      _PK_H_(0x33, 0x69)
#define REG_SC_BK33_6A_L      _PK_L_(0x33, 0x6A)
#define REG_SC_BK33_6A_H      _PK_H_(0x33, 0x6A)
#define REG_SC_BK33_6B_L      _PK_L_(0x33, 0x6B)
#define REG_SC_BK33_6B_H      _PK_H_(0x33, 0x6B)
#define REG_SC_BK33_6C_L      _PK_L_(0x33, 0x6C)
#define REG_SC_BK33_6C_H      _PK_H_(0x33, 0x6C)
#define REG_SC_BK33_6D_L      _PK_L_(0x33, 0x6D)
#define REG_SC_BK33_6D_H      _PK_H_(0x33, 0x6D)
#define REG_SC_BK33_6E_L      _PK_L_(0x33, 0x6E)
#define REG_SC_BK33_6E_H      _PK_H_(0x33, 0x6E)
#define REG_SC_BK33_6F_L      _PK_L_(0x33, 0x6F)
#define REG_SC_BK33_6F_H      _PK_H_(0x33, 0x6F)
#define REG_SC_BK33_70_L      _PK_L_(0x33, 0x70)
#define REG_SC_BK33_70_H      _PK_H_(0x33, 0x70)
#define REG_SC_BK33_71_L      _PK_L_(0x33, 0x71)
#define REG_SC_BK33_71_H      _PK_H_(0x33, 0x71)
#define REG_SC_BK33_72_L      _PK_L_(0x33, 0x72)
#define REG_SC_BK33_72_H      _PK_H_(0x33, 0x72)
#define REG_SC_BK33_73_L      _PK_L_(0x33, 0x73)
#define REG_SC_BK33_73_H      _PK_H_(0x33, 0x73)
#define REG_SC_BK33_74_L      _PK_L_(0x33, 0x74)
#define REG_SC_BK33_74_H      _PK_H_(0x33, 0x74)
#define REG_SC_BK33_75_L      _PK_L_(0x33, 0x75)
#define REG_SC_BK33_75_H      _PK_H_(0x33, 0x75)
#define REG_SC_BK33_76_L      _PK_L_(0x33, 0x76)
#define REG_SC_BK33_76_H      _PK_H_(0x33, 0x76)
#define REG_SC_BK33_77_L      _PK_L_(0x33, 0x77)
#define REG_SC_BK33_77_H      _PK_H_(0x33, 0x77)
#define REG_SC_BK33_78_L      _PK_L_(0x33, 0x78)
#define REG_SC_BK33_78_H      _PK_H_(0x33, 0x78)
#define REG_SC_BK33_79_L      _PK_L_(0x33, 0x79)
#define REG_SC_BK33_79_H      _PK_H_(0x33, 0x79)
#define REG_SC_BK33_7A_L      _PK_L_(0x33, 0x7A)
#define REG_SC_BK33_7A_H      _PK_H_(0x33, 0x7A)
#define REG_SC_BK33_7B_L      _PK_L_(0x33, 0x7B)
#define REG_SC_BK33_7B_H      _PK_H_(0x33, 0x7B)
#define REG_SC_BK33_7C_L      _PK_L_(0x33, 0x7C)
#define REG_SC_BK33_7C_H      _PK_H_(0x33, 0x7C)
#define REG_SC_BK33_7D_L      _PK_L_(0x33, 0x7D)
#define REG_SC_BK33_7D_H      _PK_H_(0x33, 0x7D)
#define REG_SC_BK33_7E_L      _PK_L_(0x33, 0x7E)
#define REG_SC_BK33_7E_H      _PK_H_(0x33, 0x7E)
#define REG_SC_BK33_7F_L      _PK_L_(0x33, 0x7F)
#define REG_SC_BK33_7F_H      _PK_H_(0x33, 0x7F)
//----------------------------------------------
#define REG_SC_BK38_00_L      _PK_L_(0x38, 0x00)
#define REG_SC_BK38_00_H      _PK_H_(0x38, 0x00)
#define REG_SC_BK38_01_L      _PK_L_(0x38, 0x01)
#define REG_SC_BK38_01_H      _PK_H_(0x38, 0x01)
#define REG_SC_BK38_02_L      _PK_L_(0x38, 0x02)
#define REG_SC_BK38_02_H      _PK_H_(0x38, 0x02)
#define REG_SC_BK38_03_L      _PK_L_(0x38, 0x03)
#define REG_SC_BK38_03_H      _PK_H_(0x38, 0x03)
#define REG_SC_BK38_04_L      _PK_L_(0x38, 0x04)
#define REG_SC_BK38_04_H      _PK_H_(0x38, 0x04)
#define REG_SC_BK38_05_L      _PK_L_(0x38, 0x05)
#define REG_SC_BK38_05_H      _PK_H_(0x38, 0x05)
#define REG_SC_BK38_06_L      _PK_L_(0x38, 0x06)
#define REG_SC_BK38_06_H      _PK_H_(0x38, 0x06)
#define REG_SC_BK38_07_L      _PK_L_(0x38, 0x07)
#define REG_SC_BK38_07_H      _PK_H_(0x38, 0x07)
#define REG_SC_BK38_08_L      _PK_L_(0x38, 0x08)
#define REG_SC_BK38_08_H      _PK_H_(0x38, 0x08)
#define REG_SC_BK38_09_L      _PK_L_(0x38, 0x09)
#define REG_SC_BK38_09_H      _PK_H_(0x38, 0x09)
#define REG_SC_BK38_0A_L      _PK_L_(0x38, 0x0A)
#define REG_SC_BK38_0A_H      _PK_H_(0x38, 0x0A)
#define REG_SC_BK38_0B_L      _PK_L_(0x38, 0x0B)
#define REG_SC_BK38_0B_H      _PK_H_(0x38, 0x0B)
#define REG_SC_BK38_0C_L      _PK_L_(0x38, 0x0C)
#define REG_SC_BK38_0C_H      _PK_H_(0x38, 0x0C)
#define REG_SC_BK38_0D_L      _PK_L_(0x38, 0x0D)
#define REG_SC_BK38_0D_H      _PK_H_(0x38, 0x0D)
#define REG_SC_BK38_0E_L      _PK_L_(0x38, 0x0E)
#define REG_SC_BK38_0E_H      _PK_H_(0x38, 0x0E)
#define REG_SC_BK38_0F_L      _PK_L_(0x38, 0x0F)
#define REG_SC_BK38_0F_H      _PK_H_(0x38, 0x0F)
#define REG_SC_BK38_10_L      _PK_L_(0x38, 0x10)
#define REG_SC_BK38_10_H      _PK_H_(0x38, 0x10)
#define REG_SC_BK38_11_L      _PK_L_(0x38, 0x11)
#define REG_SC_BK38_11_H      _PK_H_(0x38, 0x11)
#define REG_SC_BK38_12_L      _PK_L_(0x38, 0x12)
#define REG_SC_BK38_12_H      _PK_H_(0x38, 0x12)
#define REG_SC_BK38_13_L      _PK_L_(0x38, 0x13)
#define REG_SC_BK38_13_H      _PK_H_(0x38, 0x13)
#define REG_SC_BK38_14_L      _PK_L_(0x38, 0x14)
#define REG_SC_BK38_14_H      _PK_H_(0x38, 0x14)
#define REG_SC_BK38_15_L      _PK_L_(0x38, 0x15)
#define REG_SC_BK38_15_H      _PK_H_(0x38, 0x15)
#define REG_SC_BK38_16_L      _PK_L_(0x38, 0x16)
#define REG_SC_BK38_16_H      _PK_H_(0x38, 0x16)
#define REG_SC_BK38_17_L      _PK_L_(0x38, 0x17)
#define REG_SC_BK38_17_H      _PK_H_(0x38, 0x17)
#define REG_SC_BK38_18_L      _PK_L_(0x38, 0x18)
#define REG_SC_BK38_18_H      _PK_H_(0x38, 0x18)
#define REG_SC_BK38_19_L      _PK_L_(0x38, 0x19)
#define REG_SC_BK38_19_H      _PK_H_(0x38, 0x19)
#define REG_SC_BK38_1A_L      _PK_L_(0x38, 0x1A)
#define REG_SC_BK38_1A_H      _PK_H_(0x38, 0x1A)
#define REG_SC_BK38_1B_L      _PK_L_(0x38, 0x1B)
#define REG_SC_BK38_1B_H      _PK_H_(0x38, 0x1B)
#define REG_SC_BK38_1C_L      _PK_L_(0x38, 0x1C)
#define REG_SC_BK38_1C_H      _PK_H_(0x38, 0x1C)
#define REG_SC_BK38_1D_L      _PK_L_(0x38, 0x1D)
#define REG_SC_BK38_1D_H      _PK_H_(0x38, 0x1D)
#define REG_SC_BK38_1E_L      _PK_L_(0x38, 0x1E)
#define REG_SC_BK38_1E_H      _PK_H_(0x38, 0x1E)
#define REG_SC_BK38_1F_L      _PK_L_(0x38, 0x1F)
#define REG_SC_BK38_1F_H      _PK_H_(0x38, 0x1F)
#define REG_SC_BK38_20_L      _PK_L_(0x38, 0x20)
#define REG_SC_BK38_20_H      _PK_H_(0x38, 0x20)
#define REG_SC_BK38_21_L      _PK_L_(0x38, 0x21)
#define REG_SC_BK38_21_H      _PK_H_(0x38, 0x21)
#define REG_SC_BK38_22_L      _PK_L_(0x38, 0x22)
#define REG_SC_BK38_22_H      _PK_H_(0x38, 0x22)
#define REG_SC_BK38_23_L      _PK_L_(0x38, 0x23)
#define REG_SC_BK38_23_H      _PK_H_(0x38, 0x23)
#define REG_SC_BK38_24_L      _PK_L_(0x38, 0x24)
#define REG_SC_BK38_24_H      _PK_H_(0x38, 0x24)
#define REG_SC_BK38_25_L      _PK_L_(0x38, 0x25)
#define REG_SC_BK38_25_H      _PK_H_(0x38, 0x25)
#define REG_SC_BK38_26_L      _PK_L_(0x38, 0x26)
#define REG_SC_BK38_26_H      _PK_H_(0x38, 0x26)
#define REG_SC_BK38_27_L      _PK_L_(0x38, 0x27)
#define REG_SC_BK38_27_H      _PK_H_(0x38, 0x27)
#define REG_SC_BK38_28_L      _PK_L_(0x38, 0x28)
#define REG_SC_BK38_28_H      _PK_H_(0x38, 0x28)
#define REG_SC_BK38_29_L      _PK_L_(0x38, 0x29)
#define REG_SC_BK38_29_H      _PK_H_(0x38, 0x29)
#define REG_SC_BK38_2A_L      _PK_L_(0x38, 0x2A)
#define REG_SC_BK38_2A_H      _PK_H_(0x38, 0x2A)
#define REG_SC_BK38_2B_L      _PK_L_(0x38, 0x2B)
#define REG_SC_BK38_2B_H      _PK_H_(0x38, 0x2B)
#define REG_SC_BK38_2C_L      _PK_L_(0x38, 0x2C)
#define REG_SC_BK38_2C_H      _PK_H_(0x38, 0x2C)
#define REG_SC_BK38_2D_L      _PK_L_(0x38, 0x2D)
#define REG_SC_BK38_2D_H      _PK_H_(0x38, 0x2D)
#define REG_SC_BK38_2E_L      _PK_L_(0x38, 0x2E)
#define REG_SC_BK38_2E_H      _PK_H_(0x38, 0x2E)
#define REG_SC_BK38_2F_L      _PK_L_(0x38, 0x2F)
#define REG_SC_BK38_2F_H      _PK_H_(0x38, 0x2F)
#define REG_SC_BK38_30_L      _PK_L_(0x38, 0x30)
#define REG_SC_BK38_30_H      _PK_H_(0x38, 0x30)
#define REG_SC_BK38_31_L      _PK_L_(0x38, 0x31)
#define REG_SC_BK38_31_H      _PK_H_(0x38, 0x31)
#define REG_SC_BK38_32_L      _PK_L_(0x38, 0x32)
#define REG_SC_BK38_32_H      _PK_H_(0x38, 0x32)
#define REG_SC_BK38_33_L      _PK_L_(0x38, 0x33)
#define REG_SC_BK38_33_H      _PK_H_(0x38, 0x33)
#define REG_SC_BK38_34_L      _PK_L_(0x38, 0x34)
#define REG_SC_BK38_34_H      _PK_H_(0x38, 0x34)
#define REG_SC_BK38_35_L      _PK_L_(0x38, 0x35)
#define REG_SC_BK38_35_H      _PK_H_(0x38, 0x35)
#define REG_SC_BK38_36_L      _PK_L_(0x38, 0x36)
#define REG_SC_BK38_36_H      _PK_H_(0x38, 0x36)
#define REG_SC_BK38_37_L      _PK_L_(0x38, 0x37)
#define REG_SC_BK38_37_H      _PK_H_(0x38, 0x37)
#define REG_SC_BK38_38_L      _PK_L_(0x38, 0x38)
#define REG_SC_BK38_38_H      _PK_H_(0x38, 0x38)
#define REG_SC_BK38_39_L      _PK_L_(0x38, 0x39)
#define REG_SC_BK38_39_H      _PK_H_(0x38, 0x39)
#define REG_SC_BK38_3A_L      _PK_L_(0x38, 0x3A)
#define REG_SC_BK38_3A_H      _PK_H_(0x38, 0x3A)
#define REG_SC_BK38_3B_L      _PK_L_(0x38, 0x3B)
#define REG_SC_BK38_3B_H      _PK_H_(0x38, 0x3B)
#define REG_SC_BK38_3C_L      _PK_L_(0x38, 0x3C)
#define REG_SC_BK38_3C_H      _PK_H_(0x38, 0x3C)
#define REG_SC_BK38_3D_L      _PK_L_(0x38, 0x3D)
#define REG_SC_BK38_3D_H      _PK_H_(0x38, 0x3D)
#define REG_SC_BK38_3E_L      _PK_L_(0x38, 0x3E)
#define REG_SC_BK38_3E_H      _PK_H_(0x38, 0x3E)
#define REG_SC_BK38_3F_L      _PK_L_(0x38, 0x3F)
#define REG_SC_BK38_3F_H      _PK_H_(0x38, 0x3F)
#define REG_SC_BK38_40_L      _PK_L_(0x38, 0x40)
#define REG_SC_BK38_40_H      _PK_H_(0x38, 0x40)
#define REG_SC_BK38_41_L      _PK_L_(0x38, 0x41)
#define REG_SC_BK38_41_H      _PK_H_(0x38, 0x41)
#define REG_SC_BK38_42_L      _PK_L_(0x38, 0x42)
#define REG_SC_BK38_42_H      _PK_H_(0x38, 0x42)
#define REG_SC_BK38_43_L      _PK_L_(0x38, 0x43)
#define REG_SC_BK38_43_H      _PK_H_(0x38, 0x43)
#define REG_SC_BK38_44_L      _PK_L_(0x38, 0x44)
#define REG_SC_BK38_44_H      _PK_H_(0x38, 0x44)
#define REG_SC_BK38_45_L      _PK_L_(0x38, 0x45)
#define REG_SC_BK38_45_H      _PK_H_(0x38, 0x45)
#define REG_SC_BK38_46_L      _PK_L_(0x38, 0x46)
#define REG_SC_BK38_46_H      _PK_H_(0x38, 0x46)
#define REG_SC_BK38_47_L      _PK_L_(0x38, 0x47)
#define REG_SC_BK38_47_H      _PK_H_(0x38, 0x47)
#define REG_SC_BK38_48_L      _PK_L_(0x38, 0x48)
#define REG_SC_BK38_48_H      _PK_H_(0x38, 0x48)
#define REG_SC_BK38_49_L      _PK_L_(0x38, 0x49)
#define REG_SC_BK38_49_H      _PK_H_(0x38, 0x49)
#define REG_SC_BK38_4A_L      _PK_L_(0x38, 0x4A)
#define REG_SC_BK38_4A_H      _PK_H_(0x38, 0x4A)
#define REG_SC_BK38_4B_L      _PK_L_(0x38, 0x4B)
#define REG_SC_BK38_4B_H      _PK_H_(0x38, 0x4B)
#define REG_SC_BK38_4C_L      _PK_L_(0x38, 0x4C)
#define REG_SC_BK38_4C_H      _PK_H_(0x38, 0x4C)
#define REG_SC_BK38_4D_L      _PK_L_(0x38, 0x4D)
#define REG_SC_BK38_4D_H      _PK_H_(0x38, 0x4D)
#define REG_SC_BK38_4E_L      _PK_L_(0x38, 0x4E)
#define REG_SC_BK38_4E_H      _PK_H_(0x38, 0x4E)
#define REG_SC_BK38_4F_L      _PK_L_(0x38, 0x4F)
#define REG_SC_BK38_4F_H      _PK_H_(0x38, 0x4F)
#define REG_SC_BK38_50_L      _PK_L_(0x38, 0x50)
#define REG_SC_BK38_50_H      _PK_H_(0x38, 0x50)
#define REG_SC_BK38_51_L      _PK_L_(0x38, 0x51)
#define REG_SC_BK38_51_H      _PK_H_(0x38, 0x51)
#define REG_SC_BK38_52_L      _PK_L_(0x38, 0x52)
#define REG_SC_BK38_52_H      _PK_H_(0x38, 0x52)
#define REG_SC_BK38_53_L      _PK_L_(0x38, 0x53)
#define REG_SC_BK38_53_H      _PK_H_(0x38, 0x53)
#define REG_SC_BK38_54_L      _PK_L_(0x38, 0x54)
#define REG_SC_BK38_54_H      _PK_H_(0x38, 0x54)
#define REG_SC_BK38_55_L      _PK_L_(0x38, 0x55)
#define REG_SC_BK38_55_H      _PK_H_(0x38, 0x55)
#define REG_SC_BK38_56_L      _PK_L_(0x38, 0x56)
#define REG_SC_BK38_56_H      _PK_H_(0x38, 0x56)
#define REG_SC_BK38_57_L      _PK_L_(0x38, 0x57)
#define REG_SC_BK38_57_H      _PK_H_(0x38, 0x57)
#define REG_SC_BK38_58_L      _PK_L_(0x38, 0x58)
#define REG_SC_BK38_58_H      _PK_H_(0x38, 0x58)
#define REG_SC_BK38_59_L      _PK_L_(0x38, 0x59)
#define REG_SC_BK38_59_H      _PK_H_(0x38, 0x59)
#define REG_SC_BK38_5A_L      _PK_L_(0x38, 0x5A)
#define REG_SC_BK38_5A_H      _PK_H_(0x38, 0x5A)
#define REG_SC_BK38_5B_L      _PK_L_(0x38, 0x5B)
#define REG_SC_BK38_5B_H      _PK_H_(0x38, 0x5B)
#define REG_SC_BK38_5C_L      _PK_L_(0x38, 0x5C)
#define REG_SC_BK38_5C_H      _PK_H_(0x38, 0x5C)
#define REG_SC_BK38_5D_L      _PK_L_(0x38, 0x5D)
#define REG_SC_BK38_5D_H      _PK_H_(0x38, 0x5D)
#define REG_SC_BK38_5E_L      _PK_L_(0x38, 0x5E)
#define REG_SC_BK38_5E_H      _PK_H_(0x38, 0x5E)
#define REG_SC_BK38_5F_L      _PK_L_(0x38, 0x5F)
#define REG_SC_BK38_5F_H      _PK_H_(0x38, 0x5F)
#define REG_SC_BK38_60_L      _PK_L_(0x38, 0x60)
#define REG_SC_BK38_60_H      _PK_H_(0x38, 0x60)
#define REG_SC_BK38_61_L      _PK_L_(0x38, 0x61)
#define REG_SC_BK38_61_H      _PK_H_(0x38, 0x61)
#define REG_SC_BK38_62_L      _PK_L_(0x38, 0x62)
#define REG_SC_BK38_62_H      _PK_H_(0x38, 0x62)
#define REG_SC_BK38_63_L      _PK_L_(0x38, 0x63)
#define REG_SC_BK38_63_H      _PK_H_(0x38, 0x63)
#define REG_SC_BK38_64_L      _PK_L_(0x38, 0x64)
#define REG_SC_BK38_64_H      _PK_H_(0x38, 0x64)
#define REG_SC_BK38_65_L      _PK_L_(0x38, 0x65)
#define REG_SC_BK38_65_H      _PK_H_(0x38, 0x65)
#define REG_SC_BK38_66_L      _PK_L_(0x38, 0x66)
#define REG_SC_BK38_66_H      _PK_H_(0x38, 0x66)
#define REG_SC_BK38_67_L      _PK_L_(0x38, 0x67)
#define REG_SC_BK38_67_H      _PK_H_(0x38, 0x67)
#define REG_SC_BK38_68_L      _PK_L_(0x38, 0x68)
#define REG_SC_BK38_68_H      _PK_H_(0x38, 0x68)
#define REG_SC_BK38_69_L      _PK_L_(0x38, 0x69)
#define REG_SC_BK38_69_H      _PK_H_(0x38, 0x69)
#define REG_SC_BK38_6A_L      _PK_L_(0x38, 0x6A)
#define REG_SC_BK38_6A_H      _PK_H_(0x38, 0x6A)
#define REG_SC_BK38_6B_L      _PK_L_(0x38, 0x6B)
#define REG_SC_BK38_6B_H      _PK_H_(0x38, 0x6B)
#define REG_SC_BK38_6C_L      _PK_L_(0x38, 0x6C)
#define REG_SC_BK38_6C_H      _PK_H_(0x38, 0x6C)
#define REG_SC_BK38_6D_L      _PK_L_(0x38, 0x6D)
#define REG_SC_BK38_6D_H      _PK_H_(0x38, 0x6D)
#define REG_SC_BK38_6E_L      _PK_L_(0x38, 0x6E)
#define REG_SC_BK38_6E_H      _PK_H_(0x38, 0x6E)
#define REG_SC_BK38_6F_L      _PK_L_(0x38, 0x6F)
#define REG_SC_BK38_6F_H      _PK_H_(0x38, 0x6F)
#define REG_SC_BK38_70_L      _PK_L_(0x38, 0x70)
#define REG_SC_BK38_70_H      _PK_H_(0x38, 0x70)
#define REG_SC_BK38_71_L      _PK_L_(0x38, 0x71)
#define REG_SC_BK38_71_H      _PK_H_(0x38, 0x71)
#define REG_SC_BK38_72_L      _PK_L_(0x38, 0x72)
#define REG_SC_BK38_72_H      _PK_H_(0x38, 0x72)
#define REG_SC_BK38_73_L      _PK_L_(0x38, 0x73)
#define REG_SC_BK38_73_H      _PK_H_(0x38, 0x73)
#define REG_SC_BK38_74_L      _PK_L_(0x38, 0x74)
#define REG_SC_BK38_74_H      _PK_H_(0x38, 0x74)
#define REG_SC_BK38_75_L      _PK_L_(0x38, 0x75)
#define REG_SC_BK38_75_H      _PK_H_(0x38, 0x75)
#define REG_SC_BK38_76_L      _PK_L_(0x38, 0x76)
#define REG_SC_BK38_76_H      _PK_H_(0x38, 0x76)
#define REG_SC_BK38_77_L      _PK_L_(0x38, 0x77)
#define REG_SC_BK38_77_H      _PK_H_(0x38, 0x77)
#define REG_SC_BK38_78_L      _PK_L_(0x38, 0x78)
#define REG_SC_BK38_78_H      _PK_H_(0x38, 0x78)
#define REG_SC_BK38_79_L      _PK_L_(0x38, 0x79)
#define REG_SC_BK38_79_H      _PK_H_(0x38, 0x79)
#define REG_SC_BK38_7A_L      _PK_L_(0x38, 0x7A)
#define REG_SC_BK38_7A_H      _PK_H_(0x38, 0x7A)
#define REG_SC_BK38_7B_L      _PK_L_(0x38, 0x7B)
#define REG_SC_BK38_7B_H      _PK_H_(0x38, 0x7B)
#define REG_SC_BK38_7C_L      _PK_L_(0x38, 0x7C)
#define REG_SC_BK38_7C_H      _PK_H_(0x38, 0x7C)
#define REG_SC_BK38_7D_L      _PK_L_(0x38, 0x7D)
#define REG_SC_BK38_7D_H      _PK_H_(0x38, 0x7D)
#define REG_SC_BK38_7E_L      _PK_L_(0x38, 0x7E)
#define REG_SC_BK38_7E_H      _PK_H_(0x38, 0x7E)
#define REG_SC_BK38_7F_L      _PK_L_(0x38, 0x7F)
#define REG_SC_BK38_7F_H      _PK_H_(0x38, 0x7F)
//----------------------------------------------
#define REG_SC_BK39_00_L      _PK_L_(0x39, 0x00)
#define REG_SC_BK39_00_H      _PK_H_(0x39, 0x00)
#define REG_SC_BK39_01_L      _PK_L_(0x39, 0x01)
#define REG_SC_BK39_01_H      _PK_H_(0x39, 0x01)
#define REG_SC_BK39_02_L      _PK_L_(0x39, 0x02)
#define REG_SC_BK39_02_H      _PK_H_(0x39, 0x02)
#define REG_SC_BK39_03_L      _PK_L_(0x39, 0x03)
#define REG_SC_BK39_03_H      _PK_H_(0x39, 0x03)
#define REG_SC_BK39_04_L      _PK_L_(0x39, 0x04)
#define REG_SC_BK39_04_H      _PK_H_(0x39, 0x04)
#define REG_SC_BK39_05_L      _PK_L_(0x39, 0x05)
#define REG_SC_BK39_05_H      _PK_H_(0x39, 0x05)
#define REG_SC_BK39_06_L      _PK_L_(0x39, 0x06)
#define REG_SC_BK39_06_H      _PK_H_(0x39, 0x06)
#define REG_SC_BK39_07_L      _PK_L_(0x39, 0x07)
#define REG_SC_BK39_07_H      _PK_H_(0x39, 0x07)
#define REG_SC_BK39_08_L      _PK_L_(0x39, 0x08)
#define REG_SC_BK39_08_H      _PK_H_(0x39, 0x08)
#define REG_SC_BK39_09_L      _PK_L_(0x39, 0x09)
#define REG_SC_BK39_09_H      _PK_H_(0x39, 0x09)
#define REG_SC_BK39_0A_L      _PK_L_(0x39, 0x0A)
#define REG_SC_BK39_0A_H      _PK_H_(0x39, 0x0A)
#define REG_SC_BK39_0B_L      _PK_L_(0x39, 0x0B)
#define REG_SC_BK39_0B_H      _PK_H_(0x39, 0x0B)
#define REG_SC_BK39_0C_L      _PK_L_(0x39, 0x0C)
#define REG_SC_BK39_0C_H      _PK_H_(0x39, 0x0C)
#define REG_SC_BK39_0D_L      _PK_L_(0x39, 0x0D)
#define REG_SC_BK39_0D_H      _PK_H_(0x39, 0x0D)
#define REG_SC_BK39_0E_L      _PK_L_(0x39, 0x0E)
#define REG_SC_BK39_0E_H      _PK_H_(0x39, 0x0E)
#define REG_SC_BK39_0F_L      _PK_L_(0x39, 0x0F)
#define REG_SC_BK39_0F_H      _PK_H_(0x39, 0x0F)
#define REG_SC_BK39_10_L      _PK_L_(0x39, 0x10)
#define REG_SC_BK39_10_H      _PK_H_(0x39, 0x10)
#define REG_SC_BK39_11_L      _PK_L_(0x39, 0x11)
#define REG_SC_BK39_11_H      _PK_H_(0x39, 0x11)
#define REG_SC_BK39_12_L      _PK_L_(0x39, 0x12)
#define REG_SC_BK39_12_H      _PK_H_(0x39, 0x12)
#define REG_SC_BK39_13_L      _PK_L_(0x39, 0x13)
#define REG_SC_BK39_13_H      _PK_H_(0x39, 0x13)
#define REG_SC_BK39_14_L      _PK_L_(0x39, 0x14)
#define REG_SC_BK39_14_H      _PK_H_(0x39, 0x14)
#define REG_SC_BK39_15_L      _PK_L_(0x39, 0x15)
#define REG_SC_BK39_15_H      _PK_H_(0x39, 0x15)
#define REG_SC_BK39_16_L      _PK_L_(0x39, 0x16)
#define REG_SC_BK39_16_H      _PK_H_(0x39, 0x16)
#define REG_SC_BK39_17_L      _PK_L_(0x39, 0x17)
#define REG_SC_BK39_17_H      _PK_H_(0x39, 0x17)
#define REG_SC_BK39_18_L      _PK_L_(0x39, 0x18)
#define REG_SC_BK39_18_H      _PK_H_(0x39, 0x18)
#define REG_SC_BK39_19_L      _PK_L_(0x39, 0x19)
#define REG_SC_BK39_19_H      _PK_H_(0x39, 0x19)
#define REG_SC_BK39_1A_L      _PK_L_(0x39, 0x1A)
#define REG_SC_BK39_1A_H      _PK_H_(0x39, 0x1A)
#define REG_SC_BK39_1B_L      _PK_L_(0x39, 0x1B)
#define REG_SC_BK39_1B_H      _PK_H_(0x39, 0x1B)
#define REG_SC_BK39_1C_L      _PK_L_(0x39, 0x1C)
#define REG_SC_BK39_1C_H      _PK_H_(0x39, 0x1C)
#define REG_SC_BK39_1D_L      _PK_L_(0x39, 0x1D)
#define REG_SC_BK39_1D_H      _PK_H_(0x39, 0x1D)
#define REG_SC_BK39_1E_L      _PK_L_(0x39, 0x1E)
#define REG_SC_BK39_1E_H      _PK_H_(0x39, 0x1E)
#define REG_SC_BK39_1F_L      _PK_L_(0x39, 0x1F)
#define REG_SC_BK39_1F_H      _PK_H_(0x39, 0x1F)
#define REG_SC_BK39_20_L      _PK_L_(0x39, 0x20)
#define REG_SC_BK39_20_H      _PK_H_(0x39, 0x20)
#define REG_SC_BK39_21_L      _PK_L_(0x39, 0x21)
#define REG_SC_BK39_21_H      _PK_H_(0x39, 0x21)
#define REG_SC_BK39_22_L      _PK_L_(0x39, 0x22)
#define REG_SC_BK39_22_H      _PK_H_(0x39, 0x22)
#define REG_SC_BK39_23_L      _PK_L_(0x39, 0x23)
#define REG_SC_BK39_23_H      _PK_H_(0x39, 0x23)
#define REG_SC_BK39_24_L      _PK_L_(0x39, 0x24)
#define REG_SC_BK39_24_H      _PK_H_(0x39, 0x24)
#define REG_SC_BK39_25_L      _PK_L_(0x39, 0x25)
#define REG_SC_BK39_25_H      _PK_H_(0x39, 0x25)
#define REG_SC_BK39_26_L      _PK_L_(0x39, 0x26)
#define REG_SC_BK39_26_H      _PK_H_(0x39, 0x26)
#define REG_SC_BK39_27_L      _PK_L_(0x39, 0x27)
#define REG_SC_BK39_27_H      _PK_H_(0x39, 0x27)
#define REG_SC_BK39_28_L      _PK_L_(0x39, 0x28)
#define REG_SC_BK39_28_H      _PK_H_(0x39, 0x28)
#define REG_SC_BK39_29_L      _PK_L_(0x39, 0x29)
#define REG_SC_BK39_29_H      _PK_H_(0x39, 0x29)
#define REG_SC_BK39_2A_L      _PK_L_(0x39, 0x2A)
#define REG_SC_BK39_2A_H      _PK_H_(0x39, 0x2A)
#define REG_SC_BK39_2B_L      _PK_L_(0x39, 0x2B)
#define REG_SC_BK39_2B_H      _PK_H_(0x39, 0x2B)
#define REG_SC_BK39_2C_L      _PK_L_(0x39, 0x2C)
#define REG_SC_BK39_2C_H      _PK_H_(0x39, 0x2C)
#define REG_SC_BK39_2D_L      _PK_L_(0x39, 0x2D)
#define REG_SC_BK39_2D_H      _PK_H_(0x39, 0x2D)
#define REG_SC_BK39_2E_L      _PK_L_(0x39, 0x2E)
#define REG_SC_BK39_2E_H      _PK_H_(0x39, 0x2E)
#define REG_SC_BK39_2F_L      _PK_L_(0x39, 0x2F)
#define REG_SC_BK39_2F_H      _PK_H_(0x39, 0x2F)
#define REG_SC_BK39_30_L      _PK_L_(0x39, 0x30)
#define REG_SC_BK39_30_H      _PK_H_(0x39, 0x30)
#define REG_SC_BK39_31_L      _PK_L_(0x39, 0x31)
#define REG_SC_BK39_31_H      _PK_H_(0x39, 0x31)
#define REG_SC_BK39_32_L      _PK_L_(0x39, 0x32)
#define REG_SC_BK39_32_H      _PK_H_(0x39, 0x32)
#define REG_SC_BK39_33_L      _PK_L_(0x39, 0x33)
#define REG_SC_BK39_33_H      _PK_H_(0x39, 0x33)
#define REG_SC_BK39_34_L      _PK_L_(0x39, 0x34)
#define REG_SC_BK39_34_H      _PK_H_(0x39, 0x34)
#define REG_SC_BK39_35_L      _PK_L_(0x39, 0x35)
#define REG_SC_BK39_35_H      _PK_H_(0x39, 0x35)
#define REG_SC_BK39_36_L      _PK_L_(0x39, 0x36)
#define REG_SC_BK39_36_H      _PK_H_(0x39, 0x36)
#define REG_SC_BK39_37_L      _PK_L_(0x39, 0x37)
#define REG_SC_BK39_37_H      _PK_H_(0x39, 0x37)
#define REG_SC_BK39_38_L      _PK_L_(0x39, 0x38)
#define REG_SC_BK39_38_H      _PK_H_(0x39, 0x38)
#define REG_SC_BK39_39_L      _PK_L_(0x39, 0x39)
#define REG_SC_BK39_39_H      _PK_H_(0x39, 0x39)
#define REG_SC_BK39_3A_L      _PK_L_(0x39, 0x3A)
#define REG_SC_BK39_3A_H      _PK_H_(0x39, 0x3A)
#define REG_SC_BK39_3B_L      _PK_L_(0x39, 0x3B)
#define REG_SC_BK39_3B_H      _PK_H_(0x39, 0x3B)
#define REG_SC_BK39_3C_L      _PK_L_(0x39, 0x3C)
#define REG_SC_BK39_3C_H      _PK_H_(0x39, 0x3C)
#define REG_SC_BK39_3D_L      _PK_L_(0x39, 0x3D)
#define REG_SC_BK39_3D_H      _PK_H_(0x39, 0x3D)
#define REG_SC_BK39_3E_L      _PK_L_(0x39, 0x3E)
#define REG_SC_BK39_3E_H      _PK_H_(0x39, 0x3E)
#define REG_SC_BK39_3F_L      _PK_L_(0x39, 0x3F)
#define REG_SC_BK39_3F_H      _PK_H_(0x39, 0x3F)
#define REG_SC_BK39_40_L      _PK_L_(0x39, 0x40)
#define REG_SC_BK39_40_H      _PK_H_(0x39, 0x40)
#define REG_SC_BK39_41_L      _PK_L_(0x39, 0x41)
#define REG_SC_BK39_41_H      _PK_H_(0x39, 0x41)
#define REG_SC_BK39_42_L      _PK_L_(0x39, 0x42)
#define REG_SC_BK39_42_H      _PK_H_(0x39, 0x42)
#define REG_SC_BK39_43_L      _PK_L_(0x39, 0x43)
#define REG_SC_BK39_43_H      _PK_H_(0x39, 0x43)
#define REG_SC_BK39_44_L      _PK_L_(0x39, 0x44)
#define REG_SC_BK39_44_H      _PK_H_(0x39, 0x44)
#define REG_SC_BK39_45_L      _PK_L_(0x39, 0x45)
#define REG_SC_BK39_45_H      _PK_H_(0x39, 0x45)
#define REG_SC_BK39_46_L      _PK_L_(0x39, 0x46)
#define REG_SC_BK39_46_H      _PK_H_(0x39, 0x46)
#define REG_SC_BK39_47_L      _PK_L_(0x39, 0x47)
#define REG_SC_BK39_47_H      _PK_H_(0x39, 0x47)
#define REG_SC_BK39_48_L      _PK_L_(0x39, 0x48)
#define REG_SC_BK39_48_H      _PK_H_(0x39, 0x48)
#define REG_SC_BK39_49_L      _PK_L_(0x39, 0x49)
#define REG_SC_BK39_49_H      _PK_H_(0x39, 0x49)
#define REG_SC_BK39_4A_L      _PK_L_(0x39, 0x4A)
#define REG_SC_BK39_4A_H      _PK_H_(0x39, 0x4A)
#define REG_SC_BK39_4B_L      _PK_L_(0x39, 0x4B)
#define REG_SC_BK39_4B_H      _PK_H_(0x39, 0x4B)
#define REG_SC_BK39_4C_L      _PK_L_(0x39, 0x4C)
#define REG_SC_BK39_4C_H      _PK_H_(0x39, 0x4C)
#define REG_SC_BK39_4D_L      _PK_L_(0x39, 0x4D)
#define REG_SC_BK39_4D_H      _PK_H_(0x39, 0x4D)
#define REG_SC_BK39_4E_L      _PK_L_(0x39, 0x4E)
#define REG_SC_BK39_4E_H      _PK_H_(0x39, 0x4E)
#define REG_SC_BK39_4F_L      _PK_L_(0x39, 0x4F)
#define REG_SC_BK39_4F_H      _PK_H_(0x39, 0x4F)
#define REG_SC_BK39_50_L      _PK_L_(0x39, 0x50)
#define REG_SC_BK39_50_H      _PK_H_(0x39, 0x50)
#define REG_SC_BK39_51_L      _PK_L_(0x39, 0x51)
#define REG_SC_BK39_51_H      _PK_H_(0x39, 0x51)
#define REG_SC_BK39_52_L      _PK_L_(0x39, 0x52)
#define REG_SC_BK39_52_H      _PK_H_(0x39, 0x52)
#define REG_SC_BK39_53_L      _PK_L_(0x39, 0x53)
#define REG_SC_BK39_53_H      _PK_H_(0x39, 0x53)
#define REG_SC_BK39_54_L      _PK_L_(0x39, 0x54)
#define REG_SC_BK39_54_H      _PK_H_(0x39, 0x54)
#define REG_SC_BK39_55_L      _PK_L_(0x39, 0x55)
#define REG_SC_BK39_55_H      _PK_H_(0x39, 0x55)
#define REG_SC_BK39_56_L      _PK_L_(0x39, 0x56)
#define REG_SC_BK39_56_H      _PK_H_(0x39, 0x56)
#define REG_SC_BK39_57_L      _PK_L_(0x39, 0x57)
#define REG_SC_BK39_57_H      _PK_H_(0x39, 0x57)
#define REG_SC_BK39_58_L      _PK_L_(0x39, 0x58)
#define REG_SC_BK39_58_H      _PK_H_(0x39, 0x58)
#define REG_SC_BK39_59_L      _PK_L_(0x39, 0x59)
#define REG_SC_BK39_59_H      _PK_H_(0x39, 0x59)
#define REG_SC_BK39_5A_L      _PK_L_(0x39, 0x5A)
#define REG_SC_BK39_5A_H      _PK_H_(0x39, 0x5A)
#define REG_SC_BK39_5B_L      _PK_L_(0x39, 0x5B)
#define REG_SC_BK39_5B_H      _PK_H_(0x39, 0x5B)
#define REG_SC_BK39_5C_L      _PK_L_(0x39, 0x5C)
#define REG_SC_BK39_5C_H      _PK_H_(0x39, 0x5C)
#define REG_SC_BK39_5D_L      _PK_L_(0x39, 0x5D)
#define REG_SC_BK39_5D_H      _PK_H_(0x39, 0x5D)
#define REG_SC_BK39_5E_L      _PK_L_(0x39, 0x5E)
#define REG_SC_BK39_5E_H      _PK_H_(0x39, 0x5E)
#define REG_SC_BK39_5F_L      _PK_L_(0x39, 0x5F)
#define REG_SC_BK39_5F_H      _PK_H_(0x39, 0x5F)
#define REG_SC_BK39_60_L      _PK_L_(0x39, 0x60)
#define REG_SC_BK39_60_H      _PK_H_(0x39, 0x60)
#define REG_SC_BK39_61_L      _PK_L_(0x39, 0x61)
#define REG_SC_BK39_61_H      _PK_H_(0x39, 0x61)
#define REG_SC_BK39_62_L      _PK_L_(0x39, 0x62)
#define REG_SC_BK39_62_H      _PK_H_(0x39, 0x62)
#define REG_SC_BK39_63_L      _PK_L_(0x39, 0x63)
#define REG_SC_BK39_63_H      _PK_H_(0x39, 0x63)
#define REG_SC_BK39_64_L      _PK_L_(0x39, 0x64)
#define REG_SC_BK39_64_H      _PK_H_(0x39, 0x64)
#define REG_SC_BK39_65_L      _PK_L_(0x39, 0x65)
#define REG_SC_BK39_65_H      _PK_H_(0x39, 0x65)
#define REG_SC_BK39_66_L      _PK_L_(0x39, 0x66)
#define REG_SC_BK39_66_H      _PK_H_(0x39, 0x66)
#define REG_SC_BK39_67_L      _PK_L_(0x39, 0x67)
#define REG_SC_BK39_67_H      _PK_H_(0x39, 0x67)
#define REG_SC_BK39_68_L      _PK_L_(0x39, 0x68)
#define REG_SC_BK39_68_H      _PK_H_(0x39, 0x68)
#define REG_SC_BK39_69_L      _PK_L_(0x39, 0x69)
#define REG_SC_BK39_69_H      _PK_H_(0x39, 0x69)
#define REG_SC_BK39_6A_L      _PK_L_(0x39, 0x6A)
#define REG_SC_BK39_6A_H      _PK_H_(0x39, 0x6A)
#define REG_SC_BK39_6B_L      _PK_L_(0x39, 0x6B)
#define REG_SC_BK39_6B_H      _PK_H_(0x39, 0x6B)
#define REG_SC_BK39_6C_L      _PK_L_(0x39, 0x6C)
#define REG_SC_BK39_6C_H      _PK_H_(0x39, 0x6C)
#define REG_SC_BK39_6D_L      _PK_L_(0x39, 0x6D)
#define REG_SC_BK39_6D_H      _PK_H_(0x39, 0x6D)
#define REG_SC_BK39_6E_L      _PK_L_(0x39, 0x6E)
#define REG_SC_BK39_6E_H      _PK_H_(0x39, 0x6E)
#define REG_SC_BK39_6F_L      _PK_L_(0x39, 0x6F)
#define REG_SC_BK39_6F_H      _PK_H_(0x39, 0x6F)
#define REG_SC_BK39_70_L      _PK_L_(0x39, 0x70)
#define REG_SC_BK39_70_H      _PK_H_(0x39, 0x70)
#define REG_SC_BK39_71_L      _PK_L_(0x39, 0x71)
#define REG_SC_BK39_71_H      _PK_H_(0x39, 0x71)
#define REG_SC_BK39_72_L      _PK_L_(0x39, 0x72)
#define REG_SC_BK39_72_H      _PK_H_(0x39, 0x72)
#define REG_SC_BK39_73_L      _PK_L_(0x39, 0x73)
#define REG_SC_BK39_73_H      _PK_H_(0x39, 0x73)
#define REG_SC_BK39_74_L      _PK_L_(0x39, 0x74)
#define REG_SC_BK39_74_H      _PK_H_(0x39, 0x74)
#define REG_SC_BK39_75_L      _PK_L_(0x39, 0x75)
#define REG_SC_BK39_75_H      _PK_H_(0x39, 0x75)
#define REG_SC_BK39_76_L      _PK_L_(0x39, 0x76)
#define REG_SC_BK39_76_H      _PK_H_(0x39, 0x76)
#define REG_SC_BK39_77_L      _PK_L_(0x39, 0x77)
#define REG_SC_BK39_77_H      _PK_H_(0x39, 0x77)
#define REG_SC_BK39_78_L      _PK_L_(0x39, 0x78)
#define REG_SC_BK39_78_H      _PK_H_(0x39, 0x78)
#define REG_SC_BK39_79_L      _PK_L_(0x39, 0x79)
#define REG_SC_BK39_79_H      _PK_H_(0x39, 0x79)
#define REG_SC_BK39_7A_L      _PK_L_(0x39, 0x7A)
#define REG_SC_BK39_7A_H      _PK_H_(0x39, 0x7A)
#define REG_SC_BK39_7B_L      _PK_L_(0x39, 0x7B)
#define REG_SC_BK39_7B_H      _PK_H_(0x39, 0x7B)
#define REG_SC_BK39_7C_L      _PK_L_(0x39, 0x7C)
#define REG_SC_BK39_7C_H      _PK_H_(0x39, 0x7C)
#define REG_SC_BK39_7D_L      _PK_L_(0x39, 0x7D)
#define REG_SC_BK39_7D_H      _PK_H_(0x39, 0x7D)
#define REG_SC_BK39_7E_L      _PK_L_(0x39, 0x7E)
#define REG_SC_BK39_7E_H      _PK_H_(0x39, 0x7E)
#define REG_SC_BK39_7F_L      _PK_L_(0x39, 0x7F)
#define REG_SC_BK39_7F_H      _PK_H_(0x39, 0x7F)
//----------------------------------------------
#define REG_SC_BK3A_00_L      _PK_L_(0x3A, 0x00)
#define REG_SC_BK3A_00_H      _PK_H_(0x3A, 0x00)
#define REG_SC_BK3A_01_L      _PK_L_(0x3A, 0x01)
#define REG_SC_BK3A_01_H      _PK_H_(0x3A, 0x01)
#define REG_SC_BK3A_02_L      _PK_L_(0x3A, 0x02)
#define REG_SC_BK3A_02_H      _PK_H_(0x3A, 0x02)
#define REG_SC_BK3A_03_L      _PK_L_(0x3A, 0x03)
#define REG_SC_BK3A_03_H      _PK_H_(0x3A, 0x03)
#define REG_SC_BK3A_04_L      _PK_L_(0x3A, 0x04)
#define REG_SC_BK3A_04_H      _PK_H_(0x3A, 0x04)
#define REG_SC_BK3A_05_L      _PK_L_(0x3A, 0x05)
#define REG_SC_BK3A_05_H      _PK_H_(0x3A, 0x05)
#define REG_SC_BK3A_06_L      _PK_L_(0x3A, 0x06)
#define REG_SC_BK3A_06_H      _PK_H_(0x3A, 0x06)
#define REG_SC_BK3A_07_L      _PK_L_(0x3A, 0x07)
#define REG_SC_BK3A_07_H      _PK_H_(0x3A, 0x07)
#define REG_SC_BK3A_08_L      _PK_L_(0x3A, 0x08)
#define REG_SC_BK3A_08_H      _PK_H_(0x3A, 0x08)
#define REG_SC_BK3A_09_L      _PK_L_(0x3A, 0x09)
#define REG_SC_BK3A_09_H      _PK_H_(0x3A, 0x09)
#define REG_SC_BK3A_0A_L      _PK_L_(0x3A, 0x0A)
#define REG_SC_BK3A_0A_H      _PK_H_(0x3A, 0x0A)
#define REG_SC_BK3A_0B_L      _PK_L_(0x3A, 0x0B)
#define REG_SC_BK3A_0B_H      _PK_H_(0x3A, 0x0B)
#define REG_SC_BK3A_0C_L      _PK_L_(0x3A, 0x0C)
#define REG_SC_BK3A_0C_H      _PK_H_(0x3A, 0x0C)
#define REG_SC_BK3A_0D_L      _PK_L_(0x3A, 0x0D)
#define REG_SC_BK3A_0D_H      _PK_H_(0x3A, 0x0D)
#define REG_SC_BK3A_0E_L      _PK_L_(0x3A, 0x0E)
#define REG_SC_BK3A_0E_H      _PK_H_(0x3A, 0x0E)
#define REG_SC_BK3A_0F_L      _PK_L_(0x3A, 0x0F)
#define REG_SC_BK3A_0F_H      _PK_H_(0x3A, 0x0F)
#define REG_SC_BK3A_10_L      _PK_L_(0x3A, 0x10)
#define REG_SC_BK3A_10_H      _PK_H_(0x3A, 0x10)
#define REG_SC_BK3A_11_L      _PK_L_(0x3A, 0x11)
#define REG_SC_BK3A_11_H      _PK_H_(0x3A, 0x11)
#define REG_SC_BK3A_12_L      _PK_L_(0x3A, 0x12)
#define REG_SC_BK3A_12_H      _PK_H_(0x3A, 0x12)
#define REG_SC_BK3A_13_L      _PK_L_(0x3A, 0x13)
#define REG_SC_BK3A_13_H      _PK_H_(0x3A, 0x13)
#define REG_SC_BK3A_14_L      _PK_L_(0x3A, 0x14)
#define REG_SC_BK3A_14_H      _PK_H_(0x3A, 0x14)
#define REG_SC_BK3A_15_L      _PK_L_(0x3A, 0x15)
#define REG_SC_BK3A_15_H      _PK_H_(0x3A, 0x15)
#define REG_SC_BK3A_16_L      _PK_L_(0x3A, 0x16)
#define REG_SC_BK3A_16_H      _PK_H_(0x3A, 0x16)
#define REG_SC_BK3A_17_L      _PK_L_(0x3A, 0x17)
#define REG_SC_BK3A_17_H      _PK_H_(0x3A, 0x17)
#define REG_SC_BK3A_18_L      _PK_L_(0x3A, 0x18)
#define REG_SC_BK3A_18_H      _PK_H_(0x3A, 0x18)
#define REG_SC_BK3A_19_L      _PK_L_(0x3A, 0x19)
#define REG_SC_BK3A_19_H      _PK_H_(0x3A, 0x19)
#define REG_SC_BK3A_1A_L      _PK_L_(0x3A, 0x1A)
#define REG_SC_BK3A_1A_H      _PK_H_(0x3A, 0x1A)
#define REG_SC_BK3A_1B_L      _PK_L_(0x3A, 0x1B)
#define REG_SC_BK3A_1B_H      _PK_H_(0x3A, 0x1B)
#define REG_SC_BK3A_1C_L      _PK_L_(0x3A, 0x1C)
#define REG_SC_BK3A_1C_H      _PK_H_(0x3A, 0x1C)
#define REG_SC_BK3A_1D_L      _PK_L_(0x3A, 0x1D)
#define REG_SC_BK3A_1D_H      _PK_H_(0x3A, 0x1D)
#define REG_SC_BK3A_1E_L      _PK_L_(0x3A, 0x1E)
#define REG_SC_BK3A_1E_H      _PK_H_(0x3A, 0x1E)
#define REG_SC_BK3A_1F_L      _PK_L_(0x3A, 0x1F)
#define REG_SC_BK3A_1F_H      _PK_H_(0x3A, 0x1F)
#define REG_SC_BK3A_20_L      _PK_L_(0x3A, 0x20)
#define REG_SC_BK3A_20_H      _PK_H_(0x3A, 0x20)
#define REG_SC_BK3A_21_L      _PK_L_(0x3A, 0x21)
#define REG_SC_BK3A_21_H      _PK_H_(0x3A, 0x21)
#define REG_SC_BK3A_22_L      _PK_L_(0x3A, 0x22)
#define REG_SC_BK3A_22_H      _PK_H_(0x3A, 0x22)
#define REG_SC_BK3A_23_L      _PK_L_(0x3A, 0x23)
#define REG_SC_BK3A_23_H      _PK_H_(0x3A, 0x23)
#define REG_SC_BK3A_24_L      _PK_L_(0x3A, 0x24)
#define REG_SC_BK3A_24_H      _PK_H_(0x3A, 0x24)
#define REG_SC_BK3A_25_L      _PK_L_(0x3A, 0x25)
#define REG_SC_BK3A_25_H      _PK_H_(0x3A, 0x25)
#define REG_SC_BK3A_26_L      _PK_L_(0x3A, 0x26)
#define REG_SC_BK3A_26_H      _PK_H_(0x3A, 0x26)
#define REG_SC_BK3A_27_L      _PK_L_(0x3A, 0x27)
#define REG_SC_BK3A_27_H      _PK_H_(0x3A, 0x27)
#define REG_SC_BK3A_28_L      _PK_L_(0x3A, 0x28)
#define REG_SC_BK3A_28_H      _PK_H_(0x3A, 0x28)
#define REG_SC_BK3A_29_L      _PK_L_(0x3A, 0x29)
#define REG_SC_BK3A_29_H      _PK_H_(0x3A, 0x29)
#define REG_SC_BK3A_2A_L      _PK_L_(0x3A, 0x2A)
#define REG_SC_BK3A_2A_H      _PK_H_(0x3A, 0x2A)
#define REG_SC_BK3A_2B_L      _PK_L_(0x3A, 0x2B)
#define REG_SC_BK3A_2B_H      _PK_H_(0x3A, 0x2B)
#define REG_SC_BK3A_2C_L      _PK_L_(0x3A, 0x2C)
#define REG_SC_BK3A_2C_H      _PK_H_(0x3A, 0x2C)
#define REG_SC_BK3A_2D_L      _PK_L_(0x3A, 0x2D)
#define REG_SC_BK3A_2D_H      _PK_H_(0x3A, 0x2D)
#define REG_SC_BK3A_2E_L      _PK_L_(0x3A, 0x2E)
#define REG_SC_BK3A_2E_H      _PK_H_(0x3A, 0x2E)
#define REG_SC_BK3A_2F_L      _PK_L_(0x3A, 0x2F)
#define REG_SC_BK3A_2F_H      _PK_H_(0x3A, 0x2F)
#define REG_SC_BK3A_30_L      _PK_L_(0x3A, 0x30)
#define REG_SC_BK3A_30_H      _PK_H_(0x3A, 0x30)
#define REG_SC_BK3A_31_L      _PK_L_(0x3A, 0x31)
#define REG_SC_BK3A_31_H      _PK_H_(0x3A, 0x31)
#define REG_SC_BK3A_32_L      _PK_L_(0x3A, 0x32)
#define REG_SC_BK3A_32_H      _PK_H_(0x3A, 0x32)
#define REG_SC_BK3A_33_L      _PK_L_(0x3A, 0x33)
#define REG_SC_BK3A_33_H      _PK_H_(0x3A, 0x33)
#define REG_SC_BK3A_34_L      _PK_L_(0x3A, 0x34)
#define REG_SC_BK3A_34_H      _PK_H_(0x3A, 0x34)
#define REG_SC_BK3A_35_L      _PK_L_(0x3A, 0x35)
#define REG_SC_BK3A_35_H      _PK_H_(0x3A, 0x35)
#define REG_SC_BK3A_36_L      _PK_L_(0x3A, 0x36)
#define REG_SC_BK3A_36_H      _PK_H_(0x3A, 0x36)
#define REG_SC_BK3A_37_L      _PK_L_(0x3A, 0x37)
#define REG_SC_BK3A_37_H      _PK_H_(0x3A, 0x37)
#define REG_SC_BK3A_38_L      _PK_L_(0x3A, 0x38)
#define REG_SC_BK3A_38_H      _PK_H_(0x3A, 0x38)
#define REG_SC_BK3A_39_L      _PK_L_(0x3A, 0x39)
#define REG_SC_BK3A_39_H      _PK_H_(0x3A, 0x39)
#define REG_SC_BK3A_3A_L      _PK_L_(0x3A, 0x3A)
#define REG_SC_BK3A_3A_H      _PK_H_(0x3A, 0x3A)
#define REG_SC_BK3A_3B_L      _PK_L_(0x3A, 0x3B)
#define REG_SC_BK3A_3B_H      _PK_H_(0x3A, 0x3B)
#define REG_SC_BK3A_3C_L      _PK_L_(0x3A, 0x3C)
#define REG_SC_BK3A_3C_H      _PK_H_(0x3A, 0x3C)
#define REG_SC_BK3A_3D_L      _PK_L_(0x3A, 0x3D)
#define REG_SC_BK3A_3D_H      _PK_H_(0x3A, 0x3D)
#define REG_SC_BK3A_3E_L      _PK_L_(0x3A, 0x3E)
#define REG_SC_BK3A_3E_H      _PK_H_(0x3A, 0x3E)
#define REG_SC_BK3A_3F_L      _PK_L_(0x3A, 0x3F)
#define REG_SC_BK3A_3F_H      _PK_H_(0x3A, 0x3F)
#define REG_SC_BK3A_40_L      _PK_L_(0x3A, 0x40)
#define REG_SC_BK3A_40_H      _PK_H_(0x3A, 0x40)
#define REG_SC_BK3A_41_L      _PK_L_(0x3A, 0x41)
#define REG_SC_BK3A_41_H      _PK_H_(0x3A, 0x41)
#define REG_SC_BK3A_42_L      _PK_L_(0x3A, 0x42)
#define REG_SC_BK3A_42_H      _PK_H_(0x3A, 0x42)
#define REG_SC_BK3A_43_L      _PK_L_(0x3A, 0x43)
#define REG_SC_BK3A_43_H      _PK_H_(0x3A, 0x43)
#define REG_SC_BK3A_44_L      _PK_L_(0x3A, 0x44)
#define REG_SC_BK3A_44_H      _PK_H_(0x3A, 0x44)
#define REG_SC_BK3A_45_L      _PK_L_(0x3A, 0x45)
#define REG_SC_BK3A_45_H      _PK_H_(0x3A, 0x45)
#define REG_SC_BK3A_46_L      _PK_L_(0x3A, 0x46)
#define REG_SC_BK3A_46_H      _PK_H_(0x3A, 0x46)
#define REG_SC_BK3A_47_L      _PK_L_(0x3A, 0x47)
#define REG_SC_BK3A_47_H      _PK_H_(0x3A, 0x47)
#define REG_SC_BK3A_48_L      _PK_L_(0x3A, 0x48)
#define REG_SC_BK3A_48_H      _PK_H_(0x3A, 0x48)
#define REG_SC_BK3A_49_L      _PK_L_(0x3A, 0x49)
#define REG_SC_BK3A_49_H      _PK_H_(0x3A, 0x49)
#define REG_SC_BK3A_4A_L      _PK_L_(0x3A, 0x4A)
#define REG_SC_BK3A_4A_H      _PK_H_(0x3A, 0x4A)
#define REG_SC_BK3A_4B_L      _PK_L_(0x3A, 0x4B)
#define REG_SC_BK3A_4B_H      _PK_H_(0x3A, 0x4B)
#define REG_SC_BK3A_4C_L      _PK_L_(0x3A, 0x4C)
#define REG_SC_BK3A_4C_H      _PK_H_(0x3A, 0x4C)
#define REG_SC_BK3A_4D_L      _PK_L_(0x3A, 0x4D)
#define REG_SC_BK3A_4D_H      _PK_H_(0x3A, 0x4D)
#define REG_SC_BK3A_4E_L      _PK_L_(0x3A, 0x4E)
#define REG_SC_BK3A_4E_H      _PK_H_(0x3A, 0x4E)
#define REG_SC_BK3A_4F_L      _PK_L_(0x3A, 0x4F)
#define REG_SC_BK3A_4F_H      _PK_H_(0x3A, 0x4F)
#define REG_SC_BK3A_50_L      _PK_L_(0x3A, 0x50)
#define REG_SC_BK3A_50_H      _PK_H_(0x3A, 0x50)
#define REG_SC_BK3A_51_L      _PK_L_(0x3A, 0x51)
#define REG_SC_BK3A_51_H      _PK_H_(0x3A, 0x51)
#define REG_SC_BK3A_52_L      _PK_L_(0x3A, 0x52)
#define REG_SC_BK3A_52_H      _PK_H_(0x3A, 0x52)
#define REG_SC_BK3A_53_L      _PK_L_(0x3A, 0x53)
#define REG_SC_BK3A_53_H      _PK_H_(0x3A, 0x53)
#define REG_SC_BK3A_54_L      _PK_L_(0x3A, 0x54)
#define REG_SC_BK3A_54_H      _PK_H_(0x3A, 0x54)
#define REG_SC_BK3A_55_L      _PK_L_(0x3A, 0x55)
#define REG_SC_BK3A_55_H      _PK_H_(0x3A, 0x55)
#define REG_SC_BK3A_56_L      _PK_L_(0x3A, 0x56)
#define REG_SC_BK3A_56_H      _PK_H_(0x3A, 0x56)
#define REG_SC_BK3A_57_L      _PK_L_(0x3A, 0x57)
#define REG_SC_BK3A_57_H      _PK_H_(0x3A, 0x57)
#define REG_SC_BK3A_58_L      _PK_L_(0x3A, 0x58)
#define REG_SC_BK3A_58_H      _PK_H_(0x3A, 0x58)
#define REG_SC_BK3A_59_L      _PK_L_(0x3A, 0x59)
#define REG_SC_BK3A_59_H      _PK_H_(0x3A, 0x59)
#define REG_SC_BK3A_5A_L      _PK_L_(0x3A, 0x5A)
#define REG_SC_BK3A_5A_H      _PK_H_(0x3A, 0x5A)
#define REG_SC_BK3A_5B_L      _PK_L_(0x3A, 0x5B)
#define REG_SC_BK3A_5B_H      _PK_H_(0x3A, 0x5B)
#define REG_SC_BK3A_5C_L      _PK_L_(0x3A, 0x5C)
#define REG_SC_BK3A_5C_H      _PK_H_(0x3A, 0x5C)
#define REG_SC_BK3A_5D_L      _PK_L_(0x3A, 0x5D)
#define REG_SC_BK3A_5D_H      _PK_H_(0x3A, 0x5D)
#define REG_SC_BK3A_5E_L      _PK_L_(0x3A, 0x5E)
#define REG_SC_BK3A_5E_H      _PK_H_(0x3A, 0x5E)
#define REG_SC_BK3A_5F_L      _PK_L_(0x3A, 0x5F)
#define REG_SC_BK3A_5F_H      _PK_H_(0x3A, 0x5F)
#define REG_SC_BK3A_60_L      _PK_L_(0x3A, 0x60)
#define REG_SC_BK3A_60_H      _PK_H_(0x3A, 0x60)
#define REG_SC_BK3A_61_L      _PK_L_(0x3A, 0x61)
#define REG_SC_BK3A_61_H      _PK_H_(0x3A, 0x61)
#define REG_SC_BK3A_62_L      _PK_L_(0x3A, 0x62)
#define REG_SC_BK3A_62_H      _PK_H_(0x3A, 0x62)
#define REG_SC_BK3A_63_L      _PK_L_(0x3A, 0x63)
#define REG_SC_BK3A_63_H      _PK_H_(0x3A, 0x63)
#define REG_SC_BK3A_64_L      _PK_L_(0x3A, 0x64)
#define REG_SC_BK3A_64_H      _PK_H_(0x3A, 0x64)
#define REG_SC_BK3A_65_L      _PK_L_(0x3A, 0x65)
#define REG_SC_BK3A_65_H      _PK_H_(0x3A, 0x65)
#define REG_SC_BK3A_66_L      _PK_L_(0x3A, 0x66)
#define REG_SC_BK3A_66_H      _PK_H_(0x3A, 0x66)
#define REG_SC_BK3A_67_L      _PK_L_(0x3A, 0x67)
#define REG_SC_BK3A_67_H      _PK_H_(0x3A, 0x67)
#define REG_SC_BK3A_68_L      _PK_L_(0x3A, 0x68)
#define REG_SC_BK3A_68_H      _PK_H_(0x3A, 0x68)
#define REG_SC_BK3A_69_L      _PK_L_(0x3A, 0x69)
#define REG_SC_BK3A_69_H      _PK_H_(0x3A, 0x69)
#define REG_SC_BK3A_6A_L      _PK_L_(0x3A, 0x6A)
#define REG_SC_BK3A_6A_H      _PK_H_(0x3A, 0x6A)
#define REG_SC_BK3A_6B_L      _PK_L_(0x3A, 0x6B)
#define REG_SC_BK3A_6B_H      _PK_H_(0x3A, 0x6B)
#define REG_SC_BK3A_6C_L      _PK_L_(0x3A, 0x6C)
#define REG_SC_BK3A_6C_H      _PK_H_(0x3A, 0x6C)
#define REG_SC_BK3A_6D_L      _PK_L_(0x3A, 0x6D)
#define REG_SC_BK3A_6D_H      _PK_H_(0x3A, 0x6D)
#define REG_SC_BK3A_6E_L      _PK_L_(0x3A, 0x6E)
#define REG_SC_BK3A_6E_H      _PK_H_(0x3A, 0x6E)
#define REG_SC_BK3A_6F_L      _PK_L_(0x3A, 0x6F)
#define REG_SC_BK3A_6F_H      _PK_H_(0x3A, 0x6F)
#define REG_SC_BK3A_70_L      _PK_L_(0x3A, 0x70)
#define REG_SC_BK3A_70_H      _PK_H_(0x3A, 0x70)
#define REG_SC_BK3A_71_L      _PK_L_(0x3A, 0x71)
#define REG_SC_BK3A_71_H      _PK_H_(0x3A, 0x71)
#define REG_SC_BK3A_72_L      _PK_L_(0x3A, 0x72)
#define REG_SC_BK3A_72_H      _PK_H_(0x3A, 0x72)
#define REG_SC_BK3A_73_L      _PK_L_(0x3A, 0x73)
#define REG_SC_BK3A_73_H      _PK_H_(0x3A, 0x73)
#define REG_SC_BK3A_74_L      _PK_L_(0x3A, 0x74)
#define REG_SC_BK3A_74_H      _PK_H_(0x3A, 0x74)
#define REG_SC_BK3A_75_L      _PK_L_(0x3A, 0x75)
#define REG_SC_BK3A_75_H      _PK_H_(0x3A, 0x75)
#define REG_SC_BK3A_76_L      _PK_L_(0x3A, 0x76)
#define REG_SC_BK3A_76_H      _PK_H_(0x3A, 0x76)
#define REG_SC_BK3A_77_L      _PK_L_(0x3A, 0x77)
#define REG_SC_BK3A_77_H      _PK_H_(0x3A, 0x77)
#define REG_SC_BK3A_78_L      _PK_L_(0x3A, 0x78)
#define REG_SC_BK3A_78_H      _PK_H_(0x3A, 0x78)
#define REG_SC_BK3A_79_L      _PK_L_(0x3A, 0x79)
#define REG_SC_BK3A_79_H      _PK_H_(0x3A, 0x79)
#define REG_SC_BK3A_7A_L      _PK_L_(0x3A, 0x7A)
#define REG_SC_BK3A_7A_H      _PK_H_(0x3A, 0x7A)
#define REG_SC_BK3A_7B_L      _PK_L_(0x3A, 0x7B)
#define REG_SC_BK3A_7B_H      _PK_H_(0x3A, 0x7B)
#define REG_SC_BK3A_7C_L      _PK_L_(0x3A, 0x7C)
#define REG_SC_BK3A_7C_H      _PK_H_(0x3A, 0x7C)
#define REG_SC_BK3A_7D_L      _PK_L_(0x3A, 0x7D)
#define REG_SC_BK3A_7D_H      _PK_H_(0x3A, 0x7D)
#define REG_SC_BK3A_7E_L      _PK_L_(0x3A, 0x7E)
#define REG_SC_BK3A_7E_H      _PK_H_(0x3A, 0x7E)
#define REG_SC_BK3A_7F_L      _PK_L_(0x3A, 0x7F)
#define REG_SC_BK3A_7F_H      _PK_H_(0x3A, 0x7F)
//----------------------------------------------
#define REG_SC_BK45_00_L      _PK_L_(0x45, 0x00)
#define REG_SC_BK45_00_H      _PK_H_(0x45, 0x00)
#define REG_SC_BK45_01_L      _PK_L_(0x45, 0x01)
#define REG_SC_BK45_01_H      _PK_H_(0x45, 0x01)
#define REG_SC_BK45_02_L      _PK_L_(0x45, 0x02)
#define REG_SC_BK45_02_H      _PK_H_(0x45, 0x02)
#define REG_SC_BK45_03_L      _PK_L_(0x45, 0x03)
#define REG_SC_BK45_03_H      _PK_H_(0x45, 0x03)
#define REG_SC_BK45_04_L      _PK_L_(0x45, 0x04)
#define REG_SC_BK45_04_H      _PK_H_(0x45, 0x04)
#define REG_SC_BK45_05_L      _PK_L_(0x45, 0x05)
#define REG_SC_BK45_05_H      _PK_H_(0x45, 0x05)
#define REG_SC_BK45_06_L      _PK_L_(0x45, 0x06)
#define REG_SC_BK45_06_H      _PK_H_(0x45, 0x06)
#define REG_SC_BK45_07_L      _PK_L_(0x45, 0x07)
#define REG_SC_BK45_07_H      _PK_H_(0x45, 0x07)
#define REG_SC_BK45_08_L      _PK_L_(0x45, 0x08)
#define REG_SC_BK45_08_H      _PK_H_(0x45, 0x08)
#define REG_SC_BK45_09_L      _PK_L_(0x45, 0x09)
#define REG_SC_BK45_09_H      _PK_H_(0x45, 0x09)
#define REG_SC_BK45_0A_L      _PK_L_(0x45, 0x0A)
#define REG_SC_BK45_0A_H      _PK_H_(0x45, 0x0A)
#define REG_SC_BK45_0B_L      _PK_L_(0x45, 0x0B)
#define REG_SC_BK45_0B_H      _PK_H_(0x45, 0x0B)
#define REG_SC_BK45_0C_L      _PK_L_(0x45, 0x0C)
#define REG_SC_BK45_0C_H      _PK_H_(0x45, 0x0C)
#define REG_SC_BK45_0D_L      _PK_L_(0x45, 0x0D)
#define REG_SC_BK45_0D_H      _PK_H_(0x45, 0x0D)
#define REG_SC_BK45_0E_L      _PK_L_(0x45, 0x0E)
#define REG_SC_BK45_0E_H      _PK_H_(0x45, 0x0E)
#define REG_SC_BK45_0F_L      _PK_L_(0x45, 0x0F)
#define REG_SC_BK45_0F_H      _PK_H_(0x45, 0x0F)
#define REG_SC_BK45_10_L      _PK_L_(0x45, 0x10)
#define REG_SC_BK45_10_H      _PK_H_(0x45, 0x10)
#define REG_SC_BK45_11_L      _PK_L_(0x45, 0x11)
#define REG_SC_BK45_11_H      _PK_H_(0x45, 0x11)
#define REG_SC_BK45_12_L      _PK_L_(0x45, 0x12)
#define REG_SC_BK45_12_H      _PK_H_(0x45, 0x12)
#define REG_SC_BK45_13_L      _PK_L_(0x45, 0x13)
#define REG_SC_BK45_13_H      _PK_H_(0x45, 0x13)
#define REG_SC_BK45_14_L      _PK_L_(0x45, 0x14)
#define REG_SC_BK45_14_H      _PK_H_(0x45, 0x14)
#define REG_SC_BK45_15_L      _PK_L_(0x45, 0x15)
#define REG_SC_BK45_15_H      _PK_H_(0x45, 0x15)
#define REG_SC_BK45_16_L      _PK_L_(0x45, 0x16)
#define REG_SC_BK45_16_H      _PK_H_(0x45, 0x16)
#define REG_SC_BK45_17_L      _PK_L_(0x45, 0x17)
#define REG_SC_BK45_17_H      _PK_H_(0x45, 0x17)
#define REG_SC_BK45_18_L      _PK_L_(0x45, 0x18)
#define REG_SC_BK45_18_H      _PK_H_(0x45, 0x18)
#define REG_SC_BK45_19_L      _PK_L_(0x45, 0x19)
#define REG_SC_BK45_19_H      _PK_H_(0x45, 0x19)
#define REG_SC_BK45_1A_L      _PK_L_(0x45, 0x1A)
#define REG_SC_BK45_1A_H      _PK_H_(0x45, 0x1A)
#define REG_SC_BK45_1B_L      _PK_L_(0x45, 0x1B)
#define REG_SC_BK45_1B_H      _PK_H_(0x45, 0x1B)
#define REG_SC_BK45_1C_L      _PK_L_(0x45, 0x1C)
#define REG_SC_BK45_1C_H      _PK_H_(0x45, 0x1C)
#define REG_SC_BK45_1D_L      _PK_L_(0x45, 0x1D)
#define REG_SC_BK45_1D_H      _PK_H_(0x45, 0x1D)
#define REG_SC_BK45_1E_L      _PK_L_(0x45, 0x1E)
#define REG_SC_BK45_1E_H      _PK_H_(0x45, 0x1E)
#define REG_SC_BK45_1F_L      _PK_L_(0x45, 0x1F)
#define REG_SC_BK45_1F_H      _PK_H_(0x45, 0x1F)
#define REG_SC_BK45_20_L      _PK_L_(0x45, 0x20)
#define REG_SC_BK45_20_H      _PK_H_(0x45, 0x20)
#define REG_SC_BK45_21_L      _PK_L_(0x45, 0x21)
#define REG_SC_BK45_21_H      _PK_H_(0x45, 0x21)
#define REG_SC_BK45_22_L      _PK_L_(0x45, 0x22)
#define REG_SC_BK45_22_H      _PK_H_(0x45, 0x22)
#define REG_SC_BK45_23_L      _PK_L_(0x45, 0x23)
#define REG_SC_BK45_23_H      _PK_H_(0x45, 0x23)
#define REG_SC_BK45_24_L      _PK_L_(0x45, 0x24)
#define REG_SC_BK45_24_H      _PK_H_(0x45, 0x24)
#define REG_SC_BK45_25_L      _PK_L_(0x45, 0x25)
#define REG_SC_BK45_25_H      _PK_H_(0x45, 0x25)
#define REG_SC_BK45_26_L      _PK_L_(0x45, 0x26)
#define REG_SC_BK45_26_H      _PK_H_(0x45, 0x26)
#define REG_SC_BK45_27_L      _PK_L_(0x45, 0x27)
#define REG_SC_BK45_27_H      _PK_H_(0x45, 0x27)
#define REG_SC_BK45_28_L      _PK_L_(0x45, 0x28)
#define REG_SC_BK45_28_H      _PK_H_(0x45, 0x28)
#define REG_SC_BK45_29_L      _PK_L_(0x45, 0x29)
#define REG_SC_BK45_29_H      _PK_H_(0x45, 0x29)
#define REG_SC_BK45_2A_L      _PK_L_(0x45, 0x2A)
#define REG_SC_BK45_2A_H      _PK_H_(0x45, 0x2A)
#define REG_SC_BK45_2B_L      _PK_L_(0x45, 0x2B)
#define REG_SC_BK45_2B_H      _PK_H_(0x45, 0x2B)
#define REG_SC_BK45_2C_L      _PK_L_(0x45, 0x2C)
#define REG_SC_BK45_2C_H      _PK_H_(0x45, 0x2C)
#define REG_SC_BK45_2D_L      _PK_L_(0x45, 0x2D)
#define REG_SC_BK45_2D_H      _PK_H_(0x45, 0x2D)
#define REG_SC_BK45_2E_L      _PK_L_(0x45, 0x2E)
#define REG_SC_BK45_2E_H      _PK_H_(0x45, 0x2E)
#define REG_SC_BK45_2F_L      _PK_L_(0x45, 0x2F)
#define REG_SC_BK45_2F_H      _PK_H_(0x45, 0x2F)
#define REG_SC_BK45_30_L      _PK_L_(0x45, 0x30)
#define REG_SC_BK45_30_H      _PK_H_(0x45, 0x30)
#define REG_SC_BK45_31_L      _PK_L_(0x45, 0x31)
#define REG_SC_BK45_31_H      _PK_H_(0x45, 0x31)
#define REG_SC_BK45_32_L      _PK_L_(0x45, 0x32)
#define REG_SC_BK45_32_H      _PK_H_(0x45, 0x32)
#define REG_SC_BK45_33_L      _PK_L_(0x45, 0x33)
#define REG_SC_BK45_33_H      _PK_H_(0x45, 0x33)
#define REG_SC_BK45_34_L      _PK_L_(0x45, 0x34)
#define REG_SC_BK45_34_H      _PK_H_(0x45, 0x34)
#define REG_SC_BK45_35_L      _PK_L_(0x45, 0x35)
#define REG_SC_BK45_35_H      _PK_H_(0x45, 0x35)
#define REG_SC_BK45_36_L      _PK_L_(0x45, 0x36)
#define REG_SC_BK45_36_H      _PK_H_(0x45, 0x36)
#define REG_SC_BK45_37_L      _PK_L_(0x45, 0x37)
#define REG_SC_BK45_37_H      _PK_H_(0x45, 0x37)
#define REG_SC_BK45_38_L      _PK_L_(0x45, 0x38)
#define REG_SC_BK45_38_H      _PK_H_(0x45, 0x38)
#define REG_SC_BK45_39_L      _PK_L_(0x45, 0x39)
#define REG_SC_BK45_39_H      _PK_H_(0x45, 0x39)
#define REG_SC_BK45_3A_L      _PK_L_(0x45, 0x3A)
#define REG_SC_BK45_3A_H      _PK_H_(0x45, 0x3A)
#define REG_SC_BK45_3B_L      _PK_L_(0x45, 0x3B)
#define REG_SC_BK45_3B_H      _PK_H_(0x45, 0x3B)
#define REG_SC_BK45_3C_L      _PK_L_(0x45, 0x3C)
#define REG_SC_BK45_3C_H      _PK_H_(0x45, 0x3C)
#define REG_SC_BK45_3D_L      _PK_L_(0x45, 0x3D)
#define REG_SC_BK45_3D_H      _PK_H_(0x45, 0x3D)
#define REG_SC_BK45_3E_L      _PK_L_(0x45, 0x3E)
#define REG_SC_BK45_3E_H      _PK_H_(0x45, 0x3E)
#define REG_SC_BK45_3F_L      _PK_L_(0x45, 0x3F)
#define REG_SC_BK45_3F_H      _PK_H_(0x45, 0x3F)
#define REG_SC_BK45_40_L      _PK_L_(0x45, 0x40)
#define REG_SC_BK45_40_H      _PK_H_(0x45, 0x40)
#define REG_SC_BK45_41_L      _PK_L_(0x45, 0x41)
#define REG_SC_BK45_41_H      _PK_H_(0x45, 0x41)
#define REG_SC_BK45_42_L      _PK_L_(0x45, 0x42)
#define REG_SC_BK45_42_H      _PK_H_(0x45, 0x42)
#define REG_SC_BK45_43_L      _PK_L_(0x45, 0x43)
#define REG_SC_BK45_43_H      _PK_H_(0x45, 0x43)
#define REG_SC_BK45_44_L      _PK_L_(0x45, 0x44)
#define REG_SC_BK45_44_H      _PK_H_(0x45, 0x44)
#define REG_SC_BK45_45_L      _PK_L_(0x45, 0x45)
#define REG_SC_BK45_45_H      _PK_H_(0x45, 0x45)
#define REG_SC_BK45_46_L      _PK_L_(0x45, 0x46)
#define REG_SC_BK45_46_H      _PK_H_(0x45, 0x46)
#define REG_SC_BK45_47_L      _PK_L_(0x45, 0x47)
#define REG_SC_BK45_47_H      _PK_H_(0x45, 0x47)
#define REG_SC_BK45_48_L      _PK_L_(0x45, 0x48)
#define REG_SC_BK45_48_H      _PK_H_(0x45, 0x48)
#define REG_SC_BK45_49_L      _PK_L_(0x45, 0x49)
#define REG_SC_BK45_49_H      _PK_H_(0x45, 0x49)
#define REG_SC_BK45_4A_L      _PK_L_(0x45, 0x4A)
#define REG_SC_BK45_4A_H      _PK_H_(0x45, 0x4A)
#define REG_SC_BK45_4B_L      _PK_L_(0x45, 0x4B)
#define REG_SC_BK45_4B_H      _PK_H_(0x45, 0x4B)
#define REG_SC_BK45_4C_L      _PK_L_(0x45, 0x4C)
#define REG_SC_BK45_4C_H      _PK_H_(0x45, 0x4C)
#define REG_SC_BK45_4D_L      _PK_L_(0x45, 0x4D)
#define REG_SC_BK45_4D_H      _PK_H_(0x45, 0x4D)
#define REG_SC_BK45_4E_L      _PK_L_(0x45, 0x4E)
#define REG_SC_BK45_4E_H      _PK_H_(0x45, 0x4E)
#define REG_SC_BK45_4F_L      _PK_L_(0x45, 0x4F)
#define REG_SC_BK45_4F_H      _PK_H_(0x45, 0x4F)
#define REG_SC_BK45_50_L      _PK_L_(0x45, 0x50)
#define REG_SC_BK45_50_H      _PK_H_(0x45, 0x50)
#define REG_SC_BK45_51_L      _PK_L_(0x45, 0x51)
#define REG_SC_BK45_51_H      _PK_H_(0x45, 0x51)
#define REG_SC_BK45_52_L      _PK_L_(0x45, 0x52)
#define REG_SC_BK45_52_H      _PK_H_(0x45, 0x52)
#define REG_SC_BK45_53_L      _PK_L_(0x45, 0x53)
#define REG_SC_BK45_53_H      _PK_H_(0x45, 0x53)
#define REG_SC_BK45_54_L      _PK_L_(0x45, 0x54)
#define REG_SC_BK45_54_H      _PK_H_(0x45, 0x54)
#define REG_SC_BK45_55_L      _PK_L_(0x45, 0x55)
#define REG_SC_BK45_55_H      _PK_H_(0x45, 0x55)
#define REG_SC_BK45_56_L      _PK_L_(0x45, 0x56)
#define REG_SC_BK45_56_H      _PK_H_(0x45, 0x56)
#define REG_SC_BK45_57_L      _PK_L_(0x45, 0x57)
#define REG_SC_BK45_57_H      _PK_H_(0x45, 0x57)
#define REG_SC_BK45_58_L      _PK_L_(0x45, 0x58)
#define REG_SC_BK45_58_H      _PK_H_(0x45, 0x58)
#define REG_SC_BK45_59_L      _PK_L_(0x45, 0x59)
#define REG_SC_BK45_59_H      _PK_H_(0x45, 0x59)
#define REG_SC_BK45_5A_L      _PK_L_(0x45, 0x5A)
#define REG_SC_BK45_5A_H      _PK_H_(0x45, 0x5A)
#define REG_SC_BK45_5B_L      _PK_L_(0x45, 0x5B)
#define REG_SC_BK45_5B_H      _PK_H_(0x45, 0x5B)
#define REG_SC_BK45_5C_L      _PK_L_(0x45, 0x5C)
#define REG_SC_BK45_5C_H      _PK_H_(0x45, 0x5C)
#define REG_SC_BK45_5D_L      _PK_L_(0x45, 0x5D)
#define REG_SC_BK45_5D_H      _PK_H_(0x45, 0x5D)
#define REG_SC_BK45_5E_L      _PK_L_(0x45, 0x5E)
#define REG_SC_BK45_5E_H      _PK_H_(0x45, 0x5E)
#define REG_SC_BK45_5F_L      _PK_L_(0x45, 0x5F)
#define REG_SC_BK45_5F_H      _PK_H_(0x45, 0x5F)
#define REG_SC_BK45_60_L      _PK_L_(0x45, 0x60)
#define REG_SC_BK45_60_H      _PK_H_(0x45, 0x60)
#define REG_SC_BK45_61_L      _PK_L_(0x45, 0x61)
#define REG_SC_BK45_61_H      _PK_H_(0x45, 0x61)
#define REG_SC_BK45_62_L      _PK_L_(0x45, 0x62)
#define REG_SC_BK45_62_H      _PK_H_(0x45, 0x62)
#define REG_SC_BK45_63_L      _PK_L_(0x45, 0x63)
#define REG_SC_BK45_63_H      _PK_H_(0x45, 0x63)
#define REG_SC_BK45_64_L      _PK_L_(0x45, 0x64)
#define REG_SC_BK45_64_H      _PK_H_(0x45, 0x64)
#define REG_SC_BK45_65_L      _PK_L_(0x45, 0x65)
#define REG_SC_BK45_65_H      _PK_H_(0x45, 0x65)
#define REG_SC_BK45_66_L      _PK_L_(0x45, 0x66)
#define REG_SC_BK45_66_H      _PK_H_(0x45, 0x66)
#define REG_SC_BK45_67_L      _PK_L_(0x45, 0x67)
#define REG_SC_BK45_67_H      _PK_H_(0x45, 0x67)
#define REG_SC_BK45_68_L      _PK_L_(0x45, 0x68)
#define REG_SC_BK45_68_H      _PK_H_(0x45, 0x68)
#define REG_SC_BK45_69_L      _PK_L_(0x45, 0x69)
#define REG_SC_BK45_69_H      _PK_H_(0x45, 0x69)
#define REG_SC_BK45_6A_L      _PK_L_(0x45, 0x6A)
#define REG_SC_BK45_6A_H      _PK_H_(0x45, 0x6A)
#define REG_SC_BK45_6B_L      _PK_L_(0x45, 0x6B)
#define REG_SC_BK45_6B_H      _PK_H_(0x45, 0x6B)
#define REG_SC_BK45_6C_L      _PK_L_(0x45, 0x6C)
#define REG_SC_BK45_6C_H      _PK_H_(0x45, 0x6C)
#define REG_SC_BK45_6D_L      _PK_L_(0x45, 0x6D)
#define REG_SC_BK45_6D_H      _PK_H_(0x45, 0x6D)
#define REG_SC_BK45_6E_L      _PK_L_(0x45, 0x6E)
#define REG_SC_BK45_6E_H      _PK_H_(0x45, 0x6E)
#define REG_SC_BK45_6F_L      _PK_L_(0x45, 0x6F)
#define REG_SC_BK45_6F_H      _PK_H_(0x45, 0x6F)
#define REG_SC_BK45_70_L      _PK_L_(0x45, 0x70)
#define REG_SC_BK45_70_H      _PK_H_(0x45, 0x70)
#define REG_SC_BK45_71_L      _PK_L_(0x45, 0x71)
#define REG_SC_BK45_71_H      _PK_H_(0x45, 0x71)
#define REG_SC_BK45_72_L      _PK_L_(0x45, 0x72)
#define REG_SC_BK45_72_H      _PK_H_(0x45, 0x72)
#define REG_SC_BK45_73_L      _PK_L_(0x45, 0x73)
#define REG_SC_BK45_73_H      _PK_H_(0x45, 0x73)
#define REG_SC_BK45_74_L      _PK_L_(0x45, 0x74)
#define REG_SC_BK45_74_H      _PK_H_(0x45, 0x74)
#define REG_SC_BK45_75_L      _PK_L_(0x45, 0x75)
#define REG_SC_BK45_75_H      _PK_H_(0x45, 0x75)
#define REG_SC_BK45_76_L      _PK_L_(0x45, 0x76)
#define REG_SC_BK45_76_H      _PK_H_(0x45, 0x76)
#define REG_SC_BK45_77_L      _PK_L_(0x45, 0x77)
#define REG_SC_BK45_77_H      _PK_H_(0x45, 0x77)
#define REG_SC_BK45_78_L      _PK_L_(0x45, 0x78)
#define REG_SC_BK45_78_H      _PK_H_(0x45, 0x78)
#define REG_SC_BK45_79_L      _PK_L_(0x45, 0x79)
#define REG_SC_BK45_79_H      _PK_H_(0x45, 0x79)
#define REG_SC_BK45_7A_L      _PK_L_(0x45, 0x7A)
#define REG_SC_BK45_7A_H      _PK_H_(0x45, 0x7A)
#define REG_SC_BK45_7B_L      _PK_L_(0x45, 0x7B)
#define REG_SC_BK45_7B_H      _PK_H_(0x45, 0x7B)
#define REG_SC_BK45_7C_L      _PK_L_(0x45, 0x7C)
#define REG_SC_BK45_7C_H      _PK_H_(0x45, 0x7C)
#define REG_SC_BK45_7D_L      _PK_L_(0x45, 0x7D)
#define REG_SC_BK45_7D_H      _PK_H_(0x45, 0x7D)
#define REG_SC_BK45_7E_L      _PK_L_(0x45, 0x7E)
#define REG_SC_BK45_7E_H      _PK_H_(0x45, 0x7E)
#define REG_SC_BK45_7F_L      _PK_L_(0x45, 0x7F)
#define REG_SC_BK45_7F_H      _PK_H_(0x45, 0x7F)
//----------------------------------------------
#define REG_SC_BK46_00_L      _PK_L_(0x46, 0x00)
#define REG_SC_BK46_00_H      _PK_H_(0x46, 0x00)
#define REG_SC_BK46_01_L      _PK_L_(0x46, 0x01)
#define REG_SC_BK46_01_H      _PK_H_(0x46, 0x01)
#define REG_SC_BK46_02_L      _PK_L_(0x46, 0x02)
#define REG_SC_BK46_02_H      _PK_H_(0x46, 0x02)
#define REG_SC_BK46_03_L      _PK_L_(0x46, 0x03)
#define REG_SC_BK46_03_H      _PK_H_(0x46, 0x03)
#define REG_SC_BK46_04_L      _PK_L_(0x46, 0x04)
#define REG_SC_BK46_04_H      _PK_H_(0x46, 0x04)
#define REG_SC_BK46_05_L      _PK_L_(0x46, 0x05)
#define REG_SC_BK46_05_H      _PK_H_(0x46, 0x05)
#define REG_SC_BK46_06_L      _PK_L_(0x46, 0x06)
#define REG_SC_BK46_06_H      _PK_H_(0x46, 0x06)
#define REG_SC_BK46_07_L      _PK_L_(0x46, 0x07)
#define REG_SC_BK46_07_H      _PK_H_(0x46, 0x07)
#define REG_SC_BK46_08_L      _PK_L_(0x46, 0x08)
#define REG_SC_BK46_08_H      _PK_H_(0x46, 0x08)
#define REG_SC_BK46_09_L      _PK_L_(0x46, 0x09)
#define REG_SC_BK46_09_H      _PK_H_(0x46, 0x09)
#define REG_SC_BK46_0A_L      _PK_L_(0x46, 0x0A)
#define REG_SC_BK46_0A_H      _PK_H_(0x46, 0x0A)
#define REG_SC_BK46_0B_L      _PK_L_(0x46, 0x0B)
#define REG_SC_BK46_0B_H      _PK_H_(0x46, 0x0B)
#define REG_SC_BK46_0C_L      _PK_L_(0x46, 0x0C)
#define REG_SC_BK46_0C_H      _PK_H_(0x46, 0x0C)
#define REG_SC_BK46_0D_L      _PK_L_(0x46, 0x0D)
#define REG_SC_BK46_0D_H      _PK_H_(0x46, 0x0D)
#define REG_SC_BK46_0E_L      _PK_L_(0x46, 0x0E)
#define REG_SC_BK46_0E_H      _PK_H_(0x46, 0x0E)
#define REG_SC_BK46_0F_L      _PK_L_(0x46, 0x0F)
#define REG_SC_BK46_0F_H      _PK_H_(0x46, 0x0F)
#define REG_SC_BK46_10_L      _PK_L_(0x46, 0x10)
#define REG_SC_BK46_10_H      _PK_H_(0x46, 0x10)
#define REG_SC_BK46_11_L      _PK_L_(0x46, 0x11)
#define REG_SC_BK46_11_H      _PK_H_(0x46, 0x11)
#define REG_SC_BK46_12_L      _PK_L_(0x46, 0x12)
#define REG_SC_BK46_12_H      _PK_H_(0x46, 0x12)
#define REG_SC_BK46_13_L      _PK_L_(0x46, 0x13)
#define REG_SC_BK46_13_H      _PK_H_(0x46, 0x13)
#define REG_SC_BK46_14_L      _PK_L_(0x46, 0x14)
#define REG_SC_BK46_14_H      _PK_H_(0x46, 0x14)
#define REG_SC_BK46_15_L      _PK_L_(0x46, 0x15)
#define REG_SC_BK46_15_H      _PK_H_(0x46, 0x15)
#define REG_SC_BK46_16_L      _PK_L_(0x46, 0x16)
#define REG_SC_BK46_16_H      _PK_H_(0x46, 0x16)
#define REG_SC_BK46_17_L      _PK_L_(0x46, 0x17)
#define REG_SC_BK46_17_H      _PK_H_(0x46, 0x17)
#define REG_SC_BK46_18_L      _PK_L_(0x46, 0x18)
#define REG_SC_BK46_18_H      _PK_H_(0x46, 0x18)
#define REG_SC_BK46_19_L      _PK_L_(0x46, 0x19)
#define REG_SC_BK46_19_H      _PK_H_(0x46, 0x19)
#define REG_SC_BK46_1A_L      _PK_L_(0x46, 0x1A)
#define REG_SC_BK46_1A_H      _PK_H_(0x46, 0x1A)
#define REG_SC_BK46_1B_L      _PK_L_(0x46, 0x1B)
#define REG_SC_BK46_1B_H      _PK_H_(0x46, 0x1B)
#define REG_SC_BK46_1C_L      _PK_L_(0x46, 0x1C)
#define REG_SC_BK46_1C_H      _PK_H_(0x46, 0x1C)
#define REG_SC_BK46_1D_L      _PK_L_(0x46, 0x1D)
#define REG_SC_BK46_1D_H      _PK_H_(0x46, 0x1D)
#define REG_SC_BK46_1E_L      _PK_L_(0x46, 0x1E)
#define REG_SC_BK46_1E_H      _PK_H_(0x46, 0x1E)
#define REG_SC_BK46_1F_L      _PK_L_(0x46, 0x1F)
#define REG_SC_BK46_1F_H      _PK_H_(0x46, 0x1F)
#define REG_SC_BK46_20_L      _PK_L_(0x46, 0x20)
#define REG_SC_BK46_20_H      _PK_H_(0x46, 0x20)
#define REG_SC_BK46_21_L      _PK_L_(0x46, 0x21)
#define REG_SC_BK46_21_H      _PK_H_(0x46, 0x21)
#define REG_SC_BK46_22_L      _PK_L_(0x46, 0x22)
#define REG_SC_BK46_22_H      _PK_H_(0x46, 0x22)
#define REG_SC_BK46_23_L      _PK_L_(0x46, 0x23)
#define REG_SC_BK46_23_H      _PK_H_(0x46, 0x23)
#define REG_SC_BK46_24_L      _PK_L_(0x46, 0x24)
#define REG_SC_BK46_24_H      _PK_H_(0x46, 0x24)
#define REG_SC_BK46_25_L      _PK_L_(0x46, 0x25)
#define REG_SC_BK46_25_H      _PK_H_(0x46, 0x25)
#define REG_SC_BK46_26_L      _PK_L_(0x46, 0x26)
#define REG_SC_BK46_26_H      _PK_H_(0x46, 0x26)
#define REG_SC_BK46_27_L      _PK_L_(0x46, 0x27)
#define REG_SC_BK46_27_H      _PK_H_(0x46, 0x27)
#define REG_SC_BK46_28_L      _PK_L_(0x46, 0x28)
#define REG_SC_BK46_28_H      _PK_H_(0x46, 0x28)
#define REG_SC_BK46_29_L      _PK_L_(0x46, 0x29)
#define REG_SC_BK46_29_H      _PK_H_(0x46, 0x29)
#define REG_SC_BK46_2A_L      _PK_L_(0x46, 0x2A)
#define REG_SC_BK46_2A_H      _PK_H_(0x46, 0x2A)
#define REG_SC_BK46_2B_L      _PK_L_(0x46, 0x2B)
#define REG_SC_BK46_2B_H      _PK_H_(0x46, 0x2B)
#define REG_SC_BK46_2C_L      _PK_L_(0x46, 0x2C)
#define REG_SC_BK46_2C_H      _PK_H_(0x46, 0x2C)
#define REG_SC_BK46_2D_L      _PK_L_(0x46, 0x2D)
#define REG_SC_BK46_2D_H      _PK_H_(0x46, 0x2D)
#define REG_SC_BK46_2E_L      _PK_L_(0x46, 0x2E)
#define REG_SC_BK46_2E_H      _PK_H_(0x46, 0x2E)
#define REG_SC_BK46_2F_L      _PK_L_(0x46, 0x2F)
#define REG_SC_BK46_2F_H      _PK_H_(0x46, 0x2F)
#define REG_SC_BK46_30_L      _PK_L_(0x46, 0x30)
#define REG_SC_BK46_30_H      _PK_H_(0x46, 0x30)
#define REG_SC_BK46_31_L      _PK_L_(0x46, 0x31)
#define REG_SC_BK46_31_H      _PK_H_(0x46, 0x31)
#define REG_SC_BK46_32_L      _PK_L_(0x46, 0x32)
#define REG_SC_BK46_32_H      _PK_H_(0x46, 0x32)
#define REG_SC_BK46_33_L      _PK_L_(0x46, 0x33)
#define REG_SC_BK46_33_H      _PK_H_(0x46, 0x33)
#define REG_SC_BK46_34_L      _PK_L_(0x46, 0x34)
#define REG_SC_BK46_34_H      _PK_H_(0x46, 0x34)
#define REG_SC_BK46_35_L      _PK_L_(0x46, 0x35)
#define REG_SC_BK46_35_H      _PK_H_(0x46, 0x35)
#define REG_SC_BK46_36_L      _PK_L_(0x46, 0x36)
#define REG_SC_BK46_36_H      _PK_H_(0x46, 0x36)
#define REG_SC_BK46_37_L      _PK_L_(0x46, 0x37)
#define REG_SC_BK46_37_H      _PK_H_(0x46, 0x37)
#define REG_SC_BK46_38_L      _PK_L_(0x46, 0x38)
#define REG_SC_BK46_38_H      _PK_H_(0x46, 0x38)
#define REG_SC_BK46_39_L      _PK_L_(0x46, 0x39)
#define REG_SC_BK46_39_H      _PK_H_(0x46, 0x39)
#define REG_SC_BK46_3A_L      _PK_L_(0x46, 0x3A)
#define REG_SC_BK46_3A_H      _PK_H_(0x46, 0x3A)
#define REG_SC_BK46_3B_L      _PK_L_(0x46, 0x3B)
#define REG_SC_BK46_3B_H      _PK_H_(0x46, 0x3B)
#define REG_SC_BK46_3C_L      _PK_L_(0x46, 0x3C)
#define REG_SC_BK46_3C_H      _PK_H_(0x46, 0x3C)
#define REG_SC_BK46_3D_L      _PK_L_(0x46, 0x3D)
#define REG_SC_BK46_3D_H      _PK_H_(0x46, 0x3D)
#define REG_SC_BK46_3E_L      _PK_L_(0x46, 0x3E)
#define REG_SC_BK46_3E_H      _PK_H_(0x46, 0x3E)
#define REG_SC_BK46_3F_L      _PK_L_(0x46, 0x3F)
#define REG_SC_BK46_3F_H      _PK_H_(0x46, 0x3F)
#define REG_SC_BK46_40_L      _PK_L_(0x46, 0x40)
#define REG_SC_BK46_40_H      _PK_H_(0x46, 0x40)
#define REG_SC_BK46_41_L      _PK_L_(0x46, 0x41)
#define REG_SC_BK46_41_H      _PK_H_(0x46, 0x41)
#define REG_SC_BK46_42_L      _PK_L_(0x46, 0x42)
#define REG_SC_BK46_42_H      _PK_H_(0x46, 0x42)
#define REG_SC_BK46_43_L      _PK_L_(0x46, 0x43)
#define REG_SC_BK46_43_H      _PK_H_(0x46, 0x43)
#define REG_SC_BK46_44_L      _PK_L_(0x46, 0x44)
#define REG_SC_BK46_44_H      _PK_H_(0x46, 0x44)
#define REG_SC_BK46_45_L      _PK_L_(0x46, 0x45)
#define REG_SC_BK46_45_H      _PK_H_(0x46, 0x45)
#define REG_SC_BK46_46_L      _PK_L_(0x46, 0x46)
#define REG_SC_BK46_46_H      _PK_H_(0x46, 0x46)
#define REG_SC_BK46_47_L      _PK_L_(0x46, 0x47)
#define REG_SC_BK46_47_H      _PK_H_(0x46, 0x47)
#define REG_SC_BK46_48_L      _PK_L_(0x46, 0x48)
#define REG_SC_BK46_48_H      _PK_H_(0x46, 0x48)
#define REG_SC_BK46_49_L      _PK_L_(0x46, 0x49)
#define REG_SC_BK46_49_H      _PK_H_(0x46, 0x49)
#define REG_SC_BK46_4A_L      _PK_L_(0x46, 0x4A)
#define REG_SC_BK46_4A_H      _PK_H_(0x46, 0x4A)
#define REG_SC_BK46_4B_L      _PK_L_(0x46, 0x4B)
#define REG_SC_BK46_4B_H      _PK_H_(0x46, 0x4B)
#define REG_SC_BK46_4C_L      _PK_L_(0x46, 0x4C)
#define REG_SC_BK46_4C_H      _PK_H_(0x46, 0x4C)
#define REG_SC_BK46_4D_L      _PK_L_(0x46, 0x4D)
#define REG_SC_BK46_4D_H      _PK_H_(0x46, 0x4D)
#define REG_SC_BK46_4E_L      _PK_L_(0x46, 0x4E)
#define REG_SC_BK46_4E_H      _PK_H_(0x46, 0x4E)
#define REG_SC_BK46_4F_L      _PK_L_(0x46, 0x4F)
#define REG_SC_BK46_4F_H      _PK_H_(0x46, 0x4F)
#define REG_SC_BK46_50_L      _PK_L_(0x46, 0x50)
#define REG_SC_BK46_50_H      _PK_H_(0x46, 0x50)
#define REG_SC_BK46_51_L      _PK_L_(0x46, 0x51)
#define REG_SC_BK46_51_H      _PK_H_(0x46, 0x51)
#define REG_SC_BK46_52_L      _PK_L_(0x46, 0x52)
#define REG_SC_BK46_52_H      _PK_H_(0x46, 0x52)
#define REG_SC_BK46_53_L      _PK_L_(0x46, 0x53)
#define REG_SC_BK46_53_H      _PK_H_(0x46, 0x53)
#define REG_SC_BK46_54_L      _PK_L_(0x46, 0x54)
#define REG_SC_BK46_54_H      _PK_H_(0x46, 0x54)
#define REG_SC_BK46_55_L      _PK_L_(0x46, 0x55)
#define REG_SC_BK46_55_H      _PK_H_(0x46, 0x55)
#define REG_SC_BK46_56_L      _PK_L_(0x46, 0x56)
#define REG_SC_BK46_56_H      _PK_H_(0x46, 0x56)
#define REG_SC_BK46_57_L      _PK_L_(0x46, 0x57)
#define REG_SC_BK46_57_H      _PK_H_(0x46, 0x57)
#define REG_SC_BK46_58_L      _PK_L_(0x46, 0x58)
#define REG_SC_BK46_58_H      _PK_H_(0x46, 0x58)
#define REG_SC_BK46_59_L      _PK_L_(0x46, 0x59)
#define REG_SC_BK46_59_H      _PK_H_(0x46, 0x59)
#define REG_SC_BK46_5A_L      _PK_L_(0x46, 0x5A)
#define REG_SC_BK46_5A_H      _PK_H_(0x46, 0x5A)
#define REG_SC_BK46_5B_L      _PK_L_(0x46, 0x5B)
#define REG_SC_BK46_5B_H      _PK_H_(0x46, 0x5B)
#define REG_SC_BK46_5C_L      _PK_L_(0x46, 0x5C)
#define REG_SC_BK46_5C_H      _PK_H_(0x46, 0x5C)
#define REG_SC_BK46_5D_L      _PK_L_(0x46, 0x5D)
#define REG_SC_BK46_5D_H      _PK_H_(0x46, 0x5D)
#define REG_SC_BK46_5E_L      _PK_L_(0x46, 0x5E)
#define REG_SC_BK46_5E_H      _PK_H_(0x46, 0x5E)
#define REG_SC_BK46_5F_L      _PK_L_(0x46, 0x5F)
#define REG_SC_BK46_5F_H      _PK_H_(0x46, 0x5F)
#define REG_SC_BK46_60_L      _PK_L_(0x46, 0x60)
#define REG_SC_BK46_60_H      _PK_H_(0x46, 0x60)
#define REG_SC_BK46_61_L      _PK_L_(0x46, 0x61)
#define REG_SC_BK46_61_H      _PK_H_(0x46, 0x61)
#define REG_SC_BK46_62_L      _PK_L_(0x46, 0x62)
#define REG_SC_BK46_62_H      _PK_H_(0x46, 0x62)
#define REG_SC_BK46_63_L      _PK_L_(0x46, 0x63)
#define REG_SC_BK46_63_H      _PK_H_(0x46, 0x63)
#define REG_SC_BK46_64_L      _PK_L_(0x46, 0x64)
#define REG_SC_BK46_64_H      _PK_H_(0x46, 0x64)
#define REG_SC_BK46_65_L      _PK_L_(0x46, 0x65)
#define REG_SC_BK46_65_H      _PK_H_(0x46, 0x65)
#define REG_SC_BK46_66_L      _PK_L_(0x46, 0x66)
#define REG_SC_BK46_66_H      _PK_H_(0x46, 0x66)
#define REG_SC_BK46_67_L      _PK_L_(0x46, 0x67)
#define REG_SC_BK46_67_H      _PK_H_(0x46, 0x67)
#define REG_SC_BK46_68_L      _PK_L_(0x46, 0x68)
#define REG_SC_BK46_68_H      _PK_H_(0x46, 0x68)
#define REG_SC_BK46_69_L      _PK_L_(0x46, 0x69)
#define REG_SC_BK46_69_H      _PK_H_(0x46, 0x69)
#define REG_SC_BK46_6A_L      _PK_L_(0x46, 0x6A)
#define REG_SC_BK46_6A_H      _PK_H_(0x46, 0x6A)
#define REG_SC_BK46_6B_L      _PK_L_(0x46, 0x6B)
#define REG_SC_BK46_6B_H      _PK_H_(0x46, 0x6B)
#define REG_SC_BK46_6C_L      _PK_L_(0x46, 0x6C)
#define REG_SC_BK46_6C_H      _PK_H_(0x46, 0x6C)
#define REG_SC_BK46_6D_L      _PK_L_(0x46, 0x6D)
#define REG_SC_BK46_6D_H      _PK_H_(0x46, 0x6D)
#define REG_SC_BK46_6E_L      _PK_L_(0x46, 0x6E)
#define REG_SC_BK46_6E_H      _PK_H_(0x46, 0x6E)
#define REG_SC_BK46_6F_L      _PK_L_(0x46, 0x6F)
#define REG_SC_BK46_6F_H      _PK_H_(0x46, 0x6F)
#define REG_SC_BK46_70_L      _PK_L_(0x46, 0x70)
#define REG_SC_BK46_70_H      _PK_H_(0x46, 0x70)
#define REG_SC_BK46_71_L      _PK_L_(0x46, 0x71)
#define REG_SC_BK46_71_H      _PK_H_(0x46, 0x71)
#define REG_SC_BK46_72_L      _PK_L_(0x46, 0x72)
#define REG_SC_BK46_72_H      _PK_H_(0x46, 0x72)
#define REG_SC_BK46_73_L      _PK_L_(0x46, 0x73)
#define REG_SC_BK46_73_H      _PK_H_(0x46, 0x73)
#define REG_SC_BK46_74_L      _PK_L_(0x46, 0x74)
#define REG_SC_BK46_74_H      _PK_H_(0x46, 0x74)
#define REG_SC_BK46_75_L      _PK_L_(0x46, 0x75)
#define REG_SC_BK46_75_H      _PK_H_(0x46, 0x75)
#define REG_SC_BK46_76_L      _PK_L_(0x46, 0x76)
#define REG_SC_BK46_76_H      _PK_H_(0x46, 0x76)
#define REG_SC_BK46_77_L      _PK_L_(0x46, 0x77)
#define REG_SC_BK46_77_H      _PK_H_(0x46, 0x77)
#define REG_SC_BK46_78_L      _PK_L_(0x46, 0x78)
#define REG_SC_BK46_78_H      _PK_H_(0x46, 0x78)
#define REG_SC_BK46_79_L      _PK_L_(0x46, 0x79)
#define REG_SC_BK46_79_H      _PK_H_(0x46, 0x79)
#define REG_SC_BK46_7A_L      _PK_L_(0x46, 0x7A)
#define REG_SC_BK46_7A_H      _PK_H_(0x46, 0x7A)
#define REG_SC_BK46_7B_L      _PK_L_(0x46, 0x7B)
#define REG_SC_BK46_7B_H      _PK_H_(0x46, 0x7B)
#define REG_SC_BK46_7C_L      _PK_L_(0x46, 0x7C)
#define REG_SC_BK46_7C_H      _PK_H_(0x46, 0x7C)
#define REG_SC_BK46_7D_L      _PK_L_(0x46, 0x7D)
#define REG_SC_BK46_7D_H      _PK_H_(0x46, 0x7D)
#define REG_SC_BK46_7E_L      _PK_L_(0x46, 0x7E)
#define REG_SC_BK46_7E_H      _PK_H_(0x46, 0x7E)
#define REG_SC_BK46_7F_L      _PK_L_(0x46, 0x7F)
#define REG_SC_BK46_7F_H      _PK_H_(0x46, 0x7F)
//----------------------------------------------
#define REG_SC_BK47_00_L      _PK_L_(0x47, 0x00)
#define REG_SC_BK47_00_H      _PK_H_(0x47, 0x00)
#define REG_SC_BK47_01_L      _PK_L_(0x47, 0x01)
#define REG_SC_BK47_01_H      _PK_H_(0x47, 0x01)
#define REG_SC_BK47_02_L      _PK_L_(0x47, 0x02)
#define REG_SC_BK47_02_H      _PK_H_(0x47, 0x02)
#define REG_SC_BK47_03_L      _PK_L_(0x47, 0x03)
#define REG_SC_BK47_03_H      _PK_H_(0x47, 0x03)
#define REG_SC_BK47_04_L      _PK_L_(0x47, 0x04)
#define REG_SC_BK47_04_H      _PK_H_(0x47, 0x04)
#define REG_SC_BK47_05_L      _PK_L_(0x47, 0x05)
#define REG_SC_BK47_05_H      _PK_H_(0x47, 0x05)
#define REG_SC_BK47_06_L      _PK_L_(0x47, 0x06)
#define REG_SC_BK47_06_H      _PK_H_(0x47, 0x06)
#define REG_SC_BK47_07_L      _PK_L_(0x47, 0x07)
#define REG_SC_BK47_07_H      _PK_H_(0x47, 0x07)
#define REG_SC_BK47_08_L      _PK_L_(0x47, 0x08)
#define REG_SC_BK47_08_H      _PK_H_(0x47, 0x08)
#define REG_SC_BK47_09_L      _PK_L_(0x47, 0x09)
#define REG_SC_BK47_09_H      _PK_H_(0x47, 0x09)
#define REG_SC_BK47_0A_L      _PK_L_(0x47, 0x0A)
#define REG_SC_BK47_0A_H      _PK_H_(0x47, 0x0A)
#define REG_SC_BK47_0B_L      _PK_L_(0x47, 0x0B)
#define REG_SC_BK47_0B_H      _PK_H_(0x47, 0x0B)
#define REG_SC_BK47_0C_L      _PK_L_(0x47, 0x0C)
#define REG_SC_BK47_0C_H      _PK_H_(0x47, 0x0C)
#define REG_SC_BK47_0D_L      _PK_L_(0x47, 0x0D)
#define REG_SC_BK47_0D_H      _PK_H_(0x47, 0x0D)
#define REG_SC_BK47_0E_L      _PK_L_(0x47, 0x0E)
#define REG_SC_BK47_0E_H      _PK_H_(0x47, 0x0E)
#define REG_SC_BK47_0F_L      _PK_L_(0x47, 0x0F)
#define REG_SC_BK47_0F_H      _PK_H_(0x47, 0x0F)
#define REG_SC_BK47_10_L      _PK_L_(0x47, 0x10)
#define REG_SC_BK47_10_H      _PK_H_(0x47, 0x10)
#define REG_SC_BK47_11_L      _PK_L_(0x47, 0x11)
#define REG_SC_BK47_11_H      _PK_H_(0x47, 0x11)
#define REG_SC_BK47_12_L      _PK_L_(0x47, 0x12)
#define REG_SC_BK47_12_H      _PK_H_(0x47, 0x12)
#define REG_SC_BK47_13_L      _PK_L_(0x47, 0x13)
#define REG_SC_BK47_13_H      _PK_H_(0x47, 0x13)
#define REG_SC_BK47_14_L      _PK_L_(0x47, 0x14)
#define REG_SC_BK47_14_H      _PK_H_(0x47, 0x14)
#define REG_SC_BK47_15_L      _PK_L_(0x47, 0x15)
#define REG_SC_BK47_15_H      _PK_H_(0x47, 0x15)
#define REG_SC_BK47_16_L      _PK_L_(0x47, 0x16)
#define REG_SC_BK47_16_H      _PK_H_(0x47, 0x16)
#define REG_SC_BK47_17_L      _PK_L_(0x47, 0x17)
#define REG_SC_BK47_17_H      _PK_H_(0x47, 0x17)
#define REG_SC_BK47_18_L      _PK_L_(0x47, 0x18)
#define REG_SC_BK47_18_H      _PK_H_(0x47, 0x18)
#define REG_SC_BK47_19_L      _PK_L_(0x47, 0x19)
#define REG_SC_BK47_19_H      _PK_H_(0x47, 0x19)
#define REG_SC_BK47_1A_L      _PK_L_(0x47, 0x1A)
#define REG_SC_BK47_1A_H      _PK_H_(0x47, 0x1A)
#define REG_SC_BK47_1B_L      _PK_L_(0x47, 0x1B)
#define REG_SC_BK47_1B_H      _PK_H_(0x47, 0x1B)
#define REG_SC_BK47_1C_L      _PK_L_(0x47, 0x1C)
#define REG_SC_BK47_1C_H      _PK_H_(0x47, 0x1C)
#define REG_SC_BK47_1D_L      _PK_L_(0x47, 0x1D)
#define REG_SC_BK47_1D_H      _PK_H_(0x47, 0x1D)
#define REG_SC_BK47_1E_L      _PK_L_(0x47, 0x1E)
#define REG_SC_BK47_1E_H      _PK_H_(0x47, 0x1E)
#define REG_SC_BK47_1F_L      _PK_L_(0x47, 0x1F)
#define REG_SC_BK47_1F_H      _PK_H_(0x47, 0x1F)
#define REG_SC_BK47_20_L      _PK_L_(0x47, 0x20)
#define REG_SC_BK47_20_H      _PK_H_(0x47, 0x20)
#define REG_SC_BK47_21_L      _PK_L_(0x47, 0x21)
#define REG_SC_BK47_21_H      _PK_H_(0x47, 0x21)
#define REG_SC_BK47_22_L      _PK_L_(0x47, 0x22)
#define REG_SC_BK47_22_H      _PK_H_(0x47, 0x22)
#define REG_SC_BK47_23_L      _PK_L_(0x47, 0x23)
#define REG_SC_BK47_23_H      _PK_H_(0x47, 0x23)
#define REG_SC_BK47_24_L      _PK_L_(0x47, 0x24)
#define REG_SC_BK47_24_H      _PK_H_(0x47, 0x24)
#define REG_SC_BK47_25_L      _PK_L_(0x47, 0x25)
#define REG_SC_BK47_25_H      _PK_H_(0x47, 0x25)
#define REG_SC_BK47_26_L      _PK_L_(0x47, 0x26)
#define REG_SC_BK47_26_H      _PK_H_(0x47, 0x26)
#define REG_SC_BK47_27_L      _PK_L_(0x47, 0x27)
#define REG_SC_BK47_27_H      _PK_H_(0x47, 0x27)
#define REG_SC_BK47_28_L      _PK_L_(0x47, 0x28)
#define REG_SC_BK47_28_H      _PK_H_(0x47, 0x28)
#define REG_SC_BK47_29_L      _PK_L_(0x47, 0x29)
#define REG_SC_BK47_29_H      _PK_H_(0x47, 0x29)
#define REG_SC_BK47_2A_L      _PK_L_(0x47, 0x2A)
#define REG_SC_BK47_2A_H      _PK_H_(0x47, 0x2A)
#define REG_SC_BK47_2B_L      _PK_L_(0x47, 0x2B)
#define REG_SC_BK47_2B_H      _PK_H_(0x47, 0x2B)
#define REG_SC_BK47_2C_L      _PK_L_(0x47, 0x2C)
#define REG_SC_BK47_2C_H      _PK_H_(0x47, 0x2C)
#define REG_SC_BK47_2D_L      _PK_L_(0x47, 0x2D)
#define REG_SC_BK47_2D_H      _PK_H_(0x47, 0x2D)
#define REG_SC_BK47_2E_L      _PK_L_(0x47, 0x2E)
#define REG_SC_BK47_2E_H      _PK_H_(0x47, 0x2E)
#define REG_SC_BK47_2F_L      _PK_L_(0x47, 0x2F)
#define REG_SC_BK47_2F_H      _PK_H_(0x47, 0x2F)
#define REG_SC_BK47_30_L      _PK_L_(0x47, 0x30)
#define REG_SC_BK47_30_H      _PK_H_(0x47, 0x30)
#define REG_SC_BK47_31_L      _PK_L_(0x47, 0x31)
#define REG_SC_BK47_31_H      _PK_H_(0x47, 0x31)
#define REG_SC_BK47_32_L      _PK_L_(0x47, 0x32)
#define REG_SC_BK47_32_H      _PK_H_(0x47, 0x32)
#define REG_SC_BK47_33_L      _PK_L_(0x47, 0x33)
#define REG_SC_BK47_33_H      _PK_H_(0x47, 0x33)
#define REG_SC_BK47_34_L      _PK_L_(0x47, 0x34)
#define REG_SC_BK47_34_H      _PK_H_(0x47, 0x34)
#define REG_SC_BK47_35_L      _PK_L_(0x47, 0x35)
#define REG_SC_BK47_35_H      _PK_H_(0x47, 0x35)
#define REG_SC_BK47_36_L      _PK_L_(0x47, 0x36)
#define REG_SC_BK47_36_H      _PK_H_(0x47, 0x36)
#define REG_SC_BK47_37_L      _PK_L_(0x47, 0x37)
#define REG_SC_BK47_37_H      _PK_H_(0x47, 0x37)
#define REG_SC_BK47_38_L      _PK_L_(0x47, 0x38)
#define REG_SC_BK47_38_H      _PK_H_(0x47, 0x38)
#define REG_SC_BK47_39_L      _PK_L_(0x47, 0x39)
#define REG_SC_BK47_39_H      _PK_H_(0x47, 0x39)
#define REG_SC_BK47_3A_L      _PK_L_(0x47, 0x3A)
#define REG_SC_BK47_3A_H      _PK_H_(0x47, 0x3A)
#define REG_SC_BK47_3B_L      _PK_L_(0x47, 0x3B)
#define REG_SC_BK47_3B_H      _PK_H_(0x47, 0x3B)
#define REG_SC_BK47_3C_L      _PK_L_(0x47, 0x3C)
#define REG_SC_BK47_3C_H      _PK_H_(0x47, 0x3C)
#define REG_SC_BK47_3D_L      _PK_L_(0x47, 0x3D)
#define REG_SC_BK47_3D_H      _PK_H_(0x47, 0x3D)
#define REG_SC_BK47_3E_L      _PK_L_(0x47, 0x3E)
#define REG_SC_BK47_3E_H      _PK_H_(0x47, 0x3E)
#define REG_SC_BK47_3F_L      _PK_L_(0x47, 0x3F)
#define REG_SC_BK47_3F_H      _PK_H_(0x47, 0x3F)
#define REG_SC_BK47_40_L      _PK_L_(0x47, 0x40)
#define REG_SC_BK47_40_H      _PK_H_(0x47, 0x40)
#define REG_SC_BK47_41_L      _PK_L_(0x47, 0x41)
#define REG_SC_BK47_41_H      _PK_H_(0x47, 0x41)
#define REG_SC_BK47_42_L      _PK_L_(0x47, 0x42)
#define REG_SC_BK47_42_H      _PK_H_(0x47, 0x42)
#define REG_SC_BK47_43_L      _PK_L_(0x47, 0x43)
#define REG_SC_BK47_43_H      _PK_H_(0x47, 0x43)
#define REG_SC_BK47_44_L      _PK_L_(0x47, 0x44)
#define REG_SC_BK47_44_H      _PK_H_(0x47, 0x44)
#define REG_SC_BK47_45_L      _PK_L_(0x47, 0x45)
#define REG_SC_BK47_45_H      _PK_H_(0x47, 0x45)
#define REG_SC_BK47_46_L      _PK_L_(0x47, 0x46)
#define REG_SC_BK47_46_H      _PK_H_(0x47, 0x46)
#define REG_SC_BK47_47_L      _PK_L_(0x47, 0x47)
#define REG_SC_BK47_47_H      _PK_H_(0x47, 0x47)
#define REG_SC_BK47_48_L      _PK_L_(0x47, 0x48)
#define REG_SC_BK47_48_H      _PK_H_(0x47, 0x48)
#define REG_SC_BK47_49_L      _PK_L_(0x47, 0x49)
#define REG_SC_BK47_49_H      _PK_H_(0x47, 0x49)
#define REG_SC_BK47_4A_L      _PK_L_(0x47, 0x4A)
#define REG_SC_BK47_4A_H      _PK_H_(0x47, 0x4A)
#define REG_SC_BK47_4B_L      _PK_L_(0x47, 0x4B)
#define REG_SC_BK47_4B_H      _PK_H_(0x47, 0x4B)
#define REG_SC_BK47_4C_L      _PK_L_(0x47, 0x4C)
#define REG_SC_BK47_4C_H      _PK_H_(0x47, 0x4C)
#define REG_SC_BK47_4D_L      _PK_L_(0x47, 0x4D)
#define REG_SC_BK47_4D_H      _PK_H_(0x47, 0x4D)
#define REG_SC_BK47_4E_L      _PK_L_(0x47, 0x4E)
#define REG_SC_BK47_4E_H      _PK_H_(0x47, 0x4E)
#define REG_SC_BK47_4F_L      _PK_L_(0x47, 0x4F)
#define REG_SC_BK47_4F_H      _PK_H_(0x47, 0x4F)
#define REG_SC_BK47_50_L      _PK_L_(0x47, 0x50)
#define REG_SC_BK47_50_H      _PK_H_(0x47, 0x50)
#define REG_SC_BK47_51_L      _PK_L_(0x47, 0x51)
#define REG_SC_BK47_51_H      _PK_H_(0x47, 0x51)
#define REG_SC_BK47_52_L      _PK_L_(0x47, 0x52)
#define REG_SC_BK47_52_H      _PK_H_(0x47, 0x52)
#define REG_SC_BK47_53_L      _PK_L_(0x47, 0x53)
#define REG_SC_BK47_53_H      _PK_H_(0x47, 0x53)
#define REG_SC_BK47_54_L      _PK_L_(0x47, 0x54)
#define REG_SC_BK47_54_H      _PK_H_(0x47, 0x54)
#define REG_SC_BK47_55_L      _PK_L_(0x47, 0x55)
#define REG_SC_BK47_55_H      _PK_H_(0x47, 0x55)
#define REG_SC_BK47_56_L      _PK_L_(0x47, 0x56)
#define REG_SC_BK47_56_H      _PK_H_(0x47, 0x56)
#define REG_SC_BK47_57_L      _PK_L_(0x47, 0x57)
#define REG_SC_BK47_57_H      _PK_H_(0x47, 0x57)
#define REG_SC_BK47_58_L      _PK_L_(0x47, 0x58)
#define REG_SC_BK47_58_H      _PK_H_(0x47, 0x58)
#define REG_SC_BK47_59_L      _PK_L_(0x47, 0x59)
#define REG_SC_BK47_59_H      _PK_H_(0x47, 0x59)
#define REG_SC_BK47_5A_L      _PK_L_(0x47, 0x5A)
#define REG_SC_BK47_5A_H      _PK_H_(0x47, 0x5A)
#define REG_SC_BK47_5B_L      _PK_L_(0x47, 0x5B)
#define REG_SC_BK47_5B_H      _PK_H_(0x47, 0x5B)
#define REG_SC_BK47_5C_L      _PK_L_(0x47, 0x5C)
#define REG_SC_BK47_5C_H      _PK_H_(0x47, 0x5C)
#define REG_SC_BK47_5D_L      _PK_L_(0x47, 0x5D)
#define REG_SC_BK47_5D_H      _PK_H_(0x47, 0x5D)
#define REG_SC_BK47_5E_L      _PK_L_(0x47, 0x5E)
#define REG_SC_BK47_5E_H      _PK_H_(0x47, 0x5E)
#define REG_SC_BK47_5F_L      _PK_L_(0x47, 0x5F)
#define REG_SC_BK47_5F_H      _PK_H_(0x47, 0x5F)
#define REG_SC_BK47_60_L      _PK_L_(0x47, 0x60)
#define REG_SC_BK47_60_H      _PK_H_(0x47, 0x60)
#define REG_SC_BK47_61_L      _PK_L_(0x47, 0x61)
#define REG_SC_BK47_61_H      _PK_H_(0x47, 0x61)
#define REG_SC_BK47_62_L      _PK_L_(0x47, 0x62)
#define REG_SC_BK47_62_H      _PK_H_(0x47, 0x62)
#define REG_SC_BK47_63_L      _PK_L_(0x47, 0x63)
#define REG_SC_BK47_63_H      _PK_H_(0x47, 0x63)
#define REG_SC_BK47_64_L      _PK_L_(0x47, 0x64)
#define REG_SC_BK47_64_H      _PK_H_(0x47, 0x64)
#define REG_SC_BK47_65_L      _PK_L_(0x47, 0x65)
#define REG_SC_BK47_65_H      _PK_H_(0x47, 0x65)
#define REG_SC_BK47_66_L      _PK_L_(0x47, 0x66)
#define REG_SC_BK47_66_H      _PK_H_(0x47, 0x66)
#define REG_SC_BK47_67_L      _PK_L_(0x47, 0x67)
#define REG_SC_BK47_67_H      _PK_H_(0x47, 0x67)
#define REG_SC_BK47_68_L      _PK_L_(0x47, 0x68)
#define REG_SC_BK47_68_H      _PK_H_(0x47, 0x68)
#define REG_SC_BK47_69_L      _PK_L_(0x47, 0x69)
#define REG_SC_BK47_69_H      _PK_H_(0x47, 0x69)
#define REG_SC_BK47_6A_L      _PK_L_(0x47, 0x6A)
#define REG_SC_BK47_6A_H      _PK_H_(0x47, 0x6A)
#define REG_SC_BK47_6B_L      _PK_L_(0x47, 0x6B)
#define REG_SC_BK47_6B_H      _PK_H_(0x47, 0x6B)
#define REG_SC_BK47_6C_L      _PK_L_(0x47, 0x6C)
#define REG_SC_BK47_6C_H      _PK_H_(0x47, 0x6C)
#define REG_SC_BK47_6D_L      _PK_L_(0x47, 0x6D)
#define REG_SC_BK47_6D_H      _PK_H_(0x47, 0x6D)
#define REG_SC_BK47_6E_L      _PK_L_(0x47, 0x6E)
#define REG_SC_BK47_6E_H      _PK_H_(0x47, 0x6E)
#define REG_SC_BK47_6F_L      _PK_L_(0x47, 0x6F)
#define REG_SC_BK47_6F_H      _PK_H_(0x47, 0x6F)
#define REG_SC_BK47_70_L      _PK_L_(0x47, 0x70)
#define REG_SC_BK47_70_H      _PK_H_(0x47, 0x70)
#define REG_SC_BK47_71_L      _PK_L_(0x47, 0x71)
#define REG_SC_BK47_71_H      _PK_H_(0x47, 0x71)
#define REG_SC_BK47_72_L      _PK_L_(0x47, 0x72)
#define REG_SC_BK47_72_H      _PK_H_(0x47, 0x72)
#define REG_SC_BK47_73_L      _PK_L_(0x47, 0x73)
#define REG_SC_BK47_73_H      _PK_H_(0x47, 0x73)
#define REG_SC_BK47_74_L      _PK_L_(0x47, 0x74)
#define REG_SC_BK47_74_H      _PK_H_(0x47, 0x74)
#define REG_SC_BK47_75_L      _PK_L_(0x47, 0x75)
#define REG_SC_BK47_75_H      _PK_H_(0x47, 0x75)
#define REG_SC_BK47_76_L      _PK_L_(0x47, 0x76)
#define REG_SC_BK47_76_H      _PK_H_(0x47, 0x76)
#define REG_SC_BK47_77_L      _PK_L_(0x47, 0x77)
#define REG_SC_BK47_77_H      _PK_H_(0x47, 0x77)
#define REG_SC_BK47_78_L      _PK_L_(0x47, 0x78)
#define REG_SC_BK47_78_H      _PK_H_(0x47, 0x78)
#define REG_SC_BK47_79_L      _PK_L_(0x47, 0x79)
#define REG_SC_BK47_79_H      _PK_H_(0x47, 0x79)
#define REG_SC_BK47_7A_L      _PK_L_(0x47, 0x7A)
#define REG_SC_BK47_7A_H      _PK_H_(0x47, 0x7A)
#define REG_SC_BK47_7B_L      _PK_L_(0x47, 0x7B)
#define REG_SC_BK47_7B_H      _PK_H_(0x47, 0x7B)
#define REG_SC_BK47_7C_L      _PK_L_(0x47, 0x7C)
#define REG_SC_BK47_7C_H      _PK_H_(0x47, 0x7C)
#define REG_SC_BK47_7D_L      _PK_L_(0x47, 0x7D)
#define REG_SC_BK47_7D_H      _PK_H_(0x47, 0x7D)
#define REG_SC_BK47_7E_L      _PK_L_(0x47, 0x7E)
#define REG_SC_BK47_7E_H      _PK_H_(0x47, 0x7E)
#define REG_SC_BK47_7F_L      _PK_L_(0x47, 0x7F)
#define REG_SC_BK47_7F_H      _PK_H_(0x47, 0x7F)
//----------------------------------------------
#define REG_SC_BK4A_00_L      _PK_L_(0x4A, 0x00)
#define REG_SC_BK4A_00_H      _PK_H_(0x4A, 0x00)
#define REG_SC_BK4A_01_L      _PK_L_(0x4A, 0x01)
#define REG_SC_BK4A_01_H      _PK_H_(0x4A, 0x01)
#define REG_SC_BK4A_02_L      _PK_L_(0x4A, 0x02)
#define REG_SC_BK4A_02_H      _PK_H_(0x4A, 0x02)
#define REG_SC_BK4A_03_L      _PK_L_(0x4A, 0x03)
#define REG_SC_BK4A_03_H      _PK_H_(0x4A, 0x03)
#define REG_SC_BK4A_04_L      _PK_L_(0x4A, 0x04)
#define REG_SC_BK4A_04_H      _PK_H_(0x4A, 0x04)
#define REG_SC_BK4A_05_L      _PK_L_(0x4A, 0x05)
#define REG_SC_BK4A_05_H      _PK_H_(0x4A, 0x05)
#define REG_SC_BK4A_06_L      _PK_L_(0x4A, 0x06)
#define REG_SC_BK4A_06_H      _PK_H_(0x4A, 0x06)
#define REG_SC_BK4A_07_L      _PK_L_(0x4A, 0x07)
#define REG_SC_BK4A_07_H      _PK_H_(0x4A, 0x07)
#define REG_SC_BK4A_08_L      _PK_L_(0x4A, 0x08)
#define REG_SC_BK4A_08_H      _PK_H_(0x4A, 0x08)
#define REG_SC_BK4A_09_L      _PK_L_(0x4A, 0x09)
#define REG_SC_BK4A_09_H      _PK_H_(0x4A, 0x09)
#define REG_SC_BK4A_0A_L      _PK_L_(0x4A, 0x0A)
#define REG_SC_BK4A_0A_H      _PK_H_(0x4A, 0x0A)
#define REG_SC_BK4A_0B_L      _PK_L_(0x4A, 0x0B)
#define REG_SC_BK4A_0B_H      _PK_H_(0x4A, 0x0B)
#define REG_SC_BK4A_0C_L      _PK_L_(0x4A, 0x0C)
#define REG_SC_BK4A_0C_H      _PK_H_(0x4A, 0x0C)
#define REG_SC_BK4A_0D_L      _PK_L_(0x4A, 0x0D)
#define REG_SC_BK4A_0D_H      _PK_H_(0x4A, 0x0D)
#define REG_SC_BK4A_0E_L      _PK_L_(0x4A, 0x0E)
#define REG_SC_BK4A_0E_H      _PK_H_(0x4A, 0x0E)
#define REG_SC_BK4A_0F_L      _PK_L_(0x4A, 0x0F)
#define REG_SC_BK4A_0F_H      _PK_H_(0x4A, 0x0F)
#define REG_SC_BK4A_10_L      _PK_L_(0x4A, 0x10)
#define REG_SC_BK4A_10_H      _PK_H_(0x4A, 0x10)
#define REG_SC_BK4A_11_L      _PK_L_(0x4A, 0x11)
#define REG_SC_BK4A_11_H      _PK_H_(0x4A, 0x11)
#define REG_SC_BK4A_12_L      _PK_L_(0x4A, 0x12)
#define REG_SC_BK4A_12_H      _PK_H_(0x4A, 0x12)
#define REG_SC_BK4A_13_L      _PK_L_(0x4A, 0x13)
#define REG_SC_BK4A_13_H      _PK_H_(0x4A, 0x13)
#define REG_SC_BK4A_14_L      _PK_L_(0x4A, 0x14)
#define REG_SC_BK4A_14_H      _PK_H_(0x4A, 0x14)
#define REG_SC_BK4A_15_L      _PK_L_(0x4A, 0x15)
#define REG_SC_BK4A_15_H      _PK_H_(0x4A, 0x15)
#define REG_SC_BK4A_16_L      _PK_L_(0x4A, 0x16)
#define REG_SC_BK4A_16_H      _PK_H_(0x4A, 0x16)
#define REG_SC_BK4A_17_L      _PK_L_(0x4A, 0x17)
#define REG_SC_BK4A_17_H      _PK_H_(0x4A, 0x17)
#define REG_SC_BK4A_18_L      _PK_L_(0x4A, 0x18)
#define REG_SC_BK4A_18_H      _PK_H_(0x4A, 0x18)
#define REG_SC_BK4A_19_L      _PK_L_(0x4A, 0x19)
#define REG_SC_BK4A_19_H      _PK_H_(0x4A, 0x19)
#define REG_SC_BK4A_1A_L      _PK_L_(0x4A, 0x1A)
#define REG_SC_BK4A_1A_H      _PK_H_(0x4A, 0x1A)
#define REG_SC_BK4A_1B_L      _PK_L_(0x4A, 0x1B)
#define REG_SC_BK4A_1B_H      _PK_H_(0x4A, 0x1B)
#define REG_SC_BK4A_1C_L      _PK_L_(0x4A, 0x1C)
#define REG_SC_BK4A_1C_H      _PK_H_(0x4A, 0x1C)
#define REG_SC_BK4A_1D_L      _PK_L_(0x4A, 0x1D)
#define REG_SC_BK4A_1D_H      _PK_H_(0x4A, 0x1D)
#define REG_SC_BK4A_1E_L      _PK_L_(0x4A, 0x1E)
#define REG_SC_BK4A_1E_H      _PK_H_(0x4A, 0x1E)
#define REG_SC_BK4A_1F_L      _PK_L_(0x4A, 0x1F)
#define REG_SC_BK4A_1F_H      _PK_H_(0x4A, 0x1F)
#define REG_SC_BK4A_20_L      _PK_L_(0x4A, 0x20)
#define REG_SC_BK4A_20_H      _PK_H_(0x4A, 0x20)
#define REG_SC_BK4A_21_L      _PK_L_(0x4A, 0x21)
#define REG_SC_BK4A_21_H      _PK_H_(0x4A, 0x21)
#define REG_SC_BK4A_22_L      _PK_L_(0x4A, 0x22)
#define REG_SC_BK4A_22_H      _PK_H_(0x4A, 0x22)
#define REG_SC_BK4A_23_L      _PK_L_(0x4A, 0x23)
#define REG_SC_BK4A_23_H      _PK_H_(0x4A, 0x23)
#define REG_SC_BK4A_24_L      _PK_L_(0x4A, 0x24)
#define REG_SC_BK4A_24_H      _PK_H_(0x4A, 0x24)
#define REG_SC_BK4A_25_L      _PK_L_(0x4A, 0x25)
#define REG_SC_BK4A_25_H      _PK_H_(0x4A, 0x25)
#define REG_SC_BK4A_26_L      _PK_L_(0x4A, 0x26)
#define REG_SC_BK4A_26_H      _PK_H_(0x4A, 0x26)
#define REG_SC_BK4A_27_L      _PK_L_(0x4A, 0x27)
#define REG_SC_BK4A_27_H      _PK_H_(0x4A, 0x27)
#define REG_SC_BK4A_28_L      _PK_L_(0x4A, 0x28)
#define REG_SC_BK4A_28_H      _PK_H_(0x4A, 0x28)
#define REG_SC_BK4A_29_L      _PK_L_(0x4A, 0x29)
#define REG_SC_BK4A_29_H      _PK_H_(0x4A, 0x29)
#define REG_SC_BK4A_2A_L      _PK_L_(0x4A, 0x2A)
#define REG_SC_BK4A_2A_H      _PK_H_(0x4A, 0x2A)
#define REG_SC_BK4A_2B_L      _PK_L_(0x4A, 0x2B)
#define REG_SC_BK4A_2B_H      _PK_H_(0x4A, 0x2B)
#define REG_SC_BK4A_2C_L      _PK_L_(0x4A, 0x2C)
#define REG_SC_BK4A_2C_H      _PK_H_(0x4A, 0x2C)
#define REG_SC_BK4A_2D_L      _PK_L_(0x4A, 0x2D)
#define REG_SC_BK4A_2D_H      _PK_H_(0x4A, 0x2D)
#define REG_SC_BK4A_2E_L      _PK_L_(0x4A, 0x2E)
#define REG_SC_BK4A_2E_H      _PK_H_(0x4A, 0x2E)
#define REG_SC_BK4A_2F_L      _PK_L_(0x4A, 0x2F)
#define REG_SC_BK4A_2F_H      _PK_H_(0x4A, 0x2F)
#define REG_SC_BK4A_30_L      _PK_L_(0x4A, 0x30)
#define REG_SC_BK4A_30_H      _PK_H_(0x4A, 0x30)
#define REG_SC_BK4A_31_L      _PK_L_(0x4A, 0x31)
#define REG_SC_BK4A_31_H      _PK_H_(0x4A, 0x31)
#define REG_SC_BK4A_32_L      _PK_L_(0x4A, 0x32)
#define REG_SC_BK4A_32_H      _PK_H_(0x4A, 0x32)
#define REG_SC_BK4A_33_L      _PK_L_(0x4A, 0x33)
#define REG_SC_BK4A_33_H      _PK_H_(0x4A, 0x33)
#define REG_SC_BK4A_34_L      _PK_L_(0x4A, 0x34)
#define REG_SC_BK4A_34_H      _PK_H_(0x4A, 0x34)
#define REG_SC_BK4A_35_L      _PK_L_(0x4A, 0x35)
#define REG_SC_BK4A_35_H      _PK_H_(0x4A, 0x35)
#define REG_SC_BK4A_36_L      _PK_L_(0x4A, 0x36)
#define REG_SC_BK4A_36_H      _PK_H_(0x4A, 0x36)
#define REG_SC_BK4A_37_L      _PK_L_(0x4A, 0x37)
#define REG_SC_BK4A_37_H      _PK_H_(0x4A, 0x37)
#define REG_SC_BK4A_38_L      _PK_L_(0x4A, 0x38)
#define REG_SC_BK4A_38_H      _PK_H_(0x4A, 0x38)
#define REG_SC_BK4A_39_L      _PK_L_(0x4A, 0x39)
#define REG_SC_BK4A_39_H      _PK_H_(0x4A, 0x39)
#define REG_SC_BK4A_3A_L      _PK_L_(0x4A, 0x3A)
#define REG_SC_BK4A_3A_H      _PK_H_(0x4A, 0x3A)
#define REG_SC_BK4A_3B_L      _PK_L_(0x4A, 0x3B)
#define REG_SC_BK4A_3B_H      _PK_H_(0x4A, 0x3B)
#define REG_SC_BK4A_3C_L      _PK_L_(0x4A, 0x3C)
#define REG_SC_BK4A_3C_H      _PK_H_(0x4A, 0x3C)
#define REG_SC_BK4A_3D_L      _PK_L_(0x4A, 0x3D)
#define REG_SC_BK4A_3D_H      _PK_H_(0x4A, 0x3D)
#define REG_SC_BK4A_3E_L      _PK_L_(0x4A, 0x3E)
#define REG_SC_BK4A_3E_H      _PK_H_(0x4A, 0x3E)
#define REG_SC_BK4A_3F_L      _PK_L_(0x4A, 0x3F)
#define REG_SC_BK4A_3F_H      _PK_H_(0x4A, 0x3F)
#define REG_SC_BK4A_40_L      _PK_L_(0x4A, 0x40)
#define REG_SC_BK4A_40_H      _PK_H_(0x4A, 0x40)
#define REG_SC_BK4A_41_L      _PK_L_(0x4A, 0x41)
#define REG_SC_BK4A_41_H      _PK_H_(0x4A, 0x41)
#define REG_SC_BK4A_42_L      _PK_L_(0x4A, 0x42)
#define REG_SC_BK4A_42_H      _PK_H_(0x4A, 0x42)
#define REG_SC_BK4A_43_L      _PK_L_(0x4A, 0x43)
#define REG_SC_BK4A_43_H      _PK_H_(0x4A, 0x43)
#define REG_SC_BK4A_44_L      _PK_L_(0x4A, 0x44)
#define REG_SC_BK4A_44_H      _PK_H_(0x4A, 0x44)
#define REG_SC_BK4A_45_L      _PK_L_(0x4A, 0x45)
#define REG_SC_BK4A_45_H      _PK_H_(0x4A, 0x45)
#define REG_SC_BK4A_46_L      _PK_L_(0x4A, 0x46)
#define REG_SC_BK4A_46_H      _PK_H_(0x4A, 0x46)
#define REG_SC_BK4A_47_L      _PK_L_(0x4A, 0x47)
#define REG_SC_BK4A_47_H      _PK_H_(0x4A, 0x47)
#define REG_SC_BK4A_48_L      _PK_L_(0x4A, 0x48)
#define REG_SC_BK4A_48_H      _PK_H_(0x4A, 0x48)
#define REG_SC_BK4A_49_L      _PK_L_(0x4A, 0x49)
#define REG_SC_BK4A_49_H      _PK_H_(0x4A, 0x49)
#define REG_SC_BK4A_4A_L      _PK_L_(0x4A, 0x4A)
#define REG_SC_BK4A_4A_H      _PK_H_(0x4A, 0x4A)
#define REG_SC_BK4A_4B_L      _PK_L_(0x4A, 0x4B)
#define REG_SC_BK4A_4B_H      _PK_H_(0x4A, 0x4B)
#define REG_SC_BK4A_4C_L      _PK_L_(0x4A, 0x4C)
#define REG_SC_BK4A_4C_H      _PK_H_(0x4A, 0x4C)
#define REG_SC_BK4A_4D_L      _PK_L_(0x4A, 0x4D)
#define REG_SC_BK4A_4D_H      _PK_H_(0x4A, 0x4D)
#define REG_SC_BK4A_4E_L      _PK_L_(0x4A, 0x4E)
#define REG_SC_BK4A_4E_H      _PK_H_(0x4A, 0x4E)
#define REG_SC_BK4A_4F_L      _PK_L_(0x4A, 0x4F)
#define REG_SC_BK4A_4F_H      _PK_H_(0x4A, 0x4F)
#define REG_SC_BK4A_50_L      _PK_L_(0x4A, 0x50)
#define REG_SC_BK4A_50_H      _PK_H_(0x4A, 0x50)
#define REG_SC_BK4A_51_L      _PK_L_(0x4A, 0x51)
#define REG_SC_BK4A_51_H      _PK_H_(0x4A, 0x51)
#define REG_SC_BK4A_52_L      _PK_L_(0x4A, 0x52)
#define REG_SC_BK4A_52_H      _PK_H_(0x4A, 0x52)
#define REG_SC_BK4A_53_L      _PK_L_(0x4A, 0x53)
#define REG_SC_BK4A_53_H      _PK_H_(0x4A, 0x53)
#define REG_SC_BK4A_54_L      _PK_L_(0x4A, 0x54)
#define REG_SC_BK4A_54_H      _PK_H_(0x4A, 0x54)
#define REG_SC_BK4A_55_L      _PK_L_(0x4A, 0x55)
#define REG_SC_BK4A_55_H      _PK_H_(0x4A, 0x55)
#define REG_SC_BK4A_56_L      _PK_L_(0x4A, 0x56)
#define REG_SC_BK4A_56_H      _PK_H_(0x4A, 0x56)
#define REG_SC_BK4A_57_L      _PK_L_(0x4A, 0x57)
#define REG_SC_BK4A_57_H      _PK_H_(0x4A, 0x57)
#define REG_SC_BK4A_58_L      _PK_L_(0x4A, 0x58)
#define REG_SC_BK4A_58_H      _PK_H_(0x4A, 0x58)
#define REG_SC_BK4A_59_L      _PK_L_(0x4A, 0x59)
#define REG_SC_BK4A_59_H      _PK_H_(0x4A, 0x59)
#define REG_SC_BK4A_5A_L      _PK_L_(0x4A, 0x5A)
#define REG_SC_BK4A_5A_H      _PK_H_(0x4A, 0x5A)
#define REG_SC_BK4A_5B_L      _PK_L_(0x4A, 0x5B)
#define REG_SC_BK4A_5B_H      _PK_H_(0x4A, 0x5B)
#define REG_SC_BK4A_5C_L      _PK_L_(0x4A, 0x5C)
#define REG_SC_BK4A_5C_H      _PK_H_(0x4A, 0x5C)
#define REG_SC_BK4A_5D_L      _PK_L_(0x4A, 0x5D)
#define REG_SC_BK4A_5D_H      _PK_H_(0x4A, 0x5D)
#define REG_SC_BK4A_5E_L      _PK_L_(0x4A, 0x5E)
#define REG_SC_BK4A_5E_H      _PK_H_(0x4A, 0x5E)
#define REG_SC_BK4A_5F_L      _PK_L_(0x4A, 0x5F)
#define REG_SC_BK4A_5F_H      _PK_H_(0x4A, 0x5F)
#define REG_SC_BK4A_60_L      _PK_L_(0x4A, 0x60)
#define REG_SC_BK4A_60_H      _PK_H_(0x4A, 0x60)
#define REG_SC_BK4A_61_L      _PK_L_(0x4A, 0x61)
#define REG_SC_BK4A_61_H      _PK_H_(0x4A, 0x61)
#define REG_SC_BK4A_62_L      _PK_L_(0x4A, 0x62)
#define REG_SC_BK4A_62_H      _PK_H_(0x4A, 0x62)
#define REG_SC_BK4A_63_L      _PK_L_(0x4A, 0x63)
#define REG_SC_BK4A_63_H      _PK_H_(0x4A, 0x63)
#define REG_SC_BK4A_64_L      _PK_L_(0x4A, 0x64)
#define REG_SC_BK4A_64_H      _PK_H_(0x4A, 0x64)
#define REG_SC_BK4A_65_L      _PK_L_(0x4A, 0x65)
#define REG_SC_BK4A_65_H      _PK_H_(0x4A, 0x65)
#define REG_SC_BK4A_66_L      _PK_L_(0x4A, 0x66)
#define REG_SC_BK4A_66_H      _PK_H_(0x4A, 0x66)
#define REG_SC_BK4A_67_L      _PK_L_(0x4A, 0x67)
#define REG_SC_BK4A_67_H      _PK_H_(0x4A, 0x67)
#define REG_SC_BK4A_68_L      _PK_L_(0x4A, 0x68)
#define REG_SC_BK4A_68_H      _PK_H_(0x4A, 0x68)
#define REG_SC_BK4A_69_L      _PK_L_(0x4A, 0x69)
#define REG_SC_BK4A_69_H      _PK_H_(0x4A, 0x69)
#define REG_SC_BK4A_6A_L      _PK_L_(0x4A, 0x6A)
#define REG_SC_BK4A_6A_H      _PK_H_(0x4A, 0x6A)
#define REG_SC_BK4A_6B_L      _PK_L_(0x4A, 0x6B)
#define REG_SC_BK4A_6B_H      _PK_H_(0x4A, 0x6B)
#define REG_SC_BK4A_6C_L      _PK_L_(0x4A, 0x6C)
#define REG_SC_BK4A_6C_H      _PK_H_(0x4A, 0x6C)
#define REG_SC_BK4A_6D_L      _PK_L_(0x4A, 0x6D)
#define REG_SC_BK4A_6D_H      _PK_H_(0x4A, 0x6D)
#define REG_SC_BK4A_6E_L      _PK_L_(0x4A, 0x6E)
#define REG_SC_BK4A_6E_H      _PK_H_(0x4A, 0x6E)
#define REG_SC_BK4A_6F_L      _PK_L_(0x4A, 0x6F)
#define REG_SC_BK4A_6F_H      _PK_H_(0x4A, 0x6F)
#define REG_SC_BK4A_70_L      _PK_L_(0x4A, 0x70)
#define REG_SC_BK4A_70_H      _PK_H_(0x4A, 0x70)
#define REG_SC_BK4A_71_L      _PK_L_(0x4A, 0x71)
#define REG_SC_BK4A_71_H      _PK_H_(0x4A, 0x71)
#define REG_SC_BK4A_72_L      _PK_L_(0x4A, 0x72)
#define REG_SC_BK4A_72_H      _PK_H_(0x4A, 0x72)
#define REG_SC_BK4A_73_L      _PK_L_(0x4A, 0x73)
#define REG_SC_BK4A_73_H      _PK_H_(0x4A, 0x73)
#define REG_SC_BK4A_74_L      _PK_L_(0x4A, 0x74)
#define REG_SC_BK4A_74_H      _PK_H_(0x4A, 0x74)
#define REG_SC_BK4A_75_L      _PK_L_(0x4A, 0x75)
#define REG_SC_BK4A_75_H      _PK_H_(0x4A, 0x75)
#define REG_SC_BK4A_76_L      _PK_L_(0x4A, 0x76)
#define REG_SC_BK4A_76_H      _PK_H_(0x4A, 0x76)
#define REG_SC_BK4A_77_L      _PK_L_(0x4A, 0x77)
#define REG_SC_BK4A_77_H      _PK_H_(0x4A, 0x77)
#define REG_SC_BK4A_78_L      _PK_L_(0x4A, 0x78)
#define REG_SC_BK4A_78_H      _PK_H_(0x4A, 0x78)
#define REG_SC_BK4A_79_L      _PK_L_(0x4A, 0x79)
#define REG_SC_BK4A_79_H      _PK_H_(0x4A, 0x79)
#define REG_SC_BK4A_7A_L      _PK_L_(0x4A, 0x7A)
#define REG_SC_BK4A_7A_H      _PK_H_(0x4A, 0x7A)
#define REG_SC_BK4A_7B_L      _PK_L_(0x4A, 0x7B)
#define REG_SC_BK4A_7B_H      _PK_H_(0x4A, 0x7B)
#define REG_SC_BK4A_7C_L      _PK_L_(0x4A, 0x7C)
#define REG_SC_BK4A_7C_H      _PK_H_(0x4A, 0x7C)
#define REG_SC_BK4A_7D_L      _PK_L_(0x4A, 0x7D)
#define REG_SC_BK4A_7D_H      _PK_H_(0x4A, 0x7D)
#define REG_SC_BK4A_7E_L      _PK_L_(0x4A, 0x7E)
#define REG_SC_BK4A_7E_H      _PK_H_(0x4A, 0x7E)
#define REG_SC_BK4A_7F_L      _PK_L_(0x4A, 0x7F)
#define REG_SC_BK4A_7F_H      _PK_H_(0x4A, 0x7F)
//----------------------------------------------
#define REG_SC_BK4C_00_L      _PK_L_(0x4C, 0x00)
#define REG_SC_BK4C_00_H      _PK_H_(0x4C, 0x00)
#define REG_SC_BK4C_01_L      _PK_L_(0x4C, 0x01)
#define REG_SC_BK4C_01_H      _PK_H_(0x4C, 0x01)
#define REG_SC_BK4C_02_L      _PK_L_(0x4C, 0x02)
#define REG_SC_BK4C_02_H      _PK_H_(0x4C, 0x02)
#define REG_SC_BK4C_03_L      _PK_L_(0x4C, 0x03)
#define REG_SC_BK4C_03_H      _PK_H_(0x4C, 0x03)
#define REG_SC_BK4C_04_L      _PK_L_(0x4C, 0x04)
#define REG_SC_BK4C_04_H      _PK_H_(0x4C, 0x04)
#define REG_SC_BK4C_05_L      _PK_L_(0x4C, 0x05)
#define REG_SC_BK4C_05_H      _PK_H_(0x4C, 0x05)
#define REG_SC_BK4C_06_L      _PK_L_(0x4C, 0x06)
#define REG_SC_BK4C_06_H      _PK_H_(0x4C, 0x06)
#define REG_SC_BK4C_07_L      _PK_L_(0x4C, 0x07)
#define REG_SC_BK4C_07_H      _PK_H_(0x4C, 0x07)
#define REG_SC_BK4C_08_L      _PK_L_(0x4C, 0x08)
#define REG_SC_BK4C_08_H      _PK_H_(0x4C, 0x08)
#define REG_SC_BK4C_09_L      _PK_L_(0x4C, 0x09)
#define REG_SC_BK4C_09_H      _PK_H_(0x4C, 0x09)
#define REG_SC_BK4C_0A_L      _PK_L_(0x4C, 0x0A)
#define REG_SC_BK4C_0A_H      _PK_H_(0x4C, 0x0A)
#define REG_SC_BK4C_0B_L      _PK_L_(0x4C, 0x0B)
#define REG_SC_BK4C_0B_H      _PK_H_(0x4C, 0x0B)
#define REG_SC_BK4C_0C_L      _PK_L_(0x4C, 0x0C)
#define REG_SC_BK4C_0C_H      _PK_H_(0x4C, 0x0C)
#define REG_SC_BK4C_0D_L      _PK_L_(0x4C, 0x0D)
#define REG_SC_BK4C_0D_H      _PK_H_(0x4C, 0x0D)
#define REG_SC_BK4C_0E_L      _PK_L_(0x4C, 0x0E)
#define REG_SC_BK4C_0E_H      _PK_H_(0x4C, 0x0E)
#define REG_SC_BK4C_0F_L      _PK_L_(0x4C, 0x0F)
#define REG_SC_BK4C_0F_H      _PK_H_(0x4C, 0x0F)
#define REG_SC_BK4C_10_L      _PK_L_(0x4C, 0x10)
#define REG_SC_BK4C_10_H      _PK_H_(0x4C, 0x10)
#define REG_SC_BK4C_11_L      _PK_L_(0x4C, 0x11)
#define REG_SC_BK4C_11_H      _PK_H_(0x4C, 0x11)
#define REG_SC_BK4C_12_L      _PK_L_(0x4C, 0x12)
#define REG_SC_BK4C_12_H      _PK_H_(0x4C, 0x12)
#define REG_SC_BK4C_13_L      _PK_L_(0x4C, 0x13)
#define REG_SC_BK4C_13_H      _PK_H_(0x4C, 0x13)
#define REG_SC_BK4C_14_L      _PK_L_(0x4C, 0x14)
#define REG_SC_BK4C_14_H      _PK_H_(0x4C, 0x14)
#define REG_SC_BK4C_15_L      _PK_L_(0x4C, 0x15)
#define REG_SC_BK4C_15_H      _PK_H_(0x4C, 0x15)
#define REG_SC_BK4C_16_L      _PK_L_(0x4C, 0x16)
#define REG_SC_BK4C_16_H      _PK_H_(0x4C, 0x16)
#define REG_SC_BK4C_17_L      _PK_L_(0x4C, 0x17)
#define REG_SC_BK4C_17_H      _PK_H_(0x4C, 0x17)
#define REG_SC_BK4C_18_L      _PK_L_(0x4C, 0x18)
#define REG_SC_BK4C_18_H      _PK_H_(0x4C, 0x18)
#define REG_SC_BK4C_19_L      _PK_L_(0x4C, 0x19)
#define REG_SC_BK4C_19_H      _PK_H_(0x4C, 0x19)
#define REG_SC_BK4C_1A_L      _PK_L_(0x4C, 0x1A)
#define REG_SC_BK4C_1A_H      _PK_H_(0x4C, 0x1A)
#define REG_SC_BK4C_1B_L      _PK_L_(0x4C, 0x1B)
#define REG_SC_BK4C_1B_H      _PK_H_(0x4C, 0x1B)
#define REG_SC_BK4C_1C_L      _PK_L_(0x4C, 0x1C)
#define REG_SC_BK4C_1C_H      _PK_H_(0x4C, 0x1C)
#define REG_SC_BK4C_1D_L      _PK_L_(0x4C, 0x1D)
#define REG_SC_BK4C_1D_H      _PK_H_(0x4C, 0x1D)
#define REG_SC_BK4C_1E_L      _PK_L_(0x4C, 0x1E)
#define REG_SC_BK4C_1E_H      _PK_H_(0x4C, 0x1E)
#define REG_SC_BK4C_1F_L      _PK_L_(0x4C, 0x1F)
#define REG_SC_BK4C_1F_H      _PK_H_(0x4C, 0x1F)
#define REG_SC_BK4C_20_L      _PK_L_(0x4C, 0x20)
#define REG_SC_BK4C_20_H      _PK_H_(0x4C, 0x20)
#define REG_SC_BK4C_21_L      _PK_L_(0x4C, 0x21)
#define REG_SC_BK4C_21_H      _PK_H_(0x4C, 0x21)
#define REG_SC_BK4C_22_L      _PK_L_(0x4C, 0x22)
#define REG_SC_BK4C_22_H      _PK_H_(0x4C, 0x22)
#define REG_SC_BK4C_23_L      _PK_L_(0x4C, 0x23)
#define REG_SC_BK4C_23_H      _PK_H_(0x4C, 0x23)
#define REG_SC_BK4C_24_L      _PK_L_(0x4C, 0x24)
#define REG_SC_BK4C_24_H      _PK_H_(0x4C, 0x24)
#define REG_SC_BK4C_25_L      _PK_L_(0x4C, 0x25)
#define REG_SC_BK4C_25_H      _PK_H_(0x4C, 0x25)
#define REG_SC_BK4C_26_L      _PK_L_(0x4C, 0x26)
#define REG_SC_BK4C_26_H      _PK_H_(0x4C, 0x26)
#define REG_SC_BK4C_27_L      _PK_L_(0x4C, 0x27)
#define REG_SC_BK4C_27_H      _PK_H_(0x4C, 0x27)
#define REG_SC_BK4C_28_L      _PK_L_(0x4C, 0x28)
#define REG_SC_BK4C_28_H      _PK_H_(0x4C, 0x28)
#define REG_SC_BK4C_29_L      _PK_L_(0x4C, 0x29)
#define REG_SC_BK4C_29_H      _PK_H_(0x4C, 0x29)
#define REG_SC_BK4C_2A_L      _PK_L_(0x4C, 0x2A)
#define REG_SC_BK4C_2A_H      _PK_H_(0x4C, 0x2A)
#define REG_SC_BK4C_2B_L      _PK_L_(0x4C, 0x2B)
#define REG_SC_BK4C_2B_H      _PK_H_(0x4C, 0x2B)
#define REG_SC_BK4C_2C_L      _PK_L_(0x4C, 0x2C)
#define REG_SC_BK4C_2C_H      _PK_H_(0x4C, 0x2C)
#define REG_SC_BK4C_2D_L      _PK_L_(0x4C, 0x2D)
#define REG_SC_BK4C_2D_H      _PK_H_(0x4C, 0x2D)
#define REG_SC_BK4C_2E_L      _PK_L_(0x4C, 0x2E)
#define REG_SC_BK4C_2E_H      _PK_H_(0x4C, 0x2E)
#define REG_SC_BK4C_2F_L      _PK_L_(0x4C, 0x2F)
#define REG_SC_BK4C_2F_H      _PK_H_(0x4C, 0x2F)
#define REG_SC_BK4C_30_L      _PK_L_(0x4C, 0x30)
#define REG_SC_BK4C_30_H      _PK_H_(0x4C, 0x30)
#define REG_SC_BK4C_31_L      _PK_L_(0x4C, 0x31)
#define REG_SC_BK4C_31_H      _PK_H_(0x4C, 0x31)
#define REG_SC_BK4C_32_L      _PK_L_(0x4C, 0x32)
#define REG_SC_BK4C_32_H      _PK_H_(0x4C, 0x32)
#define REG_SC_BK4C_33_L      _PK_L_(0x4C, 0x33)
#define REG_SC_BK4C_33_H      _PK_H_(0x4C, 0x33)
#define REG_SC_BK4C_34_L      _PK_L_(0x4C, 0x34)
#define REG_SC_BK4C_34_H      _PK_H_(0x4C, 0x34)
#define REG_SC_BK4C_35_L      _PK_L_(0x4C, 0x35)
#define REG_SC_BK4C_35_H      _PK_H_(0x4C, 0x35)
#define REG_SC_BK4C_36_L      _PK_L_(0x4C, 0x36)
#define REG_SC_BK4C_36_H      _PK_H_(0x4C, 0x36)
#define REG_SC_BK4C_37_L      _PK_L_(0x4C, 0x37)
#define REG_SC_BK4C_37_H      _PK_H_(0x4C, 0x37)
#define REG_SC_BK4C_38_L      _PK_L_(0x4C, 0x38)
#define REG_SC_BK4C_38_H      _PK_H_(0x4C, 0x38)
#define REG_SC_BK4C_39_L      _PK_L_(0x4C, 0x39)
#define REG_SC_BK4C_39_H      _PK_H_(0x4C, 0x39)
#define REG_SC_BK4C_3A_L      _PK_L_(0x4C, 0x3A)
#define REG_SC_BK4C_3A_H      _PK_H_(0x4C, 0x3A)
#define REG_SC_BK4C_3B_L      _PK_L_(0x4C, 0x3B)
#define REG_SC_BK4C_3B_H      _PK_H_(0x4C, 0x3B)
#define REG_SC_BK4C_3C_L      _PK_L_(0x4C, 0x3C)
#define REG_SC_BK4C_3C_H      _PK_H_(0x4C, 0x3C)
#define REG_SC_BK4C_3D_L      _PK_L_(0x4C, 0x3D)
#define REG_SC_BK4C_3D_H      _PK_H_(0x4C, 0x3D)
#define REG_SC_BK4C_3E_L      _PK_L_(0x4C, 0x3E)
#define REG_SC_BK4C_3E_H      _PK_H_(0x4C, 0x3E)
#define REG_SC_BK4C_3F_L      _PK_L_(0x4C, 0x3F)
#define REG_SC_BK4C_3F_H      _PK_H_(0x4C, 0x3F)
#define REG_SC_BK4C_40_L      _PK_L_(0x4C, 0x40)
#define REG_SC_BK4C_40_H      _PK_H_(0x4C, 0x40)
#define REG_SC_BK4C_41_L      _PK_L_(0x4C, 0x41)
#define REG_SC_BK4C_41_H      _PK_H_(0x4C, 0x41)
#define REG_SC_BK4C_42_L      _PK_L_(0x4C, 0x42)
#define REG_SC_BK4C_42_H      _PK_H_(0x4C, 0x42)
#define REG_SC_BK4C_43_L      _PK_L_(0x4C, 0x43)
#define REG_SC_BK4C_43_H      _PK_H_(0x4C, 0x43)
#define REG_SC_BK4C_44_L      _PK_L_(0x4C, 0x44)
#define REG_SC_BK4C_44_H      _PK_H_(0x4C, 0x44)
#define REG_SC_BK4C_45_L      _PK_L_(0x4C, 0x45)
#define REG_SC_BK4C_45_H      _PK_H_(0x4C, 0x45)
#define REG_SC_BK4C_46_L      _PK_L_(0x4C, 0x46)
#define REG_SC_BK4C_46_H      _PK_H_(0x4C, 0x46)
#define REG_SC_BK4C_47_L      _PK_L_(0x4C, 0x47)
#define REG_SC_BK4C_47_H      _PK_H_(0x4C, 0x47)
#define REG_SC_BK4C_48_L      _PK_L_(0x4C, 0x48)
#define REG_SC_BK4C_48_H      _PK_H_(0x4C, 0x48)
#define REG_SC_BK4C_49_L      _PK_L_(0x4C, 0x49)
#define REG_SC_BK4C_49_H      _PK_H_(0x4C, 0x49)
#define REG_SC_BK4C_4A_L      _PK_L_(0x4C, 0x4A)
#define REG_SC_BK4C_4A_H      _PK_H_(0x4C, 0x4A)
#define REG_SC_BK4C_4B_L      _PK_L_(0x4C, 0x4B)
#define REG_SC_BK4C_4B_H      _PK_H_(0x4C, 0x4B)
#define REG_SC_BK4C_4C_L      _PK_L_(0x4C, 0x4C)
#define REG_SC_BK4C_4C_H      _PK_H_(0x4C, 0x4C)
#define REG_SC_BK4C_4D_L      _PK_L_(0x4C, 0x4D)
#define REG_SC_BK4C_4D_H      _PK_H_(0x4C, 0x4D)
#define REG_SC_BK4C_4E_L      _PK_L_(0x4C, 0x4E)
#define REG_SC_BK4C_4E_H      _PK_H_(0x4C, 0x4E)
#define REG_SC_BK4C_4F_L      _PK_L_(0x4C, 0x4F)
#define REG_SC_BK4C_4F_H      _PK_H_(0x4C, 0x4F)
#define REG_SC_BK4C_50_L      _PK_L_(0x4C, 0x50)
#define REG_SC_BK4C_50_H      _PK_H_(0x4C, 0x50)
#define REG_SC_BK4C_51_L      _PK_L_(0x4C, 0x51)
#define REG_SC_BK4C_51_H      _PK_H_(0x4C, 0x51)
#define REG_SC_BK4C_52_L      _PK_L_(0x4C, 0x52)
#define REG_SC_BK4C_52_H      _PK_H_(0x4C, 0x52)
#define REG_SC_BK4C_53_L      _PK_L_(0x4C, 0x53)
#define REG_SC_BK4C_53_H      _PK_H_(0x4C, 0x53)
#define REG_SC_BK4C_54_L      _PK_L_(0x4C, 0x54)
#define REG_SC_BK4C_54_H      _PK_H_(0x4C, 0x54)
#define REG_SC_BK4C_55_L      _PK_L_(0x4C, 0x55)
#define REG_SC_BK4C_55_H      _PK_H_(0x4C, 0x55)
#define REG_SC_BK4C_56_L      _PK_L_(0x4C, 0x56)
#define REG_SC_BK4C_56_H      _PK_H_(0x4C, 0x56)
#define REG_SC_BK4C_57_L      _PK_L_(0x4C, 0x57)
#define REG_SC_BK4C_57_H      _PK_H_(0x4C, 0x57)
#define REG_SC_BK4C_58_L      _PK_L_(0x4C, 0x58)
#define REG_SC_BK4C_58_H      _PK_H_(0x4C, 0x58)
#define REG_SC_BK4C_59_L      _PK_L_(0x4C, 0x59)
#define REG_SC_BK4C_59_H      _PK_H_(0x4C, 0x59)
#define REG_SC_BK4C_5A_L      _PK_L_(0x4C, 0x5A)
#define REG_SC_BK4C_5A_H      _PK_H_(0x4C, 0x5A)
#define REG_SC_BK4C_5B_L      _PK_L_(0x4C, 0x5B)
#define REG_SC_BK4C_5B_H      _PK_H_(0x4C, 0x5B)
#define REG_SC_BK4C_5C_L      _PK_L_(0x4C, 0x5C)
#define REG_SC_BK4C_5C_H      _PK_H_(0x4C, 0x5C)
#define REG_SC_BK4C_5D_L      _PK_L_(0x4C, 0x5D)
#define REG_SC_BK4C_5D_H      _PK_H_(0x4C, 0x5D)
#define REG_SC_BK4C_5E_L      _PK_L_(0x4C, 0x5E)
#define REG_SC_BK4C_5E_H      _PK_H_(0x4C, 0x5E)
#define REG_SC_BK4C_5F_L      _PK_L_(0x4C, 0x5F)
#define REG_SC_BK4C_5F_H      _PK_H_(0x4C, 0x5F)
#define REG_SC_BK4C_60_L      _PK_L_(0x4C, 0x60)
#define REG_SC_BK4C_60_H      _PK_H_(0x4C, 0x60)
#define REG_SC_BK4C_61_L      _PK_L_(0x4C, 0x61)
#define REG_SC_BK4C_61_H      _PK_H_(0x4C, 0x61)
#define REG_SC_BK4C_62_L      _PK_L_(0x4C, 0x62)
#define REG_SC_BK4C_62_H      _PK_H_(0x4C, 0x62)
#define REG_SC_BK4C_63_L      _PK_L_(0x4C, 0x63)
#define REG_SC_BK4C_63_H      _PK_H_(0x4C, 0x63)
#define REG_SC_BK4C_64_L      _PK_L_(0x4C, 0x64)
#define REG_SC_BK4C_64_H      _PK_H_(0x4C, 0x64)
#define REG_SC_BK4C_65_L      _PK_L_(0x4C, 0x65)
#define REG_SC_BK4C_65_H      _PK_H_(0x4C, 0x65)
#define REG_SC_BK4C_66_L      _PK_L_(0x4C, 0x66)
#define REG_SC_BK4C_66_H      _PK_H_(0x4C, 0x66)
#define REG_SC_BK4C_67_L      _PK_L_(0x4C, 0x67)
#define REG_SC_BK4C_67_H      _PK_H_(0x4C, 0x67)
#define REG_SC_BK4C_68_L      _PK_L_(0x4C, 0x68)
#define REG_SC_BK4C_68_H      _PK_H_(0x4C, 0x68)
#define REG_SC_BK4C_69_L      _PK_L_(0x4C, 0x69)
#define REG_SC_BK4C_69_H      _PK_H_(0x4C, 0x69)
#define REG_SC_BK4C_6A_L      _PK_L_(0x4C, 0x6A)
#define REG_SC_BK4C_6A_H      _PK_H_(0x4C, 0x6A)
#define REG_SC_BK4C_6B_L      _PK_L_(0x4C, 0x6B)
#define REG_SC_BK4C_6B_H      _PK_H_(0x4C, 0x6B)
#define REG_SC_BK4C_6C_L      _PK_L_(0x4C, 0x6C)
#define REG_SC_BK4C_6C_H      _PK_H_(0x4C, 0x6C)
#define REG_SC_BK4C_6D_L      _PK_L_(0x4C, 0x6D)
#define REG_SC_BK4C_6D_H      _PK_H_(0x4C, 0x6D)
#define REG_SC_BK4C_6E_L      _PK_L_(0x4C, 0x6E)
#define REG_SC_BK4C_6E_H      _PK_H_(0x4C, 0x6E)
#define REG_SC_BK4C_6F_L      _PK_L_(0x4C, 0x6F)
#define REG_SC_BK4C_6F_H      _PK_H_(0x4C, 0x6F)
#define REG_SC_BK4C_70_L      _PK_L_(0x4C, 0x70)
#define REG_SC_BK4C_70_H      _PK_H_(0x4C, 0x70)
#define REG_SC_BK4C_71_L      _PK_L_(0x4C, 0x71)
#define REG_SC_BK4C_71_H      _PK_H_(0x4C, 0x71)
#define REG_SC_BK4C_72_L      _PK_L_(0x4C, 0x72)
#define REG_SC_BK4C_72_H      _PK_H_(0x4C, 0x72)
#define REG_SC_BK4C_73_L      _PK_L_(0x4C, 0x73)
#define REG_SC_BK4C_73_H      _PK_H_(0x4C, 0x73)
#define REG_SC_BK4C_74_L      _PK_L_(0x4C, 0x74)
#define REG_SC_BK4C_74_H      _PK_H_(0x4C, 0x74)
#define REG_SC_BK4C_75_L      _PK_L_(0x4C, 0x75)
#define REG_SC_BK4C_75_H      _PK_H_(0x4C, 0x75)
#define REG_SC_BK4C_76_L      _PK_L_(0x4C, 0x76)
#define REG_SC_BK4C_76_H      _PK_H_(0x4C, 0x76)
#define REG_SC_BK4C_77_L      _PK_L_(0x4C, 0x77)
#define REG_SC_BK4C_77_H      _PK_H_(0x4C, 0x77)
#define REG_SC_BK4C_78_L      _PK_L_(0x4C, 0x78)
#define REG_SC_BK4C_78_H      _PK_H_(0x4C, 0x78)
#define REG_SC_BK4C_79_L      _PK_L_(0x4C, 0x79)
#define REG_SC_BK4C_79_H      _PK_H_(0x4C, 0x79)
#define REG_SC_BK4C_7A_L      _PK_L_(0x4C, 0x7A)
#define REG_SC_BK4C_7A_H      _PK_H_(0x4C, 0x7A)
#define REG_SC_BK4C_7B_L      _PK_L_(0x4C, 0x7B)
#define REG_SC_BK4C_7B_H      _PK_H_(0x4C, 0x7B)
#define REG_SC_BK4C_7C_L      _PK_L_(0x4C, 0x7C)
#define REG_SC_BK4C_7C_H      _PK_H_(0x4C, 0x7C)
#define REG_SC_BK4C_7D_L      _PK_L_(0x4C, 0x7D)
#define REG_SC_BK4C_7D_H      _PK_H_(0x4C, 0x7D)
#define REG_SC_BK4C_7E_L      _PK_L_(0x4C, 0x7E)
#define REG_SC_BK4C_7E_H      _PK_H_(0x4C, 0x7E)
#define REG_SC_BK4C_7F_L      _PK_L_(0x4C, 0x7F)
#define REG_SC_BK4C_7F_H      _PK_H_(0x4C, 0x7F)
//----------------------------------------------
#define REG_SC_BK4E_00_L      _PK_L_(0x4E, 0x00)
#define REG_SC_BK4E_00_H      _PK_H_(0x4E, 0x00)
#define REG_SC_BK4E_01_L      _PK_L_(0x4E, 0x01)
#define REG_SC_BK4E_01_H      _PK_H_(0x4E, 0x01)
#define REG_SC_BK4E_02_L      _PK_L_(0x4E, 0x02)
#define REG_SC_BK4E_02_H      _PK_H_(0x4E, 0x02)
#define REG_SC_BK4E_03_L      _PK_L_(0x4E, 0x03)
#define REG_SC_BK4E_03_H      _PK_H_(0x4E, 0x03)
#define REG_SC_BK4E_04_L      _PK_L_(0x4E, 0x04)
#define REG_SC_BK4E_04_H      _PK_H_(0x4E, 0x04)
#define REG_SC_BK4E_05_L      _PK_L_(0x4E, 0x05)
#define REG_SC_BK4E_05_H      _PK_H_(0x4E, 0x05)
#define REG_SC_BK4E_06_L      _PK_L_(0x4E, 0x06)
#define REG_SC_BK4E_06_H      _PK_H_(0x4E, 0x06)
#define REG_SC_BK4E_07_L      _PK_L_(0x4E, 0x07)
#define REG_SC_BK4E_07_H      _PK_H_(0x4E, 0x07)
#define REG_SC_BK4E_08_L      _PK_L_(0x4E, 0x08)
#define REG_SC_BK4E_08_H      _PK_H_(0x4E, 0x08)
#define REG_SC_BK4E_09_L      _PK_L_(0x4E, 0x09)
#define REG_SC_BK4E_09_H      _PK_H_(0x4E, 0x09)
#define REG_SC_BK4E_0A_L      _PK_L_(0x4E, 0x0A)
#define REG_SC_BK4E_0A_H      _PK_H_(0x4E, 0x0A)
#define REG_SC_BK4E_0B_L      _PK_L_(0x4E, 0x0B)
#define REG_SC_BK4E_0B_H      _PK_H_(0x4E, 0x0B)
#define REG_SC_BK4E_0C_L      _PK_L_(0x4E, 0x0C)
#define REG_SC_BK4E_0C_H      _PK_H_(0x4E, 0x0C)
#define REG_SC_BK4E_0D_L      _PK_L_(0x4E, 0x0D)
#define REG_SC_BK4E_0D_H      _PK_H_(0x4E, 0x0D)
#define REG_SC_BK4E_0E_L      _PK_L_(0x4E, 0x0E)
#define REG_SC_BK4E_0E_H      _PK_H_(0x4E, 0x0E)
#define REG_SC_BK4E_0F_L      _PK_L_(0x4E, 0x0F)
#define REG_SC_BK4E_0F_H      _PK_H_(0x4E, 0x0F)
#define REG_SC_BK4E_10_L      _PK_L_(0x4E, 0x10)
#define REG_SC_BK4E_10_H      _PK_H_(0x4E, 0x10)
#define REG_SC_BK4E_11_L      _PK_L_(0x4E, 0x11)
#define REG_SC_BK4E_11_H      _PK_H_(0x4E, 0x11)
#define REG_SC_BK4E_12_L      _PK_L_(0x4E, 0x12)
#define REG_SC_BK4E_12_H      _PK_H_(0x4E, 0x12)
#define REG_SC_BK4E_13_L      _PK_L_(0x4E, 0x13)
#define REG_SC_BK4E_13_H      _PK_H_(0x4E, 0x13)
#define REG_SC_BK4E_14_L      _PK_L_(0x4E, 0x14)
#define REG_SC_BK4E_14_H      _PK_H_(0x4E, 0x14)
#define REG_SC_BK4E_15_L      _PK_L_(0x4E, 0x15)
#define REG_SC_BK4E_15_H      _PK_H_(0x4E, 0x15)
#define REG_SC_BK4E_16_L      _PK_L_(0x4E, 0x16)
#define REG_SC_BK4E_16_H      _PK_H_(0x4E, 0x16)
#define REG_SC_BK4E_17_L      _PK_L_(0x4E, 0x17)
#define REG_SC_BK4E_17_H      _PK_H_(0x4E, 0x17)
#define REG_SC_BK4E_18_L      _PK_L_(0x4E, 0x18)
#define REG_SC_BK4E_18_H      _PK_H_(0x4E, 0x18)
#define REG_SC_BK4E_19_L      _PK_L_(0x4E, 0x19)
#define REG_SC_BK4E_19_H      _PK_H_(0x4E, 0x19)
#define REG_SC_BK4E_1A_L      _PK_L_(0x4E, 0x1A)
#define REG_SC_BK4E_1A_H      _PK_H_(0x4E, 0x1A)
#define REG_SC_BK4E_1B_L      _PK_L_(0x4E, 0x1B)
#define REG_SC_BK4E_1B_H      _PK_H_(0x4E, 0x1B)
#define REG_SC_BK4E_1C_L      _PK_L_(0x4E, 0x1C)
#define REG_SC_BK4E_1C_H      _PK_H_(0x4E, 0x1C)
#define REG_SC_BK4E_1D_L      _PK_L_(0x4E, 0x1D)
#define REG_SC_BK4E_1D_H      _PK_H_(0x4E, 0x1D)
#define REG_SC_BK4E_1E_L      _PK_L_(0x4E, 0x1E)
#define REG_SC_BK4E_1E_H      _PK_H_(0x4E, 0x1E)
#define REG_SC_BK4E_1F_L      _PK_L_(0x4E, 0x1F)
#define REG_SC_BK4E_1F_H      _PK_H_(0x4E, 0x1F)
#define REG_SC_BK4E_20_L      _PK_L_(0x4E, 0x20)
#define REG_SC_BK4E_20_H      _PK_H_(0x4E, 0x20)
#define REG_SC_BK4E_21_L      _PK_L_(0x4E, 0x21)
#define REG_SC_BK4E_21_H      _PK_H_(0x4E, 0x21)
#define REG_SC_BK4E_22_L      _PK_L_(0x4E, 0x22)
#define REG_SC_BK4E_22_H      _PK_H_(0x4E, 0x22)
#define REG_SC_BK4E_23_L      _PK_L_(0x4E, 0x23)
#define REG_SC_BK4E_23_H      _PK_H_(0x4E, 0x23)
#define REG_SC_BK4E_24_L      _PK_L_(0x4E, 0x24)
#define REG_SC_BK4E_24_H      _PK_H_(0x4E, 0x24)
#define REG_SC_BK4E_25_L      _PK_L_(0x4E, 0x25)
#define REG_SC_BK4E_25_H      _PK_H_(0x4E, 0x25)
#define REG_SC_BK4E_26_L      _PK_L_(0x4E, 0x26)
#define REG_SC_BK4E_26_H      _PK_H_(0x4E, 0x26)
#define REG_SC_BK4E_27_L      _PK_L_(0x4E, 0x27)
#define REG_SC_BK4E_27_H      _PK_H_(0x4E, 0x27)
#define REG_SC_BK4E_28_L      _PK_L_(0x4E, 0x28)
#define REG_SC_BK4E_28_H      _PK_H_(0x4E, 0x28)
#define REG_SC_BK4E_29_L      _PK_L_(0x4E, 0x29)
#define REG_SC_BK4E_29_H      _PK_H_(0x4E, 0x29)
#define REG_SC_BK4E_2A_L      _PK_L_(0x4E, 0x2A)
#define REG_SC_BK4E_2A_H      _PK_H_(0x4E, 0x2A)
#define REG_SC_BK4E_2B_L      _PK_L_(0x4E, 0x2B)
#define REG_SC_BK4E_2B_H      _PK_H_(0x4E, 0x2B)
#define REG_SC_BK4E_2C_L      _PK_L_(0x4E, 0x2C)
#define REG_SC_BK4E_2C_H      _PK_H_(0x4E, 0x2C)
#define REG_SC_BK4E_2D_L      _PK_L_(0x4E, 0x2D)
#define REG_SC_BK4E_2D_H      _PK_H_(0x4E, 0x2D)
#define REG_SC_BK4E_2E_L      _PK_L_(0x4E, 0x2E)
#define REG_SC_BK4E_2E_H      _PK_H_(0x4E, 0x2E)
#define REG_SC_BK4E_2F_L      _PK_L_(0x4E, 0x2F)
#define REG_SC_BK4E_2F_H      _PK_H_(0x4E, 0x2F)
#define REG_SC_BK4E_30_L      _PK_L_(0x4E, 0x30)
#define REG_SC_BK4E_30_H      _PK_H_(0x4E, 0x30)
#define REG_SC_BK4E_31_L      _PK_L_(0x4E, 0x31)
#define REG_SC_BK4E_31_H      _PK_H_(0x4E, 0x31)
#define REG_SC_BK4E_32_L      _PK_L_(0x4E, 0x32)
#define REG_SC_BK4E_32_H      _PK_H_(0x4E, 0x32)
#define REG_SC_BK4E_33_L      _PK_L_(0x4E, 0x33)
#define REG_SC_BK4E_33_H      _PK_H_(0x4E, 0x33)
#define REG_SC_BK4E_34_L      _PK_L_(0x4E, 0x34)
#define REG_SC_BK4E_34_H      _PK_H_(0x4E, 0x34)
#define REG_SC_BK4E_35_L      _PK_L_(0x4E, 0x35)
#define REG_SC_BK4E_35_H      _PK_H_(0x4E, 0x35)
#define REG_SC_BK4E_36_L      _PK_L_(0x4E, 0x36)
#define REG_SC_BK4E_36_H      _PK_H_(0x4E, 0x36)
#define REG_SC_BK4E_37_L      _PK_L_(0x4E, 0x37)
#define REG_SC_BK4E_37_H      _PK_H_(0x4E, 0x37)
#define REG_SC_BK4E_38_L      _PK_L_(0x4E, 0x38)
#define REG_SC_BK4E_38_H      _PK_H_(0x4E, 0x38)
#define REG_SC_BK4E_39_L      _PK_L_(0x4E, 0x39)
#define REG_SC_BK4E_39_H      _PK_H_(0x4E, 0x39)
#define REG_SC_BK4E_3A_L      _PK_L_(0x4E, 0x3A)
#define REG_SC_BK4E_3A_H      _PK_H_(0x4E, 0x3A)
#define REG_SC_BK4E_3B_L      _PK_L_(0x4E, 0x3B)
#define REG_SC_BK4E_3B_H      _PK_H_(0x4E, 0x3B)
#define REG_SC_BK4E_3C_L      _PK_L_(0x4E, 0x3C)
#define REG_SC_BK4E_3C_H      _PK_H_(0x4E, 0x3C)
#define REG_SC_BK4E_3D_L      _PK_L_(0x4E, 0x3D)
#define REG_SC_BK4E_3D_H      _PK_H_(0x4E, 0x3D)
#define REG_SC_BK4E_3E_L      _PK_L_(0x4E, 0x3E)
#define REG_SC_BK4E_3E_H      _PK_H_(0x4E, 0x3E)
#define REG_SC_BK4E_3F_L      _PK_L_(0x4E, 0x3F)
#define REG_SC_BK4E_3F_H      _PK_H_(0x4E, 0x3F)
#define REG_SC_BK4E_40_L      _PK_L_(0x4E, 0x40)
#define REG_SC_BK4E_40_H      _PK_H_(0x4E, 0x40)
#define REG_SC_BK4E_41_L      _PK_L_(0x4E, 0x41)
#define REG_SC_BK4E_41_H      _PK_H_(0x4E, 0x41)
#define REG_SC_BK4E_42_L      _PK_L_(0x4E, 0x42)
#define REG_SC_BK4E_42_H      _PK_H_(0x4E, 0x42)
#define REG_SC_BK4E_43_L      _PK_L_(0x4E, 0x43)
#define REG_SC_BK4E_43_H      _PK_H_(0x4E, 0x43)
#define REG_SC_BK4E_44_L      _PK_L_(0x4E, 0x44)
#define REG_SC_BK4E_44_H      _PK_H_(0x4E, 0x44)
#define REG_SC_BK4E_45_L      _PK_L_(0x4E, 0x45)
#define REG_SC_BK4E_45_H      _PK_H_(0x4E, 0x45)
#define REG_SC_BK4E_46_L      _PK_L_(0x4E, 0x46)
#define REG_SC_BK4E_46_H      _PK_H_(0x4E, 0x46)
#define REG_SC_BK4E_47_L      _PK_L_(0x4E, 0x47)
#define REG_SC_BK4E_47_H      _PK_H_(0x4E, 0x47)
#define REG_SC_BK4E_48_L      _PK_L_(0x4E, 0x48)
#define REG_SC_BK4E_48_H      _PK_H_(0x4E, 0x48)
#define REG_SC_BK4E_49_L      _PK_L_(0x4E, 0x49)
#define REG_SC_BK4E_49_H      _PK_H_(0x4E, 0x49)
#define REG_SC_BK4E_4A_L      _PK_L_(0x4E, 0x4A)
#define REG_SC_BK4E_4A_H      _PK_H_(0x4E, 0x4A)
#define REG_SC_BK4E_4B_L      _PK_L_(0x4E, 0x4B)
#define REG_SC_BK4E_4B_H      _PK_H_(0x4E, 0x4B)
#define REG_SC_BK4E_4C_L      _PK_L_(0x4E, 0x4C)
#define REG_SC_BK4E_4C_H      _PK_H_(0x4E, 0x4C)
#define REG_SC_BK4E_4D_L      _PK_L_(0x4E, 0x4D)
#define REG_SC_BK4E_4D_H      _PK_H_(0x4E, 0x4D)
#define REG_SC_BK4E_4E_L      _PK_L_(0x4E, 0x4E)
#define REG_SC_BK4E_4E_H      _PK_H_(0x4E, 0x4E)
#define REG_SC_BK4E_4F_L      _PK_L_(0x4E, 0x4F)
#define REG_SC_BK4E_4F_H      _PK_H_(0x4E, 0x4F)
#define REG_SC_BK4E_50_L      _PK_L_(0x4E, 0x50)
#define REG_SC_BK4E_50_H      _PK_H_(0x4E, 0x50)
#define REG_SC_BK4E_51_L      _PK_L_(0x4E, 0x51)
#define REG_SC_BK4E_51_H      _PK_H_(0x4E, 0x51)
#define REG_SC_BK4E_52_L      _PK_L_(0x4E, 0x52)
#define REG_SC_BK4E_52_H      _PK_H_(0x4E, 0x52)
#define REG_SC_BK4E_53_L      _PK_L_(0x4E, 0x53)
#define REG_SC_BK4E_53_H      _PK_H_(0x4E, 0x53)
#define REG_SC_BK4E_54_L      _PK_L_(0x4E, 0x54)
#define REG_SC_BK4E_54_H      _PK_H_(0x4E, 0x54)
#define REG_SC_BK4E_55_L      _PK_L_(0x4E, 0x55)
#define REG_SC_BK4E_55_H      _PK_H_(0x4E, 0x55)
#define REG_SC_BK4E_56_L      _PK_L_(0x4E, 0x56)
#define REG_SC_BK4E_56_H      _PK_H_(0x4E, 0x56)
#define REG_SC_BK4E_57_L      _PK_L_(0x4E, 0x57)
#define REG_SC_BK4E_57_H      _PK_H_(0x4E, 0x57)
#define REG_SC_BK4E_58_L      _PK_L_(0x4E, 0x58)
#define REG_SC_BK4E_58_H      _PK_H_(0x4E, 0x58)
#define REG_SC_BK4E_59_L      _PK_L_(0x4E, 0x59)
#define REG_SC_BK4E_59_H      _PK_H_(0x4E, 0x59)
#define REG_SC_BK4E_5A_L      _PK_L_(0x4E, 0x5A)
#define REG_SC_BK4E_5A_H      _PK_H_(0x4E, 0x5A)
#define REG_SC_BK4E_5B_L      _PK_L_(0x4E, 0x5B)
#define REG_SC_BK4E_5B_H      _PK_H_(0x4E, 0x5B)
#define REG_SC_BK4E_5C_L      _PK_L_(0x4E, 0x5C)
#define REG_SC_BK4E_5C_H      _PK_H_(0x4E, 0x5C)
#define REG_SC_BK4E_5D_L      _PK_L_(0x4E, 0x5D)
#define REG_SC_BK4E_5D_H      _PK_H_(0x4E, 0x5D)
#define REG_SC_BK4E_5E_L      _PK_L_(0x4E, 0x5E)
#define REG_SC_BK4E_5E_H      _PK_H_(0x4E, 0x5E)
#define REG_SC_BK4E_5F_L      _PK_L_(0x4E, 0x5F)
#define REG_SC_BK4E_5F_H      _PK_H_(0x4E, 0x5F)
#define REG_SC_BK4E_60_L      _PK_L_(0x4E, 0x60)
#define REG_SC_BK4E_60_H      _PK_H_(0x4E, 0x60)
#define REG_SC_BK4E_61_L      _PK_L_(0x4E, 0x61)
#define REG_SC_BK4E_61_H      _PK_H_(0x4E, 0x61)
#define REG_SC_BK4E_62_L      _PK_L_(0x4E, 0x62)
#define REG_SC_BK4E_62_H      _PK_H_(0x4E, 0x62)
#define REG_SC_BK4E_63_L      _PK_L_(0x4E, 0x63)
#define REG_SC_BK4E_63_H      _PK_H_(0x4E, 0x63)
#define REG_SC_BK4E_64_L      _PK_L_(0x4E, 0x64)
#define REG_SC_BK4E_64_H      _PK_H_(0x4E, 0x64)
#define REG_SC_BK4E_65_L      _PK_L_(0x4E, 0x65)
#define REG_SC_BK4E_65_H      _PK_H_(0x4E, 0x65)
#define REG_SC_BK4E_66_L      _PK_L_(0x4E, 0x66)
#define REG_SC_BK4E_66_H      _PK_H_(0x4E, 0x66)
#define REG_SC_BK4E_67_L      _PK_L_(0x4E, 0x67)
#define REG_SC_BK4E_67_H      _PK_H_(0x4E, 0x67)
#define REG_SC_BK4E_68_L      _PK_L_(0x4E, 0x68)
#define REG_SC_BK4E_68_H      _PK_H_(0x4E, 0x68)
#define REG_SC_BK4E_69_L      _PK_L_(0x4E, 0x69)
#define REG_SC_BK4E_69_H      _PK_H_(0x4E, 0x69)
#define REG_SC_BK4E_6A_L      _PK_L_(0x4E, 0x6A)
#define REG_SC_BK4E_6A_H      _PK_H_(0x4E, 0x6A)
#define REG_SC_BK4E_6B_L      _PK_L_(0x4E, 0x6B)
#define REG_SC_BK4E_6B_H      _PK_H_(0x4E, 0x6B)
#define REG_SC_BK4E_6C_L      _PK_L_(0x4E, 0x6C)
#define REG_SC_BK4E_6C_H      _PK_H_(0x4E, 0x6C)
#define REG_SC_BK4E_6D_L      _PK_L_(0x4E, 0x6D)
#define REG_SC_BK4E_6D_H      _PK_H_(0x4E, 0x6D)
#define REG_SC_BK4E_6E_L      _PK_L_(0x4E, 0x6E)
#define REG_SC_BK4E_6E_H      _PK_H_(0x4E, 0x6E)
#define REG_SC_BK4E_6F_L      _PK_L_(0x4E, 0x6F)
#define REG_SC_BK4E_6F_H      _PK_H_(0x4E, 0x6F)
#define REG_SC_BK4E_70_L      _PK_L_(0x4E, 0x70)
#define REG_SC_BK4E_70_H      _PK_H_(0x4E, 0x70)
#define REG_SC_BK4E_71_L      _PK_L_(0x4E, 0x71)
#define REG_SC_BK4E_71_H      _PK_H_(0x4E, 0x71)
#define REG_SC_BK4E_72_L      _PK_L_(0x4E, 0x72)
#define REG_SC_BK4E_72_H      _PK_H_(0x4E, 0x72)
#define REG_SC_BK4E_73_L      _PK_L_(0x4E, 0x73)
#define REG_SC_BK4E_73_H      _PK_H_(0x4E, 0x73)
#define REG_SC_BK4E_74_L      _PK_L_(0x4E, 0x74)
#define REG_SC_BK4E_74_H      _PK_H_(0x4E, 0x74)
#define REG_SC_BK4E_75_L      _PK_L_(0x4E, 0x75)
#define REG_SC_BK4E_75_H      _PK_H_(0x4E, 0x75)
#define REG_SC_BK4E_76_L      _PK_L_(0x4E, 0x76)
#define REG_SC_BK4E_76_H      _PK_H_(0x4E, 0x76)
#define REG_SC_BK4E_77_L      _PK_L_(0x4E, 0x77)
#define REG_SC_BK4E_77_H      _PK_H_(0x4E, 0x77)
#define REG_SC_BK4E_78_L      _PK_L_(0x4E, 0x78)
#define REG_SC_BK4E_78_H      _PK_H_(0x4E, 0x78)
#define REG_SC_BK4E_79_L      _PK_L_(0x4E, 0x79)
#define REG_SC_BK4E_79_H      _PK_H_(0x4E, 0x79)
#define REG_SC_BK4E_7A_L      _PK_L_(0x4E, 0x7A)
#define REG_SC_BK4E_7A_H      _PK_H_(0x4E, 0x7A)
#define REG_SC_BK4E_7B_L      _PK_L_(0x4E, 0x7B)
#define REG_SC_BK4E_7B_H      _PK_H_(0x4E, 0x7B)
#define REG_SC_BK4E_7C_L      _PK_L_(0x4E, 0x7C)
#define REG_SC_BK4E_7C_H      _PK_H_(0x4E, 0x7C)
#define REG_SC_BK4E_7D_L      _PK_L_(0x4E, 0x7D)
#define REG_SC_BK4E_7D_H      _PK_H_(0x4E, 0x7D)
#define REG_SC_BK4E_7E_L      _PK_L_(0x4E, 0x7E)
#define REG_SC_BK4E_7E_H      _PK_H_(0x4E, 0x7E)
#define REG_SC_BK4E_7F_L      _PK_L_(0x4E, 0x7F)
#define REG_SC_BK4E_7F_H      _PK_H_(0x4E, 0x7F)
//----------------------------------------------
#define REG_SC_BK4F_00_L      _PK_L_(0x4F, 0x00)
#define REG_SC_BK4F_00_H      _PK_H_(0x4F, 0x00)
#define REG_SC_BK4F_01_L      _PK_L_(0x4F, 0x01)
#define REG_SC_BK4F_01_H      _PK_H_(0x4F, 0x01)
#define REG_SC_BK4F_02_L      _PK_L_(0x4F, 0x02)
#define REG_SC_BK4F_02_H      _PK_H_(0x4F, 0x02)
#define REG_SC_BK4F_03_L      _PK_L_(0x4F, 0x03)
#define REG_SC_BK4F_03_H      _PK_H_(0x4F, 0x03)
#define REG_SC_BK4F_04_L      _PK_L_(0x4F, 0x04)
#define REG_SC_BK4F_04_H      _PK_H_(0x4F, 0x04)
#define REG_SC_BK4F_05_L      _PK_L_(0x4F, 0x05)
#define REG_SC_BK4F_05_H      _PK_H_(0x4F, 0x05)
#define REG_SC_BK4F_06_L      _PK_L_(0x4F, 0x06)
#define REG_SC_BK4F_06_H      _PK_H_(0x4F, 0x06)
#define REG_SC_BK4F_07_L      _PK_L_(0x4F, 0x07)
#define REG_SC_BK4F_07_H      _PK_H_(0x4F, 0x07)
#define REG_SC_BK4F_08_L      _PK_L_(0x4F, 0x08)
#define REG_SC_BK4F_08_H      _PK_H_(0x4F, 0x08)
#define REG_SC_BK4F_09_L      _PK_L_(0x4F, 0x09)
#define REG_SC_BK4F_09_H      _PK_H_(0x4F, 0x09)
#define REG_SC_BK4F_0A_L      _PK_L_(0x4F, 0x0A)
#define REG_SC_BK4F_0A_H      _PK_H_(0x4F, 0x0A)
#define REG_SC_BK4F_0B_L      _PK_L_(0x4F, 0x0B)
#define REG_SC_BK4F_0B_H      _PK_H_(0x4F, 0x0B)
#define REG_SC_BK4F_0C_L      _PK_L_(0x4F, 0x0C)
#define REG_SC_BK4F_0C_H      _PK_H_(0x4F, 0x0C)
#define REG_SC_BK4F_0D_L      _PK_L_(0x4F, 0x0D)
#define REG_SC_BK4F_0D_H      _PK_H_(0x4F, 0x0D)
#define REG_SC_BK4F_0E_L      _PK_L_(0x4F, 0x0E)
#define REG_SC_BK4F_0E_H      _PK_H_(0x4F, 0x0E)
#define REG_SC_BK4F_0F_L      _PK_L_(0x4F, 0x0F)
#define REG_SC_BK4F_0F_H      _PK_H_(0x4F, 0x0F)
#define REG_SC_BK4F_10_L      _PK_L_(0x4F, 0x10)
#define REG_SC_BK4F_10_H      _PK_H_(0x4F, 0x10)
#define REG_SC_BK4F_11_L      _PK_L_(0x4F, 0x11)
#define REG_SC_BK4F_11_H      _PK_H_(0x4F, 0x11)
#define REG_SC_BK4F_12_L      _PK_L_(0x4F, 0x12)
#define REG_SC_BK4F_12_H      _PK_H_(0x4F, 0x12)
#define REG_SC_BK4F_13_L      _PK_L_(0x4F, 0x13)
#define REG_SC_BK4F_13_H      _PK_H_(0x4F, 0x13)
#define REG_SC_BK4F_14_L      _PK_L_(0x4F, 0x14)
#define REG_SC_BK4F_14_H      _PK_H_(0x4F, 0x14)
#define REG_SC_BK4F_15_L      _PK_L_(0x4F, 0x15)
#define REG_SC_BK4F_15_H      _PK_H_(0x4F, 0x15)
#define REG_SC_BK4F_16_L      _PK_L_(0x4F, 0x16)
#define REG_SC_BK4F_16_H      _PK_H_(0x4F, 0x16)
#define REG_SC_BK4F_17_L      _PK_L_(0x4F, 0x17)
#define REG_SC_BK4F_17_H      _PK_H_(0x4F, 0x17)
#define REG_SC_BK4F_18_L      _PK_L_(0x4F, 0x18)
#define REG_SC_BK4F_18_H      _PK_H_(0x4F, 0x18)
#define REG_SC_BK4F_19_L      _PK_L_(0x4F, 0x19)
#define REG_SC_BK4F_19_H      _PK_H_(0x4F, 0x19)
#define REG_SC_BK4F_1A_L      _PK_L_(0x4F, 0x1A)
#define REG_SC_BK4F_1A_H      _PK_H_(0x4F, 0x1A)
#define REG_SC_BK4F_1B_L      _PK_L_(0x4F, 0x1B)
#define REG_SC_BK4F_1B_H      _PK_H_(0x4F, 0x1B)
#define REG_SC_BK4F_1C_L      _PK_L_(0x4F, 0x1C)
#define REG_SC_BK4F_1C_H      _PK_H_(0x4F, 0x1C)
#define REG_SC_BK4F_1D_L      _PK_L_(0x4F, 0x1D)
#define REG_SC_BK4F_1D_H      _PK_H_(0x4F, 0x1D)
#define REG_SC_BK4F_1E_L      _PK_L_(0x4F, 0x1E)
#define REG_SC_BK4F_1E_H      _PK_H_(0x4F, 0x1E)
#define REG_SC_BK4F_1F_L      _PK_L_(0x4F, 0x1F)
#define REG_SC_BK4F_1F_H      _PK_H_(0x4F, 0x1F)
#define REG_SC_BK4F_20_L      _PK_L_(0x4F, 0x20)
#define REG_SC_BK4F_20_H      _PK_H_(0x4F, 0x20)
#define REG_SC_BK4F_21_L      _PK_L_(0x4F, 0x21)
#define REG_SC_BK4F_21_H      _PK_H_(0x4F, 0x21)
#define REG_SC_BK4F_22_L      _PK_L_(0x4F, 0x22)
#define REG_SC_BK4F_22_H      _PK_H_(0x4F, 0x22)
#define REG_SC_BK4F_23_L      _PK_L_(0x4F, 0x23)
#define REG_SC_BK4F_23_H      _PK_H_(0x4F, 0x23)
#define REG_SC_BK4F_24_L      _PK_L_(0x4F, 0x24)
#define REG_SC_BK4F_24_H      _PK_H_(0x4F, 0x24)
#define REG_SC_BK4F_25_L      _PK_L_(0x4F, 0x25)
#define REG_SC_BK4F_25_H      _PK_H_(0x4F, 0x25)
#define REG_SC_BK4F_26_L      _PK_L_(0x4F, 0x26)
#define REG_SC_BK4F_26_H      _PK_H_(0x4F, 0x26)
#define REG_SC_BK4F_27_L      _PK_L_(0x4F, 0x27)
#define REG_SC_BK4F_27_H      _PK_H_(0x4F, 0x27)
#define REG_SC_BK4F_28_L      _PK_L_(0x4F, 0x28)
#define REG_SC_BK4F_28_H      _PK_H_(0x4F, 0x28)
#define REG_SC_BK4F_29_L      _PK_L_(0x4F, 0x29)
#define REG_SC_BK4F_29_H      _PK_H_(0x4F, 0x29)
#define REG_SC_BK4F_2A_L      _PK_L_(0x4F, 0x2A)
#define REG_SC_BK4F_2A_H      _PK_H_(0x4F, 0x2A)
#define REG_SC_BK4F_2B_L      _PK_L_(0x4F, 0x2B)
#define REG_SC_BK4F_2B_H      _PK_H_(0x4F, 0x2B)
#define REG_SC_BK4F_2C_L      _PK_L_(0x4F, 0x2C)
#define REG_SC_BK4F_2C_H      _PK_H_(0x4F, 0x2C)
#define REG_SC_BK4F_2D_L      _PK_L_(0x4F, 0x2D)
#define REG_SC_BK4F_2D_H      _PK_H_(0x4F, 0x2D)
#define REG_SC_BK4F_2E_L      _PK_L_(0x4F, 0x2E)
#define REG_SC_BK4F_2E_H      _PK_H_(0x4F, 0x2E)
#define REG_SC_BK4F_2F_L      _PK_L_(0x4F, 0x2F)
#define REG_SC_BK4F_2F_H      _PK_H_(0x4F, 0x2F)
#define REG_SC_BK4F_30_L      _PK_L_(0x4F, 0x30)
#define REG_SC_BK4F_30_H      _PK_H_(0x4F, 0x30)
#define REG_SC_BK4F_31_L      _PK_L_(0x4F, 0x31)
#define REG_SC_BK4F_31_H      _PK_H_(0x4F, 0x31)
#define REG_SC_BK4F_32_L      _PK_L_(0x4F, 0x32)
#define REG_SC_BK4F_32_H      _PK_H_(0x4F, 0x32)
#define REG_SC_BK4F_33_L      _PK_L_(0x4F, 0x33)
#define REG_SC_BK4F_33_H      _PK_H_(0x4F, 0x33)
#define REG_SC_BK4F_34_L      _PK_L_(0x4F, 0x34)
#define REG_SC_BK4F_34_H      _PK_H_(0x4F, 0x34)
#define REG_SC_BK4F_35_L      _PK_L_(0x4F, 0x35)
#define REG_SC_BK4F_35_H      _PK_H_(0x4F, 0x35)
#define REG_SC_BK4F_36_L      _PK_L_(0x4F, 0x36)
#define REG_SC_BK4F_36_H      _PK_H_(0x4F, 0x36)
#define REG_SC_BK4F_37_L      _PK_L_(0x4F, 0x37)
#define REG_SC_BK4F_37_H      _PK_H_(0x4F, 0x37)
#define REG_SC_BK4F_38_L      _PK_L_(0x4F, 0x38)
#define REG_SC_BK4F_38_H      _PK_H_(0x4F, 0x38)
#define REG_SC_BK4F_39_L      _PK_L_(0x4F, 0x39)
#define REG_SC_BK4F_39_H      _PK_H_(0x4F, 0x39)
#define REG_SC_BK4F_3A_L      _PK_L_(0x4F, 0x3A)
#define REG_SC_BK4F_3A_H      _PK_H_(0x4F, 0x3A)
#define REG_SC_BK4F_3B_L      _PK_L_(0x4F, 0x3B)
#define REG_SC_BK4F_3B_H      _PK_H_(0x4F, 0x3B)
#define REG_SC_BK4F_3C_L      _PK_L_(0x4F, 0x3C)
#define REG_SC_BK4F_3C_H      _PK_H_(0x4F, 0x3C)
#define REG_SC_BK4F_3D_L      _PK_L_(0x4F, 0x3D)
#define REG_SC_BK4F_3D_H      _PK_H_(0x4F, 0x3D)
#define REG_SC_BK4F_3E_L      _PK_L_(0x4F, 0x3E)
#define REG_SC_BK4F_3E_H      _PK_H_(0x4F, 0x3E)
#define REG_SC_BK4F_3F_L      _PK_L_(0x4F, 0x3F)
#define REG_SC_BK4F_3F_H      _PK_H_(0x4F, 0x3F)
#define REG_SC_BK4F_40_L      _PK_L_(0x4F, 0x40)
#define REG_SC_BK4F_40_H      _PK_H_(0x4F, 0x40)
#define REG_SC_BK4F_41_L      _PK_L_(0x4F, 0x41)
#define REG_SC_BK4F_41_H      _PK_H_(0x4F, 0x41)
#define REG_SC_BK4F_42_L      _PK_L_(0x4F, 0x42)
#define REG_SC_BK4F_42_H      _PK_H_(0x4F, 0x42)
#define REG_SC_BK4F_43_L      _PK_L_(0x4F, 0x43)
#define REG_SC_BK4F_43_H      _PK_H_(0x4F, 0x43)
#define REG_SC_BK4F_44_L      _PK_L_(0x4F, 0x44)
#define REG_SC_BK4F_44_H      _PK_H_(0x4F, 0x44)
#define REG_SC_BK4F_45_L      _PK_L_(0x4F, 0x45)
#define REG_SC_BK4F_45_H      _PK_H_(0x4F, 0x45)
#define REG_SC_BK4F_46_L      _PK_L_(0x4F, 0x46)
#define REG_SC_BK4F_46_H      _PK_H_(0x4F, 0x46)
#define REG_SC_BK4F_47_L      _PK_L_(0x4F, 0x47)
#define REG_SC_BK4F_47_H      _PK_H_(0x4F, 0x47)
#define REG_SC_BK4F_48_L      _PK_L_(0x4F, 0x48)
#define REG_SC_BK4F_48_H      _PK_H_(0x4F, 0x48)
#define REG_SC_BK4F_49_L      _PK_L_(0x4F, 0x49)
#define REG_SC_BK4F_49_H      _PK_H_(0x4F, 0x49)
#define REG_SC_BK4F_4A_L      _PK_L_(0x4F, 0x4A)
#define REG_SC_BK4F_4A_H      _PK_H_(0x4F, 0x4A)
#define REG_SC_BK4F_4B_L      _PK_L_(0x4F, 0x4B)
#define REG_SC_BK4F_4B_H      _PK_H_(0x4F, 0x4B)
#define REG_SC_BK4F_4C_L      _PK_L_(0x4F, 0x4C)
#define REG_SC_BK4F_4C_H      _PK_H_(0x4F, 0x4C)
#define REG_SC_BK4F_4D_L      _PK_L_(0x4F, 0x4D)
#define REG_SC_BK4F_4D_H      _PK_H_(0x4F, 0x4D)
#define REG_SC_BK4F_4E_L      _PK_L_(0x4F, 0x4E)
#define REG_SC_BK4F_4E_H      _PK_H_(0x4F, 0x4E)
#define REG_SC_BK4F_4F_L      _PK_L_(0x4F, 0x4F)
#define REG_SC_BK4F_4F_H      _PK_H_(0x4F, 0x4F)
#define REG_SC_BK4F_50_L      _PK_L_(0x4F, 0x50)
#define REG_SC_BK4F_50_H      _PK_H_(0x4F, 0x50)
#define REG_SC_BK4F_51_L      _PK_L_(0x4F, 0x51)
#define REG_SC_BK4F_51_H      _PK_H_(0x4F, 0x51)
#define REG_SC_BK4F_52_L      _PK_L_(0x4F, 0x52)
#define REG_SC_BK4F_52_H      _PK_H_(0x4F, 0x52)
#define REG_SC_BK4F_53_L      _PK_L_(0x4F, 0x53)
#define REG_SC_BK4F_53_H      _PK_H_(0x4F, 0x53)
#define REG_SC_BK4F_54_L      _PK_L_(0x4F, 0x54)
#define REG_SC_BK4F_54_H      _PK_H_(0x4F, 0x54)
#define REG_SC_BK4F_55_L      _PK_L_(0x4F, 0x55)
#define REG_SC_BK4F_55_H      _PK_H_(0x4F, 0x55)
#define REG_SC_BK4F_56_L      _PK_L_(0x4F, 0x56)
#define REG_SC_BK4F_56_H      _PK_H_(0x4F, 0x56)
#define REG_SC_BK4F_57_L      _PK_L_(0x4F, 0x57)
#define REG_SC_BK4F_57_H      _PK_H_(0x4F, 0x57)
#define REG_SC_BK4F_58_L      _PK_L_(0x4F, 0x58)
#define REG_SC_BK4F_58_H      _PK_H_(0x4F, 0x58)
#define REG_SC_BK4F_59_L      _PK_L_(0x4F, 0x59)
#define REG_SC_BK4F_59_H      _PK_H_(0x4F, 0x59)
#define REG_SC_BK4F_5A_L      _PK_L_(0x4F, 0x5A)
#define REG_SC_BK4F_5A_H      _PK_H_(0x4F, 0x5A)
#define REG_SC_BK4F_5B_L      _PK_L_(0x4F, 0x5B)
#define REG_SC_BK4F_5B_H      _PK_H_(0x4F, 0x5B)
#define REG_SC_BK4F_5C_L      _PK_L_(0x4F, 0x5C)
#define REG_SC_BK4F_5C_H      _PK_H_(0x4F, 0x5C)
#define REG_SC_BK4F_5D_L      _PK_L_(0x4F, 0x5D)
#define REG_SC_BK4F_5D_H      _PK_H_(0x4F, 0x5D)
#define REG_SC_BK4F_5E_L      _PK_L_(0x4F, 0x5E)
#define REG_SC_BK4F_5E_H      _PK_H_(0x4F, 0x5E)
#define REG_SC_BK4F_5F_L      _PK_L_(0x4F, 0x5F)
#define REG_SC_BK4F_5F_H      _PK_H_(0x4F, 0x5F)
#define REG_SC_BK4F_60_L      _PK_L_(0x4F, 0x60)
#define REG_SC_BK4F_60_H      _PK_H_(0x4F, 0x60)
#define REG_SC_BK4F_61_L      _PK_L_(0x4F, 0x61)
#define REG_SC_BK4F_61_H      _PK_H_(0x4F, 0x61)
#define REG_SC_BK4F_62_L      _PK_L_(0x4F, 0x62)
#define REG_SC_BK4F_62_H      _PK_H_(0x4F, 0x62)
#define REG_SC_BK4F_63_L      _PK_L_(0x4F, 0x63)
#define REG_SC_BK4F_63_H      _PK_H_(0x4F, 0x63)
#define REG_SC_BK4F_64_L      _PK_L_(0x4F, 0x64)
#define REG_SC_BK4F_64_H      _PK_H_(0x4F, 0x64)
#define REG_SC_BK4F_65_L      _PK_L_(0x4F, 0x65)
#define REG_SC_BK4F_65_H      _PK_H_(0x4F, 0x65)
#define REG_SC_BK4F_66_L      _PK_L_(0x4F, 0x66)
#define REG_SC_BK4F_66_H      _PK_H_(0x4F, 0x66)
#define REG_SC_BK4F_67_L      _PK_L_(0x4F, 0x67)
#define REG_SC_BK4F_67_H      _PK_H_(0x4F, 0x67)
#define REG_SC_BK4F_68_L      _PK_L_(0x4F, 0x68)
#define REG_SC_BK4F_68_H      _PK_H_(0x4F, 0x68)
#define REG_SC_BK4F_69_L      _PK_L_(0x4F, 0x69)
#define REG_SC_BK4F_69_H      _PK_H_(0x4F, 0x69)
#define REG_SC_BK4F_6A_L      _PK_L_(0x4F, 0x6A)
#define REG_SC_BK4F_6A_H      _PK_H_(0x4F, 0x6A)
#define REG_SC_BK4F_6B_L      _PK_L_(0x4F, 0x6B)
#define REG_SC_BK4F_6B_H      _PK_H_(0x4F, 0x6B)
#define REG_SC_BK4F_6C_L      _PK_L_(0x4F, 0x6C)
#define REG_SC_BK4F_6C_H      _PK_H_(0x4F, 0x6C)
#define REG_SC_BK4F_6D_L      _PK_L_(0x4F, 0x6D)
#define REG_SC_BK4F_6D_H      _PK_H_(0x4F, 0x6D)
#define REG_SC_BK4F_6E_L      _PK_L_(0x4F, 0x6E)
#define REG_SC_BK4F_6E_H      _PK_H_(0x4F, 0x6E)
#define REG_SC_BK4F_6F_L      _PK_L_(0x4F, 0x6F)
#define REG_SC_BK4F_6F_H      _PK_H_(0x4F, 0x6F)
#define REG_SC_BK4F_70_L      _PK_L_(0x4F, 0x70)
#define REG_SC_BK4F_70_H      _PK_H_(0x4F, 0x70)
#define REG_SC_BK4F_71_L      _PK_L_(0x4F, 0x71)
#define REG_SC_BK4F_71_H      _PK_H_(0x4F, 0x71)
#define REG_SC_BK4F_72_L      _PK_L_(0x4F, 0x72)
#define REG_SC_BK4F_72_H      _PK_H_(0x4F, 0x72)
#define REG_SC_BK4F_73_L      _PK_L_(0x4F, 0x73)
#define REG_SC_BK4F_73_H      _PK_H_(0x4F, 0x73)
#define REG_SC_BK4F_74_L      _PK_L_(0x4F, 0x74)
#define REG_SC_BK4F_74_H      _PK_H_(0x4F, 0x74)
#define REG_SC_BK4F_75_L      _PK_L_(0x4F, 0x75)
#define REG_SC_BK4F_75_H      _PK_H_(0x4F, 0x75)
#define REG_SC_BK4F_76_L      _PK_L_(0x4F, 0x76)
#define REG_SC_BK4F_76_H      _PK_H_(0x4F, 0x76)
#define REG_SC_BK4F_77_L      _PK_L_(0x4F, 0x77)
#define REG_SC_BK4F_77_H      _PK_H_(0x4F, 0x77)
#define REG_SC_BK4F_78_L      _PK_L_(0x4F, 0x78)
#define REG_SC_BK4F_78_H      _PK_H_(0x4F, 0x78)
#define REG_SC_BK4F_79_L      _PK_L_(0x4F, 0x79)
#define REG_SC_BK4F_79_H      _PK_H_(0x4F, 0x79)
#define REG_SC_BK4F_7A_L      _PK_L_(0x4F, 0x7A)
#define REG_SC_BK4F_7A_H      _PK_H_(0x4F, 0x7A)
#define REG_SC_BK4F_7B_L      _PK_L_(0x4F, 0x7B)
#define REG_SC_BK4F_7B_H      _PK_H_(0x4F, 0x7B)
#define REG_SC_BK4F_7C_L      _PK_L_(0x4F, 0x7C)
#define REG_SC_BK4F_7C_H      _PK_H_(0x4F, 0x7C)
#define REG_SC_BK4F_7D_L      _PK_L_(0x4F, 0x7D)
#define REG_SC_BK4F_7D_H      _PK_H_(0x4F, 0x7D)
#define REG_SC_BK4F_7E_L      _PK_L_(0x4F, 0x7E)
#define REG_SC_BK4F_7E_H      _PK_H_(0x4F, 0x7E)
#define REG_SC_BK4F_7F_L      _PK_L_(0x4F, 0x7F)
#define REG_SC_BK4F_7F_H      _PK_H_(0x4F, 0x7F)
//----------------------------------------------
#define REG_SC_BK54_00_L      _PK_L_(0x54, 0x00)
#define REG_SC_BK54_00_H      _PK_H_(0x54, 0x00)
#define REG_SC_BK54_01_L      _PK_L_(0x54, 0x01)
#define REG_SC_BK54_01_H      _PK_H_(0x54, 0x01)
#define REG_SC_BK54_02_L      _PK_L_(0x54, 0x02)
#define REG_SC_BK54_02_H      _PK_H_(0x54, 0x02)
#define REG_SC_BK54_03_L      _PK_L_(0x54, 0x03)
#define REG_SC_BK54_03_H      _PK_H_(0x54, 0x03)
#define REG_SC_BK54_04_L      _PK_L_(0x54, 0x04)
#define REG_SC_BK54_04_H      _PK_H_(0x54, 0x04)
#define REG_SC_BK54_05_L      _PK_L_(0x54, 0x05)
#define REG_SC_BK54_05_H      _PK_H_(0x54, 0x05)
#define REG_SC_BK54_06_L      _PK_L_(0x54, 0x06)
#define REG_SC_BK54_06_H      _PK_H_(0x54, 0x06)
#define REG_SC_BK54_07_L      _PK_L_(0x54, 0x07)
#define REG_SC_BK54_07_H      _PK_H_(0x54, 0x07)
#define REG_SC_BK54_08_L      _PK_L_(0x54, 0x08)
#define REG_SC_BK54_08_H      _PK_H_(0x54, 0x08)
#define REG_SC_BK54_09_L      _PK_L_(0x54, 0x09)
#define REG_SC_BK54_09_H      _PK_H_(0x54, 0x09)
#define REG_SC_BK54_0A_L      _PK_L_(0x54, 0x0A)
#define REG_SC_BK54_0A_H      _PK_H_(0x54, 0x0A)
#define REG_SC_BK54_0B_L      _PK_L_(0x54, 0x0B)
#define REG_SC_BK54_0B_H      _PK_H_(0x54, 0x0B)
#define REG_SC_BK54_0C_L      _PK_L_(0x54, 0x0C)
#define REG_SC_BK54_0C_H      _PK_H_(0x54, 0x0C)
#define REG_SC_BK54_0D_L      _PK_L_(0x54, 0x0D)
#define REG_SC_BK54_0D_H      _PK_H_(0x54, 0x0D)
#define REG_SC_BK54_0E_L      _PK_L_(0x54, 0x0E)
#define REG_SC_BK54_0E_H      _PK_H_(0x54, 0x0E)
#define REG_SC_BK54_0F_L      _PK_L_(0x54, 0x0F)
#define REG_SC_BK54_0F_H      _PK_H_(0x54, 0x0F)
#define REG_SC_BK54_10_L      _PK_L_(0x54, 0x10)
#define REG_SC_BK54_10_H      _PK_H_(0x54, 0x10)
#define REG_SC_BK54_11_L      _PK_L_(0x54, 0x11)
#define REG_SC_BK54_11_H      _PK_H_(0x54, 0x11)
#define REG_SC_BK54_12_L      _PK_L_(0x54, 0x12)
#define REG_SC_BK54_12_H      _PK_H_(0x54, 0x12)
#define REG_SC_BK54_13_L      _PK_L_(0x54, 0x13)
#define REG_SC_BK54_13_H      _PK_H_(0x54, 0x13)
#define REG_SC_BK54_14_L      _PK_L_(0x54, 0x14)
#define REG_SC_BK54_14_H      _PK_H_(0x54, 0x14)
#define REG_SC_BK54_15_L      _PK_L_(0x54, 0x15)
#define REG_SC_BK54_15_H      _PK_H_(0x54, 0x15)
#define REG_SC_BK54_16_L      _PK_L_(0x54, 0x16)
#define REG_SC_BK54_16_H      _PK_H_(0x54, 0x16)
#define REG_SC_BK54_17_L      _PK_L_(0x54, 0x17)
#define REG_SC_BK54_17_H      _PK_H_(0x54, 0x17)
#define REG_SC_BK54_18_L      _PK_L_(0x54, 0x18)
#define REG_SC_BK54_18_H      _PK_H_(0x54, 0x18)
#define REG_SC_BK54_19_L      _PK_L_(0x54, 0x19)
#define REG_SC_BK54_19_H      _PK_H_(0x54, 0x19)
#define REG_SC_BK54_1A_L      _PK_L_(0x54, 0x1A)
#define REG_SC_BK54_1A_H      _PK_H_(0x54, 0x1A)
#define REG_SC_BK54_1B_L      _PK_L_(0x54, 0x1B)
#define REG_SC_BK54_1B_H      _PK_H_(0x54, 0x1B)
#define REG_SC_BK54_1C_L      _PK_L_(0x54, 0x1C)
#define REG_SC_BK54_1C_H      _PK_H_(0x54, 0x1C)
#define REG_SC_BK54_1D_L      _PK_L_(0x54, 0x1D)
#define REG_SC_BK54_1D_H      _PK_H_(0x54, 0x1D)
#define REG_SC_BK54_1E_L      _PK_L_(0x54, 0x1E)
#define REG_SC_BK54_1E_H      _PK_H_(0x54, 0x1E)
#define REG_SC_BK54_1F_L      _PK_L_(0x54, 0x1F)
#define REG_SC_BK54_1F_H      _PK_H_(0x54, 0x1F)
#define REG_SC_BK54_20_L      _PK_L_(0x54, 0x20)
#define REG_SC_BK54_20_H      _PK_H_(0x54, 0x20)
#define REG_SC_BK54_21_L      _PK_L_(0x54, 0x21)
#define REG_SC_BK54_21_H      _PK_H_(0x54, 0x21)
#define REG_SC_BK54_22_L      _PK_L_(0x54, 0x22)
#define REG_SC_BK54_22_H      _PK_H_(0x54, 0x22)
#define REG_SC_BK54_23_L      _PK_L_(0x54, 0x23)
#define REG_SC_BK54_23_H      _PK_H_(0x54, 0x23)
#define REG_SC_BK54_24_L      _PK_L_(0x54, 0x24)
#define REG_SC_BK54_24_H      _PK_H_(0x54, 0x24)
#define REG_SC_BK54_25_L      _PK_L_(0x54, 0x25)
#define REG_SC_BK54_25_H      _PK_H_(0x54, 0x25)
#define REG_SC_BK54_26_L      _PK_L_(0x54, 0x26)
#define REG_SC_BK54_26_H      _PK_H_(0x54, 0x26)
#define REG_SC_BK54_27_L      _PK_L_(0x54, 0x27)
#define REG_SC_BK54_27_H      _PK_H_(0x54, 0x27)
#define REG_SC_BK54_28_L      _PK_L_(0x54, 0x28)
#define REG_SC_BK54_28_H      _PK_H_(0x54, 0x28)
#define REG_SC_BK54_29_L      _PK_L_(0x54, 0x29)
#define REG_SC_BK54_29_H      _PK_H_(0x54, 0x29)
#define REG_SC_BK54_2A_L      _PK_L_(0x54, 0x2A)
#define REG_SC_BK54_2A_H      _PK_H_(0x54, 0x2A)
#define REG_SC_BK54_2B_L      _PK_L_(0x54, 0x2B)
#define REG_SC_BK54_2B_H      _PK_H_(0x54, 0x2B)
#define REG_SC_BK54_2C_L      _PK_L_(0x54, 0x2C)
#define REG_SC_BK54_2C_H      _PK_H_(0x54, 0x2C)
#define REG_SC_BK54_2D_L      _PK_L_(0x54, 0x2D)
#define REG_SC_BK54_2D_H      _PK_H_(0x54, 0x2D)
#define REG_SC_BK54_2E_L      _PK_L_(0x54, 0x2E)
#define REG_SC_BK54_2E_H      _PK_H_(0x54, 0x2E)
#define REG_SC_BK54_2F_L      _PK_L_(0x54, 0x2F)
#define REG_SC_BK54_2F_H      _PK_H_(0x54, 0x2F)
#define REG_SC_BK54_30_L      _PK_L_(0x54, 0x30)
#define REG_SC_BK54_30_H      _PK_H_(0x54, 0x30)
#define REG_SC_BK54_31_L      _PK_L_(0x54, 0x31)
#define REG_SC_BK54_31_H      _PK_H_(0x54, 0x31)
#define REG_SC_BK54_32_L      _PK_L_(0x54, 0x32)
#define REG_SC_BK54_32_H      _PK_H_(0x54, 0x32)
#define REG_SC_BK54_33_L      _PK_L_(0x54, 0x33)
#define REG_SC_BK54_33_H      _PK_H_(0x54, 0x33)
#define REG_SC_BK54_34_L      _PK_L_(0x54, 0x34)
#define REG_SC_BK54_34_H      _PK_H_(0x54, 0x34)
#define REG_SC_BK54_35_L      _PK_L_(0x54, 0x35)
#define REG_SC_BK54_35_H      _PK_H_(0x54, 0x35)
#define REG_SC_BK54_36_L      _PK_L_(0x54, 0x36)
#define REG_SC_BK54_36_H      _PK_H_(0x54, 0x36)
#define REG_SC_BK54_37_L      _PK_L_(0x54, 0x37)
#define REG_SC_BK54_37_H      _PK_H_(0x54, 0x37)
#define REG_SC_BK54_38_L      _PK_L_(0x54, 0x38)
#define REG_SC_BK54_38_H      _PK_H_(0x54, 0x38)
#define REG_SC_BK54_39_L      _PK_L_(0x54, 0x39)
#define REG_SC_BK54_39_H      _PK_H_(0x54, 0x39)
#define REG_SC_BK54_3A_L      _PK_L_(0x54, 0x3A)
#define REG_SC_BK54_3A_H      _PK_H_(0x54, 0x3A)
#define REG_SC_BK54_3B_L      _PK_L_(0x54, 0x3B)
#define REG_SC_BK54_3B_H      _PK_H_(0x54, 0x3B)
#define REG_SC_BK54_3C_L      _PK_L_(0x54, 0x3C)
#define REG_SC_BK54_3C_H      _PK_H_(0x54, 0x3C)
#define REG_SC_BK54_3D_L      _PK_L_(0x54, 0x3D)
#define REG_SC_BK54_3D_H      _PK_H_(0x54, 0x3D)
#define REG_SC_BK54_3E_L      _PK_L_(0x54, 0x3E)
#define REG_SC_BK54_3E_H      _PK_H_(0x54, 0x3E)
#define REG_SC_BK54_3F_L      _PK_L_(0x54, 0x3F)
#define REG_SC_BK54_3F_H      _PK_H_(0x54, 0x3F)
#define REG_SC_BK54_40_L      _PK_L_(0x54, 0x40)
#define REG_SC_BK54_40_H      _PK_H_(0x54, 0x40)
#define REG_SC_BK54_41_L      _PK_L_(0x54, 0x41)
#define REG_SC_BK54_41_H      _PK_H_(0x54, 0x41)
#define REG_SC_BK54_42_L      _PK_L_(0x54, 0x42)
#define REG_SC_BK54_42_H      _PK_H_(0x54, 0x42)
#define REG_SC_BK54_43_L      _PK_L_(0x54, 0x43)
#define REG_SC_BK54_43_H      _PK_H_(0x54, 0x43)
#define REG_SC_BK54_44_L      _PK_L_(0x54, 0x44)
#define REG_SC_BK54_44_H      _PK_H_(0x54, 0x44)
#define REG_SC_BK54_45_L      _PK_L_(0x54, 0x45)
#define REG_SC_BK54_45_H      _PK_H_(0x54, 0x45)
#define REG_SC_BK54_46_L      _PK_L_(0x54, 0x46)
#define REG_SC_BK54_46_H      _PK_H_(0x54, 0x46)
#define REG_SC_BK54_47_L      _PK_L_(0x54, 0x47)
#define REG_SC_BK54_47_H      _PK_H_(0x54, 0x47)
#define REG_SC_BK54_48_L      _PK_L_(0x54, 0x48)
#define REG_SC_BK54_48_H      _PK_H_(0x54, 0x48)
#define REG_SC_BK54_49_L      _PK_L_(0x54, 0x49)
#define REG_SC_BK54_49_H      _PK_H_(0x54, 0x49)
#define REG_SC_BK54_4A_L      _PK_L_(0x54, 0x4A)
#define REG_SC_BK54_4A_H      _PK_H_(0x54, 0x4A)
#define REG_SC_BK54_4B_L      _PK_L_(0x54, 0x4B)
#define REG_SC_BK54_4B_H      _PK_H_(0x54, 0x4B)
#define REG_SC_BK54_4C_L      _PK_L_(0x54, 0x4C)
#define REG_SC_BK54_4C_H      _PK_H_(0x54, 0x4C)
#define REG_SC_BK54_4D_L      _PK_L_(0x54, 0x4D)
#define REG_SC_BK54_4D_H      _PK_H_(0x54, 0x4D)
#define REG_SC_BK54_4E_L      _PK_L_(0x54, 0x4E)
#define REG_SC_BK54_4E_H      _PK_H_(0x54, 0x4E)
#define REG_SC_BK54_4F_L      _PK_L_(0x54, 0x4F)
#define REG_SC_BK54_4F_H      _PK_H_(0x54, 0x4F)
#define REG_SC_BK54_50_L      _PK_L_(0x54, 0x50)
#define REG_SC_BK54_50_H      _PK_H_(0x54, 0x50)
#define REG_SC_BK54_51_L      _PK_L_(0x54, 0x51)
#define REG_SC_BK54_51_H      _PK_H_(0x54, 0x51)
#define REG_SC_BK54_52_L      _PK_L_(0x54, 0x52)
#define REG_SC_BK54_52_H      _PK_H_(0x54, 0x52)
#define REG_SC_BK54_53_L      _PK_L_(0x54, 0x53)
#define REG_SC_BK54_53_H      _PK_H_(0x54, 0x53)
#define REG_SC_BK54_54_L      _PK_L_(0x54, 0x54)
#define REG_SC_BK54_54_H      _PK_H_(0x54, 0x54)
#define REG_SC_BK54_55_L      _PK_L_(0x54, 0x55)
#define REG_SC_BK54_55_H      _PK_H_(0x54, 0x55)
#define REG_SC_BK54_56_L      _PK_L_(0x54, 0x56)
#define REG_SC_BK54_56_H      _PK_H_(0x54, 0x56)
#define REG_SC_BK54_57_L      _PK_L_(0x54, 0x57)
#define REG_SC_BK54_57_H      _PK_H_(0x54, 0x57)
#define REG_SC_BK54_58_L      _PK_L_(0x54, 0x58)
#define REG_SC_BK54_58_H      _PK_H_(0x54, 0x58)
#define REG_SC_BK54_59_L      _PK_L_(0x54, 0x59)
#define REG_SC_BK54_59_H      _PK_H_(0x54, 0x59)
#define REG_SC_BK54_5A_L      _PK_L_(0x54, 0x5A)
#define REG_SC_BK54_5A_H      _PK_H_(0x54, 0x5A)
#define REG_SC_BK54_5B_L      _PK_L_(0x54, 0x5B)
#define REG_SC_BK54_5B_H      _PK_H_(0x54, 0x5B)
#define REG_SC_BK54_5C_L      _PK_L_(0x54, 0x5C)
#define REG_SC_BK54_5C_H      _PK_H_(0x54, 0x5C)
#define REG_SC_BK54_5D_L      _PK_L_(0x54, 0x5D)
#define REG_SC_BK54_5D_H      _PK_H_(0x54, 0x5D)
#define REG_SC_BK54_5E_L      _PK_L_(0x54, 0x5E)
#define REG_SC_BK54_5E_H      _PK_H_(0x54, 0x5E)
#define REG_SC_BK54_5F_L      _PK_L_(0x54, 0x5F)
#define REG_SC_BK54_5F_H      _PK_H_(0x54, 0x5F)
#define REG_SC_BK54_60_L      _PK_L_(0x54, 0x60)
#define REG_SC_BK54_60_H      _PK_H_(0x54, 0x60)
#define REG_SC_BK54_61_L      _PK_L_(0x54, 0x61)
#define REG_SC_BK54_61_H      _PK_H_(0x54, 0x61)
#define REG_SC_BK54_62_L      _PK_L_(0x54, 0x62)
#define REG_SC_BK54_62_H      _PK_H_(0x54, 0x62)
#define REG_SC_BK54_63_L      _PK_L_(0x54, 0x63)
#define REG_SC_BK54_63_H      _PK_H_(0x54, 0x63)
#define REG_SC_BK54_64_L      _PK_L_(0x54, 0x64)
#define REG_SC_BK54_64_H      _PK_H_(0x54, 0x64)
#define REG_SC_BK54_65_L      _PK_L_(0x54, 0x65)
#define REG_SC_BK54_65_H      _PK_H_(0x54, 0x65)
#define REG_SC_BK54_66_L      _PK_L_(0x54, 0x66)
#define REG_SC_BK54_66_H      _PK_H_(0x54, 0x66)
#define REG_SC_BK54_67_L      _PK_L_(0x54, 0x67)
#define REG_SC_BK54_67_H      _PK_H_(0x54, 0x67)
#define REG_SC_BK54_68_L      _PK_L_(0x54, 0x68)
#define REG_SC_BK54_68_H      _PK_H_(0x54, 0x68)
#define REG_SC_BK54_69_L      _PK_L_(0x54, 0x69)
#define REG_SC_BK54_69_H      _PK_H_(0x54, 0x69)
#define REG_SC_BK54_6A_L      _PK_L_(0x54, 0x6A)
#define REG_SC_BK54_6A_H      _PK_H_(0x54, 0x6A)
#define REG_SC_BK54_6B_L      _PK_L_(0x54, 0x6B)
#define REG_SC_BK54_6B_H      _PK_H_(0x54, 0x6B)
#define REG_SC_BK54_6C_L      _PK_L_(0x54, 0x6C)
#define REG_SC_BK54_6C_H      _PK_H_(0x54, 0x6C)
#define REG_SC_BK54_6D_L      _PK_L_(0x54, 0x6D)
#define REG_SC_BK54_6D_H      _PK_H_(0x54, 0x6D)
#define REG_SC_BK54_6E_L      _PK_L_(0x54, 0x6E)
#define REG_SC_BK54_6E_H      _PK_H_(0x54, 0x6E)
#define REG_SC_BK54_6F_L      _PK_L_(0x54, 0x6F)
#define REG_SC_BK54_6F_H      _PK_H_(0x54, 0x6F)
#define REG_SC_BK54_70_L      _PK_L_(0x54, 0x70)
#define REG_SC_BK54_70_H      _PK_H_(0x54, 0x70)
#define REG_SC_BK54_71_L      _PK_L_(0x54, 0x71)
#define REG_SC_BK54_71_H      _PK_H_(0x54, 0x71)
#define REG_SC_BK54_72_L      _PK_L_(0x54, 0x72)
#define REG_SC_BK54_72_H      _PK_H_(0x54, 0x72)
#define REG_SC_BK54_73_L      _PK_L_(0x54, 0x73)
#define REG_SC_BK54_73_H      _PK_H_(0x54, 0x73)
#define REG_SC_BK54_74_L      _PK_L_(0x54, 0x74)
#define REG_SC_BK54_74_H      _PK_H_(0x54, 0x74)
#define REG_SC_BK54_75_L      _PK_L_(0x54, 0x75)
#define REG_SC_BK54_75_H      _PK_H_(0x54, 0x75)
#define REG_SC_BK54_76_L      _PK_L_(0x54, 0x76)
#define REG_SC_BK54_76_H      _PK_H_(0x54, 0x76)
#define REG_SC_BK54_77_L      _PK_L_(0x54, 0x77)
#define REG_SC_BK54_77_H      _PK_H_(0x54, 0x77)
#define REG_SC_BK54_78_L      _PK_L_(0x54, 0x78)
#define REG_SC_BK54_78_H      _PK_H_(0x54, 0x78)
#define REG_SC_BK54_79_L      _PK_L_(0x54, 0x79)
#define REG_SC_BK54_79_H      _PK_H_(0x54, 0x79)
#define REG_SC_BK54_7A_L      _PK_L_(0x54, 0x7A)
#define REG_SC_BK54_7A_H      _PK_H_(0x54, 0x7A)
#define REG_SC_BK54_7B_L      _PK_L_(0x54, 0x7B)
#define REG_SC_BK54_7B_H      _PK_H_(0x54, 0x7B)
#define REG_SC_BK54_7C_L      _PK_L_(0x54, 0x7C)
#define REG_SC_BK54_7C_H      _PK_H_(0x54, 0x7C)
#define REG_SC_BK54_7D_L      _PK_L_(0x54, 0x7D)
#define REG_SC_BK54_7D_H      _PK_H_(0x54, 0x7D)
#define REG_SC_BK54_7E_L      _PK_L_(0x54, 0x7E)
#define REG_SC_BK54_7E_H      _PK_H_(0x54, 0x7E)
#define REG_SC_BK54_7F_L      _PK_L_(0x54, 0x7F)
#define REG_SC_BK54_7F_H      _PK_H_(0x54, 0x7F)
//----------------------------------------------
#define REG_SC_BK55_00_L      _PK_L_(0x55, 0x00)
#define REG_SC_BK55_00_H      _PK_H_(0x55, 0x00)
#define REG_SC_BK55_01_L      _PK_L_(0x55, 0x01)
#define REG_SC_BK55_01_H      _PK_H_(0x55, 0x01)
#define REG_SC_BK55_02_L      _PK_L_(0x55, 0x02)
#define REG_SC_BK55_02_H      _PK_H_(0x55, 0x02)
#define REG_SC_BK55_03_L      _PK_L_(0x55, 0x03)
#define REG_SC_BK55_03_H      _PK_H_(0x55, 0x03)
#define REG_SC_BK55_04_L      _PK_L_(0x55, 0x04)
#define REG_SC_BK55_04_H      _PK_H_(0x55, 0x04)
#define REG_SC_BK55_05_L      _PK_L_(0x55, 0x05)
#define REG_SC_BK55_05_H      _PK_H_(0x55, 0x05)
#define REG_SC_BK55_06_L      _PK_L_(0x55, 0x06)
#define REG_SC_BK55_06_H      _PK_H_(0x55, 0x06)
#define REG_SC_BK55_07_L      _PK_L_(0x55, 0x07)
#define REG_SC_BK55_07_H      _PK_H_(0x55, 0x07)
#define REG_SC_BK55_08_L      _PK_L_(0x55, 0x08)
#define REG_SC_BK55_08_H      _PK_H_(0x55, 0x08)
#define REG_SC_BK55_09_L      _PK_L_(0x55, 0x09)
#define REG_SC_BK55_09_H      _PK_H_(0x55, 0x09)
#define REG_SC_BK55_0A_L      _PK_L_(0x55, 0x0A)
#define REG_SC_BK55_0A_H      _PK_H_(0x55, 0x0A)
#define REG_SC_BK55_0B_L      _PK_L_(0x55, 0x0B)
#define REG_SC_BK55_0B_H      _PK_H_(0x55, 0x0B)
#define REG_SC_BK55_0C_L      _PK_L_(0x55, 0x0C)
#define REG_SC_BK55_0C_H      _PK_H_(0x55, 0x0C)
#define REG_SC_BK55_0D_L      _PK_L_(0x55, 0x0D)
#define REG_SC_BK55_0D_H      _PK_H_(0x55, 0x0D)
#define REG_SC_BK55_0E_L      _PK_L_(0x55, 0x0E)
#define REG_SC_BK55_0E_H      _PK_H_(0x55, 0x0E)
#define REG_SC_BK55_0F_L      _PK_L_(0x55, 0x0F)
#define REG_SC_BK55_0F_H      _PK_H_(0x55, 0x0F)
#define REG_SC_BK55_10_L      _PK_L_(0x55, 0x10)
#define REG_SC_BK55_10_H      _PK_H_(0x55, 0x10)
#define REG_SC_BK55_11_L      _PK_L_(0x55, 0x11)
#define REG_SC_BK55_11_H      _PK_H_(0x55, 0x11)
#define REG_SC_BK55_12_L      _PK_L_(0x55, 0x12)
#define REG_SC_BK55_12_H      _PK_H_(0x55, 0x12)
#define REG_SC_BK55_13_L      _PK_L_(0x55, 0x13)
#define REG_SC_BK55_13_H      _PK_H_(0x55, 0x13)
#define REG_SC_BK55_14_L      _PK_L_(0x55, 0x14)
#define REG_SC_BK55_14_H      _PK_H_(0x55, 0x14)
#define REG_SC_BK55_15_L      _PK_L_(0x55, 0x15)
#define REG_SC_BK55_15_H      _PK_H_(0x55, 0x15)
#define REG_SC_BK55_16_L      _PK_L_(0x55, 0x16)
#define REG_SC_BK55_16_H      _PK_H_(0x55, 0x16)
#define REG_SC_BK55_17_L      _PK_L_(0x55, 0x17)
#define REG_SC_BK55_17_H      _PK_H_(0x55, 0x17)
#define REG_SC_BK55_18_L      _PK_L_(0x55, 0x18)
#define REG_SC_BK55_18_H      _PK_H_(0x55, 0x18)
#define REG_SC_BK55_19_L      _PK_L_(0x55, 0x19)
#define REG_SC_BK55_19_H      _PK_H_(0x55, 0x19)
#define REG_SC_BK55_1A_L      _PK_L_(0x55, 0x1A)
#define REG_SC_BK55_1A_H      _PK_H_(0x55, 0x1A)
#define REG_SC_BK55_1B_L      _PK_L_(0x55, 0x1B)
#define REG_SC_BK55_1B_H      _PK_H_(0x55, 0x1B)
#define REG_SC_BK55_1C_L      _PK_L_(0x55, 0x1C)
#define REG_SC_BK55_1C_H      _PK_H_(0x55, 0x1C)
#define REG_SC_BK55_1D_L      _PK_L_(0x55, 0x1D)
#define REG_SC_BK55_1D_H      _PK_H_(0x55, 0x1D)
#define REG_SC_BK55_1E_L      _PK_L_(0x55, 0x1E)
#define REG_SC_BK55_1E_H      _PK_H_(0x55, 0x1E)
#define REG_SC_BK55_1F_L      _PK_L_(0x55, 0x1F)
#define REG_SC_BK55_1F_H      _PK_H_(0x55, 0x1F)
#define REG_SC_BK55_20_L      _PK_L_(0x55, 0x20)
#define REG_SC_BK55_20_H      _PK_H_(0x55, 0x20)
#define REG_SC_BK55_21_L      _PK_L_(0x55, 0x21)
#define REG_SC_BK55_21_H      _PK_H_(0x55, 0x21)
#define REG_SC_BK55_22_L      _PK_L_(0x55, 0x22)
#define REG_SC_BK55_22_H      _PK_H_(0x55, 0x22)
#define REG_SC_BK55_23_L      _PK_L_(0x55, 0x23)
#define REG_SC_BK55_23_H      _PK_H_(0x55, 0x23)
#define REG_SC_BK55_24_L      _PK_L_(0x55, 0x24)
#define REG_SC_BK55_24_H      _PK_H_(0x55, 0x24)
#define REG_SC_BK55_25_L      _PK_L_(0x55, 0x25)
#define REG_SC_BK55_25_H      _PK_H_(0x55, 0x25)
#define REG_SC_BK55_26_L      _PK_L_(0x55, 0x26)
#define REG_SC_BK55_26_H      _PK_H_(0x55, 0x26)
#define REG_SC_BK55_27_L      _PK_L_(0x55, 0x27)
#define REG_SC_BK55_27_H      _PK_H_(0x55, 0x27)
#define REG_SC_BK55_28_L      _PK_L_(0x55, 0x28)
#define REG_SC_BK55_28_H      _PK_H_(0x55, 0x28)
#define REG_SC_BK55_29_L      _PK_L_(0x55, 0x29)
#define REG_SC_BK55_29_H      _PK_H_(0x55, 0x29)
#define REG_SC_BK55_2A_L      _PK_L_(0x55, 0x2A)
#define REG_SC_BK55_2A_H      _PK_H_(0x55, 0x2A)
#define REG_SC_BK55_2B_L      _PK_L_(0x55, 0x2B)
#define REG_SC_BK55_2B_H      _PK_H_(0x55, 0x2B)
#define REG_SC_BK55_2C_L      _PK_L_(0x55, 0x2C)
#define REG_SC_BK55_2C_H      _PK_H_(0x55, 0x2C)
#define REG_SC_BK55_2D_L      _PK_L_(0x55, 0x2D)
#define REG_SC_BK55_2D_H      _PK_H_(0x55, 0x2D)
#define REG_SC_BK55_2E_L      _PK_L_(0x55, 0x2E)
#define REG_SC_BK55_2E_H      _PK_H_(0x55, 0x2E)
#define REG_SC_BK55_2F_L      _PK_L_(0x55, 0x2F)
#define REG_SC_BK55_2F_H      _PK_H_(0x55, 0x2F)
#define REG_SC_BK55_30_L      _PK_L_(0x55, 0x30)
#define REG_SC_BK55_30_H      _PK_H_(0x55, 0x30)
#define REG_SC_BK55_31_L      _PK_L_(0x55, 0x31)
#define REG_SC_BK55_31_H      _PK_H_(0x55, 0x31)
#define REG_SC_BK55_32_L      _PK_L_(0x55, 0x32)
#define REG_SC_BK55_32_H      _PK_H_(0x55, 0x32)
#define REG_SC_BK55_33_L      _PK_L_(0x55, 0x33)
#define REG_SC_BK55_33_H      _PK_H_(0x55, 0x33)
#define REG_SC_BK55_34_L      _PK_L_(0x55, 0x34)
#define REG_SC_BK55_34_H      _PK_H_(0x55, 0x34)
#define REG_SC_BK55_35_L      _PK_L_(0x55, 0x35)
#define REG_SC_BK55_35_H      _PK_H_(0x55, 0x35)
#define REG_SC_BK55_36_L      _PK_L_(0x55, 0x36)
#define REG_SC_BK55_36_H      _PK_H_(0x55, 0x36)
#define REG_SC_BK55_37_L      _PK_L_(0x55, 0x37)
#define REG_SC_BK55_37_H      _PK_H_(0x55, 0x37)
#define REG_SC_BK55_38_L      _PK_L_(0x55, 0x38)
#define REG_SC_BK55_38_H      _PK_H_(0x55, 0x38)
#define REG_SC_BK55_39_L      _PK_L_(0x55, 0x39)
#define REG_SC_BK55_39_H      _PK_H_(0x55, 0x39)
#define REG_SC_BK55_3A_L      _PK_L_(0x55, 0x3A)
#define REG_SC_BK55_3A_H      _PK_H_(0x55, 0x3A)
#define REG_SC_BK55_3B_L      _PK_L_(0x55, 0x3B)
#define REG_SC_BK55_3B_H      _PK_H_(0x55, 0x3B)
#define REG_SC_BK55_3C_L      _PK_L_(0x55, 0x3C)
#define REG_SC_BK55_3C_H      _PK_H_(0x55, 0x3C)
#define REG_SC_BK55_3D_L      _PK_L_(0x55, 0x3D)
#define REG_SC_BK55_3D_H      _PK_H_(0x55, 0x3D)
#define REG_SC_BK55_3E_L      _PK_L_(0x55, 0x3E)
#define REG_SC_BK55_3E_H      _PK_H_(0x55, 0x3E)
#define REG_SC_BK55_3F_L      _PK_L_(0x55, 0x3F)
#define REG_SC_BK55_3F_H      _PK_H_(0x55, 0x3F)
#define REG_SC_BK55_40_L      _PK_L_(0x55, 0x40)
#define REG_SC_BK55_40_H      _PK_H_(0x55, 0x40)
#define REG_SC_BK55_41_L      _PK_L_(0x55, 0x41)
#define REG_SC_BK55_41_H      _PK_H_(0x55, 0x41)
#define REG_SC_BK55_42_L      _PK_L_(0x55, 0x42)
#define REG_SC_BK55_42_H      _PK_H_(0x55, 0x42)
#define REG_SC_BK55_43_L      _PK_L_(0x55, 0x43)
#define REG_SC_BK55_43_H      _PK_H_(0x55, 0x43)
#define REG_SC_BK55_44_L      _PK_L_(0x55, 0x44)
#define REG_SC_BK55_44_H      _PK_H_(0x55, 0x44)
#define REG_SC_BK55_45_L      _PK_L_(0x55, 0x45)
#define REG_SC_BK55_45_H      _PK_H_(0x55, 0x45)
#define REG_SC_BK55_46_L      _PK_L_(0x55, 0x46)
#define REG_SC_BK55_46_H      _PK_H_(0x55, 0x46)
#define REG_SC_BK55_47_L      _PK_L_(0x55, 0x47)
#define REG_SC_BK55_47_H      _PK_H_(0x55, 0x47)
#define REG_SC_BK55_48_L      _PK_L_(0x55, 0x48)
#define REG_SC_BK55_48_H      _PK_H_(0x55, 0x48)
#define REG_SC_BK55_49_L      _PK_L_(0x55, 0x49)
#define REG_SC_BK55_49_H      _PK_H_(0x55, 0x49)
#define REG_SC_BK55_4A_L      _PK_L_(0x55, 0x4A)
#define REG_SC_BK55_4A_H      _PK_H_(0x55, 0x4A)
#define REG_SC_BK55_4B_L      _PK_L_(0x55, 0x4B)
#define REG_SC_BK55_4B_H      _PK_H_(0x55, 0x4B)
#define REG_SC_BK55_4C_L      _PK_L_(0x55, 0x4C)
#define REG_SC_BK55_4C_H      _PK_H_(0x55, 0x4C)
#define REG_SC_BK55_4D_L      _PK_L_(0x55, 0x4D)
#define REG_SC_BK55_4D_H      _PK_H_(0x55, 0x4D)
#define REG_SC_BK55_4E_L      _PK_L_(0x55, 0x4E)
#define REG_SC_BK55_4E_H      _PK_H_(0x55, 0x4E)
#define REG_SC_BK55_4F_L      _PK_L_(0x55, 0x4F)
#define REG_SC_BK55_4F_H      _PK_H_(0x55, 0x4F)
#define REG_SC_BK55_50_L      _PK_L_(0x55, 0x50)
#define REG_SC_BK55_50_H      _PK_H_(0x55, 0x50)
#define REG_SC_BK55_51_L      _PK_L_(0x55, 0x51)
#define REG_SC_BK55_51_H      _PK_H_(0x55, 0x51)
#define REG_SC_BK55_52_L      _PK_L_(0x55, 0x52)
#define REG_SC_BK55_52_H      _PK_H_(0x55, 0x52)
#define REG_SC_BK55_53_L      _PK_L_(0x55, 0x53)
#define REG_SC_BK55_53_H      _PK_H_(0x55, 0x53)
#define REG_SC_BK55_54_L      _PK_L_(0x55, 0x54)
#define REG_SC_BK55_54_H      _PK_H_(0x55, 0x54)
#define REG_SC_BK55_55_L      _PK_L_(0x55, 0x55)
#define REG_SC_BK55_55_H      _PK_H_(0x55, 0x55)
#define REG_SC_BK55_56_L      _PK_L_(0x55, 0x56)
#define REG_SC_BK55_56_H      _PK_H_(0x55, 0x56)
#define REG_SC_BK55_57_L      _PK_L_(0x55, 0x57)
#define REG_SC_BK55_57_H      _PK_H_(0x55, 0x57)
#define REG_SC_BK55_58_L      _PK_L_(0x55, 0x58)
#define REG_SC_BK55_58_H      _PK_H_(0x55, 0x58)
#define REG_SC_BK55_59_L      _PK_L_(0x55, 0x59)
#define REG_SC_BK55_59_H      _PK_H_(0x55, 0x59)
#define REG_SC_BK55_5A_L      _PK_L_(0x55, 0x5A)
#define REG_SC_BK55_5A_H      _PK_H_(0x55, 0x5A)
#define REG_SC_BK55_5B_L      _PK_L_(0x55, 0x5B)
#define REG_SC_BK55_5B_H      _PK_H_(0x55, 0x5B)
#define REG_SC_BK55_5C_L      _PK_L_(0x55, 0x5C)
#define REG_SC_BK55_5C_H      _PK_H_(0x55, 0x5C)
#define REG_SC_BK55_5D_L      _PK_L_(0x55, 0x5D)
#define REG_SC_BK55_5D_H      _PK_H_(0x55, 0x5D)
#define REG_SC_BK55_5E_L      _PK_L_(0x55, 0x5E)
#define REG_SC_BK55_5E_H      _PK_H_(0x55, 0x5E)
#define REG_SC_BK55_5F_L      _PK_L_(0x55, 0x5F)
#define REG_SC_BK55_5F_H      _PK_H_(0x55, 0x5F)
#define REG_SC_BK55_60_L      _PK_L_(0x55, 0x60)
#define REG_SC_BK55_60_H      _PK_H_(0x55, 0x60)
#define REG_SC_BK55_61_L      _PK_L_(0x55, 0x61)
#define REG_SC_BK55_61_H      _PK_H_(0x55, 0x61)
#define REG_SC_BK55_62_L      _PK_L_(0x55, 0x62)
#define REG_SC_BK55_62_H      _PK_H_(0x55, 0x62)
#define REG_SC_BK55_63_L      _PK_L_(0x55, 0x63)
#define REG_SC_BK55_63_H      _PK_H_(0x55, 0x63)
#define REG_SC_BK55_64_L      _PK_L_(0x55, 0x64)
#define REG_SC_BK55_64_H      _PK_H_(0x55, 0x64)
#define REG_SC_BK55_65_L      _PK_L_(0x55, 0x65)
#define REG_SC_BK55_65_H      _PK_H_(0x55, 0x65)
#define REG_SC_BK55_66_L      _PK_L_(0x55, 0x66)
#define REG_SC_BK55_66_H      _PK_H_(0x55, 0x66)
#define REG_SC_BK55_67_L      _PK_L_(0x55, 0x67)
#define REG_SC_BK55_67_H      _PK_H_(0x55, 0x67)
#define REG_SC_BK55_68_L      _PK_L_(0x55, 0x68)
#define REG_SC_BK55_68_H      _PK_H_(0x55, 0x68)
#define REG_SC_BK55_69_L      _PK_L_(0x55, 0x69)
#define REG_SC_BK55_69_H      _PK_H_(0x55, 0x69)
#define REG_SC_BK55_6A_L      _PK_L_(0x55, 0x6A)
#define REG_SC_BK55_6A_H      _PK_H_(0x55, 0x6A)
#define REG_SC_BK55_6B_L      _PK_L_(0x55, 0x6B)
#define REG_SC_BK55_6B_H      _PK_H_(0x55, 0x6B)
#define REG_SC_BK55_6C_L      _PK_L_(0x55, 0x6C)
#define REG_SC_BK55_6C_H      _PK_H_(0x55, 0x6C)
#define REG_SC_BK55_6D_L      _PK_L_(0x55, 0x6D)
#define REG_SC_BK55_6D_H      _PK_H_(0x55, 0x6D)
#define REG_SC_BK55_6E_L      _PK_L_(0x55, 0x6E)
#define REG_SC_BK55_6E_H      _PK_H_(0x55, 0x6E)
#define REG_SC_BK55_6F_L      _PK_L_(0x55, 0x6F)
#define REG_SC_BK55_6F_H      _PK_H_(0x55, 0x6F)
#define REG_SC_BK55_70_L      _PK_L_(0x55, 0x70)
#define REG_SC_BK55_70_H      _PK_H_(0x55, 0x70)
#define REG_SC_BK55_71_L      _PK_L_(0x55, 0x71)
#define REG_SC_BK55_71_H      _PK_H_(0x55, 0x71)
#define REG_SC_BK55_72_L      _PK_L_(0x55, 0x72)
#define REG_SC_BK55_72_H      _PK_H_(0x55, 0x72)
#define REG_SC_BK55_73_L      _PK_L_(0x55, 0x73)
#define REG_SC_BK55_73_H      _PK_H_(0x55, 0x73)
#define REG_SC_BK55_74_L      _PK_L_(0x55, 0x74)
#define REG_SC_BK55_74_H      _PK_H_(0x55, 0x74)
#define REG_SC_BK55_75_L      _PK_L_(0x55, 0x75)
#define REG_SC_BK55_75_H      _PK_H_(0x55, 0x75)
#define REG_SC_BK55_76_L      _PK_L_(0x55, 0x76)
#define REG_SC_BK55_76_H      _PK_H_(0x55, 0x76)
#define REG_SC_BK55_77_L      _PK_L_(0x55, 0x77)
#define REG_SC_BK55_77_H      _PK_H_(0x55, 0x77)
#define REG_SC_BK55_78_L      _PK_L_(0x55, 0x78)
#define REG_SC_BK55_78_H      _PK_H_(0x55, 0x78)
#define REG_SC_BK55_79_L      _PK_L_(0x55, 0x79)
#define REG_SC_BK55_79_H      _PK_H_(0x55, 0x79)
#define REG_SC_BK55_7A_L      _PK_L_(0x55, 0x7A)
#define REG_SC_BK55_7A_H      _PK_H_(0x55, 0x7A)
#define REG_SC_BK55_7B_L      _PK_L_(0x55, 0x7B)
#define REG_SC_BK55_7B_H      _PK_H_(0x55, 0x7B)
#define REG_SC_BK55_7C_L      _PK_L_(0x55, 0x7C)
#define REG_SC_BK55_7C_H      _PK_H_(0x55, 0x7C)
#define REG_SC_BK55_7D_L      _PK_L_(0x55, 0x7D)
#define REG_SC_BK55_7D_H      _PK_H_(0x55, 0x7D)
#define REG_SC_BK55_7E_L      _PK_L_(0x55, 0x7E)
#define REG_SC_BK55_7E_H      _PK_H_(0x55, 0x7E)
#define REG_SC_BK55_7F_L      _PK_L_(0x55, 0x7F)
#define REG_SC_BK55_7F_H      _PK_H_(0x55, 0x7F)
//----------------------------------------------
#define REG_SC_BK56_00_L      _PK_L_(0x56, 0x00)
#define REG_SC_BK56_00_H      _PK_H_(0x56, 0x00)
#define REG_SC_BK56_01_L      _PK_L_(0x56, 0x01)
#define REG_SC_BK56_01_H      _PK_H_(0x56, 0x01)
#define REG_SC_BK56_02_L      _PK_L_(0x56, 0x02)
#define REG_SC_BK56_02_H      _PK_H_(0x56, 0x02)
#define REG_SC_BK56_03_L      _PK_L_(0x56, 0x03)
#define REG_SC_BK56_03_H      _PK_H_(0x56, 0x03)
#define REG_SC_BK56_04_L      _PK_L_(0x56, 0x04)
#define REG_SC_BK56_04_H      _PK_H_(0x56, 0x04)
#define REG_SC_BK56_05_L      _PK_L_(0x56, 0x05)
#define REG_SC_BK56_05_H      _PK_H_(0x56, 0x05)
#define REG_SC_BK56_06_L      _PK_L_(0x56, 0x06)
#define REG_SC_BK56_06_H      _PK_H_(0x56, 0x06)
#define REG_SC_BK56_07_L      _PK_L_(0x56, 0x07)
#define REG_SC_BK56_07_H      _PK_H_(0x56, 0x07)
#define REG_SC_BK56_08_L      _PK_L_(0x56, 0x08)
#define REG_SC_BK56_08_H      _PK_H_(0x56, 0x08)
#define REG_SC_BK56_09_L      _PK_L_(0x56, 0x09)
#define REG_SC_BK56_09_H      _PK_H_(0x56, 0x09)
#define REG_SC_BK56_0A_L      _PK_L_(0x56, 0x0A)
#define REG_SC_BK56_0A_H      _PK_H_(0x56, 0x0A)
#define REG_SC_BK56_0B_L      _PK_L_(0x56, 0x0B)
#define REG_SC_BK56_0B_H      _PK_H_(0x56, 0x0B)
#define REG_SC_BK56_0C_L      _PK_L_(0x56, 0x0C)
#define REG_SC_BK56_0C_H      _PK_H_(0x56, 0x0C)
#define REG_SC_BK56_0D_L      _PK_L_(0x56, 0x0D)
#define REG_SC_BK56_0D_H      _PK_H_(0x56, 0x0D)
#define REG_SC_BK56_0E_L      _PK_L_(0x56, 0x0E)
#define REG_SC_BK56_0E_H      _PK_H_(0x56, 0x0E)
#define REG_SC_BK56_0F_L      _PK_L_(0x56, 0x0F)
#define REG_SC_BK56_0F_H      _PK_H_(0x56, 0x0F)
#define REG_SC_BK56_10_L      _PK_L_(0x56, 0x10)
#define REG_SC_BK56_10_H      _PK_H_(0x56, 0x10)
#define REG_SC_BK56_11_L      _PK_L_(0x56, 0x11)
#define REG_SC_BK56_11_H      _PK_H_(0x56, 0x11)
#define REG_SC_BK56_12_L      _PK_L_(0x56, 0x12)
#define REG_SC_BK56_12_H      _PK_H_(0x56, 0x12)
#define REG_SC_BK56_13_L      _PK_L_(0x56, 0x13)
#define REG_SC_BK56_13_H      _PK_H_(0x56, 0x13)
#define REG_SC_BK56_14_L      _PK_L_(0x56, 0x14)
#define REG_SC_BK56_14_H      _PK_H_(0x56, 0x14)
#define REG_SC_BK56_15_L      _PK_L_(0x56, 0x15)
#define REG_SC_BK56_15_H      _PK_H_(0x56, 0x15)
#define REG_SC_BK56_16_L      _PK_L_(0x56, 0x16)
#define REG_SC_BK56_16_H      _PK_H_(0x56, 0x16)
#define REG_SC_BK56_17_L      _PK_L_(0x56, 0x17)
#define REG_SC_BK56_17_H      _PK_H_(0x56, 0x17)
#define REG_SC_BK56_18_L      _PK_L_(0x56, 0x18)
#define REG_SC_BK56_18_H      _PK_H_(0x56, 0x18)
#define REG_SC_BK56_19_L      _PK_L_(0x56, 0x19)
#define REG_SC_BK56_19_H      _PK_H_(0x56, 0x19)
#define REG_SC_BK56_1A_L      _PK_L_(0x56, 0x1A)
#define REG_SC_BK56_1A_H      _PK_H_(0x56, 0x1A)
#define REG_SC_BK56_1B_L      _PK_L_(0x56, 0x1B)
#define REG_SC_BK56_1B_H      _PK_H_(0x56, 0x1B)
#define REG_SC_BK56_1C_L      _PK_L_(0x56, 0x1C)
#define REG_SC_BK56_1C_H      _PK_H_(0x56, 0x1C)
#define REG_SC_BK56_1D_L      _PK_L_(0x56, 0x1D)
#define REG_SC_BK56_1D_H      _PK_H_(0x56, 0x1D)
#define REG_SC_BK56_1E_L      _PK_L_(0x56, 0x1E)
#define REG_SC_BK56_1E_H      _PK_H_(0x56, 0x1E)
#define REG_SC_BK56_1F_L      _PK_L_(0x56, 0x1F)
#define REG_SC_BK56_1F_H      _PK_H_(0x56, 0x1F)
#define REG_SC_BK56_20_L      _PK_L_(0x56, 0x20)
#define REG_SC_BK56_20_H      _PK_H_(0x56, 0x20)
#define REG_SC_BK56_21_L      _PK_L_(0x56, 0x21)
#define REG_SC_BK56_21_H      _PK_H_(0x56, 0x21)
#define REG_SC_BK56_22_L      _PK_L_(0x56, 0x22)
#define REG_SC_BK56_22_H      _PK_H_(0x56, 0x22)
#define REG_SC_BK56_23_L      _PK_L_(0x56, 0x23)
#define REG_SC_BK56_23_H      _PK_H_(0x56, 0x23)
#define REG_SC_BK56_24_L      _PK_L_(0x56, 0x24)
#define REG_SC_BK56_24_H      _PK_H_(0x56, 0x24)
#define REG_SC_BK56_25_L      _PK_L_(0x56, 0x25)
#define REG_SC_BK56_25_H      _PK_H_(0x56, 0x25)
#define REG_SC_BK56_26_L      _PK_L_(0x56, 0x26)
#define REG_SC_BK56_26_H      _PK_H_(0x56, 0x26)
#define REG_SC_BK56_27_L      _PK_L_(0x56, 0x27)
#define REG_SC_BK56_27_H      _PK_H_(0x56, 0x27)
#define REG_SC_BK56_28_L      _PK_L_(0x56, 0x28)
#define REG_SC_BK56_28_H      _PK_H_(0x56, 0x28)
#define REG_SC_BK56_29_L      _PK_L_(0x56, 0x29)
#define REG_SC_BK56_29_H      _PK_H_(0x56, 0x29)
#define REG_SC_BK56_2A_L      _PK_L_(0x56, 0x2A)
#define REG_SC_BK56_2A_H      _PK_H_(0x56, 0x2A)
#define REG_SC_BK56_2B_L      _PK_L_(0x56, 0x2B)
#define REG_SC_BK56_2B_H      _PK_H_(0x56, 0x2B)
#define REG_SC_BK56_2C_L      _PK_L_(0x56, 0x2C)
#define REG_SC_BK56_2C_H      _PK_H_(0x56, 0x2C)
#define REG_SC_BK56_2D_L      _PK_L_(0x56, 0x2D)
#define REG_SC_BK56_2D_H      _PK_H_(0x56, 0x2D)
#define REG_SC_BK56_2E_L      _PK_L_(0x56, 0x2E)
#define REG_SC_BK56_2E_H      _PK_H_(0x56, 0x2E)
#define REG_SC_BK56_2F_L      _PK_L_(0x56, 0x2F)
#define REG_SC_BK56_2F_H      _PK_H_(0x56, 0x2F)
#define REG_SC_BK56_30_L      _PK_L_(0x56, 0x30)
#define REG_SC_BK56_30_H      _PK_H_(0x56, 0x30)
#define REG_SC_BK56_31_L      _PK_L_(0x56, 0x31)
#define REG_SC_BK56_31_H      _PK_H_(0x56, 0x31)
#define REG_SC_BK56_32_L      _PK_L_(0x56, 0x32)
#define REG_SC_BK56_32_H      _PK_H_(0x56, 0x32)
#define REG_SC_BK56_33_L      _PK_L_(0x56, 0x33)
#define REG_SC_BK56_33_H      _PK_H_(0x56, 0x33)
#define REG_SC_BK56_34_L      _PK_L_(0x56, 0x34)
#define REG_SC_BK56_34_H      _PK_H_(0x56, 0x34)
#define REG_SC_BK56_35_L      _PK_L_(0x56, 0x35)
#define REG_SC_BK56_35_H      _PK_H_(0x56, 0x35)
#define REG_SC_BK56_36_L      _PK_L_(0x56, 0x36)
#define REG_SC_BK56_36_H      _PK_H_(0x56, 0x36)
#define REG_SC_BK56_37_L      _PK_L_(0x56, 0x37)
#define REG_SC_BK56_37_H      _PK_H_(0x56, 0x37)
#define REG_SC_BK56_38_L      _PK_L_(0x56, 0x38)
#define REG_SC_BK56_38_H      _PK_H_(0x56, 0x38)
#define REG_SC_BK56_39_L      _PK_L_(0x56, 0x39)
#define REG_SC_BK56_39_H      _PK_H_(0x56, 0x39)
#define REG_SC_BK56_3A_L      _PK_L_(0x56, 0x3A)
#define REG_SC_BK56_3A_H      _PK_H_(0x56, 0x3A)
#define REG_SC_BK56_3B_L      _PK_L_(0x56, 0x3B)
#define REG_SC_BK56_3B_H      _PK_H_(0x56, 0x3B)
#define REG_SC_BK56_3C_L      _PK_L_(0x56, 0x3C)
#define REG_SC_BK56_3C_H      _PK_H_(0x56, 0x3C)
#define REG_SC_BK56_3D_L      _PK_L_(0x56, 0x3D)
#define REG_SC_BK56_3D_H      _PK_H_(0x56, 0x3D)
#define REG_SC_BK56_3E_L      _PK_L_(0x56, 0x3E)
#define REG_SC_BK56_3E_H      _PK_H_(0x56, 0x3E)
#define REG_SC_BK56_3F_L      _PK_L_(0x56, 0x3F)
#define REG_SC_BK56_3F_H      _PK_H_(0x56, 0x3F)
#define REG_SC_BK56_40_L      _PK_L_(0x56, 0x40)
#define REG_SC_BK56_40_H      _PK_H_(0x56, 0x40)
#define REG_SC_BK56_41_L      _PK_L_(0x56, 0x41)
#define REG_SC_BK56_41_H      _PK_H_(0x56, 0x41)
#define REG_SC_BK56_42_L      _PK_L_(0x56, 0x42)
#define REG_SC_BK56_42_H      _PK_H_(0x56, 0x42)
#define REG_SC_BK56_43_L      _PK_L_(0x56, 0x43)
#define REG_SC_BK56_43_H      _PK_H_(0x56, 0x43)
#define REG_SC_BK56_44_L      _PK_L_(0x56, 0x44)
#define REG_SC_BK56_44_H      _PK_H_(0x56, 0x44)
#define REG_SC_BK56_45_L      _PK_L_(0x56, 0x45)
#define REG_SC_BK56_45_H      _PK_H_(0x56, 0x45)
#define REG_SC_BK56_46_L      _PK_L_(0x56, 0x46)
#define REG_SC_BK56_46_H      _PK_H_(0x56, 0x46)
#define REG_SC_BK56_47_L      _PK_L_(0x56, 0x47)
#define REG_SC_BK56_47_H      _PK_H_(0x56, 0x47)
#define REG_SC_BK56_48_L      _PK_L_(0x56, 0x48)
#define REG_SC_BK56_48_H      _PK_H_(0x56, 0x48)
#define REG_SC_BK56_49_L      _PK_L_(0x56, 0x49)
#define REG_SC_BK56_49_H      _PK_H_(0x56, 0x49)
#define REG_SC_BK56_4A_L      _PK_L_(0x56, 0x4A)
#define REG_SC_BK56_4A_H      _PK_H_(0x56, 0x4A)
#define REG_SC_BK56_4B_L      _PK_L_(0x56, 0x4B)
#define REG_SC_BK56_4B_H      _PK_H_(0x56, 0x4B)
#define REG_SC_BK56_4C_L      _PK_L_(0x56, 0x4C)
#define REG_SC_BK56_4C_H      _PK_H_(0x56, 0x4C)
#define REG_SC_BK56_4D_L      _PK_L_(0x56, 0x4D)
#define REG_SC_BK56_4D_H      _PK_H_(0x56, 0x4D)
#define REG_SC_BK56_4E_L      _PK_L_(0x56, 0x4E)
#define REG_SC_BK56_4E_H      _PK_H_(0x56, 0x4E)
#define REG_SC_BK56_4F_L      _PK_L_(0x56, 0x4F)
#define REG_SC_BK56_4F_H      _PK_H_(0x56, 0x4F)
#define REG_SC_BK56_50_L      _PK_L_(0x56, 0x50)
#define REG_SC_BK56_50_H      _PK_H_(0x56, 0x50)
#define REG_SC_BK56_51_L      _PK_L_(0x56, 0x51)
#define REG_SC_BK56_51_H      _PK_H_(0x56, 0x51)
#define REG_SC_BK56_52_L      _PK_L_(0x56, 0x52)
#define REG_SC_BK56_52_H      _PK_H_(0x56, 0x52)
#define REG_SC_BK56_53_L      _PK_L_(0x56, 0x53)
#define REG_SC_BK56_53_H      _PK_H_(0x56, 0x53)
#define REG_SC_BK56_54_L      _PK_L_(0x56, 0x54)
#define REG_SC_BK56_54_H      _PK_H_(0x56, 0x54)
#define REG_SC_BK56_55_L      _PK_L_(0x56, 0x55)
#define REG_SC_BK56_55_H      _PK_H_(0x56, 0x55)
#define REG_SC_BK56_56_L      _PK_L_(0x56, 0x56)
#define REG_SC_BK56_56_H      _PK_H_(0x56, 0x56)
#define REG_SC_BK56_57_L      _PK_L_(0x56, 0x57)
#define REG_SC_BK56_57_H      _PK_H_(0x56, 0x57)
#define REG_SC_BK56_58_L      _PK_L_(0x56, 0x58)
#define REG_SC_BK56_58_H      _PK_H_(0x56, 0x58)
#define REG_SC_BK56_59_L      _PK_L_(0x56, 0x59)
#define REG_SC_BK56_59_H      _PK_H_(0x56, 0x59)
#define REG_SC_BK56_5A_L      _PK_L_(0x56, 0x5A)
#define REG_SC_BK56_5A_H      _PK_H_(0x56, 0x5A)
#define REG_SC_BK56_5B_L      _PK_L_(0x56, 0x5B)
#define REG_SC_BK56_5B_H      _PK_H_(0x56, 0x5B)
#define REG_SC_BK56_5C_L      _PK_L_(0x56, 0x5C)
#define REG_SC_BK56_5C_H      _PK_H_(0x56, 0x5C)
#define REG_SC_BK56_5D_L      _PK_L_(0x56, 0x5D)
#define REG_SC_BK56_5D_H      _PK_H_(0x56, 0x5D)
#define REG_SC_BK56_5E_L      _PK_L_(0x56, 0x5E)
#define REG_SC_BK56_5E_H      _PK_H_(0x56, 0x5E)
#define REG_SC_BK56_5F_L      _PK_L_(0x56, 0x5F)
#define REG_SC_BK56_5F_H      _PK_H_(0x56, 0x5F)
#define REG_SC_BK56_60_L      _PK_L_(0x56, 0x60)
#define REG_SC_BK56_60_H      _PK_H_(0x56, 0x60)
#define REG_SC_BK56_61_L      _PK_L_(0x56, 0x61)
#define REG_SC_BK56_61_H      _PK_H_(0x56, 0x61)
#define REG_SC_BK56_62_L      _PK_L_(0x56, 0x62)
#define REG_SC_BK56_62_H      _PK_H_(0x56, 0x62)
#define REG_SC_BK56_63_L      _PK_L_(0x56, 0x63)
#define REG_SC_BK56_63_H      _PK_H_(0x56, 0x63)
#define REG_SC_BK56_64_L      _PK_L_(0x56, 0x64)
#define REG_SC_BK56_64_H      _PK_H_(0x56, 0x64)
#define REG_SC_BK56_65_L      _PK_L_(0x56, 0x65)
#define REG_SC_BK56_65_H      _PK_H_(0x56, 0x65)
#define REG_SC_BK56_66_L      _PK_L_(0x56, 0x66)
#define REG_SC_BK56_66_H      _PK_H_(0x56, 0x66)
#define REG_SC_BK56_67_L      _PK_L_(0x56, 0x67)
#define REG_SC_BK56_67_H      _PK_H_(0x56, 0x67)
#define REG_SC_BK56_68_L      _PK_L_(0x56, 0x68)
#define REG_SC_BK56_68_H      _PK_H_(0x56, 0x68)
#define REG_SC_BK56_69_L      _PK_L_(0x56, 0x69)
#define REG_SC_BK56_69_H      _PK_H_(0x56, 0x69)
#define REG_SC_BK56_6A_L      _PK_L_(0x56, 0x6A)
#define REG_SC_BK56_6A_H      _PK_H_(0x56, 0x6A)
#define REG_SC_BK56_6B_L      _PK_L_(0x56, 0x6B)
#define REG_SC_BK56_6B_H      _PK_H_(0x56, 0x6B)
#define REG_SC_BK56_6C_L      _PK_L_(0x56, 0x6C)
#define REG_SC_BK56_6C_H      _PK_H_(0x56, 0x6C)
#define REG_SC_BK56_6D_L      _PK_L_(0x56, 0x6D)
#define REG_SC_BK56_6D_H      _PK_H_(0x56, 0x6D)
#define REG_SC_BK56_6E_L      _PK_L_(0x56, 0x6E)
#define REG_SC_BK56_6E_H      _PK_H_(0x56, 0x6E)
#define REG_SC_BK56_6F_L      _PK_L_(0x56, 0x6F)
#define REG_SC_BK56_6F_H      _PK_H_(0x56, 0x6F)
#define REG_SC_BK56_70_L      _PK_L_(0x56, 0x70)
#define REG_SC_BK56_70_H      _PK_H_(0x56, 0x70)
#define REG_SC_BK56_71_L      _PK_L_(0x56, 0x71)
#define REG_SC_BK56_71_H      _PK_H_(0x56, 0x71)
#define REG_SC_BK56_72_L      _PK_L_(0x56, 0x72)
#define REG_SC_BK56_72_H      _PK_H_(0x56, 0x72)
#define REG_SC_BK56_73_L      _PK_L_(0x56, 0x73)
#define REG_SC_BK56_73_H      _PK_H_(0x56, 0x73)
#define REG_SC_BK56_74_L      _PK_L_(0x56, 0x74)
#define REG_SC_BK56_74_H      _PK_H_(0x56, 0x74)
#define REG_SC_BK56_75_L      _PK_L_(0x56, 0x75)
#define REG_SC_BK56_75_H      _PK_H_(0x56, 0x75)
#define REG_SC_BK56_76_L      _PK_L_(0x56, 0x76)
#define REG_SC_BK56_76_H      _PK_H_(0x56, 0x76)
#define REG_SC_BK56_77_L      _PK_L_(0x56, 0x77)
#define REG_SC_BK56_77_H      _PK_H_(0x56, 0x77)
#define REG_SC_BK56_78_L      _PK_L_(0x56, 0x78)
#define REG_SC_BK56_78_H      _PK_H_(0x56, 0x78)
#define REG_SC_BK56_79_L      _PK_L_(0x56, 0x79)
#define REG_SC_BK56_79_H      _PK_H_(0x56, 0x79)
#define REG_SC_BK56_7A_L      _PK_L_(0x56, 0x7A)
#define REG_SC_BK56_7A_H      _PK_H_(0x56, 0x7A)
#define REG_SC_BK56_7B_L      _PK_L_(0x56, 0x7B)
#define REG_SC_BK56_7B_H      _PK_H_(0x56, 0x7B)
#define REG_SC_BK56_7C_L      _PK_L_(0x56, 0x7C)
#define REG_SC_BK56_7C_H      _PK_H_(0x56, 0x7C)
#define REG_SC_BK56_7D_L      _PK_L_(0x56, 0x7D)
#define REG_SC_BK56_7D_H      _PK_H_(0x56, 0x7D)
#define REG_SC_BK56_7E_L      _PK_L_(0x56, 0x7E)
#define REG_SC_BK56_7E_H      _PK_H_(0x56, 0x7E)
#define REG_SC_BK56_7F_L      _PK_L_(0x56, 0x7F)
#define REG_SC_BK56_7F_H      _PK_H_(0x56, 0x7F)
//----------------------------------------------
#define REG_SC_BK57_00_L      _PK_L_(0x57, 0x00)
#define REG_SC_BK57_00_H      _PK_H_(0x57, 0x00)
#define REG_SC_BK57_01_L      _PK_L_(0x57, 0x01)
#define REG_SC_BK57_01_H      _PK_H_(0x57, 0x01)
#define REG_SC_BK57_02_L      _PK_L_(0x57, 0x02)
#define REG_SC_BK57_02_H      _PK_H_(0x57, 0x02)
#define REG_SC_BK57_03_L      _PK_L_(0x57, 0x03)
#define REG_SC_BK57_03_H      _PK_H_(0x57, 0x03)
#define REG_SC_BK57_04_L      _PK_L_(0x57, 0x04)
#define REG_SC_BK57_04_H      _PK_H_(0x57, 0x04)
#define REG_SC_BK57_05_L      _PK_L_(0x57, 0x05)
#define REG_SC_BK57_05_H      _PK_H_(0x57, 0x05)
#define REG_SC_BK57_06_L      _PK_L_(0x57, 0x06)
#define REG_SC_BK57_06_H      _PK_H_(0x57, 0x06)
#define REG_SC_BK57_07_L      _PK_L_(0x57, 0x07)
#define REG_SC_BK57_07_H      _PK_H_(0x57, 0x07)
#define REG_SC_BK57_08_L      _PK_L_(0x57, 0x08)
#define REG_SC_BK57_08_H      _PK_H_(0x57, 0x08)
#define REG_SC_BK57_09_L      _PK_L_(0x57, 0x09)
#define REG_SC_BK57_09_H      _PK_H_(0x57, 0x09)
#define REG_SC_BK57_0A_L      _PK_L_(0x57, 0x0A)
#define REG_SC_BK57_0A_H      _PK_H_(0x57, 0x0A)
#define REG_SC_BK57_0B_L      _PK_L_(0x57, 0x0B)
#define REG_SC_BK57_0B_H      _PK_H_(0x57, 0x0B)
#define REG_SC_BK57_0C_L      _PK_L_(0x57, 0x0C)
#define REG_SC_BK57_0C_H      _PK_H_(0x57, 0x0C)
#define REG_SC_BK57_0D_L      _PK_L_(0x57, 0x0D)
#define REG_SC_BK57_0D_H      _PK_H_(0x57, 0x0D)
#define REG_SC_BK57_0E_L      _PK_L_(0x57, 0x0E)
#define REG_SC_BK57_0E_H      _PK_H_(0x57, 0x0E)
#define REG_SC_BK57_0F_L      _PK_L_(0x57, 0x0F)
#define REG_SC_BK57_0F_H      _PK_H_(0x57, 0x0F)
#define REG_SC_BK57_10_L      _PK_L_(0x57, 0x10)
#define REG_SC_BK57_10_H      _PK_H_(0x57, 0x10)
#define REG_SC_BK57_11_L      _PK_L_(0x57, 0x11)
#define REG_SC_BK57_11_H      _PK_H_(0x57, 0x11)
#define REG_SC_BK57_12_L      _PK_L_(0x57, 0x12)
#define REG_SC_BK57_12_H      _PK_H_(0x57, 0x12)
#define REG_SC_BK57_13_L      _PK_L_(0x57, 0x13)
#define REG_SC_BK57_13_H      _PK_H_(0x57, 0x13)
#define REG_SC_BK57_14_L      _PK_L_(0x57, 0x14)
#define REG_SC_BK57_14_H      _PK_H_(0x57, 0x14)
#define REG_SC_BK57_15_L      _PK_L_(0x57, 0x15)
#define REG_SC_BK57_15_H      _PK_H_(0x57, 0x15)
#define REG_SC_BK57_16_L      _PK_L_(0x57, 0x16)
#define REG_SC_BK57_16_H      _PK_H_(0x57, 0x16)
#define REG_SC_BK57_17_L      _PK_L_(0x57, 0x17)
#define REG_SC_BK57_17_H      _PK_H_(0x57, 0x17)
#define REG_SC_BK57_18_L      _PK_L_(0x57, 0x18)
#define REG_SC_BK57_18_H      _PK_H_(0x57, 0x18)
#define REG_SC_BK57_19_L      _PK_L_(0x57, 0x19)
#define REG_SC_BK57_19_H      _PK_H_(0x57, 0x19)
#define REG_SC_BK57_1A_L      _PK_L_(0x57, 0x1A)
#define REG_SC_BK57_1A_H      _PK_H_(0x57, 0x1A)
#define REG_SC_BK57_1B_L      _PK_L_(0x57, 0x1B)
#define REG_SC_BK57_1B_H      _PK_H_(0x57, 0x1B)
#define REG_SC_BK57_1C_L      _PK_L_(0x57, 0x1C)
#define REG_SC_BK57_1C_H      _PK_H_(0x57, 0x1C)
#define REG_SC_BK57_1D_L      _PK_L_(0x57, 0x1D)
#define REG_SC_BK57_1D_H      _PK_H_(0x57, 0x1D)
#define REG_SC_BK57_1E_L      _PK_L_(0x57, 0x1E)
#define REG_SC_BK57_1E_H      _PK_H_(0x57, 0x1E)
#define REG_SC_BK57_1F_L      _PK_L_(0x57, 0x1F)
#define REG_SC_BK57_1F_H      _PK_H_(0x57, 0x1F)
#define REG_SC_BK57_20_L      _PK_L_(0x57, 0x20)
#define REG_SC_BK57_20_H      _PK_H_(0x57, 0x20)
#define REG_SC_BK57_21_L      _PK_L_(0x57, 0x21)
#define REG_SC_BK57_21_H      _PK_H_(0x57, 0x21)
#define REG_SC_BK57_22_L      _PK_L_(0x57, 0x22)
#define REG_SC_BK57_22_H      _PK_H_(0x57, 0x22)
#define REG_SC_BK57_23_L      _PK_L_(0x57, 0x23)
#define REG_SC_BK57_23_H      _PK_H_(0x57, 0x23)
#define REG_SC_BK57_24_L      _PK_L_(0x57, 0x24)
#define REG_SC_BK57_24_H      _PK_H_(0x57, 0x24)
#define REG_SC_BK57_25_L      _PK_L_(0x57, 0x25)
#define REG_SC_BK57_25_H      _PK_H_(0x57, 0x25)
#define REG_SC_BK57_26_L      _PK_L_(0x57, 0x26)
#define REG_SC_BK57_26_H      _PK_H_(0x57, 0x26)
#define REG_SC_BK57_27_L      _PK_L_(0x57, 0x27)
#define REG_SC_BK57_27_H      _PK_H_(0x57, 0x27)
#define REG_SC_BK57_28_L      _PK_L_(0x57, 0x28)
#define REG_SC_BK57_28_H      _PK_H_(0x57, 0x28)
#define REG_SC_BK57_29_L      _PK_L_(0x57, 0x29)
#define REG_SC_BK57_29_H      _PK_H_(0x57, 0x29)
#define REG_SC_BK57_2A_L      _PK_L_(0x57, 0x2A)
#define REG_SC_BK57_2A_H      _PK_H_(0x57, 0x2A)
#define REG_SC_BK57_2B_L      _PK_L_(0x57, 0x2B)
#define REG_SC_BK57_2B_H      _PK_H_(0x57, 0x2B)
#define REG_SC_BK57_2C_L      _PK_L_(0x57, 0x2C)
#define REG_SC_BK57_2C_H      _PK_H_(0x57, 0x2C)
#define REG_SC_BK57_2D_L      _PK_L_(0x57, 0x2D)
#define REG_SC_BK57_2D_H      _PK_H_(0x57, 0x2D)
#define REG_SC_BK57_2E_L      _PK_L_(0x57, 0x2E)
#define REG_SC_BK57_2E_H      _PK_H_(0x57, 0x2E)
#define REG_SC_BK57_2F_L      _PK_L_(0x57, 0x2F)
#define REG_SC_BK57_2F_H      _PK_H_(0x57, 0x2F)
#define REG_SC_BK57_30_L      _PK_L_(0x57, 0x30)
#define REG_SC_BK57_30_H      _PK_H_(0x57, 0x30)
#define REG_SC_BK57_31_L      _PK_L_(0x57, 0x31)
#define REG_SC_BK57_31_H      _PK_H_(0x57, 0x31)
#define REG_SC_BK57_32_L      _PK_L_(0x57, 0x32)
#define REG_SC_BK57_32_H      _PK_H_(0x57, 0x32)
#define REG_SC_BK57_33_L      _PK_L_(0x57, 0x33)
#define REG_SC_BK57_33_H      _PK_H_(0x57, 0x33)
#define REG_SC_BK57_34_L      _PK_L_(0x57, 0x34)
#define REG_SC_BK57_34_H      _PK_H_(0x57, 0x34)
#define REG_SC_BK57_35_L      _PK_L_(0x57, 0x35)
#define REG_SC_BK57_35_H      _PK_H_(0x57, 0x35)
#define REG_SC_BK57_36_L      _PK_L_(0x57, 0x36)
#define REG_SC_BK57_36_H      _PK_H_(0x57, 0x36)
#define REG_SC_BK57_37_L      _PK_L_(0x57, 0x37)
#define REG_SC_BK57_37_H      _PK_H_(0x57, 0x37)
#define REG_SC_BK57_38_L      _PK_L_(0x57, 0x38)
#define REG_SC_BK57_38_H      _PK_H_(0x57, 0x38)
#define REG_SC_BK57_39_L      _PK_L_(0x57, 0x39)
#define REG_SC_BK57_39_H      _PK_H_(0x57, 0x39)
#define REG_SC_BK57_3A_L      _PK_L_(0x57, 0x3A)
#define REG_SC_BK57_3A_H      _PK_H_(0x57, 0x3A)
#define REG_SC_BK57_3B_L      _PK_L_(0x57, 0x3B)
#define REG_SC_BK57_3B_H      _PK_H_(0x57, 0x3B)
#define REG_SC_BK57_3C_L      _PK_L_(0x57, 0x3C)
#define REG_SC_BK57_3C_H      _PK_H_(0x57, 0x3C)
#define REG_SC_BK57_3D_L      _PK_L_(0x57, 0x3D)
#define REG_SC_BK57_3D_H      _PK_H_(0x57, 0x3D)
#define REG_SC_BK57_3E_L      _PK_L_(0x57, 0x3E)
#define REG_SC_BK57_3E_H      _PK_H_(0x57, 0x3E)
#define REG_SC_BK57_3F_L      _PK_L_(0x57, 0x3F)
#define REG_SC_BK57_3F_H      _PK_H_(0x57, 0x3F)
#define REG_SC_BK57_40_L      _PK_L_(0x57, 0x40)
#define REG_SC_BK57_40_H      _PK_H_(0x57, 0x40)
#define REG_SC_BK57_41_L      _PK_L_(0x57, 0x41)
#define REG_SC_BK57_41_H      _PK_H_(0x57, 0x41)
#define REG_SC_BK57_42_L      _PK_L_(0x57, 0x42)
#define REG_SC_BK57_42_H      _PK_H_(0x57, 0x42)
#define REG_SC_BK57_43_L      _PK_L_(0x57, 0x43)
#define REG_SC_BK57_43_H      _PK_H_(0x57, 0x43)
#define REG_SC_BK57_44_L      _PK_L_(0x57, 0x44)
#define REG_SC_BK57_44_H      _PK_H_(0x57, 0x44)
#define REG_SC_BK57_45_L      _PK_L_(0x57, 0x45)
#define REG_SC_BK57_45_H      _PK_H_(0x57, 0x45)
#define REG_SC_BK57_46_L      _PK_L_(0x57, 0x46)
#define REG_SC_BK57_46_H      _PK_H_(0x57, 0x46)
#define REG_SC_BK57_47_L      _PK_L_(0x57, 0x47)
#define REG_SC_BK57_47_H      _PK_H_(0x57, 0x47)
#define REG_SC_BK57_48_L      _PK_L_(0x57, 0x48)
#define REG_SC_BK57_48_H      _PK_H_(0x57, 0x48)
#define REG_SC_BK57_49_L      _PK_L_(0x57, 0x49)
#define REG_SC_BK57_49_H      _PK_H_(0x57, 0x49)
#define REG_SC_BK57_4A_L      _PK_L_(0x57, 0x4A)
#define REG_SC_BK57_4A_H      _PK_H_(0x57, 0x4A)
#define REG_SC_BK57_4B_L      _PK_L_(0x57, 0x4B)
#define REG_SC_BK57_4B_H      _PK_H_(0x57, 0x4B)
#define REG_SC_BK57_4C_L      _PK_L_(0x57, 0x4C)
#define REG_SC_BK57_4C_H      _PK_H_(0x57, 0x4C)
#define REG_SC_BK57_4D_L      _PK_L_(0x57, 0x4D)
#define REG_SC_BK57_4D_H      _PK_H_(0x57, 0x4D)
#define REG_SC_BK57_4E_L      _PK_L_(0x57, 0x4E)
#define REG_SC_BK57_4E_H      _PK_H_(0x57, 0x4E)
#define REG_SC_BK57_4F_L      _PK_L_(0x57, 0x4F)
#define REG_SC_BK57_4F_H      _PK_H_(0x57, 0x4F)
#define REG_SC_BK57_50_L      _PK_L_(0x57, 0x50)
#define REG_SC_BK57_50_H      _PK_H_(0x57, 0x50)
#define REG_SC_BK57_51_L      _PK_L_(0x57, 0x51)
#define REG_SC_BK57_51_H      _PK_H_(0x57, 0x51)
#define REG_SC_BK57_52_L      _PK_L_(0x57, 0x52)
#define REG_SC_BK57_52_H      _PK_H_(0x57, 0x52)
#define REG_SC_BK57_53_L      _PK_L_(0x57, 0x53)
#define REG_SC_BK57_53_H      _PK_H_(0x57, 0x53)
#define REG_SC_BK57_54_L      _PK_L_(0x57, 0x54)
#define REG_SC_BK57_54_H      _PK_H_(0x57, 0x54)
#define REG_SC_BK57_55_L      _PK_L_(0x57, 0x55)
#define REG_SC_BK57_55_H      _PK_H_(0x57, 0x55)
#define REG_SC_BK57_56_L      _PK_L_(0x57, 0x56)
#define REG_SC_BK57_56_H      _PK_H_(0x57, 0x56)
#define REG_SC_BK57_57_L      _PK_L_(0x57, 0x57)
#define REG_SC_BK57_57_H      _PK_H_(0x57, 0x57)
#define REG_SC_BK57_58_L      _PK_L_(0x57, 0x58)
#define REG_SC_BK57_58_H      _PK_H_(0x57, 0x58)
#define REG_SC_BK57_59_L      _PK_L_(0x57, 0x59)
#define REG_SC_BK57_59_H      _PK_H_(0x57, 0x59)
#define REG_SC_BK57_5A_L      _PK_L_(0x57, 0x5A)
#define REG_SC_BK57_5A_H      _PK_H_(0x57, 0x5A)
#define REG_SC_BK57_5B_L      _PK_L_(0x57, 0x5B)
#define REG_SC_BK57_5B_H      _PK_H_(0x57, 0x5B)
#define REG_SC_BK57_5C_L      _PK_L_(0x57, 0x5C)
#define REG_SC_BK57_5C_H      _PK_H_(0x57, 0x5C)
#define REG_SC_BK57_5D_L      _PK_L_(0x57, 0x5D)
#define REG_SC_BK57_5D_H      _PK_H_(0x57, 0x5D)
#define REG_SC_BK57_5E_L      _PK_L_(0x57, 0x5E)
#define REG_SC_BK57_5E_H      _PK_H_(0x57, 0x5E)
#define REG_SC_BK57_5F_L      _PK_L_(0x57, 0x5F)
#define REG_SC_BK57_5F_H      _PK_H_(0x57, 0x5F)
#define REG_SC_BK57_60_L      _PK_L_(0x57, 0x60)
#define REG_SC_BK57_60_H      _PK_H_(0x57, 0x60)
#define REG_SC_BK57_61_L      _PK_L_(0x57, 0x61)
#define REG_SC_BK57_61_H      _PK_H_(0x57, 0x61)
#define REG_SC_BK57_62_L      _PK_L_(0x57, 0x62)
#define REG_SC_BK57_62_H      _PK_H_(0x57, 0x62)
#define REG_SC_BK57_63_L      _PK_L_(0x57, 0x63)
#define REG_SC_BK57_63_H      _PK_H_(0x57, 0x63)
#define REG_SC_BK57_64_L      _PK_L_(0x57, 0x64)
#define REG_SC_BK57_64_H      _PK_H_(0x57, 0x64)
#define REG_SC_BK57_65_L      _PK_L_(0x57, 0x65)
#define REG_SC_BK57_65_H      _PK_H_(0x57, 0x65)
#define REG_SC_BK57_66_L      _PK_L_(0x57, 0x66)
#define REG_SC_BK57_66_H      _PK_H_(0x57, 0x66)
#define REG_SC_BK57_67_L      _PK_L_(0x57, 0x67)
#define REG_SC_BK57_67_H      _PK_H_(0x57, 0x67)
#define REG_SC_BK57_68_L      _PK_L_(0x57, 0x68)
#define REG_SC_BK57_68_H      _PK_H_(0x57, 0x68)
#define REG_SC_BK57_69_L      _PK_L_(0x57, 0x69)
#define REG_SC_BK57_69_H      _PK_H_(0x57, 0x69)
#define REG_SC_BK57_6A_L      _PK_L_(0x57, 0x6A)
#define REG_SC_BK57_6A_H      _PK_H_(0x57, 0x6A)
#define REG_SC_BK57_6B_L      _PK_L_(0x57, 0x6B)
#define REG_SC_BK57_6B_H      _PK_H_(0x57, 0x6B)
#define REG_SC_BK57_6C_L      _PK_L_(0x57, 0x6C)
#define REG_SC_BK57_6C_H      _PK_H_(0x57, 0x6C)
#define REG_SC_BK57_6D_L      _PK_L_(0x57, 0x6D)
#define REG_SC_BK57_6D_H      _PK_H_(0x57, 0x6D)
#define REG_SC_BK57_6E_L      _PK_L_(0x57, 0x6E)
#define REG_SC_BK57_6E_H      _PK_H_(0x57, 0x6E)
#define REG_SC_BK57_6F_L      _PK_L_(0x57, 0x6F)
#define REG_SC_BK57_6F_H      _PK_H_(0x57, 0x6F)
#define REG_SC_BK57_70_L      _PK_L_(0x57, 0x70)
#define REG_SC_BK57_70_H      _PK_H_(0x57, 0x70)
#define REG_SC_BK57_71_L      _PK_L_(0x57, 0x71)
#define REG_SC_BK57_71_H      _PK_H_(0x57, 0x71)
#define REG_SC_BK57_72_L      _PK_L_(0x57, 0x72)
#define REG_SC_BK57_72_H      _PK_H_(0x57, 0x72)
#define REG_SC_BK57_73_L      _PK_L_(0x57, 0x73)
#define REG_SC_BK57_73_H      _PK_H_(0x57, 0x73)
#define REG_SC_BK57_74_L      _PK_L_(0x57, 0x74)
#define REG_SC_BK57_74_H      _PK_H_(0x57, 0x74)
#define REG_SC_BK57_75_L      _PK_L_(0x57, 0x75)
#define REG_SC_BK57_75_H      _PK_H_(0x57, 0x75)
#define REG_SC_BK57_76_L      _PK_L_(0x57, 0x76)
#define REG_SC_BK57_76_H      _PK_H_(0x57, 0x76)
#define REG_SC_BK57_77_L      _PK_L_(0x57, 0x77)
#define REG_SC_BK57_77_H      _PK_H_(0x57, 0x77)
#define REG_SC_BK57_78_L      _PK_L_(0x57, 0x78)
#define REG_SC_BK57_78_H      _PK_H_(0x57, 0x78)
#define REG_SC_BK57_79_L      _PK_L_(0x57, 0x79)
#define REG_SC_BK57_79_H      _PK_H_(0x57, 0x79)
#define REG_SC_BK57_7A_L      _PK_L_(0x57, 0x7A)
#define REG_SC_BK57_7A_H      _PK_H_(0x57, 0x7A)
#define REG_SC_BK57_7B_L      _PK_L_(0x57, 0x7B)
#define REG_SC_BK57_7B_H      _PK_H_(0x57, 0x7B)
#define REG_SC_BK57_7C_L      _PK_L_(0x57, 0x7C)
#define REG_SC_BK57_7C_H      _PK_H_(0x57, 0x7C)
#define REG_SC_BK57_7D_L      _PK_L_(0x57, 0x7D)
#define REG_SC_BK57_7D_H      _PK_H_(0x57, 0x7D)
#define REG_SC_BK57_7E_L      _PK_L_(0x57, 0x7E)
#define REG_SC_BK57_7E_H      _PK_H_(0x57, 0x7E)
#define REG_SC_BK57_7F_L      _PK_L_(0x57, 0x7F)
#define REG_SC_BK57_7F_H      _PK_H_(0x57, 0x7F)
//----------------------------------------------
#define REG_SC_BK58_00_L      _PK_L_(0x58, 0x00)
#define REG_SC_BK58_00_H      _PK_H_(0x58, 0x00)
#define REG_SC_BK58_01_L      _PK_L_(0x58, 0x01)
#define REG_SC_BK58_01_H      _PK_H_(0x58, 0x01)
#define REG_SC_BK58_02_L      _PK_L_(0x58, 0x02)
#define REG_SC_BK58_02_H      _PK_H_(0x58, 0x02)
#define REG_SC_BK58_03_L      _PK_L_(0x58, 0x03)
#define REG_SC_BK58_03_H      _PK_H_(0x58, 0x03)
#define REG_SC_BK58_04_L      _PK_L_(0x58, 0x04)
#define REG_SC_BK58_04_H      _PK_H_(0x58, 0x04)
#define REG_SC_BK58_05_L      _PK_L_(0x58, 0x05)
#define REG_SC_BK58_05_H      _PK_H_(0x58, 0x05)
#define REG_SC_BK58_06_L      _PK_L_(0x58, 0x06)
#define REG_SC_BK58_06_H      _PK_H_(0x58, 0x06)
#define REG_SC_BK58_07_L      _PK_L_(0x58, 0x07)
#define REG_SC_BK58_07_H      _PK_H_(0x58, 0x07)
#define REG_SC_BK58_08_L      _PK_L_(0x58, 0x08)
#define REG_SC_BK58_08_H      _PK_H_(0x58, 0x08)
#define REG_SC_BK58_09_L      _PK_L_(0x58, 0x09)
#define REG_SC_BK58_09_H      _PK_H_(0x58, 0x09)
#define REG_SC_BK58_0A_L      _PK_L_(0x58, 0x0A)
#define REG_SC_BK58_0A_H      _PK_H_(0x58, 0x0A)
#define REG_SC_BK58_0B_L      _PK_L_(0x58, 0x0B)
#define REG_SC_BK58_0B_H      _PK_H_(0x58, 0x0B)
#define REG_SC_BK58_0C_L      _PK_L_(0x58, 0x0C)
#define REG_SC_BK58_0C_H      _PK_H_(0x58, 0x0C)
#define REG_SC_BK58_0D_L      _PK_L_(0x58, 0x0D)
#define REG_SC_BK58_0D_H      _PK_H_(0x58, 0x0D)
#define REG_SC_BK58_0E_L      _PK_L_(0x58, 0x0E)
#define REG_SC_BK58_0E_H      _PK_H_(0x58, 0x0E)
#define REG_SC_BK58_0F_L      _PK_L_(0x58, 0x0F)
#define REG_SC_BK58_0F_H      _PK_H_(0x58, 0x0F)
#define REG_SC_BK58_10_L      _PK_L_(0x58, 0x10)
#define REG_SC_BK58_10_H      _PK_H_(0x58, 0x10)
#define REG_SC_BK58_11_L      _PK_L_(0x58, 0x11)
#define REG_SC_BK58_11_H      _PK_H_(0x58, 0x11)
#define REG_SC_BK58_12_L      _PK_L_(0x58, 0x12)
#define REG_SC_BK58_12_H      _PK_H_(0x58, 0x12)
#define REG_SC_BK58_13_L      _PK_L_(0x58, 0x13)
#define REG_SC_BK58_13_H      _PK_H_(0x58, 0x13)
#define REG_SC_BK58_14_L      _PK_L_(0x58, 0x14)
#define REG_SC_BK58_14_H      _PK_H_(0x58, 0x14)
#define REG_SC_BK58_15_L      _PK_L_(0x58, 0x15)
#define REG_SC_BK58_15_H      _PK_H_(0x58, 0x15)
#define REG_SC_BK58_16_L      _PK_L_(0x58, 0x16)
#define REG_SC_BK58_16_H      _PK_H_(0x58, 0x16)
#define REG_SC_BK58_17_L      _PK_L_(0x58, 0x17)
#define REG_SC_BK58_17_H      _PK_H_(0x58, 0x17)
#define REG_SC_BK58_18_L      _PK_L_(0x58, 0x18)
#define REG_SC_BK58_18_H      _PK_H_(0x58, 0x18)
#define REG_SC_BK58_19_L      _PK_L_(0x58, 0x19)
#define REG_SC_BK58_19_H      _PK_H_(0x58, 0x19)
#define REG_SC_BK58_1A_L      _PK_L_(0x58, 0x1A)
#define REG_SC_BK58_1A_H      _PK_H_(0x58, 0x1A)
#define REG_SC_BK58_1B_L      _PK_L_(0x58, 0x1B)
#define REG_SC_BK58_1B_H      _PK_H_(0x58, 0x1B)
#define REG_SC_BK58_1C_L      _PK_L_(0x58, 0x1C)
#define REG_SC_BK58_1C_H      _PK_H_(0x58, 0x1C)
#define REG_SC_BK58_1D_L      _PK_L_(0x58, 0x1D)
#define REG_SC_BK58_1D_H      _PK_H_(0x58, 0x1D)
#define REG_SC_BK58_1E_L      _PK_L_(0x58, 0x1E)
#define REG_SC_BK58_1E_H      _PK_H_(0x58, 0x1E)
#define REG_SC_BK58_1F_L      _PK_L_(0x58, 0x1F)
#define REG_SC_BK58_1F_H      _PK_H_(0x58, 0x1F)
#define REG_SC_BK58_20_L      _PK_L_(0x58, 0x20)
#define REG_SC_BK58_20_H      _PK_H_(0x58, 0x20)
#define REG_SC_BK58_21_L      _PK_L_(0x58, 0x21)
#define REG_SC_BK58_21_H      _PK_H_(0x58, 0x21)
#define REG_SC_BK58_22_L      _PK_L_(0x58, 0x22)
#define REG_SC_BK58_22_H      _PK_H_(0x58, 0x22)
#define REG_SC_BK58_23_L      _PK_L_(0x58, 0x23)
#define REG_SC_BK58_23_H      _PK_H_(0x58, 0x23)
#define REG_SC_BK58_24_L      _PK_L_(0x58, 0x24)
#define REG_SC_BK58_24_H      _PK_H_(0x58, 0x24)
#define REG_SC_BK58_25_L      _PK_L_(0x58, 0x25)
#define REG_SC_BK58_25_H      _PK_H_(0x58, 0x25)
#define REG_SC_BK58_26_L      _PK_L_(0x58, 0x26)
#define REG_SC_BK58_26_H      _PK_H_(0x58, 0x26)
#define REG_SC_BK58_27_L      _PK_L_(0x58, 0x27)
#define REG_SC_BK58_27_H      _PK_H_(0x58, 0x27)
#define REG_SC_BK58_28_L      _PK_L_(0x58, 0x28)
#define REG_SC_BK58_28_H      _PK_H_(0x58, 0x28)
#define REG_SC_BK58_29_L      _PK_L_(0x58, 0x29)
#define REG_SC_BK58_29_H      _PK_H_(0x58, 0x29)
#define REG_SC_BK58_2A_L      _PK_L_(0x58, 0x2A)
#define REG_SC_BK58_2A_H      _PK_H_(0x58, 0x2A)
#define REG_SC_BK58_2B_L      _PK_L_(0x58, 0x2B)
#define REG_SC_BK58_2B_H      _PK_H_(0x58, 0x2B)
#define REG_SC_BK58_2C_L      _PK_L_(0x58, 0x2C)
#define REG_SC_BK58_2C_H      _PK_H_(0x58, 0x2C)
#define REG_SC_BK58_2D_L      _PK_L_(0x58, 0x2D)
#define REG_SC_BK58_2D_H      _PK_H_(0x58, 0x2D)
#define REG_SC_BK58_2E_L      _PK_L_(0x58, 0x2E)
#define REG_SC_BK58_2E_H      _PK_H_(0x58, 0x2E)
#define REG_SC_BK58_2F_L      _PK_L_(0x58, 0x2F)
#define REG_SC_BK58_2F_H      _PK_H_(0x58, 0x2F)
#define REG_SC_BK58_30_L      _PK_L_(0x58, 0x30)
#define REG_SC_BK58_30_H      _PK_H_(0x58, 0x30)
#define REG_SC_BK58_31_L      _PK_L_(0x58, 0x31)
#define REG_SC_BK58_31_H      _PK_H_(0x58, 0x31)
#define REG_SC_BK58_32_L      _PK_L_(0x58, 0x32)
#define REG_SC_BK58_32_H      _PK_H_(0x58, 0x32)
#define REG_SC_BK58_33_L      _PK_L_(0x58, 0x33)
#define REG_SC_BK58_33_H      _PK_H_(0x58, 0x33)
#define REG_SC_BK58_34_L      _PK_L_(0x58, 0x34)
#define REG_SC_BK58_34_H      _PK_H_(0x58, 0x34)
#define REG_SC_BK58_35_L      _PK_L_(0x58, 0x35)
#define REG_SC_BK58_35_H      _PK_H_(0x58, 0x35)
#define REG_SC_BK58_36_L      _PK_L_(0x58, 0x36)
#define REG_SC_BK58_36_H      _PK_H_(0x58, 0x36)
#define REG_SC_BK58_37_L      _PK_L_(0x58, 0x37)
#define REG_SC_BK58_37_H      _PK_H_(0x58, 0x37)
#define REG_SC_BK58_38_L      _PK_L_(0x58, 0x38)
#define REG_SC_BK58_38_H      _PK_H_(0x58, 0x38)
#define REG_SC_BK58_39_L      _PK_L_(0x58, 0x39)
#define REG_SC_BK58_39_H      _PK_H_(0x58, 0x39)
#define REG_SC_BK58_3A_L      _PK_L_(0x58, 0x3A)
#define REG_SC_BK58_3A_H      _PK_H_(0x58, 0x3A)
#define REG_SC_BK58_3B_L      _PK_L_(0x58, 0x3B)
#define REG_SC_BK58_3B_H      _PK_H_(0x58, 0x3B)
#define REG_SC_BK58_3C_L      _PK_L_(0x58, 0x3C)
#define REG_SC_BK58_3C_H      _PK_H_(0x58, 0x3C)
#define REG_SC_BK58_3D_L      _PK_L_(0x58, 0x3D)
#define REG_SC_BK58_3D_H      _PK_H_(0x58, 0x3D)
#define REG_SC_BK58_3E_L      _PK_L_(0x58, 0x3E)
#define REG_SC_BK58_3E_H      _PK_H_(0x58, 0x3E)
#define REG_SC_BK58_3F_L      _PK_L_(0x58, 0x3F)
#define REG_SC_BK58_3F_H      _PK_H_(0x58, 0x3F)
#define REG_SC_BK58_40_L      _PK_L_(0x58, 0x40)
#define REG_SC_BK58_40_H      _PK_H_(0x58, 0x40)
#define REG_SC_BK58_41_L      _PK_L_(0x58, 0x41)
#define REG_SC_BK58_41_H      _PK_H_(0x58, 0x41)
#define REG_SC_BK58_42_L      _PK_L_(0x58, 0x42)
#define REG_SC_BK58_42_H      _PK_H_(0x58, 0x42)
#define REG_SC_BK58_43_L      _PK_L_(0x58, 0x43)
#define REG_SC_BK58_43_H      _PK_H_(0x58, 0x43)
#define REG_SC_BK58_44_L      _PK_L_(0x58, 0x44)
#define REG_SC_BK58_44_H      _PK_H_(0x58, 0x44)
#define REG_SC_BK58_45_L      _PK_L_(0x58, 0x45)
#define REG_SC_BK58_45_H      _PK_H_(0x58, 0x45)
#define REG_SC_BK58_46_L      _PK_L_(0x58, 0x46)
#define REG_SC_BK58_46_H      _PK_H_(0x58, 0x46)
#define REG_SC_BK58_47_L      _PK_L_(0x58, 0x47)
#define REG_SC_BK58_47_H      _PK_H_(0x58, 0x47)
#define REG_SC_BK58_48_L      _PK_L_(0x58, 0x48)
#define REG_SC_BK58_48_H      _PK_H_(0x58, 0x48)
#define REG_SC_BK58_49_L      _PK_L_(0x58, 0x49)
#define REG_SC_BK58_49_H      _PK_H_(0x58, 0x49)
#define REG_SC_BK58_4A_L      _PK_L_(0x58, 0x4A)
#define REG_SC_BK58_4A_H      _PK_H_(0x58, 0x4A)
#define REG_SC_BK58_4B_L      _PK_L_(0x58, 0x4B)
#define REG_SC_BK58_4B_H      _PK_H_(0x58, 0x4B)
#define REG_SC_BK58_4C_L      _PK_L_(0x58, 0x4C)
#define REG_SC_BK58_4C_H      _PK_H_(0x58, 0x4C)
#define REG_SC_BK58_4D_L      _PK_L_(0x58, 0x4D)
#define REG_SC_BK58_4D_H      _PK_H_(0x58, 0x4D)
#define REG_SC_BK58_4E_L      _PK_L_(0x58, 0x4E)
#define REG_SC_BK58_4E_H      _PK_H_(0x58, 0x4E)
#define REG_SC_BK58_4F_L      _PK_L_(0x58, 0x4F)
#define REG_SC_BK58_4F_H      _PK_H_(0x58, 0x4F)
#define REG_SC_BK58_50_L      _PK_L_(0x58, 0x50)
#define REG_SC_BK58_50_H      _PK_H_(0x58, 0x50)
#define REG_SC_BK58_51_L      _PK_L_(0x58, 0x51)
#define REG_SC_BK58_51_H      _PK_H_(0x58, 0x51)
#define REG_SC_BK58_52_L      _PK_L_(0x58, 0x52)
#define REG_SC_BK58_52_H      _PK_H_(0x58, 0x52)
#define REG_SC_BK58_53_L      _PK_L_(0x58, 0x53)
#define REG_SC_BK58_53_H      _PK_H_(0x58, 0x53)
#define REG_SC_BK58_54_L      _PK_L_(0x58, 0x54)
#define REG_SC_BK58_54_H      _PK_H_(0x58, 0x54)
#define REG_SC_BK58_55_L      _PK_L_(0x58, 0x55)
#define REG_SC_BK58_55_H      _PK_H_(0x58, 0x55)
#define REG_SC_BK58_56_L      _PK_L_(0x58, 0x56)
#define REG_SC_BK58_56_H      _PK_H_(0x58, 0x56)
#define REG_SC_BK58_57_L      _PK_L_(0x58, 0x57)
#define REG_SC_BK58_57_H      _PK_H_(0x58, 0x57)
#define REG_SC_BK58_58_L      _PK_L_(0x58, 0x58)
#define REG_SC_BK58_58_H      _PK_H_(0x58, 0x58)
#define REG_SC_BK58_59_L      _PK_L_(0x58, 0x59)
#define REG_SC_BK58_59_H      _PK_H_(0x58, 0x59)
#define REG_SC_BK58_5A_L      _PK_L_(0x58, 0x5A)
#define REG_SC_BK58_5A_H      _PK_H_(0x58, 0x5A)
#define REG_SC_BK58_5B_L      _PK_L_(0x58, 0x5B)
#define REG_SC_BK58_5B_H      _PK_H_(0x58, 0x5B)
#define REG_SC_BK58_5C_L      _PK_L_(0x58, 0x5C)
#define REG_SC_BK58_5C_H      _PK_H_(0x58, 0x5C)
#define REG_SC_BK58_5D_L      _PK_L_(0x58, 0x5D)
#define REG_SC_BK58_5D_H      _PK_H_(0x58, 0x5D)
#define REG_SC_BK58_5E_L      _PK_L_(0x58, 0x5E)
#define REG_SC_BK58_5E_H      _PK_H_(0x58, 0x5E)
#define REG_SC_BK58_5F_L      _PK_L_(0x58, 0x5F)
#define REG_SC_BK58_5F_H      _PK_H_(0x58, 0x5F)
#define REG_SC_BK58_60_L      _PK_L_(0x58, 0x60)
#define REG_SC_BK58_60_H      _PK_H_(0x58, 0x60)
#define REG_SC_BK58_61_L      _PK_L_(0x58, 0x61)
#define REG_SC_BK58_61_H      _PK_H_(0x58, 0x61)
#define REG_SC_BK58_62_L      _PK_L_(0x58, 0x62)
#define REG_SC_BK58_62_H      _PK_H_(0x58, 0x62)
#define REG_SC_BK58_63_L      _PK_L_(0x58, 0x63)
#define REG_SC_BK58_63_H      _PK_H_(0x58, 0x63)
#define REG_SC_BK58_64_L      _PK_L_(0x58, 0x64)
#define REG_SC_BK58_64_H      _PK_H_(0x58, 0x64)
#define REG_SC_BK58_65_L      _PK_L_(0x58, 0x65)
#define REG_SC_BK58_65_H      _PK_H_(0x58, 0x65)
#define REG_SC_BK58_66_L      _PK_L_(0x58, 0x66)
#define REG_SC_BK58_66_H      _PK_H_(0x58, 0x66)
#define REG_SC_BK58_67_L      _PK_L_(0x58, 0x67)
#define REG_SC_BK58_67_H      _PK_H_(0x58, 0x67)
#define REG_SC_BK58_68_L      _PK_L_(0x58, 0x68)
#define REG_SC_BK58_68_H      _PK_H_(0x58, 0x68)
#define REG_SC_BK58_69_L      _PK_L_(0x58, 0x69)
#define REG_SC_BK58_69_H      _PK_H_(0x58, 0x69)
#define REG_SC_BK58_6A_L      _PK_L_(0x58, 0x6A)
#define REG_SC_BK58_6A_H      _PK_H_(0x58, 0x6A)
#define REG_SC_BK58_6B_L      _PK_L_(0x58, 0x6B)
#define REG_SC_BK58_6B_H      _PK_H_(0x58, 0x6B)
#define REG_SC_BK58_6C_L      _PK_L_(0x58, 0x6C)
#define REG_SC_BK58_6C_H      _PK_H_(0x58, 0x6C)
#define REG_SC_BK58_6D_L      _PK_L_(0x58, 0x6D)
#define REG_SC_BK58_6D_H      _PK_H_(0x58, 0x6D)
#define REG_SC_BK58_6E_L      _PK_L_(0x58, 0x6E)
#define REG_SC_BK58_6E_H      _PK_H_(0x58, 0x6E)
#define REG_SC_BK58_6F_L      _PK_L_(0x58, 0x6F)
#define REG_SC_BK58_6F_H      _PK_H_(0x58, 0x6F)
#define REG_SC_BK58_70_L      _PK_L_(0x58, 0x70)
#define REG_SC_BK58_70_H      _PK_H_(0x58, 0x70)
#define REG_SC_BK58_71_L      _PK_L_(0x58, 0x71)
#define REG_SC_BK58_71_H      _PK_H_(0x58, 0x71)
#define REG_SC_BK58_72_L      _PK_L_(0x58, 0x72)
#define REG_SC_BK58_72_H      _PK_H_(0x58, 0x72)
#define REG_SC_BK58_73_L      _PK_L_(0x58, 0x73)
#define REG_SC_BK58_73_H      _PK_H_(0x58, 0x73)
#define REG_SC_BK58_74_L      _PK_L_(0x58, 0x74)
#define REG_SC_BK58_74_H      _PK_H_(0x58, 0x74)
#define REG_SC_BK58_75_L      _PK_L_(0x58, 0x75)
#define REG_SC_BK58_75_H      _PK_H_(0x58, 0x75)
#define REG_SC_BK58_76_L      _PK_L_(0x58, 0x76)
#define REG_SC_BK58_76_H      _PK_H_(0x58, 0x76)
#define REG_SC_BK58_77_L      _PK_L_(0x58, 0x77)
#define REG_SC_BK58_77_H      _PK_H_(0x58, 0x77)
#define REG_SC_BK58_78_L      _PK_L_(0x58, 0x78)
#define REG_SC_BK58_78_H      _PK_H_(0x58, 0x78)
#define REG_SC_BK58_79_L      _PK_L_(0x58, 0x79)
#define REG_SC_BK58_79_H      _PK_H_(0x58, 0x79)
#define REG_SC_BK58_7A_L      _PK_L_(0x58, 0x7A)
#define REG_SC_BK58_7A_H      _PK_H_(0x58, 0x7A)
#define REG_SC_BK58_7B_L      _PK_L_(0x58, 0x7B)
#define REG_SC_BK58_7B_H      _PK_H_(0x58, 0x7B)
#define REG_SC_BK58_7C_L      _PK_L_(0x58, 0x7C)
#define REG_SC_BK58_7C_H      _PK_H_(0x58, 0x7C)
#define REG_SC_BK58_7D_L      _PK_L_(0x58, 0x7D)
#define REG_SC_BK58_7D_H      _PK_H_(0x58, 0x7D)
#define REG_SC_BK58_7E_L      _PK_L_(0x58, 0x7E)
#define REG_SC_BK58_7E_H      _PK_H_(0x58, 0x7E)
#define REG_SC_BK58_7F_L      _PK_L_(0x58, 0x7F)
#define REG_SC_BK58_7F_H      _PK_H_(0x58, 0x7F)
//----------------------------------------------
#define REG_SC_BK59_00_L      _PK_L_(0x59, 0x00)
#define REG_SC_BK59_00_H      _PK_H_(0x59, 0x00)
#define REG_SC_BK59_01_L      _PK_L_(0x59, 0x01)
#define REG_SC_BK59_01_H      _PK_H_(0x59, 0x01)
#define REG_SC_BK59_02_L      _PK_L_(0x59, 0x02)
#define REG_SC_BK59_02_H      _PK_H_(0x59, 0x02)
#define REG_SC_BK59_03_L      _PK_L_(0x59, 0x03)
#define REG_SC_BK59_03_H      _PK_H_(0x59, 0x03)
#define REG_SC_BK59_04_L      _PK_L_(0x59, 0x04)
#define REG_SC_BK59_04_H      _PK_H_(0x59, 0x04)
#define REG_SC_BK59_05_L      _PK_L_(0x59, 0x05)
#define REG_SC_BK59_05_H      _PK_H_(0x59, 0x05)
#define REG_SC_BK59_06_L      _PK_L_(0x59, 0x06)
#define REG_SC_BK59_06_H      _PK_H_(0x59, 0x06)
#define REG_SC_BK59_07_L      _PK_L_(0x59, 0x07)
#define REG_SC_BK59_07_H      _PK_H_(0x59, 0x07)
#define REG_SC_BK59_08_L      _PK_L_(0x59, 0x08)
#define REG_SC_BK59_08_H      _PK_H_(0x59, 0x08)
#define REG_SC_BK59_09_L      _PK_L_(0x59, 0x09)
#define REG_SC_BK59_09_H      _PK_H_(0x59, 0x09)
#define REG_SC_BK59_0A_L      _PK_L_(0x59, 0x0A)
#define REG_SC_BK59_0A_H      _PK_H_(0x59, 0x0A)
#define REG_SC_BK59_0B_L      _PK_L_(0x59, 0x0B)
#define REG_SC_BK59_0B_H      _PK_H_(0x59, 0x0B)
#define REG_SC_BK59_0C_L      _PK_L_(0x59, 0x0C)
#define REG_SC_BK59_0C_H      _PK_H_(0x59, 0x0C)
#define REG_SC_BK59_0D_L      _PK_L_(0x59, 0x0D)
#define REG_SC_BK59_0D_H      _PK_H_(0x59, 0x0D)
#define REG_SC_BK59_0E_L      _PK_L_(0x59, 0x0E)
#define REG_SC_BK59_0E_H      _PK_H_(0x59, 0x0E)
#define REG_SC_BK59_0F_L      _PK_L_(0x59, 0x0F)
#define REG_SC_BK59_0F_H      _PK_H_(0x59, 0x0F)
#define REG_SC_BK59_10_L      _PK_L_(0x59, 0x10)
#define REG_SC_BK59_10_H      _PK_H_(0x59, 0x10)
#define REG_SC_BK59_11_L      _PK_L_(0x59, 0x11)
#define REG_SC_BK59_11_H      _PK_H_(0x59, 0x11)
#define REG_SC_BK59_12_L      _PK_L_(0x59, 0x12)
#define REG_SC_BK59_12_H      _PK_H_(0x59, 0x12)
#define REG_SC_BK59_13_L      _PK_L_(0x59, 0x13)
#define REG_SC_BK59_13_H      _PK_H_(0x59, 0x13)
#define REG_SC_BK59_14_L      _PK_L_(0x59, 0x14)
#define REG_SC_BK59_14_H      _PK_H_(0x59, 0x14)
#define REG_SC_BK59_15_L      _PK_L_(0x59, 0x15)
#define REG_SC_BK59_15_H      _PK_H_(0x59, 0x15)
#define REG_SC_BK59_16_L      _PK_L_(0x59, 0x16)
#define REG_SC_BK59_16_H      _PK_H_(0x59, 0x16)
#define REG_SC_BK59_17_L      _PK_L_(0x59, 0x17)
#define REG_SC_BK59_17_H      _PK_H_(0x59, 0x17)
#define REG_SC_BK59_18_L      _PK_L_(0x59, 0x18)
#define REG_SC_BK59_18_H      _PK_H_(0x59, 0x18)
#define REG_SC_BK59_19_L      _PK_L_(0x59, 0x19)
#define REG_SC_BK59_19_H      _PK_H_(0x59, 0x19)
#define REG_SC_BK59_1A_L      _PK_L_(0x59, 0x1A)
#define REG_SC_BK59_1A_H      _PK_H_(0x59, 0x1A)
#define REG_SC_BK59_1B_L      _PK_L_(0x59, 0x1B)
#define REG_SC_BK59_1B_H      _PK_H_(0x59, 0x1B)
#define REG_SC_BK59_1C_L      _PK_L_(0x59, 0x1C)
#define REG_SC_BK59_1C_H      _PK_H_(0x59, 0x1C)
#define REG_SC_BK59_1D_L      _PK_L_(0x59, 0x1D)
#define REG_SC_BK59_1D_H      _PK_H_(0x59, 0x1D)
#define REG_SC_BK59_1E_L      _PK_L_(0x59, 0x1E)
#define REG_SC_BK59_1E_H      _PK_H_(0x59, 0x1E)
#define REG_SC_BK59_1F_L      _PK_L_(0x59, 0x1F)
#define REG_SC_BK59_1F_H      _PK_H_(0x59, 0x1F)
#define REG_SC_BK59_20_L      _PK_L_(0x59, 0x20)
#define REG_SC_BK59_20_H      _PK_H_(0x59, 0x20)
#define REG_SC_BK59_21_L      _PK_L_(0x59, 0x21)
#define REG_SC_BK59_21_H      _PK_H_(0x59, 0x21)
#define REG_SC_BK59_22_L      _PK_L_(0x59, 0x22)
#define REG_SC_BK59_22_H      _PK_H_(0x59, 0x22)
#define REG_SC_BK59_23_L      _PK_L_(0x59, 0x23)
#define REG_SC_BK59_23_H      _PK_H_(0x59, 0x23)
#define REG_SC_BK59_24_L      _PK_L_(0x59, 0x24)
#define REG_SC_BK59_24_H      _PK_H_(0x59, 0x24)
#define REG_SC_BK59_25_L      _PK_L_(0x59, 0x25)
#define REG_SC_BK59_25_H      _PK_H_(0x59, 0x25)
#define REG_SC_BK59_26_L      _PK_L_(0x59, 0x26)
#define REG_SC_BK59_26_H      _PK_H_(0x59, 0x26)
#define REG_SC_BK59_27_L      _PK_L_(0x59, 0x27)
#define REG_SC_BK59_27_H      _PK_H_(0x59, 0x27)
#define REG_SC_BK59_28_L      _PK_L_(0x59, 0x28)
#define REG_SC_BK59_28_H      _PK_H_(0x59, 0x28)
#define REG_SC_BK59_29_L      _PK_L_(0x59, 0x29)
#define REG_SC_BK59_29_H      _PK_H_(0x59, 0x29)
#define REG_SC_BK59_2A_L      _PK_L_(0x59, 0x2A)
#define REG_SC_BK59_2A_H      _PK_H_(0x59, 0x2A)
#define REG_SC_BK59_2B_L      _PK_L_(0x59, 0x2B)
#define REG_SC_BK59_2B_H      _PK_H_(0x59, 0x2B)
#define REG_SC_BK59_2C_L      _PK_L_(0x59, 0x2C)
#define REG_SC_BK59_2C_H      _PK_H_(0x59, 0x2C)
#define REG_SC_BK59_2D_L      _PK_L_(0x59, 0x2D)
#define REG_SC_BK59_2D_H      _PK_H_(0x59, 0x2D)
#define REG_SC_BK59_2E_L      _PK_L_(0x59, 0x2E)
#define REG_SC_BK59_2E_H      _PK_H_(0x59, 0x2E)
#define REG_SC_BK59_2F_L      _PK_L_(0x59, 0x2F)
#define REG_SC_BK59_2F_H      _PK_H_(0x59, 0x2F)
#define REG_SC_BK59_30_L      _PK_L_(0x59, 0x30)
#define REG_SC_BK59_30_H      _PK_H_(0x59, 0x30)
#define REG_SC_BK59_31_L      _PK_L_(0x59, 0x31)
#define REG_SC_BK59_31_H      _PK_H_(0x59, 0x31)
#define REG_SC_BK59_32_L      _PK_L_(0x59, 0x32)
#define REG_SC_BK59_32_H      _PK_H_(0x59, 0x32)
#define REG_SC_BK59_33_L      _PK_L_(0x59, 0x33)
#define REG_SC_BK59_33_H      _PK_H_(0x59, 0x33)
#define REG_SC_BK59_34_L      _PK_L_(0x59, 0x34)
#define REG_SC_BK59_34_H      _PK_H_(0x59, 0x34)
#define REG_SC_BK59_35_L      _PK_L_(0x59, 0x35)
#define REG_SC_BK59_35_H      _PK_H_(0x59, 0x35)
#define REG_SC_BK59_36_L      _PK_L_(0x59, 0x36)
#define REG_SC_BK59_36_H      _PK_H_(0x59, 0x36)
#define REG_SC_BK59_37_L      _PK_L_(0x59, 0x37)
#define REG_SC_BK59_37_H      _PK_H_(0x59, 0x37)
#define REG_SC_BK59_38_L      _PK_L_(0x59, 0x38)
#define REG_SC_BK59_38_H      _PK_H_(0x59, 0x38)
#define REG_SC_BK59_39_L      _PK_L_(0x59, 0x39)
#define REG_SC_BK59_39_H      _PK_H_(0x59, 0x39)
#define REG_SC_BK59_3A_L      _PK_L_(0x59, 0x3A)
#define REG_SC_BK59_3A_H      _PK_H_(0x59, 0x3A)
#define REG_SC_BK59_3B_L      _PK_L_(0x59, 0x3B)
#define REG_SC_BK59_3B_H      _PK_H_(0x59, 0x3B)
#define REG_SC_BK59_3C_L      _PK_L_(0x59, 0x3C)
#define REG_SC_BK59_3C_H      _PK_H_(0x59, 0x3C)
#define REG_SC_BK59_3D_L      _PK_L_(0x59, 0x3D)
#define REG_SC_BK59_3D_H      _PK_H_(0x59, 0x3D)
#define REG_SC_BK59_3E_L      _PK_L_(0x59, 0x3E)
#define REG_SC_BK59_3E_H      _PK_H_(0x59, 0x3E)
#define REG_SC_BK59_3F_L      _PK_L_(0x59, 0x3F)
#define REG_SC_BK59_3F_H      _PK_H_(0x59, 0x3F)
#define REG_SC_BK59_40_L      _PK_L_(0x59, 0x40)
#define REG_SC_BK59_40_H      _PK_H_(0x59, 0x40)
#define REG_SC_BK59_41_L      _PK_L_(0x59, 0x41)
#define REG_SC_BK59_41_H      _PK_H_(0x59, 0x41)
#define REG_SC_BK59_42_L      _PK_L_(0x59, 0x42)
#define REG_SC_BK59_42_H      _PK_H_(0x59, 0x42)
#define REG_SC_BK59_43_L      _PK_L_(0x59, 0x43)
#define REG_SC_BK59_43_H      _PK_H_(0x59, 0x43)
#define REG_SC_BK59_44_L      _PK_L_(0x59, 0x44)
#define REG_SC_BK59_44_H      _PK_H_(0x59, 0x44)
#define REG_SC_BK59_45_L      _PK_L_(0x59, 0x45)
#define REG_SC_BK59_45_H      _PK_H_(0x59, 0x45)
#define REG_SC_BK59_46_L      _PK_L_(0x59, 0x46)
#define REG_SC_BK59_46_H      _PK_H_(0x59, 0x46)
#define REG_SC_BK59_47_L      _PK_L_(0x59, 0x47)
#define REG_SC_BK59_47_H      _PK_H_(0x59, 0x47)
#define REG_SC_BK59_48_L      _PK_L_(0x59, 0x48)
#define REG_SC_BK59_48_H      _PK_H_(0x59, 0x48)
#define REG_SC_BK59_49_L      _PK_L_(0x59, 0x49)
#define REG_SC_BK59_49_H      _PK_H_(0x59, 0x49)
#define REG_SC_BK59_4A_L      _PK_L_(0x59, 0x4A)
#define REG_SC_BK59_4A_H      _PK_H_(0x59, 0x4A)
#define REG_SC_BK59_4B_L      _PK_L_(0x59, 0x4B)
#define REG_SC_BK59_4B_H      _PK_H_(0x59, 0x4B)
#define REG_SC_BK59_4C_L      _PK_L_(0x59, 0x4C)
#define REG_SC_BK59_4C_H      _PK_H_(0x59, 0x4C)
#define REG_SC_BK59_4D_L      _PK_L_(0x59, 0x4D)
#define REG_SC_BK59_4D_H      _PK_H_(0x59, 0x4D)
#define REG_SC_BK59_4E_L      _PK_L_(0x59, 0x4E)
#define REG_SC_BK59_4E_H      _PK_H_(0x59, 0x4E)
#define REG_SC_BK59_4F_L      _PK_L_(0x59, 0x4F)
#define REG_SC_BK59_4F_H      _PK_H_(0x59, 0x4F)
#define REG_SC_BK59_50_L      _PK_L_(0x59, 0x50)
#define REG_SC_BK59_50_H      _PK_H_(0x59, 0x50)
#define REG_SC_BK59_51_L      _PK_L_(0x59, 0x51)
#define REG_SC_BK59_51_H      _PK_H_(0x59, 0x51)
#define REG_SC_BK59_52_L      _PK_L_(0x59, 0x52)
#define REG_SC_BK59_52_H      _PK_H_(0x59, 0x52)
#define REG_SC_BK59_53_L      _PK_L_(0x59, 0x53)
#define REG_SC_BK59_53_H      _PK_H_(0x59, 0x53)
#define REG_SC_BK59_54_L      _PK_L_(0x59, 0x54)
#define REG_SC_BK59_54_H      _PK_H_(0x59, 0x54)
#define REG_SC_BK59_55_L      _PK_L_(0x59, 0x55)
#define REG_SC_BK59_55_H      _PK_H_(0x59, 0x55)
#define REG_SC_BK59_56_L      _PK_L_(0x59, 0x56)
#define REG_SC_BK59_56_H      _PK_H_(0x59, 0x56)
#define REG_SC_BK59_57_L      _PK_L_(0x59, 0x57)
#define REG_SC_BK59_57_H      _PK_H_(0x59, 0x57)
#define REG_SC_BK59_58_L      _PK_L_(0x59, 0x58)
#define REG_SC_BK59_58_H      _PK_H_(0x59, 0x58)
#define REG_SC_BK59_59_L      _PK_L_(0x59, 0x59)
#define REG_SC_BK59_59_H      _PK_H_(0x59, 0x59)
#define REG_SC_BK59_5A_L      _PK_L_(0x59, 0x5A)
#define REG_SC_BK59_5A_H      _PK_H_(0x59, 0x5A)
#define REG_SC_BK59_5B_L      _PK_L_(0x59, 0x5B)
#define REG_SC_BK59_5B_H      _PK_H_(0x59, 0x5B)
#define REG_SC_BK59_5C_L      _PK_L_(0x59, 0x5C)
#define REG_SC_BK59_5C_H      _PK_H_(0x59, 0x5C)
#define REG_SC_BK59_5D_L      _PK_L_(0x59, 0x5D)
#define REG_SC_BK59_5D_H      _PK_H_(0x59, 0x5D)
#define REG_SC_BK59_5E_L      _PK_L_(0x59, 0x5E)
#define REG_SC_BK59_5E_H      _PK_H_(0x59, 0x5E)
#define REG_SC_BK59_5F_L      _PK_L_(0x59, 0x5F)
#define REG_SC_BK59_5F_H      _PK_H_(0x59, 0x5F)
#define REG_SC_BK59_60_L      _PK_L_(0x59, 0x60)
#define REG_SC_BK59_60_H      _PK_H_(0x59, 0x60)
#define REG_SC_BK59_61_L      _PK_L_(0x59, 0x61)
#define REG_SC_BK59_61_H      _PK_H_(0x59, 0x61)
#define REG_SC_BK59_62_L      _PK_L_(0x59, 0x62)
#define REG_SC_BK59_62_H      _PK_H_(0x59, 0x62)
#define REG_SC_BK59_63_L      _PK_L_(0x59, 0x63)
#define REG_SC_BK59_63_H      _PK_H_(0x59, 0x63)
#define REG_SC_BK59_64_L      _PK_L_(0x59, 0x64)
#define REG_SC_BK59_64_H      _PK_H_(0x59, 0x64)
#define REG_SC_BK59_65_L      _PK_L_(0x59, 0x65)
#define REG_SC_BK59_65_H      _PK_H_(0x59, 0x65)
#define REG_SC_BK59_66_L      _PK_L_(0x59, 0x66)
#define REG_SC_BK59_66_H      _PK_H_(0x59, 0x66)
#define REG_SC_BK59_67_L      _PK_L_(0x59, 0x67)
#define REG_SC_BK59_67_H      _PK_H_(0x59, 0x67)
#define REG_SC_BK59_68_L      _PK_L_(0x59, 0x68)
#define REG_SC_BK59_68_H      _PK_H_(0x59, 0x68)
#define REG_SC_BK59_69_L      _PK_L_(0x59, 0x69)
#define REG_SC_BK59_69_H      _PK_H_(0x59, 0x69)
#define REG_SC_BK59_6A_L      _PK_L_(0x59, 0x6A)
#define REG_SC_BK59_6A_H      _PK_H_(0x59, 0x6A)
#define REG_SC_BK59_6B_L      _PK_L_(0x59, 0x6B)
#define REG_SC_BK59_6B_H      _PK_H_(0x59, 0x6B)
#define REG_SC_BK59_6C_L      _PK_L_(0x59, 0x6C)
#define REG_SC_BK59_6C_H      _PK_H_(0x59, 0x6C)
#define REG_SC_BK59_6D_L      _PK_L_(0x59, 0x6D)
#define REG_SC_BK59_6D_H      _PK_H_(0x59, 0x6D)
#define REG_SC_BK59_6E_L      _PK_L_(0x59, 0x6E)
#define REG_SC_BK59_6E_H      _PK_H_(0x59, 0x6E)
#define REG_SC_BK59_6F_L      _PK_L_(0x59, 0x6F)
#define REG_SC_BK59_6F_H      _PK_H_(0x59, 0x6F)
#define REG_SC_BK59_70_L      _PK_L_(0x59, 0x70)
#define REG_SC_BK59_70_H      _PK_H_(0x59, 0x70)
#define REG_SC_BK59_71_L      _PK_L_(0x59, 0x71)
#define REG_SC_BK59_71_H      _PK_H_(0x59, 0x71)
#define REG_SC_BK59_72_L      _PK_L_(0x59, 0x72)
#define REG_SC_BK59_72_H      _PK_H_(0x59, 0x72)
#define REG_SC_BK59_73_L      _PK_L_(0x59, 0x73)
#define REG_SC_BK59_73_H      _PK_H_(0x59, 0x73)
#define REG_SC_BK59_74_L      _PK_L_(0x59, 0x74)
#define REG_SC_BK59_74_H      _PK_H_(0x59, 0x74)
#define REG_SC_BK59_75_L      _PK_L_(0x59, 0x75)
#define REG_SC_BK59_75_H      _PK_H_(0x59, 0x75)
#define REG_SC_BK59_76_L      _PK_L_(0x59, 0x76)
#define REG_SC_BK59_76_H      _PK_H_(0x59, 0x76)
#define REG_SC_BK59_77_L      _PK_L_(0x59, 0x77)
#define REG_SC_BK59_77_H      _PK_H_(0x59, 0x77)
#define REG_SC_BK59_78_L      _PK_L_(0x59, 0x78)
#define REG_SC_BK59_78_H      _PK_H_(0x59, 0x78)
#define REG_SC_BK59_79_L      _PK_L_(0x59, 0x79)
#define REG_SC_BK59_79_H      _PK_H_(0x59, 0x79)
#define REG_SC_BK59_7A_L      _PK_L_(0x59, 0x7A)
#define REG_SC_BK59_7A_H      _PK_H_(0x59, 0x7A)
#define REG_SC_BK59_7B_L      _PK_L_(0x59, 0x7B)
#define REG_SC_BK59_7B_H      _PK_H_(0x59, 0x7B)
#define REG_SC_BK59_7C_L      _PK_L_(0x59, 0x7C)
#define REG_SC_BK59_7C_H      _PK_H_(0x59, 0x7C)
#define REG_SC_BK59_7D_L      _PK_L_(0x59, 0x7D)
#define REG_SC_BK59_7D_H      _PK_H_(0x59, 0x7D)
#define REG_SC_BK59_7E_L      _PK_L_(0x59, 0x7E)
#define REG_SC_BK59_7E_H      _PK_H_(0x59, 0x7E)
#define REG_SC_BK59_7F_L      _PK_L_(0x59, 0x7F)
#define REG_SC_BK59_7F_H      _PK_H_(0x59, 0x7F)
//----------------------------------------------
#define REG_SC_BK5A_00_L      _PK_L_(0x5A, 0x00)
#define REG_SC_BK5A_00_H      _PK_H_(0x5A, 0x00)
#define REG_SC_BK5A_01_L      _PK_L_(0x5A, 0x01)
#define REG_SC_BK5A_01_H      _PK_H_(0x5A, 0x01)
#define REG_SC_BK5A_02_L      _PK_L_(0x5A, 0x02)
#define REG_SC_BK5A_02_H      _PK_H_(0x5A, 0x02)
#define REG_SC_BK5A_03_L      _PK_L_(0x5A, 0x03)
#define REG_SC_BK5A_03_H      _PK_H_(0x5A, 0x03)
#define REG_SC_BK5A_04_L      _PK_L_(0x5A, 0x04)
#define REG_SC_BK5A_04_H      _PK_H_(0x5A, 0x04)
#define REG_SC_BK5A_05_L      _PK_L_(0x5A, 0x05)
#define REG_SC_BK5A_05_H      _PK_H_(0x5A, 0x05)
#define REG_SC_BK5A_06_L      _PK_L_(0x5A, 0x06)
#define REG_SC_BK5A_06_H      _PK_H_(0x5A, 0x06)
#define REG_SC_BK5A_07_L      _PK_L_(0x5A, 0x07)
#define REG_SC_BK5A_07_H      _PK_H_(0x5A, 0x07)
#define REG_SC_BK5A_08_L      _PK_L_(0x5A, 0x08)
#define REG_SC_BK5A_08_H      _PK_H_(0x5A, 0x08)
#define REG_SC_BK5A_09_L      _PK_L_(0x5A, 0x09)
#define REG_SC_BK5A_09_H      _PK_H_(0x5A, 0x09)
#define REG_SC_BK5A_0A_L      _PK_L_(0x5A, 0x0A)
#define REG_SC_BK5A_0A_H      _PK_H_(0x5A, 0x0A)
#define REG_SC_BK5A_0B_L      _PK_L_(0x5A, 0x0B)
#define REG_SC_BK5A_0B_H      _PK_H_(0x5A, 0x0B)
#define REG_SC_BK5A_0C_L      _PK_L_(0x5A, 0x0C)
#define REG_SC_BK5A_0C_H      _PK_H_(0x5A, 0x0C)
#define REG_SC_BK5A_0D_L      _PK_L_(0x5A, 0x0D)
#define REG_SC_BK5A_0D_H      _PK_H_(0x5A, 0x0D)
#define REG_SC_BK5A_0E_L      _PK_L_(0x5A, 0x0E)
#define REG_SC_BK5A_0E_H      _PK_H_(0x5A, 0x0E)
#define REG_SC_BK5A_0F_L      _PK_L_(0x5A, 0x0F)
#define REG_SC_BK5A_0F_H      _PK_H_(0x5A, 0x0F)
#define REG_SC_BK5A_10_L      _PK_L_(0x5A, 0x10)
#define REG_SC_BK5A_10_H      _PK_H_(0x5A, 0x10)
#define REG_SC_BK5A_11_L      _PK_L_(0x5A, 0x11)
#define REG_SC_BK5A_11_H      _PK_H_(0x5A, 0x11)
#define REG_SC_BK5A_12_L      _PK_L_(0x5A, 0x12)
#define REG_SC_BK5A_12_H      _PK_H_(0x5A, 0x12)
#define REG_SC_BK5A_13_L      _PK_L_(0x5A, 0x13)
#define REG_SC_BK5A_13_H      _PK_H_(0x5A, 0x13)
#define REG_SC_BK5A_14_L      _PK_L_(0x5A, 0x14)
#define REG_SC_BK5A_14_H      _PK_H_(0x5A, 0x14)
#define REG_SC_BK5A_15_L      _PK_L_(0x5A, 0x15)
#define REG_SC_BK5A_15_H      _PK_H_(0x5A, 0x15)
#define REG_SC_BK5A_16_L      _PK_L_(0x5A, 0x16)
#define REG_SC_BK5A_16_H      _PK_H_(0x5A, 0x16)
#define REG_SC_BK5A_17_L      _PK_L_(0x5A, 0x17)
#define REG_SC_BK5A_17_H      _PK_H_(0x5A, 0x17)
#define REG_SC_BK5A_18_L      _PK_L_(0x5A, 0x18)
#define REG_SC_BK5A_18_H      _PK_H_(0x5A, 0x18)
#define REG_SC_BK5A_19_L      _PK_L_(0x5A, 0x19)
#define REG_SC_BK5A_19_H      _PK_H_(0x5A, 0x19)
#define REG_SC_BK5A_1A_L      _PK_L_(0x5A, 0x1A)
#define REG_SC_BK5A_1A_H      _PK_H_(0x5A, 0x1A)
#define REG_SC_BK5A_1B_L      _PK_L_(0x5A, 0x1B)
#define REG_SC_BK5A_1B_H      _PK_H_(0x5A, 0x1B)
#define REG_SC_BK5A_1C_L      _PK_L_(0x5A, 0x1C)
#define REG_SC_BK5A_1C_H      _PK_H_(0x5A, 0x1C)
#define REG_SC_BK5A_1D_L      _PK_L_(0x5A, 0x1D)
#define REG_SC_BK5A_1D_H      _PK_H_(0x5A, 0x1D)
#define REG_SC_BK5A_1E_L      _PK_L_(0x5A, 0x1E)
#define REG_SC_BK5A_1E_H      _PK_H_(0x5A, 0x1E)
#define REG_SC_BK5A_1F_L      _PK_L_(0x5A, 0x1F)
#define REG_SC_BK5A_1F_H      _PK_H_(0x5A, 0x1F)
#define REG_SC_BK5A_20_L      _PK_L_(0x5A, 0x20)
#define REG_SC_BK5A_20_H      _PK_H_(0x5A, 0x20)
#define REG_SC_BK5A_21_L      _PK_L_(0x5A, 0x21)
#define REG_SC_BK5A_21_H      _PK_H_(0x5A, 0x21)
#define REG_SC_BK5A_22_L      _PK_L_(0x5A, 0x22)
#define REG_SC_BK5A_22_H      _PK_H_(0x5A, 0x22)
#define REG_SC_BK5A_23_L      _PK_L_(0x5A, 0x23)
#define REG_SC_BK5A_23_H      _PK_H_(0x5A, 0x23)
#define REG_SC_BK5A_24_L      _PK_L_(0x5A, 0x24)
#define REG_SC_BK5A_24_H      _PK_H_(0x5A, 0x24)
#define REG_SC_BK5A_25_L      _PK_L_(0x5A, 0x25)
#define REG_SC_BK5A_25_H      _PK_H_(0x5A, 0x25)
#define REG_SC_BK5A_26_L      _PK_L_(0x5A, 0x26)
#define REG_SC_BK5A_26_H      _PK_H_(0x5A, 0x26)
#define REG_SC_BK5A_27_L      _PK_L_(0x5A, 0x27)
#define REG_SC_BK5A_27_H      _PK_H_(0x5A, 0x27)
#define REG_SC_BK5A_28_L      _PK_L_(0x5A, 0x28)
#define REG_SC_BK5A_28_H      _PK_H_(0x5A, 0x28)
#define REG_SC_BK5A_29_L      _PK_L_(0x5A, 0x29)
#define REG_SC_BK5A_29_H      _PK_H_(0x5A, 0x29)
#define REG_SC_BK5A_2A_L      _PK_L_(0x5A, 0x2A)
#define REG_SC_BK5A_2A_H      _PK_H_(0x5A, 0x2A)
#define REG_SC_BK5A_2B_L      _PK_L_(0x5A, 0x2B)
#define REG_SC_BK5A_2B_H      _PK_H_(0x5A, 0x2B)
#define REG_SC_BK5A_2C_L      _PK_L_(0x5A, 0x2C)
#define REG_SC_BK5A_2C_H      _PK_H_(0x5A, 0x2C)
#define REG_SC_BK5A_2D_L      _PK_L_(0x5A, 0x2D)
#define REG_SC_BK5A_2D_H      _PK_H_(0x5A, 0x2D)
#define REG_SC_BK5A_2E_L      _PK_L_(0x5A, 0x2E)
#define REG_SC_BK5A_2E_H      _PK_H_(0x5A, 0x2E)
#define REG_SC_BK5A_2F_L      _PK_L_(0x5A, 0x2F)
#define REG_SC_BK5A_2F_H      _PK_H_(0x5A, 0x2F)
#define REG_SC_BK5A_30_L      _PK_L_(0x5A, 0x30)
#define REG_SC_BK5A_30_H      _PK_H_(0x5A, 0x30)
#define REG_SC_BK5A_31_L      _PK_L_(0x5A, 0x31)
#define REG_SC_BK5A_31_H      _PK_H_(0x5A, 0x31)
#define REG_SC_BK5A_32_L      _PK_L_(0x5A, 0x32)
#define REG_SC_BK5A_32_H      _PK_H_(0x5A, 0x32)
#define REG_SC_BK5A_33_L      _PK_L_(0x5A, 0x33)
#define REG_SC_BK5A_33_H      _PK_H_(0x5A, 0x33)
#define REG_SC_BK5A_34_L      _PK_L_(0x5A, 0x34)
#define REG_SC_BK5A_34_H      _PK_H_(0x5A, 0x34)
#define REG_SC_BK5A_35_L      _PK_L_(0x5A, 0x35)
#define REG_SC_BK5A_35_H      _PK_H_(0x5A, 0x35)
#define REG_SC_BK5A_36_L      _PK_L_(0x5A, 0x36)
#define REG_SC_BK5A_36_H      _PK_H_(0x5A, 0x36)
#define REG_SC_BK5A_37_L      _PK_L_(0x5A, 0x37)
#define REG_SC_BK5A_37_H      _PK_H_(0x5A, 0x37)
#define REG_SC_BK5A_38_L      _PK_L_(0x5A, 0x38)
#define REG_SC_BK5A_38_H      _PK_H_(0x5A, 0x38)
#define REG_SC_BK5A_39_L      _PK_L_(0x5A, 0x39)
#define REG_SC_BK5A_39_H      _PK_H_(0x5A, 0x39)
#define REG_SC_BK5A_3A_L      _PK_L_(0x5A, 0x3A)
#define REG_SC_BK5A_3A_H      _PK_H_(0x5A, 0x3A)
#define REG_SC_BK5A_3B_L      _PK_L_(0x5A, 0x3B)
#define REG_SC_BK5A_3B_H      _PK_H_(0x5A, 0x3B)
#define REG_SC_BK5A_3C_L      _PK_L_(0x5A, 0x3C)
#define REG_SC_BK5A_3C_H      _PK_H_(0x5A, 0x3C)
#define REG_SC_BK5A_3D_L      _PK_L_(0x5A, 0x3D)
#define REG_SC_BK5A_3D_H      _PK_H_(0x5A, 0x3D)
#define REG_SC_BK5A_3E_L      _PK_L_(0x5A, 0x3E)
#define REG_SC_BK5A_3E_H      _PK_H_(0x5A, 0x3E)
#define REG_SC_BK5A_3F_L      _PK_L_(0x5A, 0x3F)
#define REG_SC_BK5A_3F_H      _PK_H_(0x5A, 0x3F)
#define REG_SC_BK5A_40_L      _PK_L_(0x5A, 0x40)
#define REG_SC_BK5A_40_H      _PK_H_(0x5A, 0x40)
#define REG_SC_BK5A_41_L      _PK_L_(0x5A, 0x41)
#define REG_SC_BK5A_41_H      _PK_H_(0x5A, 0x41)
#define REG_SC_BK5A_42_L      _PK_L_(0x5A, 0x42)
#define REG_SC_BK5A_42_H      _PK_H_(0x5A, 0x42)
#define REG_SC_BK5A_43_L      _PK_L_(0x5A, 0x43)
#define REG_SC_BK5A_43_H      _PK_H_(0x5A, 0x43)
#define REG_SC_BK5A_44_L      _PK_L_(0x5A, 0x44)
#define REG_SC_BK5A_44_H      _PK_H_(0x5A, 0x44)
#define REG_SC_BK5A_45_L      _PK_L_(0x5A, 0x45)
#define REG_SC_BK5A_45_H      _PK_H_(0x5A, 0x45)
#define REG_SC_BK5A_46_L      _PK_L_(0x5A, 0x46)
#define REG_SC_BK5A_46_H      _PK_H_(0x5A, 0x46)
#define REG_SC_BK5A_47_L      _PK_L_(0x5A, 0x47)
#define REG_SC_BK5A_47_H      _PK_H_(0x5A, 0x47)
#define REG_SC_BK5A_48_L      _PK_L_(0x5A, 0x48)
#define REG_SC_BK5A_48_H      _PK_H_(0x5A, 0x48)
#define REG_SC_BK5A_49_L      _PK_L_(0x5A, 0x49)
#define REG_SC_BK5A_49_H      _PK_H_(0x5A, 0x49)
#define REG_SC_BK5A_4A_L      _PK_L_(0x5A, 0x4A)
#define REG_SC_BK5A_4A_H      _PK_H_(0x5A, 0x4A)
#define REG_SC_BK5A_4B_L      _PK_L_(0x5A, 0x4B)
#define REG_SC_BK5A_4B_H      _PK_H_(0x5A, 0x4B)
#define REG_SC_BK5A_4C_L      _PK_L_(0x5A, 0x4C)
#define REG_SC_BK5A_4C_H      _PK_H_(0x5A, 0x4C)
#define REG_SC_BK5A_4D_L      _PK_L_(0x5A, 0x4D)
#define REG_SC_BK5A_4D_H      _PK_H_(0x5A, 0x4D)
#define REG_SC_BK5A_4E_L      _PK_L_(0x5A, 0x4E)
#define REG_SC_BK5A_4E_H      _PK_H_(0x5A, 0x4E)
#define REG_SC_BK5A_4F_L      _PK_L_(0x5A, 0x4F)
#define REG_SC_BK5A_4F_H      _PK_H_(0x5A, 0x4F)
#define REG_SC_BK5A_50_L      _PK_L_(0x5A, 0x50)
#define REG_SC_BK5A_50_H      _PK_H_(0x5A, 0x50)
#define REG_SC_BK5A_51_L      _PK_L_(0x5A, 0x51)
#define REG_SC_BK5A_51_H      _PK_H_(0x5A, 0x51)
#define REG_SC_BK5A_52_L      _PK_L_(0x5A, 0x52)
#define REG_SC_BK5A_52_H      _PK_H_(0x5A, 0x52)
#define REG_SC_BK5A_53_L      _PK_L_(0x5A, 0x53)
#define REG_SC_BK5A_53_H      _PK_H_(0x5A, 0x53)
#define REG_SC_BK5A_54_L      _PK_L_(0x5A, 0x54)
#define REG_SC_BK5A_54_H      _PK_H_(0x5A, 0x54)
#define REG_SC_BK5A_55_L      _PK_L_(0x5A, 0x55)
#define REG_SC_BK5A_55_H      _PK_H_(0x5A, 0x55)
#define REG_SC_BK5A_56_L      _PK_L_(0x5A, 0x56)
#define REG_SC_BK5A_56_H      _PK_H_(0x5A, 0x56)
#define REG_SC_BK5A_57_L      _PK_L_(0x5A, 0x57)
#define REG_SC_BK5A_57_H      _PK_H_(0x5A, 0x57)
#define REG_SC_BK5A_58_L      _PK_L_(0x5A, 0x58)
#define REG_SC_BK5A_58_H      _PK_H_(0x5A, 0x58)
#define REG_SC_BK5A_59_L      _PK_L_(0x5A, 0x59)
#define REG_SC_BK5A_59_H      _PK_H_(0x5A, 0x59)
#define REG_SC_BK5A_5A_L      _PK_L_(0x5A, 0x5A)
#define REG_SC_BK5A_5A_H      _PK_H_(0x5A, 0x5A)
#define REG_SC_BK5A_5B_L      _PK_L_(0x5A, 0x5B)
#define REG_SC_BK5A_5B_H      _PK_H_(0x5A, 0x5B)
#define REG_SC_BK5A_5C_L      _PK_L_(0x5A, 0x5C)
#define REG_SC_BK5A_5C_H      _PK_H_(0x5A, 0x5C)
#define REG_SC_BK5A_5D_L      _PK_L_(0x5A, 0x5D)
#define REG_SC_BK5A_5D_H      _PK_H_(0x5A, 0x5D)
#define REG_SC_BK5A_5E_L      _PK_L_(0x5A, 0x5E)
#define REG_SC_BK5A_5E_H      _PK_H_(0x5A, 0x5E)
#define REG_SC_BK5A_5F_L      _PK_L_(0x5A, 0x5F)
#define REG_SC_BK5A_5F_H      _PK_H_(0x5A, 0x5F)
#define REG_SC_BK5A_60_L      _PK_L_(0x5A, 0x60)
#define REG_SC_BK5A_60_H      _PK_H_(0x5A, 0x60)
#define REG_SC_BK5A_61_L      _PK_L_(0x5A, 0x61)
#define REG_SC_BK5A_61_H      _PK_H_(0x5A, 0x61)
#define REG_SC_BK5A_62_L      _PK_L_(0x5A, 0x62)
#define REG_SC_BK5A_62_H      _PK_H_(0x5A, 0x62)
#define REG_SC_BK5A_63_L      _PK_L_(0x5A, 0x63)
#define REG_SC_BK5A_63_H      _PK_H_(0x5A, 0x63)
#define REG_SC_BK5A_64_L      _PK_L_(0x5A, 0x64)
#define REG_SC_BK5A_64_H      _PK_H_(0x5A, 0x64)
#define REG_SC_BK5A_65_L      _PK_L_(0x5A, 0x65)
#define REG_SC_BK5A_65_H      _PK_H_(0x5A, 0x65)
#define REG_SC_BK5A_66_L      _PK_L_(0x5A, 0x66)
#define REG_SC_BK5A_66_H      _PK_H_(0x5A, 0x66)
#define REG_SC_BK5A_67_L      _PK_L_(0x5A, 0x67)
#define REG_SC_BK5A_67_H      _PK_H_(0x5A, 0x67)
#define REG_SC_BK5A_68_L      _PK_L_(0x5A, 0x68)
#define REG_SC_BK5A_68_H      _PK_H_(0x5A, 0x68)
#define REG_SC_BK5A_69_L      _PK_L_(0x5A, 0x69)
#define REG_SC_BK5A_69_H      _PK_H_(0x5A, 0x69)
#define REG_SC_BK5A_6A_L      _PK_L_(0x5A, 0x6A)
#define REG_SC_BK5A_6A_H      _PK_H_(0x5A, 0x6A)
#define REG_SC_BK5A_6B_L      _PK_L_(0x5A, 0x6B)
#define REG_SC_BK5A_6B_H      _PK_H_(0x5A, 0x6B)
#define REG_SC_BK5A_6C_L      _PK_L_(0x5A, 0x6C)
#define REG_SC_BK5A_6C_H      _PK_H_(0x5A, 0x6C)
#define REG_SC_BK5A_6D_L      _PK_L_(0x5A, 0x6D)
#define REG_SC_BK5A_6D_H      _PK_H_(0x5A, 0x6D)
#define REG_SC_BK5A_6E_L      _PK_L_(0x5A, 0x6E)
#define REG_SC_BK5A_6E_H      _PK_H_(0x5A, 0x6E)
#define REG_SC_BK5A_6F_L      _PK_L_(0x5A, 0x6F)
#define REG_SC_BK5A_6F_H      _PK_H_(0x5A, 0x6F)
#define REG_SC_BK5A_70_L      _PK_L_(0x5A, 0x70)
#define REG_SC_BK5A_70_H      _PK_H_(0x5A, 0x70)
#define REG_SC_BK5A_71_L      _PK_L_(0x5A, 0x71)
#define REG_SC_BK5A_71_H      _PK_H_(0x5A, 0x71)
#define REG_SC_BK5A_72_L      _PK_L_(0x5A, 0x72)
#define REG_SC_BK5A_72_H      _PK_H_(0x5A, 0x72)
#define REG_SC_BK5A_73_L      _PK_L_(0x5A, 0x73)
#define REG_SC_BK5A_73_H      _PK_H_(0x5A, 0x73)
#define REG_SC_BK5A_74_L      _PK_L_(0x5A, 0x74)
#define REG_SC_BK5A_74_H      _PK_H_(0x5A, 0x74)
#define REG_SC_BK5A_75_L      _PK_L_(0x5A, 0x75)
#define REG_SC_BK5A_75_H      _PK_H_(0x5A, 0x75)
#define REG_SC_BK5A_76_L      _PK_L_(0x5A, 0x76)
#define REG_SC_BK5A_76_H      _PK_H_(0x5A, 0x76)
#define REG_SC_BK5A_77_L      _PK_L_(0x5A, 0x77)
#define REG_SC_BK5A_77_H      _PK_H_(0x5A, 0x77)
#define REG_SC_BK5A_78_L      _PK_L_(0x5A, 0x78)
#define REG_SC_BK5A_78_H      _PK_H_(0x5A, 0x78)
#define REG_SC_BK5A_79_L      _PK_L_(0x5A, 0x79)
#define REG_SC_BK5A_79_H      _PK_H_(0x5A, 0x79)
#define REG_SC_BK5A_7A_L      _PK_L_(0x5A, 0x7A)
#define REG_SC_BK5A_7A_H      _PK_H_(0x5A, 0x7A)
#define REG_SC_BK5A_7B_L      _PK_L_(0x5A, 0x7B)
#define REG_SC_BK5A_7B_H      _PK_H_(0x5A, 0x7B)
#define REG_SC_BK5A_7C_L      _PK_L_(0x5A, 0x7C)
#define REG_SC_BK5A_7C_H      _PK_H_(0x5A, 0x7C)
#define REG_SC_BK5A_7D_L      _PK_L_(0x5A, 0x7D)
#define REG_SC_BK5A_7D_H      _PK_H_(0x5A, 0x7D)
#define REG_SC_BK5A_7E_L      _PK_L_(0x5A, 0x7E)
#define REG_SC_BK5A_7E_H      _PK_H_(0x5A, 0x7E)
#define REG_SC_BK5A_7F_L      _PK_L_(0x5A, 0x7F)
#define REG_SC_BK5A_7F_H      _PK_H_(0x5A, 0x7F)
//----------------------------------------------
#define REG_SC_BK5B_00_L      _PK_L_(0x5B, 0x00)
#define REG_SC_BK5B_00_H      _PK_H_(0x5B, 0x00)
#define REG_SC_BK5B_01_L      _PK_L_(0x5B, 0x01)
#define REG_SC_BK5B_01_H      _PK_H_(0x5B, 0x01)
#define REG_SC_BK5B_02_L      _PK_L_(0x5B, 0x02)
#define REG_SC_BK5B_02_H      _PK_H_(0x5B, 0x02)
#define REG_SC_BK5B_03_L      _PK_L_(0x5B, 0x03)
#define REG_SC_BK5B_03_H      _PK_H_(0x5B, 0x03)
#define REG_SC_BK5B_04_L      _PK_L_(0x5B, 0x04)
#define REG_SC_BK5B_04_H      _PK_H_(0x5B, 0x04)
#define REG_SC_BK5B_05_L      _PK_L_(0x5B, 0x05)
#define REG_SC_BK5B_05_H      _PK_H_(0x5B, 0x05)
#define REG_SC_BK5B_06_L      _PK_L_(0x5B, 0x06)
#define REG_SC_BK5B_06_H      _PK_H_(0x5B, 0x06)
#define REG_SC_BK5B_07_L      _PK_L_(0x5B, 0x07)
#define REG_SC_BK5B_07_H      _PK_H_(0x5B, 0x07)
#define REG_SC_BK5B_08_L      _PK_L_(0x5B, 0x08)
#define REG_SC_BK5B_08_H      _PK_H_(0x5B, 0x08)
#define REG_SC_BK5B_09_L      _PK_L_(0x5B, 0x09)
#define REG_SC_BK5B_09_H      _PK_H_(0x5B, 0x09)
#define REG_SC_BK5B_0A_L      _PK_L_(0x5B, 0x0A)
#define REG_SC_BK5B_0A_H      _PK_H_(0x5B, 0x0A)
#define REG_SC_BK5B_0B_L      _PK_L_(0x5B, 0x0B)
#define REG_SC_BK5B_0B_H      _PK_H_(0x5B, 0x0B)
#define REG_SC_BK5B_0C_L      _PK_L_(0x5B, 0x0C)
#define REG_SC_BK5B_0C_H      _PK_H_(0x5B, 0x0C)
#define REG_SC_BK5B_0D_L      _PK_L_(0x5B, 0x0D)
#define REG_SC_BK5B_0D_H      _PK_H_(0x5B, 0x0D)
#define REG_SC_BK5B_0E_L      _PK_L_(0x5B, 0x0E)
#define REG_SC_BK5B_0E_H      _PK_H_(0x5B, 0x0E)
#define REG_SC_BK5B_0F_L      _PK_L_(0x5B, 0x0F)
#define REG_SC_BK5B_0F_H      _PK_H_(0x5B, 0x0F)
#define REG_SC_BK5B_10_L      _PK_L_(0x5B, 0x10)
#define REG_SC_BK5B_10_H      _PK_H_(0x5B, 0x10)
#define REG_SC_BK5B_11_L      _PK_L_(0x5B, 0x11)
#define REG_SC_BK5B_11_H      _PK_H_(0x5B, 0x11)
#define REG_SC_BK5B_12_L      _PK_L_(0x5B, 0x12)
#define REG_SC_BK5B_12_H      _PK_H_(0x5B, 0x12)
#define REG_SC_BK5B_13_L      _PK_L_(0x5B, 0x13)
#define REG_SC_BK5B_13_H      _PK_H_(0x5B, 0x13)
#define REG_SC_BK5B_14_L      _PK_L_(0x5B, 0x14)
#define REG_SC_BK5B_14_H      _PK_H_(0x5B, 0x14)
#define REG_SC_BK5B_15_L      _PK_L_(0x5B, 0x15)
#define REG_SC_BK5B_15_H      _PK_H_(0x5B, 0x15)
#define REG_SC_BK5B_16_L      _PK_L_(0x5B, 0x16)
#define REG_SC_BK5B_16_H      _PK_H_(0x5B, 0x16)
#define REG_SC_BK5B_17_L      _PK_L_(0x5B, 0x17)
#define REG_SC_BK5B_17_H      _PK_H_(0x5B, 0x17)
#define REG_SC_BK5B_18_L      _PK_L_(0x5B, 0x18)
#define REG_SC_BK5B_18_H      _PK_H_(0x5B, 0x18)
#define REG_SC_BK5B_19_L      _PK_L_(0x5B, 0x19)
#define REG_SC_BK5B_19_H      _PK_H_(0x5B, 0x19)
#define REG_SC_BK5B_1A_L      _PK_L_(0x5B, 0x1A)
#define REG_SC_BK5B_1A_H      _PK_H_(0x5B, 0x1A)
#define REG_SC_BK5B_1B_L      _PK_L_(0x5B, 0x1B)
#define REG_SC_BK5B_1B_H      _PK_H_(0x5B, 0x1B)
#define REG_SC_BK5B_1C_L      _PK_L_(0x5B, 0x1C)
#define REG_SC_BK5B_1C_H      _PK_H_(0x5B, 0x1C)
#define REG_SC_BK5B_1D_L      _PK_L_(0x5B, 0x1D)
#define REG_SC_BK5B_1D_H      _PK_H_(0x5B, 0x1D)
#define REG_SC_BK5B_1E_L      _PK_L_(0x5B, 0x1E)
#define REG_SC_BK5B_1E_H      _PK_H_(0x5B, 0x1E)
#define REG_SC_BK5B_1F_L      _PK_L_(0x5B, 0x1F)
#define REG_SC_BK5B_1F_H      _PK_H_(0x5B, 0x1F)
#define REG_SC_BK5B_20_L      _PK_L_(0x5B, 0x20)
#define REG_SC_BK5B_20_H      _PK_H_(0x5B, 0x20)
#define REG_SC_BK5B_21_L      _PK_L_(0x5B, 0x21)
#define REG_SC_BK5B_21_H      _PK_H_(0x5B, 0x21)
#define REG_SC_BK5B_22_L      _PK_L_(0x5B, 0x22)
#define REG_SC_BK5B_22_H      _PK_H_(0x5B, 0x22)
#define REG_SC_BK5B_23_L      _PK_L_(0x5B, 0x23)
#define REG_SC_BK5B_23_H      _PK_H_(0x5B, 0x23)
#define REG_SC_BK5B_24_L      _PK_L_(0x5B, 0x24)
#define REG_SC_BK5B_24_H      _PK_H_(0x5B, 0x24)
#define REG_SC_BK5B_25_L      _PK_L_(0x5B, 0x25)
#define REG_SC_BK5B_25_H      _PK_H_(0x5B, 0x25)
#define REG_SC_BK5B_26_L      _PK_L_(0x5B, 0x26)
#define REG_SC_BK5B_26_H      _PK_H_(0x5B, 0x26)
#define REG_SC_BK5B_27_L      _PK_L_(0x5B, 0x27)
#define REG_SC_BK5B_27_H      _PK_H_(0x5B, 0x27)
#define REG_SC_BK5B_28_L      _PK_L_(0x5B, 0x28)
#define REG_SC_BK5B_28_H      _PK_H_(0x5B, 0x28)
#define REG_SC_BK5B_29_L      _PK_L_(0x5B, 0x29)
#define REG_SC_BK5B_29_H      _PK_H_(0x5B, 0x29)
#define REG_SC_BK5B_2A_L      _PK_L_(0x5B, 0x2A)
#define REG_SC_BK5B_2A_H      _PK_H_(0x5B, 0x2A)
#define REG_SC_BK5B_2B_L      _PK_L_(0x5B, 0x2B)
#define REG_SC_BK5B_2B_H      _PK_H_(0x5B, 0x2B)
#define REG_SC_BK5B_2C_L      _PK_L_(0x5B, 0x2C)
#define REG_SC_BK5B_2C_H      _PK_H_(0x5B, 0x2C)
#define REG_SC_BK5B_2D_L      _PK_L_(0x5B, 0x2D)
#define REG_SC_BK5B_2D_H      _PK_H_(0x5B, 0x2D)
#define REG_SC_BK5B_2E_L      _PK_L_(0x5B, 0x2E)
#define REG_SC_BK5B_2E_H      _PK_H_(0x5B, 0x2E)
#define REG_SC_BK5B_2F_L      _PK_L_(0x5B, 0x2F)
#define REG_SC_BK5B_2F_H      _PK_H_(0x5B, 0x2F)
#define REG_SC_BK5B_30_L      _PK_L_(0x5B, 0x30)
#define REG_SC_BK5B_30_H      _PK_H_(0x5B, 0x30)
#define REG_SC_BK5B_31_L      _PK_L_(0x5B, 0x31)
#define REG_SC_BK5B_31_H      _PK_H_(0x5B, 0x31)
#define REG_SC_BK5B_32_L      _PK_L_(0x5B, 0x32)
#define REG_SC_BK5B_32_H      _PK_H_(0x5B, 0x32)
#define REG_SC_BK5B_33_L      _PK_L_(0x5B, 0x33)
#define REG_SC_BK5B_33_H      _PK_H_(0x5B, 0x33)
#define REG_SC_BK5B_34_L      _PK_L_(0x5B, 0x34)
#define REG_SC_BK5B_34_H      _PK_H_(0x5B, 0x34)
#define REG_SC_BK5B_35_L      _PK_L_(0x5B, 0x35)
#define REG_SC_BK5B_35_H      _PK_H_(0x5B, 0x35)
#define REG_SC_BK5B_36_L      _PK_L_(0x5B, 0x36)
#define REG_SC_BK5B_36_H      _PK_H_(0x5B, 0x36)
#define REG_SC_BK5B_37_L      _PK_L_(0x5B, 0x37)
#define REG_SC_BK5B_37_H      _PK_H_(0x5B, 0x37)
#define REG_SC_BK5B_38_L      _PK_L_(0x5B, 0x38)
#define REG_SC_BK5B_38_H      _PK_H_(0x5B, 0x38)
#define REG_SC_BK5B_39_L      _PK_L_(0x5B, 0x39)
#define REG_SC_BK5B_39_H      _PK_H_(0x5B, 0x39)
#define REG_SC_BK5B_3A_L      _PK_L_(0x5B, 0x3A)
#define REG_SC_BK5B_3A_H      _PK_H_(0x5B, 0x3A)
#define REG_SC_BK5B_3B_L      _PK_L_(0x5B, 0x3B)
#define REG_SC_BK5B_3B_H      _PK_H_(0x5B, 0x3B)
#define REG_SC_BK5B_3C_L      _PK_L_(0x5B, 0x3C)
#define REG_SC_BK5B_3C_H      _PK_H_(0x5B, 0x3C)
#define REG_SC_BK5B_3D_L      _PK_L_(0x5B, 0x3D)
#define REG_SC_BK5B_3D_H      _PK_H_(0x5B, 0x3D)
#define REG_SC_BK5B_3E_L      _PK_L_(0x5B, 0x3E)
#define REG_SC_BK5B_3E_H      _PK_H_(0x5B, 0x3E)
#define REG_SC_BK5B_3F_L      _PK_L_(0x5B, 0x3F)
#define REG_SC_BK5B_3F_H      _PK_H_(0x5B, 0x3F)
#define REG_SC_BK5B_40_L      _PK_L_(0x5B, 0x40)
#define REG_SC_BK5B_40_H      _PK_H_(0x5B, 0x40)
#define REG_SC_BK5B_41_L      _PK_L_(0x5B, 0x41)
#define REG_SC_BK5B_41_H      _PK_H_(0x5B, 0x41)
#define REG_SC_BK5B_42_L      _PK_L_(0x5B, 0x42)
#define REG_SC_BK5B_42_H      _PK_H_(0x5B, 0x42)
#define REG_SC_BK5B_43_L      _PK_L_(0x5B, 0x43)
#define REG_SC_BK5B_43_H      _PK_H_(0x5B, 0x43)
#define REG_SC_BK5B_44_L      _PK_L_(0x5B, 0x44)
#define REG_SC_BK5B_44_H      _PK_H_(0x5B, 0x44)
#define REG_SC_BK5B_45_L      _PK_L_(0x5B, 0x45)
#define REG_SC_BK5B_45_H      _PK_H_(0x5B, 0x45)
#define REG_SC_BK5B_46_L      _PK_L_(0x5B, 0x46)
#define REG_SC_BK5B_46_H      _PK_H_(0x5B, 0x46)
#define REG_SC_BK5B_47_L      _PK_L_(0x5B, 0x47)
#define REG_SC_BK5B_47_H      _PK_H_(0x5B, 0x47)
#define REG_SC_BK5B_48_L      _PK_L_(0x5B, 0x48)
#define REG_SC_BK5B_48_H      _PK_H_(0x5B, 0x48)
#define REG_SC_BK5B_49_L      _PK_L_(0x5B, 0x49)
#define REG_SC_BK5B_49_H      _PK_H_(0x5B, 0x49)
#define REG_SC_BK5B_4A_L      _PK_L_(0x5B, 0x4A)
#define REG_SC_BK5B_4A_H      _PK_H_(0x5B, 0x4A)
#define REG_SC_BK5B_4B_L      _PK_L_(0x5B, 0x4B)
#define REG_SC_BK5B_4B_H      _PK_H_(0x5B, 0x4B)
#define REG_SC_BK5B_4C_L      _PK_L_(0x5B, 0x4C)
#define REG_SC_BK5B_4C_H      _PK_H_(0x5B, 0x4C)
#define REG_SC_BK5B_4D_L      _PK_L_(0x5B, 0x4D)
#define REG_SC_BK5B_4D_H      _PK_H_(0x5B, 0x4D)
#define REG_SC_BK5B_4E_L      _PK_L_(0x5B, 0x4E)
#define REG_SC_BK5B_4E_H      _PK_H_(0x5B, 0x4E)
#define REG_SC_BK5B_4F_L      _PK_L_(0x5B, 0x4F)
#define REG_SC_BK5B_4F_H      _PK_H_(0x5B, 0x4F)
#define REG_SC_BK5B_50_L      _PK_L_(0x5B, 0x50)
#define REG_SC_BK5B_50_H      _PK_H_(0x5B, 0x50)
#define REG_SC_BK5B_51_L      _PK_L_(0x5B, 0x51)
#define REG_SC_BK5B_51_H      _PK_H_(0x5B, 0x51)
#define REG_SC_BK5B_52_L      _PK_L_(0x5B, 0x52)
#define REG_SC_BK5B_52_H      _PK_H_(0x5B, 0x52)
#define REG_SC_BK5B_53_L      _PK_L_(0x5B, 0x53)
#define REG_SC_BK5B_53_H      _PK_H_(0x5B, 0x53)
#define REG_SC_BK5B_54_L      _PK_L_(0x5B, 0x54)
#define REG_SC_BK5B_54_H      _PK_H_(0x5B, 0x54)
#define REG_SC_BK5B_55_L      _PK_L_(0x5B, 0x55)
#define REG_SC_BK5B_55_H      _PK_H_(0x5B, 0x55)
#define REG_SC_BK5B_56_L      _PK_L_(0x5B, 0x56)
#define REG_SC_BK5B_56_H      _PK_H_(0x5B, 0x56)
#define REG_SC_BK5B_57_L      _PK_L_(0x5B, 0x57)
#define REG_SC_BK5B_57_H      _PK_H_(0x5B, 0x57)
#define REG_SC_BK5B_58_L      _PK_L_(0x5B, 0x58)
#define REG_SC_BK5B_58_H      _PK_H_(0x5B, 0x58)
#define REG_SC_BK5B_59_L      _PK_L_(0x5B, 0x59)
#define REG_SC_BK5B_59_H      _PK_H_(0x5B, 0x59)
#define REG_SC_BK5B_5A_L      _PK_L_(0x5B, 0x5A)
#define REG_SC_BK5B_5A_H      _PK_H_(0x5B, 0x5A)
#define REG_SC_BK5B_5B_L      _PK_L_(0x5B, 0x5B)
#define REG_SC_BK5B_5B_H      _PK_H_(0x5B, 0x5B)
#define REG_SC_BK5B_5C_L      _PK_L_(0x5B, 0x5C)
#define REG_SC_BK5B_5C_H      _PK_H_(0x5B, 0x5C)
#define REG_SC_BK5B_5D_L      _PK_L_(0x5B, 0x5D)
#define REG_SC_BK5B_5D_H      _PK_H_(0x5B, 0x5D)
#define REG_SC_BK5B_5E_L      _PK_L_(0x5B, 0x5E)
#define REG_SC_BK5B_5E_H      _PK_H_(0x5B, 0x5E)
#define REG_SC_BK5B_5F_L      _PK_L_(0x5B, 0x5F)
#define REG_SC_BK5B_5F_H      _PK_H_(0x5B, 0x5F)
#define REG_SC_BK5B_60_L      _PK_L_(0x5B, 0x60)
#define REG_SC_BK5B_60_H      _PK_H_(0x5B, 0x60)
#define REG_SC_BK5B_61_L      _PK_L_(0x5B, 0x61)
#define REG_SC_BK5B_61_H      _PK_H_(0x5B, 0x61)
#define REG_SC_BK5B_62_L      _PK_L_(0x5B, 0x62)
#define REG_SC_BK5B_62_H      _PK_H_(0x5B, 0x62)
#define REG_SC_BK5B_63_L      _PK_L_(0x5B, 0x63)
#define REG_SC_BK5B_63_H      _PK_H_(0x5B, 0x63)
#define REG_SC_BK5B_64_L      _PK_L_(0x5B, 0x64)
#define REG_SC_BK5B_64_H      _PK_H_(0x5B, 0x64)
#define REG_SC_BK5B_65_L      _PK_L_(0x5B, 0x65)
#define REG_SC_BK5B_65_H      _PK_H_(0x5B, 0x65)
#define REG_SC_BK5B_66_L      _PK_L_(0x5B, 0x66)
#define REG_SC_BK5B_66_H      _PK_H_(0x5B, 0x66)
#define REG_SC_BK5B_67_L      _PK_L_(0x5B, 0x67)
#define REG_SC_BK5B_67_H      _PK_H_(0x5B, 0x67)
#define REG_SC_BK5B_68_L      _PK_L_(0x5B, 0x68)
#define REG_SC_BK5B_68_H      _PK_H_(0x5B, 0x68)
#define REG_SC_BK5B_69_L      _PK_L_(0x5B, 0x69)
#define REG_SC_BK5B_69_H      _PK_H_(0x5B, 0x69)
#define REG_SC_BK5B_6A_L      _PK_L_(0x5B, 0x6A)
#define REG_SC_BK5B_6A_H      _PK_H_(0x5B, 0x6A)
#define REG_SC_BK5B_6B_L      _PK_L_(0x5B, 0x6B)
#define REG_SC_BK5B_6B_H      _PK_H_(0x5B, 0x6B)
#define REG_SC_BK5B_6C_L      _PK_L_(0x5B, 0x6C)
#define REG_SC_BK5B_6C_H      _PK_H_(0x5B, 0x6C)
#define REG_SC_BK5B_6D_L      _PK_L_(0x5B, 0x6D)
#define REG_SC_BK5B_6D_H      _PK_H_(0x5B, 0x6D)
#define REG_SC_BK5B_6E_L      _PK_L_(0x5B, 0x6E)
#define REG_SC_BK5B_6E_H      _PK_H_(0x5B, 0x6E)
#define REG_SC_BK5B_6F_L      _PK_L_(0x5B, 0x6F)
#define REG_SC_BK5B_6F_H      _PK_H_(0x5B, 0x6F)
#define REG_SC_BK5B_70_L      _PK_L_(0x5B, 0x70)
#define REG_SC_BK5B_70_H      _PK_H_(0x5B, 0x70)
#define REG_SC_BK5B_71_L      _PK_L_(0x5B, 0x71)
#define REG_SC_BK5B_71_H      _PK_H_(0x5B, 0x71)
#define REG_SC_BK5B_72_L      _PK_L_(0x5B, 0x72)
#define REG_SC_BK5B_72_H      _PK_H_(0x5B, 0x72)
#define REG_SC_BK5B_73_L      _PK_L_(0x5B, 0x73)
#define REG_SC_BK5B_73_H      _PK_H_(0x5B, 0x73)
#define REG_SC_BK5B_74_L      _PK_L_(0x5B, 0x74)
#define REG_SC_BK5B_74_H      _PK_H_(0x5B, 0x74)
#define REG_SC_BK5B_75_L      _PK_L_(0x5B, 0x75)
#define REG_SC_BK5B_75_H      _PK_H_(0x5B, 0x75)
#define REG_SC_BK5B_76_L      _PK_L_(0x5B, 0x76)
#define REG_SC_BK5B_76_H      _PK_H_(0x5B, 0x76)
#define REG_SC_BK5B_77_L      _PK_L_(0x5B, 0x77)
#define REG_SC_BK5B_77_H      _PK_H_(0x5B, 0x77)
#define REG_SC_BK5B_78_L      _PK_L_(0x5B, 0x78)
#define REG_SC_BK5B_78_H      _PK_H_(0x5B, 0x78)
#define REG_SC_BK5B_79_L      _PK_L_(0x5B, 0x79)
#define REG_SC_BK5B_79_H      _PK_H_(0x5B, 0x79)
#define REG_SC_BK5B_7A_L      _PK_L_(0x5B, 0x7A)
#define REG_SC_BK5B_7A_H      _PK_H_(0x5B, 0x7A)
#define REG_SC_BK5B_7B_L      _PK_L_(0x5B, 0x7B)
#define REG_SC_BK5B_7B_H      _PK_H_(0x5B, 0x7B)
#define REG_SC_BK5B_7C_L      _PK_L_(0x5B, 0x7C)
#define REG_SC_BK5B_7C_H      _PK_H_(0x5B, 0x7C)
#define REG_SC_BK5B_7D_L      _PK_L_(0x5B, 0x7D)
#define REG_SC_BK5B_7D_H      _PK_H_(0x5B, 0x7D)
#define REG_SC_BK5B_7E_L      _PK_L_(0x5B, 0x7E)
#define REG_SC_BK5B_7E_H      _PK_H_(0x5B, 0x7E)
#define REG_SC_BK5B_7F_L      _PK_L_(0x5B, 0x7F)
#define REG_SC_BK5B_7F_H      _PK_H_(0x5B, 0x7F)
//----------------------------------------------
#define REG_SC_BK5C_00_L      _PK_L_(0x5C, 0x00)
#define REG_SC_BK5C_00_H      _PK_H_(0x5C, 0x00)
#define REG_SC_BK5C_01_L      _PK_L_(0x5C, 0x01)
#define REG_SC_BK5C_01_H      _PK_H_(0x5C, 0x01)
#define REG_SC_BK5C_02_L      _PK_L_(0x5C, 0x02)
#define REG_SC_BK5C_02_H      _PK_H_(0x5C, 0x02)
#define REG_SC_BK5C_03_L      _PK_L_(0x5C, 0x03)
#define REG_SC_BK5C_03_H      _PK_H_(0x5C, 0x03)
#define REG_SC_BK5C_04_L      _PK_L_(0x5C, 0x04)
#define REG_SC_BK5C_04_H      _PK_H_(0x5C, 0x04)
#define REG_SC_BK5C_05_L      _PK_L_(0x5C, 0x05)
#define REG_SC_BK5C_05_H      _PK_H_(0x5C, 0x05)
#define REG_SC_BK5C_06_L      _PK_L_(0x5C, 0x06)
#define REG_SC_BK5C_06_H      _PK_H_(0x5C, 0x06)
#define REG_SC_BK5C_07_L      _PK_L_(0x5C, 0x07)
#define REG_SC_BK5C_07_H      _PK_H_(0x5C, 0x07)
#define REG_SC_BK5C_08_L      _PK_L_(0x5C, 0x08)
#define REG_SC_BK5C_08_H      _PK_H_(0x5C, 0x08)
#define REG_SC_BK5C_09_L      _PK_L_(0x5C, 0x09)
#define REG_SC_BK5C_09_H      _PK_H_(0x5C, 0x09)
#define REG_SC_BK5C_0A_L      _PK_L_(0x5C, 0x0A)
#define REG_SC_BK5C_0A_H      _PK_H_(0x5C, 0x0A)
#define REG_SC_BK5C_0B_L      _PK_L_(0x5C, 0x0B)
#define REG_SC_BK5C_0B_H      _PK_H_(0x5C, 0x0B)
#define REG_SC_BK5C_0C_L      _PK_L_(0x5C, 0x0C)
#define REG_SC_BK5C_0C_H      _PK_H_(0x5C, 0x0C)
#define REG_SC_BK5C_0D_L      _PK_L_(0x5C, 0x0D)
#define REG_SC_BK5C_0D_H      _PK_H_(0x5C, 0x0D)
#define REG_SC_BK5C_0E_L      _PK_L_(0x5C, 0x0E)
#define REG_SC_BK5C_0E_H      _PK_H_(0x5C, 0x0E)
#define REG_SC_BK5C_0F_L      _PK_L_(0x5C, 0x0F)
#define REG_SC_BK5C_0F_H      _PK_H_(0x5C, 0x0F)
#define REG_SC_BK5C_10_L      _PK_L_(0x5C, 0x10)
#define REG_SC_BK5C_10_H      _PK_H_(0x5C, 0x10)
#define REG_SC_BK5C_11_L      _PK_L_(0x5C, 0x11)
#define REG_SC_BK5C_11_H      _PK_H_(0x5C, 0x11)
#define REG_SC_BK5C_12_L      _PK_L_(0x5C, 0x12)
#define REG_SC_BK5C_12_H      _PK_H_(0x5C, 0x12)
#define REG_SC_BK5C_13_L      _PK_L_(0x5C, 0x13)
#define REG_SC_BK5C_13_H      _PK_H_(0x5C, 0x13)
#define REG_SC_BK5C_14_L      _PK_L_(0x5C, 0x14)
#define REG_SC_BK5C_14_H      _PK_H_(0x5C, 0x14)
#define REG_SC_BK5C_15_L      _PK_L_(0x5C, 0x15)
#define REG_SC_BK5C_15_H      _PK_H_(0x5C, 0x15)
#define REG_SC_BK5C_16_L      _PK_L_(0x5C, 0x16)
#define REG_SC_BK5C_16_H      _PK_H_(0x5C, 0x16)
#define REG_SC_BK5C_17_L      _PK_L_(0x5C, 0x17)
#define REG_SC_BK5C_17_H      _PK_H_(0x5C, 0x17)
#define REG_SC_BK5C_18_L      _PK_L_(0x5C, 0x18)
#define REG_SC_BK5C_18_H      _PK_H_(0x5C, 0x18)
#define REG_SC_BK5C_19_L      _PK_L_(0x5C, 0x19)
#define REG_SC_BK5C_19_H      _PK_H_(0x5C, 0x19)
#define REG_SC_BK5C_1A_L      _PK_L_(0x5C, 0x1A)
#define REG_SC_BK5C_1A_H      _PK_H_(0x5C, 0x1A)
#define REG_SC_BK5C_1B_L      _PK_L_(0x5C, 0x1B)
#define REG_SC_BK5C_1B_H      _PK_H_(0x5C, 0x1B)
#define REG_SC_BK5C_1C_L      _PK_L_(0x5C, 0x1C)
#define REG_SC_BK5C_1C_H      _PK_H_(0x5C, 0x1C)
#define REG_SC_BK5C_1D_L      _PK_L_(0x5C, 0x1D)
#define REG_SC_BK5C_1D_H      _PK_H_(0x5C, 0x1D)
#define REG_SC_BK5C_1E_L      _PK_L_(0x5C, 0x1E)
#define REG_SC_BK5C_1E_H      _PK_H_(0x5C, 0x1E)
#define REG_SC_BK5C_1F_L      _PK_L_(0x5C, 0x1F)
#define REG_SC_BK5C_1F_H      _PK_H_(0x5C, 0x1F)
#define REG_SC_BK5C_20_L      _PK_L_(0x5C, 0x20)
#define REG_SC_BK5C_20_H      _PK_H_(0x5C, 0x20)
#define REG_SC_BK5C_21_L      _PK_L_(0x5C, 0x21)
#define REG_SC_BK5C_21_H      _PK_H_(0x5C, 0x21)
#define REG_SC_BK5C_22_L      _PK_L_(0x5C, 0x22)
#define REG_SC_BK5C_22_H      _PK_H_(0x5C, 0x22)
#define REG_SC_BK5C_23_L      _PK_L_(0x5C, 0x23)
#define REG_SC_BK5C_23_H      _PK_H_(0x5C, 0x23)
#define REG_SC_BK5C_24_L      _PK_L_(0x5C, 0x24)
#define REG_SC_BK5C_24_H      _PK_H_(0x5C, 0x24)
#define REG_SC_BK5C_25_L      _PK_L_(0x5C, 0x25)
#define REG_SC_BK5C_25_H      _PK_H_(0x5C, 0x25)
#define REG_SC_BK5C_26_L      _PK_L_(0x5C, 0x26)
#define REG_SC_BK5C_26_H      _PK_H_(0x5C, 0x26)
#define REG_SC_BK5C_27_L      _PK_L_(0x5C, 0x27)
#define REG_SC_BK5C_27_H      _PK_H_(0x5C, 0x27)
#define REG_SC_BK5C_28_L      _PK_L_(0x5C, 0x28)
#define REG_SC_BK5C_28_H      _PK_H_(0x5C, 0x28)
#define REG_SC_BK5C_29_L      _PK_L_(0x5C, 0x29)
#define REG_SC_BK5C_29_H      _PK_H_(0x5C, 0x29)
#define REG_SC_BK5C_2A_L      _PK_L_(0x5C, 0x2A)
#define REG_SC_BK5C_2A_H      _PK_H_(0x5C, 0x2A)
#define REG_SC_BK5C_2B_L      _PK_L_(0x5C, 0x2B)
#define REG_SC_BK5C_2B_H      _PK_H_(0x5C, 0x2B)
#define REG_SC_BK5C_2C_L      _PK_L_(0x5C, 0x2C)
#define REG_SC_BK5C_2C_H      _PK_H_(0x5C, 0x2C)
#define REG_SC_BK5C_2D_L      _PK_L_(0x5C, 0x2D)
#define REG_SC_BK5C_2D_H      _PK_H_(0x5C, 0x2D)
#define REG_SC_BK5C_2E_L      _PK_L_(0x5C, 0x2E)
#define REG_SC_BK5C_2E_H      _PK_H_(0x5C, 0x2E)
#define REG_SC_BK5C_2F_L      _PK_L_(0x5C, 0x2F)
#define REG_SC_BK5C_2F_H      _PK_H_(0x5C, 0x2F)
#define REG_SC_BK5C_30_L      _PK_L_(0x5C, 0x30)
#define REG_SC_BK5C_30_H      _PK_H_(0x5C, 0x30)
#define REG_SC_BK5C_31_L      _PK_L_(0x5C, 0x31)
#define REG_SC_BK5C_31_H      _PK_H_(0x5C, 0x31)
#define REG_SC_BK5C_32_L      _PK_L_(0x5C, 0x32)
#define REG_SC_BK5C_32_H      _PK_H_(0x5C, 0x32)
#define REG_SC_BK5C_33_L      _PK_L_(0x5C, 0x33)
#define REG_SC_BK5C_33_H      _PK_H_(0x5C, 0x33)
#define REG_SC_BK5C_34_L      _PK_L_(0x5C, 0x34)
#define REG_SC_BK5C_34_H      _PK_H_(0x5C, 0x34)
#define REG_SC_BK5C_35_L      _PK_L_(0x5C, 0x35)
#define REG_SC_BK5C_35_H      _PK_H_(0x5C, 0x35)
#define REG_SC_BK5C_36_L      _PK_L_(0x5C, 0x36)
#define REG_SC_BK5C_36_H      _PK_H_(0x5C, 0x36)
#define REG_SC_BK5C_37_L      _PK_L_(0x5C, 0x37)
#define REG_SC_BK5C_37_H      _PK_H_(0x5C, 0x37)
#define REG_SC_BK5C_38_L      _PK_L_(0x5C, 0x38)
#define REG_SC_BK5C_38_H      _PK_H_(0x5C, 0x38)
#define REG_SC_BK5C_39_L      _PK_L_(0x5C, 0x39)
#define REG_SC_BK5C_39_H      _PK_H_(0x5C, 0x39)
#define REG_SC_BK5C_3A_L      _PK_L_(0x5C, 0x3A)
#define REG_SC_BK5C_3A_H      _PK_H_(0x5C, 0x3A)
#define REG_SC_BK5C_3B_L      _PK_L_(0x5C, 0x3B)
#define REG_SC_BK5C_3B_H      _PK_H_(0x5C, 0x3B)
#define REG_SC_BK5C_3C_L      _PK_L_(0x5C, 0x3C)
#define REG_SC_BK5C_3C_H      _PK_H_(0x5C, 0x3C)
#define REG_SC_BK5C_3D_L      _PK_L_(0x5C, 0x3D)
#define REG_SC_BK5C_3D_H      _PK_H_(0x5C, 0x3D)
#define REG_SC_BK5C_3E_L      _PK_L_(0x5C, 0x3E)
#define REG_SC_BK5C_3E_H      _PK_H_(0x5C, 0x3E)
#define REG_SC_BK5C_3F_L      _PK_L_(0x5C, 0x3F)
#define REG_SC_BK5C_3F_H      _PK_H_(0x5C, 0x3F)
#define REG_SC_BK5C_40_L      _PK_L_(0x5C, 0x40)
#define REG_SC_BK5C_40_H      _PK_H_(0x5C, 0x40)
#define REG_SC_BK5C_41_L      _PK_L_(0x5C, 0x41)
#define REG_SC_BK5C_41_H      _PK_H_(0x5C, 0x41)
#define REG_SC_BK5C_42_L      _PK_L_(0x5C, 0x42)
#define REG_SC_BK5C_42_H      _PK_H_(0x5C, 0x42)
#define REG_SC_BK5C_43_L      _PK_L_(0x5C, 0x43)
#define REG_SC_BK5C_43_H      _PK_H_(0x5C, 0x43)
#define REG_SC_BK5C_44_L      _PK_L_(0x5C, 0x44)
#define REG_SC_BK5C_44_H      _PK_H_(0x5C, 0x44)
#define REG_SC_BK5C_45_L      _PK_L_(0x5C, 0x45)
#define REG_SC_BK5C_45_H      _PK_H_(0x5C, 0x45)
#define REG_SC_BK5C_46_L      _PK_L_(0x5C, 0x46)
#define REG_SC_BK5C_46_H      _PK_H_(0x5C, 0x46)
#define REG_SC_BK5C_47_L      _PK_L_(0x5C, 0x47)
#define REG_SC_BK5C_47_H      _PK_H_(0x5C, 0x47)
#define REG_SC_BK5C_48_L      _PK_L_(0x5C, 0x48)
#define REG_SC_BK5C_48_H      _PK_H_(0x5C, 0x48)
#define REG_SC_BK5C_49_L      _PK_L_(0x5C, 0x49)
#define REG_SC_BK5C_49_H      _PK_H_(0x5C, 0x49)
#define REG_SC_BK5C_4A_L      _PK_L_(0x5C, 0x4A)
#define REG_SC_BK5C_4A_H      _PK_H_(0x5C, 0x4A)
#define REG_SC_BK5C_4B_L      _PK_L_(0x5C, 0x4B)
#define REG_SC_BK5C_4B_H      _PK_H_(0x5C, 0x4B)
#define REG_SC_BK5C_4C_L      _PK_L_(0x5C, 0x4C)
#define REG_SC_BK5C_4C_H      _PK_H_(0x5C, 0x4C)
#define REG_SC_BK5C_4D_L      _PK_L_(0x5C, 0x4D)
#define REG_SC_BK5C_4D_H      _PK_H_(0x5C, 0x4D)
#define REG_SC_BK5C_4E_L      _PK_L_(0x5C, 0x4E)
#define REG_SC_BK5C_4E_H      _PK_H_(0x5C, 0x4E)
#define REG_SC_BK5C_4F_L      _PK_L_(0x5C, 0x4F)
#define REG_SC_BK5C_4F_H      _PK_H_(0x5C, 0x4F)
#define REG_SC_BK5C_50_L      _PK_L_(0x5C, 0x50)
#define REG_SC_BK5C_50_H      _PK_H_(0x5C, 0x50)
#define REG_SC_BK5C_51_L      _PK_L_(0x5C, 0x51)
#define REG_SC_BK5C_51_H      _PK_H_(0x5C, 0x51)
#define REG_SC_BK5C_52_L      _PK_L_(0x5C, 0x52)
#define REG_SC_BK5C_52_H      _PK_H_(0x5C, 0x52)
#define REG_SC_BK5C_53_L      _PK_L_(0x5C, 0x53)
#define REG_SC_BK5C_53_H      _PK_H_(0x5C, 0x53)
#define REG_SC_BK5C_54_L      _PK_L_(0x5C, 0x54)
#define REG_SC_BK5C_54_H      _PK_H_(0x5C, 0x54)
#define REG_SC_BK5C_55_L      _PK_L_(0x5C, 0x55)
#define REG_SC_BK5C_55_H      _PK_H_(0x5C, 0x55)
#define REG_SC_BK5C_56_L      _PK_L_(0x5C, 0x56)
#define REG_SC_BK5C_56_H      _PK_H_(0x5C, 0x56)
#define REG_SC_BK5C_57_L      _PK_L_(0x5C, 0x57)
#define REG_SC_BK5C_57_H      _PK_H_(0x5C, 0x57)
#define REG_SC_BK5C_58_L      _PK_L_(0x5C, 0x58)
#define REG_SC_BK5C_58_H      _PK_H_(0x5C, 0x58)
#define REG_SC_BK5C_59_L      _PK_L_(0x5C, 0x59)
#define REG_SC_BK5C_59_H      _PK_H_(0x5C, 0x59)
#define REG_SC_BK5C_5A_L      _PK_L_(0x5C, 0x5A)
#define REG_SC_BK5C_5A_H      _PK_H_(0x5C, 0x5A)
#define REG_SC_BK5C_5B_L      _PK_L_(0x5C, 0x5B)
#define REG_SC_BK5C_5B_H      _PK_H_(0x5C, 0x5B)
#define REG_SC_BK5C_5C_L      _PK_L_(0x5C, 0x5C)
#define REG_SC_BK5C_5C_H      _PK_H_(0x5C, 0x5C)
#define REG_SC_BK5C_5D_L      _PK_L_(0x5C, 0x5D)
#define REG_SC_BK5C_5D_H      _PK_H_(0x5C, 0x5D)
#define REG_SC_BK5C_5E_L      _PK_L_(0x5C, 0x5E)
#define REG_SC_BK5C_5E_H      _PK_H_(0x5C, 0x5E)
#define REG_SC_BK5C_5F_L      _PK_L_(0x5C, 0x5F)
#define REG_SC_BK5C_5F_H      _PK_H_(0x5C, 0x5F)
#define REG_SC_BK5C_60_L      _PK_L_(0x5C, 0x60)
#define REG_SC_BK5C_60_H      _PK_H_(0x5C, 0x60)
#define REG_SC_BK5C_61_L      _PK_L_(0x5C, 0x61)
#define REG_SC_BK5C_61_H      _PK_H_(0x5C, 0x61)
#define REG_SC_BK5C_62_L      _PK_L_(0x5C, 0x62)
#define REG_SC_BK5C_62_H      _PK_H_(0x5C, 0x62)
#define REG_SC_BK5C_63_L      _PK_L_(0x5C, 0x63)
#define REG_SC_BK5C_63_H      _PK_H_(0x5C, 0x63)
#define REG_SC_BK5C_64_L      _PK_L_(0x5C, 0x64)
#define REG_SC_BK5C_64_H      _PK_H_(0x5C, 0x64)
#define REG_SC_BK5C_65_L      _PK_L_(0x5C, 0x65)
#define REG_SC_BK5C_65_H      _PK_H_(0x5C, 0x65)
#define REG_SC_BK5C_66_L      _PK_L_(0x5C, 0x66)
#define REG_SC_BK5C_66_H      _PK_H_(0x5C, 0x66)
#define REG_SC_BK5C_67_L      _PK_L_(0x5C, 0x67)
#define REG_SC_BK5C_67_H      _PK_H_(0x5C, 0x67)
#define REG_SC_BK5C_68_L      _PK_L_(0x5C, 0x68)
#define REG_SC_BK5C_68_H      _PK_H_(0x5C, 0x68)
#define REG_SC_BK5C_69_L      _PK_L_(0x5C, 0x69)
#define REG_SC_BK5C_69_H      _PK_H_(0x5C, 0x69)
#define REG_SC_BK5C_6A_L      _PK_L_(0x5C, 0x6A)
#define REG_SC_BK5C_6A_H      _PK_H_(0x5C, 0x6A)
#define REG_SC_BK5C_6B_L      _PK_L_(0x5C, 0x6B)
#define REG_SC_BK5C_6B_H      _PK_H_(0x5C, 0x6B)
#define REG_SC_BK5C_6C_L      _PK_L_(0x5C, 0x6C)
#define REG_SC_BK5C_6C_H      _PK_H_(0x5C, 0x6C)
#define REG_SC_BK5C_6D_L      _PK_L_(0x5C, 0x6D)
#define REG_SC_BK5C_6D_H      _PK_H_(0x5C, 0x6D)
#define REG_SC_BK5C_6E_L      _PK_L_(0x5C, 0x6E)
#define REG_SC_BK5C_6E_H      _PK_H_(0x5C, 0x6E)
#define REG_SC_BK5C_6F_L      _PK_L_(0x5C, 0x6F)
#define REG_SC_BK5C_6F_H      _PK_H_(0x5C, 0x6F)
#define REG_SC_BK5C_70_L      _PK_L_(0x5C, 0x70)
#define REG_SC_BK5C_70_H      _PK_H_(0x5C, 0x70)
#define REG_SC_BK5C_71_L      _PK_L_(0x5C, 0x71)
#define REG_SC_BK5C_71_H      _PK_H_(0x5C, 0x71)
#define REG_SC_BK5C_72_L      _PK_L_(0x5C, 0x72)
#define REG_SC_BK5C_72_H      _PK_H_(0x5C, 0x72)
#define REG_SC_BK5C_73_L      _PK_L_(0x5C, 0x73)
#define REG_SC_BK5C_73_H      _PK_H_(0x5C, 0x73)
#define REG_SC_BK5C_74_L      _PK_L_(0x5C, 0x74)
#define REG_SC_BK5C_74_H      _PK_H_(0x5C, 0x74)
#define REG_SC_BK5C_75_L      _PK_L_(0x5C, 0x75)
#define REG_SC_BK5C_75_H      _PK_H_(0x5C, 0x75)
#define REG_SC_BK5C_76_L      _PK_L_(0x5C, 0x76)
#define REG_SC_BK5C_76_H      _PK_H_(0x5C, 0x76)
#define REG_SC_BK5C_77_L      _PK_L_(0x5C, 0x77)
#define REG_SC_BK5C_77_H      _PK_H_(0x5C, 0x77)
#define REG_SC_BK5C_78_L      _PK_L_(0x5C, 0x78)
#define REG_SC_BK5C_78_H      _PK_H_(0x5C, 0x78)
#define REG_SC_BK5C_79_L      _PK_L_(0x5C, 0x79)
#define REG_SC_BK5C_79_H      _PK_H_(0x5C, 0x79)
#define REG_SC_BK5C_7A_L      _PK_L_(0x5C, 0x7A)
#define REG_SC_BK5C_7A_H      _PK_H_(0x5C, 0x7A)
#define REG_SC_BK5C_7B_L      _PK_L_(0x5C, 0x7B)
#define REG_SC_BK5C_7B_H      _PK_H_(0x5C, 0x7B)
#define REG_SC_BK5C_7C_L      _PK_L_(0x5C, 0x7C)
#define REG_SC_BK5C_7C_H      _PK_H_(0x5C, 0x7C)
#define REG_SC_BK5C_7D_L      _PK_L_(0x5C, 0x7D)
#define REG_SC_BK5C_7D_H      _PK_H_(0x5C, 0x7D)
#define REG_SC_BK5C_7E_L      _PK_L_(0x5C, 0x7E)
#define REG_SC_BK5C_7E_H      _PK_H_(0x5C, 0x7E)
#define REG_SC_BK5C_7F_L      _PK_L_(0x5C, 0x7F)
#define REG_SC_BK5C_7F_H      _PK_H_(0x5C, 0x7F)
//----------------------------------------------
#define REG_SC_BK5F_00_L      _PK_L_(0x5F, 0x00)
#define REG_SC_BK5F_00_H      _PK_H_(0x5F, 0x00)
#define REG_SC_BK5F_01_L      _PK_L_(0x5F, 0x01)
#define REG_SC_BK5F_01_H      _PK_H_(0x5F, 0x01)
#define REG_SC_BK5F_02_L      _PK_L_(0x5F, 0x02)
#define REG_SC_BK5F_02_H      _PK_H_(0x5F, 0x02)
#define REG_SC_BK5F_03_L      _PK_L_(0x5F, 0x03)
#define REG_SC_BK5F_03_H      _PK_H_(0x5F, 0x03)
#define REG_SC_BK5F_04_L      _PK_L_(0x5F, 0x04)
#define REG_SC_BK5F_04_H      _PK_H_(0x5F, 0x04)
#define REG_SC_BK5F_05_L      _PK_L_(0x5F, 0x05)
#define REG_SC_BK5F_05_H      _PK_H_(0x5F, 0x05)
#define REG_SC_BK5F_06_L      _PK_L_(0x5F, 0x06)
#define REG_SC_BK5F_06_H      _PK_H_(0x5F, 0x06)
#define REG_SC_BK5F_07_L      _PK_L_(0x5F, 0x07)
#define REG_SC_BK5F_07_H      _PK_H_(0x5F, 0x07)
#define REG_SC_BK5F_08_L      _PK_L_(0x5F, 0x08)
#define REG_SC_BK5F_08_H      _PK_H_(0x5F, 0x08)
#define REG_SC_BK5F_09_L      _PK_L_(0x5F, 0x09)
#define REG_SC_BK5F_09_H      _PK_H_(0x5F, 0x09)
#define REG_SC_BK5F_0A_L      _PK_L_(0x5F, 0x0A)
#define REG_SC_BK5F_0A_H      _PK_H_(0x5F, 0x0A)
#define REG_SC_BK5F_0B_L      _PK_L_(0x5F, 0x0B)
#define REG_SC_BK5F_0B_H      _PK_H_(0x5F, 0x0B)
#define REG_SC_BK5F_0C_L      _PK_L_(0x5F, 0x0C)
#define REG_SC_BK5F_0C_H      _PK_H_(0x5F, 0x0C)
#define REG_SC_BK5F_0D_L      _PK_L_(0x5F, 0x0D)
#define REG_SC_BK5F_0D_H      _PK_H_(0x5F, 0x0D)
#define REG_SC_BK5F_0E_L      _PK_L_(0x5F, 0x0E)
#define REG_SC_BK5F_0E_H      _PK_H_(0x5F, 0x0E)
#define REG_SC_BK5F_0F_L      _PK_L_(0x5F, 0x0F)
#define REG_SC_BK5F_0F_H      _PK_H_(0x5F, 0x0F)
#define REG_SC_BK5F_10_L      _PK_L_(0x5F, 0x10)
#define REG_SC_BK5F_10_H      _PK_H_(0x5F, 0x10)
#define REG_SC_BK5F_11_L      _PK_L_(0x5F, 0x11)
#define REG_SC_BK5F_11_H      _PK_H_(0x5F, 0x11)
#define REG_SC_BK5F_12_L      _PK_L_(0x5F, 0x12)
#define REG_SC_BK5F_12_H      _PK_H_(0x5F, 0x12)
#define REG_SC_BK5F_13_L      _PK_L_(0x5F, 0x13)
#define REG_SC_BK5F_13_H      _PK_H_(0x5F, 0x13)
#define REG_SC_BK5F_14_L      _PK_L_(0x5F, 0x14)
#define REG_SC_BK5F_14_H      _PK_H_(0x5F, 0x14)
#define REG_SC_BK5F_15_L      _PK_L_(0x5F, 0x15)
#define REG_SC_BK5F_15_H      _PK_H_(0x5F, 0x15)
#define REG_SC_BK5F_16_L      _PK_L_(0x5F, 0x16)
#define REG_SC_BK5F_16_H      _PK_H_(0x5F, 0x16)
#define REG_SC_BK5F_17_L      _PK_L_(0x5F, 0x17)
#define REG_SC_BK5F_17_H      _PK_H_(0x5F, 0x17)
#define REG_SC_BK5F_18_L      _PK_L_(0x5F, 0x18)
#define REG_SC_BK5F_18_H      _PK_H_(0x5F, 0x18)
#define REG_SC_BK5F_19_L      _PK_L_(0x5F, 0x19)
#define REG_SC_BK5F_19_H      _PK_H_(0x5F, 0x19)
#define REG_SC_BK5F_1A_L      _PK_L_(0x5F, 0x1A)
#define REG_SC_BK5F_1A_H      _PK_H_(0x5F, 0x1A)
#define REG_SC_BK5F_1B_L      _PK_L_(0x5F, 0x1B)
#define REG_SC_BK5F_1B_H      _PK_H_(0x5F, 0x1B)
#define REG_SC_BK5F_1C_L      _PK_L_(0x5F, 0x1C)
#define REG_SC_BK5F_1C_H      _PK_H_(0x5F, 0x1C)
#define REG_SC_BK5F_1D_L      _PK_L_(0x5F, 0x1D)
#define REG_SC_BK5F_1D_H      _PK_H_(0x5F, 0x1D)
#define REG_SC_BK5F_1E_L      _PK_L_(0x5F, 0x1E)
#define REG_SC_BK5F_1E_H      _PK_H_(0x5F, 0x1E)
#define REG_SC_BK5F_1F_L      _PK_L_(0x5F, 0x1F)
#define REG_SC_BK5F_1F_H      _PK_H_(0x5F, 0x1F)
#define REG_SC_BK5F_20_L      _PK_L_(0x5F, 0x20)
#define REG_SC_BK5F_20_H      _PK_H_(0x5F, 0x20)
#define REG_SC_BK5F_21_L      _PK_L_(0x5F, 0x21)
#define REG_SC_BK5F_21_H      _PK_H_(0x5F, 0x21)
#define REG_SC_BK5F_22_L      _PK_L_(0x5F, 0x22)
#define REG_SC_BK5F_22_H      _PK_H_(0x5F, 0x22)
#define REG_SC_BK5F_23_L      _PK_L_(0x5F, 0x23)
#define REG_SC_BK5F_23_H      _PK_H_(0x5F, 0x23)
#define REG_SC_BK5F_24_L      _PK_L_(0x5F, 0x24)
#define REG_SC_BK5F_24_H      _PK_H_(0x5F, 0x24)
#define REG_SC_BK5F_25_L      _PK_L_(0x5F, 0x25)
#define REG_SC_BK5F_25_H      _PK_H_(0x5F, 0x25)
#define REG_SC_BK5F_26_L      _PK_L_(0x5F, 0x26)
#define REG_SC_BK5F_26_H      _PK_H_(0x5F, 0x26)
#define REG_SC_BK5F_27_L      _PK_L_(0x5F, 0x27)
#define REG_SC_BK5F_27_H      _PK_H_(0x5F, 0x27)
#define REG_SC_BK5F_28_L      _PK_L_(0x5F, 0x28)
#define REG_SC_BK5F_28_H      _PK_H_(0x5F, 0x28)
#define REG_SC_BK5F_29_L      _PK_L_(0x5F, 0x29)
#define REG_SC_BK5F_29_H      _PK_H_(0x5F, 0x29)
#define REG_SC_BK5F_2A_L      _PK_L_(0x5F, 0x2A)
#define REG_SC_BK5F_2A_H      _PK_H_(0x5F, 0x2A)
#define REG_SC_BK5F_2B_L      _PK_L_(0x5F, 0x2B)
#define REG_SC_BK5F_2B_H      _PK_H_(0x5F, 0x2B)
#define REG_SC_BK5F_2C_L      _PK_L_(0x5F, 0x2C)
#define REG_SC_BK5F_2C_H      _PK_H_(0x5F, 0x2C)
#define REG_SC_BK5F_2D_L      _PK_L_(0x5F, 0x2D)
#define REG_SC_BK5F_2D_H      _PK_H_(0x5F, 0x2D)
#define REG_SC_BK5F_2E_L      _PK_L_(0x5F, 0x2E)
#define REG_SC_BK5F_2E_H      _PK_H_(0x5F, 0x2E)
#define REG_SC_BK5F_2F_L      _PK_L_(0x5F, 0x2F)
#define REG_SC_BK5F_2F_H      _PK_H_(0x5F, 0x2F)
#define REG_SC_BK5F_30_L      _PK_L_(0x5F, 0x30)
#define REG_SC_BK5F_30_H      _PK_H_(0x5F, 0x30)
#define REG_SC_BK5F_31_L      _PK_L_(0x5F, 0x31)
#define REG_SC_BK5F_31_H      _PK_H_(0x5F, 0x31)
#define REG_SC_BK5F_32_L      _PK_L_(0x5F, 0x32)
#define REG_SC_BK5F_32_H      _PK_H_(0x5F, 0x32)
#define REG_SC_BK5F_33_L      _PK_L_(0x5F, 0x33)
#define REG_SC_BK5F_33_H      _PK_H_(0x5F, 0x33)
#define REG_SC_BK5F_34_L      _PK_L_(0x5F, 0x34)
#define REG_SC_BK5F_34_H      _PK_H_(0x5F, 0x34)
#define REG_SC_BK5F_35_L      _PK_L_(0x5F, 0x35)
#define REG_SC_BK5F_35_H      _PK_H_(0x5F, 0x35)
#define REG_SC_BK5F_36_L      _PK_L_(0x5F, 0x36)
#define REG_SC_BK5F_36_H      _PK_H_(0x5F, 0x36)
#define REG_SC_BK5F_37_L      _PK_L_(0x5F, 0x37)
#define REG_SC_BK5F_37_H      _PK_H_(0x5F, 0x37)
#define REG_SC_BK5F_38_L      _PK_L_(0x5F, 0x38)
#define REG_SC_BK5F_38_H      _PK_H_(0x5F, 0x38)
#define REG_SC_BK5F_39_L      _PK_L_(0x5F, 0x39)
#define REG_SC_BK5F_39_H      _PK_H_(0x5F, 0x39)
#define REG_SC_BK5F_3A_L      _PK_L_(0x5F, 0x3A)
#define REG_SC_BK5F_3A_H      _PK_H_(0x5F, 0x3A)
#define REG_SC_BK5F_3B_L      _PK_L_(0x5F, 0x3B)
#define REG_SC_BK5F_3B_H      _PK_H_(0x5F, 0x3B)
#define REG_SC_BK5F_3C_L      _PK_L_(0x5F, 0x3C)
#define REG_SC_BK5F_3C_H      _PK_H_(0x5F, 0x3C)
#define REG_SC_BK5F_3D_L      _PK_L_(0x5F, 0x3D)
#define REG_SC_BK5F_3D_H      _PK_H_(0x5F, 0x3D)
#define REG_SC_BK5F_3E_L      _PK_L_(0x5F, 0x3E)
#define REG_SC_BK5F_3E_H      _PK_H_(0x5F, 0x3E)
#define REG_SC_BK5F_3F_L      _PK_L_(0x5F, 0x3F)
#define REG_SC_BK5F_3F_H      _PK_H_(0x5F, 0x3F)
#define REG_SC_BK5F_40_L      _PK_L_(0x5F, 0x40)
#define REG_SC_BK5F_40_H      _PK_H_(0x5F, 0x40)
#define REG_SC_BK5F_41_L      _PK_L_(0x5F, 0x41)
#define REG_SC_BK5F_41_H      _PK_H_(0x5F, 0x41)
#define REG_SC_BK5F_42_L      _PK_L_(0x5F, 0x42)
#define REG_SC_BK5F_42_H      _PK_H_(0x5F, 0x42)
#define REG_SC_BK5F_43_L      _PK_L_(0x5F, 0x43)
#define REG_SC_BK5F_43_H      _PK_H_(0x5F, 0x43)
#define REG_SC_BK5F_44_L      _PK_L_(0x5F, 0x44)
#define REG_SC_BK5F_44_H      _PK_H_(0x5F, 0x44)
#define REG_SC_BK5F_45_L      _PK_L_(0x5F, 0x45)
#define REG_SC_BK5F_45_H      _PK_H_(0x5F, 0x45)
#define REG_SC_BK5F_46_L      _PK_L_(0x5F, 0x46)
#define REG_SC_BK5F_46_H      _PK_H_(0x5F, 0x46)
#define REG_SC_BK5F_47_L      _PK_L_(0x5F, 0x47)
#define REG_SC_BK5F_47_H      _PK_H_(0x5F, 0x47)
#define REG_SC_BK5F_48_L      _PK_L_(0x5F, 0x48)
#define REG_SC_BK5F_48_H      _PK_H_(0x5F, 0x48)
#define REG_SC_BK5F_49_L      _PK_L_(0x5F, 0x49)
#define REG_SC_BK5F_49_H      _PK_H_(0x5F, 0x49)
#define REG_SC_BK5F_4A_L      _PK_L_(0x5F, 0x4A)
#define REG_SC_BK5F_4A_H      _PK_H_(0x5F, 0x4A)
#define REG_SC_BK5F_4B_L      _PK_L_(0x5F, 0x4B)
#define REG_SC_BK5F_4B_H      _PK_H_(0x5F, 0x4B)
#define REG_SC_BK5F_4C_L      _PK_L_(0x5F, 0x4C)
#define REG_SC_BK5F_4C_H      _PK_H_(0x5F, 0x4C)
#define REG_SC_BK5F_4D_L      _PK_L_(0x5F, 0x4D)
#define REG_SC_BK5F_4D_H      _PK_H_(0x5F, 0x4D)
#define REG_SC_BK5F_4E_L      _PK_L_(0x5F, 0x4E)
#define REG_SC_BK5F_4E_H      _PK_H_(0x5F, 0x4E)
#define REG_SC_BK5F_4F_L      _PK_L_(0x5F, 0x4F)
#define REG_SC_BK5F_4F_H      _PK_H_(0x5F, 0x4F)
#define REG_SC_BK5F_50_L      _PK_L_(0x5F, 0x50)
#define REG_SC_BK5F_50_H      _PK_H_(0x5F, 0x50)
#define REG_SC_BK5F_51_L      _PK_L_(0x5F, 0x51)
#define REG_SC_BK5F_51_H      _PK_H_(0x5F, 0x51)
#define REG_SC_BK5F_52_L      _PK_L_(0x5F, 0x52)
#define REG_SC_BK5F_52_H      _PK_H_(0x5F, 0x52)
#define REG_SC_BK5F_53_L      _PK_L_(0x5F, 0x53)
#define REG_SC_BK5F_53_H      _PK_H_(0x5F, 0x53)
#define REG_SC_BK5F_54_L      _PK_L_(0x5F, 0x54)
#define REG_SC_BK5F_54_H      _PK_H_(0x5F, 0x54)
#define REG_SC_BK5F_55_L      _PK_L_(0x5F, 0x55)
#define REG_SC_BK5F_55_H      _PK_H_(0x5F, 0x55)
#define REG_SC_BK5F_56_L      _PK_L_(0x5F, 0x56)
#define REG_SC_BK5F_56_H      _PK_H_(0x5F, 0x56)
#define REG_SC_BK5F_57_L      _PK_L_(0x5F, 0x57)
#define REG_SC_BK5F_57_H      _PK_H_(0x5F, 0x57)
#define REG_SC_BK5F_58_L      _PK_L_(0x5F, 0x58)
#define REG_SC_BK5F_58_H      _PK_H_(0x5F, 0x58)
#define REG_SC_BK5F_59_L      _PK_L_(0x5F, 0x59)
#define REG_SC_BK5F_59_H      _PK_H_(0x5F, 0x59)
#define REG_SC_BK5F_5A_L      _PK_L_(0x5F, 0x5A)
#define REG_SC_BK5F_5A_H      _PK_H_(0x5F, 0x5A)
#define REG_SC_BK5F_5B_L      _PK_L_(0x5F, 0x5B)
#define REG_SC_BK5F_5B_H      _PK_H_(0x5F, 0x5B)
#define REG_SC_BK5F_5C_L      _PK_L_(0x5F, 0x5C)
#define REG_SC_BK5F_5C_H      _PK_H_(0x5F, 0x5C)
#define REG_SC_BK5F_5D_L      _PK_L_(0x5F, 0x5D)
#define REG_SC_BK5F_5D_H      _PK_H_(0x5F, 0x5D)
#define REG_SC_BK5F_5E_L      _PK_L_(0x5F, 0x5E)
#define REG_SC_BK5F_5E_H      _PK_H_(0x5F, 0x5E)
#define REG_SC_BK5F_5F_L      _PK_L_(0x5F, 0x5F)
#define REG_SC_BK5F_5F_H      _PK_H_(0x5F, 0x5F)
#define REG_SC_BK5F_60_L      _PK_L_(0x5F, 0x60)
#define REG_SC_BK5F_60_H      _PK_H_(0x5F, 0x60)
#define REG_SC_BK5F_61_L      _PK_L_(0x5F, 0x61)
#define REG_SC_BK5F_61_H      _PK_H_(0x5F, 0x61)
#define REG_SC_BK5F_62_L      _PK_L_(0x5F, 0x62)
#define REG_SC_BK5F_62_H      _PK_H_(0x5F, 0x62)
#define REG_SC_BK5F_63_L      _PK_L_(0x5F, 0x63)
#define REG_SC_BK5F_63_H      _PK_H_(0x5F, 0x63)
#define REG_SC_BK5F_64_L      _PK_L_(0x5F, 0x64)
#define REG_SC_BK5F_64_H      _PK_H_(0x5F, 0x64)
#define REG_SC_BK5F_65_L      _PK_L_(0x5F, 0x65)
#define REG_SC_BK5F_65_H      _PK_H_(0x5F, 0x65)
#define REG_SC_BK5F_66_L      _PK_L_(0x5F, 0x66)
#define REG_SC_BK5F_66_H      _PK_H_(0x5F, 0x66)
#define REG_SC_BK5F_67_L      _PK_L_(0x5F, 0x67)
#define REG_SC_BK5F_67_H      _PK_H_(0x5F, 0x67)
#define REG_SC_BK5F_68_L      _PK_L_(0x5F, 0x68)
#define REG_SC_BK5F_68_H      _PK_H_(0x5F, 0x68)
#define REG_SC_BK5F_69_L      _PK_L_(0x5F, 0x69)
#define REG_SC_BK5F_69_H      _PK_H_(0x5F, 0x69)
#define REG_SC_BK5F_6A_L      _PK_L_(0x5F, 0x6A)
#define REG_SC_BK5F_6A_H      _PK_H_(0x5F, 0x6A)
#define REG_SC_BK5F_6B_L      _PK_L_(0x5F, 0x6B)
#define REG_SC_BK5F_6B_H      _PK_H_(0x5F, 0x6B)
#define REG_SC_BK5F_6C_L      _PK_L_(0x5F, 0x6C)
#define REG_SC_BK5F_6C_H      _PK_H_(0x5F, 0x6C)
#define REG_SC_BK5F_6D_L      _PK_L_(0x5F, 0x6D)
#define REG_SC_BK5F_6D_H      _PK_H_(0x5F, 0x6D)
#define REG_SC_BK5F_6E_L      _PK_L_(0x5F, 0x6E)
#define REG_SC_BK5F_6E_H      _PK_H_(0x5F, 0x6E)
#define REG_SC_BK5F_6F_L      _PK_L_(0x5F, 0x6F)
#define REG_SC_BK5F_6F_H      _PK_H_(0x5F, 0x6F)
#define REG_SC_BK5F_70_L      _PK_L_(0x5F, 0x70)
#define REG_SC_BK5F_70_H      _PK_H_(0x5F, 0x70)
#define REG_SC_BK5F_71_L      _PK_L_(0x5F, 0x71)
#define REG_SC_BK5F_71_H      _PK_H_(0x5F, 0x71)
#define REG_SC_BK5F_72_L      _PK_L_(0x5F, 0x72)
#define REG_SC_BK5F_72_H      _PK_H_(0x5F, 0x72)
#define REG_SC_BK5F_73_L      _PK_L_(0x5F, 0x73)
#define REG_SC_BK5F_73_H      _PK_H_(0x5F, 0x73)
#define REG_SC_BK5F_74_L      _PK_L_(0x5F, 0x74)
#define REG_SC_BK5F_74_H      _PK_H_(0x5F, 0x74)
#define REG_SC_BK5F_75_L      _PK_L_(0x5F, 0x75)
#define REG_SC_BK5F_75_H      _PK_H_(0x5F, 0x75)
#define REG_SC_BK5F_76_L      _PK_L_(0x5F, 0x76)
#define REG_SC_BK5F_76_H      _PK_H_(0x5F, 0x76)
#define REG_SC_BK5F_77_L      _PK_L_(0x5F, 0x77)
#define REG_SC_BK5F_77_H      _PK_H_(0x5F, 0x77)
#define REG_SC_BK5F_78_L      _PK_L_(0x5F, 0x78)
#define REG_SC_BK5F_78_H      _PK_H_(0x5F, 0x78)
#define REG_SC_BK5F_79_L      _PK_L_(0x5F, 0x79)
#define REG_SC_BK5F_79_H      _PK_H_(0x5F, 0x79)
#define REG_SC_BK5F_7A_L      _PK_L_(0x5F, 0x7A)
#define REG_SC_BK5F_7A_H      _PK_H_(0x5F, 0x7A)
#define REG_SC_BK5F_7B_L      _PK_L_(0x5F, 0x7B)
#define REG_SC_BK5F_7B_H      _PK_H_(0x5F, 0x7B)
#define REG_SC_BK5F_7C_L      _PK_L_(0x5F, 0x7C)
#define REG_SC_BK5F_7C_H      _PK_H_(0x5F, 0x7C)
#define REG_SC_BK5F_7D_L      _PK_L_(0x5F, 0x7D)
#define REG_SC_BK5F_7D_H      _PK_H_(0x5F, 0x7D)
#define REG_SC_BK5F_7E_L      _PK_L_(0x5F, 0x7E)
#define REG_SC_BK5F_7E_H      _PK_H_(0x5F, 0x7E)
#define REG_SC_BK5F_7F_L      _PK_L_(0x5F, 0x7F)
#define REG_SC_BK5F_7F_H      _PK_H_(0x5F, 0x7F)
//----------------------------------------------
#define REG_SC_BK60_00_L      _PK_L_(0x60, 0x00)
#define REG_SC_BK60_00_H      _PK_H_(0x60, 0x00)
#define REG_SC_BK60_01_L      _PK_L_(0x60, 0x01)
#define REG_SC_BK60_01_H      _PK_H_(0x60, 0x01)
#define REG_SC_BK60_02_L      _PK_L_(0x60, 0x02)
#define REG_SC_BK60_02_H      _PK_H_(0x60, 0x02)
#define REG_SC_BK60_03_L      _PK_L_(0x60, 0x03)
#define REG_SC_BK60_03_H      _PK_H_(0x60, 0x03)
#define REG_SC_BK60_04_L      _PK_L_(0x60, 0x04)
#define REG_SC_BK60_04_H      _PK_H_(0x60, 0x04)
#define REG_SC_BK60_05_L      _PK_L_(0x60, 0x05)
#define REG_SC_BK60_05_H      _PK_H_(0x60, 0x05)
#define REG_SC_BK60_06_L      _PK_L_(0x60, 0x06)
#define REG_SC_BK60_06_H      _PK_H_(0x60, 0x06)
#define REG_SC_BK60_07_L      _PK_L_(0x60, 0x07)
#define REG_SC_BK60_07_H      _PK_H_(0x60, 0x07)
#define REG_SC_BK60_08_L      _PK_L_(0x60, 0x08)
#define REG_SC_BK60_08_H      _PK_H_(0x60, 0x08)
#define REG_SC_BK60_09_L      _PK_L_(0x60, 0x09)
#define REG_SC_BK60_09_H      _PK_H_(0x60, 0x09)
#define REG_SC_BK60_0A_L      _PK_L_(0x60, 0x0A)
#define REG_SC_BK60_0A_H      _PK_H_(0x60, 0x0A)
#define REG_SC_BK60_0B_L      _PK_L_(0x60, 0x0B)
#define REG_SC_BK60_0B_H      _PK_H_(0x60, 0x0B)
#define REG_SC_BK60_0C_L      _PK_L_(0x60, 0x0C)
#define REG_SC_BK60_0C_H      _PK_H_(0x60, 0x0C)
#define REG_SC_BK60_0D_L      _PK_L_(0x60, 0x0D)
#define REG_SC_BK60_0D_H      _PK_H_(0x60, 0x0D)
#define REG_SC_BK60_0E_L      _PK_L_(0x60, 0x0E)
#define REG_SC_BK60_0E_H      _PK_H_(0x60, 0x0E)
#define REG_SC_BK60_0F_L      _PK_L_(0x60, 0x0F)
#define REG_SC_BK60_0F_H      _PK_H_(0x60, 0x0F)
#define REG_SC_BK60_10_L      _PK_L_(0x60, 0x10)
#define REG_SC_BK60_10_H      _PK_H_(0x60, 0x10)
#define REG_SC_BK60_11_L      _PK_L_(0x60, 0x11)
#define REG_SC_BK60_11_H      _PK_H_(0x60, 0x11)
#define REG_SC_BK60_12_L      _PK_L_(0x60, 0x12)
#define REG_SC_BK60_12_H      _PK_H_(0x60, 0x12)
#define REG_SC_BK60_13_L      _PK_L_(0x60, 0x13)
#define REG_SC_BK60_13_H      _PK_H_(0x60, 0x13)
#define REG_SC_BK60_14_L      _PK_L_(0x60, 0x14)
#define REG_SC_BK60_14_H      _PK_H_(0x60, 0x14)
#define REG_SC_BK60_15_L      _PK_L_(0x60, 0x15)
#define REG_SC_BK60_15_H      _PK_H_(0x60, 0x15)
#define REG_SC_BK60_16_L      _PK_L_(0x60, 0x16)
#define REG_SC_BK60_16_H      _PK_H_(0x60, 0x16)
#define REG_SC_BK60_17_L      _PK_L_(0x60, 0x17)
#define REG_SC_BK60_17_H      _PK_H_(0x60, 0x17)
#define REG_SC_BK60_18_L      _PK_L_(0x60, 0x18)
#define REG_SC_BK60_18_H      _PK_H_(0x60, 0x18)
#define REG_SC_BK60_19_L      _PK_L_(0x60, 0x19)
#define REG_SC_BK60_19_H      _PK_H_(0x60, 0x19)
#define REG_SC_BK60_1A_L      _PK_L_(0x60, 0x1A)
#define REG_SC_BK60_1A_H      _PK_H_(0x60, 0x1A)
#define REG_SC_BK60_1B_L      _PK_L_(0x60, 0x1B)
#define REG_SC_BK60_1B_H      _PK_H_(0x60, 0x1B)
#define REG_SC_BK60_1C_L      _PK_L_(0x60, 0x1C)
#define REG_SC_BK60_1C_H      _PK_H_(0x60, 0x1C)
#define REG_SC_BK60_1D_L      _PK_L_(0x60, 0x1D)
#define REG_SC_BK60_1D_H      _PK_H_(0x60, 0x1D)
#define REG_SC_BK60_1E_L      _PK_L_(0x60, 0x1E)
#define REG_SC_BK60_1E_H      _PK_H_(0x60, 0x1E)
#define REG_SC_BK60_1F_L      _PK_L_(0x60, 0x1F)
#define REG_SC_BK60_1F_H      _PK_H_(0x60, 0x1F)
#define REG_SC_BK60_20_L      _PK_L_(0x60, 0x20)
#define REG_SC_BK60_20_H      _PK_H_(0x60, 0x20)
#define REG_SC_BK60_21_L      _PK_L_(0x60, 0x21)
#define REG_SC_BK60_21_H      _PK_H_(0x60, 0x21)
#define REG_SC_BK60_22_L      _PK_L_(0x60, 0x22)
#define REG_SC_BK60_22_H      _PK_H_(0x60, 0x22)
#define REG_SC_BK60_23_L      _PK_L_(0x60, 0x23)
#define REG_SC_BK60_23_H      _PK_H_(0x60, 0x23)
#define REG_SC_BK60_24_L      _PK_L_(0x60, 0x24)
#define REG_SC_BK60_24_H      _PK_H_(0x60, 0x24)
#define REG_SC_BK60_25_L      _PK_L_(0x60, 0x25)
#define REG_SC_BK60_25_H      _PK_H_(0x60, 0x25)
#define REG_SC_BK60_26_L      _PK_L_(0x60, 0x26)
#define REG_SC_BK60_26_H      _PK_H_(0x60, 0x26)
#define REG_SC_BK60_27_L      _PK_L_(0x60, 0x27)
#define REG_SC_BK60_27_H      _PK_H_(0x60, 0x27)
#define REG_SC_BK60_28_L      _PK_L_(0x60, 0x28)
#define REG_SC_BK60_28_H      _PK_H_(0x60, 0x28)
#define REG_SC_BK60_29_L      _PK_L_(0x60, 0x29)
#define REG_SC_BK60_29_H      _PK_H_(0x60, 0x29)
#define REG_SC_BK60_2A_L      _PK_L_(0x60, 0x2A)
#define REG_SC_BK60_2A_H      _PK_H_(0x60, 0x2A)
#define REG_SC_BK60_2B_L      _PK_L_(0x60, 0x2B)
#define REG_SC_BK60_2B_H      _PK_H_(0x60, 0x2B)
#define REG_SC_BK60_2C_L      _PK_L_(0x60, 0x2C)
#define REG_SC_BK60_2C_H      _PK_H_(0x60, 0x2C)
#define REG_SC_BK60_2D_L      _PK_L_(0x60, 0x2D)
#define REG_SC_BK60_2D_H      _PK_H_(0x60, 0x2D)
#define REG_SC_BK60_2E_L      _PK_L_(0x60, 0x2E)
#define REG_SC_BK60_2E_H      _PK_H_(0x60, 0x2E)
#define REG_SC_BK60_2F_L      _PK_L_(0x60, 0x2F)
#define REG_SC_BK60_2F_H      _PK_H_(0x60, 0x2F)
#define REG_SC_BK60_30_L      _PK_L_(0x60, 0x30)
#define REG_SC_BK60_30_H      _PK_H_(0x60, 0x30)
#define REG_SC_BK60_31_L      _PK_L_(0x60, 0x31)
#define REG_SC_BK60_31_H      _PK_H_(0x60, 0x31)
#define REG_SC_BK60_32_L      _PK_L_(0x60, 0x32)
#define REG_SC_BK60_32_H      _PK_H_(0x60, 0x32)
#define REG_SC_BK60_33_L      _PK_L_(0x60, 0x33)
#define REG_SC_BK60_33_H      _PK_H_(0x60, 0x33)
#define REG_SC_BK60_34_L      _PK_L_(0x60, 0x34)
#define REG_SC_BK60_34_H      _PK_H_(0x60, 0x34)
#define REG_SC_BK60_35_L      _PK_L_(0x60, 0x35)
#define REG_SC_BK60_35_H      _PK_H_(0x60, 0x35)
#define REG_SC_BK60_36_L      _PK_L_(0x60, 0x36)
#define REG_SC_BK60_36_H      _PK_H_(0x60, 0x36)
#define REG_SC_BK60_37_L      _PK_L_(0x60, 0x37)
#define REG_SC_BK60_37_H      _PK_H_(0x60, 0x37)
#define REG_SC_BK60_38_L      _PK_L_(0x60, 0x38)
#define REG_SC_BK60_38_H      _PK_H_(0x60, 0x38)
#define REG_SC_BK60_39_L      _PK_L_(0x60, 0x39)
#define REG_SC_BK60_39_H      _PK_H_(0x60, 0x39)
#define REG_SC_BK60_3A_L      _PK_L_(0x60, 0x3A)
#define REG_SC_BK60_3A_H      _PK_H_(0x60, 0x3A)
#define REG_SC_BK60_3B_L      _PK_L_(0x60, 0x3B)
#define REG_SC_BK60_3B_H      _PK_H_(0x60, 0x3B)
#define REG_SC_BK60_3C_L      _PK_L_(0x60, 0x3C)
#define REG_SC_BK60_3C_H      _PK_H_(0x60, 0x3C)
#define REG_SC_BK60_3D_L      _PK_L_(0x60, 0x3D)
#define REG_SC_BK60_3D_H      _PK_H_(0x60, 0x3D)
#define REG_SC_BK60_3E_L      _PK_L_(0x60, 0x3E)
#define REG_SC_BK60_3E_H      _PK_H_(0x60, 0x3E)
#define REG_SC_BK60_3F_L      _PK_L_(0x60, 0x3F)
#define REG_SC_BK60_3F_H      _PK_H_(0x60, 0x3F)
#define REG_SC_BK60_40_L      _PK_L_(0x60, 0x40)
#define REG_SC_BK60_40_H      _PK_H_(0x60, 0x40)
#define REG_SC_BK60_41_L      _PK_L_(0x60, 0x41)
#define REG_SC_BK60_41_H      _PK_H_(0x60, 0x41)
#define REG_SC_BK60_42_L      _PK_L_(0x60, 0x42)
#define REG_SC_BK60_42_H      _PK_H_(0x60, 0x42)
#define REG_SC_BK60_43_L      _PK_L_(0x60, 0x43)
#define REG_SC_BK60_43_H      _PK_H_(0x60, 0x43)
#define REG_SC_BK60_44_L      _PK_L_(0x60, 0x44)
#define REG_SC_BK60_44_H      _PK_H_(0x60, 0x44)
#define REG_SC_BK60_45_L      _PK_L_(0x60, 0x45)
#define REG_SC_BK60_45_H      _PK_H_(0x60, 0x45)
#define REG_SC_BK60_46_L      _PK_L_(0x60, 0x46)
#define REG_SC_BK60_46_H      _PK_H_(0x60, 0x46)
#define REG_SC_BK60_47_L      _PK_L_(0x60, 0x47)
#define REG_SC_BK60_47_H      _PK_H_(0x60, 0x47)
#define REG_SC_BK60_48_L      _PK_L_(0x60, 0x48)
#define REG_SC_BK60_48_H      _PK_H_(0x60, 0x48)
#define REG_SC_BK60_49_L      _PK_L_(0x60, 0x49)
#define REG_SC_BK60_49_H      _PK_H_(0x60, 0x49)
#define REG_SC_BK60_4A_L      _PK_L_(0x60, 0x4A)
#define REG_SC_BK60_4A_H      _PK_H_(0x60, 0x4A)
#define REG_SC_BK60_4B_L      _PK_L_(0x60, 0x4B)
#define REG_SC_BK60_4B_H      _PK_H_(0x60, 0x4B)
#define REG_SC_BK60_4C_L      _PK_L_(0x60, 0x4C)
#define REG_SC_BK60_4C_H      _PK_H_(0x60, 0x4C)
#define REG_SC_BK60_4D_L      _PK_L_(0x60, 0x4D)
#define REG_SC_BK60_4D_H      _PK_H_(0x60, 0x4D)
#define REG_SC_BK60_4E_L      _PK_L_(0x60, 0x4E)
#define REG_SC_BK60_4E_H      _PK_H_(0x60, 0x4E)
#define REG_SC_BK60_4F_L      _PK_L_(0x60, 0x4F)
#define REG_SC_BK60_4F_H      _PK_H_(0x60, 0x4F)
#define REG_SC_BK60_50_L      _PK_L_(0x60, 0x50)
#define REG_SC_BK60_50_H      _PK_H_(0x60, 0x50)
#define REG_SC_BK60_51_L      _PK_L_(0x60, 0x51)
#define REG_SC_BK60_51_H      _PK_H_(0x60, 0x51)
#define REG_SC_BK60_52_L      _PK_L_(0x60, 0x52)
#define REG_SC_BK60_52_H      _PK_H_(0x60, 0x52)
#define REG_SC_BK60_53_L      _PK_L_(0x60, 0x53)
#define REG_SC_BK60_53_H      _PK_H_(0x60, 0x53)
#define REG_SC_BK60_54_L      _PK_L_(0x60, 0x54)
#define REG_SC_BK60_54_H      _PK_H_(0x60, 0x54)
#define REG_SC_BK60_55_L      _PK_L_(0x60, 0x55)
#define REG_SC_BK60_55_H      _PK_H_(0x60, 0x55)
#define REG_SC_BK60_56_L      _PK_L_(0x60, 0x56)
#define REG_SC_BK60_56_H      _PK_H_(0x60, 0x56)
#define REG_SC_BK60_57_L      _PK_L_(0x60, 0x57)
#define REG_SC_BK60_57_H      _PK_H_(0x60, 0x57)
#define REG_SC_BK60_58_L      _PK_L_(0x60, 0x58)
#define REG_SC_BK60_58_H      _PK_H_(0x60, 0x58)
#define REG_SC_BK60_59_L      _PK_L_(0x60, 0x59)
#define REG_SC_BK60_59_H      _PK_H_(0x60, 0x59)
#define REG_SC_BK60_5A_L      _PK_L_(0x60, 0x5A)
#define REG_SC_BK60_5A_H      _PK_H_(0x60, 0x5A)
#define REG_SC_BK60_5B_L      _PK_L_(0x60, 0x5B)
#define REG_SC_BK60_5B_H      _PK_H_(0x60, 0x5B)
#define REG_SC_BK60_5C_L      _PK_L_(0x60, 0x5C)
#define REG_SC_BK60_5C_H      _PK_H_(0x60, 0x5C)
#define REG_SC_BK60_5D_L      _PK_L_(0x60, 0x5D)
#define REG_SC_BK60_5D_H      _PK_H_(0x60, 0x5D)
#define REG_SC_BK60_5E_L      _PK_L_(0x60, 0x5E)
#define REG_SC_BK60_5E_H      _PK_H_(0x60, 0x5E)
#define REG_SC_BK60_5F_L      _PK_L_(0x60, 0x5F)
#define REG_SC_BK60_5F_H      _PK_H_(0x60, 0x5F)
#define REG_SC_BK60_60_L      _PK_L_(0x60, 0x60)
#define REG_SC_BK60_60_H      _PK_H_(0x60, 0x60)
#define REG_SC_BK60_61_L      _PK_L_(0x60, 0x61)
#define REG_SC_BK60_61_H      _PK_H_(0x60, 0x61)
#define REG_SC_BK60_62_L      _PK_L_(0x60, 0x62)
#define REG_SC_BK60_62_H      _PK_H_(0x60, 0x62)
#define REG_SC_BK60_63_L      _PK_L_(0x60, 0x63)
#define REG_SC_BK60_63_H      _PK_H_(0x60, 0x63)
#define REG_SC_BK60_64_L      _PK_L_(0x60, 0x64)
#define REG_SC_BK60_64_H      _PK_H_(0x60, 0x64)
#define REG_SC_BK60_65_L      _PK_L_(0x60, 0x65)
#define REG_SC_BK60_65_H      _PK_H_(0x60, 0x65)
#define REG_SC_BK60_66_L      _PK_L_(0x60, 0x66)
#define REG_SC_BK60_66_H      _PK_H_(0x60, 0x66)
#define REG_SC_BK60_67_L      _PK_L_(0x60, 0x67)
#define REG_SC_BK60_67_H      _PK_H_(0x60, 0x67)
#define REG_SC_BK60_68_L      _PK_L_(0x60, 0x68)
#define REG_SC_BK60_68_H      _PK_H_(0x60, 0x68)
#define REG_SC_BK60_69_L      _PK_L_(0x60, 0x69)
#define REG_SC_BK60_69_H      _PK_H_(0x60, 0x69)
#define REG_SC_BK60_6A_L      _PK_L_(0x60, 0x6A)
#define REG_SC_BK60_6A_H      _PK_H_(0x60, 0x6A)
#define REG_SC_BK60_6B_L      _PK_L_(0x60, 0x6B)
#define REG_SC_BK60_6B_H      _PK_H_(0x60, 0x6B)
#define REG_SC_BK60_6C_L      _PK_L_(0x60, 0x6C)
#define REG_SC_BK60_6C_H      _PK_H_(0x60, 0x6C)
#define REG_SC_BK60_6D_L      _PK_L_(0x60, 0x6D)
#define REG_SC_BK60_6D_H      _PK_H_(0x60, 0x6D)
#define REG_SC_BK60_6E_L      _PK_L_(0x60, 0x6E)
#define REG_SC_BK60_6E_H      _PK_H_(0x60, 0x6E)
#define REG_SC_BK60_6F_L      _PK_L_(0x60, 0x6F)
#define REG_SC_BK60_6F_H      _PK_H_(0x60, 0x6F)
#define REG_SC_BK60_70_L      _PK_L_(0x60, 0x70)
#define REG_SC_BK60_70_H      _PK_H_(0x60, 0x70)
#define REG_SC_BK60_71_L      _PK_L_(0x60, 0x71)
#define REG_SC_BK60_71_H      _PK_H_(0x60, 0x71)
#define REG_SC_BK60_72_L      _PK_L_(0x60, 0x72)
#define REG_SC_BK60_72_H      _PK_H_(0x60, 0x72)
#define REG_SC_BK60_73_L      _PK_L_(0x60, 0x73)
#define REG_SC_BK60_73_H      _PK_H_(0x60, 0x73)
#define REG_SC_BK60_74_L      _PK_L_(0x60, 0x74)
#define REG_SC_BK60_74_H      _PK_H_(0x60, 0x74)
#define REG_SC_BK60_75_L      _PK_L_(0x60, 0x75)
#define REG_SC_BK60_75_H      _PK_H_(0x60, 0x75)
#define REG_SC_BK60_76_L      _PK_L_(0x60, 0x76)
#define REG_SC_BK60_76_H      _PK_H_(0x60, 0x76)
#define REG_SC_BK60_77_L      _PK_L_(0x60, 0x77)
#define REG_SC_BK60_77_H      _PK_H_(0x60, 0x77)
#define REG_SC_BK60_78_L      _PK_L_(0x60, 0x78)
#define REG_SC_BK60_78_H      _PK_H_(0x60, 0x78)
#define REG_SC_BK60_79_L      _PK_L_(0x60, 0x79)
#define REG_SC_BK60_79_H      _PK_H_(0x60, 0x79)
#define REG_SC_BK60_7A_L      _PK_L_(0x60, 0x7A)
#define REG_SC_BK60_7A_H      _PK_H_(0x60, 0x7A)
#define REG_SC_BK60_7B_L      _PK_L_(0x60, 0x7B)
#define REG_SC_BK60_7B_H      _PK_H_(0x60, 0x7B)
#define REG_SC_BK60_7C_L      _PK_L_(0x60, 0x7C)
#define REG_SC_BK60_7C_H      _PK_H_(0x60, 0x7C)
#define REG_SC_BK60_7D_L      _PK_L_(0x60, 0x7D)
#define REG_SC_BK60_7D_H      _PK_H_(0x60, 0x7D)
#define REG_SC_BK60_7E_L      _PK_L_(0x60, 0x7E)
#define REG_SC_BK60_7E_H      _PK_H_(0x60, 0x7E)
#define REG_SC_BK60_7F_L      _PK_L_(0x60, 0x7F)
#define REG_SC_BK60_7F_H      _PK_H_(0x60, 0x7F)
//----------------------------------------------
#define REG_SC_BK61_00_L      _PK_L_(0x61, 0x00)
#define REG_SC_BK61_00_H      _PK_H_(0x61, 0x00)
#define REG_SC_BK61_01_L      _PK_L_(0x61, 0x01)
#define REG_SC_BK61_01_H      _PK_H_(0x61, 0x01)
#define REG_SC_BK61_02_L      _PK_L_(0x61, 0x02)
#define REG_SC_BK61_02_H      _PK_H_(0x61, 0x02)
#define REG_SC_BK61_03_L      _PK_L_(0x61, 0x03)
#define REG_SC_BK61_03_H      _PK_H_(0x61, 0x03)
#define REG_SC_BK61_04_L      _PK_L_(0x61, 0x04)
#define REG_SC_BK61_04_H      _PK_H_(0x61, 0x04)
#define REG_SC_BK61_05_L      _PK_L_(0x61, 0x05)
#define REG_SC_BK61_05_H      _PK_H_(0x61, 0x05)
#define REG_SC_BK61_06_L      _PK_L_(0x61, 0x06)
#define REG_SC_BK61_06_H      _PK_H_(0x61, 0x06)
#define REG_SC_BK61_07_L      _PK_L_(0x61, 0x07)
#define REG_SC_BK61_07_H      _PK_H_(0x61, 0x07)
#define REG_SC_BK61_08_L      _PK_L_(0x61, 0x08)
#define REG_SC_BK61_08_H      _PK_H_(0x61, 0x08)
#define REG_SC_BK61_09_L      _PK_L_(0x61, 0x09)
#define REG_SC_BK61_09_H      _PK_H_(0x61, 0x09)
#define REG_SC_BK61_0A_L      _PK_L_(0x61, 0x0A)
#define REG_SC_BK61_0A_H      _PK_H_(0x61, 0x0A)
#define REG_SC_BK61_0B_L      _PK_L_(0x61, 0x0B)
#define REG_SC_BK61_0B_H      _PK_H_(0x61, 0x0B)
#define REG_SC_BK61_0C_L      _PK_L_(0x61, 0x0C)
#define REG_SC_BK61_0C_H      _PK_H_(0x61, 0x0C)
#define REG_SC_BK61_0D_L      _PK_L_(0x61, 0x0D)
#define REG_SC_BK61_0D_H      _PK_H_(0x61, 0x0D)
#define REG_SC_BK61_0E_L      _PK_L_(0x61, 0x0E)
#define REG_SC_BK61_0E_H      _PK_H_(0x61, 0x0E)
#define REG_SC_BK61_0F_L      _PK_L_(0x61, 0x0F)
#define REG_SC_BK61_0F_H      _PK_H_(0x61, 0x0F)
#define REG_SC_BK61_10_L      _PK_L_(0x61, 0x10)
#define REG_SC_BK61_10_H      _PK_H_(0x61, 0x10)
#define REG_SC_BK61_11_L      _PK_L_(0x61, 0x11)
#define REG_SC_BK61_11_H      _PK_H_(0x61, 0x11)
#define REG_SC_BK61_12_L      _PK_L_(0x61, 0x12)
#define REG_SC_BK61_12_H      _PK_H_(0x61, 0x12)
#define REG_SC_BK61_13_L      _PK_L_(0x61, 0x13)
#define REG_SC_BK61_13_H      _PK_H_(0x61, 0x13)
#define REG_SC_BK61_14_L      _PK_L_(0x61, 0x14)
#define REG_SC_BK61_14_H      _PK_H_(0x61, 0x14)
#define REG_SC_BK61_15_L      _PK_L_(0x61, 0x15)
#define REG_SC_BK61_15_H      _PK_H_(0x61, 0x15)
#define REG_SC_BK61_16_L      _PK_L_(0x61, 0x16)
#define REG_SC_BK61_16_H      _PK_H_(0x61, 0x16)
#define REG_SC_BK61_17_L      _PK_L_(0x61, 0x17)
#define REG_SC_BK61_17_H      _PK_H_(0x61, 0x17)
#define REG_SC_BK61_18_L      _PK_L_(0x61, 0x18)
#define REG_SC_BK61_18_H      _PK_H_(0x61, 0x18)
#define REG_SC_BK61_19_L      _PK_L_(0x61, 0x19)
#define REG_SC_BK61_19_H      _PK_H_(0x61, 0x19)
#define REG_SC_BK61_1A_L      _PK_L_(0x61, 0x1A)
#define REG_SC_BK61_1A_H      _PK_H_(0x61, 0x1A)
#define REG_SC_BK61_1B_L      _PK_L_(0x61, 0x1B)
#define REG_SC_BK61_1B_H      _PK_H_(0x61, 0x1B)
#define REG_SC_BK61_1C_L      _PK_L_(0x61, 0x1C)
#define REG_SC_BK61_1C_H      _PK_H_(0x61, 0x1C)
#define REG_SC_BK61_1D_L      _PK_L_(0x61, 0x1D)
#define REG_SC_BK61_1D_H      _PK_H_(0x61, 0x1D)
#define REG_SC_BK61_1E_L      _PK_L_(0x61, 0x1E)
#define REG_SC_BK61_1E_H      _PK_H_(0x61, 0x1E)
#define REG_SC_BK61_1F_L      _PK_L_(0x61, 0x1F)
#define REG_SC_BK61_1F_H      _PK_H_(0x61, 0x1F)
#define REG_SC_BK61_20_L      _PK_L_(0x61, 0x20)
#define REG_SC_BK61_20_H      _PK_H_(0x61, 0x20)
#define REG_SC_BK61_21_L      _PK_L_(0x61, 0x21)
#define REG_SC_BK61_21_H      _PK_H_(0x61, 0x21)
#define REG_SC_BK61_22_L      _PK_L_(0x61, 0x22)
#define REG_SC_BK61_22_H      _PK_H_(0x61, 0x22)
#define REG_SC_BK61_23_L      _PK_L_(0x61, 0x23)
#define REG_SC_BK61_23_H      _PK_H_(0x61, 0x23)
#define REG_SC_BK61_24_L      _PK_L_(0x61, 0x24)
#define REG_SC_BK61_24_H      _PK_H_(0x61, 0x24)
#define REG_SC_BK61_25_L      _PK_L_(0x61, 0x25)
#define REG_SC_BK61_25_H      _PK_H_(0x61, 0x25)
#define REG_SC_BK61_26_L      _PK_L_(0x61, 0x26)
#define REG_SC_BK61_26_H      _PK_H_(0x61, 0x26)
#define REG_SC_BK61_27_L      _PK_L_(0x61, 0x27)
#define REG_SC_BK61_27_H      _PK_H_(0x61, 0x27)
#define REG_SC_BK61_28_L      _PK_L_(0x61, 0x28)
#define REG_SC_BK61_28_H      _PK_H_(0x61, 0x28)
#define REG_SC_BK61_29_L      _PK_L_(0x61, 0x29)
#define REG_SC_BK61_29_H      _PK_H_(0x61, 0x29)
#define REG_SC_BK61_2A_L      _PK_L_(0x61, 0x2A)
#define REG_SC_BK61_2A_H      _PK_H_(0x61, 0x2A)
#define REG_SC_BK61_2B_L      _PK_L_(0x61, 0x2B)
#define REG_SC_BK61_2B_H      _PK_H_(0x61, 0x2B)
#define REG_SC_BK61_2C_L      _PK_L_(0x61, 0x2C)
#define REG_SC_BK61_2C_H      _PK_H_(0x61, 0x2C)
#define REG_SC_BK61_2D_L      _PK_L_(0x61, 0x2D)
#define REG_SC_BK61_2D_H      _PK_H_(0x61, 0x2D)
#define REG_SC_BK61_2E_L      _PK_L_(0x61, 0x2E)
#define REG_SC_BK61_2E_H      _PK_H_(0x61, 0x2E)
#define REG_SC_BK61_2F_L      _PK_L_(0x61, 0x2F)
#define REG_SC_BK61_2F_H      _PK_H_(0x61, 0x2F)
#define REG_SC_BK61_30_L      _PK_L_(0x61, 0x30)
#define REG_SC_BK61_30_H      _PK_H_(0x61, 0x30)
#define REG_SC_BK61_31_L      _PK_L_(0x61, 0x31)
#define REG_SC_BK61_31_H      _PK_H_(0x61, 0x31)
#define REG_SC_BK61_32_L      _PK_L_(0x61, 0x32)
#define REG_SC_BK61_32_H      _PK_H_(0x61, 0x32)
#define REG_SC_BK61_33_L      _PK_L_(0x61, 0x33)
#define REG_SC_BK61_33_H      _PK_H_(0x61, 0x33)
#define REG_SC_BK61_34_L      _PK_L_(0x61, 0x34)
#define REG_SC_BK61_34_H      _PK_H_(0x61, 0x34)
#define REG_SC_BK61_35_L      _PK_L_(0x61, 0x35)
#define REG_SC_BK61_35_H      _PK_H_(0x61, 0x35)
#define REG_SC_BK61_36_L      _PK_L_(0x61, 0x36)
#define REG_SC_BK61_36_H      _PK_H_(0x61, 0x36)
#define REG_SC_BK61_37_L      _PK_L_(0x61, 0x37)
#define REG_SC_BK61_37_H      _PK_H_(0x61, 0x37)
#define REG_SC_BK61_38_L      _PK_L_(0x61, 0x38)
#define REG_SC_BK61_38_H      _PK_H_(0x61, 0x38)
#define REG_SC_BK61_39_L      _PK_L_(0x61, 0x39)
#define REG_SC_BK61_39_H      _PK_H_(0x61, 0x39)
#define REG_SC_BK61_3A_L      _PK_L_(0x61, 0x3A)
#define REG_SC_BK61_3A_H      _PK_H_(0x61, 0x3A)
#define REG_SC_BK61_3B_L      _PK_L_(0x61, 0x3B)
#define REG_SC_BK61_3B_H      _PK_H_(0x61, 0x3B)
#define REG_SC_BK61_3C_L      _PK_L_(0x61, 0x3C)
#define REG_SC_BK61_3C_H      _PK_H_(0x61, 0x3C)
#define REG_SC_BK61_3D_L      _PK_L_(0x61, 0x3D)
#define REG_SC_BK61_3D_H      _PK_H_(0x61, 0x3D)
#define REG_SC_BK61_3E_L      _PK_L_(0x61, 0x3E)
#define REG_SC_BK61_3E_H      _PK_H_(0x61, 0x3E)
#define REG_SC_BK61_3F_L      _PK_L_(0x61, 0x3F)
#define REG_SC_BK61_3F_H      _PK_H_(0x61, 0x3F)
#define REG_SC_BK61_40_L      _PK_L_(0x61, 0x40)
#define REG_SC_BK61_40_H      _PK_H_(0x61, 0x40)
#define REG_SC_BK61_41_L      _PK_L_(0x61, 0x41)
#define REG_SC_BK61_41_H      _PK_H_(0x61, 0x41)
#define REG_SC_BK61_42_L      _PK_L_(0x61, 0x42)
#define REG_SC_BK61_42_H      _PK_H_(0x61, 0x42)
#define REG_SC_BK61_43_L      _PK_L_(0x61, 0x43)
#define REG_SC_BK61_43_H      _PK_H_(0x61, 0x43)
#define REG_SC_BK61_44_L      _PK_L_(0x61, 0x44)
#define REG_SC_BK61_44_H      _PK_H_(0x61, 0x44)
#define REG_SC_BK61_45_L      _PK_L_(0x61, 0x45)
#define REG_SC_BK61_45_H      _PK_H_(0x61, 0x45)
#define REG_SC_BK61_46_L      _PK_L_(0x61, 0x46)
#define REG_SC_BK61_46_H      _PK_H_(0x61, 0x46)
#define REG_SC_BK61_47_L      _PK_L_(0x61, 0x47)
#define REG_SC_BK61_47_H      _PK_H_(0x61, 0x47)
#define REG_SC_BK61_48_L      _PK_L_(0x61, 0x48)
#define REG_SC_BK61_48_H      _PK_H_(0x61, 0x48)
#define REG_SC_BK61_49_L      _PK_L_(0x61, 0x49)
#define REG_SC_BK61_49_H      _PK_H_(0x61, 0x49)
#define REG_SC_BK61_4A_L      _PK_L_(0x61, 0x4A)
#define REG_SC_BK61_4A_H      _PK_H_(0x61, 0x4A)
#define REG_SC_BK61_4B_L      _PK_L_(0x61, 0x4B)
#define REG_SC_BK61_4B_H      _PK_H_(0x61, 0x4B)
#define REG_SC_BK61_4C_L      _PK_L_(0x61, 0x4C)
#define REG_SC_BK61_4C_H      _PK_H_(0x61, 0x4C)
#define REG_SC_BK61_4D_L      _PK_L_(0x61, 0x4D)
#define REG_SC_BK61_4D_H      _PK_H_(0x61, 0x4D)
#define REG_SC_BK61_4E_L      _PK_L_(0x61, 0x4E)
#define REG_SC_BK61_4E_H      _PK_H_(0x61, 0x4E)
#define REG_SC_BK61_4F_L      _PK_L_(0x61, 0x4F)
#define REG_SC_BK61_4F_H      _PK_H_(0x61, 0x4F)
#define REG_SC_BK61_50_L      _PK_L_(0x61, 0x50)
#define REG_SC_BK61_50_H      _PK_H_(0x61, 0x50)
#define REG_SC_BK61_51_L      _PK_L_(0x61, 0x51)
#define REG_SC_BK61_51_H      _PK_H_(0x61, 0x51)
#define REG_SC_BK61_52_L      _PK_L_(0x61, 0x52)
#define REG_SC_BK61_52_H      _PK_H_(0x61, 0x52)
#define REG_SC_BK61_53_L      _PK_L_(0x61, 0x53)
#define REG_SC_BK61_53_H      _PK_H_(0x61, 0x53)
#define REG_SC_BK61_54_L      _PK_L_(0x61, 0x54)
#define REG_SC_BK61_54_H      _PK_H_(0x61, 0x54)
#define REG_SC_BK61_55_L      _PK_L_(0x61, 0x55)
#define REG_SC_BK61_55_H      _PK_H_(0x61, 0x55)
#define REG_SC_BK61_56_L      _PK_L_(0x61, 0x56)
#define REG_SC_BK61_56_H      _PK_H_(0x61, 0x56)
#define REG_SC_BK61_57_L      _PK_L_(0x61, 0x57)
#define REG_SC_BK61_57_H      _PK_H_(0x61, 0x57)
#define REG_SC_BK61_58_L      _PK_L_(0x61, 0x58)
#define REG_SC_BK61_58_H      _PK_H_(0x61, 0x58)
#define REG_SC_BK61_59_L      _PK_L_(0x61, 0x59)
#define REG_SC_BK61_59_H      _PK_H_(0x61, 0x59)
#define REG_SC_BK61_5A_L      _PK_L_(0x61, 0x5A)
#define REG_SC_BK61_5A_H      _PK_H_(0x61, 0x5A)
#define REG_SC_BK61_5B_L      _PK_L_(0x61, 0x5B)
#define REG_SC_BK61_5B_H      _PK_H_(0x61, 0x5B)
#define REG_SC_BK61_5C_L      _PK_L_(0x61, 0x5C)
#define REG_SC_BK61_5C_H      _PK_H_(0x61, 0x5C)
#define REG_SC_BK61_5D_L      _PK_L_(0x61, 0x5D)
#define REG_SC_BK61_5D_H      _PK_H_(0x61, 0x5D)
#define REG_SC_BK61_5E_L      _PK_L_(0x61, 0x5E)
#define REG_SC_BK61_5E_H      _PK_H_(0x61, 0x5E)
#define REG_SC_BK61_5F_L      _PK_L_(0x61, 0x5F)
#define REG_SC_BK61_5F_H      _PK_H_(0x61, 0x5F)
#define REG_SC_BK61_60_L      _PK_L_(0x61, 0x60)
#define REG_SC_BK61_60_H      _PK_H_(0x61, 0x60)
#define REG_SC_BK61_61_L      _PK_L_(0x61, 0x61)
#define REG_SC_BK61_61_H      _PK_H_(0x61, 0x61)
#define REG_SC_BK61_62_L      _PK_L_(0x61, 0x62)
#define REG_SC_BK61_62_H      _PK_H_(0x61, 0x62)
#define REG_SC_BK61_63_L      _PK_L_(0x61, 0x63)
#define REG_SC_BK61_63_H      _PK_H_(0x61, 0x63)
#define REG_SC_BK61_64_L      _PK_L_(0x61, 0x64)
#define REG_SC_BK61_64_H      _PK_H_(0x61, 0x64)
#define REG_SC_BK61_65_L      _PK_L_(0x61, 0x65)
#define REG_SC_BK61_65_H      _PK_H_(0x61, 0x65)
#define REG_SC_BK61_66_L      _PK_L_(0x61, 0x66)
#define REG_SC_BK61_66_H      _PK_H_(0x61, 0x66)
#define REG_SC_BK61_67_L      _PK_L_(0x61, 0x67)
#define REG_SC_BK61_67_H      _PK_H_(0x61, 0x67)
#define REG_SC_BK61_68_L      _PK_L_(0x61, 0x68)
#define REG_SC_BK61_68_H      _PK_H_(0x61, 0x68)
#define REG_SC_BK61_69_L      _PK_L_(0x61, 0x69)
#define REG_SC_BK61_69_H      _PK_H_(0x61, 0x69)
#define REG_SC_BK61_6A_L      _PK_L_(0x61, 0x6A)
#define REG_SC_BK61_6A_H      _PK_H_(0x61, 0x6A)
#define REG_SC_BK61_6B_L      _PK_L_(0x61, 0x6B)
#define REG_SC_BK61_6B_H      _PK_H_(0x61, 0x6B)
#define REG_SC_BK61_6C_L      _PK_L_(0x61, 0x6C)
#define REG_SC_BK61_6C_H      _PK_H_(0x61, 0x6C)
#define REG_SC_BK61_6D_L      _PK_L_(0x61, 0x6D)
#define REG_SC_BK61_6D_H      _PK_H_(0x61, 0x6D)
#define REG_SC_BK61_6E_L      _PK_L_(0x61, 0x6E)
#define REG_SC_BK61_6E_H      _PK_H_(0x61, 0x6E)
#define REG_SC_BK61_6F_L      _PK_L_(0x61, 0x6F)
#define REG_SC_BK61_6F_H      _PK_H_(0x61, 0x6F)
#define REG_SC_BK61_70_L      _PK_L_(0x61, 0x70)
#define REG_SC_BK61_70_H      _PK_H_(0x61, 0x70)
#define REG_SC_BK61_71_L      _PK_L_(0x61, 0x71)
#define REG_SC_BK61_71_H      _PK_H_(0x61, 0x71)
#define REG_SC_BK61_72_L      _PK_L_(0x61, 0x72)
#define REG_SC_BK61_72_H      _PK_H_(0x61, 0x72)
#define REG_SC_BK61_73_L      _PK_L_(0x61, 0x73)
#define REG_SC_BK61_73_H      _PK_H_(0x61, 0x73)
#define REG_SC_BK61_74_L      _PK_L_(0x61, 0x74)
#define REG_SC_BK61_74_H      _PK_H_(0x61, 0x74)
#define REG_SC_BK61_75_L      _PK_L_(0x61, 0x75)
#define REG_SC_BK61_75_H      _PK_H_(0x61, 0x75)
#define REG_SC_BK61_76_L      _PK_L_(0x61, 0x76)
#define REG_SC_BK61_76_H      _PK_H_(0x61, 0x76)
#define REG_SC_BK61_77_L      _PK_L_(0x61, 0x77)
#define REG_SC_BK61_77_H      _PK_H_(0x61, 0x77)
#define REG_SC_BK61_78_L      _PK_L_(0x61, 0x78)
#define REG_SC_BK61_78_H      _PK_H_(0x61, 0x78)
#define REG_SC_BK61_79_L      _PK_L_(0x61, 0x79)
#define REG_SC_BK61_79_H      _PK_H_(0x61, 0x79)
#define REG_SC_BK61_7A_L      _PK_L_(0x61, 0x7A)
#define REG_SC_BK61_7A_H      _PK_H_(0x61, 0x7A)
#define REG_SC_BK61_7B_L      _PK_L_(0x61, 0x7B)
#define REG_SC_BK61_7B_H      _PK_H_(0x61, 0x7B)
#define REG_SC_BK61_7C_L      _PK_L_(0x61, 0x7C)
#define REG_SC_BK61_7C_H      _PK_H_(0x61, 0x7C)
#define REG_SC_BK61_7D_L      _PK_L_(0x61, 0x7D)
#define REG_SC_BK61_7D_H      _PK_H_(0x61, 0x7D)
#define REG_SC_BK61_7E_L      _PK_L_(0x61, 0x7E)
#define REG_SC_BK61_7E_H      _PK_H_(0x61, 0x7E)
#define REG_SC_BK61_7F_L      _PK_L_(0x61, 0x7F)
#define REG_SC_BK61_7F_H      _PK_H_(0x61, 0x7F)
//----------------------------------------------
#define REG_SC_BK67_00_L      _PK_L_(0x67, 0x00)
#define REG_SC_BK67_00_H      _PK_H_(0x67, 0x00)
#define REG_SC_BK67_01_L      _PK_L_(0x67, 0x01)
#define REG_SC_BK67_01_H      _PK_H_(0x67, 0x01)
#define REG_SC_BK67_02_L      _PK_L_(0x67, 0x02)
#define REG_SC_BK67_02_H      _PK_H_(0x67, 0x02)
#define REG_SC_BK67_03_L      _PK_L_(0x67, 0x03)
#define REG_SC_BK67_03_H      _PK_H_(0x67, 0x03)
#define REG_SC_BK67_04_L      _PK_L_(0x67, 0x04)
#define REG_SC_BK67_04_H      _PK_H_(0x67, 0x04)
#define REG_SC_BK67_05_L      _PK_L_(0x67, 0x05)
#define REG_SC_BK67_05_H      _PK_H_(0x67, 0x05)
#define REG_SC_BK67_06_L      _PK_L_(0x67, 0x06)
#define REG_SC_BK67_06_H      _PK_H_(0x67, 0x06)
#define REG_SC_BK67_07_L      _PK_L_(0x67, 0x07)
#define REG_SC_BK67_07_H      _PK_H_(0x67, 0x07)
#define REG_SC_BK67_08_L      _PK_L_(0x67, 0x08)
#define REG_SC_BK67_08_H      _PK_H_(0x67, 0x08)
#define REG_SC_BK67_09_L      _PK_L_(0x67, 0x09)
#define REG_SC_BK67_09_H      _PK_H_(0x67, 0x09)
#define REG_SC_BK67_0A_L      _PK_L_(0x67, 0x0A)
#define REG_SC_BK67_0A_H      _PK_H_(0x67, 0x0A)
#define REG_SC_BK67_0B_L      _PK_L_(0x67, 0x0B)
#define REG_SC_BK67_0B_H      _PK_H_(0x67, 0x0B)
#define REG_SC_BK67_0C_L      _PK_L_(0x67, 0x0C)
#define REG_SC_BK67_0C_H      _PK_H_(0x67, 0x0C)
#define REG_SC_BK67_0D_L      _PK_L_(0x67, 0x0D)
#define REG_SC_BK67_0D_H      _PK_H_(0x67, 0x0D)
#define REG_SC_BK67_0E_L      _PK_L_(0x67, 0x0E)
#define REG_SC_BK67_0E_H      _PK_H_(0x67, 0x0E)
#define REG_SC_BK67_0F_L      _PK_L_(0x67, 0x0F)
#define REG_SC_BK67_0F_H      _PK_H_(0x67, 0x0F)
#define REG_SC_BK67_10_L      _PK_L_(0x67, 0x10)
#define REG_SC_BK67_10_H      _PK_H_(0x67, 0x10)
#define REG_SC_BK67_11_L      _PK_L_(0x67, 0x11)
#define REG_SC_BK67_11_H      _PK_H_(0x67, 0x11)
#define REG_SC_BK67_12_L      _PK_L_(0x67, 0x12)
#define REG_SC_BK67_12_H      _PK_H_(0x67, 0x12)
#define REG_SC_BK67_13_L      _PK_L_(0x67, 0x13)
#define REG_SC_BK67_13_H      _PK_H_(0x67, 0x13)
#define REG_SC_BK67_14_L      _PK_L_(0x67, 0x14)
#define REG_SC_BK67_14_H      _PK_H_(0x67, 0x14)
#define REG_SC_BK67_15_L      _PK_L_(0x67, 0x15)
#define REG_SC_BK67_15_H      _PK_H_(0x67, 0x15)
#define REG_SC_BK67_16_L      _PK_L_(0x67, 0x16)
#define REG_SC_BK67_16_H      _PK_H_(0x67, 0x16)
#define REG_SC_BK67_17_L      _PK_L_(0x67, 0x17)
#define REG_SC_BK67_17_H      _PK_H_(0x67, 0x17)
#define REG_SC_BK67_18_L      _PK_L_(0x67, 0x18)
#define REG_SC_BK67_18_H      _PK_H_(0x67, 0x18)
#define REG_SC_BK67_19_L      _PK_L_(0x67, 0x19)
#define REG_SC_BK67_19_H      _PK_H_(0x67, 0x19)
#define REG_SC_BK67_1A_L      _PK_L_(0x67, 0x1A)
#define REG_SC_BK67_1A_H      _PK_H_(0x67, 0x1A)
#define REG_SC_BK67_1B_L      _PK_L_(0x67, 0x1B)
#define REG_SC_BK67_1B_H      _PK_H_(0x67, 0x1B)
#define REG_SC_BK67_1C_L      _PK_L_(0x67, 0x1C)
#define REG_SC_BK67_1C_H      _PK_H_(0x67, 0x1C)
#define REG_SC_BK67_1D_L      _PK_L_(0x67, 0x1D)
#define REG_SC_BK67_1D_H      _PK_H_(0x67, 0x1D)
#define REG_SC_BK67_1E_L      _PK_L_(0x67, 0x1E)
#define REG_SC_BK67_1E_H      _PK_H_(0x67, 0x1E)
#define REG_SC_BK67_1F_L      _PK_L_(0x67, 0x1F)
#define REG_SC_BK67_1F_H      _PK_H_(0x67, 0x1F)
#define REG_SC_BK67_20_L      _PK_L_(0x67, 0x20)
#define REG_SC_BK67_20_H      _PK_H_(0x67, 0x20)
#define REG_SC_BK67_21_L      _PK_L_(0x67, 0x21)
#define REG_SC_BK67_21_H      _PK_H_(0x67, 0x21)
#define REG_SC_BK67_22_L      _PK_L_(0x67, 0x22)
#define REG_SC_BK67_22_H      _PK_H_(0x67, 0x22)
#define REG_SC_BK67_23_L      _PK_L_(0x67, 0x23)
#define REG_SC_BK67_23_H      _PK_H_(0x67, 0x23)
#define REG_SC_BK67_24_L      _PK_L_(0x67, 0x24)
#define REG_SC_BK67_24_H      _PK_H_(0x67, 0x24)
#define REG_SC_BK67_25_L      _PK_L_(0x67, 0x25)
#define REG_SC_BK67_25_H      _PK_H_(0x67, 0x25)
#define REG_SC_BK67_26_L      _PK_L_(0x67, 0x26)
#define REG_SC_BK67_26_H      _PK_H_(0x67, 0x26)
#define REG_SC_BK67_27_L      _PK_L_(0x67, 0x27)
#define REG_SC_BK67_27_H      _PK_H_(0x67, 0x27)
#define REG_SC_BK67_28_L      _PK_L_(0x67, 0x28)
#define REG_SC_BK67_28_H      _PK_H_(0x67, 0x28)
#define REG_SC_BK67_29_L      _PK_L_(0x67, 0x29)
#define REG_SC_BK67_29_H      _PK_H_(0x67, 0x29)
#define REG_SC_BK67_2A_L      _PK_L_(0x67, 0x2A)
#define REG_SC_BK67_2A_H      _PK_H_(0x67, 0x2A)
#define REG_SC_BK67_2B_L      _PK_L_(0x67, 0x2B)
#define REG_SC_BK67_2B_H      _PK_H_(0x67, 0x2B)
#define REG_SC_BK67_2C_L      _PK_L_(0x67, 0x2C)
#define REG_SC_BK67_2C_H      _PK_H_(0x67, 0x2C)
#define REG_SC_BK67_2D_L      _PK_L_(0x67, 0x2D)
#define REG_SC_BK67_2D_H      _PK_H_(0x67, 0x2D)
#define REG_SC_BK67_2E_L      _PK_L_(0x67, 0x2E)
#define REG_SC_BK67_2E_H      _PK_H_(0x67, 0x2E)
#define REG_SC_BK67_2F_L      _PK_L_(0x67, 0x2F)
#define REG_SC_BK67_2F_H      _PK_H_(0x67, 0x2F)
#define REG_SC_BK67_30_L      _PK_L_(0x67, 0x30)
#define REG_SC_BK67_30_H      _PK_H_(0x67, 0x30)
#define REG_SC_BK67_31_L      _PK_L_(0x67, 0x31)
#define REG_SC_BK67_31_H      _PK_H_(0x67, 0x31)
#define REG_SC_BK67_32_L      _PK_L_(0x67, 0x32)
#define REG_SC_BK67_32_H      _PK_H_(0x67, 0x32)
#define REG_SC_BK67_33_L      _PK_L_(0x67, 0x33)
#define REG_SC_BK67_33_H      _PK_H_(0x67, 0x33)
#define REG_SC_BK67_34_L      _PK_L_(0x67, 0x34)
#define REG_SC_BK67_34_H      _PK_H_(0x67, 0x34)
#define REG_SC_BK67_35_L      _PK_L_(0x67, 0x35)
#define REG_SC_BK67_35_H      _PK_H_(0x67, 0x35)
#define REG_SC_BK67_36_L      _PK_L_(0x67, 0x36)
#define REG_SC_BK67_36_H      _PK_H_(0x67, 0x36)
#define REG_SC_BK67_37_L      _PK_L_(0x67, 0x37)
#define REG_SC_BK67_37_H      _PK_H_(0x67, 0x37)
#define REG_SC_BK67_38_L      _PK_L_(0x67, 0x38)
#define REG_SC_BK67_38_H      _PK_H_(0x67, 0x38)
#define REG_SC_BK67_39_L      _PK_L_(0x67, 0x39)
#define REG_SC_BK67_39_H      _PK_H_(0x67, 0x39)
#define REG_SC_BK67_3A_L      _PK_L_(0x67, 0x3A)
#define REG_SC_BK67_3A_H      _PK_H_(0x67, 0x3A)
#define REG_SC_BK67_3B_L      _PK_L_(0x67, 0x3B)
#define REG_SC_BK67_3B_H      _PK_H_(0x67, 0x3B)
#define REG_SC_BK67_3C_L      _PK_L_(0x67, 0x3C)
#define REG_SC_BK67_3C_H      _PK_H_(0x67, 0x3C)
#define REG_SC_BK67_3D_L      _PK_L_(0x67, 0x3D)
#define REG_SC_BK67_3D_H      _PK_H_(0x67, 0x3D)
#define REG_SC_BK67_3E_L      _PK_L_(0x67, 0x3E)
#define REG_SC_BK67_3E_H      _PK_H_(0x67, 0x3E)
#define REG_SC_BK67_3F_L      _PK_L_(0x67, 0x3F)
#define REG_SC_BK67_3F_H      _PK_H_(0x67, 0x3F)
#define REG_SC_BK67_40_L      _PK_L_(0x67, 0x40)
#define REG_SC_BK67_40_H      _PK_H_(0x67, 0x40)
#define REG_SC_BK67_41_L      _PK_L_(0x67, 0x41)
#define REG_SC_BK67_41_H      _PK_H_(0x67, 0x41)
#define REG_SC_BK67_42_L      _PK_L_(0x67, 0x42)
#define REG_SC_BK67_42_H      _PK_H_(0x67, 0x42)
#define REG_SC_BK67_43_L      _PK_L_(0x67, 0x43)
#define REG_SC_BK67_43_H      _PK_H_(0x67, 0x43)
#define REG_SC_BK67_44_L      _PK_L_(0x67, 0x44)
#define REG_SC_BK67_44_H      _PK_H_(0x67, 0x44)
#define REG_SC_BK67_45_L      _PK_L_(0x67, 0x45)
#define REG_SC_BK67_45_H      _PK_H_(0x67, 0x45)
#define REG_SC_BK67_46_L      _PK_L_(0x67, 0x46)
#define REG_SC_BK67_46_H      _PK_H_(0x67, 0x46)
#define REG_SC_BK67_47_L      _PK_L_(0x67, 0x47)
#define REG_SC_BK67_47_H      _PK_H_(0x67, 0x47)
#define REG_SC_BK67_48_L      _PK_L_(0x67, 0x48)
#define REG_SC_BK67_48_H      _PK_H_(0x67, 0x48)
#define REG_SC_BK67_49_L      _PK_L_(0x67, 0x49)
#define REG_SC_BK67_49_H      _PK_H_(0x67, 0x49)
#define REG_SC_BK67_4A_L      _PK_L_(0x67, 0x4A)
#define REG_SC_BK67_4A_H      _PK_H_(0x67, 0x4A)
#define REG_SC_BK67_4B_L      _PK_L_(0x67, 0x4B)
#define REG_SC_BK67_4B_H      _PK_H_(0x67, 0x4B)
#define REG_SC_BK67_4C_L      _PK_L_(0x67, 0x4C)
#define REG_SC_BK67_4C_H      _PK_H_(0x67, 0x4C)
#define REG_SC_BK67_4D_L      _PK_L_(0x67, 0x4D)
#define REG_SC_BK67_4D_H      _PK_H_(0x67, 0x4D)
#define REG_SC_BK67_4E_L      _PK_L_(0x67, 0x4E)
#define REG_SC_BK67_4E_H      _PK_H_(0x67, 0x4E)
#define REG_SC_BK67_4F_L      _PK_L_(0x67, 0x4F)
#define REG_SC_BK67_4F_H      _PK_H_(0x67, 0x4F)
#define REG_SC_BK67_50_L      _PK_L_(0x67, 0x50)
#define REG_SC_BK67_50_H      _PK_H_(0x67, 0x50)
#define REG_SC_BK67_51_L      _PK_L_(0x67, 0x51)
#define REG_SC_BK67_51_H      _PK_H_(0x67, 0x51)
#define REG_SC_BK67_52_L      _PK_L_(0x67, 0x52)
#define REG_SC_BK67_52_H      _PK_H_(0x67, 0x52)
#define REG_SC_BK67_53_L      _PK_L_(0x67, 0x53)
#define REG_SC_BK67_53_H      _PK_H_(0x67, 0x53)
#define REG_SC_BK67_54_L      _PK_L_(0x67, 0x54)
#define REG_SC_BK67_54_H      _PK_H_(0x67, 0x54)
#define REG_SC_BK67_55_L      _PK_L_(0x67, 0x55)
#define REG_SC_BK67_55_H      _PK_H_(0x67, 0x55)
#define REG_SC_BK67_56_L      _PK_L_(0x67, 0x56)
#define REG_SC_BK67_56_H      _PK_H_(0x67, 0x56)
#define REG_SC_BK67_57_L      _PK_L_(0x67, 0x57)
#define REG_SC_BK67_57_H      _PK_H_(0x67, 0x57)
#define REG_SC_BK67_58_L      _PK_L_(0x67, 0x58)
#define REG_SC_BK67_58_H      _PK_H_(0x67, 0x58)
#define REG_SC_BK67_59_L      _PK_L_(0x67, 0x59)
#define REG_SC_BK67_59_H      _PK_H_(0x67, 0x59)
#define REG_SC_BK67_5A_L      _PK_L_(0x67, 0x5A)
#define REG_SC_BK67_5A_H      _PK_H_(0x67, 0x5A)
#define REG_SC_BK67_5B_L      _PK_L_(0x67, 0x5B)
#define REG_SC_BK67_5B_H      _PK_H_(0x67, 0x5B)
#define REG_SC_BK67_5C_L      _PK_L_(0x67, 0x5C)
#define REG_SC_BK67_5C_H      _PK_H_(0x67, 0x5C)
#define REG_SC_BK67_5D_L      _PK_L_(0x67, 0x5D)
#define REG_SC_BK67_5D_H      _PK_H_(0x67, 0x5D)
#define REG_SC_BK67_5E_L      _PK_L_(0x67, 0x5E)
#define REG_SC_BK67_5E_H      _PK_H_(0x67, 0x5E)
#define REG_SC_BK67_5F_L      _PK_L_(0x67, 0x5F)
#define REG_SC_BK67_5F_H      _PK_H_(0x67, 0x5F)
#define REG_SC_BK67_60_L      _PK_L_(0x67, 0x60)
#define REG_SC_BK67_60_H      _PK_H_(0x67, 0x60)
#define REG_SC_BK67_61_L      _PK_L_(0x67, 0x61)
#define REG_SC_BK67_61_H      _PK_H_(0x67, 0x61)
#define REG_SC_BK67_62_L      _PK_L_(0x67, 0x62)
#define REG_SC_BK67_62_H      _PK_H_(0x67, 0x62)
#define REG_SC_BK67_63_L      _PK_L_(0x67, 0x63)
#define REG_SC_BK67_63_H      _PK_H_(0x67, 0x63)
#define REG_SC_BK67_64_L      _PK_L_(0x67, 0x64)
#define REG_SC_BK67_64_H      _PK_H_(0x67, 0x64)
#define REG_SC_BK67_65_L      _PK_L_(0x67, 0x65)
#define REG_SC_BK67_65_H      _PK_H_(0x67, 0x65)
#define REG_SC_BK67_66_L      _PK_L_(0x67, 0x66)
#define REG_SC_BK67_66_H      _PK_H_(0x67, 0x66)
#define REG_SC_BK67_67_L      _PK_L_(0x67, 0x67)
#define REG_SC_BK67_67_H      _PK_H_(0x67, 0x67)
#define REG_SC_BK67_68_L      _PK_L_(0x67, 0x68)
#define REG_SC_BK67_68_H      _PK_H_(0x67, 0x68)
#define REG_SC_BK67_69_L      _PK_L_(0x67, 0x69)
#define REG_SC_BK67_69_H      _PK_H_(0x67, 0x69)
#define REG_SC_BK67_6A_L      _PK_L_(0x67, 0x6A)
#define REG_SC_BK67_6A_H      _PK_H_(0x67, 0x6A)
#define REG_SC_BK67_6B_L      _PK_L_(0x67, 0x6B)
#define REG_SC_BK67_6B_H      _PK_H_(0x67, 0x6B)
#define REG_SC_BK67_6C_L      _PK_L_(0x67, 0x6C)
#define REG_SC_BK67_6C_H      _PK_H_(0x67, 0x6C)
#define REG_SC_BK67_6D_L      _PK_L_(0x67, 0x6D)
#define REG_SC_BK67_6D_H      _PK_H_(0x67, 0x6D)
#define REG_SC_BK67_6E_L      _PK_L_(0x67, 0x6E)
#define REG_SC_BK67_6E_H      _PK_H_(0x67, 0x6E)
#define REG_SC_BK67_6F_L      _PK_L_(0x67, 0x6F)
#define REG_SC_BK67_6F_H      _PK_H_(0x67, 0x6F)
#define REG_SC_BK67_70_L      _PK_L_(0x67, 0x70)
#define REG_SC_BK67_70_H      _PK_H_(0x67, 0x70)
#define REG_SC_BK67_71_L      _PK_L_(0x67, 0x71)
#define REG_SC_BK67_71_H      _PK_H_(0x67, 0x71)
#define REG_SC_BK67_72_L      _PK_L_(0x67, 0x72)
#define REG_SC_BK67_72_H      _PK_H_(0x67, 0x72)
#define REG_SC_BK67_73_L      _PK_L_(0x67, 0x73)
#define REG_SC_BK67_73_H      _PK_H_(0x67, 0x73)
#define REG_SC_BK67_74_L      _PK_L_(0x67, 0x74)
#define REG_SC_BK67_74_H      _PK_H_(0x67, 0x74)
#define REG_SC_BK67_75_L      _PK_L_(0x67, 0x75)
#define REG_SC_BK67_75_H      _PK_H_(0x67, 0x75)
#define REG_SC_BK67_76_L      _PK_L_(0x67, 0x76)
#define REG_SC_BK67_76_H      _PK_H_(0x67, 0x76)
#define REG_SC_BK67_77_L      _PK_L_(0x67, 0x77)
#define REG_SC_BK67_77_H      _PK_H_(0x67, 0x77)
#define REG_SC_BK67_78_L      _PK_L_(0x67, 0x78)
#define REG_SC_BK67_78_H      _PK_H_(0x67, 0x78)
#define REG_SC_BK67_79_L      _PK_L_(0x67, 0x79)
#define REG_SC_BK67_79_H      _PK_H_(0x67, 0x79)
#define REG_SC_BK67_7A_L      _PK_L_(0x67, 0x7A)
#define REG_SC_BK67_7A_H      _PK_H_(0x67, 0x7A)
#define REG_SC_BK67_7B_L      _PK_L_(0x67, 0x7B)
#define REG_SC_BK67_7B_H      _PK_H_(0x67, 0x7B)
#define REG_SC_BK67_7C_L      _PK_L_(0x67, 0x7C)
#define REG_SC_BK67_7C_H      _PK_H_(0x67, 0x7C)
#define REG_SC_BK67_7D_L      _PK_L_(0x67, 0x7D)
#define REG_SC_BK67_7D_H      _PK_H_(0x67, 0x7D)
#define REG_SC_BK67_7E_L      _PK_L_(0x67, 0x7E)
#define REG_SC_BK67_7E_H      _PK_H_(0x67, 0x7E)
#define REG_SC_BK67_7F_L      _PK_L_(0x67, 0x7F)
#define REG_SC_BK67_7F_H      _PK_H_(0x67, 0x7F)
//----------------------------------------------
#define REG_SC_BK6A_00_L      _PK_L_(0x6A, 0x00)
#define REG_SC_BK6A_00_H      _PK_H_(0x6A, 0x00)
#define REG_SC_BK6A_01_L      _PK_L_(0x6A, 0x01)
#define REG_SC_BK6A_01_H      _PK_H_(0x6A, 0x01)
#define REG_SC_BK6A_02_L      _PK_L_(0x6A, 0x02)
#define REG_SC_BK6A_02_H      _PK_H_(0x6A, 0x02)
#define REG_SC_BK6A_03_L      _PK_L_(0x6A, 0x03)
#define REG_SC_BK6A_03_H      _PK_H_(0x6A, 0x03)
#define REG_SC_BK6A_04_L      _PK_L_(0x6A, 0x04)
#define REG_SC_BK6A_04_H      _PK_H_(0x6A, 0x04)
#define REG_SC_BK6A_05_L      _PK_L_(0x6A, 0x05)
#define REG_SC_BK6A_05_H      _PK_H_(0x6A, 0x05)
#define REG_SC_BK6A_06_L      _PK_L_(0x6A, 0x06)
#define REG_SC_BK6A_06_H      _PK_H_(0x6A, 0x06)
#define REG_SC_BK6A_07_L      _PK_L_(0x6A, 0x07)
#define REG_SC_BK6A_07_H      _PK_H_(0x6A, 0x07)
#define REG_SC_BK6A_08_L      _PK_L_(0x6A, 0x08)
#define REG_SC_BK6A_08_H      _PK_H_(0x6A, 0x08)
#define REG_SC_BK6A_09_L      _PK_L_(0x6A, 0x09)
#define REG_SC_BK6A_09_H      _PK_H_(0x6A, 0x09)
#define REG_SC_BK6A_0A_L      _PK_L_(0x6A, 0x0A)
#define REG_SC_BK6A_0A_H      _PK_H_(0x6A, 0x0A)
#define REG_SC_BK6A_0B_L      _PK_L_(0x6A, 0x0B)
#define REG_SC_BK6A_0B_H      _PK_H_(0x6A, 0x0B)
#define REG_SC_BK6A_0C_L      _PK_L_(0x6A, 0x0C)
#define REG_SC_BK6A_0C_H      _PK_H_(0x6A, 0x0C)
#define REG_SC_BK6A_0D_L      _PK_L_(0x6A, 0x0D)
#define REG_SC_BK6A_0D_H      _PK_H_(0x6A, 0x0D)
#define REG_SC_BK6A_0E_L      _PK_L_(0x6A, 0x0E)
#define REG_SC_BK6A_0E_H      _PK_H_(0x6A, 0x0E)
#define REG_SC_BK6A_0F_L      _PK_L_(0x6A, 0x0F)
#define REG_SC_BK6A_0F_H      _PK_H_(0x6A, 0x0F)
#define REG_SC_BK6A_10_L      _PK_L_(0x6A, 0x10)
#define REG_SC_BK6A_10_H      _PK_H_(0x6A, 0x10)
#define REG_SC_BK6A_11_L      _PK_L_(0x6A, 0x11)
#define REG_SC_BK6A_11_H      _PK_H_(0x6A, 0x11)
#define REG_SC_BK6A_12_L      _PK_L_(0x6A, 0x12)
#define REG_SC_BK6A_12_H      _PK_H_(0x6A, 0x12)
#define REG_SC_BK6A_13_L      _PK_L_(0x6A, 0x13)
#define REG_SC_BK6A_13_H      _PK_H_(0x6A, 0x13)
#define REG_SC_BK6A_14_L      _PK_L_(0x6A, 0x14)
#define REG_SC_BK6A_14_H      _PK_H_(0x6A, 0x14)
#define REG_SC_BK6A_15_L      _PK_L_(0x6A, 0x15)
#define REG_SC_BK6A_15_H      _PK_H_(0x6A, 0x15)
#define REG_SC_BK6A_16_L      _PK_L_(0x6A, 0x16)
#define REG_SC_BK6A_16_H      _PK_H_(0x6A, 0x16)
#define REG_SC_BK6A_17_L      _PK_L_(0x6A, 0x17)
#define REG_SC_BK6A_17_H      _PK_H_(0x6A, 0x17)
#define REG_SC_BK6A_18_L      _PK_L_(0x6A, 0x18)
#define REG_SC_BK6A_18_H      _PK_H_(0x6A, 0x18)
#define REG_SC_BK6A_19_L      _PK_L_(0x6A, 0x19)
#define REG_SC_BK6A_19_H      _PK_H_(0x6A, 0x19)
#define REG_SC_BK6A_1A_L      _PK_L_(0x6A, 0x1A)
#define REG_SC_BK6A_1A_H      _PK_H_(0x6A, 0x1A)
#define REG_SC_BK6A_1B_L      _PK_L_(0x6A, 0x1B)
#define REG_SC_BK6A_1B_H      _PK_H_(0x6A, 0x1B)
#define REG_SC_BK6A_1C_L      _PK_L_(0x6A, 0x1C)
#define REG_SC_BK6A_1C_H      _PK_H_(0x6A, 0x1C)
#define REG_SC_BK6A_1D_L      _PK_L_(0x6A, 0x1D)
#define REG_SC_BK6A_1D_H      _PK_H_(0x6A, 0x1D)
#define REG_SC_BK6A_1E_L      _PK_L_(0x6A, 0x1E)
#define REG_SC_BK6A_1E_H      _PK_H_(0x6A, 0x1E)
#define REG_SC_BK6A_1F_L      _PK_L_(0x6A, 0x1F)
#define REG_SC_BK6A_1F_H      _PK_H_(0x6A, 0x1F)
#define REG_SC_BK6A_20_L      _PK_L_(0x6A, 0x20)
#define REG_SC_BK6A_20_H      _PK_H_(0x6A, 0x20)
#define REG_SC_BK6A_21_L      _PK_L_(0x6A, 0x21)
#define REG_SC_BK6A_21_H      _PK_H_(0x6A, 0x21)
#define REG_SC_BK6A_22_L      _PK_L_(0x6A, 0x22)
#define REG_SC_BK6A_22_H      _PK_H_(0x6A, 0x22)
#define REG_SC_BK6A_23_L      _PK_L_(0x6A, 0x23)
#define REG_SC_BK6A_23_H      _PK_H_(0x6A, 0x23)
#define REG_SC_BK6A_24_L      _PK_L_(0x6A, 0x24)
#define REG_SC_BK6A_24_H      _PK_H_(0x6A, 0x24)
#define REG_SC_BK6A_25_L      _PK_L_(0x6A, 0x25)
#define REG_SC_BK6A_25_H      _PK_H_(0x6A, 0x25)
#define REG_SC_BK6A_26_L      _PK_L_(0x6A, 0x26)
#define REG_SC_BK6A_26_H      _PK_H_(0x6A, 0x26)
#define REG_SC_BK6A_27_L      _PK_L_(0x6A, 0x27)
#define REG_SC_BK6A_27_H      _PK_H_(0x6A, 0x27)
#define REG_SC_BK6A_28_L      _PK_L_(0x6A, 0x28)
#define REG_SC_BK6A_28_H      _PK_H_(0x6A, 0x28)
#define REG_SC_BK6A_29_L      _PK_L_(0x6A, 0x29)
#define REG_SC_BK6A_29_H      _PK_H_(0x6A, 0x29)
#define REG_SC_BK6A_2A_L      _PK_L_(0x6A, 0x2A)
#define REG_SC_BK6A_2A_H      _PK_H_(0x6A, 0x2A)
#define REG_SC_BK6A_2B_L      _PK_L_(0x6A, 0x2B)
#define REG_SC_BK6A_2B_H      _PK_H_(0x6A, 0x2B)
#define REG_SC_BK6A_2C_L      _PK_L_(0x6A, 0x2C)
#define REG_SC_BK6A_2C_H      _PK_H_(0x6A, 0x2C)
#define REG_SC_BK6A_2D_L      _PK_L_(0x6A, 0x2D)
#define REG_SC_BK6A_2D_H      _PK_H_(0x6A, 0x2D)
#define REG_SC_BK6A_2E_L      _PK_L_(0x6A, 0x2E)
#define REG_SC_BK6A_2E_H      _PK_H_(0x6A, 0x2E)
#define REG_SC_BK6A_2F_L      _PK_L_(0x6A, 0x2F)
#define REG_SC_BK6A_2F_H      _PK_H_(0x6A, 0x2F)
#define REG_SC_BK6A_30_L      _PK_L_(0x6A, 0x30)
#define REG_SC_BK6A_30_H      _PK_H_(0x6A, 0x30)
#define REG_SC_BK6A_31_L      _PK_L_(0x6A, 0x31)
#define REG_SC_BK6A_31_H      _PK_H_(0x6A, 0x31)
#define REG_SC_BK6A_32_L      _PK_L_(0x6A, 0x32)
#define REG_SC_BK6A_32_H      _PK_H_(0x6A, 0x32)
#define REG_SC_BK6A_33_L      _PK_L_(0x6A, 0x33)
#define REG_SC_BK6A_33_H      _PK_H_(0x6A, 0x33)
#define REG_SC_BK6A_34_L      _PK_L_(0x6A, 0x34)
#define REG_SC_BK6A_34_H      _PK_H_(0x6A, 0x34)
#define REG_SC_BK6A_35_L      _PK_L_(0x6A, 0x35)
#define REG_SC_BK6A_35_H      _PK_H_(0x6A, 0x35)
#define REG_SC_BK6A_36_L      _PK_L_(0x6A, 0x36)
#define REG_SC_BK6A_36_H      _PK_H_(0x6A, 0x36)
#define REG_SC_BK6A_37_L      _PK_L_(0x6A, 0x37)
#define REG_SC_BK6A_37_H      _PK_H_(0x6A, 0x37)
#define REG_SC_BK6A_38_L      _PK_L_(0x6A, 0x38)
#define REG_SC_BK6A_38_H      _PK_H_(0x6A, 0x38)
#define REG_SC_BK6A_39_L      _PK_L_(0x6A, 0x39)
#define REG_SC_BK6A_39_H      _PK_H_(0x6A, 0x39)
#define REG_SC_BK6A_3A_L      _PK_L_(0x6A, 0x3A)
#define REG_SC_BK6A_3A_H      _PK_H_(0x6A, 0x3A)
#define REG_SC_BK6A_3B_L      _PK_L_(0x6A, 0x3B)
#define REG_SC_BK6A_3B_H      _PK_H_(0x6A, 0x3B)
#define REG_SC_BK6A_3C_L      _PK_L_(0x6A, 0x3C)
#define REG_SC_BK6A_3C_H      _PK_H_(0x6A, 0x3C)
#define REG_SC_BK6A_3D_L      _PK_L_(0x6A, 0x3D)
#define REG_SC_BK6A_3D_H      _PK_H_(0x6A, 0x3D)
#define REG_SC_BK6A_3E_L      _PK_L_(0x6A, 0x3E)
#define REG_SC_BK6A_3E_H      _PK_H_(0x6A, 0x3E)
#define REG_SC_BK6A_3F_L      _PK_L_(0x6A, 0x3F)
#define REG_SC_BK6A_3F_H      _PK_H_(0x6A, 0x3F)
#define REG_SC_BK6A_40_L      _PK_L_(0x6A, 0x40)
#define REG_SC_BK6A_40_H      _PK_H_(0x6A, 0x40)
#define REG_SC_BK6A_41_L      _PK_L_(0x6A, 0x41)
#define REG_SC_BK6A_41_H      _PK_H_(0x6A, 0x41)
#define REG_SC_BK6A_42_L      _PK_L_(0x6A, 0x42)
#define REG_SC_BK6A_42_H      _PK_H_(0x6A, 0x42)
#define REG_SC_BK6A_43_L      _PK_L_(0x6A, 0x43)
#define REG_SC_BK6A_43_H      _PK_H_(0x6A, 0x43)
#define REG_SC_BK6A_44_L      _PK_L_(0x6A, 0x44)
#define REG_SC_BK6A_44_H      _PK_H_(0x6A, 0x44)
#define REG_SC_BK6A_45_L      _PK_L_(0x6A, 0x45)
#define REG_SC_BK6A_45_H      _PK_H_(0x6A, 0x45)
#define REG_SC_BK6A_46_L      _PK_L_(0x6A, 0x46)
#define REG_SC_BK6A_46_H      _PK_H_(0x6A, 0x46)
#define REG_SC_BK6A_47_L      _PK_L_(0x6A, 0x47)
#define REG_SC_BK6A_47_H      _PK_H_(0x6A, 0x47)
#define REG_SC_BK6A_48_L      _PK_L_(0x6A, 0x48)
#define REG_SC_BK6A_48_H      _PK_H_(0x6A, 0x48)
#define REG_SC_BK6A_49_L      _PK_L_(0x6A, 0x49)
#define REG_SC_BK6A_49_H      _PK_H_(0x6A, 0x49)
#define REG_SC_BK6A_4A_L      _PK_L_(0x6A, 0x4A)
#define REG_SC_BK6A_4A_H      _PK_H_(0x6A, 0x4A)
#define REG_SC_BK6A_4B_L      _PK_L_(0x6A, 0x4B)
#define REG_SC_BK6A_4B_H      _PK_H_(0x6A, 0x4B)
#define REG_SC_BK6A_4C_L      _PK_L_(0x6A, 0x4C)
#define REG_SC_BK6A_4C_H      _PK_H_(0x6A, 0x4C)
#define REG_SC_BK6A_4D_L      _PK_L_(0x6A, 0x4D)
#define REG_SC_BK6A_4D_H      _PK_H_(0x6A, 0x4D)
#define REG_SC_BK6A_4E_L      _PK_L_(0x6A, 0x4E)
#define REG_SC_BK6A_4E_H      _PK_H_(0x6A, 0x4E)
#define REG_SC_BK6A_4F_L      _PK_L_(0x6A, 0x4F)
#define REG_SC_BK6A_4F_H      _PK_H_(0x6A, 0x4F)
#define REG_SC_BK6A_50_L      _PK_L_(0x6A, 0x50)
#define REG_SC_BK6A_50_H      _PK_H_(0x6A, 0x50)
#define REG_SC_BK6A_51_L      _PK_L_(0x6A, 0x51)
#define REG_SC_BK6A_51_H      _PK_H_(0x6A, 0x51)
#define REG_SC_BK6A_52_L      _PK_L_(0x6A, 0x52)
#define REG_SC_BK6A_52_H      _PK_H_(0x6A, 0x52)
#define REG_SC_BK6A_53_L      _PK_L_(0x6A, 0x53)
#define REG_SC_BK6A_53_H      _PK_H_(0x6A, 0x53)
#define REG_SC_BK6A_54_L      _PK_L_(0x6A, 0x54)
#define REG_SC_BK6A_54_H      _PK_H_(0x6A, 0x54)
#define REG_SC_BK6A_55_L      _PK_L_(0x6A, 0x55)
#define REG_SC_BK6A_55_H      _PK_H_(0x6A, 0x55)
#define REG_SC_BK6A_56_L      _PK_L_(0x6A, 0x56)
#define REG_SC_BK6A_56_H      _PK_H_(0x6A, 0x56)
#define REG_SC_BK6A_57_L      _PK_L_(0x6A, 0x57)
#define REG_SC_BK6A_57_H      _PK_H_(0x6A, 0x57)
#define REG_SC_BK6A_58_L      _PK_L_(0x6A, 0x58)
#define REG_SC_BK6A_58_H      _PK_H_(0x6A, 0x58)
#define REG_SC_BK6A_59_L      _PK_L_(0x6A, 0x59)
#define REG_SC_BK6A_59_H      _PK_H_(0x6A, 0x59)
#define REG_SC_BK6A_5A_L      _PK_L_(0x6A, 0x5A)
#define REG_SC_BK6A_5A_H      _PK_H_(0x6A, 0x5A)
#define REG_SC_BK6A_5B_L      _PK_L_(0x6A, 0x5B)
#define REG_SC_BK6A_5B_H      _PK_H_(0x6A, 0x5B)
#define REG_SC_BK6A_5C_L      _PK_L_(0x6A, 0x5C)
#define REG_SC_BK6A_5C_H      _PK_H_(0x6A, 0x5C)
#define REG_SC_BK6A_5D_L      _PK_L_(0x6A, 0x5D)
#define REG_SC_BK6A_5D_H      _PK_H_(0x6A, 0x5D)
#define REG_SC_BK6A_5E_L      _PK_L_(0x6A, 0x5E)
#define REG_SC_BK6A_5E_H      _PK_H_(0x6A, 0x5E)
#define REG_SC_BK6A_5F_L      _PK_L_(0x6A, 0x5F)
#define REG_SC_BK6A_5F_H      _PK_H_(0x6A, 0x5F)
#define REG_SC_BK6A_60_L      _PK_L_(0x6A, 0x60)
#define REG_SC_BK6A_60_H      _PK_H_(0x6A, 0x60)
#define REG_SC_BK6A_61_L      _PK_L_(0x6A, 0x61)
#define REG_SC_BK6A_61_H      _PK_H_(0x6A, 0x61)
#define REG_SC_BK6A_62_L      _PK_L_(0x6A, 0x62)
#define REG_SC_BK6A_62_H      _PK_H_(0x6A, 0x62)
#define REG_SC_BK6A_63_L      _PK_L_(0x6A, 0x63)
#define REG_SC_BK6A_63_H      _PK_H_(0x6A, 0x63)
#define REG_SC_BK6A_64_L      _PK_L_(0x6A, 0x64)
#define REG_SC_BK6A_64_H      _PK_H_(0x6A, 0x64)
#define REG_SC_BK6A_65_L      _PK_L_(0x6A, 0x65)
#define REG_SC_BK6A_65_H      _PK_H_(0x6A, 0x65)
#define REG_SC_BK6A_66_L      _PK_L_(0x6A, 0x66)
#define REG_SC_BK6A_66_H      _PK_H_(0x6A, 0x66)
#define REG_SC_BK6A_67_L      _PK_L_(0x6A, 0x67)
#define REG_SC_BK6A_67_H      _PK_H_(0x6A, 0x67)
#define REG_SC_BK6A_68_L      _PK_L_(0x6A, 0x68)
#define REG_SC_BK6A_68_H      _PK_H_(0x6A, 0x68)
#define REG_SC_BK6A_69_L      _PK_L_(0x6A, 0x69)
#define REG_SC_BK6A_69_H      _PK_H_(0x6A, 0x69)
#define REG_SC_BK6A_6A_L      _PK_L_(0x6A, 0x6A)
#define REG_SC_BK6A_6A_H      _PK_H_(0x6A, 0x6A)
#define REG_SC_BK6A_6B_L      _PK_L_(0x6A, 0x6B)
#define REG_SC_BK6A_6B_H      _PK_H_(0x6A, 0x6B)
#define REG_SC_BK6A_6C_L      _PK_L_(0x6A, 0x6C)
#define REG_SC_BK6A_6C_H      _PK_H_(0x6A, 0x6C)
#define REG_SC_BK6A_6D_L      _PK_L_(0x6A, 0x6D)
#define REG_SC_BK6A_6D_H      _PK_H_(0x6A, 0x6D)
#define REG_SC_BK6A_6E_L      _PK_L_(0x6A, 0x6E)
#define REG_SC_BK6A_6E_H      _PK_H_(0x6A, 0x6E)
#define REG_SC_BK6A_6F_L      _PK_L_(0x6A, 0x6F)
#define REG_SC_BK6A_6F_H      _PK_H_(0x6A, 0x6F)
#define REG_SC_BK6A_70_L      _PK_L_(0x6A, 0x70)
#define REG_SC_BK6A_70_H      _PK_H_(0x6A, 0x70)
#define REG_SC_BK6A_71_L      _PK_L_(0x6A, 0x71)
#define REG_SC_BK6A_71_H      _PK_H_(0x6A, 0x71)
#define REG_SC_BK6A_72_L      _PK_L_(0x6A, 0x72)
#define REG_SC_BK6A_72_H      _PK_H_(0x6A, 0x72)
#define REG_SC_BK6A_73_L      _PK_L_(0x6A, 0x73)
#define REG_SC_BK6A_73_H      _PK_H_(0x6A, 0x73)
#define REG_SC_BK6A_74_L      _PK_L_(0x6A, 0x74)
#define REG_SC_BK6A_74_H      _PK_H_(0x6A, 0x74)
#define REG_SC_BK6A_75_L      _PK_L_(0x6A, 0x75)
#define REG_SC_BK6A_75_H      _PK_H_(0x6A, 0x75)
#define REG_SC_BK6A_76_L      _PK_L_(0x6A, 0x76)
#define REG_SC_BK6A_76_H      _PK_H_(0x6A, 0x76)
#define REG_SC_BK6A_77_L      _PK_L_(0x6A, 0x77)
#define REG_SC_BK6A_77_H      _PK_H_(0x6A, 0x77)
#define REG_SC_BK6A_78_L      _PK_L_(0x6A, 0x78)
#define REG_SC_BK6A_78_H      _PK_H_(0x6A, 0x78)
#define REG_SC_BK6A_79_L      _PK_L_(0x6A, 0x79)
#define REG_SC_BK6A_79_H      _PK_H_(0x6A, 0x79)
#define REG_SC_BK6A_7A_L      _PK_L_(0x6A, 0x7A)
#define REG_SC_BK6A_7A_H      _PK_H_(0x6A, 0x7A)
#define REG_SC_BK6A_7B_L      _PK_L_(0x6A, 0x7B)
#define REG_SC_BK6A_7B_H      _PK_H_(0x6A, 0x7B)
#define REG_SC_BK6A_7C_L      _PK_L_(0x6A, 0x7C)
#define REG_SC_BK6A_7C_H      _PK_H_(0x6A, 0x7C)
#define REG_SC_BK6A_7D_L      _PK_L_(0x6A, 0x7D)
#define REG_SC_BK6A_7D_H      _PK_H_(0x6A, 0x7D)
#define REG_SC_BK6A_7E_L      _PK_L_(0x6A, 0x7E)
#define REG_SC_BK6A_7E_H      _PK_H_(0x6A, 0x7E)
#define REG_SC_BK6A_7F_L      _PK_L_(0x6A, 0x7F)
#define REG_SC_BK6A_7F_H      _PK_H_(0x6A, 0x7F)
//----------------------------------------------
#define REG_SC_BK6B_00_L      _PK_L_(0x6B, 0x00)
#define REG_SC_BK6B_00_H      _PK_H_(0x6B, 0x00)
#define REG_SC_BK6B_01_L      _PK_L_(0x6B, 0x01)
#define REG_SC_BK6B_01_H      _PK_H_(0x6B, 0x01)
#define REG_SC_BK6B_02_L      _PK_L_(0x6B, 0x02)
#define REG_SC_BK6B_02_H      _PK_H_(0x6B, 0x02)
#define REG_SC_BK6B_03_L      _PK_L_(0x6B, 0x03)
#define REG_SC_BK6B_03_H      _PK_H_(0x6B, 0x03)
#define REG_SC_BK6B_04_L      _PK_L_(0x6B, 0x04)
#define REG_SC_BK6B_04_H      _PK_H_(0x6B, 0x04)
#define REG_SC_BK6B_05_L      _PK_L_(0x6B, 0x05)
#define REG_SC_BK6B_05_H      _PK_H_(0x6B, 0x05)
#define REG_SC_BK6B_06_L      _PK_L_(0x6B, 0x06)
#define REG_SC_BK6B_06_H      _PK_H_(0x6B, 0x06)
#define REG_SC_BK6B_07_L      _PK_L_(0x6B, 0x07)
#define REG_SC_BK6B_07_H      _PK_H_(0x6B, 0x07)
#define REG_SC_BK6B_08_L      _PK_L_(0x6B, 0x08)
#define REG_SC_BK6B_08_H      _PK_H_(0x6B, 0x08)
#define REG_SC_BK6B_09_L      _PK_L_(0x6B, 0x09)
#define REG_SC_BK6B_09_H      _PK_H_(0x6B, 0x09)
#define REG_SC_BK6B_0A_L      _PK_L_(0x6B, 0x0A)
#define REG_SC_BK6B_0A_H      _PK_H_(0x6B, 0x0A)
#define REG_SC_BK6B_0B_L      _PK_L_(0x6B, 0x0B)
#define REG_SC_BK6B_0B_H      _PK_H_(0x6B, 0x0B)
#define REG_SC_BK6B_0C_L      _PK_L_(0x6B, 0x0C)
#define REG_SC_BK6B_0C_H      _PK_H_(0x6B, 0x0C)
#define REG_SC_BK6B_0D_L      _PK_L_(0x6B, 0x0D)
#define REG_SC_BK6B_0D_H      _PK_H_(0x6B, 0x0D)
#define REG_SC_BK6B_0E_L      _PK_L_(0x6B, 0x0E)
#define REG_SC_BK6B_0E_H      _PK_H_(0x6B, 0x0E)
#define REG_SC_BK6B_0F_L      _PK_L_(0x6B, 0x0F)
#define REG_SC_BK6B_0F_H      _PK_H_(0x6B, 0x0F)
#define REG_SC_BK6B_10_L      _PK_L_(0x6B, 0x10)
#define REG_SC_BK6B_10_H      _PK_H_(0x6B, 0x10)
#define REG_SC_BK6B_11_L      _PK_L_(0x6B, 0x11)
#define REG_SC_BK6B_11_H      _PK_H_(0x6B, 0x11)
#define REG_SC_BK6B_12_L      _PK_L_(0x6B, 0x12)
#define REG_SC_BK6B_12_H      _PK_H_(0x6B, 0x12)
#define REG_SC_BK6B_13_L      _PK_L_(0x6B, 0x13)
#define REG_SC_BK6B_13_H      _PK_H_(0x6B, 0x13)
#define REG_SC_BK6B_14_L      _PK_L_(0x6B, 0x14)
#define REG_SC_BK6B_14_H      _PK_H_(0x6B, 0x14)
#define REG_SC_BK6B_15_L      _PK_L_(0x6B, 0x15)
#define REG_SC_BK6B_15_H      _PK_H_(0x6B, 0x15)
#define REG_SC_BK6B_16_L      _PK_L_(0x6B, 0x16)
#define REG_SC_BK6B_16_H      _PK_H_(0x6B, 0x16)
#define REG_SC_BK6B_17_L      _PK_L_(0x6B, 0x17)
#define REG_SC_BK6B_17_H      _PK_H_(0x6B, 0x17)
#define REG_SC_BK6B_18_L      _PK_L_(0x6B, 0x18)
#define REG_SC_BK6B_18_H      _PK_H_(0x6B, 0x18)
#define REG_SC_BK6B_19_L      _PK_L_(0x6B, 0x19)
#define REG_SC_BK6B_19_H      _PK_H_(0x6B, 0x19)
#define REG_SC_BK6B_1A_L      _PK_L_(0x6B, 0x1A)
#define REG_SC_BK6B_1A_H      _PK_H_(0x6B, 0x1A)
#define REG_SC_BK6B_1B_L      _PK_L_(0x6B, 0x1B)
#define REG_SC_BK6B_1B_H      _PK_H_(0x6B, 0x1B)
#define REG_SC_BK6B_1C_L      _PK_L_(0x6B, 0x1C)
#define REG_SC_BK6B_1C_H      _PK_H_(0x6B, 0x1C)
#define REG_SC_BK6B_1D_L      _PK_L_(0x6B, 0x1D)
#define REG_SC_BK6B_1D_H      _PK_H_(0x6B, 0x1D)
#define REG_SC_BK6B_1E_L      _PK_L_(0x6B, 0x1E)
#define REG_SC_BK6B_1E_H      _PK_H_(0x6B, 0x1E)
#define REG_SC_BK6B_1F_L      _PK_L_(0x6B, 0x1F)
#define REG_SC_BK6B_1F_H      _PK_H_(0x6B, 0x1F)
#define REG_SC_BK6B_20_L      _PK_L_(0x6B, 0x20)
#define REG_SC_BK6B_20_H      _PK_H_(0x6B, 0x20)
#define REG_SC_BK6B_21_L      _PK_L_(0x6B, 0x21)
#define REG_SC_BK6B_21_H      _PK_H_(0x6B, 0x21)
#define REG_SC_BK6B_22_L      _PK_L_(0x6B, 0x22)
#define REG_SC_BK6B_22_H      _PK_H_(0x6B, 0x22)
#define REG_SC_BK6B_23_L      _PK_L_(0x6B, 0x23)
#define REG_SC_BK6B_23_H      _PK_H_(0x6B, 0x23)
#define REG_SC_BK6B_24_L      _PK_L_(0x6B, 0x24)
#define REG_SC_BK6B_24_H      _PK_H_(0x6B, 0x24)
#define REG_SC_BK6B_25_L      _PK_L_(0x6B, 0x25)
#define REG_SC_BK6B_25_H      _PK_H_(0x6B, 0x25)
#define REG_SC_BK6B_26_L      _PK_L_(0x6B, 0x26)
#define REG_SC_BK6B_26_H      _PK_H_(0x6B, 0x26)
#define REG_SC_BK6B_27_L      _PK_L_(0x6B, 0x27)
#define REG_SC_BK6B_27_H      _PK_H_(0x6B, 0x27)
#define REG_SC_BK6B_28_L      _PK_L_(0x6B, 0x28)
#define REG_SC_BK6B_28_H      _PK_H_(0x6B, 0x28)
#define REG_SC_BK6B_29_L      _PK_L_(0x6B, 0x29)
#define REG_SC_BK6B_29_H      _PK_H_(0x6B, 0x29)
#define REG_SC_BK6B_2A_L      _PK_L_(0x6B, 0x2A)
#define REG_SC_BK6B_2A_H      _PK_H_(0x6B, 0x2A)
#define REG_SC_BK6B_2B_L      _PK_L_(0x6B, 0x2B)
#define REG_SC_BK6B_2B_H      _PK_H_(0x6B, 0x2B)
#define REG_SC_BK6B_2C_L      _PK_L_(0x6B, 0x2C)
#define REG_SC_BK6B_2C_H      _PK_H_(0x6B, 0x2C)
#define REG_SC_BK6B_2D_L      _PK_L_(0x6B, 0x2D)
#define REG_SC_BK6B_2D_H      _PK_H_(0x6B, 0x2D)
#define REG_SC_BK6B_2E_L      _PK_L_(0x6B, 0x2E)
#define REG_SC_BK6B_2E_H      _PK_H_(0x6B, 0x2E)
#define REG_SC_BK6B_2F_L      _PK_L_(0x6B, 0x2F)
#define REG_SC_BK6B_2F_H      _PK_H_(0x6B, 0x2F)
#define REG_SC_BK6B_30_L      _PK_L_(0x6B, 0x30)
#define REG_SC_BK6B_30_H      _PK_H_(0x6B, 0x30)
#define REG_SC_BK6B_31_L      _PK_L_(0x6B, 0x31)
#define REG_SC_BK6B_31_H      _PK_H_(0x6B, 0x31)
#define REG_SC_BK6B_32_L      _PK_L_(0x6B, 0x32)
#define REG_SC_BK6B_32_H      _PK_H_(0x6B, 0x32)
#define REG_SC_BK6B_33_L      _PK_L_(0x6B, 0x33)
#define REG_SC_BK6B_33_H      _PK_H_(0x6B, 0x33)
#define REG_SC_BK6B_34_L      _PK_L_(0x6B, 0x34)
#define REG_SC_BK6B_34_H      _PK_H_(0x6B, 0x34)
#define REG_SC_BK6B_35_L      _PK_L_(0x6B, 0x35)
#define REG_SC_BK6B_35_H      _PK_H_(0x6B, 0x35)
#define REG_SC_BK6B_36_L      _PK_L_(0x6B, 0x36)
#define REG_SC_BK6B_36_H      _PK_H_(0x6B, 0x36)
#define REG_SC_BK6B_37_L      _PK_L_(0x6B, 0x37)
#define REG_SC_BK6B_37_H      _PK_H_(0x6B, 0x37)
#define REG_SC_BK6B_38_L      _PK_L_(0x6B, 0x38)
#define REG_SC_BK6B_38_H      _PK_H_(0x6B, 0x38)
#define REG_SC_BK6B_39_L      _PK_L_(0x6B, 0x39)
#define REG_SC_BK6B_39_H      _PK_H_(0x6B, 0x39)
#define REG_SC_BK6B_3A_L      _PK_L_(0x6B, 0x3A)
#define REG_SC_BK6B_3A_H      _PK_H_(0x6B, 0x3A)
#define REG_SC_BK6B_3B_L      _PK_L_(0x6B, 0x3B)
#define REG_SC_BK6B_3B_H      _PK_H_(0x6B, 0x3B)
#define REG_SC_BK6B_3C_L      _PK_L_(0x6B, 0x3C)
#define REG_SC_BK6B_3C_H      _PK_H_(0x6B, 0x3C)
#define REG_SC_BK6B_3D_L      _PK_L_(0x6B, 0x3D)
#define REG_SC_BK6B_3D_H      _PK_H_(0x6B, 0x3D)
#define REG_SC_BK6B_3E_L      _PK_L_(0x6B, 0x3E)
#define REG_SC_BK6B_3E_H      _PK_H_(0x6B, 0x3E)
#define REG_SC_BK6B_3F_L      _PK_L_(0x6B, 0x3F)
#define REG_SC_BK6B_3F_H      _PK_H_(0x6B, 0x3F)
#define REG_SC_BK6B_40_L      _PK_L_(0x6B, 0x40)
#define REG_SC_BK6B_40_H      _PK_H_(0x6B, 0x40)
#define REG_SC_BK6B_41_L      _PK_L_(0x6B, 0x41)
#define REG_SC_BK6B_41_H      _PK_H_(0x6B, 0x41)
#define REG_SC_BK6B_42_L      _PK_L_(0x6B, 0x42)
#define REG_SC_BK6B_42_H      _PK_H_(0x6B, 0x42)
#define REG_SC_BK6B_43_L      _PK_L_(0x6B, 0x43)
#define REG_SC_BK6B_43_H      _PK_H_(0x6B, 0x43)
#define REG_SC_BK6B_44_L      _PK_L_(0x6B, 0x44)
#define REG_SC_BK6B_44_H      _PK_H_(0x6B, 0x44)
#define REG_SC_BK6B_45_L      _PK_L_(0x6B, 0x45)
#define REG_SC_BK6B_45_H      _PK_H_(0x6B, 0x45)
#define REG_SC_BK6B_46_L      _PK_L_(0x6B, 0x46)
#define REG_SC_BK6B_46_H      _PK_H_(0x6B, 0x46)
#define REG_SC_BK6B_47_L      _PK_L_(0x6B, 0x47)
#define REG_SC_BK6B_47_H      _PK_H_(0x6B, 0x47)
#define REG_SC_BK6B_48_L      _PK_L_(0x6B, 0x48)
#define REG_SC_BK6B_48_H      _PK_H_(0x6B, 0x48)
#define REG_SC_BK6B_49_L      _PK_L_(0x6B, 0x49)
#define REG_SC_BK6B_49_H      _PK_H_(0x6B, 0x49)
#define REG_SC_BK6B_4A_L      _PK_L_(0x6B, 0x4A)
#define REG_SC_BK6B_4A_H      _PK_H_(0x6B, 0x4A)
#define REG_SC_BK6B_4B_L      _PK_L_(0x6B, 0x4B)
#define REG_SC_BK6B_4B_H      _PK_H_(0x6B, 0x4B)
#define REG_SC_BK6B_4C_L      _PK_L_(0x6B, 0x4C)
#define REG_SC_BK6B_4C_H      _PK_H_(0x6B, 0x4C)
#define REG_SC_BK6B_4D_L      _PK_L_(0x6B, 0x4D)
#define REG_SC_BK6B_4D_H      _PK_H_(0x6B, 0x4D)
#define REG_SC_BK6B_4E_L      _PK_L_(0x6B, 0x4E)
#define REG_SC_BK6B_4E_H      _PK_H_(0x6B, 0x4E)
#define REG_SC_BK6B_4F_L      _PK_L_(0x6B, 0x4F)
#define REG_SC_BK6B_4F_H      _PK_H_(0x6B, 0x4F)
#define REG_SC_BK6B_50_L      _PK_L_(0x6B, 0x50)
#define REG_SC_BK6B_50_H      _PK_H_(0x6B, 0x50)
#define REG_SC_BK6B_51_L      _PK_L_(0x6B, 0x51)
#define REG_SC_BK6B_51_H      _PK_H_(0x6B, 0x51)
#define REG_SC_BK6B_52_L      _PK_L_(0x6B, 0x52)
#define REG_SC_BK6B_52_H      _PK_H_(0x6B, 0x52)
#define REG_SC_BK6B_53_L      _PK_L_(0x6B, 0x53)
#define REG_SC_BK6B_53_H      _PK_H_(0x6B, 0x53)
#define REG_SC_BK6B_54_L      _PK_L_(0x6B, 0x54)
#define REG_SC_BK6B_54_H      _PK_H_(0x6B, 0x54)
#define REG_SC_BK6B_55_L      _PK_L_(0x6B, 0x55)
#define REG_SC_BK6B_55_H      _PK_H_(0x6B, 0x55)
#define REG_SC_BK6B_56_L      _PK_L_(0x6B, 0x56)
#define REG_SC_BK6B_56_H      _PK_H_(0x6B, 0x56)
#define REG_SC_BK6B_57_L      _PK_L_(0x6B, 0x57)
#define REG_SC_BK6B_57_H      _PK_H_(0x6B, 0x57)
#define REG_SC_BK6B_58_L      _PK_L_(0x6B, 0x58)
#define REG_SC_BK6B_58_H      _PK_H_(0x6B, 0x58)
#define REG_SC_BK6B_59_L      _PK_L_(0x6B, 0x59)
#define REG_SC_BK6B_59_H      _PK_H_(0x6B, 0x59)
#define REG_SC_BK6B_5A_L      _PK_L_(0x6B, 0x5A)
#define REG_SC_BK6B_5A_H      _PK_H_(0x6B, 0x5A)
#define REG_SC_BK6B_5B_L      _PK_L_(0x6B, 0x5B)
#define REG_SC_BK6B_5B_H      _PK_H_(0x6B, 0x5B)
#define REG_SC_BK6B_5C_L      _PK_L_(0x6B, 0x5C)
#define REG_SC_BK6B_5C_H      _PK_H_(0x6B, 0x5C)
#define REG_SC_BK6B_5D_L      _PK_L_(0x6B, 0x5D)
#define REG_SC_BK6B_5D_H      _PK_H_(0x6B, 0x5D)
#define REG_SC_BK6B_5E_L      _PK_L_(0x6B, 0x5E)
#define REG_SC_BK6B_5E_H      _PK_H_(0x6B, 0x5E)
#define REG_SC_BK6B_5F_L      _PK_L_(0x6B, 0x5F)
#define REG_SC_BK6B_5F_H      _PK_H_(0x6B, 0x5F)
#define REG_SC_BK6B_60_L      _PK_L_(0x6B, 0x60)
#define REG_SC_BK6B_60_H      _PK_H_(0x6B, 0x60)
#define REG_SC_BK6B_61_L      _PK_L_(0x6B, 0x61)
#define REG_SC_BK6B_61_H      _PK_H_(0x6B, 0x61)
#define REG_SC_BK6B_62_L      _PK_L_(0x6B, 0x62)
#define REG_SC_BK6B_62_H      _PK_H_(0x6B, 0x62)
#define REG_SC_BK6B_63_L      _PK_L_(0x6B, 0x63)
#define REG_SC_BK6B_63_H      _PK_H_(0x6B, 0x63)
#define REG_SC_BK6B_64_L      _PK_L_(0x6B, 0x64)
#define REG_SC_BK6B_64_H      _PK_H_(0x6B, 0x64)
#define REG_SC_BK6B_65_L      _PK_L_(0x6B, 0x65)
#define REG_SC_BK6B_65_H      _PK_H_(0x6B, 0x65)
#define REG_SC_BK6B_66_L      _PK_L_(0x6B, 0x66)
#define REG_SC_BK6B_66_H      _PK_H_(0x6B, 0x66)
#define REG_SC_BK6B_67_L      _PK_L_(0x6B, 0x67)
#define REG_SC_BK6B_67_H      _PK_H_(0x6B, 0x67)
#define REG_SC_BK6B_68_L      _PK_L_(0x6B, 0x68)
#define REG_SC_BK6B_68_H      _PK_H_(0x6B, 0x68)
#define REG_SC_BK6B_69_L      _PK_L_(0x6B, 0x69)
#define REG_SC_BK6B_69_H      _PK_H_(0x6B, 0x69)
#define REG_SC_BK6B_6A_L      _PK_L_(0x6B, 0x6A)
#define REG_SC_BK6B_6A_H      _PK_H_(0x6B, 0x6A)
#define REG_SC_BK6B_6B_L      _PK_L_(0x6B, 0x6B)
#define REG_SC_BK6B_6B_H      _PK_H_(0x6B, 0x6B)
#define REG_SC_BK6B_6C_L      _PK_L_(0x6B, 0x6C)
#define REG_SC_BK6B_6C_H      _PK_H_(0x6B, 0x6C)
#define REG_SC_BK6B_6D_L      _PK_L_(0x6B, 0x6D)
#define REG_SC_BK6B_6D_H      _PK_H_(0x6B, 0x6D)
#define REG_SC_BK6B_6E_L      _PK_L_(0x6B, 0x6E)
#define REG_SC_BK6B_6E_H      _PK_H_(0x6B, 0x6E)
#define REG_SC_BK6B_6F_L      _PK_L_(0x6B, 0x6F)
#define REG_SC_BK6B_6F_H      _PK_H_(0x6B, 0x6F)
#define REG_SC_BK6B_70_L      _PK_L_(0x6B, 0x70)
#define REG_SC_BK6B_70_H      _PK_H_(0x6B, 0x70)
#define REG_SC_BK6B_71_L      _PK_L_(0x6B, 0x71)
#define REG_SC_BK6B_71_H      _PK_H_(0x6B, 0x71)
#define REG_SC_BK6B_72_L      _PK_L_(0x6B, 0x72)
#define REG_SC_BK6B_72_H      _PK_H_(0x6B, 0x72)
#define REG_SC_BK6B_73_L      _PK_L_(0x6B, 0x73)
#define REG_SC_BK6B_73_H      _PK_H_(0x6B, 0x73)
#define REG_SC_BK6B_74_L      _PK_L_(0x6B, 0x74)
#define REG_SC_BK6B_74_H      _PK_H_(0x6B, 0x74)
#define REG_SC_BK6B_75_L      _PK_L_(0x6B, 0x75)
#define REG_SC_BK6B_75_H      _PK_H_(0x6B, 0x75)
#define REG_SC_BK6B_76_L      _PK_L_(0x6B, 0x76)
#define REG_SC_BK6B_76_H      _PK_H_(0x6B, 0x76)
#define REG_SC_BK6B_77_L      _PK_L_(0x6B, 0x77)
#define REG_SC_BK6B_77_H      _PK_H_(0x6B, 0x77)
#define REG_SC_BK6B_78_L      _PK_L_(0x6B, 0x78)
#define REG_SC_BK6B_78_H      _PK_H_(0x6B, 0x78)
#define REG_SC_BK6B_79_L      _PK_L_(0x6B, 0x79)
#define REG_SC_BK6B_79_H      _PK_H_(0x6B, 0x79)
#define REG_SC_BK6B_7A_L      _PK_L_(0x6B, 0x7A)
#define REG_SC_BK6B_7A_H      _PK_H_(0x6B, 0x7A)
#define REG_SC_BK6B_7B_L      _PK_L_(0x6B, 0x7B)
#define REG_SC_BK6B_7B_H      _PK_H_(0x6B, 0x7B)
#define REG_SC_BK6B_7C_L      _PK_L_(0x6B, 0x7C)
#define REG_SC_BK6B_7C_H      _PK_H_(0x6B, 0x7C)
#define REG_SC_BK6B_7D_L      _PK_L_(0x6B, 0x7D)
#define REG_SC_BK6B_7D_H      _PK_H_(0x6B, 0x7D)
#define REG_SC_BK6B_7E_L      _PK_L_(0x6B, 0x7E)
#define REG_SC_BK6B_7E_H      _PK_H_(0x6B, 0x7E)
#define REG_SC_BK6B_7F_L      _PK_L_(0x6B, 0x7F)
#define REG_SC_BK6B_7F_H      _PK_H_(0x6B, 0x7F)
//----------------------------------------------
#define REG_SC_BK6C_00_L      _PK_L_(0x6C, 0x00)
#define REG_SC_BK6C_00_H      _PK_H_(0x6C, 0x00)
#define REG_SC_BK6C_01_L      _PK_L_(0x6C, 0x01)
#define REG_SC_BK6C_01_H      _PK_H_(0x6C, 0x01)
#define REG_SC_BK6C_02_L      _PK_L_(0x6C, 0x02)
#define REG_SC_BK6C_02_H      _PK_H_(0x6C, 0x02)
#define REG_SC_BK6C_03_L      _PK_L_(0x6C, 0x03)
#define REG_SC_BK6C_03_H      _PK_H_(0x6C, 0x03)
#define REG_SC_BK6C_04_L      _PK_L_(0x6C, 0x04)
#define REG_SC_BK6C_04_H      _PK_H_(0x6C, 0x04)
#define REG_SC_BK6C_05_L      _PK_L_(0x6C, 0x05)
#define REG_SC_BK6C_05_H      _PK_H_(0x6C, 0x05)
#define REG_SC_BK6C_06_L      _PK_L_(0x6C, 0x06)
#define REG_SC_BK6C_06_H      _PK_H_(0x6C, 0x06)
#define REG_SC_BK6C_07_L      _PK_L_(0x6C, 0x07)
#define REG_SC_BK6C_07_H      _PK_H_(0x6C, 0x07)
#define REG_SC_BK6C_08_L      _PK_L_(0x6C, 0x08)
#define REG_SC_BK6C_08_H      _PK_H_(0x6C, 0x08)
#define REG_SC_BK6C_09_L      _PK_L_(0x6C, 0x09)
#define REG_SC_BK6C_09_H      _PK_H_(0x6C, 0x09)
#define REG_SC_BK6C_0A_L      _PK_L_(0x6C, 0x0A)
#define REG_SC_BK6C_0A_H      _PK_H_(0x6C, 0x0A)
#define REG_SC_BK6C_0B_L      _PK_L_(0x6C, 0x0B)
#define REG_SC_BK6C_0B_H      _PK_H_(0x6C, 0x0B)
#define REG_SC_BK6C_0C_L      _PK_L_(0x6C, 0x0C)
#define REG_SC_BK6C_0C_H      _PK_H_(0x6C, 0x0C)
#define REG_SC_BK6C_0D_L      _PK_L_(0x6C, 0x0D)
#define REG_SC_BK6C_0D_H      _PK_H_(0x6C, 0x0D)
#define REG_SC_BK6C_0E_L      _PK_L_(0x6C, 0x0E)
#define REG_SC_BK6C_0E_H      _PK_H_(0x6C, 0x0E)
#define REG_SC_BK6C_0F_L      _PK_L_(0x6C, 0x0F)
#define REG_SC_BK6C_0F_H      _PK_H_(0x6C, 0x0F)
#define REG_SC_BK6C_10_L      _PK_L_(0x6C, 0x10)
#define REG_SC_BK6C_10_H      _PK_H_(0x6C, 0x10)
#define REG_SC_BK6C_11_L      _PK_L_(0x6C, 0x11)
#define REG_SC_BK6C_11_H      _PK_H_(0x6C, 0x11)
#define REG_SC_BK6C_12_L      _PK_L_(0x6C, 0x12)
#define REG_SC_BK6C_12_H      _PK_H_(0x6C, 0x12)
#define REG_SC_BK6C_13_L      _PK_L_(0x6C, 0x13)
#define REG_SC_BK6C_13_H      _PK_H_(0x6C, 0x13)
#define REG_SC_BK6C_14_L      _PK_L_(0x6C, 0x14)
#define REG_SC_BK6C_14_H      _PK_H_(0x6C, 0x14)
#define REG_SC_BK6C_15_L      _PK_L_(0x6C, 0x15)
#define REG_SC_BK6C_15_H      _PK_H_(0x6C, 0x15)
#define REG_SC_BK6C_16_L      _PK_L_(0x6C, 0x16)
#define REG_SC_BK6C_16_H      _PK_H_(0x6C, 0x16)
#define REG_SC_BK6C_17_L      _PK_L_(0x6C, 0x17)
#define REG_SC_BK6C_17_H      _PK_H_(0x6C, 0x17)
#define REG_SC_BK6C_18_L      _PK_L_(0x6C, 0x18)
#define REG_SC_BK6C_18_H      _PK_H_(0x6C, 0x18)
#define REG_SC_BK6C_19_L      _PK_L_(0x6C, 0x19)
#define REG_SC_BK6C_19_H      _PK_H_(0x6C, 0x19)
#define REG_SC_BK6C_1A_L      _PK_L_(0x6C, 0x1A)
#define REG_SC_BK6C_1A_H      _PK_H_(0x6C, 0x1A)
#define REG_SC_BK6C_1B_L      _PK_L_(0x6C, 0x1B)
#define REG_SC_BK6C_1B_H      _PK_H_(0x6C, 0x1B)
#define REG_SC_BK6C_1C_L      _PK_L_(0x6C, 0x1C)
#define REG_SC_BK6C_1C_H      _PK_H_(0x6C, 0x1C)
#define REG_SC_BK6C_1D_L      _PK_L_(0x6C, 0x1D)
#define REG_SC_BK6C_1D_H      _PK_H_(0x6C, 0x1D)
#define REG_SC_BK6C_1E_L      _PK_L_(0x6C, 0x1E)
#define REG_SC_BK6C_1E_H      _PK_H_(0x6C, 0x1E)
#define REG_SC_BK6C_1F_L      _PK_L_(0x6C, 0x1F)
#define REG_SC_BK6C_1F_H      _PK_H_(0x6C, 0x1F)
#define REG_SC_BK6C_20_L      _PK_L_(0x6C, 0x20)
#define REG_SC_BK6C_20_H      _PK_H_(0x6C, 0x20)
#define REG_SC_BK6C_21_L      _PK_L_(0x6C, 0x21)
#define REG_SC_BK6C_21_H      _PK_H_(0x6C, 0x21)
#define REG_SC_BK6C_22_L      _PK_L_(0x6C, 0x22)
#define REG_SC_BK6C_22_H      _PK_H_(0x6C, 0x22)
#define REG_SC_BK6C_23_L      _PK_L_(0x6C, 0x23)
#define REG_SC_BK6C_23_H      _PK_H_(0x6C, 0x23)
#define REG_SC_BK6C_24_L      _PK_L_(0x6C, 0x24)
#define REG_SC_BK6C_24_H      _PK_H_(0x6C, 0x24)
#define REG_SC_BK6C_25_L      _PK_L_(0x6C, 0x25)
#define REG_SC_BK6C_25_H      _PK_H_(0x6C, 0x25)
#define REG_SC_BK6C_26_L      _PK_L_(0x6C, 0x26)
#define REG_SC_BK6C_26_H      _PK_H_(0x6C, 0x26)
#define REG_SC_BK6C_27_L      _PK_L_(0x6C, 0x27)
#define REG_SC_BK6C_27_H      _PK_H_(0x6C, 0x27)
#define REG_SC_BK6C_28_L      _PK_L_(0x6C, 0x28)
#define REG_SC_BK6C_28_H      _PK_H_(0x6C, 0x28)
#define REG_SC_BK6C_29_L      _PK_L_(0x6C, 0x29)
#define REG_SC_BK6C_29_H      _PK_H_(0x6C, 0x29)
#define REG_SC_BK6C_2A_L      _PK_L_(0x6C, 0x2A)
#define REG_SC_BK6C_2A_H      _PK_H_(0x6C, 0x2A)
#define REG_SC_BK6C_2B_L      _PK_L_(0x6C, 0x2B)
#define REG_SC_BK6C_2B_H      _PK_H_(0x6C, 0x2B)
#define REG_SC_BK6C_2C_L      _PK_L_(0x6C, 0x2C)
#define REG_SC_BK6C_2C_H      _PK_H_(0x6C, 0x2C)
#define REG_SC_BK6C_2D_L      _PK_L_(0x6C, 0x2D)
#define REG_SC_BK6C_2D_H      _PK_H_(0x6C, 0x2D)
#define REG_SC_BK6C_2E_L      _PK_L_(0x6C, 0x2E)
#define REG_SC_BK6C_2E_H      _PK_H_(0x6C, 0x2E)
#define REG_SC_BK6C_2F_L      _PK_L_(0x6C, 0x2F)
#define REG_SC_BK6C_2F_H      _PK_H_(0x6C, 0x2F)
#define REG_SC_BK6C_30_L      _PK_L_(0x6C, 0x30)
#define REG_SC_BK6C_30_H      _PK_H_(0x6C, 0x30)
#define REG_SC_BK6C_31_L      _PK_L_(0x6C, 0x31)
#define REG_SC_BK6C_31_H      _PK_H_(0x6C, 0x31)
#define REG_SC_BK6C_32_L      _PK_L_(0x6C, 0x32)
#define REG_SC_BK6C_32_H      _PK_H_(0x6C, 0x32)
#define REG_SC_BK6C_33_L      _PK_L_(0x6C, 0x33)
#define REG_SC_BK6C_33_H      _PK_H_(0x6C, 0x33)
#define REG_SC_BK6C_34_L      _PK_L_(0x6C, 0x34)
#define REG_SC_BK6C_34_H      _PK_H_(0x6C, 0x34)
#define REG_SC_BK6C_35_L      _PK_L_(0x6C, 0x35)
#define REG_SC_BK6C_35_H      _PK_H_(0x6C, 0x35)
#define REG_SC_BK6C_36_L      _PK_L_(0x6C, 0x36)
#define REG_SC_BK6C_36_H      _PK_H_(0x6C, 0x36)
#define REG_SC_BK6C_37_L      _PK_L_(0x6C, 0x37)
#define REG_SC_BK6C_37_H      _PK_H_(0x6C, 0x37)
#define REG_SC_BK6C_38_L      _PK_L_(0x6C, 0x38)
#define REG_SC_BK6C_38_H      _PK_H_(0x6C, 0x38)
#define REG_SC_BK6C_39_L      _PK_L_(0x6C, 0x39)
#define REG_SC_BK6C_39_H      _PK_H_(0x6C, 0x39)
#define REG_SC_BK6C_3A_L      _PK_L_(0x6C, 0x3A)
#define REG_SC_BK6C_3A_H      _PK_H_(0x6C, 0x3A)
#define REG_SC_BK6C_3B_L      _PK_L_(0x6C, 0x3B)
#define REG_SC_BK6C_3B_H      _PK_H_(0x6C, 0x3B)
#define REG_SC_BK6C_3C_L      _PK_L_(0x6C, 0x3C)
#define REG_SC_BK6C_3C_H      _PK_H_(0x6C, 0x3C)
#define REG_SC_BK6C_3D_L      _PK_L_(0x6C, 0x3D)
#define REG_SC_BK6C_3D_H      _PK_H_(0x6C, 0x3D)
#define REG_SC_BK6C_3E_L      _PK_L_(0x6C, 0x3E)
#define REG_SC_BK6C_3E_H      _PK_H_(0x6C, 0x3E)
#define REG_SC_BK6C_3F_L      _PK_L_(0x6C, 0x3F)
#define REG_SC_BK6C_3F_H      _PK_H_(0x6C, 0x3F)
#define REG_SC_BK6C_40_L      _PK_L_(0x6C, 0x40)
#define REG_SC_BK6C_40_H      _PK_H_(0x6C, 0x40)
#define REG_SC_BK6C_41_L      _PK_L_(0x6C, 0x41)
#define REG_SC_BK6C_41_H      _PK_H_(0x6C, 0x41)
#define REG_SC_BK6C_42_L      _PK_L_(0x6C, 0x42)
#define REG_SC_BK6C_42_H      _PK_H_(0x6C, 0x42)
#define REG_SC_BK6C_43_L      _PK_L_(0x6C, 0x43)
#define REG_SC_BK6C_43_H      _PK_H_(0x6C, 0x43)
#define REG_SC_BK6C_44_L      _PK_L_(0x6C, 0x44)
#define REG_SC_BK6C_44_H      _PK_H_(0x6C, 0x44)
#define REG_SC_BK6C_45_L      _PK_L_(0x6C, 0x45)
#define REG_SC_BK6C_45_H      _PK_H_(0x6C, 0x45)
#define REG_SC_BK6C_46_L      _PK_L_(0x6C, 0x46)
#define REG_SC_BK6C_46_H      _PK_H_(0x6C, 0x46)
#define REG_SC_BK6C_47_L      _PK_L_(0x6C, 0x47)
#define REG_SC_BK6C_47_H      _PK_H_(0x6C, 0x47)
#define REG_SC_BK6C_48_L      _PK_L_(0x6C, 0x48)
#define REG_SC_BK6C_48_H      _PK_H_(0x6C, 0x48)
#define REG_SC_BK6C_49_L      _PK_L_(0x6C, 0x49)
#define REG_SC_BK6C_49_H      _PK_H_(0x6C, 0x49)
#define REG_SC_BK6C_4A_L      _PK_L_(0x6C, 0x4A)
#define REG_SC_BK6C_4A_H      _PK_H_(0x6C, 0x4A)
#define REG_SC_BK6C_4B_L      _PK_L_(0x6C, 0x4B)
#define REG_SC_BK6C_4B_H      _PK_H_(0x6C, 0x4B)
#define REG_SC_BK6C_4C_L      _PK_L_(0x6C, 0x4C)
#define REG_SC_BK6C_4C_H      _PK_H_(0x6C, 0x4C)
#define REG_SC_BK6C_4D_L      _PK_L_(0x6C, 0x4D)
#define REG_SC_BK6C_4D_H      _PK_H_(0x6C, 0x4D)
#define REG_SC_BK6C_4E_L      _PK_L_(0x6C, 0x4E)
#define REG_SC_BK6C_4E_H      _PK_H_(0x6C, 0x4E)
#define REG_SC_BK6C_4F_L      _PK_L_(0x6C, 0x4F)
#define REG_SC_BK6C_4F_H      _PK_H_(0x6C, 0x4F)
#define REG_SC_BK6C_50_L      _PK_L_(0x6C, 0x50)
#define REG_SC_BK6C_50_H      _PK_H_(0x6C, 0x50)
#define REG_SC_BK6C_51_L      _PK_L_(0x6C, 0x51)
#define REG_SC_BK6C_51_H      _PK_H_(0x6C, 0x51)
#define REG_SC_BK6C_52_L      _PK_L_(0x6C, 0x52)
#define REG_SC_BK6C_52_H      _PK_H_(0x6C, 0x52)
#define REG_SC_BK6C_53_L      _PK_L_(0x6C, 0x53)
#define REG_SC_BK6C_53_H      _PK_H_(0x6C, 0x53)
#define REG_SC_BK6C_54_L      _PK_L_(0x6C, 0x54)
#define REG_SC_BK6C_54_H      _PK_H_(0x6C, 0x54)
#define REG_SC_BK6C_55_L      _PK_L_(0x6C, 0x55)
#define REG_SC_BK6C_55_H      _PK_H_(0x6C, 0x55)
#define REG_SC_BK6C_56_L      _PK_L_(0x6C, 0x56)
#define REG_SC_BK6C_56_H      _PK_H_(0x6C, 0x56)
#define REG_SC_BK6C_57_L      _PK_L_(0x6C, 0x57)
#define REG_SC_BK6C_57_H      _PK_H_(0x6C, 0x57)
#define REG_SC_BK6C_58_L      _PK_L_(0x6C, 0x58)
#define REG_SC_BK6C_58_H      _PK_H_(0x6C, 0x58)
#define REG_SC_BK6C_59_L      _PK_L_(0x6C, 0x59)
#define REG_SC_BK6C_59_H      _PK_H_(0x6C, 0x59)
#define REG_SC_BK6C_5A_L      _PK_L_(0x6C, 0x5A)
#define REG_SC_BK6C_5A_H      _PK_H_(0x6C, 0x5A)
#define REG_SC_BK6C_5B_L      _PK_L_(0x6C, 0x5B)
#define REG_SC_BK6C_5B_H      _PK_H_(0x6C, 0x5B)
#define REG_SC_BK6C_5C_L      _PK_L_(0x6C, 0x5C)
#define REG_SC_BK6C_5C_H      _PK_H_(0x6C, 0x5C)
#define REG_SC_BK6C_5D_L      _PK_L_(0x6C, 0x5D)
#define REG_SC_BK6C_5D_H      _PK_H_(0x6C, 0x5D)
#define REG_SC_BK6C_5E_L      _PK_L_(0x6C, 0x5E)
#define REG_SC_BK6C_5E_H      _PK_H_(0x6C, 0x5E)
#define REG_SC_BK6C_5F_L      _PK_L_(0x6C, 0x5F)
#define REG_SC_BK6C_5F_H      _PK_H_(0x6C, 0x5F)
#define REG_SC_BK6C_60_L      _PK_L_(0x6C, 0x60)
#define REG_SC_BK6C_60_H      _PK_H_(0x6C, 0x60)
#define REG_SC_BK6C_61_L      _PK_L_(0x6C, 0x61)
#define REG_SC_BK6C_61_H      _PK_H_(0x6C, 0x61)
#define REG_SC_BK6C_62_L      _PK_L_(0x6C, 0x62)
#define REG_SC_BK6C_62_H      _PK_H_(0x6C, 0x62)
#define REG_SC_BK6C_63_L      _PK_L_(0x6C, 0x63)
#define REG_SC_BK6C_63_H      _PK_H_(0x6C, 0x63)
#define REG_SC_BK6C_64_L      _PK_L_(0x6C, 0x64)
#define REG_SC_BK6C_64_H      _PK_H_(0x6C, 0x64)
#define REG_SC_BK6C_65_L      _PK_L_(0x6C, 0x65)
#define REG_SC_BK6C_65_H      _PK_H_(0x6C, 0x65)
#define REG_SC_BK6C_66_L      _PK_L_(0x6C, 0x66)
#define REG_SC_BK6C_66_H      _PK_H_(0x6C, 0x66)
#define REG_SC_BK6C_67_L      _PK_L_(0x6C, 0x67)
#define REG_SC_BK6C_67_H      _PK_H_(0x6C, 0x67)
#define REG_SC_BK6C_68_L      _PK_L_(0x6C, 0x68)
#define REG_SC_BK6C_68_H      _PK_H_(0x6C, 0x68)
#define REG_SC_BK6C_69_L      _PK_L_(0x6C, 0x69)
#define REG_SC_BK6C_69_H      _PK_H_(0x6C, 0x69)
#define REG_SC_BK6C_6A_L      _PK_L_(0x6C, 0x6A)
#define REG_SC_BK6C_6A_H      _PK_H_(0x6C, 0x6A)
#define REG_SC_BK6C_6B_L      _PK_L_(0x6C, 0x6B)
#define REG_SC_BK6C_6B_H      _PK_H_(0x6C, 0x6B)
#define REG_SC_BK6C_6C_L      _PK_L_(0x6C, 0x6C)
#define REG_SC_BK6C_6C_H      _PK_H_(0x6C, 0x6C)
#define REG_SC_BK6C_6D_L      _PK_L_(0x6C, 0x6D)
#define REG_SC_BK6C_6D_H      _PK_H_(0x6C, 0x6D)
#define REG_SC_BK6C_6E_L      _PK_L_(0x6C, 0x6E)
#define REG_SC_BK6C_6E_H      _PK_H_(0x6C, 0x6E)
#define REG_SC_BK6C_6F_L      _PK_L_(0x6C, 0x6F)
#define REG_SC_BK6C_6F_H      _PK_H_(0x6C, 0x6F)
#define REG_SC_BK6C_70_L      _PK_L_(0x6C, 0x70)
#define REG_SC_BK6C_70_H      _PK_H_(0x6C, 0x70)
#define REG_SC_BK6C_71_L      _PK_L_(0x6C, 0x71)
#define REG_SC_BK6C_71_H      _PK_H_(0x6C, 0x71)
#define REG_SC_BK6C_72_L      _PK_L_(0x6C, 0x72)
#define REG_SC_BK6C_72_H      _PK_H_(0x6C, 0x72)
#define REG_SC_BK6C_73_L      _PK_L_(0x6C, 0x73)
#define REG_SC_BK6C_73_H      _PK_H_(0x6C, 0x73)
#define REG_SC_BK6C_74_L      _PK_L_(0x6C, 0x74)
#define REG_SC_BK6C_74_H      _PK_H_(0x6C, 0x74)
#define REG_SC_BK6C_75_L      _PK_L_(0x6C, 0x75)
#define REG_SC_BK6C_75_H      _PK_H_(0x6C, 0x75)
#define REG_SC_BK6C_76_L      _PK_L_(0x6C, 0x76)
#define REG_SC_BK6C_76_H      _PK_H_(0x6C, 0x76)
#define REG_SC_BK6C_77_L      _PK_L_(0x6C, 0x77)
#define REG_SC_BK6C_77_H      _PK_H_(0x6C, 0x77)
#define REG_SC_BK6C_78_L      _PK_L_(0x6C, 0x78)
#define REG_SC_BK6C_78_H      _PK_H_(0x6C, 0x78)
#define REG_SC_BK6C_79_L      _PK_L_(0x6C, 0x79)
#define REG_SC_BK6C_79_H      _PK_H_(0x6C, 0x79)
#define REG_SC_BK6C_7A_L      _PK_L_(0x6C, 0x7A)
#define REG_SC_BK6C_7A_H      _PK_H_(0x6C, 0x7A)
#define REG_SC_BK6C_7B_L      _PK_L_(0x6C, 0x7B)
#define REG_SC_BK6C_7B_H      _PK_H_(0x6C, 0x7B)
#define REG_SC_BK6C_7C_L      _PK_L_(0x6C, 0x7C)
#define REG_SC_BK6C_7C_H      _PK_H_(0x6C, 0x7C)
#define REG_SC_BK6C_7D_L      _PK_L_(0x6C, 0x7D)
#define REG_SC_BK6C_7D_H      _PK_H_(0x6C, 0x7D)
#define REG_SC_BK6C_7E_L      _PK_L_(0x6C, 0x7E)
#define REG_SC_BK6C_7E_H      _PK_H_(0x6C, 0x7E)
#define REG_SC_BK6C_7F_L      _PK_L_(0x6C, 0x7F)
#define REG_SC_BK6C_7F_H      _PK_H_(0x6C, 0x7F)
//----------------------------------------------
#define REG_SC_BK6E_00_L      _PK_L_(0x6E, 0x00)
#define REG_SC_BK6E_00_H      _PK_H_(0x6E, 0x00)
#define REG_SC_BK6E_01_L      _PK_L_(0x6E, 0x01)
#define REG_SC_BK6E_01_H      _PK_H_(0x6E, 0x01)
#define REG_SC_BK6E_02_L      _PK_L_(0x6E, 0x02)
#define REG_SC_BK6E_02_H      _PK_H_(0x6E, 0x02)
#define REG_SC_BK6E_03_L      _PK_L_(0x6E, 0x03)
#define REG_SC_BK6E_03_H      _PK_H_(0x6E, 0x03)
#define REG_SC_BK6E_04_L      _PK_L_(0x6E, 0x04)
#define REG_SC_BK6E_04_H      _PK_H_(0x6E, 0x04)
#define REG_SC_BK6E_05_L      _PK_L_(0x6E, 0x05)
#define REG_SC_BK6E_05_H      _PK_H_(0x6E, 0x05)
#define REG_SC_BK6E_06_L      _PK_L_(0x6E, 0x06)
#define REG_SC_BK6E_06_H      _PK_H_(0x6E, 0x06)
#define REG_SC_BK6E_07_L      _PK_L_(0x6E, 0x07)
#define REG_SC_BK6E_07_H      _PK_H_(0x6E, 0x07)
#define REG_SC_BK6E_08_L      _PK_L_(0x6E, 0x08)
#define REG_SC_BK6E_08_H      _PK_H_(0x6E, 0x08)
#define REG_SC_BK6E_09_L      _PK_L_(0x6E, 0x09)
#define REG_SC_BK6E_09_H      _PK_H_(0x6E, 0x09)
#define REG_SC_BK6E_0A_L      _PK_L_(0x6E, 0x0A)
#define REG_SC_BK6E_0A_H      _PK_H_(0x6E, 0x0A)
#define REG_SC_BK6E_0B_L      _PK_L_(0x6E, 0x0B)
#define REG_SC_BK6E_0B_H      _PK_H_(0x6E, 0x0B)
#define REG_SC_BK6E_0C_L      _PK_L_(0x6E, 0x0C)
#define REG_SC_BK6E_0C_H      _PK_H_(0x6E, 0x0C)
#define REG_SC_BK6E_0D_L      _PK_L_(0x6E, 0x0D)
#define REG_SC_BK6E_0D_H      _PK_H_(0x6E, 0x0D)
#define REG_SC_BK6E_0E_L      _PK_L_(0x6E, 0x0E)
#define REG_SC_BK6E_0E_H      _PK_H_(0x6E, 0x0E)
#define REG_SC_BK6E_0F_L      _PK_L_(0x6E, 0x0F)
#define REG_SC_BK6E_0F_H      _PK_H_(0x6E, 0x0F)
#define REG_SC_BK6E_10_L      _PK_L_(0x6E, 0x10)
#define REG_SC_BK6E_10_H      _PK_H_(0x6E, 0x10)
#define REG_SC_BK6E_11_L      _PK_L_(0x6E, 0x11)
#define REG_SC_BK6E_11_H      _PK_H_(0x6E, 0x11)
#define REG_SC_BK6E_12_L      _PK_L_(0x6E, 0x12)
#define REG_SC_BK6E_12_H      _PK_H_(0x6E, 0x12)
#define REG_SC_BK6E_13_L      _PK_L_(0x6E, 0x13)
#define REG_SC_BK6E_13_H      _PK_H_(0x6E, 0x13)
#define REG_SC_BK6E_14_L      _PK_L_(0x6E, 0x14)
#define REG_SC_BK6E_14_H      _PK_H_(0x6E, 0x14)
#define REG_SC_BK6E_15_L      _PK_L_(0x6E, 0x15)
#define REG_SC_BK6E_15_H      _PK_H_(0x6E, 0x15)
#define REG_SC_BK6E_16_L      _PK_L_(0x6E, 0x16)
#define REG_SC_BK6E_16_H      _PK_H_(0x6E, 0x16)
#define REG_SC_BK6E_17_L      _PK_L_(0x6E, 0x17)
#define REG_SC_BK6E_17_H      _PK_H_(0x6E, 0x17)
#define REG_SC_BK6E_18_L      _PK_L_(0x6E, 0x18)
#define REG_SC_BK6E_18_H      _PK_H_(0x6E, 0x18)
#define REG_SC_BK6E_19_L      _PK_L_(0x6E, 0x19)
#define REG_SC_BK6E_19_H      _PK_H_(0x6E, 0x19)
#define REG_SC_BK6E_1A_L      _PK_L_(0x6E, 0x1A)
#define REG_SC_BK6E_1A_H      _PK_H_(0x6E, 0x1A)
#define REG_SC_BK6E_1B_L      _PK_L_(0x6E, 0x1B)
#define REG_SC_BK6E_1B_H      _PK_H_(0x6E, 0x1B)
#define REG_SC_BK6E_1C_L      _PK_L_(0x6E, 0x1C)
#define REG_SC_BK6E_1C_H      _PK_H_(0x6E, 0x1C)
#define REG_SC_BK6E_1D_L      _PK_L_(0x6E, 0x1D)
#define REG_SC_BK6E_1D_H      _PK_H_(0x6E, 0x1D)
#define REG_SC_BK6E_1E_L      _PK_L_(0x6E, 0x1E)
#define REG_SC_BK6E_1E_H      _PK_H_(0x6E, 0x1E)
#define REG_SC_BK6E_1F_L      _PK_L_(0x6E, 0x1F)
#define REG_SC_BK6E_1F_H      _PK_H_(0x6E, 0x1F)
#define REG_SC_BK6E_20_L      _PK_L_(0x6E, 0x20)
#define REG_SC_BK6E_20_H      _PK_H_(0x6E, 0x20)
#define REG_SC_BK6E_21_L      _PK_L_(0x6E, 0x21)
#define REG_SC_BK6E_21_H      _PK_H_(0x6E, 0x21)
#define REG_SC_BK6E_22_L      _PK_L_(0x6E, 0x22)
#define REG_SC_BK6E_22_H      _PK_H_(0x6E, 0x22)
#define REG_SC_BK6E_23_L      _PK_L_(0x6E, 0x23)
#define REG_SC_BK6E_23_H      _PK_H_(0x6E, 0x23)
#define REG_SC_BK6E_24_L      _PK_L_(0x6E, 0x24)
#define REG_SC_BK6E_24_H      _PK_H_(0x6E, 0x24)
#define REG_SC_BK6E_25_L      _PK_L_(0x6E, 0x25)
#define REG_SC_BK6E_25_H      _PK_H_(0x6E, 0x25)
#define REG_SC_BK6E_26_L      _PK_L_(0x6E, 0x26)
#define REG_SC_BK6E_26_H      _PK_H_(0x6E, 0x26)
#define REG_SC_BK6E_27_L      _PK_L_(0x6E, 0x27)
#define REG_SC_BK6E_27_H      _PK_H_(0x6E, 0x27)
#define REG_SC_BK6E_28_L      _PK_L_(0x6E, 0x28)
#define REG_SC_BK6E_28_H      _PK_H_(0x6E, 0x28)
#define REG_SC_BK6E_29_L      _PK_L_(0x6E, 0x29)
#define REG_SC_BK6E_29_H      _PK_H_(0x6E, 0x29)
#define REG_SC_BK6E_2A_L      _PK_L_(0x6E, 0x2A)
#define REG_SC_BK6E_2A_H      _PK_H_(0x6E, 0x2A)
#define REG_SC_BK6E_2B_L      _PK_L_(0x6E, 0x2B)
#define REG_SC_BK6E_2B_H      _PK_H_(0x6E, 0x2B)
#define REG_SC_BK6E_2C_L      _PK_L_(0x6E, 0x2C)
#define REG_SC_BK6E_2C_H      _PK_H_(0x6E, 0x2C)
#define REG_SC_BK6E_2D_L      _PK_L_(0x6E, 0x2D)
#define REG_SC_BK6E_2D_H      _PK_H_(0x6E, 0x2D)
#define REG_SC_BK6E_2E_L      _PK_L_(0x6E, 0x2E)
#define REG_SC_BK6E_2E_H      _PK_H_(0x6E, 0x2E)
#define REG_SC_BK6E_2F_L      _PK_L_(0x6E, 0x2F)
#define REG_SC_BK6E_2F_H      _PK_H_(0x6E, 0x2F)
#define REG_SC_BK6E_30_L      _PK_L_(0x6E, 0x30)
#define REG_SC_BK6E_30_H      _PK_H_(0x6E, 0x30)
#define REG_SC_BK6E_31_L      _PK_L_(0x6E, 0x31)
#define REG_SC_BK6E_31_H      _PK_H_(0x6E, 0x31)
#define REG_SC_BK6E_32_L      _PK_L_(0x6E, 0x32)
#define REG_SC_BK6E_32_H      _PK_H_(0x6E, 0x32)
#define REG_SC_BK6E_33_L      _PK_L_(0x6E, 0x33)
#define REG_SC_BK6E_33_H      _PK_H_(0x6E, 0x33)
#define REG_SC_BK6E_34_L      _PK_L_(0x6E, 0x34)
#define REG_SC_BK6E_34_H      _PK_H_(0x6E, 0x34)
#define REG_SC_BK6E_35_L      _PK_L_(0x6E, 0x35)
#define REG_SC_BK6E_35_H      _PK_H_(0x6E, 0x35)
#define REG_SC_BK6E_36_L      _PK_L_(0x6E, 0x36)
#define REG_SC_BK6E_36_H      _PK_H_(0x6E, 0x36)
#define REG_SC_BK6E_37_L      _PK_L_(0x6E, 0x37)
#define REG_SC_BK6E_37_H      _PK_H_(0x6E, 0x37)
#define REG_SC_BK6E_38_L      _PK_L_(0x6E, 0x38)
#define REG_SC_BK6E_38_H      _PK_H_(0x6E, 0x38)
#define REG_SC_BK6E_39_L      _PK_L_(0x6E, 0x39)
#define REG_SC_BK6E_39_H      _PK_H_(0x6E, 0x39)
#define REG_SC_BK6E_3A_L      _PK_L_(0x6E, 0x3A)
#define REG_SC_BK6E_3A_H      _PK_H_(0x6E, 0x3A)
#define REG_SC_BK6E_3B_L      _PK_L_(0x6E, 0x3B)
#define REG_SC_BK6E_3B_H      _PK_H_(0x6E, 0x3B)
#define REG_SC_BK6E_3C_L      _PK_L_(0x6E, 0x3C)
#define REG_SC_BK6E_3C_H      _PK_H_(0x6E, 0x3C)
#define REG_SC_BK6E_3D_L      _PK_L_(0x6E, 0x3D)
#define REG_SC_BK6E_3D_H      _PK_H_(0x6E, 0x3D)
#define REG_SC_BK6E_3E_L      _PK_L_(0x6E, 0x3E)
#define REG_SC_BK6E_3E_H      _PK_H_(0x6E, 0x3E)
#define REG_SC_BK6E_3F_L      _PK_L_(0x6E, 0x3F)
#define REG_SC_BK6E_3F_H      _PK_H_(0x6E, 0x3F)
#define REG_SC_BK6E_40_L      _PK_L_(0x6E, 0x40)
#define REG_SC_BK6E_40_H      _PK_H_(0x6E, 0x40)
#define REG_SC_BK6E_41_L      _PK_L_(0x6E, 0x41)
#define REG_SC_BK6E_41_H      _PK_H_(0x6E, 0x41)
#define REG_SC_BK6E_42_L      _PK_L_(0x6E, 0x42)
#define REG_SC_BK6E_42_H      _PK_H_(0x6E, 0x42)
#define REG_SC_BK6E_43_L      _PK_L_(0x6E, 0x43)
#define REG_SC_BK6E_43_H      _PK_H_(0x6E, 0x43)
#define REG_SC_BK6E_44_L      _PK_L_(0x6E, 0x44)
#define REG_SC_BK6E_44_H      _PK_H_(0x6E, 0x44)
#define REG_SC_BK6E_45_L      _PK_L_(0x6E, 0x45)
#define REG_SC_BK6E_45_H      _PK_H_(0x6E, 0x45)
#define REG_SC_BK6E_46_L      _PK_L_(0x6E, 0x46)
#define REG_SC_BK6E_46_H      _PK_H_(0x6E, 0x46)
#define REG_SC_BK6E_47_L      _PK_L_(0x6E, 0x47)
#define REG_SC_BK6E_47_H      _PK_H_(0x6E, 0x47)
#define REG_SC_BK6E_48_L      _PK_L_(0x6E, 0x48)
#define REG_SC_BK6E_48_H      _PK_H_(0x6E, 0x48)
#define REG_SC_BK6E_49_L      _PK_L_(0x6E, 0x49)
#define REG_SC_BK6E_49_H      _PK_H_(0x6E, 0x49)
#define REG_SC_BK6E_4A_L      _PK_L_(0x6E, 0x4A)
#define REG_SC_BK6E_4A_H      _PK_H_(0x6E, 0x4A)
#define REG_SC_BK6E_4B_L      _PK_L_(0x6E, 0x4B)
#define REG_SC_BK6E_4B_H      _PK_H_(0x6E, 0x4B)
#define REG_SC_BK6E_4C_L      _PK_L_(0x6E, 0x4C)
#define REG_SC_BK6E_4C_H      _PK_H_(0x6E, 0x4C)
#define REG_SC_BK6E_4D_L      _PK_L_(0x6E, 0x4D)
#define REG_SC_BK6E_4D_H      _PK_H_(0x6E, 0x4D)
#define REG_SC_BK6E_4E_L      _PK_L_(0x6E, 0x4E)
#define REG_SC_BK6E_4E_H      _PK_H_(0x6E, 0x4E)
#define REG_SC_BK6E_4F_L      _PK_L_(0x6E, 0x4F)
#define REG_SC_BK6E_4F_H      _PK_H_(0x6E, 0x4F)
#define REG_SC_BK6E_50_L      _PK_L_(0x6E, 0x50)
#define REG_SC_BK6E_50_H      _PK_H_(0x6E, 0x50)
#define REG_SC_BK6E_51_L      _PK_L_(0x6E, 0x51)
#define REG_SC_BK6E_51_H      _PK_H_(0x6E, 0x51)
#define REG_SC_BK6E_52_L      _PK_L_(0x6E, 0x52)
#define REG_SC_BK6E_52_H      _PK_H_(0x6E, 0x52)
#define REG_SC_BK6E_53_L      _PK_L_(0x6E, 0x53)
#define REG_SC_BK6E_53_H      _PK_H_(0x6E, 0x53)
#define REG_SC_BK6E_54_L      _PK_L_(0x6E, 0x54)
#define REG_SC_BK6E_54_H      _PK_H_(0x6E, 0x54)
#define REG_SC_BK6E_55_L      _PK_L_(0x6E, 0x55)
#define REG_SC_BK6E_55_H      _PK_H_(0x6E, 0x55)
#define REG_SC_BK6E_56_L      _PK_L_(0x6E, 0x56)
#define REG_SC_BK6E_56_H      _PK_H_(0x6E, 0x56)
#define REG_SC_BK6E_57_L      _PK_L_(0x6E, 0x57)
#define REG_SC_BK6E_57_H      _PK_H_(0x6E, 0x57)
#define REG_SC_BK6E_58_L      _PK_L_(0x6E, 0x58)
#define REG_SC_BK6E_58_H      _PK_H_(0x6E, 0x58)
#define REG_SC_BK6E_59_L      _PK_L_(0x6E, 0x59)
#define REG_SC_BK6E_59_H      _PK_H_(0x6E, 0x59)
#define REG_SC_BK6E_5A_L      _PK_L_(0x6E, 0x5A)
#define REG_SC_BK6E_5A_H      _PK_H_(0x6E, 0x5A)
#define REG_SC_BK6E_5B_L      _PK_L_(0x6E, 0x5B)
#define REG_SC_BK6E_5B_H      _PK_H_(0x6E, 0x5B)
#define REG_SC_BK6E_5C_L      _PK_L_(0x6E, 0x5C)
#define REG_SC_BK6E_5C_H      _PK_H_(0x6E, 0x5C)
#define REG_SC_BK6E_5D_L      _PK_L_(0x6E, 0x5D)
#define REG_SC_BK6E_5D_H      _PK_H_(0x6E, 0x5D)
#define REG_SC_BK6E_5E_L      _PK_L_(0x6E, 0x5E)
#define REG_SC_BK6E_5E_H      _PK_H_(0x6E, 0x5E)
#define REG_SC_BK6E_5F_L      _PK_L_(0x6E, 0x5F)
#define REG_SC_BK6E_5F_H      _PK_H_(0x6E, 0x5F)
#define REG_SC_BK6E_60_L      _PK_L_(0x6E, 0x60)
#define REG_SC_BK6E_60_H      _PK_H_(0x6E, 0x60)
#define REG_SC_BK6E_61_L      _PK_L_(0x6E, 0x61)
#define REG_SC_BK6E_61_H      _PK_H_(0x6E, 0x61)
#define REG_SC_BK6E_62_L      _PK_L_(0x6E, 0x62)
#define REG_SC_BK6E_62_H      _PK_H_(0x6E, 0x62)
#define REG_SC_BK6E_63_L      _PK_L_(0x6E, 0x63)
#define REG_SC_BK6E_63_H      _PK_H_(0x6E, 0x63)
#define REG_SC_BK6E_64_L      _PK_L_(0x6E, 0x64)
#define REG_SC_BK6E_64_H      _PK_H_(0x6E, 0x64)
#define REG_SC_BK6E_65_L      _PK_L_(0x6E, 0x65)
#define REG_SC_BK6E_65_H      _PK_H_(0x6E, 0x65)
#define REG_SC_BK6E_66_L      _PK_L_(0x6E, 0x66)
#define REG_SC_BK6E_66_H      _PK_H_(0x6E, 0x66)
#define REG_SC_BK6E_67_L      _PK_L_(0x6E, 0x67)
#define REG_SC_BK6E_67_H      _PK_H_(0x6E, 0x67)
#define REG_SC_BK6E_68_L      _PK_L_(0x6E, 0x68)
#define REG_SC_BK6E_68_H      _PK_H_(0x6E, 0x68)
#define REG_SC_BK6E_69_L      _PK_L_(0x6E, 0x69)
#define REG_SC_BK6E_69_H      _PK_H_(0x6E, 0x69)
#define REG_SC_BK6E_6A_L      _PK_L_(0x6E, 0x6A)
#define REG_SC_BK6E_6A_H      _PK_H_(0x6E, 0x6A)
#define REG_SC_BK6E_6B_L      _PK_L_(0x6E, 0x6B)
#define REG_SC_BK6E_6B_H      _PK_H_(0x6E, 0x6B)
#define REG_SC_BK6E_6C_L      _PK_L_(0x6E, 0x6C)
#define REG_SC_BK6E_6C_H      _PK_H_(0x6E, 0x6C)
#define REG_SC_BK6E_6D_L      _PK_L_(0x6E, 0x6D)
#define REG_SC_BK6E_6D_H      _PK_H_(0x6E, 0x6D)
#define REG_SC_BK6E_6E_L      _PK_L_(0x6E, 0x6E)
#define REG_SC_BK6E_6E_H      _PK_H_(0x6E, 0x6E)
#define REG_SC_BK6E_6F_L      _PK_L_(0x6E, 0x6F)
#define REG_SC_BK6E_6F_H      _PK_H_(0x6E, 0x6F)
#define REG_SC_BK6E_70_L      _PK_L_(0x6E, 0x70)
#define REG_SC_BK6E_70_H      _PK_H_(0x6E, 0x70)
#define REG_SC_BK6E_71_L      _PK_L_(0x6E, 0x71)
#define REG_SC_BK6E_71_H      _PK_H_(0x6E, 0x71)
#define REG_SC_BK6E_72_L      _PK_L_(0x6E, 0x72)
#define REG_SC_BK6E_72_H      _PK_H_(0x6E, 0x72)
#define REG_SC_BK6E_73_L      _PK_L_(0x6E, 0x73)
#define REG_SC_BK6E_73_H      _PK_H_(0x6E, 0x73)
#define REG_SC_BK6E_74_L      _PK_L_(0x6E, 0x74)
#define REG_SC_BK6E_74_H      _PK_H_(0x6E, 0x74)
#define REG_SC_BK6E_75_L      _PK_L_(0x6E, 0x75)
#define REG_SC_BK6E_75_H      _PK_H_(0x6E, 0x75)
#define REG_SC_BK6E_76_L      _PK_L_(0x6E, 0x76)
#define REG_SC_BK6E_76_H      _PK_H_(0x6E, 0x76)
#define REG_SC_BK6E_77_L      _PK_L_(0x6E, 0x77)
#define REG_SC_BK6E_77_H      _PK_H_(0x6E, 0x77)
#define REG_SC_BK6E_78_L      _PK_L_(0x6E, 0x78)
#define REG_SC_BK6E_78_H      _PK_H_(0x6E, 0x78)
#define REG_SC_BK6E_79_L      _PK_L_(0x6E, 0x79)
#define REG_SC_BK6E_79_H      _PK_H_(0x6E, 0x79)
#define REG_SC_BK6E_7A_L      _PK_L_(0x6E, 0x7A)
#define REG_SC_BK6E_7A_H      _PK_H_(0x6E, 0x7A)
#define REG_SC_BK6E_7B_L      _PK_L_(0x6E, 0x7B)
#define REG_SC_BK6E_7B_H      _PK_H_(0x6E, 0x7B)
#define REG_SC_BK6E_7C_L      _PK_L_(0x6E, 0x7C)
#define REG_SC_BK6E_7C_H      _PK_H_(0x6E, 0x7C)
#define REG_SC_BK6E_7D_L      _PK_L_(0x6E, 0x7D)
#define REG_SC_BK6E_7D_H      _PK_H_(0x6E, 0x7D)
#define REG_SC_BK6E_7E_L      _PK_L_(0x6E, 0x7E)
#define REG_SC_BK6E_7E_H      _PK_H_(0x6E, 0x7E)
#define REG_SC_BK6E_7F_L      _PK_L_(0x6E, 0x7F)
#define REG_SC_BK6E_7F_H      _PK_H_(0x6E, 0x7F)
//----------------------------------------------
#define REG_SC_BK76_00_L      _PK_L_(0x76, 0x00)
#define REG_SC_BK76_00_H      _PK_H_(0x76, 0x00)
#define REG_SC_BK76_01_L      _PK_L_(0x76, 0x01)
#define REG_SC_BK76_01_H      _PK_H_(0x76, 0x01)
#define REG_SC_BK76_02_L      _PK_L_(0x76, 0x02)
#define REG_SC_BK76_02_H      _PK_H_(0x76, 0x02)
#define REG_SC_BK76_03_L      _PK_L_(0x76, 0x03)
#define REG_SC_BK76_03_H      _PK_H_(0x76, 0x03)
#define REG_SC_BK76_04_L      _PK_L_(0x76, 0x04)
#define REG_SC_BK76_04_H      _PK_H_(0x76, 0x04)
#define REG_SC_BK76_05_L      _PK_L_(0x76, 0x05)
#define REG_SC_BK76_05_H      _PK_H_(0x76, 0x05)
#define REG_SC_BK76_06_L      _PK_L_(0x76, 0x06)
#define REG_SC_BK76_06_H      _PK_H_(0x76, 0x06)
#define REG_SC_BK76_07_L      _PK_L_(0x76, 0x07)
#define REG_SC_BK76_07_H      _PK_H_(0x76, 0x07)
#define REG_SC_BK76_08_L      _PK_L_(0x76, 0x08)
#define REG_SC_BK76_08_H      _PK_H_(0x76, 0x08)
#define REG_SC_BK76_09_L      _PK_L_(0x76, 0x09)
#define REG_SC_BK76_09_H      _PK_H_(0x76, 0x09)
#define REG_SC_BK76_0A_L      _PK_L_(0x76, 0x0A)
#define REG_SC_BK76_0A_H      _PK_H_(0x76, 0x0A)
#define REG_SC_BK76_0B_L      _PK_L_(0x76, 0x0B)
#define REG_SC_BK76_0B_H      _PK_H_(0x76, 0x0B)
#define REG_SC_BK76_0C_L      _PK_L_(0x76, 0x0C)
#define REG_SC_BK76_0C_H      _PK_H_(0x76, 0x0C)
#define REG_SC_BK76_0D_L      _PK_L_(0x76, 0x0D)
#define REG_SC_BK76_0D_H      _PK_H_(0x76, 0x0D)
#define REG_SC_BK76_0E_L      _PK_L_(0x76, 0x0E)
#define REG_SC_BK76_0E_H      _PK_H_(0x76, 0x0E)
#define REG_SC_BK76_0F_L      _PK_L_(0x76, 0x0F)
#define REG_SC_BK76_0F_H      _PK_H_(0x76, 0x0F)
#define REG_SC_BK76_10_L      _PK_L_(0x76, 0x10)
#define REG_SC_BK76_10_H      _PK_H_(0x76, 0x10)
#define REG_SC_BK76_11_L      _PK_L_(0x76, 0x11)
#define REG_SC_BK76_11_H      _PK_H_(0x76, 0x11)
#define REG_SC_BK76_12_L      _PK_L_(0x76, 0x12)
#define REG_SC_BK76_12_H      _PK_H_(0x76, 0x12)
#define REG_SC_BK76_13_L      _PK_L_(0x76, 0x13)
#define REG_SC_BK76_13_H      _PK_H_(0x76, 0x13)
#define REG_SC_BK76_14_L      _PK_L_(0x76, 0x14)
#define REG_SC_BK76_14_H      _PK_H_(0x76, 0x14)
#define REG_SC_BK76_15_L      _PK_L_(0x76, 0x15)
#define REG_SC_BK76_15_H      _PK_H_(0x76, 0x15)
#define REG_SC_BK76_16_L      _PK_L_(0x76, 0x16)
#define REG_SC_BK76_16_H      _PK_H_(0x76, 0x16)
#define REG_SC_BK76_17_L      _PK_L_(0x76, 0x17)
#define REG_SC_BK76_17_H      _PK_H_(0x76, 0x17)
#define REG_SC_BK76_18_L      _PK_L_(0x76, 0x18)
#define REG_SC_BK76_18_H      _PK_H_(0x76, 0x18)
#define REG_SC_BK76_19_L      _PK_L_(0x76, 0x19)
#define REG_SC_BK76_19_H      _PK_H_(0x76, 0x19)
#define REG_SC_BK76_1A_L      _PK_L_(0x76, 0x1A)
#define REG_SC_BK76_1A_H      _PK_H_(0x76, 0x1A)
#define REG_SC_BK76_1B_L      _PK_L_(0x76, 0x1B)
#define REG_SC_BK76_1B_H      _PK_H_(0x76, 0x1B)
#define REG_SC_BK76_1C_L      _PK_L_(0x76, 0x1C)
#define REG_SC_BK76_1C_H      _PK_H_(0x76, 0x1C)
#define REG_SC_BK76_1D_L      _PK_L_(0x76, 0x1D)
#define REG_SC_BK76_1D_H      _PK_H_(0x76, 0x1D)
#define REG_SC_BK76_1E_L      _PK_L_(0x76, 0x1E)
#define REG_SC_BK76_1E_H      _PK_H_(0x76, 0x1E)
#define REG_SC_BK76_1F_L      _PK_L_(0x76, 0x1F)
#define REG_SC_BK76_1F_H      _PK_H_(0x76, 0x1F)
#define REG_SC_BK76_20_L      _PK_L_(0x76, 0x20)
#define REG_SC_BK76_20_H      _PK_H_(0x76, 0x20)
#define REG_SC_BK76_21_L      _PK_L_(0x76, 0x21)
#define REG_SC_BK76_21_H      _PK_H_(0x76, 0x21)
#define REG_SC_BK76_22_L      _PK_L_(0x76, 0x22)
#define REG_SC_BK76_22_H      _PK_H_(0x76, 0x22)
#define REG_SC_BK76_23_L      _PK_L_(0x76, 0x23)
#define REG_SC_BK76_23_H      _PK_H_(0x76, 0x23)
#define REG_SC_BK76_24_L      _PK_L_(0x76, 0x24)
#define REG_SC_BK76_24_H      _PK_H_(0x76, 0x24)
#define REG_SC_BK76_25_L      _PK_L_(0x76, 0x25)
#define REG_SC_BK76_25_H      _PK_H_(0x76, 0x25)
#define REG_SC_BK76_26_L      _PK_L_(0x76, 0x26)
#define REG_SC_BK76_26_H      _PK_H_(0x76, 0x26)
#define REG_SC_BK76_27_L      _PK_L_(0x76, 0x27)
#define REG_SC_BK76_27_H      _PK_H_(0x76, 0x27)
#define REG_SC_BK76_28_L      _PK_L_(0x76, 0x28)
#define REG_SC_BK76_28_H      _PK_H_(0x76, 0x28)
#define REG_SC_BK76_29_L      _PK_L_(0x76, 0x29)
#define REG_SC_BK76_29_H      _PK_H_(0x76, 0x29)
#define REG_SC_BK76_2A_L      _PK_L_(0x76, 0x2A)
#define REG_SC_BK76_2A_H      _PK_H_(0x76, 0x2A)
#define REG_SC_BK76_2B_L      _PK_L_(0x76, 0x2B)
#define REG_SC_BK76_2B_H      _PK_H_(0x76, 0x2B)
#define REG_SC_BK76_2C_L      _PK_L_(0x76, 0x2C)
#define REG_SC_BK76_2C_H      _PK_H_(0x76, 0x2C)
#define REG_SC_BK76_2D_L      _PK_L_(0x76, 0x2D)
#define REG_SC_BK76_2D_H      _PK_H_(0x76, 0x2D)
#define REG_SC_BK76_2E_L      _PK_L_(0x76, 0x2E)
#define REG_SC_BK76_2E_H      _PK_H_(0x76, 0x2E)
#define REG_SC_BK76_2F_L      _PK_L_(0x76, 0x2F)
#define REG_SC_BK76_2F_H      _PK_H_(0x76, 0x2F)
#define REG_SC_BK76_30_L      _PK_L_(0x76, 0x30)
#define REG_SC_BK76_30_H      _PK_H_(0x76, 0x30)
#define REG_SC_BK76_31_L      _PK_L_(0x76, 0x31)
#define REG_SC_BK76_31_H      _PK_H_(0x76, 0x31)
#define REG_SC_BK76_32_L      _PK_L_(0x76, 0x32)
#define REG_SC_BK76_32_H      _PK_H_(0x76, 0x32)
#define REG_SC_BK76_33_L      _PK_L_(0x76, 0x33)
#define REG_SC_BK76_33_H      _PK_H_(0x76, 0x33)
#define REG_SC_BK76_34_L      _PK_L_(0x76, 0x34)
#define REG_SC_BK76_34_H      _PK_H_(0x76, 0x34)
#define REG_SC_BK76_35_L      _PK_L_(0x76, 0x35)
#define REG_SC_BK76_35_H      _PK_H_(0x76, 0x35)
#define REG_SC_BK76_36_L      _PK_L_(0x76, 0x36)
#define REG_SC_BK76_36_H      _PK_H_(0x76, 0x36)
#define REG_SC_BK76_37_L      _PK_L_(0x76, 0x37)
#define REG_SC_BK76_37_H      _PK_H_(0x76, 0x37)
#define REG_SC_BK76_38_L      _PK_L_(0x76, 0x38)
#define REG_SC_BK76_38_H      _PK_H_(0x76, 0x38)
#define REG_SC_BK76_39_L      _PK_L_(0x76, 0x39)
#define REG_SC_BK76_39_H      _PK_H_(0x76, 0x39)
#define REG_SC_BK76_3A_L      _PK_L_(0x76, 0x3A)
#define REG_SC_BK76_3A_H      _PK_H_(0x76, 0x3A)
#define REG_SC_BK76_3B_L      _PK_L_(0x76, 0x3B)
#define REG_SC_BK76_3B_H      _PK_H_(0x76, 0x3B)
#define REG_SC_BK76_3C_L      _PK_L_(0x76, 0x3C)
#define REG_SC_BK76_3C_H      _PK_H_(0x76, 0x3C)
#define REG_SC_BK76_3D_L      _PK_L_(0x76, 0x3D)
#define REG_SC_BK76_3D_H      _PK_H_(0x76, 0x3D)
#define REG_SC_BK76_3E_L      _PK_L_(0x76, 0x3E)
#define REG_SC_BK76_3E_H      _PK_H_(0x76, 0x3E)
#define REG_SC_BK76_3F_L      _PK_L_(0x76, 0x3F)
#define REG_SC_BK76_3F_H      _PK_H_(0x76, 0x3F)
#define REG_SC_BK76_40_L      _PK_L_(0x76, 0x40)
#define REG_SC_BK76_40_H      _PK_H_(0x76, 0x40)
#define REG_SC_BK76_41_L      _PK_L_(0x76, 0x41)
#define REG_SC_BK76_41_H      _PK_H_(0x76, 0x41)
#define REG_SC_BK76_42_L      _PK_L_(0x76, 0x42)
#define REG_SC_BK76_42_H      _PK_H_(0x76, 0x42)
#define REG_SC_BK76_43_L      _PK_L_(0x76, 0x43)
#define REG_SC_BK76_43_H      _PK_H_(0x76, 0x43)
#define REG_SC_BK76_44_L      _PK_L_(0x76, 0x44)
#define REG_SC_BK76_44_H      _PK_H_(0x76, 0x44)
#define REG_SC_BK76_45_L      _PK_L_(0x76, 0x45)
#define REG_SC_BK76_45_H      _PK_H_(0x76, 0x45)
#define REG_SC_BK76_46_L      _PK_L_(0x76, 0x46)
#define REG_SC_BK76_46_H      _PK_H_(0x76, 0x46)
#define REG_SC_BK76_47_L      _PK_L_(0x76, 0x47)
#define REG_SC_BK76_47_H      _PK_H_(0x76, 0x47)
#define REG_SC_BK76_48_L      _PK_L_(0x76, 0x48)
#define REG_SC_BK76_48_H      _PK_H_(0x76, 0x48)
#define REG_SC_BK76_49_L      _PK_L_(0x76, 0x49)
#define REG_SC_BK76_49_H      _PK_H_(0x76, 0x49)
#define REG_SC_BK76_4A_L      _PK_L_(0x76, 0x4A)
#define REG_SC_BK76_4A_H      _PK_H_(0x76, 0x4A)
#define REG_SC_BK76_4B_L      _PK_L_(0x76, 0x4B)
#define REG_SC_BK76_4B_H      _PK_H_(0x76, 0x4B)
#define REG_SC_BK76_4C_L      _PK_L_(0x76, 0x4C)
#define REG_SC_BK76_4C_H      _PK_H_(0x76, 0x4C)
#define REG_SC_BK76_4D_L      _PK_L_(0x76, 0x4D)
#define REG_SC_BK76_4D_H      _PK_H_(0x76, 0x4D)
#define REG_SC_BK76_4E_L      _PK_L_(0x76, 0x4E)
#define REG_SC_BK76_4E_H      _PK_H_(0x76, 0x4E)
#define REG_SC_BK76_4F_L      _PK_L_(0x76, 0x4F)
#define REG_SC_BK76_4F_H      _PK_H_(0x76, 0x4F)
#define REG_SC_BK76_50_L      _PK_L_(0x76, 0x50)
#define REG_SC_BK76_50_H      _PK_H_(0x76, 0x50)
#define REG_SC_BK76_51_L      _PK_L_(0x76, 0x51)
#define REG_SC_BK76_51_H      _PK_H_(0x76, 0x51)
#define REG_SC_BK76_52_L      _PK_L_(0x76, 0x52)
#define REG_SC_BK76_52_H      _PK_H_(0x76, 0x52)
#define REG_SC_BK76_53_L      _PK_L_(0x76, 0x53)
#define REG_SC_BK76_53_H      _PK_H_(0x76, 0x53)
#define REG_SC_BK76_54_L      _PK_L_(0x76, 0x54)
#define REG_SC_BK76_54_H      _PK_H_(0x76, 0x54)
#define REG_SC_BK76_55_L      _PK_L_(0x76, 0x55)
#define REG_SC_BK76_55_H      _PK_H_(0x76, 0x55)
#define REG_SC_BK76_56_L      _PK_L_(0x76, 0x56)
#define REG_SC_BK76_56_H      _PK_H_(0x76, 0x56)
#define REG_SC_BK76_57_L      _PK_L_(0x76, 0x57)
#define REG_SC_BK76_57_H      _PK_H_(0x76, 0x57)
#define REG_SC_BK76_58_L      _PK_L_(0x76, 0x58)
#define REG_SC_BK76_58_H      _PK_H_(0x76, 0x58)
#define REG_SC_BK76_59_L      _PK_L_(0x76, 0x59)
#define REG_SC_BK76_59_H      _PK_H_(0x76, 0x59)
#define REG_SC_BK76_5A_L      _PK_L_(0x76, 0x5A)
#define REG_SC_BK76_5A_H      _PK_H_(0x76, 0x5A)
#define REG_SC_BK76_5B_L      _PK_L_(0x76, 0x5B)
#define REG_SC_BK76_5B_H      _PK_H_(0x76, 0x5B)
#define REG_SC_BK76_5C_L      _PK_L_(0x76, 0x5C)
#define REG_SC_BK76_5C_H      _PK_H_(0x76, 0x5C)
#define REG_SC_BK76_5D_L      _PK_L_(0x76, 0x5D)
#define REG_SC_BK76_5D_H      _PK_H_(0x76, 0x5D)
#define REG_SC_BK76_5E_L      _PK_L_(0x76, 0x5E)
#define REG_SC_BK76_5E_H      _PK_H_(0x76, 0x5E)
#define REG_SC_BK76_5F_L      _PK_L_(0x76, 0x5F)
#define REG_SC_BK76_5F_H      _PK_H_(0x76, 0x5F)
#define REG_SC_BK76_60_L      _PK_L_(0x76, 0x60)
#define REG_SC_BK76_60_H      _PK_H_(0x76, 0x60)
#define REG_SC_BK76_61_L      _PK_L_(0x76, 0x61)
#define REG_SC_BK76_61_H      _PK_H_(0x76, 0x61)
#define REG_SC_BK76_62_L      _PK_L_(0x76, 0x62)
#define REG_SC_BK76_62_H      _PK_H_(0x76, 0x62)
#define REG_SC_BK76_63_L      _PK_L_(0x76, 0x63)
#define REG_SC_BK76_63_H      _PK_H_(0x76, 0x63)
#define REG_SC_BK76_64_L      _PK_L_(0x76, 0x64)
#define REG_SC_BK76_64_H      _PK_H_(0x76, 0x64)
#define REG_SC_BK76_65_L      _PK_L_(0x76, 0x65)
#define REG_SC_BK76_65_H      _PK_H_(0x76, 0x65)
#define REG_SC_BK76_66_L      _PK_L_(0x76, 0x66)
#define REG_SC_BK76_66_H      _PK_H_(0x76, 0x66)
#define REG_SC_BK76_67_L      _PK_L_(0x76, 0x67)
#define REG_SC_BK76_67_H      _PK_H_(0x76, 0x67)
#define REG_SC_BK76_68_L      _PK_L_(0x76, 0x68)
#define REG_SC_BK76_68_H      _PK_H_(0x76, 0x68)
#define REG_SC_BK76_69_L      _PK_L_(0x76, 0x69)
#define REG_SC_BK76_69_H      _PK_H_(0x76, 0x69)
#define REG_SC_BK76_6A_L      _PK_L_(0x76, 0x6A)
#define REG_SC_BK76_6A_H      _PK_H_(0x76, 0x6A)
#define REG_SC_BK76_6B_L      _PK_L_(0x76, 0x6B)
#define REG_SC_BK76_6B_H      _PK_H_(0x76, 0x6B)
#define REG_SC_BK76_6C_L      _PK_L_(0x76, 0x6C)
#define REG_SC_BK76_6C_H      _PK_H_(0x76, 0x6C)
#define REG_SC_BK76_6D_L      _PK_L_(0x76, 0x6D)
#define REG_SC_BK76_6D_H      _PK_H_(0x76, 0x6D)
#define REG_SC_BK76_6E_L      _PK_L_(0x76, 0x6E)
#define REG_SC_BK76_6E_H      _PK_H_(0x76, 0x6E)
#define REG_SC_BK76_6F_L      _PK_L_(0x76, 0x6F)
#define REG_SC_BK76_6F_H      _PK_H_(0x76, 0x6F)
#define REG_SC_BK76_70_L      _PK_L_(0x76, 0x70)
#define REG_SC_BK76_70_H      _PK_H_(0x76, 0x70)
#define REG_SC_BK76_71_L      _PK_L_(0x76, 0x71)
#define REG_SC_BK76_71_H      _PK_H_(0x76, 0x71)
#define REG_SC_BK76_72_L      _PK_L_(0x76, 0x72)
#define REG_SC_BK76_72_H      _PK_H_(0x76, 0x72)
#define REG_SC_BK76_73_L      _PK_L_(0x76, 0x73)
#define REG_SC_BK76_73_H      _PK_H_(0x76, 0x73)
#define REG_SC_BK76_74_L      _PK_L_(0x76, 0x74)
#define REG_SC_BK76_74_H      _PK_H_(0x76, 0x74)
#define REG_SC_BK76_75_L      _PK_L_(0x76, 0x75)
#define REG_SC_BK76_75_H      _PK_H_(0x76, 0x75)
#define REG_SC_BK76_76_L      _PK_L_(0x76, 0x76)
#define REG_SC_BK76_76_H      _PK_H_(0x76, 0x76)
#define REG_SC_BK76_77_L      _PK_L_(0x76, 0x77)
#define REG_SC_BK76_77_H      _PK_H_(0x76, 0x77)
#define REG_SC_BK76_78_L      _PK_L_(0x76, 0x78)
#define REG_SC_BK76_78_H      _PK_H_(0x76, 0x78)
#define REG_SC_BK76_79_L      _PK_L_(0x76, 0x79)
#define REG_SC_BK76_79_H      _PK_H_(0x76, 0x79)
#define REG_SC_BK76_7A_L      _PK_L_(0x76, 0x7A)
#define REG_SC_BK76_7A_H      _PK_H_(0x76, 0x7A)
#define REG_SC_BK76_7B_L      _PK_L_(0x76, 0x7B)
#define REG_SC_BK76_7B_H      _PK_H_(0x76, 0x7B)
#define REG_SC_BK76_7C_L      _PK_L_(0x76, 0x7C)
#define REG_SC_BK76_7C_H      _PK_H_(0x76, 0x7C)
#define REG_SC_BK76_7D_L      _PK_L_(0x76, 0x7D)
#define REG_SC_BK76_7D_H      _PK_H_(0x76, 0x7D)
#define REG_SC_BK76_7E_L      _PK_L_(0x76, 0x7E)
#define REG_SC_BK76_7E_H      _PK_H_(0x76, 0x7E)
#define REG_SC_BK76_7F_L      _PK_L_(0x76, 0x7F)
#define REG_SC_BK76_7F_H      _PK_H_(0x76, 0x7F)
//----------------------------------------------
#define REG_SC_BK79_00_L      _PK_L_(0x79, 0x00)
#define REG_SC_BK79_00_H      _PK_H_(0x79, 0x00)
#define REG_SC_BK79_01_L      _PK_L_(0x79, 0x01)
#define REG_SC_BK79_01_H      _PK_H_(0x79, 0x01)
#define REG_SC_BK79_02_L      _PK_L_(0x79, 0x02)
#define REG_SC_BK79_02_H      _PK_H_(0x79, 0x02)
#define REG_SC_BK79_03_L      _PK_L_(0x79, 0x03)
#define REG_SC_BK79_03_H      _PK_H_(0x79, 0x03)
#define REG_SC_BK79_04_L      _PK_L_(0x79, 0x04)
#define REG_SC_BK79_04_H      _PK_H_(0x79, 0x04)
#define REG_SC_BK79_05_L      _PK_L_(0x79, 0x05)
#define REG_SC_BK79_05_H      _PK_H_(0x79, 0x05)
#define REG_SC_BK79_06_L      _PK_L_(0x79, 0x06)
#define REG_SC_BK79_06_H      _PK_H_(0x79, 0x06)
#define REG_SC_BK79_07_L      _PK_L_(0x79, 0x07)
#define REG_SC_BK79_07_H      _PK_H_(0x79, 0x07)
#define REG_SC_BK79_08_L      _PK_L_(0x79, 0x08)
#define REG_SC_BK79_08_H      _PK_H_(0x79, 0x08)
#define REG_SC_BK79_09_L      _PK_L_(0x79, 0x09)
#define REG_SC_BK79_09_H      _PK_H_(0x79, 0x09)
#define REG_SC_BK79_0A_L      _PK_L_(0x79, 0x0A)
#define REG_SC_BK79_0A_H      _PK_H_(0x79, 0x0A)
#define REG_SC_BK79_0B_L      _PK_L_(0x79, 0x0B)
#define REG_SC_BK79_0B_H      _PK_H_(0x79, 0x0B)
#define REG_SC_BK79_0C_L      _PK_L_(0x79, 0x0C)
#define REG_SC_BK79_0C_H      _PK_H_(0x79, 0x0C)
#define REG_SC_BK79_0D_L      _PK_L_(0x79, 0x0D)
#define REG_SC_BK79_0D_H      _PK_H_(0x79, 0x0D)
#define REG_SC_BK79_0E_L      _PK_L_(0x79, 0x0E)
#define REG_SC_BK79_0E_H      _PK_H_(0x79, 0x0E)
#define REG_SC_BK79_0F_L      _PK_L_(0x79, 0x0F)
#define REG_SC_BK79_0F_H      _PK_H_(0x79, 0x0F)
#define REG_SC_BK79_10_L      _PK_L_(0x79, 0x10)
#define REG_SC_BK79_10_H      _PK_H_(0x79, 0x10)
#define REG_SC_BK79_11_L      _PK_L_(0x79, 0x11)
#define REG_SC_BK79_11_H      _PK_H_(0x79, 0x11)
#define REG_SC_BK79_12_L      _PK_L_(0x79, 0x12)
#define REG_SC_BK79_12_H      _PK_H_(0x79, 0x12)
#define REG_SC_BK79_13_L      _PK_L_(0x79, 0x13)
#define REG_SC_BK79_13_H      _PK_H_(0x79, 0x13)
#define REG_SC_BK79_14_L      _PK_L_(0x79, 0x14)
#define REG_SC_BK79_14_H      _PK_H_(0x79, 0x14)
#define REG_SC_BK79_15_L      _PK_L_(0x79, 0x15)
#define REG_SC_BK79_15_H      _PK_H_(0x79, 0x15)
#define REG_SC_BK79_16_L      _PK_L_(0x79, 0x16)
#define REG_SC_BK79_16_H      _PK_H_(0x79, 0x16)
#define REG_SC_BK79_17_L      _PK_L_(0x79, 0x17)
#define REG_SC_BK79_17_H      _PK_H_(0x79, 0x17)
#define REG_SC_BK79_18_L      _PK_L_(0x79, 0x18)
#define REG_SC_BK79_18_H      _PK_H_(0x79, 0x18)
#define REG_SC_BK79_19_L      _PK_L_(0x79, 0x19)
#define REG_SC_BK79_19_H      _PK_H_(0x79, 0x19)
#define REG_SC_BK79_1A_L      _PK_L_(0x79, 0x1A)
#define REG_SC_BK79_1A_H      _PK_H_(0x79, 0x1A)
#define REG_SC_BK79_1B_L      _PK_L_(0x79, 0x1B)
#define REG_SC_BK79_1B_H      _PK_H_(0x79, 0x1B)
#define REG_SC_BK79_1C_L      _PK_L_(0x79, 0x1C)
#define REG_SC_BK79_1C_H      _PK_H_(0x79, 0x1C)
#define REG_SC_BK79_1D_L      _PK_L_(0x79, 0x1D)
#define REG_SC_BK79_1D_H      _PK_H_(0x79, 0x1D)
#define REG_SC_BK79_1E_L      _PK_L_(0x79, 0x1E)
#define REG_SC_BK79_1E_H      _PK_H_(0x79, 0x1E)
#define REG_SC_BK79_1F_L      _PK_L_(0x79, 0x1F)
#define REG_SC_BK79_1F_H      _PK_H_(0x79, 0x1F)
#define REG_SC_BK79_20_L      _PK_L_(0x79, 0x20)
#define REG_SC_BK79_20_H      _PK_H_(0x79, 0x20)
#define REG_SC_BK79_21_L      _PK_L_(0x79, 0x21)
#define REG_SC_BK79_21_H      _PK_H_(0x79, 0x21)
#define REG_SC_BK79_22_L      _PK_L_(0x79, 0x22)
#define REG_SC_BK79_22_H      _PK_H_(0x79, 0x22)
#define REG_SC_BK79_23_L      _PK_L_(0x79, 0x23)
#define REG_SC_BK79_23_H      _PK_H_(0x79, 0x23)
#define REG_SC_BK79_24_L      _PK_L_(0x79, 0x24)
#define REG_SC_BK79_24_H      _PK_H_(0x79, 0x24)
#define REG_SC_BK79_25_L      _PK_L_(0x79, 0x25)
#define REG_SC_BK79_25_H      _PK_H_(0x79, 0x25)
#define REG_SC_BK79_26_L      _PK_L_(0x79, 0x26)
#define REG_SC_BK79_26_H      _PK_H_(0x79, 0x26)
#define REG_SC_BK79_27_L      _PK_L_(0x79, 0x27)
#define REG_SC_BK79_27_H      _PK_H_(0x79, 0x27)
#define REG_SC_BK79_28_L      _PK_L_(0x79, 0x28)
#define REG_SC_BK79_28_H      _PK_H_(0x79, 0x28)
#define REG_SC_BK79_29_L      _PK_L_(0x79, 0x29)
#define REG_SC_BK79_29_H      _PK_H_(0x79, 0x29)
#define REG_SC_BK79_2A_L      _PK_L_(0x79, 0x2A)
#define REG_SC_BK79_2A_H      _PK_H_(0x79, 0x2A)
#define REG_SC_BK79_2B_L      _PK_L_(0x79, 0x2B)
#define REG_SC_BK79_2B_H      _PK_H_(0x79, 0x2B)
#define REG_SC_BK79_2C_L      _PK_L_(0x79, 0x2C)
#define REG_SC_BK79_2C_H      _PK_H_(0x79, 0x2C)
#define REG_SC_BK79_2D_L      _PK_L_(0x79, 0x2D)
#define REG_SC_BK79_2D_H      _PK_H_(0x79, 0x2D)
#define REG_SC_BK79_2E_L      _PK_L_(0x79, 0x2E)
#define REG_SC_BK79_2E_H      _PK_H_(0x79, 0x2E)
#define REG_SC_BK79_2F_L      _PK_L_(0x79, 0x2F)
#define REG_SC_BK79_2F_H      _PK_H_(0x79, 0x2F)
#define REG_SC_BK79_30_L      _PK_L_(0x79, 0x30)
#define REG_SC_BK79_30_H      _PK_H_(0x79, 0x30)
#define REG_SC_BK79_31_L      _PK_L_(0x79, 0x31)
#define REG_SC_BK79_31_H      _PK_H_(0x79, 0x31)
#define REG_SC_BK79_32_L      _PK_L_(0x79, 0x32)
#define REG_SC_BK79_32_H      _PK_H_(0x79, 0x32)
#define REG_SC_BK79_33_L      _PK_L_(0x79, 0x33)
#define REG_SC_BK79_33_H      _PK_H_(0x79, 0x33)
#define REG_SC_BK79_34_L      _PK_L_(0x79, 0x34)
#define REG_SC_BK79_34_H      _PK_H_(0x79, 0x34)
#define REG_SC_BK79_35_L      _PK_L_(0x79, 0x35)
#define REG_SC_BK79_35_H      _PK_H_(0x79, 0x35)
#define REG_SC_BK79_36_L      _PK_L_(0x79, 0x36)
#define REG_SC_BK79_36_H      _PK_H_(0x79, 0x36)
#define REG_SC_BK79_37_L      _PK_L_(0x79, 0x37)
#define REG_SC_BK79_37_H      _PK_H_(0x79, 0x37)
#define REG_SC_BK79_38_L      _PK_L_(0x79, 0x38)
#define REG_SC_BK79_38_H      _PK_H_(0x79, 0x38)
#define REG_SC_BK79_39_L      _PK_L_(0x79, 0x39)
#define REG_SC_BK79_39_H      _PK_H_(0x79, 0x39)
#define REG_SC_BK79_3A_L      _PK_L_(0x79, 0x3A)
#define REG_SC_BK79_3A_H      _PK_H_(0x79, 0x3A)
#define REG_SC_BK79_3B_L      _PK_L_(0x79, 0x3B)
#define REG_SC_BK79_3B_H      _PK_H_(0x79, 0x3B)
#define REG_SC_BK79_3C_L      _PK_L_(0x79, 0x3C)
#define REG_SC_BK79_3C_H      _PK_H_(0x79, 0x3C)
#define REG_SC_BK79_3D_L      _PK_L_(0x79, 0x3D)
#define REG_SC_BK79_3D_H      _PK_H_(0x79, 0x3D)
#define REG_SC_BK79_3E_L      _PK_L_(0x79, 0x3E)
#define REG_SC_BK79_3E_H      _PK_H_(0x79, 0x3E)
#define REG_SC_BK79_3F_L      _PK_L_(0x79, 0x3F)
#define REG_SC_BK79_3F_H      _PK_H_(0x79, 0x3F)
#define REG_SC_BK79_40_L      _PK_L_(0x79, 0x40)
#define REG_SC_BK79_40_H      _PK_H_(0x79, 0x40)
#define REG_SC_BK79_41_L      _PK_L_(0x79, 0x41)
#define REG_SC_BK79_41_H      _PK_H_(0x79, 0x41)
#define REG_SC_BK79_42_L      _PK_L_(0x79, 0x42)
#define REG_SC_BK79_42_H      _PK_H_(0x79, 0x42)
#define REG_SC_BK79_43_L      _PK_L_(0x79, 0x43)
#define REG_SC_BK79_43_H      _PK_H_(0x79, 0x43)
#define REG_SC_BK79_44_L      _PK_L_(0x79, 0x44)
#define REG_SC_BK79_44_H      _PK_H_(0x79, 0x44)
#define REG_SC_BK79_45_L      _PK_L_(0x79, 0x45)
#define REG_SC_BK79_45_H      _PK_H_(0x79, 0x45)
#define REG_SC_BK79_46_L      _PK_L_(0x79, 0x46)
#define REG_SC_BK79_46_H      _PK_H_(0x79, 0x46)
#define REG_SC_BK79_47_L      _PK_L_(0x79, 0x47)
#define REG_SC_BK79_47_H      _PK_H_(0x79, 0x47)
#define REG_SC_BK79_48_L      _PK_L_(0x79, 0x48)
#define REG_SC_BK79_48_H      _PK_H_(0x79, 0x48)
#define REG_SC_BK79_49_L      _PK_L_(0x79, 0x49)
#define REG_SC_BK79_49_H      _PK_H_(0x79, 0x49)
#define REG_SC_BK79_4A_L      _PK_L_(0x79, 0x4A)
#define REG_SC_BK79_4A_H      _PK_H_(0x79, 0x4A)
#define REG_SC_BK79_4B_L      _PK_L_(0x79, 0x4B)
#define REG_SC_BK79_4B_H      _PK_H_(0x79, 0x4B)
#define REG_SC_BK79_4C_L      _PK_L_(0x79, 0x4C)
#define REG_SC_BK79_4C_H      _PK_H_(0x79, 0x4C)
#define REG_SC_BK79_4D_L      _PK_L_(0x79, 0x4D)
#define REG_SC_BK79_4D_H      _PK_H_(0x79, 0x4D)
#define REG_SC_BK79_4E_L      _PK_L_(0x79, 0x4E)
#define REG_SC_BK79_4E_H      _PK_H_(0x79, 0x4E)
#define REG_SC_BK79_4F_L      _PK_L_(0x79, 0x4F)
#define REG_SC_BK79_4F_H      _PK_H_(0x79, 0x4F)
#define REG_SC_BK79_50_L      _PK_L_(0x79, 0x50)
#define REG_SC_BK79_50_H      _PK_H_(0x79, 0x50)
#define REG_SC_BK79_51_L      _PK_L_(0x79, 0x51)
#define REG_SC_BK79_51_H      _PK_H_(0x79, 0x51)
#define REG_SC_BK79_52_L      _PK_L_(0x79, 0x52)
#define REG_SC_BK79_52_H      _PK_H_(0x79, 0x52)
#define REG_SC_BK79_53_L      _PK_L_(0x79, 0x53)
#define REG_SC_BK79_53_H      _PK_H_(0x79, 0x53)
#define REG_SC_BK79_54_L      _PK_L_(0x79, 0x54)
#define REG_SC_BK79_54_H      _PK_H_(0x79, 0x54)
#define REG_SC_BK79_55_L      _PK_L_(0x79, 0x55)
#define REG_SC_BK79_55_H      _PK_H_(0x79, 0x55)
#define REG_SC_BK79_56_L      _PK_L_(0x79, 0x56)
#define REG_SC_BK79_56_H      _PK_H_(0x79, 0x56)
#define REG_SC_BK79_57_L      _PK_L_(0x79, 0x57)
#define REG_SC_BK79_57_H      _PK_H_(0x79, 0x57)
#define REG_SC_BK79_58_L      _PK_L_(0x79, 0x58)
#define REG_SC_BK79_58_H      _PK_H_(0x79, 0x58)
#define REG_SC_BK79_59_L      _PK_L_(0x79, 0x59)
#define REG_SC_BK79_59_H      _PK_H_(0x79, 0x59)
#define REG_SC_BK79_5A_L      _PK_L_(0x79, 0x5A)
#define REG_SC_BK79_5A_H      _PK_H_(0x79, 0x5A)
#define REG_SC_BK79_5B_L      _PK_L_(0x79, 0x5B)
#define REG_SC_BK79_5B_H      _PK_H_(0x79, 0x5B)
#define REG_SC_BK79_5C_L      _PK_L_(0x79, 0x5C)
#define REG_SC_BK79_5C_H      _PK_H_(0x79, 0x5C)
#define REG_SC_BK79_5D_L      _PK_L_(0x79, 0x5D)
#define REG_SC_BK79_5D_H      _PK_H_(0x79, 0x5D)
#define REG_SC_BK79_5E_L      _PK_L_(0x79, 0x5E)
#define REG_SC_BK79_5E_H      _PK_H_(0x79, 0x5E)
#define REG_SC_BK79_5F_L      _PK_L_(0x79, 0x5F)
#define REG_SC_BK79_5F_H      _PK_H_(0x79, 0x5F)
#define REG_SC_BK79_60_L      _PK_L_(0x79, 0x60)
#define REG_SC_BK79_60_H      _PK_H_(0x79, 0x60)
#define REG_SC_BK79_61_L      _PK_L_(0x79, 0x61)
#define REG_SC_BK79_61_H      _PK_H_(0x79, 0x61)
#define REG_SC_BK79_62_L      _PK_L_(0x79, 0x62)
#define REG_SC_BK79_62_H      _PK_H_(0x79, 0x62)
#define REG_SC_BK79_63_L      _PK_L_(0x79, 0x63)
#define REG_SC_BK79_63_H      _PK_H_(0x79, 0x63)
#define REG_SC_BK79_64_L      _PK_L_(0x79, 0x64)
#define REG_SC_BK79_64_H      _PK_H_(0x79, 0x64)
#define REG_SC_BK79_65_L      _PK_L_(0x79, 0x65)
#define REG_SC_BK79_65_H      _PK_H_(0x79, 0x65)
#define REG_SC_BK79_66_L      _PK_L_(0x79, 0x66)
#define REG_SC_BK79_66_H      _PK_H_(0x79, 0x66)
#define REG_SC_BK79_67_L      _PK_L_(0x79, 0x67)
#define REG_SC_BK79_67_H      _PK_H_(0x79, 0x67)
#define REG_SC_BK79_68_L      _PK_L_(0x79, 0x68)
#define REG_SC_BK79_68_H      _PK_H_(0x79, 0x68)
#define REG_SC_BK79_69_L      _PK_L_(0x79, 0x69)
#define REG_SC_BK79_69_H      _PK_H_(0x79, 0x69)
#define REG_SC_BK79_6A_L      _PK_L_(0x79, 0x6A)
#define REG_SC_BK79_6A_H      _PK_H_(0x79, 0x6A)
#define REG_SC_BK79_6B_L      _PK_L_(0x79, 0x6B)
#define REG_SC_BK79_6B_H      _PK_H_(0x79, 0x6B)
#define REG_SC_BK79_6C_L      _PK_L_(0x79, 0x6C)
#define REG_SC_BK79_6C_H      _PK_H_(0x79, 0x6C)
#define REG_SC_BK79_6D_L      _PK_L_(0x79, 0x6D)
#define REG_SC_BK79_6D_H      _PK_H_(0x79, 0x6D)
#define REG_SC_BK79_6E_L      _PK_L_(0x79, 0x6E)
#define REG_SC_BK79_6E_H      _PK_H_(0x79, 0x6E)
#define REG_SC_BK79_6F_L      _PK_L_(0x79, 0x6F)
#define REG_SC_BK79_6F_H      _PK_H_(0x79, 0x6F)
#define REG_SC_BK79_70_L      _PK_L_(0x79, 0x70)
#define REG_SC_BK79_70_H      _PK_H_(0x79, 0x70)
#define REG_SC_BK79_71_L      _PK_L_(0x79, 0x71)
#define REG_SC_BK79_71_H      _PK_H_(0x79, 0x71)
#define REG_SC_BK79_72_L      _PK_L_(0x79, 0x72)
#define REG_SC_BK79_72_H      _PK_H_(0x79, 0x72)
#define REG_SC_BK79_73_L      _PK_L_(0x79, 0x73)
#define REG_SC_BK79_73_H      _PK_H_(0x79, 0x73)
#define REG_SC_BK79_74_L      _PK_L_(0x79, 0x74)
#define REG_SC_BK79_74_H      _PK_H_(0x79, 0x74)
#define REG_SC_BK79_75_L      _PK_L_(0x79, 0x75)
#define REG_SC_BK79_75_H      _PK_H_(0x79, 0x75)
#define REG_SC_BK79_76_L      _PK_L_(0x79, 0x76)
#define REG_SC_BK79_76_H      _PK_H_(0x79, 0x76)
#define REG_SC_BK79_77_L      _PK_L_(0x79, 0x77)
#define REG_SC_BK79_77_H      _PK_H_(0x79, 0x77)
#define REG_SC_BK79_78_L      _PK_L_(0x79, 0x78)
#define REG_SC_BK79_78_H      _PK_H_(0x79, 0x78)
#define REG_SC_BK79_79_L      _PK_L_(0x79, 0x79)
#define REG_SC_BK79_79_H      _PK_H_(0x79, 0x79)
#define REG_SC_BK79_7A_L      _PK_L_(0x79, 0x7A)
#define REG_SC_BK79_7A_H      _PK_H_(0x79, 0x7A)
#define REG_SC_BK79_7B_L      _PK_L_(0x79, 0x7B)
#define REG_SC_BK79_7B_H      _PK_H_(0x79, 0x7B)
#define REG_SC_BK79_7C_L      _PK_L_(0x79, 0x7C)
#define REG_SC_BK79_7C_H      _PK_H_(0x79, 0x7C)
#define REG_SC_BK79_7D_L      _PK_L_(0x79, 0x7D)
#define REG_SC_BK79_7D_H      _PK_H_(0x79, 0x7D)
#define REG_SC_BK79_7E_L      _PK_L_(0x79, 0x7E)
#define REG_SC_BK79_7E_H      _PK_H_(0x79, 0x7E)
#define REG_SC_BK79_7F_L      _PK_L_(0x79, 0x7F)
#define REG_SC_BK79_7F_H      _PK_H_(0x79, 0x7F)
//----------------------------------------------
#define REG_SC_BK7A_00_L      _PK_L_(0x7A, 0x00)
#define REG_SC_BK7A_00_H      _PK_H_(0x7A, 0x00)
#define REG_SC_BK7A_01_L      _PK_L_(0x7A, 0x01)
#define REG_SC_BK7A_01_H      _PK_H_(0x7A, 0x01)
#define REG_SC_BK7A_02_L      _PK_L_(0x7A, 0x02)
#define REG_SC_BK7A_02_H      _PK_H_(0x7A, 0x02)
#define REG_SC_BK7A_03_L      _PK_L_(0x7A, 0x03)
#define REG_SC_BK7A_03_H      _PK_H_(0x7A, 0x03)
#define REG_SC_BK7A_04_L      _PK_L_(0x7A, 0x04)
#define REG_SC_BK7A_04_H      _PK_H_(0x7A, 0x04)
#define REG_SC_BK7A_05_L      _PK_L_(0x7A, 0x05)
#define REG_SC_BK7A_05_H      _PK_H_(0x7A, 0x05)
#define REG_SC_BK7A_06_L      _PK_L_(0x7A, 0x06)
#define REG_SC_BK7A_06_H      _PK_H_(0x7A, 0x06)
#define REG_SC_BK7A_07_L      _PK_L_(0x7A, 0x07)
#define REG_SC_BK7A_07_H      _PK_H_(0x7A, 0x07)
#define REG_SC_BK7A_08_L      _PK_L_(0x7A, 0x08)
#define REG_SC_BK7A_08_H      _PK_H_(0x7A, 0x08)
#define REG_SC_BK7A_09_L      _PK_L_(0x7A, 0x09)
#define REG_SC_BK7A_09_H      _PK_H_(0x7A, 0x09)
#define REG_SC_BK7A_0A_L      _PK_L_(0x7A, 0x0A)
#define REG_SC_BK7A_0A_H      _PK_H_(0x7A, 0x0A)
#define REG_SC_BK7A_0B_L      _PK_L_(0x7A, 0x0B)
#define REG_SC_BK7A_0B_H      _PK_H_(0x7A, 0x0B)
#define REG_SC_BK7A_0C_L      _PK_L_(0x7A, 0x0C)
#define REG_SC_BK7A_0C_H      _PK_H_(0x7A, 0x0C)
#define REG_SC_BK7A_0D_L      _PK_L_(0x7A, 0x0D)
#define REG_SC_BK7A_0D_H      _PK_H_(0x7A, 0x0D)
#define REG_SC_BK7A_0E_L      _PK_L_(0x7A, 0x0E)
#define REG_SC_BK7A_0E_H      _PK_H_(0x7A, 0x0E)
#define REG_SC_BK7A_0F_L      _PK_L_(0x7A, 0x0F)
#define REG_SC_BK7A_0F_H      _PK_H_(0x7A, 0x0F)
#define REG_SC_BK7A_10_L      _PK_L_(0x7A, 0x10)
#define REG_SC_BK7A_10_H      _PK_H_(0x7A, 0x10)
#define REG_SC_BK7A_11_L      _PK_L_(0x7A, 0x11)
#define REG_SC_BK7A_11_H      _PK_H_(0x7A, 0x11)
#define REG_SC_BK7A_12_L      _PK_L_(0x7A, 0x12)
#define REG_SC_BK7A_12_H      _PK_H_(0x7A, 0x12)
#define REG_SC_BK7A_13_L      _PK_L_(0x7A, 0x13)
#define REG_SC_BK7A_13_H      _PK_H_(0x7A, 0x13)
#define REG_SC_BK7A_14_L      _PK_L_(0x7A, 0x14)
#define REG_SC_BK7A_14_H      _PK_H_(0x7A, 0x14)
#define REG_SC_BK7A_15_L      _PK_L_(0x7A, 0x15)
#define REG_SC_BK7A_15_H      _PK_H_(0x7A, 0x15)
#define REG_SC_BK7A_16_L      _PK_L_(0x7A, 0x16)
#define REG_SC_BK7A_16_H      _PK_H_(0x7A, 0x16)
#define REG_SC_BK7A_17_L      _PK_L_(0x7A, 0x17)
#define REG_SC_BK7A_17_H      _PK_H_(0x7A, 0x17)
#define REG_SC_BK7A_18_L      _PK_L_(0x7A, 0x18)
#define REG_SC_BK7A_18_H      _PK_H_(0x7A, 0x18)
#define REG_SC_BK7A_19_L      _PK_L_(0x7A, 0x19)
#define REG_SC_BK7A_19_H      _PK_H_(0x7A, 0x19)
#define REG_SC_BK7A_1A_L      _PK_L_(0x7A, 0x1A)
#define REG_SC_BK7A_1A_H      _PK_H_(0x7A, 0x1A)
#define REG_SC_BK7A_1B_L      _PK_L_(0x7A, 0x1B)
#define REG_SC_BK7A_1B_H      _PK_H_(0x7A, 0x1B)
#define REG_SC_BK7A_1C_L      _PK_L_(0x7A, 0x1C)
#define REG_SC_BK7A_1C_H      _PK_H_(0x7A, 0x1C)
#define REG_SC_BK7A_1D_L      _PK_L_(0x7A, 0x1D)
#define REG_SC_BK7A_1D_H      _PK_H_(0x7A, 0x1D)
#define REG_SC_BK7A_1E_L      _PK_L_(0x7A, 0x1E)
#define REG_SC_BK7A_1E_H      _PK_H_(0x7A, 0x1E)
#define REG_SC_BK7A_1F_L      _PK_L_(0x7A, 0x1F)
#define REG_SC_BK7A_1F_H      _PK_H_(0x7A, 0x1F)
#define REG_SC_BK7A_20_L      _PK_L_(0x7A, 0x20)
#define REG_SC_BK7A_20_H      _PK_H_(0x7A, 0x20)
#define REG_SC_BK7A_21_L      _PK_L_(0x7A, 0x21)
#define REG_SC_BK7A_21_H      _PK_H_(0x7A, 0x21)
#define REG_SC_BK7A_22_L      _PK_L_(0x7A, 0x22)
#define REG_SC_BK7A_22_H      _PK_H_(0x7A, 0x22)
#define REG_SC_BK7A_23_L      _PK_L_(0x7A, 0x23)
#define REG_SC_BK7A_23_H      _PK_H_(0x7A, 0x23)
#define REG_SC_BK7A_24_L      _PK_L_(0x7A, 0x24)
#define REG_SC_BK7A_24_H      _PK_H_(0x7A, 0x24)
#define REG_SC_BK7A_25_L      _PK_L_(0x7A, 0x25)
#define REG_SC_BK7A_25_H      _PK_H_(0x7A, 0x25)
#define REG_SC_BK7A_26_L      _PK_L_(0x7A, 0x26)
#define REG_SC_BK7A_26_H      _PK_H_(0x7A, 0x26)
#define REG_SC_BK7A_27_L      _PK_L_(0x7A, 0x27)
#define REG_SC_BK7A_27_H      _PK_H_(0x7A, 0x27)
#define REG_SC_BK7A_28_L      _PK_L_(0x7A, 0x28)
#define REG_SC_BK7A_28_H      _PK_H_(0x7A, 0x28)
#define REG_SC_BK7A_29_L      _PK_L_(0x7A, 0x29)
#define REG_SC_BK7A_29_H      _PK_H_(0x7A, 0x29)
#define REG_SC_BK7A_2A_L      _PK_L_(0x7A, 0x2A)
#define REG_SC_BK7A_2A_H      _PK_H_(0x7A, 0x2A)
#define REG_SC_BK7A_2B_L      _PK_L_(0x7A, 0x2B)
#define REG_SC_BK7A_2B_H      _PK_H_(0x7A, 0x2B)
#define REG_SC_BK7A_2C_L      _PK_L_(0x7A, 0x2C)
#define REG_SC_BK7A_2C_H      _PK_H_(0x7A, 0x2C)
#define REG_SC_BK7A_2D_L      _PK_L_(0x7A, 0x2D)
#define REG_SC_BK7A_2D_H      _PK_H_(0x7A, 0x2D)
#define REG_SC_BK7A_2E_L      _PK_L_(0x7A, 0x2E)
#define REG_SC_BK7A_2E_H      _PK_H_(0x7A, 0x2E)
#define REG_SC_BK7A_2F_L      _PK_L_(0x7A, 0x2F)
#define REG_SC_BK7A_2F_H      _PK_H_(0x7A, 0x2F)
#define REG_SC_BK7A_30_L      _PK_L_(0x7A, 0x30)
#define REG_SC_BK7A_30_H      _PK_H_(0x7A, 0x30)
#define REG_SC_BK7A_31_L      _PK_L_(0x7A, 0x31)
#define REG_SC_BK7A_31_H      _PK_H_(0x7A, 0x31)
#define REG_SC_BK7A_32_L      _PK_L_(0x7A, 0x32)
#define REG_SC_BK7A_32_H      _PK_H_(0x7A, 0x32)
#define REG_SC_BK7A_33_L      _PK_L_(0x7A, 0x33)
#define REG_SC_BK7A_33_H      _PK_H_(0x7A, 0x33)
#define REG_SC_BK7A_34_L      _PK_L_(0x7A, 0x34)
#define REG_SC_BK7A_34_H      _PK_H_(0x7A, 0x34)
#define REG_SC_BK7A_35_L      _PK_L_(0x7A, 0x35)
#define REG_SC_BK7A_35_H      _PK_H_(0x7A, 0x35)
#define REG_SC_BK7A_36_L      _PK_L_(0x7A, 0x36)
#define REG_SC_BK7A_36_H      _PK_H_(0x7A, 0x36)
#define REG_SC_BK7A_37_L      _PK_L_(0x7A, 0x37)
#define REG_SC_BK7A_37_H      _PK_H_(0x7A, 0x37)
#define REG_SC_BK7A_38_L      _PK_L_(0x7A, 0x38)
#define REG_SC_BK7A_38_H      _PK_H_(0x7A, 0x38)
#define REG_SC_BK7A_39_L      _PK_L_(0x7A, 0x39)
#define REG_SC_BK7A_39_H      _PK_H_(0x7A, 0x39)
#define REG_SC_BK7A_3A_L      _PK_L_(0x7A, 0x3A)
#define REG_SC_BK7A_3A_H      _PK_H_(0x7A, 0x3A)
#define REG_SC_BK7A_3B_L      _PK_L_(0x7A, 0x3B)
#define REG_SC_BK7A_3B_H      _PK_H_(0x7A, 0x3B)
#define REG_SC_BK7A_3C_L      _PK_L_(0x7A, 0x3C)
#define REG_SC_BK7A_3C_H      _PK_H_(0x7A, 0x3C)
#define REG_SC_BK7A_3D_L      _PK_L_(0x7A, 0x3D)
#define REG_SC_BK7A_3D_H      _PK_H_(0x7A, 0x3D)
#define REG_SC_BK7A_3E_L      _PK_L_(0x7A, 0x3E)
#define REG_SC_BK7A_3E_H      _PK_H_(0x7A, 0x3E)
#define REG_SC_BK7A_3F_L      _PK_L_(0x7A, 0x3F)
#define REG_SC_BK7A_3F_H      _PK_H_(0x7A, 0x3F)
#define REG_SC_BK7A_40_L      _PK_L_(0x7A, 0x40)
#define REG_SC_BK7A_40_H      _PK_H_(0x7A, 0x40)
#define REG_SC_BK7A_41_L      _PK_L_(0x7A, 0x41)
#define REG_SC_BK7A_41_H      _PK_H_(0x7A, 0x41)
#define REG_SC_BK7A_42_L      _PK_L_(0x7A, 0x42)
#define REG_SC_BK7A_42_H      _PK_H_(0x7A, 0x42)
#define REG_SC_BK7A_43_L      _PK_L_(0x7A, 0x43)
#define REG_SC_BK7A_43_H      _PK_H_(0x7A, 0x43)
#define REG_SC_BK7A_44_L      _PK_L_(0x7A, 0x44)
#define REG_SC_BK7A_44_H      _PK_H_(0x7A, 0x44)
#define REG_SC_BK7A_45_L      _PK_L_(0x7A, 0x45)
#define REG_SC_BK7A_45_H      _PK_H_(0x7A, 0x45)
#define REG_SC_BK7A_46_L      _PK_L_(0x7A, 0x46)
#define REG_SC_BK7A_46_H      _PK_H_(0x7A, 0x46)
#define REG_SC_BK7A_47_L      _PK_L_(0x7A, 0x47)
#define REG_SC_BK7A_47_H      _PK_H_(0x7A, 0x47)
#define REG_SC_BK7A_48_L      _PK_L_(0x7A, 0x48)
#define REG_SC_BK7A_48_H      _PK_H_(0x7A, 0x48)
#define REG_SC_BK7A_49_L      _PK_L_(0x7A, 0x49)
#define REG_SC_BK7A_49_H      _PK_H_(0x7A, 0x49)
#define REG_SC_BK7A_4A_L      _PK_L_(0x7A, 0x4A)
#define REG_SC_BK7A_4A_H      _PK_H_(0x7A, 0x4A)
#define REG_SC_BK7A_4B_L      _PK_L_(0x7A, 0x4B)
#define REG_SC_BK7A_4B_H      _PK_H_(0x7A, 0x4B)
#define REG_SC_BK7A_4C_L      _PK_L_(0x7A, 0x4C)
#define REG_SC_BK7A_4C_H      _PK_H_(0x7A, 0x4C)
#define REG_SC_BK7A_4D_L      _PK_L_(0x7A, 0x4D)
#define REG_SC_BK7A_4D_H      _PK_H_(0x7A, 0x4D)
#define REG_SC_BK7A_4E_L      _PK_L_(0x7A, 0x4E)
#define REG_SC_BK7A_4E_H      _PK_H_(0x7A, 0x4E)
#define REG_SC_BK7A_4F_L      _PK_L_(0x7A, 0x4F)
#define REG_SC_BK7A_4F_H      _PK_H_(0x7A, 0x4F)
#define REG_SC_BK7A_50_L      _PK_L_(0x7A, 0x50)
#define REG_SC_BK7A_50_H      _PK_H_(0x7A, 0x50)
#define REG_SC_BK7A_51_L      _PK_L_(0x7A, 0x51)
#define REG_SC_BK7A_51_H      _PK_H_(0x7A, 0x51)
#define REG_SC_BK7A_52_L      _PK_L_(0x7A, 0x52)
#define REG_SC_BK7A_52_H      _PK_H_(0x7A, 0x52)
#define REG_SC_BK7A_53_L      _PK_L_(0x7A, 0x53)
#define REG_SC_BK7A_53_H      _PK_H_(0x7A, 0x53)
#define REG_SC_BK7A_54_L      _PK_L_(0x7A, 0x54)
#define REG_SC_BK7A_54_H      _PK_H_(0x7A, 0x54)
#define REG_SC_BK7A_55_L      _PK_L_(0x7A, 0x55)
#define REG_SC_BK7A_55_H      _PK_H_(0x7A, 0x55)
#define REG_SC_BK7A_56_L      _PK_L_(0x7A, 0x56)
#define REG_SC_BK7A_56_H      _PK_H_(0x7A, 0x56)
#define REG_SC_BK7A_57_L      _PK_L_(0x7A, 0x57)
#define REG_SC_BK7A_57_H      _PK_H_(0x7A, 0x57)
#define REG_SC_BK7A_58_L      _PK_L_(0x7A, 0x58)
#define REG_SC_BK7A_58_H      _PK_H_(0x7A, 0x58)
#define REG_SC_BK7A_59_L      _PK_L_(0x7A, 0x59)
#define REG_SC_BK7A_59_H      _PK_H_(0x7A, 0x59)
#define REG_SC_BK7A_5A_L      _PK_L_(0x7A, 0x5A)
#define REG_SC_BK7A_5A_H      _PK_H_(0x7A, 0x5A)
#define REG_SC_BK7A_5B_L      _PK_L_(0x7A, 0x5B)
#define REG_SC_BK7A_5B_H      _PK_H_(0x7A, 0x5B)
#define REG_SC_BK7A_5C_L      _PK_L_(0x7A, 0x5C)
#define REG_SC_BK7A_5C_H      _PK_H_(0x7A, 0x5C)
#define REG_SC_BK7A_5D_L      _PK_L_(0x7A, 0x5D)
#define REG_SC_BK7A_5D_H      _PK_H_(0x7A, 0x5D)
#define REG_SC_BK7A_5E_L      _PK_L_(0x7A, 0x5E)
#define REG_SC_BK7A_5E_H      _PK_H_(0x7A, 0x5E)
#define REG_SC_BK7A_5F_L      _PK_L_(0x7A, 0x5F)
#define REG_SC_BK7A_5F_H      _PK_H_(0x7A, 0x5F)
#define REG_SC_BK7A_60_L      _PK_L_(0x7A, 0x60)
#define REG_SC_BK7A_60_H      _PK_H_(0x7A, 0x60)
#define REG_SC_BK7A_61_L      _PK_L_(0x7A, 0x61)
#define REG_SC_BK7A_61_H      _PK_H_(0x7A, 0x61)
#define REG_SC_BK7A_62_L      _PK_L_(0x7A, 0x62)
#define REG_SC_BK7A_62_H      _PK_H_(0x7A, 0x62)
#define REG_SC_BK7A_63_L      _PK_L_(0x7A, 0x63)
#define REG_SC_BK7A_63_H      _PK_H_(0x7A, 0x63)
#define REG_SC_BK7A_64_L      _PK_L_(0x7A, 0x64)
#define REG_SC_BK7A_64_H      _PK_H_(0x7A, 0x64)
#define REG_SC_BK7A_65_L      _PK_L_(0x7A, 0x65)
#define REG_SC_BK7A_65_H      _PK_H_(0x7A, 0x65)
#define REG_SC_BK7A_66_L      _PK_L_(0x7A, 0x66)
#define REG_SC_BK7A_66_H      _PK_H_(0x7A, 0x66)
#define REG_SC_BK7A_67_L      _PK_L_(0x7A, 0x67)
#define REG_SC_BK7A_67_H      _PK_H_(0x7A, 0x67)
#define REG_SC_BK7A_68_L      _PK_L_(0x7A, 0x68)
#define REG_SC_BK7A_68_H      _PK_H_(0x7A, 0x68)
#define REG_SC_BK7A_69_L      _PK_L_(0x7A, 0x69)
#define REG_SC_BK7A_69_H      _PK_H_(0x7A, 0x69)
#define REG_SC_BK7A_6A_L      _PK_L_(0x7A, 0x6A)
#define REG_SC_BK7A_6A_H      _PK_H_(0x7A, 0x6A)
#define REG_SC_BK7A_6B_L      _PK_L_(0x7A, 0x6B)
#define REG_SC_BK7A_6B_H      _PK_H_(0x7A, 0x6B)
#define REG_SC_BK7A_6C_L      _PK_L_(0x7A, 0x6C)
#define REG_SC_BK7A_6C_H      _PK_H_(0x7A, 0x6C)
#define REG_SC_BK7A_6D_L      _PK_L_(0x7A, 0x6D)
#define REG_SC_BK7A_6D_H      _PK_H_(0x7A, 0x6D)
#define REG_SC_BK7A_6E_L      _PK_L_(0x7A, 0x6E)
#define REG_SC_BK7A_6E_H      _PK_H_(0x7A, 0x6E)
#define REG_SC_BK7A_6F_L      _PK_L_(0x7A, 0x6F)
#define REG_SC_BK7A_6F_H      _PK_H_(0x7A, 0x6F)
#define REG_SC_BK7A_70_L      _PK_L_(0x7A, 0x70)
#define REG_SC_BK7A_70_H      _PK_H_(0x7A, 0x70)
#define REG_SC_BK7A_71_L      _PK_L_(0x7A, 0x71)
#define REG_SC_BK7A_71_H      _PK_H_(0x7A, 0x71)
#define REG_SC_BK7A_72_L      _PK_L_(0x7A, 0x72)
#define REG_SC_BK7A_72_H      _PK_H_(0x7A, 0x72)
#define REG_SC_BK7A_73_L      _PK_L_(0x7A, 0x73)
#define REG_SC_BK7A_73_H      _PK_H_(0x7A, 0x73)
#define REG_SC_BK7A_74_L      _PK_L_(0x7A, 0x74)
#define REG_SC_BK7A_74_H      _PK_H_(0x7A, 0x74)
#define REG_SC_BK7A_75_L      _PK_L_(0x7A, 0x75)
#define REG_SC_BK7A_75_H      _PK_H_(0x7A, 0x75)
#define REG_SC_BK7A_76_L      _PK_L_(0x7A, 0x76)
#define REG_SC_BK7A_76_H      _PK_H_(0x7A, 0x76)
#define REG_SC_BK7A_77_L      _PK_L_(0x7A, 0x77)
#define REG_SC_BK7A_77_H      _PK_H_(0x7A, 0x77)
#define REG_SC_BK7A_78_L      _PK_L_(0x7A, 0x78)
#define REG_SC_BK7A_78_H      _PK_H_(0x7A, 0x78)
#define REG_SC_BK7A_79_L      _PK_L_(0x7A, 0x79)
#define REG_SC_BK7A_79_H      _PK_H_(0x7A, 0x79)
#define REG_SC_BK7A_7A_L      _PK_L_(0x7A, 0x7A)
#define REG_SC_BK7A_7A_H      _PK_H_(0x7A, 0x7A)
#define REG_SC_BK7A_7B_L      _PK_L_(0x7A, 0x7B)
#define REG_SC_BK7A_7B_H      _PK_H_(0x7A, 0x7B)
#define REG_SC_BK7A_7C_L      _PK_L_(0x7A, 0x7C)
#define REG_SC_BK7A_7C_H      _PK_H_(0x7A, 0x7C)
#define REG_SC_BK7A_7D_L      _PK_L_(0x7A, 0x7D)
#define REG_SC_BK7A_7D_H      _PK_H_(0x7A, 0x7D)
#define REG_SC_BK7A_7E_L      _PK_L_(0x7A, 0x7E)
#define REG_SC_BK7A_7E_H      _PK_H_(0x7A, 0x7E)
#define REG_SC_BK7A_7F_L      _PK_L_(0x7A, 0x7F)
#define REG_SC_BK7A_7F_H      _PK_H_(0x7A, 0x7F)
//----------------------------------------------
#define REG_SC_BK7B_00_L      _PK_L_(0x7B, 0x00)
#define REG_SC_BK7B_00_H      _PK_H_(0x7B, 0x00)
#define REG_SC_BK7B_01_L      _PK_L_(0x7B, 0x01)
#define REG_SC_BK7B_01_H      _PK_H_(0x7B, 0x01)
#define REG_SC_BK7B_02_L      _PK_L_(0x7B, 0x02)
#define REG_SC_BK7B_02_H      _PK_H_(0x7B, 0x02)
#define REG_SC_BK7B_03_L      _PK_L_(0x7B, 0x03)
#define REG_SC_BK7B_03_H      _PK_H_(0x7B, 0x03)
#define REG_SC_BK7B_04_L      _PK_L_(0x7B, 0x04)
#define REG_SC_BK7B_04_H      _PK_H_(0x7B, 0x04)
#define REG_SC_BK7B_05_L      _PK_L_(0x7B, 0x05)
#define REG_SC_BK7B_05_H      _PK_H_(0x7B, 0x05)
#define REG_SC_BK7B_06_L      _PK_L_(0x7B, 0x06)
#define REG_SC_BK7B_06_H      _PK_H_(0x7B, 0x06)
#define REG_SC_BK7B_07_L      _PK_L_(0x7B, 0x07)
#define REG_SC_BK7B_07_H      _PK_H_(0x7B, 0x07)
#define REG_SC_BK7B_08_L      _PK_L_(0x7B, 0x08)
#define REG_SC_BK7B_08_H      _PK_H_(0x7B, 0x08)
#define REG_SC_BK7B_09_L      _PK_L_(0x7B, 0x09)
#define REG_SC_BK7B_09_H      _PK_H_(0x7B, 0x09)
#define REG_SC_BK7B_0A_L      _PK_L_(0x7B, 0x0A)
#define REG_SC_BK7B_0A_H      _PK_H_(0x7B, 0x0A)
#define REG_SC_BK7B_0B_L      _PK_L_(0x7B, 0x0B)
#define REG_SC_BK7B_0B_H      _PK_H_(0x7B, 0x0B)
#define REG_SC_BK7B_0C_L      _PK_L_(0x7B, 0x0C)
#define REG_SC_BK7B_0C_H      _PK_H_(0x7B, 0x0C)
#define REG_SC_BK7B_0D_L      _PK_L_(0x7B, 0x0D)
#define REG_SC_BK7B_0D_H      _PK_H_(0x7B, 0x0D)
#define REG_SC_BK7B_0E_L      _PK_L_(0x7B, 0x0E)
#define REG_SC_BK7B_0E_H      _PK_H_(0x7B, 0x0E)
#define REG_SC_BK7B_0F_L      _PK_L_(0x7B, 0x0F)
#define REG_SC_BK7B_0F_H      _PK_H_(0x7B, 0x0F)
#define REG_SC_BK7B_10_L      _PK_L_(0x7B, 0x10)
#define REG_SC_BK7B_10_H      _PK_H_(0x7B, 0x10)
#define REG_SC_BK7B_11_L      _PK_L_(0x7B, 0x11)
#define REG_SC_BK7B_11_H      _PK_H_(0x7B, 0x11)
#define REG_SC_BK7B_12_L      _PK_L_(0x7B, 0x12)
#define REG_SC_BK7B_12_H      _PK_H_(0x7B, 0x12)
#define REG_SC_BK7B_13_L      _PK_L_(0x7B, 0x13)
#define REG_SC_BK7B_13_H      _PK_H_(0x7B, 0x13)
#define REG_SC_BK7B_14_L      _PK_L_(0x7B, 0x14)
#define REG_SC_BK7B_14_H      _PK_H_(0x7B, 0x14)
#define REG_SC_BK7B_15_L      _PK_L_(0x7B, 0x15)
#define REG_SC_BK7B_15_H      _PK_H_(0x7B, 0x15)
#define REG_SC_BK7B_16_L      _PK_L_(0x7B, 0x16)
#define REG_SC_BK7B_16_H      _PK_H_(0x7B, 0x16)
#define REG_SC_BK7B_17_L      _PK_L_(0x7B, 0x17)
#define REG_SC_BK7B_17_H      _PK_H_(0x7B, 0x17)
#define REG_SC_BK7B_18_L      _PK_L_(0x7B, 0x18)
#define REG_SC_BK7B_18_H      _PK_H_(0x7B, 0x18)
#define REG_SC_BK7B_19_L      _PK_L_(0x7B, 0x19)
#define REG_SC_BK7B_19_H      _PK_H_(0x7B, 0x19)
#define REG_SC_BK7B_1A_L      _PK_L_(0x7B, 0x1A)
#define REG_SC_BK7B_1A_H      _PK_H_(0x7B, 0x1A)
#define REG_SC_BK7B_1B_L      _PK_L_(0x7B, 0x1B)
#define REG_SC_BK7B_1B_H      _PK_H_(0x7B, 0x1B)
#define REG_SC_BK7B_1C_L      _PK_L_(0x7B, 0x1C)
#define REG_SC_BK7B_1C_H      _PK_H_(0x7B, 0x1C)
#define REG_SC_BK7B_1D_L      _PK_L_(0x7B, 0x1D)
#define REG_SC_BK7B_1D_H      _PK_H_(0x7B, 0x1D)
#define REG_SC_BK7B_1E_L      _PK_L_(0x7B, 0x1E)
#define REG_SC_BK7B_1E_H      _PK_H_(0x7B, 0x1E)
#define REG_SC_BK7B_1F_L      _PK_L_(0x7B, 0x1F)
#define REG_SC_BK7B_1F_H      _PK_H_(0x7B, 0x1F)
#define REG_SC_BK7B_20_L      _PK_L_(0x7B, 0x20)
#define REG_SC_BK7B_20_H      _PK_H_(0x7B, 0x20)
#define REG_SC_BK7B_21_L      _PK_L_(0x7B, 0x21)
#define REG_SC_BK7B_21_H      _PK_H_(0x7B, 0x21)
#define REG_SC_BK7B_22_L      _PK_L_(0x7B, 0x22)
#define REG_SC_BK7B_22_H      _PK_H_(0x7B, 0x22)
#define REG_SC_BK7B_23_L      _PK_L_(0x7B, 0x23)
#define REG_SC_BK7B_23_H      _PK_H_(0x7B, 0x23)
#define REG_SC_BK7B_24_L      _PK_L_(0x7B, 0x24)
#define REG_SC_BK7B_24_H      _PK_H_(0x7B, 0x24)
#define REG_SC_BK7B_25_L      _PK_L_(0x7B, 0x25)
#define REG_SC_BK7B_25_H      _PK_H_(0x7B, 0x25)
#define REG_SC_BK7B_26_L      _PK_L_(0x7B, 0x26)
#define REG_SC_BK7B_26_H      _PK_H_(0x7B, 0x26)
#define REG_SC_BK7B_27_L      _PK_L_(0x7B, 0x27)
#define REG_SC_BK7B_27_H      _PK_H_(0x7B, 0x27)
#define REG_SC_BK7B_28_L      _PK_L_(0x7B, 0x28)
#define REG_SC_BK7B_28_H      _PK_H_(0x7B, 0x28)
#define REG_SC_BK7B_29_L      _PK_L_(0x7B, 0x29)
#define REG_SC_BK7B_29_H      _PK_H_(0x7B, 0x29)
#define REG_SC_BK7B_2A_L      _PK_L_(0x7B, 0x2A)
#define REG_SC_BK7B_2A_H      _PK_H_(0x7B, 0x2A)
#define REG_SC_BK7B_2B_L      _PK_L_(0x7B, 0x2B)
#define REG_SC_BK7B_2B_H      _PK_H_(0x7B, 0x2B)
#define REG_SC_BK7B_2C_L      _PK_L_(0x7B, 0x2C)
#define REG_SC_BK7B_2C_H      _PK_H_(0x7B, 0x2C)
#define REG_SC_BK7B_2D_L      _PK_L_(0x7B, 0x2D)
#define REG_SC_BK7B_2D_H      _PK_H_(0x7B, 0x2D)
#define REG_SC_BK7B_2E_L      _PK_L_(0x7B, 0x2E)
#define REG_SC_BK7B_2E_H      _PK_H_(0x7B, 0x2E)
#define REG_SC_BK7B_2F_L      _PK_L_(0x7B, 0x2F)
#define REG_SC_BK7B_2F_H      _PK_H_(0x7B, 0x2F)
#define REG_SC_BK7B_30_L      _PK_L_(0x7B, 0x30)
#define REG_SC_BK7B_30_H      _PK_H_(0x7B, 0x30)
#define REG_SC_BK7B_31_L      _PK_L_(0x7B, 0x31)
#define REG_SC_BK7B_31_H      _PK_H_(0x7B, 0x31)
#define REG_SC_BK7B_32_L      _PK_L_(0x7B, 0x32)
#define REG_SC_BK7B_32_H      _PK_H_(0x7B, 0x32)
#define REG_SC_BK7B_33_L      _PK_L_(0x7B, 0x33)
#define REG_SC_BK7B_33_H      _PK_H_(0x7B, 0x33)
#define REG_SC_BK7B_34_L      _PK_L_(0x7B, 0x34)
#define REG_SC_BK7B_34_H      _PK_H_(0x7B, 0x34)
#define REG_SC_BK7B_35_L      _PK_L_(0x7B, 0x35)
#define REG_SC_BK7B_35_H      _PK_H_(0x7B, 0x35)
#define REG_SC_BK7B_36_L      _PK_L_(0x7B, 0x36)
#define REG_SC_BK7B_36_H      _PK_H_(0x7B, 0x36)
#define REG_SC_BK7B_37_L      _PK_L_(0x7B, 0x37)
#define REG_SC_BK7B_37_H      _PK_H_(0x7B, 0x37)
#define REG_SC_BK7B_38_L      _PK_L_(0x7B, 0x38)
#define REG_SC_BK7B_38_H      _PK_H_(0x7B, 0x38)
#define REG_SC_BK7B_39_L      _PK_L_(0x7B, 0x39)
#define REG_SC_BK7B_39_H      _PK_H_(0x7B, 0x39)
#define REG_SC_BK7B_3A_L      _PK_L_(0x7B, 0x3A)
#define REG_SC_BK7B_3A_H      _PK_H_(0x7B, 0x3A)
#define REG_SC_BK7B_3B_L      _PK_L_(0x7B, 0x3B)
#define REG_SC_BK7B_3B_H      _PK_H_(0x7B, 0x3B)
#define REG_SC_BK7B_3C_L      _PK_L_(0x7B, 0x3C)
#define REG_SC_BK7B_3C_H      _PK_H_(0x7B, 0x3C)
#define REG_SC_BK7B_3D_L      _PK_L_(0x7B, 0x3D)
#define REG_SC_BK7B_3D_H      _PK_H_(0x7B, 0x3D)
#define REG_SC_BK7B_3E_L      _PK_L_(0x7B, 0x3E)
#define REG_SC_BK7B_3E_H      _PK_H_(0x7B, 0x3E)
#define REG_SC_BK7B_3F_L      _PK_L_(0x7B, 0x3F)
#define REG_SC_BK7B_3F_H      _PK_H_(0x7B, 0x3F)
#define REG_SC_BK7B_40_L      _PK_L_(0x7B, 0x40)
#define REG_SC_BK7B_40_H      _PK_H_(0x7B, 0x40)
#define REG_SC_BK7B_41_L      _PK_L_(0x7B, 0x41)
#define REG_SC_BK7B_41_H      _PK_H_(0x7B, 0x41)
#define REG_SC_BK7B_42_L      _PK_L_(0x7B, 0x42)
#define REG_SC_BK7B_42_H      _PK_H_(0x7B, 0x42)
#define REG_SC_BK7B_43_L      _PK_L_(0x7B, 0x43)
#define REG_SC_BK7B_43_H      _PK_H_(0x7B, 0x43)
#define REG_SC_BK7B_44_L      _PK_L_(0x7B, 0x44)
#define REG_SC_BK7B_44_H      _PK_H_(0x7B, 0x44)
#define REG_SC_BK7B_45_L      _PK_L_(0x7B, 0x45)
#define REG_SC_BK7B_45_H      _PK_H_(0x7B, 0x45)
#define REG_SC_BK7B_46_L      _PK_L_(0x7B, 0x46)
#define REG_SC_BK7B_46_H      _PK_H_(0x7B, 0x46)
#define REG_SC_BK7B_47_L      _PK_L_(0x7B, 0x47)
#define REG_SC_BK7B_47_H      _PK_H_(0x7B, 0x47)
#define REG_SC_BK7B_48_L      _PK_L_(0x7B, 0x48)
#define REG_SC_BK7B_48_H      _PK_H_(0x7B, 0x48)
#define REG_SC_BK7B_49_L      _PK_L_(0x7B, 0x49)
#define REG_SC_BK7B_49_H      _PK_H_(0x7B, 0x49)
#define REG_SC_BK7B_4A_L      _PK_L_(0x7B, 0x4A)
#define REG_SC_BK7B_4A_H      _PK_H_(0x7B, 0x4A)
#define REG_SC_BK7B_4B_L      _PK_L_(0x7B, 0x4B)
#define REG_SC_BK7B_4B_H      _PK_H_(0x7B, 0x4B)
#define REG_SC_BK7B_4C_L      _PK_L_(0x7B, 0x4C)
#define REG_SC_BK7B_4C_H      _PK_H_(0x7B, 0x4C)
#define REG_SC_BK7B_4D_L      _PK_L_(0x7B, 0x4D)
#define REG_SC_BK7B_4D_H      _PK_H_(0x7B, 0x4D)
#define REG_SC_BK7B_4E_L      _PK_L_(0x7B, 0x4E)
#define REG_SC_BK7B_4E_H      _PK_H_(0x7B, 0x4E)
#define REG_SC_BK7B_4F_L      _PK_L_(0x7B, 0x4F)
#define REG_SC_BK7B_4F_H      _PK_H_(0x7B, 0x4F)
#define REG_SC_BK7B_50_L      _PK_L_(0x7B, 0x50)
#define REG_SC_BK7B_50_H      _PK_H_(0x7B, 0x50)
#define REG_SC_BK7B_51_L      _PK_L_(0x7B, 0x51)
#define REG_SC_BK7B_51_H      _PK_H_(0x7B, 0x51)
#define REG_SC_BK7B_52_L      _PK_L_(0x7B, 0x52)
#define REG_SC_BK7B_52_H      _PK_H_(0x7B, 0x52)
#define REG_SC_BK7B_53_L      _PK_L_(0x7B, 0x53)
#define REG_SC_BK7B_53_H      _PK_H_(0x7B, 0x53)
#define REG_SC_BK7B_54_L      _PK_L_(0x7B, 0x54)
#define REG_SC_BK7B_54_H      _PK_H_(0x7B, 0x54)
#define REG_SC_BK7B_55_L      _PK_L_(0x7B, 0x55)
#define REG_SC_BK7B_55_H      _PK_H_(0x7B, 0x55)
#define REG_SC_BK7B_56_L      _PK_L_(0x7B, 0x56)
#define REG_SC_BK7B_56_H      _PK_H_(0x7B, 0x56)
#define REG_SC_BK7B_57_L      _PK_L_(0x7B, 0x57)
#define REG_SC_BK7B_57_H      _PK_H_(0x7B, 0x57)
#define REG_SC_BK7B_58_L      _PK_L_(0x7B, 0x58)
#define REG_SC_BK7B_58_H      _PK_H_(0x7B, 0x58)
#define REG_SC_BK7B_59_L      _PK_L_(0x7B, 0x59)
#define REG_SC_BK7B_59_H      _PK_H_(0x7B, 0x59)
#define REG_SC_BK7B_5A_L      _PK_L_(0x7B, 0x5A)
#define REG_SC_BK7B_5A_H      _PK_H_(0x7B, 0x5A)
#define REG_SC_BK7B_5B_L      _PK_L_(0x7B, 0x5B)
#define REG_SC_BK7B_5B_H      _PK_H_(0x7B, 0x5B)
#define REG_SC_BK7B_5C_L      _PK_L_(0x7B, 0x5C)
#define REG_SC_BK7B_5C_H      _PK_H_(0x7B, 0x5C)
#define REG_SC_BK7B_5D_L      _PK_L_(0x7B, 0x5D)
#define REG_SC_BK7B_5D_H      _PK_H_(0x7B, 0x5D)
#define REG_SC_BK7B_5E_L      _PK_L_(0x7B, 0x5E)
#define REG_SC_BK7B_5E_H      _PK_H_(0x7B, 0x5E)
#define REG_SC_BK7B_5F_L      _PK_L_(0x7B, 0x5F)
#define REG_SC_BK7B_5F_H      _PK_H_(0x7B, 0x5F)
#define REG_SC_BK7B_60_L      _PK_L_(0x7B, 0x60)
#define REG_SC_BK7B_60_H      _PK_H_(0x7B, 0x60)
#define REG_SC_BK7B_61_L      _PK_L_(0x7B, 0x61)
#define REG_SC_BK7B_61_H      _PK_H_(0x7B, 0x61)
#define REG_SC_BK7B_62_L      _PK_L_(0x7B, 0x62)
#define REG_SC_BK7B_62_H      _PK_H_(0x7B, 0x62)
#define REG_SC_BK7B_63_L      _PK_L_(0x7B, 0x63)
#define REG_SC_BK7B_63_H      _PK_H_(0x7B, 0x63)
#define REG_SC_BK7B_64_L      _PK_L_(0x7B, 0x64)
#define REG_SC_BK7B_64_H      _PK_H_(0x7B, 0x64)
#define REG_SC_BK7B_65_L      _PK_L_(0x7B, 0x65)
#define REG_SC_BK7B_65_H      _PK_H_(0x7B, 0x65)
#define REG_SC_BK7B_66_L      _PK_L_(0x7B, 0x66)
#define REG_SC_BK7B_66_H      _PK_H_(0x7B, 0x66)
#define REG_SC_BK7B_67_L      _PK_L_(0x7B, 0x67)
#define REG_SC_BK7B_67_H      _PK_H_(0x7B, 0x67)
#define REG_SC_BK7B_68_L      _PK_L_(0x7B, 0x68)
#define REG_SC_BK7B_68_H      _PK_H_(0x7B, 0x68)
#define REG_SC_BK7B_69_L      _PK_L_(0x7B, 0x69)
#define REG_SC_BK7B_69_H      _PK_H_(0x7B, 0x69)
#define REG_SC_BK7B_6A_L      _PK_L_(0x7B, 0x6A)
#define REG_SC_BK7B_6A_H      _PK_H_(0x7B, 0x6A)
#define REG_SC_BK7B_6B_L      _PK_L_(0x7B, 0x6B)
#define REG_SC_BK7B_6B_H      _PK_H_(0x7B, 0x6B)
#define REG_SC_BK7B_6C_L      _PK_L_(0x7B, 0x6C)
#define REG_SC_BK7B_6C_H      _PK_H_(0x7B, 0x6C)
#define REG_SC_BK7B_6D_L      _PK_L_(0x7B, 0x6D)
#define REG_SC_BK7B_6D_H      _PK_H_(0x7B, 0x6D)
#define REG_SC_BK7B_6E_L      _PK_L_(0x7B, 0x6E)
#define REG_SC_BK7B_6E_H      _PK_H_(0x7B, 0x6E)
#define REG_SC_BK7B_6F_L      _PK_L_(0x7B, 0x6F)
#define REG_SC_BK7B_6F_H      _PK_H_(0x7B, 0x6F)
#define REG_SC_BK7B_70_L      _PK_L_(0x7B, 0x70)
#define REG_SC_BK7B_70_H      _PK_H_(0x7B, 0x70)
#define REG_SC_BK7B_71_L      _PK_L_(0x7B, 0x71)
#define REG_SC_BK7B_71_H      _PK_H_(0x7B, 0x71)
#define REG_SC_BK7B_72_L      _PK_L_(0x7B, 0x72)
#define REG_SC_BK7B_72_H      _PK_H_(0x7B, 0x72)
#define REG_SC_BK7B_73_L      _PK_L_(0x7B, 0x73)
#define REG_SC_BK7B_73_H      _PK_H_(0x7B, 0x73)
#define REG_SC_BK7B_74_L      _PK_L_(0x7B, 0x74)
#define REG_SC_BK7B_74_H      _PK_H_(0x7B, 0x74)
#define REG_SC_BK7B_75_L      _PK_L_(0x7B, 0x75)
#define REG_SC_BK7B_75_H      _PK_H_(0x7B, 0x75)
#define REG_SC_BK7B_76_L      _PK_L_(0x7B, 0x76)
#define REG_SC_BK7B_76_H      _PK_H_(0x7B, 0x76)
#define REG_SC_BK7B_77_L      _PK_L_(0x7B, 0x77)
#define REG_SC_BK7B_77_H      _PK_H_(0x7B, 0x77)
#define REG_SC_BK7B_78_L      _PK_L_(0x7B, 0x78)
#define REG_SC_BK7B_78_H      _PK_H_(0x7B, 0x78)
#define REG_SC_BK7B_79_L      _PK_L_(0x7B, 0x79)
#define REG_SC_BK7B_79_H      _PK_H_(0x7B, 0x79)
#define REG_SC_BK7B_7A_L      _PK_L_(0x7B, 0x7A)
#define REG_SC_BK7B_7A_H      _PK_H_(0x7B, 0x7A)
#define REG_SC_BK7B_7B_L      _PK_L_(0x7B, 0x7B)
#define REG_SC_BK7B_7B_H      _PK_H_(0x7B, 0x7B)
#define REG_SC_BK7B_7C_L      _PK_L_(0x7B, 0x7C)
#define REG_SC_BK7B_7C_H      _PK_H_(0x7B, 0x7C)
#define REG_SC_BK7B_7D_L      _PK_L_(0x7B, 0x7D)
#define REG_SC_BK7B_7D_H      _PK_H_(0x7B, 0x7D)
#define REG_SC_BK7B_7E_L      _PK_L_(0x7B, 0x7E)
#define REG_SC_BK7B_7E_H      _PK_H_(0x7B, 0x7E)
#define REG_SC_BK7B_7F_L      _PK_L_(0x7B, 0x7F)
#define REG_SC_BK7B_7F_H      _PK_H_(0x7B, 0x7F)
//----------------------------------------------
#define REG_SC_BK7C_00_L      _PK_L_(0x7C, 0x00)
#define REG_SC_BK7C_00_H      _PK_H_(0x7C, 0x00)
#define REG_SC_BK7C_01_L      _PK_L_(0x7C, 0x01)
#define REG_SC_BK7C_01_H      _PK_H_(0x7C, 0x01)
#define REG_SC_BK7C_02_L      _PK_L_(0x7C, 0x02)
#define REG_SC_BK7C_02_H      _PK_H_(0x7C, 0x02)
#define REG_SC_BK7C_03_L      _PK_L_(0x7C, 0x03)
#define REG_SC_BK7C_03_H      _PK_H_(0x7C, 0x03)
#define REG_SC_BK7C_04_L      _PK_L_(0x7C, 0x04)
#define REG_SC_BK7C_04_H      _PK_H_(0x7C, 0x04)
#define REG_SC_BK7C_05_L      _PK_L_(0x7C, 0x05)
#define REG_SC_BK7C_05_H      _PK_H_(0x7C, 0x05)
#define REG_SC_BK7C_06_L      _PK_L_(0x7C, 0x06)
#define REG_SC_BK7C_06_H      _PK_H_(0x7C, 0x06)
#define REG_SC_BK7C_07_L      _PK_L_(0x7C, 0x07)
#define REG_SC_BK7C_07_H      _PK_H_(0x7C, 0x07)
#define REG_SC_BK7C_08_L      _PK_L_(0x7C, 0x08)
#define REG_SC_BK7C_08_H      _PK_H_(0x7C, 0x08)
#define REG_SC_BK7C_09_L      _PK_L_(0x7C, 0x09)
#define REG_SC_BK7C_09_H      _PK_H_(0x7C, 0x09)
#define REG_SC_BK7C_0A_L      _PK_L_(0x7C, 0x0A)
#define REG_SC_BK7C_0A_H      _PK_H_(0x7C, 0x0A)
#define REG_SC_BK7C_0B_L      _PK_L_(0x7C, 0x0B)
#define REG_SC_BK7C_0B_H      _PK_H_(0x7C, 0x0B)
#define REG_SC_BK7C_0C_L      _PK_L_(0x7C, 0x0C)
#define REG_SC_BK7C_0C_H      _PK_H_(0x7C, 0x0C)
#define REG_SC_BK7C_0D_L      _PK_L_(0x7C, 0x0D)
#define REG_SC_BK7C_0D_H      _PK_H_(0x7C, 0x0D)
#define REG_SC_BK7C_0E_L      _PK_L_(0x7C, 0x0E)
#define REG_SC_BK7C_0E_H      _PK_H_(0x7C, 0x0E)
#define REG_SC_BK7C_0F_L      _PK_L_(0x7C, 0x0F)
#define REG_SC_BK7C_0F_H      _PK_H_(0x7C, 0x0F)
#define REG_SC_BK7C_10_L      _PK_L_(0x7C, 0x10)
#define REG_SC_BK7C_10_H      _PK_H_(0x7C, 0x10)
#define REG_SC_BK7C_11_L      _PK_L_(0x7C, 0x11)
#define REG_SC_BK7C_11_H      _PK_H_(0x7C, 0x11)
#define REG_SC_BK7C_12_L      _PK_L_(0x7C, 0x12)
#define REG_SC_BK7C_12_H      _PK_H_(0x7C, 0x12)
#define REG_SC_BK7C_13_L      _PK_L_(0x7C, 0x13)
#define REG_SC_BK7C_13_H      _PK_H_(0x7C, 0x13)
#define REG_SC_BK7C_14_L      _PK_L_(0x7C, 0x14)
#define REG_SC_BK7C_14_H      _PK_H_(0x7C, 0x14)
#define REG_SC_BK7C_15_L      _PK_L_(0x7C, 0x15)
#define REG_SC_BK7C_15_H      _PK_H_(0x7C, 0x15)
#define REG_SC_BK7C_16_L      _PK_L_(0x7C, 0x16)
#define REG_SC_BK7C_16_H      _PK_H_(0x7C, 0x16)
#define REG_SC_BK7C_17_L      _PK_L_(0x7C, 0x17)
#define REG_SC_BK7C_17_H      _PK_H_(0x7C, 0x17)
#define REG_SC_BK7C_18_L      _PK_L_(0x7C, 0x18)
#define REG_SC_BK7C_18_H      _PK_H_(0x7C, 0x18)
#define REG_SC_BK7C_19_L      _PK_L_(0x7C, 0x19)
#define REG_SC_BK7C_19_H      _PK_H_(0x7C, 0x19)
#define REG_SC_BK7C_1A_L      _PK_L_(0x7C, 0x1A)
#define REG_SC_BK7C_1A_H      _PK_H_(0x7C, 0x1A)
#define REG_SC_BK7C_1B_L      _PK_L_(0x7C, 0x1B)
#define REG_SC_BK7C_1B_H      _PK_H_(0x7C, 0x1B)
#define REG_SC_BK7C_1C_L      _PK_L_(0x7C, 0x1C)
#define REG_SC_BK7C_1C_H      _PK_H_(0x7C, 0x1C)
#define REG_SC_BK7C_1D_L      _PK_L_(0x7C, 0x1D)
#define REG_SC_BK7C_1D_H      _PK_H_(0x7C, 0x1D)
#define REG_SC_BK7C_1E_L      _PK_L_(0x7C, 0x1E)
#define REG_SC_BK7C_1E_H      _PK_H_(0x7C, 0x1E)
#define REG_SC_BK7C_1F_L      _PK_L_(0x7C, 0x1F)
#define REG_SC_BK7C_1F_H      _PK_H_(0x7C, 0x1F)
#define REG_SC_BK7C_20_L      _PK_L_(0x7C, 0x20)
#define REG_SC_BK7C_20_H      _PK_H_(0x7C, 0x20)
#define REG_SC_BK7C_21_L      _PK_L_(0x7C, 0x21)
#define REG_SC_BK7C_21_H      _PK_H_(0x7C, 0x21)
#define REG_SC_BK7C_22_L      _PK_L_(0x7C, 0x22)
#define REG_SC_BK7C_22_H      _PK_H_(0x7C, 0x22)
#define REG_SC_BK7C_23_L      _PK_L_(0x7C, 0x23)
#define REG_SC_BK7C_23_H      _PK_H_(0x7C, 0x23)
#define REG_SC_BK7C_24_L      _PK_L_(0x7C, 0x24)
#define REG_SC_BK7C_24_H      _PK_H_(0x7C, 0x24)
#define REG_SC_BK7C_25_L      _PK_L_(0x7C, 0x25)
#define REG_SC_BK7C_25_H      _PK_H_(0x7C, 0x25)
#define REG_SC_BK7C_26_L      _PK_L_(0x7C, 0x26)
#define REG_SC_BK7C_26_H      _PK_H_(0x7C, 0x26)
#define REG_SC_BK7C_27_L      _PK_L_(0x7C, 0x27)
#define REG_SC_BK7C_27_H      _PK_H_(0x7C, 0x27)
#define REG_SC_BK7C_28_L      _PK_L_(0x7C, 0x28)
#define REG_SC_BK7C_28_H      _PK_H_(0x7C, 0x28)
#define REG_SC_BK7C_29_L      _PK_L_(0x7C, 0x29)
#define REG_SC_BK7C_29_H      _PK_H_(0x7C, 0x29)
#define REG_SC_BK7C_2A_L      _PK_L_(0x7C, 0x2A)
#define REG_SC_BK7C_2A_H      _PK_H_(0x7C, 0x2A)
#define REG_SC_BK7C_2B_L      _PK_L_(0x7C, 0x2B)
#define REG_SC_BK7C_2B_H      _PK_H_(0x7C, 0x2B)
#define REG_SC_BK7C_2C_L      _PK_L_(0x7C, 0x2C)
#define REG_SC_BK7C_2C_H      _PK_H_(0x7C, 0x2C)
#define REG_SC_BK7C_2D_L      _PK_L_(0x7C, 0x2D)
#define REG_SC_BK7C_2D_H      _PK_H_(0x7C, 0x2D)
#define REG_SC_BK7C_2E_L      _PK_L_(0x7C, 0x2E)
#define REG_SC_BK7C_2E_H      _PK_H_(0x7C, 0x2E)
#define REG_SC_BK7C_2F_L      _PK_L_(0x7C, 0x2F)
#define REG_SC_BK7C_2F_H      _PK_H_(0x7C, 0x2F)
#define REG_SC_BK7C_30_L      _PK_L_(0x7C, 0x30)
#define REG_SC_BK7C_30_H      _PK_H_(0x7C, 0x30)
#define REG_SC_BK7C_31_L      _PK_L_(0x7C, 0x31)
#define REG_SC_BK7C_31_H      _PK_H_(0x7C, 0x31)
#define REG_SC_BK7C_32_L      _PK_L_(0x7C, 0x32)
#define REG_SC_BK7C_32_H      _PK_H_(0x7C, 0x32)
#define REG_SC_BK7C_33_L      _PK_L_(0x7C, 0x33)
#define REG_SC_BK7C_33_H      _PK_H_(0x7C, 0x33)
#define REG_SC_BK7C_34_L      _PK_L_(0x7C, 0x34)
#define REG_SC_BK7C_34_H      _PK_H_(0x7C, 0x34)
#define REG_SC_BK7C_35_L      _PK_L_(0x7C, 0x35)
#define REG_SC_BK7C_35_H      _PK_H_(0x7C, 0x35)
#define REG_SC_BK7C_36_L      _PK_L_(0x7C, 0x36)
#define REG_SC_BK7C_36_H      _PK_H_(0x7C, 0x36)
#define REG_SC_BK7C_37_L      _PK_L_(0x7C, 0x37)
#define REG_SC_BK7C_37_H      _PK_H_(0x7C, 0x37)
#define REG_SC_BK7C_38_L      _PK_L_(0x7C, 0x38)
#define REG_SC_BK7C_38_H      _PK_H_(0x7C, 0x38)
#define REG_SC_BK7C_39_L      _PK_L_(0x7C, 0x39)
#define REG_SC_BK7C_39_H      _PK_H_(0x7C, 0x39)
#define REG_SC_BK7C_3A_L      _PK_L_(0x7C, 0x3A)
#define REG_SC_BK7C_3A_H      _PK_H_(0x7C, 0x3A)
#define REG_SC_BK7C_3B_L      _PK_L_(0x7C, 0x3B)
#define REG_SC_BK7C_3B_H      _PK_H_(0x7C, 0x3B)
#define REG_SC_BK7C_3C_L      _PK_L_(0x7C, 0x3C)
#define REG_SC_BK7C_3C_H      _PK_H_(0x7C, 0x3C)
#define REG_SC_BK7C_3D_L      _PK_L_(0x7C, 0x3D)
#define REG_SC_BK7C_3D_H      _PK_H_(0x7C, 0x3D)
#define REG_SC_BK7C_3E_L      _PK_L_(0x7C, 0x3E)
#define REG_SC_BK7C_3E_H      _PK_H_(0x7C, 0x3E)
#define REG_SC_BK7C_3F_L      _PK_L_(0x7C, 0x3F)
#define REG_SC_BK7C_3F_H      _PK_H_(0x7C, 0x3F)
#define REG_SC_BK7C_40_L      _PK_L_(0x7C, 0x40)
#define REG_SC_BK7C_40_H      _PK_H_(0x7C, 0x40)
#define REG_SC_BK7C_41_L      _PK_L_(0x7C, 0x41)
#define REG_SC_BK7C_41_H      _PK_H_(0x7C, 0x41)
#define REG_SC_BK7C_42_L      _PK_L_(0x7C, 0x42)
#define REG_SC_BK7C_42_H      _PK_H_(0x7C, 0x42)
#define REG_SC_BK7C_43_L      _PK_L_(0x7C, 0x43)
#define REG_SC_BK7C_43_H      _PK_H_(0x7C, 0x43)
#define REG_SC_BK7C_44_L      _PK_L_(0x7C, 0x44)
#define REG_SC_BK7C_44_H      _PK_H_(0x7C, 0x44)
#define REG_SC_BK7C_45_L      _PK_L_(0x7C, 0x45)
#define REG_SC_BK7C_45_H      _PK_H_(0x7C, 0x45)
#define REG_SC_BK7C_46_L      _PK_L_(0x7C, 0x46)
#define REG_SC_BK7C_46_H      _PK_H_(0x7C, 0x46)
#define REG_SC_BK7C_47_L      _PK_L_(0x7C, 0x47)
#define REG_SC_BK7C_47_H      _PK_H_(0x7C, 0x47)
#define REG_SC_BK7C_48_L      _PK_L_(0x7C, 0x48)
#define REG_SC_BK7C_48_H      _PK_H_(0x7C, 0x48)
#define REG_SC_BK7C_49_L      _PK_L_(0x7C, 0x49)
#define REG_SC_BK7C_49_H      _PK_H_(0x7C, 0x49)
#define REG_SC_BK7C_4A_L      _PK_L_(0x7C, 0x4A)
#define REG_SC_BK7C_4A_H      _PK_H_(0x7C, 0x4A)
#define REG_SC_BK7C_4B_L      _PK_L_(0x7C, 0x4B)
#define REG_SC_BK7C_4B_H      _PK_H_(0x7C, 0x4B)
#define REG_SC_BK7C_4C_L      _PK_L_(0x7C, 0x4C)
#define REG_SC_BK7C_4C_H      _PK_H_(0x7C, 0x4C)
#define REG_SC_BK7C_4D_L      _PK_L_(0x7C, 0x4D)
#define REG_SC_BK7C_4D_H      _PK_H_(0x7C, 0x4D)
#define REG_SC_BK7C_4E_L      _PK_L_(0x7C, 0x4E)
#define REG_SC_BK7C_4E_H      _PK_H_(0x7C, 0x4E)
#define REG_SC_BK7C_4F_L      _PK_L_(0x7C, 0x4F)
#define REG_SC_BK7C_4F_H      _PK_H_(0x7C, 0x4F)
#define REG_SC_BK7C_50_L      _PK_L_(0x7C, 0x50)
#define REG_SC_BK7C_50_H      _PK_H_(0x7C, 0x50)
#define REG_SC_BK7C_51_L      _PK_L_(0x7C, 0x51)
#define REG_SC_BK7C_51_H      _PK_H_(0x7C, 0x51)
#define REG_SC_BK7C_52_L      _PK_L_(0x7C, 0x52)
#define REG_SC_BK7C_52_H      _PK_H_(0x7C, 0x52)
#define REG_SC_BK7C_53_L      _PK_L_(0x7C, 0x53)
#define REG_SC_BK7C_53_H      _PK_H_(0x7C, 0x53)
#define REG_SC_BK7C_54_L      _PK_L_(0x7C, 0x54)
#define REG_SC_BK7C_54_H      _PK_H_(0x7C, 0x54)
#define REG_SC_BK7C_55_L      _PK_L_(0x7C, 0x55)
#define REG_SC_BK7C_55_H      _PK_H_(0x7C, 0x55)
#define REG_SC_BK7C_56_L      _PK_L_(0x7C, 0x56)
#define REG_SC_BK7C_56_H      _PK_H_(0x7C, 0x56)
#define REG_SC_BK7C_57_L      _PK_L_(0x7C, 0x57)
#define REG_SC_BK7C_57_H      _PK_H_(0x7C, 0x57)
#define REG_SC_BK7C_58_L      _PK_L_(0x7C, 0x58)
#define REG_SC_BK7C_58_H      _PK_H_(0x7C, 0x58)
#define REG_SC_BK7C_59_L      _PK_L_(0x7C, 0x59)
#define REG_SC_BK7C_59_H      _PK_H_(0x7C, 0x59)
#define REG_SC_BK7C_5A_L      _PK_L_(0x7C, 0x5A)
#define REG_SC_BK7C_5A_H      _PK_H_(0x7C, 0x5A)
#define REG_SC_BK7C_5B_L      _PK_L_(0x7C, 0x5B)
#define REG_SC_BK7C_5B_H      _PK_H_(0x7C, 0x5B)
#define REG_SC_BK7C_5C_L      _PK_L_(0x7C, 0x5C)
#define REG_SC_BK7C_5C_H      _PK_H_(0x7C, 0x5C)
#define REG_SC_BK7C_5D_L      _PK_L_(0x7C, 0x5D)
#define REG_SC_BK7C_5D_H      _PK_H_(0x7C, 0x5D)
#define REG_SC_BK7C_5E_L      _PK_L_(0x7C, 0x5E)
#define REG_SC_BK7C_5E_H      _PK_H_(0x7C, 0x5E)
#define REG_SC_BK7C_5F_L      _PK_L_(0x7C, 0x5F)
#define REG_SC_BK7C_5F_H      _PK_H_(0x7C, 0x5F)
#define REG_SC_BK7C_60_L      _PK_L_(0x7C, 0x60)
#define REG_SC_BK7C_60_H      _PK_H_(0x7C, 0x60)
#define REG_SC_BK7C_61_L      _PK_L_(0x7C, 0x61)
#define REG_SC_BK7C_61_H      _PK_H_(0x7C, 0x61)
#define REG_SC_BK7C_62_L      _PK_L_(0x7C, 0x62)
#define REG_SC_BK7C_62_H      _PK_H_(0x7C, 0x62)
#define REG_SC_BK7C_63_L      _PK_L_(0x7C, 0x63)
#define REG_SC_BK7C_63_H      _PK_H_(0x7C, 0x63)
#define REG_SC_BK7C_64_L      _PK_L_(0x7C, 0x64)
#define REG_SC_BK7C_64_H      _PK_H_(0x7C, 0x64)
#define REG_SC_BK7C_65_L      _PK_L_(0x7C, 0x65)
#define REG_SC_BK7C_65_H      _PK_H_(0x7C, 0x65)
#define REG_SC_BK7C_66_L      _PK_L_(0x7C, 0x66)
#define REG_SC_BK7C_66_H      _PK_H_(0x7C, 0x66)
#define REG_SC_BK7C_67_L      _PK_L_(0x7C, 0x67)
#define REG_SC_BK7C_67_H      _PK_H_(0x7C, 0x67)
#define REG_SC_BK7C_68_L      _PK_L_(0x7C, 0x68)
#define REG_SC_BK7C_68_H      _PK_H_(0x7C, 0x68)
#define REG_SC_BK7C_69_L      _PK_L_(0x7C, 0x69)
#define REG_SC_BK7C_69_H      _PK_H_(0x7C, 0x69)
#define REG_SC_BK7C_6A_L      _PK_L_(0x7C, 0x6A)
#define REG_SC_BK7C_6A_H      _PK_H_(0x7C, 0x6A)
#define REG_SC_BK7C_6B_L      _PK_L_(0x7C, 0x6B)
#define REG_SC_BK7C_6B_H      _PK_H_(0x7C, 0x6B)
#define REG_SC_BK7C_6C_L      _PK_L_(0x7C, 0x6C)
#define REG_SC_BK7C_6C_H      _PK_H_(0x7C, 0x6C)
#define REG_SC_BK7C_6D_L      _PK_L_(0x7C, 0x6D)
#define REG_SC_BK7C_6D_H      _PK_H_(0x7C, 0x6D)
#define REG_SC_BK7C_6E_L      _PK_L_(0x7C, 0x6E)
#define REG_SC_BK7C_6E_H      _PK_H_(0x7C, 0x6E)
#define REG_SC_BK7C_6F_L      _PK_L_(0x7C, 0x6F)
#define REG_SC_BK7C_6F_H      _PK_H_(0x7C, 0x6F)
#define REG_SC_BK7C_70_L      _PK_L_(0x7C, 0x70)
#define REG_SC_BK7C_70_H      _PK_H_(0x7C, 0x70)
#define REG_SC_BK7C_71_L      _PK_L_(0x7C, 0x71)
#define REG_SC_BK7C_71_H      _PK_H_(0x7C, 0x71)
#define REG_SC_BK7C_72_L      _PK_L_(0x7C, 0x72)
#define REG_SC_BK7C_72_H      _PK_H_(0x7C, 0x72)
#define REG_SC_BK7C_73_L      _PK_L_(0x7C, 0x73)
#define REG_SC_BK7C_73_H      _PK_H_(0x7C, 0x73)
#define REG_SC_BK7C_74_L      _PK_L_(0x7C, 0x74)
#define REG_SC_BK7C_74_H      _PK_H_(0x7C, 0x74)
#define REG_SC_BK7C_75_L      _PK_L_(0x7C, 0x75)
#define REG_SC_BK7C_75_H      _PK_H_(0x7C, 0x75)
#define REG_SC_BK7C_76_L      _PK_L_(0x7C, 0x76)
#define REG_SC_BK7C_76_H      _PK_H_(0x7C, 0x76)
#define REG_SC_BK7C_77_L      _PK_L_(0x7C, 0x77)
#define REG_SC_BK7C_77_H      _PK_H_(0x7C, 0x77)
#define REG_SC_BK7C_78_L      _PK_L_(0x7C, 0x78)
#define REG_SC_BK7C_78_H      _PK_H_(0x7C, 0x78)
#define REG_SC_BK7C_79_L      _PK_L_(0x7C, 0x79)
#define REG_SC_BK7C_79_H      _PK_H_(0x7C, 0x79)
#define REG_SC_BK7C_7A_L      _PK_L_(0x7C, 0x7A)
#define REG_SC_BK7C_7A_H      _PK_H_(0x7C, 0x7A)
#define REG_SC_BK7C_7B_L      _PK_L_(0x7C, 0x7B)
#define REG_SC_BK7C_7B_H      _PK_H_(0x7C, 0x7B)
#define REG_SC_BK7C_7C_L      _PK_L_(0x7C, 0x7C)
#define REG_SC_BK7C_7C_H      _PK_H_(0x7C, 0x7C)
#define REG_SC_BK7C_7D_L      _PK_L_(0x7C, 0x7D)
#define REG_SC_BK7C_7D_H      _PK_H_(0x7C, 0x7D)
#define REG_SC_BK7C_7E_L      _PK_L_(0x7C, 0x7E)
#define REG_SC_BK7C_7E_H      _PK_H_(0x7C, 0x7E)
#define REG_SC_BK7C_7F_L      _PK_L_(0x7C, 0x7F)
#define REG_SC_BK7C_7F_H      _PK_H_(0x7C, 0x7F)
//----------------------------------------------
#define REG_SC_BK7D_00_L      _PK_L_(0x7D, 0x00)
#define REG_SC_BK7D_00_H      _PK_H_(0x7D, 0x00)
#define REG_SC_BK7D_01_L      _PK_L_(0x7D, 0x01)
#define REG_SC_BK7D_01_H      _PK_H_(0x7D, 0x01)
#define REG_SC_BK7D_02_L      _PK_L_(0x7D, 0x02)
#define REG_SC_BK7D_02_H      _PK_H_(0x7D, 0x02)
#define REG_SC_BK7D_03_L      _PK_L_(0x7D, 0x03)
#define REG_SC_BK7D_03_H      _PK_H_(0x7D, 0x03)
#define REG_SC_BK7D_04_L      _PK_L_(0x7D, 0x04)
#define REG_SC_BK7D_04_H      _PK_H_(0x7D, 0x04)
#define REG_SC_BK7D_05_L      _PK_L_(0x7D, 0x05)
#define REG_SC_BK7D_05_H      _PK_H_(0x7D, 0x05)
#define REG_SC_BK7D_06_L      _PK_L_(0x7D, 0x06)
#define REG_SC_BK7D_06_H      _PK_H_(0x7D, 0x06)
#define REG_SC_BK7D_07_L      _PK_L_(0x7D, 0x07)
#define REG_SC_BK7D_07_H      _PK_H_(0x7D, 0x07)
#define REG_SC_BK7D_08_L      _PK_L_(0x7D, 0x08)
#define REG_SC_BK7D_08_H      _PK_H_(0x7D, 0x08)
#define REG_SC_BK7D_09_L      _PK_L_(0x7D, 0x09)
#define REG_SC_BK7D_09_H      _PK_H_(0x7D, 0x09)
#define REG_SC_BK7D_0A_L      _PK_L_(0x7D, 0x0A)
#define REG_SC_BK7D_0A_H      _PK_H_(0x7D, 0x0A)
#define REG_SC_BK7D_0B_L      _PK_L_(0x7D, 0x0B)
#define REG_SC_BK7D_0B_H      _PK_H_(0x7D, 0x0B)
#define REG_SC_BK7D_0C_L      _PK_L_(0x7D, 0x0C)
#define REG_SC_BK7D_0C_H      _PK_H_(0x7D, 0x0C)
#define REG_SC_BK7D_0D_L      _PK_L_(0x7D, 0x0D)
#define REG_SC_BK7D_0D_H      _PK_H_(0x7D, 0x0D)
#define REG_SC_BK7D_0E_L      _PK_L_(0x7D, 0x0E)
#define REG_SC_BK7D_0E_H      _PK_H_(0x7D, 0x0E)
#define REG_SC_BK7D_0F_L      _PK_L_(0x7D, 0x0F)
#define REG_SC_BK7D_0F_H      _PK_H_(0x7D, 0x0F)
#define REG_SC_BK7D_10_L      _PK_L_(0x7D, 0x10)
#define REG_SC_BK7D_10_H      _PK_H_(0x7D, 0x10)
#define REG_SC_BK7D_11_L      _PK_L_(0x7D, 0x11)
#define REG_SC_BK7D_11_H      _PK_H_(0x7D, 0x11)
#define REG_SC_BK7D_12_L      _PK_L_(0x7D, 0x12)
#define REG_SC_BK7D_12_H      _PK_H_(0x7D, 0x12)
#define REG_SC_BK7D_13_L      _PK_L_(0x7D, 0x13)
#define REG_SC_BK7D_13_H      _PK_H_(0x7D, 0x13)
#define REG_SC_BK7D_14_L      _PK_L_(0x7D, 0x14)
#define REG_SC_BK7D_14_H      _PK_H_(0x7D, 0x14)
#define REG_SC_BK7D_15_L      _PK_L_(0x7D, 0x15)
#define REG_SC_BK7D_15_H      _PK_H_(0x7D, 0x15)
#define REG_SC_BK7D_16_L      _PK_L_(0x7D, 0x16)
#define REG_SC_BK7D_16_H      _PK_H_(0x7D, 0x16)
#define REG_SC_BK7D_17_L      _PK_L_(0x7D, 0x17)
#define REG_SC_BK7D_17_H      _PK_H_(0x7D, 0x17)
#define REG_SC_BK7D_18_L      _PK_L_(0x7D, 0x18)
#define REG_SC_BK7D_18_H      _PK_H_(0x7D, 0x18)
#define REG_SC_BK7D_19_L      _PK_L_(0x7D, 0x19)
#define REG_SC_BK7D_19_H      _PK_H_(0x7D, 0x19)
#define REG_SC_BK7D_1A_L      _PK_L_(0x7D, 0x1A)
#define REG_SC_BK7D_1A_H      _PK_H_(0x7D, 0x1A)
#define REG_SC_BK7D_1B_L      _PK_L_(0x7D, 0x1B)
#define REG_SC_BK7D_1B_H      _PK_H_(0x7D, 0x1B)
#define REG_SC_BK7D_1C_L      _PK_L_(0x7D, 0x1C)
#define REG_SC_BK7D_1C_H      _PK_H_(0x7D, 0x1C)
#define REG_SC_BK7D_1D_L      _PK_L_(0x7D, 0x1D)
#define REG_SC_BK7D_1D_H      _PK_H_(0x7D, 0x1D)
#define REG_SC_BK7D_1E_L      _PK_L_(0x7D, 0x1E)
#define REG_SC_BK7D_1E_H      _PK_H_(0x7D, 0x1E)
#define REG_SC_BK7D_1F_L      _PK_L_(0x7D, 0x1F)
#define REG_SC_BK7D_1F_H      _PK_H_(0x7D, 0x1F)
#define REG_SC_BK7D_20_L      _PK_L_(0x7D, 0x20)
#define REG_SC_BK7D_20_H      _PK_H_(0x7D, 0x20)
#define REG_SC_BK7D_21_L      _PK_L_(0x7D, 0x21)
#define REG_SC_BK7D_21_H      _PK_H_(0x7D, 0x21)
#define REG_SC_BK7D_22_L      _PK_L_(0x7D, 0x22)
#define REG_SC_BK7D_22_H      _PK_H_(0x7D, 0x22)
#define REG_SC_BK7D_23_L      _PK_L_(0x7D, 0x23)
#define REG_SC_BK7D_23_H      _PK_H_(0x7D, 0x23)
#define REG_SC_BK7D_24_L      _PK_L_(0x7D, 0x24)
#define REG_SC_BK7D_24_H      _PK_H_(0x7D, 0x24)
#define REG_SC_BK7D_25_L      _PK_L_(0x7D, 0x25)
#define REG_SC_BK7D_25_H      _PK_H_(0x7D, 0x25)
#define REG_SC_BK7D_26_L      _PK_L_(0x7D, 0x26)
#define REG_SC_BK7D_26_H      _PK_H_(0x7D, 0x26)
#define REG_SC_BK7D_27_L      _PK_L_(0x7D, 0x27)
#define REG_SC_BK7D_27_H      _PK_H_(0x7D, 0x27)
#define REG_SC_BK7D_28_L      _PK_L_(0x7D, 0x28)
#define REG_SC_BK7D_28_H      _PK_H_(0x7D, 0x28)
#define REG_SC_BK7D_29_L      _PK_L_(0x7D, 0x29)
#define REG_SC_BK7D_29_H      _PK_H_(0x7D, 0x29)
#define REG_SC_BK7D_2A_L      _PK_L_(0x7D, 0x2A)
#define REG_SC_BK7D_2A_H      _PK_H_(0x7D, 0x2A)
#define REG_SC_BK7D_2B_L      _PK_L_(0x7D, 0x2B)
#define REG_SC_BK7D_2B_H      _PK_H_(0x7D, 0x2B)
#define REG_SC_BK7D_2C_L      _PK_L_(0x7D, 0x2C)
#define REG_SC_BK7D_2C_H      _PK_H_(0x7D, 0x2C)
#define REG_SC_BK7D_2D_L      _PK_L_(0x7D, 0x2D)
#define REG_SC_BK7D_2D_H      _PK_H_(0x7D, 0x2D)
#define REG_SC_BK7D_2E_L      _PK_L_(0x7D, 0x2E)
#define REG_SC_BK7D_2E_H      _PK_H_(0x7D, 0x2E)
#define REG_SC_BK7D_2F_L      _PK_L_(0x7D, 0x2F)
#define REG_SC_BK7D_2F_H      _PK_H_(0x7D, 0x2F)
#define REG_SC_BK7D_30_L      _PK_L_(0x7D, 0x30)
#define REG_SC_BK7D_30_H      _PK_H_(0x7D, 0x30)
#define REG_SC_BK7D_31_L      _PK_L_(0x7D, 0x31)
#define REG_SC_BK7D_31_H      _PK_H_(0x7D, 0x31)
#define REG_SC_BK7D_32_L      _PK_L_(0x7D, 0x32)
#define REG_SC_BK7D_32_H      _PK_H_(0x7D, 0x32)
#define REG_SC_BK7D_33_L      _PK_L_(0x7D, 0x33)
#define REG_SC_BK7D_33_H      _PK_H_(0x7D, 0x33)
#define REG_SC_BK7D_34_L      _PK_L_(0x7D, 0x34)
#define REG_SC_BK7D_34_H      _PK_H_(0x7D, 0x34)
#define REG_SC_BK7D_35_L      _PK_L_(0x7D, 0x35)
#define REG_SC_BK7D_35_H      _PK_H_(0x7D, 0x35)
#define REG_SC_BK7D_36_L      _PK_L_(0x7D, 0x36)
#define REG_SC_BK7D_36_H      _PK_H_(0x7D, 0x36)
#define REG_SC_BK7D_37_L      _PK_L_(0x7D, 0x37)
#define REG_SC_BK7D_37_H      _PK_H_(0x7D, 0x37)
#define REG_SC_BK7D_38_L      _PK_L_(0x7D, 0x38)
#define REG_SC_BK7D_38_H      _PK_H_(0x7D, 0x38)
#define REG_SC_BK7D_39_L      _PK_L_(0x7D, 0x39)
#define REG_SC_BK7D_39_H      _PK_H_(0x7D, 0x39)
#define REG_SC_BK7D_3A_L      _PK_L_(0x7D, 0x3A)
#define REG_SC_BK7D_3A_H      _PK_H_(0x7D, 0x3A)
#define REG_SC_BK7D_3B_L      _PK_L_(0x7D, 0x3B)
#define REG_SC_BK7D_3B_H      _PK_H_(0x7D, 0x3B)
#define REG_SC_BK7D_3C_L      _PK_L_(0x7D, 0x3C)
#define REG_SC_BK7D_3C_H      _PK_H_(0x7D, 0x3C)
#define REG_SC_BK7D_3D_L      _PK_L_(0x7D, 0x3D)
#define REG_SC_BK7D_3D_H      _PK_H_(0x7D, 0x3D)
#define REG_SC_BK7D_3E_L      _PK_L_(0x7D, 0x3E)
#define REG_SC_BK7D_3E_H      _PK_H_(0x7D, 0x3E)
#define REG_SC_BK7D_3F_L      _PK_L_(0x7D, 0x3F)
#define REG_SC_BK7D_3F_H      _PK_H_(0x7D, 0x3F)
#define REG_SC_BK7D_40_L      _PK_L_(0x7D, 0x40)
#define REG_SC_BK7D_40_H      _PK_H_(0x7D, 0x40)
#define REG_SC_BK7D_41_L      _PK_L_(0x7D, 0x41)
#define REG_SC_BK7D_41_H      _PK_H_(0x7D, 0x41)
#define REG_SC_BK7D_42_L      _PK_L_(0x7D, 0x42)
#define REG_SC_BK7D_42_H      _PK_H_(0x7D, 0x42)
#define REG_SC_BK7D_43_L      _PK_L_(0x7D, 0x43)
#define REG_SC_BK7D_43_H      _PK_H_(0x7D, 0x43)
#define REG_SC_BK7D_44_L      _PK_L_(0x7D, 0x44)
#define REG_SC_BK7D_44_H      _PK_H_(0x7D, 0x44)
#define REG_SC_BK7D_45_L      _PK_L_(0x7D, 0x45)
#define REG_SC_BK7D_45_H      _PK_H_(0x7D, 0x45)
#define REG_SC_BK7D_46_L      _PK_L_(0x7D, 0x46)
#define REG_SC_BK7D_46_H      _PK_H_(0x7D, 0x46)
#define REG_SC_BK7D_47_L      _PK_L_(0x7D, 0x47)
#define REG_SC_BK7D_47_H      _PK_H_(0x7D, 0x47)
#define REG_SC_BK7D_48_L      _PK_L_(0x7D, 0x48)
#define REG_SC_BK7D_48_H      _PK_H_(0x7D, 0x48)
#define REG_SC_BK7D_49_L      _PK_L_(0x7D, 0x49)
#define REG_SC_BK7D_49_H      _PK_H_(0x7D, 0x49)
#define REG_SC_BK7D_4A_L      _PK_L_(0x7D, 0x4A)
#define REG_SC_BK7D_4A_H      _PK_H_(0x7D, 0x4A)
#define REG_SC_BK7D_4B_L      _PK_L_(0x7D, 0x4B)
#define REG_SC_BK7D_4B_H      _PK_H_(0x7D, 0x4B)
#define REG_SC_BK7D_4C_L      _PK_L_(0x7D, 0x4C)
#define REG_SC_BK7D_4C_H      _PK_H_(0x7D, 0x4C)
#define REG_SC_BK7D_4D_L      _PK_L_(0x7D, 0x4D)
#define REG_SC_BK7D_4D_H      _PK_H_(0x7D, 0x4D)
#define REG_SC_BK7D_4E_L      _PK_L_(0x7D, 0x4E)
#define REG_SC_BK7D_4E_H      _PK_H_(0x7D, 0x4E)
#define REG_SC_BK7D_4F_L      _PK_L_(0x7D, 0x4F)
#define REG_SC_BK7D_4F_H      _PK_H_(0x7D, 0x4F)
#define REG_SC_BK7D_50_L      _PK_L_(0x7D, 0x50)
#define REG_SC_BK7D_50_H      _PK_H_(0x7D, 0x50)
#define REG_SC_BK7D_51_L      _PK_L_(0x7D, 0x51)
#define REG_SC_BK7D_51_H      _PK_H_(0x7D, 0x51)
#define REG_SC_BK7D_52_L      _PK_L_(0x7D, 0x52)
#define REG_SC_BK7D_52_H      _PK_H_(0x7D, 0x52)
#define REG_SC_BK7D_53_L      _PK_L_(0x7D, 0x53)
#define REG_SC_BK7D_53_H      _PK_H_(0x7D, 0x53)
#define REG_SC_BK7D_54_L      _PK_L_(0x7D, 0x54)
#define REG_SC_BK7D_54_H      _PK_H_(0x7D, 0x54)
#define REG_SC_BK7D_55_L      _PK_L_(0x7D, 0x55)
#define REG_SC_BK7D_55_H      _PK_H_(0x7D, 0x55)
#define REG_SC_BK7D_56_L      _PK_L_(0x7D, 0x56)
#define REG_SC_BK7D_56_H      _PK_H_(0x7D, 0x56)
#define REG_SC_BK7D_57_L      _PK_L_(0x7D, 0x57)
#define REG_SC_BK7D_57_H      _PK_H_(0x7D, 0x57)
#define REG_SC_BK7D_58_L      _PK_L_(0x7D, 0x58)
#define REG_SC_BK7D_58_H      _PK_H_(0x7D, 0x58)
#define REG_SC_BK7D_59_L      _PK_L_(0x7D, 0x59)
#define REG_SC_BK7D_59_H      _PK_H_(0x7D, 0x59)
#define REG_SC_BK7D_5A_L      _PK_L_(0x7D, 0x5A)
#define REG_SC_BK7D_5A_H      _PK_H_(0x7D, 0x5A)
#define REG_SC_BK7D_5B_L      _PK_L_(0x7D, 0x5B)
#define REG_SC_BK7D_5B_H      _PK_H_(0x7D, 0x5B)
#define REG_SC_BK7D_5C_L      _PK_L_(0x7D, 0x5C)
#define REG_SC_BK7D_5C_H      _PK_H_(0x7D, 0x5C)
#define REG_SC_BK7D_5D_L      _PK_L_(0x7D, 0x5D)
#define REG_SC_BK7D_5D_H      _PK_H_(0x7D, 0x5D)
#define REG_SC_BK7D_5E_L      _PK_L_(0x7D, 0x5E)
#define REG_SC_BK7D_5E_H      _PK_H_(0x7D, 0x5E)
#define REG_SC_BK7D_5F_L      _PK_L_(0x7D, 0x5F)
#define REG_SC_BK7D_5F_H      _PK_H_(0x7D, 0x5F)
#define REG_SC_BK7D_60_L      _PK_L_(0x7D, 0x60)
#define REG_SC_BK7D_60_H      _PK_H_(0x7D, 0x60)
#define REG_SC_BK7D_61_L      _PK_L_(0x7D, 0x61)
#define REG_SC_BK7D_61_H      _PK_H_(0x7D, 0x61)
#define REG_SC_BK7D_62_L      _PK_L_(0x7D, 0x62)
#define REG_SC_BK7D_62_H      _PK_H_(0x7D, 0x62)
#define REG_SC_BK7D_63_L      _PK_L_(0x7D, 0x63)
#define REG_SC_BK7D_63_H      _PK_H_(0x7D, 0x63)
#define REG_SC_BK7D_64_L      _PK_L_(0x7D, 0x64)
#define REG_SC_BK7D_64_H      _PK_H_(0x7D, 0x64)
#define REG_SC_BK7D_65_L      _PK_L_(0x7D, 0x65)
#define REG_SC_BK7D_65_H      _PK_H_(0x7D, 0x65)
#define REG_SC_BK7D_66_L      _PK_L_(0x7D, 0x66)
#define REG_SC_BK7D_66_H      _PK_H_(0x7D, 0x66)
#define REG_SC_BK7D_67_L      _PK_L_(0x7D, 0x67)
#define REG_SC_BK7D_67_H      _PK_H_(0x7D, 0x67)
#define REG_SC_BK7D_68_L      _PK_L_(0x7D, 0x68)
#define REG_SC_BK7D_68_H      _PK_H_(0x7D, 0x68)
#define REG_SC_BK7D_69_L      _PK_L_(0x7D, 0x69)
#define REG_SC_BK7D_69_H      _PK_H_(0x7D, 0x69)
#define REG_SC_BK7D_6A_L      _PK_L_(0x7D, 0x6A)
#define REG_SC_BK7D_6A_H      _PK_H_(0x7D, 0x6A)
#define REG_SC_BK7D_6B_L      _PK_L_(0x7D, 0x6B)
#define REG_SC_BK7D_6B_H      _PK_H_(0x7D, 0x6B)
#define REG_SC_BK7D_6C_L      _PK_L_(0x7D, 0x6C)
#define REG_SC_BK7D_6C_H      _PK_H_(0x7D, 0x6C)
#define REG_SC_BK7D_6D_L      _PK_L_(0x7D, 0x6D)
#define REG_SC_BK7D_6D_H      _PK_H_(0x7D, 0x6D)
#define REG_SC_BK7D_6E_L      _PK_L_(0x7D, 0x6E)
#define REG_SC_BK7D_6E_H      _PK_H_(0x7D, 0x6E)
#define REG_SC_BK7D_6F_L      _PK_L_(0x7D, 0x6F)
#define REG_SC_BK7D_6F_H      _PK_H_(0x7D, 0x6F)
#define REG_SC_BK7D_70_L      _PK_L_(0x7D, 0x70)
#define REG_SC_BK7D_70_H      _PK_H_(0x7D, 0x70)
#define REG_SC_BK7D_71_L      _PK_L_(0x7D, 0x71)
#define REG_SC_BK7D_71_H      _PK_H_(0x7D, 0x71)
#define REG_SC_BK7D_72_L      _PK_L_(0x7D, 0x72)
#define REG_SC_BK7D_72_H      _PK_H_(0x7D, 0x72)
#define REG_SC_BK7D_73_L      _PK_L_(0x7D, 0x73)
#define REG_SC_BK7D_73_H      _PK_H_(0x7D, 0x73)
#define REG_SC_BK7D_74_L      _PK_L_(0x7D, 0x74)
#define REG_SC_BK7D_74_H      _PK_H_(0x7D, 0x74)
#define REG_SC_BK7D_75_L      _PK_L_(0x7D, 0x75)
#define REG_SC_BK7D_75_H      _PK_H_(0x7D, 0x75)
#define REG_SC_BK7D_76_L      _PK_L_(0x7D, 0x76)
#define REG_SC_BK7D_76_H      _PK_H_(0x7D, 0x76)
#define REG_SC_BK7D_77_L      _PK_L_(0x7D, 0x77)
#define REG_SC_BK7D_77_H      _PK_H_(0x7D, 0x77)
#define REG_SC_BK7D_78_L      _PK_L_(0x7D, 0x78)
#define REG_SC_BK7D_78_H      _PK_H_(0x7D, 0x78)
#define REG_SC_BK7D_79_L      _PK_L_(0x7D, 0x79)
#define REG_SC_BK7D_79_H      _PK_H_(0x7D, 0x79)
#define REG_SC_BK7D_7A_L      _PK_L_(0x7D, 0x7A)
#define REG_SC_BK7D_7A_H      _PK_H_(0x7D, 0x7A)
#define REG_SC_BK7D_7B_L      _PK_L_(0x7D, 0x7B)
#define REG_SC_BK7D_7B_H      _PK_H_(0x7D, 0x7B)
#define REG_SC_BK7D_7C_L      _PK_L_(0x7D, 0x7C)
#define REG_SC_BK7D_7C_H      _PK_H_(0x7D, 0x7C)
#define REG_SC_BK7D_7D_L      _PK_L_(0x7D, 0x7D)
#define REG_SC_BK7D_7D_H      _PK_H_(0x7D, 0x7D)
#define REG_SC_BK7D_7E_L      _PK_L_(0x7D, 0x7E)
#define REG_SC_BK7D_7E_H      _PK_H_(0x7D, 0x7E)
#define REG_SC_BK7D_7F_L      _PK_L_(0x7D, 0x7F)
#define REG_SC_BK7D_7F_H      _PK_H_(0x7D, 0x7F)
//----------------------------------------------
#define REG_SC_BK7E_00_L      _PK_L_(0x7E, 0x00)
#define REG_SC_BK7E_00_H      _PK_H_(0x7E, 0x00)
#define REG_SC_BK7E_01_L      _PK_L_(0x7E, 0x01)
#define REG_SC_BK7E_01_H      _PK_H_(0x7E, 0x01)
#define REG_SC_BK7E_02_L      _PK_L_(0x7E, 0x02)
#define REG_SC_BK7E_02_H      _PK_H_(0x7E, 0x02)
#define REG_SC_BK7E_03_L      _PK_L_(0x7E, 0x03)
#define REG_SC_BK7E_03_H      _PK_H_(0x7E, 0x03)
#define REG_SC_BK7E_04_L      _PK_L_(0x7E, 0x04)
#define REG_SC_BK7E_04_H      _PK_H_(0x7E, 0x04)
#define REG_SC_BK7E_05_L      _PK_L_(0x7E, 0x05)
#define REG_SC_BK7E_05_H      _PK_H_(0x7E, 0x05)
#define REG_SC_BK7E_06_L      _PK_L_(0x7E, 0x06)
#define REG_SC_BK7E_06_H      _PK_H_(0x7E, 0x06)
#define REG_SC_BK7E_07_L      _PK_L_(0x7E, 0x07)
#define REG_SC_BK7E_07_H      _PK_H_(0x7E, 0x07)
#define REG_SC_BK7E_08_L      _PK_L_(0x7E, 0x08)
#define REG_SC_BK7E_08_H      _PK_H_(0x7E, 0x08)
#define REG_SC_BK7E_09_L      _PK_L_(0x7E, 0x09)
#define REG_SC_BK7E_09_H      _PK_H_(0x7E, 0x09)
#define REG_SC_BK7E_0A_L      _PK_L_(0x7E, 0x0A)
#define REG_SC_BK7E_0A_H      _PK_H_(0x7E, 0x0A)
#define REG_SC_BK7E_0B_L      _PK_L_(0x7E, 0x0B)
#define REG_SC_BK7E_0B_H      _PK_H_(0x7E, 0x0B)
#define REG_SC_BK7E_0C_L      _PK_L_(0x7E, 0x0C)
#define REG_SC_BK7E_0C_H      _PK_H_(0x7E, 0x0C)
#define REG_SC_BK7E_0D_L      _PK_L_(0x7E, 0x0D)
#define REG_SC_BK7E_0D_H      _PK_H_(0x7E, 0x0D)
#define REG_SC_BK7E_0E_L      _PK_L_(0x7E, 0x0E)
#define REG_SC_BK7E_0E_H      _PK_H_(0x7E, 0x0E)
#define REG_SC_BK7E_0F_L      _PK_L_(0x7E, 0x0F)
#define REG_SC_BK7E_0F_H      _PK_H_(0x7E, 0x0F)
#define REG_SC_BK7E_10_L      _PK_L_(0x7E, 0x10)
#define REG_SC_BK7E_10_H      _PK_H_(0x7E, 0x10)
#define REG_SC_BK7E_11_L      _PK_L_(0x7E, 0x11)
#define REG_SC_BK7E_11_H      _PK_H_(0x7E, 0x11)
#define REG_SC_BK7E_12_L      _PK_L_(0x7E, 0x12)
#define REG_SC_BK7E_12_H      _PK_H_(0x7E, 0x12)
#define REG_SC_BK7E_13_L      _PK_L_(0x7E, 0x13)
#define REG_SC_BK7E_13_H      _PK_H_(0x7E, 0x13)
#define REG_SC_BK7E_14_L      _PK_L_(0x7E, 0x14)
#define REG_SC_BK7E_14_H      _PK_H_(0x7E, 0x14)
#define REG_SC_BK7E_15_L      _PK_L_(0x7E, 0x15)
#define REG_SC_BK7E_15_H      _PK_H_(0x7E, 0x15)
#define REG_SC_BK7E_16_L      _PK_L_(0x7E, 0x16)
#define REG_SC_BK7E_16_H      _PK_H_(0x7E, 0x16)
#define REG_SC_BK7E_17_L      _PK_L_(0x7E, 0x17)
#define REG_SC_BK7E_17_H      _PK_H_(0x7E, 0x17)
#define REG_SC_BK7E_18_L      _PK_L_(0x7E, 0x18)
#define REG_SC_BK7E_18_H      _PK_H_(0x7E, 0x18)
#define REG_SC_BK7E_19_L      _PK_L_(0x7E, 0x19)
#define REG_SC_BK7E_19_H      _PK_H_(0x7E, 0x19)
#define REG_SC_BK7E_1A_L      _PK_L_(0x7E, 0x1A)
#define REG_SC_BK7E_1A_H      _PK_H_(0x7E, 0x1A)
#define REG_SC_BK7E_1B_L      _PK_L_(0x7E, 0x1B)
#define REG_SC_BK7E_1B_H      _PK_H_(0x7E, 0x1B)
#define REG_SC_BK7E_1C_L      _PK_L_(0x7E, 0x1C)
#define REG_SC_BK7E_1C_H      _PK_H_(0x7E, 0x1C)
#define REG_SC_BK7E_1D_L      _PK_L_(0x7E, 0x1D)
#define REG_SC_BK7E_1D_H      _PK_H_(0x7E, 0x1D)
#define REG_SC_BK7E_1E_L      _PK_L_(0x7E, 0x1E)
#define REG_SC_BK7E_1E_H      _PK_H_(0x7E, 0x1E)
#define REG_SC_BK7E_1F_L      _PK_L_(0x7E, 0x1F)
#define REG_SC_BK7E_1F_H      _PK_H_(0x7E, 0x1F)
#define REG_SC_BK7E_20_L      _PK_L_(0x7E, 0x20)
#define REG_SC_BK7E_20_H      _PK_H_(0x7E, 0x20)
#define REG_SC_BK7E_21_L      _PK_L_(0x7E, 0x21)
#define REG_SC_BK7E_21_H      _PK_H_(0x7E, 0x21)
#define REG_SC_BK7E_22_L      _PK_L_(0x7E, 0x22)
#define REG_SC_BK7E_22_H      _PK_H_(0x7E, 0x22)
#define REG_SC_BK7E_23_L      _PK_L_(0x7E, 0x23)
#define REG_SC_BK7E_23_H      _PK_H_(0x7E, 0x23)
#define REG_SC_BK7E_24_L      _PK_L_(0x7E, 0x24)
#define REG_SC_BK7E_24_H      _PK_H_(0x7E, 0x24)
#define REG_SC_BK7E_25_L      _PK_L_(0x7E, 0x25)
#define REG_SC_BK7E_25_H      _PK_H_(0x7E, 0x25)
#define REG_SC_BK7E_26_L      _PK_L_(0x7E, 0x26)
#define REG_SC_BK7E_26_H      _PK_H_(0x7E, 0x26)
#define REG_SC_BK7E_27_L      _PK_L_(0x7E, 0x27)
#define REG_SC_BK7E_27_H      _PK_H_(0x7E, 0x27)
#define REG_SC_BK7E_28_L      _PK_L_(0x7E, 0x28)
#define REG_SC_BK7E_28_H      _PK_H_(0x7E, 0x28)
#define REG_SC_BK7E_29_L      _PK_L_(0x7E, 0x29)
#define REG_SC_BK7E_29_H      _PK_H_(0x7E, 0x29)
#define REG_SC_BK7E_2A_L      _PK_L_(0x7E, 0x2A)
#define REG_SC_BK7E_2A_H      _PK_H_(0x7E, 0x2A)
#define REG_SC_BK7E_2B_L      _PK_L_(0x7E, 0x2B)
#define REG_SC_BK7E_2B_H      _PK_H_(0x7E, 0x2B)
#define REG_SC_BK7E_2C_L      _PK_L_(0x7E, 0x2C)
#define REG_SC_BK7E_2C_H      _PK_H_(0x7E, 0x2C)
#define REG_SC_BK7E_2D_L      _PK_L_(0x7E, 0x2D)
#define REG_SC_BK7E_2D_H      _PK_H_(0x7E, 0x2D)
#define REG_SC_BK7E_2E_L      _PK_L_(0x7E, 0x2E)
#define REG_SC_BK7E_2E_H      _PK_H_(0x7E, 0x2E)
#define REG_SC_BK7E_2F_L      _PK_L_(0x7E, 0x2F)
#define REG_SC_BK7E_2F_H      _PK_H_(0x7E, 0x2F)
#define REG_SC_BK7E_30_L      _PK_L_(0x7E, 0x30)
#define REG_SC_BK7E_30_H      _PK_H_(0x7E, 0x30)
#define REG_SC_BK7E_31_L      _PK_L_(0x7E, 0x31)
#define REG_SC_BK7E_31_H      _PK_H_(0x7E, 0x31)
#define REG_SC_BK7E_32_L      _PK_L_(0x7E, 0x32)
#define REG_SC_BK7E_32_H      _PK_H_(0x7E, 0x32)
#define REG_SC_BK7E_33_L      _PK_L_(0x7E, 0x33)
#define REG_SC_BK7E_33_H      _PK_H_(0x7E, 0x33)
#define REG_SC_BK7E_34_L      _PK_L_(0x7E, 0x34)
#define REG_SC_BK7E_34_H      _PK_H_(0x7E, 0x34)
#define REG_SC_BK7E_35_L      _PK_L_(0x7E, 0x35)
#define REG_SC_BK7E_35_H      _PK_H_(0x7E, 0x35)
#define REG_SC_BK7E_36_L      _PK_L_(0x7E, 0x36)
#define REG_SC_BK7E_36_H      _PK_H_(0x7E, 0x36)
#define REG_SC_BK7E_37_L      _PK_L_(0x7E, 0x37)
#define REG_SC_BK7E_37_H      _PK_H_(0x7E, 0x37)
#define REG_SC_BK7E_38_L      _PK_L_(0x7E, 0x38)
#define REG_SC_BK7E_38_H      _PK_H_(0x7E, 0x38)
#define REG_SC_BK7E_39_L      _PK_L_(0x7E, 0x39)
#define REG_SC_BK7E_39_H      _PK_H_(0x7E, 0x39)
#define REG_SC_BK7E_3A_L      _PK_L_(0x7E, 0x3A)
#define REG_SC_BK7E_3A_H      _PK_H_(0x7E, 0x3A)
#define REG_SC_BK7E_3B_L      _PK_L_(0x7E, 0x3B)
#define REG_SC_BK7E_3B_H      _PK_H_(0x7E, 0x3B)
#define REG_SC_BK7E_3C_L      _PK_L_(0x7E, 0x3C)
#define REG_SC_BK7E_3C_H      _PK_H_(0x7E, 0x3C)
#define REG_SC_BK7E_3D_L      _PK_L_(0x7E, 0x3D)
#define REG_SC_BK7E_3D_H      _PK_H_(0x7E, 0x3D)
#define REG_SC_BK7E_3E_L      _PK_L_(0x7E, 0x3E)
#define REG_SC_BK7E_3E_H      _PK_H_(0x7E, 0x3E)
#define REG_SC_BK7E_3F_L      _PK_L_(0x7E, 0x3F)
#define REG_SC_BK7E_3F_H      _PK_H_(0x7E, 0x3F)
#define REG_SC_BK7E_40_L      _PK_L_(0x7E, 0x40)
#define REG_SC_BK7E_40_H      _PK_H_(0x7E, 0x40)
#define REG_SC_BK7E_41_L      _PK_L_(0x7E, 0x41)
#define REG_SC_BK7E_41_H      _PK_H_(0x7E, 0x41)
#define REG_SC_BK7E_42_L      _PK_L_(0x7E, 0x42)
#define REG_SC_BK7E_42_H      _PK_H_(0x7E, 0x42)
#define REG_SC_BK7E_43_L      _PK_L_(0x7E, 0x43)
#define REG_SC_BK7E_43_H      _PK_H_(0x7E, 0x43)
#define REG_SC_BK7E_44_L      _PK_L_(0x7E, 0x44)
#define REG_SC_BK7E_44_H      _PK_H_(0x7E, 0x44)
#define REG_SC_BK7E_45_L      _PK_L_(0x7E, 0x45)
#define REG_SC_BK7E_45_H      _PK_H_(0x7E, 0x45)
#define REG_SC_BK7E_46_L      _PK_L_(0x7E, 0x46)
#define REG_SC_BK7E_46_H      _PK_H_(0x7E, 0x46)
#define REG_SC_BK7E_47_L      _PK_L_(0x7E, 0x47)
#define REG_SC_BK7E_47_H      _PK_H_(0x7E, 0x47)
#define REG_SC_BK7E_48_L      _PK_L_(0x7E, 0x48)
#define REG_SC_BK7E_48_H      _PK_H_(0x7E, 0x48)
#define REG_SC_BK7E_49_L      _PK_L_(0x7E, 0x49)
#define REG_SC_BK7E_49_H      _PK_H_(0x7E, 0x49)
#define REG_SC_BK7E_4A_L      _PK_L_(0x7E, 0x4A)
#define REG_SC_BK7E_4A_H      _PK_H_(0x7E, 0x4A)
#define REG_SC_BK7E_4B_L      _PK_L_(0x7E, 0x4B)
#define REG_SC_BK7E_4B_H      _PK_H_(0x7E, 0x4B)
#define REG_SC_BK7E_4C_L      _PK_L_(0x7E, 0x4C)
#define REG_SC_BK7E_4C_H      _PK_H_(0x7E, 0x4C)
#define REG_SC_BK7E_4D_L      _PK_L_(0x7E, 0x4D)
#define REG_SC_BK7E_4D_H      _PK_H_(0x7E, 0x4D)
#define REG_SC_BK7E_4E_L      _PK_L_(0x7E, 0x4E)
#define REG_SC_BK7E_4E_H      _PK_H_(0x7E, 0x4E)
#define REG_SC_BK7E_4F_L      _PK_L_(0x7E, 0x4F)
#define REG_SC_BK7E_4F_H      _PK_H_(0x7E, 0x4F)
#define REG_SC_BK7E_50_L      _PK_L_(0x7E, 0x50)
#define REG_SC_BK7E_50_H      _PK_H_(0x7E, 0x50)
#define REG_SC_BK7E_51_L      _PK_L_(0x7E, 0x51)
#define REG_SC_BK7E_51_H      _PK_H_(0x7E, 0x51)
#define REG_SC_BK7E_52_L      _PK_L_(0x7E, 0x52)
#define REG_SC_BK7E_52_H      _PK_H_(0x7E, 0x52)
#define REG_SC_BK7E_53_L      _PK_L_(0x7E, 0x53)
#define REG_SC_BK7E_53_H      _PK_H_(0x7E, 0x53)
#define REG_SC_BK7E_54_L      _PK_L_(0x7E, 0x54)
#define REG_SC_BK7E_54_H      _PK_H_(0x7E, 0x54)
#define REG_SC_BK7E_55_L      _PK_L_(0x7E, 0x55)
#define REG_SC_BK7E_55_H      _PK_H_(0x7E, 0x55)
#define REG_SC_BK7E_56_L      _PK_L_(0x7E, 0x56)
#define REG_SC_BK7E_56_H      _PK_H_(0x7E, 0x56)
#define REG_SC_BK7E_57_L      _PK_L_(0x7E, 0x57)
#define REG_SC_BK7E_57_H      _PK_H_(0x7E, 0x57)
#define REG_SC_BK7E_58_L      _PK_L_(0x7E, 0x58)
#define REG_SC_BK7E_58_H      _PK_H_(0x7E, 0x58)
#define REG_SC_BK7E_59_L      _PK_L_(0x7E, 0x59)
#define REG_SC_BK7E_59_H      _PK_H_(0x7E, 0x59)
#define REG_SC_BK7E_5A_L      _PK_L_(0x7E, 0x5A)
#define REG_SC_BK7E_5A_H      _PK_H_(0x7E, 0x5A)
#define REG_SC_BK7E_5B_L      _PK_L_(0x7E, 0x5B)
#define REG_SC_BK7E_5B_H      _PK_H_(0x7E, 0x5B)
#define REG_SC_BK7E_5C_L      _PK_L_(0x7E, 0x5C)
#define REG_SC_BK7E_5C_H      _PK_H_(0x7E, 0x5C)
#define REG_SC_BK7E_5D_L      _PK_L_(0x7E, 0x5D)
#define REG_SC_BK7E_5D_H      _PK_H_(0x7E, 0x5D)
#define REG_SC_BK7E_5E_L      _PK_L_(0x7E, 0x5E)
#define REG_SC_BK7E_5E_H      _PK_H_(0x7E, 0x5E)
#define REG_SC_BK7E_5F_L      _PK_L_(0x7E, 0x5F)
#define REG_SC_BK7E_5F_H      _PK_H_(0x7E, 0x5F)
#define REG_SC_BK7E_60_L      _PK_L_(0x7E, 0x60)
#define REG_SC_BK7E_60_H      _PK_H_(0x7E, 0x60)
#define REG_SC_BK7E_61_L      _PK_L_(0x7E, 0x61)
#define REG_SC_BK7E_61_H      _PK_H_(0x7E, 0x61)
#define REG_SC_BK7E_62_L      _PK_L_(0x7E, 0x62)
#define REG_SC_BK7E_62_H      _PK_H_(0x7E, 0x62)
#define REG_SC_BK7E_63_L      _PK_L_(0x7E, 0x63)
#define REG_SC_BK7E_63_H      _PK_H_(0x7E, 0x63)
#define REG_SC_BK7E_64_L      _PK_L_(0x7E, 0x64)
#define REG_SC_BK7E_64_H      _PK_H_(0x7E, 0x64)
#define REG_SC_BK7E_65_L      _PK_L_(0x7E, 0x65)
#define REG_SC_BK7E_65_H      _PK_H_(0x7E, 0x65)
#define REG_SC_BK7E_66_L      _PK_L_(0x7E, 0x66)
#define REG_SC_BK7E_66_H      _PK_H_(0x7E, 0x66)
#define REG_SC_BK7E_67_L      _PK_L_(0x7E, 0x67)
#define REG_SC_BK7E_67_H      _PK_H_(0x7E, 0x67)
#define REG_SC_BK7E_68_L      _PK_L_(0x7E, 0x68)
#define REG_SC_BK7E_68_H      _PK_H_(0x7E, 0x68)
#define REG_SC_BK7E_69_L      _PK_L_(0x7E, 0x69)
#define REG_SC_BK7E_69_H      _PK_H_(0x7E, 0x69)
#define REG_SC_BK7E_6A_L      _PK_L_(0x7E, 0x6A)
#define REG_SC_BK7E_6A_H      _PK_H_(0x7E, 0x6A)
#define REG_SC_BK7E_6B_L      _PK_L_(0x7E, 0x6B)
#define REG_SC_BK7E_6B_H      _PK_H_(0x7E, 0x6B)
#define REG_SC_BK7E_6C_L      _PK_L_(0x7E, 0x6C)
#define REG_SC_BK7E_6C_H      _PK_H_(0x7E, 0x6C)
#define REG_SC_BK7E_6D_L      _PK_L_(0x7E, 0x6D)
#define REG_SC_BK7E_6D_H      _PK_H_(0x7E, 0x6D)
#define REG_SC_BK7E_6E_L      _PK_L_(0x7E, 0x6E)
#define REG_SC_BK7E_6E_H      _PK_H_(0x7E, 0x6E)
#define REG_SC_BK7E_6F_L      _PK_L_(0x7E, 0x6F)
#define REG_SC_BK7E_6F_H      _PK_H_(0x7E, 0x6F)
#define REG_SC_BK7E_70_L      _PK_L_(0x7E, 0x70)
#define REG_SC_BK7E_70_H      _PK_H_(0x7E, 0x70)
#define REG_SC_BK7E_71_L      _PK_L_(0x7E, 0x71)
#define REG_SC_BK7E_71_H      _PK_H_(0x7E, 0x71)
#define REG_SC_BK7E_72_L      _PK_L_(0x7E, 0x72)
#define REG_SC_BK7E_72_H      _PK_H_(0x7E, 0x72)
#define REG_SC_BK7E_73_L      _PK_L_(0x7E, 0x73)
#define REG_SC_BK7E_73_H      _PK_H_(0x7E, 0x73)
#define REG_SC_BK7E_74_L      _PK_L_(0x7E, 0x74)
#define REG_SC_BK7E_74_H      _PK_H_(0x7E, 0x74)
#define REG_SC_BK7E_75_L      _PK_L_(0x7E, 0x75)
#define REG_SC_BK7E_75_H      _PK_H_(0x7E, 0x75)
#define REG_SC_BK7E_76_L      _PK_L_(0x7E, 0x76)
#define REG_SC_BK7E_76_H      _PK_H_(0x7E, 0x76)
#define REG_SC_BK7E_77_L      _PK_L_(0x7E, 0x77)
#define REG_SC_BK7E_77_H      _PK_H_(0x7E, 0x77)
#define REG_SC_BK7E_78_L      _PK_L_(0x7E, 0x78)
#define REG_SC_BK7E_78_H      _PK_H_(0x7E, 0x78)
#define REG_SC_BK7E_79_L      _PK_L_(0x7E, 0x79)
#define REG_SC_BK7E_79_H      _PK_H_(0x7E, 0x79)
#define REG_SC_BK7E_7A_L      _PK_L_(0x7E, 0x7A)
#define REG_SC_BK7E_7A_H      _PK_H_(0x7E, 0x7A)
#define REG_SC_BK7E_7B_L      _PK_L_(0x7E, 0x7B)
#define REG_SC_BK7E_7B_H      _PK_H_(0x7E, 0x7B)
#define REG_SC_BK7E_7C_L      _PK_L_(0x7E, 0x7C)
#define REG_SC_BK7E_7C_H      _PK_H_(0x7E, 0x7C)
#define REG_SC_BK7E_7D_L      _PK_L_(0x7E, 0x7D)
#define REG_SC_BK7E_7D_H      _PK_H_(0x7E, 0x7D)
#define REG_SC_BK7E_7E_L      _PK_L_(0x7E, 0x7E)
#define REG_SC_BK7E_7E_H      _PK_H_(0x7E, 0x7E)
#define REG_SC_BK7E_7F_L      _PK_L_(0x7E, 0x7F)
#define REG_SC_BK7E_7F_H      _PK_H_(0x7E, 0x7F)
//----------------------------------------------
#define REG_SC_BK80_00_L      _PK_L_(0x80, 0x00)
#define REG_SC_BK80_00_H      _PK_H_(0x80, 0x00)
#define REG_SC_BK80_01_L      _PK_L_(0x80, 0x01)
#define REG_SC_BK80_01_H      _PK_H_(0x80, 0x01)
#define REG_SC_BK80_02_L      _PK_L_(0x80, 0x02)
#define REG_SC_BK80_02_H      _PK_H_(0x80, 0x02)
#define REG_SC_BK80_03_L      _PK_L_(0x80, 0x03)
#define REG_SC_BK80_03_H      _PK_H_(0x80, 0x03)
#define REG_SC_BK80_04_L      _PK_L_(0x80, 0x04)
#define REG_SC_BK80_04_H      _PK_H_(0x80, 0x04)
#define REG_SC_BK80_05_L      _PK_L_(0x80, 0x05)
#define REG_SC_BK80_05_H      _PK_H_(0x80, 0x05)
#define REG_SC_BK80_06_L      _PK_L_(0x80, 0x06)
#define REG_SC_BK80_06_H      _PK_H_(0x80, 0x06)
#define REG_SC_BK80_07_L      _PK_L_(0x80, 0x07)
#define REG_SC_BK80_07_H      _PK_H_(0x80, 0x07)
#define REG_SC_BK80_08_L      _PK_L_(0x80, 0x08)
#define REG_SC_BK80_08_H      _PK_H_(0x80, 0x08)
#define REG_SC_BK80_09_L      _PK_L_(0x80, 0x09)
#define REG_SC_BK80_09_H      _PK_H_(0x80, 0x09)
#define REG_SC_BK80_0A_L      _PK_L_(0x80, 0x0A)
#define REG_SC_BK80_0A_H      _PK_H_(0x80, 0x0A)
#define REG_SC_BK80_0B_L      _PK_L_(0x80, 0x0B)
#define REG_SC_BK80_0B_H      _PK_H_(0x80, 0x0B)
#define REG_SC_BK80_0C_L      _PK_L_(0x80, 0x0C)
#define REG_SC_BK80_0C_H      _PK_H_(0x80, 0x0C)
#define REG_SC_BK80_0D_L      _PK_L_(0x80, 0x0D)
#define REG_SC_BK80_0D_H      _PK_H_(0x80, 0x0D)
#define REG_SC_BK80_0E_L      _PK_L_(0x80, 0x0E)
#define REG_SC_BK80_0E_H      _PK_H_(0x80, 0x0E)
#define REG_SC_BK80_0F_L      _PK_L_(0x80, 0x0F)
#define REG_SC_BK80_0F_H      _PK_H_(0x80, 0x0F)
#define REG_SC_BK80_10_L      _PK_L_(0x80, 0x10)
#define REG_SC_BK80_10_H      _PK_H_(0x80, 0x10)
#define REG_SC_BK80_11_L      _PK_L_(0x80, 0x11)
#define REG_SC_BK80_11_H      _PK_H_(0x80, 0x11)
#define REG_SC_BK80_12_L      _PK_L_(0x80, 0x12)
#define REG_SC_BK80_12_H      _PK_H_(0x80, 0x12)
#define REG_SC_BK80_13_L      _PK_L_(0x80, 0x13)
#define REG_SC_BK80_13_H      _PK_H_(0x80, 0x13)
#define REG_SC_BK80_14_L      _PK_L_(0x80, 0x14)
#define REG_SC_BK80_14_H      _PK_H_(0x80, 0x14)
#define REG_SC_BK80_15_L      _PK_L_(0x80, 0x15)
#define REG_SC_BK80_15_H      _PK_H_(0x80, 0x15)
#define REG_SC_BK80_16_L      _PK_L_(0x80, 0x16)
#define REG_SC_BK80_16_H      _PK_H_(0x80, 0x16)
#define REG_SC_BK80_17_L      _PK_L_(0x80, 0x17)
#define REG_SC_BK80_17_H      _PK_H_(0x80, 0x17)
#define REG_SC_BK80_18_L      _PK_L_(0x80, 0x18)
#define REG_SC_BK80_18_H      _PK_H_(0x80, 0x18)
#define REG_SC_BK80_19_L      _PK_L_(0x80, 0x19)
#define REG_SC_BK80_19_H      _PK_H_(0x80, 0x19)
#define REG_SC_BK80_1A_L      _PK_L_(0x80, 0x1A)
#define REG_SC_BK80_1A_H      _PK_H_(0x80, 0x1A)
#define REG_SC_BK80_1B_L      _PK_L_(0x80, 0x1B)
#define REG_SC_BK80_1B_H      _PK_H_(0x80, 0x1B)
#define REG_SC_BK80_1C_L      _PK_L_(0x80, 0x1C)
#define REG_SC_BK80_1C_H      _PK_H_(0x80, 0x1C)
#define REG_SC_BK80_1D_L      _PK_L_(0x80, 0x1D)
#define REG_SC_BK80_1D_H      _PK_H_(0x80, 0x1D)
#define REG_SC_BK80_1E_L      _PK_L_(0x80, 0x1E)
#define REG_SC_BK80_1E_H      _PK_H_(0x80, 0x1E)
#define REG_SC_BK80_1F_L      _PK_L_(0x80, 0x1F)
#define REG_SC_BK80_1F_H      _PK_H_(0x80, 0x1F)
#define REG_SC_BK80_20_L      _PK_L_(0x80, 0x20)
#define REG_SC_BK80_20_H      _PK_H_(0x80, 0x20)
#define REG_SC_BK80_21_L      _PK_L_(0x80, 0x21)
#define REG_SC_BK80_21_H      _PK_H_(0x80, 0x21)
#define REG_SC_BK80_22_L      _PK_L_(0x80, 0x22)
#define REG_SC_BK80_22_H      _PK_H_(0x80, 0x22)
#define REG_SC_BK80_23_L      _PK_L_(0x80, 0x23)
#define REG_SC_BK80_23_H      _PK_H_(0x80, 0x23)
#define REG_SC_BK80_24_L      _PK_L_(0x80, 0x24)
#define REG_SC_BK80_24_H      _PK_H_(0x80, 0x24)
#define REG_SC_BK80_25_L      _PK_L_(0x80, 0x25)
#define REG_SC_BK80_25_H      _PK_H_(0x80, 0x25)
#define REG_SC_BK80_26_L      _PK_L_(0x80, 0x26)
#define REG_SC_BK80_26_H      _PK_H_(0x80, 0x26)
#define REG_SC_BK80_27_L      _PK_L_(0x80, 0x27)
#define REG_SC_BK80_27_H      _PK_H_(0x80, 0x27)
#define REG_SC_BK80_28_L      _PK_L_(0x80, 0x28)
#define REG_SC_BK80_28_H      _PK_H_(0x80, 0x28)
#define REG_SC_BK80_29_L      _PK_L_(0x80, 0x29)
#define REG_SC_BK80_29_H      _PK_H_(0x80, 0x29)
#define REG_SC_BK80_2A_L      _PK_L_(0x80, 0x2A)
#define REG_SC_BK80_2A_H      _PK_H_(0x80, 0x2A)
#define REG_SC_BK80_2B_L      _PK_L_(0x80, 0x2B)
#define REG_SC_BK80_2B_H      _PK_H_(0x80, 0x2B)
#define REG_SC_BK80_2C_L      _PK_L_(0x80, 0x2C)
#define REG_SC_BK80_2C_H      _PK_H_(0x80, 0x2C)
#define REG_SC_BK80_2D_L      _PK_L_(0x80, 0x2D)
#define REG_SC_BK80_2D_H      _PK_H_(0x80, 0x2D)
#define REG_SC_BK80_2E_L      _PK_L_(0x80, 0x2E)
#define REG_SC_BK80_2E_H      _PK_H_(0x80, 0x2E)
#define REG_SC_BK80_2F_L      _PK_L_(0x80, 0x2F)
#define REG_SC_BK80_2F_H      _PK_H_(0x80, 0x2F)
#define REG_SC_BK80_30_L      _PK_L_(0x80, 0x30)
#define REG_SC_BK80_30_H      _PK_H_(0x80, 0x30)
#define REG_SC_BK80_31_L      _PK_L_(0x80, 0x31)
#define REG_SC_BK80_31_H      _PK_H_(0x80, 0x31)
#define REG_SC_BK80_32_L      _PK_L_(0x80, 0x32)
#define REG_SC_BK80_32_H      _PK_H_(0x80, 0x32)
#define REG_SC_BK80_33_L      _PK_L_(0x80, 0x33)
#define REG_SC_BK80_33_H      _PK_H_(0x80, 0x33)
#define REG_SC_BK80_34_L      _PK_L_(0x80, 0x34)
#define REG_SC_BK80_34_H      _PK_H_(0x80, 0x34)
#define REG_SC_BK80_35_L      _PK_L_(0x80, 0x35)
#define REG_SC_BK80_35_H      _PK_H_(0x80, 0x35)
#define REG_SC_BK80_36_L      _PK_L_(0x80, 0x36)
#define REG_SC_BK80_36_H      _PK_H_(0x80, 0x36)
#define REG_SC_BK80_37_L      _PK_L_(0x80, 0x37)
#define REG_SC_BK80_37_H      _PK_H_(0x80, 0x37)
#define REG_SC_BK80_38_L      _PK_L_(0x80, 0x38)
#define REG_SC_BK80_38_H      _PK_H_(0x80, 0x38)
#define REG_SC_BK80_39_L      _PK_L_(0x80, 0x39)
#define REG_SC_BK80_39_H      _PK_H_(0x80, 0x39)
#define REG_SC_BK80_3A_L      _PK_L_(0x80, 0x3A)
#define REG_SC_BK80_3A_H      _PK_H_(0x80, 0x3A)
#define REG_SC_BK80_3B_L      _PK_L_(0x80, 0x3B)
#define REG_SC_BK80_3B_H      _PK_H_(0x80, 0x3B)
#define REG_SC_BK80_3C_L      _PK_L_(0x80, 0x3C)
#define REG_SC_BK80_3C_H      _PK_H_(0x80, 0x3C)
#define REG_SC_BK80_3D_L      _PK_L_(0x80, 0x3D)
#define REG_SC_BK80_3D_H      _PK_H_(0x80, 0x3D)
#define REG_SC_BK80_3E_L      _PK_L_(0x80, 0x3E)
#define REG_SC_BK80_3E_H      _PK_H_(0x80, 0x3E)
#define REG_SC_BK80_3F_L      _PK_L_(0x80, 0x3F)
#define REG_SC_BK80_3F_H      _PK_H_(0x80, 0x3F)
#define REG_SC_BK80_40_L      _PK_L_(0x80, 0x40)
#define REG_SC_BK80_40_H      _PK_H_(0x80, 0x40)
#define REG_SC_BK80_41_L      _PK_L_(0x80, 0x41)
#define REG_SC_BK80_41_H      _PK_H_(0x80, 0x41)
#define REG_SC_BK80_42_L      _PK_L_(0x80, 0x42)
#define REG_SC_BK80_42_H      _PK_H_(0x80, 0x42)
#define REG_SC_BK80_43_L      _PK_L_(0x80, 0x43)
#define REG_SC_BK80_43_H      _PK_H_(0x80, 0x43)
#define REG_SC_BK80_44_L      _PK_L_(0x80, 0x44)
#define REG_SC_BK80_44_H      _PK_H_(0x80, 0x44)
#define REG_SC_BK80_45_L      _PK_L_(0x80, 0x45)
#define REG_SC_BK80_45_H      _PK_H_(0x80, 0x45)
#define REG_SC_BK80_46_L      _PK_L_(0x80, 0x46)
#define REG_SC_BK80_46_H      _PK_H_(0x80, 0x46)
#define REG_SC_BK80_47_L      _PK_L_(0x80, 0x47)
#define REG_SC_BK80_47_H      _PK_H_(0x80, 0x47)
#define REG_SC_BK80_48_L      _PK_L_(0x80, 0x48)
#define REG_SC_BK80_48_H      _PK_H_(0x80, 0x48)
#define REG_SC_BK80_49_L      _PK_L_(0x80, 0x49)
#define REG_SC_BK80_49_H      _PK_H_(0x80, 0x49)
#define REG_SC_BK80_4A_L      _PK_L_(0x80, 0x4A)
#define REG_SC_BK80_4A_H      _PK_H_(0x80, 0x4A)
#define REG_SC_BK80_4B_L      _PK_L_(0x80, 0x4B)
#define REG_SC_BK80_4B_H      _PK_H_(0x80, 0x4B)
#define REG_SC_BK80_4C_L      _PK_L_(0x80, 0x4C)
#define REG_SC_BK80_4C_H      _PK_H_(0x80, 0x4C)
#define REG_SC_BK80_4D_L      _PK_L_(0x80, 0x4D)
#define REG_SC_BK80_4D_H      _PK_H_(0x80, 0x4D)
#define REG_SC_BK80_4E_L      _PK_L_(0x80, 0x4E)
#define REG_SC_BK80_4E_H      _PK_H_(0x80, 0x4E)
#define REG_SC_BK80_4F_L      _PK_L_(0x80, 0x4F)
#define REG_SC_BK80_4F_H      _PK_H_(0x80, 0x4F)
#define REG_SC_BK80_50_L      _PK_L_(0x80, 0x50)
#define REG_SC_BK80_50_H      _PK_H_(0x80, 0x50)
#define REG_SC_BK80_51_L      _PK_L_(0x80, 0x51)
#define REG_SC_BK80_51_H      _PK_H_(0x80, 0x51)
#define REG_SC_BK80_52_L      _PK_L_(0x80, 0x52)
#define REG_SC_BK80_52_H      _PK_H_(0x80, 0x52)
#define REG_SC_BK80_53_L      _PK_L_(0x80, 0x53)
#define REG_SC_BK80_53_H      _PK_H_(0x80, 0x53)
#define REG_SC_BK80_54_L      _PK_L_(0x80, 0x54)
#define REG_SC_BK80_54_H      _PK_H_(0x80, 0x54)
#define REG_SC_BK80_55_L      _PK_L_(0x80, 0x55)
#define REG_SC_BK80_55_H      _PK_H_(0x80, 0x55)
#define REG_SC_BK80_56_L      _PK_L_(0x80, 0x56)
#define REG_SC_BK80_56_H      _PK_H_(0x80, 0x56)
#define REG_SC_BK80_57_L      _PK_L_(0x80, 0x57)
#define REG_SC_BK80_57_H      _PK_H_(0x80, 0x57)
#define REG_SC_BK80_58_L      _PK_L_(0x80, 0x58)
#define REG_SC_BK80_58_H      _PK_H_(0x80, 0x58)
#define REG_SC_BK80_59_L      _PK_L_(0x80, 0x59)
#define REG_SC_BK80_59_H      _PK_H_(0x80, 0x59)
#define REG_SC_BK80_5A_L      _PK_L_(0x80, 0x5A)
#define REG_SC_BK80_5A_H      _PK_H_(0x80, 0x5A)
#define REG_SC_BK80_5B_L      _PK_L_(0x80, 0x5B)
#define REG_SC_BK80_5B_H      _PK_H_(0x80, 0x5B)
#define REG_SC_BK80_5C_L      _PK_L_(0x80, 0x5C)
#define REG_SC_BK80_5C_H      _PK_H_(0x80, 0x5C)
#define REG_SC_BK80_5D_L      _PK_L_(0x80, 0x5D)
#define REG_SC_BK80_5D_H      _PK_H_(0x80, 0x5D)
#define REG_SC_BK80_5E_L      _PK_L_(0x80, 0x5E)
#define REG_SC_BK80_5E_H      _PK_H_(0x80, 0x5E)
#define REG_SC_BK80_5F_L      _PK_L_(0x80, 0x5F)
#define REG_SC_BK80_5F_H      _PK_H_(0x80, 0x5F)
#define REG_SC_BK80_60_L      _PK_L_(0x80, 0x60)
#define REG_SC_BK80_60_H      _PK_H_(0x80, 0x60)
#define REG_SC_BK80_61_L      _PK_L_(0x80, 0x61)
#define REG_SC_BK80_61_H      _PK_H_(0x80, 0x61)
#define REG_SC_BK80_62_L      _PK_L_(0x80, 0x62)
#define REG_SC_BK80_62_H      _PK_H_(0x80, 0x62)
#define REG_SC_BK80_63_L      _PK_L_(0x80, 0x63)
#define REG_SC_BK80_63_H      _PK_H_(0x80, 0x63)
#define REG_SC_BK80_64_L      _PK_L_(0x80, 0x64)
#define REG_SC_BK80_64_H      _PK_H_(0x80, 0x64)
#define REG_SC_BK80_65_L      _PK_L_(0x80, 0x65)
#define REG_SC_BK80_65_H      _PK_H_(0x80, 0x65)
#define REG_SC_BK80_66_L      _PK_L_(0x80, 0x66)
#define REG_SC_BK80_66_H      _PK_H_(0x80, 0x66)
#define REG_SC_BK80_67_L      _PK_L_(0x80, 0x67)
#define REG_SC_BK80_67_H      _PK_H_(0x80, 0x67)
#define REG_SC_BK80_68_L      _PK_L_(0x80, 0x68)
#define REG_SC_BK80_68_H      _PK_H_(0x80, 0x68)
#define REG_SC_BK80_69_L      _PK_L_(0x80, 0x69)
#define REG_SC_BK80_69_H      _PK_H_(0x80, 0x69)
#define REG_SC_BK80_6A_L      _PK_L_(0x80, 0x6A)
#define REG_SC_BK80_6A_H      _PK_H_(0x80, 0x6A)
#define REG_SC_BK80_6B_L      _PK_L_(0x80, 0x6B)
#define REG_SC_BK80_6B_H      _PK_H_(0x80, 0x6B)
#define REG_SC_BK80_6C_L      _PK_L_(0x80, 0x6C)
#define REG_SC_BK80_6C_H      _PK_H_(0x80, 0x6C)
#define REG_SC_BK80_6D_L      _PK_L_(0x80, 0x6D)
#define REG_SC_BK80_6D_H      _PK_H_(0x80, 0x6D)
#define REG_SC_BK80_6E_L      _PK_L_(0x80, 0x6E)
#define REG_SC_BK80_6E_H      _PK_H_(0x80, 0x6E)
#define REG_SC_BK80_6F_L      _PK_L_(0x80, 0x6F)
#define REG_SC_BK80_6F_H      _PK_H_(0x80, 0x6F)
#define REG_SC_BK80_70_L      _PK_L_(0x80, 0x70)
#define REG_SC_BK80_70_H      _PK_H_(0x80, 0x70)
#define REG_SC_BK80_71_L      _PK_L_(0x80, 0x71)
#define REG_SC_BK80_71_H      _PK_H_(0x80, 0x71)
#define REG_SC_BK80_72_L      _PK_L_(0x80, 0x72)
#define REG_SC_BK80_72_H      _PK_H_(0x80, 0x72)
#define REG_SC_BK80_73_L      _PK_L_(0x80, 0x73)
#define REG_SC_BK80_73_H      _PK_H_(0x80, 0x73)
#define REG_SC_BK80_74_L      _PK_L_(0x80, 0x74)
#define REG_SC_BK80_74_H      _PK_H_(0x80, 0x74)
#define REG_SC_BK80_75_L      _PK_L_(0x80, 0x75)
#define REG_SC_BK80_75_H      _PK_H_(0x80, 0x75)
#define REG_SC_BK80_76_L      _PK_L_(0x80, 0x76)
#define REG_SC_BK80_76_H      _PK_H_(0x80, 0x76)
#define REG_SC_BK80_77_L      _PK_L_(0x80, 0x77)
#define REG_SC_BK80_77_H      _PK_H_(0x80, 0x77)
#define REG_SC_BK80_78_L      _PK_L_(0x80, 0x78)
#define REG_SC_BK80_78_H      _PK_H_(0x80, 0x78)
#define REG_SC_BK80_79_L      _PK_L_(0x80, 0x79)
#define REG_SC_BK80_79_H      _PK_H_(0x80, 0x79)
#define REG_SC_BK80_7A_L      _PK_L_(0x80, 0x7A)
#define REG_SC_BK80_7A_H      _PK_H_(0x80, 0x7A)
#define REG_SC_BK80_7B_L      _PK_L_(0x80, 0x7B)
#define REG_SC_BK80_7B_H      _PK_H_(0x80, 0x7B)
#define REG_SC_BK80_7C_L      _PK_L_(0x80, 0x7C)
#define REG_SC_BK80_7C_H      _PK_H_(0x80, 0x7C)
#define REG_SC_BK80_7D_L      _PK_L_(0x80, 0x7D)
#define REG_SC_BK80_7D_H      _PK_H_(0x80, 0x7D)
#define REG_SC_BK80_7E_L      _PK_L_(0x80, 0x7E)
#define REG_SC_BK80_7E_H      _PK_H_(0x80, 0x7E)
#define REG_SC_BK80_7F_L      _PK_L_(0x80, 0x7F)
#define REG_SC_BK80_7F_H      _PK_H_(0x80, 0x7F)
//----------------------------------------------
#define REG_SC_BK81_00_L      _PK_L_(0x81, 0x00)
#define REG_SC_BK81_00_H      _PK_H_(0x81, 0x00)
#define REG_SC_BK81_01_L      _PK_L_(0x81, 0x01)
#define REG_SC_BK81_01_H      _PK_H_(0x81, 0x01)
#define REG_SC_BK81_02_L      _PK_L_(0x81, 0x02)
#define REG_SC_BK81_02_H      _PK_H_(0x81, 0x02)
#define REG_SC_BK81_03_L      _PK_L_(0x81, 0x03)
#define REG_SC_BK81_03_H      _PK_H_(0x81, 0x03)
#define REG_SC_BK81_04_L      _PK_L_(0x81, 0x04)
#define REG_SC_BK81_04_H      _PK_H_(0x81, 0x04)
#define REG_SC_BK81_05_L      _PK_L_(0x81, 0x05)
#define REG_SC_BK81_05_H      _PK_H_(0x81, 0x05)
#define REG_SC_BK81_06_L      _PK_L_(0x81, 0x06)
#define REG_SC_BK81_06_H      _PK_H_(0x81, 0x06)
#define REG_SC_BK81_07_L      _PK_L_(0x81, 0x07)
#define REG_SC_BK81_07_H      _PK_H_(0x81, 0x07)
#define REG_SC_BK81_08_L      _PK_L_(0x81, 0x08)
#define REG_SC_BK81_08_H      _PK_H_(0x81, 0x08)
#define REG_SC_BK81_09_L      _PK_L_(0x81, 0x09)
#define REG_SC_BK81_09_H      _PK_H_(0x81, 0x09)
#define REG_SC_BK81_0A_L      _PK_L_(0x81, 0x0A)
#define REG_SC_BK81_0A_H      _PK_H_(0x81, 0x0A)
#define REG_SC_BK81_0B_L      _PK_L_(0x81, 0x0B)
#define REG_SC_BK81_0B_H      _PK_H_(0x81, 0x0B)
#define REG_SC_BK81_0C_L      _PK_L_(0x81, 0x0C)
#define REG_SC_BK81_0C_H      _PK_H_(0x81, 0x0C)
#define REG_SC_BK81_0D_L      _PK_L_(0x81, 0x0D)
#define REG_SC_BK81_0D_H      _PK_H_(0x81, 0x0D)
#define REG_SC_BK81_0E_L      _PK_L_(0x81, 0x0E)
#define REG_SC_BK81_0E_H      _PK_H_(0x81, 0x0E)
#define REG_SC_BK81_0F_L      _PK_L_(0x81, 0x0F)
#define REG_SC_BK81_0F_H      _PK_H_(0x81, 0x0F)
#define REG_SC_BK81_10_L      _PK_L_(0x81, 0x10)
#define REG_SC_BK81_10_H      _PK_H_(0x81, 0x10)
#define REG_SC_BK81_11_L      _PK_L_(0x81, 0x11)
#define REG_SC_BK81_11_H      _PK_H_(0x81, 0x11)
#define REG_SC_BK81_12_L      _PK_L_(0x81, 0x12)
#define REG_SC_BK81_12_H      _PK_H_(0x81, 0x12)
#define REG_SC_BK81_13_L      _PK_L_(0x81, 0x13)
#define REG_SC_BK81_13_H      _PK_H_(0x81, 0x13)
#define REG_SC_BK81_14_L      _PK_L_(0x81, 0x14)
#define REG_SC_BK81_14_H      _PK_H_(0x81, 0x14)
#define REG_SC_BK81_15_L      _PK_L_(0x81, 0x15)
#define REG_SC_BK81_15_H      _PK_H_(0x81, 0x15)
#define REG_SC_BK81_16_L      _PK_L_(0x81, 0x16)
#define REG_SC_BK81_16_H      _PK_H_(0x81, 0x16)
#define REG_SC_BK81_17_L      _PK_L_(0x81, 0x17)
#define REG_SC_BK81_17_H      _PK_H_(0x81, 0x17)
#define REG_SC_BK81_18_L      _PK_L_(0x81, 0x18)
#define REG_SC_BK81_18_H      _PK_H_(0x81, 0x18)
#define REG_SC_BK81_19_L      _PK_L_(0x81, 0x19)
#define REG_SC_BK81_19_H      _PK_H_(0x81, 0x19)
#define REG_SC_BK81_1A_L      _PK_L_(0x81, 0x1A)
#define REG_SC_BK81_1A_H      _PK_H_(0x81, 0x1A)
#define REG_SC_BK81_1B_L      _PK_L_(0x81, 0x1B)
#define REG_SC_BK81_1B_H      _PK_H_(0x81, 0x1B)
#define REG_SC_BK81_1C_L      _PK_L_(0x81, 0x1C)
#define REG_SC_BK81_1C_H      _PK_H_(0x81, 0x1C)
#define REG_SC_BK81_1D_L      _PK_L_(0x81, 0x1D)
#define REG_SC_BK81_1D_H      _PK_H_(0x81, 0x1D)
#define REG_SC_BK81_1E_L      _PK_L_(0x81, 0x1E)
#define REG_SC_BK81_1E_H      _PK_H_(0x81, 0x1E)
#define REG_SC_BK81_1F_L      _PK_L_(0x81, 0x1F)
#define REG_SC_BK81_1F_H      _PK_H_(0x81, 0x1F)
#define REG_SC_BK81_20_L      _PK_L_(0x81, 0x20)
#define REG_SC_BK81_20_H      _PK_H_(0x81, 0x20)
#define REG_SC_BK81_21_L      _PK_L_(0x81, 0x21)
#define REG_SC_BK81_21_H      _PK_H_(0x81, 0x21)
#define REG_SC_BK81_22_L      _PK_L_(0x81, 0x22)
#define REG_SC_BK81_22_H      _PK_H_(0x81, 0x22)
#define REG_SC_BK81_23_L      _PK_L_(0x81, 0x23)
#define REG_SC_BK81_23_H      _PK_H_(0x81, 0x23)
#define REG_SC_BK81_24_L      _PK_L_(0x81, 0x24)
#define REG_SC_BK81_24_H      _PK_H_(0x81, 0x24)
#define REG_SC_BK81_25_L      _PK_L_(0x81, 0x25)
#define REG_SC_BK81_25_H      _PK_H_(0x81, 0x25)
#define REG_SC_BK81_26_L      _PK_L_(0x81, 0x26)
#define REG_SC_BK81_26_H      _PK_H_(0x81, 0x26)
#define REG_SC_BK81_27_L      _PK_L_(0x81, 0x27)
#define REG_SC_BK81_27_H      _PK_H_(0x81, 0x27)
#define REG_SC_BK81_28_L      _PK_L_(0x81, 0x28)
#define REG_SC_BK81_28_H      _PK_H_(0x81, 0x28)
#define REG_SC_BK81_29_L      _PK_L_(0x81, 0x29)
#define REG_SC_BK81_29_H      _PK_H_(0x81, 0x29)
#define REG_SC_BK81_2A_L      _PK_L_(0x81, 0x2A)
#define REG_SC_BK81_2A_H      _PK_H_(0x81, 0x2A)
#define REG_SC_BK81_2B_L      _PK_L_(0x81, 0x2B)
#define REG_SC_BK81_2B_H      _PK_H_(0x81, 0x2B)
#define REG_SC_BK81_2C_L      _PK_L_(0x81, 0x2C)
#define REG_SC_BK81_2C_H      _PK_H_(0x81, 0x2C)
#define REG_SC_BK81_2D_L      _PK_L_(0x81, 0x2D)
#define REG_SC_BK81_2D_H      _PK_H_(0x81, 0x2D)
#define REG_SC_BK81_2E_L      _PK_L_(0x81, 0x2E)
#define REG_SC_BK81_2E_H      _PK_H_(0x81, 0x2E)
#define REG_SC_BK81_2F_L      _PK_L_(0x81, 0x2F)
#define REG_SC_BK81_2F_H      _PK_H_(0x81, 0x2F)
#define REG_SC_BK81_30_L      _PK_L_(0x81, 0x30)
#define REG_SC_BK81_30_H      _PK_H_(0x81, 0x30)
#define REG_SC_BK81_31_L      _PK_L_(0x81, 0x31)
#define REG_SC_BK81_31_H      _PK_H_(0x81, 0x31)
#define REG_SC_BK81_32_L      _PK_L_(0x81, 0x32)
#define REG_SC_BK81_32_H      _PK_H_(0x81, 0x32)
#define REG_SC_BK81_33_L      _PK_L_(0x81, 0x33)
#define REG_SC_BK81_33_H      _PK_H_(0x81, 0x33)
#define REG_SC_BK81_34_L      _PK_L_(0x81, 0x34)
#define REG_SC_BK81_34_H      _PK_H_(0x81, 0x34)
#define REG_SC_BK81_35_L      _PK_L_(0x81, 0x35)
#define REG_SC_BK81_35_H      _PK_H_(0x81, 0x35)
#define REG_SC_BK81_36_L      _PK_L_(0x81, 0x36)
#define REG_SC_BK81_36_H      _PK_H_(0x81, 0x36)
#define REG_SC_BK81_37_L      _PK_L_(0x81, 0x37)
#define REG_SC_BK81_37_H      _PK_H_(0x81, 0x37)
#define REG_SC_BK81_38_L      _PK_L_(0x81, 0x38)
#define REG_SC_BK81_38_H      _PK_H_(0x81, 0x38)
#define REG_SC_BK81_39_L      _PK_L_(0x81, 0x39)
#define REG_SC_BK81_39_H      _PK_H_(0x81, 0x39)
#define REG_SC_BK81_3A_L      _PK_L_(0x81, 0x3A)
#define REG_SC_BK81_3A_H      _PK_H_(0x81, 0x3A)
#define REG_SC_BK81_3B_L      _PK_L_(0x81, 0x3B)
#define REG_SC_BK81_3B_H      _PK_H_(0x81, 0x3B)
#define REG_SC_BK81_3C_L      _PK_L_(0x81, 0x3C)
#define REG_SC_BK81_3C_H      _PK_H_(0x81, 0x3C)
#define REG_SC_BK81_3D_L      _PK_L_(0x81, 0x3D)
#define REG_SC_BK81_3D_H      _PK_H_(0x81, 0x3D)
#define REG_SC_BK81_3E_L      _PK_L_(0x81, 0x3E)
#define REG_SC_BK81_3E_H      _PK_H_(0x81, 0x3E)
#define REG_SC_BK81_3F_L      _PK_L_(0x81, 0x3F)
#define REG_SC_BK81_3F_H      _PK_H_(0x81, 0x3F)
#define REG_SC_BK81_40_L      _PK_L_(0x81, 0x40)
#define REG_SC_BK81_40_H      _PK_H_(0x81, 0x40)
#define REG_SC_BK81_41_L      _PK_L_(0x81, 0x41)
#define REG_SC_BK81_41_H      _PK_H_(0x81, 0x41)
#define REG_SC_BK81_42_L      _PK_L_(0x81, 0x42)
#define REG_SC_BK81_42_H      _PK_H_(0x81, 0x42)
#define REG_SC_BK81_43_L      _PK_L_(0x81, 0x43)
#define REG_SC_BK81_43_H      _PK_H_(0x81, 0x43)
#define REG_SC_BK81_44_L      _PK_L_(0x81, 0x44)
#define REG_SC_BK81_44_H      _PK_H_(0x81, 0x44)
#define REG_SC_BK81_45_L      _PK_L_(0x81, 0x45)
#define REG_SC_BK81_45_H      _PK_H_(0x81, 0x45)
#define REG_SC_BK81_46_L      _PK_L_(0x81, 0x46)
#define REG_SC_BK81_46_H      _PK_H_(0x81, 0x46)
#define REG_SC_BK81_47_L      _PK_L_(0x81, 0x47)
#define REG_SC_BK81_47_H      _PK_H_(0x81, 0x47)
#define REG_SC_BK81_48_L      _PK_L_(0x81, 0x48)
#define REG_SC_BK81_48_H      _PK_H_(0x81, 0x48)
#define REG_SC_BK81_49_L      _PK_L_(0x81, 0x49)
#define REG_SC_BK81_49_H      _PK_H_(0x81, 0x49)
#define REG_SC_BK81_4A_L      _PK_L_(0x81, 0x4A)
#define REG_SC_BK81_4A_H      _PK_H_(0x81, 0x4A)
#define REG_SC_BK81_4B_L      _PK_L_(0x81, 0x4B)
#define REG_SC_BK81_4B_H      _PK_H_(0x81, 0x4B)
#define REG_SC_BK81_4C_L      _PK_L_(0x81, 0x4C)
#define REG_SC_BK81_4C_H      _PK_H_(0x81, 0x4C)
#define REG_SC_BK81_4D_L      _PK_L_(0x81, 0x4D)
#define REG_SC_BK81_4D_H      _PK_H_(0x81, 0x4D)
#define REG_SC_BK81_4E_L      _PK_L_(0x81, 0x4E)
#define REG_SC_BK81_4E_H      _PK_H_(0x81, 0x4E)
#define REG_SC_BK81_4F_L      _PK_L_(0x81, 0x4F)
#define REG_SC_BK81_4F_H      _PK_H_(0x81, 0x4F)
#define REG_SC_BK81_50_L      _PK_L_(0x81, 0x50)
#define REG_SC_BK81_50_H      _PK_H_(0x81, 0x50)
#define REG_SC_BK81_51_L      _PK_L_(0x81, 0x51)
#define REG_SC_BK81_51_H      _PK_H_(0x81, 0x51)
#define REG_SC_BK81_52_L      _PK_L_(0x81, 0x52)
#define REG_SC_BK81_52_H      _PK_H_(0x81, 0x52)
#define REG_SC_BK81_53_L      _PK_L_(0x81, 0x53)
#define REG_SC_BK81_53_H      _PK_H_(0x81, 0x53)
#define REG_SC_BK81_54_L      _PK_L_(0x81, 0x54)
#define REG_SC_BK81_54_H      _PK_H_(0x81, 0x54)
#define REG_SC_BK81_55_L      _PK_L_(0x81, 0x55)
#define REG_SC_BK81_55_H      _PK_H_(0x81, 0x55)
#define REG_SC_BK81_56_L      _PK_L_(0x81, 0x56)
#define REG_SC_BK81_56_H      _PK_H_(0x81, 0x56)
#define REG_SC_BK81_57_L      _PK_L_(0x81, 0x57)
#define REG_SC_BK81_57_H      _PK_H_(0x81, 0x57)
#define REG_SC_BK81_58_L      _PK_L_(0x81, 0x58)
#define REG_SC_BK81_58_H      _PK_H_(0x81, 0x58)
#define REG_SC_BK81_59_L      _PK_L_(0x81, 0x59)
#define REG_SC_BK81_59_H      _PK_H_(0x81, 0x59)
#define REG_SC_BK81_5A_L      _PK_L_(0x81, 0x5A)
#define REG_SC_BK81_5A_H      _PK_H_(0x81, 0x5A)
#define REG_SC_BK81_5B_L      _PK_L_(0x81, 0x5B)
#define REG_SC_BK81_5B_H      _PK_H_(0x81, 0x5B)
#define REG_SC_BK81_5C_L      _PK_L_(0x81, 0x5C)
#define REG_SC_BK81_5C_H      _PK_H_(0x81, 0x5C)
#define REG_SC_BK81_5D_L      _PK_L_(0x81, 0x5D)
#define REG_SC_BK81_5D_H      _PK_H_(0x81, 0x5D)
#define REG_SC_BK81_5E_L      _PK_L_(0x81, 0x5E)
#define REG_SC_BK81_5E_H      _PK_H_(0x81, 0x5E)
#define REG_SC_BK81_5F_L      _PK_L_(0x81, 0x5F)
#define REG_SC_BK81_5F_H      _PK_H_(0x81, 0x5F)
#define REG_SC_BK81_60_L      _PK_L_(0x81, 0x60)
#define REG_SC_BK81_60_H      _PK_H_(0x81, 0x60)
#define REG_SC_BK81_61_L      _PK_L_(0x81, 0x61)
#define REG_SC_BK81_61_H      _PK_H_(0x81, 0x61)
#define REG_SC_BK81_62_L      _PK_L_(0x81, 0x62)
#define REG_SC_BK81_62_H      _PK_H_(0x81, 0x62)
#define REG_SC_BK81_63_L      _PK_L_(0x81, 0x63)
#define REG_SC_BK81_63_H      _PK_H_(0x81, 0x63)
#define REG_SC_BK81_64_L      _PK_L_(0x81, 0x64)
#define REG_SC_BK81_64_H      _PK_H_(0x81, 0x64)
#define REG_SC_BK81_65_L      _PK_L_(0x81, 0x65)
#define REG_SC_BK81_65_H      _PK_H_(0x81, 0x65)
#define REG_SC_BK81_66_L      _PK_L_(0x81, 0x66)
#define REG_SC_BK81_66_H      _PK_H_(0x81, 0x66)
#define REG_SC_BK81_67_L      _PK_L_(0x81, 0x67)
#define REG_SC_BK81_67_H      _PK_H_(0x81, 0x67)
#define REG_SC_BK81_68_L      _PK_L_(0x81, 0x68)
#define REG_SC_BK81_68_H      _PK_H_(0x81, 0x68)
#define REG_SC_BK81_69_L      _PK_L_(0x81, 0x69)
#define REG_SC_BK81_69_H      _PK_H_(0x81, 0x69)
#define REG_SC_BK81_6A_L      _PK_L_(0x81, 0x6A)
#define REG_SC_BK81_6A_H      _PK_H_(0x81, 0x6A)
#define REG_SC_BK81_6B_L      _PK_L_(0x81, 0x6B)
#define REG_SC_BK81_6B_H      _PK_H_(0x81, 0x6B)
#define REG_SC_BK81_6C_L      _PK_L_(0x81, 0x6C)
#define REG_SC_BK81_6C_H      _PK_H_(0x81, 0x6C)
#define REG_SC_BK81_6D_L      _PK_L_(0x81, 0x6D)
#define REG_SC_BK81_6D_H      _PK_H_(0x81, 0x6D)
#define REG_SC_BK81_6E_L      _PK_L_(0x81, 0x6E)
#define REG_SC_BK81_6E_H      _PK_H_(0x81, 0x6E)
#define REG_SC_BK81_6F_L      _PK_L_(0x81, 0x6F)
#define REG_SC_BK81_6F_H      _PK_H_(0x81, 0x6F)
#define REG_SC_BK81_70_L      _PK_L_(0x81, 0x70)
#define REG_SC_BK81_70_H      _PK_H_(0x81, 0x70)
#define REG_SC_BK81_71_L      _PK_L_(0x81, 0x71)
#define REG_SC_BK81_71_H      _PK_H_(0x81, 0x71)
#define REG_SC_BK81_72_L      _PK_L_(0x81, 0x72)
#define REG_SC_BK81_72_H      _PK_H_(0x81, 0x72)
#define REG_SC_BK81_73_L      _PK_L_(0x81, 0x73)
#define REG_SC_BK81_73_H      _PK_H_(0x81, 0x73)
#define REG_SC_BK81_74_L      _PK_L_(0x81, 0x74)
#define REG_SC_BK81_74_H      _PK_H_(0x81, 0x74)
#define REG_SC_BK81_75_L      _PK_L_(0x81, 0x75)
#define REG_SC_BK81_75_H      _PK_H_(0x81, 0x75)
#define REG_SC_BK81_76_L      _PK_L_(0x81, 0x76)
#define REG_SC_BK81_76_H      _PK_H_(0x81, 0x76)
#define REG_SC_BK81_77_L      _PK_L_(0x81, 0x77)
#define REG_SC_BK81_77_H      _PK_H_(0x81, 0x77)
#define REG_SC_BK81_78_L      _PK_L_(0x81, 0x78)
#define REG_SC_BK81_78_H      _PK_H_(0x81, 0x78)
#define REG_SC_BK81_79_L      _PK_L_(0x81, 0x79)
#define REG_SC_BK81_79_H      _PK_H_(0x81, 0x79)
#define REG_SC_BK81_7A_L      _PK_L_(0x81, 0x7A)
#define REG_SC_BK81_7A_H      _PK_H_(0x81, 0x7A)
#define REG_SC_BK81_7B_L      _PK_L_(0x81, 0x7B)
#define REG_SC_BK81_7B_H      _PK_H_(0x81, 0x7B)
#define REG_SC_BK81_7C_L      _PK_L_(0x81, 0x7C)
#define REG_SC_BK81_7C_H      _PK_H_(0x81, 0x7C)
#define REG_SC_BK81_7D_L      _PK_L_(0x81, 0x7D)
#define REG_SC_BK81_7D_H      _PK_H_(0x81, 0x7D)
#define REG_SC_BK81_7E_L      _PK_L_(0x81, 0x7E)
#define REG_SC_BK81_7E_H      _PK_H_(0x81, 0x7E)
#define REG_SC_BK81_7F_L      _PK_L_(0x81, 0x7F)
#define REG_SC_BK81_7F_H      _PK_H_(0x81, 0x7F)
//----------------------------------------------
#define REG_SC_BK82_00_L      _PK_L_(0x82, 0x00)
#define REG_SC_BK82_00_H      _PK_H_(0x82, 0x00)
#define REG_SC_BK82_01_L      _PK_L_(0x82, 0x01)
#define REG_SC_BK82_01_H      _PK_H_(0x82, 0x01)
#define REG_SC_BK82_02_L      _PK_L_(0x82, 0x02)
#define REG_SC_BK82_02_H      _PK_H_(0x82, 0x02)
#define REG_SC_BK82_03_L      _PK_L_(0x82, 0x03)
#define REG_SC_BK82_03_H      _PK_H_(0x82, 0x03)
#define REG_SC_BK82_04_L      _PK_L_(0x82, 0x04)
#define REG_SC_BK82_04_H      _PK_H_(0x82, 0x04)
#define REG_SC_BK82_05_L      _PK_L_(0x82, 0x05)
#define REG_SC_BK82_05_H      _PK_H_(0x82, 0x05)
#define REG_SC_BK82_06_L      _PK_L_(0x82, 0x06)
#define REG_SC_BK82_06_H      _PK_H_(0x82, 0x06)
#define REG_SC_BK82_07_L      _PK_L_(0x82, 0x07)
#define REG_SC_BK82_07_H      _PK_H_(0x82, 0x07)
#define REG_SC_BK82_08_L      _PK_L_(0x82, 0x08)
#define REG_SC_BK82_08_H      _PK_H_(0x82, 0x08)
#define REG_SC_BK82_09_L      _PK_L_(0x82, 0x09)
#define REG_SC_BK82_09_H      _PK_H_(0x82, 0x09)
#define REG_SC_BK82_0A_L      _PK_L_(0x82, 0x0A)
#define REG_SC_BK82_0A_H      _PK_H_(0x82, 0x0A)
#define REG_SC_BK82_0B_L      _PK_L_(0x82, 0x0B)
#define REG_SC_BK82_0B_H      _PK_H_(0x82, 0x0B)
#define REG_SC_BK82_0C_L      _PK_L_(0x82, 0x0C)
#define REG_SC_BK82_0C_H      _PK_H_(0x82, 0x0C)
#define REG_SC_BK82_0D_L      _PK_L_(0x82, 0x0D)
#define REG_SC_BK82_0D_H      _PK_H_(0x82, 0x0D)
#define REG_SC_BK82_0E_L      _PK_L_(0x82, 0x0E)
#define REG_SC_BK82_0E_H      _PK_H_(0x82, 0x0E)
#define REG_SC_BK82_0F_L      _PK_L_(0x82, 0x0F)
#define REG_SC_BK82_0F_H      _PK_H_(0x82, 0x0F)
#define REG_SC_BK82_10_L      _PK_L_(0x82, 0x10)
#define REG_SC_BK82_10_H      _PK_H_(0x82, 0x10)
#define REG_SC_BK82_11_L      _PK_L_(0x82, 0x11)
#define REG_SC_BK82_11_H      _PK_H_(0x82, 0x11)
#define REG_SC_BK82_12_L      _PK_L_(0x82, 0x12)
#define REG_SC_BK82_12_H      _PK_H_(0x82, 0x12)
#define REG_SC_BK82_13_L      _PK_L_(0x82, 0x13)
#define REG_SC_BK82_13_H      _PK_H_(0x82, 0x13)
#define REG_SC_BK82_14_L      _PK_L_(0x82, 0x14)
#define REG_SC_BK82_14_H      _PK_H_(0x82, 0x14)
#define REG_SC_BK82_15_L      _PK_L_(0x82, 0x15)
#define REG_SC_BK82_15_H      _PK_H_(0x82, 0x15)
#define REG_SC_BK82_16_L      _PK_L_(0x82, 0x16)
#define REG_SC_BK82_16_H      _PK_H_(0x82, 0x16)
#define REG_SC_BK82_17_L      _PK_L_(0x82, 0x17)
#define REG_SC_BK82_17_H      _PK_H_(0x82, 0x17)
#define REG_SC_BK82_18_L      _PK_L_(0x82, 0x18)
#define REG_SC_BK82_18_H      _PK_H_(0x82, 0x18)
#define REG_SC_BK82_19_L      _PK_L_(0x82, 0x19)
#define REG_SC_BK82_19_H      _PK_H_(0x82, 0x19)
#define REG_SC_BK82_1A_L      _PK_L_(0x82, 0x1A)
#define REG_SC_BK82_1A_H      _PK_H_(0x82, 0x1A)
#define REG_SC_BK82_1B_L      _PK_L_(0x82, 0x1B)
#define REG_SC_BK82_1B_H      _PK_H_(0x82, 0x1B)
#define REG_SC_BK82_1C_L      _PK_L_(0x82, 0x1C)
#define REG_SC_BK82_1C_H      _PK_H_(0x82, 0x1C)
#define REG_SC_BK82_1D_L      _PK_L_(0x82, 0x1D)
#define REG_SC_BK82_1D_H      _PK_H_(0x82, 0x1D)
#define REG_SC_BK82_1E_L      _PK_L_(0x82, 0x1E)
#define REG_SC_BK82_1E_H      _PK_H_(0x82, 0x1E)
#define REG_SC_BK82_1F_L      _PK_L_(0x82, 0x1F)
#define REG_SC_BK82_1F_H      _PK_H_(0x82, 0x1F)
#define REG_SC_BK82_20_L      _PK_L_(0x82, 0x20)
#define REG_SC_BK82_20_H      _PK_H_(0x82, 0x20)
#define REG_SC_BK82_21_L      _PK_L_(0x82, 0x21)
#define REG_SC_BK82_21_H      _PK_H_(0x82, 0x21)
#define REG_SC_BK82_22_L      _PK_L_(0x82, 0x22)
#define REG_SC_BK82_22_H      _PK_H_(0x82, 0x22)
#define REG_SC_BK82_23_L      _PK_L_(0x82, 0x23)
#define REG_SC_BK82_23_H      _PK_H_(0x82, 0x23)
#define REG_SC_BK82_24_L      _PK_L_(0x82, 0x24)
#define REG_SC_BK82_24_H      _PK_H_(0x82, 0x24)
#define REG_SC_BK82_25_L      _PK_L_(0x82, 0x25)
#define REG_SC_BK82_25_H      _PK_H_(0x82, 0x25)
#define REG_SC_BK82_26_L      _PK_L_(0x82, 0x26)
#define REG_SC_BK82_26_H      _PK_H_(0x82, 0x26)
#define REG_SC_BK82_27_L      _PK_L_(0x82, 0x27)
#define REG_SC_BK82_27_H      _PK_H_(0x82, 0x27)
#define REG_SC_BK82_28_L      _PK_L_(0x82, 0x28)
#define REG_SC_BK82_28_H      _PK_H_(0x82, 0x28)
#define REG_SC_BK82_29_L      _PK_L_(0x82, 0x29)
#define REG_SC_BK82_29_H      _PK_H_(0x82, 0x29)
#define REG_SC_BK82_2A_L      _PK_L_(0x82, 0x2A)
#define REG_SC_BK82_2A_H      _PK_H_(0x82, 0x2A)
#define REG_SC_BK82_2B_L      _PK_L_(0x82, 0x2B)
#define REG_SC_BK82_2B_H      _PK_H_(0x82, 0x2B)
#define REG_SC_BK82_2C_L      _PK_L_(0x82, 0x2C)
#define REG_SC_BK82_2C_H      _PK_H_(0x82, 0x2C)
#define REG_SC_BK82_2D_L      _PK_L_(0x82, 0x2D)
#define REG_SC_BK82_2D_H      _PK_H_(0x82, 0x2D)
#define REG_SC_BK82_2E_L      _PK_L_(0x82, 0x2E)
#define REG_SC_BK82_2E_H      _PK_H_(0x82, 0x2E)
#define REG_SC_BK82_2F_L      _PK_L_(0x82, 0x2F)
#define REG_SC_BK82_2F_H      _PK_H_(0x82, 0x2F)
#define REG_SC_BK82_30_L      _PK_L_(0x82, 0x30)
#define REG_SC_BK82_30_H      _PK_H_(0x82, 0x30)
#define REG_SC_BK82_31_L      _PK_L_(0x82, 0x31)
#define REG_SC_BK82_31_H      _PK_H_(0x82, 0x31)
#define REG_SC_BK82_32_L      _PK_L_(0x82, 0x32)
#define REG_SC_BK82_32_H      _PK_H_(0x82, 0x32)
#define REG_SC_BK82_33_L      _PK_L_(0x82, 0x33)
#define REG_SC_BK82_33_H      _PK_H_(0x82, 0x33)
#define REG_SC_BK82_34_L      _PK_L_(0x82, 0x34)
#define REG_SC_BK82_34_H      _PK_H_(0x82, 0x34)
#define REG_SC_BK82_35_L      _PK_L_(0x82, 0x35)
#define REG_SC_BK82_35_H      _PK_H_(0x82, 0x35)
#define REG_SC_BK82_36_L      _PK_L_(0x82, 0x36)
#define REG_SC_BK82_36_H      _PK_H_(0x82, 0x36)
#define REG_SC_BK82_37_L      _PK_L_(0x82, 0x37)
#define REG_SC_BK82_37_H      _PK_H_(0x82, 0x37)
#define REG_SC_BK82_38_L      _PK_L_(0x82, 0x38)
#define REG_SC_BK82_38_H      _PK_H_(0x82, 0x38)
#define REG_SC_BK82_39_L      _PK_L_(0x82, 0x39)
#define REG_SC_BK82_39_H      _PK_H_(0x82, 0x39)
#define REG_SC_BK82_3A_L      _PK_L_(0x82, 0x3A)
#define REG_SC_BK82_3A_H      _PK_H_(0x82, 0x3A)
#define REG_SC_BK82_3B_L      _PK_L_(0x82, 0x3B)
#define REG_SC_BK82_3B_H      _PK_H_(0x82, 0x3B)
#define REG_SC_BK82_3C_L      _PK_L_(0x82, 0x3C)
#define REG_SC_BK82_3C_H      _PK_H_(0x82, 0x3C)
#define REG_SC_BK82_3D_L      _PK_L_(0x82, 0x3D)
#define REG_SC_BK82_3D_H      _PK_H_(0x82, 0x3D)
#define REG_SC_BK82_3E_L      _PK_L_(0x82, 0x3E)
#define REG_SC_BK82_3E_H      _PK_H_(0x82, 0x3E)
#define REG_SC_BK82_3F_L      _PK_L_(0x82, 0x3F)
#define REG_SC_BK82_3F_H      _PK_H_(0x82, 0x3F)
#define REG_SC_BK82_40_L      _PK_L_(0x82, 0x40)
#define REG_SC_BK82_40_H      _PK_H_(0x82, 0x40)
#define REG_SC_BK82_41_L      _PK_L_(0x82, 0x41)
#define REG_SC_BK82_41_H      _PK_H_(0x82, 0x41)
#define REG_SC_BK82_42_L      _PK_L_(0x82, 0x42)
#define REG_SC_BK82_42_H      _PK_H_(0x82, 0x42)
#define REG_SC_BK82_43_L      _PK_L_(0x82, 0x43)
#define REG_SC_BK82_43_H      _PK_H_(0x82, 0x43)
#define REG_SC_BK82_44_L      _PK_L_(0x82, 0x44)
#define REG_SC_BK82_44_H      _PK_H_(0x82, 0x44)
#define REG_SC_BK82_45_L      _PK_L_(0x82, 0x45)
#define REG_SC_BK82_45_H      _PK_H_(0x82, 0x45)
#define REG_SC_BK82_46_L      _PK_L_(0x82, 0x46)
#define REG_SC_BK82_46_H      _PK_H_(0x82, 0x46)
#define REG_SC_BK82_47_L      _PK_L_(0x82, 0x47)
#define REG_SC_BK82_47_H      _PK_H_(0x82, 0x47)
#define REG_SC_BK82_48_L      _PK_L_(0x82, 0x48)
#define REG_SC_BK82_48_H      _PK_H_(0x82, 0x48)
#define REG_SC_BK82_49_L      _PK_L_(0x82, 0x49)
#define REG_SC_BK82_49_H      _PK_H_(0x82, 0x49)
#define REG_SC_BK82_4A_L      _PK_L_(0x82, 0x4A)
#define REG_SC_BK82_4A_H      _PK_H_(0x82, 0x4A)
#define REG_SC_BK82_4B_L      _PK_L_(0x82, 0x4B)
#define REG_SC_BK82_4B_H      _PK_H_(0x82, 0x4B)
#define REG_SC_BK82_4C_L      _PK_L_(0x82, 0x4C)
#define REG_SC_BK82_4C_H      _PK_H_(0x82, 0x4C)
#define REG_SC_BK82_4D_L      _PK_L_(0x82, 0x4D)
#define REG_SC_BK82_4D_H      _PK_H_(0x82, 0x4D)
#define REG_SC_BK82_4E_L      _PK_L_(0x82, 0x4E)
#define REG_SC_BK82_4E_H      _PK_H_(0x82, 0x4E)
#define REG_SC_BK82_4F_L      _PK_L_(0x82, 0x4F)
#define REG_SC_BK82_4F_H      _PK_H_(0x82, 0x4F)
#define REG_SC_BK82_50_L      _PK_L_(0x82, 0x50)
#define REG_SC_BK82_50_H      _PK_H_(0x82, 0x50)
#define REG_SC_BK82_51_L      _PK_L_(0x82, 0x51)
#define REG_SC_BK82_51_H      _PK_H_(0x82, 0x51)
#define REG_SC_BK82_52_L      _PK_L_(0x82, 0x52)
#define REG_SC_BK82_52_H      _PK_H_(0x82, 0x52)
#define REG_SC_BK82_53_L      _PK_L_(0x82, 0x53)
#define REG_SC_BK82_53_H      _PK_H_(0x82, 0x53)
#define REG_SC_BK82_54_L      _PK_L_(0x82, 0x54)
#define REG_SC_BK82_54_H      _PK_H_(0x82, 0x54)
#define REG_SC_BK82_55_L      _PK_L_(0x82, 0x55)
#define REG_SC_BK82_55_H      _PK_H_(0x82, 0x55)
#define REG_SC_BK82_56_L      _PK_L_(0x82, 0x56)
#define REG_SC_BK82_56_H      _PK_H_(0x82, 0x56)
#define REG_SC_BK82_57_L      _PK_L_(0x82, 0x57)
#define REG_SC_BK82_57_H      _PK_H_(0x82, 0x57)
#define REG_SC_BK82_58_L      _PK_L_(0x82, 0x58)
#define REG_SC_BK82_58_H      _PK_H_(0x82, 0x58)
#define REG_SC_BK82_59_L      _PK_L_(0x82, 0x59)
#define REG_SC_BK82_59_H      _PK_H_(0x82, 0x59)
#define REG_SC_BK82_5A_L      _PK_L_(0x82, 0x5A)
#define REG_SC_BK82_5A_H      _PK_H_(0x82, 0x5A)
#define REG_SC_BK82_5B_L      _PK_L_(0x82, 0x5B)
#define REG_SC_BK82_5B_H      _PK_H_(0x82, 0x5B)
#define REG_SC_BK82_5C_L      _PK_L_(0x82, 0x5C)
#define REG_SC_BK82_5C_H      _PK_H_(0x82, 0x5C)
#define REG_SC_BK82_5D_L      _PK_L_(0x82, 0x5D)
#define REG_SC_BK82_5D_H      _PK_H_(0x82, 0x5D)
#define REG_SC_BK82_5E_L      _PK_L_(0x82, 0x5E)
#define REG_SC_BK82_5E_H      _PK_H_(0x82, 0x5E)
#define REG_SC_BK82_5F_L      _PK_L_(0x82, 0x5F)
#define REG_SC_BK82_5F_H      _PK_H_(0x82, 0x5F)
#define REG_SC_BK82_60_L      _PK_L_(0x82, 0x60)
#define REG_SC_BK82_60_H      _PK_H_(0x82, 0x60)
#define REG_SC_BK82_61_L      _PK_L_(0x82, 0x61)
#define REG_SC_BK82_61_H      _PK_H_(0x82, 0x61)
#define REG_SC_BK82_62_L      _PK_L_(0x82, 0x62)
#define REG_SC_BK82_62_H      _PK_H_(0x82, 0x62)
#define REG_SC_BK82_63_L      _PK_L_(0x82, 0x63)
#define REG_SC_BK82_63_H      _PK_H_(0x82, 0x63)
#define REG_SC_BK82_64_L      _PK_L_(0x82, 0x64)
#define REG_SC_BK82_64_H      _PK_H_(0x82, 0x64)
#define REG_SC_BK82_65_L      _PK_L_(0x82, 0x65)
#define REG_SC_BK82_65_H      _PK_H_(0x82, 0x65)
#define REG_SC_BK82_66_L      _PK_L_(0x82, 0x66)
#define REG_SC_BK82_66_H      _PK_H_(0x82, 0x66)
#define REG_SC_BK82_67_L      _PK_L_(0x82, 0x67)
#define REG_SC_BK82_67_H      _PK_H_(0x82, 0x67)
#define REG_SC_BK82_68_L      _PK_L_(0x82, 0x68)
#define REG_SC_BK82_68_H      _PK_H_(0x82, 0x68)
#define REG_SC_BK82_69_L      _PK_L_(0x82, 0x69)
#define REG_SC_BK82_69_H      _PK_H_(0x82, 0x69)
#define REG_SC_BK82_6A_L      _PK_L_(0x82, 0x6A)
#define REG_SC_BK82_6A_H      _PK_H_(0x82, 0x6A)
#define REG_SC_BK82_6B_L      _PK_L_(0x82, 0x6B)
#define REG_SC_BK82_6B_H      _PK_H_(0x82, 0x6B)
#define REG_SC_BK82_6C_L      _PK_L_(0x82, 0x6C)
#define REG_SC_BK82_6C_H      _PK_H_(0x82, 0x6C)
#define REG_SC_BK82_6D_L      _PK_L_(0x82, 0x6D)
#define REG_SC_BK82_6D_H      _PK_H_(0x82, 0x6D)
#define REG_SC_BK82_6E_L      _PK_L_(0x82, 0x6E)
#define REG_SC_BK82_6E_H      _PK_H_(0x82, 0x6E)
#define REG_SC_BK82_6F_L      _PK_L_(0x82, 0x6F)
#define REG_SC_BK82_6F_H      _PK_H_(0x82, 0x6F)
#define REG_SC_BK82_70_L      _PK_L_(0x82, 0x70)
#define REG_SC_BK82_70_H      _PK_H_(0x82, 0x70)
#define REG_SC_BK82_71_L      _PK_L_(0x82, 0x71)
#define REG_SC_BK82_71_H      _PK_H_(0x82, 0x71)
#define REG_SC_BK82_72_L      _PK_L_(0x82, 0x72)
#define REG_SC_BK82_72_H      _PK_H_(0x82, 0x72)
#define REG_SC_BK82_73_L      _PK_L_(0x82, 0x73)
#define REG_SC_BK82_73_H      _PK_H_(0x82, 0x73)
#define REG_SC_BK82_74_L      _PK_L_(0x82, 0x74)
#define REG_SC_BK82_74_H      _PK_H_(0x82, 0x74)
#define REG_SC_BK82_75_L      _PK_L_(0x82, 0x75)
#define REG_SC_BK82_75_H      _PK_H_(0x82, 0x75)
#define REG_SC_BK82_76_L      _PK_L_(0x82, 0x76)
#define REG_SC_BK82_76_H      _PK_H_(0x82, 0x76)
#define REG_SC_BK82_77_L      _PK_L_(0x82, 0x77)
#define REG_SC_BK82_77_H      _PK_H_(0x82, 0x77)
#define REG_SC_BK82_78_L      _PK_L_(0x82, 0x78)
#define REG_SC_BK82_78_H      _PK_H_(0x82, 0x78)
#define REG_SC_BK82_79_L      _PK_L_(0x82, 0x79)
#define REG_SC_BK82_79_H      _PK_H_(0x82, 0x79)
#define REG_SC_BK82_7A_L      _PK_L_(0x82, 0x7A)
#define REG_SC_BK82_7A_H      _PK_H_(0x82, 0x7A)
#define REG_SC_BK82_7B_L      _PK_L_(0x82, 0x7B)
#define REG_SC_BK82_7B_H      _PK_H_(0x82, 0x7B)
#define REG_SC_BK82_7C_L      _PK_L_(0x82, 0x7C)
#define REG_SC_BK82_7C_H      _PK_H_(0x82, 0x7C)
#define REG_SC_BK82_7D_L      _PK_L_(0x82, 0x7D)
#define REG_SC_BK82_7D_H      _PK_H_(0x82, 0x7D)
#define REG_SC_BK82_7E_L      _PK_L_(0x82, 0x7E)
#define REG_SC_BK82_7E_H      _PK_H_(0x82, 0x7E)
#define REG_SC_BK82_7F_L      _PK_L_(0x82, 0x7F)
#define REG_SC_BK82_7F_H      _PK_H_(0x82, 0x7F)
//----------------------------------------------
#define REG_SC_BK83_00_L      _PK_L_(0x83, 0x00)
#define REG_SC_BK83_00_H      _PK_H_(0x83, 0x00)
#define REG_SC_BK83_01_L      _PK_L_(0x83, 0x01)
#define REG_SC_BK83_01_H      _PK_H_(0x83, 0x01)
#define REG_SC_BK83_02_L      _PK_L_(0x83, 0x02)
#define REG_SC_BK83_02_H      _PK_H_(0x83, 0x02)
#define REG_SC_BK83_03_L      _PK_L_(0x83, 0x03)
#define REG_SC_BK83_03_H      _PK_H_(0x83, 0x03)
#define REG_SC_BK83_04_L      _PK_L_(0x83, 0x04)
#define REG_SC_BK83_04_H      _PK_H_(0x83, 0x04)
#define REG_SC_BK83_05_L      _PK_L_(0x83, 0x05)
#define REG_SC_BK83_05_H      _PK_H_(0x83, 0x05)
#define REG_SC_BK83_06_L      _PK_L_(0x83, 0x06)
#define REG_SC_BK83_06_H      _PK_H_(0x83, 0x06)
#define REG_SC_BK83_07_L      _PK_L_(0x83, 0x07)
#define REG_SC_BK83_07_H      _PK_H_(0x83, 0x07)
#define REG_SC_BK83_08_L      _PK_L_(0x83, 0x08)
#define REG_SC_BK83_08_H      _PK_H_(0x83, 0x08)
#define REG_SC_BK83_09_L      _PK_L_(0x83, 0x09)
#define REG_SC_BK83_09_H      _PK_H_(0x83, 0x09)
#define REG_SC_BK83_0A_L      _PK_L_(0x83, 0x0A)
#define REG_SC_BK83_0A_H      _PK_H_(0x83, 0x0A)
#define REG_SC_BK83_0B_L      _PK_L_(0x83, 0x0B)
#define REG_SC_BK83_0B_H      _PK_H_(0x83, 0x0B)
#define REG_SC_BK83_0C_L      _PK_L_(0x83, 0x0C)
#define REG_SC_BK83_0C_H      _PK_H_(0x83, 0x0C)
#define REG_SC_BK83_0D_L      _PK_L_(0x83, 0x0D)
#define REG_SC_BK83_0D_H      _PK_H_(0x83, 0x0D)
#define REG_SC_BK83_0E_L      _PK_L_(0x83, 0x0E)
#define REG_SC_BK83_0E_H      _PK_H_(0x83, 0x0E)
#define REG_SC_BK83_0F_L      _PK_L_(0x83, 0x0F)
#define REG_SC_BK83_0F_H      _PK_H_(0x83, 0x0F)
#define REG_SC_BK83_10_L      _PK_L_(0x83, 0x10)
#define REG_SC_BK83_10_H      _PK_H_(0x83, 0x10)
#define REG_SC_BK83_11_L      _PK_L_(0x83, 0x11)
#define REG_SC_BK83_11_H      _PK_H_(0x83, 0x11)
#define REG_SC_BK83_12_L      _PK_L_(0x83, 0x12)
#define REG_SC_BK83_12_H      _PK_H_(0x83, 0x12)
#define REG_SC_BK83_13_L      _PK_L_(0x83, 0x13)
#define REG_SC_BK83_13_H      _PK_H_(0x83, 0x13)
#define REG_SC_BK83_14_L      _PK_L_(0x83, 0x14)
#define REG_SC_BK83_14_H      _PK_H_(0x83, 0x14)
#define REG_SC_BK83_15_L      _PK_L_(0x83, 0x15)
#define REG_SC_BK83_15_H      _PK_H_(0x83, 0x15)
#define REG_SC_BK83_16_L      _PK_L_(0x83, 0x16)
#define REG_SC_BK83_16_H      _PK_H_(0x83, 0x16)
#define REG_SC_BK83_17_L      _PK_L_(0x83, 0x17)
#define REG_SC_BK83_17_H      _PK_H_(0x83, 0x17)
#define REG_SC_BK83_18_L      _PK_L_(0x83, 0x18)
#define REG_SC_BK83_18_H      _PK_H_(0x83, 0x18)
#define REG_SC_BK83_19_L      _PK_L_(0x83, 0x19)
#define REG_SC_BK83_19_H      _PK_H_(0x83, 0x19)
#define REG_SC_BK83_1A_L      _PK_L_(0x83, 0x1A)
#define REG_SC_BK83_1A_H      _PK_H_(0x83, 0x1A)
#define REG_SC_BK83_1B_L      _PK_L_(0x83, 0x1B)
#define REG_SC_BK83_1B_H      _PK_H_(0x83, 0x1B)
#define REG_SC_BK83_1C_L      _PK_L_(0x83, 0x1C)
#define REG_SC_BK83_1C_H      _PK_H_(0x83, 0x1C)
#define REG_SC_BK83_1D_L      _PK_L_(0x83, 0x1D)
#define REG_SC_BK83_1D_H      _PK_H_(0x83, 0x1D)
#define REG_SC_BK83_1E_L      _PK_L_(0x83, 0x1E)
#define REG_SC_BK83_1E_H      _PK_H_(0x83, 0x1E)
#define REG_SC_BK83_1F_L      _PK_L_(0x83, 0x1F)
#define REG_SC_BK83_1F_H      _PK_H_(0x83, 0x1F)
#define REG_SC_BK83_20_L      _PK_L_(0x83, 0x20)
#define REG_SC_BK83_20_H      _PK_H_(0x83, 0x20)
#define REG_SC_BK83_21_L      _PK_L_(0x83, 0x21)
#define REG_SC_BK83_21_H      _PK_H_(0x83, 0x21)
#define REG_SC_BK83_22_L      _PK_L_(0x83, 0x22)
#define REG_SC_BK83_22_H      _PK_H_(0x83, 0x22)
#define REG_SC_BK83_23_L      _PK_L_(0x83, 0x23)
#define REG_SC_BK83_23_H      _PK_H_(0x83, 0x23)
#define REG_SC_BK83_24_L      _PK_L_(0x83, 0x24)
#define REG_SC_BK83_24_H      _PK_H_(0x83, 0x24)
#define REG_SC_BK83_25_L      _PK_L_(0x83, 0x25)
#define REG_SC_BK83_25_H      _PK_H_(0x83, 0x25)
#define REG_SC_BK83_26_L      _PK_L_(0x83, 0x26)
#define REG_SC_BK83_26_H      _PK_H_(0x83, 0x26)
#define REG_SC_BK83_27_L      _PK_L_(0x83, 0x27)
#define REG_SC_BK83_27_H      _PK_H_(0x83, 0x27)
#define REG_SC_BK83_28_L      _PK_L_(0x83, 0x28)
#define REG_SC_BK83_28_H      _PK_H_(0x83, 0x28)
#define REG_SC_BK83_29_L      _PK_L_(0x83, 0x29)
#define REG_SC_BK83_29_H      _PK_H_(0x83, 0x29)
#define REG_SC_BK83_2A_L      _PK_L_(0x83, 0x2A)
#define REG_SC_BK83_2A_H      _PK_H_(0x83, 0x2A)
#define REG_SC_BK83_2B_L      _PK_L_(0x83, 0x2B)
#define REG_SC_BK83_2B_H      _PK_H_(0x83, 0x2B)
#define REG_SC_BK83_2C_L      _PK_L_(0x83, 0x2C)
#define REG_SC_BK83_2C_H      _PK_H_(0x83, 0x2C)
#define REG_SC_BK83_2D_L      _PK_L_(0x83, 0x2D)
#define REG_SC_BK83_2D_H      _PK_H_(0x83, 0x2D)
#define REG_SC_BK83_2E_L      _PK_L_(0x83, 0x2E)
#define REG_SC_BK83_2E_H      _PK_H_(0x83, 0x2E)
#define REG_SC_BK83_2F_L      _PK_L_(0x83, 0x2F)
#define REG_SC_BK83_2F_H      _PK_H_(0x83, 0x2F)
#define REG_SC_BK83_30_L      _PK_L_(0x83, 0x30)
#define REG_SC_BK83_30_H      _PK_H_(0x83, 0x30)
#define REG_SC_BK83_31_L      _PK_L_(0x83, 0x31)
#define REG_SC_BK83_31_H      _PK_H_(0x83, 0x31)
#define REG_SC_BK83_32_L      _PK_L_(0x83, 0x32)
#define REG_SC_BK83_32_H      _PK_H_(0x83, 0x32)
#define REG_SC_BK83_33_L      _PK_L_(0x83, 0x33)
#define REG_SC_BK83_33_H      _PK_H_(0x83, 0x33)
#define REG_SC_BK83_34_L      _PK_L_(0x83, 0x34)
#define REG_SC_BK83_34_H      _PK_H_(0x83, 0x34)
#define REG_SC_BK83_35_L      _PK_L_(0x83, 0x35)
#define REG_SC_BK83_35_H      _PK_H_(0x83, 0x35)
#define REG_SC_BK83_36_L      _PK_L_(0x83, 0x36)
#define REG_SC_BK83_36_H      _PK_H_(0x83, 0x36)
#define REG_SC_BK83_37_L      _PK_L_(0x83, 0x37)
#define REG_SC_BK83_37_H      _PK_H_(0x83, 0x37)
#define REG_SC_BK83_38_L      _PK_L_(0x83, 0x38)
#define REG_SC_BK83_38_H      _PK_H_(0x83, 0x38)
#define REG_SC_BK83_39_L      _PK_L_(0x83, 0x39)
#define REG_SC_BK83_39_H      _PK_H_(0x83, 0x39)
#define REG_SC_BK83_3A_L      _PK_L_(0x83, 0x3A)
#define REG_SC_BK83_3A_H      _PK_H_(0x83, 0x3A)
#define REG_SC_BK83_3B_L      _PK_L_(0x83, 0x3B)
#define REG_SC_BK83_3B_H      _PK_H_(0x83, 0x3B)
#define REG_SC_BK83_3C_L      _PK_L_(0x83, 0x3C)
#define REG_SC_BK83_3C_H      _PK_H_(0x83, 0x3C)
#define REG_SC_BK83_3D_L      _PK_L_(0x83, 0x3D)
#define REG_SC_BK83_3D_H      _PK_H_(0x83, 0x3D)
#define REG_SC_BK83_3E_L      _PK_L_(0x83, 0x3E)
#define REG_SC_BK83_3E_H      _PK_H_(0x83, 0x3E)
#define REG_SC_BK83_3F_L      _PK_L_(0x83, 0x3F)
#define REG_SC_BK83_3F_H      _PK_H_(0x83, 0x3F)
#define REG_SC_BK83_40_L      _PK_L_(0x83, 0x40)
#define REG_SC_BK83_40_H      _PK_H_(0x83, 0x40)
#define REG_SC_BK83_41_L      _PK_L_(0x83, 0x41)
#define REG_SC_BK83_41_H      _PK_H_(0x83, 0x41)
#define REG_SC_BK83_42_L      _PK_L_(0x83, 0x42)
#define REG_SC_BK83_42_H      _PK_H_(0x83, 0x42)
#define REG_SC_BK83_43_L      _PK_L_(0x83, 0x43)
#define REG_SC_BK83_43_H      _PK_H_(0x83, 0x43)
#define REG_SC_BK83_44_L      _PK_L_(0x83, 0x44)
#define REG_SC_BK83_44_H      _PK_H_(0x83, 0x44)
#define REG_SC_BK83_45_L      _PK_L_(0x83, 0x45)
#define REG_SC_BK83_45_H      _PK_H_(0x83, 0x45)
#define REG_SC_BK83_46_L      _PK_L_(0x83, 0x46)
#define REG_SC_BK83_46_H      _PK_H_(0x83, 0x46)
#define REG_SC_BK83_47_L      _PK_L_(0x83, 0x47)
#define REG_SC_BK83_47_H      _PK_H_(0x83, 0x47)
#define REG_SC_BK83_48_L      _PK_L_(0x83, 0x48)
#define REG_SC_BK83_48_H      _PK_H_(0x83, 0x48)
#define REG_SC_BK83_49_L      _PK_L_(0x83, 0x49)
#define REG_SC_BK83_49_H      _PK_H_(0x83, 0x49)
#define REG_SC_BK83_4A_L      _PK_L_(0x83, 0x4A)
#define REG_SC_BK83_4A_H      _PK_H_(0x83, 0x4A)
#define REG_SC_BK83_4B_L      _PK_L_(0x83, 0x4B)
#define REG_SC_BK83_4B_H      _PK_H_(0x83, 0x4B)
#define REG_SC_BK83_4C_L      _PK_L_(0x83, 0x4C)
#define REG_SC_BK83_4C_H      _PK_H_(0x83, 0x4C)
#define REG_SC_BK83_4D_L      _PK_L_(0x83, 0x4D)
#define REG_SC_BK83_4D_H      _PK_H_(0x83, 0x4D)
#define REG_SC_BK83_4E_L      _PK_L_(0x83, 0x4E)
#define REG_SC_BK83_4E_H      _PK_H_(0x83, 0x4E)
#define REG_SC_BK83_4F_L      _PK_L_(0x83, 0x4F)
#define REG_SC_BK83_4F_H      _PK_H_(0x83, 0x4F)
#define REG_SC_BK83_50_L      _PK_L_(0x83, 0x50)
#define REG_SC_BK83_50_H      _PK_H_(0x83, 0x50)
#define REG_SC_BK83_51_L      _PK_L_(0x83, 0x51)
#define REG_SC_BK83_51_H      _PK_H_(0x83, 0x51)
#define REG_SC_BK83_52_L      _PK_L_(0x83, 0x52)
#define REG_SC_BK83_52_H      _PK_H_(0x83, 0x52)
#define REG_SC_BK83_53_L      _PK_L_(0x83, 0x53)
#define REG_SC_BK83_53_H      _PK_H_(0x83, 0x53)
#define REG_SC_BK83_54_L      _PK_L_(0x83, 0x54)
#define REG_SC_BK83_54_H      _PK_H_(0x83, 0x54)
#define REG_SC_BK83_55_L      _PK_L_(0x83, 0x55)
#define REG_SC_BK83_55_H      _PK_H_(0x83, 0x55)
#define REG_SC_BK83_56_L      _PK_L_(0x83, 0x56)
#define REG_SC_BK83_56_H      _PK_H_(0x83, 0x56)
#define REG_SC_BK83_57_L      _PK_L_(0x83, 0x57)
#define REG_SC_BK83_57_H      _PK_H_(0x83, 0x57)
#define REG_SC_BK83_58_L      _PK_L_(0x83, 0x58)
#define REG_SC_BK83_58_H      _PK_H_(0x83, 0x58)
#define REG_SC_BK83_59_L      _PK_L_(0x83, 0x59)
#define REG_SC_BK83_59_H      _PK_H_(0x83, 0x59)
#define REG_SC_BK83_5A_L      _PK_L_(0x83, 0x5A)
#define REG_SC_BK83_5A_H      _PK_H_(0x83, 0x5A)
#define REG_SC_BK83_5B_L      _PK_L_(0x83, 0x5B)
#define REG_SC_BK83_5B_H      _PK_H_(0x83, 0x5B)
#define REG_SC_BK83_5C_L      _PK_L_(0x83, 0x5C)
#define REG_SC_BK83_5C_H      _PK_H_(0x83, 0x5C)
#define REG_SC_BK83_5D_L      _PK_L_(0x83, 0x5D)
#define REG_SC_BK83_5D_H      _PK_H_(0x83, 0x5D)
#define REG_SC_BK83_5E_L      _PK_L_(0x83, 0x5E)
#define REG_SC_BK83_5E_H      _PK_H_(0x83, 0x5E)
#define REG_SC_BK83_5F_L      _PK_L_(0x83, 0x5F)
#define REG_SC_BK83_5F_H      _PK_H_(0x83, 0x5F)
#define REG_SC_BK83_60_L      _PK_L_(0x83, 0x60)
#define REG_SC_BK83_60_H      _PK_H_(0x83, 0x60)
#define REG_SC_BK83_61_L      _PK_L_(0x83, 0x61)
#define REG_SC_BK83_61_H      _PK_H_(0x83, 0x61)
#define REG_SC_BK83_62_L      _PK_L_(0x83, 0x62)
#define REG_SC_BK83_62_H      _PK_H_(0x83, 0x62)
#define REG_SC_BK83_63_L      _PK_L_(0x83, 0x63)
#define REG_SC_BK83_63_H      _PK_H_(0x83, 0x63)
#define REG_SC_BK83_64_L      _PK_L_(0x83, 0x64)
#define REG_SC_BK83_64_H      _PK_H_(0x83, 0x64)
#define REG_SC_BK83_65_L      _PK_L_(0x83, 0x65)
#define REG_SC_BK83_65_H      _PK_H_(0x83, 0x65)
#define REG_SC_BK83_66_L      _PK_L_(0x83, 0x66)
#define REG_SC_BK83_66_H      _PK_H_(0x83, 0x66)
#define REG_SC_BK83_67_L      _PK_L_(0x83, 0x67)
#define REG_SC_BK83_67_H      _PK_H_(0x83, 0x67)
#define REG_SC_BK83_68_L      _PK_L_(0x83, 0x68)
#define REG_SC_BK83_68_H      _PK_H_(0x83, 0x68)
#define REG_SC_BK83_69_L      _PK_L_(0x83, 0x69)
#define REG_SC_BK83_69_H      _PK_H_(0x83, 0x69)
#define REG_SC_BK83_6A_L      _PK_L_(0x83, 0x6A)
#define REG_SC_BK83_6A_H      _PK_H_(0x83, 0x6A)
#define REG_SC_BK83_6B_L      _PK_L_(0x83, 0x6B)
#define REG_SC_BK83_6B_H      _PK_H_(0x83, 0x6B)
#define REG_SC_BK83_6C_L      _PK_L_(0x83, 0x6C)
#define REG_SC_BK83_6C_H      _PK_H_(0x83, 0x6C)
#define REG_SC_BK83_6D_L      _PK_L_(0x83, 0x6D)
#define REG_SC_BK83_6D_H      _PK_H_(0x83, 0x6D)
#define REG_SC_BK83_6E_L      _PK_L_(0x83, 0x6E)
#define REG_SC_BK83_6E_H      _PK_H_(0x83, 0x6E)
#define REG_SC_BK83_6F_L      _PK_L_(0x83, 0x6F)
#define REG_SC_BK83_6F_H      _PK_H_(0x83, 0x6F)
#define REG_SC_BK83_70_L      _PK_L_(0x83, 0x70)
#define REG_SC_BK83_70_H      _PK_H_(0x83, 0x70)
#define REG_SC_BK83_71_L      _PK_L_(0x83, 0x71)
#define REG_SC_BK83_71_H      _PK_H_(0x83, 0x71)
#define REG_SC_BK83_72_L      _PK_L_(0x83, 0x72)
#define REG_SC_BK83_72_H      _PK_H_(0x83, 0x72)
#define REG_SC_BK83_73_L      _PK_L_(0x83, 0x73)
#define REG_SC_BK83_73_H      _PK_H_(0x83, 0x73)
#define REG_SC_BK83_74_L      _PK_L_(0x83, 0x74)
#define REG_SC_BK83_74_H      _PK_H_(0x83, 0x74)
#define REG_SC_BK83_75_L      _PK_L_(0x83, 0x75)
#define REG_SC_BK83_75_H      _PK_H_(0x83, 0x75)
#define REG_SC_BK83_76_L      _PK_L_(0x83, 0x76)
#define REG_SC_BK83_76_H      _PK_H_(0x83, 0x76)
#define REG_SC_BK83_77_L      _PK_L_(0x83, 0x77)
#define REG_SC_BK83_77_H      _PK_H_(0x83, 0x77)
#define REG_SC_BK83_78_L      _PK_L_(0x83, 0x78)
#define REG_SC_BK83_78_H      _PK_H_(0x83, 0x78)
#define REG_SC_BK83_79_L      _PK_L_(0x83, 0x79)
#define REG_SC_BK83_79_H      _PK_H_(0x83, 0x79)
#define REG_SC_BK83_7A_L      _PK_L_(0x83, 0x7A)
#define REG_SC_BK83_7A_H      _PK_H_(0x83, 0x7A)
#define REG_SC_BK83_7B_L      _PK_L_(0x83, 0x7B)
#define REG_SC_BK83_7B_H      _PK_H_(0x83, 0x7B)
#define REG_SC_BK83_7C_L      _PK_L_(0x83, 0x7C)
#define REG_SC_BK83_7C_H      _PK_H_(0x83, 0x7C)
#define REG_SC_BK83_7D_L      _PK_L_(0x83, 0x7D)
#define REG_SC_BK83_7D_H      _PK_H_(0x83, 0x7D)
#define REG_SC_BK83_7E_L      _PK_L_(0x83, 0x7E)
#define REG_SC_BK83_7E_H      _PK_H_(0x83, 0x7E)
#define REG_SC_BK83_7F_L      _PK_L_(0x83, 0x7F)
#define REG_SC_BK83_7F_H      _PK_H_(0x83, 0x7F)
//----------------------------------------------
#define REG_SC_BK84_00_L      _PK_L_(0x84, 0x00)
#define REG_SC_BK84_00_H      _PK_H_(0x84, 0x00)
#define REG_SC_BK84_01_L      _PK_L_(0x84, 0x01)
#define REG_SC_BK84_01_H      _PK_H_(0x84, 0x01)
#define REG_SC_BK84_02_L      _PK_L_(0x84, 0x02)
#define REG_SC_BK84_02_H      _PK_H_(0x84, 0x02)
#define REG_SC_BK84_03_L      _PK_L_(0x84, 0x03)
#define REG_SC_BK84_03_H      _PK_H_(0x84, 0x03)
#define REG_SC_BK84_04_L      _PK_L_(0x84, 0x04)
#define REG_SC_BK84_04_H      _PK_H_(0x84, 0x04)
#define REG_SC_BK84_05_L      _PK_L_(0x84, 0x05)
#define REG_SC_BK84_05_H      _PK_H_(0x84, 0x05)
#define REG_SC_BK84_06_L      _PK_L_(0x84, 0x06)
#define REG_SC_BK84_06_H      _PK_H_(0x84, 0x06)
#define REG_SC_BK84_07_L      _PK_L_(0x84, 0x07)
#define REG_SC_BK84_07_H      _PK_H_(0x84, 0x07)
#define REG_SC_BK84_08_L      _PK_L_(0x84, 0x08)
#define REG_SC_BK84_08_H      _PK_H_(0x84, 0x08)
#define REG_SC_BK84_09_L      _PK_L_(0x84, 0x09)
#define REG_SC_BK84_09_H      _PK_H_(0x84, 0x09)
#define REG_SC_BK84_0A_L      _PK_L_(0x84, 0x0A)
#define REG_SC_BK84_0A_H      _PK_H_(0x84, 0x0A)
#define REG_SC_BK84_0B_L      _PK_L_(0x84, 0x0B)
#define REG_SC_BK84_0B_H      _PK_H_(0x84, 0x0B)
#define REG_SC_BK84_0C_L      _PK_L_(0x84, 0x0C)
#define REG_SC_BK84_0C_H      _PK_H_(0x84, 0x0C)
#define REG_SC_BK84_0D_L      _PK_L_(0x84, 0x0D)
#define REG_SC_BK84_0D_H      _PK_H_(0x84, 0x0D)
#define REG_SC_BK84_0E_L      _PK_L_(0x84, 0x0E)
#define REG_SC_BK84_0E_H      _PK_H_(0x84, 0x0E)
#define REG_SC_BK84_0F_L      _PK_L_(0x84, 0x0F)
#define REG_SC_BK84_0F_H      _PK_H_(0x84, 0x0F)
#define REG_SC_BK84_10_L      _PK_L_(0x84, 0x10)
#define REG_SC_BK84_10_H      _PK_H_(0x84, 0x10)
#define REG_SC_BK84_11_L      _PK_L_(0x84, 0x11)
#define REG_SC_BK84_11_H      _PK_H_(0x84, 0x11)
#define REG_SC_BK84_12_L      _PK_L_(0x84, 0x12)
#define REG_SC_BK84_12_H      _PK_H_(0x84, 0x12)
#define REG_SC_BK84_13_L      _PK_L_(0x84, 0x13)
#define REG_SC_BK84_13_H      _PK_H_(0x84, 0x13)
#define REG_SC_BK84_14_L      _PK_L_(0x84, 0x14)
#define REG_SC_BK84_14_H      _PK_H_(0x84, 0x14)
#define REG_SC_BK84_15_L      _PK_L_(0x84, 0x15)
#define REG_SC_BK84_15_H      _PK_H_(0x84, 0x15)
#define REG_SC_BK84_16_L      _PK_L_(0x84, 0x16)
#define REG_SC_BK84_16_H      _PK_H_(0x84, 0x16)
#define REG_SC_BK84_17_L      _PK_L_(0x84, 0x17)
#define REG_SC_BK84_17_H      _PK_H_(0x84, 0x17)
#define REG_SC_BK84_18_L      _PK_L_(0x84, 0x18)
#define REG_SC_BK84_18_H      _PK_H_(0x84, 0x18)
#define REG_SC_BK84_19_L      _PK_L_(0x84, 0x19)
#define REG_SC_BK84_19_H      _PK_H_(0x84, 0x19)
#define REG_SC_BK84_1A_L      _PK_L_(0x84, 0x1A)
#define REG_SC_BK84_1A_H      _PK_H_(0x84, 0x1A)
#define REG_SC_BK84_1B_L      _PK_L_(0x84, 0x1B)
#define REG_SC_BK84_1B_H      _PK_H_(0x84, 0x1B)
#define REG_SC_BK84_1C_L      _PK_L_(0x84, 0x1C)
#define REG_SC_BK84_1C_H      _PK_H_(0x84, 0x1C)
#define REG_SC_BK84_1D_L      _PK_L_(0x84, 0x1D)
#define REG_SC_BK84_1D_H      _PK_H_(0x84, 0x1D)
#define REG_SC_BK84_1E_L      _PK_L_(0x84, 0x1E)
#define REG_SC_BK84_1E_H      _PK_H_(0x84, 0x1E)
#define REG_SC_BK84_1F_L      _PK_L_(0x84, 0x1F)
#define REG_SC_BK84_1F_H      _PK_H_(0x84, 0x1F)
#define REG_SC_BK84_20_L      _PK_L_(0x84, 0x20)
#define REG_SC_BK84_20_H      _PK_H_(0x84, 0x20)
#define REG_SC_BK84_21_L      _PK_L_(0x84, 0x21)
#define REG_SC_BK84_21_H      _PK_H_(0x84, 0x21)
#define REG_SC_BK84_22_L      _PK_L_(0x84, 0x22)
#define REG_SC_BK84_22_H      _PK_H_(0x84, 0x22)
#define REG_SC_BK84_23_L      _PK_L_(0x84, 0x23)
#define REG_SC_BK84_23_H      _PK_H_(0x84, 0x23)
#define REG_SC_BK84_24_L      _PK_L_(0x84, 0x24)
#define REG_SC_BK84_24_H      _PK_H_(0x84, 0x24)
#define REG_SC_BK84_25_L      _PK_L_(0x84, 0x25)
#define REG_SC_BK84_25_H      _PK_H_(0x84, 0x25)
#define REG_SC_BK84_26_L      _PK_L_(0x84, 0x26)
#define REG_SC_BK84_26_H      _PK_H_(0x84, 0x26)
#define REG_SC_BK84_27_L      _PK_L_(0x84, 0x27)
#define REG_SC_BK84_27_H      _PK_H_(0x84, 0x27)
#define REG_SC_BK84_28_L      _PK_L_(0x84, 0x28)
#define REG_SC_BK84_28_H      _PK_H_(0x84, 0x28)
#define REG_SC_BK84_29_L      _PK_L_(0x84, 0x29)
#define REG_SC_BK84_29_H      _PK_H_(0x84, 0x29)
#define REG_SC_BK84_2A_L      _PK_L_(0x84, 0x2A)
#define REG_SC_BK84_2A_H      _PK_H_(0x84, 0x2A)
#define REG_SC_BK84_2B_L      _PK_L_(0x84, 0x2B)
#define REG_SC_BK84_2B_H      _PK_H_(0x84, 0x2B)
#define REG_SC_BK84_2C_L      _PK_L_(0x84, 0x2C)
#define REG_SC_BK84_2C_H      _PK_H_(0x84, 0x2C)
#define REG_SC_BK84_2D_L      _PK_L_(0x84, 0x2D)
#define REG_SC_BK84_2D_H      _PK_H_(0x84, 0x2D)
#define REG_SC_BK84_2E_L      _PK_L_(0x84, 0x2E)
#define REG_SC_BK84_2E_H      _PK_H_(0x84, 0x2E)
#define REG_SC_BK84_2F_L      _PK_L_(0x84, 0x2F)
#define REG_SC_BK84_2F_H      _PK_H_(0x84, 0x2F)
#define REG_SC_BK84_30_L      _PK_L_(0x84, 0x30)
#define REG_SC_BK84_30_H      _PK_H_(0x84, 0x30)
#define REG_SC_BK84_31_L      _PK_L_(0x84, 0x31)
#define REG_SC_BK84_31_H      _PK_H_(0x84, 0x31)
#define REG_SC_BK84_32_L      _PK_L_(0x84, 0x32)
#define REG_SC_BK84_32_H      _PK_H_(0x84, 0x32)
#define REG_SC_BK84_33_L      _PK_L_(0x84, 0x33)
#define REG_SC_BK84_33_H      _PK_H_(0x84, 0x33)
#define REG_SC_BK84_34_L      _PK_L_(0x84, 0x34)
#define REG_SC_BK84_34_H      _PK_H_(0x84, 0x34)
#define REG_SC_BK84_35_L      _PK_L_(0x84, 0x35)
#define REG_SC_BK84_35_H      _PK_H_(0x84, 0x35)
#define REG_SC_BK84_36_L      _PK_L_(0x84, 0x36)
#define REG_SC_BK84_36_H      _PK_H_(0x84, 0x36)
#define REG_SC_BK84_37_L      _PK_L_(0x84, 0x37)
#define REG_SC_BK84_37_H      _PK_H_(0x84, 0x37)
#define REG_SC_BK84_38_L      _PK_L_(0x84, 0x38)
#define REG_SC_BK84_38_H      _PK_H_(0x84, 0x38)
#define REG_SC_BK84_39_L      _PK_L_(0x84, 0x39)
#define REG_SC_BK84_39_H      _PK_H_(0x84, 0x39)
#define REG_SC_BK84_3A_L      _PK_L_(0x84, 0x3A)
#define REG_SC_BK84_3A_H      _PK_H_(0x84, 0x3A)
#define REG_SC_BK84_3B_L      _PK_L_(0x84, 0x3B)
#define REG_SC_BK84_3B_H      _PK_H_(0x84, 0x3B)
#define REG_SC_BK84_3C_L      _PK_L_(0x84, 0x3C)
#define REG_SC_BK84_3C_H      _PK_H_(0x84, 0x3C)
#define REG_SC_BK84_3D_L      _PK_L_(0x84, 0x3D)
#define REG_SC_BK84_3D_H      _PK_H_(0x84, 0x3D)
#define REG_SC_BK84_3E_L      _PK_L_(0x84, 0x3E)
#define REG_SC_BK84_3E_H      _PK_H_(0x84, 0x3E)
#define REG_SC_BK84_3F_L      _PK_L_(0x84, 0x3F)
#define REG_SC_BK84_3F_H      _PK_H_(0x84, 0x3F)
#define REG_SC_BK84_40_L      _PK_L_(0x84, 0x40)
#define REG_SC_BK84_40_H      _PK_H_(0x84, 0x40)
#define REG_SC_BK84_41_L      _PK_L_(0x84, 0x41)
#define REG_SC_BK84_41_H      _PK_H_(0x84, 0x41)
#define REG_SC_BK84_42_L      _PK_L_(0x84, 0x42)
#define REG_SC_BK84_42_H      _PK_H_(0x84, 0x42)
#define REG_SC_BK84_43_L      _PK_L_(0x84, 0x43)
#define REG_SC_BK84_43_H      _PK_H_(0x84, 0x43)
#define REG_SC_BK84_44_L      _PK_L_(0x84, 0x44)
#define REG_SC_BK84_44_H      _PK_H_(0x84, 0x44)
#define REG_SC_BK84_45_L      _PK_L_(0x84, 0x45)
#define REG_SC_BK84_45_H      _PK_H_(0x84, 0x45)
#define REG_SC_BK84_46_L      _PK_L_(0x84, 0x46)
#define REG_SC_BK84_46_H      _PK_H_(0x84, 0x46)
#define REG_SC_BK84_47_L      _PK_L_(0x84, 0x47)
#define REG_SC_BK84_47_H      _PK_H_(0x84, 0x47)
#define REG_SC_BK84_48_L      _PK_L_(0x84, 0x48)
#define REG_SC_BK84_48_H      _PK_H_(0x84, 0x48)
#define REG_SC_BK84_49_L      _PK_L_(0x84, 0x49)
#define REG_SC_BK84_49_H      _PK_H_(0x84, 0x49)
#define REG_SC_BK84_4A_L      _PK_L_(0x84, 0x4A)
#define REG_SC_BK84_4A_H      _PK_H_(0x84, 0x4A)
#define REG_SC_BK84_4B_L      _PK_L_(0x84, 0x4B)
#define REG_SC_BK84_4B_H      _PK_H_(0x84, 0x4B)
#define REG_SC_BK84_4C_L      _PK_L_(0x84, 0x4C)
#define REG_SC_BK84_4C_H      _PK_H_(0x84, 0x4C)
#define REG_SC_BK84_4D_L      _PK_L_(0x84, 0x4D)
#define REG_SC_BK84_4D_H      _PK_H_(0x84, 0x4D)
#define REG_SC_BK84_4E_L      _PK_L_(0x84, 0x4E)
#define REG_SC_BK84_4E_H      _PK_H_(0x84, 0x4E)
#define REG_SC_BK84_4F_L      _PK_L_(0x84, 0x4F)
#define REG_SC_BK84_4F_H      _PK_H_(0x84, 0x4F)
#define REG_SC_BK84_50_L      _PK_L_(0x84, 0x50)
#define REG_SC_BK84_50_H      _PK_H_(0x84, 0x50)
#define REG_SC_BK84_51_L      _PK_L_(0x84, 0x51)
#define REG_SC_BK84_51_H      _PK_H_(0x84, 0x51)
#define REG_SC_BK84_52_L      _PK_L_(0x84, 0x52)
#define REG_SC_BK84_52_H      _PK_H_(0x84, 0x52)
#define REG_SC_BK84_53_L      _PK_L_(0x84, 0x53)
#define REG_SC_BK84_53_H      _PK_H_(0x84, 0x53)
#define REG_SC_BK84_54_L      _PK_L_(0x84, 0x54)
#define REG_SC_BK84_54_H      _PK_H_(0x84, 0x54)
#define REG_SC_BK84_55_L      _PK_L_(0x84, 0x55)
#define REG_SC_BK84_55_H      _PK_H_(0x84, 0x55)
#define REG_SC_BK84_56_L      _PK_L_(0x84, 0x56)
#define REG_SC_BK84_56_H      _PK_H_(0x84, 0x56)
#define REG_SC_BK84_57_L      _PK_L_(0x84, 0x57)
#define REG_SC_BK84_57_H      _PK_H_(0x84, 0x57)
#define REG_SC_BK84_58_L      _PK_L_(0x84, 0x58)
#define REG_SC_BK84_58_H      _PK_H_(0x84, 0x58)
#define REG_SC_BK84_59_L      _PK_L_(0x84, 0x59)
#define REG_SC_BK84_59_H      _PK_H_(0x84, 0x59)
#define REG_SC_BK84_5A_L      _PK_L_(0x84, 0x5A)
#define REG_SC_BK84_5A_H      _PK_H_(0x84, 0x5A)
#define REG_SC_BK84_5B_L      _PK_L_(0x84, 0x5B)
#define REG_SC_BK84_5B_H      _PK_H_(0x84, 0x5B)
#define REG_SC_BK84_5C_L      _PK_L_(0x84, 0x5C)
#define REG_SC_BK84_5C_H      _PK_H_(0x84, 0x5C)
#define REG_SC_BK84_5D_L      _PK_L_(0x84, 0x5D)
#define REG_SC_BK84_5D_H      _PK_H_(0x84, 0x5D)
#define REG_SC_BK84_5E_L      _PK_L_(0x84, 0x5E)
#define REG_SC_BK84_5E_H      _PK_H_(0x84, 0x5E)
#define REG_SC_BK84_5F_L      _PK_L_(0x84, 0x5F)
#define REG_SC_BK84_5F_H      _PK_H_(0x84, 0x5F)
#define REG_SC_BK84_60_L      _PK_L_(0x84, 0x60)
#define REG_SC_BK84_60_H      _PK_H_(0x84, 0x60)
#define REG_SC_BK84_61_L      _PK_L_(0x84, 0x61)
#define REG_SC_BK84_61_H      _PK_H_(0x84, 0x61)
#define REG_SC_BK84_62_L      _PK_L_(0x84, 0x62)
#define REG_SC_BK84_62_H      _PK_H_(0x84, 0x62)
#define REG_SC_BK84_63_L      _PK_L_(0x84, 0x63)
#define REG_SC_BK84_63_H      _PK_H_(0x84, 0x63)
#define REG_SC_BK84_64_L      _PK_L_(0x84, 0x64)
#define REG_SC_BK84_64_H      _PK_H_(0x84, 0x64)
#define REG_SC_BK84_65_L      _PK_L_(0x84, 0x65)
#define REG_SC_BK84_65_H      _PK_H_(0x84, 0x65)
#define REG_SC_BK84_66_L      _PK_L_(0x84, 0x66)
#define REG_SC_BK84_66_H      _PK_H_(0x84, 0x66)
#define REG_SC_BK84_67_L      _PK_L_(0x84, 0x67)
#define REG_SC_BK84_67_H      _PK_H_(0x84, 0x67)
#define REG_SC_BK84_68_L      _PK_L_(0x84, 0x68)
#define REG_SC_BK84_68_H      _PK_H_(0x84, 0x68)
#define REG_SC_BK84_69_L      _PK_L_(0x84, 0x69)
#define REG_SC_BK84_69_H      _PK_H_(0x84, 0x69)
#define REG_SC_BK84_6A_L      _PK_L_(0x84, 0x6A)
#define REG_SC_BK84_6A_H      _PK_H_(0x84, 0x6A)
#define REG_SC_BK84_6B_L      _PK_L_(0x84, 0x6B)
#define REG_SC_BK84_6B_H      _PK_H_(0x84, 0x6B)
#define REG_SC_BK84_6C_L      _PK_L_(0x84, 0x6C)
#define REG_SC_BK84_6C_H      _PK_H_(0x84, 0x6C)
#define REG_SC_BK84_6D_L      _PK_L_(0x84, 0x6D)
#define REG_SC_BK84_6D_H      _PK_H_(0x84, 0x6D)
#define REG_SC_BK84_6E_L      _PK_L_(0x84, 0x6E)
#define REG_SC_BK84_6E_H      _PK_H_(0x84, 0x6E)
#define REG_SC_BK84_6F_L      _PK_L_(0x84, 0x6F)
#define REG_SC_BK84_6F_H      _PK_H_(0x84, 0x6F)
#define REG_SC_BK84_70_L      _PK_L_(0x84, 0x70)
#define REG_SC_BK84_70_H      _PK_H_(0x84, 0x70)
#define REG_SC_BK84_71_L      _PK_L_(0x84, 0x71)
#define REG_SC_BK84_71_H      _PK_H_(0x84, 0x71)
#define REG_SC_BK84_72_L      _PK_L_(0x84, 0x72)
#define REG_SC_BK84_72_H      _PK_H_(0x84, 0x72)
#define REG_SC_BK84_73_L      _PK_L_(0x84, 0x73)
#define REG_SC_BK84_73_H      _PK_H_(0x84, 0x73)
#define REG_SC_BK84_74_L      _PK_L_(0x84, 0x74)
#define REG_SC_BK84_74_H      _PK_H_(0x84, 0x74)
#define REG_SC_BK84_75_L      _PK_L_(0x84, 0x75)
#define REG_SC_BK84_75_H      _PK_H_(0x84, 0x75)
#define REG_SC_BK84_76_L      _PK_L_(0x84, 0x76)
#define REG_SC_BK84_76_H      _PK_H_(0x84, 0x76)
#define REG_SC_BK84_77_L      _PK_L_(0x84, 0x77)
#define REG_SC_BK84_77_H      _PK_H_(0x84, 0x77)
#define REG_SC_BK84_78_L      _PK_L_(0x84, 0x78)
#define REG_SC_BK84_78_H      _PK_H_(0x84, 0x78)
#define REG_SC_BK84_79_L      _PK_L_(0x84, 0x79)
#define REG_SC_BK84_79_H      _PK_H_(0x84, 0x79)
#define REG_SC_BK84_7A_L      _PK_L_(0x84, 0x7A)
#define REG_SC_BK84_7A_H      _PK_H_(0x84, 0x7A)
#define REG_SC_BK84_7B_L      _PK_L_(0x84, 0x7B)
#define REG_SC_BK84_7B_H      _PK_H_(0x84, 0x7B)
#define REG_SC_BK84_7C_L      _PK_L_(0x84, 0x7C)
#define REG_SC_BK84_7C_H      _PK_H_(0x84, 0x7C)
#define REG_SC_BK84_7D_L      _PK_L_(0x84, 0x7D)
#define REG_SC_BK84_7D_H      _PK_H_(0x84, 0x7D)
#define REG_SC_BK84_7E_L      _PK_L_(0x84, 0x7E)
#define REG_SC_BK84_7E_H      _PK_H_(0x84, 0x7E)
#define REG_SC_BK84_7F_L      _PK_L_(0x84, 0x7F)
#define REG_SC_BK84_7F_H      _PK_H_(0x84, 0x7F)
//----------------------------------------------
#define REG_SC_BK85_00_L      _PK_L_(0x85, 0x00)
#define REG_SC_BK85_00_H      _PK_H_(0x85, 0x00)
#define REG_SC_BK85_01_L      _PK_L_(0x85, 0x01)
#define REG_SC_BK85_01_H      _PK_H_(0x85, 0x01)
#define REG_SC_BK85_02_L      _PK_L_(0x85, 0x02)
#define REG_SC_BK85_02_H      _PK_H_(0x85, 0x02)
#define REG_SC_BK85_03_L      _PK_L_(0x85, 0x03)
#define REG_SC_BK85_03_H      _PK_H_(0x85, 0x03)
#define REG_SC_BK85_04_L      _PK_L_(0x85, 0x04)
#define REG_SC_BK85_04_H      _PK_H_(0x85, 0x04)
#define REG_SC_BK85_05_L      _PK_L_(0x85, 0x05)
#define REG_SC_BK85_05_H      _PK_H_(0x85, 0x05)
#define REG_SC_BK85_06_L      _PK_L_(0x85, 0x06)
#define REG_SC_BK85_06_H      _PK_H_(0x85, 0x06)
#define REG_SC_BK85_07_L      _PK_L_(0x85, 0x07)
#define REG_SC_BK85_07_H      _PK_H_(0x85, 0x07)
#define REG_SC_BK85_08_L      _PK_L_(0x85, 0x08)
#define REG_SC_BK85_08_H      _PK_H_(0x85, 0x08)
#define REG_SC_BK85_09_L      _PK_L_(0x85, 0x09)
#define REG_SC_BK85_09_H      _PK_H_(0x85, 0x09)
#define REG_SC_BK85_0A_L      _PK_L_(0x85, 0x0A)
#define REG_SC_BK85_0A_H      _PK_H_(0x85, 0x0A)
#define REG_SC_BK85_0B_L      _PK_L_(0x85, 0x0B)
#define REG_SC_BK85_0B_H      _PK_H_(0x85, 0x0B)
#define REG_SC_BK85_0C_L      _PK_L_(0x85, 0x0C)
#define REG_SC_BK85_0C_H      _PK_H_(0x85, 0x0C)
#define REG_SC_BK85_0D_L      _PK_L_(0x85, 0x0D)
#define REG_SC_BK85_0D_H      _PK_H_(0x85, 0x0D)
#define REG_SC_BK85_0E_L      _PK_L_(0x85, 0x0E)
#define REG_SC_BK85_0E_H      _PK_H_(0x85, 0x0E)
#define REG_SC_BK85_0F_L      _PK_L_(0x85, 0x0F)
#define REG_SC_BK85_0F_H      _PK_H_(0x85, 0x0F)
#define REG_SC_BK85_10_L      _PK_L_(0x85, 0x10)
#define REG_SC_BK85_10_H      _PK_H_(0x85, 0x10)
#define REG_SC_BK85_11_L      _PK_L_(0x85, 0x11)
#define REG_SC_BK85_11_H      _PK_H_(0x85, 0x11)
#define REG_SC_BK85_12_L      _PK_L_(0x85, 0x12)
#define REG_SC_BK85_12_H      _PK_H_(0x85, 0x12)
#define REG_SC_BK85_13_L      _PK_L_(0x85, 0x13)
#define REG_SC_BK85_13_H      _PK_H_(0x85, 0x13)
#define REG_SC_BK85_14_L      _PK_L_(0x85, 0x14)
#define REG_SC_BK85_14_H      _PK_H_(0x85, 0x14)
#define REG_SC_BK85_15_L      _PK_L_(0x85, 0x15)
#define REG_SC_BK85_15_H      _PK_H_(0x85, 0x15)
#define REG_SC_BK85_16_L      _PK_L_(0x85, 0x16)
#define REG_SC_BK85_16_H      _PK_H_(0x85, 0x16)
#define REG_SC_BK85_17_L      _PK_L_(0x85, 0x17)
#define REG_SC_BK85_17_H      _PK_H_(0x85, 0x17)
#define REG_SC_BK85_18_L      _PK_L_(0x85, 0x18)
#define REG_SC_BK85_18_H      _PK_H_(0x85, 0x18)
#define REG_SC_BK85_19_L      _PK_L_(0x85, 0x19)
#define REG_SC_BK85_19_H      _PK_H_(0x85, 0x19)
#define REG_SC_BK85_1A_L      _PK_L_(0x85, 0x1A)
#define REG_SC_BK85_1A_H      _PK_H_(0x85, 0x1A)
#define REG_SC_BK85_1B_L      _PK_L_(0x85, 0x1B)
#define REG_SC_BK85_1B_H      _PK_H_(0x85, 0x1B)
#define REG_SC_BK85_1C_L      _PK_L_(0x85, 0x1C)
#define REG_SC_BK85_1C_H      _PK_H_(0x85, 0x1C)
#define REG_SC_BK85_1D_L      _PK_L_(0x85, 0x1D)
#define REG_SC_BK85_1D_H      _PK_H_(0x85, 0x1D)
#define REG_SC_BK85_1E_L      _PK_L_(0x85, 0x1E)
#define REG_SC_BK85_1E_H      _PK_H_(0x85, 0x1E)
#define REG_SC_BK85_1F_L      _PK_L_(0x85, 0x1F)
#define REG_SC_BK85_1F_H      _PK_H_(0x85, 0x1F)
#define REG_SC_BK85_20_L      _PK_L_(0x85, 0x20)
#define REG_SC_BK85_20_H      _PK_H_(0x85, 0x20)
#define REG_SC_BK85_21_L      _PK_L_(0x85, 0x21)
#define REG_SC_BK85_21_H      _PK_H_(0x85, 0x21)
#define REG_SC_BK85_22_L      _PK_L_(0x85, 0x22)
#define REG_SC_BK85_22_H      _PK_H_(0x85, 0x22)
#define REG_SC_BK85_23_L      _PK_L_(0x85, 0x23)
#define REG_SC_BK85_23_H      _PK_H_(0x85, 0x23)
#define REG_SC_BK85_24_L      _PK_L_(0x85, 0x24)
#define REG_SC_BK85_24_H      _PK_H_(0x85, 0x24)
#define REG_SC_BK85_25_L      _PK_L_(0x85, 0x25)
#define REG_SC_BK85_25_H      _PK_H_(0x85, 0x25)
#define REG_SC_BK85_26_L      _PK_L_(0x85, 0x26)
#define REG_SC_BK85_26_H      _PK_H_(0x85, 0x26)
#define REG_SC_BK85_27_L      _PK_L_(0x85, 0x27)
#define REG_SC_BK85_27_H      _PK_H_(0x85, 0x27)
#define REG_SC_BK85_28_L      _PK_L_(0x85, 0x28)
#define REG_SC_BK85_28_H      _PK_H_(0x85, 0x28)
#define REG_SC_BK85_29_L      _PK_L_(0x85, 0x29)
#define REG_SC_BK85_29_H      _PK_H_(0x85, 0x29)
#define REG_SC_BK85_2A_L      _PK_L_(0x85, 0x2A)
#define REG_SC_BK85_2A_H      _PK_H_(0x85, 0x2A)
#define REG_SC_BK85_2B_L      _PK_L_(0x85, 0x2B)
#define REG_SC_BK85_2B_H      _PK_H_(0x85, 0x2B)
#define REG_SC_BK85_2C_L      _PK_L_(0x85, 0x2C)
#define REG_SC_BK85_2C_H      _PK_H_(0x85, 0x2C)
#define REG_SC_BK85_2D_L      _PK_L_(0x85, 0x2D)
#define REG_SC_BK85_2D_H      _PK_H_(0x85, 0x2D)
#define REG_SC_BK85_2E_L      _PK_L_(0x85, 0x2E)
#define REG_SC_BK85_2E_H      _PK_H_(0x85, 0x2E)
#define REG_SC_BK85_2F_L      _PK_L_(0x85, 0x2F)
#define REG_SC_BK85_2F_H      _PK_H_(0x85, 0x2F)
#define REG_SC_BK85_30_L      _PK_L_(0x85, 0x30)
#define REG_SC_BK85_30_H      _PK_H_(0x85, 0x30)
#define REG_SC_BK85_31_L      _PK_L_(0x85, 0x31)
#define REG_SC_BK85_31_H      _PK_H_(0x85, 0x31)
#define REG_SC_BK85_32_L      _PK_L_(0x85, 0x32)
#define REG_SC_BK85_32_H      _PK_H_(0x85, 0x32)
#define REG_SC_BK85_33_L      _PK_L_(0x85, 0x33)
#define REG_SC_BK85_33_H      _PK_H_(0x85, 0x33)
#define REG_SC_BK85_34_L      _PK_L_(0x85, 0x34)
#define REG_SC_BK85_34_H      _PK_H_(0x85, 0x34)
#define REG_SC_BK85_35_L      _PK_L_(0x85, 0x35)
#define REG_SC_BK85_35_H      _PK_H_(0x85, 0x35)
#define REG_SC_BK85_36_L      _PK_L_(0x85, 0x36)
#define REG_SC_BK85_36_H      _PK_H_(0x85, 0x36)
#define REG_SC_BK85_37_L      _PK_L_(0x85, 0x37)
#define REG_SC_BK85_37_H      _PK_H_(0x85, 0x37)
#define REG_SC_BK85_38_L      _PK_L_(0x85, 0x38)
#define REG_SC_BK85_38_H      _PK_H_(0x85, 0x38)
#define REG_SC_BK85_39_L      _PK_L_(0x85, 0x39)
#define REG_SC_BK85_39_H      _PK_H_(0x85, 0x39)
#define REG_SC_BK85_3A_L      _PK_L_(0x85, 0x3A)
#define REG_SC_BK85_3A_H      _PK_H_(0x85, 0x3A)
#define REG_SC_BK85_3B_L      _PK_L_(0x85, 0x3B)
#define REG_SC_BK85_3B_H      _PK_H_(0x85, 0x3B)
#define REG_SC_BK85_3C_L      _PK_L_(0x85, 0x3C)
#define REG_SC_BK85_3C_H      _PK_H_(0x85, 0x3C)
#define REG_SC_BK85_3D_L      _PK_L_(0x85, 0x3D)
#define REG_SC_BK85_3D_H      _PK_H_(0x85, 0x3D)
#define REG_SC_BK85_3E_L      _PK_L_(0x85, 0x3E)
#define REG_SC_BK85_3E_H      _PK_H_(0x85, 0x3E)
#define REG_SC_BK85_3F_L      _PK_L_(0x85, 0x3F)
#define REG_SC_BK85_3F_H      _PK_H_(0x85, 0x3F)
#define REG_SC_BK85_40_L      _PK_L_(0x85, 0x40)
#define REG_SC_BK85_40_H      _PK_H_(0x85, 0x40)
#define REG_SC_BK85_41_L      _PK_L_(0x85, 0x41)
#define REG_SC_BK85_41_H      _PK_H_(0x85, 0x41)
#define REG_SC_BK85_42_L      _PK_L_(0x85, 0x42)
#define REG_SC_BK85_42_H      _PK_H_(0x85, 0x42)
#define REG_SC_BK85_43_L      _PK_L_(0x85, 0x43)
#define REG_SC_BK85_43_H      _PK_H_(0x85, 0x43)
#define REG_SC_BK85_44_L      _PK_L_(0x85, 0x44)
#define REG_SC_BK85_44_H      _PK_H_(0x85, 0x44)
#define REG_SC_BK85_45_L      _PK_L_(0x85, 0x45)
#define REG_SC_BK85_45_H      _PK_H_(0x85, 0x45)
#define REG_SC_BK85_46_L      _PK_L_(0x85, 0x46)
#define REG_SC_BK85_46_H      _PK_H_(0x85, 0x46)
#define REG_SC_BK85_47_L      _PK_L_(0x85, 0x47)
#define REG_SC_BK85_47_H      _PK_H_(0x85, 0x47)
#define REG_SC_BK85_48_L      _PK_L_(0x85, 0x48)
#define REG_SC_BK85_48_H      _PK_H_(0x85, 0x48)
#define REG_SC_BK85_49_L      _PK_L_(0x85, 0x49)
#define REG_SC_BK85_49_H      _PK_H_(0x85, 0x49)
#define REG_SC_BK85_4A_L      _PK_L_(0x85, 0x4A)
#define REG_SC_BK85_4A_H      _PK_H_(0x85, 0x4A)
#define REG_SC_BK85_4B_L      _PK_L_(0x85, 0x4B)
#define REG_SC_BK85_4B_H      _PK_H_(0x85, 0x4B)
#define REG_SC_BK85_4C_L      _PK_L_(0x85, 0x4C)
#define REG_SC_BK85_4C_H      _PK_H_(0x85, 0x4C)
#define REG_SC_BK85_4D_L      _PK_L_(0x85, 0x4D)
#define REG_SC_BK85_4D_H      _PK_H_(0x85, 0x4D)
#define REG_SC_BK85_4E_L      _PK_L_(0x85, 0x4E)
#define REG_SC_BK85_4E_H      _PK_H_(0x85, 0x4E)
#define REG_SC_BK85_4F_L      _PK_L_(0x85, 0x4F)
#define REG_SC_BK85_4F_H      _PK_H_(0x85, 0x4F)
#define REG_SC_BK85_50_L      _PK_L_(0x85, 0x50)
#define REG_SC_BK85_50_H      _PK_H_(0x85, 0x50)
#define REG_SC_BK85_51_L      _PK_L_(0x85, 0x51)
#define REG_SC_BK85_51_H      _PK_H_(0x85, 0x51)
#define REG_SC_BK85_52_L      _PK_L_(0x85, 0x52)
#define REG_SC_BK85_52_H      _PK_H_(0x85, 0x52)
#define REG_SC_BK85_53_L      _PK_L_(0x85, 0x53)
#define REG_SC_BK85_53_H      _PK_H_(0x85, 0x53)
#define REG_SC_BK85_54_L      _PK_L_(0x85, 0x54)
#define REG_SC_BK85_54_H      _PK_H_(0x85, 0x54)
#define REG_SC_BK85_55_L      _PK_L_(0x85, 0x55)
#define REG_SC_BK85_55_H      _PK_H_(0x85, 0x55)
#define REG_SC_BK85_56_L      _PK_L_(0x85, 0x56)
#define REG_SC_BK85_56_H      _PK_H_(0x85, 0x56)
#define REG_SC_BK85_57_L      _PK_L_(0x85, 0x57)
#define REG_SC_BK85_57_H      _PK_H_(0x85, 0x57)
#define REG_SC_BK85_58_L      _PK_L_(0x85, 0x58)
#define REG_SC_BK85_58_H      _PK_H_(0x85, 0x58)
#define REG_SC_BK85_59_L      _PK_L_(0x85, 0x59)
#define REG_SC_BK85_59_H      _PK_H_(0x85, 0x59)
#define REG_SC_BK85_5A_L      _PK_L_(0x85, 0x5A)
#define REG_SC_BK85_5A_H      _PK_H_(0x85, 0x5A)
#define REG_SC_BK85_5B_L      _PK_L_(0x85, 0x5B)
#define REG_SC_BK85_5B_H      _PK_H_(0x85, 0x5B)
#define REG_SC_BK85_5C_L      _PK_L_(0x85, 0x5C)
#define REG_SC_BK85_5C_H      _PK_H_(0x85, 0x5C)
#define REG_SC_BK85_5D_L      _PK_L_(0x85, 0x5D)
#define REG_SC_BK85_5D_H      _PK_H_(0x85, 0x5D)
#define REG_SC_BK85_5E_L      _PK_L_(0x85, 0x5E)
#define REG_SC_BK85_5E_H      _PK_H_(0x85, 0x5E)
#define REG_SC_BK85_5F_L      _PK_L_(0x85, 0x5F)
#define REG_SC_BK85_5F_H      _PK_H_(0x85, 0x5F)
#define REG_SC_BK85_60_L      _PK_L_(0x85, 0x60)
#define REG_SC_BK85_60_H      _PK_H_(0x85, 0x60)
#define REG_SC_BK85_61_L      _PK_L_(0x85, 0x61)
#define REG_SC_BK85_61_H      _PK_H_(0x85, 0x61)
#define REG_SC_BK85_62_L      _PK_L_(0x85, 0x62)
#define REG_SC_BK85_62_H      _PK_H_(0x85, 0x62)
#define REG_SC_BK85_63_L      _PK_L_(0x85, 0x63)
#define REG_SC_BK85_63_H      _PK_H_(0x85, 0x63)
#define REG_SC_BK85_64_L      _PK_L_(0x85, 0x64)
#define REG_SC_BK85_64_H      _PK_H_(0x85, 0x64)
#define REG_SC_BK85_65_L      _PK_L_(0x85, 0x65)
#define REG_SC_BK85_65_H      _PK_H_(0x85, 0x65)
#define REG_SC_BK85_66_L      _PK_L_(0x85, 0x66)
#define REG_SC_BK85_66_H      _PK_H_(0x85, 0x66)
#define REG_SC_BK85_67_L      _PK_L_(0x85, 0x67)
#define REG_SC_BK85_67_H      _PK_H_(0x85, 0x67)
#define REG_SC_BK85_68_L      _PK_L_(0x85, 0x68)
#define REG_SC_BK85_68_H      _PK_H_(0x85, 0x68)
#define REG_SC_BK85_69_L      _PK_L_(0x85, 0x69)
#define REG_SC_BK85_69_H      _PK_H_(0x85, 0x69)
#define REG_SC_BK85_6A_L      _PK_L_(0x85, 0x6A)
#define REG_SC_BK85_6A_H      _PK_H_(0x85, 0x6A)
#define REG_SC_BK85_6B_L      _PK_L_(0x85, 0x6B)
#define REG_SC_BK85_6B_H      _PK_H_(0x85, 0x6B)
#define REG_SC_BK85_6C_L      _PK_L_(0x85, 0x6C)
#define REG_SC_BK85_6C_H      _PK_H_(0x85, 0x6C)
#define REG_SC_BK85_6D_L      _PK_L_(0x85, 0x6D)
#define REG_SC_BK85_6D_H      _PK_H_(0x85, 0x6D)
#define REG_SC_BK85_6E_L      _PK_L_(0x85, 0x6E)
#define REG_SC_BK85_6E_H      _PK_H_(0x85, 0x6E)
#define REG_SC_BK85_6F_L      _PK_L_(0x85, 0x6F)
#define REG_SC_BK85_6F_H      _PK_H_(0x85, 0x6F)
#define REG_SC_BK85_70_L      _PK_L_(0x85, 0x70)
#define REG_SC_BK85_70_H      _PK_H_(0x85, 0x70)
#define REG_SC_BK85_71_L      _PK_L_(0x85, 0x71)
#define REG_SC_BK85_71_H      _PK_H_(0x85, 0x71)
#define REG_SC_BK85_72_L      _PK_L_(0x85, 0x72)
#define REG_SC_BK85_72_H      _PK_H_(0x85, 0x72)
#define REG_SC_BK85_73_L      _PK_L_(0x85, 0x73)
#define REG_SC_BK85_73_H      _PK_H_(0x85, 0x73)
#define REG_SC_BK85_74_L      _PK_L_(0x85, 0x74)
#define REG_SC_BK85_74_H      _PK_H_(0x85, 0x74)
#define REG_SC_BK85_75_L      _PK_L_(0x85, 0x75)
#define REG_SC_BK85_75_H      _PK_H_(0x85, 0x75)
#define REG_SC_BK85_76_L      _PK_L_(0x85, 0x76)
#define REG_SC_BK85_76_H      _PK_H_(0x85, 0x76)
#define REG_SC_BK85_77_L      _PK_L_(0x85, 0x77)
#define REG_SC_BK85_77_H      _PK_H_(0x85, 0x77)
#define REG_SC_BK85_78_L      _PK_L_(0x85, 0x78)
#define REG_SC_BK85_78_H      _PK_H_(0x85, 0x78)
#define REG_SC_BK85_79_L      _PK_L_(0x85, 0x79)
#define REG_SC_BK85_79_H      _PK_H_(0x85, 0x79)
#define REG_SC_BK85_7A_L      _PK_L_(0x85, 0x7A)
#define REG_SC_BK85_7A_H      _PK_H_(0x85, 0x7A)
#define REG_SC_BK85_7B_L      _PK_L_(0x85, 0x7B)
#define REG_SC_BK85_7B_H      _PK_H_(0x85, 0x7B)
#define REG_SC_BK85_7C_L      _PK_L_(0x85, 0x7C)
#define REG_SC_BK85_7C_H      _PK_H_(0x85, 0x7C)
#define REG_SC_BK85_7D_L      _PK_L_(0x85, 0x7D)
#define REG_SC_BK85_7D_H      _PK_H_(0x85, 0x7D)
#define REG_SC_BK85_7E_L      _PK_L_(0x85, 0x7E)
#define REG_SC_BK85_7E_H      _PK_H_(0x85, 0x7E)
#define REG_SC_BK85_7F_L      _PK_L_(0x85, 0x7F)
#define REG_SC_BK85_7F_H      _PK_H_(0x85, 0x7F)
//----------------------------------------------
#define REG_SC_BK86_00_L      _PK_L_(0x86, 0x00)
#define REG_SC_BK86_00_H      _PK_H_(0x86, 0x00)
#define REG_SC_BK86_01_L      _PK_L_(0x86, 0x01)
#define REG_SC_BK86_01_H      _PK_H_(0x86, 0x01)
#define REG_SC_BK86_02_L      _PK_L_(0x86, 0x02)
#define REG_SC_BK86_02_H      _PK_H_(0x86, 0x02)
#define REG_SC_BK86_03_L      _PK_L_(0x86, 0x03)
#define REG_SC_BK86_03_H      _PK_H_(0x86, 0x03)
#define REG_SC_BK86_04_L      _PK_L_(0x86, 0x04)
#define REG_SC_BK86_04_H      _PK_H_(0x86, 0x04)
#define REG_SC_BK86_05_L      _PK_L_(0x86, 0x05)
#define REG_SC_BK86_05_H      _PK_H_(0x86, 0x05)
#define REG_SC_BK86_06_L      _PK_L_(0x86, 0x06)
#define REG_SC_BK86_06_H      _PK_H_(0x86, 0x06)
#define REG_SC_BK86_07_L      _PK_L_(0x86, 0x07)
#define REG_SC_BK86_07_H      _PK_H_(0x86, 0x07)
#define REG_SC_BK86_08_L      _PK_L_(0x86, 0x08)
#define REG_SC_BK86_08_H      _PK_H_(0x86, 0x08)
#define REG_SC_BK86_09_L      _PK_L_(0x86, 0x09)
#define REG_SC_BK86_09_H      _PK_H_(0x86, 0x09)
#define REG_SC_BK86_0A_L      _PK_L_(0x86, 0x0A)
#define REG_SC_BK86_0A_H      _PK_H_(0x86, 0x0A)
#define REG_SC_BK86_0B_L      _PK_L_(0x86, 0x0B)
#define REG_SC_BK86_0B_H      _PK_H_(0x86, 0x0B)
#define REG_SC_BK86_0C_L      _PK_L_(0x86, 0x0C)
#define REG_SC_BK86_0C_H      _PK_H_(0x86, 0x0C)
#define REG_SC_BK86_0D_L      _PK_L_(0x86, 0x0D)
#define REG_SC_BK86_0D_H      _PK_H_(0x86, 0x0D)
#define REG_SC_BK86_0E_L      _PK_L_(0x86, 0x0E)
#define REG_SC_BK86_0E_H      _PK_H_(0x86, 0x0E)
#define REG_SC_BK86_0F_L      _PK_L_(0x86, 0x0F)
#define REG_SC_BK86_0F_H      _PK_H_(0x86, 0x0F)
#define REG_SC_BK86_10_L      _PK_L_(0x86, 0x10)
#define REG_SC_BK86_10_H      _PK_H_(0x86, 0x10)
#define REG_SC_BK86_11_L      _PK_L_(0x86, 0x11)
#define REG_SC_BK86_11_H      _PK_H_(0x86, 0x11)
#define REG_SC_BK86_12_L      _PK_L_(0x86, 0x12)
#define REG_SC_BK86_12_H      _PK_H_(0x86, 0x12)
#define REG_SC_BK86_13_L      _PK_L_(0x86, 0x13)
#define REG_SC_BK86_13_H      _PK_H_(0x86, 0x13)
#define REG_SC_BK86_14_L      _PK_L_(0x86, 0x14)
#define REG_SC_BK86_14_H      _PK_H_(0x86, 0x14)
#define REG_SC_BK86_15_L      _PK_L_(0x86, 0x15)
#define REG_SC_BK86_15_H      _PK_H_(0x86, 0x15)
#define REG_SC_BK86_16_L      _PK_L_(0x86, 0x16)
#define REG_SC_BK86_16_H      _PK_H_(0x86, 0x16)
#define REG_SC_BK86_17_L      _PK_L_(0x86, 0x17)
#define REG_SC_BK86_17_H      _PK_H_(0x86, 0x17)
#define REG_SC_BK86_18_L      _PK_L_(0x86, 0x18)
#define REG_SC_BK86_18_H      _PK_H_(0x86, 0x18)
#define REG_SC_BK86_19_L      _PK_L_(0x86, 0x19)
#define REG_SC_BK86_19_H      _PK_H_(0x86, 0x19)
#define REG_SC_BK86_1A_L      _PK_L_(0x86, 0x1A)
#define REG_SC_BK86_1A_H      _PK_H_(0x86, 0x1A)
#define REG_SC_BK86_1B_L      _PK_L_(0x86, 0x1B)
#define REG_SC_BK86_1B_H      _PK_H_(0x86, 0x1B)
#define REG_SC_BK86_1C_L      _PK_L_(0x86, 0x1C)
#define REG_SC_BK86_1C_H      _PK_H_(0x86, 0x1C)
#define REG_SC_BK86_1D_L      _PK_L_(0x86, 0x1D)
#define REG_SC_BK86_1D_H      _PK_H_(0x86, 0x1D)
#define REG_SC_BK86_1E_L      _PK_L_(0x86, 0x1E)
#define REG_SC_BK86_1E_H      _PK_H_(0x86, 0x1E)
#define REG_SC_BK86_1F_L      _PK_L_(0x86, 0x1F)
#define REG_SC_BK86_1F_H      _PK_H_(0x86, 0x1F)
#define REG_SC_BK86_20_L      _PK_L_(0x86, 0x20)
#define REG_SC_BK86_20_H      _PK_H_(0x86, 0x20)
#define REG_SC_BK86_21_L      _PK_L_(0x86, 0x21)
#define REG_SC_BK86_21_H      _PK_H_(0x86, 0x21)
#define REG_SC_BK86_22_L      _PK_L_(0x86, 0x22)
#define REG_SC_BK86_22_H      _PK_H_(0x86, 0x22)
#define REG_SC_BK86_23_L      _PK_L_(0x86, 0x23)
#define REG_SC_BK86_23_H      _PK_H_(0x86, 0x23)
#define REG_SC_BK86_24_L      _PK_L_(0x86, 0x24)
#define REG_SC_BK86_24_H      _PK_H_(0x86, 0x24)
#define REG_SC_BK86_25_L      _PK_L_(0x86, 0x25)
#define REG_SC_BK86_25_H      _PK_H_(0x86, 0x25)
#define REG_SC_BK86_26_L      _PK_L_(0x86, 0x26)
#define REG_SC_BK86_26_H      _PK_H_(0x86, 0x26)
#define REG_SC_BK86_27_L      _PK_L_(0x86, 0x27)
#define REG_SC_BK86_27_H      _PK_H_(0x86, 0x27)
#define REG_SC_BK86_28_L      _PK_L_(0x86, 0x28)
#define REG_SC_BK86_28_H      _PK_H_(0x86, 0x28)
#define REG_SC_BK86_29_L      _PK_L_(0x86, 0x29)
#define REG_SC_BK86_29_H      _PK_H_(0x86, 0x29)
#define REG_SC_BK86_2A_L      _PK_L_(0x86, 0x2A)
#define REG_SC_BK86_2A_H      _PK_H_(0x86, 0x2A)
#define REG_SC_BK86_2B_L      _PK_L_(0x86, 0x2B)
#define REG_SC_BK86_2B_H      _PK_H_(0x86, 0x2B)
#define REG_SC_BK86_2C_L      _PK_L_(0x86, 0x2C)
#define REG_SC_BK86_2C_H      _PK_H_(0x86, 0x2C)
#define REG_SC_BK86_2D_L      _PK_L_(0x86, 0x2D)
#define REG_SC_BK86_2D_H      _PK_H_(0x86, 0x2D)
#define REG_SC_BK86_2E_L      _PK_L_(0x86, 0x2E)
#define REG_SC_BK86_2E_H      _PK_H_(0x86, 0x2E)
#define REG_SC_BK86_2F_L      _PK_L_(0x86, 0x2F)
#define REG_SC_BK86_2F_H      _PK_H_(0x86, 0x2F)
#define REG_SC_BK86_30_L      _PK_L_(0x86, 0x30)
#define REG_SC_BK86_30_H      _PK_H_(0x86, 0x30)
#define REG_SC_BK86_31_L      _PK_L_(0x86, 0x31)
#define REG_SC_BK86_31_H      _PK_H_(0x86, 0x31)
#define REG_SC_BK86_32_L      _PK_L_(0x86, 0x32)
#define REG_SC_BK86_32_H      _PK_H_(0x86, 0x32)
#define REG_SC_BK86_33_L      _PK_L_(0x86, 0x33)
#define REG_SC_BK86_33_H      _PK_H_(0x86, 0x33)
#define REG_SC_BK86_34_L      _PK_L_(0x86, 0x34)
#define REG_SC_BK86_34_H      _PK_H_(0x86, 0x34)
#define REG_SC_BK86_35_L      _PK_L_(0x86, 0x35)
#define REG_SC_BK86_35_H      _PK_H_(0x86, 0x35)
#define REG_SC_BK86_36_L      _PK_L_(0x86, 0x36)
#define REG_SC_BK86_36_H      _PK_H_(0x86, 0x36)
#define REG_SC_BK86_37_L      _PK_L_(0x86, 0x37)
#define REG_SC_BK86_37_H      _PK_H_(0x86, 0x37)
#define REG_SC_BK86_38_L      _PK_L_(0x86, 0x38)
#define REG_SC_BK86_38_H      _PK_H_(0x86, 0x38)
#define REG_SC_BK86_39_L      _PK_L_(0x86, 0x39)
#define REG_SC_BK86_39_H      _PK_H_(0x86, 0x39)
#define REG_SC_BK86_3A_L      _PK_L_(0x86, 0x3A)
#define REG_SC_BK86_3A_H      _PK_H_(0x86, 0x3A)
#define REG_SC_BK86_3B_L      _PK_L_(0x86, 0x3B)
#define REG_SC_BK86_3B_H      _PK_H_(0x86, 0x3B)
#define REG_SC_BK86_3C_L      _PK_L_(0x86, 0x3C)
#define REG_SC_BK86_3C_H      _PK_H_(0x86, 0x3C)
#define REG_SC_BK86_3D_L      _PK_L_(0x86, 0x3D)
#define REG_SC_BK86_3D_H      _PK_H_(0x86, 0x3D)
#define REG_SC_BK86_3E_L      _PK_L_(0x86, 0x3E)
#define REG_SC_BK86_3E_H      _PK_H_(0x86, 0x3E)
#define REG_SC_BK86_3F_L      _PK_L_(0x86, 0x3F)
#define REG_SC_BK86_3F_H      _PK_H_(0x86, 0x3F)
#define REG_SC_BK86_40_L      _PK_L_(0x86, 0x40)
#define REG_SC_BK86_40_H      _PK_H_(0x86, 0x40)
#define REG_SC_BK86_41_L      _PK_L_(0x86, 0x41)
#define REG_SC_BK86_41_H      _PK_H_(0x86, 0x41)
#define REG_SC_BK86_42_L      _PK_L_(0x86, 0x42)
#define REG_SC_BK86_42_H      _PK_H_(0x86, 0x42)
#define REG_SC_BK86_43_L      _PK_L_(0x86, 0x43)
#define REG_SC_BK86_43_H      _PK_H_(0x86, 0x43)
#define REG_SC_BK86_44_L      _PK_L_(0x86, 0x44)
#define REG_SC_BK86_44_H      _PK_H_(0x86, 0x44)
#define REG_SC_BK86_45_L      _PK_L_(0x86, 0x45)
#define REG_SC_BK86_45_H      _PK_H_(0x86, 0x45)
#define REG_SC_BK86_46_L      _PK_L_(0x86, 0x46)
#define REG_SC_BK86_46_H      _PK_H_(0x86, 0x46)
#define REG_SC_BK86_47_L      _PK_L_(0x86, 0x47)
#define REG_SC_BK86_47_H      _PK_H_(0x86, 0x47)
#define REG_SC_BK86_48_L      _PK_L_(0x86, 0x48)
#define REG_SC_BK86_48_H      _PK_H_(0x86, 0x48)
#define REG_SC_BK86_49_L      _PK_L_(0x86, 0x49)
#define REG_SC_BK86_49_H      _PK_H_(0x86, 0x49)
#define REG_SC_BK86_4A_L      _PK_L_(0x86, 0x4A)
#define REG_SC_BK86_4A_H      _PK_H_(0x86, 0x4A)
#define REG_SC_BK86_4B_L      _PK_L_(0x86, 0x4B)
#define REG_SC_BK86_4B_H      _PK_H_(0x86, 0x4B)
#define REG_SC_BK86_4C_L      _PK_L_(0x86, 0x4C)
#define REG_SC_BK86_4C_H      _PK_H_(0x86, 0x4C)
#define REG_SC_BK86_4D_L      _PK_L_(0x86, 0x4D)
#define REG_SC_BK86_4D_H      _PK_H_(0x86, 0x4D)
#define REG_SC_BK86_4E_L      _PK_L_(0x86, 0x4E)
#define REG_SC_BK86_4E_H      _PK_H_(0x86, 0x4E)
#define REG_SC_BK86_4F_L      _PK_L_(0x86, 0x4F)
#define REG_SC_BK86_4F_H      _PK_H_(0x86, 0x4F)
#define REG_SC_BK86_50_L      _PK_L_(0x86, 0x50)
#define REG_SC_BK86_50_H      _PK_H_(0x86, 0x50)
#define REG_SC_BK86_51_L      _PK_L_(0x86, 0x51)
#define REG_SC_BK86_51_H      _PK_H_(0x86, 0x51)
#define REG_SC_BK86_52_L      _PK_L_(0x86, 0x52)
#define REG_SC_BK86_52_H      _PK_H_(0x86, 0x52)
#define REG_SC_BK86_53_L      _PK_L_(0x86, 0x53)
#define REG_SC_BK86_53_H      _PK_H_(0x86, 0x53)
#define REG_SC_BK86_54_L      _PK_L_(0x86, 0x54)
#define REG_SC_BK86_54_H      _PK_H_(0x86, 0x54)
#define REG_SC_BK86_55_L      _PK_L_(0x86, 0x55)
#define REG_SC_BK86_55_H      _PK_H_(0x86, 0x55)
#define REG_SC_BK86_56_L      _PK_L_(0x86, 0x56)
#define REG_SC_BK86_56_H      _PK_H_(0x86, 0x56)
#define REG_SC_BK86_57_L      _PK_L_(0x86, 0x57)
#define REG_SC_BK86_57_H      _PK_H_(0x86, 0x57)
#define REG_SC_BK86_58_L      _PK_L_(0x86, 0x58)
#define REG_SC_BK86_58_H      _PK_H_(0x86, 0x58)
#define REG_SC_BK86_59_L      _PK_L_(0x86, 0x59)
#define REG_SC_BK86_59_H      _PK_H_(0x86, 0x59)
#define REG_SC_BK86_5A_L      _PK_L_(0x86, 0x5A)
#define REG_SC_BK86_5A_H      _PK_H_(0x86, 0x5A)
#define REG_SC_BK86_5B_L      _PK_L_(0x86, 0x5B)
#define REG_SC_BK86_5B_H      _PK_H_(0x86, 0x5B)
#define REG_SC_BK86_5C_L      _PK_L_(0x86, 0x5C)
#define REG_SC_BK86_5C_H      _PK_H_(0x86, 0x5C)
#define REG_SC_BK86_5D_L      _PK_L_(0x86, 0x5D)
#define REG_SC_BK86_5D_H      _PK_H_(0x86, 0x5D)
#define REG_SC_BK86_5E_L      _PK_L_(0x86, 0x5E)
#define REG_SC_BK86_5E_H      _PK_H_(0x86, 0x5E)
#define REG_SC_BK86_5F_L      _PK_L_(0x86, 0x5F)
#define REG_SC_BK86_5F_H      _PK_H_(0x86, 0x5F)
#define REG_SC_BK86_60_L      _PK_L_(0x86, 0x60)
#define REG_SC_BK86_60_H      _PK_H_(0x86, 0x60)
#define REG_SC_BK86_61_L      _PK_L_(0x86, 0x61)
#define REG_SC_BK86_61_H      _PK_H_(0x86, 0x61)
#define REG_SC_BK86_62_L      _PK_L_(0x86, 0x62)
#define REG_SC_BK86_62_H      _PK_H_(0x86, 0x62)
#define REG_SC_BK86_63_L      _PK_L_(0x86, 0x63)
#define REG_SC_BK86_63_H      _PK_H_(0x86, 0x63)
#define REG_SC_BK86_64_L      _PK_L_(0x86, 0x64)
#define REG_SC_BK86_64_H      _PK_H_(0x86, 0x64)
#define REG_SC_BK86_65_L      _PK_L_(0x86, 0x65)
#define REG_SC_BK86_65_H      _PK_H_(0x86, 0x65)
#define REG_SC_BK86_66_L      _PK_L_(0x86, 0x66)
#define REG_SC_BK86_66_H      _PK_H_(0x86, 0x66)
#define REG_SC_BK86_67_L      _PK_L_(0x86, 0x67)
#define REG_SC_BK86_67_H      _PK_H_(0x86, 0x67)
#define REG_SC_BK86_68_L      _PK_L_(0x86, 0x68)
#define REG_SC_BK86_68_H      _PK_H_(0x86, 0x68)
#define REG_SC_BK86_69_L      _PK_L_(0x86, 0x69)
#define REG_SC_BK86_69_H      _PK_H_(0x86, 0x69)
#define REG_SC_BK86_6A_L      _PK_L_(0x86, 0x6A)
#define REG_SC_BK86_6A_H      _PK_H_(0x86, 0x6A)
#define REG_SC_BK86_6B_L      _PK_L_(0x86, 0x6B)
#define REG_SC_BK86_6B_H      _PK_H_(0x86, 0x6B)
#define REG_SC_BK86_6C_L      _PK_L_(0x86, 0x6C)
#define REG_SC_BK86_6C_H      _PK_H_(0x86, 0x6C)
#define REG_SC_BK86_6D_L      _PK_L_(0x86, 0x6D)
#define REG_SC_BK86_6D_H      _PK_H_(0x86, 0x6D)
#define REG_SC_BK86_6E_L      _PK_L_(0x86, 0x6E)
#define REG_SC_BK86_6E_H      _PK_H_(0x86, 0x6E)
#define REG_SC_BK86_6F_L      _PK_L_(0x86, 0x6F)
#define REG_SC_BK86_6F_H      _PK_H_(0x86, 0x6F)
#define REG_SC_BK86_70_L      _PK_L_(0x86, 0x70)
#define REG_SC_BK86_70_H      _PK_H_(0x86, 0x70)
#define REG_SC_BK86_71_L      _PK_L_(0x86, 0x71)
#define REG_SC_BK86_71_H      _PK_H_(0x86, 0x71)
#define REG_SC_BK86_72_L      _PK_L_(0x86, 0x72)
#define REG_SC_BK86_72_H      _PK_H_(0x86, 0x72)
#define REG_SC_BK86_73_L      _PK_L_(0x86, 0x73)
#define REG_SC_BK86_73_H      _PK_H_(0x86, 0x73)
#define REG_SC_BK86_74_L      _PK_L_(0x86, 0x74)
#define REG_SC_BK86_74_H      _PK_H_(0x86, 0x74)
#define REG_SC_BK86_75_L      _PK_L_(0x86, 0x75)
#define REG_SC_BK86_75_H      _PK_H_(0x86, 0x75)
#define REG_SC_BK86_76_L      _PK_L_(0x86, 0x76)
#define REG_SC_BK86_76_H      _PK_H_(0x86, 0x76)
#define REG_SC_BK86_77_L      _PK_L_(0x86, 0x77)
#define REG_SC_BK86_77_H      _PK_H_(0x86, 0x77)
#define REG_SC_BK86_78_L      _PK_L_(0x86, 0x78)
#define REG_SC_BK86_78_H      _PK_H_(0x86, 0x78)
#define REG_SC_BK86_79_L      _PK_L_(0x86, 0x79)
#define REG_SC_BK86_79_H      _PK_H_(0x86, 0x79)
#define REG_SC_BK86_7A_L      _PK_L_(0x86, 0x7A)
#define REG_SC_BK86_7A_H      _PK_H_(0x86, 0x7A)
#define REG_SC_BK86_7B_L      _PK_L_(0x86, 0x7B)
#define REG_SC_BK86_7B_H      _PK_H_(0x86, 0x7B)
#define REG_SC_BK86_7C_L      _PK_L_(0x86, 0x7C)
#define REG_SC_BK86_7C_H      _PK_H_(0x86, 0x7C)
#define REG_SC_BK86_7D_L      _PK_L_(0x86, 0x7D)
#define REG_SC_BK86_7D_H      _PK_H_(0x86, 0x7D)
#define REG_SC_BK86_7E_L      _PK_L_(0x86, 0x7E)
#define REG_SC_BK86_7E_H      _PK_H_(0x86, 0x7E)
#define REG_SC_BK86_7F_L      _PK_L_(0x86, 0x7F)
#define REG_SC_BK86_7F_H      _PK_H_(0x86, 0x7F)
//----------------------------------------------
#define REG_SC_BK87_00_L      _PK_L_(0x87, 0x00)
#define REG_SC_BK87_00_H      _PK_H_(0x87, 0x00)
#define REG_SC_BK87_01_L      _PK_L_(0x87, 0x01)
#define REG_SC_BK87_01_H      _PK_H_(0x87, 0x01)
#define REG_SC_BK87_02_L      _PK_L_(0x87, 0x02)
#define REG_SC_BK87_02_H      _PK_H_(0x87, 0x02)
#define REG_SC_BK87_03_L      _PK_L_(0x87, 0x03)
#define REG_SC_BK87_03_H      _PK_H_(0x87, 0x03)
#define REG_SC_BK87_04_L      _PK_L_(0x87, 0x04)
#define REG_SC_BK87_04_H      _PK_H_(0x87, 0x04)
#define REG_SC_BK87_05_L      _PK_L_(0x87, 0x05)
#define REG_SC_BK87_05_H      _PK_H_(0x87, 0x05)
#define REG_SC_BK87_06_L      _PK_L_(0x87, 0x06)
#define REG_SC_BK87_06_H      _PK_H_(0x87, 0x06)
#define REG_SC_BK87_07_L      _PK_L_(0x87, 0x07)
#define REG_SC_BK87_07_H      _PK_H_(0x87, 0x07)
#define REG_SC_BK87_08_L      _PK_L_(0x87, 0x08)
#define REG_SC_BK87_08_H      _PK_H_(0x87, 0x08)
#define REG_SC_BK87_09_L      _PK_L_(0x87, 0x09)
#define REG_SC_BK87_09_H      _PK_H_(0x87, 0x09)
#define REG_SC_BK87_0A_L      _PK_L_(0x87, 0x0A)
#define REG_SC_BK87_0A_H      _PK_H_(0x87, 0x0A)
#define REG_SC_BK87_0B_L      _PK_L_(0x87, 0x0B)
#define REG_SC_BK87_0B_H      _PK_H_(0x87, 0x0B)
#define REG_SC_BK87_0C_L      _PK_L_(0x87, 0x0C)
#define REG_SC_BK87_0C_H      _PK_H_(0x87, 0x0C)
#define REG_SC_BK87_0D_L      _PK_L_(0x87, 0x0D)
#define REG_SC_BK87_0D_H      _PK_H_(0x87, 0x0D)
#define REG_SC_BK87_0E_L      _PK_L_(0x87, 0x0E)
#define REG_SC_BK87_0E_H      _PK_H_(0x87, 0x0E)
#define REG_SC_BK87_0F_L      _PK_L_(0x87, 0x0F)
#define REG_SC_BK87_0F_H      _PK_H_(0x87, 0x0F)
#define REG_SC_BK87_10_L      _PK_L_(0x87, 0x10)
#define REG_SC_BK87_10_H      _PK_H_(0x87, 0x10)
#define REG_SC_BK87_11_L      _PK_L_(0x87, 0x11)
#define REG_SC_BK87_11_H      _PK_H_(0x87, 0x11)
#define REG_SC_BK87_12_L      _PK_L_(0x87, 0x12)
#define REG_SC_BK87_12_H      _PK_H_(0x87, 0x12)
#define REG_SC_BK87_13_L      _PK_L_(0x87, 0x13)
#define REG_SC_BK87_13_H      _PK_H_(0x87, 0x13)
#define REG_SC_BK87_14_L      _PK_L_(0x87, 0x14)
#define REG_SC_BK87_14_H      _PK_H_(0x87, 0x14)
#define REG_SC_BK87_15_L      _PK_L_(0x87, 0x15)
#define REG_SC_BK87_15_H      _PK_H_(0x87, 0x15)
#define REG_SC_BK87_16_L      _PK_L_(0x87, 0x16)
#define REG_SC_BK87_16_H      _PK_H_(0x87, 0x16)
#define REG_SC_BK87_17_L      _PK_L_(0x87, 0x17)
#define REG_SC_BK87_17_H      _PK_H_(0x87, 0x17)
#define REG_SC_BK87_18_L      _PK_L_(0x87, 0x18)
#define REG_SC_BK87_18_H      _PK_H_(0x87, 0x18)
#define REG_SC_BK87_19_L      _PK_L_(0x87, 0x19)
#define REG_SC_BK87_19_H      _PK_H_(0x87, 0x19)
#define REG_SC_BK87_1A_L      _PK_L_(0x87, 0x1A)
#define REG_SC_BK87_1A_H      _PK_H_(0x87, 0x1A)
#define REG_SC_BK87_1B_L      _PK_L_(0x87, 0x1B)
#define REG_SC_BK87_1B_H      _PK_H_(0x87, 0x1B)
#define REG_SC_BK87_1C_L      _PK_L_(0x87, 0x1C)
#define REG_SC_BK87_1C_H      _PK_H_(0x87, 0x1C)
#define REG_SC_BK87_1D_L      _PK_L_(0x87, 0x1D)
#define REG_SC_BK87_1D_H      _PK_H_(0x87, 0x1D)
#define REG_SC_BK87_1E_L      _PK_L_(0x87, 0x1E)
#define REG_SC_BK87_1E_H      _PK_H_(0x87, 0x1E)
#define REG_SC_BK87_1F_L      _PK_L_(0x87, 0x1F)
#define REG_SC_BK87_1F_H      _PK_H_(0x87, 0x1F)
#define REG_SC_BK87_20_L      _PK_L_(0x87, 0x20)
#define REG_SC_BK87_20_H      _PK_H_(0x87, 0x20)
#define REG_SC_BK87_21_L      _PK_L_(0x87, 0x21)
#define REG_SC_BK87_21_H      _PK_H_(0x87, 0x21)
#define REG_SC_BK87_22_L      _PK_L_(0x87, 0x22)
#define REG_SC_BK87_22_H      _PK_H_(0x87, 0x22)
#define REG_SC_BK87_23_L      _PK_L_(0x87, 0x23)
#define REG_SC_BK87_23_H      _PK_H_(0x87, 0x23)
#define REG_SC_BK87_24_L      _PK_L_(0x87, 0x24)
#define REG_SC_BK87_24_H      _PK_H_(0x87, 0x24)
#define REG_SC_BK87_25_L      _PK_L_(0x87, 0x25)
#define REG_SC_BK87_25_H      _PK_H_(0x87, 0x25)
#define REG_SC_BK87_26_L      _PK_L_(0x87, 0x26)
#define REG_SC_BK87_26_H      _PK_H_(0x87, 0x26)
#define REG_SC_BK87_27_L      _PK_L_(0x87, 0x27)
#define REG_SC_BK87_27_H      _PK_H_(0x87, 0x27)
#define REG_SC_BK87_28_L      _PK_L_(0x87, 0x28)
#define REG_SC_BK87_28_H      _PK_H_(0x87, 0x28)
#define REG_SC_BK87_29_L      _PK_L_(0x87, 0x29)
#define REG_SC_BK87_29_H      _PK_H_(0x87, 0x29)
#define REG_SC_BK87_2A_L      _PK_L_(0x87, 0x2A)
#define REG_SC_BK87_2A_H      _PK_H_(0x87, 0x2A)
#define REG_SC_BK87_2B_L      _PK_L_(0x87, 0x2B)
#define REG_SC_BK87_2B_H      _PK_H_(0x87, 0x2B)
#define REG_SC_BK87_2C_L      _PK_L_(0x87, 0x2C)
#define REG_SC_BK87_2C_H      _PK_H_(0x87, 0x2C)
#define REG_SC_BK87_2D_L      _PK_L_(0x87, 0x2D)
#define REG_SC_BK87_2D_H      _PK_H_(0x87, 0x2D)
#define REG_SC_BK87_2E_L      _PK_L_(0x87, 0x2E)
#define REG_SC_BK87_2E_H      _PK_H_(0x87, 0x2E)
#define REG_SC_BK87_2F_L      _PK_L_(0x87, 0x2F)
#define REG_SC_BK87_2F_H      _PK_H_(0x87, 0x2F)
#define REG_SC_BK87_30_L      _PK_L_(0x87, 0x30)
#define REG_SC_BK87_30_H      _PK_H_(0x87, 0x30)
#define REG_SC_BK87_31_L      _PK_L_(0x87, 0x31)
#define REG_SC_BK87_31_H      _PK_H_(0x87, 0x31)
#define REG_SC_BK87_32_L      _PK_L_(0x87, 0x32)
#define REG_SC_BK87_32_H      _PK_H_(0x87, 0x32)
#define REG_SC_BK87_33_L      _PK_L_(0x87, 0x33)
#define REG_SC_BK87_33_H      _PK_H_(0x87, 0x33)
#define REG_SC_BK87_34_L      _PK_L_(0x87, 0x34)
#define REG_SC_BK87_34_H      _PK_H_(0x87, 0x34)
#define REG_SC_BK87_35_L      _PK_L_(0x87, 0x35)
#define REG_SC_BK87_35_H      _PK_H_(0x87, 0x35)
#define REG_SC_BK87_36_L      _PK_L_(0x87, 0x36)
#define REG_SC_BK87_36_H      _PK_H_(0x87, 0x36)
#define REG_SC_BK87_37_L      _PK_L_(0x87, 0x37)
#define REG_SC_BK87_37_H      _PK_H_(0x87, 0x37)
#define REG_SC_BK87_38_L      _PK_L_(0x87, 0x38)
#define REG_SC_BK87_38_H      _PK_H_(0x87, 0x38)
#define REG_SC_BK87_39_L      _PK_L_(0x87, 0x39)
#define REG_SC_BK87_39_H      _PK_H_(0x87, 0x39)
#define REG_SC_BK87_3A_L      _PK_L_(0x87, 0x3A)
#define REG_SC_BK87_3A_H      _PK_H_(0x87, 0x3A)
#define REG_SC_BK87_3B_L      _PK_L_(0x87, 0x3B)
#define REG_SC_BK87_3B_H      _PK_H_(0x87, 0x3B)
#define REG_SC_BK87_3C_L      _PK_L_(0x87, 0x3C)
#define REG_SC_BK87_3C_H      _PK_H_(0x87, 0x3C)
#define REG_SC_BK87_3D_L      _PK_L_(0x87, 0x3D)
#define REG_SC_BK87_3D_H      _PK_H_(0x87, 0x3D)
#define REG_SC_BK87_3E_L      _PK_L_(0x87, 0x3E)
#define REG_SC_BK87_3E_H      _PK_H_(0x87, 0x3E)
#define REG_SC_BK87_3F_L      _PK_L_(0x87, 0x3F)
#define REG_SC_BK87_3F_H      _PK_H_(0x87, 0x3F)
#define REG_SC_BK87_40_L      _PK_L_(0x87, 0x40)
#define REG_SC_BK87_40_H      _PK_H_(0x87, 0x40)
#define REG_SC_BK87_41_L      _PK_L_(0x87, 0x41)
#define REG_SC_BK87_41_H      _PK_H_(0x87, 0x41)
#define REG_SC_BK87_42_L      _PK_L_(0x87, 0x42)
#define REG_SC_BK87_42_H      _PK_H_(0x87, 0x42)
#define REG_SC_BK87_43_L      _PK_L_(0x87, 0x43)
#define REG_SC_BK87_43_H      _PK_H_(0x87, 0x43)
#define REG_SC_BK87_44_L      _PK_L_(0x87, 0x44)
#define REG_SC_BK87_44_H      _PK_H_(0x87, 0x44)
#define REG_SC_BK87_45_L      _PK_L_(0x87, 0x45)
#define REG_SC_BK87_45_H      _PK_H_(0x87, 0x45)
#define REG_SC_BK87_46_L      _PK_L_(0x87, 0x46)
#define REG_SC_BK87_46_H      _PK_H_(0x87, 0x46)
#define REG_SC_BK87_47_L      _PK_L_(0x87, 0x47)
#define REG_SC_BK87_47_H      _PK_H_(0x87, 0x47)
#define REG_SC_BK87_48_L      _PK_L_(0x87, 0x48)
#define REG_SC_BK87_48_H      _PK_H_(0x87, 0x48)
#define REG_SC_BK87_49_L      _PK_L_(0x87, 0x49)
#define REG_SC_BK87_49_H      _PK_H_(0x87, 0x49)
#define REG_SC_BK87_4A_L      _PK_L_(0x87, 0x4A)
#define REG_SC_BK87_4A_H      _PK_H_(0x87, 0x4A)
#define REG_SC_BK87_4B_L      _PK_L_(0x87, 0x4B)
#define REG_SC_BK87_4B_H      _PK_H_(0x87, 0x4B)
#define REG_SC_BK87_4C_L      _PK_L_(0x87, 0x4C)
#define REG_SC_BK87_4C_H      _PK_H_(0x87, 0x4C)
#define REG_SC_BK87_4D_L      _PK_L_(0x87, 0x4D)
#define REG_SC_BK87_4D_H      _PK_H_(0x87, 0x4D)
#define REG_SC_BK87_4E_L      _PK_L_(0x87, 0x4E)
#define REG_SC_BK87_4E_H      _PK_H_(0x87, 0x4E)
#define REG_SC_BK87_4F_L      _PK_L_(0x87, 0x4F)
#define REG_SC_BK87_4F_H      _PK_H_(0x87, 0x4F)
#define REG_SC_BK87_50_L      _PK_L_(0x87, 0x50)
#define REG_SC_BK87_50_H      _PK_H_(0x87, 0x50)
#define REG_SC_BK87_51_L      _PK_L_(0x87, 0x51)
#define REG_SC_BK87_51_H      _PK_H_(0x87, 0x51)
#define REG_SC_BK87_52_L      _PK_L_(0x87, 0x52)
#define REG_SC_BK87_52_H      _PK_H_(0x87, 0x52)
#define REG_SC_BK87_53_L      _PK_L_(0x87, 0x53)
#define REG_SC_BK87_53_H      _PK_H_(0x87, 0x53)
#define REG_SC_BK87_54_L      _PK_L_(0x87, 0x54)
#define REG_SC_BK87_54_H      _PK_H_(0x87, 0x54)
#define REG_SC_BK87_55_L      _PK_L_(0x87, 0x55)
#define REG_SC_BK87_55_H      _PK_H_(0x87, 0x55)
#define REG_SC_BK87_56_L      _PK_L_(0x87, 0x56)
#define REG_SC_BK87_56_H      _PK_H_(0x87, 0x56)
#define REG_SC_BK87_57_L      _PK_L_(0x87, 0x57)
#define REG_SC_BK87_57_H      _PK_H_(0x87, 0x57)
#define REG_SC_BK87_58_L      _PK_L_(0x87, 0x58)
#define REG_SC_BK87_58_H      _PK_H_(0x87, 0x58)
#define REG_SC_BK87_59_L      _PK_L_(0x87, 0x59)
#define REG_SC_BK87_59_H      _PK_H_(0x87, 0x59)
#define REG_SC_BK87_5A_L      _PK_L_(0x87, 0x5A)
#define REG_SC_BK87_5A_H      _PK_H_(0x87, 0x5A)
#define REG_SC_BK87_5B_L      _PK_L_(0x87, 0x5B)
#define REG_SC_BK87_5B_H      _PK_H_(0x87, 0x5B)
#define REG_SC_BK87_5C_L      _PK_L_(0x87, 0x5C)
#define REG_SC_BK87_5C_H      _PK_H_(0x87, 0x5C)
#define REG_SC_BK87_5D_L      _PK_L_(0x87, 0x5D)
#define REG_SC_BK87_5D_H      _PK_H_(0x87, 0x5D)
#define REG_SC_BK87_5E_L      _PK_L_(0x87, 0x5E)
#define REG_SC_BK87_5E_H      _PK_H_(0x87, 0x5E)
#define REG_SC_BK87_5F_L      _PK_L_(0x87, 0x5F)
#define REG_SC_BK87_5F_H      _PK_H_(0x87, 0x5F)
#define REG_SC_BK87_60_L      _PK_L_(0x87, 0x60)
#define REG_SC_BK87_60_H      _PK_H_(0x87, 0x60)
#define REG_SC_BK87_61_L      _PK_L_(0x87, 0x61)
#define REG_SC_BK87_61_H      _PK_H_(0x87, 0x61)
#define REG_SC_BK87_62_L      _PK_L_(0x87, 0x62)
#define REG_SC_BK87_62_H      _PK_H_(0x87, 0x62)
#define REG_SC_BK87_63_L      _PK_L_(0x87, 0x63)
#define REG_SC_BK87_63_H      _PK_H_(0x87, 0x63)
#define REG_SC_BK87_64_L      _PK_L_(0x87, 0x64)
#define REG_SC_BK87_64_H      _PK_H_(0x87, 0x64)
#define REG_SC_BK87_65_L      _PK_L_(0x87, 0x65)
#define REG_SC_BK87_65_H      _PK_H_(0x87, 0x65)
#define REG_SC_BK87_66_L      _PK_L_(0x87, 0x66)
#define REG_SC_BK87_66_H      _PK_H_(0x87, 0x66)
#define REG_SC_BK87_67_L      _PK_L_(0x87, 0x67)
#define REG_SC_BK87_67_H      _PK_H_(0x87, 0x67)
#define REG_SC_BK87_68_L      _PK_L_(0x87, 0x68)
#define REG_SC_BK87_68_H      _PK_H_(0x87, 0x68)
#define REG_SC_BK87_69_L      _PK_L_(0x87, 0x69)
#define REG_SC_BK87_69_H      _PK_H_(0x87, 0x69)
#define REG_SC_BK87_6A_L      _PK_L_(0x87, 0x6A)
#define REG_SC_BK87_6A_H      _PK_H_(0x87, 0x6A)
#define REG_SC_BK87_6B_L      _PK_L_(0x87, 0x6B)
#define REG_SC_BK87_6B_H      _PK_H_(0x87, 0x6B)
#define REG_SC_BK87_6C_L      _PK_L_(0x87, 0x6C)
#define REG_SC_BK87_6C_H      _PK_H_(0x87, 0x6C)
#define REG_SC_BK87_6D_L      _PK_L_(0x87, 0x6D)
#define REG_SC_BK87_6D_H      _PK_H_(0x87, 0x6D)
#define REG_SC_BK87_6E_L      _PK_L_(0x87, 0x6E)
#define REG_SC_BK87_6E_H      _PK_H_(0x87, 0x6E)
#define REG_SC_BK87_6F_L      _PK_L_(0x87, 0x6F)
#define REG_SC_BK87_6F_H      _PK_H_(0x87, 0x6F)
#define REG_SC_BK87_70_L      _PK_L_(0x87, 0x70)
#define REG_SC_BK87_70_H      _PK_H_(0x87, 0x70)
#define REG_SC_BK87_71_L      _PK_L_(0x87, 0x71)
#define REG_SC_BK87_71_H      _PK_H_(0x87, 0x71)
#define REG_SC_BK87_72_L      _PK_L_(0x87, 0x72)
#define REG_SC_BK87_72_H      _PK_H_(0x87, 0x72)
#define REG_SC_BK87_73_L      _PK_L_(0x87, 0x73)
#define REG_SC_BK87_73_H      _PK_H_(0x87, 0x73)
#define REG_SC_BK87_74_L      _PK_L_(0x87, 0x74)
#define REG_SC_BK87_74_H      _PK_H_(0x87, 0x74)
#define REG_SC_BK87_75_L      _PK_L_(0x87, 0x75)
#define REG_SC_BK87_75_H      _PK_H_(0x87, 0x75)
#define REG_SC_BK87_76_L      _PK_L_(0x87, 0x76)
#define REG_SC_BK87_76_H      _PK_H_(0x87, 0x76)
#define REG_SC_BK87_77_L      _PK_L_(0x87, 0x77)
#define REG_SC_BK87_77_H      _PK_H_(0x87, 0x77)
#define REG_SC_BK87_78_L      _PK_L_(0x87, 0x78)
#define REG_SC_BK87_78_H      _PK_H_(0x87, 0x78)
#define REG_SC_BK87_79_L      _PK_L_(0x87, 0x79)
#define REG_SC_BK87_79_H      _PK_H_(0x87, 0x79)
#define REG_SC_BK87_7A_L      _PK_L_(0x87, 0x7A)
#define REG_SC_BK87_7A_H      _PK_H_(0x87, 0x7A)
#define REG_SC_BK87_7B_L      _PK_L_(0x87, 0x7B)
#define REG_SC_BK87_7B_H      _PK_H_(0x87, 0x7B)
#define REG_SC_BK87_7C_L      _PK_L_(0x87, 0x7C)
#define REG_SC_BK87_7C_H      _PK_H_(0x87, 0x7C)
#define REG_SC_BK87_7D_L      _PK_L_(0x87, 0x7D)
#define REG_SC_BK87_7D_H      _PK_H_(0x87, 0x7D)
#define REG_SC_BK87_7E_L      _PK_L_(0x87, 0x7E)
#define REG_SC_BK87_7E_H      _PK_H_(0x87, 0x7E)
#define REG_SC_BK87_7F_L      _PK_L_(0x87, 0x7F)
#define REG_SC_BK87_7F_H      _PK_H_(0x87, 0x7F)
//----------------------------------------------
#define REG_SC_BK88_00_L      _PK_L_(0x88, 0x00)
#define REG_SC_BK88_00_H      _PK_H_(0x88, 0x00)
#define REG_SC_BK88_01_L      _PK_L_(0x88, 0x01)
#define REG_SC_BK88_01_H      _PK_H_(0x88, 0x01)
#define REG_SC_BK88_02_L      _PK_L_(0x88, 0x02)
#define REG_SC_BK88_02_H      _PK_H_(0x88, 0x02)
#define REG_SC_BK88_03_L      _PK_L_(0x88, 0x03)
#define REG_SC_BK88_03_H      _PK_H_(0x88, 0x03)
#define REG_SC_BK88_04_L      _PK_L_(0x88, 0x04)
#define REG_SC_BK88_04_H      _PK_H_(0x88, 0x04)
#define REG_SC_BK88_05_L      _PK_L_(0x88, 0x05)
#define REG_SC_BK88_05_H      _PK_H_(0x88, 0x05)
#define REG_SC_BK88_06_L      _PK_L_(0x88, 0x06)
#define REG_SC_BK88_06_H      _PK_H_(0x88, 0x06)
#define REG_SC_BK88_07_L      _PK_L_(0x88, 0x07)
#define REG_SC_BK88_07_H      _PK_H_(0x88, 0x07)
#define REG_SC_BK88_08_L      _PK_L_(0x88, 0x08)
#define REG_SC_BK88_08_H      _PK_H_(0x88, 0x08)
#define REG_SC_BK88_09_L      _PK_L_(0x88, 0x09)
#define REG_SC_BK88_09_H      _PK_H_(0x88, 0x09)
#define REG_SC_BK88_0A_L      _PK_L_(0x88, 0x0A)
#define REG_SC_BK88_0A_H      _PK_H_(0x88, 0x0A)
#define REG_SC_BK88_0B_L      _PK_L_(0x88, 0x0B)
#define REG_SC_BK88_0B_H      _PK_H_(0x88, 0x0B)
#define REG_SC_BK88_0C_L      _PK_L_(0x88, 0x0C)
#define REG_SC_BK88_0C_H      _PK_H_(0x88, 0x0C)
#define REG_SC_BK88_0D_L      _PK_L_(0x88, 0x0D)
#define REG_SC_BK88_0D_H      _PK_H_(0x88, 0x0D)
#define REG_SC_BK88_0E_L      _PK_L_(0x88, 0x0E)
#define REG_SC_BK88_0E_H      _PK_H_(0x88, 0x0E)
#define REG_SC_BK88_0F_L      _PK_L_(0x88, 0x0F)
#define REG_SC_BK88_0F_H      _PK_H_(0x88, 0x0F)
#define REG_SC_BK88_10_L      _PK_L_(0x88, 0x10)
#define REG_SC_BK88_10_H      _PK_H_(0x88, 0x10)
#define REG_SC_BK88_11_L      _PK_L_(0x88, 0x11)
#define REG_SC_BK88_11_H      _PK_H_(0x88, 0x11)
#define REG_SC_BK88_12_L      _PK_L_(0x88, 0x12)
#define REG_SC_BK88_12_H      _PK_H_(0x88, 0x12)
#define REG_SC_BK88_13_L      _PK_L_(0x88, 0x13)
#define REG_SC_BK88_13_H      _PK_H_(0x88, 0x13)
#define REG_SC_BK88_14_L      _PK_L_(0x88, 0x14)
#define REG_SC_BK88_14_H      _PK_H_(0x88, 0x14)
#define REG_SC_BK88_15_L      _PK_L_(0x88, 0x15)
#define REG_SC_BK88_15_H      _PK_H_(0x88, 0x15)
#define REG_SC_BK88_16_L      _PK_L_(0x88, 0x16)
#define REG_SC_BK88_16_H      _PK_H_(0x88, 0x16)
#define REG_SC_BK88_17_L      _PK_L_(0x88, 0x17)
#define REG_SC_BK88_17_H      _PK_H_(0x88, 0x17)
#define REG_SC_BK88_18_L      _PK_L_(0x88, 0x18)
#define REG_SC_BK88_18_H      _PK_H_(0x88, 0x18)
#define REG_SC_BK88_19_L      _PK_L_(0x88, 0x19)
#define REG_SC_BK88_19_H      _PK_H_(0x88, 0x19)
#define REG_SC_BK88_1A_L      _PK_L_(0x88, 0x1A)
#define REG_SC_BK88_1A_H      _PK_H_(0x88, 0x1A)
#define REG_SC_BK88_1B_L      _PK_L_(0x88, 0x1B)
#define REG_SC_BK88_1B_H      _PK_H_(0x88, 0x1B)
#define REG_SC_BK88_1C_L      _PK_L_(0x88, 0x1C)
#define REG_SC_BK88_1C_H      _PK_H_(0x88, 0x1C)
#define REG_SC_BK88_1D_L      _PK_L_(0x88, 0x1D)
#define REG_SC_BK88_1D_H      _PK_H_(0x88, 0x1D)
#define REG_SC_BK88_1E_L      _PK_L_(0x88, 0x1E)
#define REG_SC_BK88_1E_H      _PK_H_(0x88, 0x1E)
#define REG_SC_BK88_1F_L      _PK_L_(0x88, 0x1F)
#define REG_SC_BK88_1F_H      _PK_H_(0x88, 0x1F)
#define REG_SC_BK88_20_L      _PK_L_(0x88, 0x20)
#define REG_SC_BK88_20_H      _PK_H_(0x88, 0x20)
#define REG_SC_BK88_21_L      _PK_L_(0x88, 0x21)
#define REG_SC_BK88_21_H      _PK_H_(0x88, 0x21)
#define REG_SC_BK88_22_L      _PK_L_(0x88, 0x22)
#define REG_SC_BK88_22_H      _PK_H_(0x88, 0x22)
#define REG_SC_BK88_23_L      _PK_L_(0x88, 0x23)
#define REG_SC_BK88_23_H      _PK_H_(0x88, 0x23)
#define REG_SC_BK88_24_L      _PK_L_(0x88, 0x24)
#define REG_SC_BK88_24_H      _PK_H_(0x88, 0x24)
#define REG_SC_BK88_25_L      _PK_L_(0x88, 0x25)
#define REG_SC_BK88_25_H      _PK_H_(0x88, 0x25)
#define REG_SC_BK88_26_L      _PK_L_(0x88, 0x26)
#define REG_SC_BK88_26_H      _PK_H_(0x88, 0x26)
#define REG_SC_BK88_27_L      _PK_L_(0x88, 0x27)
#define REG_SC_BK88_27_H      _PK_H_(0x88, 0x27)
#define REG_SC_BK88_28_L      _PK_L_(0x88, 0x28)
#define REG_SC_BK88_28_H      _PK_H_(0x88, 0x28)
#define REG_SC_BK88_29_L      _PK_L_(0x88, 0x29)
#define REG_SC_BK88_29_H      _PK_H_(0x88, 0x29)
#define REG_SC_BK88_2A_L      _PK_L_(0x88, 0x2A)
#define REG_SC_BK88_2A_H      _PK_H_(0x88, 0x2A)
#define REG_SC_BK88_2B_L      _PK_L_(0x88, 0x2B)
#define REG_SC_BK88_2B_H      _PK_H_(0x88, 0x2B)
#define REG_SC_BK88_2C_L      _PK_L_(0x88, 0x2C)
#define REG_SC_BK88_2C_H      _PK_H_(0x88, 0x2C)
#define REG_SC_BK88_2D_L      _PK_L_(0x88, 0x2D)
#define REG_SC_BK88_2D_H      _PK_H_(0x88, 0x2D)
#define REG_SC_BK88_2E_L      _PK_L_(0x88, 0x2E)
#define REG_SC_BK88_2E_H      _PK_H_(0x88, 0x2E)
#define REG_SC_BK88_2F_L      _PK_L_(0x88, 0x2F)
#define REG_SC_BK88_2F_H      _PK_H_(0x88, 0x2F)
#define REG_SC_BK88_30_L      _PK_L_(0x88, 0x30)
#define REG_SC_BK88_30_H      _PK_H_(0x88, 0x30)
#define REG_SC_BK88_31_L      _PK_L_(0x88, 0x31)
#define REG_SC_BK88_31_H      _PK_H_(0x88, 0x31)
#define REG_SC_BK88_32_L      _PK_L_(0x88, 0x32)
#define REG_SC_BK88_32_H      _PK_H_(0x88, 0x32)
#define REG_SC_BK88_33_L      _PK_L_(0x88, 0x33)
#define REG_SC_BK88_33_H      _PK_H_(0x88, 0x33)
#define REG_SC_BK88_34_L      _PK_L_(0x88, 0x34)
#define REG_SC_BK88_34_H      _PK_H_(0x88, 0x34)
#define REG_SC_BK88_35_L      _PK_L_(0x88, 0x35)
#define REG_SC_BK88_35_H      _PK_H_(0x88, 0x35)
#define REG_SC_BK88_36_L      _PK_L_(0x88, 0x36)
#define REG_SC_BK88_36_H      _PK_H_(0x88, 0x36)
#define REG_SC_BK88_37_L      _PK_L_(0x88, 0x37)
#define REG_SC_BK88_37_H      _PK_H_(0x88, 0x37)
#define REG_SC_BK88_38_L      _PK_L_(0x88, 0x38)
#define REG_SC_BK88_38_H      _PK_H_(0x88, 0x38)
#define REG_SC_BK88_39_L      _PK_L_(0x88, 0x39)
#define REG_SC_BK88_39_H      _PK_H_(0x88, 0x39)
#define REG_SC_BK88_3A_L      _PK_L_(0x88, 0x3A)
#define REG_SC_BK88_3A_H      _PK_H_(0x88, 0x3A)
#define REG_SC_BK88_3B_L      _PK_L_(0x88, 0x3B)
#define REG_SC_BK88_3B_H      _PK_H_(0x88, 0x3B)
#define REG_SC_BK88_3C_L      _PK_L_(0x88, 0x3C)
#define REG_SC_BK88_3C_H      _PK_H_(0x88, 0x3C)
#define REG_SC_BK88_3D_L      _PK_L_(0x88, 0x3D)
#define REG_SC_BK88_3D_H      _PK_H_(0x88, 0x3D)
#define REG_SC_BK88_3E_L      _PK_L_(0x88, 0x3E)
#define REG_SC_BK88_3E_H      _PK_H_(0x88, 0x3E)
#define REG_SC_BK88_3F_L      _PK_L_(0x88, 0x3F)
#define REG_SC_BK88_3F_H      _PK_H_(0x88, 0x3F)
#define REG_SC_BK88_40_L      _PK_L_(0x88, 0x40)
#define REG_SC_BK88_40_H      _PK_H_(0x88, 0x40)
#define REG_SC_BK88_41_L      _PK_L_(0x88, 0x41)
#define REG_SC_BK88_41_H      _PK_H_(0x88, 0x41)
#define REG_SC_BK88_42_L      _PK_L_(0x88, 0x42)
#define REG_SC_BK88_42_H      _PK_H_(0x88, 0x42)
#define REG_SC_BK88_43_L      _PK_L_(0x88, 0x43)
#define REG_SC_BK88_43_H      _PK_H_(0x88, 0x43)
#define REG_SC_BK88_44_L      _PK_L_(0x88, 0x44)
#define REG_SC_BK88_44_H      _PK_H_(0x88, 0x44)
#define REG_SC_BK88_45_L      _PK_L_(0x88, 0x45)
#define REG_SC_BK88_45_H      _PK_H_(0x88, 0x45)
#define REG_SC_BK88_46_L      _PK_L_(0x88, 0x46)
#define REG_SC_BK88_46_H      _PK_H_(0x88, 0x46)
#define REG_SC_BK88_47_L      _PK_L_(0x88, 0x47)
#define REG_SC_BK88_47_H      _PK_H_(0x88, 0x47)
#define REG_SC_BK88_48_L      _PK_L_(0x88, 0x48)
#define REG_SC_BK88_48_H      _PK_H_(0x88, 0x48)
#define REG_SC_BK88_49_L      _PK_L_(0x88, 0x49)
#define REG_SC_BK88_49_H      _PK_H_(0x88, 0x49)
#define REG_SC_BK88_4A_L      _PK_L_(0x88, 0x4A)
#define REG_SC_BK88_4A_H      _PK_H_(0x88, 0x4A)
#define REG_SC_BK88_4B_L      _PK_L_(0x88, 0x4B)
#define REG_SC_BK88_4B_H      _PK_H_(0x88, 0x4B)
#define REG_SC_BK88_4C_L      _PK_L_(0x88, 0x4C)
#define REG_SC_BK88_4C_H      _PK_H_(0x88, 0x4C)
#define REG_SC_BK88_4D_L      _PK_L_(0x88, 0x4D)
#define REG_SC_BK88_4D_H      _PK_H_(0x88, 0x4D)
#define REG_SC_BK88_4E_L      _PK_L_(0x88, 0x4E)
#define REG_SC_BK88_4E_H      _PK_H_(0x88, 0x4E)
#define REG_SC_BK88_4F_L      _PK_L_(0x88, 0x4F)
#define REG_SC_BK88_4F_H      _PK_H_(0x88, 0x4F)
#define REG_SC_BK88_50_L      _PK_L_(0x88, 0x50)
#define REG_SC_BK88_50_H      _PK_H_(0x88, 0x50)
#define REG_SC_BK88_51_L      _PK_L_(0x88, 0x51)
#define REG_SC_BK88_51_H      _PK_H_(0x88, 0x51)
#define REG_SC_BK88_52_L      _PK_L_(0x88, 0x52)
#define REG_SC_BK88_52_H      _PK_H_(0x88, 0x52)
#define REG_SC_BK88_53_L      _PK_L_(0x88, 0x53)
#define REG_SC_BK88_53_H      _PK_H_(0x88, 0x53)
#define REG_SC_BK88_54_L      _PK_L_(0x88, 0x54)
#define REG_SC_BK88_54_H      _PK_H_(0x88, 0x54)
#define REG_SC_BK88_55_L      _PK_L_(0x88, 0x55)
#define REG_SC_BK88_55_H      _PK_H_(0x88, 0x55)
#define REG_SC_BK88_56_L      _PK_L_(0x88, 0x56)
#define REG_SC_BK88_56_H      _PK_H_(0x88, 0x56)
#define REG_SC_BK88_57_L      _PK_L_(0x88, 0x57)
#define REG_SC_BK88_57_H      _PK_H_(0x88, 0x57)
#define REG_SC_BK88_58_L      _PK_L_(0x88, 0x58)
#define REG_SC_BK88_58_H      _PK_H_(0x88, 0x58)
#define REG_SC_BK88_59_L      _PK_L_(0x88, 0x59)
#define REG_SC_BK88_59_H      _PK_H_(0x88, 0x59)
#define REG_SC_BK88_5A_L      _PK_L_(0x88, 0x5A)
#define REG_SC_BK88_5A_H      _PK_H_(0x88, 0x5A)
#define REG_SC_BK88_5B_L      _PK_L_(0x88, 0x5B)
#define REG_SC_BK88_5B_H      _PK_H_(0x88, 0x5B)
#define REG_SC_BK88_5C_L      _PK_L_(0x88, 0x5C)
#define REG_SC_BK88_5C_H      _PK_H_(0x88, 0x5C)
#define REG_SC_BK88_5D_L      _PK_L_(0x88, 0x5D)
#define REG_SC_BK88_5D_H      _PK_H_(0x88, 0x5D)
#define REG_SC_BK88_5E_L      _PK_L_(0x88, 0x5E)
#define REG_SC_BK88_5E_H      _PK_H_(0x88, 0x5E)
#define REG_SC_BK88_5F_L      _PK_L_(0x88, 0x5F)
#define REG_SC_BK88_5F_H      _PK_H_(0x88, 0x5F)
#define REG_SC_BK88_60_L      _PK_L_(0x88, 0x60)
#define REG_SC_BK88_60_H      _PK_H_(0x88, 0x60)
#define REG_SC_BK88_61_L      _PK_L_(0x88, 0x61)
#define REG_SC_BK88_61_H      _PK_H_(0x88, 0x61)
#define REG_SC_BK88_62_L      _PK_L_(0x88, 0x62)
#define REG_SC_BK88_62_H      _PK_H_(0x88, 0x62)
#define REG_SC_BK88_63_L      _PK_L_(0x88, 0x63)
#define REG_SC_BK88_63_H      _PK_H_(0x88, 0x63)
#define REG_SC_BK88_64_L      _PK_L_(0x88, 0x64)
#define REG_SC_BK88_64_H      _PK_H_(0x88, 0x64)
#define REG_SC_BK88_65_L      _PK_L_(0x88, 0x65)
#define REG_SC_BK88_65_H      _PK_H_(0x88, 0x65)
#define REG_SC_BK88_66_L      _PK_L_(0x88, 0x66)
#define REG_SC_BK88_66_H      _PK_H_(0x88, 0x66)
#define REG_SC_BK88_67_L      _PK_L_(0x88, 0x67)
#define REG_SC_BK88_67_H      _PK_H_(0x88, 0x67)
#define REG_SC_BK88_68_L      _PK_L_(0x88, 0x68)
#define REG_SC_BK88_68_H      _PK_H_(0x88, 0x68)
#define REG_SC_BK88_69_L      _PK_L_(0x88, 0x69)
#define REG_SC_BK88_69_H      _PK_H_(0x88, 0x69)
#define REG_SC_BK88_6A_L      _PK_L_(0x88, 0x6A)
#define REG_SC_BK88_6A_H      _PK_H_(0x88, 0x6A)
#define REG_SC_BK88_6B_L      _PK_L_(0x88, 0x6B)
#define REG_SC_BK88_6B_H      _PK_H_(0x88, 0x6B)
#define REG_SC_BK88_6C_L      _PK_L_(0x88, 0x6C)
#define REG_SC_BK88_6C_H      _PK_H_(0x88, 0x6C)
#define REG_SC_BK88_6D_L      _PK_L_(0x88, 0x6D)
#define REG_SC_BK88_6D_H      _PK_H_(0x88, 0x6D)
#define REG_SC_BK88_6E_L      _PK_L_(0x88, 0x6E)
#define REG_SC_BK88_6E_H      _PK_H_(0x88, 0x6E)
#define REG_SC_BK88_6F_L      _PK_L_(0x88, 0x6F)
#define REG_SC_BK88_6F_H      _PK_H_(0x88, 0x6F)
#define REG_SC_BK88_70_L      _PK_L_(0x88, 0x70)
#define REG_SC_BK88_70_H      _PK_H_(0x88, 0x70)
#define REG_SC_BK88_71_L      _PK_L_(0x88, 0x71)
#define REG_SC_BK88_71_H      _PK_H_(0x88, 0x71)
#define REG_SC_BK88_72_L      _PK_L_(0x88, 0x72)
#define REG_SC_BK88_72_H      _PK_H_(0x88, 0x72)
#define REG_SC_BK88_73_L      _PK_L_(0x88, 0x73)
#define REG_SC_BK88_73_H      _PK_H_(0x88, 0x73)
#define REG_SC_BK88_74_L      _PK_L_(0x88, 0x74)
#define REG_SC_BK88_74_H      _PK_H_(0x88, 0x74)
#define REG_SC_BK88_75_L      _PK_L_(0x88, 0x75)
#define REG_SC_BK88_75_H      _PK_H_(0x88, 0x75)
#define REG_SC_BK88_76_L      _PK_L_(0x88, 0x76)
#define REG_SC_BK88_76_H      _PK_H_(0x88, 0x76)
#define REG_SC_BK88_77_L      _PK_L_(0x88, 0x77)
#define REG_SC_BK88_77_H      _PK_H_(0x88, 0x77)
#define REG_SC_BK88_78_L      _PK_L_(0x88, 0x78)
#define REG_SC_BK88_78_H      _PK_H_(0x88, 0x78)
#define REG_SC_BK88_79_L      _PK_L_(0x88, 0x79)
#define REG_SC_BK88_79_H      _PK_H_(0x88, 0x79)
#define REG_SC_BK88_7A_L      _PK_L_(0x88, 0x7A)
#define REG_SC_BK88_7A_H      _PK_H_(0x88, 0x7A)
#define REG_SC_BK88_7B_L      _PK_L_(0x88, 0x7B)
#define REG_SC_BK88_7B_H      _PK_H_(0x88, 0x7B)
#define REG_SC_BK88_7C_L      _PK_L_(0x88, 0x7C)
#define REG_SC_BK88_7C_H      _PK_H_(0x88, 0x7C)
#define REG_SC_BK88_7D_L      _PK_L_(0x88, 0x7D)
#define REG_SC_BK88_7D_H      _PK_H_(0x88, 0x7D)
#define REG_SC_BK88_7E_L      _PK_L_(0x88, 0x7E)
#define REG_SC_BK88_7E_H      _PK_H_(0x88, 0x7E)
#define REG_SC_BK88_7F_L      _PK_L_(0x88, 0x7F)
#define REG_SC_BK88_7F_H      _PK_H_(0x88, 0x7F)
//----------------------------------------------
#define REG_SC_BK89_00_L      _PK_L_(0x89, 0x00)
#define REG_SC_BK89_00_H      _PK_H_(0x89, 0x00)
#define REG_SC_BK89_01_L      _PK_L_(0x89, 0x01)
#define REG_SC_BK89_01_H      _PK_H_(0x89, 0x01)
#define REG_SC_BK89_02_L      _PK_L_(0x89, 0x02)
#define REG_SC_BK89_02_H      _PK_H_(0x89, 0x02)
#define REG_SC_BK89_03_L      _PK_L_(0x89, 0x03)
#define REG_SC_BK89_03_H      _PK_H_(0x89, 0x03)
#define REG_SC_BK89_04_L      _PK_L_(0x89, 0x04)
#define REG_SC_BK89_04_H      _PK_H_(0x89, 0x04)
#define REG_SC_BK89_05_L      _PK_L_(0x89, 0x05)
#define REG_SC_BK89_05_H      _PK_H_(0x89, 0x05)
#define REG_SC_BK89_06_L      _PK_L_(0x89, 0x06)
#define REG_SC_BK89_06_H      _PK_H_(0x89, 0x06)
#define REG_SC_BK89_07_L      _PK_L_(0x89, 0x07)
#define REG_SC_BK89_07_H      _PK_H_(0x89, 0x07)
#define REG_SC_BK89_08_L      _PK_L_(0x89, 0x08)
#define REG_SC_BK89_08_H      _PK_H_(0x89, 0x08)
#define REG_SC_BK89_09_L      _PK_L_(0x89, 0x09)
#define REG_SC_BK89_09_H      _PK_H_(0x89, 0x09)
#define REG_SC_BK89_0A_L      _PK_L_(0x89, 0x0A)
#define REG_SC_BK89_0A_H      _PK_H_(0x89, 0x0A)
#define REG_SC_BK89_0B_L      _PK_L_(0x89, 0x0B)
#define REG_SC_BK89_0B_H      _PK_H_(0x89, 0x0B)
#define REG_SC_BK89_0C_L      _PK_L_(0x89, 0x0C)
#define REG_SC_BK89_0C_H      _PK_H_(0x89, 0x0C)
#define REG_SC_BK89_0D_L      _PK_L_(0x89, 0x0D)
#define REG_SC_BK89_0D_H      _PK_H_(0x89, 0x0D)
#define REG_SC_BK89_0E_L      _PK_L_(0x89, 0x0E)
#define REG_SC_BK89_0E_H      _PK_H_(0x89, 0x0E)
#define REG_SC_BK89_0F_L      _PK_L_(0x89, 0x0F)
#define REG_SC_BK89_0F_H      _PK_H_(0x89, 0x0F)
#define REG_SC_BK89_10_L      _PK_L_(0x89, 0x10)
#define REG_SC_BK89_10_H      _PK_H_(0x89, 0x10)
#define REG_SC_BK89_11_L      _PK_L_(0x89, 0x11)
#define REG_SC_BK89_11_H      _PK_H_(0x89, 0x11)
#define REG_SC_BK89_12_L      _PK_L_(0x89, 0x12)
#define REG_SC_BK89_12_H      _PK_H_(0x89, 0x12)
#define REG_SC_BK89_13_L      _PK_L_(0x89, 0x13)
#define REG_SC_BK89_13_H      _PK_H_(0x89, 0x13)
#define REG_SC_BK89_14_L      _PK_L_(0x89, 0x14)
#define REG_SC_BK89_14_H      _PK_H_(0x89, 0x14)
#define REG_SC_BK89_15_L      _PK_L_(0x89, 0x15)
#define REG_SC_BK89_15_H      _PK_H_(0x89, 0x15)
#define REG_SC_BK89_16_L      _PK_L_(0x89, 0x16)
#define REG_SC_BK89_16_H      _PK_H_(0x89, 0x16)
#define REG_SC_BK89_17_L      _PK_L_(0x89, 0x17)
#define REG_SC_BK89_17_H      _PK_H_(0x89, 0x17)
#define REG_SC_BK89_18_L      _PK_L_(0x89, 0x18)
#define REG_SC_BK89_18_H      _PK_H_(0x89, 0x18)
#define REG_SC_BK89_19_L      _PK_L_(0x89, 0x19)
#define REG_SC_BK89_19_H      _PK_H_(0x89, 0x19)
#define REG_SC_BK89_1A_L      _PK_L_(0x89, 0x1A)
#define REG_SC_BK89_1A_H      _PK_H_(0x89, 0x1A)
#define REG_SC_BK89_1B_L      _PK_L_(0x89, 0x1B)
#define REG_SC_BK89_1B_H      _PK_H_(0x89, 0x1B)
#define REG_SC_BK89_1C_L      _PK_L_(0x89, 0x1C)
#define REG_SC_BK89_1C_H      _PK_H_(0x89, 0x1C)
#define REG_SC_BK89_1D_L      _PK_L_(0x89, 0x1D)
#define REG_SC_BK89_1D_H      _PK_H_(0x89, 0x1D)
#define REG_SC_BK89_1E_L      _PK_L_(0x89, 0x1E)
#define REG_SC_BK89_1E_H      _PK_H_(0x89, 0x1E)
#define REG_SC_BK89_1F_L      _PK_L_(0x89, 0x1F)
#define REG_SC_BK89_1F_H      _PK_H_(0x89, 0x1F)
#define REG_SC_BK89_20_L      _PK_L_(0x89, 0x20)
#define REG_SC_BK89_20_H      _PK_H_(0x89, 0x20)
#define REG_SC_BK89_21_L      _PK_L_(0x89, 0x21)
#define REG_SC_BK89_21_H      _PK_H_(0x89, 0x21)
#define REG_SC_BK89_22_L      _PK_L_(0x89, 0x22)
#define REG_SC_BK89_22_H      _PK_H_(0x89, 0x22)
#define REG_SC_BK89_23_L      _PK_L_(0x89, 0x23)
#define REG_SC_BK89_23_H      _PK_H_(0x89, 0x23)
#define REG_SC_BK89_24_L      _PK_L_(0x89, 0x24)
#define REG_SC_BK89_24_H      _PK_H_(0x89, 0x24)
#define REG_SC_BK89_25_L      _PK_L_(0x89, 0x25)
#define REG_SC_BK89_25_H      _PK_H_(0x89, 0x25)
#define REG_SC_BK89_26_L      _PK_L_(0x89, 0x26)
#define REG_SC_BK89_26_H      _PK_H_(0x89, 0x26)
#define REG_SC_BK89_27_L      _PK_L_(0x89, 0x27)
#define REG_SC_BK89_27_H      _PK_H_(0x89, 0x27)
#define REG_SC_BK89_28_L      _PK_L_(0x89, 0x28)
#define REG_SC_BK89_28_H      _PK_H_(0x89, 0x28)
#define REG_SC_BK89_29_L      _PK_L_(0x89, 0x29)
#define REG_SC_BK89_29_H      _PK_H_(0x89, 0x29)
#define REG_SC_BK89_2A_L      _PK_L_(0x89, 0x2A)
#define REG_SC_BK89_2A_H      _PK_H_(0x89, 0x2A)
#define REG_SC_BK89_2B_L      _PK_L_(0x89, 0x2B)
#define REG_SC_BK89_2B_H      _PK_H_(0x89, 0x2B)
#define REG_SC_BK89_2C_L      _PK_L_(0x89, 0x2C)
#define REG_SC_BK89_2C_H      _PK_H_(0x89, 0x2C)
#define REG_SC_BK89_2D_L      _PK_L_(0x89, 0x2D)
#define REG_SC_BK89_2D_H      _PK_H_(0x89, 0x2D)
#define REG_SC_BK89_2E_L      _PK_L_(0x89, 0x2E)
#define REG_SC_BK89_2E_H      _PK_H_(0x89, 0x2E)
#define REG_SC_BK89_2F_L      _PK_L_(0x89, 0x2F)
#define REG_SC_BK89_2F_H      _PK_H_(0x89, 0x2F)
#define REG_SC_BK89_30_L      _PK_L_(0x89, 0x30)
#define REG_SC_BK89_30_H      _PK_H_(0x89, 0x30)
#define REG_SC_BK89_31_L      _PK_L_(0x89, 0x31)
#define REG_SC_BK89_31_H      _PK_H_(0x89, 0x31)
#define REG_SC_BK89_32_L      _PK_L_(0x89, 0x32)
#define REG_SC_BK89_32_H      _PK_H_(0x89, 0x32)
#define REG_SC_BK89_33_L      _PK_L_(0x89, 0x33)
#define REG_SC_BK89_33_H      _PK_H_(0x89, 0x33)
#define REG_SC_BK89_34_L      _PK_L_(0x89, 0x34)
#define REG_SC_BK89_34_H      _PK_H_(0x89, 0x34)
#define REG_SC_BK89_35_L      _PK_L_(0x89, 0x35)
#define REG_SC_BK89_35_H      _PK_H_(0x89, 0x35)
#define REG_SC_BK89_36_L      _PK_L_(0x89, 0x36)
#define REG_SC_BK89_36_H      _PK_H_(0x89, 0x36)
#define REG_SC_BK89_37_L      _PK_L_(0x89, 0x37)
#define REG_SC_BK89_37_H      _PK_H_(0x89, 0x37)
#define REG_SC_BK89_38_L      _PK_L_(0x89, 0x38)
#define REG_SC_BK89_38_H      _PK_H_(0x89, 0x38)
#define REG_SC_BK89_39_L      _PK_L_(0x89, 0x39)
#define REG_SC_BK89_39_H      _PK_H_(0x89, 0x39)
#define REG_SC_BK89_3A_L      _PK_L_(0x89, 0x3A)
#define REG_SC_BK89_3A_H      _PK_H_(0x89, 0x3A)
#define REG_SC_BK89_3B_L      _PK_L_(0x89, 0x3B)
#define REG_SC_BK89_3B_H      _PK_H_(0x89, 0x3B)
#define REG_SC_BK89_3C_L      _PK_L_(0x89, 0x3C)
#define REG_SC_BK89_3C_H      _PK_H_(0x89, 0x3C)
#define REG_SC_BK89_3D_L      _PK_L_(0x89, 0x3D)
#define REG_SC_BK89_3D_H      _PK_H_(0x89, 0x3D)
#define REG_SC_BK89_3E_L      _PK_L_(0x89, 0x3E)
#define REG_SC_BK89_3E_H      _PK_H_(0x89, 0x3E)
#define REG_SC_BK89_3F_L      _PK_L_(0x89, 0x3F)
#define REG_SC_BK89_3F_H      _PK_H_(0x89, 0x3F)
#define REG_SC_BK89_40_L      _PK_L_(0x89, 0x40)
#define REG_SC_BK89_40_H      _PK_H_(0x89, 0x40)
#define REG_SC_BK89_41_L      _PK_L_(0x89, 0x41)
#define REG_SC_BK89_41_H      _PK_H_(0x89, 0x41)
#define REG_SC_BK89_42_L      _PK_L_(0x89, 0x42)
#define REG_SC_BK89_42_H      _PK_H_(0x89, 0x42)
#define REG_SC_BK89_43_L      _PK_L_(0x89, 0x43)
#define REG_SC_BK89_43_H      _PK_H_(0x89, 0x43)
#define REG_SC_BK89_44_L      _PK_L_(0x89, 0x44)
#define REG_SC_BK89_44_H      _PK_H_(0x89, 0x44)
#define REG_SC_BK89_45_L      _PK_L_(0x89, 0x45)
#define REG_SC_BK89_45_H      _PK_H_(0x89, 0x45)
#define REG_SC_BK89_46_L      _PK_L_(0x89, 0x46)
#define REG_SC_BK89_46_H      _PK_H_(0x89, 0x46)
#define REG_SC_BK89_47_L      _PK_L_(0x89, 0x47)
#define REG_SC_BK89_47_H      _PK_H_(0x89, 0x47)
#define REG_SC_BK89_48_L      _PK_L_(0x89, 0x48)
#define REG_SC_BK89_48_H      _PK_H_(0x89, 0x48)
#define REG_SC_BK89_49_L      _PK_L_(0x89, 0x49)
#define REG_SC_BK89_49_H      _PK_H_(0x89, 0x49)
#define REG_SC_BK89_4A_L      _PK_L_(0x89, 0x4A)
#define REG_SC_BK89_4A_H      _PK_H_(0x89, 0x4A)
#define REG_SC_BK89_4B_L      _PK_L_(0x89, 0x4B)
#define REG_SC_BK89_4B_H      _PK_H_(0x89, 0x4B)
#define REG_SC_BK89_4C_L      _PK_L_(0x89, 0x4C)
#define REG_SC_BK89_4C_H      _PK_H_(0x89, 0x4C)
#define REG_SC_BK89_4D_L      _PK_L_(0x89, 0x4D)
#define REG_SC_BK89_4D_H      _PK_H_(0x89, 0x4D)
#define REG_SC_BK89_4E_L      _PK_L_(0x89, 0x4E)
#define REG_SC_BK89_4E_H      _PK_H_(0x89, 0x4E)
#define REG_SC_BK89_4F_L      _PK_L_(0x89, 0x4F)
#define REG_SC_BK89_4F_H      _PK_H_(0x89, 0x4F)
#define REG_SC_BK89_50_L      _PK_L_(0x89, 0x50)
#define REG_SC_BK89_50_H      _PK_H_(0x89, 0x50)
#define REG_SC_BK89_51_L      _PK_L_(0x89, 0x51)
#define REG_SC_BK89_51_H      _PK_H_(0x89, 0x51)
#define REG_SC_BK89_52_L      _PK_L_(0x89, 0x52)
#define REG_SC_BK89_52_H      _PK_H_(0x89, 0x52)
#define REG_SC_BK89_53_L      _PK_L_(0x89, 0x53)
#define REG_SC_BK89_53_H      _PK_H_(0x89, 0x53)
#define REG_SC_BK89_54_L      _PK_L_(0x89, 0x54)
#define REG_SC_BK89_54_H      _PK_H_(0x89, 0x54)
#define REG_SC_BK89_55_L      _PK_L_(0x89, 0x55)
#define REG_SC_BK89_55_H      _PK_H_(0x89, 0x55)
#define REG_SC_BK89_56_L      _PK_L_(0x89, 0x56)
#define REG_SC_BK89_56_H      _PK_H_(0x89, 0x56)
#define REG_SC_BK89_57_L      _PK_L_(0x89, 0x57)
#define REG_SC_BK89_57_H      _PK_H_(0x89, 0x57)
#define REG_SC_BK89_58_L      _PK_L_(0x89, 0x58)
#define REG_SC_BK89_58_H      _PK_H_(0x89, 0x58)
#define REG_SC_BK89_59_L      _PK_L_(0x89, 0x59)
#define REG_SC_BK89_59_H      _PK_H_(0x89, 0x59)
#define REG_SC_BK89_5A_L      _PK_L_(0x89, 0x5A)
#define REG_SC_BK89_5A_H      _PK_H_(0x89, 0x5A)
#define REG_SC_BK89_5B_L      _PK_L_(0x89, 0x5B)
#define REG_SC_BK89_5B_H      _PK_H_(0x89, 0x5B)
#define REG_SC_BK89_5C_L      _PK_L_(0x89, 0x5C)
#define REG_SC_BK89_5C_H      _PK_H_(0x89, 0x5C)
#define REG_SC_BK89_5D_L      _PK_L_(0x89, 0x5D)
#define REG_SC_BK89_5D_H      _PK_H_(0x89, 0x5D)
#define REG_SC_BK89_5E_L      _PK_L_(0x89, 0x5E)
#define REG_SC_BK89_5E_H      _PK_H_(0x89, 0x5E)
#define REG_SC_BK89_5F_L      _PK_L_(0x89, 0x5F)
#define REG_SC_BK89_5F_H      _PK_H_(0x89, 0x5F)
#define REG_SC_BK89_60_L      _PK_L_(0x89, 0x60)
#define REG_SC_BK89_60_H      _PK_H_(0x89, 0x60)
#define REG_SC_BK89_61_L      _PK_L_(0x89, 0x61)
#define REG_SC_BK89_61_H      _PK_H_(0x89, 0x61)
#define REG_SC_BK89_62_L      _PK_L_(0x89, 0x62)
#define REG_SC_BK89_62_H      _PK_H_(0x89, 0x62)
#define REG_SC_BK89_63_L      _PK_L_(0x89, 0x63)
#define REG_SC_BK89_63_H      _PK_H_(0x89, 0x63)
#define REG_SC_BK89_64_L      _PK_L_(0x89, 0x64)
#define REG_SC_BK89_64_H      _PK_H_(0x89, 0x64)
#define REG_SC_BK89_65_L      _PK_L_(0x89, 0x65)
#define REG_SC_BK89_65_H      _PK_H_(0x89, 0x65)
#define REG_SC_BK89_66_L      _PK_L_(0x89, 0x66)
#define REG_SC_BK89_66_H      _PK_H_(0x89, 0x66)
#define REG_SC_BK89_67_L      _PK_L_(0x89, 0x67)
#define REG_SC_BK89_67_H      _PK_H_(0x89, 0x67)
#define REG_SC_BK89_68_L      _PK_L_(0x89, 0x68)
#define REG_SC_BK89_68_H      _PK_H_(0x89, 0x68)
#define REG_SC_BK89_69_L      _PK_L_(0x89, 0x69)
#define REG_SC_BK89_69_H      _PK_H_(0x89, 0x69)
#define REG_SC_BK89_6A_L      _PK_L_(0x89, 0x6A)
#define REG_SC_BK89_6A_H      _PK_H_(0x89, 0x6A)
#define REG_SC_BK89_6B_L      _PK_L_(0x89, 0x6B)
#define REG_SC_BK89_6B_H      _PK_H_(0x89, 0x6B)
#define REG_SC_BK89_6C_L      _PK_L_(0x89, 0x6C)
#define REG_SC_BK89_6C_H      _PK_H_(0x89, 0x6C)
#define REG_SC_BK89_6D_L      _PK_L_(0x89, 0x6D)
#define REG_SC_BK89_6D_H      _PK_H_(0x89, 0x6D)
#define REG_SC_BK89_6E_L      _PK_L_(0x89, 0x6E)
#define REG_SC_BK89_6E_H      _PK_H_(0x89, 0x6E)
#define REG_SC_BK89_6F_L      _PK_L_(0x89, 0x6F)
#define REG_SC_BK89_6F_H      _PK_H_(0x89, 0x6F)
#define REG_SC_BK89_70_L      _PK_L_(0x89, 0x70)
#define REG_SC_BK89_70_H      _PK_H_(0x89, 0x70)
#define REG_SC_BK89_71_L      _PK_L_(0x89, 0x71)
#define REG_SC_BK89_71_H      _PK_H_(0x89, 0x71)
#define REG_SC_BK89_72_L      _PK_L_(0x89, 0x72)
#define REG_SC_BK89_72_H      _PK_H_(0x89, 0x72)
#define REG_SC_BK89_73_L      _PK_L_(0x89, 0x73)
#define REG_SC_BK89_73_H      _PK_H_(0x89, 0x73)
#define REG_SC_BK89_74_L      _PK_L_(0x89, 0x74)
#define REG_SC_BK89_74_H      _PK_H_(0x89, 0x74)
#define REG_SC_BK89_75_L      _PK_L_(0x89, 0x75)
#define REG_SC_BK89_75_H      _PK_H_(0x89, 0x75)
#define REG_SC_BK89_76_L      _PK_L_(0x89, 0x76)
#define REG_SC_BK89_76_H      _PK_H_(0x89, 0x76)
#define REG_SC_BK89_77_L      _PK_L_(0x89, 0x77)
#define REG_SC_BK89_77_H      _PK_H_(0x89, 0x77)
#define REG_SC_BK89_78_L      _PK_L_(0x89, 0x78)
#define REG_SC_BK89_78_H      _PK_H_(0x89, 0x78)
#define REG_SC_BK89_79_L      _PK_L_(0x89, 0x79)
#define REG_SC_BK89_79_H      _PK_H_(0x89, 0x79)
#define REG_SC_BK89_7A_L      _PK_L_(0x89, 0x7A)
#define REG_SC_BK89_7A_H      _PK_H_(0x89, 0x7A)
#define REG_SC_BK89_7B_L      _PK_L_(0x89, 0x7B)
#define REG_SC_BK89_7B_H      _PK_H_(0x89, 0x7B)
#define REG_SC_BK89_7C_L      _PK_L_(0x89, 0x7C)
#define REG_SC_BK89_7C_H      _PK_H_(0x89, 0x7C)
#define REG_SC_BK89_7D_L      _PK_L_(0x89, 0x7D)
#define REG_SC_BK89_7D_H      _PK_H_(0x89, 0x7D)
#define REG_SC_BK89_7E_L      _PK_L_(0x89, 0x7E)
#define REG_SC_BK89_7E_H      _PK_H_(0x89, 0x7E)
#define REG_SC_BK89_7F_L      _PK_L_(0x89, 0x7F)
#define REG_SC_BK89_7F_H      _PK_H_(0x89, 0x7F)
//----------------------------------------------
#define REG_SC_BK8A_00_L      _PK_L_(0x8A, 0x00)
#define REG_SC_BK8A_00_H      _PK_H_(0x8A, 0x00)
#define REG_SC_BK8A_01_L      _PK_L_(0x8A, 0x01)
#define REG_SC_BK8A_01_H      _PK_H_(0x8A, 0x01)
#define REG_SC_BK8A_02_L      _PK_L_(0x8A, 0x02)
#define REG_SC_BK8A_02_H      _PK_H_(0x8A, 0x02)
#define REG_SC_BK8A_03_L      _PK_L_(0x8A, 0x03)
#define REG_SC_BK8A_03_H      _PK_H_(0x8A, 0x03)
#define REG_SC_BK8A_04_L      _PK_L_(0x8A, 0x04)
#define REG_SC_BK8A_04_H      _PK_H_(0x8A, 0x04)
#define REG_SC_BK8A_05_L      _PK_L_(0x8A, 0x05)
#define REG_SC_BK8A_05_H      _PK_H_(0x8A, 0x05)
#define REG_SC_BK8A_06_L      _PK_L_(0x8A, 0x06)
#define REG_SC_BK8A_06_H      _PK_H_(0x8A, 0x06)
#define REG_SC_BK8A_07_L      _PK_L_(0x8A, 0x07)
#define REG_SC_BK8A_07_H      _PK_H_(0x8A, 0x07)
#define REG_SC_BK8A_08_L      _PK_L_(0x8A, 0x08)
#define REG_SC_BK8A_08_H      _PK_H_(0x8A, 0x08)
#define REG_SC_BK8A_09_L      _PK_L_(0x8A, 0x09)
#define REG_SC_BK8A_09_H      _PK_H_(0x8A, 0x09)
#define REG_SC_BK8A_0A_L      _PK_L_(0x8A, 0x0A)
#define REG_SC_BK8A_0A_H      _PK_H_(0x8A, 0x0A)
#define REG_SC_BK8A_0B_L      _PK_L_(0x8A, 0x0B)
#define REG_SC_BK8A_0B_H      _PK_H_(0x8A, 0x0B)
#define REG_SC_BK8A_0C_L      _PK_L_(0x8A, 0x0C)
#define REG_SC_BK8A_0C_H      _PK_H_(0x8A, 0x0C)
#define REG_SC_BK8A_0D_L      _PK_L_(0x8A, 0x0D)
#define REG_SC_BK8A_0D_H      _PK_H_(0x8A, 0x0D)
#define REG_SC_BK8A_0E_L      _PK_L_(0x8A, 0x0E)
#define REG_SC_BK8A_0E_H      _PK_H_(0x8A, 0x0E)
#define REG_SC_BK8A_0F_L      _PK_L_(0x8A, 0x0F)
#define REG_SC_BK8A_0F_H      _PK_H_(0x8A, 0x0F)
#define REG_SC_BK8A_10_L      _PK_L_(0x8A, 0x10)
#define REG_SC_BK8A_10_H      _PK_H_(0x8A, 0x10)
#define REG_SC_BK8A_11_L      _PK_L_(0x8A, 0x11)
#define REG_SC_BK8A_11_H      _PK_H_(0x8A, 0x11)
#define REG_SC_BK8A_12_L      _PK_L_(0x8A, 0x12)
#define REG_SC_BK8A_12_H      _PK_H_(0x8A, 0x12)
#define REG_SC_BK8A_13_L      _PK_L_(0x8A, 0x13)
#define REG_SC_BK8A_13_H      _PK_H_(0x8A, 0x13)
#define REG_SC_BK8A_14_L      _PK_L_(0x8A, 0x14)
#define REG_SC_BK8A_14_H      _PK_H_(0x8A, 0x14)
#define REG_SC_BK8A_15_L      _PK_L_(0x8A, 0x15)
#define REG_SC_BK8A_15_H      _PK_H_(0x8A, 0x15)
#define REG_SC_BK8A_16_L      _PK_L_(0x8A, 0x16)
#define REG_SC_BK8A_16_H      _PK_H_(0x8A, 0x16)
#define REG_SC_BK8A_17_L      _PK_L_(0x8A, 0x17)
#define REG_SC_BK8A_17_H      _PK_H_(0x8A, 0x17)
#define REG_SC_BK8A_18_L      _PK_L_(0x8A, 0x18)
#define REG_SC_BK8A_18_H      _PK_H_(0x8A, 0x18)
#define REG_SC_BK8A_19_L      _PK_L_(0x8A, 0x19)
#define REG_SC_BK8A_19_H      _PK_H_(0x8A, 0x19)
#define REG_SC_BK8A_1A_L      _PK_L_(0x8A, 0x1A)
#define REG_SC_BK8A_1A_H      _PK_H_(0x8A, 0x1A)
#define REG_SC_BK8A_1B_L      _PK_L_(0x8A, 0x1B)
#define REG_SC_BK8A_1B_H      _PK_H_(0x8A, 0x1B)
#define REG_SC_BK8A_1C_L      _PK_L_(0x8A, 0x1C)
#define REG_SC_BK8A_1C_H      _PK_H_(0x8A, 0x1C)
#define REG_SC_BK8A_1D_L      _PK_L_(0x8A, 0x1D)
#define REG_SC_BK8A_1D_H      _PK_H_(0x8A, 0x1D)
#define REG_SC_BK8A_1E_L      _PK_L_(0x8A, 0x1E)
#define REG_SC_BK8A_1E_H      _PK_H_(0x8A, 0x1E)
#define REG_SC_BK8A_1F_L      _PK_L_(0x8A, 0x1F)
#define REG_SC_BK8A_1F_H      _PK_H_(0x8A, 0x1F)
#define REG_SC_BK8A_20_L      _PK_L_(0x8A, 0x20)
#define REG_SC_BK8A_20_H      _PK_H_(0x8A, 0x20)
#define REG_SC_BK8A_21_L      _PK_L_(0x8A, 0x21)
#define REG_SC_BK8A_21_H      _PK_H_(0x8A, 0x21)
#define REG_SC_BK8A_22_L      _PK_L_(0x8A, 0x22)
#define REG_SC_BK8A_22_H      _PK_H_(0x8A, 0x22)
#define REG_SC_BK8A_23_L      _PK_L_(0x8A, 0x23)
#define REG_SC_BK8A_23_H      _PK_H_(0x8A, 0x23)
#define REG_SC_BK8A_24_L      _PK_L_(0x8A, 0x24)
#define REG_SC_BK8A_24_H      _PK_H_(0x8A, 0x24)
#define REG_SC_BK8A_25_L      _PK_L_(0x8A, 0x25)
#define REG_SC_BK8A_25_H      _PK_H_(0x8A, 0x25)
#define REG_SC_BK8A_26_L      _PK_L_(0x8A, 0x26)
#define REG_SC_BK8A_26_H      _PK_H_(0x8A, 0x26)
#define REG_SC_BK8A_27_L      _PK_L_(0x8A, 0x27)
#define REG_SC_BK8A_27_H      _PK_H_(0x8A, 0x27)
#define REG_SC_BK8A_28_L      _PK_L_(0x8A, 0x28)
#define REG_SC_BK8A_28_H      _PK_H_(0x8A, 0x28)
#define REG_SC_BK8A_29_L      _PK_L_(0x8A, 0x29)
#define REG_SC_BK8A_29_H      _PK_H_(0x8A, 0x29)
#define REG_SC_BK8A_2A_L      _PK_L_(0x8A, 0x2A)
#define REG_SC_BK8A_2A_H      _PK_H_(0x8A, 0x2A)
#define REG_SC_BK8A_2B_L      _PK_L_(0x8A, 0x2B)
#define REG_SC_BK8A_2B_H      _PK_H_(0x8A, 0x2B)
#define REG_SC_BK8A_2C_L      _PK_L_(0x8A, 0x2C)
#define REG_SC_BK8A_2C_H      _PK_H_(0x8A, 0x2C)
#define REG_SC_BK8A_2D_L      _PK_L_(0x8A, 0x2D)
#define REG_SC_BK8A_2D_H      _PK_H_(0x8A, 0x2D)
#define REG_SC_BK8A_2E_L      _PK_L_(0x8A, 0x2E)
#define REG_SC_BK8A_2E_H      _PK_H_(0x8A, 0x2E)
#define REG_SC_BK8A_2F_L      _PK_L_(0x8A, 0x2F)
#define REG_SC_BK8A_2F_H      _PK_H_(0x8A, 0x2F)
#define REG_SC_BK8A_30_L      _PK_L_(0x8A, 0x30)
#define REG_SC_BK8A_30_H      _PK_H_(0x8A, 0x30)
#define REG_SC_BK8A_31_L      _PK_L_(0x8A, 0x31)
#define REG_SC_BK8A_31_H      _PK_H_(0x8A, 0x31)
#define REG_SC_BK8A_32_L      _PK_L_(0x8A, 0x32)
#define REG_SC_BK8A_32_H      _PK_H_(0x8A, 0x32)
#define REG_SC_BK8A_33_L      _PK_L_(0x8A, 0x33)
#define REG_SC_BK8A_33_H      _PK_H_(0x8A, 0x33)
#define REG_SC_BK8A_34_L      _PK_L_(0x8A, 0x34)
#define REG_SC_BK8A_34_H      _PK_H_(0x8A, 0x34)
#define REG_SC_BK8A_35_L      _PK_L_(0x8A, 0x35)
#define REG_SC_BK8A_35_H      _PK_H_(0x8A, 0x35)
#define REG_SC_BK8A_36_L      _PK_L_(0x8A, 0x36)
#define REG_SC_BK8A_36_H      _PK_H_(0x8A, 0x36)
#define REG_SC_BK8A_37_L      _PK_L_(0x8A, 0x37)
#define REG_SC_BK8A_37_H      _PK_H_(0x8A, 0x37)
#define REG_SC_BK8A_38_L      _PK_L_(0x8A, 0x38)
#define REG_SC_BK8A_38_H      _PK_H_(0x8A, 0x38)
#define REG_SC_BK8A_39_L      _PK_L_(0x8A, 0x39)
#define REG_SC_BK8A_39_H      _PK_H_(0x8A, 0x39)
#define REG_SC_BK8A_3A_L      _PK_L_(0x8A, 0x3A)
#define REG_SC_BK8A_3A_H      _PK_H_(0x8A, 0x3A)
#define REG_SC_BK8A_3B_L      _PK_L_(0x8A, 0x3B)
#define REG_SC_BK8A_3B_H      _PK_H_(0x8A, 0x3B)
#define REG_SC_BK8A_3C_L      _PK_L_(0x8A, 0x3C)
#define REG_SC_BK8A_3C_H      _PK_H_(0x8A, 0x3C)
#define REG_SC_BK8A_3D_L      _PK_L_(0x8A, 0x3D)
#define REG_SC_BK8A_3D_H      _PK_H_(0x8A, 0x3D)
#define REG_SC_BK8A_3E_L      _PK_L_(0x8A, 0x3E)
#define REG_SC_BK8A_3E_H      _PK_H_(0x8A, 0x3E)
#define REG_SC_BK8A_3F_L      _PK_L_(0x8A, 0x3F)
#define REG_SC_BK8A_3F_H      _PK_H_(0x8A, 0x3F)
#define REG_SC_BK8A_40_L      _PK_L_(0x8A, 0x40)
#define REG_SC_BK8A_40_H      _PK_H_(0x8A, 0x40)
#define REG_SC_BK8A_41_L      _PK_L_(0x8A, 0x41)
#define REG_SC_BK8A_41_H      _PK_H_(0x8A, 0x41)
#define REG_SC_BK8A_42_L      _PK_L_(0x8A, 0x42)
#define REG_SC_BK8A_42_H      _PK_H_(0x8A, 0x42)
#define REG_SC_BK8A_43_L      _PK_L_(0x8A, 0x43)
#define REG_SC_BK8A_43_H      _PK_H_(0x8A, 0x43)
#define REG_SC_BK8A_44_L      _PK_L_(0x8A, 0x44)
#define REG_SC_BK8A_44_H      _PK_H_(0x8A, 0x44)
#define REG_SC_BK8A_45_L      _PK_L_(0x8A, 0x45)
#define REG_SC_BK8A_45_H      _PK_H_(0x8A, 0x45)
#define REG_SC_BK8A_46_L      _PK_L_(0x8A, 0x46)
#define REG_SC_BK8A_46_H      _PK_H_(0x8A, 0x46)
#define REG_SC_BK8A_47_L      _PK_L_(0x8A, 0x47)
#define REG_SC_BK8A_47_H      _PK_H_(0x8A, 0x47)
#define REG_SC_BK8A_48_L      _PK_L_(0x8A, 0x48)
#define REG_SC_BK8A_48_H      _PK_H_(0x8A, 0x48)
#define REG_SC_BK8A_49_L      _PK_L_(0x8A, 0x49)
#define REG_SC_BK8A_49_H      _PK_H_(0x8A, 0x49)
#define REG_SC_BK8A_4A_L      _PK_L_(0x8A, 0x4A)
#define REG_SC_BK8A_4A_H      _PK_H_(0x8A, 0x4A)
#define REG_SC_BK8A_4B_L      _PK_L_(0x8A, 0x4B)
#define REG_SC_BK8A_4B_H      _PK_H_(0x8A, 0x4B)
#define REG_SC_BK8A_4C_L      _PK_L_(0x8A, 0x4C)
#define REG_SC_BK8A_4C_H      _PK_H_(0x8A, 0x4C)
#define REG_SC_BK8A_4D_L      _PK_L_(0x8A, 0x4D)
#define REG_SC_BK8A_4D_H      _PK_H_(0x8A, 0x4D)
#define REG_SC_BK8A_4E_L      _PK_L_(0x8A, 0x4E)
#define REG_SC_BK8A_4E_H      _PK_H_(0x8A, 0x4E)
#define REG_SC_BK8A_4F_L      _PK_L_(0x8A, 0x4F)
#define REG_SC_BK8A_4F_H      _PK_H_(0x8A, 0x4F)
#define REG_SC_BK8A_50_L      _PK_L_(0x8A, 0x50)
#define REG_SC_BK8A_50_H      _PK_H_(0x8A, 0x50)
#define REG_SC_BK8A_51_L      _PK_L_(0x8A, 0x51)
#define REG_SC_BK8A_51_H      _PK_H_(0x8A, 0x51)
#define REG_SC_BK8A_52_L      _PK_L_(0x8A, 0x52)
#define REG_SC_BK8A_52_H      _PK_H_(0x8A, 0x52)
#define REG_SC_BK8A_53_L      _PK_L_(0x8A, 0x53)
#define REG_SC_BK8A_53_H      _PK_H_(0x8A, 0x53)
#define REG_SC_BK8A_54_L      _PK_L_(0x8A, 0x54)
#define REG_SC_BK8A_54_H      _PK_H_(0x8A, 0x54)
#define REG_SC_BK8A_55_L      _PK_L_(0x8A, 0x55)
#define REG_SC_BK8A_55_H      _PK_H_(0x8A, 0x55)
#define REG_SC_BK8A_56_L      _PK_L_(0x8A, 0x56)
#define REG_SC_BK8A_56_H      _PK_H_(0x8A, 0x56)
#define REG_SC_BK8A_57_L      _PK_L_(0x8A, 0x57)
#define REG_SC_BK8A_57_H      _PK_H_(0x8A, 0x57)
#define REG_SC_BK8A_58_L      _PK_L_(0x8A, 0x58)
#define REG_SC_BK8A_58_H      _PK_H_(0x8A, 0x58)
#define REG_SC_BK8A_59_L      _PK_L_(0x8A, 0x59)
#define REG_SC_BK8A_59_H      _PK_H_(0x8A, 0x59)
#define REG_SC_BK8A_5A_L      _PK_L_(0x8A, 0x5A)
#define REG_SC_BK8A_5A_H      _PK_H_(0x8A, 0x5A)
#define REG_SC_BK8A_5B_L      _PK_L_(0x8A, 0x5B)
#define REG_SC_BK8A_5B_H      _PK_H_(0x8A, 0x5B)
#define REG_SC_BK8A_5C_L      _PK_L_(0x8A, 0x5C)
#define REG_SC_BK8A_5C_H      _PK_H_(0x8A, 0x5C)
#define REG_SC_BK8A_5D_L      _PK_L_(0x8A, 0x5D)
#define REG_SC_BK8A_5D_H      _PK_H_(0x8A, 0x5D)
#define REG_SC_BK8A_5E_L      _PK_L_(0x8A, 0x5E)
#define REG_SC_BK8A_5E_H      _PK_H_(0x8A, 0x5E)
#define REG_SC_BK8A_5F_L      _PK_L_(0x8A, 0x5F)
#define REG_SC_BK8A_5F_H      _PK_H_(0x8A, 0x5F)
#define REG_SC_BK8A_60_L      _PK_L_(0x8A, 0x60)
#define REG_SC_BK8A_60_H      _PK_H_(0x8A, 0x60)
#define REG_SC_BK8A_61_L      _PK_L_(0x8A, 0x61)
#define REG_SC_BK8A_61_H      _PK_H_(0x8A, 0x61)
#define REG_SC_BK8A_62_L      _PK_L_(0x8A, 0x62)
#define REG_SC_BK8A_62_H      _PK_H_(0x8A, 0x62)
#define REG_SC_BK8A_63_L      _PK_L_(0x8A, 0x63)
#define REG_SC_BK8A_63_H      _PK_H_(0x8A, 0x63)
#define REG_SC_BK8A_64_L      _PK_L_(0x8A, 0x64)
#define REG_SC_BK8A_64_H      _PK_H_(0x8A, 0x64)
#define REG_SC_BK8A_65_L      _PK_L_(0x8A, 0x65)
#define REG_SC_BK8A_65_H      _PK_H_(0x8A, 0x65)
#define REG_SC_BK8A_66_L      _PK_L_(0x8A, 0x66)
#define REG_SC_BK8A_66_H      _PK_H_(0x8A, 0x66)
#define REG_SC_BK8A_67_L      _PK_L_(0x8A, 0x67)
#define REG_SC_BK8A_67_H      _PK_H_(0x8A, 0x67)
#define REG_SC_BK8A_68_L      _PK_L_(0x8A, 0x68)
#define REG_SC_BK8A_68_H      _PK_H_(0x8A, 0x68)
#define REG_SC_BK8A_69_L      _PK_L_(0x8A, 0x69)
#define REG_SC_BK8A_69_H      _PK_H_(0x8A, 0x69)
#define REG_SC_BK8A_6A_L      _PK_L_(0x8A, 0x6A)
#define REG_SC_BK8A_6A_H      _PK_H_(0x8A, 0x6A)
#define REG_SC_BK8A_6B_L      _PK_L_(0x8A, 0x6B)
#define REG_SC_BK8A_6B_H      _PK_H_(0x8A, 0x6B)
#define REG_SC_BK8A_6C_L      _PK_L_(0x8A, 0x6C)
#define REG_SC_BK8A_6C_H      _PK_H_(0x8A, 0x6C)
#define REG_SC_BK8A_6D_L      _PK_L_(0x8A, 0x6D)
#define REG_SC_BK8A_6D_H      _PK_H_(0x8A, 0x6D)
#define REG_SC_BK8A_6E_L      _PK_L_(0x8A, 0x6E)
#define REG_SC_BK8A_6E_H      _PK_H_(0x8A, 0x6E)
#define REG_SC_BK8A_6F_L      _PK_L_(0x8A, 0x6F)
#define REG_SC_BK8A_6F_H      _PK_H_(0x8A, 0x6F)
#define REG_SC_BK8A_70_L      _PK_L_(0x8A, 0x70)
#define REG_SC_BK8A_70_H      _PK_H_(0x8A, 0x70)
#define REG_SC_BK8A_71_L      _PK_L_(0x8A, 0x71)
#define REG_SC_BK8A_71_H      _PK_H_(0x8A, 0x71)
#define REG_SC_BK8A_72_L      _PK_L_(0x8A, 0x72)
#define REG_SC_BK8A_72_H      _PK_H_(0x8A, 0x72)
#define REG_SC_BK8A_73_L      _PK_L_(0x8A, 0x73)
#define REG_SC_BK8A_73_H      _PK_H_(0x8A, 0x73)
#define REG_SC_BK8A_74_L      _PK_L_(0x8A, 0x74)
#define REG_SC_BK8A_74_H      _PK_H_(0x8A, 0x74)
#define REG_SC_BK8A_75_L      _PK_L_(0x8A, 0x75)
#define REG_SC_BK8A_75_H      _PK_H_(0x8A, 0x75)
#define REG_SC_BK8A_76_L      _PK_L_(0x8A, 0x76)
#define REG_SC_BK8A_76_H      _PK_H_(0x8A, 0x76)
#define REG_SC_BK8A_77_L      _PK_L_(0x8A, 0x77)
#define REG_SC_BK8A_77_H      _PK_H_(0x8A, 0x77)
#define REG_SC_BK8A_78_L      _PK_L_(0x8A, 0x78)
#define REG_SC_BK8A_78_H      _PK_H_(0x8A, 0x78)
#define REG_SC_BK8A_79_L      _PK_L_(0x8A, 0x79)
#define REG_SC_BK8A_79_H      _PK_H_(0x8A, 0x79)
#define REG_SC_BK8A_7A_L      _PK_L_(0x8A, 0x7A)
#define REG_SC_BK8A_7A_H      _PK_H_(0x8A, 0x7A)
#define REG_SC_BK8A_7B_L      _PK_L_(0x8A, 0x7B)
#define REG_SC_BK8A_7B_H      _PK_H_(0x8A, 0x7B)
#define REG_SC_BK8A_7C_L      _PK_L_(0x8A, 0x7C)
#define REG_SC_BK8A_7C_H      _PK_H_(0x8A, 0x7C)
#define REG_SC_BK8A_7D_L      _PK_L_(0x8A, 0x7D)
#define REG_SC_BK8A_7D_H      _PK_H_(0x8A, 0x7D)
#define REG_SC_BK8A_7E_L      _PK_L_(0x8A, 0x7E)
#define REG_SC_BK8A_7E_H      _PK_H_(0x8A, 0x7E)
#define REG_SC_BK8A_7F_L      _PK_L_(0x8A, 0x7F)
#define REG_SC_BK8A_7F_H      _PK_H_(0x8A, 0x7F)
//----------------------------------------------
#define REG_SC_BK8B_00_L      _PK_L_(0x8B, 0x00)
#define REG_SC_BK8B_00_H      _PK_H_(0x8B, 0x00)
#define REG_SC_BK8B_01_L      _PK_L_(0x8B, 0x01)
#define REG_SC_BK8B_01_H      _PK_H_(0x8B, 0x01)
#define REG_SC_BK8B_02_L      _PK_L_(0x8B, 0x02)
#define REG_SC_BK8B_02_H      _PK_H_(0x8B, 0x02)
#define REG_SC_BK8B_03_L      _PK_L_(0x8B, 0x03)
#define REG_SC_BK8B_03_H      _PK_H_(0x8B, 0x03)
#define REG_SC_BK8B_04_L      _PK_L_(0x8B, 0x04)
#define REG_SC_BK8B_04_H      _PK_H_(0x8B, 0x04)
#define REG_SC_BK8B_05_L      _PK_L_(0x8B, 0x05)
#define REG_SC_BK8B_05_H      _PK_H_(0x8B, 0x05)
#define REG_SC_BK8B_06_L      _PK_L_(0x8B, 0x06)
#define REG_SC_BK8B_06_H      _PK_H_(0x8B, 0x06)
#define REG_SC_BK8B_07_L      _PK_L_(0x8B, 0x07)
#define REG_SC_BK8B_07_H      _PK_H_(0x8B, 0x07)
#define REG_SC_BK8B_08_L      _PK_L_(0x8B, 0x08)
#define REG_SC_BK8B_08_H      _PK_H_(0x8B, 0x08)
#define REG_SC_BK8B_09_L      _PK_L_(0x8B, 0x09)
#define REG_SC_BK8B_09_H      _PK_H_(0x8B, 0x09)
#define REG_SC_BK8B_0A_L      _PK_L_(0x8B, 0x0A)
#define REG_SC_BK8B_0A_H      _PK_H_(0x8B, 0x0A)
#define REG_SC_BK8B_0B_L      _PK_L_(0x8B, 0x0B)
#define REG_SC_BK8B_0B_H      _PK_H_(0x8B, 0x0B)
#define REG_SC_BK8B_0C_L      _PK_L_(0x8B, 0x0C)
#define REG_SC_BK8B_0C_H      _PK_H_(0x8B, 0x0C)
#define REG_SC_BK8B_0D_L      _PK_L_(0x8B, 0x0D)
#define REG_SC_BK8B_0D_H      _PK_H_(0x8B, 0x0D)
#define REG_SC_BK8B_0E_L      _PK_L_(0x8B, 0x0E)
#define REG_SC_BK8B_0E_H      _PK_H_(0x8B, 0x0E)
#define REG_SC_BK8B_0F_L      _PK_L_(0x8B, 0x0F)
#define REG_SC_BK8B_0F_H      _PK_H_(0x8B, 0x0F)
#define REG_SC_BK8B_10_L      _PK_L_(0x8B, 0x10)
#define REG_SC_BK8B_10_H      _PK_H_(0x8B, 0x10)
#define REG_SC_BK8B_11_L      _PK_L_(0x8B, 0x11)
#define REG_SC_BK8B_11_H      _PK_H_(0x8B, 0x11)
#define REG_SC_BK8B_12_L      _PK_L_(0x8B, 0x12)
#define REG_SC_BK8B_12_H      _PK_H_(0x8B, 0x12)
#define REG_SC_BK8B_13_L      _PK_L_(0x8B, 0x13)
#define REG_SC_BK8B_13_H      _PK_H_(0x8B, 0x13)
#define REG_SC_BK8B_14_L      _PK_L_(0x8B, 0x14)
#define REG_SC_BK8B_14_H      _PK_H_(0x8B, 0x14)
#define REG_SC_BK8B_15_L      _PK_L_(0x8B, 0x15)
#define REG_SC_BK8B_15_H      _PK_H_(0x8B, 0x15)
#define REG_SC_BK8B_16_L      _PK_L_(0x8B, 0x16)
#define REG_SC_BK8B_16_H      _PK_H_(0x8B, 0x16)
#define REG_SC_BK8B_17_L      _PK_L_(0x8B, 0x17)
#define REG_SC_BK8B_17_H      _PK_H_(0x8B, 0x17)
#define REG_SC_BK8B_18_L      _PK_L_(0x8B, 0x18)
#define REG_SC_BK8B_18_H      _PK_H_(0x8B, 0x18)
#define REG_SC_BK8B_19_L      _PK_L_(0x8B, 0x19)
#define REG_SC_BK8B_19_H      _PK_H_(0x8B, 0x19)
#define REG_SC_BK8B_1A_L      _PK_L_(0x8B, 0x1A)
#define REG_SC_BK8B_1A_H      _PK_H_(0x8B, 0x1A)
#define REG_SC_BK8B_1B_L      _PK_L_(0x8B, 0x1B)
#define REG_SC_BK8B_1B_H      _PK_H_(0x8B, 0x1B)
#define REG_SC_BK8B_1C_L      _PK_L_(0x8B, 0x1C)
#define REG_SC_BK8B_1C_H      _PK_H_(0x8B, 0x1C)
#define REG_SC_BK8B_1D_L      _PK_L_(0x8B, 0x1D)
#define REG_SC_BK8B_1D_H      _PK_H_(0x8B, 0x1D)
#define REG_SC_BK8B_1E_L      _PK_L_(0x8B, 0x1E)
#define REG_SC_BK8B_1E_H      _PK_H_(0x8B, 0x1E)
#define REG_SC_BK8B_1F_L      _PK_L_(0x8B, 0x1F)
#define REG_SC_BK8B_1F_H      _PK_H_(0x8B, 0x1F)
#define REG_SC_BK8B_20_L      _PK_L_(0x8B, 0x20)
#define REG_SC_BK8B_20_H      _PK_H_(0x8B, 0x20)
#define REG_SC_BK8B_21_L      _PK_L_(0x8B, 0x21)
#define REG_SC_BK8B_21_H      _PK_H_(0x8B, 0x21)
#define REG_SC_BK8B_22_L      _PK_L_(0x8B, 0x22)
#define REG_SC_BK8B_22_H      _PK_H_(0x8B, 0x22)
#define REG_SC_BK8B_23_L      _PK_L_(0x8B, 0x23)
#define REG_SC_BK8B_23_H      _PK_H_(0x8B, 0x23)
#define REG_SC_BK8B_24_L      _PK_L_(0x8B, 0x24)
#define REG_SC_BK8B_24_H      _PK_H_(0x8B, 0x24)
#define REG_SC_BK8B_25_L      _PK_L_(0x8B, 0x25)
#define REG_SC_BK8B_25_H      _PK_H_(0x8B, 0x25)
#define REG_SC_BK8B_26_L      _PK_L_(0x8B, 0x26)
#define REG_SC_BK8B_26_H      _PK_H_(0x8B, 0x26)
#define REG_SC_BK8B_27_L      _PK_L_(0x8B, 0x27)
#define REG_SC_BK8B_27_H      _PK_H_(0x8B, 0x27)
#define REG_SC_BK8B_28_L      _PK_L_(0x8B, 0x28)
#define REG_SC_BK8B_28_H      _PK_H_(0x8B, 0x28)
#define REG_SC_BK8B_29_L      _PK_L_(0x8B, 0x29)
#define REG_SC_BK8B_29_H      _PK_H_(0x8B, 0x29)
#define REG_SC_BK8B_2A_L      _PK_L_(0x8B, 0x2A)
#define REG_SC_BK8B_2A_H      _PK_H_(0x8B, 0x2A)
#define REG_SC_BK8B_2B_L      _PK_L_(0x8B, 0x2B)
#define REG_SC_BK8B_2B_H      _PK_H_(0x8B, 0x2B)
#define REG_SC_BK8B_2C_L      _PK_L_(0x8B, 0x2C)
#define REG_SC_BK8B_2C_H      _PK_H_(0x8B, 0x2C)
#define REG_SC_BK8B_2D_L      _PK_L_(0x8B, 0x2D)
#define REG_SC_BK8B_2D_H      _PK_H_(0x8B, 0x2D)
#define REG_SC_BK8B_2E_L      _PK_L_(0x8B, 0x2E)
#define REG_SC_BK8B_2E_H      _PK_H_(0x8B, 0x2E)
#define REG_SC_BK8B_2F_L      _PK_L_(0x8B, 0x2F)
#define REG_SC_BK8B_2F_H      _PK_H_(0x8B, 0x2F)
#define REG_SC_BK8B_30_L      _PK_L_(0x8B, 0x30)
#define REG_SC_BK8B_30_H      _PK_H_(0x8B, 0x30)
#define REG_SC_BK8B_31_L      _PK_L_(0x8B, 0x31)
#define REG_SC_BK8B_31_H      _PK_H_(0x8B, 0x31)
#define REG_SC_BK8B_32_L      _PK_L_(0x8B, 0x32)
#define REG_SC_BK8B_32_H      _PK_H_(0x8B, 0x32)
#define REG_SC_BK8B_33_L      _PK_L_(0x8B, 0x33)
#define REG_SC_BK8B_33_H      _PK_H_(0x8B, 0x33)
#define REG_SC_BK8B_34_L      _PK_L_(0x8B, 0x34)
#define REG_SC_BK8B_34_H      _PK_H_(0x8B, 0x34)
#define REG_SC_BK8B_35_L      _PK_L_(0x8B, 0x35)
#define REG_SC_BK8B_35_H      _PK_H_(0x8B, 0x35)
#define REG_SC_BK8B_36_L      _PK_L_(0x8B, 0x36)
#define REG_SC_BK8B_36_H      _PK_H_(0x8B, 0x36)
#define REG_SC_BK8B_37_L      _PK_L_(0x8B, 0x37)
#define REG_SC_BK8B_37_H      _PK_H_(0x8B, 0x37)
#define REG_SC_BK8B_38_L      _PK_L_(0x8B, 0x38)
#define REG_SC_BK8B_38_H      _PK_H_(0x8B, 0x38)
#define REG_SC_BK8B_39_L      _PK_L_(0x8B, 0x39)
#define REG_SC_BK8B_39_H      _PK_H_(0x8B, 0x39)
#define REG_SC_BK8B_3A_L      _PK_L_(0x8B, 0x3A)
#define REG_SC_BK8B_3A_H      _PK_H_(0x8B, 0x3A)
#define REG_SC_BK8B_3B_L      _PK_L_(0x8B, 0x3B)
#define REG_SC_BK8B_3B_H      _PK_H_(0x8B, 0x3B)
#define REG_SC_BK8B_3C_L      _PK_L_(0x8B, 0x3C)
#define REG_SC_BK8B_3C_H      _PK_H_(0x8B, 0x3C)
#define REG_SC_BK8B_3D_L      _PK_L_(0x8B, 0x3D)
#define REG_SC_BK8B_3D_H      _PK_H_(0x8B, 0x3D)
#define REG_SC_BK8B_3E_L      _PK_L_(0x8B, 0x3E)
#define REG_SC_BK8B_3E_H      _PK_H_(0x8B, 0x3E)
#define REG_SC_BK8B_3F_L      _PK_L_(0x8B, 0x3F)
#define REG_SC_BK8B_3F_H      _PK_H_(0x8B, 0x3F)
#define REG_SC_BK8B_40_L      _PK_L_(0x8B, 0x40)
#define REG_SC_BK8B_40_H      _PK_H_(0x8B, 0x40)
#define REG_SC_BK8B_41_L      _PK_L_(0x8B, 0x41)
#define REG_SC_BK8B_41_H      _PK_H_(0x8B, 0x41)
#define REG_SC_BK8B_42_L      _PK_L_(0x8B, 0x42)
#define REG_SC_BK8B_42_H      _PK_H_(0x8B, 0x42)
#define REG_SC_BK8B_43_L      _PK_L_(0x8B, 0x43)
#define REG_SC_BK8B_43_H      _PK_H_(0x8B, 0x43)
#define REG_SC_BK8B_44_L      _PK_L_(0x8B, 0x44)
#define REG_SC_BK8B_44_H      _PK_H_(0x8B, 0x44)
#define REG_SC_BK8B_45_L      _PK_L_(0x8B, 0x45)
#define REG_SC_BK8B_45_H      _PK_H_(0x8B, 0x45)
#define REG_SC_BK8B_46_L      _PK_L_(0x8B, 0x46)
#define REG_SC_BK8B_46_H      _PK_H_(0x8B, 0x46)
#define REG_SC_BK8B_47_L      _PK_L_(0x8B, 0x47)
#define REG_SC_BK8B_47_H      _PK_H_(0x8B, 0x47)
#define REG_SC_BK8B_48_L      _PK_L_(0x8B, 0x48)
#define REG_SC_BK8B_48_H      _PK_H_(0x8B, 0x48)
#define REG_SC_BK8B_49_L      _PK_L_(0x8B, 0x49)
#define REG_SC_BK8B_49_H      _PK_H_(0x8B, 0x49)
#define REG_SC_BK8B_4A_L      _PK_L_(0x8B, 0x4A)
#define REG_SC_BK8B_4A_H      _PK_H_(0x8B, 0x4A)
#define REG_SC_BK8B_4B_L      _PK_L_(0x8B, 0x4B)
#define REG_SC_BK8B_4B_H      _PK_H_(0x8B, 0x4B)
#define REG_SC_BK8B_4C_L      _PK_L_(0x8B, 0x4C)
#define REG_SC_BK8B_4C_H      _PK_H_(0x8B, 0x4C)
#define REG_SC_BK8B_4D_L      _PK_L_(0x8B, 0x4D)
#define REG_SC_BK8B_4D_H      _PK_H_(0x8B, 0x4D)
#define REG_SC_BK8B_4E_L      _PK_L_(0x8B, 0x4E)
#define REG_SC_BK8B_4E_H      _PK_H_(0x8B, 0x4E)
#define REG_SC_BK8B_4F_L      _PK_L_(0x8B, 0x4F)
#define REG_SC_BK8B_4F_H      _PK_H_(0x8B, 0x4F)
#define REG_SC_BK8B_50_L      _PK_L_(0x8B, 0x50)
#define REG_SC_BK8B_50_H      _PK_H_(0x8B, 0x50)
#define REG_SC_BK8B_51_L      _PK_L_(0x8B, 0x51)
#define REG_SC_BK8B_51_H      _PK_H_(0x8B, 0x51)
#define REG_SC_BK8B_52_L      _PK_L_(0x8B, 0x52)
#define REG_SC_BK8B_52_H      _PK_H_(0x8B, 0x52)
#define REG_SC_BK8B_53_L      _PK_L_(0x8B, 0x53)
#define REG_SC_BK8B_53_H      _PK_H_(0x8B, 0x53)
#define REG_SC_BK8B_54_L      _PK_L_(0x8B, 0x54)
#define REG_SC_BK8B_54_H      _PK_H_(0x8B, 0x54)
#define REG_SC_BK8B_55_L      _PK_L_(0x8B, 0x55)
#define REG_SC_BK8B_55_H      _PK_H_(0x8B, 0x55)
#define REG_SC_BK8B_56_L      _PK_L_(0x8B, 0x56)
#define REG_SC_BK8B_56_H      _PK_H_(0x8B, 0x56)
#define REG_SC_BK8B_57_L      _PK_L_(0x8B, 0x57)
#define REG_SC_BK8B_57_H      _PK_H_(0x8B, 0x57)
#define REG_SC_BK8B_58_L      _PK_L_(0x8B, 0x58)
#define REG_SC_BK8B_58_H      _PK_H_(0x8B, 0x58)
#define REG_SC_BK8B_59_L      _PK_L_(0x8B, 0x59)
#define REG_SC_BK8B_59_H      _PK_H_(0x8B, 0x59)
#define REG_SC_BK8B_5A_L      _PK_L_(0x8B, 0x5A)
#define REG_SC_BK8B_5A_H      _PK_H_(0x8B, 0x5A)
#define REG_SC_BK8B_5B_L      _PK_L_(0x8B, 0x5B)
#define REG_SC_BK8B_5B_H      _PK_H_(0x8B, 0x5B)
#define REG_SC_BK8B_5C_L      _PK_L_(0x8B, 0x5C)
#define REG_SC_BK8B_5C_H      _PK_H_(0x8B, 0x5C)
#define REG_SC_BK8B_5D_L      _PK_L_(0x8B, 0x5D)
#define REG_SC_BK8B_5D_H      _PK_H_(0x8B, 0x5D)
#define REG_SC_BK8B_5E_L      _PK_L_(0x8B, 0x5E)
#define REG_SC_BK8B_5E_H      _PK_H_(0x8B, 0x5E)
#define REG_SC_BK8B_5F_L      _PK_L_(0x8B, 0x5F)
#define REG_SC_BK8B_5F_H      _PK_H_(0x8B, 0x5F)
#define REG_SC_BK8B_60_L      _PK_L_(0x8B, 0x60)
#define REG_SC_BK8B_60_H      _PK_H_(0x8B, 0x60)
#define REG_SC_BK8B_61_L      _PK_L_(0x8B, 0x61)
#define REG_SC_BK8B_61_H      _PK_H_(0x8B, 0x61)
#define REG_SC_BK8B_62_L      _PK_L_(0x8B, 0x62)
#define REG_SC_BK8B_62_H      _PK_H_(0x8B, 0x62)
#define REG_SC_BK8B_63_L      _PK_L_(0x8B, 0x63)
#define REG_SC_BK8B_63_H      _PK_H_(0x8B, 0x63)
#define REG_SC_BK8B_64_L      _PK_L_(0x8B, 0x64)
#define REG_SC_BK8B_64_H      _PK_H_(0x8B, 0x64)
#define REG_SC_BK8B_65_L      _PK_L_(0x8B, 0x65)
#define REG_SC_BK8B_65_H      _PK_H_(0x8B, 0x65)
#define REG_SC_BK8B_66_L      _PK_L_(0x8B, 0x66)
#define REG_SC_BK8B_66_H      _PK_H_(0x8B, 0x66)
#define REG_SC_BK8B_67_L      _PK_L_(0x8B, 0x67)
#define REG_SC_BK8B_67_H      _PK_H_(0x8B, 0x67)
#define REG_SC_BK8B_68_L      _PK_L_(0x8B, 0x68)
#define REG_SC_BK8B_68_H      _PK_H_(0x8B, 0x68)
#define REG_SC_BK8B_69_L      _PK_L_(0x8B, 0x69)
#define REG_SC_BK8B_69_H      _PK_H_(0x8B, 0x69)
#define REG_SC_BK8B_6A_L      _PK_L_(0x8B, 0x6A)
#define REG_SC_BK8B_6A_H      _PK_H_(0x8B, 0x6A)
#define REG_SC_BK8B_6B_L      _PK_L_(0x8B, 0x6B)
#define REG_SC_BK8B_6B_H      _PK_H_(0x8B, 0x6B)
#define REG_SC_BK8B_6C_L      _PK_L_(0x8B, 0x6C)
#define REG_SC_BK8B_6C_H      _PK_H_(0x8B, 0x6C)
#define REG_SC_BK8B_6D_L      _PK_L_(0x8B, 0x6D)
#define REG_SC_BK8B_6D_H      _PK_H_(0x8B, 0x6D)
#define REG_SC_BK8B_6E_L      _PK_L_(0x8B, 0x6E)
#define REG_SC_BK8B_6E_H      _PK_H_(0x8B, 0x6E)
#define REG_SC_BK8B_6F_L      _PK_L_(0x8B, 0x6F)
#define REG_SC_BK8B_6F_H      _PK_H_(0x8B, 0x6F)
#define REG_SC_BK8B_70_L      _PK_L_(0x8B, 0x70)
#define REG_SC_BK8B_70_H      _PK_H_(0x8B, 0x70)
#define REG_SC_BK8B_71_L      _PK_L_(0x8B, 0x71)
#define REG_SC_BK8B_71_H      _PK_H_(0x8B, 0x71)
#define REG_SC_BK8B_72_L      _PK_L_(0x8B, 0x72)
#define REG_SC_BK8B_72_H      _PK_H_(0x8B, 0x72)
#define REG_SC_BK8B_73_L      _PK_L_(0x8B, 0x73)
#define REG_SC_BK8B_73_H      _PK_H_(0x8B, 0x73)
#define REG_SC_BK8B_74_L      _PK_L_(0x8B, 0x74)
#define REG_SC_BK8B_74_H      _PK_H_(0x8B, 0x74)
#define REG_SC_BK8B_75_L      _PK_L_(0x8B, 0x75)
#define REG_SC_BK8B_75_H      _PK_H_(0x8B, 0x75)
#define REG_SC_BK8B_76_L      _PK_L_(0x8B, 0x76)
#define REG_SC_BK8B_76_H      _PK_H_(0x8B, 0x76)
#define REG_SC_BK8B_77_L      _PK_L_(0x8B, 0x77)
#define REG_SC_BK8B_77_H      _PK_H_(0x8B, 0x77)
#define REG_SC_BK8B_78_L      _PK_L_(0x8B, 0x78)
#define REG_SC_BK8B_78_H      _PK_H_(0x8B, 0x78)
#define REG_SC_BK8B_79_L      _PK_L_(0x8B, 0x79)
#define REG_SC_BK8B_79_H      _PK_H_(0x8B, 0x79)
#define REG_SC_BK8B_7A_L      _PK_L_(0x8B, 0x7A)
#define REG_SC_BK8B_7A_H      _PK_H_(0x8B, 0x7A)
#define REG_SC_BK8B_7B_L      _PK_L_(0x8B, 0x7B)
#define REG_SC_BK8B_7B_H      _PK_H_(0x8B, 0x7B)
#define REG_SC_BK8B_7C_L      _PK_L_(0x8B, 0x7C)
#define REG_SC_BK8B_7C_H      _PK_H_(0x8B, 0x7C)
#define REG_SC_BK8B_7D_L      _PK_L_(0x8B, 0x7D)
#define REG_SC_BK8B_7D_H      _PK_H_(0x8B, 0x7D)
#define REG_SC_BK8B_7E_L      _PK_L_(0x8B, 0x7E)
#define REG_SC_BK8B_7E_H      _PK_H_(0x8B, 0x7E)
#define REG_SC_BK8B_7F_L      _PK_L_(0x8B, 0x7F)
#define REG_SC_BK8B_7F_H      _PK_H_(0x8B, 0x7F)
//----------------------------------------------
#define REG_SC_BK8C_00_L      _PK_L_(0x8C, 0x00)
#define REG_SC_BK8C_00_H      _PK_H_(0x8C, 0x00)
#define REG_SC_BK8C_01_L      _PK_L_(0x8C, 0x01)
#define REG_SC_BK8C_01_H      _PK_H_(0x8C, 0x01)
#define REG_SC_BK8C_02_L      _PK_L_(0x8C, 0x02)
#define REG_SC_BK8C_02_H      _PK_H_(0x8C, 0x02)
#define REG_SC_BK8C_03_L      _PK_L_(0x8C, 0x03)
#define REG_SC_BK8C_03_H      _PK_H_(0x8C, 0x03)
#define REG_SC_BK8C_04_L      _PK_L_(0x8C, 0x04)
#define REG_SC_BK8C_04_H      _PK_H_(0x8C, 0x04)
#define REG_SC_BK8C_05_L      _PK_L_(0x8C, 0x05)
#define REG_SC_BK8C_05_H      _PK_H_(0x8C, 0x05)
#define REG_SC_BK8C_06_L      _PK_L_(0x8C, 0x06)
#define REG_SC_BK8C_06_H      _PK_H_(0x8C, 0x06)
#define REG_SC_BK8C_07_L      _PK_L_(0x8C, 0x07)
#define REG_SC_BK8C_07_H      _PK_H_(0x8C, 0x07)
#define REG_SC_BK8C_08_L      _PK_L_(0x8C, 0x08)
#define REG_SC_BK8C_08_H      _PK_H_(0x8C, 0x08)
#define REG_SC_BK8C_09_L      _PK_L_(0x8C, 0x09)
#define REG_SC_BK8C_09_H      _PK_H_(0x8C, 0x09)
#define REG_SC_BK8C_0A_L      _PK_L_(0x8C, 0x0A)
#define REG_SC_BK8C_0A_H      _PK_H_(0x8C, 0x0A)
#define REG_SC_BK8C_0B_L      _PK_L_(0x8C, 0x0B)
#define REG_SC_BK8C_0B_H      _PK_H_(0x8C, 0x0B)
#define REG_SC_BK8C_0C_L      _PK_L_(0x8C, 0x0C)
#define REG_SC_BK8C_0C_H      _PK_H_(0x8C, 0x0C)
#define REG_SC_BK8C_0D_L      _PK_L_(0x8C, 0x0D)
#define REG_SC_BK8C_0D_H      _PK_H_(0x8C, 0x0D)
#define REG_SC_BK8C_0E_L      _PK_L_(0x8C, 0x0E)
#define REG_SC_BK8C_0E_H      _PK_H_(0x8C, 0x0E)
#define REG_SC_BK8C_0F_L      _PK_L_(0x8C, 0x0F)
#define REG_SC_BK8C_0F_H      _PK_H_(0x8C, 0x0F)
#define REG_SC_BK8C_10_L      _PK_L_(0x8C, 0x10)
#define REG_SC_BK8C_10_H      _PK_H_(0x8C, 0x10)
#define REG_SC_BK8C_11_L      _PK_L_(0x8C, 0x11)
#define REG_SC_BK8C_11_H      _PK_H_(0x8C, 0x11)
#define REG_SC_BK8C_12_L      _PK_L_(0x8C, 0x12)
#define REG_SC_BK8C_12_H      _PK_H_(0x8C, 0x12)
#define REG_SC_BK8C_13_L      _PK_L_(0x8C, 0x13)
#define REG_SC_BK8C_13_H      _PK_H_(0x8C, 0x13)
#define REG_SC_BK8C_14_L      _PK_L_(0x8C, 0x14)
#define REG_SC_BK8C_14_H      _PK_H_(0x8C, 0x14)
#define REG_SC_BK8C_15_L      _PK_L_(0x8C, 0x15)
#define REG_SC_BK8C_15_H      _PK_H_(0x8C, 0x15)
#define REG_SC_BK8C_16_L      _PK_L_(0x8C, 0x16)
#define REG_SC_BK8C_16_H      _PK_H_(0x8C, 0x16)
#define REG_SC_BK8C_17_L      _PK_L_(0x8C, 0x17)
#define REG_SC_BK8C_17_H      _PK_H_(0x8C, 0x17)
#define REG_SC_BK8C_18_L      _PK_L_(0x8C, 0x18)
#define REG_SC_BK8C_18_H      _PK_H_(0x8C, 0x18)
#define REG_SC_BK8C_19_L      _PK_L_(0x8C, 0x19)
#define REG_SC_BK8C_19_H      _PK_H_(0x8C, 0x19)
#define REG_SC_BK8C_1A_L      _PK_L_(0x8C, 0x1A)
#define REG_SC_BK8C_1A_H      _PK_H_(0x8C, 0x1A)
#define REG_SC_BK8C_1B_L      _PK_L_(0x8C, 0x1B)
#define REG_SC_BK8C_1B_H      _PK_H_(0x8C, 0x1B)
#define REG_SC_BK8C_1C_L      _PK_L_(0x8C, 0x1C)
#define REG_SC_BK8C_1C_H      _PK_H_(0x8C, 0x1C)
#define REG_SC_BK8C_1D_L      _PK_L_(0x8C, 0x1D)
#define REG_SC_BK8C_1D_H      _PK_H_(0x8C, 0x1D)
#define REG_SC_BK8C_1E_L      _PK_L_(0x8C, 0x1E)
#define REG_SC_BK8C_1E_H      _PK_H_(0x8C, 0x1E)
#define REG_SC_BK8C_1F_L      _PK_L_(0x8C, 0x1F)
#define REG_SC_BK8C_1F_H      _PK_H_(0x8C, 0x1F)
#define REG_SC_BK8C_20_L      _PK_L_(0x8C, 0x20)
#define REG_SC_BK8C_20_H      _PK_H_(0x8C, 0x20)
#define REG_SC_BK8C_21_L      _PK_L_(0x8C, 0x21)
#define REG_SC_BK8C_21_H      _PK_H_(0x8C, 0x21)
#define REG_SC_BK8C_22_L      _PK_L_(0x8C, 0x22)
#define REG_SC_BK8C_22_H      _PK_H_(0x8C, 0x22)
#define REG_SC_BK8C_23_L      _PK_L_(0x8C, 0x23)
#define REG_SC_BK8C_23_H      _PK_H_(0x8C, 0x23)
#define REG_SC_BK8C_24_L      _PK_L_(0x8C, 0x24)
#define REG_SC_BK8C_24_H      _PK_H_(0x8C, 0x24)
#define REG_SC_BK8C_25_L      _PK_L_(0x8C, 0x25)
#define REG_SC_BK8C_25_H      _PK_H_(0x8C, 0x25)
#define REG_SC_BK8C_26_L      _PK_L_(0x8C, 0x26)
#define REG_SC_BK8C_26_H      _PK_H_(0x8C, 0x26)
#define REG_SC_BK8C_27_L      _PK_L_(0x8C, 0x27)
#define REG_SC_BK8C_27_H      _PK_H_(0x8C, 0x27)
#define REG_SC_BK8C_28_L      _PK_L_(0x8C, 0x28)
#define REG_SC_BK8C_28_H      _PK_H_(0x8C, 0x28)
#define REG_SC_BK8C_29_L      _PK_L_(0x8C, 0x29)
#define REG_SC_BK8C_29_H      _PK_H_(0x8C, 0x29)
#define REG_SC_BK8C_2A_L      _PK_L_(0x8C, 0x2A)
#define REG_SC_BK8C_2A_H      _PK_H_(0x8C, 0x2A)
#define REG_SC_BK8C_2B_L      _PK_L_(0x8C, 0x2B)
#define REG_SC_BK8C_2B_H      _PK_H_(0x8C, 0x2B)
#define REG_SC_BK8C_2C_L      _PK_L_(0x8C, 0x2C)
#define REG_SC_BK8C_2C_H      _PK_H_(0x8C, 0x2C)
#define REG_SC_BK8C_2D_L      _PK_L_(0x8C, 0x2D)
#define REG_SC_BK8C_2D_H      _PK_H_(0x8C, 0x2D)
#define REG_SC_BK8C_2E_L      _PK_L_(0x8C, 0x2E)
#define REG_SC_BK8C_2E_H      _PK_H_(0x8C, 0x2E)
#define REG_SC_BK8C_2F_L      _PK_L_(0x8C, 0x2F)
#define REG_SC_BK8C_2F_H      _PK_H_(0x8C, 0x2F)
#define REG_SC_BK8C_30_L      _PK_L_(0x8C, 0x30)
#define REG_SC_BK8C_30_H      _PK_H_(0x8C, 0x30)
#define REG_SC_BK8C_31_L      _PK_L_(0x8C, 0x31)
#define REG_SC_BK8C_31_H      _PK_H_(0x8C, 0x31)
#define REG_SC_BK8C_32_L      _PK_L_(0x8C, 0x32)
#define REG_SC_BK8C_32_H      _PK_H_(0x8C, 0x32)
#define REG_SC_BK8C_33_L      _PK_L_(0x8C, 0x33)
#define REG_SC_BK8C_33_H      _PK_H_(0x8C, 0x33)
#define REG_SC_BK8C_34_L      _PK_L_(0x8C, 0x34)
#define REG_SC_BK8C_34_H      _PK_H_(0x8C, 0x34)
#define REG_SC_BK8C_35_L      _PK_L_(0x8C, 0x35)
#define REG_SC_BK8C_35_H      _PK_H_(0x8C, 0x35)
#define REG_SC_BK8C_36_L      _PK_L_(0x8C, 0x36)
#define REG_SC_BK8C_36_H      _PK_H_(0x8C, 0x36)
#define REG_SC_BK8C_37_L      _PK_L_(0x8C, 0x37)
#define REG_SC_BK8C_37_H      _PK_H_(0x8C, 0x37)
#define REG_SC_BK8C_38_L      _PK_L_(0x8C, 0x38)
#define REG_SC_BK8C_38_H      _PK_H_(0x8C, 0x38)
#define REG_SC_BK8C_39_L      _PK_L_(0x8C, 0x39)
#define REG_SC_BK8C_39_H      _PK_H_(0x8C, 0x39)
#define REG_SC_BK8C_3A_L      _PK_L_(0x8C, 0x3A)
#define REG_SC_BK8C_3A_H      _PK_H_(0x8C, 0x3A)
#define REG_SC_BK8C_3B_L      _PK_L_(0x8C, 0x3B)
#define REG_SC_BK8C_3B_H      _PK_H_(0x8C, 0x3B)
#define REG_SC_BK8C_3C_L      _PK_L_(0x8C, 0x3C)
#define REG_SC_BK8C_3C_H      _PK_H_(0x8C, 0x3C)
#define REG_SC_BK8C_3D_L      _PK_L_(0x8C, 0x3D)
#define REG_SC_BK8C_3D_H      _PK_H_(0x8C, 0x3D)
#define REG_SC_BK8C_3E_L      _PK_L_(0x8C, 0x3E)
#define REG_SC_BK8C_3E_H      _PK_H_(0x8C, 0x3E)
#define REG_SC_BK8C_3F_L      _PK_L_(0x8C, 0x3F)
#define REG_SC_BK8C_3F_H      _PK_H_(0x8C, 0x3F)
#define REG_SC_BK8C_40_L      _PK_L_(0x8C, 0x40)
#define REG_SC_BK8C_40_H      _PK_H_(0x8C, 0x40)
#define REG_SC_BK8C_41_L      _PK_L_(0x8C, 0x41)
#define REG_SC_BK8C_41_H      _PK_H_(0x8C, 0x41)
#define REG_SC_BK8C_42_L      _PK_L_(0x8C, 0x42)
#define REG_SC_BK8C_42_H      _PK_H_(0x8C, 0x42)
#define REG_SC_BK8C_43_L      _PK_L_(0x8C, 0x43)
#define REG_SC_BK8C_43_H      _PK_H_(0x8C, 0x43)
#define REG_SC_BK8C_44_L      _PK_L_(0x8C, 0x44)
#define REG_SC_BK8C_44_H      _PK_H_(0x8C, 0x44)
#define REG_SC_BK8C_45_L      _PK_L_(0x8C, 0x45)
#define REG_SC_BK8C_45_H      _PK_H_(0x8C, 0x45)
#define REG_SC_BK8C_46_L      _PK_L_(0x8C, 0x46)
#define REG_SC_BK8C_46_H      _PK_H_(0x8C, 0x46)
#define REG_SC_BK8C_47_L      _PK_L_(0x8C, 0x47)
#define REG_SC_BK8C_47_H      _PK_H_(0x8C, 0x47)
#define REG_SC_BK8C_48_L      _PK_L_(0x8C, 0x48)
#define REG_SC_BK8C_48_H      _PK_H_(0x8C, 0x48)
#define REG_SC_BK8C_49_L      _PK_L_(0x8C, 0x49)
#define REG_SC_BK8C_49_H      _PK_H_(0x8C, 0x49)
#define REG_SC_BK8C_4A_L      _PK_L_(0x8C, 0x4A)
#define REG_SC_BK8C_4A_H      _PK_H_(0x8C, 0x4A)
#define REG_SC_BK8C_4B_L      _PK_L_(0x8C, 0x4B)
#define REG_SC_BK8C_4B_H      _PK_H_(0x8C, 0x4B)
#define REG_SC_BK8C_4C_L      _PK_L_(0x8C, 0x4C)
#define REG_SC_BK8C_4C_H      _PK_H_(0x8C, 0x4C)
#define REG_SC_BK8C_4D_L      _PK_L_(0x8C, 0x4D)
#define REG_SC_BK8C_4D_H      _PK_H_(0x8C, 0x4D)
#define REG_SC_BK8C_4E_L      _PK_L_(0x8C, 0x4E)
#define REG_SC_BK8C_4E_H      _PK_H_(0x8C, 0x4E)
#define REG_SC_BK8C_4F_L      _PK_L_(0x8C, 0x4F)
#define REG_SC_BK8C_4F_H      _PK_H_(0x8C, 0x4F)
#define REG_SC_BK8C_50_L      _PK_L_(0x8C, 0x50)
#define REG_SC_BK8C_50_H      _PK_H_(0x8C, 0x50)
#define REG_SC_BK8C_51_L      _PK_L_(0x8C, 0x51)
#define REG_SC_BK8C_51_H      _PK_H_(0x8C, 0x51)
#define REG_SC_BK8C_52_L      _PK_L_(0x8C, 0x52)
#define REG_SC_BK8C_52_H      _PK_H_(0x8C, 0x52)
#define REG_SC_BK8C_53_L      _PK_L_(0x8C, 0x53)
#define REG_SC_BK8C_53_H      _PK_H_(0x8C, 0x53)
#define REG_SC_BK8C_54_L      _PK_L_(0x8C, 0x54)
#define REG_SC_BK8C_54_H      _PK_H_(0x8C, 0x54)
#define REG_SC_BK8C_55_L      _PK_L_(0x8C, 0x55)
#define REG_SC_BK8C_55_H      _PK_H_(0x8C, 0x55)
#define REG_SC_BK8C_56_L      _PK_L_(0x8C, 0x56)
#define REG_SC_BK8C_56_H      _PK_H_(0x8C, 0x56)
#define REG_SC_BK8C_57_L      _PK_L_(0x8C, 0x57)
#define REG_SC_BK8C_57_H      _PK_H_(0x8C, 0x57)
#define REG_SC_BK8C_58_L      _PK_L_(0x8C, 0x58)
#define REG_SC_BK8C_58_H      _PK_H_(0x8C, 0x58)
#define REG_SC_BK8C_59_L      _PK_L_(0x8C, 0x59)
#define REG_SC_BK8C_59_H      _PK_H_(0x8C, 0x59)
#define REG_SC_BK8C_5A_L      _PK_L_(0x8C, 0x5A)
#define REG_SC_BK8C_5A_H      _PK_H_(0x8C, 0x5A)
#define REG_SC_BK8C_5B_L      _PK_L_(0x8C, 0x5B)
#define REG_SC_BK8C_5B_H      _PK_H_(0x8C, 0x5B)
#define REG_SC_BK8C_5C_L      _PK_L_(0x8C, 0x5C)
#define REG_SC_BK8C_5C_H      _PK_H_(0x8C, 0x5C)
#define REG_SC_BK8C_5D_L      _PK_L_(0x8C, 0x5D)
#define REG_SC_BK8C_5D_H      _PK_H_(0x8C, 0x5D)
#define REG_SC_BK8C_5E_L      _PK_L_(0x8C, 0x5E)
#define REG_SC_BK8C_5E_H      _PK_H_(0x8C, 0x5E)
#define REG_SC_BK8C_5F_L      _PK_L_(0x8C, 0x5F)
#define REG_SC_BK8C_5F_H      _PK_H_(0x8C, 0x5F)
#define REG_SC_BK8C_60_L      _PK_L_(0x8C, 0x60)
#define REG_SC_BK8C_60_H      _PK_H_(0x8C, 0x60)
#define REG_SC_BK8C_61_L      _PK_L_(0x8C, 0x61)
#define REG_SC_BK8C_61_H      _PK_H_(0x8C, 0x61)
#define REG_SC_BK8C_62_L      _PK_L_(0x8C, 0x62)
#define REG_SC_BK8C_62_H      _PK_H_(0x8C, 0x62)
#define REG_SC_BK8C_63_L      _PK_L_(0x8C, 0x63)
#define REG_SC_BK8C_63_H      _PK_H_(0x8C, 0x63)
#define REG_SC_BK8C_64_L      _PK_L_(0x8C, 0x64)
#define REG_SC_BK8C_64_H      _PK_H_(0x8C, 0x64)
#define REG_SC_BK8C_65_L      _PK_L_(0x8C, 0x65)
#define REG_SC_BK8C_65_H      _PK_H_(0x8C, 0x65)
#define REG_SC_BK8C_66_L      _PK_L_(0x8C, 0x66)
#define REG_SC_BK8C_66_H      _PK_H_(0x8C, 0x66)
#define REG_SC_BK8C_67_L      _PK_L_(0x8C, 0x67)
#define REG_SC_BK8C_67_H      _PK_H_(0x8C, 0x67)
#define REG_SC_BK8C_68_L      _PK_L_(0x8C, 0x68)
#define REG_SC_BK8C_68_H      _PK_H_(0x8C, 0x68)
#define REG_SC_BK8C_69_L      _PK_L_(0x8C, 0x69)
#define REG_SC_BK8C_69_H      _PK_H_(0x8C, 0x69)
#define REG_SC_BK8C_6A_L      _PK_L_(0x8C, 0x6A)
#define REG_SC_BK8C_6A_H      _PK_H_(0x8C, 0x6A)
#define REG_SC_BK8C_6B_L      _PK_L_(0x8C, 0x6B)
#define REG_SC_BK8C_6B_H      _PK_H_(0x8C, 0x6B)
#define REG_SC_BK8C_6C_L      _PK_L_(0x8C, 0x6C)
#define REG_SC_BK8C_6C_H      _PK_H_(0x8C, 0x6C)
#define REG_SC_BK8C_6D_L      _PK_L_(0x8C, 0x6D)
#define REG_SC_BK8C_6D_H      _PK_H_(0x8C, 0x6D)
#define REG_SC_BK8C_6E_L      _PK_L_(0x8C, 0x6E)
#define REG_SC_BK8C_6E_H      _PK_H_(0x8C, 0x6E)
#define REG_SC_BK8C_6F_L      _PK_L_(0x8C, 0x6F)
#define REG_SC_BK8C_6F_H      _PK_H_(0x8C, 0x6F)
#define REG_SC_BK8C_70_L      _PK_L_(0x8C, 0x70)
#define REG_SC_BK8C_70_H      _PK_H_(0x8C, 0x70)
#define REG_SC_BK8C_71_L      _PK_L_(0x8C, 0x71)
#define REG_SC_BK8C_71_H      _PK_H_(0x8C, 0x71)
#define REG_SC_BK8C_72_L      _PK_L_(0x8C, 0x72)
#define REG_SC_BK8C_72_H      _PK_H_(0x8C, 0x72)
#define REG_SC_BK8C_73_L      _PK_L_(0x8C, 0x73)
#define REG_SC_BK8C_73_H      _PK_H_(0x8C, 0x73)
#define REG_SC_BK8C_74_L      _PK_L_(0x8C, 0x74)
#define REG_SC_BK8C_74_H      _PK_H_(0x8C, 0x74)
#define REG_SC_BK8C_75_L      _PK_L_(0x8C, 0x75)
#define REG_SC_BK8C_75_H      _PK_H_(0x8C, 0x75)
#define REG_SC_BK8C_76_L      _PK_L_(0x8C, 0x76)
#define REG_SC_BK8C_76_H      _PK_H_(0x8C, 0x76)
#define REG_SC_BK8C_77_L      _PK_L_(0x8C, 0x77)
#define REG_SC_BK8C_77_H      _PK_H_(0x8C, 0x77)
#define REG_SC_BK8C_78_L      _PK_L_(0x8C, 0x78)
#define REG_SC_BK8C_78_H      _PK_H_(0x8C, 0x78)
#define REG_SC_BK8C_79_L      _PK_L_(0x8C, 0x79)
#define REG_SC_BK8C_79_H      _PK_H_(0x8C, 0x79)
#define REG_SC_BK8C_7A_L      _PK_L_(0x8C, 0x7A)
#define REG_SC_BK8C_7A_H      _PK_H_(0x8C, 0x7A)
#define REG_SC_BK8C_7B_L      _PK_L_(0x8C, 0x7B)
#define REG_SC_BK8C_7B_H      _PK_H_(0x8C, 0x7B)
#define REG_SC_BK8C_7C_L      _PK_L_(0x8C, 0x7C)
#define REG_SC_BK8C_7C_H      _PK_H_(0x8C, 0x7C)
#define REG_SC_BK8C_7D_L      _PK_L_(0x8C, 0x7D)
#define REG_SC_BK8C_7D_H      _PK_H_(0x8C, 0x7D)
#define REG_SC_BK8C_7E_L      _PK_L_(0x8C, 0x7E)
#define REG_SC_BK8C_7E_H      _PK_H_(0x8C, 0x7E)
#define REG_SC_BK8C_7F_L      _PK_L_(0x8C, 0x7F)
#define REG_SC_BK8C_7F_H      _PK_H_(0x8C, 0x7F)
//----------------------------------------------
#define REG_SC_BK8D_00_L      _PK_L_(0x8D, 0x00)
#define REG_SC_BK8D_00_H      _PK_H_(0x8D, 0x00)
#define REG_SC_BK8D_01_L      _PK_L_(0x8D, 0x01)
#define REG_SC_BK8D_01_H      _PK_H_(0x8D, 0x01)
#define REG_SC_BK8D_02_L      _PK_L_(0x8D, 0x02)
#define REG_SC_BK8D_02_H      _PK_H_(0x8D, 0x02)
#define REG_SC_BK8D_03_L      _PK_L_(0x8D, 0x03)
#define REG_SC_BK8D_03_H      _PK_H_(0x8D, 0x03)
#define REG_SC_BK8D_04_L      _PK_L_(0x8D, 0x04)
#define REG_SC_BK8D_04_H      _PK_H_(0x8D, 0x04)
#define REG_SC_BK8D_05_L      _PK_L_(0x8D, 0x05)
#define REG_SC_BK8D_05_H      _PK_H_(0x8D, 0x05)
#define REG_SC_BK8D_06_L      _PK_L_(0x8D, 0x06)
#define REG_SC_BK8D_06_H      _PK_H_(0x8D, 0x06)
#define REG_SC_BK8D_07_L      _PK_L_(0x8D, 0x07)
#define REG_SC_BK8D_07_H      _PK_H_(0x8D, 0x07)
#define REG_SC_BK8D_08_L      _PK_L_(0x8D, 0x08)
#define REG_SC_BK8D_08_H      _PK_H_(0x8D, 0x08)
#define REG_SC_BK8D_09_L      _PK_L_(0x8D, 0x09)
#define REG_SC_BK8D_09_H      _PK_H_(0x8D, 0x09)
#define REG_SC_BK8D_0A_L      _PK_L_(0x8D, 0x0A)
#define REG_SC_BK8D_0A_H      _PK_H_(0x8D, 0x0A)
#define REG_SC_BK8D_0B_L      _PK_L_(0x8D, 0x0B)
#define REG_SC_BK8D_0B_H      _PK_H_(0x8D, 0x0B)
#define REG_SC_BK8D_0C_L      _PK_L_(0x8D, 0x0C)
#define REG_SC_BK8D_0C_H      _PK_H_(0x8D, 0x0C)
#define REG_SC_BK8D_0D_L      _PK_L_(0x8D, 0x0D)
#define REG_SC_BK8D_0D_H      _PK_H_(0x8D, 0x0D)
#define REG_SC_BK8D_0E_L      _PK_L_(0x8D, 0x0E)
#define REG_SC_BK8D_0E_H      _PK_H_(0x8D, 0x0E)
#define REG_SC_BK8D_0F_L      _PK_L_(0x8D, 0x0F)
#define REG_SC_BK8D_0F_H      _PK_H_(0x8D, 0x0F)
#define REG_SC_BK8D_10_L      _PK_L_(0x8D, 0x10)
#define REG_SC_BK8D_10_H      _PK_H_(0x8D, 0x10)
#define REG_SC_BK8D_11_L      _PK_L_(0x8D, 0x11)
#define REG_SC_BK8D_11_H      _PK_H_(0x8D, 0x11)
#define REG_SC_BK8D_12_L      _PK_L_(0x8D, 0x12)
#define REG_SC_BK8D_12_H      _PK_H_(0x8D, 0x12)
#define REG_SC_BK8D_13_L      _PK_L_(0x8D, 0x13)
#define REG_SC_BK8D_13_H      _PK_H_(0x8D, 0x13)
#define REG_SC_BK8D_14_L      _PK_L_(0x8D, 0x14)
#define REG_SC_BK8D_14_H      _PK_H_(0x8D, 0x14)
#define REG_SC_BK8D_15_L      _PK_L_(0x8D, 0x15)
#define REG_SC_BK8D_15_H      _PK_H_(0x8D, 0x15)
#define REG_SC_BK8D_16_L      _PK_L_(0x8D, 0x16)
#define REG_SC_BK8D_16_H      _PK_H_(0x8D, 0x16)
#define REG_SC_BK8D_17_L      _PK_L_(0x8D, 0x17)
#define REG_SC_BK8D_17_H      _PK_H_(0x8D, 0x17)
#define REG_SC_BK8D_18_L      _PK_L_(0x8D, 0x18)
#define REG_SC_BK8D_18_H      _PK_H_(0x8D, 0x18)
#define REG_SC_BK8D_19_L      _PK_L_(0x8D, 0x19)
#define REG_SC_BK8D_19_H      _PK_H_(0x8D, 0x19)
#define REG_SC_BK8D_1A_L      _PK_L_(0x8D, 0x1A)
#define REG_SC_BK8D_1A_H      _PK_H_(0x8D, 0x1A)
#define REG_SC_BK8D_1B_L      _PK_L_(0x8D, 0x1B)
#define REG_SC_BK8D_1B_H      _PK_H_(0x8D, 0x1B)
#define REG_SC_BK8D_1C_L      _PK_L_(0x8D, 0x1C)
#define REG_SC_BK8D_1C_H      _PK_H_(0x8D, 0x1C)
#define REG_SC_BK8D_1D_L      _PK_L_(0x8D, 0x1D)
#define REG_SC_BK8D_1D_H      _PK_H_(0x8D, 0x1D)
#define REG_SC_BK8D_1E_L      _PK_L_(0x8D, 0x1E)
#define REG_SC_BK8D_1E_H      _PK_H_(0x8D, 0x1E)
#define REG_SC_BK8D_1F_L      _PK_L_(0x8D, 0x1F)
#define REG_SC_BK8D_1F_H      _PK_H_(0x8D, 0x1F)
#define REG_SC_BK8D_20_L      _PK_L_(0x8D, 0x20)
#define REG_SC_BK8D_20_H      _PK_H_(0x8D, 0x20)
#define REG_SC_BK8D_21_L      _PK_L_(0x8D, 0x21)
#define REG_SC_BK8D_21_H      _PK_H_(0x8D, 0x21)
#define REG_SC_BK8D_22_L      _PK_L_(0x8D, 0x22)
#define REG_SC_BK8D_22_H      _PK_H_(0x8D, 0x22)
#define REG_SC_BK8D_23_L      _PK_L_(0x8D, 0x23)
#define REG_SC_BK8D_23_H      _PK_H_(0x8D, 0x23)
#define REG_SC_BK8D_24_L      _PK_L_(0x8D, 0x24)
#define REG_SC_BK8D_24_H      _PK_H_(0x8D, 0x24)
#define REG_SC_BK8D_25_L      _PK_L_(0x8D, 0x25)
#define REG_SC_BK8D_25_H      _PK_H_(0x8D, 0x25)
#define REG_SC_BK8D_26_L      _PK_L_(0x8D, 0x26)
#define REG_SC_BK8D_26_H      _PK_H_(0x8D, 0x26)
#define REG_SC_BK8D_27_L      _PK_L_(0x8D, 0x27)
#define REG_SC_BK8D_27_H      _PK_H_(0x8D, 0x27)
#define REG_SC_BK8D_28_L      _PK_L_(0x8D, 0x28)
#define REG_SC_BK8D_28_H      _PK_H_(0x8D, 0x28)
#define REG_SC_BK8D_29_L      _PK_L_(0x8D, 0x29)
#define REG_SC_BK8D_29_H      _PK_H_(0x8D, 0x29)
#define REG_SC_BK8D_2A_L      _PK_L_(0x8D, 0x2A)
#define REG_SC_BK8D_2A_H      _PK_H_(0x8D, 0x2A)
#define REG_SC_BK8D_2B_L      _PK_L_(0x8D, 0x2B)
#define REG_SC_BK8D_2B_H      _PK_H_(0x8D, 0x2B)
#define REG_SC_BK8D_2C_L      _PK_L_(0x8D, 0x2C)
#define REG_SC_BK8D_2C_H      _PK_H_(0x8D, 0x2C)
#define REG_SC_BK8D_2D_L      _PK_L_(0x8D, 0x2D)
#define REG_SC_BK8D_2D_H      _PK_H_(0x8D, 0x2D)
#define REG_SC_BK8D_2E_L      _PK_L_(0x8D, 0x2E)
#define REG_SC_BK8D_2E_H      _PK_H_(0x8D, 0x2E)
#define REG_SC_BK8D_2F_L      _PK_L_(0x8D, 0x2F)
#define REG_SC_BK8D_2F_H      _PK_H_(0x8D, 0x2F)
#define REG_SC_BK8D_30_L      _PK_L_(0x8D, 0x30)
#define REG_SC_BK8D_30_H      _PK_H_(0x8D, 0x30)
#define REG_SC_BK8D_31_L      _PK_L_(0x8D, 0x31)
#define REG_SC_BK8D_31_H      _PK_H_(0x8D, 0x31)
#define REG_SC_BK8D_32_L      _PK_L_(0x8D, 0x32)
#define REG_SC_BK8D_32_H      _PK_H_(0x8D, 0x32)
#define REG_SC_BK8D_33_L      _PK_L_(0x8D, 0x33)
#define REG_SC_BK8D_33_H      _PK_H_(0x8D, 0x33)
#define REG_SC_BK8D_34_L      _PK_L_(0x8D, 0x34)
#define REG_SC_BK8D_34_H      _PK_H_(0x8D, 0x34)
#define REG_SC_BK8D_35_L      _PK_L_(0x8D, 0x35)
#define REG_SC_BK8D_35_H      _PK_H_(0x8D, 0x35)
#define REG_SC_BK8D_36_L      _PK_L_(0x8D, 0x36)
#define REG_SC_BK8D_36_H      _PK_H_(0x8D, 0x36)
#define REG_SC_BK8D_37_L      _PK_L_(0x8D, 0x37)
#define REG_SC_BK8D_37_H      _PK_H_(0x8D, 0x37)
#define REG_SC_BK8D_38_L      _PK_L_(0x8D, 0x38)
#define REG_SC_BK8D_38_H      _PK_H_(0x8D, 0x38)
#define REG_SC_BK8D_39_L      _PK_L_(0x8D, 0x39)
#define REG_SC_BK8D_39_H      _PK_H_(0x8D, 0x39)
#define REG_SC_BK8D_3A_L      _PK_L_(0x8D, 0x3A)
#define REG_SC_BK8D_3A_H      _PK_H_(0x8D, 0x3A)
#define REG_SC_BK8D_3B_L      _PK_L_(0x8D, 0x3B)
#define REG_SC_BK8D_3B_H      _PK_H_(0x8D, 0x3B)
#define REG_SC_BK8D_3C_L      _PK_L_(0x8D, 0x3C)
#define REG_SC_BK8D_3C_H      _PK_H_(0x8D, 0x3C)
#define REG_SC_BK8D_3D_L      _PK_L_(0x8D, 0x3D)
#define REG_SC_BK8D_3D_H      _PK_H_(0x8D, 0x3D)
#define REG_SC_BK8D_3E_L      _PK_L_(0x8D, 0x3E)
#define REG_SC_BK8D_3E_H      _PK_H_(0x8D, 0x3E)
#define REG_SC_BK8D_3F_L      _PK_L_(0x8D, 0x3F)
#define REG_SC_BK8D_3F_H      _PK_H_(0x8D, 0x3F)
#define REG_SC_BK8D_40_L      _PK_L_(0x8D, 0x40)
#define REG_SC_BK8D_40_H      _PK_H_(0x8D, 0x40)
#define REG_SC_BK8D_41_L      _PK_L_(0x8D, 0x41)
#define REG_SC_BK8D_41_H      _PK_H_(0x8D, 0x41)
#define REG_SC_BK8D_42_L      _PK_L_(0x8D, 0x42)
#define REG_SC_BK8D_42_H      _PK_H_(0x8D, 0x42)
#define REG_SC_BK8D_43_L      _PK_L_(0x8D, 0x43)
#define REG_SC_BK8D_43_H      _PK_H_(0x8D, 0x43)
#define REG_SC_BK8D_44_L      _PK_L_(0x8D, 0x44)
#define REG_SC_BK8D_44_H      _PK_H_(0x8D, 0x44)
#define REG_SC_BK8D_45_L      _PK_L_(0x8D, 0x45)
#define REG_SC_BK8D_45_H      _PK_H_(0x8D, 0x45)
#define REG_SC_BK8D_46_L      _PK_L_(0x8D, 0x46)
#define REG_SC_BK8D_46_H      _PK_H_(0x8D, 0x46)
#define REG_SC_BK8D_47_L      _PK_L_(0x8D, 0x47)
#define REG_SC_BK8D_47_H      _PK_H_(0x8D, 0x47)
#define REG_SC_BK8D_48_L      _PK_L_(0x8D, 0x48)
#define REG_SC_BK8D_48_H      _PK_H_(0x8D, 0x48)
#define REG_SC_BK8D_49_L      _PK_L_(0x8D, 0x49)
#define REG_SC_BK8D_49_H      _PK_H_(0x8D, 0x49)
#define REG_SC_BK8D_4A_L      _PK_L_(0x8D, 0x4A)
#define REG_SC_BK8D_4A_H      _PK_H_(0x8D, 0x4A)
#define REG_SC_BK8D_4B_L      _PK_L_(0x8D, 0x4B)
#define REG_SC_BK8D_4B_H      _PK_H_(0x8D, 0x4B)
#define REG_SC_BK8D_4C_L      _PK_L_(0x8D, 0x4C)
#define REG_SC_BK8D_4C_H      _PK_H_(0x8D, 0x4C)
#define REG_SC_BK8D_4D_L      _PK_L_(0x8D, 0x4D)
#define REG_SC_BK8D_4D_H      _PK_H_(0x8D, 0x4D)
#define REG_SC_BK8D_4E_L      _PK_L_(0x8D, 0x4E)
#define REG_SC_BK8D_4E_H      _PK_H_(0x8D, 0x4E)
#define REG_SC_BK8D_4F_L      _PK_L_(0x8D, 0x4F)
#define REG_SC_BK8D_4F_H      _PK_H_(0x8D, 0x4F)
#define REG_SC_BK8D_50_L      _PK_L_(0x8D, 0x50)
#define REG_SC_BK8D_50_H      _PK_H_(0x8D, 0x50)
#define REG_SC_BK8D_51_L      _PK_L_(0x8D, 0x51)
#define REG_SC_BK8D_51_H      _PK_H_(0x8D, 0x51)
#define REG_SC_BK8D_52_L      _PK_L_(0x8D, 0x52)
#define REG_SC_BK8D_52_H      _PK_H_(0x8D, 0x52)
#define REG_SC_BK8D_53_L      _PK_L_(0x8D, 0x53)
#define REG_SC_BK8D_53_H      _PK_H_(0x8D, 0x53)
#define REG_SC_BK8D_54_L      _PK_L_(0x8D, 0x54)
#define REG_SC_BK8D_54_H      _PK_H_(0x8D, 0x54)
#define REG_SC_BK8D_55_L      _PK_L_(0x8D, 0x55)
#define REG_SC_BK8D_55_H      _PK_H_(0x8D, 0x55)
#define REG_SC_BK8D_56_L      _PK_L_(0x8D, 0x56)
#define REG_SC_BK8D_56_H      _PK_H_(0x8D, 0x56)
#define REG_SC_BK8D_57_L      _PK_L_(0x8D, 0x57)
#define REG_SC_BK8D_57_H      _PK_H_(0x8D, 0x57)
#define REG_SC_BK8D_58_L      _PK_L_(0x8D, 0x58)
#define REG_SC_BK8D_58_H      _PK_H_(0x8D, 0x58)
#define REG_SC_BK8D_59_L      _PK_L_(0x8D, 0x59)
#define REG_SC_BK8D_59_H      _PK_H_(0x8D, 0x59)
#define REG_SC_BK8D_5A_L      _PK_L_(0x8D, 0x5A)
#define REG_SC_BK8D_5A_H      _PK_H_(0x8D, 0x5A)
#define REG_SC_BK8D_5B_L      _PK_L_(0x8D, 0x5B)
#define REG_SC_BK8D_5B_H      _PK_H_(0x8D, 0x5B)
#define REG_SC_BK8D_5C_L      _PK_L_(0x8D, 0x5C)
#define REG_SC_BK8D_5C_H      _PK_H_(0x8D, 0x5C)
#define REG_SC_BK8D_5D_L      _PK_L_(0x8D, 0x5D)
#define REG_SC_BK8D_5D_H      _PK_H_(0x8D, 0x5D)
#define REG_SC_BK8D_5E_L      _PK_L_(0x8D, 0x5E)
#define REG_SC_BK8D_5E_H      _PK_H_(0x8D, 0x5E)
#define REG_SC_BK8D_5F_L      _PK_L_(0x8D, 0x5F)
#define REG_SC_BK8D_5F_H      _PK_H_(0x8D, 0x5F)
#define REG_SC_BK8D_60_L      _PK_L_(0x8D, 0x60)
#define REG_SC_BK8D_60_H      _PK_H_(0x8D, 0x60)
#define REG_SC_BK8D_61_L      _PK_L_(0x8D, 0x61)
#define REG_SC_BK8D_61_H      _PK_H_(0x8D, 0x61)
#define REG_SC_BK8D_62_L      _PK_L_(0x8D, 0x62)
#define REG_SC_BK8D_62_H      _PK_H_(0x8D, 0x62)
#define REG_SC_BK8D_63_L      _PK_L_(0x8D, 0x63)
#define REG_SC_BK8D_63_H      _PK_H_(0x8D, 0x63)
#define REG_SC_BK8D_64_L      _PK_L_(0x8D, 0x64)
#define REG_SC_BK8D_64_H      _PK_H_(0x8D, 0x64)
#define REG_SC_BK8D_65_L      _PK_L_(0x8D, 0x65)
#define REG_SC_BK8D_65_H      _PK_H_(0x8D, 0x65)
#define REG_SC_BK8D_66_L      _PK_L_(0x8D, 0x66)
#define REG_SC_BK8D_66_H      _PK_H_(0x8D, 0x66)
#define REG_SC_BK8D_67_L      _PK_L_(0x8D, 0x67)
#define REG_SC_BK8D_67_H      _PK_H_(0x8D, 0x67)
#define REG_SC_BK8D_68_L      _PK_L_(0x8D, 0x68)
#define REG_SC_BK8D_68_H      _PK_H_(0x8D, 0x68)
#define REG_SC_BK8D_69_L      _PK_L_(0x8D, 0x69)
#define REG_SC_BK8D_69_H      _PK_H_(0x8D, 0x69)
#define REG_SC_BK8D_6A_L      _PK_L_(0x8D, 0x6A)
#define REG_SC_BK8D_6A_H      _PK_H_(0x8D, 0x6A)
#define REG_SC_BK8D_6B_L      _PK_L_(0x8D, 0x6B)
#define REG_SC_BK8D_6B_H      _PK_H_(0x8D, 0x6B)
#define REG_SC_BK8D_6C_L      _PK_L_(0x8D, 0x6C)
#define REG_SC_BK8D_6C_H      _PK_H_(0x8D, 0x6C)
#define REG_SC_BK8D_6D_L      _PK_L_(0x8D, 0x6D)
#define REG_SC_BK8D_6D_H      _PK_H_(0x8D, 0x6D)
#define REG_SC_BK8D_6E_L      _PK_L_(0x8D, 0x6E)
#define REG_SC_BK8D_6E_H      _PK_H_(0x8D, 0x6E)
#define REG_SC_BK8D_6F_L      _PK_L_(0x8D, 0x6F)
#define REG_SC_BK8D_6F_H      _PK_H_(0x8D, 0x6F)
#define REG_SC_BK8D_70_L      _PK_L_(0x8D, 0x70)
#define REG_SC_BK8D_70_H      _PK_H_(0x8D, 0x70)
#define REG_SC_BK8D_71_L      _PK_L_(0x8D, 0x71)
#define REG_SC_BK8D_71_H      _PK_H_(0x8D, 0x71)
#define REG_SC_BK8D_72_L      _PK_L_(0x8D, 0x72)
#define REG_SC_BK8D_72_H      _PK_H_(0x8D, 0x72)
#define REG_SC_BK8D_73_L      _PK_L_(0x8D, 0x73)
#define REG_SC_BK8D_73_H      _PK_H_(0x8D, 0x73)
#define REG_SC_BK8D_74_L      _PK_L_(0x8D, 0x74)
#define REG_SC_BK8D_74_H      _PK_H_(0x8D, 0x74)
#define REG_SC_BK8D_75_L      _PK_L_(0x8D, 0x75)
#define REG_SC_BK8D_75_H      _PK_H_(0x8D, 0x75)
#define REG_SC_BK8D_76_L      _PK_L_(0x8D, 0x76)
#define REG_SC_BK8D_76_H      _PK_H_(0x8D, 0x76)
#define REG_SC_BK8D_77_L      _PK_L_(0x8D, 0x77)
#define REG_SC_BK8D_77_H      _PK_H_(0x8D, 0x77)
#define REG_SC_BK8D_78_L      _PK_L_(0x8D, 0x78)
#define REG_SC_BK8D_78_H      _PK_H_(0x8D, 0x78)
#define REG_SC_BK8D_79_L      _PK_L_(0x8D, 0x79)
#define REG_SC_BK8D_79_H      _PK_H_(0x8D, 0x79)
#define REG_SC_BK8D_7A_L      _PK_L_(0x8D, 0x7A)
#define REG_SC_BK8D_7A_H      _PK_H_(0x8D, 0x7A)
#define REG_SC_BK8D_7B_L      _PK_L_(0x8D, 0x7B)
#define REG_SC_BK8D_7B_H      _PK_H_(0x8D, 0x7B)
#define REG_SC_BK8D_7C_L      _PK_L_(0x8D, 0x7C)
#define REG_SC_BK8D_7C_H      _PK_H_(0x8D, 0x7C)
#define REG_SC_BK8D_7D_L      _PK_L_(0x8D, 0x7D)
#define REG_SC_BK8D_7D_H      _PK_H_(0x8D, 0x7D)
#define REG_SC_BK8D_7E_L      _PK_L_(0x8D, 0x7E)
#define REG_SC_BK8D_7E_H      _PK_H_(0x8D, 0x7E)
#define REG_SC_BK8D_7F_L      _PK_L_(0x8D, 0x7F)
#define REG_SC_BK8D_7F_H      _PK_H_(0x8D, 0x7F)
//----------------------------------------------
#define REG_SC_BK8E_00_L      _PK_L_(0x8E, 0x00)
#define REG_SC_BK8E_00_H      _PK_H_(0x8E, 0x00)
#define REG_SC_BK8E_01_L      _PK_L_(0x8E, 0x01)
#define REG_SC_BK8E_01_H      _PK_H_(0x8E, 0x01)
#define REG_SC_BK8E_02_L      _PK_L_(0x8E, 0x02)
#define REG_SC_BK8E_02_H      _PK_H_(0x8E, 0x02)
#define REG_SC_BK8E_03_L      _PK_L_(0x8E, 0x03)
#define REG_SC_BK8E_03_H      _PK_H_(0x8E, 0x03)
#define REG_SC_BK8E_04_L      _PK_L_(0x8E, 0x04)
#define REG_SC_BK8E_04_H      _PK_H_(0x8E, 0x04)
#define REG_SC_BK8E_05_L      _PK_L_(0x8E, 0x05)
#define REG_SC_BK8E_05_H      _PK_H_(0x8E, 0x05)
#define REG_SC_BK8E_06_L      _PK_L_(0x8E, 0x06)
#define REG_SC_BK8E_06_H      _PK_H_(0x8E, 0x06)
#define REG_SC_BK8E_07_L      _PK_L_(0x8E, 0x07)
#define REG_SC_BK8E_07_H      _PK_H_(0x8E, 0x07)
#define REG_SC_BK8E_08_L      _PK_L_(0x8E, 0x08)
#define REG_SC_BK8E_08_H      _PK_H_(0x8E, 0x08)
#define REG_SC_BK8E_09_L      _PK_L_(0x8E, 0x09)
#define REG_SC_BK8E_09_H      _PK_H_(0x8E, 0x09)
#define REG_SC_BK8E_0A_L      _PK_L_(0x8E, 0x0A)
#define REG_SC_BK8E_0A_H      _PK_H_(0x8E, 0x0A)
#define REG_SC_BK8E_0B_L      _PK_L_(0x8E, 0x0B)
#define REG_SC_BK8E_0B_H      _PK_H_(0x8E, 0x0B)
#define REG_SC_BK8E_0C_L      _PK_L_(0x8E, 0x0C)
#define REG_SC_BK8E_0C_H      _PK_H_(0x8E, 0x0C)
#define REG_SC_BK8E_0D_L      _PK_L_(0x8E, 0x0D)
#define REG_SC_BK8E_0D_H      _PK_H_(0x8E, 0x0D)
#define REG_SC_BK8E_0E_L      _PK_L_(0x8E, 0x0E)
#define REG_SC_BK8E_0E_H      _PK_H_(0x8E, 0x0E)
#define REG_SC_BK8E_0F_L      _PK_L_(0x8E, 0x0F)
#define REG_SC_BK8E_0F_H      _PK_H_(0x8E, 0x0F)
#define REG_SC_BK8E_10_L      _PK_L_(0x8E, 0x10)
#define REG_SC_BK8E_10_H      _PK_H_(0x8E, 0x10)
#define REG_SC_BK8E_11_L      _PK_L_(0x8E, 0x11)
#define REG_SC_BK8E_11_H      _PK_H_(0x8E, 0x11)
#define REG_SC_BK8E_12_L      _PK_L_(0x8E, 0x12)
#define REG_SC_BK8E_12_H      _PK_H_(0x8E, 0x12)
#define REG_SC_BK8E_13_L      _PK_L_(0x8E, 0x13)
#define REG_SC_BK8E_13_H      _PK_H_(0x8E, 0x13)
#define REG_SC_BK8E_14_L      _PK_L_(0x8E, 0x14)
#define REG_SC_BK8E_14_H      _PK_H_(0x8E, 0x14)
#define REG_SC_BK8E_15_L      _PK_L_(0x8E, 0x15)
#define REG_SC_BK8E_15_H      _PK_H_(0x8E, 0x15)
#define REG_SC_BK8E_16_L      _PK_L_(0x8E, 0x16)
#define REG_SC_BK8E_16_H      _PK_H_(0x8E, 0x16)
#define REG_SC_BK8E_17_L      _PK_L_(0x8E, 0x17)
#define REG_SC_BK8E_17_H      _PK_H_(0x8E, 0x17)
#define REG_SC_BK8E_18_L      _PK_L_(0x8E, 0x18)
#define REG_SC_BK8E_18_H      _PK_H_(0x8E, 0x18)
#define REG_SC_BK8E_19_L      _PK_L_(0x8E, 0x19)
#define REG_SC_BK8E_19_H      _PK_H_(0x8E, 0x19)
#define REG_SC_BK8E_1A_L      _PK_L_(0x8E, 0x1A)
#define REG_SC_BK8E_1A_H      _PK_H_(0x8E, 0x1A)
#define REG_SC_BK8E_1B_L      _PK_L_(0x8E, 0x1B)
#define REG_SC_BK8E_1B_H      _PK_H_(0x8E, 0x1B)
#define REG_SC_BK8E_1C_L      _PK_L_(0x8E, 0x1C)
#define REG_SC_BK8E_1C_H      _PK_H_(0x8E, 0x1C)
#define REG_SC_BK8E_1D_L      _PK_L_(0x8E, 0x1D)
#define REG_SC_BK8E_1D_H      _PK_H_(0x8E, 0x1D)
#define REG_SC_BK8E_1E_L      _PK_L_(0x8E, 0x1E)
#define REG_SC_BK8E_1E_H      _PK_H_(0x8E, 0x1E)
#define REG_SC_BK8E_1F_L      _PK_L_(0x8E, 0x1F)
#define REG_SC_BK8E_1F_H      _PK_H_(0x8E, 0x1F)
#define REG_SC_BK8E_20_L      _PK_L_(0x8E, 0x20)
#define REG_SC_BK8E_20_H      _PK_H_(0x8E, 0x20)
#define REG_SC_BK8E_21_L      _PK_L_(0x8E, 0x21)
#define REG_SC_BK8E_21_H      _PK_H_(0x8E, 0x21)
#define REG_SC_BK8E_22_L      _PK_L_(0x8E, 0x22)
#define REG_SC_BK8E_22_H      _PK_H_(0x8E, 0x22)
#define REG_SC_BK8E_23_L      _PK_L_(0x8E, 0x23)
#define REG_SC_BK8E_23_H      _PK_H_(0x8E, 0x23)
#define REG_SC_BK8E_24_L      _PK_L_(0x8E, 0x24)
#define REG_SC_BK8E_24_H      _PK_H_(0x8E, 0x24)
#define REG_SC_BK8E_25_L      _PK_L_(0x8E, 0x25)
#define REG_SC_BK8E_25_H      _PK_H_(0x8E, 0x25)
#define REG_SC_BK8E_26_L      _PK_L_(0x8E, 0x26)
#define REG_SC_BK8E_26_H      _PK_H_(0x8E, 0x26)
#define REG_SC_BK8E_27_L      _PK_L_(0x8E, 0x27)
#define REG_SC_BK8E_27_H      _PK_H_(0x8E, 0x27)
#define REG_SC_BK8E_28_L      _PK_L_(0x8E, 0x28)
#define REG_SC_BK8E_28_H      _PK_H_(0x8E, 0x28)
#define REG_SC_BK8E_29_L      _PK_L_(0x8E, 0x29)
#define REG_SC_BK8E_29_H      _PK_H_(0x8E, 0x29)
#define REG_SC_BK8E_2A_L      _PK_L_(0x8E, 0x2A)
#define REG_SC_BK8E_2A_H      _PK_H_(0x8E, 0x2A)
#define REG_SC_BK8E_2B_L      _PK_L_(0x8E, 0x2B)
#define REG_SC_BK8E_2B_H      _PK_H_(0x8E, 0x2B)
#define REG_SC_BK8E_2C_L      _PK_L_(0x8E, 0x2C)
#define REG_SC_BK8E_2C_H      _PK_H_(0x8E, 0x2C)
#define REG_SC_BK8E_2D_L      _PK_L_(0x8E, 0x2D)
#define REG_SC_BK8E_2D_H      _PK_H_(0x8E, 0x2D)
#define REG_SC_BK8E_2E_L      _PK_L_(0x8E, 0x2E)
#define REG_SC_BK8E_2E_H      _PK_H_(0x8E, 0x2E)
#define REG_SC_BK8E_2F_L      _PK_L_(0x8E, 0x2F)
#define REG_SC_BK8E_2F_H      _PK_H_(0x8E, 0x2F)
#define REG_SC_BK8E_30_L      _PK_L_(0x8E, 0x30)
#define REG_SC_BK8E_30_H      _PK_H_(0x8E, 0x30)
#define REG_SC_BK8E_31_L      _PK_L_(0x8E, 0x31)
#define REG_SC_BK8E_31_H      _PK_H_(0x8E, 0x31)
#define REG_SC_BK8E_32_L      _PK_L_(0x8E, 0x32)
#define REG_SC_BK8E_32_H      _PK_H_(0x8E, 0x32)
#define REG_SC_BK8E_33_L      _PK_L_(0x8E, 0x33)
#define REG_SC_BK8E_33_H      _PK_H_(0x8E, 0x33)
#define REG_SC_BK8E_34_L      _PK_L_(0x8E, 0x34)
#define REG_SC_BK8E_34_H      _PK_H_(0x8E, 0x34)
#define REG_SC_BK8E_35_L      _PK_L_(0x8E, 0x35)
#define REG_SC_BK8E_35_H      _PK_H_(0x8E, 0x35)
#define REG_SC_BK8E_36_L      _PK_L_(0x8E, 0x36)
#define REG_SC_BK8E_36_H      _PK_H_(0x8E, 0x36)
#define REG_SC_BK8E_37_L      _PK_L_(0x8E, 0x37)
#define REG_SC_BK8E_37_H      _PK_H_(0x8E, 0x37)
#define REG_SC_BK8E_38_L      _PK_L_(0x8E, 0x38)
#define REG_SC_BK8E_38_H      _PK_H_(0x8E, 0x38)
#define REG_SC_BK8E_39_L      _PK_L_(0x8E, 0x39)
#define REG_SC_BK8E_39_H      _PK_H_(0x8E, 0x39)
#define REG_SC_BK8E_3A_L      _PK_L_(0x8E, 0x3A)
#define REG_SC_BK8E_3A_H      _PK_H_(0x8E, 0x3A)
#define REG_SC_BK8E_3B_L      _PK_L_(0x8E, 0x3B)
#define REG_SC_BK8E_3B_H      _PK_H_(0x8E, 0x3B)
#define REG_SC_BK8E_3C_L      _PK_L_(0x8E, 0x3C)
#define REG_SC_BK8E_3C_H      _PK_H_(0x8E, 0x3C)
#define REG_SC_BK8E_3D_L      _PK_L_(0x8E, 0x3D)
#define REG_SC_BK8E_3D_H      _PK_H_(0x8E, 0x3D)
#define REG_SC_BK8E_3E_L      _PK_L_(0x8E, 0x3E)
#define REG_SC_BK8E_3E_H      _PK_H_(0x8E, 0x3E)
#define REG_SC_BK8E_3F_L      _PK_L_(0x8E, 0x3F)
#define REG_SC_BK8E_3F_H      _PK_H_(0x8E, 0x3F)
#define REG_SC_BK8E_40_L      _PK_L_(0x8E, 0x40)
#define REG_SC_BK8E_40_H      _PK_H_(0x8E, 0x40)
#define REG_SC_BK8E_41_L      _PK_L_(0x8E, 0x41)
#define REG_SC_BK8E_41_H      _PK_H_(0x8E, 0x41)
#define REG_SC_BK8E_42_L      _PK_L_(0x8E, 0x42)
#define REG_SC_BK8E_42_H      _PK_H_(0x8E, 0x42)
#define REG_SC_BK8E_43_L      _PK_L_(0x8E, 0x43)
#define REG_SC_BK8E_43_H      _PK_H_(0x8E, 0x43)
#define REG_SC_BK8E_44_L      _PK_L_(0x8E, 0x44)
#define REG_SC_BK8E_44_H      _PK_H_(0x8E, 0x44)
#define REG_SC_BK8E_45_L      _PK_L_(0x8E, 0x45)
#define REG_SC_BK8E_45_H      _PK_H_(0x8E, 0x45)
#define REG_SC_BK8E_46_L      _PK_L_(0x8E, 0x46)
#define REG_SC_BK8E_46_H      _PK_H_(0x8E, 0x46)
#define REG_SC_BK8E_47_L      _PK_L_(0x8E, 0x47)
#define REG_SC_BK8E_47_H      _PK_H_(0x8E, 0x47)
#define REG_SC_BK8E_48_L      _PK_L_(0x8E, 0x48)
#define REG_SC_BK8E_48_H      _PK_H_(0x8E, 0x48)
#define REG_SC_BK8E_49_L      _PK_L_(0x8E, 0x49)
#define REG_SC_BK8E_49_H      _PK_H_(0x8E, 0x49)
#define REG_SC_BK8E_4A_L      _PK_L_(0x8E, 0x4A)
#define REG_SC_BK8E_4A_H      _PK_H_(0x8E, 0x4A)
#define REG_SC_BK8E_4B_L      _PK_L_(0x8E, 0x4B)
#define REG_SC_BK8E_4B_H      _PK_H_(0x8E, 0x4B)
#define REG_SC_BK8E_4C_L      _PK_L_(0x8E, 0x4C)
#define REG_SC_BK8E_4C_H      _PK_H_(0x8E, 0x4C)
#define REG_SC_BK8E_4D_L      _PK_L_(0x8E, 0x4D)
#define REG_SC_BK8E_4D_H      _PK_H_(0x8E, 0x4D)
#define REG_SC_BK8E_4E_L      _PK_L_(0x8E, 0x4E)
#define REG_SC_BK8E_4E_H      _PK_H_(0x8E, 0x4E)
#define REG_SC_BK8E_4F_L      _PK_L_(0x8E, 0x4F)
#define REG_SC_BK8E_4F_H      _PK_H_(0x8E, 0x4F)
#define REG_SC_BK8E_50_L      _PK_L_(0x8E, 0x50)
#define REG_SC_BK8E_50_H      _PK_H_(0x8E, 0x50)
#define REG_SC_BK8E_51_L      _PK_L_(0x8E, 0x51)
#define REG_SC_BK8E_51_H      _PK_H_(0x8E, 0x51)
#define REG_SC_BK8E_52_L      _PK_L_(0x8E, 0x52)
#define REG_SC_BK8E_52_H      _PK_H_(0x8E, 0x52)
#define REG_SC_BK8E_53_L      _PK_L_(0x8E, 0x53)
#define REG_SC_BK8E_53_H      _PK_H_(0x8E, 0x53)
#define REG_SC_BK8E_54_L      _PK_L_(0x8E, 0x54)
#define REG_SC_BK8E_54_H      _PK_H_(0x8E, 0x54)
#define REG_SC_BK8E_55_L      _PK_L_(0x8E, 0x55)
#define REG_SC_BK8E_55_H      _PK_H_(0x8E, 0x55)
#define REG_SC_BK8E_56_L      _PK_L_(0x8E, 0x56)
#define REG_SC_BK8E_56_H      _PK_H_(0x8E, 0x56)
#define REG_SC_BK8E_57_L      _PK_L_(0x8E, 0x57)
#define REG_SC_BK8E_57_H      _PK_H_(0x8E, 0x57)
#define REG_SC_BK8E_58_L      _PK_L_(0x8E, 0x58)
#define REG_SC_BK8E_58_H      _PK_H_(0x8E, 0x58)
#define REG_SC_BK8E_59_L      _PK_L_(0x8E, 0x59)
#define REG_SC_BK8E_59_H      _PK_H_(0x8E, 0x59)
#define REG_SC_BK8E_5A_L      _PK_L_(0x8E, 0x5A)
#define REG_SC_BK8E_5A_H      _PK_H_(0x8E, 0x5A)
#define REG_SC_BK8E_5B_L      _PK_L_(0x8E, 0x5B)
#define REG_SC_BK8E_5B_H      _PK_H_(0x8E, 0x5B)
#define REG_SC_BK8E_5C_L      _PK_L_(0x8E, 0x5C)
#define REG_SC_BK8E_5C_H      _PK_H_(0x8E, 0x5C)
#define REG_SC_BK8E_5D_L      _PK_L_(0x8E, 0x5D)
#define REG_SC_BK8E_5D_H      _PK_H_(0x8E, 0x5D)
#define REG_SC_BK8E_5E_L      _PK_L_(0x8E, 0x5E)
#define REG_SC_BK8E_5E_H      _PK_H_(0x8E, 0x5E)
#define REG_SC_BK8E_5F_L      _PK_L_(0x8E, 0x5F)
#define REG_SC_BK8E_5F_H      _PK_H_(0x8E, 0x5F)
#define REG_SC_BK8E_60_L      _PK_L_(0x8E, 0x60)
#define REG_SC_BK8E_60_H      _PK_H_(0x8E, 0x60)
#define REG_SC_BK8E_61_L      _PK_L_(0x8E, 0x61)
#define REG_SC_BK8E_61_H      _PK_H_(0x8E, 0x61)
#define REG_SC_BK8E_62_L      _PK_L_(0x8E, 0x62)
#define REG_SC_BK8E_62_H      _PK_H_(0x8E, 0x62)
#define REG_SC_BK8E_63_L      _PK_L_(0x8E, 0x63)
#define REG_SC_BK8E_63_H      _PK_H_(0x8E, 0x63)
#define REG_SC_BK8E_64_L      _PK_L_(0x8E, 0x64)
#define REG_SC_BK8E_64_H      _PK_H_(0x8E, 0x64)
#define REG_SC_BK8E_65_L      _PK_L_(0x8E, 0x65)
#define REG_SC_BK8E_65_H      _PK_H_(0x8E, 0x65)
#define REG_SC_BK8E_66_L      _PK_L_(0x8E, 0x66)
#define REG_SC_BK8E_66_H      _PK_H_(0x8E, 0x66)
#define REG_SC_BK8E_67_L      _PK_L_(0x8E, 0x67)
#define REG_SC_BK8E_67_H      _PK_H_(0x8E, 0x67)
#define REG_SC_BK8E_68_L      _PK_L_(0x8E, 0x68)
#define REG_SC_BK8E_68_H      _PK_H_(0x8E, 0x68)
#define REG_SC_BK8E_69_L      _PK_L_(0x8E, 0x69)
#define REG_SC_BK8E_69_H      _PK_H_(0x8E, 0x69)
#define REG_SC_BK8E_6A_L      _PK_L_(0x8E, 0x6A)
#define REG_SC_BK8E_6A_H      _PK_H_(0x8E, 0x6A)
#define REG_SC_BK8E_6B_L      _PK_L_(0x8E, 0x6B)
#define REG_SC_BK8E_6B_H      _PK_H_(0x8E, 0x6B)
#define REG_SC_BK8E_6C_L      _PK_L_(0x8E, 0x6C)
#define REG_SC_BK8E_6C_H      _PK_H_(0x8E, 0x6C)
#define REG_SC_BK8E_6D_L      _PK_L_(0x8E, 0x6D)
#define REG_SC_BK8E_6D_H      _PK_H_(0x8E, 0x6D)
#define REG_SC_BK8E_6E_L      _PK_L_(0x8E, 0x6E)
#define REG_SC_BK8E_6E_H      _PK_H_(0x8E, 0x6E)
#define REG_SC_BK8E_6F_L      _PK_L_(0x8E, 0x6F)
#define REG_SC_BK8E_6F_H      _PK_H_(0x8E, 0x6F)
#define REG_SC_BK8E_70_L      _PK_L_(0x8E, 0x70)
#define REG_SC_BK8E_70_H      _PK_H_(0x8E, 0x70)
#define REG_SC_BK8E_71_L      _PK_L_(0x8E, 0x71)
#define REG_SC_BK8E_71_H      _PK_H_(0x8E, 0x71)
#define REG_SC_BK8E_72_L      _PK_L_(0x8E, 0x72)
#define REG_SC_BK8E_72_H      _PK_H_(0x8E, 0x72)
#define REG_SC_BK8E_73_L      _PK_L_(0x8E, 0x73)
#define REG_SC_BK8E_73_H      _PK_H_(0x8E, 0x73)
#define REG_SC_BK8E_74_L      _PK_L_(0x8E, 0x74)
#define REG_SC_BK8E_74_H      _PK_H_(0x8E, 0x74)
#define REG_SC_BK8E_75_L      _PK_L_(0x8E, 0x75)
#define REG_SC_BK8E_75_H      _PK_H_(0x8E, 0x75)
#define REG_SC_BK8E_76_L      _PK_L_(0x8E, 0x76)
#define REG_SC_BK8E_76_H      _PK_H_(0x8E, 0x76)
#define REG_SC_BK8E_77_L      _PK_L_(0x8E, 0x77)
#define REG_SC_BK8E_77_H      _PK_H_(0x8E, 0x77)
#define REG_SC_BK8E_78_L      _PK_L_(0x8E, 0x78)
#define REG_SC_BK8E_78_H      _PK_H_(0x8E, 0x78)
#define REG_SC_BK8E_79_L      _PK_L_(0x8E, 0x79)
#define REG_SC_BK8E_79_H      _PK_H_(0x8E, 0x79)
#define REG_SC_BK8E_7A_L      _PK_L_(0x8E, 0x7A)
#define REG_SC_BK8E_7A_H      _PK_H_(0x8E, 0x7A)
#define REG_SC_BK8E_7B_L      _PK_L_(0x8E, 0x7B)
#define REG_SC_BK8E_7B_H      _PK_H_(0x8E, 0x7B)
#define REG_SC_BK8E_7C_L      _PK_L_(0x8E, 0x7C)
#define REG_SC_BK8E_7C_H      _PK_H_(0x8E, 0x7C)
#define REG_SC_BK8E_7D_L      _PK_L_(0x8E, 0x7D)
#define REG_SC_BK8E_7D_H      _PK_H_(0x8E, 0x7D)
#define REG_SC_BK8E_7E_L      _PK_L_(0x8E, 0x7E)
#define REG_SC_BK8E_7E_H      _PK_H_(0x8E, 0x7E)
#define REG_SC_BK8E_7F_L      _PK_L_(0x8E, 0x7F)
#define REG_SC_BK8E_7F_H      _PK_H_(0x8E, 0x7F)
//----------------------------------------------
#define REG_SC_BK8F_00_L      _PK_L_(0x8F, 0x00)
#define REG_SC_BK8F_00_H      _PK_H_(0x8F, 0x00)
#define REG_SC_BK8F_01_L      _PK_L_(0x8F, 0x01)
#define REG_SC_BK8F_01_H      _PK_H_(0x8F, 0x01)
#define REG_SC_BK8F_02_L      _PK_L_(0x8F, 0x02)
#define REG_SC_BK8F_02_H      _PK_H_(0x8F, 0x02)
#define REG_SC_BK8F_03_L      _PK_L_(0x8F, 0x03)
#define REG_SC_BK8F_03_H      _PK_H_(0x8F, 0x03)
#define REG_SC_BK8F_04_L      _PK_L_(0x8F, 0x04)
#define REG_SC_BK8F_04_H      _PK_H_(0x8F, 0x04)
#define REG_SC_BK8F_05_L      _PK_L_(0x8F, 0x05)
#define REG_SC_BK8F_05_H      _PK_H_(0x8F, 0x05)
#define REG_SC_BK8F_06_L      _PK_L_(0x8F, 0x06)
#define REG_SC_BK8F_06_H      _PK_H_(0x8F, 0x06)
#define REG_SC_BK8F_07_L      _PK_L_(0x8F, 0x07)
#define REG_SC_BK8F_07_H      _PK_H_(0x8F, 0x07)
#define REG_SC_BK8F_08_L      _PK_L_(0x8F, 0x08)
#define REG_SC_BK8F_08_H      _PK_H_(0x8F, 0x08)
#define REG_SC_BK8F_09_L      _PK_L_(0x8F, 0x09)
#define REG_SC_BK8F_09_H      _PK_H_(0x8F, 0x09)
#define REG_SC_BK8F_0A_L      _PK_L_(0x8F, 0x0A)
#define REG_SC_BK8F_0A_H      _PK_H_(0x8F, 0x0A)
#define REG_SC_BK8F_0B_L      _PK_L_(0x8F, 0x0B)
#define REG_SC_BK8F_0B_H      _PK_H_(0x8F, 0x0B)
#define REG_SC_BK8F_0C_L      _PK_L_(0x8F, 0x0C)
#define REG_SC_BK8F_0C_H      _PK_H_(0x8F, 0x0C)
#define REG_SC_BK8F_0D_L      _PK_L_(0x8F, 0x0D)
#define REG_SC_BK8F_0D_H      _PK_H_(0x8F, 0x0D)
#define REG_SC_BK8F_0E_L      _PK_L_(0x8F, 0x0E)
#define REG_SC_BK8F_0E_H      _PK_H_(0x8F, 0x0E)
#define REG_SC_BK8F_0F_L      _PK_L_(0x8F, 0x0F)
#define REG_SC_BK8F_0F_H      _PK_H_(0x8F, 0x0F)
#define REG_SC_BK8F_10_L      _PK_L_(0x8F, 0x10)
#define REG_SC_BK8F_10_H      _PK_H_(0x8F, 0x10)
#define REG_SC_BK8F_11_L      _PK_L_(0x8F, 0x11)
#define REG_SC_BK8F_11_H      _PK_H_(0x8F, 0x11)
#define REG_SC_BK8F_12_L      _PK_L_(0x8F, 0x12)
#define REG_SC_BK8F_12_H      _PK_H_(0x8F, 0x12)
#define REG_SC_BK8F_13_L      _PK_L_(0x8F, 0x13)
#define REG_SC_BK8F_13_H      _PK_H_(0x8F, 0x13)
#define REG_SC_BK8F_14_L      _PK_L_(0x8F, 0x14)
#define REG_SC_BK8F_14_H      _PK_H_(0x8F, 0x14)
#define REG_SC_BK8F_15_L      _PK_L_(0x8F, 0x15)
#define REG_SC_BK8F_15_H      _PK_H_(0x8F, 0x15)
#define REG_SC_BK8F_16_L      _PK_L_(0x8F, 0x16)
#define REG_SC_BK8F_16_H      _PK_H_(0x8F, 0x16)
#define REG_SC_BK8F_17_L      _PK_L_(0x8F, 0x17)
#define REG_SC_BK8F_17_H      _PK_H_(0x8F, 0x17)
#define REG_SC_BK8F_18_L      _PK_L_(0x8F, 0x18)
#define REG_SC_BK8F_18_H      _PK_H_(0x8F, 0x18)
#define REG_SC_BK8F_19_L      _PK_L_(0x8F, 0x19)
#define REG_SC_BK8F_19_H      _PK_H_(0x8F, 0x19)
#define REG_SC_BK8F_1A_L      _PK_L_(0x8F, 0x1A)
#define REG_SC_BK8F_1A_H      _PK_H_(0x8F, 0x1A)
#define REG_SC_BK8F_1B_L      _PK_L_(0x8F, 0x1B)
#define REG_SC_BK8F_1B_H      _PK_H_(0x8F, 0x1B)
#define REG_SC_BK8F_1C_L      _PK_L_(0x8F, 0x1C)
#define REG_SC_BK8F_1C_H      _PK_H_(0x8F, 0x1C)
#define REG_SC_BK8F_1D_L      _PK_L_(0x8F, 0x1D)
#define REG_SC_BK8F_1D_H      _PK_H_(0x8F, 0x1D)
#define REG_SC_BK8F_1E_L      _PK_L_(0x8F, 0x1E)
#define REG_SC_BK8F_1E_H      _PK_H_(0x8F, 0x1E)
#define REG_SC_BK8F_1F_L      _PK_L_(0x8F, 0x1F)
#define REG_SC_BK8F_1F_H      _PK_H_(0x8F, 0x1F)
#define REG_SC_BK8F_20_L      _PK_L_(0x8F, 0x20)
#define REG_SC_BK8F_20_H      _PK_H_(0x8F, 0x20)
#define REG_SC_BK8F_21_L      _PK_L_(0x8F, 0x21)
#define REG_SC_BK8F_21_H      _PK_H_(0x8F, 0x21)
#define REG_SC_BK8F_22_L      _PK_L_(0x8F, 0x22)
#define REG_SC_BK8F_22_H      _PK_H_(0x8F, 0x22)
#define REG_SC_BK8F_23_L      _PK_L_(0x8F, 0x23)
#define REG_SC_BK8F_23_H      _PK_H_(0x8F, 0x23)
#define REG_SC_BK8F_24_L      _PK_L_(0x8F, 0x24)
#define REG_SC_BK8F_24_H      _PK_H_(0x8F, 0x24)
#define REG_SC_BK8F_25_L      _PK_L_(0x8F, 0x25)
#define REG_SC_BK8F_25_H      _PK_H_(0x8F, 0x25)
#define REG_SC_BK8F_26_L      _PK_L_(0x8F, 0x26)
#define REG_SC_BK8F_26_H      _PK_H_(0x8F, 0x26)
#define REG_SC_BK8F_27_L      _PK_L_(0x8F, 0x27)
#define REG_SC_BK8F_27_H      _PK_H_(0x8F, 0x27)
#define REG_SC_BK8F_28_L      _PK_L_(0x8F, 0x28)
#define REG_SC_BK8F_28_H      _PK_H_(0x8F, 0x28)
#define REG_SC_BK8F_29_L      _PK_L_(0x8F, 0x29)
#define REG_SC_BK8F_29_H      _PK_H_(0x8F, 0x29)
#define REG_SC_BK8F_2A_L      _PK_L_(0x8F, 0x2A)
#define REG_SC_BK8F_2A_H      _PK_H_(0x8F, 0x2A)
#define REG_SC_BK8F_2B_L      _PK_L_(0x8F, 0x2B)
#define REG_SC_BK8F_2B_H      _PK_H_(0x8F, 0x2B)
#define REG_SC_BK8F_2C_L      _PK_L_(0x8F, 0x2C)
#define REG_SC_BK8F_2C_H      _PK_H_(0x8F, 0x2C)
#define REG_SC_BK8F_2D_L      _PK_L_(0x8F, 0x2D)
#define REG_SC_BK8F_2D_H      _PK_H_(0x8F, 0x2D)
#define REG_SC_BK8F_2E_L      _PK_L_(0x8F, 0x2E)
#define REG_SC_BK8F_2E_H      _PK_H_(0x8F, 0x2E)
#define REG_SC_BK8F_2F_L      _PK_L_(0x8F, 0x2F)
#define REG_SC_BK8F_2F_H      _PK_H_(0x8F, 0x2F)
#define REG_SC_BK8F_30_L      _PK_L_(0x8F, 0x30)
#define REG_SC_BK8F_30_H      _PK_H_(0x8F, 0x30)
#define REG_SC_BK8F_31_L      _PK_L_(0x8F, 0x31)
#define REG_SC_BK8F_31_H      _PK_H_(0x8F, 0x31)
#define REG_SC_BK8F_32_L      _PK_L_(0x8F, 0x32)
#define REG_SC_BK8F_32_H      _PK_H_(0x8F, 0x32)
#define REG_SC_BK8F_33_L      _PK_L_(0x8F, 0x33)
#define REG_SC_BK8F_33_H      _PK_H_(0x8F, 0x33)
#define REG_SC_BK8F_34_L      _PK_L_(0x8F, 0x34)
#define REG_SC_BK8F_34_H      _PK_H_(0x8F, 0x34)
#define REG_SC_BK8F_35_L      _PK_L_(0x8F, 0x35)
#define REG_SC_BK8F_35_H      _PK_H_(0x8F, 0x35)
#define REG_SC_BK8F_36_L      _PK_L_(0x8F, 0x36)
#define REG_SC_BK8F_36_H      _PK_H_(0x8F, 0x36)
#define REG_SC_BK8F_37_L      _PK_L_(0x8F, 0x37)
#define REG_SC_BK8F_37_H      _PK_H_(0x8F, 0x37)
#define REG_SC_BK8F_38_L      _PK_L_(0x8F, 0x38)
#define REG_SC_BK8F_38_H      _PK_H_(0x8F, 0x38)
#define REG_SC_BK8F_39_L      _PK_L_(0x8F, 0x39)
#define REG_SC_BK8F_39_H      _PK_H_(0x8F, 0x39)
#define REG_SC_BK8F_3A_L      _PK_L_(0x8F, 0x3A)
#define REG_SC_BK8F_3A_H      _PK_H_(0x8F, 0x3A)
#define REG_SC_BK8F_3B_L      _PK_L_(0x8F, 0x3B)
#define REG_SC_BK8F_3B_H      _PK_H_(0x8F, 0x3B)
#define REG_SC_BK8F_3C_L      _PK_L_(0x8F, 0x3C)
#define REG_SC_BK8F_3C_H      _PK_H_(0x8F, 0x3C)
#define REG_SC_BK8F_3D_L      _PK_L_(0x8F, 0x3D)
#define REG_SC_BK8F_3D_H      _PK_H_(0x8F, 0x3D)
#define REG_SC_BK8F_3E_L      _PK_L_(0x8F, 0x3E)
#define REG_SC_BK8F_3E_H      _PK_H_(0x8F, 0x3E)
#define REG_SC_BK8F_3F_L      _PK_L_(0x8F, 0x3F)
#define REG_SC_BK8F_3F_H      _PK_H_(0x8F, 0x3F)
#define REG_SC_BK8F_40_L      _PK_L_(0x8F, 0x40)
#define REG_SC_BK8F_40_H      _PK_H_(0x8F, 0x40)
#define REG_SC_BK8F_41_L      _PK_L_(0x8F, 0x41)
#define REG_SC_BK8F_41_H      _PK_H_(0x8F, 0x41)
#define REG_SC_BK8F_42_L      _PK_L_(0x8F, 0x42)
#define REG_SC_BK8F_42_H      _PK_H_(0x8F, 0x42)
#define REG_SC_BK8F_43_L      _PK_L_(0x8F, 0x43)
#define REG_SC_BK8F_43_H      _PK_H_(0x8F, 0x43)
#define REG_SC_BK8F_44_L      _PK_L_(0x8F, 0x44)
#define REG_SC_BK8F_44_H      _PK_H_(0x8F, 0x44)
#define REG_SC_BK8F_45_L      _PK_L_(0x8F, 0x45)
#define REG_SC_BK8F_45_H      _PK_H_(0x8F, 0x45)
#define REG_SC_BK8F_46_L      _PK_L_(0x8F, 0x46)
#define REG_SC_BK8F_46_H      _PK_H_(0x8F, 0x46)
#define REG_SC_BK8F_47_L      _PK_L_(0x8F, 0x47)
#define REG_SC_BK8F_47_H      _PK_H_(0x8F, 0x47)
#define REG_SC_BK8F_48_L      _PK_L_(0x8F, 0x48)
#define REG_SC_BK8F_48_H      _PK_H_(0x8F, 0x48)
#define REG_SC_BK8F_49_L      _PK_L_(0x8F, 0x49)
#define REG_SC_BK8F_49_H      _PK_H_(0x8F, 0x49)
#define REG_SC_BK8F_4A_L      _PK_L_(0x8F, 0x4A)
#define REG_SC_BK8F_4A_H      _PK_H_(0x8F, 0x4A)
#define REG_SC_BK8F_4B_L      _PK_L_(0x8F, 0x4B)
#define REG_SC_BK8F_4B_H      _PK_H_(0x8F, 0x4B)
#define REG_SC_BK8F_4C_L      _PK_L_(0x8F, 0x4C)
#define REG_SC_BK8F_4C_H      _PK_H_(0x8F, 0x4C)
#define REG_SC_BK8F_4D_L      _PK_L_(0x8F, 0x4D)
#define REG_SC_BK8F_4D_H      _PK_H_(0x8F, 0x4D)
#define REG_SC_BK8F_4E_L      _PK_L_(0x8F, 0x4E)
#define REG_SC_BK8F_4E_H      _PK_H_(0x8F, 0x4E)
#define REG_SC_BK8F_4F_L      _PK_L_(0x8F, 0x4F)
#define REG_SC_BK8F_4F_H      _PK_H_(0x8F, 0x4F)
#define REG_SC_BK8F_50_L      _PK_L_(0x8F, 0x50)
#define REG_SC_BK8F_50_H      _PK_H_(0x8F, 0x50)
#define REG_SC_BK8F_51_L      _PK_L_(0x8F, 0x51)
#define REG_SC_BK8F_51_H      _PK_H_(0x8F, 0x51)
#define REG_SC_BK8F_52_L      _PK_L_(0x8F, 0x52)
#define REG_SC_BK8F_52_H      _PK_H_(0x8F, 0x52)
#define REG_SC_BK8F_53_L      _PK_L_(0x8F, 0x53)
#define REG_SC_BK8F_53_H      _PK_H_(0x8F, 0x53)
#define REG_SC_BK8F_54_L      _PK_L_(0x8F, 0x54)
#define REG_SC_BK8F_54_H      _PK_H_(0x8F, 0x54)
#define REG_SC_BK8F_55_L      _PK_L_(0x8F, 0x55)
#define REG_SC_BK8F_55_H      _PK_H_(0x8F, 0x55)
#define REG_SC_BK8F_56_L      _PK_L_(0x8F, 0x56)
#define REG_SC_BK8F_56_H      _PK_H_(0x8F, 0x56)
#define REG_SC_BK8F_57_L      _PK_L_(0x8F, 0x57)
#define REG_SC_BK8F_57_H      _PK_H_(0x8F, 0x57)
#define REG_SC_BK8F_58_L      _PK_L_(0x8F, 0x58)
#define REG_SC_BK8F_58_H      _PK_H_(0x8F, 0x58)
#define REG_SC_BK8F_59_L      _PK_L_(0x8F, 0x59)
#define REG_SC_BK8F_59_H      _PK_H_(0x8F, 0x59)
#define REG_SC_BK8F_5A_L      _PK_L_(0x8F, 0x5A)
#define REG_SC_BK8F_5A_H      _PK_H_(0x8F, 0x5A)
#define REG_SC_BK8F_5B_L      _PK_L_(0x8F, 0x5B)
#define REG_SC_BK8F_5B_H      _PK_H_(0x8F, 0x5B)
#define REG_SC_BK8F_5C_L      _PK_L_(0x8F, 0x5C)
#define REG_SC_BK8F_5C_H      _PK_H_(0x8F, 0x5C)
#define REG_SC_BK8F_5D_L      _PK_L_(0x8F, 0x5D)
#define REG_SC_BK8F_5D_H      _PK_H_(0x8F, 0x5D)
#define REG_SC_BK8F_5E_L      _PK_L_(0x8F, 0x5E)
#define REG_SC_BK8F_5E_H      _PK_H_(0x8F, 0x5E)
#define REG_SC_BK8F_5F_L      _PK_L_(0x8F, 0x5F)
#define REG_SC_BK8F_5F_H      _PK_H_(0x8F, 0x5F)
#define REG_SC_BK8F_60_L      _PK_L_(0x8F, 0x60)
#define REG_SC_BK8F_60_H      _PK_H_(0x8F, 0x60)
#define REG_SC_BK8F_61_L      _PK_L_(0x8F, 0x61)
#define REG_SC_BK8F_61_H      _PK_H_(0x8F, 0x61)
#define REG_SC_BK8F_62_L      _PK_L_(0x8F, 0x62)
#define REG_SC_BK8F_62_H      _PK_H_(0x8F, 0x62)
#define REG_SC_BK8F_63_L      _PK_L_(0x8F, 0x63)
#define REG_SC_BK8F_63_H      _PK_H_(0x8F, 0x63)
#define REG_SC_BK8F_64_L      _PK_L_(0x8F, 0x64)
#define REG_SC_BK8F_64_H      _PK_H_(0x8F, 0x64)
#define REG_SC_BK8F_65_L      _PK_L_(0x8F, 0x65)
#define REG_SC_BK8F_65_H      _PK_H_(0x8F, 0x65)
#define REG_SC_BK8F_66_L      _PK_L_(0x8F, 0x66)
#define REG_SC_BK8F_66_H      _PK_H_(0x8F, 0x66)
#define REG_SC_BK8F_67_L      _PK_L_(0x8F, 0x67)
#define REG_SC_BK8F_67_H      _PK_H_(0x8F, 0x67)
#define REG_SC_BK8F_68_L      _PK_L_(0x8F, 0x68)
#define REG_SC_BK8F_68_H      _PK_H_(0x8F, 0x68)
#define REG_SC_BK8F_69_L      _PK_L_(0x8F, 0x69)
#define REG_SC_BK8F_69_H      _PK_H_(0x8F, 0x69)
#define REG_SC_BK8F_6A_L      _PK_L_(0x8F, 0x6A)
#define REG_SC_BK8F_6A_H      _PK_H_(0x8F, 0x6A)
#define REG_SC_BK8F_6B_L      _PK_L_(0x8F, 0x6B)
#define REG_SC_BK8F_6B_H      _PK_H_(0x8F, 0x6B)
#define REG_SC_BK8F_6C_L      _PK_L_(0x8F, 0x6C)
#define REG_SC_BK8F_6C_H      _PK_H_(0x8F, 0x6C)
#define REG_SC_BK8F_6D_L      _PK_L_(0x8F, 0x6D)
#define REG_SC_BK8F_6D_H      _PK_H_(0x8F, 0x6D)
#define REG_SC_BK8F_6E_L      _PK_L_(0x8F, 0x6E)
#define REG_SC_BK8F_6E_H      _PK_H_(0x8F, 0x6E)
#define REG_SC_BK8F_6F_L      _PK_L_(0x8F, 0x6F)
#define REG_SC_BK8F_6F_H      _PK_H_(0x8F, 0x6F)
#define REG_SC_BK8F_70_L      _PK_L_(0x8F, 0x70)
#define REG_SC_BK8F_70_H      _PK_H_(0x8F, 0x70)
#define REG_SC_BK8F_71_L      _PK_L_(0x8F, 0x71)
#define REG_SC_BK8F_71_H      _PK_H_(0x8F, 0x71)
#define REG_SC_BK8F_72_L      _PK_L_(0x8F, 0x72)
#define REG_SC_BK8F_72_H      _PK_H_(0x8F, 0x72)
#define REG_SC_BK8F_73_L      _PK_L_(0x8F, 0x73)
#define REG_SC_BK8F_73_H      _PK_H_(0x8F, 0x73)
#define REG_SC_BK8F_74_L      _PK_L_(0x8F, 0x74)
#define REG_SC_BK8F_74_H      _PK_H_(0x8F, 0x74)
#define REG_SC_BK8F_75_L      _PK_L_(0x8F, 0x75)
#define REG_SC_BK8F_75_H      _PK_H_(0x8F, 0x75)
#define REG_SC_BK8F_76_L      _PK_L_(0x8F, 0x76)
#define REG_SC_BK8F_76_H      _PK_H_(0x8F, 0x76)
#define REG_SC_BK8F_77_L      _PK_L_(0x8F, 0x77)
#define REG_SC_BK8F_77_H      _PK_H_(0x8F, 0x77)
#define REG_SC_BK8F_78_L      _PK_L_(0x8F, 0x78)
#define REG_SC_BK8F_78_H      _PK_H_(0x8F, 0x78)
#define REG_SC_BK8F_79_L      _PK_L_(0x8F, 0x79)
#define REG_SC_BK8F_79_H      _PK_H_(0x8F, 0x79)
#define REG_SC_BK8F_7A_L      _PK_L_(0x8F, 0x7A)
#define REG_SC_BK8F_7A_H      _PK_H_(0x8F, 0x7A)
#define REG_SC_BK8F_7B_L      _PK_L_(0x8F, 0x7B)
#define REG_SC_BK8F_7B_H      _PK_H_(0x8F, 0x7B)
#define REG_SC_BK8F_7C_L      _PK_L_(0x8F, 0x7C)
#define REG_SC_BK8F_7C_H      _PK_H_(0x8F, 0x7C)
#define REG_SC_BK8F_7D_L      _PK_L_(0x8F, 0x7D)
#define REG_SC_BK8F_7D_H      _PK_H_(0x8F, 0x7D)
#define REG_SC_BK8F_7E_L      _PK_L_(0x8F, 0x7E)
#define REG_SC_BK8F_7E_H      _PK_H_(0x8F, 0x7E)
#define REG_SC_BK8F_7F_L      _PK_L_(0x8F, 0x7F)
#define REG_SC_BK8F_7F_H      _PK_H_(0x8F, 0x7F)
//----------------------------------------------
#define REG_SC_BK90_00_L      _PK_L_(0x90, 0x00)
#define REG_SC_BK90_00_H      _PK_H_(0x90, 0x00)
#define REG_SC_BK90_01_L      _PK_L_(0x90, 0x01)
#define REG_SC_BK90_01_H      _PK_H_(0x90, 0x01)
#define REG_SC_BK90_02_L      _PK_L_(0x90, 0x02)
#define REG_SC_BK90_02_H      _PK_H_(0x90, 0x02)
#define REG_SC_BK90_03_L      _PK_L_(0x90, 0x03)
#define REG_SC_BK90_03_H      _PK_H_(0x90, 0x03)
#define REG_SC_BK90_04_L      _PK_L_(0x90, 0x04)
#define REG_SC_BK90_04_H      _PK_H_(0x90, 0x04)
#define REG_SC_BK90_05_L      _PK_L_(0x90, 0x05)
#define REG_SC_BK90_05_H      _PK_H_(0x90, 0x05)
#define REG_SC_BK90_06_L      _PK_L_(0x90, 0x06)
#define REG_SC_BK90_06_H      _PK_H_(0x90, 0x06)
#define REG_SC_BK90_07_L      _PK_L_(0x90, 0x07)
#define REG_SC_BK90_07_H      _PK_H_(0x90, 0x07)
#define REG_SC_BK90_08_L      _PK_L_(0x90, 0x08)
#define REG_SC_BK90_08_H      _PK_H_(0x90, 0x08)
#define REG_SC_BK90_09_L      _PK_L_(0x90, 0x09)
#define REG_SC_BK90_09_H      _PK_H_(0x90, 0x09)
#define REG_SC_BK90_0A_L      _PK_L_(0x90, 0x0A)
#define REG_SC_BK90_0A_H      _PK_H_(0x90, 0x0A)
#define REG_SC_BK90_0B_L      _PK_L_(0x90, 0x0B)
#define REG_SC_BK90_0B_H      _PK_H_(0x90, 0x0B)
#define REG_SC_BK90_0C_L      _PK_L_(0x90, 0x0C)
#define REG_SC_BK90_0C_H      _PK_H_(0x90, 0x0C)
#define REG_SC_BK90_0D_L      _PK_L_(0x90, 0x0D)
#define REG_SC_BK90_0D_H      _PK_H_(0x90, 0x0D)
#define REG_SC_BK90_0E_L      _PK_L_(0x90, 0x0E)
#define REG_SC_BK90_0E_H      _PK_H_(0x90, 0x0E)
#define REG_SC_BK90_0F_L      _PK_L_(0x90, 0x0F)
#define REG_SC_BK90_0F_H      _PK_H_(0x90, 0x0F)
#define REG_SC_BK90_10_L      _PK_L_(0x90, 0x10)
#define REG_SC_BK90_10_H      _PK_H_(0x90, 0x10)
#define REG_SC_BK90_11_L      _PK_L_(0x90, 0x11)
#define REG_SC_BK90_11_H      _PK_H_(0x90, 0x11)
#define REG_SC_BK90_12_L      _PK_L_(0x90, 0x12)
#define REG_SC_BK90_12_H      _PK_H_(0x90, 0x12)
#define REG_SC_BK90_13_L      _PK_L_(0x90, 0x13)
#define REG_SC_BK90_13_H      _PK_H_(0x90, 0x13)
#define REG_SC_BK90_14_L      _PK_L_(0x90, 0x14)
#define REG_SC_BK90_14_H      _PK_H_(0x90, 0x14)
#define REG_SC_BK90_15_L      _PK_L_(0x90, 0x15)
#define REG_SC_BK90_15_H      _PK_H_(0x90, 0x15)
#define REG_SC_BK90_16_L      _PK_L_(0x90, 0x16)
#define REG_SC_BK90_16_H      _PK_H_(0x90, 0x16)
#define REG_SC_BK90_17_L      _PK_L_(0x90, 0x17)
#define REG_SC_BK90_17_H      _PK_H_(0x90, 0x17)
#define REG_SC_BK90_18_L      _PK_L_(0x90, 0x18)
#define REG_SC_BK90_18_H      _PK_H_(0x90, 0x18)
#define REG_SC_BK90_19_L      _PK_L_(0x90, 0x19)
#define REG_SC_BK90_19_H      _PK_H_(0x90, 0x19)
#define REG_SC_BK90_1A_L      _PK_L_(0x90, 0x1A)
#define REG_SC_BK90_1A_H      _PK_H_(0x90, 0x1A)
#define REG_SC_BK90_1B_L      _PK_L_(0x90, 0x1B)
#define REG_SC_BK90_1B_H      _PK_H_(0x90, 0x1B)
#define REG_SC_BK90_1C_L      _PK_L_(0x90, 0x1C)
#define REG_SC_BK90_1C_H      _PK_H_(0x90, 0x1C)
#define REG_SC_BK90_1D_L      _PK_L_(0x90, 0x1D)
#define REG_SC_BK90_1D_H      _PK_H_(0x90, 0x1D)
#define REG_SC_BK90_1E_L      _PK_L_(0x90, 0x1E)
#define REG_SC_BK90_1E_H      _PK_H_(0x90, 0x1E)
#define REG_SC_BK90_1F_L      _PK_L_(0x90, 0x1F)
#define REG_SC_BK90_1F_H      _PK_H_(0x90, 0x1F)
#define REG_SC_BK90_20_L      _PK_L_(0x90, 0x20)
#define REG_SC_BK90_20_H      _PK_H_(0x90, 0x20)
#define REG_SC_BK90_21_L      _PK_L_(0x90, 0x21)
#define REG_SC_BK90_21_H      _PK_H_(0x90, 0x21)
#define REG_SC_BK90_22_L      _PK_L_(0x90, 0x22)
#define REG_SC_BK90_22_H      _PK_H_(0x90, 0x22)
#define REG_SC_BK90_23_L      _PK_L_(0x90, 0x23)
#define REG_SC_BK90_23_H      _PK_H_(0x90, 0x23)
#define REG_SC_BK90_24_L      _PK_L_(0x90, 0x24)
#define REG_SC_BK90_24_H      _PK_H_(0x90, 0x24)
#define REG_SC_BK90_25_L      _PK_L_(0x90, 0x25)
#define REG_SC_BK90_25_H      _PK_H_(0x90, 0x25)
#define REG_SC_BK90_26_L      _PK_L_(0x90, 0x26)
#define REG_SC_BK90_26_H      _PK_H_(0x90, 0x26)
#define REG_SC_BK90_27_L      _PK_L_(0x90, 0x27)
#define REG_SC_BK90_27_H      _PK_H_(0x90, 0x27)
#define REG_SC_BK90_28_L      _PK_L_(0x90, 0x28)
#define REG_SC_BK90_28_H      _PK_H_(0x90, 0x28)
#define REG_SC_BK90_29_L      _PK_L_(0x90, 0x29)
#define REG_SC_BK90_29_H      _PK_H_(0x90, 0x29)
#define REG_SC_BK90_2A_L      _PK_L_(0x90, 0x2A)
#define REG_SC_BK90_2A_H      _PK_H_(0x90, 0x2A)
#define REG_SC_BK90_2B_L      _PK_L_(0x90, 0x2B)
#define REG_SC_BK90_2B_H      _PK_H_(0x90, 0x2B)
#define REG_SC_BK90_2C_L      _PK_L_(0x90, 0x2C)
#define REG_SC_BK90_2C_H      _PK_H_(0x90, 0x2C)
#define REG_SC_BK90_2D_L      _PK_L_(0x90, 0x2D)
#define REG_SC_BK90_2D_H      _PK_H_(0x90, 0x2D)
#define REG_SC_BK90_2E_L      _PK_L_(0x90, 0x2E)
#define REG_SC_BK90_2E_H      _PK_H_(0x90, 0x2E)
#define REG_SC_BK90_2F_L      _PK_L_(0x90, 0x2F)
#define REG_SC_BK90_2F_H      _PK_H_(0x90, 0x2F)
#define REG_SC_BK90_30_L      _PK_L_(0x90, 0x30)
#define REG_SC_BK90_30_H      _PK_H_(0x90, 0x30)
#define REG_SC_BK90_31_L      _PK_L_(0x90, 0x31)
#define REG_SC_BK90_31_H      _PK_H_(0x90, 0x31)
#define REG_SC_BK90_32_L      _PK_L_(0x90, 0x32)
#define REG_SC_BK90_32_H      _PK_H_(0x90, 0x32)
#define REG_SC_BK90_33_L      _PK_L_(0x90, 0x33)
#define REG_SC_BK90_33_H      _PK_H_(0x90, 0x33)
#define REG_SC_BK90_34_L      _PK_L_(0x90, 0x34)
#define REG_SC_BK90_34_H      _PK_H_(0x90, 0x34)
#define REG_SC_BK90_35_L      _PK_L_(0x90, 0x35)
#define REG_SC_BK90_35_H      _PK_H_(0x90, 0x35)
#define REG_SC_BK90_36_L      _PK_L_(0x90, 0x36)
#define REG_SC_BK90_36_H      _PK_H_(0x90, 0x36)
#define REG_SC_BK90_37_L      _PK_L_(0x90, 0x37)
#define REG_SC_BK90_37_H      _PK_H_(0x90, 0x37)
#define REG_SC_BK90_38_L      _PK_L_(0x90, 0x38)
#define REG_SC_BK90_38_H      _PK_H_(0x90, 0x38)
#define REG_SC_BK90_39_L      _PK_L_(0x90, 0x39)
#define REG_SC_BK90_39_H      _PK_H_(0x90, 0x39)
#define REG_SC_BK90_3A_L      _PK_L_(0x90, 0x3A)
#define REG_SC_BK90_3A_H      _PK_H_(0x90, 0x3A)
#define REG_SC_BK90_3B_L      _PK_L_(0x90, 0x3B)
#define REG_SC_BK90_3B_H      _PK_H_(0x90, 0x3B)
#define REG_SC_BK90_3C_L      _PK_L_(0x90, 0x3C)
#define REG_SC_BK90_3C_H      _PK_H_(0x90, 0x3C)
#define REG_SC_BK90_3D_L      _PK_L_(0x90, 0x3D)
#define REG_SC_BK90_3D_H      _PK_H_(0x90, 0x3D)
#define REG_SC_BK90_3E_L      _PK_L_(0x90, 0x3E)
#define REG_SC_BK90_3E_H      _PK_H_(0x90, 0x3E)
#define REG_SC_BK90_3F_L      _PK_L_(0x90, 0x3F)
#define REG_SC_BK90_3F_H      _PK_H_(0x90, 0x3F)
#define REG_SC_BK90_40_L      _PK_L_(0x90, 0x40)
#define REG_SC_BK90_40_H      _PK_H_(0x90, 0x40)
#define REG_SC_BK90_41_L      _PK_L_(0x90, 0x41)
#define REG_SC_BK90_41_H      _PK_H_(0x90, 0x41)
#define REG_SC_BK90_42_L      _PK_L_(0x90, 0x42)
#define REG_SC_BK90_42_H      _PK_H_(0x90, 0x42)
#define REG_SC_BK90_43_L      _PK_L_(0x90, 0x43)
#define REG_SC_BK90_43_H      _PK_H_(0x90, 0x43)
#define REG_SC_BK90_44_L      _PK_L_(0x90, 0x44)
#define REG_SC_BK90_44_H      _PK_H_(0x90, 0x44)
#define REG_SC_BK90_45_L      _PK_L_(0x90, 0x45)
#define REG_SC_BK90_45_H      _PK_H_(0x90, 0x45)
#define REG_SC_BK90_46_L      _PK_L_(0x90, 0x46)
#define REG_SC_BK90_46_H      _PK_H_(0x90, 0x46)
#define REG_SC_BK90_47_L      _PK_L_(0x90, 0x47)
#define REG_SC_BK90_47_H      _PK_H_(0x90, 0x47)
#define REG_SC_BK90_48_L      _PK_L_(0x90, 0x48)
#define REG_SC_BK90_48_H      _PK_H_(0x90, 0x48)
#define REG_SC_BK90_49_L      _PK_L_(0x90, 0x49)
#define REG_SC_BK90_49_H      _PK_H_(0x90, 0x49)
#define REG_SC_BK90_4A_L      _PK_L_(0x90, 0x4A)
#define REG_SC_BK90_4A_H      _PK_H_(0x90, 0x4A)
#define REG_SC_BK90_4B_L      _PK_L_(0x90, 0x4B)
#define REG_SC_BK90_4B_H      _PK_H_(0x90, 0x4B)
#define REG_SC_BK90_4C_L      _PK_L_(0x90, 0x4C)
#define REG_SC_BK90_4C_H      _PK_H_(0x90, 0x4C)
#define REG_SC_BK90_4D_L      _PK_L_(0x90, 0x4D)
#define REG_SC_BK90_4D_H      _PK_H_(0x90, 0x4D)
#define REG_SC_BK90_4E_L      _PK_L_(0x90, 0x4E)
#define REG_SC_BK90_4E_H      _PK_H_(0x90, 0x4E)
#define REG_SC_BK90_4F_L      _PK_L_(0x90, 0x4F)
#define REG_SC_BK90_4F_H      _PK_H_(0x90, 0x4F)
#define REG_SC_BK90_50_L      _PK_L_(0x90, 0x50)
#define REG_SC_BK90_50_H      _PK_H_(0x90, 0x50)
#define REG_SC_BK90_51_L      _PK_L_(0x90, 0x51)
#define REG_SC_BK90_51_H      _PK_H_(0x90, 0x51)
#define REG_SC_BK90_52_L      _PK_L_(0x90, 0x52)
#define REG_SC_BK90_52_H      _PK_H_(0x90, 0x52)
#define REG_SC_BK90_53_L      _PK_L_(0x90, 0x53)
#define REG_SC_BK90_53_H      _PK_H_(0x90, 0x53)
#define REG_SC_BK90_54_L      _PK_L_(0x90, 0x54)
#define REG_SC_BK90_54_H      _PK_H_(0x90, 0x54)
#define REG_SC_BK90_55_L      _PK_L_(0x90, 0x55)
#define REG_SC_BK90_55_H      _PK_H_(0x90, 0x55)
#define REG_SC_BK90_56_L      _PK_L_(0x90, 0x56)
#define REG_SC_BK90_56_H      _PK_H_(0x90, 0x56)
#define REG_SC_BK90_57_L      _PK_L_(0x90, 0x57)
#define REG_SC_BK90_57_H      _PK_H_(0x90, 0x57)
#define REG_SC_BK90_58_L      _PK_L_(0x90, 0x58)
#define REG_SC_BK90_58_H      _PK_H_(0x90, 0x58)
#define REG_SC_BK90_59_L      _PK_L_(0x90, 0x59)
#define REG_SC_BK90_59_H      _PK_H_(0x90, 0x59)
#define REG_SC_BK90_5A_L      _PK_L_(0x90, 0x5A)
#define REG_SC_BK90_5A_H      _PK_H_(0x90, 0x5A)
#define REG_SC_BK90_5B_L      _PK_L_(0x90, 0x5B)
#define REG_SC_BK90_5B_H      _PK_H_(0x90, 0x5B)
#define REG_SC_BK90_5C_L      _PK_L_(0x90, 0x5C)
#define REG_SC_BK90_5C_H      _PK_H_(0x90, 0x5C)
#define REG_SC_BK90_5D_L      _PK_L_(0x90, 0x5D)
#define REG_SC_BK90_5D_H      _PK_H_(0x90, 0x5D)
#define REG_SC_BK90_5E_L      _PK_L_(0x90, 0x5E)
#define REG_SC_BK90_5E_H      _PK_H_(0x90, 0x5E)
#define REG_SC_BK90_5F_L      _PK_L_(0x90, 0x5F)
#define REG_SC_BK90_5F_H      _PK_H_(0x90, 0x5F)
#define REG_SC_BK90_60_L      _PK_L_(0x90, 0x60)
#define REG_SC_BK90_60_H      _PK_H_(0x90, 0x60)
#define REG_SC_BK90_61_L      _PK_L_(0x90, 0x61)
#define REG_SC_BK90_61_H      _PK_H_(0x90, 0x61)
#define REG_SC_BK90_62_L      _PK_L_(0x90, 0x62)
#define REG_SC_BK90_62_H      _PK_H_(0x90, 0x62)
#define REG_SC_BK90_63_L      _PK_L_(0x90, 0x63)
#define REG_SC_BK90_63_H      _PK_H_(0x90, 0x63)
#define REG_SC_BK90_64_L      _PK_L_(0x90, 0x64)
#define REG_SC_BK90_64_H      _PK_H_(0x90, 0x64)
#define REG_SC_BK90_65_L      _PK_L_(0x90, 0x65)
#define REG_SC_BK90_65_H      _PK_H_(0x90, 0x65)
#define REG_SC_BK90_66_L      _PK_L_(0x90, 0x66)
#define REG_SC_BK90_66_H      _PK_H_(0x90, 0x66)
#define REG_SC_BK90_67_L      _PK_L_(0x90, 0x67)
#define REG_SC_BK90_67_H      _PK_H_(0x90, 0x67)
#define REG_SC_BK90_68_L      _PK_L_(0x90, 0x68)
#define REG_SC_BK90_68_H      _PK_H_(0x90, 0x68)
#define REG_SC_BK90_69_L      _PK_L_(0x90, 0x69)
#define REG_SC_BK90_69_H      _PK_H_(0x90, 0x69)
#define REG_SC_BK90_6A_L      _PK_L_(0x90, 0x6A)
#define REG_SC_BK90_6A_H      _PK_H_(0x90, 0x6A)
#define REG_SC_BK90_6B_L      _PK_L_(0x90, 0x6B)
#define REG_SC_BK90_6B_H      _PK_H_(0x90, 0x6B)
#define REG_SC_BK90_6C_L      _PK_L_(0x90, 0x6C)
#define REG_SC_BK90_6C_H      _PK_H_(0x90, 0x6C)
#define REG_SC_BK90_6D_L      _PK_L_(0x90, 0x6D)
#define REG_SC_BK90_6D_H      _PK_H_(0x90, 0x6D)
#define REG_SC_BK90_6E_L      _PK_L_(0x90, 0x6E)
#define REG_SC_BK90_6E_H      _PK_H_(0x90, 0x6E)
#define REG_SC_BK90_6F_L      _PK_L_(0x90, 0x6F)
#define REG_SC_BK90_6F_H      _PK_H_(0x90, 0x6F)
#define REG_SC_BK90_70_L      _PK_L_(0x90, 0x70)
#define REG_SC_BK90_70_H      _PK_H_(0x90, 0x70)
#define REG_SC_BK90_71_L      _PK_L_(0x90, 0x71)
#define REG_SC_BK90_71_H      _PK_H_(0x90, 0x71)
#define REG_SC_BK90_72_L      _PK_L_(0x90, 0x72)
#define REG_SC_BK90_72_H      _PK_H_(0x90, 0x72)
#define REG_SC_BK90_73_L      _PK_L_(0x90, 0x73)
#define REG_SC_BK90_73_H      _PK_H_(0x90, 0x73)
#define REG_SC_BK90_74_L      _PK_L_(0x90, 0x74)
#define REG_SC_BK90_74_H      _PK_H_(0x90, 0x74)
#define REG_SC_BK90_75_L      _PK_L_(0x90, 0x75)
#define REG_SC_BK90_75_H      _PK_H_(0x90, 0x75)
#define REG_SC_BK90_76_L      _PK_L_(0x90, 0x76)
#define REG_SC_BK90_76_H      _PK_H_(0x90, 0x76)
#define REG_SC_BK90_77_L      _PK_L_(0x90, 0x77)
#define REG_SC_BK90_77_H      _PK_H_(0x90, 0x77)
#define REG_SC_BK90_78_L      _PK_L_(0x90, 0x78)
#define REG_SC_BK90_78_H      _PK_H_(0x90, 0x78)
#define REG_SC_BK90_79_L      _PK_L_(0x90, 0x79)
#define REG_SC_BK90_79_H      _PK_H_(0x90, 0x79)
#define REG_SC_BK90_7A_L      _PK_L_(0x90, 0x7A)
#define REG_SC_BK90_7A_H      _PK_H_(0x90, 0x7A)
#define REG_SC_BK90_7B_L      _PK_L_(0x90, 0x7B)
#define REG_SC_BK90_7B_H      _PK_H_(0x90, 0x7B)
#define REG_SC_BK90_7C_L      _PK_L_(0x90, 0x7C)
#define REG_SC_BK90_7C_H      _PK_H_(0x90, 0x7C)
#define REG_SC_BK90_7D_L      _PK_L_(0x90, 0x7D)
#define REG_SC_BK90_7D_H      _PK_H_(0x90, 0x7D)
#define REG_SC_BK90_7E_L      _PK_L_(0x90, 0x7E)
#define REG_SC_BK90_7E_H      _PK_H_(0x90, 0x7E)
#define REG_SC_BK90_7F_L      _PK_L_(0x90, 0x7F)
#define REG_SC_BK90_7F_H      _PK_H_(0x90, 0x7F)
//----------------------------------------------
#define REG_SC_BK91_00_L      _PK_L_(0x91, 0x00)
#define REG_SC_BK91_00_H      _PK_H_(0x91, 0x00)
#define REG_SC_BK91_01_L      _PK_L_(0x91, 0x01)
#define REG_SC_BK91_01_H      _PK_H_(0x91, 0x01)
#define REG_SC_BK91_02_L      _PK_L_(0x91, 0x02)
#define REG_SC_BK91_02_H      _PK_H_(0x91, 0x02)
#define REG_SC_BK91_03_L      _PK_L_(0x91, 0x03)
#define REG_SC_BK91_03_H      _PK_H_(0x91, 0x03)
#define REG_SC_BK91_04_L      _PK_L_(0x91, 0x04)
#define REG_SC_BK91_04_H      _PK_H_(0x91, 0x04)
#define REG_SC_BK91_05_L      _PK_L_(0x91, 0x05)
#define REG_SC_BK91_05_H      _PK_H_(0x91, 0x05)
#define REG_SC_BK91_06_L      _PK_L_(0x91, 0x06)
#define REG_SC_BK91_06_H      _PK_H_(0x91, 0x06)
#define REG_SC_BK91_07_L      _PK_L_(0x91, 0x07)
#define REG_SC_BK91_07_H      _PK_H_(0x91, 0x07)
#define REG_SC_BK91_08_L      _PK_L_(0x91, 0x08)
#define REG_SC_BK91_08_H      _PK_H_(0x91, 0x08)
#define REG_SC_BK91_09_L      _PK_L_(0x91, 0x09)
#define REG_SC_BK91_09_H      _PK_H_(0x91, 0x09)
#define REG_SC_BK91_0A_L      _PK_L_(0x91, 0x0A)
#define REG_SC_BK91_0A_H      _PK_H_(0x91, 0x0A)
#define REG_SC_BK91_0B_L      _PK_L_(0x91, 0x0B)
#define REG_SC_BK91_0B_H      _PK_H_(0x91, 0x0B)
#define REG_SC_BK91_0C_L      _PK_L_(0x91, 0x0C)
#define REG_SC_BK91_0C_H      _PK_H_(0x91, 0x0C)
#define REG_SC_BK91_0D_L      _PK_L_(0x91, 0x0D)
#define REG_SC_BK91_0D_H      _PK_H_(0x91, 0x0D)
#define REG_SC_BK91_0E_L      _PK_L_(0x91, 0x0E)
#define REG_SC_BK91_0E_H      _PK_H_(0x91, 0x0E)
#define REG_SC_BK91_0F_L      _PK_L_(0x91, 0x0F)
#define REG_SC_BK91_0F_H      _PK_H_(0x91, 0x0F)
#define REG_SC_BK91_10_L      _PK_L_(0x91, 0x10)
#define REG_SC_BK91_10_H      _PK_H_(0x91, 0x10)
#define REG_SC_BK91_11_L      _PK_L_(0x91, 0x11)
#define REG_SC_BK91_11_H      _PK_H_(0x91, 0x11)
#define REG_SC_BK91_12_L      _PK_L_(0x91, 0x12)
#define REG_SC_BK91_12_H      _PK_H_(0x91, 0x12)
#define REG_SC_BK91_13_L      _PK_L_(0x91, 0x13)
#define REG_SC_BK91_13_H      _PK_H_(0x91, 0x13)
#define REG_SC_BK91_14_L      _PK_L_(0x91, 0x14)
#define REG_SC_BK91_14_H      _PK_H_(0x91, 0x14)
#define REG_SC_BK91_15_L      _PK_L_(0x91, 0x15)
#define REG_SC_BK91_15_H      _PK_H_(0x91, 0x15)
#define REG_SC_BK91_16_L      _PK_L_(0x91, 0x16)
#define REG_SC_BK91_16_H      _PK_H_(0x91, 0x16)
#define REG_SC_BK91_17_L      _PK_L_(0x91, 0x17)
#define REG_SC_BK91_17_H      _PK_H_(0x91, 0x17)
#define REG_SC_BK91_18_L      _PK_L_(0x91, 0x18)
#define REG_SC_BK91_18_H      _PK_H_(0x91, 0x18)
#define REG_SC_BK91_19_L      _PK_L_(0x91, 0x19)
#define REG_SC_BK91_19_H      _PK_H_(0x91, 0x19)
#define REG_SC_BK91_1A_L      _PK_L_(0x91, 0x1A)
#define REG_SC_BK91_1A_H      _PK_H_(0x91, 0x1A)
#define REG_SC_BK91_1B_L      _PK_L_(0x91, 0x1B)
#define REG_SC_BK91_1B_H      _PK_H_(0x91, 0x1B)
#define REG_SC_BK91_1C_L      _PK_L_(0x91, 0x1C)
#define REG_SC_BK91_1C_H      _PK_H_(0x91, 0x1C)
#define REG_SC_BK91_1D_L      _PK_L_(0x91, 0x1D)
#define REG_SC_BK91_1D_H      _PK_H_(0x91, 0x1D)
#define REG_SC_BK91_1E_L      _PK_L_(0x91, 0x1E)
#define REG_SC_BK91_1E_H      _PK_H_(0x91, 0x1E)
#define REG_SC_BK91_1F_L      _PK_L_(0x91, 0x1F)
#define REG_SC_BK91_1F_H      _PK_H_(0x91, 0x1F)
#define REG_SC_BK91_20_L      _PK_L_(0x91, 0x20)
#define REG_SC_BK91_20_H      _PK_H_(0x91, 0x20)
#define REG_SC_BK91_21_L      _PK_L_(0x91, 0x21)
#define REG_SC_BK91_21_H      _PK_H_(0x91, 0x21)
#define REG_SC_BK91_22_L      _PK_L_(0x91, 0x22)
#define REG_SC_BK91_22_H      _PK_H_(0x91, 0x22)
#define REG_SC_BK91_23_L      _PK_L_(0x91, 0x23)
#define REG_SC_BK91_23_H      _PK_H_(0x91, 0x23)
#define REG_SC_BK91_24_L      _PK_L_(0x91, 0x24)
#define REG_SC_BK91_24_H      _PK_H_(0x91, 0x24)
#define REG_SC_BK91_25_L      _PK_L_(0x91, 0x25)
#define REG_SC_BK91_25_H      _PK_H_(0x91, 0x25)
#define REG_SC_BK91_26_L      _PK_L_(0x91, 0x26)
#define REG_SC_BK91_26_H      _PK_H_(0x91, 0x26)
#define REG_SC_BK91_27_L      _PK_L_(0x91, 0x27)
#define REG_SC_BK91_27_H      _PK_H_(0x91, 0x27)
#define REG_SC_BK91_28_L      _PK_L_(0x91, 0x28)
#define REG_SC_BK91_28_H      _PK_H_(0x91, 0x28)
#define REG_SC_BK91_29_L      _PK_L_(0x91, 0x29)
#define REG_SC_BK91_29_H      _PK_H_(0x91, 0x29)
#define REG_SC_BK91_2A_L      _PK_L_(0x91, 0x2A)
#define REG_SC_BK91_2A_H      _PK_H_(0x91, 0x2A)
#define REG_SC_BK91_2B_L      _PK_L_(0x91, 0x2B)
#define REG_SC_BK91_2B_H      _PK_H_(0x91, 0x2B)
#define REG_SC_BK91_2C_L      _PK_L_(0x91, 0x2C)
#define REG_SC_BK91_2C_H      _PK_H_(0x91, 0x2C)
#define REG_SC_BK91_2D_L      _PK_L_(0x91, 0x2D)
#define REG_SC_BK91_2D_H      _PK_H_(0x91, 0x2D)
#define REG_SC_BK91_2E_L      _PK_L_(0x91, 0x2E)
#define REG_SC_BK91_2E_H      _PK_H_(0x91, 0x2E)
#define REG_SC_BK91_2F_L      _PK_L_(0x91, 0x2F)
#define REG_SC_BK91_2F_H      _PK_H_(0x91, 0x2F)
#define REG_SC_BK91_30_L      _PK_L_(0x91, 0x30)
#define REG_SC_BK91_30_H      _PK_H_(0x91, 0x30)
#define REG_SC_BK91_31_L      _PK_L_(0x91, 0x31)
#define REG_SC_BK91_31_H      _PK_H_(0x91, 0x31)
#define REG_SC_BK91_32_L      _PK_L_(0x91, 0x32)
#define REG_SC_BK91_32_H      _PK_H_(0x91, 0x32)
#define REG_SC_BK91_33_L      _PK_L_(0x91, 0x33)
#define REG_SC_BK91_33_H      _PK_H_(0x91, 0x33)
#define REG_SC_BK91_34_L      _PK_L_(0x91, 0x34)
#define REG_SC_BK91_34_H      _PK_H_(0x91, 0x34)
#define REG_SC_BK91_35_L      _PK_L_(0x91, 0x35)
#define REG_SC_BK91_35_H      _PK_H_(0x91, 0x35)
#define REG_SC_BK91_36_L      _PK_L_(0x91, 0x36)
#define REG_SC_BK91_36_H      _PK_H_(0x91, 0x36)
#define REG_SC_BK91_37_L      _PK_L_(0x91, 0x37)
#define REG_SC_BK91_37_H      _PK_H_(0x91, 0x37)
#define REG_SC_BK91_38_L      _PK_L_(0x91, 0x38)
#define REG_SC_BK91_38_H      _PK_H_(0x91, 0x38)
#define REG_SC_BK91_39_L      _PK_L_(0x91, 0x39)
#define REG_SC_BK91_39_H      _PK_H_(0x91, 0x39)
#define REG_SC_BK91_3A_L      _PK_L_(0x91, 0x3A)
#define REG_SC_BK91_3A_H      _PK_H_(0x91, 0x3A)
#define REG_SC_BK91_3B_L      _PK_L_(0x91, 0x3B)
#define REG_SC_BK91_3B_H      _PK_H_(0x91, 0x3B)
#define REG_SC_BK91_3C_L      _PK_L_(0x91, 0x3C)
#define REG_SC_BK91_3C_H      _PK_H_(0x91, 0x3C)
#define REG_SC_BK91_3D_L      _PK_L_(0x91, 0x3D)
#define REG_SC_BK91_3D_H      _PK_H_(0x91, 0x3D)
#define REG_SC_BK91_3E_L      _PK_L_(0x91, 0x3E)
#define REG_SC_BK91_3E_H      _PK_H_(0x91, 0x3E)
#define REG_SC_BK91_3F_L      _PK_L_(0x91, 0x3F)
#define REG_SC_BK91_3F_H      _PK_H_(0x91, 0x3F)
#define REG_SC_BK91_40_L      _PK_L_(0x91, 0x40)
#define REG_SC_BK91_40_H      _PK_H_(0x91, 0x40)
#define REG_SC_BK91_41_L      _PK_L_(0x91, 0x41)
#define REG_SC_BK91_41_H      _PK_H_(0x91, 0x41)
#define REG_SC_BK91_42_L      _PK_L_(0x91, 0x42)
#define REG_SC_BK91_42_H      _PK_H_(0x91, 0x42)
#define REG_SC_BK91_43_L      _PK_L_(0x91, 0x43)
#define REG_SC_BK91_43_H      _PK_H_(0x91, 0x43)
#define REG_SC_BK91_44_L      _PK_L_(0x91, 0x44)
#define REG_SC_BK91_44_H      _PK_H_(0x91, 0x44)
#define REG_SC_BK91_45_L      _PK_L_(0x91, 0x45)
#define REG_SC_BK91_45_H      _PK_H_(0x91, 0x45)
#define REG_SC_BK91_46_L      _PK_L_(0x91, 0x46)
#define REG_SC_BK91_46_H      _PK_H_(0x91, 0x46)
#define REG_SC_BK91_47_L      _PK_L_(0x91, 0x47)
#define REG_SC_BK91_47_H      _PK_H_(0x91, 0x47)
#define REG_SC_BK91_48_L      _PK_L_(0x91, 0x48)
#define REG_SC_BK91_48_H      _PK_H_(0x91, 0x48)
#define REG_SC_BK91_49_L      _PK_L_(0x91, 0x49)
#define REG_SC_BK91_49_H      _PK_H_(0x91, 0x49)
#define REG_SC_BK91_4A_L      _PK_L_(0x91, 0x4A)
#define REG_SC_BK91_4A_H      _PK_H_(0x91, 0x4A)
#define REG_SC_BK91_4B_L      _PK_L_(0x91, 0x4B)
#define REG_SC_BK91_4B_H      _PK_H_(0x91, 0x4B)
#define REG_SC_BK91_4C_L      _PK_L_(0x91, 0x4C)
#define REG_SC_BK91_4C_H      _PK_H_(0x91, 0x4C)
#define REG_SC_BK91_4D_L      _PK_L_(0x91, 0x4D)
#define REG_SC_BK91_4D_H      _PK_H_(0x91, 0x4D)
#define REG_SC_BK91_4E_L      _PK_L_(0x91, 0x4E)
#define REG_SC_BK91_4E_H      _PK_H_(0x91, 0x4E)
#define REG_SC_BK91_4F_L      _PK_L_(0x91, 0x4F)
#define REG_SC_BK91_4F_H      _PK_H_(0x91, 0x4F)
#define REG_SC_BK91_50_L      _PK_L_(0x91, 0x50)
#define REG_SC_BK91_50_H      _PK_H_(0x91, 0x50)
#define REG_SC_BK91_51_L      _PK_L_(0x91, 0x51)
#define REG_SC_BK91_51_H      _PK_H_(0x91, 0x51)
#define REG_SC_BK91_52_L      _PK_L_(0x91, 0x52)
#define REG_SC_BK91_52_H      _PK_H_(0x91, 0x52)
#define REG_SC_BK91_53_L      _PK_L_(0x91, 0x53)
#define REG_SC_BK91_53_H      _PK_H_(0x91, 0x53)
#define REG_SC_BK91_54_L      _PK_L_(0x91, 0x54)
#define REG_SC_BK91_54_H      _PK_H_(0x91, 0x54)
#define REG_SC_BK91_55_L      _PK_L_(0x91, 0x55)
#define REG_SC_BK91_55_H      _PK_H_(0x91, 0x55)
#define REG_SC_BK91_56_L      _PK_L_(0x91, 0x56)
#define REG_SC_BK91_56_H      _PK_H_(0x91, 0x56)
#define REG_SC_BK91_57_L      _PK_L_(0x91, 0x57)
#define REG_SC_BK91_57_H      _PK_H_(0x91, 0x57)
#define REG_SC_BK91_58_L      _PK_L_(0x91, 0x58)
#define REG_SC_BK91_58_H      _PK_H_(0x91, 0x58)
#define REG_SC_BK91_59_L      _PK_L_(0x91, 0x59)
#define REG_SC_BK91_59_H      _PK_H_(0x91, 0x59)
#define REG_SC_BK91_5A_L      _PK_L_(0x91, 0x5A)
#define REG_SC_BK91_5A_H      _PK_H_(0x91, 0x5A)
#define REG_SC_BK91_5B_L      _PK_L_(0x91, 0x5B)
#define REG_SC_BK91_5B_H      _PK_H_(0x91, 0x5B)
#define REG_SC_BK91_5C_L      _PK_L_(0x91, 0x5C)
#define REG_SC_BK91_5C_H      _PK_H_(0x91, 0x5C)
#define REG_SC_BK91_5D_L      _PK_L_(0x91, 0x5D)
#define REG_SC_BK91_5D_H      _PK_H_(0x91, 0x5D)
#define REG_SC_BK91_5E_L      _PK_L_(0x91, 0x5E)
#define REG_SC_BK91_5E_H      _PK_H_(0x91, 0x5E)
#define REG_SC_BK91_5F_L      _PK_L_(0x91, 0x5F)
#define REG_SC_BK91_5F_H      _PK_H_(0x91, 0x5F)
#define REG_SC_BK91_60_L      _PK_L_(0x91, 0x60)
#define REG_SC_BK91_60_H      _PK_H_(0x91, 0x60)
#define REG_SC_BK91_61_L      _PK_L_(0x91, 0x61)
#define REG_SC_BK91_61_H      _PK_H_(0x91, 0x61)
#define REG_SC_BK91_62_L      _PK_L_(0x91, 0x62)
#define REG_SC_BK91_62_H      _PK_H_(0x91, 0x62)
#define REG_SC_BK91_63_L      _PK_L_(0x91, 0x63)
#define REG_SC_BK91_63_H      _PK_H_(0x91, 0x63)
#define REG_SC_BK91_64_L      _PK_L_(0x91, 0x64)
#define REG_SC_BK91_64_H      _PK_H_(0x91, 0x64)
#define REG_SC_BK91_65_L      _PK_L_(0x91, 0x65)
#define REG_SC_BK91_65_H      _PK_H_(0x91, 0x65)
#define REG_SC_BK91_66_L      _PK_L_(0x91, 0x66)
#define REG_SC_BK91_66_H      _PK_H_(0x91, 0x66)
#define REG_SC_BK91_67_L      _PK_L_(0x91, 0x67)
#define REG_SC_BK91_67_H      _PK_H_(0x91, 0x67)
#define REG_SC_BK91_68_L      _PK_L_(0x91, 0x68)
#define REG_SC_BK91_68_H      _PK_H_(0x91, 0x68)
#define REG_SC_BK91_69_L      _PK_L_(0x91, 0x69)
#define REG_SC_BK91_69_H      _PK_H_(0x91, 0x69)
#define REG_SC_BK91_6A_L      _PK_L_(0x91, 0x6A)
#define REG_SC_BK91_6A_H      _PK_H_(0x91, 0x6A)
#define REG_SC_BK91_6B_L      _PK_L_(0x91, 0x6B)
#define REG_SC_BK91_6B_H      _PK_H_(0x91, 0x6B)
#define REG_SC_BK91_6C_L      _PK_L_(0x91, 0x6C)
#define REG_SC_BK91_6C_H      _PK_H_(0x91, 0x6C)
#define REG_SC_BK91_6D_L      _PK_L_(0x91, 0x6D)
#define REG_SC_BK91_6D_H      _PK_H_(0x91, 0x6D)
#define REG_SC_BK91_6E_L      _PK_L_(0x91, 0x6E)
#define REG_SC_BK91_6E_H      _PK_H_(0x91, 0x6E)
#define REG_SC_BK91_6F_L      _PK_L_(0x91, 0x6F)
#define REG_SC_BK91_6F_H      _PK_H_(0x91, 0x6F)
#define REG_SC_BK91_70_L      _PK_L_(0x91, 0x70)
#define REG_SC_BK91_70_H      _PK_H_(0x91, 0x70)
#define REG_SC_BK91_71_L      _PK_L_(0x91, 0x71)
#define REG_SC_BK91_71_H      _PK_H_(0x91, 0x71)
#define REG_SC_BK91_72_L      _PK_L_(0x91, 0x72)
#define REG_SC_BK91_72_H      _PK_H_(0x91, 0x72)
#define REG_SC_BK91_73_L      _PK_L_(0x91, 0x73)
#define REG_SC_BK91_73_H      _PK_H_(0x91, 0x73)
#define REG_SC_BK91_74_L      _PK_L_(0x91, 0x74)
#define REG_SC_BK91_74_H      _PK_H_(0x91, 0x74)
#define REG_SC_BK91_75_L      _PK_L_(0x91, 0x75)
#define REG_SC_BK91_75_H      _PK_H_(0x91, 0x75)
#define REG_SC_BK91_76_L      _PK_L_(0x91, 0x76)
#define REG_SC_BK91_76_H      _PK_H_(0x91, 0x76)
#define REG_SC_BK91_77_L      _PK_L_(0x91, 0x77)
#define REG_SC_BK91_77_H      _PK_H_(0x91, 0x77)
#define REG_SC_BK91_78_L      _PK_L_(0x91, 0x78)
#define REG_SC_BK91_78_H      _PK_H_(0x91, 0x78)
#define REG_SC_BK91_79_L      _PK_L_(0x91, 0x79)
#define REG_SC_BK91_79_H      _PK_H_(0x91, 0x79)
#define REG_SC_BK91_7A_L      _PK_L_(0x91, 0x7A)
#define REG_SC_BK91_7A_H      _PK_H_(0x91, 0x7A)
#define REG_SC_BK91_7B_L      _PK_L_(0x91, 0x7B)
#define REG_SC_BK91_7B_H      _PK_H_(0x91, 0x7B)
#define REG_SC_BK91_7C_L      _PK_L_(0x91, 0x7C)
#define REG_SC_BK91_7C_H      _PK_H_(0x91, 0x7C)
#define REG_SC_BK91_7D_L      _PK_L_(0x91, 0x7D)
#define REG_SC_BK91_7D_H      _PK_H_(0x91, 0x7D)
#define REG_SC_BK91_7E_L      _PK_L_(0x91, 0x7E)
#define REG_SC_BK91_7E_H      _PK_H_(0x91, 0x7E)
#define REG_SC_BK91_7F_L      _PK_L_(0x91, 0x7F)
#define REG_SC_BK91_7F_H      _PK_H_(0x91, 0x7F)
//----------------------------------------------
#define REG_SC_BK92_00_L      _PK_L_(0x92, 0x00)
#define REG_SC_BK92_00_H      _PK_H_(0x92, 0x00)
#define REG_SC_BK92_01_L      _PK_L_(0x92, 0x01)
#define REG_SC_BK92_01_H      _PK_H_(0x92, 0x01)
#define REG_SC_BK92_02_L      _PK_L_(0x92, 0x02)
#define REG_SC_BK92_02_H      _PK_H_(0x92, 0x02)
#define REG_SC_BK92_03_L      _PK_L_(0x92, 0x03)
#define REG_SC_BK92_03_H      _PK_H_(0x92, 0x03)
#define REG_SC_BK92_04_L      _PK_L_(0x92, 0x04)
#define REG_SC_BK92_04_H      _PK_H_(0x92, 0x04)
#define REG_SC_BK92_05_L      _PK_L_(0x92, 0x05)
#define REG_SC_BK92_05_H      _PK_H_(0x92, 0x05)
#define REG_SC_BK92_06_L      _PK_L_(0x92, 0x06)
#define REG_SC_BK92_06_H      _PK_H_(0x92, 0x06)
#define REG_SC_BK92_07_L      _PK_L_(0x92, 0x07)
#define REG_SC_BK92_07_H      _PK_H_(0x92, 0x07)
#define REG_SC_BK92_08_L      _PK_L_(0x92, 0x08)
#define REG_SC_BK92_08_H      _PK_H_(0x92, 0x08)
#define REG_SC_BK92_09_L      _PK_L_(0x92, 0x09)
#define REG_SC_BK92_09_H      _PK_H_(0x92, 0x09)
#define REG_SC_BK92_0A_L      _PK_L_(0x92, 0x0A)
#define REG_SC_BK92_0A_H      _PK_H_(0x92, 0x0A)
#define REG_SC_BK92_0B_L      _PK_L_(0x92, 0x0B)
#define REG_SC_BK92_0B_H      _PK_H_(0x92, 0x0B)
#define REG_SC_BK92_0C_L      _PK_L_(0x92, 0x0C)
#define REG_SC_BK92_0C_H      _PK_H_(0x92, 0x0C)
#define REG_SC_BK92_0D_L      _PK_L_(0x92, 0x0D)
#define REG_SC_BK92_0D_H      _PK_H_(0x92, 0x0D)
#define REG_SC_BK92_0E_L      _PK_L_(0x92, 0x0E)
#define REG_SC_BK92_0E_H      _PK_H_(0x92, 0x0E)
#define REG_SC_BK92_0F_L      _PK_L_(0x92, 0x0F)
#define REG_SC_BK92_0F_H      _PK_H_(0x92, 0x0F)
#define REG_SC_BK92_10_L      _PK_L_(0x92, 0x10)
#define REG_SC_BK92_10_H      _PK_H_(0x92, 0x10)
#define REG_SC_BK92_11_L      _PK_L_(0x92, 0x11)
#define REG_SC_BK92_11_H      _PK_H_(0x92, 0x11)
#define REG_SC_BK92_12_L      _PK_L_(0x92, 0x12)
#define REG_SC_BK92_12_H      _PK_H_(0x92, 0x12)
#define REG_SC_BK92_13_L      _PK_L_(0x92, 0x13)
#define REG_SC_BK92_13_H      _PK_H_(0x92, 0x13)
#define REG_SC_BK92_14_L      _PK_L_(0x92, 0x14)
#define REG_SC_BK92_14_H      _PK_H_(0x92, 0x14)
#define REG_SC_BK92_15_L      _PK_L_(0x92, 0x15)
#define REG_SC_BK92_15_H      _PK_H_(0x92, 0x15)
#define REG_SC_BK92_16_L      _PK_L_(0x92, 0x16)
#define REG_SC_BK92_16_H      _PK_H_(0x92, 0x16)
#define REG_SC_BK92_17_L      _PK_L_(0x92, 0x17)
#define REG_SC_BK92_17_H      _PK_H_(0x92, 0x17)
#define REG_SC_BK92_18_L      _PK_L_(0x92, 0x18)
#define REG_SC_BK92_18_H      _PK_H_(0x92, 0x18)
#define REG_SC_BK92_19_L      _PK_L_(0x92, 0x19)
#define REG_SC_BK92_19_H      _PK_H_(0x92, 0x19)
#define REG_SC_BK92_1A_L      _PK_L_(0x92, 0x1A)
#define REG_SC_BK92_1A_H      _PK_H_(0x92, 0x1A)
#define REG_SC_BK92_1B_L      _PK_L_(0x92, 0x1B)
#define REG_SC_BK92_1B_H      _PK_H_(0x92, 0x1B)
#define REG_SC_BK92_1C_L      _PK_L_(0x92, 0x1C)
#define REG_SC_BK92_1C_H      _PK_H_(0x92, 0x1C)
#define REG_SC_BK92_1D_L      _PK_L_(0x92, 0x1D)
#define REG_SC_BK92_1D_H      _PK_H_(0x92, 0x1D)
#define REG_SC_BK92_1E_L      _PK_L_(0x92, 0x1E)
#define REG_SC_BK92_1E_H      _PK_H_(0x92, 0x1E)
#define REG_SC_BK92_1F_L      _PK_L_(0x92, 0x1F)
#define REG_SC_BK92_1F_H      _PK_H_(0x92, 0x1F)
#define REG_SC_BK92_20_L      _PK_L_(0x92, 0x20)
#define REG_SC_BK92_20_H      _PK_H_(0x92, 0x20)
#define REG_SC_BK92_21_L      _PK_L_(0x92, 0x21)
#define REG_SC_BK92_21_H      _PK_H_(0x92, 0x21)
#define REG_SC_BK92_22_L      _PK_L_(0x92, 0x22)
#define REG_SC_BK92_22_H      _PK_H_(0x92, 0x22)
#define REG_SC_BK92_23_L      _PK_L_(0x92, 0x23)
#define REG_SC_BK92_23_H      _PK_H_(0x92, 0x23)
#define REG_SC_BK92_24_L      _PK_L_(0x92, 0x24)
#define REG_SC_BK92_24_H      _PK_H_(0x92, 0x24)
#define REG_SC_BK92_25_L      _PK_L_(0x92, 0x25)
#define REG_SC_BK92_25_H      _PK_H_(0x92, 0x25)
#define REG_SC_BK92_26_L      _PK_L_(0x92, 0x26)
#define REG_SC_BK92_26_H      _PK_H_(0x92, 0x26)
#define REG_SC_BK92_27_L      _PK_L_(0x92, 0x27)
#define REG_SC_BK92_27_H      _PK_H_(0x92, 0x27)
#define REG_SC_BK92_28_L      _PK_L_(0x92, 0x28)
#define REG_SC_BK92_28_H      _PK_H_(0x92, 0x28)
#define REG_SC_BK92_29_L      _PK_L_(0x92, 0x29)
#define REG_SC_BK92_29_H      _PK_H_(0x92, 0x29)
#define REG_SC_BK92_2A_L      _PK_L_(0x92, 0x2A)
#define REG_SC_BK92_2A_H      _PK_H_(0x92, 0x2A)
#define REG_SC_BK92_2B_L      _PK_L_(0x92, 0x2B)
#define REG_SC_BK92_2B_H      _PK_H_(0x92, 0x2B)
#define REG_SC_BK92_2C_L      _PK_L_(0x92, 0x2C)
#define REG_SC_BK92_2C_H      _PK_H_(0x92, 0x2C)
#define REG_SC_BK92_2D_L      _PK_L_(0x92, 0x2D)
#define REG_SC_BK92_2D_H      _PK_H_(0x92, 0x2D)
#define REG_SC_BK92_2E_L      _PK_L_(0x92, 0x2E)
#define REG_SC_BK92_2E_H      _PK_H_(0x92, 0x2E)
#define REG_SC_BK92_2F_L      _PK_L_(0x92, 0x2F)
#define REG_SC_BK92_2F_H      _PK_H_(0x92, 0x2F)
#define REG_SC_BK92_30_L      _PK_L_(0x92, 0x30)
#define REG_SC_BK92_30_H      _PK_H_(0x92, 0x30)
#define REG_SC_BK92_31_L      _PK_L_(0x92, 0x31)
#define REG_SC_BK92_31_H      _PK_H_(0x92, 0x31)
#define REG_SC_BK92_32_L      _PK_L_(0x92, 0x32)
#define REG_SC_BK92_32_H      _PK_H_(0x92, 0x32)
#define REG_SC_BK92_33_L      _PK_L_(0x92, 0x33)
#define REG_SC_BK92_33_H      _PK_H_(0x92, 0x33)
#define REG_SC_BK92_34_L      _PK_L_(0x92, 0x34)
#define REG_SC_BK92_34_H      _PK_H_(0x92, 0x34)
#define REG_SC_BK92_35_L      _PK_L_(0x92, 0x35)
#define REG_SC_BK92_35_H      _PK_H_(0x92, 0x35)
#define REG_SC_BK92_36_L      _PK_L_(0x92, 0x36)
#define REG_SC_BK92_36_H      _PK_H_(0x92, 0x36)
#define REG_SC_BK92_37_L      _PK_L_(0x92, 0x37)
#define REG_SC_BK92_37_H      _PK_H_(0x92, 0x37)
#define REG_SC_BK92_38_L      _PK_L_(0x92, 0x38)
#define REG_SC_BK92_38_H      _PK_H_(0x92, 0x38)
#define REG_SC_BK92_39_L      _PK_L_(0x92, 0x39)
#define REG_SC_BK92_39_H      _PK_H_(0x92, 0x39)
#define REG_SC_BK92_3A_L      _PK_L_(0x92, 0x3A)
#define REG_SC_BK92_3A_H      _PK_H_(0x92, 0x3A)
#define REG_SC_BK92_3B_L      _PK_L_(0x92, 0x3B)
#define REG_SC_BK92_3B_H      _PK_H_(0x92, 0x3B)
#define REG_SC_BK92_3C_L      _PK_L_(0x92, 0x3C)
#define REG_SC_BK92_3C_H      _PK_H_(0x92, 0x3C)
#define REG_SC_BK92_3D_L      _PK_L_(0x92, 0x3D)
#define REG_SC_BK92_3D_H      _PK_H_(0x92, 0x3D)
#define REG_SC_BK92_3E_L      _PK_L_(0x92, 0x3E)
#define REG_SC_BK92_3E_H      _PK_H_(0x92, 0x3E)
#define REG_SC_BK92_3F_L      _PK_L_(0x92, 0x3F)
#define REG_SC_BK92_3F_H      _PK_H_(0x92, 0x3F)
#define REG_SC_BK92_40_L      _PK_L_(0x92, 0x40)
#define REG_SC_BK92_40_H      _PK_H_(0x92, 0x40)
#define REG_SC_BK92_41_L      _PK_L_(0x92, 0x41)
#define REG_SC_BK92_41_H      _PK_H_(0x92, 0x41)
#define REG_SC_BK92_42_L      _PK_L_(0x92, 0x42)
#define REG_SC_BK92_42_H      _PK_H_(0x92, 0x42)
#define REG_SC_BK92_43_L      _PK_L_(0x92, 0x43)
#define REG_SC_BK92_43_H      _PK_H_(0x92, 0x43)
#define REG_SC_BK92_44_L      _PK_L_(0x92, 0x44)
#define REG_SC_BK92_44_H      _PK_H_(0x92, 0x44)
#define REG_SC_BK92_45_L      _PK_L_(0x92, 0x45)
#define REG_SC_BK92_45_H      _PK_H_(0x92, 0x45)
#define REG_SC_BK92_46_L      _PK_L_(0x92, 0x46)
#define REG_SC_BK92_46_H      _PK_H_(0x92, 0x46)
#define REG_SC_BK92_47_L      _PK_L_(0x92, 0x47)
#define REG_SC_BK92_47_H      _PK_H_(0x92, 0x47)
#define REG_SC_BK92_48_L      _PK_L_(0x92, 0x48)
#define REG_SC_BK92_48_H      _PK_H_(0x92, 0x48)
#define REG_SC_BK92_49_L      _PK_L_(0x92, 0x49)
#define REG_SC_BK92_49_H      _PK_H_(0x92, 0x49)
#define REG_SC_BK92_4A_L      _PK_L_(0x92, 0x4A)
#define REG_SC_BK92_4A_H      _PK_H_(0x92, 0x4A)
#define REG_SC_BK92_4B_L      _PK_L_(0x92, 0x4B)
#define REG_SC_BK92_4B_H      _PK_H_(0x92, 0x4B)
#define REG_SC_BK92_4C_L      _PK_L_(0x92, 0x4C)
#define REG_SC_BK92_4C_H      _PK_H_(0x92, 0x4C)
#define REG_SC_BK92_4D_L      _PK_L_(0x92, 0x4D)
#define REG_SC_BK92_4D_H      _PK_H_(0x92, 0x4D)
#define REG_SC_BK92_4E_L      _PK_L_(0x92, 0x4E)
#define REG_SC_BK92_4E_H      _PK_H_(0x92, 0x4E)
#define REG_SC_BK92_4F_L      _PK_L_(0x92, 0x4F)
#define REG_SC_BK92_4F_H      _PK_H_(0x92, 0x4F)
#define REG_SC_BK92_50_L      _PK_L_(0x92, 0x50)
#define REG_SC_BK92_50_H      _PK_H_(0x92, 0x50)
#define REG_SC_BK92_51_L      _PK_L_(0x92, 0x51)
#define REG_SC_BK92_51_H      _PK_H_(0x92, 0x51)
#define REG_SC_BK92_52_L      _PK_L_(0x92, 0x52)
#define REG_SC_BK92_52_H      _PK_H_(0x92, 0x52)
#define REG_SC_BK92_53_L      _PK_L_(0x92, 0x53)
#define REG_SC_BK92_53_H      _PK_H_(0x92, 0x53)
#define REG_SC_BK92_54_L      _PK_L_(0x92, 0x54)
#define REG_SC_BK92_54_H      _PK_H_(0x92, 0x54)
#define REG_SC_BK92_55_L      _PK_L_(0x92, 0x55)
#define REG_SC_BK92_55_H      _PK_H_(0x92, 0x55)
#define REG_SC_BK92_56_L      _PK_L_(0x92, 0x56)
#define REG_SC_BK92_56_H      _PK_H_(0x92, 0x56)
#define REG_SC_BK92_57_L      _PK_L_(0x92, 0x57)
#define REG_SC_BK92_57_H      _PK_H_(0x92, 0x57)
#define REG_SC_BK92_58_L      _PK_L_(0x92, 0x58)
#define REG_SC_BK92_58_H      _PK_H_(0x92, 0x58)
#define REG_SC_BK92_59_L      _PK_L_(0x92, 0x59)
#define REG_SC_BK92_59_H      _PK_H_(0x92, 0x59)
#define REG_SC_BK92_5A_L      _PK_L_(0x92, 0x5A)
#define REG_SC_BK92_5A_H      _PK_H_(0x92, 0x5A)
#define REG_SC_BK92_5B_L      _PK_L_(0x92, 0x5B)
#define REG_SC_BK92_5B_H      _PK_H_(0x92, 0x5B)
#define REG_SC_BK92_5C_L      _PK_L_(0x92, 0x5C)
#define REG_SC_BK92_5C_H      _PK_H_(0x92, 0x5C)
#define REG_SC_BK92_5D_L      _PK_L_(0x92, 0x5D)
#define REG_SC_BK92_5D_H      _PK_H_(0x92, 0x5D)
#define REG_SC_BK92_5E_L      _PK_L_(0x92, 0x5E)
#define REG_SC_BK92_5E_H      _PK_H_(0x92, 0x5E)
#define REG_SC_BK92_5F_L      _PK_L_(0x92, 0x5F)
#define REG_SC_BK92_5F_H      _PK_H_(0x92, 0x5F)
#define REG_SC_BK92_60_L      _PK_L_(0x92, 0x60)
#define REG_SC_BK92_60_H      _PK_H_(0x92, 0x60)
#define REG_SC_BK92_61_L      _PK_L_(0x92, 0x61)
#define REG_SC_BK92_61_H      _PK_H_(0x92, 0x61)
#define REG_SC_BK92_62_L      _PK_L_(0x92, 0x62)
#define REG_SC_BK92_62_H      _PK_H_(0x92, 0x62)
#define REG_SC_BK92_63_L      _PK_L_(0x92, 0x63)
#define REG_SC_BK92_63_H      _PK_H_(0x92, 0x63)
#define REG_SC_BK92_64_L      _PK_L_(0x92, 0x64)
#define REG_SC_BK92_64_H      _PK_H_(0x92, 0x64)
#define REG_SC_BK92_65_L      _PK_L_(0x92, 0x65)
#define REG_SC_BK92_65_H      _PK_H_(0x92, 0x65)
#define REG_SC_BK92_66_L      _PK_L_(0x92, 0x66)
#define REG_SC_BK92_66_H      _PK_H_(0x92, 0x66)
#define REG_SC_BK92_67_L      _PK_L_(0x92, 0x67)
#define REG_SC_BK92_67_H      _PK_H_(0x92, 0x67)
#define REG_SC_BK92_68_L      _PK_L_(0x92, 0x68)
#define REG_SC_BK92_68_H      _PK_H_(0x92, 0x68)
#define REG_SC_BK92_69_L      _PK_L_(0x92, 0x69)
#define REG_SC_BK92_69_H      _PK_H_(0x92, 0x69)
#define REG_SC_BK92_6A_L      _PK_L_(0x92, 0x6A)
#define REG_SC_BK92_6A_H      _PK_H_(0x92, 0x6A)
#define REG_SC_BK92_6B_L      _PK_L_(0x92, 0x6B)
#define REG_SC_BK92_6B_H      _PK_H_(0x92, 0x6B)
#define REG_SC_BK92_6C_L      _PK_L_(0x92, 0x6C)
#define REG_SC_BK92_6C_H      _PK_H_(0x92, 0x6C)
#define REG_SC_BK92_6D_L      _PK_L_(0x92, 0x6D)
#define REG_SC_BK92_6D_H      _PK_H_(0x92, 0x6D)
#define REG_SC_BK92_6E_L      _PK_L_(0x92, 0x6E)
#define REG_SC_BK92_6E_H      _PK_H_(0x92, 0x6E)
#define REG_SC_BK92_6F_L      _PK_L_(0x92, 0x6F)
#define REG_SC_BK92_6F_H      _PK_H_(0x92, 0x6F)
#define REG_SC_BK92_70_L      _PK_L_(0x92, 0x70)
#define REG_SC_BK92_70_H      _PK_H_(0x92, 0x70)
#define REG_SC_BK92_71_L      _PK_L_(0x92, 0x71)
#define REG_SC_BK92_71_H      _PK_H_(0x92, 0x71)
#define REG_SC_BK92_72_L      _PK_L_(0x92, 0x72)
#define REG_SC_BK92_72_H      _PK_H_(0x92, 0x72)
#define REG_SC_BK92_73_L      _PK_L_(0x92, 0x73)
#define REG_SC_BK92_73_H      _PK_H_(0x92, 0x73)
#define REG_SC_BK92_74_L      _PK_L_(0x92, 0x74)
#define REG_SC_BK92_74_H      _PK_H_(0x92, 0x74)
#define REG_SC_BK92_75_L      _PK_L_(0x92, 0x75)
#define REG_SC_BK92_75_H      _PK_H_(0x92, 0x75)
#define REG_SC_BK92_76_L      _PK_L_(0x92, 0x76)
#define REG_SC_BK92_76_H      _PK_H_(0x92, 0x76)
#define REG_SC_BK92_77_L      _PK_L_(0x92, 0x77)
#define REG_SC_BK92_77_H      _PK_H_(0x92, 0x77)
#define REG_SC_BK92_78_L      _PK_L_(0x92, 0x78)
#define REG_SC_BK92_78_H      _PK_H_(0x92, 0x78)
#define REG_SC_BK92_79_L      _PK_L_(0x92, 0x79)
#define REG_SC_BK92_79_H      _PK_H_(0x92, 0x79)
#define REG_SC_BK92_7A_L      _PK_L_(0x92, 0x7A)
#define REG_SC_BK92_7A_H      _PK_H_(0x92, 0x7A)
#define REG_SC_BK92_7B_L      _PK_L_(0x92, 0x7B)
#define REG_SC_BK92_7B_H      _PK_H_(0x92, 0x7B)
#define REG_SC_BK92_7C_L      _PK_L_(0x92, 0x7C)
#define REG_SC_BK92_7C_H      _PK_H_(0x92, 0x7C)
#define REG_SC_BK92_7D_L      _PK_L_(0x92, 0x7D)
#define REG_SC_BK92_7D_H      _PK_H_(0x92, 0x7D)
#define REG_SC_BK92_7E_L      _PK_L_(0x92, 0x7E)
#define REG_SC_BK92_7E_H      _PK_H_(0x92, 0x7E)
#define REG_SC_BK92_7F_L      _PK_L_(0x92, 0x7F)
#define REG_SC_BK92_7F_H      _PK_H_(0x92, 0x7F)
//----------------------------------------------
#define REG_SC_BK93_00_L      _PK_L_(0x93, 0x00)
#define REG_SC_BK93_00_H      _PK_H_(0x93, 0x00)
#define REG_SC_BK93_01_L      _PK_L_(0x93, 0x01)
#define REG_SC_BK93_01_H      _PK_H_(0x93, 0x01)
#define REG_SC_BK93_02_L      _PK_L_(0x93, 0x02)
#define REG_SC_BK93_02_H      _PK_H_(0x93, 0x02)
#define REG_SC_BK93_03_L      _PK_L_(0x93, 0x03)
#define REG_SC_BK93_03_H      _PK_H_(0x93, 0x03)
#define REG_SC_BK93_04_L      _PK_L_(0x93, 0x04)
#define REG_SC_BK93_04_H      _PK_H_(0x93, 0x04)
#define REG_SC_BK93_05_L      _PK_L_(0x93, 0x05)
#define REG_SC_BK93_05_H      _PK_H_(0x93, 0x05)
#define REG_SC_BK93_06_L      _PK_L_(0x93, 0x06)
#define REG_SC_BK93_06_H      _PK_H_(0x93, 0x06)
#define REG_SC_BK93_07_L      _PK_L_(0x93, 0x07)
#define REG_SC_BK93_07_H      _PK_H_(0x93, 0x07)
#define REG_SC_BK93_08_L      _PK_L_(0x93, 0x08)
#define REG_SC_BK93_08_H      _PK_H_(0x93, 0x08)
#define REG_SC_BK93_09_L      _PK_L_(0x93, 0x09)
#define REG_SC_BK93_09_H      _PK_H_(0x93, 0x09)
#define REG_SC_BK93_0A_L      _PK_L_(0x93, 0x0A)
#define REG_SC_BK93_0A_H      _PK_H_(0x93, 0x0A)
#define REG_SC_BK93_0B_L      _PK_L_(0x93, 0x0B)
#define REG_SC_BK93_0B_H      _PK_H_(0x93, 0x0B)
#define REG_SC_BK93_0C_L      _PK_L_(0x93, 0x0C)
#define REG_SC_BK93_0C_H      _PK_H_(0x93, 0x0C)
#define REG_SC_BK93_0D_L      _PK_L_(0x93, 0x0D)
#define REG_SC_BK93_0D_H      _PK_H_(0x93, 0x0D)
#define REG_SC_BK93_0E_L      _PK_L_(0x93, 0x0E)
#define REG_SC_BK93_0E_H      _PK_H_(0x93, 0x0E)
#define REG_SC_BK93_0F_L      _PK_L_(0x93, 0x0F)
#define REG_SC_BK93_0F_H      _PK_H_(0x93, 0x0F)
#define REG_SC_BK93_10_L      _PK_L_(0x93, 0x10)
#define REG_SC_BK93_10_H      _PK_H_(0x93, 0x10)
#define REG_SC_BK93_11_L      _PK_L_(0x93, 0x11)
#define REG_SC_BK93_11_H      _PK_H_(0x93, 0x11)
#define REG_SC_BK93_12_L      _PK_L_(0x93, 0x12)
#define REG_SC_BK93_12_H      _PK_H_(0x93, 0x12)
#define REG_SC_BK93_13_L      _PK_L_(0x93, 0x13)
#define REG_SC_BK93_13_H      _PK_H_(0x93, 0x13)
#define REG_SC_BK93_14_L      _PK_L_(0x93, 0x14)
#define REG_SC_BK93_14_H      _PK_H_(0x93, 0x14)
#define REG_SC_BK93_15_L      _PK_L_(0x93, 0x15)
#define REG_SC_BK93_15_H      _PK_H_(0x93, 0x15)
#define REG_SC_BK93_16_L      _PK_L_(0x93, 0x16)
#define REG_SC_BK93_16_H      _PK_H_(0x93, 0x16)
#define REG_SC_BK93_17_L      _PK_L_(0x93, 0x17)
#define REG_SC_BK93_17_H      _PK_H_(0x93, 0x17)
#define REG_SC_BK93_18_L      _PK_L_(0x93, 0x18)
#define REG_SC_BK93_18_H      _PK_H_(0x93, 0x18)
#define REG_SC_BK93_19_L      _PK_L_(0x93, 0x19)
#define REG_SC_BK93_19_H      _PK_H_(0x93, 0x19)
#define REG_SC_BK93_1A_L      _PK_L_(0x93, 0x1A)
#define REG_SC_BK93_1A_H      _PK_H_(0x93, 0x1A)
#define REG_SC_BK93_1B_L      _PK_L_(0x93, 0x1B)
#define REG_SC_BK93_1B_H      _PK_H_(0x93, 0x1B)
#define REG_SC_BK93_1C_L      _PK_L_(0x93, 0x1C)
#define REG_SC_BK93_1C_H      _PK_H_(0x93, 0x1C)
#define REG_SC_BK93_1D_L      _PK_L_(0x93, 0x1D)
#define REG_SC_BK93_1D_H      _PK_H_(0x93, 0x1D)
#define REG_SC_BK93_1E_L      _PK_L_(0x93, 0x1E)
#define REG_SC_BK93_1E_H      _PK_H_(0x93, 0x1E)
#define REG_SC_BK93_1F_L      _PK_L_(0x93, 0x1F)
#define REG_SC_BK93_1F_H      _PK_H_(0x93, 0x1F)
#define REG_SC_BK93_20_L      _PK_L_(0x93, 0x20)
#define REG_SC_BK93_20_H      _PK_H_(0x93, 0x20)
#define REG_SC_BK93_21_L      _PK_L_(0x93, 0x21)
#define REG_SC_BK93_21_H      _PK_H_(0x93, 0x21)
#define REG_SC_BK93_22_L      _PK_L_(0x93, 0x22)
#define REG_SC_BK93_22_H      _PK_H_(0x93, 0x22)
#define REG_SC_BK93_23_L      _PK_L_(0x93, 0x23)
#define REG_SC_BK93_23_H      _PK_H_(0x93, 0x23)
#define REG_SC_BK93_24_L      _PK_L_(0x93, 0x24)
#define REG_SC_BK93_24_H      _PK_H_(0x93, 0x24)
#define REG_SC_BK93_25_L      _PK_L_(0x93, 0x25)
#define REG_SC_BK93_25_H      _PK_H_(0x93, 0x25)
#define REG_SC_BK93_26_L      _PK_L_(0x93, 0x26)
#define REG_SC_BK93_26_H      _PK_H_(0x93, 0x26)
#define REG_SC_BK93_27_L      _PK_L_(0x93, 0x27)
#define REG_SC_BK93_27_H      _PK_H_(0x93, 0x27)
#define REG_SC_BK93_28_L      _PK_L_(0x93, 0x28)
#define REG_SC_BK93_28_H      _PK_H_(0x93, 0x28)
#define REG_SC_BK93_29_L      _PK_L_(0x93, 0x29)
#define REG_SC_BK93_29_H      _PK_H_(0x93, 0x29)
#define REG_SC_BK93_2A_L      _PK_L_(0x93, 0x2A)
#define REG_SC_BK93_2A_H      _PK_H_(0x93, 0x2A)
#define REG_SC_BK93_2B_L      _PK_L_(0x93, 0x2B)
#define REG_SC_BK93_2B_H      _PK_H_(0x93, 0x2B)
#define REG_SC_BK93_2C_L      _PK_L_(0x93, 0x2C)
#define REG_SC_BK93_2C_H      _PK_H_(0x93, 0x2C)
#define REG_SC_BK93_2D_L      _PK_L_(0x93, 0x2D)
#define REG_SC_BK93_2D_H      _PK_H_(0x93, 0x2D)
#define REG_SC_BK93_2E_L      _PK_L_(0x93, 0x2E)
#define REG_SC_BK93_2E_H      _PK_H_(0x93, 0x2E)
#define REG_SC_BK93_2F_L      _PK_L_(0x93, 0x2F)
#define REG_SC_BK93_2F_H      _PK_H_(0x93, 0x2F)
#define REG_SC_BK93_30_L      _PK_L_(0x93, 0x30)
#define REG_SC_BK93_30_H      _PK_H_(0x93, 0x30)
#define REG_SC_BK93_31_L      _PK_L_(0x93, 0x31)
#define REG_SC_BK93_31_H      _PK_H_(0x93, 0x31)
#define REG_SC_BK93_32_L      _PK_L_(0x93, 0x32)
#define REG_SC_BK93_32_H      _PK_H_(0x93, 0x32)
#define REG_SC_BK93_33_L      _PK_L_(0x93, 0x33)
#define REG_SC_BK93_33_H      _PK_H_(0x93, 0x33)
#define REG_SC_BK93_34_L      _PK_L_(0x93, 0x34)
#define REG_SC_BK93_34_H      _PK_H_(0x93, 0x34)
#define REG_SC_BK93_35_L      _PK_L_(0x93, 0x35)
#define REG_SC_BK93_35_H      _PK_H_(0x93, 0x35)
#define REG_SC_BK93_36_L      _PK_L_(0x93, 0x36)
#define REG_SC_BK93_36_H      _PK_H_(0x93, 0x36)
#define REG_SC_BK93_37_L      _PK_L_(0x93, 0x37)
#define REG_SC_BK93_37_H      _PK_H_(0x93, 0x37)
#define REG_SC_BK93_38_L      _PK_L_(0x93, 0x38)
#define REG_SC_BK93_38_H      _PK_H_(0x93, 0x38)
#define REG_SC_BK93_39_L      _PK_L_(0x93, 0x39)
#define REG_SC_BK93_39_H      _PK_H_(0x93, 0x39)
#define REG_SC_BK93_3A_L      _PK_L_(0x93, 0x3A)
#define REG_SC_BK93_3A_H      _PK_H_(0x93, 0x3A)
#define REG_SC_BK93_3B_L      _PK_L_(0x93, 0x3B)
#define REG_SC_BK93_3B_H      _PK_H_(0x93, 0x3B)
#define REG_SC_BK93_3C_L      _PK_L_(0x93, 0x3C)
#define REG_SC_BK93_3C_H      _PK_H_(0x93, 0x3C)
#define REG_SC_BK93_3D_L      _PK_L_(0x93, 0x3D)
#define REG_SC_BK93_3D_H      _PK_H_(0x93, 0x3D)
#define REG_SC_BK93_3E_L      _PK_L_(0x93, 0x3E)
#define REG_SC_BK93_3E_H      _PK_H_(0x93, 0x3E)
#define REG_SC_BK93_3F_L      _PK_L_(0x93, 0x3F)
#define REG_SC_BK93_3F_H      _PK_H_(0x93, 0x3F)
#define REG_SC_BK93_40_L      _PK_L_(0x93, 0x40)
#define REG_SC_BK93_40_H      _PK_H_(0x93, 0x40)
#define REG_SC_BK93_41_L      _PK_L_(0x93, 0x41)
#define REG_SC_BK93_41_H      _PK_H_(0x93, 0x41)
#define REG_SC_BK93_42_L      _PK_L_(0x93, 0x42)
#define REG_SC_BK93_42_H      _PK_H_(0x93, 0x42)
#define REG_SC_BK93_43_L      _PK_L_(0x93, 0x43)
#define REG_SC_BK93_43_H      _PK_H_(0x93, 0x43)
#define REG_SC_BK93_44_L      _PK_L_(0x93, 0x44)
#define REG_SC_BK93_44_H      _PK_H_(0x93, 0x44)
#define REG_SC_BK93_45_L      _PK_L_(0x93, 0x45)
#define REG_SC_BK93_45_H      _PK_H_(0x93, 0x45)
#define REG_SC_BK93_46_L      _PK_L_(0x93, 0x46)
#define REG_SC_BK93_46_H      _PK_H_(0x93, 0x46)
#define REG_SC_BK93_47_L      _PK_L_(0x93, 0x47)
#define REG_SC_BK93_47_H      _PK_H_(0x93, 0x47)
#define REG_SC_BK93_48_L      _PK_L_(0x93, 0x48)
#define REG_SC_BK93_48_H      _PK_H_(0x93, 0x48)
#define REG_SC_BK93_49_L      _PK_L_(0x93, 0x49)
#define REG_SC_BK93_49_H      _PK_H_(0x93, 0x49)
#define REG_SC_BK93_4A_L      _PK_L_(0x93, 0x4A)
#define REG_SC_BK93_4A_H      _PK_H_(0x93, 0x4A)
#define REG_SC_BK93_4B_L      _PK_L_(0x93, 0x4B)
#define REG_SC_BK93_4B_H      _PK_H_(0x93, 0x4B)
#define REG_SC_BK93_4C_L      _PK_L_(0x93, 0x4C)
#define REG_SC_BK93_4C_H      _PK_H_(0x93, 0x4C)
#define REG_SC_BK93_4D_L      _PK_L_(0x93, 0x4D)
#define REG_SC_BK93_4D_H      _PK_H_(0x93, 0x4D)
#define REG_SC_BK93_4E_L      _PK_L_(0x93, 0x4E)
#define REG_SC_BK93_4E_H      _PK_H_(0x93, 0x4E)
#define REG_SC_BK93_4F_L      _PK_L_(0x93, 0x4F)
#define REG_SC_BK93_4F_H      _PK_H_(0x93, 0x4F)
#define REG_SC_BK93_50_L      _PK_L_(0x93, 0x50)
#define REG_SC_BK93_50_H      _PK_H_(0x93, 0x50)
#define REG_SC_BK93_51_L      _PK_L_(0x93, 0x51)
#define REG_SC_BK93_51_H      _PK_H_(0x93, 0x51)
#define REG_SC_BK93_52_L      _PK_L_(0x93, 0x52)
#define REG_SC_BK93_52_H      _PK_H_(0x93, 0x52)
#define REG_SC_BK93_53_L      _PK_L_(0x93, 0x53)
#define REG_SC_BK93_53_H      _PK_H_(0x93, 0x53)
#define REG_SC_BK93_54_L      _PK_L_(0x93, 0x54)
#define REG_SC_BK93_54_H      _PK_H_(0x93, 0x54)
#define REG_SC_BK93_55_L      _PK_L_(0x93, 0x55)
#define REG_SC_BK93_55_H      _PK_H_(0x93, 0x55)
#define REG_SC_BK93_56_L      _PK_L_(0x93, 0x56)
#define REG_SC_BK93_56_H      _PK_H_(0x93, 0x56)
#define REG_SC_BK93_57_L      _PK_L_(0x93, 0x57)
#define REG_SC_BK93_57_H      _PK_H_(0x93, 0x57)
#define REG_SC_BK93_58_L      _PK_L_(0x93, 0x58)
#define REG_SC_BK93_58_H      _PK_H_(0x93, 0x58)
#define REG_SC_BK93_59_L      _PK_L_(0x93, 0x59)
#define REG_SC_BK93_59_H      _PK_H_(0x93, 0x59)
#define REG_SC_BK93_5A_L      _PK_L_(0x93, 0x5A)
#define REG_SC_BK93_5A_H      _PK_H_(0x93, 0x5A)
#define REG_SC_BK93_5B_L      _PK_L_(0x93, 0x5B)
#define REG_SC_BK93_5B_H      _PK_H_(0x93, 0x5B)
#define REG_SC_BK93_5C_L      _PK_L_(0x93, 0x5C)
#define REG_SC_BK93_5C_H      _PK_H_(0x93, 0x5C)
#define REG_SC_BK93_5D_L      _PK_L_(0x93, 0x5D)
#define REG_SC_BK93_5D_H      _PK_H_(0x93, 0x5D)
#define REG_SC_BK93_5E_L      _PK_L_(0x93, 0x5E)
#define REG_SC_BK93_5E_H      _PK_H_(0x93, 0x5E)
#define REG_SC_BK93_5F_L      _PK_L_(0x93, 0x5F)
#define REG_SC_BK93_5F_H      _PK_H_(0x93, 0x5F)
#define REG_SC_BK93_60_L      _PK_L_(0x93, 0x60)
#define REG_SC_BK93_60_H      _PK_H_(0x93, 0x60)
#define REG_SC_BK93_61_L      _PK_L_(0x93, 0x61)
#define REG_SC_BK93_61_H      _PK_H_(0x93, 0x61)
#define REG_SC_BK93_62_L      _PK_L_(0x93, 0x62)
#define REG_SC_BK93_62_H      _PK_H_(0x93, 0x62)
#define REG_SC_BK93_63_L      _PK_L_(0x93, 0x63)
#define REG_SC_BK93_63_H      _PK_H_(0x93, 0x63)
#define REG_SC_BK93_64_L      _PK_L_(0x93, 0x64)
#define REG_SC_BK93_64_H      _PK_H_(0x93, 0x64)
#define REG_SC_BK93_65_L      _PK_L_(0x93, 0x65)
#define REG_SC_BK93_65_H      _PK_H_(0x93, 0x65)
#define REG_SC_BK93_66_L      _PK_L_(0x93, 0x66)
#define REG_SC_BK93_66_H      _PK_H_(0x93, 0x66)
#define REG_SC_BK93_67_L      _PK_L_(0x93, 0x67)
#define REG_SC_BK93_67_H      _PK_H_(0x93, 0x67)
#define REG_SC_BK93_68_L      _PK_L_(0x93, 0x68)
#define REG_SC_BK93_68_H      _PK_H_(0x93, 0x68)
#define REG_SC_BK93_69_L      _PK_L_(0x93, 0x69)
#define REG_SC_BK93_69_H      _PK_H_(0x93, 0x69)
#define REG_SC_BK93_6A_L      _PK_L_(0x93, 0x6A)
#define REG_SC_BK93_6A_H      _PK_H_(0x93, 0x6A)
#define REG_SC_BK93_6B_L      _PK_L_(0x93, 0x6B)
#define REG_SC_BK93_6B_H      _PK_H_(0x93, 0x6B)
#define REG_SC_BK93_6C_L      _PK_L_(0x93, 0x6C)
#define REG_SC_BK93_6C_H      _PK_H_(0x93, 0x6C)
#define REG_SC_BK93_6D_L      _PK_L_(0x93, 0x6D)
#define REG_SC_BK93_6D_H      _PK_H_(0x93, 0x6D)
#define REG_SC_BK93_6E_L      _PK_L_(0x93, 0x6E)
#define REG_SC_BK93_6E_H      _PK_H_(0x93, 0x6E)
#define REG_SC_BK93_6F_L      _PK_L_(0x93, 0x6F)
#define REG_SC_BK93_6F_H      _PK_H_(0x93, 0x6F)
#define REG_SC_BK93_70_L      _PK_L_(0x93, 0x70)
#define REG_SC_BK93_70_H      _PK_H_(0x93, 0x70)
#define REG_SC_BK93_71_L      _PK_L_(0x93, 0x71)
#define REG_SC_BK93_71_H      _PK_H_(0x93, 0x71)
#define REG_SC_BK93_72_L      _PK_L_(0x93, 0x72)
#define REG_SC_BK93_72_H      _PK_H_(0x93, 0x72)
#define REG_SC_BK93_73_L      _PK_L_(0x93, 0x73)
#define REG_SC_BK93_73_H      _PK_H_(0x93, 0x73)
#define REG_SC_BK93_74_L      _PK_L_(0x93, 0x74)
#define REG_SC_BK93_74_H      _PK_H_(0x93, 0x74)
#define REG_SC_BK93_75_L      _PK_L_(0x93, 0x75)
#define REG_SC_BK93_75_H      _PK_H_(0x93, 0x75)
#define REG_SC_BK93_76_L      _PK_L_(0x93, 0x76)
#define REG_SC_BK93_76_H      _PK_H_(0x93, 0x76)
#define REG_SC_BK93_77_L      _PK_L_(0x93, 0x77)
#define REG_SC_BK93_77_H      _PK_H_(0x93, 0x77)
#define REG_SC_BK93_78_L      _PK_L_(0x93, 0x78)
#define REG_SC_BK93_78_H      _PK_H_(0x93, 0x78)
#define REG_SC_BK93_79_L      _PK_L_(0x93, 0x79)
#define REG_SC_BK93_79_H      _PK_H_(0x93, 0x79)
#define REG_SC_BK93_7A_L      _PK_L_(0x93, 0x7A)
#define REG_SC_BK93_7A_H      _PK_H_(0x93, 0x7A)
#define REG_SC_BK93_7B_L      _PK_L_(0x93, 0x7B)
#define REG_SC_BK93_7B_H      _PK_H_(0x93, 0x7B)
#define REG_SC_BK93_7C_L      _PK_L_(0x93, 0x7C)
#define REG_SC_BK93_7C_H      _PK_H_(0x93, 0x7C)
#define REG_SC_BK93_7D_L      _PK_L_(0x93, 0x7D)
#define REG_SC_BK93_7D_H      _PK_H_(0x93, 0x7D)
#define REG_SC_BK93_7E_L      _PK_L_(0x93, 0x7E)
#define REG_SC_BK93_7E_H      _PK_H_(0x93, 0x7E)
#define REG_SC_BK93_7F_L      _PK_L_(0x93, 0x7F)
#define REG_SC_BK93_7F_H      _PK_H_(0x93, 0x7F)
//----------------------------------------------
#define REG_SC_BK94_00_L      _PK_L_(0x94, 0x00)
#define REG_SC_BK94_00_H      _PK_H_(0x94, 0x00)
#define REG_SC_BK94_01_L      _PK_L_(0x94, 0x01)
#define REG_SC_BK94_01_H      _PK_H_(0x94, 0x01)
#define REG_SC_BK94_02_L      _PK_L_(0x94, 0x02)
#define REG_SC_BK94_02_H      _PK_H_(0x94, 0x02)
#define REG_SC_BK94_03_L      _PK_L_(0x94, 0x03)
#define REG_SC_BK94_03_H      _PK_H_(0x94, 0x03)
#define REG_SC_BK94_04_L      _PK_L_(0x94, 0x04)
#define REG_SC_BK94_04_H      _PK_H_(0x94, 0x04)
#define REG_SC_BK94_05_L      _PK_L_(0x94, 0x05)
#define REG_SC_BK94_05_H      _PK_H_(0x94, 0x05)
#define REG_SC_BK94_06_L      _PK_L_(0x94, 0x06)
#define REG_SC_BK94_06_H      _PK_H_(0x94, 0x06)
#define REG_SC_BK94_07_L      _PK_L_(0x94, 0x07)
#define REG_SC_BK94_07_H      _PK_H_(0x94, 0x07)
#define REG_SC_BK94_08_L      _PK_L_(0x94, 0x08)
#define REG_SC_BK94_08_H      _PK_H_(0x94, 0x08)
#define REG_SC_BK94_09_L      _PK_L_(0x94, 0x09)
#define REG_SC_BK94_09_H      _PK_H_(0x94, 0x09)
#define REG_SC_BK94_0A_L      _PK_L_(0x94, 0x0A)
#define REG_SC_BK94_0A_H      _PK_H_(0x94, 0x0A)
#define REG_SC_BK94_0B_L      _PK_L_(0x94, 0x0B)
#define REG_SC_BK94_0B_H      _PK_H_(0x94, 0x0B)
#define REG_SC_BK94_0C_L      _PK_L_(0x94, 0x0C)
#define REG_SC_BK94_0C_H      _PK_H_(0x94, 0x0C)
#define REG_SC_BK94_0D_L      _PK_L_(0x94, 0x0D)
#define REG_SC_BK94_0D_H      _PK_H_(0x94, 0x0D)
#define REG_SC_BK94_0E_L      _PK_L_(0x94, 0x0E)
#define REG_SC_BK94_0E_H      _PK_H_(0x94, 0x0E)
#define REG_SC_BK94_0F_L      _PK_L_(0x94, 0x0F)
#define REG_SC_BK94_0F_H      _PK_H_(0x94, 0x0F)
#define REG_SC_BK94_10_L      _PK_L_(0x94, 0x10)
#define REG_SC_BK94_10_H      _PK_H_(0x94, 0x10)
#define REG_SC_BK94_11_L      _PK_L_(0x94, 0x11)
#define REG_SC_BK94_11_H      _PK_H_(0x94, 0x11)
#define REG_SC_BK94_12_L      _PK_L_(0x94, 0x12)
#define REG_SC_BK94_12_H      _PK_H_(0x94, 0x12)
#define REG_SC_BK94_13_L      _PK_L_(0x94, 0x13)
#define REG_SC_BK94_13_H      _PK_H_(0x94, 0x13)
#define REG_SC_BK94_14_L      _PK_L_(0x94, 0x14)
#define REG_SC_BK94_14_H      _PK_H_(0x94, 0x14)
#define REG_SC_BK94_15_L      _PK_L_(0x94, 0x15)
#define REG_SC_BK94_15_H      _PK_H_(0x94, 0x15)
#define REG_SC_BK94_16_L      _PK_L_(0x94, 0x16)
#define REG_SC_BK94_16_H      _PK_H_(0x94, 0x16)
#define REG_SC_BK94_17_L      _PK_L_(0x94, 0x17)
#define REG_SC_BK94_17_H      _PK_H_(0x94, 0x17)
#define REG_SC_BK94_18_L      _PK_L_(0x94, 0x18)
#define REG_SC_BK94_18_H      _PK_H_(0x94, 0x18)
#define REG_SC_BK94_19_L      _PK_L_(0x94, 0x19)
#define REG_SC_BK94_19_H      _PK_H_(0x94, 0x19)
#define REG_SC_BK94_1A_L      _PK_L_(0x94, 0x1A)
#define REG_SC_BK94_1A_H      _PK_H_(0x94, 0x1A)
#define REG_SC_BK94_1B_L      _PK_L_(0x94, 0x1B)
#define REG_SC_BK94_1B_H      _PK_H_(0x94, 0x1B)
#define REG_SC_BK94_1C_L      _PK_L_(0x94, 0x1C)
#define REG_SC_BK94_1C_H      _PK_H_(0x94, 0x1C)
#define REG_SC_BK94_1D_L      _PK_L_(0x94, 0x1D)
#define REG_SC_BK94_1D_H      _PK_H_(0x94, 0x1D)
#define REG_SC_BK94_1E_L      _PK_L_(0x94, 0x1E)
#define REG_SC_BK94_1E_H      _PK_H_(0x94, 0x1E)
#define REG_SC_BK94_1F_L      _PK_L_(0x94, 0x1F)
#define REG_SC_BK94_1F_H      _PK_H_(0x94, 0x1F)
#define REG_SC_BK94_20_L      _PK_L_(0x94, 0x20)
#define REG_SC_BK94_20_H      _PK_H_(0x94, 0x20)
#define REG_SC_BK94_21_L      _PK_L_(0x94, 0x21)
#define REG_SC_BK94_21_H      _PK_H_(0x94, 0x21)
#define REG_SC_BK94_22_L      _PK_L_(0x94, 0x22)
#define REG_SC_BK94_22_H      _PK_H_(0x94, 0x22)
#define REG_SC_BK94_23_L      _PK_L_(0x94, 0x23)
#define REG_SC_BK94_23_H      _PK_H_(0x94, 0x23)
#define REG_SC_BK94_24_L      _PK_L_(0x94, 0x24)
#define REG_SC_BK94_24_H      _PK_H_(0x94, 0x24)
#define REG_SC_BK94_25_L      _PK_L_(0x94, 0x25)
#define REG_SC_BK94_25_H      _PK_H_(0x94, 0x25)
#define REG_SC_BK94_26_L      _PK_L_(0x94, 0x26)
#define REG_SC_BK94_26_H      _PK_H_(0x94, 0x26)
#define REG_SC_BK94_27_L      _PK_L_(0x94, 0x27)
#define REG_SC_BK94_27_H      _PK_H_(0x94, 0x27)
#define REG_SC_BK94_28_L      _PK_L_(0x94, 0x28)
#define REG_SC_BK94_28_H      _PK_H_(0x94, 0x28)
#define REG_SC_BK94_29_L      _PK_L_(0x94, 0x29)
#define REG_SC_BK94_29_H      _PK_H_(0x94, 0x29)
#define REG_SC_BK94_2A_L      _PK_L_(0x94, 0x2A)
#define REG_SC_BK94_2A_H      _PK_H_(0x94, 0x2A)
#define REG_SC_BK94_2B_L      _PK_L_(0x94, 0x2B)
#define REG_SC_BK94_2B_H      _PK_H_(0x94, 0x2B)
#define REG_SC_BK94_2C_L      _PK_L_(0x94, 0x2C)
#define REG_SC_BK94_2C_H      _PK_H_(0x94, 0x2C)
#define REG_SC_BK94_2D_L      _PK_L_(0x94, 0x2D)
#define REG_SC_BK94_2D_H      _PK_H_(0x94, 0x2D)
#define REG_SC_BK94_2E_L      _PK_L_(0x94, 0x2E)
#define REG_SC_BK94_2E_H      _PK_H_(0x94, 0x2E)
#define REG_SC_BK94_2F_L      _PK_L_(0x94, 0x2F)
#define REG_SC_BK94_2F_H      _PK_H_(0x94, 0x2F)
#define REG_SC_BK94_30_L      _PK_L_(0x94, 0x30)
#define REG_SC_BK94_30_H      _PK_H_(0x94, 0x30)
#define REG_SC_BK94_31_L      _PK_L_(0x94, 0x31)
#define REG_SC_BK94_31_H      _PK_H_(0x94, 0x31)
#define REG_SC_BK94_32_L      _PK_L_(0x94, 0x32)
#define REG_SC_BK94_32_H      _PK_H_(0x94, 0x32)
#define REG_SC_BK94_33_L      _PK_L_(0x94, 0x33)
#define REG_SC_BK94_33_H      _PK_H_(0x94, 0x33)
#define REG_SC_BK94_34_L      _PK_L_(0x94, 0x34)
#define REG_SC_BK94_34_H      _PK_H_(0x94, 0x34)
#define REG_SC_BK94_35_L      _PK_L_(0x94, 0x35)
#define REG_SC_BK94_35_H      _PK_H_(0x94, 0x35)
#define REG_SC_BK94_36_L      _PK_L_(0x94, 0x36)
#define REG_SC_BK94_36_H      _PK_H_(0x94, 0x36)
#define REG_SC_BK94_37_L      _PK_L_(0x94, 0x37)
#define REG_SC_BK94_37_H      _PK_H_(0x94, 0x37)
#define REG_SC_BK94_38_L      _PK_L_(0x94, 0x38)
#define REG_SC_BK94_38_H      _PK_H_(0x94, 0x38)
#define REG_SC_BK94_39_L      _PK_L_(0x94, 0x39)
#define REG_SC_BK94_39_H      _PK_H_(0x94, 0x39)
#define REG_SC_BK94_3A_L      _PK_L_(0x94, 0x3A)
#define REG_SC_BK94_3A_H      _PK_H_(0x94, 0x3A)
#define REG_SC_BK94_3B_L      _PK_L_(0x94, 0x3B)
#define REG_SC_BK94_3B_H      _PK_H_(0x94, 0x3B)
#define REG_SC_BK94_3C_L      _PK_L_(0x94, 0x3C)
#define REG_SC_BK94_3C_H      _PK_H_(0x94, 0x3C)
#define REG_SC_BK94_3D_L      _PK_L_(0x94, 0x3D)
#define REG_SC_BK94_3D_H      _PK_H_(0x94, 0x3D)
#define REG_SC_BK94_3E_L      _PK_L_(0x94, 0x3E)
#define REG_SC_BK94_3E_H      _PK_H_(0x94, 0x3E)
#define REG_SC_BK94_3F_L      _PK_L_(0x94, 0x3F)
#define REG_SC_BK94_3F_H      _PK_H_(0x94, 0x3F)
#define REG_SC_BK94_40_L      _PK_L_(0x94, 0x40)
#define REG_SC_BK94_40_H      _PK_H_(0x94, 0x40)
#define REG_SC_BK94_41_L      _PK_L_(0x94, 0x41)
#define REG_SC_BK94_41_H      _PK_H_(0x94, 0x41)
#define REG_SC_BK94_42_L      _PK_L_(0x94, 0x42)
#define REG_SC_BK94_42_H      _PK_H_(0x94, 0x42)
#define REG_SC_BK94_43_L      _PK_L_(0x94, 0x43)
#define REG_SC_BK94_43_H      _PK_H_(0x94, 0x43)
#define REG_SC_BK94_44_L      _PK_L_(0x94, 0x44)
#define REG_SC_BK94_44_H      _PK_H_(0x94, 0x44)
#define REG_SC_BK94_45_L      _PK_L_(0x94, 0x45)
#define REG_SC_BK94_45_H      _PK_H_(0x94, 0x45)
#define REG_SC_BK94_46_L      _PK_L_(0x94, 0x46)
#define REG_SC_BK94_46_H      _PK_H_(0x94, 0x46)
#define REG_SC_BK94_47_L      _PK_L_(0x94, 0x47)
#define REG_SC_BK94_47_H      _PK_H_(0x94, 0x47)
#define REG_SC_BK94_48_L      _PK_L_(0x94, 0x48)
#define REG_SC_BK94_48_H      _PK_H_(0x94, 0x48)
#define REG_SC_BK94_49_L      _PK_L_(0x94, 0x49)
#define REG_SC_BK94_49_H      _PK_H_(0x94, 0x49)
#define REG_SC_BK94_4A_L      _PK_L_(0x94, 0x4A)
#define REG_SC_BK94_4A_H      _PK_H_(0x94, 0x4A)
#define REG_SC_BK94_4B_L      _PK_L_(0x94, 0x4B)
#define REG_SC_BK94_4B_H      _PK_H_(0x94, 0x4B)
#define REG_SC_BK94_4C_L      _PK_L_(0x94, 0x4C)
#define REG_SC_BK94_4C_H      _PK_H_(0x94, 0x4C)
#define REG_SC_BK94_4D_L      _PK_L_(0x94, 0x4D)
#define REG_SC_BK94_4D_H      _PK_H_(0x94, 0x4D)
#define REG_SC_BK94_4E_L      _PK_L_(0x94, 0x4E)
#define REG_SC_BK94_4E_H      _PK_H_(0x94, 0x4E)
#define REG_SC_BK94_4F_L      _PK_L_(0x94, 0x4F)
#define REG_SC_BK94_4F_H      _PK_H_(0x94, 0x4F)
#define REG_SC_BK94_50_L      _PK_L_(0x94, 0x50)
#define REG_SC_BK94_50_H      _PK_H_(0x94, 0x50)
#define REG_SC_BK94_51_L      _PK_L_(0x94, 0x51)
#define REG_SC_BK94_51_H      _PK_H_(0x94, 0x51)
#define REG_SC_BK94_52_L      _PK_L_(0x94, 0x52)
#define REG_SC_BK94_52_H      _PK_H_(0x94, 0x52)
#define REG_SC_BK94_53_L      _PK_L_(0x94, 0x53)
#define REG_SC_BK94_53_H      _PK_H_(0x94, 0x53)
#define REG_SC_BK94_54_L      _PK_L_(0x94, 0x54)
#define REG_SC_BK94_54_H      _PK_H_(0x94, 0x54)
#define REG_SC_BK94_55_L      _PK_L_(0x94, 0x55)
#define REG_SC_BK94_55_H      _PK_H_(0x94, 0x55)
#define REG_SC_BK94_56_L      _PK_L_(0x94, 0x56)
#define REG_SC_BK94_56_H      _PK_H_(0x94, 0x56)
#define REG_SC_BK94_57_L      _PK_L_(0x94, 0x57)
#define REG_SC_BK94_57_H      _PK_H_(0x94, 0x57)
#define REG_SC_BK94_58_L      _PK_L_(0x94, 0x58)
#define REG_SC_BK94_58_H      _PK_H_(0x94, 0x58)
#define REG_SC_BK94_59_L      _PK_L_(0x94, 0x59)
#define REG_SC_BK94_59_H      _PK_H_(0x94, 0x59)
#define REG_SC_BK94_5A_L      _PK_L_(0x94, 0x5A)
#define REG_SC_BK94_5A_H      _PK_H_(0x94, 0x5A)
#define REG_SC_BK94_5B_L      _PK_L_(0x94, 0x5B)
#define REG_SC_BK94_5B_H      _PK_H_(0x94, 0x5B)
#define REG_SC_BK94_5C_L      _PK_L_(0x94, 0x5C)
#define REG_SC_BK94_5C_H      _PK_H_(0x94, 0x5C)
#define REG_SC_BK94_5D_L      _PK_L_(0x94, 0x5D)
#define REG_SC_BK94_5D_H      _PK_H_(0x94, 0x5D)
#define REG_SC_BK94_5E_L      _PK_L_(0x94, 0x5E)
#define REG_SC_BK94_5E_H      _PK_H_(0x94, 0x5E)
#define REG_SC_BK94_5F_L      _PK_L_(0x94, 0x5F)
#define REG_SC_BK94_5F_H      _PK_H_(0x94, 0x5F)
#define REG_SC_BK94_60_L      _PK_L_(0x94, 0x60)
#define REG_SC_BK94_60_H      _PK_H_(0x94, 0x60)
#define REG_SC_BK94_61_L      _PK_L_(0x94, 0x61)
#define REG_SC_BK94_61_H      _PK_H_(0x94, 0x61)
#define REG_SC_BK94_62_L      _PK_L_(0x94, 0x62)
#define REG_SC_BK94_62_H      _PK_H_(0x94, 0x62)
#define REG_SC_BK94_63_L      _PK_L_(0x94, 0x63)
#define REG_SC_BK94_63_H      _PK_H_(0x94, 0x63)
#define REG_SC_BK94_64_L      _PK_L_(0x94, 0x64)
#define REG_SC_BK94_64_H      _PK_H_(0x94, 0x64)
#define REG_SC_BK94_65_L      _PK_L_(0x94, 0x65)
#define REG_SC_BK94_65_H      _PK_H_(0x94, 0x65)
#define REG_SC_BK94_66_L      _PK_L_(0x94, 0x66)
#define REG_SC_BK94_66_H      _PK_H_(0x94, 0x66)
#define REG_SC_BK94_67_L      _PK_L_(0x94, 0x67)
#define REG_SC_BK94_67_H      _PK_H_(0x94, 0x67)
#define REG_SC_BK94_68_L      _PK_L_(0x94, 0x68)
#define REG_SC_BK94_68_H      _PK_H_(0x94, 0x68)
#define REG_SC_BK94_69_L      _PK_L_(0x94, 0x69)
#define REG_SC_BK94_69_H      _PK_H_(0x94, 0x69)
#define REG_SC_BK94_6A_L      _PK_L_(0x94, 0x6A)
#define REG_SC_BK94_6A_H      _PK_H_(0x94, 0x6A)
#define REG_SC_BK94_6B_L      _PK_L_(0x94, 0x6B)
#define REG_SC_BK94_6B_H      _PK_H_(0x94, 0x6B)
#define REG_SC_BK94_6C_L      _PK_L_(0x94, 0x6C)
#define REG_SC_BK94_6C_H      _PK_H_(0x94, 0x6C)
#define REG_SC_BK94_6D_L      _PK_L_(0x94, 0x6D)
#define REG_SC_BK94_6D_H      _PK_H_(0x94, 0x6D)
#define REG_SC_BK94_6E_L      _PK_L_(0x94, 0x6E)
#define REG_SC_BK94_6E_H      _PK_H_(0x94, 0x6E)
#define REG_SC_BK94_6F_L      _PK_L_(0x94, 0x6F)
#define REG_SC_BK94_6F_H      _PK_H_(0x94, 0x6F)
#define REG_SC_BK94_70_L      _PK_L_(0x94, 0x70)
#define REG_SC_BK94_70_H      _PK_H_(0x94, 0x70)
#define REG_SC_BK94_71_L      _PK_L_(0x94, 0x71)
#define REG_SC_BK94_71_H      _PK_H_(0x94, 0x71)
#define REG_SC_BK94_72_L      _PK_L_(0x94, 0x72)
#define REG_SC_BK94_72_H      _PK_H_(0x94, 0x72)
#define REG_SC_BK94_73_L      _PK_L_(0x94, 0x73)
#define REG_SC_BK94_73_H      _PK_H_(0x94, 0x73)
#define REG_SC_BK94_74_L      _PK_L_(0x94, 0x74)
#define REG_SC_BK94_74_H      _PK_H_(0x94, 0x74)
#define REG_SC_BK94_75_L      _PK_L_(0x94, 0x75)
#define REG_SC_BK94_75_H      _PK_H_(0x94, 0x75)
#define REG_SC_BK94_76_L      _PK_L_(0x94, 0x76)
#define REG_SC_BK94_76_H      _PK_H_(0x94, 0x76)
#define REG_SC_BK94_77_L      _PK_L_(0x94, 0x77)
#define REG_SC_BK94_77_H      _PK_H_(0x94, 0x77)
#define REG_SC_BK94_78_L      _PK_L_(0x94, 0x78)
#define REG_SC_BK94_78_H      _PK_H_(0x94, 0x78)
#define REG_SC_BK94_79_L      _PK_L_(0x94, 0x79)
#define REG_SC_BK94_79_H      _PK_H_(0x94, 0x79)
#define REG_SC_BK94_7A_L      _PK_L_(0x94, 0x7A)
#define REG_SC_BK94_7A_H      _PK_H_(0x94, 0x7A)
#define REG_SC_BK94_7B_L      _PK_L_(0x94, 0x7B)
#define REG_SC_BK94_7B_H      _PK_H_(0x94, 0x7B)
#define REG_SC_BK94_7C_L      _PK_L_(0x94, 0x7C)
#define REG_SC_BK94_7C_H      _PK_H_(0x94, 0x7C)
#define REG_SC_BK94_7D_L      _PK_L_(0x94, 0x7D)
#define REG_SC_BK94_7D_H      _PK_H_(0x94, 0x7D)
#define REG_SC_BK94_7E_L      _PK_L_(0x94, 0x7E)
#define REG_SC_BK94_7E_H      _PK_H_(0x94, 0x7E)
#define REG_SC_BK94_7F_L      _PK_L_(0x94, 0x7F)
#define REG_SC_BK94_7F_H      _PK_H_(0x94, 0x7F)
//----------------------------------------------
#define REG_SC_BK95_00_L      _PK_L_(0x95, 0x00)
#define REG_SC_BK95_00_H      _PK_H_(0x95, 0x00)
#define REG_SC_BK95_01_L      _PK_L_(0x95, 0x01)
#define REG_SC_BK95_01_H      _PK_H_(0x95, 0x01)
#define REG_SC_BK95_02_L      _PK_L_(0x95, 0x02)
#define REG_SC_BK95_02_H      _PK_H_(0x95, 0x02)
#define REG_SC_BK95_03_L      _PK_L_(0x95, 0x03)
#define REG_SC_BK95_03_H      _PK_H_(0x95, 0x03)
#define REG_SC_BK95_04_L      _PK_L_(0x95, 0x04)
#define REG_SC_BK95_04_H      _PK_H_(0x95, 0x04)
#define REG_SC_BK95_05_L      _PK_L_(0x95, 0x05)
#define REG_SC_BK95_05_H      _PK_H_(0x95, 0x05)
#define REG_SC_BK95_06_L      _PK_L_(0x95, 0x06)
#define REG_SC_BK95_06_H      _PK_H_(0x95, 0x06)
#define REG_SC_BK95_07_L      _PK_L_(0x95, 0x07)
#define REG_SC_BK95_07_H      _PK_H_(0x95, 0x07)
#define REG_SC_BK95_08_L      _PK_L_(0x95, 0x08)
#define REG_SC_BK95_08_H      _PK_H_(0x95, 0x08)
#define REG_SC_BK95_09_L      _PK_L_(0x95, 0x09)
#define REG_SC_BK95_09_H      _PK_H_(0x95, 0x09)
#define REG_SC_BK95_0A_L      _PK_L_(0x95, 0x0A)
#define REG_SC_BK95_0A_H      _PK_H_(0x95, 0x0A)
#define REG_SC_BK95_0B_L      _PK_L_(0x95, 0x0B)
#define REG_SC_BK95_0B_H      _PK_H_(0x95, 0x0B)
#define REG_SC_BK95_0C_L      _PK_L_(0x95, 0x0C)
#define REG_SC_BK95_0C_H      _PK_H_(0x95, 0x0C)
#define REG_SC_BK95_0D_L      _PK_L_(0x95, 0x0D)
#define REG_SC_BK95_0D_H      _PK_H_(0x95, 0x0D)
#define REG_SC_BK95_0E_L      _PK_L_(0x95, 0x0E)
#define REG_SC_BK95_0E_H      _PK_H_(0x95, 0x0E)
#define REG_SC_BK95_0F_L      _PK_L_(0x95, 0x0F)
#define REG_SC_BK95_0F_H      _PK_H_(0x95, 0x0F)
#define REG_SC_BK95_10_L      _PK_L_(0x95, 0x10)
#define REG_SC_BK95_10_H      _PK_H_(0x95, 0x10)
#define REG_SC_BK95_11_L      _PK_L_(0x95, 0x11)
#define REG_SC_BK95_11_H      _PK_H_(0x95, 0x11)
#define REG_SC_BK95_12_L      _PK_L_(0x95, 0x12)
#define REG_SC_BK95_12_H      _PK_H_(0x95, 0x12)
#define REG_SC_BK95_13_L      _PK_L_(0x95, 0x13)
#define REG_SC_BK95_13_H      _PK_H_(0x95, 0x13)
#define REG_SC_BK95_14_L      _PK_L_(0x95, 0x14)
#define REG_SC_BK95_14_H      _PK_H_(0x95, 0x14)
#define REG_SC_BK95_15_L      _PK_L_(0x95, 0x15)
#define REG_SC_BK95_15_H      _PK_H_(0x95, 0x15)
#define REG_SC_BK95_16_L      _PK_L_(0x95, 0x16)
#define REG_SC_BK95_16_H      _PK_H_(0x95, 0x16)
#define REG_SC_BK95_17_L      _PK_L_(0x95, 0x17)
#define REG_SC_BK95_17_H      _PK_H_(0x95, 0x17)
#define REG_SC_BK95_18_L      _PK_L_(0x95, 0x18)
#define REG_SC_BK95_18_H      _PK_H_(0x95, 0x18)
#define REG_SC_BK95_19_L      _PK_L_(0x95, 0x19)
#define REG_SC_BK95_19_H      _PK_H_(0x95, 0x19)
#define REG_SC_BK95_1A_L      _PK_L_(0x95, 0x1A)
#define REG_SC_BK95_1A_H      _PK_H_(0x95, 0x1A)
#define REG_SC_BK95_1B_L      _PK_L_(0x95, 0x1B)
#define REG_SC_BK95_1B_H      _PK_H_(0x95, 0x1B)
#define REG_SC_BK95_1C_L      _PK_L_(0x95, 0x1C)
#define REG_SC_BK95_1C_H      _PK_H_(0x95, 0x1C)
#define REG_SC_BK95_1D_L      _PK_L_(0x95, 0x1D)
#define REG_SC_BK95_1D_H      _PK_H_(0x95, 0x1D)
#define REG_SC_BK95_1E_L      _PK_L_(0x95, 0x1E)
#define REG_SC_BK95_1E_H      _PK_H_(0x95, 0x1E)
#define REG_SC_BK95_1F_L      _PK_L_(0x95, 0x1F)
#define REG_SC_BK95_1F_H      _PK_H_(0x95, 0x1F)
#define REG_SC_BK95_20_L      _PK_L_(0x95, 0x20)
#define REG_SC_BK95_20_H      _PK_H_(0x95, 0x20)
#define REG_SC_BK95_21_L      _PK_L_(0x95, 0x21)
#define REG_SC_BK95_21_H      _PK_H_(0x95, 0x21)
#define REG_SC_BK95_22_L      _PK_L_(0x95, 0x22)
#define REG_SC_BK95_22_H      _PK_H_(0x95, 0x22)
#define REG_SC_BK95_23_L      _PK_L_(0x95, 0x23)
#define REG_SC_BK95_23_H      _PK_H_(0x95, 0x23)
#define REG_SC_BK95_24_L      _PK_L_(0x95, 0x24)
#define REG_SC_BK95_24_H      _PK_H_(0x95, 0x24)
#define REG_SC_BK95_25_L      _PK_L_(0x95, 0x25)
#define REG_SC_BK95_25_H      _PK_H_(0x95, 0x25)
#define REG_SC_BK95_26_L      _PK_L_(0x95, 0x26)
#define REG_SC_BK95_26_H      _PK_H_(0x95, 0x26)
#define REG_SC_BK95_27_L      _PK_L_(0x95, 0x27)
#define REG_SC_BK95_27_H      _PK_H_(0x95, 0x27)
#define REG_SC_BK95_28_L      _PK_L_(0x95, 0x28)
#define REG_SC_BK95_28_H      _PK_H_(0x95, 0x28)
#define REG_SC_BK95_29_L      _PK_L_(0x95, 0x29)
#define REG_SC_BK95_29_H      _PK_H_(0x95, 0x29)
#define REG_SC_BK95_2A_L      _PK_L_(0x95, 0x2A)
#define REG_SC_BK95_2A_H      _PK_H_(0x95, 0x2A)
#define REG_SC_BK95_2B_L      _PK_L_(0x95, 0x2B)
#define REG_SC_BK95_2B_H      _PK_H_(0x95, 0x2B)
#define REG_SC_BK95_2C_L      _PK_L_(0x95, 0x2C)
#define REG_SC_BK95_2C_H      _PK_H_(0x95, 0x2C)
#define REG_SC_BK95_2D_L      _PK_L_(0x95, 0x2D)
#define REG_SC_BK95_2D_H      _PK_H_(0x95, 0x2D)
#define REG_SC_BK95_2E_L      _PK_L_(0x95, 0x2E)
#define REG_SC_BK95_2E_H      _PK_H_(0x95, 0x2E)
#define REG_SC_BK95_2F_L      _PK_L_(0x95, 0x2F)
#define REG_SC_BK95_2F_H      _PK_H_(0x95, 0x2F)
#define REG_SC_BK95_30_L      _PK_L_(0x95, 0x30)
#define REG_SC_BK95_30_H      _PK_H_(0x95, 0x30)
#define REG_SC_BK95_31_L      _PK_L_(0x95, 0x31)
#define REG_SC_BK95_31_H      _PK_H_(0x95, 0x31)
#define REG_SC_BK95_32_L      _PK_L_(0x95, 0x32)
#define REG_SC_BK95_32_H      _PK_H_(0x95, 0x32)
#define REG_SC_BK95_33_L      _PK_L_(0x95, 0x33)
#define REG_SC_BK95_33_H      _PK_H_(0x95, 0x33)
#define REG_SC_BK95_34_L      _PK_L_(0x95, 0x34)
#define REG_SC_BK95_34_H      _PK_H_(0x95, 0x34)
#define REG_SC_BK95_35_L      _PK_L_(0x95, 0x35)
#define REG_SC_BK95_35_H      _PK_H_(0x95, 0x35)
#define REG_SC_BK95_36_L      _PK_L_(0x95, 0x36)
#define REG_SC_BK95_36_H      _PK_H_(0x95, 0x36)
#define REG_SC_BK95_37_L      _PK_L_(0x95, 0x37)
#define REG_SC_BK95_37_H      _PK_H_(0x95, 0x37)
#define REG_SC_BK95_38_L      _PK_L_(0x95, 0x38)
#define REG_SC_BK95_38_H      _PK_H_(0x95, 0x38)
#define REG_SC_BK95_39_L      _PK_L_(0x95, 0x39)
#define REG_SC_BK95_39_H      _PK_H_(0x95, 0x39)
#define REG_SC_BK95_3A_L      _PK_L_(0x95, 0x3A)
#define REG_SC_BK95_3A_H      _PK_H_(0x95, 0x3A)
#define REG_SC_BK95_3B_L      _PK_L_(0x95, 0x3B)
#define REG_SC_BK95_3B_H      _PK_H_(0x95, 0x3B)
#define REG_SC_BK95_3C_L      _PK_L_(0x95, 0x3C)
#define REG_SC_BK95_3C_H      _PK_H_(0x95, 0x3C)
#define REG_SC_BK95_3D_L      _PK_L_(0x95, 0x3D)
#define REG_SC_BK95_3D_H      _PK_H_(0x95, 0x3D)
#define REG_SC_BK95_3E_L      _PK_L_(0x95, 0x3E)
#define REG_SC_BK95_3E_H      _PK_H_(0x95, 0x3E)
#define REG_SC_BK95_3F_L      _PK_L_(0x95, 0x3F)
#define REG_SC_BK95_3F_H      _PK_H_(0x95, 0x3F)
#define REG_SC_BK95_40_L      _PK_L_(0x95, 0x40)
#define REG_SC_BK95_40_H      _PK_H_(0x95, 0x40)
#define REG_SC_BK95_41_L      _PK_L_(0x95, 0x41)
#define REG_SC_BK95_41_H      _PK_H_(0x95, 0x41)
#define REG_SC_BK95_42_L      _PK_L_(0x95, 0x42)
#define REG_SC_BK95_42_H      _PK_H_(0x95, 0x42)
#define REG_SC_BK95_43_L      _PK_L_(0x95, 0x43)
#define REG_SC_BK95_43_H      _PK_H_(0x95, 0x43)
#define REG_SC_BK95_44_L      _PK_L_(0x95, 0x44)
#define REG_SC_BK95_44_H      _PK_H_(0x95, 0x44)
#define REG_SC_BK95_45_L      _PK_L_(0x95, 0x45)
#define REG_SC_BK95_45_H      _PK_H_(0x95, 0x45)
#define REG_SC_BK95_46_L      _PK_L_(0x95, 0x46)
#define REG_SC_BK95_46_H      _PK_H_(0x95, 0x46)
#define REG_SC_BK95_47_L      _PK_L_(0x95, 0x47)
#define REG_SC_BK95_47_H      _PK_H_(0x95, 0x47)
#define REG_SC_BK95_48_L      _PK_L_(0x95, 0x48)
#define REG_SC_BK95_48_H      _PK_H_(0x95, 0x48)
#define REG_SC_BK95_49_L      _PK_L_(0x95, 0x49)
#define REG_SC_BK95_49_H      _PK_H_(0x95, 0x49)
#define REG_SC_BK95_4A_L      _PK_L_(0x95, 0x4A)
#define REG_SC_BK95_4A_H      _PK_H_(0x95, 0x4A)
#define REG_SC_BK95_4B_L      _PK_L_(0x95, 0x4B)
#define REG_SC_BK95_4B_H      _PK_H_(0x95, 0x4B)
#define REG_SC_BK95_4C_L      _PK_L_(0x95, 0x4C)
#define REG_SC_BK95_4C_H      _PK_H_(0x95, 0x4C)
#define REG_SC_BK95_4D_L      _PK_L_(0x95, 0x4D)
#define REG_SC_BK95_4D_H      _PK_H_(0x95, 0x4D)
#define REG_SC_BK95_4E_L      _PK_L_(0x95, 0x4E)
#define REG_SC_BK95_4E_H      _PK_H_(0x95, 0x4E)
#define REG_SC_BK95_4F_L      _PK_L_(0x95, 0x4F)
#define REG_SC_BK95_4F_H      _PK_H_(0x95, 0x4F)
#define REG_SC_BK95_50_L      _PK_L_(0x95, 0x50)
#define REG_SC_BK95_50_H      _PK_H_(0x95, 0x50)
#define REG_SC_BK95_51_L      _PK_L_(0x95, 0x51)
#define REG_SC_BK95_51_H      _PK_H_(0x95, 0x51)
#define REG_SC_BK95_52_L      _PK_L_(0x95, 0x52)
#define REG_SC_BK95_52_H      _PK_H_(0x95, 0x52)
#define REG_SC_BK95_53_L      _PK_L_(0x95, 0x53)
#define REG_SC_BK95_53_H      _PK_H_(0x95, 0x53)
#define REG_SC_BK95_54_L      _PK_L_(0x95, 0x54)
#define REG_SC_BK95_54_H      _PK_H_(0x95, 0x54)
#define REG_SC_BK95_55_L      _PK_L_(0x95, 0x55)
#define REG_SC_BK95_55_H      _PK_H_(0x95, 0x55)
#define REG_SC_BK95_56_L      _PK_L_(0x95, 0x56)
#define REG_SC_BK95_56_H      _PK_H_(0x95, 0x56)
#define REG_SC_BK95_57_L      _PK_L_(0x95, 0x57)
#define REG_SC_BK95_57_H      _PK_H_(0x95, 0x57)
#define REG_SC_BK95_58_L      _PK_L_(0x95, 0x58)
#define REG_SC_BK95_58_H      _PK_H_(0x95, 0x58)
#define REG_SC_BK95_59_L      _PK_L_(0x95, 0x59)
#define REG_SC_BK95_59_H      _PK_H_(0x95, 0x59)
#define REG_SC_BK95_5A_L      _PK_L_(0x95, 0x5A)
#define REG_SC_BK95_5A_H      _PK_H_(0x95, 0x5A)
#define REG_SC_BK95_5B_L      _PK_L_(0x95, 0x5B)
#define REG_SC_BK95_5B_H      _PK_H_(0x95, 0x5B)
#define REG_SC_BK95_5C_L      _PK_L_(0x95, 0x5C)
#define REG_SC_BK95_5C_H      _PK_H_(0x95, 0x5C)
#define REG_SC_BK95_5D_L      _PK_L_(0x95, 0x5D)
#define REG_SC_BK95_5D_H      _PK_H_(0x95, 0x5D)
#define REG_SC_BK95_5E_L      _PK_L_(0x95, 0x5E)
#define REG_SC_BK95_5E_H      _PK_H_(0x95, 0x5E)
#define REG_SC_BK95_5F_L      _PK_L_(0x95, 0x5F)
#define REG_SC_BK95_5F_H      _PK_H_(0x95, 0x5F)
#define REG_SC_BK95_60_L      _PK_L_(0x95, 0x60)
#define REG_SC_BK95_60_H      _PK_H_(0x95, 0x60)
#define REG_SC_BK95_61_L      _PK_L_(0x95, 0x61)
#define REG_SC_BK95_61_H      _PK_H_(0x95, 0x61)
#define REG_SC_BK95_62_L      _PK_L_(0x95, 0x62)
#define REG_SC_BK95_62_H      _PK_H_(0x95, 0x62)
#define REG_SC_BK95_63_L      _PK_L_(0x95, 0x63)
#define REG_SC_BK95_63_H      _PK_H_(0x95, 0x63)
#define REG_SC_BK95_64_L      _PK_L_(0x95, 0x64)
#define REG_SC_BK95_64_H      _PK_H_(0x95, 0x64)
#define REG_SC_BK95_65_L      _PK_L_(0x95, 0x65)
#define REG_SC_BK95_65_H      _PK_H_(0x95, 0x65)
#define REG_SC_BK95_66_L      _PK_L_(0x95, 0x66)
#define REG_SC_BK95_66_H      _PK_H_(0x95, 0x66)
#define REG_SC_BK95_67_L      _PK_L_(0x95, 0x67)
#define REG_SC_BK95_67_H      _PK_H_(0x95, 0x67)
#define REG_SC_BK95_68_L      _PK_L_(0x95, 0x68)
#define REG_SC_BK95_68_H      _PK_H_(0x95, 0x68)
#define REG_SC_BK95_69_L      _PK_L_(0x95, 0x69)
#define REG_SC_BK95_69_H      _PK_H_(0x95, 0x69)
#define REG_SC_BK95_6A_L      _PK_L_(0x95, 0x6A)
#define REG_SC_BK95_6A_H      _PK_H_(0x95, 0x6A)
#define REG_SC_BK95_6B_L      _PK_L_(0x95, 0x6B)
#define REG_SC_BK95_6B_H      _PK_H_(0x95, 0x6B)
#define REG_SC_BK95_6C_L      _PK_L_(0x95, 0x6C)
#define REG_SC_BK95_6C_H      _PK_H_(0x95, 0x6C)
#define REG_SC_BK95_6D_L      _PK_L_(0x95, 0x6D)
#define REG_SC_BK95_6D_H      _PK_H_(0x95, 0x6D)
#define REG_SC_BK95_6E_L      _PK_L_(0x95, 0x6E)
#define REG_SC_BK95_6E_H      _PK_H_(0x95, 0x6E)
#define REG_SC_BK95_6F_L      _PK_L_(0x95, 0x6F)
#define REG_SC_BK95_6F_H      _PK_H_(0x95, 0x6F)
#define REG_SC_BK95_70_L      _PK_L_(0x95, 0x70)
#define REG_SC_BK95_70_H      _PK_H_(0x95, 0x70)
#define REG_SC_BK95_71_L      _PK_L_(0x95, 0x71)
#define REG_SC_BK95_71_H      _PK_H_(0x95, 0x71)
#define REG_SC_BK95_72_L      _PK_L_(0x95, 0x72)
#define REG_SC_BK95_72_H      _PK_H_(0x95, 0x72)
#define REG_SC_BK95_73_L      _PK_L_(0x95, 0x73)
#define REG_SC_BK95_73_H      _PK_H_(0x95, 0x73)
#define REG_SC_BK95_74_L      _PK_L_(0x95, 0x74)
#define REG_SC_BK95_74_H      _PK_H_(0x95, 0x74)
#define REG_SC_BK95_75_L      _PK_L_(0x95, 0x75)
#define REG_SC_BK95_75_H      _PK_H_(0x95, 0x75)
#define REG_SC_BK95_76_L      _PK_L_(0x95, 0x76)
#define REG_SC_BK95_76_H      _PK_H_(0x95, 0x76)
#define REG_SC_BK95_77_L      _PK_L_(0x95, 0x77)
#define REG_SC_BK95_77_H      _PK_H_(0x95, 0x77)
#define REG_SC_BK95_78_L      _PK_L_(0x95, 0x78)
#define REG_SC_BK95_78_H      _PK_H_(0x95, 0x78)
#define REG_SC_BK95_79_L      _PK_L_(0x95, 0x79)
#define REG_SC_BK95_79_H      _PK_H_(0x95, 0x79)
#define REG_SC_BK95_7A_L      _PK_L_(0x95, 0x7A)
#define REG_SC_BK95_7A_H      _PK_H_(0x95, 0x7A)
#define REG_SC_BK95_7B_L      _PK_L_(0x95, 0x7B)
#define REG_SC_BK95_7B_H      _PK_H_(0x95, 0x7B)
#define REG_SC_BK95_7C_L      _PK_L_(0x95, 0x7C)
#define REG_SC_BK95_7C_H      _PK_H_(0x95, 0x7C)
#define REG_SC_BK95_7D_L      _PK_L_(0x95, 0x7D)
#define REG_SC_BK95_7D_H      _PK_H_(0x95, 0x7D)
#define REG_SC_BK95_7E_L      _PK_L_(0x95, 0x7E)
#define REG_SC_BK95_7E_H      _PK_H_(0x95, 0x7E)
#define REG_SC_BK95_7F_L      _PK_L_(0x95, 0x7F)
#define REG_SC_BK95_7F_H      _PK_H_(0x95, 0x7F)
//----------------------------------------------
#define REG_SC_BK96_00_L      _PK_L_(0x96, 0x00)
#define REG_SC_BK96_00_H      _PK_H_(0x96, 0x00)
#define REG_SC_BK96_01_L      _PK_L_(0x96, 0x01)
#define REG_SC_BK96_01_H      _PK_H_(0x96, 0x01)
#define REG_SC_BK96_02_L      _PK_L_(0x96, 0x02)
#define REG_SC_BK96_02_H      _PK_H_(0x96, 0x02)
#define REG_SC_BK96_03_L      _PK_L_(0x96, 0x03)
#define REG_SC_BK96_03_H      _PK_H_(0x96, 0x03)
#define REG_SC_BK96_04_L      _PK_L_(0x96, 0x04)
#define REG_SC_BK96_04_H      _PK_H_(0x96, 0x04)
#define REG_SC_BK96_05_L      _PK_L_(0x96, 0x05)
#define REG_SC_BK96_05_H      _PK_H_(0x96, 0x05)
#define REG_SC_BK96_06_L      _PK_L_(0x96, 0x06)
#define REG_SC_BK96_06_H      _PK_H_(0x96, 0x06)
#define REG_SC_BK96_07_L      _PK_L_(0x96, 0x07)
#define REG_SC_BK96_07_H      _PK_H_(0x96, 0x07)
#define REG_SC_BK96_08_L      _PK_L_(0x96, 0x08)
#define REG_SC_BK96_08_H      _PK_H_(0x96, 0x08)
#define REG_SC_BK96_09_L      _PK_L_(0x96, 0x09)
#define REG_SC_BK96_09_H      _PK_H_(0x96, 0x09)
#define REG_SC_BK96_0A_L      _PK_L_(0x96, 0x0A)
#define REG_SC_BK96_0A_H      _PK_H_(0x96, 0x0A)
#define REG_SC_BK96_0B_L      _PK_L_(0x96, 0x0B)
#define REG_SC_BK96_0B_H      _PK_H_(0x96, 0x0B)
#define REG_SC_BK96_0C_L      _PK_L_(0x96, 0x0C)
#define REG_SC_BK96_0C_H      _PK_H_(0x96, 0x0C)
#define REG_SC_BK96_0D_L      _PK_L_(0x96, 0x0D)
#define REG_SC_BK96_0D_H      _PK_H_(0x96, 0x0D)
#define REG_SC_BK96_0E_L      _PK_L_(0x96, 0x0E)
#define REG_SC_BK96_0E_H      _PK_H_(0x96, 0x0E)
#define REG_SC_BK96_0F_L      _PK_L_(0x96, 0x0F)
#define REG_SC_BK96_0F_H      _PK_H_(0x96, 0x0F)
#define REG_SC_BK96_10_L      _PK_L_(0x96, 0x10)
#define REG_SC_BK96_10_H      _PK_H_(0x96, 0x10)
#define REG_SC_BK96_11_L      _PK_L_(0x96, 0x11)
#define REG_SC_BK96_11_H      _PK_H_(0x96, 0x11)
#define REG_SC_BK96_12_L      _PK_L_(0x96, 0x12)
#define REG_SC_BK96_12_H      _PK_H_(0x96, 0x12)
#define REG_SC_BK96_13_L      _PK_L_(0x96, 0x13)
#define REG_SC_BK96_13_H      _PK_H_(0x96, 0x13)
#define REG_SC_BK96_14_L      _PK_L_(0x96, 0x14)
#define REG_SC_BK96_14_H      _PK_H_(0x96, 0x14)
#define REG_SC_BK96_15_L      _PK_L_(0x96, 0x15)
#define REG_SC_BK96_15_H      _PK_H_(0x96, 0x15)
#define REG_SC_BK96_16_L      _PK_L_(0x96, 0x16)
#define REG_SC_BK96_16_H      _PK_H_(0x96, 0x16)
#define REG_SC_BK96_17_L      _PK_L_(0x96, 0x17)
#define REG_SC_BK96_17_H      _PK_H_(0x96, 0x17)
#define REG_SC_BK96_18_L      _PK_L_(0x96, 0x18)
#define REG_SC_BK96_18_H      _PK_H_(0x96, 0x18)
#define REG_SC_BK96_19_L      _PK_L_(0x96, 0x19)
#define REG_SC_BK96_19_H      _PK_H_(0x96, 0x19)
#define REG_SC_BK96_1A_L      _PK_L_(0x96, 0x1A)
#define REG_SC_BK96_1A_H      _PK_H_(0x96, 0x1A)
#define REG_SC_BK96_1B_L      _PK_L_(0x96, 0x1B)
#define REG_SC_BK96_1B_H      _PK_H_(0x96, 0x1B)
#define REG_SC_BK96_1C_L      _PK_L_(0x96, 0x1C)
#define REG_SC_BK96_1C_H      _PK_H_(0x96, 0x1C)
#define REG_SC_BK96_1D_L      _PK_L_(0x96, 0x1D)
#define REG_SC_BK96_1D_H      _PK_H_(0x96, 0x1D)
#define REG_SC_BK96_1E_L      _PK_L_(0x96, 0x1E)
#define REG_SC_BK96_1E_H      _PK_H_(0x96, 0x1E)
#define REG_SC_BK96_1F_L      _PK_L_(0x96, 0x1F)
#define REG_SC_BK96_1F_H      _PK_H_(0x96, 0x1F)
#define REG_SC_BK96_20_L      _PK_L_(0x96, 0x20)
#define REG_SC_BK96_20_H      _PK_H_(0x96, 0x20)
#define REG_SC_BK96_21_L      _PK_L_(0x96, 0x21)
#define REG_SC_BK96_21_H      _PK_H_(0x96, 0x21)
#define REG_SC_BK96_22_L      _PK_L_(0x96, 0x22)
#define REG_SC_BK96_22_H      _PK_H_(0x96, 0x22)
#define REG_SC_BK96_23_L      _PK_L_(0x96, 0x23)
#define REG_SC_BK96_23_H      _PK_H_(0x96, 0x23)
#define REG_SC_BK96_24_L      _PK_L_(0x96, 0x24)
#define REG_SC_BK96_24_H      _PK_H_(0x96, 0x24)
#define REG_SC_BK96_25_L      _PK_L_(0x96, 0x25)
#define REG_SC_BK96_25_H      _PK_H_(0x96, 0x25)
#define REG_SC_BK96_26_L      _PK_L_(0x96, 0x26)
#define REG_SC_BK96_26_H      _PK_H_(0x96, 0x26)
#define REG_SC_BK96_27_L      _PK_L_(0x96, 0x27)
#define REG_SC_BK96_27_H      _PK_H_(0x96, 0x27)
#define REG_SC_BK96_28_L      _PK_L_(0x96, 0x28)
#define REG_SC_BK96_28_H      _PK_H_(0x96, 0x28)
#define REG_SC_BK96_29_L      _PK_L_(0x96, 0x29)
#define REG_SC_BK96_29_H      _PK_H_(0x96, 0x29)
#define REG_SC_BK96_2A_L      _PK_L_(0x96, 0x2A)
#define REG_SC_BK96_2A_H      _PK_H_(0x96, 0x2A)
#define REG_SC_BK96_2B_L      _PK_L_(0x96, 0x2B)
#define REG_SC_BK96_2B_H      _PK_H_(0x96, 0x2B)
#define REG_SC_BK96_2C_L      _PK_L_(0x96, 0x2C)
#define REG_SC_BK96_2C_H      _PK_H_(0x96, 0x2C)
#define REG_SC_BK96_2D_L      _PK_L_(0x96, 0x2D)
#define REG_SC_BK96_2D_H      _PK_H_(0x96, 0x2D)
#define REG_SC_BK96_2E_L      _PK_L_(0x96, 0x2E)
#define REG_SC_BK96_2E_H      _PK_H_(0x96, 0x2E)
#define REG_SC_BK96_2F_L      _PK_L_(0x96, 0x2F)
#define REG_SC_BK96_2F_H      _PK_H_(0x96, 0x2F)
#define REG_SC_BK96_30_L      _PK_L_(0x96, 0x30)
#define REG_SC_BK96_30_H      _PK_H_(0x96, 0x30)
#define REG_SC_BK96_31_L      _PK_L_(0x96, 0x31)
#define REG_SC_BK96_31_H      _PK_H_(0x96, 0x31)
#define REG_SC_BK96_32_L      _PK_L_(0x96, 0x32)
#define REG_SC_BK96_32_H      _PK_H_(0x96, 0x32)
#define REG_SC_BK96_33_L      _PK_L_(0x96, 0x33)
#define REG_SC_BK96_33_H      _PK_H_(0x96, 0x33)
#define REG_SC_BK96_34_L      _PK_L_(0x96, 0x34)
#define REG_SC_BK96_34_H      _PK_H_(0x96, 0x34)
#define REG_SC_BK96_35_L      _PK_L_(0x96, 0x35)
#define REG_SC_BK96_35_H      _PK_H_(0x96, 0x35)
#define REG_SC_BK96_36_L      _PK_L_(0x96, 0x36)
#define REG_SC_BK96_36_H      _PK_H_(0x96, 0x36)
#define REG_SC_BK96_37_L      _PK_L_(0x96, 0x37)
#define REG_SC_BK96_37_H      _PK_H_(0x96, 0x37)
#define REG_SC_BK96_38_L      _PK_L_(0x96, 0x38)
#define REG_SC_BK96_38_H      _PK_H_(0x96, 0x38)
#define REG_SC_BK96_39_L      _PK_L_(0x96, 0x39)
#define REG_SC_BK96_39_H      _PK_H_(0x96, 0x39)
#define REG_SC_BK96_3A_L      _PK_L_(0x96, 0x3A)
#define REG_SC_BK96_3A_H      _PK_H_(0x96, 0x3A)
#define REG_SC_BK96_3B_L      _PK_L_(0x96, 0x3B)
#define REG_SC_BK96_3B_H      _PK_H_(0x96, 0x3B)
#define REG_SC_BK96_3C_L      _PK_L_(0x96, 0x3C)
#define REG_SC_BK96_3C_H      _PK_H_(0x96, 0x3C)
#define REG_SC_BK96_3D_L      _PK_L_(0x96, 0x3D)
#define REG_SC_BK96_3D_H      _PK_H_(0x96, 0x3D)
#define REG_SC_BK96_3E_L      _PK_L_(0x96, 0x3E)
#define REG_SC_BK96_3E_H      _PK_H_(0x96, 0x3E)
#define REG_SC_BK96_3F_L      _PK_L_(0x96, 0x3F)
#define REG_SC_BK96_3F_H      _PK_H_(0x96, 0x3F)
#define REG_SC_BK96_40_L      _PK_L_(0x96, 0x40)
#define REG_SC_BK96_40_H      _PK_H_(0x96, 0x40)
#define REG_SC_BK96_41_L      _PK_L_(0x96, 0x41)
#define REG_SC_BK96_41_H      _PK_H_(0x96, 0x41)
#define REG_SC_BK96_42_L      _PK_L_(0x96, 0x42)
#define REG_SC_BK96_42_H      _PK_H_(0x96, 0x42)
#define REG_SC_BK96_43_L      _PK_L_(0x96, 0x43)
#define REG_SC_BK96_43_H      _PK_H_(0x96, 0x43)
#define REG_SC_BK96_44_L      _PK_L_(0x96, 0x44)
#define REG_SC_BK96_44_H      _PK_H_(0x96, 0x44)
#define REG_SC_BK96_45_L      _PK_L_(0x96, 0x45)
#define REG_SC_BK96_45_H      _PK_H_(0x96, 0x45)
#define REG_SC_BK96_46_L      _PK_L_(0x96, 0x46)
#define REG_SC_BK96_46_H      _PK_H_(0x96, 0x46)
#define REG_SC_BK96_47_L      _PK_L_(0x96, 0x47)
#define REG_SC_BK96_47_H      _PK_H_(0x96, 0x47)
#define REG_SC_BK96_48_L      _PK_L_(0x96, 0x48)
#define REG_SC_BK96_48_H      _PK_H_(0x96, 0x48)
#define REG_SC_BK96_49_L      _PK_L_(0x96, 0x49)
#define REG_SC_BK96_49_H      _PK_H_(0x96, 0x49)
#define REG_SC_BK96_4A_L      _PK_L_(0x96, 0x4A)
#define REG_SC_BK96_4A_H      _PK_H_(0x96, 0x4A)
#define REG_SC_BK96_4B_L      _PK_L_(0x96, 0x4B)
#define REG_SC_BK96_4B_H      _PK_H_(0x96, 0x4B)
#define REG_SC_BK96_4C_L      _PK_L_(0x96, 0x4C)
#define REG_SC_BK96_4C_H      _PK_H_(0x96, 0x4C)
#define REG_SC_BK96_4D_L      _PK_L_(0x96, 0x4D)
#define REG_SC_BK96_4D_H      _PK_H_(0x96, 0x4D)
#define REG_SC_BK96_4E_L      _PK_L_(0x96, 0x4E)
#define REG_SC_BK96_4E_H      _PK_H_(0x96, 0x4E)
#define REG_SC_BK96_4F_L      _PK_L_(0x96, 0x4F)
#define REG_SC_BK96_4F_H      _PK_H_(0x96, 0x4F)
#define REG_SC_BK96_50_L      _PK_L_(0x96, 0x50)
#define REG_SC_BK96_50_H      _PK_H_(0x96, 0x50)
#define REG_SC_BK96_51_L      _PK_L_(0x96, 0x51)
#define REG_SC_BK96_51_H      _PK_H_(0x96, 0x51)
#define REG_SC_BK96_52_L      _PK_L_(0x96, 0x52)
#define REG_SC_BK96_52_H      _PK_H_(0x96, 0x52)
#define REG_SC_BK96_53_L      _PK_L_(0x96, 0x53)
#define REG_SC_BK96_53_H      _PK_H_(0x96, 0x53)
#define REG_SC_BK96_54_L      _PK_L_(0x96, 0x54)
#define REG_SC_BK96_54_H      _PK_H_(0x96, 0x54)
#define REG_SC_BK96_55_L      _PK_L_(0x96, 0x55)
#define REG_SC_BK96_55_H      _PK_H_(0x96, 0x55)
#define REG_SC_BK96_56_L      _PK_L_(0x96, 0x56)
#define REG_SC_BK96_56_H      _PK_H_(0x96, 0x56)
#define REG_SC_BK96_57_L      _PK_L_(0x96, 0x57)
#define REG_SC_BK96_57_H      _PK_H_(0x96, 0x57)
#define REG_SC_BK96_58_L      _PK_L_(0x96, 0x58)
#define REG_SC_BK96_58_H      _PK_H_(0x96, 0x58)
#define REG_SC_BK96_59_L      _PK_L_(0x96, 0x59)
#define REG_SC_BK96_59_H      _PK_H_(0x96, 0x59)
#define REG_SC_BK96_5A_L      _PK_L_(0x96, 0x5A)
#define REG_SC_BK96_5A_H      _PK_H_(0x96, 0x5A)
#define REG_SC_BK96_5B_L      _PK_L_(0x96, 0x5B)
#define REG_SC_BK96_5B_H      _PK_H_(0x96, 0x5B)
#define REG_SC_BK96_5C_L      _PK_L_(0x96, 0x5C)
#define REG_SC_BK96_5C_H      _PK_H_(0x96, 0x5C)
#define REG_SC_BK96_5D_L      _PK_L_(0x96, 0x5D)
#define REG_SC_BK96_5D_H      _PK_H_(0x96, 0x5D)
#define REG_SC_BK96_5E_L      _PK_L_(0x96, 0x5E)
#define REG_SC_BK96_5E_H      _PK_H_(0x96, 0x5E)
#define REG_SC_BK96_5F_L      _PK_L_(0x96, 0x5F)
#define REG_SC_BK96_5F_H      _PK_H_(0x96, 0x5F)
#define REG_SC_BK96_60_L      _PK_L_(0x96, 0x60)
#define REG_SC_BK96_60_H      _PK_H_(0x96, 0x60)
#define REG_SC_BK96_61_L      _PK_L_(0x96, 0x61)
#define REG_SC_BK96_61_H      _PK_H_(0x96, 0x61)
#define REG_SC_BK96_62_L      _PK_L_(0x96, 0x62)
#define REG_SC_BK96_62_H      _PK_H_(0x96, 0x62)
#define REG_SC_BK96_63_L      _PK_L_(0x96, 0x63)
#define REG_SC_BK96_63_H      _PK_H_(0x96, 0x63)
#define REG_SC_BK96_64_L      _PK_L_(0x96, 0x64)
#define REG_SC_BK96_64_H      _PK_H_(0x96, 0x64)
#define REG_SC_BK96_65_L      _PK_L_(0x96, 0x65)
#define REG_SC_BK96_65_H      _PK_H_(0x96, 0x65)
#define REG_SC_BK96_66_L      _PK_L_(0x96, 0x66)
#define REG_SC_BK96_66_H      _PK_H_(0x96, 0x66)
#define REG_SC_BK96_67_L      _PK_L_(0x96, 0x67)
#define REG_SC_BK96_67_H      _PK_H_(0x96, 0x67)
#define REG_SC_BK96_68_L      _PK_L_(0x96, 0x68)
#define REG_SC_BK96_68_H      _PK_H_(0x96, 0x68)
#define REG_SC_BK96_69_L      _PK_L_(0x96, 0x69)
#define REG_SC_BK96_69_H      _PK_H_(0x96, 0x69)
#define REG_SC_BK96_6A_L      _PK_L_(0x96, 0x6A)
#define REG_SC_BK96_6A_H      _PK_H_(0x96, 0x6A)
#define REG_SC_BK96_6B_L      _PK_L_(0x96, 0x6B)
#define REG_SC_BK96_6B_H      _PK_H_(0x96, 0x6B)
#define REG_SC_BK96_6C_L      _PK_L_(0x96, 0x6C)
#define REG_SC_BK96_6C_H      _PK_H_(0x96, 0x6C)
#define REG_SC_BK96_6D_L      _PK_L_(0x96, 0x6D)
#define REG_SC_BK96_6D_H      _PK_H_(0x96, 0x6D)
#define REG_SC_BK96_6E_L      _PK_L_(0x96, 0x6E)
#define REG_SC_BK96_6E_H      _PK_H_(0x96, 0x6E)
#define REG_SC_BK96_6F_L      _PK_L_(0x96, 0x6F)
#define REG_SC_BK96_6F_H      _PK_H_(0x96, 0x6F)
#define REG_SC_BK96_70_L      _PK_L_(0x96, 0x70)
#define REG_SC_BK96_70_H      _PK_H_(0x96, 0x70)
#define REG_SC_BK96_71_L      _PK_L_(0x96, 0x71)
#define REG_SC_BK96_71_H      _PK_H_(0x96, 0x71)
#define REG_SC_BK96_72_L      _PK_L_(0x96, 0x72)
#define REG_SC_BK96_72_H      _PK_H_(0x96, 0x72)
#define REG_SC_BK96_73_L      _PK_L_(0x96, 0x73)
#define REG_SC_BK96_73_H      _PK_H_(0x96, 0x73)
#define REG_SC_BK96_74_L      _PK_L_(0x96, 0x74)
#define REG_SC_BK96_74_H      _PK_H_(0x96, 0x74)
#define REG_SC_BK96_75_L      _PK_L_(0x96, 0x75)
#define REG_SC_BK96_75_H      _PK_H_(0x96, 0x75)
#define REG_SC_BK96_76_L      _PK_L_(0x96, 0x76)
#define REG_SC_BK96_76_H      _PK_H_(0x96, 0x76)
#define REG_SC_BK96_77_L      _PK_L_(0x96, 0x77)
#define REG_SC_BK96_77_H      _PK_H_(0x96, 0x77)
#define REG_SC_BK96_78_L      _PK_L_(0x96, 0x78)
#define REG_SC_BK96_78_H      _PK_H_(0x96, 0x78)
#define REG_SC_BK96_79_L      _PK_L_(0x96, 0x79)
#define REG_SC_BK96_79_H      _PK_H_(0x96, 0x79)
#define REG_SC_BK96_7A_L      _PK_L_(0x96, 0x7A)
#define REG_SC_BK96_7A_H      _PK_H_(0x96, 0x7A)
#define REG_SC_BK96_7B_L      _PK_L_(0x96, 0x7B)
#define REG_SC_BK96_7B_H      _PK_H_(0x96, 0x7B)
#define REG_SC_BK96_7C_L      _PK_L_(0x96, 0x7C)
#define REG_SC_BK96_7C_H      _PK_H_(0x96, 0x7C)
#define REG_SC_BK96_7D_L      _PK_L_(0x96, 0x7D)
#define REG_SC_BK96_7D_H      _PK_H_(0x96, 0x7D)
#define REG_SC_BK96_7E_L      _PK_L_(0x96, 0x7E)
#define REG_SC_BK96_7E_H      _PK_H_(0x96, 0x7E)
#define REG_SC_BK96_7F_L      _PK_L_(0x96, 0x7F)
#define REG_SC_BK96_7F_H      _PK_H_(0x96, 0x7F)
//----------------------------------------------
#define REG_SC_BK97_00_L      _PK_L_(0x97, 0x00)
#define REG_SC_BK97_00_H      _PK_H_(0x97, 0x00)
#define REG_SC_BK97_01_L      _PK_L_(0x97, 0x01)
#define REG_SC_BK97_01_H      _PK_H_(0x97, 0x01)
#define REG_SC_BK97_02_L      _PK_L_(0x97, 0x02)
#define REG_SC_BK97_02_H      _PK_H_(0x97, 0x02)
#define REG_SC_BK97_03_L      _PK_L_(0x97, 0x03)
#define REG_SC_BK97_03_H      _PK_H_(0x97, 0x03)
#define REG_SC_BK97_04_L      _PK_L_(0x97, 0x04)
#define REG_SC_BK97_04_H      _PK_H_(0x97, 0x04)
#define REG_SC_BK97_05_L      _PK_L_(0x97, 0x05)
#define REG_SC_BK97_05_H      _PK_H_(0x97, 0x05)
#define REG_SC_BK97_06_L      _PK_L_(0x97, 0x06)
#define REG_SC_BK97_06_H      _PK_H_(0x97, 0x06)
#define REG_SC_BK97_07_L      _PK_L_(0x97, 0x07)
#define REG_SC_BK97_07_H      _PK_H_(0x97, 0x07)
#define REG_SC_BK97_08_L      _PK_L_(0x97, 0x08)
#define REG_SC_BK97_08_H      _PK_H_(0x97, 0x08)
#define REG_SC_BK97_09_L      _PK_L_(0x97, 0x09)
#define REG_SC_BK97_09_H      _PK_H_(0x97, 0x09)
#define REG_SC_BK97_0A_L      _PK_L_(0x97, 0x0A)
#define REG_SC_BK97_0A_H      _PK_H_(0x97, 0x0A)
#define REG_SC_BK97_0B_L      _PK_L_(0x97, 0x0B)
#define REG_SC_BK97_0B_H      _PK_H_(0x97, 0x0B)
#define REG_SC_BK97_0C_L      _PK_L_(0x97, 0x0C)
#define REG_SC_BK97_0C_H      _PK_H_(0x97, 0x0C)
#define REG_SC_BK97_0D_L      _PK_L_(0x97, 0x0D)
#define REG_SC_BK97_0D_H      _PK_H_(0x97, 0x0D)
#define REG_SC_BK97_0E_L      _PK_L_(0x97, 0x0E)
#define REG_SC_BK97_0E_H      _PK_H_(0x97, 0x0E)
#define REG_SC_BK97_0F_L      _PK_L_(0x97, 0x0F)
#define REG_SC_BK97_0F_H      _PK_H_(0x97, 0x0F)
#define REG_SC_BK97_10_L      _PK_L_(0x97, 0x10)
#define REG_SC_BK97_10_H      _PK_H_(0x97, 0x10)
#define REG_SC_BK97_11_L      _PK_L_(0x97, 0x11)
#define REG_SC_BK97_11_H      _PK_H_(0x97, 0x11)
#define REG_SC_BK97_12_L      _PK_L_(0x97, 0x12)
#define REG_SC_BK97_12_H      _PK_H_(0x97, 0x12)
#define REG_SC_BK97_13_L      _PK_L_(0x97, 0x13)
#define REG_SC_BK97_13_H      _PK_H_(0x97, 0x13)
#define REG_SC_BK97_14_L      _PK_L_(0x97, 0x14)
#define REG_SC_BK97_14_H      _PK_H_(0x97, 0x14)
#define REG_SC_BK97_15_L      _PK_L_(0x97, 0x15)
#define REG_SC_BK97_15_H      _PK_H_(0x97, 0x15)
#define REG_SC_BK97_16_L      _PK_L_(0x97, 0x16)
#define REG_SC_BK97_16_H      _PK_H_(0x97, 0x16)
#define REG_SC_BK97_17_L      _PK_L_(0x97, 0x17)
#define REG_SC_BK97_17_H      _PK_H_(0x97, 0x17)
#define REG_SC_BK97_18_L      _PK_L_(0x97, 0x18)
#define REG_SC_BK97_18_H      _PK_H_(0x97, 0x18)
#define REG_SC_BK97_19_L      _PK_L_(0x97, 0x19)
#define REG_SC_BK97_19_H      _PK_H_(0x97, 0x19)
#define REG_SC_BK97_1A_L      _PK_L_(0x97, 0x1A)
#define REG_SC_BK97_1A_H      _PK_H_(0x97, 0x1A)
#define REG_SC_BK97_1B_L      _PK_L_(0x97, 0x1B)
#define REG_SC_BK97_1B_H      _PK_H_(0x97, 0x1B)
#define REG_SC_BK97_1C_L      _PK_L_(0x97, 0x1C)
#define REG_SC_BK97_1C_H      _PK_H_(0x97, 0x1C)
#define REG_SC_BK97_1D_L      _PK_L_(0x97, 0x1D)
#define REG_SC_BK97_1D_H      _PK_H_(0x97, 0x1D)
#define REG_SC_BK97_1E_L      _PK_L_(0x97, 0x1E)
#define REG_SC_BK97_1E_H      _PK_H_(0x97, 0x1E)
#define REG_SC_BK97_1F_L      _PK_L_(0x97, 0x1F)
#define REG_SC_BK97_1F_H      _PK_H_(0x97, 0x1F)
#define REG_SC_BK97_20_L      _PK_L_(0x97, 0x20)
#define REG_SC_BK97_20_H      _PK_H_(0x97, 0x20)
#define REG_SC_BK97_21_L      _PK_L_(0x97, 0x21)
#define REG_SC_BK97_21_H      _PK_H_(0x97, 0x21)
#define REG_SC_BK97_22_L      _PK_L_(0x97, 0x22)
#define REG_SC_BK97_22_H      _PK_H_(0x97, 0x22)
#define REG_SC_BK97_23_L      _PK_L_(0x97, 0x23)
#define REG_SC_BK97_23_H      _PK_H_(0x97, 0x23)
#define REG_SC_BK97_24_L      _PK_L_(0x97, 0x24)
#define REG_SC_BK97_24_H      _PK_H_(0x97, 0x24)
#define REG_SC_BK97_25_L      _PK_L_(0x97, 0x25)
#define REG_SC_BK97_25_H      _PK_H_(0x97, 0x25)
#define REG_SC_BK97_26_L      _PK_L_(0x97, 0x26)
#define REG_SC_BK97_26_H      _PK_H_(0x97, 0x26)
#define REG_SC_BK97_27_L      _PK_L_(0x97, 0x27)
#define REG_SC_BK97_27_H      _PK_H_(0x97, 0x27)
#define REG_SC_BK97_28_L      _PK_L_(0x97, 0x28)
#define REG_SC_BK97_28_H      _PK_H_(0x97, 0x28)
#define REG_SC_BK97_29_L      _PK_L_(0x97, 0x29)
#define REG_SC_BK97_29_H      _PK_H_(0x97, 0x29)
#define REG_SC_BK97_2A_L      _PK_L_(0x97, 0x2A)
#define REG_SC_BK97_2A_H      _PK_H_(0x97, 0x2A)
#define REG_SC_BK97_2B_L      _PK_L_(0x97, 0x2B)
#define REG_SC_BK97_2B_H      _PK_H_(0x97, 0x2B)
#define REG_SC_BK97_2C_L      _PK_L_(0x97, 0x2C)
#define REG_SC_BK97_2C_H      _PK_H_(0x97, 0x2C)
#define REG_SC_BK97_2D_L      _PK_L_(0x97, 0x2D)
#define REG_SC_BK97_2D_H      _PK_H_(0x97, 0x2D)
#define REG_SC_BK97_2E_L      _PK_L_(0x97, 0x2E)
#define REG_SC_BK97_2E_H      _PK_H_(0x97, 0x2E)
#define REG_SC_BK97_2F_L      _PK_L_(0x97, 0x2F)
#define REG_SC_BK97_2F_H      _PK_H_(0x97, 0x2F)
#define REG_SC_BK97_30_L      _PK_L_(0x97, 0x30)
#define REG_SC_BK97_30_H      _PK_H_(0x97, 0x30)
#define REG_SC_BK97_31_L      _PK_L_(0x97, 0x31)
#define REG_SC_BK97_31_H      _PK_H_(0x97, 0x31)
#define REG_SC_BK97_32_L      _PK_L_(0x97, 0x32)
#define REG_SC_BK97_32_H      _PK_H_(0x97, 0x32)
#define REG_SC_BK97_33_L      _PK_L_(0x97, 0x33)
#define REG_SC_BK97_33_H      _PK_H_(0x97, 0x33)
#define REG_SC_BK97_34_L      _PK_L_(0x97, 0x34)
#define REG_SC_BK97_34_H      _PK_H_(0x97, 0x34)
#define REG_SC_BK97_35_L      _PK_L_(0x97, 0x35)
#define REG_SC_BK97_35_H      _PK_H_(0x97, 0x35)
#define REG_SC_BK97_36_L      _PK_L_(0x97, 0x36)
#define REG_SC_BK97_36_H      _PK_H_(0x97, 0x36)
#define REG_SC_BK97_37_L      _PK_L_(0x97, 0x37)
#define REG_SC_BK97_37_H      _PK_H_(0x97, 0x37)
#define REG_SC_BK97_38_L      _PK_L_(0x97, 0x38)
#define REG_SC_BK97_38_H      _PK_H_(0x97, 0x38)
#define REG_SC_BK97_39_L      _PK_L_(0x97, 0x39)
#define REG_SC_BK97_39_H      _PK_H_(0x97, 0x39)
#define REG_SC_BK97_3A_L      _PK_L_(0x97, 0x3A)
#define REG_SC_BK97_3A_H      _PK_H_(0x97, 0x3A)
#define REG_SC_BK97_3B_L      _PK_L_(0x97, 0x3B)
#define REG_SC_BK97_3B_H      _PK_H_(0x97, 0x3B)
#define REG_SC_BK97_3C_L      _PK_L_(0x97, 0x3C)
#define REG_SC_BK97_3C_H      _PK_H_(0x97, 0x3C)
#define REG_SC_BK97_3D_L      _PK_L_(0x97, 0x3D)
#define REG_SC_BK97_3D_H      _PK_H_(0x97, 0x3D)
#define REG_SC_BK97_3E_L      _PK_L_(0x97, 0x3E)
#define REG_SC_BK97_3E_H      _PK_H_(0x97, 0x3E)
#define REG_SC_BK97_3F_L      _PK_L_(0x97, 0x3F)
#define REG_SC_BK97_3F_H      _PK_H_(0x97, 0x3F)
#define REG_SC_BK97_40_L      _PK_L_(0x97, 0x40)
#define REG_SC_BK97_40_H      _PK_H_(0x97, 0x40)
#define REG_SC_BK97_41_L      _PK_L_(0x97, 0x41)
#define REG_SC_BK97_41_H      _PK_H_(0x97, 0x41)
#define REG_SC_BK97_42_L      _PK_L_(0x97, 0x42)
#define REG_SC_BK97_42_H      _PK_H_(0x97, 0x42)
#define REG_SC_BK97_43_L      _PK_L_(0x97, 0x43)
#define REG_SC_BK97_43_H      _PK_H_(0x97, 0x43)
#define REG_SC_BK97_44_L      _PK_L_(0x97, 0x44)
#define REG_SC_BK97_44_H      _PK_H_(0x97, 0x44)
#define REG_SC_BK97_45_L      _PK_L_(0x97, 0x45)
#define REG_SC_BK97_45_H      _PK_H_(0x97, 0x45)
#define REG_SC_BK97_46_L      _PK_L_(0x97, 0x46)
#define REG_SC_BK97_46_H      _PK_H_(0x97, 0x46)
#define REG_SC_BK97_47_L      _PK_L_(0x97, 0x47)
#define REG_SC_BK97_47_H      _PK_H_(0x97, 0x47)
#define REG_SC_BK97_48_L      _PK_L_(0x97, 0x48)
#define REG_SC_BK97_48_H      _PK_H_(0x97, 0x48)
#define REG_SC_BK97_49_L      _PK_L_(0x97, 0x49)
#define REG_SC_BK97_49_H      _PK_H_(0x97, 0x49)
#define REG_SC_BK97_4A_L      _PK_L_(0x97, 0x4A)
#define REG_SC_BK97_4A_H      _PK_H_(0x97, 0x4A)
#define REG_SC_BK97_4B_L      _PK_L_(0x97, 0x4B)
#define REG_SC_BK97_4B_H      _PK_H_(0x97, 0x4B)
#define REG_SC_BK97_4C_L      _PK_L_(0x97, 0x4C)
#define REG_SC_BK97_4C_H      _PK_H_(0x97, 0x4C)
#define REG_SC_BK97_4D_L      _PK_L_(0x97, 0x4D)
#define REG_SC_BK97_4D_H      _PK_H_(0x97, 0x4D)
#define REG_SC_BK97_4E_L      _PK_L_(0x97, 0x4E)
#define REG_SC_BK97_4E_H      _PK_H_(0x97, 0x4E)
#define REG_SC_BK97_4F_L      _PK_L_(0x97, 0x4F)
#define REG_SC_BK97_4F_H      _PK_H_(0x97, 0x4F)
#define REG_SC_BK97_50_L      _PK_L_(0x97, 0x50)
#define REG_SC_BK97_50_H      _PK_H_(0x97, 0x50)
#define REG_SC_BK97_51_L      _PK_L_(0x97, 0x51)
#define REG_SC_BK97_51_H      _PK_H_(0x97, 0x51)
#define REG_SC_BK97_52_L      _PK_L_(0x97, 0x52)
#define REG_SC_BK97_52_H      _PK_H_(0x97, 0x52)
#define REG_SC_BK97_53_L      _PK_L_(0x97, 0x53)
#define REG_SC_BK97_53_H      _PK_H_(0x97, 0x53)
#define REG_SC_BK97_54_L      _PK_L_(0x97, 0x54)
#define REG_SC_BK97_54_H      _PK_H_(0x97, 0x54)
#define REG_SC_BK97_55_L      _PK_L_(0x97, 0x55)
#define REG_SC_BK97_55_H      _PK_H_(0x97, 0x55)
#define REG_SC_BK97_56_L      _PK_L_(0x97, 0x56)
#define REG_SC_BK97_56_H      _PK_H_(0x97, 0x56)
#define REG_SC_BK97_57_L      _PK_L_(0x97, 0x57)
#define REG_SC_BK97_57_H      _PK_H_(0x97, 0x57)
#define REG_SC_BK97_58_L      _PK_L_(0x97, 0x58)
#define REG_SC_BK97_58_H      _PK_H_(0x97, 0x58)
#define REG_SC_BK97_59_L      _PK_L_(0x97, 0x59)
#define REG_SC_BK97_59_H      _PK_H_(0x97, 0x59)
#define REG_SC_BK97_5A_L      _PK_L_(0x97, 0x5A)
#define REG_SC_BK97_5A_H      _PK_H_(0x97, 0x5A)
#define REG_SC_BK97_5B_L      _PK_L_(0x97, 0x5B)
#define REG_SC_BK97_5B_H      _PK_H_(0x97, 0x5B)
#define REG_SC_BK97_5C_L      _PK_L_(0x97, 0x5C)
#define REG_SC_BK97_5C_H      _PK_H_(0x97, 0x5C)
#define REG_SC_BK97_5D_L      _PK_L_(0x97, 0x5D)
#define REG_SC_BK97_5D_H      _PK_H_(0x97, 0x5D)
#define REG_SC_BK97_5E_L      _PK_L_(0x97, 0x5E)
#define REG_SC_BK97_5E_H      _PK_H_(0x97, 0x5E)
#define REG_SC_BK97_5F_L      _PK_L_(0x97, 0x5F)
#define REG_SC_BK97_5F_H      _PK_H_(0x97, 0x5F)
#define REG_SC_BK97_60_L      _PK_L_(0x97, 0x60)
#define REG_SC_BK97_60_H      _PK_H_(0x97, 0x60)
#define REG_SC_BK97_61_L      _PK_L_(0x97, 0x61)
#define REG_SC_BK97_61_H      _PK_H_(0x97, 0x61)
#define REG_SC_BK97_62_L      _PK_L_(0x97, 0x62)
#define REG_SC_BK97_62_H      _PK_H_(0x97, 0x62)
#define REG_SC_BK97_63_L      _PK_L_(0x97, 0x63)
#define REG_SC_BK97_63_H      _PK_H_(0x97, 0x63)
#define REG_SC_BK97_64_L      _PK_L_(0x97, 0x64)
#define REG_SC_BK97_64_H      _PK_H_(0x97, 0x64)
#define REG_SC_BK97_65_L      _PK_L_(0x97, 0x65)
#define REG_SC_BK97_65_H      _PK_H_(0x97, 0x65)
#define REG_SC_BK97_66_L      _PK_L_(0x97, 0x66)
#define REG_SC_BK97_66_H      _PK_H_(0x97, 0x66)
#define REG_SC_BK97_67_L      _PK_L_(0x97, 0x67)
#define REG_SC_BK97_67_H      _PK_H_(0x97, 0x67)
#define REG_SC_BK97_68_L      _PK_L_(0x97, 0x68)
#define REG_SC_BK97_68_H      _PK_H_(0x97, 0x68)
#define REG_SC_BK97_69_L      _PK_L_(0x97, 0x69)
#define REG_SC_BK97_69_H      _PK_H_(0x97, 0x69)
#define REG_SC_BK97_6A_L      _PK_L_(0x97, 0x6A)
#define REG_SC_BK97_6A_H      _PK_H_(0x97, 0x6A)
#define REG_SC_BK97_6B_L      _PK_L_(0x97, 0x6B)
#define REG_SC_BK97_6B_H      _PK_H_(0x97, 0x6B)
#define REG_SC_BK97_6C_L      _PK_L_(0x97, 0x6C)
#define REG_SC_BK97_6C_H      _PK_H_(0x97, 0x6C)
#define REG_SC_BK97_6D_L      _PK_L_(0x97, 0x6D)
#define REG_SC_BK97_6D_H      _PK_H_(0x97, 0x6D)
#define REG_SC_BK97_6E_L      _PK_L_(0x97, 0x6E)
#define REG_SC_BK97_6E_H      _PK_H_(0x97, 0x6E)
#define REG_SC_BK97_6F_L      _PK_L_(0x97, 0x6F)
#define REG_SC_BK97_6F_H      _PK_H_(0x97, 0x6F)
#define REG_SC_BK97_70_L      _PK_L_(0x97, 0x70)
#define REG_SC_BK97_70_H      _PK_H_(0x97, 0x70)
#define REG_SC_BK97_71_L      _PK_L_(0x97, 0x71)
#define REG_SC_BK97_71_H      _PK_H_(0x97, 0x71)
#define REG_SC_BK97_72_L      _PK_L_(0x97, 0x72)
#define REG_SC_BK97_72_H      _PK_H_(0x97, 0x72)
#define REG_SC_BK97_73_L      _PK_L_(0x97, 0x73)
#define REG_SC_BK97_73_H      _PK_H_(0x97, 0x73)
#define REG_SC_BK97_74_L      _PK_L_(0x97, 0x74)
#define REG_SC_BK97_74_H      _PK_H_(0x97, 0x74)
#define REG_SC_BK97_75_L      _PK_L_(0x97, 0x75)
#define REG_SC_BK97_75_H      _PK_H_(0x97, 0x75)
#define REG_SC_BK97_76_L      _PK_L_(0x97, 0x76)
#define REG_SC_BK97_76_H      _PK_H_(0x97, 0x76)
#define REG_SC_BK97_77_L      _PK_L_(0x97, 0x77)
#define REG_SC_BK97_77_H      _PK_H_(0x97, 0x77)
#define REG_SC_BK97_78_L      _PK_L_(0x97, 0x78)
#define REG_SC_BK97_78_H      _PK_H_(0x97, 0x78)
#define REG_SC_BK97_79_L      _PK_L_(0x97, 0x79)
#define REG_SC_BK97_79_H      _PK_H_(0x97, 0x79)
#define REG_SC_BK97_7A_L      _PK_L_(0x97, 0x7A)
#define REG_SC_BK97_7A_H      _PK_H_(0x97, 0x7A)
#define REG_SC_BK97_7B_L      _PK_L_(0x97, 0x7B)
#define REG_SC_BK97_7B_H      _PK_H_(0x97, 0x7B)
#define REG_SC_BK97_7C_L      _PK_L_(0x97, 0x7C)
#define REG_SC_BK97_7C_H      _PK_H_(0x97, 0x7C)
#define REG_SC_BK97_7D_L      _PK_L_(0x97, 0x7D)
#define REG_SC_BK97_7D_H      _PK_H_(0x97, 0x7D)
#define REG_SC_BK97_7E_L      _PK_L_(0x97, 0x7E)
#define REG_SC_BK97_7E_H      _PK_H_(0x97, 0x7E)
#define REG_SC_BK97_7F_L      _PK_L_(0x97, 0x7F)
#define REG_SC_BK97_7F_H      _PK_H_(0x97, 0x7F)
//----------------------------------------------
#define REG_SC_BK98_00_L      _PK_L_(0x98, 0x00)
#define REG_SC_BK98_00_H      _PK_H_(0x98, 0x00)
#define REG_SC_BK98_01_L      _PK_L_(0x98, 0x01)
#define REG_SC_BK98_01_H      _PK_H_(0x98, 0x01)
#define REG_SC_BK98_02_L      _PK_L_(0x98, 0x02)
#define REG_SC_BK98_02_H      _PK_H_(0x98, 0x02)
#define REG_SC_BK98_03_L      _PK_L_(0x98, 0x03)
#define REG_SC_BK98_03_H      _PK_H_(0x98, 0x03)
#define REG_SC_BK98_04_L      _PK_L_(0x98, 0x04)
#define REG_SC_BK98_04_H      _PK_H_(0x98, 0x04)
#define REG_SC_BK98_05_L      _PK_L_(0x98, 0x05)
#define REG_SC_BK98_05_H      _PK_H_(0x98, 0x05)
#define REG_SC_BK98_06_L      _PK_L_(0x98, 0x06)
#define REG_SC_BK98_06_H      _PK_H_(0x98, 0x06)
#define REG_SC_BK98_07_L      _PK_L_(0x98, 0x07)
#define REG_SC_BK98_07_H      _PK_H_(0x98, 0x07)
#define REG_SC_BK98_08_L      _PK_L_(0x98, 0x08)
#define REG_SC_BK98_08_H      _PK_H_(0x98, 0x08)
#define REG_SC_BK98_09_L      _PK_L_(0x98, 0x09)
#define REG_SC_BK98_09_H      _PK_H_(0x98, 0x09)
#define REG_SC_BK98_0A_L      _PK_L_(0x98, 0x0A)
#define REG_SC_BK98_0A_H      _PK_H_(0x98, 0x0A)
#define REG_SC_BK98_0B_L      _PK_L_(0x98, 0x0B)
#define REG_SC_BK98_0B_H      _PK_H_(0x98, 0x0B)
#define REG_SC_BK98_0C_L      _PK_L_(0x98, 0x0C)
#define REG_SC_BK98_0C_H      _PK_H_(0x98, 0x0C)
#define REG_SC_BK98_0D_L      _PK_L_(0x98, 0x0D)
#define REG_SC_BK98_0D_H      _PK_H_(0x98, 0x0D)
#define REG_SC_BK98_0E_L      _PK_L_(0x98, 0x0E)
#define REG_SC_BK98_0E_H      _PK_H_(0x98, 0x0E)
#define REG_SC_BK98_0F_L      _PK_L_(0x98, 0x0F)
#define REG_SC_BK98_0F_H      _PK_H_(0x98, 0x0F)
#define REG_SC_BK98_10_L      _PK_L_(0x98, 0x10)
#define REG_SC_BK98_10_H      _PK_H_(0x98, 0x10)
#define REG_SC_BK98_11_L      _PK_L_(0x98, 0x11)
#define REG_SC_BK98_11_H      _PK_H_(0x98, 0x11)
#define REG_SC_BK98_12_L      _PK_L_(0x98, 0x12)
#define REG_SC_BK98_12_H      _PK_H_(0x98, 0x12)
#define REG_SC_BK98_13_L      _PK_L_(0x98, 0x13)
#define REG_SC_BK98_13_H      _PK_H_(0x98, 0x13)
#define REG_SC_BK98_14_L      _PK_L_(0x98, 0x14)
#define REG_SC_BK98_14_H      _PK_H_(0x98, 0x14)
#define REG_SC_BK98_15_L      _PK_L_(0x98, 0x15)
#define REG_SC_BK98_15_H      _PK_H_(0x98, 0x15)
#define REG_SC_BK98_16_L      _PK_L_(0x98, 0x16)
#define REG_SC_BK98_16_H      _PK_H_(0x98, 0x16)
#define REG_SC_BK98_17_L      _PK_L_(0x98, 0x17)
#define REG_SC_BK98_17_H      _PK_H_(0x98, 0x17)
#define REG_SC_BK98_18_L      _PK_L_(0x98, 0x18)
#define REG_SC_BK98_18_H      _PK_H_(0x98, 0x18)
#define REG_SC_BK98_19_L      _PK_L_(0x98, 0x19)
#define REG_SC_BK98_19_H      _PK_H_(0x98, 0x19)
#define REG_SC_BK98_1A_L      _PK_L_(0x98, 0x1A)
#define REG_SC_BK98_1A_H      _PK_H_(0x98, 0x1A)
#define REG_SC_BK98_1B_L      _PK_L_(0x98, 0x1B)
#define REG_SC_BK98_1B_H      _PK_H_(0x98, 0x1B)
#define REG_SC_BK98_1C_L      _PK_L_(0x98, 0x1C)
#define REG_SC_BK98_1C_H      _PK_H_(0x98, 0x1C)
#define REG_SC_BK98_1D_L      _PK_L_(0x98, 0x1D)
#define REG_SC_BK98_1D_H      _PK_H_(0x98, 0x1D)
#define REG_SC_BK98_1E_L      _PK_L_(0x98, 0x1E)
#define REG_SC_BK98_1E_H      _PK_H_(0x98, 0x1E)
#define REG_SC_BK98_1F_L      _PK_L_(0x98, 0x1F)
#define REG_SC_BK98_1F_H      _PK_H_(0x98, 0x1F)
#define REG_SC_BK98_20_L      _PK_L_(0x98, 0x20)
#define REG_SC_BK98_20_H      _PK_H_(0x98, 0x20)
#define REG_SC_BK98_21_L      _PK_L_(0x98, 0x21)
#define REG_SC_BK98_21_H      _PK_H_(0x98, 0x21)
#define REG_SC_BK98_22_L      _PK_L_(0x98, 0x22)
#define REG_SC_BK98_22_H      _PK_H_(0x98, 0x22)
#define REG_SC_BK98_23_L      _PK_L_(0x98, 0x23)
#define REG_SC_BK98_23_H      _PK_H_(0x98, 0x23)
#define REG_SC_BK98_24_L      _PK_L_(0x98, 0x24)
#define REG_SC_BK98_24_H      _PK_H_(0x98, 0x24)
#define REG_SC_BK98_25_L      _PK_L_(0x98, 0x25)
#define REG_SC_BK98_25_H      _PK_H_(0x98, 0x25)
#define REG_SC_BK98_26_L      _PK_L_(0x98, 0x26)
#define REG_SC_BK98_26_H      _PK_H_(0x98, 0x26)
#define REG_SC_BK98_27_L      _PK_L_(0x98, 0x27)
#define REG_SC_BK98_27_H      _PK_H_(0x98, 0x27)
#define REG_SC_BK98_28_L      _PK_L_(0x98, 0x28)
#define REG_SC_BK98_28_H      _PK_H_(0x98, 0x28)
#define REG_SC_BK98_29_L      _PK_L_(0x98, 0x29)
#define REG_SC_BK98_29_H      _PK_H_(0x98, 0x29)
#define REG_SC_BK98_2A_L      _PK_L_(0x98, 0x2A)
#define REG_SC_BK98_2A_H      _PK_H_(0x98, 0x2A)
#define REG_SC_BK98_2B_L      _PK_L_(0x98, 0x2B)
#define REG_SC_BK98_2B_H      _PK_H_(0x98, 0x2B)
#define REG_SC_BK98_2C_L      _PK_L_(0x98, 0x2C)
#define REG_SC_BK98_2C_H      _PK_H_(0x98, 0x2C)
#define REG_SC_BK98_2D_L      _PK_L_(0x98, 0x2D)
#define REG_SC_BK98_2D_H      _PK_H_(0x98, 0x2D)
#define REG_SC_BK98_2E_L      _PK_L_(0x98, 0x2E)
#define REG_SC_BK98_2E_H      _PK_H_(0x98, 0x2E)
#define REG_SC_BK98_2F_L      _PK_L_(0x98, 0x2F)
#define REG_SC_BK98_2F_H      _PK_H_(0x98, 0x2F)
#define REG_SC_BK98_30_L      _PK_L_(0x98, 0x30)
#define REG_SC_BK98_30_H      _PK_H_(0x98, 0x30)
#define REG_SC_BK98_31_L      _PK_L_(0x98, 0x31)
#define REG_SC_BK98_31_H      _PK_H_(0x98, 0x31)
#define REG_SC_BK98_32_L      _PK_L_(0x98, 0x32)
#define REG_SC_BK98_32_H      _PK_H_(0x98, 0x32)
#define REG_SC_BK98_33_L      _PK_L_(0x98, 0x33)
#define REG_SC_BK98_33_H      _PK_H_(0x98, 0x33)
#define REG_SC_BK98_34_L      _PK_L_(0x98, 0x34)
#define REG_SC_BK98_34_H      _PK_H_(0x98, 0x34)
#define REG_SC_BK98_35_L      _PK_L_(0x98, 0x35)
#define REG_SC_BK98_35_H      _PK_H_(0x98, 0x35)
#define REG_SC_BK98_36_L      _PK_L_(0x98, 0x36)
#define REG_SC_BK98_36_H      _PK_H_(0x98, 0x36)
#define REG_SC_BK98_37_L      _PK_L_(0x98, 0x37)
#define REG_SC_BK98_37_H      _PK_H_(0x98, 0x37)
#define REG_SC_BK98_38_L      _PK_L_(0x98, 0x38)
#define REG_SC_BK98_38_H      _PK_H_(0x98, 0x38)
#define REG_SC_BK98_39_L      _PK_L_(0x98, 0x39)
#define REG_SC_BK98_39_H      _PK_H_(0x98, 0x39)
#define REG_SC_BK98_3A_L      _PK_L_(0x98, 0x3A)
#define REG_SC_BK98_3A_H      _PK_H_(0x98, 0x3A)
#define REG_SC_BK98_3B_L      _PK_L_(0x98, 0x3B)
#define REG_SC_BK98_3B_H      _PK_H_(0x98, 0x3B)
#define REG_SC_BK98_3C_L      _PK_L_(0x98, 0x3C)
#define REG_SC_BK98_3C_H      _PK_H_(0x98, 0x3C)
#define REG_SC_BK98_3D_L      _PK_L_(0x98, 0x3D)
#define REG_SC_BK98_3D_H      _PK_H_(0x98, 0x3D)
#define REG_SC_BK98_3E_L      _PK_L_(0x98, 0x3E)
#define REG_SC_BK98_3E_H      _PK_H_(0x98, 0x3E)
#define REG_SC_BK98_3F_L      _PK_L_(0x98, 0x3F)
#define REG_SC_BK98_3F_H      _PK_H_(0x98, 0x3F)
#define REG_SC_BK98_40_L      _PK_L_(0x98, 0x40)
#define REG_SC_BK98_40_H      _PK_H_(0x98, 0x40)
#define REG_SC_BK98_41_L      _PK_L_(0x98, 0x41)
#define REG_SC_BK98_41_H      _PK_H_(0x98, 0x41)
#define REG_SC_BK98_42_L      _PK_L_(0x98, 0x42)
#define REG_SC_BK98_42_H      _PK_H_(0x98, 0x42)
#define REG_SC_BK98_43_L      _PK_L_(0x98, 0x43)
#define REG_SC_BK98_43_H      _PK_H_(0x98, 0x43)
#define REG_SC_BK98_44_L      _PK_L_(0x98, 0x44)
#define REG_SC_BK98_44_H      _PK_H_(0x98, 0x44)
#define REG_SC_BK98_45_L      _PK_L_(0x98, 0x45)
#define REG_SC_BK98_45_H      _PK_H_(0x98, 0x45)
#define REG_SC_BK98_46_L      _PK_L_(0x98, 0x46)
#define REG_SC_BK98_46_H      _PK_H_(0x98, 0x46)
#define REG_SC_BK98_47_L      _PK_L_(0x98, 0x47)
#define REG_SC_BK98_47_H      _PK_H_(0x98, 0x47)
#define REG_SC_BK98_48_L      _PK_L_(0x98, 0x48)
#define REG_SC_BK98_48_H      _PK_H_(0x98, 0x48)
#define REG_SC_BK98_49_L      _PK_L_(0x98, 0x49)
#define REG_SC_BK98_49_H      _PK_H_(0x98, 0x49)
#define REG_SC_BK98_4A_L      _PK_L_(0x98, 0x4A)
#define REG_SC_BK98_4A_H      _PK_H_(0x98, 0x4A)
#define REG_SC_BK98_4B_L      _PK_L_(0x98, 0x4B)
#define REG_SC_BK98_4B_H      _PK_H_(0x98, 0x4B)
#define REG_SC_BK98_4C_L      _PK_L_(0x98, 0x4C)
#define REG_SC_BK98_4C_H      _PK_H_(0x98, 0x4C)
#define REG_SC_BK98_4D_L      _PK_L_(0x98, 0x4D)
#define REG_SC_BK98_4D_H      _PK_H_(0x98, 0x4D)
#define REG_SC_BK98_4E_L      _PK_L_(0x98, 0x4E)
#define REG_SC_BK98_4E_H      _PK_H_(0x98, 0x4E)
#define REG_SC_BK98_4F_L      _PK_L_(0x98, 0x4F)
#define REG_SC_BK98_4F_H      _PK_H_(0x98, 0x4F)
#define REG_SC_BK98_50_L      _PK_L_(0x98, 0x50)
#define REG_SC_BK98_50_H      _PK_H_(0x98, 0x50)
#define REG_SC_BK98_51_L      _PK_L_(0x98, 0x51)
#define REG_SC_BK98_51_H      _PK_H_(0x98, 0x51)
#define REG_SC_BK98_52_L      _PK_L_(0x98, 0x52)
#define REG_SC_BK98_52_H      _PK_H_(0x98, 0x52)
#define REG_SC_BK98_53_L      _PK_L_(0x98, 0x53)
#define REG_SC_BK98_53_H      _PK_H_(0x98, 0x53)
#define REG_SC_BK98_54_L      _PK_L_(0x98, 0x54)
#define REG_SC_BK98_54_H      _PK_H_(0x98, 0x54)
#define REG_SC_BK98_55_L      _PK_L_(0x98, 0x55)
#define REG_SC_BK98_55_H      _PK_H_(0x98, 0x55)
#define REG_SC_BK98_56_L      _PK_L_(0x98, 0x56)
#define REG_SC_BK98_56_H      _PK_H_(0x98, 0x56)
#define REG_SC_BK98_57_L      _PK_L_(0x98, 0x57)
#define REG_SC_BK98_57_H      _PK_H_(0x98, 0x57)
#define REG_SC_BK98_58_L      _PK_L_(0x98, 0x58)
#define REG_SC_BK98_58_H      _PK_H_(0x98, 0x58)
#define REG_SC_BK98_59_L      _PK_L_(0x98, 0x59)
#define REG_SC_BK98_59_H      _PK_H_(0x98, 0x59)
#define REG_SC_BK98_5A_L      _PK_L_(0x98, 0x5A)
#define REG_SC_BK98_5A_H      _PK_H_(0x98, 0x5A)
#define REG_SC_BK98_5B_L      _PK_L_(0x98, 0x5B)
#define REG_SC_BK98_5B_H      _PK_H_(0x98, 0x5B)
#define REG_SC_BK98_5C_L      _PK_L_(0x98, 0x5C)
#define REG_SC_BK98_5C_H      _PK_H_(0x98, 0x5C)
#define REG_SC_BK98_5D_L      _PK_L_(0x98, 0x5D)
#define REG_SC_BK98_5D_H      _PK_H_(0x98, 0x5D)
#define REG_SC_BK98_5E_L      _PK_L_(0x98, 0x5E)
#define REG_SC_BK98_5E_H      _PK_H_(0x98, 0x5E)
#define REG_SC_BK98_5F_L      _PK_L_(0x98, 0x5F)
#define REG_SC_BK98_5F_H      _PK_H_(0x98, 0x5F)
#define REG_SC_BK98_60_L      _PK_L_(0x98, 0x60)
#define REG_SC_BK98_60_H      _PK_H_(0x98, 0x60)
#define REG_SC_BK98_61_L      _PK_L_(0x98, 0x61)
#define REG_SC_BK98_61_H      _PK_H_(0x98, 0x61)
#define REG_SC_BK98_62_L      _PK_L_(0x98, 0x62)
#define REG_SC_BK98_62_H      _PK_H_(0x98, 0x62)
#define REG_SC_BK98_63_L      _PK_L_(0x98, 0x63)
#define REG_SC_BK98_63_H      _PK_H_(0x98, 0x63)
#define REG_SC_BK98_64_L      _PK_L_(0x98, 0x64)
#define REG_SC_BK98_64_H      _PK_H_(0x98, 0x64)
#define REG_SC_BK98_65_L      _PK_L_(0x98, 0x65)
#define REG_SC_BK98_65_H      _PK_H_(0x98, 0x65)
#define REG_SC_BK98_66_L      _PK_L_(0x98, 0x66)
#define REG_SC_BK98_66_H      _PK_H_(0x98, 0x66)
#define REG_SC_BK98_67_L      _PK_L_(0x98, 0x67)
#define REG_SC_BK98_67_H      _PK_H_(0x98, 0x67)
#define REG_SC_BK98_68_L      _PK_L_(0x98, 0x68)
#define REG_SC_BK98_68_H      _PK_H_(0x98, 0x68)
#define REG_SC_BK98_69_L      _PK_L_(0x98, 0x69)
#define REG_SC_BK98_69_H      _PK_H_(0x98, 0x69)
#define REG_SC_BK98_6A_L      _PK_L_(0x98, 0x6A)
#define REG_SC_BK98_6A_H      _PK_H_(0x98, 0x6A)
#define REG_SC_BK98_6B_L      _PK_L_(0x98, 0x6B)
#define REG_SC_BK98_6B_H      _PK_H_(0x98, 0x6B)
#define REG_SC_BK98_6C_L      _PK_L_(0x98, 0x6C)
#define REG_SC_BK98_6C_H      _PK_H_(0x98, 0x6C)
#define REG_SC_BK98_6D_L      _PK_L_(0x98, 0x6D)
#define REG_SC_BK98_6D_H      _PK_H_(0x98, 0x6D)
#define REG_SC_BK98_6E_L      _PK_L_(0x98, 0x6E)
#define REG_SC_BK98_6E_H      _PK_H_(0x98, 0x6E)
#define REG_SC_BK98_6F_L      _PK_L_(0x98, 0x6F)
#define REG_SC_BK98_6F_H      _PK_H_(0x98, 0x6F)
#define REG_SC_BK98_70_L      _PK_L_(0x98, 0x70)
#define REG_SC_BK98_70_H      _PK_H_(0x98, 0x70)
#define REG_SC_BK98_71_L      _PK_L_(0x98, 0x71)
#define REG_SC_BK98_71_H      _PK_H_(0x98, 0x71)
#define REG_SC_BK98_72_L      _PK_L_(0x98, 0x72)
#define REG_SC_BK98_72_H      _PK_H_(0x98, 0x72)
#define REG_SC_BK98_73_L      _PK_L_(0x98, 0x73)
#define REG_SC_BK98_73_H      _PK_H_(0x98, 0x73)
#define REG_SC_BK98_74_L      _PK_L_(0x98, 0x74)
#define REG_SC_BK98_74_H      _PK_H_(0x98, 0x74)
#define REG_SC_BK98_75_L      _PK_L_(0x98, 0x75)
#define REG_SC_BK98_75_H      _PK_H_(0x98, 0x75)
#define REG_SC_BK98_76_L      _PK_L_(0x98, 0x76)
#define REG_SC_BK98_76_H      _PK_H_(0x98, 0x76)
#define REG_SC_BK98_77_L      _PK_L_(0x98, 0x77)
#define REG_SC_BK98_77_H      _PK_H_(0x98, 0x77)
#define REG_SC_BK98_78_L      _PK_L_(0x98, 0x78)
#define REG_SC_BK98_78_H      _PK_H_(0x98, 0x78)
#define REG_SC_BK98_79_L      _PK_L_(0x98, 0x79)
#define REG_SC_BK98_79_H      _PK_H_(0x98, 0x79)
#define REG_SC_BK98_7A_L      _PK_L_(0x98, 0x7A)
#define REG_SC_BK98_7A_H      _PK_H_(0x98, 0x7A)
#define REG_SC_BK98_7B_L      _PK_L_(0x98, 0x7B)
#define REG_SC_BK98_7B_H      _PK_H_(0x98, 0x7B)
#define REG_SC_BK98_7C_L      _PK_L_(0x98, 0x7C)
#define REG_SC_BK98_7C_H      _PK_H_(0x98, 0x7C)
#define REG_SC_BK98_7D_L      _PK_L_(0x98, 0x7D)
#define REG_SC_BK98_7D_H      _PK_H_(0x98, 0x7D)
#define REG_SC_BK98_7E_L      _PK_L_(0x98, 0x7E)
#define REG_SC_BK98_7E_H      _PK_H_(0x98, 0x7E)
#define REG_SC_BK98_7F_L      _PK_L_(0x98, 0x7F)
#define REG_SC_BK98_7F_H      _PK_H_(0x98, 0x7F)
//----------------------------------------------
#define REG_SC_BK99_00_L      _PK_L_(0x99, 0x00)
#define REG_SC_BK99_00_H      _PK_H_(0x99, 0x00)
#define REG_SC_BK99_01_L      _PK_L_(0x99, 0x01)
#define REG_SC_BK99_01_H      _PK_H_(0x99, 0x01)
#define REG_SC_BK99_02_L      _PK_L_(0x99, 0x02)
#define REG_SC_BK99_02_H      _PK_H_(0x99, 0x02)
#define REG_SC_BK99_03_L      _PK_L_(0x99, 0x03)
#define REG_SC_BK99_03_H      _PK_H_(0x99, 0x03)
#define REG_SC_BK99_04_L      _PK_L_(0x99, 0x04)
#define REG_SC_BK99_04_H      _PK_H_(0x99, 0x04)
#define REG_SC_BK99_05_L      _PK_L_(0x99, 0x05)
#define REG_SC_BK99_05_H      _PK_H_(0x99, 0x05)
#define REG_SC_BK99_06_L      _PK_L_(0x99, 0x06)
#define REG_SC_BK99_06_H      _PK_H_(0x99, 0x06)
#define REG_SC_BK99_07_L      _PK_L_(0x99, 0x07)
#define REG_SC_BK99_07_H      _PK_H_(0x99, 0x07)
#define REG_SC_BK99_08_L      _PK_L_(0x99, 0x08)
#define REG_SC_BK99_08_H      _PK_H_(0x99, 0x08)
#define REG_SC_BK99_09_L      _PK_L_(0x99, 0x09)
#define REG_SC_BK99_09_H      _PK_H_(0x99, 0x09)
#define REG_SC_BK99_0A_L      _PK_L_(0x99, 0x0A)
#define REG_SC_BK99_0A_H      _PK_H_(0x99, 0x0A)
#define REG_SC_BK99_0B_L      _PK_L_(0x99, 0x0B)
#define REG_SC_BK99_0B_H      _PK_H_(0x99, 0x0B)
#define REG_SC_BK99_0C_L      _PK_L_(0x99, 0x0C)
#define REG_SC_BK99_0C_H      _PK_H_(0x99, 0x0C)
#define REG_SC_BK99_0D_L      _PK_L_(0x99, 0x0D)
#define REG_SC_BK99_0D_H      _PK_H_(0x99, 0x0D)
#define REG_SC_BK99_0E_L      _PK_L_(0x99, 0x0E)
#define REG_SC_BK99_0E_H      _PK_H_(0x99, 0x0E)
#define REG_SC_BK99_0F_L      _PK_L_(0x99, 0x0F)
#define REG_SC_BK99_0F_H      _PK_H_(0x99, 0x0F)
#define REG_SC_BK99_10_L      _PK_L_(0x99, 0x10)
#define REG_SC_BK99_10_H      _PK_H_(0x99, 0x10)
#define REG_SC_BK99_11_L      _PK_L_(0x99, 0x11)
#define REG_SC_BK99_11_H      _PK_H_(0x99, 0x11)
#define REG_SC_BK99_12_L      _PK_L_(0x99, 0x12)
#define REG_SC_BK99_12_H      _PK_H_(0x99, 0x12)
#define REG_SC_BK99_13_L      _PK_L_(0x99, 0x13)
#define REG_SC_BK99_13_H      _PK_H_(0x99, 0x13)
#define REG_SC_BK99_14_L      _PK_L_(0x99, 0x14)
#define REG_SC_BK99_14_H      _PK_H_(0x99, 0x14)
#define REG_SC_BK99_15_L      _PK_L_(0x99, 0x15)
#define REG_SC_BK99_15_H      _PK_H_(0x99, 0x15)
#define REG_SC_BK99_16_L      _PK_L_(0x99, 0x16)
#define REG_SC_BK99_16_H      _PK_H_(0x99, 0x16)
#define REG_SC_BK99_17_L      _PK_L_(0x99, 0x17)
#define REG_SC_BK99_17_H      _PK_H_(0x99, 0x17)
#define REG_SC_BK99_18_L      _PK_L_(0x99, 0x18)
#define REG_SC_BK99_18_H      _PK_H_(0x99, 0x18)
#define REG_SC_BK99_19_L      _PK_L_(0x99, 0x19)
#define REG_SC_BK99_19_H      _PK_H_(0x99, 0x19)
#define REG_SC_BK99_1A_L      _PK_L_(0x99, 0x1A)
#define REG_SC_BK99_1A_H      _PK_H_(0x99, 0x1A)
#define REG_SC_BK99_1B_L      _PK_L_(0x99, 0x1B)
#define REG_SC_BK99_1B_H      _PK_H_(0x99, 0x1B)
#define REG_SC_BK99_1C_L      _PK_L_(0x99, 0x1C)
#define REG_SC_BK99_1C_H      _PK_H_(0x99, 0x1C)
#define REG_SC_BK99_1D_L      _PK_L_(0x99, 0x1D)
#define REG_SC_BK99_1D_H      _PK_H_(0x99, 0x1D)
#define REG_SC_BK99_1E_L      _PK_L_(0x99, 0x1E)
#define REG_SC_BK99_1E_H      _PK_H_(0x99, 0x1E)
#define REG_SC_BK99_1F_L      _PK_L_(0x99, 0x1F)
#define REG_SC_BK99_1F_H      _PK_H_(0x99, 0x1F)
#define REG_SC_BK99_20_L      _PK_L_(0x99, 0x20)
#define REG_SC_BK99_20_H      _PK_H_(0x99, 0x20)
#define REG_SC_BK99_21_L      _PK_L_(0x99, 0x21)
#define REG_SC_BK99_21_H      _PK_H_(0x99, 0x21)
#define REG_SC_BK99_22_L      _PK_L_(0x99, 0x22)
#define REG_SC_BK99_22_H      _PK_H_(0x99, 0x22)
#define REG_SC_BK99_23_L      _PK_L_(0x99, 0x23)
#define REG_SC_BK99_23_H      _PK_H_(0x99, 0x23)
#define REG_SC_BK99_24_L      _PK_L_(0x99, 0x24)
#define REG_SC_BK99_24_H      _PK_H_(0x99, 0x24)
#define REG_SC_BK99_25_L      _PK_L_(0x99, 0x25)
#define REG_SC_BK99_25_H      _PK_H_(0x99, 0x25)
#define REG_SC_BK99_26_L      _PK_L_(0x99, 0x26)
#define REG_SC_BK99_26_H      _PK_H_(0x99, 0x26)
#define REG_SC_BK99_27_L      _PK_L_(0x99, 0x27)
#define REG_SC_BK99_27_H      _PK_H_(0x99, 0x27)
#define REG_SC_BK99_28_L      _PK_L_(0x99, 0x28)
#define REG_SC_BK99_28_H      _PK_H_(0x99, 0x28)
#define REG_SC_BK99_29_L      _PK_L_(0x99, 0x29)
#define REG_SC_BK99_29_H      _PK_H_(0x99, 0x29)
#define REG_SC_BK99_2A_L      _PK_L_(0x99, 0x2A)
#define REG_SC_BK99_2A_H      _PK_H_(0x99, 0x2A)
#define REG_SC_BK99_2B_L      _PK_L_(0x99, 0x2B)
#define REG_SC_BK99_2B_H      _PK_H_(0x99, 0x2B)
#define REG_SC_BK99_2C_L      _PK_L_(0x99, 0x2C)
#define REG_SC_BK99_2C_H      _PK_H_(0x99, 0x2C)
#define REG_SC_BK99_2D_L      _PK_L_(0x99, 0x2D)
#define REG_SC_BK99_2D_H      _PK_H_(0x99, 0x2D)
#define REG_SC_BK99_2E_L      _PK_L_(0x99, 0x2E)
#define REG_SC_BK99_2E_H      _PK_H_(0x99, 0x2E)
#define REG_SC_BK99_2F_L      _PK_L_(0x99, 0x2F)
#define REG_SC_BK99_2F_H      _PK_H_(0x99, 0x2F)
#define REG_SC_BK99_30_L      _PK_L_(0x99, 0x30)
#define REG_SC_BK99_30_H      _PK_H_(0x99, 0x30)
#define REG_SC_BK99_31_L      _PK_L_(0x99, 0x31)
#define REG_SC_BK99_31_H      _PK_H_(0x99, 0x31)
#define REG_SC_BK99_32_L      _PK_L_(0x99, 0x32)
#define REG_SC_BK99_32_H      _PK_H_(0x99, 0x32)
#define REG_SC_BK99_33_L      _PK_L_(0x99, 0x33)
#define REG_SC_BK99_33_H      _PK_H_(0x99, 0x33)
#define REG_SC_BK99_34_L      _PK_L_(0x99, 0x34)
#define REG_SC_BK99_34_H      _PK_H_(0x99, 0x34)
#define REG_SC_BK99_35_L      _PK_L_(0x99, 0x35)
#define REG_SC_BK99_35_H      _PK_H_(0x99, 0x35)
#define REG_SC_BK99_36_L      _PK_L_(0x99, 0x36)
#define REG_SC_BK99_36_H      _PK_H_(0x99, 0x36)
#define REG_SC_BK99_37_L      _PK_L_(0x99, 0x37)
#define REG_SC_BK99_37_H      _PK_H_(0x99, 0x37)
#define REG_SC_BK99_38_L      _PK_L_(0x99, 0x38)
#define REG_SC_BK99_38_H      _PK_H_(0x99, 0x38)
#define REG_SC_BK99_39_L      _PK_L_(0x99, 0x39)
#define REG_SC_BK99_39_H      _PK_H_(0x99, 0x39)
#define REG_SC_BK99_3A_L      _PK_L_(0x99, 0x3A)
#define REG_SC_BK99_3A_H      _PK_H_(0x99, 0x3A)
#define REG_SC_BK99_3B_L      _PK_L_(0x99, 0x3B)
#define REG_SC_BK99_3B_H      _PK_H_(0x99, 0x3B)
#define REG_SC_BK99_3C_L      _PK_L_(0x99, 0x3C)
#define REG_SC_BK99_3C_H      _PK_H_(0x99, 0x3C)
#define REG_SC_BK99_3D_L      _PK_L_(0x99, 0x3D)
#define REG_SC_BK99_3D_H      _PK_H_(0x99, 0x3D)
#define REG_SC_BK99_3E_L      _PK_L_(0x99, 0x3E)
#define REG_SC_BK99_3E_H      _PK_H_(0x99, 0x3E)
#define REG_SC_BK99_3F_L      _PK_L_(0x99, 0x3F)
#define REG_SC_BK99_3F_H      _PK_H_(0x99, 0x3F)
#define REG_SC_BK99_40_L      _PK_L_(0x99, 0x40)
#define REG_SC_BK99_40_H      _PK_H_(0x99, 0x40)
#define REG_SC_BK99_41_L      _PK_L_(0x99, 0x41)
#define REG_SC_BK99_41_H      _PK_H_(0x99, 0x41)
#define REG_SC_BK99_42_L      _PK_L_(0x99, 0x42)
#define REG_SC_BK99_42_H      _PK_H_(0x99, 0x42)
#define REG_SC_BK99_43_L      _PK_L_(0x99, 0x43)
#define REG_SC_BK99_43_H      _PK_H_(0x99, 0x43)
#define REG_SC_BK99_44_L      _PK_L_(0x99, 0x44)
#define REG_SC_BK99_44_H      _PK_H_(0x99, 0x44)
#define REG_SC_BK99_45_L      _PK_L_(0x99, 0x45)
#define REG_SC_BK99_45_H      _PK_H_(0x99, 0x45)
#define REG_SC_BK99_46_L      _PK_L_(0x99, 0x46)
#define REG_SC_BK99_46_H      _PK_H_(0x99, 0x46)
#define REG_SC_BK99_47_L      _PK_L_(0x99, 0x47)
#define REG_SC_BK99_47_H      _PK_H_(0x99, 0x47)
#define REG_SC_BK99_48_L      _PK_L_(0x99, 0x48)
#define REG_SC_BK99_48_H      _PK_H_(0x99, 0x48)
#define REG_SC_BK99_49_L      _PK_L_(0x99, 0x49)
#define REG_SC_BK99_49_H      _PK_H_(0x99, 0x49)
#define REG_SC_BK99_4A_L      _PK_L_(0x99, 0x4A)
#define REG_SC_BK99_4A_H      _PK_H_(0x99, 0x4A)
#define REG_SC_BK99_4B_L      _PK_L_(0x99, 0x4B)
#define REG_SC_BK99_4B_H      _PK_H_(0x99, 0x4B)
#define REG_SC_BK99_4C_L      _PK_L_(0x99, 0x4C)
#define REG_SC_BK99_4C_H      _PK_H_(0x99, 0x4C)
#define REG_SC_BK99_4D_L      _PK_L_(0x99, 0x4D)
#define REG_SC_BK99_4D_H      _PK_H_(0x99, 0x4D)
#define REG_SC_BK99_4E_L      _PK_L_(0x99, 0x4E)
#define REG_SC_BK99_4E_H      _PK_H_(0x99, 0x4E)
#define REG_SC_BK99_4F_L      _PK_L_(0x99, 0x4F)
#define REG_SC_BK99_4F_H      _PK_H_(0x99, 0x4F)
#define REG_SC_BK99_50_L      _PK_L_(0x99, 0x50)
#define REG_SC_BK99_50_H      _PK_H_(0x99, 0x50)
#define REG_SC_BK99_51_L      _PK_L_(0x99, 0x51)
#define REG_SC_BK99_51_H      _PK_H_(0x99, 0x51)
#define REG_SC_BK99_52_L      _PK_L_(0x99, 0x52)
#define REG_SC_BK99_52_H      _PK_H_(0x99, 0x52)
#define REG_SC_BK99_53_L      _PK_L_(0x99, 0x53)
#define REG_SC_BK99_53_H      _PK_H_(0x99, 0x53)
#define REG_SC_BK99_54_L      _PK_L_(0x99, 0x54)
#define REG_SC_BK99_54_H      _PK_H_(0x99, 0x54)
#define REG_SC_BK99_55_L      _PK_L_(0x99, 0x55)
#define REG_SC_BK99_55_H      _PK_H_(0x99, 0x55)
#define REG_SC_BK99_56_L      _PK_L_(0x99, 0x56)
#define REG_SC_BK99_56_H      _PK_H_(0x99, 0x56)
#define REG_SC_BK99_57_L      _PK_L_(0x99, 0x57)
#define REG_SC_BK99_57_H      _PK_H_(0x99, 0x57)
#define REG_SC_BK99_58_L      _PK_L_(0x99, 0x58)
#define REG_SC_BK99_58_H      _PK_H_(0x99, 0x58)
#define REG_SC_BK99_59_L      _PK_L_(0x99, 0x59)
#define REG_SC_BK99_59_H      _PK_H_(0x99, 0x59)
#define REG_SC_BK99_5A_L      _PK_L_(0x99, 0x5A)
#define REG_SC_BK99_5A_H      _PK_H_(0x99, 0x5A)
#define REG_SC_BK99_5B_L      _PK_L_(0x99, 0x5B)
#define REG_SC_BK99_5B_H      _PK_H_(0x99, 0x5B)
#define REG_SC_BK99_5C_L      _PK_L_(0x99, 0x5C)
#define REG_SC_BK99_5C_H      _PK_H_(0x99, 0x5C)
#define REG_SC_BK99_5D_L      _PK_L_(0x99, 0x5D)
#define REG_SC_BK99_5D_H      _PK_H_(0x99, 0x5D)
#define REG_SC_BK99_5E_L      _PK_L_(0x99, 0x5E)
#define REG_SC_BK99_5E_H      _PK_H_(0x99, 0x5E)
#define REG_SC_BK99_5F_L      _PK_L_(0x99, 0x5F)
#define REG_SC_BK99_5F_H      _PK_H_(0x99, 0x5F)
#define REG_SC_BK99_60_L      _PK_L_(0x99, 0x60)
#define REG_SC_BK99_60_H      _PK_H_(0x99, 0x60)
#define REG_SC_BK99_61_L      _PK_L_(0x99, 0x61)
#define REG_SC_BK99_61_H      _PK_H_(0x99, 0x61)
#define REG_SC_BK99_62_L      _PK_L_(0x99, 0x62)
#define REG_SC_BK99_62_H      _PK_H_(0x99, 0x62)
#define REG_SC_BK99_63_L      _PK_L_(0x99, 0x63)
#define REG_SC_BK99_63_H      _PK_H_(0x99, 0x63)
#define REG_SC_BK99_64_L      _PK_L_(0x99, 0x64)
#define REG_SC_BK99_64_H      _PK_H_(0x99, 0x64)
#define REG_SC_BK99_65_L      _PK_L_(0x99, 0x65)
#define REG_SC_BK99_65_H      _PK_H_(0x99, 0x65)
#define REG_SC_BK99_66_L      _PK_L_(0x99, 0x66)
#define REG_SC_BK99_66_H      _PK_H_(0x99, 0x66)
#define REG_SC_BK99_67_L      _PK_L_(0x99, 0x67)
#define REG_SC_BK99_67_H      _PK_H_(0x99, 0x67)
#define REG_SC_BK99_68_L      _PK_L_(0x99, 0x68)
#define REG_SC_BK99_68_H      _PK_H_(0x99, 0x68)
#define REG_SC_BK99_69_L      _PK_L_(0x99, 0x69)
#define REG_SC_BK99_69_H      _PK_H_(0x99, 0x69)
#define REG_SC_BK99_6A_L      _PK_L_(0x99, 0x6A)
#define REG_SC_BK99_6A_H      _PK_H_(0x99, 0x6A)
#define REG_SC_BK99_6B_L      _PK_L_(0x99, 0x6B)
#define REG_SC_BK99_6B_H      _PK_H_(0x99, 0x6B)
#define REG_SC_BK99_6C_L      _PK_L_(0x99, 0x6C)
#define REG_SC_BK99_6C_H      _PK_H_(0x99, 0x6C)
#define REG_SC_BK99_6D_L      _PK_L_(0x99, 0x6D)
#define REG_SC_BK99_6D_H      _PK_H_(0x99, 0x6D)
#define REG_SC_BK99_6E_L      _PK_L_(0x99, 0x6E)
#define REG_SC_BK99_6E_H      _PK_H_(0x99, 0x6E)
#define REG_SC_BK99_6F_L      _PK_L_(0x99, 0x6F)
#define REG_SC_BK99_6F_H      _PK_H_(0x99, 0x6F)
#define REG_SC_BK99_70_L      _PK_L_(0x99, 0x70)
#define REG_SC_BK99_70_H      _PK_H_(0x99, 0x70)
#define REG_SC_BK99_71_L      _PK_L_(0x99, 0x71)
#define REG_SC_BK99_71_H      _PK_H_(0x99, 0x71)
#define REG_SC_BK99_72_L      _PK_L_(0x99, 0x72)
#define REG_SC_BK99_72_H      _PK_H_(0x99, 0x72)
#define REG_SC_BK99_73_L      _PK_L_(0x99, 0x73)
#define REG_SC_BK99_73_H      _PK_H_(0x99, 0x73)
#define REG_SC_BK99_74_L      _PK_L_(0x99, 0x74)
#define REG_SC_BK99_74_H      _PK_H_(0x99, 0x74)
#define REG_SC_BK99_75_L      _PK_L_(0x99, 0x75)
#define REG_SC_BK99_75_H      _PK_H_(0x99, 0x75)
#define REG_SC_BK99_76_L      _PK_L_(0x99, 0x76)
#define REG_SC_BK99_76_H      _PK_H_(0x99, 0x76)
#define REG_SC_BK99_77_L      _PK_L_(0x99, 0x77)
#define REG_SC_BK99_77_H      _PK_H_(0x99, 0x77)
#define REG_SC_BK99_78_L      _PK_L_(0x99, 0x78)
#define REG_SC_BK99_78_H      _PK_H_(0x99, 0x78)
#define REG_SC_BK99_79_L      _PK_L_(0x99, 0x79)
#define REG_SC_BK99_79_H      _PK_H_(0x99, 0x79)
#define REG_SC_BK99_7A_L      _PK_L_(0x99, 0x7A)
#define REG_SC_BK99_7A_H      _PK_H_(0x99, 0x7A)
#define REG_SC_BK99_7B_L      _PK_L_(0x99, 0x7B)
#define REG_SC_BK99_7B_H      _PK_H_(0x99, 0x7B)
#define REG_SC_BK99_7C_L      _PK_L_(0x99, 0x7C)
#define REG_SC_BK99_7C_H      _PK_H_(0x99, 0x7C)
#define REG_SC_BK99_7D_L      _PK_L_(0x99, 0x7D)
#define REG_SC_BK99_7D_H      _PK_H_(0x99, 0x7D)
#define REG_SC_BK99_7E_L      _PK_L_(0x99, 0x7E)
#define REG_SC_BK99_7E_H      _PK_H_(0x99, 0x7E)
#define REG_SC_BK99_7F_L      _PK_L_(0x99, 0x7F)
#define REG_SC_BK99_7F_H      _PK_H_(0x99, 0x7F)
//----------------------------------------------
#define REG_SC_BK9A_00_L      _PK_L_(0x9A, 0x00)
#define REG_SC_BK9A_00_H      _PK_H_(0x9A, 0x00)
#define REG_SC_BK9A_01_L      _PK_L_(0x9A, 0x01)
#define REG_SC_BK9A_01_H      _PK_H_(0x9A, 0x01)
#define REG_SC_BK9A_02_L      _PK_L_(0x9A, 0x02)
#define REG_SC_BK9A_02_H      _PK_H_(0x9A, 0x02)
#define REG_SC_BK9A_03_L      _PK_L_(0x9A, 0x03)
#define REG_SC_BK9A_03_H      _PK_H_(0x9A, 0x03)
#define REG_SC_BK9A_04_L      _PK_L_(0x9A, 0x04)
#define REG_SC_BK9A_04_H      _PK_H_(0x9A, 0x04)
#define REG_SC_BK9A_05_L      _PK_L_(0x9A, 0x05)
#define REG_SC_BK9A_05_H      _PK_H_(0x9A, 0x05)
#define REG_SC_BK9A_06_L      _PK_L_(0x9A, 0x06)
#define REG_SC_BK9A_06_H      _PK_H_(0x9A, 0x06)
#define REG_SC_BK9A_07_L      _PK_L_(0x9A, 0x07)
#define REG_SC_BK9A_07_H      _PK_H_(0x9A, 0x07)
#define REG_SC_BK9A_08_L      _PK_L_(0x9A, 0x08)
#define REG_SC_BK9A_08_H      _PK_H_(0x9A, 0x08)
#define REG_SC_BK9A_09_L      _PK_L_(0x9A, 0x09)
#define REG_SC_BK9A_09_H      _PK_H_(0x9A, 0x09)
#define REG_SC_BK9A_0A_L      _PK_L_(0x9A, 0x0A)
#define REG_SC_BK9A_0A_H      _PK_H_(0x9A, 0x0A)
#define REG_SC_BK9A_0B_L      _PK_L_(0x9A, 0x0B)
#define REG_SC_BK9A_0B_H      _PK_H_(0x9A, 0x0B)
#define REG_SC_BK9A_0C_L      _PK_L_(0x9A, 0x0C)
#define REG_SC_BK9A_0C_H      _PK_H_(0x9A, 0x0C)
#define REG_SC_BK9A_0D_L      _PK_L_(0x9A, 0x0D)
#define REG_SC_BK9A_0D_H      _PK_H_(0x9A, 0x0D)
#define REG_SC_BK9A_0E_L      _PK_L_(0x9A, 0x0E)
#define REG_SC_BK9A_0E_H      _PK_H_(0x9A, 0x0E)
#define REG_SC_BK9A_0F_L      _PK_L_(0x9A, 0x0F)
#define REG_SC_BK9A_0F_H      _PK_H_(0x9A, 0x0F)
#define REG_SC_BK9A_10_L      _PK_L_(0x9A, 0x10)
#define REG_SC_BK9A_10_H      _PK_H_(0x9A, 0x10)
#define REG_SC_BK9A_11_L      _PK_L_(0x9A, 0x11)
#define REG_SC_BK9A_11_H      _PK_H_(0x9A, 0x11)
#define REG_SC_BK9A_12_L      _PK_L_(0x9A, 0x12)
#define REG_SC_BK9A_12_H      _PK_H_(0x9A, 0x12)
#define REG_SC_BK9A_13_L      _PK_L_(0x9A, 0x13)
#define REG_SC_BK9A_13_H      _PK_H_(0x9A, 0x13)
#define REG_SC_BK9A_14_L      _PK_L_(0x9A, 0x14)
#define REG_SC_BK9A_14_H      _PK_H_(0x9A, 0x14)
#define REG_SC_BK9A_15_L      _PK_L_(0x9A, 0x15)
#define REG_SC_BK9A_15_H      _PK_H_(0x9A, 0x15)
#define REG_SC_BK9A_16_L      _PK_L_(0x9A, 0x16)
#define REG_SC_BK9A_16_H      _PK_H_(0x9A, 0x16)
#define REG_SC_BK9A_17_L      _PK_L_(0x9A, 0x17)
#define REG_SC_BK9A_17_H      _PK_H_(0x9A, 0x17)
#define REG_SC_BK9A_18_L      _PK_L_(0x9A, 0x18)
#define REG_SC_BK9A_18_H      _PK_H_(0x9A, 0x18)
#define REG_SC_BK9A_19_L      _PK_L_(0x9A, 0x19)
#define REG_SC_BK9A_19_H      _PK_H_(0x9A, 0x19)
#define REG_SC_BK9A_1A_L      _PK_L_(0x9A, 0x1A)
#define REG_SC_BK9A_1A_H      _PK_H_(0x9A, 0x1A)
#define REG_SC_BK9A_1B_L      _PK_L_(0x9A, 0x1B)
#define REG_SC_BK9A_1B_H      _PK_H_(0x9A, 0x1B)
#define REG_SC_BK9A_1C_L      _PK_L_(0x9A, 0x1C)
#define REG_SC_BK9A_1C_H      _PK_H_(0x9A, 0x1C)
#define REG_SC_BK9A_1D_L      _PK_L_(0x9A, 0x1D)
#define REG_SC_BK9A_1D_H      _PK_H_(0x9A, 0x1D)
#define REG_SC_BK9A_1E_L      _PK_L_(0x9A, 0x1E)
#define REG_SC_BK9A_1E_H      _PK_H_(0x9A, 0x1E)
#define REG_SC_BK9A_1F_L      _PK_L_(0x9A, 0x1F)
#define REG_SC_BK9A_1F_H      _PK_H_(0x9A, 0x1F)
#define REG_SC_BK9A_20_L      _PK_L_(0x9A, 0x20)
#define REG_SC_BK9A_20_H      _PK_H_(0x9A, 0x20)
#define REG_SC_BK9A_21_L      _PK_L_(0x9A, 0x21)
#define REG_SC_BK9A_21_H      _PK_H_(0x9A, 0x21)
#define REG_SC_BK9A_22_L      _PK_L_(0x9A, 0x22)
#define REG_SC_BK9A_22_H      _PK_H_(0x9A, 0x22)
#define REG_SC_BK9A_23_L      _PK_L_(0x9A, 0x23)
#define REG_SC_BK9A_23_H      _PK_H_(0x9A, 0x23)
#define REG_SC_BK9A_24_L      _PK_L_(0x9A, 0x24)
#define REG_SC_BK9A_24_H      _PK_H_(0x9A, 0x24)
#define REG_SC_BK9A_25_L      _PK_L_(0x9A, 0x25)
#define REG_SC_BK9A_25_H      _PK_H_(0x9A, 0x25)
#define REG_SC_BK9A_26_L      _PK_L_(0x9A, 0x26)
#define REG_SC_BK9A_26_H      _PK_H_(0x9A, 0x26)
#define REG_SC_BK9A_27_L      _PK_L_(0x9A, 0x27)
#define REG_SC_BK9A_27_H      _PK_H_(0x9A, 0x27)
#define REG_SC_BK9A_28_L      _PK_L_(0x9A, 0x28)
#define REG_SC_BK9A_28_H      _PK_H_(0x9A, 0x28)
#define REG_SC_BK9A_29_L      _PK_L_(0x9A, 0x29)
#define REG_SC_BK9A_29_H      _PK_H_(0x9A, 0x29)
#define REG_SC_BK9A_2A_L      _PK_L_(0x9A, 0x2A)
#define REG_SC_BK9A_2A_H      _PK_H_(0x9A, 0x2A)
#define REG_SC_BK9A_2B_L      _PK_L_(0x9A, 0x2B)
#define REG_SC_BK9A_2B_H      _PK_H_(0x9A, 0x2B)
#define REG_SC_BK9A_2C_L      _PK_L_(0x9A, 0x2C)
#define REG_SC_BK9A_2C_H      _PK_H_(0x9A, 0x2C)
#define REG_SC_BK9A_2D_L      _PK_L_(0x9A, 0x2D)
#define REG_SC_BK9A_2D_H      _PK_H_(0x9A, 0x2D)
#define REG_SC_BK9A_2E_L      _PK_L_(0x9A, 0x2E)
#define REG_SC_BK9A_2E_H      _PK_H_(0x9A, 0x2E)
#define REG_SC_BK9A_2F_L      _PK_L_(0x9A, 0x2F)
#define REG_SC_BK9A_2F_H      _PK_H_(0x9A, 0x2F)
#define REG_SC_BK9A_30_L      _PK_L_(0x9A, 0x30)
#define REG_SC_BK9A_30_H      _PK_H_(0x9A, 0x30)
#define REG_SC_BK9A_31_L      _PK_L_(0x9A, 0x31)
#define REG_SC_BK9A_31_H      _PK_H_(0x9A, 0x31)
#define REG_SC_BK9A_32_L      _PK_L_(0x9A, 0x32)
#define REG_SC_BK9A_32_H      _PK_H_(0x9A, 0x32)
#define REG_SC_BK9A_33_L      _PK_L_(0x9A, 0x33)
#define REG_SC_BK9A_33_H      _PK_H_(0x9A, 0x33)
#define REG_SC_BK9A_34_L      _PK_L_(0x9A, 0x34)
#define REG_SC_BK9A_34_H      _PK_H_(0x9A, 0x34)
#define REG_SC_BK9A_35_L      _PK_L_(0x9A, 0x35)
#define REG_SC_BK9A_35_H      _PK_H_(0x9A, 0x35)
#define REG_SC_BK9A_36_L      _PK_L_(0x9A, 0x36)
#define REG_SC_BK9A_36_H      _PK_H_(0x9A, 0x36)
#define REG_SC_BK9A_37_L      _PK_L_(0x9A, 0x37)
#define REG_SC_BK9A_37_H      _PK_H_(0x9A, 0x37)
#define REG_SC_BK9A_38_L      _PK_L_(0x9A, 0x38)
#define REG_SC_BK9A_38_H      _PK_H_(0x9A, 0x38)
#define REG_SC_BK9A_39_L      _PK_L_(0x9A, 0x39)
#define REG_SC_BK9A_39_H      _PK_H_(0x9A, 0x39)
#define REG_SC_BK9A_3A_L      _PK_L_(0x9A, 0x3A)
#define REG_SC_BK9A_3A_H      _PK_H_(0x9A, 0x3A)
#define REG_SC_BK9A_3B_L      _PK_L_(0x9A, 0x3B)
#define REG_SC_BK9A_3B_H      _PK_H_(0x9A, 0x3B)
#define REG_SC_BK9A_3C_L      _PK_L_(0x9A, 0x3C)
#define REG_SC_BK9A_3C_H      _PK_H_(0x9A, 0x3C)
#define REG_SC_BK9A_3D_L      _PK_L_(0x9A, 0x3D)
#define REG_SC_BK9A_3D_H      _PK_H_(0x9A, 0x3D)
#define REG_SC_BK9A_3E_L      _PK_L_(0x9A, 0x3E)
#define REG_SC_BK9A_3E_H      _PK_H_(0x9A, 0x3E)
#define REG_SC_BK9A_3F_L      _PK_L_(0x9A, 0x3F)
#define REG_SC_BK9A_3F_H      _PK_H_(0x9A, 0x3F)
#define REG_SC_BK9A_40_L      _PK_L_(0x9A, 0x40)
#define REG_SC_BK9A_40_H      _PK_H_(0x9A, 0x40)
#define REG_SC_BK9A_41_L      _PK_L_(0x9A, 0x41)
#define REG_SC_BK9A_41_H      _PK_H_(0x9A, 0x41)
#define REG_SC_BK9A_42_L      _PK_L_(0x9A, 0x42)
#define REG_SC_BK9A_42_H      _PK_H_(0x9A, 0x42)
#define REG_SC_BK9A_43_L      _PK_L_(0x9A, 0x43)
#define REG_SC_BK9A_43_H      _PK_H_(0x9A, 0x43)
#define REG_SC_BK9A_44_L      _PK_L_(0x9A, 0x44)
#define REG_SC_BK9A_44_H      _PK_H_(0x9A, 0x44)
#define REG_SC_BK9A_45_L      _PK_L_(0x9A, 0x45)
#define REG_SC_BK9A_45_H      _PK_H_(0x9A, 0x45)
#define REG_SC_BK9A_46_L      _PK_L_(0x9A, 0x46)
#define REG_SC_BK9A_46_H      _PK_H_(0x9A, 0x46)
#define REG_SC_BK9A_47_L      _PK_L_(0x9A, 0x47)
#define REG_SC_BK9A_47_H      _PK_H_(0x9A, 0x47)
#define REG_SC_BK9A_48_L      _PK_L_(0x9A, 0x48)
#define REG_SC_BK9A_48_H      _PK_H_(0x9A, 0x48)
#define REG_SC_BK9A_49_L      _PK_L_(0x9A, 0x49)
#define REG_SC_BK9A_49_H      _PK_H_(0x9A, 0x49)
#define REG_SC_BK9A_4A_L      _PK_L_(0x9A, 0x4A)
#define REG_SC_BK9A_4A_H      _PK_H_(0x9A, 0x4A)
#define REG_SC_BK9A_4B_L      _PK_L_(0x9A, 0x4B)
#define REG_SC_BK9A_4B_H      _PK_H_(0x9A, 0x4B)
#define REG_SC_BK9A_4C_L      _PK_L_(0x9A, 0x4C)
#define REG_SC_BK9A_4C_H      _PK_H_(0x9A, 0x4C)
#define REG_SC_BK9A_4D_L      _PK_L_(0x9A, 0x4D)
#define REG_SC_BK9A_4D_H      _PK_H_(0x9A, 0x4D)
#define REG_SC_BK9A_4E_L      _PK_L_(0x9A, 0x4E)
#define REG_SC_BK9A_4E_H      _PK_H_(0x9A, 0x4E)
#define REG_SC_BK9A_4F_L      _PK_L_(0x9A, 0x4F)
#define REG_SC_BK9A_4F_H      _PK_H_(0x9A, 0x4F)
#define REG_SC_BK9A_50_L      _PK_L_(0x9A, 0x50)
#define REG_SC_BK9A_50_H      _PK_H_(0x9A, 0x50)
#define REG_SC_BK9A_51_L      _PK_L_(0x9A, 0x51)
#define REG_SC_BK9A_51_H      _PK_H_(0x9A, 0x51)
#define REG_SC_BK9A_52_L      _PK_L_(0x9A, 0x52)
#define REG_SC_BK9A_52_H      _PK_H_(0x9A, 0x52)
#define REG_SC_BK9A_53_L      _PK_L_(0x9A, 0x53)
#define REG_SC_BK9A_53_H      _PK_H_(0x9A, 0x53)
#define REG_SC_BK9A_54_L      _PK_L_(0x9A, 0x54)
#define REG_SC_BK9A_54_H      _PK_H_(0x9A, 0x54)
#define REG_SC_BK9A_55_L      _PK_L_(0x9A, 0x55)
#define REG_SC_BK9A_55_H      _PK_H_(0x9A, 0x55)
#define REG_SC_BK9A_56_L      _PK_L_(0x9A, 0x56)
#define REG_SC_BK9A_56_H      _PK_H_(0x9A, 0x56)
#define REG_SC_BK9A_57_L      _PK_L_(0x9A, 0x57)
#define REG_SC_BK9A_57_H      _PK_H_(0x9A, 0x57)
#define REG_SC_BK9A_58_L      _PK_L_(0x9A, 0x58)
#define REG_SC_BK9A_58_H      _PK_H_(0x9A, 0x58)
#define REG_SC_BK9A_59_L      _PK_L_(0x9A, 0x59)
#define REG_SC_BK9A_59_H      _PK_H_(0x9A, 0x59)
#define REG_SC_BK9A_5A_L      _PK_L_(0x9A, 0x5A)
#define REG_SC_BK9A_5A_H      _PK_H_(0x9A, 0x5A)
#define REG_SC_BK9A_5B_L      _PK_L_(0x9A, 0x5B)
#define REG_SC_BK9A_5B_H      _PK_H_(0x9A, 0x5B)
#define REG_SC_BK9A_5C_L      _PK_L_(0x9A, 0x5C)
#define REG_SC_BK9A_5C_H      _PK_H_(0x9A, 0x5C)
#define REG_SC_BK9A_5D_L      _PK_L_(0x9A, 0x5D)
#define REG_SC_BK9A_5D_H      _PK_H_(0x9A, 0x5D)
#define REG_SC_BK9A_5E_L      _PK_L_(0x9A, 0x5E)
#define REG_SC_BK9A_5E_H      _PK_H_(0x9A, 0x5E)
#define REG_SC_BK9A_5F_L      _PK_L_(0x9A, 0x5F)
#define REG_SC_BK9A_5F_H      _PK_H_(0x9A, 0x5F)
#define REG_SC_BK9A_60_L      _PK_L_(0x9A, 0x60)
#define REG_SC_BK9A_60_H      _PK_H_(0x9A, 0x60)
#define REG_SC_BK9A_61_L      _PK_L_(0x9A, 0x61)
#define REG_SC_BK9A_61_H      _PK_H_(0x9A, 0x61)
#define REG_SC_BK9A_62_L      _PK_L_(0x9A, 0x62)
#define REG_SC_BK9A_62_H      _PK_H_(0x9A, 0x62)
#define REG_SC_BK9A_63_L      _PK_L_(0x9A, 0x63)
#define REG_SC_BK9A_63_H      _PK_H_(0x9A, 0x63)
#define REG_SC_BK9A_64_L      _PK_L_(0x9A, 0x64)
#define REG_SC_BK9A_64_H      _PK_H_(0x9A, 0x64)
#define REG_SC_BK9A_65_L      _PK_L_(0x9A, 0x65)
#define REG_SC_BK9A_65_H      _PK_H_(0x9A, 0x65)
#define REG_SC_BK9A_66_L      _PK_L_(0x9A, 0x66)
#define REG_SC_BK9A_66_H      _PK_H_(0x9A, 0x66)
#define REG_SC_BK9A_67_L      _PK_L_(0x9A, 0x67)
#define REG_SC_BK9A_67_H      _PK_H_(0x9A, 0x67)
#define REG_SC_BK9A_68_L      _PK_L_(0x9A, 0x68)
#define REG_SC_BK9A_68_H      _PK_H_(0x9A, 0x68)
#define REG_SC_BK9A_69_L      _PK_L_(0x9A, 0x69)
#define REG_SC_BK9A_69_H      _PK_H_(0x9A, 0x69)
#define REG_SC_BK9A_6A_L      _PK_L_(0x9A, 0x6A)
#define REG_SC_BK9A_6A_H      _PK_H_(0x9A, 0x6A)
#define REG_SC_BK9A_6B_L      _PK_L_(0x9A, 0x6B)
#define REG_SC_BK9A_6B_H      _PK_H_(0x9A, 0x6B)
#define REG_SC_BK9A_6C_L      _PK_L_(0x9A, 0x6C)
#define REG_SC_BK9A_6C_H      _PK_H_(0x9A, 0x6C)
#define REG_SC_BK9A_6D_L      _PK_L_(0x9A, 0x6D)
#define REG_SC_BK9A_6D_H      _PK_H_(0x9A, 0x6D)
#define REG_SC_BK9A_6E_L      _PK_L_(0x9A, 0x6E)
#define REG_SC_BK9A_6E_H      _PK_H_(0x9A, 0x6E)
#define REG_SC_BK9A_6F_L      _PK_L_(0x9A, 0x6F)
#define REG_SC_BK9A_6F_H      _PK_H_(0x9A, 0x6F)
#define REG_SC_BK9A_70_L      _PK_L_(0x9A, 0x70)
#define REG_SC_BK9A_70_H      _PK_H_(0x9A, 0x70)
#define REG_SC_BK9A_71_L      _PK_L_(0x9A, 0x71)
#define REG_SC_BK9A_71_H      _PK_H_(0x9A, 0x71)
#define REG_SC_BK9A_72_L      _PK_L_(0x9A, 0x72)
#define REG_SC_BK9A_72_H      _PK_H_(0x9A, 0x72)
#define REG_SC_BK9A_73_L      _PK_L_(0x9A, 0x73)
#define REG_SC_BK9A_73_H      _PK_H_(0x9A, 0x73)
#define REG_SC_BK9A_74_L      _PK_L_(0x9A, 0x74)
#define REG_SC_BK9A_74_H      _PK_H_(0x9A, 0x74)
#define REG_SC_BK9A_75_L      _PK_L_(0x9A, 0x75)
#define REG_SC_BK9A_75_H      _PK_H_(0x9A, 0x75)
#define REG_SC_BK9A_76_L      _PK_L_(0x9A, 0x76)
#define REG_SC_BK9A_76_H      _PK_H_(0x9A, 0x76)
#define REG_SC_BK9A_77_L      _PK_L_(0x9A, 0x77)
#define REG_SC_BK9A_77_H      _PK_H_(0x9A, 0x77)
#define REG_SC_BK9A_78_L      _PK_L_(0x9A, 0x78)
#define REG_SC_BK9A_78_H      _PK_H_(0x9A, 0x78)
#define REG_SC_BK9A_79_L      _PK_L_(0x9A, 0x79)
#define REG_SC_BK9A_79_H      _PK_H_(0x9A, 0x79)
#define REG_SC_BK9A_7A_L      _PK_L_(0x9A, 0x7A)
#define REG_SC_BK9A_7A_H      _PK_H_(0x9A, 0x7A)
#define REG_SC_BK9A_7B_L      _PK_L_(0x9A, 0x7B)
#define REG_SC_BK9A_7B_H      _PK_H_(0x9A, 0x7B)
#define REG_SC_BK9A_7C_L      _PK_L_(0x9A, 0x7C)
#define REG_SC_BK9A_7C_H      _PK_H_(0x9A, 0x7C)
#define REG_SC_BK9A_7D_L      _PK_L_(0x9A, 0x7D)
#define REG_SC_BK9A_7D_H      _PK_H_(0x9A, 0x7D)
#define REG_SC_BK9A_7E_L      _PK_L_(0x9A, 0x7E)
#define REG_SC_BK9A_7E_H      _PK_H_(0x9A, 0x7E)
#define REG_SC_BK9A_7F_L      _PK_L_(0x9A, 0x7F)
#define REG_SC_BK9A_7F_H      _PK_H_(0x9A, 0x7F)
//----------------------------------------------
#define REG_SC_BK9B_00_L      _PK_L_(0x9B, 0x00)
#define REG_SC_BK9B_00_H      _PK_H_(0x9B, 0x00)
#define REG_SC_BK9B_01_L      _PK_L_(0x9B, 0x01)
#define REG_SC_BK9B_01_H      _PK_H_(0x9B, 0x01)
#define REG_SC_BK9B_02_L      _PK_L_(0x9B, 0x02)
#define REG_SC_BK9B_02_H      _PK_H_(0x9B, 0x02)
#define REG_SC_BK9B_03_L      _PK_L_(0x9B, 0x03)
#define REG_SC_BK9B_03_H      _PK_H_(0x9B, 0x03)
#define REG_SC_BK9B_04_L      _PK_L_(0x9B, 0x04)
#define REG_SC_BK9B_04_H      _PK_H_(0x9B, 0x04)
#define REG_SC_BK9B_05_L      _PK_L_(0x9B, 0x05)
#define REG_SC_BK9B_05_H      _PK_H_(0x9B, 0x05)
#define REG_SC_BK9B_06_L      _PK_L_(0x9B, 0x06)
#define REG_SC_BK9B_06_H      _PK_H_(0x9B, 0x06)
#define REG_SC_BK9B_07_L      _PK_L_(0x9B, 0x07)
#define REG_SC_BK9B_07_H      _PK_H_(0x9B, 0x07)
#define REG_SC_BK9B_08_L      _PK_L_(0x9B, 0x08)
#define REG_SC_BK9B_08_H      _PK_H_(0x9B, 0x08)
#define REG_SC_BK9B_09_L      _PK_L_(0x9B, 0x09)
#define REG_SC_BK9B_09_H      _PK_H_(0x9B, 0x09)
#define REG_SC_BK9B_0A_L      _PK_L_(0x9B, 0x0A)
#define REG_SC_BK9B_0A_H      _PK_H_(0x9B, 0x0A)
#define REG_SC_BK9B_0B_L      _PK_L_(0x9B, 0x0B)
#define REG_SC_BK9B_0B_H      _PK_H_(0x9B, 0x0B)
#define REG_SC_BK9B_0C_L      _PK_L_(0x9B, 0x0C)
#define REG_SC_BK9B_0C_H      _PK_H_(0x9B, 0x0C)
#define REG_SC_BK9B_0D_L      _PK_L_(0x9B, 0x0D)
#define REG_SC_BK9B_0D_H      _PK_H_(0x9B, 0x0D)
#define REG_SC_BK9B_0E_L      _PK_L_(0x9B, 0x0E)
#define REG_SC_BK9B_0E_H      _PK_H_(0x9B, 0x0E)
#define REG_SC_BK9B_0F_L      _PK_L_(0x9B, 0x0F)
#define REG_SC_BK9B_0F_H      _PK_H_(0x9B, 0x0F)
#define REG_SC_BK9B_10_L      _PK_L_(0x9B, 0x10)
#define REG_SC_BK9B_10_H      _PK_H_(0x9B, 0x10)
#define REG_SC_BK9B_11_L      _PK_L_(0x9B, 0x11)
#define REG_SC_BK9B_11_H      _PK_H_(0x9B, 0x11)
#define REG_SC_BK9B_12_L      _PK_L_(0x9B, 0x12)
#define REG_SC_BK9B_12_H      _PK_H_(0x9B, 0x12)
#define REG_SC_BK9B_13_L      _PK_L_(0x9B, 0x13)
#define REG_SC_BK9B_13_H      _PK_H_(0x9B, 0x13)
#define REG_SC_BK9B_14_L      _PK_L_(0x9B, 0x14)
#define REG_SC_BK9B_14_H      _PK_H_(0x9B, 0x14)
#define REG_SC_BK9B_15_L      _PK_L_(0x9B, 0x15)
#define REG_SC_BK9B_15_H      _PK_H_(0x9B, 0x15)
#define REG_SC_BK9B_16_L      _PK_L_(0x9B, 0x16)
#define REG_SC_BK9B_16_H      _PK_H_(0x9B, 0x16)
#define REG_SC_BK9B_17_L      _PK_L_(0x9B, 0x17)
#define REG_SC_BK9B_17_H      _PK_H_(0x9B, 0x17)
#define REG_SC_BK9B_18_L      _PK_L_(0x9B, 0x18)
#define REG_SC_BK9B_18_H      _PK_H_(0x9B, 0x18)
#define REG_SC_BK9B_19_L      _PK_L_(0x9B, 0x19)
#define REG_SC_BK9B_19_H      _PK_H_(0x9B, 0x19)
#define REG_SC_BK9B_1A_L      _PK_L_(0x9B, 0x1A)
#define REG_SC_BK9B_1A_H      _PK_H_(0x9B, 0x1A)
#define REG_SC_BK9B_1B_L      _PK_L_(0x9B, 0x1B)
#define REG_SC_BK9B_1B_H      _PK_H_(0x9B, 0x1B)
#define REG_SC_BK9B_1C_L      _PK_L_(0x9B, 0x1C)
#define REG_SC_BK9B_1C_H      _PK_H_(0x9B, 0x1C)
#define REG_SC_BK9B_1D_L      _PK_L_(0x9B, 0x1D)
#define REG_SC_BK9B_1D_H      _PK_H_(0x9B, 0x1D)
#define REG_SC_BK9B_1E_L      _PK_L_(0x9B, 0x1E)
#define REG_SC_BK9B_1E_H      _PK_H_(0x9B, 0x1E)
#define REG_SC_BK9B_1F_L      _PK_L_(0x9B, 0x1F)
#define REG_SC_BK9B_1F_H      _PK_H_(0x9B, 0x1F)
#define REG_SC_BK9B_20_L      _PK_L_(0x9B, 0x20)
#define REG_SC_BK9B_20_H      _PK_H_(0x9B, 0x20)
#define REG_SC_BK9B_21_L      _PK_L_(0x9B, 0x21)
#define REG_SC_BK9B_21_H      _PK_H_(0x9B, 0x21)
#define REG_SC_BK9B_22_L      _PK_L_(0x9B, 0x22)
#define REG_SC_BK9B_22_H      _PK_H_(0x9B, 0x22)
#define REG_SC_BK9B_23_L      _PK_L_(0x9B, 0x23)
#define REG_SC_BK9B_23_H      _PK_H_(0x9B, 0x23)
#define REG_SC_BK9B_24_L      _PK_L_(0x9B, 0x24)
#define REG_SC_BK9B_24_H      _PK_H_(0x9B, 0x24)
#define REG_SC_BK9B_25_L      _PK_L_(0x9B, 0x25)
#define REG_SC_BK9B_25_H      _PK_H_(0x9B, 0x25)
#define REG_SC_BK9B_26_L      _PK_L_(0x9B, 0x26)
#define REG_SC_BK9B_26_H      _PK_H_(0x9B, 0x26)
#define REG_SC_BK9B_27_L      _PK_L_(0x9B, 0x27)
#define REG_SC_BK9B_27_H      _PK_H_(0x9B, 0x27)
#define REG_SC_BK9B_28_L      _PK_L_(0x9B, 0x28)
#define REG_SC_BK9B_28_H      _PK_H_(0x9B, 0x28)
#define REG_SC_BK9B_29_L      _PK_L_(0x9B, 0x29)
#define REG_SC_BK9B_29_H      _PK_H_(0x9B, 0x29)
#define REG_SC_BK9B_2A_L      _PK_L_(0x9B, 0x2A)
#define REG_SC_BK9B_2A_H      _PK_H_(0x9B, 0x2A)
#define REG_SC_BK9B_2B_L      _PK_L_(0x9B, 0x2B)
#define REG_SC_BK9B_2B_H      _PK_H_(0x9B, 0x2B)
#define REG_SC_BK9B_2C_L      _PK_L_(0x9B, 0x2C)
#define REG_SC_BK9B_2C_H      _PK_H_(0x9B, 0x2C)
#define REG_SC_BK9B_2D_L      _PK_L_(0x9B, 0x2D)
#define REG_SC_BK9B_2D_H      _PK_H_(0x9B, 0x2D)
#define REG_SC_BK9B_2E_L      _PK_L_(0x9B, 0x2E)
#define REG_SC_BK9B_2E_H      _PK_H_(0x9B, 0x2E)
#define REG_SC_BK9B_2F_L      _PK_L_(0x9B, 0x2F)
#define REG_SC_BK9B_2F_H      _PK_H_(0x9B, 0x2F)
#define REG_SC_BK9B_30_L      _PK_L_(0x9B, 0x30)
#define REG_SC_BK9B_30_H      _PK_H_(0x9B, 0x30)
#define REG_SC_BK9B_31_L      _PK_L_(0x9B, 0x31)
#define REG_SC_BK9B_31_H      _PK_H_(0x9B, 0x31)
#define REG_SC_BK9B_32_L      _PK_L_(0x9B, 0x32)
#define REG_SC_BK9B_32_H      _PK_H_(0x9B, 0x32)
#define REG_SC_BK9B_33_L      _PK_L_(0x9B, 0x33)
#define REG_SC_BK9B_33_H      _PK_H_(0x9B, 0x33)
#define REG_SC_BK9B_34_L      _PK_L_(0x9B, 0x34)
#define REG_SC_BK9B_34_H      _PK_H_(0x9B, 0x34)
#define REG_SC_BK9B_35_L      _PK_L_(0x9B, 0x35)
#define REG_SC_BK9B_35_H      _PK_H_(0x9B, 0x35)
#define REG_SC_BK9B_36_L      _PK_L_(0x9B, 0x36)
#define REG_SC_BK9B_36_H      _PK_H_(0x9B, 0x36)
#define REG_SC_BK9B_37_L      _PK_L_(0x9B, 0x37)
#define REG_SC_BK9B_37_H      _PK_H_(0x9B, 0x37)
#define REG_SC_BK9B_38_L      _PK_L_(0x9B, 0x38)
#define REG_SC_BK9B_38_H      _PK_H_(0x9B, 0x38)
#define REG_SC_BK9B_39_L      _PK_L_(0x9B, 0x39)
#define REG_SC_BK9B_39_H      _PK_H_(0x9B, 0x39)
#define REG_SC_BK9B_3A_L      _PK_L_(0x9B, 0x3A)
#define REG_SC_BK9B_3A_H      _PK_H_(0x9B, 0x3A)
#define REG_SC_BK9B_3B_L      _PK_L_(0x9B, 0x3B)
#define REG_SC_BK9B_3B_H      _PK_H_(0x9B, 0x3B)
#define REG_SC_BK9B_3C_L      _PK_L_(0x9B, 0x3C)
#define REG_SC_BK9B_3C_H      _PK_H_(0x9B, 0x3C)
#define REG_SC_BK9B_3D_L      _PK_L_(0x9B, 0x3D)
#define REG_SC_BK9B_3D_H      _PK_H_(0x9B, 0x3D)
#define REG_SC_BK9B_3E_L      _PK_L_(0x9B, 0x3E)
#define REG_SC_BK9B_3E_H      _PK_H_(0x9B, 0x3E)
#define REG_SC_BK9B_3F_L      _PK_L_(0x9B, 0x3F)
#define REG_SC_BK9B_3F_H      _PK_H_(0x9B, 0x3F)
#define REG_SC_BK9B_40_L      _PK_L_(0x9B, 0x40)
#define REG_SC_BK9B_40_H      _PK_H_(0x9B, 0x40)
#define REG_SC_BK9B_41_L      _PK_L_(0x9B, 0x41)
#define REG_SC_BK9B_41_H      _PK_H_(0x9B, 0x41)
#define REG_SC_BK9B_42_L      _PK_L_(0x9B, 0x42)
#define REG_SC_BK9B_42_H      _PK_H_(0x9B, 0x42)
#define REG_SC_BK9B_43_L      _PK_L_(0x9B, 0x43)
#define REG_SC_BK9B_43_H      _PK_H_(0x9B, 0x43)
#define REG_SC_BK9B_44_L      _PK_L_(0x9B, 0x44)
#define REG_SC_BK9B_44_H      _PK_H_(0x9B, 0x44)
#define REG_SC_BK9B_45_L      _PK_L_(0x9B, 0x45)
#define REG_SC_BK9B_45_H      _PK_H_(0x9B, 0x45)
#define REG_SC_BK9B_46_L      _PK_L_(0x9B, 0x46)
#define REG_SC_BK9B_46_H      _PK_H_(0x9B, 0x46)
#define REG_SC_BK9B_47_L      _PK_L_(0x9B, 0x47)
#define REG_SC_BK9B_47_H      _PK_H_(0x9B, 0x47)
#define REG_SC_BK9B_48_L      _PK_L_(0x9B, 0x48)
#define REG_SC_BK9B_48_H      _PK_H_(0x9B, 0x48)
#define REG_SC_BK9B_49_L      _PK_L_(0x9B, 0x49)
#define REG_SC_BK9B_49_H      _PK_H_(0x9B, 0x49)
#define REG_SC_BK9B_4A_L      _PK_L_(0x9B, 0x4A)
#define REG_SC_BK9B_4A_H      _PK_H_(0x9B, 0x4A)
#define REG_SC_BK9B_4B_L      _PK_L_(0x9B, 0x4B)
#define REG_SC_BK9B_4B_H      _PK_H_(0x9B, 0x4B)
#define REG_SC_BK9B_4C_L      _PK_L_(0x9B, 0x4C)
#define REG_SC_BK9B_4C_H      _PK_H_(0x9B, 0x4C)
#define REG_SC_BK9B_4D_L      _PK_L_(0x9B, 0x4D)
#define REG_SC_BK9B_4D_H      _PK_H_(0x9B, 0x4D)
#define REG_SC_BK9B_4E_L      _PK_L_(0x9B, 0x4E)
#define REG_SC_BK9B_4E_H      _PK_H_(0x9B, 0x4E)
#define REG_SC_BK9B_4F_L      _PK_L_(0x9B, 0x4F)
#define REG_SC_BK9B_4F_H      _PK_H_(0x9B, 0x4F)
#define REG_SC_BK9B_50_L      _PK_L_(0x9B, 0x50)
#define REG_SC_BK9B_50_H      _PK_H_(0x9B, 0x50)
#define REG_SC_BK9B_51_L      _PK_L_(0x9B, 0x51)
#define REG_SC_BK9B_51_H      _PK_H_(0x9B, 0x51)
#define REG_SC_BK9B_52_L      _PK_L_(0x9B, 0x52)
#define REG_SC_BK9B_52_H      _PK_H_(0x9B, 0x52)
#define REG_SC_BK9B_53_L      _PK_L_(0x9B, 0x53)
#define REG_SC_BK9B_53_H      _PK_H_(0x9B, 0x53)
#define REG_SC_BK9B_54_L      _PK_L_(0x9B, 0x54)
#define REG_SC_BK9B_54_H      _PK_H_(0x9B, 0x54)
#define REG_SC_BK9B_55_L      _PK_L_(0x9B, 0x55)
#define REG_SC_BK9B_55_H      _PK_H_(0x9B, 0x55)
#define REG_SC_BK9B_56_L      _PK_L_(0x9B, 0x56)
#define REG_SC_BK9B_56_H      _PK_H_(0x9B, 0x56)
#define REG_SC_BK9B_57_L      _PK_L_(0x9B, 0x57)
#define REG_SC_BK9B_57_H      _PK_H_(0x9B, 0x57)
#define REG_SC_BK9B_58_L      _PK_L_(0x9B, 0x58)
#define REG_SC_BK9B_58_H      _PK_H_(0x9B, 0x58)
#define REG_SC_BK9B_59_L      _PK_L_(0x9B, 0x59)
#define REG_SC_BK9B_59_H      _PK_H_(0x9B, 0x59)
#define REG_SC_BK9B_5A_L      _PK_L_(0x9B, 0x5A)
#define REG_SC_BK9B_5A_H      _PK_H_(0x9B, 0x5A)
#define REG_SC_BK9B_5B_L      _PK_L_(0x9B, 0x5B)
#define REG_SC_BK9B_5B_H      _PK_H_(0x9B, 0x5B)
#define REG_SC_BK9B_5C_L      _PK_L_(0x9B, 0x5C)
#define REG_SC_BK9B_5C_H      _PK_H_(0x9B, 0x5C)
#define REG_SC_BK9B_5D_L      _PK_L_(0x9B, 0x5D)
#define REG_SC_BK9B_5D_H      _PK_H_(0x9B, 0x5D)
#define REG_SC_BK9B_5E_L      _PK_L_(0x9B, 0x5E)
#define REG_SC_BK9B_5E_H      _PK_H_(0x9B, 0x5E)
#define REG_SC_BK9B_5F_L      _PK_L_(0x9B, 0x5F)
#define REG_SC_BK9B_5F_H      _PK_H_(0x9B, 0x5F)
#define REG_SC_BK9B_60_L      _PK_L_(0x9B, 0x60)
#define REG_SC_BK9B_60_H      _PK_H_(0x9B, 0x60)
#define REG_SC_BK9B_61_L      _PK_L_(0x9B, 0x61)
#define REG_SC_BK9B_61_H      _PK_H_(0x9B, 0x61)
#define REG_SC_BK9B_62_L      _PK_L_(0x9B, 0x62)
#define REG_SC_BK9B_62_H      _PK_H_(0x9B, 0x62)
#define REG_SC_BK9B_63_L      _PK_L_(0x9B, 0x63)
#define REG_SC_BK9B_63_H      _PK_H_(0x9B, 0x63)
#define REG_SC_BK9B_64_L      _PK_L_(0x9B, 0x64)
#define REG_SC_BK9B_64_H      _PK_H_(0x9B, 0x64)
#define REG_SC_BK9B_65_L      _PK_L_(0x9B, 0x65)
#define REG_SC_BK9B_65_H      _PK_H_(0x9B, 0x65)
#define REG_SC_BK9B_66_L      _PK_L_(0x9B, 0x66)
#define REG_SC_BK9B_66_H      _PK_H_(0x9B, 0x66)
#define REG_SC_BK9B_67_L      _PK_L_(0x9B, 0x67)
#define REG_SC_BK9B_67_H      _PK_H_(0x9B, 0x67)
#define REG_SC_BK9B_68_L      _PK_L_(0x9B, 0x68)
#define REG_SC_BK9B_68_H      _PK_H_(0x9B, 0x68)
#define REG_SC_BK9B_69_L      _PK_L_(0x9B, 0x69)
#define REG_SC_BK9B_69_H      _PK_H_(0x9B, 0x69)
#define REG_SC_BK9B_6A_L      _PK_L_(0x9B, 0x6A)
#define REG_SC_BK9B_6A_H      _PK_H_(0x9B, 0x6A)
#define REG_SC_BK9B_6B_L      _PK_L_(0x9B, 0x6B)
#define REG_SC_BK9B_6B_H      _PK_H_(0x9B, 0x6B)
#define REG_SC_BK9B_6C_L      _PK_L_(0x9B, 0x6C)
#define REG_SC_BK9B_6C_H      _PK_H_(0x9B, 0x6C)
#define REG_SC_BK9B_6D_L      _PK_L_(0x9B, 0x6D)
#define REG_SC_BK9B_6D_H      _PK_H_(0x9B, 0x6D)
#define REG_SC_BK9B_6E_L      _PK_L_(0x9B, 0x6E)
#define REG_SC_BK9B_6E_H      _PK_H_(0x9B, 0x6E)
#define REG_SC_BK9B_6F_L      _PK_L_(0x9B, 0x6F)
#define REG_SC_BK9B_6F_H      _PK_H_(0x9B, 0x6F)
#define REG_SC_BK9B_70_L      _PK_L_(0x9B, 0x70)
#define REG_SC_BK9B_70_H      _PK_H_(0x9B, 0x70)
#define REG_SC_BK9B_71_L      _PK_L_(0x9B, 0x71)
#define REG_SC_BK9B_71_H      _PK_H_(0x9B, 0x71)
#define REG_SC_BK9B_72_L      _PK_L_(0x9B, 0x72)
#define REG_SC_BK9B_72_H      _PK_H_(0x9B, 0x72)
#define REG_SC_BK9B_73_L      _PK_L_(0x9B, 0x73)
#define REG_SC_BK9B_73_H      _PK_H_(0x9B, 0x73)
#define REG_SC_BK9B_74_L      _PK_L_(0x9B, 0x74)
#define REG_SC_BK9B_74_H      _PK_H_(0x9B, 0x74)
#define REG_SC_BK9B_75_L      _PK_L_(0x9B, 0x75)
#define REG_SC_BK9B_75_H      _PK_H_(0x9B, 0x75)
#define REG_SC_BK9B_76_L      _PK_L_(0x9B, 0x76)
#define REG_SC_BK9B_76_H      _PK_H_(0x9B, 0x76)
#define REG_SC_BK9B_77_L      _PK_L_(0x9B, 0x77)
#define REG_SC_BK9B_77_H      _PK_H_(0x9B, 0x77)
#define REG_SC_BK9B_78_L      _PK_L_(0x9B, 0x78)
#define REG_SC_BK9B_78_H      _PK_H_(0x9B, 0x78)
#define REG_SC_BK9B_79_L      _PK_L_(0x9B, 0x79)
#define REG_SC_BK9B_79_H      _PK_H_(0x9B, 0x79)
#define REG_SC_BK9B_7A_L      _PK_L_(0x9B, 0x7A)
#define REG_SC_BK9B_7A_H      _PK_H_(0x9B, 0x7A)
#define REG_SC_BK9B_7B_L      _PK_L_(0x9B, 0x7B)
#define REG_SC_BK9B_7B_H      _PK_H_(0x9B, 0x7B)
#define REG_SC_BK9B_7C_L      _PK_L_(0x9B, 0x7C)
#define REG_SC_BK9B_7C_H      _PK_H_(0x9B, 0x7C)
#define REG_SC_BK9B_7D_L      _PK_L_(0x9B, 0x7D)
#define REG_SC_BK9B_7D_H      _PK_H_(0x9B, 0x7D)
#define REG_SC_BK9B_7E_L      _PK_L_(0x9B, 0x7E)
#define REG_SC_BK9B_7E_H      _PK_H_(0x9B, 0x7E)
#define REG_SC_BK9B_7F_L      _PK_L_(0x9B, 0x7F)
#define REG_SC_BK9B_7F_H      _PK_H_(0x9B, 0x7F)
//----------------------------------------------
#define REG_SC_BK9C_00_L      _PK_L_(0x9C, 0x00)
#define REG_SC_BK9C_00_H      _PK_H_(0x9C, 0x00)
#define REG_SC_BK9C_01_L      _PK_L_(0x9C, 0x01)
#define REG_SC_BK9C_01_H      _PK_H_(0x9C, 0x01)
#define REG_SC_BK9C_02_L      _PK_L_(0x9C, 0x02)
#define REG_SC_BK9C_02_H      _PK_H_(0x9C, 0x02)
#define REG_SC_BK9C_03_L      _PK_L_(0x9C, 0x03)
#define REG_SC_BK9C_03_H      _PK_H_(0x9C, 0x03)
#define REG_SC_BK9C_04_L      _PK_L_(0x9C, 0x04)
#define REG_SC_BK9C_04_H      _PK_H_(0x9C, 0x04)
#define REG_SC_BK9C_05_L      _PK_L_(0x9C, 0x05)
#define REG_SC_BK9C_05_H      _PK_H_(0x9C, 0x05)
#define REG_SC_BK9C_06_L      _PK_L_(0x9C, 0x06)
#define REG_SC_BK9C_06_H      _PK_H_(0x9C, 0x06)
#define REG_SC_BK9C_07_L      _PK_L_(0x9C, 0x07)
#define REG_SC_BK9C_07_H      _PK_H_(0x9C, 0x07)
#define REG_SC_BK9C_08_L      _PK_L_(0x9C, 0x08)
#define REG_SC_BK9C_08_H      _PK_H_(0x9C, 0x08)
#define REG_SC_BK9C_09_L      _PK_L_(0x9C, 0x09)
#define REG_SC_BK9C_09_H      _PK_H_(0x9C, 0x09)
#define REG_SC_BK9C_0A_L      _PK_L_(0x9C, 0x0A)
#define REG_SC_BK9C_0A_H      _PK_H_(0x9C, 0x0A)
#define REG_SC_BK9C_0B_L      _PK_L_(0x9C, 0x0B)
#define REG_SC_BK9C_0B_H      _PK_H_(0x9C, 0x0B)
#define REG_SC_BK9C_0C_L      _PK_L_(0x9C, 0x0C)
#define REG_SC_BK9C_0C_H      _PK_H_(0x9C, 0x0C)
#define REG_SC_BK9C_0D_L      _PK_L_(0x9C, 0x0D)
#define REG_SC_BK9C_0D_H      _PK_H_(0x9C, 0x0D)
#define REG_SC_BK9C_0E_L      _PK_L_(0x9C, 0x0E)
#define REG_SC_BK9C_0E_H      _PK_H_(0x9C, 0x0E)
#define REG_SC_BK9C_0F_L      _PK_L_(0x9C, 0x0F)
#define REG_SC_BK9C_0F_H      _PK_H_(0x9C, 0x0F)
#define REG_SC_BK9C_10_L      _PK_L_(0x9C, 0x10)
#define REG_SC_BK9C_10_H      _PK_H_(0x9C, 0x10)
#define REG_SC_BK9C_11_L      _PK_L_(0x9C, 0x11)
#define REG_SC_BK9C_11_H      _PK_H_(0x9C, 0x11)
#define REG_SC_BK9C_12_L      _PK_L_(0x9C, 0x12)
#define REG_SC_BK9C_12_H      _PK_H_(0x9C, 0x12)
#define REG_SC_BK9C_13_L      _PK_L_(0x9C, 0x13)
#define REG_SC_BK9C_13_H      _PK_H_(0x9C, 0x13)
#define REG_SC_BK9C_14_L      _PK_L_(0x9C, 0x14)
#define REG_SC_BK9C_14_H      _PK_H_(0x9C, 0x14)
#define REG_SC_BK9C_15_L      _PK_L_(0x9C, 0x15)
#define REG_SC_BK9C_15_H      _PK_H_(0x9C, 0x15)
#define REG_SC_BK9C_16_L      _PK_L_(0x9C, 0x16)
#define REG_SC_BK9C_16_H      _PK_H_(0x9C, 0x16)
#define REG_SC_BK9C_17_L      _PK_L_(0x9C, 0x17)
#define REG_SC_BK9C_17_H      _PK_H_(0x9C, 0x17)
#define REG_SC_BK9C_18_L      _PK_L_(0x9C, 0x18)
#define REG_SC_BK9C_18_H      _PK_H_(0x9C, 0x18)
#define REG_SC_BK9C_19_L      _PK_L_(0x9C, 0x19)
#define REG_SC_BK9C_19_H      _PK_H_(0x9C, 0x19)
#define REG_SC_BK9C_1A_L      _PK_L_(0x9C, 0x1A)
#define REG_SC_BK9C_1A_H      _PK_H_(0x9C, 0x1A)
#define REG_SC_BK9C_1B_L      _PK_L_(0x9C, 0x1B)
#define REG_SC_BK9C_1B_H      _PK_H_(0x9C, 0x1B)
#define REG_SC_BK9C_1C_L      _PK_L_(0x9C, 0x1C)
#define REG_SC_BK9C_1C_H      _PK_H_(0x9C, 0x1C)
#define REG_SC_BK9C_1D_L      _PK_L_(0x9C, 0x1D)
#define REG_SC_BK9C_1D_H      _PK_H_(0x9C, 0x1D)
#define REG_SC_BK9C_1E_L      _PK_L_(0x9C, 0x1E)
#define REG_SC_BK9C_1E_H      _PK_H_(0x9C, 0x1E)
#define REG_SC_BK9C_1F_L      _PK_L_(0x9C, 0x1F)
#define REG_SC_BK9C_1F_H      _PK_H_(0x9C, 0x1F)
#define REG_SC_BK9C_20_L      _PK_L_(0x9C, 0x20)
#define REG_SC_BK9C_20_H      _PK_H_(0x9C, 0x20)
#define REG_SC_BK9C_21_L      _PK_L_(0x9C, 0x21)
#define REG_SC_BK9C_21_H      _PK_H_(0x9C, 0x21)
#define REG_SC_BK9C_22_L      _PK_L_(0x9C, 0x22)
#define REG_SC_BK9C_22_H      _PK_H_(0x9C, 0x22)
#define REG_SC_BK9C_23_L      _PK_L_(0x9C, 0x23)
#define REG_SC_BK9C_23_H      _PK_H_(0x9C, 0x23)
#define REG_SC_BK9C_24_L      _PK_L_(0x9C, 0x24)
#define REG_SC_BK9C_24_H      _PK_H_(0x9C, 0x24)
#define REG_SC_BK9C_25_L      _PK_L_(0x9C, 0x25)
#define REG_SC_BK9C_25_H      _PK_H_(0x9C, 0x25)
#define REG_SC_BK9C_26_L      _PK_L_(0x9C, 0x26)
#define REG_SC_BK9C_26_H      _PK_H_(0x9C, 0x26)
#define REG_SC_BK9C_27_L      _PK_L_(0x9C, 0x27)
#define REG_SC_BK9C_27_H      _PK_H_(0x9C, 0x27)
#define REG_SC_BK9C_28_L      _PK_L_(0x9C, 0x28)
#define REG_SC_BK9C_28_H      _PK_H_(0x9C, 0x28)
#define REG_SC_BK9C_29_L      _PK_L_(0x9C, 0x29)
#define REG_SC_BK9C_29_H      _PK_H_(0x9C, 0x29)
#define REG_SC_BK9C_2A_L      _PK_L_(0x9C, 0x2A)
#define REG_SC_BK9C_2A_H      _PK_H_(0x9C, 0x2A)
#define REG_SC_BK9C_2B_L      _PK_L_(0x9C, 0x2B)
#define REG_SC_BK9C_2B_H      _PK_H_(0x9C, 0x2B)
#define REG_SC_BK9C_2C_L      _PK_L_(0x9C, 0x2C)
#define REG_SC_BK9C_2C_H      _PK_H_(0x9C, 0x2C)
#define REG_SC_BK9C_2D_L      _PK_L_(0x9C, 0x2D)
#define REG_SC_BK9C_2D_H      _PK_H_(0x9C, 0x2D)
#define REG_SC_BK9C_2E_L      _PK_L_(0x9C, 0x2E)
#define REG_SC_BK9C_2E_H      _PK_H_(0x9C, 0x2E)
#define REG_SC_BK9C_2F_L      _PK_L_(0x9C, 0x2F)
#define REG_SC_BK9C_2F_H      _PK_H_(0x9C, 0x2F)
#define REG_SC_BK9C_30_L      _PK_L_(0x9C, 0x30)
#define REG_SC_BK9C_30_H      _PK_H_(0x9C, 0x30)
#define REG_SC_BK9C_31_L      _PK_L_(0x9C, 0x31)
#define REG_SC_BK9C_31_H      _PK_H_(0x9C, 0x31)
#define REG_SC_BK9C_32_L      _PK_L_(0x9C, 0x32)
#define REG_SC_BK9C_32_H      _PK_H_(0x9C, 0x32)
#define REG_SC_BK9C_33_L      _PK_L_(0x9C, 0x33)
#define REG_SC_BK9C_33_H      _PK_H_(0x9C, 0x33)
#define REG_SC_BK9C_34_L      _PK_L_(0x9C, 0x34)
#define REG_SC_BK9C_34_H      _PK_H_(0x9C, 0x34)
#define REG_SC_BK9C_35_L      _PK_L_(0x9C, 0x35)
#define REG_SC_BK9C_35_H      _PK_H_(0x9C, 0x35)
#define REG_SC_BK9C_36_L      _PK_L_(0x9C, 0x36)
#define REG_SC_BK9C_36_H      _PK_H_(0x9C, 0x36)
#define REG_SC_BK9C_37_L      _PK_L_(0x9C, 0x37)
#define REG_SC_BK9C_37_H      _PK_H_(0x9C, 0x37)
#define REG_SC_BK9C_38_L      _PK_L_(0x9C, 0x38)
#define REG_SC_BK9C_38_H      _PK_H_(0x9C, 0x38)
#define REG_SC_BK9C_39_L      _PK_L_(0x9C, 0x39)
#define REG_SC_BK9C_39_H      _PK_H_(0x9C, 0x39)
#define REG_SC_BK9C_3A_L      _PK_L_(0x9C, 0x3A)
#define REG_SC_BK9C_3A_H      _PK_H_(0x9C, 0x3A)
#define REG_SC_BK9C_3B_L      _PK_L_(0x9C, 0x3B)
#define REG_SC_BK9C_3B_H      _PK_H_(0x9C, 0x3B)
#define REG_SC_BK9C_3C_L      _PK_L_(0x9C, 0x3C)
#define REG_SC_BK9C_3C_H      _PK_H_(0x9C, 0x3C)
#define REG_SC_BK9C_3D_L      _PK_L_(0x9C, 0x3D)
#define REG_SC_BK9C_3D_H      _PK_H_(0x9C, 0x3D)
#define REG_SC_BK9C_3E_L      _PK_L_(0x9C, 0x3E)
#define REG_SC_BK9C_3E_H      _PK_H_(0x9C, 0x3E)
#define REG_SC_BK9C_3F_L      _PK_L_(0x9C, 0x3F)
#define REG_SC_BK9C_3F_H      _PK_H_(0x9C, 0x3F)
#define REG_SC_BK9C_40_L      _PK_L_(0x9C, 0x40)
#define REG_SC_BK9C_40_H      _PK_H_(0x9C, 0x40)
#define REG_SC_BK9C_41_L      _PK_L_(0x9C, 0x41)
#define REG_SC_BK9C_41_H      _PK_H_(0x9C, 0x41)
#define REG_SC_BK9C_42_L      _PK_L_(0x9C, 0x42)
#define REG_SC_BK9C_42_H      _PK_H_(0x9C, 0x42)
#define REG_SC_BK9C_43_L      _PK_L_(0x9C, 0x43)
#define REG_SC_BK9C_43_H      _PK_H_(0x9C, 0x43)
#define REG_SC_BK9C_44_L      _PK_L_(0x9C, 0x44)
#define REG_SC_BK9C_44_H      _PK_H_(0x9C, 0x44)
#define REG_SC_BK9C_45_L      _PK_L_(0x9C, 0x45)
#define REG_SC_BK9C_45_H      _PK_H_(0x9C, 0x45)
#define REG_SC_BK9C_46_L      _PK_L_(0x9C, 0x46)
#define REG_SC_BK9C_46_H      _PK_H_(0x9C, 0x46)
#define REG_SC_BK9C_47_L      _PK_L_(0x9C, 0x47)
#define REG_SC_BK9C_47_H      _PK_H_(0x9C, 0x47)
#define REG_SC_BK9C_48_L      _PK_L_(0x9C, 0x48)
#define REG_SC_BK9C_48_H      _PK_H_(0x9C, 0x48)
#define REG_SC_BK9C_49_L      _PK_L_(0x9C, 0x49)
#define REG_SC_BK9C_49_H      _PK_H_(0x9C, 0x49)
#define REG_SC_BK9C_4A_L      _PK_L_(0x9C, 0x4A)
#define REG_SC_BK9C_4A_H      _PK_H_(0x9C, 0x4A)
#define REG_SC_BK9C_4B_L      _PK_L_(0x9C, 0x4B)
#define REG_SC_BK9C_4B_H      _PK_H_(0x9C, 0x4B)
#define REG_SC_BK9C_4C_L      _PK_L_(0x9C, 0x4C)
#define REG_SC_BK9C_4C_H      _PK_H_(0x9C, 0x4C)
#define REG_SC_BK9C_4D_L      _PK_L_(0x9C, 0x4D)
#define REG_SC_BK9C_4D_H      _PK_H_(0x9C, 0x4D)
#define REG_SC_BK9C_4E_L      _PK_L_(0x9C, 0x4E)
#define REG_SC_BK9C_4E_H      _PK_H_(0x9C, 0x4E)
#define REG_SC_BK9C_4F_L      _PK_L_(0x9C, 0x4F)
#define REG_SC_BK9C_4F_H      _PK_H_(0x9C, 0x4F)
#define REG_SC_BK9C_50_L      _PK_L_(0x9C, 0x50)
#define REG_SC_BK9C_50_H      _PK_H_(0x9C, 0x50)
#define REG_SC_BK9C_51_L      _PK_L_(0x9C, 0x51)
#define REG_SC_BK9C_51_H      _PK_H_(0x9C, 0x51)
#define REG_SC_BK9C_52_L      _PK_L_(0x9C, 0x52)
#define REG_SC_BK9C_52_H      _PK_H_(0x9C, 0x52)
#define REG_SC_BK9C_53_L      _PK_L_(0x9C, 0x53)
#define REG_SC_BK9C_53_H      _PK_H_(0x9C, 0x53)
#define REG_SC_BK9C_54_L      _PK_L_(0x9C, 0x54)
#define REG_SC_BK9C_54_H      _PK_H_(0x9C, 0x54)
#define REG_SC_BK9C_55_L      _PK_L_(0x9C, 0x55)
#define REG_SC_BK9C_55_H      _PK_H_(0x9C, 0x55)
#define REG_SC_BK9C_56_L      _PK_L_(0x9C, 0x56)
#define REG_SC_BK9C_56_H      _PK_H_(0x9C, 0x56)
#define REG_SC_BK9C_57_L      _PK_L_(0x9C, 0x57)
#define REG_SC_BK9C_57_H      _PK_H_(0x9C, 0x57)
#define REG_SC_BK9C_58_L      _PK_L_(0x9C, 0x58)
#define REG_SC_BK9C_58_H      _PK_H_(0x9C, 0x58)
#define REG_SC_BK9C_59_L      _PK_L_(0x9C, 0x59)
#define REG_SC_BK9C_59_H      _PK_H_(0x9C, 0x59)
#define REG_SC_BK9C_5A_L      _PK_L_(0x9C, 0x5A)
#define REG_SC_BK9C_5A_H      _PK_H_(0x9C, 0x5A)
#define REG_SC_BK9C_5B_L      _PK_L_(0x9C, 0x5B)
#define REG_SC_BK9C_5B_H      _PK_H_(0x9C, 0x5B)
#define REG_SC_BK9C_5C_L      _PK_L_(0x9C, 0x5C)
#define REG_SC_BK9C_5C_H      _PK_H_(0x9C, 0x5C)
#define REG_SC_BK9C_5D_L      _PK_L_(0x9C, 0x5D)
#define REG_SC_BK9C_5D_H      _PK_H_(0x9C, 0x5D)
#define REG_SC_BK9C_5E_L      _PK_L_(0x9C, 0x5E)
#define REG_SC_BK9C_5E_H      _PK_H_(0x9C, 0x5E)
#define REG_SC_BK9C_5F_L      _PK_L_(0x9C, 0x5F)
#define REG_SC_BK9C_5F_H      _PK_H_(0x9C, 0x5F)
#define REG_SC_BK9C_60_L      _PK_L_(0x9C, 0x60)
#define REG_SC_BK9C_60_H      _PK_H_(0x9C, 0x60)
#define REG_SC_BK9C_61_L      _PK_L_(0x9C, 0x61)
#define REG_SC_BK9C_61_H      _PK_H_(0x9C, 0x61)
#define REG_SC_BK9C_62_L      _PK_L_(0x9C, 0x62)
#define REG_SC_BK9C_62_H      _PK_H_(0x9C, 0x62)
#define REG_SC_BK9C_63_L      _PK_L_(0x9C, 0x63)
#define REG_SC_BK9C_63_H      _PK_H_(0x9C, 0x63)
#define REG_SC_BK9C_64_L      _PK_L_(0x9C, 0x64)
#define REG_SC_BK9C_64_H      _PK_H_(0x9C, 0x64)
#define REG_SC_BK9C_65_L      _PK_L_(0x9C, 0x65)
#define REG_SC_BK9C_65_H      _PK_H_(0x9C, 0x65)
#define REG_SC_BK9C_66_L      _PK_L_(0x9C, 0x66)
#define REG_SC_BK9C_66_H      _PK_H_(0x9C, 0x66)
#define REG_SC_BK9C_67_L      _PK_L_(0x9C, 0x67)
#define REG_SC_BK9C_67_H      _PK_H_(0x9C, 0x67)
#define REG_SC_BK9C_68_L      _PK_L_(0x9C, 0x68)
#define REG_SC_BK9C_68_H      _PK_H_(0x9C, 0x68)
#define REG_SC_BK9C_69_L      _PK_L_(0x9C, 0x69)
#define REG_SC_BK9C_69_H      _PK_H_(0x9C, 0x69)
#define REG_SC_BK9C_6A_L      _PK_L_(0x9C, 0x6A)
#define REG_SC_BK9C_6A_H      _PK_H_(0x9C, 0x6A)
#define REG_SC_BK9C_6B_L      _PK_L_(0x9C, 0x6B)
#define REG_SC_BK9C_6B_H      _PK_H_(0x9C, 0x6B)
#define REG_SC_BK9C_6C_L      _PK_L_(0x9C, 0x6C)
#define REG_SC_BK9C_6C_H      _PK_H_(0x9C, 0x6C)
#define REG_SC_BK9C_6D_L      _PK_L_(0x9C, 0x6D)
#define REG_SC_BK9C_6D_H      _PK_H_(0x9C, 0x6D)
#define REG_SC_BK9C_6E_L      _PK_L_(0x9C, 0x6E)
#define REG_SC_BK9C_6E_H      _PK_H_(0x9C, 0x6E)
#define REG_SC_BK9C_6F_L      _PK_L_(0x9C, 0x6F)
#define REG_SC_BK9C_6F_H      _PK_H_(0x9C, 0x6F)
#define REG_SC_BK9C_70_L      _PK_L_(0x9C, 0x70)
#define REG_SC_BK9C_70_H      _PK_H_(0x9C, 0x70)
#define REG_SC_BK9C_71_L      _PK_L_(0x9C, 0x71)
#define REG_SC_BK9C_71_H      _PK_H_(0x9C, 0x71)
#define REG_SC_BK9C_72_L      _PK_L_(0x9C, 0x72)
#define REG_SC_BK9C_72_H      _PK_H_(0x9C, 0x72)
#define REG_SC_BK9C_73_L      _PK_L_(0x9C, 0x73)
#define REG_SC_BK9C_73_H      _PK_H_(0x9C, 0x73)
#define REG_SC_BK9C_74_L      _PK_L_(0x9C, 0x74)
#define REG_SC_BK9C_74_H      _PK_H_(0x9C, 0x74)
#define REG_SC_BK9C_75_L      _PK_L_(0x9C, 0x75)
#define REG_SC_BK9C_75_H      _PK_H_(0x9C, 0x75)
#define REG_SC_BK9C_76_L      _PK_L_(0x9C, 0x76)
#define REG_SC_BK9C_76_H      _PK_H_(0x9C, 0x76)
#define REG_SC_BK9C_77_L      _PK_L_(0x9C, 0x77)
#define REG_SC_BK9C_77_H      _PK_H_(0x9C, 0x77)
#define REG_SC_BK9C_78_L      _PK_L_(0x9C, 0x78)
#define REG_SC_BK9C_78_H      _PK_H_(0x9C, 0x78)
#define REG_SC_BK9C_79_L      _PK_L_(0x9C, 0x79)
#define REG_SC_BK9C_79_H      _PK_H_(0x9C, 0x79)
#define REG_SC_BK9C_7A_L      _PK_L_(0x9C, 0x7A)
#define REG_SC_BK9C_7A_H      _PK_H_(0x9C, 0x7A)
#define REG_SC_BK9C_7B_L      _PK_L_(0x9C, 0x7B)
#define REG_SC_BK9C_7B_H      _PK_H_(0x9C, 0x7B)
#define REG_SC_BK9C_7C_L      _PK_L_(0x9C, 0x7C)
#define REG_SC_BK9C_7C_H      _PK_H_(0x9C, 0x7C)
#define REG_SC_BK9C_7D_L      _PK_L_(0x9C, 0x7D)
#define REG_SC_BK9C_7D_H      _PK_H_(0x9C, 0x7D)
#define REG_SC_BK9C_7E_L      _PK_L_(0x9C, 0x7E)
#define REG_SC_BK9C_7E_H      _PK_H_(0x9C, 0x7E)
#define REG_SC_BK9C_7F_L      _PK_L_(0x9C, 0x7F)
#define REG_SC_BK9C_7F_H      _PK_H_(0x9C, 0x7F)
//----------------------------------------------
#define REG_SC_BK9D_00_L      _PK_L_(0x9D, 0x00)
#define REG_SC_BK9D_00_H      _PK_H_(0x9D, 0x00)
#define REG_SC_BK9D_01_L      _PK_L_(0x9D, 0x01)
#define REG_SC_BK9D_01_H      _PK_H_(0x9D, 0x01)
#define REG_SC_BK9D_02_L      _PK_L_(0x9D, 0x02)
#define REG_SC_BK9D_02_H      _PK_H_(0x9D, 0x02)
#define REG_SC_BK9D_03_L      _PK_L_(0x9D, 0x03)
#define REG_SC_BK9D_03_H      _PK_H_(0x9D, 0x03)
#define REG_SC_BK9D_04_L      _PK_L_(0x9D, 0x04)
#define REG_SC_BK9D_04_H      _PK_H_(0x9D, 0x04)
#define REG_SC_BK9D_05_L      _PK_L_(0x9D, 0x05)
#define REG_SC_BK9D_05_H      _PK_H_(0x9D, 0x05)
#define REG_SC_BK9D_06_L      _PK_L_(0x9D, 0x06)
#define REG_SC_BK9D_06_H      _PK_H_(0x9D, 0x06)
#define REG_SC_BK9D_07_L      _PK_L_(0x9D, 0x07)
#define REG_SC_BK9D_07_H      _PK_H_(0x9D, 0x07)
#define REG_SC_BK9D_08_L      _PK_L_(0x9D, 0x08)
#define REG_SC_BK9D_08_H      _PK_H_(0x9D, 0x08)
#define REG_SC_BK9D_09_L      _PK_L_(0x9D, 0x09)
#define REG_SC_BK9D_09_H      _PK_H_(0x9D, 0x09)
#define REG_SC_BK9D_0A_L      _PK_L_(0x9D, 0x0A)
#define REG_SC_BK9D_0A_H      _PK_H_(0x9D, 0x0A)
#define REG_SC_BK9D_0B_L      _PK_L_(0x9D, 0x0B)
#define REG_SC_BK9D_0B_H      _PK_H_(0x9D, 0x0B)
#define REG_SC_BK9D_0C_L      _PK_L_(0x9D, 0x0C)
#define REG_SC_BK9D_0C_H      _PK_H_(0x9D, 0x0C)
#define REG_SC_BK9D_0D_L      _PK_L_(0x9D, 0x0D)
#define REG_SC_BK9D_0D_H      _PK_H_(0x9D, 0x0D)
#define REG_SC_BK9D_0E_L      _PK_L_(0x9D, 0x0E)
#define REG_SC_BK9D_0E_H      _PK_H_(0x9D, 0x0E)
#define REG_SC_BK9D_0F_L      _PK_L_(0x9D, 0x0F)
#define REG_SC_BK9D_0F_H      _PK_H_(0x9D, 0x0F)
#define REG_SC_BK9D_10_L      _PK_L_(0x9D, 0x10)
#define REG_SC_BK9D_10_H      _PK_H_(0x9D, 0x10)
#define REG_SC_BK9D_11_L      _PK_L_(0x9D, 0x11)
#define REG_SC_BK9D_11_H      _PK_H_(0x9D, 0x11)
#define REG_SC_BK9D_12_L      _PK_L_(0x9D, 0x12)
#define REG_SC_BK9D_12_H      _PK_H_(0x9D, 0x12)
#define REG_SC_BK9D_13_L      _PK_L_(0x9D, 0x13)
#define REG_SC_BK9D_13_H      _PK_H_(0x9D, 0x13)
#define REG_SC_BK9D_14_L      _PK_L_(0x9D, 0x14)
#define REG_SC_BK9D_14_H      _PK_H_(0x9D, 0x14)
#define REG_SC_BK9D_15_L      _PK_L_(0x9D, 0x15)
#define REG_SC_BK9D_15_H      _PK_H_(0x9D, 0x15)
#define REG_SC_BK9D_16_L      _PK_L_(0x9D, 0x16)
#define REG_SC_BK9D_16_H      _PK_H_(0x9D, 0x16)
#define REG_SC_BK9D_17_L      _PK_L_(0x9D, 0x17)
#define REG_SC_BK9D_17_H      _PK_H_(0x9D, 0x17)
#define REG_SC_BK9D_18_L      _PK_L_(0x9D, 0x18)
#define REG_SC_BK9D_18_H      _PK_H_(0x9D, 0x18)
#define REG_SC_BK9D_19_L      _PK_L_(0x9D, 0x19)
#define REG_SC_BK9D_19_H      _PK_H_(0x9D, 0x19)
#define REG_SC_BK9D_1A_L      _PK_L_(0x9D, 0x1A)
#define REG_SC_BK9D_1A_H      _PK_H_(0x9D, 0x1A)
#define REG_SC_BK9D_1B_L      _PK_L_(0x9D, 0x1B)
#define REG_SC_BK9D_1B_H      _PK_H_(0x9D, 0x1B)
#define REG_SC_BK9D_1C_L      _PK_L_(0x9D, 0x1C)
#define REG_SC_BK9D_1C_H      _PK_H_(0x9D, 0x1C)
#define REG_SC_BK9D_1D_L      _PK_L_(0x9D, 0x1D)
#define REG_SC_BK9D_1D_H      _PK_H_(0x9D, 0x1D)
#define REG_SC_BK9D_1E_L      _PK_L_(0x9D, 0x1E)
#define REG_SC_BK9D_1E_H      _PK_H_(0x9D, 0x1E)
#define REG_SC_BK9D_1F_L      _PK_L_(0x9D, 0x1F)
#define REG_SC_BK9D_1F_H      _PK_H_(0x9D, 0x1F)
#define REG_SC_BK9D_20_L      _PK_L_(0x9D, 0x20)
#define REG_SC_BK9D_20_H      _PK_H_(0x9D, 0x20)
#define REG_SC_BK9D_21_L      _PK_L_(0x9D, 0x21)
#define REG_SC_BK9D_21_H      _PK_H_(0x9D, 0x21)
#define REG_SC_BK9D_22_L      _PK_L_(0x9D, 0x22)
#define REG_SC_BK9D_22_H      _PK_H_(0x9D, 0x22)
#define REG_SC_BK9D_23_L      _PK_L_(0x9D, 0x23)
#define REG_SC_BK9D_23_H      _PK_H_(0x9D, 0x23)
#define REG_SC_BK9D_24_L      _PK_L_(0x9D, 0x24)
#define REG_SC_BK9D_24_H      _PK_H_(0x9D, 0x24)
#define REG_SC_BK9D_25_L      _PK_L_(0x9D, 0x25)
#define REG_SC_BK9D_25_H      _PK_H_(0x9D, 0x25)
#define REG_SC_BK9D_26_L      _PK_L_(0x9D, 0x26)
#define REG_SC_BK9D_26_H      _PK_H_(0x9D, 0x26)
#define REG_SC_BK9D_27_L      _PK_L_(0x9D, 0x27)
#define REG_SC_BK9D_27_H      _PK_H_(0x9D, 0x27)
#define REG_SC_BK9D_28_L      _PK_L_(0x9D, 0x28)
#define REG_SC_BK9D_28_H      _PK_H_(0x9D, 0x28)
#define REG_SC_BK9D_29_L      _PK_L_(0x9D, 0x29)
#define REG_SC_BK9D_29_H      _PK_H_(0x9D, 0x29)
#define REG_SC_BK9D_2A_L      _PK_L_(0x9D, 0x2A)
#define REG_SC_BK9D_2A_H      _PK_H_(0x9D, 0x2A)
#define REG_SC_BK9D_2B_L      _PK_L_(0x9D, 0x2B)
#define REG_SC_BK9D_2B_H      _PK_H_(0x9D, 0x2B)
#define REG_SC_BK9D_2C_L      _PK_L_(0x9D, 0x2C)
#define REG_SC_BK9D_2C_H      _PK_H_(0x9D, 0x2C)
#define REG_SC_BK9D_2D_L      _PK_L_(0x9D, 0x2D)
#define REG_SC_BK9D_2D_H      _PK_H_(0x9D, 0x2D)
#define REG_SC_BK9D_2E_L      _PK_L_(0x9D, 0x2E)
#define REG_SC_BK9D_2E_H      _PK_H_(0x9D, 0x2E)
#define REG_SC_BK9D_2F_L      _PK_L_(0x9D, 0x2F)
#define REG_SC_BK9D_2F_H      _PK_H_(0x9D, 0x2F)
#define REG_SC_BK9D_30_L      _PK_L_(0x9D, 0x30)
#define REG_SC_BK9D_30_H      _PK_H_(0x9D, 0x30)
#define REG_SC_BK9D_31_L      _PK_L_(0x9D, 0x31)
#define REG_SC_BK9D_31_H      _PK_H_(0x9D, 0x31)
#define REG_SC_BK9D_32_L      _PK_L_(0x9D, 0x32)
#define REG_SC_BK9D_32_H      _PK_H_(0x9D, 0x32)
#define REG_SC_BK9D_33_L      _PK_L_(0x9D, 0x33)
#define REG_SC_BK9D_33_H      _PK_H_(0x9D, 0x33)
#define REG_SC_BK9D_34_L      _PK_L_(0x9D, 0x34)
#define REG_SC_BK9D_34_H      _PK_H_(0x9D, 0x34)
#define REG_SC_BK9D_35_L      _PK_L_(0x9D, 0x35)
#define REG_SC_BK9D_35_H      _PK_H_(0x9D, 0x35)
#define REG_SC_BK9D_36_L      _PK_L_(0x9D, 0x36)
#define REG_SC_BK9D_36_H      _PK_H_(0x9D, 0x36)
#define REG_SC_BK9D_37_L      _PK_L_(0x9D, 0x37)
#define REG_SC_BK9D_37_H      _PK_H_(0x9D, 0x37)
#define REG_SC_BK9D_38_L      _PK_L_(0x9D, 0x38)
#define REG_SC_BK9D_38_H      _PK_H_(0x9D, 0x38)
#define REG_SC_BK9D_39_L      _PK_L_(0x9D, 0x39)
#define REG_SC_BK9D_39_H      _PK_H_(0x9D, 0x39)
#define REG_SC_BK9D_3A_L      _PK_L_(0x9D, 0x3A)
#define REG_SC_BK9D_3A_H      _PK_H_(0x9D, 0x3A)
#define REG_SC_BK9D_3B_L      _PK_L_(0x9D, 0x3B)
#define REG_SC_BK9D_3B_H      _PK_H_(0x9D, 0x3B)
#define REG_SC_BK9D_3C_L      _PK_L_(0x9D, 0x3C)
#define REG_SC_BK9D_3C_H      _PK_H_(0x9D, 0x3C)
#define REG_SC_BK9D_3D_L      _PK_L_(0x9D, 0x3D)
#define REG_SC_BK9D_3D_H      _PK_H_(0x9D, 0x3D)
#define REG_SC_BK9D_3E_L      _PK_L_(0x9D, 0x3E)
#define REG_SC_BK9D_3E_H      _PK_H_(0x9D, 0x3E)
#define REG_SC_BK9D_3F_L      _PK_L_(0x9D, 0x3F)
#define REG_SC_BK9D_3F_H      _PK_H_(0x9D, 0x3F)
#define REG_SC_BK9D_40_L      _PK_L_(0x9D, 0x40)
#define REG_SC_BK9D_40_H      _PK_H_(0x9D, 0x40)
#define REG_SC_BK9D_41_L      _PK_L_(0x9D, 0x41)
#define REG_SC_BK9D_41_H      _PK_H_(0x9D, 0x41)
#define REG_SC_BK9D_42_L      _PK_L_(0x9D, 0x42)
#define REG_SC_BK9D_42_H      _PK_H_(0x9D, 0x42)
#define REG_SC_BK9D_43_L      _PK_L_(0x9D, 0x43)
#define REG_SC_BK9D_43_H      _PK_H_(0x9D, 0x43)
#define REG_SC_BK9D_44_L      _PK_L_(0x9D, 0x44)
#define REG_SC_BK9D_44_H      _PK_H_(0x9D, 0x44)
#define REG_SC_BK9D_45_L      _PK_L_(0x9D, 0x45)
#define REG_SC_BK9D_45_H      _PK_H_(0x9D, 0x45)
#define REG_SC_BK9D_46_L      _PK_L_(0x9D, 0x46)
#define REG_SC_BK9D_46_H      _PK_H_(0x9D, 0x46)
#define REG_SC_BK9D_47_L      _PK_L_(0x9D, 0x47)
#define REG_SC_BK9D_47_H      _PK_H_(0x9D, 0x47)
#define REG_SC_BK9D_48_L      _PK_L_(0x9D, 0x48)
#define REG_SC_BK9D_48_H      _PK_H_(0x9D, 0x48)
#define REG_SC_BK9D_49_L      _PK_L_(0x9D, 0x49)
#define REG_SC_BK9D_49_H      _PK_H_(0x9D, 0x49)
#define REG_SC_BK9D_4A_L      _PK_L_(0x9D, 0x4A)
#define REG_SC_BK9D_4A_H      _PK_H_(0x9D, 0x4A)
#define REG_SC_BK9D_4B_L      _PK_L_(0x9D, 0x4B)
#define REG_SC_BK9D_4B_H      _PK_H_(0x9D, 0x4B)
#define REG_SC_BK9D_4C_L      _PK_L_(0x9D, 0x4C)
#define REG_SC_BK9D_4C_H      _PK_H_(0x9D, 0x4C)
#define REG_SC_BK9D_4D_L      _PK_L_(0x9D, 0x4D)
#define REG_SC_BK9D_4D_H      _PK_H_(0x9D, 0x4D)
#define REG_SC_BK9D_4E_L      _PK_L_(0x9D, 0x4E)
#define REG_SC_BK9D_4E_H      _PK_H_(0x9D, 0x4E)
#define REG_SC_BK9D_4F_L      _PK_L_(0x9D, 0x4F)
#define REG_SC_BK9D_4F_H      _PK_H_(0x9D, 0x4F)
#define REG_SC_BK9D_50_L      _PK_L_(0x9D, 0x50)
#define REG_SC_BK9D_50_H      _PK_H_(0x9D, 0x50)
#define REG_SC_BK9D_51_L      _PK_L_(0x9D, 0x51)
#define REG_SC_BK9D_51_H      _PK_H_(0x9D, 0x51)
#define REG_SC_BK9D_52_L      _PK_L_(0x9D, 0x52)
#define REG_SC_BK9D_52_H      _PK_H_(0x9D, 0x52)
#define REG_SC_BK9D_53_L      _PK_L_(0x9D, 0x53)
#define REG_SC_BK9D_53_H      _PK_H_(0x9D, 0x53)
#define REG_SC_BK9D_54_L      _PK_L_(0x9D, 0x54)
#define REG_SC_BK9D_54_H      _PK_H_(0x9D, 0x54)
#define REG_SC_BK9D_55_L      _PK_L_(0x9D, 0x55)
#define REG_SC_BK9D_55_H      _PK_H_(0x9D, 0x55)
#define REG_SC_BK9D_56_L      _PK_L_(0x9D, 0x56)
#define REG_SC_BK9D_56_H      _PK_H_(0x9D, 0x56)
#define REG_SC_BK9D_57_L      _PK_L_(0x9D, 0x57)
#define REG_SC_BK9D_57_H      _PK_H_(0x9D, 0x57)
#define REG_SC_BK9D_58_L      _PK_L_(0x9D, 0x58)
#define REG_SC_BK9D_58_H      _PK_H_(0x9D, 0x58)
#define REG_SC_BK9D_59_L      _PK_L_(0x9D, 0x59)
#define REG_SC_BK9D_59_H      _PK_H_(0x9D, 0x59)
#define REG_SC_BK9D_5A_L      _PK_L_(0x9D, 0x5A)
#define REG_SC_BK9D_5A_H      _PK_H_(0x9D, 0x5A)
#define REG_SC_BK9D_5B_L      _PK_L_(0x9D, 0x5B)
#define REG_SC_BK9D_5B_H      _PK_H_(0x9D, 0x5B)
#define REG_SC_BK9D_5C_L      _PK_L_(0x9D, 0x5C)
#define REG_SC_BK9D_5C_H      _PK_H_(0x9D, 0x5C)
#define REG_SC_BK9D_5D_L      _PK_L_(0x9D, 0x5D)
#define REG_SC_BK9D_5D_H      _PK_H_(0x9D, 0x5D)
#define REG_SC_BK9D_5E_L      _PK_L_(0x9D, 0x5E)
#define REG_SC_BK9D_5E_H      _PK_H_(0x9D, 0x5E)
#define REG_SC_BK9D_5F_L      _PK_L_(0x9D, 0x5F)
#define REG_SC_BK9D_5F_H      _PK_H_(0x9D, 0x5F)
#define REG_SC_BK9D_60_L      _PK_L_(0x9D, 0x60)
#define REG_SC_BK9D_60_H      _PK_H_(0x9D, 0x60)
#define REG_SC_BK9D_61_L      _PK_L_(0x9D, 0x61)
#define REG_SC_BK9D_61_H      _PK_H_(0x9D, 0x61)
#define REG_SC_BK9D_62_L      _PK_L_(0x9D, 0x62)
#define REG_SC_BK9D_62_H      _PK_H_(0x9D, 0x62)
#define REG_SC_BK9D_63_L      _PK_L_(0x9D, 0x63)
#define REG_SC_BK9D_63_H      _PK_H_(0x9D, 0x63)
#define REG_SC_BK9D_64_L      _PK_L_(0x9D, 0x64)
#define REG_SC_BK9D_64_H      _PK_H_(0x9D, 0x64)
#define REG_SC_BK9D_65_L      _PK_L_(0x9D, 0x65)
#define REG_SC_BK9D_65_H      _PK_H_(0x9D, 0x65)
#define REG_SC_BK9D_66_L      _PK_L_(0x9D, 0x66)
#define REG_SC_BK9D_66_H      _PK_H_(0x9D, 0x66)
#define REG_SC_BK9D_67_L      _PK_L_(0x9D, 0x67)
#define REG_SC_BK9D_67_H      _PK_H_(0x9D, 0x67)
#define REG_SC_BK9D_68_L      _PK_L_(0x9D, 0x68)
#define REG_SC_BK9D_68_H      _PK_H_(0x9D, 0x68)
#define REG_SC_BK9D_69_L      _PK_L_(0x9D, 0x69)
#define REG_SC_BK9D_69_H      _PK_H_(0x9D, 0x69)
#define REG_SC_BK9D_6A_L      _PK_L_(0x9D, 0x6A)
#define REG_SC_BK9D_6A_H      _PK_H_(0x9D, 0x6A)
#define REG_SC_BK9D_6B_L      _PK_L_(0x9D, 0x6B)
#define REG_SC_BK9D_6B_H      _PK_H_(0x9D, 0x6B)
#define REG_SC_BK9D_6C_L      _PK_L_(0x9D, 0x6C)
#define REG_SC_BK9D_6C_H      _PK_H_(0x9D, 0x6C)
#define REG_SC_BK9D_6D_L      _PK_L_(0x9D, 0x6D)
#define REG_SC_BK9D_6D_H      _PK_H_(0x9D, 0x6D)
#define REG_SC_BK9D_6E_L      _PK_L_(0x9D, 0x6E)
#define REG_SC_BK9D_6E_H      _PK_H_(0x9D, 0x6E)
#define REG_SC_BK9D_6F_L      _PK_L_(0x9D, 0x6F)
#define REG_SC_BK9D_6F_H      _PK_H_(0x9D, 0x6F)
#define REG_SC_BK9D_70_L      _PK_L_(0x9D, 0x70)
#define REG_SC_BK9D_70_H      _PK_H_(0x9D, 0x70)
#define REG_SC_BK9D_71_L      _PK_L_(0x9D, 0x71)
#define REG_SC_BK9D_71_H      _PK_H_(0x9D, 0x71)
#define REG_SC_BK9D_72_L      _PK_L_(0x9D, 0x72)
#define REG_SC_BK9D_72_H      _PK_H_(0x9D, 0x72)
#define REG_SC_BK9D_73_L      _PK_L_(0x9D, 0x73)
#define REG_SC_BK9D_73_H      _PK_H_(0x9D, 0x73)
#define REG_SC_BK9D_74_L      _PK_L_(0x9D, 0x74)
#define REG_SC_BK9D_74_H      _PK_H_(0x9D, 0x74)
#define REG_SC_BK9D_75_L      _PK_L_(0x9D, 0x75)
#define REG_SC_BK9D_75_H      _PK_H_(0x9D, 0x75)
#define REG_SC_BK9D_76_L      _PK_L_(0x9D, 0x76)
#define REG_SC_BK9D_76_H      _PK_H_(0x9D, 0x76)
#define REG_SC_BK9D_77_L      _PK_L_(0x9D, 0x77)
#define REG_SC_BK9D_77_H      _PK_H_(0x9D, 0x77)
#define REG_SC_BK9D_78_L      _PK_L_(0x9D, 0x78)
#define REG_SC_BK9D_78_H      _PK_H_(0x9D, 0x78)
#define REG_SC_BK9D_79_L      _PK_L_(0x9D, 0x79)
#define REG_SC_BK9D_79_H      _PK_H_(0x9D, 0x79)
#define REG_SC_BK9D_7A_L      _PK_L_(0x9D, 0x7A)
#define REG_SC_BK9D_7A_H      _PK_H_(0x9D, 0x7A)
#define REG_SC_BK9D_7B_L      _PK_L_(0x9D, 0x7B)
#define REG_SC_BK9D_7B_H      _PK_H_(0x9D, 0x7B)
#define REG_SC_BK9D_7C_L      _PK_L_(0x9D, 0x7C)
#define REG_SC_BK9D_7C_H      _PK_H_(0x9D, 0x7C)
#define REG_SC_BK9D_7D_L      _PK_L_(0x9D, 0x7D)
#define REG_SC_BK9D_7D_H      _PK_H_(0x9D, 0x7D)
#define REG_SC_BK9D_7E_L      _PK_L_(0x9D, 0x7E)
#define REG_SC_BK9D_7E_H      _PK_H_(0x9D, 0x7E)
#define REG_SC_BK9D_7F_L      _PK_L_(0x9D, 0x7F)
#define REG_SC_BK9D_7F_H      _PK_H_(0x9D, 0x7F)
//----------------------------------------------
#define REG_SC_BK9E_00_L      _PK_L_(0x9E, 0x00)
#define REG_SC_BK9E_00_H      _PK_H_(0x9E, 0x00)
#define REG_SC_BK9E_01_L      _PK_L_(0x9E, 0x01)
#define REG_SC_BK9E_01_H      _PK_H_(0x9E, 0x01)
#define REG_SC_BK9E_02_L      _PK_L_(0x9E, 0x02)
#define REG_SC_BK9E_02_H      _PK_H_(0x9E, 0x02)
#define REG_SC_BK9E_03_L      _PK_L_(0x9E, 0x03)
#define REG_SC_BK9E_03_H      _PK_H_(0x9E, 0x03)
#define REG_SC_BK9E_04_L      _PK_L_(0x9E, 0x04)
#define REG_SC_BK9E_04_H      _PK_H_(0x9E, 0x04)
#define REG_SC_BK9E_05_L      _PK_L_(0x9E, 0x05)
#define REG_SC_BK9E_05_H      _PK_H_(0x9E, 0x05)
#define REG_SC_BK9E_06_L      _PK_L_(0x9E, 0x06)
#define REG_SC_BK9E_06_H      _PK_H_(0x9E, 0x06)
#define REG_SC_BK9E_07_L      _PK_L_(0x9E, 0x07)
#define REG_SC_BK9E_07_H      _PK_H_(0x9E, 0x07)
#define REG_SC_BK9E_08_L      _PK_L_(0x9E, 0x08)
#define REG_SC_BK9E_08_H      _PK_H_(0x9E, 0x08)
#define REG_SC_BK9E_09_L      _PK_L_(0x9E, 0x09)
#define REG_SC_BK9E_09_H      _PK_H_(0x9E, 0x09)
#define REG_SC_BK9E_0A_L      _PK_L_(0x9E, 0x0A)
#define REG_SC_BK9E_0A_H      _PK_H_(0x9E, 0x0A)
#define REG_SC_BK9E_0B_L      _PK_L_(0x9E, 0x0B)
#define REG_SC_BK9E_0B_H      _PK_H_(0x9E, 0x0B)
#define REG_SC_BK9E_0C_L      _PK_L_(0x9E, 0x0C)
#define REG_SC_BK9E_0C_H      _PK_H_(0x9E, 0x0C)
#define REG_SC_BK9E_0D_L      _PK_L_(0x9E, 0x0D)
#define REG_SC_BK9E_0D_H      _PK_H_(0x9E, 0x0D)
#define REG_SC_BK9E_0E_L      _PK_L_(0x9E, 0x0E)
#define REG_SC_BK9E_0E_H      _PK_H_(0x9E, 0x0E)
#define REG_SC_BK9E_0F_L      _PK_L_(0x9E, 0x0F)
#define REG_SC_BK9E_0F_H      _PK_H_(0x9E, 0x0F)
#define REG_SC_BK9E_10_L      _PK_L_(0x9E, 0x10)
#define REG_SC_BK9E_10_H      _PK_H_(0x9E, 0x10)
#define REG_SC_BK9E_11_L      _PK_L_(0x9E, 0x11)
#define REG_SC_BK9E_11_H      _PK_H_(0x9E, 0x11)
#define REG_SC_BK9E_12_L      _PK_L_(0x9E, 0x12)
#define REG_SC_BK9E_12_H      _PK_H_(0x9E, 0x12)
#define REG_SC_BK9E_13_L      _PK_L_(0x9E, 0x13)
#define REG_SC_BK9E_13_H      _PK_H_(0x9E, 0x13)
#define REG_SC_BK9E_14_L      _PK_L_(0x9E, 0x14)
#define REG_SC_BK9E_14_H      _PK_H_(0x9E, 0x14)
#define REG_SC_BK9E_15_L      _PK_L_(0x9E, 0x15)
#define REG_SC_BK9E_15_H      _PK_H_(0x9E, 0x15)
#define REG_SC_BK9E_16_L      _PK_L_(0x9E, 0x16)
#define REG_SC_BK9E_16_H      _PK_H_(0x9E, 0x16)
#define REG_SC_BK9E_17_L      _PK_L_(0x9E, 0x17)
#define REG_SC_BK9E_17_H      _PK_H_(0x9E, 0x17)
#define REG_SC_BK9E_18_L      _PK_L_(0x9E, 0x18)
#define REG_SC_BK9E_18_H      _PK_H_(0x9E, 0x18)
#define REG_SC_BK9E_19_L      _PK_L_(0x9E, 0x19)
#define REG_SC_BK9E_19_H      _PK_H_(0x9E, 0x19)
#define REG_SC_BK9E_1A_L      _PK_L_(0x9E, 0x1A)
#define REG_SC_BK9E_1A_H      _PK_H_(0x9E, 0x1A)
#define REG_SC_BK9E_1B_L      _PK_L_(0x9E, 0x1B)
#define REG_SC_BK9E_1B_H      _PK_H_(0x9E, 0x1B)
#define REG_SC_BK9E_1C_L      _PK_L_(0x9E, 0x1C)
#define REG_SC_BK9E_1C_H      _PK_H_(0x9E, 0x1C)
#define REG_SC_BK9E_1D_L      _PK_L_(0x9E, 0x1D)
#define REG_SC_BK9E_1D_H      _PK_H_(0x9E, 0x1D)
#define REG_SC_BK9E_1E_L      _PK_L_(0x9E, 0x1E)
#define REG_SC_BK9E_1E_H      _PK_H_(0x9E, 0x1E)
#define REG_SC_BK9E_1F_L      _PK_L_(0x9E, 0x1F)
#define REG_SC_BK9E_1F_H      _PK_H_(0x9E, 0x1F)
#define REG_SC_BK9E_20_L      _PK_L_(0x9E, 0x20)
#define REG_SC_BK9E_20_H      _PK_H_(0x9E, 0x20)
#define REG_SC_BK9E_21_L      _PK_L_(0x9E, 0x21)
#define REG_SC_BK9E_21_H      _PK_H_(0x9E, 0x21)
#define REG_SC_BK9E_22_L      _PK_L_(0x9E, 0x22)
#define REG_SC_BK9E_22_H      _PK_H_(0x9E, 0x22)
#define REG_SC_BK9E_23_L      _PK_L_(0x9E, 0x23)
#define REG_SC_BK9E_23_H      _PK_H_(0x9E, 0x23)
#define REG_SC_BK9E_24_L      _PK_L_(0x9E, 0x24)
#define REG_SC_BK9E_24_H      _PK_H_(0x9E, 0x24)
#define REG_SC_BK9E_25_L      _PK_L_(0x9E, 0x25)
#define REG_SC_BK9E_25_H      _PK_H_(0x9E, 0x25)
#define REG_SC_BK9E_26_L      _PK_L_(0x9E, 0x26)
#define REG_SC_BK9E_26_H      _PK_H_(0x9E, 0x26)
#define REG_SC_BK9E_27_L      _PK_L_(0x9E, 0x27)
#define REG_SC_BK9E_27_H      _PK_H_(0x9E, 0x27)
#define REG_SC_BK9E_28_L      _PK_L_(0x9E, 0x28)
#define REG_SC_BK9E_28_H      _PK_H_(0x9E, 0x28)
#define REG_SC_BK9E_29_L      _PK_L_(0x9E, 0x29)
#define REG_SC_BK9E_29_H      _PK_H_(0x9E, 0x29)
#define REG_SC_BK9E_2A_L      _PK_L_(0x9E, 0x2A)
#define REG_SC_BK9E_2A_H      _PK_H_(0x9E, 0x2A)
#define REG_SC_BK9E_2B_L      _PK_L_(0x9E, 0x2B)
#define REG_SC_BK9E_2B_H      _PK_H_(0x9E, 0x2B)
#define REG_SC_BK9E_2C_L      _PK_L_(0x9E, 0x2C)
#define REG_SC_BK9E_2C_H      _PK_H_(0x9E, 0x2C)
#define REG_SC_BK9E_2D_L      _PK_L_(0x9E, 0x2D)
#define REG_SC_BK9E_2D_H      _PK_H_(0x9E, 0x2D)
#define REG_SC_BK9E_2E_L      _PK_L_(0x9E, 0x2E)
#define REG_SC_BK9E_2E_H      _PK_H_(0x9E, 0x2E)
#define REG_SC_BK9E_2F_L      _PK_L_(0x9E, 0x2F)
#define REG_SC_BK9E_2F_H      _PK_H_(0x9E, 0x2F)
#define REG_SC_BK9E_30_L      _PK_L_(0x9E, 0x30)
#define REG_SC_BK9E_30_H      _PK_H_(0x9E, 0x30)
#define REG_SC_BK9E_31_L      _PK_L_(0x9E, 0x31)
#define REG_SC_BK9E_31_H      _PK_H_(0x9E, 0x31)
#define REG_SC_BK9E_32_L      _PK_L_(0x9E, 0x32)
#define REG_SC_BK9E_32_H      _PK_H_(0x9E, 0x32)
#define REG_SC_BK9E_33_L      _PK_L_(0x9E, 0x33)
#define REG_SC_BK9E_33_H      _PK_H_(0x9E, 0x33)
#define REG_SC_BK9E_34_L      _PK_L_(0x9E, 0x34)
#define REG_SC_BK9E_34_H      _PK_H_(0x9E, 0x34)
#define REG_SC_BK9E_35_L      _PK_L_(0x9E, 0x35)
#define REG_SC_BK9E_35_H      _PK_H_(0x9E, 0x35)
#define REG_SC_BK9E_36_L      _PK_L_(0x9E, 0x36)
#define REG_SC_BK9E_36_H      _PK_H_(0x9E, 0x36)
#define REG_SC_BK9E_37_L      _PK_L_(0x9E, 0x37)
#define REG_SC_BK9E_37_H      _PK_H_(0x9E, 0x37)
#define REG_SC_BK9E_38_L      _PK_L_(0x9E, 0x38)
#define REG_SC_BK9E_38_H      _PK_H_(0x9E, 0x38)
#define REG_SC_BK9E_39_L      _PK_L_(0x9E, 0x39)
#define REG_SC_BK9E_39_H      _PK_H_(0x9E, 0x39)
#define REG_SC_BK9E_3A_L      _PK_L_(0x9E, 0x3A)
#define REG_SC_BK9E_3A_H      _PK_H_(0x9E, 0x3A)
#define REG_SC_BK9E_3B_L      _PK_L_(0x9E, 0x3B)
#define REG_SC_BK9E_3B_H      _PK_H_(0x9E, 0x3B)
#define REG_SC_BK9E_3C_L      _PK_L_(0x9E, 0x3C)
#define REG_SC_BK9E_3C_H      _PK_H_(0x9E, 0x3C)
#define REG_SC_BK9E_3D_L      _PK_L_(0x9E, 0x3D)
#define REG_SC_BK9E_3D_H      _PK_H_(0x9E, 0x3D)
#define REG_SC_BK9E_3E_L      _PK_L_(0x9E, 0x3E)
#define REG_SC_BK9E_3E_H      _PK_H_(0x9E, 0x3E)
#define REG_SC_BK9E_3F_L      _PK_L_(0x9E, 0x3F)
#define REG_SC_BK9E_3F_H      _PK_H_(0x9E, 0x3F)
#define REG_SC_BK9E_40_L      _PK_L_(0x9E, 0x40)
#define REG_SC_BK9E_40_H      _PK_H_(0x9E, 0x40)
#define REG_SC_BK9E_41_L      _PK_L_(0x9E, 0x41)
#define REG_SC_BK9E_41_H      _PK_H_(0x9E, 0x41)
#define REG_SC_BK9E_42_L      _PK_L_(0x9E, 0x42)
#define REG_SC_BK9E_42_H      _PK_H_(0x9E, 0x42)
#define REG_SC_BK9E_43_L      _PK_L_(0x9E, 0x43)
#define REG_SC_BK9E_43_H      _PK_H_(0x9E, 0x43)
#define REG_SC_BK9E_44_L      _PK_L_(0x9E, 0x44)
#define REG_SC_BK9E_44_H      _PK_H_(0x9E, 0x44)
#define REG_SC_BK9E_45_L      _PK_L_(0x9E, 0x45)
#define REG_SC_BK9E_45_H      _PK_H_(0x9E, 0x45)
#define REG_SC_BK9E_46_L      _PK_L_(0x9E, 0x46)
#define REG_SC_BK9E_46_H      _PK_H_(0x9E, 0x46)
#define REG_SC_BK9E_47_L      _PK_L_(0x9E, 0x47)
#define REG_SC_BK9E_47_H      _PK_H_(0x9E, 0x47)
#define REG_SC_BK9E_48_L      _PK_L_(0x9E, 0x48)
#define REG_SC_BK9E_48_H      _PK_H_(0x9E, 0x48)
#define REG_SC_BK9E_49_L      _PK_L_(0x9E, 0x49)
#define REG_SC_BK9E_49_H      _PK_H_(0x9E, 0x49)
#define REG_SC_BK9E_4A_L      _PK_L_(0x9E, 0x4A)
#define REG_SC_BK9E_4A_H      _PK_H_(0x9E, 0x4A)
#define REG_SC_BK9E_4B_L      _PK_L_(0x9E, 0x4B)
#define REG_SC_BK9E_4B_H      _PK_H_(0x9E, 0x4B)
#define REG_SC_BK9E_4C_L      _PK_L_(0x9E, 0x4C)
#define REG_SC_BK9E_4C_H      _PK_H_(0x9E, 0x4C)
#define REG_SC_BK9E_4D_L      _PK_L_(0x9E, 0x4D)
#define REG_SC_BK9E_4D_H      _PK_H_(0x9E, 0x4D)
#define REG_SC_BK9E_4E_L      _PK_L_(0x9E, 0x4E)
#define REG_SC_BK9E_4E_H      _PK_H_(0x9E, 0x4E)
#define REG_SC_BK9E_4F_L      _PK_L_(0x9E, 0x4F)
#define REG_SC_BK9E_4F_H      _PK_H_(0x9E, 0x4F)
#define REG_SC_BK9E_50_L      _PK_L_(0x9E, 0x50)
#define REG_SC_BK9E_50_H      _PK_H_(0x9E, 0x50)
#define REG_SC_BK9E_51_L      _PK_L_(0x9E, 0x51)
#define REG_SC_BK9E_51_H      _PK_H_(0x9E, 0x51)
#define REG_SC_BK9E_52_L      _PK_L_(0x9E, 0x52)
#define REG_SC_BK9E_52_H      _PK_H_(0x9E, 0x52)
#define REG_SC_BK9E_53_L      _PK_L_(0x9E, 0x53)
#define REG_SC_BK9E_53_H      _PK_H_(0x9E, 0x53)
#define REG_SC_BK9E_54_L      _PK_L_(0x9E, 0x54)
#define REG_SC_BK9E_54_H      _PK_H_(0x9E, 0x54)
#define REG_SC_BK9E_55_L      _PK_L_(0x9E, 0x55)
#define REG_SC_BK9E_55_H      _PK_H_(0x9E, 0x55)
#define REG_SC_BK9E_56_L      _PK_L_(0x9E, 0x56)
#define REG_SC_BK9E_56_H      _PK_H_(0x9E, 0x56)
#define REG_SC_BK9E_57_L      _PK_L_(0x9E, 0x57)
#define REG_SC_BK9E_57_H      _PK_H_(0x9E, 0x57)
#define REG_SC_BK9E_58_L      _PK_L_(0x9E, 0x58)
#define REG_SC_BK9E_58_H      _PK_H_(0x9E, 0x58)
#define REG_SC_BK9E_59_L      _PK_L_(0x9E, 0x59)
#define REG_SC_BK9E_59_H      _PK_H_(0x9E, 0x59)
#define REG_SC_BK9E_5A_L      _PK_L_(0x9E, 0x5A)
#define REG_SC_BK9E_5A_H      _PK_H_(0x9E, 0x5A)
#define REG_SC_BK9E_5B_L      _PK_L_(0x9E, 0x5B)
#define REG_SC_BK9E_5B_H      _PK_H_(0x9E, 0x5B)
#define REG_SC_BK9E_5C_L      _PK_L_(0x9E, 0x5C)
#define REG_SC_BK9E_5C_H      _PK_H_(0x9E, 0x5C)
#define REG_SC_BK9E_5D_L      _PK_L_(0x9E, 0x5D)
#define REG_SC_BK9E_5D_H      _PK_H_(0x9E, 0x5D)
#define REG_SC_BK9E_5E_L      _PK_L_(0x9E, 0x5E)
#define REG_SC_BK9E_5E_H      _PK_H_(0x9E, 0x5E)
#define REG_SC_BK9E_5F_L      _PK_L_(0x9E, 0x5F)
#define REG_SC_BK9E_5F_H      _PK_H_(0x9E, 0x5F)
#define REG_SC_BK9E_60_L      _PK_L_(0x9E, 0x60)
#define REG_SC_BK9E_60_H      _PK_H_(0x9E, 0x60)
#define REG_SC_BK9E_61_L      _PK_L_(0x9E, 0x61)
#define REG_SC_BK9E_61_H      _PK_H_(0x9E, 0x61)
#define REG_SC_BK9E_62_L      _PK_L_(0x9E, 0x62)
#define REG_SC_BK9E_62_H      _PK_H_(0x9E, 0x62)
#define REG_SC_BK9E_63_L      _PK_L_(0x9E, 0x63)
#define REG_SC_BK9E_63_H      _PK_H_(0x9E, 0x63)
#define REG_SC_BK9E_64_L      _PK_L_(0x9E, 0x64)
#define REG_SC_BK9E_64_H      _PK_H_(0x9E, 0x64)
#define REG_SC_BK9E_65_L      _PK_L_(0x9E, 0x65)
#define REG_SC_BK9E_65_H      _PK_H_(0x9E, 0x65)
#define REG_SC_BK9E_66_L      _PK_L_(0x9E, 0x66)
#define REG_SC_BK9E_66_H      _PK_H_(0x9E, 0x66)
#define REG_SC_BK9E_67_L      _PK_L_(0x9E, 0x67)
#define REG_SC_BK9E_67_H      _PK_H_(0x9E, 0x67)
#define REG_SC_BK9E_68_L      _PK_L_(0x9E, 0x68)
#define REG_SC_BK9E_68_H      _PK_H_(0x9E, 0x68)
#define REG_SC_BK9E_69_L      _PK_L_(0x9E, 0x69)
#define REG_SC_BK9E_69_H      _PK_H_(0x9E, 0x69)
#define REG_SC_BK9E_6A_L      _PK_L_(0x9E, 0x6A)
#define REG_SC_BK9E_6A_H      _PK_H_(0x9E, 0x6A)
#define REG_SC_BK9E_6B_L      _PK_L_(0x9E, 0x6B)
#define REG_SC_BK9E_6B_H      _PK_H_(0x9E, 0x6B)
#define REG_SC_BK9E_6C_L      _PK_L_(0x9E, 0x6C)
#define REG_SC_BK9E_6C_H      _PK_H_(0x9E, 0x6C)
#define REG_SC_BK9E_6D_L      _PK_L_(0x9E, 0x6D)
#define REG_SC_BK9E_6D_H      _PK_H_(0x9E, 0x6D)
#define REG_SC_BK9E_6E_L      _PK_L_(0x9E, 0x6E)
#define REG_SC_BK9E_6E_H      _PK_H_(0x9E, 0x6E)
#define REG_SC_BK9E_6F_L      _PK_L_(0x9E, 0x6F)
#define REG_SC_BK9E_6F_H      _PK_H_(0x9E, 0x6F)
#define REG_SC_BK9E_70_L      _PK_L_(0x9E, 0x70)
#define REG_SC_BK9E_70_H      _PK_H_(0x9E, 0x70)
#define REG_SC_BK9E_71_L      _PK_L_(0x9E, 0x71)
#define REG_SC_BK9E_71_H      _PK_H_(0x9E, 0x71)
#define REG_SC_BK9E_72_L      _PK_L_(0x9E, 0x72)
#define REG_SC_BK9E_72_H      _PK_H_(0x9E, 0x72)
#define REG_SC_BK9E_73_L      _PK_L_(0x9E, 0x73)
#define REG_SC_BK9E_73_H      _PK_H_(0x9E, 0x73)
#define REG_SC_BK9E_74_L      _PK_L_(0x9E, 0x74)
#define REG_SC_BK9E_74_H      _PK_H_(0x9E, 0x74)
#define REG_SC_BK9E_75_L      _PK_L_(0x9E, 0x75)
#define REG_SC_BK9E_75_H      _PK_H_(0x9E, 0x75)
#define REG_SC_BK9E_76_L      _PK_L_(0x9E, 0x76)
#define REG_SC_BK9E_76_H      _PK_H_(0x9E, 0x76)
#define REG_SC_BK9E_77_L      _PK_L_(0x9E, 0x77)
#define REG_SC_BK9E_77_H      _PK_H_(0x9E, 0x77)
#define REG_SC_BK9E_78_L      _PK_L_(0x9E, 0x78)
#define REG_SC_BK9E_78_H      _PK_H_(0x9E, 0x78)
#define REG_SC_BK9E_79_L      _PK_L_(0x9E, 0x79)
#define REG_SC_BK9E_79_H      _PK_H_(0x9E, 0x79)
#define REG_SC_BK9E_7A_L      _PK_L_(0x9E, 0x7A)
#define REG_SC_BK9E_7A_H      _PK_H_(0x9E, 0x7A)
#define REG_SC_BK9E_7B_L      _PK_L_(0x9E, 0x7B)
#define REG_SC_BK9E_7B_H      _PK_H_(0x9E, 0x7B)
#define REG_SC_BK9E_7C_L      _PK_L_(0x9E, 0x7C)
#define REG_SC_BK9E_7C_H      _PK_H_(0x9E, 0x7C)
#define REG_SC_BK9E_7D_L      _PK_L_(0x9E, 0x7D)
#define REG_SC_BK9E_7D_H      _PK_H_(0x9E, 0x7D)
#define REG_SC_BK9E_7E_L      _PK_L_(0x9E, 0x7E)
#define REG_SC_BK9E_7E_H      _PK_H_(0x9E, 0x7E)
#define REG_SC_BK9E_7F_L      _PK_L_(0x9E, 0x7F)
#define REG_SC_BK9E_7F_H      _PK_H_(0x9E, 0x7F)
//----------------------------------------------
#define REG_SC_BK9F_00_L      _PK_L_(0x9F, 0x00)
#define REG_SC_BK9F_00_H      _PK_H_(0x9F, 0x00)
#define REG_SC_BK9F_01_L      _PK_L_(0x9F, 0x01)
#define REG_SC_BK9F_01_H      _PK_H_(0x9F, 0x01)
#define REG_SC_BK9F_02_L      _PK_L_(0x9F, 0x02)
#define REG_SC_BK9F_02_H      _PK_H_(0x9F, 0x02)
#define REG_SC_BK9F_03_L      _PK_L_(0x9F, 0x03)
#define REG_SC_BK9F_03_H      _PK_H_(0x9F, 0x03)
#define REG_SC_BK9F_04_L      _PK_L_(0x9F, 0x04)
#define REG_SC_BK9F_04_H      _PK_H_(0x9F, 0x04)
#define REG_SC_BK9F_05_L      _PK_L_(0x9F, 0x05)
#define REG_SC_BK9F_05_H      _PK_H_(0x9F, 0x05)
#define REG_SC_BK9F_06_L      _PK_L_(0x9F, 0x06)
#define REG_SC_BK9F_06_H      _PK_H_(0x9F, 0x06)
#define REG_SC_BK9F_07_L      _PK_L_(0x9F, 0x07)
#define REG_SC_BK9F_07_H      _PK_H_(0x9F, 0x07)
#define REG_SC_BK9F_08_L      _PK_L_(0x9F, 0x08)
#define REG_SC_BK9F_08_H      _PK_H_(0x9F, 0x08)
#define REG_SC_BK9F_09_L      _PK_L_(0x9F, 0x09)
#define REG_SC_BK9F_09_H      _PK_H_(0x9F, 0x09)
#define REG_SC_BK9F_0A_L      _PK_L_(0x9F, 0x0A)
#define REG_SC_BK9F_0A_H      _PK_H_(0x9F, 0x0A)
#define REG_SC_BK9F_0B_L      _PK_L_(0x9F, 0x0B)
#define REG_SC_BK9F_0B_H      _PK_H_(0x9F, 0x0B)
#define REG_SC_BK9F_0C_L      _PK_L_(0x9F, 0x0C)
#define REG_SC_BK9F_0C_H      _PK_H_(0x9F, 0x0C)
#define REG_SC_BK9F_0D_L      _PK_L_(0x9F, 0x0D)
#define REG_SC_BK9F_0D_H      _PK_H_(0x9F, 0x0D)
#define REG_SC_BK9F_0E_L      _PK_L_(0x9F, 0x0E)
#define REG_SC_BK9F_0E_H      _PK_H_(0x9F, 0x0E)
#define REG_SC_BK9F_0F_L      _PK_L_(0x9F, 0x0F)
#define REG_SC_BK9F_0F_H      _PK_H_(0x9F, 0x0F)
#define REG_SC_BK9F_10_L      _PK_L_(0x9F, 0x10)
#define REG_SC_BK9F_10_H      _PK_H_(0x9F, 0x10)
#define REG_SC_BK9F_11_L      _PK_L_(0x9F, 0x11)
#define REG_SC_BK9F_11_H      _PK_H_(0x9F, 0x11)
#define REG_SC_BK9F_12_L      _PK_L_(0x9F, 0x12)
#define REG_SC_BK9F_12_H      _PK_H_(0x9F, 0x12)
#define REG_SC_BK9F_13_L      _PK_L_(0x9F, 0x13)
#define REG_SC_BK9F_13_H      _PK_H_(0x9F, 0x13)
#define REG_SC_BK9F_14_L      _PK_L_(0x9F, 0x14)
#define REG_SC_BK9F_14_H      _PK_H_(0x9F, 0x14)
#define REG_SC_BK9F_15_L      _PK_L_(0x9F, 0x15)
#define REG_SC_BK9F_15_H      _PK_H_(0x9F, 0x15)
#define REG_SC_BK9F_16_L      _PK_L_(0x9F, 0x16)
#define REG_SC_BK9F_16_H      _PK_H_(0x9F, 0x16)
#define REG_SC_BK9F_17_L      _PK_L_(0x9F, 0x17)
#define REG_SC_BK9F_17_H      _PK_H_(0x9F, 0x17)
#define REG_SC_BK9F_18_L      _PK_L_(0x9F, 0x18)
#define REG_SC_BK9F_18_H      _PK_H_(0x9F, 0x18)
#define REG_SC_BK9F_19_L      _PK_L_(0x9F, 0x19)
#define REG_SC_BK9F_19_H      _PK_H_(0x9F, 0x19)
#define REG_SC_BK9F_1A_L      _PK_L_(0x9F, 0x1A)
#define REG_SC_BK9F_1A_H      _PK_H_(0x9F, 0x1A)
#define REG_SC_BK9F_1B_L      _PK_L_(0x9F, 0x1B)
#define REG_SC_BK9F_1B_H      _PK_H_(0x9F, 0x1B)
#define REG_SC_BK9F_1C_L      _PK_L_(0x9F, 0x1C)
#define REG_SC_BK9F_1C_H      _PK_H_(0x9F, 0x1C)
#define REG_SC_BK9F_1D_L      _PK_L_(0x9F, 0x1D)
#define REG_SC_BK9F_1D_H      _PK_H_(0x9F, 0x1D)
#define REG_SC_BK9F_1E_L      _PK_L_(0x9F, 0x1E)
#define REG_SC_BK9F_1E_H      _PK_H_(0x9F, 0x1E)
#define REG_SC_BK9F_1F_L      _PK_L_(0x9F, 0x1F)
#define REG_SC_BK9F_1F_H      _PK_H_(0x9F, 0x1F)
#define REG_SC_BK9F_20_L      _PK_L_(0x9F, 0x20)
#define REG_SC_BK9F_20_H      _PK_H_(0x9F, 0x20)
#define REG_SC_BK9F_21_L      _PK_L_(0x9F, 0x21)
#define REG_SC_BK9F_21_H      _PK_H_(0x9F, 0x21)
#define REG_SC_BK9F_22_L      _PK_L_(0x9F, 0x22)
#define REG_SC_BK9F_22_H      _PK_H_(0x9F, 0x22)
#define REG_SC_BK9F_23_L      _PK_L_(0x9F, 0x23)
#define REG_SC_BK9F_23_H      _PK_H_(0x9F, 0x23)
#define REG_SC_BK9F_24_L      _PK_L_(0x9F, 0x24)
#define REG_SC_BK9F_24_H      _PK_H_(0x9F, 0x24)
#define REG_SC_BK9F_25_L      _PK_L_(0x9F, 0x25)
#define REG_SC_BK9F_25_H      _PK_H_(0x9F, 0x25)
#define REG_SC_BK9F_26_L      _PK_L_(0x9F, 0x26)
#define REG_SC_BK9F_26_H      _PK_H_(0x9F, 0x26)
#define REG_SC_BK9F_27_L      _PK_L_(0x9F, 0x27)
#define REG_SC_BK9F_27_H      _PK_H_(0x9F, 0x27)
#define REG_SC_BK9F_28_L      _PK_L_(0x9F, 0x28)
#define REG_SC_BK9F_28_H      _PK_H_(0x9F, 0x28)
#define REG_SC_BK9F_29_L      _PK_L_(0x9F, 0x29)
#define REG_SC_BK9F_29_H      _PK_H_(0x9F, 0x29)
#define REG_SC_BK9F_2A_L      _PK_L_(0x9F, 0x2A)
#define REG_SC_BK9F_2A_H      _PK_H_(0x9F, 0x2A)
#define REG_SC_BK9F_2B_L      _PK_L_(0x9F, 0x2B)
#define REG_SC_BK9F_2B_H      _PK_H_(0x9F, 0x2B)
#define REG_SC_BK9F_2C_L      _PK_L_(0x9F, 0x2C)
#define REG_SC_BK9F_2C_H      _PK_H_(0x9F, 0x2C)
#define REG_SC_BK9F_2D_L      _PK_L_(0x9F, 0x2D)
#define REG_SC_BK9F_2D_H      _PK_H_(0x9F, 0x2D)
#define REG_SC_BK9F_2E_L      _PK_L_(0x9F, 0x2E)
#define REG_SC_BK9F_2E_H      _PK_H_(0x9F, 0x2E)
#define REG_SC_BK9F_2F_L      _PK_L_(0x9F, 0x2F)
#define REG_SC_BK9F_2F_H      _PK_H_(0x9F, 0x2F)
#define REG_SC_BK9F_30_L      _PK_L_(0x9F, 0x30)
#define REG_SC_BK9F_30_H      _PK_H_(0x9F, 0x30)
#define REG_SC_BK9F_31_L      _PK_L_(0x9F, 0x31)
#define REG_SC_BK9F_31_H      _PK_H_(0x9F, 0x31)
#define REG_SC_BK9F_32_L      _PK_L_(0x9F, 0x32)
#define REG_SC_BK9F_32_H      _PK_H_(0x9F, 0x32)
#define REG_SC_BK9F_33_L      _PK_L_(0x9F, 0x33)
#define REG_SC_BK9F_33_H      _PK_H_(0x9F, 0x33)
#define REG_SC_BK9F_34_L      _PK_L_(0x9F, 0x34)
#define REG_SC_BK9F_34_H      _PK_H_(0x9F, 0x34)
#define REG_SC_BK9F_35_L      _PK_L_(0x9F, 0x35)
#define REG_SC_BK9F_35_H      _PK_H_(0x9F, 0x35)
#define REG_SC_BK9F_36_L      _PK_L_(0x9F, 0x36)
#define REG_SC_BK9F_36_H      _PK_H_(0x9F, 0x36)
#define REG_SC_BK9F_37_L      _PK_L_(0x9F, 0x37)
#define REG_SC_BK9F_37_H      _PK_H_(0x9F, 0x37)
#define REG_SC_BK9F_38_L      _PK_L_(0x9F, 0x38)
#define REG_SC_BK9F_38_H      _PK_H_(0x9F, 0x38)
#define REG_SC_BK9F_39_L      _PK_L_(0x9F, 0x39)
#define REG_SC_BK9F_39_H      _PK_H_(0x9F, 0x39)
#define REG_SC_BK9F_3A_L      _PK_L_(0x9F, 0x3A)
#define REG_SC_BK9F_3A_H      _PK_H_(0x9F, 0x3A)
#define REG_SC_BK9F_3B_L      _PK_L_(0x9F, 0x3B)
#define REG_SC_BK9F_3B_H      _PK_H_(0x9F, 0x3B)
#define REG_SC_BK9F_3C_L      _PK_L_(0x9F, 0x3C)
#define REG_SC_BK9F_3C_H      _PK_H_(0x9F, 0x3C)
#define REG_SC_BK9F_3D_L      _PK_L_(0x9F, 0x3D)
#define REG_SC_BK9F_3D_H      _PK_H_(0x9F, 0x3D)
#define REG_SC_BK9F_3E_L      _PK_L_(0x9F, 0x3E)
#define REG_SC_BK9F_3E_H      _PK_H_(0x9F, 0x3E)
#define REG_SC_BK9F_3F_L      _PK_L_(0x9F, 0x3F)
#define REG_SC_BK9F_3F_H      _PK_H_(0x9F, 0x3F)
#define REG_SC_BK9F_40_L      _PK_L_(0x9F, 0x40)
#define REG_SC_BK9F_40_H      _PK_H_(0x9F, 0x40)
#define REG_SC_BK9F_41_L      _PK_L_(0x9F, 0x41)
#define REG_SC_BK9F_41_H      _PK_H_(0x9F, 0x41)
#define REG_SC_BK9F_42_L      _PK_L_(0x9F, 0x42)
#define REG_SC_BK9F_42_H      _PK_H_(0x9F, 0x42)
#define REG_SC_BK9F_43_L      _PK_L_(0x9F, 0x43)
#define REG_SC_BK9F_43_H      _PK_H_(0x9F, 0x43)
#define REG_SC_BK9F_44_L      _PK_L_(0x9F, 0x44)
#define REG_SC_BK9F_44_H      _PK_H_(0x9F, 0x44)
#define REG_SC_BK9F_45_L      _PK_L_(0x9F, 0x45)
#define REG_SC_BK9F_45_H      _PK_H_(0x9F, 0x45)
#define REG_SC_BK9F_46_L      _PK_L_(0x9F, 0x46)
#define REG_SC_BK9F_46_H      _PK_H_(0x9F, 0x46)
#define REG_SC_BK9F_47_L      _PK_L_(0x9F, 0x47)
#define REG_SC_BK9F_47_H      _PK_H_(0x9F, 0x47)
#define REG_SC_BK9F_48_L      _PK_L_(0x9F, 0x48)
#define REG_SC_BK9F_48_H      _PK_H_(0x9F, 0x48)
#define REG_SC_BK9F_49_L      _PK_L_(0x9F, 0x49)
#define REG_SC_BK9F_49_H      _PK_H_(0x9F, 0x49)
#define REG_SC_BK9F_4A_L      _PK_L_(0x9F, 0x4A)
#define REG_SC_BK9F_4A_H      _PK_H_(0x9F, 0x4A)
#define REG_SC_BK9F_4B_L      _PK_L_(0x9F, 0x4B)
#define REG_SC_BK9F_4B_H      _PK_H_(0x9F, 0x4B)
#define REG_SC_BK9F_4C_L      _PK_L_(0x9F, 0x4C)
#define REG_SC_BK9F_4C_H      _PK_H_(0x9F, 0x4C)
#define REG_SC_BK9F_4D_L      _PK_L_(0x9F, 0x4D)
#define REG_SC_BK9F_4D_H      _PK_H_(0x9F, 0x4D)
#define REG_SC_BK9F_4E_L      _PK_L_(0x9F, 0x4E)
#define REG_SC_BK9F_4E_H      _PK_H_(0x9F, 0x4E)
#define REG_SC_BK9F_4F_L      _PK_L_(0x9F, 0x4F)
#define REG_SC_BK9F_4F_H      _PK_H_(0x9F, 0x4F)
#define REG_SC_BK9F_50_L      _PK_L_(0x9F, 0x50)
#define REG_SC_BK9F_50_H      _PK_H_(0x9F, 0x50)
#define REG_SC_BK9F_51_L      _PK_L_(0x9F, 0x51)
#define REG_SC_BK9F_51_H      _PK_H_(0x9F, 0x51)
#define REG_SC_BK9F_52_L      _PK_L_(0x9F, 0x52)
#define REG_SC_BK9F_52_H      _PK_H_(0x9F, 0x52)
#define REG_SC_BK9F_53_L      _PK_L_(0x9F, 0x53)
#define REG_SC_BK9F_53_H      _PK_H_(0x9F, 0x53)
#define REG_SC_BK9F_54_L      _PK_L_(0x9F, 0x54)
#define REG_SC_BK9F_54_H      _PK_H_(0x9F, 0x54)
#define REG_SC_BK9F_55_L      _PK_L_(0x9F, 0x55)
#define REG_SC_BK9F_55_H      _PK_H_(0x9F, 0x55)
#define REG_SC_BK9F_56_L      _PK_L_(0x9F, 0x56)
#define REG_SC_BK9F_56_H      _PK_H_(0x9F, 0x56)
#define REG_SC_BK9F_57_L      _PK_L_(0x9F, 0x57)
#define REG_SC_BK9F_57_H      _PK_H_(0x9F, 0x57)
#define REG_SC_BK9F_58_L      _PK_L_(0x9F, 0x58)
#define REG_SC_BK9F_58_H      _PK_H_(0x9F, 0x58)
#define REG_SC_BK9F_59_L      _PK_L_(0x9F, 0x59)
#define REG_SC_BK9F_59_H      _PK_H_(0x9F, 0x59)
#define REG_SC_BK9F_5A_L      _PK_L_(0x9F, 0x5A)
#define REG_SC_BK9F_5A_H      _PK_H_(0x9F, 0x5A)
#define REG_SC_BK9F_5B_L      _PK_L_(0x9F, 0x5B)
#define REG_SC_BK9F_5B_H      _PK_H_(0x9F, 0x5B)
#define REG_SC_BK9F_5C_L      _PK_L_(0x9F, 0x5C)
#define REG_SC_BK9F_5C_H      _PK_H_(0x9F, 0x5C)
#define REG_SC_BK9F_5D_L      _PK_L_(0x9F, 0x5D)
#define REG_SC_BK9F_5D_H      _PK_H_(0x9F, 0x5D)
#define REG_SC_BK9F_5E_L      _PK_L_(0x9F, 0x5E)
#define REG_SC_BK9F_5E_H      _PK_H_(0x9F, 0x5E)
#define REG_SC_BK9F_5F_L      _PK_L_(0x9F, 0x5F)
#define REG_SC_BK9F_5F_H      _PK_H_(0x9F, 0x5F)
#define REG_SC_BK9F_60_L      _PK_L_(0x9F, 0x60)
#define REG_SC_BK9F_60_H      _PK_H_(0x9F, 0x60)
#define REG_SC_BK9F_61_L      _PK_L_(0x9F, 0x61)
#define REG_SC_BK9F_61_H      _PK_H_(0x9F, 0x61)
#define REG_SC_BK9F_62_L      _PK_L_(0x9F, 0x62)
#define REG_SC_BK9F_62_H      _PK_H_(0x9F, 0x62)
#define REG_SC_BK9F_63_L      _PK_L_(0x9F, 0x63)
#define REG_SC_BK9F_63_H      _PK_H_(0x9F, 0x63)
#define REG_SC_BK9F_64_L      _PK_L_(0x9F, 0x64)
#define REG_SC_BK9F_64_H      _PK_H_(0x9F, 0x64)
#define REG_SC_BK9F_65_L      _PK_L_(0x9F, 0x65)
#define REG_SC_BK9F_65_H      _PK_H_(0x9F, 0x65)
#define REG_SC_BK9F_66_L      _PK_L_(0x9F, 0x66)
#define REG_SC_BK9F_66_H      _PK_H_(0x9F, 0x66)
#define REG_SC_BK9F_67_L      _PK_L_(0x9F, 0x67)
#define REG_SC_BK9F_67_H      _PK_H_(0x9F, 0x67)
#define REG_SC_BK9F_68_L      _PK_L_(0x9F, 0x68)
#define REG_SC_BK9F_68_H      _PK_H_(0x9F, 0x68)
#define REG_SC_BK9F_69_L      _PK_L_(0x9F, 0x69)
#define REG_SC_BK9F_69_H      _PK_H_(0x9F, 0x69)
#define REG_SC_BK9F_6A_L      _PK_L_(0x9F, 0x6A)
#define REG_SC_BK9F_6A_H      _PK_H_(0x9F, 0x6A)
#define REG_SC_BK9F_6B_L      _PK_L_(0x9F, 0x6B)
#define REG_SC_BK9F_6B_H      _PK_H_(0x9F, 0x6B)
#define REG_SC_BK9F_6C_L      _PK_L_(0x9F, 0x6C)
#define REG_SC_BK9F_6C_H      _PK_H_(0x9F, 0x6C)
#define REG_SC_BK9F_6D_L      _PK_L_(0x9F, 0x6D)
#define REG_SC_BK9F_6D_H      _PK_H_(0x9F, 0x6D)
#define REG_SC_BK9F_6E_L      _PK_L_(0x9F, 0x6E)
#define REG_SC_BK9F_6E_H      _PK_H_(0x9F, 0x6E)
#define REG_SC_BK9F_6F_L      _PK_L_(0x9F, 0x6F)
#define REG_SC_BK9F_6F_H      _PK_H_(0x9F, 0x6F)
#define REG_SC_BK9F_70_L      _PK_L_(0x9F, 0x70)
#define REG_SC_BK9F_70_H      _PK_H_(0x9F, 0x70)
#define REG_SC_BK9F_71_L      _PK_L_(0x9F, 0x71)
#define REG_SC_BK9F_71_H      _PK_H_(0x9F, 0x71)
#define REG_SC_BK9F_72_L      _PK_L_(0x9F, 0x72)
#define REG_SC_BK9F_72_H      _PK_H_(0x9F, 0x72)
#define REG_SC_BK9F_73_L      _PK_L_(0x9F, 0x73)
#define REG_SC_BK9F_73_H      _PK_H_(0x9F, 0x73)
#define REG_SC_BK9F_74_L      _PK_L_(0x9F, 0x74)
#define REG_SC_BK9F_74_H      _PK_H_(0x9F, 0x74)
#define REG_SC_BK9F_75_L      _PK_L_(0x9F, 0x75)
#define REG_SC_BK9F_75_H      _PK_H_(0x9F, 0x75)
#define REG_SC_BK9F_76_L      _PK_L_(0x9F, 0x76)
#define REG_SC_BK9F_76_H      _PK_H_(0x9F, 0x76)
#define REG_SC_BK9F_77_L      _PK_L_(0x9F, 0x77)
#define REG_SC_BK9F_77_H      _PK_H_(0x9F, 0x77)
#define REG_SC_BK9F_78_L      _PK_L_(0x9F, 0x78)
#define REG_SC_BK9F_78_H      _PK_H_(0x9F, 0x78)
#define REG_SC_BK9F_79_L      _PK_L_(0x9F, 0x79)
#define REG_SC_BK9F_79_H      _PK_H_(0x9F, 0x79)
#define REG_SC_BK9F_7A_L      _PK_L_(0x9F, 0x7A)
#define REG_SC_BK9F_7A_H      _PK_H_(0x9F, 0x7A)
#define REG_SC_BK9F_7B_L      _PK_L_(0x9F, 0x7B)
#define REG_SC_BK9F_7B_H      _PK_H_(0x9F, 0x7B)
#define REG_SC_BK9F_7C_L      _PK_L_(0x9F, 0x7C)
#define REG_SC_BK9F_7C_H      _PK_H_(0x9F, 0x7C)
#define REG_SC_BK9F_7D_L      _PK_L_(0x9F, 0x7D)
#define REG_SC_BK9F_7D_H      _PK_H_(0x9F, 0x7D)
#define REG_SC_BK9F_7E_L      _PK_L_(0x9F, 0x7E)
#define REG_SC_BK9F_7E_H      _PK_H_(0x9F, 0x7E)
#define REG_SC_BK9F_7F_L      _PK_L_(0x9F, 0x7F)
#define REG_SC_BK9F_7F_H      _PK_H_(0x9F, 0x7F)
//----------------------------------------------
#define REG_SC_BKA0_00_L      _PK_L_(0xA0, 0x00)
#define REG_SC_BKA0_00_H      _PK_H_(0xA0, 0x00)
#define REG_SC_BKA0_01_L      _PK_L_(0xA0, 0x01)
#define REG_SC_BKA0_01_H      _PK_H_(0xA0, 0x01)
#define REG_SC_BKA0_02_L      _PK_L_(0xA0, 0x02)
#define REG_SC_BKA0_02_H      _PK_H_(0xA0, 0x02)
#define REG_SC_BKA0_03_L      _PK_L_(0xA0, 0x03)
#define REG_SC_BKA0_03_H      _PK_H_(0xA0, 0x03)
#define REG_SC_BKA0_04_L      _PK_L_(0xA0, 0x04)
#define REG_SC_BKA0_04_H      _PK_H_(0xA0, 0x04)
#define REG_SC_BKA0_05_L      _PK_L_(0xA0, 0x05)
#define REG_SC_BKA0_05_H      _PK_H_(0xA0, 0x05)
#define REG_SC_BKA0_06_L      _PK_L_(0xA0, 0x06)
#define REG_SC_BKA0_06_H      _PK_H_(0xA0, 0x06)
#define REG_SC_BKA0_07_L      _PK_L_(0xA0, 0x07)
#define REG_SC_BKA0_07_H      _PK_H_(0xA0, 0x07)
#define REG_SC_BKA0_08_L      _PK_L_(0xA0, 0x08)
#define REG_SC_BKA0_08_H      _PK_H_(0xA0, 0x08)
#define REG_SC_BKA0_09_L      _PK_L_(0xA0, 0x09)
#define REG_SC_BKA0_09_H      _PK_H_(0xA0, 0x09)
#define REG_SC_BKA0_0A_L      _PK_L_(0xA0, 0x0A)
#define REG_SC_BKA0_0A_H      _PK_H_(0xA0, 0x0A)
#define REG_SC_BKA0_0B_L      _PK_L_(0xA0, 0x0B)
#define REG_SC_BKA0_0B_H      _PK_H_(0xA0, 0x0B)
#define REG_SC_BKA0_0C_L      _PK_L_(0xA0, 0x0C)
#define REG_SC_BKA0_0C_H      _PK_H_(0xA0, 0x0C)
#define REG_SC_BKA0_0D_L      _PK_L_(0xA0, 0x0D)
#define REG_SC_BKA0_0D_H      _PK_H_(0xA0, 0x0D)
#define REG_SC_BKA0_0E_L      _PK_L_(0xA0, 0x0E)
#define REG_SC_BKA0_0E_H      _PK_H_(0xA0, 0x0E)
#define REG_SC_BKA0_0F_L      _PK_L_(0xA0, 0x0F)
#define REG_SC_BKA0_0F_H      _PK_H_(0xA0, 0x0F)
#define REG_SC_BKA0_10_L      _PK_L_(0xA0, 0x10)
#define REG_SC_BKA0_10_H      _PK_H_(0xA0, 0x10)
#define REG_SC_BKA0_11_L      _PK_L_(0xA0, 0x11)
#define REG_SC_BKA0_11_H      _PK_H_(0xA0, 0x11)
#define REG_SC_BKA0_12_L      _PK_L_(0xA0, 0x12)
#define REG_SC_BKA0_12_H      _PK_H_(0xA0, 0x12)
#define REG_SC_BKA0_13_L      _PK_L_(0xA0, 0x13)
#define REG_SC_BKA0_13_H      _PK_H_(0xA0, 0x13)
#define REG_SC_BKA0_14_L      _PK_L_(0xA0, 0x14)
#define REG_SC_BKA0_14_H      _PK_H_(0xA0, 0x14)
#define REG_SC_BKA0_15_L      _PK_L_(0xA0, 0x15)
#define REG_SC_BKA0_15_H      _PK_H_(0xA0, 0x15)
#define REG_SC_BKA0_16_L      _PK_L_(0xA0, 0x16)
#define REG_SC_BKA0_16_H      _PK_H_(0xA0, 0x16)
#define REG_SC_BKA0_17_L      _PK_L_(0xA0, 0x17)
#define REG_SC_BKA0_17_H      _PK_H_(0xA0, 0x17)
#define REG_SC_BKA0_18_L      _PK_L_(0xA0, 0x18)
#define REG_SC_BKA0_18_H      _PK_H_(0xA0, 0x18)
#define REG_SC_BKA0_19_L      _PK_L_(0xA0, 0x19)
#define REG_SC_BKA0_19_H      _PK_H_(0xA0, 0x19)
#define REG_SC_BKA0_1A_L      _PK_L_(0xA0, 0x1A)
#define REG_SC_BKA0_1A_H      _PK_H_(0xA0, 0x1A)
#define REG_SC_BKA0_1B_L      _PK_L_(0xA0, 0x1B)
#define REG_SC_BKA0_1B_H      _PK_H_(0xA0, 0x1B)
#define REG_SC_BKA0_1C_L      _PK_L_(0xA0, 0x1C)
#define REG_SC_BKA0_1C_H      _PK_H_(0xA0, 0x1C)
#define REG_SC_BKA0_1D_L      _PK_L_(0xA0, 0x1D)
#define REG_SC_BKA0_1D_H      _PK_H_(0xA0, 0x1D)
#define REG_SC_BKA0_1E_L      _PK_L_(0xA0, 0x1E)
#define REG_SC_BKA0_1E_H      _PK_H_(0xA0, 0x1E)
#define REG_SC_BKA0_1F_L      _PK_L_(0xA0, 0x1F)
#define REG_SC_BKA0_1F_H      _PK_H_(0xA0, 0x1F)
#define REG_SC_BKA0_20_L      _PK_L_(0xA0, 0x20)
#define REG_SC_BKA0_20_H      _PK_H_(0xA0, 0x20)
#define REG_SC_BKA0_21_L      _PK_L_(0xA0, 0x21)
#define REG_SC_BKA0_21_H      _PK_H_(0xA0, 0x21)
#define REG_SC_BKA0_22_L      _PK_L_(0xA0, 0x22)
#define REG_SC_BKA0_22_H      _PK_H_(0xA0, 0x22)
#define REG_SC_BKA0_23_L      _PK_L_(0xA0, 0x23)
#define REG_SC_BKA0_23_H      _PK_H_(0xA0, 0x23)
#define REG_SC_BKA0_24_L      _PK_L_(0xA0, 0x24)
#define REG_SC_BKA0_24_H      _PK_H_(0xA0, 0x24)
#define REG_SC_BKA0_25_L      _PK_L_(0xA0, 0x25)
#define REG_SC_BKA0_25_H      _PK_H_(0xA0, 0x25)
#define REG_SC_BKA0_26_L      _PK_L_(0xA0, 0x26)
#define REG_SC_BKA0_26_H      _PK_H_(0xA0, 0x26)
#define REG_SC_BKA0_27_L      _PK_L_(0xA0, 0x27)
#define REG_SC_BKA0_27_H      _PK_H_(0xA0, 0x27)
#define REG_SC_BKA0_28_L      _PK_L_(0xA0, 0x28)
#define REG_SC_BKA0_28_H      _PK_H_(0xA0, 0x28)
#define REG_SC_BKA0_29_L      _PK_L_(0xA0, 0x29)
#define REG_SC_BKA0_29_H      _PK_H_(0xA0, 0x29)
#define REG_SC_BKA0_2A_L      _PK_L_(0xA0, 0x2A)
#define REG_SC_BKA0_2A_H      _PK_H_(0xA0, 0x2A)
#define REG_SC_BKA0_2B_L      _PK_L_(0xA0, 0x2B)
#define REG_SC_BKA0_2B_H      _PK_H_(0xA0, 0x2B)
#define REG_SC_BKA0_2C_L      _PK_L_(0xA0, 0x2C)
#define REG_SC_BKA0_2C_H      _PK_H_(0xA0, 0x2C)
#define REG_SC_BKA0_2D_L      _PK_L_(0xA0, 0x2D)
#define REG_SC_BKA0_2D_H      _PK_H_(0xA0, 0x2D)
#define REG_SC_BKA0_2E_L      _PK_L_(0xA0, 0x2E)
#define REG_SC_BKA0_2E_H      _PK_H_(0xA0, 0x2E)
#define REG_SC_BKA0_2F_L      _PK_L_(0xA0, 0x2F)
#define REG_SC_BKA0_2F_H      _PK_H_(0xA0, 0x2F)
#define REG_SC_BKA0_30_L      _PK_L_(0xA0, 0x30)
#define REG_SC_BKA0_30_H      _PK_H_(0xA0, 0x30)
#define REG_SC_BKA0_31_L      _PK_L_(0xA0, 0x31)
#define REG_SC_BKA0_31_H      _PK_H_(0xA0, 0x31)
#define REG_SC_BKA0_32_L      _PK_L_(0xA0, 0x32)
#define REG_SC_BKA0_32_H      _PK_H_(0xA0, 0x32)
#define REG_SC_BKA0_33_L      _PK_L_(0xA0, 0x33)
#define REG_SC_BKA0_33_H      _PK_H_(0xA0, 0x33)
#define REG_SC_BKA0_34_L      _PK_L_(0xA0, 0x34)
#define REG_SC_BKA0_34_H      _PK_H_(0xA0, 0x34)
#define REG_SC_BKA0_35_L      _PK_L_(0xA0, 0x35)
#define REG_SC_BKA0_35_H      _PK_H_(0xA0, 0x35)
#define REG_SC_BKA0_36_L      _PK_L_(0xA0, 0x36)
#define REG_SC_BKA0_36_H      _PK_H_(0xA0, 0x36)
#define REG_SC_BKA0_37_L      _PK_L_(0xA0, 0x37)
#define REG_SC_BKA0_37_H      _PK_H_(0xA0, 0x37)
#define REG_SC_BKA0_38_L      _PK_L_(0xA0, 0x38)
#define REG_SC_BKA0_38_H      _PK_H_(0xA0, 0x38)
#define REG_SC_BKA0_39_L      _PK_L_(0xA0, 0x39)
#define REG_SC_BKA0_39_H      _PK_H_(0xA0, 0x39)
#define REG_SC_BKA0_3A_L      _PK_L_(0xA0, 0x3A)
#define REG_SC_BKA0_3A_H      _PK_H_(0xA0, 0x3A)
#define REG_SC_BKA0_3B_L      _PK_L_(0xA0, 0x3B)
#define REG_SC_BKA0_3B_H      _PK_H_(0xA0, 0x3B)
#define REG_SC_BKA0_3C_L      _PK_L_(0xA0, 0x3C)
#define REG_SC_BKA0_3C_H      _PK_H_(0xA0, 0x3C)
#define REG_SC_BKA0_3D_L      _PK_L_(0xA0, 0x3D)
#define REG_SC_BKA0_3D_H      _PK_H_(0xA0, 0x3D)
#define REG_SC_BKA0_3E_L      _PK_L_(0xA0, 0x3E)
#define REG_SC_BKA0_3E_H      _PK_H_(0xA0, 0x3E)
#define REG_SC_BKA0_3F_L      _PK_L_(0xA0, 0x3F)
#define REG_SC_BKA0_3F_H      _PK_H_(0xA0, 0x3F)
#define REG_SC_BKA0_40_L      _PK_L_(0xA0, 0x40)
#define REG_SC_BKA0_40_H      _PK_H_(0xA0, 0x40)
#define REG_SC_BKA0_41_L      _PK_L_(0xA0, 0x41)
#define REG_SC_BKA0_41_H      _PK_H_(0xA0, 0x41)
#define REG_SC_BKA0_42_L      _PK_L_(0xA0, 0x42)
#define REG_SC_BKA0_42_H      _PK_H_(0xA0, 0x42)
#define REG_SC_BKA0_43_L      _PK_L_(0xA0, 0x43)
#define REG_SC_BKA0_43_H      _PK_H_(0xA0, 0x43)
#define REG_SC_BKA0_44_L      _PK_L_(0xA0, 0x44)
#define REG_SC_BKA0_44_H      _PK_H_(0xA0, 0x44)
#define REG_SC_BKA0_45_L      _PK_L_(0xA0, 0x45)
#define REG_SC_BKA0_45_H      _PK_H_(0xA0, 0x45)
#define REG_SC_BKA0_46_L      _PK_L_(0xA0, 0x46)
#define REG_SC_BKA0_46_H      _PK_H_(0xA0, 0x46)
#define REG_SC_BKA0_47_L      _PK_L_(0xA0, 0x47)
#define REG_SC_BKA0_47_H      _PK_H_(0xA0, 0x47)
#define REG_SC_BKA0_48_L      _PK_L_(0xA0, 0x48)
#define REG_SC_BKA0_48_H      _PK_H_(0xA0, 0x48)
#define REG_SC_BKA0_49_L      _PK_L_(0xA0, 0x49)
#define REG_SC_BKA0_49_H      _PK_H_(0xA0, 0x49)
#define REG_SC_BKA0_4A_L      _PK_L_(0xA0, 0x4A)
#define REG_SC_BKA0_4A_H      _PK_H_(0xA0, 0x4A)
#define REG_SC_BKA0_4B_L      _PK_L_(0xA0, 0x4B)
#define REG_SC_BKA0_4B_H      _PK_H_(0xA0, 0x4B)
#define REG_SC_BKA0_4C_L      _PK_L_(0xA0, 0x4C)
#define REG_SC_BKA0_4C_H      _PK_H_(0xA0, 0x4C)
#define REG_SC_BKA0_4D_L      _PK_L_(0xA0, 0x4D)
#define REG_SC_BKA0_4D_H      _PK_H_(0xA0, 0x4D)
#define REG_SC_BKA0_4E_L      _PK_L_(0xA0, 0x4E)
#define REG_SC_BKA0_4E_H      _PK_H_(0xA0, 0x4E)
#define REG_SC_BKA0_4F_L      _PK_L_(0xA0, 0x4F)
#define REG_SC_BKA0_4F_H      _PK_H_(0xA0, 0x4F)
#define REG_SC_BKA0_50_L      _PK_L_(0xA0, 0x50)
#define REG_SC_BKA0_50_H      _PK_H_(0xA0, 0x50)
#define REG_SC_BKA0_51_L      _PK_L_(0xA0, 0x51)
#define REG_SC_BKA0_51_H      _PK_H_(0xA0, 0x51)
#define REG_SC_BKA0_52_L      _PK_L_(0xA0, 0x52)
#define REG_SC_BKA0_52_H      _PK_H_(0xA0, 0x52)
#define REG_SC_BKA0_53_L      _PK_L_(0xA0, 0x53)
#define REG_SC_BKA0_53_H      _PK_H_(0xA0, 0x53)
#define REG_SC_BKA0_54_L      _PK_L_(0xA0, 0x54)
#define REG_SC_BKA0_54_H      _PK_H_(0xA0, 0x54)
#define REG_SC_BKA0_55_L      _PK_L_(0xA0, 0x55)
#define REG_SC_BKA0_55_H      _PK_H_(0xA0, 0x55)
#define REG_SC_BKA0_56_L      _PK_L_(0xA0, 0x56)
#define REG_SC_BKA0_56_H      _PK_H_(0xA0, 0x56)
#define REG_SC_BKA0_57_L      _PK_L_(0xA0, 0x57)
#define REG_SC_BKA0_57_H      _PK_H_(0xA0, 0x57)
#define REG_SC_BKA0_58_L      _PK_L_(0xA0, 0x58)
#define REG_SC_BKA0_58_H      _PK_H_(0xA0, 0x58)
#define REG_SC_BKA0_59_L      _PK_L_(0xA0, 0x59)
#define REG_SC_BKA0_59_H      _PK_H_(0xA0, 0x59)
#define REG_SC_BKA0_5A_L      _PK_L_(0xA0, 0x5A)
#define REG_SC_BKA0_5A_H      _PK_H_(0xA0, 0x5A)
#define REG_SC_BKA0_5B_L      _PK_L_(0xA0, 0x5B)
#define REG_SC_BKA0_5B_H      _PK_H_(0xA0, 0x5B)
#define REG_SC_BKA0_5C_L      _PK_L_(0xA0, 0x5C)
#define REG_SC_BKA0_5C_H      _PK_H_(0xA0, 0x5C)
#define REG_SC_BKA0_5D_L      _PK_L_(0xA0, 0x5D)
#define REG_SC_BKA0_5D_H      _PK_H_(0xA0, 0x5D)
#define REG_SC_BKA0_5E_L      _PK_L_(0xA0, 0x5E)
#define REG_SC_BKA0_5E_H      _PK_H_(0xA0, 0x5E)
#define REG_SC_BKA0_5F_L      _PK_L_(0xA0, 0x5F)
#define REG_SC_BKA0_5F_H      _PK_H_(0xA0, 0x5F)
#define REG_SC_BKA0_60_L      _PK_L_(0xA0, 0x60)
#define REG_SC_BKA0_60_H      _PK_H_(0xA0, 0x60)
#define REG_SC_BKA0_61_L      _PK_L_(0xA0, 0x61)
#define REG_SC_BKA0_61_H      _PK_H_(0xA0, 0x61)
#define REG_SC_BKA0_62_L      _PK_L_(0xA0, 0x62)
#define REG_SC_BKA0_62_H      _PK_H_(0xA0, 0x62)
#define REG_SC_BKA0_63_L      _PK_L_(0xA0, 0x63)
#define REG_SC_BKA0_63_H      _PK_H_(0xA0, 0x63)
#define REG_SC_BKA0_64_L      _PK_L_(0xA0, 0x64)
#define REG_SC_BKA0_64_H      _PK_H_(0xA0, 0x64)
#define REG_SC_BKA0_65_L      _PK_L_(0xA0, 0x65)
#define REG_SC_BKA0_65_H      _PK_H_(0xA0, 0x65)
#define REG_SC_BKA0_66_L      _PK_L_(0xA0, 0x66)
#define REG_SC_BKA0_66_H      _PK_H_(0xA0, 0x66)
#define REG_SC_BKA0_67_L      _PK_L_(0xA0, 0x67)
#define REG_SC_BKA0_67_H      _PK_H_(0xA0, 0x67)
#define REG_SC_BKA0_68_L      _PK_L_(0xA0, 0x68)
#define REG_SC_BKA0_68_H      _PK_H_(0xA0, 0x68)
#define REG_SC_BKA0_69_L      _PK_L_(0xA0, 0x69)
#define REG_SC_BKA0_69_H      _PK_H_(0xA0, 0x69)
#define REG_SC_BKA0_6A_L      _PK_L_(0xA0, 0x6A)
#define REG_SC_BKA0_6A_H      _PK_H_(0xA0, 0x6A)
#define REG_SC_BKA0_6B_L      _PK_L_(0xA0, 0x6B)
#define REG_SC_BKA0_6B_H      _PK_H_(0xA0, 0x6B)
#define REG_SC_BKA0_6C_L      _PK_L_(0xA0, 0x6C)
#define REG_SC_BKA0_6C_H      _PK_H_(0xA0, 0x6C)
#define REG_SC_BKA0_6D_L      _PK_L_(0xA0, 0x6D)
#define REG_SC_BKA0_6D_H      _PK_H_(0xA0, 0x6D)
#define REG_SC_BKA0_6E_L      _PK_L_(0xA0, 0x6E)
#define REG_SC_BKA0_6E_H      _PK_H_(0xA0, 0x6E)
#define REG_SC_BKA0_6F_L      _PK_L_(0xA0, 0x6F)
#define REG_SC_BKA0_6F_H      _PK_H_(0xA0, 0x6F)
#define REG_SC_BKA0_70_L      _PK_L_(0xA0, 0x70)
#define REG_SC_BKA0_70_H      _PK_H_(0xA0, 0x70)
#define REG_SC_BKA0_71_L      _PK_L_(0xA0, 0x71)
#define REG_SC_BKA0_71_H      _PK_H_(0xA0, 0x71)
#define REG_SC_BKA0_72_L      _PK_L_(0xA0, 0x72)
#define REG_SC_BKA0_72_H      _PK_H_(0xA0, 0x72)
#define REG_SC_BKA0_73_L      _PK_L_(0xA0, 0x73)
#define REG_SC_BKA0_73_H      _PK_H_(0xA0, 0x73)
#define REG_SC_BKA0_74_L      _PK_L_(0xA0, 0x74)
#define REG_SC_BKA0_74_H      _PK_H_(0xA0, 0x74)
#define REG_SC_BKA0_75_L      _PK_L_(0xA0, 0x75)
#define REG_SC_BKA0_75_H      _PK_H_(0xA0, 0x75)
#define REG_SC_BKA0_76_L      _PK_L_(0xA0, 0x76)
#define REG_SC_BKA0_76_H      _PK_H_(0xA0, 0x76)
#define REG_SC_BKA0_77_L      _PK_L_(0xA0, 0x77)
#define REG_SC_BKA0_77_H      _PK_H_(0xA0, 0x77)
#define REG_SC_BKA0_78_L      _PK_L_(0xA0, 0x78)
#define REG_SC_BKA0_78_H      _PK_H_(0xA0, 0x78)
#define REG_SC_BKA0_79_L      _PK_L_(0xA0, 0x79)
#define REG_SC_BKA0_79_H      _PK_H_(0xA0, 0x79)
#define REG_SC_BKA0_7A_L      _PK_L_(0xA0, 0x7A)
#define REG_SC_BKA0_7A_H      _PK_H_(0xA0, 0x7A)
#define REG_SC_BKA0_7B_L      _PK_L_(0xA0, 0x7B)
#define REG_SC_BKA0_7B_H      _PK_H_(0xA0, 0x7B)
#define REG_SC_BKA0_7C_L      _PK_L_(0xA0, 0x7C)
#define REG_SC_BKA0_7C_H      _PK_H_(0xA0, 0x7C)
#define REG_SC_BKA0_7D_L      _PK_L_(0xA0, 0x7D)
#define REG_SC_BKA0_7D_H      _PK_H_(0xA0, 0x7D)
#define REG_SC_BKA0_7E_L      _PK_L_(0xA0, 0x7E)
#define REG_SC_BKA0_7E_H      _PK_H_(0xA0, 0x7E)
#define REG_SC_BKA0_7F_L      _PK_L_(0xA0, 0x7F)
#define REG_SC_BKA0_7F_H      _PK_H_(0xA0, 0x7F)
//----------------------------------------------
#define REG_SC_BKA1_00_L      _PK_L_(0xA1, 0x00)
#define REG_SC_BKA1_00_H      _PK_H_(0xA1, 0x00)
#define REG_SC_BKA1_01_L      _PK_L_(0xA1, 0x01)
#define REG_SC_BKA1_01_H      _PK_H_(0xA1, 0x01)
#define REG_SC_BKA1_02_L      _PK_L_(0xA1, 0x02)
#define REG_SC_BKA1_02_H      _PK_H_(0xA1, 0x02)
#define REG_SC_BKA1_03_L      _PK_L_(0xA1, 0x03)
#define REG_SC_BKA1_03_H      _PK_H_(0xA1, 0x03)
#define REG_SC_BKA1_04_L      _PK_L_(0xA1, 0x04)
#define REG_SC_BKA1_04_H      _PK_H_(0xA1, 0x04)
#define REG_SC_BKA1_05_L      _PK_L_(0xA1, 0x05)
#define REG_SC_BKA1_05_H      _PK_H_(0xA1, 0x05)
#define REG_SC_BKA1_06_L      _PK_L_(0xA1, 0x06)
#define REG_SC_BKA1_06_H      _PK_H_(0xA1, 0x06)
#define REG_SC_BKA1_07_L      _PK_L_(0xA1, 0x07)
#define REG_SC_BKA1_07_H      _PK_H_(0xA1, 0x07)
#define REG_SC_BKA1_08_L      _PK_L_(0xA1, 0x08)
#define REG_SC_BKA1_08_H      _PK_H_(0xA1, 0x08)
#define REG_SC_BKA1_09_L      _PK_L_(0xA1, 0x09)
#define REG_SC_BKA1_09_H      _PK_H_(0xA1, 0x09)
#define REG_SC_BKA1_0A_L      _PK_L_(0xA1, 0x0A)
#define REG_SC_BKA1_0A_H      _PK_H_(0xA1, 0x0A)
#define REG_SC_BKA1_0B_L      _PK_L_(0xA1, 0x0B)
#define REG_SC_BKA1_0B_H      _PK_H_(0xA1, 0x0B)
#define REG_SC_BKA1_0C_L      _PK_L_(0xA1, 0x0C)
#define REG_SC_BKA1_0C_H      _PK_H_(0xA1, 0x0C)
#define REG_SC_BKA1_0D_L      _PK_L_(0xA1, 0x0D)
#define REG_SC_BKA1_0D_H      _PK_H_(0xA1, 0x0D)
#define REG_SC_BKA1_0E_L      _PK_L_(0xA1, 0x0E)
#define REG_SC_BKA1_0E_H      _PK_H_(0xA1, 0x0E)
#define REG_SC_BKA1_0F_L      _PK_L_(0xA1, 0x0F)
#define REG_SC_BKA1_0F_H      _PK_H_(0xA1, 0x0F)
#define REG_SC_BKA1_10_L      _PK_L_(0xA1, 0x10)
#define REG_SC_BKA1_10_H      _PK_H_(0xA1, 0x10)
#define REG_SC_BKA1_11_L      _PK_L_(0xA1, 0x11)
#define REG_SC_BKA1_11_H      _PK_H_(0xA1, 0x11)
#define REG_SC_BKA1_12_L      _PK_L_(0xA1, 0x12)
#define REG_SC_BKA1_12_H      _PK_H_(0xA1, 0x12)
#define REG_SC_BKA1_13_L      _PK_L_(0xA1, 0x13)
#define REG_SC_BKA1_13_H      _PK_H_(0xA1, 0x13)
#define REG_SC_BKA1_14_L      _PK_L_(0xA1, 0x14)
#define REG_SC_BKA1_14_H      _PK_H_(0xA1, 0x14)
#define REG_SC_BKA1_15_L      _PK_L_(0xA1, 0x15)
#define REG_SC_BKA1_15_H      _PK_H_(0xA1, 0x15)
#define REG_SC_BKA1_16_L      _PK_L_(0xA1, 0x16)
#define REG_SC_BKA1_16_H      _PK_H_(0xA1, 0x16)
#define REG_SC_BKA1_17_L      _PK_L_(0xA1, 0x17)
#define REG_SC_BKA1_17_H      _PK_H_(0xA1, 0x17)
#define REG_SC_BKA1_18_L      _PK_L_(0xA1, 0x18)
#define REG_SC_BKA1_18_H      _PK_H_(0xA1, 0x18)
#define REG_SC_BKA1_19_L      _PK_L_(0xA1, 0x19)
#define REG_SC_BKA1_19_H      _PK_H_(0xA1, 0x19)
#define REG_SC_BKA1_1A_L      _PK_L_(0xA1, 0x1A)
#define REG_SC_BKA1_1A_H      _PK_H_(0xA1, 0x1A)
#define REG_SC_BKA1_1B_L      _PK_L_(0xA1, 0x1B)
#define REG_SC_BKA1_1B_H      _PK_H_(0xA1, 0x1B)
#define REG_SC_BKA1_1C_L      _PK_L_(0xA1, 0x1C)
#define REG_SC_BKA1_1C_H      _PK_H_(0xA1, 0x1C)
#define REG_SC_BKA1_1D_L      _PK_L_(0xA1, 0x1D)
#define REG_SC_BKA1_1D_H      _PK_H_(0xA1, 0x1D)
#define REG_SC_BKA1_1E_L      _PK_L_(0xA1, 0x1E)
#define REG_SC_BKA1_1E_H      _PK_H_(0xA1, 0x1E)
#define REG_SC_BKA1_1F_L      _PK_L_(0xA1, 0x1F)
#define REG_SC_BKA1_1F_H      _PK_H_(0xA1, 0x1F)
#define REG_SC_BKA1_20_L      _PK_L_(0xA1, 0x20)
#define REG_SC_BKA1_20_H      _PK_H_(0xA1, 0x20)
#define REG_SC_BKA1_21_L      _PK_L_(0xA1, 0x21)
#define REG_SC_BKA1_21_H      _PK_H_(0xA1, 0x21)
#define REG_SC_BKA1_22_L      _PK_L_(0xA1, 0x22)
#define REG_SC_BKA1_22_H      _PK_H_(0xA1, 0x22)
#define REG_SC_BKA1_23_L      _PK_L_(0xA1, 0x23)
#define REG_SC_BKA1_23_H      _PK_H_(0xA1, 0x23)
#define REG_SC_BKA1_24_L      _PK_L_(0xA1, 0x24)
#define REG_SC_BKA1_24_H      _PK_H_(0xA1, 0x24)
#define REG_SC_BKA1_25_L      _PK_L_(0xA1, 0x25)
#define REG_SC_BKA1_25_H      _PK_H_(0xA1, 0x25)
#define REG_SC_BKA1_26_L      _PK_L_(0xA1, 0x26)
#define REG_SC_BKA1_26_H      _PK_H_(0xA1, 0x26)
#define REG_SC_BKA1_27_L      _PK_L_(0xA1, 0x27)
#define REG_SC_BKA1_27_H      _PK_H_(0xA1, 0x27)
#define REG_SC_BKA1_28_L      _PK_L_(0xA1, 0x28)
#define REG_SC_BKA1_28_H      _PK_H_(0xA1, 0x28)
#define REG_SC_BKA1_29_L      _PK_L_(0xA1, 0x29)
#define REG_SC_BKA1_29_H      _PK_H_(0xA1, 0x29)
#define REG_SC_BKA1_2A_L      _PK_L_(0xA1, 0x2A)
#define REG_SC_BKA1_2A_H      _PK_H_(0xA1, 0x2A)
#define REG_SC_BKA1_2B_L      _PK_L_(0xA1, 0x2B)
#define REG_SC_BKA1_2B_H      _PK_H_(0xA1, 0x2B)
#define REG_SC_BKA1_2C_L      _PK_L_(0xA1, 0x2C)
#define REG_SC_BKA1_2C_H      _PK_H_(0xA1, 0x2C)
#define REG_SC_BKA1_2D_L      _PK_L_(0xA1, 0x2D)
#define REG_SC_BKA1_2D_H      _PK_H_(0xA1, 0x2D)
#define REG_SC_BKA1_2E_L      _PK_L_(0xA1, 0x2E)
#define REG_SC_BKA1_2E_H      _PK_H_(0xA1, 0x2E)
#define REG_SC_BKA1_2F_L      _PK_L_(0xA1, 0x2F)
#define REG_SC_BKA1_2F_H      _PK_H_(0xA1, 0x2F)
#define REG_SC_BKA1_30_L      _PK_L_(0xA1, 0x30)
#define REG_SC_BKA1_30_H      _PK_H_(0xA1, 0x30)
#define REG_SC_BKA1_31_L      _PK_L_(0xA1, 0x31)
#define REG_SC_BKA1_31_H      _PK_H_(0xA1, 0x31)
#define REG_SC_BKA1_32_L      _PK_L_(0xA1, 0x32)
#define REG_SC_BKA1_32_H      _PK_H_(0xA1, 0x32)
#define REG_SC_BKA1_33_L      _PK_L_(0xA1, 0x33)
#define REG_SC_BKA1_33_H      _PK_H_(0xA1, 0x33)
#define REG_SC_BKA1_34_L      _PK_L_(0xA1, 0x34)
#define REG_SC_BKA1_34_H      _PK_H_(0xA1, 0x34)
#define REG_SC_BKA1_35_L      _PK_L_(0xA1, 0x35)
#define REG_SC_BKA1_35_H      _PK_H_(0xA1, 0x35)
#define REG_SC_BKA1_36_L      _PK_L_(0xA1, 0x36)
#define REG_SC_BKA1_36_H      _PK_H_(0xA1, 0x36)
#define REG_SC_BKA1_37_L      _PK_L_(0xA1, 0x37)
#define REG_SC_BKA1_37_H      _PK_H_(0xA1, 0x37)
#define REG_SC_BKA1_38_L      _PK_L_(0xA1, 0x38)
#define REG_SC_BKA1_38_H      _PK_H_(0xA1, 0x38)
#define REG_SC_BKA1_39_L      _PK_L_(0xA1, 0x39)
#define REG_SC_BKA1_39_H      _PK_H_(0xA1, 0x39)
#define REG_SC_BKA1_3A_L      _PK_L_(0xA1, 0x3A)
#define REG_SC_BKA1_3A_H      _PK_H_(0xA1, 0x3A)
#define REG_SC_BKA1_3B_L      _PK_L_(0xA1, 0x3B)
#define REG_SC_BKA1_3B_H      _PK_H_(0xA1, 0x3B)
#define REG_SC_BKA1_3C_L      _PK_L_(0xA1, 0x3C)
#define REG_SC_BKA1_3C_H      _PK_H_(0xA1, 0x3C)
#define REG_SC_BKA1_3D_L      _PK_L_(0xA1, 0x3D)
#define REG_SC_BKA1_3D_H      _PK_H_(0xA1, 0x3D)
#define REG_SC_BKA1_3E_L      _PK_L_(0xA1, 0x3E)
#define REG_SC_BKA1_3E_H      _PK_H_(0xA1, 0x3E)
#define REG_SC_BKA1_3F_L      _PK_L_(0xA1, 0x3F)
#define REG_SC_BKA1_3F_H      _PK_H_(0xA1, 0x3F)
#define REG_SC_BKA1_40_L      _PK_L_(0xA1, 0x40)
#define REG_SC_BKA1_40_H      _PK_H_(0xA1, 0x40)
#define REG_SC_BKA1_41_L      _PK_L_(0xA1, 0x41)
#define REG_SC_BKA1_41_H      _PK_H_(0xA1, 0x41)
#define REG_SC_BKA1_42_L      _PK_L_(0xA1, 0x42)
#define REG_SC_BKA1_42_H      _PK_H_(0xA1, 0x42)
#define REG_SC_BKA1_43_L      _PK_L_(0xA1, 0x43)
#define REG_SC_BKA1_43_H      _PK_H_(0xA1, 0x43)
#define REG_SC_BKA1_44_L      _PK_L_(0xA1, 0x44)
#define REG_SC_BKA1_44_H      _PK_H_(0xA1, 0x44)
#define REG_SC_BKA1_45_L      _PK_L_(0xA1, 0x45)
#define REG_SC_BKA1_45_H      _PK_H_(0xA1, 0x45)
#define REG_SC_BKA1_46_L      _PK_L_(0xA1, 0x46)
#define REG_SC_BKA1_46_H      _PK_H_(0xA1, 0x46)
#define REG_SC_BKA1_47_L      _PK_L_(0xA1, 0x47)
#define REG_SC_BKA1_47_H      _PK_H_(0xA1, 0x47)
#define REG_SC_BKA1_48_L      _PK_L_(0xA1, 0x48)
#define REG_SC_BKA1_48_H      _PK_H_(0xA1, 0x48)
#define REG_SC_BKA1_49_L      _PK_L_(0xA1, 0x49)
#define REG_SC_BKA1_49_H      _PK_H_(0xA1, 0x49)
#define REG_SC_BKA1_4A_L      _PK_L_(0xA1, 0x4A)
#define REG_SC_BKA1_4A_H      _PK_H_(0xA1, 0x4A)
#define REG_SC_BKA1_4B_L      _PK_L_(0xA1, 0x4B)
#define REG_SC_BKA1_4B_H      _PK_H_(0xA1, 0x4B)
#define REG_SC_BKA1_4C_L      _PK_L_(0xA1, 0x4C)
#define REG_SC_BKA1_4C_H      _PK_H_(0xA1, 0x4C)
#define REG_SC_BKA1_4D_L      _PK_L_(0xA1, 0x4D)
#define REG_SC_BKA1_4D_H      _PK_H_(0xA1, 0x4D)
#define REG_SC_BKA1_4E_L      _PK_L_(0xA1, 0x4E)
#define REG_SC_BKA1_4E_H      _PK_H_(0xA1, 0x4E)
#define REG_SC_BKA1_4F_L      _PK_L_(0xA1, 0x4F)
#define REG_SC_BKA1_4F_H      _PK_H_(0xA1, 0x4F)
#define REG_SC_BKA1_50_L      _PK_L_(0xA1, 0x50)
#define REG_SC_BKA1_50_H      _PK_H_(0xA1, 0x50)
#define REG_SC_BKA1_51_L      _PK_L_(0xA1, 0x51)
#define REG_SC_BKA1_51_H      _PK_H_(0xA1, 0x51)
#define REG_SC_BKA1_52_L      _PK_L_(0xA1, 0x52)
#define REG_SC_BKA1_52_H      _PK_H_(0xA1, 0x52)
#define REG_SC_BKA1_53_L      _PK_L_(0xA1, 0x53)
#define REG_SC_BKA1_53_H      _PK_H_(0xA1, 0x53)
#define REG_SC_BKA1_54_L      _PK_L_(0xA1, 0x54)
#define REG_SC_BKA1_54_H      _PK_H_(0xA1, 0x54)
#define REG_SC_BKA1_55_L      _PK_L_(0xA1, 0x55)
#define REG_SC_BKA1_55_H      _PK_H_(0xA1, 0x55)
#define REG_SC_BKA1_56_L      _PK_L_(0xA1, 0x56)
#define REG_SC_BKA1_56_H      _PK_H_(0xA1, 0x56)
#define REG_SC_BKA1_57_L      _PK_L_(0xA1, 0x57)
#define REG_SC_BKA1_57_H      _PK_H_(0xA1, 0x57)
#define REG_SC_BKA1_58_L      _PK_L_(0xA1, 0x58)
#define REG_SC_BKA1_58_H      _PK_H_(0xA1, 0x58)
#define REG_SC_BKA1_59_L      _PK_L_(0xA1, 0x59)
#define REG_SC_BKA1_59_H      _PK_H_(0xA1, 0x59)
#define REG_SC_BKA1_5A_L      _PK_L_(0xA1, 0x5A)
#define REG_SC_BKA1_5A_H      _PK_H_(0xA1, 0x5A)
#define REG_SC_BKA1_5B_L      _PK_L_(0xA1, 0x5B)
#define REG_SC_BKA1_5B_H      _PK_H_(0xA1, 0x5B)
#define REG_SC_BKA1_5C_L      _PK_L_(0xA1, 0x5C)
#define REG_SC_BKA1_5C_H      _PK_H_(0xA1, 0x5C)
#define REG_SC_BKA1_5D_L      _PK_L_(0xA1, 0x5D)
#define REG_SC_BKA1_5D_H      _PK_H_(0xA1, 0x5D)
#define REG_SC_BKA1_5E_L      _PK_L_(0xA1, 0x5E)
#define REG_SC_BKA1_5E_H      _PK_H_(0xA1, 0x5E)
#define REG_SC_BKA1_5F_L      _PK_L_(0xA1, 0x5F)
#define REG_SC_BKA1_5F_H      _PK_H_(0xA1, 0x5F)
#define REG_SC_BKA1_60_L      _PK_L_(0xA1, 0x60)
#define REG_SC_BKA1_60_H      _PK_H_(0xA1, 0x60)
#define REG_SC_BKA1_61_L      _PK_L_(0xA1, 0x61)
#define REG_SC_BKA1_61_H      _PK_H_(0xA1, 0x61)
#define REG_SC_BKA1_62_L      _PK_L_(0xA1, 0x62)
#define REG_SC_BKA1_62_H      _PK_H_(0xA1, 0x62)
#define REG_SC_BKA1_63_L      _PK_L_(0xA1, 0x63)
#define REG_SC_BKA1_63_H      _PK_H_(0xA1, 0x63)
#define REG_SC_BKA1_64_L      _PK_L_(0xA1, 0x64)
#define REG_SC_BKA1_64_H      _PK_H_(0xA1, 0x64)
#define REG_SC_BKA1_65_L      _PK_L_(0xA1, 0x65)
#define REG_SC_BKA1_65_H      _PK_H_(0xA1, 0x65)
#define REG_SC_BKA1_66_L      _PK_L_(0xA1, 0x66)
#define REG_SC_BKA1_66_H      _PK_H_(0xA1, 0x66)
#define REG_SC_BKA1_67_L      _PK_L_(0xA1, 0x67)
#define REG_SC_BKA1_67_H      _PK_H_(0xA1, 0x67)
#define REG_SC_BKA1_68_L      _PK_L_(0xA1, 0x68)
#define REG_SC_BKA1_68_H      _PK_H_(0xA1, 0x68)
#define REG_SC_BKA1_69_L      _PK_L_(0xA1, 0x69)
#define REG_SC_BKA1_69_H      _PK_H_(0xA1, 0x69)
#define REG_SC_BKA1_6A_L      _PK_L_(0xA1, 0x6A)
#define REG_SC_BKA1_6A_H      _PK_H_(0xA1, 0x6A)
#define REG_SC_BKA1_6B_L      _PK_L_(0xA1, 0x6B)
#define REG_SC_BKA1_6B_H      _PK_H_(0xA1, 0x6B)
#define REG_SC_BKA1_6C_L      _PK_L_(0xA1, 0x6C)
#define REG_SC_BKA1_6C_H      _PK_H_(0xA1, 0x6C)
#define REG_SC_BKA1_6D_L      _PK_L_(0xA1, 0x6D)
#define REG_SC_BKA1_6D_H      _PK_H_(0xA1, 0x6D)
#define REG_SC_BKA1_6E_L      _PK_L_(0xA1, 0x6E)
#define REG_SC_BKA1_6E_H      _PK_H_(0xA1, 0x6E)
#define REG_SC_BKA1_6F_L      _PK_L_(0xA1, 0x6F)
#define REG_SC_BKA1_6F_H      _PK_H_(0xA1, 0x6F)
#define REG_SC_BKA1_70_L      _PK_L_(0xA1, 0x70)
#define REG_SC_BKA1_70_H      _PK_H_(0xA1, 0x70)
#define REG_SC_BKA1_71_L      _PK_L_(0xA1, 0x71)
#define REG_SC_BKA1_71_H      _PK_H_(0xA1, 0x71)
#define REG_SC_BKA1_72_L      _PK_L_(0xA1, 0x72)
#define REG_SC_BKA1_72_H      _PK_H_(0xA1, 0x72)
#define REG_SC_BKA1_73_L      _PK_L_(0xA1, 0x73)
#define REG_SC_BKA1_73_H      _PK_H_(0xA1, 0x73)
#define REG_SC_BKA1_74_L      _PK_L_(0xA1, 0x74)
#define REG_SC_BKA1_74_H      _PK_H_(0xA1, 0x74)
#define REG_SC_BKA1_75_L      _PK_L_(0xA1, 0x75)
#define REG_SC_BKA1_75_H      _PK_H_(0xA1, 0x75)
#define REG_SC_BKA1_76_L      _PK_L_(0xA1, 0x76)
#define REG_SC_BKA1_76_H      _PK_H_(0xA1, 0x76)
#define REG_SC_BKA1_77_L      _PK_L_(0xA1, 0x77)
#define REG_SC_BKA1_77_H      _PK_H_(0xA1, 0x77)
#define REG_SC_BKA1_78_L      _PK_L_(0xA1, 0x78)
#define REG_SC_BKA1_78_H      _PK_H_(0xA1, 0x78)
#define REG_SC_BKA1_79_L      _PK_L_(0xA1, 0x79)
#define REG_SC_BKA1_79_H      _PK_H_(0xA1, 0x79)
#define REG_SC_BKA1_7A_L      _PK_L_(0xA1, 0x7A)
#define REG_SC_BKA1_7A_H      _PK_H_(0xA1, 0x7A)
#define REG_SC_BKA1_7B_L      _PK_L_(0xA1, 0x7B)
#define REG_SC_BKA1_7B_H      _PK_H_(0xA1, 0x7B)
#define REG_SC_BKA1_7C_L      _PK_L_(0xA1, 0x7C)
#define REG_SC_BKA1_7C_H      _PK_H_(0xA1, 0x7C)
#define REG_SC_BKA1_7D_L      _PK_L_(0xA1, 0x7D)
#define REG_SC_BKA1_7D_H      _PK_H_(0xA1, 0x7D)
#define REG_SC_BKA1_7E_L      _PK_L_(0xA1, 0x7E)
#define REG_SC_BKA1_7E_H      _PK_H_(0xA1, 0x7E)
#define REG_SC_BKA1_7F_L      _PK_L_(0xA1, 0x7F)
#define REG_SC_BKA1_7F_H      _PK_H_(0xA1, 0x7F)
//----------------------------------------------
#define REG_SC_BKA2_00_L      _PK_L_(0xA2, 0x00)
#define REG_SC_BKA2_00_H      _PK_H_(0xA2, 0x00)
#define REG_SC_BKA2_01_L      _PK_L_(0xA2, 0x01)
#define REG_SC_BKA2_01_H      _PK_H_(0xA2, 0x01)
#define REG_SC_BKA2_02_L      _PK_L_(0xA2, 0x02)
#define REG_SC_BKA2_02_H      _PK_H_(0xA2, 0x02)
#define REG_SC_BKA2_03_L      _PK_L_(0xA2, 0x03)
#define REG_SC_BKA2_03_H      _PK_H_(0xA2, 0x03)
#define REG_SC_BKA2_04_L      _PK_L_(0xA2, 0x04)
#define REG_SC_BKA2_04_H      _PK_H_(0xA2, 0x04)
#define REG_SC_BKA2_05_L      _PK_L_(0xA2, 0x05)
#define REG_SC_BKA2_05_H      _PK_H_(0xA2, 0x05)
#define REG_SC_BKA2_06_L      _PK_L_(0xA2, 0x06)
#define REG_SC_BKA2_06_H      _PK_H_(0xA2, 0x06)
#define REG_SC_BKA2_07_L      _PK_L_(0xA2, 0x07)
#define REG_SC_BKA2_07_H      _PK_H_(0xA2, 0x07)
#define REG_SC_BKA2_08_L      _PK_L_(0xA2, 0x08)
#define REG_SC_BKA2_08_H      _PK_H_(0xA2, 0x08)
#define REG_SC_BKA2_09_L      _PK_L_(0xA2, 0x09)
#define REG_SC_BKA2_09_H      _PK_H_(0xA2, 0x09)
#define REG_SC_BKA2_0A_L      _PK_L_(0xA2, 0x0A)
#define REG_SC_BKA2_0A_H      _PK_H_(0xA2, 0x0A)
#define REG_SC_BKA2_0B_L      _PK_L_(0xA2, 0x0B)
#define REG_SC_BKA2_0B_H      _PK_H_(0xA2, 0x0B)
#define REG_SC_BKA2_0C_L      _PK_L_(0xA2, 0x0C)
#define REG_SC_BKA2_0C_H      _PK_H_(0xA2, 0x0C)
#define REG_SC_BKA2_0D_L      _PK_L_(0xA2, 0x0D)
#define REG_SC_BKA2_0D_H      _PK_H_(0xA2, 0x0D)
#define REG_SC_BKA2_0E_L      _PK_L_(0xA2, 0x0E)
#define REG_SC_BKA2_0E_H      _PK_H_(0xA2, 0x0E)
#define REG_SC_BKA2_0F_L      _PK_L_(0xA2, 0x0F)
#define REG_SC_BKA2_0F_H      _PK_H_(0xA2, 0x0F)
#define REG_SC_BKA2_10_L      _PK_L_(0xA2, 0x10)
#define REG_SC_BKA2_10_H      _PK_H_(0xA2, 0x10)
#define REG_SC_BKA2_11_L      _PK_L_(0xA2, 0x11)
#define REG_SC_BKA2_11_H      _PK_H_(0xA2, 0x11)
#define REG_SC_BKA2_12_L      _PK_L_(0xA2, 0x12)
#define REG_SC_BKA2_12_H      _PK_H_(0xA2, 0x12)
#define REG_SC_BKA2_13_L      _PK_L_(0xA2, 0x13)
#define REG_SC_BKA2_13_H      _PK_H_(0xA2, 0x13)
#define REG_SC_BKA2_14_L      _PK_L_(0xA2, 0x14)
#define REG_SC_BKA2_14_H      _PK_H_(0xA2, 0x14)
#define REG_SC_BKA2_15_L      _PK_L_(0xA2, 0x15)
#define REG_SC_BKA2_15_H      _PK_H_(0xA2, 0x15)
#define REG_SC_BKA2_16_L      _PK_L_(0xA2, 0x16)
#define REG_SC_BKA2_16_H      _PK_H_(0xA2, 0x16)
#define REG_SC_BKA2_17_L      _PK_L_(0xA2, 0x17)
#define REG_SC_BKA2_17_H      _PK_H_(0xA2, 0x17)
#define REG_SC_BKA2_18_L      _PK_L_(0xA2, 0x18)
#define REG_SC_BKA2_18_H      _PK_H_(0xA2, 0x18)
#define REG_SC_BKA2_19_L      _PK_L_(0xA2, 0x19)
#define REG_SC_BKA2_19_H      _PK_H_(0xA2, 0x19)
#define REG_SC_BKA2_1A_L      _PK_L_(0xA2, 0x1A)
#define REG_SC_BKA2_1A_H      _PK_H_(0xA2, 0x1A)
#define REG_SC_BKA2_1B_L      _PK_L_(0xA2, 0x1B)
#define REG_SC_BKA2_1B_H      _PK_H_(0xA2, 0x1B)
#define REG_SC_BKA2_1C_L      _PK_L_(0xA2, 0x1C)
#define REG_SC_BKA2_1C_H      _PK_H_(0xA2, 0x1C)
#define REG_SC_BKA2_1D_L      _PK_L_(0xA2, 0x1D)
#define REG_SC_BKA2_1D_H      _PK_H_(0xA2, 0x1D)
#define REG_SC_BKA2_1E_L      _PK_L_(0xA2, 0x1E)
#define REG_SC_BKA2_1E_H      _PK_H_(0xA2, 0x1E)
#define REG_SC_BKA2_1F_L      _PK_L_(0xA2, 0x1F)
#define REG_SC_BKA2_1F_H      _PK_H_(0xA2, 0x1F)
#define REG_SC_BKA2_20_L      _PK_L_(0xA2, 0x20)
#define REG_SC_BKA2_20_H      _PK_H_(0xA2, 0x20)
#define REG_SC_BKA2_21_L      _PK_L_(0xA2, 0x21)
#define REG_SC_BKA2_21_H      _PK_H_(0xA2, 0x21)
#define REG_SC_BKA2_22_L      _PK_L_(0xA2, 0x22)
#define REG_SC_BKA2_22_H      _PK_H_(0xA2, 0x22)
#define REG_SC_BKA2_23_L      _PK_L_(0xA2, 0x23)
#define REG_SC_BKA2_23_H      _PK_H_(0xA2, 0x23)
#define REG_SC_BKA2_24_L      _PK_L_(0xA2, 0x24)
#define REG_SC_BKA2_24_H      _PK_H_(0xA2, 0x24)
#define REG_SC_BKA2_25_L      _PK_L_(0xA2, 0x25)
#define REG_SC_BKA2_25_H      _PK_H_(0xA2, 0x25)
#define REG_SC_BKA2_26_L      _PK_L_(0xA2, 0x26)
#define REG_SC_BKA2_26_H      _PK_H_(0xA2, 0x26)
#define REG_SC_BKA2_27_L      _PK_L_(0xA2, 0x27)
#define REG_SC_BKA2_27_H      _PK_H_(0xA2, 0x27)
#define REG_SC_BKA2_28_L      _PK_L_(0xA2, 0x28)
#define REG_SC_BKA2_28_H      _PK_H_(0xA2, 0x28)
#define REG_SC_BKA2_29_L      _PK_L_(0xA2, 0x29)
#define REG_SC_BKA2_29_H      _PK_H_(0xA2, 0x29)
#define REG_SC_BKA2_2A_L      _PK_L_(0xA2, 0x2A)
#define REG_SC_BKA2_2A_H      _PK_H_(0xA2, 0x2A)
#define REG_SC_BKA2_2B_L      _PK_L_(0xA2, 0x2B)
#define REG_SC_BKA2_2B_H      _PK_H_(0xA2, 0x2B)
#define REG_SC_BKA2_2C_L      _PK_L_(0xA2, 0x2C)
#define REG_SC_BKA2_2C_H      _PK_H_(0xA2, 0x2C)
#define REG_SC_BKA2_2D_L      _PK_L_(0xA2, 0x2D)
#define REG_SC_BKA2_2D_H      _PK_H_(0xA2, 0x2D)
#define REG_SC_BKA2_2E_L      _PK_L_(0xA2, 0x2E)
#define REG_SC_BKA2_2E_H      _PK_H_(0xA2, 0x2E)
#define REG_SC_BKA2_2F_L      _PK_L_(0xA2, 0x2F)
#define REG_SC_BKA2_2F_H      _PK_H_(0xA2, 0x2F)
#define REG_SC_BKA2_30_L      _PK_L_(0xA2, 0x30)
#define REG_SC_BKA2_30_H      _PK_H_(0xA2, 0x30)
#define REG_SC_BKA2_31_L      _PK_L_(0xA2, 0x31)
#define REG_SC_BKA2_31_H      _PK_H_(0xA2, 0x31)
#define REG_SC_BKA2_32_L      _PK_L_(0xA2, 0x32)
#define REG_SC_BKA2_32_H      _PK_H_(0xA2, 0x32)
#define REG_SC_BKA2_33_L      _PK_L_(0xA2, 0x33)
#define REG_SC_BKA2_33_H      _PK_H_(0xA2, 0x33)
#define REG_SC_BKA2_34_L      _PK_L_(0xA2, 0x34)
#define REG_SC_BKA2_34_H      _PK_H_(0xA2, 0x34)
#define REG_SC_BKA2_35_L      _PK_L_(0xA2, 0x35)
#define REG_SC_BKA2_35_H      _PK_H_(0xA2, 0x35)
#define REG_SC_BKA2_36_L      _PK_L_(0xA2, 0x36)
#define REG_SC_BKA2_36_H      _PK_H_(0xA2, 0x36)
#define REG_SC_BKA2_37_L      _PK_L_(0xA2, 0x37)
#define REG_SC_BKA2_37_H      _PK_H_(0xA2, 0x37)
#define REG_SC_BKA2_38_L      _PK_L_(0xA2, 0x38)
#define REG_SC_BKA2_38_H      _PK_H_(0xA2, 0x38)
#define REG_SC_BKA2_39_L      _PK_L_(0xA2, 0x39)
#define REG_SC_BKA2_39_H      _PK_H_(0xA2, 0x39)
#define REG_SC_BKA2_3A_L      _PK_L_(0xA2, 0x3A)
#define REG_SC_BKA2_3A_H      _PK_H_(0xA2, 0x3A)
#define REG_SC_BKA2_3B_L      _PK_L_(0xA2, 0x3B)
#define REG_SC_BKA2_3B_H      _PK_H_(0xA2, 0x3B)
#define REG_SC_BKA2_3C_L      _PK_L_(0xA2, 0x3C)
#define REG_SC_BKA2_3C_H      _PK_H_(0xA2, 0x3C)
#define REG_SC_BKA2_3D_L      _PK_L_(0xA2, 0x3D)
#define REG_SC_BKA2_3D_H      _PK_H_(0xA2, 0x3D)
#define REG_SC_BKA2_3E_L      _PK_L_(0xA2, 0x3E)
#define REG_SC_BKA2_3E_H      _PK_H_(0xA2, 0x3E)
#define REG_SC_BKA2_3F_L      _PK_L_(0xA2, 0x3F)
#define REG_SC_BKA2_3F_H      _PK_H_(0xA2, 0x3F)
#define REG_SC_BKA2_40_L      _PK_L_(0xA2, 0x40)
#define REG_SC_BKA2_40_H      _PK_H_(0xA2, 0x40)
#define REG_SC_BKA2_41_L      _PK_L_(0xA2, 0x41)
#define REG_SC_BKA2_41_H      _PK_H_(0xA2, 0x41)
#define REG_SC_BKA2_42_L      _PK_L_(0xA2, 0x42)
#define REG_SC_BKA2_42_H      _PK_H_(0xA2, 0x42)
#define REG_SC_BKA2_43_L      _PK_L_(0xA2, 0x43)
#define REG_SC_BKA2_43_H      _PK_H_(0xA2, 0x43)
#define REG_SC_BKA2_44_L      _PK_L_(0xA2, 0x44)
#define REG_SC_BKA2_44_H      _PK_H_(0xA2, 0x44)
#define REG_SC_BKA2_45_L      _PK_L_(0xA2, 0x45)
#define REG_SC_BKA2_45_H      _PK_H_(0xA2, 0x45)
#define REG_SC_BKA2_46_L      _PK_L_(0xA2, 0x46)
#define REG_SC_BKA2_46_H      _PK_H_(0xA2, 0x46)
#define REG_SC_BKA2_47_L      _PK_L_(0xA2, 0x47)
#define REG_SC_BKA2_47_H      _PK_H_(0xA2, 0x47)
#define REG_SC_BKA2_48_L      _PK_L_(0xA2, 0x48)
#define REG_SC_BKA2_48_H      _PK_H_(0xA2, 0x48)
#define REG_SC_BKA2_49_L      _PK_L_(0xA2, 0x49)
#define REG_SC_BKA2_49_H      _PK_H_(0xA2, 0x49)
#define REG_SC_BKA2_4A_L      _PK_L_(0xA2, 0x4A)
#define REG_SC_BKA2_4A_H      _PK_H_(0xA2, 0x4A)
#define REG_SC_BKA2_4B_L      _PK_L_(0xA2, 0x4B)
#define REG_SC_BKA2_4B_H      _PK_H_(0xA2, 0x4B)
#define REG_SC_BKA2_4C_L      _PK_L_(0xA2, 0x4C)
#define REG_SC_BKA2_4C_H      _PK_H_(0xA2, 0x4C)
#define REG_SC_BKA2_4D_L      _PK_L_(0xA2, 0x4D)
#define REG_SC_BKA2_4D_H      _PK_H_(0xA2, 0x4D)
#define REG_SC_BKA2_4E_L      _PK_L_(0xA2, 0x4E)
#define REG_SC_BKA2_4E_H      _PK_H_(0xA2, 0x4E)
#define REG_SC_BKA2_4F_L      _PK_L_(0xA2, 0x4F)
#define REG_SC_BKA2_4F_H      _PK_H_(0xA2, 0x4F)
#define REG_SC_BKA2_50_L      _PK_L_(0xA2, 0x50)
#define REG_SC_BKA2_50_H      _PK_H_(0xA2, 0x50)
#define REG_SC_BKA2_51_L      _PK_L_(0xA2, 0x51)
#define REG_SC_BKA2_51_H      _PK_H_(0xA2, 0x51)
#define REG_SC_BKA2_52_L      _PK_L_(0xA2, 0x52)
#define REG_SC_BKA2_52_H      _PK_H_(0xA2, 0x52)
#define REG_SC_BKA2_53_L      _PK_L_(0xA2, 0x53)
#define REG_SC_BKA2_53_H      _PK_H_(0xA2, 0x53)
#define REG_SC_BKA2_54_L      _PK_L_(0xA2, 0x54)
#define REG_SC_BKA2_54_H      _PK_H_(0xA2, 0x54)
#define REG_SC_BKA2_55_L      _PK_L_(0xA2, 0x55)
#define REG_SC_BKA2_55_H      _PK_H_(0xA2, 0x55)
#define REG_SC_BKA2_56_L      _PK_L_(0xA2, 0x56)
#define REG_SC_BKA2_56_H      _PK_H_(0xA2, 0x56)
#define REG_SC_BKA2_57_L      _PK_L_(0xA2, 0x57)
#define REG_SC_BKA2_57_H      _PK_H_(0xA2, 0x57)
#define REG_SC_BKA2_58_L      _PK_L_(0xA2, 0x58)
#define REG_SC_BKA2_58_H      _PK_H_(0xA2, 0x58)
#define REG_SC_BKA2_59_L      _PK_L_(0xA2, 0x59)
#define REG_SC_BKA2_59_H      _PK_H_(0xA2, 0x59)
#define REG_SC_BKA2_5A_L      _PK_L_(0xA2, 0x5A)
#define REG_SC_BKA2_5A_H      _PK_H_(0xA2, 0x5A)
#define REG_SC_BKA2_5B_L      _PK_L_(0xA2, 0x5B)
#define REG_SC_BKA2_5B_H      _PK_H_(0xA2, 0x5B)
#define REG_SC_BKA2_5C_L      _PK_L_(0xA2, 0x5C)
#define REG_SC_BKA2_5C_H      _PK_H_(0xA2, 0x5C)
#define REG_SC_BKA2_5D_L      _PK_L_(0xA2, 0x5D)
#define REG_SC_BKA2_5D_H      _PK_H_(0xA2, 0x5D)
#define REG_SC_BKA2_5E_L      _PK_L_(0xA2, 0x5E)
#define REG_SC_BKA2_5E_H      _PK_H_(0xA2, 0x5E)
#define REG_SC_BKA2_5F_L      _PK_L_(0xA2, 0x5F)
#define REG_SC_BKA2_5F_H      _PK_H_(0xA2, 0x5F)
#define REG_SC_BKA2_60_L      _PK_L_(0xA2, 0x60)
#define REG_SC_BKA2_60_H      _PK_H_(0xA2, 0x60)
#define REG_SC_BKA2_61_L      _PK_L_(0xA2, 0x61)
#define REG_SC_BKA2_61_H      _PK_H_(0xA2, 0x61)
#define REG_SC_BKA2_62_L      _PK_L_(0xA2, 0x62)
#define REG_SC_BKA2_62_H      _PK_H_(0xA2, 0x62)
#define REG_SC_BKA2_63_L      _PK_L_(0xA2, 0x63)
#define REG_SC_BKA2_63_H      _PK_H_(0xA2, 0x63)
#define REG_SC_BKA2_64_L      _PK_L_(0xA2, 0x64)
#define REG_SC_BKA2_64_H      _PK_H_(0xA2, 0x64)
#define REG_SC_BKA2_65_L      _PK_L_(0xA2, 0x65)
#define REG_SC_BKA2_65_H      _PK_H_(0xA2, 0x65)
#define REG_SC_BKA2_66_L      _PK_L_(0xA2, 0x66)
#define REG_SC_BKA2_66_H      _PK_H_(0xA2, 0x66)
#define REG_SC_BKA2_67_L      _PK_L_(0xA2, 0x67)
#define REG_SC_BKA2_67_H      _PK_H_(0xA2, 0x67)
#define REG_SC_BKA2_68_L      _PK_L_(0xA2, 0x68)
#define REG_SC_BKA2_68_H      _PK_H_(0xA2, 0x68)
#define REG_SC_BKA2_69_L      _PK_L_(0xA2, 0x69)
#define REG_SC_BKA2_69_H      _PK_H_(0xA2, 0x69)
#define REG_SC_BKA2_6A_L      _PK_L_(0xA2, 0x6A)
#define REG_SC_BKA2_6A_H      _PK_H_(0xA2, 0x6A)
#define REG_SC_BKA2_6B_L      _PK_L_(0xA2, 0x6B)
#define REG_SC_BKA2_6B_H      _PK_H_(0xA2, 0x6B)
#define REG_SC_BKA2_6C_L      _PK_L_(0xA2, 0x6C)
#define REG_SC_BKA2_6C_H      _PK_H_(0xA2, 0x6C)
#define REG_SC_BKA2_6D_L      _PK_L_(0xA2, 0x6D)
#define REG_SC_BKA2_6D_H      _PK_H_(0xA2, 0x6D)
#define REG_SC_BKA2_6E_L      _PK_L_(0xA2, 0x6E)
#define REG_SC_BKA2_6E_H      _PK_H_(0xA2, 0x6E)
#define REG_SC_BKA2_6F_L      _PK_L_(0xA2, 0x6F)
#define REG_SC_BKA2_6F_H      _PK_H_(0xA2, 0x6F)
#define REG_SC_BKA2_70_L      _PK_L_(0xA2, 0x70)
#define REG_SC_BKA2_70_H      _PK_H_(0xA2, 0x70)
#define REG_SC_BKA2_71_L      _PK_L_(0xA2, 0x71)
#define REG_SC_BKA2_71_H      _PK_H_(0xA2, 0x71)
#define REG_SC_BKA2_72_L      _PK_L_(0xA2, 0x72)
#define REG_SC_BKA2_72_H      _PK_H_(0xA2, 0x72)
#define REG_SC_BKA2_73_L      _PK_L_(0xA2, 0x73)
#define REG_SC_BKA2_73_H      _PK_H_(0xA2, 0x73)
#define REG_SC_BKA2_74_L      _PK_L_(0xA2, 0x74)
#define REG_SC_BKA2_74_H      _PK_H_(0xA2, 0x74)
#define REG_SC_BKA2_75_L      _PK_L_(0xA2, 0x75)
#define REG_SC_BKA2_75_H      _PK_H_(0xA2, 0x75)
#define REG_SC_BKA2_76_L      _PK_L_(0xA2, 0x76)
#define REG_SC_BKA2_76_H      _PK_H_(0xA2, 0x76)
#define REG_SC_BKA2_77_L      _PK_L_(0xA2, 0x77)
#define REG_SC_BKA2_77_H      _PK_H_(0xA2, 0x77)
#define REG_SC_BKA2_78_L      _PK_L_(0xA2, 0x78)
#define REG_SC_BKA2_78_H      _PK_H_(0xA2, 0x78)
#define REG_SC_BKA2_79_L      _PK_L_(0xA2, 0x79)
#define REG_SC_BKA2_79_H      _PK_H_(0xA2, 0x79)
#define REG_SC_BKA2_7A_L      _PK_L_(0xA2, 0x7A)
#define REG_SC_BKA2_7A_H      _PK_H_(0xA2, 0x7A)
#define REG_SC_BKA2_7B_L      _PK_L_(0xA2, 0x7B)
#define REG_SC_BKA2_7B_H      _PK_H_(0xA2, 0x7B)
#define REG_SC_BKA2_7C_L      _PK_L_(0xA2, 0x7C)
#define REG_SC_BKA2_7C_H      _PK_H_(0xA2, 0x7C)
#define REG_SC_BKA2_7D_L      _PK_L_(0xA2, 0x7D)
#define REG_SC_BKA2_7D_H      _PK_H_(0xA2, 0x7D)
#define REG_SC_BKA2_7E_L      _PK_L_(0xA2, 0x7E)
#define REG_SC_BKA2_7E_H      _PK_H_(0xA2, 0x7E)
#define REG_SC_BKA2_7F_L      _PK_L_(0xA2, 0x7F)
#define REG_SC_BKA2_7F_H      _PK_H_(0xA2, 0x7F)
//----------------------------------------------
#define REG_SC_BKA3_00_L      _PK_L_(0xA3, 0x00)
#define REG_SC_BKA3_00_H      _PK_H_(0xA3, 0x00)
#define REG_SC_BKA3_01_L      _PK_L_(0xA3, 0x01)
#define REG_SC_BKA3_01_H      _PK_H_(0xA3, 0x01)
#define REG_SC_BKA3_02_L      _PK_L_(0xA3, 0x02)
#define REG_SC_BKA3_02_H      _PK_H_(0xA3, 0x02)
#define REG_SC_BKA3_03_L      _PK_L_(0xA3, 0x03)
#define REG_SC_BKA3_03_H      _PK_H_(0xA3, 0x03)
#define REG_SC_BKA3_04_L      _PK_L_(0xA3, 0x04)
#define REG_SC_BKA3_04_H      _PK_H_(0xA3, 0x04)
#define REG_SC_BKA3_05_L      _PK_L_(0xA3, 0x05)
#define REG_SC_BKA3_05_H      _PK_H_(0xA3, 0x05)
#define REG_SC_BKA3_06_L      _PK_L_(0xA3, 0x06)
#define REG_SC_BKA3_06_H      _PK_H_(0xA3, 0x06)
#define REG_SC_BKA3_07_L      _PK_L_(0xA3, 0x07)
#define REG_SC_BKA3_07_H      _PK_H_(0xA3, 0x07)
#define REG_SC_BKA3_08_L      _PK_L_(0xA3, 0x08)
#define REG_SC_BKA3_08_H      _PK_H_(0xA3, 0x08)
#define REG_SC_BKA3_09_L      _PK_L_(0xA3, 0x09)
#define REG_SC_BKA3_09_H      _PK_H_(0xA3, 0x09)
#define REG_SC_BKA3_0A_L      _PK_L_(0xA3, 0x0A)
#define REG_SC_BKA3_0A_H      _PK_H_(0xA3, 0x0A)
#define REG_SC_BKA3_0B_L      _PK_L_(0xA3, 0x0B)
#define REG_SC_BKA3_0B_H      _PK_H_(0xA3, 0x0B)
#define REG_SC_BKA3_0C_L      _PK_L_(0xA3, 0x0C)
#define REG_SC_BKA3_0C_H      _PK_H_(0xA3, 0x0C)
#define REG_SC_BKA3_0D_L      _PK_L_(0xA3, 0x0D)
#define REG_SC_BKA3_0D_H      _PK_H_(0xA3, 0x0D)
#define REG_SC_BKA3_0E_L      _PK_L_(0xA3, 0x0E)
#define REG_SC_BKA3_0E_H      _PK_H_(0xA3, 0x0E)
#define REG_SC_BKA3_0F_L      _PK_L_(0xA3, 0x0F)
#define REG_SC_BKA3_0F_H      _PK_H_(0xA3, 0x0F)
#define REG_SC_BKA3_10_L      _PK_L_(0xA3, 0x10)
#define REG_SC_BKA3_10_H      _PK_H_(0xA3, 0x10)
#define REG_SC_BKA3_11_L      _PK_L_(0xA3, 0x11)
#define REG_SC_BKA3_11_H      _PK_H_(0xA3, 0x11)
#define REG_SC_BKA3_12_L      _PK_L_(0xA3, 0x12)
#define REG_SC_BKA3_12_H      _PK_H_(0xA3, 0x12)
#define REG_SC_BKA3_13_L      _PK_L_(0xA3, 0x13)
#define REG_SC_BKA3_13_H      _PK_H_(0xA3, 0x13)
#define REG_SC_BKA3_14_L      _PK_L_(0xA3, 0x14)
#define REG_SC_BKA3_14_H      _PK_H_(0xA3, 0x14)
#define REG_SC_BKA3_15_L      _PK_L_(0xA3, 0x15)
#define REG_SC_BKA3_15_H      _PK_H_(0xA3, 0x15)
#define REG_SC_BKA3_16_L      _PK_L_(0xA3, 0x16)
#define REG_SC_BKA3_16_H      _PK_H_(0xA3, 0x16)
#define REG_SC_BKA3_17_L      _PK_L_(0xA3, 0x17)
#define REG_SC_BKA3_17_H      _PK_H_(0xA3, 0x17)
#define REG_SC_BKA3_18_L      _PK_L_(0xA3, 0x18)
#define REG_SC_BKA3_18_H      _PK_H_(0xA3, 0x18)
#define REG_SC_BKA3_19_L      _PK_L_(0xA3, 0x19)
#define REG_SC_BKA3_19_H      _PK_H_(0xA3, 0x19)
#define REG_SC_BKA3_1A_L      _PK_L_(0xA3, 0x1A)
#define REG_SC_BKA3_1A_H      _PK_H_(0xA3, 0x1A)
#define REG_SC_BKA3_1B_L      _PK_L_(0xA3, 0x1B)
#define REG_SC_BKA3_1B_H      _PK_H_(0xA3, 0x1B)
#define REG_SC_BKA3_1C_L      _PK_L_(0xA3, 0x1C)
#define REG_SC_BKA3_1C_H      _PK_H_(0xA3, 0x1C)
#define REG_SC_BKA3_1D_L      _PK_L_(0xA3, 0x1D)
#define REG_SC_BKA3_1D_H      _PK_H_(0xA3, 0x1D)
#define REG_SC_BKA3_1E_L      _PK_L_(0xA3, 0x1E)
#define REG_SC_BKA3_1E_H      _PK_H_(0xA3, 0x1E)
#define REG_SC_BKA3_1F_L      _PK_L_(0xA3, 0x1F)
#define REG_SC_BKA3_1F_H      _PK_H_(0xA3, 0x1F)
#define REG_SC_BKA3_20_L      _PK_L_(0xA3, 0x20)
#define REG_SC_BKA3_20_H      _PK_H_(0xA3, 0x20)
#define REG_SC_BKA3_21_L      _PK_L_(0xA3, 0x21)
#define REG_SC_BKA3_21_H      _PK_H_(0xA3, 0x21)
#define REG_SC_BKA3_22_L      _PK_L_(0xA3, 0x22)
#define REG_SC_BKA3_22_H      _PK_H_(0xA3, 0x22)
#define REG_SC_BKA3_23_L      _PK_L_(0xA3, 0x23)
#define REG_SC_BKA3_23_H      _PK_H_(0xA3, 0x23)
#define REG_SC_BKA3_24_L      _PK_L_(0xA3, 0x24)
#define REG_SC_BKA3_24_H      _PK_H_(0xA3, 0x24)
#define REG_SC_BKA3_25_L      _PK_L_(0xA3, 0x25)
#define REG_SC_BKA3_25_H      _PK_H_(0xA3, 0x25)
#define REG_SC_BKA3_26_L      _PK_L_(0xA3, 0x26)
#define REG_SC_BKA3_26_H      _PK_H_(0xA3, 0x26)
#define REG_SC_BKA3_27_L      _PK_L_(0xA3, 0x27)
#define REG_SC_BKA3_27_H      _PK_H_(0xA3, 0x27)
#define REG_SC_BKA3_28_L      _PK_L_(0xA3, 0x28)
#define REG_SC_BKA3_28_H      _PK_H_(0xA3, 0x28)
#define REG_SC_BKA3_29_L      _PK_L_(0xA3, 0x29)
#define REG_SC_BKA3_29_H      _PK_H_(0xA3, 0x29)
#define REG_SC_BKA3_2A_L      _PK_L_(0xA3, 0x2A)
#define REG_SC_BKA3_2A_H      _PK_H_(0xA3, 0x2A)
#define REG_SC_BKA3_2B_L      _PK_L_(0xA3, 0x2B)
#define REG_SC_BKA3_2B_H      _PK_H_(0xA3, 0x2B)
#define REG_SC_BKA3_2C_L      _PK_L_(0xA3, 0x2C)
#define REG_SC_BKA3_2C_H      _PK_H_(0xA3, 0x2C)
#define REG_SC_BKA3_2D_L      _PK_L_(0xA3, 0x2D)
#define REG_SC_BKA3_2D_H      _PK_H_(0xA3, 0x2D)
#define REG_SC_BKA3_2E_L      _PK_L_(0xA3, 0x2E)
#define REG_SC_BKA3_2E_H      _PK_H_(0xA3, 0x2E)
#define REG_SC_BKA3_2F_L      _PK_L_(0xA3, 0x2F)
#define REG_SC_BKA3_2F_H      _PK_H_(0xA3, 0x2F)
#define REG_SC_BKA3_30_L      _PK_L_(0xA3, 0x30)
#define REG_SC_BKA3_30_H      _PK_H_(0xA3, 0x30)
#define REG_SC_BKA3_31_L      _PK_L_(0xA3, 0x31)
#define REG_SC_BKA3_31_H      _PK_H_(0xA3, 0x31)
#define REG_SC_BKA3_32_L      _PK_L_(0xA3, 0x32)
#define REG_SC_BKA3_32_H      _PK_H_(0xA3, 0x32)
#define REG_SC_BKA3_33_L      _PK_L_(0xA3, 0x33)
#define REG_SC_BKA3_33_H      _PK_H_(0xA3, 0x33)
#define REG_SC_BKA3_34_L      _PK_L_(0xA3, 0x34)
#define REG_SC_BKA3_34_H      _PK_H_(0xA3, 0x34)
#define REG_SC_BKA3_35_L      _PK_L_(0xA3, 0x35)
#define REG_SC_BKA3_35_H      _PK_H_(0xA3, 0x35)
#define REG_SC_BKA3_36_L      _PK_L_(0xA3, 0x36)
#define REG_SC_BKA3_36_H      _PK_H_(0xA3, 0x36)
#define REG_SC_BKA3_37_L      _PK_L_(0xA3, 0x37)
#define REG_SC_BKA3_37_H      _PK_H_(0xA3, 0x37)
#define REG_SC_BKA3_38_L      _PK_L_(0xA3, 0x38)
#define REG_SC_BKA3_38_H      _PK_H_(0xA3, 0x38)
#define REG_SC_BKA3_39_L      _PK_L_(0xA3, 0x39)
#define REG_SC_BKA3_39_H      _PK_H_(0xA3, 0x39)
#define REG_SC_BKA3_3A_L      _PK_L_(0xA3, 0x3A)
#define REG_SC_BKA3_3A_H      _PK_H_(0xA3, 0x3A)
#define REG_SC_BKA3_3B_L      _PK_L_(0xA3, 0x3B)
#define REG_SC_BKA3_3B_H      _PK_H_(0xA3, 0x3B)
#define REG_SC_BKA3_3C_L      _PK_L_(0xA3, 0x3C)
#define REG_SC_BKA3_3C_H      _PK_H_(0xA3, 0x3C)
#define REG_SC_BKA3_3D_L      _PK_L_(0xA3, 0x3D)
#define REG_SC_BKA3_3D_H      _PK_H_(0xA3, 0x3D)
#define REG_SC_BKA3_3E_L      _PK_L_(0xA3, 0x3E)
#define REG_SC_BKA3_3E_H      _PK_H_(0xA3, 0x3E)
#define REG_SC_BKA3_3F_L      _PK_L_(0xA3, 0x3F)
#define REG_SC_BKA3_3F_H      _PK_H_(0xA3, 0x3F)
#define REG_SC_BKA3_40_L      _PK_L_(0xA3, 0x40)
#define REG_SC_BKA3_40_H      _PK_H_(0xA3, 0x40)
#define REG_SC_BKA3_41_L      _PK_L_(0xA3, 0x41)
#define REG_SC_BKA3_41_H      _PK_H_(0xA3, 0x41)
#define REG_SC_BKA3_42_L      _PK_L_(0xA3, 0x42)
#define REG_SC_BKA3_42_H      _PK_H_(0xA3, 0x42)
#define REG_SC_BKA3_43_L      _PK_L_(0xA3, 0x43)
#define REG_SC_BKA3_43_H      _PK_H_(0xA3, 0x43)
#define REG_SC_BKA3_44_L      _PK_L_(0xA3, 0x44)
#define REG_SC_BKA3_44_H      _PK_H_(0xA3, 0x44)
#define REG_SC_BKA3_45_L      _PK_L_(0xA3, 0x45)
#define REG_SC_BKA3_45_H      _PK_H_(0xA3, 0x45)
#define REG_SC_BKA3_46_L      _PK_L_(0xA3, 0x46)
#define REG_SC_BKA3_46_H      _PK_H_(0xA3, 0x46)
#define REG_SC_BKA3_47_L      _PK_L_(0xA3, 0x47)
#define REG_SC_BKA3_47_H      _PK_H_(0xA3, 0x47)
#define REG_SC_BKA3_48_L      _PK_L_(0xA3, 0x48)
#define REG_SC_BKA3_48_H      _PK_H_(0xA3, 0x48)
#define REG_SC_BKA3_49_L      _PK_L_(0xA3, 0x49)
#define REG_SC_BKA3_49_H      _PK_H_(0xA3, 0x49)
#define REG_SC_BKA3_4A_L      _PK_L_(0xA3, 0x4A)
#define REG_SC_BKA3_4A_H      _PK_H_(0xA3, 0x4A)
#define REG_SC_BKA3_4B_L      _PK_L_(0xA3, 0x4B)
#define REG_SC_BKA3_4B_H      _PK_H_(0xA3, 0x4B)
#define REG_SC_BKA3_4C_L      _PK_L_(0xA3, 0x4C)
#define REG_SC_BKA3_4C_H      _PK_H_(0xA3, 0x4C)
#define REG_SC_BKA3_4D_L      _PK_L_(0xA3, 0x4D)
#define REG_SC_BKA3_4D_H      _PK_H_(0xA3, 0x4D)
#define REG_SC_BKA3_4E_L      _PK_L_(0xA3, 0x4E)
#define REG_SC_BKA3_4E_H      _PK_H_(0xA3, 0x4E)
#define REG_SC_BKA3_4F_L      _PK_L_(0xA3, 0x4F)
#define REG_SC_BKA3_4F_H      _PK_H_(0xA3, 0x4F)
#define REG_SC_BKA3_50_L      _PK_L_(0xA3, 0x50)
#define REG_SC_BKA3_50_H      _PK_H_(0xA3, 0x50)
#define REG_SC_BKA3_51_L      _PK_L_(0xA3, 0x51)
#define REG_SC_BKA3_51_H      _PK_H_(0xA3, 0x51)
#define REG_SC_BKA3_52_L      _PK_L_(0xA3, 0x52)
#define REG_SC_BKA3_52_H      _PK_H_(0xA3, 0x52)
#define REG_SC_BKA3_53_L      _PK_L_(0xA3, 0x53)
#define REG_SC_BKA3_53_H      _PK_H_(0xA3, 0x53)
#define REG_SC_BKA3_54_L      _PK_L_(0xA3, 0x54)
#define REG_SC_BKA3_54_H      _PK_H_(0xA3, 0x54)
#define REG_SC_BKA3_55_L      _PK_L_(0xA3, 0x55)
#define REG_SC_BKA3_55_H      _PK_H_(0xA3, 0x55)
#define REG_SC_BKA3_56_L      _PK_L_(0xA3, 0x56)
#define REG_SC_BKA3_56_H      _PK_H_(0xA3, 0x56)
#define REG_SC_BKA3_57_L      _PK_L_(0xA3, 0x57)
#define REG_SC_BKA3_57_H      _PK_H_(0xA3, 0x57)
#define REG_SC_BKA3_58_L      _PK_L_(0xA3, 0x58)
#define REG_SC_BKA3_58_H      _PK_H_(0xA3, 0x58)
#define REG_SC_BKA3_59_L      _PK_L_(0xA3, 0x59)
#define REG_SC_BKA3_59_H      _PK_H_(0xA3, 0x59)
#define REG_SC_BKA3_5A_L      _PK_L_(0xA3, 0x5A)
#define REG_SC_BKA3_5A_H      _PK_H_(0xA3, 0x5A)
#define REG_SC_BKA3_5B_L      _PK_L_(0xA3, 0x5B)
#define REG_SC_BKA3_5B_H      _PK_H_(0xA3, 0x5B)
#define REG_SC_BKA3_5C_L      _PK_L_(0xA3, 0x5C)
#define REG_SC_BKA3_5C_H      _PK_H_(0xA3, 0x5C)
#define REG_SC_BKA3_5D_L      _PK_L_(0xA3, 0x5D)
#define REG_SC_BKA3_5D_H      _PK_H_(0xA3, 0x5D)
#define REG_SC_BKA3_5E_L      _PK_L_(0xA3, 0x5E)
#define REG_SC_BKA3_5E_H      _PK_H_(0xA3, 0x5E)
#define REG_SC_BKA3_5F_L      _PK_L_(0xA3, 0x5F)
#define REG_SC_BKA3_5F_H      _PK_H_(0xA3, 0x5F)
#define REG_SC_BKA3_60_L      _PK_L_(0xA3, 0x60)
#define REG_SC_BKA3_60_H      _PK_H_(0xA3, 0x60)
#define REG_SC_BKA3_61_L      _PK_L_(0xA3, 0x61)
#define REG_SC_BKA3_61_H      _PK_H_(0xA3, 0x61)
#define REG_SC_BKA3_62_L      _PK_L_(0xA3, 0x62)
#define REG_SC_BKA3_62_H      _PK_H_(0xA3, 0x62)
#define REG_SC_BKA3_63_L      _PK_L_(0xA3, 0x63)
#define REG_SC_BKA3_63_H      _PK_H_(0xA3, 0x63)
#define REG_SC_BKA3_64_L      _PK_L_(0xA3, 0x64)
#define REG_SC_BKA3_64_H      _PK_H_(0xA3, 0x64)
#define REG_SC_BKA3_65_L      _PK_L_(0xA3, 0x65)
#define REG_SC_BKA3_65_H      _PK_H_(0xA3, 0x65)
#define REG_SC_BKA3_66_L      _PK_L_(0xA3, 0x66)
#define REG_SC_BKA3_66_H      _PK_H_(0xA3, 0x66)
#define REG_SC_BKA3_67_L      _PK_L_(0xA3, 0x67)
#define REG_SC_BKA3_67_H      _PK_H_(0xA3, 0x67)
#define REG_SC_BKA3_68_L      _PK_L_(0xA3, 0x68)
#define REG_SC_BKA3_68_H      _PK_H_(0xA3, 0x68)
#define REG_SC_BKA3_69_L      _PK_L_(0xA3, 0x69)
#define REG_SC_BKA3_69_H      _PK_H_(0xA3, 0x69)
#define REG_SC_BKA3_6A_L      _PK_L_(0xA3, 0x6A)
#define REG_SC_BKA3_6A_H      _PK_H_(0xA3, 0x6A)
#define REG_SC_BKA3_6B_L      _PK_L_(0xA3, 0x6B)
#define REG_SC_BKA3_6B_H      _PK_H_(0xA3, 0x6B)
#define REG_SC_BKA3_6C_L      _PK_L_(0xA3, 0x6C)
#define REG_SC_BKA3_6C_H      _PK_H_(0xA3, 0x6C)
#define REG_SC_BKA3_6D_L      _PK_L_(0xA3, 0x6D)
#define REG_SC_BKA3_6D_H      _PK_H_(0xA3, 0x6D)
#define REG_SC_BKA3_6E_L      _PK_L_(0xA3, 0x6E)
#define REG_SC_BKA3_6E_H      _PK_H_(0xA3, 0x6E)
#define REG_SC_BKA3_6F_L      _PK_L_(0xA3, 0x6F)
#define REG_SC_BKA3_6F_H      _PK_H_(0xA3, 0x6F)
#define REG_SC_BKA3_70_L      _PK_L_(0xA3, 0x70)
#define REG_SC_BKA3_70_H      _PK_H_(0xA3, 0x70)
#define REG_SC_BKA3_71_L      _PK_L_(0xA3, 0x71)
#define REG_SC_BKA3_71_H      _PK_H_(0xA3, 0x71)
#define REG_SC_BKA3_72_L      _PK_L_(0xA3, 0x72)
#define REG_SC_BKA3_72_H      _PK_H_(0xA3, 0x72)
#define REG_SC_BKA3_73_L      _PK_L_(0xA3, 0x73)
#define REG_SC_BKA3_73_H      _PK_H_(0xA3, 0x73)
#define REG_SC_BKA3_74_L      _PK_L_(0xA3, 0x74)
#define REG_SC_BKA3_74_H      _PK_H_(0xA3, 0x74)
#define REG_SC_BKA3_75_L      _PK_L_(0xA3, 0x75)
#define REG_SC_BKA3_75_H      _PK_H_(0xA3, 0x75)
#define REG_SC_BKA3_76_L      _PK_L_(0xA3, 0x76)
#define REG_SC_BKA3_76_H      _PK_H_(0xA3, 0x76)
#define REG_SC_BKA3_77_L      _PK_L_(0xA3, 0x77)
#define REG_SC_BKA3_77_H      _PK_H_(0xA3, 0x77)
#define REG_SC_BKA3_78_L      _PK_L_(0xA3, 0x78)
#define REG_SC_BKA3_78_H      _PK_H_(0xA3, 0x78)
#define REG_SC_BKA3_79_L      _PK_L_(0xA3, 0x79)
#define REG_SC_BKA3_79_H      _PK_H_(0xA3, 0x79)
#define REG_SC_BKA3_7A_L      _PK_L_(0xA3, 0x7A)
#define REG_SC_BKA3_7A_H      _PK_H_(0xA3, 0x7A)
#define REG_SC_BKA3_7B_L      _PK_L_(0xA3, 0x7B)
#define REG_SC_BKA3_7B_H      _PK_H_(0xA3, 0x7B)
#define REG_SC_BKA3_7C_L      _PK_L_(0xA3, 0x7C)
#define REG_SC_BKA3_7C_H      _PK_H_(0xA3, 0x7C)
#define REG_SC_BKA3_7D_L      _PK_L_(0xA3, 0x7D)
#define REG_SC_BKA3_7D_H      _PK_H_(0xA3, 0x7D)
#define REG_SC_BKA3_7E_L      _PK_L_(0xA3, 0x7E)
#define REG_SC_BKA3_7E_H      _PK_H_(0xA3, 0x7E)
#define REG_SC_BKA3_7F_L      _PK_L_(0xA3, 0x7F)
#define REG_SC_BKA3_7F_H      _PK_H_(0xA3, 0x7F)
//----------------------------------------------
#define REG_SC_BKA4_00_L      _PK_L_(0xA4, 0x00)
#define REG_SC_BKA4_00_H      _PK_H_(0xA4, 0x00)
#define REG_SC_BKA4_01_L      _PK_L_(0xA4, 0x01)
#define REG_SC_BKA4_01_H      _PK_H_(0xA4, 0x01)
#define REG_SC_BKA4_02_L      _PK_L_(0xA4, 0x02)
#define REG_SC_BKA4_02_H      _PK_H_(0xA4, 0x02)
#define REG_SC_BKA4_03_L      _PK_L_(0xA4, 0x03)
#define REG_SC_BKA4_03_H      _PK_H_(0xA4, 0x03)
#define REG_SC_BKA4_04_L      _PK_L_(0xA4, 0x04)
#define REG_SC_BKA4_04_H      _PK_H_(0xA4, 0x04)
#define REG_SC_BKA4_05_L      _PK_L_(0xA4, 0x05)
#define REG_SC_BKA4_05_H      _PK_H_(0xA4, 0x05)
#define REG_SC_BKA4_06_L      _PK_L_(0xA4, 0x06)
#define REG_SC_BKA4_06_H      _PK_H_(0xA4, 0x06)
#define REG_SC_BKA4_07_L      _PK_L_(0xA4, 0x07)
#define REG_SC_BKA4_07_H      _PK_H_(0xA4, 0x07)
#define REG_SC_BKA4_08_L      _PK_L_(0xA4, 0x08)
#define REG_SC_BKA4_08_H      _PK_H_(0xA4, 0x08)
#define REG_SC_BKA4_09_L      _PK_L_(0xA4, 0x09)
#define REG_SC_BKA4_09_H      _PK_H_(0xA4, 0x09)
#define REG_SC_BKA4_0A_L      _PK_L_(0xA4, 0x0A)
#define REG_SC_BKA4_0A_H      _PK_H_(0xA4, 0x0A)
#define REG_SC_BKA4_0B_L      _PK_L_(0xA4, 0x0B)
#define REG_SC_BKA4_0B_H      _PK_H_(0xA4, 0x0B)
#define REG_SC_BKA4_0C_L      _PK_L_(0xA4, 0x0C)
#define REG_SC_BKA4_0C_H      _PK_H_(0xA4, 0x0C)
#define REG_SC_BKA4_0D_L      _PK_L_(0xA4, 0x0D)
#define REG_SC_BKA4_0D_H      _PK_H_(0xA4, 0x0D)
#define REG_SC_BKA4_0E_L      _PK_L_(0xA4, 0x0E)
#define REG_SC_BKA4_0E_H      _PK_H_(0xA4, 0x0E)
#define REG_SC_BKA4_0F_L      _PK_L_(0xA4, 0x0F)
#define REG_SC_BKA4_0F_H      _PK_H_(0xA4, 0x0F)
#define REG_SC_BKA4_10_L      _PK_L_(0xA4, 0x10)
#define REG_SC_BKA4_10_H      _PK_H_(0xA4, 0x10)
#define REG_SC_BKA4_11_L      _PK_L_(0xA4, 0x11)
#define REG_SC_BKA4_11_H      _PK_H_(0xA4, 0x11)
#define REG_SC_BKA4_12_L      _PK_L_(0xA4, 0x12)
#define REG_SC_BKA4_12_H      _PK_H_(0xA4, 0x12)
#define REG_SC_BKA4_13_L      _PK_L_(0xA4, 0x13)
#define REG_SC_BKA4_13_H      _PK_H_(0xA4, 0x13)
#define REG_SC_BKA4_14_L      _PK_L_(0xA4, 0x14)
#define REG_SC_BKA4_14_H      _PK_H_(0xA4, 0x14)
#define REG_SC_BKA4_15_L      _PK_L_(0xA4, 0x15)
#define REG_SC_BKA4_15_H      _PK_H_(0xA4, 0x15)
#define REG_SC_BKA4_16_L      _PK_L_(0xA4, 0x16)
#define REG_SC_BKA4_16_H      _PK_H_(0xA4, 0x16)
#define REG_SC_BKA4_17_L      _PK_L_(0xA4, 0x17)
#define REG_SC_BKA4_17_H      _PK_H_(0xA4, 0x17)
#define REG_SC_BKA4_18_L      _PK_L_(0xA4, 0x18)
#define REG_SC_BKA4_18_H      _PK_H_(0xA4, 0x18)
#define REG_SC_BKA4_19_L      _PK_L_(0xA4, 0x19)
#define REG_SC_BKA4_19_H      _PK_H_(0xA4, 0x19)
#define REG_SC_BKA4_1A_L      _PK_L_(0xA4, 0x1A)
#define REG_SC_BKA4_1A_H      _PK_H_(0xA4, 0x1A)
#define REG_SC_BKA4_1B_L      _PK_L_(0xA4, 0x1B)
#define REG_SC_BKA4_1B_H      _PK_H_(0xA4, 0x1B)
#define REG_SC_BKA4_1C_L      _PK_L_(0xA4, 0x1C)
#define REG_SC_BKA4_1C_H      _PK_H_(0xA4, 0x1C)
#define REG_SC_BKA4_1D_L      _PK_L_(0xA4, 0x1D)
#define REG_SC_BKA4_1D_H      _PK_H_(0xA4, 0x1D)
#define REG_SC_BKA4_1E_L      _PK_L_(0xA4, 0x1E)
#define REG_SC_BKA4_1E_H      _PK_H_(0xA4, 0x1E)
#define REG_SC_BKA4_1F_L      _PK_L_(0xA4, 0x1F)
#define REG_SC_BKA4_1F_H      _PK_H_(0xA4, 0x1F)
#define REG_SC_BKA4_20_L      _PK_L_(0xA4, 0x20)
#define REG_SC_BKA4_20_H      _PK_H_(0xA4, 0x20)
#define REG_SC_BKA4_21_L      _PK_L_(0xA4, 0x21)
#define REG_SC_BKA4_21_H      _PK_H_(0xA4, 0x21)
#define REG_SC_BKA4_22_L      _PK_L_(0xA4, 0x22)
#define REG_SC_BKA4_22_H      _PK_H_(0xA4, 0x22)
#define REG_SC_BKA4_23_L      _PK_L_(0xA4, 0x23)
#define REG_SC_BKA4_23_H      _PK_H_(0xA4, 0x23)
#define REG_SC_BKA4_24_L      _PK_L_(0xA4, 0x24)
#define REG_SC_BKA4_24_H      _PK_H_(0xA4, 0x24)
#define REG_SC_BKA4_25_L      _PK_L_(0xA4, 0x25)
#define REG_SC_BKA4_25_H      _PK_H_(0xA4, 0x25)
#define REG_SC_BKA4_26_L      _PK_L_(0xA4, 0x26)
#define REG_SC_BKA4_26_H      _PK_H_(0xA4, 0x26)
#define REG_SC_BKA4_27_L      _PK_L_(0xA4, 0x27)
#define REG_SC_BKA4_27_H      _PK_H_(0xA4, 0x27)
#define REG_SC_BKA4_28_L      _PK_L_(0xA4, 0x28)
#define REG_SC_BKA4_28_H      _PK_H_(0xA4, 0x28)
#define REG_SC_BKA4_29_L      _PK_L_(0xA4, 0x29)
#define REG_SC_BKA4_29_H      _PK_H_(0xA4, 0x29)
#define REG_SC_BKA4_2A_L      _PK_L_(0xA4, 0x2A)
#define REG_SC_BKA4_2A_H      _PK_H_(0xA4, 0x2A)
#define REG_SC_BKA4_2B_L      _PK_L_(0xA4, 0x2B)
#define REG_SC_BKA4_2B_H      _PK_H_(0xA4, 0x2B)
#define REG_SC_BKA4_2C_L      _PK_L_(0xA4, 0x2C)
#define REG_SC_BKA4_2C_H      _PK_H_(0xA4, 0x2C)
#define REG_SC_BKA4_2D_L      _PK_L_(0xA4, 0x2D)
#define REG_SC_BKA4_2D_H      _PK_H_(0xA4, 0x2D)
#define REG_SC_BKA4_2E_L      _PK_L_(0xA4, 0x2E)
#define REG_SC_BKA4_2E_H      _PK_H_(0xA4, 0x2E)
#define REG_SC_BKA4_2F_L      _PK_L_(0xA4, 0x2F)
#define REG_SC_BKA4_2F_H      _PK_H_(0xA4, 0x2F)
#define REG_SC_BKA4_30_L      _PK_L_(0xA4, 0x30)
#define REG_SC_BKA4_30_H      _PK_H_(0xA4, 0x30)
#define REG_SC_BKA4_31_L      _PK_L_(0xA4, 0x31)
#define REG_SC_BKA4_31_H      _PK_H_(0xA4, 0x31)
#define REG_SC_BKA4_32_L      _PK_L_(0xA4, 0x32)
#define REG_SC_BKA4_32_H      _PK_H_(0xA4, 0x32)
#define REG_SC_BKA4_33_L      _PK_L_(0xA4, 0x33)
#define REG_SC_BKA4_33_H      _PK_H_(0xA4, 0x33)
#define REG_SC_BKA4_34_L      _PK_L_(0xA4, 0x34)
#define REG_SC_BKA4_34_H      _PK_H_(0xA4, 0x34)
#define REG_SC_BKA4_35_L      _PK_L_(0xA4, 0x35)
#define REG_SC_BKA4_35_H      _PK_H_(0xA4, 0x35)
#define REG_SC_BKA4_36_L      _PK_L_(0xA4, 0x36)
#define REG_SC_BKA4_36_H      _PK_H_(0xA4, 0x36)
#define REG_SC_BKA4_37_L      _PK_L_(0xA4, 0x37)
#define REG_SC_BKA4_37_H      _PK_H_(0xA4, 0x37)
#define REG_SC_BKA4_38_L      _PK_L_(0xA4, 0x38)
#define REG_SC_BKA4_38_H      _PK_H_(0xA4, 0x38)
#define REG_SC_BKA4_39_L      _PK_L_(0xA4, 0x39)
#define REG_SC_BKA4_39_H      _PK_H_(0xA4, 0x39)
#define REG_SC_BKA4_3A_L      _PK_L_(0xA4, 0x3A)
#define REG_SC_BKA4_3A_H      _PK_H_(0xA4, 0x3A)
#define REG_SC_BKA4_3B_L      _PK_L_(0xA4, 0x3B)
#define REG_SC_BKA4_3B_H      _PK_H_(0xA4, 0x3B)
#define REG_SC_BKA4_3C_L      _PK_L_(0xA4, 0x3C)
#define REG_SC_BKA4_3C_H      _PK_H_(0xA4, 0x3C)
#define REG_SC_BKA4_3D_L      _PK_L_(0xA4, 0x3D)
#define REG_SC_BKA4_3D_H      _PK_H_(0xA4, 0x3D)
#define REG_SC_BKA4_3E_L      _PK_L_(0xA4, 0x3E)
#define REG_SC_BKA4_3E_H      _PK_H_(0xA4, 0x3E)
#define REG_SC_BKA4_3F_L      _PK_L_(0xA4, 0x3F)
#define REG_SC_BKA4_3F_H      _PK_H_(0xA4, 0x3F)
#define REG_SC_BKA4_40_L      _PK_L_(0xA4, 0x40)
#define REG_SC_BKA4_40_H      _PK_H_(0xA4, 0x40)
#define REG_SC_BKA4_41_L      _PK_L_(0xA4, 0x41)
#define REG_SC_BKA4_41_H      _PK_H_(0xA4, 0x41)
#define REG_SC_BKA4_42_L      _PK_L_(0xA4, 0x42)
#define REG_SC_BKA4_42_H      _PK_H_(0xA4, 0x42)
#define REG_SC_BKA4_43_L      _PK_L_(0xA4, 0x43)
#define REG_SC_BKA4_43_H      _PK_H_(0xA4, 0x43)
#define REG_SC_BKA4_44_L      _PK_L_(0xA4, 0x44)
#define REG_SC_BKA4_44_H      _PK_H_(0xA4, 0x44)
#define REG_SC_BKA4_45_L      _PK_L_(0xA4, 0x45)
#define REG_SC_BKA4_45_H      _PK_H_(0xA4, 0x45)
#define REG_SC_BKA4_46_L      _PK_L_(0xA4, 0x46)
#define REG_SC_BKA4_46_H      _PK_H_(0xA4, 0x46)
#define REG_SC_BKA4_47_L      _PK_L_(0xA4, 0x47)
#define REG_SC_BKA4_47_H      _PK_H_(0xA4, 0x47)
#define REG_SC_BKA4_48_L      _PK_L_(0xA4, 0x48)
#define REG_SC_BKA4_48_H      _PK_H_(0xA4, 0x48)
#define REG_SC_BKA4_49_L      _PK_L_(0xA4, 0x49)
#define REG_SC_BKA4_49_H      _PK_H_(0xA4, 0x49)
#define REG_SC_BKA4_4A_L      _PK_L_(0xA4, 0x4A)
#define REG_SC_BKA4_4A_H      _PK_H_(0xA4, 0x4A)
#define REG_SC_BKA4_4B_L      _PK_L_(0xA4, 0x4B)
#define REG_SC_BKA4_4B_H      _PK_H_(0xA4, 0x4B)
#define REG_SC_BKA4_4C_L      _PK_L_(0xA4, 0x4C)
#define REG_SC_BKA4_4C_H      _PK_H_(0xA4, 0x4C)
#define REG_SC_BKA4_4D_L      _PK_L_(0xA4, 0x4D)
#define REG_SC_BKA4_4D_H      _PK_H_(0xA4, 0x4D)
#define REG_SC_BKA4_4E_L      _PK_L_(0xA4, 0x4E)
#define REG_SC_BKA4_4E_H      _PK_H_(0xA4, 0x4E)
#define REG_SC_BKA4_4F_L      _PK_L_(0xA4, 0x4F)
#define REG_SC_BKA4_4F_H      _PK_H_(0xA4, 0x4F)
#define REG_SC_BKA4_50_L      _PK_L_(0xA4, 0x50)
#define REG_SC_BKA4_50_H      _PK_H_(0xA4, 0x50)
#define REG_SC_BKA4_51_L      _PK_L_(0xA4, 0x51)
#define REG_SC_BKA4_51_H      _PK_H_(0xA4, 0x51)
#define REG_SC_BKA4_52_L      _PK_L_(0xA4, 0x52)
#define REG_SC_BKA4_52_H      _PK_H_(0xA4, 0x52)
#define REG_SC_BKA4_53_L      _PK_L_(0xA4, 0x53)
#define REG_SC_BKA4_53_H      _PK_H_(0xA4, 0x53)
#define REG_SC_BKA4_54_L      _PK_L_(0xA4, 0x54)
#define REG_SC_BKA4_54_H      _PK_H_(0xA4, 0x54)
#define REG_SC_BKA4_55_L      _PK_L_(0xA4, 0x55)
#define REG_SC_BKA4_55_H      _PK_H_(0xA4, 0x55)
#define REG_SC_BKA4_56_L      _PK_L_(0xA4, 0x56)
#define REG_SC_BKA4_56_H      _PK_H_(0xA4, 0x56)
#define REG_SC_BKA4_57_L      _PK_L_(0xA4, 0x57)
#define REG_SC_BKA4_57_H      _PK_H_(0xA4, 0x57)
#define REG_SC_BKA4_58_L      _PK_L_(0xA4, 0x58)
#define REG_SC_BKA4_58_H      _PK_H_(0xA4, 0x58)
#define REG_SC_BKA4_59_L      _PK_L_(0xA4, 0x59)
#define REG_SC_BKA4_59_H      _PK_H_(0xA4, 0x59)
#define REG_SC_BKA4_5A_L      _PK_L_(0xA4, 0x5A)
#define REG_SC_BKA4_5A_H      _PK_H_(0xA4, 0x5A)
#define REG_SC_BKA4_5B_L      _PK_L_(0xA4, 0x5B)
#define REG_SC_BKA4_5B_H      _PK_H_(0xA4, 0x5B)
#define REG_SC_BKA4_5C_L      _PK_L_(0xA4, 0x5C)
#define REG_SC_BKA4_5C_H      _PK_H_(0xA4, 0x5C)
#define REG_SC_BKA4_5D_L      _PK_L_(0xA4, 0x5D)
#define REG_SC_BKA4_5D_H      _PK_H_(0xA4, 0x5D)
#define REG_SC_BKA4_5E_L      _PK_L_(0xA4, 0x5E)
#define REG_SC_BKA4_5E_H      _PK_H_(0xA4, 0x5E)
#define REG_SC_BKA4_5F_L      _PK_L_(0xA4, 0x5F)
#define REG_SC_BKA4_5F_H      _PK_H_(0xA4, 0x5F)
#define REG_SC_BKA4_60_L      _PK_L_(0xA4, 0x60)
#define REG_SC_BKA4_60_H      _PK_H_(0xA4, 0x60)
#define REG_SC_BKA4_61_L      _PK_L_(0xA4, 0x61)
#define REG_SC_BKA4_61_H      _PK_H_(0xA4, 0x61)
#define REG_SC_BKA4_62_L      _PK_L_(0xA4, 0x62)
#define REG_SC_BKA4_62_H      _PK_H_(0xA4, 0x62)
#define REG_SC_BKA4_63_L      _PK_L_(0xA4, 0x63)
#define REG_SC_BKA4_63_H      _PK_H_(0xA4, 0x63)
#define REG_SC_BKA4_64_L      _PK_L_(0xA4, 0x64)
#define REG_SC_BKA4_64_H      _PK_H_(0xA4, 0x64)
#define REG_SC_BKA4_65_L      _PK_L_(0xA4, 0x65)
#define REG_SC_BKA4_65_H      _PK_H_(0xA4, 0x65)
#define REG_SC_BKA4_66_L      _PK_L_(0xA4, 0x66)
#define REG_SC_BKA4_66_H      _PK_H_(0xA4, 0x66)
#define REG_SC_BKA4_67_L      _PK_L_(0xA4, 0x67)
#define REG_SC_BKA4_67_H      _PK_H_(0xA4, 0x67)
#define REG_SC_BKA4_68_L      _PK_L_(0xA4, 0x68)
#define REG_SC_BKA4_68_H      _PK_H_(0xA4, 0x68)
#define REG_SC_BKA4_69_L      _PK_L_(0xA4, 0x69)
#define REG_SC_BKA4_69_H      _PK_H_(0xA4, 0x69)
#define REG_SC_BKA4_6A_L      _PK_L_(0xA4, 0x6A)
#define REG_SC_BKA4_6A_H      _PK_H_(0xA4, 0x6A)
#define REG_SC_BKA4_6B_L      _PK_L_(0xA4, 0x6B)
#define REG_SC_BKA4_6B_H      _PK_H_(0xA4, 0x6B)
#define REG_SC_BKA4_6C_L      _PK_L_(0xA4, 0x6C)
#define REG_SC_BKA4_6C_H      _PK_H_(0xA4, 0x6C)
#define REG_SC_BKA4_6D_L      _PK_L_(0xA4, 0x6D)
#define REG_SC_BKA4_6D_H      _PK_H_(0xA4, 0x6D)
#define REG_SC_BKA4_6E_L      _PK_L_(0xA4, 0x6E)
#define REG_SC_BKA4_6E_H      _PK_H_(0xA4, 0x6E)
#define REG_SC_BKA4_6F_L      _PK_L_(0xA4, 0x6F)
#define REG_SC_BKA4_6F_H      _PK_H_(0xA4, 0x6F)
#define REG_SC_BKA4_70_L      _PK_L_(0xA4, 0x70)
#define REG_SC_BKA4_70_H      _PK_H_(0xA4, 0x70)
#define REG_SC_BKA4_71_L      _PK_L_(0xA4, 0x71)
#define REG_SC_BKA4_71_H      _PK_H_(0xA4, 0x71)
#define REG_SC_BKA4_72_L      _PK_L_(0xA4, 0x72)
#define REG_SC_BKA4_72_H      _PK_H_(0xA4, 0x72)
#define REG_SC_BKA4_73_L      _PK_L_(0xA4, 0x73)
#define REG_SC_BKA4_73_H      _PK_H_(0xA4, 0x73)
#define REG_SC_BKA4_74_L      _PK_L_(0xA4, 0x74)
#define REG_SC_BKA4_74_H      _PK_H_(0xA4, 0x74)
#define REG_SC_BKA4_75_L      _PK_L_(0xA4, 0x75)
#define REG_SC_BKA4_75_H      _PK_H_(0xA4, 0x75)
#define REG_SC_BKA4_76_L      _PK_L_(0xA4, 0x76)
#define REG_SC_BKA4_76_H      _PK_H_(0xA4, 0x76)
#define REG_SC_BKA4_77_L      _PK_L_(0xA4, 0x77)
#define REG_SC_BKA4_77_H      _PK_H_(0xA4, 0x77)
#define REG_SC_BKA4_78_L      _PK_L_(0xA4, 0x78)
#define REG_SC_BKA4_78_H      _PK_H_(0xA4, 0x78)
#define REG_SC_BKA4_79_L      _PK_L_(0xA4, 0x79)
#define REG_SC_BKA4_79_H      _PK_H_(0xA4, 0x79)
#define REG_SC_BKA4_7A_L      _PK_L_(0xA4, 0x7A)
#define REG_SC_BKA4_7A_H      _PK_H_(0xA4, 0x7A)
#define REG_SC_BKA4_7B_L      _PK_L_(0xA4, 0x7B)
#define REG_SC_BKA4_7B_H      _PK_H_(0xA4, 0x7B)
#define REG_SC_BKA4_7C_L      _PK_L_(0xA4, 0x7C)
#define REG_SC_BKA4_7C_H      _PK_H_(0xA4, 0x7C)
#define REG_SC_BKA4_7D_L      _PK_L_(0xA4, 0x7D)
#define REG_SC_BKA4_7D_H      _PK_H_(0xA4, 0x7D)
#define REG_SC_BKA4_7E_L      _PK_L_(0xA4, 0x7E)
#define REG_SC_BKA4_7E_H      _PK_H_(0xA4, 0x7E)
#define REG_SC_BKA4_7F_L      _PK_L_(0xA4, 0x7F)
#define REG_SC_BKA4_7F_H      _PK_H_(0xA4, 0x7F)
//----------------------------------------------
#define REG_SC_BKA5_00_L      _PK_L_(0xA5, 0x00)
#define REG_SC_BKA5_00_H      _PK_H_(0xA5, 0x00)
#define REG_SC_BKA5_01_L      _PK_L_(0xA5, 0x01)
#define REG_SC_BKA5_01_H      _PK_H_(0xA5, 0x01)
#define REG_SC_BKA5_02_L      _PK_L_(0xA5, 0x02)
#define REG_SC_BKA5_02_H      _PK_H_(0xA5, 0x02)
#define REG_SC_BKA5_03_L      _PK_L_(0xA5, 0x03)
#define REG_SC_BKA5_03_H      _PK_H_(0xA5, 0x03)
#define REG_SC_BKA5_04_L      _PK_L_(0xA5, 0x04)
#define REG_SC_BKA5_04_H      _PK_H_(0xA5, 0x04)
#define REG_SC_BKA5_05_L      _PK_L_(0xA5, 0x05)
#define REG_SC_BKA5_05_H      _PK_H_(0xA5, 0x05)
#define REG_SC_BKA5_06_L      _PK_L_(0xA5, 0x06)
#define REG_SC_BKA5_06_H      _PK_H_(0xA5, 0x06)
#define REG_SC_BKA5_07_L      _PK_L_(0xA5, 0x07)
#define REG_SC_BKA5_07_H      _PK_H_(0xA5, 0x07)
#define REG_SC_BKA5_08_L      _PK_L_(0xA5, 0x08)
#define REG_SC_BKA5_08_H      _PK_H_(0xA5, 0x08)
#define REG_SC_BKA5_09_L      _PK_L_(0xA5, 0x09)
#define REG_SC_BKA5_09_H      _PK_H_(0xA5, 0x09)
#define REG_SC_BKA5_0A_L      _PK_L_(0xA5, 0x0A)
#define REG_SC_BKA5_0A_H      _PK_H_(0xA5, 0x0A)
#define REG_SC_BKA5_0B_L      _PK_L_(0xA5, 0x0B)
#define REG_SC_BKA5_0B_H      _PK_H_(0xA5, 0x0B)
#define REG_SC_BKA5_0C_L      _PK_L_(0xA5, 0x0C)
#define REG_SC_BKA5_0C_H      _PK_H_(0xA5, 0x0C)
#define REG_SC_BKA5_0D_L      _PK_L_(0xA5, 0x0D)
#define REG_SC_BKA5_0D_H      _PK_H_(0xA5, 0x0D)
#define REG_SC_BKA5_0E_L      _PK_L_(0xA5, 0x0E)
#define REG_SC_BKA5_0E_H      _PK_H_(0xA5, 0x0E)
#define REG_SC_BKA5_0F_L      _PK_L_(0xA5, 0x0F)
#define REG_SC_BKA5_0F_H      _PK_H_(0xA5, 0x0F)
#define REG_SC_BKA5_10_L      _PK_L_(0xA5, 0x10)
#define REG_SC_BKA5_10_H      _PK_H_(0xA5, 0x10)
#define REG_SC_BKA5_11_L      _PK_L_(0xA5, 0x11)
#define REG_SC_BKA5_11_H      _PK_H_(0xA5, 0x11)
#define REG_SC_BKA5_12_L      _PK_L_(0xA5, 0x12)
#define REG_SC_BKA5_12_H      _PK_H_(0xA5, 0x12)
#define REG_SC_BKA5_13_L      _PK_L_(0xA5, 0x13)
#define REG_SC_BKA5_13_H      _PK_H_(0xA5, 0x13)
#define REG_SC_BKA5_14_L      _PK_L_(0xA5, 0x14)
#define REG_SC_BKA5_14_H      _PK_H_(0xA5, 0x14)
#define REG_SC_BKA5_15_L      _PK_L_(0xA5, 0x15)
#define REG_SC_BKA5_15_H      _PK_H_(0xA5, 0x15)
#define REG_SC_BKA5_16_L      _PK_L_(0xA5, 0x16)
#define REG_SC_BKA5_16_H      _PK_H_(0xA5, 0x16)
#define REG_SC_BKA5_17_L      _PK_L_(0xA5, 0x17)
#define REG_SC_BKA5_17_H      _PK_H_(0xA5, 0x17)
#define REG_SC_BKA5_18_L      _PK_L_(0xA5, 0x18)
#define REG_SC_BKA5_18_H      _PK_H_(0xA5, 0x18)
#define REG_SC_BKA5_19_L      _PK_L_(0xA5, 0x19)
#define REG_SC_BKA5_19_H      _PK_H_(0xA5, 0x19)
#define REG_SC_BKA5_1A_L      _PK_L_(0xA5, 0x1A)
#define REG_SC_BKA5_1A_H      _PK_H_(0xA5, 0x1A)
#define REG_SC_BKA5_1B_L      _PK_L_(0xA5, 0x1B)
#define REG_SC_BKA5_1B_H      _PK_H_(0xA5, 0x1B)
#define REG_SC_BKA5_1C_L      _PK_L_(0xA5, 0x1C)
#define REG_SC_BKA5_1C_H      _PK_H_(0xA5, 0x1C)
#define REG_SC_BKA5_1D_L      _PK_L_(0xA5, 0x1D)
#define REG_SC_BKA5_1D_H      _PK_H_(0xA5, 0x1D)
#define REG_SC_BKA5_1E_L      _PK_L_(0xA5, 0x1E)
#define REG_SC_BKA5_1E_H      _PK_H_(0xA5, 0x1E)
#define REG_SC_BKA5_1F_L      _PK_L_(0xA5, 0x1F)
#define REG_SC_BKA5_1F_H      _PK_H_(0xA5, 0x1F)
#define REG_SC_BKA5_20_L      _PK_L_(0xA5, 0x20)
#define REG_SC_BKA5_20_H      _PK_H_(0xA5, 0x20)
#define REG_SC_BKA5_21_L      _PK_L_(0xA5, 0x21)
#define REG_SC_BKA5_21_H      _PK_H_(0xA5, 0x21)
#define REG_SC_BKA5_22_L      _PK_L_(0xA5, 0x22)
#define REG_SC_BKA5_22_H      _PK_H_(0xA5, 0x22)
#define REG_SC_BKA5_23_L      _PK_L_(0xA5, 0x23)
#define REG_SC_BKA5_23_H      _PK_H_(0xA5, 0x23)
#define REG_SC_BKA5_24_L      _PK_L_(0xA5, 0x24)
#define REG_SC_BKA5_24_H      _PK_H_(0xA5, 0x24)
#define REG_SC_BKA5_25_L      _PK_L_(0xA5, 0x25)
#define REG_SC_BKA5_25_H      _PK_H_(0xA5, 0x25)
#define REG_SC_BKA5_26_L      _PK_L_(0xA5, 0x26)
#define REG_SC_BKA5_26_H      _PK_H_(0xA5, 0x26)
#define REG_SC_BKA5_27_L      _PK_L_(0xA5, 0x27)
#define REG_SC_BKA5_27_H      _PK_H_(0xA5, 0x27)
#define REG_SC_BKA5_28_L      _PK_L_(0xA5, 0x28)
#define REG_SC_BKA5_28_H      _PK_H_(0xA5, 0x28)
#define REG_SC_BKA5_29_L      _PK_L_(0xA5, 0x29)
#define REG_SC_BKA5_29_H      _PK_H_(0xA5, 0x29)
#define REG_SC_BKA5_2A_L      _PK_L_(0xA5, 0x2A)
#define REG_SC_BKA5_2A_H      _PK_H_(0xA5, 0x2A)
#define REG_SC_BKA5_2B_L      _PK_L_(0xA5, 0x2B)
#define REG_SC_BKA5_2B_H      _PK_H_(0xA5, 0x2B)
#define REG_SC_BKA5_2C_L      _PK_L_(0xA5, 0x2C)
#define REG_SC_BKA5_2C_H      _PK_H_(0xA5, 0x2C)
#define REG_SC_BKA5_2D_L      _PK_L_(0xA5, 0x2D)
#define REG_SC_BKA5_2D_H      _PK_H_(0xA5, 0x2D)
#define REG_SC_BKA5_2E_L      _PK_L_(0xA5, 0x2E)
#define REG_SC_BKA5_2E_H      _PK_H_(0xA5, 0x2E)
#define REG_SC_BKA5_2F_L      _PK_L_(0xA5, 0x2F)
#define REG_SC_BKA5_2F_H      _PK_H_(0xA5, 0x2F)
#define REG_SC_BKA5_30_L      _PK_L_(0xA5, 0x30)
#define REG_SC_BKA5_30_H      _PK_H_(0xA5, 0x30)
#define REG_SC_BKA5_31_L      _PK_L_(0xA5, 0x31)
#define REG_SC_BKA5_31_H      _PK_H_(0xA5, 0x31)
#define REG_SC_BKA5_32_L      _PK_L_(0xA5, 0x32)
#define REG_SC_BKA5_32_H      _PK_H_(0xA5, 0x32)
#define REG_SC_BKA5_33_L      _PK_L_(0xA5, 0x33)
#define REG_SC_BKA5_33_H      _PK_H_(0xA5, 0x33)
#define REG_SC_BKA5_34_L      _PK_L_(0xA5, 0x34)
#define REG_SC_BKA5_34_H      _PK_H_(0xA5, 0x34)
#define REG_SC_BKA5_35_L      _PK_L_(0xA5, 0x35)
#define REG_SC_BKA5_35_H      _PK_H_(0xA5, 0x35)
#define REG_SC_BKA5_36_L      _PK_L_(0xA5, 0x36)
#define REG_SC_BKA5_36_H      _PK_H_(0xA5, 0x36)
#define REG_SC_BKA5_37_L      _PK_L_(0xA5, 0x37)
#define REG_SC_BKA5_37_H      _PK_H_(0xA5, 0x37)
#define REG_SC_BKA5_38_L      _PK_L_(0xA5, 0x38)
#define REG_SC_BKA5_38_H      _PK_H_(0xA5, 0x38)
#define REG_SC_BKA5_39_L      _PK_L_(0xA5, 0x39)
#define REG_SC_BKA5_39_H      _PK_H_(0xA5, 0x39)
#define REG_SC_BKA5_3A_L      _PK_L_(0xA5, 0x3A)
#define REG_SC_BKA5_3A_H      _PK_H_(0xA5, 0x3A)
#define REG_SC_BKA5_3B_L      _PK_L_(0xA5, 0x3B)
#define REG_SC_BKA5_3B_H      _PK_H_(0xA5, 0x3B)
#define REG_SC_BKA5_3C_L      _PK_L_(0xA5, 0x3C)
#define REG_SC_BKA5_3C_H      _PK_H_(0xA5, 0x3C)
#define REG_SC_BKA5_3D_L      _PK_L_(0xA5, 0x3D)
#define REG_SC_BKA5_3D_H      _PK_H_(0xA5, 0x3D)
#define REG_SC_BKA5_3E_L      _PK_L_(0xA5, 0x3E)
#define REG_SC_BKA5_3E_H      _PK_H_(0xA5, 0x3E)
#define REG_SC_BKA5_3F_L      _PK_L_(0xA5, 0x3F)
#define REG_SC_BKA5_3F_H      _PK_H_(0xA5, 0x3F)
#define REG_SC_BKA5_40_L      _PK_L_(0xA5, 0x40)
#define REG_SC_BKA5_40_H      _PK_H_(0xA5, 0x40)
#define REG_SC_BKA5_41_L      _PK_L_(0xA5, 0x41)
#define REG_SC_BKA5_41_H      _PK_H_(0xA5, 0x41)
#define REG_SC_BKA5_42_L      _PK_L_(0xA5, 0x42)
#define REG_SC_BKA5_42_H      _PK_H_(0xA5, 0x42)
#define REG_SC_BKA5_43_L      _PK_L_(0xA5, 0x43)
#define REG_SC_BKA5_43_H      _PK_H_(0xA5, 0x43)
#define REG_SC_BKA5_44_L      _PK_L_(0xA5, 0x44)
#define REG_SC_BKA5_44_H      _PK_H_(0xA5, 0x44)
#define REG_SC_BKA5_45_L      _PK_L_(0xA5, 0x45)
#define REG_SC_BKA5_45_H      _PK_H_(0xA5, 0x45)
#define REG_SC_BKA5_46_L      _PK_L_(0xA5, 0x46)
#define REG_SC_BKA5_46_H      _PK_H_(0xA5, 0x46)
#define REG_SC_BKA5_47_L      _PK_L_(0xA5, 0x47)
#define REG_SC_BKA5_47_H      _PK_H_(0xA5, 0x47)
#define REG_SC_BKA5_48_L      _PK_L_(0xA5, 0x48)
#define REG_SC_BKA5_48_H      _PK_H_(0xA5, 0x48)
#define REG_SC_BKA5_49_L      _PK_L_(0xA5, 0x49)
#define REG_SC_BKA5_49_H      _PK_H_(0xA5, 0x49)
#define REG_SC_BKA5_4A_L      _PK_L_(0xA5, 0x4A)
#define REG_SC_BKA5_4A_H      _PK_H_(0xA5, 0x4A)
#define REG_SC_BKA5_4B_L      _PK_L_(0xA5, 0x4B)
#define REG_SC_BKA5_4B_H      _PK_H_(0xA5, 0x4B)
#define REG_SC_BKA5_4C_L      _PK_L_(0xA5, 0x4C)
#define REG_SC_BKA5_4C_H      _PK_H_(0xA5, 0x4C)
#define REG_SC_BKA5_4D_L      _PK_L_(0xA5, 0x4D)
#define REG_SC_BKA5_4D_H      _PK_H_(0xA5, 0x4D)
#define REG_SC_BKA5_4E_L      _PK_L_(0xA5, 0x4E)
#define REG_SC_BKA5_4E_H      _PK_H_(0xA5, 0x4E)
#define REG_SC_BKA5_4F_L      _PK_L_(0xA5, 0x4F)
#define REG_SC_BKA5_4F_H      _PK_H_(0xA5, 0x4F)
#define REG_SC_BKA5_50_L      _PK_L_(0xA5, 0x50)
#define REG_SC_BKA5_50_H      _PK_H_(0xA5, 0x50)
#define REG_SC_BKA5_51_L      _PK_L_(0xA5, 0x51)
#define REG_SC_BKA5_51_H      _PK_H_(0xA5, 0x51)
#define REG_SC_BKA5_52_L      _PK_L_(0xA5, 0x52)
#define REG_SC_BKA5_52_H      _PK_H_(0xA5, 0x52)
#define REG_SC_BKA5_53_L      _PK_L_(0xA5, 0x53)
#define REG_SC_BKA5_53_H      _PK_H_(0xA5, 0x53)
#define REG_SC_BKA5_54_L      _PK_L_(0xA5, 0x54)
#define REG_SC_BKA5_54_H      _PK_H_(0xA5, 0x54)
#define REG_SC_BKA5_55_L      _PK_L_(0xA5, 0x55)
#define REG_SC_BKA5_55_H      _PK_H_(0xA5, 0x55)
#define REG_SC_BKA5_56_L      _PK_L_(0xA5, 0x56)
#define REG_SC_BKA5_56_H      _PK_H_(0xA5, 0x56)
#define REG_SC_BKA5_57_L      _PK_L_(0xA5, 0x57)
#define REG_SC_BKA5_57_H      _PK_H_(0xA5, 0x57)
#define REG_SC_BKA5_58_L      _PK_L_(0xA5, 0x58)
#define REG_SC_BKA5_58_H      _PK_H_(0xA5, 0x58)
#define REG_SC_BKA5_59_L      _PK_L_(0xA5, 0x59)
#define REG_SC_BKA5_59_H      _PK_H_(0xA5, 0x59)
#define REG_SC_BKA5_5A_L      _PK_L_(0xA5, 0x5A)
#define REG_SC_BKA5_5A_H      _PK_H_(0xA5, 0x5A)
#define REG_SC_BKA5_5B_L      _PK_L_(0xA5, 0x5B)
#define REG_SC_BKA5_5B_H      _PK_H_(0xA5, 0x5B)
#define REG_SC_BKA5_5C_L      _PK_L_(0xA5, 0x5C)
#define REG_SC_BKA5_5C_H      _PK_H_(0xA5, 0x5C)
#define REG_SC_BKA5_5D_L      _PK_L_(0xA5, 0x5D)
#define REG_SC_BKA5_5D_H      _PK_H_(0xA5, 0x5D)
#define REG_SC_BKA5_5E_L      _PK_L_(0xA5, 0x5E)
#define REG_SC_BKA5_5E_H      _PK_H_(0xA5, 0x5E)
#define REG_SC_BKA5_5F_L      _PK_L_(0xA5, 0x5F)
#define REG_SC_BKA5_5F_H      _PK_H_(0xA5, 0x5F)
#define REG_SC_BKA5_60_L      _PK_L_(0xA5, 0x60)
#define REG_SC_BKA5_60_H      _PK_H_(0xA5, 0x60)
#define REG_SC_BKA5_61_L      _PK_L_(0xA5, 0x61)
#define REG_SC_BKA5_61_H      _PK_H_(0xA5, 0x61)
#define REG_SC_BKA5_62_L      _PK_L_(0xA5, 0x62)
#define REG_SC_BKA5_62_H      _PK_H_(0xA5, 0x62)
#define REG_SC_BKA5_63_L      _PK_L_(0xA5, 0x63)
#define REG_SC_BKA5_63_H      _PK_H_(0xA5, 0x63)
#define REG_SC_BKA5_64_L      _PK_L_(0xA5, 0x64)
#define REG_SC_BKA5_64_H      _PK_H_(0xA5, 0x64)
#define REG_SC_BKA5_65_L      _PK_L_(0xA5, 0x65)
#define REG_SC_BKA5_65_H      _PK_H_(0xA5, 0x65)
#define REG_SC_BKA5_66_L      _PK_L_(0xA5, 0x66)
#define REG_SC_BKA5_66_H      _PK_H_(0xA5, 0x66)
#define REG_SC_BKA5_67_L      _PK_L_(0xA5, 0x67)
#define REG_SC_BKA5_67_H      _PK_H_(0xA5, 0x67)
#define REG_SC_BKA5_68_L      _PK_L_(0xA5, 0x68)
#define REG_SC_BKA5_68_H      _PK_H_(0xA5, 0x68)
#define REG_SC_BKA5_69_L      _PK_L_(0xA5, 0x69)
#define REG_SC_BKA5_69_H      _PK_H_(0xA5, 0x69)
#define REG_SC_BKA5_6A_L      _PK_L_(0xA5, 0x6A)
#define REG_SC_BKA5_6A_H      _PK_H_(0xA5, 0x6A)
#define REG_SC_BKA5_6B_L      _PK_L_(0xA5, 0x6B)
#define REG_SC_BKA5_6B_H      _PK_H_(0xA5, 0x6B)
#define REG_SC_BKA5_6C_L      _PK_L_(0xA5, 0x6C)
#define REG_SC_BKA5_6C_H      _PK_H_(0xA5, 0x6C)
#define REG_SC_BKA5_6D_L      _PK_L_(0xA5, 0x6D)
#define REG_SC_BKA5_6D_H      _PK_H_(0xA5, 0x6D)
#define REG_SC_BKA5_6E_L      _PK_L_(0xA5, 0x6E)
#define REG_SC_BKA5_6E_H      _PK_H_(0xA5, 0x6E)
#define REG_SC_BKA5_6F_L      _PK_L_(0xA5, 0x6F)
#define REG_SC_BKA5_6F_H      _PK_H_(0xA5, 0x6F)
#define REG_SC_BKA5_70_L      _PK_L_(0xA5, 0x70)
#define REG_SC_BKA5_70_H      _PK_H_(0xA5, 0x70)
#define REG_SC_BKA5_71_L      _PK_L_(0xA5, 0x71)
#define REG_SC_BKA5_71_H      _PK_H_(0xA5, 0x71)
#define REG_SC_BKA5_72_L      _PK_L_(0xA5, 0x72)
#define REG_SC_BKA5_72_H      _PK_H_(0xA5, 0x72)
#define REG_SC_BKA5_73_L      _PK_L_(0xA5, 0x73)
#define REG_SC_BKA5_73_H      _PK_H_(0xA5, 0x73)
#define REG_SC_BKA5_74_L      _PK_L_(0xA5, 0x74)
#define REG_SC_BKA5_74_H      _PK_H_(0xA5, 0x74)
#define REG_SC_BKA5_75_L      _PK_L_(0xA5, 0x75)
#define REG_SC_BKA5_75_H      _PK_H_(0xA5, 0x75)
#define REG_SC_BKA5_76_L      _PK_L_(0xA5, 0x76)
#define REG_SC_BKA5_76_H      _PK_H_(0xA5, 0x76)
#define REG_SC_BKA5_77_L      _PK_L_(0xA5, 0x77)
#define REG_SC_BKA5_77_H      _PK_H_(0xA5, 0x77)
#define REG_SC_BKA5_78_L      _PK_L_(0xA5, 0x78)
#define REG_SC_BKA5_78_H      _PK_H_(0xA5, 0x78)
#define REG_SC_BKA5_79_L      _PK_L_(0xA5, 0x79)
#define REG_SC_BKA5_79_H      _PK_H_(0xA5, 0x79)
#define REG_SC_BKA5_7A_L      _PK_L_(0xA5, 0x7A)
#define REG_SC_BKA5_7A_H      _PK_H_(0xA5, 0x7A)
#define REG_SC_BKA5_7B_L      _PK_L_(0xA5, 0x7B)
#define REG_SC_BKA5_7B_H      _PK_H_(0xA5, 0x7B)
#define REG_SC_BKA5_7C_L      _PK_L_(0xA5, 0x7C)
#define REG_SC_BKA5_7C_H      _PK_H_(0xA5, 0x7C)
#define REG_SC_BKA5_7D_L      _PK_L_(0xA5, 0x7D)
#define REG_SC_BKA5_7D_H      _PK_H_(0xA5, 0x7D)
#define REG_SC_BKA5_7E_L      _PK_L_(0xA5, 0x7E)
#define REG_SC_BKA5_7E_H      _PK_H_(0xA5, 0x7E)
#define REG_SC_BKA5_7F_L      _PK_L_(0xA5, 0x7F)
#define REG_SC_BKA5_7F_H      _PK_H_(0xA5, 0x7F)
//----------------------------------------------
#define REG_SC_BKA6_00_L      _PK_L_(0xA6, 0x00)
#define REG_SC_BKA6_00_H      _PK_H_(0xA6, 0x00)
#define REG_SC_BKA6_01_L      _PK_L_(0xA6, 0x01)
#define REG_SC_BKA6_01_H      _PK_H_(0xA6, 0x01)
#define REG_SC_BKA6_02_L      _PK_L_(0xA6, 0x02)
#define REG_SC_BKA6_02_H      _PK_H_(0xA6, 0x02)
#define REG_SC_BKA6_03_L      _PK_L_(0xA6, 0x03)
#define REG_SC_BKA6_03_H      _PK_H_(0xA6, 0x03)
#define REG_SC_BKA6_04_L      _PK_L_(0xA6, 0x04)
#define REG_SC_BKA6_04_H      _PK_H_(0xA6, 0x04)
#define REG_SC_BKA6_05_L      _PK_L_(0xA6, 0x05)
#define REG_SC_BKA6_05_H      _PK_H_(0xA6, 0x05)
#define REG_SC_BKA6_06_L      _PK_L_(0xA6, 0x06)
#define REG_SC_BKA6_06_H      _PK_H_(0xA6, 0x06)
#define REG_SC_BKA6_07_L      _PK_L_(0xA6, 0x07)
#define REG_SC_BKA6_07_H      _PK_H_(0xA6, 0x07)
#define REG_SC_BKA6_08_L      _PK_L_(0xA6, 0x08)
#define REG_SC_BKA6_08_H      _PK_H_(0xA6, 0x08)
#define REG_SC_BKA6_09_L      _PK_L_(0xA6, 0x09)
#define REG_SC_BKA6_09_H      _PK_H_(0xA6, 0x09)
#define REG_SC_BKA6_0A_L      _PK_L_(0xA6, 0x0A)
#define REG_SC_BKA6_0A_H      _PK_H_(0xA6, 0x0A)
#define REG_SC_BKA6_0B_L      _PK_L_(0xA6, 0x0B)
#define REG_SC_BKA6_0B_H      _PK_H_(0xA6, 0x0B)
#define REG_SC_BKA6_0C_L      _PK_L_(0xA6, 0x0C)
#define REG_SC_BKA6_0C_H      _PK_H_(0xA6, 0x0C)
#define REG_SC_BKA6_0D_L      _PK_L_(0xA6, 0x0D)
#define REG_SC_BKA6_0D_H      _PK_H_(0xA6, 0x0D)
#define REG_SC_BKA6_0E_L      _PK_L_(0xA6, 0x0E)
#define REG_SC_BKA6_0E_H      _PK_H_(0xA6, 0x0E)
#define REG_SC_BKA6_0F_L      _PK_L_(0xA6, 0x0F)
#define REG_SC_BKA6_0F_H      _PK_H_(0xA6, 0x0F)
#define REG_SC_BKA6_10_L      _PK_L_(0xA6, 0x10)
#define REG_SC_BKA6_10_H      _PK_H_(0xA6, 0x10)
#define REG_SC_BKA6_11_L      _PK_L_(0xA6, 0x11)
#define REG_SC_BKA6_11_H      _PK_H_(0xA6, 0x11)
#define REG_SC_BKA6_12_L      _PK_L_(0xA6, 0x12)
#define REG_SC_BKA6_12_H      _PK_H_(0xA6, 0x12)
#define REG_SC_BKA6_13_L      _PK_L_(0xA6, 0x13)
#define REG_SC_BKA6_13_H      _PK_H_(0xA6, 0x13)
#define REG_SC_BKA6_14_L      _PK_L_(0xA6, 0x14)
#define REG_SC_BKA6_14_H      _PK_H_(0xA6, 0x14)
#define REG_SC_BKA6_15_L      _PK_L_(0xA6, 0x15)
#define REG_SC_BKA6_15_H      _PK_H_(0xA6, 0x15)
#define REG_SC_BKA6_16_L      _PK_L_(0xA6, 0x16)
#define REG_SC_BKA6_16_H      _PK_H_(0xA6, 0x16)
#define REG_SC_BKA6_17_L      _PK_L_(0xA6, 0x17)
#define REG_SC_BKA6_17_H      _PK_H_(0xA6, 0x17)
#define REG_SC_BKA6_18_L      _PK_L_(0xA6, 0x18)
#define REG_SC_BKA6_18_H      _PK_H_(0xA6, 0x18)
#define REG_SC_BKA6_19_L      _PK_L_(0xA6, 0x19)
#define REG_SC_BKA6_19_H      _PK_H_(0xA6, 0x19)
#define REG_SC_BKA6_1A_L      _PK_L_(0xA6, 0x1A)
#define REG_SC_BKA6_1A_H      _PK_H_(0xA6, 0x1A)
#define REG_SC_BKA6_1B_L      _PK_L_(0xA6, 0x1B)
#define REG_SC_BKA6_1B_H      _PK_H_(0xA6, 0x1B)
#define REG_SC_BKA6_1C_L      _PK_L_(0xA6, 0x1C)
#define REG_SC_BKA6_1C_H      _PK_H_(0xA6, 0x1C)
#define REG_SC_BKA6_1D_L      _PK_L_(0xA6, 0x1D)
#define REG_SC_BKA6_1D_H      _PK_H_(0xA6, 0x1D)
#define REG_SC_BKA6_1E_L      _PK_L_(0xA6, 0x1E)
#define REG_SC_BKA6_1E_H      _PK_H_(0xA6, 0x1E)
#define REG_SC_BKA6_1F_L      _PK_L_(0xA6, 0x1F)
#define REG_SC_BKA6_1F_H      _PK_H_(0xA6, 0x1F)
#define REG_SC_BKA6_20_L      _PK_L_(0xA6, 0x20)
#define REG_SC_BKA6_20_H      _PK_H_(0xA6, 0x20)
#define REG_SC_BKA6_21_L      _PK_L_(0xA6, 0x21)
#define REG_SC_BKA6_21_H      _PK_H_(0xA6, 0x21)
#define REG_SC_BKA6_22_L      _PK_L_(0xA6, 0x22)
#define REG_SC_BKA6_22_H      _PK_H_(0xA6, 0x22)
#define REG_SC_BKA6_23_L      _PK_L_(0xA6, 0x23)
#define REG_SC_BKA6_23_H      _PK_H_(0xA6, 0x23)
#define REG_SC_BKA6_24_L      _PK_L_(0xA6, 0x24)
#define REG_SC_BKA6_24_H      _PK_H_(0xA6, 0x24)
#define REG_SC_BKA6_25_L      _PK_L_(0xA6, 0x25)
#define REG_SC_BKA6_25_H      _PK_H_(0xA6, 0x25)
#define REG_SC_BKA6_26_L      _PK_L_(0xA6, 0x26)
#define REG_SC_BKA6_26_H      _PK_H_(0xA6, 0x26)
#define REG_SC_BKA6_27_L      _PK_L_(0xA6, 0x27)
#define REG_SC_BKA6_27_H      _PK_H_(0xA6, 0x27)
#define REG_SC_BKA6_28_L      _PK_L_(0xA6, 0x28)
#define REG_SC_BKA6_28_H      _PK_H_(0xA6, 0x28)
#define REG_SC_BKA6_29_L      _PK_L_(0xA6, 0x29)
#define REG_SC_BKA6_29_H      _PK_H_(0xA6, 0x29)
#define REG_SC_BKA6_2A_L      _PK_L_(0xA6, 0x2A)
#define REG_SC_BKA6_2A_H      _PK_H_(0xA6, 0x2A)
#define REG_SC_BKA6_2B_L      _PK_L_(0xA6, 0x2B)
#define REG_SC_BKA6_2B_H      _PK_H_(0xA6, 0x2B)
#define REG_SC_BKA6_2C_L      _PK_L_(0xA6, 0x2C)
#define REG_SC_BKA6_2C_H      _PK_H_(0xA6, 0x2C)
#define REG_SC_BKA6_2D_L      _PK_L_(0xA6, 0x2D)
#define REG_SC_BKA6_2D_H      _PK_H_(0xA6, 0x2D)
#define REG_SC_BKA6_2E_L      _PK_L_(0xA6, 0x2E)
#define REG_SC_BKA6_2E_H      _PK_H_(0xA6, 0x2E)
#define REG_SC_BKA6_2F_L      _PK_L_(0xA6, 0x2F)
#define REG_SC_BKA6_2F_H      _PK_H_(0xA6, 0x2F)
#define REG_SC_BKA6_30_L      _PK_L_(0xA6, 0x30)
#define REG_SC_BKA6_30_H      _PK_H_(0xA6, 0x30)
#define REG_SC_BKA6_31_L      _PK_L_(0xA6, 0x31)
#define REG_SC_BKA6_31_H      _PK_H_(0xA6, 0x31)
#define REG_SC_BKA6_32_L      _PK_L_(0xA6, 0x32)
#define REG_SC_BKA6_32_H      _PK_H_(0xA6, 0x32)
#define REG_SC_BKA6_33_L      _PK_L_(0xA6, 0x33)
#define REG_SC_BKA6_33_H      _PK_H_(0xA6, 0x33)
#define REG_SC_BKA6_34_L      _PK_L_(0xA6, 0x34)
#define REG_SC_BKA6_34_H      _PK_H_(0xA6, 0x34)
#define REG_SC_BKA6_35_L      _PK_L_(0xA6, 0x35)
#define REG_SC_BKA6_35_H      _PK_H_(0xA6, 0x35)
#define REG_SC_BKA6_36_L      _PK_L_(0xA6, 0x36)
#define REG_SC_BKA6_36_H      _PK_H_(0xA6, 0x36)
#define REG_SC_BKA6_37_L      _PK_L_(0xA6, 0x37)
#define REG_SC_BKA6_37_H      _PK_H_(0xA6, 0x37)
#define REG_SC_BKA6_38_L      _PK_L_(0xA6, 0x38)
#define REG_SC_BKA6_38_H      _PK_H_(0xA6, 0x38)
#define REG_SC_BKA6_39_L      _PK_L_(0xA6, 0x39)
#define REG_SC_BKA6_39_H      _PK_H_(0xA6, 0x39)
#define REG_SC_BKA6_3A_L      _PK_L_(0xA6, 0x3A)
#define REG_SC_BKA6_3A_H      _PK_H_(0xA6, 0x3A)
#define REG_SC_BKA6_3B_L      _PK_L_(0xA6, 0x3B)
#define REG_SC_BKA6_3B_H      _PK_H_(0xA6, 0x3B)
#define REG_SC_BKA6_3C_L      _PK_L_(0xA6, 0x3C)
#define REG_SC_BKA6_3C_H      _PK_H_(0xA6, 0x3C)
#define REG_SC_BKA6_3D_L      _PK_L_(0xA6, 0x3D)
#define REG_SC_BKA6_3D_H      _PK_H_(0xA6, 0x3D)
#define REG_SC_BKA6_3E_L      _PK_L_(0xA6, 0x3E)
#define REG_SC_BKA6_3E_H      _PK_H_(0xA6, 0x3E)
#define REG_SC_BKA6_3F_L      _PK_L_(0xA6, 0x3F)
#define REG_SC_BKA6_3F_H      _PK_H_(0xA6, 0x3F)
#define REG_SC_BKA6_40_L      _PK_L_(0xA6, 0x40)
#define REG_SC_BKA6_40_H      _PK_H_(0xA6, 0x40)
#define REG_SC_BKA6_41_L      _PK_L_(0xA6, 0x41)
#define REG_SC_BKA6_41_H      _PK_H_(0xA6, 0x41)
#define REG_SC_BKA6_42_L      _PK_L_(0xA6, 0x42)
#define REG_SC_BKA6_42_H      _PK_H_(0xA6, 0x42)
#define REG_SC_BKA6_43_L      _PK_L_(0xA6, 0x43)
#define REG_SC_BKA6_43_H      _PK_H_(0xA6, 0x43)
#define REG_SC_BKA6_44_L      _PK_L_(0xA6, 0x44)
#define REG_SC_BKA6_44_H      _PK_H_(0xA6, 0x44)
#define REG_SC_BKA6_45_L      _PK_L_(0xA6, 0x45)
#define REG_SC_BKA6_45_H      _PK_H_(0xA6, 0x45)
#define REG_SC_BKA6_46_L      _PK_L_(0xA6, 0x46)
#define REG_SC_BKA6_46_H      _PK_H_(0xA6, 0x46)
#define REG_SC_BKA6_47_L      _PK_L_(0xA6, 0x47)
#define REG_SC_BKA6_47_H      _PK_H_(0xA6, 0x47)
#define REG_SC_BKA6_48_L      _PK_L_(0xA6, 0x48)
#define REG_SC_BKA6_48_H      _PK_H_(0xA6, 0x48)
#define REG_SC_BKA6_49_L      _PK_L_(0xA6, 0x49)
#define REG_SC_BKA6_49_H      _PK_H_(0xA6, 0x49)
#define REG_SC_BKA6_4A_L      _PK_L_(0xA6, 0x4A)
#define REG_SC_BKA6_4A_H      _PK_H_(0xA6, 0x4A)
#define REG_SC_BKA6_4B_L      _PK_L_(0xA6, 0x4B)
#define REG_SC_BKA6_4B_H      _PK_H_(0xA6, 0x4B)
#define REG_SC_BKA6_4C_L      _PK_L_(0xA6, 0x4C)
#define REG_SC_BKA6_4C_H      _PK_H_(0xA6, 0x4C)
#define REG_SC_BKA6_4D_L      _PK_L_(0xA6, 0x4D)
#define REG_SC_BKA6_4D_H      _PK_H_(0xA6, 0x4D)
#define REG_SC_BKA6_4E_L      _PK_L_(0xA6, 0x4E)
#define REG_SC_BKA6_4E_H      _PK_H_(0xA6, 0x4E)
#define REG_SC_BKA6_4F_L      _PK_L_(0xA6, 0x4F)
#define REG_SC_BKA6_4F_H      _PK_H_(0xA6, 0x4F)
#define REG_SC_BKA6_50_L      _PK_L_(0xA6, 0x50)
#define REG_SC_BKA6_50_H      _PK_H_(0xA6, 0x50)
#define REG_SC_BKA6_51_L      _PK_L_(0xA6, 0x51)
#define REG_SC_BKA6_51_H      _PK_H_(0xA6, 0x51)
#define REG_SC_BKA6_52_L      _PK_L_(0xA6, 0x52)
#define REG_SC_BKA6_52_H      _PK_H_(0xA6, 0x52)
#define REG_SC_BKA6_53_L      _PK_L_(0xA6, 0x53)
#define REG_SC_BKA6_53_H      _PK_H_(0xA6, 0x53)
#define REG_SC_BKA6_54_L      _PK_L_(0xA6, 0x54)
#define REG_SC_BKA6_54_H      _PK_H_(0xA6, 0x54)
#define REG_SC_BKA6_55_L      _PK_L_(0xA6, 0x55)
#define REG_SC_BKA6_55_H      _PK_H_(0xA6, 0x55)
#define REG_SC_BKA6_56_L      _PK_L_(0xA6, 0x56)
#define REG_SC_BKA6_56_H      _PK_H_(0xA6, 0x56)
#define REG_SC_BKA6_57_L      _PK_L_(0xA6, 0x57)
#define REG_SC_BKA6_57_H      _PK_H_(0xA6, 0x57)
#define REG_SC_BKA6_58_L      _PK_L_(0xA6, 0x58)
#define REG_SC_BKA6_58_H      _PK_H_(0xA6, 0x58)
#define REG_SC_BKA6_59_L      _PK_L_(0xA6, 0x59)
#define REG_SC_BKA6_59_H      _PK_H_(0xA6, 0x59)
#define REG_SC_BKA6_5A_L      _PK_L_(0xA6, 0x5A)
#define REG_SC_BKA6_5A_H      _PK_H_(0xA6, 0x5A)
#define REG_SC_BKA6_5B_L      _PK_L_(0xA6, 0x5B)
#define REG_SC_BKA6_5B_H      _PK_H_(0xA6, 0x5B)
#define REG_SC_BKA6_5C_L      _PK_L_(0xA6, 0x5C)
#define REG_SC_BKA6_5C_H      _PK_H_(0xA6, 0x5C)
#define REG_SC_BKA6_5D_L      _PK_L_(0xA6, 0x5D)
#define REG_SC_BKA6_5D_H      _PK_H_(0xA6, 0x5D)
#define REG_SC_BKA6_5E_L      _PK_L_(0xA6, 0x5E)
#define REG_SC_BKA6_5E_H      _PK_H_(0xA6, 0x5E)
#define REG_SC_BKA6_5F_L      _PK_L_(0xA6, 0x5F)
#define REG_SC_BKA6_5F_H      _PK_H_(0xA6, 0x5F)
#define REG_SC_BKA6_60_L      _PK_L_(0xA6, 0x60)
#define REG_SC_BKA6_60_H      _PK_H_(0xA6, 0x60)
#define REG_SC_BKA6_61_L      _PK_L_(0xA6, 0x61)
#define REG_SC_BKA6_61_H      _PK_H_(0xA6, 0x61)
#define REG_SC_BKA6_62_L      _PK_L_(0xA6, 0x62)
#define REG_SC_BKA6_62_H      _PK_H_(0xA6, 0x62)
#define REG_SC_BKA6_63_L      _PK_L_(0xA6, 0x63)
#define REG_SC_BKA6_63_H      _PK_H_(0xA6, 0x63)
#define REG_SC_BKA6_64_L      _PK_L_(0xA6, 0x64)
#define REG_SC_BKA6_64_H      _PK_H_(0xA6, 0x64)
#define REG_SC_BKA6_65_L      _PK_L_(0xA6, 0x65)
#define REG_SC_BKA6_65_H      _PK_H_(0xA6, 0x65)
#define REG_SC_BKA6_66_L      _PK_L_(0xA6, 0x66)
#define REG_SC_BKA6_66_H      _PK_H_(0xA6, 0x66)
#define REG_SC_BKA6_67_L      _PK_L_(0xA6, 0x67)
#define REG_SC_BKA6_67_H      _PK_H_(0xA6, 0x67)
#define REG_SC_BKA6_68_L      _PK_L_(0xA6, 0x68)
#define REG_SC_BKA6_68_H      _PK_H_(0xA6, 0x68)
#define REG_SC_BKA6_69_L      _PK_L_(0xA6, 0x69)
#define REG_SC_BKA6_69_H      _PK_H_(0xA6, 0x69)
#define REG_SC_BKA6_6A_L      _PK_L_(0xA6, 0x6A)
#define REG_SC_BKA6_6A_H      _PK_H_(0xA6, 0x6A)
#define REG_SC_BKA6_6B_L      _PK_L_(0xA6, 0x6B)
#define REG_SC_BKA6_6B_H      _PK_H_(0xA6, 0x6B)
#define REG_SC_BKA6_6C_L      _PK_L_(0xA6, 0x6C)
#define REG_SC_BKA6_6C_H      _PK_H_(0xA6, 0x6C)
#define REG_SC_BKA6_6D_L      _PK_L_(0xA6, 0x6D)
#define REG_SC_BKA6_6D_H      _PK_H_(0xA6, 0x6D)
#define REG_SC_BKA6_6E_L      _PK_L_(0xA6, 0x6E)
#define REG_SC_BKA6_6E_H      _PK_H_(0xA6, 0x6E)
#define REG_SC_BKA6_6F_L      _PK_L_(0xA6, 0x6F)
#define REG_SC_BKA6_6F_H      _PK_H_(0xA6, 0x6F)
#define REG_SC_BKA6_70_L      _PK_L_(0xA6, 0x70)
#define REG_SC_BKA6_70_H      _PK_H_(0xA6, 0x70)
#define REG_SC_BKA6_71_L      _PK_L_(0xA6, 0x71)
#define REG_SC_BKA6_71_H      _PK_H_(0xA6, 0x71)
#define REG_SC_BKA6_72_L      _PK_L_(0xA6, 0x72)
#define REG_SC_BKA6_72_H      _PK_H_(0xA6, 0x72)
#define REG_SC_BKA6_73_L      _PK_L_(0xA6, 0x73)
#define REG_SC_BKA6_73_H      _PK_H_(0xA6, 0x73)
#define REG_SC_BKA6_74_L      _PK_L_(0xA6, 0x74)
#define REG_SC_BKA6_74_H      _PK_H_(0xA6, 0x74)
#define REG_SC_BKA6_75_L      _PK_L_(0xA6, 0x75)
#define REG_SC_BKA6_75_H      _PK_H_(0xA6, 0x75)
#define REG_SC_BKA6_76_L      _PK_L_(0xA6, 0x76)
#define REG_SC_BKA6_76_H      _PK_H_(0xA6, 0x76)
#define REG_SC_BKA6_77_L      _PK_L_(0xA6, 0x77)
#define REG_SC_BKA6_77_H      _PK_H_(0xA6, 0x77)
#define REG_SC_BKA6_78_L      _PK_L_(0xA6, 0x78)
#define REG_SC_BKA6_78_H      _PK_H_(0xA6, 0x78)
#define REG_SC_BKA6_79_L      _PK_L_(0xA6, 0x79)
#define REG_SC_BKA6_79_H      _PK_H_(0xA6, 0x79)
#define REG_SC_BKA6_7A_L      _PK_L_(0xA6, 0x7A)
#define REG_SC_BKA6_7A_H      _PK_H_(0xA6, 0x7A)
#define REG_SC_BKA6_7B_L      _PK_L_(0xA6, 0x7B)
#define REG_SC_BKA6_7B_H      _PK_H_(0xA6, 0x7B)
#define REG_SC_BKA6_7C_L      _PK_L_(0xA6, 0x7C)
#define REG_SC_BKA6_7C_H      _PK_H_(0xA6, 0x7C)
#define REG_SC_BKA6_7D_L      _PK_L_(0xA6, 0x7D)
#define REG_SC_BKA6_7D_H      _PK_H_(0xA6, 0x7D)
#define REG_SC_BKA6_7E_L      _PK_L_(0xA6, 0x7E)
#define REG_SC_BKA6_7E_H      _PK_H_(0xA6, 0x7E)
#define REG_SC_BKA6_7F_L      _PK_L_(0xA6, 0x7F)
#define REG_SC_BKA6_7F_H      _PK_H_(0xA6, 0x7F)
//----------------------------------------------
#define REG_SC_BKA7_00_L      _PK_L_(0xA7, 0x00)
#define REG_SC_BKA7_00_H      _PK_H_(0xA7, 0x00)
#define REG_SC_BKA7_01_L      _PK_L_(0xA7, 0x01)
#define REG_SC_BKA7_01_H      _PK_H_(0xA7, 0x01)
#define REG_SC_BKA7_02_L      _PK_L_(0xA7, 0x02)
#define REG_SC_BKA7_02_H      _PK_H_(0xA7, 0x02)
#define REG_SC_BKA7_03_L      _PK_L_(0xA7, 0x03)
#define REG_SC_BKA7_03_H      _PK_H_(0xA7, 0x03)
#define REG_SC_BKA7_04_L      _PK_L_(0xA7, 0x04)
#define REG_SC_BKA7_04_H      _PK_H_(0xA7, 0x04)
#define REG_SC_BKA7_05_L      _PK_L_(0xA7, 0x05)
#define REG_SC_BKA7_05_H      _PK_H_(0xA7, 0x05)
#define REG_SC_BKA7_06_L      _PK_L_(0xA7, 0x06)
#define REG_SC_BKA7_06_H      _PK_H_(0xA7, 0x06)
#define REG_SC_BKA7_07_L      _PK_L_(0xA7, 0x07)
#define REG_SC_BKA7_07_H      _PK_H_(0xA7, 0x07)
#define REG_SC_BKA7_08_L      _PK_L_(0xA7, 0x08)
#define REG_SC_BKA7_08_H      _PK_H_(0xA7, 0x08)
#define REG_SC_BKA7_09_L      _PK_L_(0xA7, 0x09)
#define REG_SC_BKA7_09_H      _PK_H_(0xA7, 0x09)
#define REG_SC_BKA7_0A_L      _PK_L_(0xA7, 0x0A)
#define REG_SC_BKA7_0A_H      _PK_H_(0xA7, 0x0A)
#define REG_SC_BKA7_0B_L      _PK_L_(0xA7, 0x0B)
#define REG_SC_BKA7_0B_H      _PK_H_(0xA7, 0x0B)
#define REG_SC_BKA7_0C_L      _PK_L_(0xA7, 0x0C)
#define REG_SC_BKA7_0C_H      _PK_H_(0xA7, 0x0C)
#define REG_SC_BKA7_0D_L      _PK_L_(0xA7, 0x0D)
#define REG_SC_BKA7_0D_H      _PK_H_(0xA7, 0x0D)
#define REG_SC_BKA7_0E_L      _PK_L_(0xA7, 0x0E)
#define REG_SC_BKA7_0E_H      _PK_H_(0xA7, 0x0E)
#define REG_SC_BKA7_0F_L      _PK_L_(0xA7, 0x0F)
#define REG_SC_BKA7_0F_H      _PK_H_(0xA7, 0x0F)
#define REG_SC_BKA7_10_L      _PK_L_(0xA7, 0x10)
#define REG_SC_BKA7_10_H      _PK_H_(0xA7, 0x10)
#define REG_SC_BKA7_11_L      _PK_L_(0xA7, 0x11)
#define REG_SC_BKA7_11_H      _PK_H_(0xA7, 0x11)
#define REG_SC_BKA7_12_L      _PK_L_(0xA7, 0x12)
#define REG_SC_BKA7_12_H      _PK_H_(0xA7, 0x12)
#define REG_SC_BKA7_13_L      _PK_L_(0xA7, 0x13)
#define REG_SC_BKA7_13_H      _PK_H_(0xA7, 0x13)
#define REG_SC_BKA7_14_L      _PK_L_(0xA7, 0x14)
#define REG_SC_BKA7_14_H      _PK_H_(0xA7, 0x14)
#define REG_SC_BKA7_15_L      _PK_L_(0xA7, 0x15)
#define REG_SC_BKA7_15_H      _PK_H_(0xA7, 0x15)
#define REG_SC_BKA7_16_L      _PK_L_(0xA7, 0x16)
#define REG_SC_BKA7_16_H      _PK_H_(0xA7, 0x16)
#define REG_SC_BKA7_17_L      _PK_L_(0xA7, 0x17)
#define REG_SC_BKA7_17_H      _PK_H_(0xA7, 0x17)
#define REG_SC_BKA7_18_L      _PK_L_(0xA7, 0x18)
#define REG_SC_BKA7_18_H      _PK_H_(0xA7, 0x18)
#define REG_SC_BKA7_19_L      _PK_L_(0xA7, 0x19)
#define REG_SC_BKA7_19_H      _PK_H_(0xA7, 0x19)
#define REG_SC_BKA7_1A_L      _PK_L_(0xA7, 0x1A)
#define REG_SC_BKA7_1A_H      _PK_H_(0xA7, 0x1A)
#define REG_SC_BKA7_1B_L      _PK_L_(0xA7, 0x1B)
#define REG_SC_BKA7_1B_H      _PK_H_(0xA7, 0x1B)
#define REG_SC_BKA7_1C_L      _PK_L_(0xA7, 0x1C)
#define REG_SC_BKA7_1C_H      _PK_H_(0xA7, 0x1C)
#define REG_SC_BKA7_1D_L      _PK_L_(0xA7, 0x1D)
#define REG_SC_BKA7_1D_H      _PK_H_(0xA7, 0x1D)
#define REG_SC_BKA7_1E_L      _PK_L_(0xA7, 0x1E)
#define REG_SC_BKA7_1E_H      _PK_H_(0xA7, 0x1E)
#define REG_SC_BKA7_1F_L      _PK_L_(0xA7, 0x1F)
#define REG_SC_BKA7_1F_H      _PK_H_(0xA7, 0x1F)
#define REG_SC_BKA7_20_L      _PK_L_(0xA7, 0x20)
#define REG_SC_BKA7_20_H      _PK_H_(0xA7, 0x20)
#define REG_SC_BKA7_21_L      _PK_L_(0xA7, 0x21)
#define REG_SC_BKA7_21_H      _PK_H_(0xA7, 0x21)
#define REG_SC_BKA7_22_L      _PK_L_(0xA7, 0x22)
#define REG_SC_BKA7_22_H      _PK_H_(0xA7, 0x22)
#define REG_SC_BKA7_23_L      _PK_L_(0xA7, 0x23)
#define REG_SC_BKA7_23_H      _PK_H_(0xA7, 0x23)
#define REG_SC_BKA7_24_L      _PK_L_(0xA7, 0x24)
#define REG_SC_BKA7_24_H      _PK_H_(0xA7, 0x24)
#define REG_SC_BKA7_25_L      _PK_L_(0xA7, 0x25)
#define REG_SC_BKA7_25_H      _PK_H_(0xA7, 0x25)
#define REG_SC_BKA7_26_L      _PK_L_(0xA7, 0x26)
#define REG_SC_BKA7_26_H      _PK_H_(0xA7, 0x26)
#define REG_SC_BKA7_27_L      _PK_L_(0xA7, 0x27)
#define REG_SC_BKA7_27_H      _PK_H_(0xA7, 0x27)
#define REG_SC_BKA7_28_L      _PK_L_(0xA7, 0x28)
#define REG_SC_BKA7_28_H      _PK_H_(0xA7, 0x28)
#define REG_SC_BKA7_29_L      _PK_L_(0xA7, 0x29)
#define REG_SC_BKA7_29_H      _PK_H_(0xA7, 0x29)
#define REG_SC_BKA7_2A_L      _PK_L_(0xA7, 0x2A)
#define REG_SC_BKA7_2A_H      _PK_H_(0xA7, 0x2A)
#define REG_SC_BKA7_2B_L      _PK_L_(0xA7, 0x2B)
#define REG_SC_BKA7_2B_H      _PK_H_(0xA7, 0x2B)
#define REG_SC_BKA7_2C_L      _PK_L_(0xA7, 0x2C)
#define REG_SC_BKA7_2C_H      _PK_H_(0xA7, 0x2C)
#define REG_SC_BKA7_2D_L      _PK_L_(0xA7, 0x2D)
#define REG_SC_BKA7_2D_H      _PK_H_(0xA7, 0x2D)
#define REG_SC_BKA7_2E_L      _PK_L_(0xA7, 0x2E)
#define REG_SC_BKA7_2E_H      _PK_H_(0xA7, 0x2E)
#define REG_SC_BKA7_2F_L      _PK_L_(0xA7, 0x2F)
#define REG_SC_BKA7_2F_H      _PK_H_(0xA7, 0x2F)
#define REG_SC_BKA7_30_L      _PK_L_(0xA7, 0x30)
#define REG_SC_BKA7_30_H      _PK_H_(0xA7, 0x30)
#define REG_SC_BKA7_31_L      _PK_L_(0xA7, 0x31)
#define REG_SC_BKA7_31_H      _PK_H_(0xA7, 0x31)
#define REG_SC_BKA7_32_L      _PK_L_(0xA7, 0x32)
#define REG_SC_BKA7_32_H      _PK_H_(0xA7, 0x32)
#define REG_SC_BKA7_33_L      _PK_L_(0xA7, 0x33)
#define REG_SC_BKA7_33_H      _PK_H_(0xA7, 0x33)
#define REG_SC_BKA7_34_L      _PK_L_(0xA7, 0x34)
#define REG_SC_BKA7_34_H      _PK_H_(0xA7, 0x34)
#define REG_SC_BKA7_35_L      _PK_L_(0xA7, 0x35)
#define REG_SC_BKA7_35_H      _PK_H_(0xA7, 0x35)
#define REG_SC_BKA7_36_L      _PK_L_(0xA7, 0x36)
#define REG_SC_BKA7_36_H      _PK_H_(0xA7, 0x36)
#define REG_SC_BKA7_37_L      _PK_L_(0xA7, 0x37)
#define REG_SC_BKA7_37_H      _PK_H_(0xA7, 0x37)
#define REG_SC_BKA7_38_L      _PK_L_(0xA7, 0x38)
#define REG_SC_BKA7_38_H      _PK_H_(0xA7, 0x38)
#define REG_SC_BKA7_39_L      _PK_L_(0xA7, 0x39)
#define REG_SC_BKA7_39_H      _PK_H_(0xA7, 0x39)
#define REG_SC_BKA7_3A_L      _PK_L_(0xA7, 0x3A)
#define REG_SC_BKA7_3A_H      _PK_H_(0xA7, 0x3A)
#define REG_SC_BKA7_3B_L      _PK_L_(0xA7, 0x3B)
#define REG_SC_BKA7_3B_H      _PK_H_(0xA7, 0x3B)
#define REG_SC_BKA7_3C_L      _PK_L_(0xA7, 0x3C)
#define REG_SC_BKA7_3C_H      _PK_H_(0xA7, 0x3C)
#define REG_SC_BKA7_3D_L      _PK_L_(0xA7, 0x3D)
#define REG_SC_BKA7_3D_H      _PK_H_(0xA7, 0x3D)
#define REG_SC_BKA7_3E_L      _PK_L_(0xA7, 0x3E)
#define REG_SC_BKA7_3E_H      _PK_H_(0xA7, 0x3E)
#define REG_SC_BKA7_3F_L      _PK_L_(0xA7, 0x3F)
#define REG_SC_BKA7_3F_H      _PK_H_(0xA7, 0x3F)
#define REG_SC_BKA7_40_L      _PK_L_(0xA7, 0x40)
#define REG_SC_BKA7_40_H      _PK_H_(0xA7, 0x40)
#define REG_SC_BKA7_41_L      _PK_L_(0xA7, 0x41)
#define REG_SC_BKA7_41_H      _PK_H_(0xA7, 0x41)
#define REG_SC_BKA7_42_L      _PK_L_(0xA7, 0x42)
#define REG_SC_BKA7_42_H      _PK_H_(0xA7, 0x42)
#define REG_SC_BKA7_43_L      _PK_L_(0xA7, 0x43)
#define REG_SC_BKA7_43_H      _PK_H_(0xA7, 0x43)
#define REG_SC_BKA7_44_L      _PK_L_(0xA7, 0x44)
#define REG_SC_BKA7_44_H      _PK_H_(0xA7, 0x44)
#define REG_SC_BKA7_45_L      _PK_L_(0xA7, 0x45)
#define REG_SC_BKA7_45_H      _PK_H_(0xA7, 0x45)
#define REG_SC_BKA7_46_L      _PK_L_(0xA7, 0x46)
#define REG_SC_BKA7_46_H      _PK_H_(0xA7, 0x46)
#define REG_SC_BKA7_47_L      _PK_L_(0xA7, 0x47)
#define REG_SC_BKA7_47_H      _PK_H_(0xA7, 0x47)
#define REG_SC_BKA7_48_L      _PK_L_(0xA7, 0x48)
#define REG_SC_BKA7_48_H      _PK_H_(0xA7, 0x48)
#define REG_SC_BKA7_49_L      _PK_L_(0xA7, 0x49)
#define REG_SC_BKA7_49_H      _PK_H_(0xA7, 0x49)
#define REG_SC_BKA7_4A_L      _PK_L_(0xA7, 0x4A)
#define REG_SC_BKA7_4A_H      _PK_H_(0xA7, 0x4A)
#define REG_SC_BKA7_4B_L      _PK_L_(0xA7, 0x4B)
#define REG_SC_BKA7_4B_H      _PK_H_(0xA7, 0x4B)
#define REG_SC_BKA7_4C_L      _PK_L_(0xA7, 0x4C)
#define REG_SC_BKA7_4C_H      _PK_H_(0xA7, 0x4C)
#define REG_SC_BKA7_4D_L      _PK_L_(0xA7, 0x4D)
#define REG_SC_BKA7_4D_H      _PK_H_(0xA7, 0x4D)
#define REG_SC_BKA7_4E_L      _PK_L_(0xA7, 0x4E)
#define REG_SC_BKA7_4E_H      _PK_H_(0xA7, 0x4E)
#define REG_SC_BKA7_4F_L      _PK_L_(0xA7, 0x4F)
#define REG_SC_BKA7_4F_H      _PK_H_(0xA7, 0x4F)
#define REG_SC_BKA7_50_L      _PK_L_(0xA7, 0x50)
#define REG_SC_BKA7_50_H      _PK_H_(0xA7, 0x50)
#define REG_SC_BKA7_51_L      _PK_L_(0xA7, 0x51)
#define REG_SC_BKA7_51_H      _PK_H_(0xA7, 0x51)
#define REG_SC_BKA7_52_L      _PK_L_(0xA7, 0x52)
#define REG_SC_BKA7_52_H      _PK_H_(0xA7, 0x52)
#define REG_SC_BKA7_53_L      _PK_L_(0xA7, 0x53)
#define REG_SC_BKA7_53_H      _PK_H_(0xA7, 0x53)
#define REG_SC_BKA7_54_L      _PK_L_(0xA7, 0x54)
#define REG_SC_BKA7_54_H      _PK_H_(0xA7, 0x54)
#define REG_SC_BKA7_55_L      _PK_L_(0xA7, 0x55)
#define REG_SC_BKA7_55_H      _PK_H_(0xA7, 0x55)
#define REG_SC_BKA7_56_L      _PK_L_(0xA7, 0x56)
#define REG_SC_BKA7_56_H      _PK_H_(0xA7, 0x56)
#define REG_SC_BKA7_57_L      _PK_L_(0xA7, 0x57)
#define REG_SC_BKA7_57_H      _PK_H_(0xA7, 0x57)
#define REG_SC_BKA7_58_L      _PK_L_(0xA7, 0x58)
#define REG_SC_BKA7_58_H      _PK_H_(0xA7, 0x58)
#define REG_SC_BKA7_59_L      _PK_L_(0xA7, 0x59)
#define REG_SC_BKA7_59_H      _PK_H_(0xA7, 0x59)
#define REG_SC_BKA7_5A_L      _PK_L_(0xA7, 0x5A)
#define REG_SC_BKA7_5A_H      _PK_H_(0xA7, 0x5A)
#define REG_SC_BKA7_5B_L      _PK_L_(0xA7, 0x5B)
#define REG_SC_BKA7_5B_H      _PK_H_(0xA7, 0x5B)
#define REG_SC_BKA7_5C_L      _PK_L_(0xA7, 0x5C)
#define REG_SC_BKA7_5C_H      _PK_H_(0xA7, 0x5C)
#define REG_SC_BKA7_5D_L      _PK_L_(0xA7, 0x5D)
#define REG_SC_BKA7_5D_H      _PK_H_(0xA7, 0x5D)
#define REG_SC_BKA7_5E_L      _PK_L_(0xA7, 0x5E)
#define REG_SC_BKA7_5E_H      _PK_H_(0xA7, 0x5E)
#define REG_SC_BKA7_5F_L      _PK_L_(0xA7, 0x5F)
#define REG_SC_BKA7_5F_H      _PK_H_(0xA7, 0x5F)
#define REG_SC_BKA7_60_L      _PK_L_(0xA7, 0x60)
#define REG_SC_BKA7_60_H      _PK_H_(0xA7, 0x60)
#define REG_SC_BKA7_61_L      _PK_L_(0xA7, 0x61)
#define REG_SC_BKA7_61_H      _PK_H_(0xA7, 0x61)
#define REG_SC_BKA7_62_L      _PK_L_(0xA7, 0x62)
#define REG_SC_BKA7_62_H      _PK_H_(0xA7, 0x62)
#define REG_SC_BKA7_63_L      _PK_L_(0xA7, 0x63)
#define REG_SC_BKA7_63_H      _PK_H_(0xA7, 0x63)
#define REG_SC_BKA7_64_L      _PK_L_(0xA7, 0x64)
#define REG_SC_BKA7_64_H      _PK_H_(0xA7, 0x64)
#define REG_SC_BKA7_65_L      _PK_L_(0xA7, 0x65)
#define REG_SC_BKA7_65_H      _PK_H_(0xA7, 0x65)
#define REG_SC_BKA7_66_L      _PK_L_(0xA7, 0x66)
#define REG_SC_BKA7_66_H      _PK_H_(0xA7, 0x66)
#define REG_SC_BKA7_67_L      _PK_L_(0xA7, 0x67)
#define REG_SC_BKA7_67_H      _PK_H_(0xA7, 0x67)
#define REG_SC_BKA7_68_L      _PK_L_(0xA7, 0x68)
#define REG_SC_BKA7_68_H      _PK_H_(0xA7, 0x68)
#define REG_SC_BKA7_69_L      _PK_L_(0xA7, 0x69)
#define REG_SC_BKA7_69_H      _PK_H_(0xA7, 0x69)
#define REG_SC_BKA7_6A_L      _PK_L_(0xA7, 0x6A)
#define REG_SC_BKA7_6A_H      _PK_H_(0xA7, 0x6A)
#define REG_SC_BKA7_6B_L      _PK_L_(0xA7, 0x6B)
#define REG_SC_BKA7_6B_H      _PK_H_(0xA7, 0x6B)
#define REG_SC_BKA7_6C_L      _PK_L_(0xA7, 0x6C)
#define REG_SC_BKA7_6C_H      _PK_H_(0xA7, 0x6C)
#define REG_SC_BKA7_6D_L      _PK_L_(0xA7, 0x6D)
#define REG_SC_BKA7_6D_H      _PK_H_(0xA7, 0x6D)
#define REG_SC_BKA7_6E_L      _PK_L_(0xA7, 0x6E)
#define REG_SC_BKA7_6E_H      _PK_H_(0xA7, 0x6E)
#define REG_SC_BKA7_6F_L      _PK_L_(0xA7, 0x6F)
#define REG_SC_BKA7_6F_H      _PK_H_(0xA7, 0x6F)
#define REG_SC_BKA7_70_L      _PK_L_(0xA7, 0x70)
#define REG_SC_BKA7_70_H      _PK_H_(0xA7, 0x70)
#define REG_SC_BKA7_71_L      _PK_L_(0xA7, 0x71)
#define REG_SC_BKA7_71_H      _PK_H_(0xA7, 0x71)
#define REG_SC_BKA7_72_L      _PK_L_(0xA7, 0x72)
#define REG_SC_BKA7_72_H      _PK_H_(0xA7, 0x72)
#define REG_SC_BKA7_73_L      _PK_L_(0xA7, 0x73)
#define REG_SC_BKA7_73_H      _PK_H_(0xA7, 0x73)
#define REG_SC_BKA7_74_L      _PK_L_(0xA7, 0x74)
#define REG_SC_BKA7_74_H      _PK_H_(0xA7, 0x74)
#define REG_SC_BKA7_75_L      _PK_L_(0xA7, 0x75)
#define REG_SC_BKA7_75_H      _PK_H_(0xA7, 0x75)
#define REG_SC_BKA7_76_L      _PK_L_(0xA7, 0x76)
#define REG_SC_BKA7_76_H      _PK_H_(0xA7, 0x76)
#define REG_SC_BKA7_77_L      _PK_L_(0xA7, 0x77)
#define REG_SC_BKA7_77_H      _PK_H_(0xA7, 0x77)
#define REG_SC_BKA7_78_L      _PK_L_(0xA7, 0x78)
#define REG_SC_BKA7_78_H      _PK_H_(0xA7, 0x78)
#define REG_SC_BKA7_79_L      _PK_L_(0xA7, 0x79)
#define REG_SC_BKA7_79_H      _PK_H_(0xA7, 0x79)
#define REG_SC_BKA7_7A_L      _PK_L_(0xA7, 0x7A)
#define REG_SC_BKA7_7A_H      _PK_H_(0xA7, 0x7A)
#define REG_SC_BKA7_7B_L      _PK_L_(0xA7, 0x7B)
#define REG_SC_BKA7_7B_H      _PK_H_(0xA7, 0x7B)
#define REG_SC_BKA7_7C_L      _PK_L_(0xA7, 0x7C)
#define REG_SC_BKA7_7C_H      _PK_H_(0xA7, 0x7C)
#define REG_SC_BKA7_7D_L      _PK_L_(0xA7, 0x7D)
#define REG_SC_BKA7_7D_H      _PK_H_(0xA7, 0x7D)
#define REG_SC_BKA7_7E_L      _PK_L_(0xA7, 0x7E)
#define REG_SC_BKA7_7E_H      _PK_H_(0xA7, 0x7E)
#define REG_SC_BKA7_7F_L      _PK_L_(0xA7, 0x7F)
#define REG_SC_BKA7_7F_H      _PK_H_(0xA7, 0x7F)
//----------------------------------------------
#define REG_SC_BKA8_00_L      _PK_L_(0xA8, 0x00)
#define REG_SC_BKA8_00_H      _PK_H_(0xA8, 0x00)
#define REG_SC_BKA8_01_L      _PK_L_(0xA8, 0x01)
#define REG_SC_BKA8_01_H      _PK_H_(0xA8, 0x01)
#define REG_SC_BKA8_02_L      _PK_L_(0xA8, 0x02)
#define REG_SC_BKA8_02_H      _PK_H_(0xA8, 0x02)
#define REG_SC_BKA8_03_L      _PK_L_(0xA8, 0x03)
#define REG_SC_BKA8_03_H      _PK_H_(0xA8, 0x03)
#define REG_SC_BKA8_04_L      _PK_L_(0xA8, 0x04)
#define REG_SC_BKA8_04_H      _PK_H_(0xA8, 0x04)
#define REG_SC_BKA8_05_L      _PK_L_(0xA8, 0x05)
#define REG_SC_BKA8_05_H      _PK_H_(0xA8, 0x05)
#define REG_SC_BKA8_06_L      _PK_L_(0xA8, 0x06)
#define REG_SC_BKA8_06_H      _PK_H_(0xA8, 0x06)
#define REG_SC_BKA8_07_L      _PK_L_(0xA8, 0x07)
#define REG_SC_BKA8_07_H      _PK_H_(0xA8, 0x07)
#define REG_SC_BKA8_08_L      _PK_L_(0xA8, 0x08)
#define REG_SC_BKA8_08_H      _PK_H_(0xA8, 0x08)
#define REG_SC_BKA8_09_L      _PK_L_(0xA8, 0x09)
#define REG_SC_BKA8_09_H      _PK_H_(0xA8, 0x09)
#define REG_SC_BKA8_0A_L      _PK_L_(0xA8, 0x0A)
#define REG_SC_BKA8_0A_H      _PK_H_(0xA8, 0x0A)
#define REG_SC_BKA8_0B_L      _PK_L_(0xA8, 0x0B)
#define REG_SC_BKA8_0B_H      _PK_H_(0xA8, 0x0B)
#define REG_SC_BKA8_0C_L      _PK_L_(0xA8, 0x0C)
#define REG_SC_BKA8_0C_H      _PK_H_(0xA8, 0x0C)
#define REG_SC_BKA8_0D_L      _PK_L_(0xA8, 0x0D)
#define REG_SC_BKA8_0D_H      _PK_H_(0xA8, 0x0D)
#define REG_SC_BKA8_0E_L      _PK_L_(0xA8, 0x0E)
#define REG_SC_BKA8_0E_H      _PK_H_(0xA8, 0x0E)
#define REG_SC_BKA8_0F_L      _PK_L_(0xA8, 0x0F)
#define REG_SC_BKA8_0F_H      _PK_H_(0xA8, 0x0F)
#define REG_SC_BKA8_10_L      _PK_L_(0xA8, 0x10)
#define REG_SC_BKA8_10_H      _PK_H_(0xA8, 0x10)
#define REG_SC_BKA8_11_L      _PK_L_(0xA8, 0x11)
#define REG_SC_BKA8_11_H      _PK_H_(0xA8, 0x11)
#define REG_SC_BKA8_12_L      _PK_L_(0xA8, 0x12)
#define REG_SC_BKA8_12_H      _PK_H_(0xA8, 0x12)
#define REG_SC_BKA8_13_L      _PK_L_(0xA8, 0x13)
#define REG_SC_BKA8_13_H      _PK_H_(0xA8, 0x13)
#define REG_SC_BKA8_14_L      _PK_L_(0xA8, 0x14)
#define REG_SC_BKA8_14_H      _PK_H_(0xA8, 0x14)
#define REG_SC_BKA8_15_L      _PK_L_(0xA8, 0x15)
#define REG_SC_BKA8_15_H      _PK_H_(0xA8, 0x15)
#define REG_SC_BKA8_16_L      _PK_L_(0xA8, 0x16)
#define REG_SC_BKA8_16_H      _PK_H_(0xA8, 0x16)
#define REG_SC_BKA8_17_L      _PK_L_(0xA8, 0x17)
#define REG_SC_BKA8_17_H      _PK_H_(0xA8, 0x17)
#define REG_SC_BKA8_18_L      _PK_L_(0xA8, 0x18)
#define REG_SC_BKA8_18_H      _PK_H_(0xA8, 0x18)
#define REG_SC_BKA8_19_L      _PK_L_(0xA8, 0x19)
#define REG_SC_BKA8_19_H      _PK_H_(0xA8, 0x19)
#define REG_SC_BKA8_1A_L      _PK_L_(0xA8, 0x1A)
#define REG_SC_BKA8_1A_H      _PK_H_(0xA8, 0x1A)
#define REG_SC_BKA8_1B_L      _PK_L_(0xA8, 0x1B)
#define REG_SC_BKA8_1B_H      _PK_H_(0xA8, 0x1B)
#define REG_SC_BKA8_1C_L      _PK_L_(0xA8, 0x1C)
#define REG_SC_BKA8_1C_H      _PK_H_(0xA8, 0x1C)
#define REG_SC_BKA8_1D_L      _PK_L_(0xA8, 0x1D)
#define REG_SC_BKA8_1D_H      _PK_H_(0xA8, 0x1D)
#define REG_SC_BKA8_1E_L      _PK_L_(0xA8, 0x1E)
#define REG_SC_BKA8_1E_H      _PK_H_(0xA8, 0x1E)
#define REG_SC_BKA8_1F_L      _PK_L_(0xA8, 0x1F)
#define REG_SC_BKA8_1F_H      _PK_H_(0xA8, 0x1F)
#define REG_SC_BKA8_20_L      _PK_L_(0xA8, 0x20)
#define REG_SC_BKA8_20_H      _PK_H_(0xA8, 0x20)
#define REG_SC_BKA8_21_L      _PK_L_(0xA8, 0x21)
#define REG_SC_BKA8_21_H      _PK_H_(0xA8, 0x21)
#define REG_SC_BKA8_22_L      _PK_L_(0xA8, 0x22)
#define REG_SC_BKA8_22_H      _PK_H_(0xA8, 0x22)
#define REG_SC_BKA8_23_L      _PK_L_(0xA8, 0x23)
#define REG_SC_BKA8_23_H      _PK_H_(0xA8, 0x23)
#define REG_SC_BKA8_24_L      _PK_L_(0xA8, 0x24)
#define REG_SC_BKA8_24_H      _PK_H_(0xA8, 0x24)
#define REG_SC_BKA8_25_L      _PK_L_(0xA8, 0x25)
#define REG_SC_BKA8_25_H      _PK_H_(0xA8, 0x25)
#define REG_SC_BKA8_26_L      _PK_L_(0xA8, 0x26)
#define REG_SC_BKA8_26_H      _PK_H_(0xA8, 0x26)
#define REG_SC_BKA8_27_L      _PK_L_(0xA8, 0x27)
#define REG_SC_BKA8_27_H      _PK_H_(0xA8, 0x27)
#define REG_SC_BKA8_28_L      _PK_L_(0xA8, 0x28)
#define REG_SC_BKA8_28_H      _PK_H_(0xA8, 0x28)
#define REG_SC_BKA8_29_L      _PK_L_(0xA8, 0x29)
#define REG_SC_BKA8_29_H      _PK_H_(0xA8, 0x29)
#define REG_SC_BKA8_2A_L      _PK_L_(0xA8, 0x2A)
#define REG_SC_BKA8_2A_H      _PK_H_(0xA8, 0x2A)
#define REG_SC_BKA8_2B_L      _PK_L_(0xA8, 0x2B)
#define REG_SC_BKA8_2B_H      _PK_H_(0xA8, 0x2B)
#define REG_SC_BKA8_2C_L      _PK_L_(0xA8, 0x2C)
#define REG_SC_BKA8_2C_H      _PK_H_(0xA8, 0x2C)
#define REG_SC_BKA8_2D_L      _PK_L_(0xA8, 0x2D)
#define REG_SC_BKA8_2D_H      _PK_H_(0xA8, 0x2D)
#define REG_SC_BKA8_2E_L      _PK_L_(0xA8, 0x2E)
#define REG_SC_BKA8_2E_H      _PK_H_(0xA8, 0x2E)
#define REG_SC_BKA8_2F_L      _PK_L_(0xA8, 0x2F)
#define REG_SC_BKA8_2F_H      _PK_H_(0xA8, 0x2F)
#define REG_SC_BKA8_30_L      _PK_L_(0xA8, 0x30)
#define REG_SC_BKA8_30_H      _PK_H_(0xA8, 0x30)
#define REG_SC_BKA8_31_L      _PK_L_(0xA8, 0x31)
#define REG_SC_BKA8_31_H      _PK_H_(0xA8, 0x31)
#define REG_SC_BKA8_32_L      _PK_L_(0xA8, 0x32)
#define REG_SC_BKA8_32_H      _PK_H_(0xA8, 0x32)
#define REG_SC_BKA8_33_L      _PK_L_(0xA8, 0x33)
#define REG_SC_BKA8_33_H      _PK_H_(0xA8, 0x33)
#define REG_SC_BKA8_34_L      _PK_L_(0xA8, 0x34)
#define REG_SC_BKA8_34_H      _PK_H_(0xA8, 0x34)
#define REG_SC_BKA8_35_L      _PK_L_(0xA8, 0x35)
#define REG_SC_BKA8_35_H      _PK_H_(0xA8, 0x35)
#define REG_SC_BKA8_36_L      _PK_L_(0xA8, 0x36)
#define REG_SC_BKA8_36_H      _PK_H_(0xA8, 0x36)
#define REG_SC_BKA8_37_L      _PK_L_(0xA8, 0x37)
#define REG_SC_BKA8_37_H      _PK_H_(0xA8, 0x37)
#define REG_SC_BKA8_38_L      _PK_L_(0xA8, 0x38)
#define REG_SC_BKA8_38_H      _PK_H_(0xA8, 0x38)
#define REG_SC_BKA8_39_L      _PK_L_(0xA8, 0x39)
#define REG_SC_BKA8_39_H      _PK_H_(0xA8, 0x39)
#define REG_SC_BKA8_3A_L      _PK_L_(0xA8, 0x3A)
#define REG_SC_BKA8_3A_H      _PK_H_(0xA8, 0x3A)
#define REG_SC_BKA8_3B_L      _PK_L_(0xA8, 0x3B)
#define REG_SC_BKA8_3B_H      _PK_H_(0xA8, 0x3B)
#define REG_SC_BKA8_3C_L      _PK_L_(0xA8, 0x3C)
#define REG_SC_BKA8_3C_H      _PK_H_(0xA8, 0x3C)
#define REG_SC_BKA8_3D_L      _PK_L_(0xA8, 0x3D)
#define REG_SC_BKA8_3D_H      _PK_H_(0xA8, 0x3D)
#define REG_SC_BKA8_3E_L      _PK_L_(0xA8, 0x3E)
#define REG_SC_BKA8_3E_H      _PK_H_(0xA8, 0x3E)
#define REG_SC_BKA8_3F_L      _PK_L_(0xA8, 0x3F)
#define REG_SC_BKA8_3F_H      _PK_H_(0xA8, 0x3F)
#define REG_SC_BKA8_40_L      _PK_L_(0xA8, 0x40)
#define REG_SC_BKA8_40_H      _PK_H_(0xA8, 0x40)
#define REG_SC_BKA8_41_L      _PK_L_(0xA8, 0x41)
#define REG_SC_BKA8_41_H      _PK_H_(0xA8, 0x41)
#define REG_SC_BKA8_42_L      _PK_L_(0xA8, 0x42)
#define REG_SC_BKA8_42_H      _PK_H_(0xA8, 0x42)
#define REG_SC_BKA8_43_L      _PK_L_(0xA8, 0x43)
#define REG_SC_BKA8_43_H      _PK_H_(0xA8, 0x43)
#define REG_SC_BKA8_44_L      _PK_L_(0xA8, 0x44)
#define REG_SC_BKA8_44_H      _PK_H_(0xA8, 0x44)
#define REG_SC_BKA8_45_L      _PK_L_(0xA8, 0x45)
#define REG_SC_BKA8_45_H      _PK_H_(0xA8, 0x45)
#define REG_SC_BKA8_46_L      _PK_L_(0xA8, 0x46)
#define REG_SC_BKA8_46_H      _PK_H_(0xA8, 0x46)
#define REG_SC_BKA8_47_L      _PK_L_(0xA8, 0x47)
#define REG_SC_BKA8_47_H      _PK_H_(0xA8, 0x47)
#define REG_SC_BKA8_48_L      _PK_L_(0xA8, 0x48)
#define REG_SC_BKA8_48_H      _PK_H_(0xA8, 0x48)
#define REG_SC_BKA8_49_L      _PK_L_(0xA8, 0x49)
#define REG_SC_BKA8_49_H      _PK_H_(0xA8, 0x49)
#define REG_SC_BKA8_4A_L      _PK_L_(0xA8, 0x4A)
#define REG_SC_BKA8_4A_H      _PK_H_(0xA8, 0x4A)
#define REG_SC_BKA8_4B_L      _PK_L_(0xA8, 0x4B)
#define REG_SC_BKA8_4B_H      _PK_H_(0xA8, 0x4B)
#define REG_SC_BKA8_4C_L      _PK_L_(0xA8, 0x4C)
#define REG_SC_BKA8_4C_H      _PK_H_(0xA8, 0x4C)
#define REG_SC_BKA8_4D_L      _PK_L_(0xA8, 0x4D)
#define REG_SC_BKA8_4D_H      _PK_H_(0xA8, 0x4D)
#define REG_SC_BKA8_4E_L      _PK_L_(0xA8, 0x4E)
#define REG_SC_BKA8_4E_H      _PK_H_(0xA8, 0x4E)
#define REG_SC_BKA8_4F_L      _PK_L_(0xA8, 0x4F)
#define REG_SC_BKA8_4F_H      _PK_H_(0xA8, 0x4F)
#define REG_SC_BKA8_50_L      _PK_L_(0xA8, 0x50)
#define REG_SC_BKA8_50_H      _PK_H_(0xA8, 0x50)
#define REG_SC_BKA8_51_L      _PK_L_(0xA8, 0x51)
#define REG_SC_BKA8_51_H      _PK_H_(0xA8, 0x51)
#define REG_SC_BKA8_52_L      _PK_L_(0xA8, 0x52)
#define REG_SC_BKA8_52_H      _PK_H_(0xA8, 0x52)
#define REG_SC_BKA8_53_L      _PK_L_(0xA8, 0x53)
#define REG_SC_BKA8_53_H      _PK_H_(0xA8, 0x53)
#define REG_SC_BKA8_54_L      _PK_L_(0xA8, 0x54)
#define REG_SC_BKA8_54_H      _PK_H_(0xA8, 0x54)
#define REG_SC_BKA8_55_L      _PK_L_(0xA8, 0x55)
#define REG_SC_BKA8_55_H      _PK_H_(0xA8, 0x55)
#define REG_SC_BKA8_56_L      _PK_L_(0xA8, 0x56)
#define REG_SC_BKA8_56_H      _PK_H_(0xA8, 0x56)
#define REG_SC_BKA8_57_L      _PK_L_(0xA8, 0x57)
#define REG_SC_BKA8_57_H      _PK_H_(0xA8, 0x57)
#define REG_SC_BKA8_58_L      _PK_L_(0xA8, 0x58)
#define REG_SC_BKA8_58_H      _PK_H_(0xA8, 0x58)
#define REG_SC_BKA8_59_L      _PK_L_(0xA8, 0x59)
#define REG_SC_BKA8_59_H      _PK_H_(0xA8, 0x59)
#define REG_SC_BKA8_5A_L      _PK_L_(0xA8, 0x5A)
#define REG_SC_BKA8_5A_H      _PK_H_(0xA8, 0x5A)
#define REG_SC_BKA8_5B_L      _PK_L_(0xA8, 0x5B)
#define REG_SC_BKA8_5B_H      _PK_H_(0xA8, 0x5B)
#define REG_SC_BKA8_5C_L      _PK_L_(0xA8, 0x5C)
#define REG_SC_BKA8_5C_H      _PK_H_(0xA8, 0x5C)
#define REG_SC_BKA8_5D_L      _PK_L_(0xA8, 0x5D)
#define REG_SC_BKA8_5D_H      _PK_H_(0xA8, 0x5D)
#define REG_SC_BKA8_5E_L      _PK_L_(0xA8, 0x5E)
#define REG_SC_BKA8_5E_H      _PK_H_(0xA8, 0x5E)
#define REG_SC_BKA8_5F_L      _PK_L_(0xA8, 0x5F)
#define REG_SC_BKA8_5F_H      _PK_H_(0xA8, 0x5F)
#define REG_SC_BKA8_60_L      _PK_L_(0xA8, 0x60)
#define REG_SC_BKA8_60_H      _PK_H_(0xA8, 0x60)
#define REG_SC_BKA8_61_L      _PK_L_(0xA8, 0x61)
#define REG_SC_BKA8_61_H      _PK_H_(0xA8, 0x61)
#define REG_SC_BKA8_62_L      _PK_L_(0xA8, 0x62)
#define REG_SC_BKA8_62_H      _PK_H_(0xA8, 0x62)
#define REG_SC_BKA8_63_L      _PK_L_(0xA8, 0x63)
#define REG_SC_BKA8_63_H      _PK_H_(0xA8, 0x63)
#define REG_SC_BKA8_64_L      _PK_L_(0xA8, 0x64)
#define REG_SC_BKA8_64_H      _PK_H_(0xA8, 0x64)
#define REG_SC_BKA8_65_L      _PK_L_(0xA8, 0x65)
#define REG_SC_BKA8_65_H      _PK_H_(0xA8, 0x65)
#define REG_SC_BKA8_66_L      _PK_L_(0xA8, 0x66)
#define REG_SC_BKA8_66_H      _PK_H_(0xA8, 0x66)
#define REG_SC_BKA8_67_L      _PK_L_(0xA8, 0x67)
#define REG_SC_BKA8_67_H      _PK_H_(0xA8, 0x67)
#define REG_SC_BKA8_68_L      _PK_L_(0xA8, 0x68)
#define REG_SC_BKA8_68_H      _PK_H_(0xA8, 0x68)
#define REG_SC_BKA8_69_L      _PK_L_(0xA8, 0x69)
#define REG_SC_BKA8_69_H      _PK_H_(0xA8, 0x69)
#define REG_SC_BKA8_6A_L      _PK_L_(0xA8, 0x6A)
#define REG_SC_BKA8_6A_H      _PK_H_(0xA8, 0x6A)
#define REG_SC_BKA8_6B_L      _PK_L_(0xA8, 0x6B)
#define REG_SC_BKA8_6B_H      _PK_H_(0xA8, 0x6B)
#define REG_SC_BKA8_6C_L      _PK_L_(0xA8, 0x6C)
#define REG_SC_BKA8_6C_H      _PK_H_(0xA8, 0x6C)
#define REG_SC_BKA8_6D_L      _PK_L_(0xA8, 0x6D)
#define REG_SC_BKA8_6D_H      _PK_H_(0xA8, 0x6D)
#define REG_SC_BKA8_6E_L      _PK_L_(0xA8, 0x6E)
#define REG_SC_BKA8_6E_H      _PK_H_(0xA8, 0x6E)
#define REG_SC_BKA8_6F_L      _PK_L_(0xA8, 0x6F)
#define REG_SC_BKA8_6F_H      _PK_H_(0xA8, 0x6F)
#define REG_SC_BKA8_70_L      _PK_L_(0xA8, 0x70)
#define REG_SC_BKA8_70_H      _PK_H_(0xA8, 0x70)
#define REG_SC_BKA8_71_L      _PK_L_(0xA8, 0x71)
#define REG_SC_BKA8_71_H      _PK_H_(0xA8, 0x71)
#define REG_SC_BKA8_72_L      _PK_L_(0xA8, 0x72)
#define REG_SC_BKA8_72_H      _PK_H_(0xA8, 0x72)
#define REG_SC_BKA8_73_L      _PK_L_(0xA8, 0x73)
#define REG_SC_BKA8_73_H      _PK_H_(0xA8, 0x73)
#define REG_SC_BKA8_74_L      _PK_L_(0xA8, 0x74)
#define REG_SC_BKA8_74_H      _PK_H_(0xA8, 0x74)
#define REG_SC_BKA8_75_L      _PK_L_(0xA8, 0x75)
#define REG_SC_BKA8_75_H      _PK_H_(0xA8, 0x75)
#define REG_SC_BKA8_76_L      _PK_L_(0xA8, 0x76)
#define REG_SC_BKA8_76_H      _PK_H_(0xA8, 0x76)
#define REG_SC_BKA8_77_L      _PK_L_(0xA8, 0x77)
#define REG_SC_BKA8_77_H      _PK_H_(0xA8, 0x77)
#define REG_SC_BKA8_78_L      _PK_L_(0xA8, 0x78)
#define REG_SC_BKA8_78_H      _PK_H_(0xA8, 0x78)
#define REG_SC_BKA8_79_L      _PK_L_(0xA8, 0x79)
#define REG_SC_BKA8_79_H      _PK_H_(0xA8, 0x79)
#define REG_SC_BKA8_7A_L      _PK_L_(0xA8, 0x7A)
#define REG_SC_BKA8_7A_H      _PK_H_(0xA8, 0x7A)
#define REG_SC_BKA8_7B_L      _PK_L_(0xA8, 0x7B)
#define REG_SC_BKA8_7B_H      _PK_H_(0xA8, 0x7B)
#define REG_SC_BKA8_7C_L      _PK_L_(0xA8, 0x7C)
#define REG_SC_BKA8_7C_H      _PK_H_(0xA8, 0x7C)
#define REG_SC_BKA8_7D_L      _PK_L_(0xA8, 0x7D)
#define REG_SC_BKA8_7D_H      _PK_H_(0xA8, 0x7D)
#define REG_SC_BKA8_7E_L      _PK_L_(0xA8, 0x7E)
#define REG_SC_BKA8_7E_H      _PK_H_(0xA8, 0x7E)
#define REG_SC_BKA8_7F_L      _PK_L_(0xA8, 0x7F)
#define REG_SC_BKA8_7F_H      _PK_H_(0xA8, 0x7F)
//----------------------------------------------
#define REG_SC_BKAA_00_L      _PK_L_(0xAA, 0x00)
#define REG_SC_BKAA_00_H      _PK_H_(0xAA, 0x00)
#define REG_SC_BKAA_01_L      _PK_L_(0xAA, 0x01)
#define REG_SC_BKAA_01_H      _PK_H_(0xAA, 0x01)
#define REG_SC_BKAA_02_L      _PK_L_(0xAA, 0x02)
#define REG_SC_BKAA_02_H      _PK_H_(0xAA, 0x02)
#define REG_SC_BKAA_03_L      _PK_L_(0xAA, 0x03)
#define REG_SC_BKAA_03_H      _PK_H_(0xAA, 0x03)
#define REG_SC_BKAA_04_L      _PK_L_(0xAA, 0x04)
#define REG_SC_BKAA_04_H      _PK_H_(0xAA, 0x04)
#define REG_SC_BKAA_05_L      _PK_L_(0xAA, 0x05)
#define REG_SC_BKAA_05_H      _PK_H_(0xAA, 0x05)
#define REG_SC_BKAA_06_L      _PK_L_(0xAA, 0x06)
#define REG_SC_BKAA_06_H      _PK_H_(0xAA, 0x06)
#define REG_SC_BKAA_07_L      _PK_L_(0xAA, 0x07)
#define REG_SC_BKAA_07_H      _PK_H_(0xAA, 0x07)
#define REG_SC_BKAA_08_L      _PK_L_(0xAA, 0x08)
#define REG_SC_BKAA_08_H      _PK_H_(0xAA, 0x08)
#define REG_SC_BKAA_09_L      _PK_L_(0xAA, 0x09)
#define REG_SC_BKAA_09_H      _PK_H_(0xAA, 0x09)
#define REG_SC_BKAA_0A_L      _PK_L_(0xAA, 0x0A)
#define REG_SC_BKAA_0A_H      _PK_H_(0xAA, 0x0A)
#define REG_SC_BKAA_0B_L      _PK_L_(0xAA, 0x0B)
#define REG_SC_BKAA_0B_H      _PK_H_(0xAA, 0x0B)
#define REG_SC_BKAA_0C_L      _PK_L_(0xAA, 0x0C)
#define REG_SC_BKAA_0C_H      _PK_H_(0xAA, 0x0C)
#define REG_SC_BKAA_0D_L      _PK_L_(0xAA, 0x0D)
#define REG_SC_BKAA_0D_H      _PK_H_(0xAA, 0x0D)
#define REG_SC_BKAA_0E_L      _PK_L_(0xAA, 0x0E)
#define REG_SC_BKAA_0E_H      _PK_H_(0xAA, 0x0E)
#define REG_SC_BKAA_0F_L      _PK_L_(0xAA, 0x0F)
#define REG_SC_BKAA_0F_H      _PK_H_(0xAA, 0x0F)
#define REG_SC_BKAA_10_L      _PK_L_(0xAA, 0x10)
#define REG_SC_BKAA_10_H      _PK_H_(0xAA, 0x10)
#define REG_SC_BKAA_11_L      _PK_L_(0xAA, 0x11)
#define REG_SC_BKAA_11_H      _PK_H_(0xAA, 0x11)
#define REG_SC_BKAA_12_L      _PK_L_(0xAA, 0x12)
#define REG_SC_BKAA_12_H      _PK_H_(0xAA, 0x12)
#define REG_SC_BKAA_13_L      _PK_L_(0xAA, 0x13)
#define REG_SC_BKAA_13_H      _PK_H_(0xAA, 0x13)
#define REG_SC_BKAA_14_L      _PK_L_(0xAA, 0x14)
#define REG_SC_BKAA_14_H      _PK_H_(0xAA, 0x14)
#define REG_SC_BKAA_15_L      _PK_L_(0xAA, 0x15)
#define REG_SC_BKAA_15_H      _PK_H_(0xAA, 0x15)
#define REG_SC_BKAA_16_L      _PK_L_(0xAA, 0x16)
#define REG_SC_BKAA_16_H      _PK_H_(0xAA, 0x16)
#define REG_SC_BKAA_17_L      _PK_L_(0xAA, 0x17)
#define REG_SC_BKAA_17_H      _PK_H_(0xAA, 0x17)
#define REG_SC_BKAA_18_L      _PK_L_(0xAA, 0x18)
#define REG_SC_BKAA_18_H      _PK_H_(0xAA, 0x18)
#define REG_SC_BKAA_19_L      _PK_L_(0xAA, 0x19)
#define REG_SC_BKAA_19_H      _PK_H_(0xAA, 0x19)
#define REG_SC_BKAA_1A_L      _PK_L_(0xAA, 0x1A)
#define REG_SC_BKAA_1A_H      _PK_H_(0xAA, 0x1A)
#define REG_SC_BKAA_1B_L      _PK_L_(0xAA, 0x1B)
#define REG_SC_BKAA_1B_H      _PK_H_(0xAA, 0x1B)
#define REG_SC_BKAA_1C_L      _PK_L_(0xAA, 0x1C)
#define REG_SC_BKAA_1C_H      _PK_H_(0xAA, 0x1C)
#define REG_SC_BKAA_1D_L      _PK_L_(0xAA, 0x1D)
#define REG_SC_BKAA_1D_H      _PK_H_(0xAA, 0x1D)
#define REG_SC_BKAA_1E_L      _PK_L_(0xAA, 0x1E)
#define REG_SC_BKAA_1E_H      _PK_H_(0xAA, 0x1E)
#define REG_SC_BKAA_1F_L      _PK_L_(0xAA, 0x1F)
#define REG_SC_BKAA_1F_H      _PK_H_(0xAA, 0x1F)
#define REG_SC_BKAA_20_L      _PK_L_(0xAA, 0x20)
#define REG_SC_BKAA_20_H      _PK_H_(0xAA, 0x20)
#define REG_SC_BKAA_21_L      _PK_L_(0xAA, 0x21)
#define REG_SC_BKAA_21_H      _PK_H_(0xAA, 0x21)
#define REG_SC_BKAA_22_L      _PK_L_(0xAA, 0x22)
#define REG_SC_BKAA_22_H      _PK_H_(0xAA, 0x22)
#define REG_SC_BKAA_23_L      _PK_L_(0xAA, 0x23)
#define REG_SC_BKAA_23_H      _PK_H_(0xAA, 0x23)
#define REG_SC_BKAA_24_L      _PK_L_(0xAA, 0x24)
#define REG_SC_BKAA_24_H      _PK_H_(0xAA, 0x24)
#define REG_SC_BKAA_25_L      _PK_L_(0xAA, 0x25)
#define REG_SC_BKAA_25_H      _PK_H_(0xAA, 0x25)
#define REG_SC_BKAA_26_L      _PK_L_(0xAA, 0x26)
#define REG_SC_BKAA_26_H      _PK_H_(0xAA, 0x26)
#define REG_SC_BKAA_27_L      _PK_L_(0xAA, 0x27)
#define REG_SC_BKAA_27_H      _PK_H_(0xAA, 0x27)
#define REG_SC_BKAA_28_L      _PK_L_(0xAA, 0x28)
#define REG_SC_BKAA_28_H      _PK_H_(0xAA, 0x28)
#define REG_SC_BKAA_29_L      _PK_L_(0xAA, 0x29)
#define REG_SC_BKAA_29_H      _PK_H_(0xAA, 0x29)
#define REG_SC_BKAA_2A_L      _PK_L_(0xAA, 0x2A)
#define REG_SC_BKAA_2A_H      _PK_H_(0xAA, 0x2A)
#define REG_SC_BKAA_2B_L      _PK_L_(0xAA, 0x2B)
#define REG_SC_BKAA_2B_H      _PK_H_(0xAA, 0x2B)
#define REG_SC_BKAA_2C_L      _PK_L_(0xAA, 0x2C)
#define REG_SC_BKAA_2C_H      _PK_H_(0xAA, 0x2C)
#define REG_SC_BKAA_2D_L      _PK_L_(0xAA, 0x2D)
#define REG_SC_BKAA_2D_H      _PK_H_(0xAA, 0x2D)
#define REG_SC_BKAA_2E_L      _PK_L_(0xAA, 0x2E)
#define REG_SC_BKAA_2E_H      _PK_H_(0xAA, 0x2E)
#define REG_SC_BKAA_2F_L      _PK_L_(0xAA, 0x2F)
#define REG_SC_BKAA_2F_H      _PK_H_(0xAA, 0x2F)
#define REG_SC_BKAA_30_L      _PK_L_(0xAA, 0x30)
#define REG_SC_BKAA_30_H      _PK_H_(0xAA, 0x30)
#define REG_SC_BKAA_31_L      _PK_L_(0xAA, 0x31)
#define REG_SC_BKAA_31_H      _PK_H_(0xAA, 0x31)
#define REG_SC_BKAA_32_L      _PK_L_(0xAA, 0x32)
#define REG_SC_BKAA_32_H      _PK_H_(0xAA, 0x32)
#define REG_SC_BKAA_33_L      _PK_L_(0xAA, 0x33)
#define REG_SC_BKAA_33_H      _PK_H_(0xAA, 0x33)
#define REG_SC_BKAA_34_L      _PK_L_(0xAA, 0x34)
#define REG_SC_BKAA_34_H      _PK_H_(0xAA, 0x34)
#define REG_SC_BKAA_35_L      _PK_L_(0xAA, 0x35)
#define REG_SC_BKAA_35_H      _PK_H_(0xAA, 0x35)
#define REG_SC_BKAA_36_L      _PK_L_(0xAA, 0x36)
#define REG_SC_BKAA_36_H      _PK_H_(0xAA, 0x36)
#define REG_SC_BKAA_37_L      _PK_L_(0xAA, 0x37)
#define REG_SC_BKAA_37_H      _PK_H_(0xAA, 0x37)
#define REG_SC_BKAA_38_L      _PK_L_(0xAA, 0x38)
#define REG_SC_BKAA_38_H      _PK_H_(0xAA, 0x38)
#define REG_SC_BKAA_39_L      _PK_L_(0xAA, 0x39)
#define REG_SC_BKAA_39_H      _PK_H_(0xAA, 0x39)
#define REG_SC_BKAA_3A_L      _PK_L_(0xAA, 0x3A)
#define REG_SC_BKAA_3A_H      _PK_H_(0xAA, 0x3A)
#define REG_SC_BKAA_3B_L      _PK_L_(0xAA, 0x3B)
#define REG_SC_BKAA_3B_H      _PK_H_(0xAA, 0x3B)
#define REG_SC_BKAA_3C_L      _PK_L_(0xAA, 0x3C)
#define REG_SC_BKAA_3C_H      _PK_H_(0xAA, 0x3C)
#define REG_SC_BKAA_3D_L      _PK_L_(0xAA, 0x3D)
#define REG_SC_BKAA_3D_H      _PK_H_(0xAA, 0x3D)
#define REG_SC_BKAA_3E_L      _PK_L_(0xAA, 0x3E)
#define REG_SC_BKAA_3E_H      _PK_H_(0xAA, 0x3E)
#define REG_SC_BKAA_3F_L      _PK_L_(0xAA, 0x3F)
#define REG_SC_BKAA_3F_H      _PK_H_(0xAA, 0x3F)
#define REG_SC_BKAA_40_L      _PK_L_(0xAA, 0x40)
#define REG_SC_BKAA_40_H      _PK_H_(0xAA, 0x40)
#define REG_SC_BKAA_41_L      _PK_L_(0xAA, 0x41)
#define REG_SC_BKAA_41_H      _PK_H_(0xAA, 0x41)
#define REG_SC_BKAA_42_L      _PK_L_(0xAA, 0x42)
#define REG_SC_BKAA_42_H      _PK_H_(0xAA, 0x42)
#define REG_SC_BKAA_43_L      _PK_L_(0xAA, 0x43)
#define REG_SC_BKAA_43_H      _PK_H_(0xAA, 0x43)
#define REG_SC_BKAA_44_L      _PK_L_(0xAA, 0x44)
#define REG_SC_BKAA_44_H      _PK_H_(0xAA, 0x44)
#define REG_SC_BKAA_45_L      _PK_L_(0xAA, 0x45)
#define REG_SC_BKAA_45_H      _PK_H_(0xAA, 0x45)
#define REG_SC_BKAA_46_L      _PK_L_(0xAA, 0x46)
#define REG_SC_BKAA_46_H      _PK_H_(0xAA, 0x46)
#define REG_SC_BKAA_47_L      _PK_L_(0xAA, 0x47)
#define REG_SC_BKAA_47_H      _PK_H_(0xAA, 0x47)
#define REG_SC_BKAA_48_L      _PK_L_(0xAA, 0x48)
#define REG_SC_BKAA_48_H      _PK_H_(0xAA, 0x48)
#define REG_SC_BKAA_49_L      _PK_L_(0xAA, 0x49)
#define REG_SC_BKAA_49_H      _PK_H_(0xAA, 0x49)
#define REG_SC_BKAA_4A_L      _PK_L_(0xAA, 0x4A)
#define REG_SC_BKAA_4A_H      _PK_H_(0xAA, 0x4A)
#define REG_SC_BKAA_4B_L      _PK_L_(0xAA, 0x4B)
#define REG_SC_BKAA_4B_H      _PK_H_(0xAA, 0x4B)
#define REG_SC_BKAA_4C_L      _PK_L_(0xAA, 0x4C)
#define REG_SC_BKAA_4C_H      _PK_H_(0xAA, 0x4C)
#define REG_SC_BKAA_4D_L      _PK_L_(0xAA, 0x4D)
#define REG_SC_BKAA_4D_H      _PK_H_(0xAA, 0x4D)
#define REG_SC_BKAA_4E_L      _PK_L_(0xAA, 0x4E)
#define REG_SC_BKAA_4E_H      _PK_H_(0xAA, 0x4E)
#define REG_SC_BKAA_4F_L      _PK_L_(0xAA, 0x4F)
#define REG_SC_BKAA_4F_H      _PK_H_(0xAA, 0x4F)
#define REG_SC_BKAA_50_L      _PK_L_(0xAA, 0x50)
#define REG_SC_BKAA_50_H      _PK_H_(0xAA, 0x50)
#define REG_SC_BKAA_51_L      _PK_L_(0xAA, 0x51)
#define REG_SC_BKAA_51_H      _PK_H_(0xAA, 0x51)
#define REG_SC_BKAA_52_L      _PK_L_(0xAA, 0x52)
#define REG_SC_BKAA_52_H      _PK_H_(0xAA, 0x52)
#define REG_SC_BKAA_53_L      _PK_L_(0xAA, 0x53)
#define REG_SC_BKAA_53_H      _PK_H_(0xAA, 0x53)
#define REG_SC_BKAA_54_L      _PK_L_(0xAA, 0x54)
#define REG_SC_BKAA_54_H      _PK_H_(0xAA, 0x54)
#define REG_SC_BKAA_55_L      _PK_L_(0xAA, 0x55)
#define REG_SC_BKAA_55_H      _PK_H_(0xAA, 0x55)
#define REG_SC_BKAA_56_L      _PK_L_(0xAA, 0x56)
#define REG_SC_BKAA_56_H      _PK_H_(0xAA, 0x56)
#define REG_SC_BKAA_57_L      _PK_L_(0xAA, 0x57)
#define REG_SC_BKAA_57_H      _PK_H_(0xAA, 0x57)
#define REG_SC_BKAA_58_L      _PK_L_(0xAA, 0x58)
#define REG_SC_BKAA_58_H      _PK_H_(0xAA, 0x58)
#define REG_SC_BKAA_59_L      _PK_L_(0xAA, 0x59)
#define REG_SC_BKAA_59_H      _PK_H_(0xAA, 0x59)
#define REG_SC_BKAA_5A_L      _PK_L_(0xAA, 0x5A)
#define REG_SC_BKAA_5A_H      _PK_H_(0xAA, 0x5A)
#define REG_SC_BKAA_5B_L      _PK_L_(0xAA, 0x5B)
#define REG_SC_BKAA_5B_H      _PK_H_(0xAA, 0x5B)
#define REG_SC_BKAA_5C_L      _PK_L_(0xAA, 0x5C)
#define REG_SC_BKAA_5C_H      _PK_H_(0xAA, 0x5C)
#define REG_SC_BKAA_5D_L      _PK_L_(0xAA, 0x5D)
#define REG_SC_BKAA_5D_H      _PK_H_(0xAA, 0x5D)
#define REG_SC_BKAA_5E_L      _PK_L_(0xAA, 0x5E)
#define REG_SC_BKAA_5E_H      _PK_H_(0xAA, 0x5E)
#define REG_SC_BKAA_5F_L      _PK_L_(0xAA, 0x5F)
#define REG_SC_BKAA_5F_H      _PK_H_(0xAA, 0x5F)
#define REG_SC_BKAA_60_L      _PK_L_(0xAA, 0x60)
#define REG_SC_BKAA_60_H      _PK_H_(0xAA, 0x60)
#define REG_SC_BKAA_61_L      _PK_L_(0xAA, 0x61)
#define REG_SC_BKAA_61_H      _PK_H_(0xAA, 0x61)
#define REG_SC_BKAA_62_L      _PK_L_(0xAA, 0x62)
#define REG_SC_BKAA_62_H      _PK_H_(0xAA, 0x62)
#define REG_SC_BKAA_63_L      _PK_L_(0xAA, 0x63)
#define REG_SC_BKAA_63_H      _PK_H_(0xAA, 0x63)
#define REG_SC_BKAA_64_L      _PK_L_(0xAA, 0x64)
#define REG_SC_BKAA_64_H      _PK_H_(0xAA, 0x64)
#define REG_SC_BKAA_65_L      _PK_L_(0xAA, 0x65)
#define REG_SC_BKAA_65_H      _PK_H_(0xAA, 0x65)
#define REG_SC_BKAA_66_L      _PK_L_(0xAA, 0x66)
#define REG_SC_BKAA_66_H      _PK_H_(0xAA, 0x66)
#define REG_SC_BKAA_67_L      _PK_L_(0xAA, 0x67)
#define REG_SC_BKAA_67_H      _PK_H_(0xAA, 0x67)
#define REG_SC_BKAA_68_L      _PK_L_(0xAA, 0x68)
#define REG_SC_BKAA_68_H      _PK_H_(0xAA, 0x68)
#define REG_SC_BKAA_69_L      _PK_L_(0xAA, 0x69)
#define REG_SC_BKAA_69_H      _PK_H_(0xAA, 0x69)
#define REG_SC_BKAA_6A_L      _PK_L_(0xAA, 0x6A)
#define REG_SC_BKAA_6A_H      _PK_H_(0xAA, 0x6A)
#define REG_SC_BKAA_6B_L      _PK_L_(0xAA, 0x6B)
#define REG_SC_BKAA_6B_H      _PK_H_(0xAA, 0x6B)
#define REG_SC_BKAA_6C_L      _PK_L_(0xAA, 0x6C)
#define REG_SC_BKAA_6C_H      _PK_H_(0xAA, 0x6C)
#define REG_SC_BKAA_6D_L      _PK_L_(0xAA, 0x6D)
#define REG_SC_BKAA_6D_H      _PK_H_(0xAA, 0x6D)
#define REG_SC_BKAA_6E_L      _PK_L_(0xAA, 0x6E)
#define REG_SC_BKAA_6E_H      _PK_H_(0xAA, 0x6E)
#define REG_SC_BKAA_6F_L      _PK_L_(0xAA, 0x6F)
#define REG_SC_BKAA_6F_H      _PK_H_(0xAA, 0x6F)
#define REG_SC_BKAA_70_L      _PK_L_(0xAA, 0x70)
#define REG_SC_BKAA_70_H      _PK_H_(0xAA, 0x70)
#define REG_SC_BKAA_71_L      _PK_L_(0xAA, 0x71)
#define REG_SC_BKAA_71_H      _PK_H_(0xAA, 0x71)
#define REG_SC_BKAA_72_L      _PK_L_(0xAA, 0x72)
#define REG_SC_BKAA_72_H      _PK_H_(0xAA, 0x72)
#define REG_SC_BKAA_73_L      _PK_L_(0xAA, 0x73)
#define REG_SC_BKAA_73_H      _PK_H_(0xAA, 0x73)
#define REG_SC_BKAA_74_L      _PK_L_(0xAA, 0x74)
#define REG_SC_BKAA_74_H      _PK_H_(0xAA, 0x74)
#define REG_SC_BKAA_75_L      _PK_L_(0xAA, 0x75)
#define REG_SC_BKAA_75_H      _PK_H_(0xAA, 0x75)
#define REG_SC_BKAA_76_L      _PK_L_(0xAA, 0x76)
#define REG_SC_BKAA_76_H      _PK_H_(0xAA, 0x76)
#define REG_SC_BKAA_77_L      _PK_L_(0xAA, 0x77)
#define REG_SC_BKAA_77_H      _PK_H_(0xAA, 0x77)
#define REG_SC_BKAA_78_L      _PK_L_(0xAA, 0x78)
#define REG_SC_BKAA_78_H      _PK_H_(0xAA, 0x78)
#define REG_SC_BKAA_79_L      _PK_L_(0xAA, 0x79)
#define REG_SC_BKAA_79_H      _PK_H_(0xAA, 0x79)
#define REG_SC_BKAA_7A_L      _PK_L_(0xAA, 0x7A)
#define REG_SC_BKAA_7A_H      _PK_H_(0xAA, 0x7A)
#define REG_SC_BKAA_7B_L      _PK_L_(0xAA, 0x7B)
#define REG_SC_BKAA_7B_H      _PK_H_(0xAA, 0x7B)
#define REG_SC_BKAA_7C_L      _PK_L_(0xAA, 0x7C)
#define REG_SC_BKAA_7C_H      _PK_H_(0xAA, 0x7C)
#define REG_SC_BKAA_7D_L      _PK_L_(0xAA, 0x7D)
#define REG_SC_BKAA_7D_H      _PK_H_(0xAA, 0x7D)
#define REG_SC_BKAA_7E_L      _PK_L_(0xAA, 0x7E)
#define REG_SC_BKAA_7E_H      _PK_H_(0xAA, 0x7E)
#define REG_SC_BKAA_7F_L      _PK_L_(0xAA, 0x7F)
#define REG_SC_BKAA_7F_H      _PK_H_(0xAA, 0x7F)
//----------------------------------------------
#define REG_SC_BKAB_00_L      _PK_L_(0xAB, 0x00)
#define REG_SC_BKAB_00_H      _PK_H_(0xAB, 0x00)
#define REG_SC_BKAB_01_L      _PK_L_(0xAB, 0x01)
#define REG_SC_BKAB_01_H      _PK_H_(0xAB, 0x01)
#define REG_SC_BKAB_02_L      _PK_L_(0xAB, 0x02)
#define REG_SC_BKAB_02_H      _PK_H_(0xAB, 0x02)
#define REG_SC_BKAB_03_L      _PK_L_(0xAB, 0x03)
#define REG_SC_BKAB_03_H      _PK_H_(0xAB, 0x03)
#define REG_SC_BKAB_04_L      _PK_L_(0xAB, 0x04)
#define REG_SC_BKAB_04_H      _PK_H_(0xAB, 0x04)
#define REG_SC_BKAB_05_L      _PK_L_(0xAB, 0x05)
#define REG_SC_BKAB_05_H      _PK_H_(0xAB, 0x05)
#define REG_SC_BKAB_06_L      _PK_L_(0xAB, 0x06)
#define REG_SC_BKAB_06_H      _PK_H_(0xAB, 0x06)
#define REG_SC_BKAB_07_L      _PK_L_(0xAB, 0x07)
#define REG_SC_BKAB_07_H      _PK_H_(0xAB, 0x07)
#define REG_SC_BKAB_08_L      _PK_L_(0xAB, 0x08)
#define REG_SC_BKAB_08_H      _PK_H_(0xAB, 0x08)
#define REG_SC_BKAB_09_L      _PK_L_(0xAB, 0x09)
#define REG_SC_BKAB_09_H      _PK_H_(0xAB, 0x09)
#define REG_SC_BKAB_0A_L      _PK_L_(0xAB, 0x0A)
#define REG_SC_BKAB_0A_H      _PK_H_(0xAB, 0x0A)
#define REG_SC_BKAB_0B_L      _PK_L_(0xAB, 0x0B)
#define REG_SC_BKAB_0B_H      _PK_H_(0xAB, 0x0B)
#define REG_SC_BKAB_0C_L      _PK_L_(0xAB, 0x0C)
#define REG_SC_BKAB_0C_H      _PK_H_(0xAB, 0x0C)
#define REG_SC_BKAB_0D_L      _PK_L_(0xAB, 0x0D)
#define REG_SC_BKAB_0D_H      _PK_H_(0xAB, 0x0D)
#define REG_SC_BKAB_0E_L      _PK_L_(0xAB, 0x0E)
#define REG_SC_BKAB_0E_H      _PK_H_(0xAB, 0x0E)
#define REG_SC_BKAB_0F_L      _PK_L_(0xAB, 0x0F)
#define REG_SC_BKAB_0F_H      _PK_H_(0xAB, 0x0F)
#define REG_SC_BKAB_10_L      _PK_L_(0xAB, 0x10)
#define REG_SC_BKAB_10_H      _PK_H_(0xAB, 0x10)
#define REG_SC_BKAB_11_L      _PK_L_(0xAB, 0x11)
#define REG_SC_BKAB_11_H      _PK_H_(0xAB, 0x11)
#define REG_SC_BKAB_12_L      _PK_L_(0xAB, 0x12)
#define REG_SC_BKAB_12_H      _PK_H_(0xAB, 0x12)
#define REG_SC_BKAB_13_L      _PK_L_(0xAB, 0x13)
#define REG_SC_BKAB_13_H      _PK_H_(0xAB, 0x13)
#define REG_SC_BKAB_14_L      _PK_L_(0xAB, 0x14)
#define REG_SC_BKAB_14_H      _PK_H_(0xAB, 0x14)
#define REG_SC_BKAB_15_L      _PK_L_(0xAB, 0x15)
#define REG_SC_BKAB_15_H      _PK_H_(0xAB, 0x15)
#define REG_SC_BKAB_16_L      _PK_L_(0xAB, 0x16)
#define REG_SC_BKAB_16_H      _PK_H_(0xAB, 0x16)
#define REG_SC_BKAB_17_L      _PK_L_(0xAB, 0x17)
#define REG_SC_BKAB_17_H      _PK_H_(0xAB, 0x17)
#define REG_SC_BKAB_18_L      _PK_L_(0xAB, 0x18)
#define REG_SC_BKAB_18_H      _PK_H_(0xAB, 0x18)
#define REG_SC_BKAB_19_L      _PK_L_(0xAB, 0x19)
#define REG_SC_BKAB_19_H      _PK_H_(0xAB, 0x19)
#define REG_SC_BKAB_1A_L      _PK_L_(0xAB, 0x1A)
#define REG_SC_BKAB_1A_H      _PK_H_(0xAB, 0x1A)
#define REG_SC_BKAB_1B_L      _PK_L_(0xAB, 0x1B)
#define REG_SC_BKAB_1B_H      _PK_H_(0xAB, 0x1B)
#define REG_SC_BKAB_1C_L      _PK_L_(0xAB, 0x1C)
#define REG_SC_BKAB_1C_H      _PK_H_(0xAB, 0x1C)
#define REG_SC_BKAB_1D_L      _PK_L_(0xAB, 0x1D)
#define REG_SC_BKAB_1D_H      _PK_H_(0xAB, 0x1D)
#define REG_SC_BKAB_1E_L      _PK_L_(0xAB, 0x1E)
#define REG_SC_BKAB_1E_H      _PK_H_(0xAB, 0x1E)
#define REG_SC_BKAB_1F_L      _PK_L_(0xAB, 0x1F)
#define REG_SC_BKAB_1F_H      _PK_H_(0xAB, 0x1F)
#define REG_SC_BKAB_20_L      _PK_L_(0xAB, 0x20)
#define REG_SC_BKAB_20_H      _PK_H_(0xAB, 0x20)
#define REG_SC_BKAB_21_L      _PK_L_(0xAB, 0x21)
#define REG_SC_BKAB_21_H      _PK_H_(0xAB, 0x21)
#define REG_SC_BKAB_22_L      _PK_L_(0xAB, 0x22)
#define REG_SC_BKAB_22_H      _PK_H_(0xAB, 0x22)
#define REG_SC_BKAB_23_L      _PK_L_(0xAB, 0x23)
#define REG_SC_BKAB_23_H      _PK_H_(0xAB, 0x23)
#define REG_SC_BKAB_24_L      _PK_L_(0xAB, 0x24)
#define REG_SC_BKAB_24_H      _PK_H_(0xAB, 0x24)
#define REG_SC_BKAB_25_L      _PK_L_(0xAB, 0x25)
#define REG_SC_BKAB_25_H      _PK_H_(0xAB, 0x25)
#define REG_SC_BKAB_26_L      _PK_L_(0xAB, 0x26)
#define REG_SC_BKAB_26_H      _PK_H_(0xAB, 0x26)
#define REG_SC_BKAB_27_L      _PK_L_(0xAB, 0x27)
#define REG_SC_BKAB_27_H      _PK_H_(0xAB, 0x27)
#define REG_SC_BKAB_28_L      _PK_L_(0xAB, 0x28)
#define REG_SC_BKAB_28_H      _PK_H_(0xAB, 0x28)
#define REG_SC_BKAB_29_L      _PK_L_(0xAB, 0x29)
#define REG_SC_BKAB_29_H      _PK_H_(0xAB, 0x29)
#define REG_SC_BKAB_2A_L      _PK_L_(0xAB, 0x2A)
#define REG_SC_BKAB_2A_H      _PK_H_(0xAB, 0x2A)
#define REG_SC_BKAB_2B_L      _PK_L_(0xAB, 0x2B)
#define REG_SC_BKAB_2B_H      _PK_H_(0xAB, 0x2B)
#define REG_SC_BKAB_2C_L      _PK_L_(0xAB, 0x2C)
#define REG_SC_BKAB_2C_H      _PK_H_(0xAB, 0x2C)
#define REG_SC_BKAB_2D_L      _PK_L_(0xAB, 0x2D)
#define REG_SC_BKAB_2D_H      _PK_H_(0xAB, 0x2D)
#define REG_SC_BKAB_2E_L      _PK_L_(0xAB, 0x2E)
#define REG_SC_BKAB_2E_H      _PK_H_(0xAB, 0x2E)
#define REG_SC_BKAB_2F_L      _PK_L_(0xAB, 0x2F)
#define REG_SC_BKAB_2F_H      _PK_H_(0xAB, 0x2F)
#define REG_SC_BKAB_30_L      _PK_L_(0xAB, 0x30)
#define REG_SC_BKAB_30_H      _PK_H_(0xAB, 0x30)
#define REG_SC_BKAB_31_L      _PK_L_(0xAB, 0x31)
#define REG_SC_BKAB_31_H      _PK_H_(0xAB, 0x31)
#define REG_SC_BKAB_32_L      _PK_L_(0xAB, 0x32)
#define REG_SC_BKAB_32_H      _PK_H_(0xAB, 0x32)
#define REG_SC_BKAB_33_L      _PK_L_(0xAB, 0x33)
#define REG_SC_BKAB_33_H      _PK_H_(0xAB, 0x33)
#define REG_SC_BKAB_34_L      _PK_L_(0xAB, 0x34)
#define REG_SC_BKAB_34_H      _PK_H_(0xAB, 0x34)
#define REG_SC_BKAB_35_L      _PK_L_(0xAB, 0x35)
#define REG_SC_BKAB_35_H      _PK_H_(0xAB, 0x35)
#define REG_SC_BKAB_36_L      _PK_L_(0xAB, 0x36)
#define REG_SC_BKAB_36_H      _PK_H_(0xAB, 0x36)
#define REG_SC_BKAB_37_L      _PK_L_(0xAB, 0x37)
#define REG_SC_BKAB_37_H      _PK_H_(0xAB, 0x37)
#define REG_SC_BKAB_38_L      _PK_L_(0xAB, 0x38)
#define REG_SC_BKAB_38_H      _PK_H_(0xAB, 0x38)
#define REG_SC_BKAB_39_L      _PK_L_(0xAB, 0x39)
#define REG_SC_BKAB_39_H      _PK_H_(0xAB, 0x39)
#define REG_SC_BKAB_3A_L      _PK_L_(0xAB, 0x3A)
#define REG_SC_BKAB_3A_H      _PK_H_(0xAB, 0x3A)
#define REG_SC_BKAB_3B_L      _PK_L_(0xAB, 0x3B)
#define REG_SC_BKAB_3B_H      _PK_H_(0xAB, 0x3B)
#define REG_SC_BKAB_3C_L      _PK_L_(0xAB, 0x3C)
#define REG_SC_BKAB_3C_H      _PK_H_(0xAB, 0x3C)
#define REG_SC_BKAB_3D_L      _PK_L_(0xAB, 0x3D)
#define REG_SC_BKAB_3D_H      _PK_H_(0xAB, 0x3D)
#define REG_SC_BKAB_3E_L      _PK_L_(0xAB, 0x3E)
#define REG_SC_BKAB_3E_H      _PK_H_(0xAB, 0x3E)
#define REG_SC_BKAB_3F_L      _PK_L_(0xAB, 0x3F)
#define REG_SC_BKAB_3F_H      _PK_H_(0xAB, 0x3F)
#define REG_SC_BKAB_40_L      _PK_L_(0xAB, 0x40)
#define REG_SC_BKAB_40_H      _PK_H_(0xAB, 0x40)
#define REG_SC_BKAB_41_L      _PK_L_(0xAB, 0x41)
#define REG_SC_BKAB_41_H      _PK_H_(0xAB, 0x41)
#define REG_SC_BKAB_42_L      _PK_L_(0xAB, 0x42)
#define REG_SC_BKAB_42_H      _PK_H_(0xAB, 0x42)
#define REG_SC_BKAB_43_L      _PK_L_(0xAB, 0x43)
#define REG_SC_BKAB_43_H      _PK_H_(0xAB, 0x43)
#define REG_SC_BKAB_44_L      _PK_L_(0xAB, 0x44)
#define REG_SC_BKAB_44_H      _PK_H_(0xAB, 0x44)
#define REG_SC_BKAB_45_L      _PK_L_(0xAB, 0x45)
#define REG_SC_BKAB_45_H      _PK_H_(0xAB, 0x45)
#define REG_SC_BKAB_46_L      _PK_L_(0xAB, 0x46)
#define REG_SC_BKAB_46_H      _PK_H_(0xAB, 0x46)
#define REG_SC_BKAB_47_L      _PK_L_(0xAB, 0x47)
#define REG_SC_BKAB_47_H      _PK_H_(0xAB, 0x47)
#define REG_SC_BKAB_48_L      _PK_L_(0xAB, 0x48)
#define REG_SC_BKAB_48_H      _PK_H_(0xAB, 0x48)
#define REG_SC_BKAB_49_L      _PK_L_(0xAB, 0x49)
#define REG_SC_BKAB_49_H      _PK_H_(0xAB, 0x49)
#define REG_SC_BKAB_4A_L      _PK_L_(0xAB, 0x4A)
#define REG_SC_BKAB_4A_H      _PK_H_(0xAB, 0x4A)
#define REG_SC_BKAB_4B_L      _PK_L_(0xAB, 0x4B)
#define REG_SC_BKAB_4B_H      _PK_H_(0xAB, 0x4B)
#define REG_SC_BKAB_4C_L      _PK_L_(0xAB, 0x4C)
#define REG_SC_BKAB_4C_H      _PK_H_(0xAB, 0x4C)
#define REG_SC_BKAB_4D_L      _PK_L_(0xAB, 0x4D)
#define REG_SC_BKAB_4D_H      _PK_H_(0xAB, 0x4D)
#define REG_SC_BKAB_4E_L      _PK_L_(0xAB, 0x4E)
#define REG_SC_BKAB_4E_H      _PK_H_(0xAB, 0x4E)
#define REG_SC_BKAB_4F_L      _PK_L_(0xAB, 0x4F)
#define REG_SC_BKAB_4F_H      _PK_H_(0xAB, 0x4F)
#define REG_SC_BKAB_50_L      _PK_L_(0xAB, 0x50)
#define REG_SC_BKAB_50_H      _PK_H_(0xAB, 0x50)
#define REG_SC_BKAB_51_L      _PK_L_(0xAB, 0x51)
#define REG_SC_BKAB_51_H      _PK_H_(0xAB, 0x51)
#define REG_SC_BKAB_52_L      _PK_L_(0xAB, 0x52)
#define REG_SC_BKAB_52_H      _PK_H_(0xAB, 0x52)
#define REG_SC_BKAB_53_L      _PK_L_(0xAB, 0x53)
#define REG_SC_BKAB_53_H      _PK_H_(0xAB, 0x53)
#define REG_SC_BKAB_54_L      _PK_L_(0xAB, 0x54)
#define REG_SC_BKAB_54_H      _PK_H_(0xAB, 0x54)
#define REG_SC_BKAB_55_L      _PK_L_(0xAB, 0x55)
#define REG_SC_BKAB_55_H      _PK_H_(0xAB, 0x55)
#define REG_SC_BKAB_56_L      _PK_L_(0xAB, 0x56)
#define REG_SC_BKAB_56_H      _PK_H_(0xAB, 0x56)
#define REG_SC_BKAB_57_L      _PK_L_(0xAB, 0x57)
#define REG_SC_BKAB_57_H      _PK_H_(0xAB, 0x57)
#define REG_SC_BKAB_58_L      _PK_L_(0xAB, 0x58)
#define REG_SC_BKAB_58_H      _PK_H_(0xAB, 0x58)
#define REG_SC_BKAB_59_L      _PK_L_(0xAB, 0x59)
#define REG_SC_BKAB_59_H      _PK_H_(0xAB, 0x59)
#define REG_SC_BKAB_5A_L      _PK_L_(0xAB, 0x5A)
#define REG_SC_BKAB_5A_H      _PK_H_(0xAB, 0x5A)
#define REG_SC_BKAB_5B_L      _PK_L_(0xAB, 0x5B)
#define REG_SC_BKAB_5B_H      _PK_H_(0xAB, 0x5B)
#define REG_SC_BKAB_5C_L      _PK_L_(0xAB, 0x5C)
#define REG_SC_BKAB_5C_H      _PK_H_(0xAB, 0x5C)
#define REG_SC_BKAB_5D_L      _PK_L_(0xAB, 0x5D)
#define REG_SC_BKAB_5D_H      _PK_H_(0xAB, 0x5D)
#define REG_SC_BKAB_5E_L      _PK_L_(0xAB, 0x5E)
#define REG_SC_BKAB_5E_H      _PK_H_(0xAB, 0x5E)
#define REG_SC_BKAB_5F_L      _PK_L_(0xAB, 0x5F)
#define REG_SC_BKAB_5F_H      _PK_H_(0xAB, 0x5F)
#define REG_SC_BKAB_60_L      _PK_L_(0xAB, 0x60)
#define REG_SC_BKAB_60_H      _PK_H_(0xAB, 0x60)
#define REG_SC_BKAB_61_L      _PK_L_(0xAB, 0x61)
#define REG_SC_BKAB_61_H      _PK_H_(0xAB, 0x61)
#define REG_SC_BKAB_62_L      _PK_L_(0xAB, 0x62)
#define REG_SC_BKAB_62_H      _PK_H_(0xAB, 0x62)
#define REG_SC_BKAB_63_L      _PK_L_(0xAB, 0x63)
#define REG_SC_BKAB_63_H      _PK_H_(0xAB, 0x63)
#define REG_SC_BKAB_64_L      _PK_L_(0xAB, 0x64)
#define REG_SC_BKAB_64_H      _PK_H_(0xAB, 0x64)
#define REG_SC_BKAB_65_L      _PK_L_(0xAB, 0x65)
#define REG_SC_BKAB_65_H      _PK_H_(0xAB, 0x65)
#define REG_SC_BKAB_66_L      _PK_L_(0xAB, 0x66)
#define REG_SC_BKAB_66_H      _PK_H_(0xAB, 0x66)
#define REG_SC_BKAB_67_L      _PK_L_(0xAB, 0x67)
#define REG_SC_BKAB_67_H      _PK_H_(0xAB, 0x67)
#define REG_SC_BKAB_68_L      _PK_L_(0xAB, 0x68)
#define REG_SC_BKAB_68_H      _PK_H_(0xAB, 0x68)
#define REG_SC_BKAB_69_L      _PK_L_(0xAB, 0x69)
#define REG_SC_BKAB_69_H      _PK_H_(0xAB, 0x69)
#define REG_SC_BKAB_6A_L      _PK_L_(0xAB, 0x6A)
#define REG_SC_BKAB_6A_H      _PK_H_(0xAB, 0x6A)
#define REG_SC_BKAB_6B_L      _PK_L_(0xAB, 0x6B)
#define REG_SC_BKAB_6B_H      _PK_H_(0xAB, 0x6B)
#define REG_SC_BKAB_6C_L      _PK_L_(0xAB, 0x6C)
#define REG_SC_BKAB_6C_H      _PK_H_(0xAB, 0x6C)
#define REG_SC_BKAB_6D_L      _PK_L_(0xAB, 0x6D)
#define REG_SC_BKAB_6D_H      _PK_H_(0xAB, 0x6D)
#define REG_SC_BKAB_6E_L      _PK_L_(0xAB, 0x6E)
#define REG_SC_BKAB_6E_H      _PK_H_(0xAB, 0x6E)
#define REG_SC_BKAB_6F_L      _PK_L_(0xAB, 0x6F)
#define REG_SC_BKAB_6F_H      _PK_H_(0xAB, 0x6F)
#define REG_SC_BKAB_70_L      _PK_L_(0xAB, 0x70)
#define REG_SC_BKAB_70_H      _PK_H_(0xAB, 0x70)
#define REG_SC_BKAB_71_L      _PK_L_(0xAB, 0x71)
#define REG_SC_BKAB_71_H      _PK_H_(0xAB, 0x71)
#define REG_SC_BKAB_72_L      _PK_L_(0xAB, 0x72)
#define REG_SC_BKAB_72_H      _PK_H_(0xAB, 0x72)
#define REG_SC_BKAB_73_L      _PK_L_(0xAB, 0x73)
#define REG_SC_BKAB_73_H      _PK_H_(0xAB, 0x73)
#define REG_SC_BKAB_74_L      _PK_L_(0xAB, 0x74)
#define REG_SC_BKAB_74_H      _PK_H_(0xAB, 0x74)
#define REG_SC_BKAB_75_L      _PK_L_(0xAB, 0x75)
#define REG_SC_BKAB_75_H      _PK_H_(0xAB, 0x75)
#define REG_SC_BKAB_76_L      _PK_L_(0xAB, 0x76)
#define REG_SC_BKAB_76_H      _PK_H_(0xAB, 0x76)
#define REG_SC_BKAB_77_L      _PK_L_(0xAB, 0x77)
#define REG_SC_BKAB_77_H      _PK_H_(0xAB, 0x77)
#define REG_SC_BKAB_78_L      _PK_L_(0xAB, 0x78)
#define REG_SC_BKAB_78_H      _PK_H_(0xAB, 0x78)
#define REG_SC_BKAB_79_L      _PK_L_(0xAB, 0x79)
#define REG_SC_BKAB_79_H      _PK_H_(0xAB, 0x79)
#define REG_SC_BKAB_7A_L      _PK_L_(0xAB, 0x7A)
#define REG_SC_BKAB_7A_H      _PK_H_(0xAB, 0x7A)
#define REG_SC_BKAB_7B_L      _PK_L_(0xAB, 0x7B)
#define REG_SC_BKAB_7B_H      _PK_H_(0xAB, 0x7B)
#define REG_SC_BKAB_7C_L      _PK_L_(0xAB, 0x7C)
#define REG_SC_BKAB_7C_H      _PK_H_(0xAB, 0x7C)
#define REG_SC_BKAB_7D_L      _PK_L_(0xAB, 0x7D)
#define REG_SC_BKAB_7D_H      _PK_H_(0xAB, 0x7D)
#define REG_SC_BKAB_7E_L      _PK_L_(0xAB, 0x7E)
#define REG_SC_BKAB_7E_H      _PK_H_(0xAB, 0x7E)
#define REG_SC_BKAB_7F_L      _PK_L_(0xAB, 0x7F)
#define REG_SC_BKAB_7F_H      _PK_H_(0xAB, 0x7F)
//----------------------------------------------
#define REG_SC_BKAC_00_L      _PK_L_(0xAC, 0x00)
#define REG_SC_BKAC_00_H      _PK_H_(0xAC, 0x00)
#define REG_SC_BKAC_01_L      _PK_L_(0xAC, 0x01)
#define REG_SC_BKAC_01_H      _PK_H_(0xAC, 0x01)
#define REG_SC_BKAC_02_L      _PK_L_(0xAC, 0x02)
#define REG_SC_BKAC_02_H      _PK_H_(0xAC, 0x02)
#define REG_SC_BKAC_03_L      _PK_L_(0xAC, 0x03)
#define REG_SC_BKAC_03_H      _PK_H_(0xAC, 0x03)
#define REG_SC_BKAC_04_L      _PK_L_(0xAC, 0x04)
#define REG_SC_BKAC_04_H      _PK_H_(0xAC, 0x04)
#define REG_SC_BKAC_05_L      _PK_L_(0xAC, 0x05)
#define REG_SC_BKAC_05_H      _PK_H_(0xAC, 0x05)
#define REG_SC_BKAC_06_L      _PK_L_(0xAC, 0x06)
#define REG_SC_BKAC_06_H      _PK_H_(0xAC, 0x06)
#define REG_SC_BKAC_07_L      _PK_L_(0xAC, 0x07)
#define REG_SC_BKAC_07_H      _PK_H_(0xAC, 0x07)
#define REG_SC_BKAC_08_L      _PK_L_(0xAC, 0x08)
#define REG_SC_BKAC_08_H      _PK_H_(0xAC, 0x08)
#define REG_SC_BKAC_09_L      _PK_L_(0xAC, 0x09)
#define REG_SC_BKAC_09_H      _PK_H_(0xAC, 0x09)
#define REG_SC_BKAC_0A_L      _PK_L_(0xAC, 0x0A)
#define REG_SC_BKAC_0A_H      _PK_H_(0xAC, 0x0A)
#define REG_SC_BKAC_0B_L      _PK_L_(0xAC, 0x0B)
#define REG_SC_BKAC_0B_H      _PK_H_(0xAC, 0x0B)
#define REG_SC_BKAC_0C_L      _PK_L_(0xAC, 0x0C)
#define REG_SC_BKAC_0C_H      _PK_H_(0xAC, 0x0C)
#define REG_SC_BKAC_0D_L      _PK_L_(0xAC, 0x0D)
#define REG_SC_BKAC_0D_H      _PK_H_(0xAC, 0x0D)
#define REG_SC_BKAC_0E_L      _PK_L_(0xAC, 0x0E)
#define REG_SC_BKAC_0E_H      _PK_H_(0xAC, 0x0E)
#define REG_SC_BKAC_0F_L      _PK_L_(0xAC, 0x0F)
#define REG_SC_BKAC_0F_H      _PK_H_(0xAC, 0x0F)
#define REG_SC_BKAC_10_L      _PK_L_(0xAC, 0x10)
#define REG_SC_BKAC_10_H      _PK_H_(0xAC, 0x10)
#define REG_SC_BKAC_11_L      _PK_L_(0xAC, 0x11)
#define REG_SC_BKAC_11_H      _PK_H_(0xAC, 0x11)
#define REG_SC_BKAC_12_L      _PK_L_(0xAC, 0x12)
#define REG_SC_BKAC_12_H      _PK_H_(0xAC, 0x12)
#define REG_SC_BKAC_13_L      _PK_L_(0xAC, 0x13)
#define REG_SC_BKAC_13_H      _PK_H_(0xAC, 0x13)
#define REG_SC_BKAC_14_L      _PK_L_(0xAC, 0x14)
#define REG_SC_BKAC_14_H      _PK_H_(0xAC, 0x14)
#define REG_SC_BKAC_15_L      _PK_L_(0xAC, 0x15)
#define REG_SC_BKAC_15_H      _PK_H_(0xAC, 0x15)
#define REG_SC_BKAC_16_L      _PK_L_(0xAC, 0x16)
#define REG_SC_BKAC_16_H      _PK_H_(0xAC, 0x16)
#define REG_SC_BKAC_17_L      _PK_L_(0xAC, 0x17)
#define REG_SC_BKAC_17_H      _PK_H_(0xAC, 0x17)
#define REG_SC_BKAC_18_L      _PK_L_(0xAC, 0x18)
#define REG_SC_BKAC_18_H      _PK_H_(0xAC, 0x18)
#define REG_SC_BKAC_19_L      _PK_L_(0xAC, 0x19)
#define REG_SC_BKAC_19_H      _PK_H_(0xAC, 0x19)
#define REG_SC_BKAC_1A_L      _PK_L_(0xAC, 0x1A)
#define REG_SC_BKAC_1A_H      _PK_H_(0xAC, 0x1A)
#define REG_SC_BKAC_1B_L      _PK_L_(0xAC, 0x1B)
#define REG_SC_BKAC_1B_H      _PK_H_(0xAC, 0x1B)
#define REG_SC_BKAC_1C_L      _PK_L_(0xAC, 0x1C)
#define REG_SC_BKAC_1C_H      _PK_H_(0xAC, 0x1C)
#define REG_SC_BKAC_1D_L      _PK_L_(0xAC, 0x1D)
#define REG_SC_BKAC_1D_H      _PK_H_(0xAC, 0x1D)
#define REG_SC_BKAC_1E_L      _PK_L_(0xAC, 0x1E)
#define REG_SC_BKAC_1E_H      _PK_H_(0xAC, 0x1E)
#define REG_SC_BKAC_1F_L      _PK_L_(0xAC, 0x1F)
#define REG_SC_BKAC_1F_H      _PK_H_(0xAC, 0x1F)
#define REG_SC_BKAC_20_L      _PK_L_(0xAC, 0x20)
#define REG_SC_BKAC_20_H      _PK_H_(0xAC, 0x20)
#define REG_SC_BKAC_21_L      _PK_L_(0xAC, 0x21)
#define REG_SC_BKAC_21_H      _PK_H_(0xAC, 0x21)
#define REG_SC_BKAC_22_L      _PK_L_(0xAC, 0x22)
#define REG_SC_BKAC_22_H      _PK_H_(0xAC, 0x22)
#define REG_SC_BKAC_23_L      _PK_L_(0xAC, 0x23)
#define REG_SC_BKAC_23_H      _PK_H_(0xAC, 0x23)
#define REG_SC_BKAC_24_L      _PK_L_(0xAC, 0x24)
#define REG_SC_BKAC_24_H      _PK_H_(0xAC, 0x24)
#define REG_SC_BKAC_25_L      _PK_L_(0xAC, 0x25)
#define REG_SC_BKAC_25_H      _PK_H_(0xAC, 0x25)
#define REG_SC_BKAC_26_L      _PK_L_(0xAC, 0x26)
#define REG_SC_BKAC_26_H      _PK_H_(0xAC, 0x26)
#define REG_SC_BKAC_27_L      _PK_L_(0xAC, 0x27)
#define REG_SC_BKAC_27_H      _PK_H_(0xAC, 0x27)
#define REG_SC_BKAC_28_L      _PK_L_(0xAC, 0x28)
#define REG_SC_BKAC_28_H      _PK_H_(0xAC, 0x28)
#define REG_SC_BKAC_29_L      _PK_L_(0xAC, 0x29)
#define REG_SC_BKAC_29_H      _PK_H_(0xAC, 0x29)
#define REG_SC_BKAC_2A_L      _PK_L_(0xAC, 0x2A)
#define REG_SC_BKAC_2A_H      _PK_H_(0xAC, 0x2A)
#define REG_SC_BKAC_2B_L      _PK_L_(0xAC, 0x2B)
#define REG_SC_BKAC_2B_H      _PK_H_(0xAC, 0x2B)
#define REG_SC_BKAC_2C_L      _PK_L_(0xAC, 0x2C)
#define REG_SC_BKAC_2C_H      _PK_H_(0xAC, 0x2C)
#define REG_SC_BKAC_2D_L      _PK_L_(0xAC, 0x2D)
#define REG_SC_BKAC_2D_H      _PK_H_(0xAC, 0x2D)
#define REG_SC_BKAC_2E_L      _PK_L_(0xAC, 0x2E)
#define REG_SC_BKAC_2E_H      _PK_H_(0xAC, 0x2E)
#define REG_SC_BKAC_2F_L      _PK_L_(0xAC, 0x2F)
#define REG_SC_BKAC_2F_H      _PK_H_(0xAC, 0x2F)
#define REG_SC_BKAC_30_L      _PK_L_(0xAC, 0x30)
#define REG_SC_BKAC_30_H      _PK_H_(0xAC, 0x30)
#define REG_SC_BKAC_31_L      _PK_L_(0xAC, 0x31)
#define REG_SC_BKAC_31_H      _PK_H_(0xAC, 0x31)
#define REG_SC_BKAC_32_L      _PK_L_(0xAC, 0x32)
#define REG_SC_BKAC_32_H      _PK_H_(0xAC, 0x32)
#define REG_SC_BKAC_33_L      _PK_L_(0xAC, 0x33)
#define REG_SC_BKAC_33_H      _PK_H_(0xAC, 0x33)
#define REG_SC_BKAC_34_L      _PK_L_(0xAC, 0x34)
#define REG_SC_BKAC_34_H      _PK_H_(0xAC, 0x34)
#define REG_SC_BKAC_35_L      _PK_L_(0xAC, 0x35)
#define REG_SC_BKAC_35_H      _PK_H_(0xAC, 0x35)
#define REG_SC_BKAC_36_L      _PK_L_(0xAC, 0x36)
#define REG_SC_BKAC_36_H      _PK_H_(0xAC, 0x36)
#define REG_SC_BKAC_37_L      _PK_L_(0xAC, 0x37)
#define REG_SC_BKAC_37_H      _PK_H_(0xAC, 0x37)
#define REG_SC_BKAC_38_L      _PK_L_(0xAC, 0x38)
#define REG_SC_BKAC_38_H      _PK_H_(0xAC, 0x38)
#define REG_SC_BKAC_39_L      _PK_L_(0xAC, 0x39)
#define REG_SC_BKAC_39_H      _PK_H_(0xAC, 0x39)
#define REG_SC_BKAC_3A_L      _PK_L_(0xAC, 0x3A)
#define REG_SC_BKAC_3A_H      _PK_H_(0xAC, 0x3A)
#define REG_SC_BKAC_3B_L      _PK_L_(0xAC, 0x3B)
#define REG_SC_BKAC_3B_H      _PK_H_(0xAC, 0x3B)
#define REG_SC_BKAC_3C_L      _PK_L_(0xAC, 0x3C)
#define REG_SC_BKAC_3C_H      _PK_H_(0xAC, 0x3C)
#define REG_SC_BKAC_3D_L      _PK_L_(0xAC, 0x3D)
#define REG_SC_BKAC_3D_H      _PK_H_(0xAC, 0x3D)
#define REG_SC_BKAC_3E_L      _PK_L_(0xAC, 0x3E)
#define REG_SC_BKAC_3E_H      _PK_H_(0xAC, 0x3E)
#define REG_SC_BKAC_3F_L      _PK_L_(0xAC, 0x3F)
#define REG_SC_BKAC_3F_H      _PK_H_(0xAC, 0x3F)
#define REG_SC_BKAC_40_L      _PK_L_(0xAC, 0x40)
#define REG_SC_BKAC_40_H      _PK_H_(0xAC, 0x40)
#define REG_SC_BKAC_41_L      _PK_L_(0xAC, 0x41)
#define REG_SC_BKAC_41_H      _PK_H_(0xAC, 0x41)
#define REG_SC_BKAC_42_L      _PK_L_(0xAC, 0x42)
#define REG_SC_BKAC_42_H      _PK_H_(0xAC, 0x42)
#define REG_SC_BKAC_43_L      _PK_L_(0xAC, 0x43)
#define REG_SC_BKAC_43_H      _PK_H_(0xAC, 0x43)
#define REG_SC_BKAC_44_L      _PK_L_(0xAC, 0x44)
#define REG_SC_BKAC_44_H      _PK_H_(0xAC, 0x44)
#define REG_SC_BKAC_45_L      _PK_L_(0xAC, 0x45)
#define REG_SC_BKAC_45_H      _PK_H_(0xAC, 0x45)
#define REG_SC_BKAC_46_L      _PK_L_(0xAC, 0x46)
#define REG_SC_BKAC_46_H      _PK_H_(0xAC, 0x46)
#define REG_SC_BKAC_47_L      _PK_L_(0xAC, 0x47)
#define REG_SC_BKAC_47_H      _PK_H_(0xAC, 0x47)
#define REG_SC_BKAC_48_L      _PK_L_(0xAC, 0x48)
#define REG_SC_BKAC_48_H      _PK_H_(0xAC, 0x48)
#define REG_SC_BKAC_49_L      _PK_L_(0xAC, 0x49)
#define REG_SC_BKAC_49_H      _PK_H_(0xAC, 0x49)
#define REG_SC_BKAC_4A_L      _PK_L_(0xAC, 0x4A)
#define REG_SC_BKAC_4A_H      _PK_H_(0xAC, 0x4A)
#define REG_SC_BKAC_4B_L      _PK_L_(0xAC, 0x4B)
#define REG_SC_BKAC_4B_H      _PK_H_(0xAC, 0x4B)
#define REG_SC_BKAC_4C_L      _PK_L_(0xAC, 0x4C)
#define REG_SC_BKAC_4C_H      _PK_H_(0xAC, 0x4C)
#define REG_SC_BKAC_4D_L      _PK_L_(0xAC, 0x4D)
#define REG_SC_BKAC_4D_H      _PK_H_(0xAC, 0x4D)
#define REG_SC_BKAC_4E_L      _PK_L_(0xAC, 0x4E)
#define REG_SC_BKAC_4E_H      _PK_H_(0xAC, 0x4E)
#define REG_SC_BKAC_4F_L      _PK_L_(0xAC, 0x4F)
#define REG_SC_BKAC_4F_H      _PK_H_(0xAC, 0x4F)
#define REG_SC_BKAC_50_L      _PK_L_(0xAC, 0x50)
#define REG_SC_BKAC_50_H      _PK_H_(0xAC, 0x50)
#define REG_SC_BKAC_51_L      _PK_L_(0xAC, 0x51)
#define REG_SC_BKAC_51_H      _PK_H_(0xAC, 0x51)
#define REG_SC_BKAC_52_L      _PK_L_(0xAC, 0x52)
#define REG_SC_BKAC_52_H      _PK_H_(0xAC, 0x52)
#define REG_SC_BKAC_53_L      _PK_L_(0xAC, 0x53)
#define REG_SC_BKAC_53_H      _PK_H_(0xAC, 0x53)
#define REG_SC_BKAC_54_L      _PK_L_(0xAC, 0x54)
#define REG_SC_BKAC_54_H      _PK_H_(0xAC, 0x54)
#define REG_SC_BKAC_55_L      _PK_L_(0xAC, 0x55)
#define REG_SC_BKAC_55_H      _PK_H_(0xAC, 0x55)
#define REG_SC_BKAC_56_L      _PK_L_(0xAC, 0x56)
#define REG_SC_BKAC_56_H      _PK_H_(0xAC, 0x56)
#define REG_SC_BKAC_57_L      _PK_L_(0xAC, 0x57)
#define REG_SC_BKAC_57_H      _PK_H_(0xAC, 0x57)
#define REG_SC_BKAC_58_L      _PK_L_(0xAC, 0x58)
#define REG_SC_BKAC_58_H      _PK_H_(0xAC, 0x58)
#define REG_SC_BKAC_59_L      _PK_L_(0xAC, 0x59)
#define REG_SC_BKAC_59_H      _PK_H_(0xAC, 0x59)
#define REG_SC_BKAC_5A_L      _PK_L_(0xAC, 0x5A)
#define REG_SC_BKAC_5A_H      _PK_H_(0xAC, 0x5A)
#define REG_SC_BKAC_5B_L      _PK_L_(0xAC, 0x5B)
#define REG_SC_BKAC_5B_H      _PK_H_(0xAC, 0x5B)
#define REG_SC_BKAC_5C_L      _PK_L_(0xAC, 0x5C)
#define REG_SC_BKAC_5C_H      _PK_H_(0xAC, 0x5C)
#define REG_SC_BKAC_5D_L      _PK_L_(0xAC, 0x5D)
#define REG_SC_BKAC_5D_H      _PK_H_(0xAC, 0x5D)
#define REG_SC_BKAC_5E_L      _PK_L_(0xAC, 0x5E)
#define REG_SC_BKAC_5E_H      _PK_H_(0xAC, 0x5E)
#define REG_SC_BKAC_5F_L      _PK_L_(0xAC, 0x5F)
#define REG_SC_BKAC_5F_H      _PK_H_(0xAC, 0x5F)
#define REG_SC_BKAC_60_L      _PK_L_(0xAC, 0x60)
#define REG_SC_BKAC_60_H      _PK_H_(0xAC, 0x60)
#define REG_SC_BKAC_61_L      _PK_L_(0xAC, 0x61)
#define REG_SC_BKAC_61_H      _PK_H_(0xAC, 0x61)
#define REG_SC_BKAC_62_L      _PK_L_(0xAC, 0x62)
#define REG_SC_BKAC_62_H      _PK_H_(0xAC, 0x62)
#define REG_SC_BKAC_63_L      _PK_L_(0xAC, 0x63)
#define REG_SC_BKAC_63_H      _PK_H_(0xAC, 0x63)
#define REG_SC_BKAC_64_L      _PK_L_(0xAC, 0x64)
#define REG_SC_BKAC_64_H      _PK_H_(0xAC, 0x64)
#define REG_SC_BKAC_65_L      _PK_L_(0xAC, 0x65)
#define REG_SC_BKAC_65_H      _PK_H_(0xAC, 0x65)
#define REG_SC_BKAC_66_L      _PK_L_(0xAC, 0x66)
#define REG_SC_BKAC_66_H      _PK_H_(0xAC, 0x66)
#define REG_SC_BKAC_67_L      _PK_L_(0xAC, 0x67)
#define REG_SC_BKAC_67_H      _PK_H_(0xAC, 0x67)
#define REG_SC_BKAC_68_L      _PK_L_(0xAC, 0x68)
#define REG_SC_BKAC_68_H      _PK_H_(0xAC, 0x68)
#define REG_SC_BKAC_69_L      _PK_L_(0xAC, 0x69)
#define REG_SC_BKAC_69_H      _PK_H_(0xAC, 0x69)
#define REG_SC_BKAC_6A_L      _PK_L_(0xAC, 0x6A)
#define REG_SC_BKAC_6A_H      _PK_H_(0xAC, 0x6A)
#define REG_SC_BKAC_6B_L      _PK_L_(0xAC, 0x6B)
#define REG_SC_BKAC_6B_H      _PK_H_(0xAC, 0x6B)
#define REG_SC_BKAC_6C_L      _PK_L_(0xAC, 0x6C)
#define REG_SC_BKAC_6C_H      _PK_H_(0xAC, 0x6C)
#define REG_SC_BKAC_6D_L      _PK_L_(0xAC, 0x6D)
#define REG_SC_BKAC_6D_H      _PK_H_(0xAC, 0x6D)
#define REG_SC_BKAC_6E_L      _PK_L_(0xAC, 0x6E)
#define REG_SC_BKAC_6E_H      _PK_H_(0xAC, 0x6E)
#define REG_SC_BKAC_6F_L      _PK_L_(0xAC, 0x6F)
#define REG_SC_BKAC_6F_H      _PK_H_(0xAC, 0x6F)
#define REG_SC_BKAC_70_L      _PK_L_(0xAC, 0x70)
#define REG_SC_BKAC_70_H      _PK_H_(0xAC, 0x70)
#define REG_SC_BKAC_71_L      _PK_L_(0xAC, 0x71)
#define REG_SC_BKAC_71_H      _PK_H_(0xAC, 0x71)
#define REG_SC_BKAC_72_L      _PK_L_(0xAC, 0x72)
#define REG_SC_BKAC_72_H      _PK_H_(0xAC, 0x72)
#define REG_SC_BKAC_73_L      _PK_L_(0xAC, 0x73)
#define REG_SC_BKAC_73_H      _PK_H_(0xAC, 0x73)
#define REG_SC_BKAC_74_L      _PK_L_(0xAC, 0x74)
#define REG_SC_BKAC_74_H      _PK_H_(0xAC, 0x74)
#define REG_SC_BKAC_75_L      _PK_L_(0xAC, 0x75)
#define REG_SC_BKAC_75_H      _PK_H_(0xAC, 0x75)
#define REG_SC_BKAC_76_L      _PK_L_(0xAC, 0x76)
#define REG_SC_BKAC_76_H      _PK_H_(0xAC, 0x76)
#define REG_SC_BKAC_77_L      _PK_L_(0xAC, 0x77)
#define REG_SC_BKAC_77_H      _PK_H_(0xAC, 0x77)
#define REG_SC_BKAC_78_L      _PK_L_(0xAC, 0x78)
#define REG_SC_BKAC_78_H      _PK_H_(0xAC, 0x78)
#define REG_SC_BKAC_79_L      _PK_L_(0xAC, 0x79)
#define REG_SC_BKAC_79_H      _PK_H_(0xAC, 0x79)
#define REG_SC_BKAC_7A_L      _PK_L_(0xAC, 0x7A)
#define REG_SC_BKAC_7A_H      _PK_H_(0xAC, 0x7A)
#define REG_SC_BKAC_7B_L      _PK_L_(0xAC, 0x7B)
#define REG_SC_BKAC_7B_H      _PK_H_(0xAC, 0x7B)
#define REG_SC_BKAC_7C_L      _PK_L_(0xAC, 0x7C)
#define REG_SC_BKAC_7C_H      _PK_H_(0xAC, 0x7C)
#define REG_SC_BKAC_7D_L      _PK_L_(0xAC, 0x7D)
#define REG_SC_BKAC_7D_H      _PK_H_(0xAC, 0x7D)
#define REG_SC_BKAC_7E_L      _PK_L_(0xAC, 0x7E)
#define REG_SC_BKAC_7E_H      _PK_H_(0xAC, 0x7E)
#define REG_SC_BKAC_7F_L      _PK_L_(0xAC, 0x7F)
#define REG_SC_BKAC_7F_H      _PK_H_(0xAC, 0x7F)
//----------------------------------------------
#define REG_SC_BKAD_00_L      _PK_L_(0xAD, 0x00)
#define REG_SC_BKAD_00_H      _PK_H_(0xAD, 0x00)
#define REG_SC_BKAD_01_L      _PK_L_(0xAD, 0x01)
#define REG_SC_BKAD_01_H      _PK_H_(0xAD, 0x01)
#define REG_SC_BKAD_02_L      _PK_L_(0xAD, 0x02)
#define REG_SC_BKAD_02_H      _PK_H_(0xAD, 0x02)
#define REG_SC_BKAD_03_L      _PK_L_(0xAD, 0x03)
#define REG_SC_BKAD_03_H      _PK_H_(0xAD, 0x03)
#define REG_SC_BKAD_04_L      _PK_L_(0xAD, 0x04)
#define REG_SC_BKAD_04_H      _PK_H_(0xAD, 0x04)
#define REG_SC_BKAD_05_L      _PK_L_(0xAD, 0x05)
#define REG_SC_BKAD_05_H      _PK_H_(0xAD, 0x05)
#define REG_SC_BKAD_06_L      _PK_L_(0xAD, 0x06)
#define REG_SC_BKAD_06_H      _PK_H_(0xAD, 0x06)
#define REG_SC_BKAD_07_L      _PK_L_(0xAD, 0x07)
#define REG_SC_BKAD_07_H      _PK_H_(0xAD, 0x07)
#define REG_SC_BKAD_08_L      _PK_L_(0xAD, 0x08)
#define REG_SC_BKAD_08_H      _PK_H_(0xAD, 0x08)
#define REG_SC_BKAD_09_L      _PK_L_(0xAD, 0x09)
#define REG_SC_BKAD_09_H      _PK_H_(0xAD, 0x09)
#define REG_SC_BKAD_0A_L      _PK_L_(0xAD, 0x0A)
#define REG_SC_BKAD_0A_H      _PK_H_(0xAD, 0x0A)
#define REG_SC_BKAD_0B_L      _PK_L_(0xAD, 0x0B)
#define REG_SC_BKAD_0B_H      _PK_H_(0xAD, 0x0B)
#define REG_SC_BKAD_0C_L      _PK_L_(0xAD, 0x0C)
#define REG_SC_BKAD_0C_H      _PK_H_(0xAD, 0x0C)
#define REG_SC_BKAD_0D_L      _PK_L_(0xAD, 0x0D)
#define REG_SC_BKAD_0D_H      _PK_H_(0xAD, 0x0D)
#define REG_SC_BKAD_0E_L      _PK_L_(0xAD, 0x0E)
#define REG_SC_BKAD_0E_H      _PK_H_(0xAD, 0x0E)
#define REG_SC_BKAD_0F_L      _PK_L_(0xAD, 0x0F)
#define REG_SC_BKAD_0F_H      _PK_H_(0xAD, 0x0F)
#define REG_SC_BKAD_10_L      _PK_L_(0xAD, 0x10)
#define REG_SC_BKAD_10_H      _PK_H_(0xAD, 0x10)
#define REG_SC_BKAD_11_L      _PK_L_(0xAD, 0x11)
#define REG_SC_BKAD_11_H      _PK_H_(0xAD, 0x11)
#define REG_SC_BKAD_12_L      _PK_L_(0xAD, 0x12)
#define REG_SC_BKAD_12_H      _PK_H_(0xAD, 0x12)
#define REG_SC_BKAD_13_L      _PK_L_(0xAD, 0x13)
#define REG_SC_BKAD_13_H      _PK_H_(0xAD, 0x13)
#define REG_SC_BKAD_14_L      _PK_L_(0xAD, 0x14)
#define REG_SC_BKAD_14_H      _PK_H_(0xAD, 0x14)
#define REG_SC_BKAD_15_L      _PK_L_(0xAD, 0x15)
#define REG_SC_BKAD_15_H      _PK_H_(0xAD, 0x15)
#define REG_SC_BKAD_16_L      _PK_L_(0xAD, 0x16)
#define REG_SC_BKAD_16_H      _PK_H_(0xAD, 0x16)
#define REG_SC_BKAD_17_L      _PK_L_(0xAD, 0x17)
#define REG_SC_BKAD_17_H      _PK_H_(0xAD, 0x17)
#define REG_SC_BKAD_18_L      _PK_L_(0xAD, 0x18)
#define REG_SC_BKAD_18_H      _PK_H_(0xAD, 0x18)
#define REG_SC_BKAD_19_L      _PK_L_(0xAD, 0x19)
#define REG_SC_BKAD_19_H      _PK_H_(0xAD, 0x19)
#define REG_SC_BKAD_1A_L      _PK_L_(0xAD, 0x1A)
#define REG_SC_BKAD_1A_H      _PK_H_(0xAD, 0x1A)
#define REG_SC_BKAD_1B_L      _PK_L_(0xAD, 0x1B)
#define REG_SC_BKAD_1B_H      _PK_H_(0xAD, 0x1B)
#define REG_SC_BKAD_1C_L      _PK_L_(0xAD, 0x1C)
#define REG_SC_BKAD_1C_H      _PK_H_(0xAD, 0x1C)
#define REG_SC_BKAD_1D_L      _PK_L_(0xAD, 0x1D)
#define REG_SC_BKAD_1D_H      _PK_H_(0xAD, 0x1D)
#define REG_SC_BKAD_1E_L      _PK_L_(0xAD, 0x1E)
#define REG_SC_BKAD_1E_H      _PK_H_(0xAD, 0x1E)
#define REG_SC_BKAD_1F_L      _PK_L_(0xAD, 0x1F)
#define REG_SC_BKAD_1F_H      _PK_H_(0xAD, 0x1F)
#define REG_SC_BKAD_20_L      _PK_L_(0xAD, 0x20)
#define REG_SC_BKAD_20_H      _PK_H_(0xAD, 0x20)
#define REG_SC_BKAD_21_L      _PK_L_(0xAD, 0x21)
#define REG_SC_BKAD_21_H      _PK_H_(0xAD, 0x21)
#define REG_SC_BKAD_22_L      _PK_L_(0xAD, 0x22)
#define REG_SC_BKAD_22_H      _PK_H_(0xAD, 0x22)
#define REG_SC_BKAD_23_L      _PK_L_(0xAD, 0x23)
#define REG_SC_BKAD_23_H      _PK_H_(0xAD, 0x23)
#define REG_SC_BKAD_24_L      _PK_L_(0xAD, 0x24)
#define REG_SC_BKAD_24_H      _PK_H_(0xAD, 0x24)
#define REG_SC_BKAD_25_L      _PK_L_(0xAD, 0x25)
#define REG_SC_BKAD_25_H      _PK_H_(0xAD, 0x25)
#define REG_SC_BKAD_26_L      _PK_L_(0xAD, 0x26)
#define REG_SC_BKAD_26_H      _PK_H_(0xAD, 0x26)
#define REG_SC_BKAD_27_L      _PK_L_(0xAD, 0x27)
#define REG_SC_BKAD_27_H      _PK_H_(0xAD, 0x27)
#define REG_SC_BKAD_28_L      _PK_L_(0xAD, 0x28)
#define REG_SC_BKAD_28_H      _PK_H_(0xAD, 0x28)
#define REG_SC_BKAD_29_L      _PK_L_(0xAD, 0x29)
#define REG_SC_BKAD_29_H      _PK_H_(0xAD, 0x29)
#define REG_SC_BKAD_2A_L      _PK_L_(0xAD, 0x2A)
#define REG_SC_BKAD_2A_H      _PK_H_(0xAD, 0x2A)
#define REG_SC_BKAD_2B_L      _PK_L_(0xAD, 0x2B)
#define REG_SC_BKAD_2B_H      _PK_H_(0xAD, 0x2B)
#define REG_SC_BKAD_2C_L      _PK_L_(0xAD, 0x2C)
#define REG_SC_BKAD_2C_H      _PK_H_(0xAD, 0x2C)
#define REG_SC_BKAD_2D_L      _PK_L_(0xAD, 0x2D)
#define REG_SC_BKAD_2D_H      _PK_H_(0xAD, 0x2D)
#define REG_SC_BKAD_2E_L      _PK_L_(0xAD, 0x2E)
#define REG_SC_BKAD_2E_H      _PK_H_(0xAD, 0x2E)
#define REG_SC_BKAD_2F_L      _PK_L_(0xAD, 0x2F)
#define REG_SC_BKAD_2F_H      _PK_H_(0xAD, 0x2F)
#define REG_SC_BKAD_30_L      _PK_L_(0xAD, 0x30)
#define REG_SC_BKAD_30_H      _PK_H_(0xAD, 0x30)
#define REG_SC_BKAD_31_L      _PK_L_(0xAD, 0x31)
#define REG_SC_BKAD_31_H      _PK_H_(0xAD, 0x31)
#define REG_SC_BKAD_32_L      _PK_L_(0xAD, 0x32)
#define REG_SC_BKAD_32_H      _PK_H_(0xAD, 0x32)
#define REG_SC_BKAD_33_L      _PK_L_(0xAD, 0x33)
#define REG_SC_BKAD_33_H      _PK_H_(0xAD, 0x33)
#define REG_SC_BKAD_34_L      _PK_L_(0xAD, 0x34)
#define REG_SC_BKAD_34_H      _PK_H_(0xAD, 0x34)
#define REG_SC_BKAD_35_L      _PK_L_(0xAD, 0x35)
#define REG_SC_BKAD_35_H      _PK_H_(0xAD, 0x35)
#define REG_SC_BKAD_36_L      _PK_L_(0xAD, 0x36)
#define REG_SC_BKAD_36_H      _PK_H_(0xAD, 0x36)
#define REG_SC_BKAD_37_L      _PK_L_(0xAD, 0x37)
#define REG_SC_BKAD_37_H      _PK_H_(0xAD, 0x37)
#define REG_SC_BKAD_38_L      _PK_L_(0xAD, 0x38)
#define REG_SC_BKAD_38_H      _PK_H_(0xAD, 0x38)
#define REG_SC_BKAD_39_L      _PK_L_(0xAD, 0x39)
#define REG_SC_BKAD_39_H      _PK_H_(0xAD, 0x39)
#define REG_SC_BKAD_3A_L      _PK_L_(0xAD, 0x3A)
#define REG_SC_BKAD_3A_H      _PK_H_(0xAD, 0x3A)
#define REG_SC_BKAD_3B_L      _PK_L_(0xAD, 0x3B)
#define REG_SC_BKAD_3B_H      _PK_H_(0xAD, 0x3B)
#define REG_SC_BKAD_3C_L      _PK_L_(0xAD, 0x3C)
#define REG_SC_BKAD_3C_H      _PK_H_(0xAD, 0x3C)
#define REG_SC_BKAD_3D_L      _PK_L_(0xAD, 0x3D)
#define REG_SC_BKAD_3D_H      _PK_H_(0xAD, 0x3D)
#define REG_SC_BKAD_3E_L      _PK_L_(0xAD, 0x3E)
#define REG_SC_BKAD_3E_H      _PK_H_(0xAD, 0x3E)
#define REG_SC_BKAD_3F_L      _PK_L_(0xAD, 0x3F)
#define REG_SC_BKAD_3F_H      _PK_H_(0xAD, 0x3F)
#define REG_SC_BKAD_40_L      _PK_L_(0xAD, 0x40)
#define REG_SC_BKAD_40_H      _PK_H_(0xAD, 0x40)
#define REG_SC_BKAD_41_L      _PK_L_(0xAD, 0x41)
#define REG_SC_BKAD_41_H      _PK_H_(0xAD, 0x41)
#define REG_SC_BKAD_42_L      _PK_L_(0xAD, 0x42)
#define REG_SC_BKAD_42_H      _PK_H_(0xAD, 0x42)
#define REG_SC_BKAD_43_L      _PK_L_(0xAD, 0x43)
#define REG_SC_BKAD_43_H      _PK_H_(0xAD, 0x43)
#define REG_SC_BKAD_44_L      _PK_L_(0xAD, 0x44)
#define REG_SC_BKAD_44_H      _PK_H_(0xAD, 0x44)
#define REG_SC_BKAD_45_L      _PK_L_(0xAD, 0x45)
#define REG_SC_BKAD_45_H      _PK_H_(0xAD, 0x45)
#define REG_SC_BKAD_46_L      _PK_L_(0xAD, 0x46)
#define REG_SC_BKAD_46_H      _PK_H_(0xAD, 0x46)
#define REG_SC_BKAD_47_L      _PK_L_(0xAD, 0x47)
#define REG_SC_BKAD_47_H      _PK_H_(0xAD, 0x47)
#define REG_SC_BKAD_48_L      _PK_L_(0xAD, 0x48)
#define REG_SC_BKAD_48_H      _PK_H_(0xAD, 0x48)
#define REG_SC_BKAD_49_L      _PK_L_(0xAD, 0x49)
#define REG_SC_BKAD_49_H      _PK_H_(0xAD, 0x49)
#define REG_SC_BKAD_4A_L      _PK_L_(0xAD, 0x4A)
#define REG_SC_BKAD_4A_H      _PK_H_(0xAD, 0x4A)
#define REG_SC_BKAD_4B_L      _PK_L_(0xAD, 0x4B)
#define REG_SC_BKAD_4B_H      _PK_H_(0xAD, 0x4B)
#define REG_SC_BKAD_4C_L      _PK_L_(0xAD, 0x4C)
#define REG_SC_BKAD_4C_H      _PK_H_(0xAD, 0x4C)
#define REG_SC_BKAD_4D_L      _PK_L_(0xAD, 0x4D)
#define REG_SC_BKAD_4D_H      _PK_H_(0xAD, 0x4D)
#define REG_SC_BKAD_4E_L      _PK_L_(0xAD, 0x4E)
#define REG_SC_BKAD_4E_H      _PK_H_(0xAD, 0x4E)
#define REG_SC_BKAD_4F_L      _PK_L_(0xAD, 0x4F)
#define REG_SC_BKAD_4F_H      _PK_H_(0xAD, 0x4F)
#define REG_SC_BKAD_50_L      _PK_L_(0xAD, 0x50)
#define REG_SC_BKAD_50_H      _PK_H_(0xAD, 0x50)
#define REG_SC_BKAD_51_L      _PK_L_(0xAD, 0x51)
#define REG_SC_BKAD_51_H      _PK_H_(0xAD, 0x51)
#define REG_SC_BKAD_52_L      _PK_L_(0xAD, 0x52)
#define REG_SC_BKAD_52_H      _PK_H_(0xAD, 0x52)
#define REG_SC_BKAD_53_L      _PK_L_(0xAD, 0x53)
#define REG_SC_BKAD_53_H      _PK_H_(0xAD, 0x53)
#define REG_SC_BKAD_54_L      _PK_L_(0xAD, 0x54)
#define REG_SC_BKAD_54_H      _PK_H_(0xAD, 0x54)
#define REG_SC_BKAD_55_L      _PK_L_(0xAD, 0x55)
#define REG_SC_BKAD_55_H      _PK_H_(0xAD, 0x55)
#define REG_SC_BKAD_56_L      _PK_L_(0xAD, 0x56)
#define REG_SC_BKAD_56_H      _PK_H_(0xAD, 0x56)
#define REG_SC_BKAD_57_L      _PK_L_(0xAD, 0x57)
#define REG_SC_BKAD_57_H      _PK_H_(0xAD, 0x57)
#define REG_SC_BKAD_58_L      _PK_L_(0xAD, 0x58)
#define REG_SC_BKAD_58_H      _PK_H_(0xAD, 0x58)
#define REG_SC_BKAD_59_L      _PK_L_(0xAD, 0x59)
#define REG_SC_BKAD_59_H      _PK_H_(0xAD, 0x59)
#define REG_SC_BKAD_5A_L      _PK_L_(0xAD, 0x5A)
#define REG_SC_BKAD_5A_H      _PK_H_(0xAD, 0x5A)
#define REG_SC_BKAD_5B_L      _PK_L_(0xAD, 0x5B)
#define REG_SC_BKAD_5B_H      _PK_H_(0xAD, 0x5B)
#define REG_SC_BKAD_5C_L      _PK_L_(0xAD, 0x5C)
#define REG_SC_BKAD_5C_H      _PK_H_(0xAD, 0x5C)
#define REG_SC_BKAD_5D_L      _PK_L_(0xAD, 0x5D)
#define REG_SC_BKAD_5D_H      _PK_H_(0xAD, 0x5D)
#define REG_SC_BKAD_5E_L      _PK_L_(0xAD, 0x5E)
#define REG_SC_BKAD_5E_H      _PK_H_(0xAD, 0x5E)
#define REG_SC_BKAD_5F_L      _PK_L_(0xAD, 0x5F)
#define REG_SC_BKAD_5F_H      _PK_H_(0xAD, 0x5F)
#define REG_SC_BKAD_60_L      _PK_L_(0xAD, 0x60)
#define REG_SC_BKAD_60_H      _PK_H_(0xAD, 0x60)
#define REG_SC_BKAD_61_L      _PK_L_(0xAD, 0x61)
#define REG_SC_BKAD_61_H      _PK_H_(0xAD, 0x61)
#define REG_SC_BKAD_62_L      _PK_L_(0xAD, 0x62)
#define REG_SC_BKAD_62_H      _PK_H_(0xAD, 0x62)
#define REG_SC_BKAD_63_L      _PK_L_(0xAD, 0x63)
#define REG_SC_BKAD_63_H      _PK_H_(0xAD, 0x63)
#define REG_SC_BKAD_64_L      _PK_L_(0xAD, 0x64)
#define REG_SC_BKAD_64_H      _PK_H_(0xAD, 0x64)
#define REG_SC_BKAD_65_L      _PK_L_(0xAD, 0x65)
#define REG_SC_BKAD_65_H      _PK_H_(0xAD, 0x65)
#define REG_SC_BKAD_66_L      _PK_L_(0xAD, 0x66)
#define REG_SC_BKAD_66_H      _PK_H_(0xAD, 0x66)
#define REG_SC_BKAD_67_L      _PK_L_(0xAD, 0x67)
#define REG_SC_BKAD_67_H      _PK_H_(0xAD, 0x67)
#define REG_SC_BKAD_68_L      _PK_L_(0xAD, 0x68)
#define REG_SC_BKAD_68_H      _PK_H_(0xAD, 0x68)
#define REG_SC_BKAD_69_L      _PK_L_(0xAD, 0x69)
#define REG_SC_BKAD_69_H      _PK_H_(0xAD, 0x69)
#define REG_SC_BKAD_6A_L      _PK_L_(0xAD, 0x6A)
#define REG_SC_BKAD_6A_H      _PK_H_(0xAD, 0x6A)
#define REG_SC_BKAD_6B_L      _PK_L_(0xAD, 0x6B)
#define REG_SC_BKAD_6B_H      _PK_H_(0xAD, 0x6B)
#define REG_SC_BKAD_6C_L      _PK_L_(0xAD, 0x6C)
#define REG_SC_BKAD_6C_H      _PK_H_(0xAD, 0x6C)
#define REG_SC_BKAD_6D_L      _PK_L_(0xAD, 0x6D)
#define REG_SC_BKAD_6D_H      _PK_H_(0xAD, 0x6D)
#define REG_SC_BKAD_6E_L      _PK_L_(0xAD, 0x6E)
#define REG_SC_BKAD_6E_H      _PK_H_(0xAD, 0x6E)
#define REG_SC_BKAD_6F_L      _PK_L_(0xAD, 0x6F)
#define REG_SC_BKAD_6F_H      _PK_H_(0xAD, 0x6F)
#define REG_SC_BKAD_70_L      _PK_L_(0xAD, 0x70)
#define REG_SC_BKAD_70_H      _PK_H_(0xAD, 0x70)
#define REG_SC_BKAD_71_L      _PK_L_(0xAD, 0x71)
#define REG_SC_BKAD_71_H      _PK_H_(0xAD, 0x71)
#define REG_SC_BKAD_72_L      _PK_L_(0xAD, 0x72)
#define REG_SC_BKAD_72_H      _PK_H_(0xAD, 0x72)
#define REG_SC_BKAD_73_L      _PK_L_(0xAD, 0x73)
#define REG_SC_BKAD_73_H      _PK_H_(0xAD, 0x73)
#define REG_SC_BKAD_74_L      _PK_L_(0xAD, 0x74)
#define REG_SC_BKAD_74_H      _PK_H_(0xAD, 0x74)
#define REG_SC_BKAD_75_L      _PK_L_(0xAD, 0x75)
#define REG_SC_BKAD_75_H      _PK_H_(0xAD, 0x75)
#define REG_SC_BKAD_76_L      _PK_L_(0xAD, 0x76)
#define REG_SC_BKAD_76_H      _PK_H_(0xAD, 0x76)
#define REG_SC_BKAD_77_L      _PK_L_(0xAD, 0x77)
#define REG_SC_BKAD_77_H      _PK_H_(0xAD, 0x77)
#define REG_SC_BKAD_78_L      _PK_L_(0xAD, 0x78)
#define REG_SC_BKAD_78_H      _PK_H_(0xAD, 0x78)
#define REG_SC_BKAD_79_L      _PK_L_(0xAD, 0x79)
#define REG_SC_BKAD_79_H      _PK_H_(0xAD, 0x79)
#define REG_SC_BKAD_7A_L      _PK_L_(0xAD, 0x7A)
#define REG_SC_BKAD_7A_H      _PK_H_(0xAD, 0x7A)
#define REG_SC_BKAD_7B_L      _PK_L_(0xAD, 0x7B)
#define REG_SC_BKAD_7B_H      _PK_H_(0xAD, 0x7B)
#define REG_SC_BKAD_7C_L      _PK_L_(0xAD, 0x7C)
#define REG_SC_BKAD_7C_H      _PK_H_(0xAD, 0x7C)
#define REG_SC_BKAD_7D_L      _PK_L_(0xAD, 0x7D)
#define REG_SC_BKAD_7D_H      _PK_H_(0xAD, 0x7D)
#define REG_SC_BKAD_7E_L      _PK_L_(0xAD, 0x7E)
#define REG_SC_BKAD_7E_H      _PK_H_(0xAD, 0x7E)
#define REG_SC_BKAD_7F_L      _PK_L_(0xAD, 0x7F)
#define REG_SC_BKAD_7F_H      _PK_H_(0xAD, 0x7F)
//----------------------------------------------
#define REG_SC_BKB0_00_L      _PK_L_(0xB0, 0x00)
#define REG_SC_BKB0_00_H      _PK_H_(0xB0, 0x00)
#define REG_SC_BKB0_01_L      _PK_L_(0xB0, 0x01)
#define REG_SC_BKB0_01_H      _PK_H_(0xB0, 0x01)
#define REG_SC_BKB0_02_L      _PK_L_(0xB0, 0x02)
#define REG_SC_BKB0_02_H      _PK_H_(0xB0, 0x02)
#define REG_SC_BKB0_03_L      _PK_L_(0xB0, 0x03)
#define REG_SC_BKB0_03_H      _PK_H_(0xB0, 0x03)
#define REG_SC_BKB0_04_L      _PK_L_(0xB0, 0x04)
#define REG_SC_BKB0_04_H      _PK_H_(0xB0, 0x04)
#define REG_SC_BKB0_05_L      _PK_L_(0xB0, 0x05)
#define REG_SC_BKB0_05_H      _PK_H_(0xB0, 0x05)
#define REG_SC_BKB0_06_L      _PK_L_(0xB0, 0x06)
#define REG_SC_BKB0_06_H      _PK_H_(0xB0, 0x06)
#define REG_SC_BKB0_07_L      _PK_L_(0xB0, 0x07)
#define REG_SC_BKB0_07_H      _PK_H_(0xB0, 0x07)
#define REG_SC_BKB0_08_L      _PK_L_(0xB0, 0x08)
#define REG_SC_BKB0_08_H      _PK_H_(0xB0, 0x08)
#define REG_SC_BKB0_09_L      _PK_L_(0xB0, 0x09)
#define REG_SC_BKB0_09_H      _PK_H_(0xB0, 0x09)
#define REG_SC_BKB0_0A_L      _PK_L_(0xB0, 0x0A)
#define REG_SC_BKB0_0A_H      _PK_H_(0xB0, 0x0A)
#define REG_SC_BKB0_0B_L      _PK_L_(0xB0, 0x0B)
#define REG_SC_BKB0_0B_H      _PK_H_(0xB0, 0x0B)
#define REG_SC_BKB0_0C_L      _PK_L_(0xB0, 0x0C)
#define REG_SC_BKB0_0C_H      _PK_H_(0xB0, 0x0C)
#define REG_SC_BKB0_0D_L      _PK_L_(0xB0, 0x0D)
#define REG_SC_BKB0_0D_H      _PK_H_(0xB0, 0x0D)
#define REG_SC_BKB0_0E_L      _PK_L_(0xB0, 0x0E)
#define REG_SC_BKB0_0E_H      _PK_H_(0xB0, 0x0E)
#define REG_SC_BKB0_0F_L      _PK_L_(0xB0, 0x0F)
#define REG_SC_BKB0_0F_H      _PK_H_(0xB0, 0x0F)
#define REG_SC_BKB0_10_L      _PK_L_(0xB0, 0x10)
#define REG_SC_BKB0_10_H      _PK_H_(0xB0, 0x10)
#define REG_SC_BKB0_11_L      _PK_L_(0xB0, 0x11)
#define REG_SC_BKB0_11_H      _PK_H_(0xB0, 0x11)
#define REG_SC_BKB0_12_L      _PK_L_(0xB0, 0x12)
#define REG_SC_BKB0_12_H      _PK_H_(0xB0, 0x12)
#define REG_SC_BKB0_13_L      _PK_L_(0xB0, 0x13)
#define REG_SC_BKB0_13_H      _PK_H_(0xB0, 0x13)
#define REG_SC_BKB0_14_L      _PK_L_(0xB0, 0x14)
#define REG_SC_BKB0_14_H      _PK_H_(0xB0, 0x14)
#define REG_SC_BKB0_15_L      _PK_L_(0xB0, 0x15)
#define REG_SC_BKB0_15_H      _PK_H_(0xB0, 0x15)
#define REG_SC_BKB0_16_L      _PK_L_(0xB0, 0x16)
#define REG_SC_BKB0_16_H      _PK_H_(0xB0, 0x16)
#define REG_SC_BKB0_17_L      _PK_L_(0xB0, 0x17)
#define REG_SC_BKB0_17_H      _PK_H_(0xB0, 0x17)
#define REG_SC_BKB0_18_L      _PK_L_(0xB0, 0x18)
#define REG_SC_BKB0_18_H      _PK_H_(0xB0, 0x18)
#define REG_SC_BKB0_19_L      _PK_L_(0xB0, 0x19)
#define REG_SC_BKB0_19_H      _PK_H_(0xB0, 0x19)
#define REG_SC_BKB0_1A_L      _PK_L_(0xB0, 0x1A)
#define REG_SC_BKB0_1A_H      _PK_H_(0xB0, 0x1A)
#define REG_SC_BKB0_1B_L      _PK_L_(0xB0, 0x1B)
#define REG_SC_BKB0_1B_H      _PK_H_(0xB0, 0x1B)
#define REG_SC_BKB0_1C_L      _PK_L_(0xB0, 0x1C)
#define REG_SC_BKB0_1C_H      _PK_H_(0xB0, 0x1C)
#define REG_SC_BKB0_1D_L      _PK_L_(0xB0, 0x1D)
#define REG_SC_BKB0_1D_H      _PK_H_(0xB0, 0x1D)
#define REG_SC_BKB0_1E_L      _PK_L_(0xB0, 0x1E)
#define REG_SC_BKB0_1E_H      _PK_H_(0xB0, 0x1E)
#define REG_SC_BKB0_1F_L      _PK_L_(0xB0, 0x1F)
#define REG_SC_BKB0_1F_H      _PK_H_(0xB0, 0x1F)
#define REG_SC_BKB0_20_L      _PK_L_(0xB0, 0x20)
#define REG_SC_BKB0_20_H      _PK_H_(0xB0, 0x20)
#define REG_SC_BKB0_21_L      _PK_L_(0xB0, 0x21)
#define REG_SC_BKB0_21_H      _PK_H_(0xB0, 0x21)
#define REG_SC_BKB0_22_L      _PK_L_(0xB0, 0x22)
#define REG_SC_BKB0_22_H      _PK_H_(0xB0, 0x22)
#define REG_SC_BKB0_23_L      _PK_L_(0xB0, 0x23)
#define REG_SC_BKB0_23_H      _PK_H_(0xB0, 0x23)
#define REG_SC_BKB0_24_L      _PK_L_(0xB0, 0x24)
#define REG_SC_BKB0_24_H      _PK_H_(0xB0, 0x24)
#define REG_SC_BKB0_25_L      _PK_L_(0xB0, 0x25)
#define REG_SC_BKB0_25_H      _PK_H_(0xB0, 0x25)
#define REG_SC_BKB0_26_L      _PK_L_(0xB0, 0x26)
#define REG_SC_BKB0_26_H      _PK_H_(0xB0, 0x26)
#define REG_SC_BKB0_27_L      _PK_L_(0xB0, 0x27)
#define REG_SC_BKB0_27_H      _PK_H_(0xB0, 0x27)
#define REG_SC_BKB0_28_L      _PK_L_(0xB0, 0x28)
#define REG_SC_BKB0_28_H      _PK_H_(0xB0, 0x28)
#define REG_SC_BKB0_29_L      _PK_L_(0xB0, 0x29)
#define REG_SC_BKB0_29_H      _PK_H_(0xB0, 0x29)
#define REG_SC_BKB0_2A_L      _PK_L_(0xB0, 0x2A)
#define REG_SC_BKB0_2A_H      _PK_H_(0xB0, 0x2A)
#define REG_SC_BKB0_2B_L      _PK_L_(0xB0, 0x2B)
#define REG_SC_BKB0_2B_H      _PK_H_(0xB0, 0x2B)
#define REG_SC_BKB0_2C_L      _PK_L_(0xB0, 0x2C)
#define REG_SC_BKB0_2C_H      _PK_H_(0xB0, 0x2C)
#define REG_SC_BKB0_2D_L      _PK_L_(0xB0, 0x2D)
#define REG_SC_BKB0_2D_H      _PK_H_(0xB0, 0x2D)
#define REG_SC_BKB0_2E_L      _PK_L_(0xB0, 0x2E)
#define REG_SC_BKB0_2E_H      _PK_H_(0xB0, 0x2E)
#define REG_SC_BKB0_2F_L      _PK_L_(0xB0, 0x2F)
#define REG_SC_BKB0_2F_H      _PK_H_(0xB0, 0x2F)
#define REG_SC_BKB0_30_L      _PK_L_(0xB0, 0x30)
#define REG_SC_BKB0_30_H      _PK_H_(0xB0, 0x30)
#define REG_SC_BKB0_31_L      _PK_L_(0xB0, 0x31)
#define REG_SC_BKB0_31_H      _PK_H_(0xB0, 0x31)
#define REG_SC_BKB0_32_L      _PK_L_(0xB0, 0x32)
#define REG_SC_BKB0_32_H      _PK_H_(0xB0, 0x32)
#define REG_SC_BKB0_33_L      _PK_L_(0xB0, 0x33)
#define REG_SC_BKB0_33_H      _PK_H_(0xB0, 0x33)
#define REG_SC_BKB0_34_L      _PK_L_(0xB0, 0x34)
#define REG_SC_BKB0_34_H      _PK_H_(0xB0, 0x34)
#define REG_SC_BKB0_35_L      _PK_L_(0xB0, 0x35)
#define REG_SC_BKB0_35_H      _PK_H_(0xB0, 0x35)
#define REG_SC_BKB0_36_L      _PK_L_(0xB0, 0x36)
#define REG_SC_BKB0_36_H      _PK_H_(0xB0, 0x36)
#define REG_SC_BKB0_37_L      _PK_L_(0xB0, 0x37)
#define REG_SC_BKB0_37_H      _PK_H_(0xB0, 0x37)
#define REG_SC_BKB0_38_L      _PK_L_(0xB0, 0x38)
#define REG_SC_BKB0_38_H      _PK_H_(0xB0, 0x38)
#define REG_SC_BKB0_39_L      _PK_L_(0xB0, 0x39)
#define REG_SC_BKB0_39_H      _PK_H_(0xB0, 0x39)
#define REG_SC_BKB0_3A_L      _PK_L_(0xB0, 0x3A)
#define REG_SC_BKB0_3A_H      _PK_H_(0xB0, 0x3A)
#define REG_SC_BKB0_3B_L      _PK_L_(0xB0, 0x3B)
#define REG_SC_BKB0_3B_H      _PK_H_(0xB0, 0x3B)
#define REG_SC_BKB0_3C_L      _PK_L_(0xB0, 0x3C)
#define REG_SC_BKB0_3C_H      _PK_H_(0xB0, 0x3C)
#define REG_SC_BKB0_3D_L      _PK_L_(0xB0, 0x3D)
#define REG_SC_BKB0_3D_H      _PK_H_(0xB0, 0x3D)
#define REG_SC_BKB0_3E_L      _PK_L_(0xB0, 0x3E)
#define REG_SC_BKB0_3E_H      _PK_H_(0xB0, 0x3E)
#define REG_SC_BKB0_3F_L      _PK_L_(0xB0, 0x3F)
#define REG_SC_BKB0_3F_H      _PK_H_(0xB0, 0x3F)
#define REG_SC_BKB0_40_L      _PK_L_(0xB0, 0x40)
#define REG_SC_BKB0_40_H      _PK_H_(0xB0, 0x40)
#define REG_SC_BKB0_41_L      _PK_L_(0xB0, 0x41)
#define REG_SC_BKB0_41_H      _PK_H_(0xB0, 0x41)
#define REG_SC_BKB0_42_L      _PK_L_(0xB0, 0x42)
#define REG_SC_BKB0_42_H      _PK_H_(0xB0, 0x42)
#define REG_SC_BKB0_43_L      _PK_L_(0xB0, 0x43)
#define REG_SC_BKB0_43_H      _PK_H_(0xB0, 0x43)
#define REG_SC_BKB0_44_L      _PK_L_(0xB0, 0x44)
#define REG_SC_BKB0_44_H      _PK_H_(0xB0, 0x44)
#define REG_SC_BKB0_45_L      _PK_L_(0xB0, 0x45)
#define REG_SC_BKB0_45_H      _PK_H_(0xB0, 0x45)
#define REG_SC_BKB0_46_L      _PK_L_(0xB0, 0x46)
#define REG_SC_BKB0_46_H      _PK_H_(0xB0, 0x46)
#define REG_SC_BKB0_47_L      _PK_L_(0xB0, 0x47)
#define REG_SC_BKB0_47_H      _PK_H_(0xB0, 0x47)
#define REG_SC_BKB0_48_L      _PK_L_(0xB0, 0x48)
#define REG_SC_BKB0_48_H      _PK_H_(0xB0, 0x48)
#define REG_SC_BKB0_49_L      _PK_L_(0xB0, 0x49)
#define REG_SC_BKB0_49_H      _PK_H_(0xB0, 0x49)
#define REG_SC_BKB0_4A_L      _PK_L_(0xB0, 0x4A)
#define REG_SC_BKB0_4A_H      _PK_H_(0xB0, 0x4A)
#define REG_SC_BKB0_4B_L      _PK_L_(0xB0, 0x4B)
#define REG_SC_BKB0_4B_H      _PK_H_(0xB0, 0x4B)
#define REG_SC_BKB0_4C_L      _PK_L_(0xB0, 0x4C)
#define REG_SC_BKB0_4C_H      _PK_H_(0xB0, 0x4C)
#define REG_SC_BKB0_4D_L      _PK_L_(0xB0, 0x4D)
#define REG_SC_BKB0_4D_H      _PK_H_(0xB0, 0x4D)
#define REG_SC_BKB0_4E_L      _PK_L_(0xB0, 0x4E)
#define REG_SC_BKB0_4E_H      _PK_H_(0xB0, 0x4E)
#define REG_SC_BKB0_4F_L      _PK_L_(0xB0, 0x4F)
#define REG_SC_BKB0_4F_H      _PK_H_(0xB0, 0x4F)
#define REG_SC_BKB0_50_L      _PK_L_(0xB0, 0x50)
#define REG_SC_BKB0_50_H      _PK_H_(0xB0, 0x50)
#define REG_SC_BKB0_51_L      _PK_L_(0xB0, 0x51)
#define REG_SC_BKB0_51_H      _PK_H_(0xB0, 0x51)
#define REG_SC_BKB0_52_L      _PK_L_(0xB0, 0x52)
#define REG_SC_BKB0_52_H      _PK_H_(0xB0, 0x52)
#define REG_SC_BKB0_53_L      _PK_L_(0xB0, 0x53)
#define REG_SC_BKB0_53_H      _PK_H_(0xB0, 0x53)
#define REG_SC_BKB0_54_L      _PK_L_(0xB0, 0x54)
#define REG_SC_BKB0_54_H      _PK_H_(0xB0, 0x54)
#define REG_SC_BKB0_55_L      _PK_L_(0xB0, 0x55)
#define REG_SC_BKB0_55_H      _PK_H_(0xB0, 0x55)
#define REG_SC_BKB0_56_L      _PK_L_(0xB0, 0x56)
#define REG_SC_BKB0_56_H      _PK_H_(0xB0, 0x56)
#define REG_SC_BKB0_57_L      _PK_L_(0xB0, 0x57)
#define REG_SC_BKB0_57_H      _PK_H_(0xB0, 0x57)
#define REG_SC_BKB0_58_L      _PK_L_(0xB0, 0x58)
#define REG_SC_BKB0_58_H      _PK_H_(0xB0, 0x58)
#define REG_SC_BKB0_59_L      _PK_L_(0xB0, 0x59)
#define REG_SC_BKB0_59_H      _PK_H_(0xB0, 0x59)
#define REG_SC_BKB0_5A_L      _PK_L_(0xB0, 0x5A)
#define REG_SC_BKB0_5A_H      _PK_H_(0xB0, 0x5A)
#define REG_SC_BKB0_5B_L      _PK_L_(0xB0, 0x5B)
#define REG_SC_BKB0_5B_H      _PK_H_(0xB0, 0x5B)
#define REG_SC_BKB0_5C_L      _PK_L_(0xB0, 0x5C)
#define REG_SC_BKB0_5C_H      _PK_H_(0xB0, 0x5C)
#define REG_SC_BKB0_5D_L      _PK_L_(0xB0, 0x5D)
#define REG_SC_BKB0_5D_H      _PK_H_(0xB0, 0x5D)
#define REG_SC_BKB0_5E_L      _PK_L_(0xB0, 0x5E)
#define REG_SC_BKB0_5E_H      _PK_H_(0xB0, 0x5E)
#define REG_SC_BKB0_5F_L      _PK_L_(0xB0, 0x5F)
#define REG_SC_BKB0_5F_H      _PK_H_(0xB0, 0x5F)
#define REG_SC_BKB0_60_L      _PK_L_(0xB0, 0x60)
#define REG_SC_BKB0_60_H      _PK_H_(0xB0, 0x60)
#define REG_SC_BKB0_61_L      _PK_L_(0xB0, 0x61)
#define REG_SC_BKB0_61_H      _PK_H_(0xB0, 0x61)
#define REG_SC_BKB0_62_L      _PK_L_(0xB0, 0x62)
#define REG_SC_BKB0_62_H      _PK_H_(0xB0, 0x62)
#define REG_SC_BKB0_63_L      _PK_L_(0xB0, 0x63)
#define REG_SC_BKB0_63_H      _PK_H_(0xB0, 0x63)
#define REG_SC_BKB0_64_L      _PK_L_(0xB0, 0x64)
#define REG_SC_BKB0_64_H      _PK_H_(0xB0, 0x64)
#define REG_SC_BKB0_65_L      _PK_L_(0xB0, 0x65)
#define REG_SC_BKB0_65_H      _PK_H_(0xB0, 0x65)
#define REG_SC_BKB0_66_L      _PK_L_(0xB0, 0x66)
#define REG_SC_BKB0_66_H      _PK_H_(0xB0, 0x66)
#define REG_SC_BKB0_67_L      _PK_L_(0xB0, 0x67)
#define REG_SC_BKB0_67_H      _PK_H_(0xB0, 0x67)
#define REG_SC_BKB0_68_L      _PK_L_(0xB0, 0x68)
#define REG_SC_BKB0_68_H      _PK_H_(0xB0, 0x68)
#define REG_SC_BKB0_69_L      _PK_L_(0xB0, 0x69)
#define REG_SC_BKB0_69_H      _PK_H_(0xB0, 0x69)
#define REG_SC_BKB0_6A_L      _PK_L_(0xB0, 0x6A)
#define REG_SC_BKB0_6A_H      _PK_H_(0xB0, 0x6A)
#define REG_SC_BKB0_6B_L      _PK_L_(0xB0, 0x6B)
#define REG_SC_BKB0_6B_H      _PK_H_(0xB0, 0x6B)
#define REG_SC_BKB0_6C_L      _PK_L_(0xB0, 0x6C)
#define REG_SC_BKB0_6C_H      _PK_H_(0xB0, 0x6C)
#define REG_SC_BKB0_6D_L      _PK_L_(0xB0, 0x6D)
#define REG_SC_BKB0_6D_H      _PK_H_(0xB0, 0x6D)
#define REG_SC_BKB0_6E_L      _PK_L_(0xB0, 0x6E)
#define REG_SC_BKB0_6E_H      _PK_H_(0xB0, 0x6E)
#define REG_SC_BKB0_6F_L      _PK_L_(0xB0, 0x6F)
#define REG_SC_BKB0_6F_H      _PK_H_(0xB0, 0x6F)
#define REG_SC_BKB0_70_L      _PK_L_(0xB0, 0x70)
#define REG_SC_BKB0_70_H      _PK_H_(0xB0, 0x70)
#define REG_SC_BKB0_71_L      _PK_L_(0xB0, 0x71)
#define REG_SC_BKB0_71_H      _PK_H_(0xB0, 0x71)
#define REG_SC_BKB0_72_L      _PK_L_(0xB0, 0x72)
#define REG_SC_BKB0_72_H      _PK_H_(0xB0, 0x72)
#define REG_SC_BKB0_73_L      _PK_L_(0xB0, 0x73)
#define REG_SC_BKB0_73_H      _PK_H_(0xB0, 0x73)
#define REG_SC_BKB0_74_L      _PK_L_(0xB0, 0x74)
#define REG_SC_BKB0_74_H      _PK_H_(0xB0, 0x74)
#define REG_SC_BKB0_75_L      _PK_L_(0xB0, 0x75)
#define REG_SC_BKB0_75_H      _PK_H_(0xB0, 0x75)
#define REG_SC_BKB0_76_L      _PK_L_(0xB0, 0x76)
#define REG_SC_BKB0_76_H      _PK_H_(0xB0, 0x76)
#define REG_SC_BKB0_77_L      _PK_L_(0xB0, 0x77)
#define REG_SC_BKB0_77_H      _PK_H_(0xB0, 0x77)
#define REG_SC_BKB0_78_L      _PK_L_(0xB0, 0x78)
#define REG_SC_BKB0_78_H      _PK_H_(0xB0, 0x78)
#define REG_SC_BKB0_79_L      _PK_L_(0xB0, 0x79)
#define REG_SC_BKB0_79_H      _PK_H_(0xB0, 0x79)
#define REG_SC_BKB0_7A_L      _PK_L_(0xB0, 0x7A)
#define REG_SC_BKB0_7A_H      _PK_H_(0xB0, 0x7A)
#define REG_SC_BKB0_7B_L      _PK_L_(0xB0, 0x7B)
#define REG_SC_BKB0_7B_H      _PK_H_(0xB0, 0x7B)
#define REG_SC_BKB0_7C_L      _PK_L_(0xB0, 0x7C)
#define REG_SC_BKB0_7C_H      _PK_H_(0xB0, 0x7C)
#define REG_SC_BKB0_7D_L      _PK_L_(0xB0, 0x7D)
#define REG_SC_BKB0_7D_H      _PK_H_(0xB0, 0x7D)
#define REG_SC_BKB0_7E_L      _PK_L_(0xB0, 0x7E)
#define REG_SC_BKB0_7E_H      _PK_H_(0xB0, 0x7E)
#define REG_SC_BKB0_7F_L      _PK_L_(0xB0, 0x7F)
#define REG_SC_BKB0_7F_H      _PK_H_(0xB0, 0x7F)
//----------------------------------------------
#define REG_SC_BKB1_00_L      _PK_L_(0xB1, 0x00)
#define REG_SC_BKB1_00_H      _PK_H_(0xB1, 0x00)
#define REG_SC_BKB1_01_L      _PK_L_(0xB1, 0x01)
#define REG_SC_BKB1_01_H      _PK_H_(0xB1, 0x01)
#define REG_SC_BKB1_02_L      _PK_L_(0xB1, 0x02)
#define REG_SC_BKB1_02_H      _PK_H_(0xB1, 0x02)
#define REG_SC_BKB1_03_L      _PK_L_(0xB1, 0x03)
#define REG_SC_BKB1_03_H      _PK_H_(0xB1, 0x03)
#define REG_SC_BKB1_04_L      _PK_L_(0xB1, 0x04)
#define REG_SC_BKB1_04_H      _PK_H_(0xB1, 0x04)
#define REG_SC_BKB1_05_L      _PK_L_(0xB1, 0x05)
#define REG_SC_BKB1_05_H      _PK_H_(0xB1, 0x05)
#define REG_SC_BKB1_06_L      _PK_L_(0xB1, 0x06)
#define REG_SC_BKB1_06_H      _PK_H_(0xB1, 0x06)
#define REG_SC_BKB1_07_L      _PK_L_(0xB1, 0x07)
#define REG_SC_BKB1_07_H      _PK_H_(0xB1, 0x07)
#define REG_SC_BKB1_08_L      _PK_L_(0xB1, 0x08)
#define REG_SC_BKB1_08_H      _PK_H_(0xB1, 0x08)
#define REG_SC_BKB1_09_L      _PK_L_(0xB1, 0x09)
#define REG_SC_BKB1_09_H      _PK_H_(0xB1, 0x09)
#define REG_SC_BKB1_0A_L      _PK_L_(0xB1, 0x0A)
#define REG_SC_BKB1_0A_H      _PK_H_(0xB1, 0x0A)
#define REG_SC_BKB1_0B_L      _PK_L_(0xB1, 0x0B)
#define REG_SC_BKB1_0B_H      _PK_H_(0xB1, 0x0B)
#define REG_SC_BKB1_0C_L      _PK_L_(0xB1, 0x0C)
#define REG_SC_BKB1_0C_H      _PK_H_(0xB1, 0x0C)
#define REG_SC_BKB1_0D_L      _PK_L_(0xB1, 0x0D)
#define REG_SC_BKB1_0D_H      _PK_H_(0xB1, 0x0D)
#define REG_SC_BKB1_0E_L      _PK_L_(0xB1, 0x0E)
#define REG_SC_BKB1_0E_H      _PK_H_(0xB1, 0x0E)
#define REG_SC_BKB1_0F_L      _PK_L_(0xB1, 0x0F)
#define REG_SC_BKB1_0F_H      _PK_H_(0xB1, 0x0F)
#define REG_SC_BKB1_10_L      _PK_L_(0xB1, 0x10)
#define REG_SC_BKB1_10_H      _PK_H_(0xB1, 0x10)
#define REG_SC_BKB1_11_L      _PK_L_(0xB1, 0x11)
#define REG_SC_BKB1_11_H      _PK_H_(0xB1, 0x11)
#define REG_SC_BKB1_12_L      _PK_L_(0xB1, 0x12)
#define REG_SC_BKB1_12_H      _PK_H_(0xB1, 0x12)
#define REG_SC_BKB1_13_L      _PK_L_(0xB1, 0x13)
#define REG_SC_BKB1_13_H      _PK_H_(0xB1, 0x13)
#define REG_SC_BKB1_14_L      _PK_L_(0xB1, 0x14)
#define REG_SC_BKB1_14_H      _PK_H_(0xB1, 0x14)
#define REG_SC_BKB1_15_L      _PK_L_(0xB1, 0x15)
#define REG_SC_BKB1_15_H      _PK_H_(0xB1, 0x15)
#define REG_SC_BKB1_16_L      _PK_L_(0xB1, 0x16)
#define REG_SC_BKB1_16_H      _PK_H_(0xB1, 0x16)
#define REG_SC_BKB1_17_L      _PK_L_(0xB1, 0x17)
#define REG_SC_BKB1_17_H      _PK_H_(0xB1, 0x17)
#define REG_SC_BKB1_18_L      _PK_L_(0xB1, 0x18)
#define REG_SC_BKB1_18_H      _PK_H_(0xB1, 0x18)
#define REG_SC_BKB1_19_L      _PK_L_(0xB1, 0x19)
#define REG_SC_BKB1_19_H      _PK_H_(0xB1, 0x19)
#define REG_SC_BKB1_1A_L      _PK_L_(0xB1, 0x1A)
#define REG_SC_BKB1_1A_H      _PK_H_(0xB1, 0x1A)
#define REG_SC_BKB1_1B_L      _PK_L_(0xB1, 0x1B)
#define REG_SC_BKB1_1B_H      _PK_H_(0xB1, 0x1B)
#define REG_SC_BKB1_1C_L      _PK_L_(0xB1, 0x1C)
#define REG_SC_BKB1_1C_H      _PK_H_(0xB1, 0x1C)
#define REG_SC_BKB1_1D_L      _PK_L_(0xB1, 0x1D)
#define REG_SC_BKB1_1D_H      _PK_H_(0xB1, 0x1D)
#define REG_SC_BKB1_1E_L      _PK_L_(0xB1, 0x1E)
#define REG_SC_BKB1_1E_H      _PK_H_(0xB1, 0x1E)
#define REG_SC_BKB1_1F_L      _PK_L_(0xB1, 0x1F)
#define REG_SC_BKB1_1F_H      _PK_H_(0xB1, 0x1F)
#define REG_SC_BKB1_20_L      _PK_L_(0xB1, 0x20)
#define REG_SC_BKB1_20_H      _PK_H_(0xB1, 0x20)
#define REG_SC_BKB1_21_L      _PK_L_(0xB1, 0x21)
#define REG_SC_BKB1_21_H      _PK_H_(0xB1, 0x21)
#define REG_SC_BKB1_22_L      _PK_L_(0xB1, 0x22)
#define REG_SC_BKB1_22_H      _PK_H_(0xB1, 0x22)
#define REG_SC_BKB1_23_L      _PK_L_(0xB1, 0x23)
#define REG_SC_BKB1_23_H      _PK_H_(0xB1, 0x23)
#define REG_SC_BKB1_24_L      _PK_L_(0xB1, 0x24)
#define REG_SC_BKB1_24_H      _PK_H_(0xB1, 0x24)
#define REG_SC_BKB1_25_L      _PK_L_(0xB1, 0x25)
#define REG_SC_BKB1_25_H      _PK_H_(0xB1, 0x25)
#define REG_SC_BKB1_26_L      _PK_L_(0xB1, 0x26)
#define REG_SC_BKB1_26_H      _PK_H_(0xB1, 0x26)
#define REG_SC_BKB1_27_L      _PK_L_(0xB1, 0x27)
#define REG_SC_BKB1_27_H      _PK_H_(0xB1, 0x27)
#define REG_SC_BKB1_28_L      _PK_L_(0xB1, 0x28)
#define REG_SC_BKB1_28_H      _PK_H_(0xB1, 0x28)
#define REG_SC_BKB1_29_L      _PK_L_(0xB1, 0x29)
#define REG_SC_BKB1_29_H      _PK_H_(0xB1, 0x29)
#define REG_SC_BKB1_2A_L      _PK_L_(0xB1, 0x2A)
#define REG_SC_BKB1_2A_H      _PK_H_(0xB1, 0x2A)
#define REG_SC_BKB1_2B_L      _PK_L_(0xB1, 0x2B)
#define REG_SC_BKB1_2B_H      _PK_H_(0xB1, 0x2B)
#define REG_SC_BKB1_2C_L      _PK_L_(0xB1, 0x2C)
#define REG_SC_BKB1_2C_H      _PK_H_(0xB1, 0x2C)
#define REG_SC_BKB1_2D_L      _PK_L_(0xB1, 0x2D)
#define REG_SC_BKB1_2D_H      _PK_H_(0xB1, 0x2D)
#define REG_SC_BKB1_2E_L      _PK_L_(0xB1, 0x2E)
#define REG_SC_BKB1_2E_H      _PK_H_(0xB1, 0x2E)
#define REG_SC_BKB1_2F_L      _PK_L_(0xB1, 0x2F)
#define REG_SC_BKB1_2F_H      _PK_H_(0xB1, 0x2F)
#define REG_SC_BKB1_30_L      _PK_L_(0xB1, 0x30)
#define REG_SC_BKB1_30_H      _PK_H_(0xB1, 0x30)
#define REG_SC_BKB1_31_L      _PK_L_(0xB1, 0x31)
#define REG_SC_BKB1_31_H      _PK_H_(0xB1, 0x31)
#define REG_SC_BKB1_32_L      _PK_L_(0xB1, 0x32)
#define REG_SC_BKB1_32_H      _PK_H_(0xB1, 0x32)
#define REG_SC_BKB1_33_L      _PK_L_(0xB1, 0x33)
#define REG_SC_BKB1_33_H      _PK_H_(0xB1, 0x33)
#define REG_SC_BKB1_34_L      _PK_L_(0xB1, 0x34)
#define REG_SC_BKB1_34_H      _PK_H_(0xB1, 0x34)
#define REG_SC_BKB1_35_L      _PK_L_(0xB1, 0x35)
#define REG_SC_BKB1_35_H      _PK_H_(0xB1, 0x35)
#define REG_SC_BKB1_36_L      _PK_L_(0xB1, 0x36)
#define REG_SC_BKB1_36_H      _PK_H_(0xB1, 0x36)
#define REG_SC_BKB1_37_L      _PK_L_(0xB1, 0x37)
#define REG_SC_BKB1_37_H      _PK_H_(0xB1, 0x37)
#define REG_SC_BKB1_38_L      _PK_L_(0xB1, 0x38)
#define REG_SC_BKB1_38_H      _PK_H_(0xB1, 0x38)
#define REG_SC_BKB1_39_L      _PK_L_(0xB1, 0x39)
#define REG_SC_BKB1_39_H      _PK_H_(0xB1, 0x39)
#define REG_SC_BKB1_3A_L      _PK_L_(0xB1, 0x3A)
#define REG_SC_BKB1_3A_H      _PK_H_(0xB1, 0x3A)
#define REG_SC_BKB1_3B_L      _PK_L_(0xB1, 0x3B)
#define REG_SC_BKB1_3B_H      _PK_H_(0xB1, 0x3B)
#define REG_SC_BKB1_3C_L      _PK_L_(0xB1, 0x3C)
#define REG_SC_BKB1_3C_H      _PK_H_(0xB1, 0x3C)
#define REG_SC_BKB1_3D_L      _PK_L_(0xB1, 0x3D)
#define REG_SC_BKB1_3D_H      _PK_H_(0xB1, 0x3D)
#define REG_SC_BKB1_3E_L      _PK_L_(0xB1, 0x3E)
#define REG_SC_BKB1_3E_H      _PK_H_(0xB1, 0x3E)
#define REG_SC_BKB1_3F_L      _PK_L_(0xB1, 0x3F)
#define REG_SC_BKB1_3F_H      _PK_H_(0xB1, 0x3F)
#define REG_SC_BKB1_40_L      _PK_L_(0xB1, 0x40)
#define REG_SC_BKB1_40_H      _PK_H_(0xB1, 0x40)
#define REG_SC_BKB1_41_L      _PK_L_(0xB1, 0x41)
#define REG_SC_BKB1_41_H      _PK_H_(0xB1, 0x41)
#define REG_SC_BKB1_42_L      _PK_L_(0xB1, 0x42)
#define REG_SC_BKB1_42_H      _PK_H_(0xB1, 0x42)
#define REG_SC_BKB1_43_L      _PK_L_(0xB1, 0x43)
#define REG_SC_BKB1_43_H      _PK_H_(0xB1, 0x43)
#define REG_SC_BKB1_44_L      _PK_L_(0xB1, 0x44)
#define REG_SC_BKB1_44_H      _PK_H_(0xB1, 0x44)
#define REG_SC_BKB1_45_L      _PK_L_(0xB1, 0x45)
#define REG_SC_BKB1_45_H      _PK_H_(0xB1, 0x45)
#define REG_SC_BKB1_46_L      _PK_L_(0xB1, 0x46)
#define REG_SC_BKB1_46_H      _PK_H_(0xB1, 0x46)
#define REG_SC_BKB1_47_L      _PK_L_(0xB1, 0x47)
#define REG_SC_BKB1_47_H      _PK_H_(0xB1, 0x47)
#define REG_SC_BKB1_48_L      _PK_L_(0xB1, 0x48)
#define REG_SC_BKB1_48_H      _PK_H_(0xB1, 0x48)
#define REG_SC_BKB1_49_L      _PK_L_(0xB1, 0x49)
#define REG_SC_BKB1_49_H      _PK_H_(0xB1, 0x49)
#define REG_SC_BKB1_4A_L      _PK_L_(0xB1, 0x4A)
#define REG_SC_BKB1_4A_H      _PK_H_(0xB1, 0x4A)
#define REG_SC_BKB1_4B_L      _PK_L_(0xB1, 0x4B)
#define REG_SC_BKB1_4B_H      _PK_H_(0xB1, 0x4B)
#define REG_SC_BKB1_4C_L      _PK_L_(0xB1, 0x4C)
#define REG_SC_BKB1_4C_H      _PK_H_(0xB1, 0x4C)
#define REG_SC_BKB1_4D_L      _PK_L_(0xB1, 0x4D)
#define REG_SC_BKB1_4D_H      _PK_H_(0xB1, 0x4D)
#define REG_SC_BKB1_4E_L      _PK_L_(0xB1, 0x4E)
#define REG_SC_BKB1_4E_H      _PK_H_(0xB1, 0x4E)
#define REG_SC_BKB1_4F_L      _PK_L_(0xB1, 0x4F)
#define REG_SC_BKB1_4F_H      _PK_H_(0xB1, 0x4F)
#define REG_SC_BKB1_50_L      _PK_L_(0xB1, 0x50)
#define REG_SC_BKB1_50_H      _PK_H_(0xB1, 0x50)
#define REG_SC_BKB1_51_L      _PK_L_(0xB1, 0x51)
#define REG_SC_BKB1_51_H      _PK_H_(0xB1, 0x51)
#define REG_SC_BKB1_52_L      _PK_L_(0xB1, 0x52)
#define REG_SC_BKB1_52_H      _PK_H_(0xB1, 0x52)
#define REG_SC_BKB1_53_L      _PK_L_(0xB1, 0x53)
#define REG_SC_BKB1_53_H      _PK_H_(0xB1, 0x53)
#define REG_SC_BKB1_54_L      _PK_L_(0xB1, 0x54)
#define REG_SC_BKB1_54_H      _PK_H_(0xB1, 0x54)
#define REG_SC_BKB1_55_L      _PK_L_(0xB1, 0x55)
#define REG_SC_BKB1_55_H      _PK_H_(0xB1, 0x55)
#define REG_SC_BKB1_56_L      _PK_L_(0xB1, 0x56)
#define REG_SC_BKB1_56_H      _PK_H_(0xB1, 0x56)
#define REG_SC_BKB1_57_L      _PK_L_(0xB1, 0x57)
#define REG_SC_BKB1_57_H      _PK_H_(0xB1, 0x57)
#define REG_SC_BKB1_58_L      _PK_L_(0xB1, 0x58)
#define REG_SC_BKB1_58_H      _PK_H_(0xB1, 0x58)
#define REG_SC_BKB1_59_L      _PK_L_(0xB1, 0x59)
#define REG_SC_BKB1_59_H      _PK_H_(0xB1, 0x59)
#define REG_SC_BKB1_5A_L      _PK_L_(0xB1, 0x5A)
#define REG_SC_BKB1_5A_H      _PK_H_(0xB1, 0x5A)
#define REG_SC_BKB1_5B_L      _PK_L_(0xB1, 0x5B)
#define REG_SC_BKB1_5B_H      _PK_H_(0xB1, 0x5B)
#define REG_SC_BKB1_5C_L      _PK_L_(0xB1, 0x5C)
#define REG_SC_BKB1_5C_H      _PK_H_(0xB1, 0x5C)
#define REG_SC_BKB1_5D_L      _PK_L_(0xB1, 0x5D)
#define REG_SC_BKB1_5D_H      _PK_H_(0xB1, 0x5D)
#define REG_SC_BKB1_5E_L      _PK_L_(0xB1, 0x5E)
#define REG_SC_BKB1_5E_H      _PK_H_(0xB1, 0x5E)
#define REG_SC_BKB1_5F_L      _PK_L_(0xB1, 0x5F)
#define REG_SC_BKB1_5F_H      _PK_H_(0xB1, 0x5F)
#define REG_SC_BKB1_60_L      _PK_L_(0xB1, 0x60)
#define REG_SC_BKB1_60_H      _PK_H_(0xB1, 0x60)
#define REG_SC_BKB1_61_L      _PK_L_(0xB1, 0x61)
#define REG_SC_BKB1_61_H      _PK_H_(0xB1, 0x61)
#define REG_SC_BKB1_62_L      _PK_L_(0xB1, 0x62)
#define REG_SC_BKB1_62_H      _PK_H_(0xB1, 0x62)
#define REG_SC_BKB1_63_L      _PK_L_(0xB1, 0x63)
#define REG_SC_BKB1_63_H      _PK_H_(0xB1, 0x63)
#define REG_SC_BKB1_64_L      _PK_L_(0xB1, 0x64)
#define REG_SC_BKB1_64_H      _PK_H_(0xB1, 0x64)
#define REG_SC_BKB1_65_L      _PK_L_(0xB1, 0x65)
#define REG_SC_BKB1_65_H      _PK_H_(0xB1, 0x65)
#define REG_SC_BKB1_66_L      _PK_L_(0xB1, 0x66)
#define REG_SC_BKB1_66_H      _PK_H_(0xB1, 0x66)
#define REG_SC_BKB1_67_L      _PK_L_(0xB1, 0x67)
#define REG_SC_BKB1_67_H      _PK_H_(0xB1, 0x67)
#define REG_SC_BKB1_68_L      _PK_L_(0xB1, 0x68)
#define REG_SC_BKB1_68_H      _PK_H_(0xB1, 0x68)
#define REG_SC_BKB1_69_L      _PK_L_(0xB1, 0x69)
#define REG_SC_BKB1_69_H      _PK_H_(0xB1, 0x69)
#define REG_SC_BKB1_6A_L      _PK_L_(0xB1, 0x6A)
#define REG_SC_BKB1_6A_H      _PK_H_(0xB1, 0x6A)
#define REG_SC_BKB1_6B_L      _PK_L_(0xB1, 0x6B)
#define REG_SC_BKB1_6B_H      _PK_H_(0xB1, 0x6B)
#define REG_SC_BKB1_6C_L      _PK_L_(0xB1, 0x6C)
#define REG_SC_BKB1_6C_H      _PK_H_(0xB1, 0x6C)
#define REG_SC_BKB1_6D_L      _PK_L_(0xB1, 0x6D)
#define REG_SC_BKB1_6D_H      _PK_H_(0xB1, 0x6D)
#define REG_SC_BKB1_6E_L      _PK_L_(0xB1, 0x6E)
#define REG_SC_BKB1_6E_H      _PK_H_(0xB1, 0x6E)
#define REG_SC_BKB1_6F_L      _PK_L_(0xB1, 0x6F)
#define REG_SC_BKB1_6F_H      _PK_H_(0xB1, 0x6F)
#define REG_SC_BKB1_70_L      _PK_L_(0xB1, 0x70)
#define REG_SC_BKB1_70_H      _PK_H_(0xB1, 0x70)
#define REG_SC_BKB1_71_L      _PK_L_(0xB1, 0x71)
#define REG_SC_BKB1_71_H      _PK_H_(0xB1, 0x71)
#define REG_SC_BKB1_72_L      _PK_L_(0xB1, 0x72)
#define REG_SC_BKB1_72_H      _PK_H_(0xB1, 0x72)
#define REG_SC_BKB1_73_L      _PK_L_(0xB1, 0x73)
#define REG_SC_BKB1_73_H      _PK_H_(0xB1, 0x73)
#define REG_SC_BKB1_74_L      _PK_L_(0xB1, 0x74)
#define REG_SC_BKB1_74_H      _PK_H_(0xB1, 0x74)
#define REG_SC_BKB1_75_L      _PK_L_(0xB1, 0x75)
#define REG_SC_BKB1_75_H      _PK_H_(0xB1, 0x75)
#define REG_SC_BKB1_76_L      _PK_L_(0xB1, 0x76)
#define REG_SC_BKB1_76_H      _PK_H_(0xB1, 0x76)
#define REG_SC_BKB1_77_L      _PK_L_(0xB1, 0x77)
#define REG_SC_BKB1_77_H      _PK_H_(0xB1, 0x77)
#define REG_SC_BKB1_78_L      _PK_L_(0xB1, 0x78)
#define REG_SC_BKB1_78_H      _PK_H_(0xB1, 0x78)
#define REG_SC_BKB1_79_L      _PK_L_(0xB1, 0x79)
#define REG_SC_BKB1_79_H      _PK_H_(0xB1, 0x79)
#define REG_SC_BKB1_7A_L      _PK_L_(0xB1, 0x7A)
#define REG_SC_BKB1_7A_H      _PK_H_(0xB1, 0x7A)
#define REG_SC_BKB1_7B_L      _PK_L_(0xB1, 0x7B)
#define REG_SC_BKB1_7B_H      _PK_H_(0xB1, 0x7B)
#define REG_SC_BKB1_7C_L      _PK_L_(0xB1, 0x7C)
#define REG_SC_BKB1_7C_H      _PK_H_(0xB1, 0x7C)
#define REG_SC_BKB1_7D_L      _PK_L_(0xB1, 0x7D)
#define REG_SC_BKB1_7D_H      _PK_H_(0xB1, 0x7D)
#define REG_SC_BKB1_7E_L      _PK_L_(0xB1, 0x7E)
#define REG_SC_BKB1_7E_H      _PK_H_(0xB1, 0x7E)
#define REG_SC_BKB1_7F_L      _PK_L_(0xB1, 0x7F)
#define REG_SC_BKB1_7F_H      _PK_H_(0xB1, 0x7F)
//----------------------------------------------
#define REG_SC_BKB2_00_L      _PK_L_(0xB2, 0x00)
#define REG_SC_BKB2_00_H      _PK_H_(0xB2, 0x00)
#define REG_SC_BKB2_01_L      _PK_L_(0xB2, 0x01)
#define REG_SC_BKB2_01_H      _PK_H_(0xB2, 0x01)
#define REG_SC_BKB2_02_L      _PK_L_(0xB2, 0x02)
#define REG_SC_BKB2_02_H      _PK_H_(0xB2, 0x02)
#define REG_SC_BKB2_03_L      _PK_L_(0xB2, 0x03)
#define REG_SC_BKB2_03_H      _PK_H_(0xB2, 0x03)
#define REG_SC_BKB2_04_L      _PK_L_(0xB2, 0x04)
#define REG_SC_BKB2_04_H      _PK_H_(0xB2, 0x04)
#define REG_SC_BKB2_05_L      _PK_L_(0xB2, 0x05)
#define REG_SC_BKB2_05_H      _PK_H_(0xB2, 0x05)
#define REG_SC_BKB2_06_L      _PK_L_(0xB2, 0x06)
#define REG_SC_BKB2_06_H      _PK_H_(0xB2, 0x06)
#define REG_SC_BKB2_07_L      _PK_L_(0xB2, 0x07)
#define REG_SC_BKB2_07_H      _PK_H_(0xB2, 0x07)
#define REG_SC_BKB2_08_L      _PK_L_(0xB2, 0x08)
#define REG_SC_BKB2_08_H      _PK_H_(0xB2, 0x08)
#define REG_SC_BKB2_09_L      _PK_L_(0xB2, 0x09)
#define REG_SC_BKB2_09_H      _PK_H_(0xB2, 0x09)
#define REG_SC_BKB2_0A_L      _PK_L_(0xB2, 0x0A)
#define REG_SC_BKB2_0A_H      _PK_H_(0xB2, 0x0A)
#define REG_SC_BKB2_0B_L      _PK_L_(0xB2, 0x0B)
#define REG_SC_BKB2_0B_H      _PK_H_(0xB2, 0x0B)
#define REG_SC_BKB2_0C_L      _PK_L_(0xB2, 0x0C)
#define REG_SC_BKB2_0C_H      _PK_H_(0xB2, 0x0C)
#define REG_SC_BKB2_0D_L      _PK_L_(0xB2, 0x0D)
#define REG_SC_BKB2_0D_H      _PK_H_(0xB2, 0x0D)
#define REG_SC_BKB2_0E_L      _PK_L_(0xB2, 0x0E)
#define REG_SC_BKB2_0E_H      _PK_H_(0xB2, 0x0E)
#define REG_SC_BKB2_0F_L      _PK_L_(0xB2, 0x0F)
#define REG_SC_BKB2_0F_H      _PK_H_(0xB2, 0x0F)
#define REG_SC_BKB2_10_L      _PK_L_(0xB2, 0x10)
#define REG_SC_BKB2_10_H      _PK_H_(0xB2, 0x10)
#define REG_SC_BKB2_11_L      _PK_L_(0xB2, 0x11)
#define REG_SC_BKB2_11_H      _PK_H_(0xB2, 0x11)
#define REG_SC_BKB2_12_L      _PK_L_(0xB2, 0x12)
#define REG_SC_BKB2_12_H      _PK_H_(0xB2, 0x12)
#define REG_SC_BKB2_13_L      _PK_L_(0xB2, 0x13)
#define REG_SC_BKB2_13_H      _PK_H_(0xB2, 0x13)
#define REG_SC_BKB2_14_L      _PK_L_(0xB2, 0x14)
#define REG_SC_BKB2_14_H      _PK_H_(0xB2, 0x14)
#define REG_SC_BKB2_15_L      _PK_L_(0xB2, 0x15)
#define REG_SC_BKB2_15_H      _PK_H_(0xB2, 0x15)
#define REG_SC_BKB2_16_L      _PK_L_(0xB2, 0x16)
#define REG_SC_BKB2_16_H      _PK_H_(0xB2, 0x16)
#define REG_SC_BKB2_17_L      _PK_L_(0xB2, 0x17)
#define REG_SC_BKB2_17_H      _PK_H_(0xB2, 0x17)
#define REG_SC_BKB2_18_L      _PK_L_(0xB2, 0x18)
#define REG_SC_BKB2_18_H      _PK_H_(0xB2, 0x18)
#define REG_SC_BKB2_19_L      _PK_L_(0xB2, 0x19)
#define REG_SC_BKB2_19_H      _PK_H_(0xB2, 0x19)
#define REG_SC_BKB2_1A_L      _PK_L_(0xB2, 0x1A)
#define REG_SC_BKB2_1A_H      _PK_H_(0xB2, 0x1A)
#define REG_SC_BKB2_1B_L      _PK_L_(0xB2, 0x1B)
#define REG_SC_BKB2_1B_H      _PK_H_(0xB2, 0x1B)
#define REG_SC_BKB2_1C_L      _PK_L_(0xB2, 0x1C)
#define REG_SC_BKB2_1C_H      _PK_H_(0xB2, 0x1C)
#define REG_SC_BKB2_1D_L      _PK_L_(0xB2, 0x1D)
#define REG_SC_BKB2_1D_H      _PK_H_(0xB2, 0x1D)
#define REG_SC_BKB2_1E_L      _PK_L_(0xB2, 0x1E)
#define REG_SC_BKB2_1E_H      _PK_H_(0xB2, 0x1E)
#define REG_SC_BKB2_1F_L      _PK_L_(0xB2, 0x1F)
#define REG_SC_BKB2_1F_H      _PK_H_(0xB2, 0x1F)
#define REG_SC_BKB2_20_L      _PK_L_(0xB2, 0x20)
#define REG_SC_BKB2_20_H      _PK_H_(0xB2, 0x20)
#define REG_SC_BKB2_21_L      _PK_L_(0xB2, 0x21)
#define REG_SC_BKB2_21_H      _PK_H_(0xB2, 0x21)
#define REG_SC_BKB2_22_L      _PK_L_(0xB2, 0x22)
#define REG_SC_BKB2_22_H      _PK_H_(0xB2, 0x22)
#define REG_SC_BKB2_23_L      _PK_L_(0xB2, 0x23)
#define REG_SC_BKB2_23_H      _PK_H_(0xB2, 0x23)
#define REG_SC_BKB2_24_L      _PK_L_(0xB2, 0x24)
#define REG_SC_BKB2_24_H      _PK_H_(0xB2, 0x24)
#define REG_SC_BKB2_25_L      _PK_L_(0xB2, 0x25)
#define REG_SC_BKB2_25_H      _PK_H_(0xB2, 0x25)
#define REG_SC_BKB2_26_L      _PK_L_(0xB2, 0x26)
#define REG_SC_BKB2_26_H      _PK_H_(0xB2, 0x26)
#define REG_SC_BKB2_27_L      _PK_L_(0xB2, 0x27)
#define REG_SC_BKB2_27_H      _PK_H_(0xB2, 0x27)
#define REG_SC_BKB2_28_L      _PK_L_(0xB2, 0x28)
#define REG_SC_BKB2_28_H      _PK_H_(0xB2, 0x28)
#define REG_SC_BKB2_29_L      _PK_L_(0xB2, 0x29)
#define REG_SC_BKB2_29_H      _PK_H_(0xB2, 0x29)
#define REG_SC_BKB2_2A_L      _PK_L_(0xB2, 0x2A)
#define REG_SC_BKB2_2A_H      _PK_H_(0xB2, 0x2A)
#define REG_SC_BKB2_2B_L      _PK_L_(0xB2, 0x2B)
#define REG_SC_BKB2_2B_H      _PK_H_(0xB2, 0x2B)
#define REG_SC_BKB2_2C_L      _PK_L_(0xB2, 0x2C)
#define REG_SC_BKB2_2C_H      _PK_H_(0xB2, 0x2C)
#define REG_SC_BKB2_2D_L      _PK_L_(0xB2, 0x2D)
#define REG_SC_BKB2_2D_H      _PK_H_(0xB2, 0x2D)
#define REG_SC_BKB2_2E_L      _PK_L_(0xB2, 0x2E)
#define REG_SC_BKB2_2E_H      _PK_H_(0xB2, 0x2E)
#define REG_SC_BKB2_2F_L      _PK_L_(0xB2, 0x2F)
#define REG_SC_BKB2_2F_H      _PK_H_(0xB2, 0x2F)
#define REG_SC_BKB2_30_L      _PK_L_(0xB2, 0x30)
#define REG_SC_BKB2_30_H      _PK_H_(0xB2, 0x30)
#define REG_SC_BKB2_31_L      _PK_L_(0xB2, 0x31)
#define REG_SC_BKB2_31_H      _PK_H_(0xB2, 0x31)
#define REG_SC_BKB2_32_L      _PK_L_(0xB2, 0x32)
#define REG_SC_BKB2_32_H      _PK_H_(0xB2, 0x32)
#define REG_SC_BKB2_33_L      _PK_L_(0xB2, 0x33)
#define REG_SC_BKB2_33_H      _PK_H_(0xB2, 0x33)
#define REG_SC_BKB2_34_L      _PK_L_(0xB2, 0x34)
#define REG_SC_BKB2_34_H      _PK_H_(0xB2, 0x34)
#define REG_SC_BKB2_35_L      _PK_L_(0xB2, 0x35)
#define REG_SC_BKB2_35_H      _PK_H_(0xB2, 0x35)
#define REG_SC_BKB2_36_L      _PK_L_(0xB2, 0x36)
#define REG_SC_BKB2_36_H      _PK_H_(0xB2, 0x36)
#define REG_SC_BKB2_37_L      _PK_L_(0xB2, 0x37)
#define REG_SC_BKB2_37_H      _PK_H_(0xB2, 0x37)
#define REG_SC_BKB2_38_L      _PK_L_(0xB2, 0x38)
#define REG_SC_BKB2_38_H      _PK_H_(0xB2, 0x38)
#define REG_SC_BKB2_39_L      _PK_L_(0xB2, 0x39)
#define REG_SC_BKB2_39_H      _PK_H_(0xB2, 0x39)
#define REG_SC_BKB2_3A_L      _PK_L_(0xB2, 0x3A)
#define REG_SC_BKB2_3A_H      _PK_H_(0xB2, 0x3A)
#define REG_SC_BKB2_3B_L      _PK_L_(0xB2, 0x3B)
#define REG_SC_BKB2_3B_H      _PK_H_(0xB2, 0x3B)
#define REG_SC_BKB2_3C_L      _PK_L_(0xB2, 0x3C)
#define REG_SC_BKB2_3C_H      _PK_H_(0xB2, 0x3C)
#define REG_SC_BKB2_3D_L      _PK_L_(0xB2, 0x3D)
#define REG_SC_BKB2_3D_H      _PK_H_(0xB2, 0x3D)
#define REG_SC_BKB2_3E_L      _PK_L_(0xB2, 0x3E)
#define REG_SC_BKB2_3E_H      _PK_H_(0xB2, 0x3E)
#define REG_SC_BKB2_3F_L      _PK_L_(0xB2, 0x3F)
#define REG_SC_BKB2_3F_H      _PK_H_(0xB2, 0x3F)
#define REG_SC_BKB2_40_L      _PK_L_(0xB2, 0x40)
#define REG_SC_BKB2_40_H      _PK_H_(0xB2, 0x40)
#define REG_SC_BKB2_41_L      _PK_L_(0xB2, 0x41)
#define REG_SC_BKB2_41_H      _PK_H_(0xB2, 0x41)
#define REG_SC_BKB2_42_L      _PK_L_(0xB2, 0x42)
#define REG_SC_BKB2_42_H      _PK_H_(0xB2, 0x42)
#define REG_SC_BKB2_43_L      _PK_L_(0xB2, 0x43)
#define REG_SC_BKB2_43_H      _PK_H_(0xB2, 0x43)
#define REG_SC_BKB2_44_L      _PK_L_(0xB2, 0x44)
#define REG_SC_BKB2_44_H      _PK_H_(0xB2, 0x44)
#define REG_SC_BKB2_45_L      _PK_L_(0xB2, 0x45)
#define REG_SC_BKB2_45_H      _PK_H_(0xB2, 0x45)
#define REG_SC_BKB2_46_L      _PK_L_(0xB2, 0x46)
#define REG_SC_BKB2_46_H      _PK_H_(0xB2, 0x46)
#define REG_SC_BKB2_47_L      _PK_L_(0xB2, 0x47)
#define REG_SC_BKB2_47_H      _PK_H_(0xB2, 0x47)
#define REG_SC_BKB2_48_L      _PK_L_(0xB2, 0x48)
#define REG_SC_BKB2_48_H      _PK_H_(0xB2, 0x48)
#define REG_SC_BKB2_49_L      _PK_L_(0xB2, 0x49)
#define REG_SC_BKB2_49_H      _PK_H_(0xB2, 0x49)
#define REG_SC_BKB2_4A_L      _PK_L_(0xB2, 0x4A)
#define REG_SC_BKB2_4A_H      _PK_H_(0xB2, 0x4A)
#define REG_SC_BKB2_4B_L      _PK_L_(0xB2, 0x4B)
#define REG_SC_BKB2_4B_H      _PK_H_(0xB2, 0x4B)
#define REG_SC_BKB2_4C_L      _PK_L_(0xB2, 0x4C)
#define REG_SC_BKB2_4C_H      _PK_H_(0xB2, 0x4C)
#define REG_SC_BKB2_4D_L      _PK_L_(0xB2, 0x4D)
#define REG_SC_BKB2_4D_H      _PK_H_(0xB2, 0x4D)
#define REG_SC_BKB2_4E_L      _PK_L_(0xB2, 0x4E)
#define REG_SC_BKB2_4E_H      _PK_H_(0xB2, 0x4E)
#define REG_SC_BKB2_4F_L      _PK_L_(0xB2, 0x4F)
#define REG_SC_BKB2_4F_H      _PK_H_(0xB2, 0x4F)
#define REG_SC_BKB2_50_L      _PK_L_(0xB2, 0x50)
#define REG_SC_BKB2_50_H      _PK_H_(0xB2, 0x50)
#define REG_SC_BKB2_51_L      _PK_L_(0xB2, 0x51)
#define REG_SC_BKB2_51_H      _PK_H_(0xB2, 0x51)
#define REG_SC_BKB2_52_L      _PK_L_(0xB2, 0x52)
#define REG_SC_BKB2_52_H      _PK_H_(0xB2, 0x52)
#define REG_SC_BKB2_53_L      _PK_L_(0xB2, 0x53)
#define REG_SC_BKB2_53_H      _PK_H_(0xB2, 0x53)
#define REG_SC_BKB2_54_L      _PK_L_(0xB2, 0x54)
#define REG_SC_BKB2_54_H      _PK_H_(0xB2, 0x54)
#define REG_SC_BKB2_55_L      _PK_L_(0xB2, 0x55)
#define REG_SC_BKB2_55_H      _PK_H_(0xB2, 0x55)
#define REG_SC_BKB2_56_L      _PK_L_(0xB2, 0x56)
#define REG_SC_BKB2_56_H      _PK_H_(0xB2, 0x56)
#define REG_SC_BKB2_57_L      _PK_L_(0xB2, 0x57)
#define REG_SC_BKB2_57_H      _PK_H_(0xB2, 0x57)
#define REG_SC_BKB2_58_L      _PK_L_(0xB2, 0x58)
#define REG_SC_BKB2_58_H      _PK_H_(0xB2, 0x58)
#define REG_SC_BKB2_59_L      _PK_L_(0xB2, 0x59)
#define REG_SC_BKB2_59_H      _PK_H_(0xB2, 0x59)
#define REG_SC_BKB2_5A_L      _PK_L_(0xB2, 0x5A)
#define REG_SC_BKB2_5A_H      _PK_H_(0xB2, 0x5A)
#define REG_SC_BKB2_5B_L      _PK_L_(0xB2, 0x5B)
#define REG_SC_BKB2_5B_H      _PK_H_(0xB2, 0x5B)
#define REG_SC_BKB2_5C_L      _PK_L_(0xB2, 0x5C)
#define REG_SC_BKB2_5C_H      _PK_H_(0xB2, 0x5C)
#define REG_SC_BKB2_5D_L      _PK_L_(0xB2, 0x5D)
#define REG_SC_BKB2_5D_H      _PK_H_(0xB2, 0x5D)
#define REG_SC_BKB2_5E_L      _PK_L_(0xB2, 0x5E)
#define REG_SC_BKB2_5E_H      _PK_H_(0xB2, 0x5E)
#define REG_SC_BKB2_5F_L      _PK_L_(0xB2, 0x5F)
#define REG_SC_BKB2_5F_H      _PK_H_(0xB2, 0x5F)
#define REG_SC_BKB2_60_L      _PK_L_(0xB2, 0x60)
#define REG_SC_BKB2_60_H      _PK_H_(0xB2, 0x60)
#define REG_SC_BKB2_61_L      _PK_L_(0xB2, 0x61)
#define REG_SC_BKB2_61_H      _PK_H_(0xB2, 0x61)
#define REG_SC_BKB2_62_L      _PK_L_(0xB2, 0x62)
#define REG_SC_BKB2_62_H      _PK_H_(0xB2, 0x62)
#define REG_SC_BKB2_63_L      _PK_L_(0xB2, 0x63)
#define REG_SC_BKB2_63_H      _PK_H_(0xB2, 0x63)
#define REG_SC_BKB2_64_L      _PK_L_(0xB2, 0x64)
#define REG_SC_BKB2_64_H      _PK_H_(0xB2, 0x64)
#define REG_SC_BKB2_65_L      _PK_L_(0xB2, 0x65)
#define REG_SC_BKB2_65_H      _PK_H_(0xB2, 0x65)
#define REG_SC_BKB2_66_L      _PK_L_(0xB2, 0x66)
#define REG_SC_BKB2_66_H      _PK_H_(0xB2, 0x66)
#define REG_SC_BKB2_67_L      _PK_L_(0xB2, 0x67)
#define REG_SC_BKB2_67_H      _PK_H_(0xB2, 0x67)
#define REG_SC_BKB2_68_L      _PK_L_(0xB2, 0x68)
#define REG_SC_BKB2_68_H      _PK_H_(0xB2, 0x68)
#define REG_SC_BKB2_69_L      _PK_L_(0xB2, 0x69)
#define REG_SC_BKB2_69_H      _PK_H_(0xB2, 0x69)
#define REG_SC_BKB2_6A_L      _PK_L_(0xB2, 0x6A)
#define REG_SC_BKB2_6A_H      _PK_H_(0xB2, 0x6A)
#define REG_SC_BKB2_6B_L      _PK_L_(0xB2, 0x6B)
#define REG_SC_BKB2_6B_H      _PK_H_(0xB2, 0x6B)
#define REG_SC_BKB2_6C_L      _PK_L_(0xB2, 0x6C)
#define REG_SC_BKB2_6C_H      _PK_H_(0xB2, 0x6C)
#define REG_SC_BKB2_6D_L      _PK_L_(0xB2, 0x6D)
#define REG_SC_BKB2_6D_H      _PK_H_(0xB2, 0x6D)
#define REG_SC_BKB2_6E_L      _PK_L_(0xB2, 0x6E)
#define REG_SC_BKB2_6E_H      _PK_H_(0xB2, 0x6E)
#define REG_SC_BKB2_6F_L      _PK_L_(0xB2, 0x6F)
#define REG_SC_BKB2_6F_H      _PK_H_(0xB2, 0x6F)
#define REG_SC_BKB2_70_L      _PK_L_(0xB2, 0x70)
#define REG_SC_BKB2_70_H      _PK_H_(0xB2, 0x70)
#define REG_SC_BKB2_71_L      _PK_L_(0xB2, 0x71)
#define REG_SC_BKB2_71_H      _PK_H_(0xB2, 0x71)
#define REG_SC_BKB2_72_L      _PK_L_(0xB2, 0x72)
#define REG_SC_BKB2_72_H      _PK_H_(0xB2, 0x72)
#define REG_SC_BKB2_73_L      _PK_L_(0xB2, 0x73)
#define REG_SC_BKB2_73_H      _PK_H_(0xB2, 0x73)
#define REG_SC_BKB2_74_L      _PK_L_(0xB2, 0x74)
#define REG_SC_BKB2_74_H      _PK_H_(0xB2, 0x74)
#define REG_SC_BKB2_75_L      _PK_L_(0xB2, 0x75)
#define REG_SC_BKB2_75_H      _PK_H_(0xB2, 0x75)
#define REG_SC_BKB2_76_L      _PK_L_(0xB2, 0x76)
#define REG_SC_BKB2_76_H      _PK_H_(0xB2, 0x76)
#define REG_SC_BKB2_77_L      _PK_L_(0xB2, 0x77)
#define REG_SC_BKB2_77_H      _PK_H_(0xB2, 0x77)
#define REG_SC_BKB2_78_L      _PK_L_(0xB2, 0x78)
#define REG_SC_BKB2_78_H      _PK_H_(0xB2, 0x78)
#define REG_SC_BKB2_79_L      _PK_L_(0xB2, 0x79)
#define REG_SC_BKB2_79_H      _PK_H_(0xB2, 0x79)
#define REG_SC_BKB2_7A_L      _PK_L_(0xB2, 0x7A)
#define REG_SC_BKB2_7A_H      _PK_H_(0xB2, 0x7A)
#define REG_SC_BKB2_7B_L      _PK_L_(0xB2, 0x7B)
#define REG_SC_BKB2_7B_H      _PK_H_(0xB2, 0x7B)
#define REG_SC_BKB2_7C_L      _PK_L_(0xB2, 0x7C)
#define REG_SC_BKB2_7C_H      _PK_H_(0xB2, 0x7C)
#define REG_SC_BKB2_7D_L      _PK_L_(0xB2, 0x7D)
#define REG_SC_BKB2_7D_H      _PK_H_(0xB2, 0x7D)
#define REG_SC_BKB2_7E_L      _PK_L_(0xB2, 0x7E)
#define REG_SC_BKB2_7E_H      _PK_H_(0xB2, 0x7E)
#define REG_SC_BKB2_7F_L      _PK_L_(0xB2, 0x7F)
#define REG_SC_BKB2_7F_H      _PK_H_(0xB2, 0x7F)
//----------------------------------------------
#define REG_SC_BKB3_00_L      _PK_L_(0xB3, 0x00)
#define REG_SC_BKB3_00_H      _PK_H_(0xB3, 0x00)
#define REG_SC_BKB3_01_L      _PK_L_(0xB3, 0x01)
#define REG_SC_BKB3_01_H      _PK_H_(0xB3, 0x01)
#define REG_SC_BKB3_02_L      _PK_L_(0xB3, 0x02)
#define REG_SC_BKB3_02_H      _PK_H_(0xB3, 0x02)
#define REG_SC_BKB3_03_L      _PK_L_(0xB3, 0x03)
#define REG_SC_BKB3_03_H      _PK_H_(0xB3, 0x03)
#define REG_SC_BKB3_04_L      _PK_L_(0xB3, 0x04)
#define REG_SC_BKB3_04_H      _PK_H_(0xB3, 0x04)
#define REG_SC_BKB3_05_L      _PK_L_(0xB3, 0x05)
#define REG_SC_BKB3_05_H      _PK_H_(0xB3, 0x05)
#define REG_SC_BKB3_06_L      _PK_L_(0xB3, 0x06)
#define REG_SC_BKB3_06_H      _PK_H_(0xB3, 0x06)
#define REG_SC_BKB3_07_L      _PK_L_(0xB3, 0x07)
#define REG_SC_BKB3_07_H      _PK_H_(0xB3, 0x07)
#define REG_SC_BKB3_08_L      _PK_L_(0xB3, 0x08)
#define REG_SC_BKB3_08_H      _PK_H_(0xB3, 0x08)
#define REG_SC_BKB3_09_L      _PK_L_(0xB3, 0x09)
#define REG_SC_BKB3_09_H      _PK_H_(0xB3, 0x09)
#define REG_SC_BKB3_0A_L      _PK_L_(0xB3, 0x0A)
#define REG_SC_BKB3_0A_H      _PK_H_(0xB3, 0x0A)
#define REG_SC_BKB3_0B_L      _PK_L_(0xB3, 0x0B)
#define REG_SC_BKB3_0B_H      _PK_H_(0xB3, 0x0B)
#define REG_SC_BKB3_0C_L      _PK_L_(0xB3, 0x0C)
#define REG_SC_BKB3_0C_H      _PK_H_(0xB3, 0x0C)
#define REG_SC_BKB3_0D_L      _PK_L_(0xB3, 0x0D)
#define REG_SC_BKB3_0D_H      _PK_H_(0xB3, 0x0D)
#define REG_SC_BKB3_0E_L      _PK_L_(0xB3, 0x0E)
#define REG_SC_BKB3_0E_H      _PK_H_(0xB3, 0x0E)
#define REG_SC_BKB3_0F_L      _PK_L_(0xB3, 0x0F)
#define REG_SC_BKB3_0F_H      _PK_H_(0xB3, 0x0F)
#define REG_SC_BKB3_10_L      _PK_L_(0xB3, 0x10)
#define REG_SC_BKB3_10_H      _PK_H_(0xB3, 0x10)
#define REG_SC_BKB3_11_L      _PK_L_(0xB3, 0x11)
#define REG_SC_BKB3_11_H      _PK_H_(0xB3, 0x11)
#define REG_SC_BKB3_12_L      _PK_L_(0xB3, 0x12)
#define REG_SC_BKB3_12_H      _PK_H_(0xB3, 0x12)
#define REG_SC_BKB3_13_L      _PK_L_(0xB3, 0x13)
#define REG_SC_BKB3_13_H      _PK_H_(0xB3, 0x13)
#define REG_SC_BKB3_14_L      _PK_L_(0xB3, 0x14)
#define REG_SC_BKB3_14_H      _PK_H_(0xB3, 0x14)
#define REG_SC_BKB3_15_L      _PK_L_(0xB3, 0x15)
#define REG_SC_BKB3_15_H      _PK_H_(0xB3, 0x15)
#define REG_SC_BKB3_16_L      _PK_L_(0xB3, 0x16)
#define REG_SC_BKB3_16_H      _PK_H_(0xB3, 0x16)
#define REG_SC_BKB3_17_L      _PK_L_(0xB3, 0x17)
#define REG_SC_BKB3_17_H      _PK_H_(0xB3, 0x17)
#define REG_SC_BKB3_18_L      _PK_L_(0xB3, 0x18)
#define REG_SC_BKB3_18_H      _PK_H_(0xB3, 0x18)
#define REG_SC_BKB3_19_L      _PK_L_(0xB3, 0x19)
#define REG_SC_BKB3_19_H      _PK_H_(0xB3, 0x19)
#define REG_SC_BKB3_1A_L      _PK_L_(0xB3, 0x1A)
#define REG_SC_BKB3_1A_H      _PK_H_(0xB3, 0x1A)
#define REG_SC_BKB3_1B_L      _PK_L_(0xB3, 0x1B)
#define REG_SC_BKB3_1B_H      _PK_H_(0xB3, 0x1B)
#define REG_SC_BKB3_1C_L      _PK_L_(0xB3, 0x1C)
#define REG_SC_BKB3_1C_H      _PK_H_(0xB3, 0x1C)
#define REG_SC_BKB3_1D_L      _PK_L_(0xB3, 0x1D)
#define REG_SC_BKB3_1D_H      _PK_H_(0xB3, 0x1D)
#define REG_SC_BKB3_1E_L      _PK_L_(0xB3, 0x1E)
#define REG_SC_BKB3_1E_H      _PK_H_(0xB3, 0x1E)
#define REG_SC_BKB3_1F_L      _PK_L_(0xB3, 0x1F)
#define REG_SC_BKB3_1F_H      _PK_H_(0xB3, 0x1F)
#define REG_SC_BKB3_20_L      _PK_L_(0xB3, 0x20)
#define REG_SC_BKB3_20_H      _PK_H_(0xB3, 0x20)
#define REG_SC_BKB3_21_L      _PK_L_(0xB3, 0x21)
#define REG_SC_BKB3_21_H      _PK_H_(0xB3, 0x21)
#define REG_SC_BKB3_22_L      _PK_L_(0xB3, 0x22)
#define REG_SC_BKB3_22_H      _PK_H_(0xB3, 0x22)
#define REG_SC_BKB3_23_L      _PK_L_(0xB3, 0x23)
#define REG_SC_BKB3_23_H      _PK_H_(0xB3, 0x23)
#define REG_SC_BKB3_24_L      _PK_L_(0xB3, 0x24)
#define REG_SC_BKB3_24_H      _PK_H_(0xB3, 0x24)
#define REG_SC_BKB3_25_L      _PK_L_(0xB3, 0x25)
#define REG_SC_BKB3_25_H      _PK_H_(0xB3, 0x25)
#define REG_SC_BKB3_26_L      _PK_L_(0xB3, 0x26)
#define REG_SC_BKB3_26_H      _PK_H_(0xB3, 0x26)
#define REG_SC_BKB3_27_L      _PK_L_(0xB3, 0x27)
#define REG_SC_BKB3_27_H      _PK_H_(0xB3, 0x27)
#define REG_SC_BKB3_28_L      _PK_L_(0xB3, 0x28)
#define REG_SC_BKB3_28_H      _PK_H_(0xB3, 0x28)
#define REG_SC_BKB3_29_L      _PK_L_(0xB3, 0x29)
#define REG_SC_BKB3_29_H      _PK_H_(0xB3, 0x29)
#define REG_SC_BKB3_2A_L      _PK_L_(0xB3, 0x2A)
#define REG_SC_BKB3_2A_H      _PK_H_(0xB3, 0x2A)
#define REG_SC_BKB3_2B_L      _PK_L_(0xB3, 0x2B)
#define REG_SC_BKB3_2B_H      _PK_H_(0xB3, 0x2B)
#define REG_SC_BKB3_2C_L      _PK_L_(0xB3, 0x2C)
#define REG_SC_BKB3_2C_H      _PK_H_(0xB3, 0x2C)
#define REG_SC_BKB3_2D_L      _PK_L_(0xB3, 0x2D)
#define REG_SC_BKB3_2D_H      _PK_H_(0xB3, 0x2D)
#define REG_SC_BKB3_2E_L      _PK_L_(0xB3, 0x2E)
#define REG_SC_BKB3_2E_H      _PK_H_(0xB3, 0x2E)
#define REG_SC_BKB3_2F_L      _PK_L_(0xB3, 0x2F)
#define REG_SC_BKB3_2F_H      _PK_H_(0xB3, 0x2F)
#define REG_SC_BKB3_30_L      _PK_L_(0xB3, 0x30)
#define REG_SC_BKB3_30_H      _PK_H_(0xB3, 0x30)
#define REG_SC_BKB3_31_L      _PK_L_(0xB3, 0x31)
#define REG_SC_BKB3_31_H      _PK_H_(0xB3, 0x31)
#define REG_SC_BKB3_32_L      _PK_L_(0xB3, 0x32)
#define REG_SC_BKB3_32_H      _PK_H_(0xB3, 0x32)
#define REG_SC_BKB3_33_L      _PK_L_(0xB3, 0x33)
#define REG_SC_BKB3_33_H      _PK_H_(0xB3, 0x33)
#define REG_SC_BKB3_34_L      _PK_L_(0xB3, 0x34)
#define REG_SC_BKB3_34_H      _PK_H_(0xB3, 0x34)
#define REG_SC_BKB3_35_L      _PK_L_(0xB3, 0x35)
#define REG_SC_BKB3_35_H      _PK_H_(0xB3, 0x35)
#define REG_SC_BKB3_36_L      _PK_L_(0xB3, 0x36)
#define REG_SC_BKB3_36_H      _PK_H_(0xB3, 0x36)
#define REG_SC_BKB3_37_L      _PK_L_(0xB3, 0x37)
#define REG_SC_BKB3_37_H      _PK_H_(0xB3, 0x37)
#define REG_SC_BKB3_38_L      _PK_L_(0xB3, 0x38)
#define REG_SC_BKB3_38_H      _PK_H_(0xB3, 0x38)
#define REG_SC_BKB3_39_L      _PK_L_(0xB3, 0x39)
#define REG_SC_BKB3_39_H      _PK_H_(0xB3, 0x39)
#define REG_SC_BKB3_3A_L      _PK_L_(0xB3, 0x3A)
#define REG_SC_BKB3_3A_H      _PK_H_(0xB3, 0x3A)
#define REG_SC_BKB3_3B_L      _PK_L_(0xB3, 0x3B)
#define REG_SC_BKB3_3B_H      _PK_H_(0xB3, 0x3B)
#define REG_SC_BKB3_3C_L      _PK_L_(0xB3, 0x3C)
#define REG_SC_BKB3_3C_H      _PK_H_(0xB3, 0x3C)
#define REG_SC_BKB3_3D_L      _PK_L_(0xB3, 0x3D)
#define REG_SC_BKB3_3D_H      _PK_H_(0xB3, 0x3D)
#define REG_SC_BKB3_3E_L      _PK_L_(0xB3, 0x3E)
#define REG_SC_BKB3_3E_H      _PK_H_(0xB3, 0x3E)
#define REG_SC_BKB3_3F_L      _PK_L_(0xB3, 0x3F)
#define REG_SC_BKB3_3F_H      _PK_H_(0xB3, 0x3F)
#define REG_SC_BKB3_40_L      _PK_L_(0xB3, 0x40)
#define REG_SC_BKB3_40_H      _PK_H_(0xB3, 0x40)
#define REG_SC_BKB3_41_L      _PK_L_(0xB3, 0x41)
#define REG_SC_BKB3_41_H      _PK_H_(0xB3, 0x41)
#define REG_SC_BKB3_42_L      _PK_L_(0xB3, 0x42)
#define REG_SC_BKB3_42_H      _PK_H_(0xB3, 0x42)
#define REG_SC_BKB3_43_L      _PK_L_(0xB3, 0x43)
#define REG_SC_BKB3_43_H      _PK_H_(0xB3, 0x43)
#define REG_SC_BKB3_44_L      _PK_L_(0xB3, 0x44)
#define REG_SC_BKB3_44_H      _PK_H_(0xB3, 0x44)
#define REG_SC_BKB3_45_L      _PK_L_(0xB3, 0x45)
#define REG_SC_BKB3_45_H      _PK_H_(0xB3, 0x45)
#define REG_SC_BKB3_46_L      _PK_L_(0xB3, 0x46)
#define REG_SC_BKB3_46_H      _PK_H_(0xB3, 0x46)
#define REG_SC_BKB3_47_L      _PK_L_(0xB3, 0x47)
#define REG_SC_BKB3_47_H      _PK_H_(0xB3, 0x47)
#define REG_SC_BKB3_48_L      _PK_L_(0xB3, 0x48)
#define REG_SC_BKB3_48_H      _PK_H_(0xB3, 0x48)
#define REG_SC_BKB3_49_L      _PK_L_(0xB3, 0x49)
#define REG_SC_BKB3_49_H      _PK_H_(0xB3, 0x49)
#define REG_SC_BKB3_4A_L      _PK_L_(0xB3, 0x4A)
#define REG_SC_BKB3_4A_H      _PK_H_(0xB3, 0x4A)
#define REG_SC_BKB3_4B_L      _PK_L_(0xB3, 0x4B)
#define REG_SC_BKB3_4B_H      _PK_H_(0xB3, 0x4B)
#define REG_SC_BKB3_4C_L      _PK_L_(0xB3, 0x4C)
#define REG_SC_BKB3_4C_H      _PK_H_(0xB3, 0x4C)
#define REG_SC_BKB3_4D_L      _PK_L_(0xB3, 0x4D)
#define REG_SC_BKB3_4D_H      _PK_H_(0xB3, 0x4D)
#define REG_SC_BKB3_4E_L      _PK_L_(0xB3, 0x4E)
#define REG_SC_BKB3_4E_H      _PK_H_(0xB3, 0x4E)
#define REG_SC_BKB3_4F_L      _PK_L_(0xB3, 0x4F)
#define REG_SC_BKB3_4F_H      _PK_H_(0xB3, 0x4F)
#define REG_SC_BKB3_50_L      _PK_L_(0xB3, 0x50)
#define REG_SC_BKB3_50_H      _PK_H_(0xB3, 0x50)
#define REG_SC_BKB3_51_L      _PK_L_(0xB3, 0x51)
#define REG_SC_BKB3_51_H      _PK_H_(0xB3, 0x51)
#define REG_SC_BKB3_52_L      _PK_L_(0xB3, 0x52)
#define REG_SC_BKB3_52_H      _PK_H_(0xB3, 0x52)
#define REG_SC_BKB3_53_L      _PK_L_(0xB3, 0x53)
#define REG_SC_BKB3_53_H      _PK_H_(0xB3, 0x53)
#define REG_SC_BKB3_54_L      _PK_L_(0xB3, 0x54)
#define REG_SC_BKB3_54_H      _PK_H_(0xB3, 0x54)
#define REG_SC_BKB3_55_L      _PK_L_(0xB3, 0x55)
#define REG_SC_BKB3_55_H      _PK_H_(0xB3, 0x55)
#define REG_SC_BKB3_56_L      _PK_L_(0xB3, 0x56)
#define REG_SC_BKB3_56_H      _PK_H_(0xB3, 0x56)
#define REG_SC_BKB3_57_L      _PK_L_(0xB3, 0x57)
#define REG_SC_BKB3_57_H      _PK_H_(0xB3, 0x57)
#define REG_SC_BKB3_58_L      _PK_L_(0xB3, 0x58)
#define REG_SC_BKB3_58_H      _PK_H_(0xB3, 0x58)
#define REG_SC_BKB3_59_L      _PK_L_(0xB3, 0x59)
#define REG_SC_BKB3_59_H      _PK_H_(0xB3, 0x59)
#define REG_SC_BKB3_5A_L      _PK_L_(0xB3, 0x5A)
#define REG_SC_BKB3_5A_H      _PK_H_(0xB3, 0x5A)
#define REG_SC_BKB3_5B_L      _PK_L_(0xB3, 0x5B)
#define REG_SC_BKB3_5B_H      _PK_H_(0xB3, 0x5B)
#define REG_SC_BKB3_5C_L      _PK_L_(0xB3, 0x5C)
#define REG_SC_BKB3_5C_H      _PK_H_(0xB3, 0x5C)
#define REG_SC_BKB3_5D_L      _PK_L_(0xB3, 0x5D)
#define REG_SC_BKB3_5D_H      _PK_H_(0xB3, 0x5D)
#define REG_SC_BKB3_5E_L      _PK_L_(0xB3, 0x5E)
#define REG_SC_BKB3_5E_H      _PK_H_(0xB3, 0x5E)
#define REG_SC_BKB3_5F_L      _PK_L_(0xB3, 0x5F)
#define REG_SC_BKB3_5F_H      _PK_H_(0xB3, 0x5F)
#define REG_SC_BKB3_60_L      _PK_L_(0xB3, 0x60)
#define REG_SC_BKB3_60_H      _PK_H_(0xB3, 0x60)
#define REG_SC_BKB3_61_L      _PK_L_(0xB3, 0x61)
#define REG_SC_BKB3_61_H      _PK_H_(0xB3, 0x61)
#define REG_SC_BKB3_62_L      _PK_L_(0xB3, 0x62)
#define REG_SC_BKB3_62_H      _PK_H_(0xB3, 0x62)
#define REG_SC_BKB3_63_L      _PK_L_(0xB3, 0x63)
#define REG_SC_BKB3_63_H      _PK_H_(0xB3, 0x63)
#define REG_SC_BKB3_64_L      _PK_L_(0xB3, 0x64)
#define REG_SC_BKB3_64_H      _PK_H_(0xB3, 0x64)
#define REG_SC_BKB3_65_L      _PK_L_(0xB3, 0x65)
#define REG_SC_BKB3_65_H      _PK_H_(0xB3, 0x65)
#define REG_SC_BKB3_66_L      _PK_L_(0xB3, 0x66)
#define REG_SC_BKB3_66_H      _PK_H_(0xB3, 0x66)
#define REG_SC_BKB3_67_L      _PK_L_(0xB3, 0x67)
#define REG_SC_BKB3_67_H      _PK_H_(0xB3, 0x67)
#define REG_SC_BKB3_68_L      _PK_L_(0xB3, 0x68)
#define REG_SC_BKB3_68_H      _PK_H_(0xB3, 0x68)
#define REG_SC_BKB3_69_L      _PK_L_(0xB3, 0x69)
#define REG_SC_BKB3_69_H      _PK_H_(0xB3, 0x69)
#define REG_SC_BKB3_6A_L      _PK_L_(0xB3, 0x6A)
#define REG_SC_BKB3_6A_H      _PK_H_(0xB3, 0x6A)
#define REG_SC_BKB3_6B_L      _PK_L_(0xB3, 0x6B)
#define REG_SC_BKB3_6B_H      _PK_H_(0xB3, 0x6B)
#define REG_SC_BKB3_6C_L      _PK_L_(0xB3, 0x6C)
#define REG_SC_BKB3_6C_H      _PK_H_(0xB3, 0x6C)
#define REG_SC_BKB3_6D_L      _PK_L_(0xB3, 0x6D)
#define REG_SC_BKB3_6D_H      _PK_H_(0xB3, 0x6D)
#define REG_SC_BKB3_6E_L      _PK_L_(0xB3, 0x6E)
#define REG_SC_BKB3_6E_H      _PK_H_(0xB3, 0x6E)
#define REG_SC_BKB3_6F_L      _PK_L_(0xB3, 0x6F)
#define REG_SC_BKB3_6F_H      _PK_H_(0xB3, 0x6F)
#define REG_SC_BKB3_70_L      _PK_L_(0xB3, 0x70)
#define REG_SC_BKB3_70_H      _PK_H_(0xB3, 0x70)
#define REG_SC_BKB3_71_L      _PK_L_(0xB3, 0x71)
#define REG_SC_BKB3_71_H      _PK_H_(0xB3, 0x71)
#define REG_SC_BKB3_72_L      _PK_L_(0xB3, 0x72)
#define REG_SC_BKB3_72_H      _PK_H_(0xB3, 0x72)
#define REG_SC_BKB3_73_L      _PK_L_(0xB3, 0x73)
#define REG_SC_BKB3_73_H      _PK_H_(0xB3, 0x73)
#define REG_SC_BKB3_74_L      _PK_L_(0xB3, 0x74)
#define REG_SC_BKB3_74_H      _PK_H_(0xB3, 0x74)
#define REG_SC_BKB3_75_L      _PK_L_(0xB3, 0x75)
#define REG_SC_BKB3_75_H      _PK_H_(0xB3, 0x75)
#define REG_SC_BKB3_76_L      _PK_L_(0xB3, 0x76)
#define REG_SC_BKB3_76_H      _PK_H_(0xB3, 0x76)
#define REG_SC_BKB3_77_L      _PK_L_(0xB3, 0x77)
#define REG_SC_BKB3_77_H      _PK_H_(0xB3, 0x77)
#define REG_SC_BKB3_78_L      _PK_L_(0xB3, 0x78)
#define REG_SC_BKB3_78_H      _PK_H_(0xB3, 0x78)
#define REG_SC_BKB3_79_L      _PK_L_(0xB3, 0x79)
#define REG_SC_BKB3_79_H      _PK_H_(0xB3, 0x79)
#define REG_SC_BKB3_7A_L      _PK_L_(0xB3, 0x7A)
#define REG_SC_BKB3_7A_H      _PK_H_(0xB3, 0x7A)
#define REG_SC_BKB3_7B_L      _PK_L_(0xB3, 0x7B)
#define REG_SC_BKB3_7B_H      _PK_H_(0xB3, 0x7B)
#define REG_SC_BKB3_7C_L      _PK_L_(0xB3, 0x7C)
#define REG_SC_BKB3_7C_H      _PK_H_(0xB3, 0x7C)
#define REG_SC_BKB3_7D_L      _PK_L_(0xB3, 0x7D)
#define REG_SC_BKB3_7D_H      _PK_H_(0xB3, 0x7D)
#define REG_SC_BKB3_7E_L      _PK_L_(0xB3, 0x7E)
#define REG_SC_BKB3_7E_H      _PK_H_(0xB3, 0x7E)
#define REG_SC_BKB3_7F_L      _PK_L_(0xB3, 0x7F)
#define REG_SC_BKB3_7F_H      _PK_H_(0xB3, 0x7F)
//----------------------------------------------
#define REG_SC_BKB8_00_L      _PK_L_(0xB8, 0x00)
#define REG_SC_BKB8_00_H      _PK_H_(0xB8, 0x00)
#define REG_SC_BKB8_01_L      _PK_L_(0xB8, 0x01)
#define REG_SC_BKB8_01_H      _PK_H_(0xB8, 0x01)
#define REG_SC_BKB8_02_L      _PK_L_(0xB8, 0x02)
#define REG_SC_BKB8_02_H      _PK_H_(0xB8, 0x02)
#define REG_SC_BKB8_03_L      _PK_L_(0xB8, 0x03)
#define REG_SC_BKB8_03_H      _PK_H_(0xB8, 0x03)
#define REG_SC_BKB8_04_L      _PK_L_(0xB8, 0x04)
#define REG_SC_BKB8_04_H      _PK_H_(0xB8, 0x04)
#define REG_SC_BKB8_05_L      _PK_L_(0xB8, 0x05)
#define REG_SC_BKB8_05_H      _PK_H_(0xB8, 0x05)
#define REG_SC_BKB8_06_L      _PK_L_(0xB8, 0x06)
#define REG_SC_BKB8_06_H      _PK_H_(0xB8, 0x06)
#define REG_SC_BKB8_07_L      _PK_L_(0xB8, 0x07)
#define REG_SC_BKB8_07_H      _PK_H_(0xB8, 0x07)
#define REG_SC_BKB8_08_L      _PK_L_(0xB8, 0x08)
#define REG_SC_BKB8_08_H      _PK_H_(0xB8, 0x08)
#define REG_SC_BKB8_09_L      _PK_L_(0xB8, 0x09)
#define REG_SC_BKB8_09_H      _PK_H_(0xB8, 0x09)
#define REG_SC_BKB8_0A_L      _PK_L_(0xB8, 0x0A)
#define REG_SC_BKB8_0A_H      _PK_H_(0xB8, 0x0A)
#define REG_SC_BKB8_0B_L      _PK_L_(0xB8, 0x0B)
#define REG_SC_BKB8_0B_H      _PK_H_(0xB8, 0x0B)
#define REG_SC_BKB8_0C_L      _PK_L_(0xB8, 0x0C)
#define REG_SC_BKB8_0C_H      _PK_H_(0xB8, 0x0C)
#define REG_SC_BKB8_0D_L      _PK_L_(0xB8, 0x0D)
#define REG_SC_BKB8_0D_H      _PK_H_(0xB8, 0x0D)
#define REG_SC_BKB8_0E_L      _PK_L_(0xB8, 0x0E)
#define REG_SC_BKB8_0E_H      _PK_H_(0xB8, 0x0E)
#define REG_SC_BKB8_0F_L      _PK_L_(0xB8, 0x0F)
#define REG_SC_BKB8_0F_H      _PK_H_(0xB8, 0x0F)
#define REG_SC_BKB8_10_L      _PK_L_(0xB8, 0x10)
#define REG_SC_BKB8_10_H      _PK_H_(0xB8, 0x10)
#define REG_SC_BKB8_11_L      _PK_L_(0xB8, 0x11)
#define REG_SC_BKB8_11_H      _PK_H_(0xB8, 0x11)
#define REG_SC_BKB8_12_L      _PK_L_(0xB8, 0x12)
#define REG_SC_BKB8_12_H      _PK_H_(0xB8, 0x12)
#define REG_SC_BKB8_13_L      _PK_L_(0xB8, 0x13)
#define REG_SC_BKB8_13_H      _PK_H_(0xB8, 0x13)
#define REG_SC_BKB8_14_L      _PK_L_(0xB8, 0x14)
#define REG_SC_BKB8_14_H      _PK_H_(0xB8, 0x14)
#define REG_SC_BKB8_15_L      _PK_L_(0xB8, 0x15)
#define REG_SC_BKB8_15_H      _PK_H_(0xB8, 0x15)
#define REG_SC_BKB8_16_L      _PK_L_(0xB8, 0x16)
#define REG_SC_BKB8_16_H      _PK_H_(0xB8, 0x16)
#define REG_SC_BKB8_17_L      _PK_L_(0xB8, 0x17)
#define REG_SC_BKB8_17_H      _PK_H_(0xB8, 0x17)
#define REG_SC_BKB8_18_L      _PK_L_(0xB8, 0x18)
#define REG_SC_BKB8_18_H      _PK_H_(0xB8, 0x18)
#define REG_SC_BKB8_19_L      _PK_L_(0xB8, 0x19)
#define REG_SC_BKB8_19_H      _PK_H_(0xB8, 0x19)
#define REG_SC_BKB8_1A_L      _PK_L_(0xB8, 0x1A)
#define REG_SC_BKB8_1A_H      _PK_H_(0xB8, 0x1A)
#define REG_SC_BKB8_1B_L      _PK_L_(0xB8, 0x1B)
#define REG_SC_BKB8_1B_H      _PK_H_(0xB8, 0x1B)
#define REG_SC_BKB8_1C_L      _PK_L_(0xB8, 0x1C)
#define REG_SC_BKB8_1C_H      _PK_H_(0xB8, 0x1C)
#define REG_SC_BKB8_1D_L      _PK_L_(0xB8, 0x1D)
#define REG_SC_BKB8_1D_H      _PK_H_(0xB8, 0x1D)
#define REG_SC_BKB8_1E_L      _PK_L_(0xB8, 0x1E)
#define REG_SC_BKB8_1E_H      _PK_H_(0xB8, 0x1E)
#define REG_SC_BKB8_1F_L      _PK_L_(0xB8, 0x1F)
#define REG_SC_BKB8_1F_H      _PK_H_(0xB8, 0x1F)
#define REG_SC_BKB8_20_L      _PK_L_(0xB8, 0x20)
#define REG_SC_BKB8_20_H      _PK_H_(0xB8, 0x20)
#define REG_SC_BKB8_21_L      _PK_L_(0xB8, 0x21)
#define REG_SC_BKB8_21_H      _PK_H_(0xB8, 0x21)
#define REG_SC_BKB8_22_L      _PK_L_(0xB8, 0x22)
#define REG_SC_BKB8_22_H      _PK_H_(0xB8, 0x22)
#define REG_SC_BKB8_23_L      _PK_L_(0xB8, 0x23)
#define REG_SC_BKB8_23_H      _PK_H_(0xB8, 0x23)
#define REG_SC_BKB8_24_L      _PK_L_(0xB8, 0x24)
#define REG_SC_BKB8_24_H      _PK_H_(0xB8, 0x24)
#define REG_SC_BKB8_25_L      _PK_L_(0xB8, 0x25)
#define REG_SC_BKB8_25_H      _PK_H_(0xB8, 0x25)
#define REG_SC_BKB8_26_L      _PK_L_(0xB8, 0x26)
#define REG_SC_BKB8_26_H      _PK_H_(0xB8, 0x26)
#define REG_SC_BKB8_27_L      _PK_L_(0xB8, 0x27)
#define REG_SC_BKB8_27_H      _PK_H_(0xB8, 0x27)
#define REG_SC_BKB8_28_L      _PK_L_(0xB8, 0x28)
#define REG_SC_BKB8_28_H      _PK_H_(0xB8, 0x28)
#define REG_SC_BKB8_29_L      _PK_L_(0xB8, 0x29)
#define REG_SC_BKB8_29_H      _PK_H_(0xB8, 0x29)
#define REG_SC_BKB8_2A_L      _PK_L_(0xB8, 0x2A)
#define REG_SC_BKB8_2A_H      _PK_H_(0xB8, 0x2A)
#define REG_SC_BKB8_2B_L      _PK_L_(0xB8, 0x2B)
#define REG_SC_BKB8_2B_H      _PK_H_(0xB8, 0x2B)
#define REG_SC_BKB8_2C_L      _PK_L_(0xB8, 0x2C)
#define REG_SC_BKB8_2C_H      _PK_H_(0xB8, 0x2C)
#define REG_SC_BKB8_2D_L      _PK_L_(0xB8, 0x2D)
#define REG_SC_BKB8_2D_H      _PK_H_(0xB8, 0x2D)
#define REG_SC_BKB8_2E_L      _PK_L_(0xB8, 0x2E)
#define REG_SC_BKB8_2E_H      _PK_H_(0xB8, 0x2E)
#define REG_SC_BKB8_2F_L      _PK_L_(0xB8, 0x2F)
#define REG_SC_BKB8_2F_H      _PK_H_(0xB8, 0x2F)
#define REG_SC_BKB8_30_L      _PK_L_(0xB8, 0x30)
#define REG_SC_BKB8_30_H      _PK_H_(0xB8, 0x30)
#define REG_SC_BKB8_31_L      _PK_L_(0xB8, 0x31)
#define REG_SC_BKB8_31_H      _PK_H_(0xB8, 0x31)
#define REG_SC_BKB8_32_L      _PK_L_(0xB8, 0x32)
#define REG_SC_BKB8_32_H      _PK_H_(0xB8, 0x32)
#define REG_SC_BKB8_33_L      _PK_L_(0xB8, 0x33)
#define REG_SC_BKB8_33_H      _PK_H_(0xB8, 0x33)
#define REG_SC_BKB8_34_L      _PK_L_(0xB8, 0x34)
#define REG_SC_BKB8_34_H      _PK_H_(0xB8, 0x34)
#define REG_SC_BKB8_35_L      _PK_L_(0xB8, 0x35)
#define REG_SC_BKB8_35_H      _PK_H_(0xB8, 0x35)
#define REG_SC_BKB8_36_L      _PK_L_(0xB8, 0x36)
#define REG_SC_BKB8_36_H      _PK_H_(0xB8, 0x36)
#define REG_SC_BKB8_37_L      _PK_L_(0xB8, 0x37)
#define REG_SC_BKB8_37_H      _PK_H_(0xB8, 0x37)
#define REG_SC_BKB8_38_L      _PK_L_(0xB8, 0x38)
#define REG_SC_BKB8_38_H      _PK_H_(0xB8, 0x38)
#define REG_SC_BKB8_39_L      _PK_L_(0xB8, 0x39)
#define REG_SC_BKB8_39_H      _PK_H_(0xB8, 0x39)
#define REG_SC_BKB8_3A_L      _PK_L_(0xB8, 0x3A)
#define REG_SC_BKB8_3A_H      _PK_H_(0xB8, 0x3A)
#define REG_SC_BKB8_3B_L      _PK_L_(0xB8, 0x3B)
#define REG_SC_BKB8_3B_H      _PK_H_(0xB8, 0x3B)
#define REG_SC_BKB8_3C_L      _PK_L_(0xB8, 0x3C)
#define REG_SC_BKB8_3C_H      _PK_H_(0xB8, 0x3C)
#define REG_SC_BKB8_3D_L      _PK_L_(0xB8, 0x3D)
#define REG_SC_BKB8_3D_H      _PK_H_(0xB8, 0x3D)
#define REG_SC_BKB8_3E_L      _PK_L_(0xB8, 0x3E)
#define REG_SC_BKB8_3E_H      _PK_H_(0xB8, 0x3E)
#define REG_SC_BKB8_3F_L      _PK_L_(0xB8, 0x3F)
#define REG_SC_BKB8_3F_H      _PK_H_(0xB8, 0x3F)
#define REG_SC_BKB8_40_L      _PK_L_(0xB8, 0x40)
#define REG_SC_BKB8_40_H      _PK_H_(0xB8, 0x40)
#define REG_SC_BKB8_41_L      _PK_L_(0xB8, 0x41)
#define REG_SC_BKB8_41_H      _PK_H_(0xB8, 0x41)
#define REG_SC_BKB8_42_L      _PK_L_(0xB8, 0x42)
#define REG_SC_BKB8_42_H      _PK_H_(0xB8, 0x42)
#define REG_SC_BKB8_43_L      _PK_L_(0xB8, 0x43)
#define REG_SC_BKB8_43_H      _PK_H_(0xB8, 0x43)
#define REG_SC_BKB8_44_L      _PK_L_(0xB8, 0x44)
#define REG_SC_BKB8_44_H      _PK_H_(0xB8, 0x44)
#define REG_SC_BKB8_45_L      _PK_L_(0xB8, 0x45)
#define REG_SC_BKB8_45_H      _PK_H_(0xB8, 0x45)
#define REG_SC_BKB8_46_L      _PK_L_(0xB8, 0x46)
#define REG_SC_BKB8_46_H      _PK_H_(0xB8, 0x46)
#define REG_SC_BKB8_47_L      _PK_L_(0xB8, 0x47)
#define REG_SC_BKB8_47_H      _PK_H_(0xB8, 0x47)
#define REG_SC_BKB8_48_L      _PK_L_(0xB8, 0x48)
#define REG_SC_BKB8_48_H      _PK_H_(0xB8, 0x48)
#define REG_SC_BKB8_49_L      _PK_L_(0xB8, 0x49)
#define REG_SC_BKB8_49_H      _PK_H_(0xB8, 0x49)
#define REG_SC_BKB8_4A_L      _PK_L_(0xB8, 0x4A)
#define REG_SC_BKB8_4A_H      _PK_H_(0xB8, 0x4A)
#define REG_SC_BKB8_4B_L      _PK_L_(0xB8, 0x4B)
#define REG_SC_BKB8_4B_H      _PK_H_(0xB8, 0x4B)
#define REG_SC_BKB8_4C_L      _PK_L_(0xB8, 0x4C)
#define REG_SC_BKB8_4C_H      _PK_H_(0xB8, 0x4C)
#define REG_SC_BKB8_4D_L      _PK_L_(0xB8, 0x4D)
#define REG_SC_BKB8_4D_H      _PK_H_(0xB8, 0x4D)
#define REG_SC_BKB8_4E_L      _PK_L_(0xB8, 0x4E)
#define REG_SC_BKB8_4E_H      _PK_H_(0xB8, 0x4E)
#define REG_SC_BKB8_4F_L      _PK_L_(0xB8, 0x4F)
#define REG_SC_BKB8_4F_H      _PK_H_(0xB8, 0x4F)
#define REG_SC_BKB8_50_L      _PK_L_(0xB8, 0x50)
#define REG_SC_BKB8_50_H      _PK_H_(0xB8, 0x50)
#define REG_SC_BKB8_51_L      _PK_L_(0xB8, 0x51)
#define REG_SC_BKB8_51_H      _PK_H_(0xB8, 0x51)
#define REG_SC_BKB8_52_L      _PK_L_(0xB8, 0x52)
#define REG_SC_BKB8_52_H      _PK_H_(0xB8, 0x52)
#define REG_SC_BKB8_53_L      _PK_L_(0xB8, 0x53)
#define REG_SC_BKB8_53_H      _PK_H_(0xB8, 0x53)
#define REG_SC_BKB8_54_L      _PK_L_(0xB8, 0x54)
#define REG_SC_BKB8_54_H      _PK_H_(0xB8, 0x54)
#define REG_SC_BKB8_55_L      _PK_L_(0xB8, 0x55)
#define REG_SC_BKB8_55_H      _PK_H_(0xB8, 0x55)
#define REG_SC_BKB8_56_L      _PK_L_(0xB8, 0x56)
#define REG_SC_BKB8_56_H      _PK_H_(0xB8, 0x56)
#define REG_SC_BKB8_57_L      _PK_L_(0xB8, 0x57)
#define REG_SC_BKB8_57_H      _PK_H_(0xB8, 0x57)
#define REG_SC_BKB8_58_L      _PK_L_(0xB8, 0x58)
#define REG_SC_BKB8_58_H      _PK_H_(0xB8, 0x58)
#define REG_SC_BKB8_59_L      _PK_L_(0xB8, 0x59)
#define REG_SC_BKB8_59_H      _PK_H_(0xB8, 0x59)
#define REG_SC_BKB8_5A_L      _PK_L_(0xB8, 0x5A)
#define REG_SC_BKB8_5A_H      _PK_H_(0xB8, 0x5A)
#define REG_SC_BKB8_5B_L      _PK_L_(0xB8, 0x5B)
#define REG_SC_BKB8_5B_H      _PK_H_(0xB8, 0x5B)
#define REG_SC_BKB8_5C_L      _PK_L_(0xB8, 0x5C)
#define REG_SC_BKB8_5C_H      _PK_H_(0xB8, 0x5C)
#define REG_SC_BKB8_5D_L      _PK_L_(0xB8, 0x5D)
#define REG_SC_BKB8_5D_H      _PK_H_(0xB8, 0x5D)
#define REG_SC_BKB8_5E_L      _PK_L_(0xB8, 0x5E)
#define REG_SC_BKB8_5E_H      _PK_H_(0xB8, 0x5E)
#define REG_SC_BKB8_5F_L      _PK_L_(0xB8, 0x5F)
#define REG_SC_BKB8_5F_H      _PK_H_(0xB8, 0x5F)
#define REG_SC_BKB8_60_L      _PK_L_(0xB8, 0x60)
#define REG_SC_BKB8_60_H      _PK_H_(0xB8, 0x60)
#define REG_SC_BKB8_61_L      _PK_L_(0xB8, 0x61)
#define REG_SC_BKB8_61_H      _PK_H_(0xB8, 0x61)
#define REG_SC_BKB8_62_L      _PK_L_(0xB8, 0x62)
#define REG_SC_BKB8_62_H      _PK_H_(0xB8, 0x62)
#define REG_SC_BKB8_63_L      _PK_L_(0xB8, 0x63)
#define REG_SC_BKB8_63_H      _PK_H_(0xB8, 0x63)
#define REG_SC_BKB8_64_L      _PK_L_(0xB8, 0x64)
#define REG_SC_BKB8_64_H      _PK_H_(0xB8, 0x64)
#define REG_SC_BKB8_65_L      _PK_L_(0xB8, 0x65)
#define REG_SC_BKB8_65_H      _PK_H_(0xB8, 0x65)
#define REG_SC_BKB8_66_L      _PK_L_(0xB8, 0x66)
#define REG_SC_BKB8_66_H      _PK_H_(0xB8, 0x66)
#define REG_SC_BKB8_67_L      _PK_L_(0xB8, 0x67)
#define REG_SC_BKB8_67_H      _PK_H_(0xB8, 0x67)
#define REG_SC_BKB8_68_L      _PK_L_(0xB8, 0x68)
#define REG_SC_BKB8_68_H      _PK_H_(0xB8, 0x68)
#define REG_SC_BKB8_69_L      _PK_L_(0xB8, 0x69)
#define REG_SC_BKB8_69_H      _PK_H_(0xB8, 0x69)
#define REG_SC_BKB8_6A_L      _PK_L_(0xB8, 0x6A)
#define REG_SC_BKB8_6A_H      _PK_H_(0xB8, 0x6A)
#define REG_SC_BKB8_6B_L      _PK_L_(0xB8, 0x6B)
#define REG_SC_BKB8_6B_H      _PK_H_(0xB8, 0x6B)
#define REG_SC_BKB8_6C_L      _PK_L_(0xB8, 0x6C)
#define REG_SC_BKB8_6C_H      _PK_H_(0xB8, 0x6C)
#define REG_SC_BKB8_6D_L      _PK_L_(0xB8, 0x6D)
#define REG_SC_BKB8_6D_H      _PK_H_(0xB8, 0x6D)
#define REG_SC_BKB8_6E_L      _PK_L_(0xB8, 0x6E)
#define REG_SC_BKB8_6E_H      _PK_H_(0xB8, 0x6E)
#define REG_SC_BKB8_6F_L      _PK_L_(0xB8, 0x6F)
#define REG_SC_BKB8_6F_H      _PK_H_(0xB8, 0x6F)
#define REG_SC_BKB8_70_L      _PK_L_(0xB8, 0x70)
#define REG_SC_BKB8_70_H      _PK_H_(0xB8, 0x70)
#define REG_SC_BKB8_71_L      _PK_L_(0xB8, 0x71)
#define REG_SC_BKB8_71_H      _PK_H_(0xB8, 0x71)
#define REG_SC_BKB8_72_L      _PK_L_(0xB8, 0x72)
#define REG_SC_BKB8_72_H      _PK_H_(0xB8, 0x72)
#define REG_SC_BKB8_73_L      _PK_L_(0xB8, 0x73)
#define REG_SC_BKB8_73_H      _PK_H_(0xB8, 0x73)
#define REG_SC_BKB8_74_L      _PK_L_(0xB8, 0x74)
#define REG_SC_BKB8_74_H      _PK_H_(0xB8, 0x74)
#define REG_SC_BKB8_75_L      _PK_L_(0xB8, 0x75)
#define REG_SC_BKB8_75_H      _PK_H_(0xB8, 0x75)
#define REG_SC_BKB8_76_L      _PK_L_(0xB8, 0x76)
#define REG_SC_BKB8_76_H      _PK_H_(0xB8, 0x76)
#define REG_SC_BKB8_77_L      _PK_L_(0xB8, 0x77)
#define REG_SC_BKB8_77_H      _PK_H_(0xB8, 0x77)
#define REG_SC_BKB8_78_L      _PK_L_(0xB8, 0x78)
#define REG_SC_BKB8_78_H      _PK_H_(0xB8, 0x78)
#define REG_SC_BKB8_79_L      _PK_L_(0xB8, 0x79)
#define REG_SC_BKB8_79_H      _PK_H_(0xB8, 0x79)
#define REG_SC_BKB8_7A_L      _PK_L_(0xB8, 0x7A)
#define REG_SC_BKB8_7A_H      _PK_H_(0xB8, 0x7A)
#define REG_SC_BKB8_7B_L      _PK_L_(0xB8, 0x7B)
#define REG_SC_BKB8_7B_H      _PK_H_(0xB8, 0x7B)
#define REG_SC_BKB8_7C_L      _PK_L_(0xB8, 0x7C)
#define REG_SC_BKB8_7C_H      _PK_H_(0xB8, 0x7C)
#define REG_SC_BKB8_7D_L      _PK_L_(0xB8, 0x7D)
#define REG_SC_BKB8_7D_H      _PK_H_(0xB8, 0x7D)
#define REG_SC_BKB8_7E_L      _PK_L_(0xB8, 0x7E)
#define REG_SC_BKB8_7E_H      _PK_H_(0xB8, 0x7E)
#define REG_SC_BKB8_7F_L      _PK_L_(0xB8, 0x7F)
#define REG_SC_BKB8_7F_H      _PK_H_(0xB8, 0x7F)
//----------------------------------------------
#define REG_SC_BKB9_00_L      _PK_L_(0xB9, 0x00)
#define REG_SC_BKB9_00_H      _PK_H_(0xB9, 0x00)
#define REG_SC_BKB9_01_L      _PK_L_(0xB9, 0x01)
#define REG_SC_BKB9_01_H      _PK_H_(0xB9, 0x01)
#define REG_SC_BKB9_02_L      _PK_L_(0xB9, 0x02)
#define REG_SC_BKB9_02_H      _PK_H_(0xB9, 0x02)
#define REG_SC_BKB9_03_L      _PK_L_(0xB9, 0x03)
#define REG_SC_BKB9_03_H      _PK_H_(0xB9, 0x03)
#define REG_SC_BKB9_04_L      _PK_L_(0xB9, 0x04)
#define REG_SC_BKB9_04_H      _PK_H_(0xB9, 0x04)
#define REG_SC_BKB9_05_L      _PK_L_(0xB9, 0x05)
#define REG_SC_BKB9_05_H      _PK_H_(0xB9, 0x05)
#define REG_SC_BKB9_06_L      _PK_L_(0xB9, 0x06)
#define REG_SC_BKB9_06_H      _PK_H_(0xB9, 0x06)
#define REG_SC_BKB9_07_L      _PK_L_(0xB9, 0x07)
#define REG_SC_BKB9_07_H      _PK_H_(0xB9, 0x07)
#define REG_SC_BKB9_08_L      _PK_L_(0xB9, 0x08)
#define REG_SC_BKB9_08_H      _PK_H_(0xB9, 0x08)
#define REG_SC_BKB9_09_L      _PK_L_(0xB9, 0x09)
#define REG_SC_BKB9_09_H      _PK_H_(0xB9, 0x09)
#define REG_SC_BKB9_0A_L      _PK_L_(0xB9, 0x0A)
#define REG_SC_BKB9_0A_H      _PK_H_(0xB9, 0x0A)
#define REG_SC_BKB9_0B_L      _PK_L_(0xB9, 0x0B)
#define REG_SC_BKB9_0B_H      _PK_H_(0xB9, 0x0B)
#define REG_SC_BKB9_0C_L      _PK_L_(0xB9, 0x0C)
#define REG_SC_BKB9_0C_H      _PK_H_(0xB9, 0x0C)
#define REG_SC_BKB9_0D_L      _PK_L_(0xB9, 0x0D)
#define REG_SC_BKB9_0D_H      _PK_H_(0xB9, 0x0D)
#define REG_SC_BKB9_0E_L      _PK_L_(0xB9, 0x0E)
#define REG_SC_BKB9_0E_H      _PK_H_(0xB9, 0x0E)
#define REG_SC_BKB9_0F_L      _PK_L_(0xB9, 0x0F)
#define REG_SC_BKB9_0F_H      _PK_H_(0xB9, 0x0F)
#define REG_SC_BKB9_10_L      _PK_L_(0xB9, 0x10)
#define REG_SC_BKB9_10_H      _PK_H_(0xB9, 0x10)
#define REG_SC_BKB9_11_L      _PK_L_(0xB9, 0x11)
#define REG_SC_BKB9_11_H      _PK_H_(0xB9, 0x11)
#define REG_SC_BKB9_12_L      _PK_L_(0xB9, 0x12)
#define REG_SC_BKB9_12_H      _PK_H_(0xB9, 0x12)
#define REG_SC_BKB9_13_L      _PK_L_(0xB9, 0x13)
#define REG_SC_BKB9_13_H      _PK_H_(0xB9, 0x13)
#define REG_SC_BKB9_14_L      _PK_L_(0xB9, 0x14)
#define REG_SC_BKB9_14_H      _PK_H_(0xB9, 0x14)
#define REG_SC_BKB9_15_L      _PK_L_(0xB9, 0x15)
#define REG_SC_BKB9_15_H      _PK_H_(0xB9, 0x15)
#define REG_SC_BKB9_16_L      _PK_L_(0xB9, 0x16)
#define REG_SC_BKB9_16_H      _PK_H_(0xB9, 0x16)
#define REG_SC_BKB9_17_L      _PK_L_(0xB9, 0x17)
#define REG_SC_BKB9_17_H      _PK_H_(0xB9, 0x17)
#define REG_SC_BKB9_18_L      _PK_L_(0xB9, 0x18)
#define REG_SC_BKB9_18_H      _PK_H_(0xB9, 0x18)
#define REG_SC_BKB9_19_L      _PK_L_(0xB9, 0x19)
#define REG_SC_BKB9_19_H      _PK_H_(0xB9, 0x19)
#define REG_SC_BKB9_1A_L      _PK_L_(0xB9, 0x1A)
#define REG_SC_BKB9_1A_H      _PK_H_(0xB9, 0x1A)
#define REG_SC_BKB9_1B_L      _PK_L_(0xB9, 0x1B)
#define REG_SC_BKB9_1B_H      _PK_H_(0xB9, 0x1B)
#define REG_SC_BKB9_1C_L      _PK_L_(0xB9, 0x1C)
#define REG_SC_BKB9_1C_H      _PK_H_(0xB9, 0x1C)
#define REG_SC_BKB9_1D_L      _PK_L_(0xB9, 0x1D)
#define REG_SC_BKB9_1D_H      _PK_H_(0xB9, 0x1D)
#define REG_SC_BKB9_1E_L      _PK_L_(0xB9, 0x1E)
#define REG_SC_BKB9_1E_H      _PK_H_(0xB9, 0x1E)
#define REG_SC_BKB9_1F_L      _PK_L_(0xB9, 0x1F)
#define REG_SC_BKB9_1F_H      _PK_H_(0xB9, 0x1F)
#define REG_SC_BKB9_20_L      _PK_L_(0xB9, 0x20)
#define REG_SC_BKB9_20_H      _PK_H_(0xB9, 0x20)
#define REG_SC_BKB9_21_L      _PK_L_(0xB9, 0x21)
#define REG_SC_BKB9_21_H      _PK_H_(0xB9, 0x21)
#define REG_SC_BKB9_22_L      _PK_L_(0xB9, 0x22)
#define REG_SC_BKB9_22_H      _PK_H_(0xB9, 0x22)
#define REG_SC_BKB9_23_L      _PK_L_(0xB9, 0x23)
#define REG_SC_BKB9_23_H      _PK_H_(0xB9, 0x23)
#define REG_SC_BKB9_24_L      _PK_L_(0xB9, 0x24)
#define REG_SC_BKB9_24_H      _PK_H_(0xB9, 0x24)
#define REG_SC_BKB9_25_L      _PK_L_(0xB9, 0x25)
#define REG_SC_BKB9_25_H      _PK_H_(0xB9, 0x25)
#define REG_SC_BKB9_26_L      _PK_L_(0xB9, 0x26)
#define REG_SC_BKB9_26_H      _PK_H_(0xB9, 0x26)
#define REG_SC_BKB9_27_L      _PK_L_(0xB9, 0x27)
#define REG_SC_BKB9_27_H      _PK_H_(0xB9, 0x27)
#define REG_SC_BKB9_28_L      _PK_L_(0xB9, 0x28)
#define REG_SC_BKB9_28_H      _PK_H_(0xB9, 0x28)
#define REG_SC_BKB9_29_L      _PK_L_(0xB9, 0x29)
#define REG_SC_BKB9_29_H      _PK_H_(0xB9, 0x29)
#define REG_SC_BKB9_2A_L      _PK_L_(0xB9, 0x2A)
#define REG_SC_BKB9_2A_H      _PK_H_(0xB9, 0x2A)
#define REG_SC_BKB9_2B_L      _PK_L_(0xB9, 0x2B)
#define REG_SC_BKB9_2B_H      _PK_H_(0xB9, 0x2B)
#define REG_SC_BKB9_2C_L      _PK_L_(0xB9, 0x2C)
#define REG_SC_BKB9_2C_H      _PK_H_(0xB9, 0x2C)
#define REG_SC_BKB9_2D_L      _PK_L_(0xB9, 0x2D)
#define REG_SC_BKB9_2D_H      _PK_H_(0xB9, 0x2D)
#define REG_SC_BKB9_2E_L      _PK_L_(0xB9, 0x2E)
#define REG_SC_BKB9_2E_H      _PK_H_(0xB9, 0x2E)
#define REG_SC_BKB9_2F_L      _PK_L_(0xB9, 0x2F)
#define REG_SC_BKB9_2F_H      _PK_H_(0xB9, 0x2F)
#define REG_SC_BKB9_30_L      _PK_L_(0xB9, 0x30)
#define REG_SC_BKB9_30_H      _PK_H_(0xB9, 0x30)
#define REG_SC_BKB9_31_L      _PK_L_(0xB9, 0x31)
#define REG_SC_BKB9_31_H      _PK_H_(0xB9, 0x31)
#define REG_SC_BKB9_32_L      _PK_L_(0xB9, 0x32)
#define REG_SC_BKB9_32_H      _PK_H_(0xB9, 0x32)
#define REG_SC_BKB9_33_L      _PK_L_(0xB9, 0x33)
#define REG_SC_BKB9_33_H      _PK_H_(0xB9, 0x33)
#define REG_SC_BKB9_34_L      _PK_L_(0xB9, 0x34)
#define REG_SC_BKB9_34_H      _PK_H_(0xB9, 0x34)
#define REG_SC_BKB9_35_L      _PK_L_(0xB9, 0x35)
#define REG_SC_BKB9_35_H      _PK_H_(0xB9, 0x35)
#define REG_SC_BKB9_36_L      _PK_L_(0xB9, 0x36)
#define REG_SC_BKB9_36_H      _PK_H_(0xB9, 0x36)
#define REG_SC_BKB9_37_L      _PK_L_(0xB9, 0x37)
#define REG_SC_BKB9_37_H      _PK_H_(0xB9, 0x37)
#define REG_SC_BKB9_38_L      _PK_L_(0xB9, 0x38)
#define REG_SC_BKB9_38_H      _PK_H_(0xB9, 0x38)
#define REG_SC_BKB9_39_L      _PK_L_(0xB9, 0x39)
#define REG_SC_BKB9_39_H      _PK_H_(0xB9, 0x39)
#define REG_SC_BKB9_3A_L      _PK_L_(0xB9, 0x3A)
#define REG_SC_BKB9_3A_H      _PK_H_(0xB9, 0x3A)
#define REG_SC_BKB9_3B_L      _PK_L_(0xB9, 0x3B)
#define REG_SC_BKB9_3B_H      _PK_H_(0xB9, 0x3B)
#define REG_SC_BKB9_3C_L      _PK_L_(0xB9, 0x3C)
#define REG_SC_BKB9_3C_H      _PK_H_(0xB9, 0x3C)
#define REG_SC_BKB9_3D_L      _PK_L_(0xB9, 0x3D)
#define REG_SC_BKB9_3D_H      _PK_H_(0xB9, 0x3D)
#define REG_SC_BKB9_3E_L      _PK_L_(0xB9, 0x3E)
#define REG_SC_BKB9_3E_H      _PK_H_(0xB9, 0x3E)
#define REG_SC_BKB9_3F_L      _PK_L_(0xB9, 0x3F)
#define REG_SC_BKB9_3F_H      _PK_H_(0xB9, 0x3F)
#define REG_SC_BKB9_40_L      _PK_L_(0xB9, 0x40)
#define REG_SC_BKB9_40_H      _PK_H_(0xB9, 0x40)
#define REG_SC_BKB9_41_L      _PK_L_(0xB9, 0x41)
#define REG_SC_BKB9_41_H      _PK_H_(0xB9, 0x41)
#define REG_SC_BKB9_42_L      _PK_L_(0xB9, 0x42)
#define REG_SC_BKB9_42_H      _PK_H_(0xB9, 0x42)
#define REG_SC_BKB9_43_L      _PK_L_(0xB9, 0x43)
#define REG_SC_BKB9_43_H      _PK_H_(0xB9, 0x43)
#define REG_SC_BKB9_44_L      _PK_L_(0xB9, 0x44)
#define REG_SC_BKB9_44_H      _PK_H_(0xB9, 0x44)
#define REG_SC_BKB9_45_L      _PK_L_(0xB9, 0x45)
#define REG_SC_BKB9_45_H      _PK_H_(0xB9, 0x45)
#define REG_SC_BKB9_46_L      _PK_L_(0xB9, 0x46)
#define REG_SC_BKB9_46_H      _PK_H_(0xB9, 0x46)
#define REG_SC_BKB9_47_L      _PK_L_(0xB9, 0x47)
#define REG_SC_BKB9_47_H      _PK_H_(0xB9, 0x47)
#define REG_SC_BKB9_48_L      _PK_L_(0xB9, 0x48)
#define REG_SC_BKB9_48_H      _PK_H_(0xB9, 0x48)
#define REG_SC_BKB9_49_L      _PK_L_(0xB9, 0x49)
#define REG_SC_BKB9_49_H      _PK_H_(0xB9, 0x49)
#define REG_SC_BKB9_4A_L      _PK_L_(0xB9, 0x4A)
#define REG_SC_BKB9_4A_H      _PK_H_(0xB9, 0x4A)
#define REG_SC_BKB9_4B_L      _PK_L_(0xB9, 0x4B)
#define REG_SC_BKB9_4B_H      _PK_H_(0xB9, 0x4B)
#define REG_SC_BKB9_4C_L      _PK_L_(0xB9, 0x4C)
#define REG_SC_BKB9_4C_H      _PK_H_(0xB9, 0x4C)
#define REG_SC_BKB9_4D_L      _PK_L_(0xB9, 0x4D)
#define REG_SC_BKB9_4D_H      _PK_H_(0xB9, 0x4D)
#define REG_SC_BKB9_4E_L      _PK_L_(0xB9, 0x4E)
#define REG_SC_BKB9_4E_H      _PK_H_(0xB9, 0x4E)
#define REG_SC_BKB9_4F_L      _PK_L_(0xB9, 0x4F)
#define REG_SC_BKB9_4F_H      _PK_H_(0xB9, 0x4F)
#define REG_SC_BKB9_50_L      _PK_L_(0xB9, 0x50)
#define REG_SC_BKB9_50_H      _PK_H_(0xB9, 0x50)
#define REG_SC_BKB9_51_L      _PK_L_(0xB9, 0x51)
#define REG_SC_BKB9_51_H      _PK_H_(0xB9, 0x51)
#define REG_SC_BKB9_52_L      _PK_L_(0xB9, 0x52)
#define REG_SC_BKB9_52_H      _PK_H_(0xB9, 0x52)
#define REG_SC_BKB9_53_L      _PK_L_(0xB9, 0x53)
#define REG_SC_BKB9_53_H      _PK_H_(0xB9, 0x53)
#define REG_SC_BKB9_54_L      _PK_L_(0xB9, 0x54)
#define REG_SC_BKB9_54_H      _PK_H_(0xB9, 0x54)
#define REG_SC_BKB9_55_L      _PK_L_(0xB9, 0x55)
#define REG_SC_BKB9_55_H      _PK_H_(0xB9, 0x55)
#define REG_SC_BKB9_56_L      _PK_L_(0xB9, 0x56)
#define REG_SC_BKB9_56_H      _PK_H_(0xB9, 0x56)
#define REG_SC_BKB9_57_L      _PK_L_(0xB9, 0x57)
#define REG_SC_BKB9_57_H      _PK_H_(0xB9, 0x57)
#define REG_SC_BKB9_58_L      _PK_L_(0xB9, 0x58)
#define REG_SC_BKB9_58_H      _PK_H_(0xB9, 0x58)
#define REG_SC_BKB9_59_L      _PK_L_(0xB9, 0x59)
#define REG_SC_BKB9_59_H      _PK_H_(0xB9, 0x59)
#define REG_SC_BKB9_5A_L      _PK_L_(0xB9, 0x5A)
#define REG_SC_BKB9_5A_H      _PK_H_(0xB9, 0x5A)
#define REG_SC_BKB9_5B_L      _PK_L_(0xB9, 0x5B)
#define REG_SC_BKB9_5B_H      _PK_H_(0xB9, 0x5B)
#define REG_SC_BKB9_5C_L      _PK_L_(0xB9, 0x5C)
#define REG_SC_BKB9_5C_H      _PK_H_(0xB9, 0x5C)
#define REG_SC_BKB9_5D_L      _PK_L_(0xB9, 0x5D)
#define REG_SC_BKB9_5D_H      _PK_H_(0xB9, 0x5D)
#define REG_SC_BKB9_5E_L      _PK_L_(0xB9, 0x5E)
#define REG_SC_BKB9_5E_H      _PK_H_(0xB9, 0x5E)
#define REG_SC_BKB9_5F_L      _PK_L_(0xB9, 0x5F)
#define REG_SC_BKB9_5F_H      _PK_H_(0xB9, 0x5F)
#define REG_SC_BKB9_60_L      _PK_L_(0xB9, 0x60)
#define REG_SC_BKB9_60_H      _PK_H_(0xB9, 0x60)
#define REG_SC_BKB9_61_L      _PK_L_(0xB9, 0x61)
#define REG_SC_BKB9_61_H      _PK_H_(0xB9, 0x61)
#define REG_SC_BKB9_62_L      _PK_L_(0xB9, 0x62)
#define REG_SC_BKB9_62_H      _PK_H_(0xB9, 0x62)
#define REG_SC_BKB9_63_L      _PK_L_(0xB9, 0x63)
#define REG_SC_BKB9_63_H      _PK_H_(0xB9, 0x63)
#define REG_SC_BKB9_64_L      _PK_L_(0xB9, 0x64)
#define REG_SC_BKB9_64_H      _PK_H_(0xB9, 0x64)
#define REG_SC_BKB9_65_L      _PK_L_(0xB9, 0x65)
#define REG_SC_BKB9_65_H      _PK_H_(0xB9, 0x65)
#define REG_SC_BKB9_66_L      _PK_L_(0xB9, 0x66)
#define REG_SC_BKB9_66_H      _PK_H_(0xB9, 0x66)
#define REG_SC_BKB9_67_L      _PK_L_(0xB9, 0x67)
#define REG_SC_BKB9_67_H      _PK_H_(0xB9, 0x67)
#define REG_SC_BKB9_68_L      _PK_L_(0xB9, 0x68)
#define REG_SC_BKB9_68_H      _PK_H_(0xB9, 0x68)
#define REG_SC_BKB9_69_L      _PK_L_(0xB9, 0x69)
#define REG_SC_BKB9_69_H      _PK_H_(0xB9, 0x69)
#define REG_SC_BKB9_6A_L      _PK_L_(0xB9, 0x6A)
#define REG_SC_BKB9_6A_H      _PK_H_(0xB9, 0x6A)
#define REG_SC_BKB9_6B_L      _PK_L_(0xB9, 0x6B)
#define REG_SC_BKB9_6B_H      _PK_H_(0xB9, 0x6B)
#define REG_SC_BKB9_6C_L      _PK_L_(0xB9, 0x6C)
#define REG_SC_BKB9_6C_H      _PK_H_(0xB9, 0x6C)
#define REG_SC_BKB9_6D_L      _PK_L_(0xB9, 0x6D)
#define REG_SC_BKB9_6D_H      _PK_H_(0xB9, 0x6D)
#define REG_SC_BKB9_6E_L      _PK_L_(0xB9, 0x6E)
#define REG_SC_BKB9_6E_H      _PK_H_(0xB9, 0x6E)
#define REG_SC_BKB9_6F_L      _PK_L_(0xB9, 0x6F)
#define REG_SC_BKB9_6F_H      _PK_H_(0xB9, 0x6F)
#define REG_SC_BKB9_70_L      _PK_L_(0xB9, 0x70)
#define REG_SC_BKB9_70_H      _PK_H_(0xB9, 0x70)
#define REG_SC_BKB9_71_L      _PK_L_(0xB9, 0x71)
#define REG_SC_BKB9_71_H      _PK_H_(0xB9, 0x71)
#define REG_SC_BKB9_72_L      _PK_L_(0xB9, 0x72)
#define REG_SC_BKB9_72_H      _PK_H_(0xB9, 0x72)
#define REG_SC_BKB9_73_L      _PK_L_(0xB9, 0x73)
#define REG_SC_BKB9_73_H      _PK_H_(0xB9, 0x73)
#define REG_SC_BKB9_74_L      _PK_L_(0xB9, 0x74)
#define REG_SC_BKB9_74_H      _PK_H_(0xB9, 0x74)
#define REG_SC_BKB9_75_L      _PK_L_(0xB9, 0x75)
#define REG_SC_BKB9_75_H      _PK_H_(0xB9, 0x75)
#define REG_SC_BKB9_76_L      _PK_L_(0xB9, 0x76)
#define REG_SC_BKB9_76_H      _PK_H_(0xB9, 0x76)
#define REG_SC_BKB9_77_L      _PK_L_(0xB9, 0x77)
#define REG_SC_BKB9_77_H      _PK_H_(0xB9, 0x77)
#define REG_SC_BKB9_78_L      _PK_L_(0xB9, 0x78)
#define REG_SC_BKB9_78_H      _PK_H_(0xB9, 0x78)
#define REG_SC_BKB9_79_L      _PK_L_(0xB9, 0x79)
#define REG_SC_BKB9_79_H      _PK_H_(0xB9, 0x79)
#define REG_SC_BKB9_7A_L      _PK_L_(0xB9, 0x7A)
#define REG_SC_BKB9_7A_H      _PK_H_(0xB9, 0x7A)
#define REG_SC_BKB9_7B_L      _PK_L_(0xB9, 0x7B)
#define REG_SC_BKB9_7B_H      _PK_H_(0xB9, 0x7B)
#define REG_SC_BKB9_7C_L      _PK_L_(0xB9, 0x7C)
#define REG_SC_BKB9_7C_H      _PK_H_(0xB9, 0x7C)
#define REG_SC_BKB9_7D_L      _PK_L_(0xB9, 0x7D)
#define REG_SC_BKB9_7D_H      _PK_H_(0xB9, 0x7D)
#define REG_SC_BKB9_7E_L      _PK_L_(0xB9, 0x7E)
#define REG_SC_BKB9_7E_H      _PK_H_(0xB9, 0x7E)
#define REG_SC_BKB9_7F_L      _PK_L_(0xB9, 0x7F)
#define REG_SC_BKB9_7F_H      _PK_H_(0xB9, 0x7F)
//----------------------------------------------
#define REG_SC_BKBA_00_L      _PK_L_(0xBA, 0x00)
#define REG_SC_BKBA_00_H      _PK_H_(0xBA, 0x00)
#define REG_SC_BKBA_01_L      _PK_L_(0xBA, 0x01)
#define REG_SC_BKBA_01_H      _PK_H_(0xBA, 0x01)
#define REG_SC_BKBA_02_L      _PK_L_(0xBA, 0x02)
#define REG_SC_BKBA_02_H      _PK_H_(0xBA, 0x02)
#define REG_SC_BKBA_03_L      _PK_L_(0xBA, 0x03)
#define REG_SC_BKBA_03_H      _PK_H_(0xBA, 0x03)
#define REG_SC_BKBA_04_L      _PK_L_(0xBA, 0x04)
#define REG_SC_BKBA_04_H      _PK_H_(0xBA, 0x04)
#define REG_SC_BKBA_05_L      _PK_L_(0xBA, 0x05)
#define REG_SC_BKBA_05_H      _PK_H_(0xBA, 0x05)
#define REG_SC_BKBA_06_L      _PK_L_(0xBA, 0x06)
#define REG_SC_BKBA_06_H      _PK_H_(0xBA, 0x06)
#define REG_SC_BKBA_07_L      _PK_L_(0xBA, 0x07)
#define REG_SC_BKBA_07_H      _PK_H_(0xBA, 0x07)
#define REG_SC_BKBA_08_L      _PK_L_(0xBA, 0x08)
#define REG_SC_BKBA_08_H      _PK_H_(0xBA, 0x08)
#define REG_SC_BKBA_09_L      _PK_L_(0xBA, 0x09)
#define REG_SC_BKBA_09_H      _PK_H_(0xBA, 0x09)
#define REG_SC_BKBA_0A_L      _PK_L_(0xBA, 0x0A)
#define REG_SC_BKBA_0A_H      _PK_H_(0xBA, 0x0A)
#define REG_SC_BKBA_0B_L      _PK_L_(0xBA, 0x0B)
#define REG_SC_BKBA_0B_H      _PK_H_(0xBA, 0x0B)
#define REG_SC_BKBA_0C_L      _PK_L_(0xBA, 0x0C)
#define REG_SC_BKBA_0C_H      _PK_H_(0xBA, 0x0C)
#define REG_SC_BKBA_0D_L      _PK_L_(0xBA, 0x0D)
#define REG_SC_BKBA_0D_H      _PK_H_(0xBA, 0x0D)
#define REG_SC_BKBA_0E_L      _PK_L_(0xBA, 0x0E)
#define REG_SC_BKBA_0E_H      _PK_H_(0xBA, 0x0E)
#define REG_SC_BKBA_0F_L      _PK_L_(0xBA, 0x0F)
#define REG_SC_BKBA_0F_H      _PK_H_(0xBA, 0x0F)
#define REG_SC_BKBA_10_L      _PK_L_(0xBA, 0x10)
#define REG_SC_BKBA_10_H      _PK_H_(0xBA, 0x10)
#define REG_SC_BKBA_11_L      _PK_L_(0xBA, 0x11)
#define REG_SC_BKBA_11_H      _PK_H_(0xBA, 0x11)
#define REG_SC_BKBA_12_L      _PK_L_(0xBA, 0x12)
#define REG_SC_BKBA_12_H      _PK_H_(0xBA, 0x12)
#define REG_SC_BKBA_13_L      _PK_L_(0xBA, 0x13)
#define REG_SC_BKBA_13_H      _PK_H_(0xBA, 0x13)
#define REG_SC_BKBA_14_L      _PK_L_(0xBA, 0x14)
#define REG_SC_BKBA_14_H      _PK_H_(0xBA, 0x14)
#define REG_SC_BKBA_15_L      _PK_L_(0xBA, 0x15)
#define REG_SC_BKBA_15_H      _PK_H_(0xBA, 0x15)
#define REG_SC_BKBA_16_L      _PK_L_(0xBA, 0x16)
#define REG_SC_BKBA_16_H      _PK_H_(0xBA, 0x16)
#define REG_SC_BKBA_17_L      _PK_L_(0xBA, 0x17)
#define REG_SC_BKBA_17_H      _PK_H_(0xBA, 0x17)
#define REG_SC_BKBA_18_L      _PK_L_(0xBA, 0x18)
#define REG_SC_BKBA_18_H      _PK_H_(0xBA, 0x18)
#define REG_SC_BKBA_19_L      _PK_L_(0xBA, 0x19)
#define REG_SC_BKBA_19_H      _PK_H_(0xBA, 0x19)
#define REG_SC_BKBA_1A_L      _PK_L_(0xBA, 0x1A)
#define REG_SC_BKBA_1A_H      _PK_H_(0xBA, 0x1A)
#define REG_SC_BKBA_1B_L      _PK_L_(0xBA, 0x1B)
#define REG_SC_BKBA_1B_H      _PK_H_(0xBA, 0x1B)
#define REG_SC_BKBA_1C_L      _PK_L_(0xBA, 0x1C)
#define REG_SC_BKBA_1C_H      _PK_H_(0xBA, 0x1C)
#define REG_SC_BKBA_1D_L      _PK_L_(0xBA, 0x1D)
#define REG_SC_BKBA_1D_H      _PK_H_(0xBA, 0x1D)
#define REG_SC_BKBA_1E_L      _PK_L_(0xBA, 0x1E)
#define REG_SC_BKBA_1E_H      _PK_H_(0xBA, 0x1E)
#define REG_SC_BKBA_1F_L      _PK_L_(0xBA, 0x1F)
#define REG_SC_BKBA_1F_H      _PK_H_(0xBA, 0x1F)
#define REG_SC_BKBA_20_L      _PK_L_(0xBA, 0x20)
#define REG_SC_BKBA_20_H      _PK_H_(0xBA, 0x20)
#define REG_SC_BKBA_21_L      _PK_L_(0xBA, 0x21)
#define REG_SC_BKBA_21_H      _PK_H_(0xBA, 0x21)
#define REG_SC_BKBA_22_L      _PK_L_(0xBA, 0x22)
#define REG_SC_BKBA_22_H      _PK_H_(0xBA, 0x22)
#define REG_SC_BKBA_23_L      _PK_L_(0xBA, 0x23)
#define REG_SC_BKBA_23_H      _PK_H_(0xBA, 0x23)
#define REG_SC_BKBA_24_L      _PK_L_(0xBA, 0x24)
#define REG_SC_BKBA_24_H      _PK_H_(0xBA, 0x24)
#define REG_SC_BKBA_25_L      _PK_L_(0xBA, 0x25)
#define REG_SC_BKBA_25_H      _PK_H_(0xBA, 0x25)
#define REG_SC_BKBA_26_L      _PK_L_(0xBA, 0x26)
#define REG_SC_BKBA_26_H      _PK_H_(0xBA, 0x26)
#define REG_SC_BKBA_27_L      _PK_L_(0xBA, 0x27)
#define REG_SC_BKBA_27_H      _PK_H_(0xBA, 0x27)
#define REG_SC_BKBA_28_L      _PK_L_(0xBA, 0x28)
#define REG_SC_BKBA_28_H      _PK_H_(0xBA, 0x28)
#define REG_SC_BKBA_29_L      _PK_L_(0xBA, 0x29)
#define REG_SC_BKBA_29_H      _PK_H_(0xBA, 0x29)
#define REG_SC_BKBA_2A_L      _PK_L_(0xBA, 0x2A)
#define REG_SC_BKBA_2A_H      _PK_H_(0xBA, 0x2A)
#define REG_SC_BKBA_2B_L      _PK_L_(0xBA, 0x2B)
#define REG_SC_BKBA_2B_H      _PK_H_(0xBA, 0x2B)
#define REG_SC_BKBA_2C_L      _PK_L_(0xBA, 0x2C)
#define REG_SC_BKBA_2C_H      _PK_H_(0xBA, 0x2C)
#define REG_SC_BKBA_2D_L      _PK_L_(0xBA, 0x2D)
#define REG_SC_BKBA_2D_H      _PK_H_(0xBA, 0x2D)
#define REG_SC_BKBA_2E_L      _PK_L_(0xBA, 0x2E)
#define REG_SC_BKBA_2E_H      _PK_H_(0xBA, 0x2E)
#define REG_SC_BKBA_2F_L      _PK_L_(0xBA, 0x2F)
#define REG_SC_BKBA_2F_H      _PK_H_(0xBA, 0x2F)
#define REG_SC_BKBA_30_L      _PK_L_(0xBA, 0x30)
#define REG_SC_BKBA_30_H      _PK_H_(0xBA, 0x30)
#define REG_SC_BKBA_31_L      _PK_L_(0xBA, 0x31)
#define REG_SC_BKBA_31_H      _PK_H_(0xBA, 0x31)
#define REG_SC_BKBA_32_L      _PK_L_(0xBA, 0x32)
#define REG_SC_BKBA_32_H      _PK_H_(0xBA, 0x32)
#define REG_SC_BKBA_33_L      _PK_L_(0xBA, 0x33)
#define REG_SC_BKBA_33_H      _PK_H_(0xBA, 0x33)
#define REG_SC_BKBA_34_L      _PK_L_(0xBA, 0x34)
#define REG_SC_BKBA_34_H      _PK_H_(0xBA, 0x34)
#define REG_SC_BKBA_35_L      _PK_L_(0xBA, 0x35)
#define REG_SC_BKBA_35_H      _PK_H_(0xBA, 0x35)
#define REG_SC_BKBA_36_L      _PK_L_(0xBA, 0x36)
#define REG_SC_BKBA_36_H      _PK_H_(0xBA, 0x36)
#define REG_SC_BKBA_37_L      _PK_L_(0xBA, 0x37)
#define REG_SC_BKBA_37_H      _PK_H_(0xBA, 0x37)
#define REG_SC_BKBA_38_L      _PK_L_(0xBA, 0x38)
#define REG_SC_BKBA_38_H      _PK_H_(0xBA, 0x38)
#define REG_SC_BKBA_39_L      _PK_L_(0xBA, 0x39)
#define REG_SC_BKBA_39_H      _PK_H_(0xBA, 0x39)
#define REG_SC_BKBA_3A_L      _PK_L_(0xBA, 0x3A)
#define REG_SC_BKBA_3A_H      _PK_H_(0xBA, 0x3A)
#define REG_SC_BKBA_3B_L      _PK_L_(0xBA, 0x3B)
#define REG_SC_BKBA_3B_H      _PK_H_(0xBA, 0x3B)
#define REG_SC_BKBA_3C_L      _PK_L_(0xBA, 0x3C)
#define REG_SC_BKBA_3C_H      _PK_H_(0xBA, 0x3C)
#define REG_SC_BKBA_3D_L      _PK_L_(0xBA, 0x3D)
#define REG_SC_BKBA_3D_H      _PK_H_(0xBA, 0x3D)
#define REG_SC_BKBA_3E_L      _PK_L_(0xBA, 0x3E)
#define REG_SC_BKBA_3E_H      _PK_H_(0xBA, 0x3E)
#define REG_SC_BKBA_3F_L      _PK_L_(0xBA, 0x3F)
#define REG_SC_BKBA_3F_H      _PK_H_(0xBA, 0x3F)
#define REG_SC_BKBA_40_L      _PK_L_(0xBA, 0x40)
#define REG_SC_BKBA_40_H      _PK_H_(0xBA, 0x40)
#define REG_SC_BKBA_41_L      _PK_L_(0xBA, 0x41)
#define REG_SC_BKBA_41_H      _PK_H_(0xBA, 0x41)
#define REG_SC_BKBA_42_L      _PK_L_(0xBA, 0x42)
#define REG_SC_BKBA_42_H      _PK_H_(0xBA, 0x42)
#define REG_SC_BKBA_43_L      _PK_L_(0xBA, 0x43)
#define REG_SC_BKBA_43_H      _PK_H_(0xBA, 0x43)
#define REG_SC_BKBA_44_L      _PK_L_(0xBA, 0x44)
#define REG_SC_BKBA_44_H      _PK_H_(0xBA, 0x44)
#define REG_SC_BKBA_45_L      _PK_L_(0xBA, 0x45)
#define REG_SC_BKBA_45_H      _PK_H_(0xBA, 0x45)
#define REG_SC_BKBA_46_L      _PK_L_(0xBA, 0x46)
#define REG_SC_BKBA_46_H      _PK_H_(0xBA, 0x46)
#define REG_SC_BKBA_47_L      _PK_L_(0xBA, 0x47)
#define REG_SC_BKBA_47_H      _PK_H_(0xBA, 0x47)
#define REG_SC_BKBA_48_L      _PK_L_(0xBA, 0x48)
#define REG_SC_BKBA_48_H      _PK_H_(0xBA, 0x48)
#define REG_SC_BKBA_49_L      _PK_L_(0xBA, 0x49)
#define REG_SC_BKBA_49_H      _PK_H_(0xBA, 0x49)
#define REG_SC_BKBA_4A_L      _PK_L_(0xBA, 0x4A)
#define REG_SC_BKBA_4A_H      _PK_H_(0xBA, 0x4A)
#define REG_SC_BKBA_4B_L      _PK_L_(0xBA, 0x4B)
#define REG_SC_BKBA_4B_H      _PK_H_(0xBA, 0x4B)
#define REG_SC_BKBA_4C_L      _PK_L_(0xBA, 0x4C)
#define REG_SC_BKBA_4C_H      _PK_H_(0xBA, 0x4C)
#define REG_SC_BKBA_4D_L      _PK_L_(0xBA, 0x4D)
#define REG_SC_BKBA_4D_H      _PK_H_(0xBA, 0x4D)
#define REG_SC_BKBA_4E_L      _PK_L_(0xBA, 0x4E)
#define REG_SC_BKBA_4E_H      _PK_H_(0xBA, 0x4E)
#define REG_SC_BKBA_4F_L      _PK_L_(0xBA, 0x4F)
#define REG_SC_BKBA_4F_H      _PK_H_(0xBA, 0x4F)
#define REG_SC_BKBA_50_L      _PK_L_(0xBA, 0x50)
#define REG_SC_BKBA_50_H      _PK_H_(0xBA, 0x50)
#define REG_SC_BKBA_51_L      _PK_L_(0xBA, 0x51)
#define REG_SC_BKBA_51_H      _PK_H_(0xBA, 0x51)
#define REG_SC_BKBA_52_L      _PK_L_(0xBA, 0x52)
#define REG_SC_BKBA_52_H      _PK_H_(0xBA, 0x52)
#define REG_SC_BKBA_53_L      _PK_L_(0xBA, 0x53)
#define REG_SC_BKBA_53_H      _PK_H_(0xBA, 0x53)
#define REG_SC_BKBA_54_L      _PK_L_(0xBA, 0x54)
#define REG_SC_BKBA_54_H      _PK_H_(0xBA, 0x54)
#define REG_SC_BKBA_55_L      _PK_L_(0xBA, 0x55)
#define REG_SC_BKBA_55_H      _PK_H_(0xBA, 0x55)
#define REG_SC_BKBA_56_L      _PK_L_(0xBA, 0x56)
#define REG_SC_BKBA_56_H      _PK_H_(0xBA, 0x56)
#define REG_SC_BKBA_57_L      _PK_L_(0xBA, 0x57)
#define REG_SC_BKBA_57_H      _PK_H_(0xBA, 0x57)
#define REG_SC_BKBA_58_L      _PK_L_(0xBA, 0x58)
#define REG_SC_BKBA_58_H      _PK_H_(0xBA, 0x58)
#define REG_SC_BKBA_59_L      _PK_L_(0xBA, 0x59)
#define REG_SC_BKBA_59_H      _PK_H_(0xBA, 0x59)
#define REG_SC_BKBA_5A_L      _PK_L_(0xBA, 0x5A)
#define REG_SC_BKBA_5A_H      _PK_H_(0xBA, 0x5A)
#define REG_SC_BKBA_5B_L      _PK_L_(0xBA, 0x5B)
#define REG_SC_BKBA_5B_H      _PK_H_(0xBA, 0x5B)
#define REG_SC_BKBA_5C_L      _PK_L_(0xBA, 0x5C)
#define REG_SC_BKBA_5C_H      _PK_H_(0xBA, 0x5C)
#define REG_SC_BKBA_5D_L      _PK_L_(0xBA, 0x5D)
#define REG_SC_BKBA_5D_H      _PK_H_(0xBA, 0x5D)
#define REG_SC_BKBA_5E_L      _PK_L_(0xBA, 0x5E)
#define REG_SC_BKBA_5E_H      _PK_H_(0xBA, 0x5E)
#define REG_SC_BKBA_5F_L      _PK_L_(0xBA, 0x5F)
#define REG_SC_BKBA_5F_H      _PK_H_(0xBA, 0x5F)
#define REG_SC_BKBA_60_L      _PK_L_(0xBA, 0x60)
#define REG_SC_BKBA_60_H      _PK_H_(0xBA, 0x60)
#define REG_SC_BKBA_61_L      _PK_L_(0xBA, 0x61)
#define REG_SC_BKBA_61_H      _PK_H_(0xBA, 0x61)
#define REG_SC_BKBA_62_L      _PK_L_(0xBA, 0x62)
#define REG_SC_BKBA_62_H      _PK_H_(0xBA, 0x62)
#define REG_SC_BKBA_63_L      _PK_L_(0xBA, 0x63)
#define REG_SC_BKBA_63_H      _PK_H_(0xBA, 0x63)
#define REG_SC_BKBA_64_L      _PK_L_(0xBA, 0x64)
#define REG_SC_BKBA_64_H      _PK_H_(0xBA, 0x64)
#define REG_SC_BKBA_65_L      _PK_L_(0xBA, 0x65)
#define REG_SC_BKBA_65_H      _PK_H_(0xBA, 0x65)
#define REG_SC_BKBA_66_L      _PK_L_(0xBA, 0x66)
#define REG_SC_BKBA_66_H      _PK_H_(0xBA, 0x66)
#define REG_SC_BKBA_67_L      _PK_L_(0xBA, 0x67)
#define REG_SC_BKBA_67_H      _PK_H_(0xBA, 0x67)
#define REG_SC_BKBA_68_L      _PK_L_(0xBA, 0x68)
#define REG_SC_BKBA_68_H      _PK_H_(0xBA, 0x68)
#define REG_SC_BKBA_69_L      _PK_L_(0xBA, 0x69)
#define REG_SC_BKBA_69_H      _PK_H_(0xBA, 0x69)
#define REG_SC_BKBA_6A_L      _PK_L_(0xBA, 0x6A)
#define REG_SC_BKBA_6A_H      _PK_H_(0xBA, 0x6A)
#define REG_SC_BKBA_6B_L      _PK_L_(0xBA, 0x6B)
#define REG_SC_BKBA_6B_H      _PK_H_(0xBA, 0x6B)
#define REG_SC_BKBA_6C_L      _PK_L_(0xBA, 0x6C)
#define REG_SC_BKBA_6C_H      _PK_H_(0xBA, 0x6C)
#define REG_SC_BKBA_6D_L      _PK_L_(0xBA, 0x6D)
#define REG_SC_BKBA_6D_H      _PK_H_(0xBA, 0x6D)
#define REG_SC_BKBA_6E_L      _PK_L_(0xBA, 0x6E)
#define REG_SC_BKBA_6E_H      _PK_H_(0xBA, 0x6E)
#define REG_SC_BKBA_6F_L      _PK_L_(0xBA, 0x6F)
#define REG_SC_BKBA_6F_H      _PK_H_(0xBA, 0x6F)
#define REG_SC_BKBA_70_L      _PK_L_(0xBA, 0x70)
#define REG_SC_BKBA_70_H      _PK_H_(0xBA, 0x70)
#define REG_SC_BKBA_71_L      _PK_L_(0xBA, 0x71)
#define REG_SC_BKBA_71_H      _PK_H_(0xBA, 0x71)
#define REG_SC_BKBA_72_L      _PK_L_(0xBA, 0x72)
#define REG_SC_BKBA_72_H      _PK_H_(0xBA, 0x72)
#define REG_SC_BKBA_73_L      _PK_L_(0xBA, 0x73)
#define REG_SC_BKBA_73_H      _PK_H_(0xBA, 0x73)
#define REG_SC_BKBA_74_L      _PK_L_(0xBA, 0x74)
#define REG_SC_BKBA_74_H      _PK_H_(0xBA, 0x74)
#define REG_SC_BKBA_75_L      _PK_L_(0xBA, 0x75)
#define REG_SC_BKBA_75_H      _PK_H_(0xBA, 0x75)
#define REG_SC_BKBA_76_L      _PK_L_(0xBA, 0x76)
#define REG_SC_BKBA_76_H      _PK_H_(0xBA, 0x76)
#define REG_SC_BKBA_77_L      _PK_L_(0xBA, 0x77)
#define REG_SC_BKBA_77_H      _PK_H_(0xBA, 0x77)
#define REG_SC_BKBA_78_L      _PK_L_(0xBA, 0x78)
#define REG_SC_BKBA_78_H      _PK_H_(0xBA, 0x78)
#define REG_SC_BKBA_79_L      _PK_L_(0xBA, 0x79)
#define REG_SC_BKBA_79_H      _PK_H_(0xBA, 0x79)
#define REG_SC_BKBA_7A_L      _PK_L_(0xBA, 0x7A)
#define REG_SC_BKBA_7A_H      _PK_H_(0xBA, 0x7A)
#define REG_SC_BKBA_7B_L      _PK_L_(0xBA, 0x7B)
#define REG_SC_BKBA_7B_H      _PK_H_(0xBA, 0x7B)
#define REG_SC_BKBA_7C_L      _PK_L_(0xBA, 0x7C)
#define REG_SC_BKBA_7C_H      _PK_H_(0xBA, 0x7C)
#define REG_SC_BKBA_7D_L      _PK_L_(0xBA, 0x7D)
#define REG_SC_BKBA_7D_H      _PK_H_(0xBA, 0x7D)
#define REG_SC_BKBA_7E_L      _PK_L_(0xBA, 0x7E)
#define REG_SC_BKBA_7E_H      _PK_H_(0xBA, 0x7E)
#define REG_SC_BKBA_7F_L      _PK_L_(0xBA, 0x7F)
#define REG_SC_BKBA_7F_H      _PK_H_(0xBA, 0x7F)
//----------------------------------------------
#define REG_SC_BKC7_00_L      _PK_L_(0xC7, 0x00)
#define REG_SC_BKC7_00_H      _PK_H_(0xC7, 0x00)
#define REG_SC_BKC7_01_L      _PK_L_(0xC7, 0x01)
#define REG_SC_BKC7_01_H      _PK_H_(0xC7, 0x01)
#define REG_SC_BKC7_02_L      _PK_L_(0xC7, 0x02)
#define REG_SC_BKC7_02_H      _PK_H_(0xC7, 0x02)
#define REG_SC_BKC7_03_L      _PK_L_(0xC7, 0x03)
#define REG_SC_BKC7_03_H      _PK_H_(0xC7, 0x03)
#define REG_SC_BKC7_04_L      _PK_L_(0xC7, 0x04)
#define REG_SC_BKC7_04_H      _PK_H_(0xC7, 0x04)
#define REG_SC_BKC7_05_L      _PK_L_(0xC7, 0x05)
#define REG_SC_BKC7_05_H      _PK_H_(0xC7, 0x05)
#define REG_SC_BKC7_06_L      _PK_L_(0xC7, 0x06)
#define REG_SC_BKC7_06_H      _PK_H_(0xC7, 0x06)
#define REG_SC_BKC7_07_L      _PK_L_(0xC7, 0x07)
#define REG_SC_BKC7_07_H      _PK_H_(0xC7, 0x07)
#define REG_SC_BKC7_08_L      _PK_L_(0xC7, 0x08)
#define REG_SC_BKC7_08_H      _PK_H_(0xC7, 0x08)
#define REG_SC_BKC7_09_L      _PK_L_(0xC7, 0x09)
#define REG_SC_BKC7_09_H      _PK_H_(0xC7, 0x09)
#define REG_SC_BKC7_0A_L      _PK_L_(0xC7, 0x0A)
#define REG_SC_BKC7_0A_H      _PK_H_(0xC7, 0x0A)
#define REG_SC_BKC7_0B_L      _PK_L_(0xC7, 0x0B)
#define REG_SC_BKC7_0B_H      _PK_H_(0xC7, 0x0B)
#define REG_SC_BKC7_0C_L      _PK_L_(0xC7, 0x0C)
#define REG_SC_BKC7_0C_H      _PK_H_(0xC7, 0x0C)
#define REG_SC_BKC7_0D_L      _PK_L_(0xC7, 0x0D)
#define REG_SC_BKC7_0D_H      _PK_H_(0xC7, 0x0D)
#define REG_SC_BKC7_0E_L      _PK_L_(0xC7, 0x0E)
#define REG_SC_BKC7_0E_H      _PK_H_(0xC7, 0x0E)
#define REG_SC_BKC7_0F_L      _PK_L_(0xC7, 0x0F)
#define REG_SC_BKC7_0F_H      _PK_H_(0xC7, 0x0F)
#define REG_SC_BKC7_10_L      _PK_L_(0xC7, 0x10)
#define REG_SC_BKC7_10_H      _PK_H_(0xC7, 0x10)
#define REG_SC_BKC7_11_L      _PK_L_(0xC7, 0x11)
#define REG_SC_BKC7_11_H      _PK_H_(0xC7, 0x11)
#define REG_SC_BKC7_12_L      _PK_L_(0xC7, 0x12)
#define REG_SC_BKC7_12_H      _PK_H_(0xC7, 0x12)
#define REG_SC_BKC7_13_L      _PK_L_(0xC7, 0x13)
#define REG_SC_BKC7_13_H      _PK_H_(0xC7, 0x13)
#define REG_SC_BKC7_14_L      _PK_L_(0xC7, 0x14)
#define REG_SC_BKC7_14_H      _PK_H_(0xC7, 0x14)
#define REG_SC_BKC7_15_L      _PK_L_(0xC7, 0x15)
#define REG_SC_BKC7_15_H      _PK_H_(0xC7, 0x15)
#define REG_SC_BKC7_16_L      _PK_L_(0xC7, 0x16)
#define REG_SC_BKC7_16_H      _PK_H_(0xC7, 0x16)
#define REG_SC_BKC7_17_L      _PK_L_(0xC7, 0x17)
#define REG_SC_BKC7_17_H      _PK_H_(0xC7, 0x17)
#define REG_SC_BKC7_18_L      _PK_L_(0xC7, 0x18)
#define REG_SC_BKC7_18_H      _PK_H_(0xC7, 0x18)
#define REG_SC_BKC7_19_L      _PK_L_(0xC7, 0x19)
#define REG_SC_BKC7_19_H      _PK_H_(0xC7, 0x19)
#define REG_SC_BKC7_1A_L      _PK_L_(0xC7, 0x1A)
#define REG_SC_BKC7_1A_H      _PK_H_(0xC7, 0x1A)
#define REG_SC_BKC7_1B_L      _PK_L_(0xC7, 0x1B)
#define REG_SC_BKC7_1B_H      _PK_H_(0xC7, 0x1B)
#define REG_SC_BKC7_1C_L      _PK_L_(0xC7, 0x1C)
#define REG_SC_BKC7_1C_H      _PK_H_(0xC7, 0x1C)
#define REG_SC_BKC7_1D_L      _PK_L_(0xC7, 0x1D)
#define REG_SC_BKC7_1D_H      _PK_H_(0xC7, 0x1D)
#define REG_SC_BKC7_1E_L      _PK_L_(0xC7, 0x1E)
#define REG_SC_BKC7_1E_H      _PK_H_(0xC7, 0x1E)
#define REG_SC_BKC7_1F_L      _PK_L_(0xC7, 0x1F)
#define REG_SC_BKC7_1F_H      _PK_H_(0xC7, 0x1F)
#define REG_SC_BKC7_20_L      _PK_L_(0xC7, 0x20)
#define REG_SC_BKC7_20_H      _PK_H_(0xC7, 0x20)
#define REG_SC_BKC7_21_L      _PK_L_(0xC7, 0x21)
#define REG_SC_BKC7_21_H      _PK_H_(0xC7, 0x21)
#define REG_SC_BKC7_22_L      _PK_L_(0xC7, 0x22)
#define REG_SC_BKC7_22_H      _PK_H_(0xC7, 0x22)
#define REG_SC_BKC7_23_L      _PK_L_(0xC7, 0x23)
#define REG_SC_BKC7_23_H      _PK_H_(0xC7, 0x23)
#define REG_SC_BKC7_24_L      _PK_L_(0xC7, 0x24)
#define REG_SC_BKC7_24_H      _PK_H_(0xC7, 0x24)
#define REG_SC_BKC7_25_L      _PK_L_(0xC7, 0x25)
#define REG_SC_BKC7_25_H      _PK_H_(0xC7, 0x25)
#define REG_SC_BKC7_26_L      _PK_L_(0xC7, 0x26)
#define REG_SC_BKC7_26_H      _PK_H_(0xC7, 0x26)
#define REG_SC_BKC7_27_L      _PK_L_(0xC7, 0x27)
#define REG_SC_BKC7_27_H      _PK_H_(0xC7, 0x27)
#define REG_SC_BKC7_28_L      _PK_L_(0xC7, 0x28)
#define REG_SC_BKC7_28_H      _PK_H_(0xC7, 0x28)
#define REG_SC_BKC7_29_L      _PK_L_(0xC7, 0x29)
#define REG_SC_BKC7_29_H      _PK_H_(0xC7, 0x29)
#define REG_SC_BKC7_2A_L      _PK_L_(0xC7, 0x2A)
#define REG_SC_BKC7_2A_H      _PK_H_(0xC7, 0x2A)
#define REG_SC_BKC7_2B_L      _PK_L_(0xC7, 0x2B)
#define REG_SC_BKC7_2B_H      _PK_H_(0xC7, 0x2B)
#define REG_SC_BKC7_2C_L      _PK_L_(0xC7, 0x2C)
#define REG_SC_BKC7_2C_H      _PK_H_(0xC7, 0x2C)
#define REG_SC_BKC7_2D_L      _PK_L_(0xC7, 0x2D)
#define REG_SC_BKC7_2D_H      _PK_H_(0xC7, 0x2D)
#define REG_SC_BKC7_2E_L      _PK_L_(0xC7, 0x2E)
#define REG_SC_BKC7_2E_H      _PK_H_(0xC7, 0x2E)
#define REG_SC_BKC7_2F_L      _PK_L_(0xC7, 0x2F)
#define REG_SC_BKC7_2F_H      _PK_H_(0xC7, 0x2F)
#define REG_SC_BKC7_30_L      _PK_L_(0xC7, 0x30)
#define REG_SC_BKC7_30_H      _PK_H_(0xC7, 0x30)
#define REG_SC_BKC7_31_L      _PK_L_(0xC7, 0x31)
#define REG_SC_BKC7_31_H      _PK_H_(0xC7, 0x31)
#define REG_SC_BKC7_32_L      _PK_L_(0xC7, 0x32)
#define REG_SC_BKC7_32_H      _PK_H_(0xC7, 0x32)
#define REG_SC_BKC7_33_L      _PK_L_(0xC7, 0x33)
#define REG_SC_BKC7_33_H      _PK_H_(0xC7, 0x33)
#define REG_SC_BKC7_34_L      _PK_L_(0xC7, 0x34)
#define REG_SC_BKC7_34_H      _PK_H_(0xC7, 0x34)
#define REG_SC_BKC7_35_L      _PK_L_(0xC7, 0x35)
#define REG_SC_BKC7_35_H      _PK_H_(0xC7, 0x35)
#define REG_SC_BKC7_36_L      _PK_L_(0xC7, 0x36)
#define REG_SC_BKC7_36_H      _PK_H_(0xC7, 0x36)
#define REG_SC_BKC7_37_L      _PK_L_(0xC7, 0x37)
#define REG_SC_BKC7_37_H      _PK_H_(0xC7, 0x37)
#define REG_SC_BKC7_38_L      _PK_L_(0xC7, 0x38)
#define REG_SC_BKC7_38_H      _PK_H_(0xC7, 0x38)
#define REG_SC_BKC7_39_L      _PK_L_(0xC7, 0x39)
#define REG_SC_BKC7_39_H      _PK_H_(0xC7, 0x39)
#define REG_SC_BKC7_3A_L      _PK_L_(0xC7, 0x3A)
#define REG_SC_BKC7_3A_H      _PK_H_(0xC7, 0x3A)
#define REG_SC_BKC7_3B_L      _PK_L_(0xC7, 0x3B)
#define REG_SC_BKC7_3B_H      _PK_H_(0xC7, 0x3B)
#define REG_SC_BKC7_3C_L      _PK_L_(0xC7, 0x3C)
#define REG_SC_BKC7_3C_H      _PK_H_(0xC7, 0x3C)
#define REG_SC_BKC7_3D_L      _PK_L_(0xC7, 0x3D)
#define REG_SC_BKC7_3D_H      _PK_H_(0xC7, 0x3D)
#define REG_SC_BKC7_3E_L      _PK_L_(0xC7, 0x3E)
#define REG_SC_BKC7_3E_H      _PK_H_(0xC7, 0x3E)
#define REG_SC_BKC7_3F_L      _PK_L_(0xC7, 0x3F)
#define REG_SC_BKC7_3F_H      _PK_H_(0xC7, 0x3F)
#define REG_SC_BKC7_40_L      _PK_L_(0xC7, 0x40)
#define REG_SC_BKC7_40_H      _PK_H_(0xC7, 0x40)
#define REG_SC_BKC7_41_L      _PK_L_(0xC7, 0x41)
#define REG_SC_BKC7_41_H      _PK_H_(0xC7, 0x41)
#define REG_SC_BKC7_42_L      _PK_L_(0xC7, 0x42)
#define REG_SC_BKC7_42_H      _PK_H_(0xC7, 0x42)
#define REG_SC_BKC7_43_L      _PK_L_(0xC7, 0x43)
#define REG_SC_BKC7_43_H      _PK_H_(0xC7, 0x43)
#define REG_SC_BKC7_44_L      _PK_L_(0xC7, 0x44)
#define REG_SC_BKC7_44_H      _PK_H_(0xC7, 0x44)
#define REG_SC_BKC7_45_L      _PK_L_(0xC7, 0x45)
#define REG_SC_BKC7_45_H      _PK_H_(0xC7, 0x45)
#define REG_SC_BKC7_46_L      _PK_L_(0xC7, 0x46)
#define REG_SC_BKC7_46_H      _PK_H_(0xC7, 0x46)
#define REG_SC_BKC7_47_L      _PK_L_(0xC7, 0x47)
#define REG_SC_BKC7_47_H      _PK_H_(0xC7, 0x47)
#define REG_SC_BKC7_48_L      _PK_L_(0xC7, 0x48)
#define REG_SC_BKC7_48_H      _PK_H_(0xC7, 0x48)
#define REG_SC_BKC7_49_L      _PK_L_(0xC7, 0x49)
#define REG_SC_BKC7_49_H      _PK_H_(0xC7, 0x49)
#define REG_SC_BKC7_4A_L      _PK_L_(0xC7, 0x4A)
#define REG_SC_BKC7_4A_H      _PK_H_(0xC7, 0x4A)
#define REG_SC_BKC7_4B_L      _PK_L_(0xC7, 0x4B)
#define REG_SC_BKC7_4B_H      _PK_H_(0xC7, 0x4B)
#define REG_SC_BKC7_4C_L      _PK_L_(0xC7, 0x4C)
#define REG_SC_BKC7_4C_H      _PK_H_(0xC7, 0x4C)
#define REG_SC_BKC7_4D_L      _PK_L_(0xC7, 0x4D)
#define REG_SC_BKC7_4D_H      _PK_H_(0xC7, 0x4D)
#define REG_SC_BKC7_4E_L      _PK_L_(0xC7, 0x4E)
#define REG_SC_BKC7_4E_H      _PK_H_(0xC7, 0x4E)
#define REG_SC_BKC7_4F_L      _PK_L_(0xC7, 0x4F)
#define REG_SC_BKC7_4F_H      _PK_H_(0xC7, 0x4F)
#define REG_SC_BKC7_50_L      _PK_L_(0xC7, 0x50)
#define REG_SC_BKC7_50_H      _PK_H_(0xC7, 0x50)
#define REG_SC_BKC7_51_L      _PK_L_(0xC7, 0x51)
#define REG_SC_BKC7_51_H      _PK_H_(0xC7, 0x51)
#define REG_SC_BKC7_52_L      _PK_L_(0xC7, 0x52)
#define REG_SC_BKC7_52_H      _PK_H_(0xC7, 0x52)
#define REG_SC_BKC7_53_L      _PK_L_(0xC7, 0x53)
#define REG_SC_BKC7_53_H      _PK_H_(0xC7, 0x53)
#define REG_SC_BKC7_54_L      _PK_L_(0xC7, 0x54)
#define REG_SC_BKC7_54_H      _PK_H_(0xC7, 0x54)
#define REG_SC_BKC7_55_L      _PK_L_(0xC7, 0x55)
#define REG_SC_BKC7_55_H      _PK_H_(0xC7, 0x55)
#define REG_SC_BKC7_56_L      _PK_L_(0xC7, 0x56)
#define REG_SC_BKC7_56_H      _PK_H_(0xC7, 0x56)
#define REG_SC_BKC7_57_L      _PK_L_(0xC7, 0x57)
#define REG_SC_BKC7_57_H      _PK_H_(0xC7, 0x57)
#define REG_SC_BKC7_58_L      _PK_L_(0xC7, 0x58)
#define REG_SC_BKC7_58_H      _PK_H_(0xC7, 0x58)
#define REG_SC_BKC7_59_L      _PK_L_(0xC7, 0x59)
#define REG_SC_BKC7_59_H      _PK_H_(0xC7, 0x59)
#define REG_SC_BKC7_5A_L      _PK_L_(0xC7, 0x5A)
#define REG_SC_BKC7_5A_H      _PK_H_(0xC7, 0x5A)
#define REG_SC_BKC7_5B_L      _PK_L_(0xC7, 0x5B)
#define REG_SC_BKC7_5B_H      _PK_H_(0xC7, 0x5B)
#define REG_SC_BKC7_5C_L      _PK_L_(0xC7, 0x5C)
#define REG_SC_BKC7_5C_H      _PK_H_(0xC7, 0x5C)
#define REG_SC_BKC7_5D_L      _PK_L_(0xC7, 0x5D)
#define REG_SC_BKC7_5D_H      _PK_H_(0xC7, 0x5D)
#define REG_SC_BKC7_5E_L      _PK_L_(0xC7, 0x5E)
#define REG_SC_BKC7_5E_H      _PK_H_(0xC7, 0x5E)
#define REG_SC_BKC7_5F_L      _PK_L_(0xC7, 0x5F)
#define REG_SC_BKC7_5F_H      _PK_H_(0xC7, 0x5F)
#define REG_SC_BKC7_60_L      _PK_L_(0xC7, 0x60)
#define REG_SC_BKC7_60_H      _PK_H_(0xC7, 0x60)
#define REG_SC_BKC7_61_L      _PK_L_(0xC7, 0x61)
#define REG_SC_BKC7_61_H      _PK_H_(0xC7, 0x61)
#define REG_SC_BKC7_62_L      _PK_L_(0xC7, 0x62)
#define REG_SC_BKC7_62_H      _PK_H_(0xC7, 0x62)
#define REG_SC_BKC7_63_L      _PK_L_(0xC7, 0x63)
#define REG_SC_BKC7_63_H      _PK_H_(0xC7, 0x63)
#define REG_SC_BKC7_64_L      _PK_L_(0xC7, 0x64)
#define REG_SC_BKC7_64_H      _PK_H_(0xC7, 0x64)
#define REG_SC_BKC7_65_L      _PK_L_(0xC7, 0x65)
#define REG_SC_BKC7_65_H      _PK_H_(0xC7, 0x65)
#define REG_SC_BKC7_66_L      _PK_L_(0xC7, 0x66)
#define REG_SC_BKC7_66_H      _PK_H_(0xC7, 0x66)
#define REG_SC_BKC7_67_L      _PK_L_(0xC7, 0x67)
#define REG_SC_BKC7_67_H      _PK_H_(0xC7, 0x67)
#define REG_SC_BKC7_68_L      _PK_L_(0xC7, 0x68)
#define REG_SC_BKC7_68_H      _PK_H_(0xC7, 0x68)
#define REG_SC_BKC7_69_L      _PK_L_(0xC7, 0x69)
#define REG_SC_BKC7_69_H      _PK_H_(0xC7, 0x69)
#define REG_SC_BKC7_6A_L      _PK_L_(0xC7, 0x6A)
#define REG_SC_BKC7_6A_H      _PK_H_(0xC7, 0x6A)
#define REG_SC_BKC7_6B_L      _PK_L_(0xC7, 0x6B)
#define REG_SC_BKC7_6B_H      _PK_H_(0xC7, 0x6B)
#define REG_SC_BKC7_6C_L      _PK_L_(0xC7, 0x6C)
#define REG_SC_BKC7_6C_H      _PK_H_(0xC7, 0x6C)
#define REG_SC_BKC7_6D_L      _PK_L_(0xC7, 0x6D)
#define REG_SC_BKC7_6D_H      _PK_H_(0xC7, 0x6D)
#define REG_SC_BKC7_6E_L      _PK_L_(0xC7, 0x6E)
#define REG_SC_BKC7_6E_H      _PK_H_(0xC7, 0x6E)
#define REG_SC_BKC7_6F_L      _PK_L_(0xC7, 0x6F)
#define REG_SC_BKC7_6F_H      _PK_H_(0xC7, 0x6F)
#define REG_SC_BKC7_70_L      _PK_L_(0xC7, 0x70)
#define REG_SC_BKC7_70_H      _PK_H_(0xC7, 0x70)
#define REG_SC_BKC7_71_L      _PK_L_(0xC7, 0x71)
#define REG_SC_BKC7_71_H      _PK_H_(0xC7, 0x71)
#define REG_SC_BKC7_72_L      _PK_L_(0xC7, 0x72)
#define REG_SC_BKC7_72_H      _PK_H_(0xC7, 0x72)
#define REG_SC_BKC7_73_L      _PK_L_(0xC7, 0x73)
#define REG_SC_BKC7_73_H      _PK_H_(0xC7, 0x73)
#define REG_SC_BKC7_74_L      _PK_L_(0xC7, 0x74)
#define REG_SC_BKC7_74_H      _PK_H_(0xC7, 0x74)
#define REG_SC_BKC7_75_L      _PK_L_(0xC7, 0x75)
#define REG_SC_BKC7_75_H      _PK_H_(0xC7, 0x75)
#define REG_SC_BKC7_76_L      _PK_L_(0xC7, 0x76)
#define REG_SC_BKC7_76_H      _PK_H_(0xC7, 0x76)
#define REG_SC_BKC7_77_L      _PK_L_(0xC7, 0x77)
#define REG_SC_BKC7_77_H      _PK_H_(0xC7, 0x77)
#define REG_SC_BKC7_78_L      _PK_L_(0xC7, 0x78)
#define REG_SC_BKC7_78_H      _PK_H_(0xC7, 0x78)
#define REG_SC_BKC7_79_L      _PK_L_(0xC7, 0x79)
#define REG_SC_BKC7_79_H      _PK_H_(0xC7, 0x79)
#define REG_SC_BKC7_7A_L      _PK_L_(0xC7, 0x7A)
#define REG_SC_BKC7_7A_H      _PK_H_(0xC7, 0x7A)
#define REG_SC_BKC7_7B_L      _PK_L_(0xC7, 0x7B)
#define REG_SC_BKC7_7B_H      _PK_H_(0xC7, 0x7B)
#define REG_SC_BKC7_7C_L      _PK_L_(0xC7, 0x7C)
#define REG_SC_BKC7_7C_H      _PK_H_(0xC7, 0x7C)
#define REG_SC_BKC7_7D_L      _PK_L_(0xC7, 0x7D)
#define REG_SC_BKC7_7D_H      _PK_H_(0xC7, 0x7D)
#define REG_SC_BKC7_7E_L      _PK_L_(0xC7, 0x7E)
#define REG_SC_BKC7_7E_H      _PK_H_(0xC7, 0x7E)
#define REG_SC_BKC7_7F_L      _PK_L_(0xC7, 0x7F)
#define REG_SC_BKC7_7F_H      _PK_H_(0xC7, 0x7F)
//----------------------------------------------
#define REG_SC_BKD7_00_L      _PK_L_(0xD7, 0x00)
#define REG_SC_BKD7_00_H      _PK_H_(0xD7, 0x00)
#define REG_SC_BKD7_01_L      _PK_L_(0xD7, 0x01)
#define REG_SC_BKD7_01_H      _PK_H_(0xD7, 0x01)
#define REG_SC_BKD7_02_L      _PK_L_(0xD7, 0x02)
#define REG_SC_BKD7_02_H      _PK_H_(0xD7, 0x02)
#define REG_SC_BKD7_03_L      _PK_L_(0xD7, 0x03)
#define REG_SC_BKD7_03_H      _PK_H_(0xD7, 0x03)
#define REG_SC_BKD7_04_L      _PK_L_(0xD7, 0x04)
#define REG_SC_BKD7_04_H      _PK_H_(0xD7, 0x04)
#define REG_SC_BKD7_05_L      _PK_L_(0xD7, 0x05)
#define REG_SC_BKD7_05_H      _PK_H_(0xD7, 0x05)
#define REG_SC_BKD7_06_L      _PK_L_(0xD7, 0x06)
#define REG_SC_BKD7_06_H      _PK_H_(0xD7, 0x06)
#define REG_SC_BKD7_07_L      _PK_L_(0xD7, 0x07)
#define REG_SC_BKD7_07_H      _PK_H_(0xD7, 0x07)
#define REG_SC_BKD7_08_L      _PK_L_(0xD7, 0x08)
#define REG_SC_BKD7_08_H      _PK_H_(0xD7, 0x08)
#define REG_SC_BKD7_09_L      _PK_L_(0xD7, 0x09)
#define REG_SC_BKD7_09_H      _PK_H_(0xD7, 0x09)
#define REG_SC_BKD7_0A_L      _PK_L_(0xD7, 0x0A)
#define REG_SC_BKD7_0A_H      _PK_H_(0xD7, 0x0A)
#define REG_SC_BKD7_0B_L      _PK_L_(0xD7, 0x0B)
#define REG_SC_BKD7_0B_H      _PK_H_(0xD7, 0x0B)
#define REG_SC_BKD7_0C_L      _PK_L_(0xD7, 0x0C)
#define REG_SC_BKD7_0C_H      _PK_H_(0xD7, 0x0C)
#define REG_SC_BKD7_0D_L      _PK_L_(0xD7, 0x0D)
#define REG_SC_BKD7_0D_H      _PK_H_(0xD7, 0x0D)
#define REG_SC_BKD7_0E_L      _PK_L_(0xD7, 0x0E)
#define REG_SC_BKD7_0E_H      _PK_H_(0xD7, 0x0E)
#define REG_SC_BKD7_0F_L      _PK_L_(0xD7, 0x0F)
#define REG_SC_BKD7_0F_H      _PK_H_(0xD7, 0x0F)
#define REG_SC_BKD7_10_L      _PK_L_(0xD7, 0x10)
#define REG_SC_BKD7_10_H      _PK_H_(0xD7, 0x10)
#define REG_SC_BKD7_11_L      _PK_L_(0xD7, 0x11)
#define REG_SC_BKD7_11_H      _PK_H_(0xD7, 0x11)
#define REG_SC_BKD7_12_L      _PK_L_(0xD7, 0x12)
#define REG_SC_BKD7_12_H      _PK_H_(0xD7, 0x12)
#define REG_SC_BKD7_13_L      _PK_L_(0xD7, 0x13)
#define REG_SC_BKD7_13_H      _PK_H_(0xD7, 0x13)
#define REG_SC_BKD7_14_L      _PK_L_(0xD7, 0x14)
#define REG_SC_BKD7_14_H      _PK_H_(0xD7, 0x14)
#define REG_SC_BKD7_15_L      _PK_L_(0xD7, 0x15)
#define REG_SC_BKD7_15_H      _PK_H_(0xD7, 0x15)
#define REG_SC_BKD7_16_L      _PK_L_(0xD7, 0x16)
#define REG_SC_BKD7_16_H      _PK_H_(0xD7, 0x16)
#define REG_SC_BKD7_17_L      _PK_L_(0xD7, 0x17)
#define REG_SC_BKD7_17_H      _PK_H_(0xD7, 0x17)
#define REG_SC_BKD7_18_L      _PK_L_(0xD7, 0x18)
#define REG_SC_BKD7_18_H      _PK_H_(0xD7, 0x18)
#define REG_SC_BKD7_19_L      _PK_L_(0xD7, 0x19)
#define REG_SC_BKD7_19_H      _PK_H_(0xD7, 0x19)
#define REG_SC_BKD7_1A_L      _PK_L_(0xD7, 0x1A)
#define REG_SC_BKD7_1A_H      _PK_H_(0xD7, 0x1A)
#define REG_SC_BKD7_1B_L      _PK_L_(0xD7, 0x1B)
#define REG_SC_BKD7_1B_H      _PK_H_(0xD7, 0x1B)
#define REG_SC_BKD7_1C_L      _PK_L_(0xD7, 0x1C)
#define REG_SC_BKD7_1C_H      _PK_H_(0xD7, 0x1C)
#define REG_SC_BKD7_1D_L      _PK_L_(0xD7, 0x1D)
#define REG_SC_BKD7_1D_H      _PK_H_(0xD7, 0x1D)
#define REG_SC_BKD7_1E_L      _PK_L_(0xD7, 0x1E)
#define REG_SC_BKD7_1E_H      _PK_H_(0xD7, 0x1E)
#define REG_SC_BKD7_1F_L      _PK_L_(0xD7, 0x1F)
#define REG_SC_BKD7_1F_H      _PK_H_(0xD7, 0x1F)
#define REG_SC_BKD7_20_L      _PK_L_(0xD7, 0x20)
#define REG_SC_BKD7_20_H      _PK_H_(0xD7, 0x20)
#define REG_SC_BKD7_21_L      _PK_L_(0xD7, 0x21)
#define REG_SC_BKD7_21_H      _PK_H_(0xD7, 0x21)
#define REG_SC_BKD7_22_L      _PK_L_(0xD7, 0x22)
#define REG_SC_BKD7_22_H      _PK_H_(0xD7, 0x22)
#define REG_SC_BKD7_23_L      _PK_L_(0xD7, 0x23)
#define REG_SC_BKD7_23_H      _PK_H_(0xD7, 0x23)
#define REG_SC_BKD7_24_L      _PK_L_(0xD7, 0x24)
#define REG_SC_BKD7_24_H      _PK_H_(0xD7, 0x24)
#define REG_SC_BKD7_25_L      _PK_L_(0xD7, 0x25)
#define REG_SC_BKD7_25_H      _PK_H_(0xD7, 0x25)
#define REG_SC_BKD7_26_L      _PK_L_(0xD7, 0x26)
#define REG_SC_BKD7_26_H      _PK_H_(0xD7, 0x26)
#define REG_SC_BKD7_27_L      _PK_L_(0xD7, 0x27)
#define REG_SC_BKD7_27_H      _PK_H_(0xD7, 0x27)
#define REG_SC_BKD7_28_L      _PK_L_(0xD7, 0x28)
#define REG_SC_BKD7_28_H      _PK_H_(0xD7, 0x28)
#define REG_SC_BKD7_29_L      _PK_L_(0xD7, 0x29)
#define REG_SC_BKD7_29_H      _PK_H_(0xD7, 0x29)
#define REG_SC_BKD7_2A_L      _PK_L_(0xD7, 0x2A)
#define REG_SC_BKD7_2A_H      _PK_H_(0xD7, 0x2A)
#define REG_SC_BKD7_2B_L      _PK_L_(0xD7, 0x2B)
#define REG_SC_BKD7_2B_H      _PK_H_(0xD7, 0x2B)
#define REG_SC_BKD7_2C_L      _PK_L_(0xD7, 0x2C)
#define REG_SC_BKD7_2C_H      _PK_H_(0xD7, 0x2C)
#define REG_SC_BKD7_2D_L      _PK_L_(0xD7, 0x2D)
#define REG_SC_BKD7_2D_H      _PK_H_(0xD7, 0x2D)
#define REG_SC_BKD7_2E_L      _PK_L_(0xD7, 0x2E)
#define REG_SC_BKD7_2E_H      _PK_H_(0xD7, 0x2E)
#define REG_SC_BKD7_2F_L      _PK_L_(0xD7, 0x2F)
#define REG_SC_BKD7_2F_H      _PK_H_(0xD7, 0x2F)
#define REG_SC_BKD7_30_L      _PK_L_(0xD7, 0x30)
#define REG_SC_BKD7_30_H      _PK_H_(0xD7, 0x30)
#define REG_SC_BKD7_31_L      _PK_L_(0xD7, 0x31)
#define REG_SC_BKD7_31_H      _PK_H_(0xD7, 0x31)
#define REG_SC_BKD7_32_L      _PK_L_(0xD7, 0x32)
#define REG_SC_BKD7_32_H      _PK_H_(0xD7, 0x32)
#define REG_SC_BKD7_33_L      _PK_L_(0xD7, 0x33)
#define REG_SC_BKD7_33_H      _PK_H_(0xD7, 0x33)
#define REG_SC_BKD7_34_L      _PK_L_(0xD7, 0x34)
#define REG_SC_BKD7_34_H      _PK_H_(0xD7, 0x34)
#define REG_SC_BKD7_35_L      _PK_L_(0xD7, 0x35)
#define REG_SC_BKD7_35_H      _PK_H_(0xD7, 0x35)
#define REG_SC_BKD7_36_L      _PK_L_(0xD7, 0x36)
#define REG_SC_BKD7_36_H      _PK_H_(0xD7, 0x36)
#define REG_SC_BKD7_37_L      _PK_L_(0xD7, 0x37)
#define REG_SC_BKD7_37_H      _PK_H_(0xD7, 0x37)
#define REG_SC_BKD7_38_L      _PK_L_(0xD7, 0x38)
#define REG_SC_BKD7_38_H      _PK_H_(0xD7, 0x38)
#define REG_SC_BKD7_39_L      _PK_L_(0xD7, 0x39)
#define REG_SC_BKD7_39_H      _PK_H_(0xD7, 0x39)
#define REG_SC_BKD7_3A_L      _PK_L_(0xD7, 0x3A)
#define REG_SC_BKD7_3A_H      _PK_H_(0xD7, 0x3A)
#define REG_SC_BKD7_3B_L      _PK_L_(0xD7, 0x3B)
#define REG_SC_BKD7_3B_H      _PK_H_(0xD7, 0x3B)
#define REG_SC_BKD7_3C_L      _PK_L_(0xD7, 0x3C)
#define REG_SC_BKD7_3C_H      _PK_H_(0xD7, 0x3C)
#define REG_SC_BKD7_3D_L      _PK_L_(0xD7, 0x3D)
#define REG_SC_BKD7_3D_H      _PK_H_(0xD7, 0x3D)
#define REG_SC_BKD7_3E_L      _PK_L_(0xD7, 0x3E)
#define REG_SC_BKD7_3E_H      _PK_H_(0xD7, 0x3E)
#define REG_SC_BKD7_3F_L      _PK_L_(0xD7, 0x3F)
#define REG_SC_BKD7_3F_H      _PK_H_(0xD7, 0x3F)
#define REG_SC_BKD7_40_L      _PK_L_(0xD7, 0x40)
#define REG_SC_BKD7_40_H      _PK_H_(0xD7, 0x40)
#define REG_SC_BKD7_41_L      _PK_L_(0xD7, 0x41)
#define REG_SC_BKD7_41_H      _PK_H_(0xD7, 0x41)
#define REG_SC_BKD7_42_L      _PK_L_(0xD7, 0x42)
#define REG_SC_BKD7_42_H      _PK_H_(0xD7, 0x42)
#define REG_SC_BKD7_43_L      _PK_L_(0xD7, 0x43)
#define REG_SC_BKD7_43_H      _PK_H_(0xD7, 0x43)
#define REG_SC_BKD7_44_L      _PK_L_(0xD7, 0x44)
#define REG_SC_BKD7_44_H      _PK_H_(0xD7, 0x44)
#define REG_SC_BKD7_45_L      _PK_L_(0xD7, 0x45)
#define REG_SC_BKD7_45_H      _PK_H_(0xD7, 0x45)
#define REG_SC_BKD7_46_L      _PK_L_(0xD7, 0x46)
#define REG_SC_BKD7_46_H      _PK_H_(0xD7, 0x46)
#define REG_SC_BKD7_47_L      _PK_L_(0xD7, 0x47)
#define REG_SC_BKD7_47_H      _PK_H_(0xD7, 0x47)
#define REG_SC_BKD7_48_L      _PK_L_(0xD7, 0x48)
#define REG_SC_BKD7_48_H      _PK_H_(0xD7, 0x48)
#define REG_SC_BKD7_49_L      _PK_L_(0xD7, 0x49)
#define REG_SC_BKD7_49_H      _PK_H_(0xD7, 0x49)
#define REG_SC_BKD7_4A_L      _PK_L_(0xD7, 0x4A)
#define REG_SC_BKD7_4A_H      _PK_H_(0xD7, 0x4A)
#define REG_SC_BKD7_4B_L      _PK_L_(0xD7, 0x4B)
#define REG_SC_BKD7_4B_H      _PK_H_(0xD7, 0x4B)
#define REG_SC_BKD7_4C_L      _PK_L_(0xD7, 0x4C)
#define REG_SC_BKD7_4C_H      _PK_H_(0xD7, 0x4C)
#define REG_SC_BKD7_4D_L      _PK_L_(0xD7, 0x4D)
#define REG_SC_BKD7_4D_H      _PK_H_(0xD7, 0x4D)
#define REG_SC_BKD7_4E_L      _PK_L_(0xD7, 0x4E)
#define REG_SC_BKD7_4E_H      _PK_H_(0xD7, 0x4E)
#define REG_SC_BKD7_4F_L      _PK_L_(0xD7, 0x4F)
#define REG_SC_BKD7_4F_H      _PK_H_(0xD7, 0x4F)
#define REG_SC_BKD7_50_L      _PK_L_(0xD7, 0x50)
#define REG_SC_BKD7_50_H      _PK_H_(0xD7, 0x50)
#define REG_SC_BKD7_51_L      _PK_L_(0xD7, 0x51)
#define REG_SC_BKD7_51_H      _PK_H_(0xD7, 0x51)
#define REG_SC_BKD7_52_L      _PK_L_(0xD7, 0x52)
#define REG_SC_BKD7_52_H      _PK_H_(0xD7, 0x52)
#define REG_SC_BKD7_53_L      _PK_L_(0xD7, 0x53)
#define REG_SC_BKD7_53_H      _PK_H_(0xD7, 0x53)
#define REG_SC_BKD7_54_L      _PK_L_(0xD7, 0x54)
#define REG_SC_BKD7_54_H      _PK_H_(0xD7, 0x54)
#define REG_SC_BKD7_55_L      _PK_L_(0xD7, 0x55)
#define REG_SC_BKD7_55_H      _PK_H_(0xD7, 0x55)
#define REG_SC_BKD7_56_L      _PK_L_(0xD7, 0x56)
#define REG_SC_BKD7_56_H      _PK_H_(0xD7, 0x56)
#define REG_SC_BKD7_57_L      _PK_L_(0xD7, 0x57)
#define REG_SC_BKD7_57_H      _PK_H_(0xD7, 0x57)
#define REG_SC_BKD7_58_L      _PK_L_(0xD7, 0x58)
#define REG_SC_BKD7_58_H      _PK_H_(0xD7, 0x58)
#define REG_SC_BKD7_59_L      _PK_L_(0xD7, 0x59)
#define REG_SC_BKD7_59_H      _PK_H_(0xD7, 0x59)
#define REG_SC_BKD7_5A_L      _PK_L_(0xD7, 0x5A)
#define REG_SC_BKD7_5A_H      _PK_H_(0xD7, 0x5A)
#define REG_SC_BKD7_5B_L      _PK_L_(0xD7, 0x5B)
#define REG_SC_BKD7_5B_H      _PK_H_(0xD7, 0x5B)
#define REG_SC_BKD7_5C_L      _PK_L_(0xD7, 0x5C)
#define REG_SC_BKD7_5C_H      _PK_H_(0xD7, 0x5C)
#define REG_SC_BKD7_5D_L      _PK_L_(0xD7, 0x5D)
#define REG_SC_BKD7_5D_H      _PK_H_(0xD7, 0x5D)
#define REG_SC_BKD7_5E_L      _PK_L_(0xD7, 0x5E)
#define REG_SC_BKD7_5E_H      _PK_H_(0xD7, 0x5E)
#define REG_SC_BKD7_5F_L      _PK_L_(0xD7, 0x5F)
#define REG_SC_BKD7_5F_H      _PK_H_(0xD7, 0x5F)
#define REG_SC_BKD7_60_L      _PK_L_(0xD7, 0x60)
#define REG_SC_BKD7_60_H      _PK_H_(0xD7, 0x60)
#define REG_SC_BKD7_61_L      _PK_L_(0xD7, 0x61)
#define REG_SC_BKD7_61_H      _PK_H_(0xD7, 0x61)
#define REG_SC_BKD7_62_L      _PK_L_(0xD7, 0x62)
#define REG_SC_BKD7_62_H      _PK_H_(0xD7, 0x62)
#define REG_SC_BKD7_63_L      _PK_L_(0xD7, 0x63)
#define REG_SC_BKD7_63_H      _PK_H_(0xD7, 0x63)
#define REG_SC_BKD7_64_L      _PK_L_(0xD7, 0x64)
#define REG_SC_BKD7_64_H      _PK_H_(0xD7, 0x64)
#define REG_SC_BKD7_65_L      _PK_L_(0xD7, 0x65)
#define REG_SC_BKD7_65_H      _PK_H_(0xD7, 0x65)
#define REG_SC_BKD7_66_L      _PK_L_(0xD7, 0x66)
#define REG_SC_BKD7_66_H      _PK_H_(0xD7, 0x66)
#define REG_SC_BKD7_67_L      _PK_L_(0xD7, 0x67)
#define REG_SC_BKD7_67_H      _PK_H_(0xD7, 0x67)
#define REG_SC_BKD7_68_L      _PK_L_(0xD7, 0x68)
#define REG_SC_BKD7_68_H      _PK_H_(0xD7, 0x68)
#define REG_SC_BKD7_69_L      _PK_L_(0xD7, 0x69)
#define REG_SC_BKD7_69_H      _PK_H_(0xD7, 0x69)
#define REG_SC_BKD7_6A_L      _PK_L_(0xD7, 0x6A)
#define REG_SC_BKD7_6A_H      _PK_H_(0xD7, 0x6A)
#define REG_SC_BKD7_6B_L      _PK_L_(0xD7, 0x6B)
#define REG_SC_BKD7_6B_H      _PK_H_(0xD7, 0x6B)
#define REG_SC_BKD7_6C_L      _PK_L_(0xD7, 0x6C)
#define REG_SC_BKD7_6C_H      _PK_H_(0xD7, 0x6C)
#define REG_SC_BKD7_6D_L      _PK_L_(0xD7, 0x6D)
#define REG_SC_BKD7_6D_H      _PK_H_(0xD7, 0x6D)
#define REG_SC_BKD7_6E_L      _PK_L_(0xD7, 0x6E)
#define REG_SC_BKD7_6E_H      _PK_H_(0xD7, 0x6E)
#define REG_SC_BKD7_6F_L      _PK_L_(0xD7, 0x6F)
#define REG_SC_BKD7_6F_H      _PK_H_(0xD7, 0x6F)
#define REG_SC_BKD7_70_L      _PK_L_(0xD7, 0x70)
#define REG_SC_BKD7_70_H      _PK_H_(0xD7, 0x70)
#define REG_SC_BKD7_71_L      _PK_L_(0xD7, 0x71)
#define REG_SC_BKD7_71_H      _PK_H_(0xD7, 0x71)
#define REG_SC_BKD7_72_L      _PK_L_(0xD7, 0x72)
#define REG_SC_BKD7_72_H      _PK_H_(0xD7, 0x72)
#define REG_SC_BKD7_73_L      _PK_L_(0xD7, 0x73)
#define REG_SC_BKD7_73_H      _PK_H_(0xD7, 0x73)
#define REG_SC_BKD7_74_L      _PK_L_(0xD7, 0x74)
#define REG_SC_BKD7_74_H      _PK_H_(0xD7, 0x74)
#define REG_SC_BKD7_75_L      _PK_L_(0xD7, 0x75)
#define REG_SC_BKD7_75_H      _PK_H_(0xD7, 0x75)
#define REG_SC_BKD7_76_L      _PK_L_(0xD7, 0x76)
#define REG_SC_BKD7_76_H      _PK_H_(0xD7, 0x76)
#define REG_SC_BKD7_77_L      _PK_L_(0xD7, 0x77)
#define REG_SC_BKD7_77_H      _PK_H_(0xD7, 0x77)
#define REG_SC_BKD7_78_L      _PK_L_(0xD7, 0x78)
#define REG_SC_BKD7_78_H      _PK_H_(0xD7, 0x78)
#define REG_SC_BKD7_79_L      _PK_L_(0xD7, 0x79)
#define REG_SC_BKD7_79_H      _PK_H_(0xD7, 0x79)
#define REG_SC_BKD7_7A_L      _PK_L_(0xD7, 0x7A)
#define REG_SC_BKD7_7A_H      _PK_H_(0xD7, 0x7A)
#define REG_SC_BKD7_7B_L      _PK_L_(0xD7, 0x7B)
#define REG_SC_BKD7_7B_H      _PK_H_(0xD7, 0x7B)
#define REG_SC_BKD7_7C_L      _PK_L_(0xD7, 0x7C)
#define REG_SC_BKD7_7C_H      _PK_H_(0xD7, 0x7C)
#define REG_SC_BKD7_7D_L      _PK_L_(0xD7, 0x7D)
#define REG_SC_BKD7_7D_H      _PK_H_(0xD7, 0x7D)
#define REG_SC_BKD7_7E_L      _PK_L_(0xD7, 0x7E)
#define REG_SC_BKD7_7E_H      _PK_H_(0xD7, 0x7E)
#define REG_SC_BKD7_7F_L      _PK_L_(0xD7, 0x7F)
#define REG_SC_BKD7_7F_H      _PK_H_(0xD7, 0x7F)
//----------------------------------------------
#define REG_SC_BKD8_00_L      _PK_L_(0xD8, 0x00)
#define REG_SC_BKD8_00_H      _PK_H_(0xD8, 0x00)
#define REG_SC_BKD8_01_L      _PK_L_(0xD8, 0x01)
#define REG_SC_BKD8_01_H      _PK_H_(0xD8, 0x01)
#define REG_SC_BKD8_02_L      _PK_L_(0xD8, 0x02)
#define REG_SC_BKD8_02_H      _PK_H_(0xD8, 0x02)
#define REG_SC_BKD8_03_L      _PK_L_(0xD8, 0x03)
#define REG_SC_BKD8_03_H      _PK_H_(0xD8, 0x03)
#define REG_SC_BKD8_04_L      _PK_L_(0xD8, 0x04)
#define REG_SC_BKD8_04_H      _PK_H_(0xD8, 0x04)
#define REG_SC_BKD8_05_L      _PK_L_(0xD8, 0x05)
#define REG_SC_BKD8_05_H      _PK_H_(0xD8, 0x05)
#define REG_SC_BKD8_06_L      _PK_L_(0xD8, 0x06)
#define REG_SC_BKD8_06_H      _PK_H_(0xD8, 0x06)
#define REG_SC_BKD8_07_L      _PK_L_(0xD8, 0x07)
#define REG_SC_BKD8_07_H      _PK_H_(0xD8, 0x07)
#define REG_SC_BKD8_08_L      _PK_L_(0xD8, 0x08)
#define REG_SC_BKD8_08_H      _PK_H_(0xD8, 0x08)
#define REG_SC_BKD8_09_L      _PK_L_(0xD8, 0x09)
#define REG_SC_BKD8_09_H      _PK_H_(0xD8, 0x09)
#define REG_SC_BKD8_0A_L      _PK_L_(0xD8, 0x0A)
#define REG_SC_BKD8_0A_H      _PK_H_(0xD8, 0x0A)
#define REG_SC_BKD8_0B_L      _PK_L_(0xD8, 0x0B)
#define REG_SC_BKD8_0B_H      _PK_H_(0xD8, 0x0B)
#define REG_SC_BKD8_0C_L      _PK_L_(0xD8, 0x0C)
#define REG_SC_BKD8_0C_H      _PK_H_(0xD8, 0x0C)
#define REG_SC_BKD8_0D_L      _PK_L_(0xD8, 0x0D)
#define REG_SC_BKD8_0D_H      _PK_H_(0xD8, 0x0D)
#define REG_SC_BKD8_0E_L      _PK_L_(0xD8, 0x0E)
#define REG_SC_BKD8_0E_H      _PK_H_(0xD8, 0x0E)
#define REG_SC_BKD8_0F_L      _PK_L_(0xD8, 0x0F)
#define REG_SC_BKD8_0F_H      _PK_H_(0xD8, 0x0F)
#define REG_SC_BKD8_10_L      _PK_L_(0xD8, 0x10)
#define REG_SC_BKD8_10_H      _PK_H_(0xD8, 0x10)
#define REG_SC_BKD8_11_L      _PK_L_(0xD8, 0x11)
#define REG_SC_BKD8_11_H      _PK_H_(0xD8, 0x11)
#define REG_SC_BKD8_12_L      _PK_L_(0xD8, 0x12)
#define REG_SC_BKD8_12_H      _PK_H_(0xD8, 0x12)
#define REG_SC_BKD8_13_L      _PK_L_(0xD8, 0x13)
#define REG_SC_BKD8_13_H      _PK_H_(0xD8, 0x13)
#define REG_SC_BKD8_14_L      _PK_L_(0xD8, 0x14)
#define REG_SC_BKD8_14_H      _PK_H_(0xD8, 0x14)
#define REG_SC_BKD8_15_L      _PK_L_(0xD8, 0x15)
#define REG_SC_BKD8_15_H      _PK_H_(0xD8, 0x15)
#define REG_SC_BKD8_16_L      _PK_L_(0xD8, 0x16)
#define REG_SC_BKD8_16_H      _PK_H_(0xD8, 0x16)
#define REG_SC_BKD8_17_L      _PK_L_(0xD8, 0x17)
#define REG_SC_BKD8_17_H      _PK_H_(0xD8, 0x17)
#define REG_SC_BKD8_18_L      _PK_L_(0xD8, 0x18)
#define REG_SC_BKD8_18_H      _PK_H_(0xD8, 0x18)
#define REG_SC_BKD8_19_L      _PK_L_(0xD8, 0x19)
#define REG_SC_BKD8_19_H      _PK_H_(0xD8, 0x19)
#define REG_SC_BKD8_1A_L      _PK_L_(0xD8, 0x1A)
#define REG_SC_BKD8_1A_H      _PK_H_(0xD8, 0x1A)
#define REG_SC_BKD8_1B_L      _PK_L_(0xD8, 0x1B)
#define REG_SC_BKD8_1B_H      _PK_H_(0xD8, 0x1B)
#define REG_SC_BKD8_1C_L      _PK_L_(0xD8, 0x1C)
#define REG_SC_BKD8_1C_H      _PK_H_(0xD8, 0x1C)
#define REG_SC_BKD8_1D_L      _PK_L_(0xD8, 0x1D)
#define REG_SC_BKD8_1D_H      _PK_H_(0xD8, 0x1D)
#define REG_SC_BKD8_1E_L      _PK_L_(0xD8, 0x1E)
#define REG_SC_BKD8_1E_H      _PK_H_(0xD8, 0x1E)
#define REG_SC_BKD8_1F_L      _PK_L_(0xD8, 0x1F)
#define REG_SC_BKD8_1F_H      _PK_H_(0xD8, 0x1F)
#define REG_SC_BKD8_20_L      _PK_L_(0xD8, 0x20)
#define REG_SC_BKD8_20_H      _PK_H_(0xD8, 0x20)
#define REG_SC_BKD8_21_L      _PK_L_(0xD8, 0x21)
#define REG_SC_BKD8_21_H      _PK_H_(0xD8, 0x21)
#define REG_SC_BKD8_22_L      _PK_L_(0xD8, 0x22)
#define REG_SC_BKD8_22_H      _PK_H_(0xD8, 0x22)
#define REG_SC_BKD8_23_L      _PK_L_(0xD8, 0x23)
#define REG_SC_BKD8_23_H      _PK_H_(0xD8, 0x23)
#define REG_SC_BKD8_24_L      _PK_L_(0xD8, 0x24)
#define REG_SC_BKD8_24_H      _PK_H_(0xD8, 0x24)
#define REG_SC_BKD8_25_L      _PK_L_(0xD8, 0x25)
#define REG_SC_BKD8_25_H      _PK_H_(0xD8, 0x25)
#define REG_SC_BKD8_26_L      _PK_L_(0xD8, 0x26)
#define REG_SC_BKD8_26_H      _PK_H_(0xD8, 0x26)
#define REG_SC_BKD8_27_L      _PK_L_(0xD8, 0x27)
#define REG_SC_BKD8_27_H      _PK_H_(0xD8, 0x27)
#define REG_SC_BKD8_28_L      _PK_L_(0xD8, 0x28)
#define REG_SC_BKD8_28_H      _PK_H_(0xD8, 0x28)
#define REG_SC_BKD8_29_L      _PK_L_(0xD8, 0x29)
#define REG_SC_BKD8_29_H      _PK_H_(0xD8, 0x29)
#define REG_SC_BKD8_2A_L      _PK_L_(0xD8, 0x2A)
#define REG_SC_BKD8_2A_H      _PK_H_(0xD8, 0x2A)
#define REG_SC_BKD8_2B_L      _PK_L_(0xD8, 0x2B)
#define REG_SC_BKD8_2B_H      _PK_H_(0xD8, 0x2B)
#define REG_SC_BKD8_2C_L      _PK_L_(0xD8, 0x2C)
#define REG_SC_BKD8_2C_H      _PK_H_(0xD8, 0x2C)
#define REG_SC_BKD8_2D_L      _PK_L_(0xD8, 0x2D)
#define REG_SC_BKD8_2D_H      _PK_H_(0xD8, 0x2D)
#define REG_SC_BKD8_2E_L      _PK_L_(0xD8, 0x2E)
#define REG_SC_BKD8_2E_H      _PK_H_(0xD8, 0x2E)
#define REG_SC_BKD8_2F_L      _PK_L_(0xD8, 0x2F)
#define REG_SC_BKD8_2F_H      _PK_H_(0xD8, 0x2F)
#define REG_SC_BKD8_30_L      _PK_L_(0xD8, 0x30)
#define REG_SC_BKD8_30_H      _PK_H_(0xD8, 0x30)
#define REG_SC_BKD8_31_L      _PK_L_(0xD8, 0x31)
#define REG_SC_BKD8_31_H      _PK_H_(0xD8, 0x31)
#define REG_SC_BKD8_32_L      _PK_L_(0xD8, 0x32)
#define REG_SC_BKD8_32_H      _PK_H_(0xD8, 0x32)
#define REG_SC_BKD8_33_L      _PK_L_(0xD8, 0x33)
#define REG_SC_BKD8_33_H      _PK_H_(0xD8, 0x33)
#define REG_SC_BKD8_34_L      _PK_L_(0xD8, 0x34)
#define REG_SC_BKD8_34_H      _PK_H_(0xD8, 0x34)
#define REG_SC_BKD8_35_L      _PK_L_(0xD8, 0x35)
#define REG_SC_BKD8_35_H      _PK_H_(0xD8, 0x35)
#define REG_SC_BKD8_36_L      _PK_L_(0xD8, 0x36)
#define REG_SC_BKD8_36_H      _PK_H_(0xD8, 0x36)
#define REG_SC_BKD8_37_L      _PK_L_(0xD8, 0x37)
#define REG_SC_BKD8_37_H      _PK_H_(0xD8, 0x37)
#define REG_SC_BKD8_38_L      _PK_L_(0xD8, 0x38)
#define REG_SC_BKD8_38_H      _PK_H_(0xD8, 0x38)
#define REG_SC_BKD8_39_L      _PK_L_(0xD8, 0x39)
#define REG_SC_BKD8_39_H      _PK_H_(0xD8, 0x39)
#define REG_SC_BKD8_3A_L      _PK_L_(0xD8, 0x3A)
#define REG_SC_BKD8_3A_H      _PK_H_(0xD8, 0x3A)
#define REG_SC_BKD8_3B_L      _PK_L_(0xD8, 0x3B)
#define REG_SC_BKD8_3B_H      _PK_H_(0xD8, 0x3B)
#define REG_SC_BKD8_3C_L      _PK_L_(0xD8, 0x3C)
#define REG_SC_BKD8_3C_H      _PK_H_(0xD8, 0x3C)
#define REG_SC_BKD8_3D_L      _PK_L_(0xD8, 0x3D)
#define REG_SC_BKD8_3D_H      _PK_H_(0xD8, 0x3D)
#define REG_SC_BKD8_3E_L      _PK_L_(0xD8, 0x3E)
#define REG_SC_BKD8_3E_H      _PK_H_(0xD8, 0x3E)
#define REG_SC_BKD8_3F_L      _PK_L_(0xD8, 0x3F)
#define REG_SC_BKD8_3F_H      _PK_H_(0xD8, 0x3F)
#define REG_SC_BKD8_40_L      _PK_L_(0xD8, 0x40)
#define REG_SC_BKD8_40_H      _PK_H_(0xD8, 0x40)
#define REG_SC_BKD8_41_L      _PK_L_(0xD8, 0x41)
#define REG_SC_BKD8_41_H      _PK_H_(0xD8, 0x41)
#define REG_SC_BKD8_42_L      _PK_L_(0xD8, 0x42)
#define REG_SC_BKD8_42_H      _PK_H_(0xD8, 0x42)
#define REG_SC_BKD8_43_L      _PK_L_(0xD8, 0x43)
#define REG_SC_BKD8_43_H      _PK_H_(0xD8, 0x43)
#define REG_SC_BKD8_44_L      _PK_L_(0xD8, 0x44)
#define REG_SC_BKD8_44_H      _PK_H_(0xD8, 0x44)
#define REG_SC_BKD8_45_L      _PK_L_(0xD8, 0x45)
#define REG_SC_BKD8_45_H      _PK_H_(0xD8, 0x45)
#define REG_SC_BKD8_46_L      _PK_L_(0xD8, 0x46)
#define REG_SC_BKD8_46_H      _PK_H_(0xD8, 0x46)
#define REG_SC_BKD8_47_L      _PK_L_(0xD8, 0x47)
#define REG_SC_BKD8_47_H      _PK_H_(0xD8, 0x47)
#define REG_SC_BKD8_48_L      _PK_L_(0xD8, 0x48)
#define REG_SC_BKD8_48_H      _PK_H_(0xD8, 0x48)
#define REG_SC_BKD8_49_L      _PK_L_(0xD8, 0x49)
#define REG_SC_BKD8_49_H      _PK_H_(0xD8, 0x49)
#define REG_SC_BKD8_4A_L      _PK_L_(0xD8, 0x4A)
#define REG_SC_BKD8_4A_H      _PK_H_(0xD8, 0x4A)
#define REG_SC_BKD8_4B_L      _PK_L_(0xD8, 0x4B)
#define REG_SC_BKD8_4B_H      _PK_H_(0xD8, 0x4B)
#define REG_SC_BKD8_4C_L      _PK_L_(0xD8, 0x4C)
#define REG_SC_BKD8_4C_H      _PK_H_(0xD8, 0x4C)
#define REG_SC_BKD8_4D_L      _PK_L_(0xD8, 0x4D)
#define REG_SC_BKD8_4D_H      _PK_H_(0xD8, 0x4D)
#define REG_SC_BKD8_4E_L      _PK_L_(0xD8, 0x4E)
#define REG_SC_BKD8_4E_H      _PK_H_(0xD8, 0x4E)
#define REG_SC_BKD8_4F_L      _PK_L_(0xD8, 0x4F)
#define REG_SC_BKD8_4F_H      _PK_H_(0xD8, 0x4F)
#define REG_SC_BKD8_50_L      _PK_L_(0xD8, 0x50)
#define REG_SC_BKD8_50_H      _PK_H_(0xD8, 0x50)
#define REG_SC_BKD8_51_L      _PK_L_(0xD8, 0x51)
#define REG_SC_BKD8_51_H      _PK_H_(0xD8, 0x51)
#define REG_SC_BKD8_52_L      _PK_L_(0xD8, 0x52)
#define REG_SC_BKD8_52_H      _PK_H_(0xD8, 0x52)
#define REG_SC_BKD8_53_L      _PK_L_(0xD8, 0x53)
#define REG_SC_BKD8_53_H      _PK_H_(0xD8, 0x53)
#define REG_SC_BKD8_54_L      _PK_L_(0xD8, 0x54)
#define REG_SC_BKD8_54_H      _PK_H_(0xD8, 0x54)
#define REG_SC_BKD8_55_L      _PK_L_(0xD8, 0x55)
#define REG_SC_BKD8_55_H      _PK_H_(0xD8, 0x55)
#define REG_SC_BKD8_56_L      _PK_L_(0xD8, 0x56)
#define REG_SC_BKD8_56_H      _PK_H_(0xD8, 0x56)
#define REG_SC_BKD8_57_L      _PK_L_(0xD8, 0x57)
#define REG_SC_BKD8_57_H      _PK_H_(0xD8, 0x57)
#define REG_SC_BKD8_58_L      _PK_L_(0xD8, 0x58)
#define REG_SC_BKD8_58_H      _PK_H_(0xD8, 0x58)
#define REG_SC_BKD8_59_L      _PK_L_(0xD8, 0x59)
#define REG_SC_BKD8_59_H      _PK_H_(0xD8, 0x59)
#define REG_SC_BKD8_5A_L      _PK_L_(0xD8, 0x5A)
#define REG_SC_BKD8_5A_H      _PK_H_(0xD8, 0x5A)
#define REG_SC_BKD8_5B_L      _PK_L_(0xD8, 0x5B)
#define REG_SC_BKD8_5B_H      _PK_H_(0xD8, 0x5B)
#define REG_SC_BKD8_5C_L      _PK_L_(0xD8, 0x5C)
#define REG_SC_BKD8_5C_H      _PK_H_(0xD8, 0x5C)
#define REG_SC_BKD8_5D_L      _PK_L_(0xD8, 0x5D)
#define REG_SC_BKD8_5D_H      _PK_H_(0xD8, 0x5D)
#define REG_SC_BKD8_5E_L      _PK_L_(0xD8, 0x5E)
#define REG_SC_BKD8_5E_H      _PK_H_(0xD8, 0x5E)
#define REG_SC_BKD8_5F_L      _PK_L_(0xD8, 0x5F)
#define REG_SC_BKD8_5F_H      _PK_H_(0xD8, 0x5F)
#define REG_SC_BKD8_60_L      _PK_L_(0xD8, 0x60)
#define REG_SC_BKD8_60_H      _PK_H_(0xD8, 0x60)
#define REG_SC_BKD8_61_L      _PK_L_(0xD8, 0x61)
#define REG_SC_BKD8_61_H      _PK_H_(0xD8, 0x61)
#define REG_SC_BKD8_62_L      _PK_L_(0xD8, 0x62)
#define REG_SC_BKD8_62_H      _PK_H_(0xD8, 0x62)
#define REG_SC_BKD8_63_L      _PK_L_(0xD8, 0x63)
#define REG_SC_BKD8_63_H      _PK_H_(0xD8, 0x63)
#define REG_SC_BKD8_64_L      _PK_L_(0xD8, 0x64)
#define REG_SC_BKD8_64_H      _PK_H_(0xD8, 0x64)
#define REG_SC_BKD8_65_L      _PK_L_(0xD8, 0x65)
#define REG_SC_BKD8_65_H      _PK_H_(0xD8, 0x65)
#define REG_SC_BKD8_66_L      _PK_L_(0xD8, 0x66)
#define REG_SC_BKD8_66_H      _PK_H_(0xD8, 0x66)
#define REG_SC_BKD8_67_L      _PK_L_(0xD8, 0x67)
#define REG_SC_BKD8_67_H      _PK_H_(0xD8, 0x67)
#define REG_SC_BKD8_68_L      _PK_L_(0xD8, 0x68)
#define REG_SC_BKD8_68_H      _PK_H_(0xD8, 0x68)
#define REG_SC_BKD8_69_L      _PK_L_(0xD8, 0x69)
#define REG_SC_BKD8_69_H      _PK_H_(0xD8, 0x69)
#define REG_SC_BKD8_6A_L      _PK_L_(0xD8, 0x6A)
#define REG_SC_BKD8_6A_H      _PK_H_(0xD8, 0x6A)
#define REG_SC_BKD8_6B_L      _PK_L_(0xD8, 0x6B)
#define REG_SC_BKD8_6B_H      _PK_H_(0xD8, 0x6B)
#define REG_SC_BKD8_6C_L      _PK_L_(0xD8, 0x6C)
#define REG_SC_BKD8_6C_H      _PK_H_(0xD8, 0x6C)
#define REG_SC_BKD8_6D_L      _PK_L_(0xD8, 0x6D)
#define REG_SC_BKD8_6D_H      _PK_H_(0xD8, 0x6D)
#define REG_SC_BKD8_6E_L      _PK_L_(0xD8, 0x6E)
#define REG_SC_BKD8_6E_H      _PK_H_(0xD8, 0x6E)
#define REG_SC_BKD8_6F_L      _PK_L_(0xD8, 0x6F)
#define REG_SC_BKD8_6F_H      _PK_H_(0xD8, 0x6F)
#define REG_SC_BKD8_70_L      _PK_L_(0xD8, 0x70)
#define REG_SC_BKD8_70_H      _PK_H_(0xD8, 0x70)
#define REG_SC_BKD8_71_L      _PK_L_(0xD8, 0x71)
#define REG_SC_BKD8_71_H      _PK_H_(0xD8, 0x71)
#define REG_SC_BKD8_72_L      _PK_L_(0xD8, 0x72)
#define REG_SC_BKD8_72_H      _PK_H_(0xD8, 0x72)
#define REG_SC_BKD8_73_L      _PK_L_(0xD8, 0x73)
#define REG_SC_BKD8_73_H      _PK_H_(0xD8, 0x73)
#define REG_SC_BKD8_74_L      _PK_L_(0xD8, 0x74)
#define REG_SC_BKD8_74_H      _PK_H_(0xD8, 0x74)
#define REG_SC_BKD8_75_L      _PK_L_(0xD8, 0x75)
#define REG_SC_BKD8_75_H      _PK_H_(0xD8, 0x75)
#define REG_SC_BKD8_76_L      _PK_L_(0xD8, 0x76)
#define REG_SC_BKD8_76_H      _PK_H_(0xD8, 0x76)
#define REG_SC_BKD8_77_L      _PK_L_(0xD8, 0x77)
#define REG_SC_BKD8_77_H      _PK_H_(0xD8, 0x77)
#define REG_SC_BKD8_78_L      _PK_L_(0xD8, 0x78)
#define REG_SC_BKD8_78_H      _PK_H_(0xD8, 0x78)
#define REG_SC_BKD8_79_L      _PK_L_(0xD8, 0x79)
#define REG_SC_BKD8_79_H      _PK_H_(0xD8, 0x79)
#define REG_SC_BKD8_7A_L      _PK_L_(0xD8, 0x7A)
#define REG_SC_BKD8_7A_H      _PK_H_(0xD8, 0x7A)
#define REG_SC_BKD8_7B_L      _PK_L_(0xD8, 0x7B)
#define REG_SC_BKD8_7B_H      _PK_H_(0xD8, 0x7B)
#define REG_SC_BKD8_7C_L      _PK_L_(0xD8, 0x7C)
#define REG_SC_BKD8_7C_H      _PK_H_(0xD8, 0x7C)
#define REG_SC_BKD8_7D_L      _PK_L_(0xD8, 0x7D)
#define REG_SC_BKD8_7D_H      _PK_H_(0xD8, 0x7D)
#define REG_SC_BKD8_7E_L      _PK_L_(0xD8, 0x7E)
#define REG_SC_BKD8_7E_H      _PK_H_(0xD8, 0x7E)
#define REG_SC_BKD8_7F_L      _PK_L_(0xD8, 0x7F)
#define REG_SC_BKD8_7F_H      _PK_H_(0xD8, 0x7F)
//----------------------------------------------
#define REG_SC_BKD9_00_L      _PK_L_(0xD9, 0x00)
#define REG_SC_BKD9_00_H      _PK_H_(0xD9, 0x00)
#define REG_SC_BKD9_01_L      _PK_L_(0xD9, 0x01)
#define REG_SC_BKD9_01_H      _PK_H_(0xD9, 0x01)
#define REG_SC_BKD9_02_L      _PK_L_(0xD9, 0x02)
#define REG_SC_BKD9_02_H      _PK_H_(0xD9, 0x02)
#define REG_SC_BKD9_03_L      _PK_L_(0xD9, 0x03)
#define REG_SC_BKD9_03_H      _PK_H_(0xD9, 0x03)
#define REG_SC_BKD9_04_L      _PK_L_(0xD9, 0x04)
#define REG_SC_BKD9_04_H      _PK_H_(0xD9, 0x04)
#define REG_SC_BKD9_05_L      _PK_L_(0xD9, 0x05)
#define REG_SC_BKD9_05_H      _PK_H_(0xD9, 0x05)
#define REG_SC_BKD9_06_L      _PK_L_(0xD9, 0x06)
#define REG_SC_BKD9_06_H      _PK_H_(0xD9, 0x06)
#define REG_SC_BKD9_07_L      _PK_L_(0xD9, 0x07)
#define REG_SC_BKD9_07_H      _PK_H_(0xD9, 0x07)
#define REG_SC_BKD9_08_L      _PK_L_(0xD9, 0x08)
#define REG_SC_BKD9_08_H      _PK_H_(0xD9, 0x08)
#define REG_SC_BKD9_09_L      _PK_L_(0xD9, 0x09)
#define REG_SC_BKD9_09_H      _PK_H_(0xD9, 0x09)
#define REG_SC_BKD9_0A_L      _PK_L_(0xD9, 0x0A)
#define REG_SC_BKD9_0A_H      _PK_H_(0xD9, 0x0A)
#define REG_SC_BKD9_0B_L      _PK_L_(0xD9, 0x0B)
#define REG_SC_BKD9_0B_H      _PK_H_(0xD9, 0x0B)
#define REG_SC_BKD9_0C_L      _PK_L_(0xD9, 0x0C)
#define REG_SC_BKD9_0C_H      _PK_H_(0xD9, 0x0C)
#define REG_SC_BKD9_0D_L      _PK_L_(0xD9, 0x0D)
#define REG_SC_BKD9_0D_H      _PK_H_(0xD9, 0x0D)
#define REG_SC_BKD9_0E_L      _PK_L_(0xD9, 0x0E)
#define REG_SC_BKD9_0E_H      _PK_H_(0xD9, 0x0E)
#define REG_SC_BKD9_0F_L      _PK_L_(0xD9, 0x0F)
#define REG_SC_BKD9_0F_H      _PK_H_(0xD9, 0x0F)
#define REG_SC_BKD9_10_L      _PK_L_(0xD9, 0x10)
#define REG_SC_BKD9_10_H      _PK_H_(0xD9, 0x10)
#define REG_SC_BKD9_11_L      _PK_L_(0xD9, 0x11)
#define REG_SC_BKD9_11_H      _PK_H_(0xD9, 0x11)
#define REG_SC_BKD9_12_L      _PK_L_(0xD9, 0x12)
#define REG_SC_BKD9_12_H      _PK_H_(0xD9, 0x12)
#define REG_SC_BKD9_13_L      _PK_L_(0xD9, 0x13)
#define REG_SC_BKD9_13_H      _PK_H_(0xD9, 0x13)
#define REG_SC_BKD9_14_L      _PK_L_(0xD9, 0x14)
#define REG_SC_BKD9_14_H      _PK_H_(0xD9, 0x14)
#define REG_SC_BKD9_15_L      _PK_L_(0xD9, 0x15)
#define REG_SC_BKD9_15_H      _PK_H_(0xD9, 0x15)
#define REG_SC_BKD9_16_L      _PK_L_(0xD9, 0x16)
#define REG_SC_BKD9_16_H      _PK_H_(0xD9, 0x16)
#define REG_SC_BKD9_17_L      _PK_L_(0xD9, 0x17)
#define REG_SC_BKD9_17_H      _PK_H_(0xD9, 0x17)
#define REG_SC_BKD9_18_L      _PK_L_(0xD9, 0x18)
#define REG_SC_BKD9_18_H      _PK_H_(0xD9, 0x18)
#define REG_SC_BKD9_19_L      _PK_L_(0xD9, 0x19)
#define REG_SC_BKD9_19_H      _PK_H_(0xD9, 0x19)
#define REG_SC_BKD9_1A_L      _PK_L_(0xD9, 0x1A)
#define REG_SC_BKD9_1A_H      _PK_H_(0xD9, 0x1A)
#define REG_SC_BKD9_1B_L      _PK_L_(0xD9, 0x1B)
#define REG_SC_BKD9_1B_H      _PK_H_(0xD9, 0x1B)
#define REG_SC_BKD9_1C_L      _PK_L_(0xD9, 0x1C)
#define REG_SC_BKD9_1C_H      _PK_H_(0xD9, 0x1C)
#define REG_SC_BKD9_1D_L      _PK_L_(0xD9, 0x1D)
#define REG_SC_BKD9_1D_H      _PK_H_(0xD9, 0x1D)
#define REG_SC_BKD9_1E_L      _PK_L_(0xD9, 0x1E)
#define REG_SC_BKD9_1E_H      _PK_H_(0xD9, 0x1E)
#define REG_SC_BKD9_1F_L      _PK_L_(0xD9, 0x1F)
#define REG_SC_BKD9_1F_H      _PK_H_(0xD9, 0x1F)
#define REG_SC_BKD9_20_L      _PK_L_(0xD9, 0x20)
#define REG_SC_BKD9_20_H      _PK_H_(0xD9, 0x20)
#define REG_SC_BKD9_21_L      _PK_L_(0xD9, 0x21)
#define REG_SC_BKD9_21_H      _PK_H_(0xD9, 0x21)
#define REG_SC_BKD9_22_L      _PK_L_(0xD9, 0x22)
#define REG_SC_BKD9_22_H      _PK_H_(0xD9, 0x22)
#define REG_SC_BKD9_23_L      _PK_L_(0xD9, 0x23)
#define REG_SC_BKD9_23_H      _PK_H_(0xD9, 0x23)
#define REG_SC_BKD9_24_L      _PK_L_(0xD9, 0x24)
#define REG_SC_BKD9_24_H      _PK_H_(0xD9, 0x24)
#define REG_SC_BKD9_25_L      _PK_L_(0xD9, 0x25)
#define REG_SC_BKD9_25_H      _PK_H_(0xD9, 0x25)
#define REG_SC_BKD9_26_L      _PK_L_(0xD9, 0x26)
#define REG_SC_BKD9_26_H      _PK_H_(0xD9, 0x26)
#define REG_SC_BKD9_27_L      _PK_L_(0xD9, 0x27)
#define REG_SC_BKD9_27_H      _PK_H_(0xD9, 0x27)
#define REG_SC_BKD9_28_L      _PK_L_(0xD9, 0x28)
#define REG_SC_BKD9_28_H      _PK_H_(0xD9, 0x28)
#define REG_SC_BKD9_29_L      _PK_L_(0xD9, 0x29)
#define REG_SC_BKD9_29_H      _PK_H_(0xD9, 0x29)
#define REG_SC_BKD9_2A_L      _PK_L_(0xD9, 0x2A)
#define REG_SC_BKD9_2A_H      _PK_H_(0xD9, 0x2A)
#define REG_SC_BKD9_2B_L      _PK_L_(0xD9, 0x2B)
#define REG_SC_BKD9_2B_H      _PK_H_(0xD9, 0x2B)
#define REG_SC_BKD9_2C_L      _PK_L_(0xD9, 0x2C)
#define REG_SC_BKD9_2C_H      _PK_H_(0xD9, 0x2C)
#define REG_SC_BKD9_2D_L      _PK_L_(0xD9, 0x2D)
#define REG_SC_BKD9_2D_H      _PK_H_(0xD9, 0x2D)
#define REG_SC_BKD9_2E_L      _PK_L_(0xD9, 0x2E)
#define REG_SC_BKD9_2E_H      _PK_H_(0xD9, 0x2E)
#define REG_SC_BKD9_2F_L      _PK_L_(0xD9, 0x2F)
#define REG_SC_BKD9_2F_H      _PK_H_(0xD9, 0x2F)
#define REG_SC_BKD9_30_L      _PK_L_(0xD9, 0x30)
#define REG_SC_BKD9_30_H      _PK_H_(0xD9, 0x30)
#define REG_SC_BKD9_31_L      _PK_L_(0xD9, 0x31)
#define REG_SC_BKD9_31_H      _PK_H_(0xD9, 0x31)
#define REG_SC_BKD9_32_L      _PK_L_(0xD9, 0x32)
#define REG_SC_BKD9_32_H      _PK_H_(0xD9, 0x32)
#define REG_SC_BKD9_33_L      _PK_L_(0xD9, 0x33)
#define REG_SC_BKD9_33_H      _PK_H_(0xD9, 0x33)
#define REG_SC_BKD9_34_L      _PK_L_(0xD9, 0x34)
#define REG_SC_BKD9_34_H      _PK_H_(0xD9, 0x34)
#define REG_SC_BKD9_35_L      _PK_L_(0xD9, 0x35)
#define REG_SC_BKD9_35_H      _PK_H_(0xD9, 0x35)
#define REG_SC_BKD9_36_L      _PK_L_(0xD9, 0x36)
#define REG_SC_BKD9_36_H      _PK_H_(0xD9, 0x36)
#define REG_SC_BKD9_37_L      _PK_L_(0xD9, 0x37)
#define REG_SC_BKD9_37_H      _PK_H_(0xD9, 0x37)
#define REG_SC_BKD9_38_L      _PK_L_(0xD9, 0x38)
#define REG_SC_BKD9_38_H      _PK_H_(0xD9, 0x38)
#define REG_SC_BKD9_39_L      _PK_L_(0xD9, 0x39)
#define REG_SC_BKD9_39_H      _PK_H_(0xD9, 0x39)
#define REG_SC_BKD9_3A_L      _PK_L_(0xD9, 0x3A)
#define REG_SC_BKD9_3A_H      _PK_H_(0xD9, 0x3A)
#define REG_SC_BKD9_3B_L      _PK_L_(0xD9, 0x3B)
#define REG_SC_BKD9_3B_H      _PK_H_(0xD9, 0x3B)
#define REG_SC_BKD9_3C_L      _PK_L_(0xD9, 0x3C)
#define REG_SC_BKD9_3C_H      _PK_H_(0xD9, 0x3C)
#define REG_SC_BKD9_3D_L      _PK_L_(0xD9, 0x3D)
#define REG_SC_BKD9_3D_H      _PK_H_(0xD9, 0x3D)
#define REG_SC_BKD9_3E_L      _PK_L_(0xD9, 0x3E)
#define REG_SC_BKD9_3E_H      _PK_H_(0xD9, 0x3E)
#define REG_SC_BKD9_3F_L      _PK_L_(0xD9, 0x3F)
#define REG_SC_BKD9_3F_H      _PK_H_(0xD9, 0x3F)
#define REG_SC_BKD9_40_L      _PK_L_(0xD9, 0x40)
#define REG_SC_BKD9_40_H      _PK_H_(0xD9, 0x40)
#define REG_SC_BKD9_41_L      _PK_L_(0xD9, 0x41)
#define REG_SC_BKD9_41_H      _PK_H_(0xD9, 0x41)
#define REG_SC_BKD9_42_L      _PK_L_(0xD9, 0x42)
#define REG_SC_BKD9_42_H      _PK_H_(0xD9, 0x42)
#define REG_SC_BKD9_43_L      _PK_L_(0xD9, 0x43)
#define REG_SC_BKD9_43_H      _PK_H_(0xD9, 0x43)
#define REG_SC_BKD9_44_L      _PK_L_(0xD9, 0x44)
#define REG_SC_BKD9_44_H      _PK_H_(0xD9, 0x44)
#define REG_SC_BKD9_45_L      _PK_L_(0xD9, 0x45)
#define REG_SC_BKD9_45_H      _PK_H_(0xD9, 0x45)
#define REG_SC_BKD9_46_L      _PK_L_(0xD9, 0x46)
#define REG_SC_BKD9_46_H      _PK_H_(0xD9, 0x46)
#define REG_SC_BKD9_47_L      _PK_L_(0xD9, 0x47)
#define REG_SC_BKD9_47_H      _PK_H_(0xD9, 0x47)
#define REG_SC_BKD9_48_L      _PK_L_(0xD9, 0x48)
#define REG_SC_BKD9_48_H      _PK_H_(0xD9, 0x48)
#define REG_SC_BKD9_49_L      _PK_L_(0xD9, 0x49)
#define REG_SC_BKD9_49_H      _PK_H_(0xD9, 0x49)
#define REG_SC_BKD9_4A_L      _PK_L_(0xD9, 0x4A)
#define REG_SC_BKD9_4A_H      _PK_H_(0xD9, 0x4A)
#define REG_SC_BKD9_4B_L      _PK_L_(0xD9, 0x4B)
#define REG_SC_BKD9_4B_H      _PK_H_(0xD9, 0x4B)
#define REG_SC_BKD9_4C_L      _PK_L_(0xD9, 0x4C)
#define REG_SC_BKD9_4C_H      _PK_H_(0xD9, 0x4C)
#define REG_SC_BKD9_4D_L      _PK_L_(0xD9, 0x4D)
#define REG_SC_BKD9_4D_H      _PK_H_(0xD9, 0x4D)
#define REG_SC_BKD9_4E_L      _PK_L_(0xD9, 0x4E)
#define REG_SC_BKD9_4E_H      _PK_H_(0xD9, 0x4E)
#define REG_SC_BKD9_4F_L      _PK_L_(0xD9, 0x4F)
#define REG_SC_BKD9_4F_H      _PK_H_(0xD9, 0x4F)
#define REG_SC_BKD9_50_L      _PK_L_(0xD9, 0x50)
#define REG_SC_BKD9_50_H      _PK_H_(0xD9, 0x50)
#define REG_SC_BKD9_51_L      _PK_L_(0xD9, 0x51)
#define REG_SC_BKD9_51_H      _PK_H_(0xD9, 0x51)
#define REG_SC_BKD9_52_L      _PK_L_(0xD9, 0x52)
#define REG_SC_BKD9_52_H      _PK_H_(0xD9, 0x52)
#define REG_SC_BKD9_53_L      _PK_L_(0xD9, 0x53)
#define REG_SC_BKD9_53_H      _PK_H_(0xD9, 0x53)
#define REG_SC_BKD9_54_L      _PK_L_(0xD9, 0x54)
#define REG_SC_BKD9_54_H      _PK_H_(0xD9, 0x54)
#define REG_SC_BKD9_55_L      _PK_L_(0xD9, 0x55)
#define REG_SC_BKD9_55_H      _PK_H_(0xD9, 0x55)
#define REG_SC_BKD9_56_L      _PK_L_(0xD9, 0x56)
#define REG_SC_BKD9_56_H      _PK_H_(0xD9, 0x56)
#define REG_SC_BKD9_57_L      _PK_L_(0xD9, 0x57)
#define REG_SC_BKD9_57_H      _PK_H_(0xD9, 0x57)
#define REG_SC_BKD9_58_L      _PK_L_(0xD9, 0x58)
#define REG_SC_BKD9_58_H      _PK_H_(0xD9, 0x58)
#define REG_SC_BKD9_59_L      _PK_L_(0xD9, 0x59)
#define REG_SC_BKD9_59_H      _PK_H_(0xD9, 0x59)
#define REG_SC_BKD9_5A_L      _PK_L_(0xD9, 0x5A)
#define REG_SC_BKD9_5A_H      _PK_H_(0xD9, 0x5A)
#define REG_SC_BKD9_5B_L      _PK_L_(0xD9, 0x5B)
#define REG_SC_BKD9_5B_H      _PK_H_(0xD9, 0x5B)
#define REG_SC_BKD9_5C_L      _PK_L_(0xD9, 0x5C)
#define REG_SC_BKD9_5C_H      _PK_H_(0xD9, 0x5C)
#define REG_SC_BKD9_5D_L      _PK_L_(0xD9, 0x5D)
#define REG_SC_BKD9_5D_H      _PK_H_(0xD9, 0x5D)
#define REG_SC_BKD9_5E_L      _PK_L_(0xD9, 0x5E)
#define REG_SC_BKD9_5E_H      _PK_H_(0xD9, 0x5E)
#define REG_SC_BKD9_5F_L      _PK_L_(0xD9, 0x5F)
#define REG_SC_BKD9_5F_H      _PK_H_(0xD9, 0x5F)
#define REG_SC_BKD9_60_L      _PK_L_(0xD9, 0x60)
#define REG_SC_BKD9_60_H      _PK_H_(0xD9, 0x60)
#define REG_SC_BKD9_61_L      _PK_L_(0xD9, 0x61)
#define REG_SC_BKD9_61_H      _PK_H_(0xD9, 0x61)
#define REG_SC_BKD9_62_L      _PK_L_(0xD9, 0x62)
#define REG_SC_BKD9_62_H      _PK_H_(0xD9, 0x62)
#define REG_SC_BKD9_63_L      _PK_L_(0xD9, 0x63)
#define REG_SC_BKD9_63_H      _PK_H_(0xD9, 0x63)
#define REG_SC_BKD9_64_L      _PK_L_(0xD9, 0x64)
#define REG_SC_BKD9_64_H      _PK_H_(0xD9, 0x64)
#define REG_SC_BKD9_65_L      _PK_L_(0xD9, 0x65)
#define REG_SC_BKD9_65_H      _PK_H_(0xD9, 0x65)
#define REG_SC_BKD9_66_L      _PK_L_(0xD9, 0x66)
#define REG_SC_BKD9_66_H      _PK_H_(0xD9, 0x66)
#define REG_SC_BKD9_67_L      _PK_L_(0xD9, 0x67)
#define REG_SC_BKD9_67_H      _PK_H_(0xD9, 0x67)
#define REG_SC_BKD9_68_L      _PK_L_(0xD9, 0x68)
#define REG_SC_BKD9_68_H      _PK_H_(0xD9, 0x68)
#define REG_SC_BKD9_69_L      _PK_L_(0xD9, 0x69)
#define REG_SC_BKD9_69_H      _PK_H_(0xD9, 0x69)
#define REG_SC_BKD9_6A_L      _PK_L_(0xD9, 0x6A)
#define REG_SC_BKD9_6A_H      _PK_H_(0xD9, 0x6A)
#define REG_SC_BKD9_6B_L      _PK_L_(0xD9, 0x6B)
#define REG_SC_BKD9_6B_H      _PK_H_(0xD9, 0x6B)
#define REG_SC_BKD9_6C_L      _PK_L_(0xD9, 0x6C)
#define REG_SC_BKD9_6C_H      _PK_H_(0xD9, 0x6C)
#define REG_SC_BKD9_6D_L      _PK_L_(0xD9, 0x6D)
#define REG_SC_BKD9_6D_H      _PK_H_(0xD9, 0x6D)
#define REG_SC_BKD9_6E_L      _PK_L_(0xD9, 0x6E)
#define REG_SC_BKD9_6E_H      _PK_H_(0xD9, 0x6E)
#define REG_SC_BKD9_6F_L      _PK_L_(0xD9, 0x6F)
#define REG_SC_BKD9_6F_H      _PK_H_(0xD9, 0x6F)
#define REG_SC_BKD9_70_L      _PK_L_(0xD9, 0x70)
#define REG_SC_BKD9_70_H      _PK_H_(0xD9, 0x70)
#define REG_SC_BKD9_71_L      _PK_L_(0xD9, 0x71)
#define REG_SC_BKD9_71_H      _PK_H_(0xD9, 0x71)
#define REG_SC_BKD9_72_L      _PK_L_(0xD9, 0x72)
#define REG_SC_BKD9_72_H      _PK_H_(0xD9, 0x72)
#define REG_SC_BKD9_73_L      _PK_L_(0xD9, 0x73)
#define REG_SC_BKD9_73_H      _PK_H_(0xD9, 0x73)
#define REG_SC_BKD9_74_L      _PK_L_(0xD9, 0x74)
#define REG_SC_BKD9_74_H      _PK_H_(0xD9, 0x74)
#define REG_SC_BKD9_75_L      _PK_L_(0xD9, 0x75)
#define REG_SC_BKD9_75_H      _PK_H_(0xD9, 0x75)
#define REG_SC_BKD9_76_L      _PK_L_(0xD9, 0x76)
#define REG_SC_BKD9_76_H      _PK_H_(0xD9, 0x76)
#define REG_SC_BKD9_77_L      _PK_L_(0xD9, 0x77)
#define REG_SC_BKD9_77_H      _PK_H_(0xD9, 0x77)
#define REG_SC_BKD9_78_L      _PK_L_(0xD9, 0x78)
#define REG_SC_BKD9_78_H      _PK_H_(0xD9, 0x78)
#define REG_SC_BKD9_79_L      _PK_L_(0xD9, 0x79)
#define REG_SC_BKD9_79_H      _PK_H_(0xD9, 0x79)
#define REG_SC_BKD9_7A_L      _PK_L_(0xD9, 0x7A)
#define REG_SC_BKD9_7A_H      _PK_H_(0xD9, 0x7A)
#define REG_SC_BKD9_7B_L      _PK_L_(0xD9, 0x7B)
#define REG_SC_BKD9_7B_H      _PK_H_(0xD9, 0x7B)
#define REG_SC_BKD9_7C_L      _PK_L_(0xD9, 0x7C)
#define REG_SC_BKD9_7C_H      _PK_H_(0xD9, 0x7C)
#define REG_SC_BKD9_7D_L      _PK_L_(0xD9, 0x7D)
#define REG_SC_BKD9_7D_H      _PK_H_(0xD9, 0x7D)
#define REG_SC_BKD9_7E_L      _PK_L_(0xD9, 0x7E)
#define REG_SC_BKD9_7E_H      _PK_H_(0xD9, 0x7E)
#define REG_SC_BKD9_7F_L      _PK_L_(0xD9, 0x7F)
#define REG_SC_BKD9_7F_H      _PK_H_(0xD9, 0x7F)
//----------------------------------------------
#define REG_SC_BKDA_00_L      _PK_L_(0xDA, 0x00)
#define REG_SC_BKDA_00_H      _PK_H_(0xDA, 0x00)
#define REG_SC_BKDA_01_L      _PK_L_(0xDA, 0x01)
#define REG_SC_BKDA_01_H      _PK_H_(0xDA, 0x01)
#define REG_SC_BKDA_02_L      _PK_L_(0xDA, 0x02)
#define REG_SC_BKDA_02_H      _PK_H_(0xDA, 0x02)
#define REG_SC_BKDA_03_L      _PK_L_(0xDA, 0x03)
#define REG_SC_BKDA_03_H      _PK_H_(0xDA, 0x03)
#define REG_SC_BKDA_04_L      _PK_L_(0xDA, 0x04)
#define REG_SC_BKDA_04_H      _PK_H_(0xDA, 0x04)
#define REG_SC_BKDA_05_L      _PK_L_(0xDA, 0x05)
#define REG_SC_BKDA_05_H      _PK_H_(0xDA, 0x05)
#define REG_SC_BKDA_06_L      _PK_L_(0xDA, 0x06)
#define REG_SC_BKDA_06_H      _PK_H_(0xDA, 0x06)
#define REG_SC_BKDA_07_L      _PK_L_(0xDA, 0x07)
#define REG_SC_BKDA_07_H      _PK_H_(0xDA, 0x07)
#define REG_SC_BKDA_08_L      _PK_L_(0xDA, 0x08)
#define REG_SC_BKDA_08_H      _PK_H_(0xDA, 0x08)
#define REG_SC_BKDA_09_L      _PK_L_(0xDA, 0x09)
#define REG_SC_BKDA_09_H      _PK_H_(0xDA, 0x09)
#define REG_SC_BKDA_0A_L      _PK_L_(0xDA, 0x0A)
#define REG_SC_BKDA_0A_H      _PK_H_(0xDA, 0x0A)
#define REG_SC_BKDA_0B_L      _PK_L_(0xDA, 0x0B)
#define REG_SC_BKDA_0B_H      _PK_H_(0xDA, 0x0B)
#define REG_SC_BKDA_0C_L      _PK_L_(0xDA, 0x0C)
#define REG_SC_BKDA_0C_H      _PK_H_(0xDA, 0x0C)
#define REG_SC_BKDA_0D_L      _PK_L_(0xDA, 0x0D)
#define REG_SC_BKDA_0D_H      _PK_H_(0xDA, 0x0D)
#define REG_SC_BKDA_0E_L      _PK_L_(0xDA, 0x0E)
#define REG_SC_BKDA_0E_H      _PK_H_(0xDA, 0x0E)
#define REG_SC_BKDA_0F_L      _PK_L_(0xDA, 0x0F)
#define REG_SC_BKDA_0F_H      _PK_H_(0xDA, 0x0F)
#define REG_SC_BKDA_10_L      _PK_L_(0xDA, 0x10)
#define REG_SC_BKDA_10_H      _PK_H_(0xDA, 0x10)
#define REG_SC_BKDA_11_L      _PK_L_(0xDA, 0x11)
#define REG_SC_BKDA_11_H      _PK_H_(0xDA, 0x11)
#define REG_SC_BKDA_12_L      _PK_L_(0xDA, 0x12)
#define REG_SC_BKDA_12_H      _PK_H_(0xDA, 0x12)
#define REG_SC_BKDA_13_L      _PK_L_(0xDA, 0x13)
#define REG_SC_BKDA_13_H      _PK_H_(0xDA, 0x13)
#define REG_SC_BKDA_14_L      _PK_L_(0xDA, 0x14)
#define REG_SC_BKDA_14_H      _PK_H_(0xDA, 0x14)
#define REG_SC_BKDA_15_L      _PK_L_(0xDA, 0x15)
#define REG_SC_BKDA_15_H      _PK_H_(0xDA, 0x15)
#define REG_SC_BKDA_16_L      _PK_L_(0xDA, 0x16)
#define REG_SC_BKDA_16_H      _PK_H_(0xDA, 0x16)
#define REG_SC_BKDA_17_L      _PK_L_(0xDA, 0x17)
#define REG_SC_BKDA_17_H      _PK_H_(0xDA, 0x17)
#define REG_SC_BKDA_18_L      _PK_L_(0xDA, 0x18)
#define REG_SC_BKDA_18_H      _PK_H_(0xDA, 0x18)
#define REG_SC_BKDA_19_L      _PK_L_(0xDA, 0x19)
#define REG_SC_BKDA_19_H      _PK_H_(0xDA, 0x19)
#define REG_SC_BKDA_1A_L      _PK_L_(0xDA, 0x1A)
#define REG_SC_BKDA_1A_H      _PK_H_(0xDA, 0x1A)
#define REG_SC_BKDA_1B_L      _PK_L_(0xDA, 0x1B)
#define REG_SC_BKDA_1B_H      _PK_H_(0xDA, 0x1B)
#define REG_SC_BKDA_1C_L      _PK_L_(0xDA, 0x1C)
#define REG_SC_BKDA_1C_H      _PK_H_(0xDA, 0x1C)
#define REG_SC_BKDA_1D_L      _PK_L_(0xDA, 0x1D)
#define REG_SC_BKDA_1D_H      _PK_H_(0xDA, 0x1D)
#define REG_SC_BKDA_1E_L      _PK_L_(0xDA, 0x1E)
#define REG_SC_BKDA_1E_H      _PK_H_(0xDA, 0x1E)
#define REG_SC_BKDA_1F_L      _PK_L_(0xDA, 0x1F)
#define REG_SC_BKDA_1F_H      _PK_H_(0xDA, 0x1F)
#define REG_SC_BKDA_20_L      _PK_L_(0xDA, 0x20)
#define REG_SC_BKDA_20_H      _PK_H_(0xDA, 0x20)
#define REG_SC_BKDA_21_L      _PK_L_(0xDA, 0x21)
#define REG_SC_BKDA_21_H      _PK_H_(0xDA, 0x21)
#define REG_SC_BKDA_22_L      _PK_L_(0xDA, 0x22)
#define REG_SC_BKDA_22_H      _PK_H_(0xDA, 0x22)
#define REG_SC_BKDA_23_L      _PK_L_(0xDA, 0x23)
#define REG_SC_BKDA_23_H      _PK_H_(0xDA, 0x23)
#define REG_SC_BKDA_24_L      _PK_L_(0xDA, 0x24)
#define REG_SC_BKDA_24_H      _PK_H_(0xDA, 0x24)
#define REG_SC_BKDA_25_L      _PK_L_(0xDA, 0x25)
#define REG_SC_BKDA_25_H      _PK_H_(0xDA, 0x25)
#define REG_SC_BKDA_26_L      _PK_L_(0xDA, 0x26)
#define REG_SC_BKDA_26_H      _PK_H_(0xDA, 0x26)
#define REG_SC_BKDA_27_L      _PK_L_(0xDA, 0x27)
#define REG_SC_BKDA_27_H      _PK_H_(0xDA, 0x27)
#define REG_SC_BKDA_28_L      _PK_L_(0xDA, 0x28)
#define REG_SC_BKDA_28_H      _PK_H_(0xDA, 0x28)
#define REG_SC_BKDA_29_L      _PK_L_(0xDA, 0x29)
#define REG_SC_BKDA_29_H      _PK_H_(0xDA, 0x29)
#define REG_SC_BKDA_2A_L      _PK_L_(0xDA, 0x2A)
#define REG_SC_BKDA_2A_H      _PK_H_(0xDA, 0x2A)
#define REG_SC_BKDA_2B_L      _PK_L_(0xDA, 0x2B)
#define REG_SC_BKDA_2B_H      _PK_H_(0xDA, 0x2B)
#define REG_SC_BKDA_2C_L      _PK_L_(0xDA, 0x2C)
#define REG_SC_BKDA_2C_H      _PK_H_(0xDA, 0x2C)
#define REG_SC_BKDA_2D_L      _PK_L_(0xDA, 0x2D)
#define REG_SC_BKDA_2D_H      _PK_H_(0xDA, 0x2D)
#define REG_SC_BKDA_2E_L      _PK_L_(0xDA, 0x2E)
#define REG_SC_BKDA_2E_H      _PK_H_(0xDA, 0x2E)
#define REG_SC_BKDA_2F_L      _PK_L_(0xDA, 0x2F)
#define REG_SC_BKDA_2F_H      _PK_H_(0xDA, 0x2F)
#define REG_SC_BKDA_30_L      _PK_L_(0xDA, 0x30)
#define REG_SC_BKDA_30_H      _PK_H_(0xDA, 0x30)
#define REG_SC_BKDA_31_L      _PK_L_(0xDA, 0x31)
#define REG_SC_BKDA_31_H      _PK_H_(0xDA, 0x31)
#define REG_SC_BKDA_32_L      _PK_L_(0xDA, 0x32)
#define REG_SC_BKDA_32_H      _PK_H_(0xDA, 0x32)
#define REG_SC_BKDA_33_L      _PK_L_(0xDA, 0x33)
#define REG_SC_BKDA_33_H      _PK_H_(0xDA, 0x33)
#define REG_SC_BKDA_34_L      _PK_L_(0xDA, 0x34)
#define REG_SC_BKDA_34_H      _PK_H_(0xDA, 0x34)
#define REG_SC_BKDA_35_L      _PK_L_(0xDA, 0x35)
#define REG_SC_BKDA_35_H      _PK_H_(0xDA, 0x35)
#define REG_SC_BKDA_36_L      _PK_L_(0xDA, 0x36)
#define REG_SC_BKDA_36_H      _PK_H_(0xDA, 0x36)
#define REG_SC_BKDA_37_L      _PK_L_(0xDA, 0x37)
#define REG_SC_BKDA_37_H      _PK_H_(0xDA, 0x37)
#define REG_SC_BKDA_38_L      _PK_L_(0xDA, 0x38)
#define REG_SC_BKDA_38_H      _PK_H_(0xDA, 0x38)
#define REG_SC_BKDA_39_L      _PK_L_(0xDA, 0x39)
#define REG_SC_BKDA_39_H      _PK_H_(0xDA, 0x39)
#define REG_SC_BKDA_3A_L      _PK_L_(0xDA, 0x3A)
#define REG_SC_BKDA_3A_H      _PK_H_(0xDA, 0x3A)
#define REG_SC_BKDA_3B_L      _PK_L_(0xDA, 0x3B)
#define REG_SC_BKDA_3B_H      _PK_H_(0xDA, 0x3B)
#define REG_SC_BKDA_3C_L      _PK_L_(0xDA, 0x3C)
#define REG_SC_BKDA_3C_H      _PK_H_(0xDA, 0x3C)
#define REG_SC_BKDA_3D_L      _PK_L_(0xDA, 0x3D)
#define REG_SC_BKDA_3D_H      _PK_H_(0xDA, 0x3D)
#define REG_SC_BKDA_3E_L      _PK_L_(0xDA, 0x3E)
#define REG_SC_BKDA_3E_H      _PK_H_(0xDA, 0x3E)
#define REG_SC_BKDA_3F_L      _PK_L_(0xDA, 0x3F)
#define REG_SC_BKDA_3F_H      _PK_H_(0xDA, 0x3F)
#define REG_SC_BKDA_40_L      _PK_L_(0xDA, 0x40)
#define REG_SC_BKDA_40_H      _PK_H_(0xDA, 0x40)
#define REG_SC_BKDA_41_L      _PK_L_(0xDA, 0x41)
#define REG_SC_BKDA_41_H      _PK_H_(0xDA, 0x41)
#define REG_SC_BKDA_42_L      _PK_L_(0xDA, 0x42)
#define REG_SC_BKDA_42_H      _PK_H_(0xDA, 0x42)
#define REG_SC_BKDA_43_L      _PK_L_(0xDA, 0x43)
#define REG_SC_BKDA_43_H      _PK_H_(0xDA, 0x43)
#define REG_SC_BKDA_44_L      _PK_L_(0xDA, 0x44)
#define REG_SC_BKDA_44_H      _PK_H_(0xDA, 0x44)
#define REG_SC_BKDA_45_L      _PK_L_(0xDA, 0x45)
#define REG_SC_BKDA_45_H      _PK_H_(0xDA, 0x45)
#define REG_SC_BKDA_46_L      _PK_L_(0xDA, 0x46)
#define REG_SC_BKDA_46_H      _PK_H_(0xDA, 0x46)
#define REG_SC_BKDA_47_L      _PK_L_(0xDA, 0x47)
#define REG_SC_BKDA_47_H      _PK_H_(0xDA, 0x47)
#define REG_SC_BKDA_48_L      _PK_L_(0xDA, 0x48)
#define REG_SC_BKDA_48_H      _PK_H_(0xDA, 0x48)
#define REG_SC_BKDA_49_L      _PK_L_(0xDA, 0x49)
#define REG_SC_BKDA_49_H      _PK_H_(0xDA, 0x49)
#define REG_SC_BKDA_4A_L      _PK_L_(0xDA, 0x4A)
#define REG_SC_BKDA_4A_H      _PK_H_(0xDA, 0x4A)
#define REG_SC_BKDA_4B_L      _PK_L_(0xDA, 0x4B)
#define REG_SC_BKDA_4B_H      _PK_H_(0xDA, 0x4B)
#define REG_SC_BKDA_4C_L      _PK_L_(0xDA, 0x4C)
#define REG_SC_BKDA_4C_H      _PK_H_(0xDA, 0x4C)
#define REG_SC_BKDA_4D_L      _PK_L_(0xDA, 0x4D)
#define REG_SC_BKDA_4D_H      _PK_H_(0xDA, 0x4D)
#define REG_SC_BKDA_4E_L      _PK_L_(0xDA, 0x4E)
#define REG_SC_BKDA_4E_H      _PK_H_(0xDA, 0x4E)
#define REG_SC_BKDA_4F_L      _PK_L_(0xDA, 0x4F)
#define REG_SC_BKDA_4F_H      _PK_H_(0xDA, 0x4F)
#define REG_SC_BKDA_50_L      _PK_L_(0xDA, 0x50)
#define REG_SC_BKDA_50_H      _PK_H_(0xDA, 0x50)
#define REG_SC_BKDA_51_L      _PK_L_(0xDA, 0x51)
#define REG_SC_BKDA_51_H      _PK_H_(0xDA, 0x51)
#define REG_SC_BKDA_52_L      _PK_L_(0xDA, 0x52)
#define REG_SC_BKDA_52_H      _PK_H_(0xDA, 0x52)
#define REG_SC_BKDA_53_L      _PK_L_(0xDA, 0x53)
#define REG_SC_BKDA_53_H      _PK_H_(0xDA, 0x53)
#define REG_SC_BKDA_54_L      _PK_L_(0xDA, 0x54)
#define REG_SC_BKDA_54_H      _PK_H_(0xDA, 0x54)
#define REG_SC_BKDA_55_L      _PK_L_(0xDA, 0x55)
#define REG_SC_BKDA_55_H      _PK_H_(0xDA, 0x55)
#define REG_SC_BKDA_56_L      _PK_L_(0xDA, 0x56)
#define REG_SC_BKDA_56_H      _PK_H_(0xDA, 0x56)
#define REG_SC_BKDA_57_L      _PK_L_(0xDA, 0x57)
#define REG_SC_BKDA_57_H      _PK_H_(0xDA, 0x57)
#define REG_SC_BKDA_58_L      _PK_L_(0xDA, 0x58)
#define REG_SC_BKDA_58_H      _PK_H_(0xDA, 0x58)
#define REG_SC_BKDA_59_L      _PK_L_(0xDA, 0x59)
#define REG_SC_BKDA_59_H      _PK_H_(0xDA, 0x59)
#define REG_SC_BKDA_5A_L      _PK_L_(0xDA, 0x5A)
#define REG_SC_BKDA_5A_H      _PK_H_(0xDA, 0x5A)
#define REG_SC_BKDA_5B_L      _PK_L_(0xDA, 0x5B)
#define REG_SC_BKDA_5B_H      _PK_H_(0xDA, 0x5B)
#define REG_SC_BKDA_5C_L      _PK_L_(0xDA, 0x5C)
#define REG_SC_BKDA_5C_H      _PK_H_(0xDA, 0x5C)
#define REG_SC_BKDA_5D_L      _PK_L_(0xDA, 0x5D)
#define REG_SC_BKDA_5D_H      _PK_H_(0xDA, 0x5D)
#define REG_SC_BKDA_5E_L      _PK_L_(0xDA, 0x5E)
#define REG_SC_BKDA_5E_H      _PK_H_(0xDA, 0x5E)
#define REG_SC_BKDA_5F_L      _PK_L_(0xDA, 0x5F)
#define REG_SC_BKDA_5F_H      _PK_H_(0xDA, 0x5F)
#define REG_SC_BKDA_60_L      _PK_L_(0xDA, 0x60)
#define REG_SC_BKDA_60_H      _PK_H_(0xDA, 0x60)
#define REG_SC_BKDA_61_L      _PK_L_(0xDA, 0x61)
#define REG_SC_BKDA_61_H      _PK_H_(0xDA, 0x61)
#define REG_SC_BKDA_62_L      _PK_L_(0xDA, 0x62)
#define REG_SC_BKDA_62_H      _PK_H_(0xDA, 0x62)
#define REG_SC_BKDA_63_L      _PK_L_(0xDA, 0x63)
#define REG_SC_BKDA_63_H      _PK_H_(0xDA, 0x63)
#define REG_SC_BKDA_64_L      _PK_L_(0xDA, 0x64)
#define REG_SC_BKDA_64_H      _PK_H_(0xDA, 0x64)
#define REG_SC_BKDA_65_L      _PK_L_(0xDA, 0x65)
#define REG_SC_BKDA_65_H      _PK_H_(0xDA, 0x65)
#define REG_SC_BKDA_66_L      _PK_L_(0xDA, 0x66)
#define REG_SC_BKDA_66_H      _PK_H_(0xDA, 0x66)
#define REG_SC_BKDA_67_L      _PK_L_(0xDA, 0x67)
#define REG_SC_BKDA_67_H      _PK_H_(0xDA, 0x67)
#define REG_SC_BKDA_68_L      _PK_L_(0xDA, 0x68)
#define REG_SC_BKDA_68_H      _PK_H_(0xDA, 0x68)
#define REG_SC_BKDA_69_L      _PK_L_(0xDA, 0x69)
#define REG_SC_BKDA_69_H      _PK_H_(0xDA, 0x69)
#define REG_SC_BKDA_6A_L      _PK_L_(0xDA, 0x6A)
#define REG_SC_BKDA_6A_H      _PK_H_(0xDA, 0x6A)
#define REG_SC_BKDA_6B_L      _PK_L_(0xDA, 0x6B)
#define REG_SC_BKDA_6B_H      _PK_H_(0xDA, 0x6B)
#define REG_SC_BKDA_6C_L      _PK_L_(0xDA, 0x6C)
#define REG_SC_BKDA_6C_H      _PK_H_(0xDA, 0x6C)
#define REG_SC_BKDA_6D_L      _PK_L_(0xDA, 0x6D)
#define REG_SC_BKDA_6D_H      _PK_H_(0xDA, 0x6D)
#define REG_SC_BKDA_6E_L      _PK_L_(0xDA, 0x6E)
#define REG_SC_BKDA_6E_H      _PK_H_(0xDA, 0x6E)
#define REG_SC_BKDA_6F_L      _PK_L_(0xDA, 0x6F)
#define REG_SC_BKDA_6F_H      _PK_H_(0xDA, 0x6F)
#define REG_SC_BKDA_70_L      _PK_L_(0xDA, 0x70)
#define REG_SC_BKDA_70_H      _PK_H_(0xDA, 0x70)
#define REG_SC_BKDA_71_L      _PK_L_(0xDA, 0x71)
#define REG_SC_BKDA_71_H      _PK_H_(0xDA, 0x71)
#define REG_SC_BKDA_72_L      _PK_L_(0xDA, 0x72)
#define REG_SC_BKDA_72_H      _PK_H_(0xDA, 0x72)
#define REG_SC_BKDA_73_L      _PK_L_(0xDA, 0x73)
#define REG_SC_BKDA_73_H      _PK_H_(0xDA, 0x73)
#define REG_SC_BKDA_74_L      _PK_L_(0xDA, 0x74)
#define REG_SC_BKDA_74_H      _PK_H_(0xDA, 0x74)
#define REG_SC_BKDA_75_L      _PK_L_(0xDA, 0x75)
#define REG_SC_BKDA_75_H      _PK_H_(0xDA, 0x75)
#define REG_SC_BKDA_76_L      _PK_L_(0xDA, 0x76)
#define REG_SC_BKDA_76_H      _PK_H_(0xDA, 0x76)
#define REG_SC_BKDA_77_L      _PK_L_(0xDA, 0x77)
#define REG_SC_BKDA_77_H      _PK_H_(0xDA, 0x77)
#define REG_SC_BKDA_78_L      _PK_L_(0xDA, 0x78)
#define REG_SC_BKDA_78_H      _PK_H_(0xDA, 0x78)
#define REG_SC_BKDA_79_L      _PK_L_(0xDA, 0x79)
#define REG_SC_BKDA_79_H      _PK_H_(0xDA, 0x79)
#define REG_SC_BKDA_7A_L      _PK_L_(0xDA, 0x7A)
#define REG_SC_BKDA_7A_H      _PK_H_(0xDA, 0x7A)
#define REG_SC_BKDA_7B_L      _PK_L_(0xDA, 0x7B)
#define REG_SC_BKDA_7B_H      _PK_H_(0xDA, 0x7B)
#define REG_SC_BKDA_7C_L      _PK_L_(0xDA, 0x7C)
#define REG_SC_BKDA_7C_H      _PK_H_(0xDA, 0x7C)
#define REG_SC_BKDA_7D_L      _PK_L_(0xDA, 0x7D)
#define REG_SC_BKDA_7D_H      _PK_H_(0xDA, 0x7D)
#define REG_SC_BKDA_7E_L      _PK_L_(0xDA, 0x7E)
#define REG_SC_BKDA_7E_H      _PK_H_(0xDA, 0x7E)
#define REG_SC_BKDA_7F_L      _PK_L_(0xDA, 0x7F)
#define REG_SC_BKDA_7F_H      _PK_H_(0xDA, 0x7F)
//----------------------------------------------
#define REG_SC_BKDB_00_L      _PK_L_(0xDB, 0x00)
#define REG_SC_BKDB_00_H      _PK_H_(0xDB, 0x00)
#define REG_SC_BKDB_01_L      _PK_L_(0xDB, 0x01)
#define REG_SC_BKDB_01_H      _PK_H_(0xDB, 0x01)
#define REG_SC_BKDB_02_L      _PK_L_(0xDB, 0x02)
#define REG_SC_BKDB_02_H      _PK_H_(0xDB, 0x02)
#define REG_SC_BKDB_03_L      _PK_L_(0xDB, 0x03)
#define REG_SC_BKDB_03_H      _PK_H_(0xDB, 0x03)
#define REG_SC_BKDB_04_L      _PK_L_(0xDB, 0x04)
#define REG_SC_BKDB_04_H      _PK_H_(0xDB, 0x04)
#define REG_SC_BKDB_05_L      _PK_L_(0xDB, 0x05)
#define REG_SC_BKDB_05_H      _PK_H_(0xDB, 0x05)
#define REG_SC_BKDB_06_L      _PK_L_(0xDB, 0x06)
#define REG_SC_BKDB_06_H      _PK_H_(0xDB, 0x06)
#define REG_SC_BKDB_07_L      _PK_L_(0xDB, 0x07)
#define REG_SC_BKDB_07_H      _PK_H_(0xDB, 0x07)
#define REG_SC_BKDB_08_L      _PK_L_(0xDB, 0x08)
#define REG_SC_BKDB_08_H      _PK_H_(0xDB, 0x08)
#define REG_SC_BKDB_09_L      _PK_L_(0xDB, 0x09)
#define REG_SC_BKDB_09_H      _PK_H_(0xDB, 0x09)
#define REG_SC_BKDB_0A_L      _PK_L_(0xDB, 0x0A)
#define REG_SC_BKDB_0A_H      _PK_H_(0xDB, 0x0A)
#define REG_SC_BKDB_0B_L      _PK_L_(0xDB, 0x0B)
#define REG_SC_BKDB_0B_H      _PK_H_(0xDB, 0x0B)
#define REG_SC_BKDB_0C_L      _PK_L_(0xDB, 0x0C)
#define REG_SC_BKDB_0C_H      _PK_H_(0xDB, 0x0C)
#define REG_SC_BKDB_0D_L      _PK_L_(0xDB, 0x0D)
#define REG_SC_BKDB_0D_H      _PK_H_(0xDB, 0x0D)
#define REG_SC_BKDB_0E_L      _PK_L_(0xDB, 0x0E)
#define REG_SC_BKDB_0E_H      _PK_H_(0xDB, 0x0E)
#define REG_SC_BKDB_0F_L      _PK_L_(0xDB, 0x0F)
#define REG_SC_BKDB_0F_H      _PK_H_(0xDB, 0x0F)
#define REG_SC_BKDB_10_L      _PK_L_(0xDB, 0x10)
#define REG_SC_BKDB_10_H      _PK_H_(0xDB, 0x10)
#define REG_SC_BKDB_11_L      _PK_L_(0xDB, 0x11)
#define REG_SC_BKDB_11_H      _PK_H_(0xDB, 0x11)
#define REG_SC_BKDB_12_L      _PK_L_(0xDB, 0x12)
#define REG_SC_BKDB_12_H      _PK_H_(0xDB, 0x12)
#define REG_SC_BKDB_13_L      _PK_L_(0xDB, 0x13)
#define REG_SC_BKDB_13_H      _PK_H_(0xDB, 0x13)
#define REG_SC_BKDB_14_L      _PK_L_(0xDB, 0x14)
#define REG_SC_BKDB_14_H      _PK_H_(0xDB, 0x14)
#define REG_SC_BKDB_15_L      _PK_L_(0xDB, 0x15)
#define REG_SC_BKDB_15_H      _PK_H_(0xDB, 0x15)
#define REG_SC_BKDB_16_L      _PK_L_(0xDB, 0x16)
#define REG_SC_BKDB_16_H      _PK_H_(0xDB, 0x16)
#define REG_SC_BKDB_17_L      _PK_L_(0xDB, 0x17)
#define REG_SC_BKDB_17_H      _PK_H_(0xDB, 0x17)
#define REG_SC_BKDB_18_L      _PK_L_(0xDB, 0x18)
#define REG_SC_BKDB_18_H      _PK_H_(0xDB, 0x18)
#define REG_SC_BKDB_19_L      _PK_L_(0xDB, 0x19)
#define REG_SC_BKDB_19_H      _PK_H_(0xDB, 0x19)
#define REG_SC_BKDB_1A_L      _PK_L_(0xDB, 0x1A)
#define REG_SC_BKDB_1A_H      _PK_H_(0xDB, 0x1A)
#define REG_SC_BKDB_1B_L      _PK_L_(0xDB, 0x1B)
#define REG_SC_BKDB_1B_H      _PK_H_(0xDB, 0x1B)
#define REG_SC_BKDB_1C_L      _PK_L_(0xDB, 0x1C)
#define REG_SC_BKDB_1C_H      _PK_H_(0xDB, 0x1C)
#define REG_SC_BKDB_1D_L      _PK_L_(0xDB, 0x1D)
#define REG_SC_BKDB_1D_H      _PK_H_(0xDB, 0x1D)
#define REG_SC_BKDB_1E_L      _PK_L_(0xDB, 0x1E)
#define REG_SC_BKDB_1E_H      _PK_H_(0xDB, 0x1E)
#define REG_SC_BKDB_1F_L      _PK_L_(0xDB, 0x1F)
#define REG_SC_BKDB_1F_H      _PK_H_(0xDB, 0x1F)
#define REG_SC_BKDB_20_L      _PK_L_(0xDB, 0x20)
#define REG_SC_BKDB_20_H      _PK_H_(0xDB, 0x20)
#define REG_SC_BKDB_21_L      _PK_L_(0xDB, 0x21)
#define REG_SC_BKDB_21_H      _PK_H_(0xDB, 0x21)
#define REG_SC_BKDB_22_L      _PK_L_(0xDB, 0x22)
#define REG_SC_BKDB_22_H      _PK_H_(0xDB, 0x22)
#define REG_SC_BKDB_23_L      _PK_L_(0xDB, 0x23)
#define REG_SC_BKDB_23_H      _PK_H_(0xDB, 0x23)
#define REG_SC_BKDB_24_L      _PK_L_(0xDB, 0x24)
#define REG_SC_BKDB_24_H      _PK_H_(0xDB, 0x24)
#define REG_SC_BKDB_25_L      _PK_L_(0xDB, 0x25)
#define REG_SC_BKDB_25_H      _PK_H_(0xDB, 0x25)
#define REG_SC_BKDB_26_L      _PK_L_(0xDB, 0x26)
#define REG_SC_BKDB_26_H      _PK_H_(0xDB, 0x26)
#define REG_SC_BKDB_27_L      _PK_L_(0xDB, 0x27)
#define REG_SC_BKDB_27_H      _PK_H_(0xDB, 0x27)
#define REG_SC_BKDB_28_L      _PK_L_(0xDB, 0x28)
#define REG_SC_BKDB_28_H      _PK_H_(0xDB, 0x28)
#define REG_SC_BKDB_29_L      _PK_L_(0xDB, 0x29)
#define REG_SC_BKDB_29_H      _PK_H_(0xDB, 0x29)
#define REG_SC_BKDB_2A_L      _PK_L_(0xDB, 0x2A)
#define REG_SC_BKDB_2A_H      _PK_H_(0xDB, 0x2A)
#define REG_SC_BKDB_2B_L      _PK_L_(0xDB, 0x2B)
#define REG_SC_BKDB_2B_H      _PK_H_(0xDB, 0x2B)
#define REG_SC_BKDB_2C_L      _PK_L_(0xDB, 0x2C)
#define REG_SC_BKDB_2C_H      _PK_H_(0xDB, 0x2C)
#define REG_SC_BKDB_2D_L      _PK_L_(0xDB, 0x2D)
#define REG_SC_BKDB_2D_H      _PK_H_(0xDB, 0x2D)
#define REG_SC_BKDB_2E_L      _PK_L_(0xDB, 0x2E)
#define REG_SC_BKDB_2E_H      _PK_H_(0xDB, 0x2E)
#define REG_SC_BKDB_2F_L      _PK_L_(0xDB, 0x2F)
#define REG_SC_BKDB_2F_H      _PK_H_(0xDB, 0x2F)
#define REG_SC_BKDB_30_L      _PK_L_(0xDB, 0x30)
#define REG_SC_BKDB_30_H      _PK_H_(0xDB, 0x30)
#define REG_SC_BKDB_31_L      _PK_L_(0xDB, 0x31)
#define REG_SC_BKDB_31_H      _PK_H_(0xDB, 0x31)
#define REG_SC_BKDB_32_L      _PK_L_(0xDB, 0x32)
#define REG_SC_BKDB_32_H      _PK_H_(0xDB, 0x32)
#define REG_SC_BKDB_33_L      _PK_L_(0xDB, 0x33)
#define REG_SC_BKDB_33_H      _PK_H_(0xDB, 0x33)
#define REG_SC_BKDB_34_L      _PK_L_(0xDB, 0x34)
#define REG_SC_BKDB_34_H      _PK_H_(0xDB, 0x34)
#define REG_SC_BKDB_35_L      _PK_L_(0xDB, 0x35)
#define REG_SC_BKDB_35_H      _PK_H_(0xDB, 0x35)
#define REG_SC_BKDB_36_L      _PK_L_(0xDB, 0x36)
#define REG_SC_BKDB_36_H      _PK_H_(0xDB, 0x36)
#define REG_SC_BKDB_37_L      _PK_L_(0xDB, 0x37)
#define REG_SC_BKDB_37_H      _PK_H_(0xDB, 0x37)
#define REG_SC_BKDB_38_L      _PK_L_(0xDB, 0x38)
#define REG_SC_BKDB_38_H      _PK_H_(0xDB, 0x38)
#define REG_SC_BKDB_39_L      _PK_L_(0xDB, 0x39)
#define REG_SC_BKDB_39_H      _PK_H_(0xDB, 0x39)
#define REG_SC_BKDB_3A_L      _PK_L_(0xDB, 0x3A)
#define REG_SC_BKDB_3A_H      _PK_H_(0xDB, 0x3A)
#define REG_SC_BKDB_3B_L      _PK_L_(0xDB, 0x3B)
#define REG_SC_BKDB_3B_H      _PK_H_(0xDB, 0x3B)
#define REG_SC_BKDB_3C_L      _PK_L_(0xDB, 0x3C)
#define REG_SC_BKDB_3C_H      _PK_H_(0xDB, 0x3C)
#define REG_SC_BKDB_3D_L      _PK_L_(0xDB, 0x3D)
#define REG_SC_BKDB_3D_H      _PK_H_(0xDB, 0x3D)
#define REG_SC_BKDB_3E_L      _PK_L_(0xDB, 0x3E)
#define REG_SC_BKDB_3E_H      _PK_H_(0xDB, 0x3E)
#define REG_SC_BKDB_3F_L      _PK_L_(0xDB, 0x3F)
#define REG_SC_BKDB_3F_H      _PK_H_(0xDB, 0x3F)
#define REG_SC_BKDB_40_L      _PK_L_(0xDB, 0x40)
#define REG_SC_BKDB_40_H      _PK_H_(0xDB, 0x40)
#define REG_SC_BKDB_41_L      _PK_L_(0xDB, 0x41)
#define REG_SC_BKDB_41_H      _PK_H_(0xDB, 0x41)
#define REG_SC_BKDB_42_L      _PK_L_(0xDB, 0x42)
#define REG_SC_BKDB_42_H      _PK_H_(0xDB, 0x42)
#define REG_SC_BKDB_43_L      _PK_L_(0xDB, 0x43)
#define REG_SC_BKDB_43_H      _PK_H_(0xDB, 0x43)
#define REG_SC_BKDB_44_L      _PK_L_(0xDB, 0x44)
#define REG_SC_BKDB_44_H      _PK_H_(0xDB, 0x44)
#define REG_SC_BKDB_45_L      _PK_L_(0xDB, 0x45)
#define REG_SC_BKDB_45_H      _PK_H_(0xDB, 0x45)
#define REG_SC_BKDB_46_L      _PK_L_(0xDB, 0x46)
#define REG_SC_BKDB_46_H      _PK_H_(0xDB, 0x46)
#define REG_SC_BKDB_47_L      _PK_L_(0xDB, 0x47)
#define REG_SC_BKDB_47_H      _PK_H_(0xDB, 0x47)
#define REG_SC_BKDB_48_L      _PK_L_(0xDB, 0x48)
#define REG_SC_BKDB_48_H      _PK_H_(0xDB, 0x48)
#define REG_SC_BKDB_49_L      _PK_L_(0xDB, 0x49)
#define REG_SC_BKDB_49_H      _PK_H_(0xDB, 0x49)
#define REG_SC_BKDB_4A_L      _PK_L_(0xDB, 0x4A)
#define REG_SC_BKDB_4A_H      _PK_H_(0xDB, 0x4A)
#define REG_SC_BKDB_4B_L      _PK_L_(0xDB, 0x4B)
#define REG_SC_BKDB_4B_H      _PK_H_(0xDB, 0x4B)
#define REG_SC_BKDB_4C_L      _PK_L_(0xDB, 0x4C)
#define REG_SC_BKDB_4C_H      _PK_H_(0xDB, 0x4C)
#define REG_SC_BKDB_4D_L      _PK_L_(0xDB, 0x4D)
#define REG_SC_BKDB_4D_H      _PK_H_(0xDB, 0x4D)
#define REG_SC_BKDB_4E_L      _PK_L_(0xDB, 0x4E)
#define REG_SC_BKDB_4E_H      _PK_H_(0xDB, 0x4E)
#define REG_SC_BKDB_4F_L      _PK_L_(0xDB, 0x4F)
#define REG_SC_BKDB_4F_H      _PK_H_(0xDB, 0x4F)
#define REG_SC_BKDB_50_L      _PK_L_(0xDB, 0x50)
#define REG_SC_BKDB_50_H      _PK_H_(0xDB, 0x50)
#define REG_SC_BKDB_51_L      _PK_L_(0xDB, 0x51)
#define REG_SC_BKDB_51_H      _PK_H_(0xDB, 0x51)
#define REG_SC_BKDB_52_L      _PK_L_(0xDB, 0x52)
#define REG_SC_BKDB_52_H      _PK_H_(0xDB, 0x52)
#define REG_SC_BKDB_53_L      _PK_L_(0xDB, 0x53)
#define REG_SC_BKDB_53_H      _PK_H_(0xDB, 0x53)
#define REG_SC_BKDB_54_L      _PK_L_(0xDB, 0x54)
#define REG_SC_BKDB_54_H      _PK_H_(0xDB, 0x54)
#define REG_SC_BKDB_55_L      _PK_L_(0xDB, 0x55)
#define REG_SC_BKDB_55_H      _PK_H_(0xDB, 0x55)
#define REG_SC_BKDB_56_L      _PK_L_(0xDB, 0x56)
#define REG_SC_BKDB_56_H      _PK_H_(0xDB, 0x56)
#define REG_SC_BKDB_57_L      _PK_L_(0xDB, 0x57)
#define REG_SC_BKDB_57_H      _PK_H_(0xDB, 0x57)
#define REG_SC_BKDB_58_L      _PK_L_(0xDB, 0x58)
#define REG_SC_BKDB_58_H      _PK_H_(0xDB, 0x58)
#define REG_SC_BKDB_59_L      _PK_L_(0xDB, 0x59)
#define REG_SC_BKDB_59_H      _PK_H_(0xDB, 0x59)
#define REG_SC_BKDB_5A_L      _PK_L_(0xDB, 0x5A)
#define REG_SC_BKDB_5A_H      _PK_H_(0xDB, 0x5A)
#define REG_SC_BKDB_5B_L      _PK_L_(0xDB, 0x5B)
#define REG_SC_BKDB_5B_H      _PK_H_(0xDB, 0x5B)
#define REG_SC_BKDB_5C_L      _PK_L_(0xDB, 0x5C)
#define REG_SC_BKDB_5C_H      _PK_H_(0xDB, 0x5C)
#define REG_SC_BKDB_5D_L      _PK_L_(0xDB, 0x5D)
#define REG_SC_BKDB_5D_H      _PK_H_(0xDB, 0x5D)
#define REG_SC_BKDB_5E_L      _PK_L_(0xDB, 0x5E)
#define REG_SC_BKDB_5E_H      _PK_H_(0xDB, 0x5E)
#define REG_SC_BKDB_5F_L      _PK_L_(0xDB, 0x5F)
#define REG_SC_BKDB_5F_H      _PK_H_(0xDB, 0x5F)
#define REG_SC_BKDB_60_L      _PK_L_(0xDB, 0x60)
#define REG_SC_BKDB_60_H      _PK_H_(0xDB, 0x60)
#define REG_SC_BKDB_61_L      _PK_L_(0xDB, 0x61)
#define REG_SC_BKDB_61_H      _PK_H_(0xDB, 0x61)
#define REG_SC_BKDB_62_L      _PK_L_(0xDB, 0x62)
#define REG_SC_BKDB_62_H      _PK_H_(0xDB, 0x62)
#define REG_SC_BKDB_63_L      _PK_L_(0xDB, 0x63)
#define REG_SC_BKDB_63_H      _PK_H_(0xDB, 0x63)
#define REG_SC_BKDB_64_L      _PK_L_(0xDB, 0x64)
#define REG_SC_BKDB_64_H      _PK_H_(0xDB, 0x64)
#define REG_SC_BKDB_65_L      _PK_L_(0xDB, 0x65)
#define REG_SC_BKDB_65_H      _PK_H_(0xDB, 0x65)
#define REG_SC_BKDB_66_L      _PK_L_(0xDB, 0x66)
#define REG_SC_BKDB_66_H      _PK_H_(0xDB, 0x66)
#define REG_SC_BKDB_67_L      _PK_L_(0xDB, 0x67)
#define REG_SC_BKDB_67_H      _PK_H_(0xDB, 0x67)
#define REG_SC_BKDB_68_L      _PK_L_(0xDB, 0x68)
#define REG_SC_BKDB_68_H      _PK_H_(0xDB, 0x68)
#define REG_SC_BKDB_69_L      _PK_L_(0xDB, 0x69)
#define REG_SC_BKDB_69_H      _PK_H_(0xDB, 0x69)
#define REG_SC_BKDB_6A_L      _PK_L_(0xDB, 0x6A)
#define REG_SC_BKDB_6A_H      _PK_H_(0xDB, 0x6A)
#define REG_SC_BKDB_6B_L      _PK_L_(0xDB, 0x6B)
#define REG_SC_BKDB_6B_H      _PK_H_(0xDB, 0x6B)
#define REG_SC_BKDB_6C_L      _PK_L_(0xDB, 0x6C)
#define REG_SC_BKDB_6C_H      _PK_H_(0xDB, 0x6C)
#define REG_SC_BKDB_6D_L      _PK_L_(0xDB, 0x6D)
#define REG_SC_BKDB_6D_H      _PK_H_(0xDB, 0x6D)
#define REG_SC_BKDB_6E_L      _PK_L_(0xDB, 0x6E)
#define REG_SC_BKDB_6E_H      _PK_H_(0xDB, 0x6E)
#define REG_SC_BKDB_6F_L      _PK_L_(0xDB, 0x6F)
#define REG_SC_BKDB_6F_H      _PK_H_(0xDB, 0x6F)
#define REG_SC_BKDB_70_L      _PK_L_(0xDB, 0x70)
#define REG_SC_BKDB_70_H      _PK_H_(0xDB, 0x70)
#define REG_SC_BKDB_71_L      _PK_L_(0xDB, 0x71)
#define REG_SC_BKDB_71_H      _PK_H_(0xDB, 0x71)
#define REG_SC_BKDB_72_L      _PK_L_(0xDB, 0x72)
#define REG_SC_BKDB_72_H      _PK_H_(0xDB, 0x72)
#define REG_SC_BKDB_73_L      _PK_L_(0xDB, 0x73)
#define REG_SC_BKDB_73_H      _PK_H_(0xDB, 0x73)
#define REG_SC_BKDB_74_L      _PK_L_(0xDB, 0x74)
#define REG_SC_BKDB_74_H      _PK_H_(0xDB, 0x74)
#define REG_SC_BKDB_75_L      _PK_L_(0xDB, 0x75)
#define REG_SC_BKDB_75_H      _PK_H_(0xDB, 0x75)
#define REG_SC_BKDB_76_L      _PK_L_(0xDB, 0x76)
#define REG_SC_BKDB_76_H      _PK_H_(0xDB, 0x76)
#define REG_SC_BKDB_77_L      _PK_L_(0xDB, 0x77)
#define REG_SC_BKDB_77_H      _PK_H_(0xDB, 0x77)
#define REG_SC_BKDB_78_L      _PK_L_(0xDB, 0x78)
#define REG_SC_BKDB_78_H      _PK_H_(0xDB, 0x78)
#define REG_SC_BKDB_79_L      _PK_L_(0xDB, 0x79)
#define REG_SC_BKDB_79_H      _PK_H_(0xDB, 0x79)
#define REG_SC_BKDB_7A_L      _PK_L_(0xDB, 0x7A)
#define REG_SC_BKDB_7A_H      _PK_H_(0xDB, 0x7A)
#define REG_SC_BKDB_7B_L      _PK_L_(0xDB, 0x7B)
#define REG_SC_BKDB_7B_H      _PK_H_(0xDB, 0x7B)
#define REG_SC_BKDB_7C_L      _PK_L_(0xDB, 0x7C)
#define REG_SC_BKDB_7C_H      _PK_H_(0xDB, 0x7C)
#define REG_SC_BKDB_7D_L      _PK_L_(0xDB, 0x7D)
#define REG_SC_BKDB_7D_H      _PK_H_(0xDB, 0x7D)
#define REG_SC_BKDB_7E_L      _PK_L_(0xDB, 0x7E)
#define REG_SC_BKDB_7E_H      _PK_H_(0xDB, 0x7E)
#define REG_SC_BKDB_7F_L      _PK_L_(0xDB, 0x7F)
#define REG_SC_BKDB_7F_H      _PK_H_(0xDB, 0x7F)
//----------------------------------------------
#define REG_SC_BKE0_00_L      _PK_L_(0xE0, 0x00)
#define REG_SC_BKE0_00_H      _PK_H_(0xE0, 0x00)
#define REG_SC_BKE0_01_L      _PK_L_(0xE0, 0x01)
#define REG_SC_BKE0_01_H      _PK_H_(0xE0, 0x01)
#define REG_SC_BKE0_02_L      _PK_L_(0xE0, 0x02)
#define REG_SC_BKE0_02_H      _PK_H_(0xE0, 0x02)
#define REG_SC_BKE0_03_L      _PK_L_(0xE0, 0x03)
#define REG_SC_BKE0_03_H      _PK_H_(0xE0, 0x03)
#define REG_SC_BKE0_04_L      _PK_L_(0xE0, 0x04)
#define REG_SC_BKE0_04_H      _PK_H_(0xE0, 0x04)
#define REG_SC_BKE0_05_L      _PK_L_(0xE0, 0x05)
#define REG_SC_BKE0_05_H      _PK_H_(0xE0, 0x05)
#define REG_SC_BKE0_06_L      _PK_L_(0xE0, 0x06)
#define REG_SC_BKE0_06_H      _PK_H_(0xE0, 0x06)
#define REG_SC_BKE0_07_L      _PK_L_(0xE0, 0x07)
#define REG_SC_BKE0_07_H      _PK_H_(0xE0, 0x07)
#define REG_SC_BKE0_08_L      _PK_L_(0xE0, 0x08)
#define REG_SC_BKE0_08_H      _PK_H_(0xE0, 0x08)
#define REG_SC_BKE0_09_L      _PK_L_(0xE0, 0x09)
#define REG_SC_BKE0_09_H      _PK_H_(0xE0, 0x09)
#define REG_SC_BKE0_0A_L      _PK_L_(0xE0, 0x0A)
#define REG_SC_BKE0_0A_H      _PK_H_(0xE0, 0x0A)
#define REG_SC_BKE0_0B_L      _PK_L_(0xE0, 0x0B)
#define REG_SC_BKE0_0B_H      _PK_H_(0xE0, 0x0B)
#define REG_SC_BKE0_0C_L      _PK_L_(0xE0, 0x0C)
#define REG_SC_BKE0_0C_H      _PK_H_(0xE0, 0x0C)
#define REG_SC_BKE0_0D_L      _PK_L_(0xE0, 0x0D)
#define REG_SC_BKE0_0D_H      _PK_H_(0xE0, 0x0D)
#define REG_SC_BKE0_0E_L      _PK_L_(0xE0, 0x0E)
#define REG_SC_BKE0_0E_H      _PK_H_(0xE0, 0x0E)
#define REG_SC_BKE0_0F_L      _PK_L_(0xE0, 0x0F)
#define REG_SC_BKE0_0F_H      _PK_H_(0xE0, 0x0F)
#define REG_SC_BKE0_10_L      _PK_L_(0xE0, 0x10)
#define REG_SC_BKE0_10_H      _PK_H_(0xE0, 0x10)
#define REG_SC_BKE0_11_L      _PK_L_(0xE0, 0x11)
#define REG_SC_BKE0_11_H      _PK_H_(0xE0, 0x11)
#define REG_SC_BKE0_12_L      _PK_L_(0xE0, 0x12)
#define REG_SC_BKE0_12_H      _PK_H_(0xE0, 0x12)
#define REG_SC_BKE0_13_L      _PK_L_(0xE0, 0x13)
#define REG_SC_BKE0_13_H      _PK_H_(0xE0, 0x13)
#define REG_SC_BKE0_14_L      _PK_L_(0xE0, 0x14)
#define REG_SC_BKE0_14_H      _PK_H_(0xE0, 0x14)
#define REG_SC_BKE0_15_L      _PK_L_(0xE0, 0x15)
#define REG_SC_BKE0_15_H      _PK_H_(0xE0, 0x15)
#define REG_SC_BKE0_16_L      _PK_L_(0xE0, 0x16)
#define REG_SC_BKE0_16_H      _PK_H_(0xE0, 0x16)
#define REG_SC_BKE0_17_L      _PK_L_(0xE0, 0x17)
#define REG_SC_BKE0_17_H      _PK_H_(0xE0, 0x17)
#define REG_SC_BKE0_18_L      _PK_L_(0xE0, 0x18)
#define REG_SC_BKE0_18_H      _PK_H_(0xE0, 0x18)
#define REG_SC_BKE0_19_L      _PK_L_(0xE0, 0x19)
#define REG_SC_BKE0_19_H      _PK_H_(0xE0, 0x19)
#define REG_SC_BKE0_1A_L      _PK_L_(0xE0, 0x1A)
#define REG_SC_BKE0_1A_H      _PK_H_(0xE0, 0x1A)
#define REG_SC_BKE0_1B_L      _PK_L_(0xE0, 0x1B)
#define REG_SC_BKE0_1B_H      _PK_H_(0xE0, 0x1B)
#define REG_SC_BKE0_1C_L      _PK_L_(0xE0, 0x1C)
#define REG_SC_BKE0_1C_H      _PK_H_(0xE0, 0x1C)
#define REG_SC_BKE0_1D_L      _PK_L_(0xE0, 0x1D)
#define REG_SC_BKE0_1D_H      _PK_H_(0xE0, 0x1D)
#define REG_SC_BKE0_1E_L      _PK_L_(0xE0, 0x1E)
#define REG_SC_BKE0_1E_H      _PK_H_(0xE0, 0x1E)
#define REG_SC_BKE0_1F_L      _PK_L_(0xE0, 0x1F)
#define REG_SC_BKE0_1F_H      _PK_H_(0xE0, 0x1F)
#define REG_SC_BKE0_20_L      _PK_L_(0xE0, 0x20)
#define REG_SC_BKE0_20_H      _PK_H_(0xE0, 0x20)
#define REG_SC_BKE0_21_L      _PK_L_(0xE0, 0x21)
#define REG_SC_BKE0_21_H      _PK_H_(0xE0, 0x21)
#define REG_SC_BKE0_22_L      _PK_L_(0xE0, 0x22)
#define REG_SC_BKE0_22_H      _PK_H_(0xE0, 0x22)
#define REG_SC_BKE0_23_L      _PK_L_(0xE0, 0x23)
#define REG_SC_BKE0_23_H      _PK_H_(0xE0, 0x23)
#define REG_SC_BKE0_24_L      _PK_L_(0xE0, 0x24)
#define REG_SC_BKE0_24_H      _PK_H_(0xE0, 0x24)
#define REG_SC_BKE0_25_L      _PK_L_(0xE0, 0x25)
#define REG_SC_BKE0_25_H      _PK_H_(0xE0, 0x25)
#define REG_SC_BKE0_26_L      _PK_L_(0xE0, 0x26)
#define REG_SC_BKE0_26_H      _PK_H_(0xE0, 0x26)
#define REG_SC_BKE0_27_L      _PK_L_(0xE0, 0x27)
#define REG_SC_BKE0_27_H      _PK_H_(0xE0, 0x27)
#define REG_SC_BKE0_28_L      _PK_L_(0xE0, 0x28)
#define REG_SC_BKE0_28_H      _PK_H_(0xE0, 0x28)
#define REG_SC_BKE0_29_L      _PK_L_(0xE0, 0x29)
#define REG_SC_BKE0_29_H      _PK_H_(0xE0, 0x29)
#define REG_SC_BKE0_2A_L      _PK_L_(0xE0, 0x2A)
#define REG_SC_BKE0_2A_H      _PK_H_(0xE0, 0x2A)
#define REG_SC_BKE0_2B_L      _PK_L_(0xE0, 0x2B)
#define REG_SC_BKE0_2B_H      _PK_H_(0xE0, 0x2B)
#define REG_SC_BKE0_2C_L      _PK_L_(0xE0, 0x2C)
#define REG_SC_BKE0_2C_H      _PK_H_(0xE0, 0x2C)
#define REG_SC_BKE0_2D_L      _PK_L_(0xE0, 0x2D)
#define REG_SC_BKE0_2D_H      _PK_H_(0xE0, 0x2D)
#define REG_SC_BKE0_2E_L      _PK_L_(0xE0, 0x2E)
#define REG_SC_BKE0_2E_H      _PK_H_(0xE0, 0x2E)
#define REG_SC_BKE0_2F_L      _PK_L_(0xE0, 0x2F)
#define REG_SC_BKE0_2F_H      _PK_H_(0xE0, 0x2F)
#define REG_SC_BKE0_30_L      _PK_L_(0xE0, 0x30)
#define REG_SC_BKE0_30_H      _PK_H_(0xE0, 0x30)
#define REG_SC_BKE0_31_L      _PK_L_(0xE0, 0x31)
#define REG_SC_BKE0_31_H      _PK_H_(0xE0, 0x31)
#define REG_SC_BKE0_32_L      _PK_L_(0xE0, 0x32)
#define REG_SC_BKE0_32_H      _PK_H_(0xE0, 0x32)
#define REG_SC_BKE0_33_L      _PK_L_(0xE0, 0x33)
#define REG_SC_BKE0_33_H      _PK_H_(0xE0, 0x33)
#define REG_SC_BKE0_34_L      _PK_L_(0xE0, 0x34)
#define REG_SC_BKE0_34_H      _PK_H_(0xE0, 0x34)
#define REG_SC_BKE0_35_L      _PK_L_(0xE0, 0x35)
#define REG_SC_BKE0_35_H      _PK_H_(0xE0, 0x35)
#define REG_SC_BKE0_36_L      _PK_L_(0xE0, 0x36)
#define REG_SC_BKE0_36_H      _PK_H_(0xE0, 0x36)
#define REG_SC_BKE0_37_L      _PK_L_(0xE0, 0x37)
#define REG_SC_BKE0_37_H      _PK_H_(0xE0, 0x37)
#define REG_SC_BKE0_38_L      _PK_L_(0xE0, 0x38)
#define REG_SC_BKE0_38_H      _PK_H_(0xE0, 0x38)
#define REG_SC_BKE0_39_L      _PK_L_(0xE0, 0x39)
#define REG_SC_BKE0_39_H      _PK_H_(0xE0, 0x39)
#define REG_SC_BKE0_3A_L      _PK_L_(0xE0, 0x3A)
#define REG_SC_BKE0_3A_H      _PK_H_(0xE0, 0x3A)
#define REG_SC_BKE0_3B_L      _PK_L_(0xE0, 0x3B)
#define REG_SC_BKE0_3B_H      _PK_H_(0xE0, 0x3B)
#define REG_SC_BKE0_3C_L      _PK_L_(0xE0, 0x3C)
#define REG_SC_BKE0_3C_H      _PK_H_(0xE0, 0x3C)
#define REG_SC_BKE0_3D_L      _PK_L_(0xE0, 0x3D)
#define REG_SC_BKE0_3D_H      _PK_H_(0xE0, 0x3D)
#define REG_SC_BKE0_3E_L      _PK_L_(0xE0, 0x3E)
#define REG_SC_BKE0_3E_H      _PK_H_(0xE0, 0x3E)
#define REG_SC_BKE0_3F_L      _PK_L_(0xE0, 0x3F)
#define REG_SC_BKE0_3F_H      _PK_H_(0xE0, 0x3F)
#define REG_SC_BKE0_40_L      _PK_L_(0xE0, 0x40)
#define REG_SC_BKE0_40_H      _PK_H_(0xE0, 0x40)
#define REG_SC_BKE0_41_L      _PK_L_(0xE0, 0x41)
#define REG_SC_BKE0_41_H      _PK_H_(0xE0, 0x41)
#define REG_SC_BKE0_42_L      _PK_L_(0xE0, 0x42)
#define REG_SC_BKE0_42_H      _PK_H_(0xE0, 0x42)
#define REG_SC_BKE0_43_L      _PK_L_(0xE0, 0x43)
#define REG_SC_BKE0_43_H      _PK_H_(0xE0, 0x43)
#define REG_SC_BKE0_44_L      _PK_L_(0xE0, 0x44)
#define REG_SC_BKE0_44_H      _PK_H_(0xE0, 0x44)
#define REG_SC_BKE0_45_L      _PK_L_(0xE0, 0x45)
#define REG_SC_BKE0_45_H      _PK_H_(0xE0, 0x45)
#define REG_SC_BKE0_46_L      _PK_L_(0xE0, 0x46)
#define REG_SC_BKE0_46_H      _PK_H_(0xE0, 0x46)
#define REG_SC_BKE0_47_L      _PK_L_(0xE0, 0x47)
#define REG_SC_BKE0_47_H      _PK_H_(0xE0, 0x47)
#define REG_SC_BKE0_48_L      _PK_L_(0xE0, 0x48)
#define REG_SC_BKE0_48_H      _PK_H_(0xE0, 0x48)
#define REG_SC_BKE0_49_L      _PK_L_(0xE0, 0x49)
#define REG_SC_BKE0_49_H      _PK_H_(0xE0, 0x49)
#define REG_SC_BKE0_4A_L      _PK_L_(0xE0, 0x4A)
#define REG_SC_BKE0_4A_H      _PK_H_(0xE0, 0x4A)
#define REG_SC_BKE0_4B_L      _PK_L_(0xE0, 0x4B)
#define REG_SC_BKE0_4B_H      _PK_H_(0xE0, 0x4B)
#define REG_SC_BKE0_4C_L      _PK_L_(0xE0, 0x4C)
#define REG_SC_BKE0_4C_H      _PK_H_(0xE0, 0x4C)
#define REG_SC_BKE0_4D_L      _PK_L_(0xE0, 0x4D)
#define REG_SC_BKE0_4D_H      _PK_H_(0xE0, 0x4D)
#define REG_SC_BKE0_4E_L      _PK_L_(0xE0, 0x4E)
#define REG_SC_BKE0_4E_H      _PK_H_(0xE0, 0x4E)
#define REG_SC_BKE0_4F_L      _PK_L_(0xE0, 0x4F)
#define REG_SC_BKE0_4F_H      _PK_H_(0xE0, 0x4F)
#define REG_SC_BKE0_50_L      _PK_L_(0xE0, 0x50)
#define REG_SC_BKE0_50_H      _PK_H_(0xE0, 0x50)
#define REG_SC_BKE0_51_L      _PK_L_(0xE0, 0x51)
#define REG_SC_BKE0_51_H      _PK_H_(0xE0, 0x51)
#define REG_SC_BKE0_52_L      _PK_L_(0xE0, 0x52)
#define REG_SC_BKE0_52_H      _PK_H_(0xE0, 0x52)
#define REG_SC_BKE0_53_L      _PK_L_(0xE0, 0x53)
#define REG_SC_BKE0_53_H      _PK_H_(0xE0, 0x53)
#define REG_SC_BKE0_54_L      _PK_L_(0xE0, 0x54)
#define REG_SC_BKE0_54_H      _PK_H_(0xE0, 0x54)
#define REG_SC_BKE0_55_L      _PK_L_(0xE0, 0x55)
#define REG_SC_BKE0_55_H      _PK_H_(0xE0, 0x55)
#define REG_SC_BKE0_56_L      _PK_L_(0xE0, 0x56)
#define REG_SC_BKE0_56_H      _PK_H_(0xE0, 0x56)
#define REG_SC_BKE0_57_L      _PK_L_(0xE0, 0x57)
#define REG_SC_BKE0_57_H      _PK_H_(0xE0, 0x57)
#define REG_SC_BKE0_58_L      _PK_L_(0xE0, 0x58)
#define REG_SC_BKE0_58_H      _PK_H_(0xE0, 0x58)
#define REG_SC_BKE0_59_L      _PK_L_(0xE0, 0x59)
#define REG_SC_BKE0_59_H      _PK_H_(0xE0, 0x59)
#define REG_SC_BKE0_5A_L      _PK_L_(0xE0, 0x5A)
#define REG_SC_BKE0_5A_H      _PK_H_(0xE0, 0x5A)
#define REG_SC_BKE0_5B_L      _PK_L_(0xE0, 0x5B)
#define REG_SC_BKE0_5B_H      _PK_H_(0xE0, 0x5B)
#define REG_SC_BKE0_5C_L      _PK_L_(0xE0, 0x5C)
#define REG_SC_BKE0_5C_H      _PK_H_(0xE0, 0x5C)
#define REG_SC_BKE0_5D_L      _PK_L_(0xE0, 0x5D)
#define REG_SC_BKE0_5D_H      _PK_H_(0xE0, 0x5D)
#define REG_SC_BKE0_5E_L      _PK_L_(0xE0, 0x5E)
#define REG_SC_BKE0_5E_H      _PK_H_(0xE0, 0x5E)
#define REG_SC_BKE0_5F_L      _PK_L_(0xE0, 0x5F)
#define REG_SC_BKE0_5F_H      _PK_H_(0xE0, 0x5F)
#define REG_SC_BKE0_60_L      _PK_L_(0xE0, 0x60)
#define REG_SC_BKE0_60_H      _PK_H_(0xE0, 0x60)
#define REG_SC_BKE0_61_L      _PK_L_(0xE0, 0x61)
#define REG_SC_BKE0_61_H      _PK_H_(0xE0, 0x61)
#define REG_SC_BKE0_62_L      _PK_L_(0xE0, 0x62)
#define REG_SC_BKE0_62_H      _PK_H_(0xE0, 0x62)
#define REG_SC_BKE0_63_L      _PK_L_(0xE0, 0x63)
#define REG_SC_BKE0_63_H      _PK_H_(0xE0, 0x63)
#define REG_SC_BKE0_64_L      _PK_L_(0xE0, 0x64)
#define REG_SC_BKE0_64_H      _PK_H_(0xE0, 0x64)
#define REG_SC_BKE0_65_L      _PK_L_(0xE0, 0x65)
#define REG_SC_BKE0_65_H      _PK_H_(0xE0, 0x65)
#define REG_SC_BKE0_66_L      _PK_L_(0xE0, 0x66)
#define REG_SC_BKE0_66_H      _PK_H_(0xE0, 0x66)
#define REG_SC_BKE0_67_L      _PK_L_(0xE0, 0x67)
#define REG_SC_BKE0_67_H      _PK_H_(0xE0, 0x67)
#define REG_SC_BKE0_68_L      _PK_L_(0xE0, 0x68)
#define REG_SC_BKE0_68_H      _PK_H_(0xE0, 0x68)
#define REG_SC_BKE0_69_L      _PK_L_(0xE0, 0x69)
#define REG_SC_BKE0_69_H      _PK_H_(0xE0, 0x69)
#define REG_SC_BKE0_6A_L      _PK_L_(0xE0, 0x6A)
#define REG_SC_BKE0_6A_H      _PK_H_(0xE0, 0x6A)
#define REG_SC_BKE0_6B_L      _PK_L_(0xE0, 0x6B)
#define REG_SC_BKE0_6B_H      _PK_H_(0xE0, 0x6B)
#define REG_SC_BKE0_6C_L      _PK_L_(0xE0, 0x6C)
#define REG_SC_BKE0_6C_H      _PK_H_(0xE0, 0x6C)
#define REG_SC_BKE0_6D_L      _PK_L_(0xE0, 0x6D)
#define REG_SC_BKE0_6D_H      _PK_H_(0xE0, 0x6D)
#define REG_SC_BKE0_6E_L      _PK_L_(0xE0, 0x6E)
#define REG_SC_BKE0_6E_H      _PK_H_(0xE0, 0x6E)
#define REG_SC_BKE0_6F_L      _PK_L_(0xE0, 0x6F)
#define REG_SC_BKE0_6F_H      _PK_H_(0xE0, 0x6F)
#define REG_SC_BKE0_70_L      _PK_L_(0xE0, 0x70)
#define REG_SC_BKE0_70_H      _PK_H_(0xE0, 0x70)
#define REG_SC_BKE0_71_L      _PK_L_(0xE0, 0x71)
#define REG_SC_BKE0_71_H      _PK_H_(0xE0, 0x71)
#define REG_SC_BKE0_72_L      _PK_L_(0xE0, 0x72)
#define REG_SC_BKE0_72_H      _PK_H_(0xE0, 0x72)
#define REG_SC_BKE0_73_L      _PK_L_(0xE0, 0x73)
#define REG_SC_BKE0_73_H      _PK_H_(0xE0, 0x73)
#define REG_SC_BKE0_74_L      _PK_L_(0xE0, 0x74)
#define REG_SC_BKE0_74_H      _PK_H_(0xE0, 0x74)
#define REG_SC_BKE0_75_L      _PK_L_(0xE0, 0x75)
#define REG_SC_BKE0_75_H      _PK_H_(0xE0, 0x75)
#define REG_SC_BKE0_76_L      _PK_L_(0xE0, 0x76)
#define REG_SC_BKE0_76_H      _PK_H_(0xE0, 0x76)
#define REG_SC_BKE0_77_L      _PK_L_(0xE0, 0x77)
#define REG_SC_BKE0_77_H      _PK_H_(0xE0, 0x77)
#define REG_SC_BKE0_78_L      _PK_L_(0xE0, 0x78)
#define REG_SC_BKE0_78_H      _PK_H_(0xE0, 0x78)
#define REG_SC_BKE0_79_L      _PK_L_(0xE0, 0x79)
#define REG_SC_BKE0_79_H      _PK_H_(0xE0, 0x79)
#define REG_SC_BKE0_7A_L      _PK_L_(0xE0, 0x7A)
#define REG_SC_BKE0_7A_H      _PK_H_(0xE0, 0x7A)
#define REG_SC_BKE0_7B_L      _PK_L_(0xE0, 0x7B)
#define REG_SC_BKE0_7B_H      _PK_H_(0xE0, 0x7B)
#define REG_SC_BKE0_7C_L      _PK_L_(0xE0, 0x7C)
#define REG_SC_BKE0_7C_H      _PK_H_(0xE0, 0x7C)
#define REG_SC_BKE0_7D_L      _PK_L_(0xE0, 0x7D)
#define REG_SC_BKE0_7D_H      _PK_H_(0xE0, 0x7D)
#define REG_SC_BKE0_7E_L      _PK_L_(0xE0, 0x7E)
#define REG_SC_BKE0_7E_H      _PK_H_(0xE0, 0x7E)
#define REG_SC_BKE0_7F_L      _PK_L_(0xE0, 0x7F)
#define REG_SC_BKE0_7F_H      _PK_H_(0xE0, 0x7F)
//----------------------------------------------
#define REG_SC_BKE1_00_L      _PK_L_(0xE1, 0x00)
#define REG_SC_BKE1_00_H      _PK_H_(0xE1, 0x00)
#define REG_SC_BKE1_01_L      _PK_L_(0xE1, 0x01)
#define REG_SC_BKE1_01_H      _PK_H_(0xE1, 0x01)
#define REG_SC_BKE1_02_L      _PK_L_(0xE1, 0x02)
#define REG_SC_BKE1_02_H      _PK_H_(0xE1, 0x02)
#define REG_SC_BKE1_03_L      _PK_L_(0xE1, 0x03)
#define REG_SC_BKE1_03_H      _PK_H_(0xE1, 0x03)
#define REG_SC_BKE1_04_L      _PK_L_(0xE1, 0x04)
#define REG_SC_BKE1_04_H      _PK_H_(0xE1, 0x04)
#define REG_SC_BKE1_05_L      _PK_L_(0xE1, 0x05)
#define REG_SC_BKE1_05_H      _PK_H_(0xE1, 0x05)
#define REG_SC_BKE1_06_L      _PK_L_(0xE1, 0x06)
#define REG_SC_BKE1_06_H      _PK_H_(0xE1, 0x06)
#define REG_SC_BKE1_07_L      _PK_L_(0xE1, 0x07)
#define REG_SC_BKE1_07_H      _PK_H_(0xE1, 0x07)
#define REG_SC_BKE1_08_L      _PK_L_(0xE1, 0x08)
#define REG_SC_BKE1_08_H      _PK_H_(0xE1, 0x08)
#define REG_SC_BKE1_09_L      _PK_L_(0xE1, 0x09)
#define REG_SC_BKE1_09_H      _PK_H_(0xE1, 0x09)
#define REG_SC_BKE1_0A_L      _PK_L_(0xE1, 0x0A)
#define REG_SC_BKE1_0A_H      _PK_H_(0xE1, 0x0A)
#define REG_SC_BKE1_0B_L      _PK_L_(0xE1, 0x0B)
#define REG_SC_BKE1_0B_H      _PK_H_(0xE1, 0x0B)
#define REG_SC_BKE1_0C_L      _PK_L_(0xE1, 0x0C)
#define REG_SC_BKE1_0C_H      _PK_H_(0xE1, 0x0C)
#define REG_SC_BKE1_0D_L      _PK_L_(0xE1, 0x0D)
#define REG_SC_BKE1_0D_H      _PK_H_(0xE1, 0x0D)
#define REG_SC_BKE1_0E_L      _PK_L_(0xE1, 0x0E)
#define REG_SC_BKE1_0E_H      _PK_H_(0xE1, 0x0E)
#define REG_SC_BKE1_0F_L      _PK_L_(0xE1, 0x0F)
#define REG_SC_BKE1_0F_H      _PK_H_(0xE1, 0x0F)
#define REG_SC_BKE1_10_L      _PK_L_(0xE1, 0x10)
#define REG_SC_BKE1_10_H      _PK_H_(0xE1, 0x10)
#define REG_SC_BKE1_11_L      _PK_L_(0xE1, 0x11)
#define REG_SC_BKE1_11_H      _PK_H_(0xE1, 0x11)
#define REG_SC_BKE1_12_L      _PK_L_(0xE1, 0x12)
#define REG_SC_BKE1_12_H      _PK_H_(0xE1, 0x12)
#define REG_SC_BKE1_13_L      _PK_L_(0xE1, 0x13)
#define REG_SC_BKE1_13_H      _PK_H_(0xE1, 0x13)
#define REG_SC_BKE1_14_L      _PK_L_(0xE1, 0x14)
#define REG_SC_BKE1_14_H      _PK_H_(0xE1, 0x14)
#define REG_SC_BKE1_15_L      _PK_L_(0xE1, 0x15)
#define REG_SC_BKE1_15_H      _PK_H_(0xE1, 0x15)
#define REG_SC_BKE1_16_L      _PK_L_(0xE1, 0x16)
#define REG_SC_BKE1_16_H      _PK_H_(0xE1, 0x16)
#define REG_SC_BKE1_17_L      _PK_L_(0xE1, 0x17)
#define REG_SC_BKE1_17_H      _PK_H_(0xE1, 0x17)
#define REG_SC_BKE1_18_L      _PK_L_(0xE1, 0x18)
#define REG_SC_BKE1_18_H      _PK_H_(0xE1, 0x18)
#define REG_SC_BKE1_19_L      _PK_L_(0xE1, 0x19)
#define REG_SC_BKE1_19_H      _PK_H_(0xE1, 0x19)
#define REG_SC_BKE1_1A_L      _PK_L_(0xE1, 0x1A)
#define REG_SC_BKE1_1A_H      _PK_H_(0xE1, 0x1A)
#define REG_SC_BKE1_1B_L      _PK_L_(0xE1, 0x1B)
#define REG_SC_BKE1_1B_H      _PK_H_(0xE1, 0x1B)
#define REG_SC_BKE1_1C_L      _PK_L_(0xE1, 0x1C)
#define REG_SC_BKE1_1C_H      _PK_H_(0xE1, 0x1C)
#define REG_SC_BKE1_1D_L      _PK_L_(0xE1, 0x1D)
#define REG_SC_BKE1_1D_H      _PK_H_(0xE1, 0x1D)
#define REG_SC_BKE1_1E_L      _PK_L_(0xE1, 0x1E)
#define REG_SC_BKE1_1E_H      _PK_H_(0xE1, 0x1E)
#define REG_SC_BKE1_1F_L      _PK_L_(0xE1, 0x1F)
#define REG_SC_BKE1_1F_H      _PK_H_(0xE1, 0x1F)
#define REG_SC_BKE1_20_L      _PK_L_(0xE1, 0x20)
#define REG_SC_BKE1_20_H      _PK_H_(0xE1, 0x20)
#define REG_SC_BKE1_21_L      _PK_L_(0xE1, 0x21)
#define REG_SC_BKE1_21_H      _PK_H_(0xE1, 0x21)
#define REG_SC_BKE1_22_L      _PK_L_(0xE1, 0x22)
#define REG_SC_BKE1_22_H      _PK_H_(0xE1, 0x22)
#define REG_SC_BKE1_23_L      _PK_L_(0xE1, 0x23)
#define REG_SC_BKE1_23_H      _PK_H_(0xE1, 0x23)
#define REG_SC_BKE1_24_L      _PK_L_(0xE1, 0x24)
#define REG_SC_BKE1_24_H      _PK_H_(0xE1, 0x24)
#define REG_SC_BKE1_25_L      _PK_L_(0xE1, 0x25)
#define REG_SC_BKE1_25_H      _PK_H_(0xE1, 0x25)
#define REG_SC_BKE1_26_L      _PK_L_(0xE1, 0x26)
#define REG_SC_BKE1_26_H      _PK_H_(0xE1, 0x26)
#define REG_SC_BKE1_27_L      _PK_L_(0xE1, 0x27)
#define REG_SC_BKE1_27_H      _PK_H_(0xE1, 0x27)
#define REG_SC_BKE1_28_L      _PK_L_(0xE1, 0x28)
#define REG_SC_BKE1_28_H      _PK_H_(0xE1, 0x28)
#define REG_SC_BKE1_29_L      _PK_L_(0xE1, 0x29)
#define REG_SC_BKE1_29_H      _PK_H_(0xE1, 0x29)
#define REG_SC_BKE1_2A_L      _PK_L_(0xE1, 0x2A)
#define REG_SC_BKE1_2A_H      _PK_H_(0xE1, 0x2A)
#define REG_SC_BKE1_2B_L      _PK_L_(0xE1, 0x2B)
#define REG_SC_BKE1_2B_H      _PK_H_(0xE1, 0x2B)
#define REG_SC_BKE1_2C_L      _PK_L_(0xE1, 0x2C)
#define REG_SC_BKE1_2C_H      _PK_H_(0xE1, 0x2C)
#define REG_SC_BKE1_2D_L      _PK_L_(0xE1, 0x2D)
#define REG_SC_BKE1_2D_H      _PK_H_(0xE1, 0x2D)
#define REG_SC_BKE1_2E_L      _PK_L_(0xE1, 0x2E)
#define REG_SC_BKE1_2E_H      _PK_H_(0xE1, 0x2E)
#define REG_SC_BKE1_2F_L      _PK_L_(0xE1, 0x2F)
#define REG_SC_BKE1_2F_H      _PK_H_(0xE1, 0x2F)
#define REG_SC_BKE1_30_L      _PK_L_(0xE1, 0x30)
#define REG_SC_BKE1_30_H      _PK_H_(0xE1, 0x30)
#define REG_SC_BKE1_31_L      _PK_L_(0xE1, 0x31)
#define REG_SC_BKE1_31_H      _PK_H_(0xE1, 0x31)
#define REG_SC_BKE1_32_L      _PK_L_(0xE1, 0x32)
#define REG_SC_BKE1_32_H      _PK_H_(0xE1, 0x32)
#define REG_SC_BKE1_33_L      _PK_L_(0xE1, 0x33)
#define REG_SC_BKE1_33_H      _PK_H_(0xE1, 0x33)
#define REG_SC_BKE1_34_L      _PK_L_(0xE1, 0x34)
#define REG_SC_BKE1_34_H      _PK_H_(0xE1, 0x34)
#define REG_SC_BKE1_35_L      _PK_L_(0xE1, 0x35)
#define REG_SC_BKE1_35_H      _PK_H_(0xE1, 0x35)
#define REG_SC_BKE1_36_L      _PK_L_(0xE1, 0x36)
#define REG_SC_BKE1_36_H      _PK_H_(0xE1, 0x36)
#define REG_SC_BKE1_37_L      _PK_L_(0xE1, 0x37)
#define REG_SC_BKE1_37_H      _PK_H_(0xE1, 0x37)
#define REG_SC_BKE1_38_L      _PK_L_(0xE1, 0x38)
#define REG_SC_BKE1_38_H      _PK_H_(0xE1, 0x38)
#define REG_SC_BKE1_39_L      _PK_L_(0xE1, 0x39)
#define REG_SC_BKE1_39_H      _PK_H_(0xE1, 0x39)
#define REG_SC_BKE1_3A_L      _PK_L_(0xE1, 0x3A)
#define REG_SC_BKE1_3A_H      _PK_H_(0xE1, 0x3A)
#define REG_SC_BKE1_3B_L      _PK_L_(0xE1, 0x3B)
#define REG_SC_BKE1_3B_H      _PK_H_(0xE1, 0x3B)
#define REG_SC_BKE1_3C_L      _PK_L_(0xE1, 0x3C)
#define REG_SC_BKE1_3C_H      _PK_H_(0xE1, 0x3C)
#define REG_SC_BKE1_3D_L      _PK_L_(0xE1, 0x3D)
#define REG_SC_BKE1_3D_H      _PK_H_(0xE1, 0x3D)
#define REG_SC_BKE1_3E_L      _PK_L_(0xE1, 0x3E)
#define REG_SC_BKE1_3E_H      _PK_H_(0xE1, 0x3E)
#define REG_SC_BKE1_3F_L      _PK_L_(0xE1, 0x3F)
#define REG_SC_BKE1_3F_H      _PK_H_(0xE1, 0x3F)
#define REG_SC_BKE1_40_L      _PK_L_(0xE1, 0x40)
#define REG_SC_BKE1_40_H      _PK_H_(0xE1, 0x40)
#define REG_SC_BKE1_41_L      _PK_L_(0xE1, 0x41)
#define REG_SC_BKE1_41_H      _PK_H_(0xE1, 0x41)
#define REG_SC_BKE1_42_L      _PK_L_(0xE1, 0x42)
#define REG_SC_BKE1_42_H      _PK_H_(0xE1, 0x42)
#define REG_SC_BKE1_43_L      _PK_L_(0xE1, 0x43)
#define REG_SC_BKE1_43_H      _PK_H_(0xE1, 0x43)
#define REG_SC_BKE1_44_L      _PK_L_(0xE1, 0x44)
#define REG_SC_BKE1_44_H      _PK_H_(0xE1, 0x44)
#define REG_SC_BKE1_45_L      _PK_L_(0xE1, 0x45)
#define REG_SC_BKE1_45_H      _PK_H_(0xE1, 0x45)
#define REG_SC_BKE1_46_L      _PK_L_(0xE1, 0x46)
#define REG_SC_BKE1_46_H      _PK_H_(0xE1, 0x46)
#define REG_SC_BKE1_47_L      _PK_L_(0xE1, 0x47)
#define REG_SC_BKE1_47_H      _PK_H_(0xE1, 0x47)
#define REG_SC_BKE1_48_L      _PK_L_(0xE1, 0x48)
#define REG_SC_BKE1_48_H      _PK_H_(0xE1, 0x48)
#define REG_SC_BKE1_49_L      _PK_L_(0xE1, 0x49)
#define REG_SC_BKE1_49_H      _PK_H_(0xE1, 0x49)
#define REG_SC_BKE1_4A_L      _PK_L_(0xE1, 0x4A)
#define REG_SC_BKE1_4A_H      _PK_H_(0xE1, 0x4A)
#define REG_SC_BKE1_4B_L      _PK_L_(0xE1, 0x4B)
#define REG_SC_BKE1_4B_H      _PK_H_(0xE1, 0x4B)
#define REG_SC_BKE1_4C_L      _PK_L_(0xE1, 0x4C)
#define REG_SC_BKE1_4C_H      _PK_H_(0xE1, 0x4C)
#define REG_SC_BKE1_4D_L      _PK_L_(0xE1, 0x4D)
#define REG_SC_BKE1_4D_H      _PK_H_(0xE1, 0x4D)
#define REG_SC_BKE1_4E_L      _PK_L_(0xE1, 0x4E)
#define REG_SC_BKE1_4E_H      _PK_H_(0xE1, 0x4E)
#define REG_SC_BKE1_4F_L      _PK_L_(0xE1, 0x4F)
#define REG_SC_BKE1_4F_H      _PK_H_(0xE1, 0x4F)
#define REG_SC_BKE1_50_L      _PK_L_(0xE1, 0x50)
#define REG_SC_BKE1_50_H      _PK_H_(0xE1, 0x50)
#define REG_SC_BKE1_51_L      _PK_L_(0xE1, 0x51)
#define REG_SC_BKE1_51_H      _PK_H_(0xE1, 0x51)
#define REG_SC_BKE1_52_L      _PK_L_(0xE1, 0x52)
#define REG_SC_BKE1_52_H      _PK_H_(0xE1, 0x52)
#define REG_SC_BKE1_53_L      _PK_L_(0xE1, 0x53)
#define REG_SC_BKE1_53_H      _PK_H_(0xE1, 0x53)
#define REG_SC_BKE1_54_L      _PK_L_(0xE1, 0x54)
#define REG_SC_BKE1_54_H      _PK_H_(0xE1, 0x54)
#define REG_SC_BKE1_55_L      _PK_L_(0xE1, 0x55)
#define REG_SC_BKE1_55_H      _PK_H_(0xE1, 0x55)
#define REG_SC_BKE1_56_L      _PK_L_(0xE1, 0x56)
#define REG_SC_BKE1_56_H      _PK_H_(0xE1, 0x56)
#define REG_SC_BKE1_57_L      _PK_L_(0xE1, 0x57)
#define REG_SC_BKE1_57_H      _PK_H_(0xE1, 0x57)
#define REG_SC_BKE1_58_L      _PK_L_(0xE1, 0x58)
#define REG_SC_BKE1_58_H      _PK_H_(0xE1, 0x58)
#define REG_SC_BKE1_59_L      _PK_L_(0xE1, 0x59)
#define REG_SC_BKE1_59_H      _PK_H_(0xE1, 0x59)
#define REG_SC_BKE1_5A_L      _PK_L_(0xE1, 0x5A)
#define REG_SC_BKE1_5A_H      _PK_H_(0xE1, 0x5A)
#define REG_SC_BKE1_5B_L      _PK_L_(0xE1, 0x5B)
#define REG_SC_BKE1_5B_H      _PK_H_(0xE1, 0x5B)
#define REG_SC_BKE1_5C_L      _PK_L_(0xE1, 0x5C)
#define REG_SC_BKE1_5C_H      _PK_H_(0xE1, 0x5C)
#define REG_SC_BKE1_5D_L      _PK_L_(0xE1, 0x5D)
#define REG_SC_BKE1_5D_H      _PK_H_(0xE1, 0x5D)
#define REG_SC_BKE1_5E_L      _PK_L_(0xE1, 0x5E)
#define REG_SC_BKE1_5E_H      _PK_H_(0xE1, 0x5E)
#define REG_SC_BKE1_5F_L      _PK_L_(0xE1, 0x5F)
#define REG_SC_BKE1_5F_H      _PK_H_(0xE1, 0x5F)
#define REG_SC_BKE1_60_L      _PK_L_(0xE1, 0x60)
#define REG_SC_BKE1_60_H      _PK_H_(0xE1, 0x60)
#define REG_SC_BKE1_61_L      _PK_L_(0xE1, 0x61)
#define REG_SC_BKE1_61_H      _PK_H_(0xE1, 0x61)
#define REG_SC_BKE1_62_L      _PK_L_(0xE1, 0x62)
#define REG_SC_BKE1_62_H      _PK_H_(0xE1, 0x62)
#define REG_SC_BKE1_63_L      _PK_L_(0xE1, 0x63)
#define REG_SC_BKE1_63_H      _PK_H_(0xE1, 0x63)
#define REG_SC_BKE1_64_L      _PK_L_(0xE1, 0x64)
#define REG_SC_BKE1_64_H      _PK_H_(0xE1, 0x64)
#define REG_SC_BKE1_65_L      _PK_L_(0xE1, 0x65)
#define REG_SC_BKE1_65_H      _PK_H_(0xE1, 0x65)
#define REG_SC_BKE1_66_L      _PK_L_(0xE1, 0x66)
#define REG_SC_BKE1_66_H      _PK_H_(0xE1, 0x66)
#define REG_SC_BKE1_67_L      _PK_L_(0xE1, 0x67)
#define REG_SC_BKE1_67_H      _PK_H_(0xE1, 0x67)
#define REG_SC_BKE1_68_L      _PK_L_(0xE1, 0x68)
#define REG_SC_BKE1_68_H      _PK_H_(0xE1, 0x68)
#define REG_SC_BKE1_69_L      _PK_L_(0xE1, 0x69)
#define REG_SC_BKE1_69_H      _PK_H_(0xE1, 0x69)
#define REG_SC_BKE1_6A_L      _PK_L_(0xE1, 0x6A)
#define REG_SC_BKE1_6A_H      _PK_H_(0xE1, 0x6A)
#define REG_SC_BKE1_6B_L      _PK_L_(0xE1, 0x6B)
#define REG_SC_BKE1_6B_H      _PK_H_(0xE1, 0x6B)
#define REG_SC_BKE1_6C_L      _PK_L_(0xE1, 0x6C)
#define REG_SC_BKE1_6C_H      _PK_H_(0xE1, 0x6C)
#define REG_SC_BKE1_6D_L      _PK_L_(0xE1, 0x6D)
#define REG_SC_BKE1_6D_H      _PK_H_(0xE1, 0x6D)
#define REG_SC_BKE1_6E_L      _PK_L_(0xE1, 0x6E)
#define REG_SC_BKE1_6E_H      _PK_H_(0xE1, 0x6E)
#define REG_SC_BKE1_6F_L      _PK_L_(0xE1, 0x6F)
#define REG_SC_BKE1_6F_H      _PK_H_(0xE1, 0x6F)
#define REG_SC_BKE1_70_L      _PK_L_(0xE1, 0x70)
#define REG_SC_BKE1_70_H      _PK_H_(0xE1, 0x70)
#define REG_SC_BKE1_71_L      _PK_L_(0xE1, 0x71)
#define REG_SC_BKE1_71_H      _PK_H_(0xE1, 0x71)
#define REG_SC_BKE1_72_L      _PK_L_(0xE1, 0x72)
#define REG_SC_BKE1_72_H      _PK_H_(0xE1, 0x72)
#define REG_SC_BKE1_73_L      _PK_L_(0xE1, 0x73)
#define REG_SC_BKE1_73_H      _PK_H_(0xE1, 0x73)
#define REG_SC_BKE1_74_L      _PK_L_(0xE1, 0x74)
#define REG_SC_BKE1_74_H      _PK_H_(0xE1, 0x74)
#define REG_SC_BKE1_75_L      _PK_L_(0xE1, 0x75)
#define REG_SC_BKE1_75_H      _PK_H_(0xE1, 0x75)
#define REG_SC_BKE1_76_L      _PK_L_(0xE1, 0x76)
#define REG_SC_BKE1_76_H      _PK_H_(0xE1, 0x76)
#define REG_SC_BKE1_77_L      _PK_L_(0xE1, 0x77)
#define REG_SC_BKE1_77_H      _PK_H_(0xE1, 0x77)
#define REG_SC_BKE1_78_L      _PK_L_(0xE1, 0x78)
#define REG_SC_BKE1_78_H      _PK_H_(0xE1, 0x78)
#define REG_SC_BKE1_79_L      _PK_L_(0xE1, 0x79)
#define REG_SC_BKE1_79_H      _PK_H_(0xE1, 0x79)
#define REG_SC_BKE1_7A_L      _PK_L_(0xE1, 0x7A)
#define REG_SC_BKE1_7A_H      _PK_H_(0xE1, 0x7A)
#define REG_SC_BKE1_7B_L      _PK_L_(0xE1, 0x7B)
#define REG_SC_BKE1_7B_H      _PK_H_(0xE1, 0x7B)
#define REG_SC_BKE1_7C_L      _PK_L_(0xE1, 0x7C)
#define REG_SC_BKE1_7C_H      _PK_H_(0xE1, 0x7C)
#define REG_SC_BKE1_7D_L      _PK_L_(0xE1, 0x7D)
#define REG_SC_BKE1_7D_H      _PK_H_(0xE1, 0x7D)
#define REG_SC_BKE1_7E_L      _PK_L_(0xE1, 0x7E)
#define REG_SC_BKE1_7E_H      _PK_H_(0xE1, 0x7E)
#define REG_SC_BKE1_7F_L      _PK_L_(0xE1, 0x7F)
#define REG_SC_BKE1_7F_H      _PK_H_(0xE1, 0x7F)
//----------------------------------------------
#define REG_BK35_00_L      0x3500
#define REG_BK35_00_H      0x3501
#define REG_BK35_01_L      0x3502
#define REG_BK35_01_H      0x3503
#define REG_BK35_02_L      0x3504
#define REG_BK35_02_H      0x3505
#define REG_BK35_03_L      0x3506
#define REG_BK35_03_H      0x3507
#define REG_BK35_04_L      0x3508
#define REG_BK35_04_H      0x3509
#define REG_BK35_05_L      0x350A
#define REG_BK35_05_H      0x350B
#define REG_BK35_06_L      0x350C
#define REG_BK35_06_H      0x350D
#define REG_BK35_07_L      0x350E
#define REG_BK35_07_H      0x350F
#define REG_BK35_08_L      0x3510
#define REG_BK35_08_H      0x3511
#define REG_BK35_09_L      0x3512
#define REG_BK35_09_H      0x3513
#define REG_BK35_0A_L      0x3514
#define REG_BK35_0A_H      0x3515
#define REG_BK35_0B_L      0x3516
#define REG_BK35_0B_H      0x3517
#define REG_BK35_0C_L      0x3518
#define REG_BK35_0C_H      0x3519
#define REG_BK35_0D_L      0x351A
#define REG_BK35_0D_H      0x351B
#define REG_BK35_0E_L      0x351C
#define REG_BK35_0E_H      0x351D
#define REG_BK35_0F_L      0x351E
#define REG_BK35_0F_H      0x351F
#define REG_BK35_10_L      0x3520
#define REG_BK35_10_H      0x3521
#define REG_BK35_11_L      0x3522
#define REG_BK35_11_H      0x3523
#define REG_BK35_12_L      0x3524
#define REG_BK35_12_H      0x3525
#define REG_BK35_13_L      0x3526
#define REG_BK35_13_H      0x3527
#define REG_BK35_14_L      0x3528
#define REG_BK35_14_H      0x3529
#define REG_BK35_15_L      0x352A
#define REG_BK35_15_H      0x352B
#define REG_BK35_16_L      0x352C
#define REG_BK35_16_H      0x352D
#define REG_BK35_17_L      0x352E
#define REG_BK35_17_H      0x352F
#define REG_BK35_18_L      0x3530
#define REG_BK35_18_H      0x3531
#define REG_BK35_19_L      0x3532
#define REG_BK35_19_H      0x3533
#define REG_BK35_1A_L      0x3534
#define REG_BK35_1A_H      0x3535
#define REG_BK35_1B_L      0x3536
#define REG_BK35_1B_H      0x3537
#define REG_BK35_1C_L      0x3538
#define REG_BK35_1C_H      0x3539
#define REG_BK35_1D_L      0x353A
#define REG_BK35_1D_H      0x353B
#define REG_BK35_1E_L      0x353C
#define REG_BK35_1E_H      0x353D
#define REG_BK35_1F_L      0x353E
#define REG_BK35_1F_H      0x353F
#define REG_BK35_20_L      0x3540
#define REG_BK35_20_H      0x3541
#define REG_BK35_21_L      0x3542
#define REG_BK35_21_H      0x3543
#define REG_BK35_22_L      0x3544
#define REG_BK35_22_H      0x3545
#define REG_BK35_23_L      0x3546
#define REG_BK35_23_H      0x3547
#define REG_BK35_24_L      0x3548
#define REG_BK35_24_H      0x3549
#define REG_BK35_25_L      0x354A
#define REG_BK35_25_H      0x354B
#define REG_BK35_26_L      0x354C
#define REG_BK35_26_H      0x354D
#define REG_BK35_27_L      0x354E
#define REG_BK35_27_H      0x354F
#define REG_BK35_28_L      0x3550
#define REG_BK35_28_H      0x3551
#define REG_BK35_29_L      0x3552
#define REG_BK35_29_H      0x3553
#define REG_BK35_2A_L      0x3554
#define REG_BK35_2A_H      0x3555
#define REG_BK35_2B_L      0x3556
#define REG_BK35_2B_H      0x3557
#define REG_BK35_2C_L      0x3558
#define REG_BK35_2C_H      0x3559
#define REG_BK35_2D_L      0x355A
#define REG_BK35_2D_H      0x355B
#define REG_BK35_2E_L      0x355C
#define REG_BK35_2E_H      0x355D
#define REG_BK35_2F_L      0x355E
#define REG_BK35_2F_H      0x355F
#define REG_BK35_30_L      0x3560
#define REG_BK35_30_H      0x3561
#define REG_BK35_31_L      0x3562
#define REG_BK35_31_H      0x3563
#define REG_BK35_32_L      0x3564
#define REG_BK35_32_H      0x3565
#define REG_BK35_33_L      0x3566
#define REG_BK35_33_H      0x3567
#define REG_BK35_34_L      0x3568
#define REG_BK35_34_H      0x3569
#define REG_BK35_35_L      0x356A
#define REG_BK35_35_H      0x356B
#define REG_BK35_36_L      0x356C
#define REG_BK35_36_H      0x356D
#define REG_BK35_37_L      0x356E
#define REG_BK35_37_H      0x356F
#define REG_BK35_38_L      0x3570
#define REG_BK35_38_H      0x3571
#define REG_BK35_39_L      0x3572
#define REG_BK35_39_H      0x3573
#define REG_BK35_3A_L      0x3574
#define REG_BK35_3A_H      0x3575
#define REG_BK35_3B_L      0x3576
#define REG_BK35_3B_H      0x3577
#define REG_BK35_3C_L      0x3578
#define REG_BK35_3C_H      0x3579
#define REG_BK35_3D_L      0x357A
#define REG_BK35_3D_H      0x357B
#define REG_BK35_3E_L      0x357C
#define REG_BK35_3E_H      0x357D
#define REG_BK35_3F_L      0x357E
#define REG_BK35_3F_H      0x357F
#define REG_BK35_40_L      0x3580
#define REG_BK35_40_H      0x3581
#define REG_BK35_41_L      0x3582
#define REG_BK35_41_H      0x3583
#define REG_BK35_42_L      0x3584
#define REG_BK35_42_H      0x3585
#define REG_BK35_43_L      0x3586
#define REG_BK35_43_H      0x3587
#define REG_BK35_44_L      0x3588
#define REG_BK35_44_H      0x3589
#define REG_BK35_45_L      0x358A
#define REG_BK35_45_H      0x358B
#define REG_BK35_46_L      0x358C
#define REG_BK35_46_H      0x358D
#define REG_BK35_47_L      0x358E
#define REG_BK35_47_H      0x358F
#define REG_BK35_48_L      0x3590
#define REG_BK35_48_H      0x3591
#define REG_BK35_49_L      0x3592
#define REG_BK35_49_H      0x3593
#define REG_BK35_4A_L      0x3594
#define REG_BK35_4A_H      0x3595
#define REG_BK35_4B_L      0x3596
#define REG_BK35_4B_H      0x3597
#define REG_BK35_4C_L      0x3598
#define REG_BK35_4C_H      0x3599
#define REG_BK35_4D_L      0x359A
#define REG_BK35_4D_H      0x359B
#define REG_BK35_4E_L      0x359C
#define REG_BK35_4E_H      0x359D
#define REG_BK35_4F_L      0x359E
#define REG_BK35_4F_H      0x359F
#define REG_BK35_50_L      0x35A0
#define REG_BK35_50_H      0x35A1
#define REG_BK35_51_L      0x35A2
#define REG_BK35_51_H      0x35A3
#define REG_BK35_52_L      0x35A4
#define REG_BK35_52_H      0x35A5
#define REG_BK35_53_L      0x35A6
#define REG_BK35_53_H      0x35A7
#define REG_BK35_54_L      0x35A8
#define REG_BK35_54_H      0x35A9
#define REG_BK35_55_L      0x35AA
#define REG_BK35_55_H      0x35AB
#define REG_BK35_56_L      0x35AC
#define REG_BK35_56_H      0x35AD
#define REG_BK35_57_L      0x35AE
#define REG_BK35_57_H      0x35AF
#define REG_BK35_58_L      0x35B0
#define REG_BK35_58_H      0x35B1
#define REG_BK35_59_L      0x35B2
#define REG_BK35_59_H      0x35B3
#define REG_BK35_5A_L      0x35B4
#define REG_BK35_5A_H      0x35B5
#define REG_BK35_5B_L      0x35B6
#define REG_BK35_5B_H      0x35B7
#define REG_BK35_5C_L      0x35B8
#define REG_BK35_5C_H      0x35B9
#define REG_BK35_5D_L      0x35BA
#define REG_BK35_5D_H      0x35BB
#define REG_BK35_5E_L      0x35BC
#define REG_BK35_5E_H      0x35BD
#define REG_BK35_5F_L      0x35BE
#define REG_BK35_5F_H      0x35BF
#define REG_BK35_60_L      0x35C0
#define REG_BK35_60_H      0x35C1
#define REG_BK35_61_L      0x35C2
#define REG_BK35_61_H      0x35C3
#define REG_BK35_62_L      0x35C4
#define REG_BK35_62_H      0x35C5
#define REG_BK35_63_L      0x35C6
#define REG_BK35_63_H      0x35C7
#define REG_BK35_64_L      0x35C8
#define REG_BK35_64_H      0x35C9
#define REG_BK35_65_L      0x35CA
#define REG_BK35_65_H      0x35CB
#define REG_BK35_66_L      0x35CC
#define REG_BK35_66_H      0x35CD
#define REG_BK35_67_L      0x35CE
#define REG_BK35_67_H      0x35CF
#define REG_BK35_68_L      0x35D0
#define REG_BK35_68_H      0x35D1
#define REG_BK35_69_L      0x35D2
#define REG_BK35_69_H      0x35D3
#define REG_BK35_6A_L      0x35D4
#define REG_BK35_6A_H      0x35D5
#define REG_BK35_6B_L      0x35D6
#define REG_BK35_6B_H      0x35D7
#define REG_BK35_6C_L      0x35D8
#define REG_BK35_6C_H      0x35D9
#define REG_BK35_6D_L      0x35DA
#define REG_BK35_6D_H      0x35DB
#define REG_BK35_6E_L      0x35DC
#define REG_BK35_6E_H      0x35DD
#define REG_BK35_6F_L      0x35DE
#define REG_BK35_6F_H      0x35DF
#define REG_BK35_70_L      0x35E0
#define REG_BK35_70_H      0x35E1
#define REG_BK35_71_L      0x35E2
#define REG_BK35_71_H      0x35E3
#define REG_BK35_72_L      0x35E4
#define REG_BK35_72_H      0x35E5
#define REG_BK35_73_L      0x35E6
#define REG_BK35_73_H      0x35E7
#define REG_BK35_74_L      0x35E8
#define REG_BK35_74_H      0x35E9
#define REG_BK35_75_L      0x35EA
#define REG_BK35_75_H      0x35EB
#define REG_BK35_76_L      0x35EC
#define REG_BK35_76_H      0x35ED
#define REG_BK35_77_L      0x35EE
#define REG_BK35_77_H      0x35EF
#define REG_BK35_78_L      0x35F0
#define REG_BK35_78_H      0x35F1
#define REG_BK35_79_L      0x35F2
#define REG_BK35_79_H      0x35F3
#define REG_BK35_7A_L      0x35F4
#define REG_BK35_7A_H      0x35F5
#define REG_BK35_7B_L      0x35F6
#define REG_BK35_7B_H      0x35F7
#define REG_BK35_7C_L      0x35F8
#define REG_BK35_7C_H      0x35F9
#define REG_BK35_7D_L      0x35FA
#define REG_BK35_7D_H      0x35FB
#define REG_BK35_7E_L      0x35FC
#define REG_BK35_7E_H      0x35FD
#define REG_BK35_7F_L      0x35FE
#define REG_BK35_7F_H      0x35FF
//----------------------------------------------
#define REG_COMB_BK00_00_L      _PK_L_(0x00, 0x00)
#define REG_COMB_BK00_00_H      _PK_H_(0x00, 0x00)
#define REG_COMB_BK00_01_L      _PK_L_(0x00, 0x01)
#define REG_COMB_BK00_01_H      _PK_H_(0x00, 0x01)
#define REG_COMB_BK00_02_L      _PK_L_(0x00, 0x02)
#define REG_COMB_BK00_02_H      _PK_H_(0x00, 0x02)
#define REG_COMB_BK00_03_L      _PK_L_(0x00, 0x03)
#define REG_COMB_BK00_03_H      _PK_H_(0x00, 0x03)
#define REG_COMB_BK00_04_L      _PK_L_(0x00, 0x04)
#define REG_COMB_BK00_04_H      _PK_H_(0x00, 0x04)
#define REG_COMB_BK00_05_L      _PK_L_(0x00, 0x05)
#define REG_COMB_BK00_05_H      _PK_H_(0x00, 0x05)
#define REG_COMB_BK00_06_L      _PK_L_(0x00, 0x06)
#define REG_COMB_BK00_06_H      _PK_H_(0x00, 0x06)
#define REG_COMB_BK00_07_L      _PK_L_(0x00, 0x07)
#define REG_COMB_BK00_07_H      _PK_H_(0x00, 0x07)
#define REG_COMB_BK00_08_L      _PK_L_(0x00, 0x08)
#define REG_COMB_BK00_08_H      _PK_H_(0x00, 0x08)
#define REG_COMB_BK00_09_L      _PK_L_(0x00, 0x09)
#define REG_COMB_BK00_09_H      _PK_H_(0x00, 0x09)
#define REG_COMB_BK00_0A_L      _PK_L_(0x00, 0x0A)
#define REG_COMB_BK00_0A_H      _PK_H_(0x00, 0x0A)
#define REG_COMB_BK00_0B_L      _PK_L_(0x00, 0x0B)
#define REG_COMB_BK00_0B_H      _PK_H_(0x00, 0x0B)
#define REG_COMB_BK00_0C_L      _PK_L_(0x00, 0x0C)
#define REG_COMB_BK00_0C_H      _PK_H_(0x00, 0x0C)
#define REG_COMB_BK00_0D_L      _PK_L_(0x00, 0x0D)
#define REG_COMB_BK00_0D_H      _PK_H_(0x00, 0x0D)
#define REG_COMB_BK00_0E_L      _PK_L_(0x00, 0x0E)
#define REG_COMB_BK00_0E_H      _PK_H_(0x00, 0x0E)
#define REG_COMB_BK00_0F_L      _PK_L_(0x00, 0x0F)
#define REG_COMB_BK00_0F_H      _PK_H_(0x00, 0x0F)
#define REG_COMB_BK00_10_L      _PK_L_(0x00, 0x10)
#define REG_COMB_BK00_10_H      _PK_H_(0x00, 0x10)
#define REG_COMB_BK00_11_L      _PK_L_(0x00, 0x11)
#define REG_COMB_BK00_11_H      _PK_H_(0x00, 0x11)
#define REG_COMB_BK00_12_L      _PK_L_(0x00, 0x12)
#define REG_COMB_BK00_12_H      _PK_H_(0x00, 0x12)
#define REG_COMB_BK00_13_L      _PK_L_(0x00, 0x13)
#define REG_COMB_BK00_13_H      _PK_H_(0x00, 0x13)
#define REG_COMB_BK00_14_L      _PK_L_(0x00, 0x14)
#define REG_COMB_BK00_14_H      _PK_H_(0x00, 0x14)
#define REG_COMB_BK00_15_L      _PK_L_(0x00, 0x15)
#define REG_COMB_BK00_15_H      _PK_H_(0x00, 0x15)
#define REG_COMB_BK00_16_L      _PK_L_(0x00, 0x16)
#define REG_COMB_BK00_16_H      _PK_H_(0x00, 0x16)
#define REG_COMB_BK00_17_L      _PK_L_(0x00, 0x17)
#define REG_COMB_BK00_17_H      _PK_H_(0x00, 0x17)
#define REG_COMB_BK00_18_L      _PK_L_(0x00, 0x18)
#define REG_COMB_BK00_18_H      _PK_H_(0x00, 0x18)
#define REG_COMB_BK00_19_L      _PK_L_(0x00, 0x19)
#define REG_COMB_BK00_19_H      _PK_H_(0x00, 0x19)
#define REG_COMB_BK00_1A_L      _PK_L_(0x00, 0x1A)
#define REG_COMB_BK00_1A_H      _PK_H_(0x00, 0x1A)
#define REG_COMB_BK00_1B_L      _PK_L_(0x00, 0x1B)
#define REG_COMB_BK00_1B_H      _PK_H_(0x00, 0x1B)
#define REG_COMB_BK00_1C_L      _PK_L_(0x00, 0x1C)
#define REG_COMB_BK00_1C_H      _PK_H_(0x00, 0x1C)
#define REG_COMB_BK00_1D_L      _PK_L_(0x00, 0x1D)
#define REG_COMB_BK00_1D_H      _PK_H_(0x00, 0x1D)
#define REG_COMB_BK00_1E_L      _PK_L_(0x00, 0x1E)
#define REG_COMB_BK00_1E_H      _PK_H_(0x00, 0x1E)
#define REG_COMB_BK00_1F_L      _PK_L_(0x00, 0x1F)
#define REG_COMB_BK00_1F_H      _PK_H_(0x00, 0x1F)
#define REG_COMB_BK00_20_L      _PK_L_(0x00, 0x20)
#define REG_COMB_BK00_20_H      _PK_H_(0x00, 0x20)
#define REG_COMB_BK00_21_L      _PK_L_(0x00, 0x21)
#define REG_COMB_BK00_21_H      _PK_H_(0x00, 0x21)
#define REG_COMB_BK00_22_L      _PK_L_(0x00, 0x22)
#define REG_COMB_BK00_22_H      _PK_H_(0x00, 0x22)
#define REG_COMB_BK00_23_L      _PK_L_(0x00, 0x23)
#define REG_COMB_BK00_23_H      _PK_H_(0x00, 0x23)
#define REG_COMB_BK00_24_L      _PK_L_(0x00, 0x24)
#define REG_COMB_BK00_24_H      _PK_H_(0x00, 0x24)
#define REG_COMB_BK00_25_L      _PK_L_(0x00, 0x25)
#define REG_COMB_BK00_25_H      _PK_H_(0x00, 0x25)
#define REG_COMB_BK00_26_L      _PK_L_(0x00, 0x26)
#define REG_COMB_BK00_26_H      _PK_H_(0x00, 0x26)
#define REG_COMB_BK00_27_L      _PK_L_(0x00, 0x27)
#define REG_COMB_BK00_27_H      _PK_H_(0x00, 0x27)
#define REG_COMB_BK00_28_L      _PK_L_(0x00, 0x28)
#define REG_COMB_BK00_28_H      _PK_H_(0x00, 0x28)
#define REG_COMB_BK00_29_L      _PK_L_(0x00, 0x29)
#define REG_COMB_BK00_29_H      _PK_H_(0x00, 0x29)
#define REG_COMB_BK00_2A_L      _PK_L_(0x00, 0x2A)
#define REG_COMB_BK00_2A_H      _PK_H_(0x00, 0x2A)
#define REG_COMB_BK00_2B_L      _PK_L_(0x00, 0x2B)
#define REG_COMB_BK00_2B_H      _PK_H_(0x00, 0x2B)
#define REG_COMB_BK00_2C_L      _PK_L_(0x00, 0x2C)
#define REG_COMB_BK00_2C_H      _PK_H_(0x00, 0x2C)
#define REG_COMB_BK00_2D_L      _PK_L_(0x00, 0x2D)
#define REG_COMB_BK00_2D_H      _PK_H_(0x00, 0x2D)
#define REG_COMB_BK00_2E_L      _PK_L_(0x00, 0x2E)
#define REG_COMB_BK00_2E_H      _PK_H_(0x00, 0x2E)
#define REG_COMB_BK00_2F_L      _PK_L_(0x00, 0x2F)
#define REG_COMB_BK00_2F_H      _PK_H_(0x00, 0x2F)
#define REG_COMB_BK00_30_L      _PK_L_(0x00, 0x30)
#define REG_COMB_BK00_30_H      _PK_H_(0x00, 0x30)
#define REG_COMB_BK00_31_L      _PK_L_(0x00, 0x31)
#define REG_COMB_BK00_31_H      _PK_H_(0x00, 0x31)
#define REG_COMB_BK00_32_L      _PK_L_(0x00, 0x32)
#define REG_COMB_BK00_32_H      _PK_H_(0x00, 0x32)
#define REG_COMB_BK00_33_L      _PK_L_(0x00, 0x33)
#define REG_COMB_BK00_33_H      _PK_H_(0x00, 0x33)
#define REG_COMB_BK00_34_L      _PK_L_(0x00, 0x34)
#define REG_COMB_BK00_34_H      _PK_H_(0x00, 0x34)
#define REG_COMB_BK00_35_L      _PK_L_(0x00, 0x35)
#define REG_COMB_BK00_35_H      _PK_H_(0x00, 0x35)
#define REG_COMB_BK00_36_L      _PK_L_(0x00, 0x36)
#define REG_COMB_BK00_36_H      _PK_H_(0x00, 0x36)
#define REG_COMB_BK00_37_L      _PK_L_(0x00, 0x37)
#define REG_COMB_BK00_37_H      _PK_H_(0x00, 0x37)
#define REG_COMB_BK00_38_L      _PK_L_(0x00, 0x38)
#define REG_COMB_BK00_38_H      _PK_H_(0x00, 0x38)
#define REG_COMB_BK00_39_L      _PK_L_(0x00, 0x39)
#define REG_COMB_BK00_39_H      _PK_H_(0x00, 0x39)
#define REG_COMB_BK00_3A_L      _PK_L_(0x00, 0x3A)
#define REG_COMB_BK00_3A_H      _PK_H_(0x00, 0x3A)
#define REG_COMB_BK00_3B_L      _PK_L_(0x00, 0x3B)
#define REG_COMB_BK00_3B_H      _PK_H_(0x00, 0x3B)
#define REG_COMB_BK00_3C_L      _PK_L_(0x00, 0x3C)
#define REG_COMB_BK00_3C_H      _PK_H_(0x00, 0x3C)
#define REG_COMB_BK00_3D_L      _PK_L_(0x00, 0x3D)
#define REG_COMB_BK00_3D_H      _PK_H_(0x00, 0x3D)
#define REG_COMB_BK00_3E_L      _PK_L_(0x00, 0x3E)
#define REG_COMB_BK00_3E_H      _PK_H_(0x00, 0x3E)
#define REG_COMB_BK00_3F_L      _PK_L_(0x00, 0x3F)
#define REG_COMB_BK00_3F_H      _PK_H_(0x00, 0x3F)
#define REG_COMB_BK00_40_L      _PK_L_(0x00, 0x40)
#define REG_COMB_BK00_40_H      _PK_H_(0x00, 0x40)
#define REG_COMB_BK00_41_L      _PK_L_(0x00, 0x41)
#define REG_COMB_BK00_41_H      _PK_H_(0x00, 0x41)
#define REG_COMB_BK00_42_L      _PK_L_(0x00, 0x42)
#define REG_COMB_BK00_42_H      _PK_H_(0x00, 0x42)
#define REG_COMB_BK00_43_L      _PK_L_(0x00, 0x43)
#define REG_COMB_BK00_43_H      _PK_H_(0x00, 0x43)
#define REG_COMB_BK00_44_L      _PK_L_(0x00, 0x44)
#define REG_COMB_BK00_44_H      _PK_H_(0x00, 0x44)
#define REG_COMB_BK00_45_L      _PK_L_(0x00, 0x45)
#define REG_COMB_BK00_45_H      _PK_H_(0x00, 0x45)
#define REG_COMB_BK00_46_L      _PK_L_(0x00, 0x46)
#define REG_COMB_BK00_46_H      _PK_H_(0x00, 0x46)
#define REG_COMB_BK00_47_L      _PK_L_(0x00, 0x47)
#define REG_COMB_BK00_47_H      _PK_H_(0x00, 0x47)
#define REG_COMB_BK00_48_L      _PK_L_(0x00, 0x48)
#define REG_COMB_BK00_48_H      _PK_H_(0x00, 0x48)
#define REG_COMB_BK00_49_L      _PK_L_(0x00, 0x49)
#define REG_COMB_BK00_49_H      _PK_H_(0x00, 0x49)
#define REG_COMB_BK00_4A_L      _PK_L_(0x00, 0x4A)
#define REG_COMB_BK00_4A_H      _PK_H_(0x00, 0x4A)
#define REG_COMB_BK00_4B_L      _PK_L_(0x00, 0x4B)
#define REG_COMB_BK00_4B_H      _PK_H_(0x00, 0x4B)
#define REG_COMB_BK00_4C_L      _PK_L_(0x00, 0x4C)
#define REG_COMB_BK00_4C_H      _PK_H_(0x00, 0x4C)
#define REG_COMB_BK00_4D_L      _PK_L_(0x00, 0x4D)
#define REG_COMB_BK00_4D_H      _PK_H_(0x00, 0x4D)
#define REG_COMB_BK00_4E_L      _PK_L_(0x00, 0x4E)
#define REG_COMB_BK00_4E_H      _PK_H_(0x00, 0x4E)
#define REG_COMB_BK00_4F_L      _PK_L_(0x00, 0x4F)
#define REG_COMB_BK00_4F_H      _PK_H_(0x00, 0x4F)
#define REG_COMB_BK00_50_L      _PK_L_(0x00, 0x50)
#define REG_COMB_BK00_50_H      _PK_H_(0x00, 0x50)
#define REG_COMB_BK00_51_L      _PK_L_(0x00, 0x51)
#define REG_COMB_BK00_51_H      _PK_H_(0x00, 0x51)
#define REG_COMB_BK00_52_L      _PK_L_(0x00, 0x52)
#define REG_COMB_BK00_52_H      _PK_H_(0x00, 0x52)
#define REG_COMB_BK00_53_L      _PK_L_(0x00, 0x53)
#define REG_COMB_BK00_53_H      _PK_H_(0x00, 0x53)
#define REG_COMB_BK00_54_L      _PK_L_(0x00, 0x54)
#define REG_COMB_BK00_54_H      _PK_H_(0x00, 0x54)
#define REG_COMB_BK00_55_L      _PK_L_(0x00, 0x55)
#define REG_COMB_BK00_55_H      _PK_H_(0x00, 0x55)
#define REG_COMB_BK00_56_L      _PK_L_(0x00, 0x56)
#define REG_COMB_BK00_56_H      _PK_H_(0x00, 0x56)
#define REG_COMB_BK00_57_L      _PK_L_(0x00, 0x57)
#define REG_COMB_BK00_57_H      _PK_H_(0x00, 0x57)
#define REG_COMB_BK00_58_L      _PK_L_(0x00, 0x58)
#define REG_COMB_BK00_58_H      _PK_H_(0x00, 0x58)
#define REG_COMB_BK00_59_L      _PK_L_(0x00, 0x59)
#define REG_COMB_BK00_59_H      _PK_H_(0x00, 0x59)
#define REG_COMB_BK00_5A_L      _PK_L_(0x00, 0x5A)
#define REG_COMB_BK00_5A_H      _PK_H_(0x00, 0x5A)
#define REG_COMB_BK00_5B_L      _PK_L_(0x00, 0x5B)
#define REG_COMB_BK00_5B_H      _PK_H_(0x00, 0x5B)
#define REG_COMB_BK00_5C_L      _PK_L_(0x00, 0x5C)
#define REG_COMB_BK00_5C_H      _PK_H_(0x00, 0x5C)
#define REG_COMB_BK00_5D_L      _PK_L_(0x00, 0x5D)
#define REG_COMB_BK00_5D_H      _PK_H_(0x00, 0x5D)
#define REG_COMB_BK00_5E_L      _PK_L_(0x00, 0x5E)
#define REG_COMB_BK00_5E_H      _PK_H_(0x00, 0x5E)
#define REG_COMB_BK00_5F_L      _PK_L_(0x00, 0x5F)
#define REG_COMB_BK00_5F_H      _PK_H_(0x00, 0x5F)
#define REG_COMB_BK00_60_L      _PK_L_(0x00, 0x60)
#define REG_COMB_BK00_60_H      _PK_H_(0x00, 0x60)
#define REG_COMB_BK00_61_L      _PK_L_(0x00, 0x61)
#define REG_COMB_BK00_61_H      _PK_H_(0x00, 0x61)
#define REG_COMB_BK00_62_L      _PK_L_(0x00, 0x62)
#define REG_COMB_BK00_62_H      _PK_H_(0x00, 0x62)
#define REG_COMB_BK00_63_L      _PK_L_(0x00, 0x63)
#define REG_COMB_BK00_63_H      _PK_H_(0x00, 0x63)
#define REG_COMB_BK00_64_L      _PK_L_(0x00, 0x64)
#define REG_COMB_BK00_64_H      _PK_H_(0x00, 0x64)
#define REG_COMB_BK00_65_L      _PK_L_(0x00, 0x65)
#define REG_COMB_BK00_65_H      _PK_H_(0x00, 0x65)
#define REG_COMB_BK00_66_L      _PK_L_(0x00, 0x66)
#define REG_COMB_BK00_66_H      _PK_H_(0x00, 0x66)
#define REG_COMB_BK00_67_L      _PK_L_(0x00, 0x67)
#define REG_COMB_BK00_67_H      _PK_H_(0x00, 0x67)
#define REG_COMB_BK00_68_L      _PK_L_(0x00, 0x68)
#define REG_COMB_BK00_68_H      _PK_H_(0x00, 0x68)
#define REG_COMB_BK00_69_L      _PK_L_(0x00, 0x69)
#define REG_COMB_BK00_69_H      _PK_H_(0x00, 0x69)
#define REG_COMB_BK00_6A_L      _PK_L_(0x00, 0x6A)
#define REG_COMB_BK00_6A_H      _PK_H_(0x00, 0x6A)
#define REG_COMB_BK00_6B_L      _PK_L_(0x00, 0x6B)
#define REG_COMB_BK00_6B_H      _PK_H_(0x00, 0x6B)
#define REG_COMB_BK00_6C_L      _PK_L_(0x00, 0x6C)
#define REG_COMB_BK00_6C_H      _PK_H_(0x00, 0x6C)
#define REG_COMB_BK00_6D_L      _PK_L_(0x00, 0x6D)
#define REG_COMB_BK00_6D_H      _PK_H_(0x00, 0x6D)
#define REG_COMB_BK00_6E_L      _PK_L_(0x00, 0x6E)
#define REG_COMB_BK00_6E_H      _PK_H_(0x00, 0x6E)
#define REG_COMB_BK00_6F_L      _PK_L_(0x00, 0x6F)
#define REG_COMB_BK00_6F_H      _PK_H_(0x00, 0x6F)
#define REG_COMB_BK00_70_L      _PK_L_(0x00, 0x70)
#define REG_COMB_BK00_70_H      _PK_H_(0x00, 0x70)
#define REG_COMB_BK00_71_L      _PK_L_(0x00, 0x71)
#define REG_COMB_BK00_71_H      _PK_H_(0x00, 0x71)
#define REG_COMB_BK00_72_L      _PK_L_(0x00, 0x72)
#define REG_COMB_BK00_72_H      _PK_H_(0x00, 0x72)
#define REG_COMB_BK00_73_L      _PK_L_(0x00, 0x73)
#define REG_COMB_BK00_73_H      _PK_H_(0x00, 0x73)
#define REG_COMB_BK00_74_L      _PK_L_(0x00, 0x74)
#define REG_COMB_BK00_74_H      _PK_H_(0x00, 0x74)
#define REG_COMB_BK00_75_L      _PK_L_(0x00, 0x75)
#define REG_COMB_BK00_75_H      _PK_H_(0x00, 0x75)
#define REG_COMB_BK00_76_L      _PK_L_(0x00, 0x76)
#define REG_COMB_BK00_76_H      _PK_H_(0x00, 0x76)
#define REG_COMB_BK00_77_L      _PK_L_(0x00, 0x77)
#define REG_COMB_BK00_77_H      _PK_H_(0x00, 0x77)
#define REG_COMB_BK00_78_L      _PK_L_(0x00, 0x78)
#define REG_COMB_BK00_78_H      _PK_H_(0x00, 0x78)
#define REG_COMB_BK00_79_L      _PK_L_(0x00, 0x79)
#define REG_COMB_BK00_79_H      _PK_H_(0x00, 0x79)
#define REG_COMB_BK00_7A_L      _PK_L_(0x00, 0x7A)
#define REG_COMB_BK00_7A_H      _PK_H_(0x00, 0x7A)
#define REG_COMB_BK00_7B_L      _PK_L_(0x00, 0x7B)
#define REG_COMB_BK00_7B_H      _PK_H_(0x00, 0x7B)
#define REG_COMB_BK00_7C_L      _PK_L_(0x00, 0x7C)
#define REG_COMB_BK00_7C_H      _PK_H_(0x00, 0x7C)
#define REG_COMB_BK00_7D_L      _PK_L_(0x00, 0x7D)
#define REG_COMB_BK00_7D_H      _PK_H_(0x00, 0x7D)
#define REG_COMB_BK00_7E_L      _PK_L_(0x00, 0x7E)
#define REG_COMB_BK00_7E_H      _PK_H_(0x00, 0x7E)
#define REG_COMB_BK00_7F_L      _PK_L_(0x00, 0x7F)
#define REG_COMB_BK00_7F_H      _PK_H_(0x00, 0x7F)
//----------------------------------------------
#define REG_COMB_BK01_00_L      _PK_L_(0x01, 0x00)
#define REG_COMB_BK01_00_H      _PK_H_(0x01, 0x00)
#define REG_COMB_BK01_01_L      _PK_L_(0x01, 0x01)
#define REG_COMB_BK01_01_H      _PK_H_(0x01, 0x01)
#define REG_COMB_BK01_02_L      _PK_L_(0x01, 0x02)
#define REG_COMB_BK01_02_H      _PK_H_(0x01, 0x02)
#define REG_COMB_BK01_03_L      _PK_L_(0x01, 0x03)
#define REG_COMB_BK01_03_H      _PK_H_(0x01, 0x03)
#define REG_COMB_BK01_04_L      _PK_L_(0x01, 0x04)
#define REG_COMB_BK01_04_H      _PK_H_(0x01, 0x04)
#define REG_COMB_BK01_05_L      _PK_L_(0x01, 0x05)
#define REG_COMB_BK01_05_H      _PK_H_(0x01, 0x05)
#define REG_COMB_BK01_06_L      _PK_L_(0x01, 0x06)
#define REG_COMB_BK01_06_H      _PK_H_(0x01, 0x06)
#define REG_COMB_BK01_07_L      _PK_L_(0x01, 0x07)
#define REG_COMB_BK01_07_H      _PK_H_(0x01, 0x07)
#define REG_COMB_BK01_08_L      _PK_L_(0x01, 0x08)
#define REG_COMB_BK01_08_H      _PK_H_(0x01, 0x08)
#define REG_COMB_BK01_09_L      _PK_L_(0x01, 0x09)
#define REG_COMB_BK01_09_H      _PK_H_(0x01, 0x09)
#define REG_COMB_BK01_0A_L      _PK_L_(0x01, 0x0A)
#define REG_COMB_BK01_0A_H      _PK_H_(0x01, 0x0A)
#define REG_COMB_BK01_0B_L      _PK_L_(0x01, 0x0B)
#define REG_COMB_BK01_0B_H      _PK_H_(0x01, 0x0B)
#define REG_COMB_BK01_0C_L      _PK_L_(0x01, 0x0C)
#define REG_COMB_BK01_0C_H      _PK_H_(0x01, 0x0C)
#define REG_COMB_BK01_0D_L      _PK_L_(0x01, 0x0D)
#define REG_COMB_BK01_0D_H      _PK_H_(0x01, 0x0D)
#define REG_COMB_BK01_0E_L      _PK_L_(0x01, 0x0E)
#define REG_COMB_BK01_0E_H      _PK_H_(0x01, 0x0E)
#define REG_COMB_BK01_0F_L      _PK_L_(0x01, 0x0F)
#define REG_COMB_BK01_0F_H      _PK_H_(0x01, 0x0F)
#define REG_COMB_BK01_10_L      _PK_L_(0x01, 0x10)
#define REG_COMB_BK01_10_H      _PK_H_(0x01, 0x10)
#define REG_COMB_BK01_11_L      _PK_L_(0x01, 0x11)
#define REG_COMB_BK01_11_H      _PK_H_(0x01, 0x11)
#define REG_COMB_BK01_12_L      _PK_L_(0x01, 0x12)
#define REG_COMB_BK01_12_H      _PK_H_(0x01, 0x12)
#define REG_COMB_BK01_13_L      _PK_L_(0x01, 0x13)
#define REG_COMB_BK01_13_H      _PK_H_(0x01, 0x13)
#define REG_COMB_BK01_14_L      _PK_L_(0x01, 0x14)
#define REG_COMB_BK01_14_H      _PK_H_(0x01, 0x14)
#define REG_COMB_BK01_15_L      _PK_L_(0x01, 0x15)
#define REG_COMB_BK01_15_H      _PK_H_(0x01, 0x15)
#define REG_COMB_BK01_16_L      _PK_L_(0x01, 0x16)
#define REG_COMB_BK01_16_H      _PK_H_(0x01, 0x16)
#define REG_COMB_BK01_17_L      _PK_L_(0x01, 0x17)
#define REG_COMB_BK01_17_H      _PK_H_(0x01, 0x17)
#define REG_COMB_BK01_18_L      _PK_L_(0x01, 0x18)
#define REG_COMB_BK01_18_H      _PK_H_(0x01, 0x18)
#define REG_COMB_BK01_19_L      _PK_L_(0x01, 0x19)
#define REG_COMB_BK01_19_H      _PK_H_(0x01, 0x19)
#define REG_COMB_BK01_1A_L      _PK_L_(0x01, 0x1A)
#define REG_COMB_BK01_1A_H      _PK_H_(0x01, 0x1A)
#define REG_COMB_BK01_1B_L      _PK_L_(0x01, 0x1B)
#define REG_COMB_BK01_1B_H      _PK_H_(0x01, 0x1B)
#define REG_COMB_BK01_1C_L      _PK_L_(0x01, 0x1C)
#define REG_COMB_BK01_1C_H      _PK_H_(0x01, 0x1C)
#define REG_COMB_BK01_1D_L      _PK_L_(0x01, 0x1D)
#define REG_COMB_BK01_1D_H      _PK_H_(0x01, 0x1D)
#define REG_COMB_BK01_1E_L      _PK_L_(0x01, 0x1E)
#define REG_COMB_BK01_1E_H      _PK_H_(0x01, 0x1E)
#define REG_COMB_BK01_1F_L      _PK_L_(0x01, 0x1F)
#define REG_COMB_BK01_1F_H      _PK_H_(0x01, 0x1F)
#define REG_COMB_BK01_20_L      _PK_L_(0x01, 0x20)
#define REG_COMB_BK01_20_H      _PK_H_(0x01, 0x20)
#define REG_COMB_BK01_21_L      _PK_L_(0x01, 0x21)
#define REG_COMB_BK01_21_H      _PK_H_(0x01, 0x21)
#define REG_COMB_BK01_22_L      _PK_L_(0x01, 0x22)
#define REG_COMB_BK01_22_H      _PK_H_(0x01, 0x22)
#define REG_COMB_BK01_23_L      _PK_L_(0x01, 0x23)
#define REG_COMB_BK01_23_H      _PK_H_(0x01, 0x23)
#define REG_COMB_BK01_24_L      _PK_L_(0x01, 0x24)
#define REG_COMB_BK01_24_H      _PK_H_(0x01, 0x24)
#define REG_COMB_BK01_25_L      _PK_L_(0x01, 0x25)
#define REG_COMB_BK01_25_H      _PK_H_(0x01, 0x25)
#define REG_COMB_BK01_26_L      _PK_L_(0x01, 0x26)
#define REG_COMB_BK01_26_H      _PK_H_(0x01, 0x26)
#define REG_COMB_BK01_27_L      _PK_L_(0x01, 0x27)
#define REG_COMB_BK01_27_H      _PK_H_(0x01, 0x27)
#define REG_COMB_BK01_28_L      _PK_L_(0x01, 0x28)
#define REG_COMB_BK01_28_H      _PK_H_(0x01, 0x28)
#define REG_COMB_BK01_29_L      _PK_L_(0x01, 0x29)
#define REG_COMB_BK01_29_H      _PK_H_(0x01, 0x29)
#define REG_COMB_BK01_2A_L      _PK_L_(0x01, 0x2A)
#define REG_COMB_BK01_2A_H      _PK_H_(0x01, 0x2A)
#define REG_COMB_BK01_2B_L      _PK_L_(0x01, 0x2B)
#define REG_COMB_BK01_2B_H      _PK_H_(0x01, 0x2B)
#define REG_COMB_BK01_2C_L      _PK_L_(0x01, 0x2C)
#define REG_COMB_BK01_2C_H      _PK_H_(0x01, 0x2C)
#define REG_COMB_BK01_2D_L      _PK_L_(0x01, 0x2D)
#define REG_COMB_BK01_2D_H      _PK_H_(0x01, 0x2D)
#define REG_COMB_BK01_2E_L      _PK_L_(0x01, 0x2E)
#define REG_COMB_BK01_2E_H      _PK_H_(0x01, 0x2E)
#define REG_COMB_BK01_2F_L      _PK_L_(0x01, 0x2F)
#define REG_COMB_BK01_2F_H      _PK_H_(0x01, 0x2F)
#define REG_COMB_BK01_30_L      _PK_L_(0x01, 0x30)
#define REG_COMB_BK01_30_H      _PK_H_(0x01, 0x30)
#define REG_COMB_BK01_31_L      _PK_L_(0x01, 0x31)
#define REG_COMB_BK01_31_H      _PK_H_(0x01, 0x31)
#define REG_COMB_BK01_32_L      _PK_L_(0x01, 0x32)
#define REG_COMB_BK01_32_H      _PK_H_(0x01, 0x32)
#define REG_COMB_BK01_33_L      _PK_L_(0x01, 0x33)
#define REG_COMB_BK01_33_H      _PK_H_(0x01, 0x33)
#define REG_COMB_BK01_34_L      _PK_L_(0x01, 0x34)
#define REG_COMB_BK01_34_H      _PK_H_(0x01, 0x34)
#define REG_COMB_BK01_35_L      _PK_L_(0x01, 0x35)
#define REG_COMB_BK01_35_H      _PK_H_(0x01, 0x35)
#define REG_COMB_BK01_36_L      _PK_L_(0x01, 0x36)
#define REG_COMB_BK01_36_H      _PK_H_(0x01, 0x36)
#define REG_COMB_BK01_37_L      _PK_L_(0x01, 0x37)
#define REG_COMB_BK01_37_H      _PK_H_(0x01, 0x37)
#define REG_COMB_BK01_38_L      _PK_L_(0x01, 0x38)
#define REG_COMB_BK01_38_H      _PK_H_(0x01, 0x38)
#define REG_COMB_BK01_39_L      _PK_L_(0x01, 0x39)
#define REG_COMB_BK01_39_H      _PK_H_(0x01, 0x39)
#define REG_COMB_BK01_3A_L      _PK_L_(0x01, 0x3A)
#define REG_COMB_BK01_3A_H      _PK_H_(0x01, 0x3A)
#define REG_COMB_BK01_3B_L      _PK_L_(0x01, 0x3B)
#define REG_COMB_BK01_3B_H      _PK_H_(0x01, 0x3B)
#define REG_COMB_BK01_3C_L      _PK_L_(0x01, 0x3C)
#define REG_COMB_BK01_3C_H      _PK_H_(0x01, 0x3C)
#define REG_COMB_BK01_3D_L      _PK_L_(0x01, 0x3D)
#define REG_COMB_BK01_3D_H      _PK_H_(0x01, 0x3D)
#define REG_COMB_BK01_3E_L      _PK_L_(0x01, 0x3E)
#define REG_COMB_BK01_3E_H      _PK_H_(0x01, 0x3E)
#define REG_COMB_BK01_3F_L      _PK_L_(0x01, 0x3F)
#define REG_COMB_BK01_3F_H      _PK_H_(0x01, 0x3F)
#define REG_COMB_BK01_40_L      _PK_L_(0x01, 0x40)
#define REG_COMB_BK01_40_H      _PK_H_(0x01, 0x40)
#define REG_COMB_BK01_41_L      _PK_L_(0x01, 0x41)
#define REG_COMB_BK01_41_H      _PK_H_(0x01, 0x41)
#define REG_COMB_BK01_42_L      _PK_L_(0x01, 0x42)
#define REG_COMB_BK01_42_H      _PK_H_(0x01, 0x42)
#define REG_COMB_BK01_43_L      _PK_L_(0x01, 0x43)
#define REG_COMB_BK01_43_H      _PK_H_(0x01, 0x43)
#define REG_COMB_BK01_44_L      _PK_L_(0x01, 0x44)
#define REG_COMB_BK01_44_H      _PK_H_(0x01, 0x44)
#define REG_COMB_BK01_45_L      _PK_L_(0x01, 0x45)
#define REG_COMB_BK01_45_H      _PK_H_(0x01, 0x45)
#define REG_COMB_BK01_46_L      _PK_L_(0x01, 0x46)
#define REG_COMB_BK01_46_H      _PK_H_(0x01, 0x46)
#define REG_COMB_BK01_47_L      _PK_L_(0x01, 0x47)
#define REG_COMB_BK01_47_H      _PK_H_(0x01, 0x47)
#define REG_COMB_BK01_48_L      _PK_L_(0x01, 0x48)
#define REG_COMB_BK01_48_H      _PK_H_(0x01, 0x48)
#define REG_COMB_BK01_49_L      _PK_L_(0x01, 0x49)
#define REG_COMB_BK01_49_H      _PK_H_(0x01, 0x49)
#define REG_COMB_BK01_4A_L      _PK_L_(0x01, 0x4A)
#define REG_COMB_BK01_4A_H      _PK_H_(0x01, 0x4A)
#define REG_COMB_BK01_4B_L      _PK_L_(0x01, 0x4B)
#define REG_COMB_BK01_4B_H      _PK_H_(0x01, 0x4B)
#define REG_COMB_BK01_4C_L      _PK_L_(0x01, 0x4C)
#define REG_COMB_BK01_4C_H      _PK_H_(0x01, 0x4C)
#define REG_COMB_BK01_4D_L      _PK_L_(0x01, 0x4D)
#define REG_COMB_BK01_4D_H      _PK_H_(0x01, 0x4D)
#define REG_COMB_BK01_4E_L      _PK_L_(0x01, 0x4E)
#define REG_COMB_BK01_4E_H      _PK_H_(0x01, 0x4E)
#define REG_COMB_BK01_4F_L      _PK_L_(0x01, 0x4F)
#define REG_COMB_BK01_4F_H      _PK_H_(0x01, 0x4F)
#define REG_COMB_BK01_50_L      _PK_L_(0x01, 0x50)
#define REG_COMB_BK01_50_H      _PK_H_(0x01, 0x50)
#define REG_COMB_BK01_51_L      _PK_L_(0x01, 0x51)
#define REG_COMB_BK01_51_H      _PK_H_(0x01, 0x51)
#define REG_COMB_BK01_52_L      _PK_L_(0x01, 0x52)
#define REG_COMB_BK01_52_H      _PK_H_(0x01, 0x52)
#define REG_COMB_BK01_53_L      _PK_L_(0x01, 0x53)
#define REG_COMB_BK01_53_H      _PK_H_(0x01, 0x53)
#define REG_COMB_BK01_54_L      _PK_L_(0x01, 0x54)
#define REG_COMB_BK01_54_H      _PK_H_(0x01, 0x54)
#define REG_COMB_BK01_55_L      _PK_L_(0x01, 0x55)
#define REG_COMB_BK01_55_H      _PK_H_(0x01, 0x55)
#define REG_COMB_BK01_56_L      _PK_L_(0x01, 0x56)
#define REG_COMB_BK01_56_H      _PK_H_(0x01, 0x56)
#define REG_COMB_BK01_57_L      _PK_L_(0x01, 0x57)
#define REG_COMB_BK01_57_H      _PK_H_(0x01, 0x57)
#define REG_COMB_BK01_58_L      _PK_L_(0x01, 0x58)
#define REG_COMB_BK01_58_H      _PK_H_(0x01, 0x58)
#define REG_COMB_BK01_59_L      _PK_L_(0x01, 0x59)
#define REG_COMB_BK01_59_H      _PK_H_(0x01, 0x59)
#define REG_COMB_BK01_5A_L      _PK_L_(0x01, 0x5A)
#define REG_COMB_BK01_5A_H      _PK_H_(0x01, 0x5A)
#define REG_COMB_BK01_5B_L      _PK_L_(0x01, 0x5B)
#define REG_COMB_BK01_5B_H      _PK_H_(0x01, 0x5B)
#define REG_COMB_BK01_5C_L      _PK_L_(0x01, 0x5C)
#define REG_COMB_BK01_5C_H      _PK_H_(0x01, 0x5C)
#define REG_COMB_BK01_5D_L      _PK_L_(0x01, 0x5D)
#define REG_COMB_BK01_5D_H      _PK_H_(0x01, 0x5D)
#define REG_COMB_BK01_5E_L      _PK_L_(0x01, 0x5E)
#define REG_COMB_BK01_5E_H      _PK_H_(0x01, 0x5E)
#define REG_COMB_BK01_5F_L      _PK_L_(0x01, 0x5F)
#define REG_COMB_BK01_5F_H      _PK_H_(0x01, 0x5F)
#define REG_COMB_BK01_60_L      _PK_L_(0x01, 0x60)
#define REG_COMB_BK01_60_H      _PK_H_(0x01, 0x60)
#define REG_COMB_BK01_61_L      _PK_L_(0x01, 0x61)
#define REG_COMB_BK01_61_H      _PK_H_(0x01, 0x61)
#define REG_COMB_BK01_62_L      _PK_L_(0x01, 0x62)
#define REG_COMB_BK01_62_H      _PK_H_(0x01, 0x62)
#define REG_COMB_BK01_63_L      _PK_L_(0x01, 0x63)
#define REG_COMB_BK01_63_H      _PK_H_(0x01, 0x63)
#define REG_COMB_BK01_64_L      _PK_L_(0x01, 0x64)
#define REG_COMB_BK01_64_H      _PK_H_(0x01, 0x64)
#define REG_COMB_BK01_65_L      _PK_L_(0x01, 0x65)
#define REG_COMB_BK01_65_H      _PK_H_(0x01, 0x65)
#define REG_COMB_BK01_66_L      _PK_L_(0x01, 0x66)
#define REG_COMB_BK01_66_H      _PK_H_(0x01, 0x66)
#define REG_COMB_BK01_67_L      _PK_L_(0x01, 0x67)
#define REG_COMB_BK01_67_H      _PK_H_(0x01, 0x67)
#define REG_COMB_BK01_68_L      _PK_L_(0x01, 0x68)
#define REG_COMB_BK01_68_H      _PK_H_(0x01, 0x68)
#define REG_COMB_BK01_69_L      _PK_L_(0x01, 0x69)
#define REG_COMB_BK01_69_H      _PK_H_(0x01, 0x69)
#define REG_COMB_BK01_6A_L      _PK_L_(0x01, 0x6A)
#define REG_COMB_BK01_6A_H      _PK_H_(0x01, 0x6A)
#define REG_COMB_BK01_6B_L      _PK_L_(0x01, 0x6B)
#define REG_COMB_BK01_6B_H      _PK_H_(0x01, 0x6B)
#define REG_COMB_BK01_6C_L      _PK_L_(0x01, 0x6C)
#define REG_COMB_BK01_6C_H      _PK_H_(0x01, 0x6C)
#define REG_COMB_BK01_6D_L      _PK_L_(0x01, 0x6D)
#define REG_COMB_BK01_6D_H      _PK_H_(0x01, 0x6D)
#define REG_COMB_BK01_6E_L      _PK_L_(0x01, 0x6E)
#define REG_COMB_BK01_6E_H      _PK_H_(0x01, 0x6E)
#define REG_COMB_BK01_6F_L      _PK_L_(0x01, 0x6F)
#define REG_COMB_BK01_6F_H      _PK_H_(0x01, 0x6F)
#define REG_COMB_BK01_70_L      _PK_L_(0x01, 0x70)
#define REG_COMB_BK01_70_H      _PK_H_(0x01, 0x70)
#define REG_COMB_BK01_71_L      _PK_L_(0x01, 0x71)
#define REG_COMB_BK01_71_H      _PK_H_(0x01, 0x71)
#define REG_COMB_BK01_72_L      _PK_L_(0x01, 0x72)
#define REG_COMB_BK01_72_H      _PK_H_(0x01, 0x72)
#define REG_COMB_BK01_73_L      _PK_L_(0x01, 0x73)
#define REG_COMB_BK01_73_H      _PK_H_(0x01, 0x73)
#define REG_COMB_BK01_74_L      _PK_L_(0x01, 0x74)
#define REG_COMB_BK01_74_H      _PK_H_(0x01, 0x74)
#define REG_COMB_BK01_75_L      _PK_L_(0x01, 0x75)
#define REG_COMB_BK01_75_H      _PK_H_(0x01, 0x75)
#define REG_COMB_BK01_76_L      _PK_L_(0x01, 0x76)
#define REG_COMB_BK01_76_H      _PK_H_(0x01, 0x76)
#define REG_COMB_BK01_77_L      _PK_L_(0x01, 0x77)
#define REG_COMB_BK01_77_H      _PK_H_(0x01, 0x77)
#define REG_COMB_BK01_78_L      _PK_L_(0x01, 0x78)
#define REG_COMB_BK01_78_H      _PK_H_(0x01, 0x78)
#define REG_COMB_BK01_79_L      _PK_L_(0x01, 0x79)
#define REG_COMB_BK01_79_H      _PK_H_(0x01, 0x79)
#define REG_COMB_BK01_7A_L      _PK_L_(0x01, 0x7A)
#define REG_COMB_BK01_7A_H      _PK_H_(0x01, 0x7A)
#define REG_COMB_BK01_7B_L      _PK_L_(0x01, 0x7B)
#define REG_COMB_BK01_7B_H      _PK_H_(0x01, 0x7B)
#define REG_COMB_BK01_7C_L      _PK_L_(0x01, 0x7C)
#define REG_COMB_BK01_7C_H      _PK_H_(0x01, 0x7C)
#define REG_COMB_BK01_7D_L      _PK_L_(0x01, 0x7D)
#define REG_COMB_BK01_7D_H      _PK_H_(0x01, 0x7D)
#define REG_COMB_BK01_7E_L      _PK_L_(0x01, 0x7E)
#define REG_COMB_BK01_7E_H      _PK_H_(0x01, 0x7E)
#define REG_COMB_BK01_7F_L      _PK_L_(0x01, 0x7F)
#define REG_COMB_BK01_7F_H      _PK_H_(0x01, 0x7F)
//----------------------------------------------
#define REG_COMB_BK02_00_L      _PK_L_(0x02, 0x00)
#define REG_COMB_BK02_00_H      _PK_H_(0x02, 0x00)
#define REG_COMB_BK02_01_L      _PK_L_(0x02, 0x01)
#define REG_COMB_BK02_01_H      _PK_H_(0x02, 0x01)
#define REG_COMB_BK02_02_L      _PK_L_(0x02, 0x02)
#define REG_COMB_BK02_02_H      _PK_H_(0x02, 0x02)
#define REG_COMB_BK02_03_L      _PK_L_(0x02, 0x03)
#define REG_COMB_BK02_03_H      _PK_H_(0x02, 0x03)
#define REG_COMB_BK02_04_L      _PK_L_(0x02, 0x04)
#define REG_COMB_BK02_04_H      _PK_H_(0x02, 0x04)
#define REG_COMB_BK02_05_L      _PK_L_(0x02, 0x05)
#define REG_COMB_BK02_05_H      _PK_H_(0x02, 0x05)
#define REG_COMB_BK02_06_L      _PK_L_(0x02, 0x06)
#define REG_COMB_BK02_06_H      _PK_H_(0x02, 0x06)
#define REG_COMB_BK02_07_L      _PK_L_(0x02, 0x07)
#define REG_COMB_BK02_07_H      _PK_H_(0x02, 0x07)
#define REG_COMB_BK02_08_L      _PK_L_(0x02, 0x08)
#define REG_COMB_BK02_08_H      _PK_H_(0x02, 0x08)
#define REG_COMB_BK02_09_L      _PK_L_(0x02, 0x09)
#define REG_COMB_BK02_09_H      _PK_H_(0x02, 0x09)
#define REG_COMB_BK02_0A_L      _PK_L_(0x02, 0x0A)
#define REG_COMB_BK02_0A_H      _PK_H_(0x02, 0x0A)
#define REG_COMB_BK02_0B_L      _PK_L_(0x02, 0x0B)
#define REG_COMB_BK02_0B_H      _PK_H_(0x02, 0x0B)
#define REG_COMB_BK02_0C_L      _PK_L_(0x02, 0x0C)
#define REG_COMB_BK02_0C_H      _PK_H_(0x02, 0x0C)
#define REG_COMB_BK02_0D_L      _PK_L_(0x02, 0x0D)
#define REG_COMB_BK02_0D_H      _PK_H_(0x02, 0x0D)
#define REG_COMB_BK02_0E_L      _PK_L_(0x02, 0x0E)
#define REG_COMB_BK02_0E_H      _PK_H_(0x02, 0x0E)
#define REG_COMB_BK02_0F_L      _PK_L_(0x02, 0x0F)
#define REG_COMB_BK02_0F_H      _PK_H_(0x02, 0x0F)
#define REG_COMB_BK02_10_L      _PK_L_(0x02, 0x10)
#define REG_COMB_BK02_10_H      _PK_H_(0x02, 0x10)
#define REG_COMB_BK02_11_L      _PK_L_(0x02, 0x11)
#define REG_COMB_BK02_11_H      _PK_H_(0x02, 0x11)
#define REG_COMB_BK02_12_L      _PK_L_(0x02, 0x12)
#define REG_COMB_BK02_12_H      _PK_H_(0x02, 0x12)
#define REG_COMB_BK02_13_L      _PK_L_(0x02, 0x13)
#define REG_COMB_BK02_13_H      _PK_H_(0x02, 0x13)
#define REG_COMB_BK02_14_L      _PK_L_(0x02, 0x14)
#define REG_COMB_BK02_14_H      _PK_H_(0x02, 0x14)
#define REG_COMB_BK02_15_L      _PK_L_(0x02, 0x15)
#define REG_COMB_BK02_15_H      _PK_H_(0x02, 0x15)
#define REG_COMB_BK02_16_L      _PK_L_(0x02, 0x16)
#define REG_COMB_BK02_16_H      _PK_H_(0x02, 0x16)
#define REG_COMB_BK02_17_L      _PK_L_(0x02, 0x17)
#define REG_COMB_BK02_17_H      _PK_H_(0x02, 0x17)
#define REG_COMB_BK02_18_L      _PK_L_(0x02, 0x18)
#define REG_COMB_BK02_18_H      _PK_H_(0x02, 0x18)
#define REG_COMB_BK02_19_L      _PK_L_(0x02, 0x19)
#define REG_COMB_BK02_19_H      _PK_H_(0x02, 0x19)
#define REG_COMB_BK02_1A_L      _PK_L_(0x02, 0x1A)
#define REG_COMB_BK02_1A_H      _PK_H_(0x02, 0x1A)
#define REG_COMB_BK02_1B_L      _PK_L_(0x02, 0x1B)
#define REG_COMB_BK02_1B_H      _PK_H_(0x02, 0x1B)
#define REG_COMB_BK02_1C_L      _PK_L_(0x02, 0x1C)
#define REG_COMB_BK02_1C_H      _PK_H_(0x02, 0x1C)
#define REG_COMB_BK02_1D_L      _PK_L_(0x02, 0x1D)
#define REG_COMB_BK02_1D_H      _PK_H_(0x02, 0x1D)
#define REG_COMB_BK02_1E_L      _PK_L_(0x02, 0x1E)
#define REG_COMB_BK02_1E_H      _PK_H_(0x02, 0x1E)
#define REG_COMB_BK02_1F_L      _PK_L_(0x02, 0x1F)
#define REG_COMB_BK02_1F_H      _PK_H_(0x02, 0x1F)
#define REG_COMB_BK02_20_L      _PK_L_(0x02, 0x20)
#define REG_COMB_BK02_20_H      _PK_H_(0x02, 0x20)
#define REG_COMB_BK02_21_L      _PK_L_(0x02, 0x21)
#define REG_COMB_BK02_21_H      _PK_H_(0x02, 0x21)
#define REG_COMB_BK02_22_L      _PK_L_(0x02, 0x22)
#define REG_COMB_BK02_22_H      _PK_H_(0x02, 0x22)
#define REG_COMB_BK02_23_L      _PK_L_(0x02, 0x23)
#define REG_COMB_BK02_23_H      _PK_H_(0x02, 0x23)
#define REG_COMB_BK02_24_L      _PK_L_(0x02, 0x24)
#define REG_COMB_BK02_24_H      _PK_H_(0x02, 0x24)
#define REG_COMB_BK02_25_L      _PK_L_(0x02, 0x25)
#define REG_COMB_BK02_25_H      _PK_H_(0x02, 0x25)
#define REG_COMB_BK02_26_L      _PK_L_(0x02, 0x26)
#define REG_COMB_BK02_26_H      _PK_H_(0x02, 0x26)
#define REG_COMB_BK02_27_L      _PK_L_(0x02, 0x27)
#define REG_COMB_BK02_27_H      _PK_H_(0x02, 0x27)
#define REG_COMB_BK02_28_L      _PK_L_(0x02, 0x28)
#define REG_COMB_BK02_28_H      _PK_H_(0x02, 0x28)
#define REG_COMB_BK02_29_L      _PK_L_(0x02, 0x29)
#define REG_COMB_BK02_29_H      _PK_H_(0x02, 0x29)
#define REG_COMB_BK02_2A_L      _PK_L_(0x02, 0x2A)
#define REG_COMB_BK02_2A_H      _PK_H_(0x02, 0x2A)
#define REG_COMB_BK02_2B_L      _PK_L_(0x02, 0x2B)
#define REG_COMB_BK02_2B_H      _PK_H_(0x02, 0x2B)
#define REG_COMB_BK02_2C_L      _PK_L_(0x02, 0x2C)
#define REG_COMB_BK02_2C_H      _PK_H_(0x02, 0x2C)
#define REG_COMB_BK02_2D_L      _PK_L_(0x02, 0x2D)
#define REG_COMB_BK02_2D_H      _PK_H_(0x02, 0x2D)
#define REG_COMB_BK02_2E_L      _PK_L_(0x02, 0x2E)
#define REG_COMB_BK02_2E_H      _PK_H_(0x02, 0x2E)
#define REG_COMB_BK02_2F_L      _PK_L_(0x02, 0x2F)
#define REG_COMB_BK02_2F_H      _PK_H_(0x02, 0x2F)
#define REG_COMB_BK02_30_L      _PK_L_(0x02, 0x30)
#define REG_COMB_BK02_30_H      _PK_H_(0x02, 0x30)
#define REG_COMB_BK02_31_L      _PK_L_(0x02, 0x31)
#define REG_COMB_BK02_31_H      _PK_H_(0x02, 0x31)
#define REG_COMB_BK02_32_L      _PK_L_(0x02, 0x32)
#define REG_COMB_BK02_32_H      _PK_H_(0x02, 0x32)
#define REG_COMB_BK02_33_L      _PK_L_(0x02, 0x33)
#define REG_COMB_BK02_33_H      _PK_H_(0x02, 0x33)
#define REG_COMB_BK02_34_L      _PK_L_(0x02, 0x34)
#define REG_COMB_BK02_34_H      _PK_H_(0x02, 0x34)
#define REG_COMB_BK02_35_L      _PK_L_(0x02, 0x35)
#define REG_COMB_BK02_35_H      _PK_H_(0x02, 0x35)
#define REG_COMB_BK02_36_L      _PK_L_(0x02, 0x36)
#define REG_COMB_BK02_36_H      _PK_H_(0x02, 0x36)
#define REG_COMB_BK02_37_L      _PK_L_(0x02, 0x37)
#define REG_COMB_BK02_37_H      _PK_H_(0x02, 0x37)
#define REG_COMB_BK02_38_L      _PK_L_(0x02, 0x38)
#define REG_COMB_BK02_38_H      _PK_H_(0x02, 0x38)
#define REG_COMB_BK02_39_L      _PK_L_(0x02, 0x39)
#define REG_COMB_BK02_39_H      _PK_H_(0x02, 0x39)
#define REG_COMB_BK02_3A_L      _PK_L_(0x02, 0x3A)
#define REG_COMB_BK02_3A_H      _PK_H_(0x02, 0x3A)
#define REG_COMB_BK02_3B_L      _PK_L_(0x02, 0x3B)
#define REG_COMB_BK02_3B_H      _PK_H_(0x02, 0x3B)
#define REG_COMB_BK02_3C_L      _PK_L_(0x02, 0x3C)
#define REG_COMB_BK02_3C_H      _PK_H_(0x02, 0x3C)
#define REG_COMB_BK02_3D_L      _PK_L_(0x02, 0x3D)
#define REG_COMB_BK02_3D_H      _PK_H_(0x02, 0x3D)
#define REG_COMB_BK02_3E_L      _PK_L_(0x02, 0x3E)
#define REG_COMB_BK02_3E_H      _PK_H_(0x02, 0x3E)
#define REG_COMB_BK02_3F_L      _PK_L_(0x02, 0x3F)
#define REG_COMB_BK02_3F_H      _PK_H_(0x02, 0x3F)
#define REG_COMB_BK02_40_L      _PK_L_(0x02, 0x40)
#define REG_COMB_BK02_40_H      _PK_H_(0x02, 0x40)
#define REG_COMB_BK02_41_L      _PK_L_(0x02, 0x41)
#define REG_COMB_BK02_41_H      _PK_H_(0x02, 0x41)
#define REG_COMB_BK02_42_L      _PK_L_(0x02, 0x42)
#define REG_COMB_BK02_42_H      _PK_H_(0x02, 0x42)
#define REG_COMB_BK02_43_L      _PK_L_(0x02, 0x43)
#define REG_COMB_BK02_43_H      _PK_H_(0x02, 0x43)
#define REG_COMB_BK02_44_L      _PK_L_(0x02, 0x44)
#define REG_COMB_BK02_44_H      _PK_H_(0x02, 0x44)
#define REG_COMB_BK02_45_L      _PK_L_(0x02, 0x45)
#define REG_COMB_BK02_45_H      _PK_H_(0x02, 0x45)
#define REG_COMB_BK02_46_L      _PK_L_(0x02, 0x46)
#define REG_COMB_BK02_46_H      _PK_H_(0x02, 0x46)
#define REG_COMB_BK02_47_L      _PK_L_(0x02, 0x47)
#define REG_COMB_BK02_47_H      _PK_H_(0x02, 0x47)
#define REG_COMB_BK02_48_L      _PK_L_(0x02, 0x48)
#define REG_COMB_BK02_48_H      _PK_H_(0x02, 0x48)
#define REG_COMB_BK02_49_L      _PK_L_(0x02, 0x49)
#define REG_COMB_BK02_49_H      _PK_H_(0x02, 0x49)
#define REG_COMB_BK02_4A_L      _PK_L_(0x02, 0x4A)
#define REG_COMB_BK02_4A_H      _PK_H_(0x02, 0x4A)
#define REG_COMB_BK02_4B_L      _PK_L_(0x02, 0x4B)
#define REG_COMB_BK02_4B_H      _PK_H_(0x02, 0x4B)
#define REG_COMB_BK02_4C_L      _PK_L_(0x02, 0x4C)
#define REG_COMB_BK02_4C_H      _PK_H_(0x02, 0x4C)
#define REG_COMB_BK02_4D_L      _PK_L_(0x02, 0x4D)
#define REG_COMB_BK02_4D_H      _PK_H_(0x02, 0x4D)
#define REG_COMB_BK02_4E_L      _PK_L_(0x02, 0x4E)
#define REG_COMB_BK02_4E_H      _PK_H_(0x02, 0x4E)
#define REG_COMB_BK02_4F_L      _PK_L_(0x02, 0x4F)
#define REG_COMB_BK02_4F_H      _PK_H_(0x02, 0x4F)
#define REG_COMB_BK02_50_L      _PK_L_(0x02, 0x50)
#define REG_COMB_BK02_50_H      _PK_H_(0x02, 0x50)
#define REG_COMB_BK02_51_L      _PK_L_(0x02, 0x51)
#define REG_COMB_BK02_51_H      _PK_H_(0x02, 0x51)
#define REG_COMB_BK02_52_L      _PK_L_(0x02, 0x52)
#define REG_COMB_BK02_52_H      _PK_H_(0x02, 0x52)
#define REG_COMB_BK02_53_L      _PK_L_(0x02, 0x53)
#define REG_COMB_BK02_53_H      _PK_H_(0x02, 0x53)
#define REG_COMB_BK02_54_L      _PK_L_(0x02, 0x54)
#define REG_COMB_BK02_54_H      _PK_H_(0x02, 0x54)
#define REG_COMB_BK02_55_L      _PK_L_(0x02, 0x55)
#define REG_COMB_BK02_55_H      _PK_H_(0x02, 0x55)
#define REG_COMB_BK02_56_L      _PK_L_(0x02, 0x56)
#define REG_COMB_BK02_56_H      _PK_H_(0x02, 0x56)
#define REG_COMB_BK02_57_L      _PK_L_(0x02, 0x57)
#define REG_COMB_BK02_57_H      _PK_H_(0x02, 0x57)
#define REG_COMB_BK02_58_L      _PK_L_(0x02, 0x58)
#define REG_COMB_BK02_58_H      _PK_H_(0x02, 0x58)
#define REG_COMB_BK02_59_L      _PK_L_(0x02, 0x59)
#define REG_COMB_BK02_59_H      _PK_H_(0x02, 0x59)
#define REG_COMB_BK02_5A_L      _PK_L_(0x02, 0x5A)
#define REG_COMB_BK02_5A_H      _PK_H_(0x02, 0x5A)
#define REG_COMB_BK02_5B_L      _PK_L_(0x02, 0x5B)
#define REG_COMB_BK02_5B_H      _PK_H_(0x02, 0x5B)
#define REG_COMB_BK02_5C_L      _PK_L_(0x02, 0x5C)
#define REG_COMB_BK02_5C_H      _PK_H_(0x02, 0x5C)
#define REG_COMB_BK02_5D_L      _PK_L_(0x02, 0x5D)
#define REG_COMB_BK02_5D_H      _PK_H_(0x02, 0x5D)
#define REG_COMB_BK02_5E_L      _PK_L_(0x02, 0x5E)
#define REG_COMB_BK02_5E_H      _PK_H_(0x02, 0x5E)
#define REG_COMB_BK02_5F_L      _PK_L_(0x02, 0x5F)
#define REG_COMB_BK02_5F_H      _PK_H_(0x02, 0x5F)
#define REG_COMB_BK02_60_L      _PK_L_(0x02, 0x60)
#define REG_COMB_BK02_60_H      _PK_H_(0x02, 0x60)
#define REG_COMB_BK02_61_L      _PK_L_(0x02, 0x61)
#define REG_COMB_BK02_61_H      _PK_H_(0x02, 0x61)
#define REG_COMB_BK02_62_L      _PK_L_(0x02, 0x62)
#define REG_COMB_BK02_62_H      _PK_H_(0x02, 0x62)
#define REG_COMB_BK02_63_L      _PK_L_(0x02, 0x63)
#define REG_COMB_BK02_63_H      _PK_H_(0x02, 0x63)
#define REG_COMB_BK02_64_L      _PK_L_(0x02, 0x64)
#define REG_COMB_BK02_64_H      _PK_H_(0x02, 0x64)
#define REG_COMB_BK02_65_L      _PK_L_(0x02, 0x65)
#define REG_COMB_BK02_65_H      _PK_H_(0x02, 0x65)
#define REG_COMB_BK02_66_L      _PK_L_(0x02, 0x66)
#define REG_COMB_BK02_66_H      _PK_H_(0x02, 0x66)
#define REG_COMB_BK02_67_L      _PK_L_(0x02, 0x67)
#define REG_COMB_BK02_67_H      _PK_H_(0x02, 0x67)
#define REG_COMB_BK02_68_L      _PK_L_(0x02, 0x68)
#define REG_COMB_BK02_68_H      _PK_H_(0x02, 0x68)
#define REG_COMB_BK02_69_L      _PK_L_(0x02, 0x69)
#define REG_COMB_BK02_69_H      _PK_H_(0x02, 0x69)
#define REG_COMB_BK02_6A_L      _PK_L_(0x02, 0x6A)
#define REG_COMB_BK02_6A_H      _PK_H_(0x02, 0x6A)
#define REG_COMB_BK02_6B_L      _PK_L_(0x02, 0x6B)
#define REG_COMB_BK02_6B_H      _PK_H_(0x02, 0x6B)
#define REG_COMB_BK02_6C_L      _PK_L_(0x02, 0x6C)
#define REG_COMB_BK02_6C_H      _PK_H_(0x02, 0x6C)
#define REG_COMB_BK02_6D_L      _PK_L_(0x02, 0x6D)
#define REG_COMB_BK02_6D_H      _PK_H_(0x02, 0x6D)
#define REG_COMB_BK02_6E_L      _PK_L_(0x02, 0x6E)
#define REG_COMB_BK02_6E_H      _PK_H_(0x02, 0x6E)
#define REG_COMB_BK02_6F_L      _PK_L_(0x02, 0x6F)
#define REG_COMB_BK02_6F_H      _PK_H_(0x02, 0x6F)
#define REG_COMB_BK02_70_L      _PK_L_(0x02, 0x70)
#define REG_COMB_BK02_70_H      _PK_H_(0x02, 0x70)
#define REG_COMB_BK02_71_L      _PK_L_(0x02, 0x71)
#define REG_COMB_BK02_71_H      _PK_H_(0x02, 0x71)
#define REG_COMB_BK02_72_L      _PK_L_(0x02, 0x72)
#define REG_COMB_BK02_72_H      _PK_H_(0x02, 0x72)
#define REG_COMB_BK02_73_L      _PK_L_(0x02, 0x73)
#define REG_COMB_BK02_73_H      _PK_H_(0x02, 0x73)
#define REG_COMB_BK02_74_L      _PK_L_(0x02, 0x74)
#define REG_COMB_BK02_74_H      _PK_H_(0x02, 0x74)
#define REG_COMB_BK02_75_L      _PK_L_(0x02, 0x75)
#define REG_COMB_BK02_75_H      _PK_H_(0x02, 0x75)
#define REG_COMB_BK02_76_L      _PK_L_(0x02, 0x76)
#define REG_COMB_BK02_76_H      _PK_H_(0x02, 0x76)
#define REG_COMB_BK02_77_L      _PK_L_(0x02, 0x77)
#define REG_COMB_BK02_77_H      _PK_H_(0x02, 0x77)
#define REG_COMB_BK02_78_L      _PK_L_(0x02, 0x78)
#define REG_COMB_BK02_78_H      _PK_H_(0x02, 0x78)
#define REG_COMB_BK02_79_L      _PK_L_(0x02, 0x79)
#define REG_COMB_BK02_79_H      _PK_H_(0x02, 0x79)
#define REG_COMB_BK02_7A_L      _PK_L_(0x02, 0x7A)
#define REG_COMB_BK02_7A_H      _PK_H_(0x02, 0x7A)
#define REG_COMB_BK02_7B_L      _PK_L_(0x02, 0x7B)
#define REG_COMB_BK02_7B_H      _PK_H_(0x02, 0x7B)
#define REG_COMB_BK02_7C_L      _PK_L_(0x02, 0x7C)
#define REG_COMB_BK02_7C_H      _PK_H_(0x02, 0x7C)
#define REG_COMB_BK02_7D_L      _PK_L_(0x02, 0x7D)
#define REG_COMB_BK02_7D_H      _PK_H_(0x02, 0x7D)
#define REG_COMB_BK02_7E_L      _PK_L_(0x02, 0x7E)
#define REG_COMB_BK02_7E_H      _PK_H_(0x02, 0x7E)
#define REG_COMB_BK02_7F_L      _PK_L_(0x02, 0x7F)
#define REG_COMB_BK02_7F_H      _PK_H_(0x02, 0x7F)
//----------------------------------------------
#define REG_COMB_BK03_00_L      _PK_L_(0x03, 0x00)
#define REG_COMB_BK03_00_H      _PK_H_(0x03, 0x00)
#define REG_COMB_BK03_01_L      _PK_L_(0x03, 0x01)
#define REG_COMB_BK03_01_H      _PK_H_(0x03, 0x01)
#define REG_COMB_BK03_02_L      _PK_L_(0x03, 0x02)
#define REG_COMB_BK03_02_H      _PK_H_(0x03, 0x02)
#define REG_COMB_BK03_03_L      _PK_L_(0x03, 0x03)
#define REG_COMB_BK03_03_H      _PK_H_(0x03, 0x03)
#define REG_COMB_BK03_04_L      _PK_L_(0x03, 0x04)
#define REG_COMB_BK03_04_H      _PK_H_(0x03, 0x04)
#define REG_COMB_BK03_05_L      _PK_L_(0x03, 0x05)
#define REG_COMB_BK03_05_H      _PK_H_(0x03, 0x05)
#define REG_COMB_BK03_06_L      _PK_L_(0x03, 0x06)
#define REG_COMB_BK03_06_H      _PK_H_(0x03, 0x06)
#define REG_COMB_BK03_07_L      _PK_L_(0x03, 0x07)
#define REG_COMB_BK03_07_H      _PK_H_(0x03, 0x07)
#define REG_COMB_BK03_08_L      _PK_L_(0x03, 0x08)
#define REG_COMB_BK03_08_H      _PK_H_(0x03, 0x08)
#define REG_COMB_BK03_09_L      _PK_L_(0x03, 0x09)
#define REG_COMB_BK03_09_H      _PK_H_(0x03, 0x09)
#define REG_COMB_BK03_0A_L      _PK_L_(0x03, 0x0A)
#define REG_COMB_BK03_0A_H      _PK_H_(0x03, 0x0A)
#define REG_COMB_BK03_0B_L      _PK_L_(0x03, 0x0B)
#define REG_COMB_BK03_0B_H      _PK_H_(0x03, 0x0B)
#define REG_COMB_BK03_0C_L      _PK_L_(0x03, 0x0C)
#define REG_COMB_BK03_0C_H      _PK_H_(0x03, 0x0C)
#define REG_COMB_BK03_0D_L      _PK_L_(0x03, 0x0D)
#define REG_COMB_BK03_0D_H      _PK_H_(0x03, 0x0D)
#define REG_COMB_BK03_0E_L      _PK_L_(0x03, 0x0E)
#define REG_COMB_BK03_0E_H      _PK_H_(0x03, 0x0E)
#define REG_COMB_BK03_0F_L      _PK_L_(0x03, 0x0F)
#define REG_COMB_BK03_0F_H      _PK_H_(0x03, 0x0F)
#define REG_COMB_BK03_10_L      _PK_L_(0x03, 0x10)
#define REG_COMB_BK03_10_H      _PK_H_(0x03, 0x10)
#define REG_COMB_BK03_11_L      _PK_L_(0x03, 0x11)
#define REG_COMB_BK03_11_H      _PK_H_(0x03, 0x11)
#define REG_COMB_BK03_12_L      _PK_L_(0x03, 0x12)
#define REG_COMB_BK03_12_H      _PK_H_(0x03, 0x12)
#define REG_COMB_BK03_13_L      _PK_L_(0x03, 0x13)
#define REG_COMB_BK03_13_H      _PK_H_(0x03, 0x13)
#define REG_COMB_BK03_14_L      _PK_L_(0x03, 0x14)
#define REG_COMB_BK03_14_H      _PK_H_(0x03, 0x14)
#define REG_COMB_BK03_15_L      _PK_L_(0x03, 0x15)
#define REG_COMB_BK03_15_H      _PK_H_(0x03, 0x15)
#define REG_COMB_BK03_16_L      _PK_L_(0x03, 0x16)
#define REG_COMB_BK03_16_H      _PK_H_(0x03, 0x16)
#define REG_COMB_BK03_17_L      _PK_L_(0x03, 0x17)
#define REG_COMB_BK03_17_H      _PK_H_(0x03, 0x17)
#define REG_COMB_BK03_18_L      _PK_L_(0x03, 0x18)
#define REG_COMB_BK03_18_H      _PK_H_(0x03, 0x18)
#define REG_COMB_BK03_19_L      _PK_L_(0x03, 0x19)
#define REG_COMB_BK03_19_H      _PK_H_(0x03, 0x19)
#define REG_COMB_BK03_1A_L      _PK_L_(0x03, 0x1A)
#define REG_COMB_BK03_1A_H      _PK_H_(0x03, 0x1A)
#define REG_COMB_BK03_1B_L      _PK_L_(0x03, 0x1B)
#define REG_COMB_BK03_1B_H      _PK_H_(0x03, 0x1B)
#define REG_COMB_BK03_1C_L      _PK_L_(0x03, 0x1C)
#define REG_COMB_BK03_1C_H      _PK_H_(0x03, 0x1C)
#define REG_COMB_BK03_1D_L      _PK_L_(0x03, 0x1D)
#define REG_COMB_BK03_1D_H      _PK_H_(0x03, 0x1D)
#define REG_COMB_BK03_1E_L      _PK_L_(0x03, 0x1E)
#define REG_COMB_BK03_1E_H      _PK_H_(0x03, 0x1E)
#define REG_COMB_BK03_1F_L      _PK_L_(0x03, 0x1F)
#define REG_COMB_BK03_1F_H      _PK_H_(0x03, 0x1F)
#define REG_COMB_BK03_20_L      _PK_L_(0x03, 0x20)
#define REG_COMB_BK03_20_H      _PK_H_(0x03, 0x20)
#define REG_COMB_BK03_21_L      _PK_L_(0x03, 0x21)
#define REG_COMB_BK03_21_H      _PK_H_(0x03, 0x21)
#define REG_COMB_BK03_22_L      _PK_L_(0x03, 0x22)
#define REG_COMB_BK03_22_H      _PK_H_(0x03, 0x22)
#define REG_COMB_BK03_23_L      _PK_L_(0x03, 0x23)
#define REG_COMB_BK03_23_H      _PK_H_(0x03, 0x23)
#define REG_COMB_BK03_24_L      _PK_L_(0x03, 0x24)
#define REG_COMB_BK03_24_H      _PK_H_(0x03, 0x24)
#define REG_COMB_BK03_25_L      _PK_L_(0x03, 0x25)
#define REG_COMB_BK03_25_H      _PK_H_(0x03, 0x25)
#define REG_COMB_BK03_26_L      _PK_L_(0x03, 0x26)
#define REG_COMB_BK03_26_H      _PK_H_(0x03, 0x26)
#define REG_COMB_BK03_27_L      _PK_L_(0x03, 0x27)
#define REG_COMB_BK03_27_H      _PK_H_(0x03, 0x27)
#define REG_COMB_BK03_28_L      _PK_L_(0x03, 0x28)
#define REG_COMB_BK03_28_H      _PK_H_(0x03, 0x28)
#define REG_COMB_BK03_29_L      _PK_L_(0x03, 0x29)
#define REG_COMB_BK03_29_H      _PK_H_(0x03, 0x29)
#define REG_COMB_BK03_2A_L      _PK_L_(0x03, 0x2A)
#define REG_COMB_BK03_2A_H      _PK_H_(0x03, 0x2A)
#define REG_COMB_BK03_2B_L      _PK_L_(0x03, 0x2B)
#define REG_COMB_BK03_2B_H      _PK_H_(0x03, 0x2B)
#define REG_COMB_BK03_2C_L      _PK_L_(0x03, 0x2C)
#define REG_COMB_BK03_2C_H      _PK_H_(0x03, 0x2C)
#define REG_COMB_BK03_2D_L      _PK_L_(0x03, 0x2D)
#define REG_COMB_BK03_2D_H      _PK_H_(0x03, 0x2D)
#define REG_COMB_BK03_2E_L      _PK_L_(0x03, 0x2E)
#define REG_COMB_BK03_2E_H      _PK_H_(0x03, 0x2E)
#define REG_COMB_BK03_2F_L      _PK_L_(0x03, 0x2F)
#define REG_COMB_BK03_2F_H      _PK_H_(0x03, 0x2F)
#define REG_COMB_BK03_30_L      _PK_L_(0x03, 0x30)
#define REG_COMB_BK03_30_H      _PK_H_(0x03, 0x30)
#define REG_COMB_BK03_31_L      _PK_L_(0x03, 0x31)
#define REG_COMB_BK03_31_H      _PK_H_(0x03, 0x31)
#define REG_COMB_BK03_32_L      _PK_L_(0x03, 0x32)
#define REG_COMB_BK03_32_H      _PK_H_(0x03, 0x32)
#define REG_COMB_BK03_33_L      _PK_L_(0x03, 0x33)
#define REG_COMB_BK03_33_H      _PK_H_(0x03, 0x33)
#define REG_COMB_BK03_34_L      _PK_L_(0x03, 0x34)
#define REG_COMB_BK03_34_H      _PK_H_(0x03, 0x34)
#define REG_COMB_BK03_35_L      _PK_L_(0x03, 0x35)
#define REG_COMB_BK03_35_H      _PK_H_(0x03, 0x35)
#define REG_COMB_BK03_36_L      _PK_L_(0x03, 0x36)
#define REG_COMB_BK03_36_H      _PK_H_(0x03, 0x36)
#define REG_COMB_BK03_37_L      _PK_L_(0x03, 0x37)
#define REG_COMB_BK03_37_H      _PK_H_(0x03, 0x37)
#define REG_COMB_BK03_38_L      _PK_L_(0x03, 0x38)
#define REG_COMB_BK03_38_H      _PK_H_(0x03, 0x38)
#define REG_COMB_BK03_39_L      _PK_L_(0x03, 0x39)
#define REG_COMB_BK03_39_H      _PK_H_(0x03, 0x39)
#define REG_COMB_BK03_3A_L      _PK_L_(0x03, 0x3A)
#define REG_COMB_BK03_3A_H      _PK_H_(0x03, 0x3A)
#define REG_COMB_BK03_3B_L      _PK_L_(0x03, 0x3B)
#define REG_COMB_BK03_3B_H      _PK_H_(0x03, 0x3B)
#define REG_COMB_BK03_3C_L      _PK_L_(0x03, 0x3C)
#define REG_COMB_BK03_3C_H      _PK_H_(0x03, 0x3C)
#define REG_COMB_BK03_3D_L      _PK_L_(0x03, 0x3D)
#define REG_COMB_BK03_3D_H      _PK_H_(0x03, 0x3D)
#define REG_COMB_BK03_3E_L      _PK_L_(0x03, 0x3E)
#define REG_COMB_BK03_3E_H      _PK_H_(0x03, 0x3E)
#define REG_COMB_BK03_3F_L      _PK_L_(0x03, 0x3F)
#define REG_COMB_BK03_3F_H      _PK_H_(0x03, 0x3F)
#define REG_COMB_BK03_40_L      _PK_L_(0x03, 0x40)
#define REG_COMB_BK03_40_H      _PK_H_(0x03, 0x40)
#define REG_COMB_BK03_41_L      _PK_L_(0x03, 0x41)
#define REG_COMB_BK03_41_H      _PK_H_(0x03, 0x41)
#define REG_COMB_BK03_42_L      _PK_L_(0x03, 0x42)
#define REG_COMB_BK03_42_H      _PK_H_(0x03, 0x42)
#define REG_COMB_BK03_43_L      _PK_L_(0x03, 0x43)
#define REG_COMB_BK03_43_H      _PK_H_(0x03, 0x43)
#define REG_COMB_BK03_44_L      _PK_L_(0x03, 0x44)
#define REG_COMB_BK03_44_H      _PK_H_(0x03, 0x44)
#define REG_COMB_BK03_45_L      _PK_L_(0x03, 0x45)
#define REG_COMB_BK03_45_H      _PK_H_(0x03, 0x45)
#define REG_COMB_BK03_46_L      _PK_L_(0x03, 0x46)
#define REG_COMB_BK03_46_H      _PK_H_(0x03, 0x46)
#define REG_COMB_BK03_47_L      _PK_L_(0x03, 0x47)
#define REG_COMB_BK03_47_H      _PK_H_(0x03, 0x47)
#define REG_COMB_BK03_48_L      _PK_L_(0x03, 0x48)
#define REG_COMB_BK03_48_H      _PK_H_(0x03, 0x48)
#define REG_COMB_BK03_49_L      _PK_L_(0x03, 0x49)
#define REG_COMB_BK03_49_H      _PK_H_(0x03, 0x49)
#define REG_COMB_BK03_4A_L      _PK_L_(0x03, 0x4A)
#define REG_COMB_BK03_4A_H      _PK_H_(0x03, 0x4A)
#define REG_COMB_BK03_4B_L      _PK_L_(0x03, 0x4B)
#define REG_COMB_BK03_4B_H      _PK_H_(0x03, 0x4B)
#define REG_COMB_BK03_4C_L      _PK_L_(0x03, 0x4C)
#define REG_COMB_BK03_4C_H      _PK_H_(0x03, 0x4C)
#define REG_COMB_BK03_4D_L      _PK_L_(0x03, 0x4D)
#define REG_COMB_BK03_4D_H      _PK_H_(0x03, 0x4D)
#define REG_COMB_BK03_4E_L      _PK_L_(0x03, 0x4E)
#define REG_COMB_BK03_4E_H      _PK_H_(0x03, 0x4E)
#define REG_COMB_BK03_4F_L      _PK_L_(0x03, 0x4F)
#define REG_COMB_BK03_4F_H      _PK_H_(0x03, 0x4F)
#define REG_COMB_BK03_50_L      _PK_L_(0x03, 0x50)
#define REG_COMB_BK03_50_H      _PK_H_(0x03, 0x50)
#define REG_COMB_BK03_51_L      _PK_L_(0x03, 0x51)
#define REG_COMB_BK03_51_H      _PK_H_(0x03, 0x51)
#define REG_COMB_BK03_52_L      _PK_L_(0x03, 0x52)
#define REG_COMB_BK03_52_H      _PK_H_(0x03, 0x52)
#define REG_COMB_BK03_53_L      _PK_L_(0x03, 0x53)
#define REG_COMB_BK03_53_H      _PK_H_(0x03, 0x53)
#define REG_COMB_BK03_54_L      _PK_L_(0x03, 0x54)
#define REG_COMB_BK03_54_H      _PK_H_(0x03, 0x54)
#define REG_COMB_BK03_55_L      _PK_L_(0x03, 0x55)
#define REG_COMB_BK03_55_H      _PK_H_(0x03, 0x55)
#define REG_COMB_BK03_56_L      _PK_L_(0x03, 0x56)
#define REG_COMB_BK03_56_H      _PK_H_(0x03, 0x56)
#define REG_COMB_BK03_57_L      _PK_L_(0x03, 0x57)
#define REG_COMB_BK03_57_H      _PK_H_(0x03, 0x57)
#define REG_COMB_BK03_58_L      _PK_L_(0x03, 0x58)
#define REG_COMB_BK03_58_H      _PK_H_(0x03, 0x58)
#define REG_COMB_BK03_59_L      _PK_L_(0x03, 0x59)
#define REG_COMB_BK03_59_H      _PK_H_(0x03, 0x59)
#define REG_COMB_BK03_5A_L      _PK_L_(0x03, 0x5A)
#define REG_COMB_BK03_5A_H      _PK_H_(0x03, 0x5A)
#define REG_COMB_BK03_5B_L      _PK_L_(0x03, 0x5B)
#define REG_COMB_BK03_5B_H      _PK_H_(0x03, 0x5B)
#define REG_COMB_BK03_5C_L      _PK_L_(0x03, 0x5C)
#define REG_COMB_BK03_5C_H      _PK_H_(0x03, 0x5C)
#define REG_COMB_BK03_5D_L      _PK_L_(0x03, 0x5D)
#define REG_COMB_BK03_5D_H      _PK_H_(0x03, 0x5D)
#define REG_COMB_BK03_5E_L      _PK_L_(0x03, 0x5E)
#define REG_COMB_BK03_5E_H      _PK_H_(0x03, 0x5E)
#define REG_COMB_BK03_5F_L      _PK_L_(0x03, 0x5F)
#define REG_COMB_BK03_5F_H      _PK_H_(0x03, 0x5F)
#define REG_COMB_BK03_60_L      _PK_L_(0x03, 0x60)
#define REG_COMB_BK03_60_H      _PK_H_(0x03, 0x60)
#define REG_COMB_BK03_61_L      _PK_L_(0x03, 0x61)
#define REG_COMB_BK03_61_H      _PK_H_(0x03, 0x61)
#define REG_COMB_BK03_62_L      _PK_L_(0x03, 0x62)
#define REG_COMB_BK03_62_H      _PK_H_(0x03, 0x62)
#define REG_COMB_BK03_63_L      _PK_L_(0x03, 0x63)
#define REG_COMB_BK03_63_H      _PK_H_(0x03, 0x63)
#define REG_COMB_BK03_64_L      _PK_L_(0x03, 0x64)
#define REG_COMB_BK03_64_H      _PK_H_(0x03, 0x64)
#define REG_COMB_BK03_65_L      _PK_L_(0x03, 0x65)
#define REG_COMB_BK03_65_H      _PK_H_(0x03, 0x65)
#define REG_COMB_BK03_66_L      _PK_L_(0x03, 0x66)
#define REG_COMB_BK03_66_H      _PK_H_(0x03, 0x66)
#define REG_COMB_BK03_67_L      _PK_L_(0x03, 0x67)
#define REG_COMB_BK03_67_H      _PK_H_(0x03, 0x67)
#define REG_COMB_BK03_68_L      _PK_L_(0x03, 0x68)
#define REG_COMB_BK03_68_H      _PK_H_(0x03, 0x68)
#define REG_COMB_BK03_69_L      _PK_L_(0x03, 0x69)
#define REG_COMB_BK03_69_H      _PK_H_(0x03, 0x69)
#define REG_COMB_BK03_6A_L      _PK_L_(0x03, 0x6A)
#define REG_COMB_BK03_6A_H      _PK_H_(0x03, 0x6A)
#define REG_COMB_BK03_6B_L      _PK_L_(0x03, 0x6B)
#define REG_COMB_BK03_6B_H      _PK_H_(0x03, 0x6B)
#define REG_COMB_BK03_6C_L      _PK_L_(0x03, 0x6C)
#define REG_COMB_BK03_6C_H      _PK_H_(0x03, 0x6C)
#define REG_COMB_BK03_6D_L      _PK_L_(0x03, 0x6D)
#define REG_COMB_BK03_6D_H      _PK_H_(0x03, 0x6D)
#define REG_COMB_BK03_6E_L      _PK_L_(0x03, 0x6E)
#define REG_COMB_BK03_6E_H      _PK_H_(0x03, 0x6E)
#define REG_COMB_BK03_6F_L      _PK_L_(0x03, 0x6F)
#define REG_COMB_BK03_6F_H      _PK_H_(0x03, 0x6F)
#define REG_COMB_BK03_70_L      _PK_L_(0x03, 0x70)
#define REG_COMB_BK03_70_H      _PK_H_(0x03, 0x70)
#define REG_COMB_BK03_71_L      _PK_L_(0x03, 0x71)
#define REG_COMB_BK03_71_H      _PK_H_(0x03, 0x71)
#define REG_COMB_BK03_72_L      _PK_L_(0x03, 0x72)
#define REG_COMB_BK03_72_H      _PK_H_(0x03, 0x72)
#define REG_COMB_BK03_73_L      _PK_L_(0x03, 0x73)
#define REG_COMB_BK03_73_H      _PK_H_(0x03, 0x73)
#define REG_COMB_BK03_74_L      _PK_L_(0x03, 0x74)
#define REG_COMB_BK03_74_H      _PK_H_(0x03, 0x74)
#define REG_COMB_BK03_75_L      _PK_L_(0x03, 0x75)
#define REG_COMB_BK03_75_H      _PK_H_(0x03, 0x75)
#define REG_COMB_BK03_76_L      _PK_L_(0x03, 0x76)
#define REG_COMB_BK03_76_H      _PK_H_(0x03, 0x76)
#define REG_COMB_BK03_77_L      _PK_L_(0x03, 0x77)
#define REG_COMB_BK03_77_H      _PK_H_(0x03, 0x77)
#define REG_COMB_BK03_78_L      _PK_L_(0x03, 0x78)
#define REG_COMB_BK03_78_H      _PK_H_(0x03, 0x78)
#define REG_COMB_BK03_79_L      _PK_L_(0x03, 0x79)
#define REG_COMB_BK03_79_H      _PK_H_(0x03, 0x79)
#define REG_COMB_BK03_7A_L      _PK_L_(0x03, 0x7A)
#define REG_COMB_BK03_7A_H      _PK_H_(0x03, 0x7A)
#define REG_COMB_BK03_7B_L      _PK_L_(0x03, 0x7B)
#define REG_COMB_BK03_7B_H      _PK_H_(0x03, 0x7B)
#define REG_COMB_BK03_7C_L      _PK_L_(0x03, 0x7C)
#define REG_COMB_BK03_7C_H      _PK_H_(0x03, 0x7C)
#define REG_COMB_BK03_7D_L      _PK_L_(0x03, 0x7D)
#define REG_COMB_BK03_7D_H      _PK_H_(0x03, 0x7D)
#define REG_COMB_BK03_7E_L      _PK_L_(0x03, 0x7E)
#define REG_COMB_BK03_7E_H      _PK_H_(0x03, 0x7E)
#define REG_COMB_BK03_7F_L      _PK_L_(0x03, 0x7F)
#define REG_COMB_BK03_7F_H      _PK_H_(0x03, 0x7F)
//----------------------------------------------
#define REG_COMB_BK04_00_L      _PK_L_(0x04, 0x00)
#define REG_COMB_BK04_00_H      _PK_H_(0x04, 0x00)
#define REG_COMB_BK04_01_L      _PK_L_(0x04, 0x01)
#define REG_COMB_BK04_01_H      _PK_H_(0x04, 0x01)
#define REG_COMB_BK04_02_L      _PK_L_(0x04, 0x02)
#define REG_COMB_BK04_02_H      _PK_H_(0x04, 0x02)
#define REG_COMB_BK04_03_L      _PK_L_(0x04, 0x03)
#define REG_COMB_BK04_03_H      _PK_H_(0x04, 0x03)
#define REG_COMB_BK04_04_L      _PK_L_(0x04, 0x04)
#define REG_COMB_BK04_04_H      _PK_H_(0x04, 0x04)
#define REG_COMB_BK04_05_L      _PK_L_(0x04, 0x05)
#define REG_COMB_BK04_05_H      _PK_H_(0x04, 0x05)
#define REG_COMB_BK04_06_L      _PK_L_(0x04, 0x06)
#define REG_COMB_BK04_06_H      _PK_H_(0x04, 0x06)
#define REG_COMB_BK04_07_L      _PK_L_(0x04, 0x07)
#define REG_COMB_BK04_07_H      _PK_H_(0x04, 0x07)
#define REG_COMB_BK04_08_L      _PK_L_(0x04, 0x08)
#define REG_COMB_BK04_08_H      _PK_H_(0x04, 0x08)
#define REG_COMB_BK04_09_L      _PK_L_(0x04, 0x09)
#define REG_COMB_BK04_09_H      _PK_H_(0x04, 0x09)
#define REG_COMB_BK04_0A_L      _PK_L_(0x04, 0x0A)
#define REG_COMB_BK04_0A_H      _PK_H_(0x04, 0x0A)
#define REG_COMB_BK04_0B_L      _PK_L_(0x04, 0x0B)
#define REG_COMB_BK04_0B_H      _PK_H_(0x04, 0x0B)
#define REG_COMB_BK04_0C_L      _PK_L_(0x04, 0x0C)
#define REG_COMB_BK04_0C_H      _PK_H_(0x04, 0x0C)
#define REG_COMB_BK04_0D_L      _PK_L_(0x04, 0x0D)
#define REG_COMB_BK04_0D_H      _PK_H_(0x04, 0x0D)
#define REG_COMB_BK04_0E_L      _PK_L_(0x04, 0x0E)
#define REG_COMB_BK04_0E_H      _PK_H_(0x04, 0x0E)
#define REG_COMB_BK04_0F_L      _PK_L_(0x04, 0x0F)
#define REG_COMB_BK04_0F_H      _PK_H_(0x04, 0x0F)
#define REG_COMB_BK04_10_L      _PK_L_(0x04, 0x10)
#define REG_COMB_BK04_10_H      _PK_H_(0x04, 0x10)
#define REG_COMB_BK04_11_L      _PK_L_(0x04, 0x11)
#define REG_COMB_BK04_11_H      _PK_H_(0x04, 0x11)
#define REG_COMB_BK04_12_L      _PK_L_(0x04, 0x12)
#define REG_COMB_BK04_12_H      _PK_H_(0x04, 0x12)
#define REG_COMB_BK04_13_L      _PK_L_(0x04, 0x13)
#define REG_COMB_BK04_13_H      _PK_H_(0x04, 0x13)
#define REG_COMB_BK04_14_L      _PK_L_(0x04, 0x14)
#define REG_COMB_BK04_14_H      _PK_H_(0x04, 0x14)
#define REG_COMB_BK04_15_L      _PK_L_(0x04, 0x15)
#define REG_COMB_BK04_15_H      _PK_H_(0x04, 0x15)
#define REG_COMB_BK04_16_L      _PK_L_(0x04, 0x16)
#define REG_COMB_BK04_16_H      _PK_H_(0x04, 0x16)
#define REG_COMB_BK04_17_L      _PK_L_(0x04, 0x17)
#define REG_COMB_BK04_17_H      _PK_H_(0x04, 0x17)
#define REG_COMB_BK04_18_L      _PK_L_(0x04, 0x18)
#define REG_COMB_BK04_18_H      _PK_H_(0x04, 0x18)
#define REG_COMB_BK04_19_L      _PK_L_(0x04, 0x19)
#define REG_COMB_BK04_19_H      _PK_H_(0x04, 0x19)
#define REG_COMB_BK04_1A_L      _PK_L_(0x04, 0x1A)
#define REG_COMB_BK04_1A_H      _PK_H_(0x04, 0x1A)
#define REG_COMB_BK04_1B_L      _PK_L_(0x04, 0x1B)
#define REG_COMB_BK04_1B_H      _PK_H_(0x04, 0x1B)
#define REG_COMB_BK04_1C_L      _PK_L_(0x04, 0x1C)
#define REG_COMB_BK04_1C_H      _PK_H_(0x04, 0x1C)
#define REG_COMB_BK04_1D_L      _PK_L_(0x04, 0x1D)
#define REG_COMB_BK04_1D_H      _PK_H_(0x04, 0x1D)
#define REG_COMB_BK04_1E_L      _PK_L_(0x04, 0x1E)
#define REG_COMB_BK04_1E_H      _PK_H_(0x04, 0x1E)
#define REG_COMB_BK04_1F_L      _PK_L_(0x04, 0x1F)
#define REG_COMB_BK04_1F_H      _PK_H_(0x04, 0x1F)
#define REG_COMB_BK04_20_L      _PK_L_(0x04, 0x20)
#define REG_COMB_BK04_20_H      _PK_H_(0x04, 0x20)
#define REG_COMB_BK04_21_L      _PK_L_(0x04, 0x21)
#define REG_COMB_BK04_21_H      _PK_H_(0x04, 0x21)
#define REG_COMB_BK04_22_L      _PK_L_(0x04, 0x22)
#define REG_COMB_BK04_22_H      _PK_H_(0x04, 0x22)
#define REG_COMB_BK04_23_L      _PK_L_(0x04, 0x23)
#define REG_COMB_BK04_23_H      _PK_H_(0x04, 0x23)
#define REG_COMB_BK04_24_L      _PK_L_(0x04, 0x24)
#define REG_COMB_BK04_24_H      _PK_H_(0x04, 0x24)
#define REG_COMB_BK04_25_L      _PK_L_(0x04, 0x25)
#define REG_COMB_BK04_25_H      _PK_H_(0x04, 0x25)
#define REG_COMB_BK04_26_L      _PK_L_(0x04, 0x26)
#define REG_COMB_BK04_26_H      _PK_H_(0x04, 0x26)
#define REG_COMB_BK04_27_L      _PK_L_(0x04, 0x27)
#define REG_COMB_BK04_27_H      _PK_H_(0x04, 0x27)
#define REG_COMB_BK04_28_L      _PK_L_(0x04, 0x28)
#define REG_COMB_BK04_28_H      _PK_H_(0x04, 0x28)
#define REG_COMB_BK04_29_L      _PK_L_(0x04, 0x29)
#define REG_COMB_BK04_29_H      _PK_H_(0x04, 0x29)
#define REG_COMB_BK04_2A_L      _PK_L_(0x04, 0x2A)
#define REG_COMB_BK04_2A_H      _PK_H_(0x04, 0x2A)
#define REG_COMB_BK04_2B_L      _PK_L_(0x04, 0x2B)
#define REG_COMB_BK04_2B_H      _PK_H_(0x04, 0x2B)
#define REG_COMB_BK04_2C_L      _PK_L_(0x04, 0x2C)
#define REG_COMB_BK04_2C_H      _PK_H_(0x04, 0x2C)
#define REG_COMB_BK04_2D_L      _PK_L_(0x04, 0x2D)
#define REG_COMB_BK04_2D_H      _PK_H_(0x04, 0x2D)
#define REG_COMB_BK04_2E_L      _PK_L_(0x04, 0x2E)
#define REG_COMB_BK04_2E_H      _PK_H_(0x04, 0x2E)
#define REG_COMB_BK04_2F_L      _PK_L_(0x04, 0x2F)
#define REG_COMB_BK04_2F_H      _PK_H_(0x04, 0x2F)
#define REG_COMB_BK04_30_L      _PK_L_(0x04, 0x30)
#define REG_COMB_BK04_30_H      _PK_H_(0x04, 0x30)
#define REG_COMB_BK04_31_L      _PK_L_(0x04, 0x31)
#define REG_COMB_BK04_31_H      _PK_H_(0x04, 0x31)
#define REG_COMB_BK04_32_L      _PK_L_(0x04, 0x32)
#define REG_COMB_BK04_32_H      _PK_H_(0x04, 0x32)
#define REG_COMB_BK04_33_L      _PK_L_(0x04, 0x33)
#define REG_COMB_BK04_33_H      _PK_H_(0x04, 0x33)
#define REG_COMB_BK04_34_L      _PK_L_(0x04, 0x34)
#define REG_COMB_BK04_34_H      _PK_H_(0x04, 0x34)
#define REG_COMB_BK04_35_L      _PK_L_(0x04, 0x35)
#define REG_COMB_BK04_35_H      _PK_H_(0x04, 0x35)
#define REG_COMB_BK04_36_L      _PK_L_(0x04, 0x36)
#define REG_COMB_BK04_36_H      _PK_H_(0x04, 0x36)
#define REG_COMB_BK04_37_L      _PK_L_(0x04, 0x37)
#define REG_COMB_BK04_37_H      _PK_H_(0x04, 0x37)
#define REG_COMB_BK04_38_L      _PK_L_(0x04, 0x38)
#define REG_COMB_BK04_38_H      _PK_H_(0x04, 0x38)
#define REG_COMB_BK04_39_L      _PK_L_(0x04, 0x39)
#define REG_COMB_BK04_39_H      _PK_H_(0x04, 0x39)
#define REG_COMB_BK04_3A_L      _PK_L_(0x04, 0x3A)
#define REG_COMB_BK04_3A_H      _PK_H_(0x04, 0x3A)
#define REG_COMB_BK04_3B_L      _PK_L_(0x04, 0x3B)
#define REG_COMB_BK04_3B_H      _PK_H_(0x04, 0x3B)
#define REG_COMB_BK04_3C_L      _PK_L_(0x04, 0x3C)
#define REG_COMB_BK04_3C_H      _PK_H_(0x04, 0x3C)
#define REG_COMB_BK04_3D_L      _PK_L_(0x04, 0x3D)
#define REG_COMB_BK04_3D_H      _PK_H_(0x04, 0x3D)
#define REG_COMB_BK04_3E_L      _PK_L_(0x04, 0x3E)
#define REG_COMB_BK04_3E_H      _PK_H_(0x04, 0x3E)
#define REG_COMB_BK04_3F_L      _PK_L_(0x04, 0x3F)
#define REG_COMB_BK04_3F_H      _PK_H_(0x04, 0x3F)
#define REG_COMB_BK04_40_L      _PK_L_(0x04, 0x40)
#define REG_COMB_BK04_40_H      _PK_H_(0x04, 0x40)
#define REG_COMB_BK04_41_L      _PK_L_(0x04, 0x41)
#define REG_COMB_BK04_41_H      _PK_H_(0x04, 0x41)
#define REG_COMB_BK04_42_L      _PK_L_(0x04, 0x42)
#define REG_COMB_BK04_42_H      _PK_H_(0x04, 0x42)
#define REG_COMB_BK04_43_L      _PK_L_(0x04, 0x43)
#define REG_COMB_BK04_43_H      _PK_H_(0x04, 0x43)
#define REG_COMB_BK04_44_L      _PK_L_(0x04, 0x44)
#define REG_COMB_BK04_44_H      _PK_H_(0x04, 0x44)
#define REG_COMB_BK04_45_L      _PK_L_(0x04, 0x45)
#define REG_COMB_BK04_45_H      _PK_H_(0x04, 0x45)
#define REG_COMB_BK04_46_L      _PK_L_(0x04, 0x46)
#define REG_COMB_BK04_46_H      _PK_H_(0x04, 0x46)
#define REG_COMB_BK04_47_L      _PK_L_(0x04, 0x47)
#define REG_COMB_BK04_47_H      _PK_H_(0x04, 0x47)
#define REG_COMB_BK04_48_L      _PK_L_(0x04, 0x48)
#define REG_COMB_BK04_48_H      _PK_H_(0x04, 0x48)
#define REG_COMB_BK04_49_L      _PK_L_(0x04, 0x49)
#define REG_COMB_BK04_49_H      _PK_H_(0x04, 0x49)
#define REG_COMB_BK04_4A_L      _PK_L_(0x04, 0x4A)
#define REG_COMB_BK04_4A_H      _PK_H_(0x04, 0x4A)
#define REG_COMB_BK04_4B_L      _PK_L_(0x04, 0x4B)
#define REG_COMB_BK04_4B_H      _PK_H_(0x04, 0x4B)
#define REG_COMB_BK04_4C_L      _PK_L_(0x04, 0x4C)
#define REG_COMB_BK04_4C_H      _PK_H_(0x04, 0x4C)
#define REG_COMB_BK04_4D_L      _PK_L_(0x04, 0x4D)
#define REG_COMB_BK04_4D_H      _PK_H_(0x04, 0x4D)
#define REG_COMB_BK04_4E_L      _PK_L_(0x04, 0x4E)
#define REG_COMB_BK04_4E_H      _PK_H_(0x04, 0x4E)
#define REG_COMB_BK04_4F_L      _PK_L_(0x04, 0x4F)
#define REG_COMB_BK04_4F_H      _PK_H_(0x04, 0x4F)
#define REG_COMB_BK04_50_L      _PK_L_(0x04, 0x50)
#define REG_COMB_BK04_50_H      _PK_H_(0x04, 0x50)
#define REG_COMB_BK04_51_L      _PK_L_(0x04, 0x51)
#define REG_COMB_BK04_51_H      _PK_H_(0x04, 0x51)
#define REG_COMB_BK04_52_L      _PK_L_(0x04, 0x52)
#define REG_COMB_BK04_52_H      _PK_H_(0x04, 0x52)
#define REG_COMB_BK04_53_L      _PK_L_(0x04, 0x53)
#define REG_COMB_BK04_53_H      _PK_H_(0x04, 0x53)
#define REG_COMB_BK04_54_L      _PK_L_(0x04, 0x54)
#define REG_COMB_BK04_54_H      _PK_H_(0x04, 0x54)
#define REG_COMB_BK04_55_L      _PK_L_(0x04, 0x55)
#define REG_COMB_BK04_55_H      _PK_H_(0x04, 0x55)
#define REG_COMB_BK04_56_L      _PK_L_(0x04, 0x56)
#define REG_COMB_BK04_56_H      _PK_H_(0x04, 0x56)
#define REG_COMB_BK04_57_L      _PK_L_(0x04, 0x57)
#define REG_COMB_BK04_57_H      _PK_H_(0x04, 0x57)
#define REG_COMB_BK04_58_L      _PK_L_(0x04, 0x58)
#define REG_COMB_BK04_58_H      _PK_H_(0x04, 0x58)
#define REG_COMB_BK04_59_L      _PK_L_(0x04, 0x59)
#define REG_COMB_BK04_59_H      _PK_H_(0x04, 0x59)
#define REG_COMB_BK04_5A_L      _PK_L_(0x04, 0x5A)
#define REG_COMB_BK04_5A_H      _PK_H_(0x04, 0x5A)
#define REG_COMB_BK04_5B_L      _PK_L_(0x04, 0x5B)
#define REG_COMB_BK04_5B_H      _PK_H_(0x04, 0x5B)
#define REG_COMB_BK04_5C_L      _PK_L_(0x04, 0x5C)
#define REG_COMB_BK04_5C_H      _PK_H_(0x04, 0x5C)
#define REG_COMB_BK04_5D_L      _PK_L_(0x04, 0x5D)
#define REG_COMB_BK04_5D_H      _PK_H_(0x04, 0x5D)
#define REG_COMB_BK04_5E_L      _PK_L_(0x04, 0x5E)
#define REG_COMB_BK04_5E_H      _PK_H_(0x04, 0x5E)
#define REG_COMB_BK04_5F_L      _PK_L_(0x04, 0x5F)
#define REG_COMB_BK04_5F_H      _PK_H_(0x04, 0x5F)
#define REG_COMB_BK04_60_L      _PK_L_(0x04, 0x60)
#define REG_COMB_BK04_60_H      _PK_H_(0x04, 0x60)
#define REG_COMB_BK04_61_L      _PK_L_(0x04, 0x61)
#define REG_COMB_BK04_61_H      _PK_H_(0x04, 0x61)
#define REG_COMB_BK04_62_L      _PK_L_(0x04, 0x62)
#define REG_COMB_BK04_62_H      _PK_H_(0x04, 0x62)
#define REG_COMB_BK04_63_L      _PK_L_(0x04, 0x63)
#define REG_COMB_BK04_63_H      _PK_H_(0x04, 0x63)
#define REG_COMB_BK04_64_L      _PK_L_(0x04, 0x64)
#define REG_COMB_BK04_64_H      _PK_H_(0x04, 0x64)
#define REG_COMB_BK04_65_L      _PK_L_(0x04, 0x65)
#define REG_COMB_BK04_65_H      _PK_H_(0x04, 0x65)
#define REG_COMB_BK04_66_L      _PK_L_(0x04, 0x66)
#define REG_COMB_BK04_66_H      _PK_H_(0x04, 0x66)
#define REG_COMB_BK04_67_L      _PK_L_(0x04, 0x67)
#define REG_COMB_BK04_67_H      _PK_H_(0x04, 0x67)
#define REG_COMB_BK04_68_L      _PK_L_(0x04, 0x68)
#define REG_COMB_BK04_68_H      _PK_H_(0x04, 0x68)
#define REG_COMB_BK04_69_L      _PK_L_(0x04, 0x69)
#define REG_COMB_BK04_69_H      _PK_H_(0x04, 0x69)
#define REG_COMB_BK04_6A_L      _PK_L_(0x04, 0x6A)
#define REG_COMB_BK04_6A_H      _PK_H_(0x04, 0x6A)
#define REG_COMB_BK04_6B_L      _PK_L_(0x04, 0x6B)
#define REG_COMB_BK04_6B_H      _PK_H_(0x04, 0x6B)
#define REG_COMB_BK04_6C_L      _PK_L_(0x04, 0x6C)
#define REG_COMB_BK04_6C_H      _PK_H_(0x04, 0x6C)
#define REG_COMB_BK04_6D_L      _PK_L_(0x04, 0x6D)
#define REG_COMB_BK04_6D_H      _PK_H_(0x04, 0x6D)
#define REG_COMB_BK04_6E_L      _PK_L_(0x04, 0x6E)
#define REG_COMB_BK04_6E_H      _PK_H_(0x04, 0x6E)
#define REG_COMB_BK04_6F_L      _PK_L_(0x04, 0x6F)
#define REG_COMB_BK04_6F_H      _PK_H_(0x04, 0x6F)
#define REG_COMB_BK04_70_L      _PK_L_(0x04, 0x70)
#define REG_COMB_BK04_70_H      _PK_H_(0x04, 0x70)
#define REG_COMB_BK04_71_L      _PK_L_(0x04, 0x71)
#define REG_COMB_BK04_71_H      _PK_H_(0x04, 0x71)
#define REG_COMB_BK04_72_L      _PK_L_(0x04, 0x72)
#define REG_COMB_BK04_72_H      _PK_H_(0x04, 0x72)
#define REG_COMB_BK04_73_L      _PK_L_(0x04, 0x73)
#define REG_COMB_BK04_73_H      _PK_H_(0x04, 0x73)
#define REG_COMB_BK04_74_L      _PK_L_(0x04, 0x74)
#define REG_COMB_BK04_74_H      _PK_H_(0x04, 0x74)
#define REG_COMB_BK04_75_L      _PK_L_(0x04, 0x75)
#define REG_COMB_BK04_75_H      _PK_H_(0x04, 0x75)
#define REG_COMB_BK04_76_L      _PK_L_(0x04, 0x76)
#define REG_COMB_BK04_76_H      _PK_H_(0x04, 0x76)
#define REG_COMB_BK04_77_L      _PK_L_(0x04, 0x77)
#define REG_COMB_BK04_77_H      _PK_H_(0x04, 0x77)
#define REG_COMB_BK04_78_L      _PK_L_(0x04, 0x78)
#define REG_COMB_BK04_78_H      _PK_H_(0x04, 0x78)
#define REG_COMB_BK04_79_L      _PK_L_(0x04, 0x79)
#define REG_COMB_BK04_79_H      _PK_H_(0x04, 0x79)
#define REG_COMB_BK04_7A_L      _PK_L_(0x04, 0x7A)
#define REG_COMB_BK04_7A_H      _PK_H_(0x04, 0x7A)
#define REG_COMB_BK04_7B_L      _PK_L_(0x04, 0x7B)
#define REG_COMB_BK04_7B_H      _PK_H_(0x04, 0x7B)
#define REG_COMB_BK04_7C_L      _PK_L_(0x04, 0x7C)
#define REG_COMB_BK04_7C_H      _PK_H_(0x04, 0x7C)
#define REG_COMB_BK04_7D_L      _PK_L_(0x04, 0x7D)
#define REG_COMB_BK04_7D_H      _PK_H_(0x04, 0x7D)
#define REG_COMB_BK04_7E_L      _PK_L_(0x04, 0x7E)
#define REG_COMB_BK04_7E_H      _PK_H_(0x04, 0x7E)
#define REG_COMB_BK04_7F_L      _PK_L_(0x04, 0x7F)
#define REG_COMB_BK04_7F_H      _PK_H_(0x04, 0x7F)
//----------------------------------------------
#define REG_COMB_BK05_00_L      _PK_L_(0x05, 0x00)
#define REG_COMB_BK05_00_H      _PK_H_(0x05, 0x00)
#define REG_COMB_BK05_01_L      _PK_L_(0x05, 0x01)
#define REG_COMB_BK05_01_H      _PK_H_(0x05, 0x01)
#define REG_COMB_BK05_02_L      _PK_L_(0x05, 0x02)
#define REG_COMB_BK05_02_H      _PK_H_(0x05, 0x02)
#define REG_COMB_BK05_03_L      _PK_L_(0x05, 0x03)
#define REG_COMB_BK05_03_H      _PK_H_(0x05, 0x03)
#define REG_COMB_BK05_04_L      _PK_L_(0x05, 0x04)
#define REG_COMB_BK05_04_H      _PK_H_(0x05, 0x04)
#define REG_COMB_BK05_05_L      _PK_L_(0x05, 0x05)
#define REG_COMB_BK05_05_H      _PK_H_(0x05, 0x05)
#define REG_COMB_BK05_06_L      _PK_L_(0x05, 0x06)
#define REG_COMB_BK05_06_H      _PK_H_(0x05, 0x06)
#define REG_COMB_BK05_07_L      _PK_L_(0x05, 0x07)
#define REG_COMB_BK05_07_H      _PK_H_(0x05, 0x07)
#define REG_COMB_BK05_08_L      _PK_L_(0x05, 0x08)
#define REG_COMB_BK05_08_H      _PK_H_(0x05, 0x08)
#define REG_COMB_BK05_09_L      _PK_L_(0x05, 0x09)
#define REG_COMB_BK05_09_H      _PK_H_(0x05, 0x09)
#define REG_COMB_BK05_0A_L      _PK_L_(0x05, 0x0A)
#define REG_COMB_BK05_0A_H      _PK_H_(0x05, 0x0A)
#define REG_COMB_BK05_0B_L      _PK_L_(0x05, 0x0B)
#define REG_COMB_BK05_0B_H      _PK_H_(0x05, 0x0B)
#define REG_COMB_BK05_0C_L      _PK_L_(0x05, 0x0C)
#define REG_COMB_BK05_0C_H      _PK_H_(0x05, 0x0C)
#define REG_COMB_BK05_0D_L      _PK_L_(0x05, 0x0D)
#define REG_COMB_BK05_0D_H      _PK_H_(0x05, 0x0D)
#define REG_COMB_BK05_0E_L      _PK_L_(0x05, 0x0E)
#define REG_COMB_BK05_0E_H      _PK_H_(0x05, 0x0E)
#define REG_COMB_BK05_0F_L      _PK_L_(0x05, 0x0F)
#define REG_COMB_BK05_0F_H      _PK_H_(0x05, 0x0F)
#define REG_COMB_BK05_10_L      _PK_L_(0x05, 0x10)
#define REG_COMB_BK05_10_H      _PK_H_(0x05, 0x10)
#define REG_COMB_BK05_11_L      _PK_L_(0x05, 0x11)
#define REG_COMB_BK05_11_H      _PK_H_(0x05, 0x11)
#define REG_COMB_BK05_12_L      _PK_L_(0x05, 0x12)
#define REG_COMB_BK05_12_H      _PK_H_(0x05, 0x12)
#define REG_COMB_BK05_13_L      _PK_L_(0x05, 0x13)
#define REG_COMB_BK05_13_H      _PK_H_(0x05, 0x13)
#define REG_COMB_BK05_14_L      _PK_L_(0x05, 0x14)
#define REG_COMB_BK05_14_H      _PK_H_(0x05, 0x14)
#define REG_COMB_BK05_15_L      _PK_L_(0x05, 0x15)
#define REG_COMB_BK05_15_H      _PK_H_(0x05, 0x15)
#define REG_COMB_BK05_16_L      _PK_L_(0x05, 0x16)
#define REG_COMB_BK05_16_H      _PK_H_(0x05, 0x16)
#define REG_COMB_BK05_17_L      _PK_L_(0x05, 0x17)
#define REG_COMB_BK05_17_H      _PK_H_(0x05, 0x17)
#define REG_COMB_BK05_18_L      _PK_L_(0x05, 0x18)
#define REG_COMB_BK05_18_H      _PK_H_(0x05, 0x18)
#define REG_COMB_BK05_19_L      _PK_L_(0x05, 0x19)
#define REG_COMB_BK05_19_H      _PK_H_(0x05, 0x19)
#define REG_COMB_BK05_1A_L      _PK_L_(0x05, 0x1A)
#define REG_COMB_BK05_1A_H      _PK_H_(0x05, 0x1A)
#define REG_COMB_BK05_1B_L      _PK_L_(0x05, 0x1B)
#define REG_COMB_BK05_1B_H      _PK_H_(0x05, 0x1B)
#define REG_COMB_BK05_1C_L      _PK_L_(0x05, 0x1C)
#define REG_COMB_BK05_1C_H      _PK_H_(0x05, 0x1C)
#define REG_COMB_BK05_1D_L      _PK_L_(0x05, 0x1D)
#define REG_COMB_BK05_1D_H      _PK_H_(0x05, 0x1D)
#define REG_COMB_BK05_1E_L      _PK_L_(0x05, 0x1E)
#define REG_COMB_BK05_1E_H      _PK_H_(0x05, 0x1E)
#define REG_COMB_BK05_1F_L      _PK_L_(0x05, 0x1F)
#define REG_COMB_BK05_1F_H      _PK_H_(0x05, 0x1F)
#define REG_COMB_BK05_20_L      _PK_L_(0x05, 0x20)
#define REG_COMB_BK05_20_H      _PK_H_(0x05, 0x20)
#define REG_COMB_BK05_21_L      _PK_L_(0x05, 0x21)
#define REG_COMB_BK05_21_H      _PK_H_(0x05, 0x21)
#define REG_COMB_BK05_22_L      _PK_L_(0x05, 0x22)
#define REG_COMB_BK05_22_H      _PK_H_(0x05, 0x22)
#define REG_COMB_BK05_23_L      _PK_L_(0x05, 0x23)
#define REG_COMB_BK05_23_H      _PK_H_(0x05, 0x23)
#define REG_COMB_BK05_24_L      _PK_L_(0x05, 0x24)
#define REG_COMB_BK05_24_H      _PK_H_(0x05, 0x24)
#define REG_COMB_BK05_25_L      _PK_L_(0x05, 0x25)
#define REG_COMB_BK05_25_H      _PK_H_(0x05, 0x25)
#define REG_COMB_BK05_26_L      _PK_L_(0x05, 0x26)
#define REG_COMB_BK05_26_H      _PK_H_(0x05, 0x26)
#define REG_COMB_BK05_27_L      _PK_L_(0x05, 0x27)
#define REG_COMB_BK05_27_H      _PK_H_(0x05, 0x27)
#define REG_COMB_BK05_28_L      _PK_L_(0x05, 0x28)
#define REG_COMB_BK05_28_H      _PK_H_(0x05, 0x28)
#define REG_COMB_BK05_29_L      _PK_L_(0x05, 0x29)
#define REG_COMB_BK05_29_H      _PK_H_(0x05, 0x29)
#define REG_COMB_BK05_2A_L      _PK_L_(0x05, 0x2A)
#define REG_COMB_BK05_2A_H      _PK_H_(0x05, 0x2A)
#define REG_COMB_BK05_2B_L      _PK_L_(0x05, 0x2B)
#define REG_COMB_BK05_2B_H      _PK_H_(0x05, 0x2B)
#define REG_COMB_BK05_2C_L      _PK_L_(0x05, 0x2C)
#define REG_COMB_BK05_2C_H      _PK_H_(0x05, 0x2C)
#define REG_COMB_BK05_2D_L      _PK_L_(0x05, 0x2D)
#define REG_COMB_BK05_2D_H      _PK_H_(0x05, 0x2D)
#define REG_COMB_BK05_2E_L      _PK_L_(0x05, 0x2E)
#define REG_COMB_BK05_2E_H      _PK_H_(0x05, 0x2E)
#define REG_COMB_BK05_2F_L      _PK_L_(0x05, 0x2F)
#define REG_COMB_BK05_2F_H      _PK_H_(0x05, 0x2F)
#define REG_COMB_BK05_30_L      _PK_L_(0x05, 0x30)
#define REG_COMB_BK05_30_H      _PK_H_(0x05, 0x30)
#define REG_COMB_BK05_31_L      _PK_L_(0x05, 0x31)
#define REG_COMB_BK05_31_H      _PK_H_(0x05, 0x31)
#define REG_COMB_BK05_32_L      _PK_L_(0x05, 0x32)
#define REG_COMB_BK05_32_H      _PK_H_(0x05, 0x32)
#define REG_COMB_BK05_33_L      _PK_L_(0x05, 0x33)
#define REG_COMB_BK05_33_H      _PK_H_(0x05, 0x33)
#define REG_COMB_BK05_34_L      _PK_L_(0x05, 0x34)
#define REG_COMB_BK05_34_H      _PK_H_(0x05, 0x34)
#define REG_COMB_BK05_35_L      _PK_L_(0x05, 0x35)
#define REG_COMB_BK05_35_H      _PK_H_(0x05, 0x35)
#define REG_COMB_BK05_36_L      _PK_L_(0x05, 0x36)
#define REG_COMB_BK05_36_H      _PK_H_(0x05, 0x36)
#define REG_COMB_BK05_37_L      _PK_L_(0x05, 0x37)
#define REG_COMB_BK05_37_H      _PK_H_(0x05, 0x37)
#define REG_COMB_BK05_38_L      _PK_L_(0x05, 0x38)
#define REG_COMB_BK05_38_H      _PK_H_(0x05, 0x38)
#define REG_COMB_BK05_39_L      _PK_L_(0x05, 0x39)
#define REG_COMB_BK05_39_H      _PK_H_(0x05, 0x39)
#define REG_COMB_BK05_3A_L      _PK_L_(0x05, 0x3A)
#define REG_COMB_BK05_3A_H      _PK_H_(0x05, 0x3A)
#define REG_COMB_BK05_3B_L      _PK_L_(0x05, 0x3B)
#define REG_COMB_BK05_3B_H      _PK_H_(0x05, 0x3B)
#define REG_COMB_BK05_3C_L      _PK_L_(0x05, 0x3C)
#define REG_COMB_BK05_3C_H      _PK_H_(0x05, 0x3C)
#define REG_COMB_BK05_3D_L      _PK_L_(0x05, 0x3D)
#define REG_COMB_BK05_3D_H      _PK_H_(0x05, 0x3D)
#define REG_COMB_BK05_3E_L      _PK_L_(0x05, 0x3E)
#define REG_COMB_BK05_3E_H      _PK_H_(0x05, 0x3E)
#define REG_COMB_BK05_3F_L      _PK_L_(0x05, 0x3F)
#define REG_COMB_BK05_3F_H      _PK_H_(0x05, 0x3F)
#define REG_COMB_BK05_40_L      _PK_L_(0x05, 0x40)
#define REG_COMB_BK05_40_H      _PK_H_(0x05, 0x40)
#define REG_COMB_BK05_41_L      _PK_L_(0x05, 0x41)
#define REG_COMB_BK05_41_H      _PK_H_(0x05, 0x41)
#define REG_COMB_BK05_42_L      _PK_L_(0x05, 0x42)
#define REG_COMB_BK05_42_H      _PK_H_(0x05, 0x42)
#define REG_COMB_BK05_43_L      _PK_L_(0x05, 0x43)
#define REG_COMB_BK05_43_H      _PK_H_(0x05, 0x43)
#define REG_COMB_BK05_44_L      _PK_L_(0x05, 0x44)
#define REG_COMB_BK05_44_H      _PK_H_(0x05, 0x44)
#define REG_COMB_BK05_45_L      _PK_L_(0x05, 0x45)
#define REG_COMB_BK05_45_H      _PK_H_(0x05, 0x45)
#define REG_COMB_BK05_46_L      _PK_L_(0x05, 0x46)
#define REG_COMB_BK05_46_H      _PK_H_(0x05, 0x46)
#define REG_COMB_BK05_47_L      _PK_L_(0x05, 0x47)
#define REG_COMB_BK05_47_H      _PK_H_(0x05, 0x47)
#define REG_COMB_BK05_48_L      _PK_L_(0x05, 0x48)
#define REG_COMB_BK05_48_H      _PK_H_(0x05, 0x48)
#define REG_COMB_BK05_49_L      _PK_L_(0x05, 0x49)
#define REG_COMB_BK05_49_H      _PK_H_(0x05, 0x49)
#define REG_COMB_BK05_4A_L      _PK_L_(0x05, 0x4A)
#define REG_COMB_BK05_4A_H      _PK_H_(0x05, 0x4A)
#define REG_COMB_BK05_4B_L      _PK_L_(0x05, 0x4B)
#define REG_COMB_BK05_4B_H      _PK_H_(0x05, 0x4B)
#define REG_COMB_BK05_4C_L      _PK_L_(0x05, 0x4C)
#define REG_COMB_BK05_4C_H      _PK_H_(0x05, 0x4C)
#define REG_COMB_BK05_4D_L      _PK_L_(0x05, 0x4D)
#define REG_COMB_BK05_4D_H      _PK_H_(0x05, 0x4D)
#define REG_COMB_BK05_4E_L      _PK_L_(0x05, 0x4E)
#define REG_COMB_BK05_4E_H      _PK_H_(0x05, 0x4E)
#define REG_COMB_BK05_4F_L      _PK_L_(0x05, 0x4F)
#define REG_COMB_BK05_4F_H      _PK_H_(0x05, 0x4F)
#define REG_COMB_BK05_50_L      _PK_L_(0x05, 0x50)
#define REG_COMB_BK05_50_H      _PK_H_(0x05, 0x50)
#define REG_COMB_BK05_51_L      _PK_L_(0x05, 0x51)
#define REG_COMB_BK05_51_H      _PK_H_(0x05, 0x51)
#define REG_COMB_BK05_52_L      _PK_L_(0x05, 0x52)
#define REG_COMB_BK05_52_H      _PK_H_(0x05, 0x52)
#define REG_COMB_BK05_53_L      _PK_L_(0x05, 0x53)
#define REG_COMB_BK05_53_H      _PK_H_(0x05, 0x53)
#define REG_COMB_BK05_54_L      _PK_L_(0x05, 0x54)
#define REG_COMB_BK05_54_H      _PK_H_(0x05, 0x54)
#define REG_COMB_BK05_55_L      _PK_L_(0x05, 0x55)
#define REG_COMB_BK05_55_H      _PK_H_(0x05, 0x55)
#define REG_COMB_BK05_56_L      _PK_L_(0x05, 0x56)
#define REG_COMB_BK05_56_H      _PK_H_(0x05, 0x56)
#define REG_COMB_BK05_57_L      _PK_L_(0x05, 0x57)
#define REG_COMB_BK05_57_H      _PK_H_(0x05, 0x57)
#define REG_COMB_BK05_58_L      _PK_L_(0x05, 0x58)
#define REG_COMB_BK05_58_H      _PK_H_(0x05, 0x58)
#define REG_COMB_BK05_59_L      _PK_L_(0x05, 0x59)
#define REG_COMB_BK05_59_H      _PK_H_(0x05, 0x59)
#define REG_COMB_BK05_5A_L      _PK_L_(0x05, 0x5A)
#define REG_COMB_BK05_5A_H      _PK_H_(0x05, 0x5A)
#define REG_COMB_BK05_5B_L      _PK_L_(0x05, 0x5B)
#define REG_COMB_BK05_5B_H      _PK_H_(0x05, 0x5B)
#define REG_COMB_BK05_5C_L      _PK_L_(0x05, 0x5C)
#define REG_COMB_BK05_5C_H      _PK_H_(0x05, 0x5C)
#define REG_COMB_BK05_5D_L      _PK_L_(0x05, 0x5D)
#define REG_COMB_BK05_5D_H      _PK_H_(0x05, 0x5D)
#define REG_COMB_BK05_5E_L      _PK_L_(0x05, 0x5E)
#define REG_COMB_BK05_5E_H      _PK_H_(0x05, 0x5E)
#define REG_COMB_BK05_5F_L      _PK_L_(0x05, 0x5F)
#define REG_COMB_BK05_5F_H      _PK_H_(0x05, 0x5F)
#define REG_COMB_BK05_60_L      _PK_L_(0x05, 0x60)
#define REG_COMB_BK05_60_H      _PK_H_(0x05, 0x60)
#define REG_COMB_BK05_61_L      _PK_L_(0x05, 0x61)
#define REG_COMB_BK05_61_H      _PK_H_(0x05, 0x61)
#define REG_COMB_BK05_62_L      _PK_L_(0x05, 0x62)
#define REG_COMB_BK05_62_H      _PK_H_(0x05, 0x62)
#define REG_COMB_BK05_63_L      _PK_L_(0x05, 0x63)
#define REG_COMB_BK05_63_H      _PK_H_(0x05, 0x63)
#define REG_COMB_BK05_64_L      _PK_L_(0x05, 0x64)
#define REG_COMB_BK05_64_H      _PK_H_(0x05, 0x64)
#define REG_COMB_BK05_65_L      _PK_L_(0x05, 0x65)
#define REG_COMB_BK05_65_H      _PK_H_(0x05, 0x65)
#define REG_COMB_BK05_66_L      _PK_L_(0x05, 0x66)
#define REG_COMB_BK05_66_H      _PK_H_(0x05, 0x66)
#define REG_COMB_BK05_67_L      _PK_L_(0x05, 0x67)
#define REG_COMB_BK05_67_H      _PK_H_(0x05, 0x67)
#define REG_COMB_BK05_68_L      _PK_L_(0x05, 0x68)
#define REG_COMB_BK05_68_H      _PK_H_(0x05, 0x68)
#define REG_COMB_BK05_69_L      _PK_L_(0x05, 0x69)
#define REG_COMB_BK05_69_H      _PK_H_(0x05, 0x69)
#define REG_COMB_BK05_6A_L      _PK_L_(0x05, 0x6A)
#define REG_COMB_BK05_6A_H      _PK_H_(0x05, 0x6A)
#define REG_COMB_BK05_6B_L      _PK_L_(0x05, 0x6B)
#define REG_COMB_BK05_6B_H      _PK_H_(0x05, 0x6B)
#define REG_COMB_BK05_6C_L      _PK_L_(0x05, 0x6C)
#define REG_COMB_BK05_6C_H      _PK_H_(0x05, 0x6C)
#define REG_COMB_BK05_6D_L      _PK_L_(0x05, 0x6D)
#define REG_COMB_BK05_6D_H      _PK_H_(0x05, 0x6D)
#define REG_COMB_BK05_6E_L      _PK_L_(0x05, 0x6E)
#define REG_COMB_BK05_6E_H      _PK_H_(0x05, 0x6E)
#define REG_COMB_BK05_6F_L      _PK_L_(0x05, 0x6F)
#define REG_COMB_BK05_6F_H      _PK_H_(0x05, 0x6F)
#define REG_COMB_BK05_70_L      _PK_L_(0x05, 0x70)
#define REG_COMB_BK05_70_H      _PK_H_(0x05, 0x70)
#define REG_COMB_BK05_71_L      _PK_L_(0x05, 0x71)
#define REG_COMB_BK05_71_H      _PK_H_(0x05, 0x71)
#define REG_COMB_BK05_72_L      _PK_L_(0x05, 0x72)
#define REG_COMB_BK05_72_H      _PK_H_(0x05, 0x72)
#define REG_COMB_BK05_73_L      _PK_L_(0x05, 0x73)
#define REG_COMB_BK05_73_H      _PK_H_(0x05, 0x73)
#define REG_COMB_BK05_74_L      _PK_L_(0x05, 0x74)
#define REG_COMB_BK05_74_H      _PK_H_(0x05, 0x74)
#define REG_COMB_BK05_75_L      _PK_L_(0x05, 0x75)
#define REG_COMB_BK05_75_H      _PK_H_(0x05, 0x75)
#define REG_COMB_BK05_76_L      _PK_L_(0x05, 0x76)
#define REG_COMB_BK05_76_H      _PK_H_(0x05, 0x76)
#define REG_COMB_BK05_77_L      _PK_L_(0x05, 0x77)
#define REG_COMB_BK05_77_H      _PK_H_(0x05, 0x77)
#define REG_COMB_BK05_78_L      _PK_L_(0x05, 0x78)
#define REG_COMB_BK05_78_H      _PK_H_(0x05, 0x78)
#define REG_COMB_BK05_79_L      _PK_L_(0x05, 0x79)
#define REG_COMB_BK05_79_H      _PK_H_(0x05, 0x79)
#define REG_COMB_BK05_7A_L      _PK_L_(0x05, 0x7A)
#define REG_COMB_BK05_7A_H      _PK_H_(0x05, 0x7A)
#define REG_COMB_BK05_7B_L      _PK_L_(0x05, 0x7B)
#define REG_COMB_BK05_7B_H      _PK_H_(0x05, 0x7B)
#define REG_COMB_BK05_7C_L      _PK_L_(0x05, 0x7C)
#define REG_COMB_BK05_7C_H      _PK_H_(0x05, 0x7C)
#define REG_COMB_BK05_7D_L      _PK_L_(0x05, 0x7D)
#define REG_COMB_BK05_7D_H      _PK_H_(0x05, 0x7D)
#define REG_COMB_BK05_7E_L      _PK_L_(0x05, 0x7E)
#define REG_COMB_BK05_7E_H      _PK_H_(0x05, 0x7E)
#define REG_COMB_BK05_7F_L      _PK_L_(0x05, 0x7F)
#define REG_COMB_BK05_7F_H      _PK_H_(0x05, 0x7F)
//----------------------------------------------
#define REG_BK38_00_L      0x3800
#define REG_BK38_00_H      0x3801
#define REG_BK38_01_L      0x3802
#define REG_BK38_01_H      0x3803
#define REG_BK38_02_L      0x3804
#define REG_BK38_02_H      0x3805
#define REG_BK38_03_L      0x3806
#define REG_BK38_03_H      0x3807
#define REG_BK38_04_L      0x3808
#define REG_BK38_04_H      0x3809
#define REG_BK38_05_L      0x380A
#define REG_BK38_05_H      0x380B
#define REG_BK38_06_L      0x380C
#define REG_BK38_06_H      0x380D
#define REG_BK38_07_L      0x380E
#define REG_BK38_07_H      0x380F
#define REG_BK38_08_L      0x3810
#define REG_BK38_08_H      0x3811
#define REG_BK38_09_L      0x3812
#define REG_BK38_09_H      0x3813
#define REG_BK38_0A_L      0x3814
#define REG_BK38_0A_H      0x3815
#define REG_BK38_0B_L      0x3816
#define REG_BK38_0B_H      0x3817
#define REG_BK38_0C_L      0x3818
#define REG_BK38_0C_H      0x3819
#define REG_BK38_0D_L      0x381A
#define REG_BK38_0D_H      0x381B
#define REG_BK38_0E_L      0x381C
#define REG_BK38_0E_H      0x381D
#define REG_BK38_0F_L      0x381E
#define REG_BK38_0F_H      0x381F
#define REG_BK38_10_L      0x3820
#define REG_BK38_10_H      0x3821
#define REG_BK38_11_L      0x3822
#define REG_BK38_11_H      0x3823
#define REG_BK38_12_L      0x3824
#define REG_BK38_12_H      0x3825
#define REG_BK38_13_L      0x3826
#define REG_BK38_13_H      0x3827
#define REG_BK38_14_L      0x3828
#define REG_BK38_14_H      0x3829
#define REG_BK38_15_L      0x382A
#define REG_BK38_15_H      0x382B
#define REG_BK38_16_L      0x382C
#define REG_BK38_16_H      0x382D
#define REG_BK38_17_L      0x382E
#define REG_BK38_17_H      0x382F
#define REG_BK38_18_L      0x3830
#define REG_BK38_18_H      0x3831
#define REG_BK38_19_L      0x3832
#define REG_BK38_19_H      0x3833
#define REG_BK38_1A_L      0x3834
#define REG_BK38_1A_H      0x3835
#define REG_BK38_1B_L      0x3836
#define REG_BK38_1B_H      0x3837
#define REG_BK38_1C_L      0x3838
#define REG_BK38_1C_H      0x3839
#define REG_BK38_1D_L      0x383A
#define REG_BK38_1D_H      0x383B
#define REG_BK38_1E_L      0x383C
#define REG_BK38_1E_H      0x383D
#define REG_BK38_1F_L      0x383E
#define REG_BK38_1F_H      0x383F
#define REG_BK38_20_L      0x3840
#define REG_BK38_20_H      0x3841
#define REG_BK38_21_L      0x3842
#define REG_BK38_21_H      0x3843
#define REG_BK38_22_L      0x3844
#define REG_BK38_22_H      0x3845
#define REG_BK38_23_L      0x3846
#define REG_BK38_23_H      0x3847
#define REG_BK38_24_L      0x3848
#define REG_BK38_24_H      0x3849
#define REG_BK38_25_L      0x384A
#define REG_BK38_25_H      0x384B
#define REG_BK38_26_L      0x384C
#define REG_BK38_26_H      0x384D
#define REG_BK38_27_L      0x384E
#define REG_BK38_27_H      0x384F
#define REG_BK38_28_L      0x3850
#define REG_BK38_28_H      0x3851
#define REG_BK38_29_L      0x3852
#define REG_BK38_29_H      0x3853
#define REG_BK38_2A_L      0x3854
#define REG_BK38_2A_H      0x3855
#define REG_BK38_2B_L      0x3856
#define REG_BK38_2B_H      0x3857
#define REG_BK38_2C_L      0x3858
#define REG_BK38_2C_H      0x3859
#define REG_BK38_2D_L      0x385A
#define REG_BK38_2D_H      0x385B
#define REG_BK38_2E_L      0x385C
#define REG_BK38_2E_H      0x385D
#define REG_BK38_2F_L      0x385E
#define REG_BK38_2F_H      0x385F
#define REG_BK38_30_L      0x3860
#define REG_BK38_30_H      0x3861
#define REG_BK38_31_L      0x3862
#define REG_BK38_31_H      0x3863
#define REG_BK38_32_L      0x3864
#define REG_BK38_32_H      0x3865
#define REG_BK38_33_L      0x3866
#define REG_BK38_33_H      0x3867
#define REG_BK38_34_L      0x3868
#define REG_BK38_34_H      0x3869
#define REG_BK38_35_L      0x386A
#define REG_BK38_35_H      0x386B
#define REG_BK38_36_L      0x386C
#define REG_BK38_36_H      0x386D
#define REG_BK38_37_L      0x386E
#define REG_BK38_37_H      0x386F
#define REG_BK38_38_L      0x3870
#define REG_BK38_38_H      0x3871
#define REG_BK38_39_L      0x3872
#define REG_BK38_39_H      0x3873
#define REG_BK38_3A_L      0x3874
#define REG_BK38_3A_H      0x3875
#define REG_BK38_3B_L      0x3876
#define REG_BK38_3B_H      0x3877
#define REG_BK38_3C_L      0x3878
#define REG_BK38_3C_H      0x3879
#define REG_BK38_3D_L      0x387A
#define REG_BK38_3D_H      0x387B
#define REG_BK38_3E_L      0x387C
#define REG_BK38_3E_H      0x387D
#define REG_BK38_3F_L      0x387E
#define REG_BK38_3F_H      0x387F
#define REG_BK38_40_L      0x3880
#define REG_BK38_40_H      0x3881
#define REG_BK38_41_L      0x3882
#define REG_BK38_41_H      0x3883
#define REG_BK38_42_L      0x3884
#define REG_BK38_42_H      0x3885
#define REG_BK38_43_L      0x3886
#define REG_BK38_43_H      0x3887
#define REG_BK38_44_L      0x3888
#define REG_BK38_44_H      0x3889
#define REG_BK38_45_L      0x388A
#define REG_BK38_45_H      0x388B
#define REG_BK38_46_L      0x388C
#define REG_BK38_46_H      0x388D
#define REG_BK38_47_L      0x388E
#define REG_BK38_47_H      0x388F
#define REG_BK38_48_L      0x3890
#define REG_BK38_48_H      0x3891
#define REG_BK38_49_L      0x3892
#define REG_BK38_49_H      0x3893
#define REG_BK38_4A_L      0x3894
#define REG_BK38_4A_H      0x3895
#define REG_BK38_4B_L      0x3896
#define REG_BK38_4B_H      0x3897
#define REG_BK38_4C_L      0x3898
#define REG_BK38_4C_H      0x3899
#define REG_BK38_4D_L      0x389A
#define REG_BK38_4D_H      0x389B
#define REG_BK38_4E_L      0x389C
#define REG_BK38_4E_H      0x389D
#define REG_BK38_4F_L      0x389E
#define REG_BK38_4F_H      0x389F
#define REG_BK38_50_L      0x38A0
#define REG_BK38_50_H      0x38A1
#define REG_BK38_51_L      0x38A2
#define REG_BK38_51_H      0x38A3
#define REG_BK38_52_L      0x38A4
#define REG_BK38_52_H      0x38A5
#define REG_BK38_53_L      0x38A6
#define REG_BK38_53_H      0x38A7
#define REG_BK38_54_L      0x38A8
#define REG_BK38_54_H      0x38A9
#define REG_BK38_55_L      0x38AA
#define REG_BK38_55_H      0x38AB
#define REG_BK38_56_L      0x38AC
#define REG_BK38_56_H      0x38AD
#define REG_BK38_57_L      0x38AE
#define REG_BK38_57_H      0x38AF
#define REG_BK38_58_L      0x38B0
#define REG_BK38_58_H      0x38B1
#define REG_BK38_59_L      0x38B2
#define REG_BK38_59_H      0x38B3
#define REG_BK38_5A_L      0x38B4
#define REG_BK38_5A_H      0x38B5
#define REG_BK38_5B_L      0x38B6
#define REG_BK38_5B_H      0x38B7
#define REG_BK38_5C_L      0x38B8
#define REG_BK38_5C_H      0x38B9
#define REG_BK38_5D_L      0x38BA
#define REG_BK38_5D_H      0x38BB
#define REG_BK38_5E_L      0x38BC
#define REG_BK38_5E_H      0x38BD
#define REG_BK38_5F_L      0x38BE
#define REG_BK38_5F_H      0x38BF
#define REG_BK38_60_L      0x38C0
#define REG_BK38_60_H      0x38C1
#define REG_BK38_61_L      0x38C2
#define REG_BK38_61_H      0x38C3
#define REG_BK38_62_L      0x38C4
#define REG_BK38_62_H      0x38C5
#define REG_BK38_63_L      0x38C6
#define REG_BK38_63_H      0x38C7
#define REG_BK38_64_L      0x38C8
#define REG_BK38_64_H      0x38C9
#define REG_BK38_65_L      0x38CA
#define REG_BK38_65_H      0x38CB
#define REG_BK38_66_L      0x38CC
#define REG_BK38_66_H      0x38CD
#define REG_BK38_67_L      0x38CE
#define REG_BK38_67_H      0x38CF
#define REG_BK38_68_L      0x38D0
#define REG_BK38_68_H      0x38D1
#define REG_BK38_69_L      0x38D2
#define REG_BK38_69_H      0x38D3
#define REG_BK38_6A_L      0x38D4
#define REG_BK38_6A_H      0x38D5
#define REG_BK38_6B_L      0x38D6
#define REG_BK38_6B_H      0x38D7
#define REG_BK38_6C_L      0x38D8
#define REG_BK38_6C_H      0x38D9
#define REG_BK38_6D_L      0x38DA
#define REG_BK38_6D_H      0x38DB
#define REG_BK38_6E_L      0x38DC
#define REG_BK38_6E_H      0x38DD
#define REG_BK38_6F_L      0x38DE
#define REG_BK38_6F_H      0x38DF
#define REG_BK38_70_L      0x38E0
#define REG_BK38_70_H      0x38E1
#define REG_BK38_71_L      0x38E2
#define REG_BK38_71_H      0x38E3
#define REG_BK38_72_L      0x38E4
#define REG_BK38_72_H      0x38E5
#define REG_BK38_73_L      0x38E6
#define REG_BK38_73_H      0x38E7
#define REG_BK38_74_L      0x38E8
#define REG_BK38_74_H      0x38E9
#define REG_BK38_75_L      0x38EA
#define REG_BK38_75_H      0x38EB
#define REG_BK38_76_L      0x38EC
#define REG_BK38_76_H      0x38ED
#define REG_BK38_77_L      0x38EE
#define REG_BK38_77_H      0x38EF
#define REG_BK38_78_L      0x38F0
#define REG_BK38_78_H      0x38F1
#define REG_BK38_79_L      0x38F2
#define REG_BK38_79_H      0x38F3
#define REG_BK38_7A_L      0x38F4
#define REG_BK38_7A_H      0x38F5
#define REG_BK38_7B_L      0x38F6
#define REG_BK38_7B_H      0x38F7
#define REG_BK38_7C_L      0x38F8
#define REG_BK38_7C_H      0x38F9
#define REG_BK38_7D_L      0x38FA
#define REG_BK38_7D_H      0x38FB
#define REG_BK38_7E_L      0x38FC
#define REG_BK38_7E_H      0x38FD
#define REG_BK38_7F_L      0x38FE
#define REG_BK38_7F_H      0x38FF
//----------------------------------------------
#define REG_FSC_BK00_00_L      0x140000
#define REG_FSC_BK00_00_H      0x140001
#define REG_FSC_BK00_01_L      0x140002
#define REG_FSC_BK00_01_H      0x140003
#define REG_FSC_BK00_02_L      0x140004
#define REG_FSC_BK00_02_H      0x140005
#define REG_FSC_BK00_03_L      0x140006
#define REG_FSC_BK00_03_H      0x140007
#define REG_FSC_BK00_04_L      0x140008
#define REG_FSC_BK00_04_H      0x140009
#define REG_FSC_BK00_05_L      0x14000A
#define REG_FSC_BK00_05_H      0x14000B
#define REG_FSC_BK00_06_L      0x14000C
#define REG_FSC_BK00_06_H      0x14000D
#define REG_FSC_BK00_07_L      0x14000E
#define REG_FSC_BK00_07_H      0x14000F
#define REG_FSC_BK00_08_L      0x140010
#define REG_FSC_BK00_08_H      0x140011
#define REG_FSC_BK00_09_L      0x140012
#define REG_FSC_BK00_09_H      0x140013
#define REG_FSC_BK00_0A_L      0x140014
#define REG_FSC_BK00_0A_H      0x140015
#define REG_FSC_BK00_0B_L      0x140016
#define REG_FSC_BK00_0B_H      0x140017
#define REG_FSC_BK00_0C_L      0x140018
#define REG_FSC_BK00_0C_H      0x140019
#define REG_FSC_BK00_0D_L      0x14001A
#define REG_FSC_BK00_0D_H      0x14001B
#define REG_FSC_BK00_0E_L      0x14001C
#define REG_FSC_BK00_0E_H      0x14001D
#define REG_FSC_BK00_0F_L      0x14001E
#define REG_FSC_BK00_0F_H      0x14001F
#define REG_FSC_BK00_10_L      0x140020
#define REG_FSC_BK00_10_H      0x140021
#define REG_FSC_BK00_11_L      0x140022
#define REG_FSC_BK00_11_H      0x140023
#define REG_FSC_BK00_12_L      0x140024
#define REG_FSC_BK00_12_H      0x140025
#define REG_FSC_BK00_13_L      0x140026
#define REG_FSC_BK00_13_H      0x140027
#define REG_FSC_BK00_14_L      0x140028
#define REG_FSC_BK00_14_H      0x140029
#define REG_FSC_BK00_15_L      0x14002A
#define REG_FSC_BK00_15_H      0x14002B
#define REG_FSC_BK00_16_L      0x14002C
#define REG_FSC_BK00_16_H      0x14002D
#define REG_FSC_BK00_17_L      0x14002E
#define REG_FSC_BK00_17_H      0x14002F
#define REG_FSC_BK00_18_L      0x140030
#define REG_FSC_BK00_18_H      0x140031
#define REG_FSC_BK00_19_L      0x140032
#define REG_FSC_BK00_19_H      0x140033
#define REG_FSC_BK00_1A_L      0x140034
#define REG_FSC_BK00_1A_H      0x140035
#define REG_FSC_BK00_1B_L      0x140036
#define REG_FSC_BK00_1B_H      0x140037
#define REG_FSC_BK00_1C_L      0x140038
#define REG_FSC_BK00_1C_H      0x140039
#define REG_FSC_BK00_1D_L      0x14003A
#define REG_FSC_BK00_1D_H      0x14003B
#define REG_FSC_BK00_1E_L      0x14003C
#define REG_FSC_BK00_1E_H      0x14003D
#define REG_FSC_BK00_1F_L      0x14003E
#define REG_FSC_BK00_1F_H      0x14003F
#define REG_FSC_BK00_20_L      0x140040
#define REG_FSC_BK00_20_H      0x140041
#define REG_FSC_BK00_21_L      0x140042
#define REG_FSC_BK00_21_H      0x140043
#define REG_FSC_BK00_22_L      0x140044
#define REG_FSC_BK00_22_H      0x140045
#define REG_FSC_BK00_23_L      0x140046
#define REG_FSC_BK00_23_H      0x140047
#define REG_FSC_BK00_24_L      0x140048
#define REG_FSC_BK00_24_H      0x140049
#define REG_FSC_BK00_25_L      0x14004A
#define REG_FSC_BK00_25_H      0x14004B
#define REG_FSC_BK00_26_L      0x14004C
#define REG_FSC_BK00_26_H      0x14004D
#define REG_FSC_BK00_27_L      0x14004E
#define REG_FSC_BK00_27_H      0x14004F
#define REG_FSC_BK00_28_L      0x140050
#define REG_FSC_BK00_28_H      0x140051
#define REG_FSC_BK00_29_L      0x140052
#define REG_FSC_BK00_29_H      0x140053
#define REG_FSC_BK00_2A_L      0x140054
#define REG_FSC_BK00_2A_H      0x140055
#define REG_FSC_BK00_2B_L      0x140056
#define REG_FSC_BK00_2B_H      0x140057
#define REG_FSC_BK00_2C_L      0x140058
#define REG_FSC_BK00_2C_H      0x140059
#define REG_FSC_BK00_2D_L      0x14005A
#define REG_FSC_BK00_2D_H      0x14005B
#define REG_FSC_BK00_2E_L      0x14005C
#define REG_FSC_BK00_2E_H      0x14005D
#define REG_FSC_BK00_2F_L      0x14005E
#define REG_FSC_BK00_2F_H      0x14005F
#define REG_FSC_BK00_30_L      0x140060
#define REG_FSC_BK00_30_H      0x140061
#define REG_FSC_BK00_31_L      0x140062
#define REG_FSC_BK00_31_H      0x140063
#define REG_FSC_BK00_32_L      0x140064
#define REG_FSC_BK00_32_H      0x140065
#define REG_FSC_BK00_33_L      0x140066
#define REG_FSC_BK00_33_H      0x140067
#define REG_FSC_BK00_34_L      0x140068
#define REG_FSC_BK00_34_H      0x140069
#define REG_FSC_BK00_35_L      0x14006A
#define REG_FSC_BK00_35_H      0x14006B
#define REG_FSC_BK00_36_L      0x14006C
#define REG_FSC_BK00_36_H      0x14006D
#define REG_FSC_BK00_37_L      0x14006E
#define REG_FSC_BK00_37_H      0x14006F
#define REG_FSC_BK00_38_L      0x140070
#define REG_FSC_BK00_38_H      0x140071
#define REG_FSC_BK00_39_L      0x140072
#define REG_FSC_BK00_39_H      0x140073
#define REG_FSC_BK00_3A_L      0x140074
#define REG_FSC_BK00_3A_H      0x140075
#define REG_FSC_BK00_3B_L      0x140076
#define REG_FSC_BK00_3B_H      0x140077
#define REG_FSC_BK00_3C_L      0x140078
#define REG_FSC_BK00_3C_H      0x140079
#define REG_FSC_BK00_3D_L      0x14007A
#define REG_FSC_BK00_3D_H      0x14007B
#define REG_FSC_BK00_3E_L      0x14007C
#define REG_FSC_BK00_3E_H      0x14007D
#define REG_FSC_BK00_3F_L      0x14007E
#define REG_FSC_BK00_3F_H      0x14007F
#define REG_FSC_BK00_40_L      0x140080
#define REG_FSC_BK00_40_H      0x140081
#define REG_FSC_BK00_41_L      0x140082
#define REG_FSC_BK00_41_H      0x140083
#define REG_FSC_BK00_42_L      0x140084
#define REG_FSC_BK00_42_H      0x140085
#define REG_FSC_BK00_43_L      0x140086
#define REG_FSC_BK00_43_H      0x140087
#define REG_FSC_BK00_44_L      0x140088
#define REG_FSC_BK00_44_H      0x140089
#define REG_FSC_BK00_45_L      0x14008A
#define REG_FSC_BK00_45_H      0x14008B
#define REG_FSC_BK00_46_L      0x14008C
#define REG_FSC_BK00_46_H      0x14008D
#define REG_FSC_BK00_47_L      0x14008E
#define REG_FSC_BK00_47_H      0x14008F
#define REG_FSC_BK00_48_L      0x140090
#define REG_FSC_BK00_48_H      0x140091
#define REG_FSC_BK00_49_L      0x140092
#define REG_FSC_BK00_49_H      0x140093
#define REG_FSC_BK00_4A_L      0x140094
#define REG_FSC_BK00_4A_H      0x140095
#define REG_FSC_BK00_4B_L      0x140096
#define REG_FSC_BK00_4B_H      0x140097
#define REG_FSC_BK00_4C_L      0x140098
#define REG_FSC_BK00_4C_H      0x140099
#define REG_FSC_BK00_4D_L      0x14009A
#define REG_FSC_BK00_4D_H      0x14009B
#define REG_FSC_BK00_4E_L      0x14009C
#define REG_FSC_BK00_4E_H      0x14009D
#define REG_FSC_BK00_4F_L      0x14009E
#define REG_FSC_BK00_4F_H      0x14009F
#define REG_FSC_BK00_50_L      0x1400A0
#define REG_FSC_BK00_50_H      0x1400A1
#define REG_FSC_BK00_51_L      0x1400A2
#define REG_FSC_BK00_51_H      0x1400A3
#define REG_FSC_BK00_52_L      0x1400A4
#define REG_FSC_BK00_52_H      0x1400A5
#define REG_FSC_BK00_53_L      0x1400A6
#define REG_FSC_BK00_53_H      0x1400A7
#define REG_FSC_BK00_54_L      0x1400A8
#define REG_FSC_BK00_54_H      0x1400A9
#define REG_FSC_BK00_55_L      0x1400AA
#define REG_FSC_BK00_55_H      0x1400AB
#define REG_FSC_BK00_56_L      0x1400AC
#define REG_FSC_BK00_56_H      0x1400AD
#define REG_FSC_BK00_57_L      0x1400AE
#define REG_FSC_BK00_57_H      0x1400AF
#define REG_FSC_BK00_58_L      0x1400B0
#define REG_FSC_BK00_58_H      0x1400B1
#define REG_FSC_BK00_59_L      0x1400B2
#define REG_FSC_BK00_59_H      0x1400B3
#define REG_FSC_BK00_5A_L      0x1400B4
#define REG_FSC_BK00_5A_H      0x1400B5
#define REG_FSC_BK00_5B_L      0x1400B6
#define REG_FSC_BK00_5B_H      0x1400B7
#define REG_FSC_BK00_5C_L      0x1400B8
#define REG_FSC_BK00_5C_H      0x1400B9
#define REG_FSC_BK00_5D_L      0x1400BA
#define REG_FSC_BK00_5D_H      0x1400BB
#define REG_FSC_BK00_5E_L      0x1400BC
#define REG_FSC_BK00_5E_H      0x1400BD
#define REG_FSC_BK00_5F_L      0x1400BE
#define REG_FSC_BK00_5F_H      0x1400BF
#define REG_FSC_BK00_60_L      0x1400C0
#define REG_FSC_BK00_60_H      0x1400C1
#define REG_FSC_BK00_61_L      0x1400C2
#define REG_FSC_BK00_61_H      0x1400C3
#define REG_FSC_BK00_62_L      0x1400C4
#define REG_FSC_BK00_62_H      0x1400C5
#define REG_FSC_BK00_63_L      0x1400C6
#define REG_FSC_BK00_63_H      0x1400C7
#define REG_FSC_BK00_64_L      0x1400C8
#define REG_FSC_BK00_64_H      0x1400C9
#define REG_FSC_BK00_65_L      0x1400CA
#define REG_FSC_BK00_65_H      0x1400CB
#define REG_FSC_BK00_66_L      0x1400CC
#define REG_FSC_BK00_66_H      0x1400CD
#define REG_FSC_BK00_67_L      0x1400CE
#define REG_FSC_BK00_67_H      0x1400CF
#define REG_FSC_BK00_68_L      0x1400D0
#define REG_FSC_BK00_68_H      0x1400D1
#define REG_FSC_BK00_69_L      0x1400D2
#define REG_FSC_BK00_69_H      0x1400D3
#define REG_FSC_BK00_6A_L      0x1400D4
#define REG_FSC_BK00_6A_H      0x1400D5
#define REG_FSC_BK00_6B_L      0x1400D6
#define REG_FSC_BK00_6B_H      0x1400D7
#define REG_FSC_BK00_6C_L      0x1400D8
#define REG_FSC_BK00_6C_H      0x1400D9
#define REG_FSC_BK00_6D_L      0x1400DA
#define REG_FSC_BK00_6D_H      0x1400DB
#define REG_FSC_BK00_6E_L      0x1400DC
#define REG_FSC_BK00_6E_H      0x1400DD
#define REG_FSC_BK00_6F_L      0x1400DE
#define REG_FSC_BK00_6F_H      0x1400DF
#define REG_FSC_BK00_70_L      0x1400E0
#define REG_FSC_BK00_70_H      0x1400E1
#define REG_FSC_BK00_71_L      0x1400E2
#define REG_FSC_BK00_71_H      0x1400E3
#define REG_FSC_BK00_72_L      0x1400E4
#define REG_FSC_BK00_72_H      0x1400E5
#define REG_FSC_BK00_73_L      0x1400E6
#define REG_FSC_BK00_73_H      0x1400E7
#define REG_FSC_BK00_74_L      0x1400E8
#define REG_FSC_BK00_74_H      0x1400E9
#define REG_FSC_BK00_75_L      0x1400EA
#define REG_FSC_BK00_75_H      0x1400EB
#define REG_FSC_BK00_76_L      0x1400EC
#define REG_FSC_BK00_76_H      0x1400ED
#define REG_FSC_BK00_77_L      0x1400EE
#define REG_FSC_BK00_77_H      0x1400EF
#define REG_FSC_BK00_78_L      0x1400F0
#define REG_FSC_BK00_78_H      0x1400F1
#define REG_FSC_BK00_79_L      0x1400F2
#define REG_FSC_BK00_79_H      0x1400F3
#define REG_FSC_BK00_7A_L      0x1400F4
#define REG_FSC_BK00_7A_H      0x1400F5
#define REG_FSC_BK00_7B_L      0x1400F6
#define REG_FSC_BK00_7B_H      0x1400F7
#define REG_FSC_BK00_7C_L      0x1400F8
#define REG_FSC_BK00_7C_H      0x1400F9
#define REG_FSC_BK00_7D_L      0x1400FA
#define REG_FSC_BK00_7D_H      0x1400FB
#define REG_FSC_BK00_7E_L      0x1400FC
#define REG_FSC_BK00_7E_H      0x1400FD
#define REG_FSC_BK00_7F_L      0x1400FE
#define REG_FSC_BK00_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK19_00_L      0x140000
#define REG_FSC_BK19_00_H      0x140001
#define REG_FSC_BK19_01_L      0x140002
#define REG_FSC_BK19_01_H      0x140003
#define REG_FSC_BK19_02_L      0x140004
#define REG_FSC_BK19_02_H      0x140005
#define REG_FSC_BK19_03_L      0x140006
#define REG_FSC_BK19_03_H      0x140007
#define REG_FSC_BK19_04_L      0x140008
#define REG_FSC_BK19_04_H      0x140009
#define REG_FSC_BK19_05_L      0x14000A
#define REG_FSC_BK19_05_H      0x14000B
#define REG_FSC_BK19_06_L      0x14000C
#define REG_FSC_BK19_06_H      0x14000D
#define REG_FSC_BK19_07_L      0x14000E
#define REG_FSC_BK19_07_H      0x14000F
#define REG_FSC_BK19_08_L      0x140010
#define REG_FSC_BK19_08_H      0x140011
#define REG_FSC_BK19_09_L      0x140012
#define REG_FSC_BK19_09_H      0x140013
#define REG_FSC_BK19_0A_L      0x140014
#define REG_FSC_BK19_0A_H      0x140015
#define REG_FSC_BK19_0B_L      0x140016
#define REG_FSC_BK19_0B_H      0x140017
#define REG_FSC_BK19_0C_L      0x140018
#define REG_FSC_BK19_0C_H      0x140019
#define REG_FSC_BK19_0D_L      0x14001A
#define REG_FSC_BK19_0D_H      0x14001B
#define REG_FSC_BK19_0E_L      0x14001C
#define REG_FSC_BK19_0E_H      0x14001D
#define REG_FSC_BK19_0F_L      0x14001E
#define REG_FSC_BK19_0F_H      0x14001F
#define REG_FSC_BK19_10_L      0x140020
#define REG_FSC_BK19_10_H      0x140021
#define REG_FSC_BK19_11_L      0x140022
#define REG_FSC_BK19_11_H      0x140023
#define REG_FSC_BK19_12_L      0x140024
#define REG_FSC_BK19_12_H      0x140025
#define REG_FSC_BK19_13_L      0x140026
#define REG_FSC_BK19_13_H      0x140027
#define REG_FSC_BK19_14_L      0x140028
#define REG_FSC_BK19_14_H      0x140029
#define REG_FSC_BK19_15_L      0x14002A
#define REG_FSC_BK19_15_H      0x14002B
#define REG_FSC_BK19_16_L      0x14002C
#define REG_FSC_BK19_16_H      0x14002D
#define REG_FSC_BK19_17_L      0x14002E
#define REG_FSC_BK19_17_H      0x14002F
#define REG_FSC_BK19_18_L      0x140030
#define REG_FSC_BK19_18_H      0x140031
#define REG_FSC_BK19_19_L      0x140032
#define REG_FSC_BK19_19_H      0x140033
#define REG_FSC_BK19_1A_L      0x140034
#define REG_FSC_BK19_1A_H      0x140035
#define REG_FSC_BK19_1B_L      0x140036
#define REG_FSC_BK19_1B_H      0x140037
#define REG_FSC_BK19_1C_L      0x140038
#define REG_FSC_BK19_1C_H      0x140039
#define REG_FSC_BK19_1D_L      0x14003A
#define REG_FSC_BK19_1D_H      0x14003B
#define REG_FSC_BK19_1E_L      0x14003C
#define REG_FSC_BK19_1E_H      0x14003D
#define REG_FSC_BK19_1F_L      0x14003E
#define REG_FSC_BK19_1F_H      0x14003F
#define REG_FSC_BK19_20_L      0x140040
#define REG_FSC_BK19_20_H      0x140041
#define REG_FSC_BK19_21_L      0x140042
#define REG_FSC_BK19_21_H      0x140043
#define REG_FSC_BK19_22_L      0x140044
#define REG_FSC_BK19_22_H      0x140045
#define REG_FSC_BK19_23_L      0x140046
#define REG_FSC_BK19_23_H      0x140047
#define REG_FSC_BK19_24_L      0x140048
#define REG_FSC_BK19_24_H      0x140049
#define REG_FSC_BK19_25_L      0x14004A
#define REG_FSC_BK19_25_H      0x14004B
#define REG_FSC_BK19_26_L      0x14004C
#define REG_FSC_BK19_26_H      0x14004D
#define REG_FSC_BK19_27_L      0x14004E
#define REG_FSC_BK19_27_H      0x14004F
#define REG_FSC_BK19_28_L      0x140050
#define REG_FSC_BK19_28_H      0x140051
#define REG_FSC_BK19_29_L      0x140052
#define REG_FSC_BK19_29_H      0x140053
#define REG_FSC_BK19_2A_L      0x140054
#define REG_FSC_BK19_2A_H      0x140055
#define REG_FSC_BK19_2B_L      0x140056
#define REG_FSC_BK19_2B_H      0x140057
#define REG_FSC_BK19_2C_L      0x140058
#define REG_FSC_BK19_2C_H      0x140059
#define REG_FSC_BK19_2D_L      0x14005A
#define REG_FSC_BK19_2D_H      0x14005B
#define REG_FSC_BK19_2E_L      0x14005C
#define REG_FSC_BK19_2E_H      0x14005D
#define REG_FSC_BK19_2F_L      0x14005E
#define REG_FSC_BK19_2F_H      0x14005F
#define REG_FSC_BK19_30_L      0x140060
#define REG_FSC_BK19_30_H      0x140061
#define REG_FSC_BK19_31_L      0x140062
#define REG_FSC_BK19_31_H      0x140063
#define REG_FSC_BK19_32_L      0x140064
#define REG_FSC_BK19_32_H      0x140065
#define REG_FSC_BK19_33_L      0x140066
#define REG_FSC_BK19_33_H      0x140067
#define REG_FSC_BK19_34_L      0x140068
#define REG_FSC_BK19_34_H      0x140069
#define REG_FSC_BK19_35_L      0x14006A
#define REG_FSC_BK19_35_H      0x14006B
#define REG_FSC_BK19_36_L      0x14006C
#define REG_FSC_BK19_36_H      0x14006D
#define REG_FSC_BK19_37_L      0x14006E
#define REG_FSC_BK19_37_H      0x14006F
#define REG_FSC_BK19_38_L      0x140070
#define REG_FSC_BK19_38_H      0x140071
#define REG_FSC_BK19_39_L      0x140072
#define REG_FSC_BK19_39_H      0x140073
#define REG_FSC_BK19_3A_L      0x140074
#define REG_FSC_BK19_3A_H      0x140075
#define REG_FSC_BK19_3B_L      0x140076
#define REG_FSC_BK19_3B_H      0x140077
#define REG_FSC_BK19_3C_L      0x140078
#define REG_FSC_BK19_3C_H      0x140079
#define REG_FSC_BK19_3D_L      0x14007A
#define REG_FSC_BK19_3D_H      0x14007B
#define REG_FSC_BK19_3E_L      0x14007C
#define REG_FSC_BK19_3E_H      0x14007D
#define REG_FSC_BK19_3F_L      0x14007E
#define REG_FSC_BK19_3F_H      0x14007F
#define REG_FSC_BK19_40_L      0x140080
#define REG_FSC_BK19_40_H      0x140081
#define REG_FSC_BK19_41_L      0x140082
#define REG_FSC_BK19_41_H      0x140083
#define REG_FSC_BK19_42_L      0x140084
#define REG_FSC_BK19_42_H      0x140085
#define REG_FSC_BK19_43_L      0x140086
#define REG_FSC_BK19_43_H      0x140087
#define REG_FSC_BK19_44_L      0x140088
#define REG_FSC_BK19_44_H      0x140089
#define REG_FSC_BK19_45_L      0x14008A
#define REG_FSC_BK19_45_H      0x14008B
#define REG_FSC_BK19_46_L      0x14008C
#define REG_FSC_BK19_46_H      0x14008D
#define REG_FSC_BK19_47_L      0x14008E
#define REG_FSC_BK19_47_H      0x14008F
#define REG_FSC_BK19_48_L      0x140090
#define REG_FSC_BK19_48_H      0x140091
#define REG_FSC_BK19_49_L      0x140092
#define REG_FSC_BK19_49_H      0x140093
#define REG_FSC_BK19_4A_L      0x140094
#define REG_FSC_BK19_4A_H      0x140095
#define REG_FSC_BK19_4B_L      0x140096
#define REG_FSC_BK19_4B_H      0x140097
#define REG_FSC_BK19_4C_L      0x140098
#define REG_FSC_BK19_4C_H      0x140099
#define REG_FSC_BK19_4D_L      0x14009A
#define REG_FSC_BK19_4D_H      0x14009B
#define REG_FSC_BK19_4E_L      0x14009C
#define REG_FSC_BK19_4E_H      0x14009D
#define REG_FSC_BK19_4F_L      0x14009E
#define REG_FSC_BK19_4F_H      0x14009F
#define REG_FSC_BK19_50_L      0x1400A0
#define REG_FSC_BK19_50_H      0x1400A1
#define REG_FSC_BK19_51_L      0x1400A2
#define REG_FSC_BK19_51_H      0x1400A3
#define REG_FSC_BK19_52_L      0x1400A4
#define REG_FSC_BK19_52_H      0x1400A5
#define REG_FSC_BK19_53_L      0x1400A6
#define REG_FSC_BK19_53_H      0x1400A7
#define REG_FSC_BK19_54_L      0x1400A8
#define REG_FSC_BK19_54_H      0x1400A9
#define REG_FSC_BK19_55_L      0x1400AA
#define REG_FSC_BK19_55_H      0x1400AB
#define REG_FSC_BK19_56_L      0x1400AC
#define REG_FSC_BK19_56_H      0x1400AD
#define REG_FSC_BK19_57_L      0x1400AE
#define REG_FSC_BK19_57_H      0x1400AF
#define REG_FSC_BK19_58_L      0x1400B0
#define REG_FSC_BK19_58_H      0x1400B1
#define REG_FSC_BK19_59_L      0x1400B2
#define REG_FSC_BK19_59_H      0x1400B3
#define REG_FSC_BK19_5A_L      0x1400B4
#define REG_FSC_BK19_5A_H      0x1400B5
#define REG_FSC_BK19_5B_L      0x1400B6
#define REG_FSC_BK19_5B_H      0x1400B7
#define REG_FSC_BK19_5C_L      0x1400B8
#define REG_FSC_BK19_5C_H      0x1400B9
#define REG_FSC_BK19_5D_L      0x1400BA
#define REG_FSC_BK19_5D_H      0x1400BB
#define REG_FSC_BK19_5E_L      0x1400BC
#define REG_FSC_BK19_5E_H      0x1400BD
#define REG_FSC_BK19_5F_L      0x1400BE
#define REG_FSC_BK19_5F_H      0x1400BF
#define REG_FSC_BK19_60_L      0x1400C0
#define REG_FSC_BK19_60_H      0x1400C1
#define REG_FSC_BK19_61_L      0x1400C2
#define REG_FSC_BK19_61_H      0x1400C3
#define REG_FSC_BK19_62_L      0x1400C4
#define REG_FSC_BK19_62_H      0x1400C5
#define REG_FSC_BK19_63_L      0x1400C6
#define REG_FSC_BK19_63_H      0x1400C7
#define REG_FSC_BK19_64_L      0x1400C8
#define REG_FSC_BK19_64_H      0x1400C9
#define REG_FSC_BK19_65_L      0x1400CA
#define REG_FSC_BK19_65_H      0x1400CB
#define REG_FSC_BK19_66_L      0x1400CC
#define REG_FSC_BK19_66_H      0x1400CD
#define REG_FSC_BK19_67_L      0x1400CE
#define REG_FSC_BK19_67_H      0x1400CF
#define REG_FSC_BK19_68_L      0x1400D0
#define REG_FSC_BK19_68_H      0x1400D1
#define REG_FSC_BK19_69_L      0x1400D2
#define REG_FSC_BK19_69_H      0x1400D3
#define REG_FSC_BK19_6A_L      0x1400D4
#define REG_FSC_BK19_6A_H      0x1400D5
#define REG_FSC_BK19_6B_L      0x1400D6
#define REG_FSC_BK19_6B_H      0x1400D7
#define REG_FSC_BK19_6C_L      0x1400D8
#define REG_FSC_BK19_6C_H      0x1400D9
#define REG_FSC_BK19_6D_L      0x1400DA
#define REG_FSC_BK19_6D_H      0x1400DB
#define REG_FSC_BK19_6E_L      0x1400DC
#define REG_FSC_BK19_6E_H      0x1400DD
#define REG_FSC_BK19_6F_L      0x1400DE
#define REG_FSC_BK19_6F_H      0x1400DF
#define REG_FSC_BK19_70_L      0x1400E0
#define REG_FSC_BK19_70_H      0x1400E1
#define REG_FSC_BK19_71_L      0x1400E2
#define REG_FSC_BK19_71_H      0x1400E3
#define REG_FSC_BK19_72_L      0x1400E4
#define REG_FSC_BK19_72_H      0x1400E5
#define REG_FSC_BK19_73_L      0x1400E6
#define REG_FSC_BK19_73_H      0x1400E7
#define REG_FSC_BK19_74_L      0x1400E8
#define REG_FSC_BK19_74_H      0x1400E9
#define REG_FSC_BK19_75_L      0x1400EA
#define REG_FSC_BK19_75_H      0x1400EB
#define REG_FSC_BK19_76_L      0x1400EC
#define REG_FSC_BK19_76_H      0x1400ED
#define REG_FSC_BK19_77_L      0x1400EE
#define REG_FSC_BK19_77_H      0x1400EF
#define REG_FSC_BK19_78_L      0x1400F0
#define REG_FSC_BK19_78_H      0x1400F1
#define REG_FSC_BK19_79_L      0x1400F2
#define REG_FSC_BK19_79_H      0x1400F3
#define REG_FSC_BK19_7A_L      0x1400F4
#define REG_FSC_BK19_7A_H      0x1400F5
#define REG_FSC_BK19_7B_L      0x1400F6
#define REG_FSC_BK19_7B_H      0x1400F7
#define REG_FSC_BK19_7C_L      0x1400F8
#define REG_FSC_BK19_7C_H      0x1400F9
#define REG_FSC_BK19_7D_L      0x1400FA
#define REG_FSC_BK19_7D_H      0x1400FB
#define REG_FSC_BK19_7E_L      0x1400FC
#define REG_FSC_BK19_7E_H      0x1400FD
#define REG_FSC_BK19_7F_L      0x1400FE
#define REG_FSC_BK19_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK1A_00_L      0x140000
#define REG_FSC_BK1A_00_H      0x140001
#define REG_FSC_BK1A_01_L      0x140002
#define REG_FSC_BK1A_01_H      0x140003
#define REG_FSC_BK1A_02_L      0x140004
#define REG_FSC_BK1A_02_H      0x140005
#define REG_FSC_BK1A_03_L      0x140006
#define REG_FSC_BK1A_03_H      0x140007
#define REG_FSC_BK1A_04_L      0x140008
#define REG_FSC_BK1A_04_H      0x140009
#define REG_FSC_BK1A_05_L      0x14000A
#define REG_FSC_BK1A_05_H      0x14000B
#define REG_FSC_BK1A_06_L      0x14000C
#define REG_FSC_BK1A_06_H      0x14000D
#define REG_FSC_BK1A_07_L      0x14000E
#define REG_FSC_BK1A_07_H      0x14000F
#define REG_FSC_BK1A_08_L      0x140010
#define REG_FSC_BK1A_08_H      0x140011
#define REG_FSC_BK1A_09_L      0x140012
#define REG_FSC_BK1A_09_H      0x140013
#define REG_FSC_BK1A_0A_L      0x140014
#define REG_FSC_BK1A_0A_H      0x140015
#define REG_FSC_BK1A_0B_L      0x140016
#define REG_FSC_BK1A_0B_H      0x140017
#define REG_FSC_BK1A_0C_L      0x140018
#define REG_FSC_BK1A_0C_H      0x140019
#define REG_FSC_BK1A_0D_L      0x14001A
#define REG_FSC_BK1A_0D_H      0x14001B
#define REG_FSC_BK1A_0E_L      0x14001C
#define REG_FSC_BK1A_0E_H      0x14001D
#define REG_FSC_BK1A_0F_L      0x14001E
#define REG_FSC_BK1A_0F_H      0x14001F
#define REG_FSC_BK1A_10_L      0x140020
#define REG_FSC_BK1A_10_H      0x140021
#define REG_FSC_BK1A_11_L      0x140022
#define REG_FSC_BK1A_11_H      0x140023
#define REG_FSC_BK1A_12_L      0x140024
#define REG_FSC_BK1A_12_H      0x140025
#define REG_FSC_BK1A_13_L      0x140026
#define REG_FSC_BK1A_13_H      0x140027
#define REG_FSC_BK1A_14_L      0x140028
#define REG_FSC_BK1A_14_H      0x140029
#define REG_FSC_BK1A_15_L      0x14002A
#define REG_FSC_BK1A_15_H      0x14002B
#define REG_FSC_BK1A_16_L      0x14002C
#define REG_FSC_BK1A_16_H      0x14002D
#define REG_FSC_BK1A_17_L      0x14002E
#define REG_FSC_BK1A_17_H      0x14002F
#define REG_FSC_BK1A_18_L      0x140030
#define REG_FSC_BK1A_18_H      0x140031
#define REG_FSC_BK1A_19_L      0x140032
#define REG_FSC_BK1A_19_H      0x140033
#define REG_FSC_BK1A_1A_L      0x140034
#define REG_FSC_BK1A_1A_H      0x140035
#define REG_FSC_BK1A_1B_L      0x140036
#define REG_FSC_BK1A_1B_H      0x140037
#define REG_FSC_BK1A_1C_L      0x140038
#define REG_FSC_BK1A_1C_H      0x140039
#define REG_FSC_BK1A_1D_L      0x14003A
#define REG_FSC_BK1A_1D_H      0x14003B
#define REG_FSC_BK1A_1E_L      0x14003C
#define REG_FSC_BK1A_1E_H      0x14003D
#define REG_FSC_BK1A_1F_L      0x14003E
#define REG_FSC_BK1A_1F_H      0x14003F
#define REG_FSC_BK1A_20_L      0x140040
#define REG_FSC_BK1A_20_H      0x140041
#define REG_FSC_BK1A_21_L      0x140042
#define REG_FSC_BK1A_21_H      0x140043
#define REG_FSC_BK1A_22_L      0x140044
#define REG_FSC_BK1A_22_H      0x140045
#define REG_FSC_BK1A_23_L      0x140046
#define REG_FSC_BK1A_23_H      0x140047
#define REG_FSC_BK1A_24_L      0x140048
#define REG_FSC_BK1A_24_H      0x140049
#define REG_FSC_BK1A_25_L      0x14004A
#define REG_FSC_BK1A_25_H      0x14004B
#define REG_FSC_BK1A_26_L      0x14004C
#define REG_FSC_BK1A_26_H      0x14004D
#define REG_FSC_BK1A_27_L      0x14004E
#define REG_FSC_BK1A_27_H      0x14004F
#define REG_FSC_BK1A_28_L      0x140050
#define REG_FSC_BK1A_28_H      0x140051
#define REG_FSC_BK1A_29_L      0x140052
#define REG_FSC_BK1A_29_H      0x140053
#define REG_FSC_BK1A_2A_L      0x140054
#define REG_FSC_BK1A_2A_H      0x140055
#define REG_FSC_BK1A_2B_L      0x140056
#define REG_FSC_BK1A_2B_H      0x140057
#define REG_FSC_BK1A_2C_L      0x140058
#define REG_FSC_BK1A_2C_H      0x140059
#define REG_FSC_BK1A_2D_L      0x14005A
#define REG_FSC_BK1A_2D_H      0x14005B
#define REG_FSC_BK1A_2E_L      0x14005C
#define REG_FSC_BK1A_2E_H      0x14005D
#define REG_FSC_BK1A_2F_L      0x14005E
#define REG_FSC_BK1A_2F_H      0x14005F
#define REG_FSC_BK1A_30_L      0x140060
#define REG_FSC_BK1A_30_H      0x140061
#define REG_FSC_BK1A_31_L      0x140062
#define REG_FSC_BK1A_31_H      0x140063
#define REG_FSC_BK1A_32_L      0x140064
#define REG_FSC_BK1A_32_H      0x140065
#define REG_FSC_BK1A_33_L      0x140066
#define REG_FSC_BK1A_33_H      0x140067
#define REG_FSC_BK1A_34_L      0x140068
#define REG_FSC_BK1A_34_H      0x140069
#define REG_FSC_BK1A_35_L      0x14006A
#define REG_FSC_BK1A_35_H      0x14006B
#define REG_FSC_BK1A_36_L      0x14006C
#define REG_FSC_BK1A_36_H      0x14006D
#define REG_FSC_BK1A_37_L      0x14006E
#define REG_FSC_BK1A_37_H      0x14006F
#define REG_FSC_BK1A_38_L      0x140070
#define REG_FSC_BK1A_38_H      0x140071
#define REG_FSC_BK1A_39_L      0x140072
#define REG_FSC_BK1A_39_H      0x140073
#define REG_FSC_BK1A_3A_L      0x140074
#define REG_FSC_BK1A_3A_H      0x140075
#define REG_FSC_BK1A_3B_L      0x140076
#define REG_FSC_BK1A_3B_H      0x140077
#define REG_FSC_BK1A_3C_L      0x140078
#define REG_FSC_BK1A_3C_H      0x140079
#define REG_FSC_BK1A_3D_L      0x14007A
#define REG_FSC_BK1A_3D_H      0x14007B
#define REG_FSC_BK1A_3E_L      0x14007C
#define REG_FSC_BK1A_3E_H      0x14007D
#define REG_FSC_BK1A_3F_L      0x14007E
#define REG_FSC_BK1A_3F_H      0x14007F
#define REG_FSC_BK1A_40_L      0x140080
#define REG_FSC_BK1A_40_H      0x140081
#define REG_FSC_BK1A_41_L      0x140082
#define REG_FSC_BK1A_41_H      0x140083
#define REG_FSC_BK1A_42_L      0x140084
#define REG_FSC_BK1A_42_H      0x140085
#define REG_FSC_BK1A_43_L      0x140086
#define REG_FSC_BK1A_43_H      0x140087
#define REG_FSC_BK1A_44_L      0x140088
#define REG_FSC_BK1A_44_H      0x140089
#define REG_FSC_BK1A_45_L      0x14008A
#define REG_FSC_BK1A_45_H      0x14008B
#define REG_FSC_BK1A_46_L      0x14008C
#define REG_FSC_BK1A_46_H      0x14008D
#define REG_FSC_BK1A_47_L      0x14008E
#define REG_FSC_BK1A_47_H      0x14008F
#define REG_FSC_BK1A_48_L      0x140090
#define REG_FSC_BK1A_48_H      0x140091
#define REG_FSC_BK1A_49_L      0x140092
#define REG_FSC_BK1A_49_H      0x140093
#define REG_FSC_BK1A_4A_L      0x140094
#define REG_FSC_BK1A_4A_H      0x140095
#define REG_FSC_BK1A_4B_L      0x140096
#define REG_FSC_BK1A_4B_H      0x140097
#define REG_FSC_BK1A_4C_L      0x140098
#define REG_FSC_BK1A_4C_H      0x140099
#define REG_FSC_BK1A_4D_L      0x14009A
#define REG_FSC_BK1A_4D_H      0x14009B
#define REG_FSC_BK1A_4E_L      0x14009C
#define REG_FSC_BK1A_4E_H      0x14009D
#define REG_FSC_BK1A_4F_L      0x14009E
#define REG_FSC_BK1A_4F_H      0x14009F
#define REG_FSC_BK1A_50_L      0x1400A0
#define REG_FSC_BK1A_50_H      0x1400A1
#define REG_FSC_BK1A_51_L      0x1400A2
#define REG_FSC_BK1A_51_H      0x1400A3
#define REG_FSC_BK1A_52_L      0x1400A4
#define REG_FSC_BK1A_52_H      0x1400A5
#define REG_FSC_BK1A_53_L      0x1400A6
#define REG_FSC_BK1A_53_H      0x1400A7
#define REG_FSC_BK1A_54_L      0x1400A8
#define REG_FSC_BK1A_54_H      0x1400A9
#define REG_FSC_BK1A_55_L      0x1400AA
#define REG_FSC_BK1A_55_H      0x1400AB
#define REG_FSC_BK1A_56_L      0x1400AC
#define REG_FSC_BK1A_56_H      0x1400AD
#define REG_FSC_BK1A_57_L      0x1400AE
#define REG_FSC_BK1A_57_H      0x1400AF
#define REG_FSC_BK1A_58_L      0x1400B0
#define REG_FSC_BK1A_58_H      0x1400B1
#define REG_FSC_BK1A_59_L      0x1400B2
#define REG_FSC_BK1A_59_H      0x1400B3
#define REG_FSC_BK1A_5A_L      0x1400B4
#define REG_FSC_BK1A_5A_H      0x1400B5
#define REG_FSC_BK1A_5B_L      0x1400B6
#define REG_FSC_BK1A_5B_H      0x1400B7
#define REG_FSC_BK1A_5C_L      0x1400B8
#define REG_FSC_BK1A_5C_H      0x1400B9
#define REG_FSC_BK1A_5D_L      0x1400BA
#define REG_FSC_BK1A_5D_H      0x1400BB
#define REG_FSC_BK1A_5E_L      0x1400BC
#define REG_FSC_BK1A_5E_H      0x1400BD
#define REG_FSC_BK1A_5F_L      0x1400BE
#define REG_FSC_BK1A_5F_H      0x1400BF
#define REG_FSC_BK1A_60_L      0x1400C0
#define REG_FSC_BK1A_60_H      0x1400C1
#define REG_FSC_BK1A_61_L      0x1400C2
#define REG_FSC_BK1A_61_H      0x1400C3
#define REG_FSC_BK1A_62_L      0x1400C4
#define REG_FSC_BK1A_62_H      0x1400C5
#define REG_FSC_BK1A_63_L      0x1400C6
#define REG_FSC_BK1A_63_H      0x1400C7
#define REG_FSC_BK1A_64_L      0x1400C8
#define REG_FSC_BK1A_64_H      0x1400C9
#define REG_FSC_BK1A_65_L      0x1400CA
#define REG_FSC_BK1A_65_H      0x1400CB
#define REG_FSC_BK1A_66_L      0x1400CC
#define REG_FSC_BK1A_66_H      0x1400CD
#define REG_FSC_BK1A_67_L      0x1400CE
#define REG_FSC_BK1A_67_H      0x1400CF
#define REG_FSC_BK1A_68_L      0x1400D0
#define REG_FSC_BK1A_68_H      0x1400D1
#define REG_FSC_BK1A_69_L      0x1400D2
#define REG_FSC_BK1A_69_H      0x1400D3
#define REG_FSC_BK1A_6A_L      0x1400D4
#define REG_FSC_BK1A_6A_H      0x1400D5
#define REG_FSC_BK1A_6B_L      0x1400D6
#define REG_FSC_BK1A_6B_H      0x1400D7
#define REG_FSC_BK1A_6C_L      0x1400D8
#define REG_FSC_BK1A_6C_H      0x1400D9
#define REG_FSC_BK1A_6D_L      0x1400DA
#define REG_FSC_BK1A_6D_H      0x1400DB
#define REG_FSC_BK1A_6E_L      0x1400DC
#define REG_FSC_BK1A_6E_H      0x1400DD
#define REG_FSC_BK1A_6F_L      0x1400DE
#define REG_FSC_BK1A_6F_H      0x1400DF
#define REG_FSC_BK1A_70_L      0x1400E0
#define REG_FSC_BK1A_70_H      0x1400E1
#define REG_FSC_BK1A_71_L      0x1400E2
#define REG_FSC_BK1A_71_H      0x1400E3
#define REG_FSC_BK1A_72_L      0x1400E4
#define REG_FSC_BK1A_72_H      0x1400E5
#define REG_FSC_BK1A_73_L      0x1400E6
#define REG_FSC_BK1A_73_H      0x1400E7
#define REG_FSC_BK1A_74_L      0x1400E8
#define REG_FSC_BK1A_74_H      0x1400E9
#define REG_FSC_BK1A_75_L      0x1400EA
#define REG_FSC_BK1A_75_H      0x1400EB
#define REG_FSC_BK1A_76_L      0x1400EC
#define REG_FSC_BK1A_76_H      0x1400ED
#define REG_FSC_BK1A_77_L      0x1400EE
#define REG_FSC_BK1A_77_H      0x1400EF
#define REG_FSC_BK1A_78_L      0x1400F0
#define REG_FSC_BK1A_78_H      0x1400F1
#define REG_FSC_BK1A_79_L      0x1400F2
#define REG_FSC_BK1A_79_H      0x1400F3
#define REG_FSC_BK1A_7A_L      0x1400F4
#define REG_FSC_BK1A_7A_H      0x1400F5
#define REG_FSC_BK1A_7B_L      0x1400F6
#define REG_FSC_BK1A_7B_H      0x1400F7
#define REG_FSC_BK1A_7C_L      0x1400F8
#define REG_FSC_BK1A_7C_H      0x1400F9
#define REG_FSC_BK1A_7D_L      0x1400FA
#define REG_FSC_BK1A_7D_H      0x1400FB
#define REG_FSC_BK1A_7E_L      0x1400FC
#define REG_FSC_BK1A_7E_H      0x1400FD
#define REG_FSC_BK1A_7F_L      0x1400FE
#define REG_FSC_BK1A_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK1C_00_L      0x140000
#define REG_FSC_BK1C_00_H      0x140001
#define REG_FSC_BK1C_01_L      0x140002
#define REG_FSC_BK1C_01_H      0x140003
#define REG_FSC_BK1C_02_L      0x140004
#define REG_FSC_BK1C_02_H      0x140005
#define REG_FSC_BK1C_03_L      0x140006
#define REG_FSC_BK1C_03_H      0x140007
#define REG_FSC_BK1C_04_L      0x140008
#define REG_FSC_BK1C_04_H      0x140009
#define REG_FSC_BK1C_05_L      0x14000A
#define REG_FSC_BK1C_05_H      0x14000B
#define REG_FSC_BK1C_06_L      0x14000C
#define REG_FSC_BK1C_06_H      0x14000D
#define REG_FSC_BK1C_07_L      0x14000E
#define REG_FSC_BK1C_07_H      0x14000F
#define REG_FSC_BK1C_08_L      0x140010
#define REG_FSC_BK1C_08_H      0x140011
#define REG_FSC_BK1C_09_L      0x140012
#define REG_FSC_BK1C_09_H      0x140013
#define REG_FSC_BK1C_0A_L      0x140014
#define REG_FSC_BK1C_0A_H      0x140015
#define REG_FSC_BK1C_0B_L      0x140016
#define REG_FSC_BK1C_0B_H      0x140017
#define REG_FSC_BK1C_0C_L      0x140018
#define REG_FSC_BK1C_0C_H      0x140019
#define REG_FSC_BK1C_0D_L      0x14001A
#define REG_FSC_BK1C_0D_H      0x14001B
#define REG_FSC_BK1C_0E_L      0x14001C
#define REG_FSC_BK1C_0E_H      0x14001D
#define REG_FSC_BK1C_0F_L      0x14001E
#define REG_FSC_BK1C_0F_H      0x14001F
#define REG_FSC_BK1C_10_L      0x140020
#define REG_FSC_BK1C_10_H      0x140021
#define REG_FSC_BK1C_11_L      0x140022
#define REG_FSC_BK1C_11_H      0x140023
#define REG_FSC_BK1C_12_L      0x140024
#define REG_FSC_BK1C_12_H      0x140025
#define REG_FSC_BK1C_13_L      0x140026
#define REG_FSC_BK1C_13_H      0x140027
#define REG_FSC_BK1C_14_L      0x140028
#define REG_FSC_BK1C_14_H      0x140029
#define REG_FSC_BK1C_15_L      0x14002A
#define REG_FSC_BK1C_15_H      0x14002B
#define REG_FSC_BK1C_16_L      0x14002C
#define REG_FSC_BK1C_16_H      0x14002D
#define REG_FSC_BK1C_17_L      0x14002E
#define REG_FSC_BK1C_17_H      0x14002F
#define REG_FSC_BK1C_18_L      0x140030
#define REG_FSC_BK1C_18_H      0x140031
#define REG_FSC_BK1C_19_L      0x140032
#define REG_FSC_BK1C_19_H      0x140033
#define REG_FSC_BK1C_1A_L      0x140034
#define REG_FSC_BK1C_1A_H      0x140035
#define REG_FSC_BK1C_1B_L      0x140036
#define REG_FSC_BK1C_1B_H      0x140037
#define REG_FSC_BK1C_1C_L      0x140038
#define REG_FSC_BK1C_1C_H      0x140039
#define REG_FSC_BK1C_1D_L      0x14003A
#define REG_FSC_BK1C_1D_H      0x14003B
#define REG_FSC_BK1C_1E_L      0x14003C
#define REG_FSC_BK1C_1E_H      0x14003D
#define REG_FSC_BK1C_1F_L      0x14003E
#define REG_FSC_BK1C_1F_H      0x14003F
#define REG_FSC_BK1C_20_L      0x140040
#define REG_FSC_BK1C_20_H      0x140041
#define REG_FSC_BK1C_21_L      0x140042
#define REG_FSC_BK1C_21_H      0x140043
#define REG_FSC_BK1C_22_L      0x140044
#define REG_FSC_BK1C_22_H      0x140045
#define REG_FSC_BK1C_23_L      0x140046
#define REG_FSC_BK1C_23_H      0x140047
#define REG_FSC_BK1C_24_L      0x140048
#define REG_FSC_BK1C_24_H      0x140049
#define REG_FSC_BK1C_25_L      0x14004A
#define REG_FSC_BK1C_25_H      0x14004B
#define REG_FSC_BK1C_26_L      0x14004C
#define REG_FSC_BK1C_26_H      0x14004D
#define REG_FSC_BK1C_27_L      0x14004E
#define REG_FSC_BK1C_27_H      0x14004F
#define REG_FSC_BK1C_28_L      0x140050
#define REG_FSC_BK1C_28_H      0x140051
#define REG_FSC_BK1C_29_L      0x140052
#define REG_FSC_BK1C_29_H      0x140053
#define REG_FSC_BK1C_2A_L      0x140054
#define REG_FSC_BK1C_2A_H      0x140055
#define REG_FSC_BK1C_2B_L      0x140056
#define REG_FSC_BK1C_2B_H      0x140057
#define REG_FSC_BK1C_2C_L      0x140058
#define REG_FSC_BK1C_2C_H      0x140059
#define REG_FSC_BK1C_2D_L      0x14005A
#define REG_FSC_BK1C_2D_H      0x14005B
#define REG_FSC_BK1C_2E_L      0x14005C
#define REG_FSC_BK1C_2E_H      0x14005D
#define REG_FSC_BK1C_2F_L      0x14005E
#define REG_FSC_BK1C_2F_H      0x14005F
#define REG_FSC_BK1C_30_L      0x140060
#define REG_FSC_BK1C_30_H      0x140061
#define REG_FSC_BK1C_31_L      0x140062
#define REG_FSC_BK1C_31_H      0x140063
#define REG_FSC_BK1C_32_L      0x140064
#define REG_FSC_BK1C_32_H      0x140065
#define REG_FSC_BK1C_33_L      0x140066
#define REG_FSC_BK1C_33_H      0x140067
#define REG_FSC_BK1C_34_L      0x140068
#define REG_FSC_BK1C_34_H      0x140069
#define REG_FSC_BK1C_35_L      0x14006A
#define REG_FSC_BK1C_35_H      0x14006B
#define REG_FSC_BK1C_36_L      0x14006C
#define REG_FSC_BK1C_36_H      0x14006D
#define REG_FSC_BK1C_37_L      0x14006E
#define REG_FSC_BK1C_37_H      0x14006F
#define REG_FSC_BK1C_38_L      0x140070
#define REG_FSC_BK1C_38_H      0x140071
#define REG_FSC_BK1C_39_L      0x140072
#define REG_FSC_BK1C_39_H      0x140073
#define REG_FSC_BK1C_3A_L      0x140074
#define REG_FSC_BK1C_3A_H      0x140075
#define REG_FSC_BK1C_3B_L      0x140076
#define REG_FSC_BK1C_3B_H      0x140077
#define REG_FSC_BK1C_3C_L      0x140078
#define REG_FSC_BK1C_3C_H      0x140079
#define REG_FSC_BK1C_3D_L      0x14007A
#define REG_FSC_BK1C_3D_H      0x14007B
#define REG_FSC_BK1C_3E_L      0x14007C
#define REG_FSC_BK1C_3E_H      0x14007D
#define REG_FSC_BK1C_3F_L      0x14007E
#define REG_FSC_BK1C_3F_H      0x14007F
#define REG_FSC_BK1C_40_L      0x140080
#define REG_FSC_BK1C_40_H      0x140081
#define REG_FSC_BK1C_41_L      0x140082
#define REG_FSC_BK1C_41_H      0x140083
#define REG_FSC_BK1C_42_L      0x140084
#define REG_FSC_BK1C_42_H      0x140085
#define REG_FSC_BK1C_43_L      0x140086
#define REG_FSC_BK1C_43_H      0x140087
#define REG_FSC_BK1C_44_L      0x140088
#define REG_FSC_BK1C_44_H      0x140089
#define REG_FSC_BK1C_45_L      0x14008A
#define REG_FSC_BK1C_45_H      0x14008B
#define REG_FSC_BK1C_46_L      0x14008C
#define REG_FSC_BK1C_46_H      0x14008D
#define REG_FSC_BK1C_47_L      0x14008E
#define REG_FSC_BK1C_47_H      0x14008F
#define REG_FSC_BK1C_48_L      0x140090
#define REG_FSC_BK1C_48_H      0x140091
#define REG_FSC_BK1C_49_L      0x140092
#define REG_FSC_BK1C_49_H      0x140093
#define REG_FSC_BK1C_4A_L      0x140094
#define REG_FSC_BK1C_4A_H      0x140095
#define REG_FSC_BK1C_4B_L      0x140096
#define REG_FSC_BK1C_4B_H      0x140097
#define REG_FSC_BK1C_4C_L      0x140098
#define REG_FSC_BK1C_4C_H      0x140099
#define REG_FSC_BK1C_4D_L      0x14009A
#define REG_FSC_BK1C_4D_H      0x14009B
#define REG_FSC_BK1C_4E_L      0x14009C
#define REG_FSC_BK1C_4E_H      0x14009D
#define REG_FSC_BK1C_4F_L      0x14009E
#define REG_FSC_BK1C_4F_H      0x14009F
#define REG_FSC_BK1C_50_L      0x1400A0
#define REG_FSC_BK1C_50_H      0x1400A1
#define REG_FSC_BK1C_51_L      0x1400A2
#define REG_FSC_BK1C_51_H      0x1400A3
#define REG_FSC_BK1C_52_L      0x1400A4
#define REG_FSC_BK1C_52_H      0x1400A5
#define REG_FSC_BK1C_53_L      0x1400A6
#define REG_FSC_BK1C_53_H      0x1400A7
#define REG_FSC_BK1C_54_L      0x1400A8
#define REG_FSC_BK1C_54_H      0x1400A9
#define REG_FSC_BK1C_55_L      0x1400AA
#define REG_FSC_BK1C_55_H      0x1400AB
#define REG_FSC_BK1C_56_L      0x1400AC
#define REG_FSC_BK1C_56_H      0x1400AD
#define REG_FSC_BK1C_57_L      0x1400AE
#define REG_FSC_BK1C_57_H      0x1400AF
#define REG_FSC_BK1C_58_L      0x1400B0
#define REG_FSC_BK1C_58_H      0x1400B1
#define REG_FSC_BK1C_59_L      0x1400B2
#define REG_FSC_BK1C_59_H      0x1400B3
#define REG_FSC_BK1C_5A_L      0x1400B4
#define REG_FSC_BK1C_5A_H      0x1400B5
#define REG_FSC_BK1C_5B_L      0x1400B6
#define REG_FSC_BK1C_5B_H      0x1400B7
#define REG_FSC_BK1C_5C_L      0x1400B8
#define REG_FSC_BK1C_5C_H      0x1400B9
#define REG_FSC_BK1C_5D_L      0x1400BA
#define REG_FSC_BK1C_5D_H      0x1400BB
#define REG_FSC_BK1C_5E_L      0x1400BC
#define REG_FSC_BK1C_5E_H      0x1400BD
#define REG_FSC_BK1C_5F_L      0x1400BE
#define REG_FSC_BK1C_5F_H      0x1400BF
#define REG_FSC_BK1C_60_L      0x1400C0
#define REG_FSC_BK1C_60_H      0x1400C1
#define REG_FSC_BK1C_61_L      0x1400C2
#define REG_FSC_BK1C_61_H      0x1400C3
#define REG_FSC_BK1C_62_L      0x1400C4
#define REG_FSC_BK1C_62_H      0x1400C5
#define REG_FSC_BK1C_63_L      0x1400C6
#define REG_FSC_BK1C_63_H      0x1400C7
#define REG_FSC_BK1C_64_L      0x1400C8
#define REG_FSC_BK1C_64_H      0x1400C9
#define REG_FSC_BK1C_65_L      0x1400CA
#define REG_FSC_BK1C_65_H      0x1400CB
#define REG_FSC_BK1C_66_L      0x1400CC
#define REG_FSC_BK1C_66_H      0x1400CD
#define REG_FSC_BK1C_67_L      0x1400CE
#define REG_FSC_BK1C_67_H      0x1400CF
#define REG_FSC_BK1C_68_L      0x1400D0
#define REG_FSC_BK1C_68_H      0x1400D1
#define REG_FSC_BK1C_69_L      0x1400D2
#define REG_FSC_BK1C_69_H      0x1400D3
#define REG_FSC_BK1C_6A_L      0x1400D4
#define REG_FSC_BK1C_6A_H      0x1400D5
#define REG_FSC_BK1C_6B_L      0x1400D6
#define REG_FSC_BK1C_6B_H      0x1400D7
#define REG_FSC_BK1C_6C_L      0x1400D8
#define REG_FSC_BK1C_6C_H      0x1400D9
#define REG_FSC_BK1C_6D_L      0x1400DA
#define REG_FSC_BK1C_6D_H      0x1400DB
#define REG_FSC_BK1C_6E_L      0x1400DC
#define REG_FSC_BK1C_6E_H      0x1400DD
#define REG_FSC_BK1C_6F_L      0x1400DE
#define REG_FSC_BK1C_6F_H      0x1400DF
#define REG_FSC_BK1C_70_L      0x1400E0
#define REG_FSC_BK1C_70_H      0x1400E1
#define REG_FSC_BK1C_71_L      0x1400E2
#define REG_FSC_BK1C_71_H      0x1400E3
#define REG_FSC_BK1C_72_L      0x1400E4
#define REG_FSC_BK1C_72_H      0x1400E5
#define REG_FSC_BK1C_73_L      0x1400E6
#define REG_FSC_BK1C_73_H      0x1400E7
#define REG_FSC_BK1C_74_L      0x1400E8
#define REG_FSC_BK1C_74_H      0x1400E9
#define REG_FSC_BK1C_75_L      0x1400EA
#define REG_FSC_BK1C_75_H      0x1400EB
#define REG_FSC_BK1C_76_L      0x1400EC
#define REG_FSC_BK1C_76_H      0x1400ED
#define REG_FSC_BK1C_77_L      0x1400EE
#define REG_FSC_BK1C_77_H      0x1400EF
#define REG_FSC_BK1C_78_L      0x1400F0
#define REG_FSC_BK1C_78_H      0x1400F1
#define REG_FSC_BK1C_79_L      0x1400F2
#define REG_FSC_BK1C_79_H      0x1400F3
#define REG_FSC_BK1C_7A_L      0x1400F4
#define REG_FSC_BK1C_7A_H      0x1400F5
#define REG_FSC_BK1C_7B_L      0x1400F6
#define REG_FSC_BK1C_7B_H      0x1400F7
#define REG_FSC_BK1C_7C_L      0x1400F8
#define REG_FSC_BK1C_7C_H      0x1400F9
#define REG_FSC_BK1C_7D_L      0x1400FA
#define REG_FSC_BK1C_7D_H      0x1400FB
#define REG_FSC_BK1C_7E_L      0x1400FC
#define REG_FSC_BK1C_7E_H      0x1400FD
#define REG_FSC_BK1C_7F_L      0x1400FE
#define REG_FSC_BK1C_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK23_00_L      0x140000
#define REG_FSC_BK23_00_H      0x140001
#define REG_FSC_BK23_01_L      0x140002
#define REG_FSC_BK23_01_H      0x140003
#define REG_FSC_BK23_02_L      0x140004
#define REG_FSC_BK23_02_H      0x140005
#define REG_FSC_BK23_03_L      0x140006
#define REG_FSC_BK23_03_H      0x140007
#define REG_FSC_BK23_04_L      0x140008
#define REG_FSC_BK23_04_H      0x140009
#define REG_FSC_BK23_05_L      0x14000A
#define REG_FSC_BK23_05_H      0x14000B
#define REG_FSC_BK23_06_L      0x14000C
#define REG_FSC_BK23_06_H      0x14000D
#define REG_FSC_BK23_07_L      0x14000E
#define REG_FSC_BK23_07_H      0x14000F
#define REG_FSC_BK23_08_L      0x140010
#define REG_FSC_BK23_08_H      0x140011
#define REG_FSC_BK23_09_L      0x140012
#define REG_FSC_BK23_09_H      0x140013
#define REG_FSC_BK23_0A_L      0x140014
#define REG_FSC_BK23_0A_H      0x140015
#define REG_FSC_BK23_0B_L      0x140016
#define REG_FSC_BK23_0B_H      0x140017
#define REG_FSC_BK23_0C_L      0x140018
#define REG_FSC_BK23_0C_H      0x140019
#define REG_FSC_BK23_0D_L      0x14001A
#define REG_FSC_BK23_0D_H      0x14001B
#define REG_FSC_BK23_0E_L      0x14001C
#define REG_FSC_BK23_0E_H      0x14001D
#define REG_FSC_BK23_0F_L      0x14001E
#define REG_FSC_BK23_0F_H      0x14001F
#define REG_FSC_BK23_10_L      0x140020
#define REG_FSC_BK23_10_H      0x140021
#define REG_FSC_BK23_11_L      0x140022
#define REG_FSC_BK23_11_H      0x140023
#define REG_FSC_BK23_12_L      0x140024
#define REG_FSC_BK23_12_H      0x140025
#define REG_FSC_BK23_13_L      0x140026
#define REG_FSC_BK23_13_H      0x140027
#define REG_FSC_BK23_14_L      0x140028
#define REG_FSC_BK23_14_H      0x140029
#define REG_FSC_BK23_15_L      0x14002A
#define REG_FSC_BK23_15_H      0x14002B
#define REG_FSC_BK23_16_L      0x14002C
#define REG_FSC_BK23_16_H      0x14002D
#define REG_FSC_BK23_17_L      0x14002E
#define REG_FSC_BK23_17_H      0x14002F
#define REG_FSC_BK23_18_L      0x140030
#define REG_FSC_BK23_18_H      0x140031
#define REG_FSC_BK23_19_L      0x140032
#define REG_FSC_BK23_19_H      0x140033
#define REG_FSC_BK23_1A_L      0x140034
#define REG_FSC_BK23_1A_H      0x140035
#define REG_FSC_BK23_1B_L      0x140036
#define REG_FSC_BK23_1B_H      0x140037
#define REG_FSC_BK23_1C_L      0x140038
#define REG_FSC_BK23_1C_H      0x140039
#define REG_FSC_BK23_1D_L      0x14003A
#define REG_FSC_BK23_1D_H      0x14003B
#define REG_FSC_BK23_1E_L      0x14003C
#define REG_FSC_BK23_1E_H      0x14003D
#define REG_FSC_BK23_1F_L      0x14003E
#define REG_FSC_BK23_1F_H      0x14003F
#define REG_FSC_BK23_20_L      0x140040
#define REG_FSC_BK23_20_H      0x140041
#define REG_FSC_BK23_21_L      0x140042
#define REG_FSC_BK23_21_H      0x140043
#define REG_FSC_BK23_22_L      0x140044
#define REG_FSC_BK23_22_H      0x140045
#define REG_FSC_BK23_23_L      0x140046
#define REG_FSC_BK23_23_H      0x140047
#define REG_FSC_BK23_24_L      0x140048
#define REG_FSC_BK23_24_H      0x140049
#define REG_FSC_BK23_25_L      0x14004A
#define REG_FSC_BK23_25_H      0x14004B
#define REG_FSC_BK23_26_L      0x14004C
#define REG_FSC_BK23_26_H      0x14004D
#define REG_FSC_BK23_27_L      0x14004E
#define REG_FSC_BK23_27_H      0x14004F
#define REG_FSC_BK23_28_L      0x140050
#define REG_FSC_BK23_28_H      0x140051
#define REG_FSC_BK23_29_L      0x140052
#define REG_FSC_BK23_29_H      0x140053
#define REG_FSC_BK23_2A_L      0x140054
#define REG_FSC_BK23_2A_H      0x140055
#define REG_FSC_BK23_2B_L      0x140056
#define REG_FSC_BK23_2B_H      0x140057
#define REG_FSC_BK23_2C_L      0x140058
#define REG_FSC_BK23_2C_H      0x140059
#define REG_FSC_BK23_2D_L      0x14005A
#define REG_FSC_BK23_2D_H      0x14005B
#define REG_FSC_BK23_2E_L      0x14005C
#define REG_FSC_BK23_2E_H      0x14005D
#define REG_FSC_BK23_2F_L      0x14005E
#define REG_FSC_BK23_2F_H      0x14005F
#define REG_FSC_BK23_30_L      0x140060
#define REG_FSC_BK23_30_H      0x140061
#define REG_FSC_BK23_31_L      0x140062
#define REG_FSC_BK23_31_H      0x140063
#define REG_FSC_BK23_32_L      0x140064
#define REG_FSC_BK23_32_H      0x140065
#define REG_FSC_BK23_33_L      0x140066
#define REG_FSC_BK23_33_H      0x140067
#define REG_FSC_BK23_34_L      0x140068
#define REG_FSC_BK23_34_H      0x140069
#define REG_FSC_BK23_35_L      0x14006A
#define REG_FSC_BK23_35_H      0x14006B
#define REG_FSC_BK23_36_L      0x14006C
#define REG_FSC_BK23_36_H      0x14006D
#define REG_FSC_BK23_37_L      0x14006E
#define REG_FSC_BK23_37_H      0x14006F
#define REG_FSC_BK23_38_L      0x140070
#define REG_FSC_BK23_38_H      0x140071
#define REG_FSC_BK23_39_L      0x140072
#define REG_FSC_BK23_39_H      0x140073
#define REG_FSC_BK23_3A_L      0x140074
#define REG_FSC_BK23_3A_H      0x140075
#define REG_FSC_BK23_3B_L      0x140076
#define REG_FSC_BK23_3B_H      0x140077
#define REG_FSC_BK23_3C_L      0x140078
#define REG_FSC_BK23_3C_H      0x140079
#define REG_FSC_BK23_3D_L      0x14007A
#define REG_FSC_BK23_3D_H      0x14007B
#define REG_FSC_BK23_3E_L      0x14007C
#define REG_FSC_BK23_3E_H      0x14007D
#define REG_FSC_BK23_3F_L      0x14007E
#define REG_FSC_BK23_3F_H      0x14007F
#define REG_FSC_BK23_40_L      0x140080
#define REG_FSC_BK23_40_H      0x140081
#define REG_FSC_BK23_41_L      0x140082
#define REG_FSC_BK23_41_H      0x140083
#define REG_FSC_BK23_42_L      0x140084
#define REG_FSC_BK23_42_H      0x140085
#define REG_FSC_BK23_43_L      0x140086
#define REG_FSC_BK23_43_H      0x140087
#define REG_FSC_BK23_44_L      0x140088
#define REG_FSC_BK23_44_H      0x140089
#define REG_FSC_BK23_45_L      0x14008A
#define REG_FSC_BK23_45_H      0x14008B
#define REG_FSC_BK23_46_L      0x14008C
#define REG_FSC_BK23_46_H      0x14008D
#define REG_FSC_BK23_47_L      0x14008E
#define REG_FSC_BK23_47_H      0x14008F
#define REG_FSC_BK23_48_L      0x140090
#define REG_FSC_BK23_48_H      0x140091
#define REG_FSC_BK23_49_L      0x140092
#define REG_FSC_BK23_49_H      0x140093
#define REG_FSC_BK23_4A_L      0x140094
#define REG_FSC_BK23_4A_H      0x140095
#define REG_FSC_BK23_4B_L      0x140096
#define REG_FSC_BK23_4B_H      0x140097
#define REG_FSC_BK23_4C_L      0x140098
#define REG_FSC_BK23_4C_H      0x140099
#define REG_FSC_BK23_4D_L      0x14009A
#define REG_FSC_BK23_4D_H      0x14009B
#define REG_FSC_BK23_4E_L      0x14009C
#define REG_FSC_BK23_4E_H      0x14009D
#define REG_FSC_BK23_4F_L      0x14009E
#define REG_FSC_BK23_4F_H      0x14009F
#define REG_FSC_BK23_50_L      0x1400A0
#define REG_FSC_BK23_50_H      0x1400A1
#define REG_FSC_BK23_51_L      0x1400A2
#define REG_FSC_BK23_51_H      0x1400A3
#define REG_FSC_BK23_52_L      0x1400A4
#define REG_FSC_BK23_52_H      0x1400A5
#define REG_FSC_BK23_53_L      0x1400A6
#define REG_FSC_BK23_53_H      0x1400A7
#define REG_FSC_BK23_54_L      0x1400A8
#define REG_FSC_BK23_54_H      0x1400A9
#define REG_FSC_BK23_55_L      0x1400AA
#define REG_FSC_BK23_55_H      0x1400AB
#define REG_FSC_BK23_56_L      0x1400AC
#define REG_FSC_BK23_56_H      0x1400AD
#define REG_FSC_BK23_57_L      0x1400AE
#define REG_FSC_BK23_57_H      0x1400AF
#define REG_FSC_BK23_58_L      0x1400B0
#define REG_FSC_BK23_58_H      0x1400B1
#define REG_FSC_BK23_59_L      0x1400B2
#define REG_FSC_BK23_59_H      0x1400B3
#define REG_FSC_BK23_5A_L      0x1400B4
#define REG_FSC_BK23_5A_H      0x1400B5
#define REG_FSC_BK23_5B_L      0x1400B6
#define REG_FSC_BK23_5B_H      0x1400B7
#define REG_FSC_BK23_5C_L      0x1400B8
#define REG_FSC_BK23_5C_H      0x1400B9
#define REG_FSC_BK23_5D_L      0x1400BA
#define REG_FSC_BK23_5D_H      0x1400BB
#define REG_FSC_BK23_5E_L      0x1400BC
#define REG_FSC_BK23_5E_H      0x1400BD
#define REG_FSC_BK23_5F_L      0x1400BE
#define REG_FSC_BK23_5F_H      0x1400BF
#define REG_FSC_BK23_60_L      0x1400C0
#define REG_FSC_BK23_60_H      0x1400C1
#define REG_FSC_BK23_61_L      0x1400C2
#define REG_FSC_BK23_61_H      0x1400C3
#define REG_FSC_BK23_62_L      0x1400C4
#define REG_FSC_BK23_62_H      0x1400C5
#define REG_FSC_BK23_63_L      0x1400C6
#define REG_FSC_BK23_63_H      0x1400C7
#define REG_FSC_BK23_64_L      0x1400C8
#define REG_FSC_BK23_64_H      0x1400C9
#define REG_FSC_BK23_65_L      0x1400CA
#define REG_FSC_BK23_65_H      0x1400CB
#define REG_FSC_BK23_66_L      0x1400CC
#define REG_FSC_BK23_66_H      0x1400CD
#define REG_FSC_BK23_67_L      0x1400CE
#define REG_FSC_BK23_67_H      0x1400CF
#define REG_FSC_BK23_68_L      0x1400D0
#define REG_FSC_BK23_68_H      0x1400D1
#define REG_FSC_BK23_69_L      0x1400D2
#define REG_FSC_BK23_69_H      0x1400D3
#define REG_FSC_BK23_6A_L      0x1400D4
#define REG_FSC_BK23_6A_H      0x1400D5
#define REG_FSC_BK23_6B_L      0x1400D6
#define REG_FSC_BK23_6B_H      0x1400D7
#define REG_FSC_BK23_6C_L      0x1400D8
#define REG_FSC_BK23_6C_H      0x1400D9
#define REG_FSC_BK23_6D_L      0x1400DA
#define REG_FSC_BK23_6D_H      0x1400DB
#define REG_FSC_BK23_6E_L      0x1400DC
#define REG_FSC_BK23_6E_H      0x1400DD
#define REG_FSC_BK23_6F_L      0x1400DE
#define REG_FSC_BK23_6F_H      0x1400DF
#define REG_FSC_BK23_70_L      0x1400E0
#define REG_FSC_BK23_70_H      0x1400E1
#define REG_FSC_BK23_71_L      0x1400E2
#define REG_FSC_BK23_71_H      0x1400E3
#define REG_FSC_BK23_72_L      0x1400E4
#define REG_FSC_BK23_72_H      0x1400E5
#define REG_FSC_BK23_73_L      0x1400E6
#define REG_FSC_BK23_73_H      0x1400E7
#define REG_FSC_BK23_74_L      0x1400E8
#define REG_FSC_BK23_74_H      0x1400E9
#define REG_FSC_BK23_75_L      0x1400EA
#define REG_FSC_BK23_75_H      0x1400EB
#define REG_FSC_BK23_76_L      0x1400EC
#define REG_FSC_BK23_76_H      0x1400ED
#define REG_FSC_BK23_77_L      0x1400EE
#define REG_FSC_BK23_77_H      0x1400EF
#define REG_FSC_BK23_78_L      0x1400F0
#define REG_FSC_BK23_78_H      0x1400F1
#define REG_FSC_BK23_79_L      0x1400F2
#define REG_FSC_BK23_79_H      0x1400F3
#define REG_FSC_BK23_7A_L      0x1400F4
#define REG_FSC_BK23_7A_H      0x1400F5
#define REG_FSC_BK23_7B_L      0x1400F6
#define REG_FSC_BK23_7B_H      0x1400F7
#define REG_FSC_BK23_7C_L      0x1400F8
#define REG_FSC_BK23_7C_H      0x1400F9
#define REG_FSC_BK23_7D_L      0x1400FA
#define REG_FSC_BK23_7D_H      0x1400FB
#define REG_FSC_BK23_7E_L      0x1400FC
#define REG_FSC_BK23_7E_H      0x1400FD
#define REG_FSC_BK23_7F_L      0x1400FE
#define REG_FSC_BK23_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK26_00_L      0x140000
#define REG_FSC_BK26_00_H      0x140001
#define REG_FSC_BK26_01_L      0x140002
#define REG_FSC_BK26_01_H      0x140003
#define REG_FSC_BK26_02_L      0x140004
#define REG_FSC_BK26_02_H      0x140005
#define REG_FSC_BK26_03_L      0x140006
#define REG_FSC_BK26_03_H      0x140007
#define REG_FSC_BK26_04_L      0x140008
#define REG_FSC_BK26_04_H      0x140009
#define REG_FSC_BK26_05_L      0x14000A
#define REG_FSC_BK26_05_H      0x14000B
#define REG_FSC_BK26_06_L      0x14000C
#define REG_FSC_BK26_06_H      0x14000D
#define REG_FSC_BK26_07_L      0x14000E
#define REG_FSC_BK26_07_H      0x14000F
#define REG_FSC_BK26_08_L      0x140010
#define REG_FSC_BK26_08_H      0x140011
#define REG_FSC_BK26_09_L      0x140012
#define REG_FSC_BK26_09_H      0x140013
#define REG_FSC_BK26_0A_L      0x140014
#define REG_FSC_BK26_0A_H      0x140015
#define REG_FSC_BK26_0B_L      0x140016
#define REG_FSC_BK26_0B_H      0x140017
#define REG_FSC_BK26_0C_L      0x140018
#define REG_FSC_BK26_0C_H      0x140019
#define REG_FSC_BK26_0D_L      0x14001A
#define REG_FSC_BK26_0D_H      0x14001B
#define REG_FSC_BK26_0E_L      0x14001C
#define REG_FSC_BK26_0E_H      0x14001D
#define REG_FSC_BK26_0F_L      0x14001E
#define REG_FSC_BK26_0F_H      0x14001F
#define REG_FSC_BK26_10_L      0x140020
#define REG_FSC_BK26_10_H      0x140021
#define REG_FSC_BK26_11_L      0x140022
#define REG_FSC_BK26_11_H      0x140023
#define REG_FSC_BK26_12_L      0x140024
#define REG_FSC_BK26_12_H      0x140025
#define REG_FSC_BK26_13_L      0x140026
#define REG_FSC_BK26_13_H      0x140027
#define REG_FSC_BK26_14_L      0x140028
#define REG_FSC_BK26_14_H      0x140029
#define REG_FSC_BK26_15_L      0x14002A
#define REG_FSC_BK26_15_H      0x14002B
#define REG_FSC_BK26_16_L      0x14002C
#define REG_FSC_BK26_16_H      0x14002D
#define REG_FSC_BK26_17_L      0x14002E
#define REG_FSC_BK26_17_H      0x14002F
#define REG_FSC_BK26_18_L      0x140030
#define REG_FSC_BK26_18_H      0x140031
#define REG_FSC_BK26_19_L      0x140032
#define REG_FSC_BK26_19_H      0x140033
#define REG_FSC_BK26_1A_L      0x140034
#define REG_FSC_BK26_1A_H      0x140035
#define REG_FSC_BK26_1B_L      0x140036
#define REG_FSC_BK26_1B_H      0x140037
#define REG_FSC_BK26_1C_L      0x140038
#define REG_FSC_BK26_1C_H      0x140039
#define REG_FSC_BK26_1D_L      0x14003A
#define REG_FSC_BK26_1D_H      0x14003B
#define REG_FSC_BK26_1E_L      0x14003C
#define REG_FSC_BK26_1E_H      0x14003D
#define REG_FSC_BK26_1F_L      0x14003E
#define REG_FSC_BK26_1F_H      0x14003F
#define REG_FSC_BK26_20_L      0x140040
#define REG_FSC_BK26_20_H      0x140041
#define REG_FSC_BK26_21_L      0x140042
#define REG_FSC_BK26_21_H      0x140043
#define REG_FSC_BK26_22_L      0x140044
#define REG_FSC_BK26_22_H      0x140045
#define REG_FSC_BK26_23_L      0x140046
#define REG_FSC_BK26_23_H      0x140047
#define REG_FSC_BK26_24_L      0x140048
#define REG_FSC_BK26_24_H      0x140049
#define REG_FSC_BK26_25_L      0x14004A
#define REG_FSC_BK26_25_H      0x14004B
#define REG_FSC_BK26_26_L      0x14004C
#define REG_FSC_BK26_26_H      0x14004D
#define REG_FSC_BK26_27_L      0x14004E
#define REG_FSC_BK26_27_H      0x14004F
#define REG_FSC_BK26_28_L      0x140050
#define REG_FSC_BK26_28_H      0x140051
#define REG_FSC_BK26_29_L      0x140052
#define REG_FSC_BK26_29_H      0x140053
#define REG_FSC_BK26_2A_L      0x140054
#define REG_FSC_BK26_2A_H      0x140055
#define REG_FSC_BK26_2B_L      0x140056
#define REG_FSC_BK26_2B_H      0x140057
#define REG_FSC_BK26_2C_L      0x140058
#define REG_FSC_BK26_2C_H      0x140059
#define REG_FSC_BK26_2D_L      0x14005A
#define REG_FSC_BK26_2D_H      0x14005B
#define REG_FSC_BK26_2E_L      0x14005C
#define REG_FSC_BK26_2E_H      0x14005D
#define REG_FSC_BK26_2F_L      0x14005E
#define REG_FSC_BK26_2F_H      0x14005F
#define REG_FSC_BK26_30_L      0x140060
#define REG_FSC_BK26_30_H      0x140061
#define REG_FSC_BK26_31_L      0x140062
#define REG_FSC_BK26_31_H      0x140063
#define REG_FSC_BK26_32_L      0x140064
#define REG_FSC_BK26_32_H      0x140065
#define REG_FSC_BK26_33_L      0x140066
#define REG_FSC_BK26_33_H      0x140067
#define REG_FSC_BK26_34_L      0x140068
#define REG_FSC_BK26_34_H      0x140069
#define REG_FSC_BK26_35_L      0x14006A
#define REG_FSC_BK26_35_H      0x14006B
#define REG_FSC_BK26_36_L      0x14006C
#define REG_FSC_BK26_36_H      0x14006D
#define REG_FSC_BK26_37_L      0x14006E
#define REG_FSC_BK26_37_H      0x14006F
#define REG_FSC_BK26_38_L      0x140070
#define REG_FSC_BK26_38_H      0x140071
#define REG_FSC_BK26_39_L      0x140072
#define REG_FSC_BK26_39_H      0x140073
#define REG_FSC_BK26_3A_L      0x140074
#define REG_FSC_BK26_3A_H      0x140075
#define REG_FSC_BK26_3B_L      0x140076
#define REG_FSC_BK26_3B_H      0x140077
#define REG_FSC_BK26_3C_L      0x140078
#define REG_FSC_BK26_3C_H      0x140079
#define REG_FSC_BK26_3D_L      0x14007A
#define REG_FSC_BK26_3D_H      0x14007B
#define REG_FSC_BK26_3E_L      0x14007C
#define REG_FSC_BK26_3E_H      0x14007D
#define REG_FSC_BK26_3F_L      0x14007E
#define REG_FSC_BK26_3F_H      0x14007F
#define REG_FSC_BK26_40_L      0x140080
#define REG_FSC_BK26_40_H      0x140081
#define REG_FSC_BK26_41_L      0x140082
#define REG_FSC_BK26_41_H      0x140083
#define REG_FSC_BK26_42_L      0x140084
#define REG_FSC_BK26_42_H      0x140085
#define REG_FSC_BK26_43_L      0x140086
#define REG_FSC_BK26_43_H      0x140087
#define REG_FSC_BK26_44_L      0x140088
#define REG_FSC_BK26_44_H      0x140089
#define REG_FSC_BK26_45_L      0x14008A
#define REG_FSC_BK26_45_H      0x14008B
#define REG_FSC_BK26_46_L      0x14008C
#define REG_FSC_BK26_46_H      0x14008D
#define REG_FSC_BK26_47_L      0x14008E
#define REG_FSC_BK26_47_H      0x14008F
#define REG_FSC_BK26_48_L      0x140090
#define REG_FSC_BK26_48_H      0x140091
#define REG_FSC_BK26_49_L      0x140092
#define REG_FSC_BK26_49_H      0x140093
#define REG_FSC_BK26_4A_L      0x140094
#define REG_FSC_BK26_4A_H      0x140095
#define REG_FSC_BK26_4B_L      0x140096
#define REG_FSC_BK26_4B_H      0x140097
#define REG_FSC_BK26_4C_L      0x140098
#define REG_FSC_BK26_4C_H      0x140099
#define REG_FSC_BK26_4D_L      0x14009A
#define REG_FSC_BK26_4D_H      0x14009B
#define REG_FSC_BK26_4E_L      0x14009C
#define REG_FSC_BK26_4E_H      0x14009D
#define REG_FSC_BK26_4F_L      0x14009E
#define REG_FSC_BK26_4F_H      0x14009F
#define REG_FSC_BK26_50_L      0x1400A0
#define REG_FSC_BK26_50_H      0x1400A1
#define REG_FSC_BK26_51_L      0x1400A2
#define REG_FSC_BK26_51_H      0x1400A3
#define REG_FSC_BK26_52_L      0x1400A4
#define REG_FSC_BK26_52_H      0x1400A5
#define REG_FSC_BK26_53_L      0x1400A6
#define REG_FSC_BK26_53_H      0x1400A7
#define REG_FSC_BK26_54_L      0x1400A8
#define REG_FSC_BK26_54_H      0x1400A9
#define REG_FSC_BK26_55_L      0x1400AA
#define REG_FSC_BK26_55_H      0x1400AB
#define REG_FSC_BK26_56_L      0x1400AC
#define REG_FSC_BK26_56_H      0x1400AD
#define REG_FSC_BK26_57_L      0x1400AE
#define REG_FSC_BK26_57_H      0x1400AF
#define REG_FSC_BK26_58_L      0x1400B0
#define REG_FSC_BK26_58_H      0x1400B1
#define REG_FSC_BK26_59_L      0x1400B2
#define REG_FSC_BK26_59_H      0x1400B3
#define REG_FSC_BK26_5A_L      0x1400B4
#define REG_FSC_BK26_5A_H      0x1400B5
#define REG_FSC_BK26_5B_L      0x1400B6
#define REG_FSC_BK26_5B_H      0x1400B7
#define REG_FSC_BK26_5C_L      0x1400B8
#define REG_FSC_BK26_5C_H      0x1400B9
#define REG_FSC_BK26_5D_L      0x1400BA
#define REG_FSC_BK26_5D_H      0x1400BB
#define REG_FSC_BK26_5E_L      0x1400BC
#define REG_FSC_BK26_5E_H      0x1400BD
#define REG_FSC_BK26_5F_L      0x1400BE
#define REG_FSC_BK26_5F_H      0x1400BF
#define REG_FSC_BK26_60_L      0x1400C0
#define REG_FSC_BK26_60_H      0x1400C1
#define REG_FSC_BK26_61_L      0x1400C2
#define REG_FSC_BK26_61_H      0x1400C3
#define REG_FSC_BK26_62_L      0x1400C4
#define REG_FSC_BK26_62_H      0x1400C5
#define REG_FSC_BK26_63_L      0x1400C6
#define REG_FSC_BK26_63_H      0x1400C7
#define REG_FSC_BK26_64_L      0x1400C8
#define REG_FSC_BK26_64_H      0x1400C9
#define REG_FSC_BK26_65_L      0x1400CA
#define REG_FSC_BK26_65_H      0x1400CB
#define REG_FSC_BK26_66_L      0x1400CC
#define REG_FSC_BK26_66_H      0x1400CD
#define REG_FSC_BK26_67_L      0x1400CE
#define REG_FSC_BK26_67_H      0x1400CF
#define REG_FSC_BK26_68_L      0x1400D0
#define REG_FSC_BK26_68_H      0x1400D1
#define REG_FSC_BK26_69_L      0x1400D2
#define REG_FSC_BK26_69_H      0x1400D3
#define REG_FSC_BK26_6A_L      0x1400D4
#define REG_FSC_BK26_6A_H      0x1400D5
#define REG_FSC_BK26_6B_L      0x1400D6
#define REG_FSC_BK26_6B_H      0x1400D7
#define REG_FSC_BK26_6C_L      0x1400D8
#define REG_FSC_BK26_6C_H      0x1400D9
#define REG_FSC_BK26_6D_L      0x1400DA
#define REG_FSC_BK26_6D_H      0x1400DB
#define REG_FSC_BK26_6E_L      0x1400DC
#define REG_FSC_BK26_6E_H      0x1400DD
#define REG_FSC_BK26_6F_L      0x1400DE
#define REG_FSC_BK26_6F_H      0x1400DF
#define REG_FSC_BK26_70_L      0x1400E0
#define REG_FSC_BK26_70_H      0x1400E1
#define REG_FSC_BK26_71_L      0x1400E2
#define REG_FSC_BK26_71_H      0x1400E3
#define REG_FSC_BK26_72_L      0x1400E4
#define REG_FSC_BK26_72_H      0x1400E5
#define REG_FSC_BK26_73_L      0x1400E6
#define REG_FSC_BK26_73_H      0x1400E7
#define REG_FSC_BK26_74_L      0x1400E8
#define REG_FSC_BK26_74_H      0x1400E9
#define REG_FSC_BK26_75_L      0x1400EA
#define REG_FSC_BK26_75_H      0x1400EB
#define REG_FSC_BK26_76_L      0x1400EC
#define REG_FSC_BK26_76_H      0x1400ED
#define REG_FSC_BK26_77_L      0x1400EE
#define REG_FSC_BK26_77_H      0x1400EF
#define REG_FSC_BK26_78_L      0x1400F0
#define REG_FSC_BK26_78_H      0x1400F1
#define REG_FSC_BK26_79_L      0x1400F2
#define REG_FSC_BK26_79_H      0x1400F3
#define REG_FSC_BK26_7A_L      0x1400F4
#define REG_FSC_BK26_7A_H      0x1400F5
#define REG_FSC_BK26_7B_L      0x1400F6
#define REG_FSC_BK26_7B_H      0x1400F7
#define REG_FSC_BK26_7C_L      0x1400F8
#define REG_FSC_BK26_7C_H      0x1400F9
#define REG_FSC_BK26_7D_L      0x1400FA
#define REG_FSC_BK26_7D_H      0x1400FB
#define REG_FSC_BK26_7E_L      0x1400FC
#define REG_FSC_BK26_7E_H      0x1400FD
#define REG_FSC_BK26_7F_L      0x1400FE
#define REG_FSC_BK26_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK2C_00_L      0x140000
#define REG_FSC_BK2C_00_H      0x140001
#define REG_FSC_BK2C_01_L      0x140002
#define REG_FSC_BK2C_01_H      0x140003
#define REG_FSC_BK2C_02_L      0x140004
#define REG_FSC_BK2C_02_H      0x140005
#define REG_FSC_BK2C_03_L      0x140006
#define REG_FSC_BK2C_03_H      0x140007
#define REG_FSC_BK2C_04_L      0x140008
#define REG_FSC_BK2C_04_H      0x140009
#define REG_FSC_BK2C_05_L      0x14000A
#define REG_FSC_BK2C_05_H      0x14000B
#define REG_FSC_BK2C_06_L      0x14000C
#define REG_FSC_BK2C_06_H      0x14000D
#define REG_FSC_BK2C_07_L      0x14000E
#define REG_FSC_BK2C_07_H      0x14000F
#define REG_FSC_BK2C_08_L      0x140010
#define REG_FSC_BK2C_08_H      0x140011
#define REG_FSC_BK2C_09_L      0x140012
#define REG_FSC_BK2C_09_H      0x140013
#define REG_FSC_BK2C_0A_L      0x140014
#define REG_FSC_BK2C_0A_H      0x140015
#define REG_FSC_BK2C_0B_L      0x140016
#define REG_FSC_BK2C_0B_H      0x140017
#define REG_FSC_BK2C_0C_L      0x140018
#define REG_FSC_BK2C_0C_H      0x140019
#define REG_FSC_BK2C_0D_L      0x14001A
#define REG_FSC_BK2C_0D_H      0x14001B
#define REG_FSC_BK2C_0E_L      0x14001C
#define REG_FSC_BK2C_0E_H      0x14001D
#define REG_FSC_BK2C_0F_L      0x14001E
#define REG_FSC_BK2C_0F_H      0x14001F
#define REG_FSC_BK2C_10_L      0x140020
#define REG_FSC_BK2C_10_H      0x140021
#define REG_FSC_BK2C_11_L      0x140022
#define REG_FSC_BK2C_11_H      0x140023
#define REG_FSC_BK2C_12_L      0x140024
#define REG_FSC_BK2C_12_H      0x140025
#define REG_FSC_BK2C_13_L      0x140026
#define REG_FSC_BK2C_13_H      0x140027
#define REG_FSC_BK2C_14_L      0x140028
#define REG_FSC_BK2C_14_H      0x140029
#define REG_FSC_BK2C_15_L      0x14002A
#define REG_FSC_BK2C_15_H      0x14002B
#define REG_FSC_BK2C_16_L      0x14002C
#define REG_FSC_BK2C_16_H      0x14002D
#define REG_FSC_BK2C_17_L      0x14002E
#define REG_FSC_BK2C_17_H      0x14002F
#define REG_FSC_BK2C_18_L      0x140030
#define REG_FSC_BK2C_18_H      0x140031
#define REG_FSC_BK2C_19_L      0x140032
#define REG_FSC_BK2C_19_H      0x140033
#define REG_FSC_BK2C_1A_L      0x140034
#define REG_FSC_BK2C_1A_H      0x140035
#define REG_FSC_BK2C_1B_L      0x140036
#define REG_FSC_BK2C_1B_H      0x140037
#define REG_FSC_BK2C_1C_L      0x140038
#define REG_FSC_BK2C_1C_H      0x140039
#define REG_FSC_BK2C_1D_L      0x14003A
#define REG_FSC_BK2C_1D_H      0x14003B
#define REG_FSC_BK2C_1E_L      0x14003C
#define REG_FSC_BK2C_1E_H      0x14003D
#define REG_FSC_BK2C_1F_L      0x14003E
#define REG_FSC_BK2C_1F_H      0x14003F
#define REG_FSC_BK2C_20_L      0x140040
#define REG_FSC_BK2C_20_H      0x140041
#define REG_FSC_BK2C_21_L      0x140042
#define REG_FSC_BK2C_21_H      0x140043
#define REG_FSC_BK2C_22_L      0x140044
#define REG_FSC_BK2C_22_H      0x140045
#define REG_FSC_BK2C_23_L      0x140046
#define REG_FSC_BK2C_23_H      0x140047
#define REG_FSC_BK2C_24_L      0x140048
#define REG_FSC_BK2C_24_H      0x140049
#define REG_FSC_BK2C_25_L      0x14004A
#define REG_FSC_BK2C_25_H      0x14004B
#define REG_FSC_BK2C_26_L      0x14004C
#define REG_FSC_BK2C_26_H      0x14004D
#define REG_FSC_BK2C_27_L      0x14004E
#define REG_FSC_BK2C_27_H      0x14004F
#define REG_FSC_BK2C_28_L      0x140050
#define REG_FSC_BK2C_28_H      0x140051
#define REG_FSC_BK2C_29_L      0x140052
#define REG_FSC_BK2C_29_H      0x140053
#define REG_FSC_BK2C_2A_L      0x140054
#define REG_FSC_BK2C_2A_H      0x140055
#define REG_FSC_BK2C_2B_L      0x140056
#define REG_FSC_BK2C_2B_H      0x140057
#define REG_FSC_BK2C_2C_L      0x140058
#define REG_FSC_BK2C_2C_H      0x140059
#define REG_FSC_BK2C_2D_L      0x14005A
#define REG_FSC_BK2C_2D_H      0x14005B
#define REG_FSC_BK2C_2E_L      0x14005C
#define REG_FSC_BK2C_2E_H      0x14005D
#define REG_FSC_BK2C_2F_L      0x14005E
#define REG_FSC_BK2C_2F_H      0x14005F
#define REG_FSC_BK2C_30_L      0x140060
#define REG_FSC_BK2C_30_H      0x140061
#define REG_FSC_BK2C_31_L      0x140062
#define REG_FSC_BK2C_31_H      0x140063
#define REG_FSC_BK2C_32_L      0x140064
#define REG_FSC_BK2C_32_H      0x140065
#define REG_FSC_BK2C_33_L      0x140066
#define REG_FSC_BK2C_33_H      0x140067
#define REG_FSC_BK2C_34_L      0x140068
#define REG_FSC_BK2C_34_H      0x140069
#define REG_FSC_BK2C_35_L      0x14006A
#define REG_FSC_BK2C_35_H      0x14006B
#define REG_FSC_BK2C_36_L      0x14006C
#define REG_FSC_BK2C_36_H      0x14006D
#define REG_FSC_BK2C_37_L      0x14006E
#define REG_FSC_BK2C_37_H      0x14006F
#define REG_FSC_BK2C_38_L      0x140070
#define REG_FSC_BK2C_38_H      0x140071
#define REG_FSC_BK2C_39_L      0x140072
#define REG_FSC_BK2C_39_H      0x140073
#define REG_FSC_BK2C_3A_L      0x140074
#define REG_FSC_BK2C_3A_H      0x140075
#define REG_FSC_BK2C_3B_L      0x140076
#define REG_FSC_BK2C_3B_H      0x140077
#define REG_FSC_BK2C_3C_L      0x140078
#define REG_FSC_BK2C_3C_H      0x140079
#define REG_FSC_BK2C_3D_L      0x14007A
#define REG_FSC_BK2C_3D_H      0x14007B
#define REG_FSC_BK2C_3E_L      0x14007C
#define REG_FSC_BK2C_3E_H      0x14007D
#define REG_FSC_BK2C_3F_L      0x14007E
#define REG_FSC_BK2C_3F_H      0x14007F
#define REG_FSC_BK2C_40_L      0x140080
#define REG_FSC_BK2C_40_H      0x140081
#define REG_FSC_BK2C_41_L      0x140082
#define REG_FSC_BK2C_41_H      0x140083
#define REG_FSC_BK2C_42_L      0x140084
#define REG_FSC_BK2C_42_H      0x140085
#define REG_FSC_BK2C_43_L      0x140086
#define REG_FSC_BK2C_43_H      0x140087
#define REG_FSC_BK2C_44_L      0x140088
#define REG_FSC_BK2C_44_H      0x140089
#define REG_FSC_BK2C_45_L      0x14008A
#define REG_FSC_BK2C_45_H      0x14008B
#define REG_FSC_BK2C_46_L      0x14008C
#define REG_FSC_BK2C_46_H      0x14008D
#define REG_FSC_BK2C_47_L      0x14008E
#define REG_FSC_BK2C_47_H      0x14008F
#define REG_FSC_BK2C_48_L      0x140090
#define REG_FSC_BK2C_48_H      0x140091
#define REG_FSC_BK2C_49_L      0x140092
#define REG_FSC_BK2C_49_H      0x140093
#define REG_FSC_BK2C_4A_L      0x140094
#define REG_FSC_BK2C_4A_H      0x140095
#define REG_FSC_BK2C_4B_L      0x140096
#define REG_FSC_BK2C_4B_H      0x140097
#define REG_FSC_BK2C_4C_L      0x140098
#define REG_FSC_BK2C_4C_H      0x140099
#define REG_FSC_BK2C_4D_L      0x14009A
#define REG_FSC_BK2C_4D_H      0x14009B
#define REG_FSC_BK2C_4E_L      0x14009C
#define REG_FSC_BK2C_4E_H      0x14009D
#define REG_FSC_BK2C_4F_L      0x14009E
#define REG_FSC_BK2C_4F_H      0x14009F
#define REG_FSC_BK2C_50_L      0x1400A0
#define REG_FSC_BK2C_50_H      0x1400A1
#define REG_FSC_BK2C_51_L      0x1400A2
#define REG_FSC_BK2C_51_H      0x1400A3
#define REG_FSC_BK2C_52_L      0x1400A4
#define REG_FSC_BK2C_52_H      0x1400A5
#define REG_FSC_BK2C_53_L      0x1400A6
#define REG_FSC_BK2C_53_H      0x1400A7
#define REG_FSC_BK2C_54_L      0x1400A8
#define REG_FSC_BK2C_54_H      0x1400A9
#define REG_FSC_BK2C_55_L      0x1400AA
#define REG_FSC_BK2C_55_H      0x1400AB
#define REG_FSC_BK2C_56_L      0x1400AC
#define REG_FSC_BK2C_56_H      0x1400AD
#define REG_FSC_BK2C_57_L      0x1400AE
#define REG_FSC_BK2C_57_H      0x1400AF
#define REG_FSC_BK2C_58_L      0x1400B0
#define REG_FSC_BK2C_58_H      0x1400B1
#define REG_FSC_BK2C_59_L      0x1400B2
#define REG_FSC_BK2C_59_H      0x1400B3
#define REG_FSC_BK2C_5A_L      0x1400B4
#define REG_FSC_BK2C_5A_H      0x1400B5
#define REG_FSC_BK2C_5B_L      0x1400B6
#define REG_FSC_BK2C_5B_H      0x1400B7
#define REG_FSC_BK2C_5C_L      0x1400B8
#define REG_FSC_BK2C_5C_H      0x1400B9
#define REG_FSC_BK2C_5D_L      0x1400BA
#define REG_FSC_BK2C_5D_H      0x1400BB
#define REG_FSC_BK2C_5E_L      0x1400BC
#define REG_FSC_BK2C_5E_H      0x1400BD
#define REG_FSC_BK2C_5F_L      0x1400BE
#define REG_FSC_BK2C_5F_H      0x1400BF
#define REG_FSC_BK2C_60_L      0x1400C0
#define REG_FSC_BK2C_60_H      0x1400C1
#define REG_FSC_BK2C_61_L      0x1400C2
#define REG_FSC_BK2C_61_H      0x1400C3
#define REG_FSC_BK2C_62_L      0x1400C4
#define REG_FSC_BK2C_62_H      0x1400C5
#define REG_FSC_BK2C_63_L      0x1400C6
#define REG_FSC_BK2C_63_H      0x1400C7
#define REG_FSC_BK2C_64_L      0x1400C8
#define REG_FSC_BK2C_64_H      0x1400C9
#define REG_FSC_BK2C_65_L      0x1400CA
#define REG_FSC_BK2C_65_H      0x1400CB
#define REG_FSC_BK2C_66_L      0x1400CC
#define REG_FSC_BK2C_66_H      0x1400CD
#define REG_FSC_BK2C_67_L      0x1400CE
#define REG_FSC_BK2C_67_H      0x1400CF
#define REG_FSC_BK2C_68_L      0x1400D0
#define REG_FSC_BK2C_68_H      0x1400D1
#define REG_FSC_BK2C_69_L      0x1400D2
#define REG_FSC_BK2C_69_H      0x1400D3
#define REG_FSC_BK2C_6A_L      0x1400D4
#define REG_FSC_BK2C_6A_H      0x1400D5
#define REG_FSC_BK2C_6B_L      0x1400D6
#define REG_FSC_BK2C_6B_H      0x1400D7
#define REG_FSC_BK2C_6C_L      0x1400D8
#define REG_FSC_BK2C_6C_H      0x1400D9
#define REG_FSC_BK2C_6D_L      0x1400DA
#define REG_FSC_BK2C_6D_H      0x1400DB
#define REG_FSC_BK2C_6E_L      0x1400DC
#define REG_FSC_BK2C_6E_H      0x1400DD
#define REG_FSC_BK2C_6F_L      0x1400DE
#define REG_FSC_BK2C_6F_H      0x1400DF
#define REG_FSC_BK2C_70_L      0x1400E0
#define REG_FSC_BK2C_70_H      0x1400E1
#define REG_FSC_BK2C_71_L      0x1400E2
#define REG_FSC_BK2C_71_H      0x1400E3
#define REG_FSC_BK2C_72_L      0x1400E4
#define REG_FSC_BK2C_72_H      0x1400E5
#define REG_FSC_BK2C_73_L      0x1400E6
#define REG_FSC_BK2C_73_H      0x1400E7
#define REG_FSC_BK2C_74_L      0x1400E8
#define REG_FSC_BK2C_74_H      0x1400E9
#define REG_FSC_BK2C_75_L      0x1400EA
#define REG_FSC_BK2C_75_H      0x1400EB
#define REG_FSC_BK2C_76_L      0x1400EC
#define REG_FSC_BK2C_76_H      0x1400ED
#define REG_FSC_BK2C_77_L      0x1400EE
#define REG_FSC_BK2C_77_H      0x1400EF
#define REG_FSC_BK2C_78_L      0x1400F0
#define REG_FSC_BK2C_78_H      0x1400F1
#define REG_FSC_BK2C_79_L      0x1400F2
#define REG_FSC_BK2C_79_H      0x1400F3
#define REG_FSC_BK2C_7A_L      0x1400F4
#define REG_FSC_BK2C_7A_H      0x1400F5
#define REG_FSC_BK2C_7B_L      0x1400F6
#define REG_FSC_BK2C_7B_H      0x1400F7
#define REG_FSC_BK2C_7C_L      0x1400F8
#define REG_FSC_BK2C_7C_H      0x1400F9
#define REG_FSC_BK2C_7D_L      0x1400FA
#define REG_FSC_BK2C_7D_H      0x1400FB
#define REG_FSC_BK2C_7E_L      0x1400FC
#define REG_FSC_BK2C_7E_H      0x1400FD
#define REG_FSC_BK2C_7F_L      0x1400FE
#define REG_FSC_BK2C_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK30_00_L      0x140000
#define REG_FSC_BK30_00_H      0x140001
#define REG_FSC_BK30_01_L      0x140002
#define REG_FSC_BK30_01_H      0x140003
#define REG_FSC_BK30_02_L      0x140004
#define REG_FSC_BK30_02_H      0x140005
#define REG_FSC_BK30_03_L      0x140006
#define REG_FSC_BK30_03_H      0x140007
#define REG_FSC_BK30_04_L      0x140008
#define REG_FSC_BK30_04_H      0x140009
#define REG_FSC_BK30_05_L      0x14000A
#define REG_FSC_BK30_05_H      0x14000B
#define REG_FSC_BK30_06_L      0x14000C
#define REG_FSC_BK30_06_H      0x14000D
#define REG_FSC_BK30_07_L      0x14000E
#define REG_FSC_BK30_07_H      0x14000F
#define REG_FSC_BK30_08_L      0x140010
#define REG_FSC_BK30_08_H      0x140011
#define REG_FSC_BK30_09_L      0x140012
#define REG_FSC_BK30_09_H      0x140013
#define REG_FSC_BK30_0A_L      0x140014
#define REG_FSC_BK30_0A_H      0x140015
#define REG_FSC_BK30_0B_L      0x140016
#define REG_FSC_BK30_0B_H      0x140017
#define REG_FSC_BK30_0C_L      0x140018
#define REG_FSC_BK30_0C_H      0x140019
#define REG_FSC_BK30_0D_L      0x14001A
#define REG_FSC_BK30_0D_H      0x14001B
#define REG_FSC_BK30_0E_L      0x14001C
#define REG_FSC_BK30_0E_H      0x14001D
#define REG_FSC_BK30_0F_L      0x14001E
#define REG_FSC_BK30_0F_H      0x14001F
#define REG_FSC_BK30_10_L      0x140020
#define REG_FSC_BK30_10_H      0x140021
#define REG_FSC_BK30_11_L      0x140022
#define REG_FSC_BK30_11_H      0x140023
#define REG_FSC_BK30_12_L      0x140024
#define REG_FSC_BK30_12_H      0x140025
#define REG_FSC_BK30_13_L      0x140026
#define REG_FSC_BK30_13_H      0x140027
#define REG_FSC_BK30_14_L      0x140028
#define REG_FSC_BK30_14_H      0x140029
#define REG_FSC_BK30_15_L      0x14002A
#define REG_FSC_BK30_15_H      0x14002B
#define REG_FSC_BK30_16_L      0x14002C
#define REG_FSC_BK30_16_H      0x14002D
#define REG_FSC_BK30_17_L      0x14002E
#define REG_FSC_BK30_17_H      0x14002F
#define REG_FSC_BK30_18_L      0x140030
#define REG_FSC_BK30_18_H      0x140031
#define REG_FSC_BK30_19_L      0x140032
#define REG_FSC_BK30_19_H      0x140033
#define REG_FSC_BK30_1A_L      0x140034
#define REG_FSC_BK30_1A_H      0x140035
#define REG_FSC_BK30_1B_L      0x140036
#define REG_FSC_BK30_1B_H      0x140037
#define REG_FSC_BK30_1C_L      0x140038
#define REG_FSC_BK30_1C_H      0x140039
#define REG_FSC_BK30_1D_L      0x14003A
#define REG_FSC_BK30_1D_H      0x14003B
#define REG_FSC_BK30_1E_L      0x14003C
#define REG_FSC_BK30_1E_H      0x14003D
#define REG_FSC_BK30_1F_L      0x14003E
#define REG_FSC_BK30_1F_H      0x14003F
#define REG_FSC_BK30_20_L      0x140040
#define REG_FSC_BK30_20_H      0x140041
#define REG_FSC_BK30_21_L      0x140042
#define REG_FSC_BK30_21_H      0x140043
#define REG_FSC_BK30_22_L      0x140044
#define REG_FSC_BK30_22_H      0x140045
#define REG_FSC_BK30_23_L      0x140046
#define REG_FSC_BK30_23_H      0x140047
#define REG_FSC_BK30_24_L      0x140048
#define REG_FSC_BK30_24_H      0x140049
#define REG_FSC_BK30_25_L      0x14004A
#define REG_FSC_BK30_25_H      0x14004B
#define REG_FSC_BK30_26_L      0x14004C
#define REG_FSC_BK30_26_H      0x14004D
#define REG_FSC_BK30_27_L      0x14004E
#define REG_FSC_BK30_27_H      0x14004F
#define REG_FSC_BK30_28_L      0x140050
#define REG_FSC_BK30_28_H      0x140051
#define REG_FSC_BK30_29_L      0x140052
#define REG_FSC_BK30_29_H      0x140053
#define REG_FSC_BK30_2A_L      0x140054
#define REG_FSC_BK30_2A_H      0x140055
#define REG_FSC_BK30_2B_L      0x140056
#define REG_FSC_BK30_2B_H      0x140057
#define REG_FSC_BK30_2C_L      0x140058
#define REG_FSC_BK30_2C_H      0x140059
#define REG_FSC_BK30_2D_L      0x14005A
#define REG_FSC_BK30_2D_H      0x14005B
#define REG_FSC_BK30_2E_L      0x14005C
#define REG_FSC_BK30_2E_H      0x14005D
#define REG_FSC_BK30_2F_L      0x14005E
#define REG_FSC_BK30_2F_H      0x14005F
#define REG_FSC_BK30_30_L      0x140060
#define REG_FSC_BK30_30_H      0x140061
#define REG_FSC_BK30_31_L      0x140062
#define REG_FSC_BK30_31_H      0x140063
#define REG_FSC_BK30_32_L      0x140064
#define REG_FSC_BK30_32_H      0x140065
#define REG_FSC_BK30_33_L      0x140066
#define REG_FSC_BK30_33_H      0x140067
#define REG_FSC_BK30_34_L      0x140068
#define REG_FSC_BK30_34_H      0x140069
#define REG_FSC_BK30_35_L      0x14006A
#define REG_FSC_BK30_35_H      0x14006B
#define REG_FSC_BK30_36_L      0x14006C
#define REG_FSC_BK30_36_H      0x14006D
#define REG_FSC_BK30_37_L      0x14006E
#define REG_FSC_BK30_37_H      0x14006F
#define REG_FSC_BK30_38_L      0x140070
#define REG_FSC_BK30_38_H      0x140071
#define REG_FSC_BK30_39_L      0x140072
#define REG_FSC_BK30_39_H      0x140073
#define REG_FSC_BK30_3A_L      0x140074
#define REG_FSC_BK30_3A_H      0x140075
#define REG_FSC_BK30_3B_L      0x140076
#define REG_FSC_BK30_3B_H      0x140077
#define REG_FSC_BK30_3C_L      0x140078
#define REG_FSC_BK30_3C_H      0x140079
#define REG_FSC_BK30_3D_L      0x14007A
#define REG_FSC_BK30_3D_H      0x14007B
#define REG_FSC_BK30_3E_L      0x14007C
#define REG_FSC_BK30_3E_H      0x14007D
#define REG_FSC_BK30_3F_L      0x14007E
#define REG_FSC_BK30_3F_H      0x14007F
#define REG_FSC_BK30_40_L      0x140080
#define REG_FSC_BK30_40_H      0x140081
#define REG_FSC_BK30_41_L      0x140082
#define REG_FSC_BK30_41_H      0x140083
#define REG_FSC_BK30_42_L      0x140084
#define REG_FSC_BK30_42_H      0x140085
#define REG_FSC_BK30_43_L      0x140086
#define REG_FSC_BK30_43_H      0x140087
#define REG_FSC_BK30_44_L      0x140088
#define REG_FSC_BK30_44_H      0x140089
#define REG_FSC_BK30_45_L      0x14008A
#define REG_FSC_BK30_45_H      0x14008B
#define REG_FSC_BK30_46_L      0x14008C
#define REG_FSC_BK30_46_H      0x14008D
#define REG_FSC_BK30_47_L      0x14008E
#define REG_FSC_BK30_47_H      0x14008F
#define REG_FSC_BK30_48_L      0x140090
#define REG_FSC_BK30_48_H      0x140091
#define REG_FSC_BK30_49_L      0x140092
#define REG_FSC_BK30_49_H      0x140093
#define REG_FSC_BK30_4A_L      0x140094
#define REG_FSC_BK30_4A_H      0x140095
#define REG_FSC_BK30_4B_L      0x140096
#define REG_FSC_BK30_4B_H      0x140097
#define REG_FSC_BK30_4C_L      0x140098
#define REG_FSC_BK30_4C_H      0x140099
#define REG_FSC_BK30_4D_L      0x14009A
#define REG_FSC_BK30_4D_H      0x14009B
#define REG_FSC_BK30_4E_L      0x14009C
#define REG_FSC_BK30_4E_H      0x14009D
#define REG_FSC_BK30_4F_L      0x14009E
#define REG_FSC_BK30_4F_H      0x14009F
#define REG_FSC_BK30_50_L      0x1400A0
#define REG_FSC_BK30_50_H      0x1400A1
#define REG_FSC_BK30_51_L      0x1400A2
#define REG_FSC_BK30_51_H      0x1400A3
#define REG_FSC_BK30_52_L      0x1400A4
#define REG_FSC_BK30_52_H      0x1400A5
#define REG_FSC_BK30_53_L      0x1400A6
#define REG_FSC_BK30_53_H      0x1400A7
#define REG_FSC_BK30_54_L      0x1400A8
#define REG_FSC_BK30_54_H      0x1400A9
#define REG_FSC_BK30_55_L      0x1400AA
#define REG_FSC_BK30_55_H      0x1400AB
#define REG_FSC_BK30_56_L      0x1400AC
#define REG_FSC_BK30_56_H      0x1400AD
#define REG_FSC_BK30_57_L      0x1400AE
#define REG_FSC_BK30_57_H      0x1400AF
#define REG_FSC_BK30_58_L      0x1400B0
#define REG_FSC_BK30_58_H      0x1400B1
#define REG_FSC_BK30_59_L      0x1400B2
#define REG_FSC_BK30_59_H      0x1400B3
#define REG_FSC_BK30_5A_L      0x1400B4
#define REG_FSC_BK30_5A_H      0x1400B5
#define REG_FSC_BK30_5B_L      0x1400B6
#define REG_FSC_BK30_5B_H      0x1400B7
#define REG_FSC_BK30_5C_L      0x1400B8
#define REG_FSC_BK30_5C_H      0x1400B9
#define REG_FSC_BK30_5D_L      0x1400BA
#define REG_FSC_BK30_5D_H      0x1400BB
#define REG_FSC_BK30_5E_L      0x1400BC
#define REG_FSC_BK30_5E_H      0x1400BD
#define REG_FSC_BK30_5F_L      0x1400BE
#define REG_FSC_BK30_5F_H      0x1400BF
#define REG_FSC_BK30_60_L      0x1400C0
#define REG_FSC_BK30_60_H      0x1400C1
#define REG_FSC_BK30_61_L      0x1400C2
#define REG_FSC_BK30_61_H      0x1400C3
#define REG_FSC_BK30_62_L      0x1400C4
#define REG_FSC_BK30_62_H      0x1400C5
#define REG_FSC_BK30_63_L      0x1400C6
#define REG_FSC_BK30_63_H      0x1400C7
#define REG_FSC_BK30_64_L      0x1400C8
#define REG_FSC_BK30_64_H      0x1400C9
#define REG_FSC_BK30_65_L      0x1400CA
#define REG_FSC_BK30_65_H      0x1400CB
#define REG_FSC_BK30_66_L      0x1400CC
#define REG_FSC_BK30_66_H      0x1400CD
#define REG_FSC_BK30_67_L      0x1400CE
#define REG_FSC_BK30_67_H      0x1400CF
#define REG_FSC_BK30_68_L      0x1400D0
#define REG_FSC_BK30_68_H      0x1400D1
#define REG_FSC_BK30_69_L      0x1400D2
#define REG_FSC_BK30_69_H      0x1400D3
#define REG_FSC_BK30_6A_L      0x1400D4
#define REG_FSC_BK30_6A_H      0x1400D5
#define REG_FSC_BK30_6B_L      0x1400D6
#define REG_FSC_BK30_6B_H      0x1400D7
#define REG_FSC_BK30_6C_L      0x1400D8
#define REG_FSC_BK30_6C_H      0x1400D9
#define REG_FSC_BK30_6D_L      0x1400DA
#define REG_FSC_BK30_6D_H      0x1400DB
#define REG_FSC_BK30_6E_L      0x1400DC
#define REG_FSC_BK30_6E_H      0x1400DD
#define REG_FSC_BK30_6F_L      0x1400DE
#define REG_FSC_BK30_6F_H      0x1400DF
#define REG_FSC_BK30_70_L      0x1400E0
#define REG_FSC_BK30_70_H      0x1400E1
#define REG_FSC_BK30_71_L      0x1400E2
#define REG_FSC_BK30_71_H      0x1400E3
#define REG_FSC_BK30_72_L      0x1400E4
#define REG_FSC_BK30_72_H      0x1400E5
#define REG_FSC_BK30_73_L      0x1400E6
#define REG_FSC_BK30_73_H      0x1400E7
#define REG_FSC_BK30_74_L      0x1400E8
#define REG_FSC_BK30_74_H      0x1400E9
#define REG_FSC_BK30_75_L      0x1400EA
#define REG_FSC_BK30_75_H      0x1400EB
#define REG_FSC_BK30_76_L      0x1400EC
#define REG_FSC_BK30_76_H      0x1400ED
#define REG_FSC_BK30_77_L      0x1400EE
#define REG_FSC_BK30_77_H      0x1400EF
#define REG_FSC_BK30_78_L      0x1400F0
#define REG_FSC_BK30_78_H      0x1400F1
#define REG_FSC_BK30_79_L      0x1400F2
#define REG_FSC_BK30_79_H      0x1400F3
#define REG_FSC_BK30_7A_L      0x1400F4
#define REG_FSC_BK30_7A_H      0x1400F5
#define REG_FSC_BK30_7B_L      0x1400F6
#define REG_FSC_BK30_7B_H      0x1400F7
#define REG_FSC_BK30_7C_L      0x1400F8
#define REG_FSC_BK30_7C_H      0x1400F9
#define REG_FSC_BK30_7D_L      0x1400FA
#define REG_FSC_BK30_7D_H      0x1400FB
#define REG_FSC_BK30_7E_L      0x1400FC
#define REG_FSC_BK30_7E_H      0x1400FD
#define REG_FSC_BK30_7F_L      0x1400FE
#define REG_FSC_BK30_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK4C_00_L      0x140000
#define REG_FSC_BK4C_00_H      0x140001
#define REG_FSC_BK4C_01_L      0x140002
#define REG_FSC_BK4C_01_H      0x140003
#define REG_FSC_BK4C_02_L      0x140004
#define REG_FSC_BK4C_02_H      0x140005
#define REG_FSC_BK4C_03_L      0x140006
#define REG_FSC_BK4C_03_H      0x140007
#define REG_FSC_BK4C_04_L      0x140008
#define REG_FSC_BK4C_04_H      0x140009
#define REG_FSC_BK4C_05_L      0x14000A
#define REG_FSC_BK4C_05_H      0x14000B
#define REG_FSC_BK4C_06_L      0x14000C
#define REG_FSC_BK4C_06_H      0x14000D
#define REG_FSC_BK4C_07_L      0x14000E
#define REG_FSC_BK4C_07_H      0x14000F
#define REG_FSC_BK4C_08_L      0x140010
#define REG_FSC_BK4C_08_H      0x140011
#define REG_FSC_BK4C_09_L      0x140012
#define REG_FSC_BK4C_09_H      0x140013
#define REG_FSC_BK4C_0A_L      0x140014
#define REG_FSC_BK4C_0A_H      0x140015
#define REG_FSC_BK4C_0B_L      0x140016
#define REG_FSC_BK4C_0B_H      0x140017
#define REG_FSC_BK4C_0C_L      0x140018
#define REG_FSC_BK4C_0C_H      0x140019
#define REG_FSC_BK4C_0D_L      0x14001A
#define REG_FSC_BK4C_0D_H      0x14001B
#define REG_FSC_BK4C_0E_L      0x14001C
#define REG_FSC_BK4C_0E_H      0x14001D
#define REG_FSC_BK4C_0F_L      0x14001E
#define REG_FSC_BK4C_0F_H      0x14001F
#define REG_FSC_BK4C_10_L      0x140020
#define REG_FSC_BK4C_10_H      0x140021
#define REG_FSC_BK4C_11_L      0x140022
#define REG_FSC_BK4C_11_H      0x140023
#define REG_FSC_BK4C_12_L      0x140024
#define REG_FSC_BK4C_12_H      0x140025
#define REG_FSC_BK4C_13_L      0x140026
#define REG_FSC_BK4C_13_H      0x140027
#define REG_FSC_BK4C_14_L      0x140028
#define REG_FSC_BK4C_14_H      0x140029
#define REG_FSC_BK4C_15_L      0x14002A
#define REG_FSC_BK4C_15_H      0x14002B
#define REG_FSC_BK4C_16_L      0x14002C
#define REG_FSC_BK4C_16_H      0x14002D
#define REG_FSC_BK4C_17_L      0x14002E
#define REG_FSC_BK4C_17_H      0x14002F
#define REG_FSC_BK4C_18_L      0x140030
#define REG_FSC_BK4C_18_H      0x140031
#define REG_FSC_BK4C_19_L      0x140032
#define REG_FSC_BK4C_19_H      0x140033
#define REG_FSC_BK4C_1A_L      0x140034
#define REG_FSC_BK4C_1A_H      0x140035
#define REG_FSC_BK4C_1B_L      0x140036
#define REG_FSC_BK4C_1B_H      0x140037
#define REG_FSC_BK4C_1C_L      0x140038
#define REG_FSC_BK4C_1C_H      0x140039
#define REG_FSC_BK4C_1D_L      0x14003A
#define REG_FSC_BK4C_1D_H      0x14003B
#define REG_FSC_BK4C_1E_L      0x14003C
#define REG_FSC_BK4C_1E_H      0x14003D
#define REG_FSC_BK4C_1F_L      0x14003E
#define REG_FSC_BK4C_1F_H      0x14003F
#define REG_FSC_BK4C_20_L      0x140040
#define REG_FSC_BK4C_20_H      0x140041
#define REG_FSC_BK4C_21_L      0x140042
#define REG_FSC_BK4C_21_H      0x140043
#define REG_FSC_BK4C_22_L      0x140044
#define REG_FSC_BK4C_22_H      0x140045
#define REG_FSC_BK4C_23_L      0x140046
#define REG_FSC_BK4C_23_H      0x140047
#define REG_FSC_BK4C_24_L      0x140048
#define REG_FSC_BK4C_24_H      0x140049
#define REG_FSC_BK4C_25_L      0x14004A
#define REG_FSC_BK4C_25_H      0x14004B
#define REG_FSC_BK4C_26_L      0x14004C
#define REG_FSC_BK4C_26_H      0x14004D
#define REG_FSC_BK4C_27_L      0x14004E
#define REG_FSC_BK4C_27_H      0x14004F
#define REG_FSC_BK4C_28_L      0x140050
#define REG_FSC_BK4C_28_H      0x140051
#define REG_FSC_BK4C_29_L      0x140052
#define REG_FSC_BK4C_29_H      0x140053
#define REG_FSC_BK4C_2A_L      0x140054
#define REG_FSC_BK4C_2A_H      0x140055
#define REG_FSC_BK4C_2B_L      0x140056
#define REG_FSC_BK4C_2B_H      0x140057
#define REG_FSC_BK4C_2C_L      0x140058
#define REG_FSC_BK4C_2C_H      0x140059
#define REG_FSC_BK4C_2D_L      0x14005A
#define REG_FSC_BK4C_2D_H      0x14005B
#define REG_FSC_BK4C_2E_L      0x14005C
#define REG_FSC_BK4C_2E_H      0x14005D
#define REG_FSC_BK4C_2F_L      0x14005E
#define REG_FSC_BK4C_2F_H      0x14005F
#define REG_FSC_BK4C_30_L      0x140060
#define REG_FSC_BK4C_30_H      0x140061
#define REG_FSC_BK4C_31_L      0x140062
#define REG_FSC_BK4C_31_H      0x140063
#define REG_FSC_BK4C_32_L      0x140064
#define REG_FSC_BK4C_32_H      0x140065
#define REG_FSC_BK4C_33_L      0x140066
#define REG_FSC_BK4C_33_H      0x140067
#define REG_FSC_BK4C_34_L      0x140068
#define REG_FSC_BK4C_34_H      0x140069
#define REG_FSC_BK4C_35_L      0x14006A
#define REG_FSC_BK4C_35_H      0x14006B
#define REG_FSC_BK4C_36_L      0x14006C
#define REG_FSC_BK4C_36_H      0x14006D
#define REG_FSC_BK4C_37_L      0x14006E
#define REG_FSC_BK4C_37_H      0x14006F
#define REG_FSC_BK4C_38_L      0x140070
#define REG_FSC_BK4C_38_H      0x140071
#define REG_FSC_BK4C_39_L      0x140072
#define REG_FSC_BK4C_39_H      0x140073
#define REG_FSC_BK4C_3A_L      0x140074
#define REG_FSC_BK4C_3A_H      0x140075
#define REG_FSC_BK4C_3B_L      0x140076
#define REG_FSC_BK4C_3B_H      0x140077
#define REG_FSC_BK4C_3C_L      0x140078
#define REG_FSC_BK4C_3C_H      0x140079
#define REG_FSC_BK4C_3D_L      0x14007A
#define REG_FSC_BK4C_3D_H      0x14007B
#define REG_FSC_BK4C_3E_L      0x14007C
#define REG_FSC_BK4C_3E_H      0x14007D
#define REG_FSC_BK4C_3F_L      0x14007E
#define REG_FSC_BK4C_3F_H      0x14007F
#define REG_FSC_BK4C_40_L      0x140080
#define REG_FSC_BK4C_40_H      0x140081
#define REG_FSC_BK4C_41_L      0x140082
#define REG_FSC_BK4C_41_H      0x140083
#define REG_FSC_BK4C_42_L      0x140084
#define REG_FSC_BK4C_42_H      0x140085
#define REG_FSC_BK4C_43_L      0x140086
#define REG_FSC_BK4C_43_H      0x140087
#define REG_FSC_BK4C_44_L      0x140088
#define REG_FSC_BK4C_44_H      0x140089
#define REG_FSC_BK4C_45_L      0x14008A
#define REG_FSC_BK4C_45_H      0x14008B
#define REG_FSC_BK4C_46_L      0x14008C
#define REG_FSC_BK4C_46_H      0x14008D
#define REG_FSC_BK4C_47_L      0x14008E
#define REG_FSC_BK4C_47_H      0x14008F
#define REG_FSC_BK4C_48_L      0x140090
#define REG_FSC_BK4C_48_H      0x140091
#define REG_FSC_BK4C_49_L      0x140092
#define REG_FSC_BK4C_49_H      0x140093
#define REG_FSC_BK4C_4A_L      0x140094
#define REG_FSC_BK4C_4A_H      0x140095
#define REG_FSC_BK4C_4B_L      0x140096
#define REG_FSC_BK4C_4B_H      0x140097
#define REG_FSC_BK4C_4C_L      0x140098
#define REG_FSC_BK4C_4C_H      0x140099
#define REG_FSC_BK4C_4D_L      0x14009A
#define REG_FSC_BK4C_4D_H      0x14009B
#define REG_FSC_BK4C_4E_L      0x14009C
#define REG_FSC_BK4C_4E_H      0x14009D
#define REG_FSC_BK4C_4F_L      0x14009E
#define REG_FSC_BK4C_4F_H      0x14009F
#define REG_FSC_BK4C_50_L      0x1400A0
#define REG_FSC_BK4C_50_H      0x1400A1
#define REG_FSC_BK4C_51_L      0x1400A2
#define REG_FSC_BK4C_51_H      0x1400A3
#define REG_FSC_BK4C_52_L      0x1400A4
#define REG_FSC_BK4C_52_H      0x1400A5
#define REG_FSC_BK4C_53_L      0x1400A6
#define REG_FSC_BK4C_53_H      0x1400A7
#define REG_FSC_BK4C_54_L      0x1400A8
#define REG_FSC_BK4C_54_H      0x1400A9
#define REG_FSC_BK4C_55_L      0x1400AA
#define REG_FSC_BK4C_55_H      0x1400AB
#define REG_FSC_BK4C_56_L      0x1400AC
#define REG_FSC_BK4C_56_H      0x1400AD
#define REG_FSC_BK4C_57_L      0x1400AE
#define REG_FSC_BK4C_57_H      0x1400AF
#define REG_FSC_BK4C_58_L      0x1400B0
#define REG_FSC_BK4C_58_H      0x1400B1
#define REG_FSC_BK4C_59_L      0x1400B2
#define REG_FSC_BK4C_59_H      0x1400B3
#define REG_FSC_BK4C_5A_L      0x1400B4
#define REG_FSC_BK4C_5A_H      0x1400B5
#define REG_FSC_BK4C_5B_L      0x1400B6
#define REG_FSC_BK4C_5B_H      0x1400B7
#define REG_FSC_BK4C_5C_L      0x1400B8
#define REG_FSC_BK4C_5C_H      0x1400B9
#define REG_FSC_BK4C_5D_L      0x1400BA
#define REG_FSC_BK4C_5D_H      0x1400BB
#define REG_FSC_BK4C_5E_L      0x1400BC
#define REG_FSC_BK4C_5E_H      0x1400BD
#define REG_FSC_BK4C_5F_L      0x1400BE
#define REG_FSC_BK4C_5F_H      0x1400BF
#define REG_FSC_BK4C_60_L      0x1400C0
#define REG_FSC_BK4C_60_H      0x1400C1
#define REG_FSC_BK4C_61_L      0x1400C2
#define REG_FSC_BK4C_61_H      0x1400C3
#define REG_FSC_BK4C_62_L      0x1400C4
#define REG_FSC_BK4C_62_H      0x1400C5
#define REG_FSC_BK4C_63_L      0x1400C6
#define REG_FSC_BK4C_63_H      0x1400C7
#define REG_FSC_BK4C_64_L      0x1400C8
#define REG_FSC_BK4C_64_H      0x1400C9
#define REG_FSC_BK4C_65_L      0x1400CA
#define REG_FSC_BK4C_65_H      0x1400CB
#define REG_FSC_BK4C_66_L      0x1400CC
#define REG_FSC_BK4C_66_H      0x1400CD
#define REG_FSC_BK4C_67_L      0x1400CE
#define REG_FSC_BK4C_67_H      0x1400CF
#define REG_FSC_BK4C_68_L      0x1400D0
#define REG_FSC_BK4C_68_H      0x1400D1
#define REG_FSC_BK4C_69_L      0x1400D2
#define REG_FSC_BK4C_69_H      0x1400D3
#define REG_FSC_BK4C_6A_L      0x1400D4
#define REG_FSC_BK4C_6A_H      0x1400D5
#define REG_FSC_BK4C_6B_L      0x1400D6
#define REG_FSC_BK4C_6B_H      0x1400D7
#define REG_FSC_BK4C_6C_L      0x1400D8
#define REG_FSC_BK4C_6C_H      0x1400D9
#define REG_FSC_BK4C_6D_L      0x1400DA
#define REG_FSC_BK4C_6D_H      0x1400DB
#define REG_FSC_BK4C_6E_L      0x1400DC
#define REG_FSC_BK4C_6E_H      0x1400DD
#define REG_FSC_BK4C_6F_L      0x1400DE
#define REG_FSC_BK4C_6F_H      0x1400DF
#define REG_FSC_BK4C_70_L      0x1400E0
#define REG_FSC_BK4C_70_H      0x1400E1
#define REG_FSC_BK4C_71_L      0x1400E2
#define REG_FSC_BK4C_71_H      0x1400E3
#define REG_FSC_BK4C_72_L      0x1400E4
#define REG_FSC_BK4C_72_H      0x1400E5
#define REG_FSC_BK4C_73_L      0x1400E6
#define REG_FSC_BK4C_73_H      0x1400E7
#define REG_FSC_BK4C_74_L      0x1400E8
#define REG_FSC_BK4C_74_H      0x1400E9
#define REG_FSC_BK4C_75_L      0x1400EA
#define REG_FSC_BK4C_75_H      0x1400EB
#define REG_FSC_BK4C_76_L      0x1400EC
#define REG_FSC_BK4C_76_H      0x1400ED
#define REG_FSC_BK4C_77_L      0x1400EE
#define REG_FSC_BK4C_77_H      0x1400EF
#define REG_FSC_BK4C_78_L      0x1400F0
#define REG_FSC_BK4C_78_H      0x1400F1
#define REG_FSC_BK4C_79_L      0x1400F2
#define REG_FSC_BK4C_79_H      0x1400F3
#define REG_FSC_BK4C_7A_L      0x1400F4
#define REG_FSC_BK4C_7A_H      0x1400F5
#define REG_FSC_BK4C_7B_L      0x1400F6
#define REG_FSC_BK4C_7B_H      0x1400F7
#define REG_FSC_BK4C_7C_L      0x1400F8
#define REG_FSC_BK4C_7C_H      0x1400F9
#define REG_FSC_BK4C_7D_L      0x1400FA
#define REG_FSC_BK4C_7D_H      0x1400FB
#define REG_FSC_BK4C_7E_L      0x1400FC
#define REG_FSC_BK4C_7E_H      0x1400FD
#define REG_FSC_BK4C_7F_L      0x1400FE
#define REG_FSC_BK4C_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK4D_00_L      0x140000
#define REG_FSC_BK4D_00_H      0x140001
#define REG_FSC_BK4D_01_L      0x140002
#define REG_FSC_BK4D_01_H      0x140003
#define REG_FSC_BK4D_02_L      0x140004
#define REG_FSC_BK4D_02_H      0x140005
#define REG_FSC_BK4D_03_L      0x140006
#define REG_FSC_BK4D_03_H      0x140007
#define REG_FSC_BK4D_04_L      0x140008
#define REG_FSC_BK4D_04_H      0x140009
#define REG_FSC_BK4D_05_L      0x14000A
#define REG_FSC_BK4D_05_H      0x14000B
#define REG_FSC_BK4D_06_L      0x14000C
#define REG_FSC_BK4D_06_H      0x14000D
#define REG_FSC_BK4D_07_L      0x14000E
#define REG_FSC_BK4D_07_H      0x14000F
#define REG_FSC_BK4D_08_L      0x140010
#define REG_FSC_BK4D_08_H      0x140011
#define REG_FSC_BK4D_09_L      0x140012
#define REG_FSC_BK4D_09_H      0x140013
#define REG_FSC_BK4D_0A_L      0x140014
#define REG_FSC_BK4D_0A_H      0x140015
#define REG_FSC_BK4D_0B_L      0x140016
#define REG_FSC_BK4D_0B_H      0x140017
#define REG_FSC_BK4D_0C_L      0x140018
#define REG_FSC_BK4D_0C_H      0x140019
#define REG_FSC_BK4D_0D_L      0x14001A
#define REG_FSC_BK4D_0D_H      0x14001B
#define REG_FSC_BK4D_0E_L      0x14001C
#define REG_FSC_BK4D_0E_H      0x14001D
#define REG_FSC_BK4D_0F_L      0x14001E
#define REG_FSC_BK4D_0F_H      0x14001F
#define REG_FSC_BK4D_10_L      0x140020
#define REG_FSC_BK4D_10_H      0x140021
#define REG_FSC_BK4D_11_L      0x140022
#define REG_FSC_BK4D_11_H      0x140023
#define REG_FSC_BK4D_12_L      0x140024
#define REG_FSC_BK4D_12_H      0x140025
#define REG_FSC_BK4D_13_L      0x140026
#define REG_FSC_BK4D_13_H      0x140027
#define REG_FSC_BK4D_14_L      0x140028
#define REG_FSC_BK4D_14_H      0x140029
#define REG_FSC_BK4D_15_L      0x14002A
#define REG_FSC_BK4D_15_H      0x14002B
#define REG_FSC_BK4D_16_L      0x14002C
#define REG_FSC_BK4D_16_H      0x14002D
#define REG_FSC_BK4D_17_L      0x14002E
#define REG_FSC_BK4D_17_H      0x14002F
#define REG_FSC_BK4D_18_L      0x140030
#define REG_FSC_BK4D_18_H      0x140031
#define REG_FSC_BK4D_19_L      0x140032
#define REG_FSC_BK4D_19_H      0x140033
#define REG_FSC_BK4D_1A_L      0x140034
#define REG_FSC_BK4D_1A_H      0x140035
#define REG_FSC_BK4D_1B_L      0x140036
#define REG_FSC_BK4D_1B_H      0x140037
#define REG_FSC_BK4D_1C_L      0x140038
#define REG_FSC_BK4D_1C_H      0x140039
#define REG_FSC_BK4D_1D_L      0x14003A
#define REG_FSC_BK4D_1D_H      0x14003B
#define REG_FSC_BK4D_1E_L      0x14003C
#define REG_FSC_BK4D_1E_H      0x14003D
#define REG_FSC_BK4D_1F_L      0x14003E
#define REG_FSC_BK4D_1F_H      0x14003F
#define REG_FSC_BK4D_20_L      0x140040
#define REG_FSC_BK4D_20_H      0x140041
#define REG_FSC_BK4D_21_L      0x140042
#define REG_FSC_BK4D_21_H      0x140043
#define REG_FSC_BK4D_22_L      0x140044
#define REG_FSC_BK4D_22_H      0x140045
#define REG_FSC_BK4D_23_L      0x140046
#define REG_FSC_BK4D_23_H      0x140047
#define REG_FSC_BK4D_24_L      0x140048
#define REG_FSC_BK4D_24_H      0x140049
#define REG_FSC_BK4D_25_L      0x14004A
#define REG_FSC_BK4D_25_H      0x14004B
#define REG_FSC_BK4D_26_L      0x14004C
#define REG_FSC_BK4D_26_H      0x14004D
#define REG_FSC_BK4D_27_L      0x14004E
#define REG_FSC_BK4D_27_H      0x14004F
#define REG_FSC_BK4D_28_L      0x140050
#define REG_FSC_BK4D_28_H      0x140051
#define REG_FSC_BK4D_29_L      0x140052
#define REG_FSC_BK4D_29_H      0x140053
#define REG_FSC_BK4D_2A_L      0x140054
#define REG_FSC_BK4D_2A_H      0x140055
#define REG_FSC_BK4D_2B_L      0x140056
#define REG_FSC_BK4D_2B_H      0x140057
#define REG_FSC_BK4D_2C_L      0x140058
#define REG_FSC_BK4D_2C_H      0x140059
#define REG_FSC_BK4D_2D_L      0x14005A
#define REG_FSC_BK4D_2D_H      0x14005B
#define REG_FSC_BK4D_2E_L      0x14005C
#define REG_FSC_BK4D_2E_H      0x14005D
#define REG_FSC_BK4D_2F_L      0x14005E
#define REG_FSC_BK4D_2F_H      0x14005F
#define REG_FSC_BK4D_30_L      0x140060
#define REG_FSC_BK4D_30_H      0x140061
#define REG_FSC_BK4D_31_L      0x140062
#define REG_FSC_BK4D_31_H      0x140063
#define REG_FSC_BK4D_32_L      0x140064
#define REG_FSC_BK4D_32_H      0x140065
#define REG_FSC_BK4D_33_L      0x140066
#define REG_FSC_BK4D_33_H      0x140067
#define REG_FSC_BK4D_34_L      0x140068
#define REG_FSC_BK4D_34_H      0x140069
#define REG_FSC_BK4D_35_L      0x14006A
#define REG_FSC_BK4D_35_H      0x14006B
#define REG_FSC_BK4D_36_L      0x14006C
#define REG_FSC_BK4D_36_H      0x14006D
#define REG_FSC_BK4D_37_L      0x14006E
#define REG_FSC_BK4D_37_H      0x14006F
#define REG_FSC_BK4D_38_L      0x140070
#define REG_FSC_BK4D_38_H      0x140071
#define REG_FSC_BK4D_39_L      0x140072
#define REG_FSC_BK4D_39_H      0x140073
#define REG_FSC_BK4D_3A_L      0x140074
#define REG_FSC_BK4D_3A_H      0x140075
#define REG_FSC_BK4D_3B_L      0x140076
#define REG_FSC_BK4D_3B_H      0x140077
#define REG_FSC_BK4D_3C_L      0x140078
#define REG_FSC_BK4D_3C_H      0x140079
#define REG_FSC_BK4D_3D_L      0x14007A
#define REG_FSC_BK4D_3D_H      0x14007B
#define REG_FSC_BK4D_3E_L      0x14007C
#define REG_FSC_BK4D_3E_H      0x14007D
#define REG_FSC_BK4D_3F_L      0x14007E
#define REG_FSC_BK4D_3F_H      0x14007F
#define REG_FSC_BK4D_40_L      0x140080
#define REG_FSC_BK4D_40_H      0x140081
#define REG_FSC_BK4D_41_L      0x140082
#define REG_FSC_BK4D_41_H      0x140083
#define REG_FSC_BK4D_42_L      0x140084
#define REG_FSC_BK4D_42_H      0x140085
#define REG_FSC_BK4D_43_L      0x140086
#define REG_FSC_BK4D_43_H      0x140087
#define REG_FSC_BK4D_44_L      0x140088
#define REG_FSC_BK4D_44_H      0x140089
#define REG_FSC_BK4D_45_L      0x14008A
#define REG_FSC_BK4D_45_H      0x14008B
#define REG_FSC_BK4D_46_L      0x14008C
#define REG_FSC_BK4D_46_H      0x14008D
#define REG_FSC_BK4D_47_L      0x14008E
#define REG_FSC_BK4D_47_H      0x14008F
#define REG_FSC_BK4D_48_L      0x140090
#define REG_FSC_BK4D_48_H      0x140091
#define REG_FSC_BK4D_49_L      0x140092
#define REG_FSC_BK4D_49_H      0x140093
#define REG_FSC_BK4D_4A_L      0x140094
#define REG_FSC_BK4D_4A_H      0x140095
#define REG_FSC_BK4D_4B_L      0x140096
#define REG_FSC_BK4D_4B_H      0x140097
#define REG_FSC_BK4D_4C_L      0x140098
#define REG_FSC_BK4D_4C_H      0x140099
#define REG_FSC_BK4D_4D_L      0x14009A
#define REG_FSC_BK4D_4D_H      0x14009B
#define REG_FSC_BK4D_4E_L      0x14009C
#define REG_FSC_BK4D_4E_H      0x14009D
#define REG_FSC_BK4D_4F_L      0x14009E
#define REG_FSC_BK4D_4F_H      0x14009F
#define REG_FSC_BK4D_50_L      0x1400A0
#define REG_FSC_BK4D_50_H      0x1400A1
#define REG_FSC_BK4D_51_L      0x1400A2
#define REG_FSC_BK4D_51_H      0x1400A3
#define REG_FSC_BK4D_52_L      0x1400A4
#define REG_FSC_BK4D_52_H      0x1400A5
#define REG_FSC_BK4D_53_L      0x1400A6
#define REG_FSC_BK4D_53_H      0x1400A7
#define REG_FSC_BK4D_54_L      0x1400A8
#define REG_FSC_BK4D_54_H      0x1400A9
#define REG_FSC_BK4D_55_L      0x1400AA
#define REG_FSC_BK4D_55_H      0x1400AB
#define REG_FSC_BK4D_56_L      0x1400AC
#define REG_FSC_BK4D_56_H      0x1400AD
#define REG_FSC_BK4D_57_L      0x1400AE
#define REG_FSC_BK4D_57_H      0x1400AF
#define REG_FSC_BK4D_58_L      0x1400B0
#define REG_FSC_BK4D_58_H      0x1400B1
#define REG_FSC_BK4D_59_L      0x1400B2
#define REG_FSC_BK4D_59_H      0x1400B3
#define REG_FSC_BK4D_5A_L      0x1400B4
#define REG_FSC_BK4D_5A_H      0x1400B5
#define REG_FSC_BK4D_5B_L      0x1400B6
#define REG_FSC_BK4D_5B_H      0x1400B7
#define REG_FSC_BK4D_5C_L      0x1400B8
#define REG_FSC_BK4D_5C_H      0x1400B9
#define REG_FSC_BK4D_5D_L      0x1400BA
#define REG_FSC_BK4D_5D_H      0x1400BB
#define REG_FSC_BK4D_5E_L      0x1400BC
#define REG_FSC_BK4D_5E_H      0x1400BD
#define REG_FSC_BK4D_5F_L      0x1400BE
#define REG_FSC_BK4D_5F_H      0x1400BF
#define REG_FSC_BK4D_60_L      0x1400C0
#define REG_FSC_BK4D_60_H      0x1400C1
#define REG_FSC_BK4D_61_L      0x1400C2
#define REG_FSC_BK4D_61_H      0x1400C3
#define REG_FSC_BK4D_62_L      0x1400C4
#define REG_FSC_BK4D_62_H      0x1400C5
#define REG_FSC_BK4D_63_L      0x1400C6
#define REG_FSC_BK4D_63_H      0x1400C7
#define REG_FSC_BK4D_64_L      0x1400C8
#define REG_FSC_BK4D_64_H      0x1400C9
#define REG_FSC_BK4D_65_L      0x1400CA
#define REG_FSC_BK4D_65_H      0x1400CB
#define REG_FSC_BK4D_66_L      0x1400CC
#define REG_FSC_BK4D_66_H      0x1400CD
#define REG_FSC_BK4D_67_L      0x1400CE
#define REG_FSC_BK4D_67_H      0x1400CF
#define REG_FSC_BK4D_68_L      0x1400D0
#define REG_FSC_BK4D_68_H      0x1400D1
#define REG_FSC_BK4D_69_L      0x1400D2
#define REG_FSC_BK4D_69_H      0x1400D3
#define REG_FSC_BK4D_6A_L      0x1400D4
#define REG_FSC_BK4D_6A_H      0x1400D5
#define REG_FSC_BK4D_6B_L      0x1400D6
#define REG_FSC_BK4D_6B_H      0x1400D7
#define REG_FSC_BK4D_6C_L      0x1400D8
#define REG_FSC_BK4D_6C_H      0x1400D9
#define REG_FSC_BK4D_6D_L      0x1400DA
#define REG_FSC_BK4D_6D_H      0x1400DB
#define REG_FSC_BK4D_6E_L      0x1400DC
#define REG_FSC_BK4D_6E_H      0x1400DD
#define REG_FSC_BK4D_6F_L      0x1400DE
#define REG_FSC_BK4D_6F_H      0x1400DF
#define REG_FSC_BK4D_70_L      0x1400E0
#define REG_FSC_BK4D_70_H      0x1400E1
#define REG_FSC_BK4D_71_L      0x1400E2
#define REG_FSC_BK4D_71_H      0x1400E3
#define REG_FSC_BK4D_72_L      0x1400E4
#define REG_FSC_BK4D_72_H      0x1400E5
#define REG_FSC_BK4D_73_L      0x1400E6
#define REG_FSC_BK4D_73_H      0x1400E7
#define REG_FSC_BK4D_74_L      0x1400E8
#define REG_FSC_BK4D_74_H      0x1400E9
#define REG_FSC_BK4D_75_L      0x1400EA
#define REG_FSC_BK4D_75_H      0x1400EB
#define REG_FSC_BK4D_76_L      0x1400EC
#define REG_FSC_BK4D_76_H      0x1400ED
#define REG_FSC_BK4D_77_L      0x1400EE
#define REG_FSC_BK4D_77_H      0x1400EF
#define REG_FSC_BK4D_78_L      0x1400F0
#define REG_FSC_BK4D_78_H      0x1400F1
#define REG_FSC_BK4D_79_L      0x1400F2
#define REG_FSC_BK4D_79_H      0x1400F3
#define REG_FSC_BK4D_7A_L      0x1400F4
#define REG_FSC_BK4D_7A_H      0x1400F5
#define REG_FSC_BK4D_7B_L      0x1400F6
#define REG_FSC_BK4D_7B_H      0x1400F7
#define REG_FSC_BK4D_7C_L      0x1400F8
#define REG_FSC_BK4D_7C_H      0x1400F9
#define REG_FSC_BK4D_7D_L      0x1400FA
#define REG_FSC_BK4D_7D_H      0x1400FB
#define REG_FSC_BK4D_7E_L      0x1400FC
#define REG_FSC_BK4D_7E_H      0x1400FD
#define REG_FSC_BK4D_7F_L      0x1400FE
#define REG_FSC_BK4D_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK4F_00_L      0x140000
#define REG_FSC_BK4F_00_H      0x140001
#define REG_FSC_BK4F_01_L      0x140002
#define REG_FSC_BK4F_01_H      0x140003
#define REG_FSC_BK4F_02_L      0x140004
#define REG_FSC_BK4F_02_H      0x140005
#define REG_FSC_BK4F_03_L      0x140006
#define REG_FSC_BK4F_03_H      0x140007
#define REG_FSC_BK4F_04_L      0x140008
#define REG_FSC_BK4F_04_H      0x140009
#define REG_FSC_BK4F_05_L      0x14000A
#define REG_FSC_BK4F_05_H      0x14000B
#define REG_FSC_BK4F_06_L      0x14000C
#define REG_FSC_BK4F_06_H      0x14000D
#define REG_FSC_BK4F_07_L      0x14000E
#define REG_FSC_BK4F_07_H      0x14000F
#define REG_FSC_BK4F_08_L      0x140010
#define REG_FSC_BK4F_08_H      0x140011
#define REG_FSC_BK4F_09_L      0x140012
#define REG_FSC_BK4F_09_H      0x140013
#define REG_FSC_BK4F_0A_L      0x140014
#define REG_FSC_BK4F_0A_H      0x140015
#define REG_FSC_BK4F_0B_L      0x140016
#define REG_FSC_BK4F_0B_H      0x140017
#define REG_FSC_BK4F_0C_L      0x140018
#define REG_FSC_BK4F_0C_H      0x140019
#define REG_FSC_BK4F_0D_L      0x14001A
#define REG_FSC_BK4F_0D_H      0x14001B
#define REG_FSC_BK4F_0E_L      0x14001C
#define REG_FSC_BK4F_0E_H      0x14001D
#define REG_FSC_BK4F_0F_L      0x14001E
#define REG_FSC_BK4F_0F_H      0x14001F
#define REG_FSC_BK4F_10_L      0x140020
#define REG_FSC_BK4F_10_H      0x140021
#define REG_FSC_BK4F_11_L      0x140022
#define REG_FSC_BK4F_11_H      0x140023
#define REG_FSC_BK4F_12_L      0x140024
#define REG_FSC_BK4F_12_H      0x140025
#define REG_FSC_BK4F_13_L      0x140026
#define REG_FSC_BK4F_13_H      0x140027
#define REG_FSC_BK4F_14_L      0x140028
#define REG_FSC_BK4F_14_H      0x140029
#define REG_FSC_BK4F_15_L      0x14002A
#define REG_FSC_BK4F_15_H      0x14002B
#define REG_FSC_BK4F_16_L      0x14002C
#define REG_FSC_BK4F_16_H      0x14002D
#define REG_FSC_BK4F_17_L      0x14002E
#define REG_FSC_BK4F_17_H      0x14002F
#define REG_FSC_BK4F_18_L      0x140030
#define REG_FSC_BK4F_18_H      0x140031
#define REG_FSC_BK4F_19_L      0x140032
#define REG_FSC_BK4F_19_H      0x140033
#define REG_FSC_BK4F_1A_L      0x140034
#define REG_FSC_BK4F_1A_H      0x140035
#define REG_FSC_BK4F_1B_L      0x140036
#define REG_FSC_BK4F_1B_H      0x140037
#define REG_FSC_BK4F_1C_L      0x140038
#define REG_FSC_BK4F_1C_H      0x140039
#define REG_FSC_BK4F_1D_L      0x14003A
#define REG_FSC_BK4F_1D_H      0x14003B
#define REG_FSC_BK4F_1E_L      0x14003C
#define REG_FSC_BK4F_1E_H      0x14003D
#define REG_FSC_BK4F_1F_L      0x14003E
#define REG_FSC_BK4F_1F_H      0x14003F
#define REG_FSC_BK4F_20_L      0x140040
#define REG_FSC_BK4F_20_H      0x140041
#define REG_FSC_BK4F_21_L      0x140042
#define REG_FSC_BK4F_21_H      0x140043
#define REG_FSC_BK4F_22_L      0x140044
#define REG_FSC_BK4F_22_H      0x140045
#define REG_FSC_BK4F_23_L      0x140046
#define REG_FSC_BK4F_23_H      0x140047
#define REG_FSC_BK4F_24_L      0x140048
#define REG_FSC_BK4F_24_H      0x140049
#define REG_FSC_BK4F_25_L      0x14004A
#define REG_FSC_BK4F_25_H      0x14004B
#define REG_FSC_BK4F_26_L      0x14004C
#define REG_FSC_BK4F_26_H      0x14004D
#define REG_FSC_BK4F_27_L      0x14004E
#define REG_FSC_BK4F_27_H      0x14004F
#define REG_FSC_BK4F_28_L      0x140050
#define REG_FSC_BK4F_28_H      0x140051
#define REG_FSC_BK4F_29_L      0x140052
#define REG_FSC_BK4F_29_H      0x140053
#define REG_FSC_BK4F_2A_L      0x140054
#define REG_FSC_BK4F_2A_H      0x140055
#define REG_FSC_BK4F_2B_L      0x140056
#define REG_FSC_BK4F_2B_H      0x140057
#define REG_FSC_BK4F_2C_L      0x140058
#define REG_FSC_BK4F_2C_H      0x140059
#define REG_FSC_BK4F_2D_L      0x14005A
#define REG_FSC_BK4F_2D_H      0x14005B
#define REG_FSC_BK4F_2E_L      0x14005C
#define REG_FSC_BK4F_2E_H      0x14005D
#define REG_FSC_BK4F_2F_L      0x14005E
#define REG_FSC_BK4F_2F_H      0x14005F
#define REG_FSC_BK4F_30_L      0x140060
#define REG_FSC_BK4F_30_H      0x140061
#define REG_FSC_BK4F_31_L      0x140062
#define REG_FSC_BK4F_31_H      0x140063
#define REG_FSC_BK4F_32_L      0x140064
#define REG_FSC_BK4F_32_H      0x140065
#define REG_FSC_BK4F_33_L      0x140066
#define REG_FSC_BK4F_33_H      0x140067
#define REG_FSC_BK4F_34_L      0x140068
#define REG_FSC_BK4F_34_H      0x140069
#define REG_FSC_BK4F_35_L      0x14006A
#define REG_FSC_BK4F_35_H      0x14006B
#define REG_FSC_BK4F_36_L      0x14006C
#define REG_FSC_BK4F_36_H      0x14006D
#define REG_FSC_BK4F_37_L      0x14006E
#define REG_FSC_BK4F_37_H      0x14006F
#define REG_FSC_BK4F_38_L      0x140070
#define REG_FSC_BK4F_38_H      0x140071
#define REG_FSC_BK4F_39_L      0x140072
#define REG_FSC_BK4F_39_H      0x140073
#define REG_FSC_BK4F_3A_L      0x140074
#define REG_FSC_BK4F_3A_H      0x140075
#define REG_FSC_BK4F_3B_L      0x140076
#define REG_FSC_BK4F_3B_H      0x140077
#define REG_FSC_BK4F_3C_L      0x140078
#define REG_FSC_BK4F_3C_H      0x140079
#define REG_FSC_BK4F_3D_L      0x14007A
#define REG_FSC_BK4F_3D_H      0x14007B
#define REG_FSC_BK4F_3E_L      0x14007C
#define REG_FSC_BK4F_3E_H      0x14007D
#define REG_FSC_BK4F_3F_L      0x14007E
#define REG_FSC_BK4F_3F_H      0x14007F
#define REG_FSC_BK4F_40_L      0x140080
#define REG_FSC_BK4F_40_H      0x140081
#define REG_FSC_BK4F_41_L      0x140082
#define REG_FSC_BK4F_41_H      0x140083
#define REG_FSC_BK4F_42_L      0x140084
#define REG_FSC_BK4F_42_H      0x140085
#define REG_FSC_BK4F_43_L      0x140086
#define REG_FSC_BK4F_43_H      0x140087
#define REG_FSC_BK4F_44_L      0x140088
#define REG_FSC_BK4F_44_H      0x140089
#define REG_FSC_BK4F_45_L      0x14008A
#define REG_FSC_BK4F_45_H      0x14008B
#define REG_FSC_BK4F_46_L      0x14008C
#define REG_FSC_BK4F_46_H      0x14008D
#define REG_FSC_BK4F_47_L      0x14008E
#define REG_FSC_BK4F_47_H      0x14008F
#define REG_FSC_BK4F_48_L      0x140090
#define REG_FSC_BK4F_48_H      0x140091
#define REG_FSC_BK4F_49_L      0x140092
#define REG_FSC_BK4F_49_H      0x140093
#define REG_FSC_BK4F_4A_L      0x140094
#define REG_FSC_BK4F_4A_H      0x140095
#define REG_FSC_BK4F_4B_L      0x140096
#define REG_FSC_BK4F_4B_H      0x140097
#define REG_FSC_BK4F_4C_L      0x140098
#define REG_FSC_BK4F_4C_H      0x140099
#define REG_FSC_BK4F_4D_L      0x14009A
#define REG_FSC_BK4F_4D_H      0x14009B
#define REG_FSC_BK4F_4E_L      0x14009C
#define REG_FSC_BK4F_4E_H      0x14009D
#define REG_FSC_BK4F_4F_L      0x14009E
#define REG_FSC_BK4F_4F_H      0x14009F
#define REG_FSC_BK4F_50_L      0x1400A0
#define REG_FSC_BK4F_50_H      0x1400A1
#define REG_FSC_BK4F_51_L      0x1400A2
#define REG_FSC_BK4F_51_H      0x1400A3
#define REG_FSC_BK4F_52_L      0x1400A4
#define REG_FSC_BK4F_52_H      0x1400A5
#define REG_FSC_BK4F_53_L      0x1400A6
#define REG_FSC_BK4F_53_H      0x1400A7
#define REG_FSC_BK4F_54_L      0x1400A8
#define REG_FSC_BK4F_54_H      0x1400A9
#define REG_FSC_BK4F_55_L      0x1400AA
#define REG_FSC_BK4F_55_H      0x1400AB
#define REG_FSC_BK4F_56_L      0x1400AC
#define REG_FSC_BK4F_56_H      0x1400AD
#define REG_FSC_BK4F_57_L      0x1400AE
#define REG_FSC_BK4F_57_H      0x1400AF
#define REG_FSC_BK4F_58_L      0x1400B0
#define REG_FSC_BK4F_58_H      0x1400B1
#define REG_FSC_BK4F_59_L      0x1400B2
#define REG_FSC_BK4F_59_H      0x1400B3
#define REG_FSC_BK4F_5A_L      0x1400B4
#define REG_FSC_BK4F_5A_H      0x1400B5
#define REG_FSC_BK4F_5B_L      0x1400B6
#define REG_FSC_BK4F_5B_H      0x1400B7
#define REG_FSC_BK4F_5C_L      0x1400B8
#define REG_FSC_BK4F_5C_H      0x1400B9
#define REG_FSC_BK4F_5D_L      0x1400BA
#define REG_FSC_BK4F_5D_H      0x1400BB
#define REG_FSC_BK4F_5E_L      0x1400BC
#define REG_FSC_BK4F_5E_H      0x1400BD
#define REG_FSC_BK4F_5F_L      0x1400BE
#define REG_FSC_BK4F_5F_H      0x1400BF
#define REG_FSC_BK4F_60_L      0x1400C0
#define REG_FSC_BK4F_60_H      0x1400C1
#define REG_FSC_BK4F_61_L      0x1400C2
#define REG_FSC_BK4F_61_H      0x1400C3
#define REG_FSC_BK4F_62_L      0x1400C4
#define REG_FSC_BK4F_62_H      0x1400C5
#define REG_FSC_BK4F_63_L      0x1400C6
#define REG_FSC_BK4F_63_H      0x1400C7
#define REG_FSC_BK4F_64_L      0x1400C8
#define REG_FSC_BK4F_64_H      0x1400C9
#define REG_FSC_BK4F_65_L      0x1400CA
#define REG_FSC_BK4F_65_H      0x1400CB
#define REG_FSC_BK4F_66_L      0x1400CC
#define REG_FSC_BK4F_66_H      0x1400CD
#define REG_FSC_BK4F_67_L      0x1400CE
#define REG_FSC_BK4F_67_H      0x1400CF
#define REG_FSC_BK4F_68_L      0x1400D0
#define REG_FSC_BK4F_68_H      0x1400D1
#define REG_FSC_BK4F_69_L      0x1400D2
#define REG_FSC_BK4F_69_H      0x1400D3
#define REG_FSC_BK4F_6A_L      0x1400D4
#define REG_FSC_BK4F_6A_H      0x1400D5
#define REG_FSC_BK4F_6B_L      0x1400D6
#define REG_FSC_BK4F_6B_H      0x1400D7
#define REG_FSC_BK4F_6C_L      0x1400D8
#define REG_FSC_BK4F_6C_H      0x1400D9
#define REG_FSC_BK4F_6D_L      0x1400DA
#define REG_FSC_BK4F_6D_H      0x1400DB
#define REG_FSC_BK4F_6E_L      0x1400DC
#define REG_FSC_BK4F_6E_H      0x1400DD
#define REG_FSC_BK4F_6F_L      0x1400DE
#define REG_FSC_BK4F_6F_H      0x1400DF
#define REG_FSC_BK4F_70_L      0x1400E0
#define REG_FSC_BK4F_70_H      0x1400E1
#define REG_FSC_BK4F_71_L      0x1400E2
#define REG_FSC_BK4F_71_H      0x1400E3
#define REG_FSC_BK4F_72_L      0x1400E4
#define REG_FSC_BK4F_72_H      0x1400E5
#define REG_FSC_BK4F_73_L      0x1400E6
#define REG_FSC_BK4F_73_H      0x1400E7
#define REG_FSC_BK4F_74_L      0x1400E8
#define REG_FSC_BK4F_74_H      0x1400E9
#define REG_FSC_BK4F_75_L      0x1400EA
#define REG_FSC_BK4F_75_H      0x1400EB
#define REG_FSC_BK4F_76_L      0x1400EC
#define REG_FSC_BK4F_76_H      0x1400ED
#define REG_FSC_BK4F_77_L      0x1400EE
#define REG_FSC_BK4F_77_H      0x1400EF
#define REG_FSC_BK4F_78_L      0x1400F0
#define REG_FSC_BK4F_78_H      0x1400F1
#define REG_FSC_BK4F_79_L      0x1400F2
#define REG_FSC_BK4F_79_H      0x1400F3
#define REG_FSC_BK4F_7A_L      0x1400F4
#define REG_FSC_BK4F_7A_H      0x1400F5
#define REG_FSC_BK4F_7B_L      0x1400F6
#define REG_FSC_BK4F_7B_H      0x1400F7
#define REG_FSC_BK4F_7C_L      0x1400F8
#define REG_FSC_BK4F_7C_H      0x1400F9
#define REG_FSC_BK4F_7D_L      0x1400FA
#define REG_FSC_BK4F_7D_H      0x1400FB
#define REG_FSC_BK4F_7E_L      0x1400FC
#define REG_FSC_BK4F_7E_H      0x1400FD
#define REG_FSC_BK4F_7F_L      0x1400FE
#define REG_FSC_BK4F_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK55_00_L      0x140000
#define REG_FSC_BK55_00_H      0x140001
#define REG_FSC_BK55_01_L      0x140002
#define REG_FSC_BK55_01_H      0x140003
#define REG_FSC_BK55_02_L      0x140004
#define REG_FSC_BK55_02_H      0x140005
#define REG_FSC_BK55_03_L      0x140006
#define REG_FSC_BK55_03_H      0x140007
#define REG_FSC_BK55_04_L      0x140008
#define REG_FSC_BK55_04_H      0x140009
#define REG_FSC_BK55_05_L      0x14000A
#define REG_FSC_BK55_05_H      0x14000B
#define REG_FSC_BK55_06_L      0x14000C
#define REG_FSC_BK55_06_H      0x14000D
#define REG_FSC_BK55_07_L      0x14000E
#define REG_FSC_BK55_07_H      0x14000F
#define REG_FSC_BK55_08_L      0x140010
#define REG_FSC_BK55_08_H      0x140011
#define REG_FSC_BK55_09_L      0x140012
#define REG_FSC_BK55_09_H      0x140013
#define REG_FSC_BK55_0A_L      0x140014
#define REG_FSC_BK55_0A_H      0x140015
#define REG_FSC_BK55_0B_L      0x140016
#define REG_FSC_BK55_0B_H      0x140017
#define REG_FSC_BK55_0C_L      0x140018
#define REG_FSC_BK55_0C_H      0x140019
#define REG_FSC_BK55_0D_L      0x14001A
#define REG_FSC_BK55_0D_H      0x14001B
#define REG_FSC_BK55_0E_L      0x14001C
#define REG_FSC_BK55_0E_H      0x14001D
#define REG_FSC_BK55_0F_L      0x14001E
#define REG_FSC_BK55_0F_H      0x14001F
#define REG_FSC_BK55_10_L      0x140020
#define REG_FSC_BK55_10_H      0x140021
#define REG_FSC_BK55_11_L      0x140022
#define REG_FSC_BK55_11_H      0x140023
#define REG_FSC_BK55_12_L      0x140024
#define REG_FSC_BK55_12_H      0x140025
#define REG_FSC_BK55_13_L      0x140026
#define REG_FSC_BK55_13_H      0x140027
#define REG_FSC_BK55_14_L      0x140028
#define REG_FSC_BK55_14_H      0x140029
#define REG_FSC_BK55_15_L      0x14002A
#define REG_FSC_BK55_15_H      0x14002B
#define REG_FSC_BK55_16_L      0x14002C
#define REG_FSC_BK55_16_H      0x14002D
#define REG_FSC_BK55_17_L      0x14002E
#define REG_FSC_BK55_17_H      0x14002F
#define REG_FSC_BK55_18_L      0x140030
#define REG_FSC_BK55_18_H      0x140031
#define REG_FSC_BK55_19_L      0x140032
#define REG_FSC_BK55_19_H      0x140033
#define REG_FSC_BK55_1A_L      0x140034
#define REG_FSC_BK55_1A_H      0x140035
#define REG_FSC_BK55_1B_L      0x140036
#define REG_FSC_BK55_1B_H      0x140037
#define REG_FSC_BK55_1C_L      0x140038
#define REG_FSC_BK55_1C_H      0x140039
#define REG_FSC_BK55_1D_L      0x14003A
#define REG_FSC_BK55_1D_H      0x14003B
#define REG_FSC_BK55_1E_L      0x14003C
#define REG_FSC_BK55_1E_H      0x14003D
#define REG_FSC_BK55_1F_L      0x14003E
#define REG_FSC_BK55_1F_H      0x14003F
#define REG_FSC_BK55_20_L      0x140040
#define REG_FSC_BK55_20_H      0x140041
#define REG_FSC_BK55_21_L      0x140042
#define REG_FSC_BK55_21_H      0x140043
#define REG_FSC_BK55_22_L      0x140044
#define REG_FSC_BK55_22_H      0x140045
#define REG_FSC_BK55_23_L      0x140046
#define REG_FSC_BK55_23_H      0x140047
#define REG_FSC_BK55_24_L      0x140048
#define REG_FSC_BK55_24_H      0x140049
#define REG_FSC_BK55_25_L      0x14004A
#define REG_FSC_BK55_25_H      0x14004B
#define REG_FSC_BK55_26_L      0x14004C
#define REG_FSC_BK55_26_H      0x14004D
#define REG_FSC_BK55_27_L      0x14004E
#define REG_FSC_BK55_27_H      0x14004F
#define REG_FSC_BK55_28_L      0x140050
#define REG_FSC_BK55_28_H      0x140051
#define REG_FSC_BK55_29_L      0x140052
#define REG_FSC_BK55_29_H      0x140053
#define REG_FSC_BK55_2A_L      0x140054
#define REG_FSC_BK55_2A_H      0x140055
#define REG_FSC_BK55_2B_L      0x140056
#define REG_FSC_BK55_2B_H      0x140057
#define REG_FSC_BK55_2C_L      0x140058
#define REG_FSC_BK55_2C_H      0x140059
#define REG_FSC_BK55_2D_L      0x14005A
#define REG_FSC_BK55_2D_H      0x14005B
#define REG_FSC_BK55_2E_L      0x14005C
#define REG_FSC_BK55_2E_H      0x14005D
#define REG_FSC_BK55_2F_L      0x14005E
#define REG_FSC_BK55_2F_H      0x14005F
#define REG_FSC_BK55_30_L      0x140060
#define REG_FSC_BK55_30_H      0x140061
#define REG_FSC_BK55_31_L      0x140062
#define REG_FSC_BK55_31_H      0x140063
#define REG_FSC_BK55_32_L      0x140064
#define REG_FSC_BK55_32_H      0x140065
#define REG_FSC_BK55_33_L      0x140066
#define REG_FSC_BK55_33_H      0x140067
#define REG_FSC_BK55_34_L      0x140068
#define REG_FSC_BK55_34_H      0x140069
#define REG_FSC_BK55_35_L      0x14006A
#define REG_FSC_BK55_35_H      0x14006B
#define REG_FSC_BK55_36_L      0x14006C
#define REG_FSC_BK55_36_H      0x14006D
#define REG_FSC_BK55_37_L      0x14006E
#define REG_FSC_BK55_37_H      0x14006F
#define REG_FSC_BK55_38_L      0x140070
#define REG_FSC_BK55_38_H      0x140071
#define REG_FSC_BK55_39_L      0x140072
#define REG_FSC_BK55_39_H      0x140073
#define REG_FSC_BK55_3A_L      0x140074
#define REG_FSC_BK55_3A_H      0x140075
#define REG_FSC_BK55_3B_L      0x140076
#define REG_FSC_BK55_3B_H      0x140077
#define REG_FSC_BK55_3C_L      0x140078
#define REG_FSC_BK55_3C_H      0x140079
#define REG_FSC_BK55_3D_L      0x14007A
#define REG_FSC_BK55_3D_H      0x14007B
#define REG_FSC_BK55_3E_L      0x14007C
#define REG_FSC_BK55_3E_H      0x14007D
#define REG_FSC_BK55_3F_L      0x14007E
#define REG_FSC_BK55_3F_H      0x14007F
#define REG_FSC_BK55_40_L      0x140080
#define REG_FSC_BK55_40_H      0x140081
#define REG_FSC_BK55_41_L      0x140082
#define REG_FSC_BK55_41_H      0x140083
#define REG_FSC_BK55_42_L      0x140084
#define REG_FSC_BK55_42_H      0x140085
#define REG_FSC_BK55_43_L      0x140086
#define REG_FSC_BK55_43_H      0x140087
#define REG_FSC_BK55_44_L      0x140088
#define REG_FSC_BK55_44_H      0x140089
#define REG_FSC_BK55_45_L      0x14008A
#define REG_FSC_BK55_45_H      0x14008B
#define REG_FSC_BK55_46_L      0x14008C
#define REG_FSC_BK55_46_H      0x14008D
#define REG_FSC_BK55_47_L      0x14008E
#define REG_FSC_BK55_47_H      0x14008F
#define REG_FSC_BK55_48_L      0x140090
#define REG_FSC_BK55_48_H      0x140091
#define REG_FSC_BK55_49_L      0x140092
#define REG_FSC_BK55_49_H      0x140093
#define REG_FSC_BK55_4A_L      0x140094
#define REG_FSC_BK55_4A_H      0x140095
#define REG_FSC_BK55_4B_L      0x140096
#define REG_FSC_BK55_4B_H      0x140097
#define REG_FSC_BK55_4C_L      0x140098
#define REG_FSC_BK55_4C_H      0x140099
#define REG_FSC_BK55_4D_L      0x14009A
#define REG_FSC_BK55_4D_H      0x14009B
#define REG_FSC_BK55_4E_L      0x14009C
#define REG_FSC_BK55_4E_H      0x14009D
#define REG_FSC_BK55_4F_L      0x14009E
#define REG_FSC_BK55_4F_H      0x14009F
#define REG_FSC_BK55_50_L      0x1400A0
#define REG_FSC_BK55_50_H      0x1400A1
#define REG_FSC_BK55_51_L      0x1400A2
#define REG_FSC_BK55_51_H      0x1400A3
#define REG_FSC_BK55_52_L      0x1400A4
#define REG_FSC_BK55_52_H      0x1400A5
#define REG_FSC_BK55_53_L      0x1400A6
#define REG_FSC_BK55_53_H      0x1400A7
#define REG_FSC_BK55_54_L      0x1400A8
#define REG_FSC_BK55_54_H      0x1400A9
#define REG_FSC_BK55_55_L      0x1400AA
#define REG_FSC_BK55_55_H      0x1400AB
#define REG_FSC_BK55_56_L      0x1400AC
#define REG_FSC_BK55_56_H      0x1400AD
#define REG_FSC_BK55_57_L      0x1400AE
#define REG_FSC_BK55_57_H      0x1400AF
#define REG_FSC_BK55_58_L      0x1400B0
#define REG_FSC_BK55_58_H      0x1400B1
#define REG_FSC_BK55_59_L      0x1400B2
#define REG_FSC_BK55_59_H      0x1400B3
#define REG_FSC_BK55_5A_L      0x1400B4
#define REG_FSC_BK55_5A_H      0x1400B5
#define REG_FSC_BK55_5B_L      0x1400B6
#define REG_FSC_BK55_5B_H      0x1400B7
#define REG_FSC_BK55_5C_L      0x1400B8
#define REG_FSC_BK55_5C_H      0x1400B9
#define REG_FSC_BK55_5D_L      0x1400BA
#define REG_FSC_BK55_5D_H      0x1400BB
#define REG_FSC_BK55_5E_L      0x1400BC
#define REG_FSC_BK55_5E_H      0x1400BD
#define REG_FSC_BK55_5F_L      0x1400BE
#define REG_FSC_BK55_5F_H      0x1400BF
#define REG_FSC_BK55_60_L      0x1400C0
#define REG_FSC_BK55_60_H      0x1400C1
#define REG_FSC_BK55_61_L      0x1400C2
#define REG_FSC_BK55_61_H      0x1400C3
#define REG_FSC_BK55_62_L      0x1400C4
#define REG_FSC_BK55_62_H      0x1400C5
#define REG_FSC_BK55_63_L      0x1400C6
#define REG_FSC_BK55_63_H      0x1400C7
#define REG_FSC_BK55_64_L      0x1400C8
#define REG_FSC_BK55_64_H      0x1400C9
#define REG_FSC_BK55_65_L      0x1400CA
#define REG_FSC_BK55_65_H      0x1400CB
#define REG_FSC_BK55_66_L      0x1400CC
#define REG_FSC_BK55_66_H      0x1400CD
#define REG_FSC_BK55_67_L      0x1400CE
#define REG_FSC_BK55_67_H      0x1400CF
#define REG_FSC_BK55_68_L      0x1400D0
#define REG_FSC_BK55_68_H      0x1400D1
#define REG_FSC_BK55_69_L      0x1400D2
#define REG_FSC_BK55_69_H      0x1400D3
#define REG_FSC_BK55_6A_L      0x1400D4
#define REG_FSC_BK55_6A_H      0x1400D5
#define REG_FSC_BK55_6B_L      0x1400D6
#define REG_FSC_BK55_6B_H      0x1400D7
#define REG_FSC_BK55_6C_L      0x1400D8
#define REG_FSC_BK55_6C_H      0x1400D9
#define REG_FSC_BK55_6D_L      0x1400DA
#define REG_FSC_BK55_6D_H      0x1400DB
#define REG_FSC_BK55_6E_L      0x1400DC
#define REG_FSC_BK55_6E_H      0x1400DD
#define REG_FSC_BK55_6F_L      0x1400DE
#define REG_FSC_BK55_6F_H      0x1400DF
#define REG_FSC_BK55_70_L      0x1400E0
#define REG_FSC_BK55_70_H      0x1400E1
#define REG_FSC_BK55_71_L      0x1400E2
#define REG_FSC_BK55_71_H      0x1400E3
#define REG_FSC_BK55_72_L      0x1400E4
#define REG_FSC_BK55_72_H      0x1400E5
#define REG_FSC_BK55_73_L      0x1400E6
#define REG_FSC_BK55_73_H      0x1400E7
#define REG_FSC_BK55_74_L      0x1400E8
#define REG_FSC_BK55_74_H      0x1400E9
#define REG_FSC_BK55_75_L      0x1400EA
#define REG_FSC_BK55_75_H      0x1400EB
#define REG_FSC_BK55_76_L      0x1400EC
#define REG_FSC_BK55_76_H      0x1400ED
#define REG_FSC_BK55_77_L      0x1400EE
#define REG_FSC_BK55_77_H      0x1400EF
#define REG_FSC_BK55_78_L      0x1400F0
#define REG_FSC_BK55_78_H      0x1400F1
#define REG_FSC_BK55_79_L      0x1400F2
#define REG_FSC_BK55_79_H      0x1400F3
#define REG_FSC_BK55_7A_L      0x1400F4
#define REG_FSC_BK55_7A_H      0x1400F5
#define REG_FSC_BK55_7B_L      0x1400F6
#define REG_FSC_BK55_7B_H      0x1400F7
#define REG_FSC_BK55_7C_L      0x1400F8
#define REG_FSC_BK55_7C_H      0x1400F9
#define REG_FSC_BK55_7D_L      0x1400FA
#define REG_FSC_BK55_7D_H      0x1400FB
#define REG_FSC_BK55_7E_L      0x1400FC
#define REG_FSC_BK55_7E_H      0x1400FD
#define REG_FSC_BK55_7F_L      0x1400FE
#define REG_FSC_BK55_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK56_00_L      0x140000
#define REG_FSC_BK56_00_H      0x140001
#define REG_FSC_BK56_01_L      0x140002
#define REG_FSC_BK56_01_H      0x140003
#define REG_FSC_BK56_02_L      0x140004
#define REG_FSC_BK56_02_H      0x140005
#define REG_FSC_BK56_03_L      0x140006
#define REG_FSC_BK56_03_H      0x140007
#define REG_FSC_BK56_04_L      0x140008
#define REG_FSC_BK56_04_H      0x140009
#define REG_FSC_BK56_05_L      0x14000A
#define REG_FSC_BK56_05_H      0x14000B
#define REG_FSC_BK56_06_L      0x14000C
#define REG_FSC_BK56_06_H      0x14000D
#define REG_FSC_BK56_07_L      0x14000E
#define REG_FSC_BK56_07_H      0x14000F
#define REG_FSC_BK56_08_L      0x140010
#define REG_FSC_BK56_08_H      0x140011
#define REG_FSC_BK56_09_L      0x140012
#define REG_FSC_BK56_09_H      0x140013
#define REG_FSC_BK56_0A_L      0x140014
#define REG_FSC_BK56_0A_H      0x140015
#define REG_FSC_BK56_0B_L      0x140016
#define REG_FSC_BK56_0B_H      0x140017
#define REG_FSC_BK56_0C_L      0x140018
#define REG_FSC_BK56_0C_H      0x140019
#define REG_FSC_BK56_0D_L      0x14001A
#define REG_FSC_BK56_0D_H      0x14001B
#define REG_FSC_BK56_0E_L      0x14001C
#define REG_FSC_BK56_0E_H      0x14001D
#define REG_FSC_BK56_0F_L      0x14001E
#define REG_FSC_BK56_0F_H      0x14001F
#define REG_FSC_BK56_10_L      0x140020
#define REG_FSC_BK56_10_H      0x140021
#define REG_FSC_BK56_11_L      0x140022
#define REG_FSC_BK56_11_H      0x140023
#define REG_FSC_BK56_12_L      0x140024
#define REG_FSC_BK56_12_H      0x140025
#define REG_FSC_BK56_13_L      0x140026
#define REG_FSC_BK56_13_H      0x140027
#define REG_FSC_BK56_14_L      0x140028
#define REG_FSC_BK56_14_H      0x140029
#define REG_FSC_BK56_15_L      0x14002A
#define REG_FSC_BK56_15_H      0x14002B
#define REG_FSC_BK56_16_L      0x14002C
#define REG_FSC_BK56_16_H      0x14002D
#define REG_FSC_BK56_17_L      0x14002E
#define REG_FSC_BK56_17_H      0x14002F
#define REG_FSC_BK56_18_L      0x140030
#define REG_FSC_BK56_18_H      0x140031
#define REG_FSC_BK56_19_L      0x140032
#define REG_FSC_BK56_19_H      0x140033
#define REG_FSC_BK56_1A_L      0x140034
#define REG_FSC_BK56_1A_H      0x140035
#define REG_FSC_BK56_1B_L      0x140036
#define REG_FSC_BK56_1B_H      0x140037
#define REG_FSC_BK56_1C_L      0x140038
#define REG_FSC_BK56_1C_H      0x140039
#define REG_FSC_BK56_1D_L      0x14003A
#define REG_FSC_BK56_1D_H      0x14003B
#define REG_FSC_BK56_1E_L      0x14003C
#define REG_FSC_BK56_1E_H      0x14003D
#define REG_FSC_BK56_1F_L      0x14003E
#define REG_FSC_BK56_1F_H      0x14003F
#define REG_FSC_BK56_20_L      0x140040
#define REG_FSC_BK56_20_H      0x140041
#define REG_FSC_BK56_21_L      0x140042
#define REG_FSC_BK56_21_H      0x140043
#define REG_FSC_BK56_22_L      0x140044
#define REG_FSC_BK56_22_H      0x140045
#define REG_FSC_BK56_23_L      0x140046
#define REG_FSC_BK56_23_H      0x140047
#define REG_FSC_BK56_24_L      0x140048
#define REG_FSC_BK56_24_H      0x140049
#define REG_FSC_BK56_25_L      0x14004A
#define REG_FSC_BK56_25_H      0x14004B
#define REG_FSC_BK56_26_L      0x14004C
#define REG_FSC_BK56_26_H      0x14004D
#define REG_FSC_BK56_27_L      0x14004E
#define REG_FSC_BK56_27_H      0x14004F
#define REG_FSC_BK56_28_L      0x140050
#define REG_FSC_BK56_28_H      0x140051
#define REG_FSC_BK56_29_L      0x140052
#define REG_FSC_BK56_29_H      0x140053
#define REG_FSC_BK56_2A_L      0x140054
#define REG_FSC_BK56_2A_H      0x140055
#define REG_FSC_BK56_2B_L      0x140056
#define REG_FSC_BK56_2B_H      0x140057
#define REG_FSC_BK56_2C_L      0x140058
#define REG_FSC_BK56_2C_H      0x140059
#define REG_FSC_BK56_2D_L      0x14005A
#define REG_FSC_BK56_2D_H      0x14005B
#define REG_FSC_BK56_2E_L      0x14005C
#define REG_FSC_BK56_2E_H      0x14005D
#define REG_FSC_BK56_2F_L      0x14005E
#define REG_FSC_BK56_2F_H      0x14005F
#define REG_FSC_BK56_30_L      0x140060
#define REG_FSC_BK56_30_H      0x140061
#define REG_FSC_BK56_31_L      0x140062
#define REG_FSC_BK56_31_H      0x140063
#define REG_FSC_BK56_32_L      0x140064
#define REG_FSC_BK56_32_H      0x140065
#define REG_FSC_BK56_33_L      0x140066
#define REG_FSC_BK56_33_H      0x140067
#define REG_FSC_BK56_34_L      0x140068
#define REG_FSC_BK56_34_H      0x140069
#define REG_FSC_BK56_35_L      0x14006A
#define REG_FSC_BK56_35_H      0x14006B
#define REG_FSC_BK56_36_L      0x14006C
#define REG_FSC_BK56_36_H      0x14006D
#define REG_FSC_BK56_37_L      0x14006E
#define REG_FSC_BK56_37_H      0x14006F
#define REG_FSC_BK56_38_L      0x140070
#define REG_FSC_BK56_38_H      0x140071
#define REG_FSC_BK56_39_L      0x140072
#define REG_FSC_BK56_39_H      0x140073
#define REG_FSC_BK56_3A_L      0x140074
#define REG_FSC_BK56_3A_H      0x140075
#define REG_FSC_BK56_3B_L      0x140076
#define REG_FSC_BK56_3B_H      0x140077
#define REG_FSC_BK56_3C_L      0x140078
#define REG_FSC_BK56_3C_H      0x140079
#define REG_FSC_BK56_3D_L      0x14007A
#define REG_FSC_BK56_3D_H      0x14007B
#define REG_FSC_BK56_3E_L      0x14007C
#define REG_FSC_BK56_3E_H      0x14007D
#define REG_FSC_BK56_3F_L      0x14007E
#define REG_FSC_BK56_3F_H      0x14007F
#define REG_FSC_BK56_40_L      0x140080
#define REG_FSC_BK56_40_H      0x140081
#define REG_FSC_BK56_41_L      0x140082
#define REG_FSC_BK56_41_H      0x140083
#define REG_FSC_BK56_42_L      0x140084
#define REG_FSC_BK56_42_H      0x140085
#define REG_FSC_BK56_43_L      0x140086
#define REG_FSC_BK56_43_H      0x140087
#define REG_FSC_BK56_44_L      0x140088
#define REG_FSC_BK56_44_H      0x140089
#define REG_FSC_BK56_45_L      0x14008A
#define REG_FSC_BK56_45_H      0x14008B
#define REG_FSC_BK56_46_L      0x14008C
#define REG_FSC_BK56_46_H      0x14008D
#define REG_FSC_BK56_47_L      0x14008E
#define REG_FSC_BK56_47_H      0x14008F
#define REG_FSC_BK56_48_L      0x140090
#define REG_FSC_BK56_48_H      0x140091
#define REG_FSC_BK56_49_L      0x140092
#define REG_FSC_BK56_49_H      0x140093
#define REG_FSC_BK56_4A_L      0x140094
#define REG_FSC_BK56_4A_H      0x140095
#define REG_FSC_BK56_4B_L      0x140096
#define REG_FSC_BK56_4B_H      0x140097
#define REG_FSC_BK56_4C_L      0x140098
#define REG_FSC_BK56_4C_H      0x140099
#define REG_FSC_BK56_4D_L      0x14009A
#define REG_FSC_BK56_4D_H      0x14009B
#define REG_FSC_BK56_4E_L      0x14009C
#define REG_FSC_BK56_4E_H      0x14009D
#define REG_FSC_BK56_4F_L      0x14009E
#define REG_FSC_BK56_4F_H      0x14009F
#define REG_FSC_BK56_50_L      0x1400A0
#define REG_FSC_BK56_50_H      0x1400A1
#define REG_FSC_BK56_51_L      0x1400A2
#define REG_FSC_BK56_51_H      0x1400A3
#define REG_FSC_BK56_52_L      0x1400A4
#define REG_FSC_BK56_52_H      0x1400A5
#define REG_FSC_BK56_53_L      0x1400A6
#define REG_FSC_BK56_53_H      0x1400A7
#define REG_FSC_BK56_54_L      0x1400A8
#define REG_FSC_BK56_54_H      0x1400A9
#define REG_FSC_BK56_55_L      0x1400AA
#define REG_FSC_BK56_55_H      0x1400AB
#define REG_FSC_BK56_56_L      0x1400AC
#define REG_FSC_BK56_56_H      0x1400AD
#define REG_FSC_BK56_57_L      0x1400AE
#define REG_FSC_BK56_57_H      0x1400AF
#define REG_FSC_BK56_58_L      0x1400B0
#define REG_FSC_BK56_58_H      0x1400B1
#define REG_FSC_BK56_59_L      0x1400B2
#define REG_FSC_BK56_59_H      0x1400B3
#define REG_FSC_BK56_5A_L      0x1400B4
#define REG_FSC_BK56_5A_H      0x1400B5
#define REG_FSC_BK56_5B_L      0x1400B6
#define REG_FSC_BK56_5B_H      0x1400B7
#define REG_FSC_BK56_5C_L      0x1400B8
#define REG_FSC_BK56_5C_H      0x1400B9
#define REG_FSC_BK56_5D_L      0x1400BA
#define REG_FSC_BK56_5D_H      0x1400BB
#define REG_FSC_BK56_5E_L      0x1400BC
#define REG_FSC_BK56_5E_H      0x1400BD
#define REG_FSC_BK56_5F_L      0x1400BE
#define REG_FSC_BK56_5F_H      0x1400BF
#define REG_FSC_BK56_60_L      0x1400C0
#define REG_FSC_BK56_60_H      0x1400C1
#define REG_FSC_BK56_61_L      0x1400C2
#define REG_FSC_BK56_61_H      0x1400C3
#define REG_FSC_BK56_62_L      0x1400C4
#define REG_FSC_BK56_62_H      0x1400C5
#define REG_FSC_BK56_63_L      0x1400C6
#define REG_FSC_BK56_63_H      0x1400C7
#define REG_FSC_BK56_64_L      0x1400C8
#define REG_FSC_BK56_64_H      0x1400C9
#define REG_FSC_BK56_65_L      0x1400CA
#define REG_FSC_BK56_65_H      0x1400CB
#define REG_FSC_BK56_66_L      0x1400CC
#define REG_FSC_BK56_66_H      0x1400CD
#define REG_FSC_BK56_67_L      0x1400CE
#define REG_FSC_BK56_67_H      0x1400CF
#define REG_FSC_BK56_68_L      0x1400D0
#define REG_FSC_BK56_68_H      0x1400D1
#define REG_FSC_BK56_69_L      0x1400D2
#define REG_FSC_BK56_69_H      0x1400D3
#define REG_FSC_BK56_6A_L      0x1400D4
#define REG_FSC_BK56_6A_H      0x1400D5
#define REG_FSC_BK56_6B_L      0x1400D6
#define REG_FSC_BK56_6B_H      0x1400D7
#define REG_FSC_BK56_6C_L      0x1400D8
#define REG_FSC_BK56_6C_H      0x1400D9
#define REG_FSC_BK56_6D_L      0x1400DA
#define REG_FSC_BK56_6D_H      0x1400DB
#define REG_FSC_BK56_6E_L      0x1400DC
#define REG_FSC_BK56_6E_H      0x1400DD
#define REG_FSC_BK56_6F_L      0x1400DE
#define REG_FSC_BK56_6F_H      0x1400DF
#define REG_FSC_BK56_70_L      0x1400E0
#define REG_FSC_BK56_70_H      0x1400E1
#define REG_FSC_BK56_71_L      0x1400E2
#define REG_FSC_BK56_71_H      0x1400E3
#define REG_FSC_BK56_72_L      0x1400E4
#define REG_FSC_BK56_72_H      0x1400E5
#define REG_FSC_BK56_73_L      0x1400E6
#define REG_FSC_BK56_73_H      0x1400E7
#define REG_FSC_BK56_74_L      0x1400E8
#define REG_FSC_BK56_74_H      0x1400E9
#define REG_FSC_BK56_75_L      0x1400EA
#define REG_FSC_BK56_75_H      0x1400EB
#define REG_FSC_BK56_76_L      0x1400EC
#define REG_FSC_BK56_76_H      0x1400ED
#define REG_FSC_BK56_77_L      0x1400EE
#define REG_FSC_BK56_77_H      0x1400EF
#define REG_FSC_BK56_78_L      0x1400F0
#define REG_FSC_BK56_78_H      0x1400F1
#define REG_FSC_BK56_79_L      0x1400F2
#define REG_FSC_BK56_79_H      0x1400F3
#define REG_FSC_BK56_7A_L      0x1400F4
#define REG_FSC_BK56_7A_H      0x1400F5
#define REG_FSC_BK56_7B_L      0x1400F6
#define REG_FSC_BK56_7B_H      0x1400F7
#define REG_FSC_BK56_7C_L      0x1400F8
#define REG_FSC_BK56_7C_H      0x1400F9
#define REG_FSC_BK56_7D_L      0x1400FA
#define REG_FSC_BK56_7D_H      0x1400FB
#define REG_FSC_BK56_7E_L      0x1400FC
#define REG_FSC_BK56_7E_H      0x1400FD
#define REG_FSC_BK56_7F_L      0x1400FE
#define REG_FSC_BK56_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK57_00_L      0x140000
#define REG_FSC_BK57_00_H      0x140001
#define REG_FSC_BK57_01_L      0x140002
#define REG_FSC_BK57_01_H      0x140003
#define REG_FSC_BK57_02_L      0x140004
#define REG_FSC_BK57_02_H      0x140005
#define REG_FSC_BK57_03_L      0x140006
#define REG_FSC_BK57_03_H      0x140007
#define REG_FSC_BK57_04_L      0x140008
#define REG_FSC_BK57_04_H      0x140009
#define REG_FSC_BK57_05_L      0x14000A
#define REG_FSC_BK57_05_H      0x14000B
#define REG_FSC_BK57_06_L      0x14000C
#define REG_FSC_BK57_06_H      0x14000D
#define REG_FSC_BK57_07_L      0x14000E
#define REG_FSC_BK57_07_H      0x14000F
#define REG_FSC_BK57_08_L      0x140010
#define REG_FSC_BK57_08_H      0x140011
#define REG_FSC_BK57_09_L      0x140012
#define REG_FSC_BK57_09_H      0x140013
#define REG_FSC_BK57_0A_L      0x140014
#define REG_FSC_BK57_0A_H      0x140015
#define REG_FSC_BK57_0B_L      0x140016
#define REG_FSC_BK57_0B_H      0x140017
#define REG_FSC_BK57_0C_L      0x140018
#define REG_FSC_BK57_0C_H      0x140019
#define REG_FSC_BK57_0D_L      0x14001A
#define REG_FSC_BK57_0D_H      0x14001B
#define REG_FSC_BK57_0E_L      0x14001C
#define REG_FSC_BK57_0E_H      0x14001D
#define REG_FSC_BK57_0F_L      0x14001E
#define REG_FSC_BK57_0F_H      0x14001F
#define REG_FSC_BK57_10_L      0x140020
#define REG_FSC_BK57_10_H      0x140021
#define REG_FSC_BK57_11_L      0x140022
#define REG_FSC_BK57_11_H      0x140023
#define REG_FSC_BK57_12_L      0x140024
#define REG_FSC_BK57_12_H      0x140025
#define REG_FSC_BK57_13_L      0x140026
#define REG_FSC_BK57_13_H      0x140027
#define REG_FSC_BK57_14_L      0x140028
#define REG_FSC_BK57_14_H      0x140029
#define REG_FSC_BK57_15_L      0x14002A
#define REG_FSC_BK57_15_H      0x14002B
#define REG_FSC_BK57_16_L      0x14002C
#define REG_FSC_BK57_16_H      0x14002D
#define REG_FSC_BK57_17_L      0x14002E
#define REG_FSC_BK57_17_H      0x14002F
#define REG_FSC_BK57_18_L      0x140030
#define REG_FSC_BK57_18_H      0x140031
#define REG_FSC_BK57_19_L      0x140032
#define REG_FSC_BK57_19_H      0x140033
#define REG_FSC_BK57_1A_L      0x140034
#define REG_FSC_BK57_1A_H      0x140035
#define REG_FSC_BK57_1B_L      0x140036
#define REG_FSC_BK57_1B_H      0x140037
#define REG_FSC_BK57_1C_L      0x140038
#define REG_FSC_BK57_1C_H      0x140039
#define REG_FSC_BK57_1D_L      0x14003A
#define REG_FSC_BK57_1D_H      0x14003B
#define REG_FSC_BK57_1E_L      0x14003C
#define REG_FSC_BK57_1E_H      0x14003D
#define REG_FSC_BK57_1F_L      0x14003E
#define REG_FSC_BK57_1F_H      0x14003F
#define REG_FSC_BK57_20_L      0x140040
#define REG_FSC_BK57_20_H      0x140041
#define REG_FSC_BK57_21_L      0x140042
#define REG_FSC_BK57_21_H      0x140043
#define REG_FSC_BK57_22_L      0x140044
#define REG_FSC_BK57_22_H      0x140045
#define REG_FSC_BK57_23_L      0x140046
#define REG_FSC_BK57_23_H      0x140047
#define REG_FSC_BK57_24_L      0x140048
#define REG_FSC_BK57_24_H      0x140049
#define REG_FSC_BK57_25_L      0x14004A
#define REG_FSC_BK57_25_H      0x14004B
#define REG_FSC_BK57_26_L      0x14004C
#define REG_FSC_BK57_26_H      0x14004D
#define REG_FSC_BK57_27_L      0x14004E
#define REG_FSC_BK57_27_H      0x14004F
#define REG_FSC_BK57_28_L      0x140050
#define REG_FSC_BK57_28_H      0x140051
#define REG_FSC_BK57_29_L      0x140052
#define REG_FSC_BK57_29_H      0x140053
#define REG_FSC_BK57_2A_L      0x140054
#define REG_FSC_BK57_2A_H      0x140055
#define REG_FSC_BK57_2B_L      0x140056
#define REG_FSC_BK57_2B_H      0x140057
#define REG_FSC_BK57_2C_L      0x140058
#define REG_FSC_BK57_2C_H      0x140059
#define REG_FSC_BK57_2D_L      0x14005A
#define REG_FSC_BK57_2D_H      0x14005B
#define REG_FSC_BK57_2E_L      0x14005C
#define REG_FSC_BK57_2E_H      0x14005D
#define REG_FSC_BK57_2F_L      0x14005E
#define REG_FSC_BK57_2F_H      0x14005F
#define REG_FSC_BK57_30_L      0x140060
#define REG_FSC_BK57_30_H      0x140061
#define REG_FSC_BK57_31_L      0x140062
#define REG_FSC_BK57_31_H      0x140063
#define REG_FSC_BK57_32_L      0x140064
#define REG_FSC_BK57_32_H      0x140065
#define REG_FSC_BK57_33_L      0x140066
#define REG_FSC_BK57_33_H      0x140067
#define REG_FSC_BK57_34_L      0x140068
#define REG_FSC_BK57_34_H      0x140069
#define REG_FSC_BK57_35_L      0x14006A
#define REG_FSC_BK57_35_H      0x14006B
#define REG_FSC_BK57_36_L      0x14006C
#define REG_FSC_BK57_36_H      0x14006D
#define REG_FSC_BK57_37_L      0x14006E
#define REG_FSC_BK57_37_H      0x14006F
#define REG_FSC_BK57_38_L      0x140070
#define REG_FSC_BK57_38_H      0x140071
#define REG_FSC_BK57_39_L      0x140072
#define REG_FSC_BK57_39_H      0x140073
#define REG_FSC_BK57_3A_L      0x140074
#define REG_FSC_BK57_3A_H      0x140075
#define REG_FSC_BK57_3B_L      0x140076
#define REG_FSC_BK57_3B_H      0x140077
#define REG_FSC_BK57_3C_L      0x140078
#define REG_FSC_BK57_3C_H      0x140079
#define REG_FSC_BK57_3D_L      0x14007A
#define REG_FSC_BK57_3D_H      0x14007B
#define REG_FSC_BK57_3E_L      0x14007C
#define REG_FSC_BK57_3E_H      0x14007D
#define REG_FSC_BK57_3F_L      0x14007E
#define REG_FSC_BK57_3F_H      0x14007F
#define REG_FSC_BK57_40_L      0x140080
#define REG_FSC_BK57_40_H      0x140081
#define REG_FSC_BK57_41_L      0x140082
#define REG_FSC_BK57_41_H      0x140083
#define REG_FSC_BK57_42_L      0x140084
#define REG_FSC_BK57_42_H      0x140085
#define REG_FSC_BK57_43_L      0x140086
#define REG_FSC_BK57_43_H      0x140087
#define REG_FSC_BK57_44_L      0x140088
#define REG_FSC_BK57_44_H      0x140089
#define REG_FSC_BK57_45_L      0x14008A
#define REG_FSC_BK57_45_H      0x14008B
#define REG_FSC_BK57_46_L      0x14008C
#define REG_FSC_BK57_46_H      0x14008D
#define REG_FSC_BK57_47_L      0x14008E
#define REG_FSC_BK57_47_H      0x14008F
#define REG_FSC_BK57_48_L      0x140090
#define REG_FSC_BK57_48_H      0x140091
#define REG_FSC_BK57_49_L      0x140092
#define REG_FSC_BK57_49_H      0x140093
#define REG_FSC_BK57_4A_L      0x140094
#define REG_FSC_BK57_4A_H      0x140095
#define REG_FSC_BK57_4B_L      0x140096
#define REG_FSC_BK57_4B_H      0x140097
#define REG_FSC_BK57_4C_L      0x140098
#define REG_FSC_BK57_4C_H      0x140099
#define REG_FSC_BK57_4D_L      0x14009A
#define REG_FSC_BK57_4D_H      0x14009B
#define REG_FSC_BK57_4E_L      0x14009C
#define REG_FSC_BK57_4E_H      0x14009D
#define REG_FSC_BK57_4F_L      0x14009E
#define REG_FSC_BK57_4F_H      0x14009F
#define REG_FSC_BK57_50_L      0x1400A0
#define REG_FSC_BK57_50_H      0x1400A1
#define REG_FSC_BK57_51_L      0x1400A2
#define REG_FSC_BK57_51_H      0x1400A3
#define REG_FSC_BK57_52_L      0x1400A4
#define REG_FSC_BK57_52_H      0x1400A5
#define REG_FSC_BK57_53_L      0x1400A6
#define REG_FSC_BK57_53_H      0x1400A7
#define REG_FSC_BK57_54_L      0x1400A8
#define REG_FSC_BK57_54_H      0x1400A9
#define REG_FSC_BK57_55_L      0x1400AA
#define REG_FSC_BK57_55_H      0x1400AB
#define REG_FSC_BK57_56_L      0x1400AC
#define REG_FSC_BK57_56_H      0x1400AD
#define REG_FSC_BK57_57_L      0x1400AE
#define REG_FSC_BK57_57_H      0x1400AF
#define REG_FSC_BK57_58_L      0x1400B0
#define REG_FSC_BK57_58_H      0x1400B1
#define REG_FSC_BK57_59_L      0x1400B2
#define REG_FSC_BK57_59_H      0x1400B3
#define REG_FSC_BK57_5A_L      0x1400B4
#define REG_FSC_BK57_5A_H      0x1400B5
#define REG_FSC_BK57_5B_L      0x1400B6
#define REG_FSC_BK57_5B_H      0x1400B7
#define REG_FSC_BK57_5C_L      0x1400B8
#define REG_FSC_BK57_5C_H      0x1400B9
#define REG_FSC_BK57_5D_L      0x1400BA
#define REG_FSC_BK57_5D_H      0x1400BB
#define REG_FSC_BK57_5E_L      0x1400BC
#define REG_FSC_BK57_5E_H      0x1400BD
#define REG_FSC_BK57_5F_L      0x1400BE
#define REG_FSC_BK57_5F_H      0x1400BF
#define REG_FSC_BK57_60_L      0x1400C0
#define REG_FSC_BK57_60_H      0x1400C1
#define REG_FSC_BK57_61_L      0x1400C2
#define REG_FSC_BK57_61_H      0x1400C3
#define REG_FSC_BK57_62_L      0x1400C4
#define REG_FSC_BK57_62_H      0x1400C5
#define REG_FSC_BK57_63_L      0x1400C6
#define REG_FSC_BK57_63_H      0x1400C7
#define REG_FSC_BK57_64_L      0x1400C8
#define REG_FSC_BK57_64_H      0x1400C9
#define REG_FSC_BK57_65_L      0x1400CA
#define REG_FSC_BK57_65_H      0x1400CB
#define REG_FSC_BK57_66_L      0x1400CC
#define REG_FSC_BK57_66_H      0x1400CD
#define REG_FSC_BK57_67_L      0x1400CE
#define REG_FSC_BK57_67_H      0x1400CF
#define REG_FSC_BK57_68_L      0x1400D0
#define REG_FSC_BK57_68_H      0x1400D1
#define REG_FSC_BK57_69_L      0x1400D2
#define REG_FSC_BK57_69_H      0x1400D3
#define REG_FSC_BK57_6A_L      0x1400D4
#define REG_FSC_BK57_6A_H      0x1400D5
#define REG_FSC_BK57_6B_L      0x1400D6
#define REG_FSC_BK57_6B_H      0x1400D7
#define REG_FSC_BK57_6C_L      0x1400D8
#define REG_FSC_BK57_6C_H      0x1400D9
#define REG_FSC_BK57_6D_L      0x1400DA
#define REG_FSC_BK57_6D_H      0x1400DB
#define REG_FSC_BK57_6E_L      0x1400DC
#define REG_FSC_BK57_6E_H      0x1400DD
#define REG_FSC_BK57_6F_L      0x1400DE
#define REG_FSC_BK57_6F_H      0x1400DF
#define REG_FSC_BK57_70_L      0x1400E0
#define REG_FSC_BK57_70_H      0x1400E1
#define REG_FSC_BK57_71_L      0x1400E2
#define REG_FSC_BK57_71_H      0x1400E3
#define REG_FSC_BK57_72_L      0x1400E4
#define REG_FSC_BK57_72_H      0x1400E5
#define REG_FSC_BK57_73_L      0x1400E6
#define REG_FSC_BK57_73_H      0x1400E7
#define REG_FSC_BK57_74_L      0x1400E8
#define REG_FSC_BK57_74_H      0x1400E9
#define REG_FSC_BK57_75_L      0x1400EA
#define REG_FSC_BK57_75_H      0x1400EB
#define REG_FSC_BK57_76_L      0x1400EC
#define REG_FSC_BK57_76_H      0x1400ED
#define REG_FSC_BK57_77_L      0x1400EE
#define REG_FSC_BK57_77_H      0x1400EF
#define REG_FSC_BK57_78_L      0x1400F0
#define REG_FSC_BK57_78_H      0x1400F1
#define REG_FSC_BK57_79_L      0x1400F2
#define REG_FSC_BK57_79_H      0x1400F3
#define REG_FSC_BK57_7A_L      0x1400F4
#define REG_FSC_BK57_7A_H      0x1400F5
#define REG_FSC_BK57_7B_L      0x1400F6
#define REG_FSC_BK57_7B_H      0x1400F7
#define REG_FSC_BK57_7C_L      0x1400F8
#define REG_FSC_BK57_7C_H      0x1400F9
#define REG_FSC_BK57_7D_L      0x1400FA
#define REG_FSC_BK57_7D_H      0x1400FB
#define REG_FSC_BK57_7E_L      0x1400FC
#define REG_FSC_BK57_7E_H      0x1400FD
#define REG_FSC_BK57_7F_L      0x1400FE
#define REG_FSC_BK57_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK5F_00_L      0x140000
#define REG_FSC_BK5F_00_H      0x140001
#define REG_FSC_BK5F_01_L      0x140002
#define REG_FSC_BK5F_01_H      0x140003
#define REG_FSC_BK5F_02_L      0x140004
#define REG_FSC_BK5F_02_H      0x140005
#define REG_FSC_BK5F_03_L      0x140006
#define REG_FSC_BK5F_03_H      0x140007
#define REG_FSC_BK5F_04_L      0x140008
#define REG_FSC_BK5F_04_H      0x140009
#define REG_FSC_BK5F_05_L      0x14000A
#define REG_FSC_BK5F_05_H      0x14000B
#define REG_FSC_BK5F_06_L      0x14000C
#define REG_FSC_BK5F_06_H      0x14000D
#define REG_FSC_BK5F_07_L      0x14000E
#define REG_FSC_BK5F_07_H      0x14000F
#define REG_FSC_BK5F_08_L      0x140010
#define REG_FSC_BK5F_08_H      0x140011
#define REG_FSC_BK5F_09_L      0x140012
#define REG_FSC_BK5F_09_H      0x140013
#define REG_FSC_BK5F_0A_L      0x140014
#define REG_FSC_BK5F_0A_H      0x140015
#define REG_FSC_BK5F_0B_L      0x140016
#define REG_FSC_BK5F_0B_H      0x140017
#define REG_FSC_BK5F_0C_L      0x140018
#define REG_FSC_BK5F_0C_H      0x140019
#define REG_FSC_BK5F_0D_L      0x14001A
#define REG_FSC_BK5F_0D_H      0x14001B
#define REG_FSC_BK5F_0E_L      0x14001C
#define REG_FSC_BK5F_0E_H      0x14001D
#define REG_FSC_BK5F_0F_L      0x14001E
#define REG_FSC_BK5F_0F_H      0x14001F
#define REG_FSC_BK5F_10_L      0x140020
#define REG_FSC_BK5F_10_H      0x140021
#define REG_FSC_BK5F_11_L      0x140022
#define REG_FSC_BK5F_11_H      0x140023
#define REG_FSC_BK5F_12_L      0x140024
#define REG_FSC_BK5F_12_H      0x140025
#define REG_FSC_BK5F_13_L      0x140026
#define REG_FSC_BK5F_13_H      0x140027
#define REG_FSC_BK5F_14_L      0x140028
#define REG_FSC_BK5F_14_H      0x140029
#define REG_FSC_BK5F_15_L      0x14002A
#define REG_FSC_BK5F_15_H      0x14002B
#define REG_FSC_BK5F_16_L      0x14002C
#define REG_FSC_BK5F_16_H      0x14002D
#define REG_FSC_BK5F_17_L      0x14002E
#define REG_FSC_BK5F_17_H      0x14002F
#define REG_FSC_BK5F_18_L      0x140030
#define REG_FSC_BK5F_18_H      0x140031
#define REG_FSC_BK5F_19_L      0x140032
#define REG_FSC_BK5F_19_H      0x140033
#define REG_FSC_BK5F_1A_L      0x140034
#define REG_FSC_BK5F_1A_H      0x140035
#define REG_FSC_BK5F_1B_L      0x140036
#define REG_FSC_BK5F_1B_H      0x140037
#define REG_FSC_BK5F_1C_L      0x140038
#define REG_FSC_BK5F_1C_H      0x140039
#define REG_FSC_BK5F_1D_L      0x14003A
#define REG_FSC_BK5F_1D_H      0x14003B
#define REG_FSC_BK5F_1E_L      0x14003C
#define REG_FSC_BK5F_1E_H      0x14003D
#define REG_FSC_BK5F_1F_L      0x14003E
#define REG_FSC_BK5F_1F_H      0x14003F
#define REG_FSC_BK5F_20_L      0x140040
#define REG_FSC_BK5F_20_H      0x140041
#define REG_FSC_BK5F_21_L      0x140042
#define REG_FSC_BK5F_21_H      0x140043
#define REG_FSC_BK5F_22_L      0x140044
#define REG_FSC_BK5F_22_H      0x140045
#define REG_FSC_BK5F_23_L      0x140046
#define REG_FSC_BK5F_23_H      0x140047
#define REG_FSC_BK5F_24_L      0x140048
#define REG_FSC_BK5F_24_H      0x140049
#define REG_FSC_BK5F_25_L      0x14004A
#define REG_FSC_BK5F_25_H      0x14004B
#define REG_FSC_BK5F_26_L      0x14004C
#define REG_FSC_BK5F_26_H      0x14004D
#define REG_FSC_BK5F_27_L      0x14004E
#define REG_FSC_BK5F_27_H      0x14004F
#define REG_FSC_BK5F_28_L      0x140050
#define REG_FSC_BK5F_28_H      0x140051
#define REG_FSC_BK5F_29_L      0x140052
#define REG_FSC_BK5F_29_H      0x140053
#define REG_FSC_BK5F_2A_L      0x140054
#define REG_FSC_BK5F_2A_H      0x140055
#define REG_FSC_BK5F_2B_L      0x140056
#define REG_FSC_BK5F_2B_H      0x140057
#define REG_FSC_BK5F_2C_L      0x140058
#define REG_FSC_BK5F_2C_H      0x140059
#define REG_FSC_BK5F_2D_L      0x14005A
#define REG_FSC_BK5F_2D_H      0x14005B
#define REG_FSC_BK5F_2E_L      0x14005C
#define REG_FSC_BK5F_2E_H      0x14005D
#define REG_FSC_BK5F_2F_L      0x14005E
#define REG_FSC_BK5F_2F_H      0x14005F
#define REG_FSC_BK5F_30_L      0x140060
#define REG_FSC_BK5F_30_H      0x140061
#define REG_FSC_BK5F_31_L      0x140062
#define REG_FSC_BK5F_31_H      0x140063
#define REG_FSC_BK5F_32_L      0x140064
#define REG_FSC_BK5F_32_H      0x140065
#define REG_FSC_BK5F_33_L      0x140066
#define REG_FSC_BK5F_33_H      0x140067
#define REG_FSC_BK5F_34_L      0x140068
#define REG_FSC_BK5F_34_H      0x140069
#define REG_FSC_BK5F_35_L      0x14006A
#define REG_FSC_BK5F_35_H      0x14006B
#define REG_FSC_BK5F_36_L      0x14006C
#define REG_FSC_BK5F_36_H      0x14006D
#define REG_FSC_BK5F_37_L      0x14006E
#define REG_FSC_BK5F_37_H      0x14006F
#define REG_FSC_BK5F_38_L      0x140070
#define REG_FSC_BK5F_38_H      0x140071
#define REG_FSC_BK5F_39_L      0x140072
#define REG_FSC_BK5F_39_H      0x140073
#define REG_FSC_BK5F_3A_L      0x140074
#define REG_FSC_BK5F_3A_H      0x140075
#define REG_FSC_BK5F_3B_L      0x140076
#define REG_FSC_BK5F_3B_H      0x140077
#define REG_FSC_BK5F_3C_L      0x140078
#define REG_FSC_BK5F_3C_H      0x140079
#define REG_FSC_BK5F_3D_L      0x14007A
#define REG_FSC_BK5F_3D_H      0x14007B
#define REG_FSC_BK5F_3E_L      0x14007C
#define REG_FSC_BK5F_3E_H      0x14007D
#define REG_FSC_BK5F_3F_L      0x14007E
#define REG_FSC_BK5F_3F_H      0x14007F
#define REG_FSC_BK5F_40_L      0x140080
#define REG_FSC_BK5F_40_H      0x140081
#define REG_FSC_BK5F_41_L      0x140082
#define REG_FSC_BK5F_41_H      0x140083
#define REG_FSC_BK5F_42_L      0x140084
#define REG_FSC_BK5F_42_H      0x140085
#define REG_FSC_BK5F_43_L      0x140086
#define REG_FSC_BK5F_43_H      0x140087
#define REG_FSC_BK5F_44_L      0x140088
#define REG_FSC_BK5F_44_H      0x140089
#define REG_FSC_BK5F_45_L      0x14008A
#define REG_FSC_BK5F_45_H      0x14008B
#define REG_FSC_BK5F_46_L      0x14008C
#define REG_FSC_BK5F_46_H      0x14008D
#define REG_FSC_BK5F_47_L      0x14008E
#define REG_FSC_BK5F_47_H      0x14008F
#define REG_FSC_BK5F_48_L      0x140090
#define REG_FSC_BK5F_48_H      0x140091
#define REG_FSC_BK5F_49_L      0x140092
#define REG_FSC_BK5F_49_H      0x140093
#define REG_FSC_BK5F_4A_L      0x140094
#define REG_FSC_BK5F_4A_H      0x140095
#define REG_FSC_BK5F_4B_L      0x140096
#define REG_FSC_BK5F_4B_H      0x140097
#define REG_FSC_BK5F_4C_L      0x140098
#define REG_FSC_BK5F_4C_H      0x140099
#define REG_FSC_BK5F_4D_L      0x14009A
#define REG_FSC_BK5F_4D_H      0x14009B
#define REG_FSC_BK5F_4E_L      0x14009C
#define REG_FSC_BK5F_4E_H      0x14009D
#define REG_FSC_BK5F_4F_L      0x14009E
#define REG_FSC_BK5F_4F_H      0x14009F
#define REG_FSC_BK5F_50_L      0x1400A0
#define REG_FSC_BK5F_50_H      0x1400A1
#define REG_FSC_BK5F_51_L      0x1400A2
#define REG_FSC_BK5F_51_H      0x1400A3
#define REG_FSC_BK5F_52_L      0x1400A4
#define REG_FSC_BK5F_52_H      0x1400A5
#define REG_FSC_BK5F_53_L      0x1400A6
#define REG_FSC_BK5F_53_H      0x1400A7
#define REG_FSC_BK5F_54_L      0x1400A8
#define REG_FSC_BK5F_54_H      0x1400A9
#define REG_FSC_BK5F_55_L      0x1400AA
#define REG_FSC_BK5F_55_H      0x1400AB
#define REG_FSC_BK5F_56_L      0x1400AC
#define REG_FSC_BK5F_56_H      0x1400AD
#define REG_FSC_BK5F_57_L      0x1400AE
#define REG_FSC_BK5F_57_H      0x1400AF
#define REG_FSC_BK5F_58_L      0x1400B0
#define REG_FSC_BK5F_58_H      0x1400B1
#define REG_FSC_BK5F_59_L      0x1400B2
#define REG_FSC_BK5F_59_H      0x1400B3
#define REG_FSC_BK5F_5A_L      0x1400B4
#define REG_FSC_BK5F_5A_H      0x1400B5
#define REG_FSC_BK5F_5B_L      0x1400B6
#define REG_FSC_BK5F_5B_H      0x1400B7
#define REG_FSC_BK5F_5C_L      0x1400B8
#define REG_FSC_BK5F_5C_H      0x1400B9
#define REG_FSC_BK5F_5D_L      0x1400BA
#define REG_FSC_BK5F_5D_H      0x1400BB
#define REG_FSC_BK5F_5E_L      0x1400BC
#define REG_FSC_BK5F_5E_H      0x1400BD
#define REG_FSC_BK5F_5F_L      0x1400BE
#define REG_FSC_BK5F_5F_H      0x1400BF
#define REG_FSC_BK5F_60_L      0x1400C0
#define REG_FSC_BK5F_60_H      0x1400C1
#define REG_FSC_BK5F_61_L      0x1400C2
#define REG_FSC_BK5F_61_H      0x1400C3
#define REG_FSC_BK5F_62_L      0x1400C4
#define REG_FSC_BK5F_62_H      0x1400C5
#define REG_FSC_BK5F_63_L      0x1400C6
#define REG_FSC_BK5F_63_H      0x1400C7
#define REG_FSC_BK5F_64_L      0x1400C8
#define REG_FSC_BK5F_64_H      0x1400C9
#define REG_FSC_BK5F_65_L      0x1400CA
#define REG_FSC_BK5F_65_H      0x1400CB
#define REG_FSC_BK5F_66_L      0x1400CC
#define REG_FSC_BK5F_66_H      0x1400CD
#define REG_FSC_BK5F_67_L      0x1400CE
#define REG_FSC_BK5F_67_H      0x1400CF
#define REG_FSC_BK5F_68_L      0x1400D0
#define REG_FSC_BK5F_68_H      0x1400D1
#define REG_FSC_BK5F_69_L      0x1400D2
#define REG_FSC_BK5F_69_H      0x1400D3
#define REG_FSC_BK5F_6A_L      0x1400D4
#define REG_FSC_BK5F_6A_H      0x1400D5
#define REG_FSC_BK5F_6B_L      0x1400D6
#define REG_FSC_BK5F_6B_H      0x1400D7
#define REG_FSC_BK5F_6C_L      0x1400D8
#define REG_FSC_BK5F_6C_H      0x1400D9
#define REG_FSC_BK5F_6D_L      0x1400DA
#define REG_FSC_BK5F_6D_H      0x1400DB
#define REG_FSC_BK5F_6E_L      0x1400DC
#define REG_FSC_BK5F_6E_H      0x1400DD
#define REG_FSC_BK5F_6F_L      0x1400DE
#define REG_FSC_BK5F_6F_H      0x1400DF
#define REG_FSC_BK5F_70_L      0x1400E0
#define REG_FSC_BK5F_70_H      0x1400E1
#define REG_FSC_BK5F_71_L      0x1400E2
#define REG_FSC_BK5F_71_H      0x1400E3
#define REG_FSC_BK5F_72_L      0x1400E4
#define REG_FSC_BK5F_72_H      0x1400E5
#define REG_FSC_BK5F_73_L      0x1400E6
#define REG_FSC_BK5F_73_H      0x1400E7
#define REG_FSC_BK5F_74_L      0x1400E8
#define REG_FSC_BK5F_74_H      0x1400E9
#define REG_FSC_BK5F_75_L      0x1400EA
#define REG_FSC_BK5F_75_H      0x1400EB
#define REG_FSC_BK5F_76_L      0x1400EC
#define REG_FSC_BK5F_76_H      0x1400ED
#define REG_FSC_BK5F_77_L      0x1400EE
#define REG_FSC_BK5F_77_H      0x1400EF
#define REG_FSC_BK5F_78_L      0x1400F0
#define REG_FSC_BK5F_78_H      0x1400F1
#define REG_FSC_BK5F_79_L      0x1400F2
#define REG_FSC_BK5F_79_H      0x1400F3
#define REG_FSC_BK5F_7A_L      0x1400F4
#define REG_FSC_BK5F_7A_H      0x1400F5
#define REG_FSC_BK5F_7B_L      0x1400F6
#define REG_FSC_BK5F_7B_H      0x1400F7
#define REG_FSC_BK5F_7C_L      0x1400F8
#define REG_FSC_BK5F_7C_H      0x1400F9
#define REG_FSC_BK5F_7D_L      0x1400FA
#define REG_FSC_BK5F_7D_H      0x1400FB
#define REG_FSC_BK5F_7E_L      0x1400FC
#define REG_FSC_BK5F_7E_H      0x1400FD
#define REG_FSC_BK5F_7F_L      0x1400FE
#define REG_FSC_BK5F_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK70_00_L      0x140000
#define REG_FSC_BK70_00_H      0x140001
#define REG_FSC_BK70_01_L      0x140002
#define REG_FSC_BK70_01_H      0x140003
#define REG_FSC_BK70_02_L      0x140004
#define REG_FSC_BK70_02_H      0x140005
#define REG_FSC_BK70_03_L      0x140006
#define REG_FSC_BK70_03_H      0x140007
#define REG_FSC_BK70_04_L      0x140008
#define REG_FSC_BK70_04_H      0x140009
#define REG_FSC_BK70_05_L      0x14000A
#define REG_FSC_BK70_05_H      0x14000B
#define REG_FSC_BK70_06_L      0x14000C
#define REG_FSC_BK70_06_H      0x14000D
#define REG_FSC_BK70_07_L      0x14000E
#define REG_FSC_BK70_07_H      0x14000F
#define REG_FSC_BK70_08_L      0x140010
#define REG_FSC_BK70_08_H      0x140011
#define REG_FSC_BK70_09_L      0x140012
#define REG_FSC_BK70_09_H      0x140013
#define REG_FSC_BK70_0A_L      0x140014
#define REG_FSC_BK70_0A_H      0x140015
#define REG_FSC_BK70_0B_L      0x140016
#define REG_FSC_BK70_0B_H      0x140017
#define REG_FSC_BK70_0C_L      0x140018
#define REG_FSC_BK70_0C_H      0x140019
#define REG_FSC_BK70_0D_L      0x14001A
#define REG_FSC_BK70_0D_H      0x14001B
#define REG_FSC_BK70_0E_L      0x14001C
#define REG_FSC_BK70_0E_H      0x14001D
#define REG_FSC_BK70_0F_L      0x14001E
#define REG_FSC_BK70_0F_H      0x14001F
#define REG_FSC_BK70_10_L      0x140020
#define REG_FSC_BK70_10_H      0x140021
#define REG_FSC_BK70_11_L      0x140022
#define REG_FSC_BK70_11_H      0x140023
#define REG_FSC_BK70_12_L      0x140024
#define REG_FSC_BK70_12_H      0x140025
#define REG_FSC_BK70_13_L      0x140026
#define REG_FSC_BK70_13_H      0x140027
#define REG_FSC_BK70_14_L      0x140028
#define REG_FSC_BK70_14_H      0x140029
#define REG_FSC_BK70_15_L      0x14002A
#define REG_FSC_BK70_15_H      0x14002B
#define REG_FSC_BK70_16_L      0x14002C
#define REG_FSC_BK70_16_H      0x14002D
#define REG_FSC_BK70_17_L      0x14002E
#define REG_FSC_BK70_17_H      0x14002F
#define REG_FSC_BK70_18_L      0x140030
#define REG_FSC_BK70_18_H      0x140031
#define REG_FSC_BK70_19_L      0x140032
#define REG_FSC_BK70_19_H      0x140033
#define REG_FSC_BK70_1A_L      0x140034
#define REG_FSC_BK70_1A_H      0x140035
#define REG_FSC_BK70_1B_L      0x140036
#define REG_FSC_BK70_1B_H      0x140037
#define REG_FSC_BK70_1C_L      0x140038
#define REG_FSC_BK70_1C_H      0x140039
#define REG_FSC_BK70_1D_L      0x14003A
#define REG_FSC_BK70_1D_H      0x14003B
#define REG_FSC_BK70_1E_L      0x14003C
#define REG_FSC_BK70_1E_H      0x14003D
#define REG_FSC_BK70_1F_L      0x14003E
#define REG_FSC_BK70_1F_H      0x14003F
#define REG_FSC_BK70_20_L      0x140040
#define REG_FSC_BK70_20_H      0x140041
#define REG_FSC_BK70_21_L      0x140042
#define REG_FSC_BK70_21_H      0x140043
#define REG_FSC_BK70_22_L      0x140044
#define REG_FSC_BK70_22_H      0x140045
#define REG_FSC_BK70_23_L      0x140046
#define REG_FSC_BK70_23_H      0x140047
#define REG_FSC_BK70_24_L      0x140048
#define REG_FSC_BK70_24_H      0x140049
#define REG_FSC_BK70_25_L      0x14004A
#define REG_FSC_BK70_25_H      0x14004B
#define REG_FSC_BK70_26_L      0x14004C
#define REG_FSC_BK70_26_H      0x14004D
#define REG_FSC_BK70_27_L      0x14004E
#define REG_FSC_BK70_27_H      0x14004F
#define REG_FSC_BK70_28_L      0x140050
#define REG_FSC_BK70_28_H      0x140051
#define REG_FSC_BK70_29_L      0x140052
#define REG_FSC_BK70_29_H      0x140053
#define REG_FSC_BK70_2A_L      0x140054
#define REG_FSC_BK70_2A_H      0x140055
#define REG_FSC_BK70_2B_L      0x140056
#define REG_FSC_BK70_2B_H      0x140057
#define REG_FSC_BK70_2C_L      0x140058
#define REG_FSC_BK70_2C_H      0x140059
#define REG_FSC_BK70_2D_L      0x14005A
#define REG_FSC_BK70_2D_H      0x14005B
#define REG_FSC_BK70_2E_L      0x14005C
#define REG_FSC_BK70_2E_H      0x14005D
#define REG_FSC_BK70_2F_L      0x14005E
#define REG_FSC_BK70_2F_H      0x14005F
#define REG_FSC_BK70_30_L      0x140060
#define REG_FSC_BK70_30_H      0x140061
#define REG_FSC_BK70_31_L      0x140062
#define REG_FSC_BK70_31_H      0x140063
#define REG_FSC_BK70_32_L      0x140064
#define REG_FSC_BK70_32_H      0x140065
#define REG_FSC_BK70_33_L      0x140066
#define REG_FSC_BK70_33_H      0x140067
#define REG_FSC_BK70_34_L      0x140068
#define REG_FSC_BK70_34_H      0x140069
#define REG_FSC_BK70_35_L      0x14006A
#define REG_FSC_BK70_35_H      0x14006B
#define REG_FSC_BK70_36_L      0x14006C
#define REG_FSC_BK70_36_H      0x14006D
#define REG_FSC_BK70_37_L      0x14006E
#define REG_FSC_BK70_37_H      0x14006F
#define REG_FSC_BK70_38_L      0x140070
#define REG_FSC_BK70_38_H      0x140071
#define REG_FSC_BK70_39_L      0x140072
#define REG_FSC_BK70_39_H      0x140073
#define REG_FSC_BK70_3A_L      0x140074
#define REG_FSC_BK70_3A_H      0x140075
#define REG_FSC_BK70_3B_L      0x140076
#define REG_FSC_BK70_3B_H      0x140077
#define REG_FSC_BK70_3C_L      0x140078
#define REG_FSC_BK70_3C_H      0x140079
#define REG_FSC_BK70_3D_L      0x14007A
#define REG_FSC_BK70_3D_H      0x14007B
#define REG_FSC_BK70_3E_L      0x14007C
#define REG_FSC_BK70_3E_H      0x14007D
#define REG_FSC_BK70_3F_L      0x14007E
#define REG_FSC_BK70_3F_H      0x14007F
#define REG_FSC_BK70_40_L      0x140080
#define REG_FSC_BK70_40_H      0x140081
#define REG_FSC_BK70_41_L      0x140082
#define REG_FSC_BK70_41_H      0x140083
#define REG_FSC_BK70_42_L      0x140084
#define REG_FSC_BK70_42_H      0x140085
#define REG_FSC_BK70_43_L      0x140086
#define REG_FSC_BK70_43_H      0x140087
#define REG_FSC_BK70_44_L      0x140088
#define REG_FSC_BK70_44_H      0x140089
#define REG_FSC_BK70_45_L      0x14008A
#define REG_FSC_BK70_45_H      0x14008B
#define REG_FSC_BK70_46_L      0x14008C
#define REG_FSC_BK70_46_H      0x14008D
#define REG_FSC_BK70_47_L      0x14008E
#define REG_FSC_BK70_47_H      0x14008F
#define REG_FSC_BK70_48_L      0x140090
#define REG_FSC_BK70_48_H      0x140091
#define REG_FSC_BK70_49_L      0x140092
#define REG_FSC_BK70_49_H      0x140093
#define REG_FSC_BK70_4A_L      0x140094
#define REG_FSC_BK70_4A_H      0x140095
#define REG_FSC_BK70_4B_L      0x140096
#define REG_FSC_BK70_4B_H      0x140097
#define REG_FSC_BK70_4C_L      0x140098
#define REG_FSC_BK70_4C_H      0x140099
#define REG_FSC_BK70_4D_L      0x14009A
#define REG_FSC_BK70_4D_H      0x14009B
#define REG_FSC_BK70_4E_L      0x14009C
#define REG_FSC_BK70_4E_H      0x14009D
#define REG_FSC_BK70_4F_L      0x14009E
#define REG_FSC_BK70_4F_H      0x14009F
#define REG_FSC_BK70_50_L      0x1400A0
#define REG_FSC_BK70_50_H      0x1400A1
#define REG_FSC_BK70_51_L      0x1400A2
#define REG_FSC_BK70_51_H      0x1400A3
#define REG_FSC_BK70_52_L      0x1400A4
#define REG_FSC_BK70_52_H      0x1400A5
#define REG_FSC_BK70_53_L      0x1400A6
#define REG_FSC_BK70_53_H      0x1400A7
#define REG_FSC_BK70_54_L      0x1400A8
#define REG_FSC_BK70_54_H      0x1400A9
#define REG_FSC_BK70_55_L      0x1400AA
#define REG_FSC_BK70_55_H      0x1400AB
#define REG_FSC_BK70_56_L      0x1400AC
#define REG_FSC_BK70_56_H      0x1400AD
#define REG_FSC_BK70_57_L      0x1400AE
#define REG_FSC_BK70_57_H      0x1400AF
#define REG_FSC_BK70_58_L      0x1400B0
#define REG_FSC_BK70_58_H      0x1400B1
#define REG_FSC_BK70_59_L      0x1400B2
#define REG_FSC_BK70_59_H      0x1400B3
#define REG_FSC_BK70_5A_L      0x1400B4
#define REG_FSC_BK70_5A_H      0x1400B5
#define REG_FSC_BK70_5B_L      0x1400B6
#define REG_FSC_BK70_5B_H      0x1400B7
#define REG_FSC_BK70_5C_L      0x1400B8
#define REG_FSC_BK70_5C_H      0x1400B9
#define REG_FSC_BK70_5D_L      0x1400BA
#define REG_FSC_BK70_5D_H      0x1400BB
#define REG_FSC_BK70_5E_L      0x1400BC
#define REG_FSC_BK70_5E_H      0x1400BD
#define REG_FSC_BK70_5F_L      0x1400BE
#define REG_FSC_BK70_5F_H      0x1400BF
#define REG_FSC_BK70_60_L      0x1400C0
#define REG_FSC_BK70_60_H      0x1400C1
#define REG_FSC_BK70_61_L      0x1400C2
#define REG_FSC_BK70_61_H      0x1400C3
#define REG_FSC_BK70_62_L      0x1400C4
#define REG_FSC_BK70_62_H      0x1400C5
#define REG_FSC_BK70_63_L      0x1400C6
#define REG_FSC_BK70_63_H      0x1400C7
#define REG_FSC_BK70_64_L      0x1400C8
#define REG_FSC_BK70_64_H      0x1400C9
#define REG_FSC_BK70_65_L      0x1400CA
#define REG_FSC_BK70_65_H      0x1400CB
#define REG_FSC_BK70_66_L      0x1400CC
#define REG_FSC_BK70_66_H      0x1400CD
#define REG_FSC_BK70_67_L      0x1400CE
#define REG_FSC_BK70_67_H      0x1400CF
#define REG_FSC_BK70_68_L      0x1400D0
#define REG_FSC_BK70_68_H      0x1400D1
#define REG_FSC_BK70_69_L      0x1400D2
#define REG_FSC_BK70_69_H      0x1400D3
#define REG_FSC_BK70_6A_L      0x1400D4
#define REG_FSC_BK70_6A_H      0x1400D5
#define REG_FSC_BK70_6B_L      0x1400D6
#define REG_FSC_BK70_6B_H      0x1400D7
#define REG_FSC_BK70_6C_L      0x1400D8
#define REG_FSC_BK70_6C_H      0x1400D9
#define REG_FSC_BK70_6D_L      0x1400DA
#define REG_FSC_BK70_6D_H      0x1400DB
#define REG_FSC_BK70_6E_L      0x1400DC
#define REG_FSC_BK70_6E_H      0x1400DD
#define REG_FSC_BK70_6F_L      0x1400DE
#define REG_FSC_BK70_6F_H      0x1400DF
#define REG_FSC_BK70_70_L      0x1400E0
#define REG_FSC_BK70_70_H      0x1400E1
#define REG_FSC_BK70_71_L      0x1400E2
#define REG_FSC_BK70_71_H      0x1400E3
#define REG_FSC_BK70_72_L      0x1400E4
#define REG_FSC_BK70_72_H      0x1400E5
#define REG_FSC_BK70_73_L      0x1400E6
#define REG_FSC_BK70_73_H      0x1400E7
#define REG_FSC_BK70_74_L      0x1400E8
#define REG_FSC_BK70_74_H      0x1400E9
#define REG_FSC_BK70_75_L      0x1400EA
#define REG_FSC_BK70_75_H      0x1400EB
#define REG_FSC_BK70_76_L      0x1400EC
#define REG_FSC_BK70_76_H      0x1400ED
#define REG_FSC_BK70_77_L      0x1400EE
#define REG_FSC_BK70_77_H      0x1400EF
#define REG_FSC_BK70_78_L      0x1400F0
#define REG_FSC_BK70_78_H      0x1400F1
#define REG_FSC_BK70_79_L      0x1400F2
#define REG_FSC_BK70_79_H      0x1400F3
#define REG_FSC_BK70_7A_L      0x1400F4
#define REG_FSC_BK70_7A_H      0x1400F5
#define REG_FSC_BK70_7B_L      0x1400F6
#define REG_FSC_BK70_7B_H      0x1400F7
#define REG_FSC_BK70_7C_L      0x1400F8
#define REG_FSC_BK70_7C_H      0x1400F9
#define REG_FSC_BK70_7D_L      0x1400FA
#define REG_FSC_BK70_7D_H      0x1400FB
#define REG_FSC_BK70_7E_L      0x1400FC
#define REG_FSC_BK70_7E_H      0x1400FD
#define REG_FSC_BK70_7F_L      0x1400FE
#define REG_FSC_BK70_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK71_00_L      0x140000
#define REG_FSC_BK71_00_H      0x140001
#define REG_FSC_BK71_01_L      0x140002
#define REG_FSC_BK71_01_H      0x140003
#define REG_FSC_BK71_02_L      0x140004
#define REG_FSC_BK71_02_H      0x140005
#define REG_FSC_BK71_03_L      0x140006
#define REG_FSC_BK71_03_H      0x140007
#define REG_FSC_BK71_04_L      0x140008
#define REG_FSC_BK71_04_H      0x140009
#define REG_FSC_BK71_05_L      0x14000A
#define REG_FSC_BK71_05_H      0x14000B
#define REG_FSC_BK71_06_L      0x14000C
#define REG_FSC_BK71_06_H      0x14000D
#define REG_FSC_BK71_07_L      0x14000E
#define REG_FSC_BK71_07_H      0x14000F
#define REG_FSC_BK71_08_L      0x140010
#define REG_FSC_BK71_08_H      0x140011
#define REG_FSC_BK71_09_L      0x140012
#define REG_FSC_BK71_09_H      0x140013
#define REG_FSC_BK71_0A_L      0x140014
#define REG_FSC_BK71_0A_H      0x140015
#define REG_FSC_BK71_0B_L      0x140016
#define REG_FSC_BK71_0B_H      0x140017
#define REG_FSC_BK71_0C_L      0x140018
#define REG_FSC_BK71_0C_H      0x140019
#define REG_FSC_BK71_0D_L      0x14001A
#define REG_FSC_BK71_0D_H      0x14001B
#define REG_FSC_BK71_0E_L      0x14001C
#define REG_FSC_BK71_0E_H      0x14001D
#define REG_FSC_BK71_0F_L      0x14001E
#define REG_FSC_BK71_0F_H      0x14001F
#define REG_FSC_BK71_10_L      0x140020
#define REG_FSC_BK71_10_H      0x140021
#define REG_FSC_BK71_11_L      0x140022
#define REG_FSC_BK71_11_H      0x140023
#define REG_FSC_BK71_12_L      0x140024
#define REG_FSC_BK71_12_H      0x140025
#define REG_FSC_BK71_13_L      0x140026
#define REG_FSC_BK71_13_H      0x140027
#define REG_FSC_BK71_14_L      0x140028
#define REG_FSC_BK71_14_H      0x140029
#define REG_FSC_BK71_15_L      0x14002A
#define REG_FSC_BK71_15_H      0x14002B
#define REG_FSC_BK71_16_L      0x14002C
#define REG_FSC_BK71_16_H      0x14002D
#define REG_FSC_BK71_17_L      0x14002E
#define REG_FSC_BK71_17_H      0x14002F
#define REG_FSC_BK71_18_L      0x140030
#define REG_FSC_BK71_18_H      0x140031
#define REG_FSC_BK71_19_L      0x140032
#define REG_FSC_BK71_19_H      0x140033
#define REG_FSC_BK71_1A_L      0x140034
#define REG_FSC_BK71_1A_H      0x140035
#define REG_FSC_BK71_1B_L      0x140036
#define REG_FSC_BK71_1B_H      0x140037
#define REG_FSC_BK71_1C_L      0x140038
#define REG_FSC_BK71_1C_H      0x140039
#define REG_FSC_BK71_1D_L      0x14003A
#define REG_FSC_BK71_1D_H      0x14003B
#define REG_FSC_BK71_1E_L      0x14003C
#define REG_FSC_BK71_1E_H      0x14003D
#define REG_FSC_BK71_1F_L      0x14003E
#define REG_FSC_BK71_1F_H      0x14003F
#define REG_FSC_BK71_20_L      0x140040
#define REG_FSC_BK71_20_H      0x140041
#define REG_FSC_BK71_21_L      0x140042
#define REG_FSC_BK71_21_H      0x140043
#define REG_FSC_BK71_22_L      0x140044
#define REG_FSC_BK71_22_H      0x140045
#define REG_FSC_BK71_23_L      0x140046
#define REG_FSC_BK71_23_H      0x140047
#define REG_FSC_BK71_24_L      0x140048
#define REG_FSC_BK71_24_H      0x140049
#define REG_FSC_BK71_25_L      0x14004A
#define REG_FSC_BK71_25_H      0x14004B
#define REG_FSC_BK71_26_L      0x14004C
#define REG_FSC_BK71_26_H      0x14004D
#define REG_FSC_BK71_27_L      0x14004E
#define REG_FSC_BK71_27_H      0x14004F
#define REG_FSC_BK71_28_L      0x140050
#define REG_FSC_BK71_28_H      0x140051
#define REG_FSC_BK71_29_L      0x140052
#define REG_FSC_BK71_29_H      0x140053
#define REG_FSC_BK71_2A_L      0x140054
#define REG_FSC_BK71_2A_H      0x140055
#define REG_FSC_BK71_2B_L      0x140056
#define REG_FSC_BK71_2B_H      0x140057
#define REG_FSC_BK71_2C_L      0x140058
#define REG_FSC_BK71_2C_H      0x140059
#define REG_FSC_BK71_2D_L      0x14005A
#define REG_FSC_BK71_2D_H      0x14005B
#define REG_FSC_BK71_2E_L      0x14005C
#define REG_FSC_BK71_2E_H      0x14005D
#define REG_FSC_BK71_2F_L      0x14005E
#define REG_FSC_BK71_2F_H      0x14005F
#define REG_FSC_BK71_30_L      0x140060
#define REG_FSC_BK71_30_H      0x140061
#define REG_FSC_BK71_31_L      0x140062
#define REG_FSC_BK71_31_H      0x140063
#define REG_FSC_BK71_32_L      0x140064
#define REG_FSC_BK71_32_H      0x140065
#define REG_FSC_BK71_33_L      0x140066
#define REG_FSC_BK71_33_H      0x140067
#define REG_FSC_BK71_34_L      0x140068
#define REG_FSC_BK71_34_H      0x140069
#define REG_FSC_BK71_35_L      0x14006A
#define REG_FSC_BK71_35_H      0x14006B
#define REG_FSC_BK71_36_L      0x14006C
#define REG_FSC_BK71_36_H      0x14006D
#define REG_FSC_BK71_37_L      0x14006E
#define REG_FSC_BK71_37_H      0x14006F
#define REG_FSC_BK71_38_L      0x140070
#define REG_FSC_BK71_38_H      0x140071
#define REG_FSC_BK71_39_L      0x140072
#define REG_FSC_BK71_39_H      0x140073
#define REG_FSC_BK71_3A_L      0x140074
#define REG_FSC_BK71_3A_H      0x140075
#define REG_FSC_BK71_3B_L      0x140076
#define REG_FSC_BK71_3B_H      0x140077
#define REG_FSC_BK71_3C_L      0x140078
#define REG_FSC_BK71_3C_H      0x140079
#define REG_FSC_BK71_3D_L      0x14007A
#define REG_FSC_BK71_3D_H      0x14007B
#define REG_FSC_BK71_3E_L      0x14007C
#define REG_FSC_BK71_3E_H      0x14007D
#define REG_FSC_BK71_3F_L      0x14007E
#define REG_FSC_BK71_3F_H      0x14007F
#define REG_FSC_BK71_40_L      0x140080
#define REG_FSC_BK71_40_H      0x140081
#define REG_FSC_BK71_41_L      0x140082
#define REG_FSC_BK71_41_H      0x140083
#define REG_FSC_BK71_42_L      0x140084
#define REG_FSC_BK71_42_H      0x140085
#define REG_FSC_BK71_43_L      0x140086
#define REG_FSC_BK71_43_H      0x140087
#define REG_FSC_BK71_44_L      0x140088
#define REG_FSC_BK71_44_H      0x140089
#define REG_FSC_BK71_45_L      0x14008A
#define REG_FSC_BK71_45_H      0x14008B
#define REG_FSC_BK71_46_L      0x14008C
#define REG_FSC_BK71_46_H      0x14008D
#define REG_FSC_BK71_47_L      0x14008E
#define REG_FSC_BK71_47_H      0x14008F
#define REG_FSC_BK71_48_L      0x140090
#define REG_FSC_BK71_48_H      0x140091
#define REG_FSC_BK71_49_L      0x140092
#define REG_FSC_BK71_49_H      0x140093
#define REG_FSC_BK71_4A_L      0x140094
#define REG_FSC_BK71_4A_H      0x140095
#define REG_FSC_BK71_4B_L      0x140096
#define REG_FSC_BK71_4B_H      0x140097
#define REG_FSC_BK71_4C_L      0x140098
#define REG_FSC_BK71_4C_H      0x140099
#define REG_FSC_BK71_4D_L      0x14009A
#define REG_FSC_BK71_4D_H      0x14009B
#define REG_FSC_BK71_4E_L      0x14009C
#define REG_FSC_BK71_4E_H      0x14009D
#define REG_FSC_BK71_4F_L      0x14009E
#define REG_FSC_BK71_4F_H      0x14009F
#define REG_FSC_BK71_50_L      0x1400A0
#define REG_FSC_BK71_50_H      0x1400A1
#define REG_FSC_BK71_51_L      0x1400A2
#define REG_FSC_BK71_51_H      0x1400A3
#define REG_FSC_BK71_52_L      0x1400A4
#define REG_FSC_BK71_52_H      0x1400A5
#define REG_FSC_BK71_53_L      0x1400A6
#define REG_FSC_BK71_53_H      0x1400A7
#define REG_FSC_BK71_54_L      0x1400A8
#define REG_FSC_BK71_54_H      0x1400A9
#define REG_FSC_BK71_55_L      0x1400AA
#define REG_FSC_BK71_55_H      0x1400AB
#define REG_FSC_BK71_56_L      0x1400AC
#define REG_FSC_BK71_56_H      0x1400AD
#define REG_FSC_BK71_57_L      0x1400AE
#define REG_FSC_BK71_57_H      0x1400AF
#define REG_FSC_BK71_58_L      0x1400B0
#define REG_FSC_BK71_58_H      0x1400B1
#define REG_FSC_BK71_59_L      0x1400B2
#define REG_FSC_BK71_59_H      0x1400B3
#define REG_FSC_BK71_5A_L      0x1400B4
#define REG_FSC_BK71_5A_H      0x1400B5
#define REG_FSC_BK71_5B_L      0x1400B6
#define REG_FSC_BK71_5B_H      0x1400B7
#define REG_FSC_BK71_5C_L      0x1400B8
#define REG_FSC_BK71_5C_H      0x1400B9
#define REG_FSC_BK71_5D_L      0x1400BA
#define REG_FSC_BK71_5D_H      0x1400BB
#define REG_FSC_BK71_5E_L      0x1400BC
#define REG_FSC_BK71_5E_H      0x1400BD
#define REG_FSC_BK71_5F_L      0x1400BE
#define REG_FSC_BK71_5F_H      0x1400BF
#define REG_FSC_BK71_60_L      0x1400C0
#define REG_FSC_BK71_60_H      0x1400C1
#define REG_FSC_BK71_61_L      0x1400C2
#define REG_FSC_BK71_61_H      0x1400C3
#define REG_FSC_BK71_62_L      0x1400C4
#define REG_FSC_BK71_62_H      0x1400C5
#define REG_FSC_BK71_63_L      0x1400C6
#define REG_FSC_BK71_63_H      0x1400C7
#define REG_FSC_BK71_64_L      0x1400C8
#define REG_FSC_BK71_64_H      0x1400C9
#define REG_FSC_BK71_65_L      0x1400CA
#define REG_FSC_BK71_65_H      0x1400CB
#define REG_FSC_BK71_66_L      0x1400CC
#define REG_FSC_BK71_66_H      0x1400CD
#define REG_FSC_BK71_67_L      0x1400CE
#define REG_FSC_BK71_67_H      0x1400CF
#define REG_FSC_BK71_68_L      0x1400D0
#define REG_FSC_BK71_68_H      0x1400D1
#define REG_FSC_BK71_69_L      0x1400D2
#define REG_FSC_BK71_69_H      0x1400D3
#define REG_FSC_BK71_6A_L      0x1400D4
#define REG_FSC_BK71_6A_H      0x1400D5
#define REG_FSC_BK71_6B_L      0x1400D6
#define REG_FSC_BK71_6B_H      0x1400D7
#define REG_FSC_BK71_6C_L      0x1400D8
#define REG_FSC_BK71_6C_H      0x1400D9
#define REG_FSC_BK71_6D_L      0x1400DA
#define REG_FSC_BK71_6D_H      0x1400DB
#define REG_FSC_BK71_6E_L      0x1400DC
#define REG_FSC_BK71_6E_H      0x1400DD
#define REG_FSC_BK71_6F_L      0x1400DE
#define REG_FSC_BK71_6F_H      0x1400DF
#define REG_FSC_BK71_70_L      0x1400E0
#define REG_FSC_BK71_70_H      0x1400E1
#define REG_FSC_BK71_71_L      0x1400E2
#define REG_FSC_BK71_71_H      0x1400E3
#define REG_FSC_BK71_72_L      0x1400E4
#define REG_FSC_BK71_72_H      0x1400E5
#define REG_FSC_BK71_73_L      0x1400E6
#define REG_FSC_BK71_73_H      0x1400E7
#define REG_FSC_BK71_74_L      0x1400E8
#define REG_FSC_BK71_74_H      0x1400E9
#define REG_FSC_BK71_75_L      0x1400EA
#define REG_FSC_BK71_75_H      0x1400EB
#define REG_FSC_BK71_76_L      0x1400EC
#define REG_FSC_BK71_76_H      0x1400ED
#define REG_FSC_BK71_77_L      0x1400EE
#define REG_FSC_BK71_77_H      0x1400EF
#define REG_FSC_BK71_78_L      0x1400F0
#define REG_FSC_BK71_78_H      0x1400F1
#define REG_FSC_BK71_79_L      0x1400F2
#define REG_FSC_BK71_79_H      0x1400F3
#define REG_FSC_BK71_7A_L      0x1400F4
#define REG_FSC_BK71_7A_H      0x1400F5
#define REG_FSC_BK71_7B_L      0x1400F6
#define REG_FSC_BK71_7B_H      0x1400F7
#define REG_FSC_BK71_7C_L      0x1400F8
#define REG_FSC_BK71_7C_H      0x1400F9
#define REG_FSC_BK71_7D_L      0x1400FA
#define REG_FSC_BK71_7D_H      0x1400FB
#define REG_FSC_BK71_7E_L      0x1400FC
#define REG_FSC_BK71_7E_H      0x1400FD
#define REG_FSC_BK71_7F_L      0x1400FE
#define REG_FSC_BK71_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK72_00_L      0x140000
#define REG_FSC_BK72_00_H      0x140001
#define REG_FSC_BK72_01_L      0x140002
#define REG_FSC_BK72_01_H      0x140003
#define REG_FSC_BK72_02_L      0x140004
#define REG_FSC_BK72_02_H      0x140005
#define REG_FSC_BK72_03_L      0x140006
#define REG_FSC_BK72_03_H      0x140007
#define REG_FSC_BK72_04_L      0x140008
#define REG_FSC_BK72_04_H      0x140009
#define REG_FSC_BK72_05_L      0x14000A
#define REG_FSC_BK72_05_H      0x14000B
#define REG_FSC_BK72_06_L      0x14000C
#define REG_FSC_BK72_06_H      0x14000D
#define REG_FSC_BK72_07_L      0x14000E
#define REG_FSC_BK72_07_H      0x14000F
#define REG_FSC_BK72_08_L      0x140010
#define REG_FSC_BK72_08_H      0x140011
#define REG_FSC_BK72_09_L      0x140012
#define REG_FSC_BK72_09_H      0x140013
#define REG_FSC_BK72_0A_L      0x140014
#define REG_FSC_BK72_0A_H      0x140015
#define REG_FSC_BK72_0B_L      0x140016
#define REG_FSC_BK72_0B_H      0x140017
#define REG_FSC_BK72_0C_L      0x140018
#define REG_FSC_BK72_0C_H      0x140019
#define REG_FSC_BK72_0D_L      0x14001A
#define REG_FSC_BK72_0D_H      0x14001B
#define REG_FSC_BK72_0E_L      0x14001C
#define REG_FSC_BK72_0E_H      0x14001D
#define REG_FSC_BK72_0F_L      0x14001E
#define REG_FSC_BK72_0F_H      0x14001F
#define REG_FSC_BK72_10_L      0x140020
#define REG_FSC_BK72_10_H      0x140021
#define REG_FSC_BK72_11_L      0x140022
#define REG_FSC_BK72_11_H      0x140023
#define REG_FSC_BK72_12_L      0x140024
#define REG_FSC_BK72_12_H      0x140025
#define REG_FSC_BK72_13_L      0x140026
#define REG_FSC_BK72_13_H      0x140027
#define REG_FSC_BK72_14_L      0x140028
#define REG_FSC_BK72_14_H      0x140029
#define REG_FSC_BK72_15_L      0x14002A
#define REG_FSC_BK72_15_H      0x14002B
#define REG_FSC_BK72_16_L      0x14002C
#define REG_FSC_BK72_16_H      0x14002D
#define REG_FSC_BK72_17_L      0x14002E
#define REG_FSC_BK72_17_H      0x14002F
#define REG_FSC_BK72_18_L      0x140030
#define REG_FSC_BK72_18_H      0x140031
#define REG_FSC_BK72_19_L      0x140032
#define REG_FSC_BK72_19_H      0x140033
#define REG_FSC_BK72_1A_L      0x140034
#define REG_FSC_BK72_1A_H      0x140035
#define REG_FSC_BK72_1B_L      0x140036
#define REG_FSC_BK72_1B_H      0x140037
#define REG_FSC_BK72_1C_L      0x140038
#define REG_FSC_BK72_1C_H      0x140039
#define REG_FSC_BK72_1D_L      0x14003A
#define REG_FSC_BK72_1D_H      0x14003B
#define REG_FSC_BK72_1E_L      0x14003C
#define REG_FSC_BK72_1E_H      0x14003D
#define REG_FSC_BK72_1F_L      0x14003E
#define REG_FSC_BK72_1F_H      0x14003F
#define REG_FSC_BK72_20_L      0x140040
#define REG_FSC_BK72_20_H      0x140041
#define REG_FSC_BK72_21_L      0x140042
#define REG_FSC_BK72_21_H      0x140043
#define REG_FSC_BK72_22_L      0x140044
#define REG_FSC_BK72_22_H      0x140045
#define REG_FSC_BK72_23_L      0x140046
#define REG_FSC_BK72_23_H      0x140047
#define REG_FSC_BK72_24_L      0x140048
#define REG_FSC_BK72_24_H      0x140049
#define REG_FSC_BK72_25_L      0x14004A
#define REG_FSC_BK72_25_H      0x14004B
#define REG_FSC_BK72_26_L      0x14004C
#define REG_FSC_BK72_26_H      0x14004D
#define REG_FSC_BK72_27_L      0x14004E
#define REG_FSC_BK72_27_H      0x14004F
#define REG_FSC_BK72_28_L      0x140050
#define REG_FSC_BK72_28_H      0x140051
#define REG_FSC_BK72_29_L      0x140052
#define REG_FSC_BK72_29_H      0x140053
#define REG_FSC_BK72_2A_L      0x140054
#define REG_FSC_BK72_2A_H      0x140055
#define REG_FSC_BK72_2B_L      0x140056
#define REG_FSC_BK72_2B_H      0x140057
#define REG_FSC_BK72_2C_L      0x140058
#define REG_FSC_BK72_2C_H      0x140059
#define REG_FSC_BK72_2D_L      0x14005A
#define REG_FSC_BK72_2D_H      0x14005B
#define REG_FSC_BK72_2E_L      0x14005C
#define REG_FSC_BK72_2E_H      0x14005D
#define REG_FSC_BK72_2F_L      0x14005E
#define REG_FSC_BK72_2F_H      0x14005F
#define REG_FSC_BK72_30_L      0x140060
#define REG_FSC_BK72_30_H      0x140061
#define REG_FSC_BK72_31_L      0x140062
#define REG_FSC_BK72_31_H      0x140063
#define REG_FSC_BK72_32_L      0x140064
#define REG_FSC_BK72_32_H      0x140065
#define REG_FSC_BK72_33_L      0x140066
#define REG_FSC_BK72_33_H      0x140067
#define REG_FSC_BK72_34_L      0x140068
#define REG_FSC_BK72_34_H      0x140069
#define REG_FSC_BK72_35_L      0x14006A
#define REG_FSC_BK72_35_H      0x14006B
#define REG_FSC_BK72_36_L      0x14006C
#define REG_FSC_BK72_36_H      0x14006D
#define REG_FSC_BK72_37_L      0x14006E
#define REG_FSC_BK72_37_H      0x14006F
#define REG_FSC_BK72_38_L      0x140070
#define REG_FSC_BK72_38_H      0x140071
#define REG_FSC_BK72_39_L      0x140072
#define REG_FSC_BK72_39_H      0x140073
#define REG_FSC_BK72_3A_L      0x140074
#define REG_FSC_BK72_3A_H      0x140075
#define REG_FSC_BK72_3B_L      0x140076
#define REG_FSC_BK72_3B_H      0x140077
#define REG_FSC_BK72_3C_L      0x140078
#define REG_FSC_BK72_3C_H      0x140079
#define REG_FSC_BK72_3D_L      0x14007A
#define REG_FSC_BK72_3D_H      0x14007B
#define REG_FSC_BK72_3E_L      0x14007C
#define REG_FSC_BK72_3E_H      0x14007D
#define REG_FSC_BK72_3F_L      0x14007E
#define REG_FSC_BK72_3F_H      0x14007F
#define REG_FSC_BK72_40_L      0x140080
#define REG_FSC_BK72_40_H      0x140081
#define REG_FSC_BK72_41_L      0x140082
#define REG_FSC_BK72_41_H      0x140083
#define REG_FSC_BK72_42_L      0x140084
#define REG_FSC_BK72_42_H      0x140085
#define REG_FSC_BK72_43_L      0x140086
#define REG_FSC_BK72_43_H      0x140087
#define REG_FSC_BK72_44_L      0x140088
#define REG_FSC_BK72_44_H      0x140089
#define REG_FSC_BK72_45_L      0x14008A
#define REG_FSC_BK72_45_H      0x14008B
#define REG_FSC_BK72_46_L      0x14008C
#define REG_FSC_BK72_46_H      0x14008D
#define REG_FSC_BK72_47_L      0x14008E
#define REG_FSC_BK72_47_H      0x14008F
#define REG_FSC_BK72_48_L      0x140090
#define REG_FSC_BK72_48_H      0x140091
#define REG_FSC_BK72_49_L      0x140092
#define REG_FSC_BK72_49_H      0x140093
#define REG_FSC_BK72_4A_L      0x140094
#define REG_FSC_BK72_4A_H      0x140095
#define REG_FSC_BK72_4B_L      0x140096
#define REG_FSC_BK72_4B_H      0x140097
#define REG_FSC_BK72_4C_L      0x140098
#define REG_FSC_BK72_4C_H      0x140099
#define REG_FSC_BK72_4D_L      0x14009A
#define REG_FSC_BK72_4D_H      0x14009B
#define REG_FSC_BK72_4E_L      0x14009C
#define REG_FSC_BK72_4E_H      0x14009D
#define REG_FSC_BK72_4F_L      0x14009E
#define REG_FSC_BK72_4F_H      0x14009F
#define REG_FSC_BK72_50_L      0x1400A0
#define REG_FSC_BK72_50_H      0x1400A1
#define REG_FSC_BK72_51_L      0x1400A2
#define REG_FSC_BK72_51_H      0x1400A3
#define REG_FSC_BK72_52_L      0x1400A4
#define REG_FSC_BK72_52_H      0x1400A5
#define REG_FSC_BK72_53_L      0x1400A6
#define REG_FSC_BK72_53_H      0x1400A7
#define REG_FSC_BK72_54_L      0x1400A8
#define REG_FSC_BK72_54_H      0x1400A9
#define REG_FSC_BK72_55_L      0x1400AA
#define REG_FSC_BK72_55_H      0x1400AB
#define REG_FSC_BK72_56_L      0x1400AC
#define REG_FSC_BK72_56_H      0x1400AD
#define REG_FSC_BK72_57_L      0x1400AE
#define REG_FSC_BK72_57_H      0x1400AF
#define REG_FSC_BK72_58_L      0x1400B0
#define REG_FSC_BK72_58_H      0x1400B1
#define REG_FSC_BK72_59_L      0x1400B2
#define REG_FSC_BK72_59_H      0x1400B3
#define REG_FSC_BK72_5A_L      0x1400B4
#define REG_FSC_BK72_5A_H      0x1400B5
#define REG_FSC_BK72_5B_L      0x1400B6
#define REG_FSC_BK72_5B_H      0x1400B7
#define REG_FSC_BK72_5C_L      0x1400B8
#define REG_FSC_BK72_5C_H      0x1400B9
#define REG_FSC_BK72_5D_L      0x1400BA
#define REG_FSC_BK72_5D_H      0x1400BB
#define REG_FSC_BK72_5E_L      0x1400BC
#define REG_FSC_BK72_5E_H      0x1400BD
#define REG_FSC_BK72_5F_L      0x1400BE
#define REG_FSC_BK72_5F_H      0x1400BF
#define REG_FSC_BK72_60_L      0x1400C0
#define REG_FSC_BK72_60_H      0x1400C1
#define REG_FSC_BK72_61_L      0x1400C2
#define REG_FSC_BK72_61_H      0x1400C3
#define REG_FSC_BK72_62_L      0x1400C4
#define REG_FSC_BK72_62_H      0x1400C5
#define REG_FSC_BK72_63_L      0x1400C6
#define REG_FSC_BK72_63_H      0x1400C7
#define REG_FSC_BK72_64_L      0x1400C8
#define REG_FSC_BK72_64_H      0x1400C9
#define REG_FSC_BK72_65_L      0x1400CA
#define REG_FSC_BK72_65_H      0x1400CB
#define REG_FSC_BK72_66_L      0x1400CC
#define REG_FSC_BK72_66_H      0x1400CD
#define REG_FSC_BK72_67_L      0x1400CE
#define REG_FSC_BK72_67_H      0x1400CF
#define REG_FSC_BK72_68_L      0x1400D0
#define REG_FSC_BK72_68_H      0x1400D1
#define REG_FSC_BK72_69_L      0x1400D2
#define REG_FSC_BK72_69_H      0x1400D3
#define REG_FSC_BK72_6A_L      0x1400D4
#define REG_FSC_BK72_6A_H      0x1400D5
#define REG_FSC_BK72_6B_L      0x1400D6
#define REG_FSC_BK72_6B_H      0x1400D7
#define REG_FSC_BK72_6C_L      0x1400D8
#define REG_FSC_BK72_6C_H      0x1400D9
#define REG_FSC_BK72_6D_L      0x1400DA
#define REG_FSC_BK72_6D_H      0x1400DB
#define REG_FSC_BK72_6E_L      0x1400DC
#define REG_FSC_BK72_6E_H      0x1400DD
#define REG_FSC_BK72_6F_L      0x1400DE
#define REG_FSC_BK72_6F_H      0x1400DF
#define REG_FSC_BK72_70_L      0x1400E0
#define REG_FSC_BK72_70_H      0x1400E1
#define REG_FSC_BK72_71_L      0x1400E2
#define REG_FSC_BK72_71_H      0x1400E3
#define REG_FSC_BK72_72_L      0x1400E4
#define REG_FSC_BK72_72_H      0x1400E5
#define REG_FSC_BK72_73_L      0x1400E6
#define REG_FSC_BK72_73_H      0x1400E7
#define REG_FSC_BK72_74_L      0x1400E8
#define REG_FSC_BK72_74_H      0x1400E9
#define REG_FSC_BK72_75_L      0x1400EA
#define REG_FSC_BK72_75_H      0x1400EB
#define REG_FSC_BK72_76_L      0x1400EC
#define REG_FSC_BK72_76_H      0x1400ED
#define REG_FSC_BK72_77_L      0x1400EE
#define REG_FSC_BK72_77_H      0x1400EF
#define REG_FSC_BK72_78_L      0x1400F0
#define REG_FSC_BK72_78_H      0x1400F1
#define REG_FSC_BK72_79_L      0x1400F2
#define REG_FSC_BK72_79_H      0x1400F3
#define REG_FSC_BK72_7A_L      0x1400F4
#define REG_FSC_BK72_7A_H      0x1400F5
#define REG_FSC_BK72_7B_L      0x1400F6
#define REG_FSC_BK72_7B_H      0x1400F7
#define REG_FSC_BK72_7C_L      0x1400F8
#define REG_FSC_BK72_7C_H      0x1400F9
#define REG_FSC_BK72_7D_L      0x1400FA
#define REG_FSC_BK72_7D_H      0x1400FB
#define REG_FSC_BK72_7E_L      0x1400FC
#define REG_FSC_BK72_7E_H      0x1400FD
#define REG_FSC_BK72_7F_L      0x1400FE
#define REG_FSC_BK72_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK74_00_L      0x140000
#define REG_FSC_BK74_00_H      0x140001
#define REG_FSC_BK74_01_L      0x140002
#define REG_FSC_BK74_01_H      0x140003
#define REG_FSC_BK74_02_L      0x140004
#define REG_FSC_BK74_02_H      0x140005
#define REG_FSC_BK74_03_L      0x140006
#define REG_FSC_BK74_03_H      0x140007
#define REG_FSC_BK74_04_L      0x140008
#define REG_FSC_BK74_04_H      0x140009
#define REG_FSC_BK74_05_L      0x14000A
#define REG_FSC_BK74_05_H      0x14000B
#define REG_FSC_BK74_06_L      0x14000C
#define REG_FSC_BK74_06_H      0x14000D
#define REG_FSC_BK74_07_L      0x14000E
#define REG_FSC_BK74_07_H      0x14000F
#define REG_FSC_BK74_08_L      0x140010
#define REG_FSC_BK74_08_H      0x140011
#define REG_FSC_BK74_09_L      0x140012
#define REG_FSC_BK74_09_H      0x140013
#define REG_FSC_BK74_0A_L      0x140014
#define REG_FSC_BK74_0A_H      0x140015
#define REG_FSC_BK74_0B_L      0x140016
#define REG_FSC_BK74_0B_H      0x140017
#define REG_FSC_BK74_0C_L      0x140018
#define REG_FSC_BK74_0C_H      0x140019
#define REG_FSC_BK74_0D_L      0x14001A
#define REG_FSC_BK74_0D_H      0x14001B
#define REG_FSC_BK74_0E_L      0x14001C
#define REG_FSC_BK74_0E_H      0x14001D
#define REG_FSC_BK74_0F_L      0x14001E
#define REG_FSC_BK74_0F_H      0x14001F
#define REG_FSC_BK74_10_L      0x140020
#define REG_FSC_BK74_10_H      0x140021
#define REG_FSC_BK74_11_L      0x140022
#define REG_FSC_BK74_11_H      0x140023
#define REG_FSC_BK74_12_L      0x140024
#define REG_FSC_BK74_12_H      0x140025
#define REG_FSC_BK74_13_L      0x140026
#define REG_FSC_BK74_13_H      0x140027
#define REG_FSC_BK74_14_L      0x140028
#define REG_FSC_BK74_14_H      0x140029
#define REG_FSC_BK74_15_L      0x14002A
#define REG_FSC_BK74_15_H      0x14002B
#define REG_FSC_BK74_16_L      0x14002C
#define REG_FSC_BK74_16_H      0x14002D
#define REG_FSC_BK74_17_L      0x14002E
#define REG_FSC_BK74_17_H      0x14002F
#define REG_FSC_BK74_18_L      0x140030
#define REG_FSC_BK74_18_H      0x140031
#define REG_FSC_BK74_19_L      0x140032
#define REG_FSC_BK74_19_H      0x140033
#define REG_FSC_BK74_1A_L      0x140034
#define REG_FSC_BK74_1A_H      0x140035
#define REG_FSC_BK74_1B_L      0x140036
#define REG_FSC_BK74_1B_H      0x140037
#define REG_FSC_BK74_1C_L      0x140038
#define REG_FSC_BK74_1C_H      0x140039
#define REG_FSC_BK74_1D_L      0x14003A
#define REG_FSC_BK74_1D_H      0x14003B
#define REG_FSC_BK74_1E_L      0x14003C
#define REG_FSC_BK74_1E_H      0x14003D
#define REG_FSC_BK74_1F_L      0x14003E
#define REG_FSC_BK74_1F_H      0x14003F
#define REG_FSC_BK74_20_L      0x140040
#define REG_FSC_BK74_20_H      0x140041
#define REG_FSC_BK74_21_L      0x140042
#define REG_FSC_BK74_21_H      0x140043
#define REG_FSC_BK74_22_L      0x140044
#define REG_FSC_BK74_22_H      0x140045
#define REG_FSC_BK74_23_L      0x140046
#define REG_FSC_BK74_23_H      0x140047
#define REG_FSC_BK74_24_L      0x140048
#define REG_FSC_BK74_24_H      0x140049
#define REG_FSC_BK74_25_L      0x14004A
#define REG_FSC_BK74_25_H      0x14004B
#define REG_FSC_BK74_26_L      0x14004C
#define REG_FSC_BK74_26_H      0x14004D
#define REG_FSC_BK74_27_L      0x14004E
#define REG_FSC_BK74_27_H      0x14004F
#define REG_FSC_BK74_28_L      0x140050
#define REG_FSC_BK74_28_H      0x140051
#define REG_FSC_BK74_29_L      0x140052
#define REG_FSC_BK74_29_H      0x140053
#define REG_FSC_BK74_2A_L      0x140054
#define REG_FSC_BK74_2A_H      0x140055
#define REG_FSC_BK74_2B_L      0x140056
#define REG_FSC_BK74_2B_H      0x140057
#define REG_FSC_BK74_2C_L      0x140058
#define REG_FSC_BK74_2C_H      0x140059
#define REG_FSC_BK74_2D_L      0x14005A
#define REG_FSC_BK74_2D_H      0x14005B
#define REG_FSC_BK74_2E_L      0x14005C
#define REG_FSC_BK74_2E_H      0x14005D
#define REG_FSC_BK74_2F_L      0x14005E
#define REG_FSC_BK74_2F_H      0x14005F
#define REG_FSC_BK74_30_L      0x140060
#define REG_FSC_BK74_30_H      0x140061
#define REG_FSC_BK74_31_L      0x140062
#define REG_FSC_BK74_31_H      0x140063
#define REG_FSC_BK74_32_L      0x140064
#define REG_FSC_BK74_32_H      0x140065
#define REG_FSC_BK74_33_L      0x140066
#define REG_FSC_BK74_33_H      0x140067
#define REG_FSC_BK74_34_L      0x140068
#define REG_FSC_BK74_34_H      0x140069
#define REG_FSC_BK74_35_L      0x14006A
#define REG_FSC_BK74_35_H      0x14006B
#define REG_FSC_BK74_36_L      0x14006C
#define REG_FSC_BK74_36_H      0x14006D
#define REG_FSC_BK74_37_L      0x14006E
#define REG_FSC_BK74_37_H      0x14006F
#define REG_FSC_BK74_38_L      0x140070
#define REG_FSC_BK74_38_H      0x140071
#define REG_FSC_BK74_39_L      0x140072
#define REG_FSC_BK74_39_H      0x140073
#define REG_FSC_BK74_3A_L      0x140074
#define REG_FSC_BK74_3A_H      0x140075
#define REG_FSC_BK74_3B_L      0x140076
#define REG_FSC_BK74_3B_H      0x140077
#define REG_FSC_BK74_3C_L      0x140078
#define REG_FSC_BK74_3C_H      0x140079
#define REG_FSC_BK74_3D_L      0x14007A
#define REG_FSC_BK74_3D_H      0x14007B
#define REG_FSC_BK74_3E_L      0x14007C
#define REG_FSC_BK74_3E_H      0x14007D
#define REG_FSC_BK74_3F_L      0x14007E
#define REG_FSC_BK74_3F_H      0x14007F
#define REG_FSC_BK74_40_L      0x140080
#define REG_FSC_BK74_40_H      0x140081
#define REG_FSC_BK74_41_L      0x140082
#define REG_FSC_BK74_41_H      0x140083
#define REG_FSC_BK74_42_L      0x140084
#define REG_FSC_BK74_42_H      0x140085
#define REG_FSC_BK74_43_L      0x140086
#define REG_FSC_BK74_43_H      0x140087
#define REG_FSC_BK74_44_L      0x140088
#define REG_FSC_BK74_44_H      0x140089
#define REG_FSC_BK74_45_L      0x14008A
#define REG_FSC_BK74_45_H      0x14008B
#define REG_FSC_BK74_46_L      0x14008C
#define REG_FSC_BK74_46_H      0x14008D
#define REG_FSC_BK74_47_L      0x14008E
#define REG_FSC_BK74_47_H      0x14008F
#define REG_FSC_BK74_48_L      0x140090
#define REG_FSC_BK74_48_H      0x140091
#define REG_FSC_BK74_49_L      0x140092
#define REG_FSC_BK74_49_H      0x140093
#define REG_FSC_BK74_4A_L      0x140094
#define REG_FSC_BK74_4A_H      0x140095
#define REG_FSC_BK74_4B_L      0x140096
#define REG_FSC_BK74_4B_H      0x140097
#define REG_FSC_BK74_4C_L      0x140098
#define REG_FSC_BK74_4C_H      0x140099
#define REG_FSC_BK74_4D_L      0x14009A
#define REG_FSC_BK74_4D_H      0x14009B
#define REG_FSC_BK74_4E_L      0x14009C
#define REG_FSC_BK74_4E_H      0x14009D
#define REG_FSC_BK74_4F_L      0x14009E
#define REG_FSC_BK74_4F_H      0x14009F
#define REG_FSC_BK74_50_L      0x1400A0
#define REG_FSC_BK74_50_H      0x1400A1
#define REG_FSC_BK74_51_L      0x1400A2
#define REG_FSC_BK74_51_H      0x1400A3
#define REG_FSC_BK74_52_L      0x1400A4
#define REG_FSC_BK74_52_H      0x1400A5
#define REG_FSC_BK74_53_L      0x1400A6
#define REG_FSC_BK74_53_H      0x1400A7
#define REG_FSC_BK74_54_L      0x1400A8
#define REG_FSC_BK74_54_H      0x1400A9
#define REG_FSC_BK74_55_L      0x1400AA
#define REG_FSC_BK74_55_H      0x1400AB
#define REG_FSC_BK74_56_L      0x1400AC
#define REG_FSC_BK74_56_H      0x1400AD
#define REG_FSC_BK74_57_L      0x1400AE
#define REG_FSC_BK74_57_H      0x1400AF
#define REG_FSC_BK74_58_L      0x1400B0
#define REG_FSC_BK74_58_H      0x1400B1
#define REG_FSC_BK74_59_L      0x1400B2
#define REG_FSC_BK74_59_H      0x1400B3
#define REG_FSC_BK74_5A_L      0x1400B4
#define REG_FSC_BK74_5A_H      0x1400B5
#define REG_FSC_BK74_5B_L      0x1400B6
#define REG_FSC_BK74_5B_H      0x1400B7
#define REG_FSC_BK74_5C_L      0x1400B8
#define REG_FSC_BK74_5C_H      0x1400B9
#define REG_FSC_BK74_5D_L      0x1400BA
#define REG_FSC_BK74_5D_H      0x1400BB
#define REG_FSC_BK74_5E_L      0x1400BC
#define REG_FSC_BK74_5E_H      0x1400BD
#define REG_FSC_BK74_5F_L      0x1400BE
#define REG_FSC_BK74_5F_H      0x1400BF
#define REG_FSC_BK74_60_L      0x1400C0
#define REG_FSC_BK74_60_H      0x1400C1
#define REG_FSC_BK74_61_L      0x1400C2
#define REG_FSC_BK74_61_H      0x1400C3
#define REG_FSC_BK74_62_L      0x1400C4
#define REG_FSC_BK74_62_H      0x1400C5
#define REG_FSC_BK74_63_L      0x1400C6
#define REG_FSC_BK74_63_H      0x1400C7
#define REG_FSC_BK74_64_L      0x1400C8
#define REG_FSC_BK74_64_H      0x1400C9
#define REG_FSC_BK74_65_L      0x1400CA
#define REG_FSC_BK74_65_H      0x1400CB
#define REG_FSC_BK74_66_L      0x1400CC
#define REG_FSC_BK74_66_H      0x1400CD
#define REG_FSC_BK74_67_L      0x1400CE
#define REG_FSC_BK74_67_H      0x1400CF
#define REG_FSC_BK74_68_L      0x1400D0
#define REG_FSC_BK74_68_H      0x1400D1
#define REG_FSC_BK74_69_L      0x1400D2
#define REG_FSC_BK74_69_H      0x1400D3
#define REG_FSC_BK74_6A_L      0x1400D4
#define REG_FSC_BK74_6A_H      0x1400D5
#define REG_FSC_BK74_6B_L      0x1400D6
#define REG_FSC_BK74_6B_H      0x1400D7
#define REG_FSC_BK74_6C_L      0x1400D8
#define REG_FSC_BK74_6C_H      0x1400D9
#define REG_FSC_BK74_6D_L      0x1400DA
#define REG_FSC_BK74_6D_H      0x1400DB
#define REG_FSC_BK74_6E_L      0x1400DC
#define REG_FSC_BK74_6E_H      0x1400DD
#define REG_FSC_BK74_6F_L      0x1400DE
#define REG_FSC_BK74_6F_H      0x1400DF
#define REG_FSC_BK74_70_L      0x1400E0
#define REG_FSC_BK74_70_H      0x1400E1
#define REG_FSC_BK74_71_L      0x1400E2
#define REG_FSC_BK74_71_H      0x1400E3
#define REG_FSC_BK74_72_L      0x1400E4
#define REG_FSC_BK74_72_H      0x1400E5
#define REG_FSC_BK74_73_L      0x1400E6
#define REG_FSC_BK74_73_H      0x1400E7
#define REG_FSC_BK74_74_L      0x1400E8
#define REG_FSC_BK74_74_H      0x1400E9
#define REG_FSC_BK74_75_L      0x1400EA
#define REG_FSC_BK74_75_H      0x1400EB
#define REG_FSC_BK74_76_L      0x1400EC
#define REG_FSC_BK74_76_H      0x1400ED
#define REG_FSC_BK74_77_L      0x1400EE
#define REG_FSC_BK74_77_H      0x1400EF
#define REG_FSC_BK74_78_L      0x1400F0
#define REG_FSC_BK74_78_H      0x1400F1
#define REG_FSC_BK74_79_L      0x1400F2
#define REG_FSC_BK74_79_H      0x1400F3
#define REG_FSC_BK74_7A_L      0x1400F4
#define REG_FSC_BK74_7A_H      0x1400F5
#define REG_FSC_BK74_7B_L      0x1400F6
#define REG_FSC_BK74_7B_H      0x1400F7
#define REG_FSC_BK74_7C_L      0x1400F8
#define REG_FSC_BK74_7C_H      0x1400F9
#define REG_FSC_BK74_7D_L      0x1400FA
#define REG_FSC_BK74_7D_H      0x1400FB
#define REG_FSC_BK74_7E_L      0x1400FC
#define REG_FSC_BK74_7E_H      0x1400FD
#define REG_FSC_BK74_7F_L      0x1400FE
#define REG_FSC_BK74_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK75_00_L      0x140000
#define REG_FSC_BK75_00_H      0x140001
#define REG_FSC_BK75_01_L      0x140002
#define REG_FSC_BK75_01_H      0x140003
#define REG_FSC_BK75_02_L      0x140004
#define REG_FSC_BK75_02_H      0x140005
#define REG_FSC_BK75_03_L      0x140006
#define REG_FSC_BK75_03_H      0x140007
#define REG_FSC_BK75_04_L      0x140008
#define REG_FSC_BK75_04_H      0x140009
#define REG_FSC_BK75_05_L      0x14000A
#define REG_FSC_BK75_05_H      0x14000B
#define REG_FSC_BK75_06_L      0x14000C
#define REG_FSC_BK75_06_H      0x14000D
#define REG_FSC_BK75_07_L      0x14000E
#define REG_FSC_BK75_07_H      0x14000F
#define REG_FSC_BK75_08_L      0x140010
#define REG_FSC_BK75_08_H      0x140011
#define REG_FSC_BK75_09_L      0x140012
#define REG_FSC_BK75_09_H      0x140013
#define REG_FSC_BK75_0A_L      0x140014
#define REG_FSC_BK75_0A_H      0x140015
#define REG_FSC_BK75_0B_L      0x140016
#define REG_FSC_BK75_0B_H      0x140017
#define REG_FSC_BK75_0C_L      0x140018
#define REG_FSC_BK75_0C_H      0x140019
#define REG_FSC_BK75_0D_L      0x14001A
#define REG_FSC_BK75_0D_H      0x14001B
#define REG_FSC_BK75_0E_L      0x14001C
#define REG_FSC_BK75_0E_H      0x14001D
#define REG_FSC_BK75_0F_L      0x14001E
#define REG_FSC_BK75_0F_H      0x14001F
#define REG_FSC_BK75_10_L      0x140020
#define REG_FSC_BK75_10_H      0x140021
#define REG_FSC_BK75_11_L      0x140022
#define REG_FSC_BK75_11_H      0x140023
#define REG_FSC_BK75_12_L      0x140024
#define REG_FSC_BK75_12_H      0x140025
#define REG_FSC_BK75_13_L      0x140026
#define REG_FSC_BK75_13_H      0x140027
#define REG_FSC_BK75_14_L      0x140028
#define REG_FSC_BK75_14_H      0x140029
#define REG_FSC_BK75_15_L      0x14002A
#define REG_FSC_BK75_15_H      0x14002B
#define REG_FSC_BK75_16_L      0x14002C
#define REG_FSC_BK75_16_H      0x14002D
#define REG_FSC_BK75_17_L      0x14002E
#define REG_FSC_BK75_17_H      0x14002F
#define REG_FSC_BK75_18_L      0x140030
#define REG_FSC_BK75_18_H      0x140031
#define REG_FSC_BK75_19_L      0x140032
#define REG_FSC_BK75_19_H      0x140033
#define REG_FSC_BK75_1A_L      0x140034
#define REG_FSC_BK75_1A_H      0x140035
#define REG_FSC_BK75_1B_L      0x140036
#define REG_FSC_BK75_1B_H      0x140037
#define REG_FSC_BK75_1C_L      0x140038
#define REG_FSC_BK75_1C_H      0x140039
#define REG_FSC_BK75_1D_L      0x14003A
#define REG_FSC_BK75_1D_H      0x14003B
#define REG_FSC_BK75_1E_L      0x14003C
#define REG_FSC_BK75_1E_H      0x14003D
#define REG_FSC_BK75_1F_L      0x14003E
#define REG_FSC_BK75_1F_H      0x14003F
#define REG_FSC_BK75_20_L      0x140040
#define REG_FSC_BK75_20_H      0x140041
#define REG_FSC_BK75_21_L      0x140042
#define REG_FSC_BK75_21_H      0x140043
#define REG_FSC_BK75_22_L      0x140044
#define REG_FSC_BK75_22_H      0x140045
#define REG_FSC_BK75_23_L      0x140046
#define REG_FSC_BK75_23_H      0x140047
#define REG_FSC_BK75_24_L      0x140048
#define REG_FSC_BK75_24_H      0x140049
#define REG_FSC_BK75_25_L      0x14004A
#define REG_FSC_BK75_25_H      0x14004B
#define REG_FSC_BK75_26_L      0x14004C
#define REG_FSC_BK75_26_H      0x14004D
#define REG_FSC_BK75_27_L      0x14004E
#define REG_FSC_BK75_27_H      0x14004F
#define REG_FSC_BK75_28_L      0x140050
#define REG_FSC_BK75_28_H      0x140051
#define REG_FSC_BK75_29_L      0x140052
#define REG_FSC_BK75_29_H      0x140053
#define REG_FSC_BK75_2A_L      0x140054
#define REG_FSC_BK75_2A_H      0x140055
#define REG_FSC_BK75_2B_L      0x140056
#define REG_FSC_BK75_2B_H      0x140057
#define REG_FSC_BK75_2C_L      0x140058
#define REG_FSC_BK75_2C_H      0x140059
#define REG_FSC_BK75_2D_L      0x14005A
#define REG_FSC_BK75_2D_H      0x14005B
#define REG_FSC_BK75_2E_L      0x14005C
#define REG_FSC_BK75_2E_H      0x14005D
#define REG_FSC_BK75_2F_L      0x14005E
#define REG_FSC_BK75_2F_H      0x14005F
#define REG_FSC_BK75_30_L      0x140060
#define REG_FSC_BK75_30_H      0x140061
#define REG_FSC_BK75_31_L      0x140062
#define REG_FSC_BK75_31_H      0x140063
#define REG_FSC_BK75_32_L      0x140064
#define REG_FSC_BK75_32_H      0x140065
#define REG_FSC_BK75_33_L      0x140066
#define REG_FSC_BK75_33_H      0x140067
#define REG_FSC_BK75_34_L      0x140068
#define REG_FSC_BK75_34_H      0x140069
#define REG_FSC_BK75_35_L      0x14006A
#define REG_FSC_BK75_35_H      0x14006B
#define REG_FSC_BK75_36_L      0x14006C
#define REG_FSC_BK75_36_H      0x14006D
#define REG_FSC_BK75_37_L      0x14006E
#define REG_FSC_BK75_37_H      0x14006F
#define REG_FSC_BK75_38_L      0x140070
#define REG_FSC_BK75_38_H      0x140071
#define REG_FSC_BK75_39_L      0x140072
#define REG_FSC_BK75_39_H      0x140073
#define REG_FSC_BK75_3A_L      0x140074
#define REG_FSC_BK75_3A_H      0x140075
#define REG_FSC_BK75_3B_L      0x140076
#define REG_FSC_BK75_3B_H      0x140077
#define REG_FSC_BK75_3C_L      0x140078
#define REG_FSC_BK75_3C_H      0x140079
#define REG_FSC_BK75_3D_L      0x14007A
#define REG_FSC_BK75_3D_H      0x14007B
#define REG_FSC_BK75_3E_L      0x14007C
#define REG_FSC_BK75_3E_H      0x14007D
#define REG_FSC_BK75_3F_L      0x14007E
#define REG_FSC_BK75_3F_H      0x14007F
#define REG_FSC_BK75_40_L      0x140080
#define REG_FSC_BK75_40_H      0x140081
#define REG_FSC_BK75_41_L      0x140082
#define REG_FSC_BK75_41_H      0x140083
#define REG_FSC_BK75_42_L      0x140084
#define REG_FSC_BK75_42_H      0x140085
#define REG_FSC_BK75_43_L      0x140086
#define REG_FSC_BK75_43_H      0x140087
#define REG_FSC_BK75_44_L      0x140088
#define REG_FSC_BK75_44_H      0x140089
#define REG_FSC_BK75_45_L      0x14008A
#define REG_FSC_BK75_45_H      0x14008B
#define REG_FSC_BK75_46_L      0x14008C
#define REG_FSC_BK75_46_H      0x14008D
#define REG_FSC_BK75_47_L      0x14008E
#define REG_FSC_BK75_47_H      0x14008F
#define REG_FSC_BK75_48_L      0x140090
#define REG_FSC_BK75_48_H      0x140091
#define REG_FSC_BK75_49_L      0x140092
#define REG_FSC_BK75_49_H      0x140093
#define REG_FSC_BK75_4A_L      0x140094
#define REG_FSC_BK75_4A_H      0x140095
#define REG_FSC_BK75_4B_L      0x140096
#define REG_FSC_BK75_4B_H      0x140097
#define REG_FSC_BK75_4C_L      0x140098
#define REG_FSC_BK75_4C_H      0x140099
#define REG_FSC_BK75_4D_L      0x14009A
#define REG_FSC_BK75_4D_H      0x14009B
#define REG_FSC_BK75_4E_L      0x14009C
#define REG_FSC_BK75_4E_H      0x14009D
#define REG_FSC_BK75_4F_L      0x14009E
#define REG_FSC_BK75_4F_H      0x14009F
#define REG_FSC_BK75_50_L      0x1400A0
#define REG_FSC_BK75_50_H      0x1400A1
#define REG_FSC_BK75_51_L      0x1400A2
#define REG_FSC_BK75_51_H      0x1400A3
#define REG_FSC_BK75_52_L      0x1400A4
#define REG_FSC_BK75_52_H      0x1400A5
#define REG_FSC_BK75_53_L      0x1400A6
#define REG_FSC_BK75_53_H      0x1400A7
#define REG_FSC_BK75_54_L      0x1400A8
#define REG_FSC_BK75_54_H      0x1400A9
#define REG_FSC_BK75_55_L      0x1400AA
#define REG_FSC_BK75_55_H      0x1400AB
#define REG_FSC_BK75_56_L      0x1400AC
#define REG_FSC_BK75_56_H      0x1400AD
#define REG_FSC_BK75_57_L      0x1400AE
#define REG_FSC_BK75_57_H      0x1400AF
#define REG_FSC_BK75_58_L      0x1400B0
#define REG_FSC_BK75_58_H      0x1400B1
#define REG_FSC_BK75_59_L      0x1400B2
#define REG_FSC_BK75_59_H      0x1400B3
#define REG_FSC_BK75_5A_L      0x1400B4
#define REG_FSC_BK75_5A_H      0x1400B5
#define REG_FSC_BK75_5B_L      0x1400B6
#define REG_FSC_BK75_5B_H      0x1400B7
#define REG_FSC_BK75_5C_L      0x1400B8
#define REG_FSC_BK75_5C_H      0x1400B9
#define REG_FSC_BK75_5D_L      0x1400BA
#define REG_FSC_BK75_5D_H      0x1400BB
#define REG_FSC_BK75_5E_L      0x1400BC
#define REG_FSC_BK75_5E_H      0x1400BD
#define REG_FSC_BK75_5F_L      0x1400BE
#define REG_FSC_BK75_5F_H      0x1400BF
#define REG_FSC_BK75_60_L      0x1400C0
#define REG_FSC_BK75_60_H      0x1400C1
#define REG_FSC_BK75_61_L      0x1400C2
#define REG_FSC_BK75_61_H      0x1400C3
#define REG_FSC_BK75_62_L      0x1400C4
#define REG_FSC_BK75_62_H      0x1400C5
#define REG_FSC_BK75_63_L      0x1400C6
#define REG_FSC_BK75_63_H      0x1400C7
#define REG_FSC_BK75_64_L      0x1400C8
#define REG_FSC_BK75_64_H      0x1400C9
#define REG_FSC_BK75_65_L      0x1400CA
#define REG_FSC_BK75_65_H      0x1400CB
#define REG_FSC_BK75_66_L      0x1400CC
#define REG_FSC_BK75_66_H      0x1400CD
#define REG_FSC_BK75_67_L      0x1400CE
#define REG_FSC_BK75_67_H      0x1400CF
#define REG_FSC_BK75_68_L      0x1400D0
#define REG_FSC_BK75_68_H      0x1400D1
#define REG_FSC_BK75_69_L      0x1400D2
#define REG_FSC_BK75_69_H      0x1400D3
#define REG_FSC_BK75_6A_L      0x1400D4
#define REG_FSC_BK75_6A_H      0x1400D5
#define REG_FSC_BK75_6B_L      0x1400D6
#define REG_FSC_BK75_6B_H      0x1400D7
#define REG_FSC_BK75_6C_L      0x1400D8
#define REG_FSC_BK75_6C_H      0x1400D9
#define REG_FSC_BK75_6D_L      0x1400DA
#define REG_FSC_BK75_6D_H      0x1400DB
#define REG_FSC_BK75_6E_L      0x1400DC
#define REG_FSC_BK75_6E_H      0x1400DD
#define REG_FSC_BK75_6F_L      0x1400DE
#define REG_FSC_BK75_6F_H      0x1400DF
#define REG_FSC_BK75_70_L      0x1400E0
#define REG_FSC_BK75_70_H      0x1400E1
#define REG_FSC_BK75_71_L      0x1400E2
#define REG_FSC_BK75_71_H      0x1400E3
#define REG_FSC_BK75_72_L      0x1400E4
#define REG_FSC_BK75_72_H      0x1400E5
#define REG_FSC_BK75_73_L      0x1400E6
#define REG_FSC_BK75_73_H      0x1400E7
#define REG_FSC_BK75_74_L      0x1400E8
#define REG_FSC_BK75_74_H      0x1400E9
#define REG_FSC_BK75_75_L      0x1400EA
#define REG_FSC_BK75_75_H      0x1400EB
#define REG_FSC_BK75_76_L      0x1400EC
#define REG_FSC_BK75_76_H      0x1400ED
#define REG_FSC_BK75_77_L      0x1400EE
#define REG_FSC_BK75_77_H      0x1400EF
#define REG_FSC_BK75_78_L      0x1400F0
#define REG_FSC_BK75_78_H      0x1400F1
#define REG_FSC_BK75_79_L      0x1400F2
#define REG_FSC_BK75_79_H      0x1400F3
#define REG_FSC_BK75_7A_L      0x1400F4
#define REG_FSC_BK75_7A_H      0x1400F5
#define REG_FSC_BK75_7B_L      0x1400F6
#define REG_FSC_BK75_7B_H      0x1400F7
#define REG_FSC_BK75_7C_L      0x1400F8
#define REG_FSC_BK75_7C_H      0x1400F9
#define REG_FSC_BK75_7D_L      0x1400FA
#define REG_FSC_BK75_7D_H      0x1400FB
#define REG_FSC_BK75_7E_L      0x1400FC
#define REG_FSC_BK75_7E_H      0x1400FD
#define REG_FSC_BK75_7F_L      0x1400FE
#define REG_FSC_BK75_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BK76_00_L      0x140000
#define REG_FSC_BK76_00_H      0x140001
#define REG_FSC_BK76_01_L      0x140002
#define REG_FSC_BK76_01_H      0x140003
#define REG_FSC_BK76_02_L      0x140004
#define REG_FSC_BK76_02_H      0x140005
#define REG_FSC_BK76_03_L      0x140006
#define REG_FSC_BK76_03_H      0x140007
#define REG_FSC_BK76_04_L      0x140008
#define REG_FSC_BK76_04_H      0x140009
#define REG_FSC_BK76_05_L      0x14000A
#define REG_FSC_BK76_05_H      0x14000B
#define REG_FSC_BK76_06_L      0x14000C
#define REG_FSC_BK76_06_H      0x14000D
#define REG_FSC_BK76_07_L      0x14000E
#define REG_FSC_BK76_07_H      0x14000F
#define REG_FSC_BK76_08_L      0x140010
#define REG_FSC_BK76_08_H      0x140011
#define REG_FSC_BK76_09_L      0x140012
#define REG_FSC_BK76_09_H      0x140013
#define REG_FSC_BK76_0A_L      0x140014
#define REG_FSC_BK76_0A_H      0x140015
#define REG_FSC_BK76_0B_L      0x140016
#define REG_FSC_BK76_0B_H      0x140017
#define REG_FSC_BK76_0C_L      0x140018
#define REG_FSC_BK76_0C_H      0x140019
#define REG_FSC_BK76_0D_L      0x14001A
#define REG_FSC_BK76_0D_H      0x14001B
#define REG_FSC_BK76_0E_L      0x14001C
#define REG_FSC_BK76_0E_H      0x14001D
#define REG_FSC_BK76_0F_L      0x14001E
#define REG_FSC_BK76_0F_H      0x14001F
#define REG_FSC_BK76_10_L      0x140020
#define REG_FSC_BK76_10_H      0x140021
#define REG_FSC_BK76_11_L      0x140022
#define REG_FSC_BK76_11_H      0x140023
#define REG_FSC_BK76_12_L      0x140024
#define REG_FSC_BK76_12_H      0x140025
#define REG_FSC_BK76_13_L      0x140026
#define REG_FSC_BK76_13_H      0x140027
#define REG_FSC_BK76_14_L      0x140028
#define REG_FSC_BK76_14_H      0x140029
#define REG_FSC_BK76_15_L      0x14002A
#define REG_FSC_BK76_15_H      0x14002B
#define REG_FSC_BK76_16_L      0x14002C
#define REG_FSC_BK76_16_H      0x14002D
#define REG_FSC_BK76_17_L      0x14002E
#define REG_FSC_BK76_17_H      0x14002F
#define REG_FSC_BK76_18_L      0x140030
#define REG_FSC_BK76_18_H      0x140031
#define REG_FSC_BK76_19_L      0x140032
#define REG_FSC_BK76_19_H      0x140033
#define REG_FSC_BK76_1A_L      0x140034
#define REG_FSC_BK76_1A_H      0x140035
#define REG_FSC_BK76_1B_L      0x140036
#define REG_FSC_BK76_1B_H      0x140037
#define REG_FSC_BK76_1C_L      0x140038
#define REG_FSC_BK76_1C_H      0x140039
#define REG_FSC_BK76_1D_L      0x14003A
#define REG_FSC_BK76_1D_H      0x14003B
#define REG_FSC_BK76_1E_L      0x14003C
#define REG_FSC_BK76_1E_H      0x14003D
#define REG_FSC_BK76_1F_L      0x14003E
#define REG_FSC_BK76_1F_H      0x14003F
#define REG_FSC_BK76_20_L      0x140040
#define REG_FSC_BK76_20_H      0x140041
#define REG_FSC_BK76_21_L      0x140042
#define REG_FSC_BK76_21_H      0x140043
#define REG_FSC_BK76_22_L      0x140044
#define REG_FSC_BK76_22_H      0x140045
#define REG_FSC_BK76_23_L      0x140046
#define REG_FSC_BK76_23_H      0x140047
#define REG_FSC_BK76_24_L      0x140048
#define REG_FSC_BK76_24_H      0x140049
#define REG_FSC_BK76_25_L      0x14004A
#define REG_FSC_BK76_25_H      0x14004B
#define REG_FSC_BK76_26_L      0x14004C
#define REG_FSC_BK76_26_H      0x14004D
#define REG_FSC_BK76_27_L      0x14004E
#define REG_FSC_BK76_27_H      0x14004F
#define REG_FSC_BK76_28_L      0x140050
#define REG_FSC_BK76_28_H      0x140051
#define REG_FSC_BK76_29_L      0x140052
#define REG_FSC_BK76_29_H      0x140053
#define REG_FSC_BK76_2A_L      0x140054
#define REG_FSC_BK76_2A_H      0x140055
#define REG_FSC_BK76_2B_L      0x140056
#define REG_FSC_BK76_2B_H      0x140057
#define REG_FSC_BK76_2C_L      0x140058
#define REG_FSC_BK76_2C_H      0x140059
#define REG_FSC_BK76_2D_L      0x14005A
#define REG_FSC_BK76_2D_H      0x14005B
#define REG_FSC_BK76_2E_L      0x14005C
#define REG_FSC_BK76_2E_H      0x14005D
#define REG_FSC_BK76_2F_L      0x14005E
#define REG_FSC_BK76_2F_H      0x14005F
#define REG_FSC_BK76_30_L      0x140060
#define REG_FSC_BK76_30_H      0x140061
#define REG_FSC_BK76_31_L      0x140062
#define REG_FSC_BK76_31_H      0x140063
#define REG_FSC_BK76_32_L      0x140064
#define REG_FSC_BK76_32_H      0x140065
#define REG_FSC_BK76_33_L      0x140066
#define REG_FSC_BK76_33_H      0x140067
#define REG_FSC_BK76_34_L      0x140068
#define REG_FSC_BK76_34_H      0x140069
#define REG_FSC_BK76_35_L      0x14006A
#define REG_FSC_BK76_35_H      0x14006B
#define REG_FSC_BK76_36_L      0x14006C
#define REG_FSC_BK76_36_H      0x14006D
#define REG_FSC_BK76_37_L      0x14006E
#define REG_FSC_BK76_37_H      0x14006F
#define REG_FSC_BK76_38_L      0x140070
#define REG_FSC_BK76_38_H      0x140071
#define REG_FSC_BK76_39_L      0x140072
#define REG_FSC_BK76_39_H      0x140073
#define REG_FSC_BK76_3A_L      0x140074
#define REG_FSC_BK76_3A_H      0x140075
#define REG_FSC_BK76_3B_L      0x140076
#define REG_FSC_BK76_3B_H      0x140077
#define REG_FSC_BK76_3C_L      0x140078
#define REG_FSC_BK76_3C_H      0x140079
#define REG_FSC_BK76_3D_L      0x14007A
#define REG_FSC_BK76_3D_H      0x14007B
#define REG_FSC_BK76_3E_L      0x14007C
#define REG_FSC_BK76_3E_H      0x14007D
#define REG_FSC_BK76_3F_L      0x14007E
#define REG_FSC_BK76_3F_H      0x14007F
#define REG_FSC_BK76_40_L      0x140080
#define REG_FSC_BK76_40_H      0x140081
#define REG_FSC_BK76_41_L      0x140082
#define REG_FSC_BK76_41_H      0x140083
#define REG_FSC_BK76_42_L      0x140084
#define REG_FSC_BK76_42_H      0x140085
#define REG_FSC_BK76_43_L      0x140086
#define REG_FSC_BK76_43_H      0x140087
#define REG_FSC_BK76_44_L      0x140088
#define REG_FSC_BK76_44_H      0x140089
#define REG_FSC_BK76_45_L      0x14008A
#define REG_FSC_BK76_45_H      0x14008B
#define REG_FSC_BK76_46_L      0x14008C
#define REG_FSC_BK76_46_H      0x14008D
#define REG_FSC_BK76_47_L      0x14008E
#define REG_FSC_BK76_47_H      0x14008F
#define REG_FSC_BK76_48_L      0x140090
#define REG_FSC_BK76_48_H      0x140091
#define REG_FSC_BK76_49_L      0x140092
#define REG_FSC_BK76_49_H      0x140093
#define REG_FSC_BK76_4A_L      0x140094
#define REG_FSC_BK76_4A_H      0x140095
#define REG_FSC_BK76_4B_L      0x140096
#define REG_FSC_BK76_4B_H      0x140097
#define REG_FSC_BK76_4C_L      0x140098
#define REG_FSC_BK76_4C_H      0x140099
#define REG_FSC_BK76_4D_L      0x14009A
#define REG_FSC_BK76_4D_H      0x14009B
#define REG_FSC_BK76_4E_L      0x14009C
#define REG_FSC_BK76_4E_H      0x14009D
#define REG_FSC_BK76_4F_L      0x14009E
#define REG_FSC_BK76_4F_H      0x14009F
#define REG_FSC_BK76_50_L      0x1400A0
#define REG_FSC_BK76_50_H      0x1400A1
#define REG_FSC_BK76_51_L      0x1400A2
#define REG_FSC_BK76_51_H      0x1400A3
#define REG_FSC_BK76_52_L      0x1400A4
#define REG_FSC_BK76_52_H      0x1400A5
#define REG_FSC_BK76_53_L      0x1400A6
#define REG_FSC_BK76_53_H      0x1400A7
#define REG_FSC_BK76_54_L      0x1400A8
#define REG_FSC_BK76_54_H      0x1400A9
#define REG_FSC_BK76_55_L      0x1400AA
#define REG_FSC_BK76_55_H      0x1400AB
#define REG_FSC_BK76_56_L      0x1400AC
#define REG_FSC_BK76_56_H      0x1400AD
#define REG_FSC_BK76_57_L      0x1400AE
#define REG_FSC_BK76_57_H      0x1400AF
#define REG_FSC_BK76_58_L      0x1400B0
#define REG_FSC_BK76_58_H      0x1400B1
#define REG_FSC_BK76_59_L      0x1400B2
#define REG_FSC_BK76_59_H      0x1400B3
#define REG_FSC_BK76_5A_L      0x1400B4
#define REG_FSC_BK76_5A_H      0x1400B5
#define REG_FSC_BK76_5B_L      0x1400B6
#define REG_FSC_BK76_5B_H      0x1400B7
#define REG_FSC_BK76_5C_L      0x1400B8
#define REG_FSC_BK76_5C_H      0x1400B9
#define REG_FSC_BK76_5D_L      0x1400BA
#define REG_FSC_BK76_5D_H      0x1400BB
#define REG_FSC_BK76_5E_L      0x1400BC
#define REG_FSC_BK76_5E_H      0x1400BD
#define REG_FSC_BK76_5F_L      0x1400BE
#define REG_FSC_BK76_5F_H      0x1400BF
#define REG_FSC_BK76_60_L      0x1400C0
#define REG_FSC_BK76_60_H      0x1400C1
#define REG_FSC_BK76_61_L      0x1400C2
#define REG_FSC_BK76_61_H      0x1400C3
#define REG_FSC_BK76_62_L      0x1400C4
#define REG_FSC_BK76_62_H      0x1400C5
#define REG_FSC_BK76_63_L      0x1400C6
#define REG_FSC_BK76_63_H      0x1400C7
#define REG_FSC_BK76_64_L      0x1400C8
#define REG_FSC_BK76_64_H      0x1400C9
#define REG_FSC_BK76_65_L      0x1400CA
#define REG_FSC_BK76_65_H      0x1400CB
#define REG_FSC_BK76_66_L      0x1400CC
#define REG_FSC_BK76_66_H      0x1400CD
#define REG_FSC_BK76_67_L      0x1400CE
#define REG_FSC_BK76_67_H      0x1400CF
#define REG_FSC_BK76_68_L      0x1400D0
#define REG_FSC_BK76_68_H      0x1400D1
#define REG_FSC_BK76_69_L      0x1400D2
#define REG_FSC_BK76_69_H      0x1400D3
#define REG_FSC_BK76_6A_L      0x1400D4
#define REG_FSC_BK76_6A_H      0x1400D5
#define REG_FSC_BK76_6B_L      0x1400D6
#define REG_FSC_BK76_6B_H      0x1400D7
#define REG_FSC_BK76_6C_L      0x1400D8
#define REG_FSC_BK76_6C_H      0x1400D9
#define REG_FSC_BK76_6D_L      0x1400DA
#define REG_FSC_BK76_6D_H      0x1400DB
#define REG_FSC_BK76_6E_L      0x1400DC
#define REG_FSC_BK76_6E_H      0x1400DD
#define REG_FSC_BK76_6F_L      0x1400DE
#define REG_FSC_BK76_6F_H      0x1400DF
#define REG_FSC_BK76_70_L      0x1400E0
#define REG_FSC_BK76_70_H      0x1400E1
#define REG_FSC_BK76_71_L      0x1400E2
#define REG_FSC_BK76_71_H      0x1400E3
#define REG_FSC_BK76_72_L      0x1400E4
#define REG_FSC_BK76_72_H      0x1400E5
#define REG_FSC_BK76_73_L      0x1400E6
#define REG_FSC_BK76_73_H      0x1400E7
#define REG_FSC_BK76_74_L      0x1400E8
#define REG_FSC_BK76_74_H      0x1400E9
#define REG_FSC_BK76_75_L      0x1400EA
#define REG_FSC_BK76_75_H      0x1400EB
#define REG_FSC_BK76_76_L      0x1400EC
#define REG_FSC_BK76_76_H      0x1400ED
#define REG_FSC_BK76_77_L      0x1400EE
#define REG_FSC_BK76_77_H      0x1400EF
#define REG_FSC_BK76_78_L      0x1400F0
#define REG_FSC_BK76_78_H      0x1400F1
#define REG_FSC_BK76_79_L      0x1400F2
#define REG_FSC_BK76_79_H      0x1400F3
#define REG_FSC_BK76_7A_L      0x1400F4
#define REG_FSC_BK76_7A_H      0x1400F5
#define REG_FSC_BK76_7B_L      0x1400F6
#define REG_FSC_BK76_7B_H      0x1400F7
#define REG_FSC_BK76_7C_L      0x1400F8
#define REG_FSC_BK76_7C_H      0x1400F9
#define REG_FSC_BK76_7D_L      0x1400FA
#define REG_FSC_BK76_7D_H      0x1400FB
#define REG_FSC_BK76_7E_L      0x1400FC
#define REG_FSC_BK76_7E_H      0x1400FD
#define REG_FSC_BK76_7F_L      0x1400FE
#define REG_FSC_BK76_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BKAC_00_L      0x140000
#define REG_FSC_BKAC_00_H      0x140001
#define REG_FSC_BKAC_01_L      0x140002
#define REG_FSC_BKAC_01_H      0x140003
#define REG_FSC_BKAC_02_L      0x140004
#define REG_FSC_BKAC_02_H      0x140005
#define REG_FSC_BKAC_03_L      0x140006
#define REG_FSC_BKAC_03_H      0x140007
#define REG_FSC_BKAC_04_L      0x140008
#define REG_FSC_BKAC_04_H      0x140009
#define REG_FSC_BKAC_05_L      0x14000A
#define REG_FSC_BKAC_05_H      0x14000B
#define REG_FSC_BKAC_06_L      0x14000C
#define REG_FSC_BKAC_06_H      0x14000D
#define REG_FSC_BKAC_07_L      0x14000E
#define REG_FSC_BKAC_07_H      0x14000F
#define REG_FSC_BKAC_08_L      0x140010
#define REG_FSC_BKAC_08_H      0x140011
#define REG_FSC_BKAC_09_L      0x140012
#define REG_FSC_BKAC_09_H      0x140013
#define REG_FSC_BKAC_0A_L      0x140014
#define REG_FSC_BKAC_0A_H      0x140015
#define REG_FSC_BKAC_0B_L      0x140016
#define REG_FSC_BKAC_0B_H      0x140017
#define REG_FSC_BKAC_0C_L      0x140018
#define REG_FSC_BKAC_0C_H      0x140019
#define REG_FSC_BKAC_0D_L      0x14001A
#define REG_FSC_BKAC_0D_H      0x14001B
#define REG_FSC_BKAC_0E_L      0x14001C
#define REG_FSC_BKAC_0E_H      0x14001D
#define REG_FSC_BKAC_0F_L      0x14001E
#define REG_FSC_BKAC_0F_H      0x14001F
#define REG_FSC_BKAC_10_L      0x140020
#define REG_FSC_BKAC_10_H      0x140021
#define REG_FSC_BKAC_11_L      0x140022
#define REG_FSC_BKAC_11_H      0x140023
#define REG_FSC_BKAC_12_L      0x140024
#define REG_FSC_BKAC_12_H      0x140025
#define REG_FSC_BKAC_13_L      0x140026
#define REG_FSC_BKAC_13_H      0x140027
#define REG_FSC_BKAC_14_L      0x140028
#define REG_FSC_BKAC_14_H      0x140029
#define REG_FSC_BKAC_15_L      0x14002A
#define REG_FSC_BKAC_15_H      0x14002B
#define REG_FSC_BKAC_16_L      0x14002C
#define REG_FSC_BKAC_16_H      0x14002D
#define REG_FSC_BKAC_17_L      0x14002E
#define REG_FSC_BKAC_17_H      0x14002F
#define REG_FSC_BKAC_18_L      0x140030
#define REG_FSC_BKAC_18_H      0x140031
#define REG_FSC_BKAC_19_L      0x140032
#define REG_FSC_BKAC_19_H      0x140033
#define REG_FSC_BKAC_1A_L      0x140034
#define REG_FSC_BKAC_1A_H      0x140035
#define REG_FSC_BKAC_1B_L      0x140036
#define REG_FSC_BKAC_1B_H      0x140037
#define REG_FSC_BKAC_1C_L      0x140038
#define REG_FSC_BKAC_1C_H      0x140039
#define REG_FSC_BKAC_1D_L      0x14003A
#define REG_FSC_BKAC_1D_H      0x14003B
#define REG_FSC_BKAC_1E_L      0x14003C
#define REG_FSC_BKAC_1E_H      0x14003D
#define REG_FSC_BKAC_1F_L      0x14003E
#define REG_FSC_BKAC_1F_H      0x14003F
#define REG_FSC_BKAC_20_L      0x140040
#define REG_FSC_BKAC_20_H      0x140041
#define REG_FSC_BKAC_21_L      0x140042
#define REG_FSC_BKAC_21_H      0x140043
#define REG_FSC_BKAC_22_L      0x140044
#define REG_FSC_BKAC_22_H      0x140045
#define REG_FSC_BKAC_23_L      0x140046
#define REG_FSC_BKAC_23_H      0x140047
#define REG_FSC_BKAC_24_L      0x140048
#define REG_FSC_BKAC_24_H      0x140049
#define REG_FSC_BKAC_25_L      0x14004A
#define REG_FSC_BKAC_25_H      0x14004B
#define REG_FSC_BKAC_26_L      0x14004C
#define REG_FSC_BKAC_26_H      0x14004D
#define REG_FSC_BKAC_27_L      0x14004E
#define REG_FSC_BKAC_27_H      0x14004F
#define REG_FSC_BKAC_28_L      0x140050
#define REG_FSC_BKAC_28_H      0x140051
#define REG_FSC_BKAC_29_L      0x140052
#define REG_FSC_BKAC_29_H      0x140053
#define REG_FSC_BKAC_2A_L      0x140054
#define REG_FSC_BKAC_2A_H      0x140055
#define REG_FSC_BKAC_2B_L      0x140056
#define REG_FSC_BKAC_2B_H      0x140057
#define REG_FSC_BKAC_2C_L      0x140058
#define REG_FSC_BKAC_2C_H      0x140059
#define REG_FSC_BKAC_2D_L      0x14005A
#define REG_FSC_BKAC_2D_H      0x14005B
#define REG_FSC_BKAC_2E_L      0x14005C
#define REG_FSC_BKAC_2E_H      0x14005D
#define REG_FSC_BKAC_2F_L      0x14005E
#define REG_FSC_BKAC_2F_H      0x14005F
#define REG_FSC_BKAC_30_L      0x140060
#define REG_FSC_BKAC_30_H      0x140061
#define REG_FSC_BKAC_31_L      0x140062
#define REG_FSC_BKAC_31_H      0x140063
#define REG_FSC_BKAC_32_L      0x140064
#define REG_FSC_BKAC_32_H      0x140065
#define REG_FSC_BKAC_33_L      0x140066
#define REG_FSC_BKAC_33_H      0x140067
#define REG_FSC_BKAC_34_L      0x140068
#define REG_FSC_BKAC_34_H      0x140069
#define REG_FSC_BKAC_35_L      0x14006A
#define REG_FSC_BKAC_35_H      0x14006B
#define REG_FSC_BKAC_36_L      0x14006C
#define REG_FSC_BKAC_36_H      0x14006D
#define REG_FSC_BKAC_37_L      0x14006E
#define REG_FSC_BKAC_37_H      0x14006F
#define REG_FSC_BKAC_38_L      0x140070
#define REG_FSC_BKAC_38_H      0x140071
#define REG_FSC_BKAC_39_L      0x140072
#define REG_FSC_BKAC_39_H      0x140073
#define REG_FSC_BKAC_3A_L      0x140074
#define REG_FSC_BKAC_3A_H      0x140075
#define REG_FSC_BKAC_3B_L      0x140076
#define REG_FSC_BKAC_3B_H      0x140077
#define REG_FSC_BKAC_3C_L      0x140078
#define REG_FSC_BKAC_3C_H      0x140079
#define REG_FSC_BKAC_3D_L      0x14007A
#define REG_FSC_BKAC_3D_H      0x14007B
#define REG_FSC_BKAC_3E_L      0x14007C
#define REG_FSC_BKAC_3E_H      0x14007D
#define REG_FSC_BKAC_3F_L      0x14007E
#define REG_FSC_BKAC_3F_H      0x14007F
#define REG_FSC_BKAC_40_L      0x140080
#define REG_FSC_BKAC_40_H      0x140081
#define REG_FSC_BKAC_41_L      0x140082
#define REG_FSC_BKAC_41_H      0x140083
#define REG_FSC_BKAC_42_L      0x140084
#define REG_FSC_BKAC_42_H      0x140085
#define REG_FSC_BKAC_43_L      0x140086
#define REG_FSC_BKAC_43_H      0x140087
#define REG_FSC_BKAC_44_L      0x140088
#define REG_FSC_BKAC_44_H      0x140089
#define REG_FSC_BKAC_45_L      0x14008A
#define REG_FSC_BKAC_45_H      0x14008B
#define REG_FSC_BKAC_46_L      0x14008C
#define REG_FSC_BKAC_46_H      0x14008D
#define REG_FSC_BKAC_47_L      0x14008E
#define REG_FSC_BKAC_47_H      0x14008F
#define REG_FSC_BKAC_48_L      0x140090
#define REG_FSC_BKAC_48_H      0x140091
#define REG_FSC_BKAC_49_L      0x140092
#define REG_FSC_BKAC_49_H      0x140093
#define REG_FSC_BKAC_4A_L      0x140094
#define REG_FSC_BKAC_4A_H      0x140095
#define REG_FSC_BKAC_4B_L      0x140096
#define REG_FSC_BKAC_4B_H      0x140097
#define REG_FSC_BKAC_4C_L      0x140098
#define REG_FSC_BKAC_4C_H      0x140099
#define REG_FSC_BKAC_4D_L      0x14009A
#define REG_FSC_BKAC_4D_H      0x14009B
#define REG_FSC_BKAC_4E_L      0x14009C
#define REG_FSC_BKAC_4E_H      0x14009D
#define REG_FSC_BKAC_4F_L      0x14009E
#define REG_FSC_BKAC_4F_H      0x14009F
#define REG_FSC_BKAC_50_L      0x1400A0
#define REG_FSC_BKAC_50_H      0x1400A1
#define REG_FSC_BKAC_51_L      0x1400A2
#define REG_FSC_BKAC_51_H      0x1400A3
#define REG_FSC_BKAC_52_L      0x1400A4
#define REG_FSC_BKAC_52_H      0x1400A5
#define REG_FSC_BKAC_53_L      0x1400A6
#define REG_FSC_BKAC_53_H      0x1400A7
#define REG_FSC_BKAC_54_L      0x1400A8
#define REG_FSC_BKAC_54_H      0x1400A9
#define REG_FSC_BKAC_55_L      0x1400AA
#define REG_FSC_BKAC_55_H      0x1400AB
#define REG_FSC_BKAC_56_L      0x1400AC
#define REG_FSC_BKAC_56_H      0x1400AD
#define REG_FSC_BKAC_57_L      0x1400AE
#define REG_FSC_BKAC_57_H      0x1400AF
#define REG_FSC_BKAC_58_L      0x1400B0
#define REG_FSC_BKAC_58_H      0x1400B1
#define REG_FSC_BKAC_59_L      0x1400B2
#define REG_FSC_BKAC_59_H      0x1400B3
#define REG_FSC_BKAC_5A_L      0x1400B4
#define REG_FSC_BKAC_5A_H      0x1400B5
#define REG_FSC_BKAC_5B_L      0x1400B6
#define REG_FSC_BKAC_5B_H      0x1400B7
#define REG_FSC_BKAC_5C_L      0x1400B8
#define REG_FSC_BKAC_5C_H      0x1400B9
#define REG_FSC_BKAC_5D_L      0x1400BA
#define REG_FSC_BKAC_5D_H      0x1400BB
#define REG_FSC_BKAC_5E_L      0x1400BC
#define REG_FSC_BKAC_5E_H      0x1400BD
#define REG_FSC_BKAC_5F_L      0x1400BE
#define REG_FSC_BKAC_5F_H      0x1400BF
#define REG_FSC_BKAC_60_L      0x1400C0
#define REG_FSC_BKAC_60_H      0x1400C1
#define REG_FSC_BKAC_61_L      0x1400C2
#define REG_FSC_BKAC_61_H      0x1400C3
#define REG_FSC_BKAC_62_L      0x1400C4
#define REG_FSC_BKAC_62_H      0x1400C5
#define REG_FSC_BKAC_63_L      0x1400C6
#define REG_FSC_BKAC_63_H      0x1400C7
#define REG_FSC_BKAC_64_L      0x1400C8
#define REG_FSC_BKAC_64_H      0x1400C9
#define REG_FSC_BKAC_65_L      0x1400CA
#define REG_FSC_BKAC_65_H      0x1400CB
#define REG_FSC_BKAC_66_L      0x1400CC
#define REG_FSC_BKAC_66_H      0x1400CD
#define REG_FSC_BKAC_67_L      0x1400CE
#define REG_FSC_BKAC_67_H      0x1400CF
#define REG_FSC_BKAC_68_L      0x1400D0
#define REG_FSC_BKAC_68_H      0x1400D1
#define REG_FSC_BKAC_69_L      0x1400D2
#define REG_FSC_BKAC_69_H      0x1400D3
#define REG_FSC_BKAC_6A_L      0x1400D4
#define REG_FSC_BKAC_6A_H      0x1400D5
#define REG_FSC_BKAC_6B_L      0x1400D6
#define REG_FSC_BKAC_6B_H      0x1400D7
#define REG_FSC_BKAC_6C_L      0x1400D8
#define REG_FSC_BKAC_6C_H      0x1400D9
#define REG_FSC_BKAC_6D_L      0x1400DA
#define REG_FSC_BKAC_6D_H      0x1400DB
#define REG_FSC_BKAC_6E_L      0x1400DC
#define REG_FSC_BKAC_6E_H      0x1400DD
#define REG_FSC_BKAC_6F_L      0x1400DE
#define REG_FSC_BKAC_6F_H      0x1400DF
#define REG_FSC_BKAC_70_L      0x1400E0
#define REG_FSC_BKAC_70_H      0x1400E1
#define REG_FSC_BKAC_71_L      0x1400E2
#define REG_FSC_BKAC_71_H      0x1400E3
#define REG_FSC_BKAC_72_L      0x1400E4
#define REG_FSC_BKAC_72_H      0x1400E5
#define REG_FSC_BKAC_73_L      0x1400E6
#define REG_FSC_BKAC_73_H      0x1400E7
#define REG_FSC_BKAC_74_L      0x1400E8
#define REG_FSC_BKAC_74_H      0x1400E9
#define REG_FSC_BKAC_75_L      0x1400EA
#define REG_FSC_BKAC_75_H      0x1400EB
#define REG_FSC_BKAC_76_L      0x1400EC
#define REG_FSC_BKAC_76_H      0x1400ED
#define REG_FSC_BKAC_77_L      0x1400EE
#define REG_FSC_BKAC_77_H      0x1400EF
#define REG_FSC_BKAC_78_L      0x1400F0
#define REG_FSC_BKAC_78_H      0x1400F1
#define REG_FSC_BKAC_79_L      0x1400F2
#define REG_FSC_BKAC_79_H      0x1400F3
#define REG_FSC_BKAC_7A_L      0x1400F4
#define REG_FSC_BKAC_7A_H      0x1400F5
#define REG_FSC_BKAC_7B_L      0x1400F6
#define REG_FSC_BKAC_7B_H      0x1400F7
#define REG_FSC_BKAC_7C_L      0x1400F8
#define REG_FSC_BKAC_7C_H      0x1400F9
#define REG_FSC_BKAC_7D_L      0x1400FA
#define REG_FSC_BKAC_7D_H      0x1400FB
#define REG_FSC_BKAC_7E_L      0x1400FC
#define REG_FSC_BKAC_7E_H      0x1400FD
#define REG_FSC_BKAC_7F_L      0x1400FE
#define REG_FSC_BKAC_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BKCD_00_L      0x140000
#define REG_FSC_BKCD_00_H      0x140001
#define REG_FSC_BKCD_01_L      0x140002
#define REG_FSC_BKCD_01_H      0x140003
#define REG_FSC_BKCD_02_L      0x140004
#define REG_FSC_BKCD_02_H      0x140005
#define REG_FSC_BKCD_03_L      0x140006
#define REG_FSC_BKCD_03_H      0x140007
#define REG_FSC_BKCD_04_L      0x140008
#define REG_FSC_BKCD_04_H      0x140009
#define REG_FSC_BKCD_05_L      0x14000A
#define REG_FSC_BKCD_05_H      0x14000B
#define REG_FSC_BKCD_06_L      0x14000C
#define REG_FSC_BKCD_06_H      0x14000D
#define REG_FSC_BKCD_07_L      0x14000E
#define REG_FSC_BKCD_07_H      0x14000F
#define REG_FSC_BKCD_08_L      0x140010
#define REG_FSC_BKCD_08_H      0x140011
#define REG_FSC_BKCD_09_L      0x140012
#define REG_FSC_BKCD_09_H      0x140013
#define REG_FSC_BKCD_0A_L      0x140014
#define REG_FSC_BKCD_0A_H      0x140015
#define REG_FSC_BKCD_0B_L      0x140016
#define REG_FSC_BKCD_0B_H      0x140017
#define REG_FSC_BKCD_0C_L      0x140018
#define REG_FSC_BKCD_0C_H      0x140019
#define REG_FSC_BKCD_0D_L      0x14001A
#define REG_FSC_BKCD_0D_H      0x14001B
#define REG_FSC_BKCD_0E_L      0x14001C
#define REG_FSC_BKCD_0E_H      0x14001D
#define REG_FSC_BKCD_0F_L      0x14001E
#define REG_FSC_BKCD_0F_H      0x14001F
#define REG_FSC_BKCD_10_L      0x140020
#define REG_FSC_BKCD_10_H      0x140021
#define REG_FSC_BKCD_11_L      0x140022
#define REG_FSC_BKCD_11_H      0x140023
#define REG_FSC_BKCD_12_L      0x140024
#define REG_FSC_BKCD_12_H      0x140025
#define REG_FSC_BKCD_13_L      0x140026
#define REG_FSC_BKCD_13_H      0x140027
#define REG_FSC_BKCD_14_L      0x140028
#define REG_FSC_BKCD_14_H      0x140029
#define REG_FSC_BKCD_15_L      0x14002A
#define REG_FSC_BKCD_15_H      0x14002B
#define REG_FSC_BKCD_16_L      0x14002C
#define REG_FSC_BKCD_16_H      0x14002D
#define REG_FSC_BKCD_17_L      0x14002E
#define REG_FSC_BKCD_17_H      0x14002F
#define REG_FSC_BKCD_18_L      0x140030
#define REG_FSC_BKCD_18_H      0x140031
#define REG_FSC_BKCD_19_L      0x140032
#define REG_FSC_BKCD_19_H      0x140033
#define REG_FSC_BKCD_1A_L      0x140034
#define REG_FSC_BKCD_1A_H      0x140035
#define REG_FSC_BKCD_1B_L      0x140036
#define REG_FSC_BKCD_1B_H      0x140037
#define REG_FSC_BKCD_1C_L      0x140038
#define REG_FSC_BKCD_1C_H      0x140039
#define REG_FSC_BKCD_1D_L      0x14003A
#define REG_FSC_BKCD_1D_H      0x14003B
#define REG_FSC_BKCD_1E_L      0x14003C
#define REG_FSC_BKCD_1E_H      0x14003D
#define REG_FSC_BKCD_1F_L      0x14003E
#define REG_FSC_BKCD_1F_H      0x14003F
#define REG_FSC_BKCD_20_L      0x140040
#define REG_FSC_BKCD_20_H      0x140041
#define REG_FSC_BKCD_21_L      0x140042
#define REG_FSC_BKCD_21_H      0x140043
#define REG_FSC_BKCD_22_L      0x140044
#define REG_FSC_BKCD_22_H      0x140045
#define REG_FSC_BKCD_23_L      0x140046
#define REG_FSC_BKCD_23_H      0x140047
#define REG_FSC_BKCD_24_L      0x140048
#define REG_FSC_BKCD_24_H      0x140049
#define REG_FSC_BKCD_25_L      0x14004A
#define REG_FSC_BKCD_25_H      0x14004B
#define REG_FSC_BKCD_26_L      0x14004C
#define REG_FSC_BKCD_26_H      0x14004D
#define REG_FSC_BKCD_27_L      0x14004E
#define REG_FSC_BKCD_27_H      0x14004F
#define REG_FSC_BKCD_28_L      0x140050
#define REG_FSC_BKCD_28_H      0x140051
#define REG_FSC_BKCD_29_L      0x140052
#define REG_FSC_BKCD_29_H      0x140053
#define REG_FSC_BKCD_2A_L      0x140054
#define REG_FSC_BKCD_2A_H      0x140055
#define REG_FSC_BKCD_2B_L      0x140056
#define REG_FSC_BKCD_2B_H      0x140057
#define REG_FSC_BKCD_2C_L      0x140058
#define REG_FSC_BKCD_2C_H      0x140059
#define REG_FSC_BKCD_2D_L      0x14005A
#define REG_FSC_BKCD_2D_H      0x14005B
#define REG_FSC_BKCD_2E_L      0x14005C
#define REG_FSC_BKCD_2E_H      0x14005D
#define REG_FSC_BKCD_2F_L      0x14005E
#define REG_FSC_BKCD_2F_H      0x14005F
#define REG_FSC_BKCD_30_L      0x140060
#define REG_FSC_BKCD_30_H      0x140061
#define REG_FSC_BKCD_31_L      0x140062
#define REG_FSC_BKCD_31_H      0x140063
#define REG_FSC_BKCD_32_L      0x140064
#define REG_FSC_BKCD_32_H      0x140065
#define REG_FSC_BKCD_33_L      0x140066
#define REG_FSC_BKCD_33_H      0x140067
#define REG_FSC_BKCD_34_L      0x140068
#define REG_FSC_BKCD_34_H      0x140069
#define REG_FSC_BKCD_35_L      0x14006A
#define REG_FSC_BKCD_35_H      0x14006B
#define REG_FSC_BKCD_36_L      0x14006C
#define REG_FSC_BKCD_36_H      0x14006D
#define REG_FSC_BKCD_37_L      0x14006E
#define REG_FSC_BKCD_37_H      0x14006F
#define REG_FSC_BKCD_38_L      0x140070
#define REG_FSC_BKCD_38_H      0x140071
#define REG_FSC_BKCD_39_L      0x140072
#define REG_FSC_BKCD_39_H      0x140073
#define REG_FSC_BKCD_3A_L      0x140074
#define REG_FSC_BKCD_3A_H      0x140075
#define REG_FSC_BKCD_3B_L      0x140076
#define REG_FSC_BKCD_3B_H      0x140077
#define REG_FSC_BKCD_3C_L      0x140078
#define REG_FSC_BKCD_3C_H      0x140079
#define REG_FSC_BKCD_3D_L      0x14007A
#define REG_FSC_BKCD_3D_H      0x14007B
#define REG_FSC_BKCD_3E_L      0x14007C
#define REG_FSC_BKCD_3E_H      0x14007D
#define REG_FSC_BKCD_3F_L      0x14007E
#define REG_FSC_BKCD_3F_H      0x14007F
#define REG_FSC_BKCD_40_L      0x140080
#define REG_FSC_BKCD_40_H      0x140081
#define REG_FSC_BKCD_41_L      0x140082
#define REG_FSC_BKCD_41_H      0x140083
#define REG_FSC_BKCD_42_L      0x140084
#define REG_FSC_BKCD_42_H      0x140085
#define REG_FSC_BKCD_43_L      0x140086
#define REG_FSC_BKCD_43_H      0x140087
#define REG_FSC_BKCD_44_L      0x140088
#define REG_FSC_BKCD_44_H      0x140089
#define REG_FSC_BKCD_45_L      0x14008A
#define REG_FSC_BKCD_45_H      0x14008B
#define REG_FSC_BKCD_46_L      0x14008C
#define REG_FSC_BKCD_46_H      0x14008D
#define REG_FSC_BKCD_47_L      0x14008E
#define REG_FSC_BKCD_47_H      0x14008F
#define REG_FSC_BKCD_48_L      0x140090
#define REG_FSC_BKCD_48_H      0x140091
#define REG_FSC_BKCD_49_L      0x140092
#define REG_FSC_BKCD_49_H      0x140093
#define REG_FSC_BKCD_4A_L      0x140094
#define REG_FSC_BKCD_4A_H      0x140095
#define REG_FSC_BKCD_4B_L      0x140096
#define REG_FSC_BKCD_4B_H      0x140097
#define REG_FSC_BKCD_4C_L      0x140098
#define REG_FSC_BKCD_4C_H      0x140099
#define REG_FSC_BKCD_4D_L      0x14009A
#define REG_FSC_BKCD_4D_H      0x14009B
#define REG_FSC_BKCD_4E_L      0x14009C
#define REG_FSC_BKCD_4E_H      0x14009D
#define REG_FSC_BKCD_4F_L      0x14009E
#define REG_FSC_BKCD_4F_H      0x14009F
#define REG_FSC_BKCD_50_L      0x1400A0
#define REG_FSC_BKCD_50_H      0x1400A1
#define REG_FSC_BKCD_51_L      0x1400A2
#define REG_FSC_BKCD_51_H      0x1400A3
#define REG_FSC_BKCD_52_L      0x1400A4
#define REG_FSC_BKCD_52_H      0x1400A5
#define REG_FSC_BKCD_53_L      0x1400A6
#define REG_FSC_BKCD_53_H      0x1400A7
#define REG_FSC_BKCD_54_L      0x1400A8
#define REG_FSC_BKCD_54_H      0x1400A9
#define REG_FSC_BKCD_55_L      0x1400AA
#define REG_FSC_BKCD_55_H      0x1400AB
#define REG_FSC_BKCD_56_L      0x1400AC
#define REG_FSC_BKCD_56_H      0x1400AD
#define REG_FSC_BKCD_57_L      0x1400AE
#define REG_FSC_BKCD_57_H      0x1400AF
#define REG_FSC_BKCD_58_L      0x1400B0
#define REG_FSC_BKCD_58_H      0x1400B1
#define REG_FSC_BKCD_59_L      0x1400B2
#define REG_FSC_BKCD_59_H      0x1400B3
#define REG_FSC_BKCD_5A_L      0x1400B4
#define REG_FSC_BKCD_5A_H      0x1400B5
#define REG_FSC_BKCD_5B_L      0x1400B6
#define REG_FSC_BKCD_5B_H      0x1400B7
#define REG_FSC_BKCD_5C_L      0x1400B8
#define REG_FSC_BKCD_5C_H      0x1400B9
#define REG_FSC_BKCD_5D_L      0x1400BA
#define REG_FSC_BKCD_5D_H      0x1400BB
#define REG_FSC_BKCD_5E_L      0x1400BC
#define REG_FSC_BKCD_5E_H      0x1400BD
#define REG_FSC_BKCD_5F_L      0x1400BE
#define REG_FSC_BKCD_5F_H      0x1400BF
#define REG_FSC_BKCD_60_L      0x1400C0
#define REG_FSC_BKCD_60_H      0x1400C1
#define REG_FSC_BKCD_61_L      0x1400C2
#define REG_FSC_BKCD_61_H      0x1400C3
#define REG_FSC_BKCD_62_L      0x1400C4
#define REG_FSC_BKCD_62_H      0x1400C5
#define REG_FSC_BKCD_63_L      0x1400C6
#define REG_FSC_BKCD_63_H      0x1400C7
#define REG_FSC_BKCD_64_L      0x1400C8
#define REG_FSC_BKCD_64_H      0x1400C9
#define REG_FSC_BKCD_65_L      0x1400CA
#define REG_FSC_BKCD_65_H      0x1400CB
#define REG_FSC_BKCD_66_L      0x1400CC
#define REG_FSC_BKCD_66_H      0x1400CD
#define REG_FSC_BKCD_67_L      0x1400CE
#define REG_FSC_BKCD_67_H      0x1400CF
#define REG_FSC_BKCD_68_L      0x1400D0
#define REG_FSC_BKCD_68_H      0x1400D1
#define REG_FSC_BKCD_69_L      0x1400D2
#define REG_FSC_BKCD_69_H      0x1400D3
#define REG_FSC_BKCD_6A_L      0x1400D4
#define REG_FSC_BKCD_6A_H      0x1400D5
#define REG_FSC_BKCD_6B_L      0x1400D6
#define REG_FSC_BKCD_6B_H      0x1400D7
#define REG_FSC_BKCD_6C_L      0x1400D8
#define REG_FSC_BKCD_6C_H      0x1400D9
#define REG_FSC_BKCD_6D_L      0x1400DA
#define REG_FSC_BKCD_6D_H      0x1400DB
#define REG_FSC_BKCD_6E_L      0x1400DC
#define REG_FSC_BKCD_6E_H      0x1400DD
#define REG_FSC_BKCD_6F_L      0x1400DE
#define REG_FSC_BKCD_6F_H      0x1400DF
#define REG_FSC_BKCD_70_L      0x1400E0
#define REG_FSC_BKCD_70_H      0x1400E1
#define REG_FSC_BKCD_71_L      0x1400E2
#define REG_FSC_BKCD_71_H      0x1400E3
#define REG_FSC_BKCD_72_L      0x1400E4
#define REG_FSC_BKCD_72_H      0x1400E5
#define REG_FSC_BKCD_73_L      0x1400E6
#define REG_FSC_BKCD_73_H      0x1400E7
#define REG_FSC_BKCD_74_L      0x1400E8
#define REG_FSC_BKCD_74_H      0x1400E9
#define REG_FSC_BKCD_75_L      0x1400EA
#define REG_FSC_BKCD_75_H      0x1400EB
#define REG_FSC_BKCD_76_L      0x1400EC
#define REG_FSC_BKCD_76_H      0x1400ED
#define REG_FSC_BKCD_77_L      0x1400EE
#define REG_FSC_BKCD_77_H      0x1400EF
#define REG_FSC_BKCD_78_L      0x1400F0
#define REG_FSC_BKCD_78_H      0x1400F1
#define REG_FSC_BKCD_79_L      0x1400F2
#define REG_FSC_BKCD_79_H      0x1400F3
#define REG_FSC_BKCD_7A_L      0x1400F4
#define REG_FSC_BKCD_7A_H      0x1400F5
#define REG_FSC_BKCD_7B_L      0x1400F6
#define REG_FSC_BKCD_7B_H      0x1400F7
#define REG_FSC_BKCD_7C_L      0x1400F8
#define REG_FSC_BKCD_7C_H      0x1400F9
#define REG_FSC_BKCD_7D_L      0x1400FA
#define REG_FSC_BKCD_7D_H      0x1400FB
#define REG_FSC_BKCD_7E_L      0x1400FC
#define REG_FSC_BKCD_7E_H      0x1400FD
#define REG_FSC_BKCD_7F_L      0x1400FE
#define REG_FSC_BKCD_7F_H      0x1400FF
//----------------------------------------------
#define REG_FSC_BKF2_00_L      0x140000
#define REG_FSC_BKF2_00_H      0x140001
#define REG_FSC_BKF2_01_L      0x140002
#define REG_FSC_BKF2_01_H      0x140003
#define REG_FSC_BKF2_02_L      0x140004
#define REG_FSC_BKF2_02_H      0x140005
#define REG_FSC_BKF2_03_L      0x140006
#define REG_FSC_BKF2_03_H      0x140007
#define REG_FSC_BKF2_04_L      0x140008
#define REG_FSC_BKF2_04_H      0x140009
#define REG_FSC_BKF2_05_L      0x14000A
#define REG_FSC_BKF2_05_H      0x14000B
#define REG_FSC_BKF2_06_L      0x14000C
#define REG_FSC_BKF2_06_H      0x14000D
#define REG_FSC_BKF2_07_L      0x14000E
#define REG_FSC_BKF2_07_H      0x14000F
#define REG_FSC_BKF2_08_L      0x140010
#define REG_FSC_BKF2_08_H      0x140011
#define REG_FSC_BKF2_09_L      0x140012
#define REG_FSC_BKF2_09_H      0x140013
#define REG_FSC_BKF2_0A_L      0x140014
#define REG_FSC_BKF2_0A_H      0x140015
#define REG_FSC_BKF2_0B_L      0x140016
#define REG_FSC_BKF2_0B_H      0x140017
#define REG_FSC_BKF2_0C_L      0x140018
#define REG_FSC_BKF2_0C_H      0x140019
#define REG_FSC_BKF2_0D_L      0x14001A
#define REG_FSC_BKF2_0D_H      0x14001B
#define REG_FSC_BKF2_0E_L      0x14001C
#define REG_FSC_BKF2_0E_H      0x14001D
#define REG_FSC_BKF2_0F_L      0x14001E
#define REG_FSC_BKF2_0F_H      0x14001F
#define REG_FSC_BKF2_10_L      0x140020
#define REG_FSC_BKF2_10_H      0x140021
#define REG_FSC_BKF2_11_L      0x140022
#define REG_FSC_BKF2_11_H      0x140023
#define REG_FSC_BKF2_12_L      0x140024
#define REG_FSC_BKF2_12_H      0x140025
#define REG_FSC_BKF2_13_L      0x140026
#define REG_FSC_BKF2_13_H      0x140027
#define REG_FSC_BKF2_14_L      0x140028
#define REG_FSC_BKF2_14_H      0x140029
#define REG_FSC_BKF2_15_L      0x14002A
#define REG_FSC_BKF2_15_H      0x14002B
#define REG_FSC_BKF2_16_L      0x14002C
#define REG_FSC_BKF2_16_H      0x14002D
#define REG_FSC_BKF2_17_L      0x14002E
#define REG_FSC_BKF2_17_H      0x14002F
#define REG_FSC_BKF2_18_L      0x140030
#define REG_FSC_BKF2_18_H      0x140031
#define REG_FSC_BKF2_19_L      0x140032
#define REG_FSC_BKF2_19_H      0x140033
#define REG_FSC_BKF2_1A_L      0x140034
#define REG_FSC_BKF2_1A_H      0x140035
#define REG_FSC_BKF2_1B_L      0x140036
#define REG_FSC_BKF2_1B_H      0x140037
#define REG_FSC_BKF2_1C_L      0x140038
#define REG_FSC_BKF2_1C_H      0x140039
#define REG_FSC_BKF2_1D_L      0x14003A
#define REG_FSC_BKF2_1D_H      0x14003B
#define REG_FSC_BKF2_1E_L      0x14003C
#define REG_FSC_BKF2_1E_H      0x14003D
#define REG_FSC_BKF2_1F_L      0x14003E
#define REG_FSC_BKF2_1F_H      0x14003F
#define REG_FSC_BKF2_20_L      0x140040
#define REG_FSC_BKF2_20_H      0x140041
#define REG_FSC_BKF2_21_L      0x140042
#define REG_FSC_BKF2_21_H      0x140043
#define REG_FSC_BKF2_22_L      0x140044
#define REG_FSC_BKF2_22_H      0x140045
#define REG_FSC_BKF2_23_L      0x140046
#define REG_FSC_BKF2_23_H      0x140047
#define REG_FSC_BKF2_24_L      0x140048
#define REG_FSC_BKF2_24_H      0x140049
#define REG_FSC_BKF2_25_L      0x14004A
#define REG_FSC_BKF2_25_H      0x14004B
#define REG_FSC_BKF2_26_L      0x14004C
#define REG_FSC_BKF2_26_H      0x14004D
#define REG_FSC_BKF2_27_L      0x14004E
#define REG_FSC_BKF2_27_H      0x14004F
#define REG_FSC_BKF2_28_L      0x140050
#define REG_FSC_BKF2_28_H      0x140051
#define REG_FSC_BKF2_29_L      0x140052
#define REG_FSC_BKF2_29_H      0x140053
#define REG_FSC_BKF2_2A_L      0x140054
#define REG_FSC_BKF2_2A_H      0x140055
#define REG_FSC_BKF2_2B_L      0x140056
#define REG_FSC_BKF2_2B_H      0x140057
#define REG_FSC_BKF2_2C_L      0x140058
#define REG_FSC_BKF2_2C_H      0x140059
#define REG_FSC_BKF2_2D_L      0x14005A
#define REG_FSC_BKF2_2D_H      0x14005B
#define REG_FSC_BKF2_2E_L      0x14005C
#define REG_FSC_BKF2_2E_H      0x14005D
#define REG_FSC_BKF2_2F_L      0x14005E
#define REG_FSC_BKF2_2F_H      0x14005F
#define REG_FSC_BKF2_30_L      0x140060
#define REG_FSC_BKF2_30_H      0x140061
#define REG_FSC_BKF2_31_L      0x140062
#define REG_FSC_BKF2_31_H      0x140063
#define REG_FSC_BKF2_32_L      0x140064
#define REG_FSC_BKF2_32_H      0x140065
#define REG_FSC_BKF2_33_L      0x140066
#define REG_FSC_BKF2_33_H      0x140067
#define REG_FSC_BKF2_34_L      0x140068
#define REG_FSC_BKF2_34_H      0x140069
#define REG_FSC_BKF2_35_L      0x14006A
#define REG_FSC_BKF2_35_H      0x14006B
#define REG_FSC_BKF2_36_L      0x14006C
#define REG_FSC_BKF2_36_H      0x14006D
#define REG_FSC_BKF2_37_L      0x14006E
#define REG_FSC_BKF2_37_H      0x14006F
#define REG_FSC_BKF2_38_L      0x140070
#define REG_FSC_BKF2_38_H      0x140071
#define REG_FSC_BKF2_39_L      0x140072
#define REG_FSC_BKF2_39_H      0x140073
#define REG_FSC_BKF2_3A_L      0x140074
#define REG_FSC_BKF2_3A_H      0x140075
#define REG_FSC_BKF2_3B_L      0x140076
#define REG_FSC_BKF2_3B_H      0x140077
#define REG_FSC_BKF2_3C_L      0x140078
#define REG_FSC_BKF2_3C_H      0x140079
#define REG_FSC_BKF2_3D_L      0x14007A
#define REG_FSC_BKF2_3D_H      0x14007B
#define REG_FSC_BKF2_3E_L      0x14007C
#define REG_FSC_BKF2_3E_H      0x14007D
#define REG_FSC_BKF2_3F_L      0x14007E
#define REG_FSC_BKF2_3F_H      0x14007F
#define REG_FSC_BKF2_40_L      0x140080
#define REG_FSC_BKF2_40_H      0x140081
#define REG_FSC_BKF2_41_L      0x140082
#define REG_FSC_BKF2_41_H      0x140083
#define REG_FSC_BKF2_42_L      0x140084
#define REG_FSC_BKF2_42_H      0x140085
#define REG_FSC_BKF2_43_L      0x140086
#define REG_FSC_BKF2_43_H      0x140087
#define REG_FSC_BKF2_44_L      0x140088
#define REG_FSC_BKF2_44_H      0x140089
#define REG_FSC_BKF2_45_L      0x14008A
#define REG_FSC_BKF2_45_H      0x14008B
#define REG_FSC_BKF2_46_L      0x14008C
#define REG_FSC_BKF2_46_H      0x14008D
#define REG_FSC_BKF2_47_L      0x14008E
#define REG_FSC_BKF2_47_H      0x14008F
#define REG_FSC_BKF2_48_L      0x140090
#define REG_FSC_BKF2_48_H      0x140091
#define REG_FSC_BKF2_49_L      0x140092
#define REG_FSC_BKF2_49_H      0x140093
#define REG_FSC_BKF2_4A_L      0x140094
#define REG_FSC_BKF2_4A_H      0x140095
#define REG_FSC_BKF2_4B_L      0x140096
#define REG_FSC_BKF2_4B_H      0x140097
#define REG_FSC_BKF2_4C_L      0x140098
#define REG_FSC_BKF2_4C_H      0x140099
#define REG_FSC_BKF2_4D_L      0x14009A
#define REG_FSC_BKF2_4D_H      0x14009B
#define REG_FSC_BKF2_4E_L      0x14009C
#define REG_FSC_BKF2_4E_H      0x14009D
#define REG_FSC_BKF2_4F_L      0x14009E
#define REG_FSC_BKF2_4F_H      0x14009F
#define REG_FSC_BKF2_50_L      0x1400A0
#define REG_FSC_BKF2_50_H      0x1400A1
#define REG_FSC_BKF2_51_L      0x1400A2
#define REG_FSC_BKF2_51_H      0x1400A3
#define REG_FSC_BKF2_52_L      0x1400A4
#define REG_FSC_BKF2_52_H      0x1400A5
#define REG_FSC_BKF2_53_L      0x1400A6
#define REG_FSC_BKF2_53_H      0x1400A7
#define REG_FSC_BKF2_54_L      0x1400A8
#define REG_FSC_BKF2_54_H      0x1400A9
#define REG_FSC_BKF2_55_L      0x1400AA
#define REG_FSC_BKF2_55_H      0x1400AB
#define REG_FSC_BKF2_56_L      0x1400AC
#define REG_FSC_BKF2_56_H      0x1400AD
#define REG_FSC_BKF2_57_L      0x1400AE
#define REG_FSC_BKF2_57_H      0x1400AF
#define REG_FSC_BKF2_58_L      0x1400B0
#define REG_FSC_BKF2_58_H      0x1400B1
#define REG_FSC_BKF2_59_L      0x1400B2
#define REG_FSC_BKF2_59_H      0x1400B3
#define REG_FSC_BKF2_5A_L      0x1400B4
#define REG_FSC_BKF2_5A_H      0x1400B5
#define REG_FSC_BKF2_5B_L      0x1400B6
#define REG_FSC_BKF2_5B_H      0x1400B7
#define REG_FSC_BKF2_5C_L      0x1400B8
#define REG_FSC_BKF2_5C_H      0x1400B9
#define REG_FSC_BKF2_5D_L      0x1400BA
#define REG_FSC_BKF2_5D_H      0x1400BB
#define REG_FSC_BKF2_5E_L      0x1400BC
#define REG_FSC_BKF2_5E_H      0x1400BD
#define REG_FSC_BKF2_5F_L      0x1400BE
#define REG_FSC_BKF2_5F_H      0x1400BF
#define REG_FSC_BKF2_60_L      0x1400C0
#define REG_FSC_BKF2_60_H      0x1400C1
#define REG_FSC_BKF2_61_L      0x1400C2
#define REG_FSC_BKF2_61_H      0x1400C3
#define REG_FSC_BKF2_62_L      0x1400C4
#define REG_FSC_BKF2_62_H      0x1400C5
#define REG_FSC_BKF2_63_L      0x1400C6
#define REG_FSC_BKF2_63_H      0x1400C7
#define REG_FSC_BKF2_64_L      0x1400C8
#define REG_FSC_BKF2_64_H      0x1400C9
#define REG_FSC_BKF2_65_L      0x1400CA
#define REG_FSC_BKF2_65_H      0x1400CB
#define REG_FSC_BKF2_66_L      0x1400CC
#define REG_FSC_BKF2_66_H      0x1400CD
#define REG_FSC_BKF2_67_L      0x1400CE
#define REG_FSC_BKF2_67_H      0x1400CF
#define REG_FSC_BKF2_68_L      0x1400D0
#define REG_FSC_BKF2_68_H      0x1400D1
#define REG_FSC_BKF2_69_L      0x1400D2
#define REG_FSC_BKF2_69_H      0x1400D3
#define REG_FSC_BKF2_6A_L      0x1400D4
#define REG_FSC_BKF2_6A_H      0x1400D5
#define REG_FSC_BKF2_6B_L      0x1400D6
#define REG_FSC_BKF2_6B_H      0x1400D7
#define REG_FSC_BKF2_6C_L      0x1400D8
#define REG_FSC_BKF2_6C_H      0x1400D9
#define REG_FSC_BKF2_6D_L      0x1400DA
#define REG_FSC_BKF2_6D_H      0x1400DB
#define REG_FSC_BKF2_6E_L      0x1400DC
#define REG_FSC_BKF2_6E_H      0x1400DD
#define REG_FSC_BKF2_6F_L      0x1400DE
#define REG_FSC_BKF2_6F_H      0x1400DF
#define REG_FSC_BKF2_70_L      0x1400E0
#define REG_FSC_BKF2_70_H      0x1400E1
#define REG_FSC_BKF2_71_L      0x1400E2
#define REG_FSC_BKF2_71_H      0x1400E3
#define REG_FSC_BKF2_72_L      0x1400E4
#define REG_FSC_BKF2_72_H      0x1400E5
#define REG_FSC_BKF2_73_L      0x1400E6
#define REG_FSC_BKF2_73_H      0x1400E7
#define REG_FSC_BKF2_74_L      0x1400E8
#define REG_FSC_BKF2_74_H      0x1400E9
#define REG_FSC_BKF2_75_L      0x1400EA
#define REG_FSC_BKF2_75_H      0x1400EB
#define REG_FSC_BKF2_76_L      0x1400EC
#define REG_FSC_BKF2_76_H      0x1400ED
#define REG_FSC_BKF2_77_L      0x1400EE
#define REG_FSC_BKF2_77_H      0x1400EF
#define REG_FSC_BKF2_78_L      0x1400F0
#define REG_FSC_BKF2_78_H      0x1400F1
#define REG_FSC_BKF2_79_L      0x1400F2
#define REG_FSC_BKF2_79_H      0x1400F3
#define REG_FSC_BKF2_7A_L      0x1400F4
#define REG_FSC_BKF2_7A_H      0x1400F5
#define REG_FSC_BKF2_7B_L      0x1400F6
#define REG_FSC_BKF2_7B_H      0x1400F7
#define REG_FSC_BKF2_7C_L      0x1400F8
#define REG_FSC_BKF2_7C_H      0x1400F9
#define REG_FSC_BKF2_7D_L      0x1400FA
#define REG_FSC_BKF2_7D_H      0x1400FB
#define REG_FSC_BKF2_7E_L      0x1400FC
#define REG_FSC_BKF2_7E_H      0x1400FD
#define REG_FSC_BKF2_7F_L      0x1400FE
#define REG_FSC_BKF2_7F_H      0x1400FF
//----------------------------------------------
#define REG_BK330A_00_L      0x330A00
#define REG_BK330A_00_H      0x330A01
#define REG_BK330A_01_L      0x330A02
#define REG_BK330A_01_H      0x330A03
#define REG_BK330A_02_L      0x330A04
#define REG_BK330A_02_H      0x330A05
#define REG_BK330A_03_L      0x330A06
#define REG_BK330A_03_H      0x330A07
#define REG_BK330A_04_L      0x330A08
#define REG_BK330A_04_H      0x330A09
#define REG_BK330A_05_L      0x330A0A
#define REG_BK330A_05_H      0x330A0B
#define REG_BK330A_06_L      0x330A0C
#define REG_BK330A_06_H      0x330A0D
#define REG_BK330A_07_L      0x330A0E
#define REG_BK330A_07_H      0x330A0F
#define REG_BK330A_08_L      0x330A10
#define REG_BK330A_08_H      0x330A11
#define REG_BK330A_09_L      0x330A12
#define REG_BK330A_09_H      0x330A13
#define REG_BK330A_0A_L      0x330A14
#define REG_BK330A_0A_H      0x330A15
#define REG_BK330A_0B_L      0x330A16
#define REG_BK330A_0B_H      0x330A17
#define REG_BK330A_0C_L      0x330A18
#define REG_BK330A_0C_H      0x330A19
#define REG_BK330A_0D_L      0x330A1A
#define REG_BK330A_0D_H      0x330A1B
#define REG_BK330A_0E_L      0x330A1C
#define REG_BK330A_0E_H      0x330A1D
#define REG_BK330A_0F_L      0x330A1E
#define REG_BK330A_0F_H      0x330A1F
#define REG_BK330A_10_L      0x330A20
#define REG_BK330A_10_H      0x330A21
#define REG_BK330A_11_L      0x330A22
#define REG_BK330A_11_H      0x330A23
#define REG_BK330A_12_L      0x330A24
#define REG_BK330A_12_H      0x330A25
#define REG_BK330A_13_L      0x330A26
#define REG_BK330A_13_H      0x330A27
#define REG_BK330A_14_L      0x330A28
#define REG_BK330A_14_H      0x330A29
#define REG_BK330A_15_L      0x330A2A
#define REG_BK330A_15_H      0x330A2B
#define REG_BK330A_16_L      0x330A2C
#define REG_BK330A_16_H      0x330A2D
#define REG_BK330A_17_L      0x330A2E
#define REG_BK330A_17_H      0x330A2F
#define REG_BK330A_18_L      0x330A30
#define REG_BK330A_18_H      0x330A31
#define REG_BK330A_19_L      0x330A32
#define REG_BK330A_19_H      0x330A33
#define REG_BK330A_1A_L      0x330A34
#define REG_BK330A_1A_H      0x330A35
#define REG_BK330A_1B_L      0x330A36
#define REG_BK330A_1B_H      0x330A37
#define REG_BK330A_1C_L      0x330A38
#define REG_BK330A_1C_H      0x330A39
#define REG_BK330A_1D_L      0x330A3A
#define REG_BK330A_1D_H      0x330A3B
#define REG_BK330A_1E_L      0x330A3C
#define REG_BK330A_1E_H      0x330A3D
#define REG_BK330A_1F_L      0x330A3E
#define REG_BK330A_1F_H      0x330A3F
#define REG_BK330A_20_L      0x330A40
#define REG_BK330A_20_H      0x330A41
#define REG_BK330A_21_L      0x330A42
#define REG_BK330A_21_H      0x330A43
#define REG_BK330A_22_L      0x330A44
#define REG_BK330A_22_H      0x330A45
#define REG_BK330A_23_L      0x330A46
#define REG_BK330A_23_H      0x330A47
#define REG_BK330A_24_L      0x330A48
#define REG_BK330A_24_H      0x330A49
#define REG_BK330A_25_L      0x330A4A
#define REG_BK330A_25_H      0x330A4B
#define REG_BK330A_26_L      0x330A4C
#define REG_BK330A_26_H      0x330A4D
#define REG_BK330A_27_L      0x330A4E
#define REG_BK330A_27_H      0x330A4F
#define REG_BK330A_28_L      0x330A50
#define REG_BK330A_28_H      0x330A51
#define REG_BK330A_29_L      0x330A52
#define REG_BK330A_29_H      0x330A53
#define REG_BK330A_2A_L      0x330A54
#define REG_BK330A_2A_H      0x330A55
#define REG_BK330A_2B_L      0x330A56
#define REG_BK330A_2B_H      0x330A57
#define REG_BK330A_2C_L      0x330A58
#define REG_BK330A_2C_H      0x330A59
#define REG_BK330A_2D_L      0x330A5A
#define REG_BK330A_2D_H      0x330A5B
#define REG_BK330A_2E_L      0x330A5C
#define REG_BK330A_2E_H      0x330A5D
#define REG_BK330A_2F_L      0x330A5E
#define REG_BK330A_2F_H      0x330A5F
#define REG_BK330A_30_L      0x330A60
#define REG_BK330A_30_H      0x330A61
#define REG_BK330A_31_L      0x330A62
#define REG_BK330A_31_H      0x330A63
#define REG_BK330A_32_L      0x330A64
#define REG_BK330A_32_H      0x330A65
#define REG_BK330A_33_L      0x330A66
#define REG_BK330A_33_H      0x330A67
#define REG_BK330A_34_L      0x330A68
#define REG_BK330A_34_H      0x330A69
#define REG_BK330A_35_L      0x330A6A
#define REG_BK330A_35_H      0x330A6B
#define REG_BK330A_36_L      0x330A6C
#define REG_BK330A_36_H      0x330A6D
#define REG_BK330A_37_L      0x330A6E
#define REG_BK330A_37_H      0x330A6F
#define REG_BK330A_38_L      0x330A70
#define REG_BK330A_38_H      0x330A71
#define REG_BK330A_39_L      0x330A72
#define REG_BK330A_39_H      0x330A73
#define REG_BK330A_3A_L      0x330A74
#define REG_BK330A_3A_H      0x330A75
#define REG_BK330A_3B_L      0x330A76
#define REG_BK330A_3B_H      0x330A77
#define REG_BK330A_3C_L      0x330A78
#define REG_BK330A_3C_H      0x330A79
#define REG_BK330A_3D_L      0x330A7A
#define REG_BK330A_3D_H      0x330A7B
#define REG_BK330A_3E_L      0x330A7C
#define REG_BK330A_3E_H      0x330A7D
#define REG_BK330A_3F_L      0x330A7E
#define REG_BK330A_3F_H      0x330A7F
#define REG_BK330A_40_L      0x330A80
#define REG_BK330A_40_H      0x330A81
#define REG_BK330A_41_L      0x330A82
#define REG_BK330A_41_H      0x330A83
#define REG_BK330A_42_L      0x330A84
#define REG_BK330A_42_H      0x330A85
#define REG_BK330A_43_L      0x330A86
#define REG_BK330A_43_H      0x330A87
#define REG_BK330A_44_L      0x330A88
#define REG_BK330A_44_H      0x330A89
#define REG_BK330A_45_L      0x330A8A
#define REG_BK330A_45_H      0x330A8B
#define REG_BK330A_46_L      0x330A8C
#define REG_BK330A_46_H      0x330A8D
#define REG_BK330A_47_L      0x330A8E
#define REG_BK330A_47_H      0x330A8F
#define REG_BK330A_48_L      0x330A90
#define REG_BK330A_48_H      0x330A91
#define REG_BK330A_49_L      0x330A92
#define REG_BK330A_49_H      0x330A93
#define REG_BK330A_4A_L      0x330A94
#define REG_BK330A_4A_H      0x330A95
#define REG_BK330A_4B_L      0x330A96
#define REG_BK330A_4B_H      0x330A97
#define REG_BK330A_4C_L      0x330A98
#define REG_BK330A_4C_H      0x330A99
#define REG_BK330A_4D_L      0x330A9A
#define REG_BK330A_4D_H      0x330A9B
#define REG_BK330A_4E_L      0x330A9C
#define REG_BK330A_4E_H      0x330A9D
#define REG_BK330A_4F_L      0x330A9E
#define REG_BK330A_4F_H      0x330A9F
#define REG_BK330A_50_L      0x330AA0
#define REG_BK330A_50_H      0x330AA1
#define REG_BK330A_51_L      0x330AA2
#define REG_BK330A_51_H      0x330AA3
#define REG_BK330A_52_L      0x330AA4
#define REG_BK330A_52_H      0x330AA5
#define REG_BK330A_53_L      0x330AA6
#define REG_BK330A_53_H      0x330AA7
#define REG_BK330A_54_L      0x330AA8
#define REG_BK330A_54_H      0x330AA9
#define REG_BK330A_55_L      0x330AAA
#define REG_BK330A_55_H      0x330AAB
#define REG_BK330A_56_L      0x330AAC
#define REG_BK330A_56_H      0x330AAD
#define REG_BK330A_57_L      0x330AAE
#define REG_BK330A_57_H      0x330AAF
#define REG_BK330A_58_L      0x330AB0
#define REG_BK330A_58_H      0x330AB1
#define REG_BK330A_59_L      0x330AB2
#define REG_BK330A_59_H      0x330AB3
#define REG_BK330A_5A_L      0x330AB4
#define REG_BK330A_5A_H      0x330AB5
#define REG_BK330A_5B_L      0x330AB6
#define REG_BK330A_5B_H      0x330AB7
#define REG_BK330A_5C_L      0x330AB8
#define REG_BK330A_5C_H      0x330AB9
#define REG_BK330A_5D_L      0x330ABA
#define REG_BK330A_5D_H      0x330ABB
#define REG_BK330A_5E_L      0x330ABC
#define REG_BK330A_5E_H      0x330ABD
#define REG_BK330A_5F_L      0x330ABE
#define REG_BK330A_5F_H      0x330ABF
#define REG_BK330A_60_L      0x330AC0
#define REG_BK330A_60_H      0x330AC1
#define REG_BK330A_61_L      0x330AC2
#define REG_BK330A_61_H      0x330AC3
#define REG_BK330A_62_L      0x330AC4
#define REG_BK330A_62_H      0x330AC5
#define REG_BK330A_63_L      0x330AC6
#define REG_BK330A_63_H      0x330AC7
#define REG_BK330A_64_L      0x330AC8
#define REG_BK330A_64_H      0x330AC9
#define REG_BK330A_65_L      0x330ACA
#define REG_BK330A_65_H      0x330ACB
#define REG_BK330A_66_L      0x330ACC
#define REG_BK330A_66_H      0x330ACD
#define REG_BK330A_67_L      0x330ACE
#define REG_BK330A_67_H      0x330ACF
#define REG_BK330A_68_L      0x330AD0
#define REG_BK330A_68_H      0x330AD1
#define REG_BK330A_69_L      0x330AD2
#define REG_BK330A_69_H      0x330AD3
#define REG_BK330A_6A_L      0x330AD4
#define REG_BK330A_6A_H      0x330AD5
#define REG_BK330A_6B_L      0x330AD6
#define REG_BK330A_6B_H      0x330AD7
#define REG_BK330A_6C_L      0x330AD8
#define REG_BK330A_6C_H      0x330AD9
#define REG_BK330A_6D_L      0x330ADA
#define REG_BK330A_6D_H      0x330ADB
#define REG_BK330A_6E_L      0x330ADC
#define REG_BK330A_6E_H      0x330ADD
#define REG_BK330A_6F_L      0x330ADE
#define REG_BK330A_6F_H      0x330ADF
#define REG_BK330A_70_L      0x330AE0
#define REG_BK330A_70_H      0x330AE1
#define REG_BK330A_71_L      0x330AE2
#define REG_BK330A_71_H      0x330AE3
#define REG_BK330A_72_L      0x330AE4
#define REG_BK330A_72_H      0x330AE5
#define REG_BK330A_73_L      0x330AE6
#define REG_BK330A_73_H      0x330AE7
#define REG_BK330A_74_L      0x330AE8
#define REG_BK330A_74_H      0x330AE9
#define REG_BK330A_75_L      0x330AEA
#define REG_BK330A_75_H      0x330AEB
#define REG_BK330A_76_L      0x330AEC
#define REG_BK330A_76_H      0x330AED
#define REG_BK330A_77_L      0x330AEE
#define REG_BK330A_77_H      0x330AEF
#define REG_BK330A_78_L      0x330AF0
#define REG_BK330A_78_H      0x330AF1
#define REG_BK330A_79_L      0x330AF2
#define REG_BK330A_79_H      0x330AF3
#define REG_BK330A_7A_L      0x330AF4
#define REG_BK330A_7A_H      0x330AF5
#define REG_BK330A_7B_L      0x330AF6
#define REG_BK330A_7B_H      0x330AF7
#define REG_BK330A_7C_L      0x330AF8
#define REG_BK330A_7C_H      0x330AF9
#define REG_BK330A_7D_L      0x330AFA
#define REG_BK330A_7D_H      0x330AFB
#define REG_BK330A_7E_L      0x330AFC
#define REG_BK330A_7E_H      0x330AFD
#define REG_BK330A_7F_L      0x330AFE
#define REG_BK330A_7F_H      0x330AFF
//----------------------------------------------
#define REG_BK330B_00_L      0x330B00
#define REG_BK330B_00_H      0x330B01
#define REG_BK330B_01_L      0x330B02
#define REG_BK330B_01_H      0x330B03
#define REG_BK330B_02_L      0x330B04
#define REG_BK330B_02_H      0x330B05
#define REG_BK330B_03_L      0x330B06
#define REG_BK330B_03_H      0x330B07
#define REG_BK330B_04_L      0x330B08
#define REG_BK330B_04_H      0x330B09
#define REG_BK330B_05_L      0x330B0A
#define REG_BK330B_05_H      0x330B0B
#define REG_BK330B_06_L      0x330B0C
#define REG_BK330B_06_H      0x330B0D
#define REG_BK330B_07_L      0x330B0E
#define REG_BK330B_07_H      0x330B0F
#define REG_BK330B_08_L      0x330B10
#define REG_BK330B_08_H      0x330B11
#define REG_BK330B_09_L      0x330B12
#define REG_BK330B_09_H      0x330B13
#define REG_BK330B_0A_L      0x330B14
#define REG_BK330B_0A_H      0x330B15
#define REG_BK330B_0B_L      0x330B16
#define REG_BK330B_0B_H      0x330B17
#define REG_BK330B_0C_L      0x330B18
#define REG_BK330B_0C_H      0x330B19
#define REG_BK330B_0D_L      0x330B1A
#define REG_BK330B_0D_H      0x330B1B
#define REG_BK330B_0E_L      0x330B1C
#define REG_BK330B_0E_H      0x330B1D
#define REG_BK330B_0F_L      0x330B1E
#define REG_BK330B_0F_H      0x330B1F
#define REG_BK330B_10_L      0x330B20
#define REG_BK330B_10_H      0x330B21
#define REG_BK330B_11_L      0x330B22
#define REG_BK330B_11_H      0x330B23
#define REG_BK330B_12_L      0x330B24
#define REG_BK330B_12_H      0x330B25
#define REG_BK330B_13_L      0x330B26
#define REG_BK330B_13_H      0x330B27
#define REG_BK330B_14_L      0x330B28
#define REG_BK330B_14_H      0x330B29
#define REG_BK330B_15_L      0x330B2A
#define REG_BK330B_15_H      0x330B2B
#define REG_BK330B_16_L      0x330B2C
#define REG_BK330B_16_H      0x330B2D
#define REG_BK330B_17_L      0x330B2E
#define REG_BK330B_17_H      0x330B2F
#define REG_BK330B_18_L      0x330B30
#define REG_BK330B_18_H      0x330B31
#define REG_BK330B_19_L      0x330B32
#define REG_BK330B_19_H      0x330B33
#define REG_BK330B_1A_L      0x330B34
#define REG_BK330B_1A_H      0x330B35
#define REG_BK330B_1B_L      0x330B36
#define REG_BK330B_1B_H      0x330B37
#define REG_BK330B_1C_L      0x330B38
#define REG_BK330B_1C_H      0x330B39
#define REG_BK330B_1D_L      0x330B3A
#define REG_BK330B_1D_H      0x330B3B
#define REG_BK330B_1E_L      0x330B3C
#define REG_BK330B_1E_H      0x330B3D
#define REG_BK330B_1F_L      0x330B3E
#define REG_BK330B_1F_H      0x330B3F
#define REG_BK330B_20_L      0x330B40
#define REG_BK330B_20_H      0x330B41
#define REG_BK330B_21_L      0x330B42
#define REG_BK330B_21_H      0x330B43
#define REG_BK330B_22_L      0x330B44
#define REG_BK330B_22_H      0x330B45
#define REG_BK330B_23_L      0x330B46
#define REG_BK330B_23_H      0x330B47
#define REG_BK330B_24_L      0x330B48
#define REG_BK330B_24_H      0x330B49
#define REG_BK330B_25_L      0x330B4A
#define REG_BK330B_25_H      0x330B4B
#define REG_BK330B_26_L      0x330B4C
#define REG_BK330B_26_H      0x330B4D
#define REG_BK330B_27_L      0x330B4E
#define REG_BK330B_27_H      0x330B4F
#define REG_BK330B_28_L      0x330B50
#define REG_BK330B_28_H      0x330B51
#define REG_BK330B_29_L      0x330B52
#define REG_BK330B_29_H      0x330B53
#define REG_BK330B_2A_L      0x330B54
#define REG_BK330B_2A_H      0x330B55
#define REG_BK330B_2B_L      0x330B56
#define REG_BK330B_2B_H      0x330B57
#define REG_BK330B_2C_L      0x330B58
#define REG_BK330B_2C_H      0x330B59
#define REG_BK330B_2D_L      0x330B5A
#define REG_BK330B_2D_H      0x330B5B
#define REG_BK330B_2E_L      0x330B5C
#define REG_BK330B_2E_H      0x330B5D
#define REG_BK330B_2F_L      0x330B5E
#define REG_BK330B_2F_H      0x330B5F
#define REG_BK330B_30_L      0x330B60
#define REG_BK330B_30_H      0x330B61
#define REG_BK330B_31_L      0x330B62
#define REG_BK330B_31_H      0x330B63
#define REG_BK330B_32_L      0x330B64
#define REG_BK330B_32_H      0x330B65
#define REG_BK330B_33_L      0x330B66
#define REG_BK330B_33_H      0x330B67
#define REG_BK330B_34_L      0x330B68
#define REG_BK330B_34_H      0x330B69
#define REG_BK330B_35_L      0x330B6A
#define REG_BK330B_35_H      0x330B6B
#define REG_BK330B_36_L      0x330B6C
#define REG_BK330B_36_H      0x330B6D
#define REG_BK330B_37_L      0x330B6E
#define REG_BK330B_37_H      0x330B6F
#define REG_BK330B_38_L      0x330B70
#define REG_BK330B_38_H      0x330B71
#define REG_BK330B_39_L      0x330B72
#define REG_BK330B_39_H      0x330B73
#define REG_BK330B_3A_L      0x330B74
#define REG_BK330B_3A_H      0x330B75
#define REG_BK330B_3B_L      0x330B76
#define REG_BK330B_3B_H      0x330B77
#define REG_BK330B_3C_L      0x330B78
#define REG_BK330B_3C_H      0x330B79
#define REG_BK330B_3D_L      0x330B7A
#define REG_BK330B_3D_H      0x330B7B
#define REG_BK330B_3E_L      0x330B7C
#define REG_BK330B_3E_H      0x330B7D
#define REG_BK330B_3F_L      0x330B7E
#define REG_BK330B_3F_H      0x330B7F
#define REG_BK330B_40_L      0x330B80
#define REG_BK330B_40_H      0x330B81
#define REG_BK330B_41_L      0x330B82
#define REG_BK330B_41_H      0x330B83
#define REG_BK330B_42_L      0x330B84
#define REG_BK330B_42_H      0x330B85
#define REG_BK330B_43_L      0x330B86
#define REG_BK330B_43_H      0x330B87
#define REG_BK330B_44_L      0x330B88
#define REG_BK330B_44_H      0x330B89
#define REG_BK330B_45_L      0x330B8A
#define REG_BK330B_45_H      0x330B8B
#define REG_BK330B_46_L      0x330B8C
#define REG_BK330B_46_H      0x330B8D
#define REG_BK330B_47_L      0x330B8E
#define REG_BK330B_47_H      0x330B8F
#define REG_BK330B_48_L      0x330B90
#define REG_BK330B_48_H      0x330B91
#define REG_BK330B_49_L      0x330B92
#define REG_BK330B_49_H      0x330B93
#define REG_BK330B_4A_L      0x330B94
#define REG_BK330B_4A_H      0x330B95
#define REG_BK330B_4B_L      0x330B96
#define REG_BK330B_4B_H      0x330B97
#define REG_BK330B_4C_L      0x330B98
#define REG_BK330B_4C_H      0x330B99
#define REG_BK330B_4D_L      0x330B9A
#define REG_BK330B_4D_H      0x330B9B
#define REG_BK330B_4E_L      0x330B9C
#define REG_BK330B_4E_H      0x330B9D
#define REG_BK330B_4F_L      0x330B9E
#define REG_BK330B_4F_H      0x330B9F
#define REG_BK330B_50_L      0x330BA0
#define REG_BK330B_50_H      0x330BA1
#define REG_BK330B_51_L      0x330BA2
#define REG_BK330B_51_H      0x330BA3
#define REG_BK330B_52_L      0x330BA4
#define REG_BK330B_52_H      0x330BA5
#define REG_BK330B_53_L      0x330BA6
#define REG_BK330B_53_H      0x330BA7
#define REG_BK330B_54_L      0x330BA8
#define REG_BK330B_54_H      0x330BA9
#define REG_BK330B_55_L      0x330BAA
#define REG_BK330B_55_H      0x330BAB
#define REG_BK330B_56_L      0x330BAC
#define REG_BK330B_56_H      0x330BAD
#define REG_BK330B_57_L      0x330BAE
#define REG_BK330B_57_H      0x330BAF
#define REG_BK330B_58_L      0x330BB0
#define REG_BK330B_58_H      0x330BB1
#define REG_BK330B_59_L      0x330BB2
#define REG_BK330B_59_H      0x330BB3
#define REG_BK330B_5A_L      0x330BB4
#define REG_BK330B_5A_H      0x330BB5
#define REG_BK330B_5B_L      0x330BB6
#define REG_BK330B_5B_H      0x330BB7
#define REG_BK330B_5C_L      0x330BB8
#define REG_BK330B_5C_H      0x330BB9
#define REG_BK330B_5D_L      0x330BBA
#define REG_BK330B_5D_H      0x330BBB
#define REG_BK330B_5E_L      0x330BBC
#define REG_BK330B_5E_H      0x330BBD
#define REG_BK330B_5F_L      0x330BBE
#define REG_BK330B_5F_H      0x330BBF
#define REG_BK330B_60_L      0x330BC0
#define REG_BK330B_60_H      0x330BC1
#define REG_BK330B_61_L      0x330BC2
#define REG_BK330B_61_H      0x330BC3
#define REG_BK330B_62_L      0x330BC4
#define REG_BK330B_62_H      0x330BC5
#define REG_BK330B_63_L      0x330BC6
#define REG_BK330B_63_H      0x330BC7
#define REG_BK330B_64_L      0x330BC8
#define REG_BK330B_64_H      0x330BC9
#define REG_BK330B_65_L      0x330BCA
#define REG_BK330B_65_H      0x330BCB
#define REG_BK330B_66_L      0x330BCC
#define REG_BK330B_66_H      0x330BCD
#define REG_BK330B_67_L      0x330BCE
#define REG_BK330B_67_H      0x330BCF
#define REG_BK330B_68_L      0x330BD0
#define REG_BK330B_68_H      0x330BD1
#define REG_BK330B_69_L      0x330BD2
#define REG_BK330B_69_H      0x330BD3
#define REG_BK330B_6A_L      0x330BD4
#define REG_BK330B_6A_H      0x330BD5
#define REG_BK330B_6B_L      0x330BD6
#define REG_BK330B_6B_H      0x330BD7
#define REG_BK330B_6C_L      0x330BD8
#define REG_BK330B_6C_H      0x330BD9
#define REG_BK330B_6D_L      0x330BDA
#define REG_BK330B_6D_H      0x330BDB
#define REG_BK330B_6E_L      0x330BDC
#define REG_BK330B_6E_H      0x330BDD
#define REG_BK330B_6F_L      0x330BDE
#define REG_BK330B_6F_H      0x330BDF
#define REG_BK330B_70_L      0x330BE0
#define REG_BK330B_70_H      0x330BE1
#define REG_BK330B_71_L      0x330BE2
#define REG_BK330B_71_H      0x330BE3
#define REG_BK330B_72_L      0x330BE4
#define REG_BK330B_72_H      0x330BE5
#define REG_BK330B_73_L      0x330BE6
#define REG_BK330B_73_H      0x330BE7
#define REG_BK330B_74_L      0x330BE8
#define REG_BK330B_74_H      0x330BE9
#define REG_BK330B_75_L      0x330BEA
#define REG_BK330B_75_H      0x330BEB
#define REG_BK330B_76_L      0x330BEC
#define REG_BK330B_76_H      0x330BED
#define REG_BK330B_77_L      0x330BEE
#define REG_BK330B_77_H      0x330BEF
#define REG_BK330B_78_L      0x330BF0
#define REG_BK330B_78_H      0x330BF1
#define REG_BK330B_79_L      0x330BF2
#define REG_BK330B_79_H      0x330BF3
#define REG_BK330B_7A_L      0x330BF4
#define REG_BK330B_7A_H      0x330BF5
#define REG_BK330B_7B_L      0x330BF6
#define REG_BK330B_7B_H      0x330BF7
#define REG_BK330B_7C_L      0x330BF8
#define REG_BK330B_7C_H      0x330BF9
#define REG_BK330B_7D_L      0x330BFA
#define REG_BK330B_7D_H      0x330BFB
#define REG_BK330B_7E_L      0x330BFC
#define REG_BK330B_7E_H      0x330BFD
#define REG_BK330B_7F_L      0x330BFE
#define REG_BK330B_7F_H      0x330BFF
//----------------------------------------------
#define REG_BK330C_00_L      0x330C00
#define REG_BK330C_00_H      0x330C01
#define REG_BK330C_01_L      0x330C02
#define REG_BK330C_01_H      0x330C03
#define REG_BK330C_02_L      0x330C04
#define REG_BK330C_02_H      0x330C05
#define REG_BK330C_03_L      0x330C06
#define REG_BK330C_03_H      0x330C07
#define REG_BK330C_04_L      0x330C08
#define REG_BK330C_04_H      0x330C09
#define REG_BK330C_05_L      0x330C0A
#define REG_BK330C_05_H      0x330C0B
#define REG_BK330C_06_L      0x330C0C
#define REG_BK330C_06_H      0x330C0D
#define REG_BK330C_07_L      0x330C0E
#define REG_BK330C_07_H      0x330C0F
#define REG_BK330C_08_L      0x330C10
#define REG_BK330C_08_H      0x330C11
#define REG_BK330C_09_L      0x330C12
#define REG_BK330C_09_H      0x330C13
#define REG_BK330C_0A_L      0x330C14
#define REG_BK330C_0A_H      0x330C15
#define REG_BK330C_0B_L      0x330C16
#define REG_BK330C_0B_H      0x330C17
#define REG_BK330C_0C_L      0x330C18
#define REG_BK330C_0C_H      0x330C19
#define REG_BK330C_0D_L      0x330C1A
#define REG_BK330C_0D_H      0x330C1B
#define REG_BK330C_0E_L      0x330C1C
#define REG_BK330C_0E_H      0x330C1D
#define REG_BK330C_0F_L      0x330C1E
#define REG_BK330C_0F_H      0x330C1F
#define REG_BK330C_10_L      0x330C20
#define REG_BK330C_10_H      0x330C21
#define REG_BK330C_11_L      0x330C22
#define REG_BK330C_11_H      0x330C23
#define REG_BK330C_12_L      0x330C24
#define REG_BK330C_12_H      0x330C25
#define REG_BK330C_13_L      0x330C26
#define REG_BK330C_13_H      0x330C27
#define REG_BK330C_14_L      0x330C28
#define REG_BK330C_14_H      0x330C29
#define REG_BK330C_15_L      0x330C2A
#define REG_BK330C_15_H      0x330C2B
#define REG_BK330C_16_L      0x330C2C
#define REG_BK330C_16_H      0x330C2D
#define REG_BK330C_17_L      0x330C2E
#define REG_BK330C_17_H      0x330C2F
#define REG_BK330C_18_L      0x330C30
#define REG_BK330C_18_H      0x330C31
#define REG_BK330C_19_L      0x330C32
#define REG_BK330C_19_H      0x330C33
#define REG_BK330C_1A_L      0x330C34
#define REG_BK330C_1A_H      0x330C35
#define REG_BK330C_1B_L      0x330C36
#define REG_BK330C_1B_H      0x330C37
#define REG_BK330C_1C_L      0x330C38
#define REG_BK330C_1C_H      0x330C39
#define REG_BK330C_1D_L      0x330C3A
#define REG_BK330C_1D_H      0x330C3B
#define REG_BK330C_1E_L      0x330C3C
#define REG_BK330C_1E_H      0x330C3D
#define REG_BK330C_1F_L      0x330C3E
#define REG_BK330C_1F_H      0x330C3F
#define REG_BK330C_20_L      0x330C40
#define REG_BK330C_20_H      0x330C41
#define REG_BK330C_21_L      0x330C42
#define REG_BK330C_21_H      0x330C43
#define REG_BK330C_22_L      0x330C44
#define REG_BK330C_22_H      0x330C45
#define REG_BK330C_23_L      0x330C46
#define REG_BK330C_23_H      0x330C47
#define REG_BK330C_24_L      0x330C48
#define REG_BK330C_24_H      0x330C49
#define REG_BK330C_25_L      0x330C4A
#define REG_BK330C_25_H      0x330C4B
#define REG_BK330C_26_L      0x330C4C
#define REG_BK330C_26_H      0x330C4D
#define REG_BK330C_27_L      0x330C4E
#define REG_BK330C_27_H      0x330C4F
#define REG_BK330C_28_L      0x330C50
#define REG_BK330C_28_H      0x330C51
#define REG_BK330C_29_L      0x330C52
#define REG_BK330C_29_H      0x330C53
#define REG_BK330C_2A_L      0x330C54
#define REG_BK330C_2A_H      0x330C55
#define REG_BK330C_2B_L      0x330C56
#define REG_BK330C_2B_H      0x330C57
#define REG_BK330C_2C_L      0x330C58
#define REG_BK330C_2C_H      0x330C59
#define REG_BK330C_2D_L      0x330C5A
#define REG_BK330C_2D_H      0x330C5B
#define REG_BK330C_2E_L      0x330C5C
#define REG_BK330C_2E_H      0x330C5D
#define REG_BK330C_2F_L      0x330C5E
#define REG_BK330C_2F_H      0x330C5F
#define REG_BK330C_30_L      0x330C60
#define REG_BK330C_30_H      0x330C61
#define REG_BK330C_31_L      0x330C62
#define REG_BK330C_31_H      0x330C63
#define REG_BK330C_32_L      0x330C64
#define REG_BK330C_32_H      0x330C65
#define REG_BK330C_33_L      0x330C66
#define REG_BK330C_33_H      0x330C67
#define REG_BK330C_34_L      0x330C68
#define REG_BK330C_34_H      0x330C69
#define REG_BK330C_35_L      0x330C6A
#define REG_BK330C_35_H      0x330C6B
#define REG_BK330C_36_L      0x330C6C
#define REG_BK330C_36_H      0x330C6D
#define REG_BK330C_37_L      0x330C6E
#define REG_BK330C_37_H      0x330C6F
#define REG_BK330C_38_L      0x330C70
#define REG_BK330C_38_H      0x330C71
#define REG_BK330C_39_L      0x330C72
#define REG_BK330C_39_H      0x330C73
#define REG_BK330C_3A_L      0x330C74
#define REG_BK330C_3A_H      0x330C75
#define REG_BK330C_3B_L      0x330C76
#define REG_BK330C_3B_H      0x330C77
#define REG_BK330C_3C_L      0x330C78
#define REG_BK330C_3C_H      0x330C79
#define REG_BK330C_3D_L      0x330C7A
#define REG_BK330C_3D_H      0x330C7B
#define REG_BK330C_3E_L      0x330C7C
#define REG_BK330C_3E_H      0x330C7D
#define REG_BK330C_3F_L      0x330C7E
#define REG_BK330C_3F_H      0x330C7F
#define REG_BK330C_40_L      0x330C80
#define REG_BK330C_40_H      0x330C81
#define REG_BK330C_41_L      0x330C82
#define REG_BK330C_41_H      0x330C83
#define REG_BK330C_42_L      0x330C84
#define REG_BK330C_42_H      0x330C85
#define REG_BK330C_43_L      0x330C86
#define REG_BK330C_43_H      0x330C87
#define REG_BK330C_44_L      0x330C88
#define REG_BK330C_44_H      0x330C89
#define REG_BK330C_45_L      0x330C8A
#define REG_BK330C_45_H      0x330C8B
#define REG_BK330C_46_L      0x330C8C
#define REG_BK330C_46_H      0x330C8D
#define REG_BK330C_47_L      0x330C8E
#define REG_BK330C_47_H      0x330C8F
#define REG_BK330C_48_L      0x330C90
#define REG_BK330C_48_H      0x330C91
#define REG_BK330C_49_L      0x330C92
#define REG_BK330C_49_H      0x330C93
#define REG_BK330C_4A_L      0x330C94
#define REG_BK330C_4A_H      0x330C95
#define REG_BK330C_4B_L      0x330C96
#define REG_BK330C_4B_H      0x330C97
#define REG_BK330C_4C_L      0x330C98
#define REG_BK330C_4C_H      0x330C99
#define REG_BK330C_4D_L      0x330C9A
#define REG_BK330C_4D_H      0x330C9B
#define REG_BK330C_4E_L      0x330C9C
#define REG_BK330C_4E_H      0x330C9D
#define REG_BK330C_4F_L      0x330C9E
#define REG_BK330C_4F_H      0x330C9F
#define REG_BK330C_50_L      0x330CA0
#define REG_BK330C_50_H      0x330CA1
#define REG_BK330C_51_L      0x330CA2
#define REG_BK330C_51_H      0x330CA3
#define REG_BK330C_52_L      0x330CA4
#define REG_BK330C_52_H      0x330CA5
#define REG_BK330C_53_L      0x330CA6
#define REG_BK330C_53_H      0x330CA7
#define REG_BK330C_54_L      0x330CA8
#define REG_BK330C_54_H      0x330CA9
#define REG_BK330C_55_L      0x330CAA
#define REG_BK330C_55_H      0x330CAB
#define REG_BK330C_56_L      0x330CAC
#define REG_BK330C_56_H      0x330CAD
#define REG_BK330C_57_L      0x330CAE
#define REG_BK330C_57_H      0x330CAF
#define REG_BK330C_58_L      0x330CB0
#define REG_BK330C_58_H      0x330CB1
#define REG_BK330C_59_L      0x330CB2
#define REG_BK330C_59_H      0x330CB3
#define REG_BK330C_5A_L      0x330CB4
#define REG_BK330C_5A_H      0x330CB5
#define REG_BK330C_5B_L      0x330CB6
#define REG_BK330C_5B_H      0x330CB7
#define REG_BK330C_5C_L      0x330CB8
#define REG_BK330C_5C_H      0x330CB9
#define REG_BK330C_5D_L      0x330CBA
#define REG_BK330C_5D_H      0x330CBB
#define REG_BK330C_5E_L      0x330CBC
#define REG_BK330C_5E_H      0x330CBD
#define REG_BK330C_5F_L      0x330CBE
#define REG_BK330C_5F_H      0x330CBF
#define REG_BK330C_60_L      0x330CC0
#define REG_BK330C_60_H      0x330CC1
#define REG_BK330C_61_L      0x330CC2
#define REG_BK330C_61_H      0x330CC3
#define REG_BK330C_62_L      0x330CC4
#define REG_BK330C_62_H      0x330CC5
#define REG_BK330C_63_L      0x330CC6
#define REG_BK330C_63_H      0x330CC7
#define REG_BK330C_64_L      0x330CC8
#define REG_BK330C_64_H      0x330CC9
#define REG_BK330C_65_L      0x330CCA
#define REG_BK330C_65_H      0x330CCB
#define REG_BK330C_66_L      0x330CCC
#define REG_BK330C_66_H      0x330CCD
#define REG_BK330C_67_L      0x330CCE
#define REG_BK330C_67_H      0x330CCF
#define REG_BK330C_68_L      0x330CD0
#define REG_BK330C_68_H      0x330CD1
#define REG_BK330C_69_L      0x330CD2
#define REG_BK330C_69_H      0x330CD3
#define REG_BK330C_6A_L      0x330CD4
#define REG_BK330C_6A_H      0x330CD5
#define REG_BK330C_6B_L      0x330CD6
#define REG_BK330C_6B_H      0x330CD7
#define REG_BK330C_6C_L      0x330CD8
#define REG_BK330C_6C_H      0x330CD9
#define REG_BK330C_6D_L      0x330CDA
#define REG_BK330C_6D_H      0x330CDB
#define REG_BK330C_6E_L      0x330CDC
#define REG_BK330C_6E_H      0x330CDD
#define REG_BK330C_6F_L      0x330CDE
#define REG_BK330C_6F_H      0x330CDF
#define REG_BK330C_70_L      0x330CE0
#define REG_BK330C_70_H      0x330CE1
#define REG_BK330C_71_L      0x330CE2
#define REG_BK330C_71_H      0x330CE3
#define REG_BK330C_72_L      0x330CE4
#define REG_BK330C_72_H      0x330CE5
#define REG_BK330C_73_L      0x330CE6
#define REG_BK330C_73_H      0x330CE7
#define REG_BK330C_74_L      0x330CE8
#define REG_BK330C_74_H      0x330CE9
#define REG_BK330C_75_L      0x330CEA
#define REG_BK330C_75_H      0x330CEB
#define REG_BK330C_76_L      0x330CEC
#define REG_BK330C_76_H      0x330CED
#define REG_BK330C_77_L      0x330CEE
#define REG_BK330C_77_H      0x330CEF
#define REG_BK330C_78_L      0x330CF0
#define REG_BK330C_78_H      0x330CF1
#define REG_BK330C_79_L      0x330CF2
#define REG_BK330C_79_H      0x330CF3
#define REG_BK330C_7A_L      0x330CF4
#define REG_BK330C_7A_H      0x330CF5
#define REG_BK330C_7B_L      0x330CF6
#define REG_BK330C_7B_H      0x330CF7
#define REG_BK330C_7C_L      0x330CF8
#define REG_BK330C_7C_H      0x330CF9
#define REG_BK330C_7D_L      0x330CFA
#define REG_BK330C_7D_H      0x330CFB
#define REG_BK330C_7E_L      0x330CFC
#define REG_BK330C_7E_H      0x330CFD
#define REG_BK330C_7F_L      0x330CFE
#define REG_BK330C_7F_H      0x330CFF
//----------------------------------------------
#define REG_BK330E_00_L      0x330E00
#define REG_BK330E_00_H      0x330E01
#define REG_BK330E_01_L      0x330E02
#define REG_BK330E_01_H      0x330E03
#define REG_BK330E_02_L      0x330E04
#define REG_BK330E_02_H      0x330E05
#define REG_BK330E_03_L      0x330E06
#define REG_BK330E_03_H      0x330E07
#define REG_BK330E_04_L      0x330E08
#define REG_BK330E_04_H      0x330E09
#define REG_BK330E_05_L      0x330E0A
#define REG_BK330E_05_H      0x330E0B
#define REG_BK330E_06_L      0x330E0C
#define REG_BK330E_06_H      0x330E0D
#define REG_BK330E_07_L      0x330E0E
#define REG_BK330E_07_H      0x330E0F
#define REG_BK330E_08_L      0x330E10
#define REG_BK330E_08_H      0x330E11
#define REG_BK330E_09_L      0x330E12
#define REG_BK330E_09_H      0x330E13
#define REG_BK330E_0A_L      0x330E14
#define REG_BK330E_0A_H      0x330E15
#define REG_BK330E_0B_L      0x330E16
#define REG_BK330E_0B_H      0x330E17
#define REG_BK330E_0C_L      0x330E18
#define REG_BK330E_0C_H      0x330E19
#define REG_BK330E_0D_L      0x330E1A
#define REG_BK330E_0D_H      0x330E1B
#define REG_BK330E_0E_L      0x330E1C
#define REG_BK330E_0E_H      0x330E1D
#define REG_BK330E_0F_L      0x330E1E
#define REG_BK330E_0F_H      0x330E1F
#define REG_BK330E_10_L      0x330E20
#define REG_BK330E_10_H      0x330E21
#define REG_BK330E_11_L      0x330E22
#define REG_BK330E_11_H      0x330E23
#define REG_BK330E_12_L      0x330E24
#define REG_BK330E_12_H      0x330E25
#define REG_BK330E_13_L      0x330E26
#define REG_BK330E_13_H      0x330E27
#define REG_BK330E_14_L      0x330E28
#define REG_BK330E_14_H      0x330E29
#define REG_BK330E_15_L      0x330E2A
#define REG_BK330E_15_H      0x330E2B
#define REG_BK330E_16_L      0x330E2C
#define REG_BK330E_16_H      0x330E2D
#define REG_BK330E_17_L      0x330E2E
#define REG_BK330E_17_H      0x330E2F
#define REG_BK330E_18_L      0x330E30
#define REG_BK330E_18_H      0x330E31
#define REG_BK330E_19_L      0x330E32
#define REG_BK330E_19_H      0x330E33
#define REG_BK330E_1A_L      0x330E34
#define REG_BK330E_1A_H      0x330E35
#define REG_BK330E_1B_L      0x330E36
#define REG_BK330E_1B_H      0x330E37
#define REG_BK330E_1C_L      0x330E38
#define REG_BK330E_1C_H      0x330E39
#define REG_BK330E_1D_L      0x330E3A
#define REG_BK330E_1D_H      0x330E3B
#define REG_BK330E_1E_L      0x330E3C
#define REG_BK330E_1E_H      0x330E3D
#define REG_BK330E_1F_L      0x330E3E
#define REG_BK330E_1F_H      0x330E3F
#define REG_BK330E_20_L      0x330E40
#define REG_BK330E_20_H      0x330E41
#define REG_BK330E_21_L      0x330E42
#define REG_BK330E_21_H      0x330E43
#define REG_BK330E_22_L      0x330E44
#define REG_BK330E_22_H      0x330E45
#define REG_BK330E_23_L      0x330E46
#define REG_BK330E_23_H      0x330E47
#define REG_BK330E_24_L      0x330E48
#define REG_BK330E_24_H      0x330E49
#define REG_BK330E_25_L      0x330E4A
#define REG_BK330E_25_H      0x330E4B
#define REG_BK330E_26_L      0x330E4C
#define REG_BK330E_26_H      0x330E4D
#define REG_BK330E_27_L      0x330E4E
#define REG_BK330E_27_H      0x330E4F
#define REG_BK330E_28_L      0x330E50
#define REG_BK330E_28_H      0x330E51
#define REG_BK330E_29_L      0x330E52
#define REG_BK330E_29_H      0x330E53
#define REG_BK330E_2A_L      0x330E54
#define REG_BK330E_2A_H      0x330E55
#define REG_BK330E_2B_L      0x330E56
#define REG_BK330E_2B_H      0x330E57
#define REG_BK330E_2C_L      0x330E58
#define REG_BK330E_2C_H      0x330E59
#define REG_BK330E_2D_L      0x330E5A
#define REG_BK330E_2D_H      0x330E5B
#define REG_BK330E_2E_L      0x330E5C
#define REG_BK330E_2E_H      0x330E5D
#define REG_BK330E_2F_L      0x330E5E
#define REG_BK330E_2F_H      0x330E5F
#define REG_BK330E_30_L      0x330E60
#define REG_BK330E_30_H      0x330E61
#define REG_BK330E_31_L      0x330E62
#define REG_BK330E_31_H      0x330E63
#define REG_BK330E_32_L      0x330E64
#define REG_BK330E_32_H      0x330E65
#define REG_BK330E_33_L      0x330E66
#define REG_BK330E_33_H      0x330E67
#define REG_BK330E_34_L      0x330E68
#define REG_BK330E_34_H      0x330E69
#define REG_BK330E_35_L      0x330E6A
#define REG_BK330E_35_H      0x330E6B
#define REG_BK330E_36_L      0x330E6C
#define REG_BK330E_36_H      0x330E6D
#define REG_BK330E_37_L      0x330E6E
#define REG_BK330E_37_H      0x330E6F
#define REG_BK330E_38_L      0x330E70
#define REG_BK330E_38_H      0x330E71
#define REG_BK330E_39_L      0x330E72
#define REG_BK330E_39_H      0x330E73
#define REG_BK330E_3A_L      0x330E74
#define REG_BK330E_3A_H      0x330E75
#define REG_BK330E_3B_L      0x330E76
#define REG_BK330E_3B_H      0x330E77
#define REG_BK330E_3C_L      0x330E78
#define REG_BK330E_3C_H      0x330E79
#define REG_BK330E_3D_L      0x330E7A
#define REG_BK330E_3D_H      0x330E7B
#define REG_BK330E_3E_L      0x330E7C
#define REG_BK330E_3E_H      0x330E7D
#define REG_BK330E_3F_L      0x330E7E
#define REG_BK330E_3F_H      0x330E7F
#define REG_BK330E_40_L      0x330E80
#define REG_BK330E_40_H      0x330E81
#define REG_BK330E_41_L      0x330E82
#define REG_BK330E_41_H      0x330E83
#define REG_BK330E_42_L      0x330E84
#define REG_BK330E_42_H      0x330E85
#define REG_BK330E_43_L      0x330E86
#define REG_BK330E_43_H      0x330E87
#define REG_BK330E_44_L      0x330E88
#define REG_BK330E_44_H      0x330E89
#define REG_BK330E_45_L      0x330E8A
#define REG_BK330E_45_H      0x330E8B
#define REG_BK330E_46_L      0x330E8C
#define REG_BK330E_46_H      0x330E8D
#define REG_BK330E_47_L      0x330E8E
#define REG_BK330E_47_H      0x330E8F
#define REG_BK330E_48_L      0x330E90
#define REG_BK330E_48_H      0x330E91
#define REG_BK330E_49_L      0x330E92
#define REG_BK330E_49_H      0x330E93
#define REG_BK330E_4A_L      0x330E94
#define REG_BK330E_4A_H      0x330E95
#define REG_BK330E_4B_L      0x330E96
#define REG_BK330E_4B_H      0x330E97
#define REG_BK330E_4C_L      0x330E98
#define REG_BK330E_4C_H      0x330E99
#define REG_BK330E_4D_L      0x330E9A
#define REG_BK330E_4D_H      0x330E9B
#define REG_BK330E_4E_L      0x330E9C
#define REG_BK330E_4E_H      0x330E9D
#define REG_BK330E_4F_L      0x330E9E
#define REG_BK330E_4F_H      0x330E9F
#define REG_BK330E_50_L      0x330EA0
#define REG_BK330E_50_H      0x330EA1
#define REG_BK330E_51_L      0x330EA2
#define REG_BK330E_51_H      0x330EA3
#define REG_BK330E_52_L      0x330EA4
#define REG_BK330E_52_H      0x330EA5
#define REG_BK330E_53_L      0x330EA6
#define REG_BK330E_53_H      0x330EA7
#define REG_BK330E_54_L      0x330EA8
#define REG_BK330E_54_H      0x330EA9
#define REG_BK330E_55_L      0x330EAA
#define REG_BK330E_55_H      0x330EAB
#define REG_BK330E_56_L      0x330EAC
#define REG_BK330E_56_H      0x330EAD
#define REG_BK330E_57_L      0x330EAE
#define REG_BK330E_57_H      0x330EAF
#define REG_BK330E_58_L      0x330EB0
#define REG_BK330E_58_H      0x330EB1
#define REG_BK330E_59_L      0x330EB2
#define REG_BK330E_59_H      0x330EB3
#define REG_BK330E_5A_L      0x330EB4
#define REG_BK330E_5A_H      0x330EB5
#define REG_BK330E_5B_L      0x330EB6
#define REG_BK330E_5B_H      0x330EB7
#define REG_BK330E_5C_L      0x330EB8
#define REG_BK330E_5C_H      0x330EB9
#define REG_BK330E_5D_L      0x330EBA
#define REG_BK330E_5D_H      0x330EBB
#define REG_BK330E_5E_L      0x330EBC
#define REG_BK330E_5E_H      0x330EBD
#define REG_BK330E_5F_L      0x330EBE
#define REG_BK330E_5F_H      0x330EBF
#define REG_BK330E_60_L      0x330EC0
#define REG_BK330E_60_H      0x330EC1
#define REG_BK330E_61_L      0x330EC2
#define REG_BK330E_61_H      0x330EC3
#define REG_BK330E_62_L      0x330EC4
#define REG_BK330E_62_H      0x330EC5
#define REG_BK330E_63_L      0x330EC6
#define REG_BK330E_63_H      0x330EC7
#define REG_BK330E_64_L      0x330EC8
#define REG_BK330E_64_H      0x330EC9
#define REG_BK330E_65_L      0x330ECA
#define REG_BK330E_65_H      0x330ECB
#define REG_BK330E_66_L      0x330ECC
#define REG_BK330E_66_H      0x330ECD
#define REG_BK330E_67_L      0x330ECE
#define REG_BK330E_67_H      0x330ECF
#define REG_BK330E_68_L      0x330ED0
#define REG_BK330E_68_H      0x330ED1
#define REG_BK330E_69_L      0x330ED2
#define REG_BK330E_69_H      0x330ED3
#define REG_BK330E_6A_L      0x330ED4
#define REG_BK330E_6A_H      0x330ED5
#define REG_BK330E_6B_L      0x330ED6
#define REG_BK330E_6B_H      0x330ED7
#define REG_BK330E_6C_L      0x330ED8
#define REG_BK330E_6C_H      0x330ED9
#define REG_BK330E_6D_L      0x330EDA
#define REG_BK330E_6D_H      0x330EDB
#define REG_BK330E_6E_L      0x330EDC
#define REG_BK330E_6E_H      0x330EDD
#define REG_BK330E_6F_L      0x330EDE
#define REG_BK330E_6F_H      0x330EDF
#define REG_BK330E_70_L      0x330EE0
#define REG_BK330E_70_H      0x330EE1
#define REG_BK330E_71_L      0x330EE2
#define REG_BK330E_71_H      0x330EE3
#define REG_BK330E_72_L      0x330EE4
#define REG_BK330E_72_H      0x330EE5
#define REG_BK330E_73_L      0x330EE6
#define REG_BK330E_73_H      0x330EE7
#define REG_BK330E_74_L      0x330EE8
#define REG_BK330E_74_H      0x330EE9
#define REG_BK330E_75_L      0x330EEA
#define REG_BK330E_75_H      0x330EEB
#define REG_BK330E_76_L      0x330EEC
#define REG_BK330E_76_H      0x330EED
#define REG_BK330E_77_L      0x330EEE
#define REG_BK330E_77_H      0x330EEF
#define REG_BK330E_78_L      0x330EF0
#define REG_BK330E_78_H      0x330EF1
#define REG_BK330E_79_L      0x330EF2
#define REG_BK330E_79_H      0x330EF3
#define REG_BK330E_7A_L      0x330EF4
#define REG_BK330E_7A_H      0x330EF5
#define REG_BK330E_7B_L      0x330EF6
#define REG_BK330E_7B_H      0x330EF7
#define REG_BK330E_7C_L      0x330EF8
#define REG_BK330E_7C_H      0x330EF9
#define REG_BK330E_7D_L      0x330EFA
#define REG_BK330E_7D_H      0x330EFB
#define REG_BK330E_7E_L      0x330EFC
#define REG_BK330E_7E_H      0x330EFD
#define REG_BK330E_7F_L      0x330EFE
#define REG_BK330E_7F_H      0x330EFF
//----------------------------------------------
#define REG_BK3310_00_L      0x331000
#define REG_BK3310_00_H      0x331001
#define REG_BK3310_01_L      0x331002
#define REG_BK3310_01_H      0x331003
#define REG_BK3310_02_L      0x331004
#define REG_BK3310_02_H      0x331005
#define REG_BK3310_03_L      0x331006
#define REG_BK3310_03_H      0x331007
#define REG_BK3310_04_L      0x331008
#define REG_BK3310_04_H      0x331009
#define REG_BK3310_05_L      0x33100A
#define REG_BK3310_05_H      0x33100B
#define REG_BK3310_06_L      0x33100C
#define REG_BK3310_06_H      0x33100D
#define REG_BK3310_07_L      0x33100E
#define REG_BK3310_07_H      0x33100F
#define REG_BK3310_08_L      0x331010
#define REG_BK3310_08_H      0x331011
#define REG_BK3310_09_L      0x331012
#define REG_BK3310_09_H      0x331013
#define REG_BK3310_0A_L      0x331014
#define REG_BK3310_0A_H      0x331015
#define REG_BK3310_0B_L      0x331016
#define REG_BK3310_0B_H      0x331017
#define REG_BK3310_0C_L      0x331018
#define REG_BK3310_0C_H      0x331019
#define REG_BK3310_0D_L      0x33101A
#define REG_BK3310_0D_H      0x33101B
#define REG_BK3310_0E_L      0x33101C
#define REG_BK3310_0E_H      0x33101D
#define REG_BK3310_0F_L      0x33101E
#define REG_BK3310_0F_H      0x33101F
#define REG_BK3310_10_L      0x331020
#define REG_BK3310_10_H      0x331021
#define REG_BK3310_11_L      0x331022
#define REG_BK3310_11_H      0x331023
#define REG_BK3310_12_L      0x331024
#define REG_BK3310_12_H      0x331025
#define REG_BK3310_13_L      0x331026
#define REG_BK3310_13_H      0x331027
#define REG_BK3310_14_L      0x331028
#define REG_BK3310_14_H      0x331029
#define REG_BK3310_15_L      0x33102A
#define REG_BK3310_15_H      0x33102B
#define REG_BK3310_16_L      0x33102C
#define REG_BK3310_16_H      0x33102D
#define REG_BK3310_17_L      0x33102E
#define REG_BK3310_17_H      0x33102F
#define REG_BK3310_18_L      0x331030
#define REG_BK3310_18_H      0x331031
#define REG_BK3310_19_L      0x331032
#define REG_BK3310_19_H      0x331033
#define REG_BK3310_1A_L      0x331034
#define REG_BK3310_1A_H      0x331035
#define REG_BK3310_1B_L      0x331036
#define REG_BK3310_1B_H      0x331037
#define REG_BK3310_1C_L      0x331038
#define REG_BK3310_1C_H      0x331039
#define REG_BK3310_1D_L      0x33103A
#define REG_BK3310_1D_H      0x33103B
#define REG_BK3310_1E_L      0x33103C
#define REG_BK3310_1E_H      0x33103D
#define REG_BK3310_1F_L      0x33103E
#define REG_BK3310_1F_H      0x33103F
#define REG_BK3310_20_L      0x331040
#define REG_BK3310_20_H      0x331041
#define REG_BK3310_21_L      0x331042
#define REG_BK3310_21_H      0x331043
#define REG_BK3310_22_L      0x331044
#define REG_BK3310_22_H      0x331045
#define REG_BK3310_23_L      0x331046
#define REG_BK3310_23_H      0x331047
#define REG_BK3310_24_L      0x331048
#define REG_BK3310_24_H      0x331049
#define REG_BK3310_25_L      0x33104A
#define REG_BK3310_25_H      0x33104B
#define REG_BK3310_26_L      0x33104C
#define REG_BK3310_26_H      0x33104D
#define REG_BK3310_27_L      0x33104E
#define REG_BK3310_27_H      0x33104F
#define REG_BK3310_28_L      0x331050
#define REG_BK3310_28_H      0x331051
#define REG_BK3310_29_L      0x331052
#define REG_BK3310_29_H      0x331053
#define REG_BK3310_2A_L      0x331054
#define REG_BK3310_2A_H      0x331055
#define REG_BK3310_2B_L      0x331056
#define REG_BK3310_2B_H      0x331057
#define REG_BK3310_2C_L      0x331058
#define REG_BK3310_2C_H      0x331059
#define REG_BK3310_2D_L      0x33105A
#define REG_BK3310_2D_H      0x33105B
#define REG_BK3310_2E_L      0x33105C
#define REG_BK3310_2E_H      0x33105D
#define REG_BK3310_2F_L      0x33105E
#define REG_BK3310_2F_H      0x33105F
#define REG_BK3310_30_L      0x331060
#define REG_BK3310_30_H      0x331061
#define REG_BK3310_31_L      0x331062
#define REG_BK3310_31_H      0x331063
#define REG_BK3310_32_L      0x331064
#define REG_BK3310_32_H      0x331065
#define REG_BK3310_33_L      0x331066
#define REG_BK3310_33_H      0x331067
#define REG_BK3310_34_L      0x331068
#define REG_BK3310_34_H      0x331069
#define REG_BK3310_35_L      0x33106A
#define REG_BK3310_35_H      0x33106B
#define REG_BK3310_36_L      0x33106C
#define REG_BK3310_36_H      0x33106D
#define REG_BK3310_37_L      0x33106E
#define REG_BK3310_37_H      0x33106F
#define REG_BK3310_38_L      0x331070
#define REG_BK3310_38_H      0x331071
#define REG_BK3310_39_L      0x331072
#define REG_BK3310_39_H      0x331073
#define REG_BK3310_3A_L      0x331074
#define REG_BK3310_3A_H      0x331075
#define REG_BK3310_3B_L      0x331076
#define REG_BK3310_3B_H      0x331077
#define REG_BK3310_3C_L      0x331078
#define REG_BK3310_3C_H      0x331079
#define REG_BK3310_3D_L      0x33107A
#define REG_BK3310_3D_H      0x33107B
#define REG_BK3310_3E_L      0x33107C
#define REG_BK3310_3E_H      0x33107D
#define REG_BK3310_3F_L      0x33107E
#define REG_BK3310_3F_H      0x33107F
#define REG_BK3310_40_L      0x331080
#define REG_BK3310_40_H      0x331081
#define REG_BK3310_41_L      0x331082
#define REG_BK3310_41_H      0x331083
#define REG_BK3310_42_L      0x331084
#define REG_BK3310_42_H      0x331085
#define REG_BK3310_43_L      0x331086
#define REG_BK3310_43_H      0x331087
#define REG_BK3310_44_L      0x331088
#define REG_BK3310_44_H      0x331089
#define REG_BK3310_45_L      0x33108A
#define REG_BK3310_45_H      0x33108B
#define REG_BK3310_46_L      0x33108C
#define REG_BK3310_46_H      0x33108D
#define REG_BK3310_47_L      0x33108E
#define REG_BK3310_47_H      0x33108F
#define REG_BK3310_48_L      0x331090
#define REG_BK3310_48_H      0x331091
#define REG_BK3310_49_L      0x331092
#define REG_BK3310_49_H      0x331093
#define REG_BK3310_4A_L      0x331094
#define REG_BK3310_4A_H      0x331095
#define REG_BK3310_4B_L      0x331096
#define REG_BK3310_4B_H      0x331097
#define REG_BK3310_4C_L      0x331098
#define REG_BK3310_4C_H      0x331099
#define REG_BK3310_4D_L      0x33109A
#define REG_BK3310_4D_H      0x33109B
#define REG_BK3310_4E_L      0x33109C
#define REG_BK3310_4E_H      0x33109D
#define REG_BK3310_4F_L      0x33109E
#define REG_BK3310_4F_H      0x33109F
#define REG_BK3310_50_L      0x3310A0
#define REG_BK3310_50_H      0x3310A1
#define REG_BK3310_51_L      0x3310A2
#define REG_BK3310_51_H      0x3310A3
#define REG_BK3310_52_L      0x3310A4
#define REG_BK3310_52_H      0x3310A5
#define REG_BK3310_53_L      0x3310A6
#define REG_BK3310_53_H      0x3310A7
#define REG_BK3310_54_L      0x3310A8
#define REG_BK3310_54_H      0x3310A9
#define REG_BK3310_55_L      0x3310AA
#define REG_BK3310_55_H      0x3310AB
#define REG_BK3310_56_L      0x3310AC
#define REG_BK3310_56_H      0x3310AD
#define REG_BK3310_57_L      0x3310AE
#define REG_BK3310_57_H      0x3310AF
#define REG_BK3310_58_L      0x3310B0
#define REG_BK3310_58_H      0x3310B1
#define REG_BK3310_59_L      0x3310B2
#define REG_BK3310_59_H      0x3310B3
#define REG_BK3310_5A_L      0x3310B4
#define REG_BK3310_5A_H      0x3310B5
#define REG_BK3310_5B_L      0x3310B6
#define REG_BK3310_5B_H      0x3310B7
#define REG_BK3310_5C_L      0x3310B8
#define REG_BK3310_5C_H      0x3310B9
#define REG_BK3310_5D_L      0x3310BA
#define REG_BK3310_5D_H      0x3310BB
#define REG_BK3310_5E_L      0x3310BC
#define REG_BK3310_5E_H      0x3310BD
#define REG_BK3310_5F_L      0x3310BE
#define REG_BK3310_5F_H      0x3310BF
#define REG_BK3310_60_L      0x3310C0
#define REG_BK3310_60_H      0x3310C1
#define REG_BK3310_61_L      0x3310C2
#define REG_BK3310_61_H      0x3310C3
#define REG_BK3310_62_L      0x3310C4
#define REG_BK3310_62_H      0x3310C5
#define REG_BK3310_63_L      0x3310C6
#define REG_BK3310_63_H      0x3310C7
#define REG_BK3310_64_L      0x3310C8
#define REG_BK3310_64_H      0x3310C9
#define REG_BK3310_65_L      0x3310CA
#define REG_BK3310_65_H      0x3310CB
#define REG_BK3310_66_L      0x3310CC
#define REG_BK3310_66_H      0x3310CD
#define REG_BK3310_67_L      0x3310CE
#define REG_BK3310_67_H      0x3310CF
#define REG_BK3310_68_L      0x3310D0
#define REG_BK3310_68_H      0x3310D1
#define REG_BK3310_69_L      0x3310D2
#define REG_BK3310_69_H      0x3310D3
#define REG_BK3310_6A_L      0x3310D4
#define REG_BK3310_6A_H      0x3310D5
#define REG_BK3310_6B_L      0x3310D6
#define REG_BK3310_6B_H      0x3310D7
#define REG_BK3310_6C_L      0x3310D8
#define REG_BK3310_6C_H      0x3310D9
#define REG_BK3310_6D_L      0x3310DA
#define REG_BK3310_6D_H      0x3310DB
#define REG_BK3310_6E_L      0x3310DC
#define REG_BK3310_6E_H      0x3310DD
#define REG_BK3310_6F_L      0x3310DE
#define REG_BK3310_6F_H      0x3310DF
#define REG_BK3310_70_L      0x3310E0
#define REG_BK3310_70_H      0x3310E1
#define REG_BK3310_71_L      0x3310E2
#define REG_BK3310_71_H      0x3310E3
#define REG_BK3310_72_L      0x3310E4
#define REG_BK3310_72_H      0x3310E5
#define REG_BK3310_73_L      0x3310E6
#define REG_BK3310_73_H      0x3310E7
#define REG_BK3310_74_L      0x3310E8
#define REG_BK3310_74_H      0x3310E9
#define REG_BK3310_75_L      0x3310EA
#define REG_BK3310_75_H      0x3310EB
#define REG_BK3310_76_L      0x3310EC
#define REG_BK3310_76_H      0x3310ED
#define REG_BK3310_77_L      0x3310EE
#define REG_BK3310_77_H      0x3310EF
#define REG_BK3310_78_L      0x3310F0
#define REG_BK3310_78_H      0x3310F1
#define REG_BK3310_79_L      0x3310F2
#define REG_BK3310_79_H      0x3310F3
#define REG_BK3310_7A_L      0x3310F4
#define REG_BK3310_7A_H      0x3310F5
#define REG_BK3310_7B_L      0x3310F6
#define REG_BK3310_7B_H      0x3310F7
#define REG_BK3310_7C_L      0x3310F8
#define REG_BK3310_7C_H      0x3310F9
#define REG_BK3310_7D_L      0x3310FA
#define REG_BK3310_7D_H      0x3310FB
#define REG_BK3310_7E_L      0x3310FC
#define REG_BK3310_7E_H      0x3310FD
#define REG_BK3310_7F_L      0x3310FE
#define REG_BK3310_7F_H      0x3310FF
//----------------------------------------------
#define REG_BK3311_00_L      0x331100
#define REG_BK3311_00_H      0x331101
#define REG_BK3311_01_L      0x331102
#define REG_BK3311_01_H      0x331103
#define REG_BK3311_02_L      0x331104
#define REG_BK3311_02_H      0x331105
#define REG_BK3311_03_L      0x331106
#define REG_BK3311_03_H      0x331107
#define REG_BK3311_04_L      0x331108
#define REG_BK3311_04_H      0x331109
#define REG_BK3311_05_L      0x33110A
#define REG_BK3311_05_H      0x33110B
#define REG_BK3311_06_L      0x33110C
#define REG_BK3311_06_H      0x33110D
#define REG_BK3311_07_L      0x33110E
#define REG_BK3311_07_H      0x33110F
#define REG_BK3311_08_L      0x331110
#define REG_BK3311_08_H      0x331111
#define REG_BK3311_09_L      0x331112
#define REG_BK3311_09_H      0x331113
#define REG_BK3311_0A_L      0x331114
#define REG_BK3311_0A_H      0x331115
#define REG_BK3311_0B_L      0x331116
#define REG_BK3311_0B_H      0x331117
#define REG_BK3311_0C_L      0x331118
#define REG_BK3311_0C_H      0x331119
#define REG_BK3311_0D_L      0x33111A
#define REG_BK3311_0D_H      0x33111B
#define REG_BK3311_0E_L      0x33111C
#define REG_BK3311_0E_H      0x33111D
#define REG_BK3311_0F_L      0x33111E
#define REG_BK3311_0F_H      0x33111F
#define REG_BK3311_10_L      0x331120
#define REG_BK3311_10_H      0x331121
#define REG_BK3311_11_L      0x331122
#define REG_BK3311_11_H      0x331123
#define REG_BK3311_12_L      0x331124
#define REG_BK3311_12_H      0x331125
#define REG_BK3311_13_L      0x331126
#define REG_BK3311_13_H      0x331127
#define REG_BK3311_14_L      0x331128
#define REG_BK3311_14_H      0x331129
#define REG_BK3311_15_L      0x33112A
#define REG_BK3311_15_H      0x33112B
#define REG_BK3311_16_L      0x33112C
#define REG_BK3311_16_H      0x33112D
#define REG_BK3311_17_L      0x33112E
#define REG_BK3311_17_H      0x33112F
#define REG_BK3311_18_L      0x331130
#define REG_BK3311_18_H      0x331131
#define REG_BK3311_19_L      0x331132
#define REG_BK3311_19_H      0x331133
#define REG_BK3311_1A_L      0x331134
#define REG_BK3311_1A_H      0x331135
#define REG_BK3311_1B_L      0x331136
#define REG_BK3311_1B_H      0x331137
#define REG_BK3311_1C_L      0x331138
#define REG_BK3311_1C_H      0x331139
#define REG_BK3311_1D_L      0x33113A
#define REG_BK3311_1D_H      0x33113B
#define REG_BK3311_1E_L      0x33113C
#define REG_BK3311_1E_H      0x33113D
#define REG_BK3311_1F_L      0x33113E
#define REG_BK3311_1F_H      0x33113F
#define REG_BK3311_20_L      0x331140
#define REG_BK3311_20_H      0x331141
#define REG_BK3311_21_L      0x331142
#define REG_BK3311_21_H      0x331143
#define REG_BK3311_22_L      0x331144
#define REG_BK3311_22_H      0x331145
#define REG_BK3311_23_L      0x331146
#define REG_BK3311_23_H      0x331147
#define REG_BK3311_24_L      0x331148
#define REG_BK3311_24_H      0x331149
#define REG_BK3311_25_L      0x33114A
#define REG_BK3311_25_H      0x33114B
#define REG_BK3311_26_L      0x33114C
#define REG_BK3311_26_H      0x33114D
#define REG_BK3311_27_L      0x33114E
#define REG_BK3311_27_H      0x33114F
#define REG_BK3311_28_L      0x331150
#define REG_BK3311_28_H      0x331151
#define REG_BK3311_29_L      0x331152
#define REG_BK3311_29_H      0x331153
#define REG_BK3311_2A_L      0x331154
#define REG_BK3311_2A_H      0x331155
#define REG_BK3311_2B_L      0x331156
#define REG_BK3311_2B_H      0x331157
#define REG_BK3311_2C_L      0x331158
#define REG_BK3311_2C_H      0x331159
#define REG_BK3311_2D_L      0x33115A
#define REG_BK3311_2D_H      0x33115B
#define REG_BK3311_2E_L      0x33115C
#define REG_BK3311_2E_H      0x33115D
#define REG_BK3311_2F_L      0x33115E
#define REG_BK3311_2F_H      0x33115F
#define REG_BK3311_30_L      0x331160
#define REG_BK3311_30_H      0x331161
#define REG_BK3311_31_L      0x331162
#define REG_BK3311_31_H      0x331163
#define REG_BK3311_32_L      0x331164
#define REG_BK3311_32_H      0x331165
#define REG_BK3311_33_L      0x331166
#define REG_BK3311_33_H      0x331167
#define REG_BK3311_34_L      0x331168
#define REG_BK3311_34_H      0x331169
#define REG_BK3311_35_L      0x33116A
#define REG_BK3311_35_H      0x33116B
#define REG_BK3311_36_L      0x33116C
#define REG_BK3311_36_H      0x33116D
#define REG_BK3311_37_L      0x33116E
#define REG_BK3311_37_H      0x33116F
#define REG_BK3311_38_L      0x331170
#define REG_BK3311_38_H      0x331171
#define REG_BK3311_39_L      0x331172
#define REG_BK3311_39_H      0x331173
#define REG_BK3311_3A_L      0x331174
#define REG_BK3311_3A_H      0x331175
#define REG_BK3311_3B_L      0x331176
#define REG_BK3311_3B_H      0x331177
#define REG_BK3311_3C_L      0x331178
#define REG_BK3311_3C_H      0x331179
#define REG_BK3311_3D_L      0x33117A
#define REG_BK3311_3D_H      0x33117B
#define REG_BK3311_3E_L      0x33117C
#define REG_BK3311_3E_H      0x33117D
#define REG_BK3311_3F_L      0x33117E
#define REG_BK3311_3F_H      0x33117F
#define REG_BK3311_40_L      0x331180
#define REG_BK3311_40_H      0x331181
#define REG_BK3311_41_L      0x331182
#define REG_BK3311_41_H      0x331183
#define REG_BK3311_42_L      0x331184
#define REG_BK3311_42_H      0x331185
#define REG_BK3311_43_L      0x331186
#define REG_BK3311_43_H      0x331187
#define REG_BK3311_44_L      0x331188
#define REG_BK3311_44_H      0x331189
#define REG_BK3311_45_L      0x33118A
#define REG_BK3311_45_H      0x33118B
#define REG_BK3311_46_L      0x33118C
#define REG_BK3311_46_H      0x33118D
#define REG_BK3311_47_L      0x33118E
#define REG_BK3311_47_H      0x33118F
#define REG_BK3311_48_L      0x331190
#define REG_BK3311_48_H      0x331191
#define REG_BK3311_49_L      0x331192
#define REG_BK3311_49_H      0x331193
#define REG_BK3311_4A_L      0x331194
#define REG_BK3311_4A_H      0x331195
#define REG_BK3311_4B_L      0x331196
#define REG_BK3311_4B_H      0x331197
#define REG_BK3311_4C_L      0x331198
#define REG_BK3311_4C_H      0x331199
#define REG_BK3311_4D_L      0x33119A
#define REG_BK3311_4D_H      0x33119B
#define REG_BK3311_4E_L      0x33119C
#define REG_BK3311_4E_H      0x33119D
#define REG_BK3311_4F_L      0x33119E
#define REG_BK3311_4F_H      0x33119F
#define REG_BK3311_50_L      0x3311A0
#define REG_BK3311_50_H      0x3311A1
#define REG_BK3311_51_L      0x3311A2
#define REG_BK3311_51_H      0x3311A3
#define REG_BK3311_52_L      0x3311A4
#define REG_BK3311_52_H      0x3311A5
#define REG_BK3311_53_L      0x3311A6
#define REG_BK3311_53_H      0x3311A7
#define REG_BK3311_54_L      0x3311A8
#define REG_BK3311_54_H      0x3311A9
#define REG_BK3311_55_L      0x3311AA
#define REG_BK3311_55_H      0x3311AB
#define REG_BK3311_56_L      0x3311AC
#define REG_BK3311_56_H      0x3311AD
#define REG_BK3311_57_L      0x3311AE
#define REG_BK3311_57_H      0x3311AF
#define REG_BK3311_58_L      0x3311B0
#define REG_BK3311_58_H      0x3311B1
#define REG_BK3311_59_L      0x3311B2
#define REG_BK3311_59_H      0x3311B3
#define REG_BK3311_5A_L      0x3311B4
#define REG_BK3311_5A_H      0x3311B5
#define REG_BK3311_5B_L      0x3311B6
#define REG_BK3311_5B_H      0x3311B7
#define REG_BK3311_5C_L      0x3311B8
#define REG_BK3311_5C_H      0x3311B9
#define REG_BK3311_5D_L      0x3311BA
#define REG_BK3311_5D_H      0x3311BB
#define REG_BK3311_5E_L      0x3311BC
#define REG_BK3311_5E_H      0x3311BD
#define REG_BK3311_5F_L      0x3311BE
#define REG_BK3311_5F_H      0x3311BF
#define REG_BK3311_60_L      0x3311C0
#define REG_BK3311_60_H      0x3311C1
#define REG_BK3311_61_L      0x3311C2
#define REG_BK3311_61_H      0x3311C3
#define REG_BK3311_62_L      0x3311C4
#define REG_BK3311_62_H      0x3311C5
#define REG_BK3311_63_L      0x3311C6
#define REG_BK3311_63_H      0x3311C7
#define REG_BK3311_64_L      0x3311C8
#define REG_BK3311_64_H      0x3311C9
#define REG_BK3311_65_L      0x3311CA
#define REG_BK3311_65_H      0x3311CB
#define REG_BK3311_66_L      0x3311CC
#define REG_BK3311_66_H      0x3311CD
#define REG_BK3311_67_L      0x3311CE
#define REG_BK3311_67_H      0x3311CF
#define REG_BK3311_68_L      0x3311D0
#define REG_BK3311_68_H      0x3311D1
#define REG_BK3311_69_L      0x3311D2
#define REG_BK3311_69_H      0x3311D3
#define REG_BK3311_6A_L      0x3311D4
#define REG_BK3311_6A_H      0x3311D5
#define REG_BK3311_6B_L      0x3311D6
#define REG_BK3311_6B_H      0x3311D7
#define REG_BK3311_6C_L      0x3311D8
#define REG_BK3311_6C_H      0x3311D9
#define REG_BK3311_6D_L      0x3311DA
#define REG_BK3311_6D_H      0x3311DB
#define REG_BK3311_6E_L      0x3311DC
#define REG_BK3311_6E_H      0x3311DD
#define REG_BK3311_6F_L      0x3311DE
#define REG_BK3311_6F_H      0x3311DF
#define REG_BK3311_70_L      0x3311E0
#define REG_BK3311_70_H      0x3311E1
#define REG_BK3311_71_L      0x3311E2
#define REG_BK3311_71_H      0x3311E3
#define REG_BK3311_72_L      0x3311E4
#define REG_BK3311_72_H      0x3311E5
#define REG_BK3311_73_L      0x3311E6
#define REG_BK3311_73_H      0x3311E7
#define REG_BK3311_74_L      0x3311E8
#define REG_BK3311_74_H      0x3311E9
#define REG_BK3311_75_L      0x3311EA
#define REG_BK3311_75_H      0x3311EB
#define REG_BK3311_76_L      0x3311EC
#define REG_BK3311_76_H      0x3311ED
#define REG_BK3311_77_L      0x3311EE
#define REG_BK3311_77_H      0x3311EF
#define REG_BK3311_78_L      0x3311F0
#define REG_BK3311_78_H      0x3311F1
#define REG_BK3311_79_L      0x3311F2
#define REG_BK3311_79_H      0x3311F3
#define REG_BK3311_7A_L      0x3311F4
#define REG_BK3311_7A_H      0x3311F5
#define REG_BK3311_7B_L      0x3311F6
#define REG_BK3311_7B_H      0x3311F7
#define REG_BK3311_7C_L      0x3311F8
#define REG_BK3311_7C_H      0x3311F9
#define REG_BK3311_7D_L      0x3311FA
#define REG_BK3311_7D_H      0x3311FB
#define REG_BK3311_7E_L      0x3311FC
#define REG_BK3311_7E_H      0x3311FD
#define REG_BK3311_7F_L      0x3311FE
#define REG_BK3311_7F_H      0x3311FF
//----------------------------------------------
#define REG_BK3312_00_L      0x331200
#define REG_BK3312_00_H      0x331201
#define REG_BK3312_01_L      0x331202
#define REG_BK3312_01_H      0x331203
#define REG_BK3312_02_L      0x331204
#define REG_BK3312_02_H      0x331205
#define REG_BK3312_03_L      0x331206
#define REG_BK3312_03_H      0x331207
#define REG_BK3312_04_L      0x331208
#define REG_BK3312_04_H      0x331209
#define REG_BK3312_05_L      0x33120A
#define REG_BK3312_05_H      0x33120B
#define REG_BK3312_06_L      0x33120C
#define REG_BK3312_06_H      0x33120D
#define REG_BK3312_07_L      0x33120E
#define REG_BK3312_07_H      0x33120F
#define REG_BK3312_08_L      0x331210
#define REG_BK3312_08_H      0x331211
#define REG_BK3312_09_L      0x331212
#define REG_BK3312_09_H      0x331213
#define REG_BK3312_0A_L      0x331214
#define REG_BK3312_0A_H      0x331215
#define REG_BK3312_0B_L      0x331216
#define REG_BK3312_0B_H      0x331217
#define REG_BK3312_0C_L      0x331218
#define REG_BK3312_0C_H      0x331219
#define REG_BK3312_0D_L      0x33121A
#define REG_BK3312_0D_H      0x33121B
#define REG_BK3312_0E_L      0x33121C
#define REG_BK3312_0E_H      0x33121D
#define REG_BK3312_0F_L      0x33121E
#define REG_BK3312_0F_H      0x33121F
#define REG_BK3312_10_L      0x331220
#define REG_BK3312_10_H      0x331221
#define REG_BK3312_11_L      0x331222
#define REG_BK3312_11_H      0x331223
#define REG_BK3312_12_L      0x331224
#define REG_BK3312_12_H      0x331225
#define REG_BK3312_13_L      0x331226
#define REG_BK3312_13_H      0x331227
#define REG_BK3312_14_L      0x331228
#define REG_BK3312_14_H      0x331229
#define REG_BK3312_15_L      0x33122A
#define REG_BK3312_15_H      0x33122B
#define REG_BK3312_16_L      0x33122C
#define REG_BK3312_16_H      0x33122D
#define REG_BK3312_17_L      0x33122E
#define REG_BK3312_17_H      0x33122F
#define REG_BK3312_18_L      0x331230
#define REG_BK3312_18_H      0x331231
#define REG_BK3312_19_L      0x331232
#define REG_BK3312_19_H      0x331233
#define REG_BK3312_1A_L      0x331234
#define REG_BK3312_1A_H      0x331235
#define REG_BK3312_1B_L      0x331236
#define REG_BK3312_1B_H      0x331237
#define REG_BK3312_1C_L      0x331238
#define REG_BK3312_1C_H      0x331239
#define REG_BK3312_1D_L      0x33123A
#define REG_BK3312_1D_H      0x33123B
#define REG_BK3312_1E_L      0x33123C
#define REG_BK3312_1E_H      0x33123D
#define REG_BK3312_1F_L      0x33123E
#define REG_BK3312_1F_H      0x33123F
#define REG_BK3312_20_L      0x331240
#define REG_BK3312_20_H      0x331241
#define REG_BK3312_21_L      0x331242
#define REG_BK3312_21_H      0x331243
#define REG_BK3312_22_L      0x331244
#define REG_BK3312_22_H      0x331245
#define REG_BK3312_23_L      0x331246
#define REG_BK3312_23_H      0x331247
#define REG_BK3312_24_L      0x331248
#define REG_BK3312_24_H      0x331249
#define REG_BK3312_25_L      0x33124A
#define REG_BK3312_25_H      0x33124B
#define REG_BK3312_26_L      0x33124C
#define REG_BK3312_26_H      0x33124D
#define REG_BK3312_27_L      0x33124E
#define REG_BK3312_27_H      0x33124F
#define REG_BK3312_28_L      0x331250
#define REG_BK3312_28_H      0x331251
#define REG_BK3312_29_L      0x331252
#define REG_BK3312_29_H      0x331253
#define REG_BK3312_2A_L      0x331254
#define REG_BK3312_2A_H      0x331255
#define REG_BK3312_2B_L      0x331256
#define REG_BK3312_2B_H      0x331257
#define REG_BK3312_2C_L      0x331258
#define REG_BK3312_2C_H      0x331259
#define REG_BK3312_2D_L      0x33125A
#define REG_BK3312_2D_H      0x33125B
#define REG_BK3312_2E_L      0x33125C
#define REG_BK3312_2E_H      0x33125D
#define REG_BK3312_2F_L      0x33125E
#define REG_BK3312_2F_H      0x33125F
#define REG_BK3312_30_L      0x331260
#define REG_BK3312_30_H      0x331261
#define REG_BK3312_31_L      0x331262
#define REG_BK3312_31_H      0x331263
#define REG_BK3312_32_L      0x331264
#define REG_BK3312_32_H      0x331265
#define REG_BK3312_33_L      0x331266
#define REG_BK3312_33_H      0x331267
#define REG_BK3312_34_L      0x331268
#define REG_BK3312_34_H      0x331269
#define REG_BK3312_35_L      0x33126A
#define REG_BK3312_35_H      0x33126B
#define REG_BK3312_36_L      0x33126C
#define REG_BK3312_36_H      0x33126D
#define REG_BK3312_37_L      0x33126E
#define REG_BK3312_37_H      0x33126F
#define REG_BK3312_38_L      0x331270
#define REG_BK3312_38_H      0x331271
#define REG_BK3312_39_L      0x331272
#define REG_BK3312_39_H      0x331273
#define REG_BK3312_3A_L      0x331274
#define REG_BK3312_3A_H      0x331275
#define REG_BK3312_3B_L      0x331276
#define REG_BK3312_3B_H      0x331277
#define REG_BK3312_3C_L      0x331278
#define REG_BK3312_3C_H      0x331279
#define REG_BK3312_3D_L      0x33127A
#define REG_BK3312_3D_H      0x33127B
#define REG_BK3312_3E_L      0x33127C
#define REG_BK3312_3E_H      0x33127D
#define REG_BK3312_3F_L      0x33127E
#define REG_BK3312_3F_H      0x33127F
#define REG_BK3312_40_L      0x331280
#define REG_BK3312_40_H      0x331281
#define REG_BK3312_41_L      0x331282
#define REG_BK3312_41_H      0x331283
#define REG_BK3312_42_L      0x331284
#define REG_BK3312_42_H      0x331285
#define REG_BK3312_43_L      0x331286
#define REG_BK3312_43_H      0x331287
#define REG_BK3312_44_L      0x331288
#define REG_BK3312_44_H      0x331289
#define REG_BK3312_45_L      0x33128A
#define REG_BK3312_45_H      0x33128B
#define REG_BK3312_46_L      0x33128C
#define REG_BK3312_46_H      0x33128D
#define REG_BK3312_47_L      0x33128E
#define REG_BK3312_47_H      0x33128F
#define REG_BK3312_48_L      0x331290
#define REG_BK3312_48_H      0x331291
#define REG_BK3312_49_L      0x331292
#define REG_BK3312_49_H      0x331293
#define REG_BK3312_4A_L      0x331294
#define REG_BK3312_4A_H      0x331295
#define REG_BK3312_4B_L      0x331296
#define REG_BK3312_4B_H      0x331297
#define REG_BK3312_4C_L      0x331298
#define REG_BK3312_4C_H      0x331299
#define REG_BK3312_4D_L      0x33129A
#define REG_BK3312_4D_H      0x33129B
#define REG_BK3312_4E_L      0x33129C
#define REG_BK3312_4E_H      0x33129D
#define REG_BK3312_4F_L      0x33129E
#define REG_BK3312_4F_H      0x33129F
#define REG_BK3312_50_L      0x3312A0
#define REG_BK3312_50_H      0x3312A1
#define REG_BK3312_51_L      0x3312A2
#define REG_BK3312_51_H      0x3312A3
#define REG_BK3312_52_L      0x3312A4
#define REG_BK3312_52_H      0x3312A5
#define REG_BK3312_53_L      0x3312A6
#define REG_BK3312_53_H      0x3312A7
#define REG_BK3312_54_L      0x3312A8
#define REG_BK3312_54_H      0x3312A9
#define REG_BK3312_55_L      0x3312AA
#define REG_BK3312_55_H      0x3312AB
#define REG_BK3312_56_L      0x3312AC
#define REG_BK3312_56_H      0x3312AD
#define REG_BK3312_57_L      0x3312AE
#define REG_BK3312_57_H      0x3312AF
#define REG_BK3312_58_L      0x3312B0
#define REG_BK3312_58_H      0x3312B1
#define REG_BK3312_59_L      0x3312B2
#define REG_BK3312_59_H      0x3312B3
#define REG_BK3312_5A_L      0x3312B4
#define REG_BK3312_5A_H      0x3312B5
#define REG_BK3312_5B_L      0x3312B6
#define REG_BK3312_5B_H      0x3312B7
#define REG_BK3312_5C_L      0x3312B8
#define REG_BK3312_5C_H      0x3312B9
#define REG_BK3312_5D_L      0x3312BA
#define REG_BK3312_5D_H      0x3312BB
#define REG_BK3312_5E_L      0x3312BC
#define REG_BK3312_5E_H      0x3312BD
#define REG_BK3312_5F_L      0x3312BE
#define REG_BK3312_5F_H      0x3312BF
#define REG_BK3312_60_L      0x3312C0
#define REG_BK3312_60_H      0x3312C1
#define REG_BK3312_61_L      0x3312C2
#define REG_BK3312_61_H      0x3312C3
#define REG_BK3312_62_L      0x3312C4
#define REG_BK3312_62_H      0x3312C5
#define REG_BK3312_63_L      0x3312C6
#define REG_BK3312_63_H      0x3312C7
#define REG_BK3312_64_L      0x3312C8
#define REG_BK3312_64_H      0x3312C9
#define REG_BK3312_65_L      0x3312CA
#define REG_BK3312_65_H      0x3312CB
#define REG_BK3312_66_L      0x3312CC
#define REG_BK3312_66_H      0x3312CD
#define REG_BK3312_67_L      0x3312CE
#define REG_BK3312_67_H      0x3312CF
#define REG_BK3312_68_L      0x3312D0
#define REG_BK3312_68_H      0x3312D1
#define REG_BK3312_69_L      0x3312D2
#define REG_BK3312_69_H      0x3312D3
#define REG_BK3312_6A_L      0x3312D4
#define REG_BK3312_6A_H      0x3312D5
#define REG_BK3312_6B_L      0x3312D6
#define REG_BK3312_6B_H      0x3312D7
#define REG_BK3312_6C_L      0x3312D8
#define REG_BK3312_6C_H      0x3312D9
#define REG_BK3312_6D_L      0x3312DA
#define REG_BK3312_6D_H      0x3312DB
#define REG_BK3312_6E_L      0x3312DC
#define REG_BK3312_6E_H      0x3312DD
#define REG_BK3312_6F_L      0x3312DE
#define REG_BK3312_6F_H      0x3312DF
#define REG_BK3312_70_L      0x3312E0
#define REG_BK3312_70_H      0x3312E1
#define REG_BK3312_71_L      0x3312E2
#define REG_BK3312_71_H      0x3312E3
#define REG_BK3312_72_L      0x3312E4
#define REG_BK3312_72_H      0x3312E5
#define REG_BK3312_73_L      0x3312E6
#define REG_BK3312_73_H      0x3312E7
#define REG_BK3312_74_L      0x3312E8
#define REG_BK3312_74_H      0x3312E9
#define REG_BK3312_75_L      0x3312EA
#define REG_BK3312_75_H      0x3312EB
#define REG_BK3312_76_L      0x3312EC
#define REG_BK3312_76_H      0x3312ED
#define REG_BK3312_77_L      0x3312EE
#define REG_BK3312_77_H      0x3312EF
#define REG_BK3312_78_L      0x3312F0
#define REG_BK3312_78_H      0x3312F1
#define REG_BK3312_79_L      0x3312F2
#define REG_BK3312_79_H      0x3312F3
#define REG_BK3312_7A_L      0x3312F4
#define REG_BK3312_7A_H      0x3312F5
#define REG_BK3312_7B_L      0x3312F6
#define REG_BK3312_7B_H      0x3312F7
#define REG_BK3312_7C_L      0x3312F8
#define REG_BK3312_7C_H      0x3312F9
#define REG_BK3312_7D_L      0x3312FA
#define REG_BK3312_7D_H      0x3312FB
#define REG_BK3312_7E_L      0x3312FC
#define REG_BK3312_7E_H      0x3312FD
#define REG_BK3312_7F_L      0x3312FE
#define REG_BK3312_7F_H      0x3312FF
//----------------------------------------------
#define REG_BK3313_00_L      0x331300
#define REG_BK3313_00_H      0x331301
#define REG_BK3313_01_L      0x331302
#define REG_BK3313_01_H      0x331303
#define REG_BK3313_02_L      0x331304
#define REG_BK3313_02_H      0x331305
#define REG_BK3313_03_L      0x331306
#define REG_BK3313_03_H      0x331307
#define REG_BK3313_04_L      0x331308
#define REG_BK3313_04_H      0x331309
#define REG_BK3313_05_L      0x33130A
#define REG_BK3313_05_H      0x33130B
#define REG_BK3313_06_L      0x33130C
#define REG_BK3313_06_H      0x33130D
#define REG_BK3313_07_L      0x33130E
#define REG_BK3313_07_H      0x33130F
#define REG_BK3313_08_L      0x331310
#define REG_BK3313_08_H      0x331311
#define REG_BK3313_09_L      0x331312
#define REG_BK3313_09_H      0x331313
#define REG_BK3313_0A_L      0x331314
#define REG_BK3313_0A_H      0x331315
#define REG_BK3313_0B_L      0x331316
#define REG_BK3313_0B_H      0x331317
#define REG_BK3313_0C_L      0x331318
#define REG_BK3313_0C_H      0x331319
#define REG_BK3313_0D_L      0x33131A
#define REG_BK3313_0D_H      0x33131B
#define REG_BK3313_0E_L      0x33131C
#define REG_BK3313_0E_H      0x33131D
#define REG_BK3313_0F_L      0x33131E
#define REG_BK3313_0F_H      0x33131F
#define REG_BK3313_10_L      0x331320
#define REG_BK3313_10_H      0x331321
#define REG_BK3313_11_L      0x331322
#define REG_BK3313_11_H      0x331323
#define REG_BK3313_12_L      0x331324
#define REG_BK3313_12_H      0x331325
#define REG_BK3313_13_L      0x331326
#define REG_BK3313_13_H      0x331327
#define REG_BK3313_14_L      0x331328
#define REG_BK3313_14_H      0x331329
#define REG_BK3313_15_L      0x33132A
#define REG_BK3313_15_H      0x33132B
#define REG_BK3313_16_L      0x33132C
#define REG_BK3313_16_H      0x33132D
#define REG_BK3313_17_L      0x33132E
#define REG_BK3313_17_H      0x33132F
#define REG_BK3313_18_L      0x331330
#define REG_BK3313_18_H      0x331331
#define REG_BK3313_19_L      0x331332
#define REG_BK3313_19_H      0x331333
#define REG_BK3313_1A_L      0x331334
#define REG_BK3313_1A_H      0x331335
#define REG_BK3313_1B_L      0x331336
#define REG_BK3313_1B_H      0x331337
#define REG_BK3313_1C_L      0x331338
#define REG_BK3313_1C_H      0x331339
#define REG_BK3313_1D_L      0x33133A
#define REG_BK3313_1D_H      0x33133B
#define REG_BK3313_1E_L      0x33133C
#define REG_BK3313_1E_H      0x33133D
#define REG_BK3313_1F_L      0x33133E
#define REG_BK3313_1F_H      0x33133F
#define REG_BK3313_20_L      0x331340
#define REG_BK3313_20_H      0x331341
#define REG_BK3313_21_L      0x331342
#define REG_BK3313_21_H      0x331343
#define REG_BK3313_22_L      0x331344
#define REG_BK3313_22_H      0x331345
#define REG_BK3313_23_L      0x331346
#define REG_BK3313_23_H      0x331347
#define REG_BK3313_24_L      0x331348
#define REG_BK3313_24_H      0x331349
#define REG_BK3313_25_L      0x33134A
#define REG_BK3313_25_H      0x33134B
#define REG_BK3313_26_L      0x33134C
#define REG_BK3313_26_H      0x33134D
#define REG_BK3313_27_L      0x33134E
#define REG_BK3313_27_H      0x33134F
#define REG_BK3313_28_L      0x331350
#define REG_BK3313_28_H      0x331351
#define REG_BK3313_29_L      0x331352
#define REG_BK3313_29_H      0x331353
#define REG_BK3313_2A_L      0x331354
#define REG_BK3313_2A_H      0x331355
#define REG_BK3313_2B_L      0x331356
#define REG_BK3313_2B_H      0x331357
#define REG_BK3313_2C_L      0x331358
#define REG_BK3313_2C_H      0x331359
#define REG_BK3313_2D_L      0x33135A
#define REG_BK3313_2D_H      0x33135B
#define REG_BK3313_2E_L      0x33135C
#define REG_BK3313_2E_H      0x33135D
#define REG_BK3313_2F_L      0x33135E
#define REG_BK3313_2F_H      0x33135F
#define REG_BK3313_30_L      0x331360
#define REG_BK3313_30_H      0x331361
#define REG_BK3313_31_L      0x331362
#define REG_BK3313_31_H      0x331363
#define REG_BK3313_32_L      0x331364
#define REG_BK3313_32_H      0x331365
#define REG_BK3313_33_L      0x331366
#define REG_BK3313_33_H      0x331367
#define REG_BK3313_34_L      0x331368
#define REG_BK3313_34_H      0x331369
#define REG_BK3313_35_L      0x33136A
#define REG_BK3313_35_H      0x33136B
#define REG_BK3313_36_L      0x33136C
#define REG_BK3313_36_H      0x33136D
#define REG_BK3313_37_L      0x33136E
#define REG_BK3313_37_H      0x33136F
#define REG_BK3313_38_L      0x331370
#define REG_BK3313_38_H      0x331371
#define REG_BK3313_39_L      0x331372
#define REG_BK3313_39_H      0x331373
#define REG_BK3313_3A_L      0x331374
#define REG_BK3313_3A_H      0x331375
#define REG_BK3313_3B_L      0x331376
#define REG_BK3313_3B_H      0x331377
#define REG_BK3313_3C_L      0x331378
#define REG_BK3313_3C_H      0x331379
#define REG_BK3313_3D_L      0x33137A
#define REG_BK3313_3D_H      0x33137B
#define REG_BK3313_3E_L      0x33137C
#define REG_BK3313_3E_H      0x33137D
#define REG_BK3313_3F_L      0x33137E
#define REG_BK3313_3F_H      0x33137F
#define REG_BK3313_40_L      0x331380
#define REG_BK3313_40_H      0x331381
#define REG_BK3313_41_L      0x331382
#define REG_BK3313_41_H      0x331383
#define REG_BK3313_42_L      0x331384
#define REG_BK3313_42_H      0x331385
#define REG_BK3313_43_L      0x331386
#define REG_BK3313_43_H      0x331387
#define REG_BK3313_44_L      0x331388
#define REG_BK3313_44_H      0x331389
#define REG_BK3313_45_L      0x33138A
#define REG_BK3313_45_H      0x33138B
#define REG_BK3313_46_L      0x33138C
#define REG_BK3313_46_H      0x33138D
#define REG_BK3313_47_L      0x33138E
#define REG_BK3313_47_H      0x33138F
#define REG_BK3313_48_L      0x331390
#define REG_BK3313_48_H      0x331391
#define REG_BK3313_49_L      0x331392
#define REG_BK3313_49_H      0x331393
#define REG_BK3313_4A_L      0x331394
#define REG_BK3313_4A_H      0x331395
#define REG_BK3313_4B_L      0x331396
#define REG_BK3313_4B_H      0x331397
#define REG_BK3313_4C_L      0x331398
#define REG_BK3313_4C_H      0x331399
#define REG_BK3313_4D_L      0x33139A
#define REG_BK3313_4D_H      0x33139B
#define REG_BK3313_4E_L      0x33139C
#define REG_BK3313_4E_H      0x33139D
#define REG_BK3313_4F_L      0x33139E
#define REG_BK3313_4F_H      0x33139F
#define REG_BK3313_50_L      0x3313A0
#define REG_BK3313_50_H      0x3313A1
#define REG_BK3313_51_L      0x3313A2
#define REG_BK3313_51_H      0x3313A3
#define REG_BK3313_52_L      0x3313A4
#define REG_BK3313_52_H      0x3313A5
#define REG_BK3313_53_L      0x3313A6
#define REG_BK3313_53_H      0x3313A7
#define REG_BK3313_54_L      0x3313A8
#define REG_BK3313_54_H      0x3313A9
#define REG_BK3313_55_L      0x3313AA
#define REG_BK3313_55_H      0x3313AB
#define REG_BK3313_56_L      0x3313AC
#define REG_BK3313_56_H      0x3313AD
#define REG_BK3313_57_L      0x3313AE
#define REG_BK3313_57_H      0x3313AF
#define REG_BK3313_58_L      0x3313B0
#define REG_BK3313_58_H      0x3313B1
#define REG_BK3313_59_L      0x3313B2
#define REG_BK3313_59_H      0x3313B3
#define REG_BK3313_5A_L      0x3313B4
#define REG_BK3313_5A_H      0x3313B5
#define REG_BK3313_5B_L      0x3313B6
#define REG_BK3313_5B_H      0x3313B7
#define REG_BK3313_5C_L      0x3313B8
#define REG_BK3313_5C_H      0x3313B9
#define REG_BK3313_5D_L      0x3313BA
#define REG_BK3313_5D_H      0x3313BB
#define REG_BK3313_5E_L      0x3313BC
#define REG_BK3313_5E_H      0x3313BD
#define REG_BK3313_5F_L      0x3313BE
#define REG_BK3313_5F_H      0x3313BF
#define REG_BK3313_60_L      0x3313C0
#define REG_BK3313_60_H      0x3313C1
#define REG_BK3313_61_L      0x3313C2
#define REG_BK3313_61_H      0x3313C3
#define REG_BK3313_62_L      0x3313C4
#define REG_BK3313_62_H      0x3313C5
#define REG_BK3313_63_L      0x3313C6
#define REG_BK3313_63_H      0x3313C7
#define REG_BK3313_64_L      0x3313C8
#define REG_BK3313_64_H      0x3313C9
#define REG_BK3313_65_L      0x3313CA
#define REG_BK3313_65_H      0x3313CB
#define REG_BK3313_66_L      0x3313CC
#define REG_BK3313_66_H      0x3313CD
#define REG_BK3313_67_L      0x3313CE
#define REG_BK3313_67_H      0x3313CF
#define REG_BK3313_68_L      0x3313D0
#define REG_BK3313_68_H      0x3313D1
#define REG_BK3313_69_L      0x3313D2
#define REG_BK3313_69_H      0x3313D3
#define REG_BK3313_6A_L      0x3313D4
#define REG_BK3313_6A_H      0x3313D5
#define REG_BK3313_6B_L      0x3313D6
#define REG_BK3313_6B_H      0x3313D7
#define REG_BK3313_6C_L      0x3313D8
#define REG_BK3313_6C_H      0x3313D9
#define REG_BK3313_6D_L      0x3313DA
#define REG_BK3313_6D_H      0x3313DB
#define REG_BK3313_6E_L      0x3313DC
#define REG_BK3313_6E_H      0x3313DD
#define REG_BK3313_6F_L      0x3313DE
#define REG_BK3313_6F_H      0x3313DF
#define REG_BK3313_70_L      0x3313E0
#define REG_BK3313_70_H      0x3313E1
#define REG_BK3313_71_L      0x3313E2
#define REG_BK3313_71_H      0x3313E3
#define REG_BK3313_72_L      0x3313E4
#define REG_BK3313_72_H      0x3313E5
#define REG_BK3313_73_L      0x3313E6
#define REG_BK3313_73_H      0x3313E7
#define REG_BK3313_74_L      0x3313E8
#define REG_BK3313_74_H      0x3313E9
#define REG_BK3313_75_L      0x3313EA
#define REG_BK3313_75_H      0x3313EB
#define REG_BK3313_76_L      0x3313EC
#define REG_BK3313_76_H      0x3313ED
#define REG_BK3313_77_L      0x3313EE
#define REG_BK3313_77_H      0x3313EF
#define REG_BK3313_78_L      0x3313F0
#define REG_BK3313_78_H      0x3313F1
#define REG_BK3313_79_L      0x3313F2
#define REG_BK3313_79_H      0x3313F3
#define REG_BK3313_7A_L      0x3313F4
#define REG_BK3313_7A_H      0x3313F5
#define REG_BK3313_7B_L      0x3313F6
#define REG_BK3313_7B_H      0x3313F7
#define REG_BK3313_7C_L      0x3313F8
#define REG_BK3313_7C_H      0x3313F9
#define REG_BK3313_7D_L      0x3313FA
#define REG_BK3313_7D_H      0x3313FB
#define REG_BK3313_7E_L      0x3313FC
#define REG_BK3313_7E_H      0x3313FD
#define REG_BK3313_7F_L      0x3313FE
#define REG_BK3313_7F_H      0x3313FF
//----------------------------------------------
#define REG_BK3316_00_L      0x331600
#define REG_BK3316_00_H      0x331601
#define REG_BK3316_01_L      0x331602
#define REG_BK3316_01_H      0x331603
#define REG_BK3316_02_L      0x331604
#define REG_BK3316_02_H      0x331605
#define REG_BK3316_03_L      0x331606
#define REG_BK3316_03_H      0x331607
#define REG_BK3316_04_L      0x331608
#define REG_BK3316_04_H      0x331609
#define REG_BK3316_05_L      0x33160A
#define REG_BK3316_05_H      0x33160B
#define REG_BK3316_06_L      0x33160C
#define REG_BK3316_06_H      0x33160D
#define REG_BK3316_07_L      0x33160E
#define REG_BK3316_07_H      0x33160F
#define REG_BK3316_08_L      0x331610
#define REG_BK3316_08_H      0x331611
#define REG_BK3316_09_L      0x331612
#define REG_BK3316_09_H      0x331613
#define REG_BK3316_0A_L      0x331614
#define REG_BK3316_0A_H      0x331615
#define REG_BK3316_0B_L      0x331616
#define REG_BK3316_0B_H      0x331617
#define REG_BK3316_0C_L      0x331618
#define REG_BK3316_0C_H      0x331619
#define REG_BK3316_0D_L      0x33161A
#define REG_BK3316_0D_H      0x33161B
#define REG_BK3316_0E_L      0x33161C
#define REG_BK3316_0E_H      0x33161D
#define REG_BK3316_0F_L      0x33161E
#define REG_BK3316_0F_H      0x33161F
#define REG_BK3316_10_L      0x331620
#define REG_BK3316_10_H      0x331621
#define REG_BK3316_11_L      0x331622
#define REG_BK3316_11_H      0x331623
#define REG_BK3316_12_L      0x331624
#define REG_BK3316_12_H      0x331625
#define REG_BK3316_13_L      0x331626
#define REG_BK3316_13_H      0x331627
#define REG_BK3316_14_L      0x331628
#define REG_BK3316_14_H      0x331629
#define REG_BK3316_15_L      0x33162A
#define REG_BK3316_15_H      0x33162B
#define REG_BK3316_16_L      0x33162C
#define REG_BK3316_16_H      0x33162D
#define REG_BK3316_17_L      0x33162E
#define REG_BK3316_17_H      0x33162F
#define REG_BK3316_18_L      0x331630
#define REG_BK3316_18_H      0x331631
#define REG_BK3316_19_L      0x331632
#define REG_BK3316_19_H      0x331633
#define REG_BK3316_1A_L      0x331634
#define REG_BK3316_1A_H      0x331635
#define REG_BK3316_1B_L      0x331636
#define REG_BK3316_1B_H      0x331637
#define REG_BK3316_1C_L      0x331638
#define REG_BK3316_1C_H      0x331639
#define REG_BK3316_1D_L      0x33163A
#define REG_BK3316_1D_H      0x33163B
#define REG_BK3316_1E_L      0x33163C
#define REG_BK3316_1E_H      0x33163D
#define REG_BK3316_1F_L      0x33163E
#define REG_BK3316_1F_H      0x33163F
#define REG_BK3316_20_L      0x331640
#define REG_BK3316_20_H      0x331641
#define REG_BK3316_21_L      0x331642
#define REG_BK3316_21_H      0x331643
#define REG_BK3316_22_L      0x331644
#define REG_BK3316_22_H      0x331645
#define REG_BK3316_23_L      0x331646
#define REG_BK3316_23_H      0x331647
#define REG_BK3316_24_L      0x331648
#define REG_BK3316_24_H      0x331649
#define REG_BK3316_25_L      0x33164A
#define REG_BK3316_25_H      0x33164B
#define REG_BK3316_26_L      0x33164C
#define REG_BK3316_26_H      0x33164D
#define REG_BK3316_27_L      0x33164E
#define REG_BK3316_27_H      0x33164F
#define REG_BK3316_28_L      0x331650
#define REG_BK3316_28_H      0x331651
#define REG_BK3316_29_L      0x331652
#define REG_BK3316_29_H      0x331653
#define REG_BK3316_2A_L      0x331654
#define REG_BK3316_2A_H      0x331655
#define REG_BK3316_2B_L      0x331656
#define REG_BK3316_2B_H      0x331657
#define REG_BK3316_2C_L      0x331658
#define REG_BK3316_2C_H      0x331659
#define REG_BK3316_2D_L      0x33165A
#define REG_BK3316_2D_H      0x33165B
#define REG_BK3316_2E_L      0x33165C
#define REG_BK3316_2E_H      0x33165D
#define REG_BK3316_2F_L      0x33165E
#define REG_BK3316_2F_H      0x33165F
#define REG_BK3316_30_L      0x331660
#define REG_BK3316_30_H      0x331661
#define REG_BK3316_31_L      0x331662
#define REG_BK3316_31_H      0x331663
#define REG_BK3316_32_L      0x331664
#define REG_BK3316_32_H      0x331665
#define REG_BK3316_33_L      0x331666
#define REG_BK3316_33_H      0x331667
#define REG_BK3316_34_L      0x331668
#define REG_BK3316_34_H      0x331669
#define REG_BK3316_35_L      0x33166A
#define REG_BK3316_35_H      0x33166B
#define REG_BK3316_36_L      0x33166C
#define REG_BK3316_36_H      0x33166D
#define REG_BK3316_37_L      0x33166E
#define REG_BK3316_37_H      0x33166F
#define REG_BK3316_38_L      0x331670
#define REG_BK3316_38_H      0x331671
#define REG_BK3316_39_L      0x331672
#define REG_BK3316_39_H      0x331673
#define REG_BK3316_3A_L      0x331674
#define REG_BK3316_3A_H      0x331675
#define REG_BK3316_3B_L      0x331676
#define REG_BK3316_3B_H      0x331677
#define REG_BK3316_3C_L      0x331678
#define REG_BK3316_3C_H      0x331679
#define REG_BK3316_3D_L      0x33167A
#define REG_BK3316_3D_H      0x33167B
#define REG_BK3316_3E_L      0x33167C
#define REG_BK3316_3E_H      0x33167D
#define REG_BK3316_3F_L      0x33167E
#define REG_BK3316_3F_H      0x33167F
#define REG_BK3316_40_L      0x331680
#define REG_BK3316_40_H      0x331681
#define REG_BK3316_41_L      0x331682
#define REG_BK3316_41_H      0x331683
#define REG_BK3316_42_L      0x331684
#define REG_BK3316_42_H      0x331685
#define REG_BK3316_43_L      0x331686
#define REG_BK3316_43_H      0x331687
#define REG_BK3316_44_L      0x331688
#define REG_BK3316_44_H      0x331689
#define REG_BK3316_45_L      0x33168A
#define REG_BK3316_45_H      0x33168B
#define REG_BK3316_46_L      0x33168C
#define REG_BK3316_46_H      0x33168D
#define REG_BK3316_47_L      0x33168E
#define REG_BK3316_47_H      0x33168F
#define REG_BK3316_48_L      0x331690
#define REG_BK3316_48_H      0x331691
#define REG_BK3316_49_L      0x331692
#define REG_BK3316_49_H      0x331693
#define REG_BK3316_4A_L      0x331694
#define REG_BK3316_4A_H      0x331695
#define REG_BK3316_4B_L      0x331696
#define REG_BK3316_4B_H      0x331697
#define REG_BK3316_4C_L      0x331698
#define REG_BK3316_4C_H      0x331699
#define REG_BK3316_4D_L      0x33169A
#define REG_BK3316_4D_H      0x33169B
#define REG_BK3316_4E_L      0x33169C
#define REG_BK3316_4E_H      0x33169D
#define REG_BK3316_4F_L      0x33169E
#define REG_BK3316_4F_H      0x33169F
#define REG_BK3316_50_L      0x3316A0
#define REG_BK3316_50_H      0x3316A1
#define REG_BK3316_51_L      0x3316A2
#define REG_BK3316_51_H      0x3316A3
#define REG_BK3316_52_L      0x3316A4
#define REG_BK3316_52_H      0x3316A5
#define REG_BK3316_53_L      0x3316A6
#define REG_BK3316_53_H      0x3316A7
#define REG_BK3316_54_L      0x3316A8
#define REG_BK3316_54_H      0x3316A9
#define REG_BK3316_55_L      0x3316AA
#define REG_BK3316_55_H      0x3316AB
#define REG_BK3316_56_L      0x3316AC
#define REG_BK3316_56_H      0x3316AD
#define REG_BK3316_57_L      0x3316AE
#define REG_BK3316_57_H      0x3316AF
#define REG_BK3316_58_L      0x3316B0
#define REG_BK3316_58_H      0x3316B1
#define REG_BK3316_59_L      0x3316B2
#define REG_BK3316_59_H      0x3316B3
#define REG_BK3316_5A_L      0x3316B4
#define REG_BK3316_5A_H      0x3316B5
#define REG_BK3316_5B_L      0x3316B6
#define REG_BK3316_5B_H      0x3316B7
#define REG_BK3316_5C_L      0x3316B8
#define REG_BK3316_5C_H      0x3316B9
#define REG_BK3316_5D_L      0x3316BA
#define REG_BK3316_5D_H      0x3316BB
#define REG_BK3316_5E_L      0x3316BC
#define REG_BK3316_5E_H      0x3316BD
#define REG_BK3316_5F_L      0x3316BE
#define REG_BK3316_5F_H      0x3316BF
#define REG_BK3316_60_L      0x3316C0
#define REG_BK3316_60_H      0x3316C1
#define REG_BK3316_61_L      0x3316C2
#define REG_BK3316_61_H      0x3316C3
#define REG_BK3316_62_L      0x3316C4
#define REG_BK3316_62_H      0x3316C5
#define REG_BK3316_63_L      0x3316C6
#define REG_BK3316_63_H      0x3316C7
#define REG_BK3316_64_L      0x3316C8
#define REG_BK3316_64_H      0x3316C9
#define REG_BK3316_65_L      0x3316CA
#define REG_BK3316_65_H      0x3316CB
#define REG_BK3316_66_L      0x3316CC
#define REG_BK3316_66_H      0x3316CD
#define REG_BK3316_67_L      0x3316CE
#define REG_BK3316_67_H      0x3316CF
#define REG_BK3316_68_L      0x3316D0
#define REG_BK3316_68_H      0x3316D1
#define REG_BK3316_69_L      0x3316D2
#define REG_BK3316_69_H      0x3316D3
#define REG_BK3316_6A_L      0x3316D4
#define REG_BK3316_6A_H      0x3316D5
#define REG_BK3316_6B_L      0x3316D6
#define REG_BK3316_6B_H      0x3316D7
#define REG_BK3316_6C_L      0x3316D8
#define REG_BK3316_6C_H      0x3316D9
#define REG_BK3316_6D_L      0x3316DA
#define REG_BK3316_6D_H      0x3316DB
#define REG_BK3316_6E_L      0x3316DC
#define REG_BK3316_6E_H      0x3316DD
#define REG_BK3316_6F_L      0x3316DE
#define REG_BK3316_6F_H      0x3316DF
#define REG_BK3316_70_L      0x3316E0
#define REG_BK3316_70_H      0x3316E1
#define REG_BK3316_71_L      0x3316E2
#define REG_BK3316_71_H      0x3316E3
#define REG_BK3316_72_L      0x3316E4
#define REG_BK3316_72_H      0x3316E5
#define REG_BK3316_73_L      0x3316E6
#define REG_BK3316_73_H      0x3316E7
#define REG_BK3316_74_L      0x3316E8
#define REG_BK3316_74_H      0x3316E9
#define REG_BK3316_75_L      0x3316EA
#define REG_BK3316_75_H      0x3316EB
#define REG_BK3316_76_L      0x3316EC
#define REG_BK3316_76_H      0x3316ED
#define REG_BK3316_77_L      0x3316EE
#define REG_BK3316_77_H      0x3316EF
#define REG_BK3316_78_L      0x3316F0
#define REG_BK3316_78_H      0x3316F1
#define REG_BK3316_79_L      0x3316F2
#define REG_BK3316_79_H      0x3316F3
#define REG_BK3316_7A_L      0x3316F4
#define REG_BK3316_7A_H      0x3316F5
#define REG_BK3316_7B_L      0x3316F6
#define REG_BK3316_7B_H      0x3316F7
#define REG_BK3316_7C_L      0x3316F8
#define REG_BK3316_7C_H      0x3316F9
#define REG_BK3316_7D_L      0x3316FA
#define REG_BK3316_7D_H      0x3316FB
#define REG_BK3316_7E_L      0x3316FC
#define REG_BK3316_7E_H      0x3316FD
#define REG_BK3316_7F_L      0x3316FE
#define REG_BK3316_7F_H      0x3316FF
//----------------------------------------------
#define REG_BK3318_00_L      0x331800
#define REG_BK3318_00_H      0x331801
#define REG_BK3318_01_L      0x331802
#define REG_BK3318_01_H      0x331803
#define REG_BK3318_02_L      0x331804
#define REG_BK3318_02_H      0x331805
#define REG_BK3318_03_L      0x331806
#define REG_BK3318_03_H      0x331807
#define REG_BK3318_04_L      0x331808
#define REG_BK3318_04_H      0x331809
#define REG_BK3318_05_L      0x33180A
#define REG_BK3318_05_H      0x33180B
#define REG_BK3318_06_L      0x33180C
#define REG_BK3318_06_H      0x33180D
#define REG_BK3318_07_L      0x33180E
#define REG_BK3318_07_H      0x33180F
#define REG_BK3318_08_L      0x331810
#define REG_BK3318_08_H      0x331811
#define REG_BK3318_09_L      0x331812
#define REG_BK3318_09_H      0x331813
#define REG_BK3318_0A_L      0x331814
#define REG_BK3318_0A_H      0x331815
#define REG_BK3318_0B_L      0x331816
#define REG_BK3318_0B_H      0x331817
#define REG_BK3318_0C_L      0x331818
#define REG_BK3318_0C_H      0x331819
#define REG_BK3318_0D_L      0x33181A
#define REG_BK3318_0D_H      0x33181B
#define REG_BK3318_0E_L      0x33181C
#define REG_BK3318_0E_H      0x33181D
#define REG_BK3318_0F_L      0x33181E
#define REG_BK3318_0F_H      0x33181F
#define REG_BK3318_10_L      0x331820
#define REG_BK3318_10_H      0x331821
#define REG_BK3318_11_L      0x331822
#define REG_BK3318_11_H      0x331823
#define REG_BK3318_12_L      0x331824
#define REG_BK3318_12_H      0x331825
#define REG_BK3318_13_L      0x331826
#define REG_BK3318_13_H      0x331827
#define REG_BK3318_14_L      0x331828
#define REG_BK3318_14_H      0x331829
#define REG_BK3318_15_L      0x33182A
#define REG_BK3318_15_H      0x33182B
#define REG_BK3318_16_L      0x33182C
#define REG_BK3318_16_H      0x33182D
#define REG_BK3318_17_L      0x33182E
#define REG_BK3318_17_H      0x33182F
#define REG_BK3318_18_L      0x331830
#define REG_BK3318_18_H      0x331831
#define REG_BK3318_19_L      0x331832
#define REG_BK3318_19_H      0x331833
#define REG_BK3318_1A_L      0x331834
#define REG_BK3318_1A_H      0x331835
#define REG_BK3318_1B_L      0x331836
#define REG_BK3318_1B_H      0x331837
#define REG_BK3318_1C_L      0x331838
#define REG_BK3318_1C_H      0x331839
#define REG_BK3318_1D_L      0x33183A
#define REG_BK3318_1D_H      0x33183B
#define REG_BK3318_1E_L      0x33183C
#define REG_BK3318_1E_H      0x33183D
#define REG_BK3318_1F_L      0x33183E
#define REG_BK3318_1F_H      0x33183F
#define REG_BK3318_20_L      0x331840
#define REG_BK3318_20_H      0x331841
#define REG_BK3318_21_L      0x331842
#define REG_BK3318_21_H      0x331843
#define REG_BK3318_22_L      0x331844
#define REG_BK3318_22_H      0x331845
#define REG_BK3318_23_L      0x331846
#define REG_BK3318_23_H      0x331847
#define REG_BK3318_24_L      0x331848
#define REG_BK3318_24_H      0x331849
#define REG_BK3318_25_L      0x33184A
#define REG_BK3318_25_H      0x33184B
#define REG_BK3318_26_L      0x33184C
#define REG_BK3318_26_H      0x33184D
#define REG_BK3318_27_L      0x33184E
#define REG_BK3318_27_H      0x33184F
#define REG_BK3318_28_L      0x331850
#define REG_BK3318_28_H      0x331851
#define REG_BK3318_29_L      0x331852
#define REG_BK3318_29_H      0x331853
#define REG_BK3318_2A_L      0x331854
#define REG_BK3318_2A_H      0x331855
#define REG_BK3318_2B_L      0x331856
#define REG_BK3318_2B_H      0x331857
#define REG_BK3318_2C_L      0x331858
#define REG_BK3318_2C_H      0x331859
#define REG_BK3318_2D_L      0x33185A
#define REG_BK3318_2D_H      0x33185B
#define REG_BK3318_2E_L      0x33185C
#define REG_BK3318_2E_H      0x33185D
#define REG_BK3318_2F_L      0x33185E
#define REG_BK3318_2F_H      0x33185F
#define REG_BK3318_30_L      0x331860
#define REG_BK3318_30_H      0x331861
#define REG_BK3318_31_L      0x331862
#define REG_BK3318_31_H      0x331863
#define REG_BK3318_32_L      0x331864
#define REG_BK3318_32_H      0x331865
#define REG_BK3318_33_L      0x331866
#define REG_BK3318_33_H      0x331867
#define REG_BK3318_34_L      0x331868
#define REG_BK3318_34_H      0x331869
#define REG_BK3318_35_L      0x33186A
#define REG_BK3318_35_H      0x33186B
#define REG_BK3318_36_L      0x33186C
#define REG_BK3318_36_H      0x33186D
#define REG_BK3318_37_L      0x33186E
#define REG_BK3318_37_H      0x33186F
#define REG_BK3318_38_L      0x331870
#define REG_BK3318_38_H      0x331871
#define REG_BK3318_39_L      0x331872
#define REG_BK3318_39_H      0x331873
#define REG_BK3318_3A_L      0x331874
#define REG_BK3318_3A_H      0x331875
#define REG_BK3318_3B_L      0x331876
#define REG_BK3318_3B_H      0x331877
#define REG_BK3318_3C_L      0x331878
#define REG_BK3318_3C_H      0x331879
#define REG_BK3318_3D_L      0x33187A
#define REG_BK3318_3D_H      0x33187B
#define REG_BK3318_3E_L      0x33187C
#define REG_BK3318_3E_H      0x33187D
#define REG_BK3318_3F_L      0x33187E
#define REG_BK3318_3F_H      0x33187F
#define REG_BK3318_40_L      0x331880
#define REG_BK3318_40_H      0x331881
#define REG_BK3318_41_L      0x331882
#define REG_BK3318_41_H      0x331883
#define REG_BK3318_42_L      0x331884
#define REG_BK3318_42_H      0x331885
#define REG_BK3318_43_L      0x331886
#define REG_BK3318_43_H      0x331887
#define REG_BK3318_44_L      0x331888
#define REG_BK3318_44_H      0x331889
#define REG_BK3318_45_L      0x33188A
#define REG_BK3318_45_H      0x33188B
#define REG_BK3318_46_L      0x33188C
#define REG_BK3318_46_H      0x33188D
#define REG_BK3318_47_L      0x33188E
#define REG_BK3318_47_H      0x33188F
#define REG_BK3318_48_L      0x331890
#define REG_BK3318_48_H      0x331891
#define REG_BK3318_49_L      0x331892
#define REG_BK3318_49_H      0x331893
#define REG_BK3318_4A_L      0x331894
#define REG_BK3318_4A_H      0x331895
#define REG_BK3318_4B_L      0x331896
#define REG_BK3318_4B_H      0x331897
#define REG_BK3318_4C_L      0x331898
#define REG_BK3318_4C_H      0x331899
#define REG_BK3318_4D_L      0x33189A
#define REG_BK3318_4D_H      0x33189B
#define REG_BK3318_4E_L      0x33189C
#define REG_BK3318_4E_H      0x33189D
#define REG_BK3318_4F_L      0x33189E
#define REG_BK3318_4F_H      0x33189F
#define REG_BK3318_50_L      0x3318A0
#define REG_BK3318_50_H      0x3318A1
#define REG_BK3318_51_L      0x3318A2
#define REG_BK3318_51_H      0x3318A3
#define REG_BK3318_52_L      0x3318A4
#define REG_BK3318_52_H      0x3318A5
#define REG_BK3318_53_L      0x3318A6
#define REG_BK3318_53_H      0x3318A7
#define REG_BK3318_54_L      0x3318A8
#define REG_BK3318_54_H      0x3318A9
#define REG_BK3318_55_L      0x3318AA
#define REG_BK3318_55_H      0x3318AB
#define REG_BK3318_56_L      0x3318AC
#define REG_BK3318_56_H      0x3318AD
#define REG_BK3318_57_L      0x3318AE
#define REG_BK3318_57_H      0x3318AF
#define REG_BK3318_58_L      0x3318B0
#define REG_BK3318_58_H      0x3318B1
#define REG_BK3318_59_L      0x3318B2
#define REG_BK3318_59_H      0x3318B3
#define REG_BK3318_5A_L      0x3318B4
#define REG_BK3318_5A_H      0x3318B5
#define REG_BK3318_5B_L      0x3318B6
#define REG_BK3318_5B_H      0x3318B7
#define REG_BK3318_5C_L      0x3318B8
#define REG_BK3318_5C_H      0x3318B9
#define REG_BK3318_5D_L      0x3318BA
#define REG_BK3318_5D_H      0x3318BB
#define REG_BK3318_5E_L      0x3318BC
#define REG_BK3318_5E_H      0x3318BD
#define REG_BK3318_5F_L      0x3318BE
#define REG_BK3318_5F_H      0x3318BF
#define REG_BK3318_60_L      0x3318C0
#define REG_BK3318_60_H      0x3318C1
#define REG_BK3318_61_L      0x3318C2
#define REG_BK3318_61_H      0x3318C3
#define REG_BK3318_62_L      0x3318C4
#define REG_BK3318_62_H      0x3318C5
#define REG_BK3318_63_L      0x3318C6
#define REG_BK3318_63_H      0x3318C7
#define REG_BK3318_64_L      0x3318C8
#define REG_BK3318_64_H      0x3318C9
#define REG_BK3318_65_L      0x3318CA
#define REG_BK3318_65_H      0x3318CB
#define REG_BK3318_66_L      0x3318CC
#define REG_BK3318_66_H      0x3318CD
#define REG_BK3318_67_L      0x3318CE
#define REG_BK3318_67_H      0x3318CF
#define REG_BK3318_68_L      0x3318D0
#define REG_BK3318_68_H      0x3318D1
#define REG_BK3318_69_L      0x3318D2
#define REG_BK3318_69_H      0x3318D3
#define REG_BK3318_6A_L      0x3318D4
#define REG_BK3318_6A_H      0x3318D5
#define REG_BK3318_6B_L      0x3318D6
#define REG_BK3318_6B_H      0x3318D7
#define REG_BK3318_6C_L      0x3318D8
#define REG_BK3318_6C_H      0x3318D9
#define REG_BK3318_6D_L      0x3318DA
#define REG_BK3318_6D_H      0x3318DB
#define REG_BK3318_6E_L      0x3318DC
#define REG_BK3318_6E_H      0x3318DD
#define REG_BK3318_6F_L      0x3318DE
#define REG_BK3318_6F_H      0x3318DF
#define REG_BK3318_70_L      0x3318E0
#define REG_BK3318_70_H      0x3318E1
#define REG_BK3318_71_L      0x3318E2
#define REG_BK3318_71_H      0x3318E3
#define REG_BK3318_72_L      0x3318E4
#define REG_BK3318_72_H      0x3318E5
#define REG_BK3318_73_L      0x3318E6
#define REG_BK3318_73_H      0x3318E7
#define REG_BK3318_74_L      0x3318E8
#define REG_BK3318_74_H      0x3318E9
#define REG_BK3318_75_L      0x3318EA
#define REG_BK3318_75_H      0x3318EB
#define REG_BK3318_76_L      0x3318EC
#define REG_BK3318_76_H      0x3318ED
#define REG_BK3318_77_L      0x3318EE
#define REG_BK3318_77_H      0x3318EF
#define REG_BK3318_78_L      0x3318F0
#define REG_BK3318_78_H      0x3318F1
#define REG_BK3318_79_L      0x3318F2
#define REG_BK3318_79_H      0x3318F3
#define REG_BK3318_7A_L      0x3318F4
#define REG_BK3318_7A_H      0x3318F5
#define REG_BK3318_7B_L      0x3318F6
#define REG_BK3318_7B_H      0x3318F7
#define REG_BK3318_7C_L      0x3318F8
#define REG_BK3318_7C_H      0x3318F9
#define REG_BK3318_7D_L      0x3318FA
#define REG_BK3318_7D_H      0x3318FB
#define REG_BK3318_7E_L      0x3318FC
#define REG_BK3318_7E_H      0x3318FD
#define REG_BK3318_7F_L      0x3318FE
#define REG_BK3318_7F_H      0x3318FF
//----------------------------------------------
#define REG_BK332C_00_L      0x332C00
#define REG_BK332C_00_H      0x332C01
#define REG_BK332C_01_L      0x332C02
#define REG_BK332C_01_H      0x332C03
#define REG_BK332C_02_L      0x332C04
#define REG_BK332C_02_H      0x332C05
#define REG_BK332C_03_L      0x332C06
#define REG_BK332C_03_H      0x332C07
#define REG_BK332C_04_L      0x332C08
#define REG_BK332C_04_H      0x332C09
#define REG_BK332C_05_L      0x332C0A
#define REG_BK332C_05_H      0x332C0B
#define REG_BK332C_06_L      0x332C0C
#define REG_BK332C_06_H      0x332C0D
#define REG_BK332C_07_L      0x332C0E
#define REG_BK332C_07_H      0x332C0F
#define REG_BK332C_08_L      0x332C10
#define REG_BK332C_08_H      0x332C11
#define REG_BK332C_09_L      0x332C12
#define REG_BK332C_09_H      0x332C13
#define REG_BK332C_0A_L      0x332C14
#define REG_BK332C_0A_H      0x332C15
#define REG_BK332C_0B_L      0x332C16
#define REG_BK332C_0B_H      0x332C17
#define REG_BK332C_0C_L      0x332C18
#define REG_BK332C_0C_H      0x332C19
#define REG_BK332C_0D_L      0x332C1A
#define REG_BK332C_0D_H      0x332C1B
#define REG_BK332C_0E_L      0x332C1C
#define REG_BK332C_0E_H      0x332C1D
#define REG_BK332C_0F_L      0x332C1E
#define REG_BK332C_0F_H      0x332C1F
#define REG_BK332C_10_L      0x332C20
#define REG_BK332C_10_H      0x332C21
#define REG_BK332C_11_L      0x332C22
#define REG_BK332C_11_H      0x332C23
#define REG_BK332C_12_L      0x332C24
#define REG_BK332C_12_H      0x332C25
#define REG_BK332C_13_L      0x332C26
#define REG_BK332C_13_H      0x332C27
#define REG_BK332C_14_L      0x332C28
#define REG_BK332C_14_H      0x332C29
#define REG_BK332C_15_L      0x332C2A
#define REG_BK332C_15_H      0x332C2B
#define REG_BK332C_16_L      0x332C2C
#define REG_BK332C_16_H      0x332C2D
#define REG_BK332C_17_L      0x332C2E
#define REG_BK332C_17_H      0x332C2F
#define REG_BK332C_18_L      0x332C30
#define REG_BK332C_18_H      0x332C31
#define REG_BK332C_19_L      0x332C32
#define REG_BK332C_19_H      0x332C33
#define REG_BK332C_1A_L      0x332C34
#define REG_BK332C_1A_H      0x332C35
#define REG_BK332C_1B_L      0x332C36
#define REG_BK332C_1B_H      0x332C37
#define REG_BK332C_1C_L      0x332C38
#define REG_BK332C_1C_H      0x332C39
#define REG_BK332C_1D_L      0x332C3A
#define REG_BK332C_1D_H      0x332C3B
#define REG_BK332C_1E_L      0x332C3C
#define REG_BK332C_1E_H      0x332C3D
#define REG_BK332C_1F_L      0x332C3E
#define REG_BK332C_1F_H      0x332C3F
#define REG_BK332C_20_L      0x332C40
#define REG_BK332C_20_H      0x332C41
#define REG_BK332C_21_L      0x332C42
#define REG_BK332C_21_H      0x332C43
#define REG_BK332C_22_L      0x332C44
#define REG_BK332C_22_H      0x332C45
#define REG_BK332C_23_L      0x332C46
#define REG_BK332C_23_H      0x332C47
#define REG_BK332C_24_L      0x332C48
#define REG_BK332C_24_H      0x332C49
#define REG_BK332C_25_L      0x332C4A
#define REG_BK332C_25_H      0x332C4B
#define REG_BK332C_26_L      0x332C4C
#define REG_BK332C_26_H      0x332C4D
#define REG_BK332C_27_L      0x332C4E
#define REG_BK332C_27_H      0x332C4F
#define REG_BK332C_28_L      0x332C50
#define REG_BK332C_28_H      0x332C51
#define REG_BK332C_29_L      0x332C52
#define REG_BK332C_29_H      0x332C53
#define REG_BK332C_2A_L      0x332C54
#define REG_BK332C_2A_H      0x332C55
#define REG_BK332C_2B_L      0x332C56
#define REG_BK332C_2B_H      0x332C57
#define REG_BK332C_2C_L      0x332C58
#define REG_BK332C_2C_H      0x332C59
#define REG_BK332C_2D_L      0x332C5A
#define REG_BK332C_2D_H      0x332C5B
#define REG_BK332C_2E_L      0x332C5C
#define REG_BK332C_2E_H      0x332C5D
#define REG_BK332C_2F_L      0x332C5E
#define REG_BK332C_2F_H      0x332C5F
#define REG_BK332C_30_L      0x332C60
#define REG_BK332C_30_H      0x332C61
#define REG_BK332C_31_L      0x332C62
#define REG_BK332C_31_H      0x332C63
#define REG_BK332C_32_L      0x332C64
#define REG_BK332C_32_H      0x332C65
#define REG_BK332C_33_L      0x332C66
#define REG_BK332C_33_H      0x332C67
#define REG_BK332C_34_L      0x332C68
#define REG_BK332C_34_H      0x332C69
#define REG_BK332C_35_L      0x332C6A
#define REG_BK332C_35_H      0x332C6B
#define REG_BK332C_36_L      0x332C6C
#define REG_BK332C_36_H      0x332C6D
#define REG_BK332C_37_L      0x332C6E
#define REG_BK332C_37_H      0x332C6F
#define REG_BK332C_38_L      0x332C70
#define REG_BK332C_38_H      0x332C71
#define REG_BK332C_39_L      0x332C72
#define REG_BK332C_39_H      0x332C73
#define REG_BK332C_3A_L      0x332C74
#define REG_BK332C_3A_H      0x332C75
#define REG_BK332C_3B_L      0x332C76
#define REG_BK332C_3B_H      0x332C77
#define REG_BK332C_3C_L      0x332C78
#define REG_BK332C_3C_H      0x332C79
#define REG_BK332C_3D_L      0x332C7A
#define REG_BK332C_3D_H      0x332C7B
#define REG_BK332C_3E_L      0x332C7C
#define REG_BK332C_3E_H      0x332C7D
#define REG_BK332C_3F_L      0x332C7E
#define REG_BK332C_3F_H      0x332C7F
#define REG_BK332C_40_L      0x332C80
#define REG_BK332C_40_H      0x332C81
#define REG_BK332C_41_L      0x332C82
#define REG_BK332C_41_H      0x332C83
#define REG_BK332C_42_L      0x332C84
#define REG_BK332C_42_H      0x332C85
#define REG_BK332C_43_L      0x332C86
#define REG_BK332C_43_H      0x332C87
#define REG_BK332C_44_L      0x332C88
#define REG_BK332C_44_H      0x332C89
#define REG_BK332C_45_L      0x332C8A
#define REG_BK332C_45_H      0x332C8B
#define REG_BK332C_46_L      0x332C8C
#define REG_BK332C_46_H      0x332C8D
#define REG_BK332C_47_L      0x332C8E
#define REG_BK332C_47_H      0x332C8F
#define REG_BK332C_48_L      0x332C90
#define REG_BK332C_48_H      0x332C91
#define REG_BK332C_49_L      0x332C92
#define REG_BK332C_49_H      0x332C93
#define REG_BK332C_4A_L      0x332C94
#define REG_BK332C_4A_H      0x332C95
#define REG_BK332C_4B_L      0x332C96
#define REG_BK332C_4B_H      0x332C97
#define REG_BK332C_4C_L      0x332C98
#define REG_BK332C_4C_H      0x332C99
#define REG_BK332C_4D_L      0x332C9A
#define REG_BK332C_4D_H      0x332C9B
#define REG_BK332C_4E_L      0x332C9C
#define REG_BK332C_4E_H      0x332C9D
#define REG_BK332C_4F_L      0x332C9E
#define REG_BK332C_4F_H      0x332C9F
#define REG_BK332C_50_L      0x332CA0
#define REG_BK332C_50_H      0x332CA1
#define REG_BK332C_51_L      0x332CA2
#define REG_BK332C_51_H      0x332CA3
#define REG_BK332C_52_L      0x332CA4
#define REG_BK332C_52_H      0x332CA5
#define REG_BK332C_53_L      0x332CA6
#define REG_BK332C_53_H      0x332CA7
#define REG_BK332C_54_L      0x332CA8
#define REG_BK332C_54_H      0x332CA9
#define REG_BK332C_55_L      0x332CAA
#define REG_BK332C_55_H      0x332CAB
#define REG_BK332C_56_L      0x332CAC
#define REG_BK332C_56_H      0x332CAD
#define REG_BK332C_57_L      0x332CAE
#define REG_BK332C_57_H      0x332CAF
#define REG_BK332C_58_L      0x332CB0
#define REG_BK332C_58_H      0x332CB1
#define REG_BK332C_59_L      0x332CB2
#define REG_BK332C_59_H      0x332CB3
#define REG_BK332C_5A_L      0x332CB4
#define REG_BK332C_5A_H      0x332CB5
#define REG_BK332C_5B_L      0x332CB6
#define REG_BK332C_5B_H      0x332CB7
#define REG_BK332C_5C_L      0x332CB8
#define REG_BK332C_5C_H      0x332CB9
#define REG_BK332C_5D_L      0x332CBA
#define REG_BK332C_5D_H      0x332CBB
#define REG_BK332C_5E_L      0x332CBC
#define REG_BK332C_5E_H      0x332CBD
#define REG_BK332C_5F_L      0x332CBE
#define REG_BK332C_5F_H      0x332CBF
#define REG_BK332C_60_L      0x332CC0
#define REG_BK332C_60_H      0x332CC1
#define REG_BK332C_61_L      0x332CC2
#define REG_BK332C_61_H      0x332CC3
#define REG_BK332C_62_L      0x332CC4
#define REG_BK332C_62_H      0x332CC5
#define REG_BK332C_63_L      0x332CC6
#define REG_BK332C_63_H      0x332CC7
#define REG_BK332C_64_L      0x332CC8
#define REG_BK332C_64_H      0x332CC9
#define REG_BK332C_65_L      0x332CCA
#define REG_BK332C_65_H      0x332CCB
#define REG_BK332C_66_L      0x332CCC
#define REG_BK332C_66_H      0x332CCD
#define REG_BK332C_67_L      0x332CCE
#define REG_BK332C_67_H      0x332CCF
#define REG_BK332C_68_L      0x332CD0
#define REG_BK332C_68_H      0x332CD1
#define REG_BK332C_69_L      0x332CD2
#define REG_BK332C_69_H      0x332CD3
#define REG_BK332C_6A_L      0x332CD4
#define REG_BK332C_6A_H      0x332CD5
#define REG_BK332C_6B_L      0x332CD6
#define REG_BK332C_6B_H      0x332CD7
#define REG_BK332C_6C_L      0x332CD8
#define REG_BK332C_6C_H      0x332CD9
#define REG_BK332C_6D_L      0x332CDA
#define REG_BK332C_6D_H      0x332CDB
#define REG_BK332C_6E_L      0x332CDC
#define REG_BK332C_6E_H      0x332CDD
#define REG_BK332C_6F_L      0x332CDE
#define REG_BK332C_6F_H      0x332CDF
#define REG_BK332C_70_L      0x332CE0
#define REG_BK332C_70_H      0x332CE1
#define REG_BK332C_71_L      0x332CE2
#define REG_BK332C_71_H      0x332CE3
#define REG_BK332C_72_L      0x332CE4
#define REG_BK332C_72_H      0x332CE5
#define REG_BK332C_73_L      0x332CE6
#define REG_BK332C_73_H      0x332CE7
#define REG_BK332C_74_L      0x332CE8
#define REG_BK332C_74_H      0x332CE9
#define REG_BK332C_75_L      0x332CEA
#define REG_BK332C_75_H      0x332CEB
#define REG_BK332C_76_L      0x332CEC
#define REG_BK332C_76_H      0x332CED
#define REG_BK332C_77_L      0x332CEE
#define REG_BK332C_77_H      0x332CEF
#define REG_BK332C_78_L      0x332CF0
#define REG_BK332C_78_H      0x332CF1
#define REG_BK332C_79_L      0x332CF2
#define REG_BK332C_79_H      0x332CF3
#define REG_BK332C_7A_L      0x332CF4
#define REG_BK332C_7A_H      0x332CF5
#define REG_BK332C_7B_L      0x332CF6
#define REG_BK332C_7B_H      0x332CF7
#define REG_BK332C_7C_L      0x332CF8
#define REG_BK332C_7C_H      0x332CF9
#define REG_BK332C_7D_L      0x332CFA
#define REG_BK332C_7D_H      0x332CFB
#define REG_BK332C_7E_L      0x332CFC
#define REG_BK332C_7E_H      0x332CFD
#define REG_BK332C_7F_L      0x332CFE
#define REG_BK332C_7F_H      0x332CFF
//----------------------------------------------
#define REG_BK3350_00_L      0x335000
#define REG_BK3350_00_H      0x335001
#define REG_BK3350_01_L      0x335002
#define REG_BK3350_01_H      0x335003
#define REG_BK3350_02_L      0x335004
#define REG_BK3350_02_H      0x335005
#define REG_BK3350_03_L      0x335006
#define REG_BK3350_03_H      0x335007
#define REG_BK3350_04_L      0x335008
#define REG_BK3350_04_H      0x335009
#define REG_BK3350_05_L      0x33500A
#define REG_BK3350_05_H      0x33500B
#define REG_BK3350_06_L      0x33500C
#define REG_BK3350_06_H      0x33500D
#define REG_BK3350_07_L      0x33500E
#define REG_BK3350_07_H      0x33500F
#define REG_BK3350_08_L      0x335010
#define REG_BK3350_08_H      0x335011
#define REG_BK3350_09_L      0x335012
#define REG_BK3350_09_H      0x335013
#define REG_BK3350_0A_L      0x335014
#define REG_BK3350_0A_H      0x335015
#define REG_BK3350_0B_L      0x335016
#define REG_BK3350_0B_H      0x335017
#define REG_BK3350_0C_L      0x335018
#define REG_BK3350_0C_H      0x335019
#define REG_BK3350_0D_L      0x33501A
#define REG_BK3350_0D_H      0x33501B
#define REG_BK3350_0E_L      0x33501C
#define REG_BK3350_0E_H      0x33501D
#define REG_BK3350_0F_L      0x33501E
#define REG_BK3350_0F_H      0x33501F
#define REG_BK3350_10_L      0x335020
#define REG_BK3350_10_H      0x335021
#define REG_BK3350_11_L      0x335022
#define REG_BK3350_11_H      0x335023
#define REG_BK3350_12_L      0x335024
#define REG_BK3350_12_H      0x335025
#define REG_BK3350_13_L      0x335026
#define REG_BK3350_13_H      0x335027
#define REG_BK3350_14_L      0x335028
#define REG_BK3350_14_H      0x335029
#define REG_BK3350_15_L      0x33502A
#define REG_BK3350_15_H      0x33502B
#define REG_BK3350_16_L      0x33502C
#define REG_BK3350_16_H      0x33502D
#define REG_BK3350_17_L      0x33502E
#define REG_BK3350_17_H      0x33502F
#define REG_BK3350_18_L      0x335030
#define REG_BK3350_18_H      0x335031
#define REG_BK3350_19_L      0x335032
#define REG_BK3350_19_H      0x335033
#define REG_BK3350_1A_L      0x335034
#define REG_BK3350_1A_H      0x335035
#define REG_BK3350_1B_L      0x335036
#define REG_BK3350_1B_H      0x335037
#define REG_BK3350_1C_L      0x335038
#define REG_BK3350_1C_H      0x335039
#define REG_BK3350_1D_L      0x33503A
#define REG_BK3350_1D_H      0x33503B
#define REG_BK3350_1E_L      0x33503C
#define REG_BK3350_1E_H      0x33503D
#define REG_BK3350_1F_L      0x33503E
#define REG_BK3350_1F_H      0x33503F
#define REG_BK3350_20_L      0x335040
#define REG_BK3350_20_H      0x335041
#define REG_BK3350_21_L      0x335042
#define REG_BK3350_21_H      0x335043
#define REG_BK3350_22_L      0x335044
#define REG_BK3350_22_H      0x335045
#define REG_BK3350_23_L      0x335046
#define REG_BK3350_23_H      0x335047
#define REG_BK3350_24_L      0x335048
#define REG_BK3350_24_H      0x335049
#define REG_BK3350_25_L      0x33504A
#define REG_BK3350_25_H      0x33504B
#define REG_BK3350_26_L      0x33504C
#define REG_BK3350_26_H      0x33504D
#define REG_BK3350_27_L      0x33504E
#define REG_BK3350_27_H      0x33504F
#define REG_BK3350_28_L      0x335050
#define REG_BK3350_28_H      0x335051
#define REG_BK3350_29_L      0x335052
#define REG_BK3350_29_H      0x335053
#define REG_BK3350_2A_L      0x335054
#define REG_BK3350_2A_H      0x335055
#define REG_BK3350_2B_L      0x335056
#define REG_BK3350_2B_H      0x335057
#define REG_BK3350_2C_L      0x335058
#define REG_BK3350_2C_H      0x335059
#define REG_BK3350_2D_L      0x33505A
#define REG_BK3350_2D_H      0x33505B
#define REG_BK3350_2E_L      0x33505C
#define REG_BK3350_2E_H      0x33505D
#define REG_BK3350_2F_L      0x33505E
#define REG_BK3350_2F_H      0x33505F
#define REG_BK3350_30_L      0x335060
#define REG_BK3350_30_H      0x335061
#define REG_BK3350_31_L      0x335062
#define REG_BK3350_31_H      0x335063
#define REG_BK3350_32_L      0x335064
#define REG_BK3350_32_H      0x335065
#define REG_BK3350_33_L      0x335066
#define REG_BK3350_33_H      0x335067
#define REG_BK3350_34_L      0x335068
#define REG_BK3350_34_H      0x335069
#define REG_BK3350_35_L      0x33506A
#define REG_BK3350_35_H      0x33506B
#define REG_BK3350_36_L      0x33506C
#define REG_BK3350_36_H      0x33506D
#define REG_BK3350_37_L      0x33506E
#define REG_BK3350_37_H      0x33506F
#define REG_BK3350_38_L      0x335070
#define REG_BK3350_38_H      0x335071
#define REG_BK3350_39_L      0x335072
#define REG_BK3350_39_H      0x335073
#define REG_BK3350_3A_L      0x335074
#define REG_BK3350_3A_H      0x335075
#define REG_BK3350_3B_L      0x335076
#define REG_BK3350_3B_H      0x335077
#define REG_BK3350_3C_L      0x335078
#define REG_BK3350_3C_H      0x335079
#define REG_BK3350_3D_L      0x33507A
#define REG_BK3350_3D_H      0x33507B
#define REG_BK3350_3E_L      0x33507C
#define REG_BK3350_3E_H      0x33507D
#define REG_BK3350_3F_L      0x33507E
#define REG_BK3350_3F_H      0x33507F
#define REG_BK3350_40_L      0x335080
#define REG_BK3350_40_H      0x335081
#define REG_BK3350_41_L      0x335082
#define REG_BK3350_41_H      0x335083
#define REG_BK3350_42_L      0x335084
#define REG_BK3350_42_H      0x335085
#define REG_BK3350_43_L      0x335086
#define REG_BK3350_43_H      0x335087
#define REG_BK3350_44_L      0x335088
#define REG_BK3350_44_H      0x335089
#define REG_BK3350_45_L      0x33508A
#define REG_BK3350_45_H      0x33508B
#define REG_BK3350_46_L      0x33508C
#define REG_BK3350_46_H      0x33508D
#define REG_BK3350_47_L      0x33508E
#define REG_BK3350_47_H      0x33508F
#define REG_BK3350_48_L      0x335090
#define REG_BK3350_48_H      0x335091
#define REG_BK3350_49_L      0x335092
#define REG_BK3350_49_H      0x335093
#define REG_BK3350_4A_L      0x335094
#define REG_BK3350_4A_H      0x335095
#define REG_BK3350_4B_L      0x335096
#define REG_BK3350_4B_H      0x335097
#define REG_BK3350_4C_L      0x335098
#define REG_BK3350_4C_H      0x335099
#define REG_BK3350_4D_L      0x33509A
#define REG_BK3350_4D_H      0x33509B
#define REG_BK3350_4E_L      0x33509C
#define REG_BK3350_4E_H      0x33509D
#define REG_BK3350_4F_L      0x33509E
#define REG_BK3350_4F_H      0x33509F
#define REG_BK3350_50_L      0x3350A0
#define REG_BK3350_50_H      0x3350A1
#define REG_BK3350_51_L      0x3350A2
#define REG_BK3350_51_H      0x3350A3
#define REG_BK3350_52_L      0x3350A4
#define REG_BK3350_52_H      0x3350A5
#define REG_BK3350_53_L      0x3350A6
#define REG_BK3350_53_H      0x3350A7
#define REG_BK3350_54_L      0x3350A8
#define REG_BK3350_54_H      0x3350A9
#define REG_BK3350_55_L      0x3350AA
#define REG_BK3350_55_H      0x3350AB
#define REG_BK3350_56_L      0x3350AC
#define REG_BK3350_56_H      0x3350AD
#define REG_BK3350_57_L      0x3350AE
#define REG_BK3350_57_H      0x3350AF
#define REG_BK3350_58_L      0x3350B0
#define REG_BK3350_58_H      0x3350B1
#define REG_BK3350_59_L      0x3350B2
#define REG_BK3350_59_H      0x3350B3
#define REG_BK3350_5A_L      0x3350B4
#define REG_BK3350_5A_H      0x3350B5
#define REG_BK3350_5B_L      0x3350B6
#define REG_BK3350_5B_H      0x3350B7
#define REG_BK3350_5C_L      0x3350B8
#define REG_BK3350_5C_H      0x3350B9
#define REG_BK3350_5D_L      0x3350BA
#define REG_BK3350_5D_H      0x3350BB
#define REG_BK3350_5E_L      0x3350BC
#define REG_BK3350_5E_H      0x3350BD
#define REG_BK3350_5F_L      0x3350BE
#define REG_BK3350_5F_H      0x3350BF
#define REG_BK3350_60_L      0x3350C0
#define REG_BK3350_60_H      0x3350C1
#define REG_BK3350_61_L      0x3350C2
#define REG_BK3350_61_H      0x3350C3
#define REG_BK3350_62_L      0x3350C4
#define REG_BK3350_62_H      0x3350C5
#define REG_BK3350_63_L      0x3350C6
#define REG_BK3350_63_H      0x3350C7
#define REG_BK3350_64_L      0x3350C8
#define REG_BK3350_64_H      0x3350C9
#define REG_BK3350_65_L      0x3350CA
#define REG_BK3350_65_H      0x3350CB
#define REG_BK3350_66_L      0x3350CC
#define REG_BK3350_66_H      0x3350CD
#define REG_BK3350_67_L      0x3350CE
#define REG_BK3350_67_H      0x3350CF
#define REG_BK3350_68_L      0x3350D0
#define REG_BK3350_68_H      0x3350D1
#define REG_BK3350_69_L      0x3350D2
#define REG_BK3350_69_H      0x3350D3
#define REG_BK3350_6A_L      0x3350D4
#define REG_BK3350_6A_H      0x3350D5
#define REG_BK3350_6B_L      0x3350D6
#define REG_BK3350_6B_H      0x3350D7
#define REG_BK3350_6C_L      0x3350D8
#define REG_BK3350_6C_H      0x3350D9
#define REG_BK3350_6D_L      0x3350DA
#define REG_BK3350_6D_H      0x3350DB
#define REG_BK3350_6E_L      0x3350DC
#define REG_BK3350_6E_H      0x3350DD
#define REG_BK3350_6F_L      0x3350DE
#define REG_BK3350_6F_H      0x3350DF
#define REG_BK3350_70_L      0x3350E0
#define REG_BK3350_70_H      0x3350E1
#define REG_BK3350_71_L      0x3350E2
#define REG_BK3350_71_H      0x3350E3
#define REG_BK3350_72_L      0x3350E4
#define REG_BK3350_72_H      0x3350E5
#define REG_BK3350_73_L      0x3350E6
#define REG_BK3350_73_H      0x3350E7
#define REG_BK3350_74_L      0x3350E8
#define REG_BK3350_74_H      0x3350E9
#define REG_BK3350_75_L      0x3350EA
#define REG_BK3350_75_H      0x3350EB
#define REG_BK3350_76_L      0x3350EC
#define REG_BK3350_76_H      0x3350ED
#define REG_BK3350_77_L      0x3350EE
#define REG_BK3350_77_H      0x3350EF
#define REG_BK3350_78_L      0x3350F0
#define REG_BK3350_78_H      0x3350F1
#define REG_BK3350_79_L      0x3350F2
#define REG_BK3350_79_H      0x3350F3
#define REG_BK3350_7A_L      0x3350F4
#define REG_BK3350_7A_H      0x3350F5
#define REG_BK3350_7B_L      0x3350F6
#define REG_BK3350_7B_H      0x3350F7
#define REG_BK3350_7C_L      0x3350F8
#define REG_BK3350_7C_H      0x3350F9
#define REG_BK3350_7D_L      0x3350FA
#define REG_BK3350_7D_H      0x3350FB
#define REG_BK3350_7E_L      0x3350FC
#define REG_BK3350_7E_H      0x3350FD
#define REG_BK3350_7F_L      0x3350FE
#define REG_BK3350_7F_H      0x3350FF
//----------------------------------------------
#define REG_BK3352_00_L      0x335200
#define REG_BK3352_00_H      0x335201
#define REG_BK3352_01_L      0x335202
#define REG_BK3352_01_H      0x335203
#define REG_BK3352_02_L      0x335204
#define REG_BK3352_02_H      0x335205
#define REG_BK3352_03_L      0x335206
#define REG_BK3352_03_H      0x335207
#define REG_BK3352_04_L      0x335208
#define REG_BK3352_04_H      0x335209
#define REG_BK3352_05_L      0x33520A
#define REG_BK3352_05_H      0x33520B
#define REG_BK3352_06_L      0x33520C
#define REG_BK3352_06_H      0x33520D
#define REG_BK3352_07_L      0x33520E
#define REG_BK3352_07_H      0x33520F
#define REG_BK3352_08_L      0x335210
#define REG_BK3352_08_H      0x335211
#define REG_BK3352_09_L      0x335212
#define REG_BK3352_09_H      0x335213
#define REG_BK3352_0A_L      0x335214
#define REG_BK3352_0A_H      0x335215
#define REG_BK3352_0B_L      0x335216
#define REG_BK3352_0B_H      0x335217
#define REG_BK3352_0C_L      0x335218
#define REG_BK3352_0C_H      0x335219
#define REG_BK3352_0D_L      0x33521A
#define REG_BK3352_0D_H      0x33521B
#define REG_BK3352_0E_L      0x33521C
#define REG_BK3352_0E_H      0x33521D
#define REG_BK3352_0F_L      0x33521E
#define REG_BK3352_0F_H      0x33521F
#define REG_BK3352_10_L      0x335220
#define REG_BK3352_10_H      0x335221
#define REG_BK3352_11_L      0x335222
#define REG_BK3352_11_H      0x335223
#define REG_BK3352_12_L      0x335224
#define REG_BK3352_12_H      0x335225
#define REG_BK3352_13_L      0x335226
#define REG_BK3352_13_H      0x335227
#define REG_BK3352_14_L      0x335228
#define REG_BK3352_14_H      0x335229
#define REG_BK3352_15_L      0x33522A
#define REG_BK3352_15_H      0x33522B
#define REG_BK3352_16_L      0x33522C
#define REG_BK3352_16_H      0x33522D
#define REG_BK3352_17_L      0x33522E
#define REG_BK3352_17_H      0x33522F
#define REG_BK3352_18_L      0x335230
#define REG_BK3352_18_H      0x335231
#define REG_BK3352_19_L      0x335232
#define REG_BK3352_19_H      0x335233
#define REG_BK3352_1A_L      0x335234
#define REG_BK3352_1A_H      0x335235
#define REG_BK3352_1B_L      0x335236
#define REG_BK3352_1B_H      0x335237
#define REG_BK3352_1C_L      0x335238
#define REG_BK3352_1C_H      0x335239
#define REG_BK3352_1D_L      0x33523A
#define REG_BK3352_1D_H      0x33523B
#define REG_BK3352_1E_L      0x33523C
#define REG_BK3352_1E_H      0x33523D
#define REG_BK3352_1F_L      0x33523E
#define REG_BK3352_1F_H      0x33523F
#define REG_BK3352_20_L      0x335240
#define REG_BK3352_20_H      0x335241
#define REG_BK3352_21_L      0x335242
#define REG_BK3352_21_H      0x335243
#define REG_BK3352_22_L      0x335244
#define REG_BK3352_22_H      0x335245
#define REG_BK3352_23_L      0x335246
#define REG_BK3352_23_H      0x335247
#define REG_BK3352_24_L      0x335248
#define REG_BK3352_24_H      0x335249
#define REG_BK3352_25_L      0x33524A
#define REG_BK3352_25_H      0x33524B
#define REG_BK3352_26_L      0x33524C
#define REG_BK3352_26_H      0x33524D
#define REG_BK3352_27_L      0x33524E
#define REG_BK3352_27_H      0x33524F
#define REG_BK3352_28_L      0x335250
#define REG_BK3352_28_H      0x335251
#define REG_BK3352_29_L      0x335252
#define REG_BK3352_29_H      0x335253
#define REG_BK3352_2A_L      0x335254
#define REG_BK3352_2A_H      0x335255
#define REG_BK3352_2B_L      0x335256
#define REG_BK3352_2B_H      0x335257
#define REG_BK3352_2C_L      0x335258
#define REG_BK3352_2C_H      0x335259
#define REG_BK3352_2D_L      0x33525A
#define REG_BK3352_2D_H      0x33525B
#define REG_BK3352_2E_L      0x33525C
#define REG_BK3352_2E_H      0x33525D
#define REG_BK3352_2F_L      0x33525E
#define REG_BK3352_2F_H      0x33525F
#define REG_BK3352_30_L      0x335260
#define REG_BK3352_30_H      0x335261
#define REG_BK3352_31_L      0x335262
#define REG_BK3352_31_H      0x335263
#define REG_BK3352_32_L      0x335264
#define REG_BK3352_32_H      0x335265
#define REG_BK3352_33_L      0x335266
#define REG_BK3352_33_H      0x335267
#define REG_BK3352_34_L      0x335268
#define REG_BK3352_34_H      0x335269
#define REG_BK3352_35_L      0x33526A
#define REG_BK3352_35_H      0x33526B
#define REG_BK3352_36_L      0x33526C
#define REG_BK3352_36_H      0x33526D
#define REG_BK3352_37_L      0x33526E
#define REG_BK3352_37_H      0x33526F
#define REG_BK3352_38_L      0x335270
#define REG_BK3352_38_H      0x335271
#define REG_BK3352_39_L      0x335272
#define REG_BK3352_39_H      0x335273
#define REG_BK3352_3A_L      0x335274
#define REG_BK3352_3A_H      0x335275
#define REG_BK3352_3B_L      0x335276
#define REG_BK3352_3B_H      0x335277
#define REG_BK3352_3C_L      0x335278
#define REG_BK3352_3C_H      0x335279
#define REG_BK3352_3D_L      0x33527A
#define REG_BK3352_3D_H      0x33527B
#define REG_BK3352_3E_L      0x33527C
#define REG_BK3352_3E_H      0x33527D
#define REG_BK3352_3F_L      0x33527E
#define REG_BK3352_3F_H      0x33527F
#define REG_BK3352_40_L      0x335280
#define REG_BK3352_40_H      0x335281
#define REG_BK3352_41_L      0x335282
#define REG_BK3352_41_H      0x335283
#define REG_BK3352_42_L      0x335284
#define REG_BK3352_42_H      0x335285
#define REG_BK3352_43_L      0x335286
#define REG_BK3352_43_H      0x335287
#define REG_BK3352_44_L      0x335288
#define REG_BK3352_44_H      0x335289
#define REG_BK3352_45_L      0x33528A
#define REG_BK3352_45_H      0x33528B
#define REG_BK3352_46_L      0x33528C
#define REG_BK3352_46_H      0x33528D
#define REG_BK3352_47_L      0x33528E
#define REG_BK3352_47_H      0x33528F
#define REG_BK3352_48_L      0x335290
#define REG_BK3352_48_H      0x335291
#define REG_BK3352_49_L      0x335292
#define REG_BK3352_49_H      0x335293
#define REG_BK3352_4A_L      0x335294
#define REG_BK3352_4A_H      0x335295
#define REG_BK3352_4B_L      0x335296
#define REG_BK3352_4B_H      0x335297
#define REG_BK3352_4C_L      0x335298
#define REG_BK3352_4C_H      0x335299
#define REG_BK3352_4D_L      0x33529A
#define REG_BK3352_4D_H      0x33529B
#define REG_BK3352_4E_L      0x33529C
#define REG_BK3352_4E_H      0x33529D
#define REG_BK3352_4F_L      0x33529E
#define REG_BK3352_4F_H      0x33529F
#define REG_BK3352_50_L      0x3352A0
#define REG_BK3352_50_H      0x3352A1
#define REG_BK3352_51_L      0x3352A2
#define REG_BK3352_51_H      0x3352A3
#define REG_BK3352_52_L      0x3352A4
#define REG_BK3352_52_H      0x3352A5
#define REG_BK3352_53_L      0x3352A6
#define REG_BK3352_53_H      0x3352A7
#define REG_BK3352_54_L      0x3352A8
#define REG_BK3352_54_H      0x3352A9
#define REG_BK3352_55_L      0x3352AA
#define REG_BK3352_55_H      0x3352AB
#define REG_BK3352_56_L      0x3352AC
#define REG_BK3352_56_H      0x3352AD
#define REG_BK3352_57_L      0x3352AE
#define REG_BK3352_57_H      0x3352AF
#define REG_BK3352_58_L      0x3352B0
#define REG_BK3352_58_H      0x3352B1
#define REG_BK3352_59_L      0x3352B2
#define REG_BK3352_59_H      0x3352B3
#define REG_BK3352_5A_L      0x3352B4
#define REG_BK3352_5A_H      0x3352B5
#define REG_BK3352_5B_L      0x3352B6
#define REG_BK3352_5B_H      0x3352B7
#define REG_BK3352_5C_L      0x3352B8
#define REG_BK3352_5C_H      0x3352B9
#define REG_BK3352_5D_L      0x3352BA
#define REG_BK3352_5D_H      0x3352BB
#define REG_BK3352_5E_L      0x3352BC
#define REG_BK3352_5E_H      0x3352BD
#define REG_BK3352_5F_L      0x3352BE
#define REG_BK3352_5F_H      0x3352BF
#define REG_BK3352_60_L      0x3352C0
#define REG_BK3352_60_H      0x3352C1
#define REG_BK3352_61_L      0x3352C2
#define REG_BK3352_61_H      0x3352C3
#define REG_BK3352_62_L      0x3352C4
#define REG_BK3352_62_H      0x3352C5
#define REG_BK3352_63_L      0x3352C6
#define REG_BK3352_63_H      0x3352C7
#define REG_BK3352_64_L      0x3352C8
#define REG_BK3352_64_H      0x3352C9
#define REG_BK3352_65_L      0x3352CA
#define REG_BK3352_65_H      0x3352CB
#define REG_BK3352_66_L      0x3352CC
#define REG_BK3352_66_H      0x3352CD
#define REG_BK3352_67_L      0x3352CE
#define REG_BK3352_67_H      0x3352CF
#define REG_BK3352_68_L      0x3352D0
#define REG_BK3352_68_H      0x3352D1
#define REG_BK3352_69_L      0x3352D2
#define REG_BK3352_69_H      0x3352D3
#define REG_BK3352_6A_L      0x3352D4
#define REG_BK3352_6A_H      0x3352D5
#define REG_BK3352_6B_L      0x3352D6
#define REG_BK3352_6B_H      0x3352D7
#define REG_BK3352_6C_L      0x3352D8
#define REG_BK3352_6C_H      0x3352D9
#define REG_BK3352_6D_L      0x3352DA
#define REG_BK3352_6D_H      0x3352DB
#define REG_BK3352_6E_L      0x3352DC
#define REG_BK3352_6E_H      0x3352DD
#define REG_BK3352_6F_L      0x3352DE
#define REG_BK3352_6F_H      0x3352DF
#define REG_BK3352_70_L      0x3352E0
#define REG_BK3352_70_H      0x3352E1
#define REG_BK3352_71_L      0x3352E2
#define REG_BK3352_71_H      0x3352E3
#define REG_BK3352_72_L      0x3352E4
#define REG_BK3352_72_H      0x3352E5
#define REG_BK3352_73_L      0x3352E6
#define REG_BK3352_73_H      0x3352E7
#define REG_BK3352_74_L      0x3352E8
#define REG_BK3352_74_H      0x3352E9
#define REG_BK3352_75_L      0x3352EA
#define REG_BK3352_75_H      0x3352EB
#define REG_BK3352_76_L      0x3352EC
#define REG_BK3352_76_H      0x3352ED
#define REG_BK3352_77_L      0x3352EE
#define REG_BK3352_77_H      0x3352EF
#define REG_BK3352_78_L      0x3352F0
#define REG_BK3352_78_H      0x3352F1
#define REG_BK3352_79_L      0x3352F2
#define REG_BK3352_79_H      0x3352F3
#define REG_BK3352_7A_L      0x3352F4
#define REG_BK3352_7A_H      0x3352F5
#define REG_BK3352_7B_L      0x3352F6
#define REG_BK3352_7B_H      0x3352F7
#define REG_BK3352_7C_L      0x3352F8
#define REG_BK3352_7C_H      0x3352F9
#define REG_BK3352_7D_L      0x3352FA
#define REG_BK3352_7D_H      0x3352FB
#define REG_BK3352_7E_L      0x3352FC
#define REG_BK3352_7E_H      0x3352FD
#define REG_BK3352_7F_L      0x3352FE
#define REG_BK3352_7F_H      0x3352FF
//----------------------------------------------
#define REG_BK3357_00_L      0x335700
#define REG_BK3357_00_H      0x335701
#define REG_BK3357_01_L      0x335702
#define REG_BK3357_01_H      0x335703
#define REG_BK3357_02_L      0x335704
#define REG_BK3357_02_H      0x335705
#define REG_BK3357_03_L      0x335706
#define REG_BK3357_03_H      0x335707
#define REG_BK3357_04_L      0x335708
#define REG_BK3357_04_H      0x335709
#define REG_BK3357_05_L      0x33570A
#define REG_BK3357_05_H      0x33570B
#define REG_BK3357_06_L      0x33570C
#define REG_BK3357_06_H      0x33570D
#define REG_BK3357_07_L      0x33570E
#define REG_BK3357_07_H      0x33570F
#define REG_BK3357_08_L      0x335710
#define REG_BK3357_08_H      0x335711
#define REG_BK3357_09_L      0x335712
#define REG_BK3357_09_H      0x335713
#define REG_BK3357_0A_L      0x335714
#define REG_BK3357_0A_H      0x335715
#define REG_BK3357_0B_L      0x335716
#define REG_BK3357_0B_H      0x335717
#define REG_BK3357_0C_L      0x335718
#define REG_BK3357_0C_H      0x335719
#define REG_BK3357_0D_L      0x33571A
#define REG_BK3357_0D_H      0x33571B
#define REG_BK3357_0E_L      0x33571C
#define REG_BK3357_0E_H      0x33571D
#define REG_BK3357_0F_L      0x33571E
#define REG_BK3357_0F_H      0x33571F
#define REG_BK3357_10_L      0x335720
#define REG_BK3357_10_H      0x335721
#define REG_BK3357_11_L      0x335722
#define REG_BK3357_11_H      0x335723
#define REG_BK3357_12_L      0x335724
#define REG_BK3357_12_H      0x335725
#define REG_BK3357_13_L      0x335726
#define REG_BK3357_13_H      0x335727
#define REG_BK3357_14_L      0x335728
#define REG_BK3357_14_H      0x335729
#define REG_BK3357_15_L      0x33572A
#define REG_BK3357_15_H      0x33572B
#define REG_BK3357_16_L      0x33572C
#define REG_BK3357_16_H      0x33572D
#define REG_BK3357_17_L      0x33572E
#define REG_BK3357_17_H      0x33572F
#define REG_BK3357_18_L      0x335730
#define REG_BK3357_18_H      0x335731
#define REG_BK3357_19_L      0x335732
#define REG_BK3357_19_H      0x335733
#define REG_BK3357_1A_L      0x335734
#define REG_BK3357_1A_H      0x335735
#define REG_BK3357_1B_L      0x335736
#define REG_BK3357_1B_H      0x335737
#define REG_BK3357_1C_L      0x335738
#define REG_BK3357_1C_H      0x335739
#define REG_BK3357_1D_L      0x33573A
#define REG_BK3357_1D_H      0x33573B
#define REG_BK3357_1E_L      0x33573C
#define REG_BK3357_1E_H      0x33573D
#define REG_BK3357_1F_L      0x33573E
#define REG_BK3357_1F_H      0x33573F
#define REG_BK3357_20_L      0x335740
#define REG_BK3357_20_H      0x335741
#define REG_BK3357_21_L      0x335742
#define REG_BK3357_21_H      0x335743
#define REG_BK3357_22_L      0x335744
#define REG_BK3357_22_H      0x335745
#define REG_BK3357_23_L      0x335746
#define REG_BK3357_23_H      0x335747
#define REG_BK3357_24_L      0x335748
#define REG_BK3357_24_H      0x335749
#define REG_BK3357_25_L      0x33574A
#define REG_BK3357_25_H      0x33574B
#define REG_BK3357_26_L      0x33574C
#define REG_BK3357_26_H      0x33574D
#define REG_BK3357_27_L      0x33574E
#define REG_BK3357_27_H      0x33574F
#define REG_BK3357_28_L      0x335750
#define REG_BK3357_28_H      0x335751
#define REG_BK3357_29_L      0x335752
#define REG_BK3357_29_H      0x335753
#define REG_BK3357_2A_L      0x335754
#define REG_BK3357_2A_H      0x335755
#define REG_BK3357_2B_L      0x335756
#define REG_BK3357_2B_H      0x335757
#define REG_BK3357_2C_L      0x335758
#define REG_BK3357_2C_H      0x335759
#define REG_BK3357_2D_L      0x33575A
#define REG_BK3357_2D_H      0x33575B
#define REG_BK3357_2E_L      0x33575C
#define REG_BK3357_2E_H      0x33575D
#define REG_BK3357_2F_L      0x33575E
#define REG_BK3357_2F_H      0x33575F
#define REG_BK3357_30_L      0x335760
#define REG_BK3357_30_H      0x335761
#define REG_BK3357_31_L      0x335762
#define REG_BK3357_31_H      0x335763
#define REG_BK3357_32_L      0x335764
#define REG_BK3357_32_H      0x335765
#define REG_BK3357_33_L      0x335766
#define REG_BK3357_33_H      0x335767
#define REG_BK3357_34_L      0x335768
#define REG_BK3357_34_H      0x335769
#define REG_BK3357_35_L      0x33576A
#define REG_BK3357_35_H      0x33576B
#define REG_BK3357_36_L      0x33576C
#define REG_BK3357_36_H      0x33576D
#define REG_BK3357_37_L      0x33576E
#define REG_BK3357_37_H      0x33576F
#define REG_BK3357_38_L      0x335770
#define REG_BK3357_38_H      0x335771
#define REG_BK3357_39_L      0x335772
#define REG_BK3357_39_H      0x335773
#define REG_BK3357_3A_L      0x335774
#define REG_BK3357_3A_H      0x335775
#define REG_BK3357_3B_L      0x335776
#define REG_BK3357_3B_H      0x335777
#define REG_BK3357_3C_L      0x335778
#define REG_BK3357_3C_H      0x335779
#define REG_BK3357_3D_L      0x33577A
#define REG_BK3357_3D_H      0x33577B
#define REG_BK3357_3E_L      0x33577C
#define REG_BK3357_3E_H      0x33577D
#define REG_BK3357_3F_L      0x33577E
#define REG_BK3357_3F_H      0x33577F
#define REG_BK3357_40_L      0x335780
#define REG_BK3357_40_H      0x335781
#define REG_BK3357_41_L      0x335782
#define REG_BK3357_41_H      0x335783
#define REG_BK3357_42_L      0x335784
#define REG_BK3357_42_H      0x335785
#define REG_BK3357_43_L      0x335786
#define REG_BK3357_43_H      0x335787
#define REG_BK3357_44_L      0x335788
#define REG_BK3357_44_H      0x335789
#define REG_BK3357_45_L      0x33578A
#define REG_BK3357_45_H      0x33578B
#define REG_BK3357_46_L      0x33578C
#define REG_BK3357_46_H      0x33578D
#define REG_BK3357_47_L      0x33578E
#define REG_BK3357_47_H      0x33578F
#define REG_BK3357_48_L      0x335790
#define REG_BK3357_48_H      0x335791
#define REG_BK3357_49_L      0x335792
#define REG_BK3357_49_H      0x335793
#define REG_BK3357_4A_L      0x335794
#define REG_BK3357_4A_H      0x335795
#define REG_BK3357_4B_L      0x335796
#define REG_BK3357_4B_H      0x335797
#define REG_BK3357_4C_L      0x335798
#define REG_BK3357_4C_H      0x335799
#define REG_BK3357_4D_L      0x33579A
#define REG_BK3357_4D_H      0x33579B
#define REG_BK3357_4E_L      0x33579C
#define REG_BK3357_4E_H      0x33579D
#define REG_BK3357_4F_L      0x33579E
#define REG_BK3357_4F_H      0x33579F
#define REG_BK3357_50_L      0x3357A0
#define REG_BK3357_50_H      0x3357A1
#define REG_BK3357_51_L      0x3357A2
#define REG_BK3357_51_H      0x3357A3
#define REG_BK3357_52_L      0x3357A4
#define REG_BK3357_52_H      0x3357A5
#define REG_BK3357_53_L      0x3357A6
#define REG_BK3357_53_H      0x3357A7
#define REG_BK3357_54_L      0x3357A8
#define REG_BK3357_54_H      0x3357A9
#define REG_BK3357_55_L      0x3357AA
#define REG_BK3357_55_H      0x3357AB
#define REG_BK3357_56_L      0x3357AC
#define REG_BK3357_56_H      0x3357AD
#define REG_BK3357_57_L      0x3357AE
#define REG_BK3357_57_H      0x3357AF
#define REG_BK3357_58_L      0x3357B0
#define REG_BK3357_58_H      0x3357B1
#define REG_BK3357_59_L      0x3357B2
#define REG_BK3357_59_H      0x3357B3
#define REG_BK3357_5A_L      0x3357B4
#define REG_BK3357_5A_H      0x3357B5
#define REG_BK3357_5B_L      0x3357B6
#define REG_BK3357_5B_H      0x3357B7
#define REG_BK3357_5C_L      0x3357B8
#define REG_BK3357_5C_H      0x3357B9
#define REG_BK3357_5D_L      0x3357BA
#define REG_BK3357_5D_H      0x3357BB
#define REG_BK3357_5E_L      0x3357BC
#define REG_BK3357_5E_H      0x3357BD
#define REG_BK3357_5F_L      0x3357BE
#define REG_BK3357_5F_H      0x3357BF
#define REG_BK3357_60_L      0x3357C0
#define REG_BK3357_60_H      0x3357C1
#define REG_BK3357_61_L      0x3357C2
#define REG_BK3357_61_H      0x3357C3
#define REG_BK3357_62_L      0x3357C4
#define REG_BK3357_62_H      0x3357C5
#define REG_BK3357_63_L      0x3357C6
#define REG_BK3357_63_H      0x3357C7
#define REG_BK3357_64_L      0x3357C8
#define REG_BK3357_64_H      0x3357C9
#define REG_BK3357_65_L      0x3357CA
#define REG_BK3357_65_H      0x3357CB
#define REG_BK3357_66_L      0x3357CC
#define REG_BK3357_66_H      0x3357CD
#define REG_BK3357_67_L      0x3357CE
#define REG_BK3357_67_H      0x3357CF
#define REG_BK3357_68_L      0x3357D0
#define REG_BK3357_68_H      0x3357D1
#define REG_BK3357_69_L      0x3357D2
#define REG_BK3357_69_H      0x3357D3
#define REG_BK3357_6A_L      0x3357D4
#define REG_BK3357_6A_H      0x3357D5
#define REG_BK3357_6B_L      0x3357D6
#define REG_BK3357_6B_H      0x3357D7
#define REG_BK3357_6C_L      0x3357D8
#define REG_BK3357_6C_H      0x3357D9
#define REG_BK3357_6D_L      0x3357DA
#define REG_BK3357_6D_H      0x3357DB
#define REG_BK3357_6E_L      0x3357DC
#define REG_BK3357_6E_H      0x3357DD
#define REG_BK3357_6F_L      0x3357DE
#define REG_BK3357_6F_H      0x3357DF
#define REG_BK3357_70_L      0x3357E0
#define REG_BK3357_70_H      0x3357E1
#define REG_BK3357_71_L      0x3357E2
#define REG_BK3357_71_H      0x3357E3
#define REG_BK3357_72_L      0x3357E4
#define REG_BK3357_72_H      0x3357E5
#define REG_BK3357_73_L      0x3357E6
#define REG_BK3357_73_H      0x3357E7
#define REG_BK3357_74_L      0x3357E8
#define REG_BK3357_74_H      0x3357E9
#define REG_BK3357_75_L      0x3357EA
#define REG_BK3357_75_H      0x3357EB
#define REG_BK3357_76_L      0x3357EC
#define REG_BK3357_76_H      0x3357ED
#define REG_BK3357_77_L      0x3357EE
#define REG_BK3357_77_H      0x3357EF
#define REG_BK3357_78_L      0x3357F0
#define REG_BK3357_78_H      0x3357F1
#define REG_BK3357_79_L      0x3357F2
#define REG_BK3357_79_H      0x3357F3
#define REG_BK3357_7A_L      0x3357F4
#define REG_BK3357_7A_H      0x3357F5
#define REG_BK3357_7B_L      0x3357F6
#define REG_BK3357_7B_H      0x3357F7
#define REG_BK3357_7C_L      0x3357F8
#define REG_BK3357_7C_H      0x3357F9
#define REG_BK3357_7D_L      0x3357FA
#define REG_BK3357_7D_H      0x3357FB
#define REG_BK3357_7E_L      0x3357FC
#define REG_BK3357_7E_H      0x3357FD
#define REG_BK3357_7F_L      0x3357FE
#define REG_BK3357_7F_H      0x3357FF
//----------------------------------------------
#define REG_BK335A_00_L      0x335A00
#define REG_BK335A_00_H      0x335A01
#define REG_BK335A_01_L      0x335A02
#define REG_BK335A_01_H      0x335A03
#define REG_BK335A_02_L      0x335A04
#define REG_BK335A_02_H      0x335A05
#define REG_BK335A_03_L      0x335A06
#define REG_BK335A_03_H      0x335A07
#define REG_BK335A_04_L      0x335A08
#define REG_BK335A_04_H      0x335A09
#define REG_BK335A_05_L      0x335A0A
#define REG_BK335A_05_H      0x335A0B
#define REG_BK335A_06_L      0x335A0C
#define REG_BK335A_06_H      0x335A0D
#define REG_BK335A_07_L      0x335A0E
#define REG_BK335A_07_H      0x335A0F
#define REG_BK335A_08_L      0x335A10
#define REG_BK335A_08_H      0x335A11
#define REG_BK335A_09_L      0x335A12
#define REG_BK335A_09_H      0x335A13
#define REG_BK335A_0A_L      0x335A14
#define REG_BK335A_0A_H      0x335A15
#define REG_BK335A_0B_L      0x335A16
#define REG_BK335A_0B_H      0x335A17
#define REG_BK335A_0C_L      0x335A18
#define REG_BK335A_0C_H      0x335A19
#define REG_BK335A_0D_L      0x335A1A
#define REG_BK335A_0D_H      0x335A1B
#define REG_BK335A_0E_L      0x335A1C
#define REG_BK335A_0E_H      0x335A1D
#define REG_BK335A_0F_L      0x335A1E
#define REG_BK335A_0F_H      0x335A1F
#define REG_BK335A_10_L      0x335A20
#define REG_BK335A_10_H      0x335A21
#define REG_BK335A_11_L      0x335A22
#define REG_BK335A_11_H      0x335A23
#define REG_BK335A_12_L      0x335A24
#define REG_BK335A_12_H      0x335A25
#define REG_BK335A_13_L      0x335A26
#define REG_BK335A_13_H      0x335A27
#define REG_BK335A_14_L      0x335A28
#define REG_BK335A_14_H      0x335A29
#define REG_BK335A_15_L      0x335A2A
#define REG_BK335A_15_H      0x335A2B
#define REG_BK335A_16_L      0x335A2C
#define REG_BK335A_16_H      0x335A2D
#define REG_BK335A_17_L      0x335A2E
#define REG_BK335A_17_H      0x335A2F
#define REG_BK335A_18_L      0x335A30
#define REG_BK335A_18_H      0x335A31
#define REG_BK335A_19_L      0x335A32
#define REG_BK335A_19_H      0x335A33
#define REG_BK335A_1A_L      0x335A34
#define REG_BK335A_1A_H      0x335A35
#define REG_BK335A_1B_L      0x335A36
#define REG_BK335A_1B_H      0x335A37
#define REG_BK335A_1C_L      0x335A38
#define REG_BK335A_1C_H      0x335A39
#define REG_BK335A_1D_L      0x335A3A
#define REG_BK335A_1D_H      0x335A3B
#define REG_BK335A_1E_L      0x335A3C
#define REG_BK335A_1E_H      0x335A3D
#define REG_BK335A_1F_L      0x335A3E
#define REG_BK335A_1F_H      0x335A3F
#define REG_BK335A_20_L      0x335A40
#define REG_BK335A_20_H      0x335A41
#define REG_BK335A_21_L      0x335A42
#define REG_BK335A_21_H      0x335A43
#define REG_BK335A_22_L      0x335A44
#define REG_BK335A_22_H      0x335A45
#define REG_BK335A_23_L      0x335A46
#define REG_BK335A_23_H      0x335A47
#define REG_BK335A_24_L      0x335A48
#define REG_BK335A_24_H      0x335A49
#define REG_BK335A_25_L      0x335A4A
#define REG_BK335A_25_H      0x335A4B
#define REG_BK335A_26_L      0x335A4C
#define REG_BK335A_26_H      0x335A4D
#define REG_BK335A_27_L      0x335A4E
#define REG_BK335A_27_H      0x335A4F
#define REG_BK335A_28_L      0x335A50
#define REG_BK335A_28_H      0x335A51
#define REG_BK335A_29_L      0x335A52
#define REG_BK335A_29_H      0x335A53
#define REG_BK335A_2A_L      0x335A54
#define REG_BK335A_2A_H      0x335A55
#define REG_BK335A_2B_L      0x335A56
#define REG_BK335A_2B_H      0x335A57
#define REG_BK335A_2C_L      0x335A58
#define REG_BK335A_2C_H      0x335A59
#define REG_BK335A_2D_L      0x335A5A
#define REG_BK335A_2D_H      0x335A5B
#define REG_BK335A_2E_L      0x335A5C
#define REG_BK335A_2E_H      0x335A5D
#define REG_BK335A_2F_L      0x335A5E
#define REG_BK335A_2F_H      0x335A5F
#define REG_BK335A_30_L      0x335A60
#define REG_BK335A_30_H      0x335A61
#define REG_BK335A_31_L      0x335A62
#define REG_BK335A_31_H      0x335A63
#define REG_BK335A_32_L      0x335A64
#define REG_BK335A_32_H      0x335A65
#define REG_BK335A_33_L      0x335A66
#define REG_BK335A_33_H      0x335A67
#define REG_BK335A_34_L      0x335A68
#define REG_BK335A_34_H      0x335A69
#define REG_BK335A_35_L      0x335A6A
#define REG_BK335A_35_H      0x335A6B
#define REG_BK335A_36_L      0x335A6C
#define REG_BK335A_36_H      0x335A6D
#define REG_BK335A_37_L      0x335A6E
#define REG_BK335A_37_H      0x335A6F
#define REG_BK335A_38_L      0x335A70
#define REG_BK335A_38_H      0x335A71
#define REG_BK335A_39_L      0x335A72
#define REG_BK335A_39_H      0x335A73
#define REG_BK335A_3A_L      0x335A74
#define REG_BK335A_3A_H      0x335A75
#define REG_BK335A_3B_L      0x335A76
#define REG_BK335A_3B_H      0x335A77
#define REG_BK335A_3C_L      0x335A78
#define REG_BK335A_3C_H      0x335A79
#define REG_BK335A_3D_L      0x335A7A
#define REG_BK335A_3D_H      0x335A7B
#define REG_BK335A_3E_L      0x335A7C
#define REG_BK335A_3E_H      0x335A7D
#define REG_BK335A_3F_L      0x335A7E
#define REG_BK335A_3F_H      0x335A7F
#define REG_BK335A_40_L      0x335A80
#define REG_BK335A_40_H      0x335A81
#define REG_BK335A_41_L      0x335A82
#define REG_BK335A_41_H      0x335A83
#define REG_BK335A_42_L      0x335A84
#define REG_BK335A_42_H      0x335A85
#define REG_BK335A_43_L      0x335A86
#define REG_BK335A_43_H      0x335A87
#define REG_BK335A_44_L      0x335A88
#define REG_BK335A_44_H      0x335A89
#define REG_BK335A_45_L      0x335A8A
#define REG_BK335A_45_H      0x335A8B
#define REG_BK335A_46_L      0x335A8C
#define REG_BK335A_46_H      0x335A8D
#define REG_BK335A_47_L      0x335A8E
#define REG_BK335A_47_H      0x335A8F
#define REG_BK335A_48_L      0x335A90
#define REG_BK335A_48_H      0x335A91
#define REG_BK335A_49_L      0x335A92
#define REG_BK335A_49_H      0x335A93
#define REG_BK335A_4A_L      0x335A94
#define REG_BK335A_4A_H      0x335A95
#define REG_BK335A_4B_L      0x335A96
#define REG_BK335A_4B_H      0x335A97
#define REG_BK335A_4C_L      0x335A98
#define REG_BK335A_4C_H      0x335A99
#define REG_BK335A_4D_L      0x335A9A
#define REG_BK335A_4D_H      0x335A9B
#define REG_BK335A_4E_L      0x335A9C
#define REG_BK335A_4E_H      0x335A9D
#define REG_BK335A_4F_L      0x335A9E
#define REG_BK335A_4F_H      0x335A9F
#define REG_BK335A_50_L      0x335AA0
#define REG_BK335A_50_H      0x335AA1
#define REG_BK335A_51_L      0x335AA2
#define REG_BK335A_51_H      0x335AA3
#define REG_BK335A_52_L      0x335AA4
#define REG_BK335A_52_H      0x335AA5
#define REG_BK335A_53_L      0x335AA6
#define REG_BK335A_53_H      0x335AA7
#define REG_BK335A_54_L      0x335AA8
#define REG_BK335A_54_H      0x335AA9
#define REG_BK335A_55_L      0x335AAA
#define REG_BK335A_55_H      0x335AAB
#define REG_BK335A_56_L      0x335AAC
#define REG_BK335A_56_H      0x335AAD
#define REG_BK335A_57_L      0x335AAE
#define REG_BK335A_57_H      0x335AAF
#define REG_BK335A_58_L      0x335AB0
#define REG_BK335A_58_H      0x335AB1
#define REG_BK335A_59_L      0x335AB2
#define REG_BK335A_59_H      0x335AB3
#define REG_BK335A_5A_L      0x335AB4
#define REG_BK335A_5A_H      0x335AB5
#define REG_BK335A_5B_L      0x335AB6
#define REG_BK335A_5B_H      0x335AB7
#define REG_BK335A_5C_L      0x335AB8
#define REG_BK335A_5C_H      0x335AB9
#define REG_BK335A_5D_L      0x335ABA
#define REG_BK335A_5D_H      0x335ABB
#define REG_BK335A_5E_L      0x335ABC
#define REG_BK335A_5E_H      0x335ABD
#define REG_BK335A_5F_L      0x335ABE
#define REG_BK335A_5F_H      0x335ABF
#define REG_BK335A_60_L      0x335AC0
#define REG_BK335A_60_H      0x335AC1
#define REG_BK335A_61_L      0x335AC2
#define REG_BK335A_61_H      0x335AC3
#define REG_BK335A_62_L      0x335AC4
#define REG_BK335A_62_H      0x335AC5
#define REG_BK335A_63_L      0x335AC6
#define REG_BK335A_63_H      0x335AC7
#define REG_BK335A_64_L      0x335AC8
#define REG_BK335A_64_H      0x335AC9
#define REG_BK335A_65_L      0x335ACA
#define REG_BK335A_65_H      0x335ACB
#define REG_BK335A_66_L      0x335ACC
#define REG_BK335A_66_H      0x335ACD
#define REG_BK335A_67_L      0x335ACE
#define REG_BK335A_67_H      0x335ACF
#define REG_BK335A_68_L      0x335AD0
#define REG_BK335A_68_H      0x335AD1
#define REG_BK335A_69_L      0x335AD2
#define REG_BK335A_69_H      0x335AD3
#define REG_BK335A_6A_L      0x335AD4
#define REG_BK335A_6A_H      0x335AD5
#define REG_BK335A_6B_L      0x335AD6
#define REG_BK335A_6B_H      0x335AD7
#define REG_BK335A_6C_L      0x335AD8
#define REG_BK335A_6C_H      0x335AD9
#define REG_BK335A_6D_L      0x335ADA
#define REG_BK335A_6D_H      0x335ADB
#define REG_BK335A_6E_L      0x335ADC
#define REG_BK335A_6E_H      0x335ADD
#define REG_BK335A_6F_L      0x335ADE
#define REG_BK335A_6F_H      0x335ADF
#define REG_BK335A_70_L      0x335AE0
#define REG_BK335A_70_H      0x335AE1
#define REG_BK335A_71_L      0x335AE2
#define REG_BK335A_71_H      0x335AE3
#define REG_BK335A_72_L      0x335AE4
#define REG_BK335A_72_H      0x335AE5
#define REG_BK335A_73_L      0x335AE6
#define REG_BK335A_73_H      0x335AE7
#define REG_BK335A_74_L      0x335AE8
#define REG_BK335A_74_H      0x335AE9
#define REG_BK335A_75_L      0x335AEA
#define REG_BK335A_75_H      0x335AEB
#define REG_BK335A_76_L      0x335AEC
#define REG_BK335A_76_H      0x335AED
#define REG_BK335A_77_L      0x335AEE
#define REG_BK335A_77_H      0x335AEF
#define REG_BK335A_78_L      0x335AF0
#define REG_BK335A_78_H      0x335AF1
#define REG_BK335A_79_L      0x335AF2
#define REG_BK335A_79_H      0x335AF3
#define REG_BK335A_7A_L      0x335AF4
#define REG_BK335A_7A_H      0x335AF5
#define REG_BK335A_7B_L      0x335AF6
#define REG_BK335A_7B_H      0x335AF7
#define REG_BK335A_7C_L      0x335AF8
#define REG_BK335A_7C_H      0x335AF9
#define REG_BK335A_7D_L      0x335AFA
#define REG_BK335A_7D_H      0x335AFB
#define REG_BK335A_7E_L      0x335AFC
#define REG_BK335A_7E_H      0x335AFD
#define REG_BK335A_7F_L      0x335AFE
#define REG_BK335A_7F_H      0x335AFF
//----------------------------------------------
#define REG_BK335C_00_L      0x335C00
#define REG_BK335C_00_H      0x335C01
#define REG_BK335C_01_L      0x335C02
#define REG_BK335C_01_H      0x335C03
#define REG_BK335C_02_L      0x335C04
#define REG_BK335C_02_H      0x335C05
#define REG_BK335C_03_L      0x335C06
#define REG_BK335C_03_H      0x335C07
#define REG_BK335C_04_L      0x335C08
#define REG_BK335C_04_H      0x335C09
#define REG_BK335C_05_L      0x335C0A
#define REG_BK335C_05_H      0x335C0B
#define REG_BK335C_06_L      0x335C0C
#define REG_BK335C_06_H      0x335C0D
#define REG_BK335C_07_L      0x335C0E
#define REG_BK335C_07_H      0x335C0F
#define REG_BK335C_08_L      0x335C10
#define REG_BK335C_08_H      0x335C11
#define REG_BK335C_09_L      0x335C12
#define REG_BK335C_09_H      0x335C13
#define REG_BK335C_0A_L      0x335C14
#define REG_BK335C_0A_H      0x335C15
#define REG_BK335C_0B_L      0x335C16
#define REG_BK335C_0B_H      0x335C17
#define REG_BK335C_0C_L      0x335C18
#define REG_BK335C_0C_H      0x335C19
#define REG_BK335C_0D_L      0x335C1A
#define REG_BK335C_0D_H      0x335C1B
#define REG_BK335C_0E_L      0x335C1C
#define REG_BK335C_0E_H      0x335C1D
#define REG_BK335C_0F_L      0x335C1E
#define REG_BK335C_0F_H      0x335C1F
#define REG_BK335C_10_L      0x335C20
#define REG_BK335C_10_H      0x335C21
#define REG_BK335C_11_L      0x335C22
#define REG_BK335C_11_H      0x335C23
#define REG_BK335C_12_L      0x335C24
#define REG_BK335C_12_H      0x335C25
#define REG_BK335C_13_L      0x335C26
#define REG_BK335C_13_H      0x335C27
#define REG_BK335C_14_L      0x335C28
#define REG_BK335C_14_H      0x335C29
#define REG_BK335C_15_L      0x335C2A
#define REG_BK335C_15_H      0x335C2B
#define REG_BK335C_16_L      0x335C2C
#define REG_BK335C_16_H      0x335C2D
#define REG_BK335C_17_L      0x335C2E
#define REG_BK335C_17_H      0x335C2F
#define REG_BK335C_18_L      0x335C30
#define REG_BK335C_18_H      0x335C31
#define REG_BK335C_19_L      0x335C32
#define REG_BK335C_19_H      0x335C33
#define REG_BK335C_1A_L      0x335C34
#define REG_BK335C_1A_H      0x335C35
#define REG_BK335C_1B_L      0x335C36
#define REG_BK335C_1B_H      0x335C37
#define REG_BK335C_1C_L      0x335C38
#define REG_BK335C_1C_H      0x335C39
#define REG_BK335C_1D_L      0x335C3A
#define REG_BK335C_1D_H      0x335C3B
#define REG_BK335C_1E_L      0x335C3C
#define REG_BK335C_1E_H      0x335C3D
#define REG_BK335C_1F_L      0x335C3E
#define REG_BK335C_1F_H      0x335C3F
#define REG_BK335C_20_L      0x335C40
#define REG_BK335C_20_H      0x335C41
#define REG_BK335C_21_L      0x335C42
#define REG_BK335C_21_H      0x335C43
#define REG_BK335C_22_L      0x335C44
#define REG_BK335C_22_H      0x335C45
#define REG_BK335C_23_L      0x335C46
#define REG_BK335C_23_H      0x335C47
#define REG_BK335C_24_L      0x335C48
#define REG_BK335C_24_H      0x335C49
#define REG_BK335C_25_L      0x335C4A
#define REG_BK335C_25_H      0x335C4B
#define REG_BK335C_26_L      0x335C4C
#define REG_BK335C_26_H      0x335C4D
#define REG_BK335C_27_L      0x335C4E
#define REG_BK335C_27_H      0x335C4F
#define REG_BK335C_28_L      0x335C50
#define REG_BK335C_28_H      0x335C51
#define REG_BK335C_29_L      0x335C52
#define REG_BK335C_29_H      0x335C53
#define REG_BK335C_2A_L      0x335C54
#define REG_BK335C_2A_H      0x335C55
#define REG_BK335C_2B_L      0x335C56
#define REG_BK335C_2B_H      0x335C57
#define REG_BK335C_2C_L      0x335C58
#define REG_BK335C_2C_H      0x335C59
#define REG_BK335C_2D_L      0x335C5A
#define REG_BK335C_2D_H      0x335C5B
#define REG_BK335C_2E_L      0x335C5C
#define REG_BK335C_2E_H      0x335C5D
#define REG_BK335C_2F_L      0x335C5E
#define REG_BK335C_2F_H      0x335C5F
#define REG_BK335C_30_L      0x335C60
#define REG_BK335C_30_H      0x335C61
#define REG_BK335C_31_L      0x335C62
#define REG_BK335C_31_H      0x335C63
#define REG_BK335C_32_L      0x335C64
#define REG_BK335C_32_H      0x335C65
#define REG_BK335C_33_L      0x335C66
#define REG_BK335C_33_H      0x335C67
#define REG_BK335C_34_L      0x335C68
#define REG_BK335C_34_H      0x335C69
#define REG_BK335C_35_L      0x335C6A
#define REG_BK335C_35_H      0x335C6B
#define REG_BK335C_36_L      0x335C6C
#define REG_BK335C_36_H      0x335C6D
#define REG_BK335C_37_L      0x335C6E
#define REG_BK335C_37_H      0x335C6F
#define REG_BK335C_38_L      0x335C70
#define REG_BK335C_38_H      0x335C71
#define REG_BK335C_39_L      0x335C72
#define REG_BK335C_39_H      0x335C73
#define REG_BK335C_3A_L      0x335C74
#define REG_BK335C_3A_H      0x335C75
#define REG_BK335C_3B_L      0x335C76
#define REG_BK335C_3B_H      0x335C77
#define REG_BK335C_3C_L      0x335C78
#define REG_BK335C_3C_H      0x335C79
#define REG_BK335C_3D_L      0x335C7A
#define REG_BK335C_3D_H      0x335C7B
#define REG_BK335C_3E_L      0x335C7C
#define REG_BK335C_3E_H      0x335C7D
#define REG_BK335C_3F_L      0x335C7E
#define REG_BK335C_3F_H      0x335C7F
#define REG_BK335C_40_L      0x335C80
#define REG_BK335C_40_H      0x335C81
#define REG_BK335C_41_L      0x335C82
#define REG_BK335C_41_H      0x335C83
#define REG_BK335C_42_L      0x335C84
#define REG_BK335C_42_H      0x335C85
#define REG_BK335C_43_L      0x335C86
#define REG_BK335C_43_H      0x335C87
#define REG_BK335C_44_L      0x335C88
#define REG_BK335C_44_H      0x335C89
#define REG_BK335C_45_L      0x335C8A
#define REG_BK335C_45_H      0x335C8B
#define REG_BK335C_46_L      0x335C8C
#define REG_BK335C_46_H      0x335C8D
#define REG_BK335C_47_L      0x335C8E
#define REG_BK335C_47_H      0x335C8F
#define REG_BK335C_48_L      0x335C90
#define REG_BK335C_48_H      0x335C91
#define REG_BK335C_49_L      0x335C92
#define REG_BK335C_49_H      0x335C93
#define REG_BK335C_4A_L      0x335C94
#define REG_BK335C_4A_H      0x335C95
#define REG_BK335C_4B_L      0x335C96
#define REG_BK335C_4B_H      0x335C97
#define REG_BK335C_4C_L      0x335C98
#define REG_BK335C_4C_H      0x335C99
#define REG_BK335C_4D_L      0x335C9A
#define REG_BK335C_4D_H      0x335C9B
#define REG_BK335C_4E_L      0x335C9C
#define REG_BK335C_4E_H      0x335C9D
#define REG_BK335C_4F_L      0x335C9E
#define REG_BK335C_4F_H      0x335C9F
#define REG_BK335C_50_L      0x335CA0
#define REG_BK335C_50_H      0x335CA1
#define REG_BK335C_51_L      0x335CA2
#define REG_BK335C_51_H      0x335CA3
#define REG_BK335C_52_L      0x335CA4
#define REG_BK335C_52_H      0x335CA5
#define REG_BK335C_53_L      0x335CA6
#define REG_BK335C_53_H      0x335CA7
#define REG_BK335C_54_L      0x335CA8
#define REG_BK335C_54_H      0x335CA9
#define REG_BK335C_55_L      0x335CAA
#define REG_BK335C_55_H      0x335CAB
#define REG_BK335C_56_L      0x335CAC
#define REG_BK335C_56_H      0x335CAD
#define REG_BK335C_57_L      0x335CAE
#define REG_BK335C_57_H      0x335CAF
#define REG_BK335C_58_L      0x335CB0
#define REG_BK335C_58_H      0x335CB1
#define REG_BK335C_59_L      0x335CB2
#define REG_BK335C_59_H      0x335CB3
#define REG_BK335C_5A_L      0x335CB4
#define REG_BK335C_5A_H      0x335CB5
#define REG_BK335C_5B_L      0x335CB6
#define REG_BK335C_5B_H      0x335CB7
#define REG_BK335C_5C_L      0x335CB8
#define REG_BK335C_5C_H      0x335CB9
#define REG_BK335C_5D_L      0x335CBA
#define REG_BK335C_5D_H      0x335CBB
#define REG_BK335C_5E_L      0x335CBC
#define REG_BK335C_5E_H      0x335CBD
#define REG_BK335C_5F_L      0x335CBE
#define REG_BK335C_5F_H      0x335CBF
#define REG_BK335C_60_L      0x335CC0
#define REG_BK335C_60_H      0x335CC1
#define REG_BK335C_61_L      0x335CC2
#define REG_BK335C_61_H      0x335CC3
#define REG_BK335C_62_L      0x335CC4
#define REG_BK335C_62_H      0x335CC5
#define REG_BK335C_63_L      0x335CC6
#define REG_BK335C_63_H      0x335CC7
#define REG_BK335C_64_L      0x335CC8
#define REG_BK335C_64_H      0x335CC9
#define REG_BK335C_65_L      0x335CCA
#define REG_BK335C_65_H      0x335CCB
#define REG_BK335C_66_L      0x335CCC
#define REG_BK335C_66_H      0x335CCD
#define REG_BK335C_67_L      0x335CCE
#define REG_BK335C_67_H      0x335CCF
#define REG_BK335C_68_L      0x335CD0
#define REG_BK335C_68_H      0x335CD1
#define REG_BK335C_69_L      0x335CD2
#define REG_BK335C_69_H      0x335CD3
#define REG_BK335C_6A_L      0x335CD4
#define REG_BK335C_6A_H      0x335CD5
#define REG_BK335C_6B_L      0x335CD6
#define REG_BK335C_6B_H      0x335CD7
#define REG_BK335C_6C_L      0x335CD8
#define REG_BK335C_6C_H      0x335CD9
#define REG_BK335C_6D_L      0x335CDA
#define REG_BK335C_6D_H      0x335CDB
#define REG_BK335C_6E_L      0x335CDC
#define REG_BK335C_6E_H      0x335CDD
#define REG_BK335C_6F_L      0x335CDE
#define REG_BK335C_6F_H      0x335CDF
#define REG_BK335C_70_L      0x335CE0
#define REG_BK335C_70_H      0x335CE1
#define REG_BK335C_71_L      0x335CE2
#define REG_BK335C_71_H      0x335CE3
#define REG_BK335C_72_L      0x335CE4
#define REG_BK335C_72_H      0x335CE5
#define REG_BK335C_73_L      0x335CE6
#define REG_BK335C_73_H      0x335CE7
#define REG_BK335C_74_L      0x335CE8
#define REG_BK335C_74_H      0x335CE9
#define REG_BK335C_75_L      0x335CEA
#define REG_BK335C_75_H      0x335CEB
#define REG_BK335C_76_L      0x335CEC
#define REG_BK335C_76_H      0x335CED
#define REG_BK335C_77_L      0x335CEE
#define REG_BK335C_77_H      0x335CEF
#define REG_BK335C_78_L      0x335CF0
#define REG_BK335C_78_H      0x335CF1
#define REG_BK335C_79_L      0x335CF2
#define REG_BK335C_79_H      0x335CF3
#define REG_BK335C_7A_L      0x335CF4
#define REG_BK335C_7A_H      0x335CF5
#define REG_BK335C_7B_L      0x335CF6
#define REG_BK335C_7B_H      0x335CF7
#define REG_BK335C_7C_L      0x335CF8
#define REG_BK335C_7C_H      0x335CF9
#define REG_BK335C_7D_L      0x335CFA
#define REG_BK335C_7D_H      0x335CFB
#define REG_BK335C_7E_L      0x335CFC
#define REG_BK335C_7E_H      0x335CFD
#define REG_BK335C_7F_L      0x335CFE
#define REG_BK335C_7F_H      0x335CFF
//----------------------------------------------
#define REG_BK335D_00_L      0x335D00
#define REG_BK335D_00_H      0x335D01
#define REG_BK335D_01_L      0x335D02
#define REG_BK335D_01_H      0x335D03
#define REG_BK335D_02_L      0x335D04
#define REG_BK335D_02_H      0x335D05
#define REG_BK335D_03_L      0x335D06
#define REG_BK335D_03_H      0x335D07
#define REG_BK335D_04_L      0x335D08
#define REG_BK335D_04_H      0x335D09
#define REG_BK335D_05_L      0x335D0A
#define REG_BK335D_05_H      0x335D0B
#define REG_BK335D_06_L      0x335D0C
#define REG_BK335D_06_H      0x335D0D
#define REG_BK335D_07_L      0x335D0E
#define REG_BK335D_07_H      0x335D0F
#define REG_BK335D_08_L      0x335D10
#define REG_BK335D_08_H      0x335D11
#define REG_BK335D_09_L      0x335D12
#define REG_BK335D_09_H      0x335D13
#define REG_BK335D_0A_L      0x335D14
#define REG_BK335D_0A_H      0x335D15
#define REG_BK335D_0B_L      0x335D16
#define REG_BK335D_0B_H      0x335D17
#define REG_BK335D_0C_L      0x335D18
#define REG_BK335D_0C_H      0x335D19
#define REG_BK335D_0D_L      0x335D1A
#define REG_BK335D_0D_H      0x335D1B
#define REG_BK335D_0E_L      0x335D1C
#define REG_BK335D_0E_H      0x335D1D
#define REG_BK335D_0F_L      0x335D1E
#define REG_BK335D_0F_H      0x335D1F
#define REG_BK335D_10_L      0x335D20
#define REG_BK335D_10_H      0x335D21
#define REG_BK335D_11_L      0x335D22
#define REG_BK335D_11_H      0x335D23
#define REG_BK335D_12_L      0x335D24
#define REG_BK335D_12_H      0x335D25
#define REG_BK335D_13_L      0x335D26
#define REG_BK335D_13_H      0x335D27
#define REG_BK335D_14_L      0x335D28
#define REG_BK335D_14_H      0x335D29
#define REG_BK335D_15_L      0x335D2A
#define REG_BK335D_15_H      0x335D2B
#define REG_BK335D_16_L      0x335D2C
#define REG_BK335D_16_H      0x335D2D
#define REG_BK335D_17_L      0x335D2E
#define REG_BK335D_17_H      0x335D2F
#define REG_BK335D_18_L      0x335D30
#define REG_BK335D_18_H      0x335D31
#define REG_BK335D_19_L      0x335D32
#define REG_BK335D_19_H      0x335D33
#define REG_BK335D_1A_L      0x335D34
#define REG_BK335D_1A_H      0x335D35
#define REG_BK335D_1B_L      0x335D36
#define REG_BK335D_1B_H      0x335D37
#define REG_BK335D_1C_L      0x335D38
#define REG_BK335D_1C_H      0x335D39
#define REG_BK335D_1D_L      0x335D3A
#define REG_BK335D_1D_H      0x335D3B
#define REG_BK335D_1E_L      0x335D3C
#define REG_BK335D_1E_H      0x335D3D
#define REG_BK335D_1F_L      0x335D3E
#define REG_BK335D_1F_H      0x335D3F
#define REG_BK335D_20_L      0x335D40
#define REG_BK335D_20_H      0x335D41
#define REG_BK335D_21_L      0x335D42
#define REG_BK335D_21_H      0x335D43
#define REG_BK335D_22_L      0x335D44
#define REG_BK335D_22_H      0x335D45
#define REG_BK335D_23_L      0x335D46
#define REG_BK335D_23_H      0x335D47
#define REG_BK335D_24_L      0x335D48
#define REG_BK335D_24_H      0x335D49
#define REG_BK335D_25_L      0x335D4A
#define REG_BK335D_25_H      0x335D4B
#define REG_BK335D_26_L      0x335D4C
#define REG_BK335D_26_H      0x335D4D
#define REG_BK335D_27_L      0x335D4E
#define REG_BK335D_27_H      0x335D4F
#define REG_BK335D_28_L      0x335D50
#define REG_BK335D_28_H      0x335D51
#define REG_BK335D_29_L      0x335D52
#define REG_BK335D_29_H      0x335D53
#define REG_BK335D_2A_L      0x335D54
#define REG_BK335D_2A_H      0x335D55
#define REG_BK335D_2B_L      0x335D56
#define REG_BK335D_2B_H      0x335D57
#define REG_BK335D_2C_L      0x335D58
#define REG_BK335D_2C_H      0x335D59
#define REG_BK335D_2D_L      0x335D5A
#define REG_BK335D_2D_H      0x335D5B
#define REG_BK335D_2E_L      0x335D5C
#define REG_BK335D_2E_H      0x335D5D
#define REG_BK335D_2F_L      0x335D5E
#define REG_BK335D_2F_H      0x335D5F
#define REG_BK335D_30_L      0x335D60
#define REG_BK335D_30_H      0x335D61
#define REG_BK335D_31_L      0x335D62
#define REG_BK335D_31_H      0x335D63
#define REG_BK335D_32_L      0x335D64
#define REG_BK335D_32_H      0x335D65
#define REG_BK335D_33_L      0x335D66
#define REG_BK335D_33_H      0x335D67
#define REG_BK335D_34_L      0x335D68
#define REG_BK335D_34_H      0x335D69
#define REG_BK335D_35_L      0x335D6A
#define REG_BK335D_35_H      0x335D6B
#define REG_BK335D_36_L      0x335D6C
#define REG_BK335D_36_H      0x335D6D
#define REG_BK335D_37_L      0x335D6E
#define REG_BK335D_37_H      0x335D6F
#define REG_BK335D_38_L      0x335D70
#define REG_BK335D_38_H      0x335D71
#define REG_BK335D_39_L      0x335D72
#define REG_BK335D_39_H      0x335D73
#define REG_BK335D_3A_L      0x335D74
#define REG_BK335D_3A_H      0x335D75
#define REG_BK335D_3B_L      0x335D76
#define REG_BK335D_3B_H      0x335D77
#define REG_BK335D_3C_L      0x335D78
#define REG_BK335D_3C_H      0x335D79
#define REG_BK335D_3D_L      0x335D7A
#define REG_BK335D_3D_H      0x335D7B
#define REG_BK335D_3E_L      0x335D7C
#define REG_BK335D_3E_H      0x335D7D
#define REG_BK335D_3F_L      0x335D7E
#define REG_BK335D_3F_H      0x335D7F
#define REG_BK335D_40_L      0x335D80
#define REG_BK335D_40_H      0x335D81
#define REG_BK335D_41_L      0x335D82
#define REG_BK335D_41_H      0x335D83
#define REG_BK335D_42_L      0x335D84
#define REG_BK335D_42_H      0x335D85
#define REG_BK335D_43_L      0x335D86
#define REG_BK335D_43_H      0x335D87
#define REG_BK335D_44_L      0x335D88
#define REG_BK335D_44_H      0x335D89
#define REG_BK335D_45_L      0x335D8A
#define REG_BK335D_45_H      0x335D8B
#define REG_BK335D_46_L      0x335D8C
#define REG_BK335D_46_H      0x335D8D
#define REG_BK335D_47_L      0x335D8E
#define REG_BK335D_47_H      0x335D8F
#define REG_BK335D_48_L      0x335D90
#define REG_BK335D_48_H      0x335D91
#define REG_BK335D_49_L      0x335D92
#define REG_BK335D_49_H      0x335D93
#define REG_BK335D_4A_L      0x335D94
#define REG_BK335D_4A_H      0x335D95
#define REG_BK335D_4B_L      0x335D96
#define REG_BK335D_4B_H      0x335D97
#define REG_BK335D_4C_L      0x335D98
#define REG_BK335D_4C_H      0x335D99
#define REG_BK335D_4D_L      0x335D9A
#define REG_BK335D_4D_H      0x335D9B
#define REG_BK335D_4E_L      0x335D9C
#define REG_BK335D_4E_H      0x335D9D
#define REG_BK335D_4F_L      0x335D9E
#define REG_BK335D_4F_H      0x335D9F
#define REG_BK335D_50_L      0x335DA0
#define REG_BK335D_50_H      0x335DA1
#define REG_BK335D_51_L      0x335DA2
#define REG_BK335D_51_H      0x335DA3
#define REG_BK335D_52_L      0x335DA4
#define REG_BK335D_52_H      0x335DA5
#define REG_BK335D_53_L      0x335DA6
#define REG_BK335D_53_H      0x335DA7
#define REG_BK335D_54_L      0x335DA8
#define REG_BK335D_54_H      0x335DA9
#define REG_BK335D_55_L      0x335DAA
#define REG_BK335D_55_H      0x335DAB
#define REG_BK335D_56_L      0x335DAC
#define REG_BK335D_56_H      0x335DAD
#define REG_BK335D_57_L      0x335DAE
#define REG_BK335D_57_H      0x335DAF
#define REG_BK335D_58_L      0x335DB0
#define REG_BK335D_58_H      0x335DB1
#define REG_BK335D_59_L      0x335DB2
#define REG_BK335D_59_H      0x335DB3
#define REG_BK335D_5A_L      0x335DB4
#define REG_BK335D_5A_H      0x335DB5
#define REG_BK335D_5B_L      0x335DB6
#define REG_BK335D_5B_H      0x335DB7
#define REG_BK335D_5C_L      0x335DB8
#define REG_BK335D_5C_H      0x335DB9
#define REG_BK335D_5D_L      0x335DBA
#define REG_BK335D_5D_H      0x335DBB
#define REG_BK335D_5E_L      0x335DBC
#define REG_BK335D_5E_H      0x335DBD
#define REG_BK335D_5F_L      0x335DBE
#define REG_BK335D_5F_H      0x335DBF
#define REG_BK335D_60_L      0x335DC0
#define REG_BK335D_60_H      0x335DC1
#define REG_BK335D_61_L      0x335DC2
#define REG_BK335D_61_H      0x335DC3
#define REG_BK335D_62_L      0x335DC4
#define REG_BK335D_62_H      0x335DC5
#define REG_BK335D_63_L      0x335DC6
#define REG_BK335D_63_H      0x335DC7
#define REG_BK335D_64_L      0x335DC8
#define REG_BK335D_64_H      0x335DC9
#define REG_BK335D_65_L      0x335DCA
#define REG_BK335D_65_H      0x335DCB
#define REG_BK335D_66_L      0x335DCC
#define REG_BK335D_66_H      0x335DCD
#define REG_BK335D_67_L      0x335DCE
#define REG_BK335D_67_H      0x335DCF
#define REG_BK335D_68_L      0x335DD0
#define REG_BK335D_68_H      0x335DD1
#define REG_BK335D_69_L      0x335DD2
#define REG_BK335D_69_H      0x335DD3
#define REG_BK335D_6A_L      0x335DD4
#define REG_BK335D_6A_H      0x335DD5
#define REG_BK335D_6B_L      0x335DD6
#define REG_BK335D_6B_H      0x335DD7
#define REG_BK335D_6C_L      0x335DD8
#define REG_BK335D_6C_H      0x335DD9
#define REG_BK335D_6D_L      0x335DDA
#define REG_BK335D_6D_H      0x335DDB
#define REG_BK335D_6E_L      0x335DDC
#define REG_BK335D_6E_H      0x335DDD
#define REG_BK335D_6F_L      0x335DDE
#define REG_BK335D_6F_H      0x335DDF
#define REG_BK335D_70_L      0x335DE0
#define REG_BK335D_70_H      0x335DE1
#define REG_BK335D_71_L      0x335DE2
#define REG_BK335D_71_H      0x335DE3
#define REG_BK335D_72_L      0x335DE4
#define REG_BK335D_72_H      0x335DE5
#define REG_BK335D_73_L      0x335DE6
#define REG_BK335D_73_H      0x335DE7
#define REG_BK335D_74_L      0x335DE8
#define REG_BK335D_74_H      0x335DE9
#define REG_BK335D_75_L      0x335DEA
#define REG_BK335D_75_H      0x335DEB
#define REG_BK335D_76_L      0x335DEC
#define REG_BK335D_76_H      0x335DED
#define REG_BK335D_77_L      0x335DEE
#define REG_BK335D_77_H      0x335DEF
#define REG_BK335D_78_L      0x335DF0
#define REG_BK335D_78_H      0x335DF1
#define REG_BK335D_79_L      0x335DF2
#define REG_BK335D_79_H      0x335DF3
#define REG_BK335D_7A_L      0x335DF4
#define REG_BK335D_7A_H      0x335DF5
#define REG_BK335D_7B_L      0x335DF6
#define REG_BK335D_7B_H      0x335DF7
#define REG_BK335D_7C_L      0x335DF8
#define REG_BK335D_7C_H      0x335DF9
#define REG_BK335D_7D_L      0x335DFA
#define REG_BK335D_7D_H      0x335DFB
#define REG_BK335D_7E_L      0x335DFC
#define REG_BK335D_7E_H      0x335DFD
#define REG_BK335D_7F_L      0x335DFE
#define REG_BK335D_7F_H      0x335DFF
//----------------------------------------------
#define REG_BK335E_00_L      0x335E00
#define REG_BK335E_00_H      0x335E01
#define REG_BK335E_01_L      0x335E02
#define REG_BK335E_01_H      0x335E03
#define REG_BK335E_02_L      0x335E04
#define REG_BK335E_02_H      0x335E05
#define REG_BK335E_03_L      0x335E06
#define REG_BK335E_03_H      0x335E07
#define REG_BK335E_04_L      0x335E08
#define REG_BK335E_04_H      0x335E09
#define REG_BK335E_05_L      0x335E0A
#define REG_BK335E_05_H      0x335E0B
#define REG_BK335E_06_L      0x335E0C
#define REG_BK335E_06_H      0x335E0D
#define REG_BK335E_07_L      0x335E0E
#define REG_BK335E_07_H      0x335E0F
#define REG_BK335E_08_L      0x335E10
#define REG_BK335E_08_H      0x335E11
#define REG_BK335E_09_L      0x335E12
#define REG_BK335E_09_H      0x335E13
#define REG_BK335E_0A_L      0x335E14
#define REG_BK335E_0A_H      0x335E15
#define REG_BK335E_0B_L      0x335E16
#define REG_BK335E_0B_H      0x335E17
#define REG_BK335E_0C_L      0x335E18
#define REG_BK335E_0C_H      0x335E19
#define REG_BK335E_0D_L      0x335E1A
#define REG_BK335E_0D_H      0x335E1B
#define REG_BK335E_0E_L      0x335E1C
#define REG_BK335E_0E_H      0x335E1D
#define REG_BK335E_0F_L      0x335E1E
#define REG_BK335E_0F_H      0x335E1F
#define REG_BK335E_10_L      0x335E20
#define REG_BK335E_10_H      0x335E21
#define REG_BK335E_11_L      0x335E22
#define REG_BK335E_11_H      0x335E23
#define REG_BK335E_12_L      0x335E24
#define REG_BK335E_12_H      0x335E25
#define REG_BK335E_13_L      0x335E26
#define REG_BK335E_13_H      0x335E27
#define REG_BK335E_14_L      0x335E28
#define REG_BK335E_14_H      0x335E29
#define REG_BK335E_15_L      0x335E2A
#define REG_BK335E_15_H      0x335E2B
#define REG_BK335E_16_L      0x335E2C
#define REG_BK335E_16_H      0x335E2D
#define REG_BK335E_17_L      0x335E2E
#define REG_BK335E_17_H      0x335E2F
#define REG_BK335E_18_L      0x335E30
#define REG_BK335E_18_H      0x335E31
#define REG_BK335E_19_L      0x335E32
#define REG_BK335E_19_H      0x335E33
#define REG_BK335E_1A_L      0x335E34
#define REG_BK335E_1A_H      0x335E35
#define REG_BK335E_1B_L      0x335E36
#define REG_BK335E_1B_H      0x335E37
#define REG_BK335E_1C_L      0x335E38
#define REG_BK335E_1C_H      0x335E39
#define REG_BK335E_1D_L      0x335E3A
#define REG_BK335E_1D_H      0x335E3B
#define REG_BK335E_1E_L      0x335E3C
#define REG_BK335E_1E_H      0x335E3D
#define REG_BK335E_1F_L      0x335E3E
#define REG_BK335E_1F_H      0x335E3F
#define REG_BK335E_20_L      0x335E40
#define REG_BK335E_20_H      0x335E41
#define REG_BK335E_21_L      0x335E42
#define REG_BK335E_21_H      0x335E43
#define REG_BK335E_22_L      0x335E44
#define REG_BK335E_22_H      0x335E45
#define REG_BK335E_23_L      0x335E46
#define REG_BK335E_23_H      0x335E47
#define REG_BK335E_24_L      0x335E48
#define REG_BK335E_24_H      0x335E49
#define REG_BK335E_25_L      0x335E4A
#define REG_BK335E_25_H      0x335E4B
#define REG_BK335E_26_L      0x335E4C
#define REG_BK335E_26_H      0x335E4D
#define REG_BK335E_27_L      0x335E4E
#define REG_BK335E_27_H      0x335E4F
#define REG_BK335E_28_L      0x335E50
#define REG_BK335E_28_H      0x335E51
#define REG_BK335E_29_L      0x335E52
#define REG_BK335E_29_H      0x335E53
#define REG_BK335E_2A_L      0x335E54
#define REG_BK335E_2A_H      0x335E55
#define REG_BK335E_2B_L      0x335E56
#define REG_BK335E_2B_H      0x335E57
#define REG_BK335E_2C_L      0x335E58
#define REG_BK335E_2C_H      0x335E59
#define REG_BK335E_2D_L      0x335E5A
#define REG_BK335E_2D_H      0x335E5B
#define REG_BK335E_2E_L      0x335E5C
#define REG_BK335E_2E_H      0x335E5D
#define REG_BK335E_2F_L      0x335E5E
#define REG_BK335E_2F_H      0x335E5F
#define REG_BK335E_30_L      0x335E60
#define REG_BK335E_30_H      0x335E61
#define REG_BK335E_31_L      0x335E62
#define REG_BK335E_31_H      0x335E63
#define REG_BK335E_32_L      0x335E64
#define REG_BK335E_32_H      0x335E65
#define REG_BK335E_33_L      0x335E66
#define REG_BK335E_33_H      0x335E67
#define REG_BK335E_34_L      0x335E68
#define REG_BK335E_34_H      0x335E69
#define REG_BK335E_35_L      0x335E6A
#define REG_BK335E_35_H      0x335E6B
#define REG_BK335E_36_L      0x335E6C
#define REG_BK335E_36_H      0x335E6D
#define REG_BK335E_37_L      0x335E6E
#define REG_BK335E_37_H      0x335E6F
#define REG_BK335E_38_L      0x335E70
#define REG_BK335E_38_H      0x335E71
#define REG_BK335E_39_L      0x335E72
#define REG_BK335E_39_H      0x335E73
#define REG_BK335E_3A_L      0x335E74
#define REG_BK335E_3A_H      0x335E75
#define REG_BK335E_3B_L      0x335E76
#define REG_BK335E_3B_H      0x335E77
#define REG_BK335E_3C_L      0x335E78
#define REG_BK335E_3C_H      0x335E79
#define REG_BK335E_3D_L      0x335E7A
#define REG_BK335E_3D_H      0x335E7B
#define REG_BK335E_3E_L      0x335E7C
#define REG_BK335E_3E_H      0x335E7D
#define REG_BK335E_3F_L      0x335E7E
#define REG_BK335E_3F_H      0x335E7F
#define REG_BK335E_40_L      0x335E80
#define REG_BK335E_40_H      0x335E81
#define REG_BK335E_41_L      0x335E82
#define REG_BK335E_41_H      0x335E83
#define REG_BK335E_42_L      0x335E84
#define REG_BK335E_42_H      0x335E85
#define REG_BK335E_43_L      0x335E86
#define REG_BK335E_43_H      0x335E87
#define REG_BK335E_44_L      0x335E88
#define REG_BK335E_44_H      0x335E89
#define REG_BK335E_45_L      0x335E8A
#define REG_BK335E_45_H      0x335E8B
#define REG_BK335E_46_L      0x335E8C
#define REG_BK335E_46_H      0x335E8D
#define REG_BK335E_47_L      0x335E8E
#define REG_BK335E_47_H      0x335E8F
#define REG_BK335E_48_L      0x335E90
#define REG_BK335E_48_H      0x335E91
#define REG_BK335E_49_L      0x335E92
#define REG_BK335E_49_H      0x335E93
#define REG_BK335E_4A_L      0x335E94
#define REG_BK335E_4A_H      0x335E95
#define REG_BK335E_4B_L      0x335E96
#define REG_BK335E_4B_H      0x335E97
#define REG_BK335E_4C_L      0x335E98
#define REG_BK335E_4C_H      0x335E99
#define REG_BK335E_4D_L      0x335E9A
#define REG_BK335E_4D_H      0x335E9B
#define REG_BK335E_4E_L      0x335E9C
#define REG_BK335E_4E_H      0x335E9D
#define REG_BK335E_4F_L      0x335E9E
#define REG_BK335E_4F_H      0x335E9F
#define REG_BK335E_50_L      0x335EA0
#define REG_BK335E_50_H      0x335EA1
#define REG_BK335E_51_L      0x335EA2
#define REG_BK335E_51_H      0x335EA3
#define REG_BK335E_52_L      0x335EA4
#define REG_BK335E_52_H      0x335EA5
#define REG_BK335E_53_L      0x335EA6
#define REG_BK335E_53_H      0x335EA7
#define REG_BK335E_54_L      0x335EA8
#define REG_BK335E_54_H      0x335EA9
#define REG_BK335E_55_L      0x335EAA
#define REG_BK335E_55_H      0x335EAB
#define REG_BK335E_56_L      0x335EAC
#define REG_BK335E_56_H      0x335EAD
#define REG_BK335E_57_L      0x335EAE
#define REG_BK335E_57_H      0x335EAF
#define REG_BK335E_58_L      0x335EB0
#define REG_BK335E_58_H      0x335EB1
#define REG_BK335E_59_L      0x335EB2
#define REG_BK335E_59_H      0x335EB3
#define REG_BK335E_5A_L      0x335EB4
#define REG_BK335E_5A_H      0x335EB5
#define REG_BK335E_5B_L      0x335EB6
#define REG_BK335E_5B_H      0x335EB7
#define REG_BK335E_5C_L      0x335EB8
#define REG_BK335E_5C_H      0x335EB9
#define REG_BK335E_5D_L      0x335EBA
#define REG_BK335E_5D_H      0x335EBB
#define REG_BK335E_5E_L      0x335EBC
#define REG_BK335E_5E_H      0x335EBD
#define REG_BK335E_5F_L      0x335EBE
#define REG_BK335E_5F_H      0x335EBF
#define REG_BK335E_60_L      0x335EC0
#define REG_BK335E_60_H      0x335EC1
#define REG_BK335E_61_L      0x335EC2
#define REG_BK335E_61_H      0x335EC3
#define REG_BK335E_62_L      0x335EC4
#define REG_BK335E_62_H      0x335EC5
#define REG_BK335E_63_L      0x335EC6
#define REG_BK335E_63_H      0x335EC7
#define REG_BK335E_64_L      0x335EC8
#define REG_BK335E_64_H      0x335EC9
#define REG_BK335E_65_L      0x335ECA
#define REG_BK335E_65_H      0x335ECB
#define REG_BK335E_66_L      0x335ECC
#define REG_BK335E_66_H      0x335ECD
#define REG_BK335E_67_L      0x335ECE
#define REG_BK335E_67_H      0x335ECF
#define REG_BK335E_68_L      0x335ED0
#define REG_BK335E_68_H      0x335ED1
#define REG_BK335E_69_L      0x335ED2
#define REG_BK335E_69_H      0x335ED3
#define REG_BK335E_6A_L      0x335ED4
#define REG_BK335E_6A_H      0x335ED5
#define REG_BK335E_6B_L      0x335ED6
#define REG_BK335E_6B_H      0x335ED7
#define REG_BK335E_6C_L      0x335ED8
#define REG_BK335E_6C_H      0x335ED9
#define REG_BK335E_6D_L      0x335EDA
#define REG_BK335E_6D_H      0x335EDB
#define REG_BK335E_6E_L      0x335EDC
#define REG_BK335E_6E_H      0x335EDD
#define REG_BK335E_6F_L      0x335EDE
#define REG_BK335E_6F_H      0x335EDF
#define REG_BK335E_70_L      0x335EE0
#define REG_BK335E_70_H      0x335EE1
#define REG_BK335E_71_L      0x335EE2
#define REG_BK335E_71_H      0x335EE3
#define REG_BK335E_72_L      0x335EE4
#define REG_BK335E_72_H      0x335EE5
#define REG_BK335E_73_L      0x335EE6
#define REG_BK335E_73_H      0x335EE7
#define REG_BK335E_74_L      0x335EE8
#define REG_BK335E_74_H      0x335EE9
#define REG_BK335E_75_L      0x335EEA
#define REG_BK335E_75_H      0x335EEB
#define REG_BK335E_76_L      0x335EEC
#define REG_BK335E_76_H      0x335EED
#define REG_BK335E_77_L      0x335EEE
#define REG_BK335E_77_H      0x335EEF
#define REG_BK335E_78_L      0x335EF0
#define REG_BK335E_78_H      0x335EF1
#define REG_BK335E_79_L      0x335EF2
#define REG_BK335E_79_H      0x335EF3
#define REG_BK335E_7A_L      0x335EF4
#define REG_BK335E_7A_H      0x335EF5
#define REG_BK335E_7B_L      0x335EF6
#define REG_BK335E_7B_H      0x335EF7
#define REG_BK335E_7C_L      0x335EF8
#define REG_BK335E_7C_H      0x335EF9
#define REG_BK335E_7D_L      0x335EFA
#define REG_BK335E_7D_H      0x335EFB
#define REG_BK335E_7E_L      0x335EFC
#define REG_BK335E_7E_H      0x335EFD
#define REG_BK335E_7F_L      0x335EFE
#define REG_BK335E_7F_H      0x335EFF
//----------------------------------------------
#define REG_BK335F_00_L      0x335F00
#define REG_BK335F_00_H      0x335F01
#define REG_BK335F_01_L      0x335F02
#define REG_BK335F_01_H      0x335F03
#define REG_BK335F_02_L      0x335F04
#define REG_BK335F_02_H      0x335F05
#define REG_BK335F_03_L      0x335F06
#define REG_BK335F_03_H      0x335F07
#define REG_BK335F_04_L      0x335F08
#define REG_BK335F_04_H      0x335F09
#define REG_BK335F_05_L      0x335F0A
#define REG_BK335F_05_H      0x335F0B
#define REG_BK335F_06_L      0x335F0C
#define REG_BK335F_06_H      0x335F0D
#define REG_BK335F_07_L      0x335F0E
#define REG_BK335F_07_H      0x335F0F
#define REG_BK335F_08_L      0x335F10
#define REG_BK335F_08_H      0x335F11
#define REG_BK335F_09_L      0x335F12
#define REG_BK335F_09_H      0x335F13
#define REG_BK335F_0A_L      0x335F14
#define REG_BK335F_0A_H      0x335F15
#define REG_BK335F_0B_L      0x335F16
#define REG_BK335F_0B_H      0x335F17
#define REG_BK335F_0C_L      0x335F18
#define REG_BK335F_0C_H      0x335F19
#define REG_BK335F_0D_L      0x335F1A
#define REG_BK335F_0D_H      0x335F1B
#define REG_BK335F_0E_L      0x335F1C
#define REG_BK335F_0E_H      0x335F1D
#define REG_BK335F_0F_L      0x335F1E
#define REG_BK335F_0F_H      0x335F1F
#define REG_BK335F_10_L      0x335F20
#define REG_BK335F_10_H      0x335F21
#define REG_BK335F_11_L      0x335F22
#define REG_BK335F_11_H      0x335F23
#define REG_BK335F_12_L      0x335F24
#define REG_BK335F_12_H      0x335F25
#define REG_BK335F_13_L      0x335F26
#define REG_BK335F_13_H      0x335F27
#define REG_BK335F_14_L      0x335F28
#define REG_BK335F_14_H      0x335F29
#define REG_BK335F_15_L      0x335F2A
#define REG_BK335F_15_H      0x335F2B
#define REG_BK335F_16_L      0x335F2C
#define REG_BK335F_16_H      0x335F2D
#define REG_BK335F_17_L      0x335F2E
#define REG_BK335F_17_H      0x335F2F
#define REG_BK335F_18_L      0x335F30
#define REG_BK335F_18_H      0x335F31
#define REG_BK335F_19_L      0x335F32
#define REG_BK335F_19_H      0x335F33
#define REG_BK335F_1A_L      0x335F34
#define REG_BK335F_1A_H      0x335F35
#define REG_BK335F_1B_L      0x335F36
#define REG_BK335F_1B_H      0x335F37
#define REG_BK335F_1C_L      0x335F38
#define REG_BK335F_1C_H      0x335F39
#define REG_BK335F_1D_L      0x335F3A
#define REG_BK335F_1D_H      0x335F3B
#define REG_BK335F_1E_L      0x335F3C
#define REG_BK335F_1E_H      0x335F3D
#define REG_BK335F_1F_L      0x335F3E
#define REG_BK335F_1F_H      0x335F3F
#define REG_BK335F_20_L      0x335F40
#define REG_BK335F_20_H      0x335F41
#define REG_BK335F_21_L      0x335F42
#define REG_BK335F_21_H      0x335F43
#define REG_BK335F_22_L      0x335F44
#define REG_BK335F_22_H      0x335F45
#define REG_BK335F_23_L      0x335F46
#define REG_BK335F_23_H      0x335F47
#define REG_BK335F_24_L      0x335F48
#define REG_BK335F_24_H      0x335F49
#define REG_BK335F_25_L      0x335F4A
#define REG_BK335F_25_H      0x335F4B
#define REG_BK335F_26_L      0x335F4C
#define REG_BK335F_26_H      0x335F4D
#define REG_BK335F_27_L      0x335F4E
#define REG_BK335F_27_H      0x335F4F
#define REG_BK335F_28_L      0x335F50
#define REG_BK335F_28_H      0x335F51
#define REG_BK335F_29_L      0x335F52
#define REG_BK335F_29_H      0x335F53
#define REG_BK335F_2A_L      0x335F54
#define REG_BK335F_2A_H      0x335F55
#define REG_BK335F_2B_L      0x335F56
#define REG_BK335F_2B_H      0x335F57
#define REG_BK335F_2C_L      0x335F58
#define REG_BK335F_2C_H      0x335F59
#define REG_BK335F_2D_L      0x335F5A
#define REG_BK335F_2D_H      0x335F5B
#define REG_BK335F_2E_L      0x335F5C
#define REG_BK335F_2E_H      0x335F5D
#define REG_BK335F_2F_L      0x335F5E
#define REG_BK335F_2F_H      0x335F5F
#define REG_BK335F_30_L      0x335F60
#define REG_BK335F_30_H      0x335F61
#define REG_BK335F_31_L      0x335F62
#define REG_BK335F_31_H      0x335F63
#define REG_BK335F_32_L      0x335F64
#define REG_BK335F_32_H      0x335F65
#define REG_BK335F_33_L      0x335F66
#define REG_BK335F_33_H      0x335F67
#define REG_BK335F_34_L      0x335F68
#define REG_BK335F_34_H      0x335F69
#define REG_BK335F_35_L      0x335F6A
#define REG_BK335F_35_H      0x335F6B
#define REG_BK335F_36_L      0x335F6C
#define REG_BK335F_36_H      0x335F6D
#define REG_BK335F_37_L      0x335F6E
#define REG_BK335F_37_H      0x335F6F
#define REG_BK335F_38_L      0x335F70
#define REG_BK335F_38_H      0x335F71
#define REG_BK335F_39_L      0x335F72
#define REG_BK335F_39_H      0x335F73
#define REG_BK335F_3A_L      0x335F74
#define REG_BK335F_3A_H      0x335F75
#define REG_BK335F_3B_L      0x335F76
#define REG_BK335F_3B_H      0x335F77
#define REG_BK335F_3C_L      0x335F78
#define REG_BK335F_3C_H      0x335F79
#define REG_BK335F_3D_L      0x335F7A
#define REG_BK335F_3D_H      0x335F7B
#define REG_BK335F_3E_L      0x335F7C
#define REG_BK335F_3E_H      0x335F7D
#define REG_BK335F_3F_L      0x335F7E
#define REG_BK335F_3F_H      0x335F7F
#define REG_BK335F_40_L      0x335F80
#define REG_BK335F_40_H      0x335F81
#define REG_BK335F_41_L      0x335F82
#define REG_BK335F_41_H      0x335F83
#define REG_BK335F_42_L      0x335F84
#define REG_BK335F_42_H      0x335F85
#define REG_BK335F_43_L      0x335F86
#define REG_BK335F_43_H      0x335F87
#define REG_BK335F_44_L      0x335F88
#define REG_BK335F_44_H      0x335F89
#define REG_BK335F_45_L      0x335F8A
#define REG_BK335F_45_H      0x335F8B
#define REG_BK335F_46_L      0x335F8C
#define REG_BK335F_46_H      0x335F8D
#define REG_BK335F_47_L      0x335F8E
#define REG_BK335F_47_H      0x335F8F
#define REG_BK335F_48_L      0x335F90
#define REG_BK335F_48_H      0x335F91
#define REG_BK335F_49_L      0x335F92
#define REG_BK335F_49_H      0x335F93
#define REG_BK335F_4A_L      0x335F94
#define REG_BK335F_4A_H      0x335F95
#define REG_BK335F_4B_L      0x335F96
#define REG_BK335F_4B_H      0x335F97
#define REG_BK335F_4C_L      0x335F98
#define REG_BK335F_4C_H      0x335F99
#define REG_BK335F_4D_L      0x335F9A
#define REG_BK335F_4D_H      0x335F9B
#define REG_BK335F_4E_L      0x335F9C
#define REG_BK335F_4E_H      0x335F9D
#define REG_BK335F_4F_L      0x335F9E
#define REG_BK335F_4F_H      0x335F9F
#define REG_BK335F_50_L      0x335FA0
#define REG_BK335F_50_H      0x335FA1
#define REG_BK335F_51_L      0x335FA2
#define REG_BK335F_51_H      0x335FA3
#define REG_BK335F_52_L      0x335FA4
#define REG_BK335F_52_H      0x335FA5
#define REG_BK335F_53_L      0x335FA6
#define REG_BK335F_53_H      0x335FA7
#define REG_BK335F_54_L      0x335FA8
#define REG_BK335F_54_H      0x335FA9
#define REG_BK335F_55_L      0x335FAA
#define REG_BK335F_55_H      0x335FAB
#define REG_BK335F_56_L      0x335FAC
#define REG_BK335F_56_H      0x335FAD
#define REG_BK335F_57_L      0x335FAE
#define REG_BK335F_57_H      0x335FAF
#define REG_BK335F_58_L      0x335FB0
#define REG_BK335F_58_H      0x335FB1
#define REG_BK335F_59_L      0x335FB2
#define REG_BK335F_59_H      0x335FB3
#define REG_BK335F_5A_L      0x335FB4
#define REG_BK335F_5A_H      0x335FB5
#define REG_BK335F_5B_L      0x335FB6
#define REG_BK335F_5B_H      0x335FB7
#define REG_BK335F_5C_L      0x335FB8
#define REG_BK335F_5C_H      0x335FB9
#define REG_BK335F_5D_L      0x335FBA
#define REG_BK335F_5D_H      0x335FBB
#define REG_BK335F_5E_L      0x335FBC
#define REG_BK335F_5E_H      0x335FBD
#define REG_BK335F_5F_L      0x335FBE
#define REG_BK335F_5F_H      0x335FBF
#define REG_BK335F_60_L      0x335FC0
#define REG_BK335F_60_H      0x335FC1
#define REG_BK335F_61_L      0x335FC2
#define REG_BK335F_61_H      0x335FC3
#define REG_BK335F_62_L      0x335FC4
#define REG_BK335F_62_H      0x335FC5
#define REG_BK335F_63_L      0x335FC6
#define REG_BK335F_63_H      0x335FC7
#define REG_BK335F_64_L      0x335FC8
#define REG_BK335F_64_H      0x335FC9
#define REG_BK335F_65_L      0x335FCA
#define REG_BK335F_65_H      0x335FCB
#define REG_BK335F_66_L      0x335FCC
#define REG_BK335F_66_H      0x335FCD
#define REG_BK335F_67_L      0x335FCE
#define REG_BK335F_67_H      0x335FCF
#define REG_BK335F_68_L      0x335FD0
#define REG_BK335F_68_H      0x335FD1
#define REG_BK335F_69_L      0x335FD2
#define REG_BK335F_69_H      0x335FD3
#define REG_BK335F_6A_L      0x335FD4
#define REG_BK335F_6A_H      0x335FD5
#define REG_BK335F_6B_L      0x335FD6
#define REG_BK335F_6B_H      0x335FD7
#define REG_BK335F_6C_L      0x335FD8
#define REG_BK335F_6C_H      0x335FD9
#define REG_BK335F_6D_L      0x335FDA
#define REG_BK335F_6D_H      0x335FDB
#define REG_BK335F_6E_L      0x335FDC
#define REG_BK335F_6E_H      0x335FDD
#define REG_BK335F_6F_L      0x335FDE
#define REG_BK335F_6F_H      0x335FDF
#define REG_BK335F_70_L      0x335FE0
#define REG_BK335F_70_H      0x335FE1
#define REG_BK335F_71_L      0x335FE2
#define REG_BK335F_71_H      0x335FE3
#define REG_BK335F_72_L      0x335FE4
#define REG_BK335F_72_H      0x335FE5
#define REG_BK335F_73_L      0x335FE6
#define REG_BK335F_73_H      0x335FE7
#define REG_BK335F_74_L      0x335FE8
#define REG_BK335F_74_H      0x335FE9
#define REG_BK335F_75_L      0x335FEA
#define REG_BK335F_75_H      0x335FEB
#define REG_BK335F_76_L      0x335FEC
#define REG_BK335F_76_H      0x335FED
#define REG_BK335F_77_L      0x335FEE
#define REG_BK335F_77_H      0x335FEF
#define REG_BK335F_78_L      0x335FF0
#define REG_BK335F_78_H      0x335FF1
#define REG_BK335F_79_L      0x335FF2
#define REG_BK335F_79_H      0x335FF3
#define REG_BK335F_7A_L      0x335FF4
#define REG_BK335F_7A_H      0x335FF5
#define REG_BK335F_7B_L      0x335FF6
#define REG_BK335F_7B_H      0x335FF7
#define REG_BK335F_7C_L      0x335FF8
#define REG_BK335F_7C_H      0x335FF9
#define REG_BK335F_7D_L      0x335FFA
#define REG_BK335F_7D_H      0x335FFB
#define REG_BK335F_7E_L      0x335FFC
#define REG_BK335F_7E_H      0x335FFD
#define REG_BK335F_7F_L      0x335FFE
#define REG_BK335F_7F_H      0x335FFF
//----------------------------------------------
#define REG_BK3360_00_L      0x336000
#define REG_BK3360_00_H      0x336001
#define REG_BK3360_01_L      0x336002
#define REG_BK3360_01_H      0x336003
#define REG_BK3360_02_L      0x336004
#define REG_BK3360_02_H      0x336005
#define REG_BK3360_03_L      0x336006
#define REG_BK3360_03_H      0x336007
#define REG_BK3360_04_L      0x336008
#define REG_BK3360_04_H      0x336009
#define REG_BK3360_05_L      0x33600A
#define REG_BK3360_05_H      0x33600B
#define REG_BK3360_06_L      0x33600C
#define REG_BK3360_06_H      0x33600D
#define REG_BK3360_07_L      0x33600E
#define REG_BK3360_07_H      0x33600F
#define REG_BK3360_08_L      0x336010
#define REG_BK3360_08_H      0x336011
#define REG_BK3360_09_L      0x336012
#define REG_BK3360_09_H      0x336013
#define REG_BK3360_0A_L      0x336014
#define REG_BK3360_0A_H      0x336015
#define REG_BK3360_0B_L      0x336016
#define REG_BK3360_0B_H      0x336017
#define REG_BK3360_0C_L      0x336018
#define REG_BK3360_0C_H      0x336019
#define REG_BK3360_0D_L      0x33601A
#define REG_BK3360_0D_H      0x33601B
#define REG_BK3360_0E_L      0x33601C
#define REG_BK3360_0E_H      0x33601D
#define REG_BK3360_0F_L      0x33601E
#define REG_BK3360_0F_H      0x33601F
#define REG_BK3360_10_L      0x336020
#define REG_BK3360_10_H      0x336021
#define REG_BK3360_11_L      0x336022
#define REG_BK3360_11_H      0x336023
#define REG_BK3360_12_L      0x336024
#define REG_BK3360_12_H      0x336025
#define REG_BK3360_13_L      0x336026
#define REG_BK3360_13_H      0x336027
#define REG_BK3360_14_L      0x336028
#define REG_BK3360_14_H      0x336029
#define REG_BK3360_15_L      0x33602A
#define REG_BK3360_15_H      0x33602B
#define REG_BK3360_16_L      0x33602C
#define REG_BK3360_16_H      0x33602D
#define REG_BK3360_17_L      0x33602E
#define REG_BK3360_17_H      0x33602F
#define REG_BK3360_18_L      0x336030
#define REG_BK3360_18_H      0x336031
#define REG_BK3360_19_L      0x336032
#define REG_BK3360_19_H      0x336033
#define REG_BK3360_1A_L      0x336034
#define REG_BK3360_1A_H      0x336035
#define REG_BK3360_1B_L      0x336036
#define REG_BK3360_1B_H      0x336037
#define REG_BK3360_1C_L      0x336038
#define REG_BK3360_1C_H      0x336039
#define REG_BK3360_1D_L      0x33603A
#define REG_BK3360_1D_H      0x33603B
#define REG_BK3360_1E_L      0x33603C
#define REG_BK3360_1E_H      0x33603D
#define REG_BK3360_1F_L      0x33603E
#define REG_BK3360_1F_H      0x33603F
#define REG_BK3360_20_L      0x336040
#define REG_BK3360_20_H      0x336041
#define REG_BK3360_21_L      0x336042
#define REG_BK3360_21_H      0x336043
#define REG_BK3360_22_L      0x336044
#define REG_BK3360_22_H      0x336045
#define REG_BK3360_23_L      0x336046
#define REG_BK3360_23_H      0x336047
#define REG_BK3360_24_L      0x336048
#define REG_BK3360_24_H      0x336049
#define REG_BK3360_25_L      0x33604A
#define REG_BK3360_25_H      0x33604B
#define REG_BK3360_26_L      0x33604C
#define REG_BK3360_26_H      0x33604D
#define REG_BK3360_27_L      0x33604E
#define REG_BK3360_27_H      0x33604F
#define REG_BK3360_28_L      0x336050
#define REG_BK3360_28_H      0x336051
#define REG_BK3360_29_L      0x336052
#define REG_BK3360_29_H      0x336053
#define REG_BK3360_2A_L      0x336054
#define REG_BK3360_2A_H      0x336055
#define REG_BK3360_2B_L      0x336056
#define REG_BK3360_2B_H      0x336057
#define REG_BK3360_2C_L      0x336058
#define REG_BK3360_2C_H      0x336059
#define REG_BK3360_2D_L      0x33605A
#define REG_BK3360_2D_H      0x33605B
#define REG_BK3360_2E_L      0x33605C
#define REG_BK3360_2E_H      0x33605D
#define REG_BK3360_2F_L      0x33605E
#define REG_BK3360_2F_H      0x33605F
#define REG_BK3360_30_L      0x336060
#define REG_BK3360_30_H      0x336061
#define REG_BK3360_31_L      0x336062
#define REG_BK3360_31_H      0x336063
#define REG_BK3360_32_L      0x336064
#define REG_BK3360_32_H      0x336065
#define REG_BK3360_33_L      0x336066
#define REG_BK3360_33_H      0x336067
#define REG_BK3360_34_L      0x336068
#define REG_BK3360_34_H      0x336069
#define REG_BK3360_35_L      0x33606A
#define REG_BK3360_35_H      0x33606B
#define REG_BK3360_36_L      0x33606C
#define REG_BK3360_36_H      0x33606D
#define REG_BK3360_37_L      0x33606E
#define REG_BK3360_37_H      0x33606F
#define REG_BK3360_38_L      0x336070
#define REG_BK3360_38_H      0x336071
#define REG_BK3360_39_L      0x336072
#define REG_BK3360_39_H      0x336073
#define REG_BK3360_3A_L      0x336074
#define REG_BK3360_3A_H      0x336075
#define REG_BK3360_3B_L      0x336076
#define REG_BK3360_3B_H      0x336077
#define REG_BK3360_3C_L      0x336078
#define REG_BK3360_3C_H      0x336079
#define REG_BK3360_3D_L      0x33607A
#define REG_BK3360_3D_H      0x33607B
#define REG_BK3360_3E_L      0x33607C
#define REG_BK3360_3E_H      0x33607D
#define REG_BK3360_3F_L      0x33607E
#define REG_BK3360_3F_H      0x33607F
#define REG_BK3360_40_L      0x336080
#define REG_BK3360_40_H      0x336081
#define REG_BK3360_41_L      0x336082
#define REG_BK3360_41_H      0x336083
#define REG_BK3360_42_L      0x336084
#define REG_BK3360_42_H      0x336085
#define REG_BK3360_43_L      0x336086
#define REG_BK3360_43_H      0x336087
#define REG_BK3360_44_L      0x336088
#define REG_BK3360_44_H      0x336089
#define REG_BK3360_45_L      0x33608A
#define REG_BK3360_45_H      0x33608B
#define REG_BK3360_46_L      0x33608C
#define REG_BK3360_46_H      0x33608D
#define REG_BK3360_47_L      0x33608E
#define REG_BK3360_47_H      0x33608F
#define REG_BK3360_48_L      0x336090
#define REG_BK3360_48_H      0x336091
#define REG_BK3360_49_L      0x336092
#define REG_BK3360_49_H      0x336093
#define REG_BK3360_4A_L      0x336094
#define REG_BK3360_4A_H      0x336095
#define REG_BK3360_4B_L      0x336096
#define REG_BK3360_4B_H      0x336097
#define REG_BK3360_4C_L      0x336098
#define REG_BK3360_4C_H      0x336099
#define REG_BK3360_4D_L      0x33609A
#define REG_BK3360_4D_H      0x33609B
#define REG_BK3360_4E_L      0x33609C
#define REG_BK3360_4E_H      0x33609D
#define REG_BK3360_4F_L      0x33609E
#define REG_BK3360_4F_H      0x33609F
#define REG_BK3360_50_L      0x3360A0
#define REG_BK3360_50_H      0x3360A1
#define REG_BK3360_51_L      0x3360A2
#define REG_BK3360_51_H      0x3360A3
#define REG_BK3360_52_L      0x3360A4
#define REG_BK3360_52_H      0x3360A5
#define REG_BK3360_53_L      0x3360A6
#define REG_BK3360_53_H      0x3360A7
#define REG_BK3360_54_L      0x3360A8
#define REG_BK3360_54_H      0x3360A9
#define REG_BK3360_55_L      0x3360AA
#define REG_BK3360_55_H      0x3360AB
#define REG_BK3360_56_L      0x3360AC
#define REG_BK3360_56_H      0x3360AD
#define REG_BK3360_57_L      0x3360AE
#define REG_BK3360_57_H      0x3360AF
#define REG_BK3360_58_L      0x3360B0
#define REG_BK3360_58_H      0x3360B1
#define REG_BK3360_59_L      0x3360B2
#define REG_BK3360_59_H      0x3360B3
#define REG_BK3360_5A_L      0x3360B4
#define REG_BK3360_5A_H      0x3360B5
#define REG_BK3360_5B_L      0x3360B6
#define REG_BK3360_5B_H      0x3360B7
#define REG_BK3360_5C_L      0x3360B8
#define REG_BK3360_5C_H      0x3360B9
#define REG_BK3360_5D_L      0x3360BA
#define REG_BK3360_5D_H      0x3360BB
#define REG_BK3360_5E_L      0x3360BC
#define REG_BK3360_5E_H      0x3360BD
#define REG_BK3360_5F_L      0x3360BE
#define REG_BK3360_5F_H      0x3360BF
#define REG_BK3360_60_L      0x3360C0
#define REG_BK3360_60_H      0x3360C1
#define REG_BK3360_61_L      0x3360C2
#define REG_BK3360_61_H      0x3360C3
#define REG_BK3360_62_L      0x3360C4
#define REG_BK3360_62_H      0x3360C5
#define REG_BK3360_63_L      0x3360C6
#define REG_BK3360_63_H      0x3360C7
#define REG_BK3360_64_L      0x3360C8
#define REG_BK3360_64_H      0x3360C9
#define REG_BK3360_65_L      0x3360CA
#define REG_BK3360_65_H      0x3360CB
#define REG_BK3360_66_L      0x3360CC
#define REG_BK3360_66_H      0x3360CD
#define REG_BK3360_67_L      0x3360CE
#define REG_BK3360_67_H      0x3360CF
#define REG_BK3360_68_L      0x3360D0
#define REG_BK3360_68_H      0x3360D1
#define REG_BK3360_69_L      0x3360D2
#define REG_BK3360_69_H      0x3360D3
#define REG_BK3360_6A_L      0x3360D4
#define REG_BK3360_6A_H      0x3360D5
#define REG_BK3360_6B_L      0x3360D6
#define REG_BK3360_6B_H      0x3360D7
#define REG_BK3360_6C_L      0x3360D8
#define REG_BK3360_6C_H      0x3360D9
#define REG_BK3360_6D_L      0x3360DA
#define REG_BK3360_6D_H      0x3360DB
#define REG_BK3360_6E_L      0x3360DC
#define REG_BK3360_6E_H      0x3360DD
#define REG_BK3360_6F_L      0x3360DE
#define REG_BK3360_6F_H      0x3360DF
#define REG_BK3360_70_L      0x3360E0
#define REG_BK3360_70_H      0x3360E1
#define REG_BK3360_71_L      0x3360E2
#define REG_BK3360_71_H      0x3360E3
#define REG_BK3360_72_L      0x3360E4
#define REG_BK3360_72_H      0x3360E5
#define REG_BK3360_73_L      0x3360E6
#define REG_BK3360_73_H      0x3360E7
#define REG_BK3360_74_L      0x3360E8
#define REG_BK3360_74_H      0x3360E9
#define REG_BK3360_75_L      0x3360EA
#define REG_BK3360_75_H      0x3360EB
#define REG_BK3360_76_L      0x3360EC
#define REG_BK3360_76_H      0x3360ED
#define REG_BK3360_77_L      0x3360EE
#define REG_BK3360_77_H      0x3360EF
#define REG_BK3360_78_L      0x3360F0
#define REG_BK3360_78_H      0x3360F1
#define REG_BK3360_79_L      0x3360F2
#define REG_BK3360_79_H      0x3360F3
#define REG_BK3360_7A_L      0x3360F4
#define REG_BK3360_7A_H      0x3360F5
#define REG_BK3360_7B_L      0x3360F6
#define REG_BK3360_7B_H      0x3360F7
#define REG_BK3360_7C_L      0x3360F8
#define REG_BK3360_7C_H      0x3360F9
#define REG_BK3360_7D_L      0x3360FA
#define REG_BK3360_7D_H      0x3360FB
#define REG_BK3360_7E_L      0x3360FC
#define REG_BK3360_7E_H      0x3360FD
#define REG_BK3360_7F_L      0x3360FE
#define REG_BK3360_7F_H      0x3360FF
//----------------------------------------------
#define REG_BK3368_00_L      0x336800
#define REG_BK3368_00_H      0x336801
#define REG_BK3368_01_L      0x336802
#define REG_BK3368_01_H      0x336803
#define REG_BK3368_02_L      0x336804
#define REG_BK3368_02_H      0x336805
#define REG_BK3368_03_L      0x336806
#define REG_BK3368_03_H      0x336807
#define REG_BK3368_04_L      0x336808
#define REG_BK3368_04_H      0x336809
#define REG_BK3368_05_L      0x33680A
#define REG_BK3368_05_H      0x33680B
#define REG_BK3368_06_L      0x33680C
#define REG_BK3368_06_H      0x33680D
#define REG_BK3368_07_L      0x33680E
#define REG_BK3368_07_H      0x33680F
#define REG_BK3368_08_L      0x336810
#define REG_BK3368_08_H      0x336811
#define REG_BK3368_09_L      0x336812
#define REG_BK3368_09_H      0x336813
#define REG_BK3368_0A_L      0x336814
#define REG_BK3368_0A_H      0x336815
#define REG_BK3368_0B_L      0x336816
#define REG_BK3368_0B_H      0x336817
#define REG_BK3368_0C_L      0x336818
#define REG_BK3368_0C_H      0x336819
#define REG_BK3368_0D_L      0x33681A
#define REG_BK3368_0D_H      0x33681B
#define REG_BK3368_0E_L      0x33681C
#define REG_BK3368_0E_H      0x33681D
#define REG_BK3368_0F_L      0x33681E
#define REG_BK3368_0F_H      0x33681F
#define REG_BK3368_10_L      0x336820
#define REG_BK3368_10_H      0x336821
#define REG_BK3368_11_L      0x336822
#define REG_BK3368_11_H      0x336823
#define REG_BK3368_12_L      0x336824
#define REG_BK3368_12_H      0x336825
#define REG_BK3368_13_L      0x336826
#define REG_BK3368_13_H      0x336827
#define REG_BK3368_14_L      0x336828
#define REG_BK3368_14_H      0x336829
#define REG_BK3368_15_L      0x33682A
#define REG_BK3368_15_H      0x33682B
#define REG_BK3368_16_L      0x33682C
#define REG_BK3368_16_H      0x33682D
#define REG_BK3368_17_L      0x33682E
#define REG_BK3368_17_H      0x33682F
#define REG_BK3368_18_L      0x336830
#define REG_BK3368_18_H      0x336831
#define REG_BK3368_19_L      0x336832
#define REG_BK3368_19_H      0x336833
#define REG_BK3368_1A_L      0x336834
#define REG_BK3368_1A_H      0x336835
#define REG_BK3368_1B_L      0x336836
#define REG_BK3368_1B_H      0x336837
#define REG_BK3368_1C_L      0x336838
#define REG_BK3368_1C_H      0x336839
#define REG_BK3368_1D_L      0x33683A
#define REG_BK3368_1D_H      0x33683B
#define REG_BK3368_1E_L      0x33683C
#define REG_BK3368_1E_H      0x33683D
#define REG_BK3368_1F_L      0x33683E
#define REG_BK3368_1F_H      0x33683F
#define REG_BK3368_20_L      0x336840
#define REG_BK3368_20_H      0x336841
#define REG_BK3368_21_L      0x336842
#define REG_BK3368_21_H      0x336843
#define REG_BK3368_22_L      0x336844
#define REG_BK3368_22_H      0x336845
#define REG_BK3368_23_L      0x336846
#define REG_BK3368_23_H      0x336847
#define REG_BK3368_24_L      0x336848
#define REG_BK3368_24_H      0x336849
#define REG_BK3368_25_L      0x33684A
#define REG_BK3368_25_H      0x33684B
#define REG_BK3368_26_L      0x33684C
#define REG_BK3368_26_H      0x33684D
#define REG_BK3368_27_L      0x33684E
#define REG_BK3368_27_H      0x33684F
#define REG_BK3368_28_L      0x336850
#define REG_BK3368_28_H      0x336851
#define REG_BK3368_29_L      0x336852
#define REG_BK3368_29_H      0x336853
#define REG_BK3368_2A_L      0x336854
#define REG_BK3368_2A_H      0x336855
#define REG_BK3368_2B_L      0x336856
#define REG_BK3368_2B_H      0x336857
#define REG_BK3368_2C_L      0x336858
#define REG_BK3368_2C_H      0x336859
#define REG_BK3368_2D_L      0x33685A
#define REG_BK3368_2D_H      0x33685B
#define REG_BK3368_2E_L      0x33685C
#define REG_BK3368_2E_H      0x33685D
#define REG_BK3368_2F_L      0x33685E
#define REG_BK3368_2F_H      0x33685F
#define REG_BK3368_30_L      0x336860
#define REG_BK3368_30_H      0x336861
#define REG_BK3368_31_L      0x336862
#define REG_BK3368_31_H      0x336863
#define REG_BK3368_32_L      0x336864
#define REG_BK3368_32_H      0x336865
#define REG_BK3368_33_L      0x336866
#define REG_BK3368_33_H      0x336867
#define REG_BK3368_34_L      0x336868
#define REG_BK3368_34_H      0x336869
#define REG_BK3368_35_L      0x33686A
#define REG_BK3368_35_H      0x33686B
#define REG_BK3368_36_L      0x33686C
#define REG_BK3368_36_H      0x33686D
#define REG_BK3368_37_L      0x33686E
#define REG_BK3368_37_H      0x33686F
#define REG_BK3368_38_L      0x336870
#define REG_BK3368_38_H      0x336871
#define REG_BK3368_39_L      0x336872
#define REG_BK3368_39_H      0x336873
#define REG_BK3368_3A_L      0x336874
#define REG_BK3368_3A_H      0x336875
#define REG_BK3368_3B_L      0x336876
#define REG_BK3368_3B_H      0x336877
#define REG_BK3368_3C_L      0x336878
#define REG_BK3368_3C_H      0x336879
#define REG_BK3368_3D_L      0x33687A
#define REG_BK3368_3D_H      0x33687B
#define REG_BK3368_3E_L      0x33687C
#define REG_BK3368_3E_H      0x33687D
#define REG_BK3368_3F_L      0x33687E
#define REG_BK3368_3F_H      0x33687F
#define REG_BK3368_40_L      0x336880
#define REG_BK3368_40_H      0x336881
#define REG_BK3368_41_L      0x336882
#define REG_BK3368_41_H      0x336883
#define REG_BK3368_42_L      0x336884
#define REG_BK3368_42_H      0x336885
#define REG_BK3368_43_L      0x336886
#define REG_BK3368_43_H      0x336887
#define REG_BK3368_44_L      0x336888
#define REG_BK3368_44_H      0x336889
#define REG_BK3368_45_L      0x33688A
#define REG_BK3368_45_H      0x33688B
#define REG_BK3368_46_L      0x33688C
#define REG_BK3368_46_H      0x33688D
#define REG_BK3368_47_L      0x33688E
#define REG_BK3368_47_H      0x33688F
#define REG_BK3368_48_L      0x336890
#define REG_BK3368_48_H      0x336891
#define REG_BK3368_49_L      0x336892
#define REG_BK3368_49_H      0x336893
#define REG_BK3368_4A_L      0x336894
#define REG_BK3368_4A_H      0x336895
#define REG_BK3368_4B_L      0x336896
#define REG_BK3368_4B_H      0x336897
#define REG_BK3368_4C_L      0x336898
#define REG_BK3368_4C_H      0x336899
#define REG_BK3368_4D_L      0x33689A
#define REG_BK3368_4D_H      0x33689B
#define REG_BK3368_4E_L      0x33689C
#define REG_BK3368_4E_H      0x33689D
#define REG_BK3368_4F_L      0x33689E
#define REG_BK3368_4F_H      0x33689F
#define REG_BK3368_50_L      0x3368A0
#define REG_BK3368_50_H      0x3368A1
#define REG_BK3368_51_L      0x3368A2
#define REG_BK3368_51_H      0x3368A3
#define REG_BK3368_52_L      0x3368A4
#define REG_BK3368_52_H      0x3368A5
#define REG_BK3368_53_L      0x3368A6
#define REG_BK3368_53_H      0x3368A7
#define REG_BK3368_54_L      0x3368A8
#define REG_BK3368_54_H      0x3368A9
#define REG_BK3368_55_L      0x3368AA
#define REG_BK3368_55_H      0x3368AB
#define REG_BK3368_56_L      0x3368AC
#define REG_BK3368_56_H      0x3368AD
#define REG_BK3368_57_L      0x3368AE
#define REG_BK3368_57_H      0x3368AF
#define REG_BK3368_58_L      0x3368B0
#define REG_BK3368_58_H      0x3368B1
#define REG_BK3368_59_L      0x3368B2
#define REG_BK3368_59_H      0x3368B3
#define REG_BK3368_5A_L      0x3368B4
#define REG_BK3368_5A_H      0x3368B5
#define REG_BK3368_5B_L      0x3368B6
#define REG_BK3368_5B_H      0x3368B7
#define REG_BK3368_5C_L      0x3368B8
#define REG_BK3368_5C_H      0x3368B9
#define REG_BK3368_5D_L      0x3368BA
#define REG_BK3368_5D_H      0x3368BB
#define REG_BK3368_5E_L      0x3368BC
#define REG_BK3368_5E_H      0x3368BD
#define REG_BK3368_5F_L      0x3368BE
#define REG_BK3368_5F_H      0x3368BF
#define REG_BK3368_60_L      0x3368C0
#define REG_BK3368_60_H      0x3368C1
#define REG_BK3368_61_L      0x3368C2
#define REG_BK3368_61_H      0x3368C3
#define REG_BK3368_62_L      0x3368C4
#define REG_BK3368_62_H      0x3368C5
#define REG_BK3368_63_L      0x3368C6
#define REG_BK3368_63_H      0x3368C7
#define REG_BK3368_64_L      0x3368C8
#define REG_BK3368_64_H      0x3368C9
#define REG_BK3368_65_L      0x3368CA
#define REG_BK3368_65_H      0x3368CB
#define REG_BK3368_66_L      0x3368CC
#define REG_BK3368_66_H      0x3368CD
#define REG_BK3368_67_L      0x3368CE
#define REG_BK3368_67_H      0x3368CF
#define REG_BK3368_68_L      0x3368D0
#define REG_BK3368_68_H      0x3368D1
#define REG_BK3368_69_L      0x3368D2
#define REG_BK3368_69_H      0x3368D3
#define REG_BK3368_6A_L      0x3368D4
#define REG_BK3368_6A_H      0x3368D5
#define REG_BK3368_6B_L      0x3368D6
#define REG_BK3368_6B_H      0x3368D7
#define REG_BK3368_6C_L      0x3368D8
#define REG_BK3368_6C_H      0x3368D9
#define REG_BK3368_6D_L      0x3368DA
#define REG_BK3368_6D_H      0x3368DB
#define REG_BK3368_6E_L      0x3368DC
#define REG_BK3368_6E_H      0x3368DD
#define REG_BK3368_6F_L      0x3368DE
#define REG_BK3368_6F_H      0x3368DF
#define REG_BK3368_70_L      0x3368E0
#define REG_BK3368_70_H      0x3368E1
#define REG_BK3368_71_L      0x3368E2
#define REG_BK3368_71_H      0x3368E3
#define REG_BK3368_72_L      0x3368E4
#define REG_BK3368_72_H      0x3368E5
#define REG_BK3368_73_L      0x3368E6
#define REG_BK3368_73_H      0x3368E7
#define REG_BK3368_74_L      0x3368E8
#define REG_BK3368_74_H      0x3368E9
#define REG_BK3368_75_L      0x3368EA
#define REG_BK3368_75_H      0x3368EB
#define REG_BK3368_76_L      0x3368EC
#define REG_BK3368_76_H      0x3368ED
#define REG_BK3368_77_L      0x3368EE
#define REG_BK3368_77_H      0x3368EF
#define REG_BK3368_78_L      0x3368F0
#define REG_BK3368_78_H      0x3368F1
#define REG_BK3368_79_L      0x3368F2
#define REG_BK3368_79_H      0x3368F3
#define REG_BK3368_7A_L      0x3368F4
#define REG_BK3368_7A_H      0x3368F5
#define REG_BK3368_7B_L      0x3368F6
#define REG_BK3368_7B_H      0x3368F7
#define REG_BK3368_7C_L      0x3368F8
#define REG_BK3368_7C_H      0x3368F9
#define REG_BK3368_7D_L      0x3368FA
#define REG_BK3368_7D_H      0x3368FB
#define REG_BK3368_7E_L      0x3368FC
#define REG_BK3368_7E_H      0x3368FD
#define REG_BK3368_7F_L      0x3368FE
#define REG_BK3368_7F_H      0x3368FF
//----------------------------------------------
#define REG_BK336B_00_L      0x336B00
#define REG_BK336B_00_H      0x336B01
#define REG_BK336B_01_L      0x336B02
#define REG_BK336B_01_H      0x336B03
#define REG_BK336B_02_L      0x336B04
#define REG_BK336B_02_H      0x336B05
#define REG_BK336B_03_L      0x336B06
#define REG_BK336B_03_H      0x336B07
#define REG_BK336B_04_L      0x336B08
#define REG_BK336B_04_H      0x336B09
#define REG_BK336B_05_L      0x336B0A
#define REG_BK336B_05_H      0x336B0B
#define REG_BK336B_06_L      0x336B0C
#define REG_BK336B_06_H      0x336B0D
#define REG_BK336B_07_L      0x336B0E
#define REG_BK336B_07_H      0x336B0F
#define REG_BK336B_08_L      0x336B10
#define REG_BK336B_08_H      0x336B11
#define REG_BK336B_09_L      0x336B12
#define REG_BK336B_09_H      0x336B13
#define REG_BK336B_0A_L      0x336B14
#define REG_BK336B_0A_H      0x336B15
#define REG_BK336B_0B_L      0x336B16
#define REG_BK336B_0B_H      0x336B17
#define REG_BK336B_0C_L      0x336B18
#define REG_BK336B_0C_H      0x336B19
#define REG_BK336B_0D_L      0x336B1A
#define REG_BK336B_0D_H      0x336B1B
#define REG_BK336B_0E_L      0x336B1C
#define REG_BK336B_0E_H      0x336B1D
#define REG_BK336B_0F_L      0x336B1E
#define REG_BK336B_0F_H      0x336B1F
#define REG_BK336B_10_L      0x336B20
#define REG_BK336B_10_H      0x336B21
#define REG_BK336B_11_L      0x336B22
#define REG_BK336B_11_H      0x336B23
#define REG_BK336B_12_L      0x336B24
#define REG_BK336B_12_H      0x336B25
#define REG_BK336B_13_L      0x336B26
#define REG_BK336B_13_H      0x336B27
#define REG_BK336B_14_L      0x336B28
#define REG_BK336B_14_H      0x336B29
#define REG_BK336B_15_L      0x336B2A
#define REG_BK336B_15_H      0x336B2B
#define REG_BK336B_16_L      0x336B2C
#define REG_BK336B_16_H      0x336B2D
#define REG_BK336B_17_L      0x336B2E
#define REG_BK336B_17_H      0x336B2F
#define REG_BK336B_18_L      0x336B30
#define REG_BK336B_18_H      0x336B31
#define REG_BK336B_19_L      0x336B32
#define REG_BK336B_19_H      0x336B33
#define REG_BK336B_1A_L      0x336B34
#define REG_BK336B_1A_H      0x336B35
#define REG_BK336B_1B_L      0x336B36
#define REG_BK336B_1B_H      0x336B37
#define REG_BK336B_1C_L      0x336B38
#define REG_BK336B_1C_H      0x336B39
#define REG_BK336B_1D_L      0x336B3A
#define REG_BK336B_1D_H      0x336B3B
#define REG_BK336B_1E_L      0x336B3C
#define REG_BK336B_1E_H      0x336B3D
#define REG_BK336B_1F_L      0x336B3E
#define REG_BK336B_1F_H      0x336B3F
#define REG_BK336B_20_L      0x336B40
#define REG_BK336B_20_H      0x336B41
#define REG_BK336B_21_L      0x336B42
#define REG_BK336B_21_H      0x336B43
#define REG_BK336B_22_L      0x336B44
#define REG_BK336B_22_H      0x336B45
#define REG_BK336B_23_L      0x336B46
#define REG_BK336B_23_H      0x336B47
#define REG_BK336B_24_L      0x336B48
#define REG_BK336B_24_H      0x336B49
#define REG_BK336B_25_L      0x336B4A
#define REG_BK336B_25_H      0x336B4B
#define REG_BK336B_26_L      0x336B4C
#define REG_BK336B_26_H      0x336B4D
#define REG_BK336B_27_L      0x336B4E
#define REG_BK336B_27_H      0x336B4F
#define REG_BK336B_28_L      0x336B50
#define REG_BK336B_28_H      0x336B51
#define REG_BK336B_29_L      0x336B52
#define REG_BK336B_29_H      0x336B53
#define REG_BK336B_2A_L      0x336B54
#define REG_BK336B_2A_H      0x336B55
#define REG_BK336B_2B_L      0x336B56
#define REG_BK336B_2B_H      0x336B57
#define REG_BK336B_2C_L      0x336B58
#define REG_BK336B_2C_H      0x336B59
#define REG_BK336B_2D_L      0x336B5A
#define REG_BK336B_2D_H      0x336B5B
#define REG_BK336B_2E_L      0x336B5C
#define REG_BK336B_2E_H      0x336B5D
#define REG_BK336B_2F_L      0x336B5E
#define REG_BK336B_2F_H      0x336B5F
#define REG_BK336B_30_L      0x336B60
#define REG_BK336B_30_H      0x336B61
#define REG_BK336B_31_L      0x336B62
#define REG_BK336B_31_H      0x336B63
#define REG_BK336B_32_L      0x336B64
#define REG_BK336B_32_H      0x336B65
#define REG_BK336B_33_L      0x336B66
#define REG_BK336B_33_H      0x336B67
#define REG_BK336B_34_L      0x336B68
#define REG_BK336B_34_H      0x336B69
#define REG_BK336B_35_L      0x336B6A
#define REG_BK336B_35_H      0x336B6B
#define REG_BK336B_36_L      0x336B6C
#define REG_BK336B_36_H      0x336B6D
#define REG_BK336B_37_L      0x336B6E
#define REG_BK336B_37_H      0x336B6F
#define REG_BK336B_38_L      0x336B70
#define REG_BK336B_38_H      0x336B71
#define REG_BK336B_39_L      0x336B72
#define REG_BK336B_39_H      0x336B73
#define REG_BK336B_3A_L      0x336B74
#define REG_BK336B_3A_H      0x336B75
#define REG_BK336B_3B_L      0x336B76
#define REG_BK336B_3B_H      0x336B77
#define REG_BK336B_3C_L      0x336B78
#define REG_BK336B_3C_H      0x336B79
#define REG_BK336B_3D_L      0x336B7A
#define REG_BK336B_3D_H      0x336B7B
#define REG_BK336B_3E_L      0x336B7C
#define REG_BK336B_3E_H      0x336B7D
#define REG_BK336B_3F_L      0x336B7E
#define REG_BK336B_3F_H      0x336B7F
#define REG_BK336B_40_L      0x336B80
#define REG_BK336B_40_H      0x336B81
#define REG_BK336B_41_L      0x336B82
#define REG_BK336B_41_H      0x336B83
#define REG_BK336B_42_L      0x336B84
#define REG_BK336B_42_H      0x336B85
#define REG_BK336B_43_L      0x336B86
#define REG_BK336B_43_H      0x336B87
#define REG_BK336B_44_L      0x336B88
#define REG_BK336B_44_H      0x336B89
#define REG_BK336B_45_L      0x336B8A
#define REG_BK336B_45_H      0x336B8B
#define REG_BK336B_46_L      0x336B8C
#define REG_BK336B_46_H      0x336B8D
#define REG_BK336B_47_L      0x336B8E
#define REG_BK336B_47_H      0x336B8F
#define REG_BK336B_48_L      0x336B90
#define REG_BK336B_48_H      0x336B91
#define REG_BK336B_49_L      0x336B92
#define REG_BK336B_49_H      0x336B93
#define REG_BK336B_4A_L      0x336B94
#define REG_BK336B_4A_H      0x336B95
#define REG_BK336B_4B_L      0x336B96
#define REG_BK336B_4B_H      0x336B97
#define REG_BK336B_4C_L      0x336B98
#define REG_BK336B_4C_H      0x336B99
#define REG_BK336B_4D_L      0x336B9A
#define REG_BK336B_4D_H      0x336B9B
#define REG_BK336B_4E_L      0x336B9C
#define REG_BK336B_4E_H      0x336B9D
#define REG_BK336B_4F_L      0x336B9E
#define REG_BK336B_4F_H      0x336B9F
#define REG_BK336B_50_L      0x336BA0
#define REG_BK336B_50_H      0x336BA1
#define REG_BK336B_51_L      0x336BA2
#define REG_BK336B_51_H      0x336BA3
#define REG_BK336B_52_L      0x336BA4
#define REG_BK336B_52_H      0x336BA5
#define REG_BK336B_53_L      0x336BA6
#define REG_BK336B_53_H      0x336BA7
#define REG_BK336B_54_L      0x336BA8
#define REG_BK336B_54_H      0x336BA9
#define REG_BK336B_55_L      0x336BAA
#define REG_BK336B_55_H      0x336BAB
#define REG_BK336B_56_L      0x336BAC
#define REG_BK336B_56_H      0x336BAD
#define REG_BK336B_57_L      0x336BAE
#define REG_BK336B_57_H      0x336BAF
#define REG_BK336B_58_L      0x336BB0
#define REG_BK336B_58_H      0x336BB1
#define REG_BK336B_59_L      0x336BB2
#define REG_BK336B_59_H      0x336BB3
#define REG_BK336B_5A_L      0x336BB4
#define REG_BK336B_5A_H      0x336BB5
#define REG_BK336B_5B_L      0x336BB6
#define REG_BK336B_5B_H      0x336BB7
#define REG_BK336B_5C_L      0x336BB8
#define REG_BK336B_5C_H      0x336BB9
#define REG_BK336B_5D_L      0x336BBA
#define REG_BK336B_5D_H      0x336BBB
#define REG_BK336B_5E_L      0x336BBC
#define REG_BK336B_5E_H      0x336BBD
#define REG_BK336B_5F_L      0x336BBE
#define REG_BK336B_5F_H      0x336BBF
#define REG_BK336B_60_L      0x336BC0
#define REG_BK336B_60_H      0x336BC1
#define REG_BK336B_61_L      0x336BC2
#define REG_BK336B_61_H      0x336BC3
#define REG_BK336B_62_L      0x336BC4
#define REG_BK336B_62_H      0x336BC5
#define REG_BK336B_63_L      0x336BC6
#define REG_BK336B_63_H      0x336BC7
#define REG_BK336B_64_L      0x336BC8
#define REG_BK336B_64_H      0x336BC9
#define REG_BK336B_65_L      0x336BCA
#define REG_BK336B_65_H      0x336BCB
#define REG_BK336B_66_L      0x336BCC
#define REG_BK336B_66_H      0x336BCD
#define REG_BK336B_67_L      0x336BCE
#define REG_BK336B_67_H      0x336BCF
#define REG_BK336B_68_L      0x336BD0
#define REG_BK336B_68_H      0x336BD1
#define REG_BK336B_69_L      0x336BD2
#define REG_BK336B_69_H      0x336BD3
#define REG_BK336B_6A_L      0x336BD4
#define REG_BK336B_6A_H      0x336BD5
#define REG_BK336B_6B_L      0x336BD6
#define REG_BK336B_6B_H      0x336BD7
#define REG_BK336B_6C_L      0x336BD8
#define REG_BK336B_6C_H      0x336BD9
#define REG_BK336B_6D_L      0x336BDA
#define REG_BK336B_6D_H      0x336BDB
#define REG_BK336B_6E_L      0x336BDC
#define REG_BK336B_6E_H      0x336BDD
#define REG_BK336B_6F_L      0x336BDE
#define REG_BK336B_6F_H      0x336BDF
#define REG_BK336B_70_L      0x336BE0
#define REG_BK336B_70_H      0x336BE1
#define REG_BK336B_71_L      0x336BE2
#define REG_BK336B_71_H      0x336BE3
#define REG_BK336B_72_L      0x336BE4
#define REG_BK336B_72_H      0x336BE5
#define REG_BK336B_73_L      0x336BE6
#define REG_BK336B_73_H      0x336BE7
#define REG_BK336B_74_L      0x336BE8
#define REG_BK336B_74_H      0x336BE9
#define REG_BK336B_75_L      0x336BEA
#define REG_BK336B_75_H      0x336BEB
#define REG_BK336B_76_L      0x336BEC
#define REG_BK336B_76_H      0x336BED
#define REG_BK336B_77_L      0x336BEE
#define REG_BK336B_77_H      0x336BEF
#define REG_BK336B_78_L      0x336BF0
#define REG_BK336B_78_H      0x336BF1
#define REG_BK336B_79_L      0x336BF2
#define REG_BK336B_79_H      0x336BF3
#define REG_BK336B_7A_L      0x336BF4
#define REG_BK336B_7A_H      0x336BF5
#define REG_BK336B_7B_L      0x336BF6
#define REG_BK336B_7B_H      0x336BF7
#define REG_BK336B_7C_L      0x336BF8
#define REG_BK336B_7C_H      0x336BF9
#define REG_BK336B_7D_L      0x336BFA
#define REG_BK336B_7D_H      0x336BFB
#define REG_BK336B_7E_L      0x336BFC
#define REG_BK336B_7E_H      0x336BFD
#define REG_BK336B_7F_L      0x336BFE
#define REG_BK336B_7F_H      0x336BFF
//----------------------------------------------
#define REG_BK336D_00_L      0x336D00
#define REG_BK336D_00_H      0x336D01
#define REG_BK336D_01_L      0x336D02
#define REG_BK336D_01_H      0x336D03
#define REG_BK336D_02_L      0x336D04
#define REG_BK336D_02_H      0x336D05
#define REG_BK336D_03_L      0x336D06
#define REG_BK336D_03_H      0x336D07
#define REG_BK336D_04_L      0x336D08
#define REG_BK336D_04_H      0x336D09
#define REG_BK336D_05_L      0x336D0A
#define REG_BK336D_05_H      0x336D0B
#define REG_BK336D_06_L      0x336D0C
#define REG_BK336D_06_H      0x336D0D
#define REG_BK336D_07_L      0x336D0E
#define REG_BK336D_07_H      0x336D0F
#define REG_BK336D_08_L      0x336D10
#define REG_BK336D_08_H      0x336D11
#define REG_BK336D_09_L      0x336D12
#define REG_BK336D_09_H      0x336D13
#define REG_BK336D_0A_L      0x336D14
#define REG_BK336D_0A_H      0x336D15
#define REG_BK336D_0B_L      0x336D16
#define REG_BK336D_0B_H      0x336D17
#define REG_BK336D_0C_L      0x336D18
#define REG_BK336D_0C_H      0x336D19
#define REG_BK336D_0D_L      0x336D1A
#define REG_BK336D_0D_H      0x336D1B
#define REG_BK336D_0E_L      0x336D1C
#define REG_BK336D_0E_H      0x336D1D
#define REG_BK336D_0F_L      0x336D1E
#define REG_BK336D_0F_H      0x336D1F
#define REG_BK336D_10_L      0x336D20
#define REG_BK336D_10_H      0x336D21
#define REG_BK336D_11_L      0x336D22
#define REG_BK336D_11_H      0x336D23
#define REG_BK336D_12_L      0x336D24
#define REG_BK336D_12_H      0x336D25
#define REG_BK336D_13_L      0x336D26
#define REG_BK336D_13_H      0x336D27
#define REG_BK336D_14_L      0x336D28
#define REG_BK336D_14_H      0x336D29
#define REG_BK336D_15_L      0x336D2A
#define REG_BK336D_15_H      0x336D2B
#define REG_BK336D_16_L      0x336D2C
#define REG_BK336D_16_H      0x336D2D
#define REG_BK336D_17_L      0x336D2E
#define REG_BK336D_17_H      0x336D2F
#define REG_BK336D_18_L      0x336D30
#define REG_BK336D_18_H      0x336D31
#define REG_BK336D_19_L      0x336D32
#define REG_BK336D_19_H      0x336D33
#define REG_BK336D_1A_L      0x336D34
#define REG_BK336D_1A_H      0x336D35
#define REG_BK336D_1B_L      0x336D36
#define REG_BK336D_1B_H      0x336D37
#define REG_BK336D_1C_L      0x336D38
#define REG_BK336D_1C_H      0x336D39
#define REG_BK336D_1D_L      0x336D3A
#define REG_BK336D_1D_H      0x336D3B
#define REG_BK336D_1E_L      0x336D3C
#define REG_BK336D_1E_H      0x336D3D
#define REG_BK336D_1F_L      0x336D3E
#define REG_BK336D_1F_H      0x336D3F
#define REG_BK336D_20_L      0x336D40
#define REG_BK336D_20_H      0x336D41
#define REG_BK336D_21_L      0x336D42
#define REG_BK336D_21_H      0x336D43
#define REG_BK336D_22_L      0x336D44
#define REG_BK336D_22_H      0x336D45
#define REG_BK336D_23_L      0x336D46
#define REG_BK336D_23_H      0x336D47
#define REG_BK336D_24_L      0x336D48
#define REG_BK336D_24_H      0x336D49
#define REG_BK336D_25_L      0x336D4A
#define REG_BK336D_25_H      0x336D4B
#define REG_BK336D_26_L      0x336D4C
#define REG_BK336D_26_H      0x336D4D
#define REG_BK336D_27_L      0x336D4E
#define REG_BK336D_27_H      0x336D4F
#define REG_BK336D_28_L      0x336D50
#define REG_BK336D_28_H      0x336D51
#define REG_BK336D_29_L      0x336D52
#define REG_BK336D_29_H      0x336D53
#define REG_BK336D_2A_L      0x336D54
#define REG_BK336D_2A_H      0x336D55
#define REG_BK336D_2B_L      0x336D56
#define REG_BK336D_2B_H      0x336D57
#define REG_BK336D_2C_L      0x336D58
#define REG_BK336D_2C_H      0x336D59
#define REG_BK336D_2D_L      0x336D5A
#define REG_BK336D_2D_H      0x336D5B
#define REG_BK336D_2E_L      0x336D5C
#define REG_BK336D_2E_H      0x336D5D
#define REG_BK336D_2F_L      0x336D5E
#define REG_BK336D_2F_H      0x336D5F
#define REG_BK336D_30_L      0x336D60
#define REG_BK336D_30_H      0x336D61
#define REG_BK336D_31_L      0x336D62
#define REG_BK336D_31_H      0x336D63
#define REG_BK336D_32_L      0x336D64
#define REG_BK336D_32_H      0x336D65
#define REG_BK336D_33_L      0x336D66
#define REG_BK336D_33_H      0x336D67
#define REG_BK336D_34_L      0x336D68
#define REG_BK336D_34_H      0x336D69
#define REG_BK336D_35_L      0x336D6A
#define REG_BK336D_35_H      0x336D6B
#define REG_BK336D_36_L      0x336D6C
#define REG_BK336D_36_H      0x336D6D
#define REG_BK336D_37_L      0x336D6E
#define REG_BK336D_37_H      0x336D6F
#define REG_BK336D_38_L      0x336D70
#define REG_BK336D_38_H      0x336D71
#define REG_BK336D_39_L      0x336D72
#define REG_BK336D_39_H      0x336D73
#define REG_BK336D_3A_L      0x336D74
#define REG_BK336D_3A_H      0x336D75
#define REG_BK336D_3B_L      0x336D76
#define REG_BK336D_3B_H      0x336D77
#define REG_BK336D_3C_L      0x336D78
#define REG_BK336D_3C_H      0x336D79
#define REG_BK336D_3D_L      0x336D7A
#define REG_BK336D_3D_H      0x336D7B
#define REG_BK336D_3E_L      0x336D7C
#define REG_BK336D_3E_H      0x336D7D
#define REG_BK336D_3F_L      0x336D7E
#define REG_BK336D_3F_H      0x336D7F
#define REG_BK336D_40_L      0x336D80
#define REG_BK336D_40_H      0x336D81
#define REG_BK336D_41_L      0x336D82
#define REG_BK336D_41_H      0x336D83
#define REG_BK336D_42_L      0x336D84
#define REG_BK336D_42_H      0x336D85
#define REG_BK336D_43_L      0x336D86
#define REG_BK336D_43_H      0x336D87
#define REG_BK336D_44_L      0x336D88
#define REG_BK336D_44_H      0x336D89
#define REG_BK336D_45_L      0x336D8A
#define REG_BK336D_45_H      0x336D8B
#define REG_BK336D_46_L      0x336D8C
#define REG_BK336D_46_H      0x336D8D
#define REG_BK336D_47_L      0x336D8E
#define REG_BK336D_47_H      0x336D8F
#define REG_BK336D_48_L      0x336D90
#define REG_BK336D_48_H      0x336D91
#define REG_BK336D_49_L      0x336D92
#define REG_BK336D_49_H      0x336D93
#define REG_BK336D_4A_L      0x336D94
#define REG_BK336D_4A_H      0x336D95
#define REG_BK336D_4B_L      0x336D96
#define REG_BK336D_4B_H      0x336D97
#define REG_BK336D_4C_L      0x336D98
#define REG_BK336D_4C_H      0x336D99
#define REG_BK336D_4D_L      0x336D9A
#define REG_BK336D_4D_H      0x336D9B
#define REG_BK336D_4E_L      0x336D9C
#define REG_BK336D_4E_H      0x336D9D
#define REG_BK336D_4F_L      0x336D9E
#define REG_BK336D_4F_H      0x336D9F
#define REG_BK336D_50_L      0x336DA0
#define REG_BK336D_50_H      0x336DA1
#define REG_BK336D_51_L      0x336DA2
#define REG_BK336D_51_H      0x336DA3
#define REG_BK336D_52_L      0x336DA4
#define REG_BK336D_52_H      0x336DA5
#define REG_BK336D_53_L      0x336DA6
#define REG_BK336D_53_H      0x336DA7
#define REG_BK336D_54_L      0x336DA8
#define REG_BK336D_54_H      0x336DA9
#define REG_BK336D_55_L      0x336DAA
#define REG_BK336D_55_H      0x336DAB
#define REG_BK336D_56_L      0x336DAC
#define REG_BK336D_56_H      0x336DAD
#define REG_BK336D_57_L      0x336DAE
#define REG_BK336D_57_H      0x336DAF
#define REG_BK336D_58_L      0x336DB0
#define REG_BK336D_58_H      0x336DB1
#define REG_BK336D_59_L      0x336DB2
#define REG_BK336D_59_H      0x336DB3
#define REG_BK336D_5A_L      0x336DB4
#define REG_BK336D_5A_H      0x336DB5
#define REG_BK336D_5B_L      0x336DB6
#define REG_BK336D_5B_H      0x336DB7
#define REG_BK336D_5C_L      0x336DB8
#define REG_BK336D_5C_H      0x336DB9
#define REG_BK336D_5D_L      0x336DBA
#define REG_BK336D_5D_H      0x336DBB
#define REG_BK336D_5E_L      0x336DBC
#define REG_BK336D_5E_H      0x336DBD
#define REG_BK336D_5F_L      0x336DBE
#define REG_BK336D_5F_H      0x336DBF
#define REG_BK336D_60_L      0x336DC0
#define REG_BK336D_60_H      0x336DC1
#define REG_BK336D_61_L      0x336DC2
#define REG_BK336D_61_H      0x336DC3
#define REG_BK336D_62_L      0x336DC4
#define REG_BK336D_62_H      0x336DC5
#define REG_BK336D_63_L      0x336DC6
#define REG_BK336D_63_H      0x336DC7
#define REG_BK336D_64_L      0x336DC8
#define REG_BK336D_64_H      0x336DC9
#define REG_BK336D_65_L      0x336DCA
#define REG_BK336D_65_H      0x336DCB
#define REG_BK336D_66_L      0x336DCC
#define REG_BK336D_66_H      0x336DCD
#define REG_BK336D_67_L      0x336DCE
#define REG_BK336D_67_H      0x336DCF
#define REG_BK336D_68_L      0x336DD0
#define REG_BK336D_68_H      0x336DD1
#define REG_BK336D_69_L      0x336DD2
#define REG_BK336D_69_H      0x336DD3
#define REG_BK336D_6A_L      0x336DD4
#define REG_BK336D_6A_H      0x336DD5
#define REG_BK336D_6B_L      0x336DD6
#define REG_BK336D_6B_H      0x336DD7
#define REG_BK336D_6C_L      0x336DD8
#define REG_BK336D_6C_H      0x336DD9
#define REG_BK336D_6D_L      0x336DDA
#define REG_BK336D_6D_H      0x336DDB
#define REG_BK336D_6E_L      0x336DDC
#define REG_BK336D_6E_H      0x336DDD
#define REG_BK336D_6F_L      0x336DDE
#define REG_BK336D_6F_H      0x336DDF
#define REG_BK336D_70_L      0x336DE0
#define REG_BK336D_70_H      0x336DE1
#define REG_BK336D_71_L      0x336DE2
#define REG_BK336D_71_H      0x336DE3
#define REG_BK336D_72_L      0x336DE4
#define REG_BK336D_72_H      0x336DE5
#define REG_BK336D_73_L      0x336DE6
#define REG_BK336D_73_H      0x336DE7
#define REG_BK336D_74_L      0x336DE8
#define REG_BK336D_74_H      0x336DE9
#define REG_BK336D_75_L      0x336DEA
#define REG_BK336D_75_H      0x336DEB
#define REG_BK336D_76_L      0x336DEC
#define REG_BK336D_76_H      0x336DED
#define REG_BK336D_77_L      0x336DEE
#define REG_BK336D_77_H      0x336DEF
#define REG_BK336D_78_L      0x336DF0
#define REG_BK336D_78_H      0x336DF1
#define REG_BK336D_79_L      0x336DF2
#define REG_BK336D_79_H      0x336DF3
#define REG_BK336D_7A_L      0x336DF4
#define REG_BK336D_7A_H      0x336DF5
#define REG_BK336D_7B_L      0x336DF6
#define REG_BK336D_7B_H      0x336DF7
#define REG_BK336D_7C_L      0x336DF8
#define REG_BK336D_7C_H      0x336DF9
#define REG_BK336D_7D_L      0x336DFA
#define REG_BK336D_7D_H      0x336DFB
#define REG_BK336D_7E_L      0x336DFC
#define REG_BK336D_7E_H      0x336DFD
#define REG_BK336D_7F_L      0x336DFE
#define REG_BK336D_7F_H      0x336DFF
//----------------------------------------------
#define REG_BK3380_00_L      0x338000
#define REG_BK3380_00_H      0x338001
#define REG_BK3380_01_L      0x338002
#define REG_BK3380_01_H      0x338003
#define REG_BK3380_02_L      0x338004
#define REG_BK3380_02_H      0x338005
#define REG_BK3380_03_L      0x338006
#define REG_BK3380_03_H      0x338007
#define REG_BK3380_04_L      0x338008
#define REG_BK3380_04_H      0x338009
#define REG_BK3380_05_L      0x33800A
#define REG_BK3380_05_H      0x33800B
#define REG_BK3380_06_L      0x33800C
#define REG_BK3380_06_H      0x33800D
#define REG_BK3380_07_L      0x33800E
#define REG_BK3380_07_H      0x33800F
#define REG_BK3380_08_L      0x338010
#define REG_BK3380_08_H      0x338011
#define REG_BK3380_09_L      0x338012
#define REG_BK3380_09_H      0x338013
#define REG_BK3380_0A_L      0x338014
#define REG_BK3380_0A_H      0x338015
#define REG_BK3380_0B_L      0x338016
#define REG_BK3380_0B_H      0x338017
#define REG_BK3380_0C_L      0x338018
#define REG_BK3380_0C_H      0x338019
#define REG_BK3380_0D_L      0x33801A
#define REG_BK3380_0D_H      0x33801B
#define REG_BK3380_0E_L      0x33801C
#define REG_BK3380_0E_H      0x33801D
#define REG_BK3380_0F_L      0x33801E
#define REG_BK3380_0F_H      0x33801F
#define REG_BK3380_10_L      0x338020
#define REG_BK3380_10_H      0x338021
#define REG_BK3380_11_L      0x338022
#define REG_BK3380_11_H      0x338023
#define REG_BK3380_12_L      0x338024
#define REG_BK3380_12_H      0x338025
#define REG_BK3380_13_L      0x338026
#define REG_BK3380_13_H      0x338027
#define REG_BK3380_14_L      0x338028
#define REG_BK3380_14_H      0x338029
#define REG_BK3380_15_L      0x33802A
#define REG_BK3380_15_H      0x33802B
#define REG_BK3380_16_L      0x33802C
#define REG_BK3380_16_H      0x33802D
#define REG_BK3380_17_L      0x33802E
#define REG_BK3380_17_H      0x33802F
#define REG_BK3380_18_L      0x338030
#define REG_BK3380_18_H      0x338031
#define REG_BK3380_19_L      0x338032
#define REG_BK3380_19_H      0x338033
#define REG_BK3380_1A_L      0x338034
#define REG_BK3380_1A_H      0x338035
#define REG_BK3380_1B_L      0x338036
#define REG_BK3380_1B_H      0x338037
#define REG_BK3380_1C_L      0x338038
#define REG_BK3380_1C_H      0x338039
#define REG_BK3380_1D_L      0x33803A
#define REG_BK3380_1D_H      0x33803B
#define REG_BK3380_1E_L      0x33803C
#define REG_BK3380_1E_H      0x33803D
#define REG_BK3380_1F_L      0x33803E
#define REG_BK3380_1F_H      0x33803F
#define REG_BK3380_20_L      0x338040
#define REG_BK3380_20_H      0x338041
#define REG_BK3380_21_L      0x338042
#define REG_BK3380_21_H      0x338043
#define REG_BK3380_22_L      0x338044
#define REG_BK3380_22_H      0x338045
#define REG_BK3380_23_L      0x338046
#define REG_BK3380_23_H      0x338047
#define REG_BK3380_24_L      0x338048
#define REG_BK3380_24_H      0x338049
#define REG_BK3380_25_L      0x33804A
#define REG_BK3380_25_H      0x33804B
#define REG_BK3380_26_L      0x33804C
#define REG_BK3380_26_H      0x33804D
#define REG_BK3380_27_L      0x33804E
#define REG_BK3380_27_H      0x33804F
#define REG_BK3380_28_L      0x338050
#define REG_BK3380_28_H      0x338051
#define REG_BK3380_29_L      0x338052
#define REG_BK3380_29_H      0x338053
#define REG_BK3380_2A_L      0x338054
#define REG_BK3380_2A_H      0x338055
#define REG_BK3380_2B_L      0x338056
#define REG_BK3380_2B_H      0x338057
#define REG_BK3380_2C_L      0x338058
#define REG_BK3380_2C_H      0x338059
#define REG_BK3380_2D_L      0x33805A
#define REG_BK3380_2D_H      0x33805B
#define REG_BK3380_2E_L      0x33805C
#define REG_BK3380_2E_H      0x33805D
#define REG_BK3380_2F_L      0x33805E
#define REG_BK3380_2F_H      0x33805F
#define REG_BK3380_30_L      0x338060
#define REG_BK3380_30_H      0x338061
#define REG_BK3380_31_L      0x338062
#define REG_BK3380_31_H      0x338063
#define REG_BK3380_32_L      0x338064
#define REG_BK3380_32_H      0x338065
#define REG_BK3380_33_L      0x338066
#define REG_BK3380_33_H      0x338067
#define REG_BK3380_34_L      0x338068
#define REG_BK3380_34_H      0x338069
#define REG_BK3380_35_L      0x33806A
#define REG_BK3380_35_H      0x33806B
#define REG_BK3380_36_L      0x33806C
#define REG_BK3380_36_H      0x33806D
#define REG_BK3380_37_L      0x33806E
#define REG_BK3380_37_H      0x33806F
#define REG_BK3380_38_L      0x338070
#define REG_BK3380_38_H      0x338071
#define REG_BK3380_39_L      0x338072
#define REG_BK3380_39_H      0x338073
#define REG_BK3380_3A_L      0x338074
#define REG_BK3380_3A_H      0x338075
#define REG_BK3380_3B_L      0x338076
#define REG_BK3380_3B_H      0x338077
#define REG_BK3380_3C_L      0x338078
#define REG_BK3380_3C_H      0x338079
#define REG_BK3380_3D_L      0x33807A
#define REG_BK3380_3D_H      0x33807B
#define REG_BK3380_3E_L      0x33807C
#define REG_BK3380_3E_H      0x33807D
#define REG_BK3380_3F_L      0x33807E
#define REG_BK3380_3F_H      0x33807F
#define REG_BK3380_40_L      0x338080
#define REG_BK3380_40_H      0x338081
#define REG_BK3380_41_L      0x338082
#define REG_BK3380_41_H      0x338083
#define REG_BK3380_42_L      0x338084
#define REG_BK3380_42_H      0x338085
#define REG_BK3380_43_L      0x338086
#define REG_BK3380_43_H      0x338087
#define REG_BK3380_44_L      0x338088
#define REG_BK3380_44_H      0x338089
#define REG_BK3380_45_L      0x33808A
#define REG_BK3380_45_H      0x33808B
#define REG_BK3380_46_L      0x33808C
#define REG_BK3380_46_H      0x33808D
#define REG_BK3380_47_L      0x33808E
#define REG_BK3380_47_H      0x33808F
#define REG_BK3380_48_L      0x338090
#define REG_BK3380_48_H      0x338091
#define REG_BK3380_49_L      0x338092
#define REG_BK3380_49_H      0x338093
#define REG_BK3380_4A_L      0x338094
#define REG_BK3380_4A_H      0x338095
#define REG_BK3380_4B_L      0x338096
#define REG_BK3380_4B_H      0x338097
#define REG_BK3380_4C_L      0x338098
#define REG_BK3380_4C_H      0x338099
#define REG_BK3380_4D_L      0x33809A
#define REG_BK3380_4D_H      0x33809B
#define REG_BK3380_4E_L      0x33809C
#define REG_BK3380_4E_H      0x33809D
#define REG_BK3380_4F_L      0x33809E
#define REG_BK3380_4F_H      0x33809F
#define REG_BK3380_50_L      0x3380A0
#define REG_BK3380_50_H      0x3380A1
#define REG_BK3380_51_L      0x3380A2
#define REG_BK3380_51_H      0x3380A3
#define REG_BK3380_52_L      0x3380A4
#define REG_BK3380_52_H      0x3380A5
#define REG_BK3380_53_L      0x3380A6
#define REG_BK3380_53_H      0x3380A7
#define REG_BK3380_54_L      0x3380A8
#define REG_BK3380_54_H      0x3380A9
#define REG_BK3380_55_L      0x3380AA
#define REG_BK3380_55_H      0x3380AB
#define REG_BK3380_56_L      0x3380AC
#define REG_BK3380_56_H      0x3380AD
#define REG_BK3380_57_L      0x3380AE
#define REG_BK3380_57_H      0x3380AF
#define REG_BK3380_58_L      0x3380B0
#define REG_BK3380_58_H      0x3380B1
#define REG_BK3380_59_L      0x3380B2
#define REG_BK3380_59_H      0x3380B3
#define REG_BK3380_5A_L      0x3380B4
#define REG_BK3380_5A_H      0x3380B5
#define REG_BK3380_5B_L      0x3380B6
#define REG_BK3380_5B_H      0x3380B7
#define REG_BK3380_5C_L      0x3380B8
#define REG_BK3380_5C_H      0x3380B9
#define REG_BK3380_5D_L      0x3380BA
#define REG_BK3380_5D_H      0x3380BB
#define REG_BK3380_5E_L      0x3380BC
#define REG_BK3380_5E_H      0x3380BD
#define REG_BK3380_5F_L      0x3380BE
#define REG_BK3380_5F_H      0x3380BF
#define REG_BK3380_60_L      0x3380C0
#define REG_BK3380_60_H      0x3380C1
#define REG_BK3380_61_L      0x3380C2
#define REG_BK3380_61_H      0x3380C3
#define REG_BK3380_62_L      0x3380C4
#define REG_BK3380_62_H      0x3380C5
#define REG_BK3380_63_L      0x3380C6
#define REG_BK3380_63_H      0x3380C7
#define REG_BK3380_64_L      0x3380C8
#define REG_BK3380_64_H      0x3380C9
#define REG_BK3380_65_L      0x3380CA
#define REG_BK3380_65_H      0x3380CB
#define REG_BK3380_66_L      0x3380CC
#define REG_BK3380_66_H      0x3380CD
#define REG_BK3380_67_L      0x3380CE
#define REG_BK3380_67_H      0x3380CF
#define REG_BK3380_68_L      0x3380D0
#define REG_BK3380_68_H      0x3380D1
#define REG_BK3380_69_L      0x3380D2
#define REG_BK3380_69_H      0x3380D3
#define REG_BK3380_6A_L      0x3380D4
#define REG_BK3380_6A_H      0x3380D5
#define REG_BK3380_6B_L      0x3380D6
#define REG_BK3380_6B_H      0x3380D7
#define REG_BK3380_6C_L      0x3380D8
#define REG_BK3380_6C_H      0x3380D9
#define REG_BK3380_6D_L      0x3380DA
#define REG_BK3380_6D_H      0x3380DB
#define REG_BK3380_6E_L      0x3380DC
#define REG_BK3380_6E_H      0x3380DD
#define REG_BK3380_6F_L      0x3380DE
#define REG_BK3380_6F_H      0x3380DF
#define REG_BK3380_70_L      0x3380E0
#define REG_BK3380_70_H      0x3380E1
#define REG_BK3380_71_L      0x3380E2
#define REG_BK3380_71_H      0x3380E3
#define REG_BK3380_72_L      0x3380E4
#define REG_BK3380_72_H      0x3380E5
#define REG_BK3380_73_L      0x3380E6
#define REG_BK3380_73_H      0x3380E7
#define REG_BK3380_74_L      0x3380E8
#define REG_BK3380_74_H      0x3380E9
#define REG_BK3380_75_L      0x3380EA
#define REG_BK3380_75_H      0x3380EB
#define REG_BK3380_76_L      0x3380EC
#define REG_BK3380_76_H      0x3380ED
#define REG_BK3380_77_L      0x3380EE
#define REG_BK3380_77_H      0x3380EF
#define REG_BK3380_78_L      0x3380F0
#define REG_BK3380_78_H      0x3380F1
#define REG_BK3380_79_L      0x3380F2
#define REG_BK3380_79_H      0x3380F3
#define REG_BK3380_7A_L      0x3380F4
#define REG_BK3380_7A_H      0x3380F5
#define REG_BK3380_7B_L      0x3380F6
#define REG_BK3380_7B_H      0x3380F7
#define REG_BK3380_7C_L      0x3380F8
#define REG_BK3380_7C_H      0x3380F9
#define REG_BK3380_7D_L      0x3380FA
#define REG_BK3380_7D_H      0x3380FB
#define REG_BK3380_7E_L      0x3380FC
#define REG_BK3380_7E_H      0x3380FD
#define REG_BK3380_7F_L      0x3380FE
#define REG_BK3380_7F_H      0x3380FF
//----------------------------------------------
#define REG_BK3385_00_L      0x338500
#define REG_BK3385_00_H      0x338501
#define REG_BK3385_01_L      0x338502
#define REG_BK3385_01_H      0x338503
#define REG_BK3385_02_L      0x338504
#define REG_BK3385_02_H      0x338505
#define REG_BK3385_03_L      0x338506
#define REG_BK3385_03_H      0x338507
#define REG_BK3385_04_L      0x338508
#define REG_BK3385_04_H      0x338509
#define REG_BK3385_05_L      0x33850A
#define REG_BK3385_05_H      0x33850B
#define REG_BK3385_06_L      0x33850C
#define REG_BK3385_06_H      0x33850D
#define REG_BK3385_07_L      0x33850E
#define REG_BK3385_07_H      0x33850F
#define REG_BK3385_08_L      0x338510
#define REG_BK3385_08_H      0x338511
#define REG_BK3385_09_L      0x338512
#define REG_BK3385_09_H      0x338513
#define REG_BK3385_0A_L      0x338514
#define REG_BK3385_0A_H      0x338515
#define REG_BK3385_0B_L      0x338516
#define REG_BK3385_0B_H      0x338517
#define REG_BK3385_0C_L      0x338518
#define REG_BK3385_0C_H      0x338519
#define REG_BK3385_0D_L      0x33851A
#define REG_BK3385_0D_H      0x33851B
#define REG_BK3385_0E_L      0x33851C
#define REG_BK3385_0E_H      0x33851D
#define REG_BK3385_0F_L      0x33851E
#define REG_BK3385_0F_H      0x33851F
#define REG_BK3385_10_L      0x338520
#define REG_BK3385_10_H      0x338521
#define REG_BK3385_11_L      0x338522
#define REG_BK3385_11_H      0x338523
#define REG_BK3385_12_L      0x338524
#define REG_BK3385_12_H      0x338525
#define REG_BK3385_13_L      0x338526
#define REG_BK3385_13_H      0x338527
#define REG_BK3385_14_L      0x338528
#define REG_BK3385_14_H      0x338529
#define REG_BK3385_15_L      0x33852A
#define REG_BK3385_15_H      0x33852B
#define REG_BK3385_16_L      0x33852C
#define REG_BK3385_16_H      0x33852D
#define REG_BK3385_17_L      0x33852E
#define REG_BK3385_17_H      0x33852F
#define REG_BK3385_18_L      0x338530
#define REG_BK3385_18_H      0x338531
#define REG_BK3385_19_L      0x338532
#define REG_BK3385_19_H      0x338533
#define REG_BK3385_1A_L      0x338534
#define REG_BK3385_1A_H      0x338535
#define REG_BK3385_1B_L      0x338536
#define REG_BK3385_1B_H      0x338537
#define REG_BK3385_1C_L      0x338538
#define REG_BK3385_1C_H      0x338539
#define REG_BK3385_1D_L      0x33853A
#define REG_BK3385_1D_H      0x33853B
#define REG_BK3385_1E_L      0x33853C
#define REG_BK3385_1E_H      0x33853D
#define REG_BK3385_1F_L      0x33853E
#define REG_BK3385_1F_H      0x33853F
#define REG_BK3385_20_L      0x338540
#define REG_BK3385_20_H      0x338541
#define REG_BK3385_21_L      0x338542
#define REG_BK3385_21_H      0x338543
#define REG_BK3385_22_L      0x338544
#define REG_BK3385_22_H      0x338545
#define REG_BK3385_23_L      0x338546
#define REG_BK3385_23_H      0x338547
#define REG_BK3385_24_L      0x338548
#define REG_BK3385_24_H      0x338549
#define REG_BK3385_25_L      0x33854A
#define REG_BK3385_25_H      0x33854B
#define REG_BK3385_26_L      0x33854C
#define REG_BK3385_26_H      0x33854D
#define REG_BK3385_27_L      0x33854E
#define REG_BK3385_27_H      0x33854F
#define REG_BK3385_28_L      0x338550
#define REG_BK3385_28_H      0x338551
#define REG_BK3385_29_L      0x338552
#define REG_BK3385_29_H      0x338553
#define REG_BK3385_2A_L      0x338554
#define REG_BK3385_2A_H      0x338555
#define REG_BK3385_2B_L      0x338556
#define REG_BK3385_2B_H      0x338557
#define REG_BK3385_2C_L      0x338558
#define REG_BK3385_2C_H      0x338559
#define REG_BK3385_2D_L      0x33855A
#define REG_BK3385_2D_H      0x33855B
#define REG_BK3385_2E_L      0x33855C
#define REG_BK3385_2E_H      0x33855D
#define REG_BK3385_2F_L      0x33855E
#define REG_BK3385_2F_H      0x33855F
#define REG_BK3385_30_L      0x338560
#define REG_BK3385_30_H      0x338561
#define REG_BK3385_31_L      0x338562
#define REG_BK3385_31_H      0x338563
#define REG_BK3385_32_L      0x338564
#define REG_BK3385_32_H      0x338565
#define REG_BK3385_33_L      0x338566
#define REG_BK3385_33_H      0x338567
#define REG_BK3385_34_L      0x338568
#define REG_BK3385_34_H      0x338569
#define REG_BK3385_35_L      0x33856A
#define REG_BK3385_35_H      0x33856B
#define REG_BK3385_36_L      0x33856C
#define REG_BK3385_36_H      0x33856D
#define REG_BK3385_37_L      0x33856E
#define REG_BK3385_37_H      0x33856F
#define REG_BK3385_38_L      0x338570
#define REG_BK3385_38_H      0x338571
#define REG_BK3385_39_L      0x338572
#define REG_BK3385_39_H      0x338573
#define REG_BK3385_3A_L      0x338574
#define REG_BK3385_3A_H      0x338575
#define REG_BK3385_3B_L      0x338576
#define REG_BK3385_3B_H      0x338577
#define REG_BK3385_3C_L      0x338578
#define REG_BK3385_3C_H      0x338579
#define REG_BK3385_3D_L      0x33857A
#define REG_BK3385_3D_H      0x33857B
#define REG_BK3385_3E_L      0x33857C
#define REG_BK3385_3E_H      0x33857D
#define REG_BK3385_3F_L      0x33857E
#define REG_BK3385_3F_H      0x33857F
#define REG_BK3385_40_L      0x338580
#define REG_BK3385_40_H      0x338581
#define REG_BK3385_41_L      0x338582
#define REG_BK3385_41_H      0x338583
#define REG_BK3385_42_L      0x338584
#define REG_BK3385_42_H      0x338585
#define REG_BK3385_43_L      0x338586
#define REG_BK3385_43_H      0x338587
#define REG_BK3385_44_L      0x338588
#define REG_BK3385_44_H      0x338589
#define REG_BK3385_45_L      0x33858A
#define REG_BK3385_45_H      0x33858B
#define REG_BK3385_46_L      0x33858C
#define REG_BK3385_46_H      0x33858D
#define REG_BK3385_47_L      0x33858E
#define REG_BK3385_47_H      0x33858F
#define REG_BK3385_48_L      0x338590
#define REG_BK3385_48_H      0x338591
#define REG_BK3385_49_L      0x338592
#define REG_BK3385_49_H      0x338593
#define REG_BK3385_4A_L      0x338594
#define REG_BK3385_4A_H      0x338595
#define REG_BK3385_4B_L      0x338596
#define REG_BK3385_4B_H      0x338597
#define REG_BK3385_4C_L      0x338598
#define REG_BK3385_4C_H      0x338599
#define REG_BK3385_4D_L      0x33859A
#define REG_BK3385_4D_H      0x33859B
#define REG_BK3385_4E_L      0x33859C
#define REG_BK3385_4E_H      0x33859D
#define REG_BK3385_4F_L      0x33859E
#define REG_BK3385_4F_H      0x33859F
#define REG_BK3385_50_L      0x3385A0
#define REG_BK3385_50_H      0x3385A1
#define REG_BK3385_51_L      0x3385A2
#define REG_BK3385_51_H      0x3385A3
#define REG_BK3385_52_L      0x3385A4
#define REG_BK3385_52_H      0x3385A5
#define REG_BK3385_53_L      0x3385A6
#define REG_BK3385_53_H      0x3385A7
#define REG_BK3385_54_L      0x3385A8
#define REG_BK3385_54_H      0x3385A9
#define REG_BK3385_55_L      0x3385AA
#define REG_BK3385_55_H      0x3385AB
#define REG_BK3385_56_L      0x3385AC
#define REG_BK3385_56_H      0x3385AD
#define REG_BK3385_57_L      0x3385AE
#define REG_BK3385_57_H      0x3385AF
#define REG_BK3385_58_L      0x3385B0
#define REG_BK3385_58_H      0x3385B1
#define REG_BK3385_59_L      0x3385B2
#define REG_BK3385_59_H      0x3385B3
#define REG_BK3385_5A_L      0x3385B4
#define REG_BK3385_5A_H      0x3385B5
#define REG_BK3385_5B_L      0x3385B6
#define REG_BK3385_5B_H      0x3385B7
#define REG_BK3385_5C_L      0x3385B8
#define REG_BK3385_5C_H      0x3385B9
#define REG_BK3385_5D_L      0x3385BA
#define REG_BK3385_5D_H      0x3385BB
#define REG_BK3385_5E_L      0x3385BC
#define REG_BK3385_5E_H      0x3385BD
#define REG_BK3385_5F_L      0x3385BE
#define REG_BK3385_5F_H      0x3385BF
#define REG_BK3385_60_L      0x3385C0
#define REG_BK3385_60_H      0x3385C1
#define REG_BK3385_61_L      0x3385C2
#define REG_BK3385_61_H      0x3385C3
#define REG_BK3385_62_L      0x3385C4
#define REG_BK3385_62_H      0x3385C5
#define REG_BK3385_63_L      0x3385C6
#define REG_BK3385_63_H      0x3385C7
#define REG_BK3385_64_L      0x3385C8
#define REG_BK3385_64_H      0x3385C9
#define REG_BK3385_65_L      0x3385CA
#define REG_BK3385_65_H      0x3385CB
#define REG_BK3385_66_L      0x3385CC
#define REG_BK3385_66_H      0x3385CD
#define REG_BK3385_67_L      0x3385CE
#define REG_BK3385_67_H      0x3385CF
#define REG_BK3385_68_L      0x3385D0
#define REG_BK3385_68_H      0x3385D1
#define REG_BK3385_69_L      0x3385D2
#define REG_BK3385_69_H      0x3385D3
#define REG_BK3385_6A_L      0x3385D4
#define REG_BK3385_6A_H      0x3385D5
#define REG_BK3385_6B_L      0x3385D6
#define REG_BK3385_6B_H      0x3385D7
#define REG_BK3385_6C_L      0x3385D8
#define REG_BK3385_6C_H      0x3385D9
#define REG_BK3385_6D_L      0x3385DA
#define REG_BK3385_6D_H      0x3385DB
#define REG_BK3385_6E_L      0x3385DC
#define REG_BK3385_6E_H      0x3385DD
#define REG_BK3385_6F_L      0x3385DE
#define REG_BK3385_6F_H      0x3385DF
#define REG_BK3385_70_L      0x3385E0
#define REG_BK3385_70_H      0x3385E1
#define REG_BK3385_71_L      0x3385E2
#define REG_BK3385_71_H      0x3385E3
#define REG_BK3385_72_L      0x3385E4
#define REG_BK3385_72_H      0x3385E5
#define REG_BK3385_73_L      0x3385E6
#define REG_BK3385_73_H      0x3385E7
#define REG_BK3385_74_L      0x3385E8
#define REG_BK3385_74_H      0x3385E9
#define REG_BK3385_75_L      0x3385EA
#define REG_BK3385_75_H      0x3385EB
#define REG_BK3385_76_L      0x3385EC
#define REG_BK3385_76_H      0x3385ED
#define REG_BK3385_77_L      0x3385EE
#define REG_BK3385_77_H      0x3385EF
#define REG_BK3385_78_L      0x3385F0
#define REG_BK3385_78_H      0x3385F1
#define REG_BK3385_79_L      0x3385F2
#define REG_BK3385_79_H      0x3385F3
#define REG_BK3385_7A_L      0x3385F4
#define REG_BK3385_7A_H      0x3385F5
#define REG_BK3385_7B_L      0x3385F6
#define REG_BK3385_7B_H      0x3385F7
#define REG_BK3385_7C_L      0x3385F8
#define REG_BK3385_7C_H      0x3385F9
#define REG_BK3385_7D_L      0x3385FA
#define REG_BK3385_7D_H      0x3385FB
#define REG_BK3385_7E_L      0x3385FC
#define REG_BK3385_7E_H      0x3385FD
#define REG_BK3385_7F_L      0x3385FE
#define REG_BK3385_7F_H      0x3385FF
//----------------------------------------------
#define REG_BK3387_00_L      0x338700
#define REG_BK3387_00_H      0x338701
#define REG_BK3387_01_L      0x338702
#define REG_BK3387_01_H      0x338703
#define REG_BK3387_02_L      0x338704
#define REG_BK3387_02_H      0x338705
#define REG_BK3387_03_L      0x338706
#define REG_BK3387_03_H      0x338707
#define REG_BK3387_04_L      0x338708
#define REG_BK3387_04_H      0x338709
#define REG_BK3387_05_L      0x33870A
#define REG_BK3387_05_H      0x33870B
#define REG_BK3387_06_L      0x33870C
#define REG_BK3387_06_H      0x33870D
#define REG_BK3387_07_L      0x33870E
#define REG_BK3387_07_H      0x33870F
#define REG_BK3387_08_L      0x338710
#define REG_BK3387_08_H      0x338711
#define REG_BK3387_09_L      0x338712
#define REG_BK3387_09_H      0x338713
#define REG_BK3387_0A_L      0x338714
#define REG_BK3387_0A_H      0x338715
#define REG_BK3387_0B_L      0x338716
#define REG_BK3387_0B_H      0x338717
#define REG_BK3387_0C_L      0x338718
#define REG_BK3387_0C_H      0x338719
#define REG_BK3387_0D_L      0x33871A
#define REG_BK3387_0D_H      0x33871B
#define REG_BK3387_0E_L      0x33871C
#define REG_BK3387_0E_H      0x33871D
#define REG_BK3387_0F_L      0x33871E
#define REG_BK3387_0F_H      0x33871F
#define REG_BK3387_10_L      0x338720
#define REG_BK3387_10_H      0x338721
#define REG_BK3387_11_L      0x338722
#define REG_BK3387_11_H      0x338723
#define REG_BK3387_12_L      0x338724
#define REG_BK3387_12_H      0x338725
#define REG_BK3387_13_L      0x338726
#define REG_BK3387_13_H      0x338727
#define REG_BK3387_14_L      0x338728
#define REG_BK3387_14_H      0x338729
#define REG_BK3387_15_L      0x33872A
#define REG_BK3387_15_H      0x33872B
#define REG_BK3387_16_L      0x33872C
#define REG_BK3387_16_H      0x33872D
#define REG_BK3387_17_L      0x33872E
#define REG_BK3387_17_H      0x33872F
#define REG_BK3387_18_L      0x338730
#define REG_BK3387_18_H      0x338731
#define REG_BK3387_19_L      0x338732
#define REG_BK3387_19_H      0x338733
#define REG_BK3387_1A_L      0x338734
#define REG_BK3387_1A_H      0x338735
#define REG_BK3387_1B_L      0x338736
#define REG_BK3387_1B_H      0x338737
#define REG_BK3387_1C_L      0x338738
#define REG_BK3387_1C_H      0x338739
#define REG_BK3387_1D_L      0x33873A
#define REG_BK3387_1D_H      0x33873B
#define REG_BK3387_1E_L      0x33873C
#define REG_BK3387_1E_H      0x33873D
#define REG_BK3387_1F_L      0x33873E
#define REG_BK3387_1F_H      0x33873F
#define REG_BK3387_20_L      0x338740
#define REG_BK3387_20_H      0x338741
#define REG_BK3387_21_L      0x338742
#define REG_BK3387_21_H      0x338743
#define REG_BK3387_22_L      0x338744
#define REG_BK3387_22_H      0x338745
#define REG_BK3387_23_L      0x338746
#define REG_BK3387_23_H      0x338747
#define REG_BK3387_24_L      0x338748
#define REG_BK3387_24_H      0x338749
#define REG_BK3387_25_L      0x33874A
#define REG_BK3387_25_H      0x33874B
#define REG_BK3387_26_L      0x33874C
#define REG_BK3387_26_H      0x33874D
#define REG_BK3387_27_L      0x33874E
#define REG_BK3387_27_H      0x33874F
#define REG_BK3387_28_L      0x338750
#define REG_BK3387_28_H      0x338751
#define REG_BK3387_29_L      0x338752
#define REG_BK3387_29_H      0x338753
#define REG_BK3387_2A_L      0x338754
#define REG_BK3387_2A_H      0x338755
#define REG_BK3387_2B_L      0x338756
#define REG_BK3387_2B_H      0x338757
#define REG_BK3387_2C_L      0x338758
#define REG_BK3387_2C_H      0x338759
#define REG_BK3387_2D_L      0x33875A
#define REG_BK3387_2D_H      0x33875B
#define REG_BK3387_2E_L      0x33875C
#define REG_BK3387_2E_H      0x33875D
#define REG_BK3387_2F_L      0x33875E
#define REG_BK3387_2F_H      0x33875F
#define REG_BK3387_30_L      0x338760
#define REG_BK3387_30_H      0x338761
#define REG_BK3387_31_L      0x338762
#define REG_BK3387_31_H      0x338763
#define REG_BK3387_32_L      0x338764
#define REG_BK3387_32_H      0x338765
#define REG_BK3387_33_L      0x338766
#define REG_BK3387_33_H      0x338767
#define REG_BK3387_34_L      0x338768
#define REG_BK3387_34_H      0x338769
#define REG_BK3387_35_L      0x33876A
#define REG_BK3387_35_H      0x33876B
#define REG_BK3387_36_L      0x33876C
#define REG_BK3387_36_H      0x33876D
#define REG_BK3387_37_L      0x33876E
#define REG_BK3387_37_H      0x33876F
#define REG_BK3387_38_L      0x338770
#define REG_BK3387_38_H      0x338771
#define REG_BK3387_39_L      0x338772
#define REG_BK3387_39_H      0x338773
#define REG_BK3387_3A_L      0x338774
#define REG_BK3387_3A_H      0x338775
#define REG_BK3387_3B_L      0x338776
#define REG_BK3387_3B_H      0x338777
#define REG_BK3387_3C_L      0x338778
#define REG_BK3387_3C_H      0x338779
#define REG_BK3387_3D_L      0x33877A
#define REG_BK3387_3D_H      0x33877B
#define REG_BK3387_3E_L      0x33877C
#define REG_BK3387_3E_H      0x33877D
#define REG_BK3387_3F_L      0x33877E
#define REG_BK3387_3F_H      0x33877F
#define REG_BK3387_40_L      0x338780
#define REG_BK3387_40_H      0x338781
#define REG_BK3387_41_L      0x338782
#define REG_BK3387_41_H      0x338783
#define REG_BK3387_42_L      0x338784
#define REG_BK3387_42_H      0x338785
#define REG_BK3387_43_L      0x338786
#define REG_BK3387_43_H      0x338787
#define REG_BK3387_44_L      0x338788
#define REG_BK3387_44_H      0x338789
#define REG_BK3387_45_L      0x33878A
#define REG_BK3387_45_H      0x33878B
#define REG_BK3387_46_L      0x33878C
#define REG_BK3387_46_H      0x33878D
#define REG_BK3387_47_L      0x33878E
#define REG_BK3387_47_H      0x33878F
#define REG_BK3387_48_L      0x338790
#define REG_BK3387_48_H      0x338791
#define REG_BK3387_49_L      0x338792
#define REG_BK3387_49_H      0x338793
#define REG_BK3387_4A_L      0x338794
#define REG_BK3387_4A_H      0x338795
#define REG_BK3387_4B_L      0x338796
#define REG_BK3387_4B_H      0x338797
#define REG_BK3387_4C_L      0x338798
#define REG_BK3387_4C_H      0x338799
#define REG_BK3387_4D_L      0x33879A
#define REG_BK3387_4D_H      0x33879B
#define REG_BK3387_4E_L      0x33879C
#define REG_BK3387_4E_H      0x33879D
#define REG_BK3387_4F_L      0x33879E
#define REG_BK3387_4F_H      0x33879F
#define REG_BK3387_50_L      0x3387A0
#define REG_BK3387_50_H      0x3387A1
#define REG_BK3387_51_L      0x3387A2
#define REG_BK3387_51_H      0x3387A3
#define REG_BK3387_52_L      0x3387A4
#define REG_BK3387_52_H      0x3387A5
#define REG_BK3387_53_L      0x3387A6
#define REG_BK3387_53_H      0x3387A7
#define REG_BK3387_54_L      0x3387A8
#define REG_BK3387_54_H      0x3387A9
#define REG_BK3387_55_L      0x3387AA
#define REG_BK3387_55_H      0x3387AB
#define REG_BK3387_56_L      0x3387AC
#define REG_BK3387_56_H      0x3387AD
#define REG_BK3387_57_L      0x3387AE
#define REG_BK3387_57_H      0x3387AF
#define REG_BK3387_58_L      0x3387B0
#define REG_BK3387_58_H      0x3387B1
#define REG_BK3387_59_L      0x3387B2
#define REG_BK3387_59_H      0x3387B3
#define REG_BK3387_5A_L      0x3387B4
#define REG_BK3387_5A_H      0x3387B5
#define REG_BK3387_5B_L      0x3387B6
#define REG_BK3387_5B_H      0x3387B7
#define REG_BK3387_5C_L      0x3387B8
#define REG_BK3387_5C_H      0x3387B9
#define REG_BK3387_5D_L      0x3387BA
#define REG_BK3387_5D_H      0x3387BB
#define REG_BK3387_5E_L      0x3387BC
#define REG_BK3387_5E_H      0x3387BD
#define REG_BK3387_5F_L      0x3387BE
#define REG_BK3387_5F_H      0x3387BF
#define REG_BK3387_60_L      0x3387C0
#define REG_BK3387_60_H      0x3387C1
#define REG_BK3387_61_L      0x3387C2
#define REG_BK3387_61_H      0x3387C3
#define REG_BK3387_62_L      0x3387C4
#define REG_BK3387_62_H      0x3387C5
#define REG_BK3387_63_L      0x3387C6
#define REG_BK3387_63_H      0x3387C7
#define REG_BK3387_64_L      0x3387C8
#define REG_BK3387_64_H      0x3387C9
#define REG_BK3387_65_L      0x3387CA
#define REG_BK3387_65_H      0x3387CB
#define REG_BK3387_66_L      0x3387CC
#define REG_BK3387_66_H      0x3387CD
#define REG_BK3387_67_L      0x3387CE
#define REG_BK3387_67_H      0x3387CF
#define REG_BK3387_68_L      0x3387D0
#define REG_BK3387_68_H      0x3387D1
#define REG_BK3387_69_L      0x3387D2
#define REG_BK3387_69_H      0x3387D3
#define REG_BK3387_6A_L      0x3387D4
#define REG_BK3387_6A_H      0x3387D5
#define REG_BK3387_6B_L      0x3387D6
#define REG_BK3387_6B_H      0x3387D7
#define REG_BK3387_6C_L      0x3387D8
#define REG_BK3387_6C_H      0x3387D9
#define REG_BK3387_6D_L      0x3387DA
#define REG_BK3387_6D_H      0x3387DB
#define REG_BK3387_6E_L      0x3387DC
#define REG_BK3387_6E_H      0x3387DD
#define REG_BK3387_6F_L      0x3387DE
#define REG_BK3387_6F_H      0x3387DF
#define REG_BK3387_70_L      0x3387E0
#define REG_BK3387_70_H      0x3387E1
#define REG_BK3387_71_L      0x3387E2
#define REG_BK3387_71_H      0x3387E3
#define REG_BK3387_72_L      0x3387E4
#define REG_BK3387_72_H      0x3387E5
#define REG_BK3387_73_L      0x3387E6
#define REG_BK3387_73_H      0x3387E7
#define REG_BK3387_74_L      0x3387E8
#define REG_BK3387_74_H      0x3387E9
#define REG_BK3387_75_L      0x3387EA
#define REG_BK3387_75_H      0x3387EB
#define REG_BK3387_76_L      0x3387EC
#define REG_BK3387_76_H      0x3387ED
#define REG_BK3387_77_L      0x3387EE
#define REG_BK3387_77_H      0x3387EF
#define REG_BK3387_78_L      0x3387F0
#define REG_BK3387_78_H      0x3387F1
#define REG_BK3387_79_L      0x3387F2
#define REG_BK3387_79_H      0x3387F3
#define REG_BK3387_7A_L      0x3387F4
#define REG_BK3387_7A_H      0x3387F5
#define REG_BK3387_7B_L      0x3387F6
#define REG_BK3387_7B_H      0x3387F7
#define REG_BK3387_7C_L      0x3387F8
#define REG_BK3387_7C_H      0x3387F9
#define REG_BK3387_7D_L      0x3387FA
#define REG_BK3387_7D_H      0x3387FB
#define REG_BK3387_7E_L      0x3387FC
#define REG_BK3387_7E_H      0x3387FD
#define REG_BK3387_7F_L      0x3387FE
#define REG_BK3387_7F_H      0x3387FF
//----------------------------------------------
#define REG_BK338A_00_L      0x338A00
#define REG_BK338A_00_H      0x338A01
#define REG_BK338A_01_L      0x338A02
#define REG_BK338A_01_H      0x338A03
#define REG_BK338A_02_L      0x338A04
#define REG_BK338A_02_H      0x338A05
#define REG_BK338A_03_L      0x338A06
#define REG_BK338A_03_H      0x338A07
#define REG_BK338A_04_L      0x338A08
#define REG_BK338A_04_H      0x338A09
#define REG_BK338A_05_L      0x338A0A
#define REG_BK338A_05_H      0x338A0B
#define REG_BK338A_06_L      0x338A0C
#define REG_BK338A_06_H      0x338A0D
#define REG_BK338A_07_L      0x338A0E
#define REG_BK338A_07_H      0x338A0F
#define REG_BK338A_08_L      0x338A10
#define REG_BK338A_08_H      0x338A11
#define REG_BK338A_09_L      0x338A12
#define REG_BK338A_09_H      0x338A13
#define REG_BK338A_0A_L      0x338A14
#define REG_BK338A_0A_H      0x338A15
#define REG_BK338A_0B_L      0x338A16
#define REG_BK338A_0B_H      0x338A17
#define REG_BK338A_0C_L      0x338A18
#define REG_BK338A_0C_H      0x338A19
#define REG_BK338A_0D_L      0x338A1A
#define REG_BK338A_0D_H      0x338A1B
#define REG_BK338A_0E_L      0x338A1C
#define REG_BK338A_0E_H      0x338A1D
#define REG_BK338A_0F_L      0x338A1E
#define REG_BK338A_0F_H      0x338A1F
#define REG_BK338A_10_L      0x338A20
#define REG_BK338A_10_H      0x338A21
#define REG_BK338A_11_L      0x338A22
#define REG_BK338A_11_H      0x338A23
#define REG_BK338A_12_L      0x338A24
#define REG_BK338A_12_H      0x338A25
#define REG_BK338A_13_L      0x338A26
#define REG_BK338A_13_H      0x338A27
#define REG_BK338A_14_L      0x338A28
#define REG_BK338A_14_H      0x338A29
#define REG_BK338A_15_L      0x338A2A
#define REG_BK338A_15_H      0x338A2B
#define REG_BK338A_16_L      0x338A2C
#define REG_BK338A_16_H      0x338A2D
#define REG_BK338A_17_L      0x338A2E
#define REG_BK338A_17_H      0x338A2F
#define REG_BK338A_18_L      0x338A30
#define REG_BK338A_18_H      0x338A31
#define REG_BK338A_19_L      0x338A32
#define REG_BK338A_19_H      0x338A33
#define REG_BK338A_1A_L      0x338A34
#define REG_BK338A_1A_H      0x338A35
#define REG_BK338A_1B_L      0x338A36
#define REG_BK338A_1B_H      0x338A37
#define REG_BK338A_1C_L      0x338A38
#define REG_BK338A_1C_H      0x338A39
#define REG_BK338A_1D_L      0x338A3A
#define REG_BK338A_1D_H      0x338A3B
#define REG_BK338A_1E_L      0x338A3C
#define REG_BK338A_1E_H      0x338A3D
#define REG_BK338A_1F_L      0x338A3E
#define REG_BK338A_1F_H      0x338A3F
#define REG_BK338A_20_L      0x338A40
#define REG_BK338A_20_H      0x338A41
#define REG_BK338A_21_L      0x338A42
#define REG_BK338A_21_H      0x338A43
#define REG_BK338A_22_L      0x338A44
#define REG_BK338A_22_H      0x338A45
#define REG_BK338A_23_L      0x338A46
#define REG_BK338A_23_H      0x338A47
#define REG_BK338A_24_L      0x338A48
#define REG_BK338A_24_H      0x338A49
#define REG_BK338A_25_L      0x338A4A
#define REG_BK338A_25_H      0x338A4B
#define REG_BK338A_26_L      0x338A4C
#define REG_BK338A_26_H      0x338A4D
#define REG_BK338A_27_L      0x338A4E
#define REG_BK338A_27_H      0x338A4F
#define REG_BK338A_28_L      0x338A50
#define REG_BK338A_28_H      0x338A51
#define REG_BK338A_29_L      0x338A52
#define REG_BK338A_29_H      0x338A53
#define REG_BK338A_2A_L      0x338A54
#define REG_BK338A_2A_H      0x338A55
#define REG_BK338A_2B_L      0x338A56
#define REG_BK338A_2B_H      0x338A57
#define REG_BK338A_2C_L      0x338A58
#define REG_BK338A_2C_H      0x338A59
#define REG_BK338A_2D_L      0x338A5A
#define REG_BK338A_2D_H      0x338A5B
#define REG_BK338A_2E_L      0x338A5C
#define REG_BK338A_2E_H      0x338A5D
#define REG_BK338A_2F_L      0x338A5E
#define REG_BK338A_2F_H      0x338A5F
#define REG_BK338A_30_L      0x338A60
#define REG_BK338A_30_H      0x338A61
#define REG_BK338A_31_L      0x338A62
#define REG_BK338A_31_H      0x338A63
#define REG_BK338A_32_L      0x338A64
#define REG_BK338A_32_H      0x338A65
#define REG_BK338A_33_L      0x338A66
#define REG_BK338A_33_H      0x338A67
#define REG_BK338A_34_L      0x338A68
#define REG_BK338A_34_H      0x338A69
#define REG_BK338A_35_L      0x338A6A
#define REG_BK338A_35_H      0x338A6B
#define REG_BK338A_36_L      0x338A6C
#define REG_BK338A_36_H      0x338A6D
#define REG_BK338A_37_L      0x338A6E
#define REG_BK338A_37_H      0x338A6F
#define REG_BK338A_38_L      0x338A70
#define REG_BK338A_38_H      0x338A71
#define REG_BK338A_39_L      0x338A72
#define REG_BK338A_39_H      0x338A73
#define REG_BK338A_3A_L      0x338A74
#define REG_BK338A_3A_H      0x338A75
#define REG_BK338A_3B_L      0x338A76
#define REG_BK338A_3B_H      0x338A77
#define REG_BK338A_3C_L      0x338A78
#define REG_BK338A_3C_H      0x338A79
#define REG_BK338A_3D_L      0x338A7A
#define REG_BK338A_3D_H      0x338A7B
#define REG_BK338A_3E_L      0x338A7C
#define REG_BK338A_3E_H      0x338A7D
#define REG_BK338A_3F_L      0x338A7E
#define REG_BK338A_3F_H      0x338A7F
#define REG_BK338A_40_L      0x338A80
#define REG_BK338A_40_H      0x338A81
#define REG_BK338A_41_L      0x338A82
#define REG_BK338A_41_H      0x338A83
#define REG_BK338A_42_L      0x338A84
#define REG_BK338A_42_H      0x338A85
#define REG_BK338A_43_L      0x338A86
#define REG_BK338A_43_H      0x338A87
#define REG_BK338A_44_L      0x338A88
#define REG_BK338A_44_H      0x338A89
#define REG_BK338A_45_L      0x338A8A
#define REG_BK338A_45_H      0x338A8B
#define REG_BK338A_46_L      0x338A8C
#define REG_BK338A_46_H      0x338A8D
#define REG_BK338A_47_L      0x338A8E
#define REG_BK338A_47_H      0x338A8F
#define REG_BK338A_48_L      0x338A90
#define REG_BK338A_48_H      0x338A91
#define REG_BK338A_49_L      0x338A92
#define REG_BK338A_49_H      0x338A93
#define REG_BK338A_4A_L      0x338A94
#define REG_BK338A_4A_H      0x338A95
#define REG_BK338A_4B_L      0x338A96
#define REG_BK338A_4B_H      0x338A97
#define REG_BK338A_4C_L      0x338A98
#define REG_BK338A_4C_H      0x338A99
#define REG_BK338A_4D_L      0x338A9A
#define REG_BK338A_4D_H      0x338A9B
#define REG_BK338A_4E_L      0x338A9C
#define REG_BK338A_4E_H      0x338A9D
#define REG_BK338A_4F_L      0x338A9E
#define REG_BK338A_4F_H      0x338A9F
#define REG_BK338A_50_L      0x338AA0
#define REG_BK338A_50_H      0x338AA1
#define REG_BK338A_51_L      0x338AA2
#define REG_BK338A_51_H      0x338AA3
#define REG_BK338A_52_L      0x338AA4
#define REG_BK338A_52_H      0x338AA5
#define REG_BK338A_53_L      0x338AA6
#define REG_BK338A_53_H      0x338AA7
#define REG_BK338A_54_L      0x338AA8
#define REG_BK338A_54_H      0x338AA9
#define REG_BK338A_55_L      0x338AAA
#define REG_BK338A_55_H      0x338AAB
#define REG_BK338A_56_L      0x338AAC
#define REG_BK338A_56_H      0x338AAD
#define REG_BK338A_57_L      0x338AAE
#define REG_BK338A_57_H      0x338AAF
#define REG_BK338A_58_L      0x338AB0
#define REG_BK338A_58_H      0x338AB1
#define REG_BK338A_59_L      0x338AB2
#define REG_BK338A_59_H      0x338AB3
#define REG_BK338A_5A_L      0x338AB4
#define REG_BK338A_5A_H      0x338AB5
#define REG_BK338A_5B_L      0x338AB6
#define REG_BK338A_5B_H      0x338AB7
#define REG_BK338A_5C_L      0x338AB8
#define REG_BK338A_5C_H      0x338AB9
#define REG_BK338A_5D_L      0x338ABA
#define REG_BK338A_5D_H      0x338ABB
#define REG_BK338A_5E_L      0x338ABC
#define REG_BK338A_5E_H      0x338ABD
#define REG_BK338A_5F_L      0x338ABE
#define REG_BK338A_5F_H      0x338ABF
#define REG_BK338A_60_L      0x338AC0
#define REG_BK338A_60_H      0x338AC1
#define REG_BK338A_61_L      0x338AC2
#define REG_BK338A_61_H      0x338AC3
#define REG_BK338A_62_L      0x338AC4
#define REG_BK338A_62_H      0x338AC5
#define REG_BK338A_63_L      0x338AC6
#define REG_BK338A_63_H      0x338AC7
#define REG_BK338A_64_L      0x338AC8
#define REG_BK338A_64_H      0x338AC9
#define REG_BK338A_65_L      0x338ACA
#define REG_BK338A_65_H      0x338ACB
#define REG_BK338A_66_L      0x338ACC
#define REG_BK338A_66_H      0x338ACD
#define REG_BK338A_67_L      0x338ACE
#define REG_BK338A_67_H      0x338ACF
#define REG_BK338A_68_L      0x338AD0
#define REG_BK338A_68_H      0x338AD1
#define REG_BK338A_69_L      0x338AD2
#define REG_BK338A_69_H      0x338AD3
#define REG_BK338A_6A_L      0x338AD4
#define REG_BK338A_6A_H      0x338AD5
#define REG_BK338A_6B_L      0x338AD6
#define REG_BK338A_6B_H      0x338AD7
#define REG_BK338A_6C_L      0x338AD8
#define REG_BK338A_6C_H      0x338AD9
#define REG_BK338A_6D_L      0x338ADA
#define REG_BK338A_6D_H      0x338ADB
#define REG_BK338A_6E_L      0x338ADC
#define REG_BK338A_6E_H      0x338ADD
#define REG_BK338A_6F_L      0x338ADE
#define REG_BK338A_6F_H      0x338ADF
#define REG_BK338A_70_L      0x338AE0
#define REG_BK338A_70_H      0x338AE1
#define REG_BK338A_71_L      0x338AE2
#define REG_BK338A_71_H      0x338AE3
#define REG_BK338A_72_L      0x338AE4
#define REG_BK338A_72_H      0x338AE5
#define REG_BK338A_73_L      0x338AE6
#define REG_BK338A_73_H      0x338AE7
#define REG_BK338A_74_L      0x338AE8
#define REG_BK338A_74_H      0x338AE9
#define REG_BK338A_75_L      0x338AEA
#define REG_BK338A_75_H      0x338AEB
#define REG_BK338A_76_L      0x338AEC
#define REG_BK338A_76_H      0x338AED
#define REG_BK338A_77_L      0x338AEE
#define REG_BK338A_77_H      0x338AEF
#define REG_BK338A_78_L      0x338AF0
#define REG_BK338A_78_H      0x338AF1
#define REG_BK338A_79_L      0x338AF2
#define REG_BK338A_79_H      0x338AF3
#define REG_BK338A_7A_L      0x338AF4
#define REG_BK338A_7A_H      0x338AF5
#define REG_BK338A_7B_L      0x338AF6
#define REG_BK338A_7B_H      0x338AF7
#define REG_BK338A_7C_L      0x338AF8
#define REG_BK338A_7C_H      0x338AF9
#define REG_BK338A_7D_L      0x338AFA
#define REG_BK338A_7D_H      0x338AFB
#define REG_BK338A_7E_L      0x338AFC
#define REG_BK338A_7E_H      0x338AFD
#define REG_BK338A_7F_L      0x338AFE
#define REG_BK338A_7F_H      0x338AFF
//----------------------------------------------
#define REG_BK338C_00_L      0x338C00
#define REG_BK338C_00_H      0x338C01
#define REG_BK338C_01_L      0x338C02
#define REG_BK338C_01_H      0x338C03
#define REG_BK338C_02_L      0x338C04
#define REG_BK338C_02_H      0x338C05
#define REG_BK338C_03_L      0x338C06
#define REG_BK338C_03_H      0x338C07
#define REG_BK338C_04_L      0x338C08
#define REG_BK338C_04_H      0x338C09
#define REG_BK338C_05_L      0x338C0A
#define REG_BK338C_05_H      0x338C0B
#define REG_BK338C_06_L      0x338C0C
#define REG_BK338C_06_H      0x338C0D
#define REG_BK338C_07_L      0x338C0E
#define REG_BK338C_07_H      0x338C0F
#define REG_BK338C_08_L      0x338C10
#define REG_BK338C_08_H      0x338C11
#define REG_BK338C_09_L      0x338C12
#define REG_BK338C_09_H      0x338C13
#define REG_BK338C_0A_L      0x338C14
#define REG_BK338C_0A_H      0x338C15
#define REG_BK338C_0B_L      0x338C16
#define REG_BK338C_0B_H      0x338C17
#define REG_BK338C_0C_L      0x338C18
#define REG_BK338C_0C_H      0x338C19
#define REG_BK338C_0D_L      0x338C1A
#define REG_BK338C_0D_H      0x338C1B
#define REG_BK338C_0E_L      0x338C1C
#define REG_BK338C_0E_H      0x338C1D
#define REG_BK338C_0F_L      0x338C1E
#define REG_BK338C_0F_H      0x338C1F
#define REG_BK338C_10_L      0x338C20
#define REG_BK338C_10_H      0x338C21
#define REG_BK338C_11_L      0x338C22
#define REG_BK338C_11_H      0x338C23
#define REG_BK338C_12_L      0x338C24
#define REG_BK338C_12_H      0x338C25
#define REG_BK338C_13_L      0x338C26
#define REG_BK338C_13_H      0x338C27
#define REG_BK338C_14_L      0x338C28
#define REG_BK338C_14_H      0x338C29
#define REG_BK338C_15_L      0x338C2A
#define REG_BK338C_15_H      0x338C2B
#define REG_BK338C_16_L      0x338C2C
#define REG_BK338C_16_H      0x338C2D
#define REG_BK338C_17_L      0x338C2E
#define REG_BK338C_17_H      0x338C2F
#define REG_BK338C_18_L      0x338C30
#define REG_BK338C_18_H      0x338C31
#define REG_BK338C_19_L      0x338C32
#define REG_BK338C_19_H      0x338C33
#define REG_BK338C_1A_L      0x338C34
#define REG_BK338C_1A_H      0x338C35
#define REG_BK338C_1B_L      0x338C36
#define REG_BK338C_1B_H      0x338C37
#define REG_BK338C_1C_L      0x338C38
#define REG_BK338C_1C_H      0x338C39
#define REG_BK338C_1D_L      0x338C3A
#define REG_BK338C_1D_H      0x338C3B
#define REG_BK338C_1E_L      0x338C3C
#define REG_BK338C_1E_H      0x338C3D
#define REG_BK338C_1F_L      0x338C3E
#define REG_BK338C_1F_H      0x338C3F
#define REG_BK338C_20_L      0x338C40
#define REG_BK338C_20_H      0x338C41
#define REG_BK338C_21_L      0x338C42
#define REG_BK338C_21_H      0x338C43
#define REG_BK338C_22_L      0x338C44
#define REG_BK338C_22_H      0x338C45
#define REG_BK338C_23_L      0x338C46
#define REG_BK338C_23_H      0x338C47
#define REG_BK338C_24_L      0x338C48
#define REG_BK338C_24_H      0x338C49
#define REG_BK338C_25_L      0x338C4A
#define REG_BK338C_25_H      0x338C4B
#define REG_BK338C_26_L      0x338C4C
#define REG_BK338C_26_H      0x338C4D
#define REG_BK338C_27_L      0x338C4E
#define REG_BK338C_27_H      0x338C4F
#define REG_BK338C_28_L      0x338C50
#define REG_BK338C_28_H      0x338C51
#define REG_BK338C_29_L      0x338C52
#define REG_BK338C_29_H      0x338C53
#define REG_BK338C_2A_L      0x338C54
#define REG_BK338C_2A_H      0x338C55
#define REG_BK338C_2B_L      0x338C56
#define REG_BK338C_2B_H      0x338C57
#define REG_BK338C_2C_L      0x338C58
#define REG_BK338C_2C_H      0x338C59
#define REG_BK338C_2D_L      0x338C5A
#define REG_BK338C_2D_H      0x338C5B
#define REG_BK338C_2E_L      0x338C5C
#define REG_BK338C_2E_H      0x338C5D
#define REG_BK338C_2F_L      0x338C5E
#define REG_BK338C_2F_H      0x338C5F
#define REG_BK338C_30_L      0x338C60
#define REG_BK338C_30_H      0x338C61
#define REG_BK338C_31_L      0x338C62
#define REG_BK338C_31_H      0x338C63
#define REG_BK338C_32_L      0x338C64
#define REG_BK338C_32_H      0x338C65
#define REG_BK338C_33_L      0x338C66
#define REG_BK338C_33_H      0x338C67
#define REG_BK338C_34_L      0x338C68
#define REG_BK338C_34_H      0x338C69
#define REG_BK338C_35_L      0x338C6A
#define REG_BK338C_35_H      0x338C6B
#define REG_BK338C_36_L      0x338C6C
#define REG_BK338C_36_H      0x338C6D
#define REG_BK338C_37_L      0x338C6E
#define REG_BK338C_37_H      0x338C6F
#define REG_BK338C_38_L      0x338C70
#define REG_BK338C_38_H      0x338C71
#define REG_BK338C_39_L      0x338C72
#define REG_BK338C_39_H      0x338C73
#define REG_BK338C_3A_L      0x338C74
#define REG_BK338C_3A_H      0x338C75
#define REG_BK338C_3B_L      0x338C76
#define REG_BK338C_3B_H      0x338C77
#define REG_BK338C_3C_L      0x338C78
#define REG_BK338C_3C_H      0x338C79
#define REG_BK338C_3D_L      0x338C7A
#define REG_BK338C_3D_H      0x338C7B
#define REG_BK338C_3E_L      0x338C7C
#define REG_BK338C_3E_H      0x338C7D
#define REG_BK338C_3F_L      0x338C7E
#define REG_BK338C_3F_H      0x338C7F
#define REG_BK338C_40_L      0x338C80
#define REG_BK338C_40_H      0x338C81
#define REG_BK338C_41_L      0x338C82
#define REG_BK338C_41_H      0x338C83
#define REG_BK338C_42_L      0x338C84
#define REG_BK338C_42_H      0x338C85
#define REG_BK338C_43_L      0x338C86
#define REG_BK338C_43_H      0x338C87
#define REG_BK338C_44_L      0x338C88
#define REG_BK338C_44_H      0x338C89
#define REG_BK338C_45_L      0x338C8A
#define REG_BK338C_45_H      0x338C8B
#define REG_BK338C_46_L      0x338C8C
#define REG_BK338C_46_H      0x338C8D
#define REG_BK338C_47_L      0x338C8E
#define REG_BK338C_47_H      0x338C8F
#define REG_BK338C_48_L      0x338C90
#define REG_BK338C_48_H      0x338C91
#define REG_BK338C_49_L      0x338C92
#define REG_BK338C_49_H      0x338C93
#define REG_BK338C_4A_L      0x338C94
#define REG_BK338C_4A_H      0x338C95
#define REG_BK338C_4B_L      0x338C96
#define REG_BK338C_4B_H      0x338C97
#define REG_BK338C_4C_L      0x338C98
#define REG_BK338C_4C_H      0x338C99
#define REG_BK338C_4D_L      0x338C9A
#define REG_BK338C_4D_H      0x338C9B
#define REG_BK338C_4E_L      0x338C9C
#define REG_BK338C_4E_H      0x338C9D
#define REG_BK338C_4F_L      0x338C9E
#define REG_BK338C_4F_H      0x338C9F
#define REG_BK338C_50_L      0x338CA0
#define REG_BK338C_50_H      0x338CA1
#define REG_BK338C_51_L      0x338CA2
#define REG_BK338C_51_H      0x338CA3
#define REG_BK338C_52_L      0x338CA4
#define REG_BK338C_52_H      0x338CA5
#define REG_BK338C_53_L      0x338CA6
#define REG_BK338C_53_H      0x338CA7
#define REG_BK338C_54_L      0x338CA8
#define REG_BK338C_54_H      0x338CA9
#define REG_BK338C_55_L      0x338CAA
#define REG_BK338C_55_H      0x338CAB
#define REG_BK338C_56_L      0x338CAC
#define REG_BK338C_56_H      0x338CAD
#define REG_BK338C_57_L      0x338CAE
#define REG_BK338C_57_H      0x338CAF
#define REG_BK338C_58_L      0x338CB0
#define REG_BK338C_58_H      0x338CB1
#define REG_BK338C_59_L      0x338CB2
#define REG_BK338C_59_H      0x338CB3
#define REG_BK338C_5A_L      0x338CB4
#define REG_BK338C_5A_H      0x338CB5
#define REG_BK338C_5B_L      0x338CB6
#define REG_BK338C_5B_H      0x338CB7
#define REG_BK338C_5C_L      0x338CB8
#define REG_BK338C_5C_H      0x338CB9
#define REG_BK338C_5D_L      0x338CBA
#define REG_BK338C_5D_H      0x338CBB
#define REG_BK338C_5E_L      0x338CBC
#define REG_BK338C_5E_H      0x338CBD
#define REG_BK338C_5F_L      0x338CBE
#define REG_BK338C_5F_H      0x338CBF
#define REG_BK338C_60_L      0x338CC0
#define REG_BK338C_60_H      0x338CC1
#define REG_BK338C_61_L      0x338CC2
#define REG_BK338C_61_H      0x338CC3
#define REG_BK338C_62_L      0x338CC4
#define REG_BK338C_62_H      0x338CC5
#define REG_BK338C_63_L      0x338CC6
#define REG_BK338C_63_H      0x338CC7
#define REG_BK338C_64_L      0x338CC8
#define REG_BK338C_64_H      0x338CC9
#define REG_BK338C_65_L      0x338CCA
#define REG_BK338C_65_H      0x338CCB
#define REG_BK338C_66_L      0x338CCC
#define REG_BK338C_66_H      0x338CCD
#define REG_BK338C_67_L      0x338CCE
#define REG_BK338C_67_H      0x338CCF
#define REG_BK338C_68_L      0x338CD0
#define REG_BK338C_68_H      0x338CD1
#define REG_BK338C_69_L      0x338CD2
#define REG_BK338C_69_H      0x338CD3
#define REG_BK338C_6A_L      0x338CD4
#define REG_BK338C_6A_H      0x338CD5
#define REG_BK338C_6B_L      0x338CD6
#define REG_BK338C_6B_H      0x338CD7
#define REG_BK338C_6C_L      0x338CD8
#define REG_BK338C_6C_H      0x338CD9
#define REG_BK338C_6D_L      0x338CDA
#define REG_BK338C_6D_H      0x338CDB
#define REG_BK338C_6E_L      0x338CDC
#define REG_BK338C_6E_H      0x338CDD
#define REG_BK338C_6F_L      0x338CDE
#define REG_BK338C_6F_H      0x338CDF
#define REG_BK338C_70_L      0x338CE0
#define REG_BK338C_70_H      0x338CE1
#define REG_BK338C_71_L      0x338CE2
#define REG_BK338C_71_H      0x338CE3
#define REG_BK338C_72_L      0x338CE4
#define REG_BK338C_72_H      0x338CE5
#define REG_BK338C_73_L      0x338CE6
#define REG_BK338C_73_H      0x338CE7
#define REG_BK338C_74_L      0x338CE8
#define REG_BK338C_74_H      0x338CE9
#define REG_BK338C_75_L      0x338CEA
#define REG_BK338C_75_H      0x338CEB
#define REG_BK338C_76_L      0x338CEC
#define REG_BK338C_76_H      0x338CED
#define REG_BK338C_77_L      0x338CEE
#define REG_BK338C_77_H      0x338CEF
#define REG_BK338C_78_L      0x338CF0
#define REG_BK338C_78_H      0x338CF1
#define REG_BK338C_79_L      0x338CF2
#define REG_BK338C_79_H      0x338CF3
#define REG_BK338C_7A_L      0x338CF4
#define REG_BK338C_7A_H      0x338CF5
#define REG_BK338C_7B_L      0x338CF6
#define REG_BK338C_7B_H      0x338CF7
#define REG_BK338C_7C_L      0x338CF8
#define REG_BK338C_7C_H      0x338CF9
#define REG_BK338C_7D_L      0x338CFA
#define REG_BK338C_7D_H      0x338CFB
#define REG_BK338C_7E_L      0x338CFC
#define REG_BK338C_7E_H      0x338CFD
#define REG_BK338C_7F_L      0x338CFE
#define REG_BK338C_7F_H      0x338CFF
//----------------------------------------------
#define REG_BK3390_00_L      0x339000
#define REG_BK3390_00_H      0x339001
#define REG_BK3390_01_L      0x339002
#define REG_BK3390_01_H      0x339003
#define REG_BK3390_02_L      0x339004
#define REG_BK3390_02_H      0x339005
#define REG_BK3390_03_L      0x339006
#define REG_BK3390_03_H      0x339007
#define REG_BK3390_04_L      0x339008
#define REG_BK3390_04_H      0x339009
#define REG_BK3390_05_L      0x33900A
#define REG_BK3390_05_H      0x33900B
#define REG_BK3390_06_L      0x33900C
#define REG_BK3390_06_H      0x33900D
#define REG_BK3390_07_L      0x33900E
#define REG_BK3390_07_H      0x33900F
#define REG_BK3390_08_L      0x339010
#define REG_BK3390_08_H      0x339011
#define REG_BK3390_09_L      0x339012
#define REG_BK3390_09_H      0x339013
#define REG_BK3390_0A_L      0x339014
#define REG_BK3390_0A_H      0x339015
#define REG_BK3390_0B_L      0x339016
#define REG_BK3390_0B_H      0x339017
#define REG_BK3390_0C_L      0x339018
#define REG_BK3390_0C_H      0x339019
#define REG_BK3390_0D_L      0x33901A
#define REG_BK3390_0D_H      0x33901B
#define REG_BK3390_0E_L      0x33901C
#define REG_BK3390_0E_H      0x33901D
#define REG_BK3390_0F_L      0x33901E
#define REG_BK3390_0F_H      0x33901F
#define REG_BK3390_10_L      0x339020
#define REG_BK3390_10_H      0x339021
#define REG_BK3390_11_L      0x339022
#define REG_BK3390_11_H      0x339023
#define REG_BK3390_12_L      0x339024
#define REG_BK3390_12_H      0x339025
#define REG_BK3390_13_L      0x339026
#define REG_BK3390_13_H      0x339027
#define REG_BK3390_14_L      0x339028
#define REG_BK3390_14_H      0x339029
#define REG_BK3390_15_L      0x33902A
#define REG_BK3390_15_H      0x33902B
#define REG_BK3390_16_L      0x33902C
#define REG_BK3390_16_H      0x33902D
#define REG_BK3390_17_L      0x33902E
#define REG_BK3390_17_H      0x33902F
#define REG_BK3390_18_L      0x339030
#define REG_BK3390_18_H      0x339031
#define REG_BK3390_19_L      0x339032
#define REG_BK3390_19_H      0x339033
#define REG_BK3390_1A_L      0x339034
#define REG_BK3390_1A_H      0x339035
#define REG_BK3390_1B_L      0x339036
#define REG_BK3390_1B_H      0x339037
#define REG_BK3390_1C_L      0x339038
#define REG_BK3390_1C_H      0x339039
#define REG_BK3390_1D_L      0x33903A
#define REG_BK3390_1D_H      0x33903B
#define REG_BK3390_1E_L      0x33903C
#define REG_BK3390_1E_H      0x33903D
#define REG_BK3390_1F_L      0x33903E
#define REG_BK3390_1F_H      0x33903F
#define REG_BK3390_20_L      0x339040
#define REG_BK3390_20_H      0x339041
#define REG_BK3390_21_L      0x339042
#define REG_BK3390_21_H      0x339043
#define REG_BK3390_22_L      0x339044
#define REG_BK3390_22_H      0x339045
#define REG_BK3390_23_L      0x339046
#define REG_BK3390_23_H      0x339047
#define REG_BK3390_24_L      0x339048
#define REG_BK3390_24_H      0x339049
#define REG_BK3390_25_L      0x33904A
#define REG_BK3390_25_H      0x33904B
#define REG_BK3390_26_L      0x33904C
#define REG_BK3390_26_H      0x33904D
#define REG_BK3390_27_L      0x33904E
#define REG_BK3390_27_H      0x33904F
#define REG_BK3390_28_L      0x339050
#define REG_BK3390_28_H      0x339051
#define REG_BK3390_29_L      0x339052
#define REG_BK3390_29_H      0x339053
#define REG_BK3390_2A_L      0x339054
#define REG_BK3390_2A_H      0x339055
#define REG_BK3390_2B_L      0x339056
#define REG_BK3390_2B_H      0x339057
#define REG_BK3390_2C_L      0x339058
#define REG_BK3390_2C_H      0x339059
#define REG_BK3390_2D_L      0x33905A
#define REG_BK3390_2D_H      0x33905B
#define REG_BK3390_2E_L      0x33905C
#define REG_BK3390_2E_H      0x33905D
#define REG_BK3390_2F_L      0x33905E
#define REG_BK3390_2F_H      0x33905F
#define REG_BK3390_30_L      0x339060
#define REG_BK3390_30_H      0x339061
#define REG_BK3390_31_L      0x339062
#define REG_BK3390_31_H      0x339063
#define REG_BK3390_32_L      0x339064
#define REG_BK3390_32_H      0x339065
#define REG_BK3390_33_L      0x339066
#define REG_BK3390_33_H      0x339067
#define REG_BK3390_34_L      0x339068
#define REG_BK3390_34_H      0x339069
#define REG_BK3390_35_L      0x33906A
#define REG_BK3390_35_H      0x33906B
#define REG_BK3390_36_L      0x33906C
#define REG_BK3390_36_H      0x33906D
#define REG_BK3390_37_L      0x33906E
#define REG_BK3390_37_H      0x33906F
#define REG_BK3390_38_L      0x339070
#define REG_BK3390_38_H      0x339071
#define REG_BK3390_39_L      0x339072
#define REG_BK3390_39_H      0x339073
#define REG_BK3390_3A_L      0x339074
#define REG_BK3390_3A_H      0x339075
#define REG_BK3390_3B_L      0x339076
#define REG_BK3390_3B_H      0x339077
#define REG_BK3390_3C_L      0x339078
#define REG_BK3390_3C_H      0x339079
#define REG_BK3390_3D_L      0x33907A
#define REG_BK3390_3D_H      0x33907B
#define REG_BK3390_3E_L      0x33907C
#define REG_BK3390_3E_H      0x33907D
#define REG_BK3390_3F_L      0x33907E
#define REG_BK3390_3F_H      0x33907F
#define REG_BK3390_40_L      0x339080
#define REG_BK3390_40_H      0x339081
#define REG_BK3390_41_L      0x339082
#define REG_BK3390_41_H      0x339083
#define REG_BK3390_42_L      0x339084
#define REG_BK3390_42_H      0x339085
#define REG_BK3390_43_L      0x339086
#define REG_BK3390_43_H      0x339087
#define REG_BK3390_44_L      0x339088
#define REG_BK3390_44_H      0x339089
#define REG_BK3390_45_L      0x33908A
#define REG_BK3390_45_H      0x33908B
#define REG_BK3390_46_L      0x33908C
#define REG_BK3390_46_H      0x33908D
#define REG_BK3390_47_L      0x33908E
#define REG_BK3390_47_H      0x33908F
#define REG_BK3390_48_L      0x339090
#define REG_BK3390_48_H      0x339091
#define REG_BK3390_49_L      0x339092
#define REG_BK3390_49_H      0x339093
#define REG_BK3390_4A_L      0x339094
#define REG_BK3390_4A_H      0x339095
#define REG_BK3390_4B_L      0x339096
#define REG_BK3390_4B_H      0x339097
#define REG_BK3390_4C_L      0x339098
#define REG_BK3390_4C_H      0x339099
#define REG_BK3390_4D_L      0x33909A
#define REG_BK3390_4D_H      0x33909B
#define REG_BK3390_4E_L      0x33909C
#define REG_BK3390_4E_H      0x33909D
#define REG_BK3390_4F_L      0x33909E
#define REG_BK3390_4F_H      0x33909F
#define REG_BK3390_50_L      0x3390A0
#define REG_BK3390_50_H      0x3390A1
#define REG_BK3390_51_L      0x3390A2
#define REG_BK3390_51_H      0x3390A3
#define REG_BK3390_52_L      0x3390A4
#define REG_BK3390_52_H      0x3390A5
#define REG_BK3390_53_L      0x3390A6
#define REG_BK3390_53_H      0x3390A7
#define REG_BK3390_54_L      0x3390A8
#define REG_BK3390_54_H      0x3390A9
#define REG_BK3390_55_L      0x3390AA
#define REG_BK3390_55_H      0x3390AB
#define REG_BK3390_56_L      0x3390AC
#define REG_BK3390_56_H      0x3390AD
#define REG_BK3390_57_L      0x3390AE
#define REG_BK3390_57_H      0x3390AF
#define REG_BK3390_58_L      0x3390B0
#define REG_BK3390_58_H      0x3390B1
#define REG_BK3390_59_L      0x3390B2
#define REG_BK3390_59_H      0x3390B3
#define REG_BK3390_5A_L      0x3390B4
#define REG_BK3390_5A_H      0x3390B5
#define REG_BK3390_5B_L      0x3390B6
#define REG_BK3390_5B_H      0x3390B7
#define REG_BK3390_5C_L      0x3390B8
#define REG_BK3390_5C_H      0x3390B9
#define REG_BK3390_5D_L      0x3390BA
#define REG_BK3390_5D_H      0x3390BB
#define REG_BK3390_5E_L      0x3390BC
#define REG_BK3390_5E_H      0x3390BD
#define REG_BK3390_5F_L      0x3390BE
#define REG_BK3390_5F_H      0x3390BF
#define REG_BK3390_60_L      0x3390C0
#define REG_BK3390_60_H      0x3390C1
#define REG_BK3390_61_L      0x3390C2
#define REG_BK3390_61_H      0x3390C3
#define REG_BK3390_62_L      0x3390C4
#define REG_BK3390_62_H      0x3390C5
#define REG_BK3390_63_L      0x3390C6
#define REG_BK3390_63_H      0x3390C7
#define REG_BK3390_64_L      0x3390C8
#define REG_BK3390_64_H      0x3390C9
#define REG_BK3390_65_L      0x3390CA
#define REG_BK3390_65_H      0x3390CB
#define REG_BK3390_66_L      0x3390CC
#define REG_BK3390_66_H      0x3390CD
#define REG_BK3390_67_L      0x3390CE
#define REG_BK3390_67_H      0x3390CF
#define REG_BK3390_68_L      0x3390D0
#define REG_BK3390_68_H      0x3390D1
#define REG_BK3390_69_L      0x3390D2
#define REG_BK3390_69_H      0x3390D3
#define REG_BK3390_6A_L      0x3390D4
#define REG_BK3390_6A_H      0x3390D5
#define REG_BK3390_6B_L      0x3390D6
#define REG_BK3390_6B_H      0x3390D7
#define REG_BK3390_6C_L      0x3390D8
#define REG_BK3390_6C_H      0x3390D9
#define REG_BK3390_6D_L      0x3390DA
#define REG_BK3390_6D_H      0x3390DB
#define REG_BK3390_6E_L      0x3390DC
#define REG_BK3390_6E_H      0x3390DD
#define REG_BK3390_6F_L      0x3390DE
#define REG_BK3390_6F_H      0x3390DF
#define REG_BK3390_70_L      0x3390E0
#define REG_BK3390_70_H      0x3390E1
#define REG_BK3390_71_L      0x3390E2
#define REG_BK3390_71_H      0x3390E3
#define REG_BK3390_72_L      0x3390E4
#define REG_BK3390_72_H      0x3390E5
#define REG_BK3390_73_L      0x3390E6
#define REG_BK3390_73_H      0x3390E7
#define REG_BK3390_74_L      0x3390E8
#define REG_BK3390_74_H      0x3390E9
#define REG_BK3390_75_L      0x3390EA
#define REG_BK3390_75_H      0x3390EB
#define REG_BK3390_76_L      0x3390EC
#define REG_BK3390_76_H      0x3390ED
#define REG_BK3390_77_L      0x3390EE
#define REG_BK3390_77_H      0x3390EF
#define REG_BK3390_78_L      0x3390F0
#define REG_BK3390_78_H      0x3390F1
#define REG_BK3390_79_L      0x3390F2
#define REG_BK3390_79_H      0x3390F3
#define REG_BK3390_7A_L      0x3390F4
#define REG_BK3390_7A_H      0x3390F5
#define REG_BK3390_7B_L      0x3390F6
#define REG_BK3390_7B_H      0x3390F7
#define REG_BK3390_7C_L      0x3390F8
#define REG_BK3390_7C_H      0x3390F9
#define REG_BK3390_7D_L      0x3390FA
#define REG_BK3390_7D_H      0x3390FB
#define REG_BK3390_7E_L      0x3390FC
#define REG_BK3390_7E_H      0x3390FD
#define REG_BK3390_7F_L      0x3390FE
#define REG_BK3390_7F_H      0x3390FF
//----------------------------------------------
#define REG_BK3391_00_L      0x339100
#define REG_BK3391_00_H      0x339101
#define REG_BK3391_01_L      0x339102
#define REG_BK3391_01_H      0x339103
#define REG_BK3391_02_L      0x339104
#define REG_BK3391_02_H      0x339105
#define REG_BK3391_03_L      0x339106
#define REG_BK3391_03_H      0x339107
#define REG_BK3391_04_L      0x339108
#define REG_BK3391_04_H      0x339109
#define REG_BK3391_05_L      0x33910A
#define REG_BK3391_05_H      0x33910B
#define REG_BK3391_06_L      0x33910C
#define REG_BK3391_06_H      0x33910D
#define REG_BK3391_07_L      0x33910E
#define REG_BK3391_07_H      0x33910F
#define REG_BK3391_08_L      0x339110
#define REG_BK3391_08_H      0x339111
#define REG_BK3391_09_L      0x339112
#define REG_BK3391_09_H      0x339113
#define REG_BK3391_0A_L      0x339114
#define REG_BK3391_0A_H      0x339115
#define REG_BK3391_0B_L      0x339116
#define REG_BK3391_0B_H      0x339117
#define REG_BK3391_0C_L      0x339118
#define REG_BK3391_0C_H      0x339119
#define REG_BK3391_0D_L      0x33911A
#define REG_BK3391_0D_H      0x33911B
#define REG_BK3391_0E_L      0x33911C
#define REG_BK3391_0E_H      0x33911D
#define REG_BK3391_0F_L      0x33911E
#define REG_BK3391_0F_H      0x33911F
#define REG_BK3391_10_L      0x339120
#define REG_BK3391_10_H      0x339121
#define REG_BK3391_11_L      0x339122
#define REG_BK3391_11_H      0x339123
#define REG_BK3391_12_L      0x339124
#define REG_BK3391_12_H      0x339125
#define REG_BK3391_13_L      0x339126
#define REG_BK3391_13_H      0x339127
#define REG_BK3391_14_L      0x339128
#define REG_BK3391_14_H      0x339129
#define REG_BK3391_15_L      0x33912A
#define REG_BK3391_15_H      0x33912B
#define REG_BK3391_16_L      0x33912C
#define REG_BK3391_16_H      0x33912D
#define REG_BK3391_17_L      0x33912E
#define REG_BK3391_17_H      0x33912F
#define REG_BK3391_18_L      0x339130
#define REG_BK3391_18_H      0x339131
#define REG_BK3391_19_L      0x339132
#define REG_BK3391_19_H      0x339133
#define REG_BK3391_1A_L      0x339134
#define REG_BK3391_1A_H      0x339135
#define REG_BK3391_1B_L      0x339136
#define REG_BK3391_1B_H      0x339137
#define REG_BK3391_1C_L      0x339138
#define REG_BK3391_1C_H      0x339139
#define REG_BK3391_1D_L      0x33913A
#define REG_BK3391_1D_H      0x33913B
#define REG_BK3391_1E_L      0x33913C
#define REG_BK3391_1E_H      0x33913D
#define REG_BK3391_1F_L      0x33913E
#define REG_BK3391_1F_H      0x33913F
#define REG_BK3391_20_L      0x339140
#define REG_BK3391_20_H      0x339141
#define REG_BK3391_21_L      0x339142
#define REG_BK3391_21_H      0x339143
#define REG_BK3391_22_L      0x339144
#define REG_BK3391_22_H      0x339145
#define REG_BK3391_23_L      0x339146
#define REG_BK3391_23_H      0x339147
#define REG_BK3391_24_L      0x339148
#define REG_BK3391_24_H      0x339149
#define REG_BK3391_25_L      0x33914A
#define REG_BK3391_25_H      0x33914B
#define REG_BK3391_26_L      0x33914C
#define REG_BK3391_26_H      0x33914D
#define REG_BK3391_27_L      0x33914E
#define REG_BK3391_27_H      0x33914F
#define REG_BK3391_28_L      0x339150
#define REG_BK3391_28_H      0x339151
#define REG_BK3391_29_L      0x339152
#define REG_BK3391_29_H      0x339153
#define REG_BK3391_2A_L      0x339154
#define REG_BK3391_2A_H      0x339155
#define REG_BK3391_2B_L      0x339156
#define REG_BK3391_2B_H      0x339157
#define REG_BK3391_2C_L      0x339158
#define REG_BK3391_2C_H      0x339159
#define REG_BK3391_2D_L      0x33915A
#define REG_BK3391_2D_H      0x33915B
#define REG_BK3391_2E_L      0x33915C
#define REG_BK3391_2E_H      0x33915D
#define REG_BK3391_2F_L      0x33915E
#define REG_BK3391_2F_H      0x33915F
#define REG_BK3391_30_L      0x339160
#define REG_BK3391_30_H      0x339161
#define REG_BK3391_31_L      0x339162
#define REG_BK3391_31_H      0x339163
#define REG_BK3391_32_L      0x339164
#define REG_BK3391_32_H      0x339165
#define REG_BK3391_33_L      0x339166
#define REG_BK3391_33_H      0x339167
#define REG_BK3391_34_L      0x339168
#define REG_BK3391_34_H      0x339169
#define REG_BK3391_35_L      0x33916A
#define REG_BK3391_35_H      0x33916B
#define REG_BK3391_36_L      0x33916C
#define REG_BK3391_36_H      0x33916D
#define REG_BK3391_37_L      0x33916E
#define REG_BK3391_37_H      0x33916F
#define REG_BK3391_38_L      0x339170
#define REG_BK3391_38_H      0x339171
#define REG_BK3391_39_L      0x339172
#define REG_BK3391_39_H      0x339173
#define REG_BK3391_3A_L      0x339174
#define REG_BK3391_3A_H      0x339175
#define REG_BK3391_3B_L      0x339176
#define REG_BK3391_3B_H      0x339177
#define REG_BK3391_3C_L      0x339178
#define REG_BK3391_3C_H      0x339179
#define REG_BK3391_3D_L      0x33917A
#define REG_BK3391_3D_H      0x33917B
#define REG_BK3391_3E_L      0x33917C
#define REG_BK3391_3E_H      0x33917D
#define REG_BK3391_3F_L      0x33917E
#define REG_BK3391_3F_H      0x33917F
#define REG_BK3391_40_L      0x339180
#define REG_BK3391_40_H      0x339181
#define REG_BK3391_41_L      0x339182
#define REG_BK3391_41_H      0x339183
#define REG_BK3391_42_L      0x339184
#define REG_BK3391_42_H      0x339185
#define REG_BK3391_43_L      0x339186
#define REG_BK3391_43_H      0x339187
#define REG_BK3391_44_L      0x339188
#define REG_BK3391_44_H      0x339189
#define REG_BK3391_45_L      0x33918A
#define REG_BK3391_45_H      0x33918B
#define REG_BK3391_46_L      0x33918C
#define REG_BK3391_46_H      0x33918D
#define REG_BK3391_47_L      0x33918E
#define REG_BK3391_47_H      0x33918F
#define REG_BK3391_48_L      0x339190
#define REG_BK3391_48_H      0x339191
#define REG_BK3391_49_L      0x339192
#define REG_BK3391_49_H      0x339193
#define REG_BK3391_4A_L      0x339194
#define REG_BK3391_4A_H      0x339195
#define REG_BK3391_4B_L      0x339196
#define REG_BK3391_4B_H      0x339197
#define REG_BK3391_4C_L      0x339198
#define REG_BK3391_4C_H      0x339199
#define REG_BK3391_4D_L      0x33919A
#define REG_BK3391_4D_H      0x33919B
#define REG_BK3391_4E_L      0x33919C
#define REG_BK3391_4E_H      0x33919D
#define REG_BK3391_4F_L      0x33919E
#define REG_BK3391_4F_H      0x33919F
#define REG_BK3391_50_L      0x3391A0
#define REG_BK3391_50_H      0x3391A1
#define REG_BK3391_51_L      0x3391A2
#define REG_BK3391_51_H      0x3391A3
#define REG_BK3391_52_L      0x3391A4
#define REG_BK3391_52_H      0x3391A5
#define REG_BK3391_53_L      0x3391A6
#define REG_BK3391_53_H      0x3391A7
#define REG_BK3391_54_L      0x3391A8
#define REG_BK3391_54_H      0x3391A9
#define REG_BK3391_55_L      0x3391AA
#define REG_BK3391_55_H      0x3391AB
#define REG_BK3391_56_L      0x3391AC
#define REG_BK3391_56_H      0x3391AD
#define REG_BK3391_57_L      0x3391AE
#define REG_BK3391_57_H      0x3391AF
#define REG_BK3391_58_L      0x3391B0
#define REG_BK3391_58_H      0x3391B1
#define REG_BK3391_59_L      0x3391B2
#define REG_BK3391_59_H      0x3391B3
#define REG_BK3391_5A_L      0x3391B4
#define REG_BK3391_5A_H      0x3391B5
#define REG_BK3391_5B_L      0x3391B6
#define REG_BK3391_5B_H      0x3391B7
#define REG_BK3391_5C_L      0x3391B8
#define REG_BK3391_5C_H      0x3391B9
#define REG_BK3391_5D_L      0x3391BA
#define REG_BK3391_5D_H      0x3391BB
#define REG_BK3391_5E_L      0x3391BC
#define REG_BK3391_5E_H      0x3391BD
#define REG_BK3391_5F_L      0x3391BE
#define REG_BK3391_5F_H      0x3391BF
#define REG_BK3391_60_L      0x3391C0
#define REG_BK3391_60_H      0x3391C1
#define REG_BK3391_61_L      0x3391C2
#define REG_BK3391_61_H      0x3391C3
#define REG_BK3391_62_L      0x3391C4
#define REG_BK3391_62_H      0x3391C5
#define REG_BK3391_63_L      0x3391C6
#define REG_BK3391_63_H      0x3391C7
#define REG_BK3391_64_L      0x3391C8
#define REG_BK3391_64_H      0x3391C9
#define REG_BK3391_65_L      0x3391CA
#define REG_BK3391_65_H      0x3391CB
#define REG_BK3391_66_L      0x3391CC
#define REG_BK3391_66_H      0x3391CD
#define REG_BK3391_67_L      0x3391CE
#define REG_BK3391_67_H      0x3391CF
#define REG_BK3391_68_L      0x3391D0
#define REG_BK3391_68_H      0x3391D1
#define REG_BK3391_69_L      0x3391D2
#define REG_BK3391_69_H      0x3391D3
#define REG_BK3391_6A_L      0x3391D4
#define REG_BK3391_6A_H      0x3391D5
#define REG_BK3391_6B_L      0x3391D6
#define REG_BK3391_6B_H      0x3391D7
#define REG_BK3391_6C_L      0x3391D8
#define REG_BK3391_6C_H      0x3391D9
#define REG_BK3391_6D_L      0x3391DA
#define REG_BK3391_6D_H      0x3391DB
#define REG_BK3391_6E_L      0x3391DC
#define REG_BK3391_6E_H      0x3391DD
#define REG_BK3391_6F_L      0x3391DE
#define REG_BK3391_6F_H      0x3391DF
#define REG_BK3391_70_L      0x3391E0
#define REG_BK3391_70_H      0x3391E1
#define REG_BK3391_71_L      0x3391E2
#define REG_BK3391_71_H      0x3391E3
#define REG_BK3391_72_L      0x3391E4
#define REG_BK3391_72_H      0x3391E5
#define REG_BK3391_73_L      0x3391E6
#define REG_BK3391_73_H      0x3391E7
#define REG_BK3391_74_L      0x3391E8
#define REG_BK3391_74_H      0x3391E9
#define REG_BK3391_75_L      0x3391EA
#define REG_BK3391_75_H      0x3391EB
#define REG_BK3391_76_L      0x3391EC
#define REG_BK3391_76_H      0x3391ED
#define REG_BK3391_77_L      0x3391EE
#define REG_BK3391_77_H      0x3391EF
#define REG_BK3391_78_L      0x3391F0
#define REG_BK3391_78_H      0x3391F1
#define REG_BK3391_79_L      0x3391F2
#define REG_BK3391_79_H      0x3391F3
#define REG_BK3391_7A_L      0x3391F4
#define REG_BK3391_7A_H      0x3391F5
#define REG_BK3391_7B_L      0x3391F6
#define REG_BK3391_7B_H      0x3391F7
#define REG_BK3391_7C_L      0x3391F8
#define REG_BK3391_7C_H      0x3391F9
#define REG_BK3391_7D_L      0x3391FA
#define REG_BK3391_7D_H      0x3391FB
#define REG_BK3391_7E_L      0x3391FC
#define REG_BK3391_7E_H      0x3391FD
#define REG_BK3391_7F_L      0x3391FE
#define REG_BK3391_7F_H      0x3391FF
//----------------------------------------------
#define REG_BK3392_00_L      0x339200
#define REG_BK3392_00_H      0x339201
#define REG_BK3392_01_L      0x339202
#define REG_BK3392_01_H      0x339203
#define REG_BK3392_02_L      0x339204
#define REG_BK3392_02_H      0x339205
#define REG_BK3392_03_L      0x339206
#define REG_BK3392_03_H      0x339207
#define REG_BK3392_04_L      0x339208
#define REG_BK3392_04_H      0x339209
#define REG_BK3392_05_L      0x33920A
#define REG_BK3392_05_H      0x33920B
#define REG_BK3392_06_L      0x33920C
#define REG_BK3392_06_H      0x33920D
#define REG_BK3392_07_L      0x33920E
#define REG_BK3392_07_H      0x33920F
#define REG_BK3392_08_L      0x339210
#define REG_BK3392_08_H      0x339211
#define REG_BK3392_09_L      0x339212
#define REG_BK3392_09_H      0x339213
#define REG_BK3392_0A_L      0x339214
#define REG_BK3392_0A_H      0x339215
#define REG_BK3392_0B_L      0x339216
#define REG_BK3392_0B_H      0x339217
#define REG_BK3392_0C_L      0x339218
#define REG_BK3392_0C_H      0x339219
#define REG_BK3392_0D_L      0x33921A
#define REG_BK3392_0D_H      0x33921B
#define REG_BK3392_0E_L      0x33921C
#define REG_BK3392_0E_H      0x33921D
#define REG_BK3392_0F_L      0x33921E
#define REG_BK3392_0F_H      0x33921F
#define REG_BK3392_10_L      0x339220
#define REG_BK3392_10_H      0x339221
#define REG_BK3392_11_L      0x339222
#define REG_BK3392_11_H      0x339223
#define REG_BK3392_12_L      0x339224
#define REG_BK3392_12_H      0x339225
#define REG_BK3392_13_L      0x339226
#define REG_BK3392_13_H      0x339227
#define REG_BK3392_14_L      0x339228
#define REG_BK3392_14_H      0x339229
#define REG_BK3392_15_L      0x33922A
#define REG_BK3392_15_H      0x33922B
#define REG_BK3392_16_L      0x33922C
#define REG_BK3392_16_H      0x33922D
#define REG_BK3392_17_L      0x33922E
#define REG_BK3392_17_H      0x33922F
#define REG_BK3392_18_L      0x339230
#define REG_BK3392_18_H      0x339231
#define REG_BK3392_19_L      0x339232
#define REG_BK3392_19_H      0x339233
#define REG_BK3392_1A_L      0x339234
#define REG_BK3392_1A_H      0x339235
#define REG_BK3392_1B_L      0x339236
#define REG_BK3392_1B_H      0x339237
#define REG_BK3392_1C_L      0x339238
#define REG_BK3392_1C_H      0x339239
#define REG_BK3392_1D_L      0x33923A
#define REG_BK3392_1D_H      0x33923B
#define REG_BK3392_1E_L      0x33923C
#define REG_BK3392_1E_H      0x33923D
#define REG_BK3392_1F_L      0x33923E
#define REG_BK3392_1F_H      0x33923F
#define REG_BK3392_20_L      0x339240
#define REG_BK3392_20_H      0x339241
#define REG_BK3392_21_L      0x339242
#define REG_BK3392_21_H      0x339243
#define REG_BK3392_22_L      0x339244
#define REG_BK3392_22_H      0x339245
#define REG_BK3392_23_L      0x339246
#define REG_BK3392_23_H      0x339247
#define REG_BK3392_24_L      0x339248
#define REG_BK3392_24_H      0x339249
#define REG_BK3392_25_L      0x33924A
#define REG_BK3392_25_H      0x33924B
#define REG_BK3392_26_L      0x33924C
#define REG_BK3392_26_H      0x33924D
#define REG_BK3392_27_L      0x33924E
#define REG_BK3392_27_H      0x33924F
#define REG_BK3392_28_L      0x339250
#define REG_BK3392_28_H      0x339251
#define REG_BK3392_29_L      0x339252
#define REG_BK3392_29_H      0x339253
#define REG_BK3392_2A_L      0x339254
#define REG_BK3392_2A_H      0x339255
#define REG_BK3392_2B_L      0x339256
#define REG_BK3392_2B_H      0x339257
#define REG_BK3392_2C_L      0x339258
#define REG_BK3392_2C_H      0x339259
#define REG_BK3392_2D_L      0x33925A
#define REG_BK3392_2D_H      0x33925B
#define REG_BK3392_2E_L      0x33925C
#define REG_BK3392_2E_H      0x33925D
#define REG_BK3392_2F_L      0x33925E
#define REG_BK3392_2F_H      0x33925F
#define REG_BK3392_30_L      0x339260
#define REG_BK3392_30_H      0x339261
#define REG_BK3392_31_L      0x339262
#define REG_BK3392_31_H      0x339263
#define REG_BK3392_32_L      0x339264
#define REG_BK3392_32_H      0x339265
#define REG_BK3392_33_L      0x339266
#define REG_BK3392_33_H      0x339267
#define REG_BK3392_34_L      0x339268
#define REG_BK3392_34_H      0x339269
#define REG_BK3392_35_L      0x33926A
#define REG_BK3392_35_H      0x33926B
#define REG_BK3392_36_L      0x33926C
#define REG_BK3392_36_H      0x33926D
#define REG_BK3392_37_L      0x33926E
#define REG_BK3392_37_H      0x33926F
#define REG_BK3392_38_L      0x339270
#define REG_BK3392_38_H      0x339271
#define REG_BK3392_39_L      0x339272
#define REG_BK3392_39_H      0x339273
#define REG_BK3392_3A_L      0x339274
#define REG_BK3392_3A_H      0x339275
#define REG_BK3392_3B_L      0x339276
#define REG_BK3392_3B_H      0x339277
#define REG_BK3392_3C_L      0x339278
#define REG_BK3392_3C_H      0x339279
#define REG_BK3392_3D_L      0x33927A
#define REG_BK3392_3D_H      0x33927B
#define REG_BK3392_3E_L      0x33927C
#define REG_BK3392_3E_H      0x33927D
#define REG_BK3392_3F_L      0x33927E
#define REG_BK3392_3F_H      0x33927F
#define REG_BK3392_40_L      0x339280
#define REG_BK3392_40_H      0x339281
#define REG_BK3392_41_L      0x339282
#define REG_BK3392_41_H      0x339283
#define REG_BK3392_42_L      0x339284
#define REG_BK3392_42_H      0x339285
#define REG_BK3392_43_L      0x339286
#define REG_BK3392_43_H      0x339287
#define REG_BK3392_44_L      0x339288
#define REG_BK3392_44_H      0x339289
#define REG_BK3392_45_L      0x33928A
#define REG_BK3392_45_H      0x33928B
#define REG_BK3392_46_L      0x33928C
#define REG_BK3392_46_H      0x33928D
#define REG_BK3392_47_L      0x33928E
#define REG_BK3392_47_H      0x33928F
#define REG_BK3392_48_L      0x339290
#define REG_BK3392_48_H      0x339291
#define REG_BK3392_49_L      0x339292
#define REG_BK3392_49_H      0x339293
#define REG_BK3392_4A_L      0x339294
#define REG_BK3392_4A_H      0x339295
#define REG_BK3392_4B_L      0x339296
#define REG_BK3392_4B_H      0x339297
#define REG_BK3392_4C_L      0x339298
#define REG_BK3392_4C_H      0x339299
#define REG_BK3392_4D_L      0x33929A
#define REG_BK3392_4D_H      0x33929B
#define REG_BK3392_4E_L      0x33929C
#define REG_BK3392_4E_H      0x33929D
#define REG_BK3392_4F_L      0x33929E
#define REG_BK3392_4F_H      0x33929F
#define REG_BK3392_50_L      0x3392A0
#define REG_BK3392_50_H      0x3392A1
#define REG_BK3392_51_L      0x3392A2
#define REG_BK3392_51_H      0x3392A3
#define REG_BK3392_52_L      0x3392A4
#define REG_BK3392_52_H      0x3392A5
#define REG_BK3392_53_L      0x3392A6
#define REG_BK3392_53_H      0x3392A7
#define REG_BK3392_54_L      0x3392A8
#define REG_BK3392_54_H      0x3392A9
#define REG_BK3392_55_L      0x3392AA
#define REG_BK3392_55_H      0x3392AB
#define REG_BK3392_56_L      0x3392AC
#define REG_BK3392_56_H      0x3392AD
#define REG_BK3392_57_L      0x3392AE
#define REG_BK3392_57_H      0x3392AF
#define REG_BK3392_58_L      0x3392B0
#define REG_BK3392_58_H      0x3392B1
#define REG_BK3392_59_L      0x3392B2
#define REG_BK3392_59_H      0x3392B3
#define REG_BK3392_5A_L      0x3392B4
#define REG_BK3392_5A_H      0x3392B5
#define REG_BK3392_5B_L      0x3392B6
#define REG_BK3392_5B_H      0x3392B7
#define REG_BK3392_5C_L      0x3392B8
#define REG_BK3392_5C_H      0x3392B9
#define REG_BK3392_5D_L      0x3392BA
#define REG_BK3392_5D_H      0x3392BB
#define REG_BK3392_5E_L      0x3392BC
#define REG_BK3392_5E_H      0x3392BD
#define REG_BK3392_5F_L      0x3392BE
#define REG_BK3392_5F_H      0x3392BF
#define REG_BK3392_60_L      0x3392C0
#define REG_BK3392_60_H      0x3392C1
#define REG_BK3392_61_L      0x3392C2
#define REG_BK3392_61_H      0x3392C3
#define REG_BK3392_62_L      0x3392C4
#define REG_BK3392_62_H      0x3392C5
#define REG_BK3392_63_L      0x3392C6
#define REG_BK3392_63_H      0x3392C7
#define REG_BK3392_64_L      0x3392C8
#define REG_BK3392_64_H      0x3392C9
#define REG_BK3392_65_L      0x3392CA
#define REG_BK3392_65_H      0x3392CB
#define REG_BK3392_66_L      0x3392CC
#define REG_BK3392_66_H      0x3392CD
#define REG_BK3392_67_L      0x3392CE
#define REG_BK3392_67_H      0x3392CF
#define REG_BK3392_68_L      0x3392D0
#define REG_BK3392_68_H      0x3392D1
#define REG_BK3392_69_L      0x3392D2
#define REG_BK3392_69_H      0x3392D3
#define REG_BK3392_6A_L      0x3392D4
#define REG_BK3392_6A_H      0x3392D5
#define REG_BK3392_6B_L      0x3392D6
#define REG_BK3392_6B_H      0x3392D7
#define REG_BK3392_6C_L      0x3392D8
#define REG_BK3392_6C_H      0x3392D9
#define REG_BK3392_6D_L      0x3392DA
#define REG_BK3392_6D_H      0x3392DB
#define REG_BK3392_6E_L      0x3392DC
#define REG_BK3392_6E_H      0x3392DD
#define REG_BK3392_6F_L      0x3392DE
#define REG_BK3392_6F_H      0x3392DF
#define REG_BK3392_70_L      0x3392E0
#define REG_BK3392_70_H      0x3392E1
#define REG_BK3392_71_L      0x3392E2
#define REG_BK3392_71_H      0x3392E3
#define REG_BK3392_72_L      0x3392E4
#define REG_BK3392_72_H      0x3392E5
#define REG_BK3392_73_L      0x3392E6
#define REG_BK3392_73_H      0x3392E7
#define REG_BK3392_74_L      0x3392E8
#define REG_BK3392_74_H      0x3392E9
#define REG_BK3392_75_L      0x3392EA
#define REG_BK3392_75_H      0x3392EB
#define REG_BK3392_76_L      0x3392EC
#define REG_BK3392_76_H      0x3392ED
#define REG_BK3392_77_L      0x3392EE
#define REG_BK3392_77_H      0x3392EF
#define REG_BK3392_78_L      0x3392F0
#define REG_BK3392_78_H      0x3392F1
#define REG_BK3392_79_L      0x3392F2
#define REG_BK3392_79_H      0x3392F3
#define REG_BK3392_7A_L      0x3392F4
#define REG_BK3392_7A_H      0x3392F5
#define REG_BK3392_7B_L      0x3392F6
#define REG_BK3392_7B_H      0x3392F7
#define REG_BK3392_7C_L      0x3392F8
#define REG_BK3392_7C_H      0x3392F9
#define REG_BK3392_7D_L      0x3392FA
#define REG_BK3392_7D_H      0x3392FB
#define REG_BK3392_7E_L      0x3392FC
#define REG_BK3392_7E_H      0x3392FD
#define REG_BK3392_7F_L      0x3392FE
#define REG_BK3392_7F_H      0x3392FF
//----------------------------------------------
#define REG_BK3393_00_L      0x339300
#define REG_BK3393_00_H      0x339301
#define REG_BK3393_01_L      0x339302
#define REG_BK3393_01_H      0x339303
#define REG_BK3393_02_L      0x339304
#define REG_BK3393_02_H      0x339305
#define REG_BK3393_03_L      0x339306
#define REG_BK3393_03_H      0x339307
#define REG_BK3393_04_L      0x339308
#define REG_BK3393_04_H      0x339309
#define REG_BK3393_05_L      0x33930A
#define REG_BK3393_05_H      0x33930B
#define REG_BK3393_06_L      0x33930C
#define REG_BK3393_06_H      0x33930D
#define REG_BK3393_07_L      0x33930E
#define REG_BK3393_07_H      0x33930F
#define REG_BK3393_08_L      0x339310
#define REG_BK3393_08_H      0x339311
#define REG_BK3393_09_L      0x339312
#define REG_BK3393_09_H      0x339313
#define REG_BK3393_0A_L      0x339314
#define REG_BK3393_0A_H      0x339315
#define REG_BK3393_0B_L      0x339316
#define REG_BK3393_0B_H      0x339317
#define REG_BK3393_0C_L      0x339318
#define REG_BK3393_0C_H      0x339319
#define REG_BK3393_0D_L      0x33931A
#define REG_BK3393_0D_H      0x33931B
#define REG_BK3393_0E_L      0x33931C
#define REG_BK3393_0E_H      0x33931D
#define REG_BK3393_0F_L      0x33931E
#define REG_BK3393_0F_H      0x33931F
#define REG_BK3393_10_L      0x339320
#define REG_BK3393_10_H      0x339321
#define REG_BK3393_11_L      0x339322
#define REG_BK3393_11_H      0x339323
#define REG_BK3393_12_L      0x339324
#define REG_BK3393_12_H      0x339325
#define REG_BK3393_13_L      0x339326
#define REG_BK3393_13_H      0x339327
#define REG_BK3393_14_L      0x339328
#define REG_BK3393_14_H      0x339329
#define REG_BK3393_15_L      0x33932A
#define REG_BK3393_15_H      0x33932B
#define REG_BK3393_16_L      0x33932C
#define REG_BK3393_16_H      0x33932D
#define REG_BK3393_17_L      0x33932E
#define REG_BK3393_17_H      0x33932F
#define REG_BK3393_18_L      0x339330
#define REG_BK3393_18_H      0x339331
#define REG_BK3393_19_L      0x339332
#define REG_BK3393_19_H      0x339333
#define REG_BK3393_1A_L      0x339334
#define REG_BK3393_1A_H      0x339335
#define REG_BK3393_1B_L      0x339336
#define REG_BK3393_1B_H      0x339337
#define REG_BK3393_1C_L      0x339338
#define REG_BK3393_1C_H      0x339339
#define REG_BK3393_1D_L      0x33933A
#define REG_BK3393_1D_H      0x33933B
#define REG_BK3393_1E_L      0x33933C
#define REG_BK3393_1E_H      0x33933D
#define REG_BK3393_1F_L      0x33933E
#define REG_BK3393_1F_H      0x33933F
#define REG_BK3393_20_L      0x339340
#define REG_BK3393_20_H      0x339341
#define REG_BK3393_21_L      0x339342
#define REG_BK3393_21_H      0x339343
#define REG_BK3393_22_L      0x339344
#define REG_BK3393_22_H      0x339345
#define REG_BK3393_23_L      0x339346
#define REG_BK3393_23_H      0x339347
#define REG_BK3393_24_L      0x339348
#define REG_BK3393_24_H      0x339349
#define REG_BK3393_25_L      0x33934A
#define REG_BK3393_25_H      0x33934B
#define REG_BK3393_26_L      0x33934C
#define REG_BK3393_26_H      0x33934D
#define REG_BK3393_27_L      0x33934E
#define REG_BK3393_27_H      0x33934F
#define REG_BK3393_28_L      0x339350
#define REG_BK3393_28_H      0x339351
#define REG_BK3393_29_L      0x339352
#define REG_BK3393_29_H      0x339353
#define REG_BK3393_2A_L      0x339354
#define REG_BK3393_2A_H      0x339355
#define REG_BK3393_2B_L      0x339356
#define REG_BK3393_2B_H      0x339357
#define REG_BK3393_2C_L      0x339358
#define REG_BK3393_2C_H      0x339359
#define REG_BK3393_2D_L      0x33935A
#define REG_BK3393_2D_H      0x33935B
#define REG_BK3393_2E_L      0x33935C
#define REG_BK3393_2E_H      0x33935D
#define REG_BK3393_2F_L      0x33935E
#define REG_BK3393_2F_H      0x33935F
#define REG_BK3393_30_L      0x339360
#define REG_BK3393_30_H      0x339361
#define REG_BK3393_31_L      0x339362
#define REG_BK3393_31_H      0x339363
#define REG_BK3393_32_L      0x339364
#define REG_BK3393_32_H      0x339365
#define REG_BK3393_33_L      0x339366
#define REG_BK3393_33_H      0x339367
#define REG_BK3393_34_L      0x339368
#define REG_BK3393_34_H      0x339369
#define REG_BK3393_35_L      0x33936A
#define REG_BK3393_35_H      0x33936B
#define REG_BK3393_36_L      0x33936C
#define REG_BK3393_36_H      0x33936D
#define REG_BK3393_37_L      0x33936E
#define REG_BK3393_37_H      0x33936F
#define REG_BK3393_38_L      0x339370
#define REG_BK3393_38_H      0x339371
#define REG_BK3393_39_L      0x339372
#define REG_BK3393_39_H      0x339373
#define REG_BK3393_3A_L      0x339374
#define REG_BK3393_3A_H      0x339375
#define REG_BK3393_3B_L      0x339376
#define REG_BK3393_3B_H      0x339377
#define REG_BK3393_3C_L      0x339378
#define REG_BK3393_3C_H      0x339379
#define REG_BK3393_3D_L      0x33937A
#define REG_BK3393_3D_H      0x33937B
#define REG_BK3393_3E_L      0x33937C
#define REG_BK3393_3E_H      0x33937D
#define REG_BK3393_3F_L      0x33937E
#define REG_BK3393_3F_H      0x33937F
#define REG_BK3393_40_L      0x339380
#define REG_BK3393_40_H      0x339381
#define REG_BK3393_41_L      0x339382
#define REG_BK3393_41_H      0x339383
#define REG_BK3393_42_L      0x339384
#define REG_BK3393_42_H      0x339385
#define REG_BK3393_43_L      0x339386
#define REG_BK3393_43_H      0x339387
#define REG_BK3393_44_L      0x339388
#define REG_BK3393_44_H      0x339389
#define REG_BK3393_45_L      0x33938A
#define REG_BK3393_45_H      0x33938B
#define REG_BK3393_46_L      0x33938C
#define REG_BK3393_46_H      0x33938D
#define REG_BK3393_47_L      0x33938E
#define REG_BK3393_47_H      0x33938F
#define REG_BK3393_48_L      0x339390
#define REG_BK3393_48_H      0x339391
#define REG_BK3393_49_L      0x339392
#define REG_BK3393_49_H      0x339393
#define REG_BK3393_4A_L      0x339394
#define REG_BK3393_4A_H      0x339395
#define REG_BK3393_4B_L      0x339396
#define REG_BK3393_4B_H      0x339397
#define REG_BK3393_4C_L      0x339398
#define REG_BK3393_4C_H      0x339399
#define REG_BK3393_4D_L      0x33939A
#define REG_BK3393_4D_H      0x33939B
#define REG_BK3393_4E_L      0x33939C
#define REG_BK3393_4E_H      0x33939D
#define REG_BK3393_4F_L      0x33939E
#define REG_BK3393_4F_H      0x33939F
#define REG_BK3393_50_L      0x3393A0
#define REG_BK3393_50_H      0x3393A1
#define REG_BK3393_51_L      0x3393A2
#define REG_BK3393_51_H      0x3393A3
#define REG_BK3393_52_L      0x3393A4
#define REG_BK3393_52_H      0x3393A5
#define REG_BK3393_53_L      0x3393A6
#define REG_BK3393_53_H      0x3393A7
#define REG_BK3393_54_L      0x3393A8
#define REG_BK3393_54_H      0x3393A9
#define REG_BK3393_55_L      0x3393AA
#define REG_BK3393_55_H      0x3393AB
#define REG_BK3393_56_L      0x3393AC
#define REG_BK3393_56_H      0x3393AD
#define REG_BK3393_57_L      0x3393AE
#define REG_BK3393_57_H      0x3393AF
#define REG_BK3393_58_L      0x3393B0
#define REG_BK3393_58_H      0x3393B1
#define REG_BK3393_59_L      0x3393B2
#define REG_BK3393_59_H      0x3393B3
#define REG_BK3393_5A_L      0x3393B4
#define REG_BK3393_5A_H      0x3393B5
#define REG_BK3393_5B_L      0x3393B6
#define REG_BK3393_5B_H      0x3393B7
#define REG_BK3393_5C_L      0x3393B8
#define REG_BK3393_5C_H      0x3393B9
#define REG_BK3393_5D_L      0x3393BA
#define REG_BK3393_5D_H      0x3393BB
#define REG_BK3393_5E_L      0x3393BC
#define REG_BK3393_5E_H      0x3393BD
#define REG_BK3393_5F_L      0x3393BE
#define REG_BK3393_5F_H      0x3393BF
#define REG_BK3393_60_L      0x3393C0
#define REG_BK3393_60_H      0x3393C1
#define REG_BK3393_61_L      0x3393C2
#define REG_BK3393_61_H      0x3393C3
#define REG_BK3393_62_L      0x3393C4
#define REG_BK3393_62_H      0x3393C5
#define REG_BK3393_63_L      0x3393C6
#define REG_BK3393_63_H      0x3393C7
#define REG_BK3393_64_L      0x3393C8
#define REG_BK3393_64_H      0x3393C9
#define REG_BK3393_65_L      0x3393CA
#define REG_BK3393_65_H      0x3393CB
#define REG_BK3393_66_L      0x3393CC
#define REG_BK3393_66_H      0x3393CD
#define REG_BK3393_67_L      0x3393CE
#define REG_BK3393_67_H      0x3393CF
#define REG_BK3393_68_L      0x3393D0
#define REG_BK3393_68_H      0x3393D1
#define REG_BK3393_69_L      0x3393D2
#define REG_BK3393_69_H      0x3393D3
#define REG_BK3393_6A_L      0x3393D4
#define REG_BK3393_6A_H      0x3393D5
#define REG_BK3393_6B_L      0x3393D6
#define REG_BK3393_6B_H      0x3393D7
#define REG_BK3393_6C_L      0x3393D8
#define REG_BK3393_6C_H      0x3393D9
#define REG_BK3393_6D_L      0x3393DA
#define REG_BK3393_6D_H      0x3393DB
#define REG_BK3393_6E_L      0x3393DC
#define REG_BK3393_6E_H      0x3393DD
#define REG_BK3393_6F_L      0x3393DE
#define REG_BK3393_6F_H      0x3393DF
#define REG_BK3393_70_L      0x3393E0
#define REG_BK3393_70_H      0x3393E1
#define REG_BK3393_71_L      0x3393E2
#define REG_BK3393_71_H      0x3393E3
#define REG_BK3393_72_L      0x3393E4
#define REG_BK3393_72_H      0x3393E5
#define REG_BK3393_73_L      0x3393E6
#define REG_BK3393_73_H      0x3393E7
#define REG_BK3393_74_L      0x3393E8
#define REG_BK3393_74_H      0x3393E9
#define REG_BK3393_75_L      0x3393EA
#define REG_BK3393_75_H      0x3393EB
#define REG_BK3393_76_L      0x3393EC
#define REG_BK3393_76_H      0x3393ED
#define REG_BK3393_77_L      0x3393EE
#define REG_BK3393_77_H      0x3393EF
#define REG_BK3393_78_L      0x3393F0
#define REG_BK3393_78_H      0x3393F1
#define REG_BK3393_79_L      0x3393F2
#define REG_BK3393_79_H      0x3393F3
#define REG_BK3393_7A_L      0x3393F4
#define REG_BK3393_7A_H      0x3393F5
#define REG_BK3393_7B_L      0x3393F6
#define REG_BK3393_7B_H      0x3393F7
#define REG_BK3393_7C_L      0x3393F8
#define REG_BK3393_7C_H      0x3393F9
#define REG_BK3393_7D_L      0x3393FA
#define REG_BK3393_7D_H      0x3393FB
#define REG_BK3393_7E_L      0x3393FC
#define REG_BK3393_7E_H      0x3393FD
#define REG_BK3393_7F_L      0x3393FE
#define REG_BK3393_7F_H      0x3393FF
//----------------------------------------------
#define REG_BK3395_00_L      0x339500
#define REG_BK3395_00_H      0x339501
#define REG_BK3395_01_L      0x339502
#define REG_BK3395_01_H      0x339503
#define REG_BK3395_02_L      0x339504
#define REG_BK3395_02_H      0x339505
#define REG_BK3395_03_L      0x339506
#define REG_BK3395_03_H      0x339507
#define REG_BK3395_04_L      0x339508
#define REG_BK3395_04_H      0x339509
#define REG_BK3395_05_L      0x33950A
#define REG_BK3395_05_H      0x33950B
#define REG_BK3395_06_L      0x33950C
#define REG_BK3395_06_H      0x33950D
#define REG_BK3395_07_L      0x33950E
#define REG_BK3395_07_H      0x33950F
#define REG_BK3395_08_L      0x339510
#define REG_BK3395_08_H      0x339511
#define REG_BK3395_09_L      0x339512
#define REG_BK3395_09_H      0x339513
#define REG_BK3395_0A_L      0x339514
#define REG_BK3395_0A_H      0x339515
#define REG_BK3395_0B_L      0x339516
#define REG_BK3395_0B_H      0x339517
#define REG_BK3395_0C_L      0x339518
#define REG_BK3395_0C_H      0x339519
#define REG_BK3395_0D_L      0x33951A
#define REG_BK3395_0D_H      0x33951B
#define REG_BK3395_0E_L      0x33951C
#define REG_BK3395_0E_H      0x33951D
#define REG_BK3395_0F_L      0x33951E
#define REG_BK3395_0F_H      0x33951F
#define REG_BK3395_10_L      0x339520
#define REG_BK3395_10_H      0x339521
#define REG_BK3395_11_L      0x339522
#define REG_BK3395_11_H      0x339523
#define REG_BK3395_12_L      0x339524
#define REG_BK3395_12_H      0x339525
#define REG_BK3395_13_L      0x339526
#define REG_BK3395_13_H      0x339527
#define REG_BK3395_14_L      0x339528
#define REG_BK3395_14_H      0x339529
#define REG_BK3395_15_L      0x33952A
#define REG_BK3395_15_H      0x33952B
#define REG_BK3395_16_L      0x33952C
#define REG_BK3395_16_H      0x33952D
#define REG_BK3395_17_L      0x33952E
#define REG_BK3395_17_H      0x33952F
#define REG_BK3395_18_L      0x339530
#define REG_BK3395_18_H      0x339531
#define REG_BK3395_19_L      0x339532
#define REG_BK3395_19_H      0x339533
#define REG_BK3395_1A_L      0x339534
#define REG_BK3395_1A_H      0x339535
#define REG_BK3395_1B_L      0x339536
#define REG_BK3395_1B_H      0x339537
#define REG_BK3395_1C_L      0x339538
#define REG_BK3395_1C_H      0x339539
#define REG_BK3395_1D_L      0x33953A
#define REG_BK3395_1D_H      0x33953B
#define REG_BK3395_1E_L      0x33953C
#define REG_BK3395_1E_H      0x33953D
#define REG_BK3395_1F_L      0x33953E
#define REG_BK3395_1F_H      0x33953F
#define REG_BK3395_20_L      0x339540
#define REG_BK3395_20_H      0x339541
#define REG_BK3395_21_L      0x339542
#define REG_BK3395_21_H      0x339543
#define REG_BK3395_22_L      0x339544
#define REG_BK3395_22_H      0x339545
#define REG_BK3395_23_L      0x339546
#define REG_BK3395_23_H      0x339547
#define REG_BK3395_24_L      0x339548
#define REG_BK3395_24_H      0x339549
#define REG_BK3395_25_L      0x33954A
#define REG_BK3395_25_H      0x33954B
#define REG_BK3395_26_L      0x33954C
#define REG_BK3395_26_H      0x33954D
#define REG_BK3395_27_L      0x33954E
#define REG_BK3395_27_H      0x33954F
#define REG_BK3395_28_L      0x339550
#define REG_BK3395_28_H      0x339551
#define REG_BK3395_29_L      0x339552
#define REG_BK3395_29_H      0x339553
#define REG_BK3395_2A_L      0x339554
#define REG_BK3395_2A_H      0x339555
#define REG_BK3395_2B_L      0x339556
#define REG_BK3395_2B_H      0x339557
#define REG_BK3395_2C_L      0x339558
#define REG_BK3395_2C_H      0x339559
#define REG_BK3395_2D_L      0x33955A
#define REG_BK3395_2D_H      0x33955B
#define REG_BK3395_2E_L      0x33955C
#define REG_BK3395_2E_H      0x33955D
#define REG_BK3395_2F_L      0x33955E
#define REG_BK3395_2F_H      0x33955F
#define REG_BK3395_30_L      0x339560
#define REG_BK3395_30_H      0x339561
#define REG_BK3395_31_L      0x339562
#define REG_BK3395_31_H      0x339563
#define REG_BK3395_32_L      0x339564
#define REG_BK3395_32_H      0x339565
#define REG_BK3395_33_L      0x339566
#define REG_BK3395_33_H      0x339567
#define REG_BK3395_34_L      0x339568
#define REG_BK3395_34_H      0x339569
#define REG_BK3395_35_L      0x33956A
#define REG_BK3395_35_H      0x33956B
#define REG_BK3395_36_L      0x33956C
#define REG_BK3395_36_H      0x33956D
#define REG_BK3395_37_L      0x33956E
#define REG_BK3395_37_H      0x33956F
#define REG_BK3395_38_L      0x339570
#define REG_BK3395_38_H      0x339571
#define REG_BK3395_39_L      0x339572
#define REG_BK3395_39_H      0x339573
#define REG_BK3395_3A_L      0x339574
#define REG_BK3395_3A_H      0x339575
#define REG_BK3395_3B_L      0x339576
#define REG_BK3395_3B_H      0x339577
#define REG_BK3395_3C_L      0x339578
#define REG_BK3395_3C_H      0x339579
#define REG_BK3395_3D_L      0x33957A
#define REG_BK3395_3D_H      0x33957B
#define REG_BK3395_3E_L      0x33957C
#define REG_BK3395_3E_H      0x33957D
#define REG_BK3395_3F_L      0x33957E
#define REG_BK3395_3F_H      0x33957F
#define REG_BK3395_40_L      0x339580
#define REG_BK3395_40_H      0x339581
#define REG_BK3395_41_L      0x339582
#define REG_BK3395_41_H      0x339583
#define REG_BK3395_42_L      0x339584
#define REG_BK3395_42_H      0x339585
#define REG_BK3395_43_L      0x339586
#define REG_BK3395_43_H      0x339587
#define REG_BK3395_44_L      0x339588
#define REG_BK3395_44_H      0x339589
#define REG_BK3395_45_L      0x33958A
#define REG_BK3395_45_H      0x33958B
#define REG_BK3395_46_L      0x33958C
#define REG_BK3395_46_H      0x33958D
#define REG_BK3395_47_L      0x33958E
#define REG_BK3395_47_H      0x33958F
#define REG_BK3395_48_L      0x339590
#define REG_BK3395_48_H      0x339591
#define REG_BK3395_49_L      0x339592
#define REG_BK3395_49_H      0x339593
#define REG_BK3395_4A_L      0x339594
#define REG_BK3395_4A_H      0x339595
#define REG_BK3395_4B_L      0x339596
#define REG_BK3395_4B_H      0x339597
#define REG_BK3395_4C_L      0x339598
#define REG_BK3395_4C_H      0x339599
#define REG_BK3395_4D_L      0x33959A
#define REG_BK3395_4D_H      0x33959B
#define REG_BK3395_4E_L      0x33959C
#define REG_BK3395_4E_H      0x33959D
#define REG_BK3395_4F_L      0x33959E
#define REG_BK3395_4F_H      0x33959F
#define REG_BK3395_50_L      0x3395A0
#define REG_BK3395_50_H      0x3395A1
#define REG_BK3395_51_L      0x3395A2
#define REG_BK3395_51_H      0x3395A3
#define REG_BK3395_52_L      0x3395A4
#define REG_BK3395_52_H      0x3395A5
#define REG_BK3395_53_L      0x3395A6
#define REG_BK3395_53_H      0x3395A7
#define REG_BK3395_54_L      0x3395A8
#define REG_BK3395_54_H      0x3395A9
#define REG_BK3395_55_L      0x3395AA
#define REG_BK3395_55_H      0x3395AB
#define REG_BK3395_56_L      0x3395AC
#define REG_BK3395_56_H      0x3395AD
#define REG_BK3395_57_L      0x3395AE
#define REG_BK3395_57_H      0x3395AF
#define REG_BK3395_58_L      0x3395B0
#define REG_BK3395_58_H      0x3395B1
#define REG_BK3395_59_L      0x3395B2
#define REG_BK3395_59_H      0x3395B3
#define REG_BK3395_5A_L      0x3395B4
#define REG_BK3395_5A_H      0x3395B5
#define REG_BK3395_5B_L      0x3395B6
#define REG_BK3395_5B_H      0x3395B7
#define REG_BK3395_5C_L      0x3395B8
#define REG_BK3395_5C_H      0x3395B9
#define REG_BK3395_5D_L      0x3395BA
#define REG_BK3395_5D_H      0x3395BB
#define REG_BK3395_5E_L      0x3395BC
#define REG_BK3395_5E_H      0x3395BD
#define REG_BK3395_5F_L      0x3395BE
#define REG_BK3395_5F_H      0x3395BF
#define REG_BK3395_60_L      0x3395C0
#define REG_BK3395_60_H      0x3395C1
#define REG_BK3395_61_L      0x3395C2
#define REG_BK3395_61_H      0x3395C3
#define REG_BK3395_62_L      0x3395C4
#define REG_BK3395_62_H      0x3395C5
#define REG_BK3395_63_L      0x3395C6
#define REG_BK3395_63_H      0x3395C7
#define REG_BK3395_64_L      0x3395C8
#define REG_BK3395_64_H      0x3395C9
#define REG_BK3395_65_L      0x3395CA
#define REG_BK3395_65_H      0x3395CB
#define REG_BK3395_66_L      0x3395CC
#define REG_BK3395_66_H      0x3395CD
#define REG_BK3395_67_L      0x3395CE
#define REG_BK3395_67_H      0x3395CF
#define REG_BK3395_68_L      0x3395D0
#define REG_BK3395_68_H      0x3395D1
#define REG_BK3395_69_L      0x3395D2
#define REG_BK3395_69_H      0x3395D3
#define REG_BK3395_6A_L      0x3395D4
#define REG_BK3395_6A_H      0x3395D5
#define REG_BK3395_6B_L      0x3395D6
#define REG_BK3395_6B_H      0x3395D7
#define REG_BK3395_6C_L      0x3395D8
#define REG_BK3395_6C_H      0x3395D9
#define REG_BK3395_6D_L      0x3395DA
#define REG_BK3395_6D_H      0x3395DB
#define REG_BK3395_6E_L      0x3395DC
#define REG_BK3395_6E_H      0x3395DD
#define REG_BK3395_6F_L      0x3395DE
#define REG_BK3395_6F_H      0x3395DF
#define REG_BK3395_70_L      0x3395E0
#define REG_BK3395_70_H      0x3395E1
#define REG_BK3395_71_L      0x3395E2
#define REG_BK3395_71_H      0x3395E3
#define REG_BK3395_72_L      0x3395E4
#define REG_BK3395_72_H      0x3395E5
#define REG_BK3395_73_L      0x3395E6
#define REG_BK3395_73_H      0x3395E7
#define REG_BK3395_74_L      0x3395E8
#define REG_BK3395_74_H      0x3395E9
#define REG_BK3395_75_L      0x3395EA
#define REG_BK3395_75_H      0x3395EB
#define REG_BK3395_76_L      0x3395EC
#define REG_BK3395_76_H      0x3395ED
#define REG_BK3395_77_L      0x3395EE
#define REG_BK3395_77_H      0x3395EF
#define REG_BK3395_78_L      0x3395F0
#define REG_BK3395_78_H      0x3395F1
#define REG_BK3395_79_L      0x3395F2
#define REG_BK3395_79_H      0x3395F3
#define REG_BK3395_7A_L      0x3395F4
#define REG_BK3395_7A_H      0x3395F5
#define REG_BK3395_7B_L      0x3395F6
#define REG_BK3395_7B_H      0x3395F7
#define REG_BK3395_7C_L      0x3395F8
#define REG_BK3395_7C_H      0x3395F9
#define REG_BK3395_7D_L      0x3395FA
#define REG_BK3395_7D_H      0x3395FB
#define REG_BK3395_7E_L      0x3395FC
#define REG_BK3395_7E_H      0x3395FD
#define REG_BK3395_7F_L      0x3395FE
#define REG_BK3395_7F_H      0x3395FF
//----------------------------------------------
#define REG_BK3397_00_L      0x339700
#define REG_BK3397_00_H      0x339701
#define REG_BK3397_01_L      0x339702
#define REG_BK3397_01_H      0x339703
#define REG_BK3397_02_L      0x339704
#define REG_BK3397_02_H      0x339705
#define REG_BK3397_03_L      0x339706
#define REG_BK3397_03_H      0x339707
#define REG_BK3397_04_L      0x339708
#define REG_BK3397_04_H      0x339709
#define REG_BK3397_05_L      0x33970A
#define REG_BK3397_05_H      0x33970B
#define REG_BK3397_06_L      0x33970C
#define REG_BK3397_06_H      0x33970D
#define REG_BK3397_07_L      0x33970E
#define REG_BK3397_07_H      0x33970F
#define REG_BK3397_08_L      0x339710
#define REG_BK3397_08_H      0x339711
#define REG_BK3397_09_L      0x339712
#define REG_BK3397_09_H      0x339713
#define REG_BK3397_0A_L      0x339714
#define REG_BK3397_0A_H      0x339715
#define REG_BK3397_0B_L      0x339716
#define REG_BK3397_0B_H      0x339717
#define REG_BK3397_0C_L      0x339718
#define REG_BK3397_0C_H      0x339719
#define REG_BK3397_0D_L      0x33971A
#define REG_BK3397_0D_H      0x33971B
#define REG_BK3397_0E_L      0x33971C
#define REG_BK3397_0E_H      0x33971D
#define REG_BK3397_0F_L      0x33971E
#define REG_BK3397_0F_H      0x33971F
#define REG_BK3397_10_L      0x339720
#define REG_BK3397_10_H      0x339721
#define REG_BK3397_11_L      0x339722
#define REG_BK3397_11_H      0x339723
#define REG_BK3397_12_L      0x339724
#define REG_BK3397_12_H      0x339725
#define REG_BK3397_13_L      0x339726
#define REG_BK3397_13_H      0x339727
#define REG_BK3397_14_L      0x339728
#define REG_BK3397_14_H      0x339729
#define REG_BK3397_15_L      0x33972A
#define REG_BK3397_15_H      0x33972B
#define REG_BK3397_16_L      0x33972C
#define REG_BK3397_16_H      0x33972D
#define REG_BK3397_17_L      0x33972E
#define REG_BK3397_17_H      0x33972F
#define REG_BK3397_18_L      0x339730
#define REG_BK3397_18_H      0x339731
#define REG_BK3397_19_L      0x339732
#define REG_BK3397_19_H      0x339733
#define REG_BK3397_1A_L      0x339734
#define REG_BK3397_1A_H      0x339735
#define REG_BK3397_1B_L      0x339736
#define REG_BK3397_1B_H      0x339737
#define REG_BK3397_1C_L      0x339738
#define REG_BK3397_1C_H      0x339739
#define REG_BK3397_1D_L      0x33973A
#define REG_BK3397_1D_H      0x33973B
#define REG_BK3397_1E_L      0x33973C
#define REG_BK3397_1E_H      0x33973D
#define REG_BK3397_1F_L      0x33973E
#define REG_BK3397_1F_H      0x33973F
#define REG_BK3397_20_L      0x339740
#define REG_BK3397_20_H      0x339741
#define REG_BK3397_21_L      0x339742
#define REG_BK3397_21_H      0x339743
#define REG_BK3397_22_L      0x339744
#define REG_BK3397_22_H      0x339745
#define REG_BK3397_23_L      0x339746
#define REG_BK3397_23_H      0x339747
#define REG_BK3397_24_L      0x339748
#define REG_BK3397_24_H      0x339749
#define REG_BK3397_25_L      0x33974A
#define REG_BK3397_25_H      0x33974B
#define REG_BK3397_26_L      0x33974C
#define REG_BK3397_26_H      0x33974D
#define REG_BK3397_27_L      0x33974E
#define REG_BK3397_27_H      0x33974F
#define REG_BK3397_28_L      0x339750
#define REG_BK3397_28_H      0x339751
#define REG_BK3397_29_L      0x339752
#define REG_BK3397_29_H      0x339753
#define REG_BK3397_2A_L      0x339754
#define REG_BK3397_2A_H      0x339755
#define REG_BK3397_2B_L      0x339756
#define REG_BK3397_2B_H      0x339757
#define REG_BK3397_2C_L      0x339758
#define REG_BK3397_2C_H      0x339759
#define REG_BK3397_2D_L      0x33975A
#define REG_BK3397_2D_H      0x33975B
#define REG_BK3397_2E_L      0x33975C
#define REG_BK3397_2E_H      0x33975D
#define REG_BK3397_2F_L      0x33975E
#define REG_BK3397_2F_H      0x33975F
#define REG_BK3397_30_L      0x339760
#define REG_BK3397_30_H      0x339761
#define REG_BK3397_31_L      0x339762
#define REG_BK3397_31_H      0x339763
#define REG_BK3397_32_L      0x339764
#define REG_BK3397_32_H      0x339765
#define REG_BK3397_33_L      0x339766
#define REG_BK3397_33_H      0x339767
#define REG_BK3397_34_L      0x339768
#define REG_BK3397_34_H      0x339769
#define REG_BK3397_35_L      0x33976A
#define REG_BK3397_35_H      0x33976B
#define REG_BK3397_36_L      0x33976C
#define REG_BK3397_36_H      0x33976D
#define REG_BK3397_37_L      0x33976E
#define REG_BK3397_37_H      0x33976F
#define REG_BK3397_38_L      0x339770
#define REG_BK3397_38_H      0x339771
#define REG_BK3397_39_L      0x339772
#define REG_BK3397_39_H      0x339773
#define REG_BK3397_3A_L      0x339774
#define REG_BK3397_3A_H      0x339775
#define REG_BK3397_3B_L      0x339776
#define REG_BK3397_3B_H      0x339777
#define REG_BK3397_3C_L      0x339778
#define REG_BK3397_3C_H      0x339779
#define REG_BK3397_3D_L      0x33977A
#define REG_BK3397_3D_H      0x33977B
#define REG_BK3397_3E_L      0x33977C
#define REG_BK3397_3E_H      0x33977D
#define REG_BK3397_3F_L      0x33977E
#define REG_BK3397_3F_H      0x33977F
#define REG_BK3397_40_L      0x339780
#define REG_BK3397_40_H      0x339781
#define REG_BK3397_41_L      0x339782
#define REG_BK3397_41_H      0x339783
#define REG_BK3397_42_L      0x339784
#define REG_BK3397_42_H      0x339785
#define REG_BK3397_43_L      0x339786
#define REG_BK3397_43_H      0x339787
#define REG_BK3397_44_L      0x339788
#define REG_BK3397_44_H      0x339789
#define REG_BK3397_45_L      0x33978A
#define REG_BK3397_45_H      0x33978B
#define REG_BK3397_46_L      0x33978C
#define REG_BK3397_46_H      0x33978D
#define REG_BK3397_47_L      0x33978E
#define REG_BK3397_47_H      0x33978F
#define REG_BK3397_48_L      0x339790
#define REG_BK3397_48_H      0x339791
#define REG_BK3397_49_L      0x339792
#define REG_BK3397_49_H      0x339793
#define REG_BK3397_4A_L      0x339794
#define REG_BK3397_4A_H      0x339795
#define REG_BK3397_4B_L      0x339796
#define REG_BK3397_4B_H      0x339797
#define REG_BK3397_4C_L      0x339798
#define REG_BK3397_4C_H      0x339799
#define REG_BK3397_4D_L      0x33979A
#define REG_BK3397_4D_H      0x33979B
#define REG_BK3397_4E_L      0x33979C
#define REG_BK3397_4E_H      0x33979D
#define REG_BK3397_4F_L      0x33979E
#define REG_BK3397_4F_H      0x33979F
#define REG_BK3397_50_L      0x3397A0
#define REG_BK3397_50_H      0x3397A1
#define REG_BK3397_51_L      0x3397A2
#define REG_BK3397_51_H      0x3397A3
#define REG_BK3397_52_L      0x3397A4
#define REG_BK3397_52_H      0x3397A5
#define REG_BK3397_53_L      0x3397A6
#define REG_BK3397_53_H      0x3397A7
#define REG_BK3397_54_L      0x3397A8
#define REG_BK3397_54_H      0x3397A9
#define REG_BK3397_55_L      0x3397AA
#define REG_BK3397_55_H      0x3397AB
#define REG_BK3397_56_L      0x3397AC
#define REG_BK3397_56_H      0x3397AD
#define REG_BK3397_57_L      0x3397AE
#define REG_BK3397_57_H      0x3397AF
#define REG_BK3397_58_L      0x3397B0
#define REG_BK3397_58_H      0x3397B1
#define REG_BK3397_59_L      0x3397B2
#define REG_BK3397_59_H      0x3397B3
#define REG_BK3397_5A_L      0x3397B4
#define REG_BK3397_5A_H      0x3397B5
#define REG_BK3397_5B_L      0x3397B6
#define REG_BK3397_5B_H      0x3397B7
#define REG_BK3397_5C_L      0x3397B8
#define REG_BK3397_5C_H      0x3397B9
#define REG_BK3397_5D_L      0x3397BA
#define REG_BK3397_5D_H      0x3397BB
#define REG_BK3397_5E_L      0x3397BC
#define REG_BK3397_5E_H      0x3397BD
#define REG_BK3397_5F_L      0x3397BE
#define REG_BK3397_5F_H      0x3397BF
#define REG_BK3397_60_L      0x3397C0
#define REG_BK3397_60_H      0x3397C1
#define REG_BK3397_61_L      0x3397C2
#define REG_BK3397_61_H      0x3397C3
#define REG_BK3397_62_L      0x3397C4
#define REG_BK3397_62_H      0x3397C5
#define REG_BK3397_63_L      0x3397C6
#define REG_BK3397_63_H      0x3397C7
#define REG_BK3397_64_L      0x3397C8
#define REG_BK3397_64_H      0x3397C9
#define REG_BK3397_65_L      0x3397CA
#define REG_BK3397_65_H      0x3397CB
#define REG_BK3397_66_L      0x3397CC
#define REG_BK3397_66_H      0x3397CD
#define REG_BK3397_67_L      0x3397CE
#define REG_BK3397_67_H      0x3397CF
#define REG_BK3397_68_L      0x3397D0
#define REG_BK3397_68_H      0x3397D1
#define REG_BK3397_69_L      0x3397D2
#define REG_BK3397_69_H      0x3397D3
#define REG_BK3397_6A_L      0x3397D4
#define REG_BK3397_6A_H      0x3397D5
#define REG_BK3397_6B_L      0x3397D6
#define REG_BK3397_6B_H      0x3397D7
#define REG_BK3397_6C_L      0x3397D8
#define REG_BK3397_6C_H      0x3397D9
#define REG_BK3397_6D_L      0x3397DA
#define REG_BK3397_6D_H      0x3397DB
#define REG_BK3397_6E_L      0x3397DC
#define REG_BK3397_6E_H      0x3397DD
#define REG_BK3397_6F_L      0x3397DE
#define REG_BK3397_6F_H      0x3397DF
#define REG_BK3397_70_L      0x3397E0
#define REG_BK3397_70_H      0x3397E1
#define REG_BK3397_71_L      0x3397E2
#define REG_BK3397_71_H      0x3397E3
#define REG_BK3397_72_L      0x3397E4
#define REG_BK3397_72_H      0x3397E5
#define REG_BK3397_73_L      0x3397E6
#define REG_BK3397_73_H      0x3397E7
#define REG_BK3397_74_L      0x3397E8
#define REG_BK3397_74_H      0x3397E9
#define REG_BK3397_75_L      0x3397EA
#define REG_BK3397_75_H      0x3397EB
#define REG_BK3397_76_L      0x3397EC
#define REG_BK3397_76_H      0x3397ED
#define REG_BK3397_77_L      0x3397EE
#define REG_BK3397_77_H      0x3397EF
#define REG_BK3397_78_L      0x3397F0
#define REG_BK3397_78_H      0x3397F1
#define REG_BK3397_79_L      0x3397F2
#define REG_BK3397_79_H      0x3397F3
#define REG_BK3397_7A_L      0x3397F4
#define REG_BK3397_7A_H      0x3397F5
#define REG_BK3397_7B_L      0x3397F6
#define REG_BK3397_7B_H      0x3397F7
#define REG_BK3397_7C_L      0x3397F8
#define REG_BK3397_7C_H      0x3397F9
#define REG_BK3397_7D_L      0x3397FA
#define REG_BK3397_7D_H      0x3397FB
#define REG_BK3397_7E_L      0x3397FC
#define REG_BK3397_7E_H      0x3397FD
#define REG_BK3397_7F_L      0x3397FE
#define REG_BK3397_7F_H      0x3397FF
//----------------------------------------------
#define REG_BK3398_00_L      0x339800
#define REG_BK3398_00_H      0x339801
#define REG_BK3398_01_L      0x339802
#define REG_BK3398_01_H      0x339803
#define REG_BK3398_02_L      0x339804
#define REG_BK3398_02_H      0x339805
#define REG_BK3398_03_L      0x339806
#define REG_BK3398_03_H      0x339807
#define REG_BK3398_04_L      0x339808
#define REG_BK3398_04_H      0x339809
#define REG_BK3398_05_L      0x33980A
#define REG_BK3398_05_H      0x33980B
#define REG_BK3398_06_L      0x33980C
#define REG_BK3398_06_H      0x33980D
#define REG_BK3398_07_L      0x33980E
#define REG_BK3398_07_H      0x33980F
#define REG_BK3398_08_L      0x339810
#define REG_BK3398_08_H      0x339811
#define REG_BK3398_09_L      0x339812
#define REG_BK3398_09_H      0x339813
#define REG_BK3398_0A_L      0x339814
#define REG_BK3398_0A_H      0x339815
#define REG_BK3398_0B_L      0x339816
#define REG_BK3398_0B_H      0x339817
#define REG_BK3398_0C_L      0x339818
#define REG_BK3398_0C_H      0x339819
#define REG_BK3398_0D_L      0x33981A
#define REG_BK3398_0D_H      0x33981B
#define REG_BK3398_0E_L      0x33981C
#define REG_BK3398_0E_H      0x33981D
#define REG_BK3398_0F_L      0x33981E
#define REG_BK3398_0F_H      0x33981F
#define REG_BK3398_10_L      0x339820
#define REG_BK3398_10_H      0x339821
#define REG_BK3398_11_L      0x339822
#define REG_BK3398_11_H      0x339823
#define REG_BK3398_12_L      0x339824
#define REG_BK3398_12_H      0x339825
#define REG_BK3398_13_L      0x339826
#define REG_BK3398_13_H      0x339827
#define REG_BK3398_14_L      0x339828
#define REG_BK3398_14_H      0x339829
#define REG_BK3398_15_L      0x33982A
#define REG_BK3398_15_H      0x33982B
#define REG_BK3398_16_L      0x33982C
#define REG_BK3398_16_H      0x33982D
#define REG_BK3398_17_L      0x33982E
#define REG_BK3398_17_H      0x33982F
#define REG_BK3398_18_L      0x339830
#define REG_BK3398_18_H      0x339831
#define REG_BK3398_19_L      0x339832
#define REG_BK3398_19_H      0x339833
#define REG_BK3398_1A_L      0x339834
#define REG_BK3398_1A_H      0x339835
#define REG_BK3398_1B_L      0x339836
#define REG_BK3398_1B_H      0x339837
#define REG_BK3398_1C_L      0x339838
#define REG_BK3398_1C_H      0x339839
#define REG_BK3398_1D_L      0x33983A
#define REG_BK3398_1D_H      0x33983B
#define REG_BK3398_1E_L      0x33983C
#define REG_BK3398_1E_H      0x33983D
#define REG_BK3398_1F_L      0x33983E
#define REG_BK3398_1F_H      0x33983F
#define REG_BK3398_20_L      0x339840
#define REG_BK3398_20_H      0x339841
#define REG_BK3398_21_L      0x339842
#define REG_BK3398_21_H      0x339843
#define REG_BK3398_22_L      0x339844
#define REG_BK3398_22_H      0x339845
#define REG_BK3398_23_L      0x339846
#define REG_BK3398_23_H      0x339847
#define REG_BK3398_24_L      0x339848
#define REG_BK3398_24_H      0x339849
#define REG_BK3398_25_L      0x33984A
#define REG_BK3398_25_H      0x33984B
#define REG_BK3398_26_L      0x33984C
#define REG_BK3398_26_H      0x33984D
#define REG_BK3398_27_L      0x33984E
#define REG_BK3398_27_H      0x33984F
#define REG_BK3398_28_L      0x339850
#define REG_BK3398_28_H      0x339851
#define REG_BK3398_29_L      0x339852
#define REG_BK3398_29_H      0x339853
#define REG_BK3398_2A_L      0x339854
#define REG_BK3398_2A_H      0x339855
#define REG_BK3398_2B_L      0x339856
#define REG_BK3398_2B_H      0x339857
#define REG_BK3398_2C_L      0x339858
#define REG_BK3398_2C_H      0x339859
#define REG_BK3398_2D_L      0x33985A
#define REG_BK3398_2D_H      0x33985B
#define REG_BK3398_2E_L      0x33985C
#define REG_BK3398_2E_H      0x33985D
#define REG_BK3398_2F_L      0x33985E
#define REG_BK3398_2F_H      0x33985F
#define REG_BK3398_30_L      0x339860
#define REG_BK3398_30_H      0x339861
#define REG_BK3398_31_L      0x339862
#define REG_BK3398_31_H      0x339863
#define REG_BK3398_32_L      0x339864
#define REG_BK3398_32_H      0x339865
#define REG_BK3398_33_L      0x339866
#define REG_BK3398_33_H      0x339867
#define REG_BK3398_34_L      0x339868
#define REG_BK3398_34_H      0x339869
#define REG_BK3398_35_L      0x33986A
#define REG_BK3398_35_H      0x33986B
#define REG_BK3398_36_L      0x33986C
#define REG_BK3398_36_H      0x33986D
#define REG_BK3398_37_L      0x33986E
#define REG_BK3398_37_H      0x33986F
#define REG_BK3398_38_L      0x339870
#define REG_BK3398_38_H      0x339871
#define REG_BK3398_39_L      0x339872
#define REG_BK3398_39_H      0x339873
#define REG_BK3398_3A_L      0x339874
#define REG_BK3398_3A_H      0x339875
#define REG_BK3398_3B_L      0x339876
#define REG_BK3398_3B_H      0x339877
#define REG_BK3398_3C_L      0x339878
#define REG_BK3398_3C_H      0x339879
#define REG_BK3398_3D_L      0x33987A
#define REG_BK3398_3D_H      0x33987B
#define REG_BK3398_3E_L      0x33987C
#define REG_BK3398_3E_H      0x33987D
#define REG_BK3398_3F_L      0x33987E
#define REG_BK3398_3F_H      0x33987F
#define REG_BK3398_40_L      0x339880
#define REG_BK3398_40_H      0x339881
#define REG_BK3398_41_L      0x339882
#define REG_BK3398_41_H      0x339883
#define REG_BK3398_42_L      0x339884
#define REG_BK3398_42_H      0x339885
#define REG_BK3398_43_L      0x339886
#define REG_BK3398_43_H      0x339887
#define REG_BK3398_44_L      0x339888
#define REG_BK3398_44_H      0x339889
#define REG_BK3398_45_L      0x33988A
#define REG_BK3398_45_H      0x33988B
#define REG_BK3398_46_L      0x33988C
#define REG_BK3398_46_H      0x33988D
#define REG_BK3398_47_L      0x33988E
#define REG_BK3398_47_H      0x33988F
#define REG_BK3398_48_L      0x339890
#define REG_BK3398_48_H      0x339891
#define REG_BK3398_49_L      0x339892
#define REG_BK3398_49_H      0x339893
#define REG_BK3398_4A_L      0x339894
#define REG_BK3398_4A_H      0x339895
#define REG_BK3398_4B_L      0x339896
#define REG_BK3398_4B_H      0x339897
#define REG_BK3398_4C_L      0x339898
#define REG_BK3398_4C_H      0x339899
#define REG_BK3398_4D_L      0x33989A
#define REG_BK3398_4D_H      0x33989B
#define REG_BK3398_4E_L      0x33989C
#define REG_BK3398_4E_H      0x33989D
#define REG_BK3398_4F_L      0x33989E
#define REG_BK3398_4F_H      0x33989F
#define REG_BK3398_50_L      0x3398A0
#define REG_BK3398_50_H      0x3398A1
#define REG_BK3398_51_L      0x3398A2
#define REG_BK3398_51_H      0x3398A3
#define REG_BK3398_52_L      0x3398A4
#define REG_BK3398_52_H      0x3398A5
#define REG_BK3398_53_L      0x3398A6
#define REG_BK3398_53_H      0x3398A7
#define REG_BK3398_54_L      0x3398A8
#define REG_BK3398_54_H      0x3398A9
#define REG_BK3398_55_L      0x3398AA
#define REG_BK3398_55_H      0x3398AB
#define REG_BK3398_56_L      0x3398AC
#define REG_BK3398_56_H      0x3398AD
#define REG_BK3398_57_L      0x3398AE
#define REG_BK3398_57_H      0x3398AF
#define REG_BK3398_58_L      0x3398B0
#define REG_BK3398_58_H      0x3398B1
#define REG_BK3398_59_L      0x3398B2
#define REG_BK3398_59_H      0x3398B3
#define REG_BK3398_5A_L      0x3398B4
#define REG_BK3398_5A_H      0x3398B5
#define REG_BK3398_5B_L      0x3398B6
#define REG_BK3398_5B_H      0x3398B7
#define REG_BK3398_5C_L      0x3398B8
#define REG_BK3398_5C_H      0x3398B9
#define REG_BK3398_5D_L      0x3398BA
#define REG_BK3398_5D_H      0x3398BB
#define REG_BK3398_5E_L      0x3398BC
#define REG_BK3398_5E_H      0x3398BD
#define REG_BK3398_5F_L      0x3398BE
#define REG_BK3398_5F_H      0x3398BF
#define REG_BK3398_60_L      0x3398C0
#define REG_BK3398_60_H      0x3398C1
#define REG_BK3398_61_L      0x3398C2
#define REG_BK3398_61_H      0x3398C3
#define REG_BK3398_62_L      0x3398C4
#define REG_BK3398_62_H      0x3398C5
#define REG_BK3398_63_L      0x3398C6
#define REG_BK3398_63_H      0x3398C7
#define REG_BK3398_64_L      0x3398C8
#define REG_BK3398_64_H      0x3398C9
#define REG_BK3398_65_L      0x3398CA
#define REG_BK3398_65_H      0x3398CB
#define REG_BK3398_66_L      0x3398CC
#define REG_BK3398_66_H      0x3398CD
#define REG_BK3398_67_L      0x3398CE
#define REG_BK3398_67_H      0x3398CF
#define REG_BK3398_68_L      0x3398D0
#define REG_BK3398_68_H      0x3398D1
#define REG_BK3398_69_L      0x3398D2
#define REG_BK3398_69_H      0x3398D3
#define REG_BK3398_6A_L      0x3398D4
#define REG_BK3398_6A_H      0x3398D5
#define REG_BK3398_6B_L      0x3398D6
#define REG_BK3398_6B_H      0x3398D7
#define REG_BK3398_6C_L      0x3398D8
#define REG_BK3398_6C_H      0x3398D9
#define REG_BK3398_6D_L      0x3398DA
#define REG_BK3398_6D_H      0x3398DB
#define REG_BK3398_6E_L      0x3398DC
#define REG_BK3398_6E_H      0x3398DD
#define REG_BK3398_6F_L      0x3398DE
#define REG_BK3398_6F_H      0x3398DF
#define REG_BK3398_70_L      0x3398E0
#define REG_BK3398_70_H      0x3398E1
#define REG_BK3398_71_L      0x3398E2
#define REG_BK3398_71_H      0x3398E3
#define REG_BK3398_72_L      0x3398E4
#define REG_BK3398_72_H      0x3398E5
#define REG_BK3398_73_L      0x3398E6
#define REG_BK3398_73_H      0x3398E7
#define REG_BK3398_74_L      0x3398E8
#define REG_BK3398_74_H      0x3398E9
#define REG_BK3398_75_L      0x3398EA
#define REG_BK3398_75_H      0x3398EB
#define REG_BK3398_76_L      0x3398EC
#define REG_BK3398_76_H      0x3398ED
#define REG_BK3398_77_L      0x3398EE
#define REG_BK3398_77_H      0x3398EF
#define REG_BK3398_78_L      0x3398F0
#define REG_BK3398_78_H      0x3398F1
#define REG_BK3398_79_L      0x3398F2
#define REG_BK3398_79_H      0x3398F3
#define REG_BK3398_7A_L      0x3398F4
#define REG_BK3398_7A_H      0x3398F5
#define REG_BK3398_7B_L      0x3398F6
#define REG_BK3398_7B_H      0x3398F7
#define REG_BK3398_7C_L      0x3398F8
#define REG_BK3398_7C_H      0x3398F9
#define REG_BK3398_7D_L      0x3398FA
#define REG_BK3398_7D_H      0x3398FB
#define REG_BK3398_7E_L      0x3398FC
#define REG_BK3398_7E_H      0x3398FD
#define REG_BK3398_7F_L      0x3398FE
#define REG_BK3398_7F_H      0x3398FF
//----------------------------------------------
#define REG_BK1300_00_L      0x130000
#define REG_BK1300_00_H      0x130001
#define REG_BK1300_01_L      0x130002
#define REG_BK1300_01_H      0x130003
#define REG_BK1300_02_L      0x130004
#define REG_BK1300_02_H      0x130005
#define REG_BK1300_03_L      0x130006
#define REG_BK1300_03_H      0x130007
#define REG_BK1300_04_L      0x130008
#define REG_BK1300_04_H      0x130009
#define REG_BK1300_05_L      0x13000A
#define REG_BK1300_05_H      0x13000B
#define REG_BK1300_06_L      0x13000C
#define REG_BK1300_06_H      0x13000D
#define REG_BK1300_07_L      0x13000E
#define REG_BK1300_07_H      0x13000F
#define REG_BK1300_08_L      0x130010
#define REG_BK1300_08_H      0x130011
#define REG_BK1300_09_L      0x130012
#define REG_BK1300_09_H      0x130013
#define REG_BK1300_0A_L      0x130014
#define REG_BK1300_0A_H      0x130015
#define REG_BK1300_0B_L      0x130016
#define REG_BK1300_0B_H      0x130017
#define REG_BK1300_0C_L      0x130018
#define REG_BK1300_0C_H      0x130019
#define REG_BK1300_0D_L      0x13001A
#define REG_BK1300_0D_H      0x13001B
#define REG_BK1300_0E_L      0x13001C
#define REG_BK1300_0E_H      0x13001D
#define REG_BK1300_0F_L      0x13001E
#define REG_BK1300_0F_H      0x13001F
#define REG_BK1300_10_L      0x130020
#define REG_BK1300_10_H      0x130021
#define REG_BK1300_11_L      0x130022
#define REG_BK1300_11_H      0x130023
#define REG_BK1300_12_L      0x130024
#define REG_BK1300_12_H      0x130025
#define REG_BK1300_13_L      0x130026
#define REG_BK1300_13_H      0x130027
#define REG_BK1300_14_L      0x130028
#define REG_BK1300_14_H      0x130029
#define REG_BK1300_15_L      0x13002A
#define REG_BK1300_15_H      0x13002B
#define REG_BK1300_16_L      0x13002C
#define REG_BK1300_16_H      0x13002D
#define REG_BK1300_17_L      0x13002E
#define REG_BK1300_17_H      0x13002F
#define REG_BK1300_18_L      0x130030
#define REG_BK1300_18_H      0x130031
#define REG_BK1300_19_L      0x130032
#define REG_BK1300_19_H      0x130033
#define REG_BK1300_1A_L      0x130034
#define REG_BK1300_1A_H      0x130035
#define REG_BK1300_1B_L      0x130036
#define REG_BK1300_1B_H      0x130037
#define REG_BK1300_1C_L      0x130038
#define REG_BK1300_1C_H      0x130039
#define REG_BK1300_1D_L      0x13003A
#define REG_BK1300_1D_H      0x13003B
#define REG_BK1300_1E_L      0x13003C
#define REG_BK1300_1E_H      0x13003D
#define REG_BK1300_1F_L      0x13003E
#define REG_BK1300_1F_H      0x13003F
#define REG_BK1300_20_L      0x130040
#define REG_BK1300_20_H      0x130041
#define REG_BK1300_21_L      0x130042
#define REG_BK1300_21_H      0x130043
#define REG_BK1300_22_L      0x130044
#define REG_BK1300_22_H      0x130045
#define REG_BK1300_23_L      0x130046
#define REG_BK1300_23_H      0x130047
#define REG_BK1300_24_L      0x130048
#define REG_BK1300_24_H      0x130049
#define REG_BK1300_25_L      0x13004A
#define REG_BK1300_25_H      0x13004B
#define REG_BK1300_26_L      0x13004C
#define REG_BK1300_26_H      0x13004D
#define REG_BK1300_27_L      0x13004E
#define REG_BK1300_27_H      0x13004F
#define REG_BK1300_28_L      0x130050
#define REG_BK1300_28_H      0x130051
#define REG_BK1300_29_L      0x130052
#define REG_BK1300_29_H      0x130053
#define REG_BK1300_2A_L      0x130054
#define REG_BK1300_2A_H      0x130055
#define REG_BK1300_2B_L      0x130056
#define REG_BK1300_2B_H      0x130057
#define REG_BK1300_2C_L      0x130058
#define REG_BK1300_2C_H      0x130059
#define REG_BK1300_2D_L      0x13005A
#define REG_BK1300_2D_H      0x13005B
#define REG_BK1300_2E_L      0x13005C
#define REG_BK1300_2E_H      0x13005D
#define REG_BK1300_2F_L      0x13005E
#define REG_BK1300_2F_H      0x13005F
#define REG_BK1300_30_L      0x130060
#define REG_BK1300_30_H      0x130061
#define REG_BK1300_31_L      0x130062
#define REG_BK1300_31_H      0x130063
#define REG_BK1300_32_L      0x130064
#define REG_BK1300_32_H      0x130065
#define REG_BK1300_33_L      0x130066
#define REG_BK1300_33_H      0x130067
#define REG_BK1300_34_L      0x130068
#define REG_BK1300_34_H      0x130069
#define REG_BK1300_35_L      0x13006A
#define REG_BK1300_35_H      0x13006B
#define REG_BK1300_36_L      0x13006C
#define REG_BK1300_36_H      0x13006D
#define REG_BK1300_37_L      0x13006E
#define REG_BK1300_37_H      0x13006F
#define REG_BK1300_38_L      0x130070
#define REG_BK1300_38_H      0x130071
#define REG_BK1300_39_L      0x130072
#define REG_BK1300_39_H      0x130073
#define REG_BK1300_3A_L      0x130074
#define REG_BK1300_3A_H      0x130075
#define REG_BK1300_3B_L      0x130076
#define REG_BK1300_3B_H      0x130077
#define REG_BK1300_3C_L      0x130078
#define REG_BK1300_3C_H      0x130079
#define REG_BK1300_3D_L      0x13007A
#define REG_BK1300_3D_H      0x13007B
#define REG_BK1300_3E_L      0x13007C
#define REG_BK1300_3E_H      0x13007D
#define REG_BK1300_3F_L      0x13007E
#define REG_BK1300_3F_H      0x13007F
#define REG_BK1300_40_L      0x130080
#define REG_BK1300_40_H      0x130081
#define REG_BK1300_41_L      0x130082
#define REG_BK1300_41_H      0x130083
#define REG_BK1300_42_L      0x130084
#define REG_BK1300_42_H      0x130085
#define REG_BK1300_43_L      0x130086
#define REG_BK1300_43_H      0x130087
#define REG_BK1300_44_L      0x130088
#define REG_BK1300_44_H      0x130089
#define REG_BK1300_45_L      0x13008A
#define REG_BK1300_45_H      0x13008B
#define REG_BK1300_46_L      0x13008C
#define REG_BK1300_46_H      0x13008D
#define REG_BK1300_47_L      0x13008E
#define REG_BK1300_47_H      0x13008F
#define REG_BK1300_48_L      0x130090
#define REG_BK1300_48_H      0x130091
#define REG_BK1300_49_L      0x130092
#define REG_BK1300_49_H      0x130093
#define REG_BK1300_4A_L      0x130094
#define REG_BK1300_4A_H      0x130095
#define REG_BK1300_4B_L      0x130096
#define REG_BK1300_4B_H      0x130097
#define REG_BK1300_4C_L      0x130098
#define REG_BK1300_4C_H      0x130099
#define REG_BK1300_4D_L      0x13009A
#define REG_BK1300_4D_H      0x13009B
#define REG_BK1300_4E_L      0x13009C
#define REG_BK1300_4E_H      0x13009D
#define REG_BK1300_4F_L      0x13009E
#define REG_BK1300_4F_H      0x13009F
#define REG_BK1300_50_L      0x1300A0
#define REG_BK1300_50_H      0x1300A1
#define REG_BK1300_51_L      0x1300A2
#define REG_BK1300_51_H      0x1300A3
#define REG_BK1300_52_L      0x1300A4
#define REG_BK1300_52_H      0x1300A5
#define REG_BK1300_53_L      0x1300A6
#define REG_BK1300_53_H      0x1300A7
#define REG_BK1300_54_L      0x1300A8
#define REG_BK1300_54_H      0x1300A9
#define REG_BK1300_55_L      0x1300AA
#define REG_BK1300_55_H      0x1300AB
#define REG_BK1300_56_L      0x1300AC
#define REG_BK1300_56_H      0x1300AD
#define REG_BK1300_57_L      0x1300AE
#define REG_BK1300_57_H      0x1300AF
#define REG_BK1300_58_L      0x1300B0
#define REG_BK1300_58_H      0x1300B1
#define REG_BK1300_59_L      0x1300B2
#define REG_BK1300_59_H      0x1300B3
#define REG_BK1300_5A_L      0x1300B4
#define REG_BK1300_5A_H      0x1300B5
#define REG_BK1300_5B_L      0x1300B6
#define REG_BK1300_5B_H      0x1300B7
#define REG_BK1300_5C_L      0x1300B8
#define REG_BK1300_5C_H      0x1300B9
#define REG_BK1300_5D_L      0x1300BA
#define REG_BK1300_5D_H      0x1300BB
#define REG_BK1300_5E_L      0x1300BC
#define REG_BK1300_5E_H      0x1300BD
#define REG_BK1300_5F_L      0x1300BE
#define REG_BK1300_5F_H      0x1300BF
#define REG_BK1300_60_L      0x1300C0
#define REG_BK1300_60_H      0x1300C1
#define REG_BK1300_61_L      0x1300C2
#define REG_BK1300_61_H      0x1300C3
#define REG_BK1300_62_L      0x1300C4
#define REG_BK1300_62_H      0x1300C5
#define REG_BK1300_63_L      0x1300C6
#define REG_BK1300_63_H      0x1300C7
#define REG_BK1300_64_L      0x1300C8
#define REG_BK1300_64_H      0x1300C9
#define REG_BK1300_65_L      0x1300CA
#define REG_BK1300_65_H      0x1300CB
#define REG_BK1300_66_L      0x1300CC
#define REG_BK1300_66_H      0x1300CD
#define REG_BK1300_67_L      0x1300CE
#define REG_BK1300_67_H      0x1300CF
#define REG_BK1300_68_L      0x1300D0
#define REG_BK1300_68_H      0x1300D1
#define REG_BK1300_69_L      0x1300D2
#define REG_BK1300_69_H      0x1300D3
#define REG_BK1300_6A_L      0x1300D4
#define REG_BK1300_6A_H      0x1300D5
#define REG_BK1300_6B_L      0x1300D6
#define REG_BK1300_6B_H      0x1300D7
#define REG_BK1300_6C_L      0x1300D8
#define REG_BK1300_6C_H      0x1300D9
#define REG_BK1300_6D_L      0x1300DA
#define REG_BK1300_6D_H      0x1300DB
#define REG_BK1300_6E_L      0x1300DC
#define REG_BK1300_6E_H      0x1300DD
#define REG_BK1300_6F_L      0x1300DE
#define REG_BK1300_6F_H      0x1300DF
#define REG_BK1300_70_L      0x1300E0
#define REG_BK1300_70_H      0x1300E1
#define REG_BK1300_71_L      0x1300E2
#define REG_BK1300_71_H      0x1300E3
#define REG_BK1300_72_L      0x1300E4
#define REG_BK1300_72_H      0x1300E5
#define REG_BK1300_73_L      0x1300E6
#define REG_BK1300_73_H      0x1300E7
#define REG_BK1300_74_L      0x1300E8
#define REG_BK1300_74_H      0x1300E9
#define REG_BK1300_75_L      0x1300EA
#define REG_BK1300_75_H      0x1300EB
#define REG_BK1300_76_L      0x1300EC
#define REG_BK1300_76_H      0x1300ED
#define REG_BK1300_77_L      0x1300EE
#define REG_BK1300_77_H      0x1300EF
#define REG_BK1300_78_L      0x1300F0
#define REG_BK1300_78_H      0x1300F1
#define REG_BK1300_79_L      0x1300F2
#define REG_BK1300_79_H      0x1300F3
#define REG_BK1300_7A_L      0x1300F4
#define REG_BK1300_7A_H      0x1300F5
#define REG_BK1300_7B_L      0x1300F6
#define REG_BK1300_7B_H      0x1300F7
#define REG_BK1300_7C_L      0x1300F8
#define REG_BK1300_7C_H      0x1300F9
#define REG_BK1300_7D_L      0x1300FA
#define REG_BK1300_7D_H      0x1300FB
#define REG_BK1300_7E_L      0x1300FC
#define REG_BK1300_7E_H      0x1300FD
#define REG_BK1300_7F_L      0x1300FE
#define REG_BK1300_7F_H      0x1300FF
//----------------------------------------------
#define REG_BK1301_00_L      0x130100
#define REG_BK1301_00_H      0x130101
#define REG_BK1301_01_L      0x130102
#define REG_BK1301_01_H      0x130103
#define REG_BK1301_02_L      0x130104
#define REG_BK1301_02_H      0x130105
#define REG_BK1301_03_L      0x130106
#define REG_BK1301_03_H      0x130107
#define REG_BK1301_04_L      0x130108
#define REG_BK1301_04_H      0x130109
#define REG_BK1301_05_L      0x13010A
#define REG_BK1301_05_H      0x13010B
#define REG_BK1301_06_L      0x13010C
#define REG_BK1301_06_H      0x13010D
#define REG_BK1301_07_L      0x13010E
#define REG_BK1301_07_H      0x13010F
#define REG_BK1301_08_L      0x130110
#define REG_BK1301_08_H      0x130111
#define REG_BK1301_09_L      0x130112
#define REG_BK1301_09_H      0x130113
#define REG_BK1301_0A_L      0x130114
#define REG_BK1301_0A_H      0x130115
#define REG_BK1301_0B_L      0x130116
#define REG_BK1301_0B_H      0x130117
#define REG_BK1301_0C_L      0x130118
#define REG_BK1301_0C_H      0x130119
#define REG_BK1301_0D_L      0x13011A
#define REG_BK1301_0D_H      0x13011B
#define REG_BK1301_0E_L      0x13011C
#define REG_BK1301_0E_H      0x13011D
#define REG_BK1301_0F_L      0x13011E
#define REG_BK1301_0F_H      0x13011F
#define REG_BK1301_10_L      0x130120
#define REG_BK1301_10_H      0x130121
#define REG_BK1301_11_L      0x130122
#define REG_BK1301_11_H      0x130123
#define REG_BK1301_12_L      0x130124
#define REG_BK1301_12_H      0x130125
#define REG_BK1301_13_L      0x130126
#define REG_BK1301_13_H      0x130127
#define REG_BK1301_14_L      0x130128
#define REG_BK1301_14_H      0x130129
#define REG_BK1301_15_L      0x13012A
#define REG_BK1301_15_H      0x13012B
#define REG_BK1301_16_L      0x13012C
#define REG_BK1301_16_H      0x13012D
#define REG_BK1301_17_L      0x13012E
#define REG_BK1301_17_H      0x13012F
#define REG_BK1301_18_L      0x130130
#define REG_BK1301_18_H      0x130131
#define REG_BK1301_19_L      0x130132
#define REG_BK1301_19_H      0x130133
#define REG_BK1301_1A_L      0x130134
#define REG_BK1301_1A_H      0x130135
#define REG_BK1301_1B_L      0x130136
#define REG_BK1301_1B_H      0x130137
#define REG_BK1301_1C_L      0x130138
#define REG_BK1301_1C_H      0x130139
#define REG_BK1301_1D_L      0x13013A
#define REG_BK1301_1D_H      0x13013B
#define REG_BK1301_1E_L      0x13013C
#define REG_BK1301_1E_H      0x13013D
#define REG_BK1301_1F_L      0x13013E
#define REG_BK1301_1F_H      0x13013F
#define REG_BK1301_20_L      0x130140
#define REG_BK1301_20_H      0x130141
#define REG_BK1301_21_L      0x130142
#define REG_BK1301_21_H      0x130143
#define REG_BK1301_22_L      0x130144
#define REG_BK1301_22_H      0x130145
#define REG_BK1301_23_L      0x130146
#define REG_BK1301_23_H      0x130147
#define REG_BK1301_24_L      0x130148
#define REG_BK1301_24_H      0x130149
#define REG_BK1301_25_L      0x13014A
#define REG_BK1301_25_H      0x13014B
#define REG_BK1301_26_L      0x13014C
#define REG_BK1301_26_H      0x13014D
#define REG_BK1301_27_L      0x13014E
#define REG_BK1301_27_H      0x13014F
#define REG_BK1301_28_L      0x130150
#define REG_BK1301_28_H      0x130151
#define REG_BK1301_29_L      0x130152
#define REG_BK1301_29_H      0x130153
#define REG_BK1301_2A_L      0x130154
#define REG_BK1301_2A_H      0x130155
#define REG_BK1301_2B_L      0x130156
#define REG_BK1301_2B_H      0x130157
#define REG_BK1301_2C_L      0x130158
#define REG_BK1301_2C_H      0x130159
#define REG_BK1301_2D_L      0x13015A
#define REG_BK1301_2D_H      0x13015B
#define REG_BK1301_2E_L      0x13015C
#define REG_BK1301_2E_H      0x13015D
#define REG_BK1301_2F_L      0x13015E
#define REG_BK1301_2F_H      0x13015F
#define REG_BK1301_30_L      0x130160
#define REG_BK1301_30_H      0x130161
#define REG_BK1301_31_L      0x130162
#define REG_BK1301_31_H      0x130163
#define REG_BK1301_32_L      0x130164
#define REG_BK1301_32_H      0x130165
#define REG_BK1301_33_L      0x130166
#define REG_BK1301_33_H      0x130167
#define REG_BK1301_34_L      0x130168
#define REG_BK1301_34_H      0x130169
#define REG_BK1301_35_L      0x13016A
#define REG_BK1301_35_H      0x13016B
#define REG_BK1301_36_L      0x13016C
#define REG_BK1301_36_H      0x13016D
#define REG_BK1301_37_L      0x13016E
#define REG_BK1301_37_H      0x13016F
#define REG_BK1301_38_L      0x130170
#define REG_BK1301_38_H      0x130171
#define REG_BK1301_39_L      0x130172
#define REG_BK1301_39_H      0x130173
#define REG_BK1301_3A_L      0x130174
#define REG_BK1301_3A_H      0x130175
#define REG_BK1301_3B_L      0x130176
#define REG_BK1301_3B_H      0x130177
#define REG_BK1301_3C_L      0x130178
#define REG_BK1301_3C_H      0x130179
#define REG_BK1301_3D_L      0x13017A
#define REG_BK1301_3D_H      0x13017B
#define REG_BK1301_3E_L      0x13017C
#define REG_BK1301_3E_H      0x13017D
#define REG_BK1301_3F_L      0x13017E
#define REG_BK1301_3F_H      0x13017F
#define REG_BK1301_40_L      0x130180
#define REG_BK1301_40_H      0x130181
#define REG_BK1301_41_L      0x130182
#define REG_BK1301_41_H      0x130183
#define REG_BK1301_42_L      0x130184
#define REG_BK1301_42_H      0x130185
#define REG_BK1301_43_L      0x130186
#define REG_BK1301_43_H      0x130187
#define REG_BK1301_44_L      0x130188
#define REG_BK1301_44_H      0x130189
#define REG_BK1301_45_L      0x13018A
#define REG_BK1301_45_H      0x13018B
#define REG_BK1301_46_L      0x13018C
#define REG_BK1301_46_H      0x13018D
#define REG_BK1301_47_L      0x13018E
#define REG_BK1301_47_H      0x13018F
#define REG_BK1301_48_L      0x130190
#define REG_BK1301_48_H      0x130191
#define REG_BK1301_49_L      0x130192
#define REG_BK1301_49_H      0x130193
#define REG_BK1301_4A_L      0x130194
#define REG_BK1301_4A_H      0x130195
#define REG_BK1301_4B_L      0x130196
#define REG_BK1301_4B_H      0x130197
#define REG_BK1301_4C_L      0x130198
#define REG_BK1301_4C_H      0x130199
#define REG_BK1301_4D_L      0x13019A
#define REG_BK1301_4D_H      0x13019B
#define REG_BK1301_4E_L      0x13019C
#define REG_BK1301_4E_H      0x13019D
#define REG_BK1301_4F_L      0x13019E
#define REG_BK1301_4F_H      0x13019F
#define REG_BK1301_50_L      0x1301A0
#define REG_BK1301_50_H      0x1301A1
#define REG_BK1301_51_L      0x1301A2
#define REG_BK1301_51_H      0x1301A3
#define REG_BK1301_52_L      0x1301A4
#define REG_BK1301_52_H      0x1301A5
#define REG_BK1301_53_L      0x1301A6
#define REG_BK1301_53_H      0x1301A7
#define REG_BK1301_54_L      0x1301A8
#define REG_BK1301_54_H      0x1301A9
#define REG_BK1301_55_L      0x1301AA
#define REG_BK1301_55_H      0x1301AB
#define REG_BK1301_56_L      0x1301AC
#define REG_BK1301_56_H      0x1301AD
#define REG_BK1301_57_L      0x1301AE
#define REG_BK1301_57_H      0x1301AF
#define REG_BK1301_58_L      0x1301B0
#define REG_BK1301_58_H      0x1301B1
#define REG_BK1301_59_L      0x1301B2
#define REG_BK1301_59_H      0x1301B3
#define REG_BK1301_5A_L      0x1301B4
#define REG_BK1301_5A_H      0x1301B5
#define REG_BK1301_5B_L      0x1301B6
#define REG_BK1301_5B_H      0x1301B7
#define REG_BK1301_5C_L      0x1301B8
#define REG_BK1301_5C_H      0x1301B9
#define REG_BK1301_5D_L      0x1301BA
#define REG_BK1301_5D_H      0x1301BB
#define REG_BK1301_5E_L      0x1301BC
#define REG_BK1301_5E_H      0x1301BD
#define REG_BK1301_5F_L      0x1301BE
#define REG_BK1301_5F_H      0x1301BF
#define REG_BK1301_60_L      0x1301C0
#define REG_BK1301_60_H      0x1301C1
#define REG_BK1301_61_L      0x1301C2
#define REG_BK1301_61_H      0x1301C3
#define REG_BK1301_62_L      0x1301C4
#define REG_BK1301_62_H      0x1301C5
#define REG_BK1301_63_L      0x1301C6
#define REG_BK1301_63_H      0x1301C7
#define REG_BK1301_64_L      0x1301C8
#define REG_BK1301_64_H      0x1301C9
#define REG_BK1301_65_L      0x1301CA
#define REG_BK1301_65_H      0x1301CB
#define REG_BK1301_66_L      0x1301CC
#define REG_BK1301_66_H      0x1301CD
#define REG_BK1301_67_L      0x1301CE
#define REG_BK1301_67_H      0x1301CF
#define REG_BK1301_68_L      0x1301D0
#define REG_BK1301_68_H      0x1301D1
#define REG_BK1301_69_L      0x1301D2
#define REG_BK1301_69_H      0x1301D3
#define REG_BK1301_6A_L      0x1301D4
#define REG_BK1301_6A_H      0x1301D5
#define REG_BK1301_6B_L      0x1301D6
#define REG_BK1301_6B_H      0x1301D7
#define REG_BK1301_6C_L      0x1301D8
#define REG_BK1301_6C_H      0x1301D9
#define REG_BK1301_6D_L      0x1301DA
#define REG_BK1301_6D_H      0x1301DB
#define REG_BK1301_6E_L      0x1301DC
#define REG_BK1301_6E_H      0x1301DD
#define REG_BK1301_6F_L      0x1301DE
#define REG_BK1301_6F_H      0x1301DF
#define REG_BK1301_70_L      0x1301E0
#define REG_BK1301_70_H      0x1301E1
#define REG_BK1301_71_L      0x1301E2
#define REG_BK1301_71_H      0x1301E3
#define REG_BK1301_72_L      0x1301E4
#define REG_BK1301_72_H      0x1301E5
#define REG_BK1301_73_L      0x1301E6
#define REG_BK1301_73_H      0x1301E7
#define REG_BK1301_74_L      0x1301E8
#define REG_BK1301_74_H      0x1301E9
#define REG_BK1301_75_L      0x1301EA
#define REG_BK1301_75_H      0x1301EB
#define REG_BK1301_76_L      0x1301EC
#define REG_BK1301_76_H      0x1301ED
#define REG_BK1301_77_L      0x1301EE
#define REG_BK1301_77_H      0x1301EF
#define REG_BK1301_78_L      0x1301F0
#define REG_BK1301_78_H      0x1301F1
#define REG_BK1301_79_L      0x1301F2
#define REG_BK1301_79_H      0x1301F3
#define REG_BK1301_7A_L      0x1301F4
#define REG_BK1301_7A_H      0x1301F5
#define REG_BK1301_7B_L      0x1301F6
#define REG_BK1301_7B_H      0x1301F7
#define REG_BK1301_7C_L      0x1301F8
#define REG_BK1301_7C_H      0x1301F9
#define REG_BK1301_7D_L      0x1301FA
#define REG_BK1301_7D_H      0x1301FB
#define REG_BK1301_7E_L      0x1301FC
#define REG_BK1301_7E_H      0x1301FD
#define REG_BK1301_7F_L      0x1301FE
#define REG_BK1301_7F_H      0x1301FF
//----------------------------------------------
#define REG_BK1302_00_L      0x130200
#define REG_BK1302_00_H      0x130201
#define REG_BK1302_01_L      0x130202
#define REG_BK1302_01_H      0x130203
#define REG_BK1302_02_L      0x130204
#define REG_BK1302_02_H      0x130205
#define REG_BK1302_03_L      0x130206
#define REG_BK1302_03_H      0x130207
#define REG_BK1302_04_L      0x130208
#define REG_BK1302_04_H      0x130209
#define REG_BK1302_05_L      0x13020A
#define REG_BK1302_05_H      0x13020B
#define REG_BK1302_06_L      0x13020C
#define REG_BK1302_06_H      0x13020D
#define REG_BK1302_07_L      0x13020E
#define REG_BK1302_07_H      0x13020F
#define REG_BK1302_08_L      0x130210
#define REG_BK1302_08_H      0x130211
#define REG_BK1302_09_L      0x130212
#define REG_BK1302_09_H      0x130213
#define REG_BK1302_0A_L      0x130214
#define REG_BK1302_0A_H      0x130215
#define REG_BK1302_0B_L      0x130216
#define REG_BK1302_0B_H      0x130217
#define REG_BK1302_0C_L      0x130218
#define REG_BK1302_0C_H      0x130219
#define REG_BK1302_0D_L      0x13021A
#define REG_BK1302_0D_H      0x13021B
#define REG_BK1302_0E_L      0x13021C
#define REG_BK1302_0E_H      0x13021D
#define REG_BK1302_0F_L      0x13021E
#define REG_BK1302_0F_H      0x13021F
#define REG_BK1302_10_L      0x130220
#define REG_BK1302_10_H      0x130221
#define REG_BK1302_11_L      0x130222
#define REG_BK1302_11_H      0x130223
#define REG_BK1302_12_L      0x130224
#define REG_BK1302_12_H      0x130225
#define REG_BK1302_13_L      0x130226
#define REG_BK1302_13_H      0x130227
#define REG_BK1302_14_L      0x130228
#define REG_BK1302_14_H      0x130229
#define REG_BK1302_15_L      0x13022A
#define REG_BK1302_15_H      0x13022B
#define REG_BK1302_16_L      0x13022C
#define REG_BK1302_16_H      0x13022D
#define REG_BK1302_17_L      0x13022E
#define REG_BK1302_17_H      0x13022F
#define REG_BK1302_18_L      0x130230
#define REG_BK1302_18_H      0x130231
#define REG_BK1302_19_L      0x130232
#define REG_BK1302_19_H      0x130233
#define REG_BK1302_1A_L      0x130234
#define REG_BK1302_1A_H      0x130235
#define REG_BK1302_1B_L      0x130236
#define REG_BK1302_1B_H      0x130237
#define REG_BK1302_1C_L      0x130238
#define REG_BK1302_1C_H      0x130239
#define REG_BK1302_1D_L      0x13023A
#define REG_BK1302_1D_H      0x13023B
#define REG_BK1302_1E_L      0x13023C
#define REG_BK1302_1E_H      0x13023D
#define REG_BK1302_1F_L      0x13023E
#define REG_BK1302_1F_H      0x13023F
#define REG_BK1302_20_L      0x130240
#define REG_BK1302_20_H      0x130241
#define REG_BK1302_21_L      0x130242
#define REG_BK1302_21_H      0x130243
#define REG_BK1302_22_L      0x130244
#define REG_BK1302_22_H      0x130245
#define REG_BK1302_23_L      0x130246
#define REG_BK1302_23_H      0x130247
#define REG_BK1302_24_L      0x130248
#define REG_BK1302_24_H      0x130249
#define REG_BK1302_25_L      0x13024A
#define REG_BK1302_25_H      0x13024B
#define REG_BK1302_26_L      0x13024C
#define REG_BK1302_26_H      0x13024D
#define REG_BK1302_27_L      0x13024E
#define REG_BK1302_27_H      0x13024F
#define REG_BK1302_28_L      0x130250
#define REG_BK1302_28_H      0x130251
#define REG_BK1302_29_L      0x130252
#define REG_BK1302_29_H      0x130253
#define REG_BK1302_2A_L      0x130254
#define REG_BK1302_2A_H      0x130255
#define REG_BK1302_2B_L      0x130256
#define REG_BK1302_2B_H      0x130257
#define REG_BK1302_2C_L      0x130258
#define REG_BK1302_2C_H      0x130259
#define REG_BK1302_2D_L      0x13025A
#define REG_BK1302_2D_H      0x13025B
#define REG_BK1302_2E_L      0x13025C
#define REG_BK1302_2E_H      0x13025D
#define REG_BK1302_2F_L      0x13025E
#define REG_BK1302_2F_H      0x13025F
#define REG_BK1302_30_L      0x130260
#define REG_BK1302_30_H      0x130261
#define REG_BK1302_31_L      0x130262
#define REG_BK1302_31_H      0x130263
#define REG_BK1302_32_L      0x130264
#define REG_BK1302_32_H      0x130265
#define REG_BK1302_33_L      0x130266
#define REG_BK1302_33_H      0x130267
#define REG_BK1302_34_L      0x130268
#define REG_BK1302_34_H      0x130269
#define REG_BK1302_35_L      0x13026A
#define REG_BK1302_35_H      0x13026B
#define REG_BK1302_36_L      0x13026C
#define REG_BK1302_36_H      0x13026D
#define REG_BK1302_37_L      0x13026E
#define REG_BK1302_37_H      0x13026F
#define REG_BK1302_38_L      0x130270
#define REG_BK1302_38_H      0x130271
#define REG_BK1302_39_L      0x130272
#define REG_BK1302_39_H      0x130273
#define REG_BK1302_3A_L      0x130274
#define REG_BK1302_3A_H      0x130275
#define REG_BK1302_3B_L      0x130276
#define REG_BK1302_3B_H      0x130277
#define REG_BK1302_3C_L      0x130278
#define REG_BK1302_3C_H      0x130279
#define REG_BK1302_3D_L      0x13027A
#define REG_BK1302_3D_H      0x13027B
#define REG_BK1302_3E_L      0x13027C
#define REG_BK1302_3E_H      0x13027D
#define REG_BK1302_3F_L      0x13027E
#define REG_BK1302_3F_H      0x13027F
#define REG_BK1302_40_L      0x130280
#define REG_BK1302_40_H      0x130281
#define REG_BK1302_41_L      0x130282
#define REG_BK1302_41_H      0x130283
#define REG_BK1302_42_L      0x130284
#define REG_BK1302_42_H      0x130285
#define REG_BK1302_43_L      0x130286
#define REG_BK1302_43_H      0x130287
#define REG_BK1302_44_L      0x130288
#define REG_BK1302_44_H      0x130289
#define REG_BK1302_45_L      0x13028A
#define REG_BK1302_45_H      0x13028B
#define REG_BK1302_46_L      0x13028C
#define REG_BK1302_46_H      0x13028D
#define REG_BK1302_47_L      0x13028E
#define REG_BK1302_47_H      0x13028F
#define REG_BK1302_48_L      0x130290
#define REG_BK1302_48_H      0x130291
#define REG_BK1302_49_L      0x130292
#define REG_BK1302_49_H      0x130293
#define REG_BK1302_4A_L      0x130294
#define REG_BK1302_4A_H      0x130295
#define REG_BK1302_4B_L      0x130296
#define REG_BK1302_4B_H      0x130297
#define REG_BK1302_4C_L      0x130298
#define REG_BK1302_4C_H      0x130299
#define REG_BK1302_4D_L      0x13029A
#define REG_BK1302_4D_H      0x13029B
#define REG_BK1302_4E_L      0x13029C
#define REG_BK1302_4E_H      0x13029D
#define REG_BK1302_4F_L      0x13029E
#define REG_BK1302_4F_H      0x13029F
#define REG_BK1302_50_L      0x1302A0
#define REG_BK1302_50_H      0x1302A1
#define REG_BK1302_51_L      0x1302A2
#define REG_BK1302_51_H      0x1302A3
#define REG_BK1302_52_L      0x1302A4
#define REG_BK1302_52_H      0x1302A5
#define REG_BK1302_53_L      0x1302A6
#define REG_BK1302_53_H      0x1302A7
#define REG_BK1302_54_L      0x1302A8
#define REG_BK1302_54_H      0x1302A9
#define REG_BK1302_55_L      0x1302AA
#define REG_BK1302_55_H      0x1302AB
#define REG_BK1302_56_L      0x1302AC
#define REG_BK1302_56_H      0x1302AD
#define REG_BK1302_57_L      0x1302AE
#define REG_BK1302_57_H      0x1302AF
#define REG_BK1302_58_L      0x1302B0
#define REG_BK1302_58_H      0x1302B1
#define REG_BK1302_59_L      0x1302B2
#define REG_BK1302_59_H      0x1302B3
#define REG_BK1302_5A_L      0x1302B4
#define REG_BK1302_5A_H      0x1302B5
#define REG_BK1302_5B_L      0x1302B6
#define REG_BK1302_5B_H      0x1302B7
#define REG_BK1302_5C_L      0x1302B8
#define REG_BK1302_5C_H      0x1302B9
#define REG_BK1302_5D_L      0x1302BA
#define REG_BK1302_5D_H      0x1302BB
#define REG_BK1302_5E_L      0x1302BC
#define REG_BK1302_5E_H      0x1302BD
#define REG_BK1302_5F_L      0x1302BE
#define REG_BK1302_5F_H      0x1302BF
#define REG_BK1302_60_L      0x1302C0
#define REG_BK1302_60_H      0x1302C1
#define REG_BK1302_61_L      0x1302C2
#define REG_BK1302_61_H      0x1302C3
#define REG_BK1302_62_L      0x1302C4
#define REG_BK1302_62_H      0x1302C5
#define REG_BK1302_63_L      0x1302C6
#define REG_BK1302_63_H      0x1302C7
#define REG_BK1302_64_L      0x1302C8
#define REG_BK1302_64_H      0x1302C9
#define REG_BK1302_65_L      0x1302CA
#define REG_BK1302_65_H      0x1302CB
#define REG_BK1302_66_L      0x1302CC
#define REG_BK1302_66_H      0x1302CD
#define REG_BK1302_67_L      0x1302CE
#define REG_BK1302_67_H      0x1302CF
#define REG_BK1302_68_L      0x1302D0
#define REG_BK1302_68_H      0x1302D1
#define REG_BK1302_69_L      0x1302D2
#define REG_BK1302_69_H      0x1302D3
#define REG_BK1302_6A_L      0x1302D4
#define REG_BK1302_6A_H      0x1302D5
#define REG_BK1302_6B_L      0x1302D6
#define REG_BK1302_6B_H      0x1302D7
#define REG_BK1302_6C_L      0x1302D8
#define REG_BK1302_6C_H      0x1302D9
#define REG_BK1302_6D_L      0x1302DA
#define REG_BK1302_6D_H      0x1302DB
#define REG_BK1302_6E_L      0x1302DC
#define REG_BK1302_6E_H      0x1302DD
#define REG_BK1302_6F_L      0x1302DE
#define REG_BK1302_6F_H      0x1302DF
#define REG_BK1302_70_L      0x1302E0
#define REG_BK1302_70_H      0x1302E1
#define REG_BK1302_71_L      0x1302E2
#define REG_BK1302_71_H      0x1302E3
#define REG_BK1302_72_L      0x1302E4
#define REG_BK1302_72_H      0x1302E5
#define REG_BK1302_73_L      0x1302E6
#define REG_BK1302_73_H      0x1302E7
#define REG_BK1302_74_L      0x1302E8
#define REG_BK1302_74_H      0x1302E9
#define REG_BK1302_75_L      0x1302EA
#define REG_BK1302_75_H      0x1302EB
#define REG_BK1302_76_L      0x1302EC
#define REG_BK1302_76_H      0x1302ED
#define REG_BK1302_77_L      0x1302EE
#define REG_BK1302_77_H      0x1302EF
#define REG_BK1302_78_L      0x1302F0
#define REG_BK1302_78_H      0x1302F1
#define REG_BK1302_79_L      0x1302F2
#define REG_BK1302_79_H      0x1302F3
#define REG_BK1302_7A_L      0x1302F4
#define REG_BK1302_7A_H      0x1302F5
#define REG_BK1302_7B_L      0x1302F6
#define REG_BK1302_7B_H      0x1302F7
#define REG_BK1302_7C_L      0x1302F8
#define REG_BK1302_7C_H      0x1302F9
#define REG_BK1302_7D_L      0x1302FA
#define REG_BK1302_7D_H      0x1302FB
#define REG_BK1302_7E_L      0x1302FC
#define REG_BK1302_7E_H      0x1302FD
#define REG_BK1302_7F_L      0x1302FE
#define REG_BK1302_7F_H      0x1302FF
//----------------------------------------------
#define REG_BK1303_00_L      0x130300
#define REG_BK1303_00_H      0x130301
#define REG_BK1303_01_L      0x130302
#define REG_BK1303_01_H      0x130303
#define REG_BK1303_02_L      0x130304
#define REG_BK1303_02_H      0x130305
#define REG_BK1303_03_L      0x130306
#define REG_BK1303_03_H      0x130307
#define REG_BK1303_04_L      0x130308
#define REG_BK1303_04_H      0x130309
#define REG_BK1303_05_L      0x13030A
#define REG_BK1303_05_H      0x13030B
#define REG_BK1303_06_L      0x13030C
#define REG_BK1303_06_H      0x13030D
#define REG_BK1303_07_L      0x13030E
#define REG_BK1303_07_H      0x13030F
#define REG_BK1303_08_L      0x130310
#define REG_BK1303_08_H      0x130311
#define REG_BK1303_09_L      0x130312
#define REG_BK1303_09_H      0x130313
#define REG_BK1303_0A_L      0x130314
#define REG_BK1303_0A_H      0x130315
#define REG_BK1303_0B_L      0x130316
#define REG_BK1303_0B_H      0x130317
#define REG_BK1303_0C_L      0x130318
#define REG_BK1303_0C_H      0x130319
#define REG_BK1303_0D_L      0x13031A
#define REG_BK1303_0D_H      0x13031B
#define REG_BK1303_0E_L      0x13031C
#define REG_BK1303_0E_H      0x13031D
#define REG_BK1303_0F_L      0x13031E
#define REG_BK1303_0F_H      0x13031F
#define REG_BK1303_10_L      0x130320
#define REG_BK1303_10_H      0x130321
#define REG_BK1303_11_L      0x130322
#define REG_BK1303_11_H      0x130323
#define REG_BK1303_12_L      0x130324
#define REG_BK1303_12_H      0x130325
#define REG_BK1303_13_L      0x130326
#define REG_BK1303_13_H      0x130327
#define REG_BK1303_14_L      0x130328
#define REG_BK1303_14_H      0x130329
#define REG_BK1303_15_L      0x13032A
#define REG_BK1303_15_H      0x13032B
#define REG_BK1303_16_L      0x13032C
#define REG_BK1303_16_H      0x13032D
#define REG_BK1303_17_L      0x13032E
#define REG_BK1303_17_H      0x13032F
#define REG_BK1303_18_L      0x130330
#define REG_BK1303_18_H      0x130331
#define REG_BK1303_19_L      0x130332
#define REG_BK1303_19_H      0x130333
#define REG_BK1303_1A_L      0x130334
#define REG_BK1303_1A_H      0x130335
#define REG_BK1303_1B_L      0x130336
#define REG_BK1303_1B_H      0x130337
#define REG_BK1303_1C_L      0x130338
#define REG_BK1303_1C_H      0x130339
#define REG_BK1303_1D_L      0x13033A
#define REG_BK1303_1D_H      0x13033B
#define REG_BK1303_1E_L      0x13033C
#define REG_BK1303_1E_H      0x13033D
#define REG_BK1303_1F_L      0x13033E
#define REG_BK1303_1F_H      0x13033F
#define REG_BK1303_20_L      0x130340
#define REG_BK1303_20_H      0x130341
#define REG_BK1303_21_L      0x130342
#define REG_BK1303_21_H      0x130343
#define REG_BK1303_22_L      0x130344
#define REG_BK1303_22_H      0x130345
#define REG_BK1303_23_L      0x130346
#define REG_BK1303_23_H      0x130347
#define REG_BK1303_24_L      0x130348
#define REG_BK1303_24_H      0x130349
#define REG_BK1303_25_L      0x13034A
#define REG_BK1303_25_H      0x13034B
#define REG_BK1303_26_L      0x13034C
#define REG_BK1303_26_H      0x13034D
#define REG_BK1303_27_L      0x13034E
#define REG_BK1303_27_H      0x13034F
#define REG_BK1303_28_L      0x130350
#define REG_BK1303_28_H      0x130351
#define REG_BK1303_29_L      0x130352
#define REG_BK1303_29_H      0x130353
#define REG_BK1303_2A_L      0x130354
#define REG_BK1303_2A_H      0x130355
#define REG_BK1303_2B_L      0x130356
#define REG_BK1303_2B_H      0x130357
#define REG_BK1303_2C_L      0x130358
#define REG_BK1303_2C_H      0x130359
#define REG_BK1303_2D_L      0x13035A
#define REG_BK1303_2D_H      0x13035B
#define REG_BK1303_2E_L      0x13035C
#define REG_BK1303_2E_H      0x13035D
#define REG_BK1303_2F_L      0x13035E
#define REG_BK1303_2F_H      0x13035F
#define REG_BK1303_30_L      0x130360
#define REG_BK1303_30_H      0x130361
#define REG_BK1303_31_L      0x130362
#define REG_BK1303_31_H      0x130363
#define REG_BK1303_32_L      0x130364
#define REG_BK1303_32_H      0x130365
#define REG_BK1303_33_L      0x130366
#define REG_BK1303_33_H      0x130367
#define REG_BK1303_34_L      0x130368
#define REG_BK1303_34_H      0x130369
#define REG_BK1303_35_L      0x13036A
#define REG_BK1303_35_H      0x13036B
#define REG_BK1303_36_L      0x13036C
#define REG_BK1303_36_H      0x13036D
#define REG_BK1303_37_L      0x13036E
#define REG_BK1303_37_H      0x13036F
#define REG_BK1303_38_L      0x130370
#define REG_BK1303_38_H      0x130371
#define REG_BK1303_39_L      0x130372
#define REG_BK1303_39_H      0x130373
#define REG_BK1303_3A_L      0x130374
#define REG_BK1303_3A_H      0x130375
#define REG_BK1303_3B_L      0x130376
#define REG_BK1303_3B_H      0x130377
#define REG_BK1303_3C_L      0x130378
#define REG_BK1303_3C_H      0x130379
#define REG_BK1303_3D_L      0x13037A
#define REG_BK1303_3D_H      0x13037B
#define REG_BK1303_3E_L      0x13037C
#define REG_BK1303_3E_H      0x13037D
#define REG_BK1303_3F_L      0x13037E
#define REG_BK1303_3F_H      0x13037F
#define REG_BK1303_40_L      0x130380
#define REG_BK1303_40_H      0x130381
#define REG_BK1303_41_L      0x130382
#define REG_BK1303_41_H      0x130383
#define REG_BK1303_42_L      0x130384
#define REG_BK1303_42_H      0x130385
#define REG_BK1303_43_L      0x130386
#define REG_BK1303_43_H      0x130387
#define REG_BK1303_44_L      0x130388
#define REG_BK1303_44_H      0x130389
#define REG_BK1303_45_L      0x13038A
#define REG_BK1303_45_H      0x13038B
#define REG_BK1303_46_L      0x13038C
#define REG_BK1303_46_H      0x13038D
#define REG_BK1303_47_L      0x13038E
#define REG_BK1303_47_H      0x13038F
#define REG_BK1303_48_L      0x130390
#define REG_BK1303_48_H      0x130391
#define REG_BK1303_49_L      0x130392
#define REG_BK1303_49_H      0x130393
#define REG_BK1303_4A_L      0x130394
#define REG_BK1303_4A_H      0x130395
#define REG_BK1303_4B_L      0x130396
#define REG_BK1303_4B_H      0x130397
#define REG_BK1303_4C_L      0x130398
#define REG_BK1303_4C_H      0x130399
#define REG_BK1303_4D_L      0x13039A
#define REG_BK1303_4D_H      0x13039B
#define REG_BK1303_4E_L      0x13039C
#define REG_BK1303_4E_H      0x13039D
#define REG_BK1303_4F_L      0x13039E
#define REG_BK1303_4F_H      0x13039F
#define REG_BK1303_50_L      0x1303A0
#define REG_BK1303_50_H      0x1303A1
#define REG_BK1303_51_L      0x1303A2
#define REG_BK1303_51_H      0x1303A3
#define REG_BK1303_52_L      0x1303A4
#define REG_BK1303_52_H      0x1303A5
#define REG_BK1303_53_L      0x1303A6
#define REG_BK1303_53_H      0x1303A7
#define REG_BK1303_54_L      0x1303A8
#define REG_BK1303_54_H      0x1303A9
#define REG_BK1303_55_L      0x1303AA
#define REG_BK1303_55_H      0x1303AB
#define REG_BK1303_56_L      0x1303AC
#define REG_BK1303_56_H      0x1303AD
#define REG_BK1303_57_L      0x1303AE
#define REG_BK1303_57_H      0x1303AF
#define REG_BK1303_58_L      0x1303B0
#define REG_BK1303_58_H      0x1303B1
#define REG_BK1303_59_L      0x1303B2
#define REG_BK1303_59_H      0x1303B3
#define REG_BK1303_5A_L      0x1303B4
#define REG_BK1303_5A_H      0x1303B5
#define REG_BK1303_5B_L      0x1303B6
#define REG_BK1303_5B_H      0x1303B7
#define REG_BK1303_5C_L      0x1303B8
#define REG_BK1303_5C_H      0x1303B9
#define REG_BK1303_5D_L      0x1303BA
#define REG_BK1303_5D_H      0x1303BB
#define REG_BK1303_5E_L      0x1303BC
#define REG_BK1303_5E_H      0x1303BD
#define REG_BK1303_5F_L      0x1303BE
#define REG_BK1303_5F_H      0x1303BF
#define REG_BK1303_60_L      0x1303C0
#define REG_BK1303_60_H      0x1303C1
#define REG_BK1303_61_L      0x1303C2
#define REG_BK1303_61_H      0x1303C3
#define REG_BK1303_62_L      0x1303C4
#define REG_BK1303_62_H      0x1303C5
#define REG_BK1303_63_L      0x1303C6
#define REG_BK1303_63_H      0x1303C7
#define REG_BK1303_64_L      0x1303C8
#define REG_BK1303_64_H      0x1303C9
#define REG_BK1303_65_L      0x1303CA
#define REG_BK1303_65_H      0x1303CB
#define REG_BK1303_66_L      0x1303CC
#define REG_BK1303_66_H      0x1303CD
#define REG_BK1303_67_L      0x1303CE
#define REG_BK1303_67_H      0x1303CF
#define REG_BK1303_68_L      0x1303D0
#define REG_BK1303_68_H      0x1303D1
#define REG_BK1303_69_L      0x1303D2
#define REG_BK1303_69_H      0x1303D3
#define REG_BK1303_6A_L      0x1303D4
#define REG_BK1303_6A_H      0x1303D5
#define REG_BK1303_6B_L      0x1303D6
#define REG_BK1303_6B_H      0x1303D7
#define REG_BK1303_6C_L      0x1303D8
#define REG_BK1303_6C_H      0x1303D9
#define REG_BK1303_6D_L      0x1303DA
#define REG_BK1303_6D_H      0x1303DB
#define REG_BK1303_6E_L      0x1303DC
#define REG_BK1303_6E_H      0x1303DD
#define REG_BK1303_6F_L      0x1303DE
#define REG_BK1303_6F_H      0x1303DF
#define REG_BK1303_70_L      0x1303E0
#define REG_BK1303_70_H      0x1303E1
#define REG_BK1303_71_L      0x1303E2
#define REG_BK1303_71_H      0x1303E3
#define REG_BK1303_72_L      0x1303E4
#define REG_BK1303_72_H      0x1303E5
#define REG_BK1303_73_L      0x1303E6
#define REG_BK1303_73_H      0x1303E7
#define REG_BK1303_74_L      0x1303E8
#define REG_BK1303_74_H      0x1303E9
#define REG_BK1303_75_L      0x1303EA
#define REG_BK1303_75_H      0x1303EB
#define REG_BK1303_76_L      0x1303EC
#define REG_BK1303_76_H      0x1303ED
#define REG_BK1303_77_L      0x1303EE
#define REG_BK1303_77_H      0x1303EF
#define REG_BK1303_78_L      0x1303F0
#define REG_BK1303_78_H      0x1303F1
#define REG_BK1303_79_L      0x1303F2
#define REG_BK1303_79_H      0x1303F3
#define REG_BK1303_7A_L      0x1303F4
#define REG_BK1303_7A_H      0x1303F5
#define REG_BK1303_7B_L      0x1303F6
#define REG_BK1303_7B_H      0x1303F7
#define REG_BK1303_7C_L      0x1303F8
#define REG_BK1303_7C_H      0x1303F9
#define REG_BK1303_7D_L      0x1303FA
#define REG_BK1303_7D_H      0x1303FB
#define REG_BK1303_7E_L      0x1303FC
#define REG_BK1303_7E_H      0x1303FD
#define REG_BK1303_7F_L      0x1303FE
#define REG_BK1303_7F_H      0x1303FF
//----------------------------------------------
#define REG_BK1304_00_L      0x130400
#define REG_BK1304_00_H      0x130401
#define REG_BK1304_01_L      0x130402
#define REG_BK1304_01_H      0x130403
#define REG_BK1304_02_L      0x130404
#define REG_BK1304_02_H      0x130405
#define REG_BK1304_03_L      0x130406
#define REG_BK1304_03_H      0x130407
#define REG_BK1304_04_L      0x130408
#define REG_BK1304_04_H      0x130409
#define REG_BK1304_05_L      0x13040A
#define REG_BK1304_05_H      0x13040B
#define REG_BK1304_06_L      0x13040C
#define REG_BK1304_06_H      0x13040D
#define REG_BK1304_07_L      0x13040E
#define REG_BK1304_07_H      0x13040F
#define REG_BK1304_08_L      0x130410
#define REG_BK1304_08_H      0x130411
#define REG_BK1304_09_L      0x130412
#define REG_BK1304_09_H      0x130413
#define REG_BK1304_0A_L      0x130414
#define REG_BK1304_0A_H      0x130415
#define REG_BK1304_0B_L      0x130416
#define REG_BK1304_0B_H      0x130417
#define REG_BK1304_0C_L      0x130418
#define REG_BK1304_0C_H      0x130419
#define REG_BK1304_0D_L      0x13041A
#define REG_BK1304_0D_H      0x13041B
#define REG_BK1304_0E_L      0x13041C
#define REG_BK1304_0E_H      0x13041D
#define REG_BK1304_0F_L      0x13041E
#define REG_BK1304_0F_H      0x13041F
#define REG_BK1304_10_L      0x130420
#define REG_BK1304_10_H      0x130421
#define REG_BK1304_11_L      0x130422
#define REG_BK1304_11_H      0x130423
#define REG_BK1304_12_L      0x130424
#define REG_BK1304_12_H      0x130425
#define REG_BK1304_13_L      0x130426
#define REG_BK1304_13_H      0x130427
#define REG_BK1304_14_L      0x130428
#define REG_BK1304_14_H      0x130429
#define REG_BK1304_15_L      0x13042A
#define REG_BK1304_15_H      0x13042B
#define REG_BK1304_16_L      0x13042C
#define REG_BK1304_16_H      0x13042D
#define REG_BK1304_17_L      0x13042E
#define REG_BK1304_17_H      0x13042F
#define REG_BK1304_18_L      0x130430
#define REG_BK1304_18_H      0x130431
#define REG_BK1304_19_L      0x130432
#define REG_BK1304_19_H      0x130433
#define REG_BK1304_1A_L      0x130434
#define REG_BK1304_1A_H      0x130435
#define REG_BK1304_1B_L      0x130436
#define REG_BK1304_1B_H      0x130437
#define REG_BK1304_1C_L      0x130438
#define REG_BK1304_1C_H      0x130439
#define REG_BK1304_1D_L      0x13043A
#define REG_BK1304_1D_H      0x13043B
#define REG_BK1304_1E_L      0x13043C
#define REG_BK1304_1E_H      0x13043D
#define REG_BK1304_1F_L      0x13043E
#define REG_BK1304_1F_H      0x13043F
#define REG_BK1304_20_L      0x130440
#define REG_BK1304_20_H      0x130441
#define REG_BK1304_21_L      0x130442
#define REG_BK1304_21_H      0x130443
#define REG_BK1304_22_L      0x130444
#define REG_BK1304_22_H      0x130445
#define REG_BK1304_23_L      0x130446
#define REG_BK1304_23_H      0x130447
#define REG_BK1304_24_L      0x130448
#define REG_BK1304_24_H      0x130449
#define REG_BK1304_25_L      0x13044A
#define REG_BK1304_25_H      0x13044B
#define REG_BK1304_26_L      0x13044C
#define REG_BK1304_26_H      0x13044D
#define REG_BK1304_27_L      0x13044E
#define REG_BK1304_27_H      0x13044F
#define REG_BK1304_28_L      0x130450
#define REG_BK1304_28_H      0x130451
#define REG_BK1304_29_L      0x130452
#define REG_BK1304_29_H      0x130453
#define REG_BK1304_2A_L      0x130454
#define REG_BK1304_2A_H      0x130455
#define REG_BK1304_2B_L      0x130456
#define REG_BK1304_2B_H      0x130457
#define REG_BK1304_2C_L      0x130458
#define REG_BK1304_2C_H      0x130459
#define REG_BK1304_2D_L      0x13045A
#define REG_BK1304_2D_H      0x13045B
#define REG_BK1304_2E_L      0x13045C
#define REG_BK1304_2E_H      0x13045D
#define REG_BK1304_2F_L      0x13045E
#define REG_BK1304_2F_H      0x13045F
#define REG_BK1304_30_L      0x130460
#define REG_BK1304_30_H      0x130461
#define REG_BK1304_31_L      0x130462
#define REG_BK1304_31_H      0x130463
#define REG_BK1304_32_L      0x130464
#define REG_BK1304_32_H      0x130465
#define REG_BK1304_33_L      0x130466
#define REG_BK1304_33_H      0x130467
#define REG_BK1304_34_L      0x130468
#define REG_BK1304_34_H      0x130469
#define REG_BK1304_35_L      0x13046A
#define REG_BK1304_35_H      0x13046B
#define REG_BK1304_36_L      0x13046C
#define REG_BK1304_36_H      0x13046D
#define REG_BK1304_37_L      0x13046E
#define REG_BK1304_37_H      0x13046F
#define REG_BK1304_38_L      0x130470
#define REG_BK1304_38_H      0x130471
#define REG_BK1304_39_L      0x130472
#define REG_BK1304_39_H      0x130473
#define REG_BK1304_3A_L      0x130474
#define REG_BK1304_3A_H      0x130475
#define REG_BK1304_3B_L      0x130476
#define REG_BK1304_3B_H      0x130477
#define REG_BK1304_3C_L      0x130478
#define REG_BK1304_3C_H      0x130479
#define REG_BK1304_3D_L      0x13047A
#define REG_BK1304_3D_H      0x13047B
#define REG_BK1304_3E_L      0x13047C
#define REG_BK1304_3E_H      0x13047D
#define REG_BK1304_3F_L      0x13047E
#define REG_BK1304_3F_H      0x13047F
#define REG_BK1304_40_L      0x130480
#define REG_BK1304_40_H      0x130481
#define REG_BK1304_41_L      0x130482
#define REG_BK1304_41_H      0x130483
#define REG_BK1304_42_L      0x130484
#define REG_BK1304_42_H      0x130485
#define REG_BK1304_43_L      0x130486
#define REG_BK1304_43_H      0x130487
#define REG_BK1304_44_L      0x130488
#define REG_BK1304_44_H      0x130489
#define REG_BK1304_45_L      0x13048A
#define REG_BK1304_45_H      0x13048B
#define REG_BK1304_46_L      0x13048C
#define REG_BK1304_46_H      0x13048D
#define REG_BK1304_47_L      0x13048E
#define REG_BK1304_47_H      0x13048F
#define REG_BK1304_48_L      0x130490
#define REG_BK1304_48_H      0x130491
#define REG_BK1304_49_L      0x130492
#define REG_BK1304_49_H      0x130493
#define REG_BK1304_4A_L      0x130494
#define REG_BK1304_4A_H      0x130495
#define REG_BK1304_4B_L      0x130496
#define REG_BK1304_4B_H      0x130497
#define REG_BK1304_4C_L      0x130498
#define REG_BK1304_4C_H      0x130499
#define REG_BK1304_4D_L      0x13049A
#define REG_BK1304_4D_H      0x13049B
#define REG_BK1304_4E_L      0x13049C
#define REG_BK1304_4E_H      0x13049D
#define REG_BK1304_4F_L      0x13049E
#define REG_BK1304_4F_H      0x13049F
#define REG_BK1304_50_L      0x1304A0
#define REG_BK1304_50_H      0x1304A1
#define REG_BK1304_51_L      0x1304A2
#define REG_BK1304_51_H      0x1304A3
#define REG_BK1304_52_L      0x1304A4
#define REG_BK1304_52_H      0x1304A5
#define REG_BK1304_53_L      0x1304A6
#define REG_BK1304_53_H      0x1304A7
#define REG_BK1304_54_L      0x1304A8
#define REG_BK1304_54_H      0x1304A9
#define REG_BK1304_55_L      0x1304AA
#define REG_BK1304_55_H      0x1304AB
#define REG_BK1304_56_L      0x1304AC
#define REG_BK1304_56_H      0x1304AD
#define REG_BK1304_57_L      0x1304AE
#define REG_BK1304_57_H      0x1304AF
#define REG_BK1304_58_L      0x1304B0
#define REG_BK1304_58_H      0x1304B1
#define REG_BK1304_59_L      0x1304B2
#define REG_BK1304_59_H      0x1304B3
#define REG_BK1304_5A_L      0x1304B4
#define REG_BK1304_5A_H      0x1304B5
#define REG_BK1304_5B_L      0x1304B6
#define REG_BK1304_5B_H      0x1304B7
#define REG_BK1304_5C_L      0x1304B8
#define REG_BK1304_5C_H      0x1304B9
#define REG_BK1304_5D_L      0x1304BA
#define REG_BK1304_5D_H      0x1304BB
#define REG_BK1304_5E_L      0x1304BC
#define REG_BK1304_5E_H      0x1304BD
#define REG_BK1304_5F_L      0x1304BE
#define REG_BK1304_5F_H      0x1304BF
#define REG_BK1304_60_L      0x1304C0
#define REG_BK1304_60_H      0x1304C1
#define REG_BK1304_61_L      0x1304C2
#define REG_BK1304_61_H      0x1304C3
#define REG_BK1304_62_L      0x1304C4
#define REG_BK1304_62_H      0x1304C5
#define REG_BK1304_63_L      0x1304C6
#define REG_BK1304_63_H      0x1304C7
#define REG_BK1304_64_L      0x1304C8
#define REG_BK1304_64_H      0x1304C9
#define REG_BK1304_65_L      0x1304CA
#define REG_BK1304_65_H      0x1304CB
#define REG_BK1304_66_L      0x1304CC
#define REG_BK1304_66_H      0x1304CD
#define REG_BK1304_67_L      0x1304CE
#define REG_BK1304_67_H      0x1304CF
#define REG_BK1304_68_L      0x1304D0
#define REG_BK1304_68_H      0x1304D1
#define REG_BK1304_69_L      0x1304D2
#define REG_BK1304_69_H      0x1304D3
#define REG_BK1304_6A_L      0x1304D4
#define REG_BK1304_6A_H      0x1304D5
#define REG_BK1304_6B_L      0x1304D6
#define REG_BK1304_6B_H      0x1304D7
#define REG_BK1304_6C_L      0x1304D8
#define REG_BK1304_6C_H      0x1304D9
#define REG_BK1304_6D_L      0x1304DA
#define REG_BK1304_6D_H      0x1304DB
#define REG_BK1304_6E_L      0x1304DC
#define REG_BK1304_6E_H      0x1304DD
#define REG_BK1304_6F_L      0x1304DE
#define REG_BK1304_6F_H      0x1304DF
#define REG_BK1304_70_L      0x1304E0
#define REG_BK1304_70_H      0x1304E1
#define REG_BK1304_71_L      0x1304E2
#define REG_BK1304_71_H      0x1304E3
#define REG_BK1304_72_L      0x1304E4
#define REG_BK1304_72_H      0x1304E5
#define REG_BK1304_73_L      0x1304E6
#define REG_BK1304_73_H      0x1304E7
#define REG_BK1304_74_L      0x1304E8
#define REG_BK1304_74_H      0x1304E9
#define REG_BK1304_75_L      0x1304EA
#define REG_BK1304_75_H      0x1304EB
#define REG_BK1304_76_L      0x1304EC
#define REG_BK1304_76_H      0x1304ED
#define REG_BK1304_77_L      0x1304EE
#define REG_BK1304_77_H      0x1304EF
#define REG_BK1304_78_L      0x1304F0
#define REG_BK1304_78_H      0x1304F1
#define REG_BK1304_79_L      0x1304F2
#define REG_BK1304_79_H      0x1304F3
#define REG_BK1304_7A_L      0x1304F4
#define REG_BK1304_7A_H      0x1304F5
#define REG_BK1304_7B_L      0x1304F6
#define REG_BK1304_7B_H      0x1304F7
#define REG_BK1304_7C_L      0x1304F8
#define REG_BK1304_7C_H      0x1304F9
#define REG_BK1304_7D_L      0x1304FA
#define REG_BK1304_7D_H      0x1304FB
#define REG_BK1304_7E_L      0x1304FC
#define REG_BK1304_7E_H      0x1304FD
#define REG_BK1304_7F_L      0x1304FE
#define REG_BK1304_7F_H      0x1304FF
//----------------------------------------------
#define REG_BK1305_00_L      0x130500
#define REG_BK1305_00_H      0x130501
#define REG_BK1305_01_L      0x130502
#define REG_BK1305_01_H      0x130503
#define REG_BK1305_02_L      0x130504
#define REG_BK1305_02_H      0x130505
#define REG_BK1305_03_L      0x130506
#define REG_BK1305_03_H      0x130507
#define REG_BK1305_04_L      0x130508
#define REG_BK1305_04_H      0x130509
#define REG_BK1305_05_L      0x13050A
#define REG_BK1305_05_H      0x13050B
#define REG_BK1305_06_L      0x13050C
#define REG_BK1305_06_H      0x13050D
#define REG_BK1305_07_L      0x13050E
#define REG_BK1305_07_H      0x13050F
#define REG_BK1305_08_L      0x130510
#define REG_BK1305_08_H      0x130511
#define REG_BK1305_09_L      0x130512
#define REG_BK1305_09_H      0x130513
#define REG_BK1305_0A_L      0x130514
#define REG_BK1305_0A_H      0x130515
#define REG_BK1305_0B_L      0x130516
#define REG_BK1305_0B_H      0x130517
#define REG_BK1305_0C_L      0x130518
#define REG_BK1305_0C_H      0x130519
#define REG_BK1305_0D_L      0x13051A
#define REG_BK1305_0D_H      0x13051B
#define REG_BK1305_0E_L      0x13051C
#define REG_BK1305_0E_H      0x13051D
#define REG_BK1305_0F_L      0x13051E
#define REG_BK1305_0F_H      0x13051F
#define REG_BK1305_10_L      0x130520
#define REG_BK1305_10_H      0x130521
#define REG_BK1305_11_L      0x130522
#define REG_BK1305_11_H      0x130523
#define REG_BK1305_12_L      0x130524
#define REG_BK1305_12_H      0x130525
#define REG_BK1305_13_L      0x130526
#define REG_BK1305_13_H      0x130527
#define REG_BK1305_14_L      0x130528
#define REG_BK1305_14_H      0x130529
#define REG_BK1305_15_L      0x13052A
#define REG_BK1305_15_H      0x13052B
#define REG_BK1305_16_L      0x13052C
#define REG_BK1305_16_H      0x13052D
#define REG_BK1305_17_L      0x13052E
#define REG_BK1305_17_H      0x13052F
#define REG_BK1305_18_L      0x130530
#define REG_BK1305_18_H      0x130531
#define REG_BK1305_19_L      0x130532
#define REG_BK1305_19_H      0x130533
#define REG_BK1305_1A_L      0x130534
#define REG_BK1305_1A_H      0x130535
#define REG_BK1305_1B_L      0x130536
#define REG_BK1305_1B_H      0x130537
#define REG_BK1305_1C_L      0x130538
#define REG_BK1305_1C_H      0x130539
#define REG_BK1305_1D_L      0x13053A
#define REG_BK1305_1D_H      0x13053B
#define REG_BK1305_1E_L      0x13053C
#define REG_BK1305_1E_H      0x13053D
#define REG_BK1305_1F_L      0x13053E
#define REG_BK1305_1F_H      0x13053F
#define REG_BK1305_20_L      0x130540
#define REG_BK1305_20_H      0x130541
#define REG_BK1305_21_L      0x130542
#define REG_BK1305_21_H      0x130543
#define REG_BK1305_22_L      0x130544
#define REG_BK1305_22_H      0x130545
#define REG_BK1305_23_L      0x130546
#define REG_BK1305_23_H      0x130547
#define REG_BK1305_24_L      0x130548
#define REG_BK1305_24_H      0x130549
#define REG_BK1305_25_L      0x13054A
#define REG_BK1305_25_H      0x13054B
#define REG_BK1305_26_L      0x13054C
#define REG_BK1305_26_H      0x13054D
#define REG_BK1305_27_L      0x13054E
#define REG_BK1305_27_H      0x13054F
#define REG_BK1305_28_L      0x130550
#define REG_BK1305_28_H      0x130551
#define REG_BK1305_29_L      0x130552
#define REG_BK1305_29_H      0x130553
#define REG_BK1305_2A_L      0x130554
#define REG_BK1305_2A_H      0x130555
#define REG_BK1305_2B_L      0x130556
#define REG_BK1305_2B_H      0x130557
#define REG_BK1305_2C_L      0x130558
#define REG_BK1305_2C_H      0x130559
#define REG_BK1305_2D_L      0x13055A
#define REG_BK1305_2D_H      0x13055B
#define REG_BK1305_2E_L      0x13055C
#define REG_BK1305_2E_H      0x13055D
#define REG_BK1305_2F_L      0x13055E
#define REG_BK1305_2F_H      0x13055F
#define REG_BK1305_30_L      0x130560
#define REG_BK1305_30_H      0x130561
#define REG_BK1305_31_L      0x130562
#define REG_BK1305_31_H      0x130563
#define REG_BK1305_32_L      0x130564
#define REG_BK1305_32_H      0x130565
#define REG_BK1305_33_L      0x130566
#define REG_BK1305_33_H      0x130567
#define REG_BK1305_34_L      0x130568
#define REG_BK1305_34_H      0x130569
#define REG_BK1305_35_L      0x13056A
#define REG_BK1305_35_H      0x13056B
#define REG_BK1305_36_L      0x13056C
#define REG_BK1305_36_H      0x13056D
#define REG_BK1305_37_L      0x13056E
#define REG_BK1305_37_H      0x13056F
#define REG_BK1305_38_L      0x130570
#define REG_BK1305_38_H      0x130571
#define REG_BK1305_39_L      0x130572
#define REG_BK1305_39_H      0x130573
#define REG_BK1305_3A_L      0x130574
#define REG_BK1305_3A_H      0x130575
#define REG_BK1305_3B_L      0x130576
#define REG_BK1305_3B_H      0x130577
#define REG_BK1305_3C_L      0x130578
#define REG_BK1305_3C_H      0x130579
#define REG_BK1305_3D_L      0x13057A
#define REG_BK1305_3D_H      0x13057B
#define REG_BK1305_3E_L      0x13057C
#define REG_BK1305_3E_H      0x13057D
#define REG_BK1305_3F_L      0x13057E
#define REG_BK1305_3F_H      0x13057F
#define REG_BK1305_40_L      0x130580
#define REG_BK1305_40_H      0x130581
#define REG_BK1305_41_L      0x130582
#define REG_BK1305_41_H      0x130583
#define REG_BK1305_42_L      0x130584
#define REG_BK1305_42_H      0x130585
#define REG_BK1305_43_L      0x130586
#define REG_BK1305_43_H      0x130587
#define REG_BK1305_44_L      0x130588
#define REG_BK1305_44_H      0x130589
#define REG_BK1305_45_L      0x13058A
#define REG_BK1305_45_H      0x13058B
#define REG_BK1305_46_L      0x13058C
#define REG_BK1305_46_H      0x13058D
#define REG_BK1305_47_L      0x13058E
#define REG_BK1305_47_H      0x13058F
#define REG_BK1305_48_L      0x130590
#define REG_BK1305_48_H      0x130591
#define REG_BK1305_49_L      0x130592
#define REG_BK1305_49_H      0x130593
#define REG_BK1305_4A_L      0x130594
#define REG_BK1305_4A_H      0x130595
#define REG_BK1305_4B_L      0x130596
#define REG_BK1305_4B_H      0x130597
#define REG_BK1305_4C_L      0x130598
#define REG_BK1305_4C_H      0x130599
#define REG_BK1305_4D_L      0x13059A
#define REG_BK1305_4D_H      0x13059B
#define REG_BK1305_4E_L      0x13059C
#define REG_BK1305_4E_H      0x13059D
#define REG_BK1305_4F_L      0x13059E
#define REG_BK1305_4F_H      0x13059F
#define REG_BK1305_50_L      0x1305A0
#define REG_BK1305_50_H      0x1305A1
#define REG_BK1305_51_L      0x1305A2
#define REG_BK1305_51_H      0x1305A3
#define REG_BK1305_52_L      0x1305A4
#define REG_BK1305_52_H      0x1305A5
#define REG_BK1305_53_L      0x1305A6
#define REG_BK1305_53_H      0x1305A7
#define REG_BK1305_54_L      0x1305A8
#define REG_BK1305_54_H      0x1305A9
#define REG_BK1305_55_L      0x1305AA
#define REG_BK1305_55_H      0x1305AB
#define REG_BK1305_56_L      0x1305AC
#define REG_BK1305_56_H      0x1305AD
#define REG_BK1305_57_L      0x1305AE
#define REG_BK1305_57_H      0x1305AF
#define REG_BK1305_58_L      0x1305B0
#define REG_BK1305_58_H      0x1305B1
#define REG_BK1305_59_L      0x1305B2
#define REG_BK1305_59_H      0x1305B3
#define REG_BK1305_5A_L      0x1305B4
#define REG_BK1305_5A_H      0x1305B5
#define REG_BK1305_5B_L      0x1305B6
#define REG_BK1305_5B_H      0x1305B7
#define REG_BK1305_5C_L      0x1305B8
#define REG_BK1305_5C_H      0x1305B9
#define REG_BK1305_5D_L      0x1305BA
#define REG_BK1305_5D_H      0x1305BB
#define REG_BK1305_5E_L      0x1305BC
#define REG_BK1305_5E_H      0x1305BD
#define REG_BK1305_5F_L      0x1305BE
#define REG_BK1305_5F_H      0x1305BF
#define REG_BK1305_60_L      0x1305C0
#define REG_BK1305_60_H      0x1305C1
#define REG_BK1305_61_L      0x1305C2
#define REG_BK1305_61_H      0x1305C3
#define REG_BK1305_62_L      0x1305C4
#define REG_BK1305_62_H      0x1305C5
#define REG_BK1305_63_L      0x1305C6
#define REG_BK1305_63_H      0x1305C7
#define REG_BK1305_64_L      0x1305C8
#define REG_BK1305_64_H      0x1305C9
#define REG_BK1305_65_L      0x1305CA
#define REG_BK1305_65_H      0x1305CB
#define REG_BK1305_66_L      0x1305CC
#define REG_BK1305_66_H      0x1305CD
#define REG_BK1305_67_L      0x1305CE
#define REG_BK1305_67_H      0x1305CF
#define REG_BK1305_68_L      0x1305D0
#define REG_BK1305_68_H      0x1305D1
#define REG_BK1305_69_L      0x1305D2
#define REG_BK1305_69_H      0x1305D3
#define REG_BK1305_6A_L      0x1305D4
#define REG_BK1305_6A_H      0x1305D5
#define REG_BK1305_6B_L      0x1305D6
#define REG_BK1305_6B_H      0x1305D7
#define REG_BK1305_6C_L      0x1305D8
#define REG_BK1305_6C_H      0x1305D9
#define REG_BK1305_6D_L      0x1305DA
#define REG_BK1305_6D_H      0x1305DB
#define REG_BK1305_6E_L      0x1305DC
#define REG_BK1305_6E_H      0x1305DD
#define REG_BK1305_6F_L      0x1305DE
#define REG_BK1305_6F_H      0x1305DF
#define REG_BK1305_70_L      0x1305E0
#define REG_BK1305_70_H      0x1305E1
#define REG_BK1305_71_L      0x1305E2
#define REG_BK1305_71_H      0x1305E3
#define REG_BK1305_72_L      0x1305E4
#define REG_BK1305_72_H      0x1305E5
#define REG_BK1305_73_L      0x1305E6
#define REG_BK1305_73_H      0x1305E7
#define REG_BK1305_74_L      0x1305E8
#define REG_BK1305_74_H      0x1305E9
#define REG_BK1305_75_L      0x1305EA
#define REG_BK1305_75_H      0x1305EB
#define REG_BK1305_76_L      0x1305EC
#define REG_BK1305_76_H      0x1305ED
#define REG_BK1305_77_L      0x1305EE
#define REG_BK1305_77_H      0x1305EF
#define REG_BK1305_78_L      0x1305F0
#define REG_BK1305_78_H      0x1305F1
#define REG_BK1305_79_L      0x1305F2
#define REG_BK1305_79_H      0x1305F3
#define REG_BK1305_7A_L      0x1305F4
#define REG_BK1305_7A_H      0x1305F5
#define REG_BK1305_7B_L      0x1305F6
#define REG_BK1305_7B_H      0x1305F7
#define REG_BK1305_7C_L      0x1305F8
#define REG_BK1305_7C_H      0x1305F9
#define REG_BK1305_7D_L      0x1305FA
#define REG_BK1305_7D_H      0x1305FB
#define REG_BK1305_7E_L      0x1305FC
#define REG_BK1305_7E_H      0x1305FD
#define REG_BK1305_7F_L      0x1305FE
#define REG_BK1305_7F_H      0x1305FF
//----------------------------------------------
#define REG_BK1306_00_L      0x130600
#define REG_BK1306_00_H      0x130601
#define REG_BK1306_01_L      0x130602
#define REG_BK1306_01_H      0x130603
#define REG_BK1306_02_L      0x130604
#define REG_BK1306_02_H      0x130605
#define REG_BK1306_03_L      0x130606
#define REG_BK1306_03_H      0x130607
#define REG_BK1306_04_L      0x130608
#define REG_BK1306_04_H      0x130609
#define REG_BK1306_05_L      0x13060A
#define REG_BK1306_05_H      0x13060B
#define REG_BK1306_06_L      0x13060C
#define REG_BK1306_06_H      0x13060D
#define REG_BK1306_07_L      0x13060E
#define REG_BK1306_07_H      0x13060F
#define REG_BK1306_08_L      0x130610
#define REG_BK1306_08_H      0x130611
#define REG_BK1306_09_L      0x130612
#define REG_BK1306_09_H      0x130613
#define REG_BK1306_0A_L      0x130614
#define REG_BK1306_0A_H      0x130615
#define REG_BK1306_0B_L      0x130616
#define REG_BK1306_0B_H      0x130617
#define REG_BK1306_0C_L      0x130618
#define REG_BK1306_0C_H      0x130619
#define REG_BK1306_0D_L      0x13061A
#define REG_BK1306_0D_H      0x13061B
#define REG_BK1306_0E_L      0x13061C
#define REG_BK1306_0E_H      0x13061D
#define REG_BK1306_0F_L      0x13061E
#define REG_BK1306_0F_H      0x13061F
#define REG_BK1306_10_L      0x130620
#define REG_BK1306_10_H      0x130621
#define REG_BK1306_11_L      0x130622
#define REG_BK1306_11_H      0x130623
#define REG_BK1306_12_L      0x130624
#define REG_BK1306_12_H      0x130625
#define REG_BK1306_13_L      0x130626
#define REG_BK1306_13_H      0x130627
#define REG_BK1306_14_L      0x130628
#define REG_BK1306_14_H      0x130629
#define REG_BK1306_15_L      0x13062A
#define REG_BK1306_15_H      0x13062B
#define REG_BK1306_16_L      0x13062C
#define REG_BK1306_16_H      0x13062D
#define REG_BK1306_17_L      0x13062E
#define REG_BK1306_17_H      0x13062F
#define REG_BK1306_18_L      0x130630
#define REG_BK1306_18_H      0x130631
#define REG_BK1306_19_L      0x130632
#define REG_BK1306_19_H      0x130633
#define REG_BK1306_1A_L      0x130634
#define REG_BK1306_1A_H      0x130635
#define REG_BK1306_1B_L      0x130636
#define REG_BK1306_1B_H      0x130637
#define REG_BK1306_1C_L      0x130638
#define REG_BK1306_1C_H      0x130639
#define REG_BK1306_1D_L      0x13063A
#define REG_BK1306_1D_H      0x13063B
#define REG_BK1306_1E_L      0x13063C
#define REG_BK1306_1E_H      0x13063D
#define REG_BK1306_1F_L      0x13063E
#define REG_BK1306_1F_H      0x13063F
#define REG_BK1306_20_L      0x130640
#define REG_BK1306_20_H      0x130641
#define REG_BK1306_21_L      0x130642
#define REG_BK1306_21_H      0x130643
#define REG_BK1306_22_L      0x130644
#define REG_BK1306_22_H      0x130645
#define REG_BK1306_23_L      0x130646
#define REG_BK1306_23_H      0x130647
#define REG_BK1306_24_L      0x130648
#define REG_BK1306_24_H      0x130649
#define REG_BK1306_25_L      0x13064A
#define REG_BK1306_25_H      0x13064B
#define REG_BK1306_26_L      0x13064C
#define REG_BK1306_26_H      0x13064D
#define REG_BK1306_27_L      0x13064E
#define REG_BK1306_27_H      0x13064F
#define REG_BK1306_28_L      0x130650
#define REG_BK1306_28_H      0x130651
#define REG_BK1306_29_L      0x130652
#define REG_BK1306_29_H      0x130653
#define REG_BK1306_2A_L      0x130654
#define REG_BK1306_2A_H      0x130655
#define REG_BK1306_2B_L      0x130656
#define REG_BK1306_2B_H      0x130657
#define REG_BK1306_2C_L      0x130658
#define REG_BK1306_2C_H      0x130659
#define REG_BK1306_2D_L      0x13065A
#define REG_BK1306_2D_H      0x13065B
#define REG_BK1306_2E_L      0x13065C
#define REG_BK1306_2E_H      0x13065D
#define REG_BK1306_2F_L      0x13065E
#define REG_BK1306_2F_H      0x13065F
#define REG_BK1306_30_L      0x130660
#define REG_BK1306_30_H      0x130661
#define REG_BK1306_31_L      0x130662
#define REG_BK1306_31_H      0x130663
#define REG_BK1306_32_L      0x130664
#define REG_BK1306_32_H      0x130665
#define REG_BK1306_33_L      0x130666
#define REG_BK1306_33_H      0x130667
#define REG_BK1306_34_L      0x130668
#define REG_BK1306_34_H      0x130669
#define REG_BK1306_35_L      0x13066A
#define REG_BK1306_35_H      0x13066B
#define REG_BK1306_36_L      0x13066C
#define REG_BK1306_36_H      0x13066D
#define REG_BK1306_37_L      0x13066E
#define REG_BK1306_37_H      0x13066F
#define REG_BK1306_38_L      0x130670
#define REG_BK1306_38_H      0x130671
#define REG_BK1306_39_L      0x130672
#define REG_BK1306_39_H      0x130673
#define REG_BK1306_3A_L      0x130674
#define REG_BK1306_3A_H      0x130675
#define REG_BK1306_3B_L      0x130676
#define REG_BK1306_3B_H      0x130677
#define REG_BK1306_3C_L      0x130678
#define REG_BK1306_3C_H      0x130679
#define REG_BK1306_3D_L      0x13067A
#define REG_BK1306_3D_H      0x13067B
#define REG_BK1306_3E_L      0x13067C
#define REG_BK1306_3E_H      0x13067D
#define REG_BK1306_3F_L      0x13067E
#define REG_BK1306_3F_H      0x13067F
#define REG_BK1306_40_L      0x130680
#define REG_BK1306_40_H      0x130681
#define REG_BK1306_41_L      0x130682
#define REG_BK1306_41_H      0x130683
#define REG_BK1306_42_L      0x130684
#define REG_BK1306_42_H      0x130685
#define REG_BK1306_43_L      0x130686
#define REG_BK1306_43_H      0x130687
#define REG_BK1306_44_L      0x130688
#define REG_BK1306_44_H      0x130689
#define REG_BK1306_45_L      0x13068A
#define REG_BK1306_45_H      0x13068B
#define REG_BK1306_46_L      0x13068C
#define REG_BK1306_46_H      0x13068D
#define REG_BK1306_47_L      0x13068E
#define REG_BK1306_47_H      0x13068F
#define REG_BK1306_48_L      0x130690
#define REG_BK1306_48_H      0x130691
#define REG_BK1306_49_L      0x130692
#define REG_BK1306_49_H      0x130693
#define REG_BK1306_4A_L      0x130694
#define REG_BK1306_4A_H      0x130695
#define REG_BK1306_4B_L      0x130696
#define REG_BK1306_4B_H      0x130697
#define REG_BK1306_4C_L      0x130698
#define REG_BK1306_4C_H      0x130699
#define REG_BK1306_4D_L      0x13069A
#define REG_BK1306_4D_H      0x13069B
#define REG_BK1306_4E_L      0x13069C
#define REG_BK1306_4E_H      0x13069D
#define REG_BK1306_4F_L      0x13069E
#define REG_BK1306_4F_H      0x13069F
#define REG_BK1306_50_L      0x1306A0
#define REG_BK1306_50_H      0x1306A1
#define REG_BK1306_51_L      0x1306A2
#define REG_BK1306_51_H      0x1306A3
#define REG_BK1306_52_L      0x1306A4
#define REG_BK1306_52_H      0x1306A5
#define REG_BK1306_53_L      0x1306A6
#define REG_BK1306_53_H      0x1306A7
#define REG_BK1306_54_L      0x1306A8
#define REG_BK1306_54_H      0x1306A9
#define REG_BK1306_55_L      0x1306AA
#define REG_BK1306_55_H      0x1306AB
#define REG_BK1306_56_L      0x1306AC
#define REG_BK1306_56_H      0x1306AD
#define REG_BK1306_57_L      0x1306AE
#define REG_BK1306_57_H      0x1306AF
#define REG_BK1306_58_L      0x1306B0
#define REG_BK1306_58_H      0x1306B1
#define REG_BK1306_59_L      0x1306B2
#define REG_BK1306_59_H      0x1306B3
#define REG_BK1306_5A_L      0x1306B4
#define REG_BK1306_5A_H      0x1306B5
#define REG_BK1306_5B_L      0x1306B6
#define REG_BK1306_5B_H      0x1306B7
#define REG_BK1306_5C_L      0x1306B8
#define REG_BK1306_5C_H      0x1306B9
#define REG_BK1306_5D_L      0x1306BA
#define REG_BK1306_5D_H      0x1306BB
#define REG_BK1306_5E_L      0x1306BC
#define REG_BK1306_5E_H      0x1306BD
#define REG_BK1306_5F_L      0x1306BE
#define REG_BK1306_5F_H      0x1306BF
#define REG_BK1306_60_L      0x1306C0
#define REG_BK1306_60_H      0x1306C1
#define REG_BK1306_61_L      0x1306C2
#define REG_BK1306_61_H      0x1306C3
#define REG_BK1306_62_L      0x1306C4
#define REG_BK1306_62_H      0x1306C5
#define REG_BK1306_63_L      0x1306C6
#define REG_BK1306_63_H      0x1306C7
#define REG_BK1306_64_L      0x1306C8
#define REG_BK1306_64_H      0x1306C9
#define REG_BK1306_65_L      0x1306CA
#define REG_BK1306_65_H      0x1306CB
#define REG_BK1306_66_L      0x1306CC
#define REG_BK1306_66_H      0x1306CD
#define REG_BK1306_67_L      0x1306CE
#define REG_BK1306_67_H      0x1306CF
#define REG_BK1306_68_L      0x1306D0
#define REG_BK1306_68_H      0x1306D1
#define REG_BK1306_69_L      0x1306D2
#define REG_BK1306_69_H      0x1306D3
#define REG_BK1306_6A_L      0x1306D4
#define REG_BK1306_6A_H      0x1306D5
#define REG_BK1306_6B_L      0x1306D6
#define REG_BK1306_6B_H      0x1306D7
#define REG_BK1306_6C_L      0x1306D8
#define REG_BK1306_6C_H      0x1306D9
#define REG_BK1306_6D_L      0x1306DA
#define REG_BK1306_6D_H      0x1306DB
#define REG_BK1306_6E_L      0x1306DC
#define REG_BK1306_6E_H      0x1306DD
#define REG_BK1306_6F_L      0x1306DE
#define REG_BK1306_6F_H      0x1306DF
#define REG_BK1306_70_L      0x1306E0
#define REG_BK1306_70_H      0x1306E1
#define REG_BK1306_71_L      0x1306E2
#define REG_BK1306_71_H      0x1306E3
#define REG_BK1306_72_L      0x1306E4
#define REG_BK1306_72_H      0x1306E5
#define REG_BK1306_73_L      0x1306E6
#define REG_BK1306_73_H      0x1306E7
#define REG_BK1306_74_L      0x1306E8
#define REG_BK1306_74_H      0x1306E9
#define REG_BK1306_75_L      0x1306EA
#define REG_BK1306_75_H      0x1306EB
#define REG_BK1306_76_L      0x1306EC
#define REG_BK1306_76_H      0x1306ED
#define REG_BK1306_77_L      0x1306EE
#define REG_BK1306_77_H      0x1306EF
#define REG_BK1306_78_L      0x1306F0
#define REG_BK1306_78_H      0x1306F1
#define REG_BK1306_79_L      0x1306F2
#define REG_BK1306_79_H      0x1306F3
#define REG_BK1306_7A_L      0x1306F4
#define REG_BK1306_7A_H      0x1306F5
#define REG_BK1306_7B_L      0x1306F6
#define REG_BK1306_7B_H      0x1306F7
#define REG_BK1306_7C_L      0x1306F8
#define REG_BK1306_7C_H      0x1306F9
#define REG_BK1306_7D_L      0x1306FA
#define REG_BK1306_7D_H      0x1306FB
#define REG_BK1306_7E_L      0x1306FC
#define REG_BK1306_7E_H      0x1306FD
#define REG_BK1306_7F_L      0x1306FE
#define REG_BK1306_7F_H      0x1306FF
//----------------------------------------------
#define REG_BK1307_00_L      0x130700
#define REG_BK1307_00_H      0x130701
#define REG_BK1307_01_L      0x130702
#define REG_BK1307_01_H      0x130703
#define REG_BK1307_02_L      0x130704
#define REG_BK1307_02_H      0x130705
#define REG_BK1307_03_L      0x130706
#define REG_BK1307_03_H      0x130707
#define REG_BK1307_04_L      0x130708
#define REG_BK1307_04_H      0x130709
#define REG_BK1307_05_L      0x13070A
#define REG_BK1307_05_H      0x13070B
#define REG_BK1307_06_L      0x13070C
#define REG_BK1307_06_H      0x13070D
#define REG_BK1307_07_L      0x13070E
#define REG_BK1307_07_H      0x13070F
#define REG_BK1307_08_L      0x130710
#define REG_BK1307_08_H      0x130711
#define REG_BK1307_09_L      0x130712
#define REG_BK1307_09_H      0x130713
#define REG_BK1307_0A_L      0x130714
#define REG_BK1307_0A_H      0x130715
#define REG_BK1307_0B_L      0x130716
#define REG_BK1307_0B_H      0x130717
#define REG_BK1307_0C_L      0x130718
#define REG_BK1307_0C_H      0x130719
#define REG_BK1307_0D_L      0x13071A
#define REG_BK1307_0D_H      0x13071B
#define REG_BK1307_0E_L      0x13071C
#define REG_BK1307_0E_H      0x13071D
#define REG_BK1307_0F_L      0x13071E
#define REG_BK1307_0F_H      0x13071F
#define REG_BK1307_10_L      0x130720
#define REG_BK1307_10_H      0x130721
#define REG_BK1307_11_L      0x130722
#define REG_BK1307_11_H      0x130723
#define REG_BK1307_12_L      0x130724
#define REG_BK1307_12_H      0x130725
#define REG_BK1307_13_L      0x130726
#define REG_BK1307_13_H      0x130727
#define REG_BK1307_14_L      0x130728
#define REG_BK1307_14_H      0x130729
#define REG_BK1307_15_L      0x13072A
#define REG_BK1307_15_H      0x13072B
#define REG_BK1307_16_L      0x13072C
#define REG_BK1307_16_H      0x13072D
#define REG_BK1307_17_L      0x13072E
#define REG_BK1307_17_H      0x13072F
#define REG_BK1307_18_L      0x130730
#define REG_BK1307_18_H      0x130731
#define REG_BK1307_19_L      0x130732
#define REG_BK1307_19_H      0x130733
#define REG_BK1307_1A_L      0x130734
#define REG_BK1307_1A_H      0x130735
#define REG_BK1307_1B_L      0x130736
#define REG_BK1307_1B_H      0x130737
#define REG_BK1307_1C_L      0x130738
#define REG_BK1307_1C_H      0x130739
#define REG_BK1307_1D_L      0x13073A
#define REG_BK1307_1D_H      0x13073B
#define REG_BK1307_1E_L      0x13073C
#define REG_BK1307_1E_H      0x13073D
#define REG_BK1307_1F_L      0x13073E
#define REG_BK1307_1F_H      0x13073F
#define REG_BK1307_20_L      0x130740
#define REG_BK1307_20_H      0x130741
#define REG_BK1307_21_L      0x130742
#define REG_BK1307_21_H      0x130743
#define REG_BK1307_22_L      0x130744
#define REG_BK1307_22_H      0x130745
#define REG_BK1307_23_L      0x130746
#define REG_BK1307_23_H      0x130747
#define REG_BK1307_24_L      0x130748
#define REG_BK1307_24_H      0x130749
#define REG_BK1307_25_L      0x13074A
#define REG_BK1307_25_H      0x13074B
#define REG_BK1307_26_L      0x13074C
#define REG_BK1307_26_H      0x13074D
#define REG_BK1307_27_L      0x13074E
#define REG_BK1307_27_H      0x13074F
#define REG_BK1307_28_L      0x130750
#define REG_BK1307_28_H      0x130751
#define REG_BK1307_29_L      0x130752
#define REG_BK1307_29_H      0x130753
#define REG_BK1307_2A_L      0x130754
#define REG_BK1307_2A_H      0x130755
#define REG_BK1307_2B_L      0x130756
#define REG_BK1307_2B_H      0x130757
#define REG_BK1307_2C_L      0x130758
#define REG_BK1307_2C_H      0x130759
#define REG_BK1307_2D_L      0x13075A
#define REG_BK1307_2D_H      0x13075B
#define REG_BK1307_2E_L      0x13075C
#define REG_BK1307_2E_H      0x13075D
#define REG_BK1307_2F_L      0x13075E
#define REG_BK1307_2F_H      0x13075F
#define REG_BK1307_30_L      0x130760
#define REG_BK1307_30_H      0x130761
#define REG_BK1307_31_L      0x130762
#define REG_BK1307_31_H      0x130763
#define REG_BK1307_32_L      0x130764
#define REG_BK1307_32_H      0x130765
#define REG_BK1307_33_L      0x130766
#define REG_BK1307_33_H      0x130767
#define REG_BK1307_34_L      0x130768
#define REG_BK1307_34_H      0x130769
#define REG_BK1307_35_L      0x13076A
#define REG_BK1307_35_H      0x13076B
#define REG_BK1307_36_L      0x13076C
#define REG_BK1307_36_H      0x13076D
#define REG_BK1307_37_L      0x13076E
#define REG_BK1307_37_H      0x13076F
#define REG_BK1307_38_L      0x130770
#define REG_BK1307_38_H      0x130771
#define REG_BK1307_39_L      0x130772
#define REG_BK1307_39_H      0x130773
#define REG_BK1307_3A_L      0x130774
#define REG_BK1307_3A_H      0x130775
#define REG_BK1307_3B_L      0x130776
#define REG_BK1307_3B_H      0x130777
#define REG_BK1307_3C_L      0x130778
#define REG_BK1307_3C_H      0x130779
#define REG_BK1307_3D_L      0x13077A
#define REG_BK1307_3D_H      0x13077B
#define REG_BK1307_3E_L      0x13077C
#define REG_BK1307_3E_H      0x13077D
#define REG_BK1307_3F_L      0x13077E
#define REG_BK1307_3F_H      0x13077F
#define REG_BK1307_40_L      0x130780
#define REG_BK1307_40_H      0x130781
#define REG_BK1307_41_L      0x130782
#define REG_BK1307_41_H      0x130783
#define REG_BK1307_42_L      0x130784
#define REG_BK1307_42_H      0x130785
#define REG_BK1307_43_L      0x130786
#define REG_BK1307_43_H      0x130787
#define REG_BK1307_44_L      0x130788
#define REG_BK1307_44_H      0x130789
#define REG_BK1307_45_L      0x13078A
#define REG_BK1307_45_H      0x13078B
#define REG_BK1307_46_L      0x13078C
#define REG_BK1307_46_H      0x13078D
#define REG_BK1307_47_L      0x13078E
#define REG_BK1307_47_H      0x13078F
#define REG_BK1307_48_L      0x130790
#define REG_BK1307_48_H      0x130791
#define REG_BK1307_49_L      0x130792
#define REG_BK1307_49_H      0x130793
#define REG_BK1307_4A_L      0x130794
#define REG_BK1307_4A_H      0x130795
#define REG_BK1307_4B_L      0x130796
#define REG_BK1307_4B_H      0x130797
#define REG_BK1307_4C_L      0x130798
#define REG_BK1307_4C_H      0x130799
#define REG_BK1307_4D_L      0x13079A
#define REG_BK1307_4D_H      0x13079B
#define REG_BK1307_4E_L      0x13079C
#define REG_BK1307_4E_H      0x13079D
#define REG_BK1307_4F_L      0x13079E
#define REG_BK1307_4F_H      0x13079F
#define REG_BK1307_50_L      0x1307A0
#define REG_BK1307_50_H      0x1307A1
#define REG_BK1307_51_L      0x1307A2
#define REG_BK1307_51_H      0x1307A3
#define REG_BK1307_52_L      0x1307A4
#define REG_BK1307_52_H      0x1307A5
#define REG_BK1307_53_L      0x1307A6
#define REG_BK1307_53_H      0x1307A7
#define REG_BK1307_54_L      0x1307A8
#define REG_BK1307_54_H      0x1307A9
#define REG_BK1307_55_L      0x1307AA
#define REG_BK1307_55_H      0x1307AB
#define REG_BK1307_56_L      0x1307AC
#define REG_BK1307_56_H      0x1307AD
#define REG_BK1307_57_L      0x1307AE
#define REG_BK1307_57_H      0x1307AF
#define REG_BK1307_58_L      0x1307B0
#define REG_BK1307_58_H      0x1307B1
#define REG_BK1307_59_L      0x1307B2
#define REG_BK1307_59_H      0x1307B3
#define REG_BK1307_5A_L      0x1307B4
#define REG_BK1307_5A_H      0x1307B5
#define REG_BK1307_5B_L      0x1307B6
#define REG_BK1307_5B_H      0x1307B7
#define REG_BK1307_5C_L      0x1307B8
#define REG_BK1307_5C_H      0x1307B9
#define REG_BK1307_5D_L      0x1307BA
#define REG_BK1307_5D_H      0x1307BB
#define REG_BK1307_5E_L      0x1307BC
#define REG_BK1307_5E_H      0x1307BD
#define REG_BK1307_5F_L      0x1307BE
#define REG_BK1307_5F_H      0x1307BF
#define REG_BK1307_60_L      0x1307C0
#define REG_BK1307_60_H      0x1307C1
#define REG_BK1307_61_L      0x1307C2
#define REG_BK1307_61_H      0x1307C3
#define REG_BK1307_62_L      0x1307C4
#define REG_BK1307_62_H      0x1307C5
#define REG_BK1307_63_L      0x1307C6
#define REG_BK1307_63_H      0x1307C7
#define REG_BK1307_64_L      0x1307C8
#define REG_BK1307_64_H      0x1307C9
#define REG_BK1307_65_L      0x1307CA
#define REG_BK1307_65_H      0x1307CB
#define REG_BK1307_66_L      0x1307CC
#define REG_BK1307_66_H      0x1307CD
#define REG_BK1307_67_L      0x1307CE
#define REG_BK1307_67_H      0x1307CF
#define REG_BK1307_68_L      0x1307D0
#define REG_BK1307_68_H      0x1307D1
#define REG_BK1307_69_L      0x1307D2
#define REG_BK1307_69_H      0x1307D3
#define REG_BK1307_6A_L      0x1307D4
#define REG_BK1307_6A_H      0x1307D5
#define REG_BK1307_6B_L      0x1307D6
#define REG_BK1307_6B_H      0x1307D7
#define REG_BK1307_6C_L      0x1307D8
#define REG_BK1307_6C_H      0x1307D9
#define REG_BK1307_6D_L      0x1307DA
#define REG_BK1307_6D_H      0x1307DB
#define REG_BK1307_6E_L      0x1307DC
#define REG_BK1307_6E_H      0x1307DD
#define REG_BK1307_6F_L      0x1307DE
#define REG_BK1307_6F_H      0x1307DF
#define REG_BK1307_70_L      0x1307E0
#define REG_BK1307_70_H      0x1307E1
#define REG_BK1307_71_L      0x1307E2
#define REG_BK1307_71_H      0x1307E3
#define REG_BK1307_72_L      0x1307E4
#define REG_BK1307_72_H      0x1307E5
#define REG_BK1307_73_L      0x1307E6
#define REG_BK1307_73_H      0x1307E7
#define REG_BK1307_74_L      0x1307E8
#define REG_BK1307_74_H      0x1307E9
#define REG_BK1307_75_L      0x1307EA
#define REG_BK1307_75_H      0x1307EB
#define REG_BK1307_76_L      0x1307EC
#define REG_BK1307_76_H      0x1307ED
#define REG_BK1307_77_L      0x1307EE
#define REG_BK1307_77_H      0x1307EF
#define REG_BK1307_78_L      0x1307F0
#define REG_BK1307_78_H      0x1307F1
#define REG_BK1307_79_L      0x1307F2
#define REG_BK1307_79_H      0x1307F3
#define REG_BK1307_7A_L      0x1307F4
#define REG_BK1307_7A_H      0x1307F5
#define REG_BK1307_7B_L      0x1307F6
#define REG_BK1307_7B_H      0x1307F7
#define REG_BK1307_7C_L      0x1307F8
#define REG_BK1307_7C_H      0x1307F9
#define REG_BK1307_7D_L      0x1307FA
#define REG_BK1307_7D_H      0x1307FB
#define REG_BK1307_7E_L      0x1307FC
#define REG_BK1307_7E_H      0x1307FD
#define REG_BK1307_7F_L      0x1307FE
#define REG_BK1307_7F_H      0x1307FF
//----------------------------------------------
#define REG_BK1308_00_L      0x130800
#define REG_BK1308_00_H      0x130801
#define REG_BK1308_01_L      0x130802
#define REG_BK1308_01_H      0x130803
#define REG_BK1308_02_L      0x130804
#define REG_BK1308_02_H      0x130805
#define REG_BK1308_03_L      0x130806
#define REG_BK1308_03_H      0x130807
#define REG_BK1308_04_L      0x130808
#define REG_BK1308_04_H      0x130809
#define REG_BK1308_05_L      0x13080A
#define REG_BK1308_05_H      0x13080B
#define REG_BK1308_06_L      0x13080C
#define REG_BK1308_06_H      0x13080D
#define REG_BK1308_07_L      0x13080E
#define REG_BK1308_07_H      0x13080F
#define REG_BK1308_08_L      0x130810
#define REG_BK1308_08_H      0x130811
#define REG_BK1308_09_L      0x130812
#define REG_BK1308_09_H      0x130813
#define REG_BK1308_0A_L      0x130814
#define REG_BK1308_0A_H      0x130815
#define REG_BK1308_0B_L      0x130816
#define REG_BK1308_0B_H      0x130817
#define REG_BK1308_0C_L      0x130818
#define REG_BK1308_0C_H      0x130819
#define REG_BK1308_0D_L      0x13081A
#define REG_BK1308_0D_H      0x13081B
#define REG_BK1308_0E_L      0x13081C
#define REG_BK1308_0E_H      0x13081D
#define REG_BK1308_0F_L      0x13081E
#define REG_BK1308_0F_H      0x13081F
#define REG_BK1308_10_L      0x130820
#define REG_BK1308_10_H      0x130821
#define REG_BK1308_11_L      0x130822
#define REG_BK1308_11_H      0x130823
#define REG_BK1308_12_L      0x130824
#define REG_BK1308_12_H      0x130825
#define REG_BK1308_13_L      0x130826
#define REG_BK1308_13_H      0x130827
#define REG_BK1308_14_L      0x130828
#define REG_BK1308_14_H      0x130829
#define REG_BK1308_15_L      0x13082A
#define REG_BK1308_15_H      0x13082B
#define REG_BK1308_16_L      0x13082C
#define REG_BK1308_16_H      0x13082D
#define REG_BK1308_17_L      0x13082E
#define REG_BK1308_17_H      0x13082F
#define REG_BK1308_18_L      0x130830
#define REG_BK1308_18_H      0x130831
#define REG_BK1308_19_L      0x130832
#define REG_BK1308_19_H      0x130833
#define REG_BK1308_1A_L      0x130834
#define REG_BK1308_1A_H      0x130835
#define REG_BK1308_1B_L      0x130836
#define REG_BK1308_1B_H      0x130837
#define REG_BK1308_1C_L      0x130838
#define REG_BK1308_1C_H      0x130839
#define REG_BK1308_1D_L      0x13083A
#define REG_BK1308_1D_H      0x13083B
#define REG_BK1308_1E_L      0x13083C
#define REG_BK1308_1E_H      0x13083D
#define REG_BK1308_1F_L      0x13083E
#define REG_BK1308_1F_H      0x13083F
#define REG_BK1308_20_L      0x130840
#define REG_BK1308_20_H      0x130841
#define REG_BK1308_21_L      0x130842
#define REG_BK1308_21_H      0x130843
#define REG_BK1308_22_L      0x130844
#define REG_BK1308_22_H      0x130845
#define REG_BK1308_23_L      0x130846
#define REG_BK1308_23_H      0x130847
#define REG_BK1308_24_L      0x130848
#define REG_BK1308_24_H      0x130849
#define REG_BK1308_25_L      0x13084A
#define REG_BK1308_25_H      0x13084B
#define REG_BK1308_26_L      0x13084C
#define REG_BK1308_26_H      0x13084D
#define REG_BK1308_27_L      0x13084E
#define REG_BK1308_27_H      0x13084F
#define REG_BK1308_28_L      0x130850
#define REG_BK1308_28_H      0x130851
#define REG_BK1308_29_L      0x130852
#define REG_BK1308_29_H      0x130853
#define REG_BK1308_2A_L      0x130854
#define REG_BK1308_2A_H      0x130855
#define REG_BK1308_2B_L      0x130856
#define REG_BK1308_2B_H      0x130857
#define REG_BK1308_2C_L      0x130858
#define REG_BK1308_2C_H      0x130859
#define REG_BK1308_2D_L      0x13085A
#define REG_BK1308_2D_H      0x13085B
#define REG_BK1308_2E_L      0x13085C
#define REG_BK1308_2E_H      0x13085D
#define REG_BK1308_2F_L      0x13085E
#define REG_BK1308_2F_H      0x13085F
#define REG_BK1308_30_L      0x130860
#define REG_BK1308_30_H      0x130861
#define REG_BK1308_31_L      0x130862
#define REG_BK1308_31_H      0x130863
#define REG_BK1308_32_L      0x130864
#define REG_BK1308_32_H      0x130865
#define REG_BK1308_33_L      0x130866
#define REG_BK1308_33_H      0x130867
#define REG_BK1308_34_L      0x130868
#define REG_BK1308_34_H      0x130869
#define REG_BK1308_35_L      0x13086A
#define REG_BK1308_35_H      0x13086B
#define REG_BK1308_36_L      0x13086C
#define REG_BK1308_36_H      0x13086D
#define REG_BK1308_37_L      0x13086E
#define REG_BK1308_37_H      0x13086F
#define REG_BK1308_38_L      0x130870
#define REG_BK1308_38_H      0x130871
#define REG_BK1308_39_L      0x130872
#define REG_BK1308_39_H      0x130873
#define REG_BK1308_3A_L      0x130874
#define REG_BK1308_3A_H      0x130875
#define REG_BK1308_3B_L      0x130876
#define REG_BK1308_3B_H      0x130877
#define REG_BK1308_3C_L      0x130878
#define REG_BK1308_3C_H      0x130879
#define REG_BK1308_3D_L      0x13087A
#define REG_BK1308_3D_H      0x13087B
#define REG_BK1308_3E_L      0x13087C
#define REG_BK1308_3E_H      0x13087D
#define REG_BK1308_3F_L      0x13087E
#define REG_BK1308_3F_H      0x13087F
#define REG_BK1308_40_L      0x130880
#define REG_BK1308_40_H      0x130881
#define REG_BK1308_41_L      0x130882
#define REG_BK1308_41_H      0x130883
#define REG_BK1308_42_L      0x130884
#define REG_BK1308_42_H      0x130885
#define REG_BK1308_43_L      0x130886
#define REG_BK1308_43_H      0x130887
#define REG_BK1308_44_L      0x130888
#define REG_BK1308_44_H      0x130889
#define REG_BK1308_45_L      0x13088A
#define REG_BK1308_45_H      0x13088B
#define REG_BK1308_46_L      0x13088C
#define REG_BK1308_46_H      0x13088D
#define REG_BK1308_47_L      0x13088E
#define REG_BK1308_47_H      0x13088F
#define REG_BK1308_48_L      0x130890
#define REG_BK1308_48_H      0x130891
#define REG_BK1308_49_L      0x130892
#define REG_BK1308_49_H      0x130893
#define REG_BK1308_4A_L      0x130894
#define REG_BK1308_4A_H      0x130895
#define REG_BK1308_4B_L      0x130896
#define REG_BK1308_4B_H      0x130897
#define REG_BK1308_4C_L      0x130898
#define REG_BK1308_4C_H      0x130899
#define REG_BK1308_4D_L      0x13089A
#define REG_BK1308_4D_H      0x13089B
#define REG_BK1308_4E_L      0x13089C
#define REG_BK1308_4E_H      0x13089D
#define REG_BK1308_4F_L      0x13089E
#define REG_BK1308_4F_H      0x13089F
#define REG_BK1308_50_L      0x1308A0
#define REG_BK1308_50_H      0x1308A1
#define REG_BK1308_51_L      0x1308A2
#define REG_BK1308_51_H      0x1308A3
#define REG_BK1308_52_L      0x1308A4
#define REG_BK1308_52_H      0x1308A5
#define REG_BK1308_53_L      0x1308A6
#define REG_BK1308_53_H      0x1308A7
#define REG_BK1308_54_L      0x1308A8
#define REG_BK1308_54_H      0x1308A9
#define REG_BK1308_55_L      0x1308AA
#define REG_BK1308_55_H      0x1308AB
#define REG_BK1308_56_L      0x1308AC
#define REG_BK1308_56_H      0x1308AD
#define REG_BK1308_57_L      0x1308AE
#define REG_BK1308_57_H      0x1308AF
#define REG_BK1308_58_L      0x1308B0
#define REG_BK1308_58_H      0x1308B1
#define REG_BK1308_59_L      0x1308B2
#define REG_BK1308_59_H      0x1308B3
#define REG_BK1308_5A_L      0x1308B4
#define REG_BK1308_5A_H      0x1308B5
#define REG_BK1308_5B_L      0x1308B6
#define REG_BK1308_5B_H      0x1308B7
#define REG_BK1308_5C_L      0x1308B8
#define REG_BK1308_5C_H      0x1308B9
#define REG_BK1308_5D_L      0x1308BA
#define REG_BK1308_5D_H      0x1308BB
#define REG_BK1308_5E_L      0x1308BC
#define REG_BK1308_5E_H      0x1308BD
#define REG_BK1308_5F_L      0x1308BE
#define REG_BK1308_5F_H      0x1308BF
#define REG_BK1308_60_L      0x1308C0
#define REG_BK1308_60_H      0x1308C1
#define REG_BK1308_61_L      0x1308C2
#define REG_BK1308_61_H      0x1308C3
#define REG_BK1308_62_L      0x1308C4
#define REG_BK1308_62_H      0x1308C5
#define REG_BK1308_63_L      0x1308C6
#define REG_BK1308_63_H      0x1308C7
#define REG_BK1308_64_L      0x1308C8
#define REG_BK1308_64_H      0x1308C9
#define REG_BK1308_65_L      0x1308CA
#define REG_BK1308_65_H      0x1308CB
#define REG_BK1308_66_L      0x1308CC
#define REG_BK1308_66_H      0x1308CD
#define REG_BK1308_67_L      0x1308CE
#define REG_BK1308_67_H      0x1308CF
#define REG_BK1308_68_L      0x1308D0
#define REG_BK1308_68_H      0x1308D1
#define REG_BK1308_69_L      0x1308D2
#define REG_BK1308_69_H      0x1308D3
#define REG_BK1308_6A_L      0x1308D4
#define REG_BK1308_6A_H      0x1308D5
#define REG_BK1308_6B_L      0x1308D6
#define REG_BK1308_6B_H      0x1308D7
#define REG_BK1308_6C_L      0x1308D8
#define REG_BK1308_6C_H      0x1308D9
#define REG_BK1308_6D_L      0x1308DA
#define REG_BK1308_6D_H      0x1308DB
#define REG_BK1308_6E_L      0x1308DC
#define REG_BK1308_6E_H      0x1308DD
#define REG_BK1308_6F_L      0x1308DE
#define REG_BK1308_6F_H      0x1308DF
#define REG_BK1308_70_L      0x1308E0
#define REG_BK1308_70_H      0x1308E1
#define REG_BK1308_71_L      0x1308E2
#define REG_BK1308_71_H      0x1308E3
#define REG_BK1308_72_L      0x1308E4
#define REG_BK1308_72_H      0x1308E5
#define REG_BK1308_73_L      0x1308E6
#define REG_BK1308_73_H      0x1308E7
#define REG_BK1308_74_L      0x1308E8
#define REG_BK1308_74_H      0x1308E9
#define REG_BK1308_75_L      0x1308EA
#define REG_BK1308_75_H      0x1308EB
#define REG_BK1308_76_L      0x1308EC
#define REG_BK1308_76_H      0x1308ED
#define REG_BK1308_77_L      0x1308EE
#define REG_BK1308_77_H      0x1308EF
#define REG_BK1308_78_L      0x1308F0
#define REG_BK1308_78_H      0x1308F1
#define REG_BK1308_79_L      0x1308F2
#define REG_BK1308_79_H      0x1308F3
#define REG_BK1308_7A_L      0x1308F4
#define REG_BK1308_7A_H      0x1308F5
#define REG_BK1308_7B_L      0x1308F6
#define REG_BK1308_7B_H      0x1308F7
#define REG_BK1308_7C_L      0x1308F8
#define REG_BK1308_7C_H      0x1308F9
#define REG_BK1308_7D_L      0x1308FA
#define REG_BK1308_7D_H      0x1308FB
#define REG_BK1308_7E_L      0x1308FC
#define REG_BK1308_7E_H      0x1308FD
#define REG_BK1308_7F_L      0x1308FE
#define REG_BK1308_7F_H      0x1308FF
//----------------------------------------------
#define REG_BK1309_00_L      0x130900
#define REG_BK1309_00_H      0x130901
#define REG_BK1309_01_L      0x130902
#define REG_BK1309_01_H      0x130903
#define REG_BK1309_02_L      0x130904
#define REG_BK1309_02_H      0x130905
#define REG_BK1309_03_L      0x130906
#define REG_BK1309_03_H      0x130907
#define REG_BK1309_04_L      0x130908
#define REG_BK1309_04_H      0x130909
#define REG_BK1309_05_L      0x13090A
#define REG_BK1309_05_H      0x13090B
#define REG_BK1309_06_L      0x13090C
#define REG_BK1309_06_H      0x13090D
#define REG_BK1309_07_L      0x13090E
#define REG_BK1309_07_H      0x13090F
#define REG_BK1309_08_L      0x130910
#define REG_BK1309_08_H      0x130911
#define REG_BK1309_09_L      0x130912
#define REG_BK1309_09_H      0x130913
#define REG_BK1309_0A_L      0x130914
#define REG_BK1309_0A_H      0x130915
#define REG_BK1309_0B_L      0x130916
#define REG_BK1309_0B_H      0x130917
#define REG_BK1309_0C_L      0x130918
#define REG_BK1309_0C_H      0x130919
#define REG_BK1309_0D_L      0x13091A
#define REG_BK1309_0D_H      0x13091B
#define REG_BK1309_0E_L      0x13091C
#define REG_BK1309_0E_H      0x13091D
#define REG_BK1309_0F_L      0x13091E
#define REG_BK1309_0F_H      0x13091F
#define REG_BK1309_10_L      0x130920
#define REG_BK1309_10_H      0x130921
#define REG_BK1309_11_L      0x130922
#define REG_BK1309_11_H      0x130923
#define REG_BK1309_12_L      0x130924
#define REG_BK1309_12_H      0x130925
#define REG_BK1309_13_L      0x130926
#define REG_BK1309_13_H      0x130927
#define REG_BK1309_14_L      0x130928
#define REG_BK1309_14_H      0x130929
#define REG_BK1309_15_L      0x13092A
#define REG_BK1309_15_H      0x13092B
#define REG_BK1309_16_L      0x13092C
#define REG_BK1309_16_H      0x13092D
#define REG_BK1309_17_L      0x13092E
#define REG_BK1309_17_H      0x13092F
#define REG_BK1309_18_L      0x130930
#define REG_BK1309_18_H      0x130931
#define REG_BK1309_19_L      0x130932
#define REG_BK1309_19_H      0x130933
#define REG_BK1309_1A_L      0x130934
#define REG_BK1309_1A_H      0x130935
#define REG_BK1309_1B_L      0x130936
#define REG_BK1309_1B_H      0x130937
#define REG_BK1309_1C_L      0x130938
#define REG_BK1309_1C_H      0x130939
#define REG_BK1309_1D_L      0x13093A
#define REG_BK1309_1D_H      0x13093B
#define REG_BK1309_1E_L      0x13093C
#define REG_BK1309_1E_H      0x13093D
#define REG_BK1309_1F_L      0x13093E
#define REG_BK1309_1F_H      0x13093F
#define REG_BK1309_20_L      0x130940
#define REG_BK1309_20_H      0x130941
#define REG_BK1309_21_L      0x130942
#define REG_BK1309_21_H      0x130943
#define REG_BK1309_22_L      0x130944
#define REG_BK1309_22_H      0x130945
#define REG_BK1309_23_L      0x130946
#define REG_BK1309_23_H      0x130947
#define REG_BK1309_24_L      0x130948
#define REG_BK1309_24_H      0x130949
#define REG_BK1309_25_L      0x13094A
#define REG_BK1309_25_H      0x13094B
#define REG_BK1309_26_L      0x13094C
#define REG_BK1309_26_H      0x13094D
#define REG_BK1309_27_L      0x13094E
#define REG_BK1309_27_H      0x13094F
#define REG_BK1309_28_L      0x130950
#define REG_BK1309_28_H      0x130951
#define REG_BK1309_29_L      0x130952
#define REG_BK1309_29_H      0x130953
#define REG_BK1309_2A_L      0x130954
#define REG_BK1309_2A_H      0x130955
#define REG_BK1309_2B_L      0x130956
#define REG_BK1309_2B_H      0x130957
#define REG_BK1309_2C_L      0x130958
#define REG_BK1309_2C_H      0x130959
#define REG_BK1309_2D_L      0x13095A
#define REG_BK1309_2D_H      0x13095B
#define REG_BK1309_2E_L      0x13095C
#define REG_BK1309_2E_H      0x13095D
#define REG_BK1309_2F_L      0x13095E
#define REG_BK1309_2F_H      0x13095F
#define REG_BK1309_30_L      0x130960
#define REG_BK1309_30_H      0x130961
#define REG_BK1309_31_L      0x130962
#define REG_BK1309_31_H      0x130963
#define REG_BK1309_32_L      0x130964
#define REG_BK1309_32_H      0x130965
#define REG_BK1309_33_L      0x130966
#define REG_BK1309_33_H      0x130967
#define REG_BK1309_34_L      0x130968
#define REG_BK1309_34_H      0x130969
#define REG_BK1309_35_L      0x13096A
#define REG_BK1309_35_H      0x13096B
#define REG_BK1309_36_L      0x13096C
#define REG_BK1309_36_H      0x13096D
#define REG_BK1309_37_L      0x13096E
#define REG_BK1309_37_H      0x13096F
#define REG_BK1309_38_L      0x130970
#define REG_BK1309_38_H      0x130971
#define REG_BK1309_39_L      0x130972
#define REG_BK1309_39_H      0x130973
#define REG_BK1309_3A_L      0x130974
#define REG_BK1309_3A_H      0x130975
#define REG_BK1309_3B_L      0x130976
#define REG_BK1309_3B_H      0x130977
#define REG_BK1309_3C_L      0x130978
#define REG_BK1309_3C_H      0x130979
#define REG_BK1309_3D_L      0x13097A
#define REG_BK1309_3D_H      0x13097B
#define REG_BK1309_3E_L      0x13097C
#define REG_BK1309_3E_H      0x13097D
#define REG_BK1309_3F_L      0x13097E
#define REG_BK1309_3F_H      0x13097F
#define REG_BK1309_40_L      0x130980
#define REG_BK1309_40_H      0x130981
#define REG_BK1309_41_L      0x130982
#define REG_BK1309_41_H      0x130983
#define REG_BK1309_42_L      0x130984
#define REG_BK1309_42_H      0x130985
#define REG_BK1309_43_L      0x130986
#define REG_BK1309_43_H      0x130987
#define REG_BK1309_44_L      0x130988
#define REG_BK1309_44_H      0x130989
#define REG_BK1309_45_L      0x13098A
#define REG_BK1309_45_H      0x13098B
#define REG_BK1309_46_L      0x13098C
#define REG_BK1309_46_H      0x13098D
#define REG_BK1309_47_L      0x13098E
#define REG_BK1309_47_H      0x13098F
#define REG_BK1309_48_L      0x130990
#define REG_BK1309_48_H      0x130991
#define REG_BK1309_49_L      0x130992
#define REG_BK1309_49_H      0x130993
#define REG_BK1309_4A_L      0x130994
#define REG_BK1309_4A_H      0x130995
#define REG_BK1309_4B_L      0x130996
#define REG_BK1309_4B_H      0x130997
#define REG_BK1309_4C_L      0x130998
#define REG_BK1309_4C_H      0x130999
#define REG_BK1309_4D_L      0x13099A
#define REG_BK1309_4D_H      0x13099B
#define REG_BK1309_4E_L      0x13099C
#define REG_BK1309_4E_H      0x13099D
#define REG_BK1309_4F_L      0x13099E
#define REG_BK1309_4F_H      0x13099F
#define REG_BK1309_50_L      0x1309A0
#define REG_BK1309_50_H      0x1309A1
#define REG_BK1309_51_L      0x1309A2
#define REG_BK1309_51_H      0x1309A3
#define REG_BK1309_52_L      0x1309A4
#define REG_BK1309_52_H      0x1309A5
#define REG_BK1309_53_L      0x1309A6
#define REG_BK1309_53_H      0x1309A7
#define REG_BK1309_54_L      0x1309A8
#define REG_BK1309_54_H      0x1309A9
#define REG_BK1309_55_L      0x1309AA
#define REG_BK1309_55_H      0x1309AB
#define REG_BK1309_56_L      0x1309AC
#define REG_BK1309_56_H      0x1309AD
#define REG_BK1309_57_L      0x1309AE
#define REG_BK1309_57_H      0x1309AF
#define REG_BK1309_58_L      0x1309B0
#define REG_BK1309_58_H      0x1309B1
#define REG_BK1309_59_L      0x1309B2
#define REG_BK1309_59_H      0x1309B3
#define REG_BK1309_5A_L      0x1309B4
#define REG_BK1309_5A_H      0x1309B5
#define REG_BK1309_5B_L      0x1309B6
#define REG_BK1309_5B_H      0x1309B7
#define REG_BK1309_5C_L      0x1309B8
#define REG_BK1309_5C_H      0x1309B9
#define REG_BK1309_5D_L      0x1309BA
#define REG_BK1309_5D_H      0x1309BB
#define REG_BK1309_5E_L      0x1309BC
#define REG_BK1309_5E_H      0x1309BD
#define REG_BK1309_5F_L      0x1309BE
#define REG_BK1309_5F_H      0x1309BF
#define REG_BK1309_60_L      0x1309C0
#define REG_BK1309_60_H      0x1309C1
#define REG_BK1309_61_L      0x1309C2
#define REG_BK1309_61_H      0x1309C3
#define REG_BK1309_62_L      0x1309C4
#define REG_BK1309_62_H      0x1309C5
#define REG_BK1309_63_L      0x1309C6
#define REG_BK1309_63_H      0x1309C7
#define REG_BK1309_64_L      0x1309C8
#define REG_BK1309_64_H      0x1309C9
#define REG_BK1309_65_L      0x1309CA
#define REG_BK1309_65_H      0x1309CB
#define REG_BK1309_66_L      0x1309CC
#define REG_BK1309_66_H      0x1309CD
#define REG_BK1309_67_L      0x1309CE
#define REG_BK1309_67_H      0x1309CF
#define REG_BK1309_68_L      0x1309D0
#define REG_BK1309_68_H      0x1309D1
#define REG_BK1309_69_L      0x1309D2
#define REG_BK1309_69_H      0x1309D3
#define REG_BK1309_6A_L      0x1309D4
#define REG_BK1309_6A_H      0x1309D5
#define REG_BK1309_6B_L      0x1309D6
#define REG_BK1309_6B_H      0x1309D7
#define REG_BK1309_6C_L      0x1309D8
#define REG_BK1309_6C_H      0x1309D9
#define REG_BK1309_6D_L      0x1309DA
#define REG_BK1309_6D_H      0x1309DB
#define REG_BK1309_6E_L      0x1309DC
#define REG_BK1309_6E_H      0x1309DD
#define REG_BK1309_6F_L      0x1309DE
#define REG_BK1309_6F_H      0x1309DF
#define REG_BK1309_70_L      0x1309E0
#define REG_BK1309_70_H      0x1309E1
#define REG_BK1309_71_L      0x1309E2
#define REG_BK1309_71_H      0x1309E3
#define REG_BK1309_72_L      0x1309E4
#define REG_BK1309_72_H      0x1309E5
#define REG_BK1309_73_L      0x1309E6
#define REG_BK1309_73_H      0x1309E7
#define REG_BK1309_74_L      0x1309E8
#define REG_BK1309_74_H      0x1309E9
#define REG_BK1309_75_L      0x1309EA
#define REG_BK1309_75_H      0x1309EB
#define REG_BK1309_76_L      0x1309EC
#define REG_BK1309_76_H      0x1309ED
#define REG_BK1309_77_L      0x1309EE
#define REG_BK1309_77_H      0x1309EF
#define REG_BK1309_78_L      0x1309F0
#define REG_BK1309_78_H      0x1309F1
#define REG_BK1309_79_L      0x1309F2
#define REG_BK1309_79_H      0x1309F3
#define REG_BK1309_7A_L      0x1309F4
#define REG_BK1309_7A_H      0x1309F5
#define REG_BK1309_7B_L      0x1309F6
#define REG_BK1309_7B_H      0x1309F7
#define REG_BK1309_7C_L      0x1309F8
#define REG_BK1309_7C_H      0x1309F9
#define REG_BK1309_7D_L      0x1309FA
#define REG_BK1309_7D_H      0x1309FB
#define REG_BK1309_7E_L      0x1309FC
#define REG_BK1309_7E_H      0x1309FD
#define REG_BK1309_7F_L      0x1309FE
#define REG_BK1309_7F_H      0x1309FF
//----------------------------------------------
#define REG_BK130A_00_L      0x130A00
#define REG_BK130A_00_H      0x130A01
#define REG_BK130A_01_L      0x130A02
#define REG_BK130A_01_H      0x130A03
#define REG_BK130A_02_L      0x130A04
#define REG_BK130A_02_H      0x130A05
#define REG_BK130A_03_L      0x130A06
#define REG_BK130A_03_H      0x130A07
#define REG_BK130A_04_L      0x130A08
#define REG_BK130A_04_H      0x130A09
#define REG_BK130A_05_L      0x130A0A
#define REG_BK130A_05_H      0x130A0B
#define REG_BK130A_06_L      0x130A0C
#define REG_BK130A_06_H      0x130A0D
#define REG_BK130A_07_L      0x130A0E
#define REG_BK130A_07_H      0x130A0F
#define REG_BK130A_08_L      0x130A10
#define REG_BK130A_08_H      0x130A11
#define REG_BK130A_09_L      0x130A12
#define REG_BK130A_09_H      0x130A13
#define REG_BK130A_0A_L      0x130A14
#define REG_BK130A_0A_H      0x130A15
#define REG_BK130A_0B_L      0x130A16
#define REG_BK130A_0B_H      0x130A17
#define REG_BK130A_0C_L      0x130A18
#define REG_BK130A_0C_H      0x130A19
#define REG_BK130A_0D_L      0x130A1A
#define REG_BK130A_0D_H      0x130A1B
#define REG_BK130A_0E_L      0x130A1C
#define REG_BK130A_0E_H      0x130A1D
#define REG_BK130A_0F_L      0x130A1E
#define REG_BK130A_0F_H      0x130A1F
#define REG_BK130A_10_L      0x130A20
#define REG_BK130A_10_H      0x130A21
#define REG_BK130A_11_L      0x130A22
#define REG_BK130A_11_H      0x130A23
#define REG_BK130A_12_L      0x130A24
#define REG_BK130A_12_H      0x130A25
#define REG_BK130A_13_L      0x130A26
#define REG_BK130A_13_H      0x130A27
#define REG_BK130A_14_L      0x130A28
#define REG_BK130A_14_H      0x130A29
#define REG_BK130A_15_L      0x130A2A
#define REG_BK130A_15_H      0x130A2B
#define REG_BK130A_16_L      0x130A2C
#define REG_BK130A_16_H      0x130A2D
#define REG_BK130A_17_L      0x130A2E
#define REG_BK130A_17_H      0x130A2F
#define REG_BK130A_18_L      0x130A30
#define REG_BK130A_18_H      0x130A31
#define REG_BK130A_19_L      0x130A32
#define REG_BK130A_19_H      0x130A33
#define REG_BK130A_1A_L      0x130A34
#define REG_BK130A_1A_H      0x130A35
#define REG_BK130A_1B_L      0x130A36
#define REG_BK130A_1B_H      0x130A37
#define REG_BK130A_1C_L      0x130A38
#define REG_BK130A_1C_H      0x130A39
#define REG_BK130A_1D_L      0x130A3A
#define REG_BK130A_1D_H      0x130A3B
#define REG_BK130A_1E_L      0x130A3C
#define REG_BK130A_1E_H      0x130A3D
#define REG_BK130A_1F_L      0x130A3E
#define REG_BK130A_1F_H      0x130A3F
#define REG_BK130A_20_L      0x130A40
#define REG_BK130A_20_H      0x130A41
#define REG_BK130A_21_L      0x130A42
#define REG_BK130A_21_H      0x130A43
#define REG_BK130A_22_L      0x130A44
#define REG_BK130A_22_H      0x130A45
#define REG_BK130A_23_L      0x130A46
#define REG_BK130A_23_H      0x130A47
#define REG_BK130A_24_L      0x130A48
#define REG_BK130A_24_H      0x130A49
#define REG_BK130A_25_L      0x130A4A
#define REG_BK130A_25_H      0x130A4B
#define REG_BK130A_26_L      0x130A4C
#define REG_BK130A_26_H      0x130A4D
#define REG_BK130A_27_L      0x130A4E
#define REG_BK130A_27_H      0x130A4F
#define REG_BK130A_28_L      0x130A50
#define REG_BK130A_28_H      0x130A51
#define REG_BK130A_29_L      0x130A52
#define REG_BK130A_29_H      0x130A53
#define REG_BK130A_2A_L      0x130A54
#define REG_BK130A_2A_H      0x130A55
#define REG_BK130A_2B_L      0x130A56
#define REG_BK130A_2B_H      0x130A57
#define REG_BK130A_2C_L      0x130A58
#define REG_BK130A_2C_H      0x130A59
#define REG_BK130A_2D_L      0x130A5A
#define REG_BK130A_2D_H      0x130A5B
#define REG_BK130A_2E_L      0x130A5C
#define REG_BK130A_2E_H      0x130A5D
#define REG_BK130A_2F_L      0x130A5E
#define REG_BK130A_2F_H      0x130A5F
#define REG_BK130A_30_L      0x130A60
#define REG_BK130A_30_H      0x130A61
#define REG_BK130A_31_L      0x130A62
#define REG_BK130A_31_H      0x130A63
#define REG_BK130A_32_L      0x130A64
#define REG_BK130A_32_H      0x130A65
#define REG_BK130A_33_L      0x130A66
#define REG_BK130A_33_H      0x130A67
#define REG_BK130A_34_L      0x130A68
#define REG_BK130A_34_H      0x130A69
#define REG_BK130A_35_L      0x130A6A
#define REG_BK130A_35_H      0x130A6B
#define REG_BK130A_36_L      0x130A6C
#define REG_BK130A_36_H      0x130A6D
#define REG_BK130A_37_L      0x130A6E
#define REG_BK130A_37_H      0x130A6F
#define REG_BK130A_38_L      0x130A70
#define REG_BK130A_38_H      0x130A71
#define REG_BK130A_39_L      0x130A72
#define REG_BK130A_39_H      0x130A73
#define REG_BK130A_3A_L      0x130A74
#define REG_BK130A_3A_H      0x130A75
#define REG_BK130A_3B_L      0x130A76
#define REG_BK130A_3B_H      0x130A77
#define REG_BK130A_3C_L      0x130A78
#define REG_BK130A_3C_H      0x130A79
#define REG_BK130A_3D_L      0x130A7A
#define REG_BK130A_3D_H      0x130A7B
#define REG_BK130A_3E_L      0x130A7C
#define REG_BK130A_3E_H      0x130A7D
#define REG_BK130A_3F_L      0x130A7E
#define REG_BK130A_3F_H      0x130A7F
#define REG_BK130A_40_L      0x130A80
#define REG_BK130A_40_H      0x130A81
#define REG_BK130A_41_L      0x130A82
#define REG_BK130A_41_H      0x130A83
#define REG_BK130A_42_L      0x130A84
#define REG_BK130A_42_H      0x130A85
#define REG_BK130A_43_L      0x130A86
#define REG_BK130A_43_H      0x130A87
#define REG_BK130A_44_L      0x130A88
#define REG_BK130A_44_H      0x130A89
#define REG_BK130A_45_L      0x130A8A
#define REG_BK130A_45_H      0x130A8B
#define REG_BK130A_46_L      0x130A8C
#define REG_BK130A_46_H      0x130A8D
#define REG_BK130A_47_L      0x130A8E
#define REG_BK130A_47_H      0x130A8F
#define REG_BK130A_48_L      0x130A90
#define REG_BK130A_48_H      0x130A91
#define REG_BK130A_49_L      0x130A92
#define REG_BK130A_49_H      0x130A93
#define REG_BK130A_4A_L      0x130A94
#define REG_BK130A_4A_H      0x130A95
#define REG_BK130A_4B_L      0x130A96
#define REG_BK130A_4B_H      0x130A97
#define REG_BK130A_4C_L      0x130A98
#define REG_BK130A_4C_H      0x130A99
#define REG_BK130A_4D_L      0x130A9A
#define REG_BK130A_4D_H      0x130A9B
#define REG_BK130A_4E_L      0x130A9C
#define REG_BK130A_4E_H      0x130A9D
#define REG_BK130A_4F_L      0x130A9E
#define REG_BK130A_4F_H      0x130A9F
#define REG_BK130A_50_L      0x130AA0
#define REG_BK130A_50_H      0x130AA1
#define REG_BK130A_51_L      0x130AA2
#define REG_BK130A_51_H      0x130AA3
#define REG_BK130A_52_L      0x130AA4
#define REG_BK130A_52_H      0x130AA5
#define REG_BK130A_53_L      0x130AA6
#define REG_BK130A_53_H      0x130AA7
#define REG_BK130A_54_L      0x130AA8
#define REG_BK130A_54_H      0x130AA9
#define REG_BK130A_55_L      0x130AAA
#define REG_BK130A_55_H      0x130AAB
#define REG_BK130A_56_L      0x130AAC
#define REG_BK130A_56_H      0x130AAD
#define REG_BK130A_57_L      0x130AAE
#define REG_BK130A_57_H      0x130AAF
#define REG_BK130A_58_L      0x130AB0
#define REG_BK130A_58_H      0x130AB1
#define REG_BK130A_59_L      0x130AB2
#define REG_BK130A_59_H      0x130AB3
#define REG_BK130A_5A_L      0x130AB4
#define REG_BK130A_5A_H      0x130AB5
#define REG_BK130A_5B_L      0x130AB6
#define REG_BK130A_5B_H      0x130AB7
#define REG_BK130A_5C_L      0x130AB8
#define REG_BK130A_5C_H      0x130AB9
#define REG_BK130A_5D_L      0x130ABA
#define REG_BK130A_5D_H      0x130ABB
#define REG_BK130A_5E_L      0x130ABC
#define REG_BK130A_5E_H      0x130ABD
#define REG_BK130A_5F_L      0x130ABE
#define REG_BK130A_5F_H      0x130ABF
#define REG_BK130A_60_L      0x130AC0
#define REG_BK130A_60_H      0x130AC1
#define REG_BK130A_61_L      0x130AC2
#define REG_BK130A_61_H      0x130AC3
#define REG_BK130A_62_L      0x130AC4
#define REG_BK130A_62_H      0x130AC5
#define REG_BK130A_63_L      0x130AC6
#define REG_BK130A_63_H      0x130AC7
#define REG_BK130A_64_L      0x130AC8
#define REG_BK130A_64_H      0x130AC9
#define REG_BK130A_65_L      0x130ACA
#define REG_BK130A_65_H      0x130ACB
#define REG_BK130A_66_L      0x130ACC
#define REG_BK130A_66_H      0x130ACD
#define REG_BK130A_67_L      0x130ACE
#define REG_BK130A_67_H      0x130ACF
#define REG_BK130A_68_L      0x130AD0
#define REG_BK130A_68_H      0x130AD1
#define REG_BK130A_69_L      0x130AD2
#define REG_BK130A_69_H      0x130AD3
#define REG_BK130A_6A_L      0x130AD4
#define REG_BK130A_6A_H      0x130AD5
#define REG_BK130A_6B_L      0x130AD6
#define REG_BK130A_6B_H      0x130AD7
#define REG_BK130A_6C_L      0x130AD8
#define REG_BK130A_6C_H      0x130AD9
#define REG_BK130A_6D_L      0x130ADA
#define REG_BK130A_6D_H      0x130ADB
#define REG_BK130A_6E_L      0x130ADC
#define REG_BK130A_6E_H      0x130ADD
#define REG_BK130A_6F_L      0x130ADE
#define REG_BK130A_6F_H      0x130ADF
#define REG_BK130A_70_L      0x130AE0
#define REG_BK130A_70_H      0x130AE1
#define REG_BK130A_71_L      0x130AE2
#define REG_BK130A_71_H      0x130AE3
#define REG_BK130A_72_L      0x130AE4
#define REG_BK130A_72_H      0x130AE5
#define REG_BK130A_73_L      0x130AE6
#define REG_BK130A_73_H      0x130AE7
#define REG_BK130A_74_L      0x130AE8
#define REG_BK130A_74_H      0x130AE9
#define REG_BK130A_75_L      0x130AEA
#define REG_BK130A_75_H      0x130AEB
#define REG_BK130A_76_L      0x130AEC
#define REG_BK130A_76_H      0x130AED
#define REG_BK130A_77_L      0x130AEE
#define REG_BK130A_77_H      0x130AEF
#define REG_BK130A_78_L      0x130AF0
#define REG_BK130A_78_H      0x130AF1
#define REG_BK130A_79_L      0x130AF2
#define REG_BK130A_79_H      0x130AF3
#define REG_BK130A_7A_L      0x130AF4
#define REG_BK130A_7A_H      0x130AF5
#define REG_BK130A_7B_L      0x130AF6
#define REG_BK130A_7B_H      0x130AF7
#define REG_BK130A_7C_L      0x130AF8
#define REG_BK130A_7C_H      0x130AF9
#define REG_BK130A_7D_L      0x130AFA
#define REG_BK130A_7D_H      0x130AFB
#define REG_BK130A_7E_L      0x130AFC
#define REG_BK130A_7E_H      0x130AFD
#define REG_BK130A_7F_L      0x130AFE
#define REG_BK130A_7F_H      0x130AFF
//----------------------------------------------
#define REG_BK130B_00_L      0x130B00
#define REG_BK130B_00_H      0x130B01
#define REG_BK130B_01_L      0x130B02
#define REG_BK130B_01_H      0x130B03
#define REG_BK130B_02_L      0x130B04
#define REG_BK130B_02_H      0x130B05
#define REG_BK130B_03_L      0x130B06
#define REG_BK130B_03_H      0x130B07
#define REG_BK130B_04_L      0x130B08
#define REG_BK130B_04_H      0x130B09
#define REG_BK130B_05_L      0x130B0A
#define REG_BK130B_05_H      0x130B0B
#define REG_BK130B_06_L      0x130B0C
#define REG_BK130B_06_H      0x130B0D
#define REG_BK130B_07_L      0x130B0E
#define REG_BK130B_07_H      0x130B0F
#define REG_BK130B_08_L      0x130B10
#define REG_BK130B_08_H      0x130B11
#define REG_BK130B_09_L      0x130B12
#define REG_BK130B_09_H      0x130B13
#define REG_BK130B_0A_L      0x130B14
#define REG_BK130B_0A_H      0x130B15
#define REG_BK130B_0B_L      0x130B16
#define REG_BK130B_0B_H      0x130B17
#define REG_BK130B_0C_L      0x130B18
#define REG_BK130B_0C_H      0x130B19
#define REG_BK130B_0D_L      0x130B1A
#define REG_BK130B_0D_H      0x130B1B
#define REG_BK130B_0E_L      0x130B1C
#define REG_BK130B_0E_H      0x130B1D
#define REG_BK130B_0F_L      0x130B1E
#define REG_BK130B_0F_H      0x130B1F
#define REG_BK130B_10_L      0x130B20
#define REG_BK130B_10_H      0x130B21
#define REG_BK130B_11_L      0x130B22
#define REG_BK130B_11_H      0x130B23
#define REG_BK130B_12_L      0x130B24
#define REG_BK130B_12_H      0x130B25
#define REG_BK130B_13_L      0x130B26
#define REG_BK130B_13_H      0x130B27
#define REG_BK130B_14_L      0x130B28
#define REG_BK130B_14_H      0x130B29
#define REG_BK130B_15_L      0x130B2A
#define REG_BK130B_15_H      0x130B2B
#define REG_BK130B_16_L      0x130B2C
#define REG_BK130B_16_H      0x130B2D
#define REG_BK130B_17_L      0x130B2E
#define REG_BK130B_17_H      0x130B2F
#define REG_BK130B_18_L      0x130B30
#define REG_BK130B_18_H      0x130B31
#define REG_BK130B_19_L      0x130B32
#define REG_BK130B_19_H      0x130B33
#define REG_BK130B_1A_L      0x130B34
#define REG_BK130B_1A_H      0x130B35
#define REG_BK130B_1B_L      0x130B36
#define REG_BK130B_1B_H      0x130B37
#define REG_BK130B_1C_L      0x130B38
#define REG_BK130B_1C_H      0x130B39
#define REG_BK130B_1D_L      0x130B3A
#define REG_BK130B_1D_H      0x130B3B
#define REG_BK130B_1E_L      0x130B3C
#define REG_BK130B_1E_H      0x130B3D
#define REG_BK130B_1F_L      0x130B3E
#define REG_BK130B_1F_H      0x130B3F
#define REG_BK130B_20_L      0x130B40
#define REG_BK130B_20_H      0x130B41
#define REG_BK130B_21_L      0x130B42
#define REG_BK130B_21_H      0x130B43
#define REG_BK130B_22_L      0x130B44
#define REG_BK130B_22_H      0x130B45
#define REG_BK130B_23_L      0x130B46
#define REG_BK130B_23_H      0x130B47
#define REG_BK130B_24_L      0x130B48
#define REG_BK130B_24_H      0x130B49
#define REG_BK130B_25_L      0x130B4A
#define REG_BK130B_25_H      0x130B4B
#define REG_BK130B_26_L      0x130B4C
#define REG_BK130B_26_H      0x130B4D
#define REG_BK130B_27_L      0x130B4E
#define REG_BK130B_27_H      0x130B4F
#define REG_BK130B_28_L      0x130B50
#define REG_BK130B_28_H      0x130B51
#define REG_BK130B_29_L      0x130B52
#define REG_BK130B_29_H      0x130B53
#define REG_BK130B_2A_L      0x130B54
#define REG_BK130B_2A_H      0x130B55
#define REG_BK130B_2B_L      0x130B56
#define REG_BK130B_2B_H      0x130B57
#define REG_BK130B_2C_L      0x130B58
#define REG_BK130B_2C_H      0x130B59
#define REG_BK130B_2D_L      0x130B5A
#define REG_BK130B_2D_H      0x130B5B
#define REG_BK130B_2E_L      0x130B5C
#define REG_BK130B_2E_H      0x130B5D
#define REG_BK130B_2F_L      0x130B5E
#define REG_BK130B_2F_H      0x130B5F
#define REG_BK130B_30_L      0x130B60
#define REG_BK130B_30_H      0x130B61
#define REG_BK130B_31_L      0x130B62
#define REG_BK130B_31_H      0x130B63
#define REG_BK130B_32_L      0x130B64
#define REG_BK130B_32_H      0x130B65
#define REG_BK130B_33_L      0x130B66
#define REG_BK130B_33_H      0x130B67
#define REG_BK130B_34_L      0x130B68
#define REG_BK130B_34_H      0x130B69
#define REG_BK130B_35_L      0x130B6A
#define REG_BK130B_35_H      0x130B6B
#define REG_BK130B_36_L      0x130B6C
#define REG_BK130B_36_H      0x130B6D
#define REG_BK130B_37_L      0x130B6E
#define REG_BK130B_37_H      0x130B6F
#define REG_BK130B_38_L      0x130B70
#define REG_BK130B_38_H      0x130B71
#define REG_BK130B_39_L      0x130B72
#define REG_BK130B_39_H      0x130B73
#define REG_BK130B_3A_L      0x130B74
#define REG_BK130B_3A_H      0x130B75
#define REG_BK130B_3B_L      0x130B76
#define REG_BK130B_3B_H      0x130B77
#define REG_BK130B_3C_L      0x130B78
#define REG_BK130B_3C_H      0x130B79
#define REG_BK130B_3D_L      0x130B7A
#define REG_BK130B_3D_H      0x130B7B
#define REG_BK130B_3E_L      0x130B7C
#define REG_BK130B_3E_H      0x130B7D
#define REG_BK130B_3F_L      0x130B7E
#define REG_BK130B_3F_H      0x130B7F
#define REG_BK130B_40_L      0x130B80
#define REG_BK130B_40_H      0x130B81
#define REG_BK130B_41_L      0x130B82
#define REG_BK130B_41_H      0x130B83
#define REG_BK130B_42_L      0x130B84
#define REG_BK130B_42_H      0x130B85
#define REG_BK130B_43_L      0x130B86
#define REG_BK130B_43_H      0x130B87
#define REG_BK130B_44_L      0x130B88
#define REG_BK130B_44_H      0x130B89
#define REG_BK130B_45_L      0x130B8A
#define REG_BK130B_45_H      0x130B8B
#define REG_BK130B_46_L      0x130B8C
#define REG_BK130B_46_H      0x130B8D
#define REG_BK130B_47_L      0x130B8E
#define REG_BK130B_47_H      0x130B8F
#define REG_BK130B_48_L      0x130B90
#define REG_BK130B_48_H      0x130B91
#define REG_BK130B_49_L      0x130B92
#define REG_BK130B_49_H      0x130B93
#define REG_BK130B_4A_L      0x130B94
#define REG_BK130B_4A_H      0x130B95
#define REG_BK130B_4B_L      0x130B96
#define REG_BK130B_4B_H      0x130B97
#define REG_BK130B_4C_L      0x130B98
#define REG_BK130B_4C_H      0x130B99
#define REG_BK130B_4D_L      0x130B9A
#define REG_BK130B_4D_H      0x130B9B
#define REG_BK130B_4E_L      0x130B9C
#define REG_BK130B_4E_H      0x130B9D
#define REG_BK130B_4F_L      0x130B9E
#define REG_BK130B_4F_H      0x130B9F
#define REG_BK130B_50_L      0x130BA0
#define REG_BK130B_50_H      0x130BA1
#define REG_BK130B_51_L      0x130BA2
#define REG_BK130B_51_H      0x130BA3
#define REG_BK130B_52_L      0x130BA4
#define REG_BK130B_52_H      0x130BA5
#define REG_BK130B_53_L      0x130BA6
#define REG_BK130B_53_H      0x130BA7
#define REG_BK130B_54_L      0x130BA8
#define REG_BK130B_54_H      0x130BA9
#define REG_BK130B_55_L      0x130BAA
#define REG_BK130B_55_H      0x130BAB
#define REG_BK130B_56_L      0x130BAC
#define REG_BK130B_56_H      0x130BAD
#define REG_BK130B_57_L      0x130BAE
#define REG_BK130B_57_H      0x130BAF
#define REG_BK130B_58_L      0x130BB0
#define REG_BK130B_58_H      0x130BB1
#define REG_BK130B_59_L      0x130BB2
#define REG_BK130B_59_H      0x130BB3
#define REG_BK130B_5A_L      0x130BB4
#define REG_BK130B_5A_H      0x130BB5
#define REG_BK130B_5B_L      0x130BB6
#define REG_BK130B_5B_H      0x130BB7
#define REG_BK130B_5C_L      0x130BB8
#define REG_BK130B_5C_H      0x130BB9
#define REG_BK130B_5D_L      0x130BBA
#define REG_BK130B_5D_H      0x130BBB
#define REG_BK130B_5E_L      0x130BBC
#define REG_BK130B_5E_H      0x130BBD
#define REG_BK130B_5F_L      0x130BBE
#define REG_BK130B_5F_H      0x130BBF
#define REG_BK130B_60_L      0x130BC0
#define REG_BK130B_60_H      0x130BC1
#define REG_BK130B_61_L      0x130BC2
#define REG_BK130B_61_H      0x130BC3
#define REG_BK130B_62_L      0x130BC4
#define REG_BK130B_62_H      0x130BC5
#define REG_BK130B_63_L      0x130BC6
#define REG_BK130B_63_H      0x130BC7
#define REG_BK130B_64_L      0x130BC8
#define REG_BK130B_64_H      0x130BC9
#define REG_BK130B_65_L      0x130BCA
#define REG_BK130B_65_H      0x130BCB
#define REG_BK130B_66_L      0x130BCC
#define REG_BK130B_66_H      0x130BCD
#define REG_BK130B_67_L      0x130BCE
#define REG_BK130B_67_H      0x130BCF
#define REG_BK130B_68_L      0x130BD0
#define REG_BK130B_68_H      0x130BD1
#define REG_BK130B_69_L      0x130BD2
#define REG_BK130B_69_H      0x130BD3
#define REG_BK130B_6A_L      0x130BD4
#define REG_BK130B_6A_H      0x130BD5
#define REG_BK130B_6B_L      0x130BD6
#define REG_BK130B_6B_H      0x130BD7
#define REG_BK130B_6C_L      0x130BD8
#define REG_BK130B_6C_H      0x130BD9
#define REG_BK130B_6D_L      0x130BDA
#define REG_BK130B_6D_H      0x130BDB
#define REG_BK130B_6E_L      0x130BDC
#define REG_BK130B_6E_H      0x130BDD
#define REG_BK130B_6F_L      0x130BDE
#define REG_BK130B_6F_H      0x130BDF
#define REG_BK130B_70_L      0x130BE0
#define REG_BK130B_70_H      0x130BE1
#define REG_BK130B_71_L      0x130BE2
#define REG_BK130B_71_H      0x130BE3
#define REG_BK130B_72_L      0x130BE4
#define REG_BK130B_72_H      0x130BE5
#define REG_BK130B_73_L      0x130BE6
#define REG_BK130B_73_H      0x130BE7
#define REG_BK130B_74_L      0x130BE8
#define REG_BK130B_74_H      0x130BE9
#define REG_BK130B_75_L      0x130BEA
#define REG_BK130B_75_H      0x130BEB
#define REG_BK130B_76_L      0x130BEC
#define REG_BK130B_76_H      0x130BED
#define REG_BK130B_77_L      0x130BEE
#define REG_BK130B_77_H      0x130BEF
#define REG_BK130B_78_L      0x130BF0
#define REG_BK130B_78_H      0x130BF1
#define REG_BK130B_79_L      0x130BF2
#define REG_BK130B_79_H      0x130BF3
#define REG_BK130B_7A_L      0x130BF4
#define REG_BK130B_7A_H      0x130BF5
#define REG_BK130B_7B_L      0x130BF6
#define REG_BK130B_7B_H      0x130BF7
#define REG_BK130B_7C_L      0x130BF8
#define REG_BK130B_7C_H      0x130BF9
#define REG_BK130B_7D_L      0x130BFA
#define REG_BK130B_7D_H      0x130BFB
#define REG_BK130B_7E_L      0x130BFC
#define REG_BK130B_7E_H      0x130BFD
#define REG_BK130B_7F_L      0x130BFE
#define REG_BK130B_7F_H      0x130BFF
//----------------------------------------------
#define REG_BK130C_00_L      0x130C00
#define REG_BK130C_00_H      0x130C01
#define REG_BK130C_01_L      0x130C02
#define REG_BK130C_01_H      0x130C03
#define REG_BK130C_02_L      0x130C04
#define REG_BK130C_02_H      0x130C05
#define REG_BK130C_03_L      0x130C06
#define REG_BK130C_03_H      0x130C07
#define REG_BK130C_04_L      0x130C08
#define REG_BK130C_04_H      0x130C09
#define REG_BK130C_05_L      0x130C0A
#define REG_BK130C_05_H      0x130C0B
#define REG_BK130C_06_L      0x130C0C
#define REG_BK130C_06_H      0x130C0D
#define REG_BK130C_07_L      0x130C0E
#define REG_BK130C_07_H      0x130C0F
#define REG_BK130C_08_L      0x130C10
#define REG_BK130C_08_H      0x130C11
#define REG_BK130C_09_L      0x130C12
#define REG_BK130C_09_H      0x130C13
#define REG_BK130C_0A_L      0x130C14
#define REG_BK130C_0A_H      0x130C15
#define REG_BK130C_0B_L      0x130C16
#define REG_BK130C_0B_H      0x130C17
#define REG_BK130C_0C_L      0x130C18
#define REG_BK130C_0C_H      0x130C19
#define REG_BK130C_0D_L      0x130C1A
#define REG_BK130C_0D_H      0x130C1B
#define REG_BK130C_0E_L      0x130C1C
#define REG_BK130C_0E_H      0x130C1D
#define REG_BK130C_0F_L      0x130C1E
#define REG_BK130C_0F_H      0x130C1F
#define REG_BK130C_10_L      0x130C20
#define REG_BK130C_10_H      0x130C21
#define REG_BK130C_11_L      0x130C22
#define REG_BK130C_11_H      0x130C23
#define REG_BK130C_12_L      0x130C24
#define REG_BK130C_12_H      0x130C25
#define REG_BK130C_13_L      0x130C26
#define REG_BK130C_13_H      0x130C27
#define REG_BK130C_14_L      0x130C28
#define REG_BK130C_14_H      0x130C29
#define REG_BK130C_15_L      0x130C2A
#define REG_BK130C_15_H      0x130C2B
#define REG_BK130C_16_L      0x130C2C
#define REG_BK130C_16_H      0x130C2D
#define REG_BK130C_17_L      0x130C2E
#define REG_BK130C_17_H      0x130C2F
#define REG_BK130C_18_L      0x130C30
#define REG_BK130C_18_H      0x130C31
#define REG_BK130C_19_L      0x130C32
#define REG_BK130C_19_H      0x130C33
#define REG_BK130C_1A_L      0x130C34
#define REG_BK130C_1A_H      0x130C35
#define REG_BK130C_1B_L      0x130C36
#define REG_BK130C_1B_H      0x130C37
#define REG_BK130C_1C_L      0x130C38
#define REG_BK130C_1C_H      0x130C39
#define REG_BK130C_1D_L      0x130C3A
#define REG_BK130C_1D_H      0x130C3B
#define REG_BK130C_1E_L      0x130C3C
#define REG_BK130C_1E_H      0x130C3D
#define REG_BK130C_1F_L      0x130C3E
#define REG_BK130C_1F_H      0x130C3F
#define REG_BK130C_20_L      0x130C40
#define REG_BK130C_20_H      0x130C41
#define REG_BK130C_21_L      0x130C42
#define REG_BK130C_21_H      0x130C43
#define REG_BK130C_22_L      0x130C44
#define REG_BK130C_22_H      0x130C45
#define REG_BK130C_23_L      0x130C46
#define REG_BK130C_23_H      0x130C47
#define REG_BK130C_24_L      0x130C48
#define REG_BK130C_24_H      0x130C49
#define REG_BK130C_25_L      0x130C4A
#define REG_BK130C_25_H      0x130C4B
#define REG_BK130C_26_L      0x130C4C
#define REG_BK130C_26_H      0x130C4D
#define REG_BK130C_27_L      0x130C4E
#define REG_BK130C_27_H      0x130C4F
#define REG_BK130C_28_L      0x130C50
#define REG_BK130C_28_H      0x130C51
#define REG_BK130C_29_L      0x130C52
#define REG_BK130C_29_H      0x130C53
#define REG_BK130C_2A_L      0x130C54
#define REG_BK130C_2A_H      0x130C55
#define REG_BK130C_2B_L      0x130C56
#define REG_BK130C_2B_H      0x130C57
#define REG_BK130C_2C_L      0x130C58
#define REG_BK130C_2C_H      0x130C59
#define REG_BK130C_2D_L      0x130C5A
#define REG_BK130C_2D_H      0x130C5B
#define REG_BK130C_2E_L      0x130C5C
#define REG_BK130C_2E_H      0x130C5D
#define REG_BK130C_2F_L      0x130C5E
#define REG_BK130C_2F_H      0x130C5F
#define REG_BK130C_30_L      0x130C60
#define REG_BK130C_30_H      0x130C61
#define REG_BK130C_31_L      0x130C62
#define REG_BK130C_31_H      0x130C63
#define REG_BK130C_32_L      0x130C64
#define REG_BK130C_32_H      0x130C65
#define REG_BK130C_33_L      0x130C66
#define REG_BK130C_33_H      0x130C67
#define REG_BK130C_34_L      0x130C68
#define REG_BK130C_34_H      0x130C69
#define REG_BK130C_35_L      0x130C6A
#define REG_BK130C_35_H      0x130C6B
#define REG_BK130C_36_L      0x130C6C
#define REG_BK130C_36_H      0x130C6D
#define REG_BK130C_37_L      0x130C6E
#define REG_BK130C_37_H      0x130C6F
#define REG_BK130C_38_L      0x130C70
#define REG_BK130C_38_H      0x130C71
#define REG_BK130C_39_L      0x130C72
#define REG_BK130C_39_H      0x130C73
#define REG_BK130C_3A_L      0x130C74
#define REG_BK130C_3A_H      0x130C75
#define REG_BK130C_3B_L      0x130C76
#define REG_BK130C_3B_H      0x130C77
#define REG_BK130C_3C_L      0x130C78
#define REG_BK130C_3C_H      0x130C79
#define REG_BK130C_3D_L      0x130C7A
#define REG_BK130C_3D_H      0x130C7B
#define REG_BK130C_3E_L      0x130C7C
#define REG_BK130C_3E_H      0x130C7D
#define REG_BK130C_3F_L      0x130C7E
#define REG_BK130C_3F_H      0x130C7F
#define REG_BK130C_40_L      0x130C80
#define REG_BK130C_40_H      0x130C81
#define REG_BK130C_41_L      0x130C82
#define REG_BK130C_41_H      0x130C83
#define REG_BK130C_42_L      0x130C84
#define REG_BK130C_42_H      0x130C85
#define REG_BK130C_43_L      0x130C86
#define REG_BK130C_43_H      0x130C87
#define REG_BK130C_44_L      0x130C88
#define REG_BK130C_44_H      0x130C89
#define REG_BK130C_45_L      0x130C8A
#define REG_BK130C_45_H      0x130C8B
#define REG_BK130C_46_L      0x130C8C
#define REG_BK130C_46_H      0x130C8D
#define REG_BK130C_47_L      0x130C8E
#define REG_BK130C_47_H      0x130C8F
#define REG_BK130C_48_L      0x130C90
#define REG_BK130C_48_H      0x130C91
#define REG_BK130C_49_L      0x130C92
#define REG_BK130C_49_H      0x130C93
#define REG_BK130C_4A_L      0x130C94
#define REG_BK130C_4A_H      0x130C95
#define REG_BK130C_4B_L      0x130C96
#define REG_BK130C_4B_H      0x130C97
#define REG_BK130C_4C_L      0x130C98
#define REG_BK130C_4C_H      0x130C99
#define REG_BK130C_4D_L      0x130C9A
#define REG_BK130C_4D_H      0x130C9B
#define REG_BK130C_4E_L      0x130C9C
#define REG_BK130C_4E_H      0x130C9D
#define REG_BK130C_4F_L      0x130C9E
#define REG_BK130C_4F_H      0x130C9F
#define REG_BK130C_50_L      0x130CA0
#define REG_BK130C_50_H      0x130CA1
#define REG_BK130C_51_L      0x130CA2
#define REG_BK130C_51_H      0x130CA3
#define REG_BK130C_52_L      0x130CA4
#define REG_BK130C_52_H      0x130CA5
#define REG_BK130C_53_L      0x130CA6
#define REG_BK130C_53_H      0x130CA7
#define REG_BK130C_54_L      0x130CA8
#define REG_BK130C_54_H      0x130CA9
#define REG_BK130C_55_L      0x130CAA
#define REG_BK130C_55_H      0x130CAB
#define REG_BK130C_56_L      0x130CAC
#define REG_BK130C_56_H      0x130CAD
#define REG_BK130C_57_L      0x130CAE
#define REG_BK130C_57_H      0x130CAF
#define REG_BK130C_58_L      0x130CB0
#define REG_BK130C_58_H      0x130CB1
#define REG_BK130C_59_L      0x130CB2
#define REG_BK130C_59_H      0x130CB3
#define REG_BK130C_5A_L      0x130CB4
#define REG_BK130C_5A_H      0x130CB5
#define REG_BK130C_5B_L      0x130CB6
#define REG_BK130C_5B_H      0x130CB7
#define REG_BK130C_5C_L      0x130CB8
#define REG_BK130C_5C_H      0x130CB9
#define REG_BK130C_5D_L      0x130CBA
#define REG_BK130C_5D_H      0x130CBB
#define REG_BK130C_5E_L      0x130CBC
#define REG_BK130C_5E_H      0x130CBD
#define REG_BK130C_5F_L      0x130CBE
#define REG_BK130C_5F_H      0x130CBF
#define REG_BK130C_60_L      0x130CC0
#define REG_BK130C_60_H      0x130CC1
#define REG_BK130C_61_L      0x130CC2
#define REG_BK130C_61_H      0x130CC3
#define REG_BK130C_62_L      0x130CC4
#define REG_BK130C_62_H      0x130CC5
#define REG_BK130C_63_L      0x130CC6
#define REG_BK130C_63_H      0x130CC7
#define REG_BK130C_64_L      0x130CC8
#define REG_BK130C_64_H      0x130CC9
#define REG_BK130C_65_L      0x130CCA
#define REG_BK130C_65_H      0x130CCB
#define REG_BK130C_66_L      0x130CCC
#define REG_BK130C_66_H      0x130CCD
#define REG_BK130C_67_L      0x130CCE
#define REG_BK130C_67_H      0x130CCF
#define REG_BK130C_68_L      0x130CD0
#define REG_BK130C_68_H      0x130CD1
#define REG_BK130C_69_L      0x130CD2
#define REG_BK130C_69_H      0x130CD3
#define REG_BK130C_6A_L      0x130CD4
#define REG_BK130C_6A_H      0x130CD5
#define REG_BK130C_6B_L      0x130CD6
#define REG_BK130C_6B_H      0x130CD7
#define REG_BK130C_6C_L      0x130CD8
#define REG_BK130C_6C_H      0x130CD9
#define REG_BK130C_6D_L      0x130CDA
#define REG_BK130C_6D_H      0x130CDB
#define REG_BK130C_6E_L      0x130CDC
#define REG_BK130C_6E_H      0x130CDD
#define REG_BK130C_6F_L      0x130CDE
#define REG_BK130C_6F_H      0x130CDF
#define REG_BK130C_70_L      0x130CE0
#define REG_BK130C_70_H      0x130CE1
#define REG_BK130C_71_L      0x130CE2
#define REG_BK130C_71_H      0x130CE3
#define REG_BK130C_72_L      0x130CE4
#define REG_BK130C_72_H      0x130CE5
#define REG_BK130C_73_L      0x130CE6
#define REG_BK130C_73_H      0x130CE7
#define REG_BK130C_74_L      0x130CE8
#define REG_BK130C_74_H      0x130CE9
#define REG_BK130C_75_L      0x130CEA
#define REG_BK130C_75_H      0x130CEB
#define REG_BK130C_76_L      0x130CEC
#define REG_BK130C_76_H      0x130CED
#define REG_BK130C_77_L      0x130CEE
#define REG_BK130C_77_H      0x130CEF
#define REG_BK130C_78_L      0x130CF0
#define REG_BK130C_78_H      0x130CF1
#define REG_BK130C_79_L      0x130CF2
#define REG_BK130C_79_H      0x130CF3
#define REG_BK130C_7A_L      0x130CF4
#define REG_BK130C_7A_H      0x130CF5
#define REG_BK130C_7B_L      0x130CF6
#define REG_BK130C_7B_H      0x130CF7
#define REG_BK130C_7C_L      0x130CF8
#define REG_BK130C_7C_H      0x130CF9
#define REG_BK130C_7D_L      0x130CFA
#define REG_BK130C_7D_H      0x130CFB
#define REG_BK130C_7E_L      0x130CFC
#define REG_BK130C_7E_H      0x130CFD
#define REG_BK130C_7F_L      0x130CFE
#define REG_BK130C_7F_H      0x130CFF
//----------------------------------------------
#define REG_BK130D_00_L      0x130D00
#define REG_BK130D_00_H      0x130D01
#define REG_BK130D_01_L      0x130D02
#define REG_BK130D_01_H      0x130D03
#define REG_BK130D_02_L      0x130D04
#define REG_BK130D_02_H      0x130D05
#define REG_BK130D_03_L      0x130D06
#define REG_BK130D_03_H      0x130D07
#define REG_BK130D_04_L      0x130D08
#define REG_BK130D_04_H      0x130D09
#define REG_BK130D_05_L      0x130D0A
#define REG_BK130D_05_H      0x130D0B
#define REG_BK130D_06_L      0x130D0C
#define REG_BK130D_06_H      0x130D0D
#define REG_BK130D_07_L      0x130D0E
#define REG_BK130D_07_H      0x130D0F
#define REG_BK130D_08_L      0x130D10
#define REG_BK130D_08_H      0x130D11
#define REG_BK130D_09_L      0x130D12
#define REG_BK130D_09_H      0x130D13
#define REG_BK130D_0A_L      0x130D14
#define REG_BK130D_0A_H      0x130D15
#define REG_BK130D_0B_L      0x130D16
#define REG_BK130D_0B_H      0x130D17
#define REG_BK130D_0C_L      0x130D18
#define REG_BK130D_0C_H      0x130D19
#define REG_BK130D_0D_L      0x130D1A
#define REG_BK130D_0D_H      0x130D1B
#define REG_BK130D_0E_L      0x130D1C
#define REG_BK130D_0E_H      0x130D1D
#define REG_BK130D_0F_L      0x130D1E
#define REG_BK130D_0F_H      0x130D1F
#define REG_BK130D_10_L      0x130D20
#define REG_BK130D_10_H      0x130D21
#define REG_BK130D_11_L      0x130D22
#define REG_BK130D_11_H      0x130D23
#define REG_BK130D_12_L      0x130D24
#define REG_BK130D_12_H      0x130D25
#define REG_BK130D_13_L      0x130D26
#define REG_BK130D_13_H      0x130D27
#define REG_BK130D_14_L      0x130D28
#define REG_BK130D_14_H      0x130D29
#define REG_BK130D_15_L      0x130D2A
#define REG_BK130D_15_H      0x130D2B
#define REG_BK130D_16_L      0x130D2C
#define REG_BK130D_16_H      0x130D2D
#define REG_BK130D_17_L      0x130D2E
#define REG_BK130D_17_H      0x130D2F
#define REG_BK130D_18_L      0x130D30
#define REG_BK130D_18_H      0x130D31
#define REG_BK130D_19_L      0x130D32
#define REG_BK130D_19_H      0x130D33
#define REG_BK130D_1A_L      0x130D34
#define REG_BK130D_1A_H      0x130D35
#define REG_BK130D_1B_L      0x130D36
#define REG_BK130D_1B_H      0x130D37
#define REG_BK130D_1C_L      0x130D38
#define REG_BK130D_1C_H      0x130D39
#define REG_BK130D_1D_L      0x130D3A
#define REG_BK130D_1D_H      0x130D3B
#define REG_BK130D_1E_L      0x130D3C
#define REG_BK130D_1E_H      0x130D3D
#define REG_BK130D_1F_L      0x130D3E
#define REG_BK130D_1F_H      0x130D3F
#define REG_BK130D_20_L      0x130D40
#define REG_BK130D_20_H      0x130D41
#define REG_BK130D_21_L      0x130D42
#define REG_BK130D_21_H      0x130D43
#define REG_BK130D_22_L      0x130D44
#define REG_BK130D_22_H      0x130D45
#define REG_BK130D_23_L      0x130D46
#define REG_BK130D_23_H      0x130D47
#define REG_BK130D_24_L      0x130D48
#define REG_BK130D_24_H      0x130D49
#define REG_BK130D_25_L      0x130D4A
#define REG_BK130D_25_H      0x130D4B
#define REG_BK130D_26_L      0x130D4C
#define REG_BK130D_26_H      0x130D4D
#define REG_BK130D_27_L      0x130D4E
#define REG_BK130D_27_H      0x130D4F
#define REG_BK130D_28_L      0x130D50
#define REG_BK130D_28_H      0x130D51
#define REG_BK130D_29_L      0x130D52
#define REG_BK130D_29_H      0x130D53
#define REG_BK130D_2A_L      0x130D54
#define REG_BK130D_2A_H      0x130D55
#define REG_BK130D_2B_L      0x130D56
#define REG_BK130D_2B_H      0x130D57
#define REG_BK130D_2C_L      0x130D58
#define REG_BK130D_2C_H      0x130D59
#define REG_BK130D_2D_L      0x130D5A
#define REG_BK130D_2D_H      0x130D5B
#define REG_BK130D_2E_L      0x130D5C
#define REG_BK130D_2E_H      0x130D5D
#define REG_BK130D_2F_L      0x130D5E
#define REG_BK130D_2F_H      0x130D5F
#define REG_BK130D_30_L      0x130D60
#define REG_BK130D_30_H      0x130D61
#define REG_BK130D_31_L      0x130D62
#define REG_BK130D_31_H      0x130D63
#define REG_BK130D_32_L      0x130D64
#define REG_BK130D_32_H      0x130D65
#define REG_BK130D_33_L      0x130D66
#define REG_BK130D_33_H      0x130D67
#define REG_BK130D_34_L      0x130D68
#define REG_BK130D_34_H      0x130D69
#define REG_BK130D_35_L      0x130D6A
#define REG_BK130D_35_H      0x130D6B
#define REG_BK130D_36_L      0x130D6C
#define REG_BK130D_36_H      0x130D6D
#define REG_BK130D_37_L      0x130D6E
#define REG_BK130D_37_H      0x130D6F
#define REG_BK130D_38_L      0x130D70
#define REG_BK130D_38_H      0x130D71
#define REG_BK130D_39_L      0x130D72
#define REG_BK130D_39_H      0x130D73
#define REG_BK130D_3A_L      0x130D74
#define REG_BK130D_3A_H      0x130D75
#define REG_BK130D_3B_L      0x130D76
#define REG_BK130D_3B_H      0x130D77
#define REG_BK130D_3C_L      0x130D78
#define REG_BK130D_3C_H      0x130D79
#define REG_BK130D_3D_L      0x130D7A
#define REG_BK130D_3D_H      0x130D7B
#define REG_BK130D_3E_L      0x130D7C
#define REG_BK130D_3E_H      0x130D7D
#define REG_BK130D_3F_L      0x130D7E
#define REG_BK130D_3F_H      0x130D7F
#define REG_BK130D_40_L      0x130D80
#define REG_BK130D_40_H      0x130D81
#define REG_BK130D_41_L      0x130D82
#define REG_BK130D_41_H      0x130D83
#define REG_BK130D_42_L      0x130D84
#define REG_BK130D_42_H      0x130D85
#define REG_BK130D_43_L      0x130D86
#define REG_BK130D_43_H      0x130D87
#define REG_BK130D_44_L      0x130D88
#define REG_BK130D_44_H      0x130D89
#define REG_BK130D_45_L      0x130D8A
#define REG_BK130D_45_H      0x130D8B
#define REG_BK130D_46_L      0x130D8C
#define REG_BK130D_46_H      0x130D8D
#define REG_BK130D_47_L      0x130D8E
#define REG_BK130D_47_H      0x130D8F
#define REG_BK130D_48_L      0x130D90
#define REG_BK130D_48_H      0x130D91
#define REG_BK130D_49_L      0x130D92
#define REG_BK130D_49_H      0x130D93
#define REG_BK130D_4A_L      0x130D94
#define REG_BK130D_4A_H      0x130D95
#define REG_BK130D_4B_L      0x130D96
#define REG_BK130D_4B_H      0x130D97
#define REG_BK130D_4C_L      0x130D98
#define REG_BK130D_4C_H      0x130D99
#define REG_BK130D_4D_L      0x130D9A
#define REG_BK130D_4D_H      0x130D9B
#define REG_BK130D_4E_L      0x130D9C
#define REG_BK130D_4E_H      0x130D9D
#define REG_BK130D_4F_L      0x130D9E
#define REG_BK130D_4F_H      0x130D9F
#define REG_BK130D_50_L      0x130DA0
#define REG_BK130D_50_H      0x130DA1
#define REG_BK130D_51_L      0x130DA2
#define REG_BK130D_51_H      0x130DA3
#define REG_BK130D_52_L      0x130DA4
#define REG_BK130D_52_H      0x130DA5
#define REG_BK130D_53_L      0x130DA6
#define REG_BK130D_53_H      0x130DA7
#define REG_BK130D_54_L      0x130DA8
#define REG_BK130D_54_H      0x130DA9
#define REG_BK130D_55_L      0x130DAA
#define REG_BK130D_55_H      0x130DAB
#define REG_BK130D_56_L      0x130DAC
#define REG_BK130D_56_H      0x130DAD
#define REG_BK130D_57_L      0x130DAE
#define REG_BK130D_57_H      0x130DAF
#define REG_BK130D_58_L      0x130DB0
#define REG_BK130D_58_H      0x130DB1
#define REG_BK130D_59_L      0x130DB2
#define REG_BK130D_59_H      0x130DB3
#define REG_BK130D_5A_L      0x130DB4
#define REG_BK130D_5A_H      0x130DB5
#define REG_BK130D_5B_L      0x130DB6
#define REG_BK130D_5B_H      0x130DB7
#define REG_BK130D_5C_L      0x130DB8
#define REG_BK130D_5C_H      0x130DB9
#define REG_BK130D_5D_L      0x130DBA
#define REG_BK130D_5D_H      0x130DBB
#define REG_BK130D_5E_L      0x130DBC
#define REG_BK130D_5E_H      0x130DBD
#define REG_BK130D_5F_L      0x130DBE
#define REG_BK130D_5F_H      0x130DBF
#define REG_BK130D_60_L      0x130DC0
#define REG_BK130D_60_H      0x130DC1
#define REG_BK130D_61_L      0x130DC2
#define REG_BK130D_61_H      0x130DC3
#define REG_BK130D_62_L      0x130DC4
#define REG_BK130D_62_H      0x130DC5
#define REG_BK130D_63_L      0x130DC6
#define REG_BK130D_63_H      0x130DC7
#define REG_BK130D_64_L      0x130DC8
#define REG_BK130D_64_H      0x130DC9
#define REG_BK130D_65_L      0x130DCA
#define REG_BK130D_65_H      0x130DCB
#define REG_BK130D_66_L      0x130DCC
#define REG_BK130D_66_H      0x130DCD
#define REG_BK130D_67_L      0x130DCE
#define REG_BK130D_67_H      0x130DCF
#define REG_BK130D_68_L      0x130DD0
#define REG_BK130D_68_H      0x130DD1
#define REG_BK130D_69_L      0x130DD2
#define REG_BK130D_69_H      0x130DD3
#define REG_BK130D_6A_L      0x130DD4
#define REG_BK130D_6A_H      0x130DD5
#define REG_BK130D_6B_L      0x130DD6
#define REG_BK130D_6B_H      0x130DD7
#define REG_BK130D_6C_L      0x130DD8
#define REG_BK130D_6C_H      0x130DD9
#define REG_BK130D_6D_L      0x130DDA
#define REG_BK130D_6D_H      0x130DDB
#define REG_BK130D_6E_L      0x130DDC
#define REG_BK130D_6E_H      0x130DDD
#define REG_BK130D_6F_L      0x130DDE
#define REG_BK130D_6F_H      0x130DDF
#define REG_BK130D_70_L      0x130DE0
#define REG_BK130D_70_H      0x130DE1
#define REG_BK130D_71_L      0x130DE2
#define REG_BK130D_71_H      0x130DE3
#define REG_BK130D_72_L      0x130DE4
#define REG_BK130D_72_H      0x130DE5
#define REG_BK130D_73_L      0x130DE6
#define REG_BK130D_73_H      0x130DE7
#define REG_BK130D_74_L      0x130DE8
#define REG_BK130D_74_H      0x130DE9
#define REG_BK130D_75_L      0x130DEA
#define REG_BK130D_75_H      0x130DEB
#define REG_BK130D_76_L      0x130DEC
#define REG_BK130D_76_H      0x130DED
#define REG_BK130D_77_L      0x130DEE
#define REG_BK130D_77_H      0x130DEF
#define REG_BK130D_78_L      0x130DF0
#define REG_BK130D_78_H      0x130DF1
#define REG_BK130D_79_L      0x130DF2
#define REG_BK130D_79_H      0x130DF3
#define REG_BK130D_7A_L      0x130DF4
#define REG_BK130D_7A_H      0x130DF5
#define REG_BK130D_7B_L      0x130DF6
#define REG_BK130D_7B_H      0x130DF7
#define REG_BK130D_7C_L      0x130DF8
#define REG_BK130D_7C_H      0x130DF9
#define REG_BK130D_7D_L      0x130DFA
#define REG_BK130D_7D_H      0x130DFB
#define REG_BK130D_7E_L      0x130DFC
#define REG_BK130D_7E_H      0x130DFD
#define REG_BK130D_7F_L      0x130DFE
#define REG_BK130D_7F_H      0x130DFF
//----------------------------------------------
#define REG_BK130E_00_L      0x130E00
#define REG_BK130E_00_H      0x130E01
#define REG_BK130E_01_L      0x130E02
#define REG_BK130E_01_H      0x130E03
#define REG_BK130E_02_L      0x130E04
#define REG_BK130E_02_H      0x130E05
#define REG_BK130E_03_L      0x130E06
#define REG_BK130E_03_H      0x130E07
#define REG_BK130E_04_L      0x130E08
#define REG_BK130E_04_H      0x130E09
#define REG_BK130E_05_L      0x130E0A
#define REG_BK130E_05_H      0x130E0B
#define REG_BK130E_06_L      0x130E0C
#define REG_BK130E_06_H      0x130E0D
#define REG_BK130E_07_L      0x130E0E
#define REG_BK130E_07_H      0x130E0F
#define REG_BK130E_08_L      0x130E10
#define REG_BK130E_08_H      0x130E11
#define REG_BK130E_09_L      0x130E12
#define REG_BK130E_09_H      0x130E13
#define REG_BK130E_0A_L      0x130E14
#define REG_BK130E_0A_H      0x130E15
#define REG_BK130E_0B_L      0x130E16
#define REG_BK130E_0B_H      0x130E17
#define REG_BK130E_0C_L      0x130E18
#define REG_BK130E_0C_H      0x130E19
#define REG_BK130E_0D_L      0x130E1A
#define REG_BK130E_0D_H      0x130E1B
#define REG_BK130E_0E_L      0x130E1C
#define REG_BK130E_0E_H      0x130E1D
#define REG_BK130E_0F_L      0x130E1E
#define REG_BK130E_0F_H      0x130E1F
#define REG_BK130E_10_L      0x130E20
#define REG_BK130E_10_H      0x130E21
#define REG_BK130E_11_L      0x130E22
#define REG_BK130E_11_H      0x130E23
#define REG_BK130E_12_L      0x130E24
#define REG_BK130E_12_H      0x130E25
#define REG_BK130E_13_L      0x130E26
#define REG_BK130E_13_H      0x130E27
#define REG_BK130E_14_L      0x130E28
#define REG_BK130E_14_H      0x130E29
#define REG_BK130E_15_L      0x130E2A
#define REG_BK130E_15_H      0x130E2B
#define REG_BK130E_16_L      0x130E2C
#define REG_BK130E_16_H      0x130E2D
#define REG_BK130E_17_L      0x130E2E
#define REG_BK130E_17_H      0x130E2F
#define REG_BK130E_18_L      0x130E30
#define REG_BK130E_18_H      0x130E31
#define REG_BK130E_19_L      0x130E32
#define REG_BK130E_19_H      0x130E33
#define REG_BK130E_1A_L      0x130E34
#define REG_BK130E_1A_H      0x130E35
#define REG_BK130E_1B_L      0x130E36
#define REG_BK130E_1B_H      0x130E37
#define REG_BK130E_1C_L      0x130E38
#define REG_BK130E_1C_H      0x130E39
#define REG_BK130E_1D_L      0x130E3A
#define REG_BK130E_1D_H      0x130E3B
#define REG_BK130E_1E_L      0x130E3C
#define REG_BK130E_1E_H      0x130E3D
#define REG_BK130E_1F_L      0x130E3E
#define REG_BK130E_1F_H      0x130E3F
#define REG_BK130E_20_L      0x130E40
#define REG_BK130E_20_H      0x130E41
#define REG_BK130E_21_L      0x130E42
#define REG_BK130E_21_H      0x130E43
#define REG_BK130E_22_L      0x130E44
#define REG_BK130E_22_H      0x130E45
#define REG_BK130E_23_L      0x130E46
#define REG_BK130E_23_H      0x130E47
#define REG_BK130E_24_L      0x130E48
#define REG_BK130E_24_H      0x130E49
#define REG_BK130E_25_L      0x130E4A
#define REG_BK130E_25_H      0x130E4B
#define REG_BK130E_26_L      0x130E4C
#define REG_BK130E_26_H      0x130E4D
#define REG_BK130E_27_L      0x130E4E
#define REG_BK130E_27_H      0x130E4F
#define REG_BK130E_28_L      0x130E50
#define REG_BK130E_28_H      0x130E51
#define REG_BK130E_29_L      0x130E52
#define REG_BK130E_29_H      0x130E53
#define REG_BK130E_2A_L      0x130E54
#define REG_BK130E_2A_H      0x130E55
#define REG_BK130E_2B_L      0x130E56
#define REG_BK130E_2B_H      0x130E57
#define REG_BK130E_2C_L      0x130E58
#define REG_BK130E_2C_H      0x130E59
#define REG_BK130E_2D_L      0x130E5A
#define REG_BK130E_2D_H      0x130E5B
#define REG_BK130E_2E_L      0x130E5C
#define REG_BK130E_2E_H      0x130E5D
#define REG_BK130E_2F_L      0x130E5E
#define REG_BK130E_2F_H      0x130E5F
#define REG_BK130E_30_L      0x130E60
#define REG_BK130E_30_H      0x130E61
#define REG_BK130E_31_L      0x130E62
#define REG_BK130E_31_H      0x130E63
#define REG_BK130E_32_L      0x130E64
#define REG_BK130E_32_H      0x130E65
#define REG_BK130E_33_L      0x130E66
#define REG_BK130E_33_H      0x130E67
#define REG_BK130E_34_L      0x130E68
#define REG_BK130E_34_H      0x130E69
#define REG_BK130E_35_L      0x130E6A
#define REG_BK130E_35_H      0x130E6B
#define REG_BK130E_36_L      0x130E6C
#define REG_BK130E_36_H      0x130E6D
#define REG_BK130E_37_L      0x130E6E
#define REG_BK130E_37_H      0x130E6F
#define REG_BK130E_38_L      0x130E70
#define REG_BK130E_38_H      0x130E71
#define REG_BK130E_39_L      0x130E72
#define REG_BK130E_39_H      0x130E73
#define REG_BK130E_3A_L      0x130E74
#define REG_BK130E_3A_H      0x130E75
#define REG_BK130E_3B_L      0x130E76
#define REG_BK130E_3B_H      0x130E77
#define REG_BK130E_3C_L      0x130E78
#define REG_BK130E_3C_H      0x130E79
#define REG_BK130E_3D_L      0x130E7A
#define REG_BK130E_3D_H      0x130E7B
#define REG_BK130E_3E_L      0x130E7C
#define REG_BK130E_3E_H      0x130E7D
#define REG_BK130E_3F_L      0x130E7E
#define REG_BK130E_3F_H      0x130E7F
#define REG_BK130E_40_L      0x130E80
#define REG_BK130E_40_H      0x130E81
#define REG_BK130E_41_L      0x130E82
#define REG_BK130E_41_H      0x130E83
#define REG_BK130E_42_L      0x130E84
#define REG_BK130E_42_H      0x130E85
#define REG_BK130E_43_L      0x130E86
#define REG_BK130E_43_H      0x130E87
#define REG_BK130E_44_L      0x130E88
#define REG_BK130E_44_H      0x130E89
#define REG_BK130E_45_L      0x130E8A
#define REG_BK130E_45_H      0x130E8B
#define REG_BK130E_46_L      0x130E8C
#define REG_BK130E_46_H      0x130E8D
#define REG_BK130E_47_L      0x130E8E
#define REG_BK130E_47_H      0x130E8F
#define REG_BK130E_48_L      0x130E90
#define REG_BK130E_48_H      0x130E91
#define REG_BK130E_49_L      0x130E92
#define REG_BK130E_49_H      0x130E93
#define REG_BK130E_4A_L      0x130E94
#define REG_BK130E_4A_H      0x130E95
#define REG_BK130E_4B_L      0x130E96
#define REG_BK130E_4B_H      0x130E97
#define REG_BK130E_4C_L      0x130E98
#define REG_BK130E_4C_H      0x130E99
#define REG_BK130E_4D_L      0x130E9A
#define REG_BK130E_4D_H      0x130E9B
#define REG_BK130E_4E_L      0x130E9C
#define REG_BK130E_4E_H      0x130E9D
#define REG_BK130E_4F_L      0x130E9E
#define REG_BK130E_4F_H      0x130E9F
#define REG_BK130E_50_L      0x130EA0
#define REG_BK130E_50_H      0x130EA1
#define REG_BK130E_51_L      0x130EA2
#define REG_BK130E_51_H      0x130EA3
#define REG_BK130E_52_L      0x130EA4
#define REG_BK130E_52_H      0x130EA5
#define REG_BK130E_53_L      0x130EA6
#define REG_BK130E_53_H      0x130EA7
#define REG_BK130E_54_L      0x130EA8
#define REG_BK130E_54_H      0x130EA9
#define REG_BK130E_55_L      0x130EAA
#define REG_BK130E_55_H      0x130EAB
#define REG_BK130E_56_L      0x130EAC
#define REG_BK130E_56_H      0x130EAD
#define REG_BK130E_57_L      0x130EAE
#define REG_BK130E_57_H      0x130EAF
#define REG_BK130E_58_L      0x130EB0
#define REG_BK130E_58_H      0x130EB1
#define REG_BK130E_59_L      0x130EB2
#define REG_BK130E_59_H      0x130EB3
#define REG_BK130E_5A_L      0x130EB4
#define REG_BK130E_5A_H      0x130EB5
#define REG_BK130E_5B_L      0x130EB6
#define REG_BK130E_5B_H      0x130EB7
#define REG_BK130E_5C_L      0x130EB8
#define REG_BK130E_5C_H      0x130EB9
#define REG_BK130E_5D_L      0x130EBA
#define REG_BK130E_5D_H      0x130EBB
#define REG_BK130E_5E_L      0x130EBC
#define REG_BK130E_5E_H      0x130EBD
#define REG_BK130E_5F_L      0x130EBE
#define REG_BK130E_5F_H      0x130EBF
#define REG_BK130E_60_L      0x130EC0
#define REG_BK130E_60_H      0x130EC1
#define REG_BK130E_61_L      0x130EC2
#define REG_BK130E_61_H      0x130EC3
#define REG_BK130E_62_L      0x130EC4
#define REG_BK130E_62_H      0x130EC5
#define REG_BK130E_63_L      0x130EC6
#define REG_BK130E_63_H      0x130EC7
#define REG_BK130E_64_L      0x130EC8
#define REG_BK130E_64_H      0x130EC9
#define REG_BK130E_65_L      0x130ECA
#define REG_BK130E_65_H      0x130ECB
#define REG_BK130E_66_L      0x130ECC
#define REG_BK130E_66_H      0x130ECD
#define REG_BK130E_67_L      0x130ECE
#define REG_BK130E_67_H      0x130ECF
#define REG_BK130E_68_L      0x130ED0
#define REG_BK130E_68_H      0x130ED1
#define REG_BK130E_69_L      0x130ED2
#define REG_BK130E_69_H      0x130ED3
#define REG_BK130E_6A_L      0x130ED4
#define REG_BK130E_6A_H      0x130ED5
#define REG_BK130E_6B_L      0x130ED6
#define REG_BK130E_6B_H      0x130ED7
#define REG_BK130E_6C_L      0x130ED8
#define REG_BK130E_6C_H      0x130ED9
#define REG_BK130E_6D_L      0x130EDA
#define REG_BK130E_6D_H      0x130EDB
#define REG_BK130E_6E_L      0x130EDC
#define REG_BK130E_6E_H      0x130EDD
#define REG_BK130E_6F_L      0x130EDE
#define REG_BK130E_6F_H      0x130EDF
#define REG_BK130E_70_L      0x130EE0
#define REG_BK130E_70_H      0x130EE1
#define REG_BK130E_71_L      0x130EE2
#define REG_BK130E_71_H      0x130EE3
#define REG_BK130E_72_L      0x130EE4
#define REG_BK130E_72_H      0x130EE5
#define REG_BK130E_73_L      0x130EE6
#define REG_BK130E_73_H      0x130EE7
#define REG_BK130E_74_L      0x130EE8
#define REG_BK130E_74_H      0x130EE9
#define REG_BK130E_75_L      0x130EEA
#define REG_BK130E_75_H      0x130EEB
#define REG_BK130E_76_L      0x130EEC
#define REG_BK130E_76_H      0x130EED
#define REG_BK130E_77_L      0x130EEE
#define REG_BK130E_77_H      0x130EEF
#define REG_BK130E_78_L      0x130EF0
#define REG_BK130E_78_H      0x130EF1
#define REG_BK130E_79_L      0x130EF2
#define REG_BK130E_79_H      0x130EF3
#define REG_BK130E_7A_L      0x130EF4
#define REG_BK130E_7A_H      0x130EF5
#define REG_BK130E_7B_L      0x130EF6
#define REG_BK130E_7B_H      0x130EF7
#define REG_BK130E_7C_L      0x130EF8
#define REG_BK130E_7C_H      0x130EF9
#define REG_BK130E_7D_L      0x130EFA
#define REG_BK130E_7D_H      0x130EFB
#define REG_BK130E_7E_L      0x130EFC
#define REG_BK130E_7E_H      0x130EFD
#define REG_BK130E_7F_L      0x130EFE
#define REG_BK130E_7F_H      0x130EFF
//----------------------------------------------
#define REG_BK130F_00_L      0x130F00
#define REG_BK130F_00_H      0x130F01
#define REG_BK130F_01_L      0x130F02
#define REG_BK130F_01_H      0x130F03
#define REG_BK130F_02_L      0x130F04
#define REG_BK130F_02_H      0x130F05
#define REG_BK130F_03_L      0x130F06
#define REG_BK130F_03_H      0x130F07
#define REG_BK130F_04_L      0x130F08
#define REG_BK130F_04_H      0x130F09
#define REG_BK130F_05_L      0x130F0A
#define REG_BK130F_05_H      0x130F0B
#define REG_BK130F_06_L      0x130F0C
#define REG_BK130F_06_H      0x130F0D
#define REG_BK130F_07_L      0x130F0E
#define REG_BK130F_07_H      0x130F0F
#define REG_BK130F_08_L      0x130F10
#define REG_BK130F_08_H      0x130F11
#define REG_BK130F_09_L      0x130F12
#define REG_BK130F_09_H      0x130F13
#define REG_BK130F_0A_L      0x130F14
#define REG_BK130F_0A_H      0x130F15
#define REG_BK130F_0B_L      0x130F16
#define REG_BK130F_0B_H      0x130F17
#define REG_BK130F_0C_L      0x130F18
#define REG_BK130F_0C_H      0x130F19
#define REG_BK130F_0D_L      0x130F1A
#define REG_BK130F_0D_H      0x130F1B
#define REG_BK130F_0E_L      0x130F1C
#define REG_BK130F_0E_H      0x130F1D
#define REG_BK130F_0F_L      0x130F1E
#define REG_BK130F_0F_H      0x130F1F
#define REG_BK130F_10_L      0x130F20
#define REG_BK130F_10_H      0x130F21
#define REG_BK130F_11_L      0x130F22
#define REG_BK130F_11_H      0x130F23
#define REG_BK130F_12_L      0x130F24
#define REG_BK130F_12_H      0x130F25
#define REG_BK130F_13_L      0x130F26
#define REG_BK130F_13_H      0x130F27
#define REG_BK130F_14_L      0x130F28
#define REG_BK130F_14_H      0x130F29
#define REG_BK130F_15_L      0x130F2A
#define REG_BK130F_15_H      0x130F2B
#define REG_BK130F_16_L      0x130F2C
#define REG_BK130F_16_H      0x130F2D
#define REG_BK130F_17_L      0x130F2E
#define REG_BK130F_17_H      0x130F2F
#define REG_BK130F_18_L      0x130F30
#define REG_BK130F_18_H      0x130F31
#define REG_BK130F_19_L      0x130F32
#define REG_BK130F_19_H      0x130F33
#define REG_BK130F_1A_L      0x130F34
#define REG_BK130F_1A_H      0x130F35
#define REG_BK130F_1B_L      0x130F36
#define REG_BK130F_1B_H      0x130F37
#define REG_BK130F_1C_L      0x130F38
#define REG_BK130F_1C_H      0x130F39
#define REG_BK130F_1D_L      0x130F3A
#define REG_BK130F_1D_H      0x130F3B
#define REG_BK130F_1E_L      0x130F3C
#define REG_BK130F_1E_H      0x130F3D
#define REG_BK130F_1F_L      0x130F3E
#define REG_BK130F_1F_H      0x130F3F
#define REG_BK130F_20_L      0x130F40
#define REG_BK130F_20_H      0x130F41
#define REG_BK130F_21_L      0x130F42
#define REG_BK130F_21_H      0x130F43
#define REG_BK130F_22_L      0x130F44
#define REG_BK130F_22_H      0x130F45
#define REG_BK130F_23_L      0x130F46
#define REG_BK130F_23_H      0x130F47
#define REG_BK130F_24_L      0x130F48
#define REG_BK130F_24_H      0x130F49
#define REG_BK130F_25_L      0x130F4A
#define REG_BK130F_25_H      0x130F4B
#define REG_BK130F_26_L      0x130F4C
#define REG_BK130F_26_H      0x130F4D
#define REG_BK130F_27_L      0x130F4E
#define REG_BK130F_27_H      0x130F4F
#define REG_BK130F_28_L      0x130F50
#define REG_BK130F_28_H      0x130F51
#define REG_BK130F_29_L      0x130F52
#define REG_BK130F_29_H      0x130F53
#define REG_BK130F_2A_L      0x130F54
#define REG_BK130F_2A_H      0x130F55
#define REG_BK130F_2B_L      0x130F56
#define REG_BK130F_2B_H      0x130F57
#define REG_BK130F_2C_L      0x130F58
#define REG_BK130F_2C_H      0x130F59
#define REG_BK130F_2D_L      0x130F5A
#define REG_BK130F_2D_H      0x130F5B
#define REG_BK130F_2E_L      0x130F5C
#define REG_BK130F_2E_H      0x130F5D
#define REG_BK130F_2F_L      0x130F5E
#define REG_BK130F_2F_H      0x130F5F
#define REG_BK130F_30_L      0x130F60
#define REG_BK130F_30_H      0x130F61
#define REG_BK130F_31_L      0x130F62
#define REG_BK130F_31_H      0x130F63
#define REG_BK130F_32_L      0x130F64
#define REG_BK130F_32_H      0x130F65
#define REG_BK130F_33_L      0x130F66
#define REG_BK130F_33_H      0x130F67
#define REG_BK130F_34_L      0x130F68
#define REG_BK130F_34_H      0x130F69
#define REG_BK130F_35_L      0x130F6A
#define REG_BK130F_35_H      0x130F6B
#define REG_BK130F_36_L      0x130F6C
#define REG_BK130F_36_H      0x130F6D
#define REG_BK130F_37_L      0x130F6E
#define REG_BK130F_37_H      0x130F6F
#define REG_BK130F_38_L      0x130F70
#define REG_BK130F_38_H      0x130F71
#define REG_BK130F_39_L      0x130F72
#define REG_BK130F_39_H      0x130F73
#define REG_BK130F_3A_L      0x130F74
#define REG_BK130F_3A_H      0x130F75
#define REG_BK130F_3B_L      0x130F76
#define REG_BK130F_3B_H      0x130F77
#define REG_BK130F_3C_L      0x130F78
#define REG_BK130F_3C_H      0x130F79
#define REG_BK130F_3D_L      0x130F7A
#define REG_BK130F_3D_H      0x130F7B
#define REG_BK130F_3E_L      0x130F7C
#define REG_BK130F_3E_H      0x130F7D
#define REG_BK130F_3F_L      0x130F7E
#define REG_BK130F_3F_H      0x130F7F
#define REG_BK130F_40_L      0x130F80
#define REG_BK130F_40_H      0x130F81
#define REG_BK130F_41_L      0x130F82
#define REG_BK130F_41_H      0x130F83
#define REG_BK130F_42_L      0x130F84
#define REG_BK130F_42_H      0x130F85
#define REG_BK130F_43_L      0x130F86
#define REG_BK130F_43_H      0x130F87
#define REG_BK130F_44_L      0x130F88
#define REG_BK130F_44_H      0x130F89
#define REG_BK130F_45_L      0x130F8A
#define REG_BK130F_45_H      0x130F8B
#define REG_BK130F_46_L      0x130F8C
#define REG_BK130F_46_H      0x130F8D
#define REG_BK130F_47_L      0x130F8E
#define REG_BK130F_47_H      0x130F8F
#define REG_BK130F_48_L      0x130F90
#define REG_BK130F_48_H      0x130F91
#define REG_BK130F_49_L      0x130F92
#define REG_BK130F_49_H      0x130F93
#define REG_BK130F_4A_L      0x130F94
#define REG_BK130F_4A_H      0x130F95
#define REG_BK130F_4B_L      0x130F96
#define REG_BK130F_4B_H      0x130F97
#define REG_BK130F_4C_L      0x130F98
#define REG_BK130F_4C_H      0x130F99
#define REG_BK130F_4D_L      0x130F9A
#define REG_BK130F_4D_H      0x130F9B
#define REG_BK130F_4E_L      0x130F9C
#define REG_BK130F_4E_H      0x130F9D
#define REG_BK130F_4F_L      0x130F9E
#define REG_BK130F_4F_H      0x130F9F
#define REG_BK130F_50_L      0x130FA0
#define REG_BK130F_50_H      0x130FA1
#define REG_BK130F_51_L      0x130FA2
#define REG_BK130F_51_H      0x130FA3
#define REG_BK130F_52_L      0x130FA4
#define REG_BK130F_52_H      0x130FA5
#define REG_BK130F_53_L      0x130FA6
#define REG_BK130F_53_H      0x130FA7
#define REG_BK130F_54_L      0x130FA8
#define REG_BK130F_54_H      0x130FA9
#define REG_BK130F_55_L      0x130FAA
#define REG_BK130F_55_H      0x130FAB
#define REG_BK130F_56_L      0x130FAC
#define REG_BK130F_56_H      0x130FAD
#define REG_BK130F_57_L      0x130FAE
#define REG_BK130F_57_H      0x130FAF
#define REG_BK130F_58_L      0x130FB0
#define REG_BK130F_58_H      0x130FB1
#define REG_BK130F_59_L      0x130FB2
#define REG_BK130F_59_H      0x130FB3
#define REG_BK130F_5A_L      0x130FB4
#define REG_BK130F_5A_H      0x130FB5
#define REG_BK130F_5B_L      0x130FB6
#define REG_BK130F_5B_H      0x130FB7
#define REG_BK130F_5C_L      0x130FB8
#define REG_BK130F_5C_H      0x130FB9
#define REG_BK130F_5D_L      0x130FBA
#define REG_BK130F_5D_H      0x130FBB
#define REG_BK130F_5E_L      0x130FBC
#define REG_BK130F_5E_H      0x130FBD
#define REG_BK130F_5F_L      0x130FBE
#define REG_BK130F_5F_H      0x130FBF
#define REG_BK130F_60_L      0x130FC0
#define REG_BK130F_60_H      0x130FC1
#define REG_BK130F_61_L      0x130FC2
#define REG_BK130F_61_H      0x130FC3
#define REG_BK130F_62_L      0x130FC4
#define REG_BK130F_62_H      0x130FC5
#define REG_BK130F_63_L      0x130FC6
#define REG_BK130F_63_H      0x130FC7
#define REG_BK130F_64_L      0x130FC8
#define REG_BK130F_64_H      0x130FC9
#define REG_BK130F_65_L      0x130FCA
#define REG_BK130F_65_H      0x130FCB
#define REG_BK130F_66_L      0x130FCC
#define REG_BK130F_66_H      0x130FCD
#define REG_BK130F_67_L      0x130FCE
#define REG_BK130F_67_H      0x130FCF
#define REG_BK130F_68_L      0x130FD0
#define REG_BK130F_68_H      0x130FD1
#define REG_BK130F_69_L      0x130FD2
#define REG_BK130F_69_H      0x130FD3
#define REG_BK130F_6A_L      0x130FD4
#define REG_BK130F_6A_H      0x130FD5
#define REG_BK130F_6B_L      0x130FD6
#define REG_BK130F_6B_H      0x130FD7
#define REG_BK130F_6C_L      0x130FD8
#define REG_BK130F_6C_H      0x130FD9
#define REG_BK130F_6D_L      0x130FDA
#define REG_BK130F_6D_H      0x130FDB
#define REG_BK130F_6E_L      0x130FDC
#define REG_BK130F_6E_H      0x130FDD
#define REG_BK130F_6F_L      0x130FDE
#define REG_BK130F_6F_H      0x130FDF
#define REG_BK130F_70_L      0x130FE0
#define REG_BK130F_70_H      0x130FE1
#define REG_BK130F_71_L      0x130FE2
#define REG_BK130F_71_H      0x130FE3
#define REG_BK130F_72_L      0x130FE4
#define REG_BK130F_72_H      0x130FE5
#define REG_BK130F_73_L      0x130FE6
#define REG_BK130F_73_H      0x130FE7
#define REG_BK130F_74_L      0x130FE8
#define REG_BK130F_74_H      0x130FE9
#define REG_BK130F_75_L      0x130FEA
#define REG_BK130F_75_H      0x130FEB
#define REG_BK130F_76_L      0x130FEC
#define REG_BK130F_76_H      0x130FED
#define REG_BK130F_77_L      0x130FEE
#define REG_BK130F_77_H      0x130FEF
#define REG_BK130F_78_L      0x130FF0
#define REG_BK130F_78_H      0x130FF1
#define REG_BK130F_79_L      0x130FF2
#define REG_BK130F_79_H      0x130FF3
#define REG_BK130F_7A_L      0x130FF4
#define REG_BK130F_7A_H      0x130FF5
#define REG_BK130F_7B_L      0x130FF6
#define REG_BK130F_7B_H      0x130FF7
#define REG_BK130F_7C_L      0x130FF8
#define REG_BK130F_7C_H      0x130FF9
#define REG_BK130F_7D_L      0x130FFA
#define REG_BK130F_7D_H      0x130FFB
#define REG_BK130F_7E_L      0x130FFC
#define REG_BK130F_7E_H      0x130FFD
#define REG_BK130F_7F_L      0x130FFE
#define REG_BK130F_7F_H      0x130FFF
//----------------------------------------------
#define REG_BK1310_00_L      0x131000
#define REG_BK1310_00_H      0x131001
#define REG_BK1310_01_L      0x131002
#define REG_BK1310_01_H      0x131003
#define REG_BK1310_02_L      0x131004
#define REG_BK1310_02_H      0x131005
#define REG_BK1310_03_L      0x131006
#define REG_BK1310_03_H      0x131007
#define REG_BK1310_04_L      0x131008
#define REG_BK1310_04_H      0x131009
#define REG_BK1310_05_L      0x13100A
#define REG_BK1310_05_H      0x13100B
#define REG_BK1310_06_L      0x13100C
#define REG_BK1310_06_H      0x13100D
#define REG_BK1310_07_L      0x13100E
#define REG_BK1310_07_H      0x13100F
#define REG_BK1310_08_L      0x131010
#define REG_BK1310_08_H      0x131011
#define REG_BK1310_09_L      0x131012
#define REG_BK1310_09_H      0x131013
#define REG_BK1310_0A_L      0x131014
#define REG_BK1310_0A_H      0x131015
#define REG_BK1310_0B_L      0x131016
#define REG_BK1310_0B_H      0x131017
#define REG_BK1310_0C_L      0x131018
#define REG_BK1310_0C_H      0x131019
#define REG_BK1310_0D_L      0x13101A
#define REG_BK1310_0D_H      0x13101B
#define REG_BK1310_0E_L      0x13101C
#define REG_BK1310_0E_H      0x13101D
#define REG_BK1310_0F_L      0x13101E
#define REG_BK1310_0F_H      0x13101F
#define REG_BK1310_10_L      0x131020
#define REG_BK1310_10_H      0x131021
#define REG_BK1310_11_L      0x131022
#define REG_BK1310_11_H      0x131023
#define REG_BK1310_12_L      0x131024
#define REG_BK1310_12_H      0x131025
#define REG_BK1310_13_L      0x131026
#define REG_BK1310_13_H      0x131027
#define REG_BK1310_14_L      0x131028
#define REG_BK1310_14_H      0x131029
#define REG_BK1310_15_L      0x13102A
#define REG_BK1310_15_H      0x13102B
#define REG_BK1310_16_L      0x13102C
#define REG_BK1310_16_H      0x13102D
#define REG_BK1310_17_L      0x13102E
#define REG_BK1310_17_H      0x13102F
#define REG_BK1310_18_L      0x131030
#define REG_BK1310_18_H      0x131031
#define REG_BK1310_19_L      0x131032
#define REG_BK1310_19_H      0x131033
#define REG_BK1310_1A_L      0x131034
#define REG_BK1310_1A_H      0x131035
#define REG_BK1310_1B_L      0x131036
#define REG_BK1310_1B_H      0x131037
#define REG_BK1310_1C_L      0x131038
#define REG_BK1310_1C_H      0x131039
#define REG_BK1310_1D_L      0x13103A
#define REG_BK1310_1D_H      0x13103B
#define REG_BK1310_1E_L      0x13103C
#define REG_BK1310_1E_H      0x13103D
#define REG_BK1310_1F_L      0x13103E
#define REG_BK1310_1F_H      0x13103F
#define REG_BK1310_20_L      0x131040
#define REG_BK1310_20_H      0x131041
#define REG_BK1310_21_L      0x131042
#define REG_BK1310_21_H      0x131043
#define REG_BK1310_22_L      0x131044
#define REG_BK1310_22_H      0x131045
#define REG_BK1310_23_L      0x131046
#define REG_BK1310_23_H      0x131047
#define REG_BK1310_24_L      0x131048
#define REG_BK1310_24_H      0x131049
#define REG_BK1310_25_L      0x13104A
#define REG_BK1310_25_H      0x13104B
#define REG_BK1310_26_L      0x13104C
#define REG_BK1310_26_H      0x13104D
#define REG_BK1310_27_L      0x13104E
#define REG_BK1310_27_H      0x13104F
#define REG_BK1310_28_L      0x131050
#define REG_BK1310_28_H      0x131051
#define REG_BK1310_29_L      0x131052
#define REG_BK1310_29_H      0x131053
#define REG_BK1310_2A_L      0x131054
#define REG_BK1310_2A_H      0x131055
#define REG_BK1310_2B_L      0x131056
#define REG_BK1310_2B_H      0x131057
#define REG_BK1310_2C_L      0x131058
#define REG_BK1310_2C_H      0x131059
#define REG_BK1310_2D_L      0x13105A
#define REG_BK1310_2D_H      0x13105B
#define REG_BK1310_2E_L      0x13105C
#define REG_BK1310_2E_H      0x13105D
#define REG_BK1310_2F_L      0x13105E
#define REG_BK1310_2F_H      0x13105F
#define REG_BK1310_30_L      0x131060
#define REG_BK1310_30_H      0x131061
#define REG_BK1310_31_L      0x131062
#define REG_BK1310_31_H      0x131063
#define REG_BK1310_32_L      0x131064
#define REG_BK1310_32_H      0x131065
#define REG_BK1310_33_L      0x131066
#define REG_BK1310_33_H      0x131067
#define REG_BK1310_34_L      0x131068
#define REG_BK1310_34_H      0x131069
#define REG_BK1310_35_L      0x13106A
#define REG_BK1310_35_H      0x13106B
#define REG_BK1310_36_L      0x13106C
#define REG_BK1310_36_H      0x13106D
#define REG_BK1310_37_L      0x13106E
#define REG_BK1310_37_H      0x13106F
#define REG_BK1310_38_L      0x131070
#define REG_BK1310_38_H      0x131071
#define REG_BK1310_39_L      0x131072
#define REG_BK1310_39_H      0x131073
#define REG_BK1310_3A_L      0x131074
#define REG_BK1310_3A_H      0x131075
#define REG_BK1310_3B_L      0x131076
#define REG_BK1310_3B_H      0x131077
#define REG_BK1310_3C_L      0x131078
#define REG_BK1310_3C_H      0x131079
#define REG_BK1310_3D_L      0x13107A
#define REG_BK1310_3D_H      0x13107B
#define REG_BK1310_3E_L      0x13107C
#define REG_BK1310_3E_H      0x13107D
#define REG_BK1310_3F_L      0x13107E
#define REG_BK1310_3F_H      0x13107F
#define REG_BK1310_40_L      0x131080
#define REG_BK1310_40_H      0x131081
#define REG_BK1310_41_L      0x131082
#define REG_BK1310_41_H      0x131083
#define REG_BK1310_42_L      0x131084
#define REG_BK1310_42_H      0x131085
#define REG_BK1310_43_L      0x131086
#define REG_BK1310_43_H      0x131087
#define REG_BK1310_44_L      0x131088
#define REG_BK1310_44_H      0x131089
#define REG_BK1310_45_L      0x13108A
#define REG_BK1310_45_H      0x13108B
#define REG_BK1310_46_L      0x13108C
#define REG_BK1310_46_H      0x13108D
#define REG_BK1310_47_L      0x13108E
#define REG_BK1310_47_H      0x13108F
#define REG_BK1310_48_L      0x131090
#define REG_BK1310_48_H      0x131091
#define REG_BK1310_49_L      0x131092
#define REG_BK1310_49_H      0x131093
#define REG_BK1310_4A_L      0x131094
#define REG_BK1310_4A_H      0x131095
#define REG_BK1310_4B_L      0x131096
#define REG_BK1310_4B_H      0x131097
#define REG_BK1310_4C_L      0x131098
#define REG_BK1310_4C_H      0x131099
#define REG_BK1310_4D_L      0x13109A
#define REG_BK1310_4D_H      0x13109B
#define REG_BK1310_4E_L      0x13109C
#define REG_BK1310_4E_H      0x13109D
#define REG_BK1310_4F_L      0x13109E
#define REG_BK1310_4F_H      0x13109F
#define REG_BK1310_50_L      0x1310A0
#define REG_BK1310_50_H      0x1310A1
#define REG_BK1310_51_L      0x1310A2
#define REG_BK1310_51_H      0x1310A3
#define REG_BK1310_52_L      0x1310A4
#define REG_BK1310_52_H      0x1310A5
#define REG_BK1310_53_L      0x1310A6
#define REG_BK1310_53_H      0x1310A7
#define REG_BK1310_54_L      0x1310A8
#define REG_BK1310_54_H      0x1310A9
#define REG_BK1310_55_L      0x1310AA
#define REG_BK1310_55_H      0x1310AB
#define REG_BK1310_56_L      0x1310AC
#define REG_BK1310_56_H      0x1310AD
#define REG_BK1310_57_L      0x1310AE
#define REG_BK1310_57_H      0x1310AF
#define REG_BK1310_58_L      0x1310B0
#define REG_BK1310_58_H      0x1310B1
#define REG_BK1310_59_L      0x1310B2
#define REG_BK1310_59_H      0x1310B3
#define REG_BK1310_5A_L      0x1310B4
#define REG_BK1310_5A_H      0x1310B5
#define REG_BK1310_5B_L      0x1310B6
#define REG_BK1310_5B_H      0x1310B7
#define REG_BK1310_5C_L      0x1310B8
#define REG_BK1310_5C_H      0x1310B9
#define REG_BK1310_5D_L      0x1310BA
#define REG_BK1310_5D_H      0x1310BB
#define REG_BK1310_5E_L      0x1310BC
#define REG_BK1310_5E_H      0x1310BD
#define REG_BK1310_5F_L      0x1310BE
#define REG_BK1310_5F_H      0x1310BF
#define REG_BK1310_60_L      0x1310C0
#define REG_BK1310_60_H      0x1310C1
#define REG_BK1310_61_L      0x1310C2
#define REG_BK1310_61_H      0x1310C3
#define REG_BK1310_62_L      0x1310C4
#define REG_BK1310_62_H      0x1310C5
#define REG_BK1310_63_L      0x1310C6
#define REG_BK1310_63_H      0x1310C7
#define REG_BK1310_64_L      0x1310C8
#define REG_BK1310_64_H      0x1310C9
#define REG_BK1310_65_L      0x1310CA
#define REG_BK1310_65_H      0x1310CB
#define REG_BK1310_66_L      0x1310CC
#define REG_BK1310_66_H      0x1310CD
#define REG_BK1310_67_L      0x1310CE
#define REG_BK1310_67_H      0x1310CF
#define REG_BK1310_68_L      0x1310D0
#define REG_BK1310_68_H      0x1310D1
#define REG_BK1310_69_L      0x1310D2
#define REG_BK1310_69_H      0x1310D3
#define REG_BK1310_6A_L      0x1310D4
#define REG_BK1310_6A_H      0x1310D5
#define REG_BK1310_6B_L      0x1310D6
#define REG_BK1310_6B_H      0x1310D7
#define REG_BK1310_6C_L      0x1310D8
#define REG_BK1310_6C_H      0x1310D9
#define REG_BK1310_6D_L      0x1310DA
#define REG_BK1310_6D_H      0x1310DB
#define REG_BK1310_6E_L      0x1310DC
#define REG_BK1310_6E_H      0x1310DD
#define REG_BK1310_6F_L      0x1310DE
#define REG_BK1310_6F_H      0x1310DF
#define REG_BK1310_70_L      0x1310E0
#define REG_BK1310_70_H      0x1310E1
#define REG_BK1310_71_L      0x1310E2
#define REG_BK1310_71_H      0x1310E3
#define REG_BK1310_72_L      0x1310E4
#define REG_BK1310_72_H      0x1310E5
#define REG_BK1310_73_L      0x1310E6
#define REG_BK1310_73_H      0x1310E7
#define REG_BK1310_74_L      0x1310E8
#define REG_BK1310_74_H      0x1310E9
#define REG_BK1310_75_L      0x1310EA
#define REG_BK1310_75_H      0x1310EB
#define REG_BK1310_76_L      0x1310EC
#define REG_BK1310_76_H      0x1310ED
#define REG_BK1310_77_L      0x1310EE
#define REG_BK1310_77_H      0x1310EF
#define REG_BK1310_78_L      0x1310F0
#define REG_BK1310_78_H      0x1310F1
#define REG_BK1310_79_L      0x1310F2
#define REG_BK1310_79_H      0x1310F3
#define REG_BK1310_7A_L      0x1310F4
#define REG_BK1310_7A_H      0x1310F5
#define REG_BK1310_7B_L      0x1310F6
#define REG_BK1310_7B_H      0x1310F7
#define REG_BK1310_7C_L      0x1310F8
#define REG_BK1310_7C_H      0x1310F9
#define REG_BK1310_7D_L      0x1310FA
#define REG_BK1310_7D_H      0x1310FB
#define REG_BK1310_7E_L      0x1310FC
#define REG_BK1310_7E_H      0x1310FD
#define REG_BK1310_7F_L      0x1310FE
#define REG_BK1310_7F_H      0x1310FF
//----------------------------------------------
#define REG_BK1311_00_L      0x131100
#define REG_BK1311_00_H      0x131101
#define REG_BK1311_01_L      0x131102
#define REG_BK1311_01_H      0x131103
#define REG_BK1311_02_L      0x131104
#define REG_BK1311_02_H      0x131105
#define REG_BK1311_03_L      0x131106
#define REG_BK1311_03_H      0x131107
#define REG_BK1311_04_L      0x131108
#define REG_BK1311_04_H      0x131109
#define REG_BK1311_05_L      0x13110A
#define REG_BK1311_05_H      0x13110B
#define REG_BK1311_06_L      0x13110C
#define REG_BK1311_06_H      0x13110D
#define REG_BK1311_07_L      0x13110E
#define REG_BK1311_07_H      0x13110F
#define REG_BK1311_08_L      0x131110
#define REG_BK1311_08_H      0x131111
#define REG_BK1311_09_L      0x131112
#define REG_BK1311_09_H      0x131113
#define REG_BK1311_0A_L      0x131114
#define REG_BK1311_0A_H      0x131115
#define REG_BK1311_0B_L      0x131116
#define REG_BK1311_0B_H      0x131117
#define REG_BK1311_0C_L      0x131118
#define REG_BK1311_0C_H      0x131119
#define REG_BK1311_0D_L      0x13111A
#define REG_BK1311_0D_H      0x13111B
#define REG_BK1311_0E_L      0x13111C
#define REG_BK1311_0E_H      0x13111D
#define REG_BK1311_0F_L      0x13111E
#define REG_BK1311_0F_H      0x13111F
#define REG_BK1311_10_L      0x131120
#define REG_BK1311_10_H      0x131121
#define REG_BK1311_11_L      0x131122
#define REG_BK1311_11_H      0x131123
#define REG_BK1311_12_L      0x131124
#define REG_BK1311_12_H      0x131125
#define REG_BK1311_13_L      0x131126
#define REG_BK1311_13_H      0x131127
#define REG_BK1311_14_L      0x131128
#define REG_BK1311_14_H      0x131129
#define REG_BK1311_15_L      0x13112A
#define REG_BK1311_15_H      0x13112B
#define REG_BK1311_16_L      0x13112C
#define REG_BK1311_16_H      0x13112D
#define REG_BK1311_17_L      0x13112E
#define REG_BK1311_17_H      0x13112F
#define REG_BK1311_18_L      0x131130
#define REG_BK1311_18_H      0x131131
#define REG_BK1311_19_L      0x131132
#define REG_BK1311_19_H      0x131133
#define REG_BK1311_1A_L      0x131134
#define REG_BK1311_1A_H      0x131135
#define REG_BK1311_1B_L      0x131136
#define REG_BK1311_1B_H      0x131137
#define REG_BK1311_1C_L      0x131138
#define REG_BK1311_1C_H      0x131139
#define REG_BK1311_1D_L      0x13113A
#define REG_BK1311_1D_H      0x13113B
#define REG_BK1311_1E_L      0x13113C
#define REG_BK1311_1E_H      0x13113D
#define REG_BK1311_1F_L      0x13113E
#define REG_BK1311_1F_H      0x13113F
#define REG_BK1311_20_L      0x131140
#define REG_BK1311_20_H      0x131141
#define REG_BK1311_21_L      0x131142
#define REG_BK1311_21_H      0x131143
#define REG_BK1311_22_L      0x131144
#define REG_BK1311_22_H      0x131145
#define REG_BK1311_23_L      0x131146
#define REG_BK1311_23_H      0x131147
#define REG_BK1311_24_L      0x131148
#define REG_BK1311_24_H      0x131149
#define REG_BK1311_25_L      0x13114A
#define REG_BK1311_25_H      0x13114B
#define REG_BK1311_26_L      0x13114C
#define REG_BK1311_26_H      0x13114D
#define REG_BK1311_27_L      0x13114E
#define REG_BK1311_27_H      0x13114F
#define REG_BK1311_28_L      0x131150
#define REG_BK1311_28_H      0x131151
#define REG_BK1311_29_L      0x131152
#define REG_BK1311_29_H      0x131153
#define REG_BK1311_2A_L      0x131154
#define REG_BK1311_2A_H      0x131155
#define REG_BK1311_2B_L      0x131156
#define REG_BK1311_2B_H      0x131157
#define REG_BK1311_2C_L      0x131158
#define REG_BK1311_2C_H      0x131159
#define REG_BK1311_2D_L      0x13115A
#define REG_BK1311_2D_H      0x13115B
#define REG_BK1311_2E_L      0x13115C
#define REG_BK1311_2E_H      0x13115D
#define REG_BK1311_2F_L      0x13115E
#define REG_BK1311_2F_H      0x13115F
#define REG_BK1311_30_L      0x131160
#define REG_BK1311_30_H      0x131161
#define REG_BK1311_31_L      0x131162
#define REG_BK1311_31_H      0x131163
#define REG_BK1311_32_L      0x131164
#define REG_BK1311_32_H      0x131165
#define REG_BK1311_33_L      0x131166
#define REG_BK1311_33_H      0x131167
#define REG_BK1311_34_L      0x131168
#define REG_BK1311_34_H      0x131169
#define REG_BK1311_35_L      0x13116A
#define REG_BK1311_35_H      0x13116B
#define REG_BK1311_36_L      0x13116C
#define REG_BK1311_36_H      0x13116D
#define REG_BK1311_37_L      0x13116E
#define REG_BK1311_37_H      0x13116F
#define REG_BK1311_38_L      0x131170
#define REG_BK1311_38_H      0x131171
#define REG_BK1311_39_L      0x131172
#define REG_BK1311_39_H      0x131173
#define REG_BK1311_3A_L      0x131174
#define REG_BK1311_3A_H      0x131175
#define REG_BK1311_3B_L      0x131176
#define REG_BK1311_3B_H      0x131177
#define REG_BK1311_3C_L      0x131178
#define REG_BK1311_3C_H      0x131179
#define REG_BK1311_3D_L      0x13117A
#define REG_BK1311_3D_H      0x13117B
#define REG_BK1311_3E_L      0x13117C
#define REG_BK1311_3E_H      0x13117D
#define REG_BK1311_3F_L      0x13117E
#define REG_BK1311_3F_H      0x13117F
#define REG_BK1311_40_L      0x131180
#define REG_BK1311_40_H      0x131181
#define REG_BK1311_41_L      0x131182
#define REG_BK1311_41_H      0x131183
#define REG_BK1311_42_L      0x131184
#define REG_BK1311_42_H      0x131185
#define REG_BK1311_43_L      0x131186
#define REG_BK1311_43_H      0x131187
#define REG_BK1311_44_L      0x131188
#define REG_BK1311_44_H      0x131189
#define REG_BK1311_45_L      0x13118A
#define REG_BK1311_45_H      0x13118B
#define REG_BK1311_46_L      0x13118C
#define REG_BK1311_46_H      0x13118D
#define REG_BK1311_47_L      0x13118E
#define REG_BK1311_47_H      0x13118F
#define REG_BK1311_48_L      0x131190
#define REG_BK1311_48_H      0x131191
#define REG_BK1311_49_L      0x131192
#define REG_BK1311_49_H      0x131193
#define REG_BK1311_4A_L      0x131194
#define REG_BK1311_4A_H      0x131195
#define REG_BK1311_4B_L      0x131196
#define REG_BK1311_4B_H      0x131197
#define REG_BK1311_4C_L      0x131198
#define REG_BK1311_4C_H      0x131199
#define REG_BK1311_4D_L      0x13119A
#define REG_BK1311_4D_H      0x13119B
#define REG_BK1311_4E_L      0x13119C
#define REG_BK1311_4E_H      0x13119D
#define REG_BK1311_4F_L      0x13119E
#define REG_BK1311_4F_H      0x13119F
#define REG_BK1311_50_L      0x1311A0
#define REG_BK1311_50_H      0x1311A1
#define REG_BK1311_51_L      0x1311A2
#define REG_BK1311_51_H      0x1311A3
#define REG_BK1311_52_L      0x1311A4
#define REG_BK1311_52_H      0x1311A5
#define REG_BK1311_53_L      0x1311A6
#define REG_BK1311_53_H      0x1311A7
#define REG_BK1311_54_L      0x1311A8
#define REG_BK1311_54_H      0x1311A9
#define REG_BK1311_55_L      0x1311AA
#define REG_BK1311_55_H      0x1311AB
#define REG_BK1311_56_L      0x1311AC
#define REG_BK1311_56_H      0x1311AD
#define REG_BK1311_57_L      0x1311AE
#define REG_BK1311_57_H      0x1311AF
#define REG_BK1311_58_L      0x1311B0
#define REG_BK1311_58_H      0x1311B1
#define REG_BK1311_59_L      0x1311B2
#define REG_BK1311_59_H      0x1311B3
#define REG_BK1311_5A_L      0x1311B4
#define REG_BK1311_5A_H      0x1311B5
#define REG_BK1311_5B_L      0x1311B6
#define REG_BK1311_5B_H      0x1311B7
#define REG_BK1311_5C_L      0x1311B8
#define REG_BK1311_5C_H      0x1311B9
#define REG_BK1311_5D_L      0x1311BA
#define REG_BK1311_5D_H      0x1311BB
#define REG_BK1311_5E_L      0x1311BC
#define REG_BK1311_5E_H      0x1311BD
#define REG_BK1311_5F_L      0x1311BE
#define REG_BK1311_5F_H      0x1311BF
#define REG_BK1311_60_L      0x1311C0
#define REG_BK1311_60_H      0x1311C1
#define REG_BK1311_61_L      0x1311C2
#define REG_BK1311_61_H      0x1311C3
#define REG_BK1311_62_L      0x1311C4
#define REG_BK1311_62_H      0x1311C5
#define REG_BK1311_63_L      0x1311C6
#define REG_BK1311_63_H      0x1311C7
#define REG_BK1311_64_L      0x1311C8
#define REG_BK1311_64_H      0x1311C9
#define REG_BK1311_65_L      0x1311CA
#define REG_BK1311_65_H      0x1311CB
#define REG_BK1311_66_L      0x1311CC
#define REG_BK1311_66_H      0x1311CD
#define REG_BK1311_67_L      0x1311CE
#define REG_BK1311_67_H      0x1311CF
#define REG_BK1311_68_L      0x1311D0
#define REG_BK1311_68_H      0x1311D1
#define REG_BK1311_69_L      0x1311D2
#define REG_BK1311_69_H      0x1311D3
#define REG_BK1311_6A_L      0x1311D4
#define REG_BK1311_6A_H      0x1311D5
#define REG_BK1311_6B_L      0x1311D6
#define REG_BK1311_6B_H      0x1311D7
#define REG_BK1311_6C_L      0x1311D8
#define REG_BK1311_6C_H      0x1311D9
#define REG_BK1311_6D_L      0x1311DA
#define REG_BK1311_6D_H      0x1311DB
#define REG_BK1311_6E_L      0x1311DC
#define REG_BK1311_6E_H      0x1311DD
#define REG_BK1311_6F_L      0x1311DE
#define REG_BK1311_6F_H      0x1311DF
#define REG_BK1311_70_L      0x1311E0
#define REG_BK1311_70_H      0x1311E1
#define REG_BK1311_71_L      0x1311E2
#define REG_BK1311_71_H      0x1311E3
#define REG_BK1311_72_L      0x1311E4
#define REG_BK1311_72_H      0x1311E5
#define REG_BK1311_73_L      0x1311E6
#define REG_BK1311_73_H      0x1311E7
#define REG_BK1311_74_L      0x1311E8
#define REG_BK1311_74_H      0x1311E9
#define REG_BK1311_75_L      0x1311EA
#define REG_BK1311_75_H      0x1311EB
#define REG_BK1311_76_L      0x1311EC
#define REG_BK1311_76_H      0x1311ED
#define REG_BK1311_77_L      0x1311EE
#define REG_BK1311_77_H      0x1311EF
#define REG_BK1311_78_L      0x1311F0
#define REG_BK1311_78_H      0x1311F1
#define REG_BK1311_79_L      0x1311F2
#define REG_BK1311_79_H      0x1311F3
#define REG_BK1311_7A_L      0x1311F4
#define REG_BK1311_7A_H      0x1311F5
#define REG_BK1311_7B_L      0x1311F6
#define REG_BK1311_7B_H      0x1311F7
#define REG_BK1311_7C_L      0x1311F8
#define REG_BK1311_7C_H      0x1311F9
#define REG_BK1311_7D_L      0x1311FA
#define REG_BK1311_7D_H      0x1311FB
#define REG_BK1311_7E_L      0x1311FC
#define REG_BK1311_7E_H      0x1311FD
#define REG_BK1311_7F_L      0x1311FE
#define REG_BK1311_7F_H      0x1311FF
//----------------------------------------------
#define REG_BK1312_00_L      0x131200
#define REG_BK1312_00_H      0x131201
#define REG_BK1312_01_L      0x131202
#define REG_BK1312_01_H      0x131203
#define REG_BK1312_02_L      0x131204
#define REG_BK1312_02_H      0x131205
#define REG_BK1312_03_L      0x131206
#define REG_BK1312_03_H      0x131207
#define REG_BK1312_04_L      0x131208
#define REG_BK1312_04_H      0x131209
#define REG_BK1312_05_L      0x13120A
#define REG_BK1312_05_H      0x13120B
#define REG_BK1312_06_L      0x13120C
#define REG_BK1312_06_H      0x13120D
#define REG_BK1312_07_L      0x13120E
#define REG_BK1312_07_H      0x13120F
#define REG_BK1312_08_L      0x131210
#define REG_BK1312_08_H      0x131211
#define REG_BK1312_09_L      0x131212
#define REG_BK1312_09_H      0x131213
#define REG_BK1312_0A_L      0x131214
#define REG_BK1312_0A_H      0x131215
#define REG_BK1312_0B_L      0x131216
#define REG_BK1312_0B_H      0x131217
#define REG_BK1312_0C_L      0x131218
#define REG_BK1312_0C_H      0x131219
#define REG_BK1312_0D_L      0x13121A
#define REG_BK1312_0D_H      0x13121B
#define REG_BK1312_0E_L      0x13121C
#define REG_BK1312_0E_H      0x13121D
#define REG_BK1312_0F_L      0x13121E
#define REG_BK1312_0F_H      0x13121F
#define REG_BK1312_10_L      0x131220
#define REG_BK1312_10_H      0x131221
#define REG_BK1312_11_L      0x131222
#define REG_BK1312_11_H      0x131223
#define REG_BK1312_12_L      0x131224
#define REG_BK1312_12_H      0x131225
#define REG_BK1312_13_L      0x131226
#define REG_BK1312_13_H      0x131227
#define REG_BK1312_14_L      0x131228
#define REG_BK1312_14_H      0x131229
#define REG_BK1312_15_L      0x13122A
#define REG_BK1312_15_H      0x13122B
#define REG_BK1312_16_L      0x13122C
#define REG_BK1312_16_H      0x13122D
#define REG_BK1312_17_L      0x13122E
#define REG_BK1312_17_H      0x13122F
#define REG_BK1312_18_L      0x131230
#define REG_BK1312_18_H      0x131231
#define REG_BK1312_19_L      0x131232
#define REG_BK1312_19_H      0x131233
#define REG_BK1312_1A_L      0x131234
#define REG_BK1312_1A_H      0x131235
#define REG_BK1312_1B_L      0x131236
#define REG_BK1312_1B_H      0x131237
#define REG_BK1312_1C_L      0x131238
#define REG_BK1312_1C_H      0x131239
#define REG_BK1312_1D_L      0x13123A
#define REG_BK1312_1D_H      0x13123B
#define REG_BK1312_1E_L      0x13123C
#define REG_BK1312_1E_H      0x13123D
#define REG_BK1312_1F_L      0x13123E
#define REG_BK1312_1F_H      0x13123F
#define REG_BK1312_20_L      0x131240
#define REG_BK1312_20_H      0x131241
#define REG_BK1312_21_L      0x131242
#define REG_BK1312_21_H      0x131243
#define REG_BK1312_22_L      0x131244
#define REG_BK1312_22_H      0x131245
#define REG_BK1312_23_L      0x131246
#define REG_BK1312_23_H      0x131247
#define REG_BK1312_24_L      0x131248
#define REG_BK1312_24_H      0x131249
#define REG_BK1312_25_L      0x13124A
#define REG_BK1312_25_H      0x13124B
#define REG_BK1312_26_L      0x13124C
#define REG_BK1312_26_H      0x13124D
#define REG_BK1312_27_L      0x13124E
#define REG_BK1312_27_H      0x13124F
#define REG_BK1312_28_L      0x131250
#define REG_BK1312_28_H      0x131251
#define REG_BK1312_29_L      0x131252
#define REG_BK1312_29_H      0x131253
#define REG_BK1312_2A_L      0x131254
#define REG_BK1312_2A_H      0x131255
#define REG_BK1312_2B_L      0x131256
#define REG_BK1312_2B_H      0x131257
#define REG_BK1312_2C_L      0x131258
#define REG_BK1312_2C_H      0x131259
#define REG_BK1312_2D_L      0x13125A
#define REG_BK1312_2D_H      0x13125B
#define REG_BK1312_2E_L      0x13125C
#define REG_BK1312_2E_H      0x13125D
#define REG_BK1312_2F_L      0x13125E
#define REG_BK1312_2F_H      0x13125F
#define REG_BK1312_30_L      0x131260
#define REG_BK1312_30_H      0x131261
#define REG_BK1312_31_L      0x131262
#define REG_BK1312_31_H      0x131263
#define REG_BK1312_32_L      0x131264
#define REG_BK1312_32_H      0x131265
#define REG_BK1312_33_L      0x131266
#define REG_BK1312_33_H      0x131267
#define REG_BK1312_34_L      0x131268
#define REG_BK1312_34_H      0x131269
#define REG_BK1312_35_L      0x13126A
#define REG_BK1312_35_H      0x13126B
#define REG_BK1312_36_L      0x13126C
#define REG_BK1312_36_H      0x13126D
#define REG_BK1312_37_L      0x13126E
#define REG_BK1312_37_H      0x13126F
#define REG_BK1312_38_L      0x131270
#define REG_BK1312_38_H      0x131271
#define REG_BK1312_39_L      0x131272
#define REG_BK1312_39_H      0x131273
#define REG_BK1312_3A_L      0x131274
#define REG_BK1312_3A_H      0x131275
#define REG_BK1312_3B_L      0x131276
#define REG_BK1312_3B_H      0x131277
#define REG_BK1312_3C_L      0x131278
#define REG_BK1312_3C_H      0x131279
#define REG_BK1312_3D_L      0x13127A
#define REG_BK1312_3D_H      0x13127B
#define REG_BK1312_3E_L      0x13127C
#define REG_BK1312_3E_H      0x13127D
#define REG_BK1312_3F_L      0x13127E
#define REG_BK1312_3F_H      0x13127F
#define REG_BK1312_40_L      0x131280
#define REG_BK1312_40_H      0x131281
#define REG_BK1312_41_L      0x131282
#define REG_BK1312_41_H      0x131283
#define REG_BK1312_42_L      0x131284
#define REG_BK1312_42_H      0x131285
#define REG_BK1312_43_L      0x131286
#define REG_BK1312_43_H      0x131287
#define REG_BK1312_44_L      0x131288
#define REG_BK1312_44_H      0x131289
#define REG_BK1312_45_L      0x13128A
#define REG_BK1312_45_H      0x13128B
#define REG_BK1312_46_L      0x13128C
#define REG_BK1312_46_H      0x13128D
#define REG_BK1312_47_L      0x13128E
#define REG_BK1312_47_H      0x13128F
#define REG_BK1312_48_L      0x131290
#define REG_BK1312_48_H      0x131291
#define REG_BK1312_49_L      0x131292
#define REG_BK1312_49_H      0x131293
#define REG_BK1312_4A_L      0x131294
#define REG_BK1312_4A_H      0x131295
#define REG_BK1312_4B_L      0x131296
#define REG_BK1312_4B_H      0x131297
#define REG_BK1312_4C_L      0x131298
#define REG_BK1312_4C_H      0x131299
#define REG_BK1312_4D_L      0x13129A
#define REG_BK1312_4D_H      0x13129B
#define REG_BK1312_4E_L      0x13129C
#define REG_BK1312_4E_H      0x13129D
#define REG_BK1312_4F_L      0x13129E
#define REG_BK1312_4F_H      0x13129F
#define REG_BK1312_50_L      0x1312A0
#define REG_BK1312_50_H      0x1312A1
#define REG_BK1312_51_L      0x1312A2
#define REG_BK1312_51_H      0x1312A3
#define REG_BK1312_52_L      0x1312A4
#define REG_BK1312_52_H      0x1312A5
#define REG_BK1312_53_L      0x1312A6
#define REG_BK1312_53_H      0x1312A7
#define REG_BK1312_54_L      0x1312A8
#define REG_BK1312_54_H      0x1312A9
#define REG_BK1312_55_L      0x1312AA
#define REG_BK1312_55_H      0x1312AB
#define REG_BK1312_56_L      0x1312AC
#define REG_BK1312_56_H      0x1312AD
#define REG_BK1312_57_L      0x1312AE
#define REG_BK1312_57_H      0x1312AF
#define REG_BK1312_58_L      0x1312B0
#define REG_BK1312_58_H      0x1312B1
#define REG_BK1312_59_L      0x1312B2
#define REG_BK1312_59_H      0x1312B3
#define REG_BK1312_5A_L      0x1312B4
#define REG_BK1312_5A_H      0x1312B5
#define REG_BK1312_5B_L      0x1312B6
#define REG_BK1312_5B_H      0x1312B7
#define REG_BK1312_5C_L      0x1312B8
#define REG_BK1312_5C_H      0x1312B9
#define REG_BK1312_5D_L      0x1312BA
#define REG_BK1312_5D_H      0x1312BB
#define REG_BK1312_5E_L      0x1312BC
#define REG_BK1312_5E_H      0x1312BD
#define REG_BK1312_5F_L      0x1312BE
#define REG_BK1312_5F_H      0x1312BF
#define REG_BK1312_60_L      0x1312C0
#define REG_BK1312_60_H      0x1312C1
#define REG_BK1312_61_L      0x1312C2
#define REG_BK1312_61_H      0x1312C3
#define REG_BK1312_62_L      0x1312C4
#define REG_BK1312_62_H      0x1312C5
#define REG_BK1312_63_L      0x1312C6
#define REG_BK1312_63_H      0x1312C7
#define REG_BK1312_64_L      0x1312C8
#define REG_BK1312_64_H      0x1312C9
#define REG_BK1312_65_L      0x1312CA
#define REG_BK1312_65_H      0x1312CB
#define REG_BK1312_66_L      0x1312CC
#define REG_BK1312_66_H      0x1312CD
#define REG_BK1312_67_L      0x1312CE
#define REG_BK1312_67_H      0x1312CF
#define REG_BK1312_68_L      0x1312D0
#define REG_BK1312_68_H      0x1312D1
#define REG_BK1312_69_L      0x1312D2
#define REG_BK1312_69_H      0x1312D3
#define REG_BK1312_6A_L      0x1312D4
#define REG_BK1312_6A_H      0x1312D5
#define REG_BK1312_6B_L      0x1312D6
#define REG_BK1312_6B_H      0x1312D7
#define REG_BK1312_6C_L      0x1312D8
#define REG_BK1312_6C_H      0x1312D9
#define REG_BK1312_6D_L      0x1312DA
#define REG_BK1312_6D_H      0x1312DB
#define REG_BK1312_6E_L      0x1312DC
#define REG_BK1312_6E_H      0x1312DD
#define REG_BK1312_6F_L      0x1312DE
#define REG_BK1312_6F_H      0x1312DF
#define REG_BK1312_70_L      0x1312E0
#define REG_BK1312_70_H      0x1312E1
#define REG_BK1312_71_L      0x1312E2
#define REG_BK1312_71_H      0x1312E3
#define REG_BK1312_72_L      0x1312E4
#define REG_BK1312_72_H      0x1312E5
#define REG_BK1312_73_L      0x1312E6
#define REG_BK1312_73_H      0x1312E7
#define REG_BK1312_74_L      0x1312E8
#define REG_BK1312_74_H      0x1312E9
#define REG_BK1312_75_L      0x1312EA
#define REG_BK1312_75_H      0x1312EB
#define REG_BK1312_76_L      0x1312EC
#define REG_BK1312_76_H      0x1312ED
#define REG_BK1312_77_L      0x1312EE
#define REG_BK1312_77_H      0x1312EF
#define REG_BK1312_78_L      0x1312F0
#define REG_BK1312_78_H      0x1312F1
#define REG_BK1312_79_L      0x1312F2
#define REG_BK1312_79_H      0x1312F3
#define REG_BK1312_7A_L      0x1312F4
#define REG_BK1312_7A_H      0x1312F5
#define REG_BK1312_7B_L      0x1312F6
#define REG_BK1312_7B_H      0x1312F7
#define REG_BK1312_7C_L      0x1312F8
#define REG_BK1312_7C_H      0x1312F9
#define REG_BK1312_7D_L      0x1312FA
#define REG_BK1312_7D_H      0x1312FB
#define REG_BK1312_7E_L      0x1312FC
#define REG_BK1312_7E_H      0x1312FD
#define REG_BK1312_7F_L      0x1312FE
#define REG_BK1312_7F_H      0x1312FF
//----------------------------------------------
#define REG_BK1313_00_L      0x131300
#define REG_BK1313_00_H      0x131301
#define REG_BK1313_01_L      0x131302
#define REG_BK1313_01_H      0x131303
#define REG_BK1313_02_L      0x131304
#define REG_BK1313_02_H      0x131305
#define REG_BK1313_03_L      0x131306
#define REG_BK1313_03_H      0x131307
#define REG_BK1313_04_L      0x131308
#define REG_BK1313_04_H      0x131309
#define REG_BK1313_05_L      0x13130A
#define REG_BK1313_05_H      0x13130B
#define REG_BK1313_06_L      0x13130C
#define REG_BK1313_06_H      0x13130D
#define REG_BK1313_07_L      0x13130E
#define REG_BK1313_07_H      0x13130F
#define REG_BK1313_08_L      0x131310
#define REG_BK1313_08_H      0x131311
#define REG_BK1313_09_L      0x131312
#define REG_BK1313_09_H      0x131313
#define REG_BK1313_0A_L      0x131314
#define REG_BK1313_0A_H      0x131315
#define REG_BK1313_0B_L      0x131316
#define REG_BK1313_0B_H      0x131317
#define REG_BK1313_0C_L      0x131318
#define REG_BK1313_0C_H      0x131319
#define REG_BK1313_0D_L      0x13131A
#define REG_BK1313_0D_H      0x13131B
#define REG_BK1313_0E_L      0x13131C
#define REG_BK1313_0E_H      0x13131D
#define REG_BK1313_0F_L      0x13131E
#define REG_BK1313_0F_H      0x13131F
#define REG_BK1313_10_L      0x131320
#define REG_BK1313_10_H      0x131321
#define REG_BK1313_11_L      0x131322
#define REG_BK1313_11_H      0x131323
#define REG_BK1313_12_L      0x131324
#define REG_BK1313_12_H      0x131325
#define REG_BK1313_13_L      0x131326
#define REG_BK1313_13_H      0x131327
#define REG_BK1313_14_L      0x131328
#define REG_BK1313_14_H      0x131329
#define REG_BK1313_15_L      0x13132A
#define REG_BK1313_15_H      0x13132B
#define REG_BK1313_16_L      0x13132C
#define REG_BK1313_16_H      0x13132D
#define REG_BK1313_17_L      0x13132E
#define REG_BK1313_17_H      0x13132F
#define REG_BK1313_18_L      0x131330
#define REG_BK1313_18_H      0x131331
#define REG_BK1313_19_L      0x131332
#define REG_BK1313_19_H      0x131333
#define REG_BK1313_1A_L      0x131334
#define REG_BK1313_1A_H      0x131335
#define REG_BK1313_1B_L      0x131336
#define REG_BK1313_1B_H      0x131337
#define REG_BK1313_1C_L      0x131338
#define REG_BK1313_1C_H      0x131339
#define REG_BK1313_1D_L      0x13133A
#define REG_BK1313_1D_H      0x13133B
#define REG_BK1313_1E_L      0x13133C
#define REG_BK1313_1E_H      0x13133D
#define REG_BK1313_1F_L      0x13133E
#define REG_BK1313_1F_H      0x13133F
#define REG_BK1313_20_L      0x131340
#define REG_BK1313_20_H      0x131341
#define REG_BK1313_21_L      0x131342
#define REG_BK1313_21_H      0x131343
#define REG_BK1313_22_L      0x131344
#define REG_BK1313_22_H      0x131345
#define REG_BK1313_23_L      0x131346
#define REG_BK1313_23_H      0x131347
#define REG_BK1313_24_L      0x131348
#define REG_BK1313_24_H      0x131349
#define REG_BK1313_25_L      0x13134A
#define REG_BK1313_25_H      0x13134B
#define REG_BK1313_26_L      0x13134C
#define REG_BK1313_26_H      0x13134D
#define REG_BK1313_27_L      0x13134E
#define REG_BK1313_27_H      0x13134F
#define REG_BK1313_28_L      0x131350
#define REG_BK1313_28_H      0x131351
#define REG_BK1313_29_L      0x131352
#define REG_BK1313_29_H      0x131353
#define REG_BK1313_2A_L      0x131354
#define REG_BK1313_2A_H      0x131355
#define REG_BK1313_2B_L      0x131356
#define REG_BK1313_2B_H      0x131357
#define REG_BK1313_2C_L      0x131358
#define REG_BK1313_2C_H      0x131359
#define REG_BK1313_2D_L      0x13135A
#define REG_BK1313_2D_H      0x13135B
#define REG_BK1313_2E_L      0x13135C
#define REG_BK1313_2E_H      0x13135D
#define REG_BK1313_2F_L      0x13135E
#define REG_BK1313_2F_H      0x13135F
#define REG_BK1313_30_L      0x131360
#define REG_BK1313_30_H      0x131361
#define REG_BK1313_31_L      0x131362
#define REG_BK1313_31_H      0x131363
#define REG_BK1313_32_L      0x131364
#define REG_BK1313_32_H      0x131365
#define REG_BK1313_33_L      0x131366
#define REG_BK1313_33_H      0x131367
#define REG_BK1313_34_L      0x131368
#define REG_BK1313_34_H      0x131369
#define REG_BK1313_35_L      0x13136A
#define REG_BK1313_35_H      0x13136B
#define REG_BK1313_36_L      0x13136C
#define REG_BK1313_36_H      0x13136D
#define REG_BK1313_37_L      0x13136E
#define REG_BK1313_37_H      0x13136F
#define REG_BK1313_38_L      0x131370
#define REG_BK1313_38_H      0x131371
#define REG_BK1313_39_L      0x131372
#define REG_BK1313_39_H      0x131373
#define REG_BK1313_3A_L      0x131374
#define REG_BK1313_3A_H      0x131375
#define REG_BK1313_3B_L      0x131376
#define REG_BK1313_3B_H      0x131377
#define REG_BK1313_3C_L      0x131378
#define REG_BK1313_3C_H      0x131379
#define REG_BK1313_3D_L      0x13137A
#define REG_BK1313_3D_H      0x13137B
#define REG_BK1313_3E_L      0x13137C
#define REG_BK1313_3E_H      0x13137D
#define REG_BK1313_3F_L      0x13137E
#define REG_BK1313_3F_H      0x13137F
#define REG_BK1313_40_L      0x131380
#define REG_BK1313_40_H      0x131381
#define REG_BK1313_41_L      0x131382
#define REG_BK1313_41_H      0x131383
#define REG_BK1313_42_L      0x131384
#define REG_BK1313_42_H      0x131385
#define REG_BK1313_43_L      0x131386
#define REG_BK1313_43_H      0x131387
#define REG_BK1313_44_L      0x131388
#define REG_BK1313_44_H      0x131389
#define REG_BK1313_45_L      0x13138A
#define REG_BK1313_45_H      0x13138B
#define REG_BK1313_46_L      0x13138C
#define REG_BK1313_46_H      0x13138D
#define REG_BK1313_47_L      0x13138E
#define REG_BK1313_47_H      0x13138F
#define REG_BK1313_48_L      0x131390
#define REG_BK1313_48_H      0x131391
#define REG_BK1313_49_L      0x131392
#define REG_BK1313_49_H      0x131393
#define REG_BK1313_4A_L      0x131394
#define REG_BK1313_4A_H      0x131395
#define REG_BK1313_4B_L      0x131396
#define REG_BK1313_4B_H      0x131397
#define REG_BK1313_4C_L      0x131398
#define REG_BK1313_4C_H      0x131399
#define REG_BK1313_4D_L      0x13139A
#define REG_BK1313_4D_H      0x13139B
#define REG_BK1313_4E_L      0x13139C
#define REG_BK1313_4E_H      0x13139D
#define REG_BK1313_4F_L      0x13139E
#define REG_BK1313_4F_H      0x13139F
#define REG_BK1313_50_L      0x1313A0
#define REG_BK1313_50_H      0x1313A1
#define REG_BK1313_51_L      0x1313A2
#define REG_BK1313_51_H      0x1313A3
#define REG_BK1313_52_L      0x1313A4
#define REG_BK1313_52_H      0x1313A5
#define REG_BK1313_53_L      0x1313A6
#define REG_BK1313_53_H      0x1313A7
#define REG_BK1313_54_L      0x1313A8
#define REG_BK1313_54_H      0x1313A9
#define REG_BK1313_55_L      0x1313AA
#define REG_BK1313_55_H      0x1313AB
#define REG_BK1313_56_L      0x1313AC
#define REG_BK1313_56_H      0x1313AD
#define REG_BK1313_57_L      0x1313AE
#define REG_BK1313_57_H      0x1313AF
#define REG_BK1313_58_L      0x1313B0
#define REG_BK1313_58_H      0x1313B1
#define REG_BK1313_59_L      0x1313B2
#define REG_BK1313_59_H      0x1313B3
#define REG_BK1313_5A_L      0x1313B4
#define REG_BK1313_5A_H      0x1313B5
#define REG_BK1313_5B_L      0x1313B6
#define REG_BK1313_5B_H      0x1313B7
#define REG_BK1313_5C_L      0x1313B8
#define REG_BK1313_5C_H      0x1313B9
#define REG_BK1313_5D_L      0x1313BA
#define REG_BK1313_5D_H      0x1313BB
#define REG_BK1313_5E_L      0x1313BC
#define REG_BK1313_5E_H      0x1313BD
#define REG_BK1313_5F_L      0x1313BE
#define REG_BK1313_5F_H      0x1313BF
#define REG_BK1313_60_L      0x1313C0
#define REG_BK1313_60_H      0x1313C1
#define REG_BK1313_61_L      0x1313C2
#define REG_BK1313_61_H      0x1313C3
#define REG_BK1313_62_L      0x1313C4
#define REG_BK1313_62_H      0x1313C5
#define REG_BK1313_63_L      0x1313C6
#define REG_BK1313_63_H      0x1313C7
#define REG_BK1313_64_L      0x1313C8
#define REG_BK1313_64_H      0x1313C9
#define REG_BK1313_65_L      0x1313CA
#define REG_BK1313_65_H      0x1313CB
#define REG_BK1313_66_L      0x1313CC
#define REG_BK1313_66_H      0x1313CD
#define REG_BK1313_67_L      0x1313CE
#define REG_BK1313_67_H      0x1313CF
#define REG_BK1313_68_L      0x1313D0
#define REG_BK1313_68_H      0x1313D1
#define REG_BK1313_69_L      0x1313D2
#define REG_BK1313_69_H      0x1313D3
#define REG_BK1313_6A_L      0x1313D4
#define REG_BK1313_6A_H      0x1313D5
#define REG_BK1313_6B_L      0x1313D6
#define REG_BK1313_6B_H      0x1313D7
#define REG_BK1313_6C_L      0x1313D8
#define REG_BK1313_6C_H      0x1313D9
#define REG_BK1313_6D_L      0x1313DA
#define REG_BK1313_6D_H      0x1313DB
#define REG_BK1313_6E_L      0x1313DC
#define REG_BK1313_6E_H      0x1313DD
#define REG_BK1313_6F_L      0x1313DE
#define REG_BK1313_6F_H      0x1313DF
#define REG_BK1313_70_L      0x1313E0
#define REG_BK1313_70_H      0x1313E1
#define REG_BK1313_71_L      0x1313E2
#define REG_BK1313_71_H      0x1313E3
#define REG_BK1313_72_L      0x1313E4
#define REG_BK1313_72_H      0x1313E5
#define REG_BK1313_73_L      0x1313E6
#define REG_BK1313_73_H      0x1313E7
#define REG_BK1313_74_L      0x1313E8
#define REG_BK1313_74_H      0x1313E9
#define REG_BK1313_75_L      0x1313EA
#define REG_BK1313_75_H      0x1313EB
#define REG_BK1313_76_L      0x1313EC
#define REG_BK1313_76_H      0x1313ED
#define REG_BK1313_77_L      0x1313EE
#define REG_BK1313_77_H      0x1313EF
#define REG_BK1313_78_L      0x1313F0
#define REG_BK1313_78_H      0x1313F1
#define REG_BK1313_79_L      0x1313F2
#define REG_BK1313_79_H      0x1313F3
#define REG_BK1313_7A_L      0x1313F4
#define REG_BK1313_7A_H      0x1313F5
#define REG_BK1313_7B_L      0x1313F6
#define REG_BK1313_7B_H      0x1313F7
#define REG_BK1313_7C_L      0x1313F8
#define REG_BK1313_7C_H      0x1313F9
#define REG_BK1313_7D_L      0x1313FA
#define REG_BK1313_7D_H      0x1313FB
#define REG_BK1313_7E_L      0x1313FC
#define REG_BK1313_7E_H      0x1313FD
#define REG_BK1313_7F_L      0x1313FE
#define REG_BK1313_7F_H      0x1313FF
//----------------------------------------------
#define REG_BK1314_00_L      0x131400
#define REG_BK1314_00_H      0x131401
#define REG_BK1314_01_L      0x131402
#define REG_BK1314_01_H      0x131403
#define REG_BK1314_02_L      0x131404
#define REG_BK1314_02_H      0x131405
#define REG_BK1314_03_L      0x131406
#define REG_BK1314_03_H      0x131407
#define REG_BK1314_04_L      0x131408
#define REG_BK1314_04_H      0x131409
#define REG_BK1314_05_L      0x13140A
#define REG_BK1314_05_H      0x13140B
#define REG_BK1314_06_L      0x13140C
#define REG_BK1314_06_H      0x13140D
#define REG_BK1314_07_L      0x13140E
#define REG_BK1314_07_H      0x13140F
#define REG_BK1314_08_L      0x131410
#define REG_BK1314_08_H      0x131411
#define REG_BK1314_09_L      0x131412
#define REG_BK1314_09_H      0x131413
#define REG_BK1314_0A_L      0x131414
#define REG_BK1314_0A_H      0x131415
#define REG_BK1314_0B_L      0x131416
#define REG_BK1314_0B_H      0x131417
#define REG_BK1314_0C_L      0x131418
#define REG_BK1314_0C_H      0x131419
#define REG_BK1314_0D_L      0x13141A
#define REG_BK1314_0D_H      0x13141B
#define REG_BK1314_0E_L      0x13141C
#define REG_BK1314_0E_H      0x13141D
#define REG_BK1314_0F_L      0x13141E
#define REG_BK1314_0F_H      0x13141F
#define REG_BK1314_10_L      0x131420
#define REG_BK1314_10_H      0x131421
#define REG_BK1314_11_L      0x131422
#define REG_BK1314_11_H      0x131423
#define REG_BK1314_12_L      0x131424
#define REG_BK1314_12_H      0x131425
#define REG_BK1314_13_L      0x131426
#define REG_BK1314_13_H      0x131427
#define REG_BK1314_14_L      0x131428
#define REG_BK1314_14_H      0x131429
#define REG_BK1314_15_L      0x13142A
#define REG_BK1314_15_H      0x13142B
#define REG_BK1314_16_L      0x13142C
#define REG_BK1314_16_H      0x13142D
#define REG_BK1314_17_L      0x13142E
#define REG_BK1314_17_H      0x13142F
#define REG_BK1314_18_L      0x131430
#define REG_BK1314_18_H      0x131431
#define REG_BK1314_19_L      0x131432
#define REG_BK1314_19_H      0x131433
#define REG_BK1314_1A_L      0x131434
#define REG_BK1314_1A_H      0x131435
#define REG_BK1314_1B_L      0x131436
#define REG_BK1314_1B_H      0x131437
#define REG_BK1314_1C_L      0x131438
#define REG_BK1314_1C_H      0x131439
#define REG_BK1314_1D_L      0x13143A
#define REG_BK1314_1D_H      0x13143B
#define REG_BK1314_1E_L      0x13143C
#define REG_BK1314_1E_H      0x13143D
#define REG_BK1314_1F_L      0x13143E
#define REG_BK1314_1F_H      0x13143F
#define REG_BK1314_20_L      0x131440
#define REG_BK1314_20_H      0x131441
#define REG_BK1314_21_L      0x131442
#define REG_BK1314_21_H      0x131443
#define REG_BK1314_22_L      0x131444
#define REG_BK1314_22_H      0x131445
#define REG_BK1314_23_L      0x131446
#define REG_BK1314_23_H      0x131447
#define REG_BK1314_24_L      0x131448
#define REG_BK1314_24_H      0x131449
#define REG_BK1314_25_L      0x13144A
#define REG_BK1314_25_H      0x13144B
#define REG_BK1314_26_L      0x13144C
#define REG_BK1314_26_H      0x13144D
#define REG_BK1314_27_L      0x13144E
#define REG_BK1314_27_H      0x13144F
#define REG_BK1314_28_L      0x131450
#define REG_BK1314_28_H      0x131451
#define REG_BK1314_29_L      0x131452
#define REG_BK1314_29_H      0x131453
#define REG_BK1314_2A_L      0x131454
#define REG_BK1314_2A_H      0x131455
#define REG_BK1314_2B_L      0x131456
#define REG_BK1314_2B_H      0x131457
#define REG_BK1314_2C_L      0x131458
#define REG_BK1314_2C_H      0x131459
#define REG_BK1314_2D_L      0x13145A
#define REG_BK1314_2D_H      0x13145B
#define REG_BK1314_2E_L      0x13145C
#define REG_BK1314_2E_H      0x13145D
#define REG_BK1314_2F_L      0x13145E
#define REG_BK1314_2F_H      0x13145F
#define REG_BK1314_30_L      0x131460
#define REG_BK1314_30_H      0x131461
#define REG_BK1314_31_L      0x131462
#define REG_BK1314_31_H      0x131463
#define REG_BK1314_32_L      0x131464
#define REG_BK1314_32_H      0x131465
#define REG_BK1314_33_L      0x131466
#define REG_BK1314_33_H      0x131467
#define REG_BK1314_34_L      0x131468
#define REG_BK1314_34_H      0x131469
#define REG_BK1314_35_L      0x13146A
#define REG_BK1314_35_H      0x13146B
#define REG_BK1314_36_L      0x13146C
#define REG_BK1314_36_H      0x13146D
#define REG_BK1314_37_L      0x13146E
#define REG_BK1314_37_H      0x13146F
#define REG_BK1314_38_L      0x131470
#define REG_BK1314_38_H      0x131471
#define REG_BK1314_39_L      0x131472
#define REG_BK1314_39_H      0x131473
#define REG_BK1314_3A_L      0x131474
#define REG_BK1314_3A_H      0x131475
#define REG_BK1314_3B_L      0x131476
#define REG_BK1314_3B_H      0x131477
#define REG_BK1314_3C_L      0x131478
#define REG_BK1314_3C_H      0x131479
#define REG_BK1314_3D_L      0x13147A
#define REG_BK1314_3D_H      0x13147B
#define REG_BK1314_3E_L      0x13147C
#define REG_BK1314_3E_H      0x13147D
#define REG_BK1314_3F_L      0x13147E
#define REG_BK1314_3F_H      0x13147F
#define REG_BK1314_40_L      0x131480
#define REG_BK1314_40_H      0x131481
#define REG_BK1314_41_L      0x131482
#define REG_BK1314_41_H      0x131483
#define REG_BK1314_42_L      0x131484
#define REG_BK1314_42_H      0x131485
#define REG_BK1314_43_L      0x131486
#define REG_BK1314_43_H      0x131487
#define REG_BK1314_44_L      0x131488
#define REG_BK1314_44_H      0x131489
#define REG_BK1314_45_L      0x13148A
#define REG_BK1314_45_H      0x13148B
#define REG_BK1314_46_L      0x13148C
#define REG_BK1314_46_H      0x13148D
#define REG_BK1314_47_L      0x13148E
#define REG_BK1314_47_H      0x13148F
#define REG_BK1314_48_L      0x131490
#define REG_BK1314_48_H      0x131491
#define REG_BK1314_49_L      0x131492
#define REG_BK1314_49_H      0x131493
#define REG_BK1314_4A_L      0x131494
#define REG_BK1314_4A_H      0x131495
#define REG_BK1314_4B_L      0x131496
#define REG_BK1314_4B_H      0x131497
#define REG_BK1314_4C_L      0x131498
#define REG_BK1314_4C_H      0x131499
#define REG_BK1314_4D_L      0x13149A
#define REG_BK1314_4D_H      0x13149B
#define REG_BK1314_4E_L      0x13149C
#define REG_BK1314_4E_H      0x13149D
#define REG_BK1314_4F_L      0x13149E
#define REG_BK1314_4F_H      0x13149F
#define REG_BK1314_50_L      0x1314A0
#define REG_BK1314_50_H      0x1314A1
#define REG_BK1314_51_L      0x1314A2
#define REG_BK1314_51_H      0x1314A3
#define REG_BK1314_52_L      0x1314A4
#define REG_BK1314_52_H      0x1314A5
#define REG_BK1314_53_L      0x1314A6
#define REG_BK1314_53_H      0x1314A7
#define REG_BK1314_54_L      0x1314A8
#define REG_BK1314_54_H      0x1314A9
#define REG_BK1314_55_L      0x1314AA
#define REG_BK1314_55_H      0x1314AB
#define REG_BK1314_56_L      0x1314AC
#define REG_BK1314_56_H      0x1314AD
#define REG_BK1314_57_L      0x1314AE
#define REG_BK1314_57_H      0x1314AF
#define REG_BK1314_58_L      0x1314B0
#define REG_BK1314_58_H      0x1314B1
#define REG_BK1314_59_L      0x1314B2
#define REG_BK1314_59_H      0x1314B3
#define REG_BK1314_5A_L      0x1314B4
#define REG_BK1314_5A_H      0x1314B5
#define REG_BK1314_5B_L      0x1314B6
#define REG_BK1314_5B_H      0x1314B7
#define REG_BK1314_5C_L      0x1314B8
#define REG_BK1314_5C_H      0x1314B9
#define REG_BK1314_5D_L      0x1314BA
#define REG_BK1314_5D_H      0x1314BB
#define REG_BK1314_5E_L      0x1314BC
#define REG_BK1314_5E_H      0x1314BD
#define REG_BK1314_5F_L      0x1314BE
#define REG_BK1314_5F_H      0x1314BF
#define REG_BK1314_60_L      0x1314C0
#define REG_BK1314_60_H      0x1314C1
#define REG_BK1314_61_L      0x1314C2
#define REG_BK1314_61_H      0x1314C3
#define REG_BK1314_62_L      0x1314C4
#define REG_BK1314_62_H      0x1314C5
#define REG_BK1314_63_L      0x1314C6
#define REG_BK1314_63_H      0x1314C7
#define REG_BK1314_64_L      0x1314C8
#define REG_BK1314_64_H      0x1314C9
#define REG_BK1314_65_L      0x1314CA
#define REG_BK1314_65_H      0x1314CB
#define REG_BK1314_66_L      0x1314CC
#define REG_BK1314_66_H      0x1314CD
#define REG_BK1314_67_L      0x1314CE
#define REG_BK1314_67_H      0x1314CF
#define REG_BK1314_68_L      0x1314D0
#define REG_BK1314_68_H      0x1314D1
#define REG_BK1314_69_L      0x1314D2
#define REG_BK1314_69_H      0x1314D3
#define REG_BK1314_6A_L      0x1314D4
#define REG_BK1314_6A_H      0x1314D5
#define REG_BK1314_6B_L      0x1314D6
#define REG_BK1314_6B_H      0x1314D7
#define REG_BK1314_6C_L      0x1314D8
#define REG_BK1314_6C_H      0x1314D9
#define REG_BK1314_6D_L      0x1314DA
#define REG_BK1314_6D_H      0x1314DB
#define REG_BK1314_6E_L      0x1314DC
#define REG_BK1314_6E_H      0x1314DD
#define REG_BK1314_6F_L      0x1314DE
#define REG_BK1314_6F_H      0x1314DF
#define REG_BK1314_70_L      0x1314E0
#define REG_BK1314_70_H      0x1314E1
#define REG_BK1314_71_L      0x1314E2
#define REG_BK1314_71_H      0x1314E3
#define REG_BK1314_72_L      0x1314E4
#define REG_BK1314_72_H      0x1314E5
#define REG_BK1314_73_L      0x1314E6
#define REG_BK1314_73_H      0x1314E7
#define REG_BK1314_74_L      0x1314E8
#define REG_BK1314_74_H      0x1314E9
#define REG_BK1314_75_L      0x1314EA
#define REG_BK1314_75_H      0x1314EB
#define REG_BK1314_76_L      0x1314EC
#define REG_BK1314_76_H      0x1314ED
#define REG_BK1314_77_L      0x1314EE
#define REG_BK1314_77_H      0x1314EF
#define REG_BK1314_78_L      0x1314F0
#define REG_BK1314_78_H      0x1314F1
#define REG_BK1314_79_L      0x1314F2
#define REG_BK1314_79_H      0x1314F3
#define REG_BK1314_7A_L      0x1314F4
#define REG_BK1314_7A_H      0x1314F5
#define REG_BK1314_7B_L      0x1314F6
#define REG_BK1314_7B_H      0x1314F7
#define REG_BK1314_7C_L      0x1314F8
#define REG_BK1314_7C_H      0x1314F9
#define REG_BK1314_7D_L      0x1314FA
#define REG_BK1314_7D_H      0x1314FB
#define REG_BK1314_7E_L      0x1314FC
#define REG_BK1314_7E_H      0x1314FD
#define REG_BK1314_7F_L      0x1314FE
#define REG_BK1314_7F_H      0x1314FF
//----------------------------------------------
#define REG_BK1315_00_L      0x131500
#define REG_BK1315_00_H      0x131501
#define REG_BK1315_01_L      0x131502
#define REG_BK1315_01_H      0x131503
#define REG_BK1315_02_L      0x131504
#define REG_BK1315_02_H      0x131505
#define REG_BK1315_03_L      0x131506
#define REG_BK1315_03_H      0x131507
#define REG_BK1315_04_L      0x131508
#define REG_BK1315_04_H      0x131509
#define REG_BK1315_05_L      0x13150A
#define REG_BK1315_05_H      0x13150B
#define REG_BK1315_06_L      0x13150C
#define REG_BK1315_06_H      0x13150D
#define REG_BK1315_07_L      0x13150E
#define REG_BK1315_07_H      0x13150F
#define REG_BK1315_08_L      0x131510
#define REG_BK1315_08_H      0x131511
#define REG_BK1315_09_L      0x131512
#define REG_BK1315_09_H      0x131513
#define REG_BK1315_0A_L      0x131514
#define REG_BK1315_0A_H      0x131515
#define REG_BK1315_0B_L      0x131516
#define REG_BK1315_0B_H      0x131517
#define REG_BK1315_0C_L      0x131518
#define REG_BK1315_0C_H      0x131519
#define REG_BK1315_0D_L      0x13151A
#define REG_BK1315_0D_H      0x13151B
#define REG_BK1315_0E_L      0x13151C
#define REG_BK1315_0E_H      0x13151D
#define REG_BK1315_0F_L      0x13151E
#define REG_BK1315_0F_H      0x13151F
#define REG_BK1315_10_L      0x131520
#define REG_BK1315_10_H      0x131521
#define REG_BK1315_11_L      0x131522
#define REG_BK1315_11_H      0x131523
#define REG_BK1315_12_L      0x131524
#define REG_BK1315_12_H      0x131525
#define REG_BK1315_13_L      0x131526
#define REG_BK1315_13_H      0x131527
#define REG_BK1315_14_L      0x131528
#define REG_BK1315_14_H      0x131529
#define REG_BK1315_15_L      0x13152A
#define REG_BK1315_15_H      0x13152B
#define REG_BK1315_16_L      0x13152C
#define REG_BK1315_16_H      0x13152D
#define REG_BK1315_17_L      0x13152E
#define REG_BK1315_17_H      0x13152F
#define REG_BK1315_18_L      0x131530
#define REG_BK1315_18_H      0x131531
#define REG_BK1315_19_L      0x131532
#define REG_BK1315_19_H      0x131533
#define REG_BK1315_1A_L      0x131534
#define REG_BK1315_1A_H      0x131535
#define REG_BK1315_1B_L      0x131536
#define REG_BK1315_1B_H      0x131537
#define REG_BK1315_1C_L      0x131538
#define REG_BK1315_1C_H      0x131539
#define REG_BK1315_1D_L      0x13153A
#define REG_BK1315_1D_H      0x13153B
#define REG_BK1315_1E_L      0x13153C
#define REG_BK1315_1E_H      0x13153D
#define REG_BK1315_1F_L      0x13153E
#define REG_BK1315_1F_H      0x13153F
#define REG_BK1315_20_L      0x131540
#define REG_BK1315_20_H      0x131541
#define REG_BK1315_21_L      0x131542
#define REG_BK1315_21_H      0x131543
#define REG_BK1315_22_L      0x131544
#define REG_BK1315_22_H      0x131545
#define REG_BK1315_23_L      0x131546
#define REG_BK1315_23_H      0x131547
#define REG_BK1315_24_L      0x131548
#define REG_BK1315_24_H      0x131549
#define REG_BK1315_25_L      0x13154A
#define REG_BK1315_25_H      0x13154B
#define REG_BK1315_26_L      0x13154C
#define REG_BK1315_26_H      0x13154D
#define REG_BK1315_27_L      0x13154E
#define REG_BK1315_27_H      0x13154F
#define REG_BK1315_28_L      0x131550
#define REG_BK1315_28_H      0x131551
#define REG_BK1315_29_L      0x131552
#define REG_BK1315_29_H      0x131553
#define REG_BK1315_2A_L      0x131554
#define REG_BK1315_2A_H      0x131555
#define REG_BK1315_2B_L      0x131556
#define REG_BK1315_2B_H      0x131557
#define REG_BK1315_2C_L      0x131558
#define REG_BK1315_2C_H      0x131559
#define REG_BK1315_2D_L      0x13155A
#define REG_BK1315_2D_H      0x13155B
#define REG_BK1315_2E_L      0x13155C
#define REG_BK1315_2E_H      0x13155D
#define REG_BK1315_2F_L      0x13155E
#define REG_BK1315_2F_H      0x13155F
#define REG_BK1315_30_L      0x131560
#define REG_BK1315_30_H      0x131561
#define REG_BK1315_31_L      0x131562
#define REG_BK1315_31_H      0x131563
#define REG_BK1315_32_L      0x131564
#define REG_BK1315_32_H      0x131565
#define REG_BK1315_33_L      0x131566
#define REG_BK1315_33_H      0x131567
#define REG_BK1315_34_L      0x131568
#define REG_BK1315_34_H      0x131569
#define REG_BK1315_35_L      0x13156A
#define REG_BK1315_35_H      0x13156B
#define REG_BK1315_36_L      0x13156C
#define REG_BK1315_36_H      0x13156D
#define REG_BK1315_37_L      0x13156E
#define REG_BK1315_37_H      0x13156F
#define REG_BK1315_38_L      0x131570
#define REG_BK1315_38_H      0x131571
#define REG_BK1315_39_L      0x131572
#define REG_BK1315_39_H      0x131573
#define REG_BK1315_3A_L      0x131574
#define REG_BK1315_3A_H      0x131575
#define REG_BK1315_3B_L      0x131576
#define REG_BK1315_3B_H      0x131577
#define REG_BK1315_3C_L      0x131578
#define REG_BK1315_3C_H      0x131579
#define REG_BK1315_3D_L      0x13157A
#define REG_BK1315_3D_H      0x13157B
#define REG_BK1315_3E_L      0x13157C
#define REG_BK1315_3E_H      0x13157D
#define REG_BK1315_3F_L      0x13157E
#define REG_BK1315_3F_H      0x13157F
#define REG_BK1315_40_L      0x131580
#define REG_BK1315_40_H      0x131581
#define REG_BK1315_41_L      0x131582
#define REG_BK1315_41_H      0x131583
#define REG_BK1315_42_L      0x131584
#define REG_BK1315_42_H      0x131585
#define REG_BK1315_43_L      0x131586
#define REG_BK1315_43_H      0x131587
#define REG_BK1315_44_L      0x131588
#define REG_BK1315_44_H      0x131589
#define REG_BK1315_45_L      0x13158A
#define REG_BK1315_45_H      0x13158B
#define REG_BK1315_46_L      0x13158C
#define REG_BK1315_46_H      0x13158D
#define REG_BK1315_47_L      0x13158E
#define REG_BK1315_47_H      0x13158F
#define REG_BK1315_48_L      0x131590
#define REG_BK1315_48_H      0x131591
#define REG_BK1315_49_L      0x131592
#define REG_BK1315_49_H      0x131593
#define REG_BK1315_4A_L      0x131594
#define REG_BK1315_4A_H      0x131595
#define REG_BK1315_4B_L      0x131596
#define REG_BK1315_4B_H      0x131597
#define REG_BK1315_4C_L      0x131598
#define REG_BK1315_4C_H      0x131599
#define REG_BK1315_4D_L      0x13159A
#define REG_BK1315_4D_H      0x13159B
#define REG_BK1315_4E_L      0x13159C
#define REG_BK1315_4E_H      0x13159D
#define REG_BK1315_4F_L      0x13159E
#define REG_BK1315_4F_H      0x13159F
#define REG_BK1315_50_L      0x1315A0
#define REG_BK1315_50_H      0x1315A1
#define REG_BK1315_51_L      0x1315A2
#define REG_BK1315_51_H      0x1315A3
#define REG_BK1315_52_L      0x1315A4
#define REG_BK1315_52_H      0x1315A5
#define REG_BK1315_53_L      0x1315A6
#define REG_BK1315_53_H      0x1315A7
#define REG_BK1315_54_L      0x1315A8
#define REG_BK1315_54_H      0x1315A9
#define REG_BK1315_55_L      0x1315AA
#define REG_BK1315_55_H      0x1315AB
#define REG_BK1315_56_L      0x1315AC
#define REG_BK1315_56_H      0x1315AD
#define REG_BK1315_57_L      0x1315AE
#define REG_BK1315_57_H      0x1315AF
#define REG_BK1315_58_L      0x1315B0
#define REG_BK1315_58_H      0x1315B1
#define REG_BK1315_59_L      0x1315B2
#define REG_BK1315_59_H      0x1315B3
#define REG_BK1315_5A_L      0x1315B4
#define REG_BK1315_5A_H      0x1315B5
#define REG_BK1315_5B_L      0x1315B6
#define REG_BK1315_5B_H      0x1315B7
#define REG_BK1315_5C_L      0x1315B8
#define REG_BK1315_5C_H      0x1315B9
#define REG_BK1315_5D_L      0x1315BA
#define REG_BK1315_5D_H      0x1315BB
#define REG_BK1315_5E_L      0x1315BC
#define REG_BK1315_5E_H      0x1315BD
#define REG_BK1315_5F_L      0x1315BE
#define REG_BK1315_5F_H      0x1315BF
#define REG_BK1315_60_L      0x1315C0
#define REG_BK1315_60_H      0x1315C1
#define REG_BK1315_61_L      0x1315C2
#define REG_BK1315_61_H      0x1315C3
#define REG_BK1315_62_L      0x1315C4
#define REG_BK1315_62_H      0x1315C5
#define REG_BK1315_63_L      0x1315C6
#define REG_BK1315_63_H      0x1315C7
#define REG_BK1315_64_L      0x1315C8
#define REG_BK1315_64_H      0x1315C9
#define REG_BK1315_65_L      0x1315CA
#define REG_BK1315_65_H      0x1315CB
#define REG_BK1315_66_L      0x1315CC
#define REG_BK1315_66_H      0x1315CD
#define REG_BK1315_67_L      0x1315CE
#define REG_BK1315_67_H      0x1315CF
#define REG_BK1315_68_L      0x1315D0
#define REG_BK1315_68_H      0x1315D1
#define REG_BK1315_69_L      0x1315D2
#define REG_BK1315_69_H      0x1315D3
#define REG_BK1315_6A_L      0x1315D4
#define REG_BK1315_6A_H      0x1315D5
#define REG_BK1315_6B_L      0x1315D6
#define REG_BK1315_6B_H      0x1315D7
#define REG_BK1315_6C_L      0x1315D8
#define REG_BK1315_6C_H      0x1315D9
#define REG_BK1315_6D_L      0x1315DA
#define REG_BK1315_6D_H      0x1315DB
#define REG_BK1315_6E_L      0x1315DC
#define REG_BK1315_6E_H      0x1315DD
#define REG_BK1315_6F_L      0x1315DE
#define REG_BK1315_6F_H      0x1315DF
#define REG_BK1315_70_L      0x1315E0
#define REG_BK1315_70_H      0x1315E1
#define REG_BK1315_71_L      0x1315E2
#define REG_BK1315_71_H      0x1315E3
#define REG_BK1315_72_L      0x1315E4
#define REG_BK1315_72_H      0x1315E5
#define REG_BK1315_73_L      0x1315E6
#define REG_BK1315_73_H      0x1315E7
#define REG_BK1315_74_L      0x1315E8
#define REG_BK1315_74_H      0x1315E9
#define REG_BK1315_75_L      0x1315EA
#define REG_BK1315_75_H      0x1315EB
#define REG_BK1315_76_L      0x1315EC
#define REG_BK1315_76_H      0x1315ED
#define REG_BK1315_77_L      0x1315EE
#define REG_BK1315_77_H      0x1315EF
#define REG_BK1315_78_L      0x1315F0
#define REG_BK1315_78_H      0x1315F1
#define REG_BK1315_79_L      0x1315F2
#define REG_BK1315_79_H      0x1315F3
#define REG_BK1315_7A_L      0x1315F4
#define REG_BK1315_7A_H      0x1315F5
#define REG_BK1315_7B_L      0x1315F6
#define REG_BK1315_7B_H      0x1315F7
#define REG_BK1315_7C_L      0x1315F8
#define REG_BK1315_7C_H      0x1315F9
#define REG_BK1315_7D_L      0x1315FA
#define REG_BK1315_7D_H      0x1315FB
#define REG_BK1315_7E_L      0x1315FC
#define REG_BK1315_7E_H      0x1315FD
#define REG_BK1315_7F_L      0x1315FE
#define REG_BK1315_7F_H      0x1315FF
//----------------------------------------------
#define REG_BK1316_00_L      0x131600
#define REG_BK1316_00_H      0x131601
#define REG_BK1316_01_L      0x131602
#define REG_BK1316_01_H      0x131603
#define REG_BK1316_02_L      0x131604
#define REG_BK1316_02_H      0x131605
#define REG_BK1316_03_L      0x131606
#define REG_BK1316_03_H      0x131607
#define REG_BK1316_04_L      0x131608
#define REG_BK1316_04_H      0x131609
#define REG_BK1316_05_L      0x13160A
#define REG_BK1316_05_H      0x13160B
#define REG_BK1316_06_L      0x13160C
#define REG_BK1316_06_H      0x13160D
#define REG_BK1316_07_L      0x13160E
#define REG_BK1316_07_H      0x13160F
#define REG_BK1316_08_L      0x131610
#define REG_BK1316_08_H      0x131611
#define REG_BK1316_09_L      0x131612
#define REG_BK1316_09_H      0x131613
#define REG_BK1316_0A_L      0x131614
#define REG_BK1316_0A_H      0x131615
#define REG_BK1316_0B_L      0x131616
#define REG_BK1316_0B_H      0x131617
#define REG_BK1316_0C_L      0x131618
#define REG_BK1316_0C_H      0x131619
#define REG_BK1316_0D_L      0x13161A
#define REG_BK1316_0D_H      0x13161B
#define REG_BK1316_0E_L      0x13161C
#define REG_BK1316_0E_H      0x13161D
#define REG_BK1316_0F_L      0x13161E
#define REG_BK1316_0F_H      0x13161F
#define REG_BK1316_10_L      0x131620
#define REG_BK1316_10_H      0x131621
#define REG_BK1316_11_L      0x131622
#define REG_BK1316_11_H      0x131623
#define REG_BK1316_12_L      0x131624
#define REG_BK1316_12_H      0x131625
#define REG_BK1316_13_L      0x131626
#define REG_BK1316_13_H      0x131627
#define REG_BK1316_14_L      0x131628
#define REG_BK1316_14_H      0x131629
#define REG_BK1316_15_L      0x13162A
#define REG_BK1316_15_H      0x13162B
#define REG_BK1316_16_L      0x13162C
#define REG_BK1316_16_H      0x13162D
#define REG_BK1316_17_L      0x13162E
#define REG_BK1316_17_H      0x13162F
#define REG_BK1316_18_L      0x131630
#define REG_BK1316_18_H      0x131631
#define REG_BK1316_19_L      0x131632
#define REG_BK1316_19_H      0x131633
#define REG_BK1316_1A_L      0x131634
#define REG_BK1316_1A_H      0x131635
#define REG_BK1316_1B_L      0x131636
#define REG_BK1316_1B_H      0x131637
#define REG_BK1316_1C_L      0x131638
#define REG_BK1316_1C_H      0x131639
#define REG_BK1316_1D_L      0x13163A
#define REG_BK1316_1D_H      0x13163B
#define REG_BK1316_1E_L      0x13163C
#define REG_BK1316_1E_H      0x13163D
#define REG_BK1316_1F_L      0x13163E
#define REG_BK1316_1F_H      0x13163F
#define REG_BK1316_20_L      0x131640
#define REG_BK1316_20_H      0x131641
#define REG_BK1316_21_L      0x131642
#define REG_BK1316_21_H      0x131643
#define REG_BK1316_22_L      0x131644
#define REG_BK1316_22_H      0x131645
#define REG_BK1316_23_L      0x131646
#define REG_BK1316_23_H      0x131647
#define REG_BK1316_24_L      0x131648
#define REG_BK1316_24_H      0x131649
#define REG_BK1316_25_L      0x13164A
#define REG_BK1316_25_H      0x13164B
#define REG_BK1316_26_L      0x13164C
#define REG_BK1316_26_H      0x13164D
#define REG_BK1316_27_L      0x13164E
#define REG_BK1316_27_H      0x13164F
#define REG_BK1316_28_L      0x131650
#define REG_BK1316_28_H      0x131651
#define REG_BK1316_29_L      0x131652
#define REG_BK1316_29_H      0x131653
#define REG_BK1316_2A_L      0x131654
#define REG_BK1316_2A_H      0x131655
#define REG_BK1316_2B_L      0x131656
#define REG_BK1316_2B_H      0x131657
#define REG_BK1316_2C_L      0x131658
#define REG_BK1316_2C_H      0x131659
#define REG_BK1316_2D_L      0x13165A
#define REG_BK1316_2D_H      0x13165B
#define REG_BK1316_2E_L      0x13165C
#define REG_BK1316_2E_H      0x13165D
#define REG_BK1316_2F_L      0x13165E
#define REG_BK1316_2F_H      0x13165F
#define REG_BK1316_30_L      0x131660
#define REG_BK1316_30_H      0x131661
#define REG_BK1316_31_L      0x131662
#define REG_BK1316_31_H      0x131663
#define REG_BK1316_32_L      0x131664
#define REG_BK1316_32_H      0x131665
#define REG_BK1316_33_L      0x131666
#define REG_BK1316_33_H      0x131667
#define REG_BK1316_34_L      0x131668
#define REG_BK1316_34_H      0x131669
#define REG_BK1316_35_L      0x13166A
#define REG_BK1316_35_H      0x13166B
#define REG_BK1316_36_L      0x13166C
#define REG_BK1316_36_H      0x13166D
#define REG_BK1316_37_L      0x13166E
#define REG_BK1316_37_H      0x13166F
#define REG_BK1316_38_L      0x131670
#define REG_BK1316_38_H      0x131671
#define REG_BK1316_39_L      0x131672
#define REG_BK1316_39_H      0x131673
#define REG_BK1316_3A_L      0x131674
#define REG_BK1316_3A_H      0x131675
#define REG_BK1316_3B_L      0x131676
#define REG_BK1316_3B_H      0x131677
#define REG_BK1316_3C_L      0x131678
#define REG_BK1316_3C_H      0x131679
#define REG_BK1316_3D_L      0x13167A
#define REG_BK1316_3D_H      0x13167B
#define REG_BK1316_3E_L      0x13167C
#define REG_BK1316_3E_H      0x13167D
#define REG_BK1316_3F_L      0x13167E
#define REG_BK1316_3F_H      0x13167F
#define REG_BK1316_40_L      0x131680
#define REG_BK1316_40_H      0x131681
#define REG_BK1316_41_L      0x131682
#define REG_BK1316_41_H      0x131683
#define REG_BK1316_42_L      0x131684
#define REG_BK1316_42_H      0x131685
#define REG_BK1316_43_L      0x131686
#define REG_BK1316_43_H      0x131687
#define REG_BK1316_44_L      0x131688
#define REG_BK1316_44_H      0x131689
#define REG_BK1316_45_L      0x13168A
#define REG_BK1316_45_H      0x13168B
#define REG_BK1316_46_L      0x13168C
#define REG_BK1316_46_H      0x13168D
#define REG_BK1316_47_L      0x13168E
#define REG_BK1316_47_H      0x13168F
#define REG_BK1316_48_L      0x131690
#define REG_BK1316_48_H      0x131691
#define REG_BK1316_49_L      0x131692
#define REG_BK1316_49_H      0x131693
#define REG_BK1316_4A_L      0x131694
#define REG_BK1316_4A_H      0x131695
#define REG_BK1316_4B_L      0x131696
#define REG_BK1316_4B_H      0x131697
#define REG_BK1316_4C_L      0x131698
#define REG_BK1316_4C_H      0x131699
#define REG_BK1316_4D_L      0x13169A
#define REG_BK1316_4D_H      0x13169B
#define REG_BK1316_4E_L      0x13169C
#define REG_BK1316_4E_H      0x13169D
#define REG_BK1316_4F_L      0x13169E
#define REG_BK1316_4F_H      0x13169F
#define REG_BK1316_50_L      0x1316A0
#define REG_BK1316_50_H      0x1316A1
#define REG_BK1316_51_L      0x1316A2
#define REG_BK1316_51_H      0x1316A3
#define REG_BK1316_52_L      0x1316A4
#define REG_BK1316_52_H      0x1316A5
#define REG_BK1316_53_L      0x1316A6
#define REG_BK1316_53_H      0x1316A7
#define REG_BK1316_54_L      0x1316A8
#define REG_BK1316_54_H      0x1316A9
#define REG_BK1316_55_L      0x1316AA
#define REG_BK1316_55_H      0x1316AB
#define REG_BK1316_56_L      0x1316AC
#define REG_BK1316_56_H      0x1316AD
#define REG_BK1316_57_L      0x1316AE
#define REG_BK1316_57_H      0x1316AF
#define REG_BK1316_58_L      0x1316B0
#define REG_BK1316_58_H      0x1316B1
#define REG_BK1316_59_L      0x1316B2
#define REG_BK1316_59_H      0x1316B3
#define REG_BK1316_5A_L      0x1316B4
#define REG_BK1316_5A_H      0x1316B5
#define REG_BK1316_5B_L      0x1316B6
#define REG_BK1316_5B_H      0x1316B7
#define REG_BK1316_5C_L      0x1316B8
#define REG_BK1316_5C_H      0x1316B9
#define REG_BK1316_5D_L      0x1316BA
#define REG_BK1316_5D_H      0x1316BB
#define REG_BK1316_5E_L      0x1316BC
#define REG_BK1316_5E_H      0x1316BD
#define REG_BK1316_5F_L      0x1316BE
#define REG_BK1316_5F_H      0x1316BF
#define REG_BK1316_60_L      0x1316C0
#define REG_BK1316_60_H      0x1316C1
#define REG_BK1316_61_L      0x1316C2
#define REG_BK1316_61_H      0x1316C3
#define REG_BK1316_62_L      0x1316C4
#define REG_BK1316_62_H      0x1316C5
#define REG_BK1316_63_L      0x1316C6
#define REG_BK1316_63_H      0x1316C7
#define REG_BK1316_64_L      0x1316C8
#define REG_BK1316_64_H      0x1316C9
#define REG_BK1316_65_L      0x1316CA
#define REG_BK1316_65_H      0x1316CB
#define REG_BK1316_66_L      0x1316CC
#define REG_BK1316_66_H      0x1316CD
#define REG_BK1316_67_L      0x1316CE
#define REG_BK1316_67_H      0x1316CF
#define REG_BK1316_68_L      0x1316D0
#define REG_BK1316_68_H      0x1316D1
#define REG_BK1316_69_L      0x1316D2
#define REG_BK1316_69_H      0x1316D3
#define REG_BK1316_6A_L      0x1316D4
#define REG_BK1316_6A_H      0x1316D5
#define REG_BK1316_6B_L      0x1316D6
#define REG_BK1316_6B_H      0x1316D7
#define REG_BK1316_6C_L      0x1316D8
#define REG_BK1316_6C_H      0x1316D9
#define REG_BK1316_6D_L      0x1316DA
#define REG_BK1316_6D_H      0x1316DB
#define REG_BK1316_6E_L      0x1316DC
#define REG_BK1316_6E_H      0x1316DD
#define REG_BK1316_6F_L      0x1316DE
#define REG_BK1316_6F_H      0x1316DF
#define REG_BK1316_70_L      0x1316E0
#define REG_BK1316_70_H      0x1316E1
#define REG_BK1316_71_L      0x1316E2
#define REG_BK1316_71_H      0x1316E3
#define REG_BK1316_72_L      0x1316E4
#define REG_BK1316_72_H      0x1316E5
#define REG_BK1316_73_L      0x1316E6
#define REG_BK1316_73_H      0x1316E7
#define REG_BK1316_74_L      0x1316E8
#define REG_BK1316_74_H      0x1316E9
#define REG_BK1316_75_L      0x1316EA
#define REG_BK1316_75_H      0x1316EB
#define REG_BK1316_76_L      0x1316EC
#define REG_BK1316_76_H      0x1316ED
#define REG_BK1316_77_L      0x1316EE
#define REG_BK1316_77_H      0x1316EF
#define REG_BK1316_78_L      0x1316F0
#define REG_BK1316_78_H      0x1316F1
#define REG_BK1316_79_L      0x1316F2
#define REG_BK1316_79_H      0x1316F3
#define REG_BK1316_7A_L      0x1316F4
#define REG_BK1316_7A_H      0x1316F5
#define REG_BK1316_7B_L      0x1316F6
#define REG_BK1316_7B_H      0x1316F7
#define REG_BK1316_7C_L      0x1316F8
#define REG_BK1316_7C_H      0x1316F9
#define REG_BK1316_7D_L      0x1316FA
#define REG_BK1316_7D_H      0x1316FB
#define REG_BK1316_7E_L      0x1316FC
#define REG_BK1316_7E_H      0x1316FD
#define REG_BK1316_7F_L      0x1316FE
#define REG_BK1316_7F_H      0x1316FF
//----------------------------------------------
#define REG_BK1317_00_L      0x131700
#define REG_BK1317_00_H      0x131701
#define REG_BK1317_01_L      0x131702
#define REG_BK1317_01_H      0x131703
#define REG_BK1317_02_L      0x131704
#define REG_BK1317_02_H      0x131705
#define REG_BK1317_03_L      0x131706
#define REG_BK1317_03_H      0x131707
#define REG_BK1317_04_L      0x131708
#define REG_BK1317_04_H      0x131709
#define REG_BK1317_05_L      0x13170A
#define REG_BK1317_05_H      0x13170B
#define REG_BK1317_06_L      0x13170C
#define REG_BK1317_06_H      0x13170D
#define REG_BK1317_07_L      0x13170E
#define REG_BK1317_07_H      0x13170F
#define REG_BK1317_08_L      0x131710
#define REG_BK1317_08_H      0x131711
#define REG_BK1317_09_L      0x131712
#define REG_BK1317_09_H      0x131713
#define REG_BK1317_0A_L      0x131714
#define REG_BK1317_0A_H      0x131715
#define REG_BK1317_0B_L      0x131716
#define REG_BK1317_0B_H      0x131717
#define REG_BK1317_0C_L      0x131718
#define REG_BK1317_0C_H      0x131719
#define REG_BK1317_0D_L      0x13171A
#define REG_BK1317_0D_H      0x13171B
#define REG_BK1317_0E_L      0x13171C
#define REG_BK1317_0E_H      0x13171D
#define REG_BK1317_0F_L      0x13171E
#define REG_BK1317_0F_H      0x13171F
#define REG_BK1317_10_L      0x131720
#define REG_BK1317_10_H      0x131721
#define REG_BK1317_11_L      0x131722
#define REG_BK1317_11_H      0x131723
#define REG_BK1317_12_L      0x131724
#define REG_BK1317_12_H      0x131725
#define REG_BK1317_13_L      0x131726
#define REG_BK1317_13_H      0x131727
#define REG_BK1317_14_L      0x131728
#define REG_BK1317_14_H      0x131729
#define REG_BK1317_15_L      0x13172A
#define REG_BK1317_15_H      0x13172B
#define REG_BK1317_16_L      0x13172C
#define REG_BK1317_16_H      0x13172D
#define REG_BK1317_17_L      0x13172E
#define REG_BK1317_17_H      0x13172F
#define REG_BK1317_18_L      0x131730
#define REG_BK1317_18_H      0x131731
#define REG_BK1317_19_L      0x131732
#define REG_BK1317_19_H      0x131733
#define REG_BK1317_1A_L      0x131734
#define REG_BK1317_1A_H      0x131735
#define REG_BK1317_1B_L      0x131736
#define REG_BK1317_1B_H      0x131737
#define REG_BK1317_1C_L      0x131738
#define REG_BK1317_1C_H      0x131739
#define REG_BK1317_1D_L      0x13173A
#define REG_BK1317_1D_H      0x13173B
#define REG_BK1317_1E_L      0x13173C
#define REG_BK1317_1E_H      0x13173D
#define REG_BK1317_1F_L      0x13173E
#define REG_BK1317_1F_H      0x13173F
#define REG_BK1317_20_L      0x131740
#define REG_BK1317_20_H      0x131741
#define REG_BK1317_21_L      0x131742
#define REG_BK1317_21_H      0x131743
#define REG_BK1317_22_L      0x131744
#define REG_BK1317_22_H      0x131745
#define REG_BK1317_23_L      0x131746
#define REG_BK1317_23_H      0x131747
#define REG_BK1317_24_L      0x131748
#define REG_BK1317_24_H      0x131749
#define REG_BK1317_25_L      0x13174A
#define REG_BK1317_25_H      0x13174B
#define REG_BK1317_26_L      0x13174C
#define REG_BK1317_26_H      0x13174D
#define REG_BK1317_27_L      0x13174E
#define REG_BK1317_27_H      0x13174F
#define REG_BK1317_28_L      0x131750
#define REG_BK1317_28_H      0x131751
#define REG_BK1317_29_L      0x131752
#define REG_BK1317_29_H      0x131753
#define REG_BK1317_2A_L      0x131754
#define REG_BK1317_2A_H      0x131755
#define REG_BK1317_2B_L      0x131756
#define REG_BK1317_2B_H      0x131757
#define REG_BK1317_2C_L      0x131758
#define REG_BK1317_2C_H      0x131759
#define REG_BK1317_2D_L      0x13175A
#define REG_BK1317_2D_H      0x13175B
#define REG_BK1317_2E_L      0x13175C
#define REG_BK1317_2E_H      0x13175D
#define REG_BK1317_2F_L      0x13175E
#define REG_BK1317_2F_H      0x13175F
#define REG_BK1317_30_L      0x131760
#define REG_BK1317_30_H      0x131761
#define REG_BK1317_31_L      0x131762
#define REG_BK1317_31_H      0x131763
#define REG_BK1317_32_L      0x131764
#define REG_BK1317_32_H      0x131765
#define REG_BK1317_33_L      0x131766
#define REG_BK1317_33_H      0x131767
#define REG_BK1317_34_L      0x131768
#define REG_BK1317_34_H      0x131769
#define REG_BK1317_35_L      0x13176A
#define REG_BK1317_35_H      0x13176B
#define REG_BK1317_36_L      0x13176C
#define REG_BK1317_36_H      0x13176D
#define REG_BK1317_37_L      0x13176E
#define REG_BK1317_37_H      0x13176F
#define REG_BK1317_38_L      0x131770
#define REG_BK1317_38_H      0x131771
#define REG_BK1317_39_L      0x131772
#define REG_BK1317_39_H      0x131773
#define REG_BK1317_3A_L      0x131774
#define REG_BK1317_3A_H      0x131775
#define REG_BK1317_3B_L      0x131776
#define REG_BK1317_3B_H      0x131777
#define REG_BK1317_3C_L      0x131778
#define REG_BK1317_3C_H      0x131779
#define REG_BK1317_3D_L      0x13177A
#define REG_BK1317_3D_H      0x13177B
#define REG_BK1317_3E_L      0x13177C
#define REG_BK1317_3E_H      0x13177D
#define REG_BK1317_3F_L      0x13177E
#define REG_BK1317_3F_H      0x13177F
#define REG_BK1317_40_L      0x131780
#define REG_BK1317_40_H      0x131781
#define REG_BK1317_41_L      0x131782
#define REG_BK1317_41_H      0x131783
#define REG_BK1317_42_L      0x131784
#define REG_BK1317_42_H      0x131785
#define REG_BK1317_43_L      0x131786
#define REG_BK1317_43_H      0x131787
#define REG_BK1317_44_L      0x131788
#define REG_BK1317_44_H      0x131789
#define REG_BK1317_45_L      0x13178A
#define REG_BK1317_45_H      0x13178B
#define REG_BK1317_46_L      0x13178C
#define REG_BK1317_46_H      0x13178D
#define REG_BK1317_47_L      0x13178E
#define REG_BK1317_47_H      0x13178F
#define REG_BK1317_48_L      0x131790
#define REG_BK1317_48_H      0x131791
#define REG_BK1317_49_L      0x131792
#define REG_BK1317_49_H      0x131793
#define REG_BK1317_4A_L      0x131794
#define REG_BK1317_4A_H      0x131795
#define REG_BK1317_4B_L      0x131796
#define REG_BK1317_4B_H      0x131797
#define REG_BK1317_4C_L      0x131798
#define REG_BK1317_4C_H      0x131799
#define REG_BK1317_4D_L      0x13179A
#define REG_BK1317_4D_H      0x13179B
#define REG_BK1317_4E_L      0x13179C
#define REG_BK1317_4E_H      0x13179D
#define REG_BK1317_4F_L      0x13179E
#define REG_BK1317_4F_H      0x13179F
#define REG_BK1317_50_L      0x1317A0
#define REG_BK1317_50_H      0x1317A1
#define REG_BK1317_51_L      0x1317A2
#define REG_BK1317_51_H      0x1317A3
#define REG_BK1317_52_L      0x1317A4
#define REG_BK1317_52_H      0x1317A5
#define REG_BK1317_53_L      0x1317A6
#define REG_BK1317_53_H      0x1317A7
#define REG_BK1317_54_L      0x1317A8
#define REG_BK1317_54_H      0x1317A9
#define REG_BK1317_55_L      0x1317AA
#define REG_BK1317_55_H      0x1317AB
#define REG_BK1317_56_L      0x1317AC
#define REG_BK1317_56_H      0x1317AD
#define REG_BK1317_57_L      0x1317AE
#define REG_BK1317_57_H      0x1317AF
#define REG_BK1317_58_L      0x1317B0
#define REG_BK1317_58_H      0x1317B1
#define REG_BK1317_59_L      0x1317B2
#define REG_BK1317_59_H      0x1317B3
#define REG_BK1317_5A_L      0x1317B4
#define REG_BK1317_5A_H      0x1317B5
#define REG_BK1317_5B_L      0x1317B6
#define REG_BK1317_5B_H      0x1317B7
#define REG_BK1317_5C_L      0x1317B8
#define REG_BK1317_5C_H      0x1317B9
#define REG_BK1317_5D_L      0x1317BA
#define REG_BK1317_5D_H      0x1317BB
#define REG_BK1317_5E_L      0x1317BC
#define REG_BK1317_5E_H      0x1317BD
#define REG_BK1317_5F_L      0x1317BE
#define REG_BK1317_5F_H      0x1317BF
#define REG_BK1317_60_L      0x1317C0
#define REG_BK1317_60_H      0x1317C1
#define REG_BK1317_61_L      0x1317C2
#define REG_BK1317_61_H      0x1317C3
#define REG_BK1317_62_L      0x1317C4
#define REG_BK1317_62_H      0x1317C5
#define REG_BK1317_63_L      0x1317C6
#define REG_BK1317_63_H      0x1317C7
#define REG_BK1317_64_L      0x1317C8
#define REG_BK1317_64_H      0x1317C9
#define REG_BK1317_65_L      0x1317CA
#define REG_BK1317_65_H      0x1317CB
#define REG_BK1317_66_L      0x1317CC
#define REG_BK1317_66_H      0x1317CD
#define REG_BK1317_67_L      0x1317CE
#define REG_BK1317_67_H      0x1317CF
#define REG_BK1317_68_L      0x1317D0
#define REG_BK1317_68_H      0x1317D1
#define REG_BK1317_69_L      0x1317D2
#define REG_BK1317_69_H      0x1317D3
#define REG_BK1317_6A_L      0x1317D4
#define REG_BK1317_6A_H      0x1317D5
#define REG_BK1317_6B_L      0x1317D6
#define REG_BK1317_6B_H      0x1317D7
#define REG_BK1317_6C_L      0x1317D8
#define REG_BK1317_6C_H      0x1317D9
#define REG_BK1317_6D_L      0x1317DA
#define REG_BK1317_6D_H      0x1317DB
#define REG_BK1317_6E_L      0x1317DC
#define REG_BK1317_6E_H      0x1317DD
#define REG_BK1317_6F_L      0x1317DE
#define REG_BK1317_6F_H      0x1317DF
#define REG_BK1317_70_L      0x1317E0
#define REG_BK1317_70_H      0x1317E1
#define REG_BK1317_71_L      0x1317E2
#define REG_BK1317_71_H      0x1317E3
#define REG_BK1317_72_L      0x1317E4
#define REG_BK1317_72_H      0x1317E5
#define REG_BK1317_73_L      0x1317E6
#define REG_BK1317_73_H      0x1317E7
#define REG_BK1317_74_L      0x1317E8
#define REG_BK1317_74_H      0x1317E9
#define REG_BK1317_75_L      0x1317EA
#define REG_BK1317_75_H      0x1317EB
#define REG_BK1317_76_L      0x1317EC
#define REG_BK1317_76_H      0x1317ED
#define REG_BK1317_77_L      0x1317EE
#define REG_BK1317_77_H      0x1317EF
#define REG_BK1317_78_L      0x1317F0
#define REG_BK1317_78_H      0x1317F1
#define REG_BK1317_79_L      0x1317F2
#define REG_BK1317_79_H      0x1317F3
#define REG_BK1317_7A_L      0x1317F4
#define REG_BK1317_7A_H      0x1317F5
#define REG_BK1317_7B_L      0x1317F6
#define REG_BK1317_7B_H      0x1317F7
#define REG_BK1317_7C_L      0x1317F8
#define REG_BK1317_7C_H      0x1317F9
#define REG_BK1317_7D_L      0x1317FA
#define REG_BK1317_7D_H      0x1317FB
#define REG_BK1317_7E_L      0x1317FC
#define REG_BK1317_7E_H      0x1317FD
#define REG_BK1317_7F_L      0x1317FE
#define REG_BK1317_7F_H      0x1317FF
//----------------------------------------------
#define REG_BK1318_00_L      0x131800
#define REG_BK1318_00_H      0x131801
#define REG_BK1318_01_L      0x131802
#define REG_BK1318_01_H      0x131803
#define REG_BK1318_02_L      0x131804
#define REG_BK1318_02_H      0x131805
#define REG_BK1318_03_L      0x131806
#define REG_BK1318_03_H      0x131807
#define REG_BK1318_04_L      0x131808
#define REG_BK1318_04_H      0x131809
#define REG_BK1318_05_L      0x13180A
#define REG_BK1318_05_H      0x13180B
#define REG_BK1318_06_L      0x13180C
#define REG_BK1318_06_H      0x13180D
#define REG_BK1318_07_L      0x13180E
#define REG_BK1318_07_H      0x13180F
#define REG_BK1318_08_L      0x131810
#define REG_BK1318_08_H      0x131811
#define REG_BK1318_09_L      0x131812
#define REG_BK1318_09_H      0x131813
#define REG_BK1318_0A_L      0x131814
#define REG_BK1318_0A_H      0x131815
#define REG_BK1318_0B_L      0x131816
#define REG_BK1318_0B_H      0x131817
#define REG_BK1318_0C_L      0x131818
#define REG_BK1318_0C_H      0x131819
#define REG_BK1318_0D_L      0x13181A
#define REG_BK1318_0D_H      0x13181B
#define REG_BK1318_0E_L      0x13181C
#define REG_BK1318_0E_H      0x13181D
#define REG_BK1318_0F_L      0x13181E
#define REG_BK1318_0F_H      0x13181F
#define REG_BK1318_10_L      0x131820
#define REG_BK1318_10_H      0x131821
#define REG_BK1318_11_L      0x131822
#define REG_BK1318_11_H      0x131823
#define REG_BK1318_12_L      0x131824
#define REG_BK1318_12_H      0x131825
#define REG_BK1318_13_L      0x131826
#define REG_BK1318_13_H      0x131827
#define REG_BK1318_14_L      0x131828
#define REG_BK1318_14_H      0x131829
#define REG_BK1318_15_L      0x13182A
#define REG_BK1318_15_H      0x13182B
#define REG_BK1318_16_L      0x13182C
#define REG_BK1318_16_H      0x13182D
#define REG_BK1318_17_L      0x13182E
#define REG_BK1318_17_H      0x13182F
#define REG_BK1318_18_L      0x131830
#define REG_BK1318_18_H      0x131831
#define REG_BK1318_19_L      0x131832
#define REG_BK1318_19_H      0x131833
#define REG_BK1318_1A_L      0x131834
#define REG_BK1318_1A_H      0x131835
#define REG_BK1318_1B_L      0x131836
#define REG_BK1318_1B_H      0x131837
#define REG_BK1318_1C_L      0x131838
#define REG_BK1318_1C_H      0x131839
#define REG_BK1318_1D_L      0x13183A
#define REG_BK1318_1D_H      0x13183B
#define REG_BK1318_1E_L      0x13183C
#define REG_BK1318_1E_H      0x13183D
#define REG_BK1318_1F_L      0x13183E
#define REG_BK1318_1F_H      0x13183F
#define REG_BK1318_20_L      0x131840
#define REG_BK1318_20_H      0x131841
#define REG_BK1318_21_L      0x131842
#define REG_BK1318_21_H      0x131843
#define REG_BK1318_22_L      0x131844
#define REG_BK1318_22_H      0x131845
#define REG_BK1318_23_L      0x131846
#define REG_BK1318_23_H      0x131847
#define REG_BK1318_24_L      0x131848
#define REG_BK1318_24_H      0x131849
#define REG_BK1318_25_L      0x13184A
#define REG_BK1318_25_H      0x13184B
#define REG_BK1318_26_L      0x13184C
#define REG_BK1318_26_H      0x13184D
#define REG_BK1318_27_L      0x13184E
#define REG_BK1318_27_H      0x13184F
#define REG_BK1318_28_L      0x131850
#define REG_BK1318_28_H      0x131851
#define REG_BK1318_29_L      0x131852
#define REG_BK1318_29_H      0x131853
#define REG_BK1318_2A_L      0x131854
#define REG_BK1318_2A_H      0x131855
#define REG_BK1318_2B_L      0x131856
#define REG_BK1318_2B_H      0x131857
#define REG_BK1318_2C_L      0x131858
#define REG_BK1318_2C_H      0x131859
#define REG_BK1318_2D_L      0x13185A
#define REG_BK1318_2D_H      0x13185B
#define REG_BK1318_2E_L      0x13185C
#define REG_BK1318_2E_H      0x13185D
#define REG_BK1318_2F_L      0x13185E
#define REG_BK1318_2F_H      0x13185F
#define REG_BK1318_30_L      0x131860
#define REG_BK1318_30_H      0x131861
#define REG_BK1318_31_L      0x131862
#define REG_BK1318_31_H      0x131863
#define REG_BK1318_32_L      0x131864
#define REG_BK1318_32_H      0x131865
#define REG_BK1318_33_L      0x131866
#define REG_BK1318_33_H      0x131867
#define REG_BK1318_34_L      0x131868
#define REG_BK1318_34_H      0x131869
#define REG_BK1318_35_L      0x13186A
#define REG_BK1318_35_H      0x13186B
#define REG_BK1318_36_L      0x13186C
#define REG_BK1318_36_H      0x13186D
#define REG_BK1318_37_L      0x13186E
#define REG_BK1318_37_H      0x13186F
#define REG_BK1318_38_L      0x131870
#define REG_BK1318_38_H      0x131871
#define REG_BK1318_39_L      0x131872
#define REG_BK1318_39_H      0x131873
#define REG_BK1318_3A_L      0x131874
#define REG_BK1318_3A_H      0x131875
#define REG_BK1318_3B_L      0x131876
#define REG_BK1318_3B_H      0x131877
#define REG_BK1318_3C_L      0x131878
#define REG_BK1318_3C_H      0x131879
#define REG_BK1318_3D_L      0x13187A
#define REG_BK1318_3D_H      0x13187B
#define REG_BK1318_3E_L      0x13187C
#define REG_BK1318_3E_H      0x13187D
#define REG_BK1318_3F_L      0x13187E
#define REG_BK1318_3F_H      0x13187F
#define REG_BK1318_40_L      0x131880
#define REG_BK1318_40_H      0x131881
#define REG_BK1318_41_L      0x131882
#define REG_BK1318_41_H      0x131883
#define REG_BK1318_42_L      0x131884
#define REG_BK1318_42_H      0x131885
#define REG_BK1318_43_L      0x131886
#define REG_BK1318_43_H      0x131887
#define REG_BK1318_44_L      0x131888
#define REG_BK1318_44_H      0x131889
#define REG_BK1318_45_L      0x13188A
#define REG_BK1318_45_H      0x13188B
#define REG_BK1318_46_L      0x13188C
#define REG_BK1318_46_H      0x13188D
#define REG_BK1318_47_L      0x13188E
#define REG_BK1318_47_H      0x13188F
#define REG_BK1318_48_L      0x131890
#define REG_BK1318_48_H      0x131891
#define REG_BK1318_49_L      0x131892
#define REG_BK1318_49_H      0x131893
#define REG_BK1318_4A_L      0x131894
#define REG_BK1318_4A_H      0x131895
#define REG_BK1318_4B_L      0x131896
#define REG_BK1318_4B_H      0x131897
#define REG_BK1318_4C_L      0x131898
#define REG_BK1318_4C_H      0x131899
#define REG_BK1318_4D_L      0x13189A
#define REG_BK1318_4D_H      0x13189B
#define REG_BK1318_4E_L      0x13189C
#define REG_BK1318_4E_H      0x13189D
#define REG_BK1318_4F_L      0x13189E
#define REG_BK1318_4F_H      0x13189F
#define REG_BK1318_50_L      0x1318A0
#define REG_BK1318_50_H      0x1318A1
#define REG_BK1318_51_L      0x1318A2
#define REG_BK1318_51_H      0x1318A3
#define REG_BK1318_52_L      0x1318A4
#define REG_BK1318_52_H      0x1318A5
#define REG_BK1318_53_L      0x1318A6
#define REG_BK1318_53_H      0x1318A7
#define REG_BK1318_54_L      0x1318A8
#define REG_BK1318_54_H      0x1318A9
#define REG_BK1318_55_L      0x1318AA
#define REG_BK1318_55_H      0x1318AB
#define REG_BK1318_56_L      0x1318AC
#define REG_BK1318_56_H      0x1318AD
#define REG_BK1318_57_L      0x1318AE
#define REG_BK1318_57_H      0x1318AF
#define REG_BK1318_58_L      0x1318B0
#define REG_BK1318_58_H      0x1318B1
#define REG_BK1318_59_L      0x1318B2
#define REG_BK1318_59_H      0x1318B3
#define REG_BK1318_5A_L      0x1318B4
#define REG_BK1318_5A_H      0x1318B5
#define REG_BK1318_5B_L      0x1318B6
#define REG_BK1318_5B_H      0x1318B7
#define REG_BK1318_5C_L      0x1318B8
#define REG_BK1318_5C_H      0x1318B9
#define REG_BK1318_5D_L      0x1318BA
#define REG_BK1318_5D_H      0x1318BB
#define REG_BK1318_5E_L      0x1318BC
#define REG_BK1318_5E_H      0x1318BD
#define REG_BK1318_5F_L      0x1318BE
#define REG_BK1318_5F_H      0x1318BF
#define REG_BK1318_60_L      0x1318C0
#define REG_BK1318_60_H      0x1318C1
#define REG_BK1318_61_L      0x1318C2
#define REG_BK1318_61_H      0x1318C3
#define REG_BK1318_62_L      0x1318C4
#define REG_BK1318_62_H      0x1318C5
#define REG_BK1318_63_L      0x1318C6
#define REG_BK1318_63_H      0x1318C7
#define REG_BK1318_64_L      0x1318C8
#define REG_BK1318_64_H      0x1318C9
#define REG_BK1318_65_L      0x1318CA
#define REG_BK1318_65_H      0x1318CB
#define REG_BK1318_66_L      0x1318CC
#define REG_BK1318_66_H      0x1318CD
#define REG_BK1318_67_L      0x1318CE
#define REG_BK1318_67_H      0x1318CF
#define REG_BK1318_68_L      0x1318D0
#define REG_BK1318_68_H      0x1318D1
#define REG_BK1318_69_L      0x1318D2
#define REG_BK1318_69_H      0x1318D3
#define REG_BK1318_6A_L      0x1318D4
#define REG_BK1318_6A_H      0x1318D5
#define REG_BK1318_6B_L      0x1318D6
#define REG_BK1318_6B_H      0x1318D7
#define REG_BK1318_6C_L      0x1318D8
#define REG_BK1318_6C_H      0x1318D9
#define REG_BK1318_6D_L      0x1318DA
#define REG_BK1318_6D_H      0x1318DB
#define REG_BK1318_6E_L      0x1318DC
#define REG_BK1318_6E_H      0x1318DD
#define REG_BK1318_6F_L      0x1318DE
#define REG_BK1318_6F_H      0x1318DF
#define REG_BK1318_70_L      0x1318E0
#define REG_BK1318_70_H      0x1318E1
#define REG_BK1318_71_L      0x1318E2
#define REG_BK1318_71_H      0x1318E3
#define REG_BK1318_72_L      0x1318E4
#define REG_BK1318_72_H      0x1318E5
#define REG_BK1318_73_L      0x1318E6
#define REG_BK1318_73_H      0x1318E7
#define REG_BK1318_74_L      0x1318E8
#define REG_BK1318_74_H      0x1318E9
#define REG_BK1318_75_L      0x1318EA
#define REG_BK1318_75_H      0x1318EB
#define REG_BK1318_76_L      0x1318EC
#define REG_BK1318_76_H      0x1318ED
#define REG_BK1318_77_L      0x1318EE
#define REG_BK1318_77_H      0x1318EF
#define REG_BK1318_78_L      0x1318F0
#define REG_BK1318_78_H      0x1318F1
#define REG_BK1318_79_L      0x1318F2
#define REG_BK1318_79_H      0x1318F3
#define REG_BK1318_7A_L      0x1318F4
#define REG_BK1318_7A_H      0x1318F5
#define REG_BK1318_7B_L      0x1318F6
#define REG_BK1318_7B_H      0x1318F7
#define REG_BK1318_7C_L      0x1318F8
#define REG_BK1318_7C_H      0x1318F9
#define REG_BK1318_7D_L      0x1318FA
#define REG_BK1318_7D_H      0x1318FB
#define REG_BK1318_7E_L      0x1318FC
#define REG_BK1318_7E_H      0x1318FD
#define REG_BK1318_7F_L      0x1318FE
#define REG_BK1318_7F_H      0x1318FF
//----------------------------------------------
#define REG_BK1319_00_L      0x131900
#define REG_BK1319_00_H      0x131901
#define REG_BK1319_01_L      0x131902
#define REG_BK1319_01_H      0x131903
#define REG_BK1319_02_L      0x131904
#define REG_BK1319_02_H      0x131905
#define REG_BK1319_03_L      0x131906
#define REG_BK1319_03_H      0x131907
#define REG_BK1319_04_L      0x131908
#define REG_BK1319_04_H      0x131909
#define REG_BK1319_05_L      0x13190A
#define REG_BK1319_05_H      0x13190B
#define REG_BK1319_06_L      0x13190C
#define REG_BK1319_06_H      0x13190D
#define REG_BK1319_07_L      0x13190E
#define REG_BK1319_07_H      0x13190F
#define REG_BK1319_08_L      0x131910
#define REG_BK1319_08_H      0x131911
#define REG_BK1319_09_L      0x131912
#define REG_BK1319_09_H      0x131913
#define REG_BK1319_0A_L      0x131914
#define REG_BK1319_0A_H      0x131915
#define REG_BK1319_0B_L      0x131916
#define REG_BK1319_0B_H      0x131917
#define REG_BK1319_0C_L      0x131918
#define REG_BK1319_0C_H      0x131919
#define REG_BK1319_0D_L      0x13191A
#define REG_BK1319_0D_H      0x13191B
#define REG_BK1319_0E_L      0x13191C
#define REG_BK1319_0E_H      0x13191D
#define REG_BK1319_0F_L      0x13191E
#define REG_BK1319_0F_H      0x13191F
#define REG_BK1319_10_L      0x131920
#define REG_BK1319_10_H      0x131921
#define REG_BK1319_11_L      0x131922
#define REG_BK1319_11_H      0x131923
#define REG_BK1319_12_L      0x131924
#define REG_BK1319_12_H      0x131925
#define REG_BK1319_13_L      0x131926
#define REG_BK1319_13_H      0x131927
#define REG_BK1319_14_L      0x131928
#define REG_BK1319_14_H      0x131929
#define REG_BK1319_15_L      0x13192A
#define REG_BK1319_15_H      0x13192B
#define REG_BK1319_16_L      0x13192C
#define REG_BK1319_16_H      0x13192D
#define REG_BK1319_17_L      0x13192E
#define REG_BK1319_17_H      0x13192F
#define REG_BK1319_18_L      0x131930
#define REG_BK1319_18_H      0x131931
#define REG_BK1319_19_L      0x131932
#define REG_BK1319_19_H      0x131933
#define REG_BK1319_1A_L      0x131934
#define REG_BK1319_1A_H      0x131935
#define REG_BK1319_1B_L      0x131936
#define REG_BK1319_1B_H      0x131937
#define REG_BK1319_1C_L      0x131938
#define REG_BK1319_1C_H      0x131939
#define REG_BK1319_1D_L      0x13193A
#define REG_BK1319_1D_H      0x13193B
#define REG_BK1319_1E_L      0x13193C
#define REG_BK1319_1E_H      0x13193D
#define REG_BK1319_1F_L      0x13193E
#define REG_BK1319_1F_H      0x13193F
#define REG_BK1319_20_L      0x131940
#define REG_BK1319_20_H      0x131941
#define REG_BK1319_21_L      0x131942
#define REG_BK1319_21_H      0x131943
#define REG_BK1319_22_L      0x131944
#define REG_BK1319_22_H      0x131945
#define REG_BK1319_23_L      0x131946
#define REG_BK1319_23_H      0x131947
#define REG_BK1319_24_L      0x131948
#define REG_BK1319_24_H      0x131949
#define REG_BK1319_25_L      0x13194A
#define REG_BK1319_25_H      0x13194B
#define REG_BK1319_26_L      0x13194C
#define REG_BK1319_26_H      0x13194D
#define REG_BK1319_27_L      0x13194E
#define REG_BK1319_27_H      0x13194F
#define REG_BK1319_28_L      0x131950
#define REG_BK1319_28_H      0x131951
#define REG_BK1319_29_L      0x131952
#define REG_BK1319_29_H      0x131953
#define REG_BK1319_2A_L      0x131954
#define REG_BK1319_2A_H      0x131955
#define REG_BK1319_2B_L      0x131956
#define REG_BK1319_2B_H      0x131957
#define REG_BK1319_2C_L      0x131958
#define REG_BK1319_2C_H      0x131959
#define REG_BK1319_2D_L      0x13195A
#define REG_BK1319_2D_H      0x13195B
#define REG_BK1319_2E_L      0x13195C
#define REG_BK1319_2E_H      0x13195D
#define REG_BK1319_2F_L      0x13195E
#define REG_BK1319_2F_H      0x13195F
#define REG_BK1319_30_L      0x131960
#define REG_BK1319_30_H      0x131961
#define REG_BK1319_31_L      0x131962
#define REG_BK1319_31_H      0x131963
#define REG_BK1319_32_L      0x131964
#define REG_BK1319_32_H      0x131965
#define REG_BK1319_33_L      0x131966
#define REG_BK1319_33_H      0x131967
#define REG_BK1319_34_L      0x131968
#define REG_BK1319_34_H      0x131969
#define REG_BK1319_35_L      0x13196A
#define REG_BK1319_35_H      0x13196B
#define REG_BK1319_36_L      0x13196C
#define REG_BK1319_36_H      0x13196D
#define REG_BK1319_37_L      0x13196E
#define REG_BK1319_37_H      0x13196F
#define REG_BK1319_38_L      0x131970
#define REG_BK1319_38_H      0x131971
#define REG_BK1319_39_L      0x131972
#define REG_BK1319_39_H      0x131973
#define REG_BK1319_3A_L      0x131974
#define REG_BK1319_3A_H      0x131975
#define REG_BK1319_3B_L      0x131976
#define REG_BK1319_3B_H      0x131977
#define REG_BK1319_3C_L      0x131978
#define REG_BK1319_3C_H      0x131979
#define REG_BK1319_3D_L      0x13197A
#define REG_BK1319_3D_H      0x13197B
#define REG_BK1319_3E_L      0x13197C
#define REG_BK1319_3E_H      0x13197D
#define REG_BK1319_3F_L      0x13197E
#define REG_BK1319_3F_H      0x13197F
#define REG_BK1319_40_L      0x131980
#define REG_BK1319_40_H      0x131981
#define REG_BK1319_41_L      0x131982
#define REG_BK1319_41_H      0x131983
#define REG_BK1319_42_L      0x131984
#define REG_BK1319_42_H      0x131985
#define REG_BK1319_43_L      0x131986
#define REG_BK1319_43_H      0x131987
#define REG_BK1319_44_L      0x131988
#define REG_BK1319_44_H      0x131989
#define REG_BK1319_45_L      0x13198A
#define REG_BK1319_45_H      0x13198B
#define REG_BK1319_46_L      0x13198C
#define REG_BK1319_46_H      0x13198D
#define REG_BK1319_47_L      0x13198E
#define REG_BK1319_47_H      0x13198F
#define REG_BK1319_48_L      0x131990
#define REG_BK1319_48_H      0x131991
#define REG_BK1319_49_L      0x131992
#define REG_BK1319_49_H      0x131993
#define REG_BK1319_4A_L      0x131994
#define REG_BK1319_4A_H      0x131995
#define REG_BK1319_4B_L      0x131996
#define REG_BK1319_4B_H      0x131997
#define REG_BK1319_4C_L      0x131998
#define REG_BK1319_4C_H      0x131999
#define REG_BK1319_4D_L      0x13199A
#define REG_BK1319_4D_H      0x13199B
#define REG_BK1319_4E_L      0x13199C
#define REG_BK1319_4E_H      0x13199D
#define REG_BK1319_4F_L      0x13199E
#define REG_BK1319_4F_H      0x13199F
#define REG_BK1319_50_L      0x1319A0
#define REG_BK1319_50_H      0x1319A1
#define REG_BK1319_51_L      0x1319A2
#define REG_BK1319_51_H      0x1319A3
#define REG_BK1319_52_L      0x1319A4
#define REG_BK1319_52_H      0x1319A5
#define REG_BK1319_53_L      0x1319A6
#define REG_BK1319_53_H      0x1319A7
#define REG_BK1319_54_L      0x1319A8
#define REG_BK1319_54_H      0x1319A9
#define REG_BK1319_55_L      0x1319AA
#define REG_BK1319_55_H      0x1319AB
#define REG_BK1319_56_L      0x1319AC
#define REG_BK1319_56_H      0x1319AD
#define REG_BK1319_57_L      0x1319AE
#define REG_BK1319_57_H      0x1319AF
#define REG_BK1319_58_L      0x1319B0
#define REG_BK1319_58_H      0x1319B1
#define REG_BK1319_59_L      0x1319B2
#define REG_BK1319_59_H      0x1319B3
#define REG_BK1319_5A_L      0x1319B4
#define REG_BK1319_5A_H      0x1319B5
#define REG_BK1319_5B_L      0x1319B6
#define REG_BK1319_5B_H      0x1319B7
#define REG_BK1319_5C_L      0x1319B8
#define REG_BK1319_5C_H      0x1319B9
#define REG_BK1319_5D_L      0x1319BA
#define REG_BK1319_5D_H      0x1319BB
#define REG_BK1319_5E_L      0x1319BC
#define REG_BK1319_5E_H      0x1319BD
#define REG_BK1319_5F_L      0x1319BE
#define REG_BK1319_5F_H      0x1319BF
#define REG_BK1319_60_L      0x1319C0
#define REG_BK1319_60_H      0x1319C1
#define REG_BK1319_61_L      0x1319C2
#define REG_BK1319_61_H      0x1319C3
#define REG_BK1319_62_L      0x1319C4
#define REG_BK1319_62_H      0x1319C5
#define REG_BK1319_63_L      0x1319C6
#define REG_BK1319_63_H      0x1319C7
#define REG_BK1319_64_L      0x1319C8
#define REG_BK1319_64_H      0x1319C9
#define REG_BK1319_65_L      0x1319CA
#define REG_BK1319_65_H      0x1319CB
#define REG_BK1319_66_L      0x1319CC
#define REG_BK1319_66_H      0x1319CD
#define REG_BK1319_67_L      0x1319CE
#define REG_BK1319_67_H      0x1319CF
#define REG_BK1319_68_L      0x1319D0
#define REG_BK1319_68_H      0x1319D1
#define REG_BK1319_69_L      0x1319D2
#define REG_BK1319_69_H      0x1319D3
#define REG_BK1319_6A_L      0x1319D4
#define REG_BK1319_6A_H      0x1319D5
#define REG_BK1319_6B_L      0x1319D6
#define REG_BK1319_6B_H      0x1319D7
#define REG_BK1319_6C_L      0x1319D8
#define REG_BK1319_6C_H      0x1319D9
#define REG_BK1319_6D_L      0x1319DA
#define REG_BK1319_6D_H      0x1319DB
#define REG_BK1319_6E_L      0x1319DC
#define REG_BK1319_6E_H      0x1319DD
#define REG_BK1319_6F_L      0x1319DE
#define REG_BK1319_6F_H      0x1319DF
#define REG_BK1319_70_L      0x1319E0
#define REG_BK1319_70_H      0x1319E1
#define REG_BK1319_71_L      0x1319E2
#define REG_BK1319_71_H      0x1319E3
#define REG_BK1319_72_L      0x1319E4
#define REG_BK1319_72_H      0x1319E5
#define REG_BK1319_73_L      0x1319E6
#define REG_BK1319_73_H      0x1319E7
#define REG_BK1319_74_L      0x1319E8
#define REG_BK1319_74_H      0x1319E9
#define REG_BK1319_75_L      0x1319EA
#define REG_BK1319_75_H      0x1319EB
#define REG_BK1319_76_L      0x1319EC
#define REG_BK1319_76_H      0x1319ED
#define REG_BK1319_77_L      0x1319EE
#define REG_BK1319_77_H      0x1319EF
#define REG_BK1319_78_L      0x1319F0
#define REG_BK1319_78_H      0x1319F1
#define REG_BK1319_79_L      0x1319F2
#define REG_BK1319_79_H      0x1319F3
#define REG_BK1319_7A_L      0x1319F4
#define REG_BK1319_7A_H      0x1319F5
#define REG_BK1319_7B_L      0x1319F6
#define REG_BK1319_7B_H      0x1319F7
#define REG_BK1319_7C_L      0x1319F8
#define REG_BK1319_7C_H      0x1319F9
#define REG_BK1319_7D_L      0x1319FA
#define REG_BK1319_7D_H      0x1319FB
#define REG_BK1319_7E_L      0x1319FC
#define REG_BK1319_7E_H      0x1319FD
#define REG_BK1319_7F_L      0x1319FE
#define REG_BK1319_7F_H      0x1319FF
//----------------------------------------------
#define REG_BK131A_00_L      0x131A00
#define REG_BK131A_00_H      0x131A01
#define REG_BK131A_01_L      0x131A02
#define REG_BK131A_01_H      0x131A03
#define REG_BK131A_02_L      0x131A04
#define REG_BK131A_02_H      0x131A05
#define REG_BK131A_03_L      0x131A06
#define REG_BK131A_03_H      0x131A07
#define REG_BK131A_04_L      0x131A08
#define REG_BK131A_04_H      0x131A09
#define REG_BK131A_05_L      0x131A0A
#define REG_BK131A_05_H      0x131A0B
#define REG_BK131A_06_L      0x131A0C
#define REG_BK131A_06_H      0x131A0D
#define REG_BK131A_07_L      0x131A0E
#define REG_BK131A_07_H      0x131A0F
#define REG_BK131A_08_L      0x131A10
#define REG_BK131A_08_H      0x131A11
#define REG_BK131A_09_L      0x131A12
#define REG_BK131A_09_H      0x131A13
#define REG_BK131A_0A_L      0x131A14
#define REG_BK131A_0A_H      0x131A15
#define REG_BK131A_0B_L      0x131A16
#define REG_BK131A_0B_H      0x131A17
#define REG_BK131A_0C_L      0x131A18
#define REG_BK131A_0C_H      0x131A19
#define REG_BK131A_0D_L      0x131A1A
#define REG_BK131A_0D_H      0x131A1B
#define REG_BK131A_0E_L      0x131A1C
#define REG_BK131A_0E_H      0x131A1D
#define REG_BK131A_0F_L      0x131A1E
#define REG_BK131A_0F_H      0x131A1F
#define REG_BK131A_10_L      0x131A20
#define REG_BK131A_10_H      0x131A21
#define REG_BK131A_11_L      0x131A22
#define REG_BK131A_11_H      0x131A23
#define REG_BK131A_12_L      0x131A24
#define REG_BK131A_12_H      0x131A25
#define REG_BK131A_13_L      0x131A26
#define REG_BK131A_13_H      0x131A27
#define REG_BK131A_14_L      0x131A28
#define REG_BK131A_14_H      0x131A29
#define REG_BK131A_15_L      0x131A2A
#define REG_BK131A_15_H      0x131A2B
#define REG_BK131A_16_L      0x131A2C
#define REG_BK131A_16_H      0x131A2D
#define REG_BK131A_17_L      0x131A2E
#define REG_BK131A_17_H      0x131A2F
#define REG_BK131A_18_L      0x131A30
#define REG_BK131A_18_H      0x131A31
#define REG_BK131A_19_L      0x131A32
#define REG_BK131A_19_H      0x131A33
#define REG_BK131A_1A_L      0x131A34
#define REG_BK131A_1A_H      0x131A35
#define REG_BK131A_1B_L      0x131A36
#define REG_BK131A_1B_H      0x131A37
#define REG_BK131A_1C_L      0x131A38
#define REG_BK131A_1C_H      0x131A39
#define REG_BK131A_1D_L      0x131A3A
#define REG_BK131A_1D_H      0x131A3B
#define REG_BK131A_1E_L      0x131A3C
#define REG_BK131A_1E_H      0x131A3D
#define REG_BK131A_1F_L      0x131A3E
#define REG_BK131A_1F_H      0x131A3F
#define REG_BK131A_20_L      0x131A40
#define REG_BK131A_20_H      0x131A41
#define REG_BK131A_21_L      0x131A42
#define REG_BK131A_21_H      0x131A43
#define REG_BK131A_22_L      0x131A44
#define REG_BK131A_22_H      0x131A45
#define REG_BK131A_23_L      0x131A46
#define REG_BK131A_23_H      0x131A47
#define REG_BK131A_24_L      0x131A48
#define REG_BK131A_24_H      0x131A49
#define REG_BK131A_25_L      0x131A4A
#define REG_BK131A_25_H      0x131A4B
#define REG_BK131A_26_L      0x131A4C
#define REG_BK131A_26_H      0x131A4D
#define REG_BK131A_27_L      0x131A4E
#define REG_BK131A_27_H      0x131A4F
#define REG_BK131A_28_L      0x131A50
#define REG_BK131A_28_H      0x131A51
#define REG_BK131A_29_L      0x131A52
#define REG_BK131A_29_H      0x131A53
#define REG_BK131A_2A_L      0x131A54
#define REG_BK131A_2A_H      0x131A55
#define REG_BK131A_2B_L      0x131A56
#define REG_BK131A_2B_H      0x131A57
#define REG_BK131A_2C_L      0x131A58
#define REG_BK131A_2C_H      0x131A59
#define REG_BK131A_2D_L      0x131A5A
#define REG_BK131A_2D_H      0x131A5B
#define REG_BK131A_2E_L      0x131A5C
#define REG_BK131A_2E_H      0x131A5D
#define REG_BK131A_2F_L      0x131A5E
#define REG_BK131A_2F_H      0x131A5F
#define REG_BK131A_30_L      0x131A60
#define REG_BK131A_30_H      0x131A61
#define REG_BK131A_31_L      0x131A62
#define REG_BK131A_31_H      0x131A63
#define REG_BK131A_32_L      0x131A64
#define REG_BK131A_32_H      0x131A65
#define REG_BK131A_33_L      0x131A66
#define REG_BK131A_33_H      0x131A67
#define REG_BK131A_34_L      0x131A68
#define REG_BK131A_34_H      0x131A69
#define REG_BK131A_35_L      0x131A6A
#define REG_BK131A_35_H      0x131A6B
#define REG_BK131A_36_L      0x131A6C
#define REG_BK131A_36_H      0x131A6D
#define REG_BK131A_37_L      0x131A6E
#define REG_BK131A_37_H      0x131A6F
#define REG_BK131A_38_L      0x131A70
#define REG_BK131A_38_H      0x131A71
#define REG_BK131A_39_L      0x131A72
#define REG_BK131A_39_H      0x131A73
#define REG_BK131A_3A_L      0x131A74
#define REG_BK131A_3A_H      0x131A75
#define REG_BK131A_3B_L      0x131A76
#define REG_BK131A_3B_H      0x131A77
#define REG_BK131A_3C_L      0x131A78
#define REG_BK131A_3C_H      0x131A79
#define REG_BK131A_3D_L      0x131A7A
#define REG_BK131A_3D_H      0x131A7B
#define REG_BK131A_3E_L      0x131A7C
#define REG_BK131A_3E_H      0x131A7D
#define REG_BK131A_3F_L      0x131A7E
#define REG_BK131A_3F_H      0x131A7F
#define REG_BK131A_40_L      0x131A80
#define REG_BK131A_40_H      0x131A81
#define REG_BK131A_41_L      0x131A82
#define REG_BK131A_41_H      0x131A83
#define REG_BK131A_42_L      0x131A84
#define REG_BK131A_42_H      0x131A85
#define REG_BK131A_43_L      0x131A86
#define REG_BK131A_43_H      0x131A87
#define REG_BK131A_44_L      0x131A88
#define REG_BK131A_44_H      0x131A89
#define REG_BK131A_45_L      0x131A8A
#define REG_BK131A_45_H      0x131A8B
#define REG_BK131A_46_L      0x131A8C
#define REG_BK131A_46_H      0x131A8D
#define REG_BK131A_47_L      0x131A8E
#define REG_BK131A_47_H      0x131A8F
#define REG_BK131A_48_L      0x131A90
#define REG_BK131A_48_H      0x131A91
#define REG_BK131A_49_L      0x131A92
#define REG_BK131A_49_H      0x131A93
#define REG_BK131A_4A_L      0x131A94
#define REG_BK131A_4A_H      0x131A95
#define REG_BK131A_4B_L      0x131A96
#define REG_BK131A_4B_H      0x131A97
#define REG_BK131A_4C_L      0x131A98
#define REG_BK131A_4C_H      0x131A99
#define REG_BK131A_4D_L      0x131A9A
#define REG_BK131A_4D_H      0x131A9B
#define REG_BK131A_4E_L      0x131A9C
#define REG_BK131A_4E_H      0x131A9D
#define REG_BK131A_4F_L      0x131A9E
#define REG_BK131A_4F_H      0x131A9F
#define REG_BK131A_50_L      0x131AA0
#define REG_BK131A_50_H      0x131AA1
#define REG_BK131A_51_L      0x131AA2
#define REG_BK131A_51_H      0x131AA3
#define REG_BK131A_52_L      0x131AA4
#define REG_BK131A_52_H      0x131AA5
#define REG_BK131A_53_L      0x131AA6
#define REG_BK131A_53_H      0x131AA7
#define REG_BK131A_54_L      0x131AA8
#define REG_BK131A_54_H      0x131AA9
#define REG_BK131A_55_L      0x131AAA
#define REG_BK131A_55_H      0x131AAB
#define REG_BK131A_56_L      0x131AAC
#define REG_BK131A_56_H      0x131AAD
#define REG_BK131A_57_L      0x131AAE
#define REG_BK131A_57_H      0x131AAF
#define REG_BK131A_58_L      0x131AB0
#define REG_BK131A_58_H      0x131AB1
#define REG_BK131A_59_L      0x131AB2
#define REG_BK131A_59_H      0x131AB3
#define REG_BK131A_5A_L      0x131AB4
#define REG_BK131A_5A_H      0x131AB5
#define REG_BK131A_5B_L      0x131AB6
#define REG_BK131A_5B_H      0x131AB7
#define REG_BK131A_5C_L      0x131AB8
#define REG_BK131A_5C_H      0x131AB9
#define REG_BK131A_5D_L      0x131ABA
#define REG_BK131A_5D_H      0x131ABB
#define REG_BK131A_5E_L      0x131ABC
#define REG_BK131A_5E_H      0x131ABD
#define REG_BK131A_5F_L      0x131ABE
#define REG_BK131A_5F_H      0x131ABF
#define REG_BK131A_60_L      0x131AC0
#define REG_BK131A_60_H      0x131AC1
#define REG_BK131A_61_L      0x131AC2
#define REG_BK131A_61_H      0x131AC3
#define REG_BK131A_62_L      0x131AC4
#define REG_BK131A_62_H      0x131AC5
#define REG_BK131A_63_L      0x131AC6
#define REG_BK131A_63_H      0x131AC7
#define REG_BK131A_64_L      0x131AC8
#define REG_BK131A_64_H      0x131AC9
#define REG_BK131A_65_L      0x131ACA
#define REG_BK131A_65_H      0x131ACB
#define REG_BK131A_66_L      0x131ACC
#define REG_BK131A_66_H      0x131ACD
#define REG_BK131A_67_L      0x131ACE
#define REG_BK131A_67_H      0x131ACF
#define REG_BK131A_68_L      0x131AD0
#define REG_BK131A_68_H      0x131AD1
#define REG_BK131A_69_L      0x131AD2
#define REG_BK131A_69_H      0x131AD3
#define REG_BK131A_6A_L      0x131AD4
#define REG_BK131A_6A_H      0x131AD5
#define REG_BK131A_6B_L      0x131AD6
#define REG_BK131A_6B_H      0x131AD7
#define REG_BK131A_6C_L      0x131AD8
#define REG_BK131A_6C_H      0x131AD9
#define REG_BK131A_6D_L      0x131ADA
#define REG_BK131A_6D_H      0x131ADB
#define REG_BK131A_6E_L      0x131ADC
#define REG_BK131A_6E_H      0x131ADD
#define REG_BK131A_6F_L      0x131ADE
#define REG_BK131A_6F_H      0x131ADF
#define REG_BK131A_70_L      0x131AE0
#define REG_BK131A_70_H      0x131AE1
#define REG_BK131A_71_L      0x131AE2
#define REG_BK131A_71_H      0x131AE3
#define REG_BK131A_72_L      0x131AE4
#define REG_BK131A_72_H      0x131AE5
#define REG_BK131A_73_L      0x131AE6
#define REG_BK131A_73_H      0x131AE7
#define REG_BK131A_74_L      0x131AE8
#define REG_BK131A_74_H      0x131AE9
#define REG_BK131A_75_L      0x131AEA
#define REG_BK131A_75_H      0x131AEB
#define REG_BK131A_76_L      0x131AEC
#define REG_BK131A_76_H      0x131AED
#define REG_BK131A_77_L      0x131AEE
#define REG_BK131A_77_H      0x131AEF
#define REG_BK131A_78_L      0x131AF0
#define REG_BK131A_78_H      0x131AF1
#define REG_BK131A_79_L      0x131AF2
#define REG_BK131A_79_H      0x131AF3
#define REG_BK131A_7A_L      0x131AF4
#define REG_BK131A_7A_H      0x131AF5
#define REG_BK131A_7B_L      0x131AF6
#define REG_BK131A_7B_H      0x131AF7
#define REG_BK131A_7C_L      0x131AF8
#define REG_BK131A_7C_H      0x131AF9
#define REG_BK131A_7D_L      0x131AFA
#define REG_BK131A_7D_H      0x131AFB
#define REG_BK131A_7E_L      0x131AFC
#define REG_BK131A_7E_H      0x131AFD
#define REG_BK131A_7F_L      0x131AFE
#define REG_BK131A_7F_H      0x131AFF
//----------------------------------------------
#define REG_BK131B_00_L      0x131B00
#define REG_BK131B_00_H      0x131B01
#define REG_BK131B_01_L      0x131B02
#define REG_BK131B_01_H      0x131B03
#define REG_BK131B_02_L      0x131B04
#define REG_BK131B_02_H      0x131B05
#define REG_BK131B_03_L      0x131B06
#define REG_BK131B_03_H      0x131B07
#define REG_BK131B_04_L      0x131B08
#define REG_BK131B_04_H      0x131B09
#define REG_BK131B_05_L      0x131B0A
#define REG_BK131B_05_H      0x131B0B
#define REG_BK131B_06_L      0x131B0C
#define REG_BK131B_06_H      0x131B0D
#define REG_BK131B_07_L      0x131B0E
#define REG_BK131B_07_H      0x131B0F
#define REG_BK131B_08_L      0x131B10
#define REG_BK131B_08_H      0x131B11
#define REG_BK131B_09_L      0x131B12
#define REG_BK131B_09_H      0x131B13
#define REG_BK131B_0A_L      0x131B14
#define REG_BK131B_0A_H      0x131B15
#define REG_BK131B_0B_L      0x131B16
#define REG_BK131B_0B_H      0x131B17
#define REG_BK131B_0C_L      0x131B18
#define REG_BK131B_0C_H      0x131B19
#define REG_BK131B_0D_L      0x131B1A
#define REG_BK131B_0D_H      0x131B1B
#define REG_BK131B_0E_L      0x131B1C
#define REG_BK131B_0E_H      0x131B1D
#define REG_BK131B_0F_L      0x131B1E
#define REG_BK131B_0F_H      0x131B1F
#define REG_BK131B_10_L      0x131B20
#define REG_BK131B_10_H      0x131B21
#define REG_BK131B_11_L      0x131B22
#define REG_BK131B_11_H      0x131B23
#define REG_BK131B_12_L      0x131B24
#define REG_BK131B_12_H      0x131B25
#define REG_BK131B_13_L      0x131B26
#define REG_BK131B_13_H      0x131B27
#define REG_BK131B_14_L      0x131B28
#define REG_BK131B_14_H      0x131B29
#define REG_BK131B_15_L      0x131B2A
#define REG_BK131B_15_H      0x131B2B
#define REG_BK131B_16_L      0x131B2C
#define REG_BK131B_16_H      0x131B2D
#define REG_BK131B_17_L      0x131B2E
#define REG_BK131B_17_H      0x131B2F
#define REG_BK131B_18_L      0x131B30
#define REG_BK131B_18_H      0x131B31
#define REG_BK131B_19_L      0x131B32
#define REG_BK131B_19_H      0x131B33
#define REG_BK131B_1A_L      0x131B34
#define REG_BK131B_1A_H      0x131B35
#define REG_BK131B_1B_L      0x131B36
#define REG_BK131B_1B_H      0x131B37
#define REG_BK131B_1C_L      0x131B38
#define REG_BK131B_1C_H      0x131B39
#define REG_BK131B_1D_L      0x131B3A
#define REG_BK131B_1D_H      0x131B3B
#define REG_BK131B_1E_L      0x131B3C
#define REG_BK131B_1E_H      0x131B3D
#define REG_BK131B_1F_L      0x131B3E
#define REG_BK131B_1F_H      0x131B3F
#define REG_BK131B_20_L      0x131B40
#define REG_BK131B_20_H      0x131B41
#define REG_BK131B_21_L      0x131B42
#define REG_BK131B_21_H      0x131B43
#define REG_BK131B_22_L      0x131B44
#define REG_BK131B_22_H      0x131B45
#define REG_BK131B_23_L      0x131B46
#define REG_BK131B_23_H      0x131B47
#define REG_BK131B_24_L      0x131B48
#define REG_BK131B_24_H      0x131B49
#define REG_BK131B_25_L      0x131B4A
#define REG_BK131B_25_H      0x131B4B
#define REG_BK131B_26_L      0x131B4C
#define REG_BK131B_26_H      0x131B4D
#define REG_BK131B_27_L      0x131B4E
#define REG_BK131B_27_H      0x131B4F
#define REG_BK131B_28_L      0x131B50
#define REG_BK131B_28_H      0x131B51
#define REG_BK131B_29_L      0x131B52
#define REG_BK131B_29_H      0x131B53
#define REG_BK131B_2A_L      0x131B54
#define REG_BK131B_2A_H      0x131B55
#define REG_BK131B_2B_L      0x131B56
#define REG_BK131B_2B_H      0x131B57
#define REG_BK131B_2C_L      0x131B58
#define REG_BK131B_2C_H      0x131B59
#define REG_BK131B_2D_L      0x131B5A
#define REG_BK131B_2D_H      0x131B5B
#define REG_BK131B_2E_L      0x131B5C
#define REG_BK131B_2E_H      0x131B5D
#define REG_BK131B_2F_L      0x131B5E
#define REG_BK131B_2F_H      0x131B5F
#define REG_BK131B_30_L      0x131B60
#define REG_BK131B_30_H      0x131B61
#define REG_BK131B_31_L      0x131B62
#define REG_BK131B_31_H      0x131B63
#define REG_BK131B_32_L      0x131B64
#define REG_BK131B_32_H      0x131B65
#define REG_BK131B_33_L      0x131B66
#define REG_BK131B_33_H      0x131B67
#define REG_BK131B_34_L      0x131B68
#define REG_BK131B_34_H      0x131B69
#define REG_BK131B_35_L      0x131B6A
#define REG_BK131B_35_H      0x131B6B
#define REG_BK131B_36_L      0x131B6C
#define REG_BK131B_36_H      0x131B6D
#define REG_BK131B_37_L      0x131B6E
#define REG_BK131B_37_H      0x131B6F
#define REG_BK131B_38_L      0x131B70
#define REG_BK131B_38_H      0x131B71
#define REG_BK131B_39_L      0x131B72
#define REG_BK131B_39_H      0x131B73
#define REG_BK131B_3A_L      0x131B74
#define REG_BK131B_3A_H      0x131B75
#define REG_BK131B_3B_L      0x131B76
#define REG_BK131B_3B_H      0x131B77
#define REG_BK131B_3C_L      0x131B78
#define REG_BK131B_3C_H      0x131B79
#define REG_BK131B_3D_L      0x131B7A
#define REG_BK131B_3D_H      0x131B7B
#define REG_BK131B_3E_L      0x131B7C
#define REG_BK131B_3E_H      0x131B7D
#define REG_BK131B_3F_L      0x131B7E
#define REG_BK131B_3F_H      0x131B7F
#define REG_BK131B_40_L      0x131B80
#define REG_BK131B_40_H      0x131B81
#define REG_BK131B_41_L      0x131B82
#define REG_BK131B_41_H      0x131B83
#define REG_BK131B_42_L      0x131B84
#define REG_BK131B_42_H      0x131B85
#define REG_BK131B_43_L      0x131B86
#define REG_BK131B_43_H      0x131B87
#define REG_BK131B_44_L      0x131B88
#define REG_BK131B_44_H      0x131B89
#define REG_BK131B_45_L      0x131B8A
#define REG_BK131B_45_H      0x131B8B
#define REG_BK131B_46_L      0x131B8C
#define REG_BK131B_46_H      0x131B8D
#define REG_BK131B_47_L      0x131B8E
#define REG_BK131B_47_H      0x131B8F
#define REG_BK131B_48_L      0x131B90
#define REG_BK131B_48_H      0x131B91
#define REG_BK131B_49_L      0x131B92
#define REG_BK131B_49_H      0x131B93
#define REG_BK131B_4A_L      0x131B94
#define REG_BK131B_4A_H      0x131B95
#define REG_BK131B_4B_L      0x131B96
#define REG_BK131B_4B_H      0x131B97
#define REG_BK131B_4C_L      0x131B98
#define REG_BK131B_4C_H      0x131B99
#define REG_BK131B_4D_L      0x131B9A
#define REG_BK131B_4D_H      0x131B9B
#define REG_BK131B_4E_L      0x131B9C
#define REG_BK131B_4E_H      0x131B9D
#define REG_BK131B_4F_L      0x131B9E
#define REG_BK131B_4F_H      0x131B9F
#define REG_BK131B_50_L      0x131BA0
#define REG_BK131B_50_H      0x131BA1
#define REG_BK131B_51_L      0x131BA2
#define REG_BK131B_51_H      0x131BA3
#define REG_BK131B_52_L      0x131BA4
#define REG_BK131B_52_H      0x131BA5
#define REG_BK131B_53_L      0x131BA6
#define REG_BK131B_53_H      0x131BA7
#define REG_BK131B_54_L      0x131BA8
#define REG_BK131B_54_H      0x131BA9
#define REG_BK131B_55_L      0x131BAA
#define REG_BK131B_55_H      0x131BAB
#define REG_BK131B_56_L      0x131BAC
#define REG_BK131B_56_H      0x131BAD
#define REG_BK131B_57_L      0x131BAE
#define REG_BK131B_57_H      0x131BAF
#define REG_BK131B_58_L      0x131BB0
#define REG_BK131B_58_H      0x131BB1
#define REG_BK131B_59_L      0x131BB2
#define REG_BK131B_59_H      0x131BB3
#define REG_BK131B_5A_L      0x131BB4
#define REG_BK131B_5A_H      0x131BB5
#define REG_BK131B_5B_L      0x131BB6
#define REG_BK131B_5B_H      0x131BB7
#define REG_BK131B_5C_L      0x131BB8
#define REG_BK131B_5C_H      0x131BB9
#define REG_BK131B_5D_L      0x131BBA
#define REG_BK131B_5D_H      0x131BBB
#define REG_BK131B_5E_L      0x131BBC
#define REG_BK131B_5E_H      0x131BBD
#define REG_BK131B_5F_L      0x131BBE
#define REG_BK131B_5F_H      0x131BBF
#define REG_BK131B_60_L      0x131BC0
#define REG_BK131B_60_H      0x131BC1
#define REG_BK131B_61_L      0x131BC2
#define REG_BK131B_61_H      0x131BC3
#define REG_BK131B_62_L      0x131BC4
#define REG_BK131B_62_H      0x131BC5
#define REG_BK131B_63_L      0x131BC6
#define REG_BK131B_63_H      0x131BC7
#define REG_BK131B_64_L      0x131BC8
#define REG_BK131B_64_H      0x131BC9
#define REG_BK131B_65_L      0x131BCA
#define REG_BK131B_65_H      0x131BCB
#define REG_BK131B_66_L      0x131BCC
#define REG_BK131B_66_H      0x131BCD
#define REG_BK131B_67_L      0x131BCE
#define REG_BK131B_67_H      0x131BCF
#define REG_BK131B_68_L      0x131BD0
#define REG_BK131B_68_H      0x131BD1
#define REG_BK131B_69_L      0x131BD2
#define REG_BK131B_69_H      0x131BD3
#define REG_BK131B_6A_L      0x131BD4
#define REG_BK131B_6A_H      0x131BD5
#define REG_BK131B_6B_L      0x131BD6
#define REG_BK131B_6B_H      0x131BD7
#define REG_BK131B_6C_L      0x131BD8
#define REG_BK131B_6C_H      0x131BD9
#define REG_BK131B_6D_L      0x131BDA
#define REG_BK131B_6D_H      0x131BDB
#define REG_BK131B_6E_L      0x131BDC
#define REG_BK131B_6E_H      0x131BDD
#define REG_BK131B_6F_L      0x131BDE
#define REG_BK131B_6F_H      0x131BDF
#define REG_BK131B_70_L      0x131BE0
#define REG_BK131B_70_H      0x131BE1
#define REG_BK131B_71_L      0x131BE2
#define REG_BK131B_71_H      0x131BE3
#define REG_BK131B_72_L      0x131BE4
#define REG_BK131B_72_H      0x131BE5
#define REG_BK131B_73_L      0x131BE6
#define REG_BK131B_73_H      0x131BE7
#define REG_BK131B_74_L      0x131BE8
#define REG_BK131B_74_H      0x131BE9
#define REG_BK131B_75_L      0x131BEA
#define REG_BK131B_75_H      0x131BEB
#define REG_BK131B_76_L      0x131BEC
#define REG_BK131B_76_H      0x131BED
#define REG_BK131B_77_L      0x131BEE
#define REG_BK131B_77_H      0x131BEF
#define REG_BK131B_78_L      0x131BF0
#define REG_BK131B_78_H      0x131BF1
#define REG_BK131B_79_L      0x131BF2
#define REG_BK131B_79_H      0x131BF3
#define REG_BK131B_7A_L      0x131BF4
#define REG_BK131B_7A_H      0x131BF5
#define REG_BK131B_7B_L      0x131BF6
#define REG_BK131B_7B_H      0x131BF7
#define REG_BK131B_7C_L      0x131BF8
#define REG_BK131B_7C_H      0x131BF9
#define REG_BK131B_7D_L      0x131BFA
#define REG_BK131B_7D_H      0x131BFB
#define REG_BK131B_7E_L      0x131BFC
#define REG_BK131B_7E_H      0x131BFD
#define REG_BK131B_7F_L      0x131BFE
#define REG_BK131B_7F_H      0x131BFF
//----------------------------------------------
#define REG_BK131C_00_L      0x131C00
#define REG_BK131C_00_H      0x131C01
#define REG_BK131C_01_L      0x131C02
#define REG_BK131C_01_H      0x131C03
#define REG_BK131C_02_L      0x131C04
#define REG_BK131C_02_H      0x131C05
#define REG_BK131C_03_L      0x131C06
#define REG_BK131C_03_H      0x131C07
#define REG_BK131C_04_L      0x131C08
#define REG_BK131C_04_H      0x131C09
#define REG_BK131C_05_L      0x131C0A
#define REG_BK131C_05_H      0x131C0B
#define REG_BK131C_06_L      0x131C0C
#define REG_BK131C_06_H      0x131C0D
#define REG_BK131C_07_L      0x131C0E
#define REG_BK131C_07_H      0x131C0F
#define REG_BK131C_08_L      0x131C10
#define REG_BK131C_08_H      0x131C11
#define REG_BK131C_09_L      0x131C12
#define REG_BK131C_09_H      0x131C13
#define REG_BK131C_0A_L      0x131C14
#define REG_BK131C_0A_H      0x131C15
#define REG_BK131C_0B_L      0x131C16
#define REG_BK131C_0B_H      0x131C17
#define REG_BK131C_0C_L      0x131C18
#define REG_BK131C_0C_H      0x131C19
#define REG_BK131C_0D_L      0x131C1A
#define REG_BK131C_0D_H      0x131C1B
#define REG_BK131C_0E_L      0x131C1C
#define REG_BK131C_0E_H      0x131C1D
#define REG_BK131C_0F_L      0x131C1E
#define REG_BK131C_0F_H      0x131C1F
#define REG_BK131C_10_L      0x131C20
#define REG_BK131C_10_H      0x131C21
#define REG_BK131C_11_L      0x131C22
#define REG_BK131C_11_H      0x131C23
#define REG_BK131C_12_L      0x131C24
#define REG_BK131C_12_H      0x131C25
#define REG_BK131C_13_L      0x131C26
#define REG_BK131C_13_H      0x131C27
#define REG_BK131C_14_L      0x131C28
#define REG_BK131C_14_H      0x131C29
#define REG_BK131C_15_L      0x131C2A
#define REG_BK131C_15_H      0x131C2B
#define REG_BK131C_16_L      0x131C2C
#define REG_BK131C_16_H      0x131C2D
#define REG_BK131C_17_L      0x131C2E
#define REG_BK131C_17_H      0x131C2F
#define REG_BK131C_18_L      0x131C30
#define REG_BK131C_18_H      0x131C31
#define REG_BK131C_19_L      0x131C32
#define REG_BK131C_19_H      0x131C33
#define REG_BK131C_1A_L      0x131C34
#define REG_BK131C_1A_H      0x131C35
#define REG_BK131C_1B_L      0x131C36
#define REG_BK131C_1B_H      0x131C37
#define REG_BK131C_1C_L      0x131C38
#define REG_BK131C_1C_H      0x131C39
#define REG_BK131C_1D_L      0x131C3A
#define REG_BK131C_1D_H      0x131C3B
#define REG_BK131C_1E_L      0x131C3C
#define REG_BK131C_1E_H      0x131C3D
#define REG_BK131C_1F_L      0x131C3E
#define REG_BK131C_1F_H      0x131C3F
#define REG_BK131C_20_L      0x131C40
#define REG_BK131C_20_H      0x131C41
#define REG_BK131C_21_L      0x131C42
#define REG_BK131C_21_H      0x131C43
#define REG_BK131C_22_L      0x131C44
#define REG_BK131C_22_H      0x131C45
#define REG_BK131C_23_L      0x131C46
#define REG_BK131C_23_H      0x131C47
#define REG_BK131C_24_L      0x131C48
#define REG_BK131C_24_H      0x131C49
#define REG_BK131C_25_L      0x131C4A
#define REG_BK131C_25_H      0x131C4B
#define REG_BK131C_26_L      0x131C4C
#define REG_BK131C_26_H      0x131C4D
#define REG_BK131C_27_L      0x131C4E
#define REG_BK131C_27_H      0x131C4F
#define REG_BK131C_28_L      0x131C50
#define REG_BK131C_28_H      0x131C51
#define REG_BK131C_29_L      0x131C52
#define REG_BK131C_29_H      0x131C53
#define REG_BK131C_2A_L      0x131C54
#define REG_BK131C_2A_H      0x131C55
#define REG_BK131C_2B_L      0x131C56
#define REG_BK131C_2B_H      0x131C57
#define REG_BK131C_2C_L      0x131C58
#define REG_BK131C_2C_H      0x131C59
#define REG_BK131C_2D_L      0x131C5A
#define REG_BK131C_2D_H      0x131C5B
#define REG_BK131C_2E_L      0x131C5C
#define REG_BK131C_2E_H      0x131C5D
#define REG_BK131C_2F_L      0x131C5E
#define REG_BK131C_2F_H      0x131C5F
#define REG_BK131C_30_L      0x131C60
#define REG_BK131C_30_H      0x131C61
#define REG_BK131C_31_L      0x131C62
#define REG_BK131C_31_H      0x131C63
#define REG_BK131C_32_L      0x131C64
#define REG_BK131C_32_H      0x131C65
#define REG_BK131C_33_L      0x131C66
#define REG_BK131C_33_H      0x131C67
#define REG_BK131C_34_L      0x131C68
#define REG_BK131C_34_H      0x131C69
#define REG_BK131C_35_L      0x131C6A
#define REG_BK131C_35_H      0x131C6B
#define REG_BK131C_36_L      0x131C6C
#define REG_BK131C_36_H      0x131C6D
#define REG_BK131C_37_L      0x131C6E
#define REG_BK131C_37_H      0x131C6F
#define REG_BK131C_38_L      0x131C70
#define REG_BK131C_38_H      0x131C71
#define REG_BK131C_39_L      0x131C72
#define REG_BK131C_39_H      0x131C73
#define REG_BK131C_3A_L      0x131C74
#define REG_BK131C_3A_H      0x131C75
#define REG_BK131C_3B_L      0x131C76
#define REG_BK131C_3B_H      0x131C77
#define REG_BK131C_3C_L      0x131C78
#define REG_BK131C_3C_H      0x131C79
#define REG_BK131C_3D_L      0x131C7A
#define REG_BK131C_3D_H      0x131C7B
#define REG_BK131C_3E_L      0x131C7C
#define REG_BK131C_3E_H      0x131C7D
#define REG_BK131C_3F_L      0x131C7E
#define REG_BK131C_3F_H      0x131C7F
#define REG_BK131C_40_L      0x131C80
#define REG_BK131C_40_H      0x131C81
#define REG_BK131C_41_L      0x131C82
#define REG_BK131C_41_H      0x131C83
#define REG_BK131C_42_L      0x131C84
#define REG_BK131C_42_H      0x131C85
#define REG_BK131C_43_L      0x131C86
#define REG_BK131C_43_H      0x131C87
#define REG_BK131C_44_L      0x131C88
#define REG_BK131C_44_H      0x131C89
#define REG_BK131C_45_L      0x131C8A
#define REG_BK131C_45_H      0x131C8B
#define REG_BK131C_46_L      0x131C8C
#define REG_BK131C_46_H      0x131C8D
#define REG_BK131C_47_L      0x131C8E
#define REG_BK131C_47_H      0x131C8F
#define REG_BK131C_48_L      0x131C90
#define REG_BK131C_48_H      0x131C91
#define REG_BK131C_49_L      0x131C92
#define REG_BK131C_49_H      0x131C93
#define REG_BK131C_4A_L      0x131C94
#define REG_BK131C_4A_H      0x131C95
#define REG_BK131C_4B_L      0x131C96
#define REG_BK131C_4B_H      0x131C97
#define REG_BK131C_4C_L      0x131C98
#define REG_BK131C_4C_H      0x131C99
#define REG_BK131C_4D_L      0x131C9A
#define REG_BK131C_4D_H      0x131C9B
#define REG_BK131C_4E_L      0x131C9C
#define REG_BK131C_4E_H      0x131C9D
#define REG_BK131C_4F_L      0x131C9E
#define REG_BK131C_4F_H      0x131C9F
#define REG_BK131C_50_L      0x131CA0
#define REG_BK131C_50_H      0x131CA1
#define REG_BK131C_51_L      0x131CA2
#define REG_BK131C_51_H      0x131CA3
#define REG_BK131C_52_L      0x131CA4
#define REG_BK131C_52_H      0x131CA5
#define REG_BK131C_53_L      0x131CA6
#define REG_BK131C_53_H      0x131CA7
#define REG_BK131C_54_L      0x131CA8
#define REG_BK131C_54_H      0x131CA9
#define REG_BK131C_55_L      0x131CAA
#define REG_BK131C_55_H      0x131CAB
#define REG_BK131C_56_L      0x131CAC
#define REG_BK131C_56_H      0x131CAD
#define REG_BK131C_57_L      0x131CAE
#define REG_BK131C_57_H      0x131CAF
#define REG_BK131C_58_L      0x131CB0
#define REG_BK131C_58_H      0x131CB1
#define REG_BK131C_59_L      0x131CB2
#define REG_BK131C_59_H      0x131CB3
#define REG_BK131C_5A_L      0x131CB4
#define REG_BK131C_5A_H      0x131CB5
#define REG_BK131C_5B_L      0x131CB6
#define REG_BK131C_5B_H      0x131CB7
#define REG_BK131C_5C_L      0x131CB8
#define REG_BK131C_5C_H      0x131CB9
#define REG_BK131C_5D_L      0x131CBA
#define REG_BK131C_5D_H      0x131CBB
#define REG_BK131C_5E_L      0x131CBC
#define REG_BK131C_5E_H      0x131CBD
#define REG_BK131C_5F_L      0x131CBE
#define REG_BK131C_5F_H      0x131CBF
#define REG_BK131C_60_L      0x131CC0
#define REG_BK131C_60_H      0x131CC1
#define REG_BK131C_61_L      0x131CC2
#define REG_BK131C_61_H      0x131CC3
#define REG_BK131C_62_L      0x131CC4
#define REG_BK131C_62_H      0x131CC5
#define REG_BK131C_63_L      0x131CC6
#define REG_BK131C_63_H      0x131CC7
#define REG_BK131C_64_L      0x131CC8
#define REG_BK131C_64_H      0x131CC9
#define REG_BK131C_65_L      0x131CCA
#define REG_BK131C_65_H      0x131CCB
#define REG_BK131C_66_L      0x131CCC
#define REG_BK131C_66_H      0x131CCD
#define REG_BK131C_67_L      0x131CCE
#define REG_BK131C_67_H      0x131CCF
#define REG_BK131C_68_L      0x131CD0
#define REG_BK131C_68_H      0x131CD1
#define REG_BK131C_69_L      0x131CD2
#define REG_BK131C_69_H      0x131CD3
#define REG_BK131C_6A_L      0x131CD4
#define REG_BK131C_6A_H      0x131CD5
#define REG_BK131C_6B_L      0x131CD6
#define REG_BK131C_6B_H      0x131CD7
#define REG_BK131C_6C_L      0x131CD8
#define REG_BK131C_6C_H      0x131CD9
#define REG_BK131C_6D_L      0x131CDA
#define REG_BK131C_6D_H      0x131CDB
#define REG_BK131C_6E_L      0x131CDC
#define REG_BK131C_6E_H      0x131CDD
#define REG_BK131C_6F_L      0x131CDE
#define REG_BK131C_6F_H      0x131CDF
#define REG_BK131C_70_L      0x131CE0
#define REG_BK131C_70_H      0x131CE1
#define REG_BK131C_71_L      0x131CE2
#define REG_BK131C_71_H      0x131CE3
#define REG_BK131C_72_L      0x131CE4
#define REG_BK131C_72_H      0x131CE5
#define REG_BK131C_73_L      0x131CE6
#define REG_BK131C_73_H      0x131CE7
#define REG_BK131C_74_L      0x131CE8
#define REG_BK131C_74_H      0x131CE9
#define REG_BK131C_75_L      0x131CEA
#define REG_BK131C_75_H      0x131CEB
#define REG_BK131C_76_L      0x131CEC
#define REG_BK131C_76_H      0x131CED
#define REG_BK131C_77_L      0x131CEE
#define REG_BK131C_77_H      0x131CEF
#define REG_BK131C_78_L      0x131CF0
#define REG_BK131C_78_H      0x131CF1
#define REG_BK131C_79_L      0x131CF2
#define REG_BK131C_79_H      0x131CF3
#define REG_BK131C_7A_L      0x131CF4
#define REG_BK131C_7A_H      0x131CF5
#define REG_BK131C_7B_L      0x131CF6
#define REG_BK131C_7B_H      0x131CF7
#define REG_BK131C_7C_L      0x131CF8
#define REG_BK131C_7C_H      0x131CF9
#define REG_BK131C_7D_L      0x131CFA
#define REG_BK131C_7D_H      0x131CFB
#define REG_BK131C_7E_L      0x131CFC
#define REG_BK131C_7E_H      0x131CFD
#define REG_BK131C_7F_L      0x131CFE
#define REG_BK131C_7F_H      0x131CFF
//----------------------------------------------
#define REG_BK131D_00_L      0x131D00
#define REG_BK131D_00_H      0x131D01
#define REG_BK131D_01_L      0x131D02
#define REG_BK131D_01_H      0x131D03
#define REG_BK131D_02_L      0x131D04
#define REG_BK131D_02_H      0x131D05
#define REG_BK131D_03_L      0x131D06
#define REG_BK131D_03_H      0x131D07
#define REG_BK131D_04_L      0x131D08
#define REG_BK131D_04_H      0x131D09
#define REG_BK131D_05_L      0x131D0A
#define REG_BK131D_05_H      0x131D0B
#define REG_BK131D_06_L      0x131D0C
#define REG_BK131D_06_H      0x131D0D
#define REG_BK131D_07_L      0x131D0E
#define REG_BK131D_07_H      0x131D0F
#define REG_BK131D_08_L      0x131D10
#define REG_BK131D_08_H      0x131D11
#define REG_BK131D_09_L      0x131D12
#define REG_BK131D_09_H      0x131D13
#define REG_BK131D_0A_L      0x131D14
#define REG_BK131D_0A_H      0x131D15
#define REG_BK131D_0B_L      0x131D16
#define REG_BK131D_0B_H      0x131D17
#define REG_BK131D_0C_L      0x131D18
#define REG_BK131D_0C_H      0x131D19
#define REG_BK131D_0D_L      0x131D1A
#define REG_BK131D_0D_H      0x131D1B
#define REG_BK131D_0E_L      0x131D1C
#define REG_BK131D_0E_H      0x131D1D
#define REG_BK131D_0F_L      0x131D1E
#define REG_BK131D_0F_H      0x131D1F
#define REG_BK131D_10_L      0x131D20
#define REG_BK131D_10_H      0x131D21
#define REG_BK131D_11_L      0x131D22
#define REG_BK131D_11_H      0x131D23
#define REG_BK131D_12_L      0x131D24
#define REG_BK131D_12_H      0x131D25
#define REG_BK131D_13_L      0x131D26
#define REG_BK131D_13_H      0x131D27
#define REG_BK131D_14_L      0x131D28
#define REG_BK131D_14_H      0x131D29
#define REG_BK131D_15_L      0x131D2A
#define REG_BK131D_15_H      0x131D2B
#define REG_BK131D_16_L      0x131D2C
#define REG_BK131D_16_H      0x131D2D
#define REG_BK131D_17_L      0x131D2E
#define REG_BK131D_17_H      0x131D2F
#define REG_BK131D_18_L      0x131D30
#define REG_BK131D_18_H      0x131D31
#define REG_BK131D_19_L      0x131D32
#define REG_BK131D_19_H      0x131D33
#define REG_BK131D_1A_L      0x131D34
#define REG_BK131D_1A_H      0x131D35
#define REG_BK131D_1B_L      0x131D36
#define REG_BK131D_1B_H      0x131D37
#define REG_BK131D_1C_L      0x131D38
#define REG_BK131D_1C_H      0x131D39
#define REG_BK131D_1D_L      0x131D3A
#define REG_BK131D_1D_H      0x131D3B
#define REG_BK131D_1E_L      0x131D3C
#define REG_BK131D_1E_H      0x131D3D
#define REG_BK131D_1F_L      0x131D3E
#define REG_BK131D_1F_H      0x131D3F
#define REG_BK131D_20_L      0x131D40
#define REG_BK131D_20_H      0x131D41
#define REG_BK131D_21_L      0x131D42
#define REG_BK131D_21_H      0x131D43
#define REG_BK131D_22_L      0x131D44
#define REG_BK131D_22_H      0x131D45
#define REG_BK131D_23_L      0x131D46
#define REG_BK131D_23_H      0x131D47
#define REG_BK131D_24_L      0x131D48
#define REG_BK131D_24_H      0x131D49
#define REG_BK131D_25_L      0x131D4A
#define REG_BK131D_25_H      0x131D4B
#define REG_BK131D_26_L      0x131D4C
#define REG_BK131D_26_H      0x131D4D
#define REG_BK131D_27_L      0x131D4E
#define REG_BK131D_27_H      0x131D4F
#define REG_BK131D_28_L      0x131D50
#define REG_BK131D_28_H      0x131D51
#define REG_BK131D_29_L      0x131D52
#define REG_BK131D_29_H      0x131D53
#define REG_BK131D_2A_L      0x131D54
#define REG_BK131D_2A_H      0x131D55
#define REG_BK131D_2B_L      0x131D56
#define REG_BK131D_2B_H      0x131D57
#define REG_BK131D_2C_L      0x131D58
#define REG_BK131D_2C_H      0x131D59
#define REG_BK131D_2D_L      0x131D5A
#define REG_BK131D_2D_H      0x131D5B
#define REG_BK131D_2E_L      0x131D5C
#define REG_BK131D_2E_H      0x131D5D
#define REG_BK131D_2F_L      0x131D5E
#define REG_BK131D_2F_H      0x131D5F
#define REG_BK131D_30_L      0x131D60
#define REG_BK131D_30_H      0x131D61
#define REG_BK131D_31_L      0x131D62
#define REG_BK131D_31_H      0x131D63
#define REG_BK131D_32_L      0x131D64
#define REG_BK131D_32_H      0x131D65
#define REG_BK131D_33_L      0x131D66
#define REG_BK131D_33_H      0x131D67
#define REG_BK131D_34_L      0x131D68
#define REG_BK131D_34_H      0x131D69
#define REG_BK131D_35_L      0x131D6A
#define REG_BK131D_35_H      0x131D6B
#define REG_BK131D_36_L      0x131D6C
#define REG_BK131D_36_H      0x131D6D
#define REG_BK131D_37_L      0x131D6E
#define REG_BK131D_37_H      0x131D6F
#define REG_BK131D_38_L      0x131D70
#define REG_BK131D_38_H      0x131D71
#define REG_BK131D_39_L      0x131D72
#define REG_BK131D_39_H      0x131D73
#define REG_BK131D_3A_L      0x131D74
#define REG_BK131D_3A_H      0x131D75
#define REG_BK131D_3B_L      0x131D76
#define REG_BK131D_3B_H      0x131D77
#define REG_BK131D_3C_L      0x131D78
#define REG_BK131D_3C_H      0x131D79
#define REG_BK131D_3D_L      0x131D7A
#define REG_BK131D_3D_H      0x131D7B
#define REG_BK131D_3E_L      0x131D7C
#define REG_BK131D_3E_H      0x131D7D
#define REG_BK131D_3F_L      0x131D7E
#define REG_BK131D_3F_H      0x131D7F
#define REG_BK131D_40_L      0x131D80
#define REG_BK131D_40_H      0x131D81
#define REG_BK131D_41_L      0x131D82
#define REG_BK131D_41_H      0x131D83
#define REG_BK131D_42_L      0x131D84
#define REG_BK131D_42_H      0x131D85
#define REG_BK131D_43_L      0x131D86
#define REG_BK131D_43_H      0x131D87
#define REG_BK131D_44_L      0x131D88
#define REG_BK131D_44_H      0x131D89
#define REG_BK131D_45_L      0x131D8A
#define REG_BK131D_45_H      0x131D8B
#define REG_BK131D_46_L      0x131D8C
#define REG_BK131D_46_H      0x131D8D
#define REG_BK131D_47_L      0x131D8E
#define REG_BK131D_47_H      0x131D8F
#define REG_BK131D_48_L      0x131D90
#define REG_BK131D_48_H      0x131D91
#define REG_BK131D_49_L      0x131D92
#define REG_BK131D_49_H      0x131D93
#define REG_BK131D_4A_L      0x131D94
#define REG_BK131D_4A_H      0x131D95
#define REG_BK131D_4B_L      0x131D96
#define REG_BK131D_4B_H      0x131D97
#define REG_BK131D_4C_L      0x131D98
#define REG_BK131D_4C_H      0x131D99
#define REG_BK131D_4D_L      0x131D9A
#define REG_BK131D_4D_H      0x131D9B
#define REG_BK131D_4E_L      0x131D9C
#define REG_BK131D_4E_H      0x131D9D
#define REG_BK131D_4F_L      0x131D9E
#define REG_BK131D_4F_H      0x131D9F
#define REG_BK131D_50_L      0x131DA0
#define REG_BK131D_50_H      0x131DA1
#define REG_BK131D_51_L      0x131DA2
#define REG_BK131D_51_H      0x131DA3
#define REG_BK131D_52_L      0x131DA4
#define REG_BK131D_52_H      0x131DA5
#define REG_BK131D_53_L      0x131DA6
#define REG_BK131D_53_H      0x131DA7
#define REG_BK131D_54_L      0x131DA8
#define REG_BK131D_54_H      0x131DA9
#define REG_BK131D_55_L      0x131DAA
#define REG_BK131D_55_H      0x131DAB
#define REG_BK131D_56_L      0x131DAC
#define REG_BK131D_56_H      0x131DAD
#define REG_BK131D_57_L      0x131DAE
#define REG_BK131D_57_H      0x131DAF
#define REG_BK131D_58_L      0x131DB0
#define REG_BK131D_58_H      0x131DB1
#define REG_BK131D_59_L      0x131DB2
#define REG_BK131D_59_H      0x131DB3
#define REG_BK131D_5A_L      0x131DB4
#define REG_BK131D_5A_H      0x131DB5
#define REG_BK131D_5B_L      0x131DB6
#define REG_BK131D_5B_H      0x131DB7
#define REG_BK131D_5C_L      0x131DB8
#define REG_BK131D_5C_H      0x131DB9
#define REG_BK131D_5D_L      0x131DBA
#define REG_BK131D_5D_H      0x131DBB
#define REG_BK131D_5E_L      0x131DBC
#define REG_BK131D_5E_H      0x131DBD
#define REG_BK131D_5F_L      0x131DBE
#define REG_BK131D_5F_H      0x131DBF
#define REG_BK131D_60_L      0x131DC0
#define REG_BK131D_60_H      0x131DC1
#define REG_BK131D_61_L      0x131DC2
#define REG_BK131D_61_H      0x131DC3
#define REG_BK131D_62_L      0x131DC4
#define REG_BK131D_62_H      0x131DC5
#define REG_BK131D_63_L      0x131DC6
#define REG_BK131D_63_H      0x131DC7
#define REG_BK131D_64_L      0x131DC8
#define REG_BK131D_64_H      0x131DC9
#define REG_BK131D_65_L      0x131DCA
#define REG_BK131D_65_H      0x131DCB
#define REG_BK131D_66_L      0x131DCC
#define REG_BK131D_66_H      0x131DCD
#define REG_BK131D_67_L      0x131DCE
#define REG_BK131D_67_H      0x131DCF
#define REG_BK131D_68_L      0x131DD0
#define REG_BK131D_68_H      0x131DD1
#define REG_BK131D_69_L      0x131DD2
#define REG_BK131D_69_H      0x131DD3
#define REG_BK131D_6A_L      0x131DD4
#define REG_BK131D_6A_H      0x131DD5
#define REG_BK131D_6B_L      0x131DD6
#define REG_BK131D_6B_H      0x131DD7
#define REG_BK131D_6C_L      0x131DD8
#define REG_BK131D_6C_H      0x131DD9
#define REG_BK131D_6D_L      0x131DDA
#define REG_BK131D_6D_H      0x131DDB
#define REG_BK131D_6E_L      0x131DDC
#define REG_BK131D_6E_H      0x131DDD
#define REG_BK131D_6F_L      0x131DDE
#define REG_BK131D_6F_H      0x131DDF
#define REG_BK131D_70_L      0x131DE0
#define REG_BK131D_70_H      0x131DE1
#define REG_BK131D_71_L      0x131DE2
#define REG_BK131D_71_H      0x131DE3
#define REG_BK131D_72_L      0x131DE4
#define REG_BK131D_72_H      0x131DE5
#define REG_BK131D_73_L      0x131DE6
#define REG_BK131D_73_H      0x131DE7
#define REG_BK131D_74_L      0x131DE8
#define REG_BK131D_74_H      0x131DE9
#define REG_BK131D_75_L      0x131DEA
#define REG_BK131D_75_H      0x131DEB
#define REG_BK131D_76_L      0x131DEC
#define REG_BK131D_76_H      0x131DED
#define REG_BK131D_77_L      0x131DEE
#define REG_BK131D_77_H      0x131DEF
#define REG_BK131D_78_L      0x131DF0
#define REG_BK131D_78_H      0x131DF1
#define REG_BK131D_79_L      0x131DF2
#define REG_BK131D_79_H      0x131DF3
#define REG_BK131D_7A_L      0x131DF4
#define REG_BK131D_7A_H      0x131DF5
#define REG_BK131D_7B_L      0x131DF6
#define REG_BK131D_7B_H      0x131DF7
#define REG_BK131D_7C_L      0x131DF8
#define REG_BK131D_7C_H      0x131DF9
#define REG_BK131D_7D_L      0x131DFA
#define REG_BK131D_7D_H      0x131DFB
#define REG_BK131D_7E_L      0x131DFC
#define REG_BK131D_7E_H      0x131DFD
#define REG_BK131D_7F_L      0x131DFE
#define REG_BK131D_7F_H      0x131DFF
//----------------------------------------------
#define REG_BK131E_00_L      0x131E00
#define REG_BK131E_00_H      0x131E01
#define REG_BK131E_01_L      0x131E02
#define REG_BK131E_01_H      0x131E03
#define REG_BK131E_02_L      0x131E04
#define REG_BK131E_02_H      0x131E05
#define REG_BK131E_03_L      0x131E06
#define REG_BK131E_03_H      0x131E07
#define REG_BK131E_04_L      0x131E08
#define REG_BK131E_04_H      0x131E09
#define REG_BK131E_05_L      0x131E0A
#define REG_BK131E_05_H      0x131E0B
#define REG_BK131E_06_L      0x131E0C
#define REG_BK131E_06_H      0x131E0D
#define REG_BK131E_07_L      0x131E0E
#define REG_BK131E_07_H      0x131E0F
#define REG_BK131E_08_L      0x131E10
#define REG_BK131E_08_H      0x131E11
#define REG_BK131E_09_L      0x131E12
#define REG_BK131E_09_H      0x131E13
#define REG_BK131E_0A_L      0x131E14
#define REG_BK131E_0A_H      0x131E15
#define REG_BK131E_0B_L      0x131E16
#define REG_BK131E_0B_H      0x131E17
#define REG_BK131E_0C_L      0x131E18
#define REG_BK131E_0C_H      0x131E19
#define REG_BK131E_0D_L      0x131E1A
#define REG_BK131E_0D_H      0x131E1B
#define REG_BK131E_0E_L      0x131E1C
#define REG_BK131E_0E_H      0x131E1D
#define REG_BK131E_0F_L      0x131E1E
#define REG_BK131E_0F_H      0x131E1F
#define REG_BK131E_10_L      0x131E20
#define REG_BK131E_10_H      0x131E21
#define REG_BK131E_11_L      0x131E22
#define REG_BK131E_11_H      0x131E23
#define REG_BK131E_12_L      0x131E24
#define REG_BK131E_12_H      0x131E25
#define REG_BK131E_13_L      0x131E26
#define REG_BK131E_13_H      0x131E27
#define REG_BK131E_14_L      0x131E28
#define REG_BK131E_14_H      0x131E29
#define REG_BK131E_15_L      0x131E2A
#define REG_BK131E_15_H      0x131E2B
#define REG_BK131E_16_L      0x131E2C
#define REG_BK131E_16_H      0x131E2D
#define REG_BK131E_17_L      0x131E2E
#define REG_BK131E_17_H      0x131E2F
#define REG_BK131E_18_L      0x131E30
#define REG_BK131E_18_H      0x131E31
#define REG_BK131E_19_L      0x131E32
#define REG_BK131E_19_H      0x131E33
#define REG_BK131E_1A_L      0x131E34
#define REG_BK131E_1A_H      0x131E35
#define REG_BK131E_1B_L      0x131E36
#define REG_BK131E_1B_H      0x131E37
#define REG_BK131E_1C_L      0x131E38
#define REG_BK131E_1C_H      0x131E39
#define REG_BK131E_1D_L      0x131E3A
#define REG_BK131E_1D_H      0x131E3B
#define REG_BK131E_1E_L      0x131E3C
#define REG_BK131E_1E_H      0x131E3D
#define REG_BK131E_1F_L      0x131E3E
#define REG_BK131E_1F_H      0x131E3F
#define REG_BK131E_20_L      0x131E40
#define REG_BK131E_20_H      0x131E41
#define REG_BK131E_21_L      0x131E42
#define REG_BK131E_21_H      0x131E43
#define REG_BK131E_22_L      0x131E44
#define REG_BK131E_22_H      0x131E45
#define REG_BK131E_23_L      0x131E46
#define REG_BK131E_23_H      0x131E47
#define REG_BK131E_24_L      0x131E48
#define REG_BK131E_24_H      0x131E49
#define REG_BK131E_25_L      0x131E4A
#define REG_BK131E_25_H      0x131E4B
#define REG_BK131E_26_L      0x131E4C
#define REG_BK131E_26_H      0x131E4D
#define REG_BK131E_27_L      0x131E4E
#define REG_BK131E_27_H      0x131E4F
#define REG_BK131E_28_L      0x131E50
#define REG_BK131E_28_H      0x131E51
#define REG_BK131E_29_L      0x131E52
#define REG_BK131E_29_H      0x131E53
#define REG_BK131E_2A_L      0x131E54
#define REG_BK131E_2A_H      0x131E55
#define REG_BK131E_2B_L      0x131E56
#define REG_BK131E_2B_H      0x131E57
#define REG_BK131E_2C_L      0x131E58
#define REG_BK131E_2C_H      0x131E59
#define REG_BK131E_2D_L      0x131E5A
#define REG_BK131E_2D_H      0x131E5B
#define REG_BK131E_2E_L      0x131E5C
#define REG_BK131E_2E_H      0x131E5D
#define REG_BK131E_2F_L      0x131E5E
#define REG_BK131E_2F_H      0x131E5F
#define REG_BK131E_30_L      0x131E60
#define REG_BK131E_30_H      0x131E61
#define REG_BK131E_31_L      0x131E62
#define REG_BK131E_31_H      0x131E63
#define REG_BK131E_32_L      0x131E64
#define REG_BK131E_32_H      0x131E65
#define REG_BK131E_33_L      0x131E66
#define REG_BK131E_33_H      0x131E67
#define REG_BK131E_34_L      0x131E68
#define REG_BK131E_34_H      0x131E69
#define REG_BK131E_35_L      0x131E6A
#define REG_BK131E_35_H      0x131E6B
#define REG_BK131E_36_L      0x131E6C
#define REG_BK131E_36_H      0x131E6D
#define REG_BK131E_37_L      0x131E6E
#define REG_BK131E_37_H      0x131E6F
#define REG_BK131E_38_L      0x131E70
#define REG_BK131E_38_H      0x131E71
#define REG_BK131E_39_L      0x131E72
#define REG_BK131E_39_H      0x131E73
#define REG_BK131E_3A_L      0x131E74
#define REG_BK131E_3A_H      0x131E75
#define REG_BK131E_3B_L      0x131E76
#define REG_BK131E_3B_H      0x131E77
#define REG_BK131E_3C_L      0x131E78
#define REG_BK131E_3C_H      0x131E79
#define REG_BK131E_3D_L      0x131E7A
#define REG_BK131E_3D_H      0x131E7B
#define REG_BK131E_3E_L      0x131E7C
#define REG_BK131E_3E_H      0x131E7D
#define REG_BK131E_3F_L      0x131E7E
#define REG_BK131E_3F_H      0x131E7F
#define REG_BK131E_40_L      0x131E80
#define REG_BK131E_40_H      0x131E81
#define REG_BK131E_41_L      0x131E82
#define REG_BK131E_41_H      0x131E83
#define REG_BK131E_42_L      0x131E84
#define REG_BK131E_42_H      0x131E85
#define REG_BK131E_43_L      0x131E86
#define REG_BK131E_43_H      0x131E87
#define REG_BK131E_44_L      0x131E88
#define REG_BK131E_44_H      0x131E89
#define REG_BK131E_45_L      0x131E8A
#define REG_BK131E_45_H      0x131E8B
#define REG_BK131E_46_L      0x131E8C
#define REG_BK131E_46_H      0x131E8D
#define REG_BK131E_47_L      0x131E8E
#define REG_BK131E_47_H      0x131E8F
#define REG_BK131E_48_L      0x131E90
#define REG_BK131E_48_H      0x131E91
#define REG_BK131E_49_L      0x131E92
#define REG_BK131E_49_H      0x131E93
#define REG_BK131E_4A_L      0x131E94
#define REG_BK131E_4A_H      0x131E95
#define REG_BK131E_4B_L      0x131E96
#define REG_BK131E_4B_H      0x131E97
#define REG_BK131E_4C_L      0x131E98
#define REG_BK131E_4C_H      0x131E99
#define REG_BK131E_4D_L      0x131E9A
#define REG_BK131E_4D_H      0x131E9B
#define REG_BK131E_4E_L      0x131E9C
#define REG_BK131E_4E_H      0x131E9D
#define REG_BK131E_4F_L      0x131E9E
#define REG_BK131E_4F_H      0x131E9F
#define REG_BK131E_50_L      0x131EA0
#define REG_BK131E_50_H      0x131EA1
#define REG_BK131E_51_L      0x131EA2
#define REG_BK131E_51_H      0x131EA3
#define REG_BK131E_52_L      0x131EA4
#define REG_BK131E_52_H      0x131EA5
#define REG_BK131E_53_L      0x131EA6
#define REG_BK131E_53_H      0x131EA7
#define REG_BK131E_54_L      0x131EA8
#define REG_BK131E_54_H      0x131EA9
#define REG_BK131E_55_L      0x131EAA
#define REG_BK131E_55_H      0x131EAB
#define REG_BK131E_56_L      0x131EAC
#define REG_BK131E_56_H      0x131EAD
#define REG_BK131E_57_L      0x131EAE
#define REG_BK131E_57_H      0x131EAF
#define REG_BK131E_58_L      0x131EB0
#define REG_BK131E_58_H      0x131EB1
#define REG_BK131E_59_L      0x131EB2
#define REG_BK131E_59_H      0x131EB3
#define REG_BK131E_5A_L      0x131EB4
#define REG_BK131E_5A_H      0x131EB5
#define REG_BK131E_5B_L      0x131EB6
#define REG_BK131E_5B_H      0x131EB7
#define REG_BK131E_5C_L      0x131EB8
#define REG_BK131E_5C_H      0x131EB9
#define REG_BK131E_5D_L      0x131EBA
#define REG_BK131E_5D_H      0x131EBB
#define REG_BK131E_5E_L      0x131EBC
#define REG_BK131E_5E_H      0x131EBD
#define REG_BK131E_5F_L      0x131EBE
#define REG_BK131E_5F_H      0x131EBF
#define REG_BK131E_60_L      0x131EC0
#define REG_BK131E_60_H      0x131EC1
#define REG_BK131E_61_L      0x131EC2
#define REG_BK131E_61_H      0x131EC3
#define REG_BK131E_62_L      0x131EC4
#define REG_BK131E_62_H      0x131EC5
#define REG_BK131E_63_L      0x131EC6
#define REG_BK131E_63_H      0x131EC7
#define REG_BK131E_64_L      0x131EC8
#define REG_BK131E_64_H      0x131EC9
#define REG_BK131E_65_L      0x131ECA
#define REG_BK131E_65_H      0x131ECB
#define REG_BK131E_66_L      0x131ECC
#define REG_BK131E_66_H      0x131ECD
#define REG_BK131E_67_L      0x131ECE
#define REG_BK131E_67_H      0x131ECF
#define REG_BK131E_68_L      0x131ED0
#define REG_BK131E_68_H      0x131ED1
#define REG_BK131E_69_L      0x131ED2
#define REG_BK131E_69_H      0x131ED3
#define REG_BK131E_6A_L      0x131ED4
#define REG_BK131E_6A_H      0x131ED5
#define REG_BK131E_6B_L      0x131ED6
#define REG_BK131E_6B_H      0x131ED7
#define REG_BK131E_6C_L      0x131ED8
#define REG_BK131E_6C_H      0x131ED9
#define REG_BK131E_6D_L      0x131EDA
#define REG_BK131E_6D_H      0x131EDB
#define REG_BK131E_6E_L      0x131EDC
#define REG_BK131E_6E_H      0x131EDD
#define REG_BK131E_6F_L      0x131EDE
#define REG_BK131E_6F_H      0x131EDF
#define REG_BK131E_70_L      0x131EE0
#define REG_BK131E_70_H      0x131EE1
#define REG_BK131E_71_L      0x131EE2
#define REG_BK131E_71_H      0x131EE3
#define REG_BK131E_72_L      0x131EE4
#define REG_BK131E_72_H      0x131EE5
#define REG_BK131E_73_L      0x131EE6
#define REG_BK131E_73_H      0x131EE7
#define REG_BK131E_74_L      0x131EE8
#define REG_BK131E_74_H      0x131EE9
#define REG_BK131E_75_L      0x131EEA
#define REG_BK131E_75_H      0x131EEB
#define REG_BK131E_76_L      0x131EEC
#define REG_BK131E_76_H      0x131EED
#define REG_BK131E_77_L      0x131EEE
#define REG_BK131E_77_H      0x131EEF
#define REG_BK131E_78_L      0x131EF0
#define REG_BK131E_78_H      0x131EF1
#define REG_BK131E_79_L      0x131EF2
#define REG_BK131E_79_H      0x131EF3
#define REG_BK131E_7A_L      0x131EF4
#define REG_BK131E_7A_H      0x131EF5
#define REG_BK131E_7B_L      0x131EF6
#define REG_BK131E_7B_H      0x131EF7
#define REG_BK131E_7C_L      0x131EF8
#define REG_BK131E_7C_H      0x131EF9
#define REG_BK131E_7D_L      0x131EFA
#define REG_BK131E_7D_H      0x131EFB
#define REG_BK131E_7E_L      0x131EFC
#define REG_BK131E_7E_H      0x131EFD
#define REG_BK131E_7F_L      0x131EFE
#define REG_BK131E_7F_H      0x131EFF
//----------------------------------------------
#define REG_BK131F_00_L      0x131F00
#define REG_BK131F_00_H      0x131F01
#define REG_BK131F_01_L      0x131F02
#define REG_BK131F_01_H      0x131F03
#define REG_BK131F_02_L      0x131F04
#define REG_BK131F_02_H      0x131F05
#define REG_BK131F_03_L      0x131F06
#define REG_BK131F_03_H      0x131F07
#define REG_BK131F_04_L      0x131F08
#define REG_BK131F_04_H      0x131F09
#define REG_BK131F_05_L      0x131F0A
#define REG_BK131F_05_H      0x131F0B
#define REG_BK131F_06_L      0x131F0C
#define REG_BK131F_06_H      0x131F0D
#define REG_BK131F_07_L      0x131F0E
#define REG_BK131F_07_H      0x131F0F
#define REG_BK131F_08_L      0x131F10
#define REG_BK131F_08_H      0x131F11
#define REG_BK131F_09_L      0x131F12
#define REG_BK131F_09_H      0x131F13
#define REG_BK131F_0A_L      0x131F14
#define REG_BK131F_0A_H      0x131F15
#define REG_BK131F_0B_L      0x131F16
#define REG_BK131F_0B_H      0x131F17
#define REG_BK131F_0C_L      0x131F18
#define REG_BK131F_0C_H      0x131F19
#define REG_BK131F_0D_L      0x131F1A
#define REG_BK131F_0D_H      0x131F1B
#define REG_BK131F_0E_L      0x131F1C
#define REG_BK131F_0E_H      0x131F1D
#define REG_BK131F_0F_L      0x131F1E
#define REG_BK131F_0F_H      0x131F1F
#define REG_BK131F_10_L      0x131F20
#define REG_BK131F_10_H      0x131F21
#define REG_BK131F_11_L      0x131F22
#define REG_BK131F_11_H      0x131F23
#define REG_BK131F_12_L      0x131F24
#define REG_BK131F_12_H      0x131F25
#define REG_BK131F_13_L      0x131F26
#define REG_BK131F_13_H      0x131F27
#define REG_BK131F_14_L      0x131F28
#define REG_BK131F_14_H      0x131F29
#define REG_BK131F_15_L      0x131F2A
#define REG_BK131F_15_H      0x131F2B
#define REG_BK131F_16_L      0x131F2C
#define REG_BK131F_16_H      0x131F2D
#define REG_BK131F_17_L      0x131F2E
#define REG_BK131F_17_H      0x131F2F
#define REG_BK131F_18_L      0x131F30
#define REG_BK131F_18_H      0x131F31
#define REG_BK131F_19_L      0x131F32
#define REG_BK131F_19_H      0x131F33
#define REG_BK131F_1A_L      0x131F34
#define REG_BK131F_1A_H      0x131F35
#define REG_BK131F_1B_L      0x131F36
#define REG_BK131F_1B_H      0x131F37
#define REG_BK131F_1C_L      0x131F38
#define REG_BK131F_1C_H      0x131F39
#define REG_BK131F_1D_L      0x131F3A
#define REG_BK131F_1D_H      0x131F3B
#define REG_BK131F_1E_L      0x131F3C
#define REG_BK131F_1E_H      0x131F3D
#define REG_BK131F_1F_L      0x131F3E
#define REG_BK131F_1F_H      0x131F3F
#define REG_BK131F_20_L      0x131F40
#define REG_BK131F_20_H      0x131F41
#define REG_BK131F_21_L      0x131F42
#define REG_BK131F_21_H      0x131F43
#define REG_BK131F_22_L      0x131F44
#define REG_BK131F_22_H      0x131F45
#define REG_BK131F_23_L      0x131F46
#define REG_BK131F_23_H      0x131F47
#define REG_BK131F_24_L      0x131F48
#define REG_BK131F_24_H      0x131F49
#define REG_BK131F_25_L      0x131F4A
#define REG_BK131F_25_H      0x131F4B
#define REG_BK131F_26_L      0x131F4C
#define REG_BK131F_26_H      0x131F4D
#define REG_BK131F_27_L      0x131F4E
#define REG_BK131F_27_H      0x131F4F
#define REG_BK131F_28_L      0x131F50
#define REG_BK131F_28_H      0x131F51
#define REG_BK131F_29_L      0x131F52
#define REG_BK131F_29_H      0x131F53
#define REG_BK131F_2A_L      0x131F54
#define REG_BK131F_2A_H      0x131F55
#define REG_BK131F_2B_L      0x131F56
#define REG_BK131F_2B_H      0x131F57
#define REG_BK131F_2C_L      0x131F58
#define REG_BK131F_2C_H      0x131F59
#define REG_BK131F_2D_L      0x131F5A
#define REG_BK131F_2D_H      0x131F5B
#define REG_BK131F_2E_L      0x131F5C
#define REG_BK131F_2E_H      0x131F5D
#define REG_BK131F_2F_L      0x131F5E
#define REG_BK131F_2F_H      0x131F5F
#define REG_BK131F_30_L      0x131F60
#define REG_BK131F_30_H      0x131F61
#define REG_BK131F_31_L      0x131F62
#define REG_BK131F_31_H      0x131F63
#define REG_BK131F_32_L      0x131F64
#define REG_BK131F_32_H      0x131F65
#define REG_BK131F_33_L      0x131F66
#define REG_BK131F_33_H      0x131F67
#define REG_BK131F_34_L      0x131F68
#define REG_BK131F_34_H      0x131F69
#define REG_BK131F_35_L      0x131F6A
#define REG_BK131F_35_H      0x131F6B
#define REG_BK131F_36_L      0x131F6C
#define REG_BK131F_36_H      0x131F6D
#define REG_BK131F_37_L      0x131F6E
#define REG_BK131F_37_H      0x131F6F
#define REG_BK131F_38_L      0x131F70
#define REG_BK131F_38_H      0x131F71
#define REG_BK131F_39_L      0x131F72
#define REG_BK131F_39_H      0x131F73
#define REG_BK131F_3A_L      0x131F74
#define REG_BK131F_3A_H      0x131F75
#define REG_BK131F_3B_L      0x131F76
#define REG_BK131F_3B_H      0x131F77
#define REG_BK131F_3C_L      0x131F78
#define REG_BK131F_3C_H      0x131F79
#define REG_BK131F_3D_L      0x131F7A
#define REG_BK131F_3D_H      0x131F7B
#define REG_BK131F_3E_L      0x131F7C
#define REG_BK131F_3E_H      0x131F7D
#define REG_BK131F_3F_L      0x131F7E
#define REG_BK131F_3F_H      0x131F7F
#define REG_BK131F_40_L      0x131F80
#define REG_BK131F_40_H      0x131F81
#define REG_BK131F_41_L      0x131F82
#define REG_BK131F_41_H      0x131F83
#define REG_BK131F_42_L      0x131F84
#define REG_BK131F_42_H      0x131F85
#define REG_BK131F_43_L      0x131F86
#define REG_BK131F_43_H      0x131F87
#define REG_BK131F_44_L      0x131F88
#define REG_BK131F_44_H      0x131F89
#define REG_BK131F_45_L      0x131F8A
#define REG_BK131F_45_H      0x131F8B
#define REG_BK131F_46_L      0x131F8C
#define REG_BK131F_46_H      0x131F8D
#define REG_BK131F_47_L      0x131F8E
#define REG_BK131F_47_H      0x131F8F
#define REG_BK131F_48_L      0x131F90
#define REG_BK131F_48_H      0x131F91
#define REG_BK131F_49_L      0x131F92
#define REG_BK131F_49_H      0x131F93
#define REG_BK131F_4A_L      0x131F94
#define REG_BK131F_4A_H      0x131F95
#define REG_BK131F_4B_L      0x131F96
#define REG_BK131F_4B_H      0x131F97
#define REG_BK131F_4C_L      0x131F98
#define REG_BK131F_4C_H      0x131F99
#define REG_BK131F_4D_L      0x131F9A
#define REG_BK131F_4D_H      0x131F9B
#define REG_BK131F_4E_L      0x131F9C
#define REG_BK131F_4E_H      0x131F9D
#define REG_BK131F_4F_L      0x131F9E
#define REG_BK131F_4F_H      0x131F9F
#define REG_BK131F_50_L      0x131FA0
#define REG_BK131F_50_H      0x131FA1
#define REG_BK131F_51_L      0x131FA2
#define REG_BK131F_51_H      0x131FA3
#define REG_BK131F_52_L      0x131FA4
#define REG_BK131F_52_H      0x131FA5
#define REG_BK131F_53_L      0x131FA6
#define REG_BK131F_53_H      0x131FA7
#define REG_BK131F_54_L      0x131FA8
#define REG_BK131F_54_H      0x131FA9
#define REG_BK131F_55_L      0x131FAA
#define REG_BK131F_55_H      0x131FAB
#define REG_BK131F_56_L      0x131FAC
#define REG_BK131F_56_H      0x131FAD
#define REG_BK131F_57_L      0x131FAE
#define REG_BK131F_57_H      0x131FAF
#define REG_BK131F_58_L      0x131FB0
#define REG_BK131F_58_H      0x131FB1
#define REG_BK131F_59_L      0x131FB2
#define REG_BK131F_59_H      0x131FB3
#define REG_BK131F_5A_L      0x131FB4
#define REG_BK131F_5A_H      0x131FB5
#define REG_BK131F_5B_L      0x131FB6
#define REG_BK131F_5B_H      0x131FB7
#define REG_BK131F_5C_L      0x131FB8
#define REG_BK131F_5C_H      0x131FB9
#define REG_BK131F_5D_L      0x131FBA
#define REG_BK131F_5D_H      0x131FBB
#define REG_BK131F_5E_L      0x131FBC
#define REG_BK131F_5E_H      0x131FBD
#define REG_BK131F_5F_L      0x131FBE
#define REG_BK131F_5F_H      0x131FBF
#define REG_BK131F_60_L      0x131FC0
#define REG_BK131F_60_H      0x131FC1
#define REG_BK131F_61_L      0x131FC2
#define REG_BK131F_61_H      0x131FC3
#define REG_BK131F_62_L      0x131FC4
#define REG_BK131F_62_H      0x131FC5
#define REG_BK131F_63_L      0x131FC6
#define REG_BK131F_63_H      0x131FC7
#define REG_BK131F_64_L      0x131FC8
#define REG_BK131F_64_H      0x131FC9
#define REG_BK131F_65_L      0x131FCA
#define REG_BK131F_65_H      0x131FCB
#define REG_BK131F_66_L      0x131FCC
#define REG_BK131F_66_H      0x131FCD
#define REG_BK131F_67_L      0x131FCE
#define REG_BK131F_67_H      0x131FCF
#define REG_BK131F_68_L      0x131FD0
#define REG_BK131F_68_H      0x131FD1
#define REG_BK131F_69_L      0x131FD2
#define REG_BK131F_69_H      0x131FD3
#define REG_BK131F_6A_L      0x131FD4
#define REG_BK131F_6A_H      0x131FD5
#define REG_BK131F_6B_L      0x131FD6
#define REG_BK131F_6B_H      0x131FD7
#define REG_BK131F_6C_L      0x131FD8
#define REG_BK131F_6C_H      0x131FD9
#define REG_BK131F_6D_L      0x131FDA
#define REG_BK131F_6D_H      0x131FDB
#define REG_BK131F_6E_L      0x131FDC
#define REG_BK131F_6E_H      0x131FDD
#define REG_BK131F_6F_L      0x131FDE
#define REG_BK131F_6F_H      0x131FDF
#define REG_BK131F_70_L      0x131FE0
#define REG_BK131F_70_H      0x131FE1
#define REG_BK131F_71_L      0x131FE2
#define REG_BK131F_71_H      0x131FE3
#define REG_BK131F_72_L      0x131FE4
#define REG_BK131F_72_H      0x131FE5
#define REG_BK131F_73_L      0x131FE6
#define REG_BK131F_73_H      0x131FE7
#define REG_BK131F_74_L      0x131FE8
#define REG_BK131F_74_H      0x131FE9
#define REG_BK131F_75_L      0x131FEA
#define REG_BK131F_75_H      0x131FEB
#define REG_BK131F_76_L      0x131FEC
#define REG_BK131F_76_H      0x131FED
#define REG_BK131F_77_L      0x131FEE
#define REG_BK131F_77_H      0x131FEF
#define REG_BK131F_78_L      0x131FF0
#define REG_BK131F_78_H      0x131FF1
#define REG_BK131F_79_L      0x131FF2
#define REG_BK131F_79_H      0x131FF3
#define REG_BK131F_7A_L      0x131FF4
#define REG_BK131F_7A_H      0x131FF5
#define REG_BK131F_7B_L      0x131FF6
#define REG_BK131F_7B_H      0x131FF7
#define REG_BK131F_7C_L      0x131FF8
#define REG_BK131F_7C_H      0x131FF9
#define REG_BK131F_7D_L      0x131FFA
#define REG_BK131F_7D_H      0x131FFB
#define REG_BK131F_7E_L      0x131FFC
#define REG_BK131F_7E_H      0x131FFD
#define REG_BK131F_7F_L      0x131FFE
#define REG_BK131F_7F_H      0x131FFF
//----------------------------------------------
#define REG_BK1320_00_L      0x132000
#define REG_BK1320_00_H      0x132001
#define REG_BK1320_01_L      0x132002
#define REG_BK1320_01_H      0x132003
#define REG_BK1320_02_L      0x132004
#define REG_BK1320_02_H      0x132005
#define REG_BK1320_03_L      0x132006
#define REG_BK1320_03_H      0x132007
#define REG_BK1320_04_L      0x132008
#define REG_BK1320_04_H      0x132009
#define REG_BK1320_05_L      0x13200A
#define REG_BK1320_05_H      0x13200B
#define REG_BK1320_06_L      0x13200C
#define REG_BK1320_06_H      0x13200D
#define REG_BK1320_07_L      0x13200E
#define REG_BK1320_07_H      0x13200F
#define REG_BK1320_08_L      0x132010
#define REG_BK1320_08_H      0x132011
#define REG_BK1320_09_L      0x132012
#define REG_BK1320_09_H      0x132013
#define REG_BK1320_0A_L      0x132014
#define REG_BK1320_0A_H      0x132015
#define REG_BK1320_0B_L      0x132016
#define REG_BK1320_0B_H      0x132017
#define REG_BK1320_0C_L      0x132018
#define REG_BK1320_0C_H      0x132019
#define REG_BK1320_0D_L      0x13201A
#define REG_BK1320_0D_H      0x13201B
#define REG_BK1320_0E_L      0x13201C
#define REG_BK1320_0E_H      0x13201D
#define REG_BK1320_0F_L      0x13201E
#define REG_BK1320_0F_H      0x13201F
#define REG_BK1320_10_L      0x132020
#define REG_BK1320_10_H      0x132021
#define REG_BK1320_11_L      0x132022
#define REG_BK1320_11_H      0x132023
#define REG_BK1320_12_L      0x132024
#define REG_BK1320_12_H      0x132025
#define REG_BK1320_13_L      0x132026
#define REG_BK1320_13_H      0x132027
#define REG_BK1320_14_L      0x132028
#define REG_BK1320_14_H      0x132029
#define REG_BK1320_15_L      0x13202A
#define REG_BK1320_15_H      0x13202B
#define REG_BK1320_16_L      0x13202C
#define REG_BK1320_16_H      0x13202D
#define REG_BK1320_17_L      0x13202E
#define REG_BK1320_17_H      0x13202F
#define REG_BK1320_18_L      0x132030
#define REG_BK1320_18_H      0x132031
#define REG_BK1320_19_L      0x132032
#define REG_BK1320_19_H      0x132033
#define REG_BK1320_1A_L      0x132034
#define REG_BK1320_1A_H      0x132035
#define REG_BK1320_1B_L      0x132036
#define REG_BK1320_1B_H      0x132037
#define REG_BK1320_1C_L      0x132038
#define REG_BK1320_1C_H      0x132039
#define REG_BK1320_1D_L      0x13203A
#define REG_BK1320_1D_H      0x13203B
#define REG_BK1320_1E_L      0x13203C
#define REG_BK1320_1E_H      0x13203D
#define REG_BK1320_1F_L      0x13203E
#define REG_BK1320_1F_H      0x13203F
#define REG_BK1320_20_L      0x132040
#define REG_BK1320_20_H      0x132041
#define REG_BK1320_21_L      0x132042
#define REG_BK1320_21_H      0x132043
#define REG_BK1320_22_L      0x132044
#define REG_BK1320_22_H      0x132045
#define REG_BK1320_23_L      0x132046
#define REG_BK1320_23_H      0x132047
#define REG_BK1320_24_L      0x132048
#define REG_BK1320_24_H      0x132049
#define REG_BK1320_25_L      0x13204A
#define REG_BK1320_25_H      0x13204B
#define REG_BK1320_26_L      0x13204C
#define REG_BK1320_26_H      0x13204D
#define REG_BK1320_27_L      0x13204E
#define REG_BK1320_27_H      0x13204F
#define REG_BK1320_28_L      0x132050
#define REG_BK1320_28_H      0x132051
#define REG_BK1320_29_L      0x132052
#define REG_BK1320_29_H      0x132053
#define REG_BK1320_2A_L      0x132054
#define REG_BK1320_2A_H      0x132055
#define REG_BK1320_2B_L      0x132056
#define REG_BK1320_2B_H      0x132057
#define REG_BK1320_2C_L      0x132058
#define REG_BK1320_2C_H      0x132059
#define REG_BK1320_2D_L      0x13205A
#define REG_BK1320_2D_H      0x13205B
#define REG_BK1320_2E_L      0x13205C
#define REG_BK1320_2E_H      0x13205D
#define REG_BK1320_2F_L      0x13205E
#define REG_BK1320_2F_H      0x13205F
#define REG_BK1320_30_L      0x132060
#define REG_BK1320_30_H      0x132061
#define REG_BK1320_31_L      0x132062
#define REG_BK1320_31_H      0x132063
#define REG_BK1320_32_L      0x132064
#define REG_BK1320_32_H      0x132065
#define REG_BK1320_33_L      0x132066
#define REG_BK1320_33_H      0x132067
#define REG_BK1320_34_L      0x132068
#define REG_BK1320_34_H      0x132069
#define REG_BK1320_35_L      0x13206A
#define REG_BK1320_35_H      0x13206B
#define REG_BK1320_36_L      0x13206C
#define REG_BK1320_36_H      0x13206D
#define REG_BK1320_37_L      0x13206E
#define REG_BK1320_37_H      0x13206F
#define REG_BK1320_38_L      0x132070
#define REG_BK1320_38_H      0x132071
#define REG_BK1320_39_L      0x132072
#define REG_BK1320_39_H      0x132073
#define REG_BK1320_3A_L      0x132074
#define REG_BK1320_3A_H      0x132075
#define REG_BK1320_3B_L      0x132076
#define REG_BK1320_3B_H      0x132077
#define REG_BK1320_3C_L      0x132078
#define REG_BK1320_3C_H      0x132079
#define REG_BK1320_3D_L      0x13207A
#define REG_BK1320_3D_H      0x13207B
#define REG_BK1320_3E_L      0x13207C
#define REG_BK1320_3E_H      0x13207D
#define REG_BK1320_3F_L      0x13207E
#define REG_BK1320_3F_H      0x13207F
#define REG_BK1320_40_L      0x132080
#define REG_BK1320_40_H      0x132081
#define REG_BK1320_41_L      0x132082
#define REG_BK1320_41_H      0x132083
#define REG_BK1320_42_L      0x132084
#define REG_BK1320_42_H      0x132085
#define REG_BK1320_43_L      0x132086
#define REG_BK1320_43_H      0x132087
#define REG_BK1320_44_L      0x132088
#define REG_BK1320_44_H      0x132089
#define REG_BK1320_45_L      0x13208A
#define REG_BK1320_45_H      0x13208B
#define REG_BK1320_46_L      0x13208C
#define REG_BK1320_46_H      0x13208D
#define REG_BK1320_47_L      0x13208E
#define REG_BK1320_47_H      0x13208F
#define REG_BK1320_48_L      0x132090
#define REG_BK1320_48_H      0x132091
#define REG_BK1320_49_L      0x132092
#define REG_BK1320_49_H      0x132093
#define REG_BK1320_4A_L      0x132094
#define REG_BK1320_4A_H      0x132095
#define REG_BK1320_4B_L      0x132096
#define REG_BK1320_4B_H      0x132097
#define REG_BK1320_4C_L      0x132098
#define REG_BK1320_4C_H      0x132099
#define REG_BK1320_4D_L      0x13209A
#define REG_BK1320_4D_H      0x13209B
#define REG_BK1320_4E_L      0x13209C
#define REG_BK1320_4E_H      0x13209D
#define REG_BK1320_4F_L      0x13209E
#define REG_BK1320_4F_H      0x13209F
#define REG_BK1320_50_L      0x1320A0
#define REG_BK1320_50_H      0x1320A1
#define REG_BK1320_51_L      0x1320A2
#define REG_BK1320_51_H      0x1320A3
#define REG_BK1320_52_L      0x1320A4
#define REG_BK1320_52_H      0x1320A5
#define REG_BK1320_53_L      0x1320A6
#define REG_BK1320_53_H      0x1320A7
#define REG_BK1320_54_L      0x1320A8
#define REG_BK1320_54_H      0x1320A9
#define REG_BK1320_55_L      0x1320AA
#define REG_BK1320_55_H      0x1320AB
#define REG_BK1320_56_L      0x1320AC
#define REG_BK1320_56_H      0x1320AD
#define REG_BK1320_57_L      0x1320AE
#define REG_BK1320_57_H      0x1320AF
#define REG_BK1320_58_L      0x1320B0
#define REG_BK1320_58_H      0x1320B1
#define REG_BK1320_59_L      0x1320B2
#define REG_BK1320_59_H      0x1320B3
#define REG_BK1320_5A_L      0x1320B4
#define REG_BK1320_5A_H      0x1320B5
#define REG_BK1320_5B_L      0x1320B6
#define REG_BK1320_5B_H      0x1320B7
#define REG_BK1320_5C_L      0x1320B8
#define REG_BK1320_5C_H      0x1320B9
#define REG_BK1320_5D_L      0x1320BA
#define REG_BK1320_5D_H      0x1320BB
#define REG_BK1320_5E_L      0x1320BC
#define REG_BK1320_5E_H      0x1320BD
#define REG_BK1320_5F_L      0x1320BE
#define REG_BK1320_5F_H      0x1320BF
#define REG_BK1320_60_L      0x1320C0
#define REG_BK1320_60_H      0x1320C1
#define REG_BK1320_61_L      0x1320C2
#define REG_BK1320_61_H      0x1320C3
#define REG_BK1320_62_L      0x1320C4
#define REG_BK1320_62_H      0x1320C5
#define REG_BK1320_63_L      0x1320C6
#define REG_BK1320_63_H      0x1320C7
#define REG_BK1320_64_L      0x1320C8
#define REG_BK1320_64_H      0x1320C9
#define REG_BK1320_65_L      0x1320CA
#define REG_BK1320_65_H      0x1320CB
#define REG_BK1320_66_L      0x1320CC
#define REG_BK1320_66_H      0x1320CD
#define REG_BK1320_67_L      0x1320CE
#define REG_BK1320_67_H      0x1320CF
#define REG_BK1320_68_L      0x1320D0
#define REG_BK1320_68_H      0x1320D1
#define REG_BK1320_69_L      0x1320D2
#define REG_BK1320_69_H      0x1320D3
#define REG_BK1320_6A_L      0x1320D4
#define REG_BK1320_6A_H      0x1320D5
#define REG_BK1320_6B_L      0x1320D6
#define REG_BK1320_6B_H      0x1320D7
#define REG_BK1320_6C_L      0x1320D8
#define REG_BK1320_6C_H      0x1320D9
#define REG_BK1320_6D_L      0x1320DA
#define REG_BK1320_6D_H      0x1320DB
#define REG_BK1320_6E_L      0x1320DC
#define REG_BK1320_6E_H      0x1320DD
#define REG_BK1320_6F_L      0x1320DE
#define REG_BK1320_6F_H      0x1320DF
#define REG_BK1320_70_L      0x1320E0
#define REG_BK1320_70_H      0x1320E1
#define REG_BK1320_71_L      0x1320E2
#define REG_BK1320_71_H      0x1320E3
#define REG_BK1320_72_L      0x1320E4
#define REG_BK1320_72_H      0x1320E5
#define REG_BK1320_73_L      0x1320E6
#define REG_BK1320_73_H      0x1320E7
#define REG_BK1320_74_L      0x1320E8
#define REG_BK1320_74_H      0x1320E9
#define REG_BK1320_75_L      0x1320EA
#define REG_BK1320_75_H      0x1320EB
#define REG_BK1320_76_L      0x1320EC
#define REG_BK1320_76_H      0x1320ED
#define REG_BK1320_77_L      0x1320EE
#define REG_BK1320_77_H      0x1320EF
#define REG_BK1320_78_L      0x1320F0
#define REG_BK1320_78_H      0x1320F1
#define REG_BK1320_79_L      0x1320F2
#define REG_BK1320_79_H      0x1320F3
#define REG_BK1320_7A_L      0x1320F4
#define REG_BK1320_7A_H      0x1320F5
#define REG_BK1320_7B_L      0x1320F6
#define REG_BK1320_7B_H      0x1320F7
#define REG_BK1320_7C_L      0x1320F8
#define REG_BK1320_7C_H      0x1320F9
#define REG_BK1320_7D_L      0x1320FA
#define REG_BK1320_7D_H      0x1320FB
#define REG_BK1320_7E_L      0x1320FC
#define REG_BK1320_7E_H      0x1320FD
#define REG_BK1320_7F_L      0x1320FE
#define REG_BK1320_7F_H      0x1320FF
//----------------------------------------------
#define REG_BK1321_00_L      0x132100
#define REG_BK1321_00_H      0x132101
#define REG_BK1321_01_L      0x132102
#define REG_BK1321_01_H      0x132103
#define REG_BK1321_02_L      0x132104
#define REG_BK1321_02_H      0x132105
#define REG_BK1321_03_L      0x132106
#define REG_BK1321_03_H      0x132107
#define REG_BK1321_04_L      0x132108
#define REG_BK1321_04_H      0x132109
#define REG_BK1321_05_L      0x13210A
#define REG_BK1321_05_H      0x13210B
#define REG_BK1321_06_L      0x13210C
#define REG_BK1321_06_H      0x13210D
#define REG_BK1321_07_L      0x13210E
#define REG_BK1321_07_H      0x13210F
#define REG_BK1321_08_L      0x132110
#define REG_BK1321_08_H      0x132111
#define REG_BK1321_09_L      0x132112
#define REG_BK1321_09_H      0x132113
#define REG_BK1321_0A_L      0x132114
#define REG_BK1321_0A_H      0x132115
#define REG_BK1321_0B_L      0x132116
#define REG_BK1321_0B_H      0x132117
#define REG_BK1321_0C_L      0x132118
#define REG_BK1321_0C_H      0x132119
#define REG_BK1321_0D_L      0x13211A
#define REG_BK1321_0D_H      0x13211B
#define REG_BK1321_0E_L      0x13211C
#define REG_BK1321_0E_H      0x13211D
#define REG_BK1321_0F_L      0x13211E
#define REG_BK1321_0F_H      0x13211F
#define REG_BK1321_10_L      0x132120
#define REG_BK1321_10_H      0x132121
#define REG_BK1321_11_L      0x132122
#define REG_BK1321_11_H      0x132123
#define REG_BK1321_12_L      0x132124
#define REG_BK1321_12_H      0x132125
#define REG_BK1321_13_L      0x132126
#define REG_BK1321_13_H      0x132127
#define REG_BK1321_14_L      0x132128
#define REG_BK1321_14_H      0x132129
#define REG_BK1321_15_L      0x13212A
#define REG_BK1321_15_H      0x13212B
#define REG_BK1321_16_L      0x13212C
#define REG_BK1321_16_H      0x13212D
#define REG_BK1321_17_L      0x13212E
#define REG_BK1321_17_H      0x13212F
#define REG_BK1321_18_L      0x132130
#define REG_BK1321_18_H      0x132131
#define REG_BK1321_19_L      0x132132
#define REG_BK1321_19_H      0x132133
#define REG_BK1321_1A_L      0x132134
#define REG_BK1321_1A_H      0x132135
#define REG_BK1321_1B_L      0x132136
#define REG_BK1321_1B_H      0x132137
#define REG_BK1321_1C_L      0x132138
#define REG_BK1321_1C_H      0x132139
#define REG_BK1321_1D_L      0x13213A
#define REG_BK1321_1D_H      0x13213B
#define REG_BK1321_1E_L      0x13213C
#define REG_BK1321_1E_H      0x13213D
#define REG_BK1321_1F_L      0x13213E
#define REG_BK1321_1F_H      0x13213F
#define REG_BK1321_20_L      0x132140
#define REG_BK1321_20_H      0x132141
#define REG_BK1321_21_L      0x132142
#define REG_BK1321_21_H      0x132143
#define REG_BK1321_22_L      0x132144
#define REG_BK1321_22_H      0x132145
#define REG_BK1321_23_L      0x132146
#define REG_BK1321_23_H      0x132147
#define REG_BK1321_24_L      0x132148
#define REG_BK1321_24_H      0x132149
#define REG_BK1321_25_L      0x13214A
#define REG_BK1321_25_H      0x13214B
#define REG_BK1321_26_L      0x13214C
#define REG_BK1321_26_H      0x13214D
#define REG_BK1321_27_L      0x13214E
#define REG_BK1321_27_H      0x13214F
#define REG_BK1321_28_L      0x132150
#define REG_BK1321_28_H      0x132151
#define REG_BK1321_29_L      0x132152
#define REG_BK1321_29_H      0x132153
#define REG_BK1321_2A_L      0x132154
#define REG_BK1321_2A_H      0x132155
#define REG_BK1321_2B_L      0x132156
#define REG_BK1321_2B_H      0x132157
#define REG_BK1321_2C_L      0x132158
#define REG_BK1321_2C_H      0x132159
#define REG_BK1321_2D_L      0x13215A
#define REG_BK1321_2D_H      0x13215B
#define REG_BK1321_2E_L      0x13215C
#define REG_BK1321_2E_H      0x13215D
#define REG_BK1321_2F_L      0x13215E
#define REG_BK1321_2F_H      0x13215F
#define REG_BK1321_30_L      0x132160
#define REG_BK1321_30_H      0x132161
#define REG_BK1321_31_L      0x132162
#define REG_BK1321_31_H      0x132163
#define REG_BK1321_32_L      0x132164
#define REG_BK1321_32_H      0x132165
#define REG_BK1321_33_L      0x132166
#define REG_BK1321_33_H      0x132167
#define REG_BK1321_34_L      0x132168
#define REG_BK1321_34_H      0x132169
#define REG_BK1321_35_L      0x13216A
#define REG_BK1321_35_H      0x13216B
#define REG_BK1321_36_L      0x13216C
#define REG_BK1321_36_H      0x13216D
#define REG_BK1321_37_L      0x13216E
#define REG_BK1321_37_H      0x13216F
#define REG_BK1321_38_L      0x132170
#define REG_BK1321_38_H      0x132171
#define REG_BK1321_39_L      0x132172
#define REG_BK1321_39_H      0x132173
#define REG_BK1321_3A_L      0x132174
#define REG_BK1321_3A_H      0x132175
#define REG_BK1321_3B_L      0x132176
#define REG_BK1321_3B_H      0x132177
#define REG_BK1321_3C_L      0x132178
#define REG_BK1321_3C_H      0x132179
#define REG_BK1321_3D_L      0x13217A
#define REG_BK1321_3D_H      0x13217B
#define REG_BK1321_3E_L      0x13217C
#define REG_BK1321_3E_H      0x13217D
#define REG_BK1321_3F_L      0x13217E
#define REG_BK1321_3F_H      0x13217F
#define REG_BK1321_40_L      0x132180
#define REG_BK1321_40_H      0x132181
#define REG_BK1321_41_L      0x132182
#define REG_BK1321_41_H      0x132183
#define REG_BK1321_42_L      0x132184
#define REG_BK1321_42_H      0x132185
#define REG_BK1321_43_L      0x132186
#define REG_BK1321_43_H      0x132187
#define REG_BK1321_44_L      0x132188
#define REG_BK1321_44_H      0x132189
#define REG_BK1321_45_L      0x13218A
#define REG_BK1321_45_H      0x13218B
#define REG_BK1321_46_L      0x13218C
#define REG_BK1321_46_H      0x13218D
#define REG_BK1321_47_L      0x13218E
#define REG_BK1321_47_H      0x13218F
#define REG_BK1321_48_L      0x132190
#define REG_BK1321_48_H      0x132191
#define REG_BK1321_49_L      0x132192
#define REG_BK1321_49_H      0x132193
#define REG_BK1321_4A_L      0x132194
#define REG_BK1321_4A_H      0x132195
#define REG_BK1321_4B_L      0x132196
#define REG_BK1321_4B_H      0x132197
#define REG_BK1321_4C_L      0x132198
#define REG_BK1321_4C_H      0x132199
#define REG_BK1321_4D_L      0x13219A
#define REG_BK1321_4D_H      0x13219B
#define REG_BK1321_4E_L      0x13219C
#define REG_BK1321_4E_H      0x13219D
#define REG_BK1321_4F_L      0x13219E
#define REG_BK1321_4F_H      0x13219F
#define REG_BK1321_50_L      0x1321A0
#define REG_BK1321_50_H      0x1321A1
#define REG_BK1321_51_L      0x1321A2
#define REG_BK1321_51_H      0x1321A3
#define REG_BK1321_52_L      0x1321A4
#define REG_BK1321_52_H      0x1321A5
#define REG_BK1321_53_L      0x1321A6
#define REG_BK1321_53_H      0x1321A7
#define REG_BK1321_54_L      0x1321A8
#define REG_BK1321_54_H      0x1321A9
#define REG_BK1321_55_L      0x1321AA
#define REG_BK1321_55_H      0x1321AB
#define REG_BK1321_56_L      0x1321AC
#define REG_BK1321_56_H      0x1321AD
#define REG_BK1321_57_L      0x1321AE
#define REG_BK1321_57_H      0x1321AF
#define REG_BK1321_58_L      0x1321B0
#define REG_BK1321_58_H      0x1321B1
#define REG_BK1321_59_L      0x1321B2
#define REG_BK1321_59_H      0x1321B3
#define REG_BK1321_5A_L      0x1321B4
#define REG_BK1321_5A_H      0x1321B5
#define REG_BK1321_5B_L      0x1321B6
#define REG_BK1321_5B_H      0x1321B7
#define REG_BK1321_5C_L      0x1321B8
#define REG_BK1321_5C_H      0x1321B9
#define REG_BK1321_5D_L      0x1321BA
#define REG_BK1321_5D_H      0x1321BB
#define REG_BK1321_5E_L      0x1321BC
#define REG_BK1321_5E_H      0x1321BD
#define REG_BK1321_5F_L      0x1321BE
#define REG_BK1321_5F_H      0x1321BF
#define REG_BK1321_60_L      0x1321C0
#define REG_BK1321_60_H      0x1321C1
#define REG_BK1321_61_L      0x1321C2
#define REG_BK1321_61_H      0x1321C3
#define REG_BK1321_62_L      0x1321C4
#define REG_BK1321_62_H      0x1321C5
#define REG_BK1321_63_L      0x1321C6
#define REG_BK1321_63_H      0x1321C7
#define REG_BK1321_64_L      0x1321C8
#define REG_BK1321_64_H      0x1321C9
#define REG_BK1321_65_L      0x1321CA
#define REG_BK1321_65_H      0x1321CB
#define REG_BK1321_66_L      0x1321CC
#define REG_BK1321_66_H      0x1321CD
#define REG_BK1321_67_L      0x1321CE
#define REG_BK1321_67_H      0x1321CF
#define REG_BK1321_68_L      0x1321D0
#define REG_BK1321_68_H      0x1321D1
#define REG_BK1321_69_L      0x1321D2
#define REG_BK1321_69_H      0x1321D3
#define REG_BK1321_6A_L      0x1321D4
#define REG_BK1321_6A_H      0x1321D5
#define REG_BK1321_6B_L      0x1321D6
#define REG_BK1321_6B_H      0x1321D7
#define REG_BK1321_6C_L      0x1321D8
#define REG_BK1321_6C_H      0x1321D9
#define REG_BK1321_6D_L      0x1321DA
#define REG_BK1321_6D_H      0x1321DB
#define REG_BK1321_6E_L      0x1321DC
#define REG_BK1321_6E_H      0x1321DD
#define REG_BK1321_6F_L      0x1321DE
#define REG_BK1321_6F_H      0x1321DF
#define REG_BK1321_70_L      0x1321E0
#define REG_BK1321_70_H      0x1321E1
#define REG_BK1321_71_L      0x1321E2
#define REG_BK1321_71_H      0x1321E3
#define REG_BK1321_72_L      0x1321E4
#define REG_BK1321_72_H      0x1321E5
#define REG_BK1321_73_L      0x1321E6
#define REG_BK1321_73_H      0x1321E7
#define REG_BK1321_74_L      0x1321E8
#define REG_BK1321_74_H      0x1321E9
#define REG_BK1321_75_L      0x1321EA
#define REG_BK1321_75_H      0x1321EB
#define REG_BK1321_76_L      0x1321EC
#define REG_BK1321_76_H      0x1321ED
#define REG_BK1321_77_L      0x1321EE
#define REG_BK1321_77_H      0x1321EF
#define REG_BK1321_78_L      0x1321F0
#define REG_BK1321_78_H      0x1321F1
#define REG_BK1321_79_L      0x1321F2
#define REG_BK1321_79_H      0x1321F3
#define REG_BK1321_7A_L      0x1321F4
#define REG_BK1321_7A_H      0x1321F5
#define REG_BK1321_7B_L      0x1321F6
#define REG_BK1321_7B_H      0x1321F7
#define REG_BK1321_7C_L      0x1321F8
#define REG_BK1321_7C_H      0x1321F9
#define REG_BK1321_7D_L      0x1321FA
#define REG_BK1321_7D_H      0x1321FB
#define REG_BK1321_7E_L      0x1321FC
#define REG_BK1321_7E_H      0x1321FD
#define REG_BK1321_7F_L      0x1321FE
#define REG_BK1321_7F_H      0x1321FF
//----------------------------------------------
#define REG_BK1322_00_L      0x132200
#define REG_BK1322_00_H      0x132201
#define REG_BK1322_01_L      0x132202
#define REG_BK1322_01_H      0x132203
#define REG_BK1322_02_L      0x132204
#define REG_BK1322_02_H      0x132205
#define REG_BK1322_03_L      0x132206
#define REG_BK1322_03_H      0x132207
#define REG_BK1322_04_L      0x132208
#define REG_BK1322_04_H      0x132209
#define REG_BK1322_05_L      0x13220A
#define REG_BK1322_05_H      0x13220B
#define REG_BK1322_06_L      0x13220C
#define REG_BK1322_06_H      0x13220D
#define REG_BK1322_07_L      0x13220E
#define REG_BK1322_07_H      0x13220F
#define REG_BK1322_08_L      0x132210
#define REG_BK1322_08_H      0x132211
#define REG_BK1322_09_L      0x132212
#define REG_BK1322_09_H      0x132213
#define REG_BK1322_0A_L      0x132214
#define REG_BK1322_0A_H      0x132215
#define REG_BK1322_0B_L      0x132216
#define REG_BK1322_0B_H      0x132217
#define REG_BK1322_0C_L      0x132218
#define REG_BK1322_0C_H      0x132219
#define REG_BK1322_0D_L      0x13221A
#define REG_BK1322_0D_H      0x13221B
#define REG_BK1322_0E_L      0x13221C
#define REG_BK1322_0E_H      0x13221D
#define REG_BK1322_0F_L      0x13221E
#define REG_BK1322_0F_H      0x13221F
#define REG_BK1322_10_L      0x132220
#define REG_BK1322_10_H      0x132221
#define REG_BK1322_11_L      0x132222
#define REG_BK1322_11_H      0x132223
#define REG_BK1322_12_L      0x132224
#define REG_BK1322_12_H      0x132225
#define REG_BK1322_13_L      0x132226
#define REG_BK1322_13_H      0x132227
#define REG_BK1322_14_L      0x132228
#define REG_BK1322_14_H      0x132229
#define REG_BK1322_15_L      0x13222A
#define REG_BK1322_15_H      0x13222B
#define REG_BK1322_16_L      0x13222C
#define REG_BK1322_16_H      0x13222D
#define REG_BK1322_17_L      0x13222E
#define REG_BK1322_17_H      0x13222F
#define REG_BK1322_18_L      0x132230
#define REG_BK1322_18_H      0x132231
#define REG_BK1322_19_L      0x132232
#define REG_BK1322_19_H      0x132233
#define REG_BK1322_1A_L      0x132234
#define REG_BK1322_1A_H      0x132235
#define REG_BK1322_1B_L      0x132236
#define REG_BK1322_1B_H      0x132237
#define REG_BK1322_1C_L      0x132238
#define REG_BK1322_1C_H      0x132239
#define REG_BK1322_1D_L      0x13223A
#define REG_BK1322_1D_H      0x13223B
#define REG_BK1322_1E_L      0x13223C
#define REG_BK1322_1E_H      0x13223D
#define REG_BK1322_1F_L      0x13223E
#define REG_BK1322_1F_H      0x13223F
#define REG_BK1322_20_L      0x132240
#define REG_BK1322_20_H      0x132241
#define REG_BK1322_21_L      0x132242
#define REG_BK1322_21_H      0x132243
#define REG_BK1322_22_L      0x132244
#define REG_BK1322_22_H      0x132245
#define REG_BK1322_23_L      0x132246
#define REG_BK1322_23_H      0x132247
#define REG_BK1322_24_L      0x132248
#define REG_BK1322_24_H      0x132249
#define REG_BK1322_25_L      0x13224A
#define REG_BK1322_25_H      0x13224B
#define REG_BK1322_26_L      0x13224C
#define REG_BK1322_26_H      0x13224D
#define REG_BK1322_27_L      0x13224E
#define REG_BK1322_27_H      0x13224F
#define REG_BK1322_28_L      0x132250
#define REG_BK1322_28_H      0x132251
#define REG_BK1322_29_L      0x132252
#define REG_BK1322_29_H      0x132253
#define REG_BK1322_2A_L      0x132254
#define REG_BK1322_2A_H      0x132255
#define REG_BK1322_2B_L      0x132256
#define REG_BK1322_2B_H      0x132257
#define REG_BK1322_2C_L      0x132258
#define REG_BK1322_2C_H      0x132259
#define REG_BK1322_2D_L      0x13225A
#define REG_BK1322_2D_H      0x13225B
#define REG_BK1322_2E_L      0x13225C
#define REG_BK1322_2E_H      0x13225D
#define REG_BK1322_2F_L      0x13225E
#define REG_BK1322_2F_H      0x13225F
#define REG_BK1322_30_L      0x132260
#define REG_BK1322_30_H      0x132261
#define REG_BK1322_31_L      0x132262
#define REG_BK1322_31_H      0x132263
#define REG_BK1322_32_L      0x132264
#define REG_BK1322_32_H      0x132265
#define REG_BK1322_33_L      0x132266
#define REG_BK1322_33_H      0x132267
#define REG_BK1322_34_L      0x132268
#define REG_BK1322_34_H      0x132269
#define REG_BK1322_35_L      0x13226A
#define REG_BK1322_35_H      0x13226B
#define REG_BK1322_36_L      0x13226C
#define REG_BK1322_36_H      0x13226D
#define REG_BK1322_37_L      0x13226E
#define REG_BK1322_37_H      0x13226F
#define REG_BK1322_38_L      0x132270
#define REG_BK1322_38_H      0x132271
#define REG_BK1322_39_L      0x132272
#define REG_BK1322_39_H      0x132273
#define REG_BK1322_3A_L      0x132274
#define REG_BK1322_3A_H      0x132275
#define REG_BK1322_3B_L      0x132276
#define REG_BK1322_3B_H      0x132277
#define REG_BK1322_3C_L      0x132278
#define REG_BK1322_3C_H      0x132279
#define REG_BK1322_3D_L      0x13227A
#define REG_BK1322_3D_H      0x13227B
#define REG_BK1322_3E_L      0x13227C
#define REG_BK1322_3E_H      0x13227D
#define REG_BK1322_3F_L      0x13227E
#define REG_BK1322_3F_H      0x13227F
#define REG_BK1322_40_L      0x132280
#define REG_BK1322_40_H      0x132281
#define REG_BK1322_41_L      0x132282
#define REG_BK1322_41_H      0x132283
#define REG_BK1322_42_L      0x132284
#define REG_BK1322_42_H      0x132285
#define REG_BK1322_43_L      0x132286
#define REG_BK1322_43_H      0x132287
#define REG_BK1322_44_L      0x132288
#define REG_BK1322_44_H      0x132289
#define REG_BK1322_45_L      0x13228A
#define REG_BK1322_45_H      0x13228B
#define REG_BK1322_46_L      0x13228C
#define REG_BK1322_46_H      0x13228D
#define REG_BK1322_47_L      0x13228E
#define REG_BK1322_47_H      0x13228F
#define REG_BK1322_48_L      0x132290
#define REG_BK1322_48_H      0x132291
#define REG_BK1322_49_L      0x132292
#define REG_BK1322_49_H      0x132293
#define REG_BK1322_4A_L      0x132294
#define REG_BK1322_4A_H      0x132295
#define REG_BK1322_4B_L      0x132296
#define REG_BK1322_4B_H      0x132297
#define REG_BK1322_4C_L      0x132298
#define REG_BK1322_4C_H      0x132299
#define REG_BK1322_4D_L      0x13229A
#define REG_BK1322_4D_H      0x13229B
#define REG_BK1322_4E_L      0x13229C
#define REG_BK1322_4E_H      0x13229D
#define REG_BK1322_4F_L      0x13229E
#define REG_BK1322_4F_H      0x13229F
#define REG_BK1322_50_L      0x1322A0
#define REG_BK1322_50_H      0x1322A1
#define REG_BK1322_51_L      0x1322A2
#define REG_BK1322_51_H      0x1322A3
#define REG_BK1322_52_L      0x1322A4
#define REG_BK1322_52_H      0x1322A5
#define REG_BK1322_53_L      0x1322A6
#define REG_BK1322_53_H      0x1322A7
#define REG_BK1322_54_L      0x1322A8
#define REG_BK1322_54_H      0x1322A9
#define REG_BK1322_55_L      0x1322AA
#define REG_BK1322_55_H      0x1322AB
#define REG_BK1322_56_L      0x1322AC
#define REG_BK1322_56_H      0x1322AD
#define REG_BK1322_57_L      0x1322AE
#define REG_BK1322_57_H      0x1322AF
#define REG_BK1322_58_L      0x1322B0
#define REG_BK1322_58_H      0x1322B1
#define REG_BK1322_59_L      0x1322B2
#define REG_BK1322_59_H      0x1322B3
#define REG_BK1322_5A_L      0x1322B4
#define REG_BK1322_5A_H      0x1322B5
#define REG_BK1322_5B_L      0x1322B6
#define REG_BK1322_5B_H      0x1322B7
#define REG_BK1322_5C_L      0x1322B8
#define REG_BK1322_5C_H      0x1322B9
#define REG_BK1322_5D_L      0x1322BA
#define REG_BK1322_5D_H      0x1322BB
#define REG_BK1322_5E_L      0x1322BC
#define REG_BK1322_5E_H      0x1322BD
#define REG_BK1322_5F_L      0x1322BE
#define REG_BK1322_5F_H      0x1322BF
#define REG_BK1322_60_L      0x1322C0
#define REG_BK1322_60_H      0x1322C1
#define REG_BK1322_61_L      0x1322C2
#define REG_BK1322_61_H      0x1322C3
#define REG_BK1322_62_L      0x1322C4
#define REG_BK1322_62_H      0x1322C5
#define REG_BK1322_63_L      0x1322C6
#define REG_BK1322_63_H      0x1322C7
#define REG_BK1322_64_L      0x1322C8
#define REG_BK1322_64_H      0x1322C9
#define REG_BK1322_65_L      0x1322CA
#define REG_BK1322_65_H      0x1322CB
#define REG_BK1322_66_L      0x1322CC
#define REG_BK1322_66_H      0x1322CD
#define REG_BK1322_67_L      0x1322CE
#define REG_BK1322_67_H      0x1322CF
#define REG_BK1322_68_L      0x1322D0
#define REG_BK1322_68_H      0x1322D1
#define REG_BK1322_69_L      0x1322D2
#define REG_BK1322_69_H      0x1322D3
#define REG_BK1322_6A_L      0x1322D4
#define REG_BK1322_6A_H      0x1322D5
#define REG_BK1322_6B_L      0x1322D6
#define REG_BK1322_6B_H      0x1322D7
#define REG_BK1322_6C_L      0x1322D8
#define REG_BK1322_6C_H      0x1322D9
#define REG_BK1322_6D_L      0x1322DA
#define REG_BK1322_6D_H      0x1322DB
#define REG_BK1322_6E_L      0x1322DC
#define REG_BK1322_6E_H      0x1322DD
#define REG_BK1322_6F_L      0x1322DE
#define REG_BK1322_6F_H      0x1322DF
#define REG_BK1322_70_L      0x1322E0
#define REG_BK1322_70_H      0x1322E1
#define REG_BK1322_71_L      0x1322E2
#define REG_BK1322_71_H      0x1322E3
#define REG_BK1322_72_L      0x1322E4
#define REG_BK1322_72_H      0x1322E5
#define REG_BK1322_73_L      0x1322E6
#define REG_BK1322_73_H      0x1322E7
#define REG_BK1322_74_L      0x1322E8
#define REG_BK1322_74_H      0x1322E9
#define REG_BK1322_75_L      0x1322EA
#define REG_BK1322_75_H      0x1322EB
#define REG_BK1322_76_L      0x1322EC
#define REG_BK1322_76_H      0x1322ED
#define REG_BK1322_77_L      0x1322EE
#define REG_BK1322_77_H      0x1322EF
#define REG_BK1322_78_L      0x1322F0
#define REG_BK1322_78_H      0x1322F1
#define REG_BK1322_79_L      0x1322F2
#define REG_BK1322_79_H      0x1322F3
#define REG_BK1322_7A_L      0x1322F4
#define REG_BK1322_7A_H      0x1322F5
#define REG_BK1322_7B_L      0x1322F6
#define REG_BK1322_7B_H      0x1322F7
#define REG_BK1322_7C_L      0x1322F8
#define REG_BK1322_7C_H      0x1322F9
#define REG_BK1322_7D_L      0x1322FA
#define REG_BK1322_7D_H      0x1322FB
#define REG_BK1322_7E_L      0x1322FC
#define REG_BK1322_7E_H      0x1322FD
#define REG_BK1322_7F_L      0x1322FE
#define REG_BK1322_7F_H      0x1322FF
//----------------------------------------------
#define REG_BK1323_00_L      0x132300
#define REG_BK1323_00_H      0x132301
#define REG_BK1323_01_L      0x132302
#define REG_BK1323_01_H      0x132303
#define REG_BK1323_02_L      0x132304
#define REG_BK1323_02_H      0x132305
#define REG_BK1323_03_L      0x132306
#define REG_BK1323_03_H      0x132307
#define REG_BK1323_04_L      0x132308
#define REG_BK1323_04_H      0x132309
#define REG_BK1323_05_L      0x13230A
#define REG_BK1323_05_H      0x13230B
#define REG_BK1323_06_L      0x13230C
#define REG_BK1323_06_H      0x13230D
#define REG_BK1323_07_L      0x13230E
#define REG_BK1323_07_H      0x13230F
#define REG_BK1323_08_L      0x132310
#define REG_BK1323_08_H      0x132311
#define REG_BK1323_09_L      0x132312
#define REG_BK1323_09_H      0x132313
#define REG_BK1323_0A_L      0x132314
#define REG_BK1323_0A_H      0x132315
#define REG_BK1323_0B_L      0x132316
#define REG_BK1323_0B_H      0x132317
#define REG_BK1323_0C_L      0x132318
#define REG_BK1323_0C_H      0x132319
#define REG_BK1323_0D_L      0x13231A
#define REG_BK1323_0D_H      0x13231B
#define REG_BK1323_0E_L      0x13231C
#define REG_BK1323_0E_H      0x13231D
#define REG_BK1323_0F_L      0x13231E
#define REG_BK1323_0F_H      0x13231F
#define REG_BK1323_10_L      0x132320
#define REG_BK1323_10_H      0x132321
#define REG_BK1323_11_L      0x132322
#define REG_BK1323_11_H      0x132323
#define REG_BK1323_12_L      0x132324
#define REG_BK1323_12_H      0x132325
#define REG_BK1323_13_L      0x132326
#define REG_BK1323_13_H      0x132327
#define REG_BK1323_14_L      0x132328
#define REG_BK1323_14_H      0x132329
#define REG_BK1323_15_L      0x13232A
#define REG_BK1323_15_H      0x13232B
#define REG_BK1323_16_L      0x13232C
#define REG_BK1323_16_H      0x13232D
#define REG_BK1323_17_L      0x13232E
#define REG_BK1323_17_H      0x13232F
#define REG_BK1323_18_L      0x132330
#define REG_BK1323_18_H      0x132331
#define REG_BK1323_19_L      0x132332
#define REG_BK1323_19_H      0x132333
#define REG_BK1323_1A_L      0x132334
#define REG_BK1323_1A_H      0x132335
#define REG_BK1323_1B_L      0x132336
#define REG_BK1323_1B_H      0x132337
#define REG_BK1323_1C_L      0x132338
#define REG_BK1323_1C_H      0x132339
#define REG_BK1323_1D_L      0x13233A
#define REG_BK1323_1D_H      0x13233B
#define REG_BK1323_1E_L      0x13233C
#define REG_BK1323_1E_H      0x13233D
#define REG_BK1323_1F_L      0x13233E
#define REG_BK1323_1F_H      0x13233F
#define REG_BK1323_20_L      0x132340
#define REG_BK1323_20_H      0x132341
#define REG_BK1323_21_L      0x132342
#define REG_BK1323_21_H      0x132343
#define REG_BK1323_22_L      0x132344
#define REG_BK1323_22_H      0x132345
#define REG_BK1323_23_L      0x132346
#define REG_BK1323_23_H      0x132347
#define REG_BK1323_24_L      0x132348
#define REG_BK1323_24_H      0x132349
#define REG_BK1323_25_L      0x13234A
#define REG_BK1323_25_H      0x13234B
#define REG_BK1323_26_L      0x13234C
#define REG_BK1323_26_H      0x13234D
#define REG_BK1323_27_L      0x13234E
#define REG_BK1323_27_H      0x13234F
#define REG_BK1323_28_L      0x132350
#define REG_BK1323_28_H      0x132351
#define REG_BK1323_29_L      0x132352
#define REG_BK1323_29_H      0x132353
#define REG_BK1323_2A_L      0x132354
#define REG_BK1323_2A_H      0x132355
#define REG_BK1323_2B_L      0x132356
#define REG_BK1323_2B_H      0x132357
#define REG_BK1323_2C_L      0x132358
#define REG_BK1323_2C_H      0x132359
#define REG_BK1323_2D_L      0x13235A
#define REG_BK1323_2D_H      0x13235B
#define REG_BK1323_2E_L      0x13235C
#define REG_BK1323_2E_H      0x13235D
#define REG_BK1323_2F_L      0x13235E
#define REG_BK1323_2F_H      0x13235F
#define REG_BK1323_30_L      0x132360
#define REG_BK1323_30_H      0x132361
#define REG_BK1323_31_L      0x132362
#define REG_BK1323_31_H      0x132363
#define REG_BK1323_32_L      0x132364
#define REG_BK1323_32_H      0x132365
#define REG_BK1323_33_L      0x132366
#define REG_BK1323_33_H      0x132367
#define REG_BK1323_34_L      0x132368
#define REG_BK1323_34_H      0x132369
#define REG_BK1323_35_L      0x13236A
#define REG_BK1323_35_H      0x13236B
#define REG_BK1323_36_L      0x13236C
#define REG_BK1323_36_H      0x13236D
#define REG_BK1323_37_L      0x13236E
#define REG_BK1323_37_H      0x13236F
#define REG_BK1323_38_L      0x132370
#define REG_BK1323_38_H      0x132371
#define REG_BK1323_39_L      0x132372
#define REG_BK1323_39_H      0x132373
#define REG_BK1323_3A_L      0x132374
#define REG_BK1323_3A_H      0x132375
#define REG_BK1323_3B_L      0x132376
#define REG_BK1323_3B_H      0x132377
#define REG_BK1323_3C_L      0x132378
#define REG_BK1323_3C_H      0x132379
#define REG_BK1323_3D_L      0x13237A
#define REG_BK1323_3D_H      0x13237B
#define REG_BK1323_3E_L      0x13237C
#define REG_BK1323_3E_H      0x13237D
#define REG_BK1323_3F_L      0x13237E
#define REG_BK1323_3F_H      0x13237F
#define REG_BK1323_40_L      0x132380
#define REG_BK1323_40_H      0x132381
#define REG_BK1323_41_L      0x132382
#define REG_BK1323_41_H      0x132383
#define REG_BK1323_42_L      0x132384
#define REG_BK1323_42_H      0x132385
#define REG_BK1323_43_L      0x132386
#define REG_BK1323_43_H      0x132387
#define REG_BK1323_44_L      0x132388
#define REG_BK1323_44_H      0x132389
#define REG_BK1323_45_L      0x13238A
#define REG_BK1323_45_H      0x13238B
#define REG_BK1323_46_L      0x13238C
#define REG_BK1323_46_H      0x13238D
#define REG_BK1323_47_L      0x13238E
#define REG_BK1323_47_H      0x13238F
#define REG_BK1323_48_L      0x132390
#define REG_BK1323_48_H      0x132391
#define REG_BK1323_49_L      0x132392
#define REG_BK1323_49_H      0x132393
#define REG_BK1323_4A_L      0x132394
#define REG_BK1323_4A_H      0x132395
#define REG_BK1323_4B_L      0x132396
#define REG_BK1323_4B_H      0x132397
#define REG_BK1323_4C_L      0x132398
#define REG_BK1323_4C_H      0x132399
#define REG_BK1323_4D_L      0x13239A
#define REG_BK1323_4D_H      0x13239B
#define REG_BK1323_4E_L      0x13239C
#define REG_BK1323_4E_H      0x13239D
#define REG_BK1323_4F_L      0x13239E
#define REG_BK1323_4F_H      0x13239F
#define REG_BK1323_50_L      0x1323A0
#define REG_BK1323_50_H      0x1323A1
#define REG_BK1323_51_L      0x1323A2
#define REG_BK1323_51_H      0x1323A3
#define REG_BK1323_52_L      0x1323A4
#define REG_BK1323_52_H      0x1323A5
#define REG_BK1323_53_L      0x1323A6
#define REG_BK1323_53_H      0x1323A7
#define REG_BK1323_54_L      0x1323A8
#define REG_BK1323_54_H      0x1323A9
#define REG_BK1323_55_L      0x1323AA
#define REG_BK1323_55_H      0x1323AB
#define REG_BK1323_56_L      0x1323AC
#define REG_BK1323_56_H      0x1323AD
#define REG_BK1323_57_L      0x1323AE
#define REG_BK1323_57_H      0x1323AF
#define REG_BK1323_58_L      0x1323B0
#define REG_BK1323_58_H      0x1323B1
#define REG_BK1323_59_L      0x1323B2
#define REG_BK1323_59_H      0x1323B3
#define REG_BK1323_5A_L      0x1323B4
#define REG_BK1323_5A_H      0x1323B5
#define REG_BK1323_5B_L      0x1323B6
#define REG_BK1323_5B_H      0x1323B7
#define REG_BK1323_5C_L      0x1323B8
#define REG_BK1323_5C_H      0x1323B9
#define REG_BK1323_5D_L      0x1323BA
#define REG_BK1323_5D_H      0x1323BB
#define REG_BK1323_5E_L      0x1323BC
#define REG_BK1323_5E_H      0x1323BD
#define REG_BK1323_5F_L      0x1323BE
#define REG_BK1323_5F_H      0x1323BF
#define REG_BK1323_60_L      0x1323C0
#define REG_BK1323_60_H      0x1323C1
#define REG_BK1323_61_L      0x1323C2
#define REG_BK1323_61_H      0x1323C3
#define REG_BK1323_62_L      0x1323C4
#define REG_BK1323_62_H      0x1323C5
#define REG_BK1323_63_L      0x1323C6
#define REG_BK1323_63_H      0x1323C7
#define REG_BK1323_64_L      0x1323C8
#define REG_BK1323_64_H      0x1323C9
#define REG_BK1323_65_L      0x1323CA
#define REG_BK1323_65_H      0x1323CB
#define REG_BK1323_66_L      0x1323CC
#define REG_BK1323_66_H      0x1323CD
#define REG_BK1323_67_L      0x1323CE
#define REG_BK1323_67_H      0x1323CF
#define REG_BK1323_68_L      0x1323D0
#define REG_BK1323_68_H      0x1323D1
#define REG_BK1323_69_L      0x1323D2
#define REG_BK1323_69_H      0x1323D3
#define REG_BK1323_6A_L      0x1323D4
#define REG_BK1323_6A_H      0x1323D5
#define REG_BK1323_6B_L      0x1323D6
#define REG_BK1323_6B_H      0x1323D7
#define REG_BK1323_6C_L      0x1323D8
#define REG_BK1323_6C_H      0x1323D9
#define REG_BK1323_6D_L      0x1323DA
#define REG_BK1323_6D_H      0x1323DB
#define REG_BK1323_6E_L      0x1323DC
#define REG_BK1323_6E_H      0x1323DD
#define REG_BK1323_6F_L      0x1323DE
#define REG_BK1323_6F_H      0x1323DF
#define REG_BK1323_70_L      0x1323E0
#define REG_BK1323_70_H      0x1323E1
#define REG_BK1323_71_L      0x1323E2
#define REG_BK1323_71_H      0x1323E3
#define REG_BK1323_72_L      0x1323E4
#define REG_BK1323_72_H      0x1323E5
#define REG_BK1323_73_L      0x1323E6
#define REG_BK1323_73_H      0x1323E7
#define REG_BK1323_74_L      0x1323E8
#define REG_BK1323_74_H      0x1323E9
#define REG_BK1323_75_L      0x1323EA
#define REG_BK1323_75_H      0x1323EB
#define REG_BK1323_76_L      0x1323EC
#define REG_BK1323_76_H      0x1323ED
#define REG_BK1323_77_L      0x1323EE
#define REG_BK1323_77_H      0x1323EF
#define REG_BK1323_78_L      0x1323F0
#define REG_BK1323_78_H      0x1323F1
#define REG_BK1323_79_L      0x1323F2
#define REG_BK1323_79_H      0x1323F3
#define REG_BK1323_7A_L      0x1323F4
#define REG_BK1323_7A_H      0x1323F5
#define REG_BK1323_7B_L      0x1323F6
#define REG_BK1323_7B_H      0x1323F7
#define REG_BK1323_7C_L      0x1323F8
#define REG_BK1323_7C_H      0x1323F9
#define REG_BK1323_7D_L      0x1323FA
#define REG_BK1323_7D_H      0x1323FB
#define REG_BK1323_7E_L      0x1323FC
#define REG_BK1323_7E_H      0x1323FD
#define REG_BK1323_7F_L      0x1323FE
#define REG_BK1323_7F_H      0x1323FF
//----------------------------------------------
#define REG_BK1324_00_L      0x132400
#define REG_BK1324_00_H      0x132401
#define REG_BK1324_01_L      0x132402
#define REG_BK1324_01_H      0x132403
#define REG_BK1324_02_L      0x132404
#define REG_BK1324_02_H      0x132405
#define REG_BK1324_03_L      0x132406
#define REG_BK1324_03_H      0x132407
#define REG_BK1324_04_L      0x132408
#define REG_BK1324_04_H      0x132409
#define REG_BK1324_05_L      0x13240A
#define REG_BK1324_05_H      0x13240B
#define REG_BK1324_06_L      0x13240C
#define REG_BK1324_06_H      0x13240D
#define REG_BK1324_07_L      0x13240E
#define REG_BK1324_07_H      0x13240F
#define REG_BK1324_08_L      0x132410
#define REG_BK1324_08_H      0x132411
#define REG_BK1324_09_L      0x132412
#define REG_BK1324_09_H      0x132413
#define REG_BK1324_0A_L      0x132414
#define REG_BK1324_0A_H      0x132415
#define REG_BK1324_0B_L      0x132416
#define REG_BK1324_0B_H      0x132417
#define REG_BK1324_0C_L      0x132418
#define REG_BK1324_0C_H      0x132419
#define REG_BK1324_0D_L      0x13241A
#define REG_BK1324_0D_H      0x13241B
#define REG_BK1324_0E_L      0x13241C
#define REG_BK1324_0E_H      0x13241D
#define REG_BK1324_0F_L      0x13241E
#define REG_BK1324_0F_H      0x13241F
#define REG_BK1324_10_L      0x132420
#define REG_BK1324_10_H      0x132421
#define REG_BK1324_11_L      0x132422
#define REG_BK1324_11_H      0x132423
#define REG_BK1324_12_L      0x132424
#define REG_BK1324_12_H      0x132425
#define REG_BK1324_13_L      0x132426
#define REG_BK1324_13_H      0x132427
#define REG_BK1324_14_L      0x132428
#define REG_BK1324_14_H      0x132429
#define REG_BK1324_15_L      0x13242A
#define REG_BK1324_15_H      0x13242B
#define REG_BK1324_16_L      0x13242C
#define REG_BK1324_16_H      0x13242D
#define REG_BK1324_17_L      0x13242E
#define REG_BK1324_17_H      0x13242F
#define REG_BK1324_18_L      0x132430
#define REG_BK1324_18_H      0x132431
#define REG_BK1324_19_L      0x132432
#define REG_BK1324_19_H      0x132433
#define REG_BK1324_1A_L      0x132434
#define REG_BK1324_1A_H      0x132435
#define REG_BK1324_1B_L      0x132436
#define REG_BK1324_1B_H      0x132437
#define REG_BK1324_1C_L      0x132438
#define REG_BK1324_1C_H      0x132439
#define REG_BK1324_1D_L      0x13243A
#define REG_BK1324_1D_H      0x13243B
#define REG_BK1324_1E_L      0x13243C
#define REG_BK1324_1E_H      0x13243D
#define REG_BK1324_1F_L      0x13243E
#define REG_BK1324_1F_H      0x13243F
#define REG_BK1324_20_L      0x132440
#define REG_BK1324_20_H      0x132441
#define REG_BK1324_21_L      0x132442
#define REG_BK1324_21_H      0x132443
#define REG_BK1324_22_L      0x132444
#define REG_BK1324_22_H      0x132445
#define REG_BK1324_23_L      0x132446
#define REG_BK1324_23_H      0x132447
#define REG_BK1324_24_L      0x132448
#define REG_BK1324_24_H      0x132449
#define REG_BK1324_25_L      0x13244A
#define REG_BK1324_25_H      0x13244B
#define REG_BK1324_26_L      0x13244C
#define REG_BK1324_26_H      0x13244D
#define REG_BK1324_27_L      0x13244E
#define REG_BK1324_27_H      0x13244F
#define REG_BK1324_28_L      0x132450
#define REG_BK1324_28_H      0x132451
#define REG_BK1324_29_L      0x132452
#define REG_BK1324_29_H      0x132453
#define REG_BK1324_2A_L      0x132454
#define REG_BK1324_2A_H      0x132455
#define REG_BK1324_2B_L      0x132456
#define REG_BK1324_2B_H      0x132457
#define REG_BK1324_2C_L      0x132458
#define REG_BK1324_2C_H      0x132459
#define REG_BK1324_2D_L      0x13245A
#define REG_BK1324_2D_H      0x13245B
#define REG_BK1324_2E_L      0x13245C
#define REG_BK1324_2E_H      0x13245D
#define REG_BK1324_2F_L      0x13245E
#define REG_BK1324_2F_H      0x13245F
#define REG_BK1324_30_L      0x132460
#define REG_BK1324_30_H      0x132461
#define REG_BK1324_31_L      0x132462
#define REG_BK1324_31_H      0x132463
#define REG_BK1324_32_L      0x132464
#define REG_BK1324_32_H      0x132465
#define REG_BK1324_33_L      0x132466
#define REG_BK1324_33_H      0x132467
#define REG_BK1324_34_L      0x132468
#define REG_BK1324_34_H      0x132469
#define REG_BK1324_35_L      0x13246A
#define REG_BK1324_35_H      0x13246B
#define REG_BK1324_36_L      0x13246C
#define REG_BK1324_36_H      0x13246D
#define REG_BK1324_37_L      0x13246E
#define REG_BK1324_37_H      0x13246F
#define REG_BK1324_38_L      0x132470
#define REG_BK1324_38_H      0x132471
#define REG_BK1324_39_L      0x132472
#define REG_BK1324_39_H      0x132473
#define REG_BK1324_3A_L      0x132474
#define REG_BK1324_3A_H      0x132475
#define REG_BK1324_3B_L      0x132476
#define REG_BK1324_3B_H      0x132477
#define REG_BK1324_3C_L      0x132478
#define REG_BK1324_3C_H      0x132479
#define REG_BK1324_3D_L      0x13247A
#define REG_BK1324_3D_H      0x13247B
#define REG_BK1324_3E_L      0x13247C
#define REG_BK1324_3E_H      0x13247D
#define REG_BK1324_3F_L      0x13247E
#define REG_BK1324_3F_H      0x13247F
#define REG_BK1324_40_L      0x132480
#define REG_BK1324_40_H      0x132481
#define REG_BK1324_41_L      0x132482
#define REG_BK1324_41_H      0x132483
#define REG_BK1324_42_L      0x132484
#define REG_BK1324_42_H      0x132485
#define REG_BK1324_43_L      0x132486
#define REG_BK1324_43_H      0x132487
#define REG_BK1324_44_L      0x132488
#define REG_BK1324_44_H      0x132489
#define REG_BK1324_45_L      0x13248A
#define REG_BK1324_45_H      0x13248B
#define REG_BK1324_46_L      0x13248C
#define REG_BK1324_46_H      0x13248D
#define REG_BK1324_47_L      0x13248E
#define REG_BK1324_47_H      0x13248F
#define REG_BK1324_48_L      0x132490
#define REG_BK1324_48_H      0x132491
#define REG_BK1324_49_L      0x132492
#define REG_BK1324_49_H      0x132493
#define REG_BK1324_4A_L      0x132494
#define REG_BK1324_4A_H      0x132495
#define REG_BK1324_4B_L      0x132496
#define REG_BK1324_4B_H      0x132497
#define REG_BK1324_4C_L      0x132498
#define REG_BK1324_4C_H      0x132499
#define REG_BK1324_4D_L      0x13249A
#define REG_BK1324_4D_H      0x13249B
#define REG_BK1324_4E_L      0x13249C
#define REG_BK1324_4E_H      0x13249D
#define REG_BK1324_4F_L      0x13249E
#define REG_BK1324_4F_H      0x13249F
#define REG_BK1324_50_L      0x1324A0
#define REG_BK1324_50_H      0x1324A1
#define REG_BK1324_51_L      0x1324A2
#define REG_BK1324_51_H      0x1324A3
#define REG_BK1324_52_L      0x1324A4
#define REG_BK1324_52_H      0x1324A5
#define REG_BK1324_53_L      0x1324A6
#define REG_BK1324_53_H      0x1324A7
#define REG_BK1324_54_L      0x1324A8
#define REG_BK1324_54_H      0x1324A9
#define REG_BK1324_55_L      0x1324AA
#define REG_BK1324_55_H      0x1324AB
#define REG_BK1324_56_L      0x1324AC
#define REG_BK1324_56_H      0x1324AD
#define REG_BK1324_57_L      0x1324AE
#define REG_BK1324_57_H      0x1324AF
#define REG_BK1324_58_L      0x1324B0
#define REG_BK1324_58_H      0x1324B1
#define REG_BK1324_59_L      0x1324B2
#define REG_BK1324_59_H      0x1324B3
#define REG_BK1324_5A_L      0x1324B4
#define REG_BK1324_5A_H      0x1324B5
#define REG_BK1324_5B_L      0x1324B6
#define REG_BK1324_5B_H      0x1324B7
#define REG_BK1324_5C_L      0x1324B8
#define REG_BK1324_5C_H      0x1324B9
#define REG_BK1324_5D_L      0x1324BA
#define REG_BK1324_5D_H      0x1324BB
#define REG_BK1324_5E_L      0x1324BC
#define REG_BK1324_5E_H      0x1324BD
#define REG_BK1324_5F_L      0x1324BE
#define REG_BK1324_5F_H      0x1324BF
#define REG_BK1324_60_L      0x1324C0
#define REG_BK1324_60_H      0x1324C1
#define REG_BK1324_61_L      0x1324C2
#define REG_BK1324_61_H      0x1324C3
#define REG_BK1324_62_L      0x1324C4
#define REG_BK1324_62_H      0x1324C5
#define REG_BK1324_63_L      0x1324C6
#define REG_BK1324_63_H      0x1324C7
#define REG_BK1324_64_L      0x1324C8
#define REG_BK1324_64_H      0x1324C9
#define REG_BK1324_65_L      0x1324CA
#define REG_BK1324_65_H      0x1324CB
#define REG_BK1324_66_L      0x1324CC
#define REG_BK1324_66_H      0x1324CD
#define REG_BK1324_67_L      0x1324CE
#define REG_BK1324_67_H      0x1324CF
#define REG_BK1324_68_L      0x1324D0
#define REG_BK1324_68_H      0x1324D1
#define REG_BK1324_69_L      0x1324D2
#define REG_BK1324_69_H      0x1324D3
#define REG_BK1324_6A_L      0x1324D4
#define REG_BK1324_6A_H      0x1324D5
#define REG_BK1324_6B_L      0x1324D6
#define REG_BK1324_6B_H      0x1324D7
#define REG_BK1324_6C_L      0x1324D8
#define REG_BK1324_6C_H      0x1324D9
#define REG_BK1324_6D_L      0x1324DA
#define REG_BK1324_6D_H      0x1324DB
#define REG_BK1324_6E_L      0x1324DC
#define REG_BK1324_6E_H      0x1324DD
#define REG_BK1324_6F_L      0x1324DE
#define REG_BK1324_6F_H      0x1324DF
#define REG_BK1324_70_L      0x1324E0
#define REG_BK1324_70_H      0x1324E1
#define REG_BK1324_71_L      0x1324E2
#define REG_BK1324_71_H      0x1324E3
#define REG_BK1324_72_L      0x1324E4
#define REG_BK1324_72_H      0x1324E5
#define REG_BK1324_73_L      0x1324E6
#define REG_BK1324_73_H      0x1324E7
#define REG_BK1324_74_L      0x1324E8
#define REG_BK1324_74_H      0x1324E9
#define REG_BK1324_75_L      0x1324EA
#define REG_BK1324_75_H      0x1324EB
#define REG_BK1324_76_L      0x1324EC
#define REG_BK1324_76_H      0x1324ED
#define REG_BK1324_77_L      0x1324EE
#define REG_BK1324_77_H      0x1324EF
#define REG_BK1324_78_L      0x1324F0
#define REG_BK1324_78_H      0x1324F1
#define REG_BK1324_79_L      0x1324F2
#define REG_BK1324_79_H      0x1324F3
#define REG_BK1324_7A_L      0x1324F4
#define REG_BK1324_7A_H      0x1324F5
#define REG_BK1324_7B_L      0x1324F6
#define REG_BK1324_7B_H      0x1324F7
#define REG_BK1324_7C_L      0x1324F8
#define REG_BK1324_7C_H      0x1324F9
#define REG_BK1324_7D_L      0x1324FA
#define REG_BK1324_7D_H      0x1324FB
#define REG_BK1324_7E_L      0x1324FC
#define REG_BK1324_7E_H      0x1324FD
#define REG_BK1324_7F_L      0x1324FE
#define REG_BK1324_7F_H      0x1324FF
//----------------------------------------------
#define REG_BK1325_00_L      0x132500
#define REG_BK1325_00_H      0x132501
#define REG_BK1325_01_L      0x132502
#define REG_BK1325_01_H      0x132503
#define REG_BK1325_02_L      0x132504
#define REG_BK1325_02_H      0x132505
#define REG_BK1325_03_L      0x132506
#define REG_BK1325_03_H      0x132507
#define REG_BK1325_04_L      0x132508
#define REG_BK1325_04_H      0x132509
#define REG_BK1325_05_L      0x13250A
#define REG_BK1325_05_H      0x13250B
#define REG_BK1325_06_L      0x13250C
#define REG_BK1325_06_H      0x13250D
#define REG_BK1325_07_L      0x13250E
#define REG_BK1325_07_H      0x13250F
#define REG_BK1325_08_L      0x132510
#define REG_BK1325_08_H      0x132511
#define REG_BK1325_09_L      0x132512
#define REG_BK1325_09_H      0x132513
#define REG_BK1325_0A_L      0x132514
#define REG_BK1325_0A_H      0x132515
#define REG_BK1325_0B_L      0x132516
#define REG_BK1325_0B_H      0x132517
#define REG_BK1325_0C_L      0x132518
#define REG_BK1325_0C_H      0x132519
#define REG_BK1325_0D_L      0x13251A
#define REG_BK1325_0D_H      0x13251B
#define REG_BK1325_0E_L      0x13251C
#define REG_BK1325_0E_H      0x13251D
#define REG_BK1325_0F_L      0x13251E
#define REG_BK1325_0F_H      0x13251F
#define REG_BK1325_10_L      0x132520
#define REG_BK1325_10_H      0x132521
#define REG_BK1325_11_L      0x132522
#define REG_BK1325_11_H      0x132523
#define REG_BK1325_12_L      0x132524
#define REG_BK1325_12_H      0x132525
#define REG_BK1325_13_L      0x132526
#define REG_BK1325_13_H      0x132527
#define REG_BK1325_14_L      0x132528
#define REG_BK1325_14_H      0x132529
#define REG_BK1325_15_L      0x13252A
#define REG_BK1325_15_H      0x13252B
#define REG_BK1325_16_L      0x13252C
#define REG_BK1325_16_H      0x13252D
#define REG_BK1325_17_L      0x13252E
#define REG_BK1325_17_H      0x13252F
#define REG_BK1325_18_L      0x132530
#define REG_BK1325_18_H      0x132531
#define REG_BK1325_19_L      0x132532
#define REG_BK1325_19_H      0x132533
#define REG_BK1325_1A_L      0x132534
#define REG_BK1325_1A_H      0x132535
#define REG_BK1325_1B_L      0x132536
#define REG_BK1325_1B_H      0x132537
#define REG_BK1325_1C_L      0x132538
#define REG_BK1325_1C_H      0x132539
#define REG_BK1325_1D_L      0x13253A
#define REG_BK1325_1D_H      0x13253B
#define REG_BK1325_1E_L      0x13253C
#define REG_BK1325_1E_H      0x13253D
#define REG_BK1325_1F_L      0x13253E
#define REG_BK1325_1F_H      0x13253F
#define REG_BK1325_20_L      0x132540
#define REG_BK1325_20_H      0x132541
#define REG_BK1325_21_L      0x132542
#define REG_BK1325_21_H      0x132543
#define REG_BK1325_22_L      0x132544
#define REG_BK1325_22_H      0x132545
#define REG_BK1325_23_L      0x132546
#define REG_BK1325_23_H      0x132547
#define REG_BK1325_24_L      0x132548
#define REG_BK1325_24_H      0x132549
#define REG_BK1325_25_L      0x13254A
#define REG_BK1325_25_H      0x13254B
#define REG_BK1325_26_L      0x13254C
#define REG_BK1325_26_H      0x13254D
#define REG_BK1325_27_L      0x13254E
#define REG_BK1325_27_H      0x13254F
#define REG_BK1325_28_L      0x132550
#define REG_BK1325_28_H      0x132551
#define REG_BK1325_29_L      0x132552
#define REG_BK1325_29_H      0x132553
#define REG_BK1325_2A_L      0x132554
#define REG_BK1325_2A_H      0x132555
#define REG_BK1325_2B_L      0x132556
#define REG_BK1325_2B_H      0x132557
#define REG_BK1325_2C_L      0x132558
#define REG_BK1325_2C_H      0x132559
#define REG_BK1325_2D_L      0x13255A
#define REG_BK1325_2D_H      0x13255B
#define REG_BK1325_2E_L      0x13255C
#define REG_BK1325_2E_H      0x13255D
#define REG_BK1325_2F_L      0x13255E
#define REG_BK1325_2F_H      0x13255F
#define REG_BK1325_30_L      0x132560
#define REG_BK1325_30_H      0x132561
#define REG_BK1325_31_L      0x132562
#define REG_BK1325_31_H      0x132563
#define REG_BK1325_32_L      0x132564
#define REG_BK1325_32_H      0x132565
#define REG_BK1325_33_L      0x132566
#define REG_BK1325_33_H      0x132567
#define REG_BK1325_34_L      0x132568
#define REG_BK1325_34_H      0x132569
#define REG_BK1325_35_L      0x13256A
#define REG_BK1325_35_H      0x13256B
#define REG_BK1325_36_L      0x13256C
#define REG_BK1325_36_H      0x13256D
#define REG_BK1325_37_L      0x13256E
#define REG_BK1325_37_H      0x13256F
#define REG_BK1325_38_L      0x132570
#define REG_BK1325_38_H      0x132571
#define REG_BK1325_39_L      0x132572
#define REG_BK1325_39_H      0x132573
#define REG_BK1325_3A_L      0x132574
#define REG_BK1325_3A_H      0x132575
#define REG_BK1325_3B_L      0x132576
#define REG_BK1325_3B_H      0x132577
#define REG_BK1325_3C_L      0x132578
#define REG_BK1325_3C_H      0x132579
#define REG_BK1325_3D_L      0x13257A
#define REG_BK1325_3D_H      0x13257B
#define REG_BK1325_3E_L      0x13257C
#define REG_BK1325_3E_H      0x13257D
#define REG_BK1325_3F_L      0x13257E
#define REG_BK1325_3F_H      0x13257F
#define REG_BK1325_40_L      0x132580
#define REG_BK1325_40_H      0x132581
#define REG_BK1325_41_L      0x132582
#define REG_BK1325_41_H      0x132583
#define REG_BK1325_42_L      0x132584
#define REG_BK1325_42_H      0x132585
#define REG_BK1325_43_L      0x132586
#define REG_BK1325_43_H      0x132587
#define REG_BK1325_44_L      0x132588
#define REG_BK1325_44_H      0x132589
#define REG_BK1325_45_L      0x13258A
#define REG_BK1325_45_H      0x13258B
#define REG_BK1325_46_L      0x13258C
#define REG_BK1325_46_H      0x13258D
#define REG_BK1325_47_L      0x13258E
#define REG_BK1325_47_H      0x13258F
#define REG_BK1325_48_L      0x132590
#define REG_BK1325_48_H      0x132591
#define REG_BK1325_49_L      0x132592
#define REG_BK1325_49_H      0x132593
#define REG_BK1325_4A_L      0x132594
#define REG_BK1325_4A_H      0x132595
#define REG_BK1325_4B_L      0x132596
#define REG_BK1325_4B_H      0x132597
#define REG_BK1325_4C_L      0x132598
#define REG_BK1325_4C_H      0x132599
#define REG_BK1325_4D_L      0x13259A
#define REG_BK1325_4D_H      0x13259B
#define REG_BK1325_4E_L      0x13259C
#define REG_BK1325_4E_H      0x13259D
#define REG_BK1325_4F_L      0x13259E
#define REG_BK1325_4F_H      0x13259F
#define REG_BK1325_50_L      0x1325A0
#define REG_BK1325_50_H      0x1325A1
#define REG_BK1325_51_L      0x1325A2
#define REG_BK1325_51_H      0x1325A3
#define REG_BK1325_52_L      0x1325A4
#define REG_BK1325_52_H      0x1325A5
#define REG_BK1325_53_L      0x1325A6
#define REG_BK1325_53_H      0x1325A7
#define REG_BK1325_54_L      0x1325A8
#define REG_BK1325_54_H      0x1325A9
#define REG_BK1325_55_L      0x1325AA
#define REG_BK1325_55_H      0x1325AB
#define REG_BK1325_56_L      0x1325AC
#define REG_BK1325_56_H      0x1325AD
#define REG_BK1325_57_L      0x1325AE
#define REG_BK1325_57_H      0x1325AF
#define REG_BK1325_58_L      0x1325B0
#define REG_BK1325_58_H      0x1325B1
#define REG_BK1325_59_L      0x1325B2
#define REG_BK1325_59_H      0x1325B3
#define REG_BK1325_5A_L      0x1325B4
#define REG_BK1325_5A_H      0x1325B5
#define REG_BK1325_5B_L      0x1325B6
#define REG_BK1325_5B_H      0x1325B7
#define REG_BK1325_5C_L      0x1325B8
#define REG_BK1325_5C_H      0x1325B9
#define REG_BK1325_5D_L      0x1325BA
#define REG_BK1325_5D_H      0x1325BB
#define REG_BK1325_5E_L      0x1325BC
#define REG_BK1325_5E_H      0x1325BD
#define REG_BK1325_5F_L      0x1325BE
#define REG_BK1325_5F_H      0x1325BF
#define REG_BK1325_60_L      0x1325C0
#define REG_BK1325_60_H      0x1325C1
#define REG_BK1325_61_L      0x1325C2
#define REG_BK1325_61_H      0x1325C3
#define REG_BK1325_62_L      0x1325C4
#define REG_BK1325_62_H      0x1325C5
#define REG_BK1325_63_L      0x1325C6
#define REG_BK1325_63_H      0x1325C7
#define REG_BK1325_64_L      0x1325C8
#define REG_BK1325_64_H      0x1325C9
#define REG_BK1325_65_L      0x1325CA
#define REG_BK1325_65_H      0x1325CB
#define REG_BK1325_66_L      0x1325CC
#define REG_BK1325_66_H      0x1325CD
#define REG_BK1325_67_L      0x1325CE
#define REG_BK1325_67_H      0x1325CF
#define REG_BK1325_68_L      0x1325D0
#define REG_BK1325_68_H      0x1325D1
#define REG_BK1325_69_L      0x1325D2
#define REG_BK1325_69_H      0x1325D3
#define REG_BK1325_6A_L      0x1325D4
#define REG_BK1325_6A_H      0x1325D5
#define REG_BK1325_6B_L      0x1325D6
#define REG_BK1325_6B_H      0x1325D7
#define REG_BK1325_6C_L      0x1325D8
#define REG_BK1325_6C_H      0x1325D9
#define REG_BK1325_6D_L      0x1325DA
#define REG_BK1325_6D_H      0x1325DB
#define REG_BK1325_6E_L      0x1325DC
#define REG_BK1325_6E_H      0x1325DD
#define REG_BK1325_6F_L      0x1325DE
#define REG_BK1325_6F_H      0x1325DF
#define REG_BK1325_70_L      0x1325E0
#define REG_BK1325_70_H      0x1325E1
#define REG_BK1325_71_L      0x1325E2
#define REG_BK1325_71_H      0x1325E3
#define REG_BK1325_72_L      0x1325E4
#define REG_BK1325_72_H      0x1325E5
#define REG_BK1325_73_L      0x1325E6
#define REG_BK1325_73_H      0x1325E7
#define REG_BK1325_74_L      0x1325E8
#define REG_BK1325_74_H      0x1325E9
#define REG_BK1325_75_L      0x1325EA
#define REG_BK1325_75_H      0x1325EB
#define REG_BK1325_76_L      0x1325EC
#define REG_BK1325_76_H      0x1325ED
#define REG_BK1325_77_L      0x1325EE
#define REG_BK1325_77_H      0x1325EF
#define REG_BK1325_78_L      0x1325F0
#define REG_BK1325_78_H      0x1325F1
#define REG_BK1325_79_L      0x1325F2
#define REG_BK1325_79_H      0x1325F3
#define REG_BK1325_7A_L      0x1325F4
#define REG_BK1325_7A_H      0x1325F5
#define REG_BK1325_7B_L      0x1325F6
#define REG_BK1325_7B_H      0x1325F7
#define REG_BK1325_7C_L      0x1325F8
#define REG_BK1325_7C_H      0x1325F9
#define REG_BK1325_7D_L      0x1325FA
#define REG_BK1325_7D_H      0x1325FB
#define REG_BK1325_7E_L      0x1325FC
#define REG_BK1325_7E_H      0x1325FD
#define REG_BK1325_7F_L      0x1325FE
#define REG_BK1325_7F_H      0x1325FF
//----------------------------------------------
#define REG_BK1326_00_L      0x132600
#define REG_BK1326_00_H      0x132601
#define REG_BK1326_01_L      0x132602
#define REG_BK1326_01_H      0x132603
#define REG_BK1326_02_L      0x132604
#define REG_BK1326_02_H      0x132605
#define REG_BK1326_03_L      0x132606
#define REG_BK1326_03_H      0x132607
#define REG_BK1326_04_L      0x132608
#define REG_BK1326_04_H      0x132609
#define REG_BK1326_05_L      0x13260A
#define REG_BK1326_05_H      0x13260B
#define REG_BK1326_06_L      0x13260C
#define REG_BK1326_06_H      0x13260D
#define REG_BK1326_07_L      0x13260E
#define REG_BK1326_07_H      0x13260F
#define REG_BK1326_08_L      0x132610
#define REG_BK1326_08_H      0x132611
#define REG_BK1326_09_L      0x132612
#define REG_BK1326_09_H      0x132613
#define REG_BK1326_0A_L      0x132614
#define REG_BK1326_0A_H      0x132615
#define REG_BK1326_0B_L      0x132616
#define REG_BK1326_0B_H      0x132617
#define REG_BK1326_0C_L      0x132618
#define REG_BK1326_0C_H      0x132619
#define REG_BK1326_0D_L      0x13261A
#define REG_BK1326_0D_H      0x13261B
#define REG_BK1326_0E_L      0x13261C
#define REG_BK1326_0E_H      0x13261D
#define REG_BK1326_0F_L      0x13261E
#define REG_BK1326_0F_H      0x13261F
#define REG_BK1326_10_L      0x132620
#define REG_BK1326_10_H      0x132621
#define REG_BK1326_11_L      0x132622
#define REG_BK1326_11_H      0x132623
#define REG_BK1326_12_L      0x132624
#define REG_BK1326_12_H      0x132625
#define REG_BK1326_13_L      0x132626
#define REG_BK1326_13_H      0x132627
#define REG_BK1326_14_L      0x132628
#define REG_BK1326_14_H      0x132629
#define REG_BK1326_15_L      0x13262A
#define REG_BK1326_15_H      0x13262B
#define REG_BK1326_16_L      0x13262C
#define REG_BK1326_16_H      0x13262D
#define REG_BK1326_17_L      0x13262E
#define REG_BK1326_17_H      0x13262F
#define REG_BK1326_18_L      0x132630
#define REG_BK1326_18_H      0x132631
#define REG_BK1326_19_L      0x132632
#define REG_BK1326_19_H      0x132633
#define REG_BK1326_1A_L      0x132634
#define REG_BK1326_1A_H      0x132635
#define REG_BK1326_1B_L      0x132636
#define REG_BK1326_1B_H      0x132637
#define REG_BK1326_1C_L      0x132638
#define REG_BK1326_1C_H      0x132639
#define REG_BK1326_1D_L      0x13263A
#define REG_BK1326_1D_H      0x13263B
#define REG_BK1326_1E_L      0x13263C
#define REG_BK1326_1E_H      0x13263D
#define REG_BK1326_1F_L      0x13263E
#define REG_BK1326_1F_H      0x13263F
#define REG_BK1326_20_L      0x132640
#define REG_BK1326_20_H      0x132641
#define REG_BK1326_21_L      0x132642
#define REG_BK1326_21_H      0x132643
#define REG_BK1326_22_L      0x132644
#define REG_BK1326_22_H      0x132645
#define REG_BK1326_23_L      0x132646
#define REG_BK1326_23_H      0x132647
#define REG_BK1326_24_L      0x132648
#define REG_BK1326_24_H      0x132649
#define REG_BK1326_25_L      0x13264A
#define REG_BK1326_25_H      0x13264B
#define REG_BK1326_26_L      0x13264C
#define REG_BK1326_26_H      0x13264D
#define REG_BK1326_27_L      0x13264E
#define REG_BK1326_27_H      0x13264F
#define REG_BK1326_28_L      0x132650
#define REG_BK1326_28_H      0x132651
#define REG_BK1326_29_L      0x132652
#define REG_BK1326_29_H      0x132653
#define REG_BK1326_2A_L      0x132654
#define REG_BK1326_2A_H      0x132655
#define REG_BK1326_2B_L      0x132656
#define REG_BK1326_2B_H      0x132657
#define REG_BK1326_2C_L      0x132658
#define REG_BK1326_2C_H      0x132659
#define REG_BK1326_2D_L      0x13265A
#define REG_BK1326_2D_H      0x13265B
#define REG_BK1326_2E_L      0x13265C
#define REG_BK1326_2E_H      0x13265D
#define REG_BK1326_2F_L      0x13265E
#define REG_BK1326_2F_H      0x13265F
#define REG_BK1326_30_L      0x132660
#define REG_BK1326_30_H      0x132661
#define REG_BK1326_31_L      0x132662
#define REG_BK1326_31_H      0x132663
#define REG_BK1326_32_L      0x132664
#define REG_BK1326_32_H      0x132665
#define REG_BK1326_33_L      0x132666
#define REG_BK1326_33_H      0x132667
#define REG_BK1326_34_L      0x132668
#define REG_BK1326_34_H      0x132669
#define REG_BK1326_35_L      0x13266A
#define REG_BK1326_35_H      0x13266B
#define REG_BK1326_36_L      0x13266C
#define REG_BK1326_36_H      0x13266D
#define REG_BK1326_37_L      0x13266E
#define REG_BK1326_37_H      0x13266F
#define REG_BK1326_38_L      0x132670
#define REG_BK1326_38_H      0x132671
#define REG_BK1326_39_L      0x132672
#define REG_BK1326_39_H      0x132673
#define REG_BK1326_3A_L      0x132674
#define REG_BK1326_3A_H      0x132675
#define REG_BK1326_3B_L      0x132676
#define REG_BK1326_3B_H      0x132677
#define REG_BK1326_3C_L      0x132678
#define REG_BK1326_3C_H      0x132679
#define REG_BK1326_3D_L      0x13267A
#define REG_BK1326_3D_H      0x13267B
#define REG_BK1326_3E_L      0x13267C
#define REG_BK1326_3E_H      0x13267D
#define REG_BK1326_3F_L      0x13267E
#define REG_BK1326_3F_H      0x13267F
#define REG_BK1326_40_L      0x132680
#define REG_BK1326_40_H      0x132681
#define REG_BK1326_41_L      0x132682
#define REG_BK1326_41_H      0x132683
#define REG_BK1326_42_L      0x132684
#define REG_BK1326_42_H      0x132685
#define REG_BK1326_43_L      0x132686
#define REG_BK1326_43_H      0x132687
#define REG_BK1326_44_L      0x132688
#define REG_BK1326_44_H      0x132689
#define REG_BK1326_45_L      0x13268A
#define REG_BK1326_45_H      0x13268B
#define REG_BK1326_46_L      0x13268C
#define REG_BK1326_46_H      0x13268D
#define REG_BK1326_47_L      0x13268E
#define REG_BK1326_47_H      0x13268F
#define REG_BK1326_48_L      0x132690
#define REG_BK1326_48_H      0x132691
#define REG_BK1326_49_L      0x132692
#define REG_BK1326_49_H      0x132693
#define REG_BK1326_4A_L      0x132694
#define REG_BK1326_4A_H      0x132695
#define REG_BK1326_4B_L      0x132696
#define REG_BK1326_4B_H      0x132697
#define REG_BK1326_4C_L      0x132698
#define REG_BK1326_4C_H      0x132699
#define REG_BK1326_4D_L      0x13269A
#define REG_BK1326_4D_H      0x13269B
#define REG_BK1326_4E_L      0x13269C
#define REG_BK1326_4E_H      0x13269D
#define REG_BK1326_4F_L      0x13269E
#define REG_BK1326_4F_H      0x13269F
#define REG_BK1326_50_L      0x1326A0
#define REG_BK1326_50_H      0x1326A1
#define REG_BK1326_51_L      0x1326A2
#define REG_BK1326_51_H      0x1326A3
#define REG_BK1326_52_L      0x1326A4
#define REG_BK1326_52_H      0x1326A5
#define REG_BK1326_53_L      0x1326A6
#define REG_BK1326_53_H      0x1326A7
#define REG_BK1326_54_L      0x1326A8
#define REG_BK1326_54_H      0x1326A9
#define REG_BK1326_55_L      0x1326AA
#define REG_BK1326_55_H      0x1326AB
#define REG_BK1326_56_L      0x1326AC
#define REG_BK1326_56_H      0x1326AD
#define REG_BK1326_57_L      0x1326AE
#define REG_BK1326_57_H      0x1326AF
#define REG_BK1326_58_L      0x1326B0
#define REG_BK1326_58_H      0x1326B1
#define REG_BK1326_59_L      0x1326B2
#define REG_BK1326_59_H      0x1326B3
#define REG_BK1326_5A_L      0x1326B4
#define REG_BK1326_5A_H      0x1326B5
#define REG_BK1326_5B_L      0x1326B6
#define REG_BK1326_5B_H      0x1326B7
#define REG_BK1326_5C_L      0x1326B8
#define REG_BK1326_5C_H      0x1326B9
#define REG_BK1326_5D_L      0x1326BA
#define REG_BK1326_5D_H      0x1326BB
#define REG_BK1326_5E_L      0x1326BC
#define REG_BK1326_5E_H      0x1326BD
#define REG_BK1326_5F_L      0x1326BE
#define REG_BK1326_5F_H      0x1326BF
#define REG_BK1326_60_L      0x1326C0
#define REG_BK1326_60_H      0x1326C1
#define REG_BK1326_61_L      0x1326C2
#define REG_BK1326_61_H      0x1326C3
#define REG_BK1326_62_L      0x1326C4
#define REG_BK1326_62_H      0x1326C5
#define REG_BK1326_63_L      0x1326C6
#define REG_BK1326_63_H      0x1326C7
#define REG_BK1326_64_L      0x1326C8
#define REG_BK1326_64_H      0x1326C9
#define REG_BK1326_65_L      0x1326CA
#define REG_BK1326_65_H      0x1326CB
#define REG_BK1326_66_L      0x1326CC
#define REG_BK1326_66_H      0x1326CD
#define REG_BK1326_67_L      0x1326CE
#define REG_BK1326_67_H      0x1326CF
#define REG_BK1326_68_L      0x1326D0
#define REG_BK1326_68_H      0x1326D1
#define REG_BK1326_69_L      0x1326D2
#define REG_BK1326_69_H      0x1326D3
#define REG_BK1326_6A_L      0x1326D4
#define REG_BK1326_6A_H      0x1326D5
#define REG_BK1326_6B_L      0x1326D6
#define REG_BK1326_6B_H      0x1326D7
#define REG_BK1326_6C_L      0x1326D8
#define REG_BK1326_6C_H      0x1326D9
#define REG_BK1326_6D_L      0x1326DA
#define REG_BK1326_6D_H      0x1326DB
#define REG_BK1326_6E_L      0x1326DC
#define REG_BK1326_6E_H      0x1326DD
#define REG_BK1326_6F_L      0x1326DE
#define REG_BK1326_6F_H      0x1326DF
#define REG_BK1326_70_L      0x1326E0
#define REG_BK1326_70_H      0x1326E1
#define REG_BK1326_71_L      0x1326E2
#define REG_BK1326_71_H      0x1326E3
#define REG_BK1326_72_L      0x1326E4
#define REG_BK1326_72_H      0x1326E5
#define REG_BK1326_73_L      0x1326E6
#define REG_BK1326_73_H      0x1326E7
#define REG_BK1326_74_L      0x1326E8
#define REG_BK1326_74_H      0x1326E9
#define REG_BK1326_75_L      0x1326EA
#define REG_BK1326_75_H      0x1326EB
#define REG_BK1326_76_L      0x1326EC
#define REG_BK1326_76_H      0x1326ED
#define REG_BK1326_77_L      0x1326EE
#define REG_BK1326_77_H      0x1326EF
#define REG_BK1326_78_L      0x1326F0
#define REG_BK1326_78_H      0x1326F1
#define REG_BK1326_79_L      0x1326F2
#define REG_BK1326_79_H      0x1326F3
#define REG_BK1326_7A_L      0x1326F4
#define REG_BK1326_7A_H      0x1326F5
#define REG_BK1326_7B_L      0x1326F6
#define REG_BK1326_7B_H      0x1326F7
#define REG_BK1326_7C_L      0x1326F8
#define REG_BK1326_7C_H      0x1326F9
#define REG_BK1326_7D_L      0x1326FA
#define REG_BK1326_7D_H      0x1326FB
#define REG_BK1326_7E_L      0x1326FC
#define REG_BK1326_7E_H      0x1326FD
#define REG_BK1326_7F_L      0x1326FE
#define REG_BK1326_7F_H      0x1326FF
//----------------------------------------------
#define REG_BK1327_00_L      0x132700
#define REG_BK1327_00_H      0x132701
#define REG_BK1327_01_L      0x132702
#define REG_BK1327_01_H      0x132703
#define REG_BK1327_02_L      0x132704
#define REG_BK1327_02_H      0x132705
#define REG_BK1327_03_L      0x132706
#define REG_BK1327_03_H      0x132707
#define REG_BK1327_04_L      0x132708
#define REG_BK1327_04_H      0x132709
#define REG_BK1327_05_L      0x13270A
#define REG_BK1327_05_H      0x13270B
#define REG_BK1327_06_L      0x13270C
#define REG_BK1327_06_H      0x13270D
#define REG_BK1327_07_L      0x13270E
#define REG_BK1327_07_H      0x13270F
#define REG_BK1327_08_L      0x132710
#define REG_BK1327_08_H      0x132711
#define REG_BK1327_09_L      0x132712
#define REG_BK1327_09_H      0x132713
#define REG_BK1327_0A_L      0x132714
#define REG_BK1327_0A_H      0x132715
#define REG_BK1327_0B_L      0x132716
#define REG_BK1327_0B_H      0x132717
#define REG_BK1327_0C_L      0x132718
#define REG_BK1327_0C_H      0x132719
#define REG_BK1327_0D_L      0x13271A
#define REG_BK1327_0D_H      0x13271B
#define REG_BK1327_0E_L      0x13271C
#define REG_BK1327_0E_H      0x13271D
#define REG_BK1327_0F_L      0x13271E
#define REG_BK1327_0F_H      0x13271F
#define REG_BK1327_10_L      0x132720
#define REG_BK1327_10_H      0x132721
#define REG_BK1327_11_L      0x132722
#define REG_BK1327_11_H      0x132723
#define REG_BK1327_12_L      0x132724
#define REG_BK1327_12_H      0x132725
#define REG_BK1327_13_L      0x132726
#define REG_BK1327_13_H      0x132727
#define REG_BK1327_14_L      0x132728
#define REG_BK1327_14_H      0x132729
#define REG_BK1327_15_L      0x13272A
#define REG_BK1327_15_H      0x13272B
#define REG_BK1327_16_L      0x13272C
#define REG_BK1327_16_H      0x13272D
#define REG_BK1327_17_L      0x13272E
#define REG_BK1327_17_H      0x13272F
#define REG_BK1327_18_L      0x132730
#define REG_BK1327_18_H      0x132731
#define REG_BK1327_19_L      0x132732
#define REG_BK1327_19_H      0x132733
#define REG_BK1327_1A_L      0x132734
#define REG_BK1327_1A_H      0x132735
#define REG_BK1327_1B_L      0x132736
#define REG_BK1327_1B_H      0x132737
#define REG_BK1327_1C_L      0x132738
#define REG_BK1327_1C_H      0x132739
#define REG_BK1327_1D_L      0x13273A
#define REG_BK1327_1D_H      0x13273B
#define REG_BK1327_1E_L      0x13273C
#define REG_BK1327_1E_H      0x13273D
#define REG_BK1327_1F_L      0x13273E
#define REG_BK1327_1F_H      0x13273F
#define REG_BK1327_20_L      0x132740
#define REG_BK1327_20_H      0x132741
#define REG_BK1327_21_L      0x132742
#define REG_BK1327_21_H      0x132743
#define REG_BK1327_22_L      0x132744
#define REG_BK1327_22_H      0x132745
#define REG_BK1327_23_L      0x132746
#define REG_BK1327_23_H      0x132747
#define REG_BK1327_24_L      0x132748
#define REG_BK1327_24_H      0x132749
#define REG_BK1327_25_L      0x13274A
#define REG_BK1327_25_H      0x13274B
#define REG_BK1327_26_L      0x13274C
#define REG_BK1327_26_H      0x13274D
#define REG_BK1327_27_L      0x13274E
#define REG_BK1327_27_H      0x13274F
#define REG_BK1327_28_L      0x132750
#define REG_BK1327_28_H      0x132751
#define REG_BK1327_29_L      0x132752
#define REG_BK1327_29_H      0x132753
#define REG_BK1327_2A_L      0x132754
#define REG_BK1327_2A_H      0x132755
#define REG_BK1327_2B_L      0x132756
#define REG_BK1327_2B_H      0x132757
#define REG_BK1327_2C_L      0x132758
#define REG_BK1327_2C_H      0x132759
#define REG_BK1327_2D_L      0x13275A
#define REG_BK1327_2D_H      0x13275B
#define REG_BK1327_2E_L      0x13275C
#define REG_BK1327_2E_H      0x13275D
#define REG_BK1327_2F_L      0x13275E
#define REG_BK1327_2F_H      0x13275F
#define REG_BK1327_30_L      0x132760
#define REG_BK1327_30_H      0x132761
#define REG_BK1327_31_L      0x132762
#define REG_BK1327_31_H      0x132763
#define REG_BK1327_32_L      0x132764
#define REG_BK1327_32_H      0x132765
#define REG_BK1327_33_L      0x132766
#define REG_BK1327_33_H      0x132767
#define REG_BK1327_34_L      0x132768
#define REG_BK1327_34_H      0x132769
#define REG_BK1327_35_L      0x13276A
#define REG_BK1327_35_H      0x13276B
#define REG_BK1327_36_L      0x13276C
#define REG_BK1327_36_H      0x13276D
#define REG_BK1327_37_L      0x13276E
#define REG_BK1327_37_H      0x13276F
#define REG_BK1327_38_L      0x132770
#define REG_BK1327_38_H      0x132771
#define REG_BK1327_39_L      0x132772
#define REG_BK1327_39_H      0x132773
#define REG_BK1327_3A_L      0x132774
#define REG_BK1327_3A_H      0x132775
#define REG_BK1327_3B_L      0x132776
#define REG_BK1327_3B_H      0x132777
#define REG_BK1327_3C_L      0x132778
#define REG_BK1327_3C_H      0x132779
#define REG_BK1327_3D_L      0x13277A
#define REG_BK1327_3D_H      0x13277B
#define REG_BK1327_3E_L      0x13277C
#define REG_BK1327_3E_H      0x13277D
#define REG_BK1327_3F_L      0x13277E
#define REG_BK1327_3F_H      0x13277F
#define REG_BK1327_40_L      0x132780
#define REG_BK1327_40_H      0x132781
#define REG_BK1327_41_L      0x132782
#define REG_BK1327_41_H      0x132783
#define REG_BK1327_42_L      0x132784
#define REG_BK1327_42_H      0x132785
#define REG_BK1327_43_L      0x132786
#define REG_BK1327_43_H      0x132787
#define REG_BK1327_44_L      0x132788
#define REG_BK1327_44_H      0x132789
#define REG_BK1327_45_L      0x13278A
#define REG_BK1327_45_H      0x13278B
#define REG_BK1327_46_L      0x13278C
#define REG_BK1327_46_H      0x13278D
#define REG_BK1327_47_L      0x13278E
#define REG_BK1327_47_H      0x13278F
#define REG_BK1327_48_L      0x132790
#define REG_BK1327_48_H      0x132791
#define REG_BK1327_49_L      0x132792
#define REG_BK1327_49_H      0x132793
#define REG_BK1327_4A_L      0x132794
#define REG_BK1327_4A_H      0x132795
#define REG_BK1327_4B_L      0x132796
#define REG_BK1327_4B_H      0x132797
#define REG_BK1327_4C_L      0x132798
#define REG_BK1327_4C_H      0x132799
#define REG_BK1327_4D_L      0x13279A
#define REG_BK1327_4D_H      0x13279B
#define REG_BK1327_4E_L      0x13279C
#define REG_BK1327_4E_H      0x13279D
#define REG_BK1327_4F_L      0x13279E
#define REG_BK1327_4F_H      0x13279F
#define REG_BK1327_50_L      0x1327A0
#define REG_BK1327_50_H      0x1327A1
#define REG_BK1327_51_L      0x1327A2
#define REG_BK1327_51_H      0x1327A3
#define REG_BK1327_52_L      0x1327A4
#define REG_BK1327_52_H      0x1327A5
#define REG_BK1327_53_L      0x1327A6
#define REG_BK1327_53_H      0x1327A7
#define REG_BK1327_54_L      0x1327A8
#define REG_BK1327_54_H      0x1327A9
#define REG_BK1327_55_L      0x1327AA
#define REG_BK1327_55_H      0x1327AB
#define REG_BK1327_56_L      0x1327AC
#define REG_BK1327_56_H      0x1327AD
#define REG_BK1327_57_L      0x1327AE
#define REG_BK1327_57_H      0x1327AF
#define REG_BK1327_58_L      0x1327B0
#define REG_BK1327_58_H      0x1327B1
#define REG_BK1327_59_L      0x1327B2
#define REG_BK1327_59_H      0x1327B3
#define REG_BK1327_5A_L      0x1327B4
#define REG_BK1327_5A_H      0x1327B5
#define REG_BK1327_5B_L      0x1327B6
#define REG_BK1327_5B_H      0x1327B7
#define REG_BK1327_5C_L      0x1327B8
#define REG_BK1327_5C_H      0x1327B9
#define REG_BK1327_5D_L      0x1327BA
#define REG_BK1327_5D_H      0x1327BB
#define REG_BK1327_5E_L      0x1327BC
#define REG_BK1327_5E_H      0x1327BD
#define REG_BK1327_5F_L      0x1327BE
#define REG_BK1327_5F_H      0x1327BF
#define REG_BK1327_60_L      0x1327C0
#define REG_BK1327_60_H      0x1327C1
#define REG_BK1327_61_L      0x1327C2
#define REG_BK1327_61_H      0x1327C3
#define REG_BK1327_62_L      0x1327C4
#define REG_BK1327_62_H      0x1327C5
#define REG_BK1327_63_L      0x1327C6
#define REG_BK1327_63_H      0x1327C7
#define REG_BK1327_64_L      0x1327C8
#define REG_BK1327_64_H      0x1327C9
#define REG_BK1327_65_L      0x1327CA
#define REG_BK1327_65_H      0x1327CB
#define REG_BK1327_66_L      0x1327CC
#define REG_BK1327_66_H      0x1327CD
#define REG_BK1327_67_L      0x1327CE
#define REG_BK1327_67_H      0x1327CF
#define REG_BK1327_68_L      0x1327D0
#define REG_BK1327_68_H      0x1327D1
#define REG_BK1327_69_L      0x1327D2
#define REG_BK1327_69_H      0x1327D3
#define REG_BK1327_6A_L      0x1327D4
#define REG_BK1327_6A_H      0x1327D5
#define REG_BK1327_6B_L      0x1327D6
#define REG_BK1327_6B_H      0x1327D7
#define REG_BK1327_6C_L      0x1327D8
#define REG_BK1327_6C_H      0x1327D9
#define REG_BK1327_6D_L      0x1327DA
#define REG_BK1327_6D_H      0x1327DB
#define REG_BK1327_6E_L      0x1327DC
#define REG_BK1327_6E_H      0x1327DD
#define REG_BK1327_6F_L      0x1327DE
#define REG_BK1327_6F_H      0x1327DF
#define REG_BK1327_70_L      0x1327E0
#define REG_BK1327_70_H      0x1327E1
#define REG_BK1327_71_L      0x1327E2
#define REG_BK1327_71_H      0x1327E3
#define REG_BK1327_72_L      0x1327E4
#define REG_BK1327_72_H      0x1327E5
#define REG_BK1327_73_L      0x1327E6
#define REG_BK1327_73_H      0x1327E7
#define REG_BK1327_74_L      0x1327E8
#define REG_BK1327_74_H      0x1327E9
#define REG_BK1327_75_L      0x1327EA
#define REG_BK1327_75_H      0x1327EB
#define REG_BK1327_76_L      0x1327EC
#define REG_BK1327_76_H      0x1327ED
#define REG_BK1327_77_L      0x1327EE
#define REG_BK1327_77_H      0x1327EF
#define REG_BK1327_78_L      0x1327F0
#define REG_BK1327_78_H      0x1327F1
#define REG_BK1327_79_L      0x1327F2
#define REG_BK1327_79_H      0x1327F3
#define REG_BK1327_7A_L      0x1327F4
#define REG_BK1327_7A_H      0x1327F5
#define REG_BK1327_7B_L      0x1327F6
#define REG_BK1327_7B_H      0x1327F7
#define REG_BK1327_7C_L      0x1327F8
#define REG_BK1327_7C_H      0x1327F9
#define REG_BK1327_7D_L      0x1327FA
#define REG_BK1327_7D_H      0x1327FB
#define REG_BK1327_7E_L      0x1327FC
#define REG_BK1327_7E_H      0x1327FD
#define REG_BK1327_7F_L      0x1327FE
#define REG_BK1327_7F_H      0x1327FF
//----------------------------------------------
#define REG_BK1328_00_L      0x132800
#define REG_BK1328_00_H      0x132801
#define REG_BK1328_01_L      0x132802
#define REG_BK1328_01_H      0x132803
#define REG_BK1328_02_L      0x132804
#define REG_BK1328_02_H      0x132805
#define REG_BK1328_03_L      0x132806
#define REG_BK1328_03_H      0x132807
#define REG_BK1328_04_L      0x132808
#define REG_BK1328_04_H      0x132809
#define REG_BK1328_05_L      0x13280A
#define REG_BK1328_05_H      0x13280B
#define REG_BK1328_06_L      0x13280C
#define REG_BK1328_06_H      0x13280D
#define REG_BK1328_07_L      0x13280E
#define REG_BK1328_07_H      0x13280F
#define REG_BK1328_08_L      0x132810
#define REG_BK1328_08_H      0x132811
#define REG_BK1328_09_L      0x132812
#define REG_BK1328_09_H      0x132813
#define REG_BK1328_0A_L      0x132814
#define REG_BK1328_0A_H      0x132815
#define REG_BK1328_0B_L      0x132816
#define REG_BK1328_0B_H      0x132817
#define REG_BK1328_0C_L      0x132818
#define REG_BK1328_0C_H      0x132819
#define REG_BK1328_0D_L      0x13281A
#define REG_BK1328_0D_H      0x13281B
#define REG_BK1328_0E_L      0x13281C
#define REG_BK1328_0E_H      0x13281D
#define REG_BK1328_0F_L      0x13281E
#define REG_BK1328_0F_H      0x13281F
#define REG_BK1328_10_L      0x132820
#define REG_BK1328_10_H      0x132821
#define REG_BK1328_11_L      0x132822
#define REG_BK1328_11_H      0x132823
#define REG_BK1328_12_L      0x132824
#define REG_BK1328_12_H      0x132825
#define REG_BK1328_13_L      0x132826
#define REG_BK1328_13_H      0x132827
#define REG_BK1328_14_L      0x132828
#define REG_BK1328_14_H      0x132829
#define REG_BK1328_15_L      0x13282A
#define REG_BK1328_15_H      0x13282B
#define REG_BK1328_16_L      0x13282C
#define REG_BK1328_16_H      0x13282D
#define REG_BK1328_17_L      0x13282E
#define REG_BK1328_17_H      0x13282F
#define REG_BK1328_18_L      0x132830
#define REG_BK1328_18_H      0x132831
#define REG_BK1328_19_L      0x132832
#define REG_BK1328_19_H      0x132833
#define REG_BK1328_1A_L      0x132834
#define REG_BK1328_1A_H      0x132835
#define REG_BK1328_1B_L      0x132836
#define REG_BK1328_1B_H      0x132837
#define REG_BK1328_1C_L      0x132838
#define REG_BK1328_1C_H      0x132839
#define REG_BK1328_1D_L      0x13283A
#define REG_BK1328_1D_H      0x13283B
#define REG_BK1328_1E_L      0x13283C
#define REG_BK1328_1E_H      0x13283D
#define REG_BK1328_1F_L      0x13283E
#define REG_BK1328_1F_H      0x13283F
#define REG_BK1328_20_L      0x132840
#define REG_BK1328_20_H      0x132841
#define REG_BK1328_21_L      0x132842
#define REG_BK1328_21_H      0x132843
#define REG_BK1328_22_L      0x132844
#define REG_BK1328_22_H      0x132845
#define REG_BK1328_23_L      0x132846
#define REG_BK1328_23_H      0x132847
#define REG_BK1328_24_L      0x132848
#define REG_BK1328_24_H      0x132849
#define REG_BK1328_25_L      0x13284A
#define REG_BK1328_25_H      0x13284B
#define REG_BK1328_26_L      0x13284C
#define REG_BK1328_26_H      0x13284D
#define REG_BK1328_27_L      0x13284E
#define REG_BK1328_27_H      0x13284F
#define REG_BK1328_28_L      0x132850
#define REG_BK1328_28_H      0x132851
#define REG_BK1328_29_L      0x132852
#define REG_BK1328_29_H      0x132853
#define REG_BK1328_2A_L      0x132854
#define REG_BK1328_2A_H      0x132855
#define REG_BK1328_2B_L      0x132856
#define REG_BK1328_2B_H      0x132857
#define REG_BK1328_2C_L      0x132858
#define REG_BK1328_2C_H      0x132859
#define REG_BK1328_2D_L      0x13285A
#define REG_BK1328_2D_H      0x13285B
#define REG_BK1328_2E_L      0x13285C
#define REG_BK1328_2E_H      0x13285D
#define REG_BK1328_2F_L      0x13285E
#define REG_BK1328_2F_H      0x13285F
#define REG_BK1328_30_L      0x132860
#define REG_BK1328_30_H      0x132861
#define REG_BK1328_31_L      0x132862
#define REG_BK1328_31_H      0x132863
#define REG_BK1328_32_L      0x132864
#define REG_BK1328_32_H      0x132865
#define REG_BK1328_33_L      0x132866
#define REG_BK1328_33_H      0x132867
#define REG_BK1328_34_L      0x132868
#define REG_BK1328_34_H      0x132869
#define REG_BK1328_35_L      0x13286A
#define REG_BK1328_35_H      0x13286B
#define REG_BK1328_36_L      0x13286C
#define REG_BK1328_36_H      0x13286D
#define REG_BK1328_37_L      0x13286E
#define REG_BK1328_37_H      0x13286F
#define REG_BK1328_38_L      0x132870
#define REG_BK1328_38_H      0x132871
#define REG_BK1328_39_L      0x132872
#define REG_BK1328_39_H      0x132873
#define REG_BK1328_3A_L      0x132874
#define REG_BK1328_3A_H      0x132875
#define REG_BK1328_3B_L      0x132876
#define REG_BK1328_3B_H      0x132877
#define REG_BK1328_3C_L      0x132878
#define REG_BK1328_3C_H      0x132879
#define REG_BK1328_3D_L      0x13287A
#define REG_BK1328_3D_H      0x13287B
#define REG_BK1328_3E_L      0x13287C
#define REG_BK1328_3E_H      0x13287D
#define REG_BK1328_3F_L      0x13287E
#define REG_BK1328_3F_H      0x13287F
#define REG_BK1328_40_L      0x132880
#define REG_BK1328_40_H      0x132881
#define REG_BK1328_41_L      0x132882
#define REG_BK1328_41_H      0x132883
#define REG_BK1328_42_L      0x132884
#define REG_BK1328_42_H      0x132885
#define REG_BK1328_43_L      0x132886
#define REG_BK1328_43_H      0x132887
#define REG_BK1328_44_L      0x132888
#define REG_BK1328_44_H      0x132889
#define REG_BK1328_45_L      0x13288A
#define REG_BK1328_45_H      0x13288B
#define REG_BK1328_46_L      0x13288C
#define REG_BK1328_46_H      0x13288D
#define REG_BK1328_47_L      0x13288E
#define REG_BK1328_47_H      0x13288F
#define REG_BK1328_48_L      0x132890
#define REG_BK1328_48_H      0x132891
#define REG_BK1328_49_L      0x132892
#define REG_BK1328_49_H      0x132893
#define REG_BK1328_4A_L      0x132894
#define REG_BK1328_4A_H      0x132895
#define REG_BK1328_4B_L      0x132896
#define REG_BK1328_4B_H      0x132897
#define REG_BK1328_4C_L      0x132898
#define REG_BK1328_4C_H      0x132899
#define REG_BK1328_4D_L      0x13289A
#define REG_BK1328_4D_H      0x13289B
#define REG_BK1328_4E_L      0x13289C
#define REG_BK1328_4E_H      0x13289D
#define REG_BK1328_4F_L      0x13289E
#define REG_BK1328_4F_H      0x13289F
#define REG_BK1328_50_L      0x1328A0
#define REG_BK1328_50_H      0x1328A1
#define REG_BK1328_51_L      0x1328A2
#define REG_BK1328_51_H      0x1328A3
#define REG_BK1328_52_L      0x1328A4
#define REG_BK1328_52_H      0x1328A5
#define REG_BK1328_53_L      0x1328A6
#define REG_BK1328_53_H      0x1328A7
#define REG_BK1328_54_L      0x1328A8
#define REG_BK1328_54_H      0x1328A9
#define REG_BK1328_55_L      0x1328AA
#define REG_BK1328_55_H      0x1328AB
#define REG_BK1328_56_L      0x1328AC
#define REG_BK1328_56_H      0x1328AD
#define REG_BK1328_57_L      0x1328AE
#define REG_BK1328_57_H      0x1328AF
#define REG_BK1328_58_L      0x1328B0
#define REG_BK1328_58_H      0x1328B1
#define REG_BK1328_59_L      0x1328B2
#define REG_BK1328_59_H      0x1328B3
#define REG_BK1328_5A_L      0x1328B4
#define REG_BK1328_5A_H      0x1328B5
#define REG_BK1328_5B_L      0x1328B6
#define REG_BK1328_5B_H      0x1328B7
#define REG_BK1328_5C_L      0x1328B8
#define REG_BK1328_5C_H      0x1328B9
#define REG_BK1328_5D_L      0x1328BA
#define REG_BK1328_5D_H      0x1328BB
#define REG_BK1328_5E_L      0x1328BC
#define REG_BK1328_5E_H      0x1328BD
#define REG_BK1328_5F_L      0x1328BE
#define REG_BK1328_5F_H      0x1328BF
#define REG_BK1328_60_L      0x1328C0
#define REG_BK1328_60_H      0x1328C1
#define REG_BK1328_61_L      0x1328C2
#define REG_BK1328_61_H      0x1328C3
#define REG_BK1328_62_L      0x1328C4
#define REG_BK1328_62_H      0x1328C5
#define REG_BK1328_63_L      0x1328C6
#define REG_BK1328_63_H      0x1328C7
#define REG_BK1328_64_L      0x1328C8
#define REG_BK1328_64_H      0x1328C9
#define REG_BK1328_65_L      0x1328CA
#define REG_BK1328_65_H      0x1328CB
#define REG_BK1328_66_L      0x1328CC
#define REG_BK1328_66_H      0x1328CD
#define REG_BK1328_67_L      0x1328CE
#define REG_BK1328_67_H      0x1328CF
#define REG_BK1328_68_L      0x1328D0
#define REG_BK1328_68_H      0x1328D1
#define REG_BK1328_69_L      0x1328D2
#define REG_BK1328_69_H      0x1328D3
#define REG_BK1328_6A_L      0x1328D4
#define REG_BK1328_6A_H      0x1328D5
#define REG_BK1328_6B_L      0x1328D6
#define REG_BK1328_6B_H      0x1328D7
#define REG_BK1328_6C_L      0x1328D8
#define REG_BK1328_6C_H      0x1328D9
#define REG_BK1328_6D_L      0x1328DA
#define REG_BK1328_6D_H      0x1328DB
#define REG_BK1328_6E_L      0x1328DC
#define REG_BK1328_6E_H      0x1328DD
#define REG_BK1328_6F_L      0x1328DE
#define REG_BK1328_6F_H      0x1328DF
#define REG_BK1328_70_L      0x1328E0
#define REG_BK1328_70_H      0x1328E1
#define REG_BK1328_71_L      0x1328E2
#define REG_BK1328_71_H      0x1328E3
#define REG_BK1328_72_L      0x1328E4
#define REG_BK1328_72_H      0x1328E5
#define REG_BK1328_73_L      0x1328E6
#define REG_BK1328_73_H      0x1328E7
#define REG_BK1328_74_L      0x1328E8
#define REG_BK1328_74_H      0x1328E9
#define REG_BK1328_75_L      0x1328EA
#define REG_BK1328_75_H      0x1328EB
#define REG_BK1328_76_L      0x1328EC
#define REG_BK1328_76_H      0x1328ED
#define REG_BK1328_77_L      0x1328EE
#define REG_BK1328_77_H      0x1328EF
#define REG_BK1328_78_L      0x1328F0
#define REG_BK1328_78_H      0x1328F1
#define REG_BK1328_79_L      0x1328F2
#define REG_BK1328_79_H      0x1328F3
#define REG_BK1328_7A_L      0x1328F4
#define REG_BK1328_7A_H      0x1328F5
#define REG_BK1328_7B_L      0x1328F6
#define REG_BK1328_7B_H      0x1328F7
#define REG_BK1328_7C_L      0x1328F8
#define REG_BK1328_7C_H      0x1328F9
#define REG_BK1328_7D_L      0x1328FA
#define REG_BK1328_7D_H      0x1328FB
#define REG_BK1328_7E_L      0x1328FC
#define REG_BK1328_7E_H      0x1328FD
#define REG_BK1328_7F_L      0x1328FE
#define REG_BK1328_7F_H      0x1328FF
//----------------------------------------------
#define REG_BK132A_00_L      0x132A00
#define REG_BK132A_00_H      0x132A01
#define REG_BK132A_01_L      0x132A02
#define REG_BK132A_01_H      0x132A03
#define REG_BK132A_02_L      0x132A04
#define REG_BK132A_02_H      0x132A05
#define REG_BK132A_03_L      0x132A06
#define REG_BK132A_03_H      0x132A07
#define REG_BK132A_04_L      0x132A08
#define REG_BK132A_04_H      0x132A09
#define REG_BK132A_05_L      0x132A0A
#define REG_BK132A_05_H      0x132A0B
#define REG_BK132A_06_L      0x132A0C
#define REG_BK132A_06_H      0x132A0D
#define REG_BK132A_07_L      0x132A0E
#define REG_BK132A_07_H      0x132A0F
#define REG_BK132A_08_L      0x132A10
#define REG_BK132A_08_H      0x132A11
#define REG_BK132A_09_L      0x132A12
#define REG_BK132A_09_H      0x132A13
#define REG_BK132A_0A_L      0x132A14
#define REG_BK132A_0A_H      0x132A15
#define REG_BK132A_0B_L      0x132A16
#define REG_BK132A_0B_H      0x132A17
#define REG_BK132A_0C_L      0x132A18
#define REG_BK132A_0C_H      0x132A19
#define REG_BK132A_0D_L      0x132A1A
#define REG_BK132A_0D_H      0x132A1B
#define REG_BK132A_0E_L      0x132A1C
#define REG_BK132A_0E_H      0x132A1D
#define REG_BK132A_0F_L      0x132A1E
#define REG_BK132A_0F_H      0x132A1F
#define REG_BK132A_10_L      0x132A20
#define REG_BK132A_10_H      0x132A21
#define REG_BK132A_11_L      0x132A22
#define REG_BK132A_11_H      0x132A23
#define REG_BK132A_12_L      0x132A24
#define REG_BK132A_12_H      0x132A25
#define REG_BK132A_13_L      0x132A26
#define REG_BK132A_13_H      0x132A27
#define REG_BK132A_14_L      0x132A28
#define REG_BK132A_14_H      0x132A29
#define REG_BK132A_15_L      0x132A2A
#define REG_BK132A_15_H      0x132A2B
#define REG_BK132A_16_L      0x132A2C
#define REG_BK132A_16_H      0x132A2D
#define REG_BK132A_17_L      0x132A2E
#define REG_BK132A_17_H      0x132A2F
#define REG_BK132A_18_L      0x132A30
#define REG_BK132A_18_H      0x132A31
#define REG_BK132A_19_L      0x132A32
#define REG_BK132A_19_H      0x132A33
#define REG_BK132A_1A_L      0x132A34
#define REG_BK132A_1A_H      0x132A35
#define REG_BK132A_1B_L      0x132A36
#define REG_BK132A_1B_H      0x132A37
#define REG_BK132A_1C_L      0x132A38
#define REG_BK132A_1C_H      0x132A39
#define REG_BK132A_1D_L      0x132A3A
#define REG_BK132A_1D_H      0x132A3B
#define REG_BK132A_1E_L      0x132A3C
#define REG_BK132A_1E_H      0x132A3D
#define REG_BK132A_1F_L      0x132A3E
#define REG_BK132A_1F_H      0x132A3F
#define REG_BK132A_20_L      0x132A40
#define REG_BK132A_20_H      0x132A41
#define REG_BK132A_21_L      0x132A42
#define REG_BK132A_21_H      0x132A43
#define REG_BK132A_22_L      0x132A44
#define REG_BK132A_22_H      0x132A45
#define REG_BK132A_23_L      0x132A46
#define REG_BK132A_23_H      0x132A47
#define REG_BK132A_24_L      0x132A48
#define REG_BK132A_24_H      0x132A49
#define REG_BK132A_25_L      0x132A4A
#define REG_BK132A_25_H      0x132A4B
#define REG_BK132A_26_L      0x132A4C
#define REG_BK132A_26_H      0x132A4D
#define REG_BK132A_27_L      0x132A4E
#define REG_BK132A_27_H      0x132A4F
#define REG_BK132A_28_L      0x132A50
#define REG_BK132A_28_H      0x132A51
#define REG_BK132A_29_L      0x132A52
#define REG_BK132A_29_H      0x132A53
#define REG_BK132A_2A_L      0x132A54
#define REG_BK132A_2A_H      0x132A55
#define REG_BK132A_2B_L      0x132A56
#define REG_BK132A_2B_H      0x132A57
#define REG_BK132A_2C_L      0x132A58
#define REG_BK132A_2C_H      0x132A59
#define REG_BK132A_2D_L      0x132A5A
#define REG_BK132A_2D_H      0x132A5B
#define REG_BK132A_2E_L      0x132A5C
#define REG_BK132A_2E_H      0x132A5D
#define REG_BK132A_2F_L      0x132A5E
#define REG_BK132A_2F_H      0x132A5F
#define REG_BK132A_30_L      0x132A60
#define REG_BK132A_30_H      0x132A61
#define REG_BK132A_31_L      0x132A62
#define REG_BK132A_31_H      0x132A63
#define REG_BK132A_32_L      0x132A64
#define REG_BK132A_32_H      0x132A65
#define REG_BK132A_33_L      0x132A66
#define REG_BK132A_33_H      0x132A67
#define REG_BK132A_34_L      0x132A68
#define REG_BK132A_34_H      0x132A69
#define REG_BK132A_35_L      0x132A6A
#define REG_BK132A_35_H      0x132A6B
#define REG_BK132A_36_L      0x132A6C
#define REG_BK132A_36_H      0x132A6D
#define REG_BK132A_37_L      0x132A6E
#define REG_BK132A_37_H      0x132A6F
#define REG_BK132A_38_L      0x132A70
#define REG_BK132A_38_H      0x132A71
#define REG_BK132A_39_L      0x132A72
#define REG_BK132A_39_H      0x132A73
#define REG_BK132A_3A_L      0x132A74
#define REG_BK132A_3A_H      0x132A75
#define REG_BK132A_3B_L      0x132A76
#define REG_BK132A_3B_H      0x132A77
#define REG_BK132A_3C_L      0x132A78
#define REG_BK132A_3C_H      0x132A79
#define REG_BK132A_3D_L      0x132A7A
#define REG_BK132A_3D_H      0x132A7B
#define REG_BK132A_3E_L      0x132A7C
#define REG_BK132A_3E_H      0x132A7D
#define REG_BK132A_3F_L      0x132A7E
#define REG_BK132A_3F_H      0x132A7F
#define REG_BK132A_40_L      0x132A80
#define REG_BK132A_40_H      0x132A81
#define REG_BK132A_41_L      0x132A82
#define REG_BK132A_41_H      0x132A83
#define REG_BK132A_42_L      0x132A84
#define REG_BK132A_42_H      0x132A85
#define REG_BK132A_43_L      0x132A86
#define REG_BK132A_43_H      0x132A87
#define REG_BK132A_44_L      0x132A88
#define REG_BK132A_44_H      0x132A89
#define REG_BK132A_45_L      0x132A8A
#define REG_BK132A_45_H      0x132A8B
#define REG_BK132A_46_L      0x132A8C
#define REG_BK132A_46_H      0x132A8D
#define REG_BK132A_47_L      0x132A8E
#define REG_BK132A_47_H      0x132A8F
#define REG_BK132A_48_L      0x132A90
#define REG_BK132A_48_H      0x132A91
#define REG_BK132A_49_L      0x132A92
#define REG_BK132A_49_H      0x132A93
#define REG_BK132A_4A_L      0x132A94
#define REG_BK132A_4A_H      0x132A95
#define REG_BK132A_4B_L      0x132A96
#define REG_BK132A_4B_H      0x132A97
#define REG_BK132A_4C_L      0x132A98
#define REG_BK132A_4C_H      0x132A99
#define REG_BK132A_4D_L      0x132A9A
#define REG_BK132A_4D_H      0x132A9B
#define REG_BK132A_4E_L      0x132A9C
#define REG_BK132A_4E_H      0x132A9D
#define REG_BK132A_4F_L      0x132A9E
#define REG_BK132A_4F_H      0x132A9F
#define REG_BK132A_50_L      0x132AA0
#define REG_BK132A_50_H      0x132AA1
#define REG_BK132A_51_L      0x132AA2
#define REG_BK132A_51_H      0x132AA3
#define REG_BK132A_52_L      0x132AA4
#define REG_BK132A_52_H      0x132AA5
#define REG_BK132A_53_L      0x132AA6
#define REG_BK132A_53_H      0x132AA7
#define REG_BK132A_54_L      0x132AA8
#define REG_BK132A_54_H      0x132AA9
#define REG_BK132A_55_L      0x132AAA
#define REG_BK132A_55_H      0x132AAB
#define REG_BK132A_56_L      0x132AAC
#define REG_BK132A_56_H      0x132AAD
#define REG_BK132A_57_L      0x132AAE
#define REG_BK132A_57_H      0x132AAF
#define REG_BK132A_58_L      0x132AB0
#define REG_BK132A_58_H      0x132AB1
#define REG_BK132A_59_L      0x132AB2
#define REG_BK132A_59_H      0x132AB3
#define REG_BK132A_5A_L      0x132AB4
#define REG_BK132A_5A_H      0x132AB5
#define REG_BK132A_5B_L      0x132AB6
#define REG_BK132A_5B_H      0x132AB7
#define REG_BK132A_5C_L      0x132AB8
#define REG_BK132A_5C_H      0x132AB9
#define REG_BK132A_5D_L      0x132ABA
#define REG_BK132A_5D_H      0x132ABB
#define REG_BK132A_5E_L      0x132ABC
#define REG_BK132A_5E_H      0x132ABD
#define REG_BK132A_5F_L      0x132ABE
#define REG_BK132A_5F_H      0x132ABF
#define REG_BK132A_60_L      0x132AC0
#define REG_BK132A_60_H      0x132AC1
#define REG_BK132A_61_L      0x132AC2
#define REG_BK132A_61_H      0x132AC3
#define REG_BK132A_62_L      0x132AC4
#define REG_BK132A_62_H      0x132AC5
#define REG_BK132A_63_L      0x132AC6
#define REG_BK132A_63_H      0x132AC7
#define REG_BK132A_64_L      0x132AC8
#define REG_BK132A_64_H      0x132AC9
#define REG_BK132A_65_L      0x132ACA
#define REG_BK132A_65_H      0x132ACB
#define REG_BK132A_66_L      0x132ACC
#define REG_BK132A_66_H      0x132ACD
#define REG_BK132A_67_L      0x132ACE
#define REG_BK132A_67_H      0x132ACF
#define REG_BK132A_68_L      0x132AD0
#define REG_BK132A_68_H      0x132AD1
#define REG_BK132A_69_L      0x132AD2
#define REG_BK132A_69_H      0x132AD3
#define REG_BK132A_6A_L      0x132AD4
#define REG_BK132A_6A_H      0x132AD5
#define REG_BK132A_6B_L      0x132AD6
#define REG_BK132A_6B_H      0x132AD7
#define REG_BK132A_6C_L      0x132AD8
#define REG_BK132A_6C_H      0x132AD9
#define REG_BK132A_6D_L      0x132ADA
#define REG_BK132A_6D_H      0x132ADB
#define REG_BK132A_6E_L      0x132ADC
#define REG_BK132A_6E_H      0x132ADD
#define REG_BK132A_6F_L      0x132ADE
#define REG_BK132A_6F_H      0x132ADF
#define REG_BK132A_70_L      0x132AE0
#define REG_BK132A_70_H      0x132AE1
#define REG_BK132A_71_L      0x132AE2
#define REG_BK132A_71_H      0x132AE3
#define REG_BK132A_72_L      0x132AE4
#define REG_BK132A_72_H      0x132AE5
#define REG_BK132A_73_L      0x132AE6
#define REG_BK132A_73_H      0x132AE7
#define REG_BK132A_74_L      0x132AE8
#define REG_BK132A_74_H      0x132AE9
#define REG_BK132A_75_L      0x132AEA
#define REG_BK132A_75_H      0x132AEB
#define REG_BK132A_76_L      0x132AEC
#define REG_BK132A_76_H      0x132AED
#define REG_BK132A_77_L      0x132AEE
#define REG_BK132A_77_H      0x132AEF
#define REG_BK132A_78_L      0x132AF0
#define REG_BK132A_78_H      0x132AF1
#define REG_BK132A_79_L      0x132AF2
#define REG_BK132A_79_H      0x132AF3
#define REG_BK132A_7A_L      0x132AF4
#define REG_BK132A_7A_H      0x132AF5
#define REG_BK132A_7B_L      0x132AF6
#define REG_BK132A_7B_H      0x132AF7
#define REG_BK132A_7C_L      0x132AF8
#define REG_BK132A_7C_H      0x132AF9
#define REG_BK132A_7D_L      0x132AFA
#define REG_BK132A_7D_H      0x132AFB
#define REG_BK132A_7E_L      0x132AFC
#define REG_BK132A_7E_H      0x132AFD
#define REG_BK132A_7F_L      0x132AFE
#define REG_BK132A_7F_H      0x132AFF
//----------------------------------------------
#define REG_BK132B_00_L      0x132B00
#define REG_BK132B_00_H      0x132B01
#define REG_BK132B_01_L      0x132B02
#define REG_BK132B_01_H      0x132B03
#define REG_BK132B_02_L      0x132B04
#define REG_BK132B_02_H      0x132B05
#define REG_BK132B_03_L      0x132B06
#define REG_BK132B_03_H      0x132B07
#define REG_BK132B_04_L      0x132B08
#define REG_BK132B_04_H      0x132B09
#define REG_BK132B_05_L      0x132B0A
#define REG_BK132B_05_H      0x132B0B
#define REG_BK132B_06_L      0x132B0C
#define REG_BK132B_06_H      0x132B0D
#define REG_BK132B_07_L      0x132B0E
#define REG_BK132B_07_H      0x132B0F
#define REG_BK132B_08_L      0x132B10
#define REG_BK132B_08_H      0x132B11
#define REG_BK132B_09_L      0x132B12
#define REG_BK132B_09_H      0x132B13
#define REG_BK132B_0A_L      0x132B14
#define REG_BK132B_0A_H      0x132B15
#define REG_BK132B_0B_L      0x132B16
#define REG_BK132B_0B_H      0x132B17
#define REG_BK132B_0C_L      0x132B18
#define REG_BK132B_0C_H      0x132B19
#define REG_BK132B_0D_L      0x132B1A
#define REG_BK132B_0D_H      0x132B1B
#define REG_BK132B_0E_L      0x132B1C
#define REG_BK132B_0E_H      0x132B1D
#define REG_BK132B_0F_L      0x132B1E
#define REG_BK132B_0F_H      0x132B1F
#define REG_BK132B_10_L      0x132B20
#define REG_BK132B_10_H      0x132B21
#define REG_BK132B_11_L      0x132B22
#define REG_BK132B_11_H      0x132B23
#define REG_BK132B_12_L      0x132B24
#define REG_BK132B_12_H      0x132B25
#define REG_BK132B_13_L      0x132B26
#define REG_BK132B_13_H      0x132B27
#define REG_BK132B_14_L      0x132B28
#define REG_BK132B_14_H      0x132B29
#define REG_BK132B_15_L      0x132B2A
#define REG_BK132B_15_H      0x132B2B
#define REG_BK132B_16_L      0x132B2C
#define REG_BK132B_16_H      0x132B2D
#define REG_BK132B_17_L      0x132B2E
#define REG_BK132B_17_H      0x132B2F
#define REG_BK132B_18_L      0x132B30
#define REG_BK132B_18_H      0x132B31
#define REG_BK132B_19_L      0x132B32
#define REG_BK132B_19_H      0x132B33
#define REG_BK132B_1A_L      0x132B34
#define REG_BK132B_1A_H      0x132B35
#define REG_BK132B_1B_L      0x132B36
#define REG_BK132B_1B_H      0x132B37
#define REG_BK132B_1C_L      0x132B38
#define REG_BK132B_1C_H      0x132B39
#define REG_BK132B_1D_L      0x132B3A
#define REG_BK132B_1D_H      0x132B3B
#define REG_BK132B_1E_L      0x132B3C
#define REG_BK132B_1E_H      0x132B3D
#define REG_BK132B_1F_L      0x132B3E
#define REG_BK132B_1F_H      0x132B3F
#define REG_BK132B_20_L      0x132B40
#define REG_BK132B_20_H      0x132B41
#define REG_BK132B_21_L      0x132B42
#define REG_BK132B_21_H      0x132B43
#define REG_BK132B_22_L      0x132B44
#define REG_BK132B_22_H      0x132B45
#define REG_BK132B_23_L      0x132B46
#define REG_BK132B_23_H      0x132B47
#define REG_BK132B_24_L      0x132B48
#define REG_BK132B_24_H      0x132B49
#define REG_BK132B_25_L      0x132B4A
#define REG_BK132B_25_H      0x132B4B
#define REG_BK132B_26_L      0x132B4C
#define REG_BK132B_26_H      0x132B4D
#define REG_BK132B_27_L      0x132B4E
#define REG_BK132B_27_H      0x132B4F
#define REG_BK132B_28_L      0x132B50
#define REG_BK132B_28_H      0x132B51
#define REG_BK132B_29_L      0x132B52
#define REG_BK132B_29_H      0x132B53
#define REG_BK132B_2A_L      0x132B54
#define REG_BK132B_2A_H      0x132B55
#define REG_BK132B_2B_L      0x132B56
#define REG_BK132B_2B_H      0x132B57
#define REG_BK132B_2C_L      0x132B58
#define REG_BK132B_2C_H      0x132B59
#define REG_BK132B_2D_L      0x132B5A
#define REG_BK132B_2D_H      0x132B5B
#define REG_BK132B_2E_L      0x132B5C
#define REG_BK132B_2E_H      0x132B5D
#define REG_BK132B_2F_L      0x132B5E
#define REG_BK132B_2F_H      0x132B5F
#define REG_BK132B_30_L      0x132B60
#define REG_BK132B_30_H      0x132B61
#define REG_BK132B_31_L      0x132B62
#define REG_BK132B_31_H      0x132B63
#define REG_BK132B_32_L      0x132B64
#define REG_BK132B_32_H      0x132B65
#define REG_BK132B_33_L      0x132B66
#define REG_BK132B_33_H      0x132B67
#define REG_BK132B_34_L      0x132B68
#define REG_BK132B_34_H      0x132B69
#define REG_BK132B_35_L      0x132B6A
#define REG_BK132B_35_H      0x132B6B
#define REG_BK132B_36_L      0x132B6C
#define REG_BK132B_36_H      0x132B6D
#define REG_BK132B_37_L      0x132B6E
#define REG_BK132B_37_H      0x132B6F
#define REG_BK132B_38_L      0x132B70
#define REG_BK132B_38_H      0x132B71
#define REG_BK132B_39_L      0x132B72
#define REG_BK132B_39_H      0x132B73
#define REG_BK132B_3A_L      0x132B74
#define REG_BK132B_3A_H      0x132B75
#define REG_BK132B_3B_L      0x132B76
#define REG_BK132B_3B_H      0x132B77
#define REG_BK132B_3C_L      0x132B78
#define REG_BK132B_3C_H      0x132B79
#define REG_BK132B_3D_L      0x132B7A
#define REG_BK132B_3D_H      0x132B7B
#define REG_BK132B_3E_L      0x132B7C
#define REG_BK132B_3E_H      0x132B7D
#define REG_BK132B_3F_L      0x132B7E
#define REG_BK132B_3F_H      0x132B7F
#define REG_BK132B_40_L      0x132B80
#define REG_BK132B_40_H      0x132B81
#define REG_BK132B_41_L      0x132B82
#define REG_BK132B_41_H      0x132B83
#define REG_BK132B_42_L      0x132B84
#define REG_BK132B_42_H      0x132B85
#define REG_BK132B_43_L      0x132B86
#define REG_BK132B_43_H      0x132B87
#define REG_BK132B_44_L      0x132B88
#define REG_BK132B_44_H      0x132B89
#define REG_BK132B_45_L      0x132B8A
#define REG_BK132B_45_H      0x132B8B
#define REG_BK132B_46_L      0x132B8C
#define REG_BK132B_46_H      0x132B8D
#define REG_BK132B_47_L      0x132B8E
#define REG_BK132B_47_H      0x132B8F
#define REG_BK132B_48_L      0x132B90
#define REG_BK132B_48_H      0x132B91
#define REG_BK132B_49_L      0x132B92
#define REG_BK132B_49_H      0x132B93
#define REG_BK132B_4A_L      0x132B94
#define REG_BK132B_4A_H      0x132B95
#define REG_BK132B_4B_L      0x132B96
#define REG_BK132B_4B_H      0x132B97
#define REG_BK132B_4C_L      0x132B98
#define REG_BK132B_4C_H      0x132B99
#define REG_BK132B_4D_L      0x132B9A
#define REG_BK132B_4D_H      0x132B9B
#define REG_BK132B_4E_L      0x132B9C
#define REG_BK132B_4E_H      0x132B9D
#define REG_BK132B_4F_L      0x132B9E
#define REG_BK132B_4F_H      0x132B9F
#define REG_BK132B_50_L      0x132BA0
#define REG_BK132B_50_H      0x132BA1
#define REG_BK132B_51_L      0x132BA2
#define REG_BK132B_51_H      0x132BA3
#define REG_BK132B_52_L      0x132BA4
#define REG_BK132B_52_H      0x132BA5
#define REG_BK132B_53_L      0x132BA6
#define REG_BK132B_53_H      0x132BA7
#define REG_BK132B_54_L      0x132BA8
#define REG_BK132B_54_H      0x132BA9
#define REG_BK132B_55_L      0x132BAA
#define REG_BK132B_55_H      0x132BAB
#define REG_BK132B_56_L      0x132BAC
#define REG_BK132B_56_H      0x132BAD
#define REG_BK132B_57_L      0x132BAE
#define REG_BK132B_57_H      0x132BAF
#define REG_BK132B_58_L      0x132BB0
#define REG_BK132B_58_H      0x132BB1
#define REG_BK132B_59_L      0x132BB2
#define REG_BK132B_59_H      0x132BB3
#define REG_BK132B_5A_L      0x132BB4
#define REG_BK132B_5A_H      0x132BB5
#define REG_BK132B_5B_L      0x132BB6
#define REG_BK132B_5B_H      0x132BB7
#define REG_BK132B_5C_L      0x132BB8
#define REG_BK132B_5C_H      0x132BB9
#define REG_BK132B_5D_L      0x132BBA
#define REG_BK132B_5D_H      0x132BBB
#define REG_BK132B_5E_L      0x132BBC
#define REG_BK132B_5E_H      0x132BBD
#define REG_BK132B_5F_L      0x132BBE
#define REG_BK132B_5F_H      0x132BBF
#define REG_BK132B_60_L      0x132BC0
#define REG_BK132B_60_H      0x132BC1
#define REG_BK132B_61_L      0x132BC2
#define REG_BK132B_61_H      0x132BC3
#define REG_BK132B_62_L      0x132BC4
#define REG_BK132B_62_H      0x132BC5
#define REG_BK132B_63_L      0x132BC6
#define REG_BK132B_63_H      0x132BC7
#define REG_BK132B_64_L      0x132BC8
#define REG_BK132B_64_H      0x132BC9
#define REG_BK132B_65_L      0x132BCA
#define REG_BK132B_65_H      0x132BCB
#define REG_BK132B_66_L      0x132BCC
#define REG_BK132B_66_H      0x132BCD
#define REG_BK132B_67_L      0x132BCE
#define REG_BK132B_67_H      0x132BCF
#define REG_BK132B_68_L      0x132BD0
#define REG_BK132B_68_H      0x132BD1
#define REG_BK132B_69_L      0x132BD2
#define REG_BK132B_69_H      0x132BD3
#define REG_BK132B_6A_L      0x132BD4
#define REG_BK132B_6A_H      0x132BD5
#define REG_BK132B_6B_L      0x132BD6
#define REG_BK132B_6B_H      0x132BD7
#define REG_BK132B_6C_L      0x132BD8
#define REG_BK132B_6C_H      0x132BD9
#define REG_BK132B_6D_L      0x132BDA
#define REG_BK132B_6D_H      0x132BDB
#define REG_BK132B_6E_L      0x132BDC
#define REG_BK132B_6E_H      0x132BDD
#define REG_BK132B_6F_L      0x132BDE
#define REG_BK132B_6F_H      0x132BDF
#define REG_BK132B_70_L      0x132BE0
#define REG_BK132B_70_H      0x132BE1
#define REG_BK132B_71_L      0x132BE2
#define REG_BK132B_71_H      0x132BE3
#define REG_BK132B_72_L      0x132BE4
#define REG_BK132B_72_H      0x132BE5
#define REG_BK132B_73_L      0x132BE6
#define REG_BK132B_73_H      0x132BE7
#define REG_BK132B_74_L      0x132BE8
#define REG_BK132B_74_H      0x132BE9
#define REG_BK132B_75_L      0x132BEA
#define REG_BK132B_75_H      0x132BEB
#define REG_BK132B_76_L      0x132BEC
#define REG_BK132B_76_H      0x132BED
#define REG_BK132B_77_L      0x132BEE
#define REG_BK132B_77_H      0x132BEF
#define REG_BK132B_78_L      0x132BF0
#define REG_BK132B_78_H      0x132BF1
#define REG_BK132B_79_L      0x132BF2
#define REG_BK132B_79_H      0x132BF3
#define REG_BK132B_7A_L      0x132BF4
#define REG_BK132B_7A_H      0x132BF5
#define REG_BK132B_7B_L      0x132BF6
#define REG_BK132B_7B_H      0x132BF7
#define REG_BK132B_7C_L      0x132BF8
#define REG_BK132B_7C_H      0x132BF9
#define REG_BK132B_7D_L      0x132BFA
#define REG_BK132B_7D_H      0x132BFB
#define REG_BK132B_7E_L      0x132BFC
#define REG_BK132B_7E_H      0x132BFD
#define REG_BK132B_7F_L      0x132BFE
#define REG_BK132B_7F_H      0x132BFF
//----------------------------------------------
#define REG_BK132C_00_L      0x132C00
#define REG_BK132C_00_H      0x132C01
#define REG_BK132C_01_L      0x132C02
#define REG_BK132C_01_H      0x132C03
#define REG_BK132C_02_L      0x132C04
#define REG_BK132C_02_H      0x132C05
#define REG_BK132C_03_L      0x132C06
#define REG_BK132C_03_H      0x132C07
#define REG_BK132C_04_L      0x132C08
#define REG_BK132C_04_H      0x132C09
#define REG_BK132C_05_L      0x132C0A
#define REG_BK132C_05_H      0x132C0B
#define REG_BK132C_06_L      0x132C0C
#define REG_BK132C_06_H      0x132C0D
#define REG_BK132C_07_L      0x132C0E
#define REG_BK132C_07_H      0x132C0F
#define REG_BK132C_08_L      0x132C10
#define REG_BK132C_08_H      0x132C11
#define REG_BK132C_09_L      0x132C12
#define REG_BK132C_09_H      0x132C13
#define REG_BK132C_0A_L      0x132C14
#define REG_BK132C_0A_H      0x132C15
#define REG_BK132C_0B_L      0x132C16
#define REG_BK132C_0B_H      0x132C17
#define REG_BK132C_0C_L      0x132C18
#define REG_BK132C_0C_H      0x132C19
#define REG_BK132C_0D_L      0x132C1A
#define REG_BK132C_0D_H      0x132C1B
#define REG_BK132C_0E_L      0x132C1C
#define REG_BK132C_0E_H      0x132C1D
#define REG_BK132C_0F_L      0x132C1E
#define REG_BK132C_0F_H      0x132C1F
#define REG_BK132C_10_L      0x132C20
#define REG_BK132C_10_H      0x132C21
#define REG_BK132C_11_L      0x132C22
#define REG_BK132C_11_H      0x132C23
#define REG_BK132C_12_L      0x132C24
#define REG_BK132C_12_H      0x132C25
#define REG_BK132C_13_L      0x132C26
#define REG_BK132C_13_H      0x132C27
#define REG_BK132C_14_L      0x132C28
#define REG_BK132C_14_H      0x132C29
#define REG_BK132C_15_L      0x132C2A
#define REG_BK132C_15_H      0x132C2B
#define REG_BK132C_16_L      0x132C2C
#define REG_BK132C_16_H      0x132C2D
#define REG_BK132C_17_L      0x132C2E
#define REG_BK132C_17_H      0x132C2F
#define REG_BK132C_18_L      0x132C30
#define REG_BK132C_18_H      0x132C31
#define REG_BK132C_19_L      0x132C32
#define REG_BK132C_19_H      0x132C33
#define REG_BK132C_1A_L      0x132C34
#define REG_BK132C_1A_H      0x132C35
#define REG_BK132C_1B_L      0x132C36
#define REG_BK132C_1B_H      0x132C37
#define REG_BK132C_1C_L      0x132C38
#define REG_BK132C_1C_H      0x132C39
#define REG_BK132C_1D_L      0x132C3A
#define REG_BK132C_1D_H      0x132C3B
#define REG_BK132C_1E_L      0x132C3C
#define REG_BK132C_1E_H      0x132C3D
#define REG_BK132C_1F_L      0x132C3E
#define REG_BK132C_1F_H      0x132C3F
#define REG_BK132C_20_L      0x132C40
#define REG_BK132C_20_H      0x132C41
#define REG_BK132C_21_L      0x132C42
#define REG_BK132C_21_H      0x132C43
#define REG_BK132C_22_L      0x132C44
#define REG_BK132C_22_H      0x132C45
#define REG_BK132C_23_L      0x132C46
#define REG_BK132C_23_H      0x132C47
#define REG_BK132C_24_L      0x132C48
#define REG_BK132C_24_H      0x132C49
#define REG_BK132C_25_L      0x132C4A
#define REG_BK132C_25_H      0x132C4B
#define REG_BK132C_26_L      0x132C4C
#define REG_BK132C_26_H      0x132C4D
#define REG_BK132C_27_L      0x132C4E
#define REG_BK132C_27_H      0x132C4F
#define REG_BK132C_28_L      0x132C50
#define REG_BK132C_28_H      0x132C51
#define REG_BK132C_29_L      0x132C52
#define REG_BK132C_29_H      0x132C53
#define REG_BK132C_2A_L      0x132C54
#define REG_BK132C_2A_H      0x132C55
#define REG_BK132C_2B_L      0x132C56
#define REG_BK132C_2B_H      0x132C57
#define REG_BK132C_2C_L      0x132C58
#define REG_BK132C_2C_H      0x132C59
#define REG_BK132C_2D_L      0x132C5A
#define REG_BK132C_2D_H      0x132C5B
#define REG_BK132C_2E_L      0x132C5C
#define REG_BK132C_2E_H      0x132C5D
#define REG_BK132C_2F_L      0x132C5E
#define REG_BK132C_2F_H      0x132C5F
#define REG_BK132C_30_L      0x132C60
#define REG_BK132C_30_H      0x132C61
#define REG_BK132C_31_L      0x132C62
#define REG_BK132C_31_H      0x132C63
#define REG_BK132C_32_L      0x132C64
#define REG_BK132C_32_H      0x132C65
#define REG_BK132C_33_L      0x132C66
#define REG_BK132C_33_H      0x132C67
#define REG_BK132C_34_L      0x132C68
#define REG_BK132C_34_H      0x132C69
#define REG_BK132C_35_L      0x132C6A
#define REG_BK132C_35_H      0x132C6B
#define REG_BK132C_36_L      0x132C6C
#define REG_BK132C_36_H      0x132C6D
#define REG_BK132C_37_L      0x132C6E
#define REG_BK132C_37_H      0x132C6F
#define REG_BK132C_38_L      0x132C70
#define REG_BK132C_38_H      0x132C71
#define REG_BK132C_39_L      0x132C72
#define REG_BK132C_39_H      0x132C73
#define REG_BK132C_3A_L      0x132C74
#define REG_BK132C_3A_H      0x132C75
#define REG_BK132C_3B_L      0x132C76
#define REG_BK132C_3B_H      0x132C77
#define REG_BK132C_3C_L      0x132C78
#define REG_BK132C_3C_H      0x132C79
#define REG_BK132C_3D_L      0x132C7A
#define REG_BK132C_3D_H      0x132C7B
#define REG_BK132C_3E_L      0x132C7C
#define REG_BK132C_3E_H      0x132C7D
#define REG_BK132C_3F_L      0x132C7E
#define REG_BK132C_3F_H      0x132C7F
#define REG_BK132C_40_L      0x132C80
#define REG_BK132C_40_H      0x132C81
#define REG_BK132C_41_L      0x132C82
#define REG_BK132C_41_H      0x132C83
#define REG_BK132C_42_L      0x132C84
#define REG_BK132C_42_H      0x132C85
#define REG_BK132C_43_L      0x132C86
#define REG_BK132C_43_H      0x132C87
#define REG_BK132C_44_L      0x132C88
#define REG_BK132C_44_H      0x132C89
#define REG_BK132C_45_L      0x132C8A
#define REG_BK132C_45_H      0x132C8B
#define REG_BK132C_46_L      0x132C8C
#define REG_BK132C_46_H      0x132C8D
#define REG_BK132C_47_L      0x132C8E
#define REG_BK132C_47_H      0x132C8F
#define REG_BK132C_48_L      0x132C90
#define REG_BK132C_48_H      0x132C91
#define REG_BK132C_49_L      0x132C92
#define REG_BK132C_49_H      0x132C93
#define REG_BK132C_4A_L      0x132C94
#define REG_BK132C_4A_H      0x132C95
#define REG_BK132C_4B_L      0x132C96
#define REG_BK132C_4B_H      0x132C97
#define REG_BK132C_4C_L      0x132C98
#define REG_BK132C_4C_H      0x132C99
#define REG_BK132C_4D_L      0x132C9A
#define REG_BK132C_4D_H      0x132C9B
#define REG_BK132C_4E_L      0x132C9C
#define REG_BK132C_4E_H      0x132C9D
#define REG_BK132C_4F_L      0x132C9E
#define REG_BK132C_4F_H      0x132C9F
#define REG_BK132C_50_L      0x132CA0
#define REG_BK132C_50_H      0x132CA1
#define REG_BK132C_51_L      0x132CA2
#define REG_BK132C_51_H      0x132CA3
#define REG_BK132C_52_L      0x132CA4
#define REG_BK132C_52_H      0x132CA5
#define REG_BK132C_53_L      0x132CA6
#define REG_BK132C_53_H      0x132CA7
#define REG_BK132C_54_L      0x132CA8
#define REG_BK132C_54_H      0x132CA9
#define REG_BK132C_55_L      0x132CAA
#define REG_BK132C_55_H      0x132CAB
#define REG_BK132C_56_L      0x132CAC
#define REG_BK132C_56_H      0x132CAD
#define REG_BK132C_57_L      0x132CAE
#define REG_BK132C_57_H      0x132CAF
#define REG_BK132C_58_L      0x132CB0
#define REG_BK132C_58_H      0x132CB1
#define REG_BK132C_59_L      0x132CB2
#define REG_BK132C_59_H      0x132CB3
#define REG_BK132C_5A_L      0x132CB4
#define REG_BK132C_5A_H      0x132CB5
#define REG_BK132C_5B_L      0x132CB6
#define REG_BK132C_5B_H      0x132CB7
#define REG_BK132C_5C_L      0x132CB8
#define REG_BK132C_5C_H      0x132CB9
#define REG_BK132C_5D_L      0x132CBA
#define REG_BK132C_5D_H      0x132CBB
#define REG_BK132C_5E_L      0x132CBC
#define REG_BK132C_5E_H      0x132CBD
#define REG_BK132C_5F_L      0x132CBE
#define REG_BK132C_5F_H      0x132CBF
#define REG_BK132C_60_L      0x132CC0
#define REG_BK132C_60_H      0x132CC1
#define REG_BK132C_61_L      0x132CC2
#define REG_BK132C_61_H      0x132CC3
#define REG_BK132C_62_L      0x132CC4
#define REG_BK132C_62_H      0x132CC5
#define REG_BK132C_63_L      0x132CC6
#define REG_BK132C_63_H      0x132CC7
#define REG_BK132C_64_L      0x132CC8
#define REG_BK132C_64_H      0x132CC9
#define REG_BK132C_65_L      0x132CCA
#define REG_BK132C_65_H      0x132CCB
#define REG_BK132C_66_L      0x132CCC
#define REG_BK132C_66_H      0x132CCD
#define REG_BK132C_67_L      0x132CCE
#define REG_BK132C_67_H      0x132CCF
#define REG_BK132C_68_L      0x132CD0
#define REG_BK132C_68_H      0x132CD1
#define REG_BK132C_69_L      0x132CD2
#define REG_BK132C_69_H      0x132CD3
#define REG_BK132C_6A_L      0x132CD4
#define REG_BK132C_6A_H      0x132CD5
#define REG_BK132C_6B_L      0x132CD6
#define REG_BK132C_6B_H      0x132CD7
#define REG_BK132C_6C_L      0x132CD8
#define REG_BK132C_6C_H      0x132CD9
#define REG_BK132C_6D_L      0x132CDA
#define REG_BK132C_6D_H      0x132CDB
#define REG_BK132C_6E_L      0x132CDC
#define REG_BK132C_6E_H      0x132CDD
#define REG_BK132C_6F_L      0x132CDE
#define REG_BK132C_6F_H      0x132CDF
#define REG_BK132C_70_L      0x132CE0
#define REG_BK132C_70_H      0x132CE1
#define REG_BK132C_71_L      0x132CE2
#define REG_BK132C_71_H      0x132CE3
#define REG_BK132C_72_L      0x132CE4
#define REG_BK132C_72_H      0x132CE5
#define REG_BK132C_73_L      0x132CE6
#define REG_BK132C_73_H      0x132CE7
#define REG_BK132C_74_L      0x132CE8
#define REG_BK132C_74_H      0x132CE9
#define REG_BK132C_75_L      0x132CEA
#define REG_BK132C_75_H      0x132CEB
#define REG_BK132C_76_L      0x132CEC
#define REG_BK132C_76_H      0x132CED
#define REG_BK132C_77_L      0x132CEE
#define REG_BK132C_77_H      0x132CEF
#define REG_BK132C_78_L      0x132CF0
#define REG_BK132C_78_H      0x132CF1
#define REG_BK132C_79_L      0x132CF2
#define REG_BK132C_79_H      0x132CF3
#define REG_BK132C_7A_L      0x132CF4
#define REG_BK132C_7A_H      0x132CF5
#define REG_BK132C_7B_L      0x132CF6
#define REG_BK132C_7B_H      0x132CF7
#define REG_BK132C_7C_L      0x132CF8
#define REG_BK132C_7C_H      0x132CF9
#define REG_BK132C_7D_L      0x132CFA
#define REG_BK132C_7D_H      0x132CFB
#define REG_BK132C_7E_L      0x132CFC
#define REG_BK132C_7E_H      0x132CFD
#define REG_BK132C_7F_L      0x132CFE
#define REG_BK132C_7F_H      0x132CFF
//----------------------------------------------
#define REG_BK132D_00_L      0x132D00
#define REG_BK132D_00_H      0x132D01
#define REG_BK132D_01_L      0x132D02
#define REG_BK132D_01_H      0x132D03
#define REG_BK132D_02_L      0x132D04
#define REG_BK132D_02_H      0x132D05
#define REG_BK132D_03_L      0x132D06
#define REG_BK132D_03_H      0x132D07
#define REG_BK132D_04_L      0x132D08
#define REG_BK132D_04_H      0x132D09
#define REG_BK132D_05_L      0x132D0A
#define REG_BK132D_05_H      0x132D0B
#define REG_BK132D_06_L      0x132D0C
#define REG_BK132D_06_H      0x132D0D
#define REG_BK132D_07_L      0x132D0E
#define REG_BK132D_07_H      0x132D0F
#define REG_BK132D_08_L      0x132D10
#define REG_BK132D_08_H      0x132D11
#define REG_BK132D_09_L      0x132D12
#define REG_BK132D_09_H      0x132D13
#define REG_BK132D_0A_L      0x132D14
#define REG_BK132D_0A_H      0x132D15
#define REG_BK132D_0B_L      0x132D16
#define REG_BK132D_0B_H      0x132D17
#define REG_BK132D_0C_L      0x132D18
#define REG_BK132D_0C_H      0x132D19
#define REG_BK132D_0D_L      0x132D1A
#define REG_BK132D_0D_H      0x132D1B
#define REG_BK132D_0E_L      0x132D1C
#define REG_BK132D_0E_H      0x132D1D
#define REG_BK132D_0F_L      0x132D1E
#define REG_BK132D_0F_H      0x132D1F
#define REG_BK132D_10_L      0x132D20
#define REG_BK132D_10_H      0x132D21
#define REG_BK132D_11_L      0x132D22
#define REG_BK132D_11_H      0x132D23
#define REG_BK132D_12_L      0x132D24
#define REG_BK132D_12_H      0x132D25
#define REG_BK132D_13_L      0x132D26
#define REG_BK132D_13_H      0x132D27
#define REG_BK132D_14_L      0x132D28
#define REG_BK132D_14_H      0x132D29
#define REG_BK132D_15_L      0x132D2A
#define REG_BK132D_15_H      0x132D2B
#define REG_BK132D_16_L      0x132D2C
#define REG_BK132D_16_H      0x132D2D
#define REG_BK132D_17_L      0x132D2E
#define REG_BK132D_17_H      0x132D2F
#define REG_BK132D_18_L      0x132D30
#define REG_BK132D_18_H      0x132D31
#define REG_BK132D_19_L      0x132D32
#define REG_BK132D_19_H      0x132D33
#define REG_BK132D_1A_L      0x132D34
#define REG_BK132D_1A_H      0x132D35
#define REG_BK132D_1B_L      0x132D36
#define REG_BK132D_1B_H      0x132D37
#define REG_BK132D_1C_L      0x132D38
#define REG_BK132D_1C_H      0x132D39
#define REG_BK132D_1D_L      0x132D3A
#define REG_BK132D_1D_H      0x132D3B
#define REG_BK132D_1E_L      0x132D3C
#define REG_BK132D_1E_H      0x132D3D
#define REG_BK132D_1F_L      0x132D3E
#define REG_BK132D_1F_H      0x132D3F
#define REG_BK132D_20_L      0x132D40
#define REG_BK132D_20_H      0x132D41
#define REG_BK132D_21_L      0x132D42
#define REG_BK132D_21_H      0x132D43
#define REG_BK132D_22_L      0x132D44
#define REG_BK132D_22_H      0x132D45
#define REG_BK132D_23_L      0x132D46
#define REG_BK132D_23_H      0x132D47
#define REG_BK132D_24_L      0x132D48
#define REG_BK132D_24_H      0x132D49
#define REG_BK132D_25_L      0x132D4A
#define REG_BK132D_25_H      0x132D4B
#define REG_BK132D_26_L      0x132D4C
#define REG_BK132D_26_H      0x132D4D
#define REG_BK132D_27_L      0x132D4E
#define REG_BK132D_27_H      0x132D4F
#define REG_BK132D_28_L      0x132D50
#define REG_BK132D_28_H      0x132D51
#define REG_BK132D_29_L      0x132D52
#define REG_BK132D_29_H      0x132D53
#define REG_BK132D_2A_L      0x132D54
#define REG_BK132D_2A_H      0x132D55
#define REG_BK132D_2B_L      0x132D56
#define REG_BK132D_2B_H      0x132D57
#define REG_BK132D_2C_L      0x132D58
#define REG_BK132D_2C_H      0x132D59
#define REG_BK132D_2D_L      0x132D5A
#define REG_BK132D_2D_H      0x132D5B
#define REG_BK132D_2E_L      0x132D5C
#define REG_BK132D_2E_H      0x132D5D
#define REG_BK132D_2F_L      0x132D5E
#define REG_BK132D_2F_H      0x132D5F
#define REG_BK132D_30_L      0x132D60
#define REG_BK132D_30_H      0x132D61
#define REG_BK132D_31_L      0x132D62
#define REG_BK132D_31_H      0x132D63
#define REG_BK132D_32_L      0x132D64
#define REG_BK132D_32_H      0x132D65
#define REG_BK132D_33_L      0x132D66
#define REG_BK132D_33_H      0x132D67
#define REG_BK132D_34_L      0x132D68
#define REG_BK132D_34_H      0x132D69
#define REG_BK132D_35_L      0x132D6A
#define REG_BK132D_35_H      0x132D6B
#define REG_BK132D_36_L      0x132D6C
#define REG_BK132D_36_H      0x132D6D
#define REG_BK132D_37_L      0x132D6E
#define REG_BK132D_37_H      0x132D6F
#define REG_BK132D_38_L      0x132D70
#define REG_BK132D_38_H      0x132D71
#define REG_BK132D_39_L      0x132D72
#define REG_BK132D_39_H      0x132D73
#define REG_BK132D_3A_L      0x132D74
#define REG_BK132D_3A_H      0x132D75
#define REG_BK132D_3B_L      0x132D76
#define REG_BK132D_3B_H      0x132D77
#define REG_BK132D_3C_L      0x132D78
#define REG_BK132D_3C_H      0x132D79
#define REG_BK132D_3D_L      0x132D7A
#define REG_BK132D_3D_H      0x132D7B
#define REG_BK132D_3E_L      0x132D7C
#define REG_BK132D_3E_H      0x132D7D
#define REG_BK132D_3F_L      0x132D7E
#define REG_BK132D_3F_H      0x132D7F
#define REG_BK132D_40_L      0x132D80
#define REG_BK132D_40_H      0x132D81
#define REG_BK132D_41_L      0x132D82
#define REG_BK132D_41_H      0x132D83
#define REG_BK132D_42_L      0x132D84
#define REG_BK132D_42_H      0x132D85
#define REG_BK132D_43_L      0x132D86
#define REG_BK132D_43_H      0x132D87
#define REG_BK132D_44_L      0x132D88
#define REG_BK132D_44_H      0x132D89
#define REG_BK132D_45_L      0x132D8A
#define REG_BK132D_45_H      0x132D8B
#define REG_BK132D_46_L      0x132D8C
#define REG_BK132D_46_H      0x132D8D
#define REG_BK132D_47_L      0x132D8E
#define REG_BK132D_47_H      0x132D8F
#define REG_BK132D_48_L      0x132D90
#define REG_BK132D_48_H      0x132D91
#define REG_BK132D_49_L      0x132D92
#define REG_BK132D_49_H      0x132D93
#define REG_BK132D_4A_L      0x132D94
#define REG_BK132D_4A_H      0x132D95
#define REG_BK132D_4B_L      0x132D96
#define REG_BK132D_4B_H      0x132D97
#define REG_BK132D_4C_L      0x132D98
#define REG_BK132D_4C_H      0x132D99
#define REG_BK132D_4D_L      0x132D9A
#define REG_BK132D_4D_H      0x132D9B
#define REG_BK132D_4E_L      0x132D9C
#define REG_BK132D_4E_H      0x132D9D
#define REG_BK132D_4F_L      0x132D9E
#define REG_BK132D_4F_H      0x132D9F
#define REG_BK132D_50_L      0x132DA0
#define REG_BK132D_50_H      0x132DA1
#define REG_BK132D_51_L      0x132DA2
#define REG_BK132D_51_H      0x132DA3
#define REG_BK132D_52_L      0x132DA4
#define REG_BK132D_52_H      0x132DA5
#define REG_BK132D_53_L      0x132DA6
#define REG_BK132D_53_H      0x132DA7
#define REG_BK132D_54_L      0x132DA8
#define REG_BK132D_54_H      0x132DA9
#define REG_BK132D_55_L      0x132DAA
#define REG_BK132D_55_H      0x132DAB
#define REG_BK132D_56_L      0x132DAC
#define REG_BK132D_56_H      0x132DAD
#define REG_BK132D_57_L      0x132DAE
#define REG_BK132D_57_H      0x132DAF
#define REG_BK132D_58_L      0x132DB0
#define REG_BK132D_58_H      0x132DB1
#define REG_BK132D_59_L      0x132DB2
#define REG_BK132D_59_H      0x132DB3
#define REG_BK132D_5A_L      0x132DB4
#define REG_BK132D_5A_H      0x132DB5
#define REG_BK132D_5B_L      0x132DB6
#define REG_BK132D_5B_H      0x132DB7
#define REG_BK132D_5C_L      0x132DB8
#define REG_BK132D_5C_H      0x132DB9
#define REG_BK132D_5D_L      0x132DBA
#define REG_BK132D_5D_H      0x132DBB
#define REG_BK132D_5E_L      0x132DBC
#define REG_BK132D_5E_H      0x132DBD
#define REG_BK132D_5F_L      0x132DBE
#define REG_BK132D_5F_H      0x132DBF
#define REG_BK132D_60_L      0x132DC0
#define REG_BK132D_60_H      0x132DC1
#define REG_BK132D_61_L      0x132DC2
#define REG_BK132D_61_H      0x132DC3
#define REG_BK132D_62_L      0x132DC4
#define REG_BK132D_62_H      0x132DC5
#define REG_BK132D_63_L      0x132DC6
#define REG_BK132D_63_H      0x132DC7
#define REG_BK132D_64_L      0x132DC8
#define REG_BK132D_64_H      0x132DC9
#define REG_BK132D_65_L      0x132DCA
#define REG_BK132D_65_H      0x132DCB
#define REG_BK132D_66_L      0x132DCC
#define REG_BK132D_66_H      0x132DCD
#define REG_BK132D_67_L      0x132DCE
#define REG_BK132D_67_H      0x132DCF
#define REG_BK132D_68_L      0x132DD0
#define REG_BK132D_68_H      0x132DD1
#define REG_BK132D_69_L      0x132DD2
#define REG_BK132D_69_H      0x132DD3
#define REG_BK132D_6A_L      0x132DD4
#define REG_BK132D_6A_H      0x132DD5
#define REG_BK132D_6B_L      0x132DD6
#define REG_BK132D_6B_H      0x132DD7
#define REG_BK132D_6C_L      0x132DD8
#define REG_BK132D_6C_H      0x132DD9
#define REG_BK132D_6D_L      0x132DDA
#define REG_BK132D_6D_H      0x132DDB
#define REG_BK132D_6E_L      0x132DDC
#define REG_BK132D_6E_H      0x132DDD
#define REG_BK132D_6F_L      0x132DDE
#define REG_BK132D_6F_H      0x132DDF
#define REG_BK132D_70_L      0x132DE0
#define REG_BK132D_70_H      0x132DE1
#define REG_BK132D_71_L      0x132DE2
#define REG_BK132D_71_H      0x132DE3
#define REG_BK132D_72_L      0x132DE4
#define REG_BK132D_72_H      0x132DE5
#define REG_BK132D_73_L      0x132DE6
#define REG_BK132D_73_H      0x132DE7
#define REG_BK132D_74_L      0x132DE8
#define REG_BK132D_74_H      0x132DE9
#define REG_BK132D_75_L      0x132DEA
#define REG_BK132D_75_H      0x132DEB
#define REG_BK132D_76_L      0x132DEC
#define REG_BK132D_76_H      0x132DED
#define REG_BK132D_77_L      0x132DEE
#define REG_BK132D_77_H      0x132DEF
#define REG_BK132D_78_L      0x132DF0
#define REG_BK132D_78_H      0x132DF1
#define REG_BK132D_79_L      0x132DF2
#define REG_BK132D_79_H      0x132DF3
#define REG_BK132D_7A_L      0x132DF4
#define REG_BK132D_7A_H      0x132DF5
#define REG_BK132D_7B_L      0x132DF6
#define REG_BK132D_7B_H      0x132DF7
#define REG_BK132D_7C_L      0x132DF8
#define REG_BK132D_7C_H      0x132DF9
#define REG_BK132D_7D_L      0x132DFA
#define REG_BK132D_7D_H      0x132DFB
#define REG_BK132D_7E_L      0x132DFC
#define REG_BK132D_7E_H      0x132DFD
#define REG_BK132D_7F_L      0x132DFE
#define REG_BK132D_7F_H      0x132DFF
//----------------------------------------------
#define REG_BK132E_00_L      0x132E00
#define REG_BK132E_00_H      0x132E01
#define REG_BK132E_01_L      0x132E02
#define REG_BK132E_01_H      0x132E03
#define REG_BK132E_02_L      0x132E04
#define REG_BK132E_02_H      0x132E05
#define REG_BK132E_03_L      0x132E06
#define REG_BK132E_03_H      0x132E07
#define REG_BK132E_04_L      0x132E08
#define REG_BK132E_04_H      0x132E09
#define REG_BK132E_05_L      0x132E0A
#define REG_BK132E_05_H      0x132E0B
#define REG_BK132E_06_L      0x132E0C
#define REG_BK132E_06_H      0x132E0D
#define REG_BK132E_07_L      0x132E0E
#define REG_BK132E_07_H      0x132E0F
#define REG_BK132E_08_L      0x132E10
#define REG_BK132E_08_H      0x132E11
#define REG_BK132E_09_L      0x132E12
#define REG_BK132E_09_H      0x132E13
#define REG_BK132E_0A_L      0x132E14
#define REG_BK132E_0A_H      0x132E15
#define REG_BK132E_0B_L      0x132E16
#define REG_BK132E_0B_H      0x132E17
#define REG_BK132E_0C_L      0x132E18
#define REG_BK132E_0C_H      0x132E19
#define REG_BK132E_0D_L      0x132E1A
#define REG_BK132E_0D_H      0x132E1B
#define REG_BK132E_0E_L      0x132E1C
#define REG_BK132E_0E_H      0x132E1D
#define REG_BK132E_0F_L      0x132E1E
#define REG_BK132E_0F_H      0x132E1F
#define REG_BK132E_10_L      0x132E20
#define REG_BK132E_10_H      0x132E21
#define REG_BK132E_11_L      0x132E22
#define REG_BK132E_11_H      0x132E23
#define REG_BK132E_12_L      0x132E24
#define REG_BK132E_12_H      0x132E25
#define REG_BK132E_13_L      0x132E26
#define REG_BK132E_13_H      0x132E27
#define REG_BK132E_14_L      0x132E28
#define REG_BK132E_14_H      0x132E29
#define REG_BK132E_15_L      0x132E2A
#define REG_BK132E_15_H      0x132E2B
#define REG_BK132E_16_L      0x132E2C
#define REG_BK132E_16_H      0x132E2D
#define REG_BK132E_17_L      0x132E2E
#define REG_BK132E_17_H      0x132E2F
#define REG_BK132E_18_L      0x132E30
#define REG_BK132E_18_H      0x132E31
#define REG_BK132E_19_L      0x132E32
#define REG_BK132E_19_H      0x132E33
#define REG_BK132E_1A_L      0x132E34
#define REG_BK132E_1A_H      0x132E35
#define REG_BK132E_1B_L      0x132E36
#define REG_BK132E_1B_H      0x132E37
#define REG_BK132E_1C_L      0x132E38
#define REG_BK132E_1C_H      0x132E39
#define REG_BK132E_1D_L      0x132E3A
#define REG_BK132E_1D_H      0x132E3B
#define REG_BK132E_1E_L      0x132E3C
#define REG_BK132E_1E_H      0x132E3D
#define REG_BK132E_1F_L      0x132E3E
#define REG_BK132E_1F_H      0x132E3F
#define REG_BK132E_20_L      0x132E40
#define REG_BK132E_20_H      0x132E41
#define REG_BK132E_21_L      0x132E42
#define REG_BK132E_21_H      0x132E43
#define REG_BK132E_22_L      0x132E44
#define REG_BK132E_22_H      0x132E45
#define REG_BK132E_23_L      0x132E46
#define REG_BK132E_23_H      0x132E47
#define REG_BK132E_24_L      0x132E48
#define REG_BK132E_24_H      0x132E49
#define REG_BK132E_25_L      0x132E4A
#define REG_BK132E_25_H      0x132E4B
#define REG_BK132E_26_L      0x132E4C
#define REG_BK132E_26_H      0x132E4D
#define REG_BK132E_27_L      0x132E4E
#define REG_BK132E_27_H      0x132E4F
#define REG_BK132E_28_L      0x132E50
#define REG_BK132E_28_H      0x132E51
#define REG_BK132E_29_L      0x132E52
#define REG_BK132E_29_H      0x132E53
#define REG_BK132E_2A_L      0x132E54
#define REG_BK132E_2A_H      0x132E55
#define REG_BK132E_2B_L      0x132E56
#define REG_BK132E_2B_H      0x132E57
#define REG_BK132E_2C_L      0x132E58
#define REG_BK132E_2C_H      0x132E59
#define REG_BK132E_2D_L      0x132E5A
#define REG_BK132E_2D_H      0x132E5B
#define REG_BK132E_2E_L      0x132E5C
#define REG_BK132E_2E_H      0x132E5D
#define REG_BK132E_2F_L      0x132E5E
#define REG_BK132E_2F_H      0x132E5F
#define REG_BK132E_30_L      0x132E60
#define REG_BK132E_30_H      0x132E61
#define REG_BK132E_31_L      0x132E62
#define REG_BK132E_31_H      0x132E63
#define REG_BK132E_32_L      0x132E64
#define REG_BK132E_32_H      0x132E65
#define REG_BK132E_33_L      0x132E66
#define REG_BK132E_33_H      0x132E67
#define REG_BK132E_34_L      0x132E68
#define REG_BK132E_34_H      0x132E69
#define REG_BK132E_35_L      0x132E6A
#define REG_BK132E_35_H      0x132E6B
#define REG_BK132E_36_L      0x132E6C
#define REG_BK132E_36_H      0x132E6D
#define REG_BK132E_37_L      0x132E6E
#define REG_BK132E_37_H      0x132E6F
#define REG_BK132E_38_L      0x132E70
#define REG_BK132E_38_H      0x132E71
#define REG_BK132E_39_L      0x132E72
#define REG_BK132E_39_H      0x132E73
#define REG_BK132E_3A_L      0x132E74
#define REG_BK132E_3A_H      0x132E75
#define REG_BK132E_3B_L      0x132E76
#define REG_BK132E_3B_H      0x132E77
#define REG_BK132E_3C_L      0x132E78
#define REG_BK132E_3C_H      0x132E79
#define REG_BK132E_3D_L      0x132E7A
#define REG_BK132E_3D_H      0x132E7B
#define REG_BK132E_3E_L      0x132E7C
#define REG_BK132E_3E_H      0x132E7D
#define REG_BK132E_3F_L      0x132E7E
#define REG_BK132E_3F_H      0x132E7F
#define REG_BK132E_40_L      0x132E80
#define REG_BK132E_40_H      0x132E81
#define REG_BK132E_41_L      0x132E82
#define REG_BK132E_41_H      0x132E83
#define REG_BK132E_42_L      0x132E84
#define REG_BK132E_42_H      0x132E85
#define REG_BK132E_43_L      0x132E86
#define REG_BK132E_43_H      0x132E87
#define REG_BK132E_44_L      0x132E88
#define REG_BK132E_44_H      0x132E89
#define REG_BK132E_45_L      0x132E8A
#define REG_BK132E_45_H      0x132E8B
#define REG_BK132E_46_L      0x132E8C
#define REG_BK132E_46_H      0x132E8D
#define REG_BK132E_47_L      0x132E8E
#define REG_BK132E_47_H      0x132E8F
#define REG_BK132E_48_L      0x132E90
#define REG_BK132E_48_H      0x132E91
#define REG_BK132E_49_L      0x132E92
#define REG_BK132E_49_H      0x132E93
#define REG_BK132E_4A_L      0x132E94
#define REG_BK132E_4A_H      0x132E95
#define REG_BK132E_4B_L      0x132E96
#define REG_BK132E_4B_H      0x132E97
#define REG_BK132E_4C_L      0x132E98
#define REG_BK132E_4C_H      0x132E99
#define REG_BK132E_4D_L      0x132E9A
#define REG_BK132E_4D_H      0x132E9B
#define REG_BK132E_4E_L      0x132E9C
#define REG_BK132E_4E_H      0x132E9D
#define REG_BK132E_4F_L      0x132E9E
#define REG_BK132E_4F_H      0x132E9F
#define REG_BK132E_50_L      0x132EA0
#define REG_BK132E_50_H      0x132EA1
#define REG_BK132E_51_L      0x132EA2
#define REG_BK132E_51_H      0x132EA3
#define REG_BK132E_52_L      0x132EA4
#define REG_BK132E_52_H      0x132EA5
#define REG_BK132E_53_L      0x132EA6
#define REG_BK132E_53_H      0x132EA7
#define REG_BK132E_54_L      0x132EA8
#define REG_BK132E_54_H      0x132EA9
#define REG_BK132E_55_L      0x132EAA
#define REG_BK132E_55_H      0x132EAB
#define REG_BK132E_56_L      0x132EAC
#define REG_BK132E_56_H      0x132EAD
#define REG_BK132E_57_L      0x132EAE
#define REG_BK132E_57_H      0x132EAF
#define REG_BK132E_58_L      0x132EB0
#define REG_BK132E_58_H      0x132EB1
#define REG_BK132E_59_L      0x132EB2
#define REG_BK132E_59_H      0x132EB3
#define REG_BK132E_5A_L      0x132EB4
#define REG_BK132E_5A_H      0x132EB5
#define REG_BK132E_5B_L      0x132EB6
#define REG_BK132E_5B_H      0x132EB7
#define REG_BK132E_5C_L      0x132EB8
#define REG_BK132E_5C_H      0x132EB9
#define REG_BK132E_5D_L      0x132EBA
#define REG_BK132E_5D_H      0x132EBB
#define REG_BK132E_5E_L      0x132EBC
#define REG_BK132E_5E_H      0x132EBD
#define REG_BK132E_5F_L      0x132EBE
#define REG_BK132E_5F_H      0x132EBF
#define REG_BK132E_60_L      0x132EC0
#define REG_BK132E_60_H      0x132EC1
#define REG_BK132E_61_L      0x132EC2
#define REG_BK132E_61_H      0x132EC3
#define REG_BK132E_62_L      0x132EC4
#define REG_BK132E_62_H      0x132EC5
#define REG_BK132E_63_L      0x132EC6
#define REG_BK132E_63_H      0x132EC7
#define REG_BK132E_64_L      0x132EC8
#define REG_BK132E_64_H      0x132EC9
#define REG_BK132E_65_L      0x132ECA
#define REG_BK132E_65_H      0x132ECB
#define REG_BK132E_66_L      0x132ECC
#define REG_BK132E_66_H      0x132ECD
#define REG_BK132E_67_L      0x132ECE
#define REG_BK132E_67_H      0x132ECF
#define REG_BK132E_68_L      0x132ED0
#define REG_BK132E_68_H      0x132ED1
#define REG_BK132E_69_L      0x132ED2
#define REG_BK132E_69_H      0x132ED3
#define REG_BK132E_6A_L      0x132ED4
#define REG_BK132E_6A_H      0x132ED5
#define REG_BK132E_6B_L      0x132ED6
#define REG_BK132E_6B_H      0x132ED7
#define REG_BK132E_6C_L      0x132ED8
#define REG_BK132E_6C_H      0x132ED9
#define REG_BK132E_6D_L      0x132EDA
#define REG_BK132E_6D_H      0x132EDB
#define REG_BK132E_6E_L      0x132EDC
#define REG_BK132E_6E_H      0x132EDD
#define REG_BK132E_6F_L      0x132EDE
#define REG_BK132E_6F_H      0x132EDF
#define REG_BK132E_70_L      0x132EE0
#define REG_BK132E_70_H      0x132EE1
#define REG_BK132E_71_L      0x132EE2
#define REG_BK132E_71_H      0x132EE3
#define REG_BK132E_72_L      0x132EE4
#define REG_BK132E_72_H      0x132EE5
#define REG_BK132E_73_L      0x132EE6
#define REG_BK132E_73_H      0x132EE7
#define REG_BK132E_74_L      0x132EE8
#define REG_BK132E_74_H      0x132EE9
#define REG_BK132E_75_L      0x132EEA
#define REG_BK132E_75_H      0x132EEB
#define REG_BK132E_76_L      0x132EEC
#define REG_BK132E_76_H      0x132EED
#define REG_BK132E_77_L      0x132EEE
#define REG_BK132E_77_H      0x132EEF
#define REG_BK132E_78_L      0x132EF0
#define REG_BK132E_78_H      0x132EF1
#define REG_BK132E_79_L      0x132EF2
#define REG_BK132E_79_H      0x132EF3
#define REG_BK132E_7A_L      0x132EF4
#define REG_BK132E_7A_H      0x132EF5
#define REG_BK132E_7B_L      0x132EF6
#define REG_BK132E_7B_H      0x132EF7
#define REG_BK132E_7C_L      0x132EF8
#define REG_BK132E_7C_H      0x132EF9
#define REG_BK132E_7D_L      0x132EFA
#define REG_BK132E_7D_H      0x132EFB
#define REG_BK132E_7E_L      0x132EFC
#define REG_BK132E_7E_H      0x132EFD
#define REG_BK132E_7F_L      0x132EFE
#define REG_BK132E_7F_H      0x132EFF
//----------------------------------------------
#define REG_BK1330_00_L      0x133000
#define REG_BK1330_00_H      0x133001
#define REG_BK1330_01_L      0x133002
#define REG_BK1330_01_H      0x133003
#define REG_BK1330_02_L      0x133004
#define REG_BK1330_02_H      0x133005
#define REG_BK1330_03_L      0x133006
#define REG_BK1330_03_H      0x133007
#define REG_BK1330_04_L      0x133008
#define REG_BK1330_04_H      0x133009
#define REG_BK1330_05_L      0x13300A
#define REG_BK1330_05_H      0x13300B
#define REG_BK1330_06_L      0x13300C
#define REG_BK1330_06_H      0x13300D
#define REG_BK1330_07_L      0x13300E
#define REG_BK1330_07_H      0x13300F
#define REG_BK1330_08_L      0x133010
#define REG_BK1330_08_H      0x133011
#define REG_BK1330_09_L      0x133012
#define REG_BK1330_09_H      0x133013
#define REG_BK1330_0A_L      0x133014
#define REG_BK1330_0A_H      0x133015
#define REG_BK1330_0B_L      0x133016
#define REG_BK1330_0B_H      0x133017
#define REG_BK1330_0C_L      0x133018
#define REG_BK1330_0C_H      0x133019
#define REG_BK1330_0D_L      0x13301A
#define REG_BK1330_0D_H      0x13301B
#define REG_BK1330_0E_L      0x13301C
#define REG_BK1330_0E_H      0x13301D
#define REG_BK1330_0F_L      0x13301E
#define REG_BK1330_0F_H      0x13301F
#define REG_BK1330_10_L      0x133020
#define REG_BK1330_10_H      0x133021
#define REG_BK1330_11_L      0x133022
#define REG_BK1330_11_H      0x133023
#define REG_BK1330_12_L      0x133024
#define REG_BK1330_12_H      0x133025
#define REG_BK1330_13_L      0x133026
#define REG_BK1330_13_H      0x133027
#define REG_BK1330_14_L      0x133028
#define REG_BK1330_14_H      0x133029
#define REG_BK1330_15_L      0x13302A
#define REG_BK1330_15_H      0x13302B
#define REG_BK1330_16_L      0x13302C
#define REG_BK1330_16_H      0x13302D
#define REG_BK1330_17_L      0x13302E
#define REG_BK1330_17_H      0x13302F
#define REG_BK1330_18_L      0x133030
#define REG_BK1330_18_H      0x133031
#define REG_BK1330_19_L      0x133032
#define REG_BK1330_19_H      0x133033
#define REG_BK1330_1A_L      0x133034
#define REG_BK1330_1A_H      0x133035
#define REG_BK1330_1B_L      0x133036
#define REG_BK1330_1B_H      0x133037
#define REG_BK1330_1C_L      0x133038
#define REG_BK1330_1C_H      0x133039
#define REG_BK1330_1D_L      0x13303A
#define REG_BK1330_1D_H      0x13303B
#define REG_BK1330_1E_L      0x13303C
#define REG_BK1330_1E_H      0x13303D
#define REG_BK1330_1F_L      0x13303E
#define REG_BK1330_1F_H      0x13303F
#define REG_BK1330_20_L      0x133040
#define REG_BK1330_20_H      0x133041
#define REG_BK1330_21_L      0x133042
#define REG_BK1330_21_H      0x133043
#define REG_BK1330_22_L      0x133044
#define REG_BK1330_22_H      0x133045
#define REG_BK1330_23_L      0x133046
#define REG_BK1330_23_H      0x133047
#define REG_BK1330_24_L      0x133048
#define REG_BK1330_24_H      0x133049
#define REG_BK1330_25_L      0x13304A
#define REG_BK1330_25_H      0x13304B
#define REG_BK1330_26_L      0x13304C
#define REG_BK1330_26_H      0x13304D
#define REG_BK1330_27_L      0x13304E
#define REG_BK1330_27_H      0x13304F
#define REG_BK1330_28_L      0x133050
#define REG_BK1330_28_H      0x133051
#define REG_BK1330_29_L      0x133052
#define REG_BK1330_29_H      0x133053
#define REG_BK1330_2A_L      0x133054
#define REG_BK1330_2A_H      0x133055
#define REG_BK1330_2B_L      0x133056
#define REG_BK1330_2B_H      0x133057
#define REG_BK1330_2C_L      0x133058
#define REG_BK1330_2C_H      0x133059
#define REG_BK1330_2D_L      0x13305A
#define REG_BK1330_2D_H      0x13305B
#define REG_BK1330_2E_L      0x13305C
#define REG_BK1330_2E_H      0x13305D
#define REG_BK1330_2F_L      0x13305E
#define REG_BK1330_2F_H      0x13305F
#define REG_BK1330_30_L      0x133060
#define REG_BK1330_30_H      0x133061
#define REG_BK1330_31_L      0x133062
#define REG_BK1330_31_H      0x133063
#define REG_BK1330_32_L      0x133064
#define REG_BK1330_32_H      0x133065
#define REG_BK1330_33_L      0x133066
#define REG_BK1330_33_H      0x133067
#define REG_BK1330_34_L      0x133068
#define REG_BK1330_34_H      0x133069
#define REG_BK1330_35_L      0x13306A
#define REG_BK1330_35_H      0x13306B
#define REG_BK1330_36_L      0x13306C
#define REG_BK1330_36_H      0x13306D
#define REG_BK1330_37_L      0x13306E
#define REG_BK1330_37_H      0x13306F
#define REG_BK1330_38_L      0x133070
#define REG_BK1330_38_H      0x133071
#define REG_BK1330_39_L      0x133072
#define REG_BK1330_39_H      0x133073
#define REG_BK1330_3A_L      0x133074
#define REG_BK1330_3A_H      0x133075
#define REG_BK1330_3B_L      0x133076
#define REG_BK1330_3B_H      0x133077
#define REG_BK1330_3C_L      0x133078
#define REG_BK1330_3C_H      0x133079
#define REG_BK1330_3D_L      0x13307A
#define REG_BK1330_3D_H      0x13307B
#define REG_BK1330_3E_L      0x13307C
#define REG_BK1330_3E_H      0x13307D
#define REG_BK1330_3F_L      0x13307E
#define REG_BK1330_3F_H      0x13307F
#define REG_BK1330_40_L      0x133080
#define REG_BK1330_40_H      0x133081
#define REG_BK1330_41_L      0x133082
#define REG_BK1330_41_H      0x133083
#define REG_BK1330_42_L      0x133084
#define REG_BK1330_42_H      0x133085
#define REG_BK1330_43_L      0x133086
#define REG_BK1330_43_H      0x133087
#define REG_BK1330_44_L      0x133088
#define REG_BK1330_44_H      0x133089
#define REG_BK1330_45_L      0x13308A
#define REG_BK1330_45_H      0x13308B
#define REG_BK1330_46_L      0x13308C
#define REG_BK1330_46_H      0x13308D
#define REG_BK1330_47_L      0x13308E
#define REG_BK1330_47_H      0x13308F
#define REG_BK1330_48_L      0x133090
#define REG_BK1330_48_H      0x133091
#define REG_BK1330_49_L      0x133092
#define REG_BK1330_49_H      0x133093
#define REG_BK1330_4A_L      0x133094
#define REG_BK1330_4A_H      0x133095
#define REG_BK1330_4B_L      0x133096
#define REG_BK1330_4B_H      0x133097
#define REG_BK1330_4C_L      0x133098
#define REG_BK1330_4C_H      0x133099
#define REG_BK1330_4D_L      0x13309A
#define REG_BK1330_4D_H      0x13309B
#define REG_BK1330_4E_L      0x13309C
#define REG_BK1330_4E_H      0x13309D
#define REG_BK1330_4F_L      0x13309E
#define REG_BK1330_4F_H      0x13309F
#define REG_BK1330_50_L      0x1330A0
#define REG_BK1330_50_H      0x1330A1
#define REG_BK1330_51_L      0x1330A2
#define REG_BK1330_51_H      0x1330A3
#define REG_BK1330_52_L      0x1330A4
#define REG_BK1330_52_H      0x1330A5
#define REG_BK1330_53_L      0x1330A6
#define REG_BK1330_53_H      0x1330A7
#define REG_BK1330_54_L      0x1330A8
#define REG_BK1330_54_H      0x1330A9
#define REG_BK1330_55_L      0x1330AA
#define REG_BK1330_55_H      0x1330AB
#define REG_BK1330_56_L      0x1330AC
#define REG_BK1330_56_H      0x1330AD
#define REG_BK1330_57_L      0x1330AE
#define REG_BK1330_57_H      0x1330AF
#define REG_BK1330_58_L      0x1330B0
#define REG_BK1330_58_H      0x1330B1
#define REG_BK1330_59_L      0x1330B2
#define REG_BK1330_59_H      0x1330B3
#define REG_BK1330_5A_L      0x1330B4
#define REG_BK1330_5A_H      0x1330B5
#define REG_BK1330_5B_L      0x1330B6
#define REG_BK1330_5B_H      0x1330B7
#define REG_BK1330_5C_L      0x1330B8
#define REG_BK1330_5C_H      0x1330B9
#define REG_BK1330_5D_L      0x1330BA
#define REG_BK1330_5D_H      0x1330BB
#define REG_BK1330_5E_L      0x1330BC
#define REG_BK1330_5E_H      0x1330BD
#define REG_BK1330_5F_L      0x1330BE
#define REG_BK1330_5F_H      0x1330BF
#define REG_BK1330_60_L      0x1330C0
#define REG_BK1330_60_H      0x1330C1
#define REG_BK1330_61_L      0x1330C2
#define REG_BK1330_61_H      0x1330C3
#define REG_BK1330_62_L      0x1330C4
#define REG_BK1330_62_H      0x1330C5
#define REG_BK1330_63_L      0x1330C6
#define REG_BK1330_63_H      0x1330C7
#define REG_BK1330_64_L      0x1330C8
#define REG_BK1330_64_H      0x1330C9
#define REG_BK1330_65_L      0x1330CA
#define REG_BK1330_65_H      0x1330CB
#define REG_BK1330_66_L      0x1330CC
#define REG_BK1330_66_H      0x1330CD
#define REG_BK1330_67_L      0x1330CE
#define REG_BK1330_67_H      0x1330CF
#define REG_BK1330_68_L      0x1330D0
#define REG_BK1330_68_H      0x1330D1
#define REG_BK1330_69_L      0x1330D2
#define REG_BK1330_69_H      0x1330D3
#define REG_BK1330_6A_L      0x1330D4
#define REG_BK1330_6A_H      0x1330D5
#define REG_BK1330_6B_L      0x1330D6
#define REG_BK1330_6B_H      0x1330D7
#define REG_BK1330_6C_L      0x1330D8
#define REG_BK1330_6C_H      0x1330D9
#define REG_BK1330_6D_L      0x1330DA
#define REG_BK1330_6D_H      0x1330DB
#define REG_BK1330_6E_L      0x1330DC
#define REG_BK1330_6E_H      0x1330DD
#define REG_BK1330_6F_L      0x1330DE
#define REG_BK1330_6F_H      0x1330DF
#define REG_BK1330_70_L      0x1330E0
#define REG_BK1330_70_H      0x1330E1
#define REG_BK1330_71_L      0x1330E2
#define REG_BK1330_71_H      0x1330E3
#define REG_BK1330_72_L      0x1330E4
#define REG_BK1330_72_H      0x1330E5
#define REG_BK1330_73_L      0x1330E6
#define REG_BK1330_73_H      0x1330E7
#define REG_BK1330_74_L      0x1330E8
#define REG_BK1330_74_H      0x1330E9
#define REG_BK1330_75_L      0x1330EA
#define REG_BK1330_75_H      0x1330EB
#define REG_BK1330_76_L      0x1330EC
#define REG_BK1330_76_H      0x1330ED
#define REG_BK1330_77_L      0x1330EE
#define REG_BK1330_77_H      0x1330EF
#define REG_BK1330_78_L      0x1330F0
#define REG_BK1330_78_H      0x1330F1
#define REG_BK1330_79_L      0x1330F2
#define REG_BK1330_79_H      0x1330F3
#define REG_BK1330_7A_L      0x1330F4
#define REG_BK1330_7A_H      0x1330F5
#define REG_BK1330_7B_L      0x1330F6
#define REG_BK1330_7B_H      0x1330F7
#define REG_BK1330_7C_L      0x1330F8
#define REG_BK1330_7C_H      0x1330F9
#define REG_BK1330_7D_L      0x1330FA
#define REG_BK1330_7D_H      0x1330FB
#define REG_BK1330_7E_L      0x1330FC
#define REG_BK1330_7E_H      0x1330FD
#define REG_BK1330_7F_L      0x1330FE
#define REG_BK1330_7F_H      0x1330FF
//----------------------------------------------
#define REG_BK1331_00_L      0x133100
#define REG_BK1331_00_H      0x133101
#define REG_BK1331_01_L      0x133102
#define REG_BK1331_01_H      0x133103
#define REG_BK1331_02_L      0x133104
#define REG_BK1331_02_H      0x133105
#define REG_BK1331_03_L      0x133106
#define REG_BK1331_03_H      0x133107
#define REG_BK1331_04_L      0x133108
#define REG_BK1331_04_H      0x133109
#define REG_BK1331_05_L      0x13310A
#define REG_BK1331_05_H      0x13310B
#define REG_BK1331_06_L      0x13310C
#define REG_BK1331_06_H      0x13310D
#define REG_BK1331_07_L      0x13310E
#define REG_BK1331_07_H      0x13310F
#define REG_BK1331_08_L      0x133110
#define REG_BK1331_08_H      0x133111
#define REG_BK1331_09_L      0x133112
#define REG_BK1331_09_H      0x133113
#define REG_BK1331_0A_L      0x133114
#define REG_BK1331_0A_H      0x133115
#define REG_BK1331_0B_L      0x133116
#define REG_BK1331_0B_H      0x133117
#define REG_BK1331_0C_L      0x133118
#define REG_BK1331_0C_H      0x133119
#define REG_BK1331_0D_L      0x13311A
#define REG_BK1331_0D_H      0x13311B
#define REG_BK1331_0E_L      0x13311C
#define REG_BK1331_0E_H      0x13311D
#define REG_BK1331_0F_L      0x13311E
#define REG_BK1331_0F_H      0x13311F
#define REG_BK1331_10_L      0x133120
#define REG_BK1331_10_H      0x133121
#define REG_BK1331_11_L      0x133122
#define REG_BK1331_11_H      0x133123
#define REG_BK1331_12_L      0x133124
#define REG_BK1331_12_H      0x133125
#define REG_BK1331_13_L      0x133126
#define REG_BK1331_13_H      0x133127
#define REG_BK1331_14_L      0x133128
#define REG_BK1331_14_H      0x133129
#define REG_BK1331_15_L      0x13312A
#define REG_BK1331_15_H      0x13312B
#define REG_BK1331_16_L      0x13312C
#define REG_BK1331_16_H      0x13312D
#define REG_BK1331_17_L      0x13312E
#define REG_BK1331_17_H      0x13312F
#define REG_BK1331_18_L      0x133130
#define REG_BK1331_18_H      0x133131
#define REG_BK1331_19_L      0x133132
#define REG_BK1331_19_H      0x133133
#define REG_BK1331_1A_L      0x133134
#define REG_BK1331_1A_H      0x133135
#define REG_BK1331_1B_L      0x133136
#define REG_BK1331_1B_H      0x133137
#define REG_BK1331_1C_L      0x133138
#define REG_BK1331_1C_H      0x133139
#define REG_BK1331_1D_L      0x13313A
#define REG_BK1331_1D_H      0x13313B
#define REG_BK1331_1E_L      0x13313C
#define REG_BK1331_1E_H      0x13313D
#define REG_BK1331_1F_L      0x13313E
#define REG_BK1331_1F_H      0x13313F
#define REG_BK1331_20_L      0x133140
#define REG_BK1331_20_H      0x133141
#define REG_BK1331_21_L      0x133142
#define REG_BK1331_21_H      0x133143
#define REG_BK1331_22_L      0x133144
#define REG_BK1331_22_H      0x133145
#define REG_BK1331_23_L      0x133146
#define REG_BK1331_23_H      0x133147
#define REG_BK1331_24_L      0x133148
#define REG_BK1331_24_H      0x133149
#define REG_BK1331_25_L      0x13314A
#define REG_BK1331_25_H      0x13314B
#define REG_BK1331_26_L      0x13314C
#define REG_BK1331_26_H      0x13314D
#define REG_BK1331_27_L      0x13314E
#define REG_BK1331_27_H      0x13314F
#define REG_BK1331_28_L      0x133150
#define REG_BK1331_28_H      0x133151
#define REG_BK1331_29_L      0x133152
#define REG_BK1331_29_H      0x133153
#define REG_BK1331_2A_L      0x133154
#define REG_BK1331_2A_H      0x133155
#define REG_BK1331_2B_L      0x133156
#define REG_BK1331_2B_H      0x133157
#define REG_BK1331_2C_L      0x133158
#define REG_BK1331_2C_H      0x133159
#define REG_BK1331_2D_L      0x13315A
#define REG_BK1331_2D_H      0x13315B
#define REG_BK1331_2E_L      0x13315C
#define REG_BK1331_2E_H      0x13315D
#define REG_BK1331_2F_L      0x13315E
#define REG_BK1331_2F_H      0x13315F
#define REG_BK1331_30_L      0x133160
#define REG_BK1331_30_H      0x133161
#define REG_BK1331_31_L      0x133162
#define REG_BK1331_31_H      0x133163
#define REG_BK1331_32_L      0x133164
#define REG_BK1331_32_H      0x133165
#define REG_BK1331_33_L      0x133166
#define REG_BK1331_33_H      0x133167
#define REG_BK1331_34_L      0x133168
#define REG_BK1331_34_H      0x133169
#define REG_BK1331_35_L      0x13316A
#define REG_BK1331_35_H      0x13316B
#define REG_BK1331_36_L      0x13316C
#define REG_BK1331_36_H      0x13316D
#define REG_BK1331_37_L      0x13316E
#define REG_BK1331_37_H      0x13316F
#define REG_BK1331_38_L      0x133170
#define REG_BK1331_38_H      0x133171
#define REG_BK1331_39_L      0x133172
#define REG_BK1331_39_H      0x133173
#define REG_BK1331_3A_L      0x133174
#define REG_BK1331_3A_H      0x133175
#define REG_BK1331_3B_L      0x133176
#define REG_BK1331_3B_H      0x133177
#define REG_BK1331_3C_L      0x133178
#define REG_BK1331_3C_H      0x133179
#define REG_BK1331_3D_L      0x13317A
#define REG_BK1331_3D_H      0x13317B
#define REG_BK1331_3E_L      0x13317C
#define REG_BK1331_3E_H      0x13317D
#define REG_BK1331_3F_L      0x13317E
#define REG_BK1331_3F_H      0x13317F
#define REG_BK1331_40_L      0x133180
#define REG_BK1331_40_H      0x133181
#define REG_BK1331_41_L      0x133182
#define REG_BK1331_41_H      0x133183
#define REG_BK1331_42_L      0x133184
#define REG_BK1331_42_H      0x133185
#define REG_BK1331_43_L      0x133186
#define REG_BK1331_43_H      0x133187
#define REG_BK1331_44_L      0x133188
#define REG_BK1331_44_H      0x133189
#define REG_BK1331_45_L      0x13318A
#define REG_BK1331_45_H      0x13318B
#define REG_BK1331_46_L      0x13318C
#define REG_BK1331_46_H      0x13318D
#define REG_BK1331_47_L      0x13318E
#define REG_BK1331_47_H      0x13318F
#define REG_BK1331_48_L      0x133190
#define REG_BK1331_48_H      0x133191
#define REG_BK1331_49_L      0x133192
#define REG_BK1331_49_H      0x133193
#define REG_BK1331_4A_L      0x133194
#define REG_BK1331_4A_H      0x133195
#define REG_BK1331_4B_L      0x133196
#define REG_BK1331_4B_H      0x133197
#define REG_BK1331_4C_L      0x133198
#define REG_BK1331_4C_H      0x133199
#define REG_BK1331_4D_L      0x13319A
#define REG_BK1331_4D_H      0x13319B
#define REG_BK1331_4E_L      0x13319C
#define REG_BK1331_4E_H      0x13319D
#define REG_BK1331_4F_L      0x13319E
#define REG_BK1331_4F_H      0x13319F
#define REG_BK1331_50_L      0x1331A0
#define REG_BK1331_50_H      0x1331A1
#define REG_BK1331_51_L      0x1331A2
#define REG_BK1331_51_H      0x1331A3
#define REG_BK1331_52_L      0x1331A4
#define REG_BK1331_52_H      0x1331A5
#define REG_BK1331_53_L      0x1331A6
#define REG_BK1331_53_H      0x1331A7
#define REG_BK1331_54_L      0x1331A8
#define REG_BK1331_54_H      0x1331A9
#define REG_BK1331_55_L      0x1331AA
#define REG_BK1331_55_H      0x1331AB
#define REG_BK1331_56_L      0x1331AC
#define REG_BK1331_56_H      0x1331AD
#define REG_BK1331_57_L      0x1331AE
#define REG_BK1331_57_H      0x1331AF
#define REG_BK1331_58_L      0x1331B0
#define REG_BK1331_58_H      0x1331B1
#define REG_BK1331_59_L      0x1331B2
#define REG_BK1331_59_H      0x1331B3
#define REG_BK1331_5A_L      0x1331B4
#define REG_BK1331_5A_H      0x1331B5
#define REG_BK1331_5B_L      0x1331B6
#define REG_BK1331_5B_H      0x1331B7
#define REG_BK1331_5C_L      0x1331B8
#define REG_BK1331_5C_H      0x1331B9
#define REG_BK1331_5D_L      0x1331BA
#define REG_BK1331_5D_H      0x1331BB
#define REG_BK1331_5E_L      0x1331BC
#define REG_BK1331_5E_H      0x1331BD
#define REG_BK1331_5F_L      0x1331BE
#define REG_BK1331_5F_H      0x1331BF
#define REG_BK1331_60_L      0x1331C0
#define REG_BK1331_60_H      0x1331C1
#define REG_BK1331_61_L      0x1331C2
#define REG_BK1331_61_H      0x1331C3
#define REG_BK1331_62_L      0x1331C4
#define REG_BK1331_62_H      0x1331C5
#define REG_BK1331_63_L      0x1331C6
#define REG_BK1331_63_H      0x1331C7
#define REG_BK1331_64_L      0x1331C8
#define REG_BK1331_64_H      0x1331C9
#define REG_BK1331_65_L      0x1331CA
#define REG_BK1331_65_H      0x1331CB
#define REG_BK1331_66_L      0x1331CC
#define REG_BK1331_66_H      0x1331CD
#define REG_BK1331_67_L      0x1331CE
#define REG_BK1331_67_H      0x1331CF
#define REG_BK1331_68_L      0x1331D0
#define REG_BK1331_68_H      0x1331D1
#define REG_BK1331_69_L      0x1331D2
#define REG_BK1331_69_H      0x1331D3
#define REG_BK1331_6A_L      0x1331D4
#define REG_BK1331_6A_H      0x1331D5
#define REG_BK1331_6B_L      0x1331D6
#define REG_BK1331_6B_H      0x1331D7
#define REG_BK1331_6C_L      0x1331D8
#define REG_BK1331_6C_H      0x1331D9
#define REG_BK1331_6D_L      0x1331DA
#define REG_BK1331_6D_H      0x1331DB
#define REG_BK1331_6E_L      0x1331DC
#define REG_BK1331_6E_H      0x1331DD
#define REG_BK1331_6F_L      0x1331DE
#define REG_BK1331_6F_H      0x1331DF
#define REG_BK1331_70_L      0x1331E0
#define REG_BK1331_70_H      0x1331E1
#define REG_BK1331_71_L      0x1331E2
#define REG_BK1331_71_H      0x1331E3
#define REG_BK1331_72_L      0x1331E4
#define REG_BK1331_72_H      0x1331E5
#define REG_BK1331_73_L      0x1331E6
#define REG_BK1331_73_H      0x1331E7
#define REG_BK1331_74_L      0x1331E8
#define REG_BK1331_74_H      0x1331E9
#define REG_BK1331_75_L      0x1331EA
#define REG_BK1331_75_H      0x1331EB
#define REG_BK1331_76_L      0x1331EC
#define REG_BK1331_76_H      0x1331ED
#define REG_BK1331_77_L      0x1331EE
#define REG_BK1331_77_H      0x1331EF
#define REG_BK1331_78_L      0x1331F0
#define REG_BK1331_78_H      0x1331F1
#define REG_BK1331_79_L      0x1331F2
#define REG_BK1331_79_H      0x1331F3
#define REG_BK1331_7A_L      0x1331F4
#define REG_BK1331_7A_H      0x1331F5
#define REG_BK1331_7B_L      0x1331F6
#define REG_BK1331_7B_H      0x1331F7
#define REG_BK1331_7C_L      0x1331F8
#define REG_BK1331_7C_H      0x1331F9
#define REG_BK1331_7D_L      0x1331FA
#define REG_BK1331_7D_H      0x1331FB
#define REG_BK1331_7E_L      0x1331FC
#define REG_BK1331_7E_H      0x1331FD
#define REG_BK1331_7F_L      0x1331FE
#define REG_BK1331_7F_H      0x1331FF
//----------------------------------------------
#define REG_BK1332_00_L      0x133200
#define REG_BK1332_00_H      0x133201
#define REG_BK1332_01_L      0x133202
#define REG_BK1332_01_H      0x133203
#define REG_BK1332_02_L      0x133204
#define REG_BK1332_02_H      0x133205
#define REG_BK1332_03_L      0x133206
#define REG_BK1332_03_H      0x133207
#define REG_BK1332_04_L      0x133208
#define REG_BK1332_04_H      0x133209
#define REG_BK1332_05_L      0x13320A
#define REG_BK1332_05_H      0x13320B
#define REG_BK1332_06_L      0x13320C
#define REG_BK1332_06_H      0x13320D
#define REG_BK1332_07_L      0x13320E
#define REG_BK1332_07_H      0x13320F
#define REG_BK1332_08_L      0x133210
#define REG_BK1332_08_H      0x133211
#define REG_BK1332_09_L      0x133212
#define REG_BK1332_09_H      0x133213
#define REG_BK1332_0A_L      0x133214
#define REG_BK1332_0A_H      0x133215
#define REG_BK1332_0B_L      0x133216
#define REG_BK1332_0B_H      0x133217
#define REG_BK1332_0C_L      0x133218
#define REG_BK1332_0C_H      0x133219
#define REG_BK1332_0D_L      0x13321A
#define REG_BK1332_0D_H      0x13321B
#define REG_BK1332_0E_L      0x13321C
#define REG_BK1332_0E_H      0x13321D
#define REG_BK1332_0F_L      0x13321E
#define REG_BK1332_0F_H      0x13321F
#define REG_BK1332_10_L      0x133220
#define REG_BK1332_10_H      0x133221
#define REG_BK1332_11_L      0x133222
#define REG_BK1332_11_H      0x133223
#define REG_BK1332_12_L      0x133224
#define REG_BK1332_12_H      0x133225
#define REG_BK1332_13_L      0x133226
#define REG_BK1332_13_H      0x133227
#define REG_BK1332_14_L      0x133228
#define REG_BK1332_14_H      0x133229
#define REG_BK1332_15_L      0x13322A
#define REG_BK1332_15_H      0x13322B
#define REG_BK1332_16_L      0x13322C
#define REG_BK1332_16_H      0x13322D
#define REG_BK1332_17_L      0x13322E
#define REG_BK1332_17_H      0x13322F
#define REG_BK1332_18_L      0x133230
#define REG_BK1332_18_H      0x133231
#define REG_BK1332_19_L      0x133232
#define REG_BK1332_19_H      0x133233
#define REG_BK1332_1A_L      0x133234
#define REG_BK1332_1A_H      0x133235
#define REG_BK1332_1B_L      0x133236
#define REG_BK1332_1B_H      0x133237
#define REG_BK1332_1C_L      0x133238
#define REG_BK1332_1C_H      0x133239
#define REG_BK1332_1D_L      0x13323A
#define REG_BK1332_1D_H      0x13323B
#define REG_BK1332_1E_L      0x13323C
#define REG_BK1332_1E_H      0x13323D
#define REG_BK1332_1F_L      0x13323E
#define REG_BK1332_1F_H      0x13323F
#define REG_BK1332_20_L      0x133240
#define REG_BK1332_20_H      0x133241
#define REG_BK1332_21_L      0x133242
#define REG_BK1332_21_H      0x133243
#define REG_BK1332_22_L      0x133244
#define REG_BK1332_22_H      0x133245
#define REG_BK1332_23_L      0x133246
#define REG_BK1332_23_H      0x133247
#define REG_BK1332_24_L      0x133248
#define REG_BK1332_24_H      0x133249
#define REG_BK1332_25_L      0x13324A
#define REG_BK1332_25_H      0x13324B
#define REG_BK1332_26_L      0x13324C
#define REG_BK1332_26_H      0x13324D
#define REG_BK1332_27_L      0x13324E
#define REG_BK1332_27_H      0x13324F
#define REG_BK1332_28_L      0x133250
#define REG_BK1332_28_H      0x133251
#define REG_BK1332_29_L      0x133252
#define REG_BK1332_29_H      0x133253
#define REG_BK1332_2A_L      0x133254
#define REG_BK1332_2A_H      0x133255
#define REG_BK1332_2B_L      0x133256
#define REG_BK1332_2B_H      0x133257
#define REG_BK1332_2C_L      0x133258
#define REG_BK1332_2C_H      0x133259
#define REG_BK1332_2D_L      0x13325A
#define REG_BK1332_2D_H      0x13325B
#define REG_BK1332_2E_L      0x13325C
#define REG_BK1332_2E_H      0x13325D
#define REG_BK1332_2F_L      0x13325E
#define REG_BK1332_2F_H      0x13325F
#define REG_BK1332_30_L      0x133260
#define REG_BK1332_30_H      0x133261
#define REG_BK1332_31_L      0x133262
#define REG_BK1332_31_H      0x133263
#define REG_BK1332_32_L      0x133264
#define REG_BK1332_32_H      0x133265
#define REG_BK1332_33_L      0x133266
#define REG_BK1332_33_H      0x133267
#define REG_BK1332_34_L      0x133268
#define REG_BK1332_34_H      0x133269
#define REG_BK1332_35_L      0x13326A
#define REG_BK1332_35_H      0x13326B
#define REG_BK1332_36_L      0x13326C
#define REG_BK1332_36_H      0x13326D
#define REG_BK1332_37_L      0x13326E
#define REG_BK1332_37_H      0x13326F
#define REG_BK1332_38_L      0x133270
#define REG_BK1332_38_H      0x133271
#define REG_BK1332_39_L      0x133272
#define REG_BK1332_39_H      0x133273
#define REG_BK1332_3A_L      0x133274
#define REG_BK1332_3A_H      0x133275
#define REG_BK1332_3B_L      0x133276
#define REG_BK1332_3B_H      0x133277
#define REG_BK1332_3C_L      0x133278
#define REG_BK1332_3C_H      0x133279
#define REG_BK1332_3D_L      0x13327A
#define REG_BK1332_3D_H      0x13327B
#define REG_BK1332_3E_L      0x13327C
#define REG_BK1332_3E_H      0x13327D
#define REG_BK1332_3F_L      0x13327E
#define REG_BK1332_3F_H      0x13327F
#define REG_BK1332_40_L      0x133280
#define REG_BK1332_40_H      0x133281
#define REG_BK1332_41_L      0x133282
#define REG_BK1332_41_H      0x133283
#define REG_BK1332_42_L      0x133284
#define REG_BK1332_42_H      0x133285
#define REG_BK1332_43_L      0x133286
#define REG_BK1332_43_H      0x133287
#define REG_BK1332_44_L      0x133288
#define REG_BK1332_44_H      0x133289
#define REG_BK1332_45_L      0x13328A
#define REG_BK1332_45_H      0x13328B
#define REG_BK1332_46_L      0x13328C
#define REG_BK1332_46_H      0x13328D
#define REG_BK1332_47_L      0x13328E
#define REG_BK1332_47_H      0x13328F
#define REG_BK1332_48_L      0x133290
#define REG_BK1332_48_H      0x133291
#define REG_BK1332_49_L      0x133292
#define REG_BK1332_49_H      0x133293
#define REG_BK1332_4A_L      0x133294
#define REG_BK1332_4A_H      0x133295
#define REG_BK1332_4B_L      0x133296
#define REG_BK1332_4B_H      0x133297
#define REG_BK1332_4C_L      0x133298
#define REG_BK1332_4C_H      0x133299
#define REG_BK1332_4D_L      0x13329A
#define REG_BK1332_4D_H      0x13329B
#define REG_BK1332_4E_L      0x13329C
#define REG_BK1332_4E_H      0x13329D
#define REG_BK1332_4F_L      0x13329E
#define REG_BK1332_4F_H      0x13329F
#define REG_BK1332_50_L      0x1332A0
#define REG_BK1332_50_H      0x1332A1
#define REG_BK1332_51_L      0x1332A2
#define REG_BK1332_51_H      0x1332A3
#define REG_BK1332_52_L      0x1332A4
#define REG_BK1332_52_H      0x1332A5
#define REG_BK1332_53_L      0x1332A6
#define REG_BK1332_53_H      0x1332A7
#define REG_BK1332_54_L      0x1332A8
#define REG_BK1332_54_H      0x1332A9
#define REG_BK1332_55_L      0x1332AA
#define REG_BK1332_55_H      0x1332AB
#define REG_BK1332_56_L      0x1332AC
#define REG_BK1332_56_H      0x1332AD
#define REG_BK1332_57_L      0x1332AE
#define REG_BK1332_57_H      0x1332AF
#define REG_BK1332_58_L      0x1332B0
#define REG_BK1332_58_H      0x1332B1
#define REG_BK1332_59_L      0x1332B2
#define REG_BK1332_59_H      0x1332B3
#define REG_BK1332_5A_L      0x1332B4
#define REG_BK1332_5A_H      0x1332B5
#define REG_BK1332_5B_L      0x1332B6
#define REG_BK1332_5B_H      0x1332B7
#define REG_BK1332_5C_L      0x1332B8
#define REG_BK1332_5C_H      0x1332B9
#define REG_BK1332_5D_L      0x1332BA
#define REG_BK1332_5D_H      0x1332BB
#define REG_BK1332_5E_L      0x1332BC
#define REG_BK1332_5E_H      0x1332BD
#define REG_BK1332_5F_L      0x1332BE
#define REG_BK1332_5F_H      0x1332BF
#define REG_BK1332_60_L      0x1332C0
#define REG_BK1332_60_H      0x1332C1
#define REG_BK1332_61_L      0x1332C2
#define REG_BK1332_61_H      0x1332C3
#define REG_BK1332_62_L      0x1332C4
#define REG_BK1332_62_H      0x1332C5
#define REG_BK1332_63_L      0x1332C6
#define REG_BK1332_63_H      0x1332C7
#define REG_BK1332_64_L      0x1332C8
#define REG_BK1332_64_H      0x1332C9
#define REG_BK1332_65_L      0x1332CA
#define REG_BK1332_65_H      0x1332CB
#define REG_BK1332_66_L      0x1332CC
#define REG_BK1332_66_H      0x1332CD
#define REG_BK1332_67_L      0x1332CE
#define REG_BK1332_67_H      0x1332CF
#define REG_BK1332_68_L      0x1332D0
#define REG_BK1332_68_H      0x1332D1
#define REG_BK1332_69_L      0x1332D2
#define REG_BK1332_69_H      0x1332D3
#define REG_BK1332_6A_L      0x1332D4
#define REG_BK1332_6A_H      0x1332D5
#define REG_BK1332_6B_L      0x1332D6
#define REG_BK1332_6B_H      0x1332D7
#define REG_BK1332_6C_L      0x1332D8
#define REG_BK1332_6C_H      0x1332D9
#define REG_BK1332_6D_L      0x1332DA
#define REG_BK1332_6D_H      0x1332DB
#define REG_BK1332_6E_L      0x1332DC
#define REG_BK1332_6E_H      0x1332DD
#define REG_BK1332_6F_L      0x1332DE
#define REG_BK1332_6F_H      0x1332DF
#define REG_BK1332_70_L      0x1332E0
#define REG_BK1332_70_H      0x1332E1
#define REG_BK1332_71_L      0x1332E2
#define REG_BK1332_71_H      0x1332E3
#define REG_BK1332_72_L      0x1332E4
#define REG_BK1332_72_H      0x1332E5
#define REG_BK1332_73_L      0x1332E6
#define REG_BK1332_73_H      0x1332E7
#define REG_BK1332_74_L      0x1332E8
#define REG_BK1332_74_H      0x1332E9
#define REG_BK1332_75_L      0x1332EA
#define REG_BK1332_75_H      0x1332EB
#define REG_BK1332_76_L      0x1332EC
#define REG_BK1332_76_H      0x1332ED
#define REG_BK1332_77_L      0x1332EE
#define REG_BK1332_77_H      0x1332EF
#define REG_BK1332_78_L      0x1332F0
#define REG_BK1332_78_H      0x1332F1
#define REG_BK1332_79_L      0x1332F2
#define REG_BK1332_79_H      0x1332F3
#define REG_BK1332_7A_L      0x1332F4
#define REG_BK1332_7A_H      0x1332F5
#define REG_BK1332_7B_L      0x1332F6
#define REG_BK1332_7B_H      0x1332F7
#define REG_BK1332_7C_L      0x1332F8
#define REG_BK1332_7C_H      0x1332F9
#define REG_BK1332_7D_L      0x1332FA
#define REG_BK1332_7D_H      0x1332FB
#define REG_BK1332_7E_L      0x1332FC
#define REG_BK1332_7E_H      0x1332FD
#define REG_BK1332_7F_L      0x1332FE
#define REG_BK1332_7F_H      0x1332FF
//----------------------------------------------
#define REG_BK1333_00_L      0x133300
#define REG_BK1333_00_H      0x133301
#define REG_BK1333_01_L      0x133302
#define REG_BK1333_01_H      0x133303
#define REG_BK1333_02_L      0x133304
#define REG_BK1333_02_H      0x133305
#define REG_BK1333_03_L      0x133306
#define REG_BK1333_03_H      0x133307
#define REG_BK1333_04_L      0x133308
#define REG_BK1333_04_H      0x133309
#define REG_BK1333_05_L      0x13330A
#define REG_BK1333_05_H      0x13330B
#define REG_BK1333_06_L      0x13330C
#define REG_BK1333_06_H      0x13330D
#define REG_BK1333_07_L      0x13330E
#define REG_BK1333_07_H      0x13330F
#define REG_BK1333_08_L      0x133310
#define REG_BK1333_08_H      0x133311
#define REG_BK1333_09_L      0x133312
#define REG_BK1333_09_H      0x133313
#define REG_BK1333_0A_L      0x133314
#define REG_BK1333_0A_H      0x133315
#define REG_BK1333_0B_L      0x133316
#define REG_BK1333_0B_H      0x133317
#define REG_BK1333_0C_L      0x133318
#define REG_BK1333_0C_H      0x133319
#define REG_BK1333_0D_L      0x13331A
#define REG_BK1333_0D_H      0x13331B
#define REG_BK1333_0E_L      0x13331C
#define REG_BK1333_0E_H      0x13331D
#define REG_BK1333_0F_L      0x13331E
#define REG_BK1333_0F_H      0x13331F
#define REG_BK1333_10_L      0x133320
#define REG_BK1333_10_H      0x133321
#define REG_BK1333_11_L      0x133322
#define REG_BK1333_11_H      0x133323
#define REG_BK1333_12_L      0x133324
#define REG_BK1333_12_H      0x133325
#define REG_BK1333_13_L      0x133326
#define REG_BK1333_13_H      0x133327
#define REG_BK1333_14_L      0x133328
#define REG_BK1333_14_H      0x133329
#define REG_BK1333_15_L      0x13332A
#define REG_BK1333_15_H      0x13332B
#define REG_BK1333_16_L      0x13332C
#define REG_BK1333_16_H      0x13332D
#define REG_BK1333_17_L      0x13332E
#define REG_BK1333_17_H      0x13332F
#define REG_BK1333_18_L      0x133330
#define REG_BK1333_18_H      0x133331
#define REG_BK1333_19_L      0x133332
#define REG_BK1333_19_H      0x133333
#define REG_BK1333_1A_L      0x133334
#define REG_BK1333_1A_H      0x133335
#define REG_BK1333_1B_L      0x133336
#define REG_BK1333_1B_H      0x133337
#define REG_BK1333_1C_L      0x133338
#define REG_BK1333_1C_H      0x133339
#define REG_BK1333_1D_L      0x13333A
#define REG_BK1333_1D_H      0x13333B
#define REG_BK1333_1E_L      0x13333C
#define REG_BK1333_1E_H      0x13333D
#define REG_BK1333_1F_L      0x13333E
#define REG_BK1333_1F_H      0x13333F
#define REG_BK1333_20_L      0x133340
#define REG_BK1333_20_H      0x133341
#define REG_BK1333_21_L      0x133342
#define REG_BK1333_21_H      0x133343
#define REG_BK1333_22_L      0x133344
#define REG_BK1333_22_H      0x133345
#define REG_BK1333_23_L      0x133346
#define REG_BK1333_23_H      0x133347
#define REG_BK1333_24_L      0x133348
#define REG_BK1333_24_H      0x133349
#define REG_BK1333_25_L      0x13334A
#define REG_BK1333_25_H      0x13334B
#define REG_BK1333_26_L      0x13334C
#define REG_BK1333_26_H      0x13334D
#define REG_BK1333_27_L      0x13334E
#define REG_BK1333_27_H      0x13334F
#define REG_BK1333_28_L      0x133350
#define REG_BK1333_28_H      0x133351
#define REG_BK1333_29_L      0x133352
#define REG_BK1333_29_H      0x133353
#define REG_BK1333_2A_L      0x133354
#define REG_BK1333_2A_H      0x133355
#define REG_BK1333_2B_L      0x133356
#define REG_BK1333_2B_H      0x133357
#define REG_BK1333_2C_L      0x133358
#define REG_BK1333_2C_H      0x133359
#define REG_BK1333_2D_L      0x13335A
#define REG_BK1333_2D_H      0x13335B
#define REG_BK1333_2E_L      0x13335C
#define REG_BK1333_2E_H      0x13335D
#define REG_BK1333_2F_L      0x13335E
#define REG_BK1333_2F_H      0x13335F
#define REG_BK1333_30_L      0x133360
#define REG_BK1333_30_H      0x133361
#define REG_BK1333_31_L      0x133362
#define REG_BK1333_31_H      0x133363
#define REG_BK1333_32_L      0x133364
#define REG_BK1333_32_H      0x133365
#define REG_BK1333_33_L      0x133366
#define REG_BK1333_33_H      0x133367
#define REG_BK1333_34_L      0x133368
#define REG_BK1333_34_H      0x133369
#define REG_BK1333_35_L      0x13336A
#define REG_BK1333_35_H      0x13336B
#define REG_BK1333_36_L      0x13336C
#define REG_BK1333_36_H      0x13336D
#define REG_BK1333_37_L      0x13336E
#define REG_BK1333_37_H      0x13336F
#define REG_BK1333_38_L      0x133370
#define REG_BK1333_38_H      0x133371
#define REG_BK1333_39_L      0x133372
#define REG_BK1333_39_H      0x133373
#define REG_BK1333_3A_L      0x133374
#define REG_BK1333_3A_H      0x133375
#define REG_BK1333_3B_L      0x133376
#define REG_BK1333_3B_H      0x133377
#define REG_BK1333_3C_L      0x133378
#define REG_BK1333_3C_H      0x133379
#define REG_BK1333_3D_L      0x13337A
#define REG_BK1333_3D_H      0x13337B
#define REG_BK1333_3E_L      0x13337C
#define REG_BK1333_3E_H      0x13337D
#define REG_BK1333_3F_L      0x13337E
#define REG_BK1333_3F_H      0x13337F
#define REG_BK1333_40_L      0x133380
#define REG_BK1333_40_H      0x133381
#define REG_BK1333_41_L      0x133382
#define REG_BK1333_41_H      0x133383
#define REG_BK1333_42_L      0x133384
#define REG_BK1333_42_H      0x133385
#define REG_BK1333_43_L      0x133386
#define REG_BK1333_43_H      0x133387
#define REG_BK1333_44_L      0x133388
#define REG_BK1333_44_H      0x133389
#define REG_BK1333_45_L      0x13338A
#define REG_BK1333_45_H      0x13338B
#define REG_BK1333_46_L      0x13338C
#define REG_BK1333_46_H      0x13338D
#define REG_BK1333_47_L      0x13338E
#define REG_BK1333_47_H      0x13338F
#define REG_BK1333_48_L      0x133390
#define REG_BK1333_48_H      0x133391
#define REG_BK1333_49_L      0x133392
#define REG_BK1333_49_H      0x133393
#define REG_BK1333_4A_L      0x133394
#define REG_BK1333_4A_H      0x133395
#define REG_BK1333_4B_L      0x133396
#define REG_BK1333_4B_H      0x133397
#define REG_BK1333_4C_L      0x133398
#define REG_BK1333_4C_H      0x133399
#define REG_BK1333_4D_L      0x13339A
#define REG_BK1333_4D_H      0x13339B
#define REG_BK1333_4E_L      0x13339C
#define REG_BK1333_4E_H      0x13339D
#define REG_BK1333_4F_L      0x13339E
#define REG_BK1333_4F_H      0x13339F
#define REG_BK1333_50_L      0x1333A0
#define REG_BK1333_50_H      0x1333A1
#define REG_BK1333_51_L      0x1333A2
#define REG_BK1333_51_H      0x1333A3
#define REG_BK1333_52_L      0x1333A4
#define REG_BK1333_52_H      0x1333A5
#define REG_BK1333_53_L      0x1333A6
#define REG_BK1333_53_H      0x1333A7
#define REG_BK1333_54_L      0x1333A8
#define REG_BK1333_54_H      0x1333A9
#define REG_BK1333_55_L      0x1333AA
#define REG_BK1333_55_H      0x1333AB
#define REG_BK1333_56_L      0x1333AC
#define REG_BK1333_56_H      0x1333AD
#define REG_BK1333_57_L      0x1333AE
#define REG_BK1333_57_H      0x1333AF
#define REG_BK1333_58_L      0x1333B0
#define REG_BK1333_58_H      0x1333B1
#define REG_BK1333_59_L      0x1333B2
#define REG_BK1333_59_H      0x1333B3
#define REG_BK1333_5A_L      0x1333B4
#define REG_BK1333_5A_H      0x1333B5
#define REG_BK1333_5B_L      0x1333B6
#define REG_BK1333_5B_H      0x1333B7
#define REG_BK1333_5C_L      0x1333B8
#define REG_BK1333_5C_H      0x1333B9
#define REG_BK1333_5D_L      0x1333BA
#define REG_BK1333_5D_H      0x1333BB
#define REG_BK1333_5E_L      0x1333BC
#define REG_BK1333_5E_H      0x1333BD
#define REG_BK1333_5F_L      0x1333BE
#define REG_BK1333_5F_H      0x1333BF
#define REG_BK1333_60_L      0x1333C0
#define REG_BK1333_60_H      0x1333C1
#define REG_BK1333_61_L      0x1333C2
#define REG_BK1333_61_H      0x1333C3
#define REG_BK1333_62_L      0x1333C4
#define REG_BK1333_62_H      0x1333C5
#define REG_BK1333_63_L      0x1333C6
#define REG_BK1333_63_H      0x1333C7
#define REG_BK1333_64_L      0x1333C8
#define REG_BK1333_64_H      0x1333C9
#define REG_BK1333_65_L      0x1333CA
#define REG_BK1333_65_H      0x1333CB
#define REG_BK1333_66_L      0x1333CC
#define REG_BK1333_66_H      0x1333CD
#define REG_BK1333_67_L      0x1333CE
#define REG_BK1333_67_H      0x1333CF
#define REG_BK1333_68_L      0x1333D0
#define REG_BK1333_68_H      0x1333D1
#define REG_BK1333_69_L      0x1333D2
#define REG_BK1333_69_H      0x1333D3
#define REG_BK1333_6A_L      0x1333D4
#define REG_BK1333_6A_H      0x1333D5
#define REG_BK1333_6B_L      0x1333D6
#define REG_BK1333_6B_H      0x1333D7
#define REG_BK1333_6C_L      0x1333D8
#define REG_BK1333_6C_H      0x1333D9
#define REG_BK1333_6D_L      0x1333DA
#define REG_BK1333_6D_H      0x1333DB
#define REG_BK1333_6E_L      0x1333DC
#define REG_BK1333_6E_H      0x1333DD
#define REG_BK1333_6F_L      0x1333DE
#define REG_BK1333_6F_H      0x1333DF
#define REG_BK1333_70_L      0x1333E0
#define REG_BK1333_70_H      0x1333E1
#define REG_BK1333_71_L      0x1333E2
#define REG_BK1333_71_H      0x1333E3
#define REG_BK1333_72_L      0x1333E4
#define REG_BK1333_72_H      0x1333E5
#define REG_BK1333_73_L      0x1333E6
#define REG_BK1333_73_H      0x1333E7
#define REG_BK1333_74_L      0x1333E8
#define REG_BK1333_74_H      0x1333E9
#define REG_BK1333_75_L      0x1333EA
#define REG_BK1333_75_H      0x1333EB
#define REG_BK1333_76_L      0x1333EC
#define REG_BK1333_76_H      0x1333ED
#define REG_BK1333_77_L      0x1333EE
#define REG_BK1333_77_H      0x1333EF
#define REG_BK1333_78_L      0x1333F0
#define REG_BK1333_78_H      0x1333F1
#define REG_BK1333_79_L      0x1333F2
#define REG_BK1333_79_H      0x1333F3
#define REG_BK1333_7A_L      0x1333F4
#define REG_BK1333_7A_H      0x1333F5
#define REG_BK1333_7B_L      0x1333F6
#define REG_BK1333_7B_H      0x1333F7
#define REG_BK1333_7C_L      0x1333F8
#define REG_BK1333_7C_H      0x1333F9
#define REG_BK1333_7D_L      0x1333FA
#define REG_BK1333_7D_H      0x1333FB
#define REG_BK1333_7E_L      0x1333FC
#define REG_BK1333_7E_H      0x1333FD
#define REG_BK1333_7F_L      0x1333FE
#define REG_BK1333_7F_H      0x1333FF
//----------------------------------------------
#define REG_BK1335_00_L      0x133500
#define REG_BK1335_00_H      0x133501
#define REG_BK1335_01_L      0x133502
#define REG_BK1335_01_H      0x133503
#define REG_BK1335_02_L      0x133504
#define REG_BK1335_02_H      0x133505
#define REG_BK1335_03_L      0x133506
#define REG_BK1335_03_H      0x133507
#define REG_BK1335_04_L      0x133508
#define REG_BK1335_04_H      0x133509
#define REG_BK1335_05_L      0x13350A
#define REG_BK1335_05_H      0x13350B
#define REG_BK1335_06_L      0x13350C
#define REG_BK1335_06_H      0x13350D
#define REG_BK1335_07_L      0x13350E
#define REG_BK1335_07_H      0x13350F
#define REG_BK1335_08_L      0x133510
#define REG_BK1335_08_H      0x133511
#define REG_BK1335_09_L      0x133512
#define REG_BK1335_09_H      0x133513
#define REG_BK1335_0A_L      0x133514
#define REG_BK1335_0A_H      0x133515
#define REG_BK1335_0B_L      0x133516
#define REG_BK1335_0B_H      0x133517
#define REG_BK1335_0C_L      0x133518
#define REG_BK1335_0C_H      0x133519
#define REG_BK1335_0D_L      0x13351A
#define REG_BK1335_0D_H      0x13351B
#define REG_BK1335_0E_L      0x13351C
#define REG_BK1335_0E_H      0x13351D
#define REG_BK1335_0F_L      0x13351E
#define REG_BK1335_0F_H      0x13351F
#define REG_BK1335_10_L      0x133520
#define REG_BK1335_10_H      0x133521
#define REG_BK1335_11_L      0x133522
#define REG_BK1335_11_H      0x133523
#define REG_BK1335_12_L      0x133524
#define REG_BK1335_12_H      0x133525
#define REG_BK1335_13_L      0x133526
#define REG_BK1335_13_H      0x133527
#define REG_BK1335_14_L      0x133528
#define REG_BK1335_14_H      0x133529
#define REG_BK1335_15_L      0x13352A
#define REG_BK1335_15_H      0x13352B
#define REG_BK1335_16_L      0x13352C
#define REG_BK1335_16_H      0x13352D
#define REG_BK1335_17_L      0x13352E
#define REG_BK1335_17_H      0x13352F
#define REG_BK1335_18_L      0x133530
#define REG_BK1335_18_H      0x133531
#define REG_BK1335_19_L      0x133532
#define REG_BK1335_19_H      0x133533
#define REG_BK1335_1A_L      0x133534
#define REG_BK1335_1A_H      0x133535
#define REG_BK1335_1B_L      0x133536
#define REG_BK1335_1B_H      0x133537
#define REG_BK1335_1C_L      0x133538
#define REG_BK1335_1C_H      0x133539
#define REG_BK1335_1D_L      0x13353A
#define REG_BK1335_1D_H      0x13353B
#define REG_BK1335_1E_L      0x13353C
#define REG_BK1335_1E_H      0x13353D
#define REG_BK1335_1F_L      0x13353E
#define REG_BK1335_1F_H      0x13353F
#define REG_BK1335_20_L      0x133540
#define REG_BK1335_20_H      0x133541
#define REG_BK1335_21_L      0x133542
#define REG_BK1335_21_H      0x133543
#define REG_BK1335_22_L      0x133544
#define REG_BK1335_22_H      0x133545
#define REG_BK1335_23_L      0x133546
#define REG_BK1335_23_H      0x133547
#define REG_BK1335_24_L      0x133548
#define REG_BK1335_24_H      0x133549
#define REG_BK1335_25_L      0x13354A
#define REG_BK1335_25_H      0x13354B
#define REG_BK1335_26_L      0x13354C
#define REG_BK1335_26_H      0x13354D
#define REG_BK1335_27_L      0x13354E
#define REG_BK1335_27_H      0x13354F
#define REG_BK1335_28_L      0x133550
#define REG_BK1335_28_H      0x133551
#define REG_BK1335_29_L      0x133552
#define REG_BK1335_29_H      0x133553
#define REG_BK1335_2A_L      0x133554
#define REG_BK1335_2A_H      0x133555
#define REG_BK1335_2B_L      0x133556
#define REG_BK1335_2B_H      0x133557
#define REG_BK1335_2C_L      0x133558
#define REG_BK1335_2C_H      0x133559
#define REG_BK1335_2D_L      0x13355A
#define REG_BK1335_2D_H      0x13355B
#define REG_BK1335_2E_L      0x13355C
#define REG_BK1335_2E_H      0x13355D
#define REG_BK1335_2F_L      0x13355E
#define REG_BK1335_2F_H      0x13355F
#define REG_BK1335_30_L      0x133560
#define REG_BK1335_30_H      0x133561
#define REG_BK1335_31_L      0x133562
#define REG_BK1335_31_H      0x133563
#define REG_BK1335_32_L      0x133564
#define REG_BK1335_32_H      0x133565
#define REG_BK1335_33_L      0x133566
#define REG_BK1335_33_H      0x133567
#define REG_BK1335_34_L      0x133568
#define REG_BK1335_34_H      0x133569
#define REG_BK1335_35_L      0x13356A
#define REG_BK1335_35_H      0x13356B
#define REG_BK1335_36_L      0x13356C
#define REG_BK1335_36_H      0x13356D
#define REG_BK1335_37_L      0x13356E
#define REG_BK1335_37_H      0x13356F
#define REG_BK1335_38_L      0x133570
#define REG_BK1335_38_H      0x133571
#define REG_BK1335_39_L      0x133572
#define REG_BK1335_39_H      0x133573
#define REG_BK1335_3A_L      0x133574
#define REG_BK1335_3A_H      0x133575
#define REG_BK1335_3B_L      0x133576
#define REG_BK1335_3B_H      0x133577
#define REG_BK1335_3C_L      0x133578
#define REG_BK1335_3C_H      0x133579
#define REG_BK1335_3D_L      0x13357A
#define REG_BK1335_3D_H      0x13357B
#define REG_BK1335_3E_L      0x13357C
#define REG_BK1335_3E_H      0x13357D
#define REG_BK1335_3F_L      0x13357E
#define REG_BK1335_3F_H      0x13357F
#define REG_BK1335_40_L      0x133580
#define REG_BK1335_40_H      0x133581
#define REG_BK1335_41_L      0x133582
#define REG_BK1335_41_H      0x133583
#define REG_BK1335_42_L      0x133584
#define REG_BK1335_42_H      0x133585
#define REG_BK1335_43_L      0x133586
#define REG_BK1335_43_H      0x133587
#define REG_BK1335_44_L      0x133588
#define REG_BK1335_44_H      0x133589
#define REG_BK1335_45_L      0x13358A
#define REG_BK1335_45_H      0x13358B
#define REG_BK1335_46_L      0x13358C
#define REG_BK1335_46_H      0x13358D
#define REG_BK1335_47_L      0x13358E
#define REG_BK1335_47_H      0x13358F
#define REG_BK1335_48_L      0x133590
#define REG_BK1335_48_H      0x133591
#define REG_BK1335_49_L      0x133592
#define REG_BK1335_49_H      0x133593
#define REG_BK1335_4A_L      0x133594
#define REG_BK1335_4A_H      0x133595
#define REG_BK1335_4B_L      0x133596
#define REG_BK1335_4B_H      0x133597
#define REG_BK1335_4C_L      0x133598
#define REG_BK1335_4C_H      0x133599
#define REG_BK1335_4D_L      0x13359A
#define REG_BK1335_4D_H      0x13359B
#define REG_BK1335_4E_L      0x13359C
#define REG_BK1335_4E_H      0x13359D
#define REG_BK1335_4F_L      0x13359E
#define REG_BK1335_4F_H      0x13359F
#define REG_BK1335_50_L      0x1335A0
#define REG_BK1335_50_H      0x1335A1
#define REG_BK1335_51_L      0x1335A2
#define REG_BK1335_51_H      0x1335A3
#define REG_BK1335_52_L      0x1335A4
#define REG_BK1335_52_H      0x1335A5
#define REG_BK1335_53_L      0x1335A6
#define REG_BK1335_53_H      0x1335A7
#define REG_BK1335_54_L      0x1335A8
#define REG_BK1335_54_H      0x1335A9
#define REG_BK1335_55_L      0x1335AA
#define REG_BK1335_55_H      0x1335AB
#define REG_BK1335_56_L      0x1335AC
#define REG_BK1335_56_H      0x1335AD
#define REG_BK1335_57_L      0x1335AE
#define REG_BK1335_57_H      0x1335AF
#define REG_BK1335_58_L      0x1335B0
#define REG_BK1335_58_H      0x1335B1
#define REG_BK1335_59_L      0x1335B2
#define REG_BK1335_59_H      0x1335B3
#define REG_BK1335_5A_L      0x1335B4
#define REG_BK1335_5A_H      0x1335B5
#define REG_BK1335_5B_L      0x1335B6
#define REG_BK1335_5B_H      0x1335B7
#define REG_BK1335_5C_L      0x1335B8
#define REG_BK1335_5C_H      0x1335B9
#define REG_BK1335_5D_L      0x1335BA
#define REG_BK1335_5D_H      0x1335BB
#define REG_BK1335_5E_L      0x1335BC
#define REG_BK1335_5E_H      0x1335BD
#define REG_BK1335_5F_L      0x1335BE
#define REG_BK1335_5F_H      0x1335BF
#define REG_BK1335_60_L      0x1335C0
#define REG_BK1335_60_H      0x1335C1
#define REG_BK1335_61_L      0x1335C2
#define REG_BK1335_61_H      0x1335C3
#define REG_BK1335_62_L      0x1335C4
#define REG_BK1335_62_H      0x1335C5
#define REG_BK1335_63_L      0x1335C6
#define REG_BK1335_63_H      0x1335C7
#define REG_BK1335_64_L      0x1335C8
#define REG_BK1335_64_H      0x1335C9
#define REG_BK1335_65_L      0x1335CA
#define REG_BK1335_65_H      0x1335CB
#define REG_BK1335_66_L      0x1335CC
#define REG_BK1335_66_H      0x1335CD
#define REG_BK1335_67_L      0x1335CE
#define REG_BK1335_67_H      0x1335CF
#define REG_BK1335_68_L      0x1335D0
#define REG_BK1335_68_H      0x1335D1
#define REG_BK1335_69_L      0x1335D2
#define REG_BK1335_69_H      0x1335D3
#define REG_BK1335_6A_L      0x1335D4
#define REG_BK1335_6A_H      0x1335D5
#define REG_BK1335_6B_L      0x1335D6
#define REG_BK1335_6B_H      0x1335D7
#define REG_BK1335_6C_L      0x1335D8
#define REG_BK1335_6C_H      0x1335D9
#define REG_BK1335_6D_L      0x1335DA
#define REG_BK1335_6D_H      0x1335DB
#define REG_BK1335_6E_L      0x1335DC
#define REG_BK1335_6E_H      0x1335DD
#define REG_BK1335_6F_L      0x1335DE
#define REG_BK1335_6F_H      0x1335DF
#define REG_BK1335_70_L      0x1335E0
#define REG_BK1335_70_H      0x1335E1
#define REG_BK1335_71_L      0x1335E2
#define REG_BK1335_71_H      0x1335E3
#define REG_BK1335_72_L      0x1335E4
#define REG_BK1335_72_H      0x1335E5
#define REG_BK1335_73_L      0x1335E6
#define REG_BK1335_73_H      0x1335E7
#define REG_BK1335_74_L      0x1335E8
#define REG_BK1335_74_H      0x1335E9
#define REG_BK1335_75_L      0x1335EA
#define REG_BK1335_75_H      0x1335EB
#define REG_BK1335_76_L      0x1335EC
#define REG_BK1335_76_H      0x1335ED
#define REG_BK1335_77_L      0x1335EE
#define REG_BK1335_77_H      0x1335EF
#define REG_BK1335_78_L      0x1335F0
#define REG_BK1335_78_H      0x1335F1
#define REG_BK1335_79_L      0x1335F2
#define REG_BK1335_79_H      0x1335F3
#define REG_BK1335_7A_L      0x1335F4
#define REG_BK1335_7A_H      0x1335F5
#define REG_BK1335_7B_L      0x1335F6
#define REG_BK1335_7B_H      0x1335F7
#define REG_BK1335_7C_L      0x1335F8
#define REG_BK1335_7C_H      0x1335F9
#define REG_BK1335_7D_L      0x1335FA
#define REG_BK1335_7D_H      0x1335FB
#define REG_BK1335_7E_L      0x1335FC
#define REG_BK1335_7E_H      0x1335FD
#define REG_BK1335_7F_L      0x1335FE
#define REG_BK1335_7F_H      0x1335FF
//----------------------------------------------
#define REG_BK1338_00_L      0x133800
#define REG_BK1338_00_H      0x133801
#define REG_BK1338_01_L      0x133802
#define REG_BK1338_01_H      0x133803
#define REG_BK1338_02_L      0x133804
#define REG_BK1338_02_H      0x133805
#define REG_BK1338_03_L      0x133806
#define REG_BK1338_03_H      0x133807
#define REG_BK1338_04_L      0x133808
#define REG_BK1338_04_H      0x133809
#define REG_BK1338_05_L      0x13380A
#define REG_BK1338_05_H      0x13380B
#define REG_BK1338_06_L      0x13380C
#define REG_BK1338_06_H      0x13380D
#define REG_BK1338_07_L      0x13380E
#define REG_BK1338_07_H      0x13380F
#define REG_BK1338_08_L      0x133810
#define REG_BK1338_08_H      0x133811
#define REG_BK1338_09_L      0x133812
#define REG_BK1338_09_H      0x133813
#define REG_BK1338_0A_L      0x133814
#define REG_BK1338_0A_H      0x133815
#define REG_BK1338_0B_L      0x133816
#define REG_BK1338_0B_H      0x133817
#define REG_BK1338_0C_L      0x133818
#define REG_BK1338_0C_H      0x133819
#define REG_BK1338_0D_L      0x13381A
#define REG_BK1338_0D_H      0x13381B
#define REG_BK1338_0E_L      0x13381C
#define REG_BK1338_0E_H      0x13381D
#define REG_BK1338_0F_L      0x13381E
#define REG_BK1338_0F_H      0x13381F
#define REG_BK1338_10_L      0x133820
#define REG_BK1338_10_H      0x133821
#define REG_BK1338_11_L      0x133822
#define REG_BK1338_11_H      0x133823
#define REG_BK1338_12_L      0x133824
#define REG_BK1338_12_H      0x133825
#define REG_BK1338_13_L      0x133826
#define REG_BK1338_13_H      0x133827
#define REG_BK1338_14_L      0x133828
#define REG_BK1338_14_H      0x133829
#define REG_BK1338_15_L      0x13382A
#define REG_BK1338_15_H      0x13382B
#define REG_BK1338_16_L      0x13382C
#define REG_BK1338_16_H      0x13382D
#define REG_BK1338_17_L      0x13382E
#define REG_BK1338_17_H      0x13382F
#define REG_BK1338_18_L      0x133830
#define REG_BK1338_18_H      0x133831
#define REG_BK1338_19_L      0x133832
#define REG_BK1338_19_H      0x133833
#define REG_BK1338_1A_L      0x133834
#define REG_BK1338_1A_H      0x133835
#define REG_BK1338_1B_L      0x133836
#define REG_BK1338_1B_H      0x133837
#define REG_BK1338_1C_L      0x133838
#define REG_BK1338_1C_H      0x133839
#define REG_BK1338_1D_L      0x13383A
#define REG_BK1338_1D_H      0x13383B
#define REG_BK1338_1E_L      0x13383C
#define REG_BK1338_1E_H      0x13383D
#define REG_BK1338_1F_L      0x13383E
#define REG_BK1338_1F_H      0x13383F
#define REG_BK1338_20_L      0x133840
#define REG_BK1338_20_H      0x133841
#define REG_BK1338_21_L      0x133842
#define REG_BK1338_21_H      0x133843
#define REG_BK1338_22_L      0x133844
#define REG_BK1338_22_H      0x133845
#define REG_BK1338_23_L      0x133846
#define REG_BK1338_23_H      0x133847
#define REG_BK1338_24_L      0x133848
#define REG_BK1338_24_H      0x133849
#define REG_BK1338_25_L      0x13384A
#define REG_BK1338_25_H      0x13384B
#define REG_BK1338_26_L      0x13384C
#define REG_BK1338_26_H      0x13384D
#define REG_BK1338_27_L      0x13384E
#define REG_BK1338_27_H      0x13384F
#define REG_BK1338_28_L      0x133850
#define REG_BK1338_28_H      0x133851
#define REG_BK1338_29_L      0x133852
#define REG_BK1338_29_H      0x133853
#define REG_BK1338_2A_L      0x133854
#define REG_BK1338_2A_H      0x133855
#define REG_BK1338_2B_L      0x133856
#define REG_BK1338_2B_H      0x133857
#define REG_BK1338_2C_L      0x133858
#define REG_BK1338_2C_H      0x133859
#define REG_BK1338_2D_L      0x13385A
#define REG_BK1338_2D_H      0x13385B
#define REG_BK1338_2E_L      0x13385C
#define REG_BK1338_2E_H      0x13385D
#define REG_BK1338_2F_L      0x13385E
#define REG_BK1338_2F_H      0x13385F
#define REG_BK1338_30_L      0x133860
#define REG_BK1338_30_H      0x133861
#define REG_BK1338_31_L      0x133862
#define REG_BK1338_31_H      0x133863
#define REG_BK1338_32_L      0x133864
#define REG_BK1338_32_H      0x133865
#define REG_BK1338_33_L      0x133866
#define REG_BK1338_33_H      0x133867
#define REG_BK1338_34_L      0x133868
#define REG_BK1338_34_H      0x133869
#define REG_BK1338_35_L      0x13386A
#define REG_BK1338_35_H      0x13386B
#define REG_BK1338_36_L      0x13386C
#define REG_BK1338_36_H      0x13386D
#define REG_BK1338_37_L      0x13386E
#define REG_BK1338_37_H      0x13386F
#define REG_BK1338_38_L      0x133870
#define REG_BK1338_38_H      0x133871
#define REG_BK1338_39_L      0x133872
#define REG_BK1338_39_H      0x133873
#define REG_BK1338_3A_L      0x133874
#define REG_BK1338_3A_H      0x133875
#define REG_BK1338_3B_L      0x133876
#define REG_BK1338_3B_H      0x133877
#define REG_BK1338_3C_L      0x133878
#define REG_BK1338_3C_H      0x133879
#define REG_BK1338_3D_L      0x13387A
#define REG_BK1338_3D_H      0x13387B
#define REG_BK1338_3E_L      0x13387C
#define REG_BK1338_3E_H      0x13387D
#define REG_BK1338_3F_L      0x13387E
#define REG_BK1338_3F_H      0x13387F
#define REG_BK1338_40_L      0x133880
#define REG_BK1338_40_H      0x133881
#define REG_BK1338_41_L      0x133882
#define REG_BK1338_41_H      0x133883
#define REG_BK1338_42_L      0x133884
#define REG_BK1338_42_H      0x133885
#define REG_BK1338_43_L      0x133886
#define REG_BK1338_43_H      0x133887
#define REG_BK1338_44_L      0x133888
#define REG_BK1338_44_H      0x133889
#define REG_BK1338_45_L      0x13388A
#define REG_BK1338_45_H      0x13388B
#define REG_BK1338_46_L      0x13388C
#define REG_BK1338_46_H      0x13388D
#define REG_BK1338_47_L      0x13388E
#define REG_BK1338_47_H      0x13388F
#define REG_BK1338_48_L      0x133890
#define REG_BK1338_48_H      0x133891
#define REG_BK1338_49_L      0x133892
#define REG_BK1338_49_H      0x133893
#define REG_BK1338_4A_L      0x133894
#define REG_BK1338_4A_H      0x133895
#define REG_BK1338_4B_L      0x133896
#define REG_BK1338_4B_H      0x133897
#define REG_BK1338_4C_L      0x133898
#define REG_BK1338_4C_H      0x133899
#define REG_BK1338_4D_L      0x13389A
#define REG_BK1338_4D_H      0x13389B
#define REG_BK1338_4E_L      0x13389C
#define REG_BK1338_4E_H      0x13389D
#define REG_BK1338_4F_L      0x13389E
#define REG_BK1338_4F_H      0x13389F
#define REG_BK1338_50_L      0x1338A0
#define REG_BK1338_50_H      0x1338A1
#define REG_BK1338_51_L      0x1338A2
#define REG_BK1338_51_H      0x1338A3
#define REG_BK1338_52_L      0x1338A4
#define REG_BK1338_52_H      0x1338A5
#define REG_BK1338_53_L      0x1338A6
#define REG_BK1338_53_H      0x1338A7
#define REG_BK1338_54_L      0x1338A8
#define REG_BK1338_54_H      0x1338A9
#define REG_BK1338_55_L      0x1338AA
#define REG_BK1338_55_H      0x1338AB
#define REG_BK1338_56_L      0x1338AC
#define REG_BK1338_56_H      0x1338AD
#define REG_BK1338_57_L      0x1338AE
#define REG_BK1338_57_H      0x1338AF
#define REG_BK1338_58_L      0x1338B0
#define REG_BK1338_58_H      0x1338B1
#define REG_BK1338_59_L      0x1338B2
#define REG_BK1338_59_H      0x1338B3
#define REG_BK1338_5A_L      0x1338B4
#define REG_BK1338_5A_H      0x1338B5
#define REG_BK1338_5B_L      0x1338B6
#define REG_BK1338_5B_H      0x1338B7
#define REG_BK1338_5C_L      0x1338B8
#define REG_BK1338_5C_H      0x1338B9
#define REG_BK1338_5D_L      0x1338BA
#define REG_BK1338_5D_H      0x1338BB
#define REG_BK1338_5E_L      0x1338BC
#define REG_BK1338_5E_H      0x1338BD
#define REG_BK1338_5F_L      0x1338BE
#define REG_BK1338_5F_H      0x1338BF
#define REG_BK1338_60_L      0x1338C0
#define REG_BK1338_60_H      0x1338C1
#define REG_BK1338_61_L      0x1338C2
#define REG_BK1338_61_H      0x1338C3
#define REG_BK1338_62_L      0x1338C4
#define REG_BK1338_62_H      0x1338C5
#define REG_BK1338_63_L      0x1338C6
#define REG_BK1338_63_H      0x1338C7
#define REG_BK1338_64_L      0x1338C8
#define REG_BK1338_64_H      0x1338C9
#define REG_BK1338_65_L      0x1338CA
#define REG_BK1338_65_H      0x1338CB
#define REG_BK1338_66_L      0x1338CC
#define REG_BK1338_66_H      0x1338CD
#define REG_BK1338_67_L      0x1338CE
#define REG_BK1338_67_H      0x1338CF
#define REG_BK1338_68_L      0x1338D0
#define REG_BK1338_68_H      0x1338D1
#define REG_BK1338_69_L      0x1338D2
#define REG_BK1338_69_H      0x1338D3
#define REG_BK1338_6A_L      0x1338D4
#define REG_BK1338_6A_H      0x1338D5
#define REG_BK1338_6B_L      0x1338D6
#define REG_BK1338_6B_H      0x1338D7
#define REG_BK1338_6C_L      0x1338D8
#define REG_BK1338_6C_H      0x1338D9
#define REG_BK1338_6D_L      0x1338DA
#define REG_BK1338_6D_H      0x1338DB
#define REG_BK1338_6E_L      0x1338DC
#define REG_BK1338_6E_H      0x1338DD
#define REG_BK1338_6F_L      0x1338DE
#define REG_BK1338_6F_H      0x1338DF
#define REG_BK1338_70_L      0x1338E0
#define REG_BK1338_70_H      0x1338E1
#define REG_BK1338_71_L      0x1338E2
#define REG_BK1338_71_H      0x1338E3
#define REG_BK1338_72_L      0x1338E4
#define REG_BK1338_72_H      0x1338E5
#define REG_BK1338_73_L      0x1338E6
#define REG_BK1338_73_H      0x1338E7
#define REG_BK1338_74_L      0x1338E8
#define REG_BK1338_74_H      0x1338E9
#define REG_BK1338_75_L      0x1338EA
#define REG_BK1338_75_H      0x1338EB
#define REG_BK1338_76_L      0x1338EC
#define REG_BK1338_76_H      0x1338ED
#define REG_BK1338_77_L      0x1338EE
#define REG_BK1338_77_H      0x1338EF
#define REG_BK1338_78_L      0x1338F0
#define REG_BK1338_78_H      0x1338F1
#define REG_BK1338_79_L      0x1338F2
#define REG_BK1338_79_H      0x1338F3
#define REG_BK1338_7A_L      0x1338F4
#define REG_BK1338_7A_H      0x1338F5
#define REG_BK1338_7B_L      0x1338F6
#define REG_BK1338_7B_H      0x1338F7
#define REG_BK1338_7C_L      0x1338F8
#define REG_BK1338_7C_H      0x1338F9
#define REG_BK1338_7D_L      0x1338FA
#define REG_BK1338_7D_H      0x1338FB
#define REG_BK1338_7E_L      0x1338FC
#define REG_BK1338_7E_H      0x1338FD
#define REG_BK1338_7F_L      0x1338FE
#define REG_BK1338_7F_H      0x1338FF
//----------------------------------------------
#define REG_BK1339_00_L      0x133900
#define REG_BK1339_00_H      0x133901
#define REG_BK1339_01_L      0x133902
#define REG_BK1339_01_H      0x133903
#define REG_BK1339_02_L      0x133904
#define REG_BK1339_02_H      0x133905
#define REG_BK1339_03_L      0x133906
#define REG_BK1339_03_H      0x133907
#define REG_BK1339_04_L      0x133908
#define REG_BK1339_04_H      0x133909
#define REG_BK1339_05_L      0x13390A
#define REG_BK1339_05_H      0x13390B
#define REG_BK1339_06_L      0x13390C
#define REG_BK1339_06_H      0x13390D
#define REG_BK1339_07_L      0x13390E
#define REG_BK1339_07_H      0x13390F
#define REG_BK1339_08_L      0x133910
#define REG_BK1339_08_H      0x133911
#define REG_BK1339_09_L      0x133912
#define REG_BK1339_09_H      0x133913
#define REG_BK1339_0A_L      0x133914
#define REG_BK1339_0A_H      0x133915
#define REG_BK1339_0B_L      0x133916
#define REG_BK1339_0B_H      0x133917
#define REG_BK1339_0C_L      0x133918
#define REG_BK1339_0C_H      0x133919
#define REG_BK1339_0D_L      0x13391A
#define REG_BK1339_0D_H      0x13391B
#define REG_BK1339_0E_L      0x13391C
#define REG_BK1339_0E_H      0x13391D
#define REG_BK1339_0F_L      0x13391E
#define REG_BK1339_0F_H      0x13391F
#define REG_BK1339_10_L      0x133920
#define REG_BK1339_10_H      0x133921
#define REG_BK1339_11_L      0x133922
#define REG_BK1339_11_H      0x133923
#define REG_BK1339_12_L      0x133924
#define REG_BK1339_12_H      0x133925
#define REG_BK1339_13_L      0x133926
#define REG_BK1339_13_H      0x133927
#define REG_BK1339_14_L      0x133928
#define REG_BK1339_14_H      0x133929
#define REG_BK1339_15_L      0x13392A
#define REG_BK1339_15_H      0x13392B
#define REG_BK1339_16_L      0x13392C
#define REG_BK1339_16_H      0x13392D
#define REG_BK1339_17_L      0x13392E
#define REG_BK1339_17_H      0x13392F
#define REG_BK1339_18_L      0x133930
#define REG_BK1339_18_H      0x133931
#define REG_BK1339_19_L      0x133932
#define REG_BK1339_19_H      0x133933
#define REG_BK1339_1A_L      0x133934
#define REG_BK1339_1A_H      0x133935
#define REG_BK1339_1B_L      0x133936
#define REG_BK1339_1B_H      0x133937
#define REG_BK1339_1C_L      0x133938
#define REG_BK1339_1C_H      0x133939
#define REG_BK1339_1D_L      0x13393A
#define REG_BK1339_1D_H      0x13393B
#define REG_BK1339_1E_L      0x13393C
#define REG_BK1339_1E_H      0x13393D
#define REG_BK1339_1F_L      0x13393E
#define REG_BK1339_1F_H      0x13393F
#define REG_BK1339_20_L      0x133940
#define REG_BK1339_20_H      0x133941
#define REG_BK1339_21_L      0x133942
#define REG_BK1339_21_H      0x133943
#define REG_BK1339_22_L      0x133944
#define REG_BK1339_22_H      0x133945
#define REG_BK1339_23_L      0x133946
#define REG_BK1339_23_H      0x133947
#define REG_BK1339_24_L      0x133948
#define REG_BK1339_24_H      0x133949
#define REG_BK1339_25_L      0x13394A
#define REG_BK1339_25_H      0x13394B
#define REG_BK1339_26_L      0x13394C
#define REG_BK1339_26_H      0x13394D
#define REG_BK1339_27_L      0x13394E
#define REG_BK1339_27_H      0x13394F
#define REG_BK1339_28_L      0x133950
#define REG_BK1339_28_H      0x133951
#define REG_BK1339_29_L      0x133952
#define REG_BK1339_29_H      0x133953
#define REG_BK1339_2A_L      0x133954
#define REG_BK1339_2A_H      0x133955
#define REG_BK1339_2B_L      0x133956
#define REG_BK1339_2B_H      0x133957
#define REG_BK1339_2C_L      0x133958
#define REG_BK1339_2C_H      0x133959
#define REG_BK1339_2D_L      0x13395A
#define REG_BK1339_2D_H      0x13395B
#define REG_BK1339_2E_L      0x13395C
#define REG_BK1339_2E_H      0x13395D
#define REG_BK1339_2F_L      0x13395E
#define REG_BK1339_2F_H      0x13395F
#define REG_BK1339_30_L      0x133960
#define REG_BK1339_30_H      0x133961
#define REG_BK1339_31_L      0x133962
#define REG_BK1339_31_H      0x133963
#define REG_BK1339_32_L      0x133964
#define REG_BK1339_32_H      0x133965
#define REG_BK1339_33_L      0x133966
#define REG_BK1339_33_H      0x133967
#define REG_BK1339_34_L      0x133968
#define REG_BK1339_34_H      0x133969
#define REG_BK1339_35_L      0x13396A
#define REG_BK1339_35_H      0x13396B
#define REG_BK1339_36_L      0x13396C
#define REG_BK1339_36_H      0x13396D
#define REG_BK1339_37_L      0x13396E
#define REG_BK1339_37_H      0x13396F
#define REG_BK1339_38_L      0x133970
#define REG_BK1339_38_H      0x133971
#define REG_BK1339_39_L      0x133972
#define REG_BK1339_39_H      0x133973
#define REG_BK1339_3A_L      0x133974
#define REG_BK1339_3A_H      0x133975
#define REG_BK1339_3B_L      0x133976
#define REG_BK1339_3B_H      0x133977
#define REG_BK1339_3C_L      0x133978
#define REG_BK1339_3C_H      0x133979
#define REG_BK1339_3D_L      0x13397A
#define REG_BK1339_3D_H      0x13397B
#define REG_BK1339_3E_L      0x13397C
#define REG_BK1339_3E_H      0x13397D
#define REG_BK1339_3F_L      0x13397E
#define REG_BK1339_3F_H      0x13397F
#define REG_BK1339_40_L      0x133980
#define REG_BK1339_40_H      0x133981
#define REG_BK1339_41_L      0x133982
#define REG_BK1339_41_H      0x133983
#define REG_BK1339_42_L      0x133984
#define REG_BK1339_42_H      0x133985
#define REG_BK1339_43_L      0x133986
#define REG_BK1339_43_H      0x133987
#define REG_BK1339_44_L      0x133988
#define REG_BK1339_44_H      0x133989
#define REG_BK1339_45_L      0x13398A
#define REG_BK1339_45_H      0x13398B
#define REG_BK1339_46_L      0x13398C
#define REG_BK1339_46_H      0x13398D
#define REG_BK1339_47_L      0x13398E
#define REG_BK1339_47_H      0x13398F
#define REG_BK1339_48_L      0x133990
#define REG_BK1339_48_H      0x133991
#define REG_BK1339_49_L      0x133992
#define REG_BK1339_49_H      0x133993
#define REG_BK1339_4A_L      0x133994
#define REG_BK1339_4A_H      0x133995
#define REG_BK1339_4B_L      0x133996
#define REG_BK1339_4B_H      0x133997
#define REG_BK1339_4C_L      0x133998
#define REG_BK1339_4C_H      0x133999
#define REG_BK1339_4D_L      0x13399A
#define REG_BK1339_4D_H      0x13399B
#define REG_BK1339_4E_L      0x13399C
#define REG_BK1339_4E_H      0x13399D
#define REG_BK1339_4F_L      0x13399E
#define REG_BK1339_4F_H      0x13399F
#define REG_BK1339_50_L      0x1339A0
#define REG_BK1339_50_H      0x1339A1
#define REG_BK1339_51_L      0x1339A2
#define REG_BK1339_51_H      0x1339A3
#define REG_BK1339_52_L      0x1339A4
#define REG_BK1339_52_H      0x1339A5
#define REG_BK1339_53_L      0x1339A6
#define REG_BK1339_53_H      0x1339A7
#define REG_BK1339_54_L      0x1339A8
#define REG_BK1339_54_H      0x1339A9
#define REG_BK1339_55_L      0x1339AA
#define REG_BK1339_55_H      0x1339AB
#define REG_BK1339_56_L      0x1339AC
#define REG_BK1339_56_H      0x1339AD
#define REG_BK1339_57_L      0x1339AE
#define REG_BK1339_57_H      0x1339AF
#define REG_BK1339_58_L      0x1339B0
#define REG_BK1339_58_H      0x1339B1
#define REG_BK1339_59_L      0x1339B2
#define REG_BK1339_59_H      0x1339B3
#define REG_BK1339_5A_L      0x1339B4
#define REG_BK1339_5A_H      0x1339B5
#define REG_BK1339_5B_L      0x1339B6
#define REG_BK1339_5B_H      0x1339B7
#define REG_BK1339_5C_L      0x1339B8
#define REG_BK1339_5C_H      0x1339B9
#define REG_BK1339_5D_L      0x1339BA
#define REG_BK1339_5D_H      0x1339BB
#define REG_BK1339_5E_L      0x1339BC
#define REG_BK1339_5E_H      0x1339BD
#define REG_BK1339_5F_L      0x1339BE
#define REG_BK1339_5F_H      0x1339BF
#define REG_BK1339_60_L      0x1339C0
#define REG_BK1339_60_H      0x1339C1
#define REG_BK1339_61_L      0x1339C2
#define REG_BK1339_61_H      0x1339C3
#define REG_BK1339_62_L      0x1339C4
#define REG_BK1339_62_H      0x1339C5
#define REG_BK1339_63_L      0x1339C6
#define REG_BK1339_63_H      0x1339C7
#define REG_BK1339_64_L      0x1339C8
#define REG_BK1339_64_H      0x1339C9
#define REG_BK1339_65_L      0x1339CA
#define REG_BK1339_65_H      0x1339CB
#define REG_BK1339_66_L      0x1339CC
#define REG_BK1339_66_H      0x1339CD
#define REG_BK1339_67_L      0x1339CE
#define REG_BK1339_67_H      0x1339CF
#define REG_BK1339_68_L      0x1339D0
#define REG_BK1339_68_H      0x1339D1
#define REG_BK1339_69_L      0x1339D2
#define REG_BK1339_69_H      0x1339D3
#define REG_BK1339_6A_L      0x1339D4
#define REG_BK1339_6A_H      0x1339D5
#define REG_BK1339_6B_L      0x1339D6
#define REG_BK1339_6B_H      0x1339D7
#define REG_BK1339_6C_L      0x1339D8
#define REG_BK1339_6C_H      0x1339D9
#define REG_BK1339_6D_L      0x1339DA
#define REG_BK1339_6D_H      0x1339DB
#define REG_BK1339_6E_L      0x1339DC
#define REG_BK1339_6E_H      0x1339DD
#define REG_BK1339_6F_L      0x1339DE
#define REG_BK1339_6F_H      0x1339DF
#define REG_BK1339_70_L      0x1339E0
#define REG_BK1339_70_H      0x1339E1
#define REG_BK1339_71_L      0x1339E2
#define REG_BK1339_71_H      0x1339E3
#define REG_BK1339_72_L      0x1339E4
#define REG_BK1339_72_H      0x1339E5
#define REG_BK1339_73_L      0x1339E6
#define REG_BK1339_73_H      0x1339E7
#define REG_BK1339_74_L      0x1339E8
#define REG_BK1339_74_H      0x1339E9
#define REG_BK1339_75_L      0x1339EA
#define REG_BK1339_75_H      0x1339EB
#define REG_BK1339_76_L      0x1339EC
#define REG_BK1339_76_H      0x1339ED
#define REG_BK1339_77_L      0x1339EE
#define REG_BK1339_77_H      0x1339EF
#define REG_BK1339_78_L      0x1339F0
#define REG_BK1339_78_H      0x1339F1
#define REG_BK1339_79_L      0x1339F2
#define REG_BK1339_79_H      0x1339F3
#define REG_BK1339_7A_L      0x1339F4
#define REG_BK1339_7A_H      0x1339F5
#define REG_BK1339_7B_L      0x1339F6
#define REG_BK1339_7B_H      0x1339F7
#define REG_BK1339_7C_L      0x1339F8
#define REG_BK1339_7C_H      0x1339F9
#define REG_BK1339_7D_L      0x1339FA
#define REG_BK1339_7D_H      0x1339FB
#define REG_BK1339_7E_L      0x1339FC
#define REG_BK1339_7E_H      0x1339FD
#define REG_BK1339_7F_L      0x1339FE
#define REG_BK1339_7F_H      0x1339FF
//----------------------------------------------
#define REG_BK133A_00_L      0x133A00
#define REG_BK133A_00_H      0x133A01
#define REG_BK133A_01_L      0x133A02
#define REG_BK133A_01_H      0x133A03
#define REG_BK133A_02_L      0x133A04
#define REG_BK133A_02_H      0x133A05
#define REG_BK133A_03_L      0x133A06
#define REG_BK133A_03_H      0x133A07
#define REG_BK133A_04_L      0x133A08
#define REG_BK133A_04_H      0x133A09
#define REG_BK133A_05_L      0x133A0A
#define REG_BK133A_05_H      0x133A0B
#define REG_BK133A_06_L      0x133A0C
#define REG_BK133A_06_H      0x133A0D
#define REG_BK133A_07_L      0x133A0E
#define REG_BK133A_07_H      0x133A0F
#define REG_BK133A_08_L      0x133A10
#define REG_BK133A_08_H      0x133A11
#define REG_BK133A_09_L      0x133A12
#define REG_BK133A_09_H      0x133A13
#define REG_BK133A_0A_L      0x133A14
#define REG_BK133A_0A_H      0x133A15
#define REG_BK133A_0B_L      0x133A16
#define REG_BK133A_0B_H      0x133A17
#define REG_BK133A_0C_L      0x133A18
#define REG_BK133A_0C_H      0x133A19
#define REG_BK133A_0D_L      0x133A1A
#define REG_BK133A_0D_H      0x133A1B
#define REG_BK133A_0E_L      0x133A1C
#define REG_BK133A_0E_H      0x133A1D
#define REG_BK133A_0F_L      0x133A1E
#define REG_BK133A_0F_H      0x133A1F
#define REG_BK133A_10_L      0x133A20
#define REG_BK133A_10_H      0x133A21
#define REG_BK133A_11_L      0x133A22
#define REG_BK133A_11_H      0x133A23
#define REG_BK133A_12_L      0x133A24
#define REG_BK133A_12_H      0x133A25
#define REG_BK133A_13_L      0x133A26
#define REG_BK133A_13_H      0x133A27
#define REG_BK133A_14_L      0x133A28
#define REG_BK133A_14_H      0x133A29
#define REG_BK133A_15_L      0x133A2A
#define REG_BK133A_15_H      0x133A2B
#define REG_BK133A_16_L      0x133A2C
#define REG_BK133A_16_H      0x133A2D
#define REG_BK133A_17_L      0x133A2E
#define REG_BK133A_17_H      0x133A2F
#define REG_BK133A_18_L      0x133A30
#define REG_BK133A_18_H      0x133A31
#define REG_BK133A_19_L      0x133A32
#define REG_BK133A_19_H      0x133A33
#define REG_BK133A_1A_L      0x133A34
#define REG_BK133A_1A_H      0x133A35
#define REG_BK133A_1B_L      0x133A36
#define REG_BK133A_1B_H      0x133A37
#define REG_BK133A_1C_L      0x133A38
#define REG_BK133A_1C_H      0x133A39
#define REG_BK133A_1D_L      0x133A3A
#define REG_BK133A_1D_H      0x133A3B
#define REG_BK133A_1E_L      0x133A3C
#define REG_BK133A_1E_H      0x133A3D
#define REG_BK133A_1F_L      0x133A3E
#define REG_BK133A_1F_H      0x133A3F
#define REG_BK133A_20_L      0x133A40
#define REG_BK133A_20_H      0x133A41
#define REG_BK133A_21_L      0x133A42
#define REG_BK133A_21_H      0x133A43
#define REG_BK133A_22_L      0x133A44
#define REG_BK133A_22_H      0x133A45
#define REG_BK133A_23_L      0x133A46
#define REG_BK133A_23_H      0x133A47
#define REG_BK133A_24_L      0x133A48
#define REG_BK133A_24_H      0x133A49
#define REG_BK133A_25_L      0x133A4A
#define REG_BK133A_25_H      0x133A4B
#define REG_BK133A_26_L      0x133A4C
#define REG_BK133A_26_H      0x133A4D
#define REG_BK133A_27_L      0x133A4E
#define REG_BK133A_27_H      0x133A4F
#define REG_BK133A_28_L      0x133A50
#define REG_BK133A_28_H      0x133A51
#define REG_BK133A_29_L      0x133A52
#define REG_BK133A_29_H      0x133A53
#define REG_BK133A_2A_L      0x133A54
#define REG_BK133A_2A_H      0x133A55
#define REG_BK133A_2B_L      0x133A56
#define REG_BK133A_2B_H      0x133A57
#define REG_BK133A_2C_L      0x133A58
#define REG_BK133A_2C_H      0x133A59
#define REG_BK133A_2D_L      0x133A5A
#define REG_BK133A_2D_H      0x133A5B
#define REG_BK133A_2E_L      0x133A5C
#define REG_BK133A_2E_H      0x133A5D
#define REG_BK133A_2F_L      0x133A5E
#define REG_BK133A_2F_H      0x133A5F
#define REG_BK133A_30_L      0x133A60
#define REG_BK133A_30_H      0x133A61
#define REG_BK133A_31_L      0x133A62
#define REG_BK133A_31_H      0x133A63
#define REG_BK133A_32_L      0x133A64
#define REG_BK133A_32_H      0x133A65
#define REG_BK133A_33_L      0x133A66
#define REG_BK133A_33_H      0x133A67
#define REG_BK133A_34_L      0x133A68
#define REG_BK133A_34_H      0x133A69
#define REG_BK133A_35_L      0x133A6A
#define REG_BK133A_35_H      0x133A6B
#define REG_BK133A_36_L      0x133A6C
#define REG_BK133A_36_H      0x133A6D
#define REG_BK133A_37_L      0x133A6E
#define REG_BK133A_37_H      0x133A6F
#define REG_BK133A_38_L      0x133A70
#define REG_BK133A_38_H      0x133A71
#define REG_BK133A_39_L      0x133A72
#define REG_BK133A_39_H      0x133A73
#define REG_BK133A_3A_L      0x133A74
#define REG_BK133A_3A_H      0x133A75
#define REG_BK133A_3B_L      0x133A76
#define REG_BK133A_3B_H      0x133A77
#define REG_BK133A_3C_L      0x133A78
#define REG_BK133A_3C_H      0x133A79
#define REG_BK133A_3D_L      0x133A7A
#define REG_BK133A_3D_H      0x133A7B
#define REG_BK133A_3E_L      0x133A7C
#define REG_BK133A_3E_H      0x133A7D
#define REG_BK133A_3F_L      0x133A7E
#define REG_BK133A_3F_H      0x133A7F
#define REG_BK133A_40_L      0x133A80
#define REG_BK133A_40_H      0x133A81
#define REG_BK133A_41_L      0x133A82
#define REG_BK133A_41_H      0x133A83
#define REG_BK133A_42_L      0x133A84
#define REG_BK133A_42_H      0x133A85
#define REG_BK133A_43_L      0x133A86
#define REG_BK133A_43_H      0x133A87
#define REG_BK133A_44_L      0x133A88
#define REG_BK133A_44_H      0x133A89
#define REG_BK133A_45_L      0x133A8A
#define REG_BK133A_45_H      0x133A8B
#define REG_BK133A_46_L      0x133A8C
#define REG_BK133A_46_H      0x133A8D
#define REG_BK133A_47_L      0x133A8E
#define REG_BK133A_47_H      0x133A8F
#define REG_BK133A_48_L      0x133A90
#define REG_BK133A_48_H      0x133A91
#define REG_BK133A_49_L      0x133A92
#define REG_BK133A_49_H      0x133A93
#define REG_BK133A_4A_L      0x133A94
#define REG_BK133A_4A_H      0x133A95
#define REG_BK133A_4B_L      0x133A96
#define REG_BK133A_4B_H      0x133A97
#define REG_BK133A_4C_L      0x133A98
#define REG_BK133A_4C_H      0x133A99
#define REG_BK133A_4D_L      0x133A9A
#define REG_BK133A_4D_H      0x133A9B
#define REG_BK133A_4E_L      0x133A9C
#define REG_BK133A_4E_H      0x133A9D
#define REG_BK133A_4F_L      0x133A9E
#define REG_BK133A_4F_H      0x133A9F
#define REG_BK133A_50_L      0x133AA0
#define REG_BK133A_50_H      0x133AA1
#define REG_BK133A_51_L      0x133AA2
#define REG_BK133A_51_H      0x133AA3
#define REG_BK133A_52_L      0x133AA4
#define REG_BK133A_52_H      0x133AA5
#define REG_BK133A_53_L      0x133AA6
#define REG_BK133A_53_H      0x133AA7
#define REG_BK133A_54_L      0x133AA8
#define REG_BK133A_54_H      0x133AA9
#define REG_BK133A_55_L      0x133AAA
#define REG_BK133A_55_H      0x133AAB
#define REG_BK133A_56_L      0x133AAC
#define REG_BK133A_56_H      0x133AAD
#define REG_BK133A_57_L      0x133AAE
#define REG_BK133A_57_H      0x133AAF
#define REG_BK133A_58_L      0x133AB0
#define REG_BK133A_58_H      0x133AB1
#define REG_BK133A_59_L      0x133AB2
#define REG_BK133A_59_H      0x133AB3
#define REG_BK133A_5A_L      0x133AB4
#define REG_BK133A_5A_H      0x133AB5
#define REG_BK133A_5B_L      0x133AB6
#define REG_BK133A_5B_H      0x133AB7
#define REG_BK133A_5C_L      0x133AB8
#define REG_BK133A_5C_H      0x133AB9
#define REG_BK133A_5D_L      0x133ABA
#define REG_BK133A_5D_H      0x133ABB
#define REG_BK133A_5E_L      0x133ABC
#define REG_BK133A_5E_H      0x133ABD
#define REG_BK133A_5F_L      0x133ABE
#define REG_BK133A_5F_H      0x133ABF
#define REG_BK133A_60_L      0x133AC0
#define REG_BK133A_60_H      0x133AC1
#define REG_BK133A_61_L      0x133AC2
#define REG_BK133A_61_H      0x133AC3
#define REG_BK133A_62_L      0x133AC4
#define REG_BK133A_62_H      0x133AC5
#define REG_BK133A_63_L      0x133AC6
#define REG_BK133A_63_H      0x133AC7
#define REG_BK133A_64_L      0x133AC8
#define REG_BK133A_64_H      0x133AC9
#define REG_BK133A_65_L      0x133ACA
#define REG_BK133A_65_H      0x133ACB
#define REG_BK133A_66_L      0x133ACC
#define REG_BK133A_66_H      0x133ACD
#define REG_BK133A_67_L      0x133ACE
#define REG_BK133A_67_H      0x133ACF
#define REG_BK133A_68_L      0x133AD0
#define REG_BK133A_68_H      0x133AD1
#define REG_BK133A_69_L      0x133AD2
#define REG_BK133A_69_H      0x133AD3
#define REG_BK133A_6A_L      0x133AD4
#define REG_BK133A_6A_H      0x133AD5
#define REG_BK133A_6B_L      0x133AD6
#define REG_BK133A_6B_H      0x133AD7
#define REG_BK133A_6C_L      0x133AD8
#define REG_BK133A_6C_H      0x133AD9
#define REG_BK133A_6D_L      0x133ADA
#define REG_BK133A_6D_H      0x133ADB
#define REG_BK133A_6E_L      0x133ADC
#define REG_BK133A_6E_H      0x133ADD
#define REG_BK133A_6F_L      0x133ADE
#define REG_BK133A_6F_H      0x133ADF
#define REG_BK133A_70_L      0x133AE0
#define REG_BK133A_70_H      0x133AE1
#define REG_BK133A_71_L      0x133AE2
#define REG_BK133A_71_H      0x133AE3
#define REG_BK133A_72_L      0x133AE4
#define REG_BK133A_72_H      0x133AE5
#define REG_BK133A_73_L      0x133AE6
#define REG_BK133A_73_H      0x133AE7
#define REG_BK133A_74_L      0x133AE8
#define REG_BK133A_74_H      0x133AE9
#define REG_BK133A_75_L      0x133AEA
#define REG_BK133A_75_H      0x133AEB
#define REG_BK133A_76_L      0x133AEC
#define REG_BK133A_76_H      0x133AED
#define REG_BK133A_77_L      0x133AEE
#define REG_BK133A_77_H      0x133AEF
#define REG_BK133A_78_L      0x133AF0
#define REG_BK133A_78_H      0x133AF1
#define REG_BK133A_79_L      0x133AF2
#define REG_BK133A_79_H      0x133AF3
#define REG_BK133A_7A_L      0x133AF4
#define REG_BK133A_7A_H      0x133AF5
#define REG_BK133A_7B_L      0x133AF6
#define REG_BK133A_7B_H      0x133AF7
#define REG_BK133A_7C_L      0x133AF8
#define REG_BK133A_7C_H      0x133AF9
#define REG_BK133A_7D_L      0x133AFA
#define REG_BK133A_7D_H      0x133AFB
#define REG_BK133A_7E_L      0x133AFC
#define REG_BK133A_7E_H      0x133AFD
#define REG_BK133A_7F_L      0x133AFE
#define REG_BK133A_7F_H      0x133AFF
//----------------------------------------------
#define REG_BK1345_00_L      0x134500
#define REG_BK1345_00_H      0x134501
#define REG_BK1345_01_L      0x134502
#define REG_BK1345_01_H      0x134503
#define REG_BK1345_02_L      0x134504
#define REG_BK1345_02_H      0x134505
#define REG_BK1345_03_L      0x134506
#define REG_BK1345_03_H      0x134507
#define REG_BK1345_04_L      0x134508
#define REG_BK1345_04_H      0x134509
#define REG_BK1345_05_L      0x13450A
#define REG_BK1345_05_H      0x13450B
#define REG_BK1345_06_L      0x13450C
#define REG_BK1345_06_H      0x13450D
#define REG_BK1345_07_L      0x13450E
#define REG_BK1345_07_H      0x13450F
#define REG_BK1345_08_L      0x134510
#define REG_BK1345_08_H      0x134511
#define REG_BK1345_09_L      0x134512
#define REG_BK1345_09_H      0x134513
#define REG_BK1345_0A_L      0x134514
#define REG_BK1345_0A_H      0x134515
#define REG_BK1345_0B_L      0x134516
#define REG_BK1345_0B_H      0x134517
#define REG_BK1345_0C_L      0x134518
#define REG_BK1345_0C_H      0x134519
#define REG_BK1345_0D_L      0x13451A
#define REG_BK1345_0D_H      0x13451B
#define REG_BK1345_0E_L      0x13451C
#define REG_BK1345_0E_H      0x13451D
#define REG_BK1345_0F_L      0x13451E
#define REG_BK1345_0F_H      0x13451F
#define REG_BK1345_10_L      0x134520
#define REG_BK1345_10_H      0x134521
#define REG_BK1345_11_L      0x134522
#define REG_BK1345_11_H      0x134523
#define REG_BK1345_12_L      0x134524
#define REG_BK1345_12_H      0x134525
#define REG_BK1345_13_L      0x134526
#define REG_BK1345_13_H      0x134527
#define REG_BK1345_14_L      0x134528
#define REG_BK1345_14_H      0x134529
#define REG_BK1345_15_L      0x13452A
#define REG_BK1345_15_H      0x13452B
#define REG_BK1345_16_L      0x13452C
#define REG_BK1345_16_H      0x13452D
#define REG_BK1345_17_L      0x13452E
#define REG_BK1345_17_H      0x13452F
#define REG_BK1345_18_L      0x134530
#define REG_BK1345_18_H      0x134531
#define REG_BK1345_19_L      0x134532
#define REG_BK1345_19_H      0x134533
#define REG_BK1345_1A_L      0x134534
#define REG_BK1345_1A_H      0x134535
#define REG_BK1345_1B_L      0x134536
#define REG_BK1345_1B_H      0x134537
#define REG_BK1345_1C_L      0x134538
#define REG_BK1345_1C_H      0x134539
#define REG_BK1345_1D_L      0x13453A
#define REG_BK1345_1D_H      0x13453B
#define REG_BK1345_1E_L      0x13453C
#define REG_BK1345_1E_H      0x13453D
#define REG_BK1345_1F_L      0x13453E
#define REG_BK1345_1F_H      0x13453F
#define REG_BK1345_20_L      0x134540
#define REG_BK1345_20_H      0x134541
#define REG_BK1345_21_L      0x134542
#define REG_BK1345_21_H      0x134543
#define REG_BK1345_22_L      0x134544
#define REG_BK1345_22_H      0x134545
#define REG_BK1345_23_L      0x134546
#define REG_BK1345_23_H      0x134547
#define REG_BK1345_24_L      0x134548
#define REG_BK1345_24_H      0x134549
#define REG_BK1345_25_L      0x13454A
#define REG_BK1345_25_H      0x13454B
#define REG_BK1345_26_L      0x13454C
#define REG_BK1345_26_H      0x13454D
#define REG_BK1345_27_L      0x13454E
#define REG_BK1345_27_H      0x13454F
#define REG_BK1345_28_L      0x134550
#define REG_BK1345_28_H      0x134551
#define REG_BK1345_29_L      0x134552
#define REG_BK1345_29_H      0x134553
#define REG_BK1345_2A_L      0x134554
#define REG_BK1345_2A_H      0x134555
#define REG_BK1345_2B_L      0x134556
#define REG_BK1345_2B_H      0x134557
#define REG_BK1345_2C_L      0x134558
#define REG_BK1345_2C_H      0x134559
#define REG_BK1345_2D_L      0x13455A
#define REG_BK1345_2D_H      0x13455B
#define REG_BK1345_2E_L      0x13455C
#define REG_BK1345_2E_H      0x13455D
#define REG_BK1345_2F_L      0x13455E
#define REG_BK1345_2F_H      0x13455F
#define REG_BK1345_30_L      0x134560
#define REG_BK1345_30_H      0x134561
#define REG_BK1345_31_L      0x134562
#define REG_BK1345_31_H      0x134563
#define REG_BK1345_32_L      0x134564
#define REG_BK1345_32_H      0x134565
#define REG_BK1345_33_L      0x134566
#define REG_BK1345_33_H      0x134567
#define REG_BK1345_34_L      0x134568
#define REG_BK1345_34_H      0x134569
#define REG_BK1345_35_L      0x13456A
#define REG_BK1345_35_H      0x13456B
#define REG_BK1345_36_L      0x13456C
#define REG_BK1345_36_H      0x13456D
#define REG_BK1345_37_L      0x13456E
#define REG_BK1345_37_H      0x13456F
#define REG_BK1345_38_L      0x134570
#define REG_BK1345_38_H      0x134571
#define REG_BK1345_39_L      0x134572
#define REG_BK1345_39_H      0x134573
#define REG_BK1345_3A_L      0x134574
#define REG_BK1345_3A_H      0x134575
#define REG_BK1345_3B_L      0x134576
#define REG_BK1345_3B_H      0x134577
#define REG_BK1345_3C_L      0x134578
#define REG_BK1345_3C_H      0x134579
#define REG_BK1345_3D_L      0x13457A
#define REG_BK1345_3D_H      0x13457B
#define REG_BK1345_3E_L      0x13457C
#define REG_BK1345_3E_H      0x13457D
#define REG_BK1345_3F_L      0x13457E
#define REG_BK1345_3F_H      0x13457F
#define REG_BK1345_40_L      0x134580
#define REG_BK1345_40_H      0x134581
#define REG_BK1345_41_L      0x134582
#define REG_BK1345_41_H      0x134583
#define REG_BK1345_42_L      0x134584
#define REG_BK1345_42_H      0x134585
#define REG_BK1345_43_L      0x134586
#define REG_BK1345_43_H      0x134587
#define REG_BK1345_44_L      0x134588
#define REG_BK1345_44_H      0x134589
#define REG_BK1345_45_L      0x13458A
#define REG_BK1345_45_H      0x13458B
#define REG_BK1345_46_L      0x13458C
#define REG_BK1345_46_H      0x13458D
#define REG_BK1345_47_L      0x13458E
#define REG_BK1345_47_H      0x13458F
#define REG_BK1345_48_L      0x134590
#define REG_BK1345_48_H      0x134591
#define REG_BK1345_49_L      0x134592
#define REG_BK1345_49_H      0x134593
#define REG_BK1345_4A_L      0x134594
#define REG_BK1345_4A_H      0x134595
#define REG_BK1345_4B_L      0x134596
#define REG_BK1345_4B_H      0x134597
#define REG_BK1345_4C_L      0x134598
#define REG_BK1345_4C_H      0x134599
#define REG_BK1345_4D_L      0x13459A
#define REG_BK1345_4D_H      0x13459B
#define REG_BK1345_4E_L      0x13459C
#define REG_BK1345_4E_H      0x13459D
#define REG_BK1345_4F_L      0x13459E
#define REG_BK1345_4F_H      0x13459F
#define REG_BK1345_50_L      0x1345A0
#define REG_BK1345_50_H      0x1345A1
#define REG_BK1345_51_L      0x1345A2
#define REG_BK1345_51_H      0x1345A3
#define REG_BK1345_52_L      0x1345A4
#define REG_BK1345_52_H      0x1345A5
#define REG_BK1345_53_L      0x1345A6
#define REG_BK1345_53_H      0x1345A7
#define REG_BK1345_54_L      0x1345A8
#define REG_BK1345_54_H      0x1345A9
#define REG_BK1345_55_L      0x1345AA
#define REG_BK1345_55_H      0x1345AB
#define REG_BK1345_56_L      0x1345AC
#define REG_BK1345_56_H      0x1345AD
#define REG_BK1345_57_L      0x1345AE
#define REG_BK1345_57_H      0x1345AF
#define REG_BK1345_58_L      0x1345B0
#define REG_BK1345_58_H      0x1345B1
#define REG_BK1345_59_L      0x1345B2
#define REG_BK1345_59_H      0x1345B3
#define REG_BK1345_5A_L      0x1345B4
#define REG_BK1345_5A_H      0x1345B5
#define REG_BK1345_5B_L      0x1345B6
#define REG_BK1345_5B_H      0x1345B7
#define REG_BK1345_5C_L      0x1345B8
#define REG_BK1345_5C_H      0x1345B9
#define REG_BK1345_5D_L      0x1345BA
#define REG_BK1345_5D_H      0x1345BB
#define REG_BK1345_5E_L      0x1345BC
#define REG_BK1345_5E_H      0x1345BD
#define REG_BK1345_5F_L      0x1345BE
#define REG_BK1345_5F_H      0x1345BF
#define REG_BK1345_60_L      0x1345C0
#define REG_BK1345_60_H      0x1345C1
#define REG_BK1345_61_L      0x1345C2
#define REG_BK1345_61_H      0x1345C3
#define REG_BK1345_62_L      0x1345C4
#define REG_BK1345_62_H      0x1345C5
#define REG_BK1345_63_L      0x1345C6
#define REG_BK1345_63_H      0x1345C7
#define REG_BK1345_64_L      0x1345C8
#define REG_BK1345_64_H      0x1345C9
#define REG_BK1345_65_L      0x1345CA
#define REG_BK1345_65_H      0x1345CB
#define REG_BK1345_66_L      0x1345CC
#define REG_BK1345_66_H      0x1345CD
#define REG_BK1345_67_L      0x1345CE
#define REG_BK1345_67_H      0x1345CF
#define REG_BK1345_68_L      0x1345D0
#define REG_BK1345_68_H      0x1345D1
#define REG_BK1345_69_L      0x1345D2
#define REG_BK1345_69_H      0x1345D3
#define REG_BK1345_6A_L      0x1345D4
#define REG_BK1345_6A_H      0x1345D5
#define REG_BK1345_6B_L      0x1345D6
#define REG_BK1345_6B_H      0x1345D7
#define REG_BK1345_6C_L      0x1345D8
#define REG_BK1345_6C_H      0x1345D9
#define REG_BK1345_6D_L      0x1345DA
#define REG_BK1345_6D_H      0x1345DB
#define REG_BK1345_6E_L      0x1345DC
#define REG_BK1345_6E_H      0x1345DD
#define REG_BK1345_6F_L      0x1345DE
#define REG_BK1345_6F_H      0x1345DF
#define REG_BK1345_70_L      0x1345E0
#define REG_BK1345_70_H      0x1345E1
#define REG_BK1345_71_L      0x1345E2
#define REG_BK1345_71_H      0x1345E3
#define REG_BK1345_72_L      0x1345E4
#define REG_BK1345_72_H      0x1345E5
#define REG_BK1345_73_L      0x1345E6
#define REG_BK1345_73_H      0x1345E7
#define REG_BK1345_74_L      0x1345E8
#define REG_BK1345_74_H      0x1345E9
#define REG_BK1345_75_L      0x1345EA
#define REG_BK1345_75_H      0x1345EB
#define REG_BK1345_76_L      0x1345EC
#define REG_BK1345_76_H      0x1345ED
#define REG_BK1345_77_L      0x1345EE
#define REG_BK1345_77_H      0x1345EF
#define REG_BK1345_78_L      0x1345F0
#define REG_BK1345_78_H      0x1345F1
#define REG_BK1345_79_L      0x1345F2
#define REG_BK1345_79_H      0x1345F3
#define REG_BK1345_7A_L      0x1345F4
#define REG_BK1345_7A_H      0x1345F5
#define REG_BK1345_7B_L      0x1345F6
#define REG_BK1345_7B_H      0x1345F7
#define REG_BK1345_7C_L      0x1345F8
#define REG_BK1345_7C_H      0x1345F9
#define REG_BK1345_7D_L      0x1345FA
#define REG_BK1345_7D_H      0x1345FB
#define REG_BK1345_7E_L      0x1345FC
#define REG_BK1345_7E_H      0x1345FD
#define REG_BK1345_7F_L      0x1345FE
#define REG_BK1345_7F_H      0x1345FF
//----------------------------------------------
#define REG_BK1346_00_L      0x134600
#define REG_BK1346_00_H      0x134601
#define REG_BK1346_01_L      0x134602
#define REG_BK1346_01_H      0x134603
#define REG_BK1346_02_L      0x134604
#define REG_BK1346_02_H      0x134605
#define REG_BK1346_03_L      0x134606
#define REG_BK1346_03_H      0x134607
#define REG_BK1346_04_L      0x134608
#define REG_BK1346_04_H      0x134609
#define REG_BK1346_05_L      0x13460A
#define REG_BK1346_05_H      0x13460B
#define REG_BK1346_06_L      0x13460C
#define REG_BK1346_06_H      0x13460D
#define REG_BK1346_07_L      0x13460E
#define REG_BK1346_07_H      0x13460F
#define REG_BK1346_08_L      0x134610
#define REG_BK1346_08_H      0x134611
#define REG_BK1346_09_L      0x134612
#define REG_BK1346_09_H      0x134613
#define REG_BK1346_0A_L      0x134614
#define REG_BK1346_0A_H      0x134615
#define REG_BK1346_0B_L      0x134616
#define REG_BK1346_0B_H      0x134617
#define REG_BK1346_0C_L      0x134618
#define REG_BK1346_0C_H      0x134619
#define REG_BK1346_0D_L      0x13461A
#define REG_BK1346_0D_H      0x13461B
#define REG_BK1346_0E_L      0x13461C
#define REG_BK1346_0E_H      0x13461D
#define REG_BK1346_0F_L      0x13461E
#define REG_BK1346_0F_H      0x13461F
#define REG_BK1346_10_L      0x134620
#define REG_BK1346_10_H      0x134621
#define REG_BK1346_11_L      0x134622
#define REG_BK1346_11_H      0x134623
#define REG_BK1346_12_L      0x134624
#define REG_BK1346_12_H      0x134625
#define REG_BK1346_13_L      0x134626
#define REG_BK1346_13_H      0x134627
#define REG_BK1346_14_L      0x134628
#define REG_BK1346_14_H      0x134629
#define REG_BK1346_15_L      0x13462A
#define REG_BK1346_15_H      0x13462B
#define REG_BK1346_16_L      0x13462C
#define REG_BK1346_16_H      0x13462D
#define REG_BK1346_17_L      0x13462E
#define REG_BK1346_17_H      0x13462F
#define REG_BK1346_18_L      0x134630
#define REG_BK1346_18_H      0x134631
#define REG_BK1346_19_L      0x134632
#define REG_BK1346_19_H      0x134633
#define REG_BK1346_1A_L      0x134634
#define REG_BK1346_1A_H      0x134635
#define REG_BK1346_1B_L      0x134636
#define REG_BK1346_1B_H      0x134637
#define REG_BK1346_1C_L      0x134638
#define REG_BK1346_1C_H      0x134639
#define REG_BK1346_1D_L      0x13463A
#define REG_BK1346_1D_H      0x13463B
#define REG_BK1346_1E_L      0x13463C
#define REG_BK1346_1E_H      0x13463D
#define REG_BK1346_1F_L      0x13463E
#define REG_BK1346_1F_H      0x13463F
#define REG_BK1346_20_L      0x134640
#define REG_BK1346_20_H      0x134641
#define REG_BK1346_21_L      0x134642
#define REG_BK1346_21_H      0x134643
#define REG_BK1346_22_L      0x134644
#define REG_BK1346_22_H      0x134645
#define REG_BK1346_23_L      0x134646
#define REG_BK1346_23_H      0x134647
#define REG_BK1346_24_L      0x134648
#define REG_BK1346_24_H      0x134649
#define REG_BK1346_25_L      0x13464A
#define REG_BK1346_25_H      0x13464B
#define REG_BK1346_26_L      0x13464C
#define REG_BK1346_26_H      0x13464D
#define REG_BK1346_27_L      0x13464E
#define REG_BK1346_27_H      0x13464F
#define REG_BK1346_28_L      0x134650
#define REG_BK1346_28_H      0x134651
#define REG_BK1346_29_L      0x134652
#define REG_BK1346_29_H      0x134653
#define REG_BK1346_2A_L      0x134654
#define REG_BK1346_2A_H      0x134655
#define REG_BK1346_2B_L      0x134656
#define REG_BK1346_2B_H      0x134657
#define REG_BK1346_2C_L      0x134658
#define REG_BK1346_2C_H      0x134659
#define REG_BK1346_2D_L      0x13465A
#define REG_BK1346_2D_H      0x13465B
#define REG_BK1346_2E_L      0x13465C
#define REG_BK1346_2E_H      0x13465D
#define REG_BK1346_2F_L      0x13465E
#define REG_BK1346_2F_H      0x13465F
#define REG_BK1346_30_L      0x134660
#define REG_BK1346_30_H      0x134661
#define REG_BK1346_31_L      0x134662
#define REG_BK1346_31_H      0x134663
#define REG_BK1346_32_L      0x134664
#define REG_BK1346_32_H      0x134665
#define REG_BK1346_33_L      0x134666
#define REG_BK1346_33_H      0x134667
#define REG_BK1346_34_L      0x134668
#define REG_BK1346_34_H      0x134669
#define REG_BK1346_35_L      0x13466A
#define REG_BK1346_35_H      0x13466B
#define REG_BK1346_36_L      0x13466C
#define REG_BK1346_36_H      0x13466D
#define REG_BK1346_37_L      0x13466E
#define REG_BK1346_37_H      0x13466F
#define REG_BK1346_38_L      0x134670
#define REG_BK1346_38_H      0x134671
#define REG_BK1346_39_L      0x134672
#define REG_BK1346_39_H      0x134673
#define REG_BK1346_3A_L      0x134674
#define REG_BK1346_3A_H      0x134675
#define REG_BK1346_3B_L      0x134676
#define REG_BK1346_3B_H      0x134677
#define REG_BK1346_3C_L      0x134678
#define REG_BK1346_3C_H      0x134679
#define REG_BK1346_3D_L      0x13467A
#define REG_BK1346_3D_H      0x13467B
#define REG_BK1346_3E_L      0x13467C
#define REG_BK1346_3E_H      0x13467D
#define REG_BK1346_3F_L      0x13467E
#define REG_BK1346_3F_H      0x13467F
#define REG_BK1346_40_L      0x134680
#define REG_BK1346_40_H      0x134681
#define REG_BK1346_41_L      0x134682
#define REG_BK1346_41_H      0x134683
#define REG_BK1346_42_L      0x134684
#define REG_BK1346_42_H      0x134685
#define REG_BK1346_43_L      0x134686
#define REG_BK1346_43_H      0x134687
#define REG_BK1346_44_L      0x134688
#define REG_BK1346_44_H      0x134689
#define REG_BK1346_45_L      0x13468A
#define REG_BK1346_45_H      0x13468B
#define REG_BK1346_46_L      0x13468C
#define REG_BK1346_46_H      0x13468D
#define REG_BK1346_47_L      0x13468E
#define REG_BK1346_47_H      0x13468F
#define REG_BK1346_48_L      0x134690
#define REG_BK1346_48_H      0x134691
#define REG_BK1346_49_L      0x134692
#define REG_BK1346_49_H      0x134693
#define REG_BK1346_4A_L      0x134694
#define REG_BK1346_4A_H      0x134695
#define REG_BK1346_4B_L      0x134696
#define REG_BK1346_4B_H      0x134697
#define REG_BK1346_4C_L      0x134698
#define REG_BK1346_4C_H      0x134699
#define REG_BK1346_4D_L      0x13469A
#define REG_BK1346_4D_H      0x13469B
#define REG_BK1346_4E_L      0x13469C
#define REG_BK1346_4E_H      0x13469D
#define REG_BK1346_4F_L      0x13469E
#define REG_BK1346_4F_H      0x13469F
#define REG_BK1346_50_L      0x1346A0
#define REG_BK1346_50_H      0x1346A1
#define REG_BK1346_51_L      0x1346A2
#define REG_BK1346_51_H      0x1346A3
#define REG_BK1346_52_L      0x1346A4
#define REG_BK1346_52_H      0x1346A5
#define REG_BK1346_53_L      0x1346A6
#define REG_BK1346_53_H      0x1346A7
#define REG_BK1346_54_L      0x1346A8
#define REG_BK1346_54_H      0x1346A9
#define REG_BK1346_55_L      0x1346AA
#define REG_BK1346_55_H      0x1346AB
#define REG_BK1346_56_L      0x1346AC
#define REG_BK1346_56_H      0x1346AD
#define REG_BK1346_57_L      0x1346AE
#define REG_BK1346_57_H      0x1346AF
#define REG_BK1346_58_L      0x1346B0
#define REG_BK1346_58_H      0x1346B1
#define REG_BK1346_59_L      0x1346B2
#define REG_BK1346_59_H      0x1346B3
#define REG_BK1346_5A_L      0x1346B4
#define REG_BK1346_5A_H      0x1346B5
#define REG_BK1346_5B_L      0x1346B6
#define REG_BK1346_5B_H      0x1346B7
#define REG_BK1346_5C_L      0x1346B8
#define REG_BK1346_5C_H      0x1346B9
#define REG_BK1346_5D_L      0x1346BA
#define REG_BK1346_5D_H      0x1346BB
#define REG_BK1346_5E_L      0x1346BC
#define REG_BK1346_5E_H      0x1346BD
#define REG_BK1346_5F_L      0x1346BE
#define REG_BK1346_5F_H      0x1346BF
#define REG_BK1346_60_L      0x1346C0
#define REG_BK1346_60_H      0x1346C1
#define REG_BK1346_61_L      0x1346C2
#define REG_BK1346_61_H      0x1346C3
#define REG_BK1346_62_L      0x1346C4
#define REG_BK1346_62_H      0x1346C5
#define REG_BK1346_63_L      0x1346C6
#define REG_BK1346_63_H      0x1346C7
#define REG_BK1346_64_L      0x1346C8
#define REG_BK1346_64_H      0x1346C9
#define REG_BK1346_65_L      0x1346CA
#define REG_BK1346_65_H      0x1346CB
#define REG_BK1346_66_L      0x1346CC
#define REG_BK1346_66_H      0x1346CD
#define REG_BK1346_67_L      0x1346CE
#define REG_BK1346_67_H      0x1346CF
#define REG_BK1346_68_L      0x1346D0
#define REG_BK1346_68_H      0x1346D1
#define REG_BK1346_69_L      0x1346D2
#define REG_BK1346_69_H      0x1346D3
#define REG_BK1346_6A_L      0x1346D4
#define REG_BK1346_6A_H      0x1346D5
#define REG_BK1346_6B_L      0x1346D6
#define REG_BK1346_6B_H      0x1346D7
#define REG_BK1346_6C_L      0x1346D8
#define REG_BK1346_6C_H      0x1346D9
#define REG_BK1346_6D_L      0x1346DA
#define REG_BK1346_6D_H      0x1346DB
#define REG_BK1346_6E_L      0x1346DC
#define REG_BK1346_6E_H      0x1346DD
#define REG_BK1346_6F_L      0x1346DE
#define REG_BK1346_6F_H      0x1346DF
#define REG_BK1346_70_L      0x1346E0
#define REG_BK1346_70_H      0x1346E1
#define REG_BK1346_71_L      0x1346E2
#define REG_BK1346_71_H      0x1346E3
#define REG_BK1346_72_L      0x1346E4
#define REG_BK1346_72_H      0x1346E5
#define REG_BK1346_73_L      0x1346E6
#define REG_BK1346_73_H      0x1346E7
#define REG_BK1346_74_L      0x1346E8
#define REG_BK1346_74_H      0x1346E9
#define REG_BK1346_75_L      0x1346EA
#define REG_BK1346_75_H      0x1346EB
#define REG_BK1346_76_L      0x1346EC
#define REG_BK1346_76_H      0x1346ED
#define REG_BK1346_77_L      0x1346EE
#define REG_BK1346_77_H      0x1346EF
#define REG_BK1346_78_L      0x1346F0
#define REG_BK1346_78_H      0x1346F1
#define REG_BK1346_79_L      0x1346F2
#define REG_BK1346_79_H      0x1346F3
#define REG_BK1346_7A_L      0x1346F4
#define REG_BK1346_7A_H      0x1346F5
#define REG_BK1346_7B_L      0x1346F6
#define REG_BK1346_7B_H      0x1346F7
#define REG_BK1346_7C_L      0x1346F8
#define REG_BK1346_7C_H      0x1346F9
#define REG_BK1346_7D_L      0x1346FA
#define REG_BK1346_7D_H      0x1346FB
#define REG_BK1346_7E_L      0x1346FC
#define REG_BK1346_7E_H      0x1346FD
#define REG_BK1346_7F_L      0x1346FE
#define REG_BK1346_7F_H      0x1346FF
//----------------------------------------------
#define REG_BK1347_00_L      0x134700
#define REG_BK1347_00_H      0x134701
#define REG_BK1347_01_L      0x134702
#define REG_BK1347_01_H      0x134703
#define REG_BK1347_02_L      0x134704
#define REG_BK1347_02_H      0x134705
#define REG_BK1347_03_L      0x134706
#define REG_BK1347_03_H      0x134707
#define REG_BK1347_04_L      0x134708
#define REG_BK1347_04_H      0x134709
#define REG_BK1347_05_L      0x13470A
#define REG_BK1347_05_H      0x13470B
#define REG_BK1347_06_L      0x13470C
#define REG_BK1347_06_H      0x13470D
#define REG_BK1347_07_L      0x13470E
#define REG_BK1347_07_H      0x13470F
#define REG_BK1347_08_L      0x134710
#define REG_BK1347_08_H      0x134711
#define REG_BK1347_09_L      0x134712
#define REG_BK1347_09_H      0x134713
#define REG_BK1347_0A_L      0x134714
#define REG_BK1347_0A_H      0x134715
#define REG_BK1347_0B_L      0x134716
#define REG_BK1347_0B_H      0x134717
#define REG_BK1347_0C_L      0x134718
#define REG_BK1347_0C_H      0x134719
#define REG_BK1347_0D_L      0x13471A
#define REG_BK1347_0D_H      0x13471B
#define REG_BK1347_0E_L      0x13471C
#define REG_BK1347_0E_H      0x13471D
#define REG_BK1347_0F_L      0x13471E
#define REG_BK1347_0F_H      0x13471F
#define REG_BK1347_10_L      0x134720
#define REG_BK1347_10_H      0x134721
#define REG_BK1347_11_L      0x134722
#define REG_BK1347_11_H      0x134723
#define REG_BK1347_12_L      0x134724
#define REG_BK1347_12_H      0x134725
#define REG_BK1347_13_L      0x134726
#define REG_BK1347_13_H      0x134727
#define REG_BK1347_14_L      0x134728
#define REG_BK1347_14_H      0x134729
#define REG_BK1347_15_L      0x13472A
#define REG_BK1347_15_H      0x13472B
#define REG_BK1347_16_L      0x13472C
#define REG_BK1347_16_H      0x13472D
#define REG_BK1347_17_L      0x13472E
#define REG_BK1347_17_H      0x13472F
#define REG_BK1347_18_L      0x134730
#define REG_BK1347_18_H      0x134731
#define REG_BK1347_19_L      0x134732
#define REG_BK1347_19_H      0x134733
#define REG_BK1347_1A_L      0x134734
#define REG_BK1347_1A_H      0x134735
#define REG_BK1347_1B_L      0x134736
#define REG_BK1347_1B_H      0x134737
#define REG_BK1347_1C_L      0x134738
#define REG_BK1347_1C_H      0x134739
#define REG_BK1347_1D_L      0x13473A
#define REG_BK1347_1D_H      0x13473B
#define REG_BK1347_1E_L      0x13473C
#define REG_BK1347_1E_H      0x13473D
#define REG_BK1347_1F_L      0x13473E
#define REG_BK1347_1F_H      0x13473F
#define REG_BK1347_20_L      0x134740
#define REG_BK1347_20_H      0x134741
#define REG_BK1347_21_L      0x134742
#define REG_BK1347_21_H      0x134743
#define REG_BK1347_22_L      0x134744
#define REG_BK1347_22_H      0x134745
#define REG_BK1347_23_L      0x134746
#define REG_BK1347_23_H      0x134747
#define REG_BK1347_24_L      0x134748
#define REG_BK1347_24_H      0x134749
#define REG_BK1347_25_L      0x13474A
#define REG_BK1347_25_H      0x13474B
#define REG_BK1347_26_L      0x13474C
#define REG_BK1347_26_H      0x13474D
#define REG_BK1347_27_L      0x13474E
#define REG_BK1347_27_H      0x13474F
#define REG_BK1347_28_L      0x134750
#define REG_BK1347_28_H      0x134751
#define REG_BK1347_29_L      0x134752
#define REG_BK1347_29_H      0x134753
#define REG_BK1347_2A_L      0x134754
#define REG_BK1347_2A_H      0x134755
#define REG_BK1347_2B_L      0x134756
#define REG_BK1347_2B_H      0x134757
#define REG_BK1347_2C_L      0x134758
#define REG_BK1347_2C_H      0x134759
#define REG_BK1347_2D_L      0x13475A
#define REG_BK1347_2D_H      0x13475B
#define REG_BK1347_2E_L      0x13475C
#define REG_BK1347_2E_H      0x13475D
#define REG_BK1347_2F_L      0x13475E
#define REG_BK1347_2F_H      0x13475F
#define REG_BK1347_30_L      0x134760
#define REG_BK1347_30_H      0x134761
#define REG_BK1347_31_L      0x134762
#define REG_BK1347_31_H      0x134763
#define REG_BK1347_32_L      0x134764
#define REG_BK1347_32_H      0x134765
#define REG_BK1347_33_L      0x134766
#define REG_BK1347_33_H      0x134767
#define REG_BK1347_34_L      0x134768
#define REG_BK1347_34_H      0x134769
#define REG_BK1347_35_L      0x13476A
#define REG_BK1347_35_H      0x13476B
#define REG_BK1347_36_L      0x13476C
#define REG_BK1347_36_H      0x13476D
#define REG_BK1347_37_L      0x13476E
#define REG_BK1347_37_H      0x13476F
#define REG_BK1347_38_L      0x134770
#define REG_BK1347_38_H      0x134771
#define REG_BK1347_39_L      0x134772
#define REG_BK1347_39_H      0x134773
#define REG_BK1347_3A_L      0x134774
#define REG_BK1347_3A_H      0x134775
#define REG_BK1347_3B_L      0x134776
#define REG_BK1347_3B_H      0x134777
#define REG_BK1347_3C_L      0x134778
#define REG_BK1347_3C_H      0x134779
#define REG_BK1347_3D_L      0x13477A
#define REG_BK1347_3D_H      0x13477B
#define REG_BK1347_3E_L      0x13477C
#define REG_BK1347_3E_H      0x13477D
#define REG_BK1347_3F_L      0x13477E
#define REG_BK1347_3F_H      0x13477F
#define REG_BK1347_40_L      0x134780
#define REG_BK1347_40_H      0x134781
#define REG_BK1347_41_L      0x134782
#define REG_BK1347_41_H      0x134783
#define REG_BK1347_42_L      0x134784
#define REG_BK1347_42_H      0x134785
#define REG_BK1347_43_L      0x134786
#define REG_BK1347_43_H      0x134787
#define REG_BK1347_44_L      0x134788
#define REG_BK1347_44_H      0x134789
#define REG_BK1347_45_L      0x13478A
#define REG_BK1347_45_H      0x13478B
#define REG_BK1347_46_L      0x13478C
#define REG_BK1347_46_H      0x13478D
#define REG_BK1347_47_L      0x13478E
#define REG_BK1347_47_H      0x13478F
#define REG_BK1347_48_L      0x134790
#define REG_BK1347_48_H      0x134791
#define REG_BK1347_49_L      0x134792
#define REG_BK1347_49_H      0x134793
#define REG_BK1347_4A_L      0x134794
#define REG_BK1347_4A_H      0x134795
#define REG_BK1347_4B_L      0x134796
#define REG_BK1347_4B_H      0x134797
#define REG_BK1347_4C_L      0x134798
#define REG_BK1347_4C_H      0x134799
#define REG_BK1347_4D_L      0x13479A
#define REG_BK1347_4D_H      0x13479B
#define REG_BK1347_4E_L      0x13479C
#define REG_BK1347_4E_H      0x13479D
#define REG_BK1347_4F_L      0x13479E
#define REG_BK1347_4F_H      0x13479F
#define REG_BK1347_50_L      0x1347A0
#define REG_BK1347_50_H      0x1347A1
#define REG_BK1347_51_L      0x1347A2
#define REG_BK1347_51_H      0x1347A3
#define REG_BK1347_52_L      0x1347A4
#define REG_BK1347_52_H      0x1347A5
#define REG_BK1347_53_L      0x1347A6
#define REG_BK1347_53_H      0x1347A7
#define REG_BK1347_54_L      0x1347A8
#define REG_BK1347_54_H      0x1347A9
#define REG_BK1347_55_L      0x1347AA
#define REG_BK1347_55_H      0x1347AB
#define REG_BK1347_56_L      0x1347AC
#define REG_BK1347_56_H      0x1347AD
#define REG_BK1347_57_L      0x1347AE
#define REG_BK1347_57_H      0x1347AF
#define REG_BK1347_58_L      0x1347B0
#define REG_BK1347_58_H      0x1347B1
#define REG_BK1347_59_L      0x1347B2
#define REG_BK1347_59_H      0x1347B3
#define REG_BK1347_5A_L      0x1347B4
#define REG_BK1347_5A_H      0x1347B5
#define REG_BK1347_5B_L      0x1347B6
#define REG_BK1347_5B_H      0x1347B7
#define REG_BK1347_5C_L      0x1347B8
#define REG_BK1347_5C_H      0x1347B9
#define REG_BK1347_5D_L      0x1347BA
#define REG_BK1347_5D_H      0x1347BB
#define REG_BK1347_5E_L      0x1347BC
#define REG_BK1347_5E_H      0x1347BD
#define REG_BK1347_5F_L      0x1347BE
#define REG_BK1347_5F_H      0x1347BF
#define REG_BK1347_60_L      0x1347C0
#define REG_BK1347_60_H      0x1347C1
#define REG_BK1347_61_L      0x1347C2
#define REG_BK1347_61_H      0x1347C3
#define REG_BK1347_62_L      0x1347C4
#define REG_BK1347_62_H      0x1347C5
#define REG_BK1347_63_L      0x1347C6
#define REG_BK1347_63_H      0x1347C7
#define REG_BK1347_64_L      0x1347C8
#define REG_BK1347_64_H      0x1347C9
#define REG_BK1347_65_L      0x1347CA
#define REG_BK1347_65_H      0x1347CB
#define REG_BK1347_66_L      0x1347CC
#define REG_BK1347_66_H      0x1347CD
#define REG_BK1347_67_L      0x1347CE
#define REG_BK1347_67_H      0x1347CF
#define REG_BK1347_68_L      0x1347D0
#define REG_BK1347_68_H      0x1347D1
#define REG_BK1347_69_L      0x1347D2
#define REG_BK1347_69_H      0x1347D3
#define REG_BK1347_6A_L      0x1347D4
#define REG_BK1347_6A_H      0x1347D5
#define REG_BK1347_6B_L      0x1347D6
#define REG_BK1347_6B_H      0x1347D7
#define REG_BK1347_6C_L      0x1347D8
#define REG_BK1347_6C_H      0x1347D9
#define REG_BK1347_6D_L      0x1347DA
#define REG_BK1347_6D_H      0x1347DB
#define REG_BK1347_6E_L      0x1347DC
#define REG_BK1347_6E_H      0x1347DD
#define REG_BK1347_6F_L      0x1347DE
#define REG_BK1347_6F_H      0x1347DF
#define REG_BK1347_70_L      0x1347E0
#define REG_BK1347_70_H      0x1347E1
#define REG_BK1347_71_L      0x1347E2
#define REG_BK1347_71_H      0x1347E3
#define REG_BK1347_72_L      0x1347E4
#define REG_BK1347_72_H      0x1347E5
#define REG_BK1347_73_L      0x1347E6
#define REG_BK1347_73_H      0x1347E7
#define REG_BK1347_74_L      0x1347E8
#define REG_BK1347_74_H      0x1347E9
#define REG_BK1347_75_L      0x1347EA
#define REG_BK1347_75_H      0x1347EB
#define REG_BK1347_76_L      0x1347EC
#define REG_BK1347_76_H      0x1347ED
#define REG_BK1347_77_L      0x1347EE
#define REG_BK1347_77_H      0x1347EF
#define REG_BK1347_78_L      0x1347F0
#define REG_BK1347_78_H      0x1347F1
#define REG_BK1347_79_L      0x1347F2
#define REG_BK1347_79_H      0x1347F3
#define REG_BK1347_7A_L      0x1347F4
#define REG_BK1347_7A_H      0x1347F5
#define REG_BK1347_7B_L      0x1347F6
#define REG_BK1347_7B_H      0x1347F7
#define REG_BK1347_7C_L      0x1347F8
#define REG_BK1347_7C_H      0x1347F9
#define REG_BK1347_7D_L      0x1347FA
#define REG_BK1347_7D_H      0x1347FB
#define REG_BK1347_7E_L      0x1347FC
#define REG_BK1347_7E_H      0x1347FD
#define REG_BK1347_7F_L      0x1347FE
#define REG_BK1347_7F_H      0x1347FF
//----------------------------------------------
#define REG_BK134A_00_L      0x134A00
#define REG_BK134A_00_H      0x134A01
#define REG_BK134A_01_L      0x134A02
#define REG_BK134A_01_H      0x134A03
#define REG_BK134A_02_L      0x134A04
#define REG_BK134A_02_H      0x134A05
#define REG_BK134A_03_L      0x134A06
#define REG_BK134A_03_H      0x134A07
#define REG_BK134A_04_L      0x134A08
#define REG_BK134A_04_H      0x134A09
#define REG_BK134A_05_L      0x134A0A
#define REG_BK134A_05_H      0x134A0B
#define REG_BK134A_06_L      0x134A0C
#define REG_BK134A_06_H      0x134A0D
#define REG_BK134A_07_L      0x134A0E
#define REG_BK134A_07_H      0x134A0F
#define REG_BK134A_08_L      0x134A10
#define REG_BK134A_08_H      0x134A11
#define REG_BK134A_09_L      0x134A12
#define REG_BK134A_09_H      0x134A13
#define REG_BK134A_0A_L      0x134A14
#define REG_BK134A_0A_H      0x134A15
#define REG_BK134A_0B_L      0x134A16
#define REG_BK134A_0B_H      0x134A17
#define REG_BK134A_0C_L      0x134A18
#define REG_BK134A_0C_H      0x134A19
#define REG_BK134A_0D_L      0x134A1A
#define REG_BK134A_0D_H      0x134A1B
#define REG_BK134A_0E_L      0x134A1C
#define REG_BK134A_0E_H      0x134A1D
#define REG_BK134A_0F_L      0x134A1E
#define REG_BK134A_0F_H      0x134A1F
#define REG_BK134A_10_L      0x134A20
#define REG_BK134A_10_H      0x134A21
#define REG_BK134A_11_L      0x134A22
#define REG_BK134A_11_H      0x134A23
#define REG_BK134A_12_L      0x134A24
#define REG_BK134A_12_H      0x134A25
#define REG_BK134A_13_L      0x134A26
#define REG_BK134A_13_H      0x134A27
#define REG_BK134A_14_L      0x134A28
#define REG_BK134A_14_H      0x134A29
#define REG_BK134A_15_L      0x134A2A
#define REG_BK134A_15_H      0x134A2B
#define REG_BK134A_16_L      0x134A2C
#define REG_BK134A_16_H      0x134A2D
#define REG_BK134A_17_L      0x134A2E
#define REG_BK134A_17_H      0x134A2F
#define REG_BK134A_18_L      0x134A30
#define REG_BK134A_18_H      0x134A31
#define REG_BK134A_19_L      0x134A32
#define REG_BK134A_19_H      0x134A33
#define REG_BK134A_1A_L      0x134A34
#define REG_BK134A_1A_H      0x134A35
#define REG_BK134A_1B_L      0x134A36
#define REG_BK134A_1B_H      0x134A37
#define REG_BK134A_1C_L      0x134A38
#define REG_BK134A_1C_H      0x134A39
#define REG_BK134A_1D_L      0x134A3A
#define REG_BK134A_1D_H      0x134A3B
#define REG_BK134A_1E_L      0x134A3C
#define REG_BK134A_1E_H      0x134A3D
#define REG_BK134A_1F_L      0x134A3E
#define REG_BK134A_1F_H      0x134A3F
#define REG_BK134A_20_L      0x134A40
#define REG_BK134A_20_H      0x134A41
#define REG_BK134A_21_L      0x134A42
#define REG_BK134A_21_H      0x134A43
#define REG_BK134A_22_L      0x134A44
#define REG_BK134A_22_H      0x134A45
#define REG_BK134A_23_L      0x134A46
#define REG_BK134A_23_H      0x134A47
#define REG_BK134A_24_L      0x134A48
#define REG_BK134A_24_H      0x134A49
#define REG_BK134A_25_L      0x134A4A
#define REG_BK134A_25_H      0x134A4B
#define REG_BK134A_26_L      0x134A4C
#define REG_BK134A_26_H      0x134A4D
#define REG_BK134A_27_L      0x134A4E
#define REG_BK134A_27_H      0x134A4F
#define REG_BK134A_28_L      0x134A50
#define REG_BK134A_28_H      0x134A51
#define REG_BK134A_29_L      0x134A52
#define REG_BK134A_29_H      0x134A53
#define REG_BK134A_2A_L      0x134A54
#define REG_BK134A_2A_H      0x134A55
#define REG_BK134A_2B_L      0x134A56
#define REG_BK134A_2B_H      0x134A57
#define REG_BK134A_2C_L      0x134A58
#define REG_BK134A_2C_H      0x134A59
#define REG_BK134A_2D_L      0x134A5A
#define REG_BK134A_2D_H      0x134A5B
#define REG_BK134A_2E_L      0x134A5C
#define REG_BK134A_2E_H      0x134A5D
#define REG_BK134A_2F_L      0x134A5E
#define REG_BK134A_2F_H      0x134A5F
#define REG_BK134A_30_L      0x134A60
#define REG_BK134A_30_H      0x134A61
#define REG_BK134A_31_L      0x134A62
#define REG_BK134A_31_H      0x134A63
#define REG_BK134A_32_L      0x134A64
#define REG_BK134A_32_H      0x134A65
#define REG_BK134A_33_L      0x134A66
#define REG_BK134A_33_H      0x134A67
#define REG_BK134A_34_L      0x134A68
#define REG_BK134A_34_H      0x134A69
#define REG_BK134A_35_L      0x134A6A
#define REG_BK134A_35_H      0x134A6B
#define REG_BK134A_36_L      0x134A6C
#define REG_BK134A_36_H      0x134A6D
#define REG_BK134A_37_L      0x134A6E
#define REG_BK134A_37_H      0x134A6F
#define REG_BK134A_38_L      0x134A70
#define REG_BK134A_38_H      0x134A71
#define REG_BK134A_39_L      0x134A72
#define REG_BK134A_39_H      0x134A73
#define REG_BK134A_3A_L      0x134A74
#define REG_BK134A_3A_H      0x134A75
#define REG_BK134A_3B_L      0x134A76
#define REG_BK134A_3B_H      0x134A77
#define REG_BK134A_3C_L      0x134A78
#define REG_BK134A_3C_H      0x134A79
#define REG_BK134A_3D_L      0x134A7A
#define REG_BK134A_3D_H      0x134A7B
#define REG_BK134A_3E_L      0x134A7C
#define REG_BK134A_3E_H      0x134A7D
#define REG_BK134A_3F_L      0x134A7E
#define REG_BK134A_3F_H      0x134A7F
#define REG_BK134A_40_L      0x134A80
#define REG_BK134A_40_H      0x134A81
#define REG_BK134A_41_L      0x134A82
#define REG_BK134A_41_H      0x134A83
#define REG_BK134A_42_L      0x134A84
#define REG_BK134A_42_H      0x134A85
#define REG_BK134A_43_L      0x134A86
#define REG_BK134A_43_H      0x134A87
#define REG_BK134A_44_L      0x134A88
#define REG_BK134A_44_H      0x134A89
#define REG_BK134A_45_L      0x134A8A
#define REG_BK134A_45_H      0x134A8B
#define REG_BK134A_46_L      0x134A8C
#define REG_BK134A_46_H      0x134A8D
#define REG_BK134A_47_L      0x134A8E
#define REG_BK134A_47_H      0x134A8F
#define REG_BK134A_48_L      0x134A90
#define REG_BK134A_48_H      0x134A91
#define REG_BK134A_49_L      0x134A92
#define REG_BK134A_49_H      0x134A93
#define REG_BK134A_4A_L      0x134A94
#define REG_BK134A_4A_H      0x134A95
#define REG_BK134A_4B_L      0x134A96
#define REG_BK134A_4B_H      0x134A97
#define REG_BK134A_4C_L      0x134A98
#define REG_BK134A_4C_H      0x134A99
#define REG_BK134A_4D_L      0x134A9A
#define REG_BK134A_4D_H      0x134A9B
#define REG_BK134A_4E_L      0x134A9C
#define REG_BK134A_4E_H      0x134A9D
#define REG_BK134A_4F_L      0x134A9E
#define REG_BK134A_4F_H      0x134A9F
#define REG_BK134A_50_L      0x134AA0
#define REG_BK134A_50_H      0x134AA1
#define REG_BK134A_51_L      0x134AA2
#define REG_BK134A_51_H      0x134AA3
#define REG_BK134A_52_L      0x134AA4
#define REG_BK134A_52_H      0x134AA5
#define REG_BK134A_53_L      0x134AA6
#define REG_BK134A_53_H      0x134AA7
#define REG_BK134A_54_L      0x134AA8
#define REG_BK134A_54_H      0x134AA9
#define REG_BK134A_55_L      0x134AAA
#define REG_BK134A_55_H      0x134AAB
#define REG_BK134A_56_L      0x134AAC
#define REG_BK134A_56_H      0x134AAD
#define REG_BK134A_57_L      0x134AAE
#define REG_BK134A_57_H      0x134AAF
#define REG_BK134A_58_L      0x134AB0
#define REG_BK134A_58_H      0x134AB1
#define REG_BK134A_59_L      0x134AB2
#define REG_BK134A_59_H      0x134AB3
#define REG_BK134A_5A_L      0x134AB4
#define REG_BK134A_5A_H      0x134AB5
#define REG_BK134A_5B_L      0x134AB6
#define REG_BK134A_5B_H      0x134AB7
#define REG_BK134A_5C_L      0x134AB8
#define REG_BK134A_5C_H      0x134AB9
#define REG_BK134A_5D_L      0x134ABA
#define REG_BK134A_5D_H      0x134ABB
#define REG_BK134A_5E_L      0x134ABC
#define REG_BK134A_5E_H      0x134ABD
#define REG_BK134A_5F_L      0x134ABE
#define REG_BK134A_5F_H      0x134ABF
#define REG_BK134A_60_L      0x134AC0
#define REG_BK134A_60_H      0x134AC1
#define REG_BK134A_61_L      0x134AC2
#define REG_BK134A_61_H      0x134AC3
#define REG_BK134A_62_L      0x134AC4
#define REG_BK134A_62_H      0x134AC5
#define REG_BK134A_63_L      0x134AC6
#define REG_BK134A_63_H      0x134AC7
#define REG_BK134A_64_L      0x134AC8
#define REG_BK134A_64_H      0x134AC9
#define REG_BK134A_65_L      0x134ACA
#define REG_BK134A_65_H      0x134ACB
#define REG_BK134A_66_L      0x134ACC
#define REG_BK134A_66_H      0x134ACD
#define REG_BK134A_67_L      0x134ACE
#define REG_BK134A_67_H      0x134ACF
#define REG_BK134A_68_L      0x134AD0
#define REG_BK134A_68_H      0x134AD1
#define REG_BK134A_69_L      0x134AD2
#define REG_BK134A_69_H      0x134AD3
#define REG_BK134A_6A_L      0x134AD4
#define REG_BK134A_6A_H      0x134AD5
#define REG_BK134A_6B_L      0x134AD6
#define REG_BK134A_6B_H      0x134AD7
#define REG_BK134A_6C_L      0x134AD8
#define REG_BK134A_6C_H      0x134AD9
#define REG_BK134A_6D_L      0x134ADA
#define REG_BK134A_6D_H      0x134ADB
#define REG_BK134A_6E_L      0x134ADC
#define REG_BK134A_6E_H      0x134ADD
#define REG_BK134A_6F_L      0x134ADE
#define REG_BK134A_6F_H      0x134ADF
#define REG_BK134A_70_L      0x134AE0
#define REG_BK134A_70_H      0x134AE1
#define REG_BK134A_71_L      0x134AE2
#define REG_BK134A_71_H      0x134AE3
#define REG_BK134A_72_L      0x134AE4
#define REG_BK134A_72_H      0x134AE5
#define REG_BK134A_73_L      0x134AE6
#define REG_BK134A_73_H      0x134AE7
#define REG_BK134A_74_L      0x134AE8
#define REG_BK134A_74_H      0x134AE9
#define REG_BK134A_75_L      0x134AEA
#define REG_BK134A_75_H      0x134AEB
#define REG_BK134A_76_L      0x134AEC
#define REG_BK134A_76_H      0x134AED
#define REG_BK134A_77_L      0x134AEE
#define REG_BK134A_77_H      0x134AEF
#define REG_BK134A_78_L      0x134AF0
#define REG_BK134A_78_H      0x134AF1
#define REG_BK134A_79_L      0x134AF2
#define REG_BK134A_79_H      0x134AF3
#define REG_BK134A_7A_L      0x134AF4
#define REG_BK134A_7A_H      0x134AF5
#define REG_BK134A_7B_L      0x134AF6
#define REG_BK134A_7B_H      0x134AF7
#define REG_BK134A_7C_L      0x134AF8
#define REG_BK134A_7C_H      0x134AF9
#define REG_BK134A_7D_L      0x134AFA
#define REG_BK134A_7D_H      0x134AFB
#define REG_BK134A_7E_L      0x134AFC
#define REG_BK134A_7E_H      0x134AFD
#define REG_BK134A_7F_L      0x134AFE
#define REG_BK134A_7F_H      0x134AFF
//----------------------------------------------
#define REG_BK134C_00_L      0x134C00
#define REG_BK134C_00_H      0x134C01
#define REG_BK134C_01_L      0x134C02
#define REG_BK134C_01_H      0x134C03
#define REG_BK134C_02_L      0x134C04
#define REG_BK134C_02_H      0x134C05
#define REG_BK134C_03_L      0x134C06
#define REG_BK134C_03_H      0x134C07
#define REG_BK134C_04_L      0x134C08
#define REG_BK134C_04_H      0x134C09
#define REG_BK134C_05_L      0x134C0A
#define REG_BK134C_05_H      0x134C0B
#define REG_BK134C_06_L      0x134C0C
#define REG_BK134C_06_H      0x134C0D
#define REG_BK134C_07_L      0x134C0E
#define REG_BK134C_07_H      0x134C0F
#define REG_BK134C_08_L      0x134C10
#define REG_BK134C_08_H      0x134C11
#define REG_BK134C_09_L      0x134C12
#define REG_BK134C_09_H      0x134C13
#define REG_BK134C_0A_L      0x134C14
#define REG_BK134C_0A_H      0x134C15
#define REG_BK134C_0B_L      0x134C16
#define REG_BK134C_0B_H      0x134C17
#define REG_BK134C_0C_L      0x134C18
#define REG_BK134C_0C_H      0x134C19
#define REG_BK134C_0D_L      0x134C1A
#define REG_BK134C_0D_H      0x134C1B
#define REG_BK134C_0E_L      0x134C1C
#define REG_BK134C_0E_H      0x134C1D
#define REG_BK134C_0F_L      0x134C1E
#define REG_BK134C_0F_H      0x134C1F
#define REG_BK134C_10_L      0x134C20
#define REG_BK134C_10_H      0x134C21
#define REG_BK134C_11_L      0x134C22
#define REG_BK134C_11_H      0x134C23
#define REG_BK134C_12_L      0x134C24
#define REG_BK134C_12_H      0x134C25
#define REG_BK134C_13_L      0x134C26
#define REG_BK134C_13_H      0x134C27
#define REG_BK134C_14_L      0x134C28
#define REG_BK134C_14_H      0x134C29
#define REG_BK134C_15_L      0x134C2A
#define REG_BK134C_15_H      0x134C2B
#define REG_BK134C_16_L      0x134C2C
#define REG_BK134C_16_H      0x134C2D
#define REG_BK134C_17_L      0x134C2E
#define REG_BK134C_17_H      0x134C2F
#define REG_BK134C_18_L      0x134C30
#define REG_BK134C_18_H      0x134C31
#define REG_BK134C_19_L      0x134C32
#define REG_BK134C_19_H      0x134C33
#define REG_BK134C_1A_L      0x134C34
#define REG_BK134C_1A_H      0x134C35
#define REG_BK134C_1B_L      0x134C36
#define REG_BK134C_1B_H      0x134C37
#define REG_BK134C_1C_L      0x134C38
#define REG_BK134C_1C_H      0x134C39
#define REG_BK134C_1D_L      0x134C3A
#define REG_BK134C_1D_H      0x134C3B
#define REG_BK134C_1E_L      0x134C3C
#define REG_BK134C_1E_H      0x134C3D
#define REG_BK134C_1F_L      0x134C3E
#define REG_BK134C_1F_H      0x134C3F
#define REG_BK134C_20_L      0x134C40
#define REG_BK134C_20_H      0x134C41
#define REG_BK134C_21_L      0x134C42
#define REG_BK134C_21_H      0x134C43
#define REG_BK134C_22_L      0x134C44
#define REG_BK134C_22_H      0x134C45
#define REG_BK134C_23_L      0x134C46
#define REG_BK134C_23_H      0x134C47
#define REG_BK134C_24_L      0x134C48
#define REG_BK134C_24_H      0x134C49
#define REG_BK134C_25_L      0x134C4A
#define REG_BK134C_25_H      0x134C4B
#define REG_BK134C_26_L      0x134C4C
#define REG_BK134C_26_H      0x134C4D
#define REG_BK134C_27_L      0x134C4E
#define REG_BK134C_27_H      0x134C4F
#define REG_BK134C_28_L      0x134C50
#define REG_BK134C_28_H      0x134C51
#define REG_BK134C_29_L      0x134C52
#define REG_BK134C_29_H      0x134C53
#define REG_BK134C_2A_L      0x134C54
#define REG_BK134C_2A_H      0x134C55
#define REG_BK134C_2B_L      0x134C56
#define REG_BK134C_2B_H      0x134C57
#define REG_BK134C_2C_L      0x134C58
#define REG_BK134C_2C_H      0x134C59
#define REG_BK134C_2D_L      0x134C5A
#define REG_BK134C_2D_H      0x134C5B
#define REG_BK134C_2E_L      0x134C5C
#define REG_BK134C_2E_H      0x134C5D
#define REG_BK134C_2F_L      0x134C5E
#define REG_BK134C_2F_H      0x134C5F
#define REG_BK134C_30_L      0x134C60
#define REG_BK134C_30_H      0x134C61
#define REG_BK134C_31_L      0x134C62
#define REG_BK134C_31_H      0x134C63
#define REG_BK134C_32_L      0x134C64
#define REG_BK134C_32_H      0x134C65
#define REG_BK134C_33_L      0x134C66
#define REG_BK134C_33_H      0x134C67
#define REG_BK134C_34_L      0x134C68
#define REG_BK134C_34_H      0x134C69
#define REG_BK134C_35_L      0x134C6A
#define REG_BK134C_35_H      0x134C6B
#define REG_BK134C_36_L      0x134C6C
#define REG_BK134C_36_H      0x134C6D
#define REG_BK134C_37_L      0x134C6E
#define REG_BK134C_37_H      0x134C6F
#define REG_BK134C_38_L      0x134C70
#define REG_BK134C_38_H      0x134C71
#define REG_BK134C_39_L      0x134C72
#define REG_BK134C_39_H      0x134C73
#define REG_BK134C_3A_L      0x134C74
#define REG_BK134C_3A_H      0x134C75
#define REG_BK134C_3B_L      0x134C76
#define REG_BK134C_3B_H      0x134C77
#define REG_BK134C_3C_L      0x134C78
#define REG_BK134C_3C_H      0x134C79
#define REG_BK134C_3D_L      0x134C7A
#define REG_BK134C_3D_H      0x134C7B
#define REG_BK134C_3E_L      0x134C7C
#define REG_BK134C_3E_H      0x134C7D
#define REG_BK134C_3F_L      0x134C7E
#define REG_BK134C_3F_H      0x134C7F
#define REG_BK134C_40_L      0x134C80
#define REG_BK134C_40_H      0x134C81
#define REG_BK134C_41_L      0x134C82
#define REG_BK134C_41_H      0x134C83
#define REG_BK134C_42_L      0x134C84
#define REG_BK134C_42_H      0x134C85
#define REG_BK134C_43_L      0x134C86
#define REG_BK134C_43_H      0x134C87
#define REG_BK134C_44_L      0x134C88
#define REG_BK134C_44_H      0x134C89
#define REG_BK134C_45_L      0x134C8A
#define REG_BK134C_45_H      0x134C8B
#define REG_BK134C_46_L      0x134C8C
#define REG_BK134C_46_H      0x134C8D
#define REG_BK134C_47_L      0x134C8E
#define REG_BK134C_47_H      0x134C8F
#define REG_BK134C_48_L      0x134C90
#define REG_BK134C_48_H      0x134C91
#define REG_BK134C_49_L      0x134C92
#define REG_BK134C_49_H      0x134C93
#define REG_BK134C_4A_L      0x134C94
#define REG_BK134C_4A_H      0x134C95
#define REG_BK134C_4B_L      0x134C96
#define REG_BK134C_4B_H      0x134C97
#define REG_BK134C_4C_L      0x134C98
#define REG_BK134C_4C_H      0x134C99
#define REG_BK134C_4D_L      0x134C9A
#define REG_BK134C_4D_H      0x134C9B
#define REG_BK134C_4E_L      0x134C9C
#define REG_BK134C_4E_H      0x134C9D
#define REG_BK134C_4F_L      0x134C9E
#define REG_BK134C_4F_H      0x134C9F
#define REG_BK134C_50_L      0x134CA0
#define REG_BK134C_50_H      0x134CA1
#define REG_BK134C_51_L      0x134CA2
#define REG_BK134C_51_H      0x134CA3
#define REG_BK134C_52_L      0x134CA4
#define REG_BK134C_52_H      0x134CA5
#define REG_BK134C_53_L      0x134CA6
#define REG_BK134C_53_H      0x134CA7
#define REG_BK134C_54_L      0x134CA8
#define REG_BK134C_54_H      0x134CA9
#define REG_BK134C_55_L      0x134CAA
#define REG_BK134C_55_H      0x134CAB
#define REG_BK134C_56_L      0x134CAC
#define REG_BK134C_56_H      0x134CAD
#define REG_BK134C_57_L      0x134CAE
#define REG_BK134C_57_H      0x134CAF
#define REG_BK134C_58_L      0x134CB0
#define REG_BK134C_58_H      0x134CB1
#define REG_BK134C_59_L      0x134CB2
#define REG_BK134C_59_H      0x134CB3
#define REG_BK134C_5A_L      0x134CB4
#define REG_BK134C_5A_H      0x134CB5
#define REG_BK134C_5B_L      0x134CB6
#define REG_BK134C_5B_H      0x134CB7
#define REG_BK134C_5C_L      0x134CB8
#define REG_BK134C_5C_H      0x134CB9
#define REG_BK134C_5D_L      0x134CBA
#define REG_BK134C_5D_H      0x134CBB
#define REG_BK134C_5E_L      0x134CBC
#define REG_BK134C_5E_H      0x134CBD
#define REG_BK134C_5F_L      0x134CBE
#define REG_BK134C_5F_H      0x134CBF
#define REG_BK134C_60_L      0x134CC0
#define REG_BK134C_60_H      0x134CC1
#define REG_BK134C_61_L      0x134CC2
#define REG_BK134C_61_H      0x134CC3
#define REG_BK134C_62_L      0x134CC4
#define REG_BK134C_62_H      0x134CC5
#define REG_BK134C_63_L      0x134CC6
#define REG_BK134C_63_H      0x134CC7
#define REG_BK134C_64_L      0x134CC8
#define REG_BK134C_64_H      0x134CC9
#define REG_BK134C_65_L      0x134CCA
#define REG_BK134C_65_H      0x134CCB
#define REG_BK134C_66_L      0x134CCC
#define REG_BK134C_66_H      0x134CCD
#define REG_BK134C_67_L      0x134CCE
#define REG_BK134C_67_H      0x134CCF
#define REG_BK134C_68_L      0x134CD0
#define REG_BK134C_68_H      0x134CD1
#define REG_BK134C_69_L      0x134CD2
#define REG_BK134C_69_H      0x134CD3
#define REG_BK134C_6A_L      0x134CD4
#define REG_BK134C_6A_H      0x134CD5
#define REG_BK134C_6B_L      0x134CD6
#define REG_BK134C_6B_H      0x134CD7
#define REG_BK134C_6C_L      0x134CD8
#define REG_BK134C_6C_H      0x134CD9
#define REG_BK134C_6D_L      0x134CDA
#define REG_BK134C_6D_H      0x134CDB
#define REG_BK134C_6E_L      0x134CDC
#define REG_BK134C_6E_H      0x134CDD
#define REG_BK134C_6F_L      0x134CDE
#define REG_BK134C_6F_H      0x134CDF
#define REG_BK134C_70_L      0x134CE0
#define REG_BK134C_70_H      0x134CE1
#define REG_BK134C_71_L      0x134CE2
#define REG_BK134C_71_H      0x134CE3
#define REG_BK134C_72_L      0x134CE4
#define REG_BK134C_72_H      0x134CE5
#define REG_BK134C_73_L      0x134CE6
#define REG_BK134C_73_H      0x134CE7
#define REG_BK134C_74_L      0x134CE8
#define REG_BK134C_74_H      0x134CE9
#define REG_BK134C_75_L      0x134CEA
#define REG_BK134C_75_H      0x134CEB
#define REG_BK134C_76_L      0x134CEC
#define REG_BK134C_76_H      0x134CED
#define REG_BK134C_77_L      0x134CEE
#define REG_BK134C_77_H      0x134CEF
#define REG_BK134C_78_L      0x134CF0
#define REG_BK134C_78_H      0x134CF1
#define REG_BK134C_79_L      0x134CF2
#define REG_BK134C_79_H      0x134CF3
#define REG_BK134C_7A_L      0x134CF4
#define REG_BK134C_7A_H      0x134CF5
#define REG_BK134C_7B_L      0x134CF6
#define REG_BK134C_7B_H      0x134CF7
#define REG_BK134C_7C_L      0x134CF8
#define REG_BK134C_7C_H      0x134CF9
#define REG_BK134C_7D_L      0x134CFA
#define REG_BK134C_7D_H      0x134CFB
#define REG_BK134C_7E_L      0x134CFC
#define REG_BK134C_7E_H      0x134CFD
#define REG_BK134C_7F_L      0x134CFE
#define REG_BK134C_7F_H      0x134CFF
//----------------------------------------------
#define REG_BK134E_00_L      0x134E00
#define REG_BK134E_00_H      0x134E01
#define REG_BK134E_01_L      0x134E02
#define REG_BK134E_01_H      0x134E03
#define REG_BK134E_02_L      0x134E04
#define REG_BK134E_02_H      0x134E05
#define REG_BK134E_03_L      0x134E06
#define REG_BK134E_03_H      0x134E07
#define REG_BK134E_04_L      0x134E08
#define REG_BK134E_04_H      0x134E09
#define REG_BK134E_05_L      0x134E0A
#define REG_BK134E_05_H      0x134E0B
#define REG_BK134E_06_L      0x134E0C
#define REG_BK134E_06_H      0x134E0D
#define REG_BK134E_07_L      0x134E0E
#define REG_BK134E_07_H      0x134E0F
#define REG_BK134E_08_L      0x134E10
#define REG_BK134E_08_H      0x134E11
#define REG_BK134E_09_L      0x134E12
#define REG_BK134E_09_H      0x134E13
#define REG_BK134E_0A_L      0x134E14
#define REG_BK134E_0A_H      0x134E15
#define REG_BK134E_0B_L      0x134E16
#define REG_BK134E_0B_H      0x134E17
#define REG_BK134E_0C_L      0x134E18
#define REG_BK134E_0C_H      0x134E19
#define REG_BK134E_0D_L      0x134E1A
#define REG_BK134E_0D_H      0x134E1B
#define REG_BK134E_0E_L      0x134E1C
#define REG_BK134E_0E_H      0x134E1D
#define REG_BK134E_0F_L      0x134E1E
#define REG_BK134E_0F_H      0x134E1F
#define REG_BK134E_10_L      0x134E20
#define REG_BK134E_10_H      0x134E21
#define REG_BK134E_11_L      0x134E22
#define REG_BK134E_11_H      0x134E23
#define REG_BK134E_12_L      0x134E24
#define REG_BK134E_12_H      0x134E25
#define REG_BK134E_13_L      0x134E26
#define REG_BK134E_13_H      0x134E27
#define REG_BK134E_14_L      0x134E28
#define REG_BK134E_14_H      0x134E29
#define REG_BK134E_15_L      0x134E2A
#define REG_BK134E_15_H      0x134E2B
#define REG_BK134E_16_L      0x134E2C
#define REG_BK134E_16_H      0x134E2D
#define REG_BK134E_17_L      0x134E2E
#define REG_BK134E_17_H      0x134E2F
#define REG_BK134E_18_L      0x134E30
#define REG_BK134E_18_H      0x134E31
#define REG_BK134E_19_L      0x134E32
#define REG_BK134E_19_H      0x134E33
#define REG_BK134E_1A_L      0x134E34
#define REG_BK134E_1A_H      0x134E35
#define REG_BK134E_1B_L      0x134E36
#define REG_BK134E_1B_H      0x134E37
#define REG_BK134E_1C_L      0x134E38
#define REG_BK134E_1C_H      0x134E39
#define REG_BK134E_1D_L      0x134E3A
#define REG_BK134E_1D_H      0x134E3B
#define REG_BK134E_1E_L      0x134E3C
#define REG_BK134E_1E_H      0x134E3D
#define REG_BK134E_1F_L      0x134E3E
#define REG_BK134E_1F_H      0x134E3F
#define REG_BK134E_20_L      0x134E40
#define REG_BK134E_20_H      0x134E41
#define REG_BK134E_21_L      0x134E42
#define REG_BK134E_21_H      0x134E43
#define REG_BK134E_22_L      0x134E44
#define REG_BK134E_22_H      0x134E45
#define REG_BK134E_23_L      0x134E46
#define REG_BK134E_23_H      0x134E47
#define REG_BK134E_24_L      0x134E48
#define REG_BK134E_24_H      0x134E49
#define REG_BK134E_25_L      0x134E4A
#define REG_BK134E_25_H      0x134E4B
#define REG_BK134E_26_L      0x134E4C
#define REG_BK134E_26_H      0x134E4D
#define REG_BK134E_27_L      0x134E4E
#define REG_BK134E_27_H      0x134E4F
#define REG_BK134E_28_L      0x134E50
#define REG_BK134E_28_H      0x134E51
#define REG_BK134E_29_L      0x134E52
#define REG_BK134E_29_H      0x134E53
#define REG_BK134E_2A_L      0x134E54
#define REG_BK134E_2A_H      0x134E55
#define REG_BK134E_2B_L      0x134E56
#define REG_BK134E_2B_H      0x134E57
#define REG_BK134E_2C_L      0x134E58
#define REG_BK134E_2C_H      0x134E59
#define REG_BK134E_2D_L      0x134E5A
#define REG_BK134E_2D_H      0x134E5B
#define REG_BK134E_2E_L      0x134E5C
#define REG_BK134E_2E_H      0x134E5D
#define REG_BK134E_2F_L      0x134E5E
#define REG_BK134E_2F_H      0x134E5F
#define REG_BK134E_30_L      0x134E60
#define REG_BK134E_30_H      0x134E61
#define REG_BK134E_31_L      0x134E62
#define REG_BK134E_31_H      0x134E63
#define REG_BK134E_32_L      0x134E64
#define REG_BK134E_32_H      0x134E65
#define REG_BK134E_33_L      0x134E66
#define REG_BK134E_33_H      0x134E67
#define REG_BK134E_34_L      0x134E68
#define REG_BK134E_34_H      0x134E69
#define REG_BK134E_35_L      0x134E6A
#define REG_BK134E_35_H      0x134E6B
#define REG_BK134E_36_L      0x134E6C
#define REG_BK134E_36_H      0x134E6D
#define REG_BK134E_37_L      0x134E6E
#define REG_BK134E_37_H      0x134E6F
#define REG_BK134E_38_L      0x134E70
#define REG_BK134E_38_H      0x134E71
#define REG_BK134E_39_L      0x134E72
#define REG_BK134E_39_H      0x134E73
#define REG_BK134E_3A_L      0x134E74
#define REG_BK134E_3A_H      0x134E75
#define REG_BK134E_3B_L      0x134E76
#define REG_BK134E_3B_H      0x134E77
#define REG_BK134E_3C_L      0x134E78
#define REG_BK134E_3C_H      0x134E79
#define REG_BK134E_3D_L      0x134E7A
#define REG_BK134E_3D_H      0x134E7B
#define REG_BK134E_3E_L      0x134E7C
#define REG_BK134E_3E_H      0x134E7D
#define REG_BK134E_3F_L      0x134E7E
#define REG_BK134E_3F_H      0x134E7F
#define REG_BK134E_40_L      0x134E80
#define REG_BK134E_40_H      0x134E81
#define REG_BK134E_41_L      0x134E82
#define REG_BK134E_41_H      0x134E83
#define REG_BK134E_42_L      0x134E84
#define REG_BK134E_42_H      0x134E85
#define REG_BK134E_43_L      0x134E86
#define REG_BK134E_43_H      0x134E87
#define REG_BK134E_44_L      0x134E88
#define REG_BK134E_44_H      0x134E89
#define REG_BK134E_45_L      0x134E8A
#define REG_BK134E_45_H      0x134E8B
#define REG_BK134E_46_L      0x134E8C
#define REG_BK134E_46_H      0x134E8D
#define REG_BK134E_47_L      0x134E8E
#define REG_BK134E_47_H      0x134E8F
#define REG_BK134E_48_L      0x134E90
#define REG_BK134E_48_H      0x134E91
#define REG_BK134E_49_L      0x134E92
#define REG_BK134E_49_H      0x134E93
#define REG_BK134E_4A_L      0x134E94
#define REG_BK134E_4A_H      0x134E95
#define REG_BK134E_4B_L      0x134E96
#define REG_BK134E_4B_H      0x134E97
#define REG_BK134E_4C_L      0x134E98
#define REG_BK134E_4C_H      0x134E99
#define REG_BK134E_4D_L      0x134E9A
#define REG_BK134E_4D_H      0x134E9B
#define REG_BK134E_4E_L      0x134E9C
#define REG_BK134E_4E_H      0x134E9D
#define REG_BK134E_4F_L      0x134E9E
#define REG_BK134E_4F_H      0x134E9F
#define REG_BK134E_50_L      0x134EA0
#define REG_BK134E_50_H      0x134EA1
#define REG_BK134E_51_L      0x134EA2
#define REG_BK134E_51_H      0x134EA3
#define REG_BK134E_52_L      0x134EA4
#define REG_BK134E_52_H      0x134EA5
#define REG_BK134E_53_L      0x134EA6
#define REG_BK134E_53_H      0x134EA7
#define REG_BK134E_54_L      0x134EA8
#define REG_BK134E_54_H      0x134EA9
#define REG_BK134E_55_L      0x134EAA
#define REG_BK134E_55_H      0x134EAB
#define REG_BK134E_56_L      0x134EAC
#define REG_BK134E_56_H      0x134EAD
#define REG_BK134E_57_L      0x134EAE
#define REG_BK134E_57_H      0x134EAF
#define REG_BK134E_58_L      0x134EB0
#define REG_BK134E_58_H      0x134EB1
#define REG_BK134E_59_L      0x134EB2
#define REG_BK134E_59_H      0x134EB3
#define REG_BK134E_5A_L      0x134EB4
#define REG_BK134E_5A_H      0x134EB5
#define REG_BK134E_5B_L      0x134EB6
#define REG_BK134E_5B_H      0x134EB7
#define REG_BK134E_5C_L      0x134EB8
#define REG_BK134E_5C_H      0x134EB9
#define REG_BK134E_5D_L      0x134EBA
#define REG_BK134E_5D_H      0x134EBB
#define REG_BK134E_5E_L      0x134EBC
#define REG_BK134E_5E_H      0x134EBD
#define REG_BK134E_5F_L      0x134EBE
#define REG_BK134E_5F_H      0x134EBF
#define REG_BK134E_60_L      0x134EC0
#define REG_BK134E_60_H      0x134EC1
#define REG_BK134E_61_L      0x134EC2
#define REG_BK134E_61_H      0x134EC3
#define REG_BK134E_62_L      0x134EC4
#define REG_BK134E_62_H      0x134EC5
#define REG_BK134E_63_L      0x134EC6
#define REG_BK134E_63_H      0x134EC7
#define REG_BK134E_64_L      0x134EC8
#define REG_BK134E_64_H      0x134EC9
#define REG_BK134E_65_L      0x134ECA
#define REG_BK134E_65_H      0x134ECB
#define REG_BK134E_66_L      0x134ECC
#define REG_BK134E_66_H      0x134ECD
#define REG_BK134E_67_L      0x134ECE
#define REG_BK134E_67_H      0x134ECF
#define REG_BK134E_68_L      0x134ED0
#define REG_BK134E_68_H      0x134ED1
#define REG_BK134E_69_L      0x134ED2
#define REG_BK134E_69_H      0x134ED3
#define REG_BK134E_6A_L      0x134ED4
#define REG_BK134E_6A_H      0x134ED5
#define REG_BK134E_6B_L      0x134ED6
#define REG_BK134E_6B_H      0x134ED7
#define REG_BK134E_6C_L      0x134ED8
#define REG_BK134E_6C_H      0x134ED9
#define REG_BK134E_6D_L      0x134EDA
#define REG_BK134E_6D_H      0x134EDB
#define REG_BK134E_6E_L      0x134EDC
#define REG_BK134E_6E_H      0x134EDD
#define REG_BK134E_6F_L      0x134EDE
#define REG_BK134E_6F_H      0x134EDF
#define REG_BK134E_70_L      0x134EE0
#define REG_BK134E_70_H      0x134EE1
#define REG_BK134E_71_L      0x134EE2
#define REG_BK134E_71_H      0x134EE3
#define REG_BK134E_72_L      0x134EE4
#define REG_BK134E_72_H      0x134EE5
#define REG_BK134E_73_L      0x134EE6
#define REG_BK134E_73_H      0x134EE7
#define REG_BK134E_74_L      0x134EE8
#define REG_BK134E_74_H      0x134EE9
#define REG_BK134E_75_L      0x134EEA
#define REG_BK134E_75_H      0x134EEB
#define REG_BK134E_76_L      0x134EEC
#define REG_BK134E_76_H      0x134EED
#define REG_BK134E_77_L      0x134EEE
#define REG_BK134E_77_H      0x134EEF
#define REG_BK134E_78_L      0x134EF0
#define REG_BK134E_78_H      0x134EF1
#define REG_BK134E_79_L      0x134EF2
#define REG_BK134E_79_H      0x134EF3
#define REG_BK134E_7A_L      0x134EF4
#define REG_BK134E_7A_H      0x134EF5
#define REG_BK134E_7B_L      0x134EF6
#define REG_BK134E_7B_H      0x134EF7
#define REG_BK134E_7C_L      0x134EF8
#define REG_BK134E_7C_H      0x134EF9
#define REG_BK134E_7D_L      0x134EFA
#define REG_BK134E_7D_H      0x134EFB
#define REG_BK134E_7E_L      0x134EFC
#define REG_BK134E_7E_H      0x134EFD
#define REG_BK134E_7F_L      0x134EFE
#define REG_BK134E_7F_H      0x134EFF
//----------------------------------------------
#define REG_BK134F_00_L      0x134F00
#define REG_BK134F_00_H      0x134F01
#define REG_BK134F_01_L      0x134F02
#define REG_BK134F_01_H      0x134F03
#define REG_BK134F_02_L      0x134F04
#define REG_BK134F_02_H      0x134F05
#define REG_BK134F_03_L      0x134F06
#define REG_BK134F_03_H      0x134F07
#define REG_BK134F_04_L      0x134F08
#define REG_BK134F_04_H      0x134F09
#define REG_BK134F_05_L      0x134F0A
#define REG_BK134F_05_H      0x134F0B
#define REG_BK134F_06_L      0x134F0C
#define REG_BK134F_06_H      0x134F0D
#define REG_BK134F_07_L      0x134F0E
#define REG_BK134F_07_H      0x134F0F
#define REG_BK134F_08_L      0x134F10
#define REG_BK134F_08_H      0x134F11
#define REG_BK134F_09_L      0x134F12
#define REG_BK134F_09_H      0x134F13
#define REG_BK134F_0A_L      0x134F14
#define REG_BK134F_0A_H      0x134F15
#define REG_BK134F_0B_L      0x134F16
#define REG_BK134F_0B_H      0x134F17
#define REG_BK134F_0C_L      0x134F18
#define REG_BK134F_0C_H      0x134F19
#define REG_BK134F_0D_L      0x134F1A
#define REG_BK134F_0D_H      0x134F1B
#define REG_BK134F_0E_L      0x134F1C
#define REG_BK134F_0E_H      0x134F1D
#define REG_BK134F_0F_L      0x134F1E
#define REG_BK134F_0F_H      0x134F1F
#define REG_BK134F_10_L      0x134F20
#define REG_BK134F_10_H      0x134F21
#define REG_BK134F_11_L      0x134F22
#define REG_BK134F_11_H      0x134F23
#define REG_BK134F_12_L      0x134F24
#define REG_BK134F_12_H      0x134F25
#define REG_BK134F_13_L      0x134F26
#define REG_BK134F_13_H      0x134F27
#define REG_BK134F_14_L      0x134F28
#define REG_BK134F_14_H      0x134F29
#define REG_BK134F_15_L      0x134F2A
#define REG_BK134F_15_H      0x134F2B
#define REG_BK134F_16_L      0x134F2C
#define REG_BK134F_16_H      0x134F2D
#define REG_BK134F_17_L      0x134F2E
#define REG_BK134F_17_H      0x134F2F
#define REG_BK134F_18_L      0x134F30
#define REG_BK134F_18_H      0x134F31
#define REG_BK134F_19_L      0x134F32
#define REG_BK134F_19_H      0x134F33
#define REG_BK134F_1A_L      0x134F34
#define REG_BK134F_1A_H      0x134F35
#define REG_BK134F_1B_L      0x134F36
#define REG_BK134F_1B_H      0x134F37
#define REG_BK134F_1C_L      0x134F38
#define REG_BK134F_1C_H      0x134F39
#define REG_BK134F_1D_L      0x134F3A
#define REG_BK134F_1D_H      0x134F3B
#define REG_BK134F_1E_L      0x134F3C
#define REG_BK134F_1E_H      0x134F3D
#define REG_BK134F_1F_L      0x134F3E
#define REG_BK134F_1F_H      0x134F3F
#define REG_BK134F_20_L      0x134F40
#define REG_BK134F_20_H      0x134F41
#define REG_BK134F_21_L      0x134F42
#define REG_BK134F_21_H      0x134F43
#define REG_BK134F_22_L      0x134F44
#define REG_BK134F_22_H      0x134F45
#define REG_BK134F_23_L      0x134F46
#define REG_BK134F_23_H      0x134F47
#define REG_BK134F_24_L      0x134F48
#define REG_BK134F_24_H      0x134F49
#define REG_BK134F_25_L      0x134F4A
#define REG_BK134F_25_H      0x134F4B
#define REG_BK134F_26_L      0x134F4C
#define REG_BK134F_26_H      0x134F4D
#define REG_BK134F_27_L      0x134F4E
#define REG_BK134F_27_H      0x134F4F
#define REG_BK134F_28_L      0x134F50
#define REG_BK134F_28_H      0x134F51
#define REG_BK134F_29_L      0x134F52
#define REG_BK134F_29_H      0x134F53
#define REG_BK134F_2A_L      0x134F54
#define REG_BK134F_2A_H      0x134F55
#define REG_BK134F_2B_L      0x134F56
#define REG_BK134F_2B_H      0x134F57
#define REG_BK134F_2C_L      0x134F58
#define REG_BK134F_2C_H      0x134F59
#define REG_BK134F_2D_L      0x134F5A
#define REG_BK134F_2D_H      0x134F5B
#define REG_BK134F_2E_L      0x134F5C
#define REG_BK134F_2E_H      0x134F5D
#define REG_BK134F_2F_L      0x134F5E
#define REG_BK134F_2F_H      0x134F5F
#define REG_BK134F_30_L      0x134F60
#define REG_BK134F_30_H      0x134F61
#define REG_BK134F_31_L      0x134F62
#define REG_BK134F_31_H      0x134F63
#define REG_BK134F_32_L      0x134F64
#define REG_BK134F_32_H      0x134F65
#define REG_BK134F_33_L      0x134F66
#define REG_BK134F_33_H      0x134F67
#define REG_BK134F_34_L      0x134F68
#define REG_BK134F_34_H      0x134F69
#define REG_BK134F_35_L      0x134F6A
#define REG_BK134F_35_H      0x134F6B
#define REG_BK134F_36_L      0x134F6C
#define REG_BK134F_36_H      0x134F6D
#define REG_BK134F_37_L      0x134F6E
#define REG_BK134F_37_H      0x134F6F
#define REG_BK134F_38_L      0x134F70
#define REG_BK134F_38_H      0x134F71
#define REG_BK134F_39_L      0x134F72
#define REG_BK134F_39_H      0x134F73
#define REG_BK134F_3A_L      0x134F74
#define REG_BK134F_3A_H      0x134F75
#define REG_BK134F_3B_L      0x134F76
#define REG_BK134F_3B_H      0x134F77
#define REG_BK134F_3C_L      0x134F78
#define REG_BK134F_3C_H      0x134F79
#define REG_BK134F_3D_L      0x134F7A
#define REG_BK134F_3D_H      0x134F7B
#define REG_BK134F_3E_L      0x134F7C
#define REG_BK134F_3E_H      0x134F7D
#define REG_BK134F_3F_L      0x134F7E
#define REG_BK134F_3F_H      0x134F7F
#define REG_BK134F_40_L      0x134F80
#define REG_BK134F_40_H      0x134F81
#define REG_BK134F_41_L      0x134F82
#define REG_BK134F_41_H      0x134F83
#define REG_BK134F_42_L      0x134F84
#define REG_BK134F_42_H      0x134F85
#define REG_BK134F_43_L      0x134F86
#define REG_BK134F_43_H      0x134F87
#define REG_BK134F_44_L      0x134F88
#define REG_BK134F_44_H      0x134F89
#define REG_BK134F_45_L      0x134F8A
#define REG_BK134F_45_H      0x134F8B
#define REG_BK134F_46_L      0x134F8C
#define REG_BK134F_46_H      0x134F8D
#define REG_BK134F_47_L      0x134F8E
#define REG_BK134F_47_H      0x134F8F
#define REG_BK134F_48_L      0x134F90
#define REG_BK134F_48_H      0x134F91
#define REG_BK134F_49_L      0x134F92
#define REG_BK134F_49_H      0x134F93
#define REG_BK134F_4A_L      0x134F94
#define REG_BK134F_4A_H      0x134F95
#define REG_BK134F_4B_L      0x134F96
#define REG_BK134F_4B_H      0x134F97
#define REG_BK134F_4C_L      0x134F98
#define REG_BK134F_4C_H      0x134F99
#define REG_BK134F_4D_L      0x134F9A
#define REG_BK134F_4D_H      0x134F9B
#define REG_BK134F_4E_L      0x134F9C
#define REG_BK134F_4E_H      0x134F9D
#define REG_BK134F_4F_L      0x134F9E
#define REG_BK134F_4F_H      0x134F9F
#define REG_BK134F_50_L      0x134FA0
#define REG_BK134F_50_H      0x134FA1
#define REG_BK134F_51_L      0x134FA2
#define REG_BK134F_51_H      0x134FA3
#define REG_BK134F_52_L      0x134FA4
#define REG_BK134F_52_H      0x134FA5
#define REG_BK134F_53_L      0x134FA6
#define REG_BK134F_53_H      0x134FA7
#define REG_BK134F_54_L      0x134FA8
#define REG_BK134F_54_H      0x134FA9
#define REG_BK134F_55_L      0x134FAA
#define REG_BK134F_55_H      0x134FAB
#define REG_BK134F_56_L      0x134FAC
#define REG_BK134F_56_H      0x134FAD
#define REG_BK134F_57_L      0x134FAE
#define REG_BK134F_57_H      0x134FAF
#define REG_BK134F_58_L      0x134FB0
#define REG_BK134F_58_H      0x134FB1
#define REG_BK134F_59_L      0x134FB2
#define REG_BK134F_59_H      0x134FB3
#define REG_BK134F_5A_L      0x134FB4
#define REG_BK134F_5A_H      0x134FB5
#define REG_BK134F_5B_L      0x134FB6
#define REG_BK134F_5B_H      0x134FB7
#define REG_BK134F_5C_L      0x134FB8
#define REG_BK134F_5C_H      0x134FB9
#define REG_BK134F_5D_L      0x134FBA
#define REG_BK134F_5D_H      0x134FBB
#define REG_BK134F_5E_L      0x134FBC
#define REG_BK134F_5E_H      0x134FBD
#define REG_BK134F_5F_L      0x134FBE
#define REG_BK134F_5F_H      0x134FBF
#define REG_BK134F_60_L      0x134FC0
#define REG_BK134F_60_H      0x134FC1
#define REG_BK134F_61_L      0x134FC2
#define REG_BK134F_61_H      0x134FC3
#define REG_BK134F_62_L      0x134FC4
#define REG_BK134F_62_H      0x134FC5
#define REG_BK134F_63_L      0x134FC6
#define REG_BK134F_63_H      0x134FC7
#define REG_BK134F_64_L      0x134FC8
#define REG_BK134F_64_H      0x134FC9
#define REG_BK134F_65_L      0x134FCA
#define REG_BK134F_65_H      0x134FCB
#define REG_BK134F_66_L      0x134FCC
#define REG_BK134F_66_H      0x134FCD
#define REG_BK134F_67_L      0x134FCE
#define REG_BK134F_67_H      0x134FCF
#define REG_BK134F_68_L      0x134FD0
#define REG_BK134F_68_H      0x134FD1
#define REG_BK134F_69_L      0x134FD2
#define REG_BK134F_69_H      0x134FD3
#define REG_BK134F_6A_L      0x134FD4
#define REG_BK134F_6A_H      0x134FD5
#define REG_BK134F_6B_L      0x134FD6
#define REG_BK134F_6B_H      0x134FD7
#define REG_BK134F_6C_L      0x134FD8
#define REG_BK134F_6C_H      0x134FD9
#define REG_BK134F_6D_L      0x134FDA
#define REG_BK134F_6D_H      0x134FDB
#define REG_BK134F_6E_L      0x134FDC
#define REG_BK134F_6E_H      0x134FDD
#define REG_BK134F_6F_L      0x134FDE
#define REG_BK134F_6F_H      0x134FDF
#define REG_BK134F_70_L      0x134FE0
#define REG_BK134F_70_H      0x134FE1
#define REG_BK134F_71_L      0x134FE2
#define REG_BK134F_71_H      0x134FE3
#define REG_BK134F_72_L      0x134FE4
#define REG_BK134F_72_H      0x134FE5
#define REG_BK134F_73_L      0x134FE6
#define REG_BK134F_73_H      0x134FE7
#define REG_BK134F_74_L      0x134FE8
#define REG_BK134F_74_H      0x134FE9
#define REG_BK134F_75_L      0x134FEA
#define REG_BK134F_75_H      0x134FEB
#define REG_BK134F_76_L      0x134FEC
#define REG_BK134F_76_H      0x134FED
#define REG_BK134F_77_L      0x134FEE
#define REG_BK134F_77_H      0x134FEF
#define REG_BK134F_78_L      0x134FF0
#define REG_BK134F_78_H      0x134FF1
#define REG_BK134F_79_L      0x134FF2
#define REG_BK134F_79_H      0x134FF3
#define REG_BK134F_7A_L      0x134FF4
#define REG_BK134F_7A_H      0x134FF5
#define REG_BK134F_7B_L      0x134FF6
#define REG_BK134F_7B_H      0x134FF7
#define REG_BK134F_7C_L      0x134FF8
#define REG_BK134F_7C_H      0x134FF9
#define REG_BK134F_7D_L      0x134FFA
#define REG_BK134F_7D_H      0x134FFB
#define REG_BK134F_7E_L      0x134FFC
#define REG_BK134F_7E_H      0x134FFD
#define REG_BK134F_7F_L      0x134FFE
#define REG_BK134F_7F_H      0x134FFF
//----------------------------------------------
#define REG_BK1354_00_L      0x135400
#define REG_BK1354_00_H      0x135401
#define REG_BK1354_01_L      0x135402
#define REG_BK1354_01_H      0x135403
#define REG_BK1354_02_L      0x135404
#define REG_BK1354_02_H      0x135405
#define REG_BK1354_03_L      0x135406
#define REG_BK1354_03_H      0x135407
#define REG_BK1354_04_L      0x135408
#define REG_BK1354_04_H      0x135409
#define REG_BK1354_05_L      0x13540A
#define REG_BK1354_05_H      0x13540B
#define REG_BK1354_06_L      0x13540C
#define REG_BK1354_06_H      0x13540D
#define REG_BK1354_07_L      0x13540E
#define REG_BK1354_07_H      0x13540F
#define REG_BK1354_08_L      0x135410
#define REG_BK1354_08_H      0x135411
#define REG_BK1354_09_L      0x135412
#define REG_BK1354_09_H      0x135413
#define REG_BK1354_0A_L      0x135414
#define REG_BK1354_0A_H      0x135415
#define REG_BK1354_0B_L      0x135416
#define REG_BK1354_0B_H      0x135417
#define REG_BK1354_0C_L      0x135418
#define REG_BK1354_0C_H      0x135419
#define REG_BK1354_0D_L      0x13541A
#define REG_BK1354_0D_H      0x13541B
#define REG_BK1354_0E_L      0x13541C
#define REG_BK1354_0E_H      0x13541D
#define REG_BK1354_0F_L      0x13541E
#define REG_BK1354_0F_H      0x13541F
#define REG_BK1354_10_L      0x135420
#define REG_BK1354_10_H      0x135421
#define REG_BK1354_11_L      0x135422
#define REG_BK1354_11_H      0x135423
#define REG_BK1354_12_L      0x135424
#define REG_BK1354_12_H      0x135425
#define REG_BK1354_13_L      0x135426
#define REG_BK1354_13_H      0x135427
#define REG_BK1354_14_L      0x135428
#define REG_BK1354_14_H      0x135429
#define REG_BK1354_15_L      0x13542A
#define REG_BK1354_15_H      0x13542B
#define REG_BK1354_16_L      0x13542C
#define REG_BK1354_16_H      0x13542D
#define REG_BK1354_17_L      0x13542E
#define REG_BK1354_17_H      0x13542F
#define REG_BK1354_18_L      0x135430
#define REG_BK1354_18_H      0x135431
#define REG_BK1354_19_L      0x135432
#define REG_BK1354_19_H      0x135433
#define REG_BK1354_1A_L      0x135434
#define REG_BK1354_1A_H      0x135435
#define REG_BK1354_1B_L      0x135436
#define REG_BK1354_1B_H      0x135437
#define REG_BK1354_1C_L      0x135438
#define REG_BK1354_1C_H      0x135439
#define REG_BK1354_1D_L      0x13543A
#define REG_BK1354_1D_H      0x13543B
#define REG_BK1354_1E_L      0x13543C
#define REG_BK1354_1E_H      0x13543D
#define REG_BK1354_1F_L      0x13543E
#define REG_BK1354_1F_H      0x13543F
#define REG_BK1354_20_L      0x135440
#define REG_BK1354_20_H      0x135441
#define REG_BK1354_21_L      0x135442
#define REG_BK1354_21_H      0x135443
#define REG_BK1354_22_L      0x135444
#define REG_BK1354_22_H      0x135445
#define REG_BK1354_23_L      0x135446
#define REG_BK1354_23_H      0x135447
#define REG_BK1354_24_L      0x135448
#define REG_BK1354_24_H      0x135449
#define REG_BK1354_25_L      0x13544A
#define REG_BK1354_25_H      0x13544B
#define REG_BK1354_26_L      0x13544C
#define REG_BK1354_26_H      0x13544D
#define REG_BK1354_27_L      0x13544E
#define REG_BK1354_27_H      0x13544F
#define REG_BK1354_28_L      0x135450
#define REG_BK1354_28_H      0x135451
#define REG_BK1354_29_L      0x135452
#define REG_BK1354_29_H      0x135453
#define REG_BK1354_2A_L      0x135454
#define REG_BK1354_2A_H      0x135455
#define REG_BK1354_2B_L      0x135456
#define REG_BK1354_2B_H      0x135457
#define REG_BK1354_2C_L      0x135458
#define REG_BK1354_2C_H      0x135459
#define REG_BK1354_2D_L      0x13545A
#define REG_BK1354_2D_H      0x13545B
#define REG_BK1354_2E_L      0x13545C
#define REG_BK1354_2E_H      0x13545D
#define REG_BK1354_2F_L      0x13545E
#define REG_BK1354_2F_H      0x13545F
#define REG_BK1354_30_L      0x135460
#define REG_BK1354_30_H      0x135461
#define REG_BK1354_31_L      0x135462
#define REG_BK1354_31_H      0x135463
#define REG_BK1354_32_L      0x135464
#define REG_BK1354_32_H      0x135465
#define REG_BK1354_33_L      0x135466
#define REG_BK1354_33_H      0x135467
#define REG_BK1354_34_L      0x135468
#define REG_BK1354_34_H      0x135469
#define REG_BK1354_35_L      0x13546A
#define REG_BK1354_35_H      0x13546B
#define REG_BK1354_36_L      0x13546C
#define REG_BK1354_36_H      0x13546D
#define REG_BK1354_37_L      0x13546E
#define REG_BK1354_37_H      0x13546F
#define REG_BK1354_38_L      0x135470
#define REG_BK1354_38_H      0x135471
#define REG_BK1354_39_L      0x135472
#define REG_BK1354_39_H      0x135473
#define REG_BK1354_3A_L      0x135474
#define REG_BK1354_3A_H      0x135475
#define REG_BK1354_3B_L      0x135476
#define REG_BK1354_3B_H      0x135477
#define REG_BK1354_3C_L      0x135478
#define REG_BK1354_3C_H      0x135479
#define REG_BK1354_3D_L      0x13547A
#define REG_BK1354_3D_H      0x13547B
#define REG_BK1354_3E_L      0x13547C
#define REG_BK1354_3E_H      0x13547D
#define REG_BK1354_3F_L      0x13547E
#define REG_BK1354_3F_H      0x13547F
#define REG_BK1354_40_L      0x135480
#define REG_BK1354_40_H      0x135481
#define REG_BK1354_41_L      0x135482
#define REG_BK1354_41_H      0x135483
#define REG_BK1354_42_L      0x135484
#define REG_BK1354_42_H      0x135485
#define REG_BK1354_43_L      0x135486
#define REG_BK1354_43_H      0x135487
#define REG_BK1354_44_L      0x135488
#define REG_BK1354_44_H      0x135489
#define REG_BK1354_45_L      0x13548A
#define REG_BK1354_45_H      0x13548B
#define REG_BK1354_46_L      0x13548C
#define REG_BK1354_46_H      0x13548D
#define REG_BK1354_47_L      0x13548E
#define REG_BK1354_47_H      0x13548F
#define REG_BK1354_48_L      0x135490
#define REG_BK1354_48_H      0x135491
#define REG_BK1354_49_L      0x135492
#define REG_BK1354_49_H      0x135493
#define REG_BK1354_4A_L      0x135494
#define REG_BK1354_4A_H      0x135495
#define REG_BK1354_4B_L      0x135496
#define REG_BK1354_4B_H      0x135497
#define REG_BK1354_4C_L      0x135498
#define REG_BK1354_4C_H      0x135499
#define REG_BK1354_4D_L      0x13549A
#define REG_BK1354_4D_H      0x13549B
#define REG_BK1354_4E_L      0x13549C
#define REG_BK1354_4E_H      0x13549D
#define REG_BK1354_4F_L      0x13549E
#define REG_BK1354_4F_H      0x13549F
#define REG_BK1354_50_L      0x1354A0
#define REG_BK1354_50_H      0x1354A1
#define REG_BK1354_51_L      0x1354A2
#define REG_BK1354_51_H      0x1354A3
#define REG_BK1354_52_L      0x1354A4
#define REG_BK1354_52_H      0x1354A5
#define REG_BK1354_53_L      0x1354A6
#define REG_BK1354_53_H      0x1354A7
#define REG_BK1354_54_L      0x1354A8
#define REG_BK1354_54_H      0x1354A9
#define REG_BK1354_55_L      0x1354AA
#define REG_BK1354_55_H      0x1354AB
#define REG_BK1354_56_L      0x1354AC
#define REG_BK1354_56_H      0x1354AD
#define REG_BK1354_57_L      0x1354AE
#define REG_BK1354_57_H      0x1354AF
#define REG_BK1354_58_L      0x1354B0
#define REG_BK1354_58_H      0x1354B1
#define REG_BK1354_59_L      0x1354B2
#define REG_BK1354_59_H      0x1354B3
#define REG_BK1354_5A_L      0x1354B4
#define REG_BK1354_5A_H      0x1354B5
#define REG_BK1354_5B_L      0x1354B6
#define REG_BK1354_5B_H      0x1354B7
#define REG_BK1354_5C_L      0x1354B8
#define REG_BK1354_5C_H      0x1354B9
#define REG_BK1354_5D_L      0x1354BA
#define REG_BK1354_5D_H      0x1354BB
#define REG_BK1354_5E_L      0x1354BC
#define REG_BK1354_5E_H      0x1354BD
#define REG_BK1354_5F_L      0x1354BE
#define REG_BK1354_5F_H      0x1354BF
#define REG_BK1354_60_L      0x1354C0
#define REG_BK1354_60_H      0x1354C1
#define REG_BK1354_61_L      0x1354C2
#define REG_BK1354_61_H      0x1354C3
#define REG_BK1354_62_L      0x1354C4
#define REG_BK1354_62_H      0x1354C5
#define REG_BK1354_63_L      0x1354C6
#define REG_BK1354_63_H      0x1354C7
#define REG_BK1354_64_L      0x1354C8
#define REG_BK1354_64_H      0x1354C9
#define REG_BK1354_65_L      0x1354CA
#define REG_BK1354_65_H      0x1354CB
#define REG_BK1354_66_L      0x1354CC
#define REG_BK1354_66_H      0x1354CD
#define REG_BK1354_67_L      0x1354CE
#define REG_BK1354_67_H      0x1354CF
#define REG_BK1354_68_L      0x1354D0
#define REG_BK1354_68_H      0x1354D1
#define REG_BK1354_69_L      0x1354D2
#define REG_BK1354_69_H      0x1354D3
#define REG_BK1354_6A_L      0x1354D4
#define REG_BK1354_6A_H      0x1354D5
#define REG_BK1354_6B_L      0x1354D6
#define REG_BK1354_6B_H      0x1354D7
#define REG_BK1354_6C_L      0x1354D8
#define REG_BK1354_6C_H      0x1354D9
#define REG_BK1354_6D_L      0x1354DA
#define REG_BK1354_6D_H      0x1354DB
#define REG_BK1354_6E_L      0x1354DC
#define REG_BK1354_6E_H      0x1354DD
#define REG_BK1354_6F_L      0x1354DE
#define REG_BK1354_6F_H      0x1354DF
#define REG_BK1354_70_L      0x1354E0
#define REG_BK1354_70_H      0x1354E1
#define REG_BK1354_71_L      0x1354E2
#define REG_BK1354_71_H      0x1354E3
#define REG_BK1354_72_L      0x1354E4
#define REG_BK1354_72_H      0x1354E5
#define REG_BK1354_73_L      0x1354E6
#define REG_BK1354_73_H      0x1354E7
#define REG_BK1354_74_L      0x1354E8
#define REG_BK1354_74_H      0x1354E9
#define REG_BK1354_75_L      0x1354EA
#define REG_BK1354_75_H      0x1354EB
#define REG_BK1354_76_L      0x1354EC
#define REG_BK1354_76_H      0x1354ED
#define REG_BK1354_77_L      0x1354EE
#define REG_BK1354_77_H      0x1354EF
#define REG_BK1354_78_L      0x1354F0
#define REG_BK1354_78_H      0x1354F1
#define REG_BK1354_79_L      0x1354F2
#define REG_BK1354_79_H      0x1354F3
#define REG_BK1354_7A_L      0x1354F4
#define REG_BK1354_7A_H      0x1354F5
#define REG_BK1354_7B_L      0x1354F6
#define REG_BK1354_7B_H      0x1354F7
#define REG_BK1354_7C_L      0x1354F8
#define REG_BK1354_7C_H      0x1354F9
#define REG_BK1354_7D_L      0x1354FA
#define REG_BK1354_7D_H      0x1354FB
#define REG_BK1354_7E_L      0x1354FC
#define REG_BK1354_7E_H      0x1354FD
#define REG_BK1354_7F_L      0x1354FE
#define REG_BK1354_7F_H      0x1354FF
//----------------------------------------------
#define REG_BK1355_00_L      0x135500
#define REG_BK1355_00_H      0x135501
#define REG_BK1355_01_L      0x135502
#define REG_BK1355_01_H      0x135503
#define REG_BK1355_02_L      0x135504
#define REG_BK1355_02_H      0x135505
#define REG_BK1355_03_L      0x135506
#define REG_BK1355_03_H      0x135507
#define REG_BK1355_04_L      0x135508
#define REG_BK1355_04_H      0x135509
#define REG_BK1355_05_L      0x13550A
#define REG_BK1355_05_H      0x13550B
#define REG_BK1355_06_L      0x13550C
#define REG_BK1355_06_H      0x13550D
#define REG_BK1355_07_L      0x13550E
#define REG_BK1355_07_H      0x13550F
#define REG_BK1355_08_L      0x135510
#define REG_BK1355_08_H      0x135511
#define REG_BK1355_09_L      0x135512
#define REG_BK1355_09_H      0x135513
#define REG_BK1355_0A_L      0x135514
#define REG_BK1355_0A_H      0x135515
#define REG_BK1355_0B_L      0x135516
#define REG_BK1355_0B_H      0x135517
#define REG_BK1355_0C_L      0x135518
#define REG_BK1355_0C_H      0x135519
#define REG_BK1355_0D_L      0x13551A
#define REG_BK1355_0D_H      0x13551B
#define REG_BK1355_0E_L      0x13551C
#define REG_BK1355_0E_H      0x13551D
#define REG_BK1355_0F_L      0x13551E
#define REG_BK1355_0F_H      0x13551F
#define REG_BK1355_10_L      0x135520
#define REG_BK1355_10_H      0x135521
#define REG_BK1355_11_L      0x135522
#define REG_BK1355_11_H      0x135523
#define REG_BK1355_12_L      0x135524
#define REG_BK1355_12_H      0x135525
#define REG_BK1355_13_L      0x135526
#define REG_BK1355_13_H      0x135527
#define REG_BK1355_14_L      0x135528
#define REG_BK1355_14_H      0x135529
#define REG_BK1355_15_L      0x13552A
#define REG_BK1355_15_H      0x13552B
#define REG_BK1355_16_L      0x13552C
#define REG_BK1355_16_H      0x13552D
#define REG_BK1355_17_L      0x13552E
#define REG_BK1355_17_H      0x13552F
#define REG_BK1355_18_L      0x135530
#define REG_BK1355_18_H      0x135531
#define REG_BK1355_19_L      0x135532
#define REG_BK1355_19_H      0x135533
#define REG_BK1355_1A_L      0x135534
#define REG_BK1355_1A_H      0x135535
#define REG_BK1355_1B_L      0x135536
#define REG_BK1355_1B_H      0x135537
#define REG_BK1355_1C_L      0x135538
#define REG_BK1355_1C_H      0x135539
#define REG_BK1355_1D_L      0x13553A
#define REG_BK1355_1D_H      0x13553B
#define REG_BK1355_1E_L      0x13553C
#define REG_BK1355_1E_H      0x13553D
#define REG_BK1355_1F_L      0x13553E
#define REG_BK1355_1F_H      0x13553F
#define REG_BK1355_20_L      0x135540
#define REG_BK1355_20_H      0x135541
#define REG_BK1355_21_L      0x135542
#define REG_BK1355_21_H      0x135543
#define REG_BK1355_22_L      0x135544
#define REG_BK1355_22_H      0x135545
#define REG_BK1355_23_L      0x135546
#define REG_BK1355_23_H      0x135547
#define REG_BK1355_24_L      0x135548
#define REG_BK1355_24_H      0x135549
#define REG_BK1355_25_L      0x13554A
#define REG_BK1355_25_H      0x13554B
#define REG_BK1355_26_L      0x13554C
#define REG_BK1355_26_H      0x13554D
#define REG_BK1355_27_L      0x13554E
#define REG_BK1355_27_H      0x13554F
#define REG_BK1355_28_L      0x135550
#define REG_BK1355_28_H      0x135551
#define REG_BK1355_29_L      0x135552
#define REG_BK1355_29_H      0x135553
#define REG_BK1355_2A_L      0x135554
#define REG_BK1355_2A_H      0x135555
#define REG_BK1355_2B_L      0x135556
#define REG_BK1355_2B_H      0x135557
#define REG_BK1355_2C_L      0x135558
#define REG_BK1355_2C_H      0x135559
#define REG_BK1355_2D_L      0x13555A
#define REG_BK1355_2D_H      0x13555B
#define REG_BK1355_2E_L      0x13555C
#define REG_BK1355_2E_H      0x13555D
#define REG_BK1355_2F_L      0x13555E
#define REG_BK1355_2F_H      0x13555F
#define REG_BK1355_30_L      0x135560
#define REG_BK1355_30_H      0x135561
#define REG_BK1355_31_L      0x135562
#define REG_BK1355_31_H      0x135563
#define REG_BK1355_32_L      0x135564
#define REG_BK1355_32_H      0x135565
#define REG_BK1355_33_L      0x135566
#define REG_BK1355_33_H      0x135567
#define REG_BK1355_34_L      0x135568
#define REG_BK1355_34_H      0x135569
#define REG_BK1355_35_L      0x13556A
#define REG_BK1355_35_H      0x13556B
#define REG_BK1355_36_L      0x13556C
#define REG_BK1355_36_H      0x13556D
#define REG_BK1355_37_L      0x13556E
#define REG_BK1355_37_H      0x13556F
#define REG_BK1355_38_L      0x135570
#define REG_BK1355_38_H      0x135571
#define REG_BK1355_39_L      0x135572
#define REG_BK1355_39_H      0x135573
#define REG_BK1355_3A_L      0x135574
#define REG_BK1355_3A_H      0x135575
#define REG_BK1355_3B_L      0x135576
#define REG_BK1355_3B_H      0x135577
#define REG_BK1355_3C_L      0x135578
#define REG_BK1355_3C_H      0x135579
#define REG_BK1355_3D_L      0x13557A
#define REG_BK1355_3D_H      0x13557B
#define REG_BK1355_3E_L      0x13557C
#define REG_BK1355_3E_H      0x13557D
#define REG_BK1355_3F_L      0x13557E
#define REG_BK1355_3F_H      0x13557F
#define REG_BK1355_40_L      0x135580
#define REG_BK1355_40_H      0x135581
#define REG_BK1355_41_L      0x135582
#define REG_BK1355_41_H      0x135583
#define REG_BK1355_42_L      0x135584
#define REG_BK1355_42_H      0x135585
#define REG_BK1355_43_L      0x135586
#define REG_BK1355_43_H      0x135587
#define REG_BK1355_44_L      0x135588
#define REG_BK1355_44_H      0x135589
#define REG_BK1355_45_L      0x13558A
#define REG_BK1355_45_H      0x13558B
#define REG_BK1355_46_L      0x13558C
#define REG_BK1355_46_H      0x13558D
#define REG_BK1355_47_L      0x13558E
#define REG_BK1355_47_H      0x13558F
#define REG_BK1355_48_L      0x135590
#define REG_BK1355_48_H      0x135591
#define REG_BK1355_49_L      0x135592
#define REG_BK1355_49_H      0x135593
#define REG_BK1355_4A_L      0x135594
#define REG_BK1355_4A_H      0x135595
#define REG_BK1355_4B_L      0x135596
#define REG_BK1355_4B_H      0x135597
#define REG_BK1355_4C_L      0x135598
#define REG_BK1355_4C_H      0x135599
#define REG_BK1355_4D_L      0x13559A
#define REG_BK1355_4D_H      0x13559B
#define REG_BK1355_4E_L      0x13559C
#define REG_BK1355_4E_H      0x13559D
#define REG_BK1355_4F_L      0x13559E
#define REG_BK1355_4F_H      0x13559F
#define REG_BK1355_50_L      0x1355A0
#define REG_BK1355_50_H      0x1355A1
#define REG_BK1355_51_L      0x1355A2
#define REG_BK1355_51_H      0x1355A3
#define REG_BK1355_52_L      0x1355A4
#define REG_BK1355_52_H      0x1355A5
#define REG_BK1355_53_L      0x1355A6
#define REG_BK1355_53_H      0x1355A7
#define REG_BK1355_54_L      0x1355A8
#define REG_BK1355_54_H      0x1355A9
#define REG_BK1355_55_L      0x1355AA
#define REG_BK1355_55_H      0x1355AB
#define REG_BK1355_56_L      0x1355AC
#define REG_BK1355_56_H      0x1355AD
#define REG_BK1355_57_L      0x1355AE
#define REG_BK1355_57_H      0x1355AF
#define REG_BK1355_58_L      0x1355B0
#define REG_BK1355_58_H      0x1355B1
#define REG_BK1355_59_L      0x1355B2
#define REG_BK1355_59_H      0x1355B3
#define REG_BK1355_5A_L      0x1355B4
#define REG_BK1355_5A_H      0x1355B5
#define REG_BK1355_5B_L      0x1355B6
#define REG_BK1355_5B_H      0x1355B7
#define REG_BK1355_5C_L      0x1355B8
#define REG_BK1355_5C_H      0x1355B9
#define REG_BK1355_5D_L      0x1355BA
#define REG_BK1355_5D_H      0x1355BB
#define REG_BK1355_5E_L      0x1355BC
#define REG_BK1355_5E_H      0x1355BD
#define REG_BK1355_5F_L      0x1355BE
#define REG_BK1355_5F_H      0x1355BF
#define REG_BK1355_60_L      0x1355C0
#define REG_BK1355_60_H      0x1355C1
#define REG_BK1355_61_L      0x1355C2
#define REG_BK1355_61_H      0x1355C3
#define REG_BK1355_62_L      0x1355C4
#define REG_BK1355_62_H      0x1355C5
#define REG_BK1355_63_L      0x1355C6
#define REG_BK1355_63_H      0x1355C7
#define REG_BK1355_64_L      0x1355C8
#define REG_BK1355_64_H      0x1355C9
#define REG_BK1355_65_L      0x1355CA
#define REG_BK1355_65_H      0x1355CB
#define REG_BK1355_66_L      0x1355CC
#define REG_BK1355_66_H      0x1355CD
#define REG_BK1355_67_L      0x1355CE
#define REG_BK1355_67_H      0x1355CF
#define REG_BK1355_68_L      0x1355D0
#define REG_BK1355_68_H      0x1355D1
#define REG_BK1355_69_L      0x1355D2
#define REG_BK1355_69_H      0x1355D3
#define REG_BK1355_6A_L      0x1355D4
#define REG_BK1355_6A_H      0x1355D5
#define REG_BK1355_6B_L      0x1355D6
#define REG_BK1355_6B_H      0x1355D7
#define REG_BK1355_6C_L      0x1355D8
#define REG_BK1355_6C_H      0x1355D9
#define REG_BK1355_6D_L      0x1355DA
#define REG_BK1355_6D_H      0x1355DB
#define REG_BK1355_6E_L      0x1355DC
#define REG_BK1355_6E_H      0x1355DD
#define REG_BK1355_6F_L      0x1355DE
#define REG_BK1355_6F_H      0x1355DF
#define REG_BK1355_70_L      0x1355E0
#define REG_BK1355_70_H      0x1355E1
#define REG_BK1355_71_L      0x1355E2
#define REG_BK1355_71_H      0x1355E3
#define REG_BK1355_72_L      0x1355E4
#define REG_BK1355_72_H      0x1355E5
#define REG_BK1355_73_L      0x1355E6
#define REG_BK1355_73_H      0x1355E7
#define REG_BK1355_74_L      0x1355E8
#define REG_BK1355_74_H      0x1355E9
#define REG_BK1355_75_L      0x1355EA
#define REG_BK1355_75_H      0x1355EB
#define REG_BK1355_76_L      0x1355EC
#define REG_BK1355_76_H      0x1355ED
#define REG_BK1355_77_L      0x1355EE
#define REG_BK1355_77_H      0x1355EF
#define REG_BK1355_78_L      0x1355F0
#define REG_BK1355_78_H      0x1355F1
#define REG_BK1355_79_L      0x1355F2
#define REG_BK1355_79_H      0x1355F3
#define REG_BK1355_7A_L      0x1355F4
#define REG_BK1355_7A_H      0x1355F5
#define REG_BK1355_7B_L      0x1355F6
#define REG_BK1355_7B_H      0x1355F7
#define REG_BK1355_7C_L      0x1355F8
#define REG_BK1355_7C_H      0x1355F9
#define REG_BK1355_7D_L      0x1355FA
#define REG_BK1355_7D_H      0x1355FB
#define REG_BK1355_7E_L      0x1355FC
#define REG_BK1355_7E_H      0x1355FD
#define REG_BK1355_7F_L      0x1355FE
#define REG_BK1355_7F_H      0x1355FF
//----------------------------------------------
#define REG_BK1356_00_L      0x135600
#define REG_BK1356_00_H      0x135601
#define REG_BK1356_01_L      0x135602
#define REG_BK1356_01_H      0x135603
#define REG_BK1356_02_L      0x135604
#define REG_BK1356_02_H      0x135605
#define REG_BK1356_03_L      0x135606
#define REG_BK1356_03_H      0x135607
#define REG_BK1356_04_L      0x135608
#define REG_BK1356_04_H      0x135609
#define REG_BK1356_05_L      0x13560A
#define REG_BK1356_05_H      0x13560B
#define REG_BK1356_06_L      0x13560C
#define REG_BK1356_06_H      0x13560D
#define REG_BK1356_07_L      0x13560E
#define REG_BK1356_07_H      0x13560F
#define REG_BK1356_08_L      0x135610
#define REG_BK1356_08_H      0x135611
#define REG_BK1356_09_L      0x135612
#define REG_BK1356_09_H      0x135613
#define REG_BK1356_0A_L      0x135614
#define REG_BK1356_0A_H      0x135615
#define REG_BK1356_0B_L      0x135616
#define REG_BK1356_0B_H      0x135617
#define REG_BK1356_0C_L      0x135618
#define REG_BK1356_0C_H      0x135619
#define REG_BK1356_0D_L      0x13561A
#define REG_BK1356_0D_H      0x13561B
#define REG_BK1356_0E_L      0x13561C
#define REG_BK1356_0E_H      0x13561D
#define REG_BK1356_0F_L      0x13561E
#define REG_BK1356_0F_H      0x13561F
#define REG_BK1356_10_L      0x135620
#define REG_BK1356_10_H      0x135621
#define REG_BK1356_11_L      0x135622
#define REG_BK1356_11_H      0x135623
#define REG_BK1356_12_L      0x135624
#define REG_BK1356_12_H      0x135625
#define REG_BK1356_13_L      0x135626
#define REG_BK1356_13_H      0x135627
#define REG_BK1356_14_L      0x135628
#define REG_BK1356_14_H      0x135629
#define REG_BK1356_15_L      0x13562A
#define REG_BK1356_15_H      0x13562B
#define REG_BK1356_16_L      0x13562C
#define REG_BK1356_16_H      0x13562D
#define REG_BK1356_17_L      0x13562E
#define REG_BK1356_17_H      0x13562F
#define REG_BK1356_18_L      0x135630
#define REG_BK1356_18_H      0x135631
#define REG_BK1356_19_L      0x135632
#define REG_BK1356_19_H      0x135633
#define REG_BK1356_1A_L      0x135634
#define REG_BK1356_1A_H      0x135635
#define REG_BK1356_1B_L      0x135636
#define REG_BK1356_1B_H      0x135637
#define REG_BK1356_1C_L      0x135638
#define REG_BK1356_1C_H      0x135639
#define REG_BK1356_1D_L      0x13563A
#define REG_BK1356_1D_H      0x13563B
#define REG_BK1356_1E_L      0x13563C
#define REG_BK1356_1E_H      0x13563D
#define REG_BK1356_1F_L      0x13563E
#define REG_BK1356_1F_H      0x13563F
#define REG_BK1356_20_L      0x135640
#define REG_BK1356_20_H      0x135641
#define REG_BK1356_21_L      0x135642
#define REG_BK1356_21_H      0x135643
#define REG_BK1356_22_L      0x135644
#define REG_BK1356_22_H      0x135645
#define REG_BK1356_23_L      0x135646
#define REG_BK1356_23_H      0x135647
#define REG_BK1356_24_L      0x135648
#define REG_BK1356_24_H      0x135649
#define REG_BK1356_25_L      0x13564A
#define REG_BK1356_25_H      0x13564B
#define REG_BK1356_26_L      0x13564C
#define REG_BK1356_26_H      0x13564D
#define REG_BK1356_27_L      0x13564E
#define REG_BK1356_27_H      0x13564F
#define REG_BK1356_28_L      0x135650
#define REG_BK1356_28_H      0x135651
#define REG_BK1356_29_L      0x135652
#define REG_BK1356_29_H      0x135653
#define REG_BK1356_2A_L      0x135654
#define REG_BK1356_2A_H      0x135655
#define REG_BK1356_2B_L      0x135656
#define REG_BK1356_2B_H      0x135657
#define REG_BK1356_2C_L      0x135658
#define REG_BK1356_2C_H      0x135659
#define REG_BK1356_2D_L      0x13565A
#define REG_BK1356_2D_H      0x13565B
#define REG_BK1356_2E_L      0x13565C
#define REG_BK1356_2E_H      0x13565D
#define REG_BK1356_2F_L      0x13565E
#define REG_BK1356_2F_H      0x13565F
#define REG_BK1356_30_L      0x135660
#define REG_BK1356_30_H      0x135661
#define REG_BK1356_31_L      0x135662
#define REG_BK1356_31_H      0x135663
#define REG_BK1356_32_L      0x135664
#define REG_BK1356_32_H      0x135665
#define REG_BK1356_33_L      0x135666
#define REG_BK1356_33_H      0x135667
#define REG_BK1356_34_L      0x135668
#define REG_BK1356_34_H      0x135669
#define REG_BK1356_35_L      0x13566A
#define REG_BK1356_35_H      0x13566B
#define REG_BK1356_36_L      0x13566C
#define REG_BK1356_36_H      0x13566D
#define REG_BK1356_37_L      0x13566E
#define REG_BK1356_37_H      0x13566F
#define REG_BK1356_38_L      0x135670
#define REG_BK1356_38_H      0x135671
#define REG_BK1356_39_L      0x135672
#define REG_BK1356_39_H      0x135673
#define REG_BK1356_3A_L      0x135674
#define REG_BK1356_3A_H      0x135675
#define REG_BK1356_3B_L      0x135676
#define REG_BK1356_3B_H      0x135677
#define REG_BK1356_3C_L      0x135678
#define REG_BK1356_3C_H      0x135679
#define REG_BK1356_3D_L      0x13567A
#define REG_BK1356_3D_H      0x13567B
#define REG_BK1356_3E_L      0x13567C
#define REG_BK1356_3E_H      0x13567D
#define REG_BK1356_3F_L      0x13567E
#define REG_BK1356_3F_H      0x13567F
#define REG_BK1356_40_L      0x135680
#define REG_BK1356_40_H      0x135681
#define REG_BK1356_41_L      0x135682
#define REG_BK1356_41_H      0x135683
#define REG_BK1356_42_L      0x135684
#define REG_BK1356_42_H      0x135685
#define REG_BK1356_43_L      0x135686
#define REG_BK1356_43_H      0x135687
#define REG_BK1356_44_L      0x135688
#define REG_BK1356_44_H      0x135689
#define REG_BK1356_45_L      0x13568A
#define REG_BK1356_45_H      0x13568B
#define REG_BK1356_46_L      0x13568C
#define REG_BK1356_46_H      0x13568D
#define REG_BK1356_47_L      0x13568E
#define REG_BK1356_47_H      0x13568F
#define REG_BK1356_48_L      0x135690
#define REG_BK1356_48_H      0x135691
#define REG_BK1356_49_L      0x135692
#define REG_BK1356_49_H      0x135693
#define REG_BK1356_4A_L      0x135694
#define REG_BK1356_4A_H      0x135695
#define REG_BK1356_4B_L      0x135696
#define REG_BK1356_4B_H      0x135697
#define REG_BK1356_4C_L      0x135698
#define REG_BK1356_4C_H      0x135699
#define REG_BK1356_4D_L      0x13569A
#define REG_BK1356_4D_H      0x13569B
#define REG_BK1356_4E_L      0x13569C
#define REG_BK1356_4E_H      0x13569D
#define REG_BK1356_4F_L      0x13569E
#define REG_BK1356_4F_H      0x13569F
#define REG_BK1356_50_L      0x1356A0
#define REG_BK1356_50_H      0x1356A1
#define REG_BK1356_51_L      0x1356A2
#define REG_BK1356_51_H      0x1356A3
#define REG_BK1356_52_L      0x1356A4
#define REG_BK1356_52_H      0x1356A5
#define REG_BK1356_53_L      0x1356A6
#define REG_BK1356_53_H      0x1356A7
#define REG_BK1356_54_L      0x1356A8
#define REG_BK1356_54_H      0x1356A9
#define REG_BK1356_55_L      0x1356AA
#define REG_BK1356_55_H      0x1356AB
#define REG_BK1356_56_L      0x1356AC
#define REG_BK1356_56_H      0x1356AD
#define REG_BK1356_57_L      0x1356AE
#define REG_BK1356_57_H      0x1356AF
#define REG_BK1356_58_L      0x1356B0
#define REG_BK1356_58_H      0x1356B1
#define REG_BK1356_59_L      0x1356B2
#define REG_BK1356_59_H      0x1356B3
#define REG_BK1356_5A_L      0x1356B4
#define REG_BK1356_5A_H      0x1356B5
#define REG_BK1356_5B_L      0x1356B6
#define REG_BK1356_5B_H      0x1356B7
#define REG_BK1356_5C_L      0x1356B8
#define REG_BK1356_5C_H      0x1356B9
#define REG_BK1356_5D_L      0x1356BA
#define REG_BK1356_5D_H      0x1356BB
#define REG_BK1356_5E_L      0x1356BC
#define REG_BK1356_5E_H      0x1356BD
#define REG_BK1356_5F_L      0x1356BE
#define REG_BK1356_5F_H      0x1356BF
#define REG_BK1356_60_L      0x1356C0
#define REG_BK1356_60_H      0x1356C1
#define REG_BK1356_61_L      0x1356C2
#define REG_BK1356_61_H      0x1356C3
#define REG_BK1356_62_L      0x1356C4
#define REG_BK1356_62_H      0x1356C5
#define REG_BK1356_63_L      0x1356C6
#define REG_BK1356_63_H      0x1356C7
#define REG_BK1356_64_L      0x1356C8
#define REG_BK1356_64_H      0x1356C9
#define REG_BK1356_65_L      0x1356CA
#define REG_BK1356_65_H      0x1356CB
#define REG_BK1356_66_L      0x1356CC
#define REG_BK1356_66_H      0x1356CD
#define REG_BK1356_67_L      0x1356CE
#define REG_BK1356_67_H      0x1356CF
#define REG_BK1356_68_L      0x1356D0
#define REG_BK1356_68_H      0x1356D1
#define REG_BK1356_69_L      0x1356D2
#define REG_BK1356_69_H      0x1356D3
#define REG_BK1356_6A_L      0x1356D4
#define REG_BK1356_6A_H      0x1356D5
#define REG_BK1356_6B_L      0x1356D6
#define REG_BK1356_6B_H      0x1356D7
#define REG_BK1356_6C_L      0x1356D8
#define REG_BK1356_6C_H      0x1356D9
#define REG_BK1356_6D_L      0x1356DA
#define REG_BK1356_6D_H      0x1356DB
#define REG_BK1356_6E_L      0x1356DC
#define REG_BK1356_6E_H      0x1356DD
#define REG_BK1356_6F_L      0x1356DE
#define REG_BK1356_6F_H      0x1356DF
#define REG_BK1356_70_L      0x1356E0
#define REG_BK1356_70_H      0x1356E1
#define REG_BK1356_71_L      0x1356E2
#define REG_BK1356_71_H      0x1356E3
#define REG_BK1356_72_L      0x1356E4
#define REG_BK1356_72_H      0x1356E5
#define REG_BK1356_73_L      0x1356E6
#define REG_BK1356_73_H      0x1356E7
#define REG_BK1356_74_L      0x1356E8
#define REG_BK1356_74_H      0x1356E9
#define REG_BK1356_75_L      0x1356EA
#define REG_BK1356_75_H      0x1356EB
#define REG_BK1356_76_L      0x1356EC
#define REG_BK1356_76_H      0x1356ED
#define REG_BK1356_77_L      0x1356EE
#define REG_BK1356_77_H      0x1356EF
#define REG_BK1356_78_L      0x1356F0
#define REG_BK1356_78_H      0x1356F1
#define REG_BK1356_79_L      0x1356F2
#define REG_BK1356_79_H      0x1356F3
#define REG_BK1356_7A_L      0x1356F4
#define REG_BK1356_7A_H      0x1356F5
#define REG_BK1356_7B_L      0x1356F6
#define REG_BK1356_7B_H      0x1356F7
#define REG_BK1356_7C_L      0x1356F8
#define REG_BK1356_7C_H      0x1356F9
#define REG_BK1356_7D_L      0x1356FA
#define REG_BK1356_7D_H      0x1356FB
#define REG_BK1356_7E_L      0x1356FC
#define REG_BK1356_7E_H      0x1356FD
#define REG_BK1356_7F_L      0x1356FE
#define REG_BK1356_7F_H      0x1356FF
//----------------------------------------------
#define REG_BK1357_00_L      0x135700
#define REG_BK1357_00_H      0x135701
#define REG_BK1357_01_L      0x135702
#define REG_BK1357_01_H      0x135703
#define REG_BK1357_02_L      0x135704
#define REG_BK1357_02_H      0x135705
#define REG_BK1357_03_L      0x135706
#define REG_BK1357_03_H      0x135707
#define REG_BK1357_04_L      0x135708
#define REG_BK1357_04_H      0x135709
#define REG_BK1357_05_L      0x13570A
#define REG_BK1357_05_H      0x13570B
#define REG_BK1357_06_L      0x13570C
#define REG_BK1357_06_H      0x13570D
#define REG_BK1357_07_L      0x13570E
#define REG_BK1357_07_H      0x13570F
#define REG_BK1357_08_L      0x135710
#define REG_BK1357_08_H      0x135711
#define REG_BK1357_09_L      0x135712
#define REG_BK1357_09_H      0x135713
#define REG_BK1357_0A_L      0x135714
#define REG_BK1357_0A_H      0x135715
#define REG_BK1357_0B_L      0x135716
#define REG_BK1357_0B_H      0x135717
#define REG_BK1357_0C_L      0x135718
#define REG_BK1357_0C_H      0x135719
#define REG_BK1357_0D_L      0x13571A
#define REG_BK1357_0D_H      0x13571B
#define REG_BK1357_0E_L      0x13571C
#define REG_BK1357_0E_H      0x13571D
#define REG_BK1357_0F_L      0x13571E
#define REG_BK1357_0F_H      0x13571F
#define REG_BK1357_10_L      0x135720
#define REG_BK1357_10_H      0x135721
#define REG_BK1357_11_L      0x135722
#define REG_BK1357_11_H      0x135723
#define REG_BK1357_12_L      0x135724
#define REG_BK1357_12_H      0x135725
#define REG_BK1357_13_L      0x135726
#define REG_BK1357_13_H      0x135727
#define REG_BK1357_14_L      0x135728
#define REG_BK1357_14_H      0x135729
#define REG_BK1357_15_L      0x13572A
#define REG_BK1357_15_H      0x13572B
#define REG_BK1357_16_L      0x13572C
#define REG_BK1357_16_H      0x13572D
#define REG_BK1357_17_L      0x13572E
#define REG_BK1357_17_H      0x13572F
#define REG_BK1357_18_L      0x135730
#define REG_BK1357_18_H      0x135731
#define REG_BK1357_19_L      0x135732
#define REG_BK1357_19_H      0x135733
#define REG_BK1357_1A_L      0x135734
#define REG_BK1357_1A_H      0x135735
#define REG_BK1357_1B_L      0x135736
#define REG_BK1357_1B_H      0x135737
#define REG_BK1357_1C_L      0x135738
#define REG_BK1357_1C_H      0x135739
#define REG_BK1357_1D_L      0x13573A
#define REG_BK1357_1D_H      0x13573B
#define REG_BK1357_1E_L      0x13573C
#define REG_BK1357_1E_H      0x13573D
#define REG_BK1357_1F_L      0x13573E
#define REG_BK1357_1F_H      0x13573F
#define REG_BK1357_20_L      0x135740
#define REG_BK1357_20_H      0x135741
#define REG_BK1357_21_L      0x135742
#define REG_BK1357_21_H      0x135743
#define REG_BK1357_22_L      0x135744
#define REG_BK1357_22_H      0x135745
#define REG_BK1357_23_L      0x135746
#define REG_BK1357_23_H      0x135747
#define REG_BK1357_24_L      0x135748
#define REG_BK1357_24_H      0x135749
#define REG_BK1357_25_L      0x13574A
#define REG_BK1357_25_H      0x13574B
#define REG_BK1357_26_L      0x13574C
#define REG_BK1357_26_H      0x13574D
#define REG_BK1357_27_L      0x13574E
#define REG_BK1357_27_H      0x13574F
#define REG_BK1357_28_L      0x135750
#define REG_BK1357_28_H      0x135751
#define REG_BK1357_29_L      0x135752
#define REG_BK1357_29_H      0x135753
#define REG_BK1357_2A_L      0x135754
#define REG_BK1357_2A_H      0x135755
#define REG_BK1357_2B_L      0x135756
#define REG_BK1357_2B_H      0x135757
#define REG_BK1357_2C_L      0x135758
#define REG_BK1357_2C_H      0x135759
#define REG_BK1357_2D_L      0x13575A
#define REG_BK1357_2D_H      0x13575B
#define REG_BK1357_2E_L      0x13575C
#define REG_BK1357_2E_H      0x13575D
#define REG_BK1357_2F_L      0x13575E
#define REG_BK1357_2F_H      0x13575F
#define REG_BK1357_30_L      0x135760
#define REG_BK1357_30_H      0x135761
#define REG_BK1357_31_L      0x135762
#define REG_BK1357_31_H      0x135763
#define REG_BK1357_32_L      0x135764
#define REG_BK1357_32_H      0x135765
#define REG_BK1357_33_L      0x135766
#define REG_BK1357_33_H      0x135767
#define REG_BK1357_34_L      0x135768
#define REG_BK1357_34_H      0x135769
#define REG_BK1357_35_L      0x13576A
#define REG_BK1357_35_H      0x13576B
#define REG_BK1357_36_L      0x13576C
#define REG_BK1357_36_H      0x13576D
#define REG_BK1357_37_L      0x13576E
#define REG_BK1357_37_H      0x13576F
#define REG_BK1357_38_L      0x135770
#define REG_BK1357_38_H      0x135771
#define REG_BK1357_39_L      0x135772
#define REG_BK1357_39_H      0x135773
#define REG_BK1357_3A_L      0x135774
#define REG_BK1357_3A_H      0x135775
#define REG_BK1357_3B_L      0x135776
#define REG_BK1357_3B_H      0x135777
#define REG_BK1357_3C_L      0x135778
#define REG_BK1357_3C_H      0x135779
#define REG_BK1357_3D_L      0x13577A
#define REG_BK1357_3D_H      0x13577B
#define REG_BK1357_3E_L      0x13577C
#define REG_BK1357_3E_H      0x13577D
#define REG_BK1357_3F_L      0x13577E
#define REG_BK1357_3F_H      0x13577F
#define REG_BK1357_40_L      0x135780
#define REG_BK1357_40_H      0x135781
#define REG_BK1357_41_L      0x135782
#define REG_BK1357_41_H      0x135783
#define REG_BK1357_42_L      0x135784
#define REG_BK1357_42_H      0x135785
#define REG_BK1357_43_L      0x135786
#define REG_BK1357_43_H      0x135787
#define REG_BK1357_44_L      0x135788
#define REG_BK1357_44_H      0x135789
#define REG_BK1357_45_L      0x13578A
#define REG_BK1357_45_H      0x13578B
#define REG_BK1357_46_L      0x13578C
#define REG_BK1357_46_H      0x13578D
#define REG_BK1357_47_L      0x13578E
#define REG_BK1357_47_H      0x13578F
#define REG_BK1357_48_L      0x135790
#define REG_BK1357_48_H      0x135791
#define REG_BK1357_49_L      0x135792
#define REG_BK1357_49_H      0x135793
#define REG_BK1357_4A_L      0x135794
#define REG_BK1357_4A_H      0x135795
#define REG_BK1357_4B_L      0x135796
#define REG_BK1357_4B_H      0x135797
#define REG_BK1357_4C_L      0x135798
#define REG_BK1357_4C_H      0x135799
#define REG_BK1357_4D_L      0x13579A
#define REG_BK1357_4D_H      0x13579B
#define REG_BK1357_4E_L      0x13579C
#define REG_BK1357_4E_H      0x13579D
#define REG_BK1357_4F_L      0x13579E
#define REG_BK1357_4F_H      0x13579F
#define REG_BK1357_50_L      0x1357A0
#define REG_BK1357_50_H      0x1357A1
#define REG_BK1357_51_L      0x1357A2
#define REG_BK1357_51_H      0x1357A3
#define REG_BK1357_52_L      0x1357A4
#define REG_BK1357_52_H      0x1357A5
#define REG_BK1357_53_L      0x1357A6
#define REG_BK1357_53_H      0x1357A7
#define REG_BK1357_54_L      0x1357A8
#define REG_BK1357_54_H      0x1357A9
#define REG_BK1357_55_L      0x1357AA
#define REG_BK1357_55_H      0x1357AB
#define REG_BK1357_56_L      0x1357AC
#define REG_BK1357_56_H      0x1357AD
#define REG_BK1357_57_L      0x1357AE
#define REG_BK1357_57_H      0x1357AF
#define REG_BK1357_58_L      0x1357B0
#define REG_BK1357_58_H      0x1357B1
#define REG_BK1357_59_L      0x1357B2
#define REG_BK1357_59_H      0x1357B3
#define REG_BK1357_5A_L      0x1357B4
#define REG_BK1357_5A_H      0x1357B5
#define REG_BK1357_5B_L      0x1357B6
#define REG_BK1357_5B_H      0x1357B7
#define REG_BK1357_5C_L      0x1357B8
#define REG_BK1357_5C_H      0x1357B9
#define REG_BK1357_5D_L      0x1357BA
#define REG_BK1357_5D_H      0x1357BB
#define REG_BK1357_5E_L      0x1357BC
#define REG_BK1357_5E_H      0x1357BD
#define REG_BK1357_5F_L      0x1357BE
#define REG_BK1357_5F_H      0x1357BF
#define REG_BK1357_60_L      0x1357C0
#define REG_BK1357_60_H      0x1357C1
#define REG_BK1357_61_L      0x1357C2
#define REG_BK1357_61_H      0x1357C3
#define REG_BK1357_62_L      0x1357C4
#define REG_BK1357_62_H      0x1357C5
#define REG_BK1357_63_L      0x1357C6
#define REG_BK1357_63_H      0x1357C7
#define REG_BK1357_64_L      0x1357C8
#define REG_BK1357_64_H      0x1357C9
#define REG_BK1357_65_L      0x1357CA
#define REG_BK1357_65_H      0x1357CB
#define REG_BK1357_66_L      0x1357CC
#define REG_BK1357_66_H      0x1357CD
#define REG_BK1357_67_L      0x1357CE
#define REG_BK1357_67_H      0x1357CF
#define REG_BK1357_68_L      0x1357D0
#define REG_BK1357_68_H      0x1357D1
#define REG_BK1357_69_L      0x1357D2
#define REG_BK1357_69_H      0x1357D3
#define REG_BK1357_6A_L      0x1357D4
#define REG_BK1357_6A_H      0x1357D5
#define REG_BK1357_6B_L      0x1357D6
#define REG_BK1357_6B_H      0x1357D7
#define REG_BK1357_6C_L      0x1357D8
#define REG_BK1357_6C_H      0x1357D9
#define REG_BK1357_6D_L      0x1357DA
#define REG_BK1357_6D_H      0x1357DB
#define REG_BK1357_6E_L      0x1357DC
#define REG_BK1357_6E_H      0x1357DD
#define REG_BK1357_6F_L      0x1357DE
#define REG_BK1357_6F_H      0x1357DF
#define REG_BK1357_70_L      0x1357E0
#define REG_BK1357_70_H      0x1357E1
#define REG_BK1357_71_L      0x1357E2
#define REG_BK1357_71_H      0x1357E3
#define REG_BK1357_72_L      0x1357E4
#define REG_BK1357_72_H      0x1357E5
#define REG_BK1357_73_L      0x1357E6
#define REG_BK1357_73_H      0x1357E7
#define REG_BK1357_74_L      0x1357E8
#define REG_BK1357_74_H      0x1357E9
#define REG_BK1357_75_L      0x1357EA
#define REG_BK1357_75_H      0x1357EB
#define REG_BK1357_76_L      0x1357EC
#define REG_BK1357_76_H      0x1357ED
#define REG_BK1357_77_L      0x1357EE
#define REG_BK1357_77_H      0x1357EF
#define REG_BK1357_78_L      0x1357F0
#define REG_BK1357_78_H      0x1357F1
#define REG_BK1357_79_L      0x1357F2
#define REG_BK1357_79_H      0x1357F3
#define REG_BK1357_7A_L      0x1357F4
#define REG_BK1357_7A_H      0x1357F5
#define REG_BK1357_7B_L      0x1357F6
#define REG_BK1357_7B_H      0x1357F7
#define REG_BK1357_7C_L      0x1357F8
#define REG_BK1357_7C_H      0x1357F9
#define REG_BK1357_7D_L      0x1357FA
#define REG_BK1357_7D_H      0x1357FB
#define REG_BK1357_7E_L      0x1357FC
#define REG_BK1357_7E_H      0x1357FD
#define REG_BK1357_7F_L      0x1357FE
#define REG_BK1357_7F_H      0x1357FF
//----------------------------------------------
#define REG_BK1358_00_L      0x135800
#define REG_BK1358_00_H      0x135801
#define REG_BK1358_01_L      0x135802
#define REG_BK1358_01_H      0x135803
#define REG_BK1358_02_L      0x135804
#define REG_BK1358_02_H      0x135805
#define REG_BK1358_03_L      0x135806
#define REG_BK1358_03_H      0x135807
#define REG_BK1358_04_L      0x135808
#define REG_BK1358_04_H      0x135809
#define REG_BK1358_05_L      0x13580A
#define REG_BK1358_05_H      0x13580B
#define REG_BK1358_06_L      0x13580C
#define REG_BK1358_06_H      0x13580D
#define REG_BK1358_07_L      0x13580E
#define REG_BK1358_07_H      0x13580F
#define REG_BK1358_08_L      0x135810
#define REG_BK1358_08_H      0x135811
#define REG_BK1358_09_L      0x135812
#define REG_BK1358_09_H      0x135813
#define REG_BK1358_0A_L      0x135814
#define REG_BK1358_0A_H      0x135815
#define REG_BK1358_0B_L      0x135816
#define REG_BK1358_0B_H      0x135817
#define REG_BK1358_0C_L      0x135818
#define REG_BK1358_0C_H      0x135819
#define REG_BK1358_0D_L      0x13581A
#define REG_BK1358_0D_H      0x13581B
#define REG_BK1358_0E_L      0x13581C
#define REG_BK1358_0E_H      0x13581D
#define REG_BK1358_0F_L      0x13581E
#define REG_BK1358_0F_H      0x13581F
#define REG_BK1358_10_L      0x135820
#define REG_BK1358_10_H      0x135821
#define REG_BK1358_11_L      0x135822
#define REG_BK1358_11_H      0x135823
#define REG_BK1358_12_L      0x135824
#define REG_BK1358_12_H      0x135825
#define REG_BK1358_13_L      0x135826
#define REG_BK1358_13_H      0x135827
#define REG_BK1358_14_L      0x135828
#define REG_BK1358_14_H      0x135829
#define REG_BK1358_15_L      0x13582A
#define REG_BK1358_15_H      0x13582B
#define REG_BK1358_16_L      0x13582C
#define REG_BK1358_16_H      0x13582D
#define REG_BK1358_17_L      0x13582E
#define REG_BK1358_17_H      0x13582F
#define REG_BK1358_18_L      0x135830
#define REG_BK1358_18_H      0x135831
#define REG_BK1358_19_L      0x135832
#define REG_BK1358_19_H      0x135833
#define REG_BK1358_1A_L      0x135834
#define REG_BK1358_1A_H      0x135835
#define REG_BK1358_1B_L      0x135836
#define REG_BK1358_1B_H      0x135837
#define REG_BK1358_1C_L      0x135838
#define REG_BK1358_1C_H      0x135839
#define REG_BK1358_1D_L      0x13583A
#define REG_BK1358_1D_H      0x13583B
#define REG_BK1358_1E_L      0x13583C
#define REG_BK1358_1E_H      0x13583D
#define REG_BK1358_1F_L      0x13583E
#define REG_BK1358_1F_H      0x13583F
#define REG_BK1358_20_L      0x135840
#define REG_BK1358_20_H      0x135841
#define REG_BK1358_21_L      0x135842
#define REG_BK1358_21_H      0x135843
#define REG_BK1358_22_L      0x135844
#define REG_BK1358_22_H      0x135845
#define REG_BK1358_23_L      0x135846
#define REG_BK1358_23_H      0x135847
#define REG_BK1358_24_L      0x135848
#define REG_BK1358_24_H      0x135849
#define REG_BK1358_25_L      0x13584A
#define REG_BK1358_25_H      0x13584B
#define REG_BK1358_26_L      0x13584C
#define REG_BK1358_26_H      0x13584D
#define REG_BK1358_27_L      0x13584E
#define REG_BK1358_27_H      0x13584F
#define REG_BK1358_28_L      0x135850
#define REG_BK1358_28_H      0x135851
#define REG_BK1358_29_L      0x135852
#define REG_BK1358_29_H      0x135853
#define REG_BK1358_2A_L      0x135854
#define REG_BK1358_2A_H      0x135855
#define REG_BK1358_2B_L      0x135856
#define REG_BK1358_2B_H      0x135857
#define REG_BK1358_2C_L      0x135858
#define REG_BK1358_2C_H      0x135859
#define REG_BK1358_2D_L      0x13585A
#define REG_BK1358_2D_H      0x13585B
#define REG_BK1358_2E_L      0x13585C
#define REG_BK1358_2E_H      0x13585D
#define REG_BK1358_2F_L      0x13585E
#define REG_BK1358_2F_H      0x13585F
#define REG_BK1358_30_L      0x135860
#define REG_BK1358_30_H      0x135861
#define REG_BK1358_31_L      0x135862
#define REG_BK1358_31_H      0x135863
#define REG_BK1358_32_L      0x135864
#define REG_BK1358_32_H      0x135865
#define REG_BK1358_33_L      0x135866
#define REG_BK1358_33_H      0x135867
#define REG_BK1358_34_L      0x135868
#define REG_BK1358_34_H      0x135869
#define REG_BK1358_35_L      0x13586A
#define REG_BK1358_35_H      0x13586B
#define REG_BK1358_36_L      0x13586C
#define REG_BK1358_36_H      0x13586D
#define REG_BK1358_37_L      0x13586E
#define REG_BK1358_37_H      0x13586F
#define REG_BK1358_38_L      0x135870
#define REG_BK1358_38_H      0x135871
#define REG_BK1358_39_L      0x135872
#define REG_BK1358_39_H      0x135873
#define REG_BK1358_3A_L      0x135874
#define REG_BK1358_3A_H      0x135875
#define REG_BK1358_3B_L      0x135876
#define REG_BK1358_3B_H      0x135877
#define REG_BK1358_3C_L      0x135878
#define REG_BK1358_3C_H      0x135879
#define REG_BK1358_3D_L      0x13587A
#define REG_BK1358_3D_H      0x13587B
#define REG_BK1358_3E_L      0x13587C
#define REG_BK1358_3E_H      0x13587D
#define REG_BK1358_3F_L      0x13587E
#define REG_BK1358_3F_H      0x13587F
#define REG_BK1358_40_L      0x135880
#define REG_BK1358_40_H      0x135881
#define REG_BK1358_41_L      0x135882
#define REG_BK1358_41_H      0x135883
#define REG_BK1358_42_L      0x135884
#define REG_BK1358_42_H      0x135885
#define REG_BK1358_43_L      0x135886
#define REG_BK1358_43_H      0x135887
#define REG_BK1358_44_L      0x135888
#define REG_BK1358_44_H      0x135889
#define REG_BK1358_45_L      0x13588A
#define REG_BK1358_45_H      0x13588B
#define REG_BK1358_46_L      0x13588C
#define REG_BK1358_46_H      0x13588D
#define REG_BK1358_47_L      0x13588E
#define REG_BK1358_47_H      0x13588F
#define REG_BK1358_48_L      0x135890
#define REG_BK1358_48_H      0x135891
#define REG_BK1358_49_L      0x135892
#define REG_BK1358_49_H      0x135893
#define REG_BK1358_4A_L      0x135894
#define REG_BK1358_4A_H      0x135895
#define REG_BK1358_4B_L      0x135896
#define REG_BK1358_4B_H      0x135897
#define REG_BK1358_4C_L      0x135898
#define REG_BK1358_4C_H      0x135899
#define REG_BK1358_4D_L      0x13589A
#define REG_BK1358_4D_H      0x13589B
#define REG_BK1358_4E_L      0x13589C
#define REG_BK1358_4E_H      0x13589D
#define REG_BK1358_4F_L      0x13589E
#define REG_BK1358_4F_H      0x13589F
#define REG_BK1358_50_L      0x1358A0
#define REG_BK1358_50_H      0x1358A1
#define REG_BK1358_51_L      0x1358A2
#define REG_BK1358_51_H      0x1358A3
#define REG_BK1358_52_L      0x1358A4
#define REG_BK1358_52_H      0x1358A5
#define REG_BK1358_53_L      0x1358A6
#define REG_BK1358_53_H      0x1358A7
#define REG_BK1358_54_L      0x1358A8
#define REG_BK1358_54_H      0x1358A9
#define REG_BK1358_55_L      0x1358AA
#define REG_BK1358_55_H      0x1358AB
#define REG_BK1358_56_L      0x1358AC
#define REG_BK1358_56_H      0x1358AD
#define REG_BK1358_57_L      0x1358AE
#define REG_BK1358_57_H      0x1358AF
#define REG_BK1358_58_L      0x1358B0
#define REG_BK1358_58_H      0x1358B1
#define REG_BK1358_59_L      0x1358B2
#define REG_BK1358_59_H      0x1358B3
#define REG_BK1358_5A_L      0x1358B4
#define REG_BK1358_5A_H      0x1358B5
#define REG_BK1358_5B_L      0x1358B6
#define REG_BK1358_5B_H      0x1358B7
#define REG_BK1358_5C_L      0x1358B8
#define REG_BK1358_5C_H      0x1358B9
#define REG_BK1358_5D_L      0x1358BA
#define REG_BK1358_5D_H      0x1358BB
#define REG_BK1358_5E_L      0x1358BC
#define REG_BK1358_5E_H      0x1358BD
#define REG_BK1358_5F_L      0x1358BE
#define REG_BK1358_5F_H      0x1358BF
#define REG_BK1358_60_L      0x1358C0
#define REG_BK1358_60_H      0x1358C1
#define REG_BK1358_61_L      0x1358C2
#define REG_BK1358_61_H      0x1358C3
#define REG_BK1358_62_L      0x1358C4
#define REG_BK1358_62_H      0x1358C5
#define REG_BK1358_63_L      0x1358C6
#define REG_BK1358_63_H      0x1358C7
#define REG_BK1358_64_L      0x1358C8
#define REG_BK1358_64_H      0x1358C9
#define REG_BK1358_65_L      0x1358CA
#define REG_BK1358_65_H      0x1358CB
#define REG_BK1358_66_L      0x1358CC
#define REG_BK1358_66_H      0x1358CD
#define REG_BK1358_67_L      0x1358CE
#define REG_BK1358_67_H      0x1358CF
#define REG_BK1358_68_L      0x1358D0
#define REG_BK1358_68_H      0x1358D1
#define REG_BK1358_69_L      0x1358D2
#define REG_BK1358_69_H      0x1358D3
#define REG_BK1358_6A_L      0x1358D4
#define REG_BK1358_6A_H      0x1358D5
#define REG_BK1358_6B_L      0x1358D6
#define REG_BK1358_6B_H      0x1358D7
#define REG_BK1358_6C_L      0x1358D8
#define REG_BK1358_6C_H      0x1358D9
#define REG_BK1358_6D_L      0x1358DA
#define REG_BK1358_6D_H      0x1358DB
#define REG_BK1358_6E_L      0x1358DC
#define REG_BK1358_6E_H      0x1358DD
#define REG_BK1358_6F_L      0x1358DE
#define REG_BK1358_6F_H      0x1358DF
#define REG_BK1358_70_L      0x1358E0
#define REG_BK1358_70_H      0x1358E1
#define REG_BK1358_71_L      0x1358E2
#define REG_BK1358_71_H      0x1358E3
#define REG_BK1358_72_L      0x1358E4
#define REG_BK1358_72_H      0x1358E5
#define REG_BK1358_73_L      0x1358E6
#define REG_BK1358_73_H      0x1358E7
#define REG_BK1358_74_L      0x1358E8
#define REG_BK1358_74_H      0x1358E9
#define REG_BK1358_75_L      0x1358EA
#define REG_BK1358_75_H      0x1358EB
#define REG_BK1358_76_L      0x1358EC
#define REG_BK1358_76_H      0x1358ED
#define REG_BK1358_77_L      0x1358EE
#define REG_BK1358_77_H      0x1358EF
#define REG_BK1358_78_L      0x1358F0
#define REG_BK1358_78_H      0x1358F1
#define REG_BK1358_79_L      0x1358F2
#define REG_BK1358_79_H      0x1358F3
#define REG_BK1358_7A_L      0x1358F4
#define REG_BK1358_7A_H      0x1358F5
#define REG_BK1358_7B_L      0x1358F6
#define REG_BK1358_7B_H      0x1358F7
#define REG_BK1358_7C_L      0x1358F8
#define REG_BK1358_7C_H      0x1358F9
#define REG_BK1358_7D_L      0x1358FA
#define REG_BK1358_7D_H      0x1358FB
#define REG_BK1358_7E_L      0x1358FC
#define REG_BK1358_7E_H      0x1358FD
#define REG_BK1358_7F_L      0x1358FE
#define REG_BK1358_7F_H      0x1358FF
//----------------------------------------------
#define REG_BK1359_00_L      0x135900
#define REG_BK1359_00_H      0x135901
#define REG_BK1359_01_L      0x135902
#define REG_BK1359_01_H      0x135903
#define REG_BK1359_02_L      0x135904
#define REG_BK1359_02_H      0x135905
#define REG_BK1359_03_L      0x135906
#define REG_BK1359_03_H      0x135907
#define REG_BK1359_04_L      0x135908
#define REG_BK1359_04_H      0x135909
#define REG_BK1359_05_L      0x13590A
#define REG_BK1359_05_H      0x13590B
#define REG_BK1359_06_L      0x13590C
#define REG_BK1359_06_H      0x13590D
#define REG_BK1359_07_L      0x13590E
#define REG_BK1359_07_H      0x13590F
#define REG_BK1359_08_L      0x135910
#define REG_BK1359_08_H      0x135911
#define REG_BK1359_09_L      0x135912
#define REG_BK1359_09_H      0x135913
#define REG_BK1359_0A_L      0x135914
#define REG_BK1359_0A_H      0x135915
#define REG_BK1359_0B_L      0x135916
#define REG_BK1359_0B_H      0x135917
#define REG_BK1359_0C_L      0x135918
#define REG_BK1359_0C_H      0x135919
#define REG_BK1359_0D_L      0x13591A
#define REG_BK1359_0D_H      0x13591B
#define REG_BK1359_0E_L      0x13591C
#define REG_BK1359_0E_H      0x13591D
#define REG_BK1359_0F_L      0x13591E
#define REG_BK1359_0F_H      0x13591F
#define REG_BK1359_10_L      0x135920
#define REG_BK1359_10_H      0x135921
#define REG_BK1359_11_L      0x135922
#define REG_BK1359_11_H      0x135923
#define REG_BK1359_12_L      0x135924
#define REG_BK1359_12_H      0x135925
#define REG_BK1359_13_L      0x135926
#define REG_BK1359_13_H      0x135927
#define REG_BK1359_14_L      0x135928
#define REG_BK1359_14_H      0x135929
#define REG_BK1359_15_L      0x13592A
#define REG_BK1359_15_H      0x13592B
#define REG_BK1359_16_L      0x13592C
#define REG_BK1359_16_H      0x13592D
#define REG_BK1359_17_L      0x13592E
#define REG_BK1359_17_H      0x13592F
#define REG_BK1359_18_L      0x135930
#define REG_BK1359_18_H      0x135931
#define REG_BK1359_19_L      0x135932
#define REG_BK1359_19_H      0x135933
#define REG_BK1359_1A_L      0x135934
#define REG_BK1359_1A_H      0x135935
#define REG_BK1359_1B_L      0x135936
#define REG_BK1359_1B_H      0x135937
#define REG_BK1359_1C_L      0x135938
#define REG_BK1359_1C_H      0x135939
#define REG_BK1359_1D_L      0x13593A
#define REG_BK1359_1D_H      0x13593B
#define REG_BK1359_1E_L      0x13593C
#define REG_BK1359_1E_H      0x13593D
#define REG_BK1359_1F_L      0x13593E
#define REG_BK1359_1F_H      0x13593F
#define REG_BK1359_20_L      0x135940
#define REG_BK1359_20_H      0x135941
#define REG_BK1359_21_L      0x135942
#define REG_BK1359_21_H      0x135943
#define REG_BK1359_22_L      0x135944
#define REG_BK1359_22_H      0x135945
#define REG_BK1359_23_L      0x135946
#define REG_BK1359_23_H      0x135947
#define REG_BK1359_24_L      0x135948
#define REG_BK1359_24_H      0x135949
#define REG_BK1359_25_L      0x13594A
#define REG_BK1359_25_H      0x13594B
#define REG_BK1359_26_L      0x13594C
#define REG_BK1359_26_H      0x13594D
#define REG_BK1359_27_L      0x13594E
#define REG_BK1359_27_H      0x13594F
#define REG_BK1359_28_L      0x135950
#define REG_BK1359_28_H      0x135951
#define REG_BK1359_29_L      0x135952
#define REG_BK1359_29_H      0x135953
#define REG_BK1359_2A_L      0x135954
#define REG_BK1359_2A_H      0x135955
#define REG_BK1359_2B_L      0x135956
#define REG_BK1359_2B_H      0x135957
#define REG_BK1359_2C_L      0x135958
#define REG_BK1359_2C_H      0x135959
#define REG_BK1359_2D_L      0x13595A
#define REG_BK1359_2D_H      0x13595B
#define REG_BK1359_2E_L      0x13595C
#define REG_BK1359_2E_H      0x13595D
#define REG_BK1359_2F_L      0x13595E
#define REG_BK1359_2F_H      0x13595F
#define REG_BK1359_30_L      0x135960
#define REG_BK1359_30_H      0x135961
#define REG_BK1359_31_L      0x135962
#define REG_BK1359_31_H      0x135963
#define REG_BK1359_32_L      0x135964
#define REG_BK1359_32_H      0x135965
#define REG_BK1359_33_L      0x135966
#define REG_BK1359_33_H      0x135967
#define REG_BK1359_34_L      0x135968
#define REG_BK1359_34_H      0x135969
#define REG_BK1359_35_L      0x13596A
#define REG_BK1359_35_H      0x13596B
#define REG_BK1359_36_L      0x13596C
#define REG_BK1359_36_H      0x13596D
#define REG_BK1359_37_L      0x13596E
#define REG_BK1359_37_H      0x13596F
#define REG_BK1359_38_L      0x135970
#define REG_BK1359_38_H      0x135971
#define REG_BK1359_39_L      0x135972
#define REG_BK1359_39_H      0x135973
#define REG_BK1359_3A_L      0x135974
#define REG_BK1359_3A_H      0x135975
#define REG_BK1359_3B_L      0x135976
#define REG_BK1359_3B_H      0x135977
#define REG_BK1359_3C_L      0x135978
#define REG_BK1359_3C_H      0x135979
#define REG_BK1359_3D_L      0x13597A
#define REG_BK1359_3D_H      0x13597B
#define REG_BK1359_3E_L      0x13597C
#define REG_BK1359_3E_H      0x13597D
#define REG_BK1359_3F_L      0x13597E
#define REG_BK1359_3F_H      0x13597F
#define REG_BK1359_40_L      0x135980
#define REG_BK1359_40_H      0x135981
#define REG_BK1359_41_L      0x135982
#define REG_BK1359_41_H      0x135983
#define REG_BK1359_42_L      0x135984
#define REG_BK1359_42_H      0x135985
#define REG_BK1359_43_L      0x135986
#define REG_BK1359_43_H      0x135987
#define REG_BK1359_44_L      0x135988
#define REG_BK1359_44_H      0x135989
#define REG_BK1359_45_L      0x13598A
#define REG_BK1359_45_H      0x13598B
#define REG_BK1359_46_L      0x13598C
#define REG_BK1359_46_H      0x13598D
#define REG_BK1359_47_L      0x13598E
#define REG_BK1359_47_H      0x13598F
#define REG_BK1359_48_L      0x135990
#define REG_BK1359_48_H      0x135991
#define REG_BK1359_49_L      0x135992
#define REG_BK1359_49_H      0x135993
#define REG_BK1359_4A_L      0x135994
#define REG_BK1359_4A_H      0x135995
#define REG_BK1359_4B_L      0x135996
#define REG_BK1359_4B_H      0x135997
#define REG_BK1359_4C_L      0x135998
#define REG_BK1359_4C_H      0x135999
#define REG_BK1359_4D_L      0x13599A
#define REG_BK1359_4D_H      0x13599B
#define REG_BK1359_4E_L      0x13599C
#define REG_BK1359_4E_H      0x13599D
#define REG_BK1359_4F_L      0x13599E
#define REG_BK1359_4F_H      0x13599F
#define REG_BK1359_50_L      0x1359A0
#define REG_BK1359_50_H      0x1359A1
#define REG_BK1359_51_L      0x1359A2
#define REG_BK1359_51_H      0x1359A3
#define REG_BK1359_52_L      0x1359A4
#define REG_BK1359_52_H      0x1359A5
#define REG_BK1359_53_L      0x1359A6
#define REG_BK1359_53_H      0x1359A7
#define REG_BK1359_54_L      0x1359A8
#define REG_BK1359_54_H      0x1359A9
#define REG_BK1359_55_L      0x1359AA
#define REG_BK1359_55_H      0x1359AB
#define REG_BK1359_56_L      0x1359AC
#define REG_BK1359_56_H      0x1359AD
#define REG_BK1359_57_L      0x1359AE
#define REG_BK1359_57_H      0x1359AF
#define REG_BK1359_58_L      0x1359B0
#define REG_BK1359_58_H      0x1359B1
#define REG_BK1359_59_L      0x1359B2
#define REG_BK1359_59_H      0x1359B3
#define REG_BK1359_5A_L      0x1359B4
#define REG_BK1359_5A_H      0x1359B5
#define REG_BK1359_5B_L      0x1359B6
#define REG_BK1359_5B_H      0x1359B7
#define REG_BK1359_5C_L      0x1359B8
#define REG_BK1359_5C_H      0x1359B9
#define REG_BK1359_5D_L      0x1359BA
#define REG_BK1359_5D_H      0x1359BB
#define REG_BK1359_5E_L      0x1359BC
#define REG_BK1359_5E_H      0x1359BD
#define REG_BK1359_5F_L      0x1359BE
#define REG_BK1359_5F_H      0x1359BF
#define REG_BK1359_60_L      0x1359C0
#define REG_BK1359_60_H      0x1359C1
#define REG_BK1359_61_L      0x1359C2
#define REG_BK1359_61_H      0x1359C3
#define REG_BK1359_62_L      0x1359C4
#define REG_BK1359_62_H      0x1359C5
#define REG_BK1359_63_L      0x1359C6
#define REG_BK1359_63_H      0x1359C7
#define REG_BK1359_64_L      0x1359C8
#define REG_BK1359_64_H      0x1359C9
#define REG_BK1359_65_L      0x1359CA
#define REG_BK1359_65_H      0x1359CB
#define REG_BK1359_66_L      0x1359CC
#define REG_BK1359_66_H      0x1359CD
#define REG_BK1359_67_L      0x1359CE
#define REG_BK1359_67_H      0x1359CF
#define REG_BK1359_68_L      0x1359D0
#define REG_BK1359_68_H      0x1359D1
#define REG_BK1359_69_L      0x1359D2
#define REG_BK1359_69_H      0x1359D3
#define REG_BK1359_6A_L      0x1359D4
#define REG_BK1359_6A_H      0x1359D5
#define REG_BK1359_6B_L      0x1359D6
#define REG_BK1359_6B_H      0x1359D7
#define REG_BK1359_6C_L      0x1359D8
#define REG_BK1359_6C_H      0x1359D9
#define REG_BK1359_6D_L      0x1359DA
#define REG_BK1359_6D_H      0x1359DB
#define REG_BK1359_6E_L      0x1359DC
#define REG_BK1359_6E_H      0x1359DD
#define REG_BK1359_6F_L      0x1359DE
#define REG_BK1359_6F_H      0x1359DF
#define REG_BK1359_70_L      0x1359E0
#define REG_BK1359_70_H      0x1359E1
#define REG_BK1359_71_L      0x1359E2
#define REG_BK1359_71_H      0x1359E3
#define REG_BK1359_72_L      0x1359E4
#define REG_BK1359_72_H      0x1359E5
#define REG_BK1359_73_L      0x1359E6
#define REG_BK1359_73_H      0x1359E7
#define REG_BK1359_74_L      0x1359E8
#define REG_BK1359_74_H      0x1359E9
#define REG_BK1359_75_L      0x1359EA
#define REG_BK1359_75_H      0x1359EB
#define REG_BK1359_76_L      0x1359EC
#define REG_BK1359_76_H      0x1359ED
#define REG_BK1359_77_L      0x1359EE
#define REG_BK1359_77_H      0x1359EF
#define REG_BK1359_78_L      0x1359F0
#define REG_BK1359_78_H      0x1359F1
#define REG_BK1359_79_L      0x1359F2
#define REG_BK1359_79_H      0x1359F3
#define REG_BK1359_7A_L      0x1359F4
#define REG_BK1359_7A_H      0x1359F5
#define REG_BK1359_7B_L      0x1359F6
#define REG_BK1359_7B_H      0x1359F7
#define REG_BK1359_7C_L      0x1359F8
#define REG_BK1359_7C_H      0x1359F9
#define REG_BK1359_7D_L      0x1359FA
#define REG_BK1359_7D_H      0x1359FB
#define REG_BK1359_7E_L      0x1359FC
#define REG_BK1359_7E_H      0x1359FD
#define REG_BK1359_7F_L      0x1359FE
#define REG_BK1359_7F_H      0x1359FF
//----------------------------------------------
#define REG_BK135A_00_L      0x135A00
#define REG_BK135A_00_H      0x135A01
#define REG_BK135A_01_L      0x135A02
#define REG_BK135A_01_H      0x135A03
#define REG_BK135A_02_L      0x135A04
#define REG_BK135A_02_H      0x135A05
#define REG_BK135A_03_L      0x135A06
#define REG_BK135A_03_H      0x135A07
#define REG_BK135A_04_L      0x135A08
#define REG_BK135A_04_H      0x135A09
#define REG_BK135A_05_L      0x135A0A
#define REG_BK135A_05_H      0x135A0B
#define REG_BK135A_06_L      0x135A0C
#define REG_BK135A_06_H      0x135A0D
#define REG_BK135A_07_L      0x135A0E
#define REG_BK135A_07_H      0x135A0F
#define REG_BK135A_08_L      0x135A10
#define REG_BK135A_08_H      0x135A11
#define REG_BK135A_09_L      0x135A12
#define REG_BK135A_09_H      0x135A13
#define REG_BK135A_0A_L      0x135A14
#define REG_BK135A_0A_H      0x135A15
#define REG_BK135A_0B_L      0x135A16
#define REG_BK135A_0B_H      0x135A17
#define REG_BK135A_0C_L      0x135A18
#define REG_BK135A_0C_H      0x135A19
#define REG_BK135A_0D_L      0x135A1A
#define REG_BK135A_0D_H      0x135A1B
#define REG_BK135A_0E_L      0x135A1C
#define REG_BK135A_0E_H      0x135A1D
#define REG_BK135A_0F_L      0x135A1E
#define REG_BK135A_0F_H      0x135A1F
#define REG_BK135A_10_L      0x135A20
#define REG_BK135A_10_H      0x135A21
#define REG_BK135A_11_L      0x135A22
#define REG_BK135A_11_H      0x135A23
#define REG_BK135A_12_L      0x135A24
#define REG_BK135A_12_H      0x135A25
#define REG_BK135A_13_L      0x135A26
#define REG_BK135A_13_H      0x135A27
#define REG_BK135A_14_L      0x135A28
#define REG_BK135A_14_H      0x135A29
#define REG_BK135A_15_L      0x135A2A
#define REG_BK135A_15_H      0x135A2B
#define REG_BK135A_16_L      0x135A2C
#define REG_BK135A_16_H      0x135A2D
#define REG_BK135A_17_L      0x135A2E
#define REG_BK135A_17_H      0x135A2F
#define REG_BK135A_18_L      0x135A30
#define REG_BK135A_18_H      0x135A31
#define REG_BK135A_19_L      0x135A32
#define REG_BK135A_19_H      0x135A33
#define REG_BK135A_1A_L      0x135A34
#define REG_BK135A_1A_H      0x135A35
#define REG_BK135A_1B_L      0x135A36
#define REG_BK135A_1B_H      0x135A37
#define REG_BK135A_1C_L      0x135A38
#define REG_BK135A_1C_H      0x135A39
#define REG_BK135A_1D_L      0x135A3A
#define REG_BK135A_1D_H      0x135A3B
#define REG_BK135A_1E_L      0x135A3C
#define REG_BK135A_1E_H      0x135A3D
#define REG_BK135A_1F_L      0x135A3E
#define REG_BK135A_1F_H      0x135A3F
#define REG_BK135A_20_L      0x135A40
#define REG_BK135A_20_H      0x135A41
#define REG_BK135A_21_L      0x135A42
#define REG_BK135A_21_H      0x135A43
#define REG_BK135A_22_L      0x135A44
#define REG_BK135A_22_H      0x135A45
#define REG_BK135A_23_L      0x135A46
#define REG_BK135A_23_H      0x135A47
#define REG_BK135A_24_L      0x135A48
#define REG_BK135A_24_H      0x135A49
#define REG_BK135A_25_L      0x135A4A
#define REG_BK135A_25_H      0x135A4B
#define REG_BK135A_26_L      0x135A4C
#define REG_BK135A_26_H      0x135A4D
#define REG_BK135A_27_L      0x135A4E
#define REG_BK135A_27_H      0x135A4F
#define REG_BK135A_28_L      0x135A50
#define REG_BK135A_28_H      0x135A51
#define REG_BK135A_29_L      0x135A52
#define REG_BK135A_29_H      0x135A53
#define REG_BK135A_2A_L      0x135A54
#define REG_BK135A_2A_H      0x135A55
#define REG_BK135A_2B_L      0x135A56
#define REG_BK135A_2B_H      0x135A57
#define REG_BK135A_2C_L      0x135A58
#define REG_BK135A_2C_H      0x135A59
#define REG_BK135A_2D_L      0x135A5A
#define REG_BK135A_2D_H      0x135A5B
#define REG_BK135A_2E_L      0x135A5C
#define REG_BK135A_2E_H      0x135A5D
#define REG_BK135A_2F_L      0x135A5E
#define REG_BK135A_2F_H      0x135A5F
#define REG_BK135A_30_L      0x135A60
#define REG_BK135A_30_H      0x135A61
#define REG_BK135A_31_L      0x135A62
#define REG_BK135A_31_H      0x135A63
#define REG_BK135A_32_L      0x135A64
#define REG_BK135A_32_H      0x135A65
#define REG_BK135A_33_L      0x135A66
#define REG_BK135A_33_H      0x135A67
#define REG_BK135A_34_L      0x135A68
#define REG_BK135A_34_H      0x135A69
#define REG_BK135A_35_L      0x135A6A
#define REG_BK135A_35_H      0x135A6B
#define REG_BK135A_36_L      0x135A6C
#define REG_BK135A_36_H      0x135A6D
#define REG_BK135A_37_L      0x135A6E
#define REG_BK135A_37_H      0x135A6F
#define REG_BK135A_38_L      0x135A70
#define REG_BK135A_38_H      0x135A71
#define REG_BK135A_39_L      0x135A72
#define REG_BK135A_39_H      0x135A73
#define REG_BK135A_3A_L      0x135A74
#define REG_BK135A_3A_H      0x135A75
#define REG_BK135A_3B_L      0x135A76
#define REG_BK135A_3B_H      0x135A77
#define REG_BK135A_3C_L      0x135A78
#define REG_BK135A_3C_H      0x135A79
#define REG_BK135A_3D_L      0x135A7A
#define REG_BK135A_3D_H      0x135A7B
#define REG_BK135A_3E_L      0x135A7C
#define REG_BK135A_3E_H      0x135A7D
#define REG_BK135A_3F_L      0x135A7E
#define REG_BK135A_3F_H      0x135A7F
#define REG_BK135A_40_L      0x135A80
#define REG_BK135A_40_H      0x135A81
#define REG_BK135A_41_L      0x135A82
#define REG_BK135A_41_H      0x135A83
#define REG_BK135A_42_L      0x135A84
#define REG_BK135A_42_H      0x135A85
#define REG_BK135A_43_L      0x135A86
#define REG_BK135A_43_H      0x135A87
#define REG_BK135A_44_L      0x135A88
#define REG_BK135A_44_H      0x135A89
#define REG_BK135A_45_L      0x135A8A
#define REG_BK135A_45_H      0x135A8B
#define REG_BK135A_46_L      0x135A8C
#define REG_BK135A_46_H      0x135A8D
#define REG_BK135A_47_L      0x135A8E
#define REG_BK135A_47_H      0x135A8F
#define REG_BK135A_48_L      0x135A90
#define REG_BK135A_48_H      0x135A91
#define REG_BK135A_49_L      0x135A92
#define REG_BK135A_49_H      0x135A93
#define REG_BK135A_4A_L      0x135A94
#define REG_BK135A_4A_H      0x135A95
#define REG_BK135A_4B_L      0x135A96
#define REG_BK135A_4B_H      0x135A97
#define REG_BK135A_4C_L      0x135A98
#define REG_BK135A_4C_H      0x135A99
#define REG_BK135A_4D_L      0x135A9A
#define REG_BK135A_4D_H      0x135A9B
#define REG_BK135A_4E_L      0x135A9C
#define REG_BK135A_4E_H      0x135A9D
#define REG_BK135A_4F_L      0x135A9E
#define REG_BK135A_4F_H      0x135A9F
#define REG_BK135A_50_L      0x135AA0
#define REG_BK135A_50_H      0x135AA1
#define REG_BK135A_51_L      0x135AA2
#define REG_BK135A_51_H      0x135AA3
#define REG_BK135A_52_L      0x135AA4
#define REG_BK135A_52_H      0x135AA5
#define REG_BK135A_53_L      0x135AA6
#define REG_BK135A_53_H      0x135AA7
#define REG_BK135A_54_L      0x135AA8
#define REG_BK135A_54_H      0x135AA9
#define REG_BK135A_55_L      0x135AAA
#define REG_BK135A_55_H      0x135AAB
#define REG_BK135A_56_L      0x135AAC
#define REG_BK135A_56_H      0x135AAD
#define REG_BK135A_57_L      0x135AAE
#define REG_BK135A_57_H      0x135AAF
#define REG_BK135A_58_L      0x135AB0
#define REG_BK135A_58_H      0x135AB1
#define REG_BK135A_59_L      0x135AB2
#define REG_BK135A_59_H      0x135AB3
#define REG_BK135A_5A_L      0x135AB4
#define REG_BK135A_5A_H      0x135AB5
#define REG_BK135A_5B_L      0x135AB6
#define REG_BK135A_5B_H      0x135AB7
#define REG_BK135A_5C_L      0x135AB8
#define REG_BK135A_5C_H      0x135AB9
#define REG_BK135A_5D_L      0x135ABA
#define REG_BK135A_5D_H      0x135ABB
#define REG_BK135A_5E_L      0x135ABC
#define REG_BK135A_5E_H      0x135ABD
#define REG_BK135A_5F_L      0x135ABE
#define REG_BK135A_5F_H      0x135ABF
#define REG_BK135A_60_L      0x135AC0
#define REG_BK135A_60_H      0x135AC1
#define REG_BK135A_61_L      0x135AC2
#define REG_BK135A_61_H      0x135AC3
#define REG_BK135A_62_L      0x135AC4
#define REG_BK135A_62_H      0x135AC5
#define REG_BK135A_63_L      0x135AC6
#define REG_BK135A_63_H      0x135AC7
#define REG_BK135A_64_L      0x135AC8
#define REG_BK135A_64_H      0x135AC9
#define REG_BK135A_65_L      0x135ACA
#define REG_BK135A_65_H      0x135ACB
#define REG_BK135A_66_L      0x135ACC
#define REG_BK135A_66_H      0x135ACD
#define REG_BK135A_67_L      0x135ACE
#define REG_BK135A_67_H      0x135ACF
#define REG_BK135A_68_L      0x135AD0
#define REG_BK135A_68_H      0x135AD1
#define REG_BK135A_69_L      0x135AD2
#define REG_BK135A_69_H      0x135AD3
#define REG_BK135A_6A_L      0x135AD4
#define REG_BK135A_6A_H      0x135AD5
#define REG_BK135A_6B_L      0x135AD6
#define REG_BK135A_6B_H      0x135AD7
#define REG_BK135A_6C_L      0x135AD8
#define REG_BK135A_6C_H      0x135AD9
#define REG_BK135A_6D_L      0x135ADA
#define REG_BK135A_6D_H      0x135ADB
#define REG_BK135A_6E_L      0x135ADC
#define REG_BK135A_6E_H      0x135ADD
#define REG_BK135A_6F_L      0x135ADE
#define REG_BK135A_6F_H      0x135ADF
#define REG_BK135A_70_L      0x135AE0
#define REG_BK135A_70_H      0x135AE1
#define REG_BK135A_71_L      0x135AE2
#define REG_BK135A_71_H      0x135AE3
#define REG_BK135A_72_L      0x135AE4
#define REG_BK135A_72_H      0x135AE5
#define REG_BK135A_73_L      0x135AE6
#define REG_BK135A_73_H      0x135AE7
#define REG_BK135A_74_L      0x135AE8
#define REG_BK135A_74_H      0x135AE9
#define REG_BK135A_75_L      0x135AEA
#define REG_BK135A_75_H      0x135AEB
#define REG_BK135A_76_L      0x135AEC
#define REG_BK135A_76_H      0x135AED
#define REG_BK135A_77_L      0x135AEE
#define REG_BK135A_77_H      0x135AEF
#define REG_BK135A_78_L      0x135AF0
#define REG_BK135A_78_H      0x135AF1
#define REG_BK135A_79_L      0x135AF2
#define REG_BK135A_79_H      0x135AF3
#define REG_BK135A_7A_L      0x135AF4
#define REG_BK135A_7A_H      0x135AF5
#define REG_BK135A_7B_L      0x135AF6
#define REG_BK135A_7B_H      0x135AF7
#define REG_BK135A_7C_L      0x135AF8
#define REG_BK135A_7C_H      0x135AF9
#define REG_BK135A_7D_L      0x135AFA
#define REG_BK135A_7D_H      0x135AFB
#define REG_BK135A_7E_L      0x135AFC
#define REG_BK135A_7E_H      0x135AFD
#define REG_BK135A_7F_L      0x135AFE
#define REG_BK135A_7F_H      0x135AFF
//----------------------------------------------
#define REG_BK135B_00_L      0x135B00
#define REG_BK135B_00_H      0x135B01
#define REG_BK135B_01_L      0x135B02
#define REG_BK135B_01_H      0x135B03
#define REG_BK135B_02_L      0x135B04
#define REG_BK135B_02_H      0x135B05
#define REG_BK135B_03_L      0x135B06
#define REG_BK135B_03_H      0x135B07
#define REG_BK135B_04_L      0x135B08
#define REG_BK135B_04_H      0x135B09
#define REG_BK135B_05_L      0x135B0A
#define REG_BK135B_05_H      0x135B0B
#define REG_BK135B_06_L      0x135B0C
#define REG_BK135B_06_H      0x135B0D
#define REG_BK135B_07_L      0x135B0E
#define REG_BK135B_07_H      0x135B0F
#define REG_BK135B_08_L      0x135B10
#define REG_BK135B_08_H      0x135B11
#define REG_BK135B_09_L      0x135B12
#define REG_BK135B_09_H      0x135B13
#define REG_BK135B_0A_L      0x135B14
#define REG_BK135B_0A_H      0x135B15
#define REG_BK135B_0B_L      0x135B16
#define REG_BK135B_0B_H      0x135B17
#define REG_BK135B_0C_L      0x135B18
#define REG_BK135B_0C_H      0x135B19
#define REG_BK135B_0D_L      0x135B1A
#define REG_BK135B_0D_H      0x135B1B
#define REG_BK135B_0E_L      0x135B1C
#define REG_BK135B_0E_H      0x135B1D
#define REG_BK135B_0F_L      0x135B1E
#define REG_BK135B_0F_H      0x135B1F
#define REG_BK135B_10_L      0x135B20
#define REG_BK135B_10_H      0x135B21
#define REG_BK135B_11_L      0x135B22
#define REG_BK135B_11_H      0x135B23
#define REG_BK135B_12_L      0x135B24
#define REG_BK135B_12_H      0x135B25
#define REG_BK135B_13_L      0x135B26
#define REG_BK135B_13_H      0x135B27
#define REG_BK135B_14_L      0x135B28
#define REG_BK135B_14_H      0x135B29
#define REG_BK135B_15_L      0x135B2A
#define REG_BK135B_15_H      0x135B2B
#define REG_BK135B_16_L      0x135B2C
#define REG_BK135B_16_H      0x135B2D
#define REG_BK135B_17_L      0x135B2E
#define REG_BK135B_17_H      0x135B2F
#define REG_BK135B_18_L      0x135B30
#define REG_BK135B_18_H      0x135B31
#define REG_BK135B_19_L      0x135B32
#define REG_BK135B_19_H      0x135B33
#define REG_BK135B_1A_L      0x135B34
#define REG_BK135B_1A_H      0x135B35
#define REG_BK135B_1B_L      0x135B36
#define REG_BK135B_1B_H      0x135B37
#define REG_BK135B_1C_L      0x135B38
#define REG_BK135B_1C_H      0x135B39
#define REG_BK135B_1D_L      0x135B3A
#define REG_BK135B_1D_H      0x135B3B
#define REG_BK135B_1E_L      0x135B3C
#define REG_BK135B_1E_H      0x135B3D
#define REG_BK135B_1F_L      0x135B3E
#define REG_BK135B_1F_H      0x135B3F
#define REG_BK135B_20_L      0x135B40
#define REG_BK135B_20_H      0x135B41
#define REG_BK135B_21_L      0x135B42
#define REG_BK135B_21_H      0x135B43
#define REG_BK135B_22_L      0x135B44
#define REG_BK135B_22_H      0x135B45
#define REG_BK135B_23_L      0x135B46
#define REG_BK135B_23_H      0x135B47
#define REG_BK135B_24_L      0x135B48
#define REG_BK135B_24_H      0x135B49
#define REG_BK135B_25_L      0x135B4A
#define REG_BK135B_25_H      0x135B4B
#define REG_BK135B_26_L      0x135B4C
#define REG_BK135B_26_H      0x135B4D
#define REG_BK135B_27_L      0x135B4E
#define REG_BK135B_27_H      0x135B4F
#define REG_BK135B_28_L      0x135B50
#define REG_BK135B_28_H      0x135B51
#define REG_BK135B_29_L      0x135B52
#define REG_BK135B_29_H      0x135B53
#define REG_BK135B_2A_L      0x135B54
#define REG_BK135B_2A_H      0x135B55
#define REG_BK135B_2B_L      0x135B56
#define REG_BK135B_2B_H      0x135B57
#define REG_BK135B_2C_L      0x135B58
#define REG_BK135B_2C_H      0x135B59
#define REG_BK135B_2D_L      0x135B5A
#define REG_BK135B_2D_H      0x135B5B
#define REG_BK135B_2E_L      0x135B5C
#define REG_BK135B_2E_H      0x135B5D
#define REG_BK135B_2F_L      0x135B5E
#define REG_BK135B_2F_H      0x135B5F
#define REG_BK135B_30_L      0x135B60
#define REG_BK135B_30_H      0x135B61
#define REG_BK135B_31_L      0x135B62
#define REG_BK135B_31_H      0x135B63
#define REG_BK135B_32_L      0x135B64
#define REG_BK135B_32_H      0x135B65
#define REG_BK135B_33_L      0x135B66
#define REG_BK135B_33_H      0x135B67
#define REG_BK135B_34_L      0x135B68
#define REG_BK135B_34_H      0x135B69
#define REG_BK135B_35_L      0x135B6A
#define REG_BK135B_35_H      0x135B6B
#define REG_BK135B_36_L      0x135B6C
#define REG_BK135B_36_H      0x135B6D
#define REG_BK135B_37_L      0x135B6E
#define REG_BK135B_37_H      0x135B6F
#define REG_BK135B_38_L      0x135B70
#define REG_BK135B_38_H      0x135B71
#define REG_BK135B_39_L      0x135B72
#define REG_BK135B_39_H      0x135B73
#define REG_BK135B_3A_L      0x135B74
#define REG_BK135B_3A_H      0x135B75
#define REG_BK135B_3B_L      0x135B76
#define REG_BK135B_3B_H      0x135B77
#define REG_BK135B_3C_L      0x135B78
#define REG_BK135B_3C_H      0x135B79
#define REG_BK135B_3D_L      0x135B7A
#define REG_BK135B_3D_H      0x135B7B
#define REG_BK135B_3E_L      0x135B7C
#define REG_BK135B_3E_H      0x135B7D
#define REG_BK135B_3F_L      0x135B7E
#define REG_BK135B_3F_H      0x135B7F
#define REG_BK135B_40_L      0x135B80
#define REG_BK135B_40_H      0x135B81
#define REG_BK135B_41_L      0x135B82
#define REG_BK135B_41_H      0x135B83
#define REG_BK135B_42_L      0x135B84
#define REG_BK135B_42_H      0x135B85
#define REG_BK135B_43_L      0x135B86
#define REG_BK135B_43_H      0x135B87
#define REG_BK135B_44_L      0x135B88
#define REG_BK135B_44_H      0x135B89
#define REG_BK135B_45_L      0x135B8A
#define REG_BK135B_45_H      0x135B8B
#define REG_BK135B_46_L      0x135B8C
#define REG_BK135B_46_H      0x135B8D
#define REG_BK135B_47_L      0x135B8E
#define REG_BK135B_47_H      0x135B8F
#define REG_BK135B_48_L      0x135B90
#define REG_BK135B_48_H      0x135B91
#define REG_BK135B_49_L      0x135B92
#define REG_BK135B_49_H      0x135B93
#define REG_BK135B_4A_L      0x135B94
#define REG_BK135B_4A_H      0x135B95
#define REG_BK135B_4B_L      0x135B96
#define REG_BK135B_4B_H      0x135B97
#define REG_BK135B_4C_L      0x135B98
#define REG_BK135B_4C_H      0x135B99
#define REG_BK135B_4D_L      0x135B9A
#define REG_BK135B_4D_H      0x135B9B
#define REG_BK135B_4E_L      0x135B9C
#define REG_BK135B_4E_H      0x135B9D
#define REG_BK135B_4F_L      0x135B9E
#define REG_BK135B_4F_H      0x135B9F
#define REG_BK135B_50_L      0x135BA0
#define REG_BK135B_50_H      0x135BA1
#define REG_BK135B_51_L      0x135BA2
#define REG_BK135B_51_H      0x135BA3
#define REG_BK135B_52_L      0x135BA4
#define REG_BK135B_52_H      0x135BA5
#define REG_BK135B_53_L      0x135BA6
#define REG_BK135B_53_H      0x135BA7
#define REG_BK135B_54_L      0x135BA8
#define REG_BK135B_54_H      0x135BA9
#define REG_BK135B_55_L      0x135BAA
#define REG_BK135B_55_H      0x135BAB
#define REG_BK135B_56_L      0x135BAC
#define REG_BK135B_56_H      0x135BAD
#define REG_BK135B_57_L      0x135BAE
#define REG_BK135B_57_H      0x135BAF
#define REG_BK135B_58_L      0x135BB0
#define REG_BK135B_58_H      0x135BB1
#define REG_BK135B_59_L      0x135BB2
#define REG_BK135B_59_H      0x135BB3
#define REG_BK135B_5A_L      0x135BB4
#define REG_BK135B_5A_H      0x135BB5
#define REG_BK135B_5B_L      0x135BB6
#define REG_BK135B_5B_H      0x135BB7
#define REG_BK135B_5C_L      0x135BB8
#define REG_BK135B_5C_H      0x135BB9
#define REG_BK135B_5D_L      0x135BBA
#define REG_BK135B_5D_H      0x135BBB
#define REG_BK135B_5E_L      0x135BBC
#define REG_BK135B_5E_H      0x135BBD
#define REG_BK135B_5F_L      0x135BBE
#define REG_BK135B_5F_H      0x135BBF
#define REG_BK135B_60_L      0x135BC0
#define REG_BK135B_60_H      0x135BC1
#define REG_BK135B_61_L      0x135BC2
#define REG_BK135B_61_H      0x135BC3
#define REG_BK135B_62_L      0x135BC4
#define REG_BK135B_62_H      0x135BC5
#define REG_BK135B_63_L      0x135BC6
#define REG_BK135B_63_H      0x135BC7
#define REG_BK135B_64_L      0x135BC8
#define REG_BK135B_64_H      0x135BC9
#define REG_BK135B_65_L      0x135BCA
#define REG_BK135B_65_H      0x135BCB
#define REG_BK135B_66_L      0x135BCC
#define REG_BK135B_66_H      0x135BCD
#define REG_BK135B_67_L      0x135BCE
#define REG_BK135B_67_H      0x135BCF
#define REG_BK135B_68_L      0x135BD0
#define REG_BK135B_68_H      0x135BD1
#define REG_BK135B_69_L      0x135BD2
#define REG_BK135B_69_H      0x135BD3
#define REG_BK135B_6A_L      0x135BD4
#define REG_BK135B_6A_H      0x135BD5
#define REG_BK135B_6B_L      0x135BD6
#define REG_BK135B_6B_H      0x135BD7
#define REG_BK135B_6C_L      0x135BD8
#define REG_BK135B_6C_H      0x135BD9
#define REG_BK135B_6D_L      0x135BDA
#define REG_BK135B_6D_H      0x135BDB
#define REG_BK135B_6E_L      0x135BDC
#define REG_BK135B_6E_H      0x135BDD
#define REG_BK135B_6F_L      0x135BDE
#define REG_BK135B_6F_H      0x135BDF
#define REG_BK135B_70_L      0x135BE0
#define REG_BK135B_70_H      0x135BE1
#define REG_BK135B_71_L      0x135BE2
#define REG_BK135B_71_H      0x135BE3
#define REG_BK135B_72_L      0x135BE4
#define REG_BK135B_72_H      0x135BE5
#define REG_BK135B_73_L      0x135BE6
#define REG_BK135B_73_H      0x135BE7
#define REG_BK135B_74_L      0x135BE8
#define REG_BK135B_74_H      0x135BE9
#define REG_BK135B_75_L      0x135BEA
#define REG_BK135B_75_H      0x135BEB
#define REG_BK135B_76_L      0x135BEC
#define REG_BK135B_76_H      0x135BED
#define REG_BK135B_77_L      0x135BEE
#define REG_BK135B_77_H      0x135BEF
#define REG_BK135B_78_L      0x135BF0
#define REG_BK135B_78_H      0x135BF1
#define REG_BK135B_79_L      0x135BF2
#define REG_BK135B_79_H      0x135BF3
#define REG_BK135B_7A_L      0x135BF4
#define REG_BK135B_7A_H      0x135BF5
#define REG_BK135B_7B_L      0x135BF6
#define REG_BK135B_7B_H      0x135BF7
#define REG_BK135B_7C_L      0x135BF8
#define REG_BK135B_7C_H      0x135BF9
#define REG_BK135B_7D_L      0x135BFA
#define REG_BK135B_7D_H      0x135BFB
#define REG_BK135B_7E_L      0x135BFC
#define REG_BK135B_7E_H      0x135BFD
#define REG_BK135B_7F_L      0x135BFE
#define REG_BK135B_7F_H      0x135BFF
//----------------------------------------------
#define REG_BK135C_00_L      0x135C00
#define REG_BK135C_00_H      0x135C01
#define REG_BK135C_01_L      0x135C02
#define REG_BK135C_01_H      0x135C03
#define REG_BK135C_02_L      0x135C04
#define REG_BK135C_02_H      0x135C05
#define REG_BK135C_03_L      0x135C06
#define REG_BK135C_03_H      0x135C07
#define REG_BK135C_04_L      0x135C08
#define REG_BK135C_04_H      0x135C09
#define REG_BK135C_05_L      0x135C0A
#define REG_BK135C_05_H      0x135C0B
#define REG_BK135C_06_L      0x135C0C
#define REG_BK135C_06_H      0x135C0D
#define REG_BK135C_07_L      0x135C0E
#define REG_BK135C_07_H      0x135C0F
#define REG_BK135C_08_L      0x135C10
#define REG_BK135C_08_H      0x135C11
#define REG_BK135C_09_L      0x135C12
#define REG_BK135C_09_H      0x135C13
#define REG_BK135C_0A_L      0x135C14
#define REG_BK135C_0A_H      0x135C15
#define REG_BK135C_0B_L      0x135C16
#define REG_BK135C_0B_H      0x135C17
#define REG_BK135C_0C_L      0x135C18
#define REG_BK135C_0C_H      0x135C19
#define REG_BK135C_0D_L      0x135C1A
#define REG_BK135C_0D_H      0x135C1B
#define REG_BK135C_0E_L      0x135C1C
#define REG_BK135C_0E_H      0x135C1D
#define REG_BK135C_0F_L      0x135C1E
#define REG_BK135C_0F_H      0x135C1F
#define REG_BK135C_10_L      0x135C20
#define REG_BK135C_10_H      0x135C21
#define REG_BK135C_11_L      0x135C22
#define REG_BK135C_11_H      0x135C23
#define REG_BK135C_12_L      0x135C24
#define REG_BK135C_12_H      0x135C25
#define REG_BK135C_13_L      0x135C26
#define REG_BK135C_13_H      0x135C27
#define REG_BK135C_14_L      0x135C28
#define REG_BK135C_14_H      0x135C29
#define REG_BK135C_15_L      0x135C2A
#define REG_BK135C_15_H      0x135C2B
#define REG_BK135C_16_L      0x135C2C
#define REG_BK135C_16_H      0x135C2D
#define REG_BK135C_17_L      0x135C2E
#define REG_BK135C_17_H      0x135C2F
#define REG_BK135C_18_L      0x135C30
#define REG_BK135C_18_H      0x135C31
#define REG_BK135C_19_L      0x135C32
#define REG_BK135C_19_H      0x135C33
#define REG_BK135C_1A_L      0x135C34
#define REG_BK135C_1A_H      0x135C35
#define REG_BK135C_1B_L      0x135C36
#define REG_BK135C_1B_H      0x135C37
#define REG_BK135C_1C_L      0x135C38
#define REG_BK135C_1C_H      0x135C39
#define REG_BK135C_1D_L      0x135C3A
#define REG_BK135C_1D_H      0x135C3B
#define REG_BK135C_1E_L      0x135C3C
#define REG_BK135C_1E_H      0x135C3D
#define REG_BK135C_1F_L      0x135C3E
#define REG_BK135C_1F_H      0x135C3F
#define REG_BK135C_20_L      0x135C40
#define REG_BK135C_20_H      0x135C41
#define REG_BK135C_21_L      0x135C42
#define REG_BK135C_21_H      0x135C43
#define REG_BK135C_22_L      0x135C44
#define REG_BK135C_22_H      0x135C45
#define REG_BK135C_23_L      0x135C46
#define REG_BK135C_23_H      0x135C47
#define REG_BK135C_24_L      0x135C48
#define REG_BK135C_24_H      0x135C49
#define REG_BK135C_25_L      0x135C4A
#define REG_BK135C_25_H      0x135C4B
#define REG_BK135C_26_L      0x135C4C
#define REG_BK135C_26_H      0x135C4D
#define REG_BK135C_27_L      0x135C4E
#define REG_BK135C_27_H      0x135C4F
#define REG_BK135C_28_L      0x135C50
#define REG_BK135C_28_H      0x135C51
#define REG_BK135C_29_L      0x135C52
#define REG_BK135C_29_H      0x135C53
#define REG_BK135C_2A_L      0x135C54
#define REG_BK135C_2A_H      0x135C55
#define REG_BK135C_2B_L      0x135C56
#define REG_BK135C_2B_H      0x135C57
#define REG_BK135C_2C_L      0x135C58
#define REG_BK135C_2C_H      0x135C59
#define REG_BK135C_2D_L      0x135C5A
#define REG_BK135C_2D_H      0x135C5B
#define REG_BK135C_2E_L      0x135C5C
#define REG_BK135C_2E_H      0x135C5D
#define REG_BK135C_2F_L      0x135C5E
#define REG_BK135C_2F_H      0x135C5F
#define REG_BK135C_30_L      0x135C60
#define REG_BK135C_30_H      0x135C61
#define REG_BK135C_31_L      0x135C62
#define REG_BK135C_31_H      0x135C63
#define REG_BK135C_32_L      0x135C64
#define REG_BK135C_32_H      0x135C65
#define REG_BK135C_33_L      0x135C66
#define REG_BK135C_33_H      0x135C67
#define REG_BK135C_34_L      0x135C68
#define REG_BK135C_34_H      0x135C69
#define REG_BK135C_35_L      0x135C6A
#define REG_BK135C_35_H      0x135C6B
#define REG_BK135C_36_L      0x135C6C
#define REG_BK135C_36_H      0x135C6D
#define REG_BK135C_37_L      0x135C6E
#define REG_BK135C_37_H      0x135C6F
#define REG_BK135C_38_L      0x135C70
#define REG_BK135C_38_H      0x135C71
#define REG_BK135C_39_L      0x135C72
#define REG_BK135C_39_H      0x135C73
#define REG_BK135C_3A_L      0x135C74
#define REG_BK135C_3A_H      0x135C75
#define REG_BK135C_3B_L      0x135C76
#define REG_BK135C_3B_H      0x135C77
#define REG_BK135C_3C_L      0x135C78
#define REG_BK135C_3C_H      0x135C79
#define REG_BK135C_3D_L      0x135C7A
#define REG_BK135C_3D_H      0x135C7B
#define REG_BK135C_3E_L      0x135C7C
#define REG_BK135C_3E_H      0x135C7D
#define REG_BK135C_3F_L      0x135C7E
#define REG_BK135C_3F_H      0x135C7F
#define REG_BK135C_40_L      0x135C80
#define REG_BK135C_40_H      0x135C81
#define REG_BK135C_41_L      0x135C82
#define REG_BK135C_41_H      0x135C83
#define REG_BK135C_42_L      0x135C84
#define REG_BK135C_42_H      0x135C85
#define REG_BK135C_43_L      0x135C86
#define REG_BK135C_43_H      0x135C87
#define REG_BK135C_44_L      0x135C88
#define REG_BK135C_44_H      0x135C89
#define REG_BK135C_45_L      0x135C8A
#define REG_BK135C_45_H      0x135C8B
#define REG_BK135C_46_L      0x135C8C
#define REG_BK135C_46_H      0x135C8D
#define REG_BK135C_47_L      0x135C8E
#define REG_BK135C_47_H      0x135C8F
#define REG_BK135C_48_L      0x135C90
#define REG_BK135C_48_H      0x135C91
#define REG_BK135C_49_L      0x135C92
#define REG_BK135C_49_H      0x135C93
#define REG_BK135C_4A_L      0x135C94
#define REG_BK135C_4A_H      0x135C95
#define REG_BK135C_4B_L      0x135C96
#define REG_BK135C_4B_H      0x135C97
#define REG_BK135C_4C_L      0x135C98
#define REG_BK135C_4C_H      0x135C99
#define REG_BK135C_4D_L      0x135C9A
#define REG_BK135C_4D_H      0x135C9B
#define REG_BK135C_4E_L      0x135C9C
#define REG_BK135C_4E_H      0x135C9D
#define REG_BK135C_4F_L      0x135C9E
#define REG_BK135C_4F_H      0x135C9F
#define REG_BK135C_50_L      0x135CA0
#define REG_BK135C_50_H      0x135CA1
#define REG_BK135C_51_L      0x135CA2
#define REG_BK135C_51_H      0x135CA3
#define REG_BK135C_52_L      0x135CA4
#define REG_BK135C_52_H      0x135CA5
#define REG_BK135C_53_L      0x135CA6
#define REG_BK135C_53_H      0x135CA7
#define REG_BK135C_54_L      0x135CA8
#define REG_BK135C_54_H      0x135CA9
#define REG_BK135C_55_L      0x135CAA
#define REG_BK135C_55_H      0x135CAB
#define REG_BK135C_56_L      0x135CAC
#define REG_BK135C_56_H      0x135CAD
#define REG_BK135C_57_L      0x135CAE
#define REG_BK135C_57_H      0x135CAF
#define REG_BK135C_58_L      0x135CB0
#define REG_BK135C_58_H      0x135CB1
#define REG_BK135C_59_L      0x135CB2
#define REG_BK135C_59_H      0x135CB3
#define REG_BK135C_5A_L      0x135CB4
#define REG_BK135C_5A_H      0x135CB5
#define REG_BK135C_5B_L      0x135CB6
#define REG_BK135C_5B_H      0x135CB7
#define REG_BK135C_5C_L      0x135CB8
#define REG_BK135C_5C_H      0x135CB9
#define REG_BK135C_5D_L      0x135CBA
#define REG_BK135C_5D_H      0x135CBB
#define REG_BK135C_5E_L      0x135CBC
#define REG_BK135C_5E_H      0x135CBD
#define REG_BK135C_5F_L      0x135CBE
#define REG_BK135C_5F_H      0x135CBF
#define REG_BK135C_60_L      0x135CC0
#define REG_BK135C_60_H      0x135CC1
#define REG_BK135C_61_L      0x135CC2
#define REG_BK135C_61_H      0x135CC3
#define REG_BK135C_62_L      0x135CC4
#define REG_BK135C_62_H      0x135CC5
#define REG_BK135C_63_L      0x135CC6
#define REG_BK135C_63_H      0x135CC7
#define REG_BK135C_64_L      0x135CC8
#define REG_BK135C_64_H      0x135CC9
#define REG_BK135C_65_L      0x135CCA
#define REG_BK135C_65_H      0x135CCB
#define REG_BK135C_66_L      0x135CCC
#define REG_BK135C_66_H      0x135CCD
#define REG_BK135C_67_L      0x135CCE
#define REG_BK135C_67_H      0x135CCF
#define REG_BK135C_68_L      0x135CD0
#define REG_BK135C_68_H      0x135CD1
#define REG_BK135C_69_L      0x135CD2
#define REG_BK135C_69_H      0x135CD3
#define REG_BK135C_6A_L      0x135CD4
#define REG_BK135C_6A_H      0x135CD5
#define REG_BK135C_6B_L      0x135CD6
#define REG_BK135C_6B_H      0x135CD7
#define REG_BK135C_6C_L      0x135CD8
#define REG_BK135C_6C_H      0x135CD9
#define REG_BK135C_6D_L      0x135CDA
#define REG_BK135C_6D_H      0x135CDB
#define REG_BK135C_6E_L      0x135CDC
#define REG_BK135C_6E_H      0x135CDD
#define REG_BK135C_6F_L      0x135CDE
#define REG_BK135C_6F_H      0x135CDF
#define REG_BK135C_70_L      0x135CE0
#define REG_BK135C_70_H      0x135CE1
#define REG_BK135C_71_L      0x135CE2
#define REG_BK135C_71_H      0x135CE3
#define REG_BK135C_72_L      0x135CE4
#define REG_BK135C_72_H      0x135CE5
#define REG_BK135C_73_L      0x135CE6
#define REG_BK135C_73_H      0x135CE7
#define REG_BK135C_74_L      0x135CE8
#define REG_BK135C_74_H      0x135CE9
#define REG_BK135C_75_L      0x135CEA
#define REG_BK135C_75_H      0x135CEB
#define REG_BK135C_76_L      0x135CEC
#define REG_BK135C_76_H      0x135CED
#define REG_BK135C_77_L      0x135CEE
#define REG_BK135C_77_H      0x135CEF
#define REG_BK135C_78_L      0x135CF0
#define REG_BK135C_78_H      0x135CF1
#define REG_BK135C_79_L      0x135CF2
#define REG_BK135C_79_H      0x135CF3
#define REG_BK135C_7A_L      0x135CF4
#define REG_BK135C_7A_H      0x135CF5
#define REG_BK135C_7B_L      0x135CF6
#define REG_BK135C_7B_H      0x135CF7
#define REG_BK135C_7C_L      0x135CF8
#define REG_BK135C_7C_H      0x135CF9
#define REG_BK135C_7D_L      0x135CFA
#define REG_BK135C_7D_H      0x135CFB
#define REG_BK135C_7E_L      0x135CFC
#define REG_BK135C_7E_H      0x135CFD
#define REG_BK135C_7F_L      0x135CFE
#define REG_BK135C_7F_H      0x135CFF
//----------------------------------------------
#define REG_BK135F_00_L      0x135F00
#define REG_BK135F_00_H      0x135F01
#define REG_BK135F_01_L      0x135F02
#define REG_BK135F_01_H      0x135F03
#define REG_BK135F_02_L      0x135F04
#define REG_BK135F_02_H      0x135F05
#define REG_BK135F_03_L      0x135F06
#define REG_BK135F_03_H      0x135F07
#define REG_BK135F_04_L      0x135F08
#define REG_BK135F_04_H      0x135F09
#define REG_BK135F_05_L      0x135F0A
#define REG_BK135F_05_H      0x135F0B
#define REG_BK135F_06_L      0x135F0C
#define REG_BK135F_06_H      0x135F0D
#define REG_BK135F_07_L      0x135F0E
#define REG_BK135F_07_H      0x135F0F
#define REG_BK135F_08_L      0x135F10
#define REG_BK135F_08_H      0x135F11
#define REG_BK135F_09_L      0x135F12
#define REG_BK135F_09_H      0x135F13
#define REG_BK135F_0A_L      0x135F14
#define REG_BK135F_0A_H      0x135F15
#define REG_BK135F_0B_L      0x135F16
#define REG_BK135F_0B_H      0x135F17
#define REG_BK135F_0C_L      0x135F18
#define REG_BK135F_0C_H      0x135F19
#define REG_BK135F_0D_L      0x135F1A
#define REG_BK135F_0D_H      0x135F1B
#define REG_BK135F_0E_L      0x135F1C
#define REG_BK135F_0E_H      0x135F1D
#define REG_BK135F_0F_L      0x135F1E
#define REG_BK135F_0F_H      0x135F1F
#define REG_BK135F_10_L      0x135F20
#define REG_BK135F_10_H      0x135F21
#define REG_BK135F_11_L      0x135F22
#define REG_BK135F_11_H      0x135F23
#define REG_BK135F_12_L      0x135F24
#define REG_BK135F_12_H      0x135F25
#define REG_BK135F_13_L      0x135F26
#define REG_BK135F_13_H      0x135F27
#define REG_BK135F_14_L      0x135F28
#define REG_BK135F_14_H      0x135F29
#define REG_BK135F_15_L      0x135F2A
#define REG_BK135F_15_H      0x135F2B
#define REG_BK135F_16_L      0x135F2C
#define REG_BK135F_16_H      0x135F2D
#define REG_BK135F_17_L      0x135F2E
#define REG_BK135F_17_H      0x135F2F
#define REG_BK135F_18_L      0x135F30
#define REG_BK135F_18_H      0x135F31
#define REG_BK135F_19_L      0x135F32
#define REG_BK135F_19_H      0x135F33
#define REG_BK135F_1A_L      0x135F34
#define REG_BK135F_1A_H      0x135F35
#define REG_BK135F_1B_L      0x135F36
#define REG_BK135F_1B_H      0x135F37
#define REG_BK135F_1C_L      0x135F38
#define REG_BK135F_1C_H      0x135F39
#define REG_BK135F_1D_L      0x135F3A
#define REG_BK135F_1D_H      0x135F3B
#define REG_BK135F_1E_L      0x135F3C
#define REG_BK135F_1E_H      0x135F3D
#define REG_BK135F_1F_L      0x135F3E
#define REG_BK135F_1F_H      0x135F3F
#define REG_BK135F_20_L      0x135F40
#define REG_BK135F_20_H      0x135F41
#define REG_BK135F_21_L      0x135F42
#define REG_BK135F_21_H      0x135F43
#define REG_BK135F_22_L      0x135F44
#define REG_BK135F_22_H      0x135F45
#define REG_BK135F_23_L      0x135F46
#define REG_BK135F_23_H      0x135F47
#define REG_BK135F_24_L      0x135F48
#define REG_BK135F_24_H      0x135F49
#define REG_BK135F_25_L      0x135F4A
#define REG_BK135F_25_H      0x135F4B
#define REG_BK135F_26_L      0x135F4C
#define REG_BK135F_26_H      0x135F4D
#define REG_BK135F_27_L      0x135F4E
#define REG_BK135F_27_H      0x135F4F
#define REG_BK135F_28_L      0x135F50
#define REG_BK135F_28_H      0x135F51
#define REG_BK135F_29_L      0x135F52
#define REG_BK135F_29_H      0x135F53
#define REG_BK135F_2A_L      0x135F54
#define REG_BK135F_2A_H      0x135F55
#define REG_BK135F_2B_L      0x135F56
#define REG_BK135F_2B_H      0x135F57
#define REG_BK135F_2C_L      0x135F58
#define REG_BK135F_2C_H      0x135F59
#define REG_BK135F_2D_L      0x135F5A
#define REG_BK135F_2D_H      0x135F5B
#define REG_BK135F_2E_L      0x135F5C
#define REG_BK135F_2E_H      0x135F5D
#define REG_BK135F_2F_L      0x135F5E
#define REG_BK135F_2F_H      0x135F5F
#define REG_BK135F_30_L      0x135F60
#define REG_BK135F_30_H      0x135F61
#define REG_BK135F_31_L      0x135F62
#define REG_BK135F_31_H      0x135F63
#define REG_BK135F_32_L      0x135F64
#define REG_BK135F_32_H      0x135F65
#define REG_BK135F_33_L      0x135F66
#define REG_BK135F_33_H      0x135F67
#define REG_BK135F_34_L      0x135F68
#define REG_BK135F_34_H      0x135F69
#define REG_BK135F_35_L      0x135F6A
#define REG_BK135F_35_H      0x135F6B
#define REG_BK135F_36_L      0x135F6C
#define REG_BK135F_36_H      0x135F6D
#define REG_BK135F_37_L      0x135F6E
#define REG_BK135F_37_H      0x135F6F
#define REG_BK135F_38_L      0x135F70
#define REG_BK135F_38_H      0x135F71
#define REG_BK135F_39_L      0x135F72
#define REG_BK135F_39_H      0x135F73
#define REG_BK135F_3A_L      0x135F74
#define REG_BK135F_3A_H      0x135F75
#define REG_BK135F_3B_L      0x135F76
#define REG_BK135F_3B_H      0x135F77
#define REG_BK135F_3C_L      0x135F78
#define REG_BK135F_3C_H      0x135F79
#define REG_BK135F_3D_L      0x135F7A
#define REG_BK135F_3D_H      0x135F7B
#define REG_BK135F_3E_L      0x135F7C
#define REG_BK135F_3E_H      0x135F7D
#define REG_BK135F_3F_L      0x135F7E
#define REG_BK135F_3F_H      0x135F7F
#define REG_BK135F_40_L      0x135F80
#define REG_BK135F_40_H      0x135F81
#define REG_BK135F_41_L      0x135F82
#define REG_BK135F_41_H      0x135F83
#define REG_BK135F_42_L      0x135F84
#define REG_BK135F_42_H      0x135F85
#define REG_BK135F_43_L      0x135F86
#define REG_BK135F_43_H      0x135F87
#define REG_BK135F_44_L      0x135F88
#define REG_BK135F_44_H      0x135F89
#define REG_BK135F_45_L      0x135F8A
#define REG_BK135F_45_H      0x135F8B
#define REG_BK135F_46_L      0x135F8C
#define REG_BK135F_46_H      0x135F8D
#define REG_BK135F_47_L      0x135F8E
#define REG_BK135F_47_H      0x135F8F
#define REG_BK135F_48_L      0x135F90
#define REG_BK135F_48_H      0x135F91
#define REG_BK135F_49_L      0x135F92
#define REG_BK135F_49_H      0x135F93
#define REG_BK135F_4A_L      0x135F94
#define REG_BK135F_4A_H      0x135F95
#define REG_BK135F_4B_L      0x135F96
#define REG_BK135F_4B_H      0x135F97
#define REG_BK135F_4C_L      0x135F98
#define REG_BK135F_4C_H      0x135F99
#define REG_BK135F_4D_L      0x135F9A
#define REG_BK135F_4D_H      0x135F9B
#define REG_BK135F_4E_L      0x135F9C
#define REG_BK135F_4E_H      0x135F9D
#define REG_BK135F_4F_L      0x135F9E
#define REG_BK135F_4F_H      0x135F9F
#define REG_BK135F_50_L      0x135FA0
#define REG_BK135F_50_H      0x135FA1
#define REG_BK135F_51_L      0x135FA2
#define REG_BK135F_51_H      0x135FA3
#define REG_BK135F_52_L      0x135FA4
#define REG_BK135F_52_H      0x135FA5
#define REG_BK135F_53_L      0x135FA6
#define REG_BK135F_53_H      0x135FA7
#define REG_BK135F_54_L      0x135FA8
#define REG_BK135F_54_H      0x135FA9
#define REG_BK135F_55_L      0x135FAA
#define REG_BK135F_55_H      0x135FAB
#define REG_BK135F_56_L      0x135FAC
#define REG_BK135F_56_H      0x135FAD
#define REG_BK135F_57_L      0x135FAE
#define REG_BK135F_57_H      0x135FAF
#define REG_BK135F_58_L      0x135FB0
#define REG_BK135F_58_H      0x135FB1
#define REG_BK135F_59_L      0x135FB2
#define REG_BK135F_59_H      0x135FB3
#define REG_BK135F_5A_L      0x135FB4
#define REG_BK135F_5A_H      0x135FB5
#define REG_BK135F_5B_L      0x135FB6
#define REG_BK135F_5B_H      0x135FB7
#define REG_BK135F_5C_L      0x135FB8
#define REG_BK135F_5C_H      0x135FB9
#define REG_BK135F_5D_L      0x135FBA
#define REG_BK135F_5D_H      0x135FBB
#define REG_BK135F_5E_L      0x135FBC
#define REG_BK135F_5E_H      0x135FBD
#define REG_BK135F_5F_L      0x135FBE
#define REG_BK135F_5F_H      0x135FBF
#define REG_BK135F_60_L      0x135FC0
#define REG_BK135F_60_H      0x135FC1
#define REG_BK135F_61_L      0x135FC2
#define REG_BK135F_61_H      0x135FC3
#define REG_BK135F_62_L      0x135FC4
#define REG_BK135F_62_H      0x135FC5
#define REG_BK135F_63_L      0x135FC6
#define REG_BK135F_63_H      0x135FC7
#define REG_BK135F_64_L      0x135FC8
#define REG_BK135F_64_H      0x135FC9
#define REG_BK135F_65_L      0x135FCA
#define REG_BK135F_65_H      0x135FCB
#define REG_BK135F_66_L      0x135FCC
#define REG_BK135F_66_H      0x135FCD
#define REG_BK135F_67_L      0x135FCE
#define REG_BK135F_67_H      0x135FCF
#define REG_BK135F_68_L      0x135FD0
#define REG_BK135F_68_H      0x135FD1
#define REG_BK135F_69_L      0x135FD2
#define REG_BK135F_69_H      0x135FD3
#define REG_BK135F_6A_L      0x135FD4
#define REG_BK135F_6A_H      0x135FD5
#define REG_BK135F_6B_L      0x135FD6
#define REG_BK135F_6B_H      0x135FD7
#define REG_BK135F_6C_L      0x135FD8
#define REG_BK135F_6C_H      0x135FD9
#define REG_BK135F_6D_L      0x135FDA
#define REG_BK135F_6D_H      0x135FDB
#define REG_BK135F_6E_L      0x135FDC
#define REG_BK135F_6E_H      0x135FDD
#define REG_BK135F_6F_L      0x135FDE
#define REG_BK135F_6F_H      0x135FDF
#define REG_BK135F_70_L      0x135FE0
#define REG_BK135F_70_H      0x135FE1
#define REG_BK135F_71_L      0x135FE2
#define REG_BK135F_71_H      0x135FE3
#define REG_BK135F_72_L      0x135FE4
#define REG_BK135F_72_H      0x135FE5
#define REG_BK135F_73_L      0x135FE6
#define REG_BK135F_73_H      0x135FE7
#define REG_BK135F_74_L      0x135FE8
#define REG_BK135F_74_H      0x135FE9
#define REG_BK135F_75_L      0x135FEA
#define REG_BK135F_75_H      0x135FEB
#define REG_BK135F_76_L      0x135FEC
#define REG_BK135F_76_H      0x135FED
#define REG_BK135F_77_L      0x135FEE
#define REG_BK135F_77_H      0x135FEF
#define REG_BK135F_78_L      0x135FF0
#define REG_BK135F_78_H      0x135FF1
#define REG_BK135F_79_L      0x135FF2
#define REG_BK135F_79_H      0x135FF3
#define REG_BK135F_7A_L      0x135FF4
#define REG_BK135F_7A_H      0x135FF5
#define REG_BK135F_7B_L      0x135FF6
#define REG_BK135F_7B_H      0x135FF7
#define REG_BK135F_7C_L      0x135FF8
#define REG_BK135F_7C_H      0x135FF9
#define REG_BK135F_7D_L      0x135FFA
#define REG_BK135F_7D_H      0x135FFB
#define REG_BK135F_7E_L      0x135FFC
#define REG_BK135F_7E_H      0x135FFD
#define REG_BK135F_7F_L      0x135FFE
#define REG_BK135F_7F_H      0x135FFF
//----------------------------------------------
#define REG_BK1360_00_L      0x136000
#define REG_BK1360_00_H      0x136001
#define REG_BK1360_01_L      0x136002
#define REG_BK1360_01_H      0x136003
#define REG_BK1360_02_L      0x136004
#define REG_BK1360_02_H      0x136005
#define REG_BK1360_03_L      0x136006
#define REG_BK1360_03_H      0x136007
#define REG_BK1360_04_L      0x136008
#define REG_BK1360_04_H      0x136009
#define REG_BK1360_05_L      0x13600A
#define REG_BK1360_05_H      0x13600B
#define REG_BK1360_06_L      0x13600C
#define REG_BK1360_06_H      0x13600D
#define REG_BK1360_07_L      0x13600E
#define REG_BK1360_07_H      0x13600F
#define REG_BK1360_08_L      0x136010
#define REG_BK1360_08_H      0x136011
#define REG_BK1360_09_L      0x136012
#define REG_BK1360_09_H      0x136013
#define REG_BK1360_0A_L      0x136014
#define REG_BK1360_0A_H      0x136015
#define REG_BK1360_0B_L      0x136016
#define REG_BK1360_0B_H      0x136017
#define REG_BK1360_0C_L      0x136018
#define REG_BK1360_0C_H      0x136019
#define REG_BK1360_0D_L      0x13601A
#define REG_BK1360_0D_H      0x13601B
#define REG_BK1360_0E_L      0x13601C
#define REG_BK1360_0E_H      0x13601D
#define REG_BK1360_0F_L      0x13601E
#define REG_BK1360_0F_H      0x13601F
#define REG_BK1360_10_L      0x136020
#define REG_BK1360_10_H      0x136021
#define REG_BK1360_11_L      0x136022
#define REG_BK1360_11_H      0x136023
#define REG_BK1360_12_L      0x136024
#define REG_BK1360_12_H      0x136025
#define REG_BK1360_13_L      0x136026
#define REG_BK1360_13_H      0x136027
#define REG_BK1360_14_L      0x136028
#define REG_BK1360_14_H      0x136029
#define REG_BK1360_15_L      0x13602A
#define REG_BK1360_15_H      0x13602B
#define REG_BK1360_16_L      0x13602C
#define REG_BK1360_16_H      0x13602D
#define REG_BK1360_17_L      0x13602E
#define REG_BK1360_17_H      0x13602F
#define REG_BK1360_18_L      0x136030
#define REG_BK1360_18_H      0x136031
#define REG_BK1360_19_L      0x136032
#define REG_BK1360_19_H      0x136033
#define REG_BK1360_1A_L      0x136034
#define REG_BK1360_1A_H      0x136035
#define REG_BK1360_1B_L      0x136036
#define REG_BK1360_1B_H      0x136037
#define REG_BK1360_1C_L      0x136038
#define REG_BK1360_1C_H      0x136039
#define REG_BK1360_1D_L      0x13603A
#define REG_BK1360_1D_H      0x13603B
#define REG_BK1360_1E_L      0x13603C
#define REG_BK1360_1E_H      0x13603D
#define REG_BK1360_1F_L      0x13603E
#define REG_BK1360_1F_H      0x13603F
#define REG_BK1360_20_L      0x136040
#define REG_BK1360_20_H      0x136041
#define REG_BK1360_21_L      0x136042
#define REG_BK1360_21_H      0x136043
#define REG_BK1360_22_L      0x136044
#define REG_BK1360_22_H      0x136045
#define REG_BK1360_23_L      0x136046
#define REG_BK1360_23_H      0x136047
#define REG_BK1360_24_L      0x136048
#define REG_BK1360_24_H      0x136049
#define REG_BK1360_25_L      0x13604A
#define REG_BK1360_25_H      0x13604B
#define REG_BK1360_26_L      0x13604C
#define REG_BK1360_26_H      0x13604D
#define REG_BK1360_27_L      0x13604E
#define REG_BK1360_27_H      0x13604F
#define REG_BK1360_28_L      0x136050
#define REG_BK1360_28_H      0x136051
#define REG_BK1360_29_L      0x136052
#define REG_BK1360_29_H      0x136053
#define REG_BK1360_2A_L      0x136054
#define REG_BK1360_2A_H      0x136055
#define REG_BK1360_2B_L      0x136056
#define REG_BK1360_2B_H      0x136057
#define REG_BK1360_2C_L      0x136058
#define REG_BK1360_2C_H      0x136059
#define REG_BK1360_2D_L      0x13605A
#define REG_BK1360_2D_H      0x13605B
#define REG_BK1360_2E_L      0x13605C
#define REG_BK1360_2E_H      0x13605D
#define REG_BK1360_2F_L      0x13605E
#define REG_BK1360_2F_H      0x13605F
#define REG_BK1360_30_L      0x136060
#define REG_BK1360_30_H      0x136061
#define REG_BK1360_31_L      0x136062
#define REG_BK1360_31_H      0x136063
#define REG_BK1360_32_L      0x136064
#define REG_BK1360_32_H      0x136065
#define REG_BK1360_33_L      0x136066
#define REG_BK1360_33_H      0x136067
#define REG_BK1360_34_L      0x136068
#define REG_BK1360_34_H      0x136069
#define REG_BK1360_35_L      0x13606A
#define REG_BK1360_35_H      0x13606B
#define REG_BK1360_36_L      0x13606C
#define REG_BK1360_36_H      0x13606D
#define REG_BK1360_37_L      0x13606E
#define REG_BK1360_37_H      0x13606F
#define REG_BK1360_38_L      0x136070
#define REG_BK1360_38_H      0x136071
#define REG_BK1360_39_L      0x136072
#define REG_BK1360_39_H      0x136073
#define REG_BK1360_3A_L      0x136074
#define REG_BK1360_3A_H      0x136075
#define REG_BK1360_3B_L      0x136076
#define REG_BK1360_3B_H      0x136077
#define REG_BK1360_3C_L      0x136078
#define REG_BK1360_3C_H      0x136079
#define REG_BK1360_3D_L      0x13607A
#define REG_BK1360_3D_H      0x13607B
#define REG_BK1360_3E_L      0x13607C
#define REG_BK1360_3E_H      0x13607D
#define REG_BK1360_3F_L      0x13607E
#define REG_BK1360_3F_H      0x13607F
#define REG_BK1360_40_L      0x136080
#define REG_BK1360_40_H      0x136081
#define REG_BK1360_41_L      0x136082
#define REG_BK1360_41_H      0x136083
#define REG_BK1360_42_L      0x136084
#define REG_BK1360_42_H      0x136085
#define REG_BK1360_43_L      0x136086
#define REG_BK1360_43_H      0x136087
#define REG_BK1360_44_L      0x136088
#define REG_BK1360_44_H      0x136089
#define REG_BK1360_45_L      0x13608A
#define REG_BK1360_45_H      0x13608B
#define REG_BK1360_46_L      0x13608C
#define REG_BK1360_46_H      0x13608D
#define REG_BK1360_47_L      0x13608E
#define REG_BK1360_47_H      0x13608F
#define REG_BK1360_48_L      0x136090
#define REG_BK1360_48_H      0x136091
#define REG_BK1360_49_L      0x136092
#define REG_BK1360_49_H      0x136093
#define REG_BK1360_4A_L      0x136094
#define REG_BK1360_4A_H      0x136095
#define REG_BK1360_4B_L      0x136096
#define REG_BK1360_4B_H      0x136097
#define REG_BK1360_4C_L      0x136098
#define REG_BK1360_4C_H      0x136099
#define REG_BK1360_4D_L      0x13609A
#define REG_BK1360_4D_H      0x13609B
#define REG_BK1360_4E_L      0x13609C
#define REG_BK1360_4E_H      0x13609D
#define REG_BK1360_4F_L      0x13609E
#define REG_BK1360_4F_H      0x13609F
#define REG_BK1360_50_L      0x1360A0
#define REG_BK1360_50_H      0x1360A1
#define REG_BK1360_51_L      0x1360A2
#define REG_BK1360_51_H      0x1360A3
#define REG_BK1360_52_L      0x1360A4
#define REG_BK1360_52_H      0x1360A5
#define REG_BK1360_53_L      0x1360A6
#define REG_BK1360_53_H      0x1360A7
#define REG_BK1360_54_L      0x1360A8
#define REG_BK1360_54_H      0x1360A9
#define REG_BK1360_55_L      0x1360AA
#define REG_BK1360_55_H      0x1360AB
#define REG_BK1360_56_L      0x1360AC
#define REG_BK1360_56_H      0x1360AD
#define REG_BK1360_57_L      0x1360AE
#define REG_BK1360_57_H      0x1360AF
#define REG_BK1360_58_L      0x1360B0
#define REG_BK1360_58_H      0x1360B1
#define REG_BK1360_59_L      0x1360B2
#define REG_BK1360_59_H      0x1360B3
#define REG_BK1360_5A_L      0x1360B4
#define REG_BK1360_5A_H      0x1360B5
#define REG_BK1360_5B_L      0x1360B6
#define REG_BK1360_5B_H      0x1360B7
#define REG_BK1360_5C_L      0x1360B8
#define REG_BK1360_5C_H      0x1360B9
#define REG_BK1360_5D_L      0x1360BA
#define REG_BK1360_5D_H      0x1360BB
#define REG_BK1360_5E_L      0x1360BC
#define REG_BK1360_5E_H      0x1360BD
#define REG_BK1360_5F_L      0x1360BE
#define REG_BK1360_5F_H      0x1360BF
#define REG_BK1360_60_L      0x1360C0
#define REG_BK1360_60_H      0x1360C1
#define REG_BK1360_61_L      0x1360C2
#define REG_BK1360_61_H      0x1360C3
#define REG_BK1360_62_L      0x1360C4
#define REG_BK1360_62_H      0x1360C5
#define REG_BK1360_63_L      0x1360C6
#define REG_BK1360_63_H      0x1360C7
#define REG_BK1360_64_L      0x1360C8
#define REG_BK1360_64_H      0x1360C9
#define REG_BK1360_65_L      0x1360CA
#define REG_BK1360_65_H      0x1360CB
#define REG_BK1360_66_L      0x1360CC
#define REG_BK1360_66_H      0x1360CD
#define REG_BK1360_67_L      0x1360CE
#define REG_BK1360_67_H      0x1360CF
#define REG_BK1360_68_L      0x1360D0
#define REG_BK1360_68_H      0x1360D1
#define REG_BK1360_69_L      0x1360D2
#define REG_BK1360_69_H      0x1360D3
#define REG_BK1360_6A_L      0x1360D4
#define REG_BK1360_6A_H      0x1360D5
#define REG_BK1360_6B_L      0x1360D6
#define REG_BK1360_6B_H      0x1360D7
#define REG_BK1360_6C_L      0x1360D8
#define REG_BK1360_6C_H      0x1360D9
#define REG_BK1360_6D_L      0x1360DA
#define REG_BK1360_6D_H      0x1360DB
#define REG_BK1360_6E_L      0x1360DC
#define REG_BK1360_6E_H      0x1360DD
#define REG_BK1360_6F_L      0x1360DE
#define REG_BK1360_6F_H      0x1360DF
#define REG_BK1360_70_L      0x1360E0
#define REG_BK1360_70_H      0x1360E1
#define REG_BK1360_71_L      0x1360E2
#define REG_BK1360_71_H      0x1360E3
#define REG_BK1360_72_L      0x1360E4
#define REG_BK1360_72_H      0x1360E5
#define REG_BK1360_73_L      0x1360E6
#define REG_BK1360_73_H      0x1360E7
#define REG_BK1360_74_L      0x1360E8
#define REG_BK1360_74_H      0x1360E9
#define REG_BK1360_75_L      0x1360EA
#define REG_BK1360_75_H      0x1360EB
#define REG_BK1360_76_L      0x1360EC
#define REG_BK1360_76_H      0x1360ED
#define REG_BK1360_77_L      0x1360EE
#define REG_BK1360_77_H      0x1360EF
#define REG_BK1360_78_L      0x1360F0
#define REG_BK1360_78_H      0x1360F1
#define REG_BK1360_79_L      0x1360F2
#define REG_BK1360_79_H      0x1360F3
#define REG_BK1360_7A_L      0x1360F4
#define REG_BK1360_7A_H      0x1360F5
#define REG_BK1360_7B_L      0x1360F6
#define REG_BK1360_7B_H      0x1360F7
#define REG_BK1360_7C_L      0x1360F8
#define REG_BK1360_7C_H      0x1360F9
#define REG_BK1360_7D_L      0x1360FA
#define REG_BK1360_7D_H      0x1360FB
#define REG_BK1360_7E_L      0x1360FC
#define REG_BK1360_7E_H      0x1360FD
#define REG_BK1360_7F_L      0x1360FE
#define REG_BK1360_7F_H      0x1360FF
//----------------------------------------------
#define REG_BK1361_00_L      0x136100
#define REG_BK1361_00_H      0x136101
#define REG_BK1361_01_L      0x136102
#define REG_BK1361_01_H      0x136103
#define REG_BK1361_02_L      0x136104
#define REG_BK1361_02_H      0x136105
#define REG_BK1361_03_L      0x136106
#define REG_BK1361_03_H      0x136107
#define REG_BK1361_04_L      0x136108
#define REG_BK1361_04_H      0x136109
#define REG_BK1361_05_L      0x13610A
#define REG_BK1361_05_H      0x13610B
#define REG_BK1361_06_L      0x13610C
#define REG_BK1361_06_H      0x13610D
#define REG_BK1361_07_L      0x13610E
#define REG_BK1361_07_H      0x13610F
#define REG_BK1361_08_L      0x136110
#define REG_BK1361_08_H      0x136111
#define REG_BK1361_09_L      0x136112
#define REG_BK1361_09_H      0x136113
#define REG_BK1361_0A_L      0x136114
#define REG_BK1361_0A_H      0x136115
#define REG_BK1361_0B_L      0x136116
#define REG_BK1361_0B_H      0x136117
#define REG_BK1361_0C_L      0x136118
#define REG_BK1361_0C_H      0x136119
#define REG_BK1361_0D_L      0x13611A
#define REG_BK1361_0D_H      0x13611B
#define REG_BK1361_0E_L      0x13611C
#define REG_BK1361_0E_H      0x13611D
#define REG_BK1361_0F_L      0x13611E
#define REG_BK1361_0F_H      0x13611F
#define REG_BK1361_10_L      0x136120
#define REG_BK1361_10_H      0x136121
#define REG_BK1361_11_L      0x136122
#define REG_BK1361_11_H      0x136123
#define REG_BK1361_12_L      0x136124
#define REG_BK1361_12_H      0x136125
#define REG_BK1361_13_L      0x136126
#define REG_BK1361_13_H      0x136127
#define REG_BK1361_14_L      0x136128
#define REG_BK1361_14_H      0x136129
#define REG_BK1361_15_L      0x13612A
#define REG_BK1361_15_H      0x13612B
#define REG_BK1361_16_L      0x13612C
#define REG_BK1361_16_H      0x13612D
#define REG_BK1361_17_L      0x13612E
#define REG_BK1361_17_H      0x13612F
#define REG_BK1361_18_L      0x136130
#define REG_BK1361_18_H      0x136131
#define REG_BK1361_19_L      0x136132
#define REG_BK1361_19_H      0x136133
#define REG_BK1361_1A_L      0x136134
#define REG_BK1361_1A_H      0x136135
#define REG_BK1361_1B_L      0x136136
#define REG_BK1361_1B_H      0x136137
#define REG_BK1361_1C_L      0x136138
#define REG_BK1361_1C_H      0x136139
#define REG_BK1361_1D_L      0x13613A
#define REG_BK1361_1D_H      0x13613B
#define REG_BK1361_1E_L      0x13613C
#define REG_BK1361_1E_H      0x13613D
#define REG_BK1361_1F_L      0x13613E
#define REG_BK1361_1F_H      0x13613F
#define REG_BK1361_20_L      0x136140
#define REG_BK1361_20_H      0x136141
#define REG_BK1361_21_L      0x136142
#define REG_BK1361_21_H      0x136143
#define REG_BK1361_22_L      0x136144
#define REG_BK1361_22_H      0x136145
#define REG_BK1361_23_L      0x136146
#define REG_BK1361_23_H      0x136147
#define REG_BK1361_24_L      0x136148
#define REG_BK1361_24_H      0x136149
#define REG_BK1361_25_L      0x13614A
#define REG_BK1361_25_H      0x13614B
#define REG_BK1361_26_L      0x13614C
#define REG_BK1361_26_H      0x13614D
#define REG_BK1361_27_L      0x13614E
#define REG_BK1361_27_H      0x13614F
#define REG_BK1361_28_L      0x136150
#define REG_BK1361_28_H      0x136151
#define REG_BK1361_29_L      0x136152
#define REG_BK1361_29_H      0x136153
#define REG_BK1361_2A_L      0x136154
#define REG_BK1361_2A_H      0x136155
#define REG_BK1361_2B_L      0x136156
#define REG_BK1361_2B_H      0x136157
#define REG_BK1361_2C_L      0x136158
#define REG_BK1361_2C_H      0x136159
#define REG_BK1361_2D_L      0x13615A
#define REG_BK1361_2D_H      0x13615B
#define REG_BK1361_2E_L      0x13615C
#define REG_BK1361_2E_H      0x13615D
#define REG_BK1361_2F_L      0x13615E
#define REG_BK1361_2F_H      0x13615F
#define REG_BK1361_30_L      0x136160
#define REG_BK1361_30_H      0x136161
#define REG_BK1361_31_L      0x136162
#define REG_BK1361_31_H      0x136163
#define REG_BK1361_32_L      0x136164
#define REG_BK1361_32_H      0x136165
#define REG_BK1361_33_L      0x136166
#define REG_BK1361_33_H      0x136167
#define REG_BK1361_34_L      0x136168
#define REG_BK1361_34_H      0x136169
#define REG_BK1361_35_L      0x13616A
#define REG_BK1361_35_H      0x13616B
#define REG_BK1361_36_L      0x13616C
#define REG_BK1361_36_H      0x13616D
#define REG_BK1361_37_L      0x13616E
#define REG_BK1361_37_H      0x13616F
#define REG_BK1361_38_L      0x136170
#define REG_BK1361_38_H      0x136171
#define REG_BK1361_39_L      0x136172
#define REG_BK1361_39_H      0x136173
#define REG_BK1361_3A_L      0x136174
#define REG_BK1361_3A_H      0x136175
#define REG_BK1361_3B_L      0x136176
#define REG_BK1361_3B_H      0x136177
#define REG_BK1361_3C_L      0x136178
#define REG_BK1361_3C_H      0x136179
#define REG_BK1361_3D_L      0x13617A
#define REG_BK1361_3D_H      0x13617B
#define REG_BK1361_3E_L      0x13617C
#define REG_BK1361_3E_H      0x13617D
#define REG_BK1361_3F_L      0x13617E
#define REG_BK1361_3F_H      0x13617F
#define REG_BK1361_40_L      0x136180
#define REG_BK1361_40_H      0x136181
#define REG_BK1361_41_L      0x136182
#define REG_BK1361_41_H      0x136183
#define REG_BK1361_42_L      0x136184
#define REG_BK1361_42_H      0x136185
#define REG_BK1361_43_L      0x136186
#define REG_BK1361_43_H      0x136187
#define REG_BK1361_44_L      0x136188
#define REG_BK1361_44_H      0x136189
#define REG_BK1361_45_L      0x13618A
#define REG_BK1361_45_H      0x13618B
#define REG_BK1361_46_L      0x13618C
#define REG_BK1361_46_H      0x13618D
#define REG_BK1361_47_L      0x13618E
#define REG_BK1361_47_H      0x13618F
#define REG_BK1361_48_L      0x136190
#define REG_BK1361_48_H      0x136191
#define REG_BK1361_49_L      0x136192
#define REG_BK1361_49_H      0x136193
#define REG_BK1361_4A_L      0x136194
#define REG_BK1361_4A_H      0x136195
#define REG_BK1361_4B_L      0x136196
#define REG_BK1361_4B_H      0x136197
#define REG_BK1361_4C_L      0x136198
#define REG_BK1361_4C_H      0x136199
#define REG_BK1361_4D_L      0x13619A
#define REG_BK1361_4D_H      0x13619B
#define REG_BK1361_4E_L      0x13619C
#define REG_BK1361_4E_H      0x13619D
#define REG_BK1361_4F_L      0x13619E
#define REG_BK1361_4F_H      0x13619F
#define REG_BK1361_50_L      0x1361A0
#define REG_BK1361_50_H      0x1361A1
#define REG_BK1361_51_L      0x1361A2
#define REG_BK1361_51_H      0x1361A3
#define REG_BK1361_52_L      0x1361A4
#define REG_BK1361_52_H      0x1361A5
#define REG_BK1361_53_L      0x1361A6
#define REG_BK1361_53_H      0x1361A7
#define REG_BK1361_54_L      0x1361A8
#define REG_BK1361_54_H      0x1361A9
#define REG_BK1361_55_L      0x1361AA
#define REG_BK1361_55_H      0x1361AB
#define REG_BK1361_56_L      0x1361AC
#define REG_BK1361_56_H      0x1361AD
#define REG_BK1361_57_L      0x1361AE
#define REG_BK1361_57_H      0x1361AF
#define REG_BK1361_58_L      0x1361B0
#define REG_BK1361_58_H      0x1361B1
#define REG_BK1361_59_L      0x1361B2
#define REG_BK1361_59_H      0x1361B3
#define REG_BK1361_5A_L      0x1361B4
#define REG_BK1361_5A_H      0x1361B5
#define REG_BK1361_5B_L      0x1361B6
#define REG_BK1361_5B_H      0x1361B7
#define REG_BK1361_5C_L      0x1361B8
#define REG_BK1361_5C_H      0x1361B9
#define REG_BK1361_5D_L      0x1361BA
#define REG_BK1361_5D_H      0x1361BB
#define REG_BK1361_5E_L      0x1361BC
#define REG_BK1361_5E_H      0x1361BD
#define REG_BK1361_5F_L      0x1361BE
#define REG_BK1361_5F_H      0x1361BF
#define REG_BK1361_60_L      0x1361C0
#define REG_BK1361_60_H      0x1361C1
#define REG_BK1361_61_L      0x1361C2
#define REG_BK1361_61_H      0x1361C3
#define REG_BK1361_62_L      0x1361C4
#define REG_BK1361_62_H      0x1361C5
#define REG_BK1361_63_L      0x1361C6
#define REG_BK1361_63_H      0x1361C7
#define REG_BK1361_64_L      0x1361C8
#define REG_BK1361_64_H      0x1361C9
#define REG_BK1361_65_L      0x1361CA
#define REG_BK1361_65_H      0x1361CB
#define REG_BK1361_66_L      0x1361CC
#define REG_BK1361_66_H      0x1361CD
#define REG_BK1361_67_L      0x1361CE
#define REG_BK1361_67_H      0x1361CF
#define REG_BK1361_68_L      0x1361D0
#define REG_BK1361_68_H      0x1361D1
#define REG_BK1361_69_L      0x1361D2
#define REG_BK1361_69_H      0x1361D3
#define REG_BK1361_6A_L      0x1361D4
#define REG_BK1361_6A_H      0x1361D5
#define REG_BK1361_6B_L      0x1361D6
#define REG_BK1361_6B_H      0x1361D7
#define REG_BK1361_6C_L      0x1361D8
#define REG_BK1361_6C_H      0x1361D9
#define REG_BK1361_6D_L      0x1361DA
#define REG_BK1361_6D_H      0x1361DB
#define REG_BK1361_6E_L      0x1361DC
#define REG_BK1361_6E_H      0x1361DD
#define REG_BK1361_6F_L      0x1361DE
#define REG_BK1361_6F_H      0x1361DF
#define REG_BK1361_70_L      0x1361E0
#define REG_BK1361_70_H      0x1361E1
#define REG_BK1361_71_L      0x1361E2
#define REG_BK1361_71_H      0x1361E3
#define REG_BK1361_72_L      0x1361E4
#define REG_BK1361_72_H      0x1361E5
#define REG_BK1361_73_L      0x1361E6
#define REG_BK1361_73_H      0x1361E7
#define REG_BK1361_74_L      0x1361E8
#define REG_BK1361_74_H      0x1361E9
#define REG_BK1361_75_L      0x1361EA
#define REG_BK1361_75_H      0x1361EB
#define REG_BK1361_76_L      0x1361EC
#define REG_BK1361_76_H      0x1361ED
#define REG_BK1361_77_L      0x1361EE
#define REG_BK1361_77_H      0x1361EF
#define REG_BK1361_78_L      0x1361F0
#define REG_BK1361_78_H      0x1361F1
#define REG_BK1361_79_L      0x1361F2
#define REG_BK1361_79_H      0x1361F3
#define REG_BK1361_7A_L      0x1361F4
#define REG_BK1361_7A_H      0x1361F5
#define REG_BK1361_7B_L      0x1361F6
#define REG_BK1361_7B_H      0x1361F7
#define REG_BK1361_7C_L      0x1361F8
#define REG_BK1361_7C_H      0x1361F9
#define REG_BK1361_7D_L      0x1361FA
#define REG_BK1361_7D_H      0x1361FB
#define REG_BK1361_7E_L      0x1361FC
#define REG_BK1361_7E_H      0x1361FD
#define REG_BK1361_7F_L      0x1361FE
#define REG_BK1361_7F_H      0x1361FF
//----------------------------------------------
#define REG_BK1367_00_L      0x136700
#define REG_BK1367_00_H      0x136701
#define REG_BK1367_01_L      0x136702
#define REG_BK1367_01_H      0x136703
#define REG_BK1367_02_L      0x136704
#define REG_BK1367_02_H      0x136705
#define REG_BK1367_03_L      0x136706
#define REG_BK1367_03_H      0x136707
#define REG_BK1367_04_L      0x136708
#define REG_BK1367_04_H      0x136709
#define REG_BK1367_05_L      0x13670A
#define REG_BK1367_05_H      0x13670B
#define REG_BK1367_06_L      0x13670C
#define REG_BK1367_06_H      0x13670D
#define REG_BK1367_07_L      0x13670E
#define REG_BK1367_07_H      0x13670F
#define REG_BK1367_08_L      0x136710
#define REG_BK1367_08_H      0x136711
#define REG_BK1367_09_L      0x136712
#define REG_BK1367_09_H      0x136713
#define REG_BK1367_0A_L      0x136714
#define REG_BK1367_0A_H      0x136715
#define REG_BK1367_0B_L      0x136716
#define REG_BK1367_0B_H      0x136717
#define REG_BK1367_0C_L      0x136718
#define REG_BK1367_0C_H      0x136719
#define REG_BK1367_0D_L      0x13671A
#define REG_BK1367_0D_H      0x13671B
#define REG_BK1367_0E_L      0x13671C
#define REG_BK1367_0E_H      0x13671D
#define REG_BK1367_0F_L      0x13671E
#define REG_BK1367_0F_H      0x13671F
#define REG_BK1367_10_L      0x136720
#define REG_BK1367_10_H      0x136721
#define REG_BK1367_11_L      0x136722
#define REG_BK1367_11_H      0x136723
#define REG_BK1367_12_L      0x136724
#define REG_BK1367_12_H      0x136725
#define REG_BK1367_13_L      0x136726
#define REG_BK1367_13_H      0x136727
#define REG_BK1367_14_L      0x136728
#define REG_BK1367_14_H      0x136729
#define REG_BK1367_15_L      0x13672A
#define REG_BK1367_15_H      0x13672B
#define REG_BK1367_16_L      0x13672C
#define REG_BK1367_16_H      0x13672D
#define REG_BK1367_17_L      0x13672E
#define REG_BK1367_17_H      0x13672F
#define REG_BK1367_18_L      0x136730
#define REG_BK1367_18_H      0x136731
#define REG_BK1367_19_L      0x136732
#define REG_BK1367_19_H      0x136733
#define REG_BK1367_1A_L      0x136734
#define REG_BK1367_1A_H      0x136735
#define REG_BK1367_1B_L      0x136736
#define REG_BK1367_1B_H      0x136737
#define REG_BK1367_1C_L      0x136738
#define REG_BK1367_1C_H      0x136739
#define REG_BK1367_1D_L      0x13673A
#define REG_BK1367_1D_H      0x13673B
#define REG_BK1367_1E_L      0x13673C
#define REG_BK1367_1E_H      0x13673D
#define REG_BK1367_1F_L      0x13673E
#define REG_BK1367_1F_H      0x13673F
#define REG_BK1367_20_L      0x136740
#define REG_BK1367_20_H      0x136741
#define REG_BK1367_21_L      0x136742
#define REG_BK1367_21_H      0x136743
#define REG_BK1367_22_L      0x136744
#define REG_BK1367_22_H      0x136745
#define REG_BK1367_23_L      0x136746
#define REG_BK1367_23_H      0x136747
#define REG_BK1367_24_L      0x136748
#define REG_BK1367_24_H      0x136749
#define REG_BK1367_25_L      0x13674A
#define REG_BK1367_25_H      0x13674B
#define REG_BK1367_26_L      0x13674C
#define REG_BK1367_26_H      0x13674D
#define REG_BK1367_27_L      0x13674E
#define REG_BK1367_27_H      0x13674F
#define REG_BK1367_28_L      0x136750
#define REG_BK1367_28_H      0x136751
#define REG_BK1367_29_L      0x136752
#define REG_BK1367_29_H      0x136753
#define REG_BK1367_2A_L      0x136754
#define REG_BK1367_2A_H      0x136755
#define REG_BK1367_2B_L      0x136756
#define REG_BK1367_2B_H      0x136757
#define REG_BK1367_2C_L      0x136758
#define REG_BK1367_2C_H      0x136759
#define REG_BK1367_2D_L      0x13675A
#define REG_BK1367_2D_H      0x13675B
#define REG_BK1367_2E_L      0x13675C
#define REG_BK1367_2E_H      0x13675D
#define REG_BK1367_2F_L      0x13675E
#define REG_BK1367_2F_H      0x13675F
#define REG_BK1367_30_L      0x136760
#define REG_BK1367_30_H      0x136761
#define REG_BK1367_31_L      0x136762
#define REG_BK1367_31_H      0x136763
#define REG_BK1367_32_L      0x136764
#define REG_BK1367_32_H      0x136765
#define REG_BK1367_33_L      0x136766
#define REG_BK1367_33_H      0x136767
#define REG_BK1367_34_L      0x136768
#define REG_BK1367_34_H      0x136769
#define REG_BK1367_35_L      0x13676A
#define REG_BK1367_35_H      0x13676B
#define REG_BK1367_36_L      0x13676C
#define REG_BK1367_36_H      0x13676D
#define REG_BK1367_37_L      0x13676E
#define REG_BK1367_37_H      0x13676F
#define REG_BK1367_38_L      0x136770
#define REG_BK1367_38_H      0x136771
#define REG_BK1367_39_L      0x136772
#define REG_BK1367_39_H      0x136773
#define REG_BK1367_3A_L      0x136774
#define REG_BK1367_3A_H      0x136775
#define REG_BK1367_3B_L      0x136776
#define REG_BK1367_3B_H      0x136777
#define REG_BK1367_3C_L      0x136778
#define REG_BK1367_3C_H      0x136779
#define REG_BK1367_3D_L      0x13677A
#define REG_BK1367_3D_H      0x13677B
#define REG_BK1367_3E_L      0x13677C
#define REG_BK1367_3E_H      0x13677D
#define REG_BK1367_3F_L      0x13677E
#define REG_BK1367_3F_H      0x13677F
#define REG_BK1367_40_L      0x136780
#define REG_BK1367_40_H      0x136781
#define REG_BK1367_41_L      0x136782
#define REG_BK1367_41_H      0x136783
#define REG_BK1367_42_L      0x136784
#define REG_BK1367_42_H      0x136785
#define REG_BK1367_43_L      0x136786
#define REG_BK1367_43_H      0x136787
#define REG_BK1367_44_L      0x136788
#define REG_BK1367_44_H      0x136789
#define REG_BK1367_45_L      0x13678A
#define REG_BK1367_45_H      0x13678B
#define REG_BK1367_46_L      0x13678C
#define REG_BK1367_46_H      0x13678D
#define REG_BK1367_47_L      0x13678E
#define REG_BK1367_47_H      0x13678F
#define REG_BK1367_48_L      0x136790
#define REG_BK1367_48_H      0x136791
#define REG_BK1367_49_L      0x136792
#define REG_BK1367_49_H      0x136793
#define REG_BK1367_4A_L      0x136794
#define REG_BK1367_4A_H      0x136795
#define REG_BK1367_4B_L      0x136796
#define REG_BK1367_4B_H      0x136797
#define REG_BK1367_4C_L      0x136798
#define REG_BK1367_4C_H      0x136799
#define REG_BK1367_4D_L      0x13679A
#define REG_BK1367_4D_H      0x13679B
#define REG_BK1367_4E_L      0x13679C
#define REG_BK1367_4E_H      0x13679D
#define REG_BK1367_4F_L      0x13679E
#define REG_BK1367_4F_H      0x13679F
#define REG_BK1367_50_L      0x1367A0
#define REG_BK1367_50_H      0x1367A1
#define REG_BK1367_51_L      0x1367A2
#define REG_BK1367_51_H      0x1367A3
#define REG_BK1367_52_L      0x1367A4
#define REG_BK1367_52_H      0x1367A5
#define REG_BK1367_53_L      0x1367A6
#define REG_BK1367_53_H      0x1367A7
#define REG_BK1367_54_L      0x1367A8
#define REG_BK1367_54_H      0x1367A9
#define REG_BK1367_55_L      0x1367AA
#define REG_BK1367_55_H      0x1367AB
#define REG_BK1367_56_L      0x1367AC
#define REG_BK1367_56_H      0x1367AD
#define REG_BK1367_57_L      0x1367AE
#define REG_BK1367_57_H      0x1367AF
#define REG_BK1367_58_L      0x1367B0
#define REG_BK1367_58_H      0x1367B1
#define REG_BK1367_59_L      0x1367B2
#define REG_BK1367_59_H      0x1367B3
#define REG_BK1367_5A_L      0x1367B4
#define REG_BK1367_5A_H      0x1367B5
#define REG_BK1367_5B_L      0x1367B6
#define REG_BK1367_5B_H      0x1367B7
#define REG_BK1367_5C_L      0x1367B8
#define REG_BK1367_5C_H      0x1367B9
#define REG_BK1367_5D_L      0x1367BA
#define REG_BK1367_5D_H      0x1367BB
#define REG_BK1367_5E_L      0x1367BC
#define REG_BK1367_5E_H      0x1367BD
#define REG_BK1367_5F_L      0x1367BE
#define REG_BK1367_5F_H      0x1367BF
#define REG_BK1367_60_L      0x1367C0
#define REG_BK1367_60_H      0x1367C1
#define REG_BK1367_61_L      0x1367C2
#define REG_BK1367_61_H      0x1367C3
#define REG_BK1367_62_L      0x1367C4
#define REG_BK1367_62_H      0x1367C5
#define REG_BK1367_63_L      0x1367C6
#define REG_BK1367_63_H      0x1367C7
#define REG_BK1367_64_L      0x1367C8
#define REG_BK1367_64_H      0x1367C9
#define REG_BK1367_65_L      0x1367CA
#define REG_BK1367_65_H      0x1367CB
#define REG_BK1367_66_L      0x1367CC
#define REG_BK1367_66_H      0x1367CD
#define REG_BK1367_67_L      0x1367CE
#define REG_BK1367_67_H      0x1367CF
#define REG_BK1367_68_L      0x1367D0
#define REG_BK1367_68_H      0x1367D1
#define REG_BK1367_69_L      0x1367D2
#define REG_BK1367_69_H      0x1367D3
#define REG_BK1367_6A_L      0x1367D4
#define REG_BK1367_6A_H      0x1367D5
#define REG_BK1367_6B_L      0x1367D6
#define REG_BK1367_6B_H      0x1367D7
#define REG_BK1367_6C_L      0x1367D8
#define REG_BK1367_6C_H      0x1367D9
#define REG_BK1367_6D_L      0x1367DA
#define REG_BK1367_6D_H      0x1367DB
#define REG_BK1367_6E_L      0x1367DC
#define REG_BK1367_6E_H      0x1367DD
#define REG_BK1367_6F_L      0x1367DE
#define REG_BK1367_6F_H      0x1367DF
#define REG_BK1367_70_L      0x1367E0
#define REG_BK1367_70_H      0x1367E1
#define REG_BK1367_71_L      0x1367E2
#define REG_BK1367_71_H      0x1367E3
#define REG_BK1367_72_L      0x1367E4
#define REG_BK1367_72_H      0x1367E5
#define REG_BK1367_73_L      0x1367E6
#define REG_BK1367_73_H      0x1367E7
#define REG_BK1367_74_L      0x1367E8
#define REG_BK1367_74_H      0x1367E9
#define REG_BK1367_75_L      0x1367EA
#define REG_BK1367_75_H      0x1367EB
#define REG_BK1367_76_L      0x1367EC
#define REG_BK1367_76_H      0x1367ED
#define REG_BK1367_77_L      0x1367EE
#define REG_BK1367_77_H      0x1367EF
#define REG_BK1367_78_L      0x1367F0
#define REG_BK1367_78_H      0x1367F1
#define REG_BK1367_79_L      0x1367F2
#define REG_BK1367_79_H      0x1367F3
#define REG_BK1367_7A_L      0x1367F4
#define REG_BK1367_7A_H      0x1367F5
#define REG_BK1367_7B_L      0x1367F6
#define REG_BK1367_7B_H      0x1367F7
#define REG_BK1367_7C_L      0x1367F8
#define REG_BK1367_7C_H      0x1367F9
#define REG_BK1367_7D_L      0x1367FA
#define REG_BK1367_7D_H      0x1367FB
#define REG_BK1367_7E_L      0x1367FC
#define REG_BK1367_7E_H      0x1367FD
#define REG_BK1367_7F_L      0x1367FE
#define REG_BK1367_7F_H      0x1367FF
//----------------------------------------------
#define REG_BK136A_00_L      0x136A00
#define REG_BK136A_00_H      0x136A01
#define REG_BK136A_01_L      0x136A02
#define REG_BK136A_01_H      0x136A03
#define REG_BK136A_02_L      0x136A04
#define REG_BK136A_02_H      0x136A05
#define REG_BK136A_03_L      0x136A06
#define REG_BK136A_03_H      0x136A07
#define REG_BK136A_04_L      0x136A08
#define REG_BK136A_04_H      0x136A09
#define REG_BK136A_05_L      0x136A0A
#define REG_BK136A_05_H      0x136A0B
#define REG_BK136A_06_L      0x136A0C
#define REG_BK136A_06_H      0x136A0D
#define REG_BK136A_07_L      0x136A0E
#define REG_BK136A_07_H      0x136A0F
#define REG_BK136A_08_L      0x136A10
#define REG_BK136A_08_H      0x136A11
#define REG_BK136A_09_L      0x136A12
#define REG_BK136A_09_H      0x136A13
#define REG_BK136A_0A_L      0x136A14
#define REG_BK136A_0A_H      0x136A15
#define REG_BK136A_0B_L      0x136A16
#define REG_BK136A_0B_H      0x136A17
#define REG_BK136A_0C_L      0x136A18
#define REG_BK136A_0C_H      0x136A19
#define REG_BK136A_0D_L      0x136A1A
#define REG_BK136A_0D_H      0x136A1B
#define REG_BK136A_0E_L      0x136A1C
#define REG_BK136A_0E_H      0x136A1D
#define REG_BK136A_0F_L      0x136A1E
#define REG_BK136A_0F_H      0x136A1F
#define REG_BK136A_10_L      0x136A20
#define REG_BK136A_10_H      0x136A21
#define REG_BK136A_11_L      0x136A22
#define REG_BK136A_11_H      0x136A23
#define REG_BK136A_12_L      0x136A24
#define REG_BK136A_12_H      0x136A25
#define REG_BK136A_13_L      0x136A26
#define REG_BK136A_13_H      0x136A27
#define REG_BK136A_14_L      0x136A28
#define REG_BK136A_14_H      0x136A29
#define REG_BK136A_15_L      0x136A2A
#define REG_BK136A_15_H      0x136A2B
#define REG_BK136A_16_L      0x136A2C
#define REG_BK136A_16_H      0x136A2D
#define REG_BK136A_17_L      0x136A2E
#define REG_BK136A_17_H      0x136A2F
#define REG_BK136A_18_L      0x136A30
#define REG_BK136A_18_H      0x136A31
#define REG_BK136A_19_L      0x136A32
#define REG_BK136A_19_H      0x136A33
#define REG_BK136A_1A_L      0x136A34
#define REG_BK136A_1A_H      0x136A35
#define REG_BK136A_1B_L      0x136A36
#define REG_BK136A_1B_H      0x136A37
#define REG_BK136A_1C_L      0x136A38
#define REG_BK136A_1C_H      0x136A39
#define REG_BK136A_1D_L      0x136A3A
#define REG_BK136A_1D_H      0x136A3B
#define REG_BK136A_1E_L      0x136A3C
#define REG_BK136A_1E_H      0x136A3D
#define REG_BK136A_1F_L      0x136A3E
#define REG_BK136A_1F_H      0x136A3F
#define REG_BK136A_20_L      0x136A40
#define REG_BK136A_20_H      0x136A41
#define REG_BK136A_21_L      0x136A42
#define REG_BK136A_21_H      0x136A43
#define REG_BK136A_22_L      0x136A44
#define REG_BK136A_22_H      0x136A45
#define REG_BK136A_23_L      0x136A46
#define REG_BK136A_23_H      0x136A47
#define REG_BK136A_24_L      0x136A48
#define REG_BK136A_24_H      0x136A49
#define REG_BK136A_25_L      0x136A4A
#define REG_BK136A_25_H      0x136A4B
#define REG_BK136A_26_L      0x136A4C
#define REG_BK136A_26_H      0x136A4D
#define REG_BK136A_27_L      0x136A4E
#define REG_BK136A_27_H      0x136A4F
#define REG_BK136A_28_L      0x136A50
#define REG_BK136A_28_H      0x136A51
#define REG_BK136A_29_L      0x136A52
#define REG_BK136A_29_H      0x136A53
#define REG_BK136A_2A_L      0x136A54
#define REG_BK136A_2A_H      0x136A55
#define REG_BK136A_2B_L      0x136A56
#define REG_BK136A_2B_H      0x136A57
#define REG_BK136A_2C_L      0x136A58
#define REG_BK136A_2C_H      0x136A59
#define REG_BK136A_2D_L      0x136A5A
#define REG_BK136A_2D_H      0x136A5B
#define REG_BK136A_2E_L      0x136A5C
#define REG_BK136A_2E_H      0x136A5D
#define REG_BK136A_2F_L      0x136A5E
#define REG_BK136A_2F_H      0x136A5F
#define REG_BK136A_30_L      0x136A60
#define REG_BK136A_30_H      0x136A61
#define REG_BK136A_31_L      0x136A62
#define REG_BK136A_31_H      0x136A63
#define REG_BK136A_32_L      0x136A64
#define REG_BK136A_32_H      0x136A65
#define REG_BK136A_33_L      0x136A66
#define REG_BK136A_33_H      0x136A67
#define REG_BK136A_34_L      0x136A68
#define REG_BK136A_34_H      0x136A69
#define REG_BK136A_35_L      0x136A6A
#define REG_BK136A_35_H      0x136A6B
#define REG_BK136A_36_L      0x136A6C
#define REG_BK136A_36_H      0x136A6D
#define REG_BK136A_37_L      0x136A6E
#define REG_BK136A_37_H      0x136A6F
#define REG_BK136A_38_L      0x136A70
#define REG_BK136A_38_H      0x136A71
#define REG_BK136A_39_L      0x136A72
#define REG_BK136A_39_H      0x136A73
#define REG_BK136A_3A_L      0x136A74
#define REG_BK136A_3A_H      0x136A75
#define REG_BK136A_3B_L      0x136A76
#define REG_BK136A_3B_H      0x136A77
#define REG_BK136A_3C_L      0x136A78
#define REG_BK136A_3C_H      0x136A79
#define REG_BK136A_3D_L      0x136A7A
#define REG_BK136A_3D_H      0x136A7B
#define REG_BK136A_3E_L      0x136A7C
#define REG_BK136A_3E_H      0x136A7D
#define REG_BK136A_3F_L      0x136A7E
#define REG_BK136A_3F_H      0x136A7F
#define REG_BK136A_40_L      0x136A80
#define REG_BK136A_40_H      0x136A81
#define REG_BK136A_41_L      0x136A82
#define REG_BK136A_41_H      0x136A83
#define REG_BK136A_42_L      0x136A84
#define REG_BK136A_42_H      0x136A85
#define REG_BK136A_43_L      0x136A86
#define REG_BK136A_43_H      0x136A87
#define REG_BK136A_44_L      0x136A88
#define REG_BK136A_44_H      0x136A89
#define REG_BK136A_45_L      0x136A8A
#define REG_BK136A_45_H      0x136A8B
#define REG_BK136A_46_L      0x136A8C
#define REG_BK136A_46_H      0x136A8D
#define REG_BK136A_47_L      0x136A8E
#define REG_BK136A_47_H      0x136A8F
#define REG_BK136A_48_L      0x136A90
#define REG_BK136A_48_H      0x136A91
#define REG_BK136A_49_L      0x136A92
#define REG_BK136A_49_H      0x136A93
#define REG_BK136A_4A_L      0x136A94
#define REG_BK136A_4A_H      0x136A95
#define REG_BK136A_4B_L      0x136A96
#define REG_BK136A_4B_H      0x136A97
#define REG_BK136A_4C_L      0x136A98
#define REG_BK136A_4C_H      0x136A99
#define REG_BK136A_4D_L      0x136A9A
#define REG_BK136A_4D_H      0x136A9B
#define REG_BK136A_4E_L      0x136A9C
#define REG_BK136A_4E_H      0x136A9D
#define REG_BK136A_4F_L      0x136A9E
#define REG_BK136A_4F_H      0x136A9F
#define REG_BK136A_50_L      0x136AA0
#define REG_BK136A_50_H      0x136AA1
#define REG_BK136A_51_L      0x136AA2
#define REG_BK136A_51_H      0x136AA3
#define REG_BK136A_52_L      0x136AA4
#define REG_BK136A_52_H      0x136AA5
#define REG_BK136A_53_L      0x136AA6
#define REG_BK136A_53_H      0x136AA7
#define REG_BK136A_54_L      0x136AA8
#define REG_BK136A_54_H      0x136AA9
#define REG_BK136A_55_L      0x136AAA
#define REG_BK136A_55_H      0x136AAB
#define REG_BK136A_56_L      0x136AAC
#define REG_BK136A_56_H      0x136AAD
#define REG_BK136A_57_L      0x136AAE
#define REG_BK136A_57_H      0x136AAF
#define REG_BK136A_58_L      0x136AB0
#define REG_BK136A_58_H      0x136AB1
#define REG_BK136A_59_L      0x136AB2
#define REG_BK136A_59_H      0x136AB3
#define REG_BK136A_5A_L      0x136AB4
#define REG_BK136A_5A_H      0x136AB5
#define REG_BK136A_5B_L      0x136AB6
#define REG_BK136A_5B_H      0x136AB7
#define REG_BK136A_5C_L      0x136AB8
#define REG_BK136A_5C_H      0x136AB9
#define REG_BK136A_5D_L      0x136ABA
#define REG_BK136A_5D_H      0x136ABB
#define REG_BK136A_5E_L      0x136ABC
#define REG_BK136A_5E_H      0x136ABD
#define REG_BK136A_5F_L      0x136ABE
#define REG_BK136A_5F_H      0x136ABF
#define REG_BK136A_60_L      0x136AC0
#define REG_BK136A_60_H      0x136AC1
#define REG_BK136A_61_L      0x136AC2
#define REG_BK136A_61_H      0x136AC3
#define REG_BK136A_62_L      0x136AC4
#define REG_BK136A_62_H      0x136AC5
#define REG_BK136A_63_L      0x136AC6
#define REG_BK136A_63_H      0x136AC7
#define REG_BK136A_64_L      0x136AC8
#define REG_BK136A_64_H      0x136AC9
#define REG_BK136A_65_L      0x136ACA
#define REG_BK136A_65_H      0x136ACB
#define REG_BK136A_66_L      0x136ACC
#define REG_BK136A_66_H      0x136ACD
#define REG_BK136A_67_L      0x136ACE
#define REG_BK136A_67_H      0x136ACF
#define REG_BK136A_68_L      0x136AD0
#define REG_BK136A_68_H      0x136AD1
#define REG_BK136A_69_L      0x136AD2
#define REG_BK136A_69_H      0x136AD3
#define REG_BK136A_6A_L      0x136AD4
#define REG_BK136A_6A_H      0x136AD5
#define REG_BK136A_6B_L      0x136AD6
#define REG_BK136A_6B_H      0x136AD7
#define REG_BK136A_6C_L      0x136AD8
#define REG_BK136A_6C_H      0x136AD9
#define REG_BK136A_6D_L      0x136ADA
#define REG_BK136A_6D_H      0x136ADB
#define REG_BK136A_6E_L      0x136ADC
#define REG_BK136A_6E_H      0x136ADD
#define REG_BK136A_6F_L      0x136ADE
#define REG_BK136A_6F_H      0x136ADF
#define REG_BK136A_70_L      0x136AE0
#define REG_BK136A_70_H      0x136AE1
#define REG_BK136A_71_L      0x136AE2
#define REG_BK136A_71_H      0x136AE3
#define REG_BK136A_72_L      0x136AE4
#define REG_BK136A_72_H      0x136AE5
#define REG_BK136A_73_L      0x136AE6
#define REG_BK136A_73_H      0x136AE7
#define REG_BK136A_74_L      0x136AE8
#define REG_BK136A_74_H      0x136AE9
#define REG_BK136A_75_L      0x136AEA
#define REG_BK136A_75_H      0x136AEB
#define REG_BK136A_76_L      0x136AEC
#define REG_BK136A_76_H      0x136AED
#define REG_BK136A_77_L      0x136AEE
#define REG_BK136A_77_H      0x136AEF
#define REG_BK136A_78_L      0x136AF0
#define REG_BK136A_78_H      0x136AF1
#define REG_BK136A_79_L      0x136AF2
#define REG_BK136A_79_H      0x136AF3
#define REG_BK136A_7A_L      0x136AF4
#define REG_BK136A_7A_H      0x136AF5
#define REG_BK136A_7B_L      0x136AF6
#define REG_BK136A_7B_H      0x136AF7
#define REG_BK136A_7C_L      0x136AF8
#define REG_BK136A_7C_H      0x136AF9
#define REG_BK136A_7D_L      0x136AFA
#define REG_BK136A_7D_H      0x136AFB
#define REG_BK136A_7E_L      0x136AFC
#define REG_BK136A_7E_H      0x136AFD
#define REG_BK136A_7F_L      0x136AFE
#define REG_BK136A_7F_H      0x136AFF
//----------------------------------------------
#define REG_BK136B_00_L      0x136B00
#define REG_BK136B_00_H      0x136B01
#define REG_BK136B_01_L      0x136B02
#define REG_BK136B_01_H      0x136B03
#define REG_BK136B_02_L      0x136B04
#define REG_BK136B_02_H      0x136B05
#define REG_BK136B_03_L      0x136B06
#define REG_BK136B_03_H      0x136B07
#define REG_BK136B_04_L      0x136B08
#define REG_BK136B_04_H      0x136B09
#define REG_BK136B_05_L      0x136B0A
#define REG_BK136B_05_H      0x136B0B
#define REG_BK136B_06_L      0x136B0C
#define REG_BK136B_06_H      0x136B0D
#define REG_BK136B_07_L      0x136B0E
#define REG_BK136B_07_H      0x136B0F
#define REG_BK136B_08_L      0x136B10
#define REG_BK136B_08_H      0x136B11
#define REG_BK136B_09_L      0x136B12
#define REG_BK136B_09_H      0x136B13
#define REG_BK136B_0A_L      0x136B14
#define REG_BK136B_0A_H      0x136B15
#define REG_BK136B_0B_L      0x136B16
#define REG_BK136B_0B_H      0x136B17
#define REG_BK136B_0C_L      0x136B18
#define REG_BK136B_0C_H      0x136B19
#define REG_BK136B_0D_L      0x136B1A
#define REG_BK136B_0D_H      0x136B1B
#define REG_BK136B_0E_L      0x136B1C
#define REG_BK136B_0E_H      0x136B1D
#define REG_BK136B_0F_L      0x136B1E
#define REG_BK136B_0F_H      0x136B1F
#define REG_BK136B_10_L      0x136B20
#define REG_BK136B_10_H      0x136B21
#define REG_BK136B_11_L      0x136B22
#define REG_BK136B_11_H      0x136B23
#define REG_BK136B_12_L      0x136B24
#define REG_BK136B_12_H      0x136B25
#define REG_BK136B_13_L      0x136B26
#define REG_BK136B_13_H      0x136B27
#define REG_BK136B_14_L      0x136B28
#define REG_BK136B_14_H      0x136B29
#define REG_BK136B_15_L      0x136B2A
#define REG_BK136B_15_H      0x136B2B
#define REG_BK136B_16_L      0x136B2C
#define REG_BK136B_16_H      0x136B2D
#define REG_BK136B_17_L      0x136B2E
#define REG_BK136B_17_H      0x136B2F
#define REG_BK136B_18_L      0x136B30
#define REG_BK136B_18_H      0x136B31
#define REG_BK136B_19_L      0x136B32
#define REG_BK136B_19_H      0x136B33
#define REG_BK136B_1A_L      0x136B34
#define REG_BK136B_1A_H      0x136B35
#define REG_BK136B_1B_L      0x136B36
#define REG_BK136B_1B_H      0x136B37
#define REG_BK136B_1C_L      0x136B38
#define REG_BK136B_1C_H      0x136B39
#define REG_BK136B_1D_L      0x136B3A
#define REG_BK136B_1D_H      0x136B3B
#define REG_BK136B_1E_L      0x136B3C
#define REG_BK136B_1E_H      0x136B3D
#define REG_BK136B_1F_L      0x136B3E
#define REG_BK136B_1F_H      0x136B3F
#define REG_BK136B_20_L      0x136B40
#define REG_BK136B_20_H      0x136B41
#define REG_BK136B_21_L      0x136B42
#define REG_BK136B_21_H      0x136B43
#define REG_BK136B_22_L      0x136B44
#define REG_BK136B_22_H      0x136B45
#define REG_BK136B_23_L      0x136B46
#define REG_BK136B_23_H      0x136B47
#define REG_BK136B_24_L      0x136B48
#define REG_BK136B_24_H      0x136B49
#define REG_BK136B_25_L      0x136B4A
#define REG_BK136B_25_H      0x136B4B
#define REG_BK136B_26_L      0x136B4C
#define REG_BK136B_26_H      0x136B4D
#define REG_BK136B_27_L      0x136B4E
#define REG_BK136B_27_H      0x136B4F
#define REG_BK136B_28_L      0x136B50
#define REG_BK136B_28_H      0x136B51
#define REG_BK136B_29_L      0x136B52
#define REG_BK136B_29_H      0x136B53
#define REG_BK136B_2A_L      0x136B54
#define REG_BK136B_2A_H      0x136B55
#define REG_BK136B_2B_L      0x136B56
#define REG_BK136B_2B_H      0x136B57
#define REG_BK136B_2C_L      0x136B58
#define REG_BK136B_2C_H      0x136B59
#define REG_BK136B_2D_L      0x136B5A
#define REG_BK136B_2D_H      0x136B5B
#define REG_BK136B_2E_L      0x136B5C
#define REG_BK136B_2E_H      0x136B5D
#define REG_BK136B_2F_L      0x136B5E
#define REG_BK136B_2F_H      0x136B5F
#define REG_BK136B_30_L      0x136B60
#define REG_BK136B_30_H      0x136B61
#define REG_BK136B_31_L      0x136B62
#define REG_BK136B_31_H      0x136B63
#define REG_BK136B_32_L      0x136B64
#define REG_BK136B_32_H      0x136B65
#define REG_BK136B_33_L      0x136B66
#define REG_BK136B_33_H      0x136B67
#define REG_BK136B_34_L      0x136B68
#define REG_BK136B_34_H      0x136B69
#define REG_BK136B_35_L      0x136B6A
#define REG_BK136B_35_H      0x136B6B
#define REG_BK136B_36_L      0x136B6C
#define REG_BK136B_36_H      0x136B6D
#define REG_BK136B_37_L      0x136B6E
#define REG_BK136B_37_H      0x136B6F
#define REG_BK136B_38_L      0x136B70
#define REG_BK136B_38_H      0x136B71
#define REG_BK136B_39_L      0x136B72
#define REG_BK136B_39_H      0x136B73
#define REG_BK136B_3A_L      0x136B74
#define REG_BK136B_3A_H      0x136B75
#define REG_BK136B_3B_L      0x136B76
#define REG_BK136B_3B_H      0x136B77
#define REG_BK136B_3C_L      0x136B78
#define REG_BK136B_3C_H      0x136B79
#define REG_BK136B_3D_L      0x136B7A
#define REG_BK136B_3D_H      0x136B7B
#define REG_BK136B_3E_L      0x136B7C
#define REG_BK136B_3E_H      0x136B7D
#define REG_BK136B_3F_L      0x136B7E
#define REG_BK136B_3F_H      0x136B7F
#define REG_BK136B_40_L      0x136B80
#define REG_BK136B_40_H      0x136B81
#define REG_BK136B_41_L      0x136B82
#define REG_BK136B_41_H      0x136B83
#define REG_BK136B_42_L      0x136B84
#define REG_BK136B_42_H      0x136B85
#define REG_BK136B_43_L      0x136B86
#define REG_BK136B_43_H      0x136B87
#define REG_BK136B_44_L      0x136B88
#define REG_BK136B_44_H      0x136B89
#define REG_BK136B_45_L      0x136B8A
#define REG_BK136B_45_H      0x136B8B
#define REG_BK136B_46_L      0x136B8C
#define REG_BK136B_46_H      0x136B8D
#define REG_BK136B_47_L      0x136B8E
#define REG_BK136B_47_H      0x136B8F
#define REG_BK136B_48_L      0x136B90
#define REG_BK136B_48_H      0x136B91
#define REG_BK136B_49_L      0x136B92
#define REG_BK136B_49_H      0x136B93
#define REG_BK136B_4A_L      0x136B94
#define REG_BK136B_4A_H      0x136B95
#define REG_BK136B_4B_L      0x136B96
#define REG_BK136B_4B_H      0x136B97
#define REG_BK136B_4C_L      0x136B98
#define REG_BK136B_4C_H      0x136B99
#define REG_BK136B_4D_L      0x136B9A
#define REG_BK136B_4D_H      0x136B9B
#define REG_BK136B_4E_L      0x136B9C
#define REG_BK136B_4E_H      0x136B9D
#define REG_BK136B_4F_L      0x136B9E
#define REG_BK136B_4F_H      0x136B9F
#define REG_BK136B_50_L      0x136BA0
#define REG_BK136B_50_H      0x136BA1
#define REG_BK136B_51_L      0x136BA2
#define REG_BK136B_51_H      0x136BA3
#define REG_BK136B_52_L      0x136BA4
#define REG_BK136B_52_H      0x136BA5
#define REG_BK136B_53_L      0x136BA6
#define REG_BK136B_53_H      0x136BA7
#define REG_BK136B_54_L      0x136BA8
#define REG_BK136B_54_H      0x136BA9
#define REG_BK136B_55_L      0x136BAA
#define REG_BK136B_55_H      0x136BAB
#define REG_BK136B_56_L      0x136BAC
#define REG_BK136B_56_H      0x136BAD
#define REG_BK136B_57_L      0x136BAE
#define REG_BK136B_57_H      0x136BAF
#define REG_BK136B_58_L      0x136BB0
#define REG_BK136B_58_H      0x136BB1
#define REG_BK136B_59_L      0x136BB2
#define REG_BK136B_59_H      0x136BB3
#define REG_BK136B_5A_L      0x136BB4
#define REG_BK136B_5A_H      0x136BB5
#define REG_BK136B_5B_L      0x136BB6
#define REG_BK136B_5B_H      0x136BB7
#define REG_BK136B_5C_L      0x136BB8
#define REG_BK136B_5C_H      0x136BB9
#define REG_BK136B_5D_L      0x136BBA
#define REG_BK136B_5D_H      0x136BBB
#define REG_BK136B_5E_L      0x136BBC
#define REG_BK136B_5E_H      0x136BBD
#define REG_BK136B_5F_L      0x136BBE
#define REG_BK136B_5F_H      0x136BBF
#define REG_BK136B_60_L      0x136BC0
#define REG_BK136B_60_H      0x136BC1
#define REG_BK136B_61_L      0x136BC2
#define REG_BK136B_61_H      0x136BC3
#define REG_BK136B_62_L      0x136BC4
#define REG_BK136B_62_H      0x136BC5
#define REG_BK136B_63_L      0x136BC6
#define REG_BK136B_63_H      0x136BC7
#define REG_BK136B_64_L      0x136BC8
#define REG_BK136B_64_H      0x136BC9
#define REG_BK136B_65_L      0x136BCA
#define REG_BK136B_65_H      0x136BCB
#define REG_BK136B_66_L      0x136BCC
#define REG_BK136B_66_H      0x136BCD
#define REG_BK136B_67_L      0x136BCE
#define REG_BK136B_67_H      0x136BCF
#define REG_BK136B_68_L      0x136BD0
#define REG_BK136B_68_H      0x136BD1
#define REG_BK136B_69_L      0x136BD2
#define REG_BK136B_69_H      0x136BD3
#define REG_BK136B_6A_L      0x136BD4
#define REG_BK136B_6A_H      0x136BD5
#define REG_BK136B_6B_L      0x136BD6
#define REG_BK136B_6B_H      0x136BD7
#define REG_BK136B_6C_L      0x136BD8
#define REG_BK136B_6C_H      0x136BD9
#define REG_BK136B_6D_L      0x136BDA
#define REG_BK136B_6D_H      0x136BDB
#define REG_BK136B_6E_L      0x136BDC
#define REG_BK136B_6E_H      0x136BDD
#define REG_BK136B_6F_L      0x136BDE
#define REG_BK136B_6F_H      0x136BDF
#define REG_BK136B_70_L      0x136BE0
#define REG_BK136B_70_H      0x136BE1
#define REG_BK136B_71_L      0x136BE2
#define REG_BK136B_71_H      0x136BE3
#define REG_BK136B_72_L      0x136BE4
#define REG_BK136B_72_H      0x136BE5
#define REG_BK136B_73_L      0x136BE6
#define REG_BK136B_73_H      0x136BE7
#define REG_BK136B_74_L      0x136BE8
#define REG_BK136B_74_H      0x136BE9
#define REG_BK136B_75_L      0x136BEA
#define REG_BK136B_75_H      0x136BEB
#define REG_BK136B_76_L      0x136BEC
#define REG_BK136B_76_H      0x136BED
#define REG_BK136B_77_L      0x136BEE
#define REG_BK136B_77_H      0x136BEF
#define REG_BK136B_78_L      0x136BF0
#define REG_BK136B_78_H      0x136BF1
#define REG_BK136B_79_L      0x136BF2
#define REG_BK136B_79_H      0x136BF3
#define REG_BK136B_7A_L      0x136BF4
#define REG_BK136B_7A_H      0x136BF5
#define REG_BK136B_7B_L      0x136BF6
#define REG_BK136B_7B_H      0x136BF7
#define REG_BK136B_7C_L      0x136BF8
#define REG_BK136B_7C_H      0x136BF9
#define REG_BK136B_7D_L      0x136BFA
#define REG_BK136B_7D_H      0x136BFB
#define REG_BK136B_7E_L      0x136BFC
#define REG_BK136B_7E_H      0x136BFD
#define REG_BK136B_7F_L      0x136BFE
#define REG_BK136B_7F_H      0x136BFF
//----------------------------------------------
#define REG_BK136C_00_L      0x136C00
#define REG_BK136C_00_H      0x136C01
#define REG_BK136C_01_L      0x136C02
#define REG_BK136C_01_H      0x136C03
#define REG_BK136C_02_L      0x136C04
#define REG_BK136C_02_H      0x136C05
#define REG_BK136C_03_L      0x136C06
#define REG_BK136C_03_H      0x136C07
#define REG_BK136C_04_L      0x136C08
#define REG_BK136C_04_H      0x136C09
#define REG_BK136C_05_L      0x136C0A
#define REG_BK136C_05_H      0x136C0B
#define REG_BK136C_06_L      0x136C0C
#define REG_BK136C_06_H      0x136C0D
#define REG_BK136C_07_L      0x136C0E
#define REG_BK136C_07_H      0x136C0F
#define REG_BK136C_08_L      0x136C10
#define REG_BK136C_08_H      0x136C11
#define REG_BK136C_09_L      0x136C12
#define REG_BK136C_09_H      0x136C13
#define REG_BK136C_0A_L      0x136C14
#define REG_BK136C_0A_H      0x136C15
#define REG_BK136C_0B_L      0x136C16
#define REG_BK136C_0B_H      0x136C17
#define REG_BK136C_0C_L      0x136C18
#define REG_BK136C_0C_H      0x136C19
#define REG_BK136C_0D_L      0x136C1A
#define REG_BK136C_0D_H      0x136C1B
#define REG_BK136C_0E_L      0x136C1C
#define REG_BK136C_0E_H      0x136C1D
#define REG_BK136C_0F_L      0x136C1E
#define REG_BK136C_0F_H      0x136C1F
#define REG_BK136C_10_L      0x136C20
#define REG_BK136C_10_H      0x136C21
#define REG_BK136C_11_L      0x136C22
#define REG_BK136C_11_H      0x136C23
#define REG_BK136C_12_L      0x136C24
#define REG_BK136C_12_H      0x136C25
#define REG_BK136C_13_L      0x136C26
#define REG_BK136C_13_H      0x136C27
#define REG_BK136C_14_L      0x136C28
#define REG_BK136C_14_H      0x136C29
#define REG_BK136C_15_L      0x136C2A
#define REG_BK136C_15_H      0x136C2B
#define REG_BK136C_16_L      0x136C2C
#define REG_BK136C_16_H      0x136C2D
#define REG_BK136C_17_L      0x136C2E
#define REG_BK136C_17_H      0x136C2F
#define REG_BK136C_18_L      0x136C30
#define REG_BK136C_18_H      0x136C31
#define REG_BK136C_19_L      0x136C32
#define REG_BK136C_19_H      0x136C33
#define REG_BK136C_1A_L      0x136C34
#define REG_BK136C_1A_H      0x136C35
#define REG_BK136C_1B_L      0x136C36
#define REG_BK136C_1B_H      0x136C37
#define REG_BK136C_1C_L      0x136C38
#define REG_BK136C_1C_H      0x136C39
#define REG_BK136C_1D_L      0x136C3A
#define REG_BK136C_1D_H      0x136C3B
#define REG_BK136C_1E_L      0x136C3C
#define REG_BK136C_1E_H      0x136C3D
#define REG_BK136C_1F_L      0x136C3E
#define REG_BK136C_1F_H      0x136C3F
#define REG_BK136C_20_L      0x136C40
#define REG_BK136C_20_H      0x136C41
#define REG_BK136C_21_L      0x136C42
#define REG_BK136C_21_H      0x136C43
#define REG_BK136C_22_L      0x136C44
#define REG_BK136C_22_H      0x136C45
#define REG_BK136C_23_L      0x136C46
#define REG_BK136C_23_H      0x136C47
#define REG_BK136C_24_L      0x136C48
#define REG_BK136C_24_H      0x136C49
#define REG_BK136C_25_L      0x136C4A
#define REG_BK136C_25_H      0x136C4B
#define REG_BK136C_26_L      0x136C4C
#define REG_BK136C_26_H      0x136C4D
#define REG_BK136C_27_L      0x136C4E
#define REG_BK136C_27_H      0x136C4F
#define REG_BK136C_28_L      0x136C50
#define REG_BK136C_28_H      0x136C51
#define REG_BK136C_29_L      0x136C52
#define REG_BK136C_29_H      0x136C53
#define REG_BK136C_2A_L      0x136C54
#define REG_BK136C_2A_H      0x136C55
#define REG_BK136C_2B_L      0x136C56
#define REG_BK136C_2B_H      0x136C57
#define REG_BK136C_2C_L      0x136C58
#define REG_BK136C_2C_H      0x136C59
#define REG_BK136C_2D_L      0x136C5A
#define REG_BK136C_2D_H      0x136C5B
#define REG_BK136C_2E_L      0x136C5C
#define REG_BK136C_2E_H      0x136C5D
#define REG_BK136C_2F_L      0x136C5E
#define REG_BK136C_2F_H      0x136C5F
#define REG_BK136C_30_L      0x136C60
#define REG_BK136C_30_H      0x136C61
#define REG_BK136C_31_L      0x136C62
#define REG_BK136C_31_H      0x136C63
#define REG_BK136C_32_L      0x136C64
#define REG_BK136C_32_H      0x136C65
#define REG_BK136C_33_L      0x136C66
#define REG_BK136C_33_H      0x136C67
#define REG_BK136C_34_L      0x136C68
#define REG_BK136C_34_H      0x136C69
#define REG_BK136C_35_L      0x136C6A
#define REG_BK136C_35_H      0x136C6B
#define REG_BK136C_36_L      0x136C6C
#define REG_BK136C_36_H      0x136C6D
#define REG_BK136C_37_L      0x136C6E
#define REG_BK136C_37_H      0x136C6F
#define REG_BK136C_38_L      0x136C70
#define REG_BK136C_38_H      0x136C71
#define REG_BK136C_39_L      0x136C72
#define REG_BK136C_39_H      0x136C73
#define REG_BK136C_3A_L      0x136C74
#define REG_BK136C_3A_H      0x136C75
#define REG_BK136C_3B_L      0x136C76
#define REG_BK136C_3B_H      0x136C77
#define REG_BK136C_3C_L      0x136C78
#define REG_BK136C_3C_H      0x136C79
#define REG_BK136C_3D_L      0x136C7A
#define REG_BK136C_3D_H      0x136C7B
#define REG_BK136C_3E_L      0x136C7C
#define REG_BK136C_3E_H      0x136C7D
#define REG_BK136C_3F_L      0x136C7E
#define REG_BK136C_3F_H      0x136C7F
#define REG_BK136C_40_L      0x136C80
#define REG_BK136C_40_H      0x136C81
#define REG_BK136C_41_L      0x136C82
#define REG_BK136C_41_H      0x136C83
#define REG_BK136C_42_L      0x136C84
#define REG_BK136C_42_H      0x136C85
#define REG_BK136C_43_L      0x136C86
#define REG_BK136C_43_H      0x136C87
#define REG_BK136C_44_L      0x136C88
#define REG_BK136C_44_H      0x136C89
#define REG_BK136C_45_L      0x136C8A
#define REG_BK136C_45_H      0x136C8B
#define REG_BK136C_46_L      0x136C8C
#define REG_BK136C_46_H      0x136C8D
#define REG_BK136C_47_L      0x136C8E
#define REG_BK136C_47_H      0x136C8F
#define REG_BK136C_48_L      0x136C90
#define REG_BK136C_48_H      0x136C91
#define REG_BK136C_49_L      0x136C92
#define REG_BK136C_49_H      0x136C93
#define REG_BK136C_4A_L      0x136C94
#define REG_BK136C_4A_H      0x136C95
#define REG_BK136C_4B_L      0x136C96
#define REG_BK136C_4B_H      0x136C97
#define REG_BK136C_4C_L      0x136C98
#define REG_BK136C_4C_H      0x136C99
#define REG_BK136C_4D_L      0x136C9A
#define REG_BK136C_4D_H      0x136C9B
#define REG_BK136C_4E_L      0x136C9C
#define REG_BK136C_4E_H      0x136C9D
#define REG_BK136C_4F_L      0x136C9E
#define REG_BK136C_4F_H      0x136C9F
#define REG_BK136C_50_L      0x136CA0
#define REG_BK136C_50_H      0x136CA1
#define REG_BK136C_51_L      0x136CA2
#define REG_BK136C_51_H      0x136CA3
#define REG_BK136C_52_L      0x136CA4
#define REG_BK136C_52_H      0x136CA5
#define REG_BK136C_53_L      0x136CA6
#define REG_BK136C_53_H      0x136CA7
#define REG_BK136C_54_L      0x136CA8
#define REG_BK136C_54_H      0x136CA9
#define REG_BK136C_55_L      0x136CAA
#define REG_BK136C_55_H      0x136CAB
#define REG_BK136C_56_L      0x136CAC
#define REG_BK136C_56_H      0x136CAD
#define REG_BK136C_57_L      0x136CAE
#define REG_BK136C_57_H      0x136CAF
#define REG_BK136C_58_L      0x136CB0
#define REG_BK136C_58_H      0x136CB1
#define REG_BK136C_59_L      0x136CB2
#define REG_BK136C_59_H      0x136CB3
#define REG_BK136C_5A_L      0x136CB4
#define REG_BK136C_5A_H      0x136CB5
#define REG_BK136C_5B_L      0x136CB6
#define REG_BK136C_5B_H      0x136CB7
#define REG_BK136C_5C_L      0x136CB8
#define REG_BK136C_5C_H      0x136CB9
#define REG_BK136C_5D_L      0x136CBA
#define REG_BK136C_5D_H      0x136CBB
#define REG_BK136C_5E_L      0x136CBC
#define REG_BK136C_5E_H      0x136CBD
#define REG_BK136C_5F_L      0x136CBE
#define REG_BK136C_5F_H      0x136CBF
#define REG_BK136C_60_L      0x136CC0
#define REG_BK136C_60_H      0x136CC1
#define REG_BK136C_61_L      0x136CC2
#define REG_BK136C_61_H      0x136CC3
#define REG_BK136C_62_L      0x136CC4
#define REG_BK136C_62_H      0x136CC5
#define REG_BK136C_63_L      0x136CC6
#define REG_BK136C_63_H      0x136CC7
#define REG_BK136C_64_L      0x136CC8
#define REG_BK136C_64_H      0x136CC9
#define REG_BK136C_65_L      0x136CCA
#define REG_BK136C_65_H      0x136CCB
#define REG_BK136C_66_L      0x136CCC
#define REG_BK136C_66_H      0x136CCD
#define REG_BK136C_67_L      0x136CCE
#define REG_BK136C_67_H      0x136CCF
#define REG_BK136C_68_L      0x136CD0
#define REG_BK136C_68_H      0x136CD1
#define REG_BK136C_69_L      0x136CD2
#define REG_BK136C_69_H      0x136CD3
#define REG_BK136C_6A_L      0x136CD4
#define REG_BK136C_6A_H      0x136CD5
#define REG_BK136C_6B_L      0x136CD6
#define REG_BK136C_6B_H      0x136CD7
#define REG_BK136C_6C_L      0x136CD8
#define REG_BK136C_6C_H      0x136CD9
#define REG_BK136C_6D_L      0x136CDA
#define REG_BK136C_6D_H      0x136CDB
#define REG_BK136C_6E_L      0x136CDC
#define REG_BK136C_6E_H      0x136CDD
#define REG_BK136C_6F_L      0x136CDE
#define REG_BK136C_6F_H      0x136CDF
#define REG_BK136C_70_L      0x136CE0
#define REG_BK136C_70_H      0x136CE1
#define REG_BK136C_71_L      0x136CE2
#define REG_BK136C_71_H      0x136CE3
#define REG_BK136C_72_L      0x136CE4
#define REG_BK136C_72_H      0x136CE5
#define REG_BK136C_73_L      0x136CE6
#define REG_BK136C_73_H      0x136CE7
#define REG_BK136C_74_L      0x136CE8
#define REG_BK136C_74_H      0x136CE9
#define REG_BK136C_75_L      0x136CEA
#define REG_BK136C_75_H      0x136CEB
#define REG_BK136C_76_L      0x136CEC
#define REG_BK136C_76_H      0x136CED
#define REG_BK136C_77_L      0x136CEE
#define REG_BK136C_77_H      0x136CEF
#define REG_BK136C_78_L      0x136CF0
#define REG_BK136C_78_H      0x136CF1
#define REG_BK136C_79_L      0x136CF2
#define REG_BK136C_79_H      0x136CF3
#define REG_BK136C_7A_L      0x136CF4
#define REG_BK136C_7A_H      0x136CF5
#define REG_BK136C_7B_L      0x136CF6
#define REG_BK136C_7B_H      0x136CF7
#define REG_BK136C_7C_L      0x136CF8
#define REG_BK136C_7C_H      0x136CF9
#define REG_BK136C_7D_L      0x136CFA
#define REG_BK136C_7D_H      0x136CFB
#define REG_BK136C_7E_L      0x136CFC
#define REG_BK136C_7E_H      0x136CFD
#define REG_BK136C_7F_L      0x136CFE
#define REG_BK136C_7F_H      0x136CFF
//----------------------------------------------
#define REG_BK136E_00_L      0x136E00
#define REG_BK136E_00_H      0x136E01
#define REG_BK136E_01_L      0x136E02
#define REG_BK136E_01_H      0x136E03
#define REG_BK136E_02_L      0x136E04
#define REG_BK136E_02_H      0x136E05
#define REG_BK136E_03_L      0x136E06
#define REG_BK136E_03_H      0x136E07
#define REG_BK136E_04_L      0x136E08
#define REG_BK136E_04_H      0x136E09
#define REG_BK136E_05_L      0x136E0A
#define REG_BK136E_05_H      0x136E0B
#define REG_BK136E_06_L      0x136E0C
#define REG_BK136E_06_H      0x136E0D
#define REG_BK136E_07_L      0x136E0E
#define REG_BK136E_07_H      0x136E0F
#define REG_BK136E_08_L      0x136E10
#define REG_BK136E_08_H      0x136E11
#define REG_BK136E_09_L      0x136E12
#define REG_BK136E_09_H      0x136E13
#define REG_BK136E_0A_L      0x136E14
#define REG_BK136E_0A_H      0x136E15
#define REG_BK136E_0B_L      0x136E16
#define REG_BK136E_0B_H      0x136E17
#define REG_BK136E_0C_L      0x136E18
#define REG_BK136E_0C_H      0x136E19
#define REG_BK136E_0D_L      0x136E1A
#define REG_BK136E_0D_H      0x136E1B
#define REG_BK136E_0E_L      0x136E1C
#define REG_BK136E_0E_H      0x136E1D
#define REG_BK136E_0F_L      0x136E1E
#define REG_BK136E_0F_H      0x136E1F
#define REG_BK136E_10_L      0x136E20
#define REG_BK136E_10_H      0x136E21
#define REG_BK136E_11_L      0x136E22
#define REG_BK136E_11_H      0x136E23
#define REG_BK136E_12_L      0x136E24
#define REG_BK136E_12_H      0x136E25
#define REG_BK136E_13_L      0x136E26
#define REG_BK136E_13_H      0x136E27
#define REG_BK136E_14_L      0x136E28
#define REG_BK136E_14_H      0x136E29
#define REG_BK136E_15_L      0x136E2A
#define REG_BK136E_15_H      0x136E2B
#define REG_BK136E_16_L      0x136E2C
#define REG_BK136E_16_H      0x136E2D
#define REG_BK136E_17_L      0x136E2E
#define REG_BK136E_17_H      0x136E2F
#define REG_BK136E_18_L      0x136E30
#define REG_BK136E_18_H      0x136E31
#define REG_BK136E_19_L      0x136E32
#define REG_BK136E_19_H      0x136E33
#define REG_BK136E_1A_L      0x136E34
#define REG_BK136E_1A_H      0x136E35
#define REG_BK136E_1B_L      0x136E36
#define REG_BK136E_1B_H      0x136E37
#define REG_BK136E_1C_L      0x136E38
#define REG_BK136E_1C_H      0x136E39
#define REG_BK136E_1D_L      0x136E3A
#define REG_BK136E_1D_H      0x136E3B
#define REG_BK136E_1E_L      0x136E3C
#define REG_BK136E_1E_H      0x136E3D
#define REG_BK136E_1F_L      0x136E3E
#define REG_BK136E_1F_H      0x136E3F
#define REG_BK136E_20_L      0x136E40
#define REG_BK136E_20_H      0x136E41
#define REG_BK136E_21_L      0x136E42
#define REG_BK136E_21_H      0x136E43
#define REG_BK136E_22_L      0x136E44
#define REG_BK136E_22_H      0x136E45
#define REG_BK136E_23_L      0x136E46
#define REG_BK136E_23_H      0x136E47
#define REG_BK136E_24_L      0x136E48
#define REG_BK136E_24_H      0x136E49
#define REG_BK136E_25_L      0x136E4A
#define REG_BK136E_25_H      0x136E4B
#define REG_BK136E_26_L      0x136E4C
#define REG_BK136E_26_H      0x136E4D
#define REG_BK136E_27_L      0x136E4E
#define REG_BK136E_27_H      0x136E4F
#define REG_BK136E_28_L      0x136E50
#define REG_BK136E_28_H      0x136E51
#define REG_BK136E_29_L      0x136E52
#define REG_BK136E_29_H      0x136E53
#define REG_BK136E_2A_L      0x136E54
#define REG_BK136E_2A_H      0x136E55
#define REG_BK136E_2B_L      0x136E56
#define REG_BK136E_2B_H      0x136E57
#define REG_BK136E_2C_L      0x136E58
#define REG_BK136E_2C_H      0x136E59
#define REG_BK136E_2D_L      0x136E5A
#define REG_BK136E_2D_H      0x136E5B
#define REG_BK136E_2E_L      0x136E5C
#define REG_BK136E_2E_H      0x136E5D
#define REG_BK136E_2F_L      0x136E5E
#define REG_BK136E_2F_H      0x136E5F
#define REG_BK136E_30_L      0x136E60
#define REG_BK136E_30_H      0x136E61
#define REG_BK136E_31_L      0x136E62
#define REG_BK136E_31_H      0x136E63
#define REG_BK136E_32_L      0x136E64
#define REG_BK136E_32_H      0x136E65
#define REG_BK136E_33_L      0x136E66
#define REG_BK136E_33_H      0x136E67
#define REG_BK136E_34_L      0x136E68
#define REG_BK136E_34_H      0x136E69
#define REG_BK136E_35_L      0x136E6A
#define REG_BK136E_35_H      0x136E6B
#define REG_BK136E_36_L      0x136E6C
#define REG_BK136E_36_H      0x136E6D
#define REG_BK136E_37_L      0x136E6E
#define REG_BK136E_37_H      0x136E6F
#define REG_BK136E_38_L      0x136E70
#define REG_BK136E_38_H      0x136E71
#define REG_BK136E_39_L      0x136E72
#define REG_BK136E_39_H      0x136E73
#define REG_BK136E_3A_L      0x136E74
#define REG_BK136E_3A_H      0x136E75
#define REG_BK136E_3B_L      0x136E76
#define REG_BK136E_3B_H      0x136E77
#define REG_BK136E_3C_L      0x136E78
#define REG_BK136E_3C_H      0x136E79
#define REG_BK136E_3D_L      0x136E7A
#define REG_BK136E_3D_H      0x136E7B
#define REG_BK136E_3E_L      0x136E7C
#define REG_BK136E_3E_H      0x136E7D
#define REG_BK136E_3F_L      0x136E7E
#define REG_BK136E_3F_H      0x136E7F
#define REG_BK136E_40_L      0x136E80
#define REG_BK136E_40_H      0x136E81
#define REG_BK136E_41_L      0x136E82
#define REG_BK136E_41_H      0x136E83
#define REG_BK136E_42_L      0x136E84
#define REG_BK136E_42_H      0x136E85
#define REG_BK136E_43_L      0x136E86
#define REG_BK136E_43_H      0x136E87
#define REG_BK136E_44_L      0x136E88
#define REG_BK136E_44_H      0x136E89
#define REG_BK136E_45_L      0x136E8A
#define REG_BK136E_45_H      0x136E8B
#define REG_BK136E_46_L      0x136E8C
#define REG_BK136E_46_H      0x136E8D
#define REG_BK136E_47_L      0x136E8E
#define REG_BK136E_47_H      0x136E8F
#define REG_BK136E_48_L      0x136E90
#define REG_BK136E_48_H      0x136E91
#define REG_BK136E_49_L      0x136E92
#define REG_BK136E_49_H      0x136E93
#define REG_BK136E_4A_L      0x136E94
#define REG_BK136E_4A_H      0x136E95
#define REG_BK136E_4B_L      0x136E96
#define REG_BK136E_4B_H      0x136E97
#define REG_BK136E_4C_L      0x136E98
#define REG_BK136E_4C_H      0x136E99
#define REG_BK136E_4D_L      0x136E9A
#define REG_BK136E_4D_H      0x136E9B
#define REG_BK136E_4E_L      0x136E9C
#define REG_BK136E_4E_H      0x136E9D
#define REG_BK136E_4F_L      0x136E9E
#define REG_BK136E_4F_H      0x136E9F
#define REG_BK136E_50_L      0x136EA0
#define REG_BK136E_50_H      0x136EA1
#define REG_BK136E_51_L      0x136EA2
#define REG_BK136E_51_H      0x136EA3
#define REG_BK136E_52_L      0x136EA4
#define REG_BK136E_52_H      0x136EA5
#define REG_BK136E_53_L      0x136EA6
#define REG_BK136E_53_H      0x136EA7
#define REG_BK136E_54_L      0x136EA8
#define REG_BK136E_54_H      0x136EA9
#define REG_BK136E_55_L      0x136EAA
#define REG_BK136E_55_H      0x136EAB
#define REG_BK136E_56_L      0x136EAC
#define REG_BK136E_56_H      0x136EAD
#define REG_BK136E_57_L      0x136EAE
#define REG_BK136E_57_H      0x136EAF
#define REG_BK136E_58_L      0x136EB0
#define REG_BK136E_58_H      0x136EB1
#define REG_BK136E_59_L      0x136EB2
#define REG_BK136E_59_H      0x136EB3
#define REG_BK136E_5A_L      0x136EB4
#define REG_BK136E_5A_H      0x136EB5
#define REG_BK136E_5B_L      0x136EB6
#define REG_BK136E_5B_H      0x136EB7
#define REG_BK136E_5C_L      0x136EB8
#define REG_BK136E_5C_H      0x136EB9
#define REG_BK136E_5D_L      0x136EBA
#define REG_BK136E_5D_H      0x136EBB
#define REG_BK136E_5E_L      0x136EBC
#define REG_BK136E_5E_H      0x136EBD
#define REG_BK136E_5F_L      0x136EBE
#define REG_BK136E_5F_H      0x136EBF
#define REG_BK136E_60_L      0x136EC0
#define REG_BK136E_60_H      0x136EC1
#define REG_BK136E_61_L      0x136EC2
#define REG_BK136E_61_H      0x136EC3
#define REG_BK136E_62_L      0x136EC4
#define REG_BK136E_62_H      0x136EC5
#define REG_BK136E_63_L      0x136EC6
#define REG_BK136E_63_H      0x136EC7
#define REG_BK136E_64_L      0x136EC8
#define REG_BK136E_64_H      0x136EC9
#define REG_BK136E_65_L      0x136ECA
#define REG_BK136E_65_H      0x136ECB
#define REG_BK136E_66_L      0x136ECC
#define REG_BK136E_66_H      0x136ECD
#define REG_BK136E_67_L      0x136ECE
#define REG_BK136E_67_H      0x136ECF
#define REG_BK136E_68_L      0x136ED0
#define REG_BK136E_68_H      0x136ED1
#define REG_BK136E_69_L      0x136ED2
#define REG_BK136E_69_H      0x136ED3
#define REG_BK136E_6A_L      0x136ED4
#define REG_BK136E_6A_H      0x136ED5
#define REG_BK136E_6B_L      0x136ED6
#define REG_BK136E_6B_H      0x136ED7
#define REG_BK136E_6C_L      0x136ED8
#define REG_BK136E_6C_H      0x136ED9
#define REG_BK136E_6D_L      0x136EDA
#define REG_BK136E_6D_H      0x136EDB
#define REG_BK136E_6E_L      0x136EDC
#define REG_BK136E_6E_H      0x136EDD
#define REG_BK136E_6F_L      0x136EDE
#define REG_BK136E_6F_H      0x136EDF
#define REG_BK136E_70_L      0x136EE0
#define REG_BK136E_70_H      0x136EE1
#define REG_BK136E_71_L      0x136EE2
#define REG_BK136E_71_H      0x136EE3
#define REG_BK136E_72_L      0x136EE4
#define REG_BK136E_72_H      0x136EE5
#define REG_BK136E_73_L      0x136EE6
#define REG_BK136E_73_H      0x136EE7
#define REG_BK136E_74_L      0x136EE8
#define REG_BK136E_74_H      0x136EE9
#define REG_BK136E_75_L      0x136EEA
#define REG_BK136E_75_H      0x136EEB
#define REG_BK136E_76_L      0x136EEC
#define REG_BK136E_76_H      0x136EED
#define REG_BK136E_77_L      0x136EEE
#define REG_BK136E_77_H      0x136EEF
#define REG_BK136E_78_L      0x136EF0
#define REG_BK136E_78_H      0x136EF1
#define REG_BK136E_79_L      0x136EF2
#define REG_BK136E_79_H      0x136EF3
#define REG_BK136E_7A_L      0x136EF4
#define REG_BK136E_7A_H      0x136EF5
#define REG_BK136E_7B_L      0x136EF6
#define REG_BK136E_7B_H      0x136EF7
#define REG_BK136E_7C_L      0x136EF8
#define REG_BK136E_7C_H      0x136EF9
#define REG_BK136E_7D_L      0x136EFA
#define REG_BK136E_7D_H      0x136EFB
#define REG_BK136E_7E_L      0x136EFC
#define REG_BK136E_7E_H      0x136EFD
#define REG_BK136E_7F_L      0x136EFE
#define REG_BK136E_7F_H      0x136EFF
//----------------------------------------------
#define REG_BK1376_00_L      0x137600
#define REG_BK1376_00_H      0x137601
#define REG_BK1376_01_L      0x137602
#define REG_BK1376_01_H      0x137603
#define REG_BK1376_02_L      0x137604
#define REG_BK1376_02_H      0x137605
#define REG_BK1376_03_L      0x137606
#define REG_BK1376_03_H      0x137607
#define REG_BK1376_04_L      0x137608
#define REG_BK1376_04_H      0x137609
#define REG_BK1376_05_L      0x13760A
#define REG_BK1376_05_H      0x13760B
#define REG_BK1376_06_L      0x13760C
#define REG_BK1376_06_H      0x13760D
#define REG_BK1376_07_L      0x13760E
#define REG_BK1376_07_H      0x13760F
#define REG_BK1376_08_L      0x137610
#define REG_BK1376_08_H      0x137611
#define REG_BK1376_09_L      0x137612
#define REG_BK1376_09_H      0x137613
#define REG_BK1376_0A_L      0x137614
#define REG_BK1376_0A_H      0x137615
#define REG_BK1376_0B_L      0x137616
#define REG_BK1376_0B_H      0x137617
#define REG_BK1376_0C_L      0x137618
#define REG_BK1376_0C_H      0x137619
#define REG_BK1376_0D_L      0x13761A
#define REG_BK1376_0D_H      0x13761B
#define REG_BK1376_0E_L      0x13761C
#define REG_BK1376_0E_H      0x13761D
#define REG_BK1376_0F_L      0x13761E
#define REG_BK1376_0F_H      0x13761F
#define REG_BK1376_10_L      0x137620
#define REG_BK1376_10_H      0x137621
#define REG_BK1376_11_L      0x137622
#define REG_BK1376_11_H      0x137623
#define REG_BK1376_12_L      0x137624
#define REG_BK1376_12_H      0x137625
#define REG_BK1376_13_L      0x137626
#define REG_BK1376_13_H      0x137627
#define REG_BK1376_14_L      0x137628
#define REG_BK1376_14_H      0x137629
#define REG_BK1376_15_L      0x13762A
#define REG_BK1376_15_H      0x13762B
#define REG_BK1376_16_L      0x13762C
#define REG_BK1376_16_H      0x13762D
#define REG_BK1376_17_L      0x13762E
#define REG_BK1376_17_H      0x13762F
#define REG_BK1376_18_L      0x137630
#define REG_BK1376_18_H      0x137631
#define REG_BK1376_19_L      0x137632
#define REG_BK1376_19_H      0x137633
#define REG_BK1376_1A_L      0x137634
#define REG_BK1376_1A_H      0x137635
#define REG_BK1376_1B_L      0x137636
#define REG_BK1376_1B_H      0x137637
#define REG_BK1376_1C_L      0x137638
#define REG_BK1376_1C_H      0x137639
#define REG_BK1376_1D_L      0x13763A
#define REG_BK1376_1D_H      0x13763B
#define REG_BK1376_1E_L      0x13763C
#define REG_BK1376_1E_H      0x13763D
#define REG_BK1376_1F_L      0x13763E
#define REG_BK1376_1F_H      0x13763F
#define REG_BK1376_20_L      0x137640
#define REG_BK1376_20_H      0x137641
#define REG_BK1376_21_L      0x137642
#define REG_BK1376_21_H      0x137643
#define REG_BK1376_22_L      0x137644
#define REG_BK1376_22_H      0x137645
#define REG_BK1376_23_L      0x137646
#define REG_BK1376_23_H      0x137647
#define REG_BK1376_24_L      0x137648
#define REG_BK1376_24_H      0x137649
#define REG_BK1376_25_L      0x13764A
#define REG_BK1376_25_H      0x13764B
#define REG_BK1376_26_L      0x13764C
#define REG_BK1376_26_H      0x13764D
#define REG_BK1376_27_L      0x13764E
#define REG_BK1376_27_H      0x13764F
#define REG_BK1376_28_L      0x137650
#define REG_BK1376_28_H      0x137651
#define REG_BK1376_29_L      0x137652
#define REG_BK1376_29_H      0x137653
#define REG_BK1376_2A_L      0x137654
#define REG_BK1376_2A_H      0x137655
#define REG_BK1376_2B_L      0x137656
#define REG_BK1376_2B_H      0x137657
#define REG_BK1376_2C_L      0x137658
#define REG_BK1376_2C_H      0x137659
#define REG_BK1376_2D_L      0x13765A
#define REG_BK1376_2D_H      0x13765B
#define REG_BK1376_2E_L      0x13765C
#define REG_BK1376_2E_H      0x13765D
#define REG_BK1376_2F_L      0x13765E
#define REG_BK1376_2F_H      0x13765F
#define REG_BK1376_30_L      0x137660
#define REG_BK1376_30_H      0x137661
#define REG_BK1376_31_L      0x137662
#define REG_BK1376_31_H      0x137663
#define REG_BK1376_32_L      0x137664
#define REG_BK1376_32_H      0x137665
#define REG_BK1376_33_L      0x137666
#define REG_BK1376_33_H      0x137667
#define REG_BK1376_34_L      0x137668
#define REG_BK1376_34_H      0x137669
#define REG_BK1376_35_L      0x13766A
#define REG_BK1376_35_H      0x13766B
#define REG_BK1376_36_L      0x13766C
#define REG_BK1376_36_H      0x13766D
#define REG_BK1376_37_L      0x13766E
#define REG_BK1376_37_H      0x13766F
#define REG_BK1376_38_L      0x137670
#define REG_BK1376_38_H      0x137671
#define REG_BK1376_39_L      0x137672
#define REG_BK1376_39_H      0x137673
#define REG_BK1376_3A_L      0x137674
#define REG_BK1376_3A_H      0x137675
#define REG_BK1376_3B_L      0x137676
#define REG_BK1376_3B_H      0x137677
#define REG_BK1376_3C_L      0x137678
#define REG_BK1376_3C_H      0x137679
#define REG_BK1376_3D_L      0x13767A
#define REG_BK1376_3D_H      0x13767B
#define REG_BK1376_3E_L      0x13767C
#define REG_BK1376_3E_H      0x13767D
#define REG_BK1376_3F_L      0x13767E
#define REG_BK1376_3F_H      0x13767F
#define REG_BK1376_40_L      0x137680
#define REG_BK1376_40_H      0x137681
#define REG_BK1376_41_L      0x137682
#define REG_BK1376_41_H      0x137683
#define REG_BK1376_42_L      0x137684
#define REG_BK1376_42_H      0x137685
#define REG_BK1376_43_L      0x137686
#define REG_BK1376_43_H      0x137687
#define REG_BK1376_44_L      0x137688
#define REG_BK1376_44_H      0x137689
#define REG_BK1376_45_L      0x13768A
#define REG_BK1376_45_H      0x13768B
#define REG_BK1376_46_L      0x13768C
#define REG_BK1376_46_H      0x13768D
#define REG_BK1376_47_L      0x13768E
#define REG_BK1376_47_H      0x13768F
#define REG_BK1376_48_L      0x137690
#define REG_BK1376_48_H      0x137691
#define REG_BK1376_49_L      0x137692
#define REG_BK1376_49_H      0x137693
#define REG_BK1376_4A_L      0x137694
#define REG_BK1376_4A_H      0x137695
#define REG_BK1376_4B_L      0x137696
#define REG_BK1376_4B_H      0x137697
#define REG_BK1376_4C_L      0x137698
#define REG_BK1376_4C_H      0x137699
#define REG_BK1376_4D_L      0x13769A
#define REG_BK1376_4D_H      0x13769B
#define REG_BK1376_4E_L      0x13769C
#define REG_BK1376_4E_H      0x13769D
#define REG_BK1376_4F_L      0x13769E
#define REG_BK1376_4F_H      0x13769F
#define REG_BK1376_50_L      0x1376A0
#define REG_BK1376_50_H      0x1376A1
#define REG_BK1376_51_L      0x1376A2
#define REG_BK1376_51_H      0x1376A3
#define REG_BK1376_52_L      0x1376A4
#define REG_BK1376_52_H      0x1376A5
#define REG_BK1376_53_L      0x1376A6
#define REG_BK1376_53_H      0x1376A7
#define REG_BK1376_54_L      0x1376A8
#define REG_BK1376_54_H      0x1376A9
#define REG_BK1376_55_L      0x1376AA
#define REG_BK1376_55_H      0x1376AB
#define REG_BK1376_56_L      0x1376AC
#define REG_BK1376_56_H      0x1376AD
#define REG_BK1376_57_L      0x1376AE
#define REG_BK1376_57_H      0x1376AF
#define REG_BK1376_58_L      0x1376B0
#define REG_BK1376_58_H      0x1376B1
#define REG_BK1376_59_L      0x1376B2
#define REG_BK1376_59_H      0x1376B3
#define REG_BK1376_5A_L      0x1376B4
#define REG_BK1376_5A_H      0x1376B5
#define REG_BK1376_5B_L      0x1376B6
#define REG_BK1376_5B_H      0x1376B7
#define REG_BK1376_5C_L      0x1376B8
#define REG_BK1376_5C_H      0x1376B9
#define REG_BK1376_5D_L      0x1376BA
#define REG_BK1376_5D_H      0x1376BB
#define REG_BK1376_5E_L      0x1376BC
#define REG_BK1376_5E_H      0x1376BD
#define REG_BK1376_5F_L      0x1376BE
#define REG_BK1376_5F_H      0x1376BF
#define REG_BK1376_60_L      0x1376C0
#define REG_BK1376_60_H      0x1376C1
#define REG_BK1376_61_L      0x1376C2
#define REG_BK1376_61_H      0x1376C3
#define REG_BK1376_62_L      0x1376C4
#define REG_BK1376_62_H      0x1376C5
#define REG_BK1376_63_L      0x1376C6
#define REG_BK1376_63_H      0x1376C7
#define REG_BK1376_64_L      0x1376C8
#define REG_BK1376_64_H      0x1376C9
#define REG_BK1376_65_L      0x1376CA
#define REG_BK1376_65_H      0x1376CB
#define REG_BK1376_66_L      0x1376CC
#define REG_BK1376_66_H      0x1376CD
#define REG_BK1376_67_L      0x1376CE
#define REG_BK1376_67_H      0x1376CF
#define REG_BK1376_68_L      0x1376D0
#define REG_BK1376_68_H      0x1376D1
#define REG_BK1376_69_L      0x1376D2
#define REG_BK1376_69_H      0x1376D3
#define REG_BK1376_6A_L      0x1376D4
#define REG_BK1376_6A_H      0x1376D5
#define REG_BK1376_6B_L      0x1376D6
#define REG_BK1376_6B_H      0x1376D7
#define REG_BK1376_6C_L      0x1376D8
#define REG_BK1376_6C_H      0x1376D9
#define REG_BK1376_6D_L      0x1376DA
#define REG_BK1376_6D_H      0x1376DB
#define REG_BK1376_6E_L      0x1376DC
#define REG_BK1376_6E_H      0x1376DD
#define REG_BK1376_6F_L      0x1376DE
#define REG_BK1376_6F_H      0x1376DF
#define REG_BK1376_70_L      0x1376E0
#define REG_BK1376_70_H      0x1376E1
#define REG_BK1376_71_L      0x1376E2
#define REG_BK1376_71_H      0x1376E3
#define REG_BK1376_72_L      0x1376E4
#define REG_BK1376_72_H      0x1376E5
#define REG_BK1376_73_L      0x1376E6
#define REG_BK1376_73_H      0x1376E7
#define REG_BK1376_74_L      0x1376E8
#define REG_BK1376_74_H      0x1376E9
#define REG_BK1376_75_L      0x1376EA
#define REG_BK1376_75_H      0x1376EB
#define REG_BK1376_76_L      0x1376EC
#define REG_BK1376_76_H      0x1376ED
#define REG_BK1376_77_L      0x1376EE
#define REG_BK1376_77_H      0x1376EF
#define REG_BK1376_78_L      0x1376F0
#define REG_BK1376_78_H      0x1376F1
#define REG_BK1376_79_L      0x1376F2
#define REG_BK1376_79_H      0x1376F3
#define REG_BK1376_7A_L      0x1376F4
#define REG_BK1376_7A_H      0x1376F5
#define REG_BK1376_7B_L      0x1376F6
#define REG_BK1376_7B_H      0x1376F7
#define REG_BK1376_7C_L      0x1376F8
#define REG_BK1376_7C_H      0x1376F9
#define REG_BK1376_7D_L      0x1376FA
#define REG_BK1376_7D_H      0x1376FB
#define REG_BK1376_7E_L      0x1376FC
#define REG_BK1376_7E_H      0x1376FD
#define REG_BK1376_7F_L      0x1376FE
#define REG_BK1376_7F_H      0x1376FF
//----------------------------------------------
#define REG_BK1379_00_L      0x137900
#define REG_BK1379_00_H      0x137901
#define REG_BK1379_01_L      0x137902
#define REG_BK1379_01_H      0x137903
#define REG_BK1379_02_L      0x137904
#define REG_BK1379_02_H      0x137905
#define REG_BK1379_03_L      0x137906
#define REG_BK1379_03_H      0x137907
#define REG_BK1379_04_L      0x137908
#define REG_BK1379_04_H      0x137909
#define REG_BK1379_05_L      0x13790A
#define REG_BK1379_05_H      0x13790B
#define REG_BK1379_06_L      0x13790C
#define REG_BK1379_06_H      0x13790D
#define REG_BK1379_07_L      0x13790E
#define REG_BK1379_07_H      0x13790F
#define REG_BK1379_08_L      0x137910
#define REG_BK1379_08_H      0x137911
#define REG_BK1379_09_L      0x137912
#define REG_BK1379_09_H      0x137913
#define REG_BK1379_0A_L      0x137914
#define REG_BK1379_0A_H      0x137915
#define REG_BK1379_0B_L      0x137916
#define REG_BK1379_0B_H      0x137917
#define REG_BK1379_0C_L      0x137918
#define REG_BK1379_0C_H      0x137919
#define REG_BK1379_0D_L      0x13791A
#define REG_BK1379_0D_H      0x13791B
#define REG_BK1379_0E_L      0x13791C
#define REG_BK1379_0E_H      0x13791D
#define REG_BK1379_0F_L      0x13791E
#define REG_BK1379_0F_H      0x13791F
#define REG_BK1379_10_L      0x137920
#define REG_BK1379_10_H      0x137921
#define REG_BK1379_11_L      0x137922
#define REG_BK1379_11_H      0x137923
#define REG_BK1379_12_L      0x137924
#define REG_BK1379_12_H      0x137925
#define REG_BK1379_13_L      0x137926
#define REG_BK1379_13_H      0x137927
#define REG_BK1379_14_L      0x137928
#define REG_BK1379_14_H      0x137929
#define REG_BK1379_15_L      0x13792A
#define REG_BK1379_15_H      0x13792B
#define REG_BK1379_16_L      0x13792C
#define REG_BK1379_16_H      0x13792D
#define REG_BK1379_17_L      0x13792E
#define REG_BK1379_17_H      0x13792F
#define REG_BK1379_18_L      0x137930
#define REG_BK1379_18_H      0x137931
#define REG_BK1379_19_L      0x137932
#define REG_BK1379_19_H      0x137933
#define REG_BK1379_1A_L      0x137934
#define REG_BK1379_1A_H      0x137935
#define REG_BK1379_1B_L      0x137936
#define REG_BK1379_1B_H      0x137937
#define REG_BK1379_1C_L      0x137938
#define REG_BK1379_1C_H      0x137939
#define REG_BK1379_1D_L      0x13793A
#define REG_BK1379_1D_H      0x13793B
#define REG_BK1379_1E_L      0x13793C
#define REG_BK1379_1E_H      0x13793D
#define REG_BK1379_1F_L      0x13793E
#define REG_BK1379_1F_H      0x13793F
#define REG_BK1379_20_L      0x137940
#define REG_BK1379_20_H      0x137941
#define REG_BK1379_21_L      0x137942
#define REG_BK1379_21_H      0x137943
#define REG_BK1379_22_L      0x137944
#define REG_BK1379_22_H      0x137945
#define REG_BK1379_23_L      0x137946
#define REG_BK1379_23_H      0x137947
#define REG_BK1379_24_L      0x137948
#define REG_BK1379_24_H      0x137949
#define REG_BK1379_25_L      0x13794A
#define REG_BK1379_25_H      0x13794B
#define REG_BK1379_26_L      0x13794C
#define REG_BK1379_26_H      0x13794D
#define REG_BK1379_27_L      0x13794E
#define REG_BK1379_27_H      0x13794F
#define REG_BK1379_28_L      0x137950
#define REG_BK1379_28_H      0x137951
#define REG_BK1379_29_L      0x137952
#define REG_BK1379_29_H      0x137953
#define REG_BK1379_2A_L      0x137954
#define REG_BK1379_2A_H      0x137955
#define REG_BK1379_2B_L      0x137956
#define REG_BK1379_2B_H      0x137957
#define REG_BK1379_2C_L      0x137958
#define REG_BK1379_2C_H      0x137959
#define REG_BK1379_2D_L      0x13795A
#define REG_BK1379_2D_H      0x13795B
#define REG_BK1379_2E_L      0x13795C
#define REG_BK1379_2E_H      0x13795D
#define REG_BK1379_2F_L      0x13795E
#define REG_BK1379_2F_H      0x13795F
#define REG_BK1379_30_L      0x137960
#define REG_BK1379_30_H      0x137961
#define REG_BK1379_31_L      0x137962
#define REG_BK1379_31_H      0x137963
#define REG_BK1379_32_L      0x137964
#define REG_BK1379_32_H      0x137965
#define REG_BK1379_33_L      0x137966
#define REG_BK1379_33_H      0x137967
#define REG_BK1379_34_L      0x137968
#define REG_BK1379_34_H      0x137969
#define REG_BK1379_35_L      0x13796A
#define REG_BK1379_35_H      0x13796B
#define REG_BK1379_36_L      0x13796C
#define REG_BK1379_36_H      0x13796D
#define REG_BK1379_37_L      0x13796E
#define REG_BK1379_37_H      0x13796F
#define REG_BK1379_38_L      0x137970
#define REG_BK1379_38_H      0x137971
#define REG_BK1379_39_L      0x137972
#define REG_BK1379_39_H      0x137973
#define REG_BK1379_3A_L      0x137974
#define REG_BK1379_3A_H      0x137975
#define REG_BK1379_3B_L      0x137976
#define REG_BK1379_3B_H      0x137977
#define REG_BK1379_3C_L      0x137978
#define REG_BK1379_3C_H      0x137979
#define REG_BK1379_3D_L      0x13797A
#define REG_BK1379_3D_H      0x13797B
#define REG_BK1379_3E_L      0x13797C
#define REG_BK1379_3E_H      0x13797D
#define REG_BK1379_3F_L      0x13797E
#define REG_BK1379_3F_H      0x13797F
#define REG_BK1379_40_L      0x137980
#define REG_BK1379_40_H      0x137981
#define REG_BK1379_41_L      0x137982
#define REG_BK1379_41_H      0x137983
#define REG_BK1379_42_L      0x137984
#define REG_BK1379_42_H      0x137985
#define REG_BK1379_43_L      0x137986
#define REG_BK1379_43_H      0x137987
#define REG_BK1379_44_L      0x137988
#define REG_BK1379_44_H      0x137989
#define REG_BK1379_45_L      0x13798A
#define REG_BK1379_45_H      0x13798B
#define REG_BK1379_46_L      0x13798C
#define REG_BK1379_46_H      0x13798D
#define REG_BK1379_47_L      0x13798E
#define REG_BK1379_47_H      0x13798F
#define REG_BK1379_48_L      0x137990
#define REG_BK1379_48_H      0x137991
#define REG_BK1379_49_L      0x137992
#define REG_BK1379_49_H      0x137993
#define REG_BK1379_4A_L      0x137994
#define REG_BK1379_4A_H      0x137995
#define REG_BK1379_4B_L      0x137996
#define REG_BK1379_4B_H      0x137997
#define REG_BK1379_4C_L      0x137998
#define REG_BK1379_4C_H      0x137999
#define REG_BK1379_4D_L      0x13799A
#define REG_BK1379_4D_H      0x13799B
#define REG_BK1379_4E_L      0x13799C
#define REG_BK1379_4E_H      0x13799D
#define REG_BK1379_4F_L      0x13799E
#define REG_BK1379_4F_H      0x13799F
#define REG_BK1379_50_L      0x1379A0
#define REG_BK1379_50_H      0x1379A1
#define REG_BK1379_51_L      0x1379A2
#define REG_BK1379_51_H      0x1379A3
#define REG_BK1379_52_L      0x1379A4
#define REG_BK1379_52_H      0x1379A5
#define REG_BK1379_53_L      0x1379A6
#define REG_BK1379_53_H      0x1379A7
#define REG_BK1379_54_L      0x1379A8
#define REG_BK1379_54_H      0x1379A9
#define REG_BK1379_55_L      0x1379AA
#define REG_BK1379_55_H      0x1379AB
#define REG_BK1379_56_L      0x1379AC
#define REG_BK1379_56_H      0x1379AD
#define REG_BK1379_57_L      0x1379AE
#define REG_BK1379_57_H      0x1379AF
#define REG_BK1379_58_L      0x1379B0
#define REG_BK1379_58_H      0x1379B1
#define REG_BK1379_59_L      0x1379B2
#define REG_BK1379_59_H      0x1379B3
#define REG_BK1379_5A_L      0x1379B4
#define REG_BK1379_5A_H      0x1379B5
#define REG_BK1379_5B_L      0x1379B6
#define REG_BK1379_5B_H      0x1379B7
#define REG_BK1379_5C_L      0x1379B8
#define REG_BK1379_5C_H      0x1379B9
#define REG_BK1379_5D_L      0x1379BA
#define REG_BK1379_5D_H      0x1379BB
#define REG_BK1379_5E_L      0x1379BC
#define REG_BK1379_5E_H      0x1379BD
#define REG_BK1379_5F_L      0x1379BE
#define REG_BK1379_5F_H      0x1379BF
#define REG_BK1379_60_L      0x1379C0
#define REG_BK1379_60_H      0x1379C1
#define REG_BK1379_61_L      0x1379C2
#define REG_BK1379_61_H      0x1379C3
#define REG_BK1379_62_L      0x1379C4
#define REG_BK1379_62_H      0x1379C5
#define REG_BK1379_63_L      0x1379C6
#define REG_BK1379_63_H      0x1379C7
#define REG_BK1379_64_L      0x1379C8
#define REG_BK1379_64_H      0x1379C9
#define REG_BK1379_65_L      0x1379CA
#define REG_BK1379_65_H      0x1379CB
#define REG_BK1379_66_L      0x1379CC
#define REG_BK1379_66_H      0x1379CD
#define REG_BK1379_67_L      0x1379CE
#define REG_BK1379_67_H      0x1379CF
#define REG_BK1379_68_L      0x1379D0
#define REG_BK1379_68_H      0x1379D1
#define REG_BK1379_69_L      0x1379D2
#define REG_BK1379_69_H      0x1379D3
#define REG_BK1379_6A_L      0x1379D4
#define REG_BK1379_6A_H      0x1379D5
#define REG_BK1379_6B_L      0x1379D6
#define REG_BK1379_6B_H      0x1379D7
#define REG_BK1379_6C_L      0x1379D8
#define REG_BK1379_6C_H      0x1379D9
#define REG_BK1379_6D_L      0x1379DA
#define REG_BK1379_6D_H      0x1379DB
#define REG_BK1379_6E_L      0x1379DC
#define REG_BK1379_6E_H      0x1379DD
#define REG_BK1379_6F_L      0x1379DE
#define REG_BK1379_6F_H      0x1379DF
#define REG_BK1379_70_L      0x1379E0
#define REG_BK1379_70_H      0x1379E1
#define REG_BK1379_71_L      0x1379E2
#define REG_BK1379_71_H      0x1379E3
#define REG_BK1379_72_L      0x1379E4
#define REG_BK1379_72_H      0x1379E5
#define REG_BK1379_73_L      0x1379E6
#define REG_BK1379_73_H      0x1379E7
#define REG_BK1379_74_L      0x1379E8
#define REG_BK1379_74_H      0x1379E9
#define REG_BK1379_75_L      0x1379EA
#define REG_BK1379_75_H      0x1379EB
#define REG_BK1379_76_L      0x1379EC
#define REG_BK1379_76_H      0x1379ED
#define REG_BK1379_77_L      0x1379EE
#define REG_BK1379_77_H      0x1379EF
#define REG_BK1379_78_L      0x1379F0
#define REG_BK1379_78_H      0x1379F1
#define REG_BK1379_79_L      0x1379F2
#define REG_BK1379_79_H      0x1379F3
#define REG_BK1379_7A_L      0x1379F4
#define REG_BK1379_7A_H      0x1379F5
#define REG_BK1379_7B_L      0x1379F6
#define REG_BK1379_7B_H      0x1379F7
#define REG_BK1379_7C_L      0x1379F8
#define REG_BK1379_7C_H      0x1379F9
#define REG_BK1379_7D_L      0x1379FA
#define REG_BK1379_7D_H      0x1379FB
#define REG_BK1379_7E_L      0x1379FC
#define REG_BK1379_7E_H      0x1379FD
#define REG_BK1379_7F_L      0x1379FE
#define REG_BK1379_7F_H      0x1379FF
//----------------------------------------------
#define REG_BK137A_00_L      0x137A00
#define REG_BK137A_00_H      0x137A01
#define REG_BK137A_01_L      0x137A02
#define REG_BK137A_01_H      0x137A03
#define REG_BK137A_02_L      0x137A04
#define REG_BK137A_02_H      0x137A05
#define REG_BK137A_03_L      0x137A06
#define REG_BK137A_03_H      0x137A07
#define REG_BK137A_04_L      0x137A08
#define REG_BK137A_04_H      0x137A09
#define REG_BK137A_05_L      0x137A0A
#define REG_BK137A_05_H      0x137A0B
#define REG_BK137A_06_L      0x137A0C
#define REG_BK137A_06_H      0x137A0D
#define REG_BK137A_07_L      0x137A0E
#define REG_BK137A_07_H      0x137A0F
#define REG_BK137A_08_L      0x137A10
#define REG_BK137A_08_H      0x137A11
#define REG_BK137A_09_L      0x137A12
#define REG_BK137A_09_H      0x137A13
#define REG_BK137A_0A_L      0x137A14
#define REG_BK137A_0A_H      0x137A15
#define REG_BK137A_0B_L      0x137A16
#define REG_BK137A_0B_H      0x137A17
#define REG_BK137A_0C_L      0x137A18
#define REG_BK137A_0C_H      0x137A19
#define REG_BK137A_0D_L      0x137A1A
#define REG_BK137A_0D_H      0x137A1B
#define REG_BK137A_0E_L      0x137A1C
#define REG_BK137A_0E_H      0x137A1D
#define REG_BK137A_0F_L      0x137A1E
#define REG_BK137A_0F_H      0x137A1F
#define REG_BK137A_10_L      0x137A20
#define REG_BK137A_10_H      0x137A21
#define REG_BK137A_11_L      0x137A22
#define REG_BK137A_11_H      0x137A23
#define REG_BK137A_12_L      0x137A24
#define REG_BK137A_12_H      0x137A25
#define REG_BK137A_13_L      0x137A26
#define REG_BK137A_13_H      0x137A27
#define REG_BK137A_14_L      0x137A28
#define REG_BK137A_14_H      0x137A29
#define REG_BK137A_15_L      0x137A2A
#define REG_BK137A_15_H      0x137A2B
#define REG_BK137A_16_L      0x137A2C
#define REG_BK137A_16_H      0x137A2D
#define REG_BK137A_17_L      0x137A2E
#define REG_BK137A_17_H      0x137A2F
#define REG_BK137A_18_L      0x137A30
#define REG_BK137A_18_H      0x137A31
#define REG_BK137A_19_L      0x137A32
#define REG_BK137A_19_H      0x137A33
#define REG_BK137A_1A_L      0x137A34
#define REG_BK137A_1A_H      0x137A35
#define REG_BK137A_1B_L      0x137A36
#define REG_BK137A_1B_H      0x137A37
#define REG_BK137A_1C_L      0x137A38
#define REG_BK137A_1C_H      0x137A39
#define REG_BK137A_1D_L      0x137A3A
#define REG_BK137A_1D_H      0x137A3B
#define REG_BK137A_1E_L      0x137A3C
#define REG_BK137A_1E_H      0x137A3D
#define REG_BK137A_1F_L      0x137A3E
#define REG_BK137A_1F_H      0x137A3F
#define REG_BK137A_20_L      0x137A40
#define REG_BK137A_20_H      0x137A41
#define REG_BK137A_21_L      0x137A42
#define REG_BK137A_21_H      0x137A43
#define REG_BK137A_22_L      0x137A44
#define REG_BK137A_22_H      0x137A45
#define REG_BK137A_23_L      0x137A46
#define REG_BK137A_23_H      0x137A47
#define REG_BK137A_24_L      0x137A48
#define REG_BK137A_24_H      0x137A49
#define REG_BK137A_25_L      0x137A4A
#define REG_BK137A_25_H      0x137A4B
#define REG_BK137A_26_L      0x137A4C
#define REG_BK137A_26_H      0x137A4D
#define REG_BK137A_27_L      0x137A4E
#define REG_BK137A_27_H      0x137A4F
#define REG_BK137A_28_L      0x137A50
#define REG_BK137A_28_H      0x137A51
#define REG_BK137A_29_L      0x137A52
#define REG_BK137A_29_H      0x137A53
#define REG_BK137A_2A_L      0x137A54
#define REG_BK137A_2A_H      0x137A55
#define REG_BK137A_2B_L      0x137A56
#define REG_BK137A_2B_H      0x137A57
#define REG_BK137A_2C_L      0x137A58
#define REG_BK137A_2C_H      0x137A59
#define REG_BK137A_2D_L      0x137A5A
#define REG_BK137A_2D_H      0x137A5B
#define REG_BK137A_2E_L      0x137A5C
#define REG_BK137A_2E_H      0x137A5D
#define REG_BK137A_2F_L      0x137A5E
#define REG_BK137A_2F_H      0x137A5F
#define REG_BK137A_30_L      0x137A60
#define REG_BK137A_30_H      0x137A61
#define REG_BK137A_31_L      0x137A62
#define REG_BK137A_31_H      0x137A63
#define REG_BK137A_32_L      0x137A64
#define REG_BK137A_32_H      0x137A65
#define REG_BK137A_33_L      0x137A66
#define REG_BK137A_33_H      0x137A67
#define REG_BK137A_34_L      0x137A68
#define REG_BK137A_34_H      0x137A69
#define REG_BK137A_35_L      0x137A6A
#define REG_BK137A_35_H      0x137A6B
#define REG_BK137A_36_L      0x137A6C
#define REG_BK137A_36_H      0x137A6D
#define REG_BK137A_37_L      0x137A6E
#define REG_BK137A_37_H      0x137A6F
#define REG_BK137A_38_L      0x137A70
#define REG_BK137A_38_H      0x137A71
#define REG_BK137A_39_L      0x137A72
#define REG_BK137A_39_H      0x137A73
#define REG_BK137A_3A_L      0x137A74
#define REG_BK137A_3A_H      0x137A75
#define REG_BK137A_3B_L      0x137A76
#define REG_BK137A_3B_H      0x137A77
#define REG_BK137A_3C_L      0x137A78
#define REG_BK137A_3C_H      0x137A79
#define REG_BK137A_3D_L      0x137A7A
#define REG_BK137A_3D_H      0x137A7B
#define REG_BK137A_3E_L      0x137A7C
#define REG_BK137A_3E_H      0x137A7D
#define REG_BK137A_3F_L      0x137A7E
#define REG_BK137A_3F_H      0x137A7F
#define REG_BK137A_40_L      0x137A80
#define REG_BK137A_40_H      0x137A81
#define REG_BK137A_41_L      0x137A82
#define REG_BK137A_41_H      0x137A83
#define REG_BK137A_42_L      0x137A84
#define REG_BK137A_42_H      0x137A85
#define REG_BK137A_43_L      0x137A86
#define REG_BK137A_43_H      0x137A87
#define REG_BK137A_44_L      0x137A88
#define REG_BK137A_44_H      0x137A89
#define REG_BK137A_45_L      0x137A8A
#define REG_BK137A_45_H      0x137A8B
#define REG_BK137A_46_L      0x137A8C
#define REG_BK137A_46_H      0x137A8D
#define REG_BK137A_47_L      0x137A8E
#define REG_BK137A_47_H      0x137A8F
#define REG_BK137A_48_L      0x137A90
#define REG_BK137A_48_H      0x137A91
#define REG_BK137A_49_L      0x137A92
#define REG_BK137A_49_H      0x137A93
#define REG_BK137A_4A_L      0x137A94
#define REG_BK137A_4A_H      0x137A95
#define REG_BK137A_4B_L      0x137A96
#define REG_BK137A_4B_H      0x137A97
#define REG_BK137A_4C_L      0x137A98
#define REG_BK137A_4C_H      0x137A99
#define REG_BK137A_4D_L      0x137A9A
#define REG_BK137A_4D_H      0x137A9B
#define REG_BK137A_4E_L      0x137A9C
#define REG_BK137A_4E_H      0x137A9D
#define REG_BK137A_4F_L      0x137A9E
#define REG_BK137A_4F_H      0x137A9F
#define REG_BK137A_50_L      0x137AA0
#define REG_BK137A_50_H      0x137AA1
#define REG_BK137A_51_L      0x137AA2
#define REG_BK137A_51_H      0x137AA3
#define REG_BK137A_52_L      0x137AA4
#define REG_BK137A_52_H      0x137AA5
#define REG_BK137A_53_L      0x137AA6
#define REG_BK137A_53_H      0x137AA7
#define REG_BK137A_54_L      0x137AA8
#define REG_BK137A_54_H      0x137AA9
#define REG_BK137A_55_L      0x137AAA
#define REG_BK137A_55_H      0x137AAB
#define REG_BK137A_56_L      0x137AAC
#define REG_BK137A_56_H      0x137AAD
#define REG_BK137A_57_L      0x137AAE
#define REG_BK137A_57_H      0x137AAF
#define REG_BK137A_58_L      0x137AB0
#define REG_BK137A_58_H      0x137AB1
#define REG_BK137A_59_L      0x137AB2
#define REG_BK137A_59_H      0x137AB3
#define REG_BK137A_5A_L      0x137AB4
#define REG_BK137A_5A_H      0x137AB5
#define REG_BK137A_5B_L      0x137AB6
#define REG_BK137A_5B_H      0x137AB7
#define REG_BK137A_5C_L      0x137AB8
#define REG_BK137A_5C_H      0x137AB9
#define REG_BK137A_5D_L      0x137ABA
#define REG_BK137A_5D_H      0x137ABB
#define REG_BK137A_5E_L      0x137ABC
#define REG_BK137A_5E_H      0x137ABD
#define REG_BK137A_5F_L      0x137ABE
#define REG_BK137A_5F_H      0x137ABF
#define REG_BK137A_60_L      0x137AC0
#define REG_BK137A_60_H      0x137AC1
#define REG_BK137A_61_L      0x137AC2
#define REG_BK137A_61_H      0x137AC3
#define REG_BK137A_62_L      0x137AC4
#define REG_BK137A_62_H      0x137AC5
#define REG_BK137A_63_L      0x137AC6
#define REG_BK137A_63_H      0x137AC7
#define REG_BK137A_64_L      0x137AC8
#define REG_BK137A_64_H      0x137AC9
#define REG_BK137A_65_L      0x137ACA
#define REG_BK137A_65_H      0x137ACB
#define REG_BK137A_66_L      0x137ACC
#define REG_BK137A_66_H      0x137ACD
#define REG_BK137A_67_L      0x137ACE
#define REG_BK137A_67_H      0x137ACF
#define REG_BK137A_68_L      0x137AD0
#define REG_BK137A_68_H      0x137AD1
#define REG_BK137A_69_L      0x137AD2
#define REG_BK137A_69_H      0x137AD3
#define REG_BK137A_6A_L      0x137AD4
#define REG_BK137A_6A_H      0x137AD5
#define REG_BK137A_6B_L      0x137AD6
#define REG_BK137A_6B_H      0x137AD7
#define REG_BK137A_6C_L      0x137AD8
#define REG_BK137A_6C_H      0x137AD9
#define REG_BK137A_6D_L      0x137ADA
#define REG_BK137A_6D_H      0x137ADB
#define REG_BK137A_6E_L      0x137ADC
#define REG_BK137A_6E_H      0x137ADD
#define REG_BK137A_6F_L      0x137ADE
#define REG_BK137A_6F_H      0x137ADF
#define REG_BK137A_70_L      0x137AE0
#define REG_BK137A_70_H      0x137AE1
#define REG_BK137A_71_L      0x137AE2
#define REG_BK137A_71_H      0x137AE3
#define REG_BK137A_72_L      0x137AE4
#define REG_BK137A_72_H      0x137AE5
#define REG_BK137A_73_L      0x137AE6
#define REG_BK137A_73_H      0x137AE7
#define REG_BK137A_74_L      0x137AE8
#define REG_BK137A_74_H      0x137AE9
#define REG_BK137A_75_L      0x137AEA
#define REG_BK137A_75_H      0x137AEB
#define REG_BK137A_76_L      0x137AEC
#define REG_BK137A_76_H      0x137AED
#define REG_BK137A_77_L      0x137AEE
#define REG_BK137A_77_H      0x137AEF
#define REG_BK137A_78_L      0x137AF0
#define REG_BK137A_78_H      0x137AF1
#define REG_BK137A_79_L      0x137AF2
#define REG_BK137A_79_H      0x137AF3
#define REG_BK137A_7A_L      0x137AF4
#define REG_BK137A_7A_H      0x137AF5
#define REG_BK137A_7B_L      0x137AF6
#define REG_BK137A_7B_H      0x137AF7
#define REG_BK137A_7C_L      0x137AF8
#define REG_BK137A_7C_H      0x137AF9
#define REG_BK137A_7D_L      0x137AFA
#define REG_BK137A_7D_H      0x137AFB
#define REG_BK137A_7E_L      0x137AFC
#define REG_BK137A_7E_H      0x137AFD
#define REG_BK137A_7F_L      0x137AFE
#define REG_BK137A_7F_H      0x137AFF
//----------------------------------------------
#define REG_BK137B_00_L      0x137B00
#define REG_BK137B_00_H      0x137B01
#define REG_BK137B_01_L      0x137B02
#define REG_BK137B_01_H      0x137B03
#define REG_BK137B_02_L      0x137B04
#define REG_BK137B_02_H      0x137B05
#define REG_BK137B_03_L      0x137B06
#define REG_BK137B_03_H      0x137B07
#define REG_BK137B_04_L      0x137B08
#define REG_BK137B_04_H      0x137B09
#define REG_BK137B_05_L      0x137B0A
#define REG_BK137B_05_H      0x137B0B
#define REG_BK137B_06_L      0x137B0C
#define REG_BK137B_06_H      0x137B0D
#define REG_BK137B_07_L      0x137B0E
#define REG_BK137B_07_H      0x137B0F
#define REG_BK137B_08_L      0x137B10
#define REG_BK137B_08_H      0x137B11
#define REG_BK137B_09_L      0x137B12
#define REG_BK137B_09_H      0x137B13
#define REG_BK137B_0A_L      0x137B14
#define REG_BK137B_0A_H      0x137B15
#define REG_BK137B_0B_L      0x137B16
#define REG_BK137B_0B_H      0x137B17
#define REG_BK137B_0C_L      0x137B18
#define REG_BK137B_0C_H      0x137B19
#define REG_BK137B_0D_L      0x137B1A
#define REG_BK137B_0D_H      0x137B1B
#define REG_BK137B_0E_L      0x137B1C
#define REG_BK137B_0E_H      0x137B1D
#define REG_BK137B_0F_L      0x137B1E
#define REG_BK137B_0F_H      0x137B1F
#define REG_BK137B_10_L      0x137B20
#define REG_BK137B_10_H      0x137B21
#define REG_BK137B_11_L      0x137B22
#define REG_BK137B_11_H      0x137B23
#define REG_BK137B_12_L      0x137B24
#define REG_BK137B_12_H      0x137B25
#define REG_BK137B_13_L      0x137B26
#define REG_BK137B_13_H      0x137B27
#define REG_BK137B_14_L      0x137B28
#define REG_BK137B_14_H      0x137B29
#define REG_BK137B_15_L      0x137B2A
#define REG_BK137B_15_H      0x137B2B
#define REG_BK137B_16_L      0x137B2C
#define REG_BK137B_16_H      0x137B2D
#define REG_BK137B_17_L      0x137B2E
#define REG_BK137B_17_H      0x137B2F
#define REG_BK137B_18_L      0x137B30
#define REG_BK137B_18_H      0x137B31
#define REG_BK137B_19_L      0x137B32
#define REG_BK137B_19_H      0x137B33
#define REG_BK137B_1A_L      0x137B34
#define REG_BK137B_1A_H      0x137B35
#define REG_BK137B_1B_L      0x137B36
#define REG_BK137B_1B_H      0x137B37
#define REG_BK137B_1C_L      0x137B38
#define REG_BK137B_1C_H      0x137B39
#define REG_BK137B_1D_L      0x137B3A
#define REG_BK137B_1D_H      0x137B3B
#define REG_BK137B_1E_L      0x137B3C
#define REG_BK137B_1E_H      0x137B3D
#define REG_BK137B_1F_L      0x137B3E
#define REG_BK137B_1F_H      0x137B3F
#define REG_BK137B_20_L      0x137B40
#define REG_BK137B_20_H      0x137B41
#define REG_BK137B_21_L      0x137B42
#define REG_BK137B_21_H      0x137B43
#define REG_BK137B_22_L      0x137B44
#define REG_BK137B_22_H      0x137B45
#define REG_BK137B_23_L      0x137B46
#define REG_BK137B_23_H      0x137B47
#define REG_BK137B_24_L      0x137B48
#define REG_BK137B_24_H      0x137B49
#define REG_BK137B_25_L      0x137B4A
#define REG_BK137B_25_H      0x137B4B
#define REG_BK137B_26_L      0x137B4C
#define REG_BK137B_26_H      0x137B4D
#define REG_BK137B_27_L      0x137B4E
#define REG_BK137B_27_H      0x137B4F
#define REG_BK137B_28_L      0x137B50
#define REG_BK137B_28_H      0x137B51
#define REG_BK137B_29_L      0x137B52
#define REG_BK137B_29_H      0x137B53
#define REG_BK137B_2A_L      0x137B54
#define REG_BK137B_2A_H      0x137B55
#define REG_BK137B_2B_L      0x137B56
#define REG_BK137B_2B_H      0x137B57
#define REG_BK137B_2C_L      0x137B58
#define REG_BK137B_2C_H      0x137B59
#define REG_BK137B_2D_L      0x137B5A
#define REG_BK137B_2D_H      0x137B5B
#define REG_BK137B_2E_L      0x137B5C
#define REG_BK137B_2E_H      0x137B5D
#define REG_BK137B_2F_L      0x137B5E
#define REG_BK137B_2F_H      0x137B5F
#define REG_BK137B_30_L      0x137B60
#define REG_BK137B_30_H      0x137B61
#define REG_BK137B_31_L      0x137B62
#define REG_BK137B_31_H      0x137B63
#define REG_BK137B_32_L      0x137B64
#define REG_BK137B_32_H      0x137B65
#define REG_BK137B_33_L      0x137B66
#define REG_BK137B_33_H      0x137B67
#define REG_BK137B_34_L      0x137B68
#define REG_BK137B_34_H      0x137B69
#define REG_BK137B_35_L      0x137B6A
#define REG_BK137B_35_H      0x137B6B
#define REG_BK137B_36_L      0x137B6C
#define REG_BK137B_36_H      0x137B6D
#define REG_BK137B_37_L      0x137B6E
#define REG_BK137B_37_H      0x137B6F
#define REG_BK137B_38_L      0x137B70
#define REG_BK137B_38_H      0x137B71
#define REG_BK137B_39_L      0x137B72
#define REG_BK137B_39_H      0x137B73
#define REG_BK137B_3A_L      0x137B74
#define REG_BK137B_3A_H      0x137B75
#define REG_BK137B_3B_L      0x137B76
#define REG_BK137B_3B_H      0x137B77
#define REG_BK137B_3C_L      0x137B78
#define REG_BK137B_3C_H      0x137B79
#define REG_BK137B_3D_L      0x137B7A
#define REG_BK137B_3D_H      0x137B7B
#define REG_BK137B_3E_L      0x137B7C
#define REG_BK137B_3E_H      0x137B7D
#define REG_BK137B_3F_L      0x137B7E
#define REG_BK137B_3F_H      0x137B7F
#define REG_BK137B_40_L      0x137B80
#define REG_BK137B_40_H      0x137B81
#define REG_BK137B_41_L      0x137B82
#define REG_BK137B_41_H      0x137B83
#define REG_BK137B_42_L      0x137B84
#define REG_BK137B_42_H      0x137B85
#define REG_BK137B_43_L      0x137B86
#define REG_BK137B_43_H      0x137B87
#define REG_BK137B_44_L      0x137B88
#define REG_BK137B_44_H      0x137B89
#define REG_BK137B_45_L      0x137B8A
#define REG_BK137B_45_H      0x137B8B
#define REG_BK137B_46_L      0x137B8C
#define REG_BK137B_46_H      0x137B8D
#define REG_BK137B_47_L      0x137B8E
#define REG_BK137B_47_H      0x137B8F
#define REG_BK137B_48_L      0x137B90
#define REG_BK137B_48_H      0x137B91
#define REG_BK137B_49_L      0x137B92
#define REG_BK137B_49_H      0x137B93
#define REG_BK137B_4A_L      0x137B94
#define REG_BK137B_4A_H      0x137B95
#define REG_BK137B_4B_L      0x137B96
#define REG_BK137B_4B_H      0x137B97
#define REG_BK137B_4C_L      0x137B98
#define REG_BK137B_4C_H      0x137B99
#define REG_BK137B_4D_L      0x137B9A
#define REG_BK137B_4D_H      0x137B9B
#define REG_BK137B_4E_L      0x137B9C
#define REG_BK137B_4E_H      0x137B9D
#define REG_BK137B_4F_L      0x137B9E
#define REG_BK137B_4F_H      0x137B9F
#define REG_BK137B_50_L      0x137BA0
#define REG_BK137B_50_H      0x137BA1
#define REG_BK137B_51_L      0x137BA2
#define REG_BK137B_51_H      0x137BA3
#define REG_BK137B_52_L      0x137BA4
#define REG_BK137B_52_H      0x137BA5
#define REG_BK137B_53_L      0x137BA6
#define REG_BK137B_53_H      0x137BA7
#define REG_BK137B_54_L      0x137BA8
#define REG_BK137B_54_H      0x137BA9
#define REG_BK137B_55_L      0x137BAA
#define REG_BK137B_55_H      0x137BAB
#define REG_BK137B_56_L      0x137BAC
#define REG_BK137B_56_H      0x137BAD
#define REG_BK137B_57_L      0x137BAE
#define REG_BK137B_57_H      0x137BAF
#define REG_BK137B_58_L      0x137BB0
#define REG_BK137B_58_H      0x137BB1
#define REG_BK137B_59_L      0x137BB2
#define REG_BK137B_59_H      0x137BB3
#define REG_BK137B_5A_L      0x137BB4
#define REG_BK137B_5A_H      0x137BB5
#define REG_BK137B_5B_L      0x137BB6
#define REG_BK137B_5B_H      0x137BB7
#define REG_BK137B_5C_L      0x137BB8
#define REG_BK137B_5C_H      0x137BB9
#define REG_BK137B_5D_L      0x137BBA
#define REG_BK137B_5D_H      0x137BBB
#define REG_BK137B_5E_L      0x137BBC
#define REG_BK137B_5E_H      0x137BBD
#define REG_BK137B_5F_L      0x137BBE
#define REG_BK137B_5F_H      0x137BBF
#define REG_BK137B_60_L      0x137BC0
#define REG_BK137B_60_H      0x137BC1
#define REG_BK137B_61_L      0x137BC2
#define REG_BK137B_61_H      0x137BC3
#define REG_BK137B_62_L      0x137BC4
#define REG_BK137B_62_H      0x137BC5
#define REG_BK137B_63_L      0x137BC6
#define REG_BK137B_63_H      0x137BC7
#define REG_BK137B_64_L      0x137BC8
#define REG_BK137B_64_H      0x137BC9
#define REG_BK137B_65_L      0x137BCA
#define REG_BK137B_65_H      0x137BCB
#define REG_BK137B_66_L      0x137BCC
#define REG_BK137B_66_H      0x137BCD
#define REG_BK137B_67_L      0x137BCE
#define REG_BK137B_67_H      0x137BCF
#define REG_BK137B_68_L      0x137BD0
#define REG_BK137B_68_H      0x137BD1
#define REG_BK137B_69_L      0x137BD2
#define REG_BK137B_69_H      0x137BD3
#define REG_BK137B_6A_L      0x137BD4
#define REG_BK137B_6A_H      0x137BD5
#define REG_BK137B_6B_L      0x137BD6
#define REG_BK137B_6B_H      0x137BD7
#define REG_BK137B_6C_L      0x137BD8
#define REG_BK137B_6C_H      0x137BD9
#define REG_BK137B_6D_L      0x137BDA
#define REG_BK137B_6D_H      0x137BDB
#define REG_BK137B_6E_L      0x137BDC
#define REG_BK137B_6E_H      0x137BDD
#define REG_BK137B_6F_L      0x137BDE
#define REG_BK137B_6F_H      0x137BDF
#define REG_BK137B_70_L      0x137BE0
#define REG_BK137B_70_H      0x137BE1
#define REG_BK137B_71_L      0x137BE2
#define REG_BK137B_71_H      0x137BE3
#define REG_BK137B_72_L      0x137BE4
#define REG_BK137B_72_H      0x137BE5
#define REG_BK137B_73_L      0x137BE6
#define REG_BK137B_73_H      0x137BE7
#define REG_BK137B_74_L      0x137BE8
#define REG_BK137B_74_H      0x137BE9
#define REG_BK137B_75_L      0x137BEA
#define REG_BK137B_75_H      0x137BEB
#define REG_BK137B_76_L      0x137BEC
#define REG_BK137B_76_H      0x137BED
#define REG_BK137B_77_L      0x137BEE
#define REG_BK137B_77_H      0x137BEF
#define REG_BK137B_78_L      0x137BF0
#define REG_BK137B_78_H      0x137BF1
#define REG_BK137B_79_L      0x137BF2
#define REG_BK137B_79_H      0x137BF3
#define REG_BK137B_7A_L      0x137BF4
#define REG_BK137B_7A_H      0x137BF5
#define REG_BK137B_7B_L      0x137BF6
#define REG_BK137B_7B_H      0x137BF7
#define REG_BK137B_7C_L      0x137BF8
#define REG_BK137B_7C_H      0x137BF9
#define REG_BK137B_7D_L      0x137BFA
#define REG_BK137B_7D_H      0x137BFB
#define REG_BK137B_7E_L      0x137BFC
#define REG_BK137B_7E_H      0x137BFD
#define REG_BK137B_7F_L      0x137BFE
#define REG_BK137B_7F_H      0x137BFF
//----------------------------------------------
#define REG_BK137C_00_L      0x137C00
#define REG_BK137C_00_H      0x137C01
#define REG_BK137C_01_L      0x137C02
#define REG_BK137C_01_H      0x137C03
#define REG_BK137C_02_L      0x137C04
#define REG_BK137C_02_H      0x137C05
#define REG_BK137C_03_L      0x137C06
#define REG_BK137C_03_H      0x137C07
#define REG_BK137C_04_L      0x137C08
#define REG_BK137C_04_H      0x137C09
#define REG_BK137C_05_L      0x137C0A
#define REG_BK137C_05_H      0x137C0B
#define REG_BK137C_06_L      0x137C0C
#define REG_BK137C_06_H      0x137C0D
#define REG_BK137C_07_L      0x137C0E
#define REG_BK137C_07_H      0x137C0F
#define REG_BK137C_08_L      0x137C10
#define REG_BK137C_08_H      0x137C11
#define REG_BK137C_09_L      0x137C12
#define REG_BK137C_09_H      0x137C13
#define REG_BK137C_0A_L      0x137C14
#define REG_BK137C_0A_H      0x137C15
#define REG_BK137C_0B_L      0x137C16
#define REG_BK137C_0B_H      0x137C17
#define REG_BK137C_0C_L      0x137C18
#define REG_BK137C_0C_H      0x137C19
#define REG_BK137C_0D_L      0x137C1A
#define REG_BK137C_0D_H      0x137C1B
#define REG_BK137C_0E_L      0x137C1C
#define REG_BK137C_0E_H      0x137C1D
#define REG_BK137C_0F_L      0x137C1E
#define REG_BK137C_0F_H      0x137C1F
#define REG_BK137C_10_L      0x137C20
#define REG_BK137C_10_H      0x137C21
#define REG_BK137C_11_L      0x137C22
#define REG_BK137C_11_H      0x137C23
#define REG_BK137C_12_L      0x137C24
#define REG_BK137C_12_H      0x137C25
#define REG_BK137C_13_L      0x137C26
#define REG_BK137C_13_H      0x137C27
#define REG_BK137C_14_L      0x137C28
#define REG_BK137C_14_H      0x137C29
#define REG_BK137C_15_L      0x137C2A
#define REG_BK137C_15_H      0x137C2B
#define REG_BK137C_16_L      0x137C2C
#define REG_BK137C_16_H      0x137C2D
#define REG_BK137C_17_L      0x137C2E
#define REG_BK137C_17_H      0x137C2F
#define REG_BK137C_18_L      0x137C30
#define REG_BK137C_18_H      0x137C31
#define REG_BK137C_19_L      0x137C32
#define REG_BK137C_19_H      0x137C33
#define REG_BK137C_1A_L      0x137C34
#define REG_BK137C_1A_H      0x137C35
#define REG_BK137C_1B_L      0x137C36
#define REG_BK137C_1B_H      0x137C37
#define REG_BK137C_1C_L      0x137C38
#define REG_BK137C_1C_H      0x137C39
#define REG_BK137C_1D_L      0x137C3A
#define REG_BK137C_1D_H      0x137C3B
#define REG_BK137C_1E_L      0x137C3C
#define REG_BK137C_1E_H      0x137C3D
#define REG_BK137C_1F_L      0x137C3E
#define REG_BK137C_1F_H      0x137C3F
#define REG_BK137C_20_L      0x137C40
#define REG_BK137C_20_H      0x137C41
#define REG_BK137C_21_L      0x137C42
#define REG_BK137C_21_H      0x137C43
#define REG_BK137C_22_L      0x137C44
#define REG_BK137C_22_H      0x137C45
#define REG_BK137C_23_L      0x137C46
#define REG_BK137C_23_H      0x137C47
#define REG_BK137C_24_L      0x137C48
#define REG_BK137C_24_H      0x137C49
#define REG_BK137C_25_L      0x137C4A
#define REG_BK137C_25_H      0x137C4B
#define REG_BK137C_26_L      0x137C4C
#define REG_BK137C_26_H      0x137C4D
#define REG_BK137C_27_L      0x137C4E
#define REG_BK137C_27_H      0x137C4F
#define REG_BK137C_28_L      0x137C50
#define REG_BK137C_28_H      0x137C51
#define REG_BK137C_29_L      0x137C52
#define REG_BK137C_29_H      0x137C53
#define REG_BK137C_2A_L      0x137C54
#define REG_BK137C_2A_H      0x137C55
#define REG_BK137C_2B_L      0x137C56
#define REG_BK137C_2B_H      0x137C57
#define REG_BK137C_2C_L      0x137C58
#define REG_BK137C_2C_H      0x137C59
#define REG_BK137C_2D_L      0x137C5A
#define REG_BK137C_2D_H      0x137C5B
#define REG_BK137C_2E_L      0x137C5C
#define REG_BK137C_2E_H      0x137C5D
#define REG_BK137C_2F_L      0x137C5E
#define REG_BK137C_2F_H      0x137C5F
#define REG_BK137C_30_L      0x137C60
#define REG_BK137C_30_H      0x137C61
#define REG_BK137C_31_L      0x137C62
#define REG_BK137C_31_H      0x137C63
#define REG_BK137C_32_L      0x137C64
#define REG_BK137C_32_H      0x137C65
#define REG_BK137C_33_L      0x137C66
#define REG_BK137C_33_H      0x137C67
#define REG_BK137C_34_L      0x137C68
#define REG_BK137C_34_H      0x137C69
#define REG_BK137C_35_L      0x137C6A
#define REG_BK137C_35_H      0x137C6B
#define REG_BK137C_36_L      0x137C6C
#define REG_BK137C_36_H      0x137C6D
#define REG_BK137C_37_L      0x137C6E
#define REG_BK137C_37_H      0x137C6F
#define REG_BK137C_38_L      0x137C70
#define REG_BK137C_38_H      0x137C71
#define REG_BK137C_39_L      0x137C72
#define REG_BK137C_39_H      0x137C73
#define REG_BK137C_3A_L      0x137C74
#define REG_BK137C_3A_H      0x137C75
#define REG_BK137C_3B_L      0x137C76
#define REG_BK137C_3B_H      0x137C77
#define REG_BK137C_3C_L      0x137C78
#define REG_BK137C_3C_H      0x137C79
#define REG_BK137C_3D_L      0x137C7A
#define REG_BK137C_3D_H      0x137C7B
#define REG_BK137C_3E_L      0x137C7C
#define REG_BK137C_3E_H      0x137C7D
#define REG_BK137C_3F_L      0x137C7E
#define REG_BK137C_3F_H      0x137C7F
#define REG_BK137C_40_L      0x137C80
#define REG_BK137C_40_H      0x137C81
#define REG_BK137C_41_L      0x137C82
#define REG_BK137C_41_H      0x137C83
#define REG_BK137C_42_L      0x137C84
#define REG_BK137C_42_H      0x137C85
#define REG_BK137C_43_L      0x137C86
#define REG_BK137C_43_H      0x137C87
#define REG_BK137C_44_L      0x137C88
#define REG_BK137C_44_H      0x137C89
#define REG_BK137C_45_L      0x137C8A
#define REG_BK137C_45_H      0x137C8B
#define REG_BK137C_46_L      0x137C8C
#define REG_BK137C_46_H      0x137C8D
#define REG_BK137C_47_L      0x137C8E
#define REG_BK137C_47_H      0x137C8F
#define REG_BK137C_48_L      0x137C90
#define REG_BK137C_48_H      0x137C91
#define REG_BK137C_49_L      0x137C92
#define REG_BK137C_49_H      0x137C93
#define REG_BK137C_4A_L      0x137C94
#define REG_BK137C_4A_H      0x137C95
#define REG_BK137C_4B_L      0x137C96
#define REG_BK137C_4B_H      0x137C97
#define REG_BK137C_4C_L      0x137C98
#define REG_BK137C_4C_H      0x137C99
#define REG_BK137C_4D_L      0x137C9A
#define REG_BK137C_4D_H      0x137C9B
#define REG_BK137C_4E_L      0x137C9C
#define REG_BK137C_4E_H      0x137C9D
#define REG_BK137C_4F_L      0x137C9E
#define REG_BK137C_4F_H      0x137C9F
#define REG_BK137C_50_L      0x137CA0
#define REG_BK137C_50_H      0x137CA1
#define REG_BK137C_51_L      0x137CA2
#define REG_BK137C_51_H      0x137CA3
#define REG_BK137C_52_L      0x137CA4
#define REG_BK137C_52_H      0x137CA5
#define REG_BK137C_53_L      0x137CA6
#define REG_BK137C_53_H      0x137CA7
#define REG_BK137C_54_L      0x137CA8
#define REG_BK137C_54_H      0x137CA9
#define REG_BK137C_55_L      0x137CAA
#define REG_BK137C_55_H      0x137CAB
#define REG_BK137C_56_L      0x137CAC
#define REG_BK137C_56_H      0x137CAD
#define REG_BK137C_57_L      0x137CAE
#define REG_BK137C_57_H      0x137CAF
#define REG_BK137C_58_L      0x137CB0
#define REG_BK137C_58_H      0x137CB1
#define REG_BK137C_59_L      0x137CB2
#define REG_BK137C_59_H      0x137CB3
#define REG_BK137C_5A_L      0x137CB4
#define REG_BK137C_5A_H      0x137CB5
#define REG_BK137C_5B_L      0x137CB6
#define REG_BK137C_5B_H      0x137CB7
#define REG_BK137C_5C_L      0x137CB8
#define REG_BK137C_5C_H      0x137CB9
#define REG_BK137C_5D_L      0x137CBA
#define REG_BK137C_5D_H      0x137CBB
#define REG_BK137C_5E_L      0x137CBC
#define REG_BK137C_5E_H      0x137CBD
#define REG_BK137C_5F_L      0x137CBE
#define REG_BK137C_5F_H      0x137CBF
#define REG_BK137C_60_L      0x137CC0
#define REG_BK137C_60_H      0x137CC1
#define REG_BK137C_61_L      0x137CC2
#define REG_BK137C_61_H      0x137CC3
#define REG_BK137C_62_L      0x137CC4
#define REG_BK137C_62_H      0x137CC5
#define REG_BK137C_63_L      0x137CC6
#define REG_BK137C_63_H      0x137CC7
#define REG_BK137C_64_L      0x137CC8
#define REG_BK137C_64_H      0x137CC9
#define REG_BK137C_65_L      0x137CCA
#define REG_BK137C_65_H      0x137CCB
#define REG_BK137C_66_L      0x137CCC
#define REG_BK137C_66_H      0x137CCD
#define REG_BK137C_67_L      0x137CCE
#define REG_BK137C_67_H      0x137CCF
#define REG_BK137C_68_L      0x137CD0
#define REG_BK137C_68_H      0x137CD1
#define REG_BK137C_69_L      0x137CD2
#define REG_BK137C_69_H      0x137CD3
#define REG_BK137C_6A_L      0x137CD4
#define REG_BK137C_6A_H      0x137CD5
#define REG_BK137C_6B_L      0x137CD6
#define REG_BK137C_6B_H      0x137CD7
#define REG_BK137C_6C_L      0x137CD8
#define REG_BK137C_6C_H      0x137CD9
#define REG_BK137C_6D_L      0x137CDA
#define REG_BK137C_6D_H      0x137CDB
#define REG_BK137C_6E_L      0x137CDC
#define REG_BK137C_6E_H      0x137CDD
#define REG_BK137C_6F_L      0x137CDE
#define REG_BK137C_6F_H      0x137CDF
#define REG_BK137C_70_L      0x137CE0
#define REG_BK137C_70_H      0x137CE1
#define REG_BK137C_71_L      0x137CE2
#define REG_BK137C_71_H      0x137CE3
#define REG_BK137C_72_L      0x137CE4
#define REG_BK137C_72_H      0x137CE5
#define REG_BK137C_73_L      0x137CE6
#define REG_BK137C_73_H      0x137CE7
#define REG_BK137C_74_L      0x137CE8
#define REG_BK137C_74_H      0x137CE9
#define REG_BK137C_75_L      0x137CEA
#define REG_BK137C_75_H      0x137CEB
#define REG_BK137C_76_L      0x137CEC
#define REG_BK137C_76_H      0x137CED
#define REG_BK137C_77_L      0x137CEE
#define REG_BK137C_77_H      0x137CEF
#define REG_BK137C_78_L      0x137CF0
#define REG_BK137C_78_H      0x137CF1
#define REG_BK137C_79_L      0x137CF2
#define REG_BK137C_79_H      0x137CF3
#define REG_BK137C_7A_L      0x137CF4
#define REG_BK137C_7A_H      0x137CF5
#define REG_BK137C_7B_L      0x137CF6
#define REG_BK137C_7B_H      0x137CF7
#define REG_BK137C_7C_L      0x137CF8
#define REG_BK137C_7C_H      0x137CF9
#define REG_BK137C_7D_L      0x137CFA
#define REG_BK137C_7D_H      0x137CFB
#define REG_BK137C_7E_L      0x137CFC
#define REG_BK137C_7E_H      0x137CFD
#define REG_BK137C_7F_L      0x137CFE
#define REG_BK137C_7F_H      0x137CFF
//----------------------------------------------
#define REG_BK137D_00_L      0x137D00
#define REG_BK137D_00_H      0x137D01
#define REG_BK137D_01_L      0x137D02
#define REG_BK137D_01_H      0x137D03
#define REG_BK137D_02_L      0x137D04
#define REG_BK137D_02_H      0x137D05
#define REG_BK137D_03_L      0x137D06
#define REG_BK137D_03_H      0x137D07
#define REG_BK137D_04_L      0x137D08
#define REG_BK137D_04_H      0x137D09
#define REG_BK137D_05_L      0x137D0A
#define REG_BK137D_05_H      0x137D0B
#define REG_BK137D_06_L      0x137D0C
#define REG_BK137D_06_H      0x137D0D
#define REG_BK137D_07_L      0x137D0E
#define REG_BK137D_07_H      0x137D0F
#define REG_BK137D_08_L      0x137D10
#define REG_BK137D_08_H      0x137D11
#define REG_BK137D_09_L      0x137D12
#define REG_BK137D_09_H      0x137D13
#define REG_BK137D_0A_L      0x137D14
#define REG_BK137D_0A_H      0x137D15
#define REG_BK137D_0B_L      0x137D16
#define REG_BK137D_0B_H      0x137D17
#define REG_BK137D_0C_L      0x137D18
#define REG_BK137D_0C_H      0x137D19
#define REG_BK137D_0D_L      0x137D1A
#define REG_BK137D_0D_H      0x137D1B
#define REG_BK137D_0E_L      0x137D1C
#define REG_BK137D_0E_H      0x137D1D
#define REG_BK137D_0F_L      0x137D1E
#define REG_BK137D_0F_H      0x137D1F
#define REG_BK137D_10_L      0x137D20
#define REG_BK137D_10_H      0x137D21
#define REG_BK137D_11_L      0x137D22
#define REG_BK137D_11_H      0x137D23
#define REG_BK137D_12_L      0x137D24
#define REG_BK137D_12_H      0x137D25
#define REG_BK137D_13_L      0x137D26
#define REG_BK137D_13_H      0x137D27
#define REG_BK137D_14_L      0x137D28
#define REG_BK137D_14_H      0x137D29
#define REG_BK137D_15_L      0x137D2A
#define REG_BK137D_15_H      0x137D2B
#define REG_BK137D_16_L      0x137D2C
#define REG_BK137D_16_H      0x137D2D
#define REG_BK137D_17_L      0x137D2E
#define REG_BK137D_17_H      0x137D2F
#define REG_BK137D_18_L      0x137D30
#define REG_BK137D_18_H      0x137D31
#define REG_BK137D_19_L      0x137D32
#define REG_BK137D_19_H      0x137D33
#define REG_BK137D_1A_L      0x137D34
#define REG_BK137D_1A_H      0x137D35
#define REG_BK137D_1B_L      0x137D36
#define REG_BK137D_1B_H      0x137D37
#define REG_BK137D_1C_L      0x137D38
#define REG_BK137D_1C_H      0x137D39
#define REG_BK137D_1D_L      0x137D3A
#define REG_BK137D_1D_H      0x137D3B
#define REG_BK137D_1E_L      0x137D3C
#define REG_BK137D_1E_H      0x137D3D
#define REG_BK137D_1F_L      0x137D3E
#define REG_BK137D_1F_H      0x137D3F
#define REG_BK137D_20_L      0x137D40
#define REG_BK137D_20_H      0x137D41
#define REG_BK137D_21_L      0x137D42
#define REG_BK137D_21_H      0x137D43
#define REG_BK137D_22_L      0x137D44
#define REG_BK137D_22_H      0x137D45
#define REG_BK137D_23_L      0x137D46
#define REG_BK137D_23_H      0x137D47
#define REG_BK137D_24_L      0x137D48
#define REG_BK137D_24_H      0x137D49
#define REG_BK137D_25_L      0x137D4A
#define REG_BK137D_25_H      0x137D4B
#define REG_BK137D_26_L      0x137D4C
#define REG_BK137D_26_H      0x137D4D
#define REG_BK137D_27_L      0x137D4E
#define REG_BK137D_27_H      0x137D4F
#define REG_BK137D_28_L      0x137D50
#define REG_BK137D_28_H      0x137D51
#define REG_BK137D_29_L      0x137D52
#define REG_BK137D_29_H      0x137D53
#define REG_BK137D_2A_L      0x137D54
#define REG_BK137D_2A_H      0x137D55
#define REG_BK137D_2B_L      0x137D56
#define REG_BK137D_2B_H      0x137D57
#define REG_BK137D_2C_L      0x137D58
#define REG_BK137D_2C_H      0x137D59
#define REG_BK137D_2D_L      0x137D5A
#define REG_BK137D_2D_H      0x137D5B
#define REG_BK137D_2E_L      0x137D5C
#define REG_BK137D_2E_H      0x137D5D
#define REG_BK137D_2F_L      0x137D5E
#define REG_BK137D_2F_H      0x137D5F
#define REG_BK137D_30_L      0x137D60
#define REG_BK137D_30_H      0x137D61
#define REG_BK137D_31_L      0x137D62
#define REG_BK137D_31_H      0x137D63
#define REG_BK137D_32_L      0x137D64
#define REG_BK137D_32_H      0x137D65
#define REG_BK137D_33_L      0x137D66
#define REG_BK137D_33_H      0x137D67
#define REG_BK137D_34_L      0x137D68
#define REG_BK137D_34_H      0x137D69
#define REG_BK137D_35_L      0x137D6A
#define REG_BK137D_35_H      0x137D6B
#define REG_BK137D_36_L      0x137D6C
#define REG_BK137D_36_H      0x137D6D
#define REG_BK137D_37_L      0x137D6E
#define REG_BK137D_37_H      0x137D6F
#define REG_BK137D_38_L      0x137D70
#define REG_BK137D_38_H      0x137D71
#define REG_BK137D_39_L      0x137D72
#define REG_BK137D_39_H      0x137D73
#define REG_BK137D_3A_L      0x137D74
#define REG_BK137D_3A_H      0x137D75
#define REG_BK137D_3B_L      0x137D76
#define REG_BK137D_3B_H      0x137D77
#define REG_BK137D_3C_L      0x137D78
#define REG_BK137D_3C_H      0x137D79
#define REG_BK137D_3D_L      0x137D7A
#define REG_BK137D_3D_H      0x137D7B
#define REG_BK137D_3E_L      0x137D7C
#define REG_BK137D_3E_H      0x137D7D
#define REG_BK137D_3F_L      0x137D7E
#define REG_BK137D_3F_H      0x137D7F
#define REG_BK137D_40_L      0x137D80
#define REG_BK137D_40_H      0x137D81
#define REG_BK137D_41_L      0x137D82
#define REG_BK137D_41_H      0x137D83
#define REG_BK137D_42_L      0x137D84
#define REG_BK137D_42_H      0x137D85
#define REG_BK137D_43_L      0x137D86
#define REG_BK137D_43_H      0x137D87
#define REG_BK137D_44_L      0x137D88
#define REG_BK137D_44_H      0x137D89
#define REG_BK137D_45_L      0x137D8A
#define REG_BK137D_45_H      0x137D8B
#define REG_BK137D_46_L      0x137D8C
#define REG_BK137D_46_H      0x137D8D
#define REG_BK137D_47_L      0x137D8E
#define REG_BK137D_47_H      0x137D8F
#define REG_BK137D_48_L      0x137D90
#define REG_BK137D_48_H      0x137D91
#define REG_BK137D_49_L      0x137D92
#define REG_BK137D_49_H      0x137D93
#define REG_BK137D_4A_L      0x137D94
#define REG_BK137D_4A_H      0x137D95
#define REG_BK137D_4B_L      0x137D96
#define REG_BK137D_4B_H      0x137D97
#define REG_BK137D_4C_L      0x137D98
#define REG_BK137D_4C_H      0x137D99
#define REG_BK137D_4D_L      0x137D9A
#define REG_BK137D_4D_H      0x137D9B
#define REG_BK137D_4E_L      0x137D9C
#define REG_BK137D_4E_H      0x137D9D
#define REG_BK137D_4F_L      0x137D9E
#define REG_BK137D_4F_H      0x137D9F
#define REG_BK137D_50_L      0x137DA0
#define REG_BK137D_50_H      0x137DA1
#define REG_BK137D_51_L      0x137DA2
#define REG_BK137D_51_H      0x137DA3
#define REG_BK137D_52_L      0x137DA4
#define REG_BK137D_52_H      0x137DA5
#define REG_BK137D_53_L      0x137DA6
#define REG_BK137D_53_H      0x137DA7
#define REG_BK137D_54_L      0x137DA8
#define REG_BK137D_54_H      0x137DA9
#define REG_BK137D_55_L      0x137DAA
#define REG_BK137D_55_H      0x137DAB
#define REG_BK137D_56_L      0x137DAC
#define REG_BK137D_56_H      0x137DAD
#define REG_BK137D_57_L      0x137DAE
#define REG_BK137D_57_H      0x137DAF
#define REG_BK137D_58_L      0x137DB0
#define REG_BK137D_58_H      0x137DB1
#define REG_BK137D_59_L      0x137DB2
#define REG_BK137D_59_H      0x137DB3
#define REG_BK137D_5A_L      0x137DB4
#define REG_BK137D_5A_H      0x137DB5
#define REG_BK137D_5B_L      0x137DB6
#define REG_BK137D_5B_H      0x137DB7
#define REG_BK137D_5C_L      0x137DB8
#define REG_BK137D_5C_H      0x137DB9
#define REG_BK137D_5D_L      0x137DBA
#define REG_BK137D_5D_H      0x137DBB
#define REG_BK137D_5E_L      0x137DBC
#define REG_BK137D_5E_H      0x137DBD
#define REG_BK137D_5F_L      0x137DBE
#define REG_BK137D_5F_H      0x137DBF
#define REG_BK137D_60_L      0x137DC0
#define REG_BK137D_60_H      0x137DC1
#define REG_BK137D_61_L      0x137DC2
#define REG_BK137D_61_H      0x137DC3
#define REG_BK137D_62_L      0x137DC4
#define REG_BK137D_62_H      0x137DC5
#define REG_BK137D_63_L      0x137DC6
#define REG_BK137D_63_H      0x137DC7
#define REG_BK137D_64_L      0x137DC8
#define REG_BK137D_64_H      0x137DC9
#define REG_BK137D_65_L      0x137DCA
#define REG_BK137D_65_H      0x137DCB
#define REG_BK137D_66_L      0x137DCC
#define REG_BK137D_66_H      0x137DCD
#define REG_BK137D_67_L      0x137DCE
#define REG_BK137D_67_H      0x137DCF
#define REG_BK137D_68_L      0x137DD0
#define REG_BK137D_68_H      0x137DD1
#define REG_BK137D_69_L      0x137DD2
#define REG_BK137D_69_H      0x137DD3
#define REG_BK137D_6A_L      0x137DD4
#define REG_BK137D_6A_H      0x137DD5
#define REG_BK137D_6B_L      0x137DD6
#define REG_BK137D_6B_H      0x137DD7
#define REG_BK137D_6C_L      0x137DD8
#define REG_BK137D_6C_H      0x137DD9
#define REG_BK137D_6D_L      0x137DDA
#define REG_BK137D_6D_H      0x137DDB
#define REG_BK137D_6E_L      0x137DDC
#define REG_BK137D_6E_H      0x137DDD
#define REG_BK137D_6F_L      0x137DDE
#define REG_BK137D_6F_H      0x137DDF
#define REG_BK137D_70_L      0x137DE0
#define REG_BK137D_70_H      0x137DE1
#define REG_BK137D_71_L      0x137DE2
#define REG_BK137D_71_H      0x137DE3
#define REG_BK137D_72_L      0x137DE4
#define REG_BK137D_72_H      0x137DE5
#define REG_BK137D_73_L      0x137DE6
#define REG_BK137D_73_H      0x137DE7
#define REG_BK137D_74_L      0x137DE8
#define REG_BK137D_74_H      0x137DE9
#define REG_BK137D_75_L      0x137DEA
#define REG_BK137D_75_H      0x137DEB
#define REG_BK137D_76_L      0x137DEC
#define REG_BK137D_76_H      0x137DED
#define REG_BK137D_77_L      0x137DEE
#define REG_BK137D_77_H      0x137DEF
#define REG_BK137D_78_L      0x137DF0
#define REG_BK137D_78_H      0x137DF1
#define REG_BK137D_79_L      0x137DF2
#define REG_BK137D_79_H      0x137DF3
#define REG_BK137D_7A_L      0x137DF4
#define REG_BK137D_7A_H      0x137DF5
#define REG_BK137D_7B_L      0x137DF6
#define REG_BK137D_7B_H      0x137DF7
#define REG_BK137D_7C_L      0x137DF8
#define REG_BK137D_7C_H      0x137DF9
#define REG_BK137D_7D_L      0x137DFA
#define REG_BK137D_7D_H      0x137DFB
#define REG_BK137D_7E_L      0x137DFC
#define REG_BK137D_7E_H      0x137DFD
#define REG_BK137D_7F_L      0x137DFE
#define REG_BK137D_7F_H      0x137DFF
//----------------------------------------------
#define REG_BK137E_00_L      0x137E00
#define REG_BK137E_00_H      0x137E01
#define REG_BK137E_01_L      0x137E02
#define REG_BK137E_01_H      0x137E03
#define REG_BK137E_02_L      0x137E04
#define REG_BK137E_02_H      0x137E05
#define REG_BK137E_03_L      0x137E06
#define REG_BK137E_03_H      0x137E07
#define REG_BK137E_04_L      0x137E08
#define REG_BK137E_04_H      0x137E09
#define REG_BK137E_05_L      0x137E0A
#define REG_BK137E_05_H      0x137E0B
#define REG_BK137E_06_L      0x137E0C
#define REG_BK137E_06_H      0x137E0D
#define REG_BK137E_07_L      0x137E0E
#define REG_BK137E_07_H      0x137E0F
#define REG_BK137E_08_L      0x137E10
#define REG_BK137E_08_H      0x137E11
#define REG_BK137E_09_L      0x137E12
#define REG_BK137E_09_H      0x137E13
#define REG_BK137E_0A_L      0x137E14
#define REG_BK137E_0A_H      0x137E15
#define REG_BK137E_0B_L      0x137E16
#define REG_BK137E_0B_H      0x137E17
#define REG_BK137E_0C_L      0x137E18
#define REG_BK137E_0C_H      0x137E19
#define REG_BK137E_0D_L      0x137E1A
#define REG_BK137E_0D_H      0x137E1B
#define REG_BK137E_0E_L      0x137E1C
#define REG_BK137E_0E_H      0x137E1D
#define REG_BK137E_0F_L      0x137E1E
#define REG_BK137E_0F_H      0x137E1F
#define REG_BK137E_10_L      0x137E20
#define REG_BK137E_10_H      0x137E21
#define REG_BK137E_11_L      0x137E22
#define REG_BK137E_11_H      0x137E23
#define REG_BK137E_12_L      0x137E24
#define REG_BK137E_12_H      0x137E25
#define REG_BK137E_13_L      0x137E26
#define REG_BK137E_13_H      0x137E27
#define REG_BK137E_14_L      0x137E28
#define REG_BK137E_14_H      0x137E29
#define REG_BK137E_15_L      0x137E2A
#define REG_BK137E_15_H      0x137E2B
#define REG_BK137E_16_L      0x137E2C
#define REG_BK137E_16_H      0x137E2D
#define REG_BK137E_17_L      0x137E2E
#define REG_BK137E_17_H      0x137E2F
#define REG_BK137E_18_L      0x137E30
#define REG_BK137E_18_H      0x137E31
#define REG_BK137E_19_L      0x137E32
#define REG_BK137E_19_H      0x137E33
#define REG_BK137E_1A_L      0x137E34
#define REG_BK137E_1A_H      0x137E35
#define REG_BK137E_1B_L      0x137E36
#define REG_BK137E_1B_H      0x137E37
#define REG_BK137E_1C_L      0x137E38
#define REG_BK137E_1C_H      0x137E39
#define REG_BK137E_1D_L      0x137E3A
#define REG_BK137E_1D_H      0x137E3B
#define REG_BK137E_1E_L      0x137E3C
#define REG_BK137E_1E_H      0x137E3D
#define REG_BK137E_1F_L      0x137E3E
#define REG_BK137E_1F_H      0x137E3F
#define REG_BK137E_20_L      0x137E40
#define REG_BK137E_20_H      0x137E41
#define REG_BK137E_21_L      0x137E42
#define REG_BK137E_21_H      0x137E43
#define REG_BK137E_22_L      0x137E44
#define REG_BK137E_22_H      0x137E45
#define REG_BK137E_23_L      0x137E46
#define REG_BK137E_23_H      0x137E47
#define REG_BK137E_24_L      0x137E48
#define REG_BK137E_24_H      0x137E49
#define REG_BK137E_25_L      0x137E4A
#define REG_BK137E_25_H      0x137E4B
#define REG_BK137E_26_L      0x137E4C
#define REG_BK137E_26_H      0x137E4D
#define REG_BK137E_27_L      0x137E4E
#define REG_BK137E_27_H      0x137E4F
#define REG_BK137E_28_L      0x137E50
#define REG_BK137E_28_H      0x137E51
#define REG_BK137E_29_L      0x137E52
#define REG_BK137E_29_H      0x137E53
#define REG_BK137E_2A_L      0x137E54
#define REG_BK137E_2A_H      0x137E55
#define REG_BK137E_2B_L      0x137E56
#define REG_BK137E_2B_H      0x137E57
#define REG_BK137E_2C_L      0x137E58
#define REG_BK137E_2C_H      0x137E59
#define REG_BK137E_2D_L      0x137E5A
#define REG_BK137E_2D_H      0x137E5B
#define REG_BK137E_2E_L      0x137E5C
#define REG_BK137E_2E_H      0x137E5D
#define REG_BK137E_2F_L      0x137E5E
#define REG_BK137E_2F_H      0x137E5F
#define REG_BK137E_30_L      0x137E60
#define REG_BK137E_30_H      0x137E61
#define REG_BK137E_31_L      0x137E62
#define REG_BK137E_31_H      0x137E63
#define REG_BK137E_32_L      0x137E64
#define REG_BK137E_32_H      0x137E65
#define REG_BK137E_33_L      0x137E66
#define REG_BK137E_33_H      0x137E67
#define REG_BK137E_34_L      0x137E68
#define REG_BK137E_34_H      0x137E69
#define REG_BK137E_35_L      0x137E6A
#define REG_BK137E_35_H      0x137E6B
#define REG_BK137E_36_L      0x137E6C
#define REG_BK137E_36_H      0x137E6D
#define REG_BK137E_37_L      0x137E6E
#define REG_BK137E_37_H      0x137E6F
#define REG_BK137E_38_L      0x137E70
#define REG_BK137E_38_H      0x137E71
#define REG_BK137E_39_L      0x137E72
#define REG_BK137E_39_H      0x137E73
#define REG_BK137E_3A_L      0x137E74
#define REG_BK137E_3A_H      0x137E75
#define REG_BK137E_3B_L      0x137E76
#define REG_BK137E_3B_H      0x137E77
#define REG_BK137E_3C_L      0x137E78
#define REG_BK137E_3C_H      0x137E79
#define REG_BK137E_3D_L      0x137E7A
#define REG_BK137E_3D_H      0x137E7B
#define REG_BK137E_3E_L      0x137E7C
#define REG_BK137E_3E_H      0x137E7D
#define REG_BK137E_3F_L      0x137E7E
#define REG_BK137E_3F_H      0x137E7F
#define REG_BK137E_40_L      0x137E80
#define REG_BK137E_40_H      0x137E81
#define REG_BK137E_41_L      0x137E82
#define REG_BK137E_41_H      0x137E83
#define REG_BK137E_42_L      0x137E84
#define REG_BK137E_42_H      0x137E85
#define REG_BK137E_43_L      0x137E86
#define REG_BK137E_43_H      0x137E87
#define REG_BK137E_44_L      0x137E88
#define REG_BK137E_44_H      0x137E89
#define REG_BK137E_45_L      0x137E8A
#define REG_BK137E_45_H      0x137E8B
#define REG_BK137E_46_L      0x137E8C
#define REG_BK137E_46_H      0x137E8D
#define REG_BK137E_47_L      0x137E8E
#define REG_BK137E_47_H      0x137E8F
#define REG_BK137E_48_L      0x137E90
#define REG_BK137E_48_H      0x137E91
#define REG_BK137E_49_L      0x137E92
#define REG_BK137E_49_H      0x137E93
#define REG_BK137E_4A_L      0x137E94
#define REG_BK137E_4A_H      0x137E95
#define REG_BK137E_4B_L      0x137E96
#define REG_BK137E_4B_H      0x137E97
#define REG_BK137E_4C_L      0x137E98
#define REG_BK137E_4C_H      0x137E99
#define REG_BK137E_4D_L      0x137E9A
#define REG_BK137E_4D_H      0x137E9B
#define REG_BK137E_4E_L      0x137E9C
#define REG_BK137E_4E_H      0x137E9D
#define REG_BK137E_4F_L      0x137E9E
#define REG_BK137E_4F_H      0x137E9F
#define REG_BK137E_50_L      0x137EA0
#define REG_BK137E_50_H      0x137EA1
#define REG_BK137E_51_L      0x137EA2
#define REG_BK137E_51_H      0x137EA3
#define REG_BK137E_52_L      0x137EA4
#define REG_BK137E_52_H      0x137EA5
#define REG_BK137E_53_L      0x137EA6
#define REG_BK137E_53_H      0x137EA7
#define REG_BK137E_54_L      0x137EA8
#define REG_BK137E_54_H      0x137EA9
#define REG_BK137E_55_L      0x137EAA
#define REG_BK137E_55_H      0x137EAB
#define REG_BK137E_56_L      0x137EAC
#define REG_BK137E_56_H      0x137EAD
#define REG_BK137E_57_L      0x137EAE
#define REG_BK137E_57_H      0x137EAF
#define REG_BK137E_58_L      0x137EB0
#define REG_BK137E_58_H      0x137EB1
#define REG_BK137E_59_L      0x137EB2
#define REG_BK137E_59_H      0x137EB3
#define REG_BK137E_5A_L      0x137EB4
#define REG_BK137E_5A_H      0x137EB5
#define REG_BK137E_5B_L      0x137EB6
#define REG_BK137E_5B_H      0x137EB7
#define REG_BK137E_5C_L      0x137EB8
#define REG_BK137E_5C_H      0x137EB9
#define REG_BK137E_5D_L      0x137EBA
#define REG_BK137E_5D_H      0x137EBB
#define REG_BK137E_5E_L      0x137EBC
#define REG_BK137E_5E_H      0x137EBD
#define REG_BK137E_5F_L      0x137EBE
#define REG_BK137E_5F_H      0x137EBF
#define REG_BK137E_60_L      0x137EC0
#define REG_BK137E_60_H      0x137EC1
#define REG_BK137E_61_L      0x137EC2
#define REG_BK137E_61_H      0x137EC3
#define REG_BK137E_62_L      0x137EC4
#define REG_BK137E_62_H      0x137EC5
#define REG_BK137E_63_L      0x137EC6
#define REG_BK137E_63_H      0x137EC7
#define REG_BK137E_64_L      0x137EC8
#define REG_BK137E_64_H      0x137EC9
#define REG_BK137E_65_L      0x137ECA
#define REG_BK137E_65_H      0x137ECB
#define REG_BK137E_66_L      0x137ECC
#define REG_BK137E_66_H      0x137ECD
#define REG_BK137E_67_L      0x137ECE
#define REG_BK137E_67_H      0x137ECF
#define REG_BK137E_68_L      0x137ED0
#define REG_BK137E_68_H      0x137ED1
#define REG_BK137E_69_L      0x137ED2
#define REG_BK137E_69_H      0x137ED3
#define REG_BK137E_6A_L      0x137ED4
#define REG_BK137E_6A_H      0x137ED5
#define REG_BK137E_6B_L      0x137ED6
#define REG_BK137E_6B_H      0x137ED7
#define REG_BK137E_6C_L      0x137ED8
#define REG_BK137E_6C_H      0x137ED9
#define REG_BK137E_6D_L      0x137EDA
#define REG_BK137E_6D_H      0x137EDB
#define REG_BK137E_6E_L      0x137EDC
#define REG_BK137E_6E_H      0x137EDD
#define REG_BK137E_6F_L      0x137EDE
#define REG_BK137E_6F_H      0x137EDF
#define REG_BK137E_70_L      0x137EE0
#define REG_BK137E_70_H      0x137EE1
#define REG_BK137E_71_L      0x137EE2
#define REG_BK137E_71_H      0x137EE3
#define REG_BK137E_72_L      0x137EE4
#define REG_BK137E_72_H      0x137EE5
#define REG_BK137E_73_L      0x137EE6
#define REG_BK137E_73_H      0x137EE7
#define REG_BK137E_74_L      0x137EE8
#define REG_BK137E_74_H      0x137EE9
#define REG_BK137E_75_L      0x137EEA
#define REG_BK137E_75_H      0x137EEB
#define REG_BK137E_76_L      0x137EEC
#define REG_BK137E_76_H      0x137EED
#define REG_BK137E_77_L      0x137EEE
#define REG_BK137E_77_H      0x137EEF
#define REG_BK137E_78_L      0x137EF0
#define REG_BK137E_78_H      0x137EF1
#define REG_BK137E_79_L      0x137EF2
#define REG_BK137E_79_H      0x137EF3
#define REG_BK137E_7A_L      0x137EF4
#define REG_BK137E_7A_H      0x137EF5
#define REG_BK137E_7B_L      0x137EF6
#define REG_BK137E_7B_H      0x137EF7
#define REG_BK137E_7C_L      0x137EF8
#define REG_BK137E_7C_H      0x137EF9
#define REG_BK137E_7D_L      0x137EFA
#define REG_BK137E_7D_H      0x137EFB
#define REG_BK137E_7E_L      0x137EFC
#define REG_BK137E_7E_H      0x137EFD
#define REG_BK137E_7F_L      0x137EFE
#define REG_BK137E_7F_H      0x137EFF
//----------------------------------------------
#define REG_BK1380_00_L      0x138000
#define REG_BK1380_00_H      0x138001
#define REG_BK1380_01_L      0x138002
#define REG_BK1380_01_H      0x138003
#define REG_BK1380_02_L      0x138004
#define REG_BK1380_02_H      0x138005
#define REG_BK1380_03_L      0x138006
#define REG_BK1380_03_H      0x138007
#define REG_BK1380_04_L      0x138008
#define REG_BK1380_04_H      0x138009
#define REG_BK1380_05_L      0x13800A
#define REG_BK1380_05_H      0x13800B
#define REG_BK1380_06_L      0x13800C
#define REG_BK1380_06_H      0x13800D
#define REG_BK1380_07_L      0x13800E
#define REG_BK1380_07_H      0x13800F
#define REG_BK1380_08_L      0x138010
#define REG_BK1380_08_H      0x138011
#define REG_BK1380_09_L      0x138012
#define REG_BK1380_09_H      0x138013
#define REG_BK1380_0A_L      0x138014
#define REG_BK1380_0A_H      0x138015
#define REG_BK1380_0B_L      0x138016
#define REG_BK1380_0B_H      0x138017
#define REG_BK1380_0C_L      0x138018
#define REG_BK1380_0C_H      0x138019
#define REG_BK1380_0D_L      0x13801A
#define REG_BK1380_0D_H      0x13801B
#define REG_BK1380_0E_L      0x13801C
#define REG_BK1380_0E_H      0x13801D
#define REG_BK1380_0F_L      0x13801E
#define REG_BK1380_0F_H      0x13801F
#define REG_BK1380_10_L      0x138020
#define REG_BK1380_10_H      0x138021
#define REG_BK1380_11_L      0x138022
#define REG_BK1380_11_H      0x138023
#define REG_BK1380_12_L      0x138024
#define REG_BK1380_12_H      0x138025
#define REG_BK1380_13_L      0x138026
#define REG_BK1380_13_H      0x138027
#define REG_BK1380_14_L      0x138028
#define REG_BK1380_14_H      0x138029
#define REG_BK1380_15_L      0x13802A
#define REG_BK1380_15_H      0x13802B
#define REG_BK1380_16_L      0x13802C
#define REG_BK1380_16_H      0x13802D
#define REG_BK1380_17_L      0x13802E
#define REG_BK1380_17_H      0x13802F
#define REG_BK1380_18_L      0x138030
#define REG_BK1380_18_H      0x138031
#define REG_BK1380_19_L      0x138032
#define REG_BK1380_19_H      0x138033
#define REG_BK1380_1A_L      0x138034
#define REG_BK1380_1A_H      0x138035
#define REG_BK1380_1B_L      0x138036
#define REG_BK1380_1B_H      0x138037
#define REG_BK1380_1C_L      0x138038
#define REG_BK1380_1C_H      0x138039
#define REG_BK1380_1D_L      0x13803A
#define REG_BK1380_1D_H      0x13803B
#define REG_BK1380_1E_L      0x13803C
#define REG_BK1380_1E_H      0x13803D
#define REG_BK1380_1F_L      0x13803E
#define REG_BK1380_1F_H      0x13803F
#define REG_BK1380_20_L      0x138040
#define REG_BK1380_20_H      0x138041
#define REG_BK1380_21_L      0x138042
#define REG_BK1380_21_H      0x138043
#define REG_BK1380_22_L      0x138044
#define REG_BK1380_22_H      0x138045
#define REG_BK1380_23_L      0x138046
#define REG_BK1380_23_H      0x138047
#define REG_BK1380_24_L      0x138048
#define REG_BK1380_24_H      0x138049
#define REG_BK1380_25_L      0x13804A
#define REG_BK1380_25_H      0x13804B
#define REG_BK1380_26_L      0x13804C
#define REG_BK1380_26_H      0x13804D
#define REG_BK1380_27_L      0x13804E
#define REG_BK1380_27_H      0x13804F
#define REG_BK1380_28_L      0x138050
#define REG_BK1380_28_H      0x138051
#define REG_BK1380_29_L      0x138052
#define REG_BK1380_29_H      0x138053
#define REG_BK1380_2A_L      0x138054
#define REG_BK1380_2A_H      0x138055
#define REG_BK1380_2B_L      0x138056
#define REG_BK1380_2B_H      0x138057
#define REG_BK1380_2C_L      0x138058
#define REG_BK1380_2C_H      0x138059
#define REG_BK1380_2D_L      0x13805A
#define REG_BK1380_2D_H      0x13805B
#define REG_BK1380_2E_L      0x13805C
#define REG_BK1380_2E_H      0x13805D
#define REG_BK1380_2F_L      0x13805E
#define REG_BK1380_2F_H      0x13805F
#define REG_BK1380_30_L      0x138060
#define REG_BK1380_30_H      0x138061
#define REG_BK1380_31_L      0x138062
#define REG_BK1380_31_H      0x138063
#define REG_BK1380_32_L      0x138064
#define REG_BK1380_32_H      0x138065
#define REG_BK1380_33_L      0x138066
#define REG_BK1380_33_H      0x138067
#define REG_BK1380_34_L      0x138068
#define REG_BK1380_34_H      0x138069
#define REG_BK1380_35_L      0x13806A
#define REG_BK1380_35_H      0x13806B
#define REG_BK1380_36_L      0x13806C
#define REG_BK1380_36_H      0x13806D
#define REG_BK1380_37_L      0x13806E
#define REG_BK1380_37_H      0x13806F
#define REG_BK1380_38_L      0x138070
#define REG_BK1380_38_H      0x138071
#define REG_BK1380_39_L      0x138072
#define REG_BK1380_39_H      0x138073
#define REG_BK1380_3A_L      0x138074
#define REG_BK1380_3A_H      0x138075
#define REG_BK1380_3B_L      0x138076
#define REG_BK1380_3B_H      0x138077
#define REG_BK1380_3C_L      0x138078
#define REG_BK1380_3C_H      0x138079
#define REG_BK1380_3D_L      0x13807A
#define REG_BK1380_3D_H      0x13807B
#define REG_BK1380_3E_L      0x13807C
#define REG_BK1380_3E_H      0x13807D
#define REG_BK1380_3F_L      0x13807E
#define REG_BK1380_3F_H      0x13807F
#define REG_BK1380_40_L      0x138080
#define REG_BK1380_40_H      0x138081
#define REG_BK1380_41_L      0x138082
#define REG_BK1380_41_H      0x138083
#define REG_BK1380_42_L      0x138084
#define REG_BK1380_42_H      0x138085
#define REG_BK1380_43_L      0x138086
#define REG_BK1380_43_H      0x138087
#define REG_BK1380_44_L      0x138088
#define REG_BK1380_44_H      0x138089
#define REG_BK1380_45_L      0x13808A
#define REG_BK1380_45_H      0x13808B
#define REG_BK1380_46_L      0x13808C
#define REG_BK1380_46_H      0x13808D
#define REG_BK1380_47_L      0x13808E
#define REG_BK1380_47_H      0x13808F
#define REG_BK1380_48_L      0x138090
#define REG_BK1380_48_H      0x138091
#define REG_BK1380_49_L      0x138092
#define REG_BK1380_49_H      0x138093
#define REG_BK1380_4A_L      0x138094
#define REG_BK1380_4A_H      0x138095
#define REG_BK1380_4B_L      0x138096
#define REG_BK1380_4B_H      0x138097
#define REG_BK1380_4C_L      0x138098
#define REG_BK1380_4C_H      0x138099
#define REG_BK1380_4D_L      0x13809A
#define REG_BK1380_4D_H      0x13809B
#define REG_BK1380_4E_L      0x13809C
#define REG_BK1380_4E_H      0x13809D
#define REG_BK1380_4F_L      0x13809E
#define REG_BK1380_4F_H      0x13809F
#define REG_BK1380_50_L      0x1380A0
#define REG_BK1380_50_H      0x1380A1
#define REG_BK1380_51_L      0x1380A2
#define REG_BK1380_51_H      0x1380A3
#define REG_BK1380_52_L      0x1380A4
#define REG_BK1380_52_H      0x1380A5
#define REG_BK1380_53_L      0x1380A6
#define REG_BK1380_53_H      0x1380A7
#define REG_BK1380_54_L      0x1380A8
#define REG_BK1380_54_H      0x1380A9
#define REG_BK1380_55_L      0x1380AA
#define REG_BK1380_55_H      0x1380AB
#define REG_BK1380_56_L      0x1380AC
#define REG_BK1380_56_H      0x1380AD
#define REG_BK1380_57_L      0x1380AE
#define REG_BK1380_57_H      0x1380AF
#define REG_BK1380_58_L      0x1380B0
#define REG_BK1380_58_H      0x1380B1
#define REG_BK1380_59_L      0x1380B2
#define REG_BK1380_59_H      0x1380B3
#define REG_BK1380_5A_L      0x1380B4
#define REG_BK1380_5A_H      0x1380B5
#define REG_BK1380_5B_L      0x1380B6
#define REG_BK1380_5B_H      0x1380B7
#define REG_BK1380_5C_L      0x1380B8
#define REG_BK1380_5C_H      0x1380B9
#define REG_BK1380_5D_L      0x1380BA
#define REG_BK1380_5D_H      0x1380BB
#define REG_BK1380_5E_L      0x1380BC
#define REG_BK1380_5E_H      0x1380BD
#define REG_BK1380_5F_L      0x1380BE
#define REG_BK1380_5F_H      0x1380BF
#define REG_BK1380_60_L      0x1380C0
#define REG_BK1380_60_H      0x1380C1
#define REG_BK1380_61_L      0x1380C2
#define REG_BK1380_61_H      0x1380C3
#define REG_BK1380_62_L      0x1380C4
#define REG_BK1380_62_H      0x1380C5
#define REG_BK1380_63_L      0x1380C6
#define REG_BK1380_63_H      0x1380C7
#define REG_BK1380_64_L      0x1380C8
#define REG_BK1380_64_H      0x1380C9
#define REG_BK1380_65_L      0x1380CA
#define REG_BK1380_65_H      0x1380CB
#define REG_BK1380_66_L      0x1380CC
#define REG_BK1380_66_H      0x1380CD
#define REG_BK1380_67_L      0x1380CE
#define REG_BK1380_67_H      0x1380CF
#define REG_BK1380_68_L      0x1380D0
#define REG_BK1380_68_H      0x1380D1
#define REG_BK1380_69_L      0x1380D2
#define REG_BK1380_69_H      0x1380D3
#define REG_BK1380_6A_L      0x1380D4
#define REG_BK1380_6A_H      0x1380D5
#define REG_BK1380_6B_L      0x1380D6
#define REG_BK1380_6B_H      0x1380D7
#define REG_BK1380_6C_L      0x1380D8
#define REG_BK1380_6C_H      0x1380D9
#define REG_BK1380_6D_L      0x1380DA
#define REG_BK1380_6D_H      0x1380DB
#define REG_BK1380_6E_L      0x1380DC
#define REG_BK1380_6E_H      0x1380DD
#define REG_BK1380_6F_L      0x1380DE
#define REG_BK1380_6F_H      0x1380DF
#define REG_BK1380_70_L      0x1380E0
#define REG_BK1380_70_H      0x1380E1
#define REG_BK1380_71_L      0x1380E2
#define REG_BK1380_71_H      0x1380E3
#define REG_BK1380_72_L      0x1380E4
#define REG_BK1380_72_H      0x1380E5
#define REG_BK1380_73_L      0x1380E6
#define REG_BK1380_73_H      0x1380E7
#define REG_BK1380_74_L      0x1380E8
#define REG_BK1380_74_H      0x1380E9
#define REG_BK1380_75_L      0x1380EA
#define REG_BK1380_75_H      0x1380EB
#define REG_BK1380_76_L      0x1380EC
#define REG_BK1380_76_H      0x1380ED
#define REG_BK1380_77_L      0x1380EE
#define REG_BK1380_77_H      0x1380EF
#define REG_BK1380_78_L      0x1380F0
#define REG_BK1380_78_H      0x1380F1
#define REG_BK1380_79_L      0x1380F2
#define REG_BK1380_79_H      0x1380F3
#define REG_BK1380_7A_L      0x1380F4
#define REG_BK1380_7A_H      0x1380F5
#define REG_BK1380_7B_L      0x1380F6
#define REG_BK1380_7B_H      0x1380F7
#define REG_BK1380_7C_L      0x1380F8
#define REG_BK1380_7C_H      0x1380F9
#define REG_BK1380_7D_L      0x1380FA
#define REG_BK1380_7D_H      0x1380FB
#define REG_BK1380_7E_L      0x1380FC
#define REG_BK1380_7E_H      0x1380FD
#define REG_BK1380_7F_L      0x1380FE
#define REG_BK1380_7F_H      0x1380FF
//----------------------------------------------
#define REG_BK1381_00_L      0x138100
#define REG_BK1381_00_H      0x138101
#define REG_BK1381_01_L      0x138102
#define REG_BK1381_01_H      0x138103
#define REG_BK1381_02_L      0x138104
#define REG_BK1381_02_H      0x138105
#define REG_BK1381_03_L      0x138106
#define REG_BK1381_03_H      0x138107
#define REG_BK1381_04_L      0x138108
#define REG_BK1381_04_H      0x138109
#define REG_BK1381_05_L      0x13810A
#define REG_BK1381_05_H      0x13810B
#define REG_BK1381_06_L      0x13810C
#define REG_BK1381_06_H      0x13810D
#define REG_BK1381_07_L      0x13810E
#define REG_BK1381_07_H      0x13810F
#define REG_BK1381_08_L      0x138110
#define REG_BK1381_08_H      0x138111
#define REG_BK1381_09_L      0x138112
#define REG_BK1381_09_H      0x138113
#define REG_BK1381_0A_L      0x138114
#define REG_BK1381_0A_H      0x138115
#define REG_BK1381_0B_L      0x138116
#define REG_BK1381_0B_H      0x138117
#define REG_BK1381_0C_L      0x138118
#define REG_BK1381_0C_H      0x138119
#define REG_BK1381_0D_L      0x13811A
#define REG_BK1381_0D_H      0x13811B
#define REG_BK1381_0E_L      0x13811C
#define REG_BK1381_0E_H      0x13811D
#define REG_BK1381_0F_L      0x13811E
#define REG_BK1381_0F_H      0x13811F
#define REG_BK1381_10_L      0x138120
#define REG_BK1381_10_H      0x138121
#define REG_BK1381_11_L      0x138122
#define REG_BK1381_11_H      0x138123
#define REG_BK1381_12_L      0x138124
#define REG_BK1381_12_H      0x138125
#define REG_BK1381_13_L      0x138126
#define REG_BK1381_13_H      0x138127
#define REG_BK1381_14_L      0x138128
#define REG_BK1381_14_H      0x138129
#define REG_BK1381_15_L      0x13812A
#define REG_BK1381_15_H      0x13812B
#define REG_BK1381_16_L      0x13812C
#define REG_BK1381_16_H      0x13812D
#define REG_BK1381_17_L      0x13812E
#define REG_BK1381_17_H      0x13812F
#define REG_BK1381_18_L      0x138130
#define REG_BK1381_18_H      0x138131
#define REG_BK1381_19_L      0x138132
#define REG_BK1381_19_H      0x138133
#define REG_BK1381_1A_L      0x138134
#define REG_BK1381_1A_H      0x138135
#define REG_BK1381_1B_L      0x138136
#define REG_BK1381_1B_H      0x138137
#define REG_BK1381_1C_L      0x138138
#define REG_BK1381_1C_H      0x138139
#define REG_BK1381_1D_L      0x13813A
#define REG_BK1381_1D_H      0x13813B
#define REG_BK1381_1E_L      0x13813C
#define REG_BK1381_1E_H      0x13813D
#define REG_BK1381_1F_L      0x13813E
#define REG_BK1381_1F_H      0x13813F
#define REG_BK1381_20_L      0x138140
#define REG_BK1381_20_H      0x138141
#define REG_BK1381_21_L      0x138142
#define REG_BK1381_21_H      0x138143
#define REG_BK1381_22_L      0x138144
#define REG_BK1381_22_H      0x138145
#define REG_BK1381_23_L      0x138146
#define REG_BK1381_23_H      0x138147
#define REG_BK1381_24_L      0x138148
#define REG_BK1381_24_H      0x138149
#define REG_BK1381_25_L      0x13814A
#define REG_BK1381_25_H      0x13814B
#define REG_BK1381_26_L      0x13814C
#define REG_BK1381_26_H      0x13814D
#define REG_BK1381_27_L      0x13814E
#define REG_BK1381_27_H      0x13814F
#define REG_BK1381_28_L      0x138150
#define REG_BK1381_28_H      0x138151
#define REG_BK1381_29_L      0x138152
#define REG_BK1381_29_H      0x138153
#define REG_BK1381_2A_L      0x138154
#define REG_BK1381_2A_H      0x138155
#define REG_BK1381_2B_L      0x138156
#define REG_BK1381_2B_H      0x138157
#define REG_BK1381_2C_L      0x138158
#define REG_BK1381_2C_H      0x138159
#define REG_BK1381_2D_L      0x13815A
#define REG_BK1381_2D_H      0x13815B
#define REG_BK1381_2E_L      0x13815C
#define REG_BK1381_2E_H      0x13815D
#define REG_BK1381_2F_L      0x13815E
#define REG_BK1381_2F_H      0x13815F
#define REG_BK1381_30_L      0x138160
#define REG_BK1381_30_H      0x138161
#define REG_BK1381_31_L      0x138162
#define REG_BK1381_31_H      0x138163
#define REG_BK1381_32_L      0x138164
#define REG_BK1381_32_H      0x138165
#define REG_BK1381_33_L      0x138166
#define REG_BK1381_33_H      0x138167
#define REG_BK1381_34_L      0x138168
#define REG_BK1381_34_H      0x138169
#define REG_BK1381_35_L      0x13816A
#define REG_BK1381_35_H      0x13816B
#define REG_BK1381_36_L      0x13816C
#define REG_BK1381_36_H      0x13816D
#define REG_BK1381_37_L      0x13816E
#define REG_BK1381_37_H      0x13816F
#define REG_BK1381_38_L      0x138170
#define REG_BK1381_38_H      0x138171
#define REG_BK1381_39_L      0x138172
#define REG_BK1381_39_H      0x138173
#define REG_BK1381_3A_L      0x138174
#define REG_BK1381_3A_H      0x138175
#define REG_BK1381_3B_L      0x138176
#define REG_BK1381_3B_H      0x138177
#define REG_BK1381_3C_L      0x138178
#define REG_BK1381_3C_H      0x138179
#define REG_BK1381_3D_L      0x13817A
#define REG_BK1381_3D_H      0x13817B
#define REG_BK1381_3E_L      0x13817C
#define REG_BK1381_3E_H      0x13817D
#define REG_BK1381_3F_L      0x13817E
#define REG_BK1381_3F_H      0x13817F
#define REG_BK1381_40_L      0x138180
#define REG_BK1381_40_H      0x138181
#define REG_BK1381_41_L      0x138182
#define REG_BK1381_41_H      0x138183
#define REG_BK1381_42_L      0x138184
#define REG_BK1381_42_H      0x138185
#define REG_BK1381_43_L      0x138186
#define REG_BK1381_43_H      0x138187
#define REG_BK1381_44_L      0x138188
#define REG_BK1381_44_H      0x138189
#define REG_BK1381_45_L      0x13818A
#define REG_BK1381_45_H      0x13818B
#define REG_BK1381_46_L      0x13818C
#define REG_BK1381_46_H      0x13818D
#define REG_BK1381_47_L      0x13818E
#define REG_BK1381_47_H      0x13818F
#define REG_BK1381_48_L      0x138190
#define REG_BK1381_48_H      0x138191
#define REG_BK1381_49_L      0x138192
#define REG_BK1381_49_H      0x138193
#define REG_BK1381_4A_L      0x138194
#define REG_BK1381_4A_H      0x138195
#define REG_BK1381_4B_L      0x138196
#define REG_BK1381_4B_H      0x138197
#define REG_BK1381_4C_L      0x138198
#define REG_BK1381_4C_H      0x138199
#define REG_BK1381_4D_L      0x13819A
#define REG_BK1381_4D_H      0x13819B
#define REG_BK1381_4E_L      0x13819C
#define REG_BK1381_4E_H      0x13819D
#define REG_BK1381_4F_L      0x13819E
#define REG_BK1381_4F_H      0x13819F
#define REG_BK1381_50_L      0x1381A0
#define REG_BK1381_50_H      0x1381A1
#define REG_BK1381_51_L      0x1381A2
#define REG_BK1381_51_H      0x1381A3
#define REG_BK1381_52_L      0x1381A4
#define REG_BK1381_52_H      0x1381A5
#define REG_BK1381_53_L      0x1381A6
#define REG_BK1381_53_H      0x1381A7
#define REG_BK1381_54_L      0x1381A8
#define REG_BK1381_54_H      0x1381A9
#define REG_BK1381_55_L      0x1381AA
#define REG_BK1381_55_H      0x1381AB
#define REG_BK1381_56_L      0x1381AC
#define REG_BK1381_56_H      0x1381AD
#define REG_BK1381_57_L      0x1381AE
#define REG_BK1381_57_H      0x1381AF
#define REG_BK1381_58_L      0x1381B0
#define REG_BK1381_58_H      0x1381B1
#define REG_BK1381_59_L      0x1381B2
#define REG_BK1381_59_H      0x1381B3
#define REG_BK1381_5A_L      0x1381B4
#define REG_BK1381_5A_H      0x1381B5
#define REG_BK1381_5B_L      0x1381B6
#define REG_BK1381_5B_H      0x1381B7
#define REG_BK1381_5C_L      0x1381B8
#define REG_BK1381_5C_H      0x1381B9
#define REG_BK1381_5D_L      0x1381BA
#define REG_BK1381_5D_H      0x1381BB
#define REG_BK1381_5E_L      0x1381BC
#define REG_BK1381_5E_H      0x1381BD
#define REG_BK1381_5F_L      0x1381BE
#define REG_BK1381_5F_H      0x1381BF
#define REG_BK1381_60_L      0x1381C0
#define REG_BK1381_60_H      0x1381C1
#define REG_BK1381_61_L      0x1381C2
#define REG_BK1381_61_H      0x1381C3
#define REG_BK1381_62_L      0x1381C4
#define REG_BK1381_62_H      0x1381C5
#define REG_BK1381_63_L      0x1381C6
#define REG_BK1381_63_H      0x1381C7
#define REG_BK1381_64_L      0x1381C8
#define REG_BK1381_64_H      0x1381C9
#define REG_BK1381_65_L      0x1381CA
#define REG_BK1381_65_H      0x1381CB
#define REG_BK1381_66_L      0x1381CC
#define REG_BK1381_66_H      0x1381CD
#define REG_BK1381_67_L      0x1381CE
#define REG_BK1381_67_H      0x1381CF
#define REG_BK1381_68_L      0x1381D0
#define REG_BK1381_68_H      0x1381D1
#define REG_BK1381_69_L      0x1381D2
#define REG_BK1381_69_H      0x1381D3
#define REG_BK1381_6A_L      0x1381D4
#define REG_BK1381_6A_H      0x1381D5
#define REG_BK1381_6B_L      0x1381D6
#define REG_BK1381_6B_H      0x1381D7
#define REG_BK1381_6C_L      0x1381D8
#define REG_BK1381_6C_H      0x1381D9
#define REG_BK1381_6D_L      0x1381DA
#define REG_BK1381_6D_H      0x1381DB
#define REG_BK1381_6E_L      0x1381DC
#define REG_BK1381_6E_H      0x1381DD
#define REG_BK1381_6F_L      0x1381DE
#define REG_BK1381_6F_H      0x1381DF
#define REG_BK1381_70_L      0x1381E0
#define REG_BK1381_70_H      0x1381E1
#define REG_BK1381_71_L      0x1381E2
#define REG_BK1381_71_H      0x1381E3
#define REG_BK1381_72_L      0x1381E4
#define REG_BK1381_72_H      0x1381E5
#define REG_BK1381_73_L      0x1381E6
#define REG_BK1381_73_H      0x1381E7
#define REG_BK1381_74_L      0x1381E8
#define REG_BK1381_74_H      0x1381E9
#define REG_BK1381_75_L      0x1381EA
#define REG_BK1381_75_H      0x1381EB
#define REG_BK1381_76_L      0x1381EC
#define REG_BK1381_76_H      0x1381ED
#define REG_BK1381_77_L      0x1381EE
#define REG_BK1381_77_H      0x1381EF
#define REG_BK1381_78_L      0x1381F0
#define REG_BK1381_78_H      0x1381F1
#define REG_BK1381_79_L      0x1381F2
#define REG_BK1381_79_H      0x1381F3
#define REG_BK1381_7A_L      0x1381F4
#define REG_BK1381_7A_H      0x1381F5
#define REG_BK1381_7B_L      0x1381F6
#define REG_BK1381_7B_H      0x1381F7
#define REG_BK1381_7C_L      0x1381F8
#define REG_BK1381_7C_H      0x1381F9
#define REG_BK1381_7D_L      0x1381FA
#define REG_BK1381_7D_H      0x1381FB
#define REG_BK1381_7E_L      0x1381FC
#define REG_BK1381_7E_H      0x1381FD
#define REG_BK1381_7F_L      0x1381FE
#define REG_BK1381_7F_H      0x1381FF
//----------------------------------------------
#define REG_BK1382_00_L      0x138200
#define REG_BK1382_00_H      0x138201
#define REG_BK1382_01_L      0x138202
#define REG_BK1382_01_H      0x138203
#define REG_BK1382_02_L      0x138204
#define REG_BK1382_02_H      0x138205
#define REG_BK1382_03_L      0x138206
#define REG_BK1382_03_H      0x138207
#define REG_BK1382_04_L      0x138208
#define REG_BK1382_04_H      0x138209
#define REG_BK1382_05_L      0x13820A
#define REG_BK1382_05_H      0x13820B
#define REG_BK1382_06_L      0x13820C
#define REG_BK1382_06_H      0x13820D
#define REG_BK1382_07_L      0x13820E
#define REG_BK1382_07_H      0x13820F
#define REG_BK1382_08_L      0x138210
#define REG_BK1382_08_H      0x138211
#define REG_BK1382_09_L      0x138212
#define REG_BK1382_09_H      0x138213
#define REG_BK1382_0A_L      0x138214
#define REG_BK1382_0A_H      0x138215
#define REG_BK1382_0B_L      0x138216
#define REG_BK1382_0B_H      0x138217
#define REG_BK1382_0C_L      0x138218
#define REG_BK1382_0C_H      0x138219
#define REG_BK1382_0D_L      0x13821A
#define REG_BK1382_0D_H      0x13821B
#define REG_BK1382_0E_L      0x13821C
#define REG_BK1382_0E_H      0x13821D
#define REG_BK1382_0F_L      0x13821E
#define REG_BK1382_0F_H      0x13821F
#define REG_BK1382_10_L      0x138220
#define REG_BK1382_10_H      0x138221
#define REG_BK1382_11_L      0x138222
#define REG_BK1382_11_H      0x138223
#define REG_BK1382_12_L      0x138224
#define REG_BK1382_12_H      0x138225
#define REG_BK1382_13_L      0x138226
#define REG_BK1382_13_H      0x138227
#define REG_BK1382_14_L      0x138228
#define REG_BK1382_14_H      0x138229
#define REG_BK1382_15_L      0x13822A
#define REG_BK1382_15_H      0x13822B
#define REG_BK1382_16_L      0x13822C
#define REG_BK1382_16_H      0x13822D
#define REG_BK1382_17_L      0x13822E
#define REG_BK1382_17_H      0x13822F
#define REG_BK1382_18_L      0x138230
#define REG_BK1382_18_H      0x138231
#define REG_BK1382_19_L      0x138232
#define REG_BK1382_19_H      0x138233
#define REG_BK1382_1A_L      0x138234
#define REG_BK1382_1A_H      0x138235
#define REG_BK1382_1B_L      0x138236
#define REG_BK1382_1B_H      0x138237
#define REG_BK1382_1C_L      0x138238
#define REG_BK1382_1C_H      0x138239
#define REG_BK1382_1D_L      0x13823A
#define REG_BK1382_1D_H      0x13823B
#define REG_BK1382_1E_L      0x13823C
#define REG_BK1382_1E_H      0x13823D
#define REG_BK1382_1F_L      0x13823E
#define REG_BK1382_1F_H      0x13823F
#define REG_BK1382_20_L      0x138240
#define REG_BK1382_20_H      0x138241
#define REG_BK1382_21_L      0x138242
#define REG_BK1382_21_H      0x138243
#define REG_BK1382_22_L      0x138244
#define REG_BK1382_22_H      0x138245
#define REG_BK1382_23_L      0x138246
#define REG_BK1382_23_H      0x138247
#define REG_BK1382_24_L      0x138248
#define REG_BK1382_24_H      0x138249
#define REG_BK1382_25_L      0x13824A
#define REG_BK1382_25_H      0x13824B
#define REG_BK1382_26_L      0x13824C
#define REG_BK1382_26_H      0x13824D
#define REG_BK1382_27_L      0x13824E
#define REG_BK1382_27_H      0x13824F
#define REG_BK1382_28_L      0x138250
#define REG_BK1382_28_H      0x138251
#define REG_BK1382_29_L      0x138252
#define REG_BK1382_29_H      0x138253
#define REG_BK1382_2A_L      0x138254
#define REG_BK1382_2A_H      0x138255
#define REG_BK1382_2B_L      0x138256
#define REG_BK1382_2B_H      0x138257
#define REG_BK1382_2C_L      0x138258
#define REG_BK1382_2C_H      0x138259
#define REG_BK1382_2D_L      0x13825A
#define REG_BK1382_2D_H      0x13825B
#define REG_BK1382_2E_L      0x13825C
#define REG_BK1382_2E_H      0x13825D
#define REG_BK1382_2F_L      0x13825E
#define REG_BK1382_2F_H      0x13825F
#define REG_BK1382_30_L      0x138260
#define REG_BK1382_30_H      0x138261
#define REG_BK1382_31_L      0x138262
#define REG_BK1382_31_H      0x138263
#define REG_BK1382_32_L      0x138264
#define REG_BK1382_32_H      0x138265
#define REG_BK1382_33_L      0x138266
#define REG_BK1382_33_H      0x138267
#define REG_BK1382_34_L      0x138268
#define REG_BK1382_34_H      0x138269
#define REG_BK1382_35_L      0x13826A
#define REG_BK1382_35_H      0x13826B
#define REG_BK1382_36_L      0x13826C
#define REG_BK1382_36_H      0x13826D
#define REG_BK1382_37_L      0x13826E
#define REG_BK1382_37_H      0x13826F
#define REG_BK1382_38_L      0x138270
#define REG_BK1382_38_H      0x138271
#define REG_BK1382_39_L      0x138272
#define REG_BK1382_39_H      0x138273
#define REG_BK1382_3A_L      0x138274
#define REG_BK1382_3A_H      0x138275
#define REG_BK1382_3B_L      0x138276
#define REG_BK1382_3B_H      0x138277
#define REG_BK1382_3C_L      0x138278
#define REG_BK1382_3C_H      0x138279
#define REG_BK1382_3D_L      0x13827A
#define REG_BK1382_3D_H      0x13827B
#define REG_BK1382_3E_L      0x13827C
#define REG_BK1382_3E_H      0x13827D
#define REG_BK1382_3F_L      0x13827E
#define REG_BK1382_3F_H      0x13827F
#define REG_BK1382_40_L      0x138280
#define REG_BK1382_40_H      0x138281
#define REG_BK1382_41_L      0x138282
#define REG_BK1382_41_H      0x138283
#define REG_BK1382_42_L      0x138284
#define REG_BK1382_42_H      0x138285
#define REG_BK1382_43_L      0x138286
#define REG_BK1382_43_H      0x138287
#define REG_BK1382_44_L      0x138288
#define REG_BK1382_44_H      0x138289
#define REG_BK1382_45_L      0x13828A
#define REG_BK1382_45_H      0x13828B
#define REG_BK1382_46_L      0x13828C
#define REG_BK1382_46_H      0x13828D
#define REG_BK1382_47_L      0x13828E
#define REG_BK1382_47_H      0x13828F
#define REG_BK1382_48_L      0x138290
#define REG_BK1382_48_H      0x138291
#define REG_BK1382_49_L      0x138292
#define REG_BK1382_49_H      0x138293
#define REG_BK1382_4A_L      0x138294
#define REG_BK1382_4A_H      0x138295
#define REG_BK1382_4B_L      0x138296
#define REG_BK1382_4B_H      0x138297
#define REG_BK1382_4C_L      0x138298
#define REG_BK1382_4C_H      0x138299
#define REG_BK1382_4D_L      0x13829A
#define REG_BK1382_4D_H      0x13829B
#define REG_BK1382_4E_L      0x13829C
#define REG_BK1382_4E_H      0x13829D
#define REG_BK1382_4F_L      0x13829E
#define REG_BK1382_4F_H      0x13829F
#define REG_BK1382_50_L      0x1382A0
#define REG_BK1382_50_H      0x1382A1
#define REG_BK1382_51_L      0x1382A2
#define REG_BK1382_51_H      0x1382A3
#define REG_BK1382_52_L      0x1382A4
#define REG_BK1382_52_H      0x1382A5
#define REG_BK1382_53_L      0x1382A6
#define REG_BK1382_53_H      0x1382A7
#define REG_BK1382_54_L      0x1382A8
#define REG_BK1382_54_H      0x1382A9
#define REG_BK1382_55_L      0x1382AA
#define REG_BK1382_55_H      0x1382AB
#define REG_BK1382_56_L      0x1382AC
#define REG_BK1382_56_H      0x1382AD
#define REG_BK1382_57_L      0x1382AE
#define REG_BK1382_57_H      0x1382AF
#define REG_BK1382_58_L      0x1382B0
#define REG_BK1382_58_H      0x1382B1
#define REG_BK1382_59_L      0x1382B2
#define REG_BK1382_59_H      0x1382B3
#define REG_BK1382_5A_L      0x1382B4
#define REG_BK1382_5A_H      0x1382B5
#define REG_BK1382_5B_L      0x1382B6
#define REG_BK1382_5B_H      0x1382B7
#define REG_BK1382_5C_L      0x1382B8
#define REG_BK1382_5C_H      0x1382B9
#define REG_BK1382_5D_L      0x1382BA
#define REG_BK1382_5D_H      0x1382BB
#define REG_BK1382_5E_L      0x1382BC
#define REG_BK1382_5E_H      0x1382BD
#define REG_BK1382_5F_L      0x1382BE
#define REG_BK1382_5F_H      0x1382BF
#define REG_BK1382_60_L      0x1382C0
#define REG_BK1382_60_H      0x1382C1
#define REG_BK1382_61_L      0x1382C2
#define REG_BK1382_61_H      0x1382C3
#define REG_BK1382_62_L      0x1382C4
#define REG_BK1382_62_H      0x1382C5
#define REG_BK1382_63_L      0x1382C6
#define REG_BK1382_63_H      0x1382C7
#define REG_BK1382_64_L      0x1382C8
#define REG_BK1382_64_H      0x1382C9
#define REG_BK1382_65_L      0x1382CA
#define REG_BK1382_65_H      0x1382CB
#define REG_BK1382_66_L      0x1382CC
#define REG_BK1382_66_H      0x1382CD
#define REG_BK1382_67_L      0x1382CE
#define REG_BK1382_67_H      0x1382CF
#define REG_BK1382_68_L      0x1382D0
#define REG_BK1382_68_H      0x1382D1
#define REG_BK1382_69_L      0x1382D2
#define REG_BK1382_69_H      0x1382D3
#define REG_BK1382_6A_L      0x1382D4
#define REG_BK1382_6A_H      0x1382D5
#define REG_BK1382_6B_L      0x1382D6
#define REG_BK1382_6B_H      0x1382D7
#define REG_BK1382_6C_L      0x1382D8
#define REG_BK1382_6C_H      0x1382D9
#define REG_BK1382_6D_L      0x1382DA
#define REG_BK1382_6D_H      0x1382DB
#define REG_BK1382_6E_L      0x1382DC
#define REG_BK1382_6E_H      0x1382DD
#define REG_BK1382_6F_L      0x1382DE
#define REG_BK1382_6F_H      0x1382DF
#define REG_BK1382_70_L      0x1382E0
#define REG_BK1382_70_H      0x1382E1
#define REG_BK1382_71_L      0x1382E2
#define REG_BK1382_71_H      0x1382E3
#define REG_BK1382_72_L      0x1382E4
#define REG_BK1382_72_H      0x1382E5
#define REG_BK1382_73_L      0x1382E6
#define REG_BK1382_73_H      0x1382E7
#define REG_BK1382_74_L      0x1382E8
#define REG_BK1382_74_H      0x1382E9
#define REG_BK1382_75_L      0x1382EA
#define REG_BK1382_75_H      0x1382EB
#define REG_BK1382_76_L      0x1382EC
#define REG_BK1382_76_H      0x1382ED
#define REG_BK1382_77_L      0x1382EE
#define REG_BK1382_77_H      0x1382EF
#define REG_BK1382_78_L      0x1382F0
#define REG_BK1382_78_H      0x1382F1
#define REG_BK1382_79_L      0x1382F2
#define REG_BK1382_79_H      0x1382F3
#define REG_BK1382_7A_L      0x1382F4
#define REG_BK1382_7A_H      0x1382F5
#define REG_BK1382_7B_L      0x1382F6
#define REG_BK1382_7B_H      0x1382F7
#define REG_BK1382_7C_L      0x1382F8
#define REG_BK1382_7C_H      0x1382F9
#define REG_BK1382_7D_L      0x1382FA
#define REG_BK1382_7D_H      0x1382FB
#define REG_BK1382_7E_L      0x1382FC
#define REG_BK1382_7E_H      0x1382FD
#define REG_BK1382_7F_L      0x1382FE
#define REG_BK1382_7F_H      0x1382FF
//----------------------------------------------
#define REG_BK1383_00_L      0x138300
#define REG_BK1383_00_H      0x138301
#define REG_BK1383_01_L      0x138302
#define REG_BK1383_01_H      0x138303
#define REG_BK1383_02_L      0x138304
#define REG_BK1383_02_H      0x138305
#define REG_BK1383_03_L      0x138306
#define REG_BK1383_03_H      0x138307
#define REG_BK1383_04_L      0x138308
#define REG_BK1383_04_H      0x138309
#define REG_BK1383_05_L      0x13830A
#define REG_BK1383_05_H      0x13830B
#define REG_BK1383_06_L      0x13830C
#define REG_BK1383_06_H      0x13830D
#define REG_BK1383_07_L      0x13830E
#define REG_BK1383_07_H      0x13830F
#define REG_BK1383_08_L      0x138310
#define REG_BK1383_08_H      0x138311
#define REG_BK1383_09_L      0x138312
#define REG_BK1383_09_H      0x138313
#define REG_BK1383_0A_L      0x138314
#define REG_BK1383_0A_H      0x138315
#define REG_BK1383_0B_L      0x138316
#define REG_BK1383_0B_H      0x138317
#define REG_BK1383_0C_L      0x138318
#define REG_BK1383_0C_H      0x138319
#define REG_BK1383_0D_L      0x13831A
#define REG_BK1383_0D_H      0x13831B
#define REG_BK1383_0E_L      0x13831C
#define REG_BK1383_0E_H      0x13831D
#define REG_BK1383_0F_L      0x13831E
#define REG_BK1383_0F_H      0x13831F
#define REG_BK1383_10_L      0x138320
#define REG_BK1383_10_H      0x138321
#define REG_BK1383_11_L      0x138322
#define REG_BK1383_11_H      0x138323
#define REG_BK1383_12_L      0x138324
#define REG_BK1383_12_H      0x138325
#define REG_BK1383_13_L      0x138326
#define REG_BK1383_13_H      0x138327
#define REG_BK1383_14_L      0x138328
#define REG_BK1383_14_H      0x138329
#define REG_BK1383_15_L      0x13832A
#define REG_BK1383_15_H      0x13832B
#define REG_BK1383_16_L      0x13832C
#define REG_BK1383_16_H      0x13832D
#define REG_BK1383_17_L      0x13832E
#define REG_BK1383_17_H      0x13832F
#define REG_BK1383_18_L      0x138330
#define REG_BK1383_18_H      0x138331
#define REG_BK1383_19_L      0x138332
#define REG_BK1383_19_H      0x138333
#define REG_BK1383_1A_L      0x138334
#define REG_BK1383_1A_H      0x138335
#define REG_BK1383_1B_L      0x138336
#define REG_BK1383_1B_H      0x138337
#define REG_BK1383_1C_L      0x138338
#define REG_BK1383_1C_H      0x138339
#define REG_BK1383_1D_L      0x13833A
#define REG_BK1383_1D_H      0x13833B
#define REG_BK1383_1E_L      0x13833C
#define REG_BK1383_1E_H      0x13833D
#define REG_BK1383_1F_L      0x13833E
#define REG_BK1383_1F_H      0x13833F
#define REG_BK1383_20_L      0x138340
#define REG_BK1383_20_H      0x138341
#define REG_BK1383_21_L      0x138342
#define REG_BK1383_21_H      0x138343
#define REG_BK1383_22_L      0x138344
#define REG_BK1383_22_H      0x138345
#define REG_BK1383_23_L      0x138346
#define REG_BK1383_23_H      0x138347
#define REG_BK1383_24_L      0x138348
#define REG_BK1383_24_H      0x138349
#define REG_BK1383_25_L      0x13834A
#define REG_BK1383_25_H      0x13834B
#define REG_BK1383_26_L      0x13834C
#define REG_BK1383_26_H      0x13834D
#define REG_BK1383_27_L      0x13834E
#define REG_BK1383_27_H      0x13834F
#define REG_BK1383_28_L      0x138350
#define REG_BK1383_28_H      0x138351
#define REG_BK1383_29_L      0x138352
#define REG_BK1383_29_H      0x138353
#define REG_BK1383_2A_L      0x138354
#define REG_BK1383_2A_H      0x138355
#define REG_BK1383_2B_L      0x138356
#define REG_BK1383_2B_H      0x138357
#define REG_BK1383_2C_L      0x138358
#define REG_BK1383_2C_H      0x138359
#define REG_BK1383_2D_L      0x13835A
#define REG_BK1383_2D_H      0x13835B
#define REG_BK1383_2E_L      0x13835C
#define REG_BK1383_2E_H      0x13835D
#define REG_BK1383_2F_L      0x13835E
#define REG_BK1383_2F_H      0x13835F
#define REG_BK1383_30_L      0x138360
#define REG_BK1383_30_H      0x138361
#define REG_BK1383_31_L      0x138362
#define REG_BK1383_31_H      0x138363
#define REG_BK1383_32_L      0x138364
#define REG_BK1383_32_H      0x138365
#define REG_BK1383_33_L      0x138366
#define REG_BK1383_33_H      0x138367
#define REG_BK1383_34_L      0x138368
#define REG_BK1383_34_H      0x138369
#define REG_BK1383_35_L      0x13836A
#define REG_BK1383_35_H      0x13836B
#define REG_BK1383_36_L      0x13836C
#define REG_BK1383_36_H      0x13836D
#define REG_BK1383_37_L      0x13836E
#define REG_BK1383_37_H      0x13836F
#define REG_BK1383_38_L      0x138370
#define REG_BK1383_38_H      0x138371
#define REG_BK1383_39_L      0x138372
#define REG_BK1383_39_H      0x138373
#define REG_BK1383_3A_L      0x138374
#define REG_BK1383_3A_H      0x138375
#define REG_BK1383_3B_L      0x138376
#define REG_BK1383_3B_H      0x138377
#define REG_BK1383_3C_L      0x138378
#define REG_BK1383_3C_H      0x138379
#define REG_BK1383_3D_L      0x13837A
#define REG_BK1383_3D_H      0x13837B
#define REG_BK1383_3E_L      0x13837C
#define REG_BK1383_3E_H      0x13837D
#define REG_BK1383_3F_L      0x13837E
#define REG_BK1383_3F_H      0x13837F
#define REG_BK1383_40_L      0x138380
#define REG_BK1383_40_H      0x138381
#define REG_BK1383_41_L      0x138382
#define REG_BK1383_41_H      0x138383
#define REG_BK1383_42_L      0x138384
#define REG_BK1383_42_H      0x138385
#define REG_BK1383_43_L      0x138386
#define REG_BK1383_43_H      0x138387
#define REG_BK1383_44_L      0x138388
#define REG_BK1383_44_H      0x138389
#define REG_BK1383_45_L      0x13838A
#define REG_BK1383_45_H      0x13838B
#define REG_BK1383_46_L      0x13838C
#define REG_BK1383_46_H      0x13838D
#define REG_BK1383_47_L      0x13838E
#define REG_BK1383_47_H      0x13838F
#define REG_BK1383_48_L      0x138390
#define REG_BK1383_48_H      0x138391
#define REG_BK1383_49_L      0x138392
#define REG_BK1383_49_H      0x138393
#define REG_BK1383_4A_L      0x138394
#define REG_BK1383_4A_H      0x138395
#define REG_BK1383_4B_L      0x138396
#define REG_BK1383_4B_H      0x138397
#define REG_BK1383_4C_L      0x138398
#define REG_BK1383_4C_H      0x138399
#define REG_BK1383_4D_L      0x13839A
#define REG_BK1383_4D_H      0x13839B
#define REG_BK1383_4E_L      0x13839C
#define REG_BK1383_4E_H      0x13839D
#define REG_BK1383_4F_L      0x13839E
#define REG_BK1383_4F_H      0x13839F
#define REG_BK1383_50_L      0x1383A0
#define REG_BK1383_50_H      0x1383A1
#define REG_BK1383_51_L      0x1383A2
#define REG_BK1383_51_H      0x1383A3
#define REG_BK1383_52_L      0x1383A4
#define REG_BK1383_52_H      0x1383A5
#define REG_BK1383_53_L      0x1383A6
#define REG_BK1383_53_H      0x1383A7
#define REG_BK1383_54_L      0x1383A8
#define REG_BK1383_54_H      0x1383A9
#define REG_BK1383_55_L      0x1383AA
#define REG_BK1383_55_H      0x1383AB
#define REG_BK1383_56_L      0x1383AC
#define REG_BK1383_56_H      0x1383AD
#define REG_BK1383_57_L      0x1383AE
#define REG_BK1383_57_H      0x1383AF
#define REG_BK1383_58_L      0x1383B0
#define REG_BK1383_58_H      0x1383B1
#define REG_BK1383_59_L      0x1383B2
#define REG_BK1383_59_H      0x1383B3
#define REG_BK1383_5A_L      0x1383B4
#define REG_BK1383_5A_H      0x1383B5
#define REG_BK1383_5B_L      0x1383B6
#define REG_BK1383_5B_H      0x1383B7
#define REG_BK1383_5C_L      0x1383B8
#define REG_BK1383_5C_H      0x1383B9
#define REG_BK1383_5D_L      0x1383BA
#define REG_BK1383_5D_H      0x1383BB
#define REG_BK1383_5E_L      0x1383BC
#define REG_BK1383_5E_H      0x1383BD
#define REG_BK1383_5F_L      0x1383BE
#define REG_BK1383_5F_H      0x1383BF
#define REG_BK1383_60_L      0x1383C0
#define REG_BK1383_60_H      0x1383C1
#define REG_BK1383_61_L      0x1383C2
#define REG_BK1383_61_H      0x1383C3
#define REG_BK1383_62_L      0x1383C4
#define REG_BK1383_62_H      0x1383C5
#define REG_BK1383_63_L      0x1383C6
#define REG_BK1383_63_H      0x1383C7
#define REG_BK1383_64_L      0x1383C8
#define REG_BK1383_64_H      0x1383C9
#define REG_BK1383_65_L      0x1383CA
#define REG_BK1383_65_H      0x1383CB
#define REG_BK1383_66_L      0x1383CC
#define REG_BK1383_66_H      0x1383CD
#define REG_BK1383_67_L      0x1383CE
#define REG_BK1383_67_H      0x1383CF
#define REG_BK1383_68_L      0x1383D0
#define REG_BK1383_68_H      0x1383D1
#define REG_BK1383_69_L      0x1383D2
#define REG_BK1383_69_H      0x1383D3
#define REG_BK1383_6A_L      0x1383D4
#define REG_BK1383_6A_H      0x1383D5
#define REG_BK1383_6B_L      0x1383D6
#define REG_BK1383_6B_H      0x1383D7
#define REG_BK1383_6C_L      0x1383D8
#define REG_BK1383_6C_H      0x1383D9
#define REG_BK1383_6D_L      0x1383DA
#define REG_BK1383_6D_H      0x1383DB
#define REG_BK1383_6E_L      0x1383DC
#define REG_BK1383_6E_H      0x1383DD
#define REG_BK1383_6F_L      0x1383DE
#define REG_BK1383_6F_H      0x1383DF
#define REG_BK1383_70_L      0x1383E0
#define REG_BK1383_70_H      0x1383E1
#define REG_BK1383_71_L      0x1383E2
#define REG_BK1383_71_H      0x1383E3
#define REG_BK1383_72_L      0x1383E4
#define REG_BK1383_72_H      0x1383E5
#define REG_BK1383_73_L      0x1383E6
#define REG_BK1383_73_H      0x1383E7
#define REG_BK1383_74_L      0x1383E8
#define REG_BK1383_74_H      0x1383E9
#define REG_BK1383_75_L      0x1383EA
#define REG_BK1383_75_H      0x1383EB
#define REG_BK1383_76_L      0x1383EC
#define REG_BK1383_76_H      0x1383ED
#define REG_BK1383_77_L      0x1383EE
#define REG_BK1383_77_H      0x1383EF
#define REG_BK1383_78_L      0x1383F0
#define REG_BK1383_78_H      0x1383F1
#define REG_BK1383_79_L      0x1383F2
#define REG_BK1383_79_H      0x1383F3
#define REG_BK1383_7A_L      0x1383F4
#define REG_BK1383_7A_H      0x1383F5
#define REG_BK1383_7B_L      0x1383F6
#define REG_BK1383_7B_H      0x1383F7
#define REG_BK1383_7C_L      0x1383F8
#define REG_BK1383_7C_H      0x1383F9
#define REG_BK1383_7D_L      0x1383FA
#define REG_BK1383_7D_H      0x1383FB
#define REG_BK1383_7E_L      0x1383FC
#define REG_BK1383_7E_H      0x1383FD
#define REG_BK1383_7F_L      0x1383FE
#define REG_BK1383_7F_H      0x1383FF
//----------------------------------------------
#define REG_BK1384_00_L      0x138400
#define REG_BK1384_00_H      0x138401
#define REG_BK1384_01_L      0x138402
#define REG_BK1384_01_H      0x138403
#define REG_BK1384_02_L      0x138404
#define REG_BK1384_02_H      0x138405
#define REG_BK1384_03_L      0x138406
#define REG_BK1384_03_H      0x138407
#define REG_BK1384_04_L      0x138408
#define REG_BK1384_04_H      0x138409
#define REG_BK1384_05_L      0x13840A
#define REG_BK1384_05_H      0x13840B
#define REG_BK1384_06_L      0x13840C
#define REG_BK1384_06_H      0x13840D
#define REG_BK1384_07_L      0x13840E
#define REG_BK1384_07_H      0x13840F
#define REG_BK1384_08_L      0x138410
#define REG_BK1384_08_H      0x138411
#define REG_BK1384_09_L      0x138412
#define REG_BK1384_09_H      0x138413
#define REG_BK1384_0A_L      0x138414
#define REG_BK1384_0A_H      0x138415
#define REG_BK1384_0B_L      0x138416
#define REG_BK1384_0B_H      0x138417
#define REG_BK1384_0C_L      0x138418
#define REG_BK1384_0C_H      0x138419
#define REG_BK1384_0D_L      0x13841A
#define REG_BK1384_0D_H      0x13841B
#define REG_BK1384_0E_L      0x13841C
#define REG_BK1384_0E_H      0x13841D
#define REG_BK1384_0F_L      0x13841E
#define REG_BK1384_0F_H      0x13841F
#define REG_BK1384_10_L      0x138420
#define REG_BK1384_10_H      0x138421
#define REG_BK1384_11_L      0x138422
#define REG_BK1384_11_H      0x138423
#define REG_BK1384_12_L      0x138424
#define REG_BK1384_12_H      0x138425
#define REG_BK1384_13_L      0x138426
#define REG_BK1384_13_H      0x138427
#define REG_BK1384_14_L      0x138428
#define REG_BK1384_14_H      0x138429
#define REG_BK1384_15_L      0x13842A
#define REG_BK1384_15_H      0x13842B
#define REG_BK1384_16_L      0x13842C
#define REG_BK1384_16_H      0x13842D
#define REG_BK1384_17_L      0x13842E
#define REG_BK1384_17_H      0x13842F
#define REG_BK1384_18_L      0x138430
#define REG_BK1384_18_H      0x138431
#define REG_BK1384_19_L      0x138432
#define REG_BK1384_19_H      0x138433
#define REG_BK1384_1A_L      0x138434
#define REG_BK1384_1A_H      0x138435
#define REG_BK1384_1B_L      0x138436
#define REG_BK1384_1B_H      0x138437
#define REG_BK1384_1C_L      0x138438
#define REG_BK1384_1C_H      0x138439
#define REG_BK1384_1D_L      0x13843A
#define REG_BK1384_1D_H      0x13843B
#define REG_BK1384_1E_L      0x13843C
#define REG_BK1384_1E_H      0x13843D
#define REG_BK1384_1F_L      0x13843E
#define REG_BK1384_1F_H      0x13843F
#define REG_BK1384_20_L      0x138440
#define REG_BK1384_20_H      0x138441
#define REG_BK1384_21_L      0x138442
#define REG_BK1384_21_H      0x138443
#define REG_BK1384_22_L      0x138444
#define REG_BK1384_22_H      0x138445
#define REG_BK1384_23_L      0x138446
#define REG_BK1384_23_H      0x138447
#define REG_BK1384_24_L      0x138448
#define REG_BK1384_24_H      0x138449
#define REG_BK1384_25_L      0x13844A
#define REG_BK1384_25_H      0x13844B
#define REG_BK1384_26_L      0x13844C
#define REG_BK1384_26_H      0x13844D
#define REG_BK1384_27_L      0x13844E
#define REG_BK1384_27_H      0x13844F
#define REG_BK1384_28_L      0x138450
#define REG_BK1384_28_H      0x138451
#define REG_BK1384_29_L      0x138452
#define REG_BK1384_29_H      0x138453
#define REG_BK1384_2A_L      0x138454
#define REG_BK1384_2A_H      0x138455
#define REG_BK1384_2B_L      0x138456
#define REG_BK1384_2B_H      0x138457
#define REG_BK1384_2C_L      0x138458
#define REG_BK1384_2C_H      0x138459
#define REG_BK1384_2D_L      0x13845A
#define REG_BK1384_2D_H      0x13845B
#define REG_BK1384_2E_L      0x13845C
#define REG_BK1384_2E_H      0x13845D
#define REG_BK1384_2F_L      0x13845E
#define REG_BK1384_2F_H      0x13845F
#define REG_BK1384_30_L      0x138460
#define REG_BK1384_30_H      0x138461
#define REG_BK1384_31_L      0x138462
#define REG_BK1384_31_H      0x138463
#define REG_BK1384_32_L      0x138464
#define REG_BK1384_32_H      0x138465
#define REG_BK1384_33_L      0x138466
#define REG_BK1384_33_H      0x138467
#define REG_BK1384_34_L      0x138468
#define REG_BK1384_34_H      0x138469
#define REG_BK1384_35_L      0x13846A
#define REG_BK1384_35_H      0x13846B
#define REG_BK1384_36_L      0x13846C
#define REG_BK1384_36_H      0x13846D
#define REG_BK1384_37_L      0x13846E
#define REG_BK1384_37_H      0x13846F
#define REG_BK1384_38_L      0x138470
#define REG_BK1384_38_H      0x138471
#define REG_BK1384_39_L      0x138472
#define REG_BK1384_39_H      0x138473
#define REG_BK1384_3A_L      0x138474
#define REG_BK1384_3A_H      0x138475
#define REG_BK1384_3B_L      0x138476
#define REG_BK1384_3B_H      0x138477
#define REG_BK1384_3C_L      0x138478
#define REG_BK1384_3C_H      0x138479
#define REG_BK1384_3D_L      0x13847A
#define REG_BK1384_3D_H      0x13847B
#define REG_BK1384_3E_L      0x13847C
#define REG_BK1384_3E_H      0x13847D
#define REG_BK1384_3F_L      0x13847E
#define REG_BK1384_3F_H      0x13847F
#define REG_BK1384_40_L      0x138480
#define REG_BK1384_40_H      0x138481
#define REG_BK1384_41_L      0x138482
#define REG_BK1384_41_H      0x138483
#define REG_BK1384_42_L      0x138484
#define REG_BK1384_42_H      0x138485
#define REG_BK1384_43_L      0x138486
#define REG_BK1384_43_H      0x138487
#define REG_BK1384_44_L      0x138488
#define REG_BK1384_44_H      0x138489
#define REG_BK1384_45_L      0x13848A
#define REG_BK1384_45_H      0x13848B
#define REG_BK1384_46_L      0x13848C
#define REG_BK1384_46_H      0x13848D
#define REG_BK1384_47_L      0x13848E
#define REG_BK1384_47_H      0x13848F
#define REG_BK1384_48_L      0x138490
#define REG_BK1384_48_H      0x138491
#define REG_BK1384_49_L      0x138492
#define REG_BK1384_49_H      0x138493
#define REG_BK1384_4A_L      0x138494
#define REG_BK1384_4A_H      0x138495
#define REG_BK1384_4B_L      0x138496
#define REG_BK1384_4B_H      0x138497
#define REG_BK1384_4C_L      0x138498
#define REG_BK1384_4C_H      0x138499
#define REG_BK1384_4D_L      0x13849A
#define REG_BK1384_4D_H      0x13849B
#define REG_BK1384_4E_L      0x13849C
#define REG_BK1384_4E_H      0x13849D
#define REG_BK1384_4F_L      0x13849E
#define REG_BK1384_4F_H      0x13849F
#define REG_BK1384_50_L      0x1384A0
#define REG_BK1384_50_H      0x1384A1
#define REG_BK1384_51_L      0x1384A2
#define REG_BK1384_51_H      0x1384A3
#define REG_BK1384_52_L      0x1384A4
#define REG_BK1384_52_H      0x1384A5
#define REG_BK1384_53_L      0x1384A6
#define REG_BK1384_53_H      0x1384A7
#define REG_BK1384_54_L      0x1384A8
#define REG_BK1384_54_H      0x1384A9
#define REG_BK1384_55_L      0x1384AA
#define REG_BK1384_55_H      0x1384AB
#define REG_BK1384_56_L      0x1384AC
#define REG_BK1384_56_H      0x1384AD
#define REG_BK1384_57_L      0x1384AE
#define REG_BK1384_57_H      0x1384AF
#define REG_BK1384_58_L      0x1384B0
#define REG_BK1384_58_H      0x1384B1
#define REG_BK1384_59_L      0x1384B2
#define REG_BK1384_59_H      0x1384B3
#define REG_BK1384_5A_L      0x1384B4
#define REG_BK1384_5A_H      0x1384B5
#define REG_BK1384_5B_L      0x1384B6
#define REG_BK1384_5B_H      0x1384B7
#define REG_BK1384_5C_L      0x1384B8
#define REG_BK1384_5C_H      0x1384B9
#define REG_BK1384_5D_L      0x1384BA
#define REG_BK1384_5D_H      0x1384BB
#define REG_BK1384_5E_L      0x1384BC
#define REG_BK1384_5E_H      0x1384BD
#define REG_BK1384_5F_L      0x1384BE
#define REG_BK1384_5F_H      0x1384BF
#define REG_BK1384_60_L      0x1384C0
#define REG_BK1384_60_H      0x1384C1
#define REG_BK1384_61_L      0x1384C2
#define REG_BK1384_61_H      0x1384C3
#define REG_BK1384_62_L      0x1384C4
#define REG_BK1384_62_H      0x1384C5
#define REG_BK1384_63_L      0x1384C6
#define REG_BK1384_63_H      0x1384C7
#define REG_BK1384_64_L      0x1384C8
#define REG_BK1384_64_H      0x1384C9
#define REG_BK1384_65_L      0x1384CA
#define REG_BK1384_65_H      0x1384CB
#define REG_BK1384_66_L      0x1384CC
#define REG_BK1384_66_H      0x1384CD
#define REG_BK1384_67_L      0x1384CE
#define REG_BK1384_67_H      0x1384CF
#define REG_BK1384_68_L      0x1384D0
#define REG_BK1384_68_H      0x1384D1
#define REG_BK1384_69_L      0x1384D2
#define REG_BK1384_69_H      0x1384D3
#define REG_BK1384_6A_L      0x1384D4
#define REG_BK1384_6A_H      0x1384D5
#define REG_BK1384_6B_L      0x1384D6
#define REG_BK1384_6B_H      0x1384D7
#define REG_BK1384_6C_L      0x1384D8
#define REG_BK1384_6C_H      0x1384D9
#define REG_BK1384_6D_L      0x1384DA
#define REG_BK1384_6D_H      0x1384DB
#define REG_BK1384_6E_L      0x1384DC
#define REG_BK1384_6E_H      0x1384DD
#define REG_BK1384_6F_L      0x1384DE
#define REG_BK1384_6F_H      0x1384DF
#define REG_BK1384_70_L      0x1384E0
#define REG_BK1384_70_H      0x1384E1
#define REG_BK1384_71_L      0x1384E2
#define REG_BK1384_71_H      0x1384E3
#define REG_BK1384_72_L      0x1384E4
#define REG_BK1384_72_H      0x1384E5
#define REG_BK1384_73_L      0x1384E6
#define REG_BK1384_73_H      0x1384E7
#define REG_BK1384_74_L      0x1384E8
#define REG_BK1384_74_H      0x1384E9
#define REG_BK1384_75_L      0x1384EA
#define REG_BK1384_75_H      0x1384EB
#define REG_BK1384_76_L      0x1384EC
#define REG_BK1384_76_H      0x1384ED
#define REG_BK1384_77_L      0x1384EE
#define REG_BK1384_77_H      0x1384EF
#define REG_BK1384_78_L      0x1384F0
#define REG_BK1384_78_H      0x1384F1
#define REG_BK1384_79_L      0x1384F2
#define REG_BK1384_79_H      0x1384F3
#define REG_BK1384_7A_L      0x1384F4
#define REG_BK1384_7A_H      0x1384F5
#define REG_BK1384_7B_L      0x1384F6
#define REG_BK1384_7B_H      0x1384F7
#define REG_BK1384_7C_L      0x1384F8
#define REG_BK1384_7C_H      0x1384F9
#define REG_BK1384_7D_L      0x1384FA
#define REG_BK1384_7D_H      0x1384FB
#define REG_BK1384_7E_L      0x1384FC
#define REG_BK1384_7E_H      0x1384FD
#define REG_BK1384_7F_L      0x1384FE
#define REG_BK1384_7F_H      0x1384FF
//----------------------------------------------
#define REG_BK1385_00_L      0x138500
#define REG_BK1385_00_H      0x138501
#define REG_BK1385_01_L      0x138502
#define REG_BK1385_01_H      0x138503
#define REG_BK1385_02_L      0x138504
#define REG_BK1385_02_H      0x138505
#define REG_BK1385_03_L      0x138506
#define REG_BK1385_03_H      0x138507
#define REG_BK1385_04_L      0x138508
#define REG_BK1385_04_H      0x138509
#define REG_BK1385_05_L      0x13850A
#define REG_BK1385_05_H      0x13850B
#define REG_BK1385_06_L      0x13850C
#define REG_BK1385_06_H      0x13850D
#define REG_BK1385_07_L      0x13850E
#define REG_BK1385_07_H      0x13850F
#define REG_BK1385_08_L      0x138510
#define REG_BK1385_08_H      0x138511
#define REG_BK1385_09_L      0x138512
#define REG_BK1385_09_H      0x138513
#define REG_BK1385_0A_L      0x138514
#define REG_BK1385_0A_H      0x138515
#define REG_BK1385_0B_L      0x138516
#define REG_BK1385_0B_H      0x138517
#define REG_BK1385_0C_L      0x138518
#define REG_BK1385_0C_H      0x138519
#define REG_BK1385_0D_L      0x13851A
#define REG_BK1385_0D_H      0x13851B
#define REG_BK1385_0E_L      0x13851C
#define REG_BK1385_0E_H      0x13851D
#define REG_BK1385_0F_L      0x13851E
#define REG_BK1385_0F_H      0x13851F
#define REG_BK1385_10_L      0x138520
#define REG_BK1385_10_H      0x138521
#define REG_BK1385_11_L      0x138522
#define REG_BK1385_11_H      0x138523
#define REG_BK1385_12_L      0x138524
#define REG_BK1385_12_H      0x138525
#define REG_BK1385_13_L      0x138526
#define REG_BK1385_13_H      0x138527
#define REG_BK1385_14_L      0x138528
#define REG_BK1385_14_H      0x138529
#define REG_BK1385_15_L      0x13852A
#define REG_BK1385_15_H      0x13852B
#define REG_BK1385_16_L      0x13852C
#define REG_BK1385_16_H      0x13852D
#define REG_BK1385_17_L      0x13852E
#define REG_BK1385_17_H      0x13852F
#define REG_BK1385_18_L      0x138530
#define REG_BK1385_18_H      0x138531
#define REG_BK1385_19_L      0x138532
#define REG_BK1385_19_H      0x138533
#define REG_BK1385_1A_L      0x138534
#define REG_BK1385_1A_H      0x138535
#define REG_BK1385_1B_L      0x138536
#define REG_BK1385_1B_H      0x138537
#define REG_BK1385_1C_L      0x138538
#define REG_BK1385_1C_H      0x138539
#define REG_BK1385_1D_L      0x13853A
#define REG_BK1385_1D_H      0x13853B
#define REG_BK1385_1E_L      0x13853C
#define REG_BK1385_1E_H      0x13853D
#define REG_BK1385_1F_L      0x13853E
#define REG_BK1385_1F_H      0x13853F
#define REG_BK1385_20_L      0x138540
#define REG_BK1385_20_H      0x138541
#define REG_BK1385_21_L      0x138542
#define REG_BK1385_21_H      0x138543
#define REG_BK1385_22_L      0x138544
#define REG_BK1385_22_H      0x138545
#define REG_BK1385_23_L      0x138546
#define REG_BK1385_23_H      0x138547
#define REG_BK1385_24_L      0x138548
#define REG_BK1385_24_H      0x138549
#define REG_BK1385_25_L      0x13854A
#define REG_BK1385_25_H      0x13854B
#define REG_BK1385_26_L      0x13854C
#define REG_BK1385_26_H      0x13854D
#define REG_BK1385_27_L      0x13854E
#define REG_BK1385_27_H      0x13854F
#define REG_BK1385_28_L      0x138550
#define REG_BK1385_28_H      0x138551
#define REG_BK1385_29_L      0x138552
#define REG_BK1385_29_H      0x138553
#define REG_BK1385_2A_L      0x138554
#define REG_BK1385_2A_H      0x138555
#define REG_BK1385_2B_L      0x138556
#define REG_BK1385_2B_H      0x138557
#define REG_BK1385_2C_L      0x138558
#define REG_BK1385_2C_H      0x138559
#define REG_BK1385_2D_L      0x13855A
#define REG_BK1385_2D_H      0x13855B
#define REG_BK1385_2E_L      0x13855C
#define REG_BK1385_2E_H      0x13855D
#define REG_BK1385_2F_L      0x13855E
#define REG_BK1385_2F_H      0x13855F
#define REG_BK1385_30_L      0x138560
#define REG_BK1385_30_H      0x138561
#define REG_BK1385_31_L      0x138562
#define REG_BK1385_31_H      0x138563
#define REG_BK1385_32_L      0x138564
#define REG_BK1385_32_H      0x138565
#define REG_BK1385_33_L      0x138566
#define REG_BK1385_33_H      0x138567
#define REG_BK1385_34_L      0x138568
#define REG_BK1385_34_H      0x138569
#define REG_BK1385_35_L      0x13856A
#define REG_BK1385_35_H      0x13856B
#define REG_BK1385_36_L      0x13856C
#define REG_BK1385_36_H      0x13856D
#define REG_BK1385_37_L      0x13856E
#define REG_BK1385_37_H      0x13856F
#define REG_BK1385_38_L      0x138570
#define REG_BK1385_38_H      0x138571
#define REG_BK1385_39_L      0x138572
#define REG_BK1385_39_H      0x138573
#define REG_BK1385_3A_L      0x138574
#define REG_BK1385_3A_H      0x138575
#define REG_BK1385_3B_L      0x138576
#define REG_BK1385_3B_H      0x138577
#define REG_BK1385_3C_L      0x138578
#define REG_BK1385_3C_H      0x138579
#define REG_BK1385_3D_L      0x13857A
#define REG_BK1385_3D_H      0x13857B
#define REG_BK1385_3E_L      0x13857C
#define REG_BK1385_3E_H      0x13857D
#define REG_BK1385_3F_L      0x13857E
#define REG_BK1385_3F_H      0x13857F
#define REG_BK1385_40_L      0x138580
#define REG_BK1385_40_H      0x138581
#define REG_BK1385_41_L      0x138582
#define REG_BK1385_41_H      0x138583
#define REG_BK1385_42_L      0x138584
#define REG_BK1385_42_H      0x138585
#define REG_BK1385_43_L      0x138586
#define REG_BK1385_43_H      0x138587
#define REG_BK1385_44_L      0x138588
#define REG_BK1385_44_H      0x138589
#define REG_BK1385_45_L      0x13858A
#define REG_BK1385_45_H      0x13858B
#define REG_BK1385_46_L      0x13858C
#define REG_BK1385_46_H      0x13858D
#define REG_BK1385_47_L      0x13858E
#define REG_BK1385_47_H      0x13858F
#define REG_BK1385_48_L      0x138590
#define REG_BK1385_48_H      0x138591
#define REG_BK1385_49_L      0x138592
#define REG_BK1385_49_H      0x138593
#define REG_BK1385_4A_L      0x138594
#define REG_BK1385_4A_H      0x138595
#define REG_BK1385_4B_L      0x138596
#define REG_BK1385_4B_H      0x138597
#define REG_BK1385_4C_L      0x138598
#define REG_BK1385_4C_H      0x138599
#define REG_BK1385_4D_L      0x13859A
#define REG_BK1385_4D_H      0x13859B
#define REG_BK1385_4E_L      0x13859C
#define REG_BK1385_4E_H      0x13859D
#define REG_BK1385_4F_L      0x13859E
#define REG_BK1385_4F_H      0x13859F
#define REG_BK1385_50_L      0x1385A0
#define REG_BK1385_50_H      0x1385A1
#define REG_BK1385_51_L      0x1385A2
#define REG_BK1385_51_H      0x1385A3
#define REG_BK1385_52_L      0x1385A4
#define REG_BK1385_52_H      0x1385A5
#define REG_BK1385_53_L      0x1385A6
#define REG_BK1385_53_H      0x1385A7
#define REG_BK1385_54_L      0x1385A8
#define REG_BK1385_54_H      0x1385A9
#define REG_BK1385_55_L      0x1385AA
#define REG_BK1385_55_H      0x1385AB
#define REG_BK1385_56_L      0x1385AC
#define REG_BK1385_56_H      0x1385AD
#define REG_BK1385_57_L      0x1385AE
#define REG_BK1385_57_H      0x1385AF
#define REG_BK1385_58_L      0x1385B0
#define REG_BK1385_58_H      0x1385B1
#define REG_BK1385_59_L      0x1385B2
#define REG_BK1385_59_H      0x1385B3
#define REG_BK1385_5A_L      0x1385B4
#define REG_BK1385_5A_H      0x1385B5
#define REG_BK1385_5B_L      0x1385B6
#define REG_BK1385_5B_H      0x1385B7
#define REG_BK1385_5C_L      0x1385B8
#define REG_BK1385_5C_H      0x1385B9
#define REG_BK1385_5D_L      0x1385BA
#define REG_BK1385_5D_H      0x1385BB
#define REG_BK1385_5E_L      0x1385BC
#define REG_BK1385_5E_H      0x1385BD
#define REG_BK1385_5F_L      0x1385BE
#define REG_BK1385_5F_H      0x1385BF
#define REG_BK1385_60_L      0x1385C0
#define REG_BK1385_60_H      0x1385C1
#define REG_BK1385_61_L      0x1385C2
#define REG_BK1385_61_H      0x1385C3
#define REG_BK1385_62_L      0x1385C4
#define REG_BK1385_62_H      0x1385C5
#define REG_BK1385_63_L      0x1385C6
#define REG_BK1385_63_H      0x1385C7
#define REG_BK1385_64_L      0x1385C8
#define REG_BK1385_64_H      0x1385C9
#define REG_BK1385_65_L      0x1385CA
#define REG_BK1385_65_H      0x1385CB
#define REG_BK1385_66_L      0x1385CC
#define REG_BK1385_66_H      0x1385CD
#define REG_BK1385_67_L      0x1385CE
#define REG_BK1385_67_H      0x1385CF
#define REG_BK1385_68_L      0x1385D0
#define REG_BK1385_68_H      0x1385D1
#define REG_BK1385_69_L      0x1385D2
#define REG_BK1385_69_H      0x1385D3
#define REG_BK1385_6A_L      0x1385D4
#define REG_BK1385_6A_H      0x1385D5
#define REG_BK1385_6B_L      0x1385D6
#define REG_BK1385_6B_H      0x1385D7
#define REG_BK1385_6C_L      0x1385D8
#define REG_BK1385_6C_H      0x1385D9
#define REG_BK1385_6D_L      0x1385DA
#define REG_BK1385_6D_H      0x1385DB
#define REG_BK1385_6E_L      0x1385DC
#define REG_BK1385_6E_H      0x1385DD
#define REG_BK1385_6F_L      0x1385DE
#define REG_BK1385_6F_H      0x1385DF
#define REG_BK1385_70_L      0x1385E0
#define REG_BK1385_70_H      0x1385E1
#define REG_BK1385_71_L      0x1385E2
#define REG_BK1385_71_H      0x1385E3
#define REG_BK1385_72_L      0x1385E4
#define REG_BK1385_72_H      0x1385E5
#define REG_BK1385_73_L      0x1385E6
#define REG_BK1385_73_H      0x1385E7
#define REG_BK1385_74_L      0x1385E8
#define REG_BK1385_74_H      0x1385E9
#define REG_BK1385_75_L      0x1385EA
#define REG_BK1385_75_H      0x1385EB
#define REG_BK1385_76_L      0x1385EC
#define REG_BK1385_76_H      0x1385ED
#define REG_BK1385_77_L      0x1385EE
#define REG_BK1385_77_H      0x1385EF
#define REG_BK1385_78_L      0x1385F0
#define REG_BK1385_78_H      0x1385F1
#define REG_BK1385_79_L      0x1385F2
#define REG_BK1385_79_H      0x1385F3
#define REG_BK1385_7A_L      0x1385F4
#define REG_BK1385_7A_H      0x1385F5
#define REG_BK1385_7B_L      0x1385F6
#define REG_BK1385_7B_H      0x1385F7
#define REG_BK1385_7C_L      0x1385F8
#define REG_BK1385_7C_H      0x1385F9
#define REG_BK1385_7D_L      0x1385FA
#define REG_BK1385_7D_H      0x1385FB
#define REG_BK1385_7E_L      0x1385FC
#define REG_BK1385_7E_H      0x1385FD
#define REG_BK1385_7F_L      0x1385FE
#define REG_BK1385_7F_H      0x1385FF
//----------------------------------------------
#define REG_BK1386_00_L      0x138600
#define REG_BK1386_00_H      0x138601
#define REG_BK1386_01_L      0x138602
#define REG_BK1386_01_H      0x138603
#define REG_BK1386_02_L      0x138604
#define REG_BK1386_02_H      0x138605
#define REG_BK1386_03_L      0x138606
#define REG_BK1386_03_H      0x138607
#define REG_BK1386_04_L      0x138608
#define REG_BK1386_04_H      0x138609
#define REG_BK1386_05_L      0x13860A
#define REG_BK1386_05_H      0x13860B
#define REG_BK1386_06_L      0x13860C
#define REG_BK1386_06_H      0x13860D
#define REG_BK1386_07_L      0x13860E
#define REG_BK1386_07_H      0x13860F
#define REG_BK1386_08_L      0x138610
#define REG_BK1386_08_H      0x138611
#define REG_BK1386_09_L      0x138612
#define REG_BK1386_09_H      0x138613
#define REG_BK1386_0A_L      0x138614
#define REG_BK1386_0A_H      0x138615
#define REG_BK1386_0B_L      0x138616
#define REG_BK1386_0B_H      0x138617
#define REG_BK1386_0C_L      0x138618
#define REG_BK1386_0C_H      0x138619
#define REG_BK1386_0D_L      0x13861A
#define REG_BK1386_0D_H      0x13861B
#define REG_BK1386_0E_L      0x13861C
#define REG_BK1386_0E_H      0x13861D
#define REG_BK1386_0F_L      0x13861E
#define REG_BK1386_0F_H      0x13861F
#define REG_BK1386_10_L      0x138620
#define REG_BK1386_10_H      0x138621
#define REG_BK1386_11_L      0x138622
#define REG_BK1386_11_H      0x138623
#define REG_BK1386_12_L      0x138624
#define REG_BK1386_12_H      0x138625
#define REG_BK1386_13_L      0x138626
#define REG_BK1386_13_H      0x138627
#define REG_BK1386_14_L      0x138628
#define REG_BK1386_14_H      0x138629
#define REG_BK1386_15_L      0x13862A
#define REG_BK1386_15_H      0x13862B
#define REG_BK1386_16_L      0x13862C
#define REG_BK1386_16_H      0x13862D
#define REG_BK1386_17_L      0x13862E
#define REG_BK1386_17_H      0x13862F
#define REG_BK1386_18_L      0x138630
#define REG_BK1386_18_H      0x138631
#define REG_BK1386_19_L      0x138632
#define REG_BK1386_19_H      0x138633
#define REG_BK1386_1A_L      0x138634
#define REG_BK1386_1A_H      0x138635
#define REG_BK1386_1B_L      0x138636
#define REG_BK1386_1B_H      0x138637
#define REG_BK1386_1C_L      0x138638
#define REG_BK1386_1C_H      0x138639
#define REG_BK1386_1D_L      0x13863A
#define REG_BK1386_1D_H      0x13863B
#define REG_BK1386_1E_L      0x13863C
#define REG_BK1386_1E_H      0x13863D
#define REG_BK1386_1F_L      0x13863E
#define REG_BK1386_1F_H      0x13863F
#define REG_BK1386_20_L      0x138640
#define REG_BK1386_20_H      0x138641
#define REG_BK1386_21_L      0x138642
#define REG_BK1386_21_H      0x138643
#define REG_BK1386_22_L      0x138644
#define REG_BK1386_22_H      0x138645
#define REG_BK1386_23_L      0x138646
#define REG_BK1386_23_H      0x138647
#define REG_BK1386_24_L      0x138648
#define REG_BK1386_24_H      0x138649
#define REG_BK1386_25_L      0x13864A
#define REG_BK1386_25_H      0x13864B
#define REG_BK1386_26_L      0x13864C
#define REG_BK1386_26_H      0x13864D
#define REG_BK1386_27_L      0x13864E
#define REG_BK1386_27_H      0x13864F
#define REG_BK1386_28_L      0x138650
#define REG_BK1386_28_H      0x138651
#define REG_BK1386_29_L      0x138652
#define REG_BK1386_29_H      0x138653
#define REG_BK1386_2A_L      0x138654
#define REG_BK1386_2A_H      0x138655
#define REG_BK1386_2B_L      0x138656
#define REG_BK1386_2B_H      0x138657
#define REG_BK1386_2C_L      0x138658
#define REG_BK1386_2C_H      0x138659
#define REG_BK1386_2D_L      0x13865A
#define REG_BK1386_2D_H      0x13865B
#define REG_BK1386_2E_L      0x13865C
#define REG_BK1386_2E_H      0x13865D
#define REG_BK1386_2F_L      0x13865E
#define REG_BK1386_2F_H      0x13865F
#define REG_BK1386_30_L      0x138660
#define REG_BK1386_30_H      0x138661
#define REG_BK1386_31_L      0x138662
#define REG_BK1386_31_H      0x138663
#define REG_BK1386_32_L      0x138664
#define REG_BK1386_32_H      0x138665
#define REG_BK1386_33_L      0x138666
#define REG_BK1386_33_H      0x138667
#define REG_BK1386_34_L      0x138668
#define REG_BK1386_34_H      0x138669
#define REG_BK1386_35_L      0x13866A
#define REG_BK1386_35_H      0x13866B
#define REG_BK1386_36_L      0x13866C
#define REG_BK1386_36_H      0x13866D
#define REG_BK1386_37_L      0x13866E
#define REG_BK1386_37_H      0x13866F
#define REG_BK1386_38_L      0x138670
#define REG_BK1386_38_H      0x138671
#define REG_BK1386_39_L      0x138672
#define REG_BK1386_39_H      0x138673
#define REG_BK1386_3A_L      0x138674
#define REG_BK1386_3A_H      0x138675
#define REG_BK1386_3B_L      0x138676
#define REG_BK1386_3B_H      0x138677
#define REG_BK1386_3C_L      0x138678
#define REG_BK1386_3C_H      0x138679
#define REG_BK1386_3D_L      0x13867A
#define REG_BK1386_3D_H      0x13867B
#define REG_BK1386_3E_L      0x13867C
#define REG_BK1386_3E_H      0x13867D
#define REG_BK1386_3F_L      0x13867E
#define REG_BK1386_3F_H      0x13867F
#define REG_BK1386_40_L      0x138680
#define REG_BK1386_40_H      0x138681
#define REG_BK1386_41_L      0x138682
#define REG_BK1386_41_H      0x138683
#define REG_BK1386_42_L      0x138684
#define REG_BK1386_42_H      0x138685
#define REG_BK1386_43_L      0x138686
#define REG_BK1386_43_H      0x138687
#define REG_BK1386_44_L      0x138688
#define REG_BK1386_44_H      0x138689
#define REG_BK1386_45_L      0x13868A
#define REG_BK1386_45_H      0x13868B
#define REG_BK1386_46_L      0x13868C
#define REG_BK1386_46_H      0x13868D
#define REG_BK1386_47_L      0x13868E
#define REG_BK1386_47_H      0x13868F
#define REG_BK1386_48_L      0x138690
#define REG_BK1386_48_H      0x138691
#define REG_BK1386_49_L      0x138692
#define REG_BK1386_49_H      0x138693
#define REG_BK1386_4A_L      0x138694
#define REG_BK1386_4A_H      0x138695
#define REG_BK1386_4B_L      0x138696
#define REG_BK1386_4B_H      0x138697
#define REG_BK1386_4C_L      0x138698
#define REG_BK1386_4C_H      0x138699
#define REG_BK1386_4D_L      0x13869A
#define REG_BK1386_4D_H      0x13869B
#define REG_BK1386_4E_L      0x13869C
#define REG_BK1386_4E_H      0x13869D
#define REG_BK1386_4F_L      0x13869E
#define REG_BK1386_4F_H      0x13869F
#define REG_BK1386_50_L      0x1386A0
#define REG_BK1386_50_H      0x1386A1
#define REG_BK1386_51_L      0x1386A2
#define REG_BK1386_51_H      0x1386A3
#define REG_BK1386_52_L      0x1386A4
#define REG_BK1386_52_H      0x1386A5
#define REG_BK1386_53_L      0x1386A6
#define REG_BK1386_53_H      0x1386A7
#define REG_BK1386_54_L      0x1386A8
#define REG_BK1386_54_H      0x1386A9
#define REG_BK1386_55_L      0x1386AA
#define REG_BK1386_55_H      0x1386AB
#define REG_BK1386_56_L      0x1386AC
#define REG_BK1386_56_H      0x1386AD
#define REG_BK1386_57_L      0x1386AE
#define REG_BK1386_57_H      0x1386AF
#define REG_BK1386_58_L      0x1386B0
#define REG_BK1386_58_H      0x1386B1
#define REG_BK1386_59_L      0x1386B2
#define REG_BK1386_59_H      0x1386B3
#define REG_BK1386_5A_L      0x1386B4
#define REG_BK1386_5A_H      0x1386B5
#define REG_BK1386_5B_L      0x1386B6
#define REG_BK1386_5B_H      0x1386B7
#define REG_BK1386_5C_L      0x1386B8
#define REG_BK1386_5C_H      0x1386B9
#define REG_BK1386_5D_L      0x1386BA
#define REG_BK1386_5D_H      0x1386BB
#define REG_BK1386_5E_L      0x1386BC
#define REG_BK1386_5E_H      0x1386BD
#define REG_BK1386_5F_L      0x1386BE
#define REG_BK1386_5F_H      0x1386BF
#define REG_BK1386_60_L      0x1386C0
#define REG_BK1386_60_H      0x1386C1
#define REG_BK1386_61_L      0x1386C2
#define REG_BK1386_61_H      0x1386C3
#define REG_BK1386_62_L      0x1386C4
#define REG_BK1386_62_H      0x1386C5
#define REG_BK1386_63_L      0x1386C6
#define REG_BK1386_63_H      0x1386C7
#define REG_BK1386_64_L      0x1386C8
#define REG_BK1386_64_H      0x1386C9
#define REG_BK1386_65_L      0x1386CA
#define REG_BK1386_65_H      0x1386CB
#define REG_BK1386_66_L      0x1386CC
#define REG_BK1386_66_H      0x1386CD
#define REG_BK1386_67_L      0x1386CE
#define REG_BK1386_67_H      0x1386CF
#define REG_BK1386_68_L      0x1386D0
#define REG_BK1386_68_H      0x1386D1
#define REG_BK1386_69_L      0x1386D2
#define REG_BK1386_69_H      0x1386D3
#define REG_BK1386_6A_L      0x1386D4
#define REG_BK1386_6A_H      0x1386D5
#define REG_BK1386_6B_L      0x1386D6
#define REG_BK1386_6B_H      0x1386D7
#define REG_BK1386_6C_L      0x1386D8
#define REG_BK1386_6C_H      0x1386D9
#define REG_BK1386_6D_L      0x1386DA
#define REG_BK1386_6D_H      0x1386DB
#define REG_BK1386_6E_L      0x1386DC
#define REG_BK1386_6E_H      0x1386DD
#define REG_BK1386_6F_L      0x1386DE
#define REG_BK1386_6F_H      0x1386DF
#define REG_BK1386_70_L      0x1386E0
#define REG_BK1386_70_H      0x1386E1
#define REG_BK1386_71_L      0x1386E2
#define REG_BK1386_71_H      0x1386E3
#define REG_BK1386_72_L      0x1386E4
#define REG_BK1386_72_H      0x1386E5
#define REG_BK1386_73_L      0x1386E6
#define REG_BK1386_73_H      0x1386E7
#define REG_BK1386_74_L      0x1386E8
#define REG_BK1386_74_H      0x1386E9
#define REG_BK1386_75_L      0x1386EA
#define REG_BK1386_75_H      0x1386EB
#define REG_BK1386_76_L      0x1386EC
#define REG_BK1386_76_H      0x1386ED
#define REG_BK1386_77_L      0x1386EE
#define REG_BK1386_77_H      0x1386EF
#define REG_BK1386_78_L      0x1386F0
#define REG_BK1386_78_H      0x1386F1
#define REG_BK1386_79_L      0x1386F2
#define REG_BK1386_79_H      0x1386F3
#define REG_BK1386_7A_L      0x1386F4
#define REG_BK1386_7A_H      0x1386F5
#define REG_BK1386_7B_L      0x1386F6
#define REG_BK1386_7B_H      0x1386F7
#define REG_BK1386_7C_L      0x1386F8
#define REG_BK1386_7C_H      0x1386F9
#define REG_BK1386_7D_L      0x1386FA
#define REG_BK1386_7D_H      0x1386FB
#define REG_BK1386_7E_L      0x1386FC
#define REG_BK1386_7E_H      0x1386FD
#define REG_BK1386_7F_L      0x1386FE
#define REG_BK1386_7F_H      0x1386FF
//----------------------------------------------
#define REG_BK1387_00_L      0x138700
#define REG_BK1387_00_H      0x138701
#define REG_BK1387_01_L      0x138702
#define REG_BK1387_01_H      0x138703
#define REG_BK1387_02_L      0x138704
#define REG_BK1387_02_H      0x138705
#define REG_BK1387_03_L      0x138706
#define REG_BK1387_03_H      0x138707
#define REG_BK1387_04_L      0x138708
#define REG_BK1387_04_H      0x138709
#define REG_BK1387_05_L      0x13870A
#define REG_BK1387_05_H      0x13870B
#define REG_BK1387_06_L      0x13870C
#define REG_BK1387_06_H      0x13870D
#define REG_BK1387_07_L      0x13870E
#define REG_BK1387_07_H      0x13870F
#define REG_BK1387_08_L      0x138710
#define REG_BK1387_08_H      0x138711
#define REG_BK1387_09_L      0x138712
#define REG_BK1387_09_H      0x138713
#define REG_BK1387_0A_L      0x138714
#define REG_BK1387_0A_H      0x138715
#define REG_BK1387_0B_L      0x138716
#define REG_BK1387_0B_H      0x138717
#define REG_BK1387_0C_L      0x138718
#define REG_BK1387_0C_H      0x138719
#define REG_BK1387_0D_L      0x13871A
#define REG_BK1387_0D_H      0x13871B
#define REG_BK1387_0E_L      0x13871C
#define REG_BK1387_0E_H      0x13871D
#define REG_BK1387_0F_L      0x13871E
#define REG_BK1387_0F_H      0x13871F
#define REG_BK1387_10_L      0x138720
#define REG_BK1387_10_H      0x138721
#define REG_BK1387_11_L      0x138722
#define REG_BK1387_11_H      0x138723
#define REG_BK1387_12_L      0x138724
#define REG_BK1387_12_H      0x138725
#define REG_BK1387_13_L      0x138726
#define REG_BK1387_13_H      0x138727
#define REG_BK1387_14_L      0x138728
#define REG_BK1387_14_H      0x138729
#define REG_BK1387_15_L      0x13872A
#define REG_BK1387_15_H      0x13872B
#define REG_BK1387_16_L      0x13872C
#define REG_BK1387_16_H      0x13872D
#define REG_BK1387_17_L      0x13872E
#define REG_BK1387_17_H      0x13872F
#define REG_BK1387_18_L      0x138730
#define REG_BK1387_18_H      0x138731
#define REG_BK1387_19_L      0x138732
#define REG_BK1387_19_H      0x138733
#define REG_BK1387_1A_L      0x138734
#define REG_BK1387_1A_H      0x138735
#define REG_BK1387_1B_L      0x138736
#define REG_BK1387_1B_H      0x138737
#define REG_BK1387_1C_L      0x138738
#define REG_BK1387_1C_H      0x138739
#define REG_BK1387_1D_L      0x13873A
#define REG_BK1387_1D_H      0x13873B
#define REG_BK1387_1E_L      0x13873C
#define REG_BK1387_1E_H      0x13873D
#define REG_BK1387_1F_L      0x13873E
#define REG_BK1387_1F_H      0x13873F
#define REG_BK1387_20_L      0x138740
#define REG_BK1387_20_H      0x138741
#define REG_BK1387_21_L      0x138742
#define REG_BK1387_21_H      0x138743
#define REG_BK1387_22_L      0x138744
#define REG_BK1387_22_H      0x138745
#define REG_BK1387_23_L      0x138746
#define REG_BK1387_23_H      0x138747
#define REG_BK1387_24_L      0x138748
#define REG_BK1387_24_H      0x138749
#define REG_BK1387_25_L      0x13874A
#define REG_BK1387_25_H      0x13874B
#define REG_BK1387_26_L      0x13874C
#define REG_BK1387_26_H      0x13874D
#define REG_BK1387_27_L      0x13874E
#define REG_BK1387_27_H      0x13874F
#define REG_BK1387_28_L      0x138750
#define REG_BK1387_28_H      0x138751
#define REG_BK1387_29_L      0x138752
#define REG_BK1387_29_H      0x138753
#define REG_BK1387_2A_L      0x138754
#define REG_BK1387_2A_H      0x138755
#define REG_BK1387_2B_L      0x138756
#define REG_BK1387_2B_H      0x138757
#define REG_BK1387_2C_L      0x138758
#define REG_BK1387_2C_H      0x138759
#define REG_BK1387_2D_L      0x13875A
#define REG_BK1387_2D_H      0x13875B
#define REG_BK1387_2E_L      0x13875C
#define REG_BK1387_2E_H      0x13875D
#define REG_BK1387_2F_L      0x13875E
#define REG_BK1387_2F_H      0x13875F
#define REG_BK1387_30_L      0x138760
#define REG_BK1387_30_H      0x138761
#define REG_BK1387_31_L      0x138762
#define REG_BK1387_31_H      0x138763
#define REG_BK1387_32_L      0x138764
#define REG_BK1387_32_H      0x138765
#define REG_BK1387_33_L      0x138766
#define REG_BK1387_33_H      0x138767
#define REG_BK1387_34_L      0x138768
#define REG_BK1387_34_H      0x138769
#define REG_BK1387_35_L      0x13876A
#define REG_BK1387_35_H      0x13876B
#define REG_BK1387_36_L      0x13876C
#define REG_BK1387_36_H      0x13876D
#define REG_BK1387_37_L      0x13876E
#define REG_BK1387_37_H      0x13876F
#define REG_BK1387_38_L      0x138770
#define REG_BK1387_38_H      0x138771
#define REG_BK1387_39_L      0x138772
#define REG_BK1387_39_H      0x138773
#define REG_BK1387_3A_L      0x138774
#define REG_BK1387_3A_H      0x138775
#define REG_BK1387_3B_L      0x138776
#define REG_BK1387_3B_H      0x138777
#define REG_BK1387_3C_L      0x138778
#define REG_BK1387_3C_H      0x138779
#define REG_BK1387_3D_L      0x13877A
#define REG_BK1387_3D_H      0x13877B
#define REG_BK1387_3E_L      0x13877C
#define REG_BK1387_3E_H      0x13877D
#define REG_BK1387_3F_L      0x13877E
#define REG_BK1387_3F_H      0x13877F
#define REG_BK1387_40_L      0x138780
#define REG_BK1387_40_H      0x138781
#define REG_BK1387_41_L      0x138782
#define REG_BK1387_41_H      0x138783
#define REG_BK1387_42_L      0x138784
#define REG_BK1387_42_H      0x138785
#define REG_BK1387_43_L      0x138786
#define REG_BK1387_43_H      0x138787
#define REG_BK1387_44_L      0x138788
#define REG_BK1387_44_H      0x138789
#define REG_BK1387_45_L      0x13878A
#define REG_BK1387_45_H      0x13878B
#define REG_BK1387_46_L      0x13878C
#define REG_BK1387_46_H      0x13878D
#define REG_BK1387_47_L      0x13878E
#define REG_BK1387_47_H      0x13878F
#define REG_BK1387_48_L      0x138790
#define REG_BK1387_48_H      0x138791
#define REG_BK1387_49_L      0x138792
#define REG_BK1387_49_H      0x138793
#define REG_BK1387_4A_L      0x138794
#define REG_BK1387_4A_H      0x138795
#define REG_BK1387_4B_L      0x138796
#define REG_BK1387_4B_H      0x138797
#define REG_BK1387_4C_L      0x138798
#define REG_BK1387_4C_H      0x138799
#define REG_BK1387_4D_L      0x13879A
#define REG_BK1387_4D_H      0x13879B
#define REG_BK1387_4E_L      0x13879C
#define REG_BK1387_4E_H      0x13879D
#define REG_BK1387_4F_L      0x13879E
#define REG_BK1387_4F_H      0x13879F
#define REG_BK1387_50_L      0x1387A0
#define REG_BK1387_50_H      0x1387A1
#define REG_BK1387_51_L      0x1387A2
#define REG_BK1387_51_H      0x1387A3
#define REG_BK1387_52_L      0x1387A4
#define REG_BK1387_52_H      0x1387A5
#define REG_BK1387_53_L      0x1387A6
#define REG_BK1387_53_H      0x1387A7
#define REG_BK1387_54_L      0x1387A8
#define REG_BK1387_54_H      0x1387A9
#define REG_BK1387_55_L      0x1387AA
#define REG_BK1387_55_H      0x1387AB
#define REG_BK1387_56_L      0x1387AC
#define REG_BK1387_56_H      0x1387AD
#define REG_BK1387_57_L      0x1387AE
#define REG_BK1387_57_H      0x1387AF
#define REG_BK1387_58_L      0x1387B0
#define REG_BK1387_58_H      0x1387B1
#define REG_BK1387_59_L      0x1387B2
#define REG_BK1387_59_H      0x1387B3
#define REG_BK1387_5A_L      0x1387B4
#define REG_BK1387_5A_H      0x1387B5
#define REG_BK1387_5B_L      0x1387B6
#define REG_BK1387_5B_H      0x1387B7
#define REG_BK1387_5C_L      0x1387B8
#define REG_BK1387_5C_H      0x1387B9
#define REG_BK1387_5D_L      0x1387BA
#define REG_BK1387_5D_H      0x1387BB
#define REG_BK1387_5E_L      0x1387BC
#define REG_BK1387_5E_H      0x1387BD
#define REG_BK1387_5F_L      0x1387BE
#define REG_BK1387_5F_H      0x1387BF
#define REG_BK1387_60_L      0x1387C0
#define REG_BK1387_60_H      0x1387C1
#define REG_BK1387_61_L      0x1387C2
#define REG_BK1387_61_H      0x1387C3
#define REG_BK1387_62_L      0x1387C4
#define REG_BK1387_62_H      0x1387C5
#define REG_BK1387_63_L      0x1387C6
#define REG_BK1387_63_H      0x1387C7
#define REG_BK1387_64_L      0x1387C8
#define REG_BK1387_64_H      0x1387C9
#define REG_BK1387_65_L      0x1387CA
#define REG_BK1387_65_H      0x1387CB
#define REG_BK1387_66_L      0x1387CC
#define REG_BK1387_66_H      0x1387CD
#define REG_BK1387_67_L      0x1387CE
#define REG_BK1387_67_H      0x1387CF
#define REG_BK1387_68_L      0x1387D0
#define REG_BK1387_68_H      0x1387D1
#define REG_BK1387_69_L      0x1387D2
#define REG_BK1387_69_H      0x1387D3
#define REG_BK1387_6A_L      0x1387D4
#define REG_BK1387_6A_H      0x1387D5
#define REG_BK1387_6B_L      0x1387D6
#define REG_BK1387_6B_H      0x1387D7
#define REG_BK1387_6C_L      0x1387D8
#define REG_BK1387_6C_H      0x1387D9
#define REG_BK1387_6D_L      0x1387DA
#define REG_BK1387_6D_H      0x1387DB
#define REG_BK1387_6E_L      0x1387DC
#define REG_BK1387_6E_H      0x1387DD
#define REG_BK1387_6F_L      0x1387DE
#define REG_BK1387_6F_H      0x1387DF
#define REG_BK1387_70_L      0x1387E0
#define REG_BK1387_70_H      0x1387E1
#define REG_BK1387_71_L      0x1387E2
#define REG_BK1387_71_H      0x1387E3
#define REG_BK1387_72_L      0x1387E4
#define REG_BK1387_72_H      0x1387E5
#define REG_BK1387_73_L      0x1387E6
#define REG_BK1387_73_H      0x1387E7
#define REG_BK1387_74_L      0x1387E8
#define REG_BK1387_74_H      0x1387E9
#define REG_BK1387_75_L      0x1387EA
#define REG_BK1387_75_H      0x1387EB
#define REG_BK1387_76_L      0x1387EC
#define REG_BK1387_76_H      0x1387ED
#define REG_BK1387_77_L      0x1387EE
#define REG_BK1387_77_H      0x1387EF
#define REG_BK1387_78_L      0x1387F0
#define REG_BK1387_78_H      0x1387F1
#define REG_BK1387_79_L      0x1387F2
#define REG_BK1387_79_H      0x1387F3
#define REG_BK1387_7A_L      0x1387F4
#define REG_BK1387_7A_H      0x1387F5
#define REG_BK1387_7B_L      0x1387F6
#define REG_BK1387_7B_H      0x1387F7
#define REG_BK1387_7C_L      0x1387F8
#define REG_BK1387_7C_H      0x1387F9
#define REG_BK1387_7D_L      0x1387FA
#define REG_BK1387_7D_H      0x1387FB
#define REG_BK1387_7E_L      0x1387FC
#define REG_BK1387_7E_H      0x1387FD
#define REG_BK1387_7F_L      0x1387FE
#define REG_BK1387_7F_H      0x1387FF
//----------------------------------------------
#define REG_BK1388_00_L      0x138800
#define REG_BK1388_00_H      0x138801
#define REG_BK1388_01_L      0x138802
#define REG_BK1388_01_H      0x138803
#define REG_BK1388_02_L      0x138804
#define REG_BK1388_02_H      0x138805
#define REG_BK1388_03_L      0x138806
#define REG_BK1388_03_H      0x138807
#define REG_BK1388_04_L      0x138808
#define REG_BK1388_04_H      0x138809
#define REG_BK1388_05_L      0x13880A
#define REG_BK1388_05_H      0x13880B
#define REG_BK1388_06_L      0x13880C
#define REG_BK1388_06_H      0x13880D
#define REG_BK1388_07_L      0x13880E
#define REG_BK1388_07_H      0x13880F
#define REG_BK1388_08_L      0x138810
#define REG_BK1388_08_H      0x138811
#define REG_BK1388_09_L      0x138812
#define REG_BK1388_09_H      0x138813
#define REG_BK1388_0A_L      0x138814
#define REG_BK1388_0A_H      0x138815
#define REG_BK1388_0B_L      0x138816
#define REG_BK1388_0B_H      0x138817
#define REG_BK1388_0C_L      0x138818
#define REG_BK1388_0C_H      0x138819
#define REG_BK1388_0D_L      0x13881A
#define REG_BK1388_0D_H      0x13881B
#define REG_BK1388_0E_L      0x13881C
#define REG_BK1388_0E_H      0x13881D
#define REG_BK1388_0F_L      0x13881E
#define REG_BK1388_0F_H      0x13881F
#define REG_BK1388_10_L      0x138820
#define REG_BK1388_10_H      0x138821
#define REG_BK1388_11_L      0x138822
#define REG_BK1388_11_H      0x138823
#define REG_BK1388_12_L      0x138824
#define REG_BK1388_12_H      0x138825
#define REG_BK1388_13_L      0x138826
#define REG_BK1388_13_H      0x138827
#define REG_BK1388_14_L      0x138828
#define REG_BK1388_14_H      0x138829
#define REG_BK1388_15_L      0x13882A
#define REG_BK1388_15_H      0x13882B
#define REG_BK1388_16_L      0x13882C
#define REG_BK1388_16_H      0x13882D
#define REG_BK1388_17_L      0x13882E
#define REG_BK1388_17_H      0x13882F
#define REG_BK1388_18_L      0x138830
#define REG_BK1388_18_H      0x138831
#define REG_BK1388_19_L      0x138832
#define REG_BK1388_19_H      0x138833
#define REG_BK1388_1A_L      0x138834
#define REG_BK1388_1A_H      0x138835
#define REG_BK1388_1B_L      0x138836
#define REG_BK1388_1B_H      0x138837
#define REG_BK1388_1C_L      0x138838
#define REG_BK1388_1C_H      0x138839
#define REG_BK1388_1D_L      0x13883A
#define REG_BK1388_1D_H      0x13883B
#define REG_BK1388_1E_L      0x13883C
#define REG_BK1388_1E_H      0x13883D
#define REG_BK1388_1F_L      0x13883E
#define REG_BK1388_1F_H      0x13883F
#define REG_BK1388_20_L      0x138840
#define REG_BK1388_20_H      0x138841
#define REG_BK1388_21_L      0x138842
#define REG_BK1388_21_H      0x138843
#define REG_BK1388_22_L      0x138844
#define REG_BK1388_22_H      0x138845
#define REG_BK1388_23_L      0x138846
#define REG_BK1388_23_H      0x138847
#define REG_BK1388_24_L      0x138848
#define REG_BK1388_24_H      0x138849
#define REG_BK1388_25_L      0x13884A
#define REG_BK1388_25_H      0x13884B
#define REG_BK1388_26_L      0x13884C
#define REG_BK1388_26_H      0x13884D
#define REG_BK1388_27_L      0x13884E
#define REG_BK1388_27_H      0x13884F
#define REG_BK1388_28_L      0x138850
#define REG_BK1388_28_H      0x138851
#define REG_BK1388_29_L      0x138852
#define REG_BK1388_29_H      0x138853
#define REG_BK1388_2A_L      0x138854
#define REG_BK1388_2A_H      0x138855
#define REG_BK1388_2B_L      0x138856
#define REG_BK1388_2B_H      0x138857
#define REG_BK1388_2C_L      0x138858
#define REG_BK1388_2C_H      0x138859
#define REG_BK1388_2D_L      0x13885A
#define REG_BK1388_2D_H      0x13885B
#define REG_BK1388_2E_L      0x13885C
#define REG_BK1388_2E_H      0x13885D
#define REG_BK1388_2F_L      0x13885E
#define REG_BK1388_2F_H      0x13885F
#define REG_BK1388_30_L      0x138860
#define REG_BK1388_30_H      0x138861
#define REG_BK1388_31_L      0x138862
#define REG_BK1388_31_H      0x138863
#define REG_BK1388_32_L      0x138864
#define REG_BK1388_32_H      0x138865
#define REG_BK1388_33_L      0x138866
#define REG_BK1388_33_H      0x138867
#define REG_BK1388_34_L      0x138868
#define REG_BK1388_34_H      0x138869
#define REG_BK1388_35_L      0x13886A
#define REG_BK1388_35_H      0x13886B
#define REG_BK1388_36_L      0x13886C
#define REG_BK1388_36_H      0x13886D
#define REG_BK1388_37_L      0x13886E
#define REG_BK1388_37_H      0x13886F
#define REG_BK1388_38_L      0x138870
#define REG_BK1388_38_H      0x138871
#define REG_BK1388_39_L      0x138872
#define REG_BK1388_39_H      0x138873
#define REG_BK1388_3A_L      0x138874
#define REG_BK1388_3A_H      0x138875
#define REG_BK1388_3B_L      0x138876
#define REG_BK1388_3B_H      0x138877
#define REG_BK1388_3C_L      0x138878
#define REG_BK1388_3C_H      0x138879
#define REG_BK1388_3D_L      0x13887A
#define REG_BK1388_3D_H      0x13887B
#define REG_BK1388_3E_L      0x13887C
#define REG_BK1388_3E_H      0x13887D
#define REG_BK1388_3F_L      0x13887E
#define REG_BK1388_3F_H      0x13887F
#define REG_BK1388_40_L      0x138880
#define REG_BK1388_40_H      0x138881
#define REG_BK1388_41_L      0x138882
#define REG_BK1388_41_H      0x138883
#define REG_BK1388_42_L      0x138884
#define REG_BK1388_42_H      0x138885
#define REG_BK1388_43_L      0x138886
#define REG_BK1388_43_H      0x138887
#define REG_BK1388_44_L      0x138888
#define REG_BK1388_44_H      0x138889
#define REG_BK1388_45_L      0x13888A
#define REG_BK1388_45_H      0x13888B
#define REG_BK1388_46_L      0x13888C
#define REG_BK1388_46_H      0x13888D
#define REG_BK1388_47_L      0x13888E
#define REG_BK1388_47_H      0x13888F
#define REG_BK1388_48_L      0x138890
#define REG_BK1388_48_H      0x138891
#define REG_BK1388_49_L      0x138892
#define REG_BK1388_49_H      0x138893
#define REG_BK1388_4A_L      0x138894
#define REG_BK1388_4A_H      0x138895
#define REG_BK1388_4B_L      0x138896
#define REG_BK1388_4B_H      0x138897
#define REG_BK1388_4C_L      0x138898
#define REG_BK1388_4C_H      0x138899
#define REG_BK1388_4D_L      0x13889A
#define REG_BK1388_4D_H      0x13889B
#define REG_BK1388_4E_L      0x13889C
#define REG_BK1388_4E_H      0x13889D
#define REG_BK1388_4F_L      0x13889E
#define REG_BK1388_4F_H      0x13889F
#define REG_BK1388_50_L      0x1388A0
#define REG_BK1388_50_H      0x1388A1
#define REG_BK1388_51_L      0x1388A2
#define REG_BK1388_51_H      0x1388A3
#define REG_BK1388_52_L      0x1388A4
#define REG_BK1388_52_H      0x1388A5
#define REG_BK1388_53_L      0x1388A6
#define REG_BK1388_53_H      0x1388A7
#define REG_BK1388_54_L      0x1388A8
#define REG_BK1388_54_H      0x1388A9
#define REG_BK1388_55_L      0x1388AA
#define REG_BK1388_55_H      0x1388AB
#define REG_BK1388_56_L      0x1388AC
#define REG_BK1388_56_H      0x1388AD
#define REG_BK1388_57_L      0x1388AE
#define REG_BK1388_57_H      0x1388AF
#define REG_BK1388_58_L      0x1388B0
#define REG_BK1388_58_H      0x1388B1
#define REG_BK1388_59_L      0x1388B2
#define REG_BK1388_59_H      0x1388B3
#define REG_BK1388_5A_L      0x1388B4
#define REG_BK1388_5A_H      0x1388B5
#define REG_BK1388_5B_L      0x1388B6
#define REG_BK1388_5B_H      0x1388B7
#define REG_BK1388_5C_L      0x1388B8
#define REG_BK1388_5C_H      0x1388B9
#define REG_BK1388_5D_L      0x1388BA
#define REG_BK1388_5D_H      0x1388BB
#define REG_BK1388_5E_L      0x1388BC
#define REG_BK1388_5E_H      0x1388BD
#define REG_BK1388_5F_L      0x1388BE
#define REG_BK1388_5F_H      0x1388BF
#define REG_BK1388_60_L      0x1388C0
#define REG_BK1388_60_H      0x1388C1
#define REG_BK1388_61_L      0x1388C2
#define REG_BK1388_61_H      0x1388C3
#define REG_BK1388_62_L      0x1388C4
#define REG_BK1388_62_H      0x1388C5
#define REG_BK1388_63_L      0x1388C6
#define REG_BK1388_63_H      0x1388C7
#define REG_BK1388_64_L      0x1388C8
#define REG_BK1388_64_H      0x1388C9
#define REG_BK1388_65_L      0x1388CA
#define REG_BK1388_65_H      0x1388CB
#define REG_BK1388_66_L      0x1388CC
#define REG_BK1388_66_H      0x1388CD
#define REG_BK1388_67_L      0x1388CE
#define REG_BK1388_67_H      0x1388CF
#define REG_BK1388_68_L      0x1388D0
#define REG_BK1388_68_H      0x1388D1
#define REG_BK1388_69_L      0x1388D2
#define REG_BK1388_69_H      0x1388D3
#define REG_BK1388_6A_L      0x1388D4
#define REG_BK1388_6A_H      0x1388D5
#define REG_BK1388_6B_L      0x1388D6
#define REG_BK1388_6B_H      0x1388D7
#define REG_BK1388_6C_L      0x1388D8
#define REG_BK1388_6C_H      0x1388D9
#define REG_BK1388_6D_L      0x1388DA
#define REG_BK1388_6D_H      0x1388DB
#define REG_BK1388_6E_L      0x1388DC
#define REG_BK1388_6E_H      0x1388DD
#define REG_BK1388_6F_L      0x1388DE
#define REG_BK1388_6F_H      0x1388DF
#define REG_BK1388_70_L      0x1388E0
#define REG_BK1388_70_H      0x1388E1
#define REG_BK1388_71_L      0x1388E2
#define REG_BK1388_71_H      0x1388E3
#define REG_BK1388_72_L      0x1388E4
#define REG_BK1388_72_H      0x1388E5
#define REG_BK1388_73_L      0x1388E6
#define REG_BK1388_73_H      0x1388E7
#define REG_BK1388_74_L      0x1388E8
#define REG_BK1388_74_H      0x1388E9
#define REG_BK1388_75_L      0x1388EA
#define REG_BK1388_75_H      0x1388EB
#define REG_BK1388_76_L      0x1388EC
#define REG_BK1388_76_H      0x1388ED
#define REG_BK1388_77_L      0x1388EE
#define REG_BK1388_77_H      0x1388EF
#define REG_BK1388_78_L      0x1388F0
#define REG_BK1388_78_H      0x1388F1
#define REG_BK1388_79_L      0x1388F2
#define REG_BK1388_79_H      0x1388F3
#define REG_BK1388_7A_L      0x1388F4
#define REG_BK1388_7A_H      0x1388F5
#define REG_BK1388_7B_L      0x1388F6
#define REG_BK1388_7B_H      0x1388F7
#define REG_BK1388_7C_L      0x1388F8
#define REG_BK1388_7C_H      0x1388F9
#define REG_BK1388_7D_L      0x1388FA
#define REG_BK1388_7D_H      0x1388FB
#define REG_BK1388_7E_L      0x1388FC
#define REG_BK1388_7E_H      0x1388FD
#define REG_BK1388_7F_L      0x1388FE
#define REG_BK1388_7F_H      0x1388FF
//----------------------------------------------
#define REG_BK1389_00_L      0x138900
#define REG_BK1389_00_H      0x138901
#define REG_BK1389_01_L      0x138902
#define REG_BK1389_01_H      0x138903
#define REG_BK1389_02_L      0x138904
#define REG_BK1389_02_H      0x138905
#define REG_BK1389_03_L      0x138906
#define REG_BK1389_03_H      0x138907
#define REG_BK1389_04_L      0x138908
#define REG_BK1389_04_H      0x138909
#define REG_BK1389_05_L      0x13890A
#define REG_BK1389_05_H      0x13890B
#define REG_BK1389_06_L      0x13890C
#define REG_BK1389_06_H      0x13890D
#define REG_BK1389_07_L      0x13890E
#define REG_BK1389_07_H      0x13890F
#define REG_BK1389_08_L      0x138910
#define REG_BK1389_08_H      0x138911
#define REG_BK1389_09_L      0x138912
#define REG_BK1389_09_H      0x138913
#define REG_BK1389_0A_L      0x138914
#define REG_BK1389_0A_H      0x138915
#define REG_BK1389_0B_L      0x138916
#define REG_BK1389_0B_H      0x138917
#define REG_BK1389_0C_L      0x138918
#define REG_BK1389_0C_H      0x138919
#define REG_BK1389_0D_L      0x13891A
#define REG_BK1389_0D_H      0x13891B
#define REG_BK1389_0E_L      0x13891C
#define REG_BK1389_0E_H      0x13891D
#define REG_BK1389_0F_L      0x13891E
#define REG_BK1389_0F_H      0x13891F
#define REG_BK1389_10_L      0x138920
#define REG_BK1389_10_H      0x138921
#define REG_BK1389_11_L      0x138922
#define REG_BK1389_11_H      0x138923
#define REG_BK1389_12_L      0x138924
#define REG_BK1389_12_H      0x138925
#define REG_BK1389_13_L      0x138926
#define REG_BK1389_13_H      0x138927
#define REG_BK1389_14_L      0x138928
#define REG_BK1389_14_H      0x138929
#define REG_BK1389_15_L      0x13892A
#define REG_BK1389_15_H      0x13892B
#define REG_BK1389_16_L      0x13892C
#define REG_BK1389_16_H      0x13892D
#define REG_BK1389_17_L      0x13892E
#define REG_BK1389_17_H      0x13892F
#define REG_BK1389_18_L      0x138930
#define REG_BK1389_18_H      0x138931
#define REG_BK1389_19_L      0x138932
#define REG_BK1389_19_H      0x138933
#define REG_BK1389_1A_L      0x138934
#define REG_BK1389_1A_H      0x138935
#define REG_BK1389_1B_L      0x138936
#define REG_BK1389_1B_H      0x138937
#define REG_BK1389_1C_L      0x138938
#define REG_BK1389_1C_H      0x138939
#define REG_BK1389_1D_L      0x13893A
#define REG_BK1389_1D_H      0x13893B
#define REG_BK1389_1E_L      0x13893C
#define REG_BK1389_1E_H      0x13893D
#define REG_BK1389_1F_L      0x13893E
#define REG_BK1389_1F_H      0x13893F
#define REG_BK1389_20_L      0x138940
#define REG_BK1389_20_H      0x138941
#define REG_BK1389_21_L      0x138942
#define REG_BK1389_21_H      0x138943
#define REG_BK1389_22_L      0x138944
#define REG_BK1389_22_H      0x138945
#define REG_BK1389_23_L      0x138946
#define REG_BK1389_23_H      0x138947
#define REG_BK1389_24_L      0x138948
#define REG_BK1389_24_H      0x138949
#define REG_BK1389_25_L      0x13894A
#define REG_BK1389_25_H      0x13894B
#define REG_BK1389_26_L      0x13894C
#define REG_BK1389_26_H      0x13894D
#define REG_BK1389_27_L      0x13894E
#define REG_BK1389_27_H      0x13894F
#define REG_BK1389_28_L      0x138950
#define REG_BK1389_28_H      0x138951
#define REG_BK1389_29_L      0x138952
#define REG_BK1389_29_H      0x138953
#define REG_BK1389_2A_L      0x138954
#define REG_BK1389_2A_H      0x138955
#define REG_BK1389_2B_L      0x138956
#define REG_BK1389_2B_H      0x138957
#define REG_BK1389_2C_L      0x138958
#define REG_BK1389_2C_H      0x138959
#define REG_BK1389_2D_L      0x13895A
#define REG_BK1389_2D_H      0x13895B
#define REG_BK1389_2E_L      0x13895C
#define REG_BK1389_2E_H      0x13895D
#define REG_BK1389_2F_L      0x13895E
#define REG_BK1389_2F_H      0x13895F
#define REG_BK1389_30_L      0x138960
#define REG_BK1389_30_H      0x138961
#define REG_BK1389_31_L      0x138962
#define REG_BK1389_31_H      0x138963
#define REG_BK1389_32_L      0x138964
#define REG_BK1389_32_H      0x138965
#define REG_BK1389_33_L      0x138966
#define REG_BK1389_33_H      0x138967
#define REG_BK1389_34_L      0x138968
#define REG_BK1389_34_H      0x138969
#define REG_BK1389_35_L      0x13896A
#define REG_BK1389_35_H      0x13896B
#define REG_BK1389_36_L      0x13896C
#define REG_BK1389_36_H      0x13896D
#define REG_BK1389_37_L      0x13896E
#define REG_BK1389_37_H      0x13896F
#define REG_BK1389_38_L      0x138970
#define REG_BK1389_38_H      0x138971
#define REG_BK1389_39_L      0x138972
#define REG_BK1389_39_H      0x138973
#define REG_BK1389_3A_L      0x138974
#define REG_BK1389_3A_H      0x138975
#define REG_BK1389_3B_L      0x138976
#define REG_BK1389_3B_H      0x138977
#define REG_BK1389_3C_L      0x138978
#define REG_BK1389_3C_H      0x138979
#define REG_BK1389_3D_L      0x13897A
#define REG_BK1389_3D_H      0x13897B
#define REG_BK1389_3E_L      0x13897C
#define REG_BK1389_3E_H      0x13897D
#define REG_BK1389_3F_L      0x13897E
#define REG_BK1389_3F_H      0x13897F
#define REG_BK1389_40_L      0x138980
#define REG_BK1389_40_H      0x138981
#define REG_BK1389_41_L      0x138982
#define REG_BK1389_41_H      0x138983
#define REG_BK1389_42_L      0x138984
#define REG_BK1389_42_H      0x138985
#define REG_BK1389_43_L      0x138986
#define REG_BK1389_43_H      0x138987
#define REG_BK1389_44_L      0x138988
#define REG_BK1389_44_H      0x138989
#define REG_BK1389_45_L      0x13898A
#define REG_BK1389_45_H      0x13898B
#define REG_BK1389_46_L      0x13898C
#define REG_BK1389_46_H      0x13898D
#define REG_BK1389_47_L      0x13898E
#define REG_BK1389_47_H      0x13898F
#define REG_BK1389_48_L      0x138990
#define REG_BK1389_48_H      0x138991
#define REG_BK1389_49_L      0x138992
#define REG_BK1389_49_H      0x138993
#define REG_BK1389_4A_L      0x138994
#define REG_BK1389_4A_H      0x138995
#define REG_BK1389_4B_L      0x138996
#define REG_BK1389_4B_H      0x138997
#define REG_BK1389_4C_L      0x138998
#define REG_BK1389_4C_H      0x138999
#define REG_BK1389_4D_L      0x13899A
#define REG_BK1389_4D_H      0x13899B
#define REG_BK1389_4E_L      0x13899C
#define REG_BK1389_4E_H      0x13899D
#define REG_BK1389_4F_L      0x13899E
#define REG_BK1389_4F_H      0x13899F
#define REG_BK1389_50_L      0x1389A0
#define REG_BK1389_50_H      0x1389A1
#define REG_BK1389_51_L      0x1389A2
#define REG_BK1389_51_H      0x1389A3
#define REG_BK1389_52_L      0x1389A4
#define REG_BK1389_52_H      0x1389A5
#define REG_BK1389_53_L      0x1389A6
#define REG_BK1389_53_H      0x1389A7
#define REG_BK1389_54_L      0x1389A8
#define REG_BK1389_54_H      0x1389A9
#define REG_BK1389_55_L      0x1389AA
#define REG_BK1389_55_H      0x1389AB
#define REG_BK1389_56_L      0x1389AC
#define REG_BK1389_56_H      0x1389AD
#define REG_BK1389_57_L      0x1389AE
#define REG_BK1389_57_H      0x1389AF
#define REG_BK1389_58_L      0x1389B0
#define REG_BK1389_58_H      0x1389B1
#define REG_BK1389_59_L      0x1389B2
#define REG_BK1389_59_H      0x1389B3
#define REG_BK1389_5A_L      0x1389B4
#define REG_BK1389_5A_H      0x1389B5
#define REG_BK1389_5B_L      0x1389B6
#define REG_BK1389_5B_H      0x1389B7
#define REG_BK1389_5C_L      0x1389B8
#define REG_BK1389_5C_H      0x1389B9
#define REG_BK1389_5D_L      0x1389BA
#define REG_BK1389_5D_H      0x1389BB
#define REG_BK1389_5E_L      0x1389BC
#define REG_BK1389_5E_H      0x1389BD
#define REG_BK1389_5F_L      0x1389BE
#define REG_BK1389_5F_H      0x1389BF
#define REG_BK1389_60_L      0x1389C0
#define REG_BK1389_60_H      0x1389C1
#define REG_BK1389_61_L      0x1389C2
#define REG_BK1389_61_H      0x1389C3
#define REG_BK1389_62_L      0x1389C4
#define REG_BK1389_62_H      0x1389C5
#define REG_BK1389_63_L      0x1389C6
#define REG_BK1389_63_H      0x1389C7
#define REG_BK1389_64_L      0x1389C8
#define REG_BK1389_64_H      0x1389C9
#define REG_BK1389_65_L      0x1389CA
#define REG_BK1389_65_H      0x1389CB
#define REG_BK1389_66_L      0x1389CC
#define REG_BK1389_66_H      0x1389CD
#define REG_BK1389_67_L      0x1389CE
#define REG_BK1389_67_H      0x1389CF
#define REG_BK1389_68_L      0x1389D0
#define REG_BK1389_68_H      0x1389D1
#define REG_BK1389_69_L      0x1389D2
#define REG_BK1389_69_H      0x1389D3
#define REG_BK1389_6A_L      0x1389D4
#define REG_BK1389_6A_H      0x1389D5
#define REG_BK1389_6B_L      0x1389D6
#define REG_BK1389_6B_H      0x1389D7
#define REG_BK1389_6C_L      0x1389D8
#define REG_BK1389_6C_H      0x1389D9
#define REG_BK1389_6D_L      0x1389DA
#define REG_BK1389_6D_H      0x1389DB
#define REG_BK1389_6E_L      0x1389DC
#define REG_BK1389_6E_H      0x1389DD
#define REG_BK1389_6F_L      0x1389DE
#define REG_BK1389_6F_H      0x1389DF
#define REG_BK1389_70_L      0x1389E0
#define REG_BK1389_70_H      0x1389E1
#define REG_BK1389_71_L      0x1389E2
#define REG_BK1389_71_H      0x1389E3
#define REG_BK1389_72_L      0x1389E4
#define REG_BK1389_72_H      0x1389E5
#define REG_BK1389_73_L      0x1389E6
#define REG_BK1389_73_H      0x1389E7
#define REG_BK1389_74_L      0x1389E8
#define REG_BK1389_74_H      0x1389E9
#define REG_BK1389_75_L      0x1389EA
#define REG_BK1389_75_H      0x1389EB
#define REG_BK1389_76_L      0x1389EC
#define REG_BK1389_76_H      0x1389ED
#define REG_BK1389_77_L      0x1389EE
#define REG_BK1389_77_H      0x1389EF
#define REG_BK1389_78_L      0x1389F0
#define REG_BK1389_78_H      0x1389F1
#define REG_BK1389_79_L      0x1389F2
#define REG_BK1389_79_H      0x1389F3
#define REG_BK1389_7A_L      0x1389F4
#define REG_BK1389_7A_H      0x1389F5
#define REG_BK1389_7B_L      0x1389F6
#define REG_BK1389_7B_H      0x1389F7
#define REG_BK1389_7C_L      0x1389F8
#define REG_BK1389_7C_H      0x1389F9
#define REG_BK1389_7D_L      0x1389FA
#define REG_BK1389_7D_H      0x1389FB
#define REG_BK1389_7E_L      0x1389FC
#define REG_BK1389_7E_H      0x1389FD
#define REG_BK1389_7F_L      0x1389FE
#define REG_BK1389_7F_H      0x1389FF
//----------------------------------------------
#define REG_BK138A_00_L      0x138A00
#define REG_BK138A_00_H      0x138A01
#define REG_BK138A_01_L      0x138A02
#define REG_BK138A_01_H      0x138A03
#define REG_BK138A_02_L      0x138A04
#define REG_BK138A_02_H      0x138A05
#define REG_BK138A_03_L      0x138A06
#define REG_BK138A_03_H      0x138A07
#define REG_BK138A_04_L      0x138A08
#define REG_BK138A_04_H      0x138A09
#define REG_BK138A_05_L      0x138A0A
#define REG_BK138A_05_H      0x138A0B
#define REG_BK138A_06_L      0x138A0C
#define REG_BK138A_06_H      0x138A0D
#define REG_BK138A_07_L      0x138A0E
#define REG_BK138A_07_H      0x138A0F
#define REG_BK138A_08_L      0x138A10
#define REG_BK138A_08_H      0x138A11
#define REG_BK138A_09_L      0x138A12
#define REG_BK138A_09_H      0x138A13
#define REG_BK138A_0A_L      0x138A14
#define REG_BK138A_0A_H      0x138A15
#define REG_BK138A_0B_L      0x138A16
#define REG_BK138A_0B_H      0x138A17
#define REG_BK138A_0C_L      0x138A18
#define REG_BK138A_0C_H      0x138A19
#define REG_BK138A_0D_L      0x138A1A
#define REG_BK138A_0D_H      0x138A1B
#define REG_BK138A_0E_L      0x138A1C
#define REG_BK138A_0E_H      0x138A1D
#define REG_BK138A_0F_L      0x138A1E
#define REG_BK138A_0F_H      0x138A1F
#define REG_BK138A_10_L      0x138A20
#define REG_BK138A_10_H      0x138A21
#define REG_BK138A_11_L      0x138A22
#define REG_BK138A_11_H      0x138A23
#define REG_BK138A_12_L      0x138A24
#define REG_BK138A_12_H      0x138A25
#define REG_BK138A_13_L      0x138A26
#define REG_BK138A_13_H      0x138A27
#define REG_BK138A_14_L      0x138A28
#define REG_BK138A_14_H      0x138A29
#define REG_BK138A_15_L      0x138A2A
#define REG_BK138A_15_H      0x138A2B
#define REG_BK138A_16_L      0x138A2C
#define REG_BK138A_16_H      0x138A2D
#define REG_BK138A_17_L      0x138A2E
#define REG_BK138A_17_H      0x138A2F
#define REG_BK138A_18_L      0x138A30
#define REG_BK138A_18_H      0x138A31
#define REG_BK138A_19_L      0x138A32
#define REG_BK138A_19_H      0x138A33
#define REG_BK138A_1A_L      0x138A34
#define REG_BK138A_1A_H      0x138A35
#define REG_BK138A_1B_L      0x138A36
#define REG_BK138A_1B_H      0x138A37
#define REG_BK138A_1C_L      0x138A38
#define REG_BK138A_1C_H      0x138A39
#define REG_BK138A_1D_L      0x138A3A
#define REG_BK138A_1D_H      0x138A3B
#define REG_BK138A_1E_L      0x138A3C
#define REG_BK138A_1E_H      0x138A3D
#define REG_BK138A_1F_L      0x138A3E
#define REG_BK138A_1F_H      0x138A3F
#define REG_BK138A_20_L      0x138A40
#define REG_BK138A_20_H      0x138A41
#define REG_BK138A_21_L      0x138A42
#define REG_BK138A_21_H      0x138A43
#define REG_BK138A_22_L      0x138A44
#define REG_BK138A_22_H      0x138A45
#define REG_BK138A_23_L      0x138A46
#define REG_BK138A_23_H      0x138A47
#define REG_BK138A_24_L      0x138A48
#define REG_BK138A_24_H      0x138A49
#define REG_BK138A_25_L      0x138A4A
#define REG_BK138A_25_H      0x138A4B
#define REG_BK138A_26_L      0x138A4C
#define REG_BK138A_26_H      0x138A4D
#define REG_BK138A_27_L      0x138A4E
#define REG_BK138A_27_H      0x138A4F
#define REG_BK138A_28_L      0x138A50
#define REG_BK138A_28_H      0x138A51
#define REG_BK138A_29_L      0x138A52
#define REG_BK138A_29_H      0x138A53
#define REG_BK138A_2A_L      0x138A54
#define REG_BK138A_2A_H      0x138A55
#define REG_BK138A_2B_L      0x138A56
#define REG_BK138A_2B_H      0x138A57
#define REG_BK138A_2C_L      0x138A58
#define REG_BK138A_2C_H      0x138A59
#define REG_BK138A_2D_L      0x138A5A
#define REG_BK138A_2D_H      0x138A5B
#define REG_BK138A_2E_L      0x138A5C
#define REG_BK138A_2E_H      0x138A5D
#define REG_BK138A_2F_L      0x138A5E
#define REG_BK138A_2F_H      0x138A5F
#define REG_BK138A_30_L      0x138A60
#define REG_BK138A_30_H      0x138A61
#define REG_BK138A_31_L      0x138A62
#define REG_BK138A_31_H      0x138A63
#define REG_BK138A_32_L      0x138A64
#define REG_BK138A_32_H      0x138A65
#define REG_BK138A_33_L      0x138A66
#define REG_BK138A_33_H      0x138A67
#define REG_BK138A_34_L      0x138A68
#define REG_BK138A_34_H      0x138A69
#define REG_BK138A_35_L      0x138A6A
#define REG_BK138A_35_H      0x138A6B
#define REG_BK138A_36_L      0x138A6C
#define REG_BK138A_36_H      0x138A6D
#define REG_BK138A_37_L      0x138A6E
#define REG_BK138A_37_H      0x138A6F
#define REG_BK138A_38_L      0x138A70
#define REG_BK138A_38_H      0x138A71
#define REG_BK138A_39_L      0x138A72
#define REG_BK138A_39_H      0x138A73
#define REG_BK138A_3A_L      0x138A74
#define REG_BK138A_3A_H      0x138A75
#define REG_BK138A_3B_L      0x138A76
#define REG_BK138A_3B_H      0x138A77
#define REG_BK138A_3C_L      0x138A78
#define REG_BK138A_3C_H      0x138A79
#define REG_BK138A_3D_L      0x138A7A
#define REG_BK138A_3D_H      0x138A7B
#define REG_BK138A_3E_L      0x138A7C
#define REG_BK138A_3E_H      0x138A7D
#define REG_BK138A_3F_L      0x138A7E
#define REG_BK138A_3F_H      0x138A7F
#define REG_BK138A_40_L      0x138A80
#define REG_BK138A_40_H      0x138A81
#define REG_BK138A_41_L      0x138A82
#define REG_BK138A_41_H      0x138A83
#define REG_BK138A_42_L      0x138A84
#define REG_BK138A_42_H      0x138A85
#define REG_BK138A_43_L      0x138A86
#define REG_BK138A_43_H      0x138A87
#define REG_BK138A_44_L      0x138A88
#define REG_BK138A_44_H      0x138A89
#define REG_BK138A_45_L      0x138A8A
#define REG_BK138A_45_H      0x138A8B
#define REG_BK138A_46_L      0x138A8C
#define REG_BK138A_46_H      0x138A8D
#define REG_BK138A_47_L      0x138A8E
#define REG_BK138A_47_H      0x138A8F
#define REG_BK138A_48_L      0x138A90
#define REG_BK138A_48_H      0x138A91
#define REG_BK138A_49_L      0x138A92
#define REG_BK138A_49_H      0x138A93
#define REG_BK138A_4A_L      0x138A94
#define REG_BK138A_4A_H      0x138A95
#define REG_BK138A_4B_L      0x138A96
#define REG_BK138A_4B_H      0x138A97
#define REG_BK138A_4C_L      0x138A98
#define REG_BK138A_4C_H      0x138A99
#define REG_BK138A_4D_L      0x138A9A
#define REG_BK138A_4D_H      0x138A9B
#define REG_BK138A_4E_L      0x138A9C
#define REG_BK138A_4E_H      0x138A9D
#define REG_BK138A_4F_L      0x138A9E
#define REG_BK138A_4F_H      0x138A9F
#define REG_BK138A_50_L      0x138AA0
#define REG_BK138A_50_H      0x138AA1
#define REG_BK138A_51_L      0x138AA2
#define REG_BK138A_51_H      0x138AA3
#define REG_BK138A_52_L      0x138AA4
#define REG_BK138A_52_H      0x138AA5
#define REG_BK138A_53_L      0x138AA6
#define REG_BK138A_53_H      0x138AA7
#define REG_BK138A_54_L      0x138AA8
#define REG_BK138A_54_H      0x138AA9
#define REG_BK138A_55_L      0x138AAA
#define REG_BK138A_55_H      0x138AAB
#define REG_BK138A_56_L      0x138AAC
#define REG_BK138A_56_H      0x138AAD
#define REG_BK138A_57_L      0x138AAE
#define REG_BK138A_57_H      0x138AAF
#define REG_BK138A_58_L      0x138AB0
#define REG_BK138A_58_H      0x138AB1
#define REG_BK138A_59_L      0x138AB2
#define REG_BK138A_59_H      0x138AB3
#define REG_BK138A_5A_L      0x138AB4
#define REG_BK138A_5A_H      0x138AB5
#define REG_BK138A_5B_L      0x138AB6
#define REG_BK138A_5B_H      0x138AB7
#define REG_BK138A_5C_L      0x138AB8
#define REG_BK138A_5C_H      0x138AB9
#define REG_BK138A_5D_L      0x138ABA
#define REG_BK138A_5D_H      0x138ABB
#define REG_BK138A_5E_L      0x138ABC
#define REG_BK138A_5E_H      0x138ABD
#define REG_BK138A_5F_L      0x138ABE
#define REG_BK138A_5F_H      0x138ABF
#define REG_BK138A_60_L      0x138AC0
#define REG_BK138A_60_H      0x138AC1
#define REG_BK138A_61_L      0x138AC2
#define REG_BK138A_61_H      0x138AC3
#define REG_BK138A_62_L      0x138AC4
#define REG_BK138A_62_H      0x138AC5
#define REG_BK138A_63_L      0x138AC6
#define REG_BK138A_63_H      0x138AC7
#define REG_BK138A_64_L      0x138AC8
#define REG_BK138A_64_H      0x138AC9
#define REG_BK138A_65_L      0x138ACA
#define REG_BK138A_65_H      0x138ACB
#define REG_BK138A_66_L      0x138ACC
#define REG_BK138A_66_H      0x138ACD
#define REG_BK138A_67_L      0x138ACE
#define REG_BK138A_67_H      0x138ACF
#define REG_BK138A_68_L      0x138AD0
#define REG_BK138A_68_H      0x138AD1
#define REG_BK138A_69_L      0x138AD2
#define REG_BK138A_69_H      0x138AD3
#define REG_BK138A_6A_L      0x138AD4
#define REG_BK138A_6A_H      0x138AD5
#define REG_BK138A_6B_L      0x138AD6
#define REG_BK138A_6B_H      0x138AD7
#define REG_BK138A_6C_L      0x138AD8
#define REG_BK138A_6C_H      0x138AD9
#define REG_BK138A_6D_L      0x138ADA
#define REG_BK138A_6D_H      0x138ADB
#define REG_BK138A_6E_L      0x138ADC
#define REG_BK138A_6E_H      0x138ADD
#define REG_BK138A_6F_L      0x138ADE
#define REG_BK138A_6F_H      0x138ADF
#define REG_BK138A_70_L      0x138AE0
#define REG_BK138A_70_H      0x138AE1
#define REG_BK138A_71_L      0x138AE2
#define REG_BK138A_71_H      0x138AE3
#define REG_BK138A_72_L      0x138AE4
#define REG_BK138A_72_H      0x138AE5
#define REG_BK138A_73_L      0x138AE6
#define REG_BK138A_73_H      0x138AE7
#define REG_BK138A_74_L      0x138AE8
#define REG_BK138A_74_H      0x138AE9
#define REG_BK138A_75_L      0x138AEA
#define REG_BK138A_75_H      0x138AEB
#define REG_BK138A_76_L      0x138AEC
#define REG_BK138A_76_H      0x138AED
#define REG_BK138A_77_L      0x138AEE
#define REG_BK138A_77_H      0x138AEF
#define REG_BK138A_78_L      0x138AF0
#define REG_BK138A_78_H      0x138AF1
#define REG_BK138A_79_L      0x138AF2
#define REG_BK138A_79_H      0x138AF3
#define REG_BK138A_7A_L      0x138AF4
#define REG_BK138A_7A_H      0x138AF5
#define REG_BK138A_7B_L      0x138AF6
#define REG_BK138A_7B_H      0x138AF7
#define REG_BK138A_7C_L      0x138AF8
#define REG_BK138A_7C_H      0x138AF9
#define REG_BK138A_7D_L      0x138AFA
#define REG_BK138A_7D_H      0x138AFB
#define REG_BK138A_7E_L      0x138AFC
#define REG_BK138A_7E_H      0x138AFD
#define REG_BK138A_7F_L      0x138AFE
#define REG_BK138A_7F_H      0x138AFF
//----------------------------------------------
#define REG_BK138B_00_L      0x138B00
#define REG_BK138B_00_H      0x138B01
#define REG_BK138B_01_L      0x138B02
#define REG_BK138B_01_H      0x138B03
#define REG_BK138B_02_L      0x138B04
#define REG_BK138B_02_H      0x138B05
#define REG_BK138B_03_L      0x138B06
#define REG_BK138B_03_H      0x138B07
#define REG_BK138B_04_L      0x138B08
#define REG_BK138B_04_H      0x138B09
#define REG_BK138B_05_L      0x138B0A
#define REG_BK138B_05_H      0x138B0B
#define REG_BK138B_06_L      0x138B0C
#define REG_BK138B_06_H      0x138B0D
#define REG_BK138B_07_L      0x138B0E
#define REG_BK138B_07_H      0x138B0F
#define REG_BK138B_08_L      0x138B10
#define REG_BK138B_08_H      0x138B11
#define REG_BK138B_09_L      0x138B12
#define REG_BK138B_09_H      0x138B13
#define REG_BK138B_0A_L      0x138B14
#define REG_BK138B_0A_H      0x138B15
#define REG_BK138B_0B_L      0x138B16
#define REG_BK138B_0B_H      0x138B17
#define REG_BK138B_0C_L      0x138B18
#define REG_BK138B_0C_H      0x138B19
#define REG_BK138B_0D_L      0x138B1A
#define REG_BK138B_0D_H      0x138B1B
#define REG_BK138B_0E_L      0x138B1C
#define REG_BK138B_0E_H      0x138B1D
#define REG_BK138B_0F_L      0x138B1E
#define REG_BK138B_0F_H      0x138B1F
#define REG_BK138B_10_L      0x138B20
#define REG_BK138B_10_H      0x138B21
#define REG_BK138B_11_L      0x138B22
#define REG_BK138B_11_H      0x138B23
#define REG_BK138B_12_L      0x138B24
#define REG_BK138B_12_H      0x138B25
#define REG_BK138B_13_L      0x138B26
#define REG_BK138B_13_H      0x138B27
#define REG_BK138B_14_L      0x138B28
#define REG_BK138B_14_H      0x138B29
#define REG_BK138B_15_L      0x138B2A
#define REG_BK138B_15_H      0x138B2B
#define REG_BK138B_16_L      0x138B2C
#define REG_BK138B_16_H      0x138B2D
#define REG_BK138B_17_L      0x138B2E
#define REG_BK138B_17_H      0x138B2F
#define REG_BK138B_18_L      0x138B30
#define REG_BK138B_18_H      0x138B31
#define REG_BK138B_19_L      0x138B32
#define REG_BK138B_19_H      0x138B33
#define REG_BK138B_1A_L      0x138B34
#define REG_BK138B_1A_H      0x138B35
#define REG_BK138B_1B_L      0x138B36
#define REG_BK138B_1B_H      0x138B37
#define REG_BK138B_1C_L      0x138B38
#define REG_BK138B_1C_H      0x138B39
#define REG_BK138B_1D_L      0x138B3A
#define REG_BK138B_1D_H      0x138B3B
#define REG_BK138B_1E_L      0x138B3C
#define REG_BK138B_1E_H      0x138B3D
#define REG_BK138B_1F_L      0x138B3E
#define REG_BK138B_1F_H      0x138B3F
#define REG_BK138B_20_L      0x138B40
#define REG_BK138B_20_H      0x138B41
#define REG_BK138B_21_L      0x138B42
#define REG_BK138B_21_H      0x138B43
#define REG_BK138B_22_L      0x138B44
#define REG_BK138B_22_H      0x138B45
#define REG_BK138B_23_L      0x138B46
#define REG_BK138B_23_H      0x138B47
#define REG_BK138B_24_L      0x138B48
#define REG_BK138B_24_H      0x138B49
#define REG_BK138B_25_L      0x138B4A
#define REG_BK138B_25_H      0x138B4B
#define REG_BK138B_26_L      0x138B4C
#define REG_BK138B_26_H      0x138B4D
#define REG_BK138B_27_L      0x138B4E
#define REG_BK138B_27_H      0x138B4F
#define REG_BK138B_28_L      0x138B50
#define REG_BK138B_28_H      0x138B51
#define REG_BK138B_29_L      0x138B52
#define REG_BK138B_29_H      0x138B53
#define REG_BK138B_2A_L      0x138B54
#define REG_BK138B_2A_H      0x138B55
#define REG_BK138B_2B_L      0x138B56
#define REG_BK138B_2B_H      0x138B57
#define REG_BK138B_2C_L      0x138B58
#define REG_BK138B_2C_H      0x138B59
#define REG_BK138B_2D_L      0x138B5A
#define REG_BK138B_2D_H      0x138B5B
#define REG_BK138B_2E_L      0x138B5C
#define REG_BK138B_2E_H      0x138B5D
#define REG_BK138B_2F_L      0x138B5E
#define REG_BK138B_2F_H      0x138B5F
#define REG_BK138B_30_L      0x138B60
#define REG_BK138B_30_H      0x138B61
#define REG_BK138B_31_L      0x138B62
#define REG_BK138B_31_H      0x138B63
#define REG_BK138B_32_L      0x138B64
#define REG_BK138B_32_H      0x138B65
#define REG_BK138B_33_L      0x138B66
#define REG_BK138B_33_H      0x138B67
#define REG_BK138B_34_L      0x138B68
#define REG_BK138B_34_H      0x138B69
#define REG_BK138B_35_L      0x138B6A
#define REG_BK138B_35_H      0x138B6B
#define REG_BK138B_36_L      0x138B6C
#define REG_BK138B_36_H      0x138B6D
#define REG_BK138B_37_L      0x138B6E
#define REG_BK138B_37_H      0x138B6F
#define REG_BK138B_38_L      0x138B70
#define REG_BK138B_38_H      0x138B71
#define REG_BK138B_39_L      0x138B72
#define REG_BK138B_39_H      0x138B73
#define REG_BK138B_3A_L      0x138B74
#define REG_BK138B_3A_H      0x138B75
#define REG_BK138B_3B_L      0x138B76
#define REG_BK138B_3B_H      0x138B77
#define REG_BK138B_3C_L      0x138B78
#define REG_BK138B_3C_H      0x138B79
#define REG_BK138B_3D_L      0x138B7A
#define REG_BK138B_3D_H      0x138B7B
#define REG_BK138B_3E_L      0x138B7C
#define REG_BK138B_3E_H      0x138B7D
#define REG_BK138B_3F_L      0x138B7E
#define REG_BK138B_3F_H      0x138B7F
#define REG_BK138B_40_L      0x138B80
#define REG_BK138B_40_H      0x138B81
#define REG_BK138B_41_L      0x138B82
#define REG_BK138B_41_H      0x138B83
#define REG_BK138B_42_L      0x138B84
#define REG_BK138B_42_H      0x138B85
#define REG_BK138B_43_L      0x138B86
#define REG_BK138B_43_H      0x138B87
#define REG_BK138B_44_L      0x138B88
#define REG_BK138B_44_H      0x138B89
#define REG_BK138B_45_L      0x138B8A
#define REG_BK138B_45_H      0x138B8B
#define REG_BK138B_46_L      0x138B8C
#define REG_BK138B_46_H      0x138B8D
#define REG_BK138B_47_L      0x138B8E
#define REG_BK138B_47_H      0x138B8F
#define REG_BK138B_48_L      0x138B90
#define REG_BK138B_48_H      0x138B91
#define REG_BK138B_49_L      0x138B92
#define REG_BK138B_49_H      0x138B93
#define REG_BK138B_4A_L      0x138B94
#define REG_BK138B_4A_H      0x138B95
#define REG_BK138B_4B_L      0x138B96
#define REG_BK138B_4B_H      0x138B97
#define REG_BK138B_4C_L      0x138B98
#define REG_BK138B_4C_H      0x138B99
#define REG_BK138B_4D_L      0x138B9A
#define REG_BK138B_4D_H      0x138B9B
#define REG_BK138B_4E_L      0x138B9C
#define REG_BK138B_4E_H      0x138B9D
#define REG_BK138B_4F_L      0x138B9E
#define REG_BK138B_4F_H      0x138B9F
#define REG_BK138B_50_L      0x138BA0
#define REG_BK138B_50_H      0x138BA1
#define REG_BK138B_51_L      0x138BA2
#define REG_BK138B_51_H      0x138BA3
#define REG_BK138B_52_L      0x138BA4
#define REG_BK138B_52_H      0x138BA5
#define REG_BK138B_53_L      0x138BA6
#define REG_BK138B_53_H      0x138BA7
#define REG_BK138B_54_L      0x138BA8
#define REG_BK138B_54_H      0x138BA9
#define REG_BK138B_55_L      0x138BAA
#define REG_BK138B_55_H      0x138BAB
#define REG_BK138B_56_L      0x138BAC
#define REG_BK138B_56_H      0x138BAD
#define REG_BK138B_57_L      0x138BAE
#define REG_BK138B_57_H      0x138BAF
#define REG_BK138B_58_L      0x138BB0
#define REG_BK138B_58_H      0x138BB1
#define REG_BK138B_59_L      0x138BB2
#define REG_BK138B_59_H      0x138BB3
#define REG_BK138B_5A_L      0x138BB4
#define REG_BK138B_5A_H      0x138BB5
#define REG_BK138B_5B_L      0x138BB6
#define REG_BK138B_5B_H      0x138BB7
#define REG_BK138B_5C_L      0x138BB8
#define REG_BK138B_5C_H      0x138BB9
#define REG_BK138B_5D_L      0x138BBA
#define REG_BK138B_5D_H      0x138BBB
#define REG_BK138B_5E_L      0x138BBC
#define REG_BK138B_5E_H      0x138BBD
#define REG_BK138B_5F_L      0x138BBE
#define REG_BK138B_5F_H      0x138BBF
#define REG_BK138B_60_L      0x138BC0
#define REG_BK138B_60_H      0x138BC1
#define REG_BK138B_61_L      0x138BC2
#define REG_BK138B_61_H      0x138BC3
#define REG_BK138B_62_L      0x138BC4
#define REG_BK138B_62_H      0x138BC5
#define REG_BK138B_63_L      0x138BC6
#define REG_BK138B_63_H      0x138BC7
#define REG_BK138B_64_L      0x138BC8
#define REG_BK138B_64_H      0x138BC9
#define REG_BK138B_65_L      0x138BCA
#define REG_BK138B_65_H      0x138BCB
#define REG_BK138B_66_L      0x138BCC
#define REG_BK138B_66_H      0x138BCD
#define REG_BK138B_67_L      0x138BCE
#define REG_BK138B_67_H      0x138BCF
#define REG_BK138B_68_L      0x138BD0
#define REG_BK138B_68_H      0x138BD1
#define REG_BK138B_69_L      0x138BD2
#define REG_BK138B_69_H      0x138BD3
#define REG_BK138B_6A_L      0x138BD4
#define REG_BK138B_6A_H      0x138BD5
#define REG_BK138B_6B_L      0x138BD6
#define REG_BK138B_6B_H      0x138BD7
#define REG_BK138B_6C_L      0x138BD8
#define REG_BK138B_6C_H      0x138BD9
#define REG_BK138B_6D_L      0x138BDA
#define REG_BK138B_6D_H      0x138BDB
#define REG_BK138B_6E_L      0x138BDC
#define REG_BK138B_6E_H      0x138BDD
#define REG_BK138B_6F_L      0x138BDE
#define REG_BK138B_6F_H      0x138BDF
#define REG_BK138B_70_L      0x138BE0
#define REG_BK138B_70_H      0x138BE1
#define REG_BK138B_71_L      0x138BE2
#define REG_BK138B_71_H      0x138BE3
#define REG_BK138B_72_L      0x138BE4
#define REG_BK138B_72_H      0x138BE5
#define REG_BK138B_73_L      0x138BE6
#define REG_BK138B_73_H      0x138BE7
#define REG_BK138B_74_L      0x138BE8
#define REG_BK138B_74_H      0x138BE9
#define REG_BK138B_75_L      0x138BEA
#define REG_BK138B_75_H      0x138BEB
#define REG_BK138B_76_L      0x138BEC
#define REG_BK138B_76_H      0x138BED
#define REG_BK138B_77_L      0x138BEE
#define REG_BK138B_77_H      0x138BEF
#define REG_BK138B_78_L      0x138BF0
#define REG_BK138B_78_H      0x138BF1
#define REG_BK138B_79_L      0x138BF2
#define REG_BK138B_79_H      0x138BF3
#define REG_BK138B_7A_L      0x138BF4
#define REG_BK138B_7A_H      0x138BF5
#define REG_BK138B_7B_L      0x138BF6
#define REG_BK138B_7B_H      0x138BF7
#define REG_BK138B_7C_L      0x138BF8
#define REG_BK138B_7C_H      0x138BF9
#define REG_BK138B_7D_L      0x138BFA
#define REG_BK138B_7D_H      0x138BFB
#define REG_BK138B_7E_L      0x138BFC
#define REG_BK138B_7E_H      0x138BFD
#define REG_BK138B_7F_L      0x138BFE
#define REG_BK138B_7F_H      0x138BFF
//----------------------------------------------
#define REG_BK138C_00_L      0x138C00
#define REG_BK138C_00_H      0x138C01
#define REG_BK138C_01_L      0x138C02
#define REG_BK138C_01_H      0x138C03
#define REG_BK138C_02_L      0x138C04
#define REG_BK138C_02_H      0x138C05
#define REG_BK138C_03_L      0x138C06
#define REG_BK138C_03_H      0x138C07
#define REG_BK138C_04_L      0x138C08
#define REG_BK138C_04_H      0x138C09
#define REG_BK138C_05_L      0x138C0A
#define REG_BK138C_05_H      0x138C0B
#define REG_BK138C_06_L      0x138C0C
#define REG_BK138C_06_H      0x138C0D
#define REG_BK138C_07_L      0x138C0E
#define REG_BK138C_07_H      0x138C0F
#define REG_BK138C_08_L      0x138C10
#define REG_BK138C_08_H      0x138C11
#define REG_BK138C_09_L      0x138C12
#define REG_BK138C_09_H      0x138C13
#define REG_BK138C_0A_L      0x138C14
#define REG_BK138C_0A_H      0x138C15
#define REG_BK138C_0B_L      0x138C16
#define REG_BK138C_0B_H      0x138C17
#define REG_BK138C_0C_L      0x138C18
#define REG_BK138C_0C_H      0x138C19
#define REG_BK138C_0D_L      0x138C1A
#define REG_BK138C_0D_H      0x138C1B
#define REG_BK138C_0E_L      0x138C1C
#define REG_BK138C_0E_H      0x138C1D
#define REG_BK138C_0F_L      0x138C1E
#define REG_BK138C_0F_H      0x138C1F
#define REG_BK138C_10_L      0x138C20
#define REG_BK138C_10_H      0x138C21
#define REG_BK138C_11_L      0x138C22
#define REG_BK138C_11_H      0x138C23
#define REG_BK138C_12_L      0x138C24
#define REG_BK138C_12_H      0x138C25
#define REG_BK138C_13_L      0x138C26
#define REG_BK138C_13_H      0x138C27
#define REG_BK138C_14_L      0x138C28
#define REG_BK138C_14_H      0x138C29
#define REG_BK138C_15_L      0x138C2A
#define REG_BK138C_15_H      0x138C2B
#define REG_BK138C_16_L      0x138C2C
#define REG_BK138C_16_H      0x138C2D
#define REG_BK138C_17_L      0x138C2E
#define REG_BK138C_17_H      0x138C2F
#define REG_BK138C_18_L      0x138C30
#define REG_BK138C_18_H      0x138C31
#define REG_BK138C_19_L      0x138C32
#define REG_BK138C_19_H      0x138C33
#define REG_BK138C_1A_L      0x138C34
#define REG_BK138C_1A_H      0x138C35
#define REG_BK138C_1B_L      0x138C36
#define REG_BK138C_1B_H      0x138C37
#define REG_BK138C_1C_L      0x138C38
#define REG_BK138C_1C_H      0x138C39
#define REG_BK138C_1D_L      0x138C3A
#define REG_BK138C_1D_H      0x138C3B
#define REG_BK138C_1E_L      0x138C3C
#define REG_BK138C_1E_H      0x138C3D
#define REG_BK138C_1F_L      0x138C3E
#define REG_BK138C_1F_H      0x138C3F
#define REG_BK138C_20_L      0x138C40
#define REG_BK138C_20_H      0x138C41
#define REG_BK138C_21_L      0x138C42
#define REG_BK138C_21_H      0x138C43
#define REG_BK138C_22_L      0x138C44
#define REG_BK138C_22_H      0x138C45
#define REG_BK138C_23_L      0x138C46
#define REG_BK138C_23_H      0x138C47
#define REG_BK138C_24_L      0x138C48
#define REG_BK138C_24_H      0x138C49
#define REG_BK138C_25_L      0x138C4A
#define REG_BK138C_25_H      0x138C4B
#define REG_BK138C_26_L      0x138C4C
#define REG_BK138C_26_H      0x138C4D
#define REG_BK138C_27_L      0x138C4E
#define REG_BK138C_27_H      0x138C4F
#define REG_BK138C_28_L      0x138C50
#define REG_BK138C_28_H      0x138C51
#define REG_BK138C_29_L      0x138C52
#define REG_BK138C_29_H      0x138C53
#define REG_BK138C_2A_L      0x138C54
#define REG_BK138C_2A_H      0x138C55
#define REG_BK138C_2B_L      0x138C56
#define REG_BK138C_2B_H      0x138C57
#define REG_BK138C_2C_L      0x138C58
#define REG_BK138C_2C_H      0x138C59
#define REG_BK138C_2D_L      0x138C5A
#define REG_BK138C_2D_H      0x138C5B
#define REG_BK138C_2E_L      0x138C5C
#define REG_BK138C_2E_H      0x138C5D
#define REG_BK138C_2F_L      0x138C5E
#define REG_BK138C_2F_H      0x138C5F
#define REG_BK138C_30_L      0x138C60
#define REG_BK138C_30_H      0x138C61
#define REG_BK138C_31_L      0x138C62
#define REG_BK138C_31_H      0x138C63
#define REG_BK138C_32_L      0x138C64
#define REG_BK138C_32_H      0x138C65
#define REG_BK138C_33_L      0x138C66
#define REG_BK138C_33_H      0x138C67
#define REG_BK138C_34_L      0x138C68
#define REG_BK138C_34_H      0x138C69
#define REG_BK138C_35_L      0x138C6A
#define REG_BK138C_35_H      0x138C6B
#define REG_BK138C_36_L      0x138C6C
#define REG_BK138C_36_H      0x138C6D
#define REG_BK138C_37_L      0x138C6E
#define REG_BK138C_37_H      0x138C6F
#define REG_BK138C_38_L      0x138C70
#define REG_BK138C_38_H      0x138C71
#define REG_BK138C_39_L      0x138C72
#define REG_BK138C_39_H      0x138C73
#define REG_BK138C_3A_L      0x138C74
#define REG_BK138C_3A_H      0x138C75
#define REG_BK138C_3B_L      0x138C76
#define REG_BK138C_3B_H      0x138C77
#define REG_BK138C_3C_L      0x138C78
#define REG_BK138C_3C_H      0x138C79
#define REG_BK138C_3D_L      0x138C7A
#define REG_BK138C_3D_H      0x138C7B
#define REG_BK138C_3E_L      0x138C7C
#define REG_BK138C_3E_H      0x138C7D
#define REG_BK138C_3F_L      0x138C7E
#define REG_BK138C_3F_H      0x138C7F
#define REG_BK138C_40_L      0x138C80
#define REG_BK138C_40_H      0x138C81
#define REG_BK138C_41_L      0x138C82
#define REG_BK138C_41_H      0x138C83
#define REG_BK138C_42_L      0x138C84
#define REG_BK138C_42_H      0x138C85
#define REG_BK138C_43_L      0x138C86
#define REG_BK138C_43_H      0x138C87
#define REG_BK138C_44_L      0x138C88
#define REG_BK138C_44_H      0x138C89
#define REG_BK138C_45_L      0x138C8A
#define REG_BK138C_45_H      0x138C8B
#define REG_BK138C_46_L      0x138C8C
#define REG_BK138C_46_H      0x138C8D
#define REG_BK138C_47_L      0x138C8E
#define REG_BK138C_47_H      0x138C8F
#define REG_BK138C_48_L      0x138C90
#define REG_BK138C_48_H      0x138C91
#define REG_BK138C_49_L      0x138C92
#define REG_BK138C_49_H      0x138C93
#define REG_BK138C_4A_L      0x138C94
#define REG_BK138C_4A_H      0x138C95
#define REG_BK138C_4B_L      0x138C96
#define REG_BK138C_4B_H      0x138C97
#define REG_BK138C_4C_L      0x138C98
#define REG_BK138C_4C_H      0x138C99
#define REG_BK138C_4D_L      0x138C9A
#define REG_BK138C_4D_H      0x138C9B
#define REG_BK138C_4E_L      0x138C9C
#define REG_BK138C_4E_H      0x138C9D
#define REG_BK138C_4F_L      0x138C9E
#define REG_BK138C_4F_H      0x138C9F
#define REG_BK138C_50_L      0x138CA0
#define REG_BK138C_50_H      0x138CA1
#define REG_BK138C_51_L      0x138CA2
#define REG_BK138C_51_H      0x138CA3
#define REG_BK138C_52_L      0x138CA4
#define REG_BK138C_52_H      0x138CA5
#define REG_BK138C_53_L      0x138CA6
#define REG_BK138C_53_H      0x138CA7
#define REG_BK138C_54_L      0x138CA8
#define REG_BK138C_54_H      0x138CA9
#define REG_BK138C_55_L      0x138CAA
#define REG_BK138C_55_H      0x138CAB
#define REG_BK138C_56_L      0x138CAC
#define REG_BK138C_56_H      0x138CAD
#define REG_BK138C_57_L      0x138CAE
#define REG_BK138C_57_H      0x138CAF
#define REG_BK138C_58_L      0x138CB0
#define REG_BK138C_58_H      0x138CB1
#define REG_BK138C_59_L      0x138CB2
#define REG_BK138C_59_H      0x138CB3
#define REG_BK138C_5A_L      0x138CB4
#define REG_BK138C_5A_H      0x138CB5
#define REG_BK138C_5B_L      0x138CB6
#define REG_BK138C_5B_H      0x138CB7
#define REG_BK138C_5C_L      0x138CB8
#define REG_BK138C_5C_H      0x138CB9
#define REG_BK138C_5D_L      0x138CBA
#define REG_BK138C_5D_H      0x138CBB
#define REG_BK138C_5E_L      0x138CBC
#define REG_BK138C_5E_H      0x138CBD
#define REG_BK138C_5F_L      0x138CBE
#define REG_BK138C_5F_H      0x138CBF
#define REG_BK138C_60_L      0x138CC0
#define REG_BK138C_60_H      0x138CC1
#define REG_BK138C_61_L      0x138CC2
#define REG_BK138C_61_H      0x138CC3
#define REG_BK138C_62_L      0x138CC4
#define REG_BK138C_62_H      0x138CC5
#define REG_BK138C_63_L      0x138CC6
#define REG_BK138C_63_H      0x138CC7
#define REG_BK138C_64_L      0x138CC8
#define REG_BK138C_64_H      0x138CC9
#define REG_BK138C_65_L      0x138CCA
#define REG_BK138C_65_H      0x138CCB
#define REG_BK138C_66_L      0x138CCC
#define REG_BK138C_66_H      0x138CCD
#define REG_BK138C_67_L      0x138CCE
#define REG_BK138C_67_H      0x138CCF
#define REG_BK138C_68_L      0x138CD0
#define REG_BK138C_68_H      0x138CD1
#define REG_BK138C_69_L      0x138CD2
#define REG_BK138C_69_H      0x138CD3
#define REG_BK138C_6A_L      0x138CD4
#define REG_BK138C_6A_H      0x138CD5
#define REG_BK138C_6B_L      0x138CD6
#define REG_BK138C_6B_H      0x138CD7
#define REG_BK138C_6C_L      0x138CD8
#define REG_BK138C_6C_H      0x138CD9
#define REG_BK138C_6D_L      0x138CDA
#define REG_BK138C_6D_H      0x138CDB
#define REG_BK138C_6E_L      0x138CDC
#define REG_BK138C_6E_H      0x138CDD
#define REG_BK138C_6F_L      0x138CDE
#define REG_BK138C_6F_H      0x138CDF
#define REG_BK138C_70_L      0x138CE0
#define REG_BK138C_70_H      0x138CE1
#define REG_BK138C_71_L      0x138CE2
#define REG_BK138C_71_H      0x138CE3
#define REG_BK138C_72_L      0x138CE4
#define REG_BK138C_72_H      0x138CE5
#define REG_BK138C_73_L      0x138CE6
#define REG_BK138C_73_H      0x138CE7
#define REG_BK138C_74_L      0x138CE8
#define REG_BK138C_74_H      0x138CE9
#define REG_BK138C_75_L      0x138CEA
#define REG_BK138C_75_H      0x138CEB
#define REG_BK138C_76_L      0x138CEC
#define REG_BK138C_76_H      0x138CED
#define REG_BK138C_77_L      0x138CEE
#define REG_BK138C_77_H      0x138CEF
#define REG_BK138C_78_L      0x138CF0
#define REG_BK138C_78_H      0x138CF1
#define REG_BK138C_79_L      0x138CF2
#define REG_BK138C_79_H      0x138CF3
#define REG_BK138C_7A_L      0x138CF4
#define REG_BK138C_7A_H      0x138CF5
#define REG_BK138C_7B_L      0x138CF6
#define REG_BK138C_7B_H      0x138CF7
#define REG_BK138C_7C_L      0x138CF8
#define REG_BK138C_7C_H      0x138CF9
#define REG_BK138C_7D_L      0x138CFA
#define REG_BK138C_7D_H      0x138CFB
#define REG_BK138C_7E_L      0x138CFC
#define REG_BK138C_7E_H      0x138CFD
#define REG_BK138C_7F_L      0x138CFE
#define REG_BK138C_7F_H      0x138CFF
//----------------------------------------------
#define REG_BK138D_00_L      0x138D00
#define REG_BK138D_00_H      0x138D01
#define REG_BK138D_01_L      0x138D02
#define REG_BK138D_01_H      0x138D03
#define REG_BK138D_02_L      0x138D04
#define REG_BK138D_02_H      0x138D05
#define REG_BK138D_03_L      0x138D06
#define REG_BK138D_03_H      0x138D07
#define REG_BK138D_04_L      0x138D08
#define REG_BK138D_04_H      0x138D09
#define REG_BK138D_05_L      0x138D0A
#define REG_BK138D_05_H      0x138D0B
#define REG_BK138D_06_L      0x138D0C
#define REG_BK138D_06_H      0x138D0D
#define REG_BK138D_07_L      0x138D0E
#define REG_BK138D_07_H      0x138D0F
#define REG_BK138D_08_L      0x138D10
#define REG_BK138D_08_H      0x138D11
#define REG_BK138D_09_L      0x138D12
#define REG_BK138D_09_H      0x138D13
#define REG_BK138D_0A_L      0x138D14
#define REG_BK138D_0A_H      0x138D15
#define REG_BK138D_0B_L      0x138D16
#define REG_BK138D_0B_H      0x138D17
#define REG_BK138D_0C_L      0x138D18
#define REG_BK138D_0C_H      0x138D19
#define REG_BK138D_0D_L      0x138D1A
#define REG_BK138D_0D_H      0x138D1B
#define REG_BK138D_0E_L      0x138D1C
#define REG_BK138D_0E_H      0x138D1D
#define REG_BK138D_0F_L      0x138D1E
#define REG_BK138D_0F_H      0x138D1F
#define REG_BK138D_10_L      0x138D20
#define REG_BK138D_10_H      0x138D21
#define REG_BK138D_11_L      0x138D22
#define REG_BK138D_11_H      0x138D23
#define REG_BK138D_12_L      0x138D24
#define REG_BK138D_12_H      0x138D25
#define REG_BK138D_13_L      0x138D26
#define REG_BK138D_13_H      0x138D27
#define REG_BK138D_14_L      0x138D28
#define REG_BK138D_14_H      0x138D29
#define REG_BK138D_15_L      0x138D2A
#define REG_BK138D_15_H      0x138D2B
#define REG_BK138D_16_L      0x138D2C
#define REG_BK138D_16_H      0x138D2D
#define REG_BK138D_17_L      0x138D2E
#define REG_BK138D_17_H      0x138D2F
#define REG_BK138D_18_L      0x138D30
#define REG_BK138D_18_H      0x138D31
#define REG_BK138D_19_L      0x138D32
#define REG_BK138D_19_H      0x138D33
#define REG_BK138D_1A_L      0x138D34
#define REG_BK138D_1A_H      0x138D35
#define REG_BK138D_1B_L      0x138D36
#define REG_BK138D_1B_H      0x138D37
#define REG_BK138D_1C_L      0x138D38
#define REG_BK138D_1C_H      0x138D39
#define REG_BK138D_1D_L      0x138D3A
#define REG_BK138D_1D_H      0x138D3B
#define REG_BK138D_1E_L      0x138D3C
#define REG_BK138D_1E_H      0x138D3D
#define REG_BK138D_1F_L      0x138D3E
#define REG_BK138D_1F_H      0x138D3F
#define REG_BK138D_20_L      0x138D40
#define REG_BK138D_20_H      0x138D41
#define REG_BK138D_21_L      0x138D42
#define REG_BK138D_21_H      0x138D43
#define REG_BK138D_22_L      0x138D44
#define REG_BK138D_22_H      0x138D45
#define REG_BK138D_23_L      0x138D46
#define REG_BK138D_23_H      0x138D47
#define REG_BK138D_24_L      0x138D48
#define REG_BK138D_24_H      0x138D49
#define REG_BK138D_25_L      0x138D4A
#define REG_BK138D_25_H      0x138D4B
#define REG_BK138D_26_L      0x138D4C
#define REG_BK138D_26_H      0x138D4D
#define REG_BK138D_27_L      0x138D4E
#define REG_BK138D_27_H      0x138D4F
#define REG_BK138D_28_L      0x138D50
#define REG_BK138D_28_H      0x138D51
#define REG_BK138D_29_L      0x138D52
#define REG_BK138D_29_H      0x138D53
#define REG_BK138D_2A_L      0x138D54
#define REG_BK138D_2A_H      0x138D55
#define REG_BK138D_2B_L      0x138D56
#define REG_BK138D_2B_H      0x138D57
#define REG_BK138D_2C_L      0x138D58
#define REG_BK138D_2C_H      0x138D59
#define REG_BK138D_2D_L      0x138D5A
#define REG_BK138D_2D_H      0x138D5B
#define REG_BK138D_2E_L      0x138D5C
#define REG_BK138D_2E_H      0x138D5D
#define REG_BK138D_2F_L      0x138D5E
#define REG_BK138D_2F_H      0x138D5F
#define REG_BK138D_30_L      0x138D60
#define REG_BK138D_30_H      0x138D61
#define REG_BK138D_31_L      0x138D62
#define REG_BK138D_31_H      0x138D63
#define REG_BK138D_32_L      0x138D64
#define REG_BK138D_32_H      0x138D65
#define REG_BK138D_33_L      0x138D66
#define REG_BK138D_33_H      0x138D67
#define REG_BK138D_34_L      0x138D68
#define REG_BK138D_34_H      0x138D69
#define REG_BK138D_35_L      0x138D6A
#define REG_BK138D_35_H      0x138D6B
#define REG_BK138D_36_L      0x138D6C
#define REG_BK138D_36_H      0x138D6D
#define REG_BK138D_37_L      0x138D6E
#define REG_BK138D_37_H      0x138D6F
#define REG_BK138D_38_L      0x138D70
#define REG_BK138D_38_H      0x138D71
#define REG_BK138D_39_L      0x138D72
#define REG_BK138D_39_H      0x138D73
#define REG_BK138D_3A_L      0x138D74
#define REG_BK138D_3A_H      0x138D75
#define REG_BK138D_3B_L      0x138D76
#define REG_BK138D_3B_H      0x138D77
#define REG_BK138D_3C_L      0x138D78
#define REG_BK138D_3C_H      0x138D79
#define REG_BK138D_3D_L      0x138D7A
#define REG_BK138D_3D_H      0x138D7B
#define REG_BK138D_3E_L      0x138D7C
#define REG_BK138D_3E_H      0x138D7D
#define REG_BK138D_3F_L      0x138D7E
#define REG_BK138D_3F_H      0x138D7F
#define REG_BK138D_40_L      0x138D80
#define REG_BK138D_40_H      0x138D81
#define REG_BK138D_41_L      0x138D82
#define REG_BK138D_41_H      0x138D83
#define REG_BK138D_42_L      0x138D84
#define REG_BK138D_42_H      0x138D85
#define REG_BK138D_43_L      0x138D86
#define REG_BK138D_43_H      0x138D87
#define REG_BK138D_44_L      0x138D88
#define REG_BK138D_44_H      0x138D89
#define REG_BK138D_45_L      0x138D8A
#define REG_BK138D_45_H      0x138D8B
#define REG_BK138D_46_L      0x138D8C
#define REG_BK138D_46_H      0x138D8D
#define REG_BK138D_47_L      0x138D8E
#define REG_BK138D_47_H      0x138D8F
#define REG_BK138D_48_L      0x138D90
#define REG_BK138D_48_H      0x138D91
#define REG_BK138D_49_L      0x138D92
#define REG_BK138D_49_H      0x138D93
#define REG_BK138D_4A_L      0x138D94
#define REG_BK138D_4A_H      0x138D95
#define REG_BK138D_4B_L      0x138D96
#define REG_BK138D_4B_H      0x138D97
#define REG_BK138D_4C_L      0x138D98
#define REG_BK138D_4C_H      0x138D99
#define REG_BK138D_4D_L      0x138D9A
#define REG_BK138D_4D_H      0x138D9B
#define REG_BK138D_4E_L      0x138D9C
#define REG_BK138D_4E_H      0x138D9D
#define REG_BK138D_4F_L      0x138D9E
#define REG_BK138D_4F_H      0x138D9F
#define REG_BK138D_50_L      0x138DA0
#define REG_BK138D_50_H      0x138DA1
#define REG_BK138D_51_L      0x138DA2
#define REG_BK138D_51_H      0x138DA3
#define REG_BK138D_52_L      0x138DA4
#define REG_BK138D_52_H      0x138DA5
#define REG_BK138D_53_L      0x138DA6
#define REG_BK138D_53_H      0x138DA7
#define REG_BK138D_54_L      0x138DA8
#define REG_BK138D_54_H      0x138DA9
#define REG_BK138D_55_L      0x138DAA
#define REG_BK138D_55_H      0x138DAB
#define REG_BK138D_56_L      0x138DAC
#define REG_BK138D_56_H      0x138DAD
#define REG_BK138D_57_L      0x138DAE
#define REG_BK138D_57_H      0x138DAF
#define REG_BK138D_58_L      0x138DB0
#define REG_BK138D_58_H      0x138DB1
#define REG_BK138D_59_L      0x138DB2
#define REG_BK138D_59_H      0x138DB3
#define REG_BK138D_5A_L      0x138DB4
#define REG_BK138D_5A_H      0x138DB5
#define REG_BK138D_5B_L      0x138DB6
#define REG_BK138D_5B_H      0x138DB7
#define REG_BK138D_5C_L      0x138DB8
#define REG_BK138D_5C_H      0x138DB9
#define REG_BK138D_5D_L      0x138DBA
#define REG_BK138D_5D_H      0x138DBB
#define REG_BK138D_5E_L      0x138DBC
#define REG_BK138D_5E_H      0x138DBD
#define REG_BK138D_5F_L      0x138DBE
#define REG_BK138D_5F_H      0x138DBF
#define REG_BK138D_60_L      0x138DC0
#define REG_BK138D_60_H      0x138DC1
#define REG_BK138D_61_L      0x138DC2
#define REG_BK138D_61_H      0x138DC3
#define REG_BK138D_62_L      0x138DC4
#define REG_BK138D_62_H      0x138DC5
#define REG_BK138D_63_L      0x138DC6
#define REG_BK138D_63_H      0x138DC7
#define REG_BK138D_64_L      0x138DC8
#define REG_BK138D_64_H      0x138DC9
#define REG_BK138D_65_L      0x138DCA
#define REG_BK138D_65_H      0x138DCB
#define REG_BK138D_66_L      0x138DCC
#define REG_BK138D_66_H      0x138DCD
#define REG_BK138D_67_L      0x138DCE
#define REG_BK138D_67_H      0x138DCF
#define REG_BK138D_68_L      0x138DD0
#define REG_BK138D_68_H      0x138DD1
#define REG_BK138D_69_L      0x138DD2
#define REG_BK138D_69_H      0x138DD3
#define REG_BK138D_6A_L      0x138DD4
#define REG_BK138D_6A_H      0x138DD5
#define REG_BK138D_6B_L      0x138DD6
#define REG_BK138D_6B_H      0x138DD7
#define REG_BK138D_6C_L      0x138DD8
#define REG_BK138D_6C_H      0x138DD9
#define REG_BK138D_6D_L      0x138DDA
#define REG_BK138D_6D_H      0x138DDB
#define REG_BK138D_6E_L      0x138DDC
#define REG_BK138D_6E_H      0x138DDD
#define REG_BK138D_6F_L      0x138DDE
#define REG_BK138D_6F_H      0x138DDF
#define REG_BK138D_70_L      0x138DE0
#define REG_BK138D_70_H      0x138DE1
#define REG_BK138D_71_L      0x138DE2
#define REG_BK138D_71_H      0x138DE3
#define REG_BK138D_72_L      0x138DE4
#define REG_BK138D_72_H      0x138DE5
#define REG_BK138D_73_L      0x138DE6
#define REG_BK138D_73_H      0x138DE7
#define REG_BK138D_74_L      0x138DE8
#define REG_BK138D_74_H      0x138DE9
#define REG_BK138D_75_L      0x138DEA
#define REG_BK138D_75_H      0x138DEB
#define REG_BK138D_76_L      0x138DEC
#define REG_BK138D_76_H      0x138DED
#define REG_BK138D_77_L      0x138DEE
#define REG_BK138D_77_H      0x138DEF
#define REG_BK138D_78_L      0x138DF0
#define REG_BK138D_78_H      0x138DF1
#define REG_BK138D_79_L      0x138DF2
#define REG_BK138D_79_H      0x138DF3
#define REG_BK138D_7A_L      0x138DF4
#define REG_BK138D_7A_H      0x138DF5
#define REG_BK138D_7B_L      0x138DF6
#define REG_BK138D_7B_H      0x138DF7
#define REG_BK138D_7C_L      0x138DF8
#define REG_BK138D_7C_H      0x138DF9
#define REG_BK138D_7D_L      0x138DFA
#define REG_BK138D_7D_H      0x138DFB
#define REG_BK138D_7E_L      0x138DFC
#define REG_BK138D_7E_H      0x138DFD
#define REG_BK138D_7F_L      0x138DFE
#define REG_BK138D_7F_H      0x138DFF
//----------------------------------------------
#define REG_BK138E_00_L      0x138E00
#define REG_BK138E_00_H      0x138E01
#define REG_BK138E_01_L      0x138E02
#define REG_BK138E_01_H      0x138E03
#define REG_BK138E_02_L      0x138E04
#define REG_BK138E_02_H      0x138E05
#define REG_BK138E_03_L      0x138E06
#define REG_BK138E_03_H      0x138E07
#define REG_BK138E_04_L      0x138E08
#define REG_BK138E_04_H      0x138E09
#define REG_BK138E_05_L      0x138E0A
#define REG_BK138E_05_H      0x138E0B
#define REG_BK138E_06_L      0x138E0C
#define REG_BK138E_06_H      0x138E0D
#define REG_BK138E_07_L      0x138E0E
#define REG_BK138E_07_H      0x138E0F
#define REG_BK138E_08_L      0x138E10
#define REG_BK138E_08_H      0x138E11
#define REG_BK138E_09_L      0x138E12
#define REG_BK138E_09_H      0x138E13
#define REG_BK138E_0A_L      0x138E14
#define REG_BK138E_0A_H      0x138E15
#define REG_BK138E_0B_L      0x138E16
#define REG_BK138E_0B_H      0x138E17
#define REG_BK138E_0C_L      0x138E18
#define REG_BK138E_0C_H      0x138E19
#define REG_BK138E_0D_L      0x138E1A
#define REG_BK138E_0D_H      0x138E1B
#define REG_BK138E_0E_L      0x138E1C
#define REG_BK138E_0E_H      0x138E1D
#define REG_BK138E_0F_L      0x138E1E
#define REG_BK138E_0F_H      0x138E1F
#define REG_BK138E_10_L      0x138E20
#define REG_BK138E_10_H      0x138E21
#define REG_BK138E_11_L      0x138E22
#define REG_BK138E_11_H      0x138E23
#define REG_BK138E_12_L      0x138E24
#define REG_BK138E_12_H      0x138E25
#define REG_BK138E_13_L      0x138E26
#define REG_BK138E_13_H      0x138E27
#define REG_BK138E_14_L      0x138E28
#define REG_BK138E_14_H      0x138E29
#define REG_BK138E_15_L      0x138E2A
#define REG_BK138E_15_H      0x138E2B
#define REG_BK138E_16_L      0x138E2C
#define REG_BK138E_16_H      0x138E2D
#define REG_BK138E_17_L      0x138E2E
#define REG_BK138E_17_H      0x138E2F
#define REG_BK138E_18_L      0x138E30
#define REG_BK138E_18_H      0x138E31
#define REG_BK138E_19_L      0x138E32
#define REG_BK138E_19_H      0x138E33
#define REG_BK138E_1A_L      0x138E34
#define REG_BK138E_1A_H      0x138E35
#define REG_BK138E_1B_L      0x138E36
#define REG_BK138E_1B_H      0x138E37
#define REG_BK138E_1C_L      0x138E38
#define REG_BK138E_1C_H      0x138E39
#define REG_BK138E_1D_L      0x138E3A
#define REG_BK138E_1D_H      0x138E3B
#define REG_BK138E_1E_L      0x138E3C
#define REG_BK138E_1E_H      0x138E3D
#define REG_BK138E_1F_L      0x138E3E
#define REG_BK138E_1F_H      0x138E3F
#define REG_BK138E_20_L      0x138E40
#define REG_BK138E_20_H      0x138E41
#define REG_BK138E_21_L      0x138E42
#define REG_BK138E_21_H      0x138E43
#define REG_BK138E_22_L      0x138E44
#define REG_BK138E_22_H      0x138E45
#define REG_BK138E_23_L      0x138E46
#define REG_BK138E_23_H      0x138E47
#define REG_BK138E_24_L      0x138E48
#define REG_BK138E_24_H      0x138E49
#define REG_BK138E_25_L      0x138E4A
#define REG_BK138E_25_H      0x138E4B
#define REG_BK138E_26_L      0x138E4C
#define REG_BK138E_26_H      0x138E4D
#define REG_BK138E_27_L      0x138E4E
#define REG_BK138E_27_H      0x138E4F
#define REG_BK138E_28_L      0x138E50
#define REG_BK138E_28_H      0x138E51
#define REG_BK138E_29_L      0x138E52
#define REG_BK138E_29_H      0x138E53
#define REG_BK138E_2A_L      0x138E54
#define REG_BK138E_2A_H      0x138E55
#define REG_BK138E_2B_L      0x138E56
#define REG_BK138E_2B_H      0x138E57
#define REG_BK138E_2C_L      0x138E58
#define REG_BK138E_2C_H      0x138E59
#define REG_BK138E_2D_L      0x138E5A
#define REG_BK138E_2D_H      0x138E5B
#define REG_BK138E_2E_L      0x138E5C
#define REG_BK138E_2E_H      0x138E5D
#define REG_BK138E_2F_L      0x138E5E
#define REG_BK138E_2F_H      0x138E5F
#define REG_BK138E_30_L      0x138E60
#define REG_BK138E_30_H      0x138E61
#define REG_BK138E_31_L      0x138E62
#define REG_BK138E_31_H      0x138E63
#define REG_BK138E_32_L      0x138E64
#define REG_BK138E_32_H      0x138E65
#define REG_BK138E_33_L      0x138E66
#define REG_BK138E_33_H      0x138E67
#define REG_BK138E_34_L      0x138E68
#define REG_BK138E_34_H      0x138E69
#define REG_BK138E_35_L      0x138E6A
#define REG_BK138E_35_H      0x138E6B
#define REG_BK138E_36_L      0x138E6C
#define REG_BK138E_36_H      0x138E6D
#define REG_BK138E_37_L      0x138E6E
#define REG_BK138E_37_H      0x138E6F
#define REG_BK138E_38_L      0x138E70
#define REG_BK138E_38_H      0x138E71
#define REG_BK138E_39_L      0x138E72
#define REG_BK138E_39_H      0x138E73
#define REG_BK138E_3A_L      0x138E74
#define REG_BK138E_3A_H      0x138E75
#define REG_BK138E_3B_L      0x138E76
#define REG_BK138E_3B_H      0x138E77
#define REG_BK138E_3C_L      0x138E78
#define REG_BK138E_3C_H      0x138E79
#define REG_BK138E_3D_L      0x138E7A
#define REG_BK138E_3D_H      0x138E7B
#define REG_BK138E_3E_L      0x138E7C
#define REG_BK138E_3E_H      0x138E7D
#define REG_BK138E_3F_L      0x138E7E
#define REG_BK138E_3F_H      0x138E7F
#define REG_BK138E_40_L      0x138E80
#define REG_BK138E_40_H      0x138E81
#define REG_BK138E_41_L      0x138E82
#define REG_BK138E_41_H      0x138E83
#define REG_BK138E_42_L      0x138E84
#define REG_BK138E_42_H      0x138E85
#define REG_BK138E_43_L      0x138E86
#define REG_BK138E_43_H      0x138E87
#define REG_BK138E_44_L      0x138E88
#define REG_BK138E_44_H      0x138E89
#define REG_BK138E_45_L      0x138E8A
#define REG_BK138E_45_H      0x138E8B
#define REG_BK138E_46_L      0x138E8C
#define REG_BK138E_46_H      0x138E8D
#define REG_BK138E_47_L      0x138E8E
#define REG_BK138E_47_H      0x138E8F
#define REG_BK138E_48_L      0x138E90
#define REG_BK138E_48_H      0x138E91
#define REG_BK138E_49_L      0x138E92
#define REG_BK138E_49_H      0x138E93
#define REG_BK138E_4A_L      0x138E94
#define REG_BK138E_4A_H      0x138E95
#define REG_BK138E_4B_L      0x138E96
#define REG_BK138E_4B_H      0x138E97
#define REG_BK138E_4C_L      0x138E98
#define REG_BK138E_4C_H      0x138E99
#define REG_BK138E_4D_L      0x138E9A
#define REG_BK138E_4D_H      0x138E9B
#define REG_BK138E_4E_L      0x138E9C
#define REG_BK138E_4E_H      0x138E9D
#define REG_BK138E_4F_L      0x138E9E
#define REG_BK138E_4F_H      0x138E9F
#define REG_BK138E_50_L      0x138EA0
#define REG_BK138E_50_H      0x138EA1
#define REG_BK138E_51_L      0x138EA2
#define REG_BK138E_51_H      0x138EA3
#define REG_BK138E_52_L      0x138EA4
#define REG_BK138E_52_H      0x138EA5
#define REG_BK138E_53_L      0x138EA6
#define REG_BK138E_53_H      0x138EA7
#define REG_BK138E_54_L      0x138EA8
#define REG_BK138E_54_H      0x138EA9
#define REG_BK138E_55_L      0x138EAA
#define REG_BK138E_55_H      0x138EAB
#define REG_BK138E_56_L      0x138EAC
#define REG_BK138E_56_H      0x138EAD
#define REG_BK138E_57_L      0x138EAE
#define REG_BK138E_57_H      0x138EAF
#define REG_BK138E_58_L      0x138EB0
#define REG_BK138E_58_H      0x138EB1
#define REG_BK138E_59_L      0x138EB2
#define REG_BK138E_59_H      0x138EB3
#define REG_BK138E_5A_L      0x138EB4
#define REG_BK138E_5A_H      0x138EB5
#define REG_BK138E_5B_L      0x138EB6
#define REG_BK138E_5B_H      0x138EB7
#define REG_BK138E_5C_L      0x138EB8
#define REG_BK138E_5C_H      0x138EB9
#define REG_BK138E_5D_L      0x138EBA
#define REG_BK138E_5D_H      0x138EBB
#define REG_BK138E_5E_L      0x138EBC
#define REG_BK138E_5E_H      0x138EBD
#define REG_BK138E_5F_L      0x138EBE
#define REG_BK138E_5F_H      0x138EBF
#define REG_BK138E_60_L      0x138EC0
#define REG_BK138E_60_H      0x138EC1
#define REG_BK138E_61_L      0x138EC2
#define REG_BK138E_61_H      0x138EC3
#define REG_BK138E_62_L      0x138EC4
#define REG_BK138E_62_H      0x138EC5
#define REG_BK138E_63_L      0x138EC6
#define REG_BK138E_63_H      0x138EC7
#define REG_BK138E_64_L      0x138EC8
#define REG_BK138E_64_H      0x138EC9
#define REG_BK138E_65_L      0x138ECA
#define REG_BK138E_65_H      0x138ECB
#define REG_BK138E_66_L      0x138ECC
#define REG_BK138E_66_H      0x138ECD
#define REG_BK138E_67_L      0x138ECE
#define REG_BK138E_67_H      0x138ECF
#define REG_BK138E_68_L      0x138ED0
#define REG_BK138E_68_H      0x138ED1
#define REG_BK138E_69_L      0x138ED2
#define REG_BK138E_69_H      0x138ED3
#define REG_BK138E_6A_L      0x138ED4
#define REG_BK138E_6A_H      0x138ED5
#define REG_BK138E_6B_L      0x138ED6
#define REG_BK138E_6B_H      0x138ED7
#define REG_BK138E_6C_L      0x138ED8
#define REG_BK138E_6C_H      0x138ED9
#define REG_BK138E_6D_L      0x138EDA
#define REG_BK138E_6D_H      0x138EDB
#define REG_BK138E_6E_L      0x138EDC
#define REG_BK138E_6E_H      0x138EDD
#define REG_BK138E_6F_L      0x138EDE
#define REG_BK138E_6F_H      0x138EDF
#define REG_BK138E_70_L      0x138EE0
#define REG_BK138E_70_H      0x138EE1
#define REG_BK138E_71_L      0x138EE2
#define REG_BK138E_71_H      0x138EE3
#define REG_BK138E_72_L      0x138EE4
#define REG_BK138E_72_H      0x138EE5
#define REG_BK138E_73_L      0x138EE6
#define REG_BK138E_73_H      0x138EE7
#define REG_BK138E_74_L      0x138EE8
#define REG_BK138E_74_H      0x138EE9
#define REG_BK138E_75_L      0x138EEA
#define REG_BK138E_75_H      0x138EEB
#define REG_BK138E_76_L      0x138EEC
#define REG_BK138E_76_H      0x138EED
#define REG_BK138E_77_L      0x138EEE
#define REG_BK138E_77_H      0x138EEF
#define REG_BK138E_78_L      0x138EF0
#define REG_BK138E_78_H      0x138EF1
#define REG_BK138E_79_L      0x138EF2
#define REG_BK138E_79_H      0x138EF3
#define REG_BK138E_7A_L      0x138EF4
#define REG_BK138E_7A_H      0x138EF5
#define REG_BK138E_7B_L      0x138EF6
#define REG_BK138E_7B_H      0x138EF7
#define REG_BK138E_7C_L      0x138EF8
#define REG_BK138E_7C_H      0x138EF9
#define REG_BK138E_7D_L      0x138EFA
#define REG_BK138E_7D_H      0x138EFB
#define REG_BK138E_7E_L      0x138EFC
#define REG_BK138E_7E_H      0x138EFD
#define REG_BK138E_7F_L      0x138EFE
#define REG_BK138E_7F_H      0x138EFF
//----------------------------------------------
#define REG_BK138F_00_L      0x138F00
#define REG_BK138F_00_H      0x138F01
#define REG_BK138F_01_L      0x138F02
#define REG_BK138F_01_H      0x138F03
#define REG_BK138F_02_L      0x138F04
#define REG_BK138F_02_H      0x138F05
#define REG_BK138F_03_L      0x138F06
#define REG_BK138F_03_H      0x138F07
#define REG_BK138F_04_L      0x138F08
#define REG_BK138F_04_H      0x138F09
#define REG_BK138F_05_L      0x138F0A
#define REG_BK138F_05_H      0x138F0B
#define REG_BK138F_06_L      0x138F0C
#define REG_BK138F_06_H      0x138F0D
#define REG_BK138F_07_L      0x138F0E
#define REG_BK138F_07_H      0x138F0F
#define REG_BK138F_08_L      0x138F10
#define REG_BK138F_08_H      0x138F11
#define REG_BK138F_09_L      0x138F12
#define REG_BK138F_09_H      0x138F13
#define REG_BK138F_0A_L      0x138F14
#define REG_BK138F_0A_H      0x138F15
#define REG_BK138F_0B_L      0x138F16
#define REG_BK138F_0B_H      0x138F17
#define REG_BK138F_0C_L      0x138F18
#define REG_BK138F_0C_H      0x138F19
#define REG_BK138F_0D_L      0x138F1A
#define REG_BK138F_0D_H      0x138F1B
#define REG_BK138F_0E_L      0x138F1C
#define REG_BK138F_0E_H      0x138F1D
#define REG_BK138F_0F_L      0x138F1E
#define REG_BK138F_0F_H      0x138F1F
#define REG_BK138F_10_L      0x138F20
#define REG_BK138F_10_H      0x138F21
#define REG_BK138F_11_L      0x138F22
#define REG_BK138F_11_H      0x138F23
#define REG_BK138F_12_L      0x138F24
#define REG_BK138F_12_H      0x138F25
#define REG_BK138F_13_L      0x138F26
#define REG_BK138F_13_H      0x138F27
#define REG_BK138F_14_L      0x138F28
#define REG_BK138F_14_H      0x138F29
#define REG_BK138F_15_L      0x138F2A
#define REG_BK138F_15_H      0x138F2B
#define REG_BK138F_16_L      0x138F2C
#define REG_BK138F_16_H      0x138F2D
#define REG_BK138F_17_L      0x138F2E
#define REG_BK138F_17_H      0x138F2F
#define REG_BK138F_18_L      0x138F30
#define REG_BK138F_18_H      0x138F31
#define REG_BK138F_19_L      0x138F32
#define REG_BK138F_19_H      0x138F33
#define REG_BK138F_1A_L      0x138F34
#define REG_BK138F_1A_H      0x138F35
#define REG_BK138F_1B_L      0x138F36
#define REG_BK138F_1B_H      0x138F37
#define REG_BK138F_1C_L      0x138F38
#define REG_BK138F_1C_H      0x138F39
#define REG_BK138F_1D_L      0x138F3A
#define REG_BK138F_1D_H      0x138F3B
#define REG_BK138F_1E_L      0x138F3C
#define REG_BK138F_1E_H      0x138F3D
#define REG_BK138F_1F_L      0x138F3E
#define REG_BK138F_1F_H      0x138F3F
#define REG_BK138F_20_L      0x138F40
#define REG_BK138F_20_H      0x138F41
#define REG_BK138F_21_L      0x138F42
#define REG_BK138F_21_H      0x138F43
#define REG_BK138F_22_L      0x138F44
#define REG_BK138F_22_H      0x138F45
#define REG_BK138F_23_L      0x138F46
#define REG_BK138F_23_H      0x138F47
#define REG_BK138F_24_L      0x138F48
#define REG_BK138F_24_H      0x138F49
#define REG_BK138F_25_L      0x138F4A
#define REG_BK138F_25_H      0x138F4B
#define REG_BK138F_26_L      0x138F4C
#define REG_BK138F_26_H      0x138F4D
#define REG_BK138F_27_L      0x138F4E
#define REG_BK138F_27_H      0x138F4F
#define REG_BK138F_28_L      0x138F50
#define REG_BK138F_28_H      0x138F51
#define REG_BK138F_29_L      0x138F52
#define REG_BK138F_29_H      0x138F53
#define REG_BK138F_2A_L      0x138F54
#define REG_BK138F_2A_H      0x138F55
#define REG_BK138F_2B_L      0x138F56
#define REG_BK138F_2B_H      0x138F57
#define REG_BK138F_2C_L      0x138F58
#define REG_BK138F_2C_H      0x138F59
#define REG_BK138F_2D_L      0x138F5A
#define REG_BK138F_2D_H      0x138F5B
#define REG_BK138F_2E_L      0x138F5C
#define REG_BK138F_2E_H      0x138F5D
#define REG_BK138F_2F_L      0x138F5E
#define REG_BK138F_2F_H      0x138F5F
#define REG_BK138F_30_L      0x138F60
#define REG_BK138F_30_H      0x138F61
#define REG_BK138F_31_L      0x138F62
#define REG_BK138F_31_H      0x138F63
#define REG_BK138F_32_L      0x138F64
#define REG_BK138F_32_H      0x138F65
#define REG_BK138F_33_L      0x138F66
#define REG_BK138F_33_H      0x138F67
#define REG_BK138F_34_L      0x138F68
#define REG_BK138F_34_H      0x138F69
#define REG_BK138F_35_L      0x138F6A
#define REG_BK138F_35_H      0x138F6B
#define REG_BK138F_36_L      0x138F6C
#define REG_BK138F_36_H      0x138F6D
#define REG_BK138F_37_L      0x138F6E
#define REG_BK138F_37_H      0x138F6F
#define REG_BK138F_38_L      0x138F70
#define REG_BK138F_38_H      0x138F71
#define REG_BK138F_39_L      0x138F72
#define REG_BK138F_39_H      0x138F73
#define REG_BK138F_3A_L      0x138F74
#define REG_BK138F_3A_H      0x138F75
#define REG_BK138F_3B_L      0x138F76
#define REG_BK138F_3B_H      0x138F77
#define REG_BK138F_3C_L      0x138F78
#define REG_BK138F_3C_H      0x138F79
#define REG_BK138F_3D_L      0x138F7A
#define REG_BK138F_3D_H      0x138F7B
#define REG_BK138F_3E_L      0x138F7C
#define REG_BK138F_3E_H      0x138F7D
#define REG_BK138F_3F_L      0x138F7E
#define REG_BK138F_3F_H      0x138F7F
#define REG_BK138F_40_L      0x138F80
#define REG_BK138F_40_H      0x138F81
#define REG_BK138F_41_L      0x138F82
#define REG_BK138F_41_H      0x138F83
#define REG_BK138F_42_L      0x138F84
#define REG_BK138F_42_H      0x138F85
#define REG_BK138F_43_L      0x138F86
#define REG_BK138F_43_H      0x138F87
#define REG_BK138F_44_L      0x138F88
#define REG_BK138F_44_H      0x138F89
#define REG_BK138F_45_L      0x138F8A
#define REG_BK138F_45_H      0x138F8B
#define REG_BK138F_46_L      0x138F8C
#define REG_BK138F_46_H      0x138F8D
#define REG_BK138F_47_L      0x138F8E
#define REG_BK138F_47_H      0x138F8F
#define REG_BK138F_48_L      0x138F90
#define REG_BK138F_48_H      0x138F91
#define REG_BK138F_49_L      0x138F92
#define REG_BK138F_49_H      0x138F93
#define REG_BK138F_4A_L      0x138F94
#define REG_BK138F_4A_H      0x138F95
#define REG_BK138F_4B_L      0x138F96
#define REG_BK138F_4B_H      0x138F97
#define REG_BK138F_4C_L      0x138F98
#define REG_BK138F_4C_H      0x138F99
#define REG_BK138F_4D_L      0x138F9A
#define REG_BK138F_4D_H      0x138F9B
#define REG_BK138F_4E_L      0x138F9C
#define REG_BK138F_4E_H      0x138F9D
#define REG_BK138F_4F_L      0x138F9E
#define REG_BK138F_4F_H      0x138F9F
#define REG_BK138F_50_L      0x138FA0
#define REG_BK138F_50_H      0x138FA1
#define REG_BK138F_51_L      0x138FA2
#define REG_BK138F_51_H      0x138FA3
#define REG_BK138F_52_L      0x138FA4
#define REG_BK138F_52_H      0x138FA5
#define REG_BK138F_53_L      0x138FA6
#define REG_BK138F_53_H      0x138FA7
#define REG_BK138F_54_L      0x138FA8
#define REG_BK138F_54_H      0x138FA9
#define REG_BK138F_55_L      0x138FAA
#define REG_BK138F_55_H      0x138FAB
#define REG_BK138F_56_L      0x138FAC
#define REG_BK138F_56_H      0x138FAD
#define REG_BK138F_57_L      0x138FAE
#define REG_BK138F_57_H      0x138FAF
#define REG_BK138F_58_L      0x138FB0
#define REG_BK138F_58_H      0x138FB1
#define REG_BK138F_59_L      0x138FB2
#define REG_BK138F_59_H      0x138FB3
#define REG_BK138F_5A_L      0x138FB4
#define REG_BK138F_5A_H      0x138FB5
#define REG_BK138F_5B_L      0x138FB6
#define REG_BK138F_5B_H      0x138FB7
#define REG_BK138F_5C_L      0x138FB8
#define REG_BK138F_5C_H      0x138FB9
#define REG_BK138F_5D_L      0x138FBA
#define REG_BK138F_5D_H      0x138FBB
#define REG_BK138F_5E_L      0x138FBC
#define REG_BK138F_5E_H      0x138FBD
#define REG_BK138F_5F_L      0x138FBE
#define REG_BK138F_5F_H      0x138FBF
#define REG_BK138F_60_L      0x138FC0
#define REG_BK138F_60_H      0x138FC1
#define REG_BK138F_61_L      0x138FC2
#define REG_BK138F_61_H      0x138FC3
#define REG_BK138F_62_L      0x138FC4
#define REG_BK138F_62_H      0x138FC5
#define REG_BK138F_63_L      0x138FC6
#define REG_BK138F_63_H      0x138FC7
#define REG_BK138F_64_L      0x138FC8
#define REG_BK138F_64_H      0x138FC9
#define REG_BK138F_65_L      0x138FCA
#define REG_BK138F_65_H      0x138FCB
#define REG_BK138F_66_L      0x138FCC
#define REG_BK138F_66_H      0x138FCD
#define REG_BK138F_67_L      0x138FCE
#define REG_BK138F_67_H      0x138FCF
#define REG_BK138F_68_L      0x138FD0
#define REG_BK138F_68_H      0x138FD1
#define REG_BK138F_69_L      0x138FD2
#define REG_BK138F_69_H      0x138FD3
#define REG_BK138F_6A_L      0x138FD4
#define REG_BK138F_6A_H      0x138FD5
#define REG_BK138F_6B_L      0x138FD6
#define REG_BK138F_6B_H      0x138FD7
#define REG_BK138F_6C_L      0x138FD8
#define REG_BK138F_6C_H      0x138FD9
#define REG_BK138F_6D_L      0x138FDA
#define REG_BK138F_6D_H      0x138FDB
#define REG_BK138F_6E_L      0x138FDC
#define REG_BK138F_6E_H      0x138FDD
#define REG_BK138F_6F_L      0x138FDE
#define REG_BK138F_6F_H      0x138FDF
#define REG_BK138F_70_L      0x138FE0
#define REG_BK138F_70_H      0x138FE1
#define REG_BK138F_71_L      0x138FE2
#define REG_BK138F_71_H      0x138FE3
#define REG_BK138F_72_L      0x138FE4
#define REG_BK138F_72_H      0x138FE5
#define REG_BK138F_73_L      0x138FE6
#define REG_BK138F_73_H      0x138FE7
#define REG_BK138F_74_L      0x138FE8
#define REG_BK138F_74_H      0x138FE9
#define REG_BK138F_75_L      0x138FEA
#define REG_BK138F_75_H      0x138FEB
#define REG_BK138F_76_L      0x138FEC
#define REG_BK138F_76_H      0x138FED
#define REG_BK138F_77_L      0x138FEE
#define REG_BK138F_77_H      0x138FEF
#define REG_BK138F_78_L      0x138FF0
#define REG_BK138F_78_H      0x138FF1
#define REG_BK138F_79_L      0x138FF2
#define REG_BK138F_79_H      0x138FF3
#define REG_BK138F_7A_L      0x138FF4
#define REG_BK138F_7A_H      0x138FF5
#define REG_BK138F_7B_L      0x138FF6
#define REG_BK138F_7B_H      0x138FF7
#define REG_BK138F_7C_L      0x138FF8
#define REG_BK138F_7C_H      0x138FF9
#define REG_BK138F_7D_L      0x138FFA
#define REG_BK138F_7D_H      0x138FFB
#define REG_BK138F_7E_L      0x138FFC
#define REG_BK138F_7E_H      0x138FFD
#define REG_BK138F_7F_L      0x138FFE
#define REG_BK138F_7F_H      0x138FFF
//----------------------------------------------
#define REG_BK1390_00_L      0x139000
#define REG_BK1390_00_H      0x139001
#define REG_BK1390_01_L      0x139002
#define REG_BK1390_01_H      0x139003
#define REG_BK1390_02_L      0x139004
#define REG_BK1390_02_H      0x139005
#define REG_BK1390_03_L      0x139006
#define REG_BK1390_03_H      0x139007
#define REG_BK1390_04_L      0x139008
#define REG_BK1390_04_H      0x139009
#define REG_BK1390_05_L      0x13900A
#define REG_BK1390_05_H      0x13900B
#define REG_BK1390_06_L      0x13900C
#define REG_BK1390_06_H      0x13900D
#define REG_BK1390_07_L      0x13900E
#define REG_BK1390_07_H      0x13900F
#define REG_BK1390_08_L      0x139010
#define REG_BK1390_08_H      0x139011
#define REG_BK1390_09_L      0x139012
#define REG_BK1390_09_H      0x139013
#define REG_BK1390_0A_L      0x139014
#define REG_BK1390_0A_H      0x139015
#define REG_BK1390_0B_L      0x139016
#define REG_BK1390_0B_H      0x139017
#define REG_BK1390_0C_L      0x139018
#define REG_BK1390_0C_H      0x139019
#define REG_BK1390_0D_L      0x13901A
#define REG_BK1390_0D_H      0x13901B
#define REG_BK1390_0E_L      0x13901C
#define REG_BK1390_0E_H      0x13901D
#define REG_BK1390_0F_L      0x13901E
#define REG_BK1390_0F_H      0x13901F
#define REG_BK1390_10_L      0x139020
#define REG_BK1390_10_H      0x139021
#define REG_BK1390_11_L      0x139022
#define REG_BK1390_11_H      0x139023
#define REG_BK1390_12_L      0x139024
#define REG_BK1390_12_H      0x139025
#define REG_BK1390_13_L      0x139026
#define REG_BK1390_13_H      0x139027
#define REG_BK1390_14_L      0x139028
#define REG_BK1390_14_H      0x139029
#define REG_BK1390_15_L      0x13902A
#define REG_BK1390_15_H      0x13902B
#define REG_BK1390_16_L      0x13902C
#define REG_BK1390_16_H      0x13902D
#define REG_BK1390_17_L      0x13902E
#define REG_BK1390_17_H      0x13902F
#define REG_BK1390_18_L      0x139030
#define REG_BK1390_18_H      0x139031
#define REG_BK1390_19_L      0x139032
#define REG_BK1390_19_H      0x139033
#define REG_BK1390_1A_L      0x139034
#define REG_BK1390_1A_H      0x139035
#define REG_BK1390_1B_L      0x139036
#define REG_BK1390_1B_H      0x139037
#define REG_BK1390_1C_L      0x139038
#define REG_BK1390_1C_H      0x139039
#define REG_BK1390_1D_L      0x13903A
#define REG_BK1390_1D_H      0x13903B
#define REG_BK1390_1E_L      0x13903C
#define REG_BK1390_1E_H      0x13903D
#define REG_BK1390_1F_L      0x13903E
#define REG_BK1390_1F_H      0x13903F
#define REG_BK1390_20_L      0x139040
#define REG_BK1390_20_H      0x139041
#define REG_BK1390_21_L      0x139042
#define REG_BK1390_21_H      0x139043
#define REG_BK1390_22_L      0x139044
#define REG_BK1390_22_H      0x139045
#define REG_BK1390_23_L      0x139046
#define REG_BK1390_23_H      0x139047
#define REG_BK1390_24_L      0x139048
#define REG_BK1390_24_H      0x139049
#define REG_BK1390_25_L      0x13904A
#define REG_BK1390_25_H      0x13904B
#define REG_BK1390_26_L      0x13904C
#define REG_BK1390_26_H      0x13904D
#define REG_BK1390_27_L      0x13904E
#define REG_BK1390_27_H      0x13904F
#define REG_BK1390_28_L      0x139050
#define REG_BK1390_28_H      0x139051
#define REG_BK1390_29_L      0x139052
#define REG_BK1390_29_H      0x139053
#define REG_BK1390_2A_L      0x139054
#define REG_BK1390_2A_H      0x139055
#define REG_BK1390_2B_L      0x139056
#define REG_BK1390_2B_H      0x139057
#define REG_BK1390_2C_L      0x139058
#define REG_BK1390_2C_H      0x139059
#define REG_BK1390_2D_L      0x13905A
#define REG_BK1390_2D_H      0x13905B
#define REG_BK1390_2E_L      0x13905C
#define REG_BK1390_2E_H      0x13905D
#define REG_BK1390_2F_L      0x13905E
#define REG_BK1390_2F_H      0x13905F
#define REG_BK1390_30_L      0x139060
#define REG_BK1390_30_H      0x139061
#define REG_BK1390_31_L      0x139062
#define REG_BK1390_31_H      0x139063
#define REG_BK1390_32_L      0x139064
#define REG_BK1390_32_H      0x139065
#define REG_BK1390_33_L      0x139066
#define REG_BK1390_33_H      0x139067
#define REG_BK1390_34_L      0x139068
#define REG_BK1390_34_H      0x139069
#define REG_BK1390_35_L      0x13906A
#define REG_BK1390_35_H      0x13906B
#define REG_BK1390_36_L      0x13906C
#define REG_BK1390_36_H      0x13906D
#define REG_BK1390_37_L      0x13906E
#define REG_BK1390_37_H      0x13906F
#define REG_BK1390_38_L      0x139070
#define REG_BK1390_38_H      0x139071
#define REG_BK1390_39_L      0x139072
#define REG_BK1390_39_H      0x139073
#define REG_BK1390_3A_L      0x139074
#define REG_BK1390_3A_H      0x139075
#define REG_BK1390_3B_L      0x139076
#define REG_BK1390_3B_H      0x139077
#define REG_BK1390_3C_L      0x139078
#define REG_BK1390_3C_H      0x139079
#define REG_BK1390_3D_L      0x13907A
#define REG_BK1390_3D_H      0x13907B
#define REG_BK1390_3E_L      0x13907C
#define REG_BK1390_3E_H      0x13907D
#define REG_BK1390_3F_L      0x13907E
#define REG_BK1390_3F_H      0x13907F
#define REG_BK1390_40_L      0x139080
#define REG_BK1390_40_H      0x139081
#define REG_BK1390_41_L      0x139082
#define REG_BK1390_41_H      0x139083
#define REG_BK1390_42_L      0x139084
#define REG_BK1390_42_H      0x139085
#define REG_BK1390_43_L      0x139086
#define REG_BK1390_43_H      0x139087
#define REG_BK1390_44_L      0x139088
#define REG_BK1390_44_H      0x139089
#define REG_BK1390_45_L      0x13908A
#define REG_BK1390_45_H      0x13908B
#define REG_BK1390_46_L      0x13908C
#define REG_BK1390_46_H      0x13908D
#define REG_BK1390_47_L      0x13908E
#define REG_BK1390_47_H      0x13908F
#define REG_BK1390_48_L      0x139090
#define REG_BK1390_48_H      0x139091
#define REG_BK1390_49_L      0x139092
#define REG_BK1390_49_H      0x139093
#define REG_BK1390_4A_L      0x139094
#define REG_BK1390_4A_H      0x139095
#define REG_BK1390_4B_L      0x139096
#define REG_BK1390_4B_H      0x139097
#define REG_BK1390_4C_L      0x139098
#define REG_BK1390_4C_H      0x139099
#define REG_BK1390_4D_L      0x13909A
#define REG_BK1390_4D_H      0x13909B
#define REG_BK1390_4E_L      0x13909C
#define REG_BK1390_4E_H      0x13909D
#define REG_BK1390_4F_L      0x13909E
#define REG_BK1390_4F_H      0x13909F
#define REG_BK1390_50_L      0x1390A0
#define REG_BK1390_50_H      0x1390A1
#define REG_BK1390_51_L      0x1390A2
#define REG_BK1390_51_H      0x1390A3
#define REG_BK1390_52_L      0x1390A4
#define REG_BK1390_52_H      0x1390A5
#define REG_BK1390_53_L      0x1390A6
#define REG_BK1390_53_H      0x1390A7
#define REG_BK1390_54_L      0x1390A8
#define REG_BK1390_54_H      0x1390A9
#define REG_BK1390_55_L      0x1390AA
#define REG_BK1390_55_H      0x1390AB
#define REG_BK1390_56_L      0x1390AC
#define REG_BK1390_56_H      0x1390AD
#define REG_BK1390_57_L      0x1390AE
#define REG_BK1390_57_H      0x1390AF
#define REG_BK1390_58_L      0x1390B0
#define REG_BK1390_58_H      0x1390B1
#define REG_BK1390_59_L      0x1390B2
#define REG_BK1390_59_H      0x1390B3
#define REG_BK1390_5A_L      0x1390B4
#define REG_BK1390_5A_H      0x1390B5
#define REG_BK1390_5B_L      0x1390B6
#define REG_BK1390_5B_H      0x1390B7
#define REG_BK1390_5C_L      0x1390B8
#define REG_BK1390_5C_H      0x1390B9
#define REG_BK1390_5D_L      0x1390BA
#define REG_BK1390_5D_H      0x1390BB
#define REG_BK1390_5E_L      0x1390BC
#define REG_BK1390_5E_H      0x1390BD
#define REG_BK1390_5F_L      0x1390BE
#define REG_BK1390_5F_H      0x1390BF
#define REG_BK1390_60_L      0x1390C0
#define REG_BK1390_60_H      0x1390C1
#define REG_BK1390_61_L      0x1390C2
#define REG_BK1390_61_H      0x1390C3
#define REG_BK1390_62_L      0x1390C4
#define REG_BK1390_62_H      0x1390C5
#define REG_BK1390_63_L      0x1390C6
#define REG_BK1390_63_H      0x1390C7
#define REG_BK1390_64_L      0x1390C8
#define REG_BK1390_64_H      0x1390C9
#define REG_BK1390_65_L      0x1390CA
#define REG_BK1390_65_H      0x1390CB
#define REG_BK1390_66_L      0x1390CC
#define REG_BK1390_66_H      0x1390CD
#define REG_BK1390_67_L      0x1390CE
#define REG_BK1390_67_H      0x1390CF
#define REG_BK1390_68_L      0x1390D0
#define REG_BK1390_68_H      0x1390D1
#define REG_BK1390_69_L      0x1390D2
#define REG_BK1390_69_H      0x1390D3
#define REG_BK1390_6A_L      0x1390D4
#define REG_BK1390_6A_H      0x1390D5
#define REG_BK1390_6B_L      0x1390D6
#define REG_BK1390_6B_H      0x1390D7
#define REG_BK1390_6C_L      0x1390D8
#define REG_BK1390_6C_H      0x1390D9
#define REG_BK1390_6D_L      0x1390DA
#define REG_BK1390_6D_H      0x1390DB
#define REG_BK1390_6E_L      0x1390DC
#define REG_BK1390_6E_H      0x1390DD
#define REG_BK1390_6F_L      0x1390DE
#define REG_BK1390_6F_H      0x1390DF
#define REG_BK1390_70_L      0x1390E0
#define REG_BK1390_70_H      0x1390E1
#define REG_BK1390_71_L      0x1390E2
#define REG_BK1390_71_H      0x1390E3
#define REG_BK1390_72_L      0x1390E4
#define REG_BK1390_72_H      0x1390E5
#define REG_BK1390_73_L      0x1390E6
#define REG_BK1390_73_H      0x1390E7
#define REG_BK1390_74_L      0x1390E8
#define REG_BK1390_74_H      0x1390E9
#define REG_BK1390_75_L      0x1390EA
#define REG_BK1390_75_H      0x1390EB
#define REG_BK1390_76_L      0x1390EC
#define REG_BK1390_76_H      0x1390ED
#define REG_BK1390_77_L      0x1390EE
#define REG_BK1390_77_H      0x1390EF
#define REG_BK1390_78_L      0x1390F0
#define REG_BK1390_78_H      0x1390F1
#define REG_BK1390_79_L      0x1390F2
#define REG_BK1390_79_H      0x1390F3
#define REG_BK1390_7A_L      0x1390F4
#define REG_BK1390_7A_H      0x1390F5
#define REG_BK1390_7B_L      0x1390F6
#define REG_BK1390_7B_H      0x1390F7
#define REG_BK1390_7C_L      0x1390F8
#define REG_BK1390_7C_H      0x1390F9
#define REG_BK1390_7D_L      0x1390FA
#define REG_BK1390_7D_H      0x1390FB
#define REG_BK1390_7E_L      0x1390FC
#define REG_BK1390_7E_H      0x1390FD
#define REG_BK1390_7F_L      0x1390FE
#define REG_BK1390_7F_H      0x1390FF
//----------------------------------------------
#define REG_BK1391_00_L      0x139100
#define REG_BK1391_00_H      0x139101
#define REG_BK1391_01_L      0x139102
#define REG_BK1391_01_H      0x139103
#define REG_BK1391_02_L      0x139104
#define REG_BK1391_02_H      0x139105
#define REG_BK1391_03_L      0x139106
#define REG_BK1391_03_H      0x139107
#define REG_BK1391_04_L      0x139108
#define REG_BK1391_04_H      0x139109
#define REG_BK1391_05_L      0x13910A
#define REG_BK1391_05_H      0x13910B
#define REG_BK1391_06_L      0x13910C
#define REG_BK1391_06_H      0x13910D
#define REG_BK1391_07_L      0x13910E
#define REG_BK1391_07_H      0x13910F
#define REG_BK1391_08_L      0x139110
#define REG_BK1391_08_H      0x139111
#define REG_BK1391_09_L      0x139112
#define REG_BK1391_09_H      0x139113
#define REG_BK1391_0A_L      0x139114
#define REG_BK1391_0A_H      0x139115
#define REG_BK1391_0B_L      0x139116
#define REG_BK1391_0B_H      0x139117
#define REG_BK1391_0C_L      0x139118
#define REG_BK1391_0C_H      0x139119
#define REG_BK1391_0D_L      0x13911A
#define REG_BK1391_0D_H      0x13911B
#define REG_BK1391_0E_L      0x13911C
#define REG_BK1391_0E_H      0x13911D
#define REG_BK1391_0F_L      0x13911E
#define REG_BK1391_0F_H      0x13911F
#define REG_BK1391_10_L      0x139120
#define REG_BK1391_10_H      0x139121
#define REG_BK1391_11_L      0x139122
#define REG_BK1391_11_H      0x139123
#define REG_BK1391_12_L      0x139124
#define REG_BK1391_12_H      0x139125
#define REG_BK1391_13_L      0x139126
#define REG_BK1391_13_H      0x139127
#define REG_BK1391_14_L      0x139128
#define REG_BK1391_14_H      0x139129
#define REG_BK1391_15_L      0x13912A
#define REG_BK1391_15_H      0x13912B
#define REG_BK1391_16_L      0x13912C
#define REG_BK1391_16_H      0x13912D
#define REG_BK1391_17_L      0x13912E
#define REG_BK1391_17_H      0x13912F
#define REG_BK1391_18_L      0x139130
#define REG_BK1391_18_H      0x139131
#define REG_BK1391_19_L      0x139132
#define REG_BK1391_19_H      0x139133
#define REG_BK1391_1A_L      0x139134
#define REG_BK1391_1A_H      0x139135
#define REG_BK1391_1B_L      0x139136
#define REG_BK1391_1B_H      0x139137
#define REG_BK1391_1C_L      0x139138
#define REG_BK1391_1C_H      0x139139
#define REG_BK1391_1D_L      0x13913A
#define REG_BK1391_1D_H      0x13913B
#define REG_BK1391_1E_L      0x13913C
#define REG_BK1391_1E_H      0x13913D
#define REG_BK1391_1F_L      0x13913E
#define REG_BK1391_1F_H      0x13913F
#define REG_BK1391_20_L      0x139140
#define REG_BK1391_20_H      0x139141
#define REG_BK1391_21_L      0x139142
#define REG_BK1391_21_H      0x139143
#define REG_BK1391_22_L      0x139144
#define REG_BK1391_22_H      0x139145
#define REG_BK1391_23_L      0x139146
#define REG_BK1391_23_H      0x139147
#define REG_BK1391_24_L      0x139148
#define REG_BK1391_24_H      0x139149
#define REG_BK1391_25_L      0x13914A
#define REG_BK1391_25_H      0x13914B
#define REG_BK1391_26_L      0x13914C
#define REG_BK1391_26_H      0x13914D
#define REG_BK1391_27_L      0x13914E
#define REG_BK1391_27_H      0x13914F
#define REG_BK1391_28_L      0x139150
#define REG_BK1391_28_H      0x139151
#define REG_BK1391_29_L      0x139152
#define REG_BK1391_29_H      0x139153
#define REG_BK1391_2A_L      0x139154
#define REG_BK1391_2A_H      0x139155
#define REG_BK1391_2B_L      0x139156
#define REG_BK1391_2B_H      0x139157
#define REG_BK1391_2C_L      0x139158
#define REG_BK1391_2C_H      0x139159
#define REG_BK1391_2D_L      0x13915A
#define REG_BK1391_2D_H      0x13915B
#define REG_BK1391_2E_L      0x13915C
#define REG_BK1391_2E_H      0x13915D
#define REG_BK1391_2F_L      0x13915E
#define REG_BK1391_2F_H      0x13915F
#define REG_BK1391_30_L      0x139160
#define REG_BK1391_30_H      0x139161
#define REG_BK1391_31_L      0x139162
#define REG_BK1391_31_H      0x139163
#define REG_BK1391_32_L      0x139164
#define REG_BK1391_32_H      0x139165
#define REG_BK1391_33_L      0x139166
#define REG_BK1391_33_H      0x139167
#define REG_BK1391_34_L      0x139168
#define REG_BK1391_34_H      0x139169
#define REG_BK1391_35_L      0x13916A
#define REG_BK1391_35_H      0x13916B
#define REG_BK1391_36_L      0x13916C
#define REG_BK1391_36_H      0x13916D
#define REG_BK1391_37_L      0x13916E
#define REG_BK1391_37_H      0x13916F
#define REG_BK1391_38_L      0x139170
#define REG_BK1391_38_H      0x139171
#define REG_BK1391_39_L      0x139172
#define REG_BK1391_39_H      0x139173
#define REG_BK1391_3A_L      0x139174
#define REG_BK1391_3A_H      0x139175
#define REG_BK1391_3B_L      0x139176
#define REG_BK1391_3B_H      0x139177
#define REG_BK1391_3C_L      0x139178
#define REG_BK1391_3C_H      0x139179
#define REG_BK1391_3D_L      0x13917A
#define REG_BK1391_3D_H      0x13917B
#define REG_BK1391_3E_L      0x13917C
#define REG_BK1391_3E_H      0x13917D
#define REG_BK1391_3F_L      0x13917E
#define REG_BK1391_3F_H      0x13917F
#define REG_BK1391_40_L      0x139180
#define REG_BK1391_40_H      0x139181
#define REG_BK1391_41_L      0x139182
#define REG_BK1391_41_H      0x139183
#define REG_BK1391_42_L      0x139184
#define REG_BK1391_42_H      0x139185
#define REG_BK1391_43_L      0x139186
#define REG_BK1391_43_H      0x139187
#define REG_BK1391_44_L      0x139188
#define REG_BK1391_44_H      0x139189
#define REG_BK1391_45_L      0x13918A
#define REG_BK1391_45_H      0x13918B
#define REG_BK1391_46_L      0x13918C
#define REG_BK1391_46_H      0x13918D
#define REG_BK1391_47_L      0x13918E
#define REG_BK1391_47_H      0x13918F
#define REG_BK1391_48_L      0x139190
#define REG_BK1391_48_H      0x139191
#define REG_BK1391_49_L      0x139192
#define REG_BK1391_49_H      0x139193
#define REG_BK1391_4A_L      0x139194
#define REG_BK1391_4A_H      0x139195
#define REG_BK1391_4B_L      0x139196
#define REG_BK1391_4B_H      0x139197
#define REG_BK1391_4C_L      0x139198
#define REG_BK1391_4C_H      0x139199
#define REG_BK1391_4D_L      0x13919A
#define REG_BK1391_4D_H      0x13919B
#define REG_BK1391_4E_L      0x13919C
#define REG_BK1391_4E_H      0x13919D
#define REG_BK1391_4F_L      0x13919E
#define REG_BK1391_4F_H      0x13919F
#define REG_BK1391_50_L      0x1391A0
#define REG_BK1391_50_H      0x1391A1
#define REG_BK1391_51_L      0x1391A2
#define REG_BK1391_51_H      0x1391A3
#define REG_BK1391_52_L      0x1391A4
#define REG_BK1391_52_H      0x1391A5
#define REG_BK1391_53_L      0x1391A6
#define REG_BK1391_53_H      0x1391A7
#define REG_BK1391_54_L      0x1391A8
#define REG_BK1391_54_H      0x1391A9
#define REG_BK1391_55_L      0x1391AA
#define REG_BK1391_55_H      0x1391AB
#define REG_BK1391_56_L      0x1391AC
#define REG_BK1391_56_H      0x1391AD
#define REG_BK1391_57_L      0x1391AE
#define REG_BK1391_57_H      0x1391AF
#define REG_BK1391_58_L      0x1391B0
#define REG_BK1391_58_H      0x1391B1
#define REG_BK1391_59_L      0x1391B2
#define REG_BK1391_59_H      0x1391B3
#define REG_BK1391_5A_L      0x1391B4
#define REG_BK1391_5A_H      0x1391B5
#define REG_BK1391_5B_L      0x1391B6
#define REG_BK1391_5B_H      0x1391B7
#define REG_BK1391_5C_L      0x1391B8
#define REG_BK1391_5C_H      0x1391B9
#define REG_BK1391_5D_L      0x1391BA
#define REG_BK1391_5D_H      0x1391BB
#define REG_BK1391_5E_L      0x1391BC
#define REG_BK1391_5E_H      0x1391BD
#define REG_BK1391_5F_L      0x1391BE
#define REG_BK1391_5F_H      0x1391BF
#define REG_BK1391_60_L      0x1391C0
#define REG_BK1391_60_H      0x1391C1
#define REG_BK1391_61_L      0x1391C2
#define REG_BK1391_61_H      0x1391C3
#define REG_BK1391_62_L      0x1391C4
#define REG_BK1391_62_H      0x1391C5
#define REG_BK1391_63_L      0x1391C6
#define REG_BK1391_63_H      0x1391C7
#define REG_BK1391_64_L      0x1391C8
#define REG_BK1391_64_H      0x1391C9
#define REG_BK1391_65_L      0x1391CA
#define REG_BK1391_65_H      0x1391CB
#define REG_BK1391_66_L      0x1391CC
#define REG_BK1391_66_H      0x1391CD
#define REG_BK1391_67_L      0x1391CE
#define REG_BK1391_67_H      0x1391CF
#define REG_BK1391_68_L      0x1391D0
#define REG_BK1391_68_H      0x1391D1
#define REG_BK1391_69_L      0x1391D2
#define REG_BK1391_69_H      0x1391D3
#define REG_BK1391_6A_L      0x1391D4
#define REG_BK1391_6A_H      0x1391D5
#define REG_BK1391_6B_L      0x1391D6
#define REG_BK1391_6B_H      0x1391D7
#define REG_BK1391_6C_L      0x1391D8
#define REG_BK1391_6C_H      0x1391D9
#define REG_BK1391_6D_L      0x1391DA
#define REG_BK1391_6D_H      0x1391DB
#define REG_BK1391_6E_L      0x1391DC
#define REG_BK1391_6E_H      0x1391DD
#define REG_BK1391_6F_L      0x1391DE
#define REG_BK1391_6F_H      0x1391DF
#define REG_BK1391_70_L      0x1391E0
#define REG_BK1391_70_H      0x1391E1
#define REG_BK1391_71_L      0x1391E2
#define REG_BK1391_71_H      0x1391E3
#define REG_BK1391_72_L      0x1391E4
#define REG_BK1391_72_H      0x1391E5
#define REG_BK1391_73_L      0x1391E6
#define REG_BK1391_73_H      0x1391E7
#define REG_BK1391_74_L      0x1391E8
#define REG_BK1391_74_H      0x1391E9
#define REG_BK1391_75_L      0x1391EA
#define REG_BK1391_75_H      0x1391EB
#define REG_BK1391_76_L      0x1391EC
#define REG_BK1391_76_H      0x1391ED
#define REG_BK1391_77_L      0x1391EE
#define REG_BK1391_77_H      0x1391EF
#define REG_BK1391_78_L      0x1391F0
#define REG_BK1391_78_H      0x1391F1
#define REG_BK1391_79_L      0x1391F2
#define REG_BK1391_79_H      0x1391F3
#define REG_BK1391_7A_L      0x1391F4
#define REG_BK1391_7A_H      0x1391F5
#define REG_BK1391_7B_L      0x1391F6
#define REG_BK1391_7B_H      0x1391F7
#define REG_BK1391_7C_L      0x1391F8
#define REG_BK1391_7C_H      0x1391F9
#define REG_BK1391_7D_L      0x1391FA
#define REG_BK1391_7D_H      0x1391FB
#define REG_BK1391_7E_L      0x1391FC
#define REG_BK1391_7E_H      0x1391FD
#define REG_BK1391_7F_L      0x1391FE
#define REG_BK1391_7F_H      0x1391FF
//----------------------------------------------
#define REG_BK1392_00_L      0x139200
#define REG_BK1392_00_H      0x139201
#define REG_BK1392_01_L      0x139202
#define REG_BK1392_01_H      0x139203
#define REG_BK1392_02_L      0x139204
#define REG_BK1392_02_H      0x139205
#define REG_BK1392_03_L      0x139206
#define REG_BK1392_03_H      0x139207
#define REG_BK1392_04_L      0x139208
#define REG_BK1392_04_H      0x139209
#define REG_BK1392_05_L      0x13920A
#define REG_BK1392_05_H      0x13920B
#define REG_BK1392_06_L      0x13920C
#define REG_BK1392_06_H      0x13920D
#define REG_BK1392_07_L      0x13920E
#define REG_BK1392_07_H      0x13920F
#define REG_BK1392_08_L      0x139210
#define REG_BK1392_08_H      0x139211
#define REG_BK1392_09_L      0x139212
#define REG_BK1392_09_H      0x139213
#define REG_BK1392_0A_L      0x139214
#define REG_BK1392_0A_H      0x139215
#define REG_BK1392_0B_L      0x139216
#define REG_BK1392_0B_H      0x139217
#define REG_BK1392_0C_L      0x139218
#define REG_BK1392_0C_H      0x139219
#define REG_BK1392_0D_L      0x13921A
#define REG_BK1392_0D_H      0x13921B
#define REG_BK1392_0E_L      0x13921C
#define REG_BK1392_0E_H      0x13921D
#define REG_BK1392_0F_L      0x13921E
#define REG_BK1392_0F_H      0x13921F
#define REG_BK1392_10_L      0x139220
#define REG_BK1392_10_H      0x139221
#define REG_BK1392_11_L      0x139222
#define REG_BK1392_11_H      0x139223
#define REG_BK1392_12_L      0x139224
#define REG_BK1392_12_H      0x139225
#define REG_BK1392_13_L      0x139226
#define REG_BK1392_13_H      0x139227
#define REG_BK1392_14_L      0x139228
#define REG_BK1392_14_H      0x139229
#define REG_BK1392_15_L      0x13922A
#define REG_BK1392_15_H      0x13922B
#define REG_BK1392_16_L      0x13922C
#define REG_BK1392_16_H      0x13922D
#define REG_BK1392_17_L      0x13922E
#define REG_BK1392_17_H      0x13922F
#define REG_BK1392_18_L      0x139230
#define REG_BK1392_18_H      0x139231
#define REG_BK1392_19_L      0x139232
#define REG_BK1392_19_H      0x139233
#define REG_BK1392_1A_L      0x139234
#define REG_BK1392_1A_H      0x139235
#define REG_BK1392_1B_L      0x139236
#define REG_BK1392_1B_H      0x139237
#define REG_BK1392_1C_L      0x139238
#define REG_BK1392_1C_H      0x139239
#define REG_BK1392_1D_L      0x13923A
#define REG_BK1392_1D_H      0x13923B
#define REG_BK1392_1E_L      0x13923C
#define REG_BK1392_1E_H      0x13923D
#define REG_BK1392_1F_L      0x13923E
#define REG_BK1392_1F_H      0x13923F
#define REG_BK1392_20_L      0x139240
#define REG_BK1392_20_H      0x139241
#define REG_BK1392_21_L      0x139242
#define REG_BK1392_21_H      0x139243
#define REG_BK1392_22_L      0x139244
#define REG_BK1392_22_H      0x139245
#define REG_BK1392_23_L      0x139246
#define REG_BK1392_23_H      0x139247
#define REG_BK1392_24_L      0x139248
#define REG_BK1392_24_H      0x139249
#define REG_BK1392_25_L      0x13924A
#define REG_BK1392_25_H      0x13924B
#define REG_BK1392_26_L      0x13924C
#define REG_BK1392_26_H      0x13924D
#define REG_BK1392_27_L      0x13924E
#define REG_BK1392_27_H      0x13924F
#define REG_BK1392_28_L      0x139250
#define REG_BK1392_28_H      0x139251
#define REG_BK1392_29_L      0x139252
#define REG_BK1392_29_H      0x139253
#define REG_BK1392_2A_L      0x139254
#define REG_BK1392_2A_H      0x139255
#define REG_BK1392_2B_L      0x139256
#define REG_BK1392_2B_H      0x139257
#define REG_BK1392_2C_L      0x139258
#define REG_BK1392_2C_H      0x139259
#define REG_BK1392_2D_L      0x13925A
#define REG_BK1392_2D_H      0x13925B
#define REG_BK1392_2E_L      0x13925C
#define REG_BK1392_2E_H      0x13925D
#define REG_BK1392_2F_L      0x13925E
#define REG_BK1392_2F_H      0x13925F
#define REG_BK1392_30_L      0x139260
#define REG_BK1392_30_H      0x139261
#define REG_BK1392_31_L      0x139262
#define REG_BK1392_31_H      0x139263
#define REG_BK1392_32_L      0x139264
#define REG_BK1392_32_H      0x139265
#define REG_BK1392_33_L      0x139266
#define REG_BK1392_33_H      0x139267
#define REG_BK1392_34_L      0x139268
#define REG_BK1392_34_H      0x139269
#define REG_BK1392_35_L      0x13926A
#define REG_BK1392_35_H      0x13926B
#define REG_BK1392_36_L      0x13926C
#define REG_BK1392_36_H      0x13926D
#define REG_BK1392_37_L      0x13926E
#define REG_BK1392_37_H      0x13926F
#define REG_BK1392_38_L      0x139270
#define REG_BK1392_38_H      0x139271
#define REG_BK1392_39_L      0x139272
#define REG_BK1392_39_H      0x139273
#define REG_BK1392_3A_L      0x139274
#define REG_BK1392_3A_H      0x139275
#define REG_BK1392_3B_L      0x139276
#define REG_BK1392_3B_H      0x139277
#define REG_BK1392_3C_L      0x139278
#define REG_BK1392_3C_H      0x139279
#define REG_BK1392_3D_L      0x13927A
#define REG_BK1392_3D_H      0x13927B
#define REG_BK1392_3E_L      0x13927C
#define REG_BK1392_3E_H      0x13927D
#define REG_BK1392_3F_L      0x13927E
#define REG_BK1392_3F_H      0x13927F
#define REG_BK1392_40_L      0x139280
#define REG_BK1392_40_H      0x139281
#define REG_BK1392_41_L      0x139282
#define REG_BK1392_41_H      0x139283
#define REG_BK1392_42_L      0x139284
#define REG_BK1392_42_H      0x139285
#define REG_BK1392_43_L      0x139286
#define REG_BK1392_43_H      0x139287
#define REG_BK1392_44_L      0x139288
#define REG_BK1392_44_H      0x139289
#define REG_BK1392_45_L      0x13928A
#define REG_BK1392_45_H      0x13928B
#define REG_BK1392_46_L      0x13928C
#define REG_BK1392_46_H      0x13928D
#define REG_BK1392_47_L      0x13928E
#define REG_BK1392_47_H      0x13928F
#define REG_BK1392_48_L      0x139290
#define REG_BK1392_48_H      0x139291
#define REG_BK1392_49_L      0x139292
#define REG_BK1392_49_H      0x139293
#define REG_BK1392_4A_L      0x139294
#define REG_BK1392_4A_H      0x139295
#define REG_BK1392_4B_L      0x139296
#define REG_BK1392_4B_H      0x139297
#define REG_BK1392_4C_L      0x139298
#define REG_BK1392_4C_H      0x139299
#define REG_BK1392_4D_L      0x13929A
#define REG_BK1392_4D_H      0x13929B
#define REG_BK1392_4E_L      0x13929C
#define REG_BK1392_4E_H      0x13929D
#define REG_BK1392_4F_L      0x13929E
#define REG_BK1392_4F_H      0x13929F
#define REG_BK1392_50_L      0x1392A0
#define REG_BK1392_50_H      0x1392A1
#define REG_BK1392_51_L      0x1392A2
#define REG_BK1392_51_H      0x1392A3
#define REG_BK1392_52_L      0x1392A4
#define REG_BK1392_52_H      0x1392A5
#define REG_BK1392_53_L      0x1392A6
#define REG_BK1392_53_H      0x1392A7
#define REG_BK1392_54_L      0x1392A8
#define REG_BK1392_54_H      0x1392A9
#define REG_BK1392_55_L      0x1392AA
#define REG_BK1392_55_H      0x1392AB
#define REG_BK1392_56_L      0x1392AC
#define REG_BK1392_56_H      0x1392AD
#define REG_BK1392_57_L      0x1392AE
#define REG_BK1392_57_H      0x1392AF
#define REG_BK1392_58_L      0x1392B0
#define REG_BK1392_58_H      0x1392B1
#define REG_BK1392_59_L      0x1392B2
#define REG_BK1392_59_H      0x1392B3
#define REG_BK1392_5A_L      0x1392B4
#define REG_BK1392_5A_H      0x1392B5
#define REG_BK1392_5B_L      0x1392B6
#define REG_BK1392_5B_H      0x1392B7
#define REG_BK1392_5C_L      0x1392B8
#define REG_BK1392_5C_H      0x1392B9
#define REG_BK1392_5D_L      0x1392BA
#define REG_BK1392_5D_H      0x1392BB
#define REG_BK1392_5E_L      0x1392BC
#define REG_BK1392_5E_H      0x1392BD
#define REG_BK1392_5F_L      0x1392BE
#define REG_BK1392_5F_H      0x1392BF
#define REG_BK1392_60_L      0x1392C0
#define REG_BK1392_60_H      0x1392C1
#define REG_BK1392_61_L      0x1392C2
#define REG_BK1392_61_H      0x1392C3
#define REG_BK1392_62_L      0x1392C4
#define REG_BK1392_62_H      0x1392C5
#define REG_BK1392_63_L      0x1392C6
#define REG_BK1392_63_H      0x1392C7
#define REG_BK1392_64_L      0x1392C8
#define REG_BK1392_64_H      0x1392C9
#define REG_BK1392_65_L      0x1392CA
#define REG_BK1392_65_H      0x1392CB
#define REG_BK1392_66_L      0x1392CC
#define REG_BK1392_66_H      0x1392CD
#define REG_BK1392_67_L      0x1392CE
#define REG_BK1392_67_H      0x1392CF
#define REG_BK1392_68_L      0x1392D0
#define REG_BK1392_68_H      0x1392D1
#define REG_BK1392_69_L      0x1392D2
#define REG_BK1392_69_H      0x1392D3
#define REG_BK1392_6A_L      0x1392D4
#define REG_BK1392_6A_H      0x1392D5
#define REG_BK1392_6B_L      0x1392D6
#define REG_BK1392_6B_H      0x1392D7
#define REG_BK1392_6C_L      0x1392D8
#define REG_BK1392_6C_H      0x1392D9
#define REG_BK1392_6D_L      0x1392DA
#define REG_BK1392_6D_H      0x1392DB
#define REG_BK1392_6E_L      0x1392DC
#define REG_BK1392_6E_H      0x1392DD
#define REG_BK1392_6F_L      0x1392DE
#define REG_BK1392_6F_H      0x1392DF
#define REG_BK1392_70_L      0x1392E0
#define REG_BK1392_70_H      0x1392E1
#define REG_BK1392_71_L      0x1392E2
#define REG_BK1392_71_H      0x1392E3
#define REG_BK1392_72_L      0x1392E4
#define REG_BK1392_72_H      0x1392E5
#define REG_BK1392_73_L      0x1392E6
#define REG_BK1392_73_H      0x1392E7
#define REG_BK1392_74_L      0x1392E8
#define REG_BK1392_74_H      0x1392E9
#define REG_BK1392_75_L      0x1392EA
#define REG_BK1392_75_H      0x1392EB
#define REG_BK1392_76_L      0x1392EC
#define REG_BK1392_76_H      0x1392ED
#define REG_BK1392_77_L      0x1392EE
#define REG_BK1392_77_H      0x1392EF
#define REG_BK1392_78_L      0x1392F0
#define REG_BK1392_78_H      0x1392F1
#define REG_BK1392_79_L      0x1392F2
#define REG_BK1392_79_H      0x1392F3
#define REG_BK1392_7A_L      0x1392F4
#define REG_BK1392_7A_H      0x1392F5
#define REG_BK1392_7B_L      0x1392F6
#define REG_BK1392_7B_H      0x1392F7
#define REG_BK1392_7C_L      0x1392F8
#define REG_BK1392_7C_H      0x1392F9
#define REG_BK1392_7D_L      0x1392FA
#define REG_BK1392_7D_H      0x1392FB
#define REG_BK1392_7E_L      0x1392FC
#define REG_BK1392_7E_H      0x1392FD
#define REG_BK1392_7F_L      0x1392FE
#define REG_BK1392_7F_H      0x1392FF
//----------------------------------------------
#define REG_BK1393_00_L      0x139300
#define REG_BK1393_00_H      0x139301
#define REG_BK1393_01_L      0x139302
#define REG_BK1393_01_H      0x139303
#define REG_BK1393_02_L      0x139304
#define REG_BK1393_02_H      0x139305
#define REG_BK1393_03_L      0x139306
#define REG_BK1393_03_H      0x139307
#define REG_BK1393_04_L      0x139308
#define REG_BK1393_04_H      0x139309
#define REG_BK1393_05_L      0x13930A
#define REG_BK1393_05_H      0x13930B
#define REG_BK1393_06_L      0x13930C
#define REG_BK1393_06_H      0x13930D
#define REG_BK1393_07_L      0x13930E
#define REG_BK1393_07_H      0x13930F
#define REG_BK1393_08_L      0x139310
#define REG_BK1393_08_H      0x139311
#define REG_BK1393_09_L      0x139312
#define REG_BK1393_09_H      0x139313
#define REG_BK1393_0A_L      0x139314
#define REG_BK1393_0A_H      0x139315
#define REG_BK1393_0B_L      0x139316
#define REG_BK1393_0B_H      0x139317
#define REG_BK1393_0C_L      0x139318
#define REG_BK1393_0C_H      0x139319
#define REG_BK1393_0D_L      0x13931A
#define REG_BK1393_0D_H      0x13931B
#define REG_BK1393_0E_L      0x13931C
#define REG_BK1393_0E_H      0x13931D
#define REG_BK1393_0F_L      0x13931E
#define REG_BK1393_0F_H      0x13931F
#define REG_BK1393_10_L      0x139320
#define REG_BK1393_10_H      0x139321
#define REG_BK1393_11_L      0x139322
#define REG_BK1393_11_H      0x139323
#define REG_BK1393_12_L      0x139324
#define REG_BK1393_12_H      0x139325
#define REG_BK1393_13_L      0x139326
#define REG_BK1393_13_H      0x139327
#define REG_BK1393_14_L      0x139328
#define REG_BK1393_14_H      0x139329
#define REG_BK1393_15_L      0x13932A
#define REG_BK1393_15_H      0x13932B
#define REG_BK1393_16_L      0x13932C
#define REG_BK1393_16_H      0x13932D
#define REG_BK1393_17_L      0x13932E
#define REG_BK1393_17_H      0x13932F
#define REG_BK1393_18_L      0x139330
#define REG_BK1393_18_H      0x139331
#define REG_BK1393_19_L      0x139332
#define REG_BK1393_19_H      0x139333
#define REG_BK1393_1A_L      0x139334
#define REG_BK1393_1A_H      0x139335
#define REG_BK1393_1B_L      0x139336
#define REG_BK1393_1B_H      0x139337
#define REG_BK1393_1C_L      0x139338
#define REG_BK1393_1C_H      0x139339
#define REG_BK1393_1D_L      0x13933A
#define REG_BK1393_1D_H      0x13933B
#define REG_BK1393_1E_L      0x13933C
#define REG_BK1393_1E_H      0x13933D
#define REG_BK1393_1F_L      0x13933E
#define REG_BK1393_1F_H      0x13933F
#define REG_BK1393_20_L      0x139340
#define REG_BK1393_20_H      0x139341
#define REG_BK1393_21_L      0x139342
#define REG_BK1393_21_H      0x139343
#define REG_BK1393_22_L      0x139344
#define REG_BK1393_22_H      0x139345
#define REG_BK1393_23_L      0x139346
#define REG_BK1393_23_H      0x139347
#define REG_BK1393_24_L      0x139348
#define REG_BK1393_24_H      0x139349
#define REG_BK1393_25_L      0x13934A
#define REG_BK1393_25_H      0x13934B
#define REG_BK1393_26_L      0x13934C
#define REG_BK1393_26_H      0x13934D
#define REG_BK1393_27_L      0x13934E
#define REG_BK1393_27_H      0x13934F
#define REG_BK1393_28_L      0x139350
#define REG_BK1393_28_H      0x139351
#define REG_BK1393_29_L      0x139352
#define REG_BK1393_29_H      0x139353
#define REG_BK1393_2A_L      0x139354
#define REG_BK1393_2A_H      0x139355
#define REG_BK1393_2B_L      0x139356
#define REG_BK1393_2B_H      0x139357
#define REG_BK1393_2C_L      0x139358
#define REG_BK1393_2C_H      0x139359
#define REG_BK1393_2D_L      0x13935A
#define REG_BK1393_2D_H      0x13935B
#define REG_BK1393_2E_L      0x13935C
#define REG_BK1393_2E_H      0x13935D
#define REG_BK1393_2F_L      0x13935E
#define REG_BK1393_2F_H      0x13935F
#define REG_BK1393_30_L      0x139360
#define REG_BK1393_30_H      0x139361
#define REG_BK1393_31_L      0x139362
#define REG_BK1393_31_H      0x139363
#define REG_BK1393_32_L      0x139364
#define REG_BK1393_32_H      0x139365
#define REG_BK1393_33_L      0x139366
#define REG_BK1393_33_H      0x139367
#define REG_BK1393_34_L      0x139368
#define REG_BK1393_34_H      0x139369
#define REG_BK1393_35_L      0x13936A
#define REG_BK1393_35_H      0x13936B
#define REG_BK1393_36_L      0x13936C
#define REG_BK1393_36_H      0x13936D
#define REG_BK1393_37_L      0x13936E
#define REG_BK1393_37_H      0x13936F
#define REG_BK1393_38_L      0x139370
#define REG_BK1393_38_H      0x139371
#define REG_BK1393_39_L      0x139372
#define REG_BK1393_39_H      0x139373
#define REG_BK1393_3A_L      0x139374
#define REG_BK1393_3A_H      0x139375
#define REG_BK1393_3B_L      0x139376
#define REG_BK1393_3B_H      0x139377
#define REG_BK1393_3C_L      0x139378
#define REG_BK1393_3C_H      0x139379
#define REG_BK1393_3D_L      0x13937A
#define REG_BK1393_3D_H      0x13937B
#define REG_BK1393_3E_L      0x13937C
#define REG_BK1393_3E_H      0x13937D
#define REG_BK1393_3F_L      0x13937E
#define REG_BK1393_3F_H      0x13937F
#define REG_BK1393_40_L      0x139380
#define REG_BK1393_40_H      0x139381
#define REG_BK1393_41_L      0x139382
#define REG_BK1393_41_H      0x139383
#define REG_BK1393_42_L      0x139384
#define REG_BK1393_42_H      0x139385
#define REG_BK1393_43_L      0x139386
#define REG_BK1393_43_H      0x139387
#define REG_BK1393_44_L      0x139388
#define REG_BK1393_44_H      0x139389
#define REG_BK1393_45_L      0x13938A
#define REG_BK1393_45_H      0x13938B
#define REG_BK1393_46_L      0x13938C
#define REG_BK1393_46_H      0x13938D
#define REG_BK1393_47_L      0x13938E
#define REG_BK1393_47_H      0x13938F
#define REG_BK1393_48_L      0x139390
#define REG_BK1393_48_H      0x139391
#define REG_BK1393_49_L      0x139392
#define REG_BK1393_49_H      0x139393
#define REG_BK1393_4A_L      0x139394
#define REG_BK1393_4A_H      0x139395
#define REG_BK1393_4B_L      0x139396
#define REG_BK1393_4B_H      0x139397
#define REG_BK1393_4C_L      0x139398
#define REG_BK1393_4C_H      0x139399
#define REG_BK1393_4D_L      0x13939A
#define REG_BK1393_4D_H      0x13939B
#define REG_BK1393_4E_L      0x13939C
#define REG_BK1393_4E_H      0x13939D
#define REG_BK1393_4F_L      0x13939E
#define REG_BK1393_4F_H      0x13939F
#define REG_BK1393_50_L      0x1393A0
#define REG_BK1393_50_H      0x1393A1
#define REG_BK1393_51_L      0x1393A2
#define REG_BK1393_51_H      0x1393A3
#define REG_BK1393_52_L      0x1393A4
#define REG_BK1393_52_H      0x1393A5
#define REG_BK1393_53_L      0x1393A6
#define REG_BK1393_53_H      0x1393A7
#define REG_BK1393_54_L      0x1393A8
#define REG_BK1393_54_H      0x1393A9
#define REG_BK1393_55_L      0x1393AA
#define REG_BK1393_55_H      0x1393AB
#define REG_BK1393_56_L      0x1393AC
#define REG_BK1393_56_H      0x1393AD
#define REG_BK1393_57_L      0x1393AE
#define REG_BK1393_57_H      0x1393AF
#define REG_BK1393_58_L      0x1393B0
#define REG_BK1393_58_H      0x1393B1
#define REG_BK1393_59_L      0x1393B2
#define REG_BK1393_59_H      0x1393B3
#define REG_BK1393_5A_L      0x1393B4
#define REG_BK1393_5A_H      0x1393B5
#define REG_BK1393_5B_L      0x1393B6
#define REG_BK1393_5B_H      0x1393B7
#define REG_BK1393_5C_L      0x1393B8
#define REG_BK1393_5C_H      0x1393B9
#define REG_BK1393_5D_L      0x1393BA
#define REG_BK1393_5D_H      0x1393BB
#define REG_BK1393_5E_L      0x1393BC
#define REG_BK1393_5E_H      0x1393BD
#define REG_BK1393_5F_L      0x1393BE
#define REG_BK1393_5F_H      0x1393BF
#define REG_BK1393_60_L      0x1393C0
#define REG_BK1393_60_H      0x1393C1
#define REG_BK1393_61_L      0x1393C2
#define REG_BK1393_61_H      0x1393C3
#define REG_BK1393_62_L      0x1393C4
#define REG_BK1393_62_H      0x1393C5
#define REG_BK1393_63_L      0x1393C6
#define REG_BK1393_63_H      0x1393C7
#define REG_BK1393_64_L      0x1393C8
#define REG_BK1393_64_H      0x1393C9
#define REG_BK1393_65_L      0x1393CA
#define REG_BK1393_65_H      0x1393CB
#define REG_BK1393_66_L      0x1393CC
#define REG_BK1393_66_H      0x1393CD
#define REG_BK1393_67_L      0x1393CE
#define REG_BK1393_67_H      0x1393CF
#define REG_BK1393_68_L      0x1393D0
#define REG_BK1393_68_H      0x1393D1
#define REG_BK1393_69_L      0x1393D2
#define REG_BK1393_69_H      0x1393D3
#define REG_BK1393_6A_L      0x1393D4
#define REG_BK1393_6A_H      0x1393D5
#define REG_BK1393_6B_L      0x1393D6
#define REG_BK1393_6B_H      0x1393D7
#define REG_BK1393_6C_L      0x1393D8
#define REG_BK1393_6C_H      0x1393D9
#define REG_BK1393_6D_L      0x1393DA
#define REG_BK1393_6D_H      0x1393DB
#define REG_BK1393_6E_L      0x1393DC
#define REG_BK1393_6E_H      0x1393DD
#define REG_BK1393_6F_L      0x1393DE
#define REG_BK1393_6F_H      0x1393DF
#define REG_BK1393_70_L      0x1393E0
#define REG_BK1393_70_H      0x1393E1
#define REG_BK1393_71_L      0x1393E2
#define REG_BK1393_71_H      0x1393E3
#define REG_BK1393_72_L      0x1393E4
#define REG_BK1393_72_H      0x1393E5
#define REG_BK1393_73_L      0x1393E6
#define REG_BK1393_73_H      0x1393E7
#define REG_BK1393_74_L      0x1393E8
#define REG_BK1393_74_H      0x1393E9
#define REG_BK1393_75_L      0x1393EA
#define REG_BK1393_75_H      0x1393EB
#define REG_BK1393_76_L      0x1393EC
#define REG_BK1393_76_H      0x1393ED
#define REG_BK1393_77_L      0x1393EE
#define REG_BK1393_77_H      0x1393EF
#define REG_BK1393_78_L      0x1393F0
#define REG_BK1393_78_H      0x1393F1
#define REG_BK1393_79_L      0x1393F2
#define REG_BK1393_79_H      0x1393F3
#define REG_BK1393_7A_L      0x1393F4
#define REG_BK1393_7A_H      0x1393F5
#define REG_BK1393_7B_L      0x1393F6
#define REG_BK1393_7B_H      0x1393F7
#define REG_BK1393_7C_L      0x1393F8
#define REG_BK1393_7C_H      0x1393F9
#define REG_BK1393_7D_L      0x1393FA
#define REG_BK1393_7D_H      0x1393FB
#define REG_BK1393_7E_L      0x1393FC
#define REG_BK1393_7E_H      0x1393FD
#define REG_BK1393_7F_L      0x1393FE
#define REG_BK1393_7F_H      0x1393FF
//----------------------------------------------
#define REG_BK1394_00_L      0x139400
#define REG_BK1394_00_H      0x139401
#define REG_BK1394_01_L      0x139402
#define REG_BK1394_01_H      0x139403
#define REG_BK1394_02_L      0x139404
#define REG_BK1394_02_H      0x139405
#define REG_BK1394_03_L      0x139406
#define REG_BK1394_03_H      0x139407
#define REG_BK1394_04_L      0x139408
#define REG_BK1394_04_H      0x139409
#define REG_BK1394_05_L      0x13940A
#define REG_BK1394_05_H      0x13940B
#define REG_BK1394_06_L      0x13940C
#define REG_BK1394_06_H      0x13940D
#define REG_BK1394_07_L      0x13940E
#define REG_BK1394_07_H      0x13940F
#define REG_BK1394_08_L      0x139410
#define REG_BK1394_08_H      0x139411
#define REG_BK1394_09_L      0x139412
#define REG_BK1394_09_H      0x139413
#define REG_BK1394_0A_L      0x139414
#define REG_BK1394_0A_H      0x139415
#define REG_BK1394_0B_L      0x139416
#define REG_BK1394_0B_H      0x139417
#define REG_BK1394_0C_L      0x139418
#define REG_BK1394_0C_H      0x139419
#define REG_BK1394_0D_L      0x13941A
#define REG_BK1394_0D_H      0x13941B
#define REG_BK1394_0E_L      0x13941C
#define REG_BK1394_0E_H      0x13941D
#define REG_BK1394_0F_L      0x13941E
#define REG_BK1394_0F_H      0x13941F
#define REG_BK1394_10_L      0x139420
#define REG_BK1394_10_H      0x139421
#define REG_BK1394_11_L      0x139422
#define REG_BK1394_11_H      0x139423
#define REG_BK1394_12_L      0x139424
#define REG_BK1394_12_H      0x139425
#define REG_BK1394_13_L      0x139426
#define REG_BK1394_13_H      0x139427
#define REG_BK1394_14_L      0x139428
#define REG_BK1394_14_H      0x139429
#define REG_BK1394_15_L      0x13942A
#define REG_BK1394_15_H      0x13942B
#define REG_BK1394_16_L      0x13942C
#define REG_BK1394_16_H      0x13942D
#define REG_BK1394_17_L      0x13942E
#define REG_BK1394_17_H      0x13942F
#define REG_BK1394_18_L      0x139430
#define REG_BK1394_18_H      0x139431
#define REG_BK1394_19_L      0x139432
#define REG_BK1394_19_H      0x139433
#define REG_BK1394_1A_L      0x139434
#define REG_BK1394_1A_H      0x139435
#define REG_BK1394_1B_L      0x139436
#define REG_BK1394_1B_H      0x139437
#define REG_BK1394_1C_L      0x139438
#define REG_BK1394_1C_H      0x139439
#define REG_BK1394_1D_L      0x13943A
#define REG_BK1394_1D_H      0x13943B
#define REG_BK1394_1E_L      0x13943C
#define REG_BK1394_1E_H      0x13943D
#define REG_BK1394_1F_L      0x13943E
#define REG_BK1394_1F_H      0x13943F
#define REG_BK1394_20_L      0x139440
#define REG_BK1394_20_H      0x139441
#define REG_BK1394_21_L      0x139442
#define REG_BK1394_21_H      0x139443
#define REG_BK1394_22_L      0x139444
#define REG_BK1394_22_H      0x139445
#define REG_BK1394_23_L      0x139446
#define REG_BK1394_23_H      0x139447
#define REG_BK1394_24_L      0x139448
#define REG_BK1394_24_H      0x139449
#define REG_BK1394_25_L      0x13944A
#define REG_BK1394_25_H      0x13944B
#define REG_BK1394_26_L      0x13944C
#define REG_BK1394_26_H      0x13944D
#define REG_BK1394_27_L      0x13944E
#define REG_BK1394_27_H      0x13944F
#define REG_BK1394_28_L      0x139450
#define REG_BK1394_28_H      0x139451
#define REG_BK1394_29_L      0x139452
#define REG_BK1394_29_H      0x139453
#define REG_BK1394_2A_L      0x139454
#define REG_BK1394_2A_H      0x139455
#define REG_BK1394_2B_L      0x139456
#define REG_BK1394_2B_H      0x139457
#define REG_BK1394_2C_L      0x139458
#define REG_BK1394_2C_H      0x139459
#define REG_BK1394_2D_L      0x13945A
#define REG_BK1394_2D_H      0x13945B
#define REG_BK1394_2E_L      0x13945C
#define REG_BK1394_2E_H      0x13945D
#define REG_BK1394_2F_L      0x13945E
#define REG_BK1394_2F_H      0x13945F
#define REG_BK1394_30_L      0x139460
#define REG_BK1394_30_H      0x139461
#define REG_BK1394_31_L      0x139462
#define REG_BK1394_31_H      0x139463
#define REG_BK1394_32_L      0x139464
#define REG_BK1394_32_H      0x139465
#define REG_BK1394_33_L      0x139466
#define REG_BK1394_33_H      0x139467
#define REG_BK1394_34_L      0x139468
#define REG_BK1394_34_H      0x139469
#define REG_BK1394_35_L      0x13946A
#define REG_BK1394_35_H      0x13946B
#define REG_BK1394_36_L      0x13946C
#define REG_BK1394_36_H      0x13946D
#define REG_BK1394_37_L      0x13946E
#define REG_BK1394_37_H      0x13946F
#define REG_BK1394_38_L      0x139470
#define REG_BK1394_38_H      0x139471
#define REG_BK1394_39_L      0x139472
#define REG_BK1394_39_H      0x139473
#define REG_BK1394_3A_L      0x139474
#define REG_BK1394_3A_H      0x139475
#define REG_BK1394_3B_L      0x139476
#define REG_BK1394_3B_H      0x139477
#define REG_BK1394_3C_L      0x139478
#define REG_BK1394_3C_H      0x139479
#define REG_BK1394_3D_L      0x13947A
#define REG_BK1394_3D_H      0x13947B
#define REG_BK1394_3E_L      0x13947C
#define REG_BK1394_3E_H      0x13947D
#define REG_BK1394_3F_L      0x13947E
#define REG_BK1394_3F_H      0x13947F
#define REG_BK1394_40_L      0x139480
#define REG_BK1394_40_H      0x139481
#define REG_BK1394_41_L      0x139482
#define REG_BK1394_41_H      0x139483
#define REG_BK1394_42_L      0x139484
#define REG_BK1394_42_H      0x139485
#define REG_BK1394_43_L      0x139486
#define REG_BK1394_43_H      0x139487
#define REG_BK1394_44_L      0x139488
#define REG_BK1394_44_H      0x139489
#define REG_BK1394_45_L      0x13948A
#define REG_BK1394_45_H      0x13948B
#define REG_BK1394_46_L      0x13948C
#define REG_BK1394_46_H      0x13948D
#define REG_BK1394_47_L      0x13948E
#define REG_BK1394_47_H      0x13948F
#define REG_BK1394_48_L      0x139490
#define REG_BK1394_48_H      0x139491
#define REG_BK1394_49_L      0x139492
#define REG_BK1394_49_H      0x139493
#define REG_BK1394_4A_L      0x139494
#define REG_BK1394_4A_H      0x139495
#define REG_BK1394_4B_L      0x139496
#define REG_BK1394_4B_H      0x139497
#define REG_BK1394_4C_L      0x139498
#define REG_BK1394_4C_H      0x139499
#define REG_BK1394_4D_L      0x13949A
#define REG_BK1394_4D_H      0x13949B
#define REG_BK1394_4E_L      0x13949C
#define REG_BK1394_4E_H      0x13949D
#define REG_BK1394_4F_L      0x13949E
#define REG_BK1394_4F_H      0x13949F
#define REG_BK1394_50_L      0x1394A0
#define REG_BK1394_50_H      0x1394A1
#define REG_BK1394_51_L      0x1394A2
#define REG_BK1394_51_H      0x1394A3
#define REG_BK1394_52_L      0x1394A4
#define REG_BK1394_52_H      0x1394A5
#define REG_BK1394_53_L      0x1394A6
#define REG_BK1394_53_H      0x1394A7
#define REG_BK1394_54_L      0x1394A8
#define REG_BK1394_54_H      0x1394A9
#define REG_BK1394_55_L      0x1394AA
#define REG_BK1394_55_H      0x1394AB
#define REG_BK1394_56_L      0x1394AC
#define REG_BK1394_56_H      0x1394AD
#define REG_BK1394_57_L      0x1394AE
#define REG_BK1394_57_H      0x1394AF
#define REG_BK1394_58_L      0x1394B0
#define REG_BK1394_58_H      0x1394B1
#define REG_BK1394_59_L      0x1394B2
#define REG_BK1394_59_H      0x1394B3
#define REG_BK1394_5A_L      0x1394B4
#define REG_BK1394_5A_H      0x1394B5
#define REG_BK1394_5B_L      0x1394B6
#define REG_BK1394_5B_H      0x1394B7
#define REG_BK1394_5C_L      0x1394B8
#define REG_BK1394_5C_H      0x1394B9
#define REG_BK1394_5D_L      0x1394BA
#define REG_BK1394_5D_H      0x1394BB
#define REG_BK1394_5E_L      0x1394BC
#define REG_BK1394_5E_H      0x1394BD
#define REG_BK1394_5F_L      0x1394BE
#define REG_BK1394_5F_H      0x1394BF
#define REG_BK1394_60_L      0x1394C0
#define REG_BK1394_60_H      0x1394C1
#define REG_BK1394_61_L      0x1394C2
#define REG_BK1394_61_H      0x1394C3
#define REG_BK1394_62_L      0x1394C4
#define REG_BK1394_62_H      0x1394C5
#define REG_BK1394_63_L      0x1394C6
#define REG_BK1394_63_H      0x1394C7
#define REG_BK1394_64_L      0x1394C8
#define REG_BK1394_64_H      0x1394C9
#define REG_BK1394_65_L      0x1394CA
#define REG_BK1394_65_H      0x1394CB
#define REG_BK1394_66_L      0x1394CC
#define REG_BK1394_66_H      0x1394CD
#define REG_BK1394_67_L      0x1394CE
#define REG_BK1394_67_H      0x1394CF
#define REG_BK1394_68_L      0x1394D0
#define REG_BK1394_68_H      0x1394D1
#define REG_BK1394_69_L      0x1394D2
#define REG_BK1394_69_H      0x1394D3
#define REG_BK1394_6A_L      0x1394D4
#define REG_BK1394_6A_H      0x1394D5
#define REG_BK1394_6B_L      0x1394D6
#define REG_BK1394_6B_H      0x1394D7
#define REG_BK1394_6C_L      0x1394D8
#define REG_BK1394_6C_H      0x1394D9
#define REG_BK1394_6D_L      0x1394DA
#define REG_BK1394_6D_H      0x1394DB
#define REG_BK1394_6E_L      0x1394DC
#define REG_BK1394_6E_H      0x1394DD
#define REG_BK1394_6F_L      0x1394DE
#define REG_BK1394_6F_H      0x1394DF
#define REG_BK1394_70_L      0x1394E0
#define REG_BK1394_70_H      0x1394E1
#define REG_BK1394_71_L      0x1394E2
#define REG_BK1394_71_H      0x1394E3
#define REG_BK1394_72_L      0x1394E4
#define REG_BK1394_72_H      0x1394E5
#define REG_BK1394_73_L      0x1394E6
#define REG_BK1394_73_H      0x1394E7
#define REG_BK1394_74_L      0x1394E8
#define REG_BK1394_74_H      0x1394E9
#define REG_BK1394_75_L      0x1394EA
#define REG_BK1394_75_H      0x1394EB
#define REG_BK1394_76_L      0x1394EC
#define REG_BK1394_76_H      0x1394ED
#define REG_BK1394_77_L      0x1394EE
#define REG_BK1394_77_H      0x1394EF
#define REG_BK1394_78_L      0x1394F0
#define REG_BK1394_78_H      0x1394F1
#define REG_BK1394_79_L      0x1394F2
#define REG_BK1394_79_H      0x1394F3
#define REG_BK1394_7A_L      0x1394F4
#define REG_BK1394_7A_H      0x1394F5
#define REG_BK1394_7B_L      0x1394F6
#define REG_BK1394_7B_H      0x1394F7
#define REG_BK1394_7C_L      0x1394F8
#define REG_BK1394_7C_H      0x1394F9
#define REG_BK1394_7D_L      0x1394FA
#define REG_BK1394_7D_H      0x1394FB
#define REG_BK1394_7E_L      0x1394FC
#define REG_BK1394_7E_H      0x1394FD
#define REG_BK1394_7F_L      0x1394FE
#define REG_BK1394_7F_H      0x1394FF
//----------------------------------------------
#define REG_BK1395_00_L      0x139500
#define REG_BK1395_00_H      0x139501
#define REG_BK1395_01_L      0x139502
#define REG_BK1395_01_H      0x139503
#define REG_BK1395_02_L      0x139504
#define REG_BK1395_02_H      0x139505
#define REG_BK1395_03_L      0x139506
#define REG_BK1395_03_H      0x139507
#define REG_BK1395_04_L      0x139508
#define REG_BK1395_04_H      0x139509
#define REG_BK1395_05_L      0x13950A
#define REG_BK1395_05_H      0x13950B
#define REG_BK1395_06_L      0x13950C
#define REG_BK1395_06_H      0x13950D
#define REG_BK1395_07_L      0x13950E
#define REG_BK1395_07_H      0x13950F
#define REG_BK1395_08_L      0x139510
#define REG_BK1395_08_H      0x139511
#define REG_BK1395_09_L      0x139512
#define REG_BK1395_09_H      0x139513
#define REG_BK1395_0A_L      0x139514
#define REG_BK1395_0A_H      0x139515
#define REG_BK1395_0B_L      0x139516
#define REG_BK1395_0B_H      0x139517
#define REG_BK1395_0C_L      0x139518
#define REG_BK1395_0C_H      0x139519
#define REG_BK1395_0D_L      0x13951A
#define REG_BK1395_0D_H      0x13951B
#define REG_BK1395_0E_L      0x13951C
#define REG_BK1395_0E_H      0x13951D
#define REG_BK1395_0F_L      0x13951E
#define REG_BK1395_0F_H      0x13951F
#define REG_BK1395_10_L      0x139520
#define REG_BK1395_10_H      0x139521
#define REG_BK1395_11_L      0x139522
#define REG_BK1395_11_H      0x139523
#define REG_BK1395_12_L      0x139524
#define REG_BK1395_12_H      0x139525
#define REG_BK1395_13_L      0x139526
#define REG_BK1395_13_H      0x139527
#define REG_BK1395_14_L      0x139528
#define REG_BK1395_14_H      0x139529
#define REG_BK1395_15_L      0x13952A
#define REG_BK1395_15_H      0x13952B
#define REG_BK1395_16_L      0x13952C
#define REG_BK1395_16_H      0x13952D
#define REG_BK1395_17_L      0x13952E
#define REG_BK1395_17_H      0x13952F
#define REG_BK1395_18_L      0x139530
#define REG_BK1395_18_H      0x139531
#define REG_BK1395_19_L      0x139532
#define REG_BK1395_19_H      0x139533
#define REG_BK1395_1A_L      0x139534
#define REG_BK1395_1A_H      0x139535
#define REG_BK1395_1B_L      0x139536
#define REG_BK1395_1B_H      0x139537
#define REG_BK1395_1C_L      0x139538
#define REG_BK1395_1C_H      0x139539
#define REG_BK1395_1D_L      0x13953A
#define REG_BK1395_1D_H      0x13953B
#define REG_BK1395_1E_L      0x13953C
#define REG_BK1395_1E_H      0x13953D
#define REG_BK1395_1F_L      0x13953E
#define REG_BK1395_1F_H      0x13953F
#define REG_BK1395_20_L      0x139540
#define REG_BK1395_20_H      0x139541
#define REG_BK1395_21_L      0x139542
#define REG_BK1395_21_H      0x139543
#define REG_BK1395_22_L      0x139544
#define REG_BK1395_22_H      0x139545
#define REG_BK1395_23_L      0x139546
#define REG_BK1395_23_H      0x139547
#define REG_BK1395_24_L      0x139548
#define REG_BK1395_24_H      0x139549
#define REG_BK1395_25_L      0x13954A
#define REG_BK1395_25_H      0x13954B
#define REG_BK1395_26_L      0x13954C
#define REG_BK1395_26_H      0x13954D
#define REG_BK1395_27_L      0x13954E
#define REG_BK1395_27_H      0x13954F
#define REG_BK1395_28_L      0x139550
#define REG_BK1395_28_H      0x139551
#define REG_BK1395_29_L      0x139552
#define REG_BK1395_29_H      0x139553
#define REG_BK1395_2A_L      0x139554
#define REG_BK1395_2A_H      0x139555
#define REG_BK1395_2B_L      0x139556
#define REG_BK1395_2B_H      0x139557
#define REG_BK1395_2C_L      0x139558
#define REG_BK1395_2C_H      0x139559
#define REG_BK1395_2D_L      0x13955A
#define REG_BK1395_2D_H      0x13955B
#define REG_BK1395_2E_L      0x13955C
#define REG_BK1395_2E_H      0x13955D
#define REG_BK1395_2F_L      0x13955E
#define REG_BK1395_2F_H      0x13955F
#define REG_BK1395_30_L      0x139560
#define REG_BK1395_30_H      0x139561
#define REG_BK1395_31_L      0x139562
#define REG_BK1395_31_H      0x139563
#define REG_BK1395_32_L      0x139564
#define REG_BK1395_32_H      0x139565
#define REG_BK1395_33_L      0x139566
#define REG_BK1395_33_H      0x139567
#define REG_BK1395_34_L      0x139568
#define REG_BK1395_34_H      0x139569
#define REG_BK1395_35_L      0x13956A
#define REG_BK1395_35_H      0x13956B
#define REG_BK1395_36_L      0x13956C
#define REG_BK1395_36_H      0x13956D
#define REG_BK1395_37_L      0x13956E
#define REG_BK1395_37_H      0x13956F
#define REG_BK1395_38_L      0x139570
#define REG_BK1395_38_H      0x139571
#define REG_BK1395_39_L      0x139572
#define REG_BK1395_39_H      0x139573
#define REG_BK1395_3A_L      0x139574
#define REG_BK1395_3A_H      0x139575
#define REG_BK1395_3B_L      0x139576
#define REG_BK1395_3B_H      0x139577
#define REG_BK1395_3C_L      0x139578
#define REG_BK1395_3C_H      0x139579
#define REG_BK1395_3D_L      0x13957A
#define REG_BK1395_3D_H      0x13957B
#define REG_BK1395_3E_L      0x13957C
#define REG_BK1395_3E_H      0x13957D
#define REG_BK1395_3F_L      0x13957E
#define REG_BK1395_3F_H      0x13957F
#define REG_BK1395_40_L      0x139580
#define REG_BK1395_40_H      0x139581
#define REG_BK1395_41_L      0x139582
#define REG_BK1395_41_H      0x139583
#define REG_BK1395_42_L      0x139584
#define REG_BK1395_42_H      0x139585
#define REG_BK1395_43_L      0x139586
#define REG_BK1395_43_H      0x139587
#define REG_BK1395_44_L      0x139588
#define REG_BK1395_44_H      0x139589
#define REG_BK1395_45_L      0x13958A
#define REG_BK1395_45_H      0x13958B
#define REG_BK1395_46_L      0x13958C
#define REG_BK1395_46_H      0x13958D
#define REG_BK1395_47_L      0x13958E
#define REG_BK1395_47_H      0x13958F
#define REG_BK1395_48_L      0x139590
#define REG_BK1395_48_H      0x139591
#define REG_BK1395_49_L      0x139592
#define REG_BK1395_49_H      0x139593
#define REG_BK1395_4A_L      0x139594
#define REG_BK1395_4A_H      0x139595
#define REG_BK1395_4B_L      0x139596
#define REG_BK1395_4B_H      0x139597
#define REG_BK1395_4C_L      0x139598
#define REG_BK1395_4C_H      0x139599
#define REG_BK1395_4D_L      0x13959A
#define REG_BK1395_4D_H      0x13959B
#define REG_BK1395_4E_L      0x13959C
#define REG_BK1395_4E_H      0x13959D
#define REG_BK1395_4F_L      0x13959E
#define REG_BK1395_4F_H      0x13959F
#define REG_BK1395_50_L      0x1395A0
#define REG_BK1395_50_H      0x1395A1
#define REG_BK1395_51_L      0x1395A2
#define REG_BK1395_51_H      0x1395A3
#define REG_BK1395_52_L      0x1395A4
#define REG_BK1395_52_H      0x1395A5
#define REG_BK1395_53_L      0x1395A6
#define REG_BK1395_53_H      0x1395A7
#define REG_BK1395_54_L      0x1395A8
#define REG_BK1395_54_H      0x1395A9
#define REG_BK1395_55_L      0x1395AA
#define REG_BK1395_55_H      0x1395AB
#define REG_BK1395_56_L      0x1395AC
#define REG_BK1395_56_H      0x1395AD
#define REG_BK1395_57_L      0x1395AE
#define REG_BK1395_57_H      0x1395AF
#define REG_BK1395_58_L      0x1395B0
#define REG_BK1395_58_H      0x1395B1
#define REG_BK1395_59_L      0x1395B2
#define REG_BK1395_59_H      0x1395B3
#define REG_BK1395_5A_L      0x1395B4
#define REG_BK1395_5A_H      0x1395B5
#define REG_BK1395_5B_L      0x1395B6
#define REG_BK1395_5B_H      0x1395B7
#define REG_BK1395_5C_L      0x1395B8
#define REG_BK1395_5C_H      0x1395B9
#define REG_BK1395_5D_L      0x1395BA
#define REG_BK1395_5D_H      0x1395BB
#define REG_BK1395_5E_L      0x1395BC
#define REG_BK1395_5E_H      0x1395BD
#define REG_BK1395_5F_L      0x1395BE
#define REG_BK1395_5F_H      0x1395BF
#define REG_BK1395_60_L      0x1395C0
#define REG_BK1395_60_H      0x1395C1
#define REG_BK1395_61_L      0x1395C2
#define REG_BK1395_61_H      0x1395C3
#define REG_BK1395_62_L      0x1395C4
#define REG_BK1395_62_H      0x1395C5
#define REG_BK1395_63_L      0x1395C6
#define REG_BK1395_63_H      0x1395C7
#define REG_BK1395_64_L      0x1395C8
#define REG_BK1395_64_H      0x1395C9
#define REG_BK1395_65_L      0x1395CA
#define REG_BK1395_65_H      0x1395CB
#define REG_BK1395_66_L      0x1395CC
#define REG_BK1395_66_H      0x1395CD
#define REG_BK1395_67_L      0x1395CE
#define REG_BK1395_67_H      0x1395CF
#define REG_BK1395_68_L      0x1395D0
#define REG_BK1395_68_H      0x1395D1
#define REG_BK1395_69_L      0x1395D2
#define REG_BK1395_69_H      0x1395D3
#define REG_BK1395_6A_L      0x1395D4
#define REG_BK1395_6A_H      0x1395D5
#define REG_BK1395_6B_L      0x1395D6
#define REG_BK1395_6B_H      0x1395D7
#define REG_BK1395_6C_L      0x1395D8
#define REG_BK1395_6C_H      0x1395D9
#define REG_BK1395_6D_L      0x1395DA
#define REG_BK1395_6D_H      0x1395DB
#define REG_BK1395_6E_L      0x1395DC
#define REG_BK1395_6E_H      0x1395DD
#define REG_BK1395_6F_L      0x1395DE
#define REG_BK1395_6F_H      0x1395DF
#define REG_BK1395_70_L      0x1395E0
#define REG_BK1395_70_H      0x1395E1
#define REG_BK1395_71_L      0x1395E2
#define REG_BK1395_71_H      0x1395E3
#define REG_BK1395_72_L      0x1395E4
#define REG_BK1395_72_H      0x1395E5
#define REG_BK1395_73_L      0x1395E6
#define REG_BK1395_73_H      0x1395E7
#define REG_BK1395_74_L      0x1395E8
#define REG_BK1395_74_H      0x1395E9
#define REG_BK1395_75_L      0x1395EA
#define REG_BK1395_75_H      0x1395EB
#define REG_BK1395_76_L      0x1395EC
#define REG_BK1395_76_H      0x1395ED
#define REG_BK1395_77_L      0x1395EE
#define REG_BK1395_77_H      0x1395EF
#define REG_BK1395_78_L      0x1395F0
#define REG_BK1395_78_H      0x1395F1
#define REG_BK1395_79_L      0x1395F2
#define REG_BK1395_79_H      0x1395F3
#define REG_BK1395_7A_L      0x1395F4
#define REG_BK1395_7A_H      0x1395F5
#define REG_BK1395_7B_L      0x1395F6
#define REG_BK1395_7B_H      0x1395F7
#define REG_BK1395_7C_L      0x1395F8
#define REG_BK1395_7C_H      0x1395F9
#define REG_BK1395_7D_L      0x1395FA
#define REG_BK1395_7D_H      0x1395FB
#define REG_BK1395_7E_L      0x1395FC
#define REG_BK1395_7E_H      0x1395FD
#define REG_BK1395_7F_L      0x1395FE
#define REG_BK1395_7F_H      0x1395FF
//----------------------------------------------
#define REG_BK1396_00_L      0x139600
#define REG_BK1396_00_H      0x139601
#define REG_BK1396_01_L      0x139602
#define REG_BK1396_01_H      0x139603
#define REG_BK1396_02_L      0x139604
#define REG_BK1396_02_H      0x139605
#define REG_BK1396_03_L      0x139606
#define REG_BK1396_03_H      0x139607
#define REG_BK1396_04_L      0x139608
#define REG_BK1396_04_H      0x139609
#define REG_BK1396_05_L      0x13960A
#define REG_BK1396_05_H      0x13960B
#define REG_BK1396_06_L      0x13960C
#define REG_BK1396_06_H      0x13960D
#define REG_BK1396_07_L      0x13960E
#define REG_BK1396_07_H      0x13960F
#define REG_BK1396_08_L      0x139610
#define REG_BK1396_08_H      0x139611
#define REG_BK1396_09_L      0x139612
#define REG_BK1396_09_H      0x139613
#define REG_BK1396_0A_L      0x139614
#define REG_BK1396_0A_H      0x139615
#define REG_BK1396_0B_L      0x139616
#define REG_BK1396_0B_H      0x139617
#define REG_BK1396_0C_L      0x139618
#define REG_BK1396_0C_H      0x139619
#define REG_BK1396_0D_L      0x13961A
#define REG_BK1396_0D_H      0x13961B
#define REG_BK1396_0E_L      0x13961C
#define REG_BK1396_0E_H      0x13961D
#define REG_BK1396_0F_L      0x13961E
#define REG_BK1396_0F_H      0x13961F
#define REG_BK1396_10_L      0x139620
#define REG_BK1396_10_H      0x139621
#define REG_BK1396_11_L      0x139622
#define REG_BK1396_11_H      0x139623
#define REG_BK1396_12_L      0x139624
#define REG_BK1396_12_H      0x139625
#define REG_BK1396_13_L      0x139626
#define REG_BK1396_13_H      0x139627
#define REG_BK1396_14_L      0x139628
#define REG_BK1396_14_H      0x139629
#define REG_BK1396_15_L      0x13962A
#define REG_BK1396_15_H      0x13962B
#define REG_BK1396_16_L      0x13962C
#define REG_BK1396_16_H      0x13962D
#define REG_BK1396_17_L      0x13962E
#define REG_BK1396_17_H      0x13962F
#define REG_BK1396_18_L      0x139630
#define REG_BK1396_18_H      0x139631
#define REG_BK1396_19_L      0x139632
#define REG_BK1396_19_H      0x139633
#define REG_BK1396_1A_L      0x139634
#define REG_BK1396_1A_H      0x139635
#define REG_BK1396_1B_L      0x139636
#define REG_BK1396_1B_H      0x139637
#define REG_BK1396_1C_L      0x139638
#define REG_BK1396_1C_H      0x139639
#define REG_BK1396_1D_L      0x13963A
#define REG_BK1396_1D_H      0x13963B
#define REG_BK1396_1E_L      0x13963C
#define REG_BK1396_1E_H      0x13963D
#define REG_BK1396_1F_L      0x13963E
#define REG_BK1396_1F_H      0x13963F
#define REG_BK1396_20_L      0x139640
#define REG_BK1396_20_H      0x139641
#define REG_BK1396_21_L      0x139642
#define REG_BK1396_21_H      0x139643
#define REG_BK1396_22_L      0x139644
#define REG_BK1396_22_H      0x139645
#define REG_BK1396_23_L      0x139646
#define REG_BK1396_23_H      0x139647
#define REG_BK1396_24_L      0x139648
#define REG_BK1396_24_H      0x139649
#define REG_BK1396_25_L      0x13964A
#define REG_BK1396_25_H      0x13964B
#define REG_BK1396_26_L      0x13964C
#define REG_BK1396_26_H      0x13964D
#define REG_BK1396_27_L      0x13964E
#define REG_BK1396_27_H      0x13964F
#define REG_BK1396_28_L      0x139650
#define REG_BK1396_28_H      0x139651
#define REG_BK1396_29_L      0x139652
#define REG_BK1396_29_H      0x139653
#define REG_BK1396_2A_L      0x139654
#define REG_BK1396_2A_H      0x139655
#define REG_BK1396_2B_L      0x139656
#define REG_BK1396_2B_H      0x139657
#define REG_BK1396_2C_L      0x139658
#define REG_BK1396_2C_H      0x139659
#define REG_BK1396_2D_L      0x13965A
#define REG_BK1396_2D_H      0x13965B
#define REG_BK1396_2E_L      0x13965C
#define REG_BK1396_2E_H      0x13965D
#define REG_BK1396_2F_L      0x13965E
#define REG_BK1396_2F_H      0x13965F
#define REG_BK1396_30_L      0x139660
#define REG_BK1396_30_H      0x139661
#define REG_BK1396_31_L      0x139662
#define REG_BK1396_31_H      0x139663
#define REG_BK1396_32_L      0x139664
#define REG_BK1396_32_H      0x139665
#define REG_BK1396_33_L      0x139666
#define REG_BK1396_33_H      0x139667
#define REG_BK1396_34_L      0x139668
#define REG_BK1396_34_H      0x139669
#define REG_BK1396_35_L      0x13966A
#define REG_BK1396_35_H      0x13966B
#define REG_BK1396_36_L      0x13966C
#define REG_BK1396_36_H      0x13966D
#define REG_BK1396_37_L      0x13966E
#define REG_BK1396_37_H      0x13966F
#define REG_BK1396_38_L      0x139670
#define REG_BK1396_38_H      0x139671
#define REG_BK1396_39_L      0x139672
#define REG_BK1396_39_H      0x139673
#define REG_BK1396_3A_L      0x139674
#define REG_BK1396_3A_H      0x139675
#define REG_BK1396_3B_L      0x139676
#define REG_BK1396_3B_H      0x139677
#define REG_BK1396_3C_L      0x139678
#define REG_BK1396_3C_H      0x139679
#define REG_BK1396_3D_L      0x13967A
#define REG_BK1396_3D_H      0x13967B
#define REG_BK1396_3E_L      0x13967C
#define REG_BK1396_3E_H      0x13967D
#define REG_BK1396_3F_L      0x13967E
#define REG_BK1396_3F_H      0x13967F
#define REG_BK1396_40_L      0x139680
#define REG_BK1396_40_H      0x139681
#define REG_BK1396_41_L      0x139682
#define REG_BK1396_41_H      0x139683
#define REG_BK1396_42_L      0x139684
#define REG_BK1396_42_H      0x139685
#define REG_BK1396_43_L      0x139686
#define REG_BK1396_43_H      0x139687
#define REG_BK1396_44_L      0x139688
#define REG_BK1396_44_H      0x139689
#define REG_BK1396_45_L      0x13968A
#define REG_BK1396_45_H      0x13968B
#define REG_BK1396_46_L      0x13968C
#define REG_BK1396_46_H      0x13968D
#define REG_BK1396_47_L      0x13968E
#define REG_BK1396_47_H      0x13968F
#define REG_BK1396_48_L      0x139690
#define REG_BK1396_48_H      0x139691
#define REG_BK1396_49_L      0x139692
#define REG_BK1396_49_H      0x139693
#define REG_BK1396_4A_L      0x139694
#define REG_BK1396_4A_H      0x139695
#define REG_BK1396_4B_L      0x139696
#define REG_BK1396_4B_H      0x139697
#define REG_BK1396_4C_L      0x139698
#define REG_BK1396_4C_H      0x139699
#define REG_BK1396_4D_L      0x13969A
#define REG_BK1396_4D_H      0x13969B
#define REG_BK1396_4E_L      0x13969C
#define REG_BK1396_4E_H      0x13969D
#define REG_BK1396_4F_L      0x13969E
#define REG_BK1396_4F_H      0x13969F
#define REG_BK1396_50_L      0x1396A0
#define REG_BK1396_50_H      0x1396A1
#define REG_BK1396_51_L      0x1396A2
#define REG_BK1396_51_H      0x1396A3
#define REG_BK1396_52_L      0x1396A4
#define REG_BK1396_52_H      0x1396A5
#define REG_BK1396_53_L      0x1396A6
#define REG_BK1396_53_H      0x1396A7
#define REG_BK1396_54_L      0x1396A8
#define REG_BK1396_54_H      0x1396A9
#define REG_BK1396_55_L      0x1396AA
#define REG_BK1396_55_H      0x1396AB
#define REG_BK1396_56_L      0x1396AC
#define REG_BK1396_56_H      0x1396AD
#define REG_BK1396_57_L      0x1396AE
#define REG_BK1396_57_H      0x1396AF
#define REG_BK1396_58_L      0x1396B0
#define REG_BK1396_58_H      0x1396B1
#define REG_BK1396_59_L      0x1396B2
#define REG_BK1396_59_H      0x1396B3
#define REG_BK1396_5A_L      0x1396B4
#define REG_BK1396_5A_H      0x1396B5
#define REG_BK1396_5B_L      0x1396B6
#define REG_BK1396_5B_H      0x1396B7
#define REG_BK1396_5C_L      0x1396B8
#define REG_BK1396_5C_H      0x1396B9
#define REG_BK1396_5D_L      0x1396BA
#define REG_BK1396_5D_H      0x1396BB
#define REG_BK1396_5E_L      0x1396BC
#define REG_BK1396_5E_H      0x1396BD
#define REG_BK1396_5F_L      0x1396BE
#define REG_BK1396_5F_H      0x1396BF
#define REG_BK1396_60_L      0x1396C0
#define REG_BK1396_60_H      0x1396C1
#define REG_BK1396_61_L      0x1396C2
#define REG_BK1396_61_H      0x1396C3
#define REG_BK1396_62_L      0x1396C4
#define REG_BK1396_62_H      0x1396C5
#define REG_BK1396_63_L      0x1396C6
#define REG_BK1396_63_H      0x1396C7
#define REG_BK1396_64_L      0x1396C8
#define REG_BK1396_64_H      0x1396C9
#define REG_BK1396_65_L      0x1396CA
#define REG_BK1396_65_H      0x1396CB
#define REG_BK1396_66_L      0x1396CC
#define REG_BK1396_66_H      0x1396CD
#define REG_BK1396_67_L      0x1396CE
#define REG_BK1396_67_H      0x1396CF
#define REG_BK1396_68_L      0x1396D0
#define REG_BK1396_68_H      0x1396D1
#define REG_BK1396_69_L      0x1396D2
#define REG_BK1396_69_H      0x1396D3
#define REG_BK1396_6A_L      0x1396D4
#define REG_BK1396_6A_H      0x1396D5
#define REG_BK1396_6B_L      0x1396D6
#define REG_BK1396_6B_H      0x1396D7
#define REG_BK1396_6C_L      0x1396D8
#define REG_BK1396_6C_H      0x1396D9
#define REG_BK1396_6D_L      0x1396DA
#define REG_BK1396_6D_H      0x1396DB
#define REG_BK1396_6E_L      0x1396DC
#define REG_BK1396_6E_H      0x1396DD
#define REG_BK1396_6F_L      0x1396DE
#define REG_BK1396_6F_H      0x1396DF
#define REG_BK1396_70_L      0x1396E0
#define REG_BK1396_70_H      0x1396E1
#define REG_BK1396_71_L      0x1396E2
#define REG_BK1396_71_H      0x1396E3
#define REG_BK1396_72_L      0x1396E4
#define REG_BK1396_72_H      0x1396E5
#define REG_BK1396_73_L      0x1396E6
#define REG_BK1396_73_H      0x1396E7
#define REG_BK1396_74_L      0x1396E8
#define REG_BK1396_74_H      0x1396E9
#define REG_BK1396_75_L      0x1396EA
#define REG_BK1396_75_H      0x1396EB
#define REG_BK1396_76_L      0x1396EC
#define REG_BK1396_76_H      0x1396ED
#define REG_BK1396_77_L      0x1396EE
#define REG_BK1396_77_H      0x1396EF
#define REG_BK1396_78_L      0x1396F0
#define REG_BK1396_78_H      0x1396F1
#define REG_BK1396_79_L      0x1396F2
#define REG_BK1396_79_H      0x1396F3
#define REG_BK1396_7A_L      0x1396F4
#define REG_BK1396_7A_H      0x1396F5
#define REG_BK1396_7B_L      0x1396F6
#define REG_BK1396_7B_H      0x1396F7
#define REG_BK1396_7C_L      0x1396F8
#define REG_BK1396_7C_H      0x1396F9
#define REG_BK1396_7D_L      0x1396FA
#define REG_BK1396_7D_H      0x1396FB
#define REG_BK1396_7E_L      0x1396FC
#define REG_BK1396_7E_H      0x1396FD
#define REG_BK1396_7F_L      0x1396FE
#define REG_BK1396_7F_H      0x1396FF
//----------------------------------------------
#define REG_BK1397_00_L      0x139700
#define REG_BK1397_00_H      0x139701
#define REG_BK1397_01_L      0x139702
#define REG_BK1397_01_H      0x139703
#define REG_BK1397_02_L      0x139704
#define REG_BK1397_02_H      0x139705
#define REG_BK1397_03_L      0x139706
#define REG_BK1397_03_H      0x139707
#define REG_BK1397_04_L      0x139708
#define REG_BK1397_04_H      0x139709
#define REG_BK1397_05_L      0x13970A
#define REG_BK1397_05_H      0x13970B
#define REG_BK1397_06_L      0x13970C
#define REG_BK1397_06_H      0x13970D
#define REG_BK1397_07_L      0x13970E
#define REG_BK1397_07_H      0x13970F
#define REG_BK1397_08_L      0x139710
#define REG_BK1397_08_H      0x139711
#define REG_BK1397_09_L      0x139712
#define REG_BK1397_09_H      0x139713
#define REG_BK1397_0A_L      0x139714
#define REG_BK1397_0A_H      0x139715
#define REG_BK1397_0B_L      0x139716
#define REG_BK1397_0B_H      0x139717
#define REG_BK1397_0C_L      0x139718
#define REG_BK1397_0C_H      0x139719
#define REG_BK1397_0D_L      0x13971A
#define REG_BK1397_0D_H      0x13971B
#define REG_BK1397_0E_L      0x13971C
#define REG_BK1397_0E_H      0x13971D
#define REG_BK1397_0F_L      0x13971E
#define REG_BK1397_0F_H      0x13971F
#define REG_BK1397_10_L      0x139720
#define REG_BK1397_10_H      0x139721
#define REG_BK1397_11_L      0x139722
#define REG_BK1397_11_H      0x139723
#define REG_BK1397_12_L      0x139724
#define REG_BK1397_12_H      0x139725
#define REG_BK1397_13_L      0x139726
#define REG_BK1397_13_H      0x139727
#define REG_BK1397_14_L      0x139728
#define REG_BK1397_14_H      0x139729
#define REG_BK1397_15_L      0x13972A
#define REG_BK1397_15_H      0x13972B
#define REG_BK1397_16_L      0x13972C
#define REG_BK1397_16_H      0x13972D
#define REG_BK1397_17_L      0x13972E
#define REG_BK1397_17_H      0x13972F
#define REG_BK1397_18_L      0x139730
#define REG_BK1397_18_H      0x139731
#define REG_BK1397_19_L      0x139732
#define REG_BK1397_19_H      0x139733
#define REG_BK1397_1A_L      0x139734
#define REG_BK1397_1A_H      0x139735
#define REG_BK1397_1B_L      0x139736
#define REG_BK1397_1B_H      0x139737
#define REG_BK1397_1C_L      0x139738
#define REG_BK1397_1C_H      0x139739
#define REG_BK1397_1D_L      0x13973A
#define REG_BK1397_1D_H      0x13973B
#define REG_BK1397_1E_L      0x13973C
#define REG_BK1397_1E_H      0x13973D
#define REG_BK1397_1F_L      0x13973E
#define REG_BK1397_1F_H      0x13973F
#define REG_BK1397_20_L      0x139740
#define REG_BK1397_20_H      0x139741
#define REG_BK1397_21_L      0x139742
#define REG_BK1397_21_H      0x139743
#define REG_BK1397_22_L      0x139744
#define REG_BK1397_22_H      0x139745
#define REG_BK1397_23_L      0x139746
#define REG_BK1397_23_H      0x139747
#define REG_BK1397_24_L      0x139748
#define REG_BK1397_24_H      0x139749
#define REG_BK1397_25_L      0x13974A
#define REG_BK1397_25_H      0x13974B
#define REG_BK1397_26_L      0x13974C
#define REG_BK1397_26_H      0x13974D
#define REG_BK1397_27_L      0x13974E
#define REG_BK1397_27_H      0x13974F
#define REG_BK1397_28_L      0x139750
#define REG_BK1397_28_H      0x139751
#define REG_BK1397_29_L      0x139752
#define REG_BK1397_29_H      0x139753
#define REG_BK1397_2A_L      0x139754
#define REG_BK1397_2A_H      0x139755
#define REG_BK1397_2B_L      0x139756
#define REG_BK1397_2B_H      0x139757
#define REG_BK1397_2C_L      0x139758
#define REG_BK1397_2C_H      0x139759
#define REG_BK1397_2D_L      0x13975A
#define REG_BK1397_2D_H      0x13975B
#define REG_BK1397_2E_L      0x13975C
#define REG_BK1397_2E_H      0x13975D
#define REG_BK1397_2F_L      0x13975E
#define REG_BK1397_2F_H      0x13975F
#define REG_BK1397_30_L      0x139760
#define REG_BK1397_30_H      0x139761
#define REG_BK1397_31_L      0x139762
#define REG_BK1397_31_H      0x139763
#define REG_BK1397_32_L      0x139764
#define REG_BK1397_32_H      0x139765
#define REG_BK1397_33_L      0x139766
#define REG_BK1397_33_H      0x139767
#define REG_BK1397_34_L      0x139768
#define REG_BK1397_34_H      0x139769
#define REG_BK1397_35_L      0x13976A
#define REG_BK1397_35_H      0x13976B
#define REG_BK1397_36_L      0x13976C
#define REG_BK1397_36_H      0x13976D
#define REG_BK1397_37_L      0x13976E
#define REG_BK1397_37_H      0x13976F
#define REG_BK1397_38_L      0x139770
#define REG_BK1397_38_H      0x139771
#define REG_BK1397_39_L      0x139772
#define REG_BK1397_39_H      0x139773
#define REG_BK1397_3A_L      0x139774
#define REG_BK1397_3A_H      0x139775
#define REG_BK1397_3B_L      0x139776
#define REG_BK1397_3B_H      0x139777
#define REG_BK1397_3C_L      0x139778
#define REG_BK1397_3C_H      0x139779
#define REG_BK1397_3D_L      0x13977A
#define REG_BK1397_3D_H      0x13977B
#define REG_BK1397_3E_L      0x13977C
#define REG_BK1397_3E_H      0x13977D
#define REG_BK1397_3F_L      0x13977E
#define REG_BK1397_3F_H      0x13977F
#define REG_BK1397_40_L      0x139780
#define REG_BK1397_40_H      0x139781
#define REG_BK1397_41_L      0x139782
#define REG_BK1397_41_H      0x139783
#define REG_BK1397_42_L      0x139784
#define REG_BK1397_42_H      0x139785
#define REG_BK1397_43_L      0x139786
#define REG_BK1397_43_H      0x139787
#define REG_BK1397_44_L      0x139788
#define REG_BK1397_44_H      0x139789
#define REG_BK1397_45_L      0x13978A
#define REG_BK1397_45_H      0x13978B
#define REG_BK1397_46_L      0x13978C
#define REG_BK1397_46_H      0x13978D
#define REG_BK1397_47_L      0x13978E
#define REG_BK1397_47_H      0x13978F
#define REG_BK1397_48_L      0x139790
#define REG_BK1397_48_H      0x139791
#define REG_BK1397_49_L      0x139792
#define REG_BK1397_49_H      0x139793
#define REG_BK1397_4A_L      0x139794
#define REG_BK1397_4A_H      0x139795
#define REG_BK1397_4B_L      0x139796
#define REG_BK1397_4B_H      0x139797
#define REG_BK1397_4C_L      0x139798
#define REG_BK1397_4C_H      0x139799
#define REG_BK1397_4D_L      0x13979A
#define REG_BK1397_4D_H      0x13979B
#define REG_BK1397_4E_L      0x13979C
#define REG_BK1397_4E_H      0x13979D
#define REG_BK1397_4F_L      0x13979E
#define REG_BK1397_4F_H      0x13979F
#define REG_BK1397_50_L      0x1397A0
#define REG_BK1397_50_H      0x1397A1
#define REG_BK1397_51_L      0x1397A2
#define REG_BK1397_51_H      0x1397A3
#define REG_BK1397_52_L      0x1397A4
#define REG_BK1397_52_H      0x1397A5
#define REG_BK1397_53_L      0x1397A6
#define REG_BK1397_53_H      0x1397A7
#define REG_BK1397_54_L      0x1397A8
#define REG_BK1397_54_H      0x1397A9
#define REG_BK1397_55_L      0x1397AA
#define REG_BK1397_55_H      0x1397AB
#define REG_BK1397_56_L      0x1397AC
#define REG_BK1397_56_H      0x1397AD
#define REG_BK1397_57_L      0x1397AE
#define REG_BK1397_57_H      0x1397AF
#define REG_BK1397_58_L      0x1397B0
#define REG_BK1397_58_H      0x1397B1
#define REG_BK1397_59_L      0x1397B2
#define REG_BK1397_59_H      0x1397B3
#define REG_BK1397_5A_L      0x1397B4
#define REG_BK1397_5A_H      0x1397B5
#define REG_BK1397_5B_L      0x1397B6
#define REG_BK1397_5B_H      0x1397B7
#define REG_BK1397_5C_L      0x1397B8
#define REG_BK1397_5C_H      0x1397B9
#define REG_BK1397_5D_L      0x1397BA
#define REG_BK1397_5D_H      0x1397BB
#define REG_BK1397_5E_L      0x1397BC
#define REG_BK1397_5E_H      0x1397BD
#define REG_BK1397_5F_L      0x1397BE
#define REG_BK1397_5F_H      0x1397BF
#define REG_BK1397_60_L      0x1397C0
#define REG_BK1397_60_H      0x1397C1
#define REG_BK1397_61_L      0x1397C2
#define REG_BK1397_61_H      0x1397C3
#define REG_BK1397_62_L      0x1397C4
#define REG_BK1397_62_H      0x1397C5
#define REG_BK1397_63_L      0x1397C6
#define REG_BK1397_63_H      0x1397C7
#define REG_BK1397_64_L      0x1397C8
#define REG_BK1397_64_H      0x1397C9
#define REG_BK1397_65_L      0x1397CA
#define REG_BK1397_65_H      0x1397CB
#define REG_BK1397_66_L      0x1397CC
#define REG_BK1397_66_H      0x1397CD
#define REG_BK1397_67_L      0x1397CE
#define REG_BK1397_67_H      0x1397CF
#define REG_BK1397_68_L      0x1397D0
#define REG_BK1397_68_H      0x1397D1
#define REG_BK1397_69_L      0x1397D2
#define REG_BK1397_69_H      0x1397D3
#define REG_BK1397_6A_L      0x1397D4
#define REG_BK1397_6A_H      0x1397D5
#define REG_BK1397_6B_L      0x1397D6
#define REG_BK1397_6B_H      0x1397D7
#define REG_BK1397_6C_L      0x1397D8
#define REG_BK1397_6C_H      0x1397D9
#define REG_BK1397_6D_L      0x1397DA
#define REG_BK1397_6D_H      0x1397DB
#define REG_BK1397_6E_L      0x1397DC
#define REG_BK1397_6E_H      0x1397DD
#define REG_BK1397_6F_L      0x1397DE
#define REG_BK1397_6F_H      0x1397DF
#define REG_BK1397_70_L      0x1397E0
#define REG_BK1397_70_H      0x1397E1
#define REG_BK1397_71_L      0x1397E2
#define REG_BK1397_71_H      0x1397E3
#define REG_BK1397_72_L      0x1397E4
#define REG_BK1397_72_H      0x1397E5
#define REG_BK1397_73_L      0x1397E6
#define REG_BK1397_73_H      0x1397E7
#define REG_BK1397_74_L      0x1397E8
#define REG_BK1397_74_H      0x1397E9
#define REG_BK1397_75_L      0x1397EA
#define REG_BK1397_75_H      0x1397EB
#define REG_BK1397_76_L      0x1397EC
#define REG_BK1397_76_H      0x1397ED
#define REG_BK1397_77_L      0x1397EE
#define REG_BK1397_77_H      0x1397EF
#define REG_BK1397_78_L      0x1397F0
#define REG_BK1397_78_H      0x1397F1
#define REG_BK1397_79_L      0x1397F2
#define REG_BK1397_79_H      0x1397F3
#define REG_BK1397_7A_L      0x1397F4
#define REG_BK1397_7A_H      0x1397F5
#define REG_BK1397_7B_L      0x1397F6
#define REG_BK1397_7B_H      0x1397F7
#define REG_BK1397_7C_L      0x1397F8
#define REG_BK1397_7C_H      0x1397F9
#define REG_BK1397_7D_L      0x1397FA
#define REG_BK1397_7D_H      0x1397FB
#define REG_BK1397_7E_L      0x1397FC
#define REG_BK1397_7E_H      0x1397FD
#define REG_BK1397_7F_L      0x1397FE
#define REG_BK1397_7F_H      0x1397FF
//----------------------------------------------
#define REG_BK1398_00_L      0x139800
#define REG_BK1398_00_H      0x139801
#define REG_BK1398_01_L      0x139802
#define REG_BK1398_01_H      0x139803
#define REG_BK1398_02_L      0x139804
#define REG_BK1398_02_H      0x139805
#define REG_BK1398_03_L      0x139806
#define REG_BK1398_03_H      0x139807
#define REG_BK1398_04_L      0x139808
#define REG_BK1398_04_H      0x139809
#define REG_BK1398_05_L      0x13980A
#define REG_BK1398_05_H      0x13980B
#define REG_BK1398_06_L      0x13980C
#define REG_BK1398_06_H      0x13980D
#define REG_BK1398_07_L      0x13980E
#define REG_BK1398_07_H      0x13980F
#define REG_BK1398_08_L      0x139810
#define REG_BK1398_08_H      0x139811
#define REG_BK1398_09_L      0x139812
#define REG_BK1398_09_H      0x139813
#define REG_BK1398_0A_L      0x139814
#define REG_BK1398_0A_H      0x139815
#define REG_BK1398_0B_L      0x139816
#define REG_BK1398_0B_H      0x139817
#define REG_BK1398_0C_L      0x139818
#define REG_BK1398_0C_H      0x139819
#define REG_BK1398_0D_L      0x13981A
#define REG_BK1398_0D_H      0x13981B
#define REG_BK1398_0E_L      0x13981C
#define REG_BK1398_0E_H      0x13981D
#define REG_BK1398_0F_L      0x13981E
#define REG_BK1398_0F_H      0x13981F
#define REG_BK1398_10_L      0x139820
#define REG_BK1398_10_H      0x139821
#define REG_BK1398_11_L      0x139822
#define REG_BK1398_11_H      0x139823
#define REG_BK1398_12_L      0x139824
#define REG_BK1398_12_H      0x139825
#define REG_BK1398_13_L      0x139826
#define REG_BK1398_13_H      0x139827
#define REG_BK1398_14_L      0x139828
#define REG_BK1398_14_H      0x139829
#define REG_BK1398_15_L      0x13982A
#define REG_BK1398_15_H      0x13982B
#define REG_BK1398_16_L      0x13982C
#define REG_BK1398_16_H      0x13982D
#define REG_BK1398_17_L      0x13982E
#define REG_BK1398_17_H      0x13982F
#define REG_BK1398_18_L      0x139830
#define REG_BK1398_18_H      0x139831
#define REG_BK1398_19_L      0x139832
#define REG_BK1398_19_H      0x139833
#define REG_BK1398_1A_L      0x139834
#define REG_BK1398_1A_H      0x139835
#define REG_BK1398_1B_L      0x139836
#define REG_BK1398_1B_H      0x139837
#define REG_BK1398_1C_L      0x139838
#define REG_BK1398_1C_H      0x139839
#define REG_BK1398_1D_L      0x13983A
#define REG_BK1398_1D_H      0x13983B
#define REG_BK1398_1E_L      0x13983C
#define REG_BK1398_1E_H      0x13983D
#define REG_BK1398_1F_L      0x13983E
#define REG_BK1398_1F_H      0x13983F
#define REG_BK1398_20_L      0x139840
#define REG_BK1398_20_H      0x139841
#define REG_BK1398_21_L      0x139842
#define REG_BK1398_21_H      0x139843
#define REG_BK1398_22_L      0x139844
#define REG_BK1398_22_H      0x139845
#define REG_BK1398_23_L      0x139846
#define REG_BK1398_23_H      0x139847
#define REG_BK1398_24_L      0x139848
#define REG_BK1398_24_H      0x139849
#define REG_BK1398_25_L      0x13984A
#define REG_BK1398_25_H      0x13984B
#define REG_BK1398_26_L      0x13984C
#define REG_BK1398_26_H      0x13984D
#define REG_BK1398_27_L      0x13984E
#define REG_BK1398_27_H      0x13984F
#define REG_BK1398_28_L      0x139850
#define REG_BK1398_28_H      0x139851
#define REG_BK1398_29_L      0x139852
#define REG_BK1398_29_H      0x139853
#define REG_BK1398_2A_L      0x139854
#define REG_BK1398_2A_H      0x139855
#define REG_BK1398_2B_L      0x139856
#define REG_BK1398_2B_H      0x139857
#define REG_BK1398_2C_L      0x139858
#define REG_BK1398_2C_H      0x139859
#define REG_BK1398_2D_L      0x13985A
#define REG_BK1398_2D_H      0x13985B
#define REG_BK1398_2E_L      0x13985C
#define REG_BK1398_2E_H      0x13985D
#define REG_BK1398_2F_L      0x13985E
#define REG_BK1398_2F_H      0x13985F
#define REG_BK1398_30_L      0x139860
#define REG_BK1398_30_H      0x139861
#define REG_BK1398_31_L      0x139862
#define REG_BK1398_31_H      0x139863
#define REG_BK1398_32_L      0x139864
#define REG_BK1398_32_H      0x139865
#define REG_BK1398_33_L      0x139866
#define REG_BK1398_33_H      0x139867
#define REG_BK1398_34_L      0x139868
#define REG_BK1398_34_H      0x139869
#define REG_BK1398_35_L      0x13986A
#define REG_BK1398_35_H      0x13986B
#define REG_BK1398_36_L      0x13986C
#define REG_BK1398_36_H      0x13986D
#define REG_BK1398_37_L      0x13986E
#define REG_BK1398_37_H      0x13986F
#define REG_BK1398_38_L      0x139870
#define REG_BK1398_38_H      0x139871
#define REG_BK1398_39_L      0x139872
#define REG_BK1398_39_H      0x139873
#define REG_BK1398_3A_L      0x139874
#define REG_BK1398_3A_H      0x139875
#define REG_BK1398_3B_L      0x139876
#define REG_BK1398_3B_H      0x139877
#define REG_BK1398_3C_L      0x139878
#define REG_BK1398_3C_H      0x139879
#define REG_BK1398_3D_L      0x13987A
#define REG_BK1398_3D_H      0x13987B
#define REG_BK1398_3E_L      0x13987C
#define REG_BK1398_3E_H      0x13987D
#define REG_BK1398_3F_L      0x13987E
#define REG_BK1398_3F_H      0x13987F
#define REG_BK1398_40_L      0x139880
#define REG_BK1398_40_H      0x139881
#define REG_BK1398_41_L      0x139882
#define REG_BK1398_41_H      0x139883
#define REG_BK1398_42_L      0x139884
#define REG_BK1398_42_H      0x139885
#define REG_BK1398_43_L      0x139886
#define REG_BK1398_43_H      0x139887
#define REG_BK1398_44_L      0x139888
#define REG_BK1398_44_H      0x139889
#define REG_BK1398_45_L      0x13988A
#define REG_BK1398_45_H      0x13988B
#define REG_BK1398_46_L      0x13988C
#define REG_BK1398_46_H      0x13988D
#define REG_BK1398_47_L      0x13988E
#define REG_BK1398_47_H      0x13988F
#define REG_BK1398_48_L      0x139890
#define REG_BK1398_48_H      0x139891
#define REG_BK1398_49_L      0x139892
#define REG_BK1398_49_H      0x139893
#define REG_BK1398_4A_L      0x139894
#define REG_BK1398_4A_H      0x139895
#define REG_BK1398_4B_L      0x139896
#define REG_BK1398_4B_H      0x139897
#define REG_BK1398_4C_L      0x139898
#define REG_BK1398_4C_H      0x139899
#define REG_BK1398_4D_L      0x13989A
#define REG_BK1398_4D_H      0x13989B
#define REG_BK1398_4E_L      0x13989C
#define REG_BK1398_4E_H      0x13989D
#define REG_BK1398_4F_L      0x13989E
#define REG_BK1398_4F_H      0x13989F
#define REG_BK1398_50_L      0x1398A0
#define REG_BK1398_50_H      0x1398A1
#define REG_BK1398_51_L      0x1398A2
#define REG_BK1398_51_H      0x1398A3
#define REG_BK1398_52_L      0x1398A4
#define REG_BK1398_52_H      0x1398A5
#define REG_BK1398_53_L      0x1398A6
#define REG_BK1398_53_H      0x1398A7
#define REG_BK1398_54_L      0x1398A8
#define REG_BK1398_54_H      0x1398A9
#define REG_BK1398_55_L      0x1398AA
#define REG_BK1398_55_H      0x1398AB
#define REG_BK1398_56_L      0x1398AC
#define REG_BK1398_56_H      0x1398AD
#define REG_BK1398_57_L      0x1398AE
#define REG_BK1398_57_H      0x1398AF
#define REG_BK1398_58_L      0x1398B0
#define REG_BK1398_58_H      0x1398B1
#define REG_BK1398_59_L      0x1398B2
#define REG_BK1398_59_H      0x1398B3
#define REG_BK1398_5A_L      0x1398B4
#define REG_BK1398_5A_H      0x1398B5
#define REG_BK1398_5B_L      0x1398B6
#define REG_BK1398_5B_H      0x1398B7
#define REG_BK1398_5C_L      0x1398B8
#define REG_BK1398_5C_H      0x1398B9
#define REG_BK1398_5D_L      0x1398BA
#define REG_BK1398_5D_H      0x1398BB
#define REG_BK1398_5E_L      0x1398BC
#define REG_BK1398_5E_H      0x1398BD
#define REG_BK1398_5F_L      0x1398BE
#define REG_BK1398_5F_H      0x1398BF
#define REG_BK1398_60_L      0x1398C0
#define REG_BK1398_60_H      0x1398C1
#define REG_BK1398_61_L      0x1398C2
#define REG_BK1398_61_H      0x1398C3
#define REG_BK1398_62_L      0x1398C4
#define REG_BK1398_62_H      0x1398C5
#define REG_BK1398_63_L      0x1398C6
#define REG_BK1398_63_H      0x1398C7
#define REG_BK1398_64_L      0x1398C8
#define REG_BK1398_64_H      0x1398C9
#define REG_BK1398_65_L      0x1398CA
#define REG_BK1398_65_H      0x1398CB
#define REG_BK1398_66_L      0x1398CC
#define REG_BK1398_66_H      0x1398CD
#define REG_BK1398_67_L      0x1398CE
#define REG_BK1398_67_H      0x1398CF
#define REG_BK1398_68_L      0x1398D0
#define REG_BK1398_68_H      0x1398D1
#define REG_BK1398_69_L      0x1398D2
#define REG_BK1398_69_H      0x1398D3
#define REG_BK1398_6A_L      0x1398D4
#define REG_BK1398_6A_H      0x1398D5
#define REG_BK1398_6B_L      0x1398D6
#define REG_BK1398_6B_H      0x1398D7
#define REG_BK1398_6C_L      0x1398D8
#define REG_BK1398_6C_H      0x1398D9
#define REG_BK1398_6D_L      0x1398DA
#define REG_BK1398_6D_H      0x1398DB
#define REG_BK1398_6E_L      0x1398DC
#define REG_BK1398_6E_H      0x1398DD
#define REG_BK1398_6F_L      0x1398DE
#define REG_BK1398_6F_H      0x1398DF
#define REG_BK1398_70_L      0x1398E0
#define REG_BK1398_70_H      0x1398E1
#define REG_BK1398_71_L      0x1398E2
#define REG_BK1398_71_H      0x1398E3
#define REG_BK1398_72_L      0x1398E4
#define REG_BK1398_72_H      0x1398E5
#define REG_BK1398_73_L      0x1398E6
#define REG_BK1398_73_H      0x1398E7
#define REG_BK1398_74_L      0x1398E8
#define REG_BK1398_74_H      0x1398E9
#define REG_BK1398_75_L      0x1398EA
#define REG_BK1398_75_H      0x1398EB
#define REG_BK1398_76_L      0x1398EC
#define REG_BK1398_76_H      0x1398ED
#define REG_BK1398_77_L      0x1398EE
#define REG_BK1398_77_H      0x1398EF
#define REG_BK1398_78_L      0x1398F0
#define REG_BK1398_78_H      0x1398F1
#define REG_BK1398_79_L      0x1398F2
#define REG_BK1398_79_H      0x1398F3
#define REG_BK1398_7A_L      0x1398F4
#define REG_BK1398_7A_H      0x1398F5
#define REG_BK1398_7B_L      0x1398F6
#define REG_BK1398_7B_H      0x1398F7
#define REG_BK1398_7C_L      0x1398F8
#define REG_BK1398_7C_H      0x1398F9
#define REG_BK1398_7D_L      0x1398FA
#define REG_BK1398_7D_H      0x1398FB
#define REG_BK1398_7E_L      0x1398FC
#define REG_BK1398_7E_H      0x1398FD
#define REG_BK1398_7F_L      0x1398FE
#define REG_BK1398_7F_H      0x1398FF
//----------------------------------------------
#define REG_BK1399_00_L      0x139900
#define REG_BK1399_00_H      0x139901
#define REG_BK1399_01_L      0x139902
#define REG_BK1399_01_H      0x139903
#define REG_BK1399_02_L      0x139904
#define REG_BK1399_02_H      0x139905
#define REG_BK1399_03_L      0x139906
#define REG_BK1399_03_H      0x139907
#define REG_BK1399_04_L      0x139908
#define REG_BK1399_04_H      0x139909
#define REG_BK1399_05_L      0x13990A
#define REG_BK1399_05_H      0x13990B
#define REG_BK1399_06_L      0x13990C
#define REG_BK1399_06_H      0x13990D
#define REG_BK1399_07_L      0x13990E
#define REG_BK1399_07_H      0x13990F
#define REG_BK1399_08_L      0x139910
#define REG_BK1399_08_H      0x139911
#define REG_BK1399_09_L      0x139912
#define REG_BK1399_09_H      0x139913
#define REG_BK1399_0A_L      0x139914
#define REG_BK1399_0A_H      0x139915
#define REG_BK1399_0B_L      0x139916
#define REG_BK1399_0B_H      0x139917
#define REG_BK1399_0C_L      0x139918
#define REG_BK1399_0C_H      0x139919
#define REG_BK1399_0D_L      0x13991A
#define REG_BK1399_0D_H      0x13991B
#define REG_BK1399_0E_L      0x13991C
#define REG_BK1399_0E_H      0x13991D
#define REG_BK1399_0F_L      0x13991E
#define REG_BK1399_0F_H      0x13991F
#define REG_BK1399_10_L      0x139920
#define REG_BK1399_10_H      0x139921
#define REG_BK1399_11_L      0x139922
#define REG_BK1399_11_H      0x139923
#define REG_BK1399_12_L      0x139924
#define REG_BK1399_12_H      0x139925
#define REG_BK1399_13_L      0x139926
#define REG_BK1399_13_H      0x139927
#define REG_BK1399_14_L      0x139928
#define REG_BK1399_14_H      0x139929
#define REG_BK1399_15_L      0x13992A
#define REG_BK1399_15_H      0x13992B
#define REG_BK1399_16_L      0x13992C
#define REG_BK1399_16_H      0x13992D
#define REG_BK1399_17_L      0x13992E
#define REG_BK1399_17_H      0x13992F
#define REG_BK1399_18_L      0x139930
#define REG_BK1399_18_H      0x139931
#define REG_BK1399_19_L      0x139932
#define REG_BK1399_19_H      0x139933
#define REG_BK1399_1A_L      0x139934
#define REG_BK1399_1A_H      0x139935
#define REG_BK1399_1B_L      0x139936
#define REG_BK1399_1B_H      0x139937
#define REG_BK1399_1C_L      0x139938
#define REG_BK1399_1C_H      0x139939
#define REG_BK1399_1D_L      0x13993A
#define REG_BK1399_1D_H      0x13993B
#define REG_BK1399_1E_L      0x13993C
#define REG_BK1399_1E_H      0x13993D
#define REG_BK1399_1F_L      0x13993E
#define REG_BK1399_1F_H      0x13993F
#define REG_BK1399_20_L      0x139940
#define REG_BK1399_20_H      0x139941
#define REG_BK1399_21_L      0x139942
#define REG_BK1399_21_H      0x139943
#define REG_BK1399_22_L      0x139944
#define REG_BK1399_22_H      0x139945
#define REG_BK1399_23_L      0x139946
#define REG_BK1399_23_H      0x139947
#define REG_BK1399_24_L      0x139948
#define REG_BK1399_24_H      0x139949
#define REG_BK1399_25_L      0x13994A
#define REG_BK1399_25_H      0x13994B
#define REG_BK1399_26_L      0x13994C
#define REG_BK1399_26_H      0x13994D
#define REG_BK1399_27_L      0x13994E
#define REG_BK1399_27_H      0x13994F
#define REG_BK1399_28_L      0x139950
#define REG_BK1399_28_H      0x139951
#define REG_BK1399_29_L      0x139952
#define REG_BK1399_29_H      0x139953
#define REG_BK1399_2A_L      0x139954
#define REG_BK1399_2A_H      0x139955
#define REG_BK1399_2B_L      0x139956
#define REG_BK1399_2B_H      0x139957
#define REG_BK1399_2C_L      0x139958
#define REG_BK1399_2C_H      0x139959
#define REG_BK1399_2D_L      0x13995A
#define REG_BK1399_2D_H      0x13995B
#define REG_BK1399_2E_L      0x13995C
#define REG_BK1399_2E_H      0x13995D
#define REG_BK1399_2F_L      0x13995E
#define REG_BK1399_2F_H      0x13995F
#define REG_BK1399_30_L      0x139960
#define REG_BK1399_30_H      0x139961
#define REG_BK1399_31_L      0x139962
#define REG_BK1399_31_H      0x139963
#define REG_BK1399_32_L      0x139964
#define REG_BK1399_32_H      0x139965
#define REG_BK1399_33_L      0x139966
#define REG_BK1399_33_H      0x139967
#define REG_BK1399_34_L      0x139968
#define REG_BK1399_34_H      0x139969
#define REG_BK1399_35_L      0x13996A
#define REG_BK1399_35_H      0x13996B
#define REG_BK1399_36_L      0x13996C
#define REG_BK1399_36_H      0x13996D
#define REG_BK1399_37_L      0x13996E
#define REG_BK1399_37_H      0x13996F
#define REG_BK1399_38_L      0x139970
#define REG_BK1399_38_H      0x139971
#define REG_BK1399_39_L      0x139972
#define REG_BK1399_39_H      0x139973
#define REG_BK1399_3A_L      0x139974
#define REG_BK1399_3A_H      0x139975
#define REG_BK1399_3B_L      0x139976
#define REG_BK1399_3B_H      0x139977
#define REG_BK1399_3C_L      0x139978
#define REG_BK1399_3C_H      0x139979
#define REG_BK1399_3D_L      0x13997A
#define REG_BK1399_3D_H      0x13997B
#define REG_BK1399_3E_L      0x13997C
#define REG_BK1399_3E_H      0x13997D
#define REG_BK1399_3F_L      0x13997E
#define REG_BK1399_3F_H      0x13997F
#define REG_BK1399_40_L      0x139980
#define REG_BK1399_40_H      0x139981
#define REG_BK1399_41_L      0x139982
#define REG_BK1399_41_H      0x139983
#define REG_BK1399_42_L      0x139984
#define REG_BK1399_42_H      0x139985
#define REG_BK1399_43_L      0x139986
#define REG_BK1399_43_H      0x139987
#define REG_BK1399_44_L      0x139988
#define REG_BK1399_44_H      0x139989
#define REG_BK1399_45_L      0x13998A
#define REG_BK1399_45_H      0x13998B
#define REG_BK1399_46_L      0x13998C
#define REG_BK1399_46_H      0x13998D
#define REG_BK1399_47_L      0x13998E
#define REG_BK1399_47_H      0x13998F
#define REG_BK1399_48_L      0x139990
#define REG_BK1399_48_H      0x139991
#define REG_BK1399_49_L      0x139992
#define REG_BK1399_49_H      0x139993
#define REG_BK1399_4A_L      0x139994
#define REG_BK1399_4A_H      0x139995
#define REG_BK1399_4B_L      0x139996
#define REG_BK1399_4B_H      0x139997
#define REG_BK1399_4C_L      0x139998
#define REG_BK1399_4C_H      0x139999
#define REG_BK1399_4D_L      0x13999A
#define REG_BK1399_4D_H      0x13999B
#define REG_BK1399_4E_L      0x13999C
#define REG_BK1399_4E_H      0x13999D
#define REG_BK1399_4F_L      0x13999E
#define REG_BK1399_4F_H      0x13999F
#define REG_BK1399_50_L      0x1399A0
#define REG_BK1399_50_H      0x1399A1
#define REG_BK1399_51_L      0x1399A2
#define REG_BK1399_51_H      0x1399A3
#define REG_BK1399_52_L      0x1399A4
#define REG_BK1399_52_H      0x1399A5
#define REG_BK1399_53_L      0x1399A6
#define REG_BK1399_53_H      0x1399A7
#define REG_BK1399_54_L      0x1399A8
#define REG_BK1399_54_H      0x1399A9
#define REG_BK1399_55_L      0x1399AA
#define REG_BK1399_55_H      0x1399AB
#define REG_BK1399_56_L      0x1399AC
#define REG_BK1399_56_H      0x1399AD
#define REG_BK1399_57_L      0x1399AE
#define REG_BK1399_57_H      0x1399AF
#define REG_BK1399_58_L      0x1399B0
#define REG_BK1399_58_H      0x1399B1
#define REG_BK1399_59_L      0x1399B2
#define REG_BK1399_59_H      0x1399B3
#define REG_BK1399_5A_L      0x1399B4
#define REG_BK1399_5A_H      0x1399B5
#define REG_BK1399_5B_L      0x1399B6
#define REG_BK1399_5B_H      0x1399B7
#define REG_BK1399_5C_L      0x1399B8
#define REG_BK1399_5C_H      0x1399B9
#define REG_BK1399_5D_L      0x1399BA
#define REG_BK1399_5D_H      0x1399BB
#define REG_BK1399_5E_L      0x1399BC
#define REG_BK1399_5E_H      0x1399BD
#define REG_BK1399_5F_L      0x1399BE
#define REG_BK1399_5F_H      0x1399BF
#define REG_BK1399_60_L      0x1399C0
#define REG_BK1399_60_H      0x1399C1
#define REG_BK1399_61_L      0x1399C2
#define REG_BK1399_61_H      0x1399C3
#define REG_BK1399_62_L      0x1399C4
#define REG_BK1399_62_H      0x1399C5
#define REG_BK1399_63_L      0x1399C6
#define REG_BK1399_63_H      0x1399C7
#define REG_BK1399_64_L      0x1399C8
#define REG_BK1399_64_H      0x1399C9
#define REG_BK1399_65_L      0x1399CA
#define REG_BK1399_65_H      0x1399CB
#define REG_BK1399_66_L      0x1399CC
#define REG_BK1399_66_H      0x1399CD
#define REG_BK1399_67_L      0x1399CE
#define REG_BK1399_67_H      0x1399CF
#define REG_BK1399_68_L      0x1399D0
#define REG_BK1399_68_H      0x1399D1
#define REG_BK1399_69_L      0x1399D2
#define REG_BK1399_69_H      0x1399D3
#define REG_BK1399_6A_L      0x1399D4
#define REG_BK1399_6A_H      0x1399D5
#define REG_BK1399_6B_L      0x1399D6
#define REG_BK1399_6B_H      0x1399D7
#define REG_BK1399_6C_L      0x1399D8
#define REG_BK1399_6C_H      0x1399D9
#define REG_BK1399_6D_L      0x1399DA
#define REG_BK1399_6D_H      0x1399DB
#define REG_BK1399_6E_L      0x1399DC
#define REG_BK1399_6E_H      0x1399DD
#define REG_BK1399_6F_L      0x1399DE
#define REG_BK1399_6F_H      0x1399DF
#define REG_BK1399_70_L      0x1399E0
#define REG_BK1399_70_H      0x1399E1
#define REG_BK1399_71_L      0x1399E2
#define REG_BK1399_71_H      0x1399E3
#define REG_BK1399_72_L      0x1399E4
#define REG_BK1399_72_H      0x1399E5
#define REG_BK1399_73_L      0x1399E6
#define REG_BK1399_73_H      0x1399E7
#define REG_BK1399_74_L      0x1399E8
#define REG_BK1399_74_H      0x1399E9
#define REG_BK1399_75_L      0x1399EA
#define REG_BK1399_75_H      0x1399EB
#define REG_BK1399_76_L      0x1399EC
#define REG_BK1399_76_H      0x1399ED
#define REG_BK1399_77_L      0x1399EE
#define REG_BK1399_77_H      0x1399EF
#define REG_BK1399_78_L      0x1399F0
#define REG_BK1399_78_H      0x1399F1
#define REG_BK1399_79_L      0x1399F2
#define REG_BK1399_79_H      0x1399F3
#define REG_BK1399_7A_L      0x1399F4
#define REG_BK1399_7A_H      0x1399F5
#define REG_BK1399_7B_L      0x1399F6
#define REG_BK1399_7B_H      0x1399F7
#define REG_BK1399_7C_L      0x1399F8
#define REG_BK1399_7C_H      0x1399F9
#define REG_BK1399_7D_L      0x1399FA
#define REG_BK1399_7D_H      0x1399FB
#define REG_BK1399_7E_L      0x1399FC
#define REG_BK1399_7E_H      0x1399FD
#define REG_BK1399_7F_L      0x1399FE
#define REG_BK1399_7F_H      0x1399FF
//----------------------------------------------
#define REG_BK139A_00_L      0x139A00
#define REG_BK139A_00_H      0x139A01
#define REG_BK139A_01_L      0x139A02
#define REG_BK139A_01_H      0x139A03
#define REG_BK139A_02_L      0x139A04
#define REG_BK139A_02_H      0x139A05
#define REG_BK139A_03_L      0x139A06
#define REG_BK139A_03_H      0x139A07
#define REG_BK139A_04_L      0x139A08
#define REG_BK139A_04_H      0x139A09
#define REG_BK139A_05_L      0x139A0A
#define REG_BK139A_05_H      0x139A0B
#define REG_BK139A_06_L      0x139A0C
#define REG_BK139A_06_H      0x139A0D
#define REG_BK139A_07_L      0x139A0E
#define REG_BK139A_07_H      0x139A0F
#define REG_BK139A_08_L      0x139A10
#define REG_BK139A_08_H      0x139A11
#define REG_BK139A_09_L      0x139A12
#define REG_BK139A_09_H      0x139A13
#define REG_BK139A_0A_L      0x139A14
#define REG_BK139A_0A_H      0x139A15
#define REG_BK139A_0B_L      0x139A16
#define REG_BK139A_0B_H      0x139A17
#define REG_BK139A_0C_L      0x139A18
#define REG_BK139A_0C_H      0x139A19
#define REG_BK139A_0D_L      0x139A1A
#define REG_BK139A_0D_H      0x139A1B
#define REG_BK139A_0E_L      0x139A1C
#define REG_BK139A_0E_H      0x139A1D
#define REG_BK139A_0F_L      0x139A1E
#define REG_BK139A_0F_H      0x139A1F
#define REG_BK139A_10_L      0x139A20
#define REG_BK139A_10_H      0x139A21
#define REG_BK139A_11_L      0x139A22
#define REG_BK139A_11_H      0x139A23
#define REG_BK139A_12_L      0x139A24
#define REG_BK139A_12_H      0x139A25
#define REG_BK139A_13_L      0x139A26
#define REG_BK139A_13_H      0x139A27
#define REG_BK139A_14_L      0x139A28
#define REG_BK139A_14_H      0x139A29
#define REG_BK139A_15_L      0x139A2A
#define REG_BK139A_15_H      0x139A2B
#define REG_BK139A_16_L      0x139A2C
#define REG_BK139A_16_H      0x139A2D
#define REG_BK139A_17_L      0x139A2E
#define REG_BK139A_17_H      0x139A2F
#define REG_BK139A_18_L      0x139A30
#define REG_BK139A_18_H      0x139A31
#define REG_BK139A_19_L      0x139A32
#define REG_BK139A_19_H      0x139A33
#define REG_BK139A_1A_L      0x139A34
#define REG_BK139A_1A_H      0x139A35
#define REG_BK139A_1B_L      0x139A36
#define REG_BK139A_1B_H      0x139A37
#define REG_BK139A_1C_L      0x139A38
#define REG_BK139A_1C_H      0x139A39
#define REG_BK139A_1D_L      0x139A3A
#define REG_BK139A_1D_H      0x139A3B
#define REG_BK139A_1E_L      0x139A3C
#define REG_BK139A_1E_H      0x139A3D
#define REG_BK139A_1F_L      0x139A3E
#define REG_BK139A_1F_H      0x139A3F
#define REG_BK139A_20_L      0x139A40
#define REG_BK139A_20_H      0x139A41
#define REG_BK139A_21_L      0x139A42
#define REG_BK139A_21_H      0x139A43
#define REG_BK139A_22_L      0x139A44
#define REG_BK139A_22_H      0x139A45
#define REG_BK139A_23_L      0x139A46
#define REG_BK139A_23_H      0x139A47
#define REG_BK139A_24_L      0x139A48
#define REG_BK139A_24_H      0x139A49
#define REG_BK139A_25_L      0x139A4A
#define REG_BK139A_25_H      0x139A4B
#define REG_BK139A_26_L      0x139A4C
#define REG_BK139A_26_H      0x139A4D
#define REG_BK139A_27_L      0x139A4E
#define REG_BK139A_27_H      0x139A4F
#define REG_BK139A_28_L      0x139A50
#define REG_BK139A_28_H      0x139A51
#define REG_BK139A_29_L      0x139A52
#define REG_BK139A_29_H      0x139A53
#define REG_BK139A_2A_L      0x139A54
#define REG_BK139A_2A_H      0x139A55
#define REG_BK139A_2B_L      0x139A56
#define REG_BK139A_2B_H      0x139A57
#define REG_BK139A_2C_L      0x139A58
#define REG_BK139A_2C_H      0x139A59
#define REG_BK139A_2D_L      0x139A5A
#define REG_BK139A_2D_H      0x139A5B
#define REG_BK139A_2E_L      0x139A5C
#define REG_BK139A_2E_H      0x139A5D
#define REG_BK139A_2F_L      0x139A5E
#define REG_BK139A_2F_H      0x139A5F
#define REG_BK139A_30_L      0x139A60
#define REG_BK139A_30_H      0x139A61
#define REG_BK139A_31_L      0x139A62
#define REG_BK139A_31_H      0x139A63
#define REG_BK139A_32_L      0x139A64
#define REG_BK139A_32_H      0x139A65
#define REG_BK139A_33_L      0x139A66
#define REG_BK139A_33_H      0x139A67
#define REG_BK139A_34_L      0x139A68
#define REG_BK139A_34_H      0x139A69
#define REG_BK139A_35_L      0x139A6A
#define REG_BK139A_35_H      0x139A6B
#define REG_BK139A_36_L      0x139A6C
#define REG_BK139A_36_H      0x139A6D
#define REG_BK139A_37_L      0x139A6E
#define REG_BK139A_37_H      0x139A6F
#define REG_BK139A_38_L      0x139A70
#define REG_BK139A_38_H      0x139A71
#define REG_BK139A_39_L      0x139A72
#define REG_BK139A_39_H      0x139A73
#define REG_BK139A_3A_L      0x139A74
#define REG_BK139A_3A_H      0x139A75
#define REG_BK139A_3B_L      0x139A76
#define REG_BK139A_3B_H      0x139A77
#define REG_BK139A_3C_L      0x139A78
#define REG_BK139A_3C_H      0x139A79
#define REG_BK139A_3D_L      0x139A7A
#define REG_BK139A_3D_H      0x139A7B
#define REG_BK139A_3E_L      0x139A7C
#define REG_BK139A_3E_H      0x139A7D
#define REG_BK139A_3F_L      0x139A7E
#define REG_BK139A_3F_H      0x139A7F
#define REG_BK139A_40_L      0x139A80
#define REG_BK139A_40_H      0x139A81
#define REG_BK139A_41_L      0x139A82
#define REG_BK139A_41_H      0x139A83
#define REG_BK139A_42_L      0x139A84
#define REG_BK139A_42_H      0x139A85
#define REG_BK139A_43_L      0x139A86
#define REG_BK139A_43_H      0x139A87
#define REG_BK139A_44_L      0x139A88
#define REG_BK139A_44_H      0x139A89
#define REG_BK139A_45_L      0x139A8A
#define REG_BK139A_45_H      0x139A8B
#define REG_BK139A_46_L      0x139A8C
#define REG_BK139A_46_H      0x139A8D
#define REG_BK139A_47_L      0x139A8E
#define REG_BK139A_47_H      0x139A8F
#define REG_BK139A_48_L      0x139A90
#define REG_BK139A_48_H      0x139A91
#define REG_BK139A_49_L      0x139A92
#define REG_BK139A_49_H      0x139A93
#define REG_BK139A_4A_L      0x139A94
#define REG_BK139A_4A_H      0x139A95
#define REG_BK139A_4B_L      0x139A96
#define REG_BK139A_4B_H      0x139A97
#define REG_BK139A_4C_L      0x139A98
#define REG_BK139A_4C_H      0x139A99
#define REG_BK139A_4D_L      0x139A9A
#define REG_BK139A_4D_H      0x139A9B
#define REG_BK139A_4E_L      0x139A9C
#define REG_BK139A_4E_H      0x139A9D
#define REG_BK139A_4F_L      0x139A9E
#define REG_BK139A_4F_H      0x139A9F
#define REG_BK139A_50_L      0x139AA0
#define REG_BK139A_50_H      0x139AA1
#define REG_BK139A_51_L      0x139AA2
#define REG_BK139A_51_H      0x139AA3
#define REG_BK139A_52_L      0x139AA4
#define REG_BK139A_52_H      0x139AA5
#define REG_BK139A_53_L      0x139AA6
#define REG_BK139A_53_H      0x139AA7
#define REG_BK139A_54_L      0x139AA8
#define REG_BK139A_54_H      0x139AA9
#define REG_BK139A_55_L      0x139AAA
#define REG_BK139A_55_H      0x139AAB
#define REG_BK139A_56_L      0x139AAC
#define REG_BK139A_56_H      0x139AAD
#define REG_BK139A_57_L      0x139AAE
#define REG_BK139A_57_H      0x139AAF
#define REG_BK139A_58_L      0x139AB0
#define REG_BK139A_58_H      0x139AB1
#define REG_BK139A_59_L      0x139AB2
#define REG_BK139A_59_H      0x139AB3
#define REG_BK139A_5A_L      0x139AB4
#define REG_BK139A_5A_H      0x139AB5
#define REG_BK139A_5B_L      0x139AB6
#define REG_BK139A_5B_H      0x139AB7
#define REG_BK139A_5C_L      0x139AB8
#define REG_BK139A_5C_H      0x139AB9
#define REG_BK139A_5D_L      0x139ABA
#define REG_BK139A_5D_H      0x139ABB
#define REG_BK139A_5E_L      0x139ABC
#define REG_BK139A_5E_H      0x139ABD
#define REG_BK139A_5F_L      0x139ABE
#define REG_BK139A_5F_H      0x139ABF
#define REG_BK139A_60_L      0x139AC0
#define REG_BK139A_60_H      0x139AC1
#define REG_BK139A_61_L      0x139AC2
#define REG_BK139A_61_H      0x139AC3
#define REG_BK139A_62_L      0x139AC4
#define REG_BK139A_62_H      0x139AC5
#define REG_BK139A_63_L      0x139AC6
#define REG_BK139A_63_H      0x139AC7
#define REG_BK139A_64_L      0x139AC8
#define REG_BK139A_64_H      0x139AC9
#define REG_BK139A_65_L      0x139ACA
#define REG_BK139A_65_H      0x139ACB
#define REG_BK139A_66_L      0x139ACC
#define REG_BK139A_66_H      0x139ACD
#define REG_BK139A_67_L      0x139ACE
#define REG_BK139A_67_H      0x139ACF
#define REG_BK139A_68_L      0x139AD0
#define REG_BK139A_68_H      0x139AD1
#define REG_BK139A_69_L      0x139AD2
#define REG_BK139A_69_H      0x139AD3
#define REG_BK139A_6A_L      0x139AD4
#define REG_BK139A_6A_H      0x139AD5
#define REG_BK139A_6B_L      0x139AD6
#define REG_BK139A_6B_H      0x139AD7
#define REG_BK139A_6C_L      0x139AD8
#define REG_BK139A_6C_H      0x139AD9
#define REG_BK139A_6D_L      0x139ADA
#define REG_BK139A_6D_H      0x139ADB
#define REG_BK139A_6E_L      0x139ADC
#define REG_BK139A_6E_H      0x139ADD
#define REG_BK139A_6F_L      0x139ADE
#define REG_BK139A_6F_H      0x139ADF
#define REG_BK139A_70_L      0x139AE0
#define REG_BK139A_70_H      0x139AE1
#define REG_BK139A_71_L      0x139AE2
#define REG_BK139A_71_H      0x139AE3
#define REG_BK139A_72_L      0x139AE4
#define REG_BK139A_72_H      0x139AE5
#define REG_BK139A_73_L      0x139AE6
#define REG_BK139A_73_H      0x139AE7
#define REG_BK139A_74_L      0x139AE8
#define REG_BK139A_74_H      0x139AE9
#define REG_BK139A_75_L      0x139AEA
#define REG_BK139A_75_H      0x139AEB
#define REG_BK139A_76_L      0x139AEC
#define REG_BK139A_76_H      0x139AED
#define REG_BK139A_77_L      0x139AEE
#define REG_BK139A_77_H      0x139AEF
#define REG_BK139A_78_L      0x139AF0
#define REG_BK139A_78_H      0x139AF1
#define REG_BK139A_79_L      0x139AF2
#define REG_BK139A_79_H      0x139AF3
#define REG_BK139A_7A_L      0x139AF4
#define REG_BK139A_7A_H      0x139AF5
#define REG_BK139A_7B_L      0x139AF6
#define REG_BK139A_7B_H      0x139AF7
#define REG_BK139A_7C_L      0x139AF8
#define REG_BK139A_7C_H      0x139AF9
#define REG_BK139A_7D_L      0x139AFA
#define REG_BK139A_7D_H      0x139AFB
#define REG_BK139A_7E_L      0x139AFC
#define REG_BK139A_7E_H      0x139AFD
#define REG_BK139A_7F_L      0x139AFE
#define REG_BK139A_7F_H      0x139AFF
//----------------------------------------------
#define REG_BK139B_00_L      0x139B00
#define REG_BK139B_00_H      0x139B01
#define REG_BK139B_01_L      0x139B02
#define REG_BK139B_01_H      0x139B03
#define REG_BK139B_02_L      0x139B04
#define REG_BK139B_02_H      0x139B05
#define REG_BK139B_03_L      0x139B06
#define REG_BK139B_03_H      0x139B07
#define REG_BK139B_04_L      0x139B08
#define REG_BK139B_04_H      0x139B09
#define REG_BK139B_05_L      0x139B0A
#define REG_BK139B_05_H      0x139B0B
#define REG_BK139B_06_L      0x139B0C
#define REG_BK139B_06_H      0x139B0D
#define REG_BK139B_07_L      0x139B0E
#define REG_BK139B_07_H      0x139B0F
#define REG_BK139B_08_L      0x139B10
#define REG_BK139B_08_H      0x139B11
#define REG_BK139B_09_L      0x139B12
#define REG_BK139B_09_H      0x139B13
#define REG_BK139B_0A_L      0x139B14
#define REG_BK139B_0A_H      0x139B15
#define REG_BK139B_0B_L      0x139B16
#define REG_BK139B_0B_H      0x139B17
#define REG_BK139B_0C_L      0x139B18
#define REG_BK139B_0C_H      0x139B19
#define REG_BK139B_0D_L      0x139B1A
#define REG_BK139B_0D_H      0x139B1B
#define REG_BK139B_0E_L      0x139B1C
#define REG_BK139B_0E_H      0x139B1D
#define REG_BK139B_0F_L      0x139B1E
#define REG_BK139B_0F_H      0x139B1F
#define REG_BK139B_10_L      0x139B20
#define REG_BK139B_10_H      0x139B21
#define REG_BK139B_11_L      0x139B22
#define REG_BK139B_11_H      0x139B23
#define REG_BK139B_12_L      0x139B24
#define REG_BK139B_12_H      0x139B25
#define REG_BK139B_13_L      0x139B26
#define REG_BK139B_13_H      0x139B27
#define REG_BK139B_14_L      0x139B28
#define REG_BK139B_14_H      0x139B29
#define REG_BK139B_15_L      0x139B2A
#define REG_BK139B_15_H      0x139B2B
#define REG_BK139B_16_L      0x139B2C
#define REG_BK139B_16_H      0x139B2D
#define REG_BK139B_17_L      0x139B2E
#define REG_BK139B_17_H      0x139B2F
#define REG_BK139B_18_L      0x139B30
#define REG_BK139B_18_H      0x139B31
#define REG_BK139B_19_L      0x139B32
#define REG_BK139B_19_H      0x139B33
#define REG_BK139B_1A_L      0x139B34
#define REG_BK139B_1A_H      0x139B35
#define REG_BK139B_1B_L      0x139B36
#define REG_BK139B_1B_H      0x139B37
#define REG_BK139B_1C_L      0x139B38
#define REG_BK139B_1C_H      0x139B39
#define REG_BK139B_1D_L      0x139B3A
#define REG_BK139B_1D_H      0x139B3B
#define REG_BK139B_1E_L      0x139B3C
#define REG_BK139B_1E_H      0x139B3D
#define REG_BK139B_1F_L      0x139B3E
#define REG_BK139B_1F_H      0x139B3F
#define REG_BK139B_20_L      0x139B40
#define REG_BK139B_20_H      0x139B41
#define REG_BK139B_21_L      0x139B42
#define REG_BK139B_21_H      0x139B43
#define REG_BK139B_22_L      0x139B44
#define REG_BK139B_22_H      0x139B45
#define REG_BK139B_23_L      0x139B46
#define REG_BK139B_23_H      0x139B47
#define REG_BK139B_24_L      0x139B48
#define REG_BK139B_24_H      0x139B49
#define REG_BK139B_25_L      0x139B4A
#define REG_BK139B_25_H      0x139B4B
#define REG_BK139B_26_L      0x139B4C
#define REG_BK139B_26_H      0x139B4D
#define REG_BK139B_27_L      0x139B4E
#define REG_BK139B_27_H      0x139B4F
#define REG_BK139B_28_L      0x139B50
#define REG_BK139B_28_H      0x139B51
#define REG_BK139B_29_L      0x139B52
#define REG_BK139B_29_H      0x139B53
#define REG_BK139B_2A_L      0x139B54
#define REG_BK139B_2A_H      0x139B55
#define REG_BK139B_2B_L      0x139B56
#define REG_BK139B_2B_H      0x139B57
#define REG_BK139B_2C_L      0x139B58
#define REG_BK139B_2C_H      0x139B59
#define REG_BK139B_2D_L      0x139B5A
#define REG_BK139B_2D_H      0x139B5B
#define REG_BK139B_2E_L      0x139B5C
#define REG_BK139B_2E_H      0x139B5D
#define REG_BK139B_2F_L      0x139B5E
#define REG_BK139B_2F_H      0x139B5F
#define REG_BK139B_30_L      0x139B60
#define REG_BK139B_30_H      0x139B61
#define REG_BK139B_31_L      0x139B62
#define REG_BK139B_31_H      0x139B63
#define REG_BK139B_32_L      0x139B64
#define REG_BK139B_32_H      0x139B65
#define REG_BK139B_33_L      0x139B66
#define REG_BK139B_33_H      0x139B67
#define REG_BK139B_34_L      0x139B68
#define REG_BK139B_34_H      0x139B69
#define REG_BK139B_35_L      0x139B6A
#define REG_BK139B_35_H      0x139B6B
#define REG_BK139B_36_L      0x139B6C
#define REG_BK139B_36_H      0x139B6D
#define REG_BK139B_37_L      0x139B6E
#define REG_BK139B_37_H      0x139B6F
#define REG_BK139B_38_L      0x139B70
#define REG_BK139B_38_H      0x139B71
#define REG_BK139B_39_L      0x139B72
#define REG_BK139B_39_H      0x139B73
#define REG_BK139B_3A_L      0x139B74
#define REG_BK139B_3A_H      0x139B75
#define REG_BK139B_3B_L      0x139B76
#define REG_BK139B_3B_H      0x139B77
#define REG_BK139B_3C_L      0x139B78
#define REG_BK139B_3C_H      0x139B79
#define REG_BK139B_3D_L      0x139B7A
#define REG_BK139B_3D_H      0x139B7B
#define REG_BK139B_3E_L      0x139B7C
#define REG_BK139B_3E_H      0x139B7D
#define REG_BK139B_3F_L      0x139B7E
#define REG_BK139B_3F_H      0x139B7F
#define REG_BK139B_40_L      0x139B80
#define REG_BK139B_40_H      0x139B81
#define REG_BK139B_41_L      0x139B82
#define REG_BK139B_41_H      0x139B83
#define REG_BK139B_42_L      0x139B84
#define REG_BK139B_42_H      0x139B85
#define REG_BK139B_43_L      0x139B86
#define REG_BK139B_43_H      0x139B87
#define REG_BK139B_44_L      0x139B88
#define REG_BK139B_44_H      0x139B89
#define REG_BK139B_45_L      0x139B8A
#define REG_BK139B_45_H      0x139B8B
#define REG_BK139B_46_L      0x139B8C
#define REG_BK139B_46_H      0x139B8D
#define REG_BK139B_47_L      0x139B8E
#define REG_BK139B_47_H      0x139B8F
#define REG_BK139B_48_L      0x139B90
#define REG_BK139B_48_H      0x139B91
#define REG_BK139B_49_L      0x139B92
#define REG_BK139B_49_H      0x139B93
#define REG_BK139B_4A_L      0x139B94
#define REG_BK139B_4A_H      0x139B95
#define REG_BK139B_4B_L      0x139B96
#define REG_BK139B_4B_H      0x139B97
#define REG_BK139B_4C_L      0x139B98
#define REG_BK139B_4C_H      0x139B99
#define REG_BK139B_4D_L      0x139B9A
#define REG_BK139B_4D_H      0x139B9B
#define REG_BK139B_4E_L      0x139B9C
#define REG_BK139B_4E_H      0x139B9D
#define REG_BK139B_4F_L      0x139B9E
#define REG_BK139B_4F_H      0x139B9F
#define REG_BK139B_50_L      0x139BA0
#define REG_BK139B_50_H      0x139BA1
#define REG_BK139B_51_L      0x139BA2
#define REG_BK139B_51_H      0x139BA3
#define REG_BK139B_52_L      0x139BA4
#define REG_BK139B_52_H      0x139BA5
#define REG_BK139B_53_L      0x139BA6
#define REG_BK139B_53_H      0x139BA7
#define REG_BK139B_54_L      0x139BA8
#define REG_BK139B_54_H      0x139BA9
#define REG_BK139B_55_L      0x139BAA
#define REG_BK139B_55_H      0x139BAB
#define REG_BK139B_56_L      0x139BAC
#define REG_BK139B_56_H      0x139BAD
#define REG_BK139B_57_L      0x139BAE
#define REG_BK139B_57_H      0x139BAF
#define REG_BK139B_58_L      0x139BB0
#define REG_BK139B_58_H      0x139BB1
#define REG_BK139B_59_L      0x139BB2
#define REG_BK139B_59_H      0x139BB3
#define REG_BK139B_5A_L      0x139BB4
#define REG_BK139B_5A_H      0x139BB5
#define REG_BK139B_5B_L      0x139BB6
#define REG_BK139B_5B_H      0x139BB7
#define REG_BK139B_5C_L      0x139BB8
#define REG_BK139B_5C_H      0x139BB9
#define REG_BK139B_5D_L      0x139BBA
#define REG_BK139B_5D_H      0x139BBB
#define REG_BK139B_5E_L      0x139BBC
#define REG_BK139B_5E_H      0x139BBD
#define REG_BK139B_5F_L      0x139BBE
#define REG_BK139B_5F_H      0x139BBF
#define REG_BK139B_60_L      0x139BC0
#define REG_BK139B_60_H      0x139BC1
#define REG_BK139B_61_L      0x139BC2
#define REG_BK139B_61_H      0x139BC3
#define REG_BK139B_62_L      0x139BC4
#define REG_BK139B_62_H      0x139BC5
#define REG_BK139B_63_L      0x139BC6
#define REG_BK139B_63_H      0x139BC7
#define REG_BK139B_64_L      0x139BC8
#define REG_BK139B_64_H      0x139BC9
#define REG_BK139B_65_L      0x139BCA
#define REG_BK139B_65_H      0x139BCB
#define REG_BK139B_66_L      0x139BCC
#define REG_BK139B_66_H      0x139BCD
#define REG_BK139B_67_L      0x139BCE
#define REG_BK139B_67_H      0x139BCF
#define REG_BK139B_68_L      0x139BD0
#define REG_BK139B_68_H      0x139BD1
#define REG_BK139B_69_L      0x139BD2
#define REG_BK139B_69_H      0x139BD3
#define REG_BK139B_6A_L      0x139BD4
#define REG_BK139B_6A_H      0x139BD5
#define REG_BK139B_6B_L      0x139BD6
#define REG_BK139B_6B_H      0x139BD7
#define REG_BK139B_6C_L      0x139BD8
#define REG_BK139B_6C_H      0x139BD9
#define REG_BK139B_6D_L      0x139BDA
#define REG_BK139B_6D_H      0x139BDB
#define REG_BK139B_6E_L      0x139BDC
#define REG_BK139B_6E_H      0x139BDD
#define REG_BK139B_6F_L      0x139BDE
#define REG_BK139B_6F_H      0x139BDF
#define REG_BK139B_70_L      0x139BE0
#define REG_BK139B_70_H      0x139BE1
#define REG_BK139B_71_L      0x139BE2
#define REG_BK139B_71_H      0x139BE3
#define REG_BK139B_72_L      0x139BE4
#define REG_BK139B_72_H      0x139BE5
#define REG_BK139B_73_L      0x139BE6
#define REG_BK139B_73_H      0x139BE7
#define REG_BK139B_74_L      0x139BE8
#define REG_BK139B_74_H      0x139BE9
#define REG_BK139B_75_L      0x139BEA
#define REG_BK139B_75_H      0x139BEB
#define REG_BK139B_76_L      0x139BEC
#define REG_BK139B_76_H      0x139BED
#define REG_BK139B_77_L      0x139BEE
#define REG_BK139B_77_H      0x139BEF
#define REG_BK139B_78_L      0x139BF0
#define REG_BK139B_78_H      0x139BF1
#define REG_BK139B_79_L      0x139BF2
#define REG_BK139B_79_H      0x139BF3
#define REG_BK139B_7A_L      0x139BF4
#define REG_BK139B_7A_H      0x139BF5
#define REG_BK139B_7B_L      0x139BF6
#define REG_BK139B_7B_H      0x139BF7
#define REG_BK139B_7C_L      0x139BF8
#define REG_BK139B_7C_H      0x139BF9
#define REG_BK139B_7D_L      0x139BFA
#define REG_BK139B_7D_H      0x139BFB
#define REG_BK139B_7E_L      0x139BFC
#define REG_BK139B_7E_H      0x139BFD
#define REG_BK139B_7F_L      0x139BFE
#define REG_BK139B_7F_H      0x139BFF
//----------------------------------------------
#define REG_BK139C_00_L      0x139C00
#define REG_BK139C_00_H      0x139C01
#define REG_BK139C_01_L      0x139C02
#define REG_BK139C_01_H      0x139C03
#define REG_BK139C_02_L      0x139C04
#define REG_BK139C_02_H      0x139C05
#define REG_BK139C_03_L      0x139C06
#define REG_BK139C_03_H      0x139C07
#define REG_BK139C_04_L      0x139C08
#define REG_BK139C_04_H      0x139C09
#define REG_BK139C_05_L      0x139C0A
#define REG_BK139C_05_H      0x139C0B
#define REG_BK139C_06_L      0x139C0C
#define REG_BK139C_06_H      0x139C0D
#define REG_BK139C_07_L      0x139C0E
#define REG_BK139C_07_H      0x139C0F
#define REG_BK139C_08_L      0x139C10
#define REG_BK139C_08_H      0x139C11
#define REG_BK139C_09_L      0x139C12
#define REG_BK139C_09_H      0x139C13
#define REG_BK139C_0A_L      0x139C14
#define REG_BK139C_0A_H      0x139C15
#define REG_BK139C_0B_L      0x139C16
#define REG_BK139C_0B_H      0x139C17
#define REG_BK139C_0C_L      0x139C18
#define REG_BK139C_0C_H      0x139C19
#define REG_BK139C_0D_L      0x139C1A
#define REG_BK139C_0D_H      0x139C1B
#define REG_BK139C_0E_L      0x139C1C
#define REG_BK139C_0E_H      0x139C1D
#define REG_BK139C_0F_L      0x139C1E
#define REG_BK139C_0F_H      0x139C1F
#define REG_BK139C_10_L      0x139C20
#define REG_BK139C_10_H      0x139C21
#define REG_BK139C_11_L      0x139C22
#define REG_BK139C_11_H      0x139C23
#define REG_BK139C_12_L      0x139C24
#define REG_BK139C_12_H      0x139C25
#define REG_BK139C_13_L      0x139C26
#define REG_BK139C_13_H      0x139C27
#define REG_BK139C_14_L      0x139C28
#define REG_BK139C_14_H      0x139C29
#define REG_BK139C_15_L      0x139C2A
#define REG_BK139C_15_H      0x139C2B
#define REG_BK139C_16_L      0x139C2C
#define REG_BK139C_16_H      0x139C2D
#define REG_BK139C_17_L      0x139C2E
#define REG_BK139C_17_H      0x139C2F
#define REG_BK139C_18_L      0x139C30
#define REG_BK139C_18_H      0x139C31
#define REG_BK139C_19_L      0x139C32
#define REG_BK139C_19_H      0x139C33
#define REG_BK139C_1A_L      0x139C34
#define REG_BK139C_1A_H      0x139C35
#define REG_BK139C_1B_L      0x139C36
#define REG_BK139C_1B_H      0x139C37
#define REG_BK139C_1C_L      0x139C38
#define REG_BK139C_1C_H      0x139C39
#define REG_BK139C_1D_L      0x139C3A
#define REG_BK139C_1D_H      0x139C3B
#define REG_BK139C_1E_L      0x139C3C
#define REG_BK139C_1E_H      0x139C3D
#define REG_BK139C_1F_L      0x139C3E
#define REG_BK139C_1F_H      0x139C3F
#define REG_BK139C_20_L      0x139C40
#define REG_BK139C_20_H      0x139C41
#define REG_BK139C_21_L      0x139C42
#define REG_BK139C_21_H      0x139C43
#define REG_BK139C_22_L      0x139C44
#define REG_BK139C_22_H      0x139C45
#define REG_BK139C_23_L      0x139C46
#define REG_BK139C_23_H      0x139C47
#define REG_BK139C_24_L      0x139C48
#define REG_BK139C_24_H      0x139C49
#define REG_BK139C_25_L      0x139C4A
#define REG_BK139C_25_H      0x139C4B
#define REG_BK139C_26_L      0x139C4C
#define REG_BK139C_26_H      0x139C4D
#define REG_BK139C_27_L      0x139C4E
#define REG_BK139C_27_H      0x139C4F
#define REG_BK139C_28_L      0x139C50
#define REG_BK139C_28_H      0x139C51
#define REG_BK139C_29_L      0x139C52
#define REG_BK139C_29_H      0x139C53
#define REG_BK139C_2A_L      0x139C54
#define REG_BK139C_2A_H      0x139C55
#define REG_BK139C_2B_L      0x139C56
#define REG_BK139C_2B_H      0x139C57
#define REG_BK139C_2C_L      0x139C58
#define REG_BK139C_2C_H      0x139C59
#define REG_BK139C_2D_L      0x139C5A
#define REG_BK139C_2D_H      0x139C5B
#define REG_BK139C_2E_L      0x139C5C
#define REG_BK139C_2E_H      0x139C5D
#define REG_BK139C_2F_L      0x139C5E
#define REG_BK139C_2F_H      0x139C5F
#define REG_BK139C_30_L      0x139C60
#define REG_BK139C_30_H      0x139C61
#define REG_BK139C_31_L      0x139C62
#define REG_BK139C_31_H      0x139C63
#define REG_BK139C_32_L      0x139C64
#define REG_BK139C_32_H      0x139C65
#define REG_BK139C_33_L      0x139C66
#define REG_BK139C_33_H      0x139C67
#define REG_BK139C_34_L      0x139C68
#define REG_BK139C_34_H      0x139C69
#define REG_BK139C_35_L      0x139C6A
#define REG_BK139C_35_H      0x139C6B
#define REG_BK139C_36_L      0x139C6C
#define REG_BK139C_36_H      0x139C6D
#define REG_BK139C_37_L      0x139C6E
#define REG_BK139C_37_H      0x139C6F
#define REG_BK139C_38_L      0x139C70
#define REG_BK139C_38_H      0x139C71
#define REG_BK139C_39_L      0x139C72
#define REG_BK139C_39_H      0x139C73
#define REG_BK139C_3A_L      0x139C74
#define REG_BK139C_3A_H      0x139C75
#define REG_BK139C_3B_L      0x139C76
#define REG_BK139C_3B_H      0x139C77
#define REG_BK139C_3C_L      0x139C78
#define REG_BK139C_3C_H      0x139C79
#define REG_BK139C_3D_L      0x139C7A
#define REG_BK139C_3D_H      0x139C7B
#define REG_BK139C_3E_L      0x139C7C
#define REG_BK139C_3E_H      0x139C7D
#define REG_BK139C_3F_L      0x139C7E
#define REG_BK139C_3F_H      0x139C7F
#define REG_BK139C_40_L      0x139C80
#define REG_BK139C_40_H      0x139C81
#define REG_BK139C_41_L      0x139C82
#define REG_BK139C_41_H      0x139C83
#define REG_BK139C_42_L      0x139C84
#define REG_BK139C_42_H      0x139C85
#define REG_BK139C_43_L      0x139C86
#define REG_BK139C_43_H      0x139C87
#define REG_BK139C_44_L      0x139C88
#define REG_BK139C_44_H      0x139C89
#define REG_BK139C_45_L      0x139C8A
#define REG_BK139C_45_H      0x139C8B
#define REG_BK139C_46_L      0x139C8C
#define REG_BK139C_46_H      0x139C8D
#define REG_BK139C_47_L      0x139C8E
#define REG_BK139C_47_H      0x139C8F
#define REG_BK139C_48_L      0x139C90
#define REG_BK139C_48_H      0x139C91
#define REG_BK139C_49_L      0x139C92
#define REG_BK139C_49_H      0x139C93
#define REG_BK139C_4A_L      0x139C94
#define REG_BK139C_4A_H      0x139C95
#define REG_BK139C_4B_L      0x139C96
#define REG_BK139C_4B_H      0x139C97
#define REG_BK139C_4C_L      0x139C98
#define REG_BK139C_4C_H      0x139C99
#define REG_BK139C_4D_L      0x139C9A
#define REG_BK139C_4D_H      0x139C9B
#define REG_BK139C_4E_L      0x139C9C
#define REG_BK139C_4E_H      0x139C9D
#define REG_BK139C_4F_L      0x139C9E
#define REG_BK139C_4F_H      0x139C9F
#define REG_BK139C_50_L      0x139CA0
#define REG_BK139C_50_H      0x139CA1
#define REG_BK139C_51_L      0x139CA2
#define REG_BK139C_51_H      0x139CA3
#define REG_BK139C_52_L      0x139CA4
#define REG_BK139C_52_H      0x139CA5
#define REG_BK139C_53_L      0x139CA6
#define REG_BK139C_53_H      0x139CA7
#define REG_BK139C_54_L      0x139CA8
#define REG_BK139C_54_H      0x139CA9
#define REG_BK139C_55_L      0x139CAA
#define REG_BK139C_55_H      0x139CAB
#define REG_BK139C_56_L      0x139CAC
#define REG_BK139C_56_H      0x139CAD
#define REG_BK139C_57_L      0x139CAE
#define REG_BK139C_57_H      0x139CAF
#define REG_BK139C_58_L      0x139CB0
#define REG_BK139C_58_H      0x139CB1
#define REG_BK139C_59_L      0x139CB2
#define REG_BK139C_59_H      0x139CB3
#define REG_BK139C_5A_L      0x139CB4
#define REG_BK139C_5A_H      0x139CB5
#define REG_BK139C_5B_L      0x139CB6
#define REG_BK139C_5B_H      0x139CB7
#define REG_BK139C_5C_L      0x139CB8
#define REG_BK139C_5C_H      0x139CB9
#define REG_BK139C_5D_L      0x139CBA
#define REG_BK139C_5D_H      0x139CBB
#define REG_BK139C_5E_L      0x139CBC
#define REG_BK139C_5E_H      0x139CBD
#define REG_BK139C_5F_L      0x139CBE
#define REG_BK139C_5F_H      0x139CBF
#define REG_BK139C_60_L      0x139CC0
#define REG_BK139C_60_H      0x139CC1
#define REG_BK139C_61_L      0x139CC2
#define REG_BK139C_61_H      0x139CC3
#define REG_BK139C_62_L      0x139CC4
#define REG_BK139C_62_H      0x139CC5
#define REG_BK139C_63_L      0x139CC6
#define REG_BK139C_63_H      0x139CC7
#define REG_BK139C_64_L      0x139CC8
#define REG_BK139C_64_H      0x139CC9
#define REG_BK139C_65_L      0x139CCA
#define REG_BK139C_65_H      0x139CCB
#define REG_BK139C_66_L      0x139CCC
#define REG_BK139C_66_H      0x139CCD
#define REG_BK139C_67_L      0x139CCE
#define REG_BK139C_67_H      0x139CCF
#define REG_BK139C_68_L      0x139CD0
#define REG_BK139C_68_H      0x139CD1
#define REG_BK139C_69_L      0x139CD2
#define REG_BK139C_69_H      0x139CD3
#define REG_BK139C_6A_L      0x139CD4
#define REG_BK139C_6A_H      0x139CD5
#define REG_BK139C_6B_L      0x139CD6
#define REG_BK139C_6B_H      0x139CD7
#define REG_BK139C_6C_L      0x139CD8
#define REG_BK139C_6C_H      0x139CD9
#define REG_BK139C_6D_L      0x139CDA
#define REG_BK139C_6D_H      0x139CDB
#define REG_BK139C_6E_L      0x139CDC
#define REG_BK139C_6E_H      0x139CDD
#define REG_BK139C_6F_L      0x139CDE
#define REG_BK139C_6F_H      0x139CDF
#define REG_BK139C_70_L      0x139CE0
#define REG_BK139C_70_H      0x139CE1
#define REG_BK139C_71_L      0x139CE2
#define REG_BK139C_71_H      0x139CE3
#define REG_BK139C_72_L      0x139CE4
#define REG_BK139C_72_H      0x139CE5
#define REG_BK139C_73_L      0x139CE6
#define REG_BK139C_73_H      0x139CE7
#define REG_BK139C_74_L      0x139CE8
#define REG_BK139C_74_H      0x139CE9
#define REG_BK139C_75_L      0x139CEA
#define REG_BK139C_75_H      0x139CEB
#define REG_BK139C_76_L      0x139CEC
#define REG_BK139C_76_H      0x139CED
#define REG_BK139C_77_L      0x139CEE
#define REG_BK139C_77_H      0x139CEF
#define REG_BK139C_78_L      0x139CF0
#define REG_BK139C_78_H      0x139CF1
#define REG_BK139C_79_L      0x139CF2
#define REG_BK139C_79_H      0x139CF3
#define REG_BK139C_7A_L      0x139CF4
#define REG_BK139C_7A_H      0x139CF5
#define REG_BK139C_7B_L      0x139CF6
#define REG_BK139C_7B_H      0x139CF7
#define REG_BK139C_7C_L      0x139CF8
#define REG_BK139C_7C_H      0x139CF9
#define REG_BK139C_7D_L      0x139CFA
#define REG_BK139C_7D_H      0x139CFB
#define REG_BK139C_7E_L      0x139CFC
#define REG_BK139C_7E_H      0x139CFD
#define REG_BK139C_7F_L      0x139CFE
#define REG_BK139C_7F_H      0x139CFF
//----------------------------------------------
#define REG_BK139D_00_L      0x139D00
#define REG_BK139D_00_H      0x139D01
#define REG_BK139D_01_L      0x139D02
#define REG_BK139D_01_H      0x139D03
#define REG_BK139D_02_L      0x139D04
#define REG_BK139D_02_H      0x139D05
#define REG_BK139D_03_L      0x139D06
#define REG_BK139D_03_H      0x139D07
#define REG_BK139D_04_L      0x139D08
#define REG_BK139D_04_H      0x139D09
#define REG_BK139D_05_L      0x139D0A
#define REG_BK139D_05_H      0x139D0B
#define REG_BK139D_06_L      0x139D0C
#define REG_BK139D_06_H      0x139D0D
#define REG_BK139D_07_L      0x139D0E
#define REG_BK139D_07_H      0x139D0F
#define REG_BK139D_08_L      0x139D10
#define REG_BK139D_08_H      0x139D11
#define REG_BK139D_09_L      0x139D12
#define REG_BK139D_09_H      0x139D13
#define REG_BK139D_0A_L      0x139D14
#define REG_BK139D_0A_H      0x139D15
#define REG_BK139D_0B_L      0x139D16
#define REG_BK139D_0B_H      0x139D17
#define REG_BK139D_0C_L      0x139D18
#define REG_BK139D_0C_H      0x139D19
#define REG_BK139D_0D_L      0x139D1A
#define REG_BK139D_0D_H      0x139D1B
#define REG_BK139D_0E_L      0x139D1C
#define REG_BK139D_0E_H      0x139D1D
#define REG_BK139D_0F_L      0x139D1E
#define REG_BK139D_0F_H      0x139D1F
#define REG_BK139D_10_L      0x139D20
#define REG_BK139D_10_H      0x139D21
#define REG_BK139D_11_L      0x139D22
#define REG_BK139D_11_H      0x139D23
#define REG_BK139D_12_L      0x139D24
#define REG_BK139D_12_H      0x139D25
#define REG_BK139D_13_L      0x139D26
#define REG_BK139D_13_H      0x139D27
#define REG_BK139D_14_L      0x139D28
#define REG_BK139D_14_H      0x139D29
#define REG_BK139D_15_L      0x139D2A
#define REG_BK139D_15_H      0x139D2B
#define REG_BK139D_16_L      0x139D2C
#define REG_BK139D_16_H      0x139D2D
#define REG_BK139D_17_L      0x139D2E
#define REG_BK139D_17_H      0x139D2F
#define REG_BK139D_18_L      0x139D30
#define REG_BK139D_18_H      0x139D31
#define REG_BK139D_19_L      0x139D32
#define REG_BK139D_19_H      0x139D33
#define REG_BK139D_1A_L      0x139D34
#define REG_BK139D_1A_H      0x139D35
#define REG_BK139D_1B_L      0x139D36
#define REG_BK139D_1B_H      0x139D37
#define REG_BK139D_1C_L      0x139D38
#define REG_BK139D_1C_H      0x139D39
#define REG_BK139D_1D_L      0x139D3A
#define REG_BK139D_1D_H      0x139D3B
#define REG_BK139D_1E_L      0x139D3C
#define REG_BK139D_1E_H      0x139D3D
#define REG_BK139D_1F_L      0x139D3E
#define REG_BK139D_1F_H      0x139D3F
#define REG_BK139D_20_L      0x139D40
#define REG_BK139D_20_H      0x139D41
#define REG_BK139D_21_L      0x139D42
#define REG_BK139D_21_H      0x139D43
#define REG_BK139D_22_L      0x139D44
#define REG_BK139D_22_H      0x139D45
#define REG_BK139D_23_L      0x139D46
#define REG_BK139D_23_H      0x139D47
#define REG_BK139D_24_L      0x139D48
#define REG_BK139D_24_H      0x139D49
#define REG_BK139D_25_L      0x139D4A
#define REG_BK139D_25_H      0x139D4B
#define REG_BK139D_26_L      0x139D4C
#define REG_BK139D_26_H      0x139D4D
#define REG_BK139D_27_L      0x139D4E
#define REG_BK139D_27_H      0x139D4F
#define REG_BK139D_28_L      0x139D50
#define REG_BK139D_28_H      0x139D51
#define REG_BK139D_29_L      0x139D52
#define REG_BK139D_29_H      0x139D53
#define REG_BK139D_2A_L      0x139D54
#define REG_BK139D_2A_H      0x139D55
#define REG_BK139D_2B_L      0x139D56
#define REG_BK139D_2B_H      0x139D57
#define REG_BK139D_2C_L      0x139D58
#define REG_BK139D_2C_H      0x139D59
#define REG_BK139D_2D_L      0x139D5A
#define REG_BK139D_2D_H      0x139D5B
#define REG_BK139D_2E_L      0x139D5C
#define REG_BK139D_2E_H      0x139D5D
#define REG_BK139D_2F_L      0x139D5E
#define REG_BK139D_2F_H      0x139D5F
#define REG_BK139D_30_L      0x139D60
#define REG_BK139D_30_H      0x139D61
#define REG_BK139D_31_L      0x139D62
#define REG_BK139D_31_H      0x139D63
#define REG_BK139D_32_L      0x139D64
#define REG_BK139D_32_H      0x139D65
#define REG_BK139D_33_L      0x139D66
#define REG_BK139D_33_H      0x139D67
#define REG_BK139D_34_L      0x139D68
#define REG_BK139D_34_H      0x139D69
#define REG_BK139D_35_L      0x139D6A
#define REG_BK139D_35_H      0x139D6B
#define REG_BK139D_36_L      0x139D6C
#define REG_BK139D_36_H      0x139D6D
#define REG_BK139D_37_L      0x139D6E
#define REG_BK139D_37_H      0x139D6F
#define REG_BK139D_38_L      0x139D70
#define REG_BK139D_38_H      0x139D71
#define REG_BK139D_39_L      0x139D72
#define REG_BK139D_39_H      0x139D73
#define REG_BK139D_3A_L      0x139D74
#define REG_BK139D_3A_H      0x139D75
#define REG_BK139D_3B_L      0x139D76
#define REG_BK139D_3B_H      0x139D77
#define REG_BK139D_3C_L      0x139D78
#define REG_BK139D_3C_H      0x139D79
#define REG_BK139D_3D_L      0x139D7A
#define REG_BK139D_3D_H      0x139D7B
#define REG_BK139D_3E_L      0x139D7C
#define REG_BK139D_3E_H      0x139D7D
#define REG_BK139D_3F_L      0x139D7E
#define REG_BK139D_3F_H      0x139D7F
#define REG_BK139D_40_L      0x139D80
#define REG_BK139D_40_H      0x139D81
#define REG_BK139D_41_L      0x139D82
#define REG_BK139D_41_H      0x139D83
#define REG_BK139D_42_L      0x139D84
#define REG_BK139D_42_H      0x139D85
#define REG_BK139D_43_L      0x139D86
#define REG_BK139D_43_H      0x139D87
#define REG_BK139D_44_L      0x139D88
#define REG_BK139D_44_H      0x139D89
#define REG_BK139D_45_L      0x139D8A
#define REG_BK139D_45_H      0x139D8B
#define REG_BK139D_46_L      0x139D8C
#define REG_BK139D_46_H      0x139D8D
#define REG_BK139D_47_L      0x139D8E
#define REG_BK139D_47_H      0x139D8F
#define REG_BK139D_48_L      0x139D90
#define REG_BK139D_48_H      0x139D91
#define REG_BK139D_49_L      0x139D92
#define REG_BK139D_49_H      0x139D93
#define REG_BK139D_4A_L      0x139D94
#define REG_BK139D_4A_H      0x139D95
#define REG_BK139D_4B_L      0x139D96
#define REG_BK139D_4B_H      0x139D97
#define REG_BK139D_4C_L      0x139D98
#define REG_BK139D_4C_H      0x139D99
#define REG_BK139D_4D_L      0x139D9A
#define REG_BK139D_4D_H      0x139D9B
#define REG_BK139D_4E_L      0x139D9C
#define REG_BK139D_4E_H      0x139D9D
#define REG_BK139D_4F_L      0x139D9E
#define REG_BK139D_4F_H      0x139D9F
#define REG_BK139D_50_L      0x139DA0
#define REG_BK139D_50_H      0x139DA1
#define REG_BK139D_51_L      0x139DA2
#define REG_BK139D_51_H      0x139DA3
#define REG_BK139D_52_L      0x139DA4
#define REG_BK139D_52_H      0x139DA5
#define REG_BK139D_53_L      0x139DA6
#define REG_BK139D_53_H      0x139DA7
#define REG_BK139D_54_L      0x139DA8
#define REG_BK139D_54_H      0x139DA9
#define REG_BK139D_55_L      0x139DAA
#define REG_BK139D_55_H      0x139DAB
#define REG_BK139D_56_L      0x139DAC
#define REG_BK139D_56_H      0x139DAD
#define REG_BK139D_57_L      0x139DAE
#define REG_BK139D_57_H      0x139DAF
#define REG_BK139D_58_L      0x139DB0
#define REG_BK139D_58_H      0x139DB1
#define REG_BK139D_59_L      0x139DB2
#define REG_BK139D_59_H      0x139DB3
#define REG_BK139D_5A_L      0x139DB4
#define REG_BK139D_5A_H      0x139DB5
#define REG_BK139D_5B_L      0x139DB6
#define REG_BK139D_5B_H      0x139DB7
#define REG_BK139D_5C_L      0x139DB8
#define REG_BK139D_5C_H      0x139DB9
#define REG_BK139D_5D_L      0x139DBA
#define REG_BK139D_5D_H      0x139DBB
#define REG_BK139D_5E_L      0x139DBC
#define REG_BK139D_5E_H      0x139DBD
#define REG_BK139D_5F_L      0x139DBE
#define REG_BK139D_5F_H      0x139DBF
#define REG_BK139D_60_L      0x139DC0
#define REG_BK139D_60_H      0x139DC1
#define REG_BK139D_61_L      0x139DC2
#define REG_BK139D_61_H      0x139DC3
#define REG_BK139D_62_L      0x139DC4
#define REG_BK139D_62_H      0x139DC5
#define REG_BK139D_63_L      0x139DC6
#define REG_BK139D_63_H      0x139DC7
#define REG_BK139D_64_L      0x139DC8
#define REG_BK139D_64_H      0x139DC9
#define REG_BK139D_65_L      0x139DCA
#define REG_BK139D_65_H      0x139DCB
#define REG_BK139D_66_L      0x139DCC
#define REG_BK139D_66_H      0x139DCD
#define REG_BK139D_67_L      0x139DCE
#define REG_BK139D_67_H      0x139DCF
#define REG_BK139D_68_L      0x139DD0
#define REG_BK139D_68_H      0x139DD1
#define REG_BK139D_69_L      0x139DD2
#define REG_BK139D_69_H      0x139DD3
#define REG_BK139D_6A_L      0x139DD4
#define REG_BK139D_6A_H      0x139DD5
#define REG_BK139D_6B_L      0x139DD6
#define REG_BK139D_6B_H      0x139DD7
#define REG_BK139D_6C_L      0x139DD8
#define REG_BK139D_6C_H      0x139DD9
#define REG_BK139D_6D_L      0x139DDA
#define REG_BK139D_6D_H      0x139DDB
#define REG_BK139D_6E_L      0x139DDC
#define REG_BK139D_6E_H      0x139DDD
#define REG_BK139D_6F_L      0x139DDE
#define REG_BK139D_6F_H      0x139DDF
#define REG_BK139D_70_L      0x139DE0
#define REG_BK139D_70_H      0x139DE1
#define REG_BK139D_71_L      0x139DE2
#define REG_BK139D_71_H      0x139DE3
#define REG_BK139D_72_L      0x139DE4
#define REG_BK139D_72_H      0x139DE5
#define REG_BK139D_73_L      0x139DE6
#define REG_BK139D_73_H      0x139DE7
#define REG_BK139D_74_L      0x139DE8
#define REG_BK139D_74_H      0x139DE9
#define REG_BK139D_75_L      0x139DEA
#define REG_BK139D_75_H      0x139DEB
#define REG_BK139D_76_L      0x139DEC
#define REG_BK139D_76_H      0x139DED
#define REG_BK139D_77_L      0x139DEE
#define REG_BK139D_77_H      0x139DEF
#define REG_BK139D_78_L      0x139DF0
#define REG_BK139D_78_H      0x139DF1
#define REG_BK139D_79_L      0x139DF2
#define REG_BK139D_79_H      0x139DF3
#define REG_BK139D_7A_L      0x139DF4
#define REG_BK139D_7A_H      0x139DF5
#define REG_BK139D_7B_L      0x139DF6
#define REG_BK139D_7B_H      0x139DF7
#define REG_BK139D_7C_L      0x139DF8
#define REG_BK139D_7C_H      0x139DF9
#define REG_BK139D_7D_L      0x139DFA
#define REG_BK139D_7D_H      0x139DFB
#define REG_BK139D_7E_L      0x139DFC
#define REG_BK139D_7E_H      0x139DFD
#define REG_BK139D_7F_L      0x139DFE
#define REG_BK139D_7F_H      0x139DFF
//----------------------------------------------
#define REG_BK139E_00_L      0x139E00
#define REG_BK139E_00_H      0x139E01
#define REG_BK139E_01_L      0x139E02
#define REG_BK139E_01_H      0x139E03
#define REG_BK139E_02_L      0x139E04
#define REG_BK139E_02_H      0x139E05
#define REG_BK139E_03_L      0x139E06
#define REG_BK139E_03_H      0x139E07
#define REG_BK139E_04_L      0x139E08
#define REG_BK139E_04_H      0x139E09
#define REG_BK139E_05_L      0x139E0A
#define REG_BK139E_05_H      0x139E0B
#define REG_BK139E_06_L      0x139E0C
#define REG_BK139E_06_H      0x139E0D
#define REG_BK139E_07_L      0x139E0E
#define REG_BK139E_07_H      0x139E0F
#define REG_BK139E_08_L      0x139E10
#define REG_BK139E_08_H      0x139E11
#define REG_BK139E_09_L      0x139E12
#define REG_BK139E_09_H      0x139E13
#define REG_BK139E_0A_L      0x139E14
#define REG_BK139E_0A_H      0x139E15
#define REG_BK139E_0B_L      0x139E16
#define REG_BK139E_0B_H      0x139E17
#define REG_BK139E_0C_L      0x139E18
#define REG_BK139E_0C_H      0x139E19
#define REG_BK139E_0D_L      0x139E1A
#define REG_BK139E_0D_H      0x139E1B
#define REG_BK139E_0E_L      0x139E1C
#define REG_BK139E_0E_H      0x139E1D
#define REG_BK139E_0F_L      0x139E1E
#define REG_BK139E_0F_H      0x139E1F
#define REG_BK139E_10_L      0x139E20
#define REG_BK139E_10_H      0x139E21
#define REG_BK139E_11_L      0x139E22
#define REG_BK139E_11_H      0x139E23
#define REG_BK139E_12_L      0x139E24
#define REG_BK139E_12_H      0x139E25
#define REG_BK139E_13_L      0x139E26
#define REG_BK139E_13_H      0x139E27
#define REG_BK139E_14_L      0x139E28
#define REG_BK139E_14_H      0x139E29
#define REG_BK139E_15_L      0x139E2A
#define REG_BK139E_15_H      0x139E2B
#define REG_BK139E_16_L      0x139E2C
#define REG_BK139E_16_H      0x139E2D
#define REG_BK139E_17_L      0x139E2E
#define REG_BK139E_17_H      0x139E2F
#define REG_BK139E_18_L      0x139E30
#define REG_BK139E_18_H      0x139E31
#define REG_BK139E_19_L      0x139E32
#define REG_BK139E_19_H      0x139E33
#define REG_BK139E_1A_L      0x139E34
#define REG_BK139E_1A_H      0x139E35
#define REG_BK139E_1B_L      0x139E36
#define REG_BK139E_1B_H      0x139E37
#define REG_BK139E_1C_L      0x139E38
#define REG_BK139E_1C_H      0x139E39
#define REG_BK139E_1D_L      0x139E3A
#define REG_BK139E_1D_H      0x139E3B
#define REG_BK139E_1E_L      0x139E3C
#define REG_BK139E_1E_H      0x139E3D
#define REG_BK139E_1F_L      0x139E3E
#define REG_BK139E_1F_H      0x139E3F
#define REG_BK139E_20_L      0x139E40
#define REG_BK139E_20_H      0x139E41
#define REG_BK139E_21_L      0x139E42
#define REG_BK139E_21_H      0x139E43
#define REG_BK139E_22_L      0x139E44
#define REG_BK139E_22_H      0x139E45
#define REG_BK139E_23_L      0x139E46
#define REG_BK139E_23_H      0x139E47
#define REG_BK139E_24_L      0x139E48
#define REG_BK139E_24_H      0x139E49
#define REG_BK139E_25_L      0x139E4A
#define REG_BK139E_25_H      0x139E4B
#define REG_BK139E_26_L      0x139E4C
#define REG_BK139E_26_H      0x139E4D
#define REG_BK139E_27_L      0x139E4E
#define REG_BK139E_27_H      0x139E4F
#define REG_BK139E_28_L      0x139E50
#define REG_BK139E_28_H      0x139E51
#define REG_BK139E_29_L      0x139E52
#define REG_BK139E_29_H      0x139E53
#define REG_BK139E_2A_L      0x139E54
#define REG_BK139E_2A_H      0x139E55
#define REG_BK139E_2B_L      0x139E56
#define REG_BK139E_2B_H      0x139E57
#define REG_BK139E_2C_L      0x139E58
#define REG_BK139E_2C_H      0x139E59
#define REG_BK139E_2D_L      0x139E5A
#define REG_BK139E_2D_H      0x139E5B
#define REG_BK139E_2E_L      0x139E5C
#define REG_BK139E_2E_H      0x139E5D
#define REG_BK139E_2F_L      0x139E5E
#define REG_BK139E_2F_H      0x139E5F
#define REG_BK139E_30_L      0x139E60
#define REG_BK139E_30_H      0x139E61
#define REG_BK139E_31_L      0x139E62
#define REG_BK139E_31_H      0x139E63
#define REG_BK139E_32_L      0x139E64
#define REG_BK139E_32_H      0x139E65
#define REG_BK139E_33_L      0x139E66
#define REG_BK139E_33_H      0x139E67
#define REG_BK139E_34_L      0x139E68
#define REG_BK139E_34_H      0x139E69
#define REG_BK139E_35_L      0x139E6A
#define REG_BK139E_35_H      0x139E6B
#define REG_BK139E_36_L      0x139E6C
#define REG_BK139E_36_H      0x139E6D
#define REG_BK139E_37_L      0x139E6E
#define REG_BK139E_37_H      0x139E6F
#define REG_BK139E_38_L      0x139E70
#define REG_BK139E_38_H      0x139E71
#define REG_BK139E_39_L      0x139E72
#define REG_BK139E_39_H      0x139E73
#define REG_BK139E_3A_L      0x139E74
#define REG_BK139E_3A_H      0x139E75
#define REG_BK139E_3B_L      0x139E76
#define REG_BK139E_3B_H      0x139E77
#define REG_BK139E_3C_L      0x139E78
#define REG_BK139E_3C_H      0x139E79
#define REG_BK139E_3D_L      0x139E7A
#define REG_BK139E_3D_H      0x139E7B
#define REG_BK139E_3E_L      0x139E7C
#define REG_BK139E_3E_H      0x139E7D
#define REG_BK139E_3F_L      0x139E7E
#define REG_BK139E_3F_H      0x139E7F
#define REG_BK139E_40_L      0x139E80
#define REG_BK139E_40_H      0x139E81
#define REG_BK139E_41_L      0x139E82
#define REG_BK139E_41_H      0x139E83
#define REG_BK139E_42_L      0x139E84
#define REG_BK139E_42_H      0x139E85
#define REG_BK139E_43_L      0x139E86
#define REG_BK139E_43_H      0x139E87
#define REG_BK139E_44_L      0x139E88
#define REG_BK139E_44_H      0x139E89
#define REG_BK139E_45_L      0x139E8A
#define REG_BK139E_45_H      0x139E8B
#define REG_BK139E_46_L      0x139E8C
#define REG_BK139E_46_H      0x139E8D
#define REG_BK139E_47_L      0x139E8E
#define REG_BK139E_47_H      0x139E8F
#define REG_BK139E_48_L      0x139E90
#define REG_BK139E_48_H      0x139E91
#define REG_BK139E_49_L      0x139E92
#define REG_BK139E_49_H      0x139E93
#define REG_BK139E_4A_L      0x139E94
#define REG_BK139E_4A_H      0x139E95
#define REG_BK139E_4B_L      0x139E96
#define REG_BK139E_4B_H      0x139E97
#define REG_BK139E_4C_L      0x139E98
#define REG_BK139E_4C_H      0x139E99
#define REG_BK139E_4D_L      0x139E9A
#define REG_BK139E_4D_H      0x139E9B
#define REG_BK139E_4E_L      0x139E9C
#define REG_BK139E_4E_H      0x139E9D
#define REG_BK139E_4F_L      0x139E9E
#define REG_BK139E_4F_H      0x139E9F
#define REG_BK139E_50_L      0x139EA0
#define REG_BK139E_50_H      0x139EA1
#define REG_BK139E_51_L      0x139EA2
#define REG_BK139E_51_H      0x139EA3
#define REG_BK139E_52_L      0x139EA4
#define REG_BK139E_52_H      0x139EA5
#define REG_BK139E_53_L      0x139EA6
#define REG_BK139E_53_H      0x139EA7
#define REG_BK139E_54_L      0x139EA8
#define REG_BK139E_54_H      0x139EA9
#define REG_BK139E_55_L      0x139EAA
#define REG_BK139E_55_H      0x139EAB
#define REG_BK139E_56_L      0x139EAC
#define REG_BK139E_56_H      0x139EAD
#define REG_BK139E_57_L      0x139EAE
#define REG_BK139E_57_H      0x139EAF
#define REG_BK139E_58_L      0x139EB0
#define REG_BK139E_58_H      0x139EB1
#define REG_BK139E_59_L      0x139EB2
#define REG_BK139E_59_H      0x139EB3
#define REG_BK139E_5A_L      0x139EB4
#define REG_BK139E_5A_H      0x139EB5
#define REG_BK139E_5B_L      0x139EB6
#define REG_BK139E_5B_H      0x139EB7
#define REG_BK139E_5C_L      0x139EB8
#define REG_BK139E_5C_H      0x139EB9
#define REG_BK139E_5D_L      0x139EBA
#define REG_BK139E_5D_H      0x139EBB
#define REG_BK139E_5E_L      0x139EBC
#define REG_BK139E_5E_H      0x139EBD
#define REG_BK139E_5F_L      0x139EBE
#define REG_BK139E_5F_H      0x139EBF
#define REG_BK139E_60_L      0x139EC0
#define REG_BK139E_60_H      0x139EC1
#define REG_BK139E_61_L      0x139EC2
#define REG_BK139E_61_H      0x139EC3
#define REG_BK139E_62_L      0x139EC4
#define REG_BK139E_62_H      0x139EC5
#define REG_BK139E_63_L      0x139EC6
#define REG_BK139E_63_H      0x139EC7
#define REG_BK139E_64_L      0x139EC8
#define REG_BK139E_64_H      0x139EC9
#define REG_BK139E_65_L      0x139ECA
#define REG_BK139E_65_H      0x139ECB
#define REG_BK139E_66_L      0x139ECC
#define REG_BK139E_66_H      0x139ECD
#define REG_BK139E_67_L      0x139ECE
#define REG_BK139E_67_H      0x139ECF
#define REG_BK139E_68_L      0x139ED0
#define REG_BK139E_68_H      0x139ED1
#define REG_BK139E_69_L      0x139ED2
#define REG_BK139E_69_H      0x139ED3
#define REG_BK139E_6A_L      0x139ED4
#define REG_BK139E_6A_H      0x139ED5
#define REG_BK139E_6B_L      0x139ED6
#define REG_BK139E_6B_H      0x139ED7
#define REG_BK139E_6C_L      0x139ED8
#define REG_BK139E_6C_H      0x139ED9
#define REG_BK139E_6D_L      0x139EDA
#define REG_BK139E_6D_H      0x139EDB
#define REG_BK139E_6E_L      0x139EDC
#define REG_BK139E_6E_H      0x139EDD
#define REG_BK139E_6F_L      0x139EDE
#define REG_BK139E_6F_H      0x139EDF
#define REG_BK139E_70_L      0x139EE0
#define REG_BK139E_70_H      0x139EE1
#define REG_BK139E_71_L      0x139EE2
#define REG_BK139E_71_H      0x139EE3
#define REG_BK139E_72_L      0x139EE4
#define REG_BK139E_72_H      0x139EE5
#define REG_BK139E_73_L      0x139EE6
#define REG_BK139E_73_H      0x139EE7
#define REG_BK139E_74_L      0x139EE8
#define REG_BK139E_74_H      0x139EE9
#define REG_BK139E_75_L      0x139EEA
#define REG_BK139E_75_H      0x139EEB
#define REG_BK139E_76_L      0x139EEC
#define REG_BK139E_76_H      0x139EED
#define REG_BK139E_77_L      0x139EEE
#define REG_BK139E_77_H      0x139EEF
#define REG_BK139E_78_L      0x139EF0
#define REG_BK139E_78_H      0x139EF1
#define REG_BK139E_79_L      0x139EF2
#define REG_BK139E_79_H      0x139EF3
#define REG_BK139E_7A_L      0x139EF4
#define REG_BK139E_7A_H      0x139EF5
#define REG_BK139E_7B_L      0x139EF6
#define REG_BK139E_7B_H      0x139EF7
#define REG_BK139E_7C_L      0x139EF8
#define REG_BK139E_7C_H      0x139EF9
#define REG_BK139E_7D_L      0x139EFA
#define REG_BK139E_7D_H      0x139EFB
#define REG_BK139E_7E_L      0x139EFC
#define REG_BK139E_7E_H      0x139EFD
#define REG_BK139E_7F_L      0x139EFE
#define REG_BK139E_7F_H      0x139EFF
//----------------------------------------------
#define REG_BK139F_00_L      0x139F00
#define REG_BK139F_00_H      0x139F01
#define REG_BK139F_01_L      0x139F02
#define REG_BK139F_01_H      0x139F03
#define REG_BK139F_02_L      0x139F04
#define REG_BK139F_02_H      0x139F05
#define REG_BK139F_03_L      0x139F06
#define REG_BK139F_03_H      0x139F07
#define REG_BK139F_04_L      0x139F08
#define REG_BK139F_04_H      0x139F09
#define REG_BK139F_05_L      0x139F0A
#define REG_BK139F_05_H      0x139F0B
#define REG_BK139F_06_L      0x139F0C
#define REG_BK139F_06_H      0x139F0D
#define REG_BK139F_07_L      0x139F0E
#define REG_BK139F_07_H      0x139F0F
#define REG_BK139F_08_L      0x139F10
#define REG_BK139F_08_H      0x139F11
#define REG_BK139F_09_L      0x139F12
#define REG_BK139F_09_H      0x139F13
#define REG_BK139F_0A_L      0x139F14
#define REG_BK139F_0A_H      0x139F15
#define REG_BK139F_0B_L      0x139F16
#define REG_BK139F_0B_H      0x139F17
#define REG_BK139F_0C_L      0x139F18
#define REG_BK139F_0C_H      0x139F19
#define REG_BK139F_0D_L      0x139F1A
#define REG_BK139F_0D_H      0x139F1B
#define REG_BK139F_0E_L      0x139F1C
#define REG_BK139F_0E_H      0x139F1D
#define REG_BK139F_0F_L      0x139F1E
#define REG_BK139F_0F_H      0x139F1F
#define REG_BK139F_10_L      0x139F20
#define REG_BK139F_10_H      0x139F21
#define REG_BK139F_11_L      0x139F22
#define REG_BK139F_11_H      0x139F23
#define REG_BK139F_12_L      0x139F24
#define REG_BK139F_12_H      0x139F25
#define REG_BK139F_13_L      0x139F26
#define REG_BK139F_13_H      0x139F27
#define REG_BK139F_14_L      0x139F28
#define REG_BK139F_14_H      0x139F29
#define REG_BK139F_15_L      0x139F2A
#define REG_BK139F_15_H      0x139F2B
#define REG_BK139F_16_L      0x139F2C
#define REG_BK139F_16_H      0x139F2D
#define REG_BK139F_17_L      0x139F2E
#define REG_BK139F_17_H      0x139F2F
#define REG_BK139F_18_L      0x139F30
#define REG_BK139F_18_H      0x139F31
#define REG_BK139F_19_L      0x139F32
#define REG_BK139F_19_H      0x139F33
#define REG_BK139F_1A_L      0x139F34
#define REG_BK139F_1A_H      0x139F35
#define REG_BK139F_1B_L      0x139F36
#define REG_BK139F_1B_H      0x139F37
#define REG_BK139F_1C_L      0x139F38
#define REG_BK139F_1C_H      0x139F39
#define REG_BK139F_1D_L      0x139F3A
#define REG_BK139F_1D_H      0x139F3B
#define REG_BK139F_1E_L      0x139F3C
#define REG_BK139F_1E_H      0x139F3D
#define REG_BK139F_1F_L      0x139F3E
#define REG_BK139F_1F_H      0x139F3F
#define REG_BK139F_20_L      0x139F40
#define REG_BK139F_20_H      0x139F41
#define REG_BK139F_21_L      0x139F42
#define REG_BK139F_21_H      0x139F43
#define REG_BK139F_22_L      0x139F44
#define REG_BK139F_22_H      0x139F45
#define REG_BK139F_23_L      0x139F46
#define REG_BK139F_23_H      0x139F47
#define REG_BK139F_24_L      0x139F48
#define REG_BK139F_24_H      0x139F49
#define REG_BK139F_25_L      0x139F4A
#define REG_BK139F_25_H      0x139F4B
#define REG_BK139F_26_L      0x139F4C
#define REG_BK139F_26_H      0x139F4D
#define REG_BK139F_27_L      0x139F4E
#define REG_BK139F_27_H      0x139F4F
#define REG_BK139F_28_L      0x139F50
#define REG_BK139F_28_H      0x139F51
#define REG_BK139F_29_L      0x139F52
#define REG_BK139F_29_H      0x139F53
#define REG_BK139F_2A_L      0x139F54
#define REG_BK139F_2A_H      0x139F55
#define REG_BK139F_2B_L      0x139F56
#define REG_BK139F_2B_H      0x139F57
#define REG_BK139F_2C_L      0x139F58
#define REG_BK139F_2C_H      0x139F59
#define REG_BK139F_2D_L      0x139F5A
#define REG_BK139F_2D_H      0x139F5B
#define REG_BK139F_2E_L      0x139F5C
#define REG_BK139F_2E_H      0x139F5D
#define REG_BK139F_2F_L      0x139F5E
#define REG_BK139F_2F_H      0x139F5F
#define REG_BK139F_30_L      0x139F60
#define REG_BK139F_30_H      0x139F61
#define REG_BK139F_31_L      0x139F62
#define REG_BK139F_31_H      0x139F63
#define REG_BK139F_32_L      0x139F64
#define REG_BK139F_32_H      0x139F65
#define REG_BK139F_33_L      0x139F66
#define REG_BK139F_33_H      0x139F67
#define REG_BK139F_34_L      0x139F68
#define REG_BK139F_34_H      0x139F69
#define REG_BK139F_35_L      0x139F6A
#define REG_BK139F_35_H      0x139F6B
#define REG_BK139F_36_L      0x139F6C
#define REG_BK139F_36_H      0x139F6D
#define REG_BK139F_37_L      0x139F6E
#define REG_BK139F_37_H      0x139F6F
#define REG_BK139F_38_L      0x139F70
#define REG_BK139F_38_H      0x139F71
#define REG_BK139F_39_L      0x139F72
#define REG_BK139F_39_H      0x139F73
#define REG_BK139F_3A_L      0x139F74
#define REG_BK139F_3A_H      0x139F75
#define REG_BK139F_3B_L      0x139F76
#define REG_BK139F_3B_H      0x139F77
#define REG_BK139F_3C_L      0x139F78
#define REG_BK139F_3C_H      0x139F79
#define REG_BK139F_3D_L      0x139F7A
#define REG_BK139F_3D_H      0x139F7B
#define REG_BK139F_3E_L      0x139F7C
#define REG_BK139F_3E_H      0x139F7D
#define REG_BK139F_3F_L      0x139F7E
#define REG_BK139F_3F_H      0x139F7F
#define REG_BK139F_40_L      0x139F80
#define REG_BK139F_40_H      0x139F81
#define REG_BK139F_41_L      0x139F82
#define REG_BK139F_41_H      0x139F83
#define REG_BK139F_42_L      0x139F84
#define REG_BK139F_42_H      0x139F85
#define REG_BK139F_43_L      0x139F86
#define REG_BK139F_43_H      0x139F87
#define REG_BK139F_44_L      0x139F88
#define REG_BK139F_44_H      0x139F89
#define REG_BK139F_45_L      0x139F8A
#define REG_BK139F_45_H      0x139F8B
#define REG_BK139F_46_L      0x139F8C
#define REG_BK139F_46_H      0x139F8D
#define REG_BK139F_47_L      0x139F8E
#define REG_BK139F_47_H      0x139F8F
#define REG_BK139F_48_L      0x139F90
#define REG_BK139F_48_H      0x139F91
#define REG_BK139F_49_L      0x139F92
#define REG_BK139F_49_H      0x139F93
#define REG_BK139F_4A_L      0x139F94
#define REG_BK139F_4A_H      0x139F95
#define REG_BK139F_4B_L      0x139F96
#define REG_BK139F_4B_H      0x139F97
#define REG_BK139F_4C_L      0x139F98
#define REG_BK139F_4C_H      0x139F99
#define REG_BK139F_4D_L      0x139F9A
#define REG_BK139F_4D_H      0x139F9B
#define REG_BK139F_4E_L      0x139F9C
#define REG_BK139F_4E_H      0x139F9D
#define REG_BK139F_4F_L      0x139F9E
#define REG_BK139F_4F_H      0x139F9F
#define REG_BK139F_50_L      0x139FA0
#define REG_BK139F_50_H      0x139FA1
#define REG_BK139F_51_L      0x139FA2
#define REG_BK139F_51_H      0x139FA3
#define REG_BK139F_52_L      0x139FA4
#define REG_BK139F_52_H      0x139FA5
#define REG_BK139F_53_L      0x139FA6
#define REG_BK139F_53_H      0x139FA7
#define REG_BK139F_54_L      0x139FA8
#define REG_BK139F_54_H      0x139FA9
#define REG_BK139F_55_L      0x139FAA
#define REG_BK139F_55_H      0x139FAB
#define REG_BK139F_56_L      0x139FAC
#define REG_BK139F_56_H      0x139FAD
#define REG_BK139F_57_L      0x139FAE
#define REG_BK139F_57_H      0x139FAF
#define REG_BK139F_58_L      0x139FB0
#define REG_BK139F_58_H      0x139FB1
#define REG_BK139F_59_L      0x139FB2
#define REG_BK139F_59_H      0x139FB3
#define REG_BK139F_5A_L      0x139FB4
#define REG_BK139F_5A_H      0x139FB5
#define REG_BK139F_5B_L      0x139FB6
#define REG_BK139F_5B_H      0x139FB7
#define REG_BK139F_5C_L      0x139FB8
#define REG_BK139F_5C_H      0x139FB9
#define REG_BK139F_5D_L      0x139FBA
#define REG_BK139F_5D_H      0x139FBB
#define REG_BK139F_5E_L      0x139FBC
#define REG_BK139F_5E_H      0x139FBD
#define REG_BK139F_5F_L      0x139FBE
#define REG_BK139F_5F_H      0x139FBF
#define REG_BK139F_60_L      0x139FC0
#define REG_BK139F_60_H      0x139FC1
#define REG_BK139F_61_L      0x139FC2
#define REG_BK139F_61_H      0x139FC3
#define REG_BK139F_62_L      0x139FC4
#define REG_BK139F_62_H      0x139FC5
#define REG_BK139F_63_L      0x139FC6
#define REG_BK139F_63_H      0x139FC7
#define REG_BK139F_64_L      0x139FC8
#define REG_BK139F_64_H      0x139FC9
#define REG_BK139F_65_L      0x139FCA
#define REG_BK139F_65_H      0x139FCB
#define REG_BK139F_66_L      0x139FCC
#define REG_BK139F_66_H      0x139FCD
#define REG_BK139F_67_L      0x139FCE
#define REG_BK139F_67_H      0x139FCF
#define REG_BK139F_68_L      0x139FD0
#define REG_BK139F_68_H      0x139FD1
#define REG_BK139F_69_L      0x139FD2
#define REG_BK139F_69_H      0x139FD3
#define REG_BK139F_6A_L      0x139FD4
#define REG_BK139F_6A_H      0x139FD5
#define REG_BK139F_6B_L      0x139FD6
#define REG_BK139F_6B_H      0x139FD7
#define REG_BK139F_6C_L      0x139FD8
#define REG_BK139F_6C_H      0x139FD9
#define REG_BK139F_6D_L      0x139FDA
#define REG_BK139F_6D_H      0x139FDB
#define REG_BK139F_6E_L      0x139FDC
#define REG_BK139F_6E_H      0x139FDD
#define REG_BK139F_6F_L      0x139FDE
#define REG_BK139F_6F_H      0x139FDF
#define REG_BK139F_70_L      0x139FE0
#define REG_BK139F_70_H      0x139FE1
#define REG_BK139F_71_L      0x139FE2
#define REG_BK139F_71_H      0x139FE3
#define REG_BK139F_72_L      0x139FE4
#define REG_BK139F_72_H      0x139FE5
#define REG_BK139F_73_L      0x139FE6
#define REG_BK139F_73_H      0x139FE7
#define REG_BK139F_74_L      0x139FE8
#define REG_BK139F_74_H      0x139FE9
#define REG_BK139F_75_L      0x139FEA
#define REG_BK139F_75_H      0x139FEB
#define REG_BK139F_76_L      0x139FEC
#define REG_BK139F_76_H      0x139FED
#define REG_BK139F_77_L      0x139FEE
#define REG_BK139F_77_H      0x139FEF
#define REG_BK139F_78_L      0x139FF0
#define REG_BK139F_78_H      0x139FF1
#define REG_BK139F_79_L      0x139FF2
#define REG_BK139F_79_H      0x139FF3
#define REG_BK139F_7A_L      0x139FF4
#define REG_BK139F_7A_H      0x139FF5
#define REG_BK139F_7B_L      0x139FF6
#define REG_BK139F_7B_H      0x139FF7
#define REG_BK139F_7C_L      0x139FF8
#define REG_BK139F_7C_H      0x139FF9
#define REG_BK139F_7D_L      0x139FFA
#define REG_BK139F_7D_H      0x139FFB
#define REG_BK139F_7E_L      0x139FFC
#define REG_BK139F_7E_H      0x139FFD
#define REG_BK139F_7F_L      0x139FFE
#define REG_BK139F_7F_H      0x139FFF
//----------------------------------------------
#define REG_BK13A0_00_L      0x13A000
#define REG_BK13A0_00_H      0x13A001
#define REG_BK13A0_01_L      0x13A002
#define REG_BK13A0_01_H      0x13A003
#define REG_BK13A0_02_L      0x13A004
#define REG_BK13A0_02_H      0x13A005
#define REG_BK13A0_03_L      0x13A006
#define REG_BK13A0_03_H      0x13A007
#define REG_BK13A0_04_L      0x13A008
#define REG_BK13A0_04_H      0x13A009
#define REG_BK13A0_05_L      0x13A00A
#define REG_BK13A0_05_H      0x13A00B
#define REG_BK13A0_06_L      0x13A00C
#define REG_BK13A0_06_H      0x13A00D
#define REG_BK13A0_07_L      0x13A00E
#define REG_BK13A0_07_H      0x13A00F
#define REG_BK13A0_08_L      0x13A010
#define REG_BK13A0_08_H      0x13A011
#define REG_BK13A0_09_L      0x13A012
#define REG_BK13A0_09_H      0x13A013
#define REG_BK13A0_0A_L      0x13A014
#define REG_BK13A0_0A_H      0x13A015
#define REG_BK13A0_0B_L      0x13A016
#define REG_BK13A0_0B_H      0x13A017
#define REG_BK13A0_0C_L      0x13A018
#define REG_BK13A0_0C_H      0x13A019
#define REG_BK13A0_0D_L      0x13A01A
#define REG_BK13A0_0D_H      0x13A01B
#define REG_BK13A0_0E_L      0x13A01C
#define REG_BK13A0_0E_H      0x13A01D
#define REG_BK13A0_0F_L      0x13A01E
#define REG_BK13A0_0F_H      0x13A01F
#define REG_BK13A0_10_L      0x13A020
#define REG_BK13A0_10_H      0x13A021
#define REG_BK13A0_11_L      0x13A022
#define REG_BK13A0_11_H      0x13A023
#define REG_BK13A0_12_L      0x13A024
#define REG_BK13A0_12_H      0x13A025
#define REG_BK13A0_13_L      0x13A026
#define REG_BK13A0_13_H      0x13A027
#define REG_BK13A0_14_L      0x13A028
#define REG_BK13A0_14_H      0x13A029
#define REG_BK13A0_15_L      0x13A02A
#define REG_BK13A0_15_H      0x13A02B
#define REG_BK13A0_16_L      0x13A02C
#define REG_BK13A0_16_H      0x13A02D
#define REG_BK13A0_17_L      0x13A02E
#define REG_BK13A0_17_H      0x13A02F
#define REG_BK13A0_18_L      0x13A030
#define REG_BK13A0_18_H      0x13A031
#define REG_BK13A0_19_L      0x13A032
#define REG_BK13A0_19_H      0x13A033
#define REG_BK13A0_1A_L      0x13A034
#define REG_BK13A0_1A_H      0x13A035
#define REG_BK13A0_1B_L      0x13A036
#define REG_BK13A0_1B_H      0x13A037
#define REG_BK13A0_1C_L      0x13A038
#define REG_BK13A0_1C_H      0x13A039
#define REG_BK13A0_1D_L      0x13A03A
#define REG_BK13A0_1D_H      0x13A03B
#define REG_BK13A0_1E_L      0x13A03C
#define REG_BK13A0_1E_H      0x13A03D
#define REG_BK13A0_1F_L      0x13A03E
#define REG_BK13A0_1F_H      0x13A03F
#define REG_BK13A0_20_L      0x13A040
#define REG_BK13A0_20_H      0x13A041
#define REG_BK13A0_21_L      0x13A042
#define REG_BK13A0_21_H      0x13A043
#define REG_BK13A0_22_L      0x13A044
#define REG_BK13A0_22_H      0x13A045
#define REG_BK13A0_23_L      0x13A046
#define REG_BK13A0_23_H      0x13A047
#define REG_BK13A0_24_L      0x13A048
#define REG_BK13A0_24_H      0x13A049
#define REG_BK13A0_25_L      0x13A04A
#define REG_BK13A0_25_H      0x13A04B
#define REG_BK13A0_26_L      0x13A04C
#define REG_BK13A0_26_H      0x13A04D
#define REG_BK13A0_27_L      0x13A04E
#define REG_BK13A0_27_H      0x13A04F
#define REG_BK13A0_28_L      0x13A050
#define REG_BK13A0_28_H      0x13A051
#define REG_BK13A0_29_L      0x13A052
#define REG_BK13A0_29_H      0x13A053
#define REG_BK13A0_2A_L      0x13A054
#define REG_BK13A0_2A_H      0x13A055
#define REG_BK13A0_2B_L      0x13A056
#define REG_BK13A0_2B_H      0x13A057
#define REG_BK13A0_2C_L      0x13A058
#define REG_BK13A0_2C_H      0x13A059
#define REG_BK13A0_2D_L      0x13A05A
#define REG_BK13A0_2D_H      0x13A05B
#define REG_BK13A0_2E_L      0x13A05C
#define REG_BK13A0_2E_H      0x13A05D
#define REG_BK13A0_2F_L      0x13A05E
#define REG_BK13A0_2F_H      0x13A05F
#define REG_BK13A0_30_L      0x13A060
#define REG_BK13A0_30_H      0x13A061
#define REG_BK13A0_31_L      0x13A062
#define REG_BK13A0_31_H      0x13A063
#define REG_BK13A0_32_L      0x13A064
#define REG_BK13A0_32_H      0x13A065
#define REG_BK13A0_33_L      0x13A066
#define REG_BK13A0_33_H      0x13A067
#define REG_BK13A0_34_L      0x13A068
#define REG_BK13A0_34_H      0x13A069
#define REG_BK13A0_35_L      0x13A06A
#define REG_BK13A0_35_H      0x13A06B
#define REG_BK13A0_36_L      0x13A06C
#define REG_BK13A0_36_H      0x13A06D
#define REG_BK13A0_37_L      0x13A06E
#define REG_BK13A0_37_H      0x13A06F
#define REG_BK13A0_38_L      0x13A070
#define REG_BK13A0_38_H      0x13A071
#define REG_BK13A0_39_L      0x13A072
#define REG_BK13A0_39_H      0x13A073
#define REG_BK13A0_3A_L      0x13A074
#define REG_BK13A0_3A_H      0x13A075
#define REG_BK13A0_3B_L      0x13A076
#define REG_BK13A0_3B_H      0x13A077
#define REG_BK13A0_3C_L      0x13A078
#define REG_BK13A0_3C_H      0x13A079
#define REG_BK13A0_3D_L      0x13A07A
#define REG_BK13A0_3D_H      0x13A07B
#define REG_BK13A0_3E_L      0x13A07C
#define REG_BK13A0_3E_H      0x13A07D
#define REG_BK13A0_3F_L      0x13A07E
#define REG_BK13A0_3F_H      0x13A07F
#define REG_BK13A0_40_L      0x13A080
#define REG_BK13A0_40_H      0x13A081
#define REG_BK13A0_41_L      0x13A082
#define REG_BK13A0_41_H      0x13A083
#define REG_BK13A0_42_L      0x13A084
#define REG_BK13A0_42_H      0x13A085
#define REG_BK13A0_43_L      0x13A086
#define REG_BK13A0_43_H      0x13A087
#define REG_BK13A0_44_L      0x13A088
#define REG_BK13A0_44_H      0x13A089
#define REG_BK13A0_45_L      0x13A08A
#define REG_BK13A0_45_H      0x13A08B
#define REG_BK13A0_46_L      0x13A08C
#define REG_BK13A0_46_H      0x13A08D
#define REG_BK13A0_47_L      0x13A08E
#define REG_BK13A0_47_H      0x13A08F
#define REG_BK13A0_48_L      0x13A090
#define REG_BK13A0_48_H      0x13A091
#define REG_BK13A0_49_L      0x13A092
#define REG_BK13A0_49_H      0x13A093
#define REG_BK13A0_4A_L      0x13A094
#define REG_BK13A0_4A_H      0x13A095
#define REG_BK13A0_4B_L      0x13A096
#define REG_BK13A0_4B_H      0x13A097
#define REG_BK13A0_4C_L      0x13A098
#define REG_BK13A0_4C_H      0x13A099
#define REG_BK13A0_4D_L      0x13A09A
#define REG_BK13A0_4D_H      0x13A09B
#define REG_BK13A0_4E_L      0x13A09C
#define REG_BK13A0_4E_H      0x13A09D
#define REG_BK13A0_4F_L      0x13A09E
#define REG_BK13A0_4F_H      0x13A09F
#define REG_BK13A0_50_L      0x13A0A0
#define REG_BK13A0_50_H      0x13A0A1
#define REG_BK13A0_51_L      0x13A0A2
#define REG_BK13A0_51_H      0x13A0A3
#define REG_BK13A0_52_L      0x13A0A4
#define REG_BK13A0_52_H      0x13A0A5
#define REG_BK13A0_53_L      0x13A0A6
#define REG_BK13A0_53_H      0x13A0A7
#define REG_BK13A0_54_L      0x13A0A8
#define REG_BK13A0_54_H      0x13A0A9
#define REG_BK13A0_55_L      0x13A0AA
#define REG_BK13A0_55_H      0x13A0AB
#define REG_BK13A0_56_L      0x13A0AC
#define REG_BK13A0_56_H      0x13A0AD
#define REG_BK13A0_57_L      0x13A0AE
#define REG_BK13A0_57_H      0x13A0AF
#define REG_BK13A0_58_L      0x13A0B0
#define REG_BK13A0_58_H      0x13A0B1
#define REG_BK13A0_59_L      0x13A0B2
#define REG_BK13A0_59_H      0x13A0B3
#define REG_BK13A0_5A_L      0x13A0B4
#define REG_BK13A0_5A_H      0x13A0B5
#define REG_BK13A0_5B_L      0x13A0B6
#define REG_BK13A0_5B_H      0x13A0B7
#define REG_BK13A0_5C_L      0x13A0B8
#define REG_BK13A0_5C_H      0x13A0B9
#define REG_BK13A0_5D_L      0x13A0BA
#define REG_BK13A0_5D_H      0x13A0BB
#define REG_BK13A0_5E_L      0x13A0BC
#define REG_BK13A0_5E_H      0x13A0BD
#define REG_BK13A0_5F_L      0x13A0BE
#define REG_BK13A0_5F_H      0x13A0BF
#define REG_BK13A0_60_L      0x13A0C0
#define REG_BK13A0_60_H      0x13A0C1
#define REG_BK13A0_61_L      0x13A0C2
#define REG_BK13A0_61_H      0x13A0C3
#define REG_BK13A0_62_L      0x13A0C4
#define REG_BK13A0_62_H      0x13A0C5
#define REG_BK13A0_63_L      0x13A0C6
#define REG_BK13A0_63_H      0x13A0C7
#define REG_BK13A0_64_L      0x13A0C8
#define REG_BK13A0_64_H      0x13A0C9
#define REG_BK13A0_65_L      0x13A0CA
#define REG_BK13A0_65_H      0x13A0CB
#define REG_BK13A0_66_L      0x13A0CC
#define REG_BK13A0_66_H      0x13A0CD
#define REG_BK13A0_67_L      0x13A0CE
#define REG_BK13A0_67_H      0x13A0CF
#define REG_BK13A0_68_L      0x13A0D0
#define REG_BK13A0_68_H      0x13A0D1
#define REG_BK13A0_69_L      0x13A0D2
#define REG_BK13A0_69_H      0x13A0D3
#define REG_BK13A0_6A_L      0x13A0D4
#define REG_BK13A0_6A_H      0x13A0D5
#define REG_BK13A0_6B_L      0x13A0D6
#define REG_BK13A0_6B_H      0x13A0D7
#define REG_BK13A0_6C_L      0x13A0D8
#define REG_BK13A0_6C_H      0x13A0D9
#define REG_BK13A0_6D_L      0x13A0DA
#define REG_BK13A0_6D_H      0x13A0DB
#define REG_BK13A0_6E_L      0x13A0DC
#define REG_BK13A0_6E_H      0x13A0DD
#define REG_BK13A0_6F_L      0x13A0DE
#define REG_BK13A0_6F_H      0x13A0DF
#define REG_BK13A0_70_L      0x13A0E0
#define REG_BK13A0_70_H      0x13A0E1
#define REG_BK13A0_71_L      0x13A0E2
#define REG_BK13A0_71_H      0x13A0E3
#define REG_BK13A0_72_L      0x13A0E4
#define REG_BK13A0_72_H      0x13A0E5
#define REG_BK13A0_73_L      0x13A0E6
#define REG_BK13A0_73_H      0x13A0E7
#define REG_BK13A0_74_L      0x13A0E8
#define REG_BK13A0_74_H      0x13A0E9
#define REG_BK13A0_75_L      0x13A0EA
#define REG_BK13A0_75_H      0x13A0EB
#define REG_BK13A0_76_L      0x13A0EC
#define REG_BK13A0_76_H      0x13A0ED
#define REG_BK13A0_77_L      0x13A0EE
#define REG_BK13A0_77_H      0x13A0EF
#define REG_BK13A0_78_L      0x13A0F0
#define REG_BK13A0_78_H      0x13A0F1
#define REG_BK13A0_79_L      0x13A0F2
#define REG_BK13A0_79_H      0x13A0F3
#define REG_BK13A0_7A_L      0x13A0F4
#define REG_BK13A0_7A_H      0x13A0F5
#define REG_BK13A0_7B_L      0x13A0F6
#define REG_BK13A0_7B_H      0x13A0F7
#define REG_BK13A0_7C_L      0x13A0F8
#define REG_BK13A0_7C_H      0x13A0F9
#define REG_BK13A0_7D_L      0x13A0FA
#define REG_BK13A0_7D_H      0x13A0FB
#define REG_BK13A0_7E_L      0x13A0FC
#define REG_BK13A0_7E_H      0x13A0FD
#define REG_BK13A0_7F_L      0x13A0FE
#define REG_BK13A0_7F_H      0x13A0FF
//----------------------------------------------
#define REG_BK13A1_00_L      0x13A100
#define REG_BK13A1_00_H      0x13A101
#define REG_BK13A1_01_L      0x13A102
#define REG_BK13A1_01_H      0x13A103
#define REG_BK13A1_02_L      0x13A104
#define REG_BK13A1_02_H      0x13A105
#define REG_BK13A1_03_L      0x13A106
#define REG_BK13A1_03_H      0x13A107
#define REG_BK13A1_04_L      0x13A108
#define REG_BK13A1_04_H      0x13A109
#define REG_BK13A1_05_L      0x13A10A
#define REG_BK13A1_05_H      0x13A10B
#define REG_BK13A1_06_L      0x13A10C
#define REG_BK13A1_06_H      0x13A10D
#define REG_BK13A1_07_L      0x13A10E
#define REG_BK13A1_07_H      0x13A10F
#define REG_BK13A1_08_L      0x13A110
#define REG_BK13A1_08_H      0x13A111
#define REG_BK13A1_09_L      0x13A112
#define REG_BK13A1_09_H      0x13A113
#define REG_BK13A1_0A_L      0x13A114
#define REG_BK13A1_0A_H      0x13A115
#define REG_BK13A1_0B_L      0x13A116
#define REG_BK13A1_0B_H      0x13A117
#define REG_BK13A1_0C_L      0x13A118
#define REG_BK13A1_0C_H      0x13A119
#define REG_BK13A1_0D_L      0x13A11A
#define REG_BK13A1_0D_H      0x13A11B
#define REG_BK13A1_0E_L      0x13A11C
#define REG_BK13A1_0E_H      0x13A11D
#define REG_BK13A1_0F_L      0x13A11E
#define REG_BK13A1_0F_H      0x13A11F
#define REG_BK13A1_10_L      0x13A120
#define REG_BK13A1_10_H      0x13A121
#define REG_BK13A1_11_L      0x13A122
#define REG_BK13A1_11_H      0x13A123
#define REG_BK13A1_12_L      0x13A124
#define REG_BK13A1_12_H      0x13A125
#define REG_BK13A1_13_L      0x13A126
#define REG_BK13A1_13_H      0x13A127
#define REG_BK13A1_14_L      0x13A128
#define REG_BK13A1_14_H      0x13A129
#define REG_BK13A1_15_L      0x13A12A
#define REG_BK13A1_15_H      0x13A12B
#define REG_BK13A1_16_L      0x13A12C
#define REG_BK13A1_16_H      0x13A12D
#define REG_BK13A1_17_L      0x13A12E
#define REG_BK13A1_17_H      0x13A12F
#define REG_BK13A1_18_L      0x13A130
#define REG_BK13A1_18_H      0x13A131
#define REG_BK13A1_19_L      0x13A132
#define REG_BK13A1_19_H      0x13A133
#define REG_BK13A1_1A_L      0x13A134
#define REG_BK13A1_1A_H      0x13A135
#define REG_BK13A1_1B_L      0x13A136
#define REG_BK13A1_1B_H      0x13A137
#define REG_BK13A1_1C_L      0x13A138
#define REG_BK13A1_1C_H      0x13A139
#define REG_BK13A1_1D_L      0x13A13A
#define REG_BK13A1_1D_H      0x13A13B
#define REG_BK13A1_1E_L      0x13A13C
#define REG_BK13A1_1E_H      0x13A13D
#define REG_BK13A1_1F_L      0x13A13E
#define REG_BK13A1_1F_H      0x13A13F
#define REG_BK13A1_20_L      0x13A140
#define REG_BK13A1_20_H      0x13A141
#define REG_BK13A1_21_L      0x13A142
#define REG_BK13A1_21_H      0x13A143
#define REG_BK13A1_22_L      0x13A144
#define REG_BK13A1_22_H      0x13A145
#define REG_BK13A1_23_L      0x13A146
#define REG_BK13A1_23_H      0x13A147
#define REG_BK13A1_24_L      0x13A148
#define REG_BK13A1_24_H      0x13A149
#define REG_BK13A1_25_L      0x13A14A
#define REG_BK13A1_25_H      0x13A14B
#define REG_BK13A1_26_L      0x13A14C
#define REG_BK13A1_26_H      0x13A14D
#define REG_BK13A1_27_L      0x13A14E
#define REG_BK13A1_27_H      0x13A14F
#define REG_BK13A1_28_L      0x13A150
#define REG_BK13A1_28_H      0x13A151
#define REG_BK13A1_29_L      0x13A152
#define REG_BK13A1_29_H      0x13A153
#define REG_BK13A1_2A_L      0x13A154
#define REG_BK13A1_2A_H      0x13A155
#define REG_BK13A1_2B_L      0x13A156
#define REG_BK13A1_2B_H      0x13A157
#define REG_BK13A1_2C_L      0x13A158
#define REG_BK13A1_2C_H      0x13A159
#define REG_BK13A1_2D_L      0x13A15A
#define REG_BK13A1_2D_H      0x13A15B
#define REG_BK13A1_2E_L      0x13A15C
#define REG_BK13A1_2E_H      0x13A15D
#define REG_BK13A1_2F_L      0x13A15E
#define REG_BK13A1_2F_H      0x13A15F
#define REG_BK13A1_30_L      0x13A160
#define REG_BK13A1_30_H      0x13A161
#define REG_BK13A1_31_L      0x13A162
#define REG_BK13A1_31_H      0x13A163
#define REG_BK13A1_32_L      0x13A164
#define REG_BK13A1_32_H      0x13A165
#define REG_BK13A1_33_L      0x13A166
#define REG_BK13A1_33_H      0x13A167
#define REG_BK13A1_34_L      0x13A168
#define REG_BK13A1_34_H      0x13A169
#define REG_BK13A1_35_L      0x13A16A
#define REG_BK13A1_35_H      0x13A16B
#define REG_BK13A1_36_L      0x13A16C
#define REG_BK13A1_36_H      0x13A16D
#define REG_BK13A1_37_L      0x13A16E
#define REG_BK13A1_37_H      0x13A16F
#define REG_BK13A1_38_L      0x13A170
#define REG_BK13A1_38_H      0x13A171
#define REG_BK13A1_39_L      0x13A172
#define REG_BK13A1_39_H      0x13A173
#define REG_BK13A1_3A_L      0x13A174
#define REG_BK13A1_3A_H      0x13A175
#define REG_BK13A1_3B_L      0x13A176
#define REG_BK13A1_3B_H      0x13A177
#define REG_BK13A1_3C_L      0x13A178
#define REG_BK13A1_3C_H      0x13A179
#define REG_BK13A1_3D_L      0x13A17A
#define REG_BK13A1_3D_H      0x13A17B
#define REG_BK13A1_3E_L      0x13A17C
#define REG_BK13A1_3E_H      0x13A17D
#define REG_BK13A1_3F_L      0x13A17E
#define REG_BK13A1_3F_H      0x13A17F
#define REG_BK13A1_40_L      0x13A180
#define REG_BK13A1_40_H      0x13A181
#define REG_BK13A1_41_L      0x13A182
#define REG_BK13A1_41_H      0x13A183
#define REG_BK13A1_42_L      0x13A184
#define REG_BK13A1_42_H      0x13A185
#define REG_BK13A1_43_L      0x13A186
#define REG_BK13A1_43_H      0x13A187
#define REG_BK13A1_44_L      0x13A188
#define REG_BK13A1_44_H      0x13A189
#define REG_BK13A1_45_L      0x13A18A
#define REG_BK13A1_45_H      0x13A18B
#define REG_BK13A1_46_L      0x13A18C
#define REG_BK13A1_46_H      0x13A18D
#define REG_BK13A1_47_L      0x13A18E
#define REG_BK13A1_47_H      0x13A18F
#define REG_BK13A1_48_L      0x13A190
#define REG_BK13A1_48_H      0x13A191
#define REG_BK13A1_49_L      0x13A192
#define REG_BK13A1_49_H      0x13A193
#define REG_BK13A1_4A_L      0x13A194
#define REG_BK13A1_4A_H      0x13A195
#define REG_BK13A1_4B_L      0x13A196
#define REG_BK13A1_4B_H      0x13A197
#define REG_BK13A1_4C_L      0x13A198
#define REG_BK13A1_4C_H      0x13A199
#define REG_BK13A1_4D_L      0x13A19A
#define REG_BK13A1_4D_H      0x13A19B
#define REG_BK13A1_4E_L      0x13A19C
#define REG_BK13A1_4E_H      0x13A19D
#define REG_BK13A1_4F_L      0x13A19E
#define REG_BK13A1_4F_H      0x13A19F
#define REG_BK13A1_50_L      0x13A1A0
#define REG_BK13A1_50_H      0x13A1A1
#define REG_BK13A1_51_L      0x13A1A2
#define REG_BK13A1_51_H      0x13A1A3
#define REG_BK13A1_52_L      0x13A1A4
#define REG_BK13A1_52_H      0x13A1A5
#define REG_BK13A1_53_L      0x13A1A6
#define REG_BK13A1_53_H      0x13A1A7
#define REG_BK13A1_54_L      0x13A1A8
#define REG_BK13A1_54_H      0x13A1A9
#define REG_BK13A1_55_L      0x13A1AA
#define REG_BK13A1_55_H      0x13A1AB
#define REG_BK13A1_56_L      0x13A1AC
#define REG_BK13A1_56_H      0x13A1AD
#define REG_BK13A1_57_L      0x13A1AE
#define REG_BK13A1_57_H      0x13A1AF
#define REG_BK13A1_58_L      0x13A1B0
#define REG_BK13A1_58_H      0x13A1B1
#define REG_BK13A1_59_L      0x13A1B2
#define REG_BK13A1_59_H      0x13A1B3
#define REG_BK13A1_5A_L      0x13A1B4
#define REG_BK13A1_5A_H      0x13A1B5
#define REG_BK13A1_5B_L      0x13A1B6
#define REG_BK13A1_5B_H      0x13A1B7
#define REG_BK13A1_5C_L      0x13A1B8
#define REG_BK13A1_5C_H      0x13A1B9
#define REG_BK13A1_5D_L      0x13A1BA
#define REG_BK13A1_5D_H      0x13A1BB
#define REG_BK13A1_5E_L      0x13A1BC
#define REG_BK13A1_5E_H      0x13A1BD
#define REG_BK13A1_5F_L      0x13A1BE
#define REG_BK13A1_5F_H      0x13A1BF
#define REG_BK13A1_60_L      0x13A1C0
#define REG_BK13A1_60_H      0x13A1C1
#define REG_BK13A1_61_L      0x13A1C2
#define REG_BK13A1_61_H      0x13A1C3
#define REG_BK13A1_62_L      0x13A1C4
#define REG_BK13A1_62_H      0x13A1C5
#define REG_BK13A1_63_L      0x13A1C6
#define REG_BK13A1_63_H      0x13A1C7
#define REG_BK13A1_64_L      0x13A1C8
#define REG_BK13A1_64_H      0x13A1C9
#define REG_BK13A1_65_L      0x13A1CA
#define REG_BK13A1_65_H      0x13A1CB
#define REG_BK13A1_66_L      0x13A1CC
#define REG_BK13A1_66_H      0x13A1CD
#define REG_BK13A1_67_L      0x13A1CE
#define REG_BK13A1_67_H      0x13A1CF
#define REG_BK13A1_68_L      0x13A1D0
#define REG_BK13A1_68_H      0x13A1D1
#define REG_BK13A1_69_L      0x13A1D2
#define REG_BK13A1_69_H      0x13A1D3
#define REG_BK13A1_6A_L      0x13A1D4
#define REG_BK13A1_6A_H      0x13A1D5
#define REG_BK13A1_6B_L      0x13A1D6
#define REG_BK13A1_6B_H      0x13A1D7
#define REG_BK13A1_6C_L      0x13A1D8
#define REG_BK13A1_6C_H      0x13A1D9
#define REG_BK13A1_6D_L      0x13A1DA
#define REG_BK13A1_6D_H      0x13A1DB
#define REG_BK13A1_6E_L      0x13A1DC
#define REG_BK13A1_6E_H      0x13A1DD
#define REG_BK13A1_6F_L      0x13A1DE
#define REG_BK13A1_6F_H      0x13A1DF
#define REG_BK13A1_70_L      0x13A1E0
#define REG_BK13A1_70_H      0x13A1E1
#define REG_BK13A1_71_L      0x13A1E2
#define REG_BK13A1_71_H      0x13A1E3
#define REG_BK13A1_72_L      0x13A1E4
#define REG_BK13A1_72_H      0x13A1E5
#define REG_BK13A1_73_L      0x13A1E6
#define REG_BK13A1_73_H      0x13A1E7
#define REG_BK13A1_74_L      0x13A1E8
#define REG_BK13A1_74_H      0x13A1E9
#define REG_BK13A1_75_L      0x13A1EA
#define REG_BK13A1_75_H      0x13A1EB
#define REG_BK13A1_76_L      0x13A1EC
#define REG_BK13A1_76_H      0x13A1ED
#define REG_BK13A1_77_L      0x13A1EE
#define REG_BK13A1_77_H      0x13A1EF
#define REG_BK13A1_78_L      0x13A1F0
#define REG_BK13A1_78_H      0x13A1F1
#define REG_BK13A1_79_L      0x13A1F2
#define REG_BK13A1_79_H      0x13A1F3
#define REG_BK13A1_7A_L      0x13A1F4
#define REG_BK13A1_7A_H      0x13A1F5
#define REG_BK13A1_7B_L      0x13A1F6
#define REG_BK13A1_7B_H      0x13A1F7
#define REG_BK13A1_7C_L      0x13A1F8
#define REG_BK13A1_7C_H      0x13A1F9
#define REG_BK13A1_7D_L      0x13A1FA
#define REG_BK13A1_7D_H      0x13A1FB
#define REG_BK13A1_7E_L      0x13A1FC
#define REG_BK13A1_7E_H      0x13A1FD
#define REG_BK13A1_7F_L      0x13A1FE
#define REG_BK13A1_7F_H      0x13A1FF
//----------------------------------------------
#define REG_BK13A2_00_L      0x13A200
#define REG_BK13A2_00_H      0x13A201
#define REG_BK13A2_01_L      0x13A202
#define REG_BK13A2_01_H      0x13A203
#define REG_BK13A2_02_L      0x13A204
#define REG_BK13A2_02_H      0x13A205
#define REG_BK13A2_03_L      0x13A206
#define REG_BK13A2_03_H      0x13A207
#define REG_BK13A2_04_L      0x13A208
#define REG_BK13A2_04_H      0x13A209
#define REG_BK13A2_05_L      0x13A20A
#define REG_BK13A2_05_H      0x13A20B
#define REG_BK13A2_06_L      0x13A20C
#define REG_BK13A2_06_H      0x13A20D
#define REG_BK13A2_07_L      0x13A20E
#define REG_BK13A2_07_H      0x13A20F
#define REG_BK13A2_08_L      0x13A210
#define REG_BK13A2_08_H      0x13A211
#define REG_BK13A2_09_L      0x13A212
#define REG_BK13A2_09_H      0x13A213
#define REG_BK13A2_0A_L      0x13A214
#define REG_BK13A2_0A_H      0x13A215
#define REG_BK13A2_0B_L      0x13A216
#define REG_BK13A2_0B_H      0x13A217
#define REG_BK13A2_0C_L      0x13A218
#define REG_BK13A2_0C_H      0x13A219
#define REG_BK13A2_0D_L      0x13A21A
#define REG_BK13A2_0D_H      0x13A21B
#define REG_BK13A2_0E_L      0x13A21C
#define REG_BK13A2_0E_H      0x13A21D
#define REG_BK13A2_0F_L      0x13A21E
#define REG_BK13A2_0F_H      0x13A21F
#define REG_BK13A2_10_L      0x13A220
#define REG_BK13A2_10_H      0x13A221
#define REG_BK13A2_11_L      0x13A222
#define REG_BK13A2_11_H      0x13A223
#define REG_BK13A2_12_L      0x13A224
#define REG_BK13A2_12_H      0x13A225
#define REG_BK13A2_13_L      0x13A226
#define REG_BK13A2_13_H      0x13A227
#define REG_BK13A2_14_L      0x13A228
#define REG_BK13A2_14_H      0x13A229
#define REG_BK13A2_15_L      0x13A22A
#define REG_BK13A2_15_H      0x13A22B
#define REG_BK13A2_16_L      0x13A22C
#define REG_BK13A2_16_H      0x13A22D
#define REG_BK13A2_17_L      0x13A22E
#define REG_BK13A2_17_H      0x13A22F
#define REG_BK13A2_18_L      0x13A230
#define REG_BK13A2_18_H      0x13A231
#define REG_BK13A2_19_L      0x13A232
#define REG_BK13A2_19_H      0x13A233
#define REG_BK13A2_1A_L      0x13A234
#define REG_BK13A2_1A_H      0x13A235
#define REG_BK13A2_1B_L      0x13A236
#define REG_BK13A2_1B_H      0x13A237
#define REG_BK13A2_1C_L      0x13A238
#define REG_BK13A2_1C_H      0x13A239
#define REG_BK13A2_1D_L      0x13A23A
#define REG_BK13A2_1D_H      0x13A23B
#define REG_BK13A2_1E_L      0x13A23C
#define REG_BK13A2_1E_H      0x13A23D
#define REG_BK13A2_1F_L      0x13A23E
#define REG_BK13A2_1F_H      0x13A23F
#define REG_BK13A2_20_L      0x13A240
#define REG_BK13A2_20_H      0x13A241
#define REG_BK13A2_21_L      0x13A242
#define REG_BK13A2_21_H      0x13A243
#define REG_BK13A2_22_L      0x13A244
#define REG_BK13A2_22_H      0x13A245
#define REG_BK13A2_23_L      0x13A246
#define REG_BK13A2_23_H      0x13A247
#define REG_BK13A2_24_L      0x13A248
#define REG_BK13A2_24_H      0x13A249
#define REG_BK13A2_25_L      0x13A24A
#define REG_BK13A2_25_H      0x13A24B
#define REG_BK13A2_26_L      0x13A24C
#define REG_BK13A2_26_H      0x13A24D
#define REG_BK13A2_27_L      0x13A24E
#define REG_BK13A2_27_H      0x13A24F
#define REG_BK13A2_28_L      0x13A250
#define REG_BK13A2_28_H      0x13A251
#define REG_BK13A2_29_L      0x13A252
#define REG_BK13A2_29_H      0x13A253
#define REG_BK13A2_2A_L      0x13A254
#define REG_BK13A2_2A_H      0x13A255
#define REG_BK13A2_2B_L      0x13A256
#define REG_BK13A2_2B_H      0x13A257
#define REG_BK13A2_2C_L      0x13A258
#define REG_BK13A2_2C_H      0x13A259
#define REG_BK13A2_2D_L      0x13A25A
#define REG_BK13A2_2D_H      0x13A25B
#define REG_BK13A2_2E_L      0x13A25C
#define REG_BK13A2_2E_H      0x13A25D
#define REG_BK13A2_2F_L      0x13A25E
#define REG_BK13A2_2F_H      0x13A25F
#define REG_BK13A2_30_L      0x13A260
#define REG_BK13A2_30_H      0x13A261
#define REG_BK13A2_31_L      0x13A262
#define REG_BK13A2_31_H      0x13A263
#define REG_BK13A2_32_L      0x13A264
#define REG_BK13A2_32_H      0x13A265
#define REG_BK13A2_33_L      0x13A266
#define REG_BK13A2_33_H      0x13A267
#define REG_BK13A2_34_L      0x13A268
#define REG_BK13A2_34_H      0x13A269
#define REG_BK13A2_35_L      0x13A26A
#define REG_BK13A2_35_H      0x13A26B
#define REG_BK13A2_36_L      0x13A26C
#define REG_BK13A2_36_H      0x13A26D
#define REG_BK13A2_37_L      0x13A26E
#define REG_BK13A2_37_H      0x13A26F
#define REG_BK13A2_38_L      0x13A270
#define REG_BK13A2_38_H      0x13A271
#define REG_BK13A2_39_L      0x13A272
#define REG_BK13A2_39_H      0x13A273
#define REG_BK13A2_3A_L      0x13A274
#define REG_BK13A2_3A_H      0x13A275
#define REG_BK13A2_3B_L      0x13A276
#define REG_BK13A2_3B_H      0x13A277
#define REG_BK13A2_3C_L      0x13A278
#define REG_BK13A2_3C_H      0x13A279
#define REG_BK13A2_3D_L      0x13A27A
#define REG_BK13A2_3D_H      0x13A27B
#define REG_BK13A2_3E_L      0x13A27C
#define REG_BK13A2_3E_H      0x13A27D
#define REG_BK13A2_3F_L      0x13A27E
#define REG_BK13A2_3F_H      0x13A27F
#define REG_BK13A2_40_L      0x13A280
#define REG_BK13A2_40_H      0x13A281
#define REG_BK13A2_41_L      0x13A282
#define REG_BK13A2_41_H      0x13A283
#define REG_BK13A2_42_L      0x13A284
#define REG_BK13A2_42_H      0x13A285
#define REG_BK13A2_43_L      0x13A286
#define REG_BK13A2_43_H      0x13A287
#define REG_BK13A2_44_L      0x13A288
#define REG_BK13A2_44_H      0x13A289
#define REG_BK13A2_45_L      0x13A28A
#define REG_BK13A2_45_H      0x13A28B
#define REG_BK13A2_46_L      0x13A28C
#define REG_BK13A2_46_H      0x13A28D
#define REG_BK13A2_47_L      0x13A28E
#define REG_BK13A2_47_H      0x13A28F
#define REG_BK13A2_48_L      0x13A290
#define REG_BK13A2_48_H      0x13A291
#define REG_BK13A2_49_L      0x13A292
#define REG_BK13A2_49_H      0x13A293
#define REG_BK13A2_4A_L      0x13A294
#define REG_BK13A2_4A_H      0x13A295
#define REG_BK13A2_4B_L      0x13A296
#define REG_BK13A2_4B_H      0x13A297
#define REG_BK13A2_4C_L      0x13A298
#define REG_BK13A2_4C_H      0x13A299
#define REG_BK13A2_4D_L      0x13A29A
#define REG_BK13A2_4D_H      0x13A29B
#define REG_BK13A2_4E_L      0x13A29C
#define REG_BK13A2_4E_H      0x13A29D
#define REG_BK13A2_4F_L      0x13A29E
#define REG_BK13A2_4F_H      0x13A29F
#define REG_BK13A2_50_L      0x13A2A0
#define REG_BK13A2_50_H      0x13A2A1
#define REG_BK13A2_51_L      0x13A2A2
#define REG_BK13A2_51_H      0x13A2A3
#define REG_BK13A2_52_L      0x13A2A4
#define REG_BK13A2_52_H      0x13A2A5
#define REG_BK13A2_53_L      0x13A2A6
#define REG_BK13A2_53_H      0x13A2A7
#define REG_BK13A2_54_L      0x13A2A8
#define REG_BK13A2_54_H      0x13A2A9
#define REG_BK13A2_55_L      0x13A2AA
#define REG_BK13A2_55_H      0x13A2AB
#define REG_BK13A2_56_L      0x13A2AC
#define REG_BK13A2_56_H      0x13A2AD
#define REG_BK13A2_57_L      0x13A2AE
#define REG_BK13A2_57_H      0x13A2AF
#define REG_BK13A2_58_L      0x13A2B0
#define REG_BK13A2_58_H      0x13A2B1
#define REG_BK13A2_59_L      0x13A2B2
#define REG_BK13A2_59_H      0x13A2B3
#define REG_BK13A2_5A_L      0x13A2B4
#define REG_BK13A2_5A_H      0x13A2B5
#define REG_BK13A2_5B_L      0x13A2B6
#define REG_BK13A2_5B_H      0x13A2B7
#define REG_BK13A2_5C_L      0x13A2B8
#define REG_BK13A2_5C_H      0x13A2B9
#define REG_BK13A2_5D_L      0x13A2BA
#define REG_BK13A2_5D_H      0x13A2BB
#define REG_BK13A2_5E_L      0x13A2BC
#define REG_BK13A2_5E_H      0x13A2BD
#define REG_BK13A2_5F_L      0x13A2BE
#define REG_BK13A2_5F_H      0x13A2BF
#define REG_BK13A2_60_L      0x13A2C0
#define REG_BK13A2_60_H      0x13A2C1
#define REG_BK13A2_61_L      0x13A2C2
#define REG_BK13A2_61_H      0x13A2C3
#define REG_BK13A2_62_L      0x13A2C4
#define REG_BK13A2_62_H      0x13A2C5
#define REG_BK13A2_63_L      0x13A2C6
#define REG_BK13A2_63_H      0x13A2C7
#define REG_BK13A2_64_L      0x13A2C8
#define REG_BK13A2_64_H      0x13A2C9
#define REG_BK13A2_65_L      0x13A2CA
#define REG_BK13A2_65_H      0x13A2CB
#define REG_BK13A2_66_L      0x13A2CC
#define REG_BK13A2_66_H      0x13A2CD
#define REG_BK13A2_67_L      0x13A2CE
#define REG_BK13A2_67_H      0x13A2CF
#define REG_BK13A2_68_L      0x13A2D0
#define REG_BK13A2_68_H      0x13A2D1
#define REG_BK13A2_69_L      0x13A2D2
#define REG_BK13A2_69_H      0x13A2D3
#define REG_BK13A2_6A_L      0x13A2D4
#define REG_BK13A2_6A_H      0x13A2D5
#define REG_BK13A2_6B_L      0x13A2D6
#define REG_BK13A2_6B_H      0x13A2D7
#define REG_BK13A2_6C_L      0x13A2D8
#define REG_BK13A2_6C_H      0x13A2D9
#define REG_BK13A2_6D_L      0x13A2DA
#define REG_BK13A2_6D_H      0x13A2DB
#define REG_BK13A2_6E_L      0x13A2DC
#define REG_BK13A2_6E_H      0x13A2DD
#define REG_BK13A2_6F_L      0x13A2DE
#define REG_BK13A2_6F_H      0x13A2DF
#define REG_BK13A2_70_L      0x13A2E0
#define REG_BK13A2_70_H      0x13A2E1
#define REG_BK13A2_71_L      0x13A2E2
#define REG_BK13A2_71_H      0x13A2E3
#define REG_BK13A2_72_L      0x13A2E4
#define REG_BK13A2_72_H      0x13A2E5
#define REG_BK13A2_73_L      0x13A2E6
#define REG_BK13A2_73_H      0x13A2E7
#define REG_BK13A2_74_L      0x13A2E8
#define REG_BK13A2_74_H      0x13A2E9
#define REG_BK13A2_75_L      0x13A2EA
#define REG_BK13A2_75_H      0x13A2EB
#define REG_BK13A2_76_L      0x13A2EC
#define REG_BK13A2_76_H      0x13A2ED
#define REG_BK13A2_77_L      0x13A2EE
#define REG_BK13A2_77_H      0x13A2EF
#define REG_BK13A2_78_L      0x13A2F0
#define REG_BK13A2_78_H      0x13A2F1
#define REG_BK13A2_79_L      0x13A2F2
#define REG_BK13A2_79_H      0x13A2F3
#define REG_BK13A2_7A_L      0x13A2F4
#define REG_BK13A2_7A_H      0x13A2F5
#define REG_BK13A2_7B_L      0x13A2F6
#define REG_BK13A2_7B_H      0x13A2F7
#define REG_BK13A2_7C_L      0x13A2F8
#define REG_BK13A2_7C_H      0x13A2F9
#define REG_BK13A2_7D_L      0x13A2FA
#define REG_BK13A2_7D_H      0x13A2FB
#define REG_BK13A2_7E_L      0x13A2FC
#define REG_BK13A2_7E_H      0x13A2FD
#define REG_BK13A2_7F_L      0x13A2FE
#define REG_BK13A2_7F_H      0x13A2FF
//----------------------------------------------
#define REG_BK13A3_00_L      0x13A300
#define REG_BK13A3_00_H      0x13A301
#define REG_BK13A3_01_L      0x13A302
#define REG_BK13A3_01_H      0x13A303
#define REG_BK13A3_02_L      0x13A304
#define REG_BK13A3_02_H      0x13A305
#define REG_BK13A3_03_L      0x13A306
#define REG_BK13A3_03_H      0x13A307
#define REG_BK13A3_04_L      0x13A308
#define REG_BK13A3_04_H      0x13A309
#define REG_BK13A3_05_L      0x13A30A
#define REG_BK13A3_05_H      0x13A30B
#define REG_BK13A3_06_L      0x13A30C
#define REG_BK13A3_06_H      0x13A30D
#define REG_BK13A3_07_L      0x13A30E
#define REG_BK13A3_07_H      0x13A30F
#define REG_BK13A3_08_L      0x13A310
#define REG_BK13A3_08_H      0x13A311
#define REG_BK13A3_09_L      0x13A312
#define REG_BK13A3_09_H      0x13A313
#define REG_BK13A3_0A_L      0x13A314
#define REG_BK13A3_0A_H      0x13A315
#define REG_BK13A3_0B_L      0x13A316
#define REG_BK13A3_0B_H      0x13A317
#define REG_BK13A3_0C_L      0x13A318
#define REG_BK13A3_0C_H      0x13A319
#define REG_BK13A3_0D_L      0x13A31A
#define REG_BK13A3_0D_H      0x13A31B
#define REG_BK13A3_0E_L      0x13A31C
#define REG_BK13A3_0E_H      0x13A31D
#define REG_BK13A3_0F_L      0x13A31E
#define REG_BK13A3_0F_H      0x13A31F
#define REG_BK13A3_10_L      0x13A320
#define REG_BK13A3_10_H      0x13A321
#define REG_BK13A3_11_L      0x13A322
#define REG_BK13A3_11_H      0x13A323
#define REG_BK13A3_12_L      0x13A324
#define REG_BK13A3_12_H      0x13A325
#define REG_BK13A3_13_L      0x13A326
#define REG_BK13A3_13_H      0x13A327
#define REG_BK13A3_14_L      0x13A328
#define REG_BK13A3_14_H      0x13A329
#define REG_BK13A3_15_L      0x13A32A
#define REG_BK13A3_15_H      0x13A32B
#define REG_BK13A3_16_L      0x13A32C
#define REG_BK13A3_16_H      0x13A32D
#define REG_BK13A3_17_L      0x13A32E
#define REG_BK13A3_17_H      0x13A32F
#define REG_BK13A3_18_L      0x13A330
#define REG_BK13A3_18_H      0x13A331
#define REG_BK13A3_19_L      0x13A332
#define REG_BK13A3_19_H      0x13A333
#define REG_BK13A3_1A_L      0x13A334
#define REG_BK13A3_1A_H      0x13A335
#define REG_BK13A3_1B_L      0x13A336
#define REG_BK13A3_1B_H      0x13A337
#define REG_BK13A3_1C_L      0x13A338
#define REG_BK13A3_1C_H      0x13A339
#define REG_BK13A3_1D_L      0x13A33A
#define REG_BK13A3_1D_H      0x13A33B
#define REG_BK13A3_1E_L      0x13A33C
#define REG_BK13A3_1E_H      0x13A33D
#define REG_BK13A3_1F_L      0x13A33E
#define REG_BK13A3_1F_H      0x13A33F
#define REG_BK13A3_20_L      0x13A340
#define REG_BK13A3_20_H      0x13A341
#define REG_BK13A3_21_L      0x13A342
#define REG_BK13A3_21_H      0x13A343
#define REG_BK13A3_22_L      0x13A344
#define REG_BK13A3_22_H      0x13A345
#define REG_BK13A3_23_L      0x13A346
#define REG_BK13A3_23_H      0x13A347
#define REG_BK13A3_24_L      0x13A348
#define REG_BK13A3_24_H      0x13A349
#define REG_BK13A3_25_L      0x13A34A
#define REG_BK13A3_25_H      0x13A34B
#define REG_BK13A3_26_L      0x13A34C
#define REG_BK13A3_26_H      0x13A34D
#define REG_BK13A3_27_L      0x13A34E
#define REG_BK13A3_27_H      0x13A34F
#define REG_BK13A3_28_L      0x13A350
#define REG_BK13A3_28_H      0x13A351
#define REG_BK13A3_29_L      0x13A352
#define REG_BK13A3_29_H      0x13A353
#define REG_BK13A3_2A_L      0x13A354
#define REG_BK13A3_2A_H      0x13A355
#define REG_BK13A3_2B_L      0x13A356
#define REG_BK13A3_2B_H      0x13A357
#define REG_BK13A3_2C_L      0x13A358
#define REG_BK13A3_2C_H      0x13A359
#define REG_BK13A3_2D_L      0x13A35A
#define REG_BK13A3_2D_H      0x13A35B
#define REG_BK13A3_2E_L      0x13A35C
#define REG_BK13A3_2E_H      0x13A35D
#define REG_BK13A3_2F_L      0x13A35E
#define REG_BK13A3_2F_H      0x13A35F
#define REG_BK13A3_30_L      0x13A360
#define REG_BK13A3_30_H      0x13A361
#define REG_BK13A3_31_L      0x13A362
#define REG_BK13A3_31_H      0x13A363
#define REG_BK13A3_32_L      0x13A364
#define REG_BK13A3_32_H      0x13A365
#define REG_BK13A3_33_L      0x13A366
#define REG_BK13A3_33_H      0x13A367
#define REG_BK13A3_34_L      0x13A368
#define REG_BK13A3_34_H      0x13A369
#define REG_BK13A3_35_L      0x13A36A
#define REG_BK13A3_35_H      0x13A36B
#define REG_BK13A3_36_L      0x13A36C
#define REG_BK13A3_36_H      0x13A36D
#define REG_BK13A3_37_L      0x13A36E
#define REG_BK13A3_37_H      0x13A36F
#define REG_BK13A3_38_L      0x13A370
#define REG_BK13A3_38_H      0x13A371
#define REG_BK13A3_39_L      0x13A372
#define REG_BK13A3_39_H      0x13A373
#define REG_BK13A3_3A_L      0x13A374
#define REG_BK13A3_3A_H      0x13A375
#define REG_BK13A3_3B_L      0x13A376
#define REG_BK13A3_3B_H      0x13A377
#define REG_BK13A3_3C_L      0x13A378
#define REG_BK13A3_3C_H      0x13A379
#define REG_BK13A3_3D_L      0x13A37A
#define REG_BK13A3_3D_H      0x13A37B
#define REG_BK13A3_3E_L      0x13A37C
#define REG_BK13A3_3E_H      0x13A37D
#define REG_BK13A3_3F_L      0x13A37E
#define REG_BK13A3_3F_H      0x13A37F
#define REG_BK13A3_40_L      0x13A380
#define REG_BK13A3_40_H      0x13A381
#define REG_BK13A3_41_L      0x13A382
#define REG_BK13A3_41_H      0x13A383
#define REG_BK13A3_42_L      0x13A384
#define REG_BK13A3_42_H      0x13A385
#define REG_BK13A3_43_L      0x13A386
#define REG_BK13A3_43_H      0x13A387
#define REG_BK13A3_44_L      0x13A388
#define REG_BK13A3_44_H      0x13A389
#define REG_BK13A3_45_L      0x13A38A
#define REG_BK13A3_45_H      0x13A38B
#define REG_BK13A3_46_L      0x13A38C
#define REG_BK13A3_46_H      0x13A38D
#define REG_BK13A3_47_L      0x13A38E
#define REG_BK13A3_47_H      0x13A38F
#define REG_BK13A3_48_L      0x13A390
#define REG_BK13A3_48_H      0x13A391
#define REG_BK13A3_49_L      0x13A392
#define REG_BK13A3_49_H      0x13A393
#define REG_BK13A3_4A_L      0x13A394
#define REG_BK13A3_4A_H      0x13A395
#define REG_BK13A3_4B_L      0x13A396
#define REG_BK13A3_4B_H      0x13A397
#define REG_BK13A3_4C_L      0x13A398
#define REG_BK13A3_4C_H      0x13A399
#define REG_BK13A3_4D_L      0x13A39A
#define REG_BK13A3_4D_H      0x13A39B
#define REG_BK13A3_4E_L      0x13A39C
#define REG_BK13A3_4E_H      0x13A39D
#define REG_BK13A3_4F_L      0x13A39E
#define REG_BK13A3_4F_H      0x13A39F
#define REG_BK13A3_50_L      0x13A3A0
#define REG_BK13A3_50_H      0x13A3A1
#define REG_BK13A3_51_L      0x13A3A2
#define REG_BK13A3_51_H      0x13A3A3
#define REG_BK13A3_52_L      0x13A3A4
#define REG_BK13A3_52_H      0x13A3A5
#define REG_BK13A3_53_L      0x13A3A6
#define REG_BK13A3_53_H      0x13A3A7
#define REG_BK13A3_54_L      0x13A3A8
#define REG_BK13A3_54_H      0x13A3A9
#define REG_BK13A3_55_L      0x13A3AA
#define REG_BK13A3_55_H      0x13A3AB
#define REG_BK13A3_56_L      0x13A3AC
#define REG_BK13A3_56_H      0x13A3AD
#define REG_BK13A3_57_L      0x13A3AE
#define REG_BK13A3_57_H      0x13A3AF
#define REG_BK13A3_58_L      0x13A3B0
#define REG_BK13A3_58_H      0x13A3B1
#define REG_BK13A3_59_L      0x13A3B2
#define REG_BK13A3_59_H      0x13A3B3
#define REG_BK13A3_5A_L      0x13A3B4
#define REG_BK13A3_5A_H      0x13A3B5
#define REG_BK13A3_5B_L      0x13A3B6
#define REG_BK13A3_5B_H      0x13A3B7
#define REG_BK13A3_5C_L      0x13A3B8
#define REG_BK13A3_5C_H      0x13A3B9
#define REG_BK13A3_5D_L      0x13A3BA
#define REG_BK13A3_5D_H      0x13A3BB
#define REG_BK13A3_5E_L      0x13A3BC
#define REG_BK13A3_5E_H      0x13A3BD
#define REG_BK13A3_5F_L      0x13A3BE
#define REG_BK13A3_5F_H      0x13A3BF
#define REG_BK13A3_60_L      0x13A3C0
#define REG_BK13A3_60_H      0x13A3C1
#define REG_BK13A3_61_L      0x13A3C2
#define REG_BK13A3_61_H      0x13A3C3
#define REG_BK13A3_62_L      0x13A3C4
#define REG_BK13A3_62_H      0x13A3C5
#define REG_BK13A3_63_L      0x13A3C6
#define REG_BK13A3_63_H      0x13A3C7
#define REG_BK13A3_64_L      0x13A3C8
#define REG_BK13A3_64_H      0x13A3C9
#define REG_BK13A3_65_L      0x13A3CA
#define REG_BK13A3_65_H      0x13A3CB
#define REG_BK13A3_66_L      0x13A3CC
#define REG_BK13A3_66_H      0x13A3CD
#define REG_BK13A3_67_L      0x13A3CE
#define REG_BK13A3_67_H      0x13A3CF
#define REG_BK13A3_68_L      0x13A3D0
#define REG_BK13A3_68_H      0x13A3D1
#define REG_BK13A3_69_L      0x13A3D2
#define REG_BK13A3_69_H      0x13A3D3
#define REG_BK13A3_6A_L      0x13A3D4
#define REG_BK13A3_6A_H      0x13A3D5
#define REG_BK13A3_6B_L      0x13A3D6
#define REG_BK13A3_6B_H      0x13A3D7
#define REG_BK13A3_6C_L      0x13A3D8
#define REG_BK13A3_6C_H      0x13A3D9
#define REG_BK13A3_6D_L      0x13A3DA
#define REG_BK13A3_6D_H      0x13A3DB
#define REG_BK13A3_6E_L      0x13A3DC
#define REG_BK13A3_6E_H      0x13A3DD
#define REG_BK13A3_6F_L      0x13A3DE
#define REG_BK13A3_6F_H      0x13A3DF
#define REG_BK13A3_70_L      0x13A3E0
#define REG_BK13A3_70_H      0x13A3E1
#define REG_BK13A3_71_L      0x13A3E2
#define REG_BK13A3_71_H      0x13A3E3
#define REG_BK13A3_72_L      0x13A3E4
#define REG_BK13A3_72_H      0x13A3E5
#define REG_BK13A3_73_L      0x13A3E6
#define REG_BK13A3_73_H      0x13A3E7
#define REG_BK13A3_74_L      0x13A3E8
#define REG_BK13A3_74_H      0x13A3E9
#define REG_BK13A3_75_L      0x13A3EA
#define REG_BK13A3_75_H      0x13A3EB
#define REG_BK13A3_76_L      0x13A3EC
#define REG_BK13A3_76_H      0x13A3ED
#define REG_BK13A3_77_L      0x13A3EE
#define REG_BK13A3_77_H      0x13A3EF
#define REG_BK13A3_78_L      0x13A3F0
#define REG_BK13A3_78_H      0x13A3F1
#define REG_BK13A3_79_L      0x13A3F2
#define REG_BK13A3_79_H      0x13A3F3
#define REG_BK13A3_7A_L      0x13A3F4
#define REG_BK13A3_7A_H      0x13A3F5
#define REG_BK13A3_7B_L      0x13A3F6
#define REG_BK13A3_7B_H      0x13A3F7
#define REG_BK13A3_7C_L      0x13A3F8
#define REG_BK13A3_7C_H      0x13A3F9
#define REG_BK13A3_7D_L      0x13A3FA
#define REG_BK13A3_7D_H      0x13A3FB
#define REG_BK13A3_7E_L      0x13A3FC
#define REG_BK13A3_7E_H      0x13A3FD
#define REG_BK13A3_7F_L      0x13A3FE
#define REG_BK13A3_7F_H      0x13A3FF
//----------------------------------------------
#define REG_BK13A4_00_L      0x13A400
#define REG_BK13A4_00_H      0x13A401
#define REG_BK13A4_01_L      0x13A402
#define REG_BK13A4_01_H      0x13A403
#define REG_BK13A4_02_L      0x13A404
#define REG_BK13A4_02_H      0x13A405
#define REG_BK13A4_03_L      0x13A406
#define REG_BK13A4_03_H      0x13A407
#define REG_BK13A4_04_L      0x13A408
#define REG_BK13A4_04_H      0x13A409
#define REG_BK13A4_05_L      0x13A40A
#define REG_BK13A4_05_H      0x13A40B
#define REG_BK13A4_06_L      0x13A40C
#define REG_BK13A4_06_H      0x13A40D
#define REG_BK13A4_07_L      0x13A40E
#define REG_BK13A4_07_H      0x13A40F
#define REG_BK13A4_08_L      0x13A410
#define REG_BK13A4_08_H      0x13A411
#define REG_BK13A4_09_L      0x13A412
#define REG_BK13A4_09_H      0x13A413
#define REG_BK13A4_0A_L      0x13A414
#define REG_BK13A4_0A_H      0x13A415
#define REG_BK13A4_0B_L      0x13A416
#define REG_BK13A4_0B_H      0x13A417
#define REG_BK13A4_0C_L      0x13A418
#define REG_BK13A4_0C_H      0x13A419
#define REG_BK13A4_0D_L      0x13A41A
#define REG_BK13A4_0D_H      0x13A41B
#define REG_BK13A4_0E_L      0x13A41C
#define REG_BK13A4_0E_H      0x13A41D
#define REG_BK13A4_0F_L      0x13A41E
#define REG_BK13A4_0F_H      0x13A41F
#define REG_BK13A4_10_L      0x13A420
#define REG_BK13A4_10_H      0x13A421
#define REG_BK13A4_11_L      0x13A422
#define REG_BK13A4_11_H      0x13A423
#define REG_BK13A4_12_L      0x13A424
#define REG_BK13A4_12_H      0x13A425
#define REG_BK13A4_13_L      0x13A426
#define REG_BK13A4_13_H      0x13A427
#define REG_BK13A4_14_L      0x13A428
#define REG_BK13A4_14_H      0x13A429
#define REG_BK13A4_15_L      0x13A42A
#define REG_BK13A4_15_H      0x13A42B
#define REG_BK13A4_16_L      0x13A42C
#define REG_BK13A4_16_H      0x13A42D
#define REG_BK13A4_17_L      0x13A42E
#define REG_BK13A4_17_H      0x13A42F
#define REG_BK13A4_18_L      0x13A430
#define REG_BK13A4_18_H      0x13A431
#define REG_BK13A4_19_L      0x13A432
#define REG_BK13A4_19_H      0x13A433
#define REG_BK13A4_1A_L      0x13A434
#define REG_BK13A4_1A_H      0x13A435
#define REG_BK13A4_1B_L      0x13A436
#define REG_BK13A4_1B_H      0x13A437
#define REG_BK13A4_1C_L      0x13A438
#define REG_BK13A4_1C_H      0x13A439
#define REG_BK13A4_1D_L      0x13A43A
#define REG_BK13A4_1D_H      0x13A43B
#define REG_BK13A4_1E_L      0x13A43C
#define REG_BK13A4_1E_H      0x13A43D
#define REG_BK13A4_1F_L      0x13A43E
#define REG_BK13A4_1F_H      0x13A43F
#define REG_BK13A4_20_L      0x13A440
#define REG_BK13A4_20_H      0x13A441
#define REG_BK13A4_21_L      0x13A442
#define REG_BK13A4_21_H      0x13A443
#define REG_BK13A4_22_L      0x13A444
#define REG_BK13A4_22_H      0x13A445
#define REG_BK13A4_23_L      0x13A446
#define REG_BK13A4_23_H      0x13A447
#define REG_BK13A4_24_L      0x13A448
#define REG_BK13A4_24_H      0x13A449
#define REG_BK13A4_25_L      0x13A44A
#define REG_BK13A4_25_H      0x13A44B
#define REG_BK13A4_26_L      0x13A44C
#define REG_BK13A4_26_H      0x13A44D
#define REG_BK13A4_27_L      0x13A44E
#define REG_BK13A4_27_H      0x13A44F
#define REG_BK13A4_28_L      0x13A450
#define REG_BK13A4_28_H      0x13A451
#define REG_BK13A4_29_L      0x13A452
#define REG_BK13A4_29_H      0x13A453
#define REG_BK13A4_2A_L      0x13A454
#define REG_BK13A4_2A_H      0x13A455
#define REG_BK13A4_2B_L      0x13A456
#define REG_BK13A4_2B_H      0x13A457
#define REG_BK13A4_2C_L      0x13A458
#define REG_BK13A4_2C_H      0x13A459
#define REG_BK13A4_2D_L      0x13A45A
#define REG_BK13A4_2D_H      0x13A45B
#define REG_BK13A4_2E_L      0x13A45C
#define REG_BK13A4_2E_H      0x13A45D
#define REG_BK13A4_2F_L      0x13A45E
#define REG_BK13A4_2F_H      0x13A45F
#define REG_BK13A4_30_L      0x13A460
#define REG_BK13A4_30_H      0x13A461
#define REG_BK13A4_31_L      0x13A462
#define REG_BK13A4_31_H      0x13A463
#define REG_BK13A4_32_L      0x13A464
#define REG_BK13A4_32_H      0x13A465
#define REG_BK13A4_33_L      0x13A466
#define REG_BK13A4_33_H      0x13A467
#define REG_BK13A4_34_L      0x13A468
#define REG_BK13A4_34_H      0x13A469
#define REG_BK13A4_35_L      0x13A46A
#define REG_BK13A4_35_H      0x13A46B
#define REG_BK13A4_36_L      0x13A46C
#define REG_BK13A4_36_H      0x13A46D
#define REG_BK13A4_37_L      0x13A46E
#define REG_BK13A4_37_H      0x13A46F
#define REG_BK13A4_38_L      0x13A470
#define REG_BK13A4_38_H      0x13A471
#define REG_BK13A4_39_L      0x13A472
#define REG_BK13A4_39_H      0x13A473
#define REG_BK13A4_3A_L      0x13A474
#define REG_BK13A4_3A_H      0x13A475
#define REG_BK13A4_3B_L      0x13A476
#define REG_BK13A4_3B_H      0x13A477
#define REG_BK13A4_3C_L      0x13A478
#define REG_BK13A4_3C_H      0x13A479
#define REG_BK13A4_3D_L      0x13A47A
#define REG_BK13A4_3D_H      0x13A47B
#define REG_BK13A4_3E_L      0x13A47C
#define REG_BK13A4_3E_H      0x13A47D
#define REG_BK13A4_3F_L      0x13A47E
#define REG_BK13A4_3F_H      0x13A47F
#define REG_BK13A4_40_L      0x13A480
#define REG_BK13A4_40_H      0x13A481
#define REG_BK13A4_41_L      0x13A482
#define REG_BK13A4_41_H      0x13A483
#define REG_BK13A4_42_L      0x13A484
#define REG_BK13A4_42_H      0x13A485
#define REG_BK13A4_43_L      0x13A486
#define REG_BK13A4_43_H      0x13A487
#define REG_BK13A4_44_L      0x13A488
#define REG_BK13A4_44_H      0x13A489
#define REG_BK13A4_45_L      0x13A48A
#define REG_BK13A4_45_H      0x13A48B
#define REG_BK13A4_46_L      0x13A48C
#define REG_BK13A4_46_H      0x13A48D
#define REG_BK13A4_47_L      0x13A48E
#define REG_BK13A4_47_H      0x13A48F
#define REG_BK13A4_48_L      0x13A490
#define REG_BK13A4_48_H      0x13A491
#define REG_BK13A4_49_L      0x13A492
#define REG_BK13A4_49_H      0x13A493
#define REG_BK13A4_4A_L      0x13A494
#define REG_BK13A4_4A_H      0x13A495
#define REG_BK13A4_4B_L      0x13A496
#define REG_BK13A4_4B_H      0x13A497
#define REG_BK13A4_4C_L      0x13A498
#define REG_BK13A4_4C_H      0x13A499
#define REG_BK13A4_4D_L      0x13A49A
#define REG_BK13A4_4D_H      0x13A49B
#define REG_BK13A4_4E_L      0x13A49C
#define REG_BK13A4_4E_H      0x13A49D
#define REG_BK13A4_4F_L      0x13A49E
#define REG_BK13A4_4F_H      0x13A49F
#define REG_BK13A4_50_L      0x13A4A0
#define REG_BK13A4_50_H      0x13A4A1
#define REG_BK13A4_51_L      0x13A4A2
#define REG_BK13A4_51_H      0x13A4A3
#define REG_BK13A4_52_L      0x13A4A4
#define REG_BK13A4_52_H      0x13A4A5
#define REG_BK13A4_53_L      0x13A4A6
#define REG_BK13A4_53_H      0x13A4A7
#define REG_BK13A4_54_L      0x13A4A8
#define REG_BK13A4_54_H      0x13A4A9
#define REG_BK13A4_55_L      0x13A4AA
#define REG_BK13A4_55_H      0x13A4AB
#define REG_BK13A4_56_L      0x13A4AC
#define REG_BK13A4_56_H      0x13A4AD
#define REG_BK13A4_57_L      0x13A4AE
#define REG_BK13A4_57_H      0x13A4AF
#define REG_BK13A4_58_L      0x13A4B0
#define REG_BK13A4_58_H      0x13A4B1
#define REG_BK13A4_59_L      0x13A4B2
#define REG_BK13A4_59_H      0x13A4B3
#define REG_BK13A4_5A_L      0x13A4B4
#define REG_BK13A4_5A_H      0x13A4B5
#define REG_BK13A4_5B_L      0x13A4B6
#define REG_BK13A4_5B_H      0x13A4B7
#define REG_BK13A4_5C_L      0x13A4B8
#define REG_BK13A4_5C_H      0x13A4B9
#define REG_BK13A4_5D_L      0x13A4BA
#define REG_BK13A4_5D_H      0x13A4BB
#define REG_BK13A4_5E_L      0x13A4BC
#define REG_BK13A4_5E_H      0x13A4BD
#define REG_BK13A4_5F_L      0x13A4BE
#define REG_BK13A4_5F_H      0x13A4BF
#define REG_BK13A4_60_L      0x13A4C0
#define REG_BK13A4_60_H      0x13A4C1
#define REG_BK13A4_61_L      0x13A4C2
#define REG_BK13A4_61_H      0x13A4C3
#define REG_BK13A4_62_L      0x13A4C4
#define REG_BK13A4_62_H      0x13A4C5
#define REG_BK13A4_63_L      0x13A4C6
#define REG_BK13A4_63_H      0x13A4C7
#define REG_BK13A4_64_L      0x13A4C8
#define REG_BK13A4_64_H      0x13A4C9
#define REG_BK13A4_65_L      0x13A4CA
#define REG_BK13A4_65_H      0x13A4CB
#define REG_BK13A4_66_L      0x13A4CC
#define REG_BK13A4_66_H      0x13A4CD
#define REG_BK13A4_67_L      0x13A4CE
#define REG_BK13A4_67_H      0x13A4CF
#define REG_BK13A4_68_L      0x13A4D0
#define REG_BK13A4_68_H      0x13A4D1
#define REG_BK13A4_69_L      0x13A4D2
#define REG_BK13A4_69_H      0x13A4D3
#define REG_BK13A4_6A_L      0x13A4D4
#define REG_BK13A4_6A_H      0x13A4D5
#define REG_BK13A4_6B_L      0x13A4D6
#define REG_BK13A4_6B_H      0x13A4D7
#define REG_BK13A4_6C_L      0x13A4D8
#define REG_BK13A4_6C_H      0x13A4D9
#define REG_BK13A4_6D_L      0x13A4DA
#define REG_BK13A4_6D_H      0x13A4DB
#define REG_BK13A4_6E_L      0x13A4DC
#define REG_BK13A4_6E_H      0x13A4DD
#define REG_BK13A4_6F_L      0x13A4DE
#define REG_BK13A4_6F_H      0x13A4DF
#define REG_BK13A4_70_L      0x13A4E0
#define REG_BK13A4_70_H      0x13A4E1
#define REG_BK13A4_71_L      0x13A4E2
#define REG_BK13A4_71_H      0x13A4E3
#define REG_BK13A4_72_L      0x13A4E4
#define REG_BK13A4_72_H      0x13A4E5
#define REG_BK13A4_73_L      0x13A4E6
#define REG_BK13A4_73_H      0x13A4E7
#define REG_BK13A4_74_L      0x13A4E8
#define REG_BK13A4_74_H      0x13A4E9
#define REG_BK13A4_75_L      0x13A4EA
#define REG_BK13A4_75_H      0x13A4EB
#define REG_BK13A4_76_L      0x13A4EC
#define REG_BK13A4_76_H      0x13A4ED
#define REG_BK13A4_77_L      0x13A4EE
#define REG_BK13A4_77_H      0x13A4EF
#define REG_BK13A4_78_L      0x13A4F0
#define REG_BK13A4_78_H      0x13A4F1
#define REG_BK13A4_79_L      0x13A4F2
#define REG_BK13A4_79_H      0x13A4F3
#define REG_BK13A4_7A_L      0x13A4F4
#define REG_BK13A4_7A_H      0x13A4F5
#define REG_BK13A4_7B_L      0x13A4F6
#define REG_BK13A4_7B_H      0x13A4F7
#define REG_BK13A4_7C_L      0x13A4F8
#define REG_BK13A4_7C_H      0x13A4F9
#define REG_BK13A4_7D_L      0x13A4FA
#define REG_BK13A4_7D_H      0x13A4FB
#define REG_BK13A4_7E_L      0x13A4FC
#define REG_BK13A4_7E_H      0x13A4FD
#define REG_BK13A4_7F_L      0x13A4FE
#define REG_BK13A4_7F_H      0x13A4FF
//----------------------------------------------
#define REG_BK13A5_00_L      0x13A500
#define REG_BK13A5_00_H      0x13A501
#define REG_BK13A5_01_L      0x13A502
#define REG_BK13A5_01_H      0x13A503
#define REG_BK13A5_02_L      0x13A504
#define REG_BK13A5_02_H      0x13A505
#define REG_BK13A5_03_L      0x13A506
#define REG_BK13A5_03_H      0x13A507
#define REG_BK13A5_04_L      0x13A508
#define REG_BK13A5_04_H      0x13A509
#define REG_BK13A5_05_L      0x13A50A
#define REG_BK13A5_05_H      0x13A50B
#define REG_BK13A5_06_L      0x13A50C
#define REG_BK13A5_06_H      0x13A50D
#define REG_BK13A5_07_L      0x13A50E
#define REG_BK13A5_07_H      0x13A50F
#define REG_BK13A5_08_L      0x13A510
#define REG_BK13A5_08_H      0x13A511
#define REG_BK13A5_09_L      0x13A512
#define REG_BK13A5_09_H      0x13A513
#define REG_BK13A5_0A_L      0x13A514
#define REG_BK13A5_0A_H      0x13A515
#define REG_BK13A5_0B_L      0x13A516
#define REG_BK13A5_0B_H      0x13A517
#define REG_BK13A5_0C_L      0x13A518
#define REG_BK13A5_0C_H      0x13A519
#define REG_BK13A5_0D_L      0x13A51A
#define REG_BK13A5_0D_H      0x13A51B
#define REG_BK13A5_0E_L      0x13A51C
#define REG_BK13A5_0E_H      0x13A51D
#define REG_BK13A5_0F_L      0x13A51E
#define REG_BK13A5_0F_H      0x13A51F
#define REG_BK13A5_10_L      0x13A520
#define REG_BK13A5_10_H      0x13A521
#define REG_BK13A5_11_L      0x13A522
#define REG_BK13A5_11_H      0x13A523
#define REG_BK13A5_12_L      0x13A524
#define REG_BK13A5_12_H      0x13A525
#define REG_BK13A5_13_L      0x13A526
#define REG_BK13A5_13_H      0x13A527
#define REG_BK13A5_14_L      0x13A528
#define REG_BK13A5_14_H      0x13A529
#define REG_BK13A5_15_L      0x13A52A
#define REG_BK13A5_15_H      0x13A52B
#define REG_BK13A5_16_L      0x13A52C
#define REG_BK13A5_16_H      0x13A52D
#define REG_BK13A5_17_L      0x13A52E
#define REG_BK13A5_17_H      0x13A52F
#define REG_BK13A5_18_L      0x13A530
#define REG_BK13A5_18_H      0x13A531
#define REG_BK13A5_19_L      0x13A532
#define REG_BK13A5_19_H      0x13A533
#define REG_BK13A5_1A_L      0x13A534
#define REG_BK13A5_1A_H      0x13A535
#define REG_BK13A5_1B_L      0x13A536
#define REG_BK13A5_1B_H      0x13A537
#define REG_BK13A5_1C_L      0x13A538
#define REG_BK13A5_1C_H      0x13A539
#define REG_BK13A5_1D_L      0x13A53A
#define REG_BK13A5_1D_H      0x13A53B
#define REG_BK13A5_1E_L      0x13A53C
#define REG_BK13A5_1E_H      0x13A53D
#define REG_BK13A5_1F_L      0x13A53E
#define REG_BK13A5_1F_H      0x13A53F
#define REG_BK13A5_20_L      0x13A540
#define REG_BK13A5_20_H      0x13A541
#define REG_BK13A5_21_L      0x13A542
#define REG_BK13A5_21_H      0x13A543
#define REG_BK13A5_22_L      0x13A544
#define REG_BK13A5_22_H      0x13A545
#define REG_BK13A5_23_L      0x13A546
#define REG_BK13A5_23_H      0x13A547
#define REG_BK13A5_24_L      0x13A548
#define REG_BK13A5_24_H      0x13A549
#define REG_BK13A5_25_L      0x13A54A
#define REG_BK13A5_25_H      0x13A54B
#define REG_BK13A5_26_L      0x13A54C
#define REG_BK13A5_26_H      0x13A54D
#define REG_BK13A5_27_L      0x13A54E
#define REG_BK13A5_27_H      0x13A54F
#define REG_BK13A5_28_L      0x13A550
#define REG_BK13A5_28_H      0x13A551
#define REG_BK13A5_29_L      0x13A552
#define REG_BK13A5_29_H      0x13A553
#define REG_BK13A5_2A_L      0x13A554
#define REG_BK13A5_2A_H      0x13A555
#define REG_BK13A5_2B_L      0x13A556
#define REG_BK13A5_2B_H      0x13A557
#define REG_BK13A5_2C_L      0x13A558
#define REG_BK13A5_2C_H      0x13A559
#define REG_BK13A5_2D_L      0x13A55A
#define REG_BK13A5_2D_H      0x13A55B
#define REG_BK13A5_2E_L      0x13A55C
#define REG_BK13A5_2E_H      0x13A55D
#define REG_BK13A5_2F_L      0x13A55E
#define REG_BK13A5_2F_H      0x13A55F
#define REG_BK13A5_30_L      0x13A560
#define REG_BK13A5_30_H      0x13A561
#define REG_BK13A5_31_L      0x13A562
#define REG_BK13A5_31_H      0x13A563
#define REG_BK13A5_32_L      0x13A564
#define REG_BK13A5_32_H      0x13A565
#define REG_BK13A5_33_L      0x13A566
#define REG_BK13A5_33_H      0x13A567
#define REG_BK13A5_34_L      0x13A568
#define REG_BK13A5_34_H      0x13A569
#define REG_BK13A5_35_L      0x13A56A
#define REG_BK13A5_35_H      0x13A56B
#define REG_BK13A5_36_L      0x13A56C
#define REG_BK13A5_36_H      0x13A56D
#define REG_BK13A5_37_L      0x13A56E
#define REG_BK13A5_37_H      0x13A56F
#define REG_BK13A5_38_L      0x13A570
#define REG_BK13A5_38_H      0x13A571
#define REG_BK13A5_39_L      0x13A572
#define REG_BK13A5_39_H      0x13A573
#define REG_BK13A5_3A_L      0x13A574
#define REG_BK13A5_3A_H      0x13A575
#define REG_BK13A5_3B_L      0x13A576
#define REG_BK13A5_3B_H      0x13A577
#define REG_BK13A5_3C_L      0x13A578
#define REG_BK13A5_3C_H      0x13A579
#define REG_BK13A5_3D_L      0x13A57A
#define REG_BK13A5_3D_H      0x13A57B
#define REG_BK13A5_3E_L      0x13A57C
#define REG_BK13A5_3E_H      0x13A57D
#define REG_BK13A5_3F_L      0x13A57E
#define REG_BK13A5_3F_H      0x13A57F
#define REG_BK13A5_40_L      0x13A580
#define REG_BK13A5_40_H      0x13A581
#define REG_BK13A5_41_L      0x13A582
#define REG_BK13A5_41_H      0x13A583
#define REG_BK13A5_42_L      0x13A584
#define REG_BK13A5_42_H      0x13A585
#define REG_BK13A5_43_L      0x13A586
#define REG_BK13A5_43_H      0x13A587
#define REG_BK13A5_44_L      0x13A588
#define REG_BK13A5_44_H      0x13A589
#define REG_BK13A5_45_L      0x13A58A
#define REG_BK13A5_45_H      0x13A58B
#define REG_BK13A5_46_L      0x13A58C
#define REG_BK13A5_46_H      0x13A58D
#define REG_BK13A5_47_L      0x13A58E
#define REG_BK13A5_47_H      0x13A58F
#define REG_BK13A5_48_L      0x13A590
#define REG_BK13A5_48_H      0x13A591
#define REG_BK13A5_49_L      0x13A592
#define REG_BK13A5_49_H      0x13A593
#define REG_BK13A5_4A_L      0x13A594
#define REG_BK13A5_4A_H      0x13A595
#define REG_BK13A5_4B_L      0x13A596
#define REG_BK13A5_4B_H      0x13A597
#define REG_BK13A5_4C_L      0x13A598
#define REG_BK13A5_4C_H      0x13A599
#define REG_BK13A5_4D_L      0x13A59A
#define REG_BK13A5_4D_H      0x13A59B
#define REG_BK13A5_4E_L      0x13A59C
#define REG_BK13A5_4E_H      0x13A59D
#define REG_BK13A5_4F_L      0x13A59E
#define REG_BK13A5_4F_H      0x13A59F
#define REG_BK13A5_50_L      0x13A5A0
#define REG_BK13A5_50_H      0x13A5A1
#define REG_BK13A5_51_L      0x13A5A2
#define REG_BK13A5_51_H      0x13A5A3
#define REG_BK13A5_52_L      0x13A5A4
#define REG_BK13A5_52_H      0x13A5A5
#define REG_BK13A5_53_L      0x13A5A6
#define REG_BK13A5_53_H      0x13A5A7
#define REG_BK13A5_54_L      0x13A5A8
#define REG_BK13A5_54_H      0x13A5A9
#define REG_BK13A5_55_L      0x13A5AA
#define REG_BK13A5_55_H      0x13A5AB
#define REG_BK13A5_56_L      0x13A5AC
#define REG_BK13A5_56_H      0x13A5AD
#define REG_BK13A5_57_L      0x13A5AE
#define REG_BK13A5_57_H      0x13A5AF
#define REG_BK13A5_58_L      0x13A5B0
#define REG_BK13A5_58_H      0x13A5B1
#define REG_BK13A5_59_L      0x13A5B2
#define REG_BK13A5_59_H      0x13A5B3
#define REG_BK13A5_5A_L      0x13A5B4
#define REG_BK13A5_5A_H      0x13A5B5
#define REG_BK13A5_5B_L      0x13A5B6
#define REG_BK13A5_5B_H      0x13A5B7
#define REG_BK13A5_5C_L      0x13A5B8
#define REG_BK13A5_5C_H      0x13A5B9
#define REG_BK13A5_5D_L      0x13A5BA
#define REG_BK13A5_5D_H      0x13A5BB
#define REG_BK13A5_5E_L      0x13A5BC
#define REG_BK13A5_5E_H      0x13A5BD
#define REG_BK13A5_5F_L      0x13A5BE
#define REG_BK13A5_5F_H      0x13A5BF
#define REG_BK13A5_60_L      0x13A5C0
#define REG_BK13A5_60_H      0x13A5C1
#define REG_BK13A5_61_L      0x13A5C2
#define REG_BK13A5_61_H      0x13A5C3
#define REG_BK13A5_62_L      0x13A5C4
#define REG_BK13A5_62_H      0x13A5C5
#define REG_BK13A5_63_L      0x13A5C6
#define REG_BK13A5_63_H      0x13A5C7
#define REG_BK13A5_64_L      0x13A5C8
#define REG_BK13A5_64_H      0x13A5C9
#define REG_BK13A5_65_L      0x13A5CA
#define REG_BK13A5_65_H      0x13A5CB
#define REG_BK13A5_66_L      0x13A5CC
#define REG_BK13A5_66_H      0x13A5CD
#define REG_BK13A5_67_L      0x13A5CE
#define REG_BK13A5_67_H      0x13A5CF
#define REG_BK13A5_68_L      0x13A5D0
#define REG_BK13A5_68_H      0x13A5D1
#define REG_BK13A5_69_L      0x13A5D2
#define REG_BK13A5_69_H      0x13A5D3
#define REG_BK13A5_6A_L      0x13A5D4
#define REG_BK13A5_6A_H      0x13A5D5
#define REG_BK13A5_6B_L      0x13A5D6
#define REG_BK13A5_6B_H      0x13A5D7
#define REG_BK13A5_6C_L      0x13A5D8
#define REG_BK13A5_6C_H      0x13A5D9
#define REG_BK13A5_6D_L      0x13A5DA
#define REG_BK13A5_6D_H      0x13A5DB
#define REG_BK13A5_6E_L      0x13A5DC
#define REG_BK13A5_6E_H      0x13A5DD
#define REG_BK13A5_6F_L      0x13A5DE
#define REG_BK13A5_6F_H      0x13A5DF
#define REG_BK13A5_70_L      0x13A5E0
#define REG_BK13A5_70_H      0x13A5E1
#define REG_BK13A5_71_L      0x13A5E2
#define REG_BK13A5_71_H      0x13A5E3
#define REG_BK13A5_72_L      0x13A5E4
#define REG_BK13A5_72_H      0x13A5E5
#define REG_BK13A5_73_L      0x13A5E6
#define REG_BK13A5_73_H      0x13A5E7
#define REG_BK13A5_74_L      0x13A5E8
#define REG_BK13A5_74_H      0x13A5E9
#define REG_BK13A5_75_L      0x13A5EA
#define REG_BK13A5_75_H      0x13A5EB
#define REG_BK13A5_76_L      0x13A5EC
#define REG_BK13A5_76_H      0x13A5ED
#define REG_BK13A5_77_L      0x13A5EE
#define REG_BK13A5_77_H      0x13A5EF
#define REG_BK13A5_78_L      0x13A5F0
#define REG_BK13A5_78_H      0x13A5F1
#define REG_BK13A5_79_L      0x13A5F2
#define REG_BK13A5_79_H      0x13A5F3
#define REG_BK13A5_7A_L      0x13A5F4
#define REG_BK13A5_7A_H      0x13A5F5
#define REG_BK13A5_7B_L      0x13A5F6
#define REG_BK13A5_7B_H      0x13A5F7
#define REG_BK13A5_7C_L      0x13A5F8
#define REG_BK13A5_7C_H      0x13A5F9
#define REG_BK13A5_7D_L      0x13A5FA
#define REG_BK13A5_7D_H      0x13A5FB
#define REG_BK13A5_7E_L      0x13A5FC
#define REG_BK13A5_7E_H      0x13A5FD
#define REG_BK13A5_7F_L      0x13A5FE
#define REG_BK13A5_7F_H      0x13A5FF
//----------------------------------------------
#define REG_BK13A6_00_L      0x13A600
#define REG_BK13A6_00_H      0x13A601
#define REG_BK13A6_01_L      0x13A602
#define REG_BK13A6_01_H      0x13A603
#define REG_BK13A6_02_L      0x13A604
#define REG_BK13A6_02_H      0x13A605
#define REG_BK13A6_03_L      0x13A606
#define REG_BK13A6_03_H      0x13A607
#define REG_BK13A6_04_L      0x13A608
#define REG_BK13A6_04_H      0x13A609
#define REG_BK13A6_05_L      0x13A60A
#define REG_BK13A6_05_H      0x13A60B
#define REG_BK13A6_06_L      0x13A60C
#define REG_BK13A6_06_H      0x13A60D
#define REG_BK13A6_07_L      0x13A60E
#define REG_BK13A6_07_H      0x13A60F
#define REG_BK13A6_08_L      0x13A610
#define REG_BK13A6_08_H      0x13A611
#define REG_BK13A6_09_L      0x13A612
#define REG_BK13A6_09_H      0x13A613
#define REG_BK13A6_0A_L      0x13A614
#define REG_BK13A6_0A_H      0x13A615
#define REG_BK13A6_0B_L      0x13A616
#define REG_BK13A6_0B_H      0x13A617
#define REG_BK13A6_0C_L      0x13A618
#define REG_BK13A6_0C_H      0x13A619
#define REG_BK13A6_0D_L      0x13A61A
#define REG_BK13A6_0D_H      0x13A61B
#define REG_BK13A6_0E_L      0x13A61C
#define REG_BK13A6_0E_H      0x13A61D
#define REG_BK13A6_0F_L      0x13A61E
#define REG_BK13A6_0F_H      0x13A61F
#define REG_BK13A6_10_L      0x13A620
#define REG_BK13A6_10_H      0x13A621
#define REG_BK13A6_11_L      0x13A622
#define REG_BK13A6_11_H      0x13A623
#define REG_BK13A6_12_L      0x13A624
#define REG_BK13A6_12_H      0x13A625
#define REG_BK13A6_13_L      0x13A626
#define REG_BK13A6_13_H      0x13A627
#define REG_BK13A6_14_L      0x13A628
#define REG_BK13A6_14_H      0x13A629
#define REG_BK13A6_15_L      0x13A62A
#define REG_BK13A6_15_H      0x13A62B
#define REG_BK13A6_16_L      0x13A62C
#define REG_BK13A6_16_H      0x13A62D
#define REG_BK13A6_17_L      0x13A62E
#define REG_BK13A6_17_H      0x13A62F
#define REG_BK13A6_18_L      0x13A630
#define REG_BK13A6_18_H      0x13A631
#define REG_BK13A6_19_L      0x13A632
#define REG_BK13A6_19_H      0x13A633
#define REG_BK13A6_1A_L      0x13A634
#define REG_BK13A6_1A_H      0x13A635
#define REG_BK13A6_1B_L      0x13A636
#define REG_BK13A6_1B_H      0x13A637
#define REG_BK13A6_1C_L      0x13A638
#define REG_BK13A6_1C_H      0x13A639
#define REG_BK13A6_1D_L      0x13A63A
#define REG_BK13A6_1D_H      0x13A63B
#define REG_BK13A6_1E_L      0x13A63C
#define REG_BK13A6_1E_H      0x13A63D
#define REG_BK13A6_1F_L      0x13A63E
#define REG_BK13A6_1F_H      0x13A63F
#define REG_BK13A6_20_L      0x13A640
#define REG_BK13A6_20_H      0x13A641
#define REG_BK13A6_21_L      0x13A642
#define REG_BK13A6_21_H      0x13A643
#define REG_BK13A6_22_L      0x13A644
#define REG_BK13A6_22_H      0x13A645
#define REG_BK13A6_23_L      0x13A646
#define REG_BK13A6_23_H      0x13A647
#define REG_BK13A6_24_L      0x13A648
#define REG_BK13A6_24_H      0x13A649
#define REG_BK13A6_25_L      0x13A64A
#define REG_BK13A6_25_H      0x13A64B
#define REG_BK13A6_26_L      0x13A64C
#define REG_BK13A6_26_H      0x13A64D
#define REG_BK13A6_27_L      0x13A64E
#define REG_BK13A6_27_H      0x13A64F
#define REG_BK13A6_28_L      0x13A650
#define REG_BK13A6_28_H      0x13A651
#define REG_BK13A6_29_L      0x13A652
#define REG_BK13A6_29_H      0x13A653
#define REG_BK13A6_2A_L      0x13A654
#define REG_BK13A6_2A_H      0x13A655
#define REG_BK13A6_2B_L      0x13A656
#define REG_BK13A6_2B_H      0x13A657
#define REG_BK13A6_2C_L      0x13A658
#define REG_BK13A6_2C_H      0x13A659
#define REG_BK13A6_2D_L      0x13A65A
#define REG_BK13A6_2D_H      0x13A65B
#define REG_BK13A6_2E_L      0x13A65C
#define REG_BK13A6_2E_H      0x13A65D
#define REG_BK13A6_2F_L      0x13A65E
#define REG_BK13A6_2F_H      0x13A65F
#define REG_BK13A6_30_L      0x13A660
#define REG_BK13A6_30_H      0x13A661
#define REG_BK13A6_31_L      0x13A662
#define REG_BK13A6_31_H      0x13A663
#define REG_BK13A6_32_L      0x13A664
#define REG_BK13A6_32_H      0x13A665
#define REG_BK13A6_33_L      0x13A666
#define REG_BK13A6_33_H      0x13A667
#define REG_BK13A6_34_L      0x13A668
#define REG_BK13A6_34_H      0x13A669
#define REG_BK13A6_35_L      0x13A66A
#define REG_BK13A6_35_H      0x13A66B
#define REG_BK13A6_36_L      0x13A66C
#define REG_BK13A6_36_H      0x13A66D
#define REG_BK13A6_37_L      0x13A66E
#define REG_BK13A6_37_H      0x13A66F
#define REG_BK13A6_38_L      0x13A670
#define REG_BK13A6_38_H      0x13A671
#define REG_BK13A6_39_L      0x13A672
#define REG_BK13A6_39_H      0x13A673
#define REG_BK13A6_3A_L      0x13A674
#define REG_BK13A6_3A_H      0x13A675
#define REG_BK13A6_3B_L      0x13A676
#define REG_BK13A6_3B_H      0x13A677
#define REG_BK13A6_3C_L      0x13A678
#define REG_BK13A6_3C_H      0x13A679
#define REG_BK13A6_3D_L      0x13A67A
#define REG_BK13A6_3D_H      0x13A67B
#define REG_BK13A6_3E_L      0x13A67C
#define REG_BK13A6_3E_H      0x13A67D
#define REG_BK13A6_3F_L      0x13A67E
#define REG_BK13A6_3F_H      0x13A67F
#define REG_BK13A6_40_L      0x13A680
#define REG_BK13A6_40_H      0x13A681
#define REG_BK13A6_41_L      0x13A682
#define REG_BK13A6_41_H      0x13A683
#define REG_BK13A6_42_L      0x13A684
#define REG_BK13A6_42_H      0x13A685
#define REG_BK13A6_43_L      0x13A686
#define REG_BK13A6_43_H      0x13A687
#define REG_BK13A6_44_L      0x13A688
#define REG_BK13A6_44_H      0x13A689
#define REG_BK13A6_45_L      0x13A68A
#define REG_BK13A6_45_H      0x13A68B
#define REG_BK13A6_46_L      0x13A68C
#define REG_BK13A6_46_H      0x13A68D
#define REG_BK13A6_47_L      0x13A68E
#define REG_BK13A6_47_H      0x13A68F
#define REG_BK13A6_48_L      0x13A690
#define REG_BK13A6_48_H      0x13A691
#define REG_BK13A6_49_L      0x13A692
#define REG_BK13A6_49_H      0x13A693
#define REG_BK13A6_4A_L      0x13A694
#define REG_BK13A6_4A_H      0x13A695
#define REG_BK13A6_4B_L      0x13A696
#define REG_BK13A6_4B_H      0x13A697
#define REG_BK13A6_4C_L      0x13A698
#define REG_BK13A6_4C_H      0x13A699
#define REG_BK13A6_4D_L      0x13A69A
#define REG_BK13A6_4D_H      0x13A69B
#define REG_BK13A6_4E_L      0x13A69C
#define REG_BK13A6_4E_H      0x13A69D
#define REG_BK13A6_4F_L      0x13A69E
#define REG_BK13A6_4F_H      0x13A69F
#define REG_BK13A6_50_L      0x13A6A0
#define REG_BK13A6_50_H      0x13A6A1
#define REG_BK13A6_51_L      0x13A6A2
#define REG_BK13A6_51_H      0x13A6A3
#define REG_BK13A6_52_L      0x13A6A4
#define REG_BK13A6_52_H      0x13A6A5
#define REG_BK13A6_53_L      0x13A6A6
#define REG_BK13A6_53_H      0x13A6A7
#define REG_BK13A6_54_L      0x13A6A8
#define REG_BK13A6_54_H      0x13A6A9
#define REG_BK13A6_55_L      0x13A6AA
#define REG_BK13A6_55_H      0x13A6AB
#define REG_BK13A6_56_L      0x13A6AC
#define REG_BK13A6_56_H      0x13A6AD
#define REG_BK13A6_57_L      0x13A6AE
#define REG_BK13A6_57_H      0x13A6AF
#define REG_BK13A6_58_L      0x13A6B0
#define REG_BK13A6_58_H      0x13A6B1
#define REG_BK13A6_59_L      0x13A6B2
#define REG_BK13A6_59_H      0x13A6B3
#define REG_BK13A6_5A_L      0x13A6B4
#define REG_BK13A6_5A_H      0x13A6B5
#define REG_BK13A6_5B_L      0x13A6B6
#define REG_BK13A6_5B_H      0x13A6B7
#define REG_BK13A6_5C_L      0x13A6B8
#define REG_BK13A6_5C_H      0x13A6B9
#define REG_BK13A6_5D_L      0x13A6BA
#define REG_BK13A6_5D_H      0x13A6BB
#define REG_BK13A6_5E_L      0x13A6BC
#define REG_BK13A6_5E_H      0x13A6BD
#define REG_BK13A6_5F_L      0x13A6BE
#define REG_BK13A6_5F_H      0x13A6BF
#define REG_BK13A6_60_L      0x13A6C0
#define REG_BK13A6_60_H      0x13A6C1
#define REG_BK13A6_61_L      0x13A6C2
#define REG_BK13A6_61_H      0x13A6C3
#define REG_BK13A6_62_L      0x13A6C4
#define REG_BK13A6_62_H      0x13A6C5
#define REG_BK13A6_63_L      0x13A6C6
#define REG_BK13A6_63_H      0x13A6C7
#define REG_BK13A6_64_L      0x13A6C8
#define REG_BK13A6_64_H      0x13A6C9
#define REG_BK13A6_65_L      0x13A6CA
#define REG_BK13A6_65_H      0x13A6CB
#define REG_BK13A6_66_L      0x13A6CC
#define REG_BK13A6_66_H      0x13A6CD
#define REG_BK13A6_67_L      0x13A6CE
#define REG_BK13A6_67_H      0x13A6CF
#define REG_BK13A6_68_L      0x13A6D0
#define REG_BK13A6_68_H      0x13A6D1
#define REG_BK13A6_69_L      0x13A6D2
#define REG_BK13A6_69_H      0x13A6D3
#define REG_BK13A6_6A_L      0x13A6D4
#define REG_BK13A6_6A_H      0x13A6D5
#define REG_BK13A6_6B_L      0x13A6D6
#define REG_BK13A6_6B_H      0x13A6D7
#define REG_BK13A6_6C_L      0x13A6D8
#define REG_BK13A6_6C_H      0x13A6D9
#define REG_BK13A6_6D_L      0x13A6DA
#define REG_BK13A6_6D_H      0x13A6DB
#define REG_BK13A6_6E_L      0x13A6DC
#define REG_BK13A6_6E_H      0x13A6DD
#define REG_BK13A6_6F_L      0x13A6DE
#define REG_BK13A6_6F_H      0x13A6DF
#define REG_BK13A6_70_L      0x13A6E0
#define REG_BK13A6_70_H      0x13A6E1
#define REG_BK13A6_71_L      0x13A6E2
#define REG_BK13A6_71_H      0x13A6E3
#define REG_BK13A6_72_L      0x13A6E4
#define REG_BK13A6_72_H      0x13A6E5
#define REG_BK13A6_73_L      0x13A6E6
#define REG_BK13A6_73_H      0x13A6E7
#define REG_BK13A6_74_L      0x13A6E8
#define REG_BK13A6_74_H      0x13A6E9
#define REG_BK13A6_75_L      0x13A6EA
#define REG_BK13A6_75_H      0x13A6EB
#define REG_BK13A6_76_L      0x13A6EC
#define REG_BK13A6_76_H      0x13A6ED
#define REG_BK13A6_77_L      0x13A6EE
#define REG_BK13A6_77_H      0x13A6EF
#define REG_BK13A6_78_L      0x13A6F0
#define REG_BK13A6_78_H      0x13A6F1
#define REG_BK13A6_79_L      0x13A6F2
#define REG_BK13A6_79_H      0x13A6F3
#define REG_BK13A6_7A_L      0x13A6F4
#define REG_BK13A6_7A_H      0x13A6F5
#define REG_BK13A6_7B_L      0x13A6F6
#define REG_BK13A6_7B_H      0x13A6F7
#define REG_BK13A6_7C_L      0x13A6F8
#define REG_BK13A6_7C_H      0x13A6F9
#define REG_BK13A6_7D_L      0x13A6FA
#define REG_BK13A6_7D_H      0x13A6FB
#define REG_BK13A6_7E_L      0x13A6FC
#define REG_BK13A6_7E_H      0x13A6FD
#define REG_BK13A6_7F_L      0x13A6FE
#define REG_BK13A6_7F_H      0x13A6FF
//----------------------------------------------
#define REG_BK13A7_00_L      0x13A700
#define REG_BK13A7_00_H      0x13A701
#define REG_BK13A7_01_L      0x13A702
#define REG_BK13A7_01_H      0x13A703
#define REG_BK13A7_02_L      0x13A704
#define REG_BK13A7_02_H      0x13A705
#define REG_BK13A7_03_L      0x13A706
#define REG_BK13A7_03_H      0x13A707
#define REG_BK13A7_04_L      0x13A708
#define REG_BK13A7_04_H      0x13A709
#define REG_BK13A7_05_L      0x13A70A
#define REG_BK13A7_05_H      0x13A70B
#define REG_BK13A7_06_L      0x13A70C
#define REG_BK13A7_06_H      0x13A70D
#define REG_BK13A7_07_L      0x13A70E
#define REG_BK13A7_07_H      0x13A70F
#define REG_BK13A7_08_L      0x13A710
#define REG_BK13A7_08_H      0x13A711
#define REG_BK13A7_09_L      0x13A712
#define REG_BK13A7_09_H      0x13A713
#define REG_BK13A7_0A_L      0x13A714
#define REG_BK13A7_0A_H      0x13A715
#define REG_BK13A7_0B_L      0x13A716
#define REG_BK13A7_0B_H      0x13A717
#define REG_BK13A7_0C_L      0x13A718
#define REG_BK13A7_0C_H      0x13A719
#define REG_BK13A7_0D_L      0x13A71A
#define REG_BK13A7_0D_H      0x13A71B
#define REG_BK13A7_0E_L      0x13A71C
#define REG_BK13A7_0E_H      0x13A71D
#define REG_BK13A7_0F_L      0x13A71E
#define REG_BK13A7_0F_H      0x13A71F
#define REG_BK13A7_10_L      0x13A720
#define REG_BK13A7_10_H      0x13A721
#define REG_BK13A7_11_L      0x13A722
#define REG_BK13A7_11_H      0x13A723
#define REG_BK13A7_12_L      0x13A724
#define REG_BK13A7_12_H      0x13A725
#define REG_BK13A7_13_L      0x13A726
#define REG_BK13A7_13_H      0x13A727
#define REG_BK13A7_14_L      0x13A728
#define REG_BK13A7_14_H      0x13A729
#define REG_BK13A7_15_L      0x13A72A
#define REG_BK13A7_15_H      0x13A72B
#define REG_BK13A7_16_L      0x13A72C
#define REG_BK13A7_16_H      0x13A72D
#define REG_BK13A7_17_L      0x13A72E
#define REG_BK13A7_17_H      0x13A72F
#define REG_BK13A7_18_L      0x13A730
#define REG_BK13A7_18_H      0x13A731
#define REG_BK13A7_19_L      0x13A732
#define REG_BK13A7_19_H      0x13A733
#define REG_BK13A7_1A_L      0x13A734
#define REG_BK13A7_1A_H      0x13A735
#define REG_BK13A7_1B_L      0x13A736
#define REG_BK13A7_1B_H      0x13A737
#define REG_BK13A7_1C_L      0x13A738
#define REG_BK13A7_1C_H      0x13A739
#define REG_BK13A7_1D_L      0x13A73A
#define REG_BK13A7_1D_H      0x13A73B
#define REG_BK13A7_1E_L      0x13A73C
#define REG_BK13A7_1E_H      0x13A73D
#define REG_BK13A7_1F_L      0x13A73E
#define REG_BK13A7_1F_H      0x13A73F
#define REG_BK13A7_20_L      0x13A740
#define REG_BK13A7_20_H      0x13A741
#define REG_BK13A7_21_L      0x13A742
#define REG_BK13A7_21_H      0x13A743
#define REG_BK13A7_22_L      0x13A744
#define REG_BK13A7_22_H      0x13A745
#define REG_BK13A7_23_L      0x13A746
#define REG_BK13A7_23_H      0x13A747
#define REG_BK13A7_24_L      0x13A748
#define REG_BK13A7_24_H      0x13A749
#define REG_BK13A7_25_L      0x13A74A
#define REG_BK13A7_25_H      0x13A74B
#define REG_BK13A7_26_L      0x13A74C
#define REG_BK13A7_26_H      0x13A74D
#define REG_BK13A7_27_L      0x13A74E
#define REG_BK13A7_27_H      0x13A74F
#define REG_BK13A7_28_L      0x13A750
#define REG_BK13A7_28_H      0x13A751
#define REG_BK13A7_29_L      0x13A752
#define REG_BK13A7_29_H      0x13A753
#define REG_BK13A7_2A_L      0x13A754
#define REG_BK13A7_2A_H      0x13A755
#define REG_BK13A7_2B_L      0x13A756
#define REG_BK13A7_2B_H      0x13A757
#define REG_BK13A7_2C_L      0x13A758
#define REG_BK13A7_2C_H      0x13A759
#define REG_BK13A7_2D_L      0x13A75A
#define REG_BK13A7_2D_H      0x13A75B
#define REG_BK13A7_2E_L      0x13A75C
#define REG_BK13A7_2E_H      0x13A75D
#define REG_BK13A7_2F_L      0x13A75E
#define REG_BK13A7_2F_H      0x13A75F
#define REG_BK13A7_30_L      0x13A760
#define REG_BK13A7_30_H      0x13A761
#define REG_BK13A7_31_L      0x13A762
#define REG_BK13A7_31_H      0x13A763
#define REG_BK13A7_32_L      0x13A764
#define REG_BK13A7_32_H      0x13A765
#define REG_BK13A7_33_L      0x13A766
#define REG_BK13A7_33_H      0x13A767
#define REG_BK13A7_34_L      0x13A768
#define REG_BK13A7_34_H      0x13A769
#define REG_BK13A7_35_L      0x13A76A
#define REG_BK13A7_35_H      0x13A76B
#define REG_BK13A7_36_L      0x13A76C
#define REG_BK13A7_36_H      0x13A76D
#define REG_BK13A7_37_L      0x13A76E
#define REG_BK13A7_37_H      0x13A76F
#define REG_BK13A7_38_L      0x13A770
#define REG_BK13A7_38_H      0x13A771
#define REG_BK13A7_39_L      0x13A772
#define REG_BK13A7_39_H      0x13A773
#define REG_BK13A7_3A_L      0x13A774
#define REG_BK13A7_3A_H      0x13A775
#define REG_BK13A7_3B_L      0x13A776
#define REG_BK13A7_3B_H      0x13A777
#define REG_BK13A7_3C_L      0x13A778
#define REG_BK13A7_3C_H      0x13A779
#define REG_BK13A7_3D_L      0x13A77A
#define REG_BK13A7_3D_H      0x13A77B
#define REG_BK13A7_3E_L      0x13A77C
#define REG_BK13A7_3E_H      0x13A77D
#define REG_BK13A7_3F_L      0x13A77E
#define REG_BK13A7_3F_H      0x13A77F
#define REG_BK13A7_40_L      0x13A780
#define REG_BK13A7_40_H      0x13A781
#define REG_BK13A7_41_L      0x13A782
#define REG_BK13A7_41_H      0x13A783
#define REG_BK13A7_42_L      0x13A784
#define REG_BK13A7_42_H      0x13A785
#define REG_BK13A7_43_L      0x13A786
#define REG_BK13A7_43_H      0x13A787
#define REG_BK13A7_44_L      0x13A788
#define REG_BK13A7_44_H      0x13A789
#define REG_BK13A7_45_L      0x13A78A
#define REG_BK13A7_45_H      0x13A78B
#define REG_BK13A7_46_L      0x13A78C
#define REG_BK13A7_46_H      0x13A78D
#define REG_BK13A7_47_L      0x13A78E
#define REG_BK13A7_47_H      0x13A78F
#define REG_BK13A7_48_L      0x13A790
#define REG_BK13A7_48_H      0x13A791
#define REG_BK13A7_49_L      0x13A792
#define REG_BK13A7_49_H      0x13A793
#define REG_BK13A7_4A_L      0x13A794
#define REG_BK13A7_4A_H      0x13A795
#define REG_BK13A7_4B_L      0x13A796
#define REG_BK13A7_4B_H      0x13A797
#define REG_BK13A7_4C_L      0x13A798
#define REG_BK13A7_4C_H      0x13A799
#define REG_BK13A7_4D_L      0x13A79A
#define REG_BK13A7_4D_H      0x13A79B
#define REG_BK13A7_4E_L      0x13A79C
#define REG_BK13A7_4E_H      0x13A79D
#define REG_BK13A7_4F_L      0x13A79E
#define REG_BK13A7_4F_H      0x13A79F
#define REG_BK13A7_50_L      0x13A7A0
#define REG_BK13A7_50_H      0x13A7A1
#define REG_BK13A7_51_L      0x13A7A2
#define REG_BK13A7_51_H      0x13A7A3
#define REG_BK13A7_52_L      0x13A7A4
#define REG_BK13A7_52_H      0x13A7A5
#define REG_BK13A7_53_L      0x13A7A6
#define REG_BK13A7_53_H      0x13A7A7
#define REG_BK13A7_54_L      0x13A7A8
#define REG_BK13A7_54_H      0x13A7A9
#define REG_BK13A7_55_L      0x13A7AA
#define REG_BK13A7_55_H      0x13A7AB
#define REG_BK13A7_56_L      0x13A7AC
#define REG_BK13A7_56_H      0x13A7AD
#define REG_BK13A7_57_L      0x13A7AE
#define REG_BK13A7_57_H      0x13A7AF
#define REG_BK13A7_58_L      0x13A7B0
#define REG_BK13A7_58_H      0x13A7B1
#define REG_BK13A7_59_L      0x13A7B2
#define REG_BK13A7_59_H      0x13A7B3
#define REG_BK13A7_5A_L      0x13A7B4
#define REG_BK13A7_5A_H      0x13A7B5
#define REG_BK13A7_5B_L      0x13A7B6
#define REG_BK13A7_5B_H      0x13A7B7
#define REG_BK13A7_5C_L      0x13A7B8
#define REG_BK13A7_5C_H      0x13A7B9
#define REG_BK13A7_5D_L      0x13A7BA
#define REG_BK13A7_5D_H      0x13A7BB
#define REG_BK13A7_5E_L      0x13A7BC
#define REG_BK13A7_5E_H      0x13A7BD
#define REG_BK13A7_5F_L      0x13A7BE
#define REG_BK13A7_5F_H      0x13A7BF
#define REG_BK13A7_60_L      0x13A7C0
#define REG_BK13A7_60_H      0x13A7C1
#define REG_BK13A7_61_L      0x13A7C2
#define REG_BK13A7_61_H      0x13A7C3
#define REG_BK13A7_62_L      0x13A7C4
#define REG_BK13A7_62_H      0x13A7C5
#define REG_BK13A7_63_L      0x13A7C6
#define REG_BK13A7_63_H      0x13A7C7
#define REG_BK13A7_64_L      0x13A7C8
#define REG_BK13A7_64_H      0x13A7C9
#define REG_BK13A7_65_L      0x13A7CA
#define REG_BK13A7_65_H      0x13A7CB
#define REG_BK13A7_66_L      0x13A7CC
#define REG_BK13A7_66_H      0x13A7CD
#define REG_BK13A7_67_L      0x13A7CE
#define REG_BK13A7_67_H      0x13A7CF
#define REG_BK13A7_68_L      0x13A7D0
#define REG_BK13A7_68_H      0x13A7D1
#define REG_BK13A7_69_L      0x13A7D2
#define REG_BK13A7_69_H      0x13A7D3
#define REG_BK13A7_6A_L      0x13A7D4
#define REG_BK13A7_6A_H      0x13A7D5
#define REG_BK13A7_6B_L      0x13A7D6
#define REG_BK13A7_6B_H      0x13A7D7
#define REG_BK13A7_6C_L      0x13A7D8
#define REG_BK13A7_6C_H      0x13A7D9
#define REG_BK13A7_6D_L      0x13A7DA
#define REG_BK13A7_6D_H      0x13A7DB
#define REG_BK13A7_6E_L      0x13A7DC
#define REG_BK13A7_6E_H      0x13A7DD
#define REG_BK13A7_6F_L      0x13A7DE
#define REG_BK13A7_6F_H      0x13A7DF
#define REG_BK13A7_70_L      0x13A7E0
#define REG_BK13A7_70_H      0x13A7E1
#define REG_BK13A7_71_L      0x13A7E2
#define REG_BK13A7_71_H      0x13A7E3
#define REG_BK13A7_72_L      0x13A7E4
#define REG_BK13A7_72_H      0x13A7E5
#define REG_BK13A7_73_L      0x13A7E6
#define REG_BK13A7_73_H      0x13A7E7
#define REG_BK13A7_74_L      0x13A7E8
#define REG_BK13A7_74_H      0x13A7E9
#define REG_BK13A7_75_L      0x13A7EA
#define REG_BK13A7_75_H      0x13A7EB
#define REG_BK13A7_76_L      0x13A7EC
#define REG_BK13A7_76_H      0x13A7ED
#define REG_BK13A7_77_L      0x13A7EE
#define REG_BK13A7_77_H      0x13A7EF
#define REG_BK13A7_78_L      0x13A7F0
#define REG_BK13A7_78_H      0x13A7F1
#define REG_BK13A7_79_L      0x13A7F2
#define REG_BK13A7_79_H      0x13A7F3
#define REG_BK13A7_7A_L      0x13A7F4
#define REG_BK13A7_7A_H      0x13A7F5
#define REG_BK13A7_7B_L      0x13A7F6
#define REG_BK13A7_7B_H      0x13A7F7
#define REG_BK13A7_7C_L      0x13A7F8
#define REG_BK13A7_7C_H      0x13A7F9
#define REG_BK13A7_7D_L      0x13A7FA
#define REG_BK13A7_7D_H      0x13A7FB
#define REG_BK13A7_7E_L      0x13A7FC
#define REG_BK13A7_7E_H      0x13A7FD
#define REG_BK13A7_7F_L      0x13A7FE
#define REG_BK13A7_7F_H      0x13A7FF
//----------------------------------------------
#define REG_BK13A8_00_L      0x13A800
#define REG_BK13A8_00_H      0x13A801
#define REG_BK13A8_01_L      0x13A802
#define REG_BK13A8_01_H      0x13A803
#define REG_BK13A8_02_L      0x13A804
#define REG_BK13A8_02_H      0x13A805
#define REG_BK13A8_03_L      0x13A806
#define REG_BK13A8_03_H      0x13A807
#define REG_BK13A8_04_L      0x13A808
#define REG_BK13A8_04_H      0x13A809
#define REG_BK13A8_05_L      0x13A80A
#define REG_BK13A8_05_H      0x13A80B
#define REG_BK13A8_06_L      0x13A80C
#define REG_BK13A8_06_H      0x13A80D
#define REG_BK13A8_07_L      0x13A80E
#define REG_BK13A8_07_H      0x13A80F
#define REG_BK13A8_08_L      0x13A810
#define REG_BK13A8_08_H      0x13A811
#define REG_BK13A8_09_L      0x13A812
#define REG_BK13A8_09_H      0x13A813
#define REG_BK13A8_0A_L      0x13A814
#define REG_BK13A8_0A_H      0x13A815
#define REG_BK13A8_0B_L      0x13A816
#define REG_BK13A8_0B_H      0x13A817
#define REG_BK13A8_0C_L      0x13A818
#define REG_BK13A8_0C_H      0x13A819
#define REG_BK13A8_0D_L      0x13A81A
#define REG_BK13A8_0D_H      0x13A81B
#define REG_BK13A8_0E_L      0x13A81C
#define REG_BK13A8_0E_H      0x13A81D
#define REG_BK13A8_0F_L      0x13A81E
#define REG_BK13A8_0F_H      0x13A81F
#define REG_BK13A8_10_L      0x13A820
#define REG_BK13A8_10_H      0x13A821
#define REG_BK13A8_11_L      0x13A822
#define REG_BK13A8_11_H      0x13A823
#define REG_BK13A8_12_L      0x13A824
#define REG_BK13A8_12_H      0x13A825
#define REG_BK13A8_13_L      0x13A826
#define REG_BK13A8_13_H      0x13A827
#define REG_BK13A8_14_L      0x13A828
#define REG_BK13A8_14_H      0x13A829
#define REG_BK13A8_15_L      0x13A82A
#define REG_BK13A8_15_H      0x13A82B
#define REG_BK13A8_16_L      0x13A82C
#define REG_BK13A8_16_H      0x13A82D
#define REG_BK13A8_17_L      0x13A82E
#define REG_BK13A8_17_H      0x13A82F
#define REG_BK13A8_18_L      0x13A830
#define REG_BK13A8_18_H      0x13A831
#define REG_BK13A8_19_L      0x13A832
#define REG_BK13A8_19_H      0x13A833
#define REG_BK13A8_1A_L      0x13A834
#define REG_BK13A8_1A_H      0x13A835
#define REG_BK13A8_1B_L      0x13A836
#define REG_BK13A8_1B_H      0x13A837
#define REG_BK13A8_1C_L      0x13A838
#define REG_BK13A8_1C_H      0x13A839
#define REG_BK13A8_1D_L      0x13A83A
#define REG_BK13A8_1D_H      0x13A83B
#define REG_BK13A8_1E_L      0x13A83C
#define REG_BK13A8_1E_H      0x13A83D
#define REG_BK13A8_1F_L      0x13A83E
#define REG_BK13A8_1F_H      0x13A83F
#define REG_BK13A8_20_L      0x13A840
#define REG_BK13A8_20_H      0x13A841
#define REG_BK13A8_21_L      0x13A842
#define REG_BK13A8_21_H      0x13A843
#define REG_BK13A8_22_L      0x13A844
#define REG_BK13A8_22_H      0x13A845
#define REG_BK13A8_23_L      0x13A846
#define REG_BK13A8_23_H      0x13A847
#define REG_BK13A8_24_L      0x13A848
#define REG_BK13A8_24_H      0x13A849
#define REG_BK13A8_25_L      0x13A84A
#define REG_BK13A8_25_H      0x13A84B
#define REG_BK13A8_26_L      0x13A84C
#define REG_BK13A8_26_H      0x13A84D
#define REG_BK13A8_27_L      0x13A84E
#define REG_BK13A8_27_H      0x13A84F
#define REG_BK13A8_28_L      0x13A850
#define REG_BK13A8_28_H      0x13A851
#define REG_BK13A8_29_L      0x13A852
#define REG_BK13A8_29_H      0x13A853
#define REG_BK13A8_2A_L      0x13A854
#define REG_BK13A8_2A_H      0x13A855
#define REG_BK13A8_2B_L      0x13A856
#define REG_BK13A8_2B_H      0x13A857
#define REG_BK13A8_2C_L      0x13A858
#define REG_BK13A8_2C_H      0x13A859
#define REG_BK13A8_2D_L      0x13A85A
#define REG_BK13A8_2D_H      0x13A85B
#define REG_BK13A8_2E_L      0x13A85C
#define REG_BK13A8_2E_H      0x13A85D
#define REG_BK13A8_2F_L      0x13A85E
#define REG_BK13A8_2F_H      0x13A85F
#define REG_BK13A8_30_L      0x13A860
#define REG_BK13A8_30_H      0x13A861
#define REG_BK13A8_31_L      0x13A862
#define REG_BK13A8_31_H      0x13A863
#define REG_BK13A8_32_L      0x13A864
#define REG_BK13A8_32_H      0x13A865
#define REG_BK13A8_33_L      0x13A866
#define REG_BK13A8_33_H      0x13A867
#define REG_BK13A8_34_L      0x13A868
#define REG_BK13A8_34_H      0x13A869
#define REG_BK13A8_35_L      0x13A86A
#define REG_BK13A8_35_H      0x13A86B
#define REG_BK13A8_36_L      0x13A86C
#define REG_BK13A8_36_H      0x13A86D
#define REG_BK13A8_37_L      0x13A86E
#define REG_BK13A8_37_H      0x13A86F
#define REG_BK13A8_38_L      0x13A870
#define REG_BK13A8_38_H      0x13A871
#define REG_BK13A8_39_L      0x13A872
#define REG_BK13A8_39_H      0x13A873
#define REG_BK13A8_3A_L      0x13A874
#define REG_BK13A8_3A_H      0x13A875
#define REG_BK13A8_3B_L      0x13A876
#define REG_BK13A8_3B_H      0x13A877
#define REG_BK13A8_3C_L      0x13A878
#define REG_BK13A8_3C_H      0x13A879
#define REG_BK13A8_3D_L      0x13A87A
#define REG_BK13A8_3D_H      0x13A87B
#define REG_BK13A8_3E_L      0x13A87C
#define REG_BK13A8_3E_H      0x13A87D
#define REG_BK13A8_3F_L      0x13A87E
#define REG_BK13A8_3F_H      0x13A87F
#define REG_BK13A8_40_L      0x13A880
#define REG_BK13A8_40_H      0x13A881
#define REG_BK13A8_41_L      0x13A882
#define REG_BK13A8_41_H      0x13A883
#define REG_BK13A8_42_L      0x13A884
#define REG_BK13A8_42_H      0x13A885
#define REG_BK13A8_43_L      0x13A886
#define REG_BK13A8_43_H      0x13A887
#define REG_BK13A8_44_L      0x13A888
#define REG_BK13A8_44_H      0x13A889
#define REG_BK13A8_45_L      0x13A88A
#define REG_BK13A8_45_H      0x13A88B
#define REG_BK13A8_46_L      0x13A88C
#define REG_BK13A8_46_H      0x13A88D
#define REG_BK13A8_47_L      0x13A88E
#define REG_BK13A8_47_H      0x13A88F
#define REG_BK13A8_48_L      0x13A890
#define REG_BK13A8_48_H      0x13A891
#define REG_BK13A8_49_L      0x13A892
#define REG_BK13A8_49_H      0x13A893
#define REG_BK13A8_4A_L      0x13A894
#define REG_BK13A8_4A_H      0x13A895
#define REG_BK13A8_4B_L      0x13A896
#define REG_BK13A8_4B_H      0x13A897
#define REG_BK13A8_4C_L      0x13A898
#define REG_BK13A8_4C_H      0x13A899
#define REG_BK13A8_4D_L      0x13A89A
#define REG_BK13A8_4D_H      0x13A89B
#define REG_BK13A8_4E_L      0x13A89C
#define REG_BK13A8_4E_H      0x13A89D
#define REG_BK13A8_4F_L      0x13A89E
#define REG_BK13A8_4F_H      0x13A89F
#define REG_BK13A8_50_L      0x13A8A0
#define REG_BK13A8_50_H      0x13A8A1
#define REG_BK13A8_51_L      0x13A8A2
#define REG_BK13A8_51_H      0x13A8A3
#define REG_BK13A8_52_L      0x13A8A4
#define REG_BK13A8_52_H      0x13A8A5
#define REG_BK13A8_53_L      0x13A8A6
#define REG_BK13A8_53_H      0x13A8A7
#define REG_BK13A8_54_L      0x13A8A8
#define REG_BK13A8_54_H      0x13A8A9
#define REG_BK13A8_55_L      0x13A8AA
#define REG_BK13A8_55_H      0x13A8AB
#define REG_BK13A8_56_L      0x13A8AC
#define REG_BK13A8_56_H      0x13A8AD
#define REG_BK13A8_57_L      0x13A8AE
#define REG_BK13A8_57_H      0x13A8AF
#define REG_BK13A8_58_L      0x13A8B0
#define REG_BK13A8_58_H      0x13A8B1
#define REG_BK13A8_59_L      0x13A8B2
#define REG_BK13A8_59_H      0x13A8B3
#define REG_BK13A8_5A_L      0x13A8B4
#define REG_BK13A8_5A_H      0x13A8B5
#define REG_BK13A8_5B_L      0x13A8B6
#define REG_BK13A8_5B_H      0x13A8B7
#define REG_BK13A8_5C_L      0x13A8B8
#define REG_BK13A8_5C_H      0x13A8B9
#define REG_BK13A8_5D_L      0x13A8BA
#define REG_BK13A8_5D_H      0x13A8BB
#define REG_BK13A8_5E_L      0x13A8BC
#define REG_BK13A8_5E_H      0x13A8BD
#define REG_BK13A8_5F_L      0x13A8BE
#define REG_BK13A8_5F_H      0x13A8BF
#define REG_BK13A8_60_L      0x13A8C0
#define REG_BK13A8_60_H      0x13A8C1
#define REG_BK13A8_61_L      0x13A8C2
#define REG_BK13A8_61_H      0x13A8C3
#define REG_BK13A8_62_L      0x13A8C4
#define REG_BK13A8_62_H      0x13A8C5
#define REG_BK13A8_63_L      0x13A8C6
#define REG_BK13A8_63_H      0x13A8C7
#define REG_BK13A8_64_L      0x13A8C8
#define REG_BK13A8_64_H      0x13A8C9
#define REG_BK13A8_65_L      0x13A8CA
#define REG_BK13A8_65_H      0x13A8CB
#define REG_BK13A8_66_L      0x13A8CC
#define REG_BK13A8_66_H      0x13A8CD
#define REG_BK13A8_67_L      0x13A8CE
#define REG_BK13A8_67_H      0x13A8CF
#define REG_BK13A8_68_L      0x13A8D0
#define REG_BK13A8_68_H      0x13A8D1
#define REG_BK13A8_69_L      0x13A8D2
#define REG_BK13A8_69_H      0x13A8D3
#define REG_BK13A8_6A_L      0x13A8D4
#define REG_BK13A8_6A_H      0x13A8D5
#define REG_BK13A8_6B_L      0x13A8D6
#define REG_BK13A8_6B_H      0x13A8D7
#define REG_BK13A8_6C_L      0x13A8D8
#define REG_BK13A8_6C_H      0x13A8D9
#define REG_BK13A8_6D_L      0x13A8DA
#define REG_BK13A8_6D_H      0x13A8DB
#define REG_BK13A8_6E_L      0x13A8DC
#define REG_BK13A8_6E_H      0x13A8DD
#define REG_BK13A8_6F_L      0x13A8DE
#define REG_BK13A8_6F_H      0x13A8DF
#define REG_BK13A8_70_L      0x13A8E0
#define REG_BK13A8_70_H      0x13A8E1
#define REG_BK13A8_71_L      0x13A8E2
#define REG_BK13A8_71_H      0x13A8E3
#define REG_BK13A8_72_L      0x13A8E4
#define REG_BK13A8_72_H      0x13A8E5
#define REG_BK13A8_73_L      0x13A8E6
#define REG_BK13A8_73_H      0x13A8E7
#define REG_BK13A8_74_L      0x13A8E8
#define REG_BK13A8_74_H      0x13A8E9
#define REG_BK13A8_75_L      0x13A8EA
#define REG_BK13A8_75_H      0x13A8EB
#define REG_BK13A8_76_L      0x13A8EC
#define REG_BK13A8_76_H      0x13A8ED
#define REG_BK13A8_77_L      0x13A8EE
#define REG_BK13A8_77_H      0x13A8EF
#define REG_BK13A8_78_L      0x13A8F0
#define REG_BK13A8_78_H      0x13A8F1
#define REG_BK13A8_79_L      0x13A8F2
#define REG_BK13A8_79_H      0x13A8F3
#define REG_BK13A8_7A_L      0x13A8F4
#define REG_BK13A8_7A_H      0x13A8F5
#define REG_BK13A8_7B_L      0x13A8F6
#define REG_BK13A8_7B_H      0x13A8F7
#define REG_BK13A8_7C_L      0x13A8F8
#define REG_BK13A8_7C_H      0x13A8F9
#define REG_BK13A8_7D_L      0x13A8FA
#define REG_BK13A8_7D_H      0x13A8FB
#define REG_BK13A8_7E_L      0x13A8FC
#define REG_BK13A8_7E_H      0x13A8FD
#define REG_BK13A8_7F_L      0x13A8FE
#define REG_BK13A8_7F_H      0x13A8FF
//----------------------------------------------
#define REG_BK13AA_00_L      0x13AA00
#define REG_BK13AA_00_H      0x13AA01
#define REG_BK13AA_01_L      0x13AA02
#define REG_BK13AA_01_H      0x13AA03
#define REG_BK13AA_02_L      0x13AA04
#define REG_BK13AA_02_H      0x13AA05
#define REG_BK13AA_03_L      0x13AA06
#define REG_BK13AA_03_H      0x13AA07
#define REG_BK13AA_04_L      0x13AA08
#define REG_BK13AA_04_H      0x13AA09
#define REG_BK13AA_05_L      0x13AA0A
#define REG_BK13AA_05_H      0x13AA0B
#define REG_BK13AA_06_L      0x13AA0C
#define REG_BK13AA_06_H      0x13AA0D
#define REG_BK13AA_07_L      0x13AA0E
#define REG_BK13AA_07_H      0x13AA0F
#define REG_BK13AA_08_L      0x13AA10
#define REG_BK13AA_08_H      0x13AA11
#define REG_BK13AA_09_L      0x13AA12
#define REG_BK13AA_09_H      0x13AA13
#define REG_BK13AA_0A_L      0x13AA14
#define REG_BK13AA_0A_H      0x13AA15
#define REG_BK13AA_0B_L      0x13AA16
#define REG_BK13AA_0B_H      0x13AA17
#define REG_BK13AA_0C_L      0x13AA18
#define REG_BK13AA_0C_H      0x13AA19
#define REG_BK13AA_0D_L      0x13AA1A
#define REG_BK13AA_0D_H      0x13AA1B
#define REG_BK13AA_0E_L      0x13AA1C
#define REG_BK13AA_0E_H      0x13AA1D
#define REG_BK13AA_0F_L      0x13AA1E
#define REG_BK13AA_0F_H      0x13AA1F
#define REG_BK13AA_10_L      0x13AA20
#define REG_BK13AA_10_H      0x13AA21
#define REG_BK13AA_11_L      0x13AA22
#define REG_BK13AA_11_H      0x13AA23
#define REG_BK13AA_12_L      0x13AA24
#define REG_BK13AA_12_H      0x13AA25
#define REG_BK13AA_13_L      0x13AA26
#define REG_BK13AA_13_H      0x13AA27
#define REG_BK13AA_14_L      0x13AA28
#define REG_BK13AA_14_H      0x13AA29
#define REG_BK13AA_15_L      0x13AA2A
#define REG_BK13AA_15_H      0x13AA2B
#define REG_BK13AA_16_L      0x13AA2C
#define REG_BK13AA_16_H      0x13AA2D
#define REG_BK13AA_17_L      0x13AA2E
#define REG_BK13AA_17_H      0x13AA2F
#define REG_BK13AA_18_L      0x13AA30
#define REG_BK13AA_18_H      0x13AA31
#define REG_BK13AA_19_L      0x13AA32
#define REG_BK13AA_19_H      0x13AA33
#define REG_BK13AA_1A_L      0x13AA34
#define REG_BK13AA_1A_H      0x13AA35
#define REG_BK13AA_1B_L      0x13AA36
#define REG_BK13AA_1B_H      0x13AA37
#define REG_BK13AA_1C_L      0x13AA38
#define REG_BK13AA_1C_H      0x13AA39
#define REG_BK13AA_1D_L      0x13AA3A
#define REG_BK13AA_1D_H      0x13AA3B
#define REG_BK13AA_1E_L      0x13AA3C
#define REG_BK13AA_1E_H      0x13AA3D
#define REG_BK13AA_1F_L      0x13AA3E
#define REG_BK13AA_1F_H      0x13AA3F
#define REG_BK13AA_20_L      0x13AA40
#define REG_BK13AA_20_H      0x13AA41
#define REG_BK13AA_21_L      0x13AA42
#define REG_BK13AA_21_H      0x13AA43
#define REG_BK13AA_22_L      0x13AA44
#define REG_BK13AA_22_H      0x13AA45
#define REG_BK13AA_23_L      0x13AA46
#define REG_BK13AA_23_H      0x13AA47
#define REG_BK13AA_24_L      0x13AA48
#define REG_BK13AA_24_H      0x13AA49
#define REG_BK13AA_25_L      0x13AA4A
#define REG_BK13AA_25_H      0x13AA4B
#define REG_BK13AA_26_L      0x13AA4C
#define REG_BK13AA_26_H      0x13AA4D
#define REG_BK13AA_27_L      0x13AA4E
#define REG_BK13AA_27_H      0x13AA4F
#define REG_BK13AA_28_L      0x13AA50
#define REG_BK13AA_28_H      0x13AA51
#define REG_BK13AA_29_L      0x13AA52
#define REG_BK13AA_29_H      0x13AA53
#define REG_BK13AA_2A_L      0x13AA54
#define REG_BK13AA_2A_H      0x13AA55
#define REG_BK13AA_2B_L      0x13AA56
#define REG_BK13AA_2B_H      0x13AA57
#define REG_BK13AA_2C_L      0x13AA58
#define REG_BK13AA_2C_H      0x13AA59
#define REG_BK13AA_2D_L      0x13AA5A
#define REG_BK13AA_2D_H      0x13AA5B
#define REG_BK13AA_2E_L      0x13AA5C
#define REG_BK13AA_2E_H      0x13AA5D
#define REG_BK13AA_2F_L      0x13AA5E
#define REG_BK13AA_2F_H      0x13AA5F
#define REG_BK13AA_30_L      0x13AA60
#define REG_BK13AA_30_H      0x13AA61
#define REG_BK13AA_31_L      0x13AA62
#define REG_BK13AA_31_H      0x13AA63
#define REG_BK13AA_32_L      0x13AA64
#define REG_BK13AA_32_H      0x13AA65
#define REG_BK13AA_33_L      0x13AA66
#define REG_BK13AA_33_H      0x13AA67
#define REG_BK13AA_34_L      0x13AA68
#define REG_BK13AA_34_H      0x13AA69
#define REG_BK13AA_35_L      0x13AA6A
#define REG_BK13AA_35_H      0x13AA6B
#define REG_BK13AA_36_L      0x13AA6C
#define REG_BK13AA_36_H      0x13AA6D
#define REG_BK13AA_37_L      0x13AA6E
#define REG_BK13AA_37_H      0x13AA6F
#define REG_BK13AA_38_L      0x13AA70
#define REG_BK13AA_38_H      0x13AA71
#define REG_BK13AA_39_L      0x13AA72
#define REG_BK13AA_39_H      0x13AA73
#define REG_BK13AA_3A_L      0x13AA74
#define REG_BK13AA_3A_H      0x13AA75
#define REG_BK13AA_3B_L      0x13AA76
#define REG_BK13AA_3B_H      0x13AA77
#define REG_BK13AA_3C_L      0x13AA78
#define REG_BK13AA_3C_H      0x13AA79
#define REG_BK13AA_3D_L      0x13AA7A
#define REG_BK13AA_3D_H      0x13AA7B
#define REG_BK13AA_3E_L      0x13AA7C
#define REG_BK13AA_3E_H      0x13AA7D
#define REG_BK13AA_3F_L      0x13AA7E
#define REG_BK13AA_3F_H      0x13AA7F
#define REG_BK13AA_40_L      0x13AA80
#define REG_BK13AA_40_H      0x13AA81
#define REG_BK13AA_41_L      0x13AA82
#define REG_BK13AA_41_H      0x13AA83
#define REG_BK13AA_42_L      0x13AA84
#define REG_BK13AA_42_H      0x13AA85
#define REG_BK13AA_43_L      0x13AA86
#define REG_BK13AA_43_H      0x13AA87
#define REG_BK13AA_44_L      0x13AA88
#define REG_BK13AA_44_H      0x13AA89
#define REG_BK13AA_45_L      0x13AA8A
#define REG_BK13AA_45_H      0x13AA8B
#define REG_BK13AA_46_L      0x13AA8C
#define REG_BK13AA_46_H      0x13AA8D
#define REG_BK13AA_47_L      0x13AA8E
#define REG_BK13AA_47_H      0x13AA8F
#define REG_BK13AA_48_L      0x13AA90
#define REG_BK13AA_48_H      0x13AA91
#define REG_BK13AA_49_L      0x13AA92
#define REG_BK13AA_49_H      0x13AA93
#define REG_BK13AA_4A_L      0x13AA94
#define REG_BK13AA_4A_H      0x13AA95
#define REG_BK13AA_4B_L      0x13AA96
#define REG_BK13AA_4B_H      0x13AA97
#define REG_BK13AA_4C_L      0x13AA98
#define REG_BK13AA_4C_H      0x13AA99
#define REG_BK13AA_4D_L      0x13AA9A
#define REG_BK13AA_4D_H      0x13AA9B
#define REG_BK13AA_4E_L      0x13AA9C
#define REG_BK13AA_4E_H      0x13AA9D
#define REG_BK13AA_4F_L      0x13AA9E
#define REG_BK13AA_4F_H      0x13AA9F
#define REG_BK13AA_50_L      0x13AAA0
#define REG_BK13AA_50_H      0x13AAA1
#define REG_BK13AA_51_L      0x13AAA2
#define REG_BK13AA_51_H      0x13AAA3
#define REG_BK13AA_52_L      0x13AAA4
#define REG_BK13AA_52_H      0x13AAA5
#define REG_BK13AA_53_L      0x13AAA6
#define REG_BK13AA_53_H      0x13AAA7
#define REG_BK13AA_54_L      0x13AAA8
#define REG_BK13AA_54_H      0x13AAA9
#define REG_BK13AA_55_L      0x13AAAA
#define REG_BK13AA_55_H      0x13AAAB
#define REG_BK13AA_56_L      0x13AAAC
#define REG_BK13AA_56_H      0x13AAAD
#define REG_BK13AA_57_L      0x13AAAE
#define REG_BK13AA_57_H      0x13AAAF
#define REG_BK13AA_58_L      0x13AAB0
#define REG_BK13AA_58_H      0x13AAB1
#define REG_BK13AA_59_L      0x13AAB2
#define REG_BK13AA_59_H      0x13AAB3
#define REG_BK13AA_5A_L      0x13AAB4
#define REG_BK13AA_5A_H      0x13AAB5
#define REG_BK13AA_5B_L      0x13AAB6
#define REG_BK13AA_5B_H      0x13AAB7
#define REG_BK13AA_5C_L      0x13AAB8
#define REG_BK13AA_5C_H      0x13AAB9
#define REG_BK13AA_5D_L      0x13AABA
#define REG_BK13AA_5D_H      0x13AABB
#define REG_BK13AA_5E_L      0x13AABC
#define REG_BK13AA_5E_H      0x13AABD
#define REG_BK13AA_5F_L      0x13AABE
#define REG_BK13AA_5F_H      0x13AABF
#define REG_BK13AA_60_L      0x13AAC0
#define REG_BK13AA_60_H      0x13AAC1
#define REG_BK13AA_61_L      0x13AAC2
#define REG_BK13AA_61_H      0x13AAC3
#define REG_BK13AA_62_L      0x13AAC4
#define REG_BK13AA_62_H      0x13AAC5
#define REG_BK13AA_63_L      0x13AAC6
#define REG_BK13AA_63_H      0x13AAC7
#define REG_BK13AA_64_L      0x13AAC8
#define REG_BK13AA_64_H      0x13AAC9
#define REG_BK13AA_65_L      0x13AACA
#define REG_BK13AA_65_H      0x13AACB
#define REG_BK13AA_66_L      0x13AACC
#define REG_BK13AA_66_H      0x13AACD
#define REG_BK13AA_67_L      0x13AACE
#define REG_BK13AA_67_H      0x13AACF
#define REG_BK13AA_68_L      0x13AAD0
#define REG_BK13AA_68_H      0x13AAD1
#define REG_BK13AA_69_L      0x13AAD2
#define REG_BK13AA_69_H      0x13AAD3
#define REG_BK13AA_6A_L      0x13AAD4
#define REG_BK13AA_6A_H      0x13AAD5
#define REG_BK13AA_6B_L      0x13AAD6
#define REG_BK13AA_6B_H      0x13AAD7
#define REG_BK13AA_6C_L      0x13AAD8
#define REG_BK13AA_6C_H      0x13AAD9
#define REG_BK13AA_6D_L      0x13AADA
#define REG_BK13AA_6D_H      0x13AADB
#define REG_BK13AA_6E_L      0x13AADC
#define REG_BK13AA_6E_H      0x13AADD
#define REG_BK13AA_6F_L      0x13AADE
#define REG_BK13AA_6F_H      0x13AADF
#define REG_BK13AA_70_L      0x13AAE0
#define REG_BK13AA_70_H      0x13AAE1
#define REG_BK13AA_71_L      0x13AAE2
#define REG_BK13AA_71_H      0x13AAE3
#define REG_BK13AA_72_L      0x13AAE4
#define REG_BK13AA_72_H      0x13AAE5
#define REG_BK13AA_73_L      0x13AAE6
#define REG_BK13AA_73_H      0x13AAE7
#define REG_BK13AA_74_L      0x13AAE8
#define REG_BK13AA_74_H      0x13AAE9
#define REG_BK13AA_75_L      0x13AAEA
#define REG_BK13AA_75_H      0x13AAEB
#define REG_BK13AA_76_L      0x13AAEC
#define REG_BK13AA_76_H      0x13AAED
#define REG_BK13AA_77_L      0x13AAEE
#define REG_BK13AA_77_H      0x13AAEF
#define REG_BK13AA_78_L      0x13AAF0
#define REG_BK13AA_78_H      0x13AAF1
#define REG_BK13AA_79_L      0x13AAF2
#define REG_BK13AA_79_H      0x13AAF3
#define REG_BK13AA_7A_L      0x13AAF4
#define REG_BK13AA_7A_H      0x13AAF5
#define REG_BK13AA_7B_L      0x13AAF6
#define REG_BK13AA_7B_H      0x13AAF7
#define REG_BK13AA_7C_L      0x13AAF8
#define REG_BK13AA_7C_H      0x13AAF9
#define REG_BK13AA_7D_L      0x13AAFA
#define REG_BK13AA_7D_H      0x13AAFB
#define REG_BK13AA_7E_L      0x13AAFC
#define REG_BK13AA_7E_H      0x13AAFD
#define REG_BK13AA_7F_L      0x13AAFE
#define REG_BK13AA_7F_H      0x13AAFF
//----------------------------------------------
#define REG_BK13AB_00_L      0x13AB00
#define REG_BK13AB_00_H      0x13AB01
#define REG_BK13AB_01_L      0x13AB02
#define REG_BK13AB_01_H      0x13AB03
#define REG_BK13AB_02_L      0x13AB04
#define REG_BK13AB_02_H      0x13AB05
#define REG_BK13AB_03_L      0x13AB06
#define REG_BK13AB_03_H      0x13AB07
#define REG_BK13AB_04_L      0x13AB08
#define REG_BK13AB_04_H      0x13AB09
#define REG_BK13AB_05_L      0x13AB0A
#define REG_BK13AB_05_H      0x13AB0B
#define REG_BK13AB_06_L      0x13AB0C
#define REG_BK13AB_06_H      0x13AB0D
#define REG_BK13AB_07_L      0x13AB0E
#define REG_BK13AB_07_H      0x13AB0F
#define REG_BK13AB_08_L      0x13AB10
#define REG_BK13AB_08_H      0x13AB11
#define REG_BK13AB_09_L      0x13AB12
#define REG_BK13AB_09_H      0x13AB13
#define REG_BK13AB_0A_L      0x13AB14
#define REG_BK13AB_0A_H      0x13AB15
#define REG_BK13AB_0B_L      0x13AB16
#define REG_BK13AB_0B_H      0x13AB17
#define REG_BK13AB_0C_L      0x13AB18
#define REG_BK13AB_0C_H      0x13AB19
#define REG_BK13AB_0D_L      0x13AB1A
#define REG_BK13AB_0D_H      0x13AB1B
#define REG_BK13AB_0E_L      0x13AB1C
#define REG_BK13AB_0E_H      0x13AB1D
#define REG_BK13AB_0F_L      0x13AB1E
#define REG_BK13AB_0F_H      0x13AB1F
#define REG_BK13AB_10_L      0x13AB20
#define REG_BK13AB_10_H      0x13AB21
#define REG_BK13AB_11_L      0x13AB22
#define REG_BK13AB_11_H      0x13AB23
#define REG_BK13AB_12_L      0x13AB24
#define REG_BK13AB_12_H      0x13AB25
#define REG_BK13AB_13_L      0x13AB26
#define REG_BK13AB_13_H      0x13AB27
#define REG_BK13AB_14_L      0x13AB28
#define REG_BK13AB_14_H      0x13AB29
#define REG_BK13AB_15_L      0x13AB2A
#define REG_BK13AB_15_H      0x13AB2B
#define REG_BK13AB_16_L      0x13AB2C
#define REG_BK13AB_16_H      0x13AB2D
#define REG_BK13AB_17_L      0x13AB2E
#define REG_BK13AB_17_H      0x13AB2F
#define REG_BK13AB_18_L      0x13AB30
#define REG_BK13AB_18_H      0x13AB31
#define REG_BK13AB_19_L      0x13AB32
#define REG_BK13AB_19_H      0x13AB33
#define REG_BK13AB_1A_L      0x13AB34
#define REG_BK13AB_1A_H      0x13AB35
#define REG_BK13AB_1B_L      0x13AB36
#define REG_BK13AB_1B_H      0x13AB37
#define REG_BK13AB_1C_L      0x13AB38
#define REG_BK13AB_1C_H      0x13AB39
#define REG_BK13AB_1D_L      0x13AB3A
#define REG_BK13AB_1D_H      0x13AB3B
#define REG_BK13AB_1E_L      0x13AB3C
#define REG_BK13AB_1E_H      0x13AB3D
#define REG_BK13AB_1F_L      0x13AB3E
#define REG_BK13AB_1F_H      0x13AB3F
#define REG_BK13AB_20_L      0x13AB40
#define REG_BK13AB_20_H      0x13AB41
#define REG_BK13AB_21_L      0x13AB42
#define REG_BK13AB_21_H      0x13AB43
#define REG_BK13AB_22_L      0x13AB44
#define REG_BK13AB_22_H      0x13AB45
#define REG_BK13AB_23_L      0x13AB46
#define REG_BK13AB_23_H      0x13AB47
#define REG_BK13AB_24_L      0x13AB48
#define REG_BK13AB_24_H      0x13AB49
#define REG_BK13AB_25_L      0x13AB4A
#define REG_BK13AB_25_H      0x13AB4B
#define REG_BK13AB_26_L      0x13AB4C
#define REG_BK13AB_26_H      0x13AB4D
#define REG_BK13AB_27_L      0x13AB4E
#define REG_BK13AB_27_H      0x13AB4F
#define REG_BK13AB_28_L      0x13AB50
#define REG_BK13AB_28_H      0x13AB51
#define REG_BK13AB_29_L      0x13AB52
#define REG_BK13AB_29_H      0x13AB53
#define REG_BK13AB_2A_L      0x13AB54
#define REG_BK13AB_2A_H      0x13AB55
#define REG_BK13AB_2B_L      0x13AB56
#define REG_BK13AB_2B_H      0x13AB57
#define REG_BK13AB_2C_L      0x13AB58
#define REG_BK13AB_2C_H      0x13AB59
#define REG_BK13AB_2D_L      0x13AB5A
#define REG_BK13AB_2D_H      0x13AB5B
#define REG_BK13AB_2E_L      0x13AB5C
#define REG_BK13AB_2E_H      0x13AB5D
#define REG_BK13AB_2F_L      0x13AB5E
#define REG_BK13AB_2F_H      0x13AB5F
#define REG_BK13AB_30_L      0x13AB60
#define REG_BK13AB_30_H      0x13AB61
#define REG_BK13AB_31_L      0x13AB62
#define REG_BK13AB_31_H      0x13AB63
#define REG_BK13AB_32_L      0x13AB64
#define REG_BK13AB_32_H      0x13AB65
#define REG_BK13AB_33_L      0x13AB66
#define REG_BK13AB_33_H      0x13AB67
#define REG_BK13AB_34_L      0x13AB68
#define REG_BK13AB_34_H      0x13AB69
#define REG_BK13AB_35_L      0x13AB6A
#define REG_BK13AB_35_H      0x13AB6B
#define REG_BK13AB_36_L      0x13AB6C
#define REG_BK13AB_36_H      0x13AB6D
#define REG_BK13AB_37_L      0x13AB6E
#define REG_BK13AB_37_H      0x13AB6F
#define REG_BK13AB_38_L      0x13AB70
#define REG_BK13AB_38_H      0x13AB71
#define REG_BK13AB_39_L      0x13AB72
#define REG_BK13AB_39_H      0x13AB73
#define REG_BK13AB_3A_L      0x13AB74
#define REG_BK13AB_3A_H      0x13AB75
#define REG_BK13AB_3B_L      0x13AB76
#define REG_BK13AB_3B_H      0x13AB77
#define REG_BK13AB_3C_L      0x13AB78
#define REG_BK13AB_3C_H      0x13AB79
#define REG_BK13AB_3D_L      0x13AB7A
#define REG_BK13AB_3D_H      0x13AB7B
#define REG_BK13AB_3E_L      0x13AB7C
#define REG_BK13AB_3E_H      0x13AB7D
#define REG_BK13AB_3F_L      0x13AB7E
#define REG_BK13AB_3F_H      0x13AB7F
#define REG_BK13AB_40_L      0x13AB80
#define REG_BK13AB_40_H      0x13AB81
#define REG_BK13AB_41_L      0x13AB82
#define REG_BK13AB_41_H      0x13AB83
#define REG_BK13AB_42_L      0x13AB84
#define REG_BK13AB_42_H      0x13AB85
#define REG_BK13AB_43_L      0x13AB86
#define REG_BK13AB_43_H      0x13AB87
#define REG_BK13AB_44_L      0x13AB88
#define REG_BK13AB_44_H      0x13AB89
#define REG_BK13AB_45_L      0x13AB8A
#define REG_BK13AB_45_H      0x13AB8B
#define REG_BK13AB_46_L      0x13AB8C
#define REG_BK13AB_46_H      0x13AB8D
#define REG_BK13AB_47_L      0x13AB8E
#define REG_BK13AB_47_H      0x13AB8F
#define REG_BK13AB_48_L      0x13AB90
#define REG_BK13AB_48_H      0x13AB91
#define REG_BK13AB_49_L      0x13AB92
#define REG_BK13AB_49_H      0x13AB93
#define REG_BK13AB_4A_L      0x13AB94
#define REG_BK13AB_4A_H      0x13AB95
#define REG_BK13AB_4B_L      0x13AB96
#define REG_BK13AB_4B_H      0x13AB97
#define REG_BK13AB_4C_L      0x13AB98
#define REG_BK13AB_4C_H      0x13AB99
#define REG_BK13AB_4D_L      0x13AB9A
#define REG_BK13AB_4D_H      0x13AB9B
#define REG_BK13AB_4E_L      0x13AB9C
#define REG_BK13AB_4E_H      0x13AB9D
#define REG_BK13AB_4F_L      0x13AB9E
#define REG_BK13AB_4F_H      0x13AB9F
#define REG_BK13AB_50_L      0x13ABA0
#define REG_BK13AB_50_H      0x13ABA1
#define REG_BK13AB_51_L      0x13ABA2
#define REG_BK13AB_51_H      0x13ABA3
#define REG_BK13AB_52_L      0x13ABA4
#define REG_BK13AB_52_H      0x13ABA5
#define REG_BK13AB_53_L      0x13ABA6
#define REG_BK13AB_53_H      0x13ABA7
#define REG_BK13AB_54_L      0x13ABA8
#define REG_BK13AB_54_H      0x13ABA9
#define REG_BK13AB_55_L      0x13ABAA
#define REG_BK13AB_55_H      0x13ABAB
#define REG_BK13AB_56_L      0x13ABAC
#define REG_BK13AB_56_H      0x13ABAD
#define REG_BK13AB_57_L      0x13ABAE
#define REG_BK13AB_57_H      0x13ABAF
#define REG_BK13AB_58_L      0x13ABB0
#define REG_BK13AB_58_H      0x13ABB1
#define REG_BK13AB_59_L      0x13ABB2
#define REG_BK13AB_59_H      0x13ABB3
#define REG_BK13AB_5A_L      0x13ABB4
#define REG_BK13AB_5A_H      0x13ABB5
#define REG_BK13AB_5B_L      0x13ABB6
#define REG_BK13AB_5B_H      0x13ABB7
#define REG_BK13AB_5C_L      0x13ABB8
#define REG_BK13AB_5C_H      0x13ABB9
#define REG_BK13AB_5D_L      0x13ABBA
#define REG_BK13AB_5D_H      0x13ABBB
#define REG_BK13AB_5E_L      0x13ABBC
#define REG_BK13AB_5E_H      0x13ABBD
#define REG_BK13AB_5F_L      0x13ABBE
#define REG_BK13AB_5F_H      0x13ABBF
#define REG_BK13AB_60_L      0x13ABC0
#define REG_BK13AB_60_H      0x13ABC1
#define REG_BK13AB_61_L      0x13ABC2
#define REG_BK13AB_61_H      0x13ABC3
#define REG_BK13AB_62_L      0x13ABC4
#define REG_BK13AB_62_H      0x13ABC5
#define REG_BK13AB_63_L      0x13ABC6
#define REG_BK13AB_63_H      0x13ABC7
#define REG_BK13AB_64_L      0x13ABC8
#define REG_BK13AB_64_H      0x13ABC9
#define REG_BK13AB_65_L      0x13ABCA
#define REG_BK13AB_65_H      0x13ABCB
#define REG_BK13AB_66_L      0x13ABCC
#define REG_BK13AB_66_H      0x13ABCD
#define REG_BK13AB_67_L      0x13ABCE
#define REG_BK13AB_67_H      0x13ABCF
#define REG_BK13AB_68_L      0x13ABD0
#define REG_BK13AB_68_H      0x13ABD1
#define REG_BK13AB_69_L      0x13ABD2
#define REG_BK13AB_69_H      0x13ABD3
#define REG_BK13AB_6A_L      0x13ABD4
#define REG_BK13AB_6A_H      0x13ABD5
#define REG_BK13AB_6B_L      0x13ABD6
#define REG_BK13AB_6B_H      0x13ABD7
#define REG_BK13AB_6C_L      0x13ABD8
#define REG_BK13AB_6C_H      0x13ABD9
#define REG_BK13AB_6D_L      0x13ABDA
#define REG_BK13AB_6D_H      0x13ABDB
#define REG_BK13AB_6E_L      0x13ABDC
#define REG_BK13AB_6E_H      0x13ABDD
#define REG_BK13AB_6F_L      0x13ABDE
#define REG_BK13AB_6F_H      0x13ABDF
#define REG_BK13AB_70_L      0x13ABE0
#define REG_BK13AB_70_H      0x13ABE1
#define REG_BK13AB_71_L      0x13ABE2
#define REG_BK13AB_71_H      0x13ABE3
#define REG_BK13AB_72_L      0x13ABE4
#define REG_BK13AB_72_H      0x13ABE5
#define REG_BK13AB_73_L      0x13ABE6
#define REG_BK13AB_73_H      0x13ABE7
#define REG_BK13AB_74_L      0x13ABE8
#define REG_BK13AB_74_H      0x13ABE9
#define REG_BK13AB_75_L      0x13ABEA
#define REG_BK13AB_75_H      0x13ABEB
#define REG_BK13AB_76_L      0x13ABEC
#define REG_BK13AB_76_H      0x13ABED
#define REG_BK13AB_77_L      0x13ABEE
#define REG_BK13AB_77_H      0x13ABEF
#define REG_BK13AB_78_L      0x13ABF0
#define REG_BK13AB_78_H      0x13ABF1
#define REG_BK13AB_79_L      0x13ABF2
#define REG_BK13AB_79_H      0x13ABF3
#define REG_BK13AB_7A_L      0x13ABF4
#define REG_BK13AB_7A_H      0x13ABF5
#define REG_BK13AB_7B_L      0x13ABF6
#define REG_BK13AB_7B_H      0x13ABF7
#define REG_BK13AB_7C_L      0x13ABF8
#define REG_BK13AB_7C_H      0x13ABF9
#define REG_BK13AB_7D_L      0x13ABFA
#define REG_BK13AB_7D_H      0x13ABFB
#define REG_BK13AB_7E_L      0x13ABFC
#define REG_BK13AB_7E_H      0x13ABFD
#define REG_BK13AB_7F_L      0x13ABFE
#define REG_BK13AB_7F_H      0x13ABFF
//----------------------------------------------
#define REG_BK13AC_00_L      0x13AC00
#define REG_BK13AC_00_H      0x13AC01
#define REG_BK13AC_01_L      0x13AC02
#define REG_BK13AC_01_H      0x13AC03
#define REG_BK13AC_02_L      0x13AC04
#define REG_BK13AC_02_H      0x13AC05
#define REG_BK13AC_03_L      0x13AC06
#define REG_BK13AC_03_H      0x13AC07
#define REG_BK13AC_04_L      0x13AC08
#define REG_BK13AC_04_H      0x13AC09
#define REG_BK13AC_05_L      0x13AC0A
#define REG_BK13AC_05_H      0x13AC0B
#define REG_BK13AC_06_L      0x13AC0C
#define REG_BK13AC_06_H      0x13AC0D
#define REG_BK13AC_07_L      0x13AC0E
#define REG_BK13AC_07_H      0x13AC0F
#define REG_BK13AC_08_L      0x13AC10
#define REG_BK13AC_08_H      0x13AC11
#define REG_BK13AC_09_L      0x13AC12
#define REG_BK13AC_09_H      0x13AC13
#define REG_BK13AC_0A_L      0x13AC14
#define REG_BK13AC_0A_H      0x13AC15
#define REG_BK13AC_0B_L      0x13AC16
#define REG_BK13AC_0B_H      0x13AC17
#define REG_BK13AC_0C_L      0x13AC18
#define REG_BK13AC_0C_H      0x13AC19
#define REG_BK13AC_0D_L      0x13AC1A
#define REG_BK13AC_0D_H      0x13AC1B
#define REG_BK13AC_0E_L      0x13AC1C
#define REG_BK13AC_0E_H      0x13AC1D
#define REG_BK13AC_0F_L      0x13AC1E
#define REG_BK13AC_0F_H      0x13AC1F
#define REG_BK13AC_10_L      0x13AC20
#define REG_BK13AC_10_H      0x13AC21
#define REG_BK13AC_11_L      0x13AC22
#define REG_BK13AC_11_H      0x13AC23
#define REG_BK13AC_12_L      0x13AC24
#define REG_BK13AC_12_H      0x13AC25
#define REG_BK13AC_13_L      0x13AC26
#define REG_BK13AC_13_H      0x13AC27
#define REG_BK13AC_14_L      0x13AC28
#define REG_BK13AC_14_H      0x13AC29
#define REG_BK13AC_15_L      0x13AC2A
#define REG_BK13AC_15_H      0x13AC2B
#define REG_BK13AC_16_L      0x13AC2C
#define REG_BK13AC_16_H      0x13AC2D
#define REG_BK13AC_17_L      0x13AC2E
#define REG_BK13AC_17_H      0x13AC2F
#define REG_BK13AC_18_L      0x13AC30
#define REG_BK13AC_18_H      0x13AC31
#define REG_BK13AC_19_L      0x13AC32
#define REG_BK13AC_19_H      0x13AC33
#define REG_BK13AC_1A_L      0x13AC34
#define REG_BK13AC_1A_H      0x13AC35
#define REG_BK13AC_1B_L      0x13AC36
#define REG_BK13AC_1B_H      0x13AC37
#define REG_BK13AC_1C_L      0x13AC38
#define REG_BK13AC_1C_H      0x13AC39
#define REG_BK13AC_1D_L      0x13AC3A
#define REG_BK13AC_1D_H      0x13AC3B
#define REG_BK13AC_1E_L      0x13AC3C
#define REG_BK13AC_1E_H      0x13AC3D
#define REG_BK13AC_1F_L      0x13AC3E
#define REG_BK13AC_1F_H      0x13AC3F
#define REG_BK13AC_20_L      0x13AC40
#define REG_BK13AC_20_H      0x13AC41
#define REG_BK13AC_21_L      0x13AC42
#define REG_BK13AC_21_H      0x13AC43
#define REG_BK13AC_22_L      0x13AC44
#define REG_BK13AC_22_H      0x13AC45
#define REG_BK13AC_23_L      0x13AC46
#define REG_BK13AC_23_H      0x13AC47
#define REG_BK13AC_24_L      0x13AC48
#define REG_BK13AC_24_H      0x13AC49
#define REG_BK13AC_25_L      0x13AC4A
#define REG_BK13AC_25_H      0x13AC4B
#define REG_BK13AC_26_L      0x13AC4C
#define REG_BK13AC_26_H      0x13AC4D
#define REG_BK13AC_27_L      0x13AC4E
#define REG_BK13AC_27_H      0x13AC4F
#define REG_BK13AC_28_L      0x13AC50
#define REG_BK13AC_28_H      0x13AC51
#define REG_BK13AC_29_L      0x13AC52
#define REG_BK13AC_29_H      0x13AC53
#define REG_BK13AC_2A_L      0x13AC54
#define REG_BK13AC_2A_H      0x13AC55
#define REG_BK13AC_2B_L      0x13AC56
#define REG_BK13AC_2B_H      0x13AC57
#define REG_BK13AC_2C_L      0x13AC58
#define REG_BK13AC_2C_H      0x13AC59
#define REG_BK13AC_2D_L      0x13AC5A
#define REG_BK13AC_2D_H      0x13AC5B
#define REG_BK13AC_2E_L      0x13AC5C
#define REG_BK13AC_2E_H      0x13AC5D
#define REG_BK13AC_2F_L      0x13AC5E
#define REG_BK13AC_2F_H      0x13AC5F
#define REG_BK13AC_30_L      0x13AC60
#define REG_BK13AC_30_H      0x13AC61
#define REG_BK13AC_31_L      0x13AC62
#define REG_BK13AC_31_H      0x13AC63
#define REG_BK13AC_32_L      0x13AC64
#define REG_BK13AC_32_H      0x13AC65
#define REG_BK13AC_33_L      0x13AC66
#define REG_BK13AC_33_H      0x13AC67
#define REG_BK13AC_34_L      0x13AC68
#define REG_BK13AC_34_H      0x13AC69
#define REG_BK13AC_35_L      0x13AC6A
#define REG_BK13AC_35_H      0x13AC6B
#define REG_BK13AC_36_L      0x13AC6C
#define REG_BK13AC_36_H      0x13AC6D
#define REG_BK13AC_37_L      0x13AC6E
#define REG_BK13AC_37_H      0x13AC6F
#define REG_BK13AC_38_L      0x13AC70
#define REG_BK13AC_38_H      0x13AC71
#define REG_BK13AC_39_L      0x13AC72
#define REG_BK13AC_39_H      0x13AC73
#define REG_BK13AC_3A_L      0x13AC74
#define REG_BK13AC_3A_H      0x13AC75
#define REG_BK13AC_3B_L      0x13AC76
#define REG_BK13AC_3B_H      0x13AC77
#define REG_BK13AC_3C_L      0x13AC78
#define REG_BK13AC_3C_H      0x13AC79
#define REG_BK13AC_3D_L      0x13AC7A
#define REG_BK13AC_3D_H      0x13AC7B
#define REG_BK13AC_3E_L      0x13AC7C
#define REG_BK13AC_3E_H      0x13AC7D
#define REG_BK13AC_3F_L      0x13AC7E
#define REG_BK13AC_3F_H      0x13AC7F
#define REG_BK13AC_40_L      0x13AC80
#define REG_BK13AC_40_H      0x13AC81
#define REG_BK13AC_41_L      0x13AC82
#define REG_BK13AC_41_H      0x13AC83
#define REG_BK13AC_42_L      0x13AC84
#define REG_BK13AC_42_H      0x13AC85
#define REG_BK13AC_43_L      0x13AC86
#define REG_BK13AC_43_H      0x13AC87
#define REG_BK13AC_44_L      0x13AC88
#define REG_BK13AC_44_H      0x13AC89
#define REG_BK13AC_45_L      0x13AC8A
#define REG_BK13AC_45_H      0x13AC8B
#define REG_BK13AC_46_L      0x13AC8C
#define REG_BK13AC_46_H      0x13AC8D
#define REG_BK13AC_47_L      0x13AC8E
#define REG_BK13AC_47_H      0x13AC8F
#define REG_BK13AC_48_L      0x13AC90
#define REG_BK13AC_48_H      0x13AC91
#define REG_BK13AC_49_L      0x13AC92
#define REG_BK13AC_49_H      0x13AC93
#define REG_BK13AC_4A_L      0x13AC94
#define REG_BK13AC_4A_H      0x13AC95
#define REG_BK13AC_4B_L      0x13AC96
#define REG_BK13AC_4B_H      0x13AC97
#define REG_BK13AC_4C_L      0x13AC98
#define REG_BK13AC_4C_H      0x13AC99
#define REG_BK13AC_4D_L      0x13AC9A
#define REG_BK13AC_4D_H      0x13AC9B
#define REG_BK13AC_4E_L      0x13AC9C
#define REG_BK13AC_4E_H      0x13AC9D
#define REG_BK13AC_4F_L      0x13AC9E
#define REG_BK13AC_4F_H      0x13AC9F
#define REG_BK13AC_50_L      0x13ACA0
#define REG_BK13AC_50_H      0x13ACA1
#define REG_BK13AC_51_L      0x13ACA2
#define REG_BK13AC_51_H      0x13ACA3
#define REG_BK13AC_52_L      0x13ACA4
#define REG_BK13AC_52_H      0x13ACA5
#define REG_BK13AC_53_L      0x13ACA6
#define REG_BK13AC_53_H      0x13ACA7
#define REG_BK13AC_54_L      0x13ACA8
#define REG_BK13AC_54_H      0x13ACA9
#define REG_BK13AC_55_L      0x13ACAA
#define REG_BK13AC_55_H      0x13ACAB
#define REG_BK13AC_56_L      0x13ACAC
#define REG_BK13AC_56_H      0x13ACAD
#define REG_BK13AC_57_L      0x13ACAE
#define REG_BK13AC_57_H      0x13ACAF
#define REG_BK13AC_58_L      0x13ACB0
#define REG_BK13AC_58_H      0x13ACB1
#define REG_BK13AC_59_L      0x13ACB2
#define REG_BK13AC_59_H      0x13ACB3
#define REG_BK13AC_5A_L      0x13ACB4
#define REG_BK13AC_5A_H      0x13ACB5
#define REG_BK13AC_5B_L      0x13ACB6
#define REG_BK13AC_5B_H      0x13ACB7
#define REG_BK13AC_5C_L      0x13ACB8
#define REG_BK13AC_5C_H      0x13ACB9
#define REG_BK13AC_5D_L      0x13ACBA
#define REG_BK13AC_5D_H      0x13ACBB
#define REG_BK13AC_5E_L      0x13ACBC
#define REG_BK13AC_5E_H      0x13ACBD
#define REG_BK13AC_5F_L      0x13ACBE
#define REG_BK13AC_5F_H      0x13ACBF
#define REG_BK13AC_60_L      0x13ACC0
#define REG_BK13AC_60_H      0x13ACC1
#define REG_BK13AC_61_L      0x13ACC2
#define REG_BK13AC_61_H      0x13ACC3
#define REG_BK13AC_62_L      0x13ACC4
#define REG_BK13AC_62_H      0x13ACC5
#define REG_BK13AC_63_L      0x13ACC6
#define REG_BK13AC_63_H      0x13ACC7
#define REG_BK13AC_64_L      0x13ACC8
#define REG_BK13AC_64_H      0x13ACC9
#define REG_BK13AC_65_L      0x13ACCA
#define REG_BK13AC_65_H      0x13ACCB
#define REG_BK13AC_66_L      0x13ACCC
#define REG_BK13AC_66_H      0x13ACCD
#define REG_BK13AC_67_L      0x13ACCE
#define REG_BK13AC_67_H      0x13ACCF
#define REG_BK13AC_68_L      0x13ACD0
#define REG_BK13AC_68_H      0x13ACD1
#define REG_BK13AC_69_L      0x13ACD2
#define REG_BK13AC_69_H      0x13ACD3
#define REG_BK13AC_6A_L      0x13ACD4
#define REG_BK13AC_6A_H      0x13ACD5
#define REG_BK13AC_6B_L      0x13ACD6
#define REG_BK13AC_6B_H      0x13ACD7
#define REG_BK13AC_6C_L      0x13ACD8
#define REG_BK13AC_6C_H      0x13ACD9
#define REG_BK13AC_6D_L      0x13ACDA
#define REG_BK13AC_6D_H      0x13ACDB
#define REG_BK13AC_6E_L      0x13ACDC
#define REG_BK13AC_6E_H      0x13ACDD
#define REG_BK13AC_6F_L      0x13ACDE
#define REG_BK13AC_6F_H      0x13ACDF
#define REG_BK13AC_70_L      0x13ACE0
#define REG_BK13AC_70_H      0x13ACE1
#define REG_BK13AC_71_L      0x13ACE2
#define REG_BK13AC_71_H      0x13ACE3
#define REG_BK13AC_72_L      0x13ACE4
#define REG_BK13AC_72_H      0x13ACE5
#define REG_BK13AC_73_L      0x13ACE6
#define REG_BK13AC_73_H      0x13ACE7
#define REG_BK13AC_74_L      0x13ACE8
#define REG_BK13AC_74_H      0x13ACE9
#define REG_BK13AC_75_L      0x13ACEA
#define REG_BK13AC_75_H      0x13ACEB
#define REG_BK13AC_76_L      0x13ACEC
#define REG_BK13AC_76_H      0x13ACED
#define REG_BK13AC_77_L      0x13ACEE
#define REG_BK13AC_77_H      0x13ACEF
#define REG_BK13AC_78_L      0x13ACF0
#define REG_BK13AC_78_H      0x13ACF1
#define REG_BK13AC_79_L      0x13ACF2
#define REG_BK13AC_79_H      0x13ACF3
#define REG_BK13AC_7A_L      0x13ACF4
#define REG_BK13AC_7A_H      0x13ACF5
#define REG_BK13AC_7B_L      0x13ACF6
#define REG_BK13AC_7B_H      0x13ACF7
#define REG_BK13AC_7C_L      0x13ACF8
#define REG_BK13AC_7C_H      0x13ACF9
#define REG_BK13AC_7D_L      0x13ACFA
#define REG_BK13AC_7D_H      0x13ACFB
#define REG_BK13AC_7E_L      0x13ACFC
#define REG_BK13AC_7E_H      0x13ACFD
#define REG_BK13AC_7F_L      0x13ACFE
#define REG_BK13AC_7F_H      0x13ACFF
//----------------------------------------------
#define REG_BK13AD_00_L      0x13AD00
#define REG_BK13AD_00_H      0x13AD01
#define REG_BK13AD_01_L      0x13AD02
#define REG_BK13AD_01_H      0x13AD03
#define REG_BK13AD_02_L      0x13AD04
#define REG_BK13AD_02_H      0x13AD05
#define REG_BK13AD_03_L      0x13AD06
#define REG_BK13AD_03_H      0x13AD07
#define REG_BK13AD_04_L      0x13AD08
#define REG_BK13AD_04_H      0x13AD09
#define REG_BK13AD_05_L      0x13AD0A
#define REG_BK13AD_05_H      0x13AD0B
#define REG_BK13AD_06_L      0x13AD0C
#define REG_BK13AD_06_H      0x13AD0D
#define REG_BK13AD_07_L      0x13AD0E
#define REG_BK13AD_07_H      0x13AD0F
#define REG_BK13AD_08_L      0x13AD10
#define REG_BK13AD_08_H      0x13AD11
#define REG_BK13AD_09_L      0x13AD12
#define REG_BK13AD_09_H      0x13AD13
#define REG_BK13AD_0A_L      0x13AD14
#define REG_BK13AD_0A_H      0x13AD15
#define REG_BK13AD_0B_L      0x13AD16
#define REG_BK13AD_0B_H      0x13AD17
#define REG_BK13AD_0C_L      0x13AD18
#define REG_BK13AD_0C_H      0x13AD19
#define REG_BK13AD_0D_L      0x13AD1A
#define REG_BK13AD_0D_H      0x13AD1B
#define REG_BK13AD_0E_L      0x13AD1C
#define REG_BK13AD_0E_H      0x13AD1D
#define REG_BK13AD_0F_L      0x13AD1E
#define REG_BK13AD_0F_H      0x13AD1F
#define REG_BK13AD_10_L      0x13AD20
#define REG_BK13AD_10_H      0x13AD21
#define REG_BK13AD_11_L      0x13AD22
#define REG_BK13AD_11_H      0x13AD23
#define REG_BK13AD_12_L      0x13AD24
#define REG_BK13AD_12_H      0x13AD25
#define REG_BK13AD_13_L      0x13AD26
#define REG_BK13AD_13_H      0x13AD27
#define REG_BK13AD_14_L      0x13AD28
#define REG_BK13AD_14_H      0x13AD29
#define REG_BK13AD_15_L      0x13AD2A
#define REG_BK13AD_15_H      0x13AD2B
#define REG_BK13AD_16_L      0x13AD2C
#define REG_BK13AD_16_H      0x13AD2D
#define REG_BK13AD_17_L      0x13AD2E
#define REG_BK13AD_17_H      0x13AD2F
#define REG_BK13AD_18_L      0x13AD30
#define REG_BK13AD_18_H      0x13AD31
#define REG_BK13AD_19_L      0x13AD32
#define REG_BK13AD_19_H      0x13AD33
#define REG_BK13AD_1A_L      0x13AD34
#define REG_BK13AD_1A_H      0x13AD35
#define REG_BK13AD_1B_L      0x13AD36
#define REG_BK13AD_1B_H      0x13AD37
#define REG_BK13AD_1C_L      0x13AD38
#define REG_BK13AD_1C_H      0x13AD39
#define REG_BK13AD_1D_L      0x13AD3A
#define REG_BK13AD_1D_H      0x13AD3B
#define REG_BK13AD_1E_L      0x13AD3C
#define REG_BK13AD_1E_H      0x13AD3D
#define REG_BK13AD_1F_L      0x13AD3E
#define REG_BK13AD_1F_H      0x13AD3F
#define REG_BK13AD_20_L      0x13AD40
#define REG_BK13AD_20_H      0x13AD41
#define REG_BK13AD_21_L      0x13AD42
#define REG_BK13AD_21_H      0x13AD43
#define REG_BK13AD_22_L      0x13AD44
#define REG_BK13AD_22_H      0x13AD45
#define REG_BK13AD_23_L      0x13AD46
#define REG_BK13AD_23_H      0x13AD47
#define REG_BK13AD_24_L      0x13AD48
#define REG_BK13AD_24_H      0x13AD49
#define REG_BK13AD_25_L      0x13AD4A
#define REG_BK13AD_25_H      0x13AD4B
#define REG_BK13AD_26_L      0x13AD4C
#define REG_BK13AD_26_H      0x13AD4D
#define REG_BK13AD_27_L      0x13AD4E
#define REG_BK13AD_27_H      0x13AD4F
#define REG_BK13AD_28_L      0x13AD50
#define REG_BK13AD_28_H      0x13AD51
#define REG_BK13AD_29_L      0x13AD52
#define REG_BK13AD_29_H      0x13AD53
#define REG_BK13AD_2A_L      0x13AD54
#define REG_BK13AD_2A_H      0x13AD55
#define REG_BK13AD_2B_L      0x13AD56
#define REG_BK13AD_2B_H      0x13AD57
#define REG_BK13AD_2C_L      0x13AD58
#define REG_BK13AD_2C_H      0x13AD59
#define REG_BK13AD_2D_L      0x13AD5A
#define REG_BK13AD_2D_H      0x13AD5B
#define REG_BK13AD_2E_L      0x13AD5C
#define REG_BK13AD_2E_H      0x13AD5D
#define REG_BK13AD_2F_L      0x13AD5E
#define REG_BK13AD_2F_H      0x13AD5F
#define REG_BK13AD_30_L      0x13AD60
#define REG_BK13AD_30_H      0x13AD61
#define REG_BK13AD_31_L      0x13AD62
#define REG_BK13AD_31_H      0x13AD63
#define REG_BK13AD_32_L      0x13AD64
#define REG_BK13AD_32_H      0x13AD65
#define REG_BK13AD_33_L      0x13AD66
#define REG_BK13AD_33_H      0x13AD67
#define REG_BK13AD_34_L      0x13AD68
#define REG_BK13AD_34_H      0x13AD69
#define REG_BK13AD_35_L      0x13AD6A
#define REG_BK13AD_35_H      0x13AD6B
#define REG_BK13AD_36_L      0x13AD6C
#define REG_BK13AD_36_H      0x13AD6D
#define REG_BK13AD_37_L      0x13AD6E
#define REG_BK13AD_37_H      0x13AD6F
#define REG_BK13AD_38_L      0x13AD70
#define REG_BK13AD_38_H      0x13AD71
#define REG_BK13AD_39_L      0x13AD72
#define REG_BK13AD_39_H      0x13AD73
#define REG_BK13AD_3A_L      0x13AD74
#define REG_BK13AD_3A_H      0x13AD75
#define REG_BK13AD_3B_L      0x13AD76
#define REG_BK13AD_3B_H      0x13AD77
#define REG_BK13AD_3C_L      0x13AD78
#define REG_BK13AD_3C_H      0x13AD79
#define REG_BK13AD_3D_L      0x13AD7A
#define REG_BK13AD_3D_H      0x13AD7B
#define REG_BK13AD_3E_L      0x13AD7C
#define REG_BK13AD_3E_H      0x13AD7D
#define REG_BK13AD_3F_L      0x13AD7E
#define REG_BK13AD_3F_H      0x13AD7F
#define REG_BK13AD_40_L      0x13AD80
#define REG_BK13AD_40_H      0x13AD81
#define REG_BK13AD_41_L      0x13AD82
#define REG_BK13AD_41_H      0x13AD83
#define REG_BK13AD_42_L      0x13AD84
#define REG_BK13AD_42_H      0x13AD85
#define REG_BK13AD_43_L      0x13AD86
#define REG_BK13AD_43_H      0x13AD87
#define REG_BK13AD_44_L      0x13AD88
#define REG_BK13AD_44_H      0x13AD89
#define REG_BK13AD_45_L      0x13AD8A
#define REG_BK13AD_45_H      0x13AD8B
#define REG_BK13AD_46_L      0x13AD8C
#define REG_BK13AD_46_H      0x13AD8D
#define REG_BK13AD_47_L      0x13AD8E
#define REG_BK13AD_47_H      0x13AD8F
#define REG_BK13AD_48_L      0x13AD90
#define REG_BK13AD_48_H      0x13AD91
#define REG_BK13AD_49_L      0x13AD92
#define REG_BK13AD_49_H      0x13AD93
#define REG_BK13AD_4A_L      0x13AD94
#define REG_BK13AD_4A_H      0x13AD95
#define REG_BK13AD_4B_L      0x13AD96
#define REG_BK13AD_4B_H      0x13AD97
#define REG_BK13AD_4C_L      0x13AD98
#define REG_BK13AD_4C_H      0x13AD99
#define REG_BK13AD_4D_L      0x13AD9A
#define REG_BK13AD_4D_H      0x13AD9B
#define REG_BK13AD_4E_L      0x13AD9C
#define REG_BK13AD_4E_H      0x13AD9D
#define REG_BK13AD_4F_L      0x13AD9E
#define REG_BK13AD_4F_H      0x13AD9F
#define REG_BK13AD_50_L      0x13ADA0
#define REG_BK13AD_50_H      0x13ADA1
#define REG_BK13AD_51_L      0x13ADA2
#define REG_BK13AD_51_H      0x13ADA3
#define REG_BK13AD_52_L      0x13ADA4
#define REG_BK13AD_52_H      0x13ADA5
#define REG_BK13AD_53_L      0x13ADA6
#define REG_BK13AD_53_H      0x13ADA7
#define REG_BK13AD_54_L      0x13ADA8
#define REG_BK13AD_54_H      0x13ADA9
#define REG_BK13AD_55_L      0x13ADAA
#define REG_BK13AD_55_H      0x13ADAB
#define REG_BK13AD_56_L      0x13ADAC
#define REG_BK13AD_56_H      0x13ADAD
#define REG_BK13AD_57_L      0x13ADAE
#define REG_BK13AD_57_H      0x13ADAF
#define REG_BK13AD_58_L      0x13ADB0
#define REG_BK13AD_58_H      0x13ADB1
#define REG_BK13AD_59_L      0x13ADB2
#define REG_BK13AD_59_H      0x13ADB3
#define REG_BK13AD_5A_L      0x13ADB4
#define REG_BK13AD_5A_H      0x13ADB5
#define REG_BK13AD_5B_L      0x13ADB6
#define REG_BK13AD_5B_H      0x13ADB7
#define REG_BK13AD_5C_L      0x13ADB8
#define REG_BK13AD_5C_H      0x13ADB9
#define REG_BK13AD_5D_L      0x13ADBA
#define REG_BK13AD_5D_H      0x13ADBB
#define REG_BK13AD_5E_L      0x13ADBC
#define REG_BK13AD_5E_H      0x13ADBD
#define REG_BK13AD_5F_L      0x13ADBE
#define REG_BK13AD_5F_H      0x13ADBF
#define REG_BK13AD_60_L      0x13ADC0
#define REG_BK13AD_60_H      0x13ADC1
#define REG_BK13AD_61_L      0x13ADC2
#define REG_BK13AD_61_H      0x13ADC3
#define REG_BK13AD_62_L      0x13ADC4
#define REG_BK13AD_62_H      0x13ADC5
#define REG_BK13AD_63_L      0x13ADC6
#define REG_BK13AD_63_H      0x13ADC7
#define REG_BK13AD_64_L      0x13ADC8
#define REG_BK13AD_64_H      0x13ADC9
#define REG_BK13AD_65_L      0x13ADCA
#define REG_BK13AD_65_H      0x13ADCB
#define REG_BK13AD_66_L      0x13ADCC
#define REG_BK13AD_66_H      0x13ADCD
#define REG_BK13AD_67_L      0x13ADCE
#define REG_BK13AD_67_H      0x13ADCF
#define REG_BK13AD_68_L      0x13ADD0
#define REG_BK13AD_68_H      0x13ADD1
#define REG_BK13AD_69_L      0x13ADD2
#define REG_BK13AD_69_H      0x13ADD3
#define REG_BK13AD_6A_L      0x13ADD4
#define REG_BK13AD_6A_H      0x13ADD5
#define REG_BK13AD_6B_L      0x13ADD6
#define REG_BK13AD_6B_H      0x13ADD7
#define REG_BK13AD_6C_L      0x13ADD8
#define REG_BK13AD_6C_H      0x13ADD9
#define REG_BK13AD_6D_L      0x13ADDA
#define REG_BK13AD_6D_H      0x13ADDB
#define REG_BK13AD_6E_L      0x13ADDC
#define REG_BK13AD_6E_H      0x13ADDD
#define REG_BK13AD_6F_L      0x13ADDE
#define REG_BK13AD_6F_H      0x13ADDF
#define REG_BK13AD_70_L      0x13ADE0
#define REG_BK13AD_70_H      0x13ADE1
#define REG_BK13AD_71_L      0x13ADE2
#define REG_BK13AD_71_H      0x13ADE3
#define REG_BK13AD_72_L      0x13ADE4
#define REG_BK13AD_72_H      0x13ADE5
#define REG_BK13AD_73_L      0x13ADE6
#define REG_BK13AD_73_H      0x13ADE7
#define REG_BK13AD_74_L      0x13ADE8
#define REG_BK13AD_74_H      0x13ADE9
#define REG_BK13AD_75_L      0x13ADEA
#define REG_BK13AD_75_H      0x13ADEB
#define REG_BK13AD_76_L      0x13ADEC
#define REG_BK13AD_76_H      0x13ADED
#define REG_BK13AD_77_L      0x13ADEE
#define REG_BK13AD_77_H      0x13ADEF
#define REG_BK13AD_78_L      0x13ADF0
#define REG_BK13AD_78_H      0x13ADF1
#define REG_BK13AD_79_L      0x13ADF2
#define REG_BK13AD_79_H      0x13ADF3
#define REG_BK13AD_7A_L      0x13ADF4
#define REG_BK13AD_7A_H      0x13ADF5
#define REG_BK13AD_7B_L      0x13ADF6
#define REG_BK13AD_7B_H      0x13ADF7
#define REG_BK13AD_7C_L      0x13ADF8
#define REG_BK13AD_7C_H      0x13ADF9
#define REG_BK13AD_7D_L      0x13ADFA
#define REG_BK13AD_7D_H      0x13ADFB
#define REG_BK13AD_7E_L      0x13ADFC
#define REG_BK13AD_7E_H      0x13ADFD
#define REG_BK13AD_7F_L      0x13ADFE
#define REG_BK13AD_7F_H      0x13ADFF
//----------------------------------------------
#define REG_BK13B0_00_L      0x13B000
#define REG_BK13B0_00_H      0x13B001
#define REG_BK13B0_01_L      0x13B002
#define REG_BK13B0_01_H      0x13B003
#define REG_BK13B0_02_L      0x13B004
#define REG_BK13B0_02_H      0x13B005
#define REG_BK13B0_03_L      0x13B006
#define REG_BK13B0_03_H      0x13B007
#define REG_BK13B0_04_L      0x13B008
#define REG_BK13B0_04_H      0x13B009
#define REG_BK13B0_05_L      0x13B00A
#define REG_BK13B0_05_H      0x13B00B
#define REG_BK13B0_06_L      0x13B00C
#define REG_BK13B0_06_H      0x13B00D
#define REG_BK13B0_07_L      0x13B00E
#define REG_BK13B0_07_H      0x13B00F
#define REG_BK13B0_08_L      0x13B010
#define REG_BK13B0_08_H      0x13B011
#define REG_BK13B0_09_L      0x13B012
#define REG_BK13B0_09_H      0x13B013
#define REG_BK13B0_0A_L      0x13B014
#define REG_BK13B0_0A_H      0x13B015
#define REG_BK13B0_0B_L      0x13B016
#define REG_BK13B0_0B_H      0x13B017
#define REG_BK13B0_0C_L      0x13B018
#define REG_BK13B0_0C_H      0x13B019
#define REG_BK13B0_0D_L      0x13B01A
#define REG_BK13B0_0D_H      0x13B01B
#define REG_BK13B0_0E_L      0x13B01C
#define REG_BK13B0_0E_H      0x13B01D
#define REG_BK13B0_0F_L      0x13B01E
#define REG_BK13B0_0F_H      0x13B01F
#define REG_BK13B0_10_L      0x13B020
#define REG_BK13B0_10_H      0x13B021
#define REG_BK13B0_11_L      0x13B022
#define REG_BK13B0_11_H      0x13B023
#define REG_BK13B0_12_L      0x13B024
#define REG_BK13B0_12_H      0x13B025
#define REG_BK13B0_13_L      0x13B026
#define REG_BK13B0_13_H      0x13B027
#define REG_BK13B0_14_L      0x13B028
#define REG_BK13B0_14_H      0x13B029
#define REG_BK13B0_15_L      0x13B02A
#define REG_BK13B0_15_H      0x13B02B
#define REG_BK13B0_16_L      0x13B02C
#define REG_BK13B0_16_H      0x13B02D
#define REG_BK13B0_17_L      0x13B02E
#define REG_BK13B0_17_H      0x13B02F
#define REG_BK13B0_18_L      0x13B030
#define REG_BK13B0_18_H      0x13B031
#define REG_BK13B0_19_L      0x13B032
#define REG_BK13B0_19_H      0x13B033
#define REG_BK13B0_1A_L      0x13B034
#define REG_BK13B0_1A_H      0x13B035
#define REG_BK13B0_1B_L      0x13B036
#define REG_BK13B0_1B_H      0x13B037
#define REG_BK13B0_1C_L      0x13B038
#define REG_BK13B0_1C_H      0x13B039
#define REG_BK13B0_1D_L      0x13B03A
#define REG_BK13B0_1D_H      0x13B03B
#define REG_BK13B0_1E_L      0x13B03C
#define REG_BK13B0_1E_H      0x13B03D
#define REG_BK13B0_1F_L      0x13B03E
#define REG_BK13B0_1F_H      0x13B03F
#define REG_BK13B0_20_L      0x13B040
#define REG_BK13B0_20_H      0x13B041
#define REG_BK13B0_21_L      0x13B042
#define REG_BK13B0_21_H      0x13B043
#define REG_BK13B0_22_L      0x13B044
#define REG_BK13B0_22_H      0x13B045
#define REG_BK13B0_23_L      0x13B046
#define REG_BK13B0_23_H      0x13B047
#define REG_BK13B0_24_L      0x13B048
#define REG_BK13B0_24_H      0x13B049
#define REG_BK13B0_25_L      0x13B04A
#define REG_BK13B0_25_H      0x13B04B
#define REG_BK13B0_26_L      0x13B04C
#define REG_BK13B0_26_H      0x13B04D
#define REG_BK13B0_27_L      0x13B04E
#define REG_BK13B0_27_H      0x13B04F
#define REG_BK13B0_28_L      0x13B050
#define REG_BK13B0_28_H      0x13B051
#define REG_BK13B0_29_L      0x13B052
#define REG_BK13B0_29_H      0x13B053
#define REG_BK13B0_2A_L      0x13B054
#define REG_BK13B0_2A_H      0x13B055
#define REG_BK13B0_2B_L      0x13B056
#define REG_BK13B0_2B_H      0x13B057
#define REG_BK13B0_2C_L      0x13B058
#define REG_BK13B0_2C_H      0x13B059
#define REG_BK13B0_2D_L      0x13B05A
#define REG_BK13B0_2D_H      0x13B05B
#define REG_BK13B0_2E_L      0x13B05C
#define REG_BK13B0_2E_H      0x13B05D
#define REG_BK13B0_2F_L      0x13B05E
#define REG_BK13B0_2F_H      0x13B05F
#define REG_BK13B0_30_L      0x13B060
#define REG_BK13B0_30_H      0x13B061
#define REG_BK13B0_31_L      0x13B062
#define REG_BK13B0_31_H      0x13B063
#define REG_BK13B0_32_L      0x13B064
#define REG_BK13B0_32_H      0x13B065
#define REG_BK13B0_33_L      0x13B066
#define REG_BK13B0_33_H      0x13B067
#define REG_BK13B0_34_L      0x13B068
#define REG_BK13B0_34_H      0x13B069
#define REG_BK13B0_35_L      0x13B06A
#define REG_BK13B0_35_H      0x13B06B
#define REG_BK13B0_36_L      0x13B06C
#define REG_BK13B0_36_H      0x13B06D
#define REG_BK13B0_37_L      0x13B06E
#define REG_BK13B0_37_H      0x13B06F
#define REG_BK13B0_38_L      0x13B070
#define REG_BK13B0_38_H      0x13B071
#define REG_BK13B0_39_L      0x13B072
#define REG_BK13B0_39_H      0x13B073
#define REG_BK13B0_3A_L      0x13B074
#define REG_BK13B0_3A_H      0x13B075
#define REG_BK13B0_3B_L      0x13B076
#define REG_BK13B0_3B_H      0x13B077
#define REG_BK13B0_3C_L      0x13B078
#define REG_BK13B0_3C_H      0x13B079
#define REG_BK13B0_3D_L      0x13B07A
#define REG_BK13B0_3D_H      0x13B07B
#define REG_BK13B0_3E_L      0x13B07C
#define REG_BK13B0_3E_H      0x13B07D
#define REG_BK13B0_3F_L      0x13B07E
#define REG_BK13B0_3F_H      0x13B07F
#define REG_BK13B0_40_L      0x13B080
#define REG_BK13B0_40_H      0x13B081
#define REG_BK13B0_41_L      0x13B082
#define REG_BK13B0_41_H      0x13B083
#define REG_BK13B0_42_L      0x13B084
#define REG_BK13B0_42_H      0x13B085
#define REG_BK13B0_43_L      0x13B086
#define REG_BK13B0_43_H      0x13B087
#define REG_BK13B0_44_L      0x13B088
#define REG_BK13B0_44_H      0x13B089
#define REG_BK13B0_45_L      0x13B08A
#define REG_BK13B0_45_H      0x13B08B
#define REG_BK13B0_46_L      0x13B08C
#define REG_BK13B0_46_H      0x13B08D
#define REG_BK13B0_47_L      0x13B08E
#define REG_BK13B0_47_H      0x13B08F
#define REG_BK13B0_48_L      0x13B090
#define REG_BK13B0_48_H      0x13B091
#define REG_BK13B0_49_L      0x13B092
#define REG_BK13B0_49_H      0x13B093
#define REG_BK13B0_4A_L      0x13B094
#define REG_BK13B0_4A_H      0x13B095
#define REG_BK13B0_4B_L      0x13B096
#define REG_BK13B0_4B_H      0x13B097
#define REG_BK13B0_4C_L      0x13B098
#define REG_BK13B0_4C_H      0x13B099
#define REG_BK13B0_4D_L      0x13B09A
#define REG_BK13B0_4D_H      0x13B09B
#define REG_BK13B0_4E_L      0x13B09C
#define REG_BK13B0_4E_H      0x13B09D
#define REG_BK13B0_4F_L      0x13B09E
#define REG_BK13B0_4F_H      0x13B09F
#define REG_BK13B0_50_L      0x13B0A0
#define REG_BK13B0_50_H      0x13B0A1
#define REG_BK13B0_51_L      0x13B0A2
#define REG_BK13B0_51_H      0x13B0A3
#define REG_BK13B0_52_L      0x13B0A4
#define REG_BK13B0_52_H      0x13B0A5
#define REG_BK13B0_53_L      0x13B0A6
#define REG_BK13B0_53_H      0x13B0A7
#define REG_BK13B0_54_L      0x13B0A8
#define REG_BK13B0_54_H      0x13B0A9
#define REG_BK13B0_55_L      0x13B0AA
#define REG_BK13B0_55_H      0x13B0AB
#define REG_BK13B0_56_L      0x13B0AC
#define REG_BK13B0_56_H      0x13B0AD
#define REG_BK13B0_57_L      0x13B0AE
#define REG_BK13B0_57_H      0x13B0AF
#define REG_BK13B0_58_L      0x13B0B0
#define REG_BK13B0_58_H      0x13B0B1
#define REG_BK13B0_59_L      0x13B0B2
#define REG_BK13B0_59_H      0x13B0B3
#define REG_BK13B0_5A_L      0x13B0B4
#define REG_BK13B0_5A_H      0x13B0B5
#define REG_BK13B0_5B_L      0x13B0B6
#define REG_BK13B0_5B_H      0x13B0B7
#define REG_BK13B0_5C_L      0x13B0B8
#define REG_BK13B0_5C_H      0x13B0B9
#define REG_BK13B0_5D_L      0x13B0BA
#define REG_BK13B0_5D_H      0x13B0BB
#define REG_BK13B0_5E_L      0x13B0BC
#define REG_BK13B0_5E_H      0x13B0BD
#define REG_BK13B0_5F_L      0x13B0BE
#define REG_BK13B0_5F_H      0x13B0BF
#define REG_BK13B0_60_L      0x13B0C0
#define REG_BK13B0_60_H      0x13B0C1
#define REG_BK13B0_61_L      0x13B0C2
#define REG_BK13B0_61_H      0x13B0C3
#define REG_BK13B0_62_L      0x13B0C4
#define REG_BK13B0_62_H      0x13B0C5
#define REG_BK13B0_63_L      0x13B0C6
#define REG_BK13B0_63_H      0x13B0C7
#define REG_BK13B0_64_L      0x13B0C8
#define REG_BK13B0_64_H      0x13B0C9
#define REG_BK13B0_65_L      0x13B0CA
#define REG_BK13B0_65_H      0x13B0CB
#define REG_BK13B0_66_L      0x13B0CC
#define REG_BK13B0_66_H      0x13B0CD
#define REG_BK13B0_67_L      0x13B0CE
#define REG_BK13B0_67_H      0x13B0CF
#define REG_BK13B0_68_L      0x13B0D0
#define REG_BK13B0_68_H      0x13B0D1
#define REG_BK13B0_69_L      0x13B0D2
#define REG_BK13B0_69_H      0x13B0D3
#define REG_BK13B0_6A_L      0x13B0D4
#define REG_BK13B0_6A_H      0x13B0D5
#define REG_BK13B0_6B_L      0x13B0D6
#define REG_BK13B0_6B_H      0x13B0D7
#define REG_BK13B0_6C_L      0x13B0D8
#define REG_BK13B0_6C_H      0x13B0D9
#define REG_BK13B0_6D_L      0x13B0DA
#define REG_BK13B0_6D_H      0x13B0DB
#define REG_BK13B0_6E_L      0x13B0DC
#define REG_BK13B0_6E_H      0x13B0DD
#define REG_BK13B0_6F_L      0x13B0DE
#define REG_BK13B0_6F_H      0x13B0DF
#define REG_BK13B0_70_L      0x13B0E0
#define REG_BK13B0_70_H      0x13B0E1
#define REG_BK13B0_71_L      0x13B0E2
#define REG_BK13B0_71_H      0x13B0E3
#define REG_BK13B0_72_L      0x13B0E4
#define REG_BK13B0_72_H      0x13B0E5
#define REG_BK13B0_73_L      0x13B0E6
#define REG_BK13B0_73_H      0x13B0E7
#define REG_BK13B0_74_L      0x13B0E8
#define REG_BK13B0_74_H      0x13B0E9
#define REG_BK13B0_75_L      0x13B0EA
#define REG_BK13B0_75_H      0x13B0EB
#define REG_BK13B0_76_L      0x13B0EC
#define REG_BK13B0_76_H      0x13B0ED
#define REG_BK13B0_77_L      0x13B0EE
#define REG_BK13B0_77_H      0x13B0EF
#define REG_BK13B0_78_L      0x13B0F0
#define REG_BK13B0_78_H      0x13B0F1
#define REG_BK13B0_79_L      0x13B0F2
#define REG_BK13B0_79_H      0x13B0F3
#define REG_BK13B0_7A_L      0x13B0F4
#define REG_BK13B0_7A_H      0x13B0F5
#define REG_BK13B0_7B_L      0x13B0F6
#define REG_BK13B0_7B_H      0x13B0F7
#define REG_BK13B0_7C_L      0x13B0F8
#define REG_BK13B0_7C_H      0x13B0F9
#define REG_BK13B0_7D_L      0x13B0FA
#define REG_BK13B0_7D_H      0x13B0FB
#define REG_BK13B0_7E_L      0x13B0FC
#define REG_BK13B0_7E_H      0x13B0FD
#define REG_BK13B0_7F_L      0x13B0FE
#define REG_BK13B0_7F_H      0x13B0FF
//----------------------------------------------
#define REG_BK13B1_00_L      0x13B100
#define REG_BK13B1_00_H      0x13B101
#define REG_BK13B1_01_L      0x13B102
#define REG_BK13B1_01_H      0x13B103
#define REG_BK13B1_02_L      0x13B104
#define REG_BK13B1_02_H      0x13B105
#define REG_BK13B1_03_L      0x13B106
#define REG_BK13B1_03_H      0x13B107
#define REG_BK13B1_04_L      0x13B108
#define REG_BK13B1_04_H      0x13B109
#define REG_BK13B1_05_L      0x13B10A
#define REG_BK13B1_05_H      0x13B10B
#define REG_BK13B1_06_L      0x13B10C
#define REG_BK13B1_06_H      0x13B10D
#define REG_BK13B1_07_L      0x13B10E
#define REG_BK13B1_07_H      0x13B10F
#define REG_BK13B1_08_L      0x13B110
#define REG_BK13B1_08_H      0x13B111
#define REG_BK13B1_09_L      0x13B112
#define REG_BK13B1_09_H      0x13B113
#define REG_BK13B1_0A_L      0x13B114
#define REG_BK13B1_0A_H      0x13B115
#define REG_BK13B1_0B_L      0x13B116
#define REG_BK13B1_0B_H      0x13B117
#define REG_BK13B1_0C_L      0x13B118
#define REG_BK13B1_0C_H      0x13B119
#define REG_BK13B1_0D_L      0x13B11A
#define REG_BK13B1_0D_H      0x13B11B
#define REG_BK13B1_0E_L      0x13B11C
#define REG_BK13B1_0E_H      0x13B11D
#define REG_BK13B1_0F_L      0x13B11E
#define REG_BK13B1_0F_H      0x13B11F
#define REG_BK13B1_10_L      0x13B120
#define REG_BK13B1_10_H      0x13B121
#define REG_BK13B1_11_L      0x13B122
#define REG_BK13B1_11_H      0x13B123
#define REG_BK13B1_12_L      0x13B124
#define REG_BK13B1_12_H      0x13B125
#define REG_BK13B1_13_L      0x13B126
#define REG_BK13B1_13_H      0x13B127
#define REG_BK13B1_14_L      0x13B128
#define REG_BK13B1_14_H      0x13B129
#define REG_BK13B1_15_L      0x13B12A
#define REG_BK13B1_15_H      0x13B12B
#define REG_BK13B1_16_L      0x13B12C
#define REG_BK13B1_16_H      0x13B12D
#define REG_BK13B1_17_L      0x13B12E
#define REG_BK13B1_17_H      0x13B12F
#define REG_BK13B1_18_L      0x13B130
#define REG_BK13B1_18_H      0x13B131
#define REG_BK13B1_19_L      0x13B132
#define REG_BK13B1_19_H      0x13B133
#define REG_BK13B1_1A_L      0x13B134
#define REG_BK13B1_1A_H      0x13B135
#define REG_BK13B1_1B_L      0x13B136
#define REG_BK13B1_1B_H      0x13B137
#define REG_BK13B1_1C_L      0x13B138
#define REG_BK13B1_1C_H      0x13B139
#define REG_BK13B1_1D_L      0x13B13A
#define REG_BK13B1_1D_H      0x13B13B
#define REG_BK13B1_1E_L      0x13B13C
#define REG_BK13B1_1E_H      0x13B13D
#define REG_BK13B1_1F_L      0x13B13E
#define REG_BK13B1_1F_H      0x13B13F
#define REG_BK13B1_20_L      0x13B140
#define REG_BK13B1_20_H      0x13B141
#define REG_BK13B1_21_L      0x13B142
#define REG_BK13B1_21_H      0x13B143
#define REG_BK13B1_22_L      0x13B144
#define REG_BK13B1_22_H      0x13B145
#define REG_BK13B1_23_L      0x13B146
#define REG_BK13B1_23_H      0x13B147
#define REG_BK13B1_24_L      0x13B148
#define REG_BK13B1_24_H      0x13B149
#define REG_BK13B1_25_L      0x13B14A
#define REG_BK13B1_25_H      0x13B14B
#define REG_BK13B1_26_L      0x13B14C
#define REG_BK13B1_26_H      0x13B14D
#define REG_BK13B1_27_L      0x13B14E
#define REG_BK13B1_27_H      0x13B14F
#define REG_BK13B1_28_L      0x13B150
#define REG_BK13B1_28_H      0x13B151
#define REG_BK13B1_29_L      0x13B152
#define REG_BK13B1_29_H      0x13B153
#define REG_BK13B1_2A_L      0x13B154
#define REG_BK13B1_2A_H      0x13B155
#define REG_BK13B1_2B_L      0x13B156
#define REG_BK13B1_2B_H      0x13B157
#define REG_BK13B1_2C_L      0x13B158
#define REG_BK13B1_2C_H      0x13B159
#define REG_BK13B1_2D_L      0x13B15A
#define REG_BK13B1_2D_H      0x13B15B
#define REG_BK13B1_2E_L      0x13B15C
#define REG_BK13B1_2E_H      0x13B15D
#define REG_BK13B1_2F_L      0x13B15E
#define REG_BK13B1_2F_H      0x13B15F
#define REG_BK13B1_30_L      0x13B160
#define REG_BK13B1_30_H      0x13B161
#define REG_BK13B1_31_L      0x13B162
#define REG_BK13B1_31_H      0x13B163
#define REG_BK13B1_32_L      0x13B164
#define REG_BK13B1_32_H      0x13B165
#define REG_BK13B1_33_L      0x13B166
#define REG_BK13B1_33_H      0x13B167
#define REG_BK13B1_34_L      0x13B168
#define REG_BK13B1_34_H      0x13B169
#define REG_BK13B1_35_L      0x13B16A
#define REG_BK13B1_35_H      0x13B16B
#define REG_BK13B1_36_L      0x13B16C
#define REG_BK13B1_36_H      0x13B16D
#define REG_BK13B1_37_L      0x13B16E
#define REG_BK13B1_37_H      0x13B16F
#define REG_BK13B1_38_L      0x13B170
#define REG_BK13B1_38_H      0x13B171
#define REG_BK13B1_39_L      0x13B172
#define REG_BK13B1_39_H      0x13B173
#define REG_BK13B1_3A_L      0x13B174
#define REG_BK13B1_3A_H      0x13B175
#define REG_BK13B1_3B_L      0x13B176
#define REG_BK13B1_3B_H      0x13B177
#define REG_BK13B1_3C_L      0x13B178
#define REG_BK13B1_3C_H      0x13B179
#define REG_BK13B1_3D_L      0x13B17A
#define REG_BK13B1_3D_H      0x13B17B
#define REG_BK13B1_3E_L      0x13B17C
#define REG_BK13B1_3E_H      0x13B17D
#define REG_BK13B1_3F_L      0x13B17E
#define REG_BK13B1_3F_H      0x13B17F
#define REG_BK13B1_40_L      0x13B180
#define REG_BK13B1_40_H      0x13B181
#define REG_BK13B1_41_L      0x13B182
#define REG_BK13B1_41_H      0x13B183
#define REG_BK13B1_42_L      0x13B184
#define REG_BK13B1_42_H      0x13B185
#define REG_BK13B1_43_L      0x13B186
#define REG_BK13B1_43_H      0x13B187
#define REG_BK13B1_44_L      0x13B188
#define REG_BK13B1_44_H      0x13B189
#define REG_BK13B1_45_L      0x13B18A
#define REG_BK13B1_45_H      0x13B18B
#define REG_BK13B1_46_L      0x13B18C
#define REG_BK13B1_46_H      0x13B18D
#define REG_BK13B1_47_L      0x13B18E
#define REG_BK13B1_47_H      0x13B18F
#define REG_BK13B1_48_L      0x13B190
#define REG_BK13B1_48_H      0x13B191
#define REG_BK13B1_49_L      0x13B192
#define REG_BK13B1_49_H      0x13B193
#define REG_BK13B1_4A_L      0x13B194
#define REG_BK13B1_4A_H      0x13B195
#define REG_BK13B1_4B_L      0x13B196
#define REG_BK13B1_4B_H      0x13B197
#define REG_BK13B1_4C_L      0x13B198
#define REG_BK13B1_4C_H      0x13B199
#define REG_BK13B1_4D_L      0x13B19A
#define REG_BK13B1_4D_H      0x13B19B
#define REG_BK13B1_4E_L      0x13B19C
#define REG_BK13B1_4E_H      0x13B19D
#define REG_BK13B1_4F_L      0x13B19E
#define REG_BK13B1_4F_H      0x13B19F
#define REG_BK13B1_50_L      0x13B1A0
#define REG_BK13B1_50_H      0x13B1A1
#define REG_BK13B1_51_L      0x13B1A2
#define REG_BK13B1_51_H      0x13B1A3
#define REG_BK13B1_52_L      0x13B1A4
#define REG_BK13B1_52_H      0x13B1A5
#define REG_BK13B1_53_L      0x13B1A6
#define REG_BK13B1_53_H      0x13B1A7
#define REG_BK13B1_54_L      0x13B1A8
#define REG_BK13B1_54_H      0x13B1A9
#define REG_BK13B1_55_L      0x13B1AA
#define REG_BK13B1_55_H      0x13B1AB
#define REG_BK13B1_56_L      0x13B1AC
#define REG_BK13B1_56_H      0x13B1AD
#define REG_BK13B1_57_L      0x13B1AE
#define REG_BK13B1_57_H      0x13B1AF
#define REG_BK13B1_58_L      0x13B1B0
#define REG_BK13B1_58_H      0x13B1B1
#define REG_BK13B1_59_L      0x13B1B2
#define REG_BK13B1_59_H      0x13B1B3
#define REG_BK13B1_5A_L      0x13B1B4
#define REG_BK13B1_5A_H      0x13B1B5
#define REG_BK13B1_5B_L      0x13B1B6
#define REG_BK13B1_5B_H      0x13B1B7
#define REG_BK13B1_5C_L      0x13B1B8
#define REG_BK13B1_5C_H      0x13B1B9
#define REG_BK13B1_5D_L      0x13B1BA
#define REG_BK13B1_5D_H      0x13B1BB
#define REG_BK13B1_5E_L      0x13B1BC
#define REG_BK13B1_5E_H      0x13B1BD
#define REG_BK13B1_5F_L      0x13B1BE
#define REG_BK13B1_5F_H      0x13B1BF
#define REG_BK13B1_60_L      0x13B1C0
#define REG_BK13B1_60_H      0x13B1C1
#define REG_BK13B1_61_L      0x13B1C2
#define REG_BK13B1_61_H      0x13B1C3
#define REG_BK13B1_62_L      0x13B1C4
#define REG_BK13B1_62_H      0x13B1C5
#define REG_BK13B1_63_L      0x13B1C6
#define REG_BK13B1_63_H      0x13B1C7
#define REG_BK13B1_64_L      0x13B1C8
#define REG_BK13B1_64_H      0x13B1C9
#define REG_BK13B1_65_L      0x13B1CA
#define REG_BK13B1_65_H      0x13B1CB
#define REG_BK13B1_66_L      0x13B1CC
#define REG_BK13B1_66_H      0x13B1CD
#define REG_BK13B1_67_L      0x13B1CE
#define REG_BK13B1_67_H      0x13B1CF
#define REG_BK13B1_68_L      0x13B1D0
#define REG_BK13B1_68_H      0x13B1D1
#define REG_BK13B1_69_L      0x13B1D2
#define REG_BK13B1_69_H      0x13B1D3
#define REG_BK13B1_6A_L      0x13B1D4
#define REG_BK13B1_6A_H      0x13B1D5
#define REG_BK13B1_6B_L      0x13B1D6
#define REG_BK13B1_6B_H      0x13B1D7
#define REG_BK13B1_6C_L      0x13B1D8
#define REG_BK13B1_6C_H      0x13B1D9
#define REG_BK13B1_6D_L      0x13B1DA
#define REG_BK13B1_6D_H      0x13B1DB
#define REG_BK13B1_6E_L      0x13B1DC
#define REG_BK13B1_6E_H      0x13B1DD
#define REG_BK13B1_6F_L      0x13B1DE
#define REG_BK13B1_6F_H      0x13B1DF
#define REG_BK13B1_70_L      0x13B1E0
#define REG_BK13B1_70_H      0x13B1E1
#define REG_BK13B1_71_L      0x13B1E2
#define REG_BK13B1_71_H      0x13B1E3
#define REG_BK13B1_72_L      0x13B1E4
#define REG_BK13B1_72_H      0x13B1E5
#define REG_BK13B1_73_L      0x13B1E6
#define REG_BK13B1_73_H      0x13B1E7
#define REG_BK13B1_74_L      0x13B1E8
#define REG_BK13B1_74_H      0x13B1E9
#define REG_BK13B1_75_L      0x13B1EA
#define REG_BK13B1_75_H      0x13B1EB
#define REG_BK13B1_76_L      0x13B1EC
#define REG_BK13B1_76_H      0x13B1ED
#define REG_BK13B1_77_L      0x13B1EE
#define REG_BK13B1_77_H      0x13B1EF
#define REG_BK13B1_78_L      0x13B1F0
#define REG_BK13B1_78_H      0x13B1F1
#define REG_BK13B1_79_L      0x13B1F2
#define REG_BK13B1_79_H      0x13B1F3
#define REG_BK13B1_7A_L      0x13B1F4
#define REG_BK13B1_7A_H      0x13B1F5
#define REG_BK13B1_7B_L      0x13B1F6
#define REG_BK13B1_7B_H      0x13B1F7
#define REG_BK13B1_7C_L      0x13B1F8
#define REG_BK13B1_7C_H      0x13B1F9
#define REG_BK13B1_7D_L      0x13B1FA
#define REG_BK13B1_7D_H      0x13B1FB
#define REG_BK13B1_7E_L      0x13B1FC
#define REG_BK13B1_7E_H      0x13B1FD
#define REG_BK13B1_7F_L      0x13B1FE
#define REG_BK13B1_7F_H      0x13B1FF
//----------------------------------------------
#define REG_BK13B2_00_L      0x13B200
#define REG_BK13B2_00_H      0x13B201
#define REG_BK13B2_01_L      0x13B202
#define REG_BK13B2_01_H      0x13B203
#define REG_BK13B2_02_L      0x13B204
#define REG_BK13B2_02_H      0x13B205
#define REG_BK13B2_03_L      0x13B206
#define REG_BK13B2_03_H      0x13B207
#define REG_BK13B2_04_L      0x13B208
#define REG_BK13B2_04_H      0x13B209
#define REG_BK13B2_05_L      0x13B20A
#define REG_BK13B2_05_H      0x13B20B
#define REG_BK13B2_06_L      0x13B20C
#define REG_BK13B2_06_H      0x13B20D
#define REG_BK13B2_07_L      0x13B20E
#define REG_BK13B2_07_H      0x13B20F
#define REG_BK13B2_08_L      0x13B210
#define REG_BK13B2_08_H      0x13B211
#define REG_BK13B2_09_L      0x13B212
#define REG_BK13B2_09_H      0x13B213
#define REG_BK13B2_0A_L      0x13B214
#define REG_BK13B2_0A_H      0x13B215
#define REG_BK13B2_0B_L      0x13B216
#define REG_BK13B2_0B_H      0x13B217
#define REG_BK13B2_0C_L      0x13B218
#define REG_BK13B2_0C_H      0x13B219
#define REG_BK13B2_0D_L      0x13B21A
#define REG_BK13B2_0D_H      0x13B21B
#define REG_BK13B2_0E_L      0x13B21C
#define REG_BK13B2_0E_H      0x13B21D
#define REG_BK13B2_0F_L      0x13B21E
#define REG_BK13B2_0F_H      0x13B21F
#define REG_BK13B2_10_L      0x13B220
#define REG_BK13B2_10_H      0x13B221
#define REG_BK13B2_11_L      0x13B222
#define REG_BK13B2_11_H      0x13B223
#define REG_BK13B2_12_L      0x13B224
#define REG_BK13B2_12_H      0x13B225
#define REG_BK13B2_13_L      0x13B226
#define REG_BK13B2_13_H      0x13B227
#define REG_BK13B2_14_L      0x13B228
#define REG_BK13B2_14_H      0x13B229
#define REG_BK13B2_15_L      0x13B22A
#define REG_BK13B2_15_H      0x13B22B
#define REG_BK13B2_16_L      0x13B22C
#define REG_BK13B2_16_H      0x13B22D
#define REG_BK13B2_17_L      0x13B22E
#define REG_BK13B2_17_H      0x13B22F
#define REG_BK13B2_18_L      0x13B230
#define REG_BK13B2_18_H      0x13B231
#define REG_BK13B2_19_L      0x13B232
#define REG_BK13B2_19_H      0x13B233
#define REG_BK13B2_1A_L      0x13B234
#define REG_BK13B2_1A_H      0x13B235
#define REG_BK13B2_1B_L      0x13B236
#define REG_BK13B2_1B_H      0x13B237
#define REG_BK13B2_1C_L      0x13B238
#define REG_BK13B2_1C_H      0x13B239
#define REG_BK13B2_1D_L      0x13B23A
#define REG_BK13B2_1D_H      0x13B23B
#define REG_BK13B2_1E_L      0x13B23C
#define REG_BK13B2_1E_H      0x13B23D
#define REG_BK13B2_1F_L      0x13B23E
#define REG_BK13B2_1F_H      0x13B23F
#define REG_BK13B2_20_L      0x13B240
#define REG_BK13B2_20_H      0x13B241
#define REG_BK13B2_21_L      0x13B242
#define REG_BK13B2_21_H      0x13B243
#define REG_BK13B2_22_L      0x13B244
#define REG_BK13B2_22_H      0x13B245
#define REG_BK13B2_23_L      0x13B246
#define REG_BK13B2_23_H      0x13B247
#define REG_BK13B2_24_L      0x13B248
#define REG_BK13B2_24_H      0x13B249
#define REG_BK13B2_25_L      0x13B24A
#define REG_BK13B2_25_H      0x13B24B
#define REG_BK13B2_26_L      0x13B24C
#define REG_BK13B2_26_H      0x13B24D
#define REG_BK13B2_27_L      0x13B24E
#define REG_BK13B2_27_H      0x13B24F
#define REG_BK13B2_28_L      0x13B250
#define REG_BK13B2_28_H      0x13B251
#define REG_BK13B2_29_L      0x13B252
#define REG_BK13B2_29_H      0x13B253
#define REG_BK13B2_2A_L      0x13B254
#define REG_BK13B2_2A_H      0x13B255
#define REG_BK13B2_2B_L      0x13B256
#define REG_BK13B2_2B_H      0x13B257
#define REG_BK13B2_2C_L      0x13B258
#define REG_BK13B2_2C_H      0x13B259
#define REG_BK13B2_2D_L      0x13B25A
#define REG_BK13B2_2D_H      0x13B25B
#define REG_BK13B2_2E_L      0x13B25C
#define REG_BK13B2_2E_H      0x13B25D
#define REG_BK13B2_2F_L      0x13B25E
#define REG_BK13B2_2F_H      0x13B25F
#define REG_BK13B2_30_L      0x13B260
#define REG_BK13B2_30_H      0x13B261
#define REG_BK13B2_31_L      0x13B262
#define REG_BK13B2_31_H      0x13B263
#define REG_BK13B2_32_L      0x13B264
#define REG_BK13B2_32_H      0x13B265
#define REG_BK13B2_33_L      0x13B266
#define REG_BK13B2_33_H      0x13B267
#define REG_BK13B2_34_L      0x13B268
#define REG_BK13B2_34_H      0x13B269
#define REG_BK13B2_35_L      0x13B26A
#define REG_BK13B2_35_H      0x13B26B
#define REG_BK13B2_36_L      0x13B26C
#define REG_BK13B2_36_H      0x13B26D
#define REG_BK13B2_37_L      0x13B26E
#define REG_BK13B2_37_H      0x13B26F
#define REG_BK13B2_38_L      0x13B270
#define REG_BK13B2_38_H      0x13B271
#define REG_BK13B2_39_L      0x13B272
#define REG_BK13B2_39_H      0x13B273
#define REG_BK13B2_3A_L      0x13B274
#define REG_BK13B2_3A_H      0x13B275
#define REG_BK13B2_3B_L      0x13B276
#define REG_BK13B2_3B_H      0x13B277
#define REG_BK13B2_3C_L      0x13B278
#define REG_BK13B2_3C_H      0x13B279
#define REG_BK13B2_3D_L      0x13B27A
#define REG_BK13B2_3D_H      0x13B27B
#define REG_BK13B2_3E_L      0x13B27C
#define REG_BK13B2_3E_H      0x13B27D
#define REG_BK13B2_3F_L      0x13B27E
#define REG_BK13B2_3F_H      0x13B27F
#define REG_BK13B2_40_L      0x13B280
#define REG_BK13B2_40_H      0x13B281
#define REG_BK13B2_41_L      0x13B282
#define REG_BK13B2_41_H      0x13B283
#define REG_BK13B2_42_L      0x13B284
#define REG_BK13B2_42_H      0x13B285
#define REG_BK13B2_43_L      0x13B286
#define REG_BK13B2_43_H      0x13B287
#define REG_BK13B2_44_L      0x13B288
#define REG_BK13B2_44_H      0x13B289
#define REG_BK13B2_45_L      0x13B28A
#define REG_BK13B2_45_H      0x13B28B
#define REG_BK13B2_46_L      0x13B28C
#define REG_BK13B2_46_H      0x13B28D
#define REG_BK13B2_47_L      0x13B28E
#define REG_BK13B2_47_H      0x13B28F
#define REG_BK13B2_48_L      0x13B290
#define REG_BK13B2_48_H      0x13B291
#define REG_BK13B2_49_L      0x13B292
#define REG_BK13B2_49_H      0x13B293
#define REG_BK13B2_4A_L      0x13B294
#define REG_BK13B2_4A_H      0x13B295
#define REG_BK13B2_4B_L      0x13B296
#define REG_BK13B2_4B_H      0x13B297
#define REG_BK13B2_4C_L      0x13B298
#define REG_BK13B2_4C_H      0x13B299
#define REG_BK13B2_4D_L      0x13B29A
#define REG_BK13B2_4D_H      0x13B29B
#define REG_BK13B2_4E_L      0x13B29C
#define REG_BK13B2_4E_H      0x13B29D
#define REG_BK13B2_4F_L      0x13B29E
#define REG_BK13B2_4F_H      0x13B29F
#define REG_BK13B2_50_L      0x13B2A0
#define REG_BK13B2_50_H      0x13B2A1
#define REG_BK13B2_51_L      0x13B2A2
#define REG_BK13B2_51_H      0x13B2A3
#define REG_BK13B2_52_L      0x13B2A4
#define REG_BK13B2_52_H      0x13B2A5
#define REG_BK13B2_53_L      0x13B2A6
#define REG_BK13B2_53_H      0x13B2A7
#define REG_BK13B2_54_L      0x13B2A8
#define REG_BK13B2_54_H      0x13B2A9
#define REG_BK13B2_55_L      0x13B2AA
#define REG_BK13B2_55_H      0x13B2AB
#define REG_BK13B2_56_L      0x13B2AC
#define REG_BK13B2_56_H      0x13B2AD
#define REG_BK13B2_57_L      0x13B2AE
#define REG_BK13B2_57_H      0x13B2AF
#define REG_BK13B2_58_L      0x13B2B0
#define REG_BK13B2_58_H      0x13B2B1
#define REG_BK13B2_59_L      0x13B2B2
#define REG_BK13B2_59_H      0x13B2B3
#define REG_BK13B2_5A_L      0x13B2B4
#define REG_BK13B2_5A_H      0x13B2B5
#define REG_BK13B2_5B_L      0x13B2B6
#define REG_BK13B2_5B_H      0x13B2B7
#define REG_BK13B2_5C_L      0x13B2B8
#define REG_BK13B2_5C_H      0x13B2B9
#define REG_BK13B2_5D_L      0x13B2BA
#define REG_BK13B2_5D_H      0x13B2BB
#define REG_BK13B2_5E_L      0x13B2BC
#define REG_BK13B2_5E_H      0x13B2BD
#define REG_BK13B2_5F_L      0x13B2BE
#define REG_BK13B2_5F_H      0x13B2BF
#define REG_BK13B2_60_L      0x13B2C0
#define REG_BK13B2_60_H      0x13B2C1
#define REG_BK13B2_61_L      0x13B2C2
#define REG_BK13B2_61_H      0x13B2C3
#define REG_BK13B2_62_L      0x13B2C4
#define REG_BK13B2_62_H      0x13B2C5
#define REG_BK13B2_63_L      0x13B2C6
#define REG_BK13B2_63_H      0x13B2C7
#define REG_BK13B2_64_L      0x13B2C8
#define REG_BK13B2_64_H      0x13B2C9
#define REG_BK13B2_65_L      0x13B2CA
#define REG_BK13B2_65_H      0x13B2CB
#define REG_BK13B2_66_L      0x13B2CC
#define REG_BK13B2_66_H      0x13B2CD
#define REG_BK13B2_67_L      0x13B2CE
#define REG_BK13B2_67_H      0x13B2CF
#define REG_BK13B2_68_L      0x13B2D0
#define REG_BK13B2_68_H      0x13B2D1
#define REG_BK13B2_69_L      0x13B2D2
#define REG_BK13B2_69_H      0x13B2D3
#define REG_BK13B2_6A_L      0x13B2D4
#define REG_BK13B2_6A_H      0x13B2D5
#define REG_BK13B2_6B_L      0x13B2D6
#define REG_BK13B2_6B_H      0x13B2D7
#define REG_BK13B2_6C_L      0x13B2D8
#define REG_BK13B2_6C_H      0x13B2D9
#define REG_BK13B2_6D_L      0x13B2DA
#define REG_BK13B2_6D_H      0x13B2DB
#define REG_BK13B2_6E_L      0x13B2DC
#define REG_BK13B2_6E_H      0x13B2DD
#define REG_BK13B2_6F_L      0x13B2DE
#define REG_BK13B2_6F_H      0x13B2DF
#define REG_BK13B2_70_L      0x13B2E0
#define REG_BK13B2_70_H      0x13B2E1
#define REG_BK13B2_71_L      0x13B2E2
#define REG_BK13B2_71_H      0x13B2E3
#define REG_BK13B2_72_L      0x13B2E4
#define REG_BK13B2_72_H      0x13B2E5
#define REG_BK13B2_73_L      0x13B2E6
#define REG_BK13B2_73_H      0x13B2E7
#define REG_BK13B2_74_L      0x13B2E8
#define REG_BK13B2_74_H      0x13B2E9
#define REG_BK13B2_75_L      0x13B2EA
#define REG_BK13B2_75_H      0x13B2EB
#define REG_BK13B2_76_L      0x13B2EC
#define REG_BK13B2_76_H      0x13B2ED
#define REG_BK13B2_77_L      0x13B2EE
#define REG_BK13B2_77_H      0x13B2EF
#define REG_BK13B2_78_L      0x13B2F0
#define REG_BK13B2_78_H      0x13B2F1
#define REG_BK13B2_79_L      0x13B2F2
#define REG_BK13B2_79_H      0x13B2F3
#define REG_BK13B2_7A_L      0x13B2F4
#define REG_BK13B2_7A_H      0x13B2F5
#define REG_BK13B2_7B_L      0x13B2F6
#define REG_BK13B2_7B_H      0x13B2F7
#define REG_BK13B2_7C_L      0x13B2F8
#define REG_BK13B2_7C_H      0x13B2F9
#define REG_BK13B2_7D_L      0x13B2FA
#define REG_BK13B2_7D_H      0x13B2FB
#define REG_BK13B2_7E_L      0x13B2FC
#define REG_BK13B2_7E_H      0x13B2FD
#define REG_BK13B2_7F_L      0x13B2FE
#define REG_BK13B2_7F_H      0x13B2FF
//----------------------------------------------
#define REG_BK13B3_00_L      0x13B300
#define REG_BK13B3_00_H      0x13B301
#define REG_BK13B3_01_L      0x13B302
#define REG_BK13B3_01_H      0x13B303
#define REG_BK13B3_02_L      0x13B304
#define REG_BK13B3_02_H      0x13B305
#define REG_BK13B3_03_L      0x13B306
#define REG_BK13B3_03_H      0x13B307
#define REG_BK13B3_04_L      0x13B308
#define REG_BK13B3_04_H      0x13B309
#define REG_BK13B3_05_L      0x13B30A
#define REG_BK13B3_05_H      0x13B30B
#define REG_BK13B3_06_L      0x13B30C
#define REG_BK13B3_06_H      0x13B30D
#define REG_BK13B3_07_L      0x13B30E
#define REG_BK13B3_07_H      0x13B30F
#define REG_BK13B3_08_L      0x13B310
#define REG_BK13B3_08_H      0x13B311
#define REG_BK13B3_09_L      0x13B312
#define REG_BK13B3_09_H      0x13B313
#define REG_BK13B3_0A_L      0x13B314
#define REG_BK13B3_0A_H      0x13B315
#define REG_BK13B3_0B_L      0x13B316
#define REG_BK13B3_0B_H      0x13B317
#define REG_BK13B3_0C_L      0x13B318
#define REG_BK13B3_0C_H      0x13B319
#define REG_BK13B3_0D_L      0x13B31A
#define REG_BK13B3_0D_H      0x13B31B
#define REG_BK13B3_0E_L      0x13B31C
#define REG_BK13B3_0E_H      0x13B31D
#define REG_BK13B3_0F_L      0x13B31E
#define REG_BK13B3_0F_H      0x13B31F
#define REG_BK13B3_10_L      0x13B320
#define REG_BK13B3_10_H      0x13B321
#define REG_BK13B3_11_L      0x13B322
#define REG_BK13B3_11_H      0x13B323
#define REG_BK13B3_12_L      0x13B324
#define REG_BK13B3_12_H      0x13B325
#define REG_BK13B3_13_L      0x13B326
#define REG_BK13B3_13_H      0x13B327
#define REG_BK13B3_14_L      0x13B328
#define REG_BK13B3_14_H      0x13B329
#define REG_BK13B3_15_L      0x13B32A
#define REG_BK13B3_15_H      0x13B32B
#define REG_BK13B3_16_L      0x13B32C
#define REG_BK13B3_16_H      0x13B32D
#define REG_BK13B3_17_L      0x13B32E
#define REG_BK13B3_17_H      0x13B32F
#define REG_BK13B3_18_L      0x13B330
#define REG_BK13B3_18_H      0x13B331
#define REG_BK13B3_19_L      0x13B332
#define REG_BK13B3_19_H      0x13B333
#define REG_BK13B3_1A_L      0x13B334
#define REG_BK13B3_1A_H      0x13B335
#define REG_BK13B3_1B_L      0x13B336
#define REG_BK13B3_1B_H      0x13B337
#define REG_BK13B3_1C_L      0x13B338
#define REG_BK13B3_1C_H      0x13B339
#define REG_BK13B3_1D_L      0x13B33A
#define REG_BK13B3_1D_H      0x13B33B
#define REG_BK13B3_1E_L      0x13B33C
#define REG_BK13B3_1E_H      0x13B33D
#define REG_BK13B3_1F_L      0x13B33E
#define REG_BK13B3_1F_H      0x13B33F
#define REG_BK13B3_20_L      0x13B340
#define REG_BK13B3_20_H      0x13B341
#define REG_BK13B3_21_L      0x13B342
#define REG_BK13B3_21_H      0x13B343
#define REG_BK13B3_22_L      0x13B344
#define REG_BK13B3_22_H      0x13B345
#define REG_BK13B3_23_L      0x13B346
#define REG_BK13B3_23_H      0x13B347
#define REG_BK13B3_24_L      0x13B348
#define REG_BK13B3_24_H      0x13B349
#define REG_BK13B3_25_L      0x13B34A
#define REG_BK13B3_25_H      0x13B34B
#define REG_BK13B3_26_L      0x13B34C
#define REG_BK13B3_26_H      0x13B34D
#define REG_BK13B3_27_L      0x13B34E
#define REG_BK13B3_27_H      0x13B34F
#define REG_BK13B3_28_L      0x13B350
#define REG_BK13B3_28_H      0x13B351
#define REG_BK13B3_29_L      0x13B352
#define REG_BK13B3_29_H      0x13B353
#define REG_BK13B3_2A_L      0x13B354
#define REG_BK13B3_2A_H      0x13B355
#define REG_BK13B3_2B_L      0x13B356
#define REG_BK13B3_2B_H      0x13B357
#define REG_BK13B3_2C_L      0x13B358
#define REG_BK13B3_2C_H      0x13B359
#define REG_BK13B3_2D_L      0x13B35A
#define REG_BK13B3_2D_H      0x13B35B
#define REG_BK13B3_2E_L      0x13B35C
#define REG_BK13B3_2E_H      0x13B35D
#define REG_BK13B3_2F_L      0x13B35E
#define REG_BK13B3_2F_H      0x13B35F
#define REG_BK13B3_30_L      0x13B360
#define REG_BK13B3_30_H      0x13B361
#define REG_BK13B3_31_L      0x13B362
#define REG_BK13B3_31_H      0x13B363
#define REG_BK13B3_32_L      0x13B364
#define REG_BK13B3_32_H      0x13B365
#define REG_BK13B3_33_L      0x13B366
#define REG_BK13B3_33_H      0x13B367
#define REG_BK13B3_34_L      0x13B368
#define REG_BK13B3_34_H      0x13B369
#define REG_BK13B3_35_L      0x13B36A
#define REG_BK13B3_35_H      0x13B36B
#define REG_BK13B3_36_L      0x13B36C
#define REG_BK13B3_36_H      0x13B36D
#define REG_BK13B3_37_L      0x13B36E
#define REG_BK13B3_37_H      0x13B36F
#define REG_BK13B3_38_L      0x13B370
#define REG_BK13B3_38_H      0x13B371
#define REG_BK13B3_39_L      0x13B372
#define REG_BK13B3_39_H      0x13B373
#define REG_BK13B3_3A_L      0x13B374
#define REG_BK13B3_3A_H      0x13B375
#define REG_BK13B3_3B_L      0x13B376
#define REG_BK13B3_3B_H      0x13B377
#define REG_BK13B3_3C_L      0x13B378
#define REG_BK13B3_3C_H      0x13B379
#define REG_BK13B3_3D_L      0x13B37A
#define REG_BK13B3_3D_H      0x13B37B
#define REG_BK13B3_3E_L      0x13B37C
#define REG_BK13B3_3E_H      0x13B37D
#define REG_BK13B3_3F_L      0x13B37E
#define REG_BK13B3_3F_H      0x13B37F
#define REG_BK13B3_40_L      0x13B380
#define REG_BK13B3_40_H      0x13B381
#define REG_BK13B3_41_L      0x13B382
#define REG_BK13B3_41_H      0x13B383
#define REG_BK13B3_42_L      0x13B384
#define REG_BK13B3_42_H      0x13B385
#define REG_BK13B3_43_L      0x13B386
#define REG_BK13B3_43_H      0x13B387
#define REG_BK13B3_44_L      0x13B388
#define REG_BK13B3_44_H      0x13B389
#define REG_BK13B3_45_L      0x13B38A
#define REG_BK13B3_45_H      0x13B38B
#define REG_BK13B3_46_L      0x13B38C
#define REG_BK13B3_46_H      0x13B38D
#define REG_BK13B3_47_L      0x13B38E
#define REG_BK13B3_47_H      0x13B38F
#define REG_BK13B3_48_L      0x13B390
#define REG_BK13B3_48_H      0x13B391
#define REG_BK13B3_49_L      0x13B392
#define REG_BK13B3_49_H      0x13B393
#define REG_BK13B3_4A_L      0x13B394
#define REG_BK13B3_4A_H      0x13B395
#define REG_BK13B3_4B_L      0x13B396
#define REG_BK13B3_4B_H      0x13B397
#define REG_BK13B3_4C_L      0x13B398
#define REG_BK13B3_4C_H      0x13B399
#define REG_BK13B3_4D_L      0x13B39A
#define REG_BK13B3_4D_H      0x13B39B
#define REG_BK13B3_4E_L      0x13B39C
#define REG_BK13B3_4E_H      0x13B39D
#define REG_BK13B3_4F_L      0x13B39E
#define REG_BK13B3_4F_H      0x13B39F
#define REG_BK13B3_50_L      0x13B3A0
#define REG_BK13B3_50_H      0x13B3A1
#define REG_BK13B3_51_L      0x13B3A2
#define REG_BK13B3_51_H      0x13B3A3
#define REG_BK13B3_52_L      0x13B3A4
#define REG_BK13B3_52_H      0x13B3A5
#define REG_BK13B3_53_L      0x13B3A6
#define REG_BK13B3_53_H      0x13B3A7
#define REG_BK13B3_54_L      0x13B3A8
#define REG_BK13B3_54_H      0x13B3A9
#define REG_BK13B3_55_L      0x13B3AA
#define REG_BK13B3_55_H      0x13B3AB
#define REG_BK13B3_56_L      0x13B3AC
#define REG_BK13B3_56_H      0x13B3AD
#define REG_BK13B3_57_L      0x13B3AE
#define REG_BK13B3_57_H      0x13B3AF
#define REG_BK13B3_58_L      0x13B3B0
#define REG_BK13B3_58_H      0x13B3B1
#define REG_BK13B3_59_L      0x13B3B2
#define REG_BK13B3_59_H      0x13B3B3
#define REG_BK13B3_5A_L      0x13B3B4
#define REG_BK13B3_5A_H      0x13B3B5
#define REG_BK13B3_5B_L      0x13B3B6
#define REG_BK13B3_5B_H      0x13B3B7
#define REG_BK13B3_5C_L      0x13B3B8
#define REG_BK13B3_5C_H      0x13B3B9
#define REG_BK13B3_5D_L      0x13B3BA
#define REG_BK13B3_5D_H      0x13B3BB
#define REG_BK13B3_5E_L      0x13B3BC
#define REG_BK13B3_5E_H      0x13B3BD
#define REG_BK13B3_5F_L      0x13B3BE
#define REG_BK13B3_5F_H      0x13B3BF
#define REG_BK13B3_60_L      0x13B3C0
#define REG_BK13B3_60_H      0x13B3C1
#define REG_BK13B3_61_L      0x13B3C2
#define REG_BK13B3_61_H      0x13B3C3
#define REG_BK13B3_62_L      0x13B3C4
#define REG_BK13B3_62_H      0x13B3C5
#define REG_BK13B3_63_L      0x13B3C6
#define REG_BK13B3_63_H      0x13B3C7
#define REG_BK13B3_64_L      0x13B3C8
#define REG_BK13B3_64_H      0x13B3C9
#define REG_BK13B3_65_L      0x13B3CA
#define REG_BK13B3_65_H      0x13B3CB
#define REG_BK13B3_66_L      0x13B3CC
#define REG_BK13B3_66_H      0x13B3CD
#define REG_BK13B3_67_L      0x13B3CE
#define REG_BK13B3_67_H      0x13B3CF
#define REG_BK13B3_68_L      0x13B3D0
#define REG_BK13B3_68_H      0x13B3D1
#define REG_BK13B3_69_L      0x13B3D2
#define REG_BK13B3_69_H      0x13B3D3
#define REG_BK13B3_6A_L      0x13B3D4
#define REG_BK13B3_6A_H      0x13B3D5
#define REG_BK13B3_6B_L      0x13B3D6
#define REG_BK13B3_6B_H      0x13B3D7
#define REG_BK13B3_6C_L      0x13B3D8
#define REG_BK13B3_6C_H      0x13B3D9
#define REG_BK13B3_6D_L      0x13B3DA
#define REG_BK13B3_6D_H      0x13B3DB
#define REG_BK13B3_6E_L      0x13B3DC
#define REG_BK13B3_6E_H      0x13B3DD
#define REG_BK13B3_6F_L      0x13B3DE
#define REG_BK13B3_6F_H      0x13B3DF
#define REG_BK13B3_70_L      0x13B3E0
#define REG_BK13B3_70_H      0x13B3E1
#define REG_BK13B3_71_L      0x13B3E2
#define REG_BK13B3_71_H      0x13B3E3
#define REG_BK13B3_72_L      0x13B3E4
#define REG_BK13B3_72_H      0x13B3E5
#define REG_BK13B3_73_L      0x13B3E6
#define REG_BK13B3_73_H      0x13B3E7
#define REG_BK13B3_74_L      0x13B3E8
#define REG_BK13B3_74_H      0x13B3E9
#define REG_BK13B3_75_L      0x13B3EA
#define REG_BK13B3_75_H      0x13B3EB
#define REG_BK13B3_76_L      0x13B3EC
#define REG_BK13B3_76_H      0x13B3ED
#define REG_BK13B3_77_L      0x13B3EE
#define REG_BK13B3_77_H      0x13B3EF
#define REG_BK13B3_78_L      0x13B3F0
#define REG_BK13B3_78_H      0x13B3F1
#define REG_BK13B3_79_L      0x13B3F2
#define REG_BK13B3_79_H      0x13B3F3
#define REG_BK13B3_7A_L      0x13B3F4
#define REG_BK13B3_7A_H      0x13B3F5
#define REG_BK13B3_7B_L      0x13B3F6
#define REG_BK13B3_7B_H      0x13B3F7
#define REG_BK13B3_7C_L      0x13B3F8
#define REG_BK13B3_7C_H      0x13B3F9
#define REG_BK13B3_7D_L      0x13B3FA
#define REG_BK13B3_7D_H      0x13B3FB
#define REG_BK13B3_7E_L      0x13B3FC
#define REG_BK13B3_7E_H      0x13B3FD
#define REG_BK13B3_7F_L      0x13B3FE
#define REG_BK13B3_7F_H      0x13B3FF
//----------------------------------------------
#define REG_BK13B8_00_L      0x13B800
#define REG_BK13B8_00_H      0x13B801
#define REG_BK13B8_01_L      0x13B802
#define REG_BK13B8_01_H      0x13B803
#define REG_BK13B8_02_L      0x13B804
#define REG_BK13B8_02_H      0x13B805
#define REG_BK13B8_03_L      0x13B806
#define REG_BK13B8_03_H      0x13B807
#define REG_BK13B8_04_L      0x13B808
#define REG_BK13B8_04_H      0x13B809
#define REG_BK13B8_05_L      0x13B80A
#define REG_BK13B8_05_H      0x13B80B
#define REG_BK13B8_06_L      0x13B80C
#define REG_BK13B8_06_H      0x13B80D
#define REG_BK13B8_07_L      0x13B80E
#define REG_BK13B8_07_H      0x13B80F
#define REG_BK13B8_08_L      0x13B810
#define REG_BK13B8_08_H      0x13B811
#define REG_BK13B8_09_L      0x13B812
#define REG_BK13B8_09_H      0x13B813
#define REG_BK13B8_0A_L      0x13B814
#define REG_BK13B8_0A_H      0x13B815
#define REG_BK13B8_0B_L      0x13B816
#define REG_BK13B8_0B_H      0x13B817
#define REG_BK13B8_0C_L      0x13B818
#define REG_BK13B8_0C_H      0x13B819
#define REG_BK13B8_0D_L      0x13B81A
#define REG_BK13B8_0D_H      0x13B81B
#define REG_BK13B8_0E_L      0x13B81C
#define REG_BK13B8_0E_H      0x13B81D
#define REG_BK13B8_0F_L      0x13B81E
#define REG_BK13B8_0F_H      0x13B81F
#define REG_BK13B8_10_L      0x13B820
#define REG_BK13B8_10_H      0x13B821
#define REG_BK13B8_11_L      0x13B822
#define REG_BK13B8_11_H      0x13B823
#define REG_BK13B8_12_L      0x13B824
#define REG_BK13B8_12_H      0x13B825
#define REG_BK13B8_13_L      0x13B826
#define REG_BK13B8_13_H      0x13B827
#define REG_BK13B8_14_L      0x13B828
#define REG_BK13B8_14_H      0x13B829
#define REG_BK13B8_15_L      0x13B82A
#define REG_BK13B8_15_H      0x13B82B
#define REG_BK13B8_16_L      0x13B82C
#define REG_BK13B8_16_H      0x13B82D
#define REG_BK13B8_17_L      0x13B82E
#define REG_BK13B8_17_H      0x13B82F
#define REG_BK13B8_18_L      0x13B830
#define REG_BK13B8_18_H      0x13B831
#define REG_BK13B8_19_L      0x13B832
#define REG_BK13B8_19_H      0x13B833
#define REG_BK13B8_1A_L      0x13B834
#define REG_BK13B8_1A_H      0x13B835
#define REG_BK13B8_1B_L      0x13B836
#define REG_BK13B8_1B_H      0x13B837
#define REG_BK13B8_1C_L      0x13B838
#define REG_BK13B8_1C_H      0x13B839
#define REG_BK13B8_1D_L      0x13B83A
#define REG_BK13B8_1D_H      0x13B83B
#define REG_BK13B8_1E_L      0x13B83C
#define REG_BK13B8_1E_H      0x13B83D
#define REG_BK13B8_1F_L      0x13B83E
#define REG_BK13B8_1F_H      0x13B83F
#define REG_BK13B8_20_L      0x13B840
#define REG_BK13B8_20_H      0x13B841
#define REG_BK13B8_21_L      0x13B842
#define REG_BK13B8_21_H      0x13B843
#define REG_BK13B8_22_L      0x13B844
#define REG_BK13B8_22_H      0x13B845
#define REG_BK13B8_23_L      0x13B846
#define REG_BK13B8_23_H      0x13B847
#define REG_BK13B8_24_L      0x13B848
#define REG_BK13B8_24_H      0x13B849
#define REG_BK13B8_25_L      0x13B84A
#define REG_BK13B8_25_H      0x13B84B
#define REG_BK13B8_26_L      0x13B84C
#define REG_BK13B8_26_H      0x13B84D
#define REG_BK13B8_27_L      0x13B84E
#define REG_BK13B8_27_H      0x13B84F
#define REG_BK13B8_28_L      0x13B850
#define REG_BK13B8_28_H      0x13B851
#define REG_BK13B8_29_L      0x13B852
#define REG_BK13B8_29_H      0x13B853
#define REG_BK13B8_2A_L      0x13B854
#define REG_BK13B8_2A_H      0x13B855
#define REG_BK13B8_2B_L      0x13B856
#define REG_BK13B8_2B_H      0x13B857
#define REG_BK13B8_2C_L      0x13B858
#define REG_BK13B8_2C_H      0x13B859
#define REG_BK13B8_2D_L      0x13B85A
#define REG_BK13B8_2D_H      0x13B85B
#define REG_BK13B8_2E_L      0x13B85C
#define REG_BK13B8_2E_H      0x13B85D
#define REG_BK13B8_2F_L      0x13B85E
#define REG_BK13B8_2F_H      0x13B85F
#define REG_BK13B8_30_L      0x13B860
#define REG_BK13B8_30_H      0x13B861
#define REG_BK13B8_31_L      0x13B862
#define REG_BK13B8_31_H      0x13B863
#define REG_BK13B8_32_L      0x13B864
#define REG_BK13B8_32_H      0x13B865
#define REG_BK13B8_33_L      0x13B866
#define REG_BK13B8_33_H      0x13B867
#define REG_BK13B8_34_L      0x13B868
#define REG_BK13B8_34_H      0x13B869
#define REG_BK13B8_35_L      0x13B86A
#define REG_BK13B8_35_H      0x13B86B
#define REG_BK13B8_36_L      0x13B86C
#define REG_BK13B8_36_H      0x13B86D
#define REG_BK13B8_37_L      0x13B86E
#define REG_BK13B8_37_H      0x13B86F
#define REG_BK13B8_38_L      0x13B870
#define REG_BK13B8_38_H      0x13B871
#define REG_BK13B8_39_L      0x13B872
#define REG_BK13B8_39_H      0x13B873
#define REG_BK13B8_3A_L      0x13B874
#define REG_BK13B8_3A_H      0x13B875
#define REG_BK13B8_3B_L      0x13B876
#define REG_BK13B8_3B_H      0x13B877
#define REG_BK13B8_3C_L      0x13B878
#define REG_BK13B8_3C_H      0x13B879
#define REG_BK13B8_3D_L      0x13B87A
#define REG_BK13B8_3D_H      0x13B87B
#define REG_BK13B8_3E_L      0x13B87C
#define REG_BK13B8_3E_H      0x13B87D
#define REG_BK13B8_3F_L      0x13B87E
#define REG_BK13B8_3F_H      0x13B87F
#define REG_BK13B8_40_L      0x13B880
#define REG_BK13B8_40_H      0x13B881
#define REG_BK13B8_41_L      0x13B882
#define REG_BK13B8_41_H      0x13B883
#define REG_BK13B8_42_L      0x13B884
#define REG_BK13B8_42_H      0x13B885
#define REG_BK13B8_43_L      0x13B886
#define REG_BK13B8_43_H      0x13B887
#define REG_BK13B8_44_L      0x13B888
#define REG_BK13B8_44_H      0x13B889
#define REG_BK13B8_45_L      0x13B88A
#define REG_BK13B8_45_H      0x13B88B
#define REG_BK13B8_46_L      0x13B88C
#define REG_BK13B8_46_H      0x13B88D
#define REG_BK13B8_47_L      0x13B88E
#define REG_BK13B8_47_H      0x13B88F
#define REG_BK13B8_48_L      0x13B890
#define REG_BK13B8_48_H      0x13B891
#define REG_BK13B8_49_L      0x13B892
#define REG_BK13B8_49_H      0x13B893
#define REG_BK13B8_4A_L      0x13B894
#define REG_BK13B8_4A_H      0x13B895
#define REG_BK13B8_4B_L      0x13B896
#define REG_BK13B8_4B_H      0x13B897
#define REG_BK13B8_4C_L      0x13B898
#define REG_BK13B8_4C_H      0x13B899
#define REG_BK13B8_4D_L      0x13B89A
#define REG_BK13B8_4D_H      0x13B89B
#define REG_BK13B8_4E_L      0x13B89C
#define REG_BK13B8_4E_H      0x13B89D
#define REG_BK13B8_4F_L      0x13B89E
#define REG_BK13B8_4F_H      0x13B89F
#define REG_BK13B8_50_L      0x13B8A0
#define REG_BK13B8_50_H      0x13B8A1
#define REG_BK13B8_51_L      0x13B8A2
#define REG_BK13B8_51_H      0x13B8A3
#define REG_BK13B8_52_L      0x13B8A4
#define REG_BK13B8_52_H      0x13B8A5
#define REG_BK13B8_53_L      0x13B8A6
#define REG_BK13B8_53_H      0x13B8A7
#define REG_BK13B8_54_L      0x13B8A8
#define REG_BK13B8_54_H      0x13B8A9
#define REG_BK13B8_55_L      0x13B8AA
#define REG_BK13B8_55_H      0x13B8AB
#define REG_BK13B8_56_L      0x13B8AC
#define REG_BK13B8_56_H      0x13B8AD
#define REG_BK13B8_57_L      0x13B8AE
#define REG_BK13B8_57_H      0x13B8AF
#define REG_BK13B8_58_L      0x13B8B0
#define REG_BK13B8_58_H      0x13B8B1
#define REG_BK13B8_59_L      0x13B8B2
#define REG_BK13B8_59_H      0x13B8B3
#define REG_BK13B8_5A_L      0x13B8B4
#define REG_BK13B8_5A_H      0x13B8B5
#define REG_BK13B8_5B_L      0x13B8B6
#define REG_BK13B8_5B_H      0x13B8B7
#define REG_BK13B8_5C_L      0x13B8B8
#define REG_BK13B8_5C_H      0x13B8B9
#define REG_BK13B8_5D_L      0x13B8BA
#define REG_BK13B8_5D_H      0x13B8BB
#define REG_BK13B8_5E_L      0x13B8BC
#define REG_BK13B8_5E_H      0x13B8BD
#define REG_BK13B8_5F_L      0x13B8BE
#define REG_BK13B8_5F_H      0x13B8BF
#define REG_BK13B8_60_L      0x13B8C0
#define REG_BK13B8_60_H      0x13B8C1
#define REG_BK13B8_61_L      0x13B8C2
#define REG_BK13B8_61_H      0x13B8C3
#define REG_BK13B8_62_L      0x13B8C4
#define REG_BK13B8_62_H      0x13B8C5
#define REG_BK13B8_63_L      0x13B8C6
#define REG_BK13B8_63_H      0x13B8C7
#define REG_BK13B8_64_L      0x13B8C8
#define REG_BK13B8_64_H      0x13B8C9
#define REG_BK13B8_65_L      0x13B8CA
#define REG_BK13B8_65_H      0x13B8CB
#define REG_BK13B8_66_L      0x13B8CC
#define REG_BK13B8_66_H      0x13B8CD
#define REG_BK13B8_67_L      0x13B8CE
#define REG_BK13B8_67_H      0x13B8CF
#define REG_BK13B8_68_L      0x13B8D0
#define REG_BK13B8_68_H      0x13B8D1
#define REG_BK13B8_69_L      0x13B8D2
#define REG_BK13B8_69_H      0x13B8D3
#define REG_BK13B8_6A_L      0x13B8D4
#define REG_BK13B8_6A_H      0x13B8D5
#define REG_BK13B8_6B_L      0x13B8D6
#define REG_BK13B8_6B_H      0x13B8D7
#define REG_BK13B8_6C_L      0x13B8D8
#define REG_BK13B8_6C_H      0x13B8D9
#define REG_BK13B8_6D_L      0x13B8DA
#define REG_BK13B8_6D_H      0x13B8DB
#define REG_BK13B8_6E_L      0x13B8DC
#define REG_BK13B8_6E_H      0x13B8DD
#define REG_BK13B8_6F_L      0x13B8DE
#define REG_BK13B8_6F_H      0x13B8DF
#define REG_BK13B8_70_L      0x13B8E0
#define REG_BK13B8_70_H      0x13B8E1
#define REG_BK13B8_71_L      0x13B8E2
#define REG_BK13B8_71_H      0x13B8E3
#define REG_BK13B8_72_L      0x13B8E4
#define REG_BK13B8_72_H      0x13B8E5
#define REG_BK13B8_73_L      0x13B8E6
#define REG_BK13B8_73_H      0x13B8E7
#define REG_BK13B8_74_L      0x13B8E8
#define REG_BK13B8_74_H      0x13B8E9
#define REG_BK13B8_75_L      0x13B8EA
#define REG_BK13B8_75_H      0x13B8EB
#define REG_BK13B8_76_L      0x13B8EC
#define REG_BK13B8_76_H      0x13B8ED
#define REG_BK13B8_77_L      0x13B8EE
#define REG_BK13B8_77_H      0x13B8EF
#define REG_BK13B8_78_L      0x13B8F0
#define REG_BK13B8_78_H      0x13B8F1
#define REG_BK13B8_79_L      0x13B8F2
#define REG_BK13B8_79_H      0x13B8F3
#define REG_BK13B8_7A_L      0x13B8F4
#define REG_BK13B8_7A_H      0x13B8F5
#define REG_BK13B8_7B_L      0x13B8F6
#define REG_BK13B8_7B_H      0x13B8F7
#define REG_BK13B8_7C_L      0x13B8F8
#define REG_BK13B8_7C_H      0x13B8F9
#define REG_BK13B8_7D_L      0x13B8FA
#define REG_BK13B8_7D_H      0x13B8FB
#define REG_BK13B8_7E_L      0x13B8FC
#define REG_BK13B8_7E_H      0x13B8FD
#define REG_BK13B8_7F_L      0x13B8FE
#define REG_BK13B8_7F_H      0x13B8FF
//----------------------------------------------
#define REG_BK13B9_00_L      0x13B900
#define REG_BK13B9_00_H      0x13B901
#define REG_BK13B9_01_L      0x13B902
#define REG_BK13B9_01_H      0x13B903
#define REG_BK13B9_02_L      0x13B904
#define REG_BK13B9_02_H      0x13B905
#define REG_BK13B9_03_L      0x13B906
#define REG_BK13B9_03_H      0x13B907
#define REG_BK13B9_04_L      0x13B908
#define REG_BK13B9_04_H      0x13B909
#define REG_BK13B9_05_L      0x13B90A
#define REG_BK13B9_05_H      0x13B90B
#define REG_BK13B9_06_L      0x13B90C
#define REG_BK13B9_06_H      0x13B90D
#define REG_BK13B9_07_L      0x13B90E
#define REG_BK13B9_07_H      0x13B90F
#define REG_BK13B9_08_L      0x13B910
#define REG_BK13B9_08_H      0x13B911
#define REG_BK13B9_09_L      0x13B912
#define REG_BK13B9_09_H      0x13B913
#define REG_BK13B9_0A_L      0x13B914
#define REG_BK13B9_0A_H      0x13B915
#define REG_BK13B9_0B_L      0x13B916
#define REG_BK13B9_0B_H      0x13B917
#define REG_BK13B9_0C_L      0x13B918
#define REG_BK13B9_0C_H      0x13B919
#define REG_BK13B9_0D_L      0x13B91A
#define REG_BK13B9_0D_H      0x13B91B
#define REG_BK13B9_0E_L      0x13B91C
#define REG_BK13B9_0E_H      0x13B91D
#define REG_BK13B9_0F_L      0x13B91E
#define REG_BK13B9_0F_H      0x13B91F
#define REG_BK13B9_10_L      0x13B920
#define REG_BK13B9_10_H      0x13B921
#define REG_BK13B9_11_L      0x13B922
#define REG_BK13B9_11_H      0x13B923
#define REG_BK13B9_12_L      0x13B924
#define REG_BK13B9_12_H      0x13B925
#define REG_BK13B9_13_L      0x13B926
#define REG_BK13B9_13_H      0x13B927
#define REG_BK13B9_14_L      0x13B928
#define REG_BK13B9_14_H      0x13B929
#define REG_BK13B9_15_L      0x13B92A
#define REG_BK13B9_15_H      0x13B92B
#define REG_BK13B9_16_L      0x13B92C
#define REG_BK13B9_16_H      0x13B92D
#define REG_BK13B9_17_L      0x13B92E
#define REG_BK13B9_17_H      0x13B92F
#define REG_BK13B9_18_L      0x13B930
#define REG_BK13B9_18_H      0x13B931
#define REG_BK13B9_19_L      0x13B932
#define REG_BK13B9_19_H      0x13B933
#define REG_BK13B9_1A_L      0x13B934
#define REG_BK13B9_1A_H      0x13B935
#define REG_BK13B9_1B_L      0x13B936
#define REG_BK13B9_1B_H      0x13B937
#define REG_BK13B9_1C_L      0x13B938
#define REG_BK13B9_1C_H      0x13B939
#define REG_BK13B9_1D_L      0x13B93A
#define REG_BK13B9_1D_H      0x13B93B
#define REG_BK13B9_1E_L      0x13B93C
#define REG_BK13B9_1E_H      0x13B93D
#define REG_BK13B9_1F_L      0x13B93E
#define REG_BK13B9_1F_H      0x13B93F
#define REG_BK13B9_20_L      0x13B940
#define REG_BK13B9_20_H      0x13B941
#define REG_BK13B9_21_L      0x13B942
#define REG_BK13B9_21_H      0x13B943
#define REG_BK13B9_22_L      0x13B944
#define REG_BK13B9_22_H      0x13B945
#define REG_BK13B9_23_L      0x13B946
#define REG_BK13B9_23_H      0x13B947
#define REG_BK13B9_24_L      0x13B948
#define REG_BK13B9_24_H      0x13B949
#define REG_BK13B9_25_L      0x13B94A
#define REG_BK13B9_25_H      0x13B94B
#define REG_BK13B9_26_L      0x13B94C
#define REG_BK13B9_26_H      0x13B94D
#define REG_BK13B9_27_L      0x13B94E
#define REG_BK13B9_27_H      0x13B94F
#define REG_BK13B9_28_L      0x13B950
#define REG_BK13B9_28_H      0x13B951
#define REG_BK13B9_29_L      0x13B952
#define REG_BK13B9_29_H      0x13B953
#define REG_BK13B9_2A_L      0x13B954
#define REG_BK13B9_2A_H      0x13B955
#define REG_BK13B9_2B_L      0x13B956
#define REG_BK13B9_2B_H      0x13B957
#define REG_BK13B9_2C_L      0x13B958
#define REG_BK13B9_2C_H      0x13B959
#define REG_BK13B9_2D_L      0x13B95A
#define REG_BK13B9_2D_H      0x13B95B
#define REG_BK13B9_2E_L      0x13B95C
#define REG_BK13B9_2E_H      0x13B95D
#define REG_BK13B9_2F_L      0x13B95E
#define REG_BK13B9_2F_H      0x13B95F
#define REG_BK13B9_30_L      0x13B960
#define REG_BK13B9_30_H      0x13B961
#define REG_BK13B9_31_L      0x13B962
#define REG_BK13B9_31_H      0x13B963
#define REG_BK13B9_32_L      0x13B964
#define REG_BK13B9_32_H      0x13B965
#define REG_BK13B9_33_L      0x13B966
#define REG_BK13B9_33_H      0x13B967
#define REG_BK13B9_34_L      0x13B968
#define REG_BK13B9_34_H      0x13B969
#define REG_BK13B9_35_L      0x13B96A
#define REG_BK13B9_35_H      0x13B96B
#define REG_BK13B9_36_L      0x13B96C
#define REG_BK13B9_36_H      0x13B96D
#define REG_BK13B9_37_L      0x13B96E
#define REG_BK13B9_37_H      0x13B96F
#define REG_BK13B9_38_L      0x13B970
#define REG_BK13B9_38_H      0x13B971
#define REG_BK13B9_39_L      0x13B972
#define REG_BK13B9_39_H      0x13B973
#define REG_BK13B9_3A_L      0x13B974
#define REG_BK13B9_3A_H      0x13B975
#define REG_BK13B9_3B_L      0x13B976
#define REG_BK13B9_3B_H      0x13B977
#define REG_BK13B9_3C_L      0x13B978
#define REG_BK13B9_3C_H      0x13B979
#define REG_BK13B9_3D_L      0x13B97A
#define REG_BK13B9_3D_H      0x13B97B
#define REG_BK13B9_3E_L      0x13B97C
#define REG_BK13B9_3E_H      0x13B97D
#define REG_BK13B9_3F_L      0x13B97E
#define REG_BK13B9_3F_H      0x13B97F
#define REG_BK13B9_40_L      0x13B980
#define REG_BK13B9_40_H      0x13B981
#define REG_BK13B9_41_L      0x13B982
#define REG_BK13B9_41_H      0x13B983
#define REG_BK13B9_42_L      0x13B984
#define REG_BK13B9_42_H      0x13B985
#define REG_BK13B9_43_L      0x13B986
#define REG_BK13B9_43_H      0x13B987
#define REG_BK13B9_44_L      0x13B988
#define REG_BK13B9_44_H      0x13B989
#define REG_BK13B9_45_L      0x13B98A
#define REG_BK13B9_45_H      0x13B98B
#define REG_BK13B9_46_L      0x13B98C
#define REG_BK13B9_46_H      0x13B98D
#define REG_BK13B9_47_L      0x13B98E
#define REG_BK13B9_47_H      0x13B98F
#define REG_BK13B9_48_L      0x13B990
#define REG_BK13B9_48_H      0x13B991
#define REG_BK13B9_49_L      0x13B992
#define REG_BK13B9_49_H      0x13B993
#define REG_BK13B9_4A_L      0x13B994
#define REG_BK13B9_4A_H      0x13B995
#define REG_BK13B9_4B_L      0x13B996
#define REG_BK13B9_4B_H      0x13B997
#define REG_BK13B9_4C_L      0x13B998
#define REG_BK13B9_4C_H      0x13B999
#define REG_BK13B9_4D_L      0x13B99A
#define REG_BK13B9_4D_H      0x13B99B
#define REG_BK13B9_4E_L      0x13B99C
#define REG_BK13B9_4E_H      0x13B99D
#define REG_BK13B9_4F_L      0x13B99E
#define REG_BK13B9_4F_H      0x13B99F
#define REG_BK13B9_50_L      0x13B9A0
#define REG_BK13B9_50_H      0x13B9A1
#define REG_BK13B9_51_L      0x13B9A2
#define REG_BK13B9_51_H      0x13B9A3
#define REG_BK13B9_52_L      0x13B9A4
#define REG_BK13B9_52_H      0x13B9A5
#define REG_BK13B9_53_L      0x13B9A6
#define REG_BK13B9_53_H      0x13B9A7
#define REG_BK13B9_54_L      0x13B9A8
#define REG_BK13B9_54_H      0x13B9A9
#define REG_BK13B9_55_L      0x13B9AA
#define REG_BK13B9_55_H      0x13B9AB
#define REG_BK13B9_56_L      0x13B9AC
#define REG_BK13B9_56_H      0x13B9AD
#define REG_BK13B9_57_L      0x13B9AE
#define REG_BK13B9_57_H      0x13B9AF
#define REG_BK13B9_58_L      0x13B9B0
#define REG_BK13B9_58_H      0x13B9B1
#define REG_BK13B9_59_L      0x13B9B2
#define REG_BK13B9_59_H      0x13B9B3
#define REG_BK13B9_5A_L      0x13B9B4
#define REG_BK13B9_5A_H      0x13B9B5
#define REG_BK13B9_5B_L      0x13B9B6
#define REG_BK13B9_5B_H      0x13B9B7
#define REG_BK13B9_5C_L      0x13B9B8
#define REG_BK13B9_5C_H      0x13B9B9
#define REG_BK13B9_5D_L      0x13B9BA
#define REG_BK13B9_5D_H      0x13B9BB
#define REG_BK13B9_5E_L      0x13B9BC
#define REG_BK13B9_5E_H      0x13B9BD
#define REG_BK13B9_5F_L      0x13B9BE
#define REG_BK13B9_5F_H      0x13B9BF
#define REG_BK13B9_60_L      0x13B9C0
#define REG_BK13B9_60_H      0x13B9C1
#define REG_BK13B9_61_L      0x13B9C2
#define REG_BK13B9_61_H      0x13B9C3
#define REG_BK13B9_62_L      0x13B9C4
#define REG_BK13B9_62_H      0x13B9C5
#define REG_BK13B9_63_L      0x13B9C6
#define REG_BK13B9_63_H      0x13B9C7
#define REG_BK13B9_64_L      0x13B9C8
#define REG_BK13B9_64_H      0x13B9C9
#define REG_BK13B9_65_L      0x13B9CA
#define REG_BK13B9_65_H      0x13B9CB
#define REG_BK13B9_66_L      0x13B9CC
#define REG_BK13B9_66_H      0x13B9CD
#define REG_BK13B9_67_L      0x13B9CE
#define REG_BK13B9_67_H      0x13B9CF
#define REG_BK13B9_68_L      0x13B9D0
#define REG_BK13B9_68_H      0x13B9D1
#define REG_BK13B9_69_L      0x13B9D2
#define REG_BK13B9_69_H      0x13B9D3
#define REG_BK13B9_6A_L      0x13B9D4
#define REG_BK13B9_6A_H      0x13B9D5
#define REG_BK13B9_6B_L      0x13B9D6
#define REG_BK13B9_6B_H      0x13B9D7
#define REG_BK13B9_6C_L      0x13B9D8
#define REG_BK13B9_6C_H      0x13B9D9
#define REG_BK13B9_6D_L      0x13B9DA
#define REG_BK13B9_6D_H      0x13B9DB
#define REG_BK13B9_6E_L      0x13B9DC
#define REG_BK13B9_6E_H      0x13B9DD
#define REG_BK13B9_6F_L      0x13B9DE
#define REG_BK13B9_6F_H      0x13B9DF
#define REG_BK13B9_70_L      0x13B9E0
#define REG_BK13B9_70_H      0x13B9E1
#define REG_BK13B9_71_L      0x13B9E2
#define REG_BK13B9_71_H      0x13B9E3
#define REG_BK13B9_72_L      0x13B9E4
#define REG_BK13B9_72_H      0x13B9E5
#define REG_BK13B9_73_L      0x13B9E6
#define REG_BK13B9_73_H      0x13B9E7
#define REG_BK13B9_74_L      0x13B9E8
#define REG_BK13B9_74_H      0x13B9E9
#define REG_BK13B9_75_L      0x13B9EA
#define REG_BK13B9_75_H      0x13B9EB
#define REG_BK13B9_76_L      0x13B9EC
#define REG_BK13B9_76_H      0x13B9ED
#define REG_BK13B9_77_L      0x13B9EE
#define REG_BK13B9_77_H      0x13B9EF
#define REG_BK13B9_78_L      0x13B9F0
#define REG_BK13B9_78_H      0x13B9F1
#define REG_BK13B9_79_L      0x13B9F2
#define REG_BK13B9_79_H      0x13B9F3
#define REG_BK13B9_7A_L      0x13B9F4
#define REG_BK13B9_7A_H      0x13B9F5
#define REG_BK13B9_7B_L      0x13B9F6
#define REG_BK13B9_7B_H      0x13B9F7
#define REG_BK13B9_7C_L      0x13B9F8
#define REG_BK13B9_7C_H      0x13B9F9
#define REG_BK13B9_7D_L      0x13B9FA
#define REG_BK13B9_7D_H      0x13B9FB
#define REG_BK13B9_7E_L      0x13B9FC
#define REG_BK13B9_7E_H      0x13B9FD
#define REG_BK13B9_7F_L      0x13B9FE
#define REG_BK13B9_7F_H      0x13B9FF
//----------------------------------------------
#define REG_BK13BA_00_L      0x13BA00
#define REG_BK13BA_00_H      0x13BA01
#define REG_BK13BA_01_L      0x13BA02
#define REG_BK13BA_01_H      0x13BA03
#define REG_BK13BA_02_L      0x13BA04
#define REG_BK13BA_02_H      0x13BA05
#define REG_BK13BA_03_L      0x13BA06
#define REG_BK13BA_03_H      0x13BA07
#define REG_BK13BA_04_L      0x13BA08
#define REG_BK13BA_04_H      0x13BA09
#define REG_BK13BA_05_L      0x13BA0A
#define REG_BK13BA_05_H      0x13BA0B
#define REG_BK13BA_06_L      0x13BA0C
#define REG_BK13BA_06_H      0x13BA0D
#define REG_BK13BA_07_L      0x13BA0E
#define REG_BK13BA_07_H      0x13BA0F
#define REG_BK13BA_08_L      0x13BA10
#define REG_BK13BA_08_H      0x13BA11
#define REG_BK13BA_09_L      0x13BA12
#define REG_BK13BA_09_H      0x13BA13
#define REG_BK13BA_0A_L      0x13BA14
#define REG_BK13BA_0A_H      0x13BA15
#define REG_BK13BA_0B_L      0x13BA16
#define REG_BK13BA_0B_H      0x13BA17
#define REG_BK13BA_0C_L      0x13BA18
#define REG_BK13BA_0C_H      0x13BA19
#define REG_BK13BA_0D_L      0x13BA1A
#define REG_BK13BA_0D_H      0x13BA1B
#define REG_BK13BA_0E_L      0x13BA1C
#define REG_BK13BA_0E_H      0x13BA1D
#define REG_BK13BA_0F_L      0x13BA1E
#define REG_BK13BA_0F_H      0x13BA1F
#define REG_BK13BA_10_L      0x13BA20
#define REG_BK13BA_10_H      0x13BA21
#define REG_BK13BA_11_L      0x13BA22
#define REG_BK13BA_11_H      0x13BA23
#define REG_BK13BA_12_L      0x13BA24
#define REG_BK13BA_12_H      0x13BA25
#define REG_BK13BA_13_L      0x13BA26
#define REG_BK13BA_13_H      0x13BA27
#define REG_BK13BA_14_L      0x13BA28
#define REG_BK13BA_14_H      0x13BA29
#define REG_BK13BA_15_L      0x13BA2A
#define REG_BK13BA_15_H      0x13BA2B
#define REG_BK13BA_16_L      0x13BA2C
#define REG_BK13BA_16_H      0x13BA2D
#define REG_BK13BA_17_L      0x13BA2E
#define REG_BK13BA_17_H      0x13BA2F
#define REG_BK13BA_18_L      0x13BA30
#define REG_BK13BA_18_H      0x13BA31
#define REG_BK13BA_19_L      0x13BA32
#define REG_BK13BA_19_H      0x13BA33
#define REG_BK13BA_1A_L      0x13BA34
#define REG_BK13BA_1A_H      0x13BA35
#define REG_BK13BA_1B_L      0x13BA36
#define REG_BK13BA_1B_H      0x13BA37
#define REG_BK13BA_1C_L      0x13BA38
#define REG_BK13BA_1C_H      0x13BA39
#define REG_BK13BA_1D_L      0x13BA3A
#define REG_BK13BA_1D_H      0x13BA3B
#define REG_BK13BA_1E_L      0x13BA3C
#define REG_BK13BA_1E_H      0x13BA3D
#define REG_BK13BA_1F_L      0x13BA3E
#define REG_BK13BA_1F_H      0x13BA3F
#define REG_BK13BA_20_L      0x13BA40
#define REG_BK13BA_20_H      0x13BA41
#define REG_BK13BA_21_L      0x13BA42
#define REG_BK13BA_21_H      0x13BA43
#define REG_BK13BA_22_L      0x13BA44
#define REG_BK13BA_22_H      0x13BA45
#define REG_BK13BA_23_L      0x13BA46
#define REG_BK13BA_23_H      0x13BA47
#define REG_BK13BA_24_L      0x13BA48
#define REG_BK13BA_24_H      0x13BA49
#define REG_BK13BA_25_L      0x13BA4A
#define REG_BK13BA_25_H      0x13BA4B
#define REG_BK13BA_26_L      0x13BA4C
#define REG_BK13BA_26_H      0x13BA4D
#define REG_BK13BA_27_L      0x13BA4E
#define REG_BK13BA_27_H      0x13BA4F
#define REG_BK13BA_28_L      0x13BA50
#define REG_BK13BA_28_H      0x13BA51
#define REG_BK13BA_29_L      0x13BA52
#define REG_BK13BA_29_H      0x13BA53
#define REG_BK13BA_2A_L      0x13BA54
#define REG_BK13BA_2A_H      0x13BA55
#define REG_BK13BA_2B_L      0x13BA56
#define REG_BK13BA_2B_H      0x13BA57
#define REG_BK13BA_2C_L      0x13BA58
#define REG_BK13BA_2C_H      0x13BA59
#define REG_BK13BA_2D_L      0x13BA5A
#define REG_BK13BA_2D_H      0x13BA5B
#define REG_BK13BA_2E_L      0x13BA5C
#define REG_BK13BA_2E_H      0x13BA5D
#define REG_BK13BA_2F_L      0x13BA5E
#define REG_BK13BA_2F_H      0x13BA5F
#define REG_BK13BA_30_L      0x13BA60
#define REG_BK13BA_30_H      0x13BA61
#define REG_BK13BA_31_L      0x13BA62
#define REG_BK13BA_31_H      0x13BA63
#define REG_BK13BA_32_L      0x13BA64
#define REG_BK13BA_32_H      0x13BA65
#define REG_BK13BA_33_L      0x13BA66
#define REG_BK13BA_33_H      0x13BA67
#define REG_BK13BA_34_L      0x13BA68
#define REG_BK13BA_34_H      0x13BA69
#define REG_BK13BA_35_L      0x13BA6A
#define REG_BK13BA_35_H      0x13BA6B
#define REG_BK13BA_36_L      0x13BA6C
#define REG_BK13BA_36_H      0x13BA6D
#define REG_BK13BA_37_L      0x13BA6E
#define REG_BK13BA_37_H      0x13BA6F
#define REG_BK13BA_38_L      0x13BA70
#define REG_BK13BA_38_H      0x13BA71
#define REG_BK13BA_39_L      0x13BA72
#define REG_BK13BA_39_H      0x13BA73
#define REG_BK13BA_3A_L      0x13BA74
#define REG_BK13BA_3A_H      0x13BA75
#define REG_BK13BA_3B_L      0x13BA76
#define REG_BK13BA_3B_H      0x13BA77
#define REG_BK13BA_3C_L      0x13BA78
#define REG_BK13BA_3C_H      0x13BA79
#define REG_BK13BA_3D_L      0x13BA7A
#define REG_BK13BA_3D_H      0x13BA7B
#define REG_BK13BA_3E_L      0x13BA7C
#define REG_BK13BA_3E_H      0x13BA7D
#define REG_BK13BA_3F_L      0x13BA7E
#define REG_BK13BA_3F_H      0x13BA7F
#define REG_BK13BA_40_L      0x13BA80
#define REG_BK13BA_40_H      0x13BA81
#define REG_BK13BA_41_L      0x13BA82
#define REG_BK13BA_41_H      0x13BA83
#define REG_BK13BA_42_L      0x13BA84
#define REG_BK13BA_42_H      0x13BA85
#define REG_BK13BA_43_L      0x13BA86
#define REG_BK13BA_43_H      0x13BA87
#define REG_BK13BA_44_L      0x13BA88
#define REG_BK13BA_44_H      0x13BA89
#define REG_BK13BA_45_L      0x13BA8A
#define REG_BK13BA_45_H      0x13BA8B
#define REG_BK13BA_46_L      0x13BA8C
#define REG_BK13BA_46_H      0x13BA8D
#define REG_BK13BA_47_L      0x13BA8E
#define REG_BK13BA_47_H      0x13BA8F
#define REG_BK13BA_48_L      0x13BA90
#define REG_BK13BA_48_H      0x13BA91
#define REG_BK13BA_49_L      0x13BA92
#define REG_BK13BA_49_H      0x13BA93
#define REG_BK13BA_4A_L      0x13BA94
#define REG_BK13BA_4A_H      0x13BA95
#define REG_BK13BA_4B_L      0x13BA96
#define REG_BK13BA_4B_H      0x13BA97
#define REG_BK13BA_4C_L      0x13BA98
#define REG_BK13BA_4C_H      0x13BA99
#define REG_BK13BA_4D_L      0x13BA9A
#define REG_BK13BA_4D_H      0x13BA9B
#define REG_BK13BA_4E_L      0x13BA9C
#define REG_BK13BA_4E_H      0x13BA9D
#define REG_BK13BA_4F_L      0x13BA9E
#define REG_BK13BA_4F_H      0x13BA9F
#define REG_BK13BA_50_L      0x13BAA0
#define REG_BK13BA_50_H      0x13BAA1
#define REG_BK13BA_51_L      0x13BAA2
#define REG_BK13BA_51_H      0x13BAA3
#define REG_BK13BA_52_L      0x13BAA4
#define REG_BK13BA_52_H      0x13BAA5
#define REG_BK13BA_53_L      0x13BAA6
#define REG_BK13BA_53_H      0x13BAA7
#define REG_BK13BA_54_L      0x13BAA8
#define REG_BK13BA_54_H      0x13BAA9
#define REG_BK13BA_55_L      0x13BAAA
#define REG_BK13BA_55_H      0x13BAAB
#define REG_BK13BA_56_L      0x13BAAC
#define REG_BK13BA_56_H      0x13BAAD
#define REG_BK13BA_57_L      0x13BAAE
#define REG_BK13BA_57_H      0x13BAAF
#define REG_BK13BA_58_L      0x13BAB0
#define REG_BK13BA_58_H      0x13BAB1
#define REG_BK13BA_59_L      0x13BAB2
#define REG_BK13BA_59_H      0x13BAB3
#define REG_BK13BA_5A_L      0x13BAB4
#define REG_BK13BA_5A_H      0x13BAB5
#define REG_BK13BA_5B_L      0x13BAB6
#define REG_BK13BA_5B_H      0x13BAB7
#define REG_BK13BA_5C_L      0x13BAB8
#define REG_BK13BA_5C_H      0x13BAB9
#define REG_BK13BA_5D_L      0x13BABA
#define REG_BK13BA_5D_H      0x13BABB
#define REG_BK13BA_5E_L      0x13BABC
#define REG_BK13BA_5E_H      0x13BABD
#define REG_BK13BA_5F_L      0x13BABE
#define REG_BK13BA_5F_H      0x13BABF
#define REG_BK13BA_60_L      0x13BAC0
#define REG_BK13BA_60_H      0x13BAC1
#define REG_BK13BA_61_L      0x13BAC2
#define REG_BK13BA_61_H      0x13BAC3
#define REG_BK13BA_62_L      0x13BAC4
#define REG_BK13BA_62_H      0x13BAC5
#define REG_BK13BA_63_L      0x13BAC6
#define REG_BK13BA_63_H      0x13BAC7
#define REG_BK13BA_64_L      0x13BAC8
#define REG_BK13BA_64_H      0x13BAC9
#define REG_BK13BA_65_L      0x13BACA
#define REG_BK13BA_65_H      0x13BACB
#define REG_BK13BA_66_L      0x13BACC
#define REG_BK13BA_66_H      0x13BACD
#define REG_BK13BA_67_L      0x13BACE
#define REG_BK13BA_67_H      0x13BACF
#define REG_BK13BA_68_L      0x13BAD0
#define REG_BK13BA_68_H      0x13BAD1
#define REG_BK13BA_69_L      0x13BAD2
#define REG_BK13BA_69_H      0x13BAD3
#define REG_BK13BA_6A_L      0x13BAD4
#define REG_BK13BA_6A_H      0x13BAD5
#define REG_BK13BA_6B_L      0x13BAD6
#define REG_BK13BA_6B_H      0x13BAD7
#define REG_BK13BA_6C_L      0x13BAD8
#define REG_BK13BA_6C_H      0x13BAD9
#define REG_BK13BA_6D_L      0x13BADA
#define REG_BK13BA_6D_H      0x13BADB
#define REG_BK13BA_6E_L      0x13BADC
#define REG_BK13BA_6E_H      0x13BADD
#define REG_BK13BA_6F_L      0x13BADE
#define REG_BK13BA_6F_H      0x13BADF
#define REG_BK13BA_70_L      0x13BAE0
#define REG_BK13BA_70_H      0x13BAE1
#define REG_BK13BA_71_L      0x13BAE2
#define REG_BK13BA_71_H      0x13BAE3
#define REG_BK13BA_72_L      0x13BAE4
#define REG_BK13BA_72_H      0x13BAE5
#define REG_BK13BA_73_L      0x13BAE6
#define REG_BK13BA_73_H      0x13BAE7
#define REG_BK13BA_74_L      0x13BAE8
#define REG_BK13BA_74_H      0x13BAE9
#define REG_BK13BA_75_L      0x13BAEA
#define REG_BK13BA_75_H      0x13BAEB
#define REG_BK13BA_76_L      0x13BAEC
#define REG_BK13BA_76_H      0x13BAED
#define REG_BK13BA_77_L      0x13BAEE
#define REG_BK13BA_77_H      0x13BAEF
#define REG_BK13BA_78_L      0x13BAF0
#define REG_BK13BA_78_H      0x13BAF1
#define REG_BK13BA_79_L      0x13BAF2
#define REG_BK13BA_79_H      0x13BAF3
#define REG_BK13BA_7A_L      0x13BAF4
#define REG_BK13BA_7A_H      0x13BAF5
#define REG_BK13BA_7B_L      0x13BAF6
#define REG_BK13BA_7B_H      0x13BAF7
#define REG_BK13BA_7C_L      0x13BAF8
#define REG_BK13BA_7C_H      0x13BAF9
#define REG_BK13BA_7D_L      0x13BAFA
#define REG_BK13BA_7D_H      0x13BAFB
#define REG_BK13BA_7E_L      0x13BAFC
#define REG_BK13BA_7E_H      0x13BAFD
#define REG_BK13BA_7F_L      0x13BAFE
#define REG_BK13BA_7F_H      0x13BAFF
//----------------------------------------------
#define REG_BK13C7_00_L      0x13C700
#define REG_BK13C7_00_H      0x13C701
#define REG_BK13C7_01_L      0x13C702
#define REG_BK13C7_01_H      0x13C703
#define REG_BK13C7_02_L      0x13C704
#define REG_BK13C7_02_H      0x13C705
#define REG_BK13C7_03_L      0x13C706
#define REG_BK13C7_03_H      0x13C707
#define REG_BK13C7_04_L      0x13C708
#define REG_BK13C7_04_H      0x13C709
#define REG_BK13C7_05_L      0x13C70A
#define REG_BK13C7_05_H      0x13C70B
#define REG_BK13C7_06_L      0x13C70C
#define REG_BK13C7_06_H      0x13C70D
#define REG_BK13C7_07_L      0x13C70E
#define REG_BK13C7_07_H      0x13C70F
#define REG_BK13C7_08_L      0x13C710
#define REG_BK13C7_08_H      0x13C711
#define REG_BK13C7_09_L      0x13C712
#define REG_BK13C7_09_H      0x13C713
#define REG_BK13C7_0A_L      0x13C714
#define REG_BK13C7_0A_H      0x13C715
#define REG_BK13C7_0B_L      0x13C716
#define REG_BK13C7_0B_H      0x13C717
#define REG_BK13C7_0C_L      0x13C718
#define REG_BK13C7_0C_H      0x13C719
#define REG_BK13C7_0D_L      0x13C71A
#define REG_BK13C7_0D_H      0x13C71B
#define REG_BK13C7_0E_L      0x13C71C
#define REG_BK13C7_0E_H      0x13C71D
#define REG_BK13C7_0F_L      0x13C71E
#define REG_BK13C7_0F_H      0x13C71F
#define REG_BK13C7_10_L      0x13C720
#define REG_BK13C7_10_H      0x13C721
#define REG_BK13C7_11_L      0x13C722
#define REG_BK13C7_11_H      0x13C723
#define REG_BK13C7_12_L      0x13C724
#define REG_BK13C7_12_H      0x13C725
#define REG_BK13C7_13_L      0x13C726
#define REG_BK13C7_13_H      0x13C727
#define REG_BK13C7_14_L      0x13C728
#define REG_BK13C7_14_H      0x13C729
#define REG_BK13C7_15_L      0x13C72A
#define REG_BK13C7_15_H      0x13C72B
#define REG_BK13C7_16_L      0x13C72C
#define REG_BK13C7_16_H      0x13C72D
#define REG_BK13C7_17_L      0x13C72E
#define REG_BK13C7_17_H      0x13C72F
#define REG_BK13C7_18_L      0x13C730
#define REG_BK13C7_18_H      0x13C731
#define REG_BK13C7_19_L      0x13C732
#define REG_BK13C7_19_H      0x13C733
#define REG_BK13C7_1A_L      0x13C734
#define REG_BK13C7_1A_H      0x13C735
#define REG_BK13C7_1B_L      0x13C736
#define REG_BK13C7_1B_H      0x13C737
#define REG_BK13C7_1C_L      0x13C738
#define REG_BK13C7_1C_H      0x13C739
#define REG_BK13C7_1D_L      0x13C73A
#define REG_BK13C7_1D_H      0x13C73B
#define REG_BK13C7_1E_L      0x13C73C
#define REG_BK13C7_1E_H      0x13C73D
#define REG_BK13C7_1F_L      0x13C73E
#define REG_BK13C7_1F_H      0x13C73F
#define REG_BK13C7_20_L      0x13C740
#define REG_BK13C7_20_H      0x13C741
#define REG_BK13C7_21_L      0x13C742
#define REG_BK13C7_21_H      0x13C743
#define REG_BK13C7_22_L      0x13C744
#define REG_BK13C7_22_H      0x13C745
#define REG_BK13C7_23_L      0x13C746
#define REG_BK13C7_23_H      0x13C747
#define REG_BK13C7_24_L      0x13C748
#define REG_BK13C7_24_H      0x13C749
#define REG_BK13C7_25_L      0x13C74A
#define REG_BK13C7_25_H      0x13C74B
#define REG_BK13C7_26_L      0x13C74C
#define REG_BK13C7_26_H      0x13C74D
#define REG_BK13C7_27_L      0x13C74E
#define REG_BK13C7_27_H      0x13C74F
#define REG_BK13C7_28_L      0x13C750
#define REG_BK13C7_28_H      0x13C751
#define REG_BK13C7_29_L      0x13C752
#define REG_BK13C7_29_H      0x13C753
#define REG_BK13C7_2A_L      0x13C754
#define REG_BK13C7_2A_H      0x13C755
#define REG_BK13C7_2B_L      0x13C756
#define REG_BK13C7_2B_H      0x13C757
#define REG_BK13C7_2C_L      0x13C758
#define REG_BK13C7_2C_H      0x13C759
#define REG_BK13C7_2D_L      0x13C75A
#define REG_BK13C7_2D_H      0x13C75B
#define REG_BK13C7_2E_L      0x13C75C
#define REG_BK13C7_2E_H      0x13C75D
#define REG_BK13C7_2F_L      0x13C75E
#define REG_BK13C7_2F_H      0x13C75F
#define REG_BK13C7_30_L      0x13C760
#define REG_BK13C7_30_H      0x13C761
#define REG_BK13C7_31_L      0x13C762
#define REG_BK13C7_31_H      0x13C763
#define REG_BK13C7_32_L      0x13C764
#define REG_BK13C7_32_H      0x13C765
#define REG_BK13C7_33_L      0x13C766
#define REG_BK13C7_33_H      0x13C767
#define REG_BK13C7_34_L      0x13C768
#define REG_BK13C7_34_H      0x13C769
#define REG_BK13C7_35_L      0x13C76A
#define REG_BK13C7_35_H      0x13C76B
#define REG_BK13C7_36_L      0x13C76C
#define REG_BK13C7_36_H      0x13C76D
#define REG_BK13C7_37_L      0x13C76E
#define REG_BK13C7_37_H      0x13C76F
#define REG_BK13C7_38_L      0x13C770
#define REG_BK13C7_38_H      0x13C771
#define REG_BK13C7_39_L      0x13C772
#define REG_BK13C7_39_H      0x13C773
#define REG_BK13C7_3A_L      0x13C774
#define REG_BK13C7_3A_H      0x13C775
#define REG_BK13C7_3B_L      0x13C776
#define REG_BK13C7_3B_H      0x13C777
#define REG_BK13C7_3C_L      0x13C778
#define REG_BK13C7_3C_H      0x13C779
#define REG_BK13C7_3D_L      0x13C77A
#define REG_BK13C7_3D_H      0x13C77B
#define REG_BK13C7_3E_L      0x13C77C
#define REG_BK13C7_3E_H      0x13C77D
#define REG_BK13C7_3F_L      0x13C77E
#define REG_BK13C7_3F_H      0x13C77F
#define REG_BK13C7_40_L      0x13C780
#define REG_BK13C7_40_H      0x13C781
#define REG_BK13C7_41_L      0x13C782
#define REG_BK13C7_41_H      0x13C783
#define REG_BK13C7_42_L      0x13C784
#define REG_BK13C7_42_H      0x13C785
#define REG_BK13C7_43_L      0x13C786
#define REG_BK13C7_43_H      0x13C787
#define REG_BK13C7_44_L      0x13C788
#define REG_BK13C7_44_H      0x13C789
#define REG_BK13C7_45_L      0x13C78A
#define REG_BK13C7_45_H      0x13C78B
#define REG_BK13C7_46_L      0x13C78C
#define REG_BK13C7_46_H      0x13C78D
#define REG_BK13C7_47_L      0x13C78E
#define REG_BK13C7_47_H      0x13C78F
#define REG_BK13C7_48_L      0x13C790
#define REG_BK13C7_48_H      0x13C791
#define REG_BK13C7_49_L      0x13C792
#define REG_BK13C7_49_H      0x13C793
#define REG_BK13C7_4A_L      0x13C794
#define REG_BK13C7_4A_H      0x13C795
#define REG_BK13C7_4B_L      0x13C796
#define REG_BK13C7_4B_H      0x13C797
#define REG_BK13C7_4C_L      0x13C798
#define REG_BK13C7_4C_H      0x13C799
#define REG_BK13C7_4D_L      0x13C79A
#define REG_BK13C7_4D_H      0x13C79B
#define REG_BK13C7_4E_L      0x13C79C
#define REG_BK13C7_4E_H      0x13C79D
#define REG_BK13C7_4F_L      0x13C79E
#define REG_BK13C7_4F_H      0x13C79F
#define REG_BK13C7_50_L      0x13C7A0
#define REG_BK13C7_50_H      0x13C7A1
#define REG_BK13C7_51_L      0x13C7A2
#define REG_BK13C7_51_H      0x13C7A3
#define REG_BK13C7_52_L      0x13C7A4
#define REG_BK13C7_52_H      0x13C7A5
#define REG_BK13C7_53_L      0x13C7A6
#define REG_BK13C7_53_H      0x13C7A7
#define REG_BK13C7_54_L      0x13C7A8
#define REG_BK13C7_54_H      0x13C7A9
#define REG_BK13C7_55_L      0x13C7AA
#define REG_BK13C7_55_H      0x13C7AB
#define REG_BK13C7_56_L      0x13C7AC
#define REG_BK13C7_56_H      0x13C7AD
#define REG_BK13C7_57_L      0x13C7AE
#define REG_BK13C7_57_H      0x13C7AF
#define REG_BK13C7_58_L      0x13C7B0
#define REG_BK13C7_58_H      0x13C7B1
#define REG_BK13C7_59_L      0x13C7B2
#define REG_BK13C7_59_H      0x13C7B3
#define REG_BK13C7_5A_L      0x13C7B4
#define REG_BK13C7_5A_H      0x13C7B5
#define REG_BK13C7_5B_L      0x13C7B6
#define REG_BK13C7_5B_H      0x13C7B7
#define REG_BK13C7_5C_L      0x13C7B8
#define REG_BK13C7_5C_H      0x13C7B9
#define REG_BK13C7_5D_L      0x13C7BA
#define REG_BK13C7_5D_H      0x13C7BB
#define REG_BK13C7_5E_L      0x13C7BC
#define REG_BK13C7_5E_H      0x13C7BD
#define REG_BK13C7_5F_L      0x13C7BE
#define REG_BK13C7_5F_H      0x13C7BF
#define REG_BK13C7_60_L      0x13C7C0
#define REG_BK13C7_60_H      0x13C7C1
#define REG_BK13C7_61_L      0x13C7C2
#define REG_BK13C7_61_H      0x13C7C3
#define REG_BK13C7_62_L      0x13C7C4
#define REG_BK13C7_62_H      0x13C7C5
#define REG_BK13C7_63_L      0x13C7C6
#define REG_BK13C7_63_H      0x13C7C7
#define REG_BK13C7_64_L      0x13C7C8
#define REG_BK13C7_64_H      0x13C7C9
#define REG_BK13C7_65_L      0x13C7CA
#define REG_BK13C7_65_H      0x13C7CB
#define REG_BK13C7_66_L      0x13C7CC
#define REG_BK13C7_66_H      0x13C7CD
#define REG_BK13C7_67_L      0x13C7CE
#define REG_BK13C7_67_H      0x13C7CF
#define REG_BK13C7_68_L      0x13C7D0
#define REG_BK13C7_68_H      0x13C7D1
#define REG_BK13C7_69_L      0x13C7D2
#define REG_BK13C7_69_H      0x13C7D3
#define REG_BK13C7_6A_L      0x13C7D4
#define REG_BK13C7_6A_H      0x13C7D5
#define REG_BK13C7_6B_L      0x13C7D6
#define REG_BK13C7_6B_H      0x13C7D7
#define REG_BK13C7_6C_L      0x13C7D8
#define REG_BK13C7_6C_H      0x13C7D9
#define REG_BK13C7_6D_L      0x13C7DA
#define REG_BK13C7_6D_H      0x13C7DB
#define REG_BK13C7_6E_L      0x13C7DC
#define REG_BK13C7_6E_H      0x13C7DD
#define REG_BK13C7_6F_L      0x13C7DE
#define REG_BK13C7_6F_H      0x13C7DF
#define REG_BK13C7_70_L      0x13C7E0
#define REG_BK13C7_70_H      0x13C7E1
#define REG_BK13C7_71_L      0x13C7E2
#define REG_BK13C7_71_H      0x13C7E3
#define REG_BK13C7_72_L      0x13C7E4
#define REG_BK13C7_72_H      0x13C7E5
#define REG_BK13C7_73_L      0x13C7E6
#define REG_BK13C7_73_H      0x13C7E7
#define REG_BK13C7_74_L      0x13C7E8
#define REG_BK13C7_74_H      0x13C7E9
#define REG_BK13C7_75_L      0x13C7EA
#define REG_BK13C7_75_H      0x13C7EB
#define REG_BK13C7_76_L      0x13C7EC
#define REG_BK13C7_76_H      0x13C7ED
#define REG_BK13C7_77_L      0x13C7EE
#define REG_BK13C7_77_H      0x13C7EF
#define REG_BK13C7_78_L      0x13C7F0
#define REG_BK13C7_78_H      0x13C7F1
#define REG_BK13C7_79_L      0x13C7F2
#define REG_BK13C7_79_H      0x13C7F3
#define REG_BK13C7_7A_L      0x13C7F4
#define REG_BK13C7_7A_H      0x13C7F5
#define REG_BK13C7_7B_L      0x13C7F6
#define REG_BK13C7_7B_H      0x13C7F7
#define REG_BK13C7_7C_L      0x13C7F8
#define REG_BK13C7_7C_H      0x13C7F9
#define REG_BK13C7_7D_L      0x13C7FA
#define REG_BK13C7_7D_H      0x13C7FB
#define REG_BK13C7_7E_L      0x13C7FC
#define REG_BK13C7_7E_H      0x13C7FD
#define REG_BK13C7_7F_L      0x13C7FE
#define REG_BK13C7_7F_H      0x13C7FF
//----------------------------------------------
#define REG_BK13D7_00_L      0x13D700
#define REG_BK13D7_00_H      0x13D701
#define REG_BK13D7_01_L      0x13D702
#define REG_BK13D7_01_H      0x13D703
#define REG_BK13D7_02_L      0x13D704
#define REG_BK13D7_02_H      0x13D705
#define REG_BK13D7_03_L      0x13D706
#define REG_BK13D7_03_H      0x13D707
#define REG_BK13D7_04_L      0x13D708
#define REG_BK13D7_04_H      0x13D709
#define REG_BK13D7_05_L      0x13D70A
#define REG_BK13D7_05_H      0x13D70B
#define REG_BK13D7_06_L      0x13D70C
#define REG_BK13D7_06_H      0x13D70D
#define REG_BK13D7_07_L      0x13D70E
#define REG_BK13D7_07_H      0x13D70F
#define REG_BK13D7_08_L      0x13D710
#define REG_BK13D7_08_H      0x13D711
#define REG_BK13D7_09_L      0x13D712
#define REG_BK13D7_09_H      0x13D713
#define REG_BK13D7_0A_L      0x13D714
#define REG_BK13D7_0A_H      0x13D715
#define REG_BK13D7_0B_L      0x13D716
#define REG_BK13D7_0B_H      0x13D717
#define REG_BK13D7_0C_L      0x13D718
#define REG_BK13D7_0C_H      0x13D719
#define REG_BK13D7_0D_L      0x13D71A
#define REG_BK13D7_0D_H      0x13D71B
#define REG_BK13D7_0E_L      0x13D71C
#define REG_BK13D7_0E_H      0x13D71D
#define REG_BK13D7_0F_L      0x13D71E
#define REG_BK13D7_0F_H      0x13D71F
#define REG_BK13D7_10_L      0x13D720
#define REG_BK13D7_10_H      0x13D721
#define REG_BK13D7_11_L      0x13D722
#define REG_BK13D7_11_H      0x13D723
#define REG_BK13D7_12_L      0x13D724
#define REG_BK13D7_12_H      0x13D725
#define REG_BK13D7_13_L      0x13D726
#define REG_BK13D7_13_H      0x13D727
#define REG_BK13D7_14_L      0x13D728
#define REG_BK13D7_14_H      0x13D729
#define REG_BK13D7_15_L      0x13D72A
#define REG_BK13D7_15_H      0x13D72B
#define REG_BK13D7_16_L      0x13D72C
#define REG_BK13D7_16_H      0x13D72D
#define REG_BK13D7_17_L      0x13D72E
#define REG_BK13D7_17_H      0x13D72F
#define REG_BK13D7_18_L      0x13D730
#define REG_BK13D7_18_H      0x13D731
#define REG_BK13D7_19_L      0x13D732
#define REG_BK13D7_19_H      0x13D733
#define REG_BK13D7_1A_L      0x13D734
#define REG_BK13D7_1A_H      0x13D735
#define REG_BK13D7_1B_L      0x13D736
#define REG_BK13D7_1B_H      0x13D737
#define REG_BK13D7_1C_L      0x13D738
#define REG_BK13D7_1C_H      0x13D739
#define REG_BK13D7_1D_L      0x13D73A
#define REG_BK13D7_1D_H      0x13D73B
#define REG_BK13D7_1E_L      0x13D73C
#define REG_BK13D7_1E_H      0x13D73D
#define REG_BK13D7_1F_L      0x13D73E
#define REG_BK13D7_1F_H      0x13D73F
#define REG_BK13D7_20_L      0x13D740
#define REG_BK13D7_20_H      0x13D741
#define REG_BK13D7_21_L      0x13D742
#define REG_BK13D7_21_H      0x13D743
#define REG_BK13D7_22_L      0x13D744
#define REG_BK13D7_22_H      0x13D745
#define REG_BK13D7_23_L      0x13D746
#define REG_BK13D7_23_H      0x13D747
#define REG_BK13D7_24_L      0x13D748
#define REG_BK13D7_24_H      0x13D749
#define REG_BK13D7_25_L      0x13D74A
#define REG_BK13D7_25_H      0x13D74B
#define REG_BK13D7_26_L      0x13D74C
#define REG_BK13D7_26_H      0x13D74D
#define REG_BK13D7_27_L      0x13D74E
#define REG_BK13D7_27_H      0x13D74F
#define REG_BK13D7_28_L      0x13D750
#define REG_BK13D7_28_H      0x13D751
#define REG_BK13D7_29_L      0x13D752
#define REG_BK13D7_29_H      0x13D753
#define REG_BK13D7_2A_L      0x13D754
#define REG_BK13D7_2A_H      0x13D755
#define REG_BK13D7_2B_L      0x13D756
#define REG_BK13D7_2B_H      0x13D757
#define REG_BK13D7_2C_L      0x13D758
#define REG_BK13D7_2C_H      0x13D759
#define REG_BK13D7_2D_L      0x13D75A
#define REG_BK13D7_2D_H      0x13D75B
#define REG_BK13D7_2E_L      0x13D75C
#define REG_BK13D7_2E_H      0x13D75D
#define REG_BK13D7_2F_L      0x13D75E
#define REG_BK13D7_2F_H      0x13D75F
#define REG_BK13D7_30_L      0x13D760
#define REG_BK13D7_30_H      0x13D761
#define REG_BK13D7_31_L      0x13D762
#define REG_BK13D7_31_H      0x13D763
#define REG_BK13D7_32_L      0x13D764
#define REG_BK13D7_32_H      0x13D765
#define REG_BK13D7_33_L      0x13D766
#define REG_BK13D7_33_H      0x13D767
#define REG_BK13D7_34_L      0x13D768
#define REG_BK13D7_34_H      0x13D769
#define REG_BK13D7_35_L      0x13D76A
#define REG_BK13D7_35_H      0x13D76B
#define REG_BK13D7_36_L      0x13D76C
#define REG_BK13D7_36_H      0x13D76D
#define REG_BK13D7_37_L      0x13D76E
#define REG_BK13D7_37_H      0x13D76F
#define REG_BK13D7_38_L      0x13D770
#define REG_BK13D7_38_H      0x13D771
#define REG_BK13D7_39_L      0x13D772
#define REG_BK13D7_39_H      0x13D773
#define REG_BK13D7_3A_L      0x13D774
#define REG_BK13D7_3A_H      0x13D775
#define REG_BK13D7_3B_L      0x13D776
#define REG_BK13D7_3B_H      0x13D777
#define REG_BK13D7_3C_L      0x13D778
#define REG_BK13D7_3C_H      0x13D779
#define REG_BK13D7_3D_L      0x13D77A
#define REG_BK13D7_3D_H      0x13D77B
#define REG_BK13D7_3E_L      0x13D77C
#define REG_BK13D7_3E_H      0x13D77D
#define REG_BK13D7_3F_L      0x13D77E
#define REG_BK13D7_3F_H      0x13D77F
#define REG_BK13D7_40_L      0x13D780
#define REG_BK13D7_40_H      0x13D781
#define REG_BK13D7_41_L      0x13D782
#define REG_BK13D7_41_H      0x13D783
#define REG_BK13D7_42_L      0x13D784
#define REG_BK13D7_42_H      0x13D785
#define REG_BK13D7_43_L      0x13D786
#define REG_BK13D7_43_H      0x13D787
#define REG_BK13D7_44_L      0x13D788
#define REG_BK13D7_44_H      0x13D789
#define REG_BK13D7_45_L      0x13D78A
#define REG_BK13D7_45_H      0x13D78B
#define REG_BK13D7_46_L      0x13D78C
#define REG_BK13D7_46_H      0x13D78D
#define REG_BK13D7_47_L      0x13D78E
#define REG_BK13D7_47_H      0x13D78F
#define REG_BK13D7_48_L      0x13D790
#define REG_BK13D7_48_H      0x13D791
#define REG_BK13D7_49_L      0x13D792
#define REG_BK13D7_49_H      0x13D793
#define REG_BK13D7_4A_L      0x13D794
#define REG_BK13D7_4A_H      0x13D795
#define REG_BK13D7_4B_L      0x13D796
#define REG_BK13D7_4B_H      0x13D797
#define REG_BK13D7_4C_L      0x13D798
#define REG_BK13D7_4C_H      0x13D799
#define REG_BK13D7_4D_L      0x13D79A
#define REG_BK13D7_4D_H      0x13D79B
#define REG_BK13D7_4E_L      0x13D79C
#define REG_BK13D7_4E_H      0x13D79D
#define REG_BK13D7_4F_L      0x13D79E
#define REG_BK13D7_4F_H      0x13D79F
#define REG_BK13D7_50_L      0x13D7A0
#define REG_BK13D7_50_H      0x13D7A1
#define REG_BK13D7_51_L      0x13D7A2
#define REG_BK13D7_51_H      0x13D7A3
#define REG_BK13D7_52_L      0x13D7A4
#define REG_BK13D7_52_H      0x13D7A5
#define REG_BK13D7_53_L      0x13D7A6
#define REG_BK13D7_53_H      0x13D7A7
#define REG_BK13D7_54_L      0x13D7A8
#define REG_BK13D7_54_H      0x13D7A9
#define REG_BK13D7_55_L      0x13D7AA
#define REG_BK13D7_55_H      0x13D7AB
#define REG_BK13D7_56_L      0x13D7AC
#define REG_BK13D7_56_H      0x13D7AD
#define REG_BK13D7_57_L      0x13D7AE
#define REG_BK13D7_57_H      0x13D7AF
#define REG_BK13D7_58_L      0x13D7B0
#define REG_BK13D7_58_H      0x13D7B1
#define REG_BK13D7_59_L      0x13D7B2
#define REG_BK13D7_59_H      0x13D7B3
#define REG_BK13D7_5A_L      0x13D7B4
#define REG_BK13D7_5A_H      0x13D7B5
#define REG_BK13D7_5B_L      0x13D7B6
#define REG_BK13D7_5B_H      0x13D7B7
#define REG_BK13D7_5C_L      0x13D7B8
#define REG_BK13D7_5C_H      0x13D7B9
#define REG_BK13D7_5D_L      0x13D7BA
#define REG_BK13D7_5D_H      0x13D7BB
#define REG_BK13D7_5E_L      0x13D7BC
#define REG_BK13D7_5E_H      0x13D7BD
#define REG_BK13D7_5F_L      0x13D7BE
#define REG_BK13D7_5F_H      0x13D7BF
#define REG_BK13D7_60_L      0x13D7C0
#define REG_BK13D7_60_H      0x13D7C1
#define REG_BK13D7_61_L      0x13D7C2
#define REG_BK13D7_61_H      0x13D7C3
#define REG_BK13D7_62_L      0x13D7C4
#define REG_BK13D7_62_H      0x13D7C5
#define REG_BK13D7_63_L      0x13D7C6
#define REG_BK13D7_63_H      0x13D7C7
#define REG_BK13D7_64_L      0x13D7C8
#define REG_BK13D7_64_H      0x13D7C9
#define REG_BK13D7_65_L      0x13D7CA
#define REG_BK13D7_65_H      0x13D7CB
#define REG_BK13D7_66_L      0x13D7CC
#define REG_BK13D7_66_H      0x13D7CD
#define REG_BK13D7_67_L      0x13D7CE
#define REG_BK13D7_67_H      0x13D7CF
#define REG_BK13D7_68_L      0x13D7D0
#define REG_BK13D7_68_H      0x13D7D1
#define REG_BK13D7_69_L      0x13D7D2
#define REG_BK13D7_69_H      0x13D7D3
#define REG_BK13D7_6A_L      0x13D7D4
#define REG_BK13D7_6A_H      0x13D7D5
#define REG_BK13D7_6B_L      0x13D7D6
#define REG_BK13D7_6B_H      0x13D7D7
#define REG_BK13D7_6C_L      0x13D7D8
#define REG_BK13D7_6C_H      0x13D7D9
#define REG_BK13D7_6D_L      0x13D7DA
#define REG_BK13D7_6D_H      0x13D7DB
#define REG_BK13D7_6E_L      0x13D7DC
#define REG_BK13D7_6E_H      0x13D7DD
#define REG_BK13D7_6F_L      0x13D7DE
#define REG_BK13D7_6F_H      0x13D7DF
#define REG_BK13D7_70_L      0x13D7E0
#define REG_BK13D7_70_H      0x13D7E1
#define REG_BK13D7_71_L      0x13D7E2
#define REG_BK13D7_71_H      0x13D7E3
#define REG_BK13D7_72_L      0x13D7E4
#define REG_BK13D7_72_H      0x13D7E5
#define REG_BK13D7_73_L      0x13D7E6
#define REG_BK13D7_73_H      0x13D7E7
#define REG_BK13D7_74_L      0x13D7E8
#define REG_BK13D7_74_H      0x13D7E9
#define REG_BK13D7_75_L      0x13D7EA
#define REG_BK13D7_75_H      0x13D7EB
#define REG_BK13D7_76_L      0x13D7EC
#define REG_BK13D7_76_H      0x13D7ED
#define REG_BK13D7_77_L      0x13D7EE
#define REG_BK13D7_77_H      0x13D7EF
#define REG_BK13D7_78_L      0x13D7F0
#define REG_BK13D7_78_H      0x13D7F1
#define REG_BK13D7_79_L      0x13D7F2
#define REG_BK13D7_79_H      0x13D7F3
#define REG_BK13D7_7A_L      0x13D7F4
#define REG_BK13D7_7A_H      0x13D7F5
#define REG_BK13D7_7B_L      0x13D7F6
#define REG_BK13D7_7B_H      0x13D7F7
#define REG_BK13D7_7C_L      0x13D7F8
#define REG_BK13D7_7C_H      0x13D7F9
#define REG_BK13D7_7D_L      0x13D7FA
#define REG_BK13D7_7D_H      0x13D7FB
#define REG_BK13D7_7E_L      0x13D7FC
#define REG_BK13D7_7E_H      0x13D7FD
#define REG_BK13D7_7F_L      0x13D7FE
#define REG_BK13D7_7F_H      0x13D7FF
//----------------------------------------------
#define REG_BK13D8_00_L      0x13D800
#define REG_BK13D8_00_H      0x13D801
#define REG_BK13D8_01_L      0x13D802
#define REG_BK13D8_01_H      0x13D803
#define REG_BK13D8_02_L      0x13D804
#define REG_BK13D8_02_H      0x13D805
#define REG_BK13D8_03_L      0x13D806
#define REG_BK13D8_03_H      0x13D807
#define REG_BK13D8_04_L      0x13D808
#define REG_BK13D8_04_H      0x13D809
#define REG_BK13D8_05_L      0x13D80A
#define REG_BK13D8_05_H      0x13D80B
#define REG_BK13D8_06_L      0x13D80C
#define REG_BK13D8_06_H      0x13D80D
#define REG_BK13D8_07_L      0x13D80E
#define REG_BK13D8_07_H      0x13D80F
#define REG_BK13D8_08_L      0x13D810
#define REG_BK13D8_08_H      0x13D811
#define REG_BK13D8_09_L      0x13D812
#define REG_BK13D8_09_H      0x13D813
#define REG_BK13D8_0A_L      0x13D814
#define REG_BK13D8_0A_H      0x13D815
#define REG_BK13D8_0B_L      0x13D816
#define REG_BK13D8_0B_H      0x13D817
#define REG_BK13D8_0C_L      0x13D818
#define REG_BK13D8_0C_H      0x13D819
#define REG_BK13D8_0D_L      0x13D81A
#define REG_BK13D8_0D_H      0x13D81B
#define REG_BK13D8_0E_L      0x13D81C
#define REG_BK13D8_0E_H      0x13D81D
#define REG_BK13D8_0F_L      0x13D81E
#define REG_BK13D8_0F_H      0x13D81F
#define REG_BK13D8_10_L      0x13D820
#define REG_BK13D8_10_H      0x13D821
#define REG_BK13D8_11_L      0x13D822
#define REG_BK13D8_11_H      0x13D823
#define REG_BK13D8_12_L      0x13D824
#define REG_BK13D8_12_H      0x13D825
#define REG_BK13D8_13_L      0x13D826
#define REG_BK13D8_13_H      0x13D827
#define REG_BK13D8_14_L      0x13D828
#define REG_BK13D8_14_H      0x13D829
#define REG_BK13D8_15_L      0x13D82A
#define REG_BK13D8_15_H      0x13D82B
#define REG_BK13D8_16_L      0x13D82C
#define REG_BK13D8_16_H      0x13D82D
#define REG_BK13D8_17_L      0x13D82E
#define REG_BK13D8_17_H      0x13D82F
#define REG_BK13D8_18_L      0x13D830
#define REG_BK13D8_18_H      0x13D831
#define REG_BK13D8_19_L      0x13D832
#define REG_BK13D8_19_H      0x13D833
#define REG_BK13D8_1A_L      0x13D834
#define REG_BK13D8_1A_H      0x13D835
#define REG_BK13D8_1B_L      0x13D836
#define REG_BK13D8_1B_H      0x13D837
#define REG_BK13D8_1C_L      0x13D838
#define REG_BK13D8_1C_H      0x13D839
#define REG_BK13D8_1D_L      0x13D83A
#define REG_BK13D8_1D_H      0x13D83B
#define REG_BK13D8_1E_L      0x13D83C
#define REG_BK13D8_1E_H      0x13D83D
#define REG_BK13D8_1F_L      0x13D83E
#define REG_BK13D8_1F_H      0x13D83F
#define REG_BK13D8_20_L      0x13D840
#define REG_BK13D8_20_H      0x13D841
#define REG_BK13D8_21_L      0x13D842
#define REG_BK13D8_21_H      0x13D843
#define REG_BK13D8_22_L      0x13D844
#define REG_BK13D8_22_H      0x13D845
#define REG_BK13D8_23_L      0x13D846
#define REG_BK13D8_23_H      0x13D847
#define REG_BK13D8_24_L      0x13D848
#define REG_BK13D8_24_H      0x13D849
#define REG_BK13D8_25_L      0x13D84A
#define REG_BK13D8_25_H      0x13D84B
#define REG_BK13D8_26_L      0x13D84C
#define REG_BK13D8_26_H      0x13D84D
#define REG_BK13D8_27_L      0x13D84E
#define REG_BK13D8_27_H      0x13D84F
#define REG_BK13D8_28_L      0x13D850
#define REG_BK13D8_28_H      0x13D851
#define REG_BK13D8_29_L      0x13D852
#define REG_BK13D8_29_H      0x13D853
#define REG_BK13D8_2A_L      0x13D854
#define REG_BK13D8_2A_H      0x13D855
#define REG_BK13D8_2B_L      0x13D856
#define REG_BK13D8_2B_H      0x13D857
#define REG_BK13D8_2C_L      0x13D858
#define REG_BK13D8_2C_H      0x13D859
#define REG_BK13D8_2D_L      0x13D85A
#define REG_BK13D8_2D_H      0x13D85B
#define REG_BK13D8_2E_L      0x13D85C
#define REG_BK13D8_2E_H      0x13D85D
#define REG_BK13D8_2F_L      0x13D85E
#define REG_BK13D8_2F_H      0x13D85F
#define REG_BK13D8_30_L      0x13D860
#define REG_BK13D8_30_H      0x13D861
#define REG_BK13D8_31_L      0x13D862
#define REG_BK13D8_31_H      0x13D863
#define REG_BK13D8_32_L      0x13D864
#define REG_BK13D8_32_H      0x13D865
#define REG_BK13D8_33_L      0x13D866
#define REG_BK13D8_33_H      0x13D867
#define REG_BK13D8_34_L      0x13D868
#define REG_BK13D8_34_H      0x13D869
#define REG_BK13D8_35_L      0x13D86A
#define REG_BK13D8_35_H      0x13D86B
#define REG_BK13D8_36_L      0x13D86C
#define REG_BK13D8_36_H      0x13D86D
#define REG_BK13D8_37_L      0x13D86E
#define REG_BK13D8_37_H      0x13D86F
#define REG_BK13D8_38_L      0x13D870
#define REG_BK13D8_38_H      0x13D871
#define REG_BK13D8_39_L      0x13D872
#define REG_BK13D8_39_H      0x13D873
#define REG_BK13D8_3A_L      0x13D874
#define REG_BK13D8_3A_H      0x13D875
#define REG_BK13D8_3B_L      0x13D876
#define REG_BK13D8_3B_H      0x13D877
#define REG_BK13D8_3C_L      0x13D878
#define REG_BK13D8_3C_H      0x13D879
#define REG_BK13D8_3D_L      0x13D87A
#define REG_BK13D8_3D_H      0x13D87B
#define REG_BK13D8_3E_L      0x13D87C
#define REG_BK13D8_3E_H      0x13D87D
#define REG_BK13D8_3F_L      0x13D87E
#define REG_BK13D8_3F_H      0x13D87F
#define REG_BK13D8_40_L      0x13D880
#define REG_BK13D8_40_H      0x13D881
#define REG_BK13D8_41_L      0x13D882
#define REG_BK13D8_41_H      0x13D883
#define REG_BK13D8_42_L      0x13D884
#define REG_BK13D8_42_H      0x13D885
#define REG_BK13D8_43_L      0x13D886
#define REG_BK13D8_43_H      0x13D887
#define REG_BK13D8_44_L      0x13D888
#define REG_BK13D8_44_H      0x13D889
#define REG_BK13D8_45_L      0x13D88A
#define REG_BK13D8_45_H      0x13D88B
#define REG_BK13D8_46_L      0x13D88C
#define REG_BK13D8_46_H      0x13D88D
#define REG_BK13D8_47_L      0x13D88E
#define REG_BK13D8_47_H      0x13D88F
#define REG_BK13D8_48_L      0x13D890
#define REG_BK13D8_48_H      0x13D891
#define REG_BK13D8_49_L      0x13D892
#define REG_BK13D8_49_H      0x13D893
#define REG_BK13D8_4A_L      0x13D894
#define REG_BK13D8_4A_H      0x13D895
#define REG_BK13D8_4B_L      0x13D896
#define REG_BK13D8_4B_H      0x13D897
#define REG_BK13D8_4C_L      0x13D898
#define REG_BK13D8_4C_H      0x13D899
#define REG_BK13D8_4D_L      0x13D89A
#define REG_BK13D8_4D_H      0x13D89B
#define REG_BK13D8_4E_L      0x13D89C
#define REG_BK13D8_4E_H      0x13D89D
#define REG_BK13D8_4F_L      0x13D89E
#define REG_BK13D8_4F_H      0x13D89F
#define REG_BK13D8_50_L      0x13D8A0
#define REG_BK13D8_50_H      0x13D8A1
#define REG_BK13D8_51_L      0x13D8A2
#define REG_BK13D8_51_H      0x13D8A3
#define REG_BK13D8_52_L      0x13D8A4
#define REG_BK13D8_52_H      0x13D8A5
#define REG_BK13D8_53_L      0x13D8A6
#define REG_BK13D8_53_H      0x13D8A7
#define REG_BK13D8_54_L      0x13D8A8
#define REG_BK13D8_54_H      0x13D8A9
#define REG_BK13D8_55_L      0x13D8AA
#define REG_BK13D8_55_H      0x13D8AB
#define REG_BK13D8_56_L      0x13D8AC
#define REG_BK13D8_56_H      0x13D8AD
#define REG_BK13D8_57_L      0x13D8AE
#define REG_BK13D8_57_H      0x13D8AF
#define REG_BK13D8_58_L      0x13D8B0
#define REG_BK13D8_58_H      0x13D8B1
#define REG_BK13D8_59_L      0x13D8B2
#define REG_BK13D8_59_H      0x13D8B3
#define REG_BK13D8_5A_L      0x13D8B4
#define REG_BK13D8_5A_H      0x13D8B5
#define REG_BK13D8_5B_L      0x13D8B6
#define REG_BK13D8_5B_H      0x13D8B7
#define REG_BK13D8_5C_L      0x13D8B8
#define REG_BK13D8_5C_H      0x13D8B9
#define REG_BK13D8_5D_L      0x13D8BA
#define REG_BK13D8_5D_H      0x13D8BB
#define REG_BK13D8_5E_L      0x13D8BC
#define REG_BK13D8_5E_H      0x13D8BD
#define REG_BK13D8_5F_L      0x13D8BE
#define REG_BK13D8_5F_H      0x13D8BF
#define REG_BK13D8_60_L      0x13D8C0
#define REG_BK13D8_60_H      0x13D8C1
#define REG_BK13D8_61_L      0x13D8C2
#define REG_BK13D8_61_H      0x13D8C3
#define REG_BK13D8_62_L      0x13D8C4
#define REG_BK13D8_62_H      0x13D8C5
#define REG_BK13D8_63_L      0x13D8C6
#define REG_BK13D8_63_H      0x13D8C7
#define REG_BK13D8_64_L      0x13D8C8
#define REG_BK13D8_64_H      0x13D8C9
#define REG_BK13D8_65_L      0x13D8CA
#define REG_BK13D8_65_H      0x13D8CB
#define REG_BK13D8_66_L      0x13D8CC
#define REG_BK13D8_66_H      0x13D8CD
#define REG_BK13D8_67_L      0x13D8CE
#define REG_BK13D8_67_H      0x13D8CF
#define REG_BK13D8_68_L      0x13D8D0
#define REG_BK13D8_68_H      0x13D8D1
#define REG_BK13D8_69_L      0x13D8D2
#define REG_BK13D8_69_H      0x13D8D3
#define REG_BK13D8_6A_L      0x13D8D4
#define REG_BK13D8_6A_H      0x13D8D5
#define REG_BK13D8_6B_L      0x13D8D6
#define REG_BK13D8_6B_H      0x13D8D7
#define REG_BK13D8_6C_L      0x13D8D8
#define REG_BK13D8_6C_H      0x13D8D9
#define REG_BK13D8_6D_L      0x13D8DA
#define REG_BK13D8_6D_H      0x13D8DB
#define REG_BK13D8_6E_L      0x13D8DC
#define REG_BK13D8_6E_H      0x13D8DD
#define REG_BK13D8_6F_L      0x13D8DE
#define REG_BK13D8_6F_H      0x13D8DF
#define REG_BK13D8_70_L      0x13D8E0
#define REG_BK13D8_70_H      0x13D8E1
#define REG_BK13D8_71_L      0x13D8E2
#define REG_BK13D8_71_H      0x13D8E3
#define REG_BK13D8_72_L      0x13D8E4
#define REG_BK13D8_72_H      0x13D8E5
#define REG_BK13D8_73_L      0x13D8E6
#define REG_BK13D8_73_H      0x13D8E7
#define REG_BK13D8_74_L      0x13D8E8
#define REG_BK13D8_74_H      0x13D8E9
#define REG_BK13D8_75_L      0x13D8EA
#define REG_BK13D8_75_H      0x13D8EB
#define REG_BK13D8_76_L      0x13D8EC
#define REG_BK13D8_76_H      0x13D8ED
#define REG_BK13D8_77_L      0x13D8EE
#define REG_BK13D8_77_H      0x13D8EF
#define REG_BK13D8_78_L      0x13D8F0
#define REG_BK13D8_78_H      0x13D8F1
#define REG_BK13D8_79_L      0x13D8F2
#define REG_BK13D8_79_H      0x13D8F3
#define REG_BK13D8_7A_L      0x13D8F4
#define REG_BK13D8_7A_H      0x13D8F5
#define REG_BK13D8_7B_L      0x13D8F6
#define REG_BK13D8_7B_H      0x13D8F7
#define REG_BK13D8_7C_L      0x13D8F8
#define REG_BK13D8_7C_H      0x13D8F9
#define REG_BK13D8_7D_L      0x13D8FA
#define REG_BK13D8_7D_H      0x13D8FB
#define REG_BK13D8_7E_L      0x13D8FC
#define REG_BK13D8_7E_H      0x13D8FD
#define REG_BK13D8_7F_L      0x13D8FE
#define REG_BK13D8_7F_H      0x13D8FF
//----------------------------------------------
#define REG_BK13D9_00_L      0x13D900
#define REG_BK13D9_00_H      0x13D901
#define REG_BK13D9_01_L      0x13D902
#define REG_BK13D9_01_H      0x13D903
#define REG_BK13D9_02_L      0x13D904
#define REG_BK13D9_02_H      0x13D905
#define REG_BK13D9_03_L      0x13D906
#define REG_BK13D9_03_H      0x13D907
#define REG_BK13D9_04_L      0x13D908
#define REG_BK13D9_04_H      0x13D909
#define REG_BK13D9_05_L      0x13D90A
#define REG_BK13D9_05_H      0x13D90B
#define REG_BK13D9_06_L      0x13D90C
#define REG_BK13D9_06_H      0x13D90D
#define REG_BK13D9_07_L      0x13D90E
#define REG_BK13D9_07_H      0x13D90F
#define REG_BK13D9_08_L      0x13D910
#define REG_BK13D9_08_H      0x13D911
#define REG_BK13D9_09_L      0x13D912
#define REG_BK13D9_09_H      0x13D913
#define REG_BK13D9_0A_L      0x13D914
#define REG_BK13D9_0A_H      0x13D915
#define REG_BK13D9_0B_L      0x13D916
#define REG_BK13D9_0B_H      0x13D917
#define REG_BK13D9_0C_L      0x13D918
#define REG_BK13D9_0C_H      0x13D919
#define REG_BK13D9_0D_L      0x13D91A
#define REG_BK13D9_0D_H      0x13D91B
#define REG_BK13D9_0E_L      0x13D91C
#define REG_BK13D9_0E_H      0x13D91D
#define REG_BK13D9_0F_L      0x13D91E
#define REG_BK13D9_0F_H      0x13D91F
#define REG_BK13D9_10_L      0x13D920
#define REG_BK13D9_10_H      0x13D921
#define REG_BK13D9_11_L      0x13D922
#define REG_BK13D9_11_H      0x13D923
#define REG_BK13D9_12_L      0x13D924
#define REG_BK13D9_12_H      0x13D925
#define REG_BK13D9_13_L      0x13D926
#define REG_BK13D9_13_H      0x13D927
#define REG_BK13D9_14_L      0x13D928
#define REG_BK13D9_14_H      0x13D929
#define REG_BK13D9_15_L      0x13D92A
#define REG_BK13D9_15_H      0x13D92B
#define REG_BK13D9_16_L      0x13D92C
#define REG_BK13D9_16_H      0x13D92D
#define REG_BK13D9_17_L      0x13D92E
#define REG_BK13D9_17_H      0x13D92F
#define REG_BK13D9_18_L      0x13D930
#define REG_BK13D9_18_H      0x13D931
#define REG_BK13D9_19_L      0x13D932
#define REG_BK13D9_19_H      0x13D933
#define REG_BK13D9_1A_L      0x13D934
#define REG_BK13D9_1A_H      0x13D935
#define REG_BK13D9_1B_L      0x13D936
#define REG_BK13D9_1B_H      0x13D937
#define REG_BK13D9_1C_L      0x13D938
#define REG_BK13D9_1C_H      0x13D939
#define REG_BK13D9_1D_L      0x13D93A
#define REG_BK13D9_1D_H      0x13D93B
#define REG_BK13D9_1E_L      0x13D93C
#define REG_BK13D9_1E_H      0x13D93D
#define REG_BK13D9_1F_L      0x13D93E
#define REG_BK13D9_1F_H      0x13D93F
#define REG_BK13D9_20_L      0x13D940
#define REG_BK13D9_20_H      0x13D941
#define REG_BK13D9_21_L      0x13D942
#define REG_BK13D9_21_H      0x13D943
#define REG_BK13D9_22_L      0x13D944
#define REG_BK13D9_22_H      0x13D945
#define REG_BK13D9_23_L      0x13D946
#define REG_BK13D9_23_H      0x13D947
#define REG_BK13D9_24_L      0x13D948
#define REG_BK13D9_24_H      0x13D949
#define REG_BK13D9_25_L      0x13D94A
#define REG_BK13D9_25_H      0x13D94B
#define REG_BK13D9_26_L      0x13D94C
#define REG_BK13D9_26_H      0x13D94D
#define REG_BK13D9_27_L      0x13D94E
#define REG_BK13D9_27_H      0x13D94F
#define REG_BK13D9_28_L      0x13D950
#define REG_BK13D9_28_H      0x13D951
#define REG_BK13D9_29_L      0x13D952
#define REG_BK13D9_29_H      0x13D953
#define REG_BK13D9_2A_L      0x13D954
#define REG_BK13D9_2A_H      0x13D955
#define REG_BK13D9_2B_L      0x13D956
#define REG_BK13D9_2B_H      0x13D957
#define REG_BK13D9_2C_L      0x13D958
#define REG_BK13D9_2C_H      0x13D959
#define REG_BK13D9_2D_L      0x13D95A
#define REG_BK13D9_2D_H      0x13D95B
#define REG_BK13D9_2E_L      0x13D95C
#define REG_BK13D9_2E_H      0x13D95D
#define REG_BK13D9_2F_L      0x13D95E
#define REG_BK13D9_2F_H      0x13D95F
#define REG_BK13D9_30_L      0x13D960
#define REG_BK13D9_30_H      0x13D961
#define REG_BK13D9_31_L      0x13D962
#define REG_BK13D9_31_H      0x13D963
#define REG_BK13D9_32_L      0x13D964
#define REG_BK13D9_32_H      0x13D965
#define REG_BK13D9_33_L      0x13D966
#define REG_BK13D9_33_H      0x13D967
#define REG_BK13D9_34_L      0x13D968
#define REG_BK13D9_34_H      0x13D969
#define REG_BK13D9_35_L      0x13D96A
#define REG_BK13D9_35_H      0x13D96B
#define REG_BK13D9_36_L      0x13D96C
#define REG_BK13D9_36_H      0x13D96D
#define REG_BK13D9_37_L      0x13D96E
#define REG_BK13D9_37_H      0x13D96F
#define REG_BK13D9_38_L      0x13D970
#define REG_BK13D9_38_H      0x13D971
#define REG_BK13D9_39_L      0x13D972
#define REG_BK13D9_39_H      0x13D973
#define REG_BK13D9_3A_L      0x13D974
#define REG_BK13D9_3A_H      0x13D975
#define REG_BK13D9_3B_L      0x13D976
#define REG_BK13D9_3B_H      0x13D977
#define REG_BK13D9_3C_L      0x13D978
#define REG_BK13D9_3C_H      0x13D979
#define REG_BK13D9_3D_L      0x13D97A
#define REG_BK13D9_3D_H      0x13D97B
#define REG_BK13D9_3E_L      0x13D97C
#define REG_BK13D9_3E_H      0x13D97D
#define REG_BK13D9_3F_L      0x13D97E
#define REG_BK13D9_3F_H      0x13D97F
#define REG_BK13D9_40_L      0x13D980
#define REG_BK13D9_40_H      0x13D981
#define REG_BK13D9_41_L      0x13D982
#define REG_BK13D9_41_H      0x13D983
#define REG_BK13D9_42_L      0x13D984
#define REG_BK13D9_42_H      0x13D985
#define REG_BK13D9_43_L      0x13D986
#define REG_BK13D9_43_H      0x13D987
#define REG_BK13D9_44_L      0x13D988
#define REG_BK13D9_44_H      0x13D989
#define REG_BK13D9_45_L      0x13D98A
#define REG_BK13D9_45_H      0x13D98B
#define REG_BK13D9_46_L      0x13D98C
#define REG_BK13D9_46_H      0x13D98D
#define REG_BK13D9_47_L      0x13D98E
#define REG_BK13D9_47_H      0x13D98F
#define REG_BK13D9_48_L      0x13D990
#define REG_BK13D9_48_H      0x13D991
#define REG_BK13D9_49_L      0x13D992
#define REG_BK13D9_49_H      0x13D993
#define REG_BK13D9_4A_L      0x13D994
#define REG_BK13D9_4A_H      0x13D995
#define REG_BK13D9_4B_L      0x13D996
#define REG_BK13D9_4B_H      0x13D997
#define REG_BK13D9_4C_L      0x13D998
#define REG_BK13D9_4C_H      0x13D999
#define REG_BK13D9_4D_L      0x13D99A
#define REG_BK13D9_4D_H      0x13D99B
#define REG_BK13D9_4E_L      0x13D99C
#define REG_BK13D9_4E_H      0x13D99D
#define REG_BK13D9_4F_L      0x13D99E
#define REG_BK13D9_4F_H      0x13D99F
#define REG_BK13D9_50_L      0x13D9A0
#define REG_BK13D9_50_H      0x13D9A1
#define REG_BK13D9_51_L      0x13D9A2
#define REG_BK13D9_51_H      0x13D9A3
#define REG_BK13D9_52_L      0x13D9A4
#define REG_BK13D9_52_H      0x13D9A5
#define REG_BK13D9_53_L      0x13D9A6
#define REG_BK13D9_53_H      0x13D9A7
#define REG_BK13D9_54_L      0x13D9A8
#define REG_BK13D9_54_H      0x13D9A9
#define REG_BK13D9_55_L      0x13D9AA
#define REG_BK13D9_55_H      0x13D9AB
#define REG_BK13D9_56_L      0x13D9AC
#define REG_BK13D9_56_H      0x13D9AD
#define REG_BK13D9_57_L      0x13D9AE
#define REG_BK13D9_57_H      0x13D9AF
#define REG_BK13D9_58_L      0x13D9B0
#define REG_BK13D9_58_H      0x13D9B1
#define REG_BK13D9_59_L      0x13D9B2
#define REG_BK13D9_59_H      0x13D9B3
#define REG_BK13D9_5A_L      0x13D9B4
#define REG_BK13D9_5A_H      0x13D9B5
#define REG_BK13D9_5B_L      0x13D9B6
#define REG_BK13D9_5B_H      0x13D9B7
#define REG_BK13D9_5C_L      0x13D9B8
#define REG_BK13D9_5C_H      0x13D9B9
#define REG_BK13D9_5D_L      0x13D9BA
#define REG_BK13D9_5D_H      0x13D9BB
#define REG_BK13D9_5E_L      0x13D9BC
#define REG_BK13D9_5E_H      0x13D9BD
#define REG_BK13D9_5F_L      0x13D9BE
#define REG_BK13D9_5F_H      0x13D9BF
#define REG_BK13D9_60_L      0x13D9C0
#define REG_BK13D9_60_H      0x13D9C1
#define REG_BK13D9_61_L      0x13D9C2
#define REG_BK13D9_61_H      0x13D9C3
#define REG_BK13D9_62_L      0x13D9C4
#define REG_BK13D9_62_H      0x13D9C5
#define REG_BK13D9_63_L      0x13D9C6
#define REG_BK13D9_63_H      0x13D9C7
#define REG_BK13D9_64_L      0x13D9C8
#define REG_BK13D9_64_H      0x13D9C9
#define REG_BK13D9_65_L      0x13D9CA
#define REG_BK13D9_65_H      0x13D9CB
#define REG_BK13D9_66_L      0x13D9CC
#define REG_BK13D9_66_H      0x13D9CD
#define REG_BK13D9_67_L      0x13D9CE
#define REG_BK13D9_67_H      0x13D9CF
#define REG_BK13D9_68_L      0x13D9D0
#define REG_BK13D9_68_H      0x13D9D1
#define REG_BK13D9_69_L      0x13D9D2
#define REG_BK13D9_69_H      0x13D9D3
#define REG_BK13D9_6A_L      0x13D9D4
#define REG_BK13D9_6A_H      0x13D9D5
#define REG_BK13D9_6B_L      0x13D9D6
#define REG_BK13D9_6B_H      0x13D9D7
#define REG_BK13D9_6C_L      0x13D9D8
#define REG_BK13D9_6C_H      0x13D9D9
#define REG_BK13D9_6D_L      0x13D9DA
#define REG_BK13D9_6D_H      0x13D9DB
#define REG_BK13D9_6E_L      0x13D9DC
#define REG_BK13D9_6E_H      0x13D9DD
#define REG_BK13D9_6F_L      0x13D9DE
#define REG_BK13D9_6F_H      0x13D9DF
#define REG_BK13D9_70_L      0x13D9E0
#define REG_BK13D9_70_H      0x13D9E1
#define REG_BK13D9_71_L      0x13D9E2
#define REG_BK13D9_71_H      0x13D9E3
#define REG_BK13D9_72_L      0x13D9E4
#define REG_BK13D9_72_H      0x13D9E5
#define REG_BK13D9_73_L      0x13D9E6
#define REG_BK13D9_73_H      0x13D9E7
#define REG_BK13D9_74_L      0x13D9E8
#define REG_BK13D9_74_H      0x13D9E9
#define REG_BK13D9_75_L      0x13D9EA
#define REG_BK13D9_75_H      0x13D9EB
#define REG_BK13D9_76_L      0x13D9EC
#define REG_BK13D9_76_H      0x13D9ED
#define REG_BK13D9_77_L      0x13D9EE
#define REG_BK13D9_77_H      0x13D9EF
#define REG_BK13D9_78_L      0x13D9F0
#define REG_BK13D9_78_H      0x13D9F1
#define REG_BK13D9_79_L      0x13D9F2
#define REG_BK13D9_79_H      0x13D9F3
#define REG_BK13D9_7A_L      0x13D9F4
#define REG_BK13D9_7A_H      0x13D9F5
#define REG_BK13D9_7B_L      0x13D9F6
#define REG_BK13D9_7B_H      0x13D9F7
#define REG_BK13D9_7C_L      0x13D9F8
#define REG_BK13D9_7C_H      0x13D9F9
#define REG_BK13D9_7D_L      0x13D9FA
#define REG_BK13D9_7D_H      0x13D9FB
#define REG_BK13D9_7E_L      0x13D9FC
#define REG_BK13D9_7E_H      0x13D9FD
#define REG_BK13D9_7F_L      0x13D9FE
#define REG_BK13D9_7F_H      0x13D9FF
//----------------------------------------------
#define REG_BK13DA_00_L      0x13DA00
#define REG_BK13DA_00_H      0x13DA01
#define REG_BK13DA_01_L      0x13DA02
#define REG_BK13DA_01_H      0x13DA03
#define REG_BK13DA_02_L      0x13DA04
#define REG_BK13DA_02_H      0x13DA05
#define REG_BK13DA_03_L      0x13DA06
#define REG_BK13DA_03_H      0x13DA07
#define REG_BK13DA_04_L      0x13DA08
#define REG_BK13DA_04_H      0x13DA09
#define REG_BK13DA_05_L      0x13DA0A
#define REG_BK13DA_05_H      0x13DA0B
#define REG_BK13DA_06_L      0x13DA0C
#define REG_BK13DA_06_H      0x13DA0D
#define REG_BK13DA_07_L      0x13DA0E
#define REG_BK13DA_07_H      0x13DA0F
#define REG_BK13DA_08_L      0x13DA10
#define REG_BK13DA_08_H      0x13DA11
#define REG_BK13DA_09_L      0x13DA12
#define REG_BK13DA_09_H      0x13DA13
#define REG_BK13DA_0A_L      0x13DA14
#define REG_BK13DA_0A_H      0x13DA15
#define REG_BK13DA_0B_L      0x13DA16
#define REG_BK13DA_0B_H      0x13DA17
#define REG_BK13DA_0C_L      0x13DA18
#define REG_BK13DA_0C_H      0x13DA19
#define REG_BK13DA_0D_L      0x13DA1A
#define REG_BK13DA_0D_H      0x13DA1B
#define REG_BK13DA_0E_L      0x13DA1C
#define REG_BK13DA_0E_H      0x13DA1D
#define REG_BK13DA_0F_L      0x13DA1E
#define REG_BK13DA_0F_H      0x13DA1F
#define REG_BK13DA_10_L      0x13DA20
#define REG_BK13DA_10_H      0x13DA21
#define REG_BK13DA_11_L      0x13DA22
#define REG_BK13DA_11_H      0x13DA23
#define REG_BK13DA_12_L      0x13DA24
#define REG_BK13DA_12_H      0x13DA25
#define REG_BK13DA_13_L      0x13DA26
#define REG_BK13DA_13_H      0x13DA27
#define REG_BK13DA_14_L      0x13DA28
#define REG_BK13DA_14_H      0x13DA29
#define REG_BK13DA_15_L      0x13DA2A
#define REG_BK13DA_15_H      0x13DA2B
#define REG_BK13DA_16_L      0x13DA2C
#define REG_BK13DA_16_H      0x13DA2D
#define REG_BK13DA_17_L      0x13DA2E
#define REG_BK13DA_17_H      0x13DA2F
#define REG_BK13DA_18_L      0x13DA30
#define REG_BK13DA_18_H      0x13DA31
#define REG_BK13DA_19_L      0x13DA32
#define REG_BK13DA_19_H      0x13DA33
#define REG_BK13DA_1A_L      0x13DA34
#define REG_BK13DA_1A_H      0x13DA35
#define REG_BK13DA_1B_L      0x13DA36
#define REG_BK13DA_1B_H      0x13DA37
#define REG_BK13DA_1C_L      0x13DA38
#define REG_BK13DA_1C_H      0x13DA39
#define REG_BK13DA_1D_L      0x13DA3A
#define REG_BK13DA_1D_H      0x13DA3B
#define REG_BK13DA_1E_L      0x13DA3C
#define REG_BK13DA_1E_H      0x13DA3D
#define REG_BK13DA_1F_L      0x13DA3E
#define REG_BK13DA_1F_H      0x13DA3F
#define REG_BK13DA_20_L      0x13DA40
#define REG_BK13DA_20_H      0x13DA41
#define REG_BK13DA_21_L      0x13DA42
#define REG_BK13DA_21_H      0x13DA43
#define REG_BK13DA_22_L      0x13DA44
#define REG_BK13DA_22_H      0x13DA45
#define REG_BK13DA_23_L      0x13DA46
#define REG_BK13DA_23_H      0x13DA47
#define REG_BK13DA_24_L      0x13DA48
#define REG_BK13DA_24_H      0x13DA49
#define REG_BK13DA_25_L      0x13DA4A
#define REG_BK13DA_25_H      0x13DA4B
#define REG_BK13DA_26_L      0x13DA4C
#define REG_BK13DA_26_H      0x13DA4D
#define REG_BK13DA_27_L      0x13DA4E
#define REG_BK13DA_27_H      0x13DA4F
#define REG_BK13DA_28_L      0x13DA50
#define REG_BK13DA_28_H      0x13DA51
#define REG_BK13DA_29_L      0x13DA52
#define REG_BK13DA_29_H      0x13DA53
#define REG_BK13DA_2A_L      0x13DA54
#define REG_BK13DA_2A_H      0x13DA55
#define REG_BK13DA_2B_L      0x13DA56
#define REG_BK13DA_2B_H      0x13DA57
#define REG_BK13DA_2C_L      0x13DA58
#define REG_BK13DA_2C_H      0x13DA59
#define REG_BK13DA_2D_L      0x13DA5A
#define REG_BK13DA_2D_H      0x13DA5B
#define REG_BK13DA_2E_L      0x13DA5C
#define REG_BK13DA_2E_H      0x13DA5D
#define REG_BK13DA_2F_L      0x13DA5E
#define REG_BK13DA_2F_H      0x13DA5F
#define REG_BK13DA_30_L      0x13DA60
#define REG_BK13DA_30_H      0x13DA61
#define REG_BK13DA_31_L      0x13DA62
#define REG_BK13DA_31_H      0x13DA63
#define REG_BK13DA_32_L      0x13DA64
#define REG_BK13DA_32_H      0x13DA65
#define REG_BK13DA_33_L      0x13DA66
#define REG_BK13DA_33_H      0x13DA67
#define REG_BK13DA_34_L      0x13DA68
#define REG_BK13DA_34_H      0x13DA69
#define REG_BK13DA_35_L      0x13DA6A
#define REG_BK13DA_35_H      0x13DA6B
#define REG_BK13DA_36_L      0x13DA6C
#define REG_BK13DA_36_H      0x13DA6D
#define REG_BK13DA_37_L      0x13DA6E
#define REG_BK13DA_37_H      0x13DA6F
#define REG_BK13DA_38_L      0x13DA70
#define REG_BK13DA_38_H      0x13DA71
#define REG_BK13DA_39_L      0x13DA72
#define REG_BK13DA_39_H      0x13DA73
#define REG_BK13DA_3A_L      0x13DA74
#define REG_BK13DA_3A_H      0x13DA75
#define REG_BK13DA_3B_L      0x13DA76
#define REG_BK13DA_3B_H      0x13DA77
#define REG_BK13DA_3C_L      0x13DA78
#define REG_BK13DA_3C_H      0x13DA79
#define REG_BK13DA_3D_L      0x13DA7A
#define REG_BK13DA_3D_H      0x13DA7B
#define REG_BK13DA_3E_L      0x13DA7C
#define REG_BK13DA_3E_H      0x13DA7D
#define REG_BK13DA_3F_L      0x13DA7E
#define REG_BK13DA_3F_H      0x13DA7F
#define REG_BK13DA_40_L      0x13DA80
#define REG_BK13DA_40_H      0x13DA81
#define REG_BK13DA_41_L      0x13DA82
#define REG_BK13DA_41_H      0x13DA83
#define REG_BK13DA_42_L      0x13DA84
#define REG_BK13DA_42_H      0x13DA85
#define REG_BK13DA_43_L      0x13DA86
#define REG_BK13DA_43_H      0x13DA87
#define REG_BK13DA_44_L      0x13DA88
#define REG_BK13DA_44_H      0x13DA89
#define REG_BK13DA_45_L      0x13DA8A
#define REG_BK13DA_45_H      0x13DA8B
#define REG_BK13DA_46_L      0x13DA8C
#define REG_BK13DA_46_H      0x13DA8D
#define REG_BK13DA_47_L      0x13DA8E
#define REG_BK13DA_47_H      0x13DA8F
#define REG_BK13DA_48_L      0x13DA90
#define REG_BK13DA_48_H      0x13DA91
#define REG_BK13DA_49_L      0x13DA92
#define REG_BK13DA_49_H      0x13DA93
#define REG_BK13DA_4A_L      0x13DA94
#define REG_BK13DA_4A_H      0x13DA95
#define REG_BK13DA_4B_L      0x13DA96
#define REG_BK13DA_4B_H      0x13DA97
#define REG_BK13DA_4C_L      0x13DA98
#define REG_BK13DA_4C_H      0x13DA99
#define REG_BK13DA_4D_L      0x13DA9A
#define REG_BK13DA_4D_H      0x13DA9B
#define REG_BK13DA_4E_L      0x13DA9C
#define REG_BK13DA_4E_H      0x13DA9D
#define REG_BK13DA_4F_L      0x13DA9E
#define REG_BK13DA_4F_H      0x13DA9F
#define REG_BK13DA_50_L      0x13DAA0
#define REG_BK13DA_50_H      0x13DAA1
#define REG_BK13DA_51_L      0x13DAA2
#define REG_BK13DA_51_H      0x13DAA3
#define REG_BK13DA_52_L      0x13DAA4
#define REG_BK13DA_52_H      0x13DAA5
#define REG_BK13DA_53_L      0x13DAA6
#define REG_BK13DA_53_H      0x13DAA7
#define REG_BK13DA_54_L      0x13DAA8
#define REG_BK13DA_54_H      0x13DAA9
#define REG_BK13DA_55_L      0x13DAAA
#define REG_BK13DA_55_H      0x13DAAB
#define REG_BK13DA_56_L      0x13DAAC
#define REG_BK13DA_56_H      0x13DAAD
#define REG_BK13DA_57_L      0x13DAAE
#define REG_BK13DA_57_H      0x13DAAF
#define REG_BK13DA_58_L      0x13DAB0
#define REG_BK13DA_58_H      0x13DAB1
#define REG_BK13DA_59_L      0x13DAB2
#define REG_BK13DA_59_H      0x13DAB3
#define REG_BK13DA_5A_L      0x13DAB4
#define REG_BK13DA_5A_H      0x13DAB5
#define REG_BK13DA_5B_L      0x13DAB6
#define REG_BK13DA_5B_H      0x13DAB7
#define REG_BK13DA_5C_L      0x13DAB8
#define REG_BK13DA_5C_H      0x13DAB9
#define REG_BK13DA_5D_L      0x13DABA
#define REG_BK13DA_5D_H      0x13DABB
#define REG_BK13DA_5E_L      0x13DABC
#define REG_BK13DA_5E_H      0x13DABD
#define REG_BK13DA_5F_L      0x13DABE
#define REG_BK13DA_5F_H      0x13DABF
#define REG_BK13DA_60_L      0x13DAC0
#define REG_BK13DA_60_H      0x13DAC1
#define REG_BK13DA_61_L      0x13DAC2
#define REG_BK13DA_61_H      0x13DAC3
#define REG_BK13DA_62_L      0x13DAC4
#define REG_BK13DA_62_H      0x13DAC5
#define REG_BK13DA_63_L      0x13DAC6
#define REG_BK13DA_63_H      0x13DAC7
#define REG_BK13DA_64_L      0x13DAC8
#define REG_BK13DA_64_H      0x13DAC9
#define REG_BK13DA_65_L      0x13DACA
#define REG_BK13DA_65_H      0x13DACB
#define REG_BK13DA_66_L      0x13DACC
#define REG_BK13DA_66_H      0x13DACD
#define REG_BK13DA_67_L      0x13DACE
#define REG_BK13DA_67_H      0x13DACF
#define REG_BK13DA_68_L      0x13DAD0
#define REG_BK13DA_68_H      0x13DAD1
#define REG_BK13DA_69_L      0x13DAD2
#define REG_BK13DA_69_H      0x13DAD3
#define REG_BK13DA_6A_L      0x13DAD4
#define REG_BK13DA_6A_H      0x13DAD5
#define REG_BK13DA_6B_L      0x13DAD6
#define REG_BK13DA_6B_H      0x13DAD7
#define REG_BK13DA_6C_L      0x13DAD8
#define REG_BK13DA_6C_H      0x13DAD9
#define REG_BK13DA_6D_L      0x13DADA
#define REG_BK13DA_6D_H      0x13DADB
#define REG_BK13DA_6E_L      0x13DADC
#define REG_BK13DA_6E_H      0x13DADD
#define REG_BK13DA_6F_L      0x13DADE
#define REG_BK13DA_6F_H      0x13DADF
#define REG_BK13DA_70_L      0x13DAE0
#define REG_BK13DA_70_H      0x13DAE1
#define REG_BK13DA_71_L      0x13DAE2
#define REG_BK13DA_71_H      0x13DAE3
#define REG_BK13DA_72_L      0x13DAE4
#define REG_BK13DA_72_H      0x13DAE5
#define REG_BK13DA_73_L      0x13DAE6
#define REG_BK13DA_73_H      0x13DAE7
#define REG_BK13DA_74_L      0x13DAE8
#define REG_BK13DA_74_H      0x13DAE9
#define REG_BK13DA_75_L      0x13DAEA
#define REG_BK13DA_75_H      0x13DAEB
#define REG_BK13DA_76_L      0x13DAEC
#define REG_BK13DA_76_H      0x13DAED
#define REG_BK13DA_77_L      0x13DAEE
#define REG_BK13DA_77_H      0x13DAEF
#define REG_BK13DA_78_L      0x13DAF0
#define REG_BK13DA_78_H      0x13DAF1
#define REG_BK13DA_79_L      0x13DAF2
#define REG_BK13DA_79_H      0x13DAF3
#define REG_BK13DA_7A_L      0x13DAF4
#define REG_BK13DA_7A_H      0x13DAF5
#define REG_BK13DA_7B_L      0x13DAF6
#define REG_BK13DA_7B_H      0x13DAF7
#define REG_BK13DA_7C_L      0x13DAF8
#define REG_BK13DA_7C_H      0x13DAF9
#define REG_BK13DA_7D_L      0x13DAFA
#define REG_BK13DA_7D_H      0x13DAFB
#define REG_BK13DA_7E_L      0x13DAFC
#define REG_BK13DA_7E_H      0x13DAFD
#define REG_BK13DA_7F_L      0x13DAFE
#define REG_BK13DA_7F_H      0x13DAFF
//----------------------------------------------
#define REG_BK13DB_00_L      0x13DB00
#define REG_BK13DB_00_H      0x13DB01
#define REG_BK13DB_01_L      0x13DB02
#define REG_BK13DB_01_H      0x13DB03
#define REG_BK13DB_02_L      0x13DB04
#define REG_BK13DB_02_H      0x13DB05
#define REG_BK13DB_03_L      0x13DB06
#define REG_BK13DB_03_H      0x13DB07
#define REG_BK13DB_04_L      0x13DB08
#define REG_BK13DB_04_H      0x13DB09
#define REG_BK13DB_05_L      0x13DB0A
#define REG_BK13DB_05_H      0x13DB0B
#define REG_BK13DB_06_L      0x13DB0C
#define REG_BK13DB_06_H      0x13DB0D
#define REG_BK13DB_07_L      0x13DB0E
#define REG_BK13DB_07_H      0x13DB0F
#define REG_BK13DB_08_L      0x13DB10
#define REG_BK13DB_08_H      0x13DB11
#define REG_BK13DB_09_L      0x13DB12
#define REG_BK13DB_09_H      0x13DB13
#define REG_BK13DB_0A_L      0x13DB14
#define REG_BK13DB_0A_H      0x13DB15
#define REG_BK13DB_0B_L      0x13DB16
#define REG_BK13DB_0B_H      0x13DB17
#define REG_BK13DB_0C_L      0x13DB18
#define REG_BK13DB_0C_H      0x13DB19
#define REG_BK13DB_0D_L      0x13DB1A
#define REG_BK13DB_0D_H      0x13DB1B
#define REG_BK13DB_0E_L      0x13DB1C
#define REG_BK13DB_0E_H      0x13DB1D
#define REG_BK13DB_0F_L      0x13DB1E
#define REG_BK13DB_0F_H      0x13DB1F
#define REG_BK13DB_10_L      0x13DB20
#define REG_BK13DB_10_H      0x13DB21
#define REG_BK13DB_11_L      0x13DB22
#define REG_BK13DB_11_H      0x13DB23
#define REG_BK13DB_12_L      0x13DB24
#define REG_BK13DB_12_H      0x13DB25
#define REG_BK13DB_13_L      0x13DB26
#define REG_BK13DB_13_H      0x13DB27
#define REG_BK13DB_14_L      0x13DB28
#define REG_BK13DB_14_H      0x13DB29
#define REG_BK13DB_15_L      0x13DB2A
#define REG_BK13DB_15_H      0x13DB2B
#define REG_BK13DB_16_L      0x13DB2C
#define REG_BK13DB_16_H      0x13DB2D
#define REG_BK13DB_17_L      0x13DB2E
#define REG_BK13DB_17_H      0x13DB2F
#define REG_BK13DB_18_L      0x13DB30
#define REG_BK13DB_18_H      0x13DB31
#define REG_BK13DB_19_L      0x13DB32
#define REG_BK13DB_19_H      0x13DB33
#define REG_BK13DB_1A_L      0x13DB34
#define REG_BK13DB_1A_H      0x13DB35
#define REG_BK13DB_1B_L      0x13DB36
#define REG_BK13DB_1B_H      0x13DB37
#define REG_BK13DB_1C_L      0x13DB38
#define REG_BK13DB_1C_H      0x13DB39
#define REG_BK13DB_1D_L      0x13DB3A
#define REG_BK13DB_1D_H      0x13DB3B
#define REG_BK13DB_1E_L      0x13DB3C
#define REG_BK13DB_1E_H      0x13DB3D
#define REG_BK13DB_1F_L      0x13DB3E
#define REG_BK13DB_1F_H      0x13DB3F
#define REG_BK13DB_20_L      0x13DB40
#define REG_BK13DB_20_H      0x13DB41
#define REG_BK13DB_21_L      0x13DB42
#define REG_BK13DB_21_H      0x13DB43
#define REG_BK13DB_22_L      0x13DB44
#define REG_BK13DB_22_H      0x13DB45
#define REG_BK13DB_23_L      0x13DB46
#define REG_BK13DB_23_H      0x13DB47
#define REG_BK13DB_24_L      0x13DB48
#define REG_BK13DB_24_H      0x13DB49
#define REG_BK13DB_25_L      0x13DB4A
#define REG_BK13DB_25_H      0x13DB4B
#define REG_BK13DB_26_L      0x13DB4C
#define REG_BK13DB_26_H      0x13DB4D
#define REG_BK13DB_27_L      0x13DB4E
#define REG_BK13DB_27_H      0x13DB4F
#define REG_BK13DB_28_L      0x13DB50
#define REG_BK13DB_28_H      0x13DB51
#define REG_BK13DB_29_L      0x13DB52
#define REG_BK13DB_29_H      0x13DB53
#define REG_BK13DB_2A_L      0x13DB54
#define REG_BK13DB_2A_H      0x13DB55
#define REG_BK13DB_2B_L      0x13DB56
#define REG_BK13DB_2B_H      0x13DB57
#define REG_BK13DB_2C_L      0x13DB58
#define REG_BK13DB_2C_H      0x13DB59
#define REG_BK13DB_2D_L      0x13DB5A
#define REG_BK13DB_2D_H      0x13DB5B
#define REG_BK13DB_2E_L      0x13DB5C
#define REG_BK13DB_2E_H      0x13DB5D
#define REG_BK13DB_2F_L      0x13DB5E
#define REG_BK13DB_2F_H      0x13DB5F
#define REG_BK13DB_30_L      0x13DB60
#define REG_BK13DB_30_H      0x13DB61
#define REG_BK13DB_31_L      0x13DB62
#define REG_BK13DB_31_H      0x13DB63
#define REG_BK13DB_32_L      0x13DB64
#define REG_BK13DB_32_H      0x13DB65
#define REG_BK13DB_33_L      0x13DB66
#define REG_BK13DB_33_H      0x13DB67
#define REG_BK13DB_34_L      0x13DB68
#define REG_BK13DB_34_H      0x13DB69
#define REG_BK13DB_35_L      0x13DB6A
#define REG_BK13DB_35_H      0x13DB6B
#define REG_BK13DB_36_L      0x13DB6C
#define REG_BK13DB_36_H      0x13DB6D
#define REG_BK13DB_37_L      0x13DB6E
#define REG_BK13DB_37_H      0x13DB6F
#define REG_BK13DB_38_L      0x13DB70
#define REG_BK13DB_38_H      0x13DB71
#define REG_BK13DB_39_L      0x13DB72
#define REG_BK13DB_39_H      0x13DB73
#define REG_BK13DB_3A_L      0x13DB74
#define REG_BK13DB_3A_H      0x13DB75
#define REG_BK13DB_3B_L      0x13DB76
#define REG_BK13DB_3B_H      0x13DB77
#define REG_BK13DB_3C_L      0x13DB78
#define REG_BK13DB_3C_H      0x13DB79
#define REG_BK13DB_3D_L      0x13DB7A
#define REG_BK13DB_3D_H      0x13DB7B
#define REG_BK13DB_3E_L      0x13DB7C
#define REG_BK13DB_3E_H      0x13DB7D
#define REG_BK13DB_3F_L      0x13DB7E
#define REG_BK13DB_3F_H      0x13DB7F
#define REG_BK13DB_40_L      0x13DB80
#define REG_BK13DB_40_H      0x13DB81
#define REG_BK13DB_41_L      0x13DB82
#define REG_BK13DB_41_H      0x13DB83
#define REG_BK13DB_42_L      0x13DB84
#define REG_BK13DB_42_H      0x13DB85
#define REG_BK13DB_43_L      0x13DB86
#define REG_BK13DB_43_H      0x13DB87
#define REG_BK13DB_44_L      0x13DB88
#define REG_BK13DB_44_H      0x13DB89
#define REG_BK13DB_45_L      0x13DB8A
#define REG_BK13DB_45_H      0x13DB8B
#define REG_BK13DB_46_L      0x13DB8C
#define REG_BK13DB_46_H      0x13DB8D
#define REG_BK13DB_47_L      0x13DB8E
#define REG_BK13DB_47_H      0x13DB8F
#define REG_BK13DB_48_L      0x13DB90
#define REG_BK13DB_48_H      0x13DB91
#define REG_BK13DB_49_L      0x13DB92
#define REG_BK13DB_49_H      0x13DB93
#define REG_BK13DB_4A_L      0x13DB94
#define REG_BK13DB_4A_H      0x13DB95
#define REG_BK13DB_4B_L      0x13DB96
#define REG_BK13DB_4B_H      0x13DB97
#define REG_BK13DB_4C_L      0x13DB98
#define REG_BK13DB_4C_H      0x13DB99
#define REG_BK13DB_4D_L      0x13DB9A
#define REG_BK13DB_4D_H      0x13DB9B
#define REG_BK13DB_4E_L      0x13DB9C
#define REG_BK13DB_4E_H      0x13DB9D
#define REG_BK13DB_4F_L      0x13DB9E
#define REG_BK13DB_4F_H      0x13DB9F
#define REG_BK13DB_50_L      0x13DBA0
#define REG_BK13DB_50_H      0x13DBA1
#define REG_BK13DB_51_L      0x13DBA2
#define REG_BK13DB_51_H      0x13DBA3
#define REG_BK13DB_52_L      0x13DBA4
#define REG_BK13DB_52_H      0x13DBA5
#define REG_BK13DB_53_L      0x13DBA6
#define REG_BK13DB_53_H      0x13DBA7
#define REG_BK13DB_54_L      0x13DBA8
#define REG_BK13DB_54_H      0x13DBA9
#define REG_BK13DB_55_L      0x13DBAA
#define REG_BK13DB_55_H      0x13DBAB
#define REG_BK13DB_56_L      0x13DBAC
#define REG_BK13DB_56_H      0x13DBAD
#define REG_BK13DB_57_L      0x13DBAE
#define REG_BK13DB_57_H      0x13DBAF
#define REG_BK13DB_58_L      0x13DBB0
#define REG_BK13DB_58_H      0x13DBB1
#define REG_BK13DB_59_L      0x13DBB2
#define REG_BK13DB_59_H      0x13DBB3
#define REG_BK13DB_5A_L      0x13DBB4
#define REG_BK13DB_5A_H      0x13DBB5
#define REG_BK13DB_5B_L      0x13DBB6
#define REG_BK13DB_5B_H      0x13DBB7
#define REG_BK13DB_5C_L      0x13DBB8
#define REG_BK13DB_5C_H      0x13DBB9
#define REG_BK13DB_5D_L      0x13DBBA
#define REG_BK13DB_5D_H      0x13DBBB
#define REG_BK13DB_5E_L      0x13DBBC
#define REG_BK13DB_5E_H      0x13DBBD
#define REG_BK13DB_5F_L      0x13DBBE
#define REG_BK13DB_5F_H      0x13DBBF
#define REG_BK13DB_60_L      0x13DBC0
#define REG_BK13DB_60_H      0x13DBC1
#define REG_BK13DB_61_L      0x13DBC2
#define REG_BK13DB_61_H      0x13DBC3
#define REG_BK13DB_62_L      0x13DBC4
#define REG_BK13DB_62_H      0x13DBC5
#define REG_BK13DB_63_L      0x13DBC6
#define REG_BK13DB_63_H      0x13DBC7
#define REG_BK13DB_64_L      0x13DBC8
#define REG_BK13DB_64_H      0x13DBC9
#define REG_BK13DB_65_L      0x13DBCA
#define REG_BK13DB_65_H      0x13DBCB
#define REG_BK13DB_66_L      0x13DBCC
#define REG_BK13DB_66_H      0x13DBCD
#define REG_BK13DB_67_L      0x13DBCE
#define REG_BK13DB_67_H      0x13DBCF
#define REG_BK13DB_68_L      0x13DBD0
#define REG_BK13DB_68_H      0x13DBD1
#define REG_BK13DB_69_L      0x13DBD2
#define REG_BK13DB_69_H      0x13DBD3
#define REG_BK13DB_6A_L      0x13DBD4
#define REG_BK13DB_6A_H      0x13DBD5
#define REG_BK13DB_6B_L      0x13DBD6
#define REG_BK13DB_6B_H      0x13DBD7
#define REG_BK13DB_6C_L      0x13DBD8
#define REG_BK13DB_6C_H      0x13DBD9
#define REG_BK13DB_6D_L      0x13DBDA
#define REG_BK13DB_6D_H      0x13DBDB
#define REG_BK13DB_6E_L      0x13DBDC
#define REG_BK13DB_6E_H      0x13DBDD
#define REG_BK13DB_6F_L      0x13DBDE
#define REG_BK13DB_6F_H      0x13DBDF
#define REG_BK13DB_70_L      0x13DBE0
#define REG_BK13DB_70_H      0x13DBE1
#define REG_BK13DB_71_L      0x13DBE2
#define REG_BK13DB_71_H      0x13DBE3
#define REG_BK13DB_72_L      0x13DBE4
#define REG_BK13DB_72_H      0x13DBE5
#define REG_BK13DB_73_L      0x13DBE6
#define REG_BK13DB_73_H      0x13DBE7
#define REG_BK13DB_74_L      0x13DBE8
#define REG_BK13DB_74_H      0x13DBE9
#define REG_BK13DB_75_L      0x13DBEA
#define REG_BK13DB_75_H      0x13DBEB
#define REG_BK13DB_76_L      0x13DBEC
#define REG_BK13DB_76_H      0x13DBED
#define REG_BK13DB_77_L      0x13DBEE
#define REG_BK13DB_77_H      0x13DBEF
#define REG_BK13DB_78_L      0x13DBF0
#define REG_BK13DB_78_H      0x13DBF1
#define REG_BK13DB_79_L      0x13DBF2
#define REG_BK13DB_79_H      0x13DBF3
#define REG_BK13DB_7A_L      0x13DBF4
#define REG_BK13DB_7A_H      0x13DBF5
#define REG_BK13DB_7B_L      0x13DBF6
#define REG_BK13DB_7B_H      0x13DBF7
#define REG_BK13DB_7C_L      0x13DBF8
#define REG_BK13DB_7C_H      0x13DBF9
#define REG_BK13DB_7D_L      0x13DBFA
#define REG_BK13DB_7D_H      0x13DBFB
#define REG_BK13DB_7E_L      0x13DBFC
#define REG_BK13DB_7E_H      0x13DBFD
#define REG_BK13DB_7F_L      0x13DBFE
#define REG_BK13DB_7F_H      0x13DBFF
//----------------------------------------------
#define REG_BK13E0_00_L      0x13E000
#define REG_BK13E0_00_H      0x13E001
#define REG_BK13E0_01_L      0x13E002
#define REG_BK13E0_01_H      0x13E003
#define REG_BK13E0_02_L      0x13E004
#define REG_BK13E0_02_H      0x13E005
#define REG_BK13E0_03_L      0x13E006
#define REG_BK13E0_03_H      0x13E007
#define REG_BK13E0_04_L      0x13E008
#define REG_BK13E0_04_H      0x13E009
#define REG_BK13E0_05_L      0x13E00A
#define REG_BK13E0_05_H      0x13E00B
#define REG_BK13E0_06_L      0x13E00C
#define REG_BK13E0_06_H      0x13E00D
#define REG_BK13E0_07_L      0x13E00E
#define REG_BK13E0_07_H      0x13E00F
#define REG_BK13E0_08_L      0x13E010
#define REG_BK13E0_08_H      0x13E011
#define REG_BK13E0_09_L      0x13E012
#define REG_BK13E0_09_H      0x13E013
#define REG_BK13E0_0A_L      0x13E014
#define REG_BK13E0_0A_H      0x13E015
#define REG_BK13E0_0B_L      0x13E016
#define REG_BK13E0_0B_H      0x13E017
#define REG_BK13E0_0C_L      0x13E018
#define REG_BK13E0_0C_H      0x13E019
#define REG_BK13E0_0D_L      0x13E01A
#define REG_BK13E0_0D_H      0x13E01B
#define REG_BK13E0_0E_L      0x13E01C
#define REG_BK13E0_0E_H      0x13E01D
#define REG_BK13E0_0F_L      0x13E01E
#define REG_BK13E0_0F_H      0x13E01F
#define REG_BK13E0_10_L      0x13E020
#define REG_BK13E0_10_H      0x13E021
#define REG_BK13E0_11_L      0x13E022
#define REG_BK13E0_11_H      0x13E023
#define REG_BK13E0_12_L      0x13E024
#define REG_BK13E0_12_H      0x13E025
#define REG_BK13E0_13_L      0x13E026
#define REG_BK13E0_13_H      0x13E027
#define REG_BK13E0_14_L      0x13E028
#define REG_BK13E0_14_H      0x13E029
#define REG_BK13E0_15_L      0x13E02A
#define REG_BK13E0_15_H      0x13E02B
#define REG_BK13E0_16_L      0x13E02C
#define REG_BK13E0_16_H      0x13E02D
#define REG_BK13E0_17_L      0x13E02E
#define REG_BK13E0_17_H      0x13E02F
#define REG_BK13E0_18_L      0x13E030
#define REG_BK13E0_18_H      0x13E031
#define REG_BK13E0_19_L      0x13E032
#define REG_BK13E0_19_H      0x13E033
#define REG_BK13E0_1A_L      0x13E034
#define REG_BK13E0_1A_H      0x13E035
#define REG_BK13E0_1B_L      0x13E036
#define REG_BK13E0_1B_H      0x13E037
#define REG_BK13E0_1C_L      0x13E038
#define REG_BK13E0_1C_H      0x13E039
#define REG_BK13E0_1D_L      0x13E03A
#define REG_BK13E0_1D_H      0x13E03B
#define REG_BK13E0_1E_L      0x13E03C
#define REG_BK13E0_1E_H      0x13E03D
#define REG_BK13E0_1F_L      0x13E03E
#define REG_BK13E0_1F_H      0x13E03F
#define REG_BK13E0_20_L      0x13E040
#define REG_BK13E0_20_H      0x13E041
#define REG_BK13E0_21_L      0x13E042
#define REG_BK13E0_21_H      0x13E043
#define REG_BK13E0_22_L      0x13E044
#define REG_BK13E0_22_H      0x13E045
#define REG_BK13E0_23_L      0x13E046
#define REG_BK13E0_23_H      0x13E047
#define REG_BK13E0_24_L      0x13E048
#define REG_BK13E0_24_H      0x13E049
#define REG_BK13E0_25_L      0x13E04A
#define REG_BK13E0_25_H      0x13E04B
#define REG_BK13E0_26_L      0x13E04C
#define REG_BK13E0_26_H      0x13E04D
#define REG_BK13E0_27_L      0x13E04E
#define REG_BK13E0_27_H      0x13E04F
#define REG_BK13E0_28_L      0x13E050
#define REG_BK13E0_28_H      0x13E051
#define REG_BK13E0_29_L      0x13E052
#define REG_BK13E0_29_H      0x13E053
#define REG_BK13E0_2A_L      0x13E054
#define REG_BK13E0_2A_H      0x13E055
#define REG_BK13E0_2B_L      0x13E056
#define REG_BK13E0_2B_H      0x13E057
#define REG_BK13E0_2C_L      0x13E058
#define REG_BK13E0_2C_H      0x13E059
#define REG_BK13E0_2D_L      0x13E05A
#define REG_BK13E0_2D_H      0x13E05B
#define REG_BK13E0_2E_L      0x13E05C
#define REG_BK13E0_2E_H      0x13E05D
#define REG_BK13E0_2F_L      0x13E05E
#define REG_BK13E0_2F_H      0x13E05F
#define REG_BK13E0_30_L      0x13E060
#define REG_BK13E0_30_H      0x13E061
#define REG_BK13E0_31_L      0x13E062
#define REG_BK13E0_31_H      0x13E063
#define REG_BK13E0_32_L      0x13E064
#define REG_BK13E0_32_H      0x13E065
#define REG_BK13E0_33_L      0x13E066
#define REG_BK13E0_33_H      0x13E067
#define REG_BK13E0_34_L      0x13E068
#define REG_BK13E0_34_H      0x13E069
#define REG_BK13E0_35_L      0x13E06A
#define REG_BK13E0_35_H      0x13E06B
#define REG_BK13E0_36_L      0x13E06C
#define REG_BK13E0_36_H      0x13E06D
#define REG_BK13E0_37_L      0x13E06E
#define REG_BK13E0_37_H      0x13E06F
#define REG_BK13E0_38_L      0x13E070
#define REG_BK13E0_38_H      0x13E071
#define REG_BK13E0_39_L      0x13E072
#define REG_BK13E0_39_H      0x13E073
#define REG_BK13E0_3A_L      0x13E074
#define REG_BK13E0_3A_H      0x13E075
#define REG_BK13E0_3B_L      0x13E076
#define REG_BK13E0_3B_H      0x13E077
#define REG_BK13E0_3C_L      0x13E078
#define REG_BK13E0_3C_H      0x13E079
#define REG_BK13E0_3D_L      0x13E07A
#define REG_BK13E0_3D_H      0x13E07B
#define REG_BK13E0_3E_L      0x13E07C
#define REG_BK13E0_3E_H      0x13E07D
#define REG_BK13E0_3F_L      0x13E07E
#define REG_BK13E0_3F_H      0x13E07F
#define REG_BK13E0_40_L      0x13E080
#define REG_BK13E0_40_H      0x13E081
#define REG_BK13E0_41_L      0x13E082
#define REG_BK13E0_41_H      0x13E083
#define REG_BK13E0_42_L      0x13E084
#define REG_BK13E0_42_H      0x13E085
#define REG_BK13E0_43_L      0x13E086
#define REG_BK13E0_43_H      0x13E087
#define REG_BK13E0_44_L      0x13E088
#define REG_BK13E0_44_H      0x13E089
#define REG_BK13E0_45_L      0x13E08A
#define REG_BK13E0_45_H      0x13E08B
#define REG_BK13E0_46_L      0x13E08C
#define REG_BK13E0_46_H      0x13E08D
#define REG_BK13E0_47_L      0x13E08E
#define REG_BK13E0_47_H      0x13E08F
#define REG_BK13E0_48_L      0x13E090
#define REG_BK13E0_48_H      0x13E091
#define REG_BK13E0_49_L      0x13E092
#define REG_BK13E0_49_H      0x13E093
#define REG_BK13E0_4A_L      0x13E094
#define REG_BK13E0_4A_H      0x13E095
#define REG_BK13E0_4B_L      0x13E096
#define REG_BK13E0_4B_H      0x13E097
#define REG_BK13E0_4C_L      0x13E098
#define REG_BK13E0_4C_H      0x13E099
#define REG_BK13E0_4D_L      0x13E09A
#define REG_BK13E0_4D_H      0x13E09B
#define REG_BK13E0_4E_L      0x13E09C
#define REG_BK13E0_4E_H      0x13E09D
#define REG_BK13E0_4F_L      0x13E09E
#define REG_BK13E0_4F_H      0x13E09F
#define REG_BK13E0_50_L      0x13E0A0
#define REG_BK13E0_50_H      0x13E0A1
#define REG_BK13E0_51_L      0x13E0A2
#define REG_BK13E0_51_H      0x13E0A3
#define REG_BK13E0_52_L      0x13E0A4
#define REG_BK13E0_52_H      0x13E0A5
#define REG_BK13E0_53_L      0x13E0A6
#define REG_BK13E0_53_H      0x13E0A7
#define REG_BK13E0_54_L      0x13E0A8
#define REG_BK13E0_54_H      0x13E0A9
#define REG_BK13E0_55_L      0x13E0AA
#define REG_BK13E0_55_H      0x13E0AB
#define REG_BK13E0_56_L      0x13E0AC
#define REG_BK13E0_56_H      0x13E0AD
#define REG_BK13E0_57_L      0x13E0AE
#define REG_BK13E0_57_H      0x13E0AF
#define REG_BK13E0_58_L      0x13E0B0
#define REG_BK13E0_58_H      0x13E0B1
#define REG_BK13E0_59_L      0x13E0B2
#define REG_BK13E0_59_H      0x13E0B3
#define REG_BK13E0_5A_L      0x13E0B4
#define REG_BK13E0_5A_H      0x13E0B5
#define REG_BK13E0_5B_L      0x13E0B6
#define REG_BK13E0_5B_H      0x13E0B7
#define REG_BK13E0_5C_L      0x13E0B8
#define REG_BK13E0_5C_H      0x13E0B9
#define REG_BK13E0_5D_L      0x13E0BA
#define REG_BK13E0_5D_H      0x13E0BB
#define REG_BK13E0_5E_L      0x13E0BC
#define REG_BK13E0_5E_H      0x13E0BD
#define REG_BK13E0_5F_L      0x13E0BE
#define REG_BK13E0_5F_H      0x13E0BF
#define REG_BK13E0_60_L      0x13E0C0
#define REG_BK13E0_60_H      0x13E0C1
#define REG_BK13E0_61_L      0x13E0C2
#define REG_BK13E0_61_H      0x13E0C3
#define REG_BK13E0_62_L      0x13E0C4
#define REG_BK13E0_62_H      0x13E0C5
#define REG_BK13E0_63_L      0x13E0C6
#define REG_BK13E0_63_H      0x13E0C7
#define REG_BK13E0_64_L      0x13E0C8
#define REG_BK13E0_64_H      0x13E0C9
#define REG_BK13E0_65_L      0x13E0CA
#define REG_BK13E0_65_H      0x13E0CB
#define REG_BK13E0_66_L      0x13E0CC
#define REG_BK13E0_66_H      0x13E0CD
#define REG_BK13E0_67_L      0x13E0CE
#define REG_BK13E0_67_H      0x13E0CF
#define REG_BK13E0_68_L      0x13E0D0
#define REG_BK13E0_68_H      0x13E0D1
#define REG_BK13E0_69_L      0x13E0D2
#define REG_BK13E0_69_H      0x13E0D3
#define REG_BK13E0_6A_L      0x13E0D4
#define REG_BK13E0_6A_H      0x13E0D5
#define REG_BK13E0_6B_L      0x13E0D6
#define REG_BK13E0_6B_H      0x13E0D7
#define REG_BK13E0_6C_L      0x13E0D8
#define REG_BK13E0_6C_H      0x13E0D9
#define REG_BK13E0_6D_L      0x13E0DA
#define REG_BK13E0_6D_H      0x13E0DB
#define REG_BK13E0_6E_L      0x13E0DC
#define REG_BK13E0_6E_H      0x13E0DD
#define REG_BK13E0_6F_L      0x13E0DE
#define REG_BK13E0_6F_H      0x13E0DF
#define REG_BK13E0_70_L      0x13E0E0
#define REG_BK13E0_70_H      0x13E0E1
#define REG_BK13E0_71_L      0x13E0E2
#define REG_BK13E0_71_H      0x13E0E3
#define REG_BK13E0_72_L      0x13E0E4
#define REG_BK13E0_72_H      0x13E0E5
#define REG_BK13E0_73_L      0x13E0E6
#define REG_BK13E0_73_H      0x13E0E7
#define REG_BK13E0_74_L      0x13E0E8
#define REG_BK13E0_74_H      0x13E0E9
#define REG_BK13E0_75_L      0x13E0EA
#define REG_BK13E0_75_H      0x13E0EB
#define REG_BK13E0_76_L      0x13E0EC
#define REG_BK13E0_76_H      0x13E0ED
#define REG_BK13E0_77_L      0x13E0EE
#define REG_BK13E0_77_H      0x13E0EF
#define REG_BK13E0_78_L      0x13E0F0
#define REG_BK13E0_78_H      0x13E0F1
#define REG_BK13E0_79_L      0x13E0F2
#define REG_BK13E0_79_H      0x13E0F3
#define REG_BK13E0_7A_L      0x13E0F4
#define REG_BK13E0_7A_H      0x13E0F5
#define REG_BK13E0_7B_L      0x13E0F6
#define REG_BK13E0_7B_H      0x13E0F7
#define REG_BK13E0_7C_L      0x13E0F8
#define REG_BK13E0_7C_H      0x13E0F9
#define REG_BK13E0_7D_L      0x13E0FA
#define REG_BK13E0_7D_H      0x13E0FB
#define REG_BK13E0_7E_L      0x13E0FC
#define REG_BK13E0_7E_H      0x13E0FD
#define REG_BK13E0_7F_L      0x13E0FE
#define REG_BK13E0_7F_H      0x13E0FF
//----------------------------------------------
#define REG_BK13E1_00_L      0x13E100
#define REG_BK13E1_00_H      0x13E101
#define REG_BK13E1_01_L      0x13E102
#define REG_BK13E1_01_H      0x13E103
#define REG_BK13E1_02_L      0x13E104
#define REG_BK13E1_02_H      0x13E105
#define REG_BK13E1_03_L      0x13E106
#define REG_BK13E1_03_H      0x13E107
#define REG_BK13E1_04_L      0x13E108
#define REG_BK13E1_04_H      0x13E109
#define REG_BK13E1_05_L      0x13E10A
#define REG_BK13E1_05_H      0x13E10B
#define REG_BK13E1_06_L      0x13E10C
#define REG_BK13E1_06_H      0x13E10D
#define REG_BK13E1_07_L      0x13E10E
#define REG_BK13E1_07_H      0x13E10F
#define REG_BK13E1_08_L      0x13E110
#define REG_BK13E1_08_H      0x13E111
#define REG_BK13E1_09_L      0x13E112
#define REG_BK13E1_09_H      0x13E113
#define REG_BK13E1_0A_L      0x13E114
#define REG_BK13E1_0A_H      0x13E115
#define REG_BK13E1_0B_L      0x13E116
#define REG_BK13E1_0B_H      0x13E117
#define REG_BK13E1_0C_L      0x13E118
#define REG_BK13E1_0C_H      0x13E119
#define REG_BK13E1_0D_L      0x13E11A
#define REG_BK13E1_0D_H      0x13E11B
#define REG_BK13E1_0E_L      0x13E11C
#define REG_BK13E1_0E_H      0x13E11D
#define REG_BK13E1_0F_L      0x13E11E
#define REG_BK13E1_0F_H      0x13E11F
#define REG_BK13E1_10_L      0x13E120
#define REG_BK13E1_10_H      0x13E121
#define REG_BK13E1_11_L      0x13E122
#define REG_BK13E1_11_H      0x13E123
#define REG_BK13E1_12_L      0x13E124
#define REG_BK13E1_12_H      0x13E125
#define REG_BK13E1_13_L      0x13E126
#define REG_BK13E1_13_H      0x13E127
#define REG_BK13E1_14_L      0x13E128
#define REG_BK13E1_14_H      0x13E129
#define REG_BK13E1_15_L      0x13E12A
#define REG_BK13E1_15_H      0x13E12B
#define REG_BK13E1_16_L      0x13E12C
#define REG_BK13E1_16_H      0x13E12D
#define REG_BK13E1_17_L      0x13E12E
#define REG_BK13E1_17_H      0x13E12F
#define REG_BK13E1_18_L      0x13E130
#define REG_BK13E1_18_H      0x13E131
#define REG_BK13E1_19_L      0x13E132
#define REG_BK13E1_19_H      0x13E133
#define REG_BK13E1_1A_L      0x13E134
#define REG_BK13E1_1A_H      0x13E135
#define REG_BK13E1_1B_L      0x13E136
#define REG_BK13E1_1B_H      0x13E137
#define REG_BK13E1_1C_L      0x13E138
#define REG_BK13E1_1C_H      0x13E139
#define REG_BK13E1_1D_L      0x13E13A
#define REG_BK13E1_1D_H      0x13E13B
#define REG_BK13E1_1E_L      0x13E13C
#define REG_BK13E1_1E_H      0x13E13D
#define REG_BK13E1_1F_L      0x13E13E
#define REG_BK13E1_1F_H      0x13E13F
#define REG_BK13E1_20_L      0x13E140
#define REG_BK13E1_20_H      0x13E141
#define REG_BK13E1_21_L      0x13E142
#define REG_BK13E1_21_H      0x13E143
#define REG_BK13E1_22_L      0x13E144
#define REG_BK13E1_22_H      0x13E145
#define REG_BK13E1_23_L      0x13E146
#define REG_BK13E1_23_H      0x13E147
#define REG_BK13E1_24_L      0x13E148
#define REG_BK13E1_24_H      0x13E149
#define REG_BK13E1_25_L      0x13E14A
#define REG_BK13E1_25_H      0x13E14B
#define REG_BK13E1_26_L      0x13E14C
#define REG_BK13E1_26_H      0x13E14D
#define REG_BK13E1_27_L      0x13E14E
#define REG_BK13E1_27_H      0x13E14F
#define REG_BK13E1_28_L      0x13E150
#define REG_BK13E1_28_H      0x13E151
#define REG_BK13E1_29_L      0x13E152
#define REG_BK13E1_29_H      0x13E153
#define REG_BK13E1_2A_L      0x13E154
#define REG_BK13E1_2A_H      0x13E155
#define REG_BK13E1_2B_L      0x13E156
#define REG_BK13E1_2B_H      0x13E157
#define REG_BK13E1_2C_L      0x13E158
#define REG_BK13E1_2C_H      0x13E159
#define REG_BK13E1_2D_L      0x13E15A
#define REG_BK13E1_2D_H      0x13E15B
#define REG_BK13E1_2E_L      0x13E15C
#define REG_BK13E1_2E_H      0x13E15D
#define REG_BK13E1_2F_L      0x13E15E
#define REG_BK13E1_2F_H      0x13E15F
#define REG_BK13E1_30_L      0x13E160
#define REG_BK13E1_30_H      0x13E161
#define REG_BK13E1_31_L      0x13E162
#define REG_BK13E1_31_H      0x13E163
#define REG_BK13E1_32_L      0x13E164
#define REG_BK13E1_32_H      0x13E165
#define REG_BK13E1_33_L      0x13E166
#define REG_BK13E1_33_H      0x13E167
#define REG_BK13E1_34_L      0x13E168
#define REG_BK13E1_34_H      0x13E169
#define REG_BK13E1_35_L      0x13E16A
#define REG_BK13E1_35_H      0x13E16B
#define REG_BK13E1_36_L      0x13E16C
#define REG_BK13E1_36_H      0x13E16D
#define REG_BK13E1_37_L      0x13E16E
#define REG_BK13E1_37_H      0x13E16F
#define REG_BK13E1_38_L      0x13E170
#define REG_BK13E1_38_H      0x13E171
#define REG_BK13E1_39_L      0x13E172
#define REG_BK13E1_39_H      0x13E173
#define REG_BK13E1_3A_L      0x13E174
#define REG_BK13E1_3A_H      0x13E175
#define REG_BK13E1_3B_L      0x13E176
#define REG_BK13E1_3B_H      0x13E177
#define REG_BK13E1_3C_L      0x13E178
#define REG_BK13E1_3C_H      0x13E179
#define REG_BK13E1_3D_L      0x13E17A
#define REG_BK13E1_3D_H      0x13E17B
#define REG_BK13E1_3E_L      0x13E17C
#define REG_BK13E1_3E_H      0x13E17D
#define REG_BK13E1_3F_L      0x13E17E
#define REG_BK13E1_3F_H      0x13E17F
#define REG_BK13E1_40_L      0x13E180
#define REG_BK13E1_40_H      0x13E181
#define REG_BK13E1_41_L      0x13E182
#define REG_BK13E1_41_H      0x13E183
#define REG_BK13E1_42_L      0x13E184
#define REG_BK13E1_42_H      0x13E185
#define REG_BK13E1_43_L      0x13E186
#define REG_BK13E1_43_H      0x13E187
#define REG_BK13E1_44_L      0x13E188
#define REG_BK13E1_44_H      0x13E189
#define REG_BK13E1_45_L      0x13E18A
#define REG_BK13E1_45_H      0x13E18B
#define REG_BK13E1_46_L      0x13E18C
#define REG_BK13E1_46_H      0x13E18D
#define REG_BK13E1_47_L      0x13E18E
#define REG_BK13E1_47_H      0x13E18F
#define REG_BK13E1_48_L      0x13E190
#define REG_BK13E1_48_H      0x13E191
#define REG_BK13E1_49_L      0x13E192
#define REG_BK13E1_49_H      0x13E193
#define REG_BK13E1_4A_L      0x13E194
#define REG_BK13E1_4A_H      0x13E195
#define REG_BK13E1_4B_L      0x13E196
#define REG_BK13E1_4B_H      0x13E197
#define REG_BK13E1_4C_L      0x13E198
#define REG_BK13E1_4C_H      0x13E199
#define REG_BK13E1_4D_L      0x13E19A
#define REG_BK13E1_4D_H      0x13E19B
#define REG_BK13E1_4E_L      0x13E19C
#define REG_BK13E1_4E_H      0x13E19D
#define REG_BK13E1_4F_L      0x13E19E
#define REG_BK13E1_4F_H      0x13E19F
#define REG_BK13E1_50_L      0x13E1A0
#define REG_BK13E1_50_H      0x13E1A1
#define REG_BK13E1_51_L      0x13E1A2
#define REG_BK13E1_51_H      0x13E1A3
#define REG_BK13E1_52_L      0x13E1A4
#define REG_BK13E1_52_H      0x13E1A5
#define REG_BK13E1_53_L      0x13E1A6
#define REG_BK13E1_53_H      0x13E1A7
#define REG_BK13E1_54_L      0x13E1A8
#define REG_BK13E1_54_H      0x13E1A9
#define REG_BK13E1_55_L      0x13E1AA
#define REG_BK13E1_55_H      0x13E1AB
#define REG_BK13E1_56_L      0x13E1AC
#define REG_BK13E1_56_H      0x13E1AD
#define REG_BK13E1_57_L      0x13E1AE
#define REG_BK13E1_57_H      0x13E1AF
#define REG_BK13E1_58_L      0x13E1B0
#define REG_BK13E1_58_H      0x13E1B1
#define REG_BK13E1_59_L      0x13E1B2
#define REG_BK13E1_59_H      0x13E1B3
#define REG_BK13E1_5A_L      0x13E1B4
#define REG_BK13E1_5A_H      0x13E1B5
#define REG_BK13E1_5B_L      0x13E1B6
#define REG_BK13E1_5B_H      0x13E1B7
#define REG_BK13E1_5C_L      0x13E1B8
#define REG_BK13E1_5C_H      0x13E1B9
#define REG_BK13E1_5D_L      0x13E1BA
#define REG_BK13E1_5D_H      0x13E1BB
#define REG_BK13E1_5E_L      0x13E1BC
#define REG_BK13E1_5E_H      0x13E1BD
#define REG_BK13E1_5F_L      0x13E1BE
#define REG_BK13E1_5F_H      0x13E1BF
#define REG_BK13E1_60_L      0x13E1C0
#define REG_BK13E1_60_H      0x13E1C1
#define REG_BK13E1_61_L      0x13E1C2
#define REG_BK13E1_61_H      0x13E1C3
#define REG_BK13E1_62_L      0x13E1C4
#define REG_BK13E1_62_H      0x13E1C5
#define REG_BK13E1_63_L      0x13E1C6
#define REG_BK13E1_63_H      0x13E1C7
#define REG_BK13E1_64_L      0x13E1C8
#define REG_BK13E1_64_H      0x13E1C9
#define REG_BK13E1_65_L      0x13E1CA
#define REG_BK13E1_65_H      0x13E1CB
#define REG_BK13E1_66_L      0x13E1CC
#define REG_BK13E1_66_H      0x13E1CD
#define REG_BK13E1_67_L      0x13E1CE
#define REG_BK13E1_67_H      0x13E1CF
#define REG_BK13E1_68_L      0x13E1D0
#define REG_BK13E1_68_H      0x13E1D1
#define REG_BK13E1_69_L      0x13E1D2
#define REG_BK13E1_69_H      0x13E1D3
#define REG_BK13E1_6A_L      0x13E1D4
#define REG_BK13E1_6A_H      0x13E1D5
#define REG_BK13E1_6B_L      0x13E1D6
#define REG_BK13E1_6B_H      0x13E1D7
#define REG_BK13E1_6C_L      0x13E1D8
#define REG_BK13E1_6C_H      0x13E1D9
#define REG_BK13E1_6D_L      0x13E1DA
#define REG_BK13E1_6D_H      0x13E1DB
#define REG_BK13E1_6E_L      0x13E1DC
#define REG_BK13E1_6E_H      0x13E1DD
#define REG_BK13E1_6F_L      0x13E1DE
#define REG_BK13E1_6F_H      0x13E1DF
#define REG_BK13E1_70_L      0x13E1E0
#define REG_BK13E1_70_H      0x13E1E1
#define REG_BK13E1_71_L      0x13E1E2
#define REG_BK13E1_71_H      0x13E1E3
#define REG_BK13E1_72_L      0x13E1E4
#define REG_BK13E1_72_H      0x13E1E5
#define REG_BK13E1_73_L      0x13E1E6
#define REG_BK13E1_73_H      0x13E1E7
#define REG_BK13E1_74_L      0x13E1E8
#define REG_BK13E1_74_H      0x13E1E9
#define REG_BK13E1_75_L      0x13E1EA
#define REG_BK13E1_75_H      0x13E1EB
#define REG_BK13E1_76_L      0x13E1EC
#define REG_BK13E1_76_H      0x13E1ED
#define REG_BK13E1_77_L      0x13E1EE
#define REG_BK13E1_77_H      0x13E1EF
#define REG_BK13E1_78_L      0x13E1F0
#define REG_BK13E1_78_H      0x13E1F1
#define REG_BK13E1_79_L      0x13E1F2
#define REG_BK13E1_79_H      0x13E1F3
#define REG_BK13E1_7A_L      0x13E1F4
#define REG_BK13E1_7A_H      0x13E1F5
#define REG_BK13E1_7B_L      0x13E1F6
#define REG_BK13E1_7B_H      0x13E1F7
#define REG_BK13E1_7C_L      0x13E1F8
#define REG_BK13E1_7C_H      0x13E1F9
#define REG_BK13E1_7D_L      0x13E1FA
#define REG_BK13E1_7D_H      0x13E1FB
#define REG_BK13E1_7E_L      0x13E1FC
#define REG_BK13E1_7E_H      0x13E1FD
#define REG_BK13E1_7F_L      0x13E1FE
#define REG_BK13E1_7F_H      0x13E1FF
//----------------------------------------------
#define REG_BK1400_00_L      0x140000
#define REG_BK1400_00_H      0x140001
#define REG_BK1400_01_L      0x140002
#define REG_BK1400_01_H      0x140003
#define REG_BK1400_02_L      0x140004
#define REG_BK1400_02_H      0x140005
#define REG_BK1400_03_L      0x140006
#define REG_BK1400_03_H      0x140007
#define REG_BK1400_04_L      0x140008
#define REG_BK1400_04_H      0x140009
#define REG_BK1400_05_L      0x14000A
#define REG_BK1400_05_H      0x14000B
#define REG_BK1400_06_L      0x14000C
#define REG_BK1400_06_H      0x14000D
#define REG_BK1400_07_L      0x14000E
#define REG_BK1400_07_H      0x14000F
#define REG_BK1400_08_L      0x140010
#define REG_BK1400_08_H      0x140011
#define REG_BK1400_09_L      0x140012
#define REG_BK1400_09_H      0x140013
#define REG_BK1400_0A_L      0x140014
#define REG_BK1400_0A_H      0x140015
#define REG_BK1400_0B_L      0x140016
#define REG_BK1400_0B_H      0x140017
#define REG_BK1400_0C_L      0x140018
#define REG_BK1400_0C_H      0x140019
#define REG_BK1400_0D_L      0x14001A
#define REG_BK1400_0D_H      0x14001B
#define REG_BK1400_0E_L      0x14001C
#define REG_BK1400_0E_H      0x14001D
#define REG_BK1400_0F_L      0x14001E
#define REG_BK1400_0F_H      0x14001F
#define REG_BK1400_10_L      0x140020
#define REG_BK1400_10_H      0x140021
#define REG_BK1400_11_L      0x140022
#define REG_BK1400_11_H      0x140023
#define REG_BK1400_12_L      0x140024
#define REG_BK1400_12_H      0x140025
#define REG_BK1400_13_L      0x140026
#define REG_BK1400_13_H      0x140027
#define REG_BK1400_14_L      0x140028
#define REG_BK1400_14_H      0x140029
#define REG_BK1400_15_L      0x14002A
#define REG_BK1400_15_H      0x14002B
#define REG_BK1400_16_L      0x14002C
#define REG_BK1400_16_H      0x14002D
#define REG_BK1400_17_L      0x14002E
#define REG_BK1400_17_H      0x14002F
#define REG_BK1400_18_L      0x140030
#define REG_BK1400_18_H      0x140031
#define REG_BK1400_19_L      0x140032
#define REG_BK1400_19_H      0x140033
#define REG_BK1400_1A_L      0x140034
#define REG_BK1400_1A_H      0x140035
#define REG_BK1400_1B_L      0x140036
#define REG_BK1400_1B_H      0x140037
#define REG_BK1400_1C_L      0x140038
#define REG_BK1400_1C_H      0x140039
#define REG_BK1400_1D_L      0x14003A
#define REG_BK1400_1D_H      0x14003B
#define REG_BK1400_1E_L      0x14003C
#define REG_BK1400_1E_H      0x14003D
#define REG_BK1400_1F_L      0x14003E
#define REG_BK1400_1F_H      0x14003F
#define REG_BK1400_20_L      0x140040
#define REG_BK1400_20_H      0x140041
#define REG_BK1400_21_L      0x140042
#define REG_BK1400_21_H      0x140043
#define REG_BK1400_22_L      0x140044
#define REG_BK1400_22_H      0x140045
#define REG_BK1400_23_L      0x140046
#define REG_BK1400_23_H      0x140047
#define REG_BK1400_24_L      0x140048
#define REG_BK1400_24_H      0x140049
#define REG_BK1400_25_L      0x14004A
#define REG_BK1400_25_H      0x14004B
#define REG_BK1400_26_L      0x14004C
#define REG_BK1400_26_H      0x14004D
#define REG_BK1400_27_L      0x14004E
#define REG_BK1400_27_H      0x14004F
#define REG_BK1400_28_L      0x140050
#define REG_BK1400_28_H      0x140051
#define REG_BK1400_29_L      0x140052
#define REG_BK1400_29_H      0x140053
#define REG_BK1400_2A_L      0x140054
#define REG_BK1400_2A_H      0x140055
#define REG_BK1400_2B_L      0x140056
#define REG_BK1400_2B_H      0x140057
#define REG_BK1400_2C_L      0x140058
#define REG_BK1400_2C_H      0x140059
#define REG_BK1400_2D_L      0x14005A
#define REG_BK1400_2D_H      0x14005B
#define REG_BK1400_2E_L      0x14005C
#define REG_BK1400_2E_H      0x14005D
#define REG_BK1400_2F_L      0x14005E
#define REG_BK1400_2F_H      0x14005F
#define REG_BK1400_30_L      0x140060
#define REG_BK1400_30_H      0x140061
#define REG_BK1400_31_L      0x140062
#define REG_BK1400_31_H      0x140063
#define REG_BK1400_32_L      0x140064
#define REG_BK1400_32_H      0x140065
#define REG_BK1400_33_L      0x140066
#define REG_BK1400_33_H      0x140067
#define REG_BK1400_34_L      0x140068
#define REG_BK1400_34_H      0x140069
#define REG_BK1400_35_L      0x14006A
#define REG_BK1400_35_H      0x14006B
#define REG_BK1400_36_L      0x14006C
#define REG_BK1400_36_H      0x14006D
#define REG_BK1400_37_L      0x14006E
#define REG_BK1400_37_H      0x14006F
#define REG_BK1400_38_L      0x140070
#define REG_BK1400_38_H      0x140071
#define REG_BK1400_39_L      0x140072
#define REG_BK1400_39_H      0x140073
#define REG_BK1400_3A_L      0x140074
#define REG_BK1400_3A_H      0x140075
#define REG_BK1400_3B_L      0x140076
#define REG_BK1400_3B_H      0x140077
#define REG_BK1400_3C_L      0x140078
#define REG_BK1400_3C_H      0x140079
#define REG_BK1400_3D_L      0x14007A
#define REG_BK1400_3D_H      0x14007B
#define REG_BK1400_3E_L      0x14007C
#define REG_BK1400_3E_H      0x14007D
#define REG_BK1400_3F_L      0x14007E
#define REG_BK1400_3F_H      0x14007F
#define REG_BK1400_40_L      0x140080
#define REG_BK1400_40_H      0x140081
#define REG_BK1400_41_L      0x140082
#define REG_BK1400_41_H      0x140083
#define REG_BK1400_42_L      0x140084
#define REG_BK1400_42_H      0x140085
#define REG_BK1400_43_L      0x140086
#define REG_BK1400_43_H      0x140087
#define REG_BK1400_44_L      0x140088
#define REG_BK1400_44_H      0x140089
#define REG_BK1400_45_L      0x14008A
#define REG_BK1400_45_H      0x14008B
#define REG_BK1400_46_L      0x14008C
#define REG_BK1400_46_H      0x14008D
#define REG_BK1400_47_L      0x14008E
#define REG_BK1400_47_H      0x14008F
#define REG_BK1400_48_L      0x140090
#define REG_BK1400_48_H      0x140091
#define REG_BK1400_49_L      0x140092
#define REG_BK1400_49_H      0x140093
#define REG_BK1400_4A_L      0x140094
#define REG_BK1400_4A_H      0x140095
#define REG_BK1400_4B_L      0x140096
#define REG_BK1400_4B_H      0x140097
#define REG_BK1400_4C_L      0x140098
#define REG_BK1400_4C_H      0x140099
#define REG_BK1400_4D_L      0x14009A
#define REG_BK1400_4D_H      0x14009B
#define REG_BK1400_4E_L      0x14009C
#define REG_BK1400_4E_H      0x14009D
#define REG_BK1400_4F_L      0x14009E
#define REG_BK1400_4F_H      0x14009F
#define REG_BK1400_50_L      0x1400A0
#define REG_BK1400_50_H      0x1400A1
#define REG_BK1400_51_L      0x1400A2
#define REG_BK1400_51_H      0x1400A3
#define REG_BK1400_52_L      0x1400A4
#define REG_BK1400_52_H      0x1400A5
#define REG_BK1400_53_L      0x1400A6
#define REG_BK1400_53_H      0x1400A7
#define REG_BK1400_54_L      0x1400A8
#define REG_BK1400_54_H      0x1400A9
#define REG_BK1400_55_L      0x1400AA
#define REG_BK1400_55_H      0x1400AB
#define REG_BK1400_56_L      0x1400AC
#define REG_BK1400_56_H      0x1400AD
#define REG_BK1400_57_L      0x1400AE
#define REG_BK1400_57_H      0x1400AF
#define REG_BK1400_58_L      0x1400B0
#define REG_BK1400_58_H      0x1400B1
#define REG_BK1400_59_L      0x1400B2
#define REG_BK1400_59_H      0x1400B3
#define REG_BK1400_5A_L      0x1400B4
#define REG_BK1400_5A_H      0x1400B5
#define REG_BK1400_5B_L      0x1400B6
#define REG_BK1400_5B_H      0x1400B7
#define REG_BK1400_5C_L      0x1400B8
#define REG_BK1400_5C_H      0x1400B9
#define REG_BK1400_5D_L      0x1400BA
#define REG_BK1400_5D_H      0x1400BB
#define REG_BK1400_5E_L      0x1400BC
#define REG_BK1400_5E_H      0x1400BD
#define REG_BK1400_5F_L      0x1400BE
#define REG_BK1400_5F_H      0x1400BF
#define REG_BK1400_60_L      0x1400C0
#define REG_BK1400_60_H      0x1400C1
#define REG_BK1400_61_L      0x1400C2
#define REG_BK1400_61_H      0x1400C3
#define REG_BK1400_62_L      0x1400C4
#define REG_BK1400_62_H      0x1400C5
#define REG_BK1400_63_L      0x1400C6
#define REG_BK1400_63_H      0x1400C7
#define REG_BK1400_64_L      0x1400C8
#define REG_BK1400_64_H      0x1400C9
#define REG_BK1400_65_L      0x1400CA
#define REG_BK1400_65_H      0x1400CB
#define REG_BK1400_66_L      0x1400CC
#define REG_BK1400_66_H      0x1400CD
#define REG_BK1400_67_L      0x1400CE
#define REG_BK1400_67_H      0x1400CF
#define REG_BK1400_68_L      0x1400D0
#define REG_BK1400_68_H      0x1400D1
#define REG_BK1400_69_L      0x1400D2
#define REG_BK1400_69_H      0x1400D3
#define REG_BK1400_6A_L      0x1400D4
#define REG_BK1400_6A_H      0x1400D5
#define REG_BK1400_6B_L      0x1400D6
#define REG_BK1400_6B_H      0x1400D7
#define REG_BK1400_6C_L      0x1400D8
#define REG_BK1400_6C_H      0x1400D9
#define REG_BK1400_6D_L      0x1400DA
#define REG_BK1400_6D_H      0x1400DB
#define REG_BK1400_6E_L      0x1400DC
#define REG_BK1400_6E_H      0x1400DD
#define REG_BK1400_6F_L      0x1400DE
#define REG_BK1400_6F_H      0x1400DF
#define REG_BK1400_70_L      0x1400E0
#define REG_BK1400_70_H      0x1400E1
#define REG_BK1400_71_L      0x1400E2
#define REG_BK1400_71_H      0x1400E3
#define REG_BK1400_72_L      0x1400E4
#define REG_BK1400_72_H      0x1400E5
#define REG_BK1400_73_L      0x1400E6
#define REG_BK1400_73_H      0x1400E7
#define REG_BK1400_74_L      0x1400E8
#define REG_BK1400_74_H      0x1400E9
#define REG_BK1400_75_L      0x1400EA
#define REG_BK1400_75_H      0x1400EB
#define REG_BK1400_76_L      0x1400EC
#define REG_BK1400_76_H      0x1400ED
#define REG_BK1400_77_L      0x1400EE
#define REG_BK1400_77_H      0x1400EF
#define REG_BK1400_78_L      0x1400F0
#define REG_BK1400_78_H      0x1400F1
#define REG_BK1400_79_L      0x1400F2
#define REG_BK1400_79_H      0x1400F3
#define REG_BK1400_7A_L      0x1400F4
#define REG_BK1400_7A_H      0x1400F5
#define REG_BK1400_7B_L      0x1400F6
#define REG_BK1400_7B_H      0x1400F7
#define REG_BK1400_7C_L      0x1400F8
#define REG_BK1400_7C_H      0x1400F9
#define REG_BK1400_7D_L      0x1400FA
#define REG_BK1400_7D_H      0x1400FB
#define REG_BK1400_7E_L      0x1400FC
#define REG_BK1400_7E_H      0x1400FD
#define REG_BK1400_7F_L      0x1400FE
#define REG_BK1400_7F_H      0x1400FF
//----------------------------------------------
#define REG_BK1419_00_L      0x141900
#define REG_BK1419_00_H      0x141901
#define REG_BK1419_01_L      0x141902
#define REG_BK1419_01_H      0x141903
#define REG_BK1419_02_L      0x141904
#define REG_BK1419_02_H      0x141905
#define REG_BK1419_03_L      0x141906
#define REG_BK1419_03_H      0x141907
#define REG_BK1419_04_L      0x141908
#define REG_BK1419_04_H      0x141909
#define REG_BK1419_05_L      0x14190A
#define REG_BK1419_05_H      0x14190B
#define REG_BK1419_06_L      0x14190C
#define REG_BK1419_06_H      0x14190D
#define REG_BK1419_07_L      0x14190E
#define REG_BK1419_07_H      0x14190F
#define REG_BK1419_08_L      0x141910
#define REG_BK1419_08_H      0x141911
#define REG_BK1419_09_L      0x141912
#define REG_BK1419_09_H      0x141913
#define REG_BK1419_0A_L      0x141914
#define REG_BK1419_0A_H      0x141915
#define REG_BK1419_0B_L      0x141916
#define REG_BK1419_0B_H      0x141917
#define REG_BK1419_0C_L      0x141918
#define REG_BK1419_0C_H      0x141919
#define REG_BK1419_0D_L      0x14191A
#define REG_BK1419_0D_H      0x14191B
#define REG_BK1419_0E_L      0x14191C
#define REG_BK1419_0E_H      0x14191D
#define REG_BK1419_0F_L      0x14191E
#define REG_BK1419_0F_H      0x14191F
#define REG_BK1419_10_L      0x141920
#define REG_BK1419_10_H      0x141921
#define REG_BK1419_11_L      0x141922
#define REG_BK1419_11_H      0x141923
#define REG_BK1419_12_L      0x141924
#define REG_BK1419_12_H      0x141925
#define REG_BK1419_13_L      0x141926
#define REG_BK1419_13_H      0x141927
#define REG_BK1419_14_L      0x141928
#define REG_BK1419_14_H      0x141929
#define REG_BK1419_15_L      0x14192A
#define REG_BK1419_15_H      0x14192B
#define REG_BK1419_16_L      0x14192C
#define REG_BK1419_16_H      0x14192D
#define REG_BK1419_17_L      0x14192E
#define REG_BK1419_17_H      0x14192F
#define REG_BK1419_18_L      0x141930
#define REG_BK1419_18_H      0x141931
#define REG_BK1419_19_L      0x141932
#define REG_BK1419_19_H      0x141933
#define REG_BK1419_1A_L      0x141934
#define REG_BK1419_1A_H      0x141935
#define REG_BK1419_1B_L      0x141936
#define REG_BK1419_1B_H      0x141937
#define REG_BK1419_1C_L      0x141938
#define REG_BK1419_1C_H      0x141939
#define REG_BK1419_1D_L      0x14193A
#define REG_BK1419_1D_H      0x14193B
#define REG_BK1419_1E_L      0x14193C
#define REG_BK1419_1E_H      0x14193D
#define REG_BK1419_1F_L      0x14193E
#define REG_BK1419_1F_H      0x14193F
#define REG_BK1419_20_L      0x141940
#define REG_BK1419_20_H      0x141941
#define REG_BK1419_21_L      0x141942
#define REG_BK1419_21_H      0x141943
#define REG_BK1419_22_L      0x141944
#define REG_BK1419_22_H      0x141945
#define REG_BK1419_23_L      0x141946
#define REG_BK1419_23_H      0x141947
#define REG_BK1419_24_L      0x141948
#define REG_BK1419_24_H      0x141949
#define REG_BK1419_25_L      0x14194A
#define REG_BK1419_25_H      0x14194B
#define REG_BK1419_26_L      0x14194C
#define REG_BK1419_26_H      0x14194D
#define REG_BK1419_27_L      0x14194E
#define REG_BK1419_27_H      0x14194F
#define REG_BK1419_28_L      0x141950
#define REG_BK1419_28_H      0x141951
#define REG_BK1419_29_L      0x141952
#define REG_BK1419_29_H      0x141953
#define REG_BK1419_2A_L      0x141954
#define REG_BK1419_2A_H      0x141955
#define REG_BK1419_2B_L      0x141956
#define REG_BK1419_2B_H      0x141957
#define REG_BK1419_2C_L      0x141958
#define REG_BK1419_2C_H      0x141959
#define REG_BK1419_2D_L      0x14195A
#define REG_BK1419_2D_H      0x14195B
#define REG_BK1419_2E_L      0x14195C
#define REG_BK1419_2E_H      0x14195D
#define REG_BK1419_2F_L      0x14195E
#define REG_BK1419_2F_H      0x14195F
#define REG_BK1419_30_L      0x141960
#define REG_BK1419_30_H      0x141961
#define REG_BK1419_31_L      0x141962
#define REG_BK1419_31_H      0x141963
#define REG_BK1419_32_L      0x141964
#define REG_BK1419_32_H      0x141965
#define REG_BK1419_33_L      0x141966
#define REG_BK1419_33_H      0x141967
#define REG_BK1419_34_L      0x141968
#define REG_BK1419_34_H      0x141969
#define REG_BK1419_35_L      0x14196A
#define REG_BK1419_35_H      0x14196B
#define REG_BK1419_36_L      0x14196C
#define REG_BK1419_36_H      0x14196D
#define REG_BK1419_37_L      0x14196E
#define REG_BK1419_37_H      0x14196F
#define REG_BK1419_38_L      0x141970
#define REG_BK1419_38_H      0x141971
#define REG_BK1419_39_L      0x141972
#define REG_BK1419_39_H      0x141973
#define REG_BK1419_3A_L      0x141974
#define REG_BK1419_3A_H      0x141975
#define REG_BK1419_3B_L      0x141976
#define REG_BK1419_3B_H      0x141977
#define REG_BK1419_3C_L      0x141978
#define REG_BK1419_3C_H      0x141979
#define REG_BK1419_3D_L      0x14197A
#define REG_BK1419_3D_H      0x14197B
#define REG_BK1419_3E_L      0x14197C
#define REG_BK1419_3E_H      0x14197D
#define REG_BK1419_3F_L      0x14197E
#define REG_BK1419_3F_H      0x14197F
#define REG_BK1419_40_L      0x141980
#define REG_BK1419_40_H      0x141981
#define REG_BK1419_41_L      0x141982
#define REG_BK1419_41_H      0x141983
#define REG_BK1419_42_L      0x141984
#define REG_BK1419_42_H      0x141985
#define REG_BK1419_43_L      0x141986
#define REG_BK1419_43_H      0x141987
#define REG_BK1419_44_L      0x141988
#define REG_BK1419_44_H      0x141989
#define REG_BK1419_45_L      0x14198A
#define REG_BK1419_45_H      0x14198B
#define REG_BK1419_46_L      0x14198C
#define REG_BK1419_46_H      0x14198D
#define REG_BK1419_47_L      0x14198E
#define REG_BK1419_47_H      0x14198F
#define REG_BK1419_48_L      0x141990
#define REG_BK1419_48_H      0x141991
#define REG_BK1419_49_L      0x141992
#define REG_BK1419_49_H      0x141993
#define REG_BK1419_4A_L      0x141994
#define REG_BK1419_4A_H      0x141995
#define REG_BK1419_4B_L      0x141996
#define REG_BK1419_4B_H      0x141997
#define REG_BK1419_4C_L      0x141998
#define REG_BK1419_4C_H      0x141999
#define REG_BK1419_4D_L      0x14199A
#define REG_BK1419_4D_H      0x14199B
#define REG_BK1419_4E_L      0x14199C
#define REG_BK1419_4E_H      0x14199D
#define REG_BK1419_4F_L      0x14199E
#define REG_BK1419_4F_H      0x14199F
#define REG_BK1419_50_L      0x1419A0
#define REG_BK1419_50_H      0x1419A1
#define REG_BK1419_51_L      0x1419A2
#define REG_BK1419_51_H      0x1419A3
#define REG_BK1419_52_L      0x1419A4
#define REG_BK1419_52_H      0x1419A5
#define REG_BK1419_53_L      0x1419A6
#define REG_BK1419_53_H      0x1419A7
#define REG_BK1419_54_L      0x1419A8
#define REG_BK1419_54_H      0x1419A9
#define REG_BK1419_55_L      0x1419AA
#define REG_BK1419_55_H      0x1419AB
#define REG_BK1419_56_L      0x1419AC
#define REG_BK1419_56_H      0x1419AD
#define REG_BK1419_57_L      0x1419AE
#define REG_BK1419_57_H      0x1419AF
#define REG_BK1419_58_L      0x1419B0
#define REG_BK1419_58_H      0x1419B1
#define REG_BK1419_59_L      0x1419B2
#define REG_BK1419_59_H      0x1419B3
#define REG_BK1419_5A_L      0x1419B4
#define REG_BK1419_5A_H      0x1419B5
#define REG_BK1419_5B_L      0x1419B6
#define REG_BK1419_5B_H      0x1419B7
#define REG_BK1419_5C_L      0x1419B8
#define REG_BK1419_5C_H      0x1419B9
#define REG_BK1419_5D_L      0x1419BA
#define REG_BK1419_5D_H      0x1419BB
#define REG_BK1419_5E_L      0x1419BC
#define REG_BK1419_5E_H      0x1419BD
#define REG_BK1419_5F_L      0x1419BE
#define REG_BK1419_5F_H      0x1419BF
#define REG_BK1419_60_L      0x1419C0
#define REG_BK1419_60_H      0x1419C1
#define REG_BK1419_61_L      0x1419C2
#define REG_BK1419_61_H      0x1419C3
#define REG_BK1419_62_L      0x1419C4
#define REG_BK1419_62_H      0x1419C5
#define REG_BK1419_63_L      0x1419C6
#define REG_BK1419_63_H      0x1419C7
#define REG_BK1419_64_L      0x1419C8
#define REG_BK1419_64_H      0x1419C9
#define REG_BK1419_65_L      0x1419CA
#define REG_BK1419_65_H      0x1419CB
#define REG_BK1419_66_L      0x1419CC
#define REG_BK1419_66_H      0x1419CD
#define REG_BK1419_67_L      0x1419CE
#define REG_BK1419_67_H      0x1419CF
#define REG_BK1419_68_L      0x1419D0
#define REG_BK1419_68_H      0x1419D1
#define REG_BK1419_69_L      0x1419D2
#define REG_BK1419_69_H      0x1419D3
#define REG_BK1419_6A_L      0x1419D4
#define REG_BK1419_6A_H      0x1419D5
#define REG_BK1419_6B_L      0x1419D6
#define REG_BK1419_6B_H      0x1419D7
#define REG_BK1419_6C_L      0x1419D8
#define REG_BK1419_6C_H      0x1419D9
#define REG_BK1419_6D_L      0x1419DA
#define REG_BK1419_6D_H      0x1419DB
#define REG_BK1419_6E_L      0x1419DC
#define REG_BK1419_6E_H      0x1419DD
#define REG_BK1419_6F_L      0x1419DE
#define REG_BK1419_6F_H      0x1419DF
#define REG_BK1419_70_L      0x1419E0
#define REG_BK1419_70_H      0x1419E1
#define REG_BK1419_71_L      0x1419E2
#define REG_BK1419_71_H      0x1419E3
#define REG_BK1419_72_L      0x1419E4
#define REG_BK1419_72_H      0x1419E5
#define REG_BK1419_73_L      0x1419E6
#define REG_BK1419_73_H      0x1419E7
#define REG_BK1419_74_L      0x1419E8
#define REG_BK1419_74_H      0x1419E9
#define REG_BK1419_75_L      0x1419EA
#define REG_BK1419_75_H      0x1419EB
#define REG_BK1419_76_L      0x1419EC
#define REG_BK1419_76_H      0x1419ED
#define REG_BK1419_77_L      0x1419EE
#define REG_BK1419_77_H      0x1419EF
#define REG_BK1419_78_L      0x1419F0
#define REG_BK1419_78_H      0x1419F1
#define REG_BK1419_79_L      0x1419F2
#define REG_BK1419_79_H      0x1419F3
#define REG_BK1419_7A_L      0x1419F4
#define REG_BK1419_7A_H      0x1419F5
#define REG_BK1419_7B_L      0x1419F6
#define REG_BK1419_7B_H      0x1419F7
#define REG_BK1419_7C_L      0x1419F8
#define REG_BK1419_7C_H      0x1419F9
#define REG_BK1419_7D_L      0x1419FA
#define REG_BK1419_7D_H      0x1419FB
#define REG_BK1419_7E_L      0x1419FC
#define REG_BK1419_7E_H      0x1419FD
#define REG_BK1419_7F_L      0x1419FE
#define REG_BK1419_7F_H      0x1419FF
//----------------------------------------------
#define REG_BK141A_00_L      0x141A00
#define REG_BK141A_00_H      0x141A01
#define REG_BK141A_01_L      0x141A02
#define REG_BK141A_01_H      0x141A03
#define REG_BK141A_02_L      0x141A04
#define REG_BK141A_02_H      0x141A05
#define REG_BK141A_03_L      0x141A06
#define REG_BK141A_03_H      0x141A07
#define REG_BK141A_04_L      0x141A08
#define REG_BK141A_04_H      0x141A09
#define REG_BK141A_05_L      0x141A0A
#define REG_BK141A_05_H      0x141A0B
#define REG_BK141A_06_L      0x141A0C
#define REG_BK141A_06_H      0x141A0D
#define REG_BK141A_07_L      0x141A0E
#define REG_BK141A_07_H      0x141A0F
#define REG_BK141A_08_L      0x141A10
#define REG_BK141A_08_H      0x141A11
#define REG_BK141A_09_L      0x141A12
#define REG_BK141A_09_H      0x141A13
#define REG_BK141A_0A_L      0x141A14
#define REG_BK141A_0A_H      0x141A15
#define REG_BK141A_0B_L      0x141A16
#define REG_BK141A_0B_H      0x141A17
#define REG_BK141A_0C_L      0x141A18
#define REG_BK141A_0C_H      0x141A19
#define REG_BK141A_0D_L      0x141A1A
#define REG_BK141A_0D_H      0x141A1B
#define REG_BK141A_0E_L      0x141A1C
#define REG_BK141A_0E_H      0x141A1D
#define REG_BK141A_0F_L      0x141A1E
#define REG_BK141A_0F_H      0x141A1F
#define REG_BK141A_10_L      0x141A20
#define REG_BK141A_10_H      0x141A21
#define REG_BK141A_11_L      0x141A22
#define REG_BK141A_11_H      0x141A23
#define REG_BK141A_12_L      0x141A24
#define REG_BK141A_12_H      0x141A25
#define REG_BK141A_13_L      0x141A26
#define REG_BK141A_13_H      0x141A27
#define REG_BK141A_14_L      0x141A28
#define REG_BK141A_14_H      0x141A29
#define REG_BK141A_15_L      0x141A2A
#define REG_BK141A_15_H      0x141A2B
#define REG_BK141A_16_L      0x141A2C
#define REG_BK141A_16_H      0x141A2D
#define REG_BK141A_17_L      0x141A2E
#define REG_BK141A_17_H      0x141A2F
#define REG_BK141A_18_L      0x141A30
#define REG_BK141A_18_H      0x141A31
#define REG_BK141A_19_L      0x141A32
#define REG_BK141A_19_H      0x141A33
#define REG_BK141A_1A_L      0x141A34
#define REG_BK141A_1A_H      0x141A35
#define REG_BK141A_1B_L      0x141A36
#define REG_BK141A_1B_H      0x141A37
#define REG_BK141A_1C_L      0x141A38
#define REG_BK141A_1C_H      0x141A39
#define REG_BK141A_1D_L      0x141A3A
#define REG_BK141A_1D_H      0x141A3B
#define REG_BK141A_1E_L      0x141A3C
#define REG_BK141A_1E_H      0x141A3D
#define REG_BK141A_1F_L      0x141A3E
#define REG_BK141A_1F_H      0x141A3F
#define REG_BK141A_20_L      0x141A40
#define REG_BK141A_20_H      0x141A41
#define REG_BK141A_21_L      0x141A42
#define REG_BK141A_21_H      0x141A43
#define REG_BK141A_22_L      0x141A44
#define REG_BK141A_22_H      0x141A45
#define REG_BK141A_23_L      0x141A46
#define REG_BK141A_23_H      0x141A47
#define REG_BK141A_24_L      0x141A48
#define REG_BK141A_24_H      0x141A49
#define REG_BK141A_25_L      0x141A4A
#define REG_BK141A_25_H      0x141A4B
#define REG_BK141A_26_L      0x141A4C
#define REG_BK141A_26_H      0x141A4D
#define REG_BK141A_27_L      0x141A4E
#define REG_BK141A_27_H      0x141A4F
#define REG_BK141A_28_L      0x141A50
#define REG_BK141A_28_H      0x141A51
#define REG_BK141A_29_L      0x141A52
#define REG_BK141A_29_H      0x141A53
#define REG_BK141A_2A_L      0x141A54
#define REG_BK141A_2A_H      0x141A55
#define REG_BK141A_2B_L      0x141A56
#define REG_BK141A_2B_H      0x141A57
#define REG_BK141A_2C_L      0x141A58
#define REG_BK141A_2C_H      0x141A59
#define REG_BK141A_2D_L      0x141A5A
#define REG_BK141A_2D_H      0x141A5B
#define REG_BK141A_2E_L      0x141A5C
#define REG_BK141A_2E_H      0x141A5D
#define REG_BK141A_2F_L      0x141A5E
#define REG_BK141A_2F_H      0x141A5F
#define REG_BK141A_30_L      0x141A60
#define REG_BK141A_30_H      0x141A61
#define REG_BK141A_31_L      0x141A62
#define REG_BK141A_31_H      0x141A63
#define REG_BK141A_32_L      0x141A64
#define REG_BK141A_32_H      0x141A65
#define REG_BK141A_33_L      0x141A66
#define REG_BK141A_33_H      0x141A67
#define REG_BK141A_34_L      0x141A68
#define REG_BK141A_34_H      0x141A69
#define REG_BK141A_35_L      0x141A6A
#define REG_BK141A_35_H      0x141A6B
#define REG_BK141A_36_L      0x141A6C
#define REG_BK141A_36_H      0x141A6D
#define REG_BK141A_37_L      0x141A6E
#define REG_BK141A_37_H      0x141A6F
#define REG_BK141A_38_L      0x141A70
#define REG_BK141A_38_H      0x141A71
#define REG_BK141A_39_L      0x141A72
#define REG_BK141A_39_H      0x141A73
#define REG_BK141A_3A_L      0x141A74
#define REG_BK141A_3A_H      0x141A75
#define REG_BK141A_3B_L      0x141A76
#define REG_BK141A_3B_H      0x141A77
#define REG_BK141A_3C_L      0x141A78
#define REG_BK141A_3C_H      0x141A79
#define REG_BK141A_3D_L      0x141A7A
#define REG_BK141A_3D_H      0x141A7B
#define REG_BK141A_3E_L      0x141A7C
#define REG_BK141A_3E_H      0x141A7D
#define REG_BK141A_3F_L      0x141A7E
#define REG_BK141A_3F_H      0x141A7F
#define REG_BK141A_40_L      0x141A80
#define REG_BK141A_40_H      0x141A81
#define REG_BK141A_41_L      0x141A82
#define REG_BK141A_41_H      0x141A83
#define REG_BK141A_42_L      0x141A84
#define REG_BK141A_42_H      0x141A85
#define REG_BK141A_43_L      0x141A86
#define REG_BK141A_43_H      0x141A87
#define REG_BK141A_44_L      0x141A88
#define REG_BK141A_44_H      0x141A89
#define REG_BK141A_45_L      0x141A8A
#define REG_BK141A_45_H      0x141A8B
#define REG_BK141A_46_L      0x141A8C
#define REG_BK141A_46_H      0x141A8D
#define REG_BK141A_47_L      0x141A8E
#define REG_BK141A_47_H      0x141A8F
#define REG_BK141A_48_L      0x141A90
#define REG_BK141A_48_H      0x141A91
#define REG_BK141A_49_L      0x141A92
#define REG_BK141A_49_H      0x141A93
#define REG_BK141A_4A_L      0x141A94
#define REG_BK141A_4A_H      0x141A95
#define REG_BK141A_4B_L      0x141A96
#define REG_BK141A_4B_H      0x141A97
#define REG_BK141A_4C_L      0x141A98
#define REG_BK141A_4C_H      0x141A99
#define REG_BK141A_4D_L      0x141A9A
#define REG_BK141A_4D_H      0x141A9B
#define REG_BK141A_4E_L      0x141A9C
#define REG_BK141A_4E_H      0x141A9D
#define REG_BK141A_4F_L      0x141A9E
#define REG_BK141A_4F_H      0x141A9F
#define REG_BK141A_50_L      0x141AA0
#define REG_BK141A_50_H      0x141AA1
#define REG_BK141A_51_L      0x141AA2
#define REG_BK141A_51_H      0x141AA3
#define REG_BK141A_52_L      0x141AA4
#define REG_BK141A_52_H      0x141AA5
#define REG_BK141A_53_L      0x141AA6
#define REG_BK141A_53_H      0x141AA7
#define REG_BK141A_54_L      0x141AA8
#define REG_BK141A_54_H      0x141AA9
#define REG_BK141A_55_L      0x141AAA
#define REG_BK141A_55_H      0x141AAB
#define REG_BK141A_56_L      0x141AAC
#define REG_BK141A_56_H      0x141AAD
#define REG_BK141A_57_L      0x141AAE
#define REG_BK141A_57_H      0x141AAF
#define REG_BK141A_58_L      0x141AB0
#define REG_BK141A_58_H      0x141AB1
#define REG_BK141A_59_L      0x141AB2
#define REG_BK141A_59_H      0x141AB3
#define REG_BK141A_5A_L      0x141AB4
#define REG_BK141A_5A_H      0x141AB5
#define REG_BK141A_5B_L      0x141AB6
#define REG_BK141A_5B_H      0x141AB7
#define REG_BK141A_5C_L      0x141AB8
#define REG_BK141A_5C_H      0x141AB9
#define REG_BK141A_5D_L      0x141ABA
#define REG_BK141A_5D_H      0x141ABB
#define REG_BK141A_5E_L      0x141ABC
#define REG_BK141A_5E_H      0x141ABD
#define REG_BK141A_5F_L      0x141ABE
#define REG_BK141A_5F_H      0x141ABF
#define REG_BK141A_60_L      0x141AC0
#define REG_BK141A_60_H      0x141AC1
#define REG_BK141A_61_L      0x141AC2
#define REG_BK141A_61_H      0x141AC3
#define REG_BK141A_62_L      0x141AC4
#define REG_BK141A_62_H      0x141AC5
#define REG_BK141A_63_L      0x141AC6
#define REG_BK141A_63_H      0x141AC7
#define REG_BK141A_64_L      0x141AC8
#define REG_BK141A_64_H      0x141AC9
#define REG_BK141A_65_L      0x141ACA
#define REG_BK141A_65_H      0x141ACB
#define REG_BK141A_66_L      0x141ACC
#define REG_BK141A_66_H      0x141ACD
#define REG_BK141A_67_L      0x141ACE
#define REG_BK141A_67_H      0x141ACF
#define REG_BK141A_68_L      0x141AD0
#define REG_BK141A_68_H      0x141AD1
#define REG_BK141A_69_L      0x141AD2
#define REG_BK141A_69_H      0x141AD3
#define REG_BK141A_6A_L      0x141AD4
#define REG_BK141A_6A_H      0x141AD5
#define REG_BK141A_6B_L      0x141AD6
#define REG_BK141A_6B_H      0x141AD7
#define REG_BK141A_6C_L      0x141AD8
#define REG_BK141A_6C_H      0x141AD9
#define REG_BK141A_6D_L      0x141ADA
#define REG_BK141A_6D_H      0x141ADB
#define REG_BK141A_6E_L      0x141ADC
#define REG_BK141A_6E_H      0x141ADD
#define REG_BK141A_6F_L      0x141ADE
#define REG_BK141A_6F_H      0x141ADF
#define REG_BK141A_70_L      0x141AE0
#define REG_BK141A_70_H      0x141AE1
#define REG_BK141A_71_L      0x141AE2
#define REG_BK141A_71_H      0x141AE3
#define REG_BK141A_72_L      0x141AE4
#define REG_BK141A_72_H      0x141AE5
#define REG_BK141A_73_L      0x141AE6
#define REG_BK141A_73_H      0x141AE7
#define REG_BK141A_74_L      0x141AE8
#define REG_BK141A_74_H      0x141AE9
#define REG_BK141A_75_L      0x141AEA
#define REG_BK141A_75_H      0x141AEB
#define REG_BK141A_76_L      0x141AEC
#define REG_BK141A_76_H      0x141AED
#define REG_BK141A_77_L      0x141AEE
#define REG_BK141A_77_H      0x141AEF
#define REG_BK141A_78_L      0x141AF0
#define REG_BK141A_78_H      0x141AF1
#define REG_BK141A_79_L      0x141AF2
#define REG_BK141A_79_H      0x141AF3
#define REG_BK141A_7A_L      0x141AF4
#define REG_BK141A_7A_H      0x141AF5
#define REG_BK141A_7B_L      0x141AF6
#define REG_BK141A_7B_H      0x141AF7
#define REG_BK141A_7C_L      0x141AF8
#define REG_BK141A_7C_H      0x141AF9
#define REG_BK141A_7D_L      0x141AFA
#define REG_BK141A_7D_H      0x141AFB
#define REG_BK141A_7E_L      0x141AFC
#define REG_BK141A_7E_H      0x141AFD
#define REG_BK141A_7F_L      0x141AFE
#define REG_BK141A_7F_H      0x141AFF
//----------------------------------------------
#define REG_BK141C_00_L      0x141C00
#define REG_BK141C_00_H      0x141C01
#define REG_BK141C_01_L      0x141C02
#define REG_BK141C_01_H      0x141C03
#define REG_BK141C_02_L      0x141C04
#define REG_BK141C_02_H      0x141C05
#define REG_BK141C_03_L      0x141C06
#define REG_BK141C_03_H      0x141C07
#define REG_BK141C_04_L      0x141C08
#define REG_BK141C_04_H      0x141C09
#define REG_BK141C_05_L      0x141C0A
#define REG_BK141C_05_H      0x141C0B
#define REG_BK141C_06_L      0x141C0C
#define REG_BK141C_06_H      0x141C0D
#define REG_BK141C_07_L      0x141C0E
#define REG_BK141C_07_H      0x141C0F
#define REG_BK141C_08_L      0x141C10
#define REG_BK141C_08_H      0x141C11
#define REG_BK141C_09_L      0x141C12
#define REG_BK141C_09_H      0x141C13
#define REG_BK141C_0A_L      0x141C14
#define REG_BK141C_0A_H      0x141C15
#define REG_BK141C_0B_L      0x141C16
#define REG_BK141C_0B_H      0x141C17
#define REG_BK141C_0C_L      0x141C18
#define REG_BK141C_0C_H      0x141C19
#define REG_BK141C_0D_L      0x141C1A
#define REG_BK141C_0D_H      0x141C1B
#define REG_BK141C_0E_L      0x141C1C
#define REG_BK141C_0E_H      0x141C1D
#define REG_BK141C_0F_L      0x141C1E
#define REG_BK141C_0F_H      0x141C1F
#define REG_BK141C_10_L      0x141C20
#define REG_BK141C_10_H      0x141C21
#define REG_BK141C_11_L      0x141C22
#define REG_BK141C_11_H      0x141C23
#define REG_BK141C_12_L      0x141C24
#define REG_BK141C_12_H      0x141C25
#define REG_BK141C_13_L      0x141C26
#define REG_BK141C_13_H      0x141C27
#define REG_BK141C_14_L      0x141C28
#define REG_BK141C_14_H      0x141C29
#define REG_BK141C_15_L      0x141C2A
#define REG_BK141C_15_H      0x141C2B
#define REG_BK141C_16_L      0x141C2C
#define REG_BK141C_16_H      0x141C2D
#define REG_BK141C_17_L      0x141C2E
#define REG_BK141C_17_H      0x141C2F
#define REG_BK141C_18_L      0x141C30
#define REG_BK141C_18_H      0x141C31
#define REG_BK141C_19_L      0x141C32
#define REG_BK141C_19_H      0x141C33
#define REG_BK141C_1A_L      0x141C34
#define REG_BK141C_1A_H      0x141C35
#define REG_BK141C_1B_L      0x141C36
#define REG_BK141C_1B_H      0x141C37
#define REG_BK141C_1C_L      0x141C38
#define REG_BK141C_1C_H      0x141C39
#define REG_BK141C_1D_L      0x141C3A
#define REG_BK141C_1D_H      0x141C3B
#define REG_BK141C_1E_L      0x141C3C
#define REG_BK141C_1E_H      0x141C3D
#define REG_BK141C_1F_L      0x141C3E
#define REG_BK141C_1F_H      0x141C3F
#define REG_BK141C_20_L      0x141C40
#define REG_BK141C_20_H      0x141C41
#define REG_BK141C_21_L      0x141C42
#define REG_BK141C_21_H      0x141C43
#define REG_BK141C_22_L      0x141C44
#define REG_BK141C_22_H      0x141C45
#define REG_BK141C_23_L      0x141C46
#define REG_BK141C_23_H      0x141C47
#define REG_BK141C_24_L      0x141C48
#define REG_BK141C_24_H      0x141C49
#define REG_BK141C_25_L      0x141C4A
#define REG_BK141C_25_H      0x141C4B
#define REG_BK141C_26_L      0x141C4C
#define REG_BK141C_26_H      0x141C4D
#define REG_BK141C_27_L      0x141C4E
#define REG_BK141C_27_H      0x141C4F
#define REG_BK141C_28_L      0x141C50
#define REG_BK141C_28_H      0x141C51
#define REG_BK141C_29_L      0x141C52
#define REG_BK141C_29_H      0x141C53
#define REG_BK141C_2A_L      0x141C54
#define REG_BK141C_2A_H      0x141C55
#define REG_BK141C_2B_L      0x141C56
#define REG_BK141C_2B_H      0x141C57
#define REG_BK141C_2C_L      0x141C58
#define REG_BK141C_2C_H      0x141C59
#define REG_BK141C_2D_L      0x141C5A
#define REG_BK141C_2D_H      0x141C5B
#define REG_BK141C_2E_L      0x141C5C
#define REG_BK141C_2E_H      0x141C5D
#define REG_BK141C_2F_L      0x141C5E
#define REG_BK141C_2F_H      0x141C5F
#define REG_BK141C_30_L      0x141C60
#define REG_BK141C_30_H      0x141C61
#define REG_BK141C_31_L      0x141C62
#define REG_BK141C_31_H      0x141C63
#define REG_BK141C_32_L      0x141C64
#define REG_BK141C_32_H      0x141C65
#define REG_BK141C_33_L      0x141C66
#define REG_BK141C_33_H      0x141C67
#define REG_BK141C_34_L      0x141C68
#define REG_BK141C_34_H      0x141C69
#define REG_BK141C_35_L      0x141C6A
#define REG_BK141C_35_H      0x141C6B
#define REG_BK141C_36_L      0x141C6C
#define REG_BK141C_36_H      0x141C6D
#define REG_BK141C_37_L      0x141C6E
#define REG_BK141C_37_H      0x141C6F
#define REG_BK141C_38_L      0x141C70
#define REG_BK141C_38_H      0x141C71
#define REG_BK141C_39_L      0x141C72
#define REG_BK141C_39_H      0x141C73
#define REG_BK141C_3A_L      0x141C74
#define REG_BK141C_3A_H      0x141C75
#define REG_BK141C_3B_L      0x141C76
#define REG_BK141C_3B_H      0x141C77
#define REG_BK141C_3C_L      0x141C78
#define REG_BK141C_3C_H      0x141C79
#define REG_BK141C_3D_L      0x141C7A
#define REG_BK141C_3D_H      0x141C7B
#define REG_BK141C_3E_L      0x141C7C
#define REG_BK141C_3E_H      0x141C7D
#define REG_BK141C_3F_L      0x141C7E
#define REG_BK141C_3F_H      0x141C7F
#define REG_BK141C_40_L      0x141C80
#define REG_BK141C_40_H      0x141C81
#define REG_BK141C_41_L      0x141C82
#define REG_BK141C_41_H      0x141C83
#define REG_BK141C_42_L      0x141C84
#define REG_BK141C_42_H      0x141C85
#define REG_BK141C_43_L      0x141C86
#define REG_BK141C_43_H      0x141C87
#define REG_BK141C_44_L      0x141C88
#define REG_BK141C_44_H      0x141C89
#define REG_BK141C_45_L      0x141C8A
#define REG_BK141C_45_H      0x141C8B
#define REG_BK141C_46_L      0x141C8C
#define REG_BK141C_46_H      0x141C8D
#define REG_BK141C_47_L      0x141C8E
#define REG_BK141C_47_H      0x141C8F
#define REG_BK141C_48_L      0x141C90
#define REG_BK141C_48_H      0x141C91
#define REG_BK141C_49_L      0x141C92
#define REG_BK141C_49_H      0x141C93
#define REG_BK141C_4A_L      0x141C94
#define REG_BK141C_4A_H      0x141C95
#define REG_BK141C_4B_L      0x141C96
#define REG_BK141C_4B_H      0x141C97
#define REG_BK141C_4C_L      0x141C98
#define REG_BK141C_4C_H      0x141C99
#define REG_BK141C_4D_L      0x141C9A
#define REG_BK141C_4D_H      0x141C9B
#define REG_BK141C_4E_L      0x141C9C
#define REG_BK141C_4E_H      0x141C9D
#define REG_BK141C_4F_L      0x141C9E
#define REG_BK141C_4F_H      0x141C9F
#define REG_BK141C_50_L      0x141CA0
#define REG_BK141C_50_H      0x141CA1
#define REG_BK141C_51_L      0x141CA2
#define REG_BK141C_51_H      0x141CA3
#define REG_BK141C_52_L      0x141CA4
#define REG_BK141C_52_H      0x141CA5
#define REG_BK141C_53_L      0x141CA6
#define REG_BK141C_53_H      0x141CA7
#define REG_BK141C_54_L      0x141CA8
#define REG_BK141C_54_H      0x141CA9
#define REG_BK141C_55_L      0x141CAA
#define REG_BK141C_55_H      0x141CAB
#define REG_BK141C_56_L      0x141CAC
#define REG_BK141C_56_H      0x141CAD
#define REG_BK141C_57_L      0x141CAE
#define REG_BK141C_57_H      0x141CAF
#define REG_BK141C_58_L      0x141CB0
#define REG_BK141C_58_H      0x141CB1
#define REG_BK141C_59_L      0x141CB2
#define REG_BK141C_59_H      0x141CB3
#define REG_BK141C_5A_L      0x141CB4
#define REG_BK141C_5A_H      0x141CB5
#define REG_BK141C_5B_L      0x141CB6
#define REG_BK141C_5B_H      0x141CB7
#define REG_BK141C_5C_L      0x141CB8
#define REG_BK141C_5C_H      0x141CB9
#define REG_BK141C_5D_L      0x141CBA
#define REG_BK141C_5D_H      0x141CBB
#define REG_BK141C_5E_L      0x141CBC
#define REG_BK141C_5E_H      0x141CBD
#define REG_BK141C_5F_L      0x141CBE
#define REG_BK141C_5F_H      0x141CBF
#define REG_BK141C_60_L      0x141CC0
#define REG_BK141C_60_H      0x141CC1
#define REG_BK141C_61_L      0x141CC2
#define REG_BK141C_61_H      0x141CC3
#define REG_BK141C_62_L      0x141CC4
#define REG_BK141C_62_H      0x141CC5
#define REG_BK141C_63_L      0x141CC6
#define REG_BK141C_63_H      0x141CC7
#define REG_BK141C_64_L      0x141CC8
#define REG_BK141C_64_H      0x141CC9
#define REG_BK141C_65_L      0x141CCA
#define REG_BK141C_65_H      0x141CCB
#define REG_BK141C_66_L      0x141CCC
#define REG_BK141C_66_H      0x141CCD
#define REG_BK141C_67_L      0x141CCE
#define REG_BK141C_67_H      0x141CCF
#define REG_BK141C_68_L      0x141CD0
#define REG_BK141C_68_H      0x141CD1
#define REG_BK141C_69_L      0x141CD2
#define REG_BK141C_69_H      0x141CD3
#define REG_BK141C_6A_L      0x141CD4
#define REG_BK141C_6A_H      0x141CD5
#define REG_BK141C_6B_L      0x141CD6
#define REG_BK141C_6B_H      0x141CD7
#define REG_BK141C_6C_L      0x141CD8
#define REG_BK141C_6C_H      0x141CD9
#define REG_BK141C_6D_L      0x141CDA
#define REG_BK141C_6D_H      0x141CDB
#define REG_BK141C_6E_L      0x141CDC
#define REG_BK141C_6E_H      0x141CDD
#define REG_BK141C_6F_L      0x141CDE
#define REG_BK141C_6F_H      0x141CDF
#define REG_BK141C_70_L      0x141CE0
#define REG_BK141C_70_H      0x141CE1
#define REG_BK141C_71_L      0x141CE2
#define REG_BK141C_71_H      0x141CE3
#define REG_BK141C_72_L      0x141CE4
#define REG_BK141C_72_H      0x141CE5
#define REG_BK141C_73_L      0x141CE6
#define REG_BK141C_73_H      0x141CE7
#define REG_BK141C_74_L      0x141CE8
#define REG_BK141C_74_H      0x141CE9
#define REG_BK141C_75_L      0x141CEA
#define REG_BK141C_75_H      0x141CEB
#define REG_BK141C_76_L      0x141CEC
#define REG_BK141C_76_H      0x141CED
#define REG_BK141C_77_L      0x141CEE
#define REG_BK141C_77_H      0x141CEF
#define REG_BK141C_78_L      0x141CF0
#define REG_BK141C_78_H      0x141CF1
#define REG_BK141C_79_L      0x141CF2
#define REG_BK141C_79_H      0x141CF3
#define REG_BK141C_7A_L      0x141CF4
#define REG_BK141C_7A_H      0x141CF5
#define REG_BK141C_7B_L      0x141CF6
#define REG_BK141C_7B_H      0x141CF7
#define REG_BK141C_7C_L      0x141CF8
#define REG_BK141C_7C_H      0x141CF9
#define REG_BK141C_7D_L      0x141CFA
#define REG_BK141C_7D_H      0x141CFB
#define REG_BK141C_7E_L      0x141CFC
#define REG_BK141C_7E_H      0x141CFD
#define REG_BK141C_7F_L      0x141CFE
#define REG_BK141C_7F_H      0x141CFF
//----------------------------------------------
#define REG_BK1423_00_L      0x142300
#define REG_BK1423_00_H      0x142301
#define REG_BK1423_01_L      0x142302
#define REG_BK1423_01_H      0x142303
#define REG_BK1423_02_L      0x142304
#define REG_BK1423_02_H      0x142305
#define REG_BK1423_03_L      0x142306
#define REG_BK1423_03_H      0x142307
#define REG_BK1423_04_L      0x142308
#define REG_BK1423_04_H      0x142309
#define REG_BK1423_05_L      0x14230A
#define REG_BK1423_05_H      0x14230B
#define REG_BK1423_06_L      0x14230C
#define REG_BK1423_06_H      0x14230D
#define REG_BK1423_07_L      0x14230E
#define REG_BK1423_07_H      0x14230F
#define REG_BK1423_08_L      0x142310
#define REG_BK1423_08_H      0x142311
#define REG_BK1423_09_L      0x142312
#define REG_BK1423_09_H      0x142313
#define REG_BK1423_0A_L      0x142314
#define REG_BK1423_0A_H      0x142315
#define REG_BK1423_0B_L      0x142316
#define REG_BK1423_0B_H      0x142317
#define REG_BK1423_0C_L      0x142318
#define REG_BK1423_0C_H      0x142319
#define REG_BK1423_0D_L      0x14231A
#define REG_BK1423_0D_H      0x14231B
#define REG_BK1423_0E_L      0x14231C
#define REG_BK1423_0E_H      0x14231D
#define REG_BK1423_0F_L      0x14231E
#define REG_BK1423_0F_H      0x14231F
#define REG_BK1423_10_L      0x142320
#define REG_BK1423_10_H      0x142321
#define REG_BK1423_11_L      0x142322
#define REG_BK1423_11_H      0x142323
#define REG_BK1423_12_L      0x142324
#define REG_BK1423_12_H      0x142325
#define REG_BK1423_13_L      0x142326
#define REG_BK1423_13_H      0x142327
#define REG_BK1423_14_L      0x142328
#define REG_BK1423_14_H      0x142329
#define REG_BK1423_15_L      0x14232A
#define REG_BK1423_15_H      0x14232B
#define REG_BK1423_16_L      0x14232C
#define REG_BK1423_16_H      0x14232D
#define REG_BK1423_17_L      0x14232E
#define REG_BK1423_17_H      0x14232F
#define REG_BK1423_18_L      0x142330
#define REG_BK1423_18_H      0x142331
#define REG_BK1423_19_L      0x142332
#define REG_BK1423_19_H      0x142333
#define REG_BK1423_1A_L      0x142334
#define REG_BK1423_1A_H      0x142335
#define REG_BK1423_1B_L      0x142336
#define REG_BK1423_1B_H      0x142337
#define REG_BK1423_1C_L      0x142338
#define REG_BK1423_1C_H      0x142339
#define REG_BK1423_1D_L      0x14233A
#define REG_BK1423_1D_H      0x14233B
#define REG_BK1423_1E_L      0x14233C
#define REG_BK1423_1E_H      0x14233D
#define REG_BK1423_1F_L      0x14233E
#define REG_BK1423_1F_H      0x14233F
#define REG_BK1423_20_L      0x142340
#define REG_BK1423_20_H      0x142341
#define REG_BK1423_21_L      0x142342
#define REG_BK1423_21_H      0x142343
#define REG_BK1423_22_L      0x142344
#define REG_BK1423_22_H      0x142345
#define REG_BK1423_23_L      0x142346
#define REG_BK1423_23_H      0x142347
#define REG_BK1423_24_L      0x142348
#define REG_BK1423_24_H      0x142349
#define REG_BK1423_25_L      0x14234A
#define REG_BK1423_25_H      0x14234B
#define REG_BK1423_26_L      0x14234C
#define REG_BK1423_26_H      0x14234D
#define REG_BK1423_27_L      0x14234E
#define REG_BK1423_27_H      0x14234F
#define REG_BK1423_28_L      0x142350
#define REG_BK1423_28_H      0x142351
#define REG_BK1423_29_L      0x142352
#define REG_BK1423_29_H      0x142353
#define REG_BK1423_2A_L      0x142354
#define REG_BK1423_2A_H      0x142355
#define REG_BK1423_2B_L      0x142356
#define REG_BK1423_2B_H      0x142357
#define REG_BK1423_2C_L      0x142358
#define REG_BK1423_2C_H      0x142359
#define REG_BK1423_2D_L      0x14235A
#define REG_BK1423_2D_H      0x14235B
#define REG_BK1423_2E_L      0x14235C
#define REG_BK1423_2E_H      0x14235D
#define REG_BK1423_2F_L      0x14235E
#define REG_BK1423_2F_H      0x14235F
#define REG_BK1423_30_L      0x142360
#define REG_BK1423_30_H      0x142361
#define REG_BK1423_31_L      0x142362
#define REG_BK1423_31_H      0x142363
#define REG_BK1423_32_L      0x142364
#define REG_BK1423_32_H      0x142365
#define REG_BK1423_33_L      0x142366
#define REG_BK1423_33_H      0x142367
#define REG_BK1423_34_L      0x142368
#define REG_BK1423_34_H      0x142369
#define REG_BK1423_35_L      0x14236A
#define REG_BK1423_35_H      0x14236B
#define REG_BK1423_36_L      0x14236C
#define REG_BK1423_36_H      0x14236D
#define REG_BK1423_37_L      0x14236E
#define REG_BK1423_37_H      0x14236F
#define REG_BK1423_38_L      0x142370
#define REG_BK1423_38_H      0x142371
#define REG_BK1423_39_L      0x142372
#define REG_BK1423_39_H      0x142373
#define REG_BK1423_3A_L      0x142374
#define REG_BK1423_3A_H      0x142375
#define REG_BK1423_3B_L      0x142376
#define REG_BK1423_3B_H      0x142377
#define REG_BK1423_3C_L      0x142378
#define REG_BK1423_3C_H      0x142379
#define REG_BK1423_3D_L      0x14237A
#define REG_BK1423_3D_H      0x14237B
#define REG_BK1423_3E_L      0x14237C
#define REG_BK1423_3E_H      0x14237D
#define REG_BK1423_3F_L      0x14237E
#define REG_BK1423_3F_H      0x14237F
#define REG_BK1423_40_L      0x142380
#define REG_BK1423_40_H      0x142381
#define REG_BK1423_41_L      0x142382
#define REG_BK1423_41_H      0x142383
#define REG_BK1423_42_L      0x142384
#define REG_BK1423_42_H      0x142385
#define REG_BK1423_43_L      0x142386
#define REG_BK1423_43_H      0x142387
#define REG_BK1423_44_L      0x142388
#define REG_BK1423_44_H      0x142389
#define REG_BK1423_45_L      0x14238A
#define REG_BK1423_45_H      0x14238B
#define REG_BK1423_46_L      0x14238C
#define REG_BK1423_46_H      0x14238D
#define REG_BK1423_47_L      0x14238E
#define REG_BK1423_47_H      0x14238F
#define REG_BK1423_48_L      0x142390
#define REG_BK1423_48_H      0x142391
#define REG_BK1423_49_L      0x142392
#define REG_BK1423_49_H      0x142393
#define REG_BK1423_4A_L      0x142394
#define REG_BK1423_4A_H      0x142395
#define REG_BK1423_4B_L      0x142396
#define REG_BK1423_4B_H      0x142397
#define REG_BK1423_4C_L      0x142398
#define REG_BK1423_4C_H      0x142399
#define REG_BK1423_4D_L      0x14239A
#define REG_BK1423_4D_H      0x14239B
#define REG_BK1423_4E_L      0x14239C
#define REG_BK1423_4E_H      0x14239D
#define REG_BK1423_4F_L      0x14239E
#define REG_BK1423_4F_H      0x14239F
#define REG_BK1423_50_L      0x1423A0
#define REG_BK1423_50_H      0x1423A1
#define REG_BK1423_51_L      0x1423A2
#define REG_BK1423_51_H      0x1423A3
#define REG_BK1423_52_L      0x1423A4
#define REG_BK1423_52_H      0x1423A5
#define REG_BK1423_53_L      0x1423A6
#define REG_BK1423_53_H      0x1423A7
#define REG_BK1423_54_L      0x1423A8
#define REG_BK1423_54_H      0x1423A9
#define REG_BK1423_55_L      0x1423AA
#define REG_BK1423_55_H      0x1423AB
#define REG_BK1423_56_L      0x1423AC
#define REG_BK1423_56_H      0x1423AD
#define REG_BK1423_57_L      0x1423AE
#define REG_BK1423_57_H      0x1423AF
#define REG_BK1423_58_L      0x1423B0
#define REG_BK1423_58_H      0x1423B1
#define REG_BK1423_59_L      0x1423B2
#define REG_BK1423_59_H      0x1423B3
#define REG_BK1423_5A_L      0x1423B4
#define REG_BK1423_5A_H      0x1423B5
#define REG_BK1423_5B_L      0x1423B6
#define REG_BK1423_5B_H      0x1423B7
#define REG_BK1423_5C_L      0x1423B8
#define REG_BK1423_5C_H      0x1423B9
#define REG_BK1423_5D_L      0x1423BA
#define REG_BK1423_5D_H      0x1423BB
#define REG_BK1423_5E_L      0x1423BC
#define REG_BK1423_5E_H      0x1423BD
#define REG_BK1423_5F_L      0x1423BE
#define REG_BK1423_5F_H      0x1423BF
#define REG_BK1423_60_L      0x1423C0
#define REG_BK1423_60_H      0x1423C1
#define REG_BK1423_61_L      0x1423C2
#define REG_BK1423_61_H      0x1423C3
#define REG_BK1423_62_L      0x1423C4
#define REG_BK1423_62_H      0x1423C5
#define REG_BK1423_63_L      0x1423C6
#define REG_BK1423_63_H      0x1423C7
#define REG_BK1423_64_L      0x1423C8
#define REG_BK1423_64_H      0x1423C9
#define REG_BK1423_65_L      0x1423CA
#define REG_BK1423_65_H      0x1423CB
#define REG_BK1423_66_L      0x1423CC
#define REG_BK1423_66_H      0x1423CD
#define REG_BK1423_67_L      0x1423CE
#define REG_BK1423_67_H      0x1423CF
#define REG_BK1423_68_L      0x1423D0
#define REG_BK1423_68_H      0x1423D1
#define REG_BK1423_69_L      0x1423D2
#define REG_BK1423_69_H      0x1423D3
#define REG_BK1423_6A_L      0x1423D4
#define REG_BK1423_6A_H      0x1423D5
#define REG_BK1423_6B_L      0x1423D6
#define REG_BK1423_6B_H      0x1423D7
#define REG_BK1423_6C_L      0x1423D8
#define REG_BK1423_6C_H      0x1423D9
#define REG_BK1423_6D_L      0x1423DA
#define REG_BK1423_6D_H      0x1423DB
#define REG_BK1423_6E_L      0x1423DC
#define REG_BK1423_6E_H      0x1423DD
#define REG_BK1423_6F_L      0x1423DE
#define REG_BK1423_6F_H      0x1423DF
#define REG_BK1423_70_L      0x1423E0
#define REG_BK1423_70_H      0x1423E1
#define REG_BK1423_71_L      0x1423E2
#define REG_BK1423_71_H      0x1423E3
#define REG_BK1423_72_L      0x1423E4
#define REG_BK1423_72_H      0x1423E5
#define REG_BK1423_73_L      0x1423E6
#define REG_BK1423_73_H      0x1423E7
#define REG_BK1423_74_L      0x1423E8
#define REG_BK1423_74_H      0x1423E9
#define REG_BK1423_75_L      0x1423EA
#define REG_BK1423_75_H      0x1423EB
#define REG_BK1423_76_L      0x1423EC
#define REG_BK1423_76_H      0x1423ED
#define REG_BK1423_77_L      0x1423EE
#define REG_BK1423_77_H      0x1423EF
#define REG_BK1423_78_L      0x1423F0
#define REG_BK1423_78_H      0x1423F1
#define REG_BK1423_79_L      0x1423F2
#define REG_BK1423_79_H      0x1423F3
#define REG_BK1423_7A_L      0x1423F4
#define REG_BK1423_7A_H      0x1423F5
#define REG_BK1423_7B_L      0x1423F6
#define REG_BK1423_7B_H      0x1423F7
#define REG_BK1423_7C_L      0x1423F8
#define REG_BK1423_7C_H      0x1423F9
#define REG_BK1423_7D_L      0x1423FA
#define REG_BK1423_7D_H      0x1423FB
#define REG_BK1423_7E_L      0x1423FC
#define REG_BK1423_7E_H      0x1423FD
#define REG_BK1423_7F_L      0x1423FE
#define REG_BK1423_7F_H      0x1423FF
//----------------------------------------------
#define REG_BK1426_00_L      0x142600
#define REG_BK1426_00_H      0x142601
#define REG_BK1426_01_L      0x142602
#define REG_BK1426_01_H      0x142603
#define REG_BK1426_02_L      0x142604
#define REG_BK1426_02_H      0x142605
#define REG_BK1426_03_L      0x142606
#define REG_BK1426_03_H      0x142607
#define REG_BK1426_04_L      0x142608
#define REG_BK1426_04_H      0x142609
#define REG_BK1426_05_L      0x14260A
#define REG_BK1426_05_H      0x14260B
#define REG_BK1426_06_L      0x14260C
#define REG_BK1426_06_H      0x14260D
#define REG_BK1426_07_L      0x14260E
#define REG_BK1426_07_H      0x14260F
#define REG_BK1426_08_L      0x142610
#define REG_BK1426_08_H      0x142611
#define REG_BK1426_09_L      0x142612
#define REG_BK1426_09_H      0x142613
#define REG_BK1426_0A_L      0x142614
#define REG_BK1426_0A_H      0x142615
#define REG_BK1426_0B_L      0x142616
#define REG_BK1426_0B_H      0x142617
#define REG_BK1426_0C_L      0x142618
#define REG_BK1426_0C_H      0x142619
#define REG_BK1426_0D_L      0x14261A
#define REG_BK1426_0D_H      0x14261B
#define REG_BK1426_0E_L      0x14261C
#define REG_BK1426_0E_H      0x14261D
#define REG_BK1426_0F_L      0x14261E
#define REG_BK1426_0F_H      0x14261F
#define REG_BK1426_10_L      0x142620
#define REG_BK1426_10_H      0x142621
#define REG_BK1426_11_L      0x142622
#define REG_BK1426_11_H      0x142623
#define REG_BK1426_12_L      0x142624
#define REG_BK1426_12_H      0x142625
#define REG_BK1426_13_L      0x142626
#define REG_BK1426_13_H      0x142627
#define REG_BK1426_14_L      0x142628
#define REG_BK1426_14_H      0x142629
#define REG_BK1426_15_L      0x14262A
#define REG_BK1426_15_H      0x14262B
#define REG_BK1426_16_L      0x14262C
#define REG_BK1426_16_H      0x14262D
#define REG_BK1426_17_L      0x14262E
#define REG_BK1426_17_H      0x14262F
#define REG_BK1426_18_L      0x142630
#define REG_BK1426_18_H      0x142631
#define REG_BK1426_19_L      0x142632
#define REG_BK1426_19_H      0x142633
#define REG_BK1426_1A_L      0x142634
#define REG_BK1426_1A_H      0x142635
#define REG_BK1426_1B_L      0x142636
#define REG_BK1426_1B_H      0x142637
#define REG_BK1426_1C_L      0x142638
#define REG_BK1426_1C_H      0x142639
#define REG_BK1426_1D_L      0x14263A
#define REG_BK1426_1D_H      0x14263B
#define REG_BK1426_1E_L      0x14263C
#define REG_BK1426_1E_H      0x14263D
#define REG_BK1426_1F_L      0x14263E
#define REG_BK1426_1F_H      0x14263F
#define REG_BK1426_20_L      0x142640
#define REG_BK1426_20_H      0x142641
#define REG_BK1426_21_L      0x142642
#define REG_BK1426_21_H      0x142643
#define REG_BK1426_22_L      0x142644
#define REG_BK1426_22_H      0x142645
#define REG_BK1426_23_L      0x142646
#define REG_BK1426_23_H      0x142647
#define REG_BK1426_24_L      0x142648
#define REG_BK1426_24_H      0x142649
#define REG_BK1426_25_L      0x14264A
#define REG_BK1426_25_H      0x14264B
#define REG_BK1426_26_L      0x14264C
#define REG_BK1426_26_H      0x14264D
#define REG_BK1426_27_L      0x14264E
#define REG_BK1426_27_H      0x14264F
#define REG_BK1426_28_L      0x142650
#define REG_BK1426_28_H      0x142651
#define REG_BK1426_29_L      0x142652
#define REG_BK1426_29_H      0x142653
#define REG_BK1426_2A_L      0x142654
#define REG_BK1426_2A_H      0x142655
#define REG_BK1426_2B_L      0x142656
#define REG_BK1426_2B_H      0x142657
#define REG_BK1426_2C_L      0x142658
#define REG_BK1426_2C_H      0x142659
#define REG_BK1426_2D_L      0x14265A
#define REG_BK1426_2D_H      0x14265B
#define REG_BK1426_2E_L      0x14265C
#define REG_BK1426_2E_H      0x14265D
#define REG_BK1426_2F_L      0x14265E
#define REG_BK1426_2F_H      0x14265F
#define REG_BK1426_30_L      0x142660
#define REG_BK1426_30_H      0x142661
#define REG_BK1426_31_L      0x142662
#define REG_BK1426_31_H      0x142663
#define REG_BK1426_32_L      0x142664
#define REG_BK1426_32_H      0x142665
#define REG_BK1426_33_L      0x142666
#define REG_BK1426_33_H      0x142667
#define REG_BK1426_34_L      0x142668
#define REG_BK1426_34_H      0x142669
#define REG_BK1426_35_L      0x14266A
#define REG_BK1426_35_H      0x14266B
#define REG_BK1426_36_L      0x14266C
#define REG_BK1426_36_H      0x14266D
#define REG_BK1426_37_L      0x14266E
#define REG_BK1426_37_H      0x14266F
#define REG_BK1426_38_L      0x142670
#define REG_BK1426_38_H      0x142671
#define REG_BK1426_39_L      0x142672
#define REG_BK1426_39_H      0x142673
#define REG_BK1426_3A_L      0x142674
#define REG_BK1426_3A_H      0x142675
#define REG_BK1426_3B_L      0x142676
#define REG_BK1426_3B_H      0x142677
#define REG_BK1426_3C_L      0x142678
#define REG_BK1426_3C_H      0x142679
#define REG_BK1426_3D_L      0x14267A
#define REG_BK1426_3D_H      0x14267B
#define REG_BK1426_3E_L      0x14267C
#define REG_BK1426_3E_H      0x14267D
#define REG_BK1426_3F_L      0x14267E
#define REG_BK1426_3F_H      0x14267F
#define REG_BK1426_40_L      0x142680
#define REG_BK1426_40_H      0x142681
#define REG_BK1426_41_L      0x142682
#define REG_BK1426_41_H      0x142683
#define REG_BK1426_42_L      0x142684
#define REG_BK1426_42_H      0x142685
#define REG_BK1426_43_L      0x142686
#define REG_BK1426_43_H      0x142687
#define REG_BK1426_44_L      0x142688
#define REG_BK1426_44_H      0x142689
#define REG_BK1426_45_L      0x14268A
#define REG_BK1426_45_H      0x14268B
#define REG_BK1426_46_L      0x14268C
#define REG_BK1426_46_H      0x14268D
#define REG_BK1426_47_L      0x14268E
#define REG_BK1426_47_H      0x14268F
#define REG_BK1426_48_L      0x142690
#define REG_BK1426_48_H      0x142691
#define REG_BK1426_49_L      0x142692
#define REG_BK1426_49_H      0x142693
#define REG_BK1426_4A_L      0x142694
#define REG_BK1426_4A_H      0x142695
#define REG_BK1426_4B_L      0x142696
#define REG_BK1426_4B_H      0x142697
#define REG_BK1426_4C_L      0x142698
#define REG_BK1426_4C_H      0x142699
#define REG_BK1426_4D_L      0x14269A
#define REG_BK1426_4D_H      0x14269B
#define REG_BK1426_4E_L      0x14269C
#define REG_BK1426_4E_H      0x14269D
#define REG_BK1426_4F_L      0x14269E
#define REG_BK1426_4F_H      0x14269F
#define REG_BK1426_50_L      0x1426A0
#define REG_BK1426_50_H      0x1426A1
#define REG_BK1426_51_L      0x1426A2
#define REG_BK1426_51_H      0x1426A3
#define REG_BK1426_52_L      0x1426A4
#define REG_BK1426_52_H      0x1426A5
#define REG_BK1426_53_L      0x1426A6
#define REG_BK1426_53_H      0x1426A7
#define REG_BK1426_54_L      0x1426A8
#define REG_BK1426_54_H      0x1426A9
#define REG_BK1426_55_L      0x1426AA
#define REG_BK1426_55_H      0x1426AB
#define REG_BK1426_56_L      0x1426AC
#define REG_BK1426_56_H      0x1426AD
#define REG_BK1426_57_L      0x1426AE
#define REG_BK1426_57_H      0x1426AF
#define REG_BK1426_58_L      0x1426B0
#define REG_BK1426_58_H      0x1426B1
#define REG_BK1426_59_L      0x1426B2
#define REG_BK1426_59_H      0x1426B3
#define REG_BK1426_5A_L      0x1426B4
#define REG_BK1426_5A_H      0x1426B5
#define REG_BK1426_5B_L      0x1426B6
#define REG_BK1426_5B_H      0x1426B7
#define REG_BK1426_5C_L      0x1426B8
#define REG_BK1426_5C_H      0x1426B9
#define REG_BK1426_5D_L      0x1426BA
#define REG_BK1426_5D_H      0x1426BB
#define REG_BK1426_5E_L      0x1426BC
#define REG_BK1426_5E_H      0x1426BD
#define REG_BK1426_5F_L      0x1426BE
#define REG_BK1426_5F_H      0x1426BF
#define REG_BK1426_60_L      0x1426C0
#define REG_BK1426_60_H      0x1426C1
#define REG_BK1426_61_L      0x1426C2
#define REG_BK1426_61_H      0x1426C3
#define REG_BK1426_62_L      0x1426C4
#define REG_BK1426_62_H      0x1426C5
#define REG_BK1426_63_L      0x1426C6
#define REG_BK1426_63_H      0x1426C7
#define REG_BK1426_64_L      0x1426C8
#define REG_BK1426_64_H      0x1426C9
#define REG_BK1426_65_L      0x1426CA
#define REG_BK1426_65_H      0x1426CB
#define REG_BK1426_66_L      0x1426CC
#define REG_BK1426_66_H      0x1426CD
#define REG_BK1426_67_L      0x1426CE
#define REG_BK1426_67_H      0x1426CF
#define REG_BK1426_68_L      0x1426D0
#define REG_BK1426_68_H      0x1426D1
#define REG_BK1426_69_L      0x1426D2
#define REG_BK1426_69_H      0x1426D3
#define REG_BK1426_6A_L      0x1426D4
#define REG_BK1426_6A_H      0x1426D5
#define REG_BK1426_6B_L      0x1426D6
#define REG_BK1426_6B_H      0x1426D7
#define REG_BK1426_6C_L      0x1426D8
#define REG_BK1426_6C_H      0x1426D9
#define REG_BK1426_6D_L      0x1426DA
#define REG_BK1426_6D_H      0x1426DB
#define REG_BK1426_6E_L      0x1426DC
#define REG_BK1426_6E_H      0x1426DD
#define REG_BK1426_6F_L      0x1426DE
#define REG_BK1426_6F_H      0x1426DF
#define REG_BK1426_70_L      0x1426E0
#define REG_BK1426_70_H      0x1426E1
#define REG_BK1426_71_L      0x1426E2
#define REG_BK1426_71_H      0x1426E3
#define REG_BK1426_72_L      0x1426E4
#define REG_BK1426_72_H      0x1426E5
#define REG_BK1426_73_L      0x1426E6
#define REG_BK1426_73_H      0x1426E7
#define REG_BK1426_74_L      0x1426E8
#define REG_BK1426_74_H      0x1426E9
#define REG_BK1426_75_L      0x1426EA
#define REG_BK1426_75_H      0x1426EB
#define REG_BK1426_76_L      0x1426EC
#define REG_BK1426_76_H      0x1426ED
#define REG_BK1426_77_L      0x1426EE
#define REG_BK1426_77_H      0x1426EF
#define REG_BK1426_78_L      0x1426F0
#define REG_BK1426_78_H      0x1426F1
#define REG_BK1426_79_L      0x1426F2
#define REG_BK1426_79_H      0x1426F3
#define REG_BK1426_7A_L      0x1426F4
#define REG_BK1426_7A_H      0x1426F5
#define REG_BK1426_7B_L      0x1426F6
#define REG_BK1426_7B_H      0x1426F7
#define REG_BK1426_7C_L      0x1426F8
#define REG_BK1426_7C_H      0x1426F9
#define REG_BK1426_7D_L      0x1426FA
#define REG_BK1426_7D_H      0x1426FB
#define REG_BK1426_7E_L      0x1426FC
#define REG_BK1426_7E_H      0x1426FD
#define REG_BK1426_7F_L      0x1426FE
#define REG_BK1426_7F_H      0x1426FF
//----------------------------------------------
#define REG_BK142C_00_L      0x142C00
#define REG_BK142C_00_H      0x142C01
#define REG_BK142C_01_L      0x142C02
#define REG_BK142C_01_H      0x142C03
#define REG_BK142C_02_L      0x142C04
#define REG_BK142C_02_H      0x142C05
#define REG_BK142C_03_L      0x142C06
#define REG_BK142C_03_H      0x142C07
#define REG_BK142C_04_L      0x142C08
#define REG_BK142C_04_H      0x142C09
#define REG_BK142C_05_L      0x142C0A
#define REG_BK142C_05_H      0x142C0B
#define REG_BK142C_06_L      0x142C0C
#define REG_BK142C_06_H      0x142C0D
#define REG_BK142C_07_L      0x142C0E
#define REG_BK142C_07_H      0x142C0F
#define REG_BK142C_08_L      0x142C10
#define REG_BK142C_08_H      0x142C11
#define REG_BK142C_09_L      0x142C12
#define REG_BK142C_09_H      0x142C13
#define REG_BK142C_0A_L      0x142C14
#define REG_BK142C_0A_H      0x142C15
#define REG_BK142C_0B_L      0x142C16
#define REG_BK142C_0B_H      0x142C17
#define REG_BK142C_0C_L      0x142C18
#define REG_BK142C_0C_H      0x142C19
#define REG_BK142C_0D_L      0x142C1A
#define REG_BK142C_0D_H      0x142C1B
#define REG_BK142C_0E_L      0x142C1C
#define REG_BK142C_0E_H      0x142C1D
#define REG_BK142C_0F_L      0x142C1E
#define REG_BK142C_0F_H      0x142C1F
#define REG_BK142C_10_L      0x142C20
#define REG_BK142C_10_H      0x142C21
#define REG_BK142C_11_L      0x142C22
#define REG_BK142C_11_H      0x142C23
#define REG_BK142C_12_L      0x142C24
#define REG_BK142C_12_H      0x142C25
#define REG_BK142C_13_L      0x142C26
#define REG_BK142C_13_H      0x142C27
#define REG_BK142C_14_L      0x142C28
#define REG_BK142C_14_H      0x142C29
#define REG_BK142C_15_L      0x142C2A
#define REG_BK142C_15_H      0x142C2B
#define REG_BK142C_16_L      0x142C2C
#define REG_BK142C_16_H      0x142C2D
#define REG_BK142C_17_L      0x142C2E
#define REG_BK142C_17_H      0x142C2F
#define REG_BK142C_18_L      0x142C30
#define REG_BK142C_18_H      0x142C31
#define REG_BK142C_19_L      0x142C32
#define REG_BK142C_19_H      0x142C33
#define REG_BK142C_1A_L      0x142C34
#define REG_BK142C_1A_H      0x142C35
#define REG_BK142C_1B_L      0x142C36
#define REG_BK142C_1B_H      0x142C37
#define REG_BK142C_1C_L      0x142C38
#define REG_BK142C_1C_H      0x142C39
#define REG_BK142C_1D_L      0x142C3A
#define REG_BK142C_1D_H      0x142C3B
#define REG_BK142C_1E_L      0x142C3C
#define REG_BK142C_1E_H      0x142C3D
#define REG_BK142C_1F_L      0x142C3E
#define REG_BK142C_1F_H      0x142C3F
#define REG_BK142C_20_L      0x142C40
#define REG_BK142C_20_H      0x142C41
#define REG_BK142C_21_L      0x142C42
#define REG_BK142C_21_H      0x142C43
#define REG_BK142C_22_L      0x142C44
#define REG_BK142C_22_H      0x142C45
#define REG_BK142C_23_L      0x142C46
#define REG_BK142C_23_H      0x142C47
#define REG_BK142C_24_L      0x142C48
#define REG_BK142C_24_H      0x142C49
#define REG_BK142C_25_L      0x142C4A
#define REG_BK142C_25_H      0x142C4B
#define REG_BK142C_26_L      0x142C4C
#define REG_BK142C_26_H      0x142C4D
#define REG_BK142C_27_L      0x142C4E
#define REG_BK142C_27_H      0x142C4F
#define REG_BK142C_28_L      0x142C50
#define REG_BK142C_28_H      0x142C51
#define REG_BK142C_29_L      0x142C52
#define REG_BK142C_29_H      0x142C53
#define REG_BK142C_2A_L      0x142C54
#define REG_BK142C_2A_H      0x142C55
#define REG_BK142C_2B_L      0x142C56
#define REG_BK142C_2B_H      0x142C57
#define REG_BK142C_2C_L      0x142C58
#define REG_BK142C_2C_H      0x142C59
#define REG_BK142C_2D_L      0x142C5A
#define REG_BK142C_2D_H      0x142C5B
#define REG_BK142C_2E_L      0x142C5C
#define REG_BK142C_2E_H      0x142C5D
#define REG_BK142C_2F_L      0x142C5E
#define REG_BK142C_2F_H      0x142C5F
#define REG_BK142C_30_L      0x142C60
#define REG_BK142C_30_H      0x142C61
#define REG_BK142C_31_L      0x142C62
#define REG_BK142C_31_H      0x142C63
#define REG_BK142C_32_L      0x142C64
#define REG_BK142C_32_H      0x142C65
#define REG_BK142C_33_L      0x142C66
#define REG_BK142C_33_H      0x142C67
#define REG_BK142C_34_L      0x142C68
#define REG_BK142C_34_H      0x142C69
#define REG_BK142C_35_L      0x142C6A
#define REG_BK142C_35_H      0x142C6B
#define REG_BK142C_36_L      0x142C6C
#define REG_BK142C_36_H      0x142C6D
#define REG_BK142C_37_L      0x142C6E
#define REG_BK142C_37_H      0x142C6F
#define REG_BK142C_38_L      0x142C70
#define REG_BK142C_38_H      0x142C71
#define REG_BK142C_39_L      0x142C72
#define REG_BK142C_39_H      0x142C73
#define REG_BK142C_3A_L      0x142C74
#define REG_BK142C_3A_H      0x142C75
#define REG_BK142C_3B_L      0x142C76
#define REG_BK142C_3B_H      0x142C77
#define REG_BK142C_3C_L      0x142C78
#define REG_BK142C_3C_H      0x142C79
#define REG_BK142C_3D_L      0x142C7A
#define REG_BK142C_3D_H      0x142C7B
#define REG_BK142C_3E_L      0x142C7C
#define REG_BK142C_3E_H      0x142C7D
#define REG_BK142C_3F_L      0x142C7E
#define REG_BK142C_3F_H      0x142C7F
#define REG_BK142C_40_L      0x142C80
#define REG_BK142C_40_H      0x142C81
#define REG_BK142C_41_L      0x142C82
#define REG_BK142C_41_H      0x142C83
#define REG_BK142C_42_L      0x142C84
#define REG_BK142C_42_H      0x142C85
#define REG_BK142C_43_L      0x142C86
#define REG_BK142C_43_H      0x142C87
#define REG_BK142C_44_L      0x142C88
#define REG_BK142C_44_H      0x142C89
#define REG_BK142C_45_L      0x142C8A
#define REG_BK142C_45_H      0x142C8B
#define REG_BK142C_46_L      0x142C8C
#define REG_BK142C_46_H      0x142C8D
#define REG_BK142C_47_L      0x142C8E
#define REG_BK142C_47_H      0x142C8F
#define REG_BK142C_48_L      0x142C90
#define REG_BK142C_48_H      0x142C91
#define REG_BK142C_49_L      0x142C92
#define REG_BK142C_49_H      0x142C93
#define REG_BK142C_4A_L      0x142C94
#define REG_BK142C_4A_H      0x142C95
#define REG_BK142C_4B_L      0x142C96
#define REG_BK142C_4B_H      0x142C97
#define REG_BK142C_4C_L      0x142C98
#define REG_BK142C_4C_H      0x142C99
#define REG_BK142C_4D_L      0x142C9A
#define REG_BK142C_4D_H      0x142C9B
#define REG_BK142C_4E_L      0x142C9C
#define REG_BK142C_4E_H      0x142C9D
#define REG_BK142C_4F_L      0x142C9E
#define REG_BK142C_4F_H      0x142C9F
#define REG_BK142C_50_L      0x142CA0
#define REG_BK142C_50_H      0x142CA1
#define REG_BK142C_51_L      0x142CA2
#define REG_BK142C_51_H      0x142CA3
#define REG_BK142C_52_L      0x142CA4
#define REG_BK142C_52_H      0x142CA5
#define REG_BK142C_53_L      0x142CA6
#define REG_BK142C_53_H      0x142CA7
#define REG_BK142C_54_L      0x142CA8
#define REG_BK142C_54_H      0x142CA9
#define REG_BK142C_55_L      0x142CAA
#define REG_BK142C_55_H      0x142CAB
#define REG_BK142C_56_L      0x142CAC
#define REG_BK142C_56_H      0x142CAD
#define REG_BK142C_57_L      0x142CAE
#define REG_BK142C_57_H      0x142CAF
#define REG_BK142C_58_L      0x142CB0
#define REG_BK142C_58_H      0x142CB1
#define REG_BK142C_59_L      0x142CB2
#define REG_BK142C_59_H      0x142CB3
#define REG_BK142C_5A_L      0x142CB4
#define REG_BK142C_5A_H      0x142CB5
#define REG_BK142C_5B_L      0x142CB6
#define REG_BK142C_5B_H      0x142CB7
#define REG_BK142C_5C_L      0x142CB8
#define REG_BK142C_5C_H      0x142CB9
#define REG_BK142C_5D_L      0x142CBA
#define REG_BK142C_5D_H      0x142CBB
#define REG_BK142C_5E_L      0x142CBC
#define REG_BK142C_5E_H      0x142CBD
#define REG_BK142C_5F_L      0x142CBE
#define REG_BK142C_5F_H      0x142CBF
#define REG_BK142C_60_L      0x142CC0
#define REG_BK142C_60_H      0x142CC1
#define REG_BK142C_61_L      0x142CC2
#define REG_BK142C_61_H      0x142CC3
#define REG_BK142C_62_L      0x142CC4
#define REG_BK142C_62_H      0x142CC5
#define REG_BK142C_63_L      0x142CC6
#define REG_BK142C_63_H      0x142CC7
#define REG_BK142C_64_L      0x142CC8
#define REG_BK142C_64_H      0x142CC9
#define REG_BK142C_65_L      0x142CCA
#define REG_BK142C_65_H      0x142CCB
#define REG_BK142C_66_L      0x142CCC
#define REG_BK142C_66_H      0x142CCD
#define REG_BK142C_67_L      0x142CCE
#define REG_BK142C_67_H      0x142CCF
#define REG_BK142C_68_L      0x142CD0
#define REG_BK142C_68_H      0x142CD1
#define REG_BK142C_69_L      0x142CD2
#define REG_BK142C_69_H      0x142CD3
#define REG_BK142C_6A_L      0x142CD4
#define REG_BK142C_6A_H      0x142CD5
#define REG_BK142C_6B_L      0x142CD6
#define REG_BK142C_6B_H      0x142CD7
#define REG_BK142C_6C_L      0x142CD8
#define REG_BK142C_6C_H      0x142CD9
#define REG_BK142C_6D_L      0x142CDA
#define REG_BK142C_6D_H      0x142CDB
#define REG_BK142C_6E_L      0x142CDC
#define REG_BK142C_6E_H      0x142CDD
#define REG_BK142C_6F_L      0x142CDE
#define REG_BK142C_6F_H      0x142CDF
#define REG_BK142C_70_L      0x142CE0
#define REG_BK142C_70_H      0x142CE1
#define REG_BK142C_71_L      0x142CE2
#define REG_BK142C_71_H      0x142CE3
#define REG_BK142C_72_L      0x142CE4
#define REG_BK142C_72_H      0x142CE5
#define REG_BK142C_73_L      0x142CE6
#define REG_BK142C_73_H      0x142CE7
#define REG_BK142C_74_L      0x142CE8
#define REG_BK142C_74_H      0x142CE9
#define REG_BK142C_75_L      0x142CEA
#define REG_BK142C_75_H      0x142CEB
#define REG_BK142C_76_L      0x142CEC
#define REG_BK142C_76_H      0x142CED
#define REG_BK142C_77_L      0x142CEE
#define REG_BK142C_77_H      0x142CEF
#define REG_BK142C_78_L      0x142CF0
#define REG_BK142C_78_H      0x142CF1
#define REG_BK142C_79_L      0x142CF2
#define REG_BK142C_79_H      0x142CF3
#define REG_BK142C_7A_L      0x142CF4
#define REG_BK142C_7A_H      0x142CF5
#define REG_BK142C_7B_L      0x142CF6
#define REG_BK142C_7B_H      0x142CF7
#define REG_BK142C_7C_L      0x142CF8
#define REG_BK142C_7C_H      0x142CF9
#define REG_BK142C_7D_L      0x142CFA
#define REG_BK142C_7D_H      0x142CFB
#define REG_BK142C_7E_L      0x142CFC
#define REG_BK142C_7E_H      0x142CFD
#define REG_BK142C_7F_L      0x142CFE
#define REG_BK142C_7F_H      0x142CFF
//----------------------------------------------
#define REG_BK1430_00_L      0x143000
#define REG_BK1430_00_H      0x143001
#define REG_BK1430_01_L      0x143002
#define REG_BK1430_01_H      0x143003
#define REG_BK1430_02_L      0x143004
#define REG_BK1430_02_H      0x143005
#define REG_BK1430_03_L      0x143006
#define REG_BK1430_03_H      0x143007
#define REG_BK1430_04_L      0x143008
#define REG_BK1430_04_H      0x143009
#define REG_BK1430_05_L      0x14300A
#define REG_BK1430_05_H      0x14300B
#define REG_BK1430_06_L      0x14300C
#define REG_BK1430_06_H      0x14300D
#define REG_BK1430_07_L      0x14300E
#define REG_BK1430_07_H      0x14300F
#define REG_BK1430_08_L      0x143010
#define REG_BK1430_08_H      0x143011
#define REG_BK1430_09_L      0x143012
#define REG_BK1430_09_H      0x143013
#define REG_BK1430_0A_L      0x143014
#define REG_BK1430_0A_H      0x143015
#define REG_BK1430_0B_L      0x143016
#define REG_BK1430_0B_H      0x143017
#define REG_BK1430_0C_L      0x143018
#define REG_BK1430_0C_H      0x143019
#define REG_BK1430_0D_L      0x14301A
#define REG_BK1430_0D_H      0x14301B
#define REG_BK1430_0E_L      0x14301C
#define REG_BK1430_0E_H      0x14301D
#define REG_BK1430_0F_L      0x14301E
#define REG_BK1430_0F_H      0x14301F
#define REG_BK1430_10_L      0x143020
#define REG_BK1430_10_H      0x143021
#define REG_BK1430_11_L      0x143022
#define REG_BK1430_11_H      0x143023
#define REG_BK1430_12_L      0x143024
#define REG_BK1430_12_H      0x143025
#define REG_BK1430_13_L      0x143026
#define REG_BK1430_13_H      0x143027
#define REG_BK1430_14_L      0x143028
#define REG_BK1430_14_H      0x143029
#define REG_BK1430_15_L      0x14302A
#define REG_BK1430_15_H      0x14302B
#define REG_BK1430_16_L      0x14302C
#define REG_BK1430_16_H      0x14302D
#define REG_BK1430_17_L      0x14302E
#define REG_BK1430_17_H      0x14302F
#define REG_BK1430_18_L      0x143030
#define REG_BK1430_18_H      0x143031
#define REG_BK1430_19_L      0x143032
#define REG_BK1430_19_H      0x143033
#define REG_BK1430_1A_L      0x143034
#define REG_BK1430_1A_H      0x143035
#define REG_BK1430_1B_L      0x143036
#define REG_BK1430_1B_H      0x143037
#define REG_BK1430_1C_L      0x143038
#define REG_BK1430_1C_H      0x143039
#define REG_BK1430_1D_L      0x14303A
#define REG_BK1430_1D_H      0x14303B
#define REG_BK1430_1E_L      0x14303C
#define REG_BK1430_1E_H      0x14303D
#define REG_BK1430_1F_L      0x14303E
#define REG_BK1430_1F_H      0x14303F
#define REG_BK1430_20_L      0x143040
#define REG_BK1430_20_H      0x143041
#define REG_BK1430_21_L      0x143042
#define REG_BK1430_21_H      0x143043
#define REG_BK1430_22_L      0x143044
#define REG_BK1430_22_H      0x143045
#define REG_BK1430_23_L      0x143046
#define REG_BK1430_23_H      0x143047
#define REG_BK1430_24_L      0x143048
#define REG_BK1430_24_H      0x143049
#define REG_BK1430_25_L      0x14304A
#define REG_BK1430_25_H      0x14304B
#define REG_BK1430_26_L      0x14304C
#define REG_BK1430_26_H      0x14304D
#define REG_BK1430_27_L      0x14304E
#define REG_BK1430_27_H      0x14304F
#define REG_BK1430_28_L      0x143050
#define REG_BK1430_28_H      0x143051
#define REG_BK1430_29_L      0x143052
#define REG_BK1430_29_H      0x143053
#define REG_BK1430_2A_L      0x143054
#define REG_BK1430_2A_H      0x143055
#define REG_BK1430_2B_L      0x143056
#define REG_BK1430_2B_H      0x143057
#define REG_BK1430_2C_L      0x143058
#define REG_BK1430_2C_H      0x143059
#define REG_BK1430_2D_L      0x14305A
#define REG_BK1430_2D_H      0x14305B
#define REG_BK1430_2E_L      0x14305C
#define REG_BK1430_2E_H      0x14305D
#define REG_BK1430_2F_L      0x14305E
#define REG_BK1430_2F_H      0x14305F
#define REG_BK1430_30_L      0x143060
#define REG_BK1430_30_H      0x143061
#define REG_BK1430_31_L      0x143062
#define REG_BK1430_31_H      0x143063
#define REG_BK1430_32_L      0x143064
#define REG_BK1430_32_H      0x143065
#define REG_BK1430_33_L      0x143066
#define REG_BK1430_33_H      0x143067
#define REG_BK1430_34_L      0x143068
#define REG_BK1430_34_H      0x143069
#define REG_BK1430_35_L      0x14306A
#define REG_BK1430_35_H      0x14306B
#define REG_BK1430_36_L      0x14306C
#define REG_BK1430_36_H      0x14306D
#define REG_BK1430_37_L      0x14306E
#define REG_BK1430_37_H      0x14306F
#define REG_BK1430_38_L      0x143070
#define REG_BK1430_38_H      0x143071
#define REG_BK1430_39_L      0x143072
#define REG_BK1430_39_H      0x143073
#define REG_BK1430_3A_L      0x143074
#define REG_BK1430_3A_H      0x143075
#define REG_BK1430_3B_L      0x143076
#define REG_BK1430_3B_H      0x143077
#define REG_BK1430_3C_L      0x143078
#define REG_BK1430_3C_H      0x143079
#define REG_BK1430_3D_L      0x14307A
#define REG_BK1430_3D_H      0x14307B
#define REG_BK1430_3E_L      0x14307C
#define REG_BK1430_3E_H      0x14307D
#define REG_BK1430_3F_L      0x14307E
#define REG_BK1430_3F_H      0x14307F
#define REG_BK1430_40_L      0x143080
#define REG_BK1430_40_H      0x143081
#define REG_BK1430_41_L      0x143082
#define REG_BK1430_41_H      0x143083
#define REG_BK1430_42_L      0x143084
#define REG_BK1430_42_H      0x143085
#define REG_BK1430_43_L      0x143086
#define REG_BK1430_43_H      0x143087
#define REG_BK1430_44_L      0x143088
#define REG_BK1430_44_H      0x143089
#define REG_BK1430_45_L      0x14308A
#define REG_BK1430_45_H      0x14308B
#define REG_BK1430_46_L      0x14308C
#define REG_BK1430_46_H      0x14308D
#define REG_BK1430_47_L      0x14308E
#define REG_BK1430_47_H      0x14308F
#define REG_BK1430_48_L      0x143090
#define REG_BK1430_48_H      0x143091
#define REG_BK1430_49_L      0x143092
#define REG_BK1430_49_H      0x143093
#define REG_BK1430_4A_L      0x143094
#define REG_BK1430_4A_H      0x143095
#define REG_BK1430_4B_L      0x143096
#define REG_BK1430_4B_H      0x143097
#define REG_BK1430_4C_L      0x143098
#define REG_BK1430_4C_H      0x143099
#define REG_BK1430_4D_L      0x14309A
#define REG_BK1430_4D_H      0x14309B
#define REG_BK1430_4E_L      0x14309C
#define REG_BK1430_4E_H      0x14309D
#define REG_BK1430_4F_L      0x14309E
#define REG_BK1430_4F_H      0x14309F
#define REG_BK1430_50_L      0x1430A0
#define REG_BK1430_50_H      0x1430A1
#define REG_BK1430_51_L      0x1430A2
#define REG_BK1430_51_H      0x1430A3
#define REG_BK1430_52_L      0x1430A4
#define REG_BK1430_52_H      0x1430A5
#define REG_BK1430_53_L      0x1430A6
#define REG_BK1430_53_H      0x1430A7
#define REG_BK1430_54_L      0x1430A8
#define REG_BK1430_54_H      0x1430A9
#define REG_BK1430_55_L      0x1430AA
#define REG_BK1430_55_H      0x1430AB
#define REG_BK1430_56_L      0x1430AC
#define REG_BK1430_56_H      0x1430AD
#define REG_BK1430_57_L      0x1430AE
#define REG_BK1430_57_H      0x1430AF
#define REG_BK1430_58_L      0x1430B0
#define REG_BK1430_58_H      0x1430B1
#define REG_BK1430_59_L      0x1430B2
#define REG_BK1430_59_H      0x1430B3
#define REG_BK1430_5A_L      0x1430B4
#define REG_BK1430_5A_H      0x1430B5
#define REG_BK1430_5B_L      0x1430B6
#define REG_BK1430_5B_H      0x1430B7
#define REG_BK1430_5C_L      0x1430B8
#define REG_BK1430_5C_H      0x1430B9
#define REG_BK1430_5D_L      0x1430BA
#define REG_BK1430_5D_H      0x1430BB
#define REG_BK1430_5E_L      0x1430BC
#define REG_BK1430_5E_H      0x1430BD
#define REG_BK1430_5F_L      0x1430BE
#define REG_BK1430_5F_H      0x1430BF
#define REG_BK1430_60_L      0x1430C0
#define REG_BK1430_60_H      0x1430C1
#define REG_BK1430_61_L      0x1430C2
#define REG_BK1430_61_H      0x1430C3
#define REG_BK1430_62_L      0x1430C4
#define REG_BK1430_62_H      0x1430C5
#define REG_BK1430_63_L      0x1430C6
#define REG_BK1430_63_H      0x1430C7
#define REG_BK1430_64_L      0x1430C8
#define REG_BK1430_64_H      0x1430C9
#define REG_BK1430_65_L      0x1430CA
#define REG_BK1430_65_H      0x1430CB
#define REG_BK1430_66_L      0x1430CC
#define REG_BK1430_66_H      0x1430CD
#define REG_BK1430_67_L      0x1430CE
#define REG_BK1430_67_H      0x1430CF
#define REG_BK1430_68_L      0x1430D0
#define REG_BK1430_68_H      0x1430D1
#define REG_BK1430_69_L      0x1430D2
#define REG_BK1430_69_H      0x1430D3
#define REG_BK1430_6A_L      0x1430D4
#define REG_BK1430_6A_H      0x1430D5
#define REG_BK1430_6B_L      0x1430D6
#define REG_BK1430_6B_H      0x1430D7
#define REG_BK1430_6C_L      0x1430D8
#define REG_BK1430_6C_H      0x1430D9
#define REG_BK1430_6D_L      0x1430DA
#define REG_BK1430_6D_H      0x1430DB
#define REG_BK1430_6E_L      0x1430DC
#define REG_BK1430_6E_H      0x1430DD
#define REG_BK1430_6F_L      0x1430DE
#define REG_BK1430_6F_H      0x1430DF
#define REG_BK1430_70_L      0x1430E0
#define REG_BK1430_70_H      0x1430E1
#define REG_BK1430_71_L      0x1430E2
#define REG_BK1430_71_H      0x1430E3
#define REG_BK1430_72_L      0x1430E4
#define REG_BK1430_72_H      0x1430E5
#define REG_BK1430_73_L      0x1430E6
#define REG_BK1430_73_H      0x1430E7
#define REG_BK1430_74_L      0x1430E8
#define REG_BK1430_74_H      0x1430E9
#define REG_BK1430_75_L      0x1430EA
#define REG_BK1430_75_H      0x1430EB
#define REG_BK1430_76_L      0x1430EC
#define REG_BK1430_76_H      0x1430ED
#define REG_BK1430_77_L      0x1430EE
#define REG_BK1430_77_H      0x1430EF
#define REG_BK1430_78_L      0x1430F0
#define REG_BK1430_78_H      0x1430F1
#define REG_BK1430_79_L      0x1430F2
#define REG_BK1430_79_H      0x1430F3
#define REG_BK1430_7A_L      0x1430F4
#define REG_BK1430_7A_H      0x1430F5
#define REG_BK1430_7B_L      0x1430F6
#define REG_BK1430_7B_H      0x1430F7
#define REG_BK1430_7C_L      0x1430F8
#define REG_BK1430_7C_H      0x1430F9
#define REG_BK1430_7D_L      0x1430FA
#define REG_BK1430_7D_H      0x1430FB
#define REG_BK1430_7E_L      0x1430FC
#define REG_BK1430_7E_H      0x1430FD
#define REG_BK1430_7F_L      0x1430FE
#define REG_BK1430_7F_H      0x1430FF
//----------------------------------------------
#define REG_BK144C_00_L      0x144C00
#define REG_BK144C_00_H      0x144C01
#define REG_BK144C_01_L      0x144C02
#define REG_BK144C_01_H      0x144C03
#define REG_BK144C_02_L      0x144C04
#define REG_BK144C_02_H      0x144C05
#define REG_BK144C_03_L      0x144C06
#define REG_BK144C_03_H      0x144C07
#define REG_BK144C_04_L      0x144C08
#define REG_BK144C_04_H      0x144C09
#define REG_BK144C_05_L      0x144C0A
#define REG_BK144C_05_H      0x144C0B
#define REG_BK144C_06_L      0x144C0C
#define REG_BK144C_06_H      0x144C0D
#define REG_BK144C_07_L      0x144C0E
#define REG_BK144C_07_H      0x144C0F
#define REG_BK144C_08_L      0x144C10
#define REG_BK144C_08_H      0x144C11
#define REG_BK144C_09_L      0x144C12
#define REG_BK144C_09_H      0x144C13
#define REG_BK144C_0A_L      0x144C14
#define REG_BK144C_0A_H      0x144C15
#define REG_BK144C_0B_L      0x144C16
#define REG_BK144C_0B_H      0x144C17
#define REG_BK144C_0C_L      0x144C18
#define REG_BK144C_0C_H      0x144C19
#define REG_BK144C_0D_L      0x144C1A
#define REG_BK144C_0D_H      0x144C1B
#define REG_BK144C_0E_L      0x144C1C
#define REG_BK144C_0E_H      0x144C1D
#define REG_BK144C_0F_L      0x144C1E
#define REG_BK144C_0F_H      0x144C1F
#define REG_BK144C_10_L      0x144C20
#define REG_BK144C_10_H      0x144C21
#define REG_BK144C_11_L      0x144C22
#define REG_BK144C_11_H      0x144C23
#define REG_BK144C_12_L      0x144C24
#define REG_BK144C_12_H      0x144C25
#define REG_BK144C_13_L      0x144C26
#define REG_BK144C_13_H      0x144C27
#define REG_BK144C_14_L      0x144C28
#define REG_BK144C_14_H      0x144C29
#define REG_BK144C_15_L      0x144C2A
#define REG_BK144C_15_H      0x144C2B
#define REG_BK144C_16_L      0x144C2C
#define REG_BK144C_16_H      0x144C2D
#define REG_BK144C_17_L      0x144C2E
#define REG_BK144C_17_H      0x144C2F
#define REG_BK144C_18_L      0x144C30
#define REG_BK144C_18_H      0x144C31
#define REG_BK144C_19_L      0x144C32
#define REG_BK144C_19_H      0x144C33
#define REG_BK144C_1A_L      0x144C34
#define REG_BK144C_1A_H      0x144C35
#define REG_BK144C_1B_L      0x144C36
#define REG_BK144C_1B_H      0x144C37
#define REG_BK144C_1C_L      0x144C38
#define REG_BK144C_1C_H      0x144C39
#define REG_BK144C_1D_L      0x144C3A
#define REG_BK144C_1D_H      0x144C3B
#define REG_BK144C_1E_L      0x144C3C
#define REG_BK144C_1E_H      0x144C3D
#define REG_BK144C_1F_L      0x144C3E
#define REG_BK144C_1F_H      0x144C3F
#define REG_BK144C_20_L      0x144C40
#define REG_BK144C_20_H      0x144C41
#define REG_BK144C_21_L      0x144C42
#define REG_BK144C_21_H      0x144C43
#define REG_BK144C_22_L      0x144C44
#define REG_BK144C_22_H      0x144C45
#define REG_BK144C_23_L      0x144C46
#define REG_BK144C_23_H      0x144C47
#define REG_BK144C_24_L      0x144C48
#define REG_BK144C_24_H      0x144C49
#define REG_BK144C_25_L      0x144C4A
#define REG_BK144C_25_H      0x144C4B
#define REG_BK144C_26_L      0x144C4C
#define REG_BK144C_26_H      0x144C4D
#define REG_BK144C_27_L      0x144C4E
#define REG_BK144C_27_H      0x144C4F
#define REG_BK144C_28_L      0x144C50
#define REG_BK144C_28_H      0x144C51
#define REG_BK144C_29_L      0x144C52
#define REG_BK144C_29_H      0x144C53
#define REG_BK144C_2A_L      0x144C54
#define REG_BK144C_2A_H      0x144C55
#define REG_BK144C_2B_L      0x144C56
#define REG_BK144C_2B_H      0x144C57
#define REG_BK144C_2C_L      0x144C58
#define REG_BK144C_2C_H      0x144C59
#define REG_BK144C_2D_L      0x144C5A
#define REG_BK144C_2D_H      0x144C5B
#define REG_BK144C_2E_L      0x144C5C
#define REG_BK144C_2E_H      0x144C5D
#define REG_BK144C_2F_L      0x144C5E
#define REG_BK144C_2F_H      0x144C5F
#define REG_BK144C_30_L      0x144C60
#define REG_BK144C_30_H      0x144C61
#define REG_BK144C_31_L      0x144C62
#define REG_BK144C_31_H      0x144C63
#define REG_BK144C_32_L      0x144C64
#define REG_BK144C_32_H      0x144C65
#define REG_BK144C_33_L      0x144C66
#define REG_BK144C_33_H      0x144C67
#define REG_BK144C_34_L      0x144C68
#define REG_BK144C_34_H      0x144C69
#define REG_BK144C_35_L      0x144C6A
#define REG_BK144C_35_H      0x144C6B
#define REG_BK144C_36_L      0x144C6C
#define REG_BK144C_36_H      0x144C6D
#define REG_BK144C_37_L      0x144C6E
#define REG_BK144C_37_H      0x144C6F
#define REG_BK144C_38_L      0x144C70
#define REG_BK144C_38_H      0x144C71
#define REG_BK144C_39_L      0x144C72
#define REG_BK144C_39_H      0x144C73
#define REG_BK144C_3A_L      0x144C74
#define REG_BK144C_3A_H      0x144C75
#define REG_BK144C_3B_L      0x144C76
#define REG_BK144C_3B_H      0x144C77
#define REG_BK144C_3C_L      0x144C78
#define REG_BK144C_3C_H      0x144C79
#define REG_BK144C_3D_L      0x144C7A
#define REG_BK144C_3D_H      0x144C7B
#define REG_BK144C_3E_L      0x144C7C
#define REG_BK144C_3E_H      0x144C7D
#define REG_BK144C_3F_L      0x144C7E
#define REG_BK144C_3F_H      0x144C7F
#define REG_BK144C_40_L      0x144C80
#define REG_BK144C_40_H      0x144C81
#define REG_BK144C_41_L      0x144C82
#define REG_BK144C_41_H      0x144C83
#define REG_BK144C_42_L      0x144C84
#define REG_BK144C_42_H      0x144C85
#define REG_BK144C_43_L      0x144C86
#define REG_BK144C_43_H      0x144C87
#define REG_BK144C_44_L      0x144C88
#define REG_BK144C_44_H      0x144C89
#define REG_BK144C_45_L      0x144C8A
#define REG_BK144C_45_H      0x144C8B
#define REG_BK144C_46_L      0x144C8C
#define REG_BK144C_46_H      0x144C8D
#define REG_BK144C_47_L      0x144C8E
#define REG_BK144C_47_H      0x144C8F
#define REG_BK144C_48_L      0x144C90
#define REG_BK144C_48_H      0x144C91
#define REG_BK144C_49_L      0x144C92
#define REG_BK144C_49_H      0x144C93
#define REG_BK144C_4A_L      0x144C94
#define REG_BK144C_4A_H      0x144C95
#define REG_BK144C_4B_L      0x144C96
#define REG_BK144C_4B_H      0x144C97
#define REG_BK144C_4C_L      0x144C98
#define REG_BK144C_4C_H      0x144C99
#define REG_BK144C_4D_L      0x144C9A
#define REG_BK144C_4D_H      0x144C9B
#define REG_BK144C_4E_L      0x144C9C
#define REG_BK144C_4E_H      0x144C9D
#define REG_BK144C_4F_L      0x144C9E
#define REG_BK144C_4F_H      0x144C9F
#define REG_BK144C_50_L      0x144CA0
#define REG_BK144C_50_H      0x144CA1
#define REG_BK144C_51_L      0x144CA2
#define REG_BK144C_51_H      0x144CA3
#define REG_BK144C_52_L      0x144CA4
#define REG_BK144C_52_H      0x144CA5
#define REG_BK144C_53_L      0x144CA6
#define REG_BK144C_53_H      0x144CA7
#define REG_BK144C_54_L      0x144CA8
#define REG_BK144C_54_H      0x144CA9
#define REG_BK144C_55_L      0x144CAA
#define REG_BK144C_55_H      0x144CAB
#define REG_BK144C_56_L      0x144CAC
#define REG_BK144C_56_H      0x144CAD
#define REG_BK144C_57_L      0x144CAE
#define REG_BK144C_57_H      0x144CAF
#define REG_BK144C_58_L      0x144CB0
#define REG_BK144C_58_H      0x144CB1
#define REG_BK144C_59_L      0x144CB2
#define REG_BK144C_59_H      0x144CB3
#define REG_BK144C_5A_L      0x144CB4
#define REG_BK144C_5A_H      0x144CB5
#define REG_BK144C_5B_L      0x144CB6
#define REG_BK144C_5B_H      0x144CB7
#define REG_BK144C_5C_L      0x144CB8
#define REG_BK144C_5C_H      0x144CB9
#define REG_BK144C_5D_L      0x144CBA
#define REG_BK144C_5D_H      0x144CBB
#define REG_BK144C_5E_L      0x144CBC
#define REG_BK144C_5E_H      0x144CBD
#define REG_BK144C_5F_L      0x144CBE
#define REG_BK144C_5F_H      0x144CBF
#define REG_BK144C_60_L      0x144CC0
#define REG_BK144C_60_H      0x144CC1
#define REG_BK144C_61_L      0x144CC2
#define REG_BK144C_61_H      0x144CC3
#define REG_BK144C_62_L      0x144CC4
#define REG_BK144C_62_H      0x144CC5
#define REG_BK144C_63_L      0x144CC6
#define REG_BK144C_63_H      0x144CC7
#define REG_BK144C_64_L      0x144CC8
#define REG_BK144C_64_H      0x144CC9
#define REG_BK144C_65_L      0x144CCA
#define REG_BK144C_65_H      0x144CCB
#define REG_BK144C_66_L      0x144CCC
#define REG_BK144C_66_H      0x144CCD
#define REG_BK144C_67_L      0x144CCE
#define REG_BK144C_67_H      0x144CCF
#define REG_BK144C_68_L      0x144CD0
#define REG_BK144C_68_H      0x144CD1
#define REG_BK144C_69_L      0x144CD2
#define REG_BK144C_69_H      0x144CD3
#define REG_BK144C_6A_L      0x144CD4
#define REG_BK144C_6A_H      0x144CD5
#define REG_BK144C_6B_L      0x144CD6
#define REG_BK144C_6B_H      0x144CD7
#define REG_BK144C_6C_L      0x144CD8
#define REG_BK144C_6C_H      0x144CD9
#define REG_BK144C_6D_L      0x144CDA
#define REG_BK144C_6D_H      0x144CDB
#define REG_BK144C_6E_L      0x144CDC
#define REG_BK144C_6E_H      0x144CDD
#define REG_BK144C_6F_L      0x144CDE
#define REG_BK144C_6F_H      0x144CDF
#define REG_BK144C_70_L      0x144CE0
#define REG_BK144C_70_H      0x144CE1
#define REG_BK144C_71_L      0x144CE2
#define REG_BK144C_71_H      0x144CE3
#define REG_BK144C_72_L      0x144CE4
#define REG_BK144C_72_H      0x144CE5
#define REG_BK144C_73_L      0x144CE6
#define REG_BK144C_73_H      0x144CE7
#define REG_BK144C_74_L      0x144CE8
#define REG_BK144C_74_H      0x144CE9
#define REG_BK144C_75_L      0x144CEA
#define REG_BK144C_75_H      0x144CEB
#define REG_BK144C_76_L      0x144CEC
#define REG_BK144C_76_H      0x144CED
#define REG_BK144C_77_L      0x144CEE
#define REG_BK144C_77_H      0x144CEF
#define REG_BK144C_78_L      0x144CF0
#define REG_BK144C_78_H      0x144CF1
#define REG_BK144C_79_L      0x144CF2
#define REG_BK144C_79_H      0x144CF3
#define REG_BK144C_7A_L      0x144CF4
#define REG_BK144C_7A_H      0x144CF5
#define REG_BK144C_7B_L      0x144CF6
#define REG_BK144C_7B_H      0x144CF7
#define REG_BK144C_7C_L      0x144CF8
#define REG_BK144C_7C_H      0x144CF9
#define REG_BK144C_7D_L      0x144CFA
#define REG_BK144C_7D_H      0x144CFB
#define REG_BK144C_7E_L      0x144CFC
#define REG_BK144C_7E_H      0x144CFD
#define REG_BK144C_7F_L      0x144CFE
#define REG_BK144C_7F_H      0x144CFF
//----------------------------------------------
#define REG_BK144D_00_L      0x144D00
#define REG_BK144D_00_H      0x144D01
#define REG_BK144D_01_L      0x144D02
#define REG_BK144D_01_H      0x144D03
#define REG_BK144D_02_L      0x144D04
#define REG_BK144D_02_H      0x144D05
#define REG_BK144D_03_L      0x144D06
#define REG_BK144D_03_H      0x144D07
#define REG_BK144D_04_L      0x144D08
#define REG_BK144D_04_H      0x144D09
#define REG_BK144D_05_L      0x144D0A
#define REG_BK144D_05_H      0x144D0B
#define REG_BK144D_06_L      0x144D0C
#define REG_BK144D_06_H      0x144D0D
#define REG_BK144D_07_L      0x144D0E
#define REG_BK144D_07_H      0x144D0F
#define REG_BK144D_08_L      0x144D10
#define REG_BK144D_08_H      0x144D11
#define REG_BK144D_09_L      0x144D12
#define REG_BK144D_09_H      0x144D13
#define REG_BK144D_0A_L      0x144D14
#define REG_BK144D_0A_H      0x144D15
#define REG_BK144D_0B_L      0x144D16
#define REG_BK144D_0B_H      0x144D17
#define REG_BK144D_0C_L      0x144D18
#define REG_BK144D_0C_H      0x144D19
#define REG_BK144D_0D_L      0x144D1A
#define REG_BK144D_0D_H      0x144D1B
#define REG_BK144D_0E_L      0x144D1C
#define REG_BK144D_0E_H      0x144D1D
#define REG_BK144D_0F_L      0x144D1E
#define REG_BK144D_0F_H      0x144D1F
#define REG_BK144D_10_L      0x144D20
#define REG_BK144D_10_H      0x144D21
#define REG_BK144D_11_L      0x144D22
#define REG_BK144D_11_H      0x144D23
#define REG_BK144D_12_L      0x144D24
#define REG_BK144D_12_H      0x144D25
#define REG_BK144D_13_L      0x144D26
#define REG_BK144D_13_H      0x144D27
#define REG_BK144D_14_L      0x144D28
#define REG_BK144D_14_H      0x144D29
#define REG_BK144D_15_L      0x144D2A
#define REG_BK144D_15_H      0x144D2B
#define REG_BK144D_16_L      0x144D2C
#define REG_BK144D_16_H      0x144D2D
#define REG_BK144D_17_L      0x144D2E
#define REG_BK144D_17_H      0x144D2F
#define REG_BK144D_18_L      0x144D30
#define REG_BK144D_18_H      0x144D31
#define REG_BK144D_19_L      0x144D32
#define REG_BK144D_19_H      0x144D33
#define REG_BK144D_1A_L      0x144D34
#define REG_BK144D_1A_H      0x144D35
#define REG_BK144D_1B_L      0x144D36
#define REG_BK144D_1B_H      0x144D37
#define REG_BK144D_1C_L      0x144D38
#define REG_BK144D_1C_H      0x144D39
#define REG_BK144D_1D_L      0x144D3A
#define REG_BK144D_1D_H      0x144D3B
#define REG_BK144D_1E_L      0x144D3C
#define REG_BK144D_1E_H      0x144D3D
#define REG_BK144D_1F_L      0x144D3E
#define REG_BK144D_1F_H      0x144D3F
#define REG_BK144D_20_L      0x144D40
#define REG_BK144D_20_H      0x144D41
#define REG_BK144D_21_L      0x144D42
#define REG_BK144D_21_H      0x144D43
#define REG_BK144D_22_L      0x144D44
#define REG_BK144D_22_H      0x144D45
#define REG_BK144D_23_L      0x144D46
#define REG_BK144D_23_H      0x144D47
#define REG_BK144D_24_L      0x144D48
#define REG_BK144D_24_H      0x144D49
#define REG_BK144D_25_L      0x144D4A
#define REG_BK144D_25_H      0x144D4B
#define REG_BK144D_26_L      0x144D4C
#define REG_BK144D_26_H      0x144D4D
#define REG_BK144D_27_L      0x144D4E
#define REG_BK144D_27_H      0x144D4F
#define REG_BK144D_28_L      0x144D50
#define REG_BK144D_28_H      0x144D51
#define REG_BK144D_29_L      0x144D52
#define REG_BK144D_29_H      0x144D53
#define REG_BK144D_2A_L      0x144D54
#define REG_BK144D_2A_H      0x144D55
#define REG_BK144D_2B_L      0x144D56
#define REG_BK144D_2B_H      0x144D57
#define REG_BK144D_2C_L      0x144D58
#define REG_BK144D_2C_H      0x144D59
#define REG_BK144D_2D_L      0x144D5A
#define REG_BK144D_2D_H      0x144D5B
#define REG_BK144D_2E_L      0x144D5C
#define REG_BK144D_2E_H      0x144D5D
#define REG_BK144D_2F_L      0x144D5E
#define REG_BK144D_2F_H      0x144D5F
#define REG_BK144D_30_L      0x144D60
#define REG_BK144D_30_H      0x144D61
#define REG_BK144D_31_L      0x144D62
#define REG_BK144D_31_H      0x144D63
#define REG_BK144D_32_L      0x144D64
#define REG_BK144D_32_H      0x144D65
#define REG_BK144D_33_L      0x144D66
#define REG_BK144D_33_H      0x144D67
#define REG_BK144D_34_L      0x144D68
#define REG_BK144D_34_H      0x144D69
#define REG_BK144D_35_L      0x144D6A
#define REG_BK144D_35_H      0x144D6B
#define REG_BK144D_36_L      0x144D6C
#define REG_BK144D_36_H      0x144D6D
#define REG_BK144D_37_L      0x144D6E
#define REG_BK144D_37_H      0x144D6F
#define REG_BK144D_38_L      0x144D70
#define REG_BK144D_38_H      0x144D71
#define REG_BK144D_39_L      0x144D72
#define REG_BK144D_39_H      0x144D73
#define REG_BK144D_3A_L      0x144D74
#define REG_BK144D_3A_H      0x144D75
#define REG_BK144D_3B_L      0x144D76
#define REG_BK144D_3B_H      0x144D77
#define REG_BK144D_3C_L      0x144D78
#define REG_BK144D_3C_H      0x144D79
#define REG_BK144D_3D_L      0x144D7A
#define REG_BK144D_3D_H      0x144D7B
#define REG_BK144D_3E_L      0x144D7C
#define REG_BK144D_3E_H      0x144D7D
#define REG_BK144D_3F_L      0x144D7E
#define REG_BK144D_3F_H      0x144D7F
#define REG_BK144D_40_L      0x144D80
#define REG_BK144D_40_H      0x144D81
#define REG_BK144D_41_L      0x144D82
#define REG_BK144D_41_H      0x144D83
#define REG_BK144D_42_L      0x144D84
#define REG_BK144D_42_H      0x144D85
#define REG_BK144D_43_L      0x144D86
#define REG_BK144D_43_H      0x144D87
#define REG_BK144D_44_L      0x144D88
#define REG_BK144D_44_H      0x144D89
#define REG_BK144D_45_L      0x144D8A
#define REG_BK144D_45_H      0x144D8B
#define REG_BK144D_46_L      0x144D8C
#define REG_BK144D_46_H      0x144D8D
#define REG_BK144D_47_L      0x144D8E
#define REG_BK144D_47_H      0x144D8F
#define REG_BK144D_48_L      0x144D90
#define REG_BK144D_48_H      0x144D91
#define REG_BK144D_49_L      0x144D92
#define REG_BK144D_49_H      0x144D93
#define REG_BK144D_4A_L      0x144D94
#define REG_BK144D_4A_H      0x144D95
#define REG_BK144D_4B_L      0x144D96
#define REG_BK144D_4B_H      0x144D97
#define REG_BK144D_4C_L      0x144D98
#define REG_BK144D_4C_H      0x144D99
#define REG_BK144D_4D_L      0x144D9A
#define REG_BK144D_4D_H      0x144D9B
#define REG_BK144D_4E_L      0x144D9C
#define REG_BK144D_4E_H      0x144D9D
#define REG_BK144D_4F_L      0x144D9E
#define REG_BK144D_4F_H      0x144D9F
#define REG_BK144D_50_L      0x144DA0
#define REG_BK144D_50_H      0x144DA1
#define REG_BK144D_51_L      0x144DA2
#define REG_BK144D_51_H      0x144DA3
#define REG_BK144D_52_L      0x144DA4
#define REG_BK144D_52_H      0x144DA5
#define REG_BK144D_53_L      0x144DA6
#define REG_BK144D_53_H      0x144DA7
#define REG_BK144D_54_L      0x144DA8
#define REG_BK144D_54_H      0x144DA9
#define REG_BK144D_55_L      0x144DAA
#define REG_BK144D_55_H      0x144DAB
#define REG_BK144D_56_L      0x144DAC
#define REG_BK144D_56_H      0x144DAD
#define REG_BK144D_57_L      0x144DAE
#define REG_BK144D_57_H      0x144DAF
#define REG_BK144D_58_L      0x144DB0
#define REG_BK144D_58_H      0x144DB1
#define REG_BK144D_59_L      0x144DB2
#define REG_BK144D_59_H      0x144DB3
#define REG_BK144D_5A_L      0x144DB4
#define REG_BK144D_5A_H      0x144DB5
#define REG_BK144D_5B_L      0x144DB6
#define REG_BK144D_5B_H      0x144DB7
#define REG_BK144D_5C_L      0x144DB8
#define REG_BK144D_5C_H      0x144DB9
#define REG_BK144D_5D_L      0x144DBA
#define REG_BK144D_5D_H      0x144DBB
#define REG_BK144D_5E_L      0x144DBC
#define REG_BK144D_5E_H      0x144DBD
#define REG_BK144D_5F_L      0x144DBE
#define REG_BK144D_5F_H      0x144DBF
#define REG_BK144D_60_L      0x144DC0
#define REG_BK144D_60_H      0x144DC1
#define REG_BK144D_61_L      0x144DC2
#define REG_BK144D_61_H      0x144DC3
#define REG_BK144D_62_L      0x144DC4
#define REG_BK144D_62_H      0x144DC5
#define REG_BK144D_63_L      0x144DC6
#define REG_BK144D_63_H      0x144DC7
#define REG_BK144D_64_L      0x144DC8
#define REG_BK144D_64_H      0x144DC9
#define REG_BK144D_65_L      0x144DCA
#define REG_BK144D_65_H      0x144DCB
#define REG_BK144D_66_L      0x144DCC
#define REG_BK144D_66_H      0x144DCD
#define REG_BK144D_67_L      0x144DCE
#define REG_BK144D_67_H      0x144DCF
#define REG_BK144D_68_L      0x144DD0
#define REG_BK144D_68_H      0x144DD1
#define REG_BK144D_69_L      0x144DD2
#define REG_BK144D_69_H      0x144DD3
#define REG_BK144D_6A_L      0x144DD4
#define REG_BK144D_6A_H      0x144DD5
#define REG_BK144D_6B_L      0x144DD6
#define REG_BK144D_6B_H      0x144DD7
#define REG_BK144D_6C_L      0x144DD8
#define REG_BK144D_6C_H      0x144DD9
#define REG_BK144D_6D_L      0x144DDA
#define REG_BK144D_6D_H      0x144DDB
#define REG_BK144D_6E_L      0x144DDC
#define REG_BK144D_6E_H      0x144DDD
#define REG_BK144D_6F_L      0x144DDE
#define REG_BK144D_6F_H      0x144DDF
#define REG_BK144D_70_L      0x144DE0
#define REG_BK144D_70_H      0x144DE1
#define REG_BK144D_71_L      0x144DE2
#define REG_BK144D_71_H      0x144DE3
#define REG_BK144D_72_L      0x144DE4
#define REG_BK144D_72_H      0x144DE5
#define REG_BK144D_73_L      0x144DE6
#define REG_BK144D_73_H      0x144DE7
#define REG_BK144D_74_L      0x144DE8
#define REG_BK144D_74_H      0x144DE9
#define REG_BK144D_75_L      0x144DEA
#define REG_BK144D_75_H      0x144DEB
#define REG_BK144D_76_L      0x144DEC
#define REG_BK144D_76_H      0x144DED
#define REG_BK144D_77_L      0x144DEE
#define REG_BK144D_77_H      0x144DEF
#define REG_BK144D_78_L      0x144DF0
#define REG_BK144D_78_H      0x144DF1
#define REG_BK144D_79_L      0x144DF2
#define REG_BK144D_79_H      0x144DF3
#define REG_BK144D_7A_L      0x144DF4
#define REG_BK144D_7A_H      0x144DF5
#define REG_BK144D_7B_L      0x144DF6
#define REG_BK144D_7B_H      0x144DF7
#define REG_BK144D_7C_L      0x144DF8
#define REG_BK144D_7C_H      0x144DF9
#define REG_BK144D_7D_L      0x144DFA
#define REG_BK144D_7D_H      0x144DFB
#define REG_BK144D_7E_L      0x144DFC
#define REG_BK144D_7E_H      0x144DFD
#define REG_BK144D_7F_L      0x144DFE
#define REG_BK144D_7F_H      0x144DFF
//----------------------------------------------
#define REG_BK144F_00_L      0x144F00
#define REG_BK144F_00_H      0x144F01
#define REG_BK144F_01_L      0x144F02
#define REG_BK144F_01_H      0x144F03
#define REG_BK144F_02_L      0x144F04
#define REG_BK144F_02_H      0x144F05
#define REG_BK144F_03_L      0x144F06
#define REG_BK144F_03_H      0x144F07
#define REG_BK144F_04_L      0x144F08
#define REG_BK144F_04_H      0x144F09
#define REG_BK144F_05_L      0x144F0A
#define REG_BK144F_05_H      0x144F0B
#define REG_BK144F_06_L      0x144F0C
#define REG_BK144F_06_H      0x144F0D
#define REG_BK144F_07_L      0x144F0E
#define REG_BK144F_07_H      0x144F0F
#define REG_BK144F_08_L      0x144F10
#define REG_BK144F_08_H      0x144F11
#define REG_BK144F_09_L      0x144F12
#define REG_BK144F_09_H      0x144F13
#define REG_BK144F_0A_L      0x144F14
#define REG_BK144F_0A_H      0x144F15
#define REG_BK144F_0B_L      0x144F16
#define REG_BK144F_0B_H      0x144F17
#define REG_BK144F_0C_L      0x144F18
#define REG_BK144F_0C_H      0x144F19
#define REG_BK144F_0D_L      0x144F1A
#define REG_BK144F_0D_H      0x144F1B
#define REG_BK144F_0E_L      0x144F1C
#define REG_BK144F_0E_H      0x144F1D
#define REG_BK144F_0F_L      0x144F1E
#define REG_BK144F_0F_H      0x144F1F
#define REG_BK144F_10_L      0x144F20
#define REG_BK144F_10_H      0x144F21
#define REG_BK144F_11_L      0x144F22
#define REG_BK144F_11_H      0x144F23
#define REG_BK144F_12_L      0x144F24
#define REG_BK144F_12_H      0x144F25
#define REG_BK144F_13_L      0x144F26
#define REG_BK144F_13_H      0x144F27
#define REG_BK144F_14_L      0x144F28
#define REG_BK144F_14_H      0x144F29
#define REG_BK144F_15_L      0x144F2A
#define REG_BK144F_15_H      0x144F2B
#define REG_BK144F_16_L      0x144F2C
#define REG_BK144F_16_H      0x144F2D
#define REG_BK144F_17_L      0x144F2E
#define REG_BK144F_17_H      0x144F2F
#define REG_BK144F_18_L      0x144F30
#define REG_BK144F_18_H      0x144F31
#define REG_BK144F_19_L      0x144F32
#define REG_BK144F_19_H      0x144F33
#define REG_BK144F_1A_L      0x144F34
#define REG_BK144F_1A_H      0x144F35
#define REG_BK144F_1B_L      0x144F36
#define REG_BK144F_1B_H      0x144F37
#define REG_BK144F_1C_L      0x144F38
#define REG_BK144F_1C_H      0x144F39
#define REG_BK144F_1D_L      0x144F3A
#define REG_BK144F_1D_H      0x144F3B
#define REG_BK144F_1E_L      0x144F3C
#define REG_BK144F_1E_H      0x144F3D
#define REG_BK144F_1F_L      0x144F3E
#define REG_BK144F_1F_H      0x144F3F
#define REG_BK144F_20_L      0x144F40
#define REG_BK144F_20_H      0x144F41
#define REG_BK144F_21_L      0x144F42
#define REG_BK144F_21_H      0x144F43
#define REG_BK144F_22_L      0x144F44
#define REG_BK144F_22_H      0x144F45
#define REG_BK144F_23_L      0x144F46
#define REG_BK144F_23_H      0x144F47
#define REG_BK144F_24_L      0x144F48
#define REG_BK144F_24_H      0x144F49
#define REG_BK144F_25_L      0x144F4A
#define REG_BK144F_25_H      0x144F4B
#define REG_BK144F_26_L      0x144F4C
#define REG_BK144F_26_H      0x144F4D
#define REG_BK144F_27_L      0x144F4E
#define REG_BK144F_27_H      0x144F4F
#define REG_BK144F_28_L      0x144F50
#define REG_BK144F_28_H      0x144F51
#define REG_BK144F_29_L      0x144F52
#define REG_BK144F_29_H      0x144F53
#define REG_BK144F_2A_L      0x144F54
#define REG_BK144F_2A_H      0x144F55
#define REG_BK144F_2B_L      0x144F56
#define REG_BK144F_2B_H      0x144F57
#define REG_BK144F_2C_L      0x144F58
#define REG_BK144F_2C_H      0x144F59
#define REG_BK144F_2D_L      0x144F5A
#define REG_BK144F_2D_H      0x144F5B
#define REG_BK144F_2E_L      0x144F5C
#define REG_BK144F_2E_H      0x144F5D
#define REG_BK144F_2F_L      0x144F5E
#define REG_BK144F_2F_H      0x144F5F
#define REG_BK144F_30_L      0x144F60
#define REG_BK144F_30_H      0x144F61
#define REG_BK144F_31_L      0x144F62
#define REG_BK144F_31_H      0x144F63
#define REG_BK144F_32_L      0x144F64
#define REG_BK144F_32_H      0x144F65
#define REG_BK144F_33_L      0x144F66
#define REG_BK144F_33_H      0x144F67
#define REG_BK144F_34_L      0x144F68
#define REG_BK144F_34_H      0x144F69
#define REG_BK144F_35_L      0x144F6A
#define REG_BK144F_35_H      0x144F6B
#define REG_BK144F_36_L      0x144F6C
#define REG_BK144F_36_H      0x144F6D
#define REG_BK144F_37_L      0x144F6E
#define REG_BK144F_37_H      0x144F6F
#define REG_BK144F_38_L      0x144F70
#define REG_BK144F_38_H      0x144F71
#define REG_BK144F_39_L      0x144F72
#define REG_BK144F_39_H      0x144F73
#define REG_BK144F_3A_L      0x144F74
#define REG_BK144F_3A_H      0x144F75
#define REG_BK144F_3B_L      0x144F76
#define REG_BK144F_3B_H      0x144F77
#define REG_BK144F_3C_L      0x144F78
#define REG_BK144F_3C_H      0x144F79
#define REG_BK144F_3D_L      0x144F7A
#define REG_BK144F_3D_H      0x144F7B
#define REG_BK144F_3E_L      0x144F7C
#define REG_BK144F_3E_H      0x144F7D
#define REG_BK144F_3F_L      0x144F7E
#define REG_BK144F_3F_H      0x144F7F
#define REG_BK144F_40_L      0x144F80
#define REG_BK144F_40_H      0x144F81
#define REG_BK144F_41_L      0x144F82
#define REG_BK144F_41_H      0x144F83
#define REG_BK144F_42_L      0x144F84
#define REG_BK144F_42_H      0x144F85
#define REG_BK144F_43_L      0x144F86
#define REG_BK144F_43_H      0x144F87
#define REG_BK144F_44_L      0x144F88
#define REG_BK144F_44_H      0x144F89
#define REG_BK144F_45_L      0x144F8A
#define REG_BK144F_45_H      0x144F8B
#define REG_BK144F_46_L      0x144F8C
#define REG_BK144F_46_H      0x144F8D
#define REG_BK144F_47_L      0x144F8E
#define REG_BK144F_47_H      0x144F8F
#define REG_BK144F_48_L      0x144F90
#define REG_BK144F_48_H      0x144F91
#define REG_BK144F_49_L      0x144F92
#define REG_BK144F_49_H      0x144F93
#define REG_BK144F_4A_L      0x144F94
#define REG_BK144F_4A_H      0x144F95
#define REG_BK144F_4B_L      0x144F96
#define REG_BK144F_4B_H      0x144F97
#define REG_BK144F_4C_L      0x144F98
#define REG_BK144F_4C_H      0x144F99
#define REG_BK144F_4D_L      0x144F9A
#define REG_BK144F_4D_H      0x144F9B
#define REG_BK144F_4E_L      0x144F9C
#define REG_BK144F_4E_H      0x144F9D
#define REG_BK144F_4F_L      0x144F9E
#define REG_BK144F_4F_H      0x144F9F
#define REG_BK144F_50_L      0x144FA0
#define REG_BK144F_50_H      0x144FA1
#define REG_BK144F_51_L      0x144FA2
#define REG_BK144F_51_H      0x144FA3
#define REG_BK144F_52_L      0x144FA4
#define REG_BK144F_52_H      0x144FA5
#define REG_BK144F_53_L      0x144FA6
#define REG_BK144F_53_H      0x144FA7
#define REG_BK144F_54_L      0x144FA8
#define REG_BK144F_54_H      0x144FA9
#define REG_BK144F_55_L      0x144FAA
#define REG_BK144F_55_H      0x144FAB
#define REG_BK144F_56_L      0x144FAC
#define REG_BK144F_56_H      0x144FAD
#define REG_BK144F_57_L      0x144FAE
#define REG_BK144F_57_H      0x144FAF
#define REG_BK144F_58_L      0x144FB0
#define REG_BK144F_58_H      0x144FB1
#define REG_BK144F_59_L      0x144FB2
#define REG_BK144F_59_H      0x144FB3
#define REG_BK144F_5A_L      0x144FB4
#define REG_BK144F_5A_H      0x144FB5
#define REG_BK144F_5B_L      0x144FB6
#define REG_BK144F_5B_H      0x144FB7
#define REG_BK144F_5C_L      0x144FB8
#define REG_BK144F_5C_H      0x144FB9
#define REG_BK144F_5D_L      0x144FBA
#define REG_BK144F_5D_H      0x144FBB
#define REG_BK144F_5E_L      0x144FBC
#define REG_BK144F_5E_H      0x144FBD
#define REG_BK144F_5F_L      0x144FBE
#define REG_BK144F_5F_H      0x144FBF
#define REG_BK144F_60_L      0x144FC0
#define REG_BK144F_60_H      0x144FC1
#define REG_BK144F_61_L      0x144FC2
#define REG_BK144F_61_H      0x144FC3
#define REG_BK144F_62_L      0x144FC4
#define REG_BK144F_62_H      0x144FC5
#define REG_BK144F_63_L      0x144FC6
#define REG_BK144F_63_H      0x144FC7
#define REG_BK144F_64_L      0x144FC8
#define REG_BK144F_64_H      0x144FC9
#define REG_BK144F_65_L      0x144FCA
#define REG_BK144F_65_H      0x144FCB
#define REG_BK144F_66_L      0x144FCC
#define REG_BK144F_66_H      0x144FCD
#define REG_BK144F_67_L      0x144FCE
#define REG_BK144F_67_H      0x144FCF
#define REG_BK144F_68_L      0x144FD0
#define REG_BK144F_68_H      0x144FD1
#define REG_BK144F_69_L      0x144FD2
#define REG_BK144F_69_H      0x144FD3
#define REG_BK144F_6A_L      0x144FD4
#define REG_BK144F_6A_H      0x144FD5
#define REG_BK144F_6B_L      0x144FD6
#define REG_BK144F_6B_H      0x144FD7
#define REG_BK144F_6C_L      0x144FD8
#define REG_BK144F_6C_H      0x144FD9
#define REG_BK144F_6D_L      0x144FDA
#define REG_BK144F_6D_H      0x144FDB
#define REG_BK144F_6E_L      0x144FDC
#define REG_BK144F_6E_H      0x144FDD
#define REG_BK144F_6F_L      0x144FDE
#define REG_BK144F_6F_H      0x144FDF
#define REG_BK144F_70_L      0x144FE0
#define REG_BK144F_70_H      0x144FE1
#define REG_BK144F_71_L      0x144FE2
#define REG_BK144F_71_H      0x144FE3
#define REG_BK144F_72_L      0x144FE4
#define REG_BK144F_72_H      0x144FE5
#define REG_BK144F_73_L      0x144FE6
#define REG_BK144F_73_H      0x144FE7
#define REG_BK144F_74_L      0x144FE8
#define REG_BK144F_74_H      0x144FE9
#define REG_BK144F_75_L      0x144FEA
#define REG_BK144F_75_H      0x144FEB
#define REG_BK144F_76_L      0x144FEC
#define REG_BK144F_76_H      0x144FED
#define REG_BK144F_77_L      0x144FEE
#define REG_BK144F_77_H      0x144FEF
#define REG_BK144F_78_L      0x144FF0
#define REG_BK144F_78_H      0x144FF1
#define REG_BK144F_79_L      0x144FF2
#define REG_BK144F_79_H      0x144FF3
#define REG_BK144F_7A_L      0x144FF4
#define REG_BK144F_7A_H      0x144FF5
#define REG_BK144F_7B_L      0x144FF6
#define REG_BK144F_7B_H      0x144FF7
#define REG_BK144F_7C_L      0x144FF8
#define REG_BK144F_7C_H      0x144FF9
#define REG_BK144F_7D_L      0x144FFA
#define REG_BK144F_7D_H      0x144FFB
#define REG_BK144F_7E_L      0x144FFC
#define REG_BK144F_7E_H      0x144FFD
#define REG_BK144F_7F_L      0x144FFE
#define REG_BK144F_7F_H      0x144FFF
//----------------------------------------------
#define REG_BK1455_00_L      0x145500
#define REG_BK1455_00_H      0x145501
#define REG_BK1455_01_L      0x145502
#define REG_BK1455_01_H      0x145503
#define REG_BK1455_02_L      0x145504
#define REG_BK1455_02_H      0x145505
#define REG_BK1455_03_L      0x145506
#define REG_BK1455_03_H      0x145507
#define REG_BK1455_04_L      0x145508
#define REG_BK1455_04_H      0x145509
#define REG_BK1455_05_L      0x14550A
#define REG_BK1455_05_H      0x14550B
#define REG_BK1455_06_L      0x14550C
#define REG_BK1455_06_H      0x14550D
#define REG_BK1455_07_L      0x14550E
#define REG_BK1455_07_H      0x14550F
#define REG_BK1455_08_L      0x145510
#define REG_BK1455_08_H      0x145511
#define REG_BK1455_09_L      0x145512
#define REG_BK1455_09_H      0x145513
#define REG_BK1455_0A_L      0x145514
#define REG_BK1455_0A_H      0x145515
#define REG_BK1455_0B_L      0x145516
#define REG_BK1455_0B_H      0x145517
#define REG_BK1455_0C_L      0x145518
#define REG_BK1455_0C_H      0x145519
#define REG_BK1455_0D_L      0x14551A
#define REG_BK1455_0D_H      0x14551B
#define REG_BK1455_0E_L      0x14551C
#define REG_BK1455_0E_H      0x14551D
#define REG_BK1455_0F_L      0x14551E
#define REG_BK1455_0F_H      0x14551F
#define REG_BK1455_10_L      0x145520
#define REG_BK1455_10_H      0x145521
#define REG_BK1455_11_L      0x145522
#define REG_BK1455_11_H      0x145523
#define REG_BK1455_12_L      0x145524
#define REG_BK1455_12_H      0x145525
#define REG_BK1455_13_L      0x145526
#define REG_BK1455_13_H      0x145527
#define REG_BK1455_14_L      0x145528
#define REG_BK1455_14_H      0x145529
#define REG_BK1455_15_L      0x14552A
#define REG_BK1455_15_H      0x14552B
#define REG_BK1455_16_L      0x14552C
#define REG_BK1455_16_H      0x14552D
#define REG_BK1455_17_L      0x14552E
#define REG_BK1455_17_H      0x14552F
#define REG_BK1455_18_L      0x145530
#define REG_BK1455_18_H      0x145531
#define REG_BK1455_19_L      0x145532
#define REG_BK1455_19_H      0x145533
#define REG_BK1455_1A_L      0x145534
#define REG_BK1455_1A_H      0x145535
#define REG_BK1455_1B_L      0x145536
#define REG_BK1455_1B_H      0x145537
#define REG_BK1455_1C_L      0x145538
#define REG_BK1455_1C_H      0x145539
#define REG_BK1455_1D_L      0x14553A
#define REG_BK1455_1D_H      0x14553B
#define REG_BK1455_1E_L      0x14553C
#define REG_BK1455_1E_H      0x14553D
#define REG_BK1455_1F_L      0x14553E
#define REG_BK1455_1F_H      0x14553F
#define REG_BK1455_20_L      0x145540
#define REG_BK1455_20_H      0x145541
#define REG_BK1455_21_L      0x145542
#define REG_BK1455_21_H      0x145543
#define REG_BK1455_22_L      0x145544
#define REG_BK1455_22_H      0x145545
#define REG_BK1455_23_L      0x145546
#define REG_BK1455_23_H      0x145547
#define REG_BK1455_24_L      0x145548
#define REG_BK1455_24_H      0x145549
#define REG_BK1455_25_L      0x14554A
#define REG_BK1455_25_H      0x14554B
#define REG_BK1455_26_L      0x14554C
#define REG_BK1455_26_H      0x14554D
#define REG_BK1455_27_L      0x14554E
#define REG_BK1455_27_H      0x14554F
#define REG_BK1455_28_L      0x145550
#define REG_BK1455_28_H      0x145551
#define REG_BK1455_29_L      0x145552
#define REG_BK1455_29_H      0x145553
#define REG_BK1455_2A_L      0x145554
#define REG_BK1455_2A_H      0x145555
#define REG_BK1455_2B_L      0x145556
#define REG_BK1455_2B_H      0x145557
#define REG_BK1455_2C_L      0x145558
#define REG_BK1455_2C_H      0x145559
#define REG_BK1455_2D_L      0x14555A
#define REG_BK1455_2D_H      0x14555B
#define REG_BK1455_2E_L      0x14555C
#define REG_BK1455_2E_H      0x14555D
#define REG_BK1455_2F_L      0x14555E
#define REG_BK1455_2F_H      0x14555F
#define REG_BK1455_30_L      0x145560
#define REG_BK1455_30_H      0x145561
#define REG_BK1455_31_L      0x145562
#define REG_BK1455_31_H      0x145563
#define REG_BK1455_32_L      0x145564
#define REG_BK1455_32_H      0x145565
#define REG_BK1455_33_L      0x145566
#define REG_BK1455_33_H      0x145567
#define REG_BK1455_34_L      0x145568
#define REG_BK1455_34_H      0x145569
#define REG_BK1455_35_L      0x14556A
#define REG_BK1455_35_H      0x14556B
#define REG_BK1455_36_L      0x14556C
#define REG_BK1455_36_H      0x14556D
#define REG_BK1455_37_L      0x14556E
#define REG_BK1455_37_H      0x14556F
#define REG_BK1455_38_L      0x145570
#define REG_BK1455_38_H      0x145571
#define REG_BK1455_39_L      0x145572
#define REG_BK1455_39_H      0x145573
#define REG_BK1455_3A_L      0x145574
#define REG_BK1455_3A_H      0x145575
#define REG_BK1455_3B_L      0x145576
#define REG_BK1455_3B_H      0x145577
#define REG_BK1455_3C_L      0x145578
#define REG_BK1455_3C_H      0x145579
#define REG_BK1455_3D_L      0x14557A
#define REG_BK1455_3D_H      0x14557B
#define REG_BK1455_3E_L      0x14557C
#define REG_BK1455_3E_H      0x14557D
#define REG_BK1455_3F_L      0x14557E
#define REG_BK1455_3F_H      0x14557F
#define REG_BK1455_40_L      0x145580
#define REG_BK1455_40_H      0x145581
#define REG_BK1455_41_L      0x145582
#define REG_BK1455_41_H      0x145583
#define REG_BK1455_42_L      0x145584
#define REG_BK1455_42_H      0x145585
#define REG_BK1455_43_L      0x145586
#define REG_BK1455_43_H      0x145587
#define REG_BK1455_44_L      0x145588
#define REG_BK1455_44_H      0x145589
#define REG_BK1455_45_L      0x14558A
#define REG_BK1455_45_H      0x14558B
#define REG_BK1455_46_L      0x14558C
#define REG_BK1455_46_H      0x14558D
#define REG_BK1455_47_L      0x14558E
#define REG_BK1455_47_H      0x14558F
#define REG_BK1455_48_L      0x145590
#define REG_BK1455_48_H      0x145591
#define REG_BK1455_49_L      0x145592
#define REG_BK1455_49_H      0x145593
#define REG_BK1455_4A_L      0x145594
#define REG_BK1455_4A_H      0x145595
#define REG_BK1455_4B_L      0x145596
#define REG_BK1455_4B_H      0x145597
#define REG_BK1455_4C_L      0x145598
#define REG_BK1455_4C_H      0x145599
#define REG_BK1455_4D_L      0x14559A
#define REG_BK1455_4D_H      0x14559B
#define REG_BK1455_4E_L      0x14559C
#define REG_BK1455_4E_H      0x14559D
#define REG_BK1455_4F_L      0x14559E
#define REG_BK1455_4F_H      0x14559F
#define REG_BK1455_50_L      0x1455A0
#define REG_BK1455_50_H      0x1455A1
#define REG_BK1455_51_L      0x1455A2
#define REG_BK1455_51_H      0x1455A3
#define REG_BK1455_52_L      0x1455A4
#define REG_BK1455_52_H      0x1455A5
#define REG_BK1455_53_L      0x1455A6
#define REG_BK1455_53_H      0x1455A7
#define REG_BK1455_54_L      0x1455A8
#define REG_BK1455_54_H      0x1455A9
#define REG_BK1455_55_L      0x1455AA
#define REG_BK1455_55_H      0x1455AB
#define REG_BK1455_56_L      0x1455AC
#define REG_BK1455_56_H      0x1455AD
#define REG_BK1455_57_L      0x1455AE
#define REG_BK1455_57_H      0x1455AF
#define REG_BK1455_58_L      0x1455B0
#define REG_BK1455_58_H      0x1455B1
#define REG_BK1455_59_L      0x1455B2
#define REG_BK1455_59_H      0x1455B3
#define REG_BK1455_5A_L      0x1455B4
#define REG_BK1455_5A_H      0x1455B5
#define REG_BK1455_5B_L      0x1455B6
#define REG_BK1455_5B_H      0x1455B7
#define REG_BK1455_5C_L      0x1455B8
#define REG_BK1455_5C_H      0x1455B9
#define REG_BK1455_5D_L      0x1455BA
#define REG_BK1455_5D_H      0x1455BB
#define REG_BK1455_5E_L      0x1455BC
#define REG_BK1455_5E_H      0x1455BD
#define REG_BK1455_5F_L      0x1455BE
#define REG_BK1455_5F_H      0x1455BF
#define REG_BK1455_60_L      0x1455C0
#define REG_BK1455_60_H      0x1455C1
#define REG_BK1455_61_L      0x1455C2
#define REG_BK1455_61_H      0x1455C3
#define REG_BK1455_62_L      0x1455C4
#define REG_BK1455_62_H      0x1455C5
#define REG_BK1455_63_L      0x1455C6
#define REG_BK1455_63_H      0x1455C7
#define REG_BK1455_64_L      0x1455C8
#define REG_BK1455_64_H      0x1455C9
#define REG_BK1455_65_L      0x1455CA
#define REG_BK1455_65_H      0x1455CB
#define REG_BK1455_66_L      0x1455CC
#define REG_BK1455_66_H      0x1455CD
#define REG_BK1455_67_L      0x1455CE
#define REG_BK1455_67_H      0x1455CF
#define REG_BK1455_68_L      0x1455D0
#define REG_BK1455_68_H      0x1455D1
#define REG_BK1455_69_L      0x1455D2
#define REG_BK1455_69_H      0x1455D3
#define REG_BK1455_6A_L      0x1455D4
#define REG_BK1455_6A_H      0x1455D5
#define REG_BK1455_6B_L      0x1455D6
#define REG_BK1455_6B_H      0x1455D7
#define REG_BK1455_6C_L      0x1455D8
#define REG_BK1455_6C_H      0x1455D9
#define REG_BK1455_6D_L      0x1455DA
#define REG_BK1455_6D_H      0x1455DB
#define REG_BK1455_6E_L      0x1455DC
#define REG_BK1455_6E_H      0x1455DD
#define REG_BK1455_6F_L      0x1455DE
#define REG_BK1455_6F_H      0x1455DF
#define REG_BK1455_70_L      0x1455E0
#define REG_BK1455_70_H      0x1455E1
#define REG_BK1455_71_L      0x1455E2
#define REG_BK1455_71_H      0x1455E3
#define REG_BK1455_72_L      0x1455E4
#define REG_BK1455_72_H      0x1455E5
#define REG_BK1455_73_L      0x1455E6
#define REG_BK1455_73_H      0x1455E7
#define REG_BK1455_74_L      0x1455E8
#define REG_BK1455_74_H      0x1455E9
#define REG_BK1455_75_L      0x1455EA
#define REG_BK1455_75_H      0x1455EB
#define REG_BK1455_76_L      0x1455EC
#define REG_BK1455_76_H      0x1455ED
#define REG_BK1455_77_L      0x1455EE
#define REG_BK1455_77_H      0x1455EF
#define REG_BK1455_78_L      0x1455F0
#define REG_BK1455_78_H      0x1455F1
#define REG_BK1455_79_L      0x1455F2
#define REG_BK1455_79_H      0x1455F3
#define REG_BK1455_7A_L      0x1455F4
#define REG_BK1455_7A_H      0x1455F5
#define REG_BK1455_7B_L      0x1455F6
#define REG_BK1455_7B_H      0x1455F7
#define REG_BK1455_7C_L      0x1455F8
#define REG_BK1455_7C_H      0x1455F9
#define REG_BK1455_7D_L      0x1455FA
#define REG_BK1455_7D_H      0x1455FB
#define REG_BK1455_7E_L      0x1455FC
#define REG_BK1455_7E_H      0x1455FD
#define REG_BK1455_7F_L      0x1455FE
#define REG_BK1455_7F_H      0x1455FF
//----------------------------------------------
#define REG_BK1456_00_L      0x145600
#define REG_BK1456_00_H      0x145601
#define REG_BK1456_01_L      0x145602
#define REG_BK1456_01_H      0x145603
#define REG_BK1456_02_L      0x145604
#define REG_BK1456_02_H      0x145605
#define REG_BK1456_03_L      0x145606
#define REG_BK1456_03_H      0x145607
#define REG_BK1456_04_L      0x145608
#define REG_BK1456_04_H      0x145609
#define REG_BK1456_05_L      0x14560A
#define REG_BK1456_05_H      0x14560B
#define REG_BK1456_06_L      0x14560C
#define REG_BK1456_06_H      0x14560D
#define REG_BK1456_07_L      0x14560E
#define REG_BK1456_07_H      0x14560F
#define REG_BK1456_08_L      0x145610
#define REG_BK1456_08_H      0x145611
#define REG_BK1456_09_L      0x145612
#define REG_BK1456_09_H      0x145613
#define REG_BK1456_0A_L      0x145614
#define REG_BK1456_0A_H      0x145615
#define REG_BK1456_0B_L      0x145616
#define REG_BK1456_0B_H      0x145617
#define REG_BK1456_0C_L      0x145618
#define REG_BK1456_0C_H      0x145619
#define REG_BK1456_0D_L      0x14561A
#define REG_BK1456_0D_H      0x14561B
#define REG_BK1456_0E_L      0x14561C
#define REG_BK1456_0E_H      0x14561D
#define REG_BK1456_0F_L      0x14561E
#define REG_BK1456_0F_H      0x14561F
#define REG_BK1456_10_L      0x145620
#define REG_BK1456_10_H      0x145621
#define REG_BK1456_11_L      0x145622
#define REG_BK1456_11_H      0x145623
#define REG_BK1456_12_L      0x145624
#define REG_BK1456_12_H      0x145625
#define REG_BK1456_13_L      0x145626
#define REG_BK1456_13_H      0x145627
#define REG_BK1456_14_L      0x145628
#define REG_BK1456_14_H      0x145629
#define REG_BK1456_15_L      0x14562A
#define REG_BK1456_15_H      0x14562B
#define REG_BK1456_16_L      0x14562C
#define REG_BK1456_16_H      0x14562D
#define REG_BK1456_17_L      0x14562E
#define REG_BK1456_17_H      0x14562F
#define REG_BK1456_18_L      0x145630
#define REG_BK1456_18_H      0x145631
#define REG_BK1456_19_L      0x145632
#define REG_BK1456_19_H      0x145633
#define REG_BK1456_1A_L      0x145634
#define REG_BK1456_1A_H      0x145635
#define REG_BK1456_1B_L      0x145636
#define REG_BK1456_1B_H      0x145637
#define REG_BK1456_1C_L      0x145638
#define REG_BK1456_1C_H      0x145639
#define REG_BK1456_1D_L      0x14563A
#define REG_BK1456_1D_H      0x14563B
#define REG_BK1456_1E_L      0x14563C
#define REG_BK1456_1E_H      0x14563D
#define REG_BK1456_1F_L      0x14563E
#define REG_BK1456_1F_H      0x14563F
#define REG_BK1456_20_L      0x145640
#define REG_BK1456_20_H      0x145641
#define REG_BK1456_21_L      0x145642
#define REG_BK1456_21_H      0x145643
#define REG_BK1456_22_L      0x145644
#define REG_BK1456_22_H      0x145645
#define REG_BK1456_23_L      0x145646
#define REG_BK1456_23_H      0x145647
#define REG_BK1456_24_L      0x145648
#define REG_BK1456_24_H      0x145649
#define REG_BK1456_25_L      0x14564A
#define REG_BK1456_25_H      0x14564B
#define REG_BK1456_26_L      0x14564C
#define REG_BK1456_26_H      0x14564D
#define REG_BK1456_27_L      0x14564E
#define REG_BK1456_27_H      0x14564F
#define REG_BK1456_28_L      0x145650
#define REG_BK1456_28_H      0x145651
#define REG_BK1456_29_L      0x145652
#define REG_BK1456_29_H      0x145653
#define REG_BK1456_2A_L      0x145654
#define REG_BK1456_2A_H      0x145655
#define REG_BK1456_2B_L      0x145656
#define REG_BK1456_2B_H      0x145657
#define REG_BK1456_2C_L      0x145658
#define REG_BK1456_2C_H      0x145659
#define REG_BK1456_2D_L      0x14565A
#define REG_BK1456_2D_H      0x14565B
#define REG_BK1456_2E_L      0x14565C
#define REG_BK1456_2E_H      0x14565D
#define REG_BK1456_2F_L      0x14565E
#define REG_BK1456_2F_H      0x14565F
#define REG_BK1456_30_L      0x145660
#define REG_BK1456_30_H      0x145661
#define REG_BK1456_31_L      0x145662
#define REG_BK1456_31_H      0x145663
#define REG_BK1456_32_L      0x145664
#define REG_BK1456_32_H      0x145665
#define REG_BK1456_33_L      0x145666
#define REG_BK1456_33_H      0x145667
#define REG_BK1456_34_L      0x145668
#define REG_BK1456_34_H      0x145669
#define REG_BK1456_35_L      0x14566A
#define REG_BK1456_35_H      0x14566B
#define REG_BK1456_36_L      0x14566C
#define REG_BK1456_36_H      0x14566D
#define REG_BK1456_37_L      0x14566E
#define REG_BK1456_37_H      0x14566F
#define REG_BK1456_38_L      0x145670
#define REG_BK1456_38_H      0x145671
#define REG_BK1456_39_L      0x145672
#define REG_BK1456_39_H      0x145673
#define REG_BK1456_3A_L      0x145674
#define REG_BK1456_3A_H      0x145675
#define REG_BK1456_3B_L      0x145676
#define REG_BK1456_3B_H      0x145677
#define REG_BK1456_3C_L      0x145678
#define REG_BK1456_3C_H      0x145679
#define REG_BK1456_3D_L      0x14567A
#define REG_BK1456_3D_H      0x14567B
#define REG_BK1456_3E_L      0x14567C
#define REG_BK1456_3E_H      0x14567D
#define REG_BK1456_3F_L      0x14567E
#define REG_BK1456_3F_H      0x14567F
#define REG_BK1456_40_L      0x145680
#define REG_BK1456_40_H      0x145681
#define REG_BK1456_41_L      0x145682
#define REG_BK1456_41_H      0x145683
#define REG_BK1456_42_L      0x145684
#define REG_BK1456_42_H      0x145685
#define REG_BK1456_43_L      0x145686
#define REG_BK1456_43_H      0x145687
#define REG_BK1456_44_L      0x145688
#define REG_BK1456_44_H      0x145689
#define REG_BK1456_45_L      0x14568A
#define REG_BK1456_45_H      0x14568B
#define REG_BK1456_46_L      0x14568C
#define REG_BK1456_46_H      0x14568D
#define REG_BK1456_47_L      0x14568E
#define REG_BK1456_47_H      0x14568F
#define REG_BK1456_48_L      0x145690
#define REG_BK1456_48_H      0x145691
#define REG_BK1456_49_L      0x145692
#define REG_BK1456_49_H      0x145693
#define REG_BK1456_4A_L      0x145694
#define REG_BK1456_4A_H      0x145695
#define REG_BK1456_4B_L      0x145696
#define REG_BK1456_4B_H      0x145697
#define REG_BK1456_4C_L      0x145698
#define REG_BK1456_4C_H      0x145699
#define REG_BK1456_4D_L      0x14569A
#define REG_BK1456_4D_H      0x14569B
#define REG_BK1456_4E_L      0x14569C
#define REG_BK1456_4E_H      0x14569D
#define REG_BK1456_4F_L      0x14569E
#define REG_BK1456_4F_H      0x14569F
#define REG_BK1456_50_L      0x1456A0
#define REG_BK1456_50_H      0x1456A1
#define REG_BK1456_51_L      0x1456A2
#define REG_BK1456_51_H      0x1456A3
#define REG_BK1456_52_L      0x1456A4
#define REG_BK1456_52_H      0x1456A5
#define REG_BK1456_53_L      0x1456A6
#define REG_BK1456_53_H      0x1456A7
#define REG_BK1456_54_L      0x1456A8
#define REG_BK1456_54_H      0x1456A9
#define REG_BK1456_55_L      0x1456AA
#define REG_BK1456_55_H      0x1456AB
#define REG_BK1456_56_L      0x1456AC
#define REG_BK1456_56_H      0x1456AD
#define REG_BK1456_57_L      0x1456AE
#define REG_BK1456_57_H      0x1456AF
#define REG_BK1456_58_L      0x1456B0
#define REG_BK1456_58_H      0x1456B1
#define REG_BK1456_59_L      0x1456B2
#define REG_BK1456_59_H      0x1456B3
#define REG_BK1456_5A_L      0x1456B4
#define REG_BK1456_5A_H      0x1456B5
#define REG_BK1456_5B_L      0x1456B6
#define REG_BK1456_5B_H      0x1456B7
#define REG_BK1456_5C_L      0x1456B8
#define REG_BK1456_5C_H      0x1456B9
#define REG_BK1456_5D_L      0x1456BA
#define REG_BK1456_5D_H      0x1456BB
#define REG_BK1456_5E_L      0x1456BC
#define REG_BK1456_5E_H      0x1456BD
#define REG_BK1456_5F_L      0x1456BE
#define REG_BK1456_5F_H      0x1456BF
#define REG_BK1456_60_L      0x1456C0
#define REG_BK1456_60_H      0x1456C1
#define REG_BK1456_61_L      0x1456C2
#define REG_BK1456_61_H      0x1456C3
#define REG_BK1456_62_L      0x1456C4
#define REG_BK1456_62_H      0x1456C5
#define REG_BK1456_63_L      0x1456C6
#define REG_BK1456_63_H      0x1456C7
#define REG_BK1456_64_L      0x1456C8
#define REG_BK1456_64_H      0x1456C9
#define REG_BK1456_65_L      0x1456CA
#define REG_BK1456_65_H      0x1456CB
#define REG_BK1456_66_L      0x1456CC
#define REG_BK1456_66_H      0x1456CD
#define REG_BK1456_67_L      0x1456CE
#define REG_BK1456_67_H      0x1456CF
#define REG_BK1456_68_L      0x1456D0
#define REG_BK1456_68_H      0x1456D1
#define REG_BK1456_69_L      0x1456D2
#define REG_BK1456_69_H      0x1456D3
#define REG_BK1456_6A_L      0x1456D4
#define REG_BK1456_6A_H      0x1456D5
#define REG_BK1456_6B_L      0x1456D6
#define REG_BK1456_6B_H      0x1456D7
#define REG_BK1456_6C_L      0x1456D8
#define REG_BK1456_6C_H      0x1456D9
#define REG_BK1456_6D_L      0x1456DA
#define REG_BK1456_6D_H      0x1456DB
#define REG_BK1456_6E_L      0x1456DC
#define REG_BK1456_6E_H      0x1456DD
#define REG_BK1456_6F_L      0x1456DE
#define REG_BK1456_6F_H      0x1456DF
#define REG_BK1456_70_L      0x1456E0
#define REG_BK1456_70_H      0x1456E1
#define REG_BK1456_71_L      0x1456E2
#define REG_BK1456_71_H      0x1456E3
#define REG_BK1456_72_L      0x1456E4
#define REG_BK1456_72_H      0x1456E5
#define REG_BK1456_73_L      0x1456E6
#define REG_BK1456_73_H      0x1456E7
#define REG_BK1456_74_L      0x1456E8
#define REG_BK1456_74_H      0x1456E9
#define REG_BK1456_75_L      0x1456EA
#define REG_BK1456_75_H      0x1456EB
#define REG_BK1456_76_L      0x1456EC
#define REG_BK1456_76_H      0x1456ED
#define REG_BK1456_77_L      0x1456EE
#define REG_BK1456_77_H      0x1456EF
#define REG_BK1456_78_L      0x1456F0
#define REG_BK1456_78_H      0x1456F1
#define REG_BK1456_79_L      0x1456F2
#define REG_BK1456_79_H      0x1456F3
#define REG_BK1456_7A_L      0x1456F4
#define REG_BK1456_7A_H      0x1456F5
#define REG_BK1456_7B_L      0x1456F6
#define REG_BK1456_7B_H      0x1456F7
#define REG_BK1456_7C_L      0x1456F8
#define REG_BK1456_7C_H      0x1456F9
#define REG_BK1456_7D_L      0x1456FA
#define REG_BK1456_7D_H      0x1456FB
#define REG_BK1456_7E_L      0x1456FC
#define REG_BK1456_7E_H      0x1456FD
#define REG_BK1456_7F_L      0x1456FE
#define REG_BK1456_7F_H      0x1456FF
//----------------------------------------------
#define REG_BK1457_00_L      0x145700
#define REG_BK1457_00_H      0x145701
#define REG_BK1457_01_L      0x145702
#define REG_BK1457_01_H      0x145703
#define REG_BK1457_02_L      0x145704
#define REG_BK1457_02_H      0x145705
#define REG_BK1457_03_L      0x145706
#define REG_BK1457_03_H      0x145707
#define REG_BK1457_04_L      0x145708
#define REG_BK1457_04_H      0x145709
#define REG_BK1457_05_L      0x14570A
#define REG_BK1457_05_H      0x14570B
#define REG_BK1457_06_L      0x14570C
#define REG_BK1457_06_H      0x14570D
#define REG_BK1457_07_L      0x14570E
#define REG_BK1457_07_H      0x14570F
#define REG_BK1457_08_L      0x145710
#define REG_BK1457_08_H      0x145711
#define REG_BK1457_09_L      0x145712
#define REG_BK1457_09_H      0x145713
#define REG_BK1457_0A_L      0x145714
#define REG_BK1457_0A_H      0x145715
#define REG_BK1457_0B_L      0x145716
#define REG_BK1457_0B_H      0x145717
#define REG_BK1457_0C_L      0x145718
#define REG_BK1457_0C_H      0x145719
#define REG_BK1457_0D_L      0x14571A
#define REG_BK1457_0D_H      0x14571B
#define REG_BK1457_0E_L      0x14571C
#define REG_BK1457_0E_H      0x14571D
#define REG_BK1457_0F_L      0x14571E
#define REG_BK1457_0F_H      0x14571F
#define REG_BK1457_10_L      0x145720
#define REG_BK1457_10_H      0x145721
#define REG_BK1457_11_L      0x145722
#define REG_BK1457_11_H      0x145723
#define REG_BK1457_12_L      0x145724
#define REG_BK1457_12_H      0x145725
#define REG_BK1457_13_L      0x145726
#define REG_BK1457_13_H      0x145727
#define REG_BK1457_14_L      0x145728
#define REG_BK1457_14_H      0x145729
#define REG_BK1457_15_L      0x14572A
#define REG_BK1457_15_H      0x14572B
#define REG_BK1457_16_L      0x14572C
#define REG_BK1457_16_H      0x14572D
#define REG_BK1457_17_L      0x14572E
#define REG_BK1457_17_H      0x14572F
#define REG_BK1457_18_L      0x145730
#define REG_BK1457_18_H      0x145731
#define REG_BK1457_19_L      0x145732
#define REG_BK1457_19_H      0x145733
#define REG_BK1457_1A_L      0x145734
#define REG_BK1457_1A_H      0x145735
#define REG_BK1457_1B_L      0x145736
#define REG_BK1457_1B_H      0x145737
#define REG_BK1457_1C_L      0x145738
#define REG_BK1457_1C_H      0x145739
#define REG_BK1457_1D_L      0x14573A
#define REG_BK1457_1D_H      0x14573B
#define REG_BK1457_1E_L      0x14573C
#define REG_BK1457_1E_H      0x14573D
#define REG_BK1457_1F_L      0x14573E
#define REG_BK1457_1F_H      0x14573F
#define REG_BK1457_20_L      0x145740
#define REG_BK1457_20_H      0x145741
#define REG_BK1457_21_L      0x145742
#define REG_BK1457_21_H      0x145743
#define REG_BK1457_22_L      0x145744
#define REG_BK1457_22_H      0x145745
#define REG_BK1457_23_L      0x145746
#define REG_BK1457_23_H      0x145747
#define REG_BK1457_24_L      0x145748
#define REG_BK1457_24_H      0x145749
#define REG_BK1457_25_L      0x14574A
#define REG_BK1457_25_H      0x14574B
#define REG_BK1457_26_L      0x14574C
#define REG_BK1457_26_H      0x14574D
#define REG_BK1457_27_L      0x14574E
#define REG_BK1457_27_H      0x14574F
#define REG_BK1457_28_L      0x145750
#define REG_BK1457_28_H      0x145751
#define REG_BK1457_29_L      0x145752
#define REG_BK1457_29_H      0x145753
#define REG_BK1457_2A_L      0x145754
#define REG_BK1457_2A_H      0x145755
#define REG_BK1457_2B_L      0x145756
#define REG_BK1457_2B_H      0x145757
#define REG_BK1457_2C_L      0x145758
#define REG_BK1457_2C_H      0x145759
#define REG_BK1457_2D_L      0x14575A
#define REG_BK1457_2D_H      0x14575B
#define REG_BK1457_2E_L      0x14575C
#define REG_BK1457_2E_H      0x14575D
#define REG_BK1457_2F_L      0x14575E
#define REG_BK1457_2F_H      0x14575F
#define REG_BK1457_30_L      0x145760
#define REG_BK1457_30_H      0x145761
#define REG_BK1457_31_L      0x145762
#define REG_BK1457_31_H      0x145763
#define REG_BK1457_32_L      0x145764
#define REG_BK1457_32_H      0x145765
#define REG_BK1457_33_L      0x145766
#define REG_BK1457_33_H      0x145767
#define REG_BK1457_34_L      0x145768
#define REG_BK1457_34_H      0x145769
#define REG_BK1457_35_L      0x14576A
#define REG_BK1457_35_H      0x14576B
#define REG_BK1457_36_L      0x14576C
#define REG_BK1457_36_H      0x14576D
#define REG_BK1457_37_L      0x14576E
#define REG_BK1457_37_H      0x14576F
#define REG_BK1457_38_L      0x145770
#define REG_BK1457_38_H      0x145771
#define REG_BK1457_39_L      0x145772
#define REG_BK1457_39_H      0x145773
#define REG_BK1457_3A_L      0x145774
#define REG_BK1457_3A_H      0x145775
#define REG_BK1457_3B_L      0x145776
#define REG_BK1457_3B_H      0x145777
#define REG_BK1457_3C_L      0x145778
#define REG_BK1457_3C_H      0x145779
#define REG_BK1457_3D_L      0x14577A
#define REG_BK1457_3D_H      0x14577B
#define REG_BK1457_3E_L      0x14577C
#define REG_BK1457_3E_H      0x14577D
#define REG_BK1457_3F_L      0x14577E
#define REG_BK1457_3F_H      0x14577F
#define REG_BK1457_40_L      0x145780
#define REG_BK1457_40_H      0x145781
#define REG_BK1457_41_L      0x145782
#define REG_BK1457_41_H      0x145783
#define REG_BK1457_42_L      0x145784
#define REG_BK1457_42_H      0x145785
#define REG_BK1457_43_L      0x145786
#define REG_BK1457_43_H      0x145787
#define REG_BK1457_44_L      0x145788
#define REG_BK1457_44_H      0x145789
#define REG_BK1457_45_L      0x14578A
#define REG_BK1457_45_H      0x14578B
#define REG_BK1457_46_L      0x14578C
#define REG_BK1457_46_H      0x14578D
#define REG_BK1457_47_L      0x14578E
#define REG_BK1457_47_H      0x14578F
#define REG_BK1457_48_L      0x145790
#define REG_BK1457_48_H      0x145791
#define REG_BK1457_49_L      0x145792
#define REG_BK1457_49_H      0x145793
#define REG_BK1457_4A_L      0x145794
#define REG_BK1457_4A_H      0x145795
#define REG_BK1457_4B_L      0x145796
#define REG_BK1457_4B_H      0x145797
#define REG_BK1457_4C_L      0x145798
#define REG_BK1457_4C_H      0x145799
#define REG_BK1457_4D_L      0x14579A
#define REG_BK1457_4D_H      0x14579B
#define REG_BK1457_4E_L      0x14579C
#define REG_BK1457_4E_H      0x14579D
#define REG_BK1457_4F_L      0x14579E
#define REG_BK1457_4F_H      0x14579F
#define REG_BK1457_50_L      0x1457A0
#define REG_BK1457_50_H      0x1457A1
#define REG_BK1457_51_L      0x1457A2
#define REG_BK1457_51_H      0x1457A3
#define REG_BK1457_52_L      0x1457A4
#define REG_BK1457_52_H      0x1457A5
#define REG_BK1457_53_L      0x1457A6
#define REG_BK1457_53_H      0x1457A7
#define REG_BK1457_54_L      0x1457A8
#define REG_BK1457_54_H      0x1457A9
#define REG_BK1457_55_L      0x1457AA
#define REG_BK1457_55_H      0x1457AB
#define REG_BK1457_56_L      0x1457AC
#define REG_BK1457_56_H      0x1457AD
#define REG_BK1457_57_L      0x1457AE
#define REG_BK1457_57_H      0x1457AF
#define REG_BK1457_58_L      0x1457B0
#define REG_BK1457_58_H      0x1457B1
#define REG_BK1457_59_L      0x1457B2
#define REG_BK1457_59_H      0x1457B3
#define REG_BK1457_5A_L      0x1457B4
#define REG_BK1457_5A_H      0x1457B5
#define REG_BK1457_5B_L      0x1457B6
#define REG_BK1457_5B_H      0x1457B7
#define REG_BK1457_5C_L      0x1457B8
#define REG_BK1457_5C_H      0x1457B9
#define REG_BK1457_5D_L      0x1457BA
#define REG_BK1457_5D_H      0x1457BB
#define REG_BK1457_5E_L      0x1457BC
#define REG_BK1457_5E_H      0x1457BD
#define REG_BK1457_5F_L      0x1457BE
#define REG_BK1457_5F_H      0x1457BF
#define REG_BK1457_60_L      0x1457C0
#define REG_BK1457_60_H      0x1457C1
#define REG_BK1457_61_L      0x1457C2
#define REG_BK1457_61_H      0x1457C3
#define REG_BK1457_62_L      0x1457C4
#define REG_BK1457_62_H      0x1457C5
#define REG_BK1457_63_L      0x1457C6
#define REG_BK1457_63_H      0x1457C7
#define REG_BK1457_64_L      0x1457C8
#define REG_BK1457_64_H      0x1457C9
#define REG_BK1457_65_L      0x1457CA
#define REG_BK1457_65_H      0x1457CB
#define REG_BK1457_66_L      0x1457CC
#define REG_BK1457_66_H      0x1457CD
#define REG_BK1457_67_L      0x1457CE
#define REG_BK1457_67_H      0x1457CF
#define REG_BK1457_68_L      0x1457D0
#define REG_BK1457_68_H      0x1457D1
#define REG_BK1457_69_L      0x1457D2
#define REG_BK1457_69_H      0x1457D3
#define REG_BK1457_6A_L      0x1457D4
#define REG_BK1457_6A_H      0x1457D5
#define REG_BK1457_6B_L      0x1457D6
#define REG_BK1457_6B_H      0x1457D7
#define REG_BK1457_6C_L      0x1457D8
#define REG_BK1457_6C_H      0x1457D9
#define REG_BK1457_6D_L      0x1457DA
#define REG_BK1457_6D_H      0x1457DB
#define REG_BK1457_6E_L      0x1457DC
#define REG_BK1457_6E_H      0x1457DD
#define REG_BK1457_6F_L      0x1457DE
#define REG_BK1457_6F_H      0x1457DF
#define REG_BK1457_70_L      0x1457E0
#define REG_BK1457_70_H      0x1457E1
#define REG_BK1457_71_L      0x1457E2
#define REG_BK1457_71_H      0x1457E3
#define REG_BK1457_72_L      0x1457E4
#define REG_BK1457_72_H      0x1457E5
#define REG_BK1457_73_L      0x1457E6
#define REG_BK1457_73_H      0x1457E7
#define REG_BK1457_74_L      0x1457E8
#define REG_BK1457_74_H      0x1457E9
#define REG_BK1457_75_L      0x1457EA
#define REG_BK1457_75_H      0x1457EB
#define REG_BK1457_76_L      0x1457EC
#define REG_BK1457_76_H      0x1457ED
#define REG_BK1457_77_L      0x1457EE
#define REG_BK1457_77_H      0x1457EF
#define REG_BK1457_78_L      0x1457F0
#define REG_BK1457_78_H      0x1457F1
#define REG_BK1457_79_L      0x1457F2
#define REG_BK1457_79_H      0x1457F3
#define REG_BK1457_7A_L      0x1457F4
#define REG_BK1457_7A_H      0x1457F5
#define REG_BK1457_7B_L      0x1457F6
#define REG_BK1457_7B_H      0x1457F7
#define REG_BK1457_7C_L      0x1457F8
#define REG_BK1457_7C_H      0x1457F9
#define REG_BK1457_7D_L      0x1457FA
#define REG_BK1457_7D_H      0x1457FB
#define REG_BK1457_7E_L      0x1457FC
#define REG_BK1457_7E_H      0x1457FD
#define REG_BK1457_7F_L      0x1457FE
#define REG_BK1457_7F_H      0x1457FF
//----------------------------------------------
#define REG_BK145F_00_L      0x145F00
#define REG_BK145F_00_H      0x145F01
#define REG_BK145F_01_L      0x145F02
#define REG_BK145F_01_H      0x145F03
#define REG_BK145F_02_L      0x145F04
#define REG_BK145F_02_H      0x145F05
#define REG_BK145F_03_L      0x145F06
#define REG_BK145F_03_H      0x145F07
#define REG_BK145F_04_L      0x145F08
#define REG_BK145F_04_H      0x145F09
#define REG_BK145F_05_L      0x145F0A
#define REG_BK145F_05_H      0x145F0B
#define REG_BK145F_06_L      0x145F0C
#define REG_BK145F_06_H      0x145F0D
#define REG_BK145F_07_L      0x145F0E
#define REG_BK145F_07_H      0x145F0F
#define REG_BK145F_08_L      0x145F10
#define REG_BK145F_08_H      0x145F11
#define REG_BK145F_09_L      0x145F12
#define REG_BK145F_09_H      0x145F13
#define REG_BK145F_0A_L      0x145F14
#define REG_BK145F_0A_H      0x145F15
#define REG_BK145F_0B_L      0x145F16
#define REG_BK145F_0B_H      0x145F17
#define REG_BK145F_0C_L      0x145F18
#define REG_BK145F_0C_H      0x145F19
#define REG_BK145F_0D_L      0x145F1A
#define REG_BK145F_0D_H      0x145F1B
#define REG_BK145F_0E_L      0x145F1C
#define REG_BK145F_0E_H      0x145F1D
#define REG_BK145F_0F_L      0x145F1E
#define REG_BK145F_0F_H      0x145F1F
#define REG_BK145F_10_L      0x145F20
#define REG_BK145F_10_H      0x145F21
#define REG_BK145F_11_L      0x145F22
#define REG_BK145F_11_H      0x145F23
#define REG_BK145F_12_L      0x145F24
#define REG_BK145F_12_H      0x145F25
#define REG_BK145F_13_L      0x145F26
#define REG_BK145F_13_H      0x145F27
#define REG_BK145F_14_L      0x145F28
#define REG_BK145F_14_H      0x145F29
#define REG_BK145F_15_L      0x145F2A
#define REG_BK145F_15_H      0x145F2B
#define REG_BK145F_16_L      0x145F2C
#define REG_BK145F_16_H      0x145F2D
#define REG_BK145F_17_L      0x145F2E
#define REG_BK145F_17_H      0x145F2F
#define REG_BK145F_18_L      0x145F30
#define REG_BK145F_18_H      0x145F31
#define REG_BK145F_19_L      0x145F32
#define REG_BK145F_19_H      0x145F33
#define REG_BK145F_1A_L      0x145F34
#define REG_BK145F_1A_H      0x145F35
#define REG_BK145F_1B_L      0x145F36
#define REG_BK145F_1B_H      0x145F37
#define REG_BK145F_1C_L      0x145F38
#define REG_BK145F_1C_H      0x145F39
#define REG_BK145F_1D_L      0x145F3A
#define REG_BK145F_1D_H      0x145F3B
#define REG_BK145F_1E_L      0x145F3C
#define REG_BK145F_1E_H      0x145F3D
#define REG_BK145F_1F_L      0x145F3E
#define REG_BK145F_1F_H      0x145F3F
#define REG_BK145F_20_L      0x145F40
#define REG_BK145F_20_H      0x145F41
#define REG_BK145F_21_L      0x145F42
#define REG_BK145F_21_H      0x145F43
#define REG_BK145F_22_L      0x145F44
#define REG_BK145F_22_H      0x145F45
#define REG_BK145F_23_L      0x145F46
#define REG_BK145F_23_H      0x145F47
#define REG_BK145F_24_L      0x145F48
#define REG_BK145F_24_H      0x145F49
#define REG_BK145F_25_L      0x145F4A
#define REG_BK145F_25_H      0x145F4B
#define REG_BK145F_26_L      0x145F4C
#define REG_BK145F_26_H      0x145F4D
#define REG_BK145F_27_L      0x145F4E
#define REG_BK145F_27_H      0x145F4F
#define REG_BK145F_28_L      0x145F50
#define REG_BK145F_28_H      0x145F51
#define REG_BK145F_29_L      0x145F52
#define REG_BK145F_29_H      0x145F53
#define REG_BK145F_2A_L      0x145F54
#define REG_BK145F_2A_H      0x145F55
#define REG_BK145F_2B_L      0x145F56
#define REG_BK145F_2B_H      0x145F57
#define REG_BK145F_2C_L      0x145F58
#define REG_BK145F_2C_H      0x145F59
#define REG_BK145F_2D_L      0x145F5A
#define REG_BK145F_2D_H      0x145F5B
#define REG_BK145F_2E_L      0x145F5C
#define REG_BK145F_2E_H      0x145F5D
#define REG_BK145F_2F_L      0x145F5E
#define REG_BK145F_2F_H      0x145F5F
#define REG_BK145F_30_L      0x145F60
#define REG_BK145F_30_H      0x145F61
#define REG_BK145F_31_L      0x145F62
#define REG_BK145F_31_H      0x145F63
#define REG_BK145F_32_L      0x145F64
#define REG_BK145F_32_H      0x145F65
#define REG_BK145F_33_L      0x145F66
#define REG_BK145F_33_H      0x145F67
#define REG_BK145F_34_L      0x145F68
#define REG_BK145F_34_H      0x145F69
#define REG_BK145F_35_L      0x145F6A
#define REG_BK145F_35_H      0x145F6B
#define REG_BK145F_36_L      0x145F6C
#define REG_BK145F_36_H      0x145F6D
#define REG_BK145F_37_L      0x145F6E
#define REG_BK145F_37_H      0x145F6F
#define REG_BK145F_38_L      0x145F70
#define REG_BK145F_38_H      0x145F71
#define REG_BK145F_39_L      0x145F72
#define REG_BK145F_39_H      0x145F73
#define REG_BK145F_3A_L      0x145F74
#define REG_BK145F_3A_H      0x145F75
#define REG_BK145F_3B_L      0x145F76
#define REG_BK145F_3B_H      0x145F77
#define REG_BK145F_3C_L      0x145F78
#define REG_BK145F_3C_H      0x145F79
#define REG_BK145F_3D_L      0x145F7A
#define REG_BK145F_3D_H      0x145F7B
#define REG_BK145F_3E_L      0x145F7C
#define REG_BK145F_3E_H      0x145F7D
#define REG_BK145F_3F_L      0x145F7E
#define REG_BK145F_3F_H      0x145F7F
#define REG_BK145F_40_L      0x145F80
#define REG_BK145F_40_H      0x145F81
#define REG_BK145F_41_L      0x145F82
#define REG_BK145F_41_H      0x145F83
#define REG_BK145F_42_L      0x145F84
#define REG_BK145F_42_H      0x145F85
#define REG_BK145F_43_L      0x145F86
#define REG_BK145F_43_H      0x145F87
#define REG_BK145F_44_L      0x145F88
#define REG_BK145F_44_H      0x145F89
#define REG_BK145F_45_L      0x145F8A
#define REG_BK145F_45_H      0x145F8B
#define REG_BK145F_46_L      0x145F8C
#define REG_BK145F_46_H      0x145F8D
#define REG_BK145F_47_L      0x145F8E
#define REG_BK145F_47_H      0x145F8F
#define REG_BK145F_48_L      0x145F90
#define REG_BK145F_48_H      0x145F91
#define REG_BK145F_49_L      0x145F92
#define REG_BK145F_49_H      0x145F93
#define REG_BK145F_4A_L      0x145F94
#define REG_BK145F_4A_H      0x145F95
#define REG_BK145F_4B_L      0x145F96
#define REG_BK145F_4B_H      0x145F97
#define REG_BK145F_4C_L      0x145F98
#define REG_BK145F_4C_H      0x145F99
#define REG_BK145F_4D_L      0x145F9A
#define REG_BK145F_4D_H      0x145F9B
#define REG_BK145F_4E_L      0x145F9C
#define REG_BK145F_4E_H      0x145F9D
#define REG_BK145F_4F_L      0x145F9E
#define REG_BK145F_4F_H      0x145F9F
#define REG_BK145F_50_L      0x145FA0
#define REG_BK145F_50_H      0x145FA1
#define REG_BK145F_51_L      0x145FA2
#define REG_BK145F_51_H      0x145FA3
#define REG_BK145F_52_L      0x145FA4
#define REG_BK145F_52_H      0x145FA5
#define REG_BK145F_53_L      0x145FA6
#define REG_BK145F_53_H      0x145FA7
#define REG_BK145F_54_L      0x145FA8
#define REG_BK145F_54_H      0x145FA9
#define REG_BK145F_55_L      0x145FAA
#define REG_BK145F_55_H      0x145FAB
#define REG_BK145F_56_L      0x145FAC
#define REG_BK145F_56_H      0x145FAD
#define REG_BK145F_57_L      0x145FAE
#define REG_BK145F_57_H      0x145FAF
#define REG_BK145F_58_L      0x145FB0
#define REG_BK145F_58_H      0x145FB1
#define REG_BK145F_59_L      0x145FB2
#define REG_BK145F_59_H      0x145FB3
#define REG_BK145F_5A_L      0x145FB4
#define REG_BK145F_5A_H      0x145FB5
#define REG_BK145F_5B_L      0x145FB6
#define REG_BK145F_5B_H      0x145FB7
#define REG_BK145F_5C_L      0x145FB8
#define REG_BK145F_5C_H      0x145FB9
#define REG_BK145F_5D_L      0x145FBA
#define REG_BK145F_5D_H      0x145FBB
#define REG_BK145F_5E_L      0x145FBC
#define REG_BK145F_5E_H      0x145FBD
#define REG_BK145F_5F_L      0x145FBE
#define REG_BK145F_5F_H      0x145FBF
#define REG_BK145F_60_L      0x145FC0
#define REG_BK145F_60_H      0x145FC1
#define REG_BK145F_61_L      0x145FC2
#define REG_BK145F_61_H      0x145FC3
#define REG_BK145F_62_L      0x145FC4
#define REG_BK145F_62_H      0x145FC5
#define REG_BK145F_63_L      0x145FC6
#define REG_BK145F_63_H      0x145FC7
#define REG_BK145F_64_L      0x145FC8
#define REG_BK145F_64_H      0x145FC9
#define REG_BK145F_65_L      0x145FCA
#define REG_BK145F_65_H      0x145FCB
#define REG_BK145F_66_L      0x145FCC
#define REG_BK145F_66_H      0x145FCD
#define REG_BK145F_67_L      0x145FCE
#define REG_BK145F_67_H      0x145FCF
#define REG_BK145F_68_L      0x145FD0
#define REG_BK145F_68_H      0x145FD1
#define REG_BK145F_69_L      0x145FD2
#define REG_BK145F_69_H      0x145FD3
#define REG_BK145F_6A_L      0x145FD4
#define REG_BK145F_6A_H      0x145FD5
#define REG_BK145F_6B_L      0x145FD6
#define REG_BK145F_6B_H      0x145FD7
#define REG_BK145F_6C_L      0x145FD8
#define REG_BK145F_6C_H      0x145FD9
#define REG_BK145F_6D_L      0x145FDA
#define REG_BK145F_6D_H      0x145FDB
#define REG_BK145F_6E_L      0x145FDC
#define REG_BK145F_6E_H      0x145FDD
#define REG_BK145F_6F_L      0x145FDE
#define REG_BK145F_6F_H      0x145FDF
#define REG_BK145F_70_L      0x145FE0
#define REG_BK145F_70_H      0x145FE1
#define REG_BK145F_71_L      0x145FE2
#define REG_BK145F_71_H      0x145FE3
#define REG_BK145F_72_L      0x145FE4
#define REG_BK145F_72_H      0x145FE5
#define REG_BK145F_73_L      0x145FE6
#define REG_BK145F_73_H      0x145FE7
#define REG_BK145F_74_L      0x145FE8
#define REG_BK145F_74_H      0x145FE9
#define REG_BK145F_75_L      0x145FEA
#define REG_BK145F_75_H      0x145FEB
#define REG_BK145F_76_L      0x145FEC
#define REG_BK145F_76_H      0x145FED
#define REG_BK145F_77_L      0x145FEE
#define REG_BK145F_77_H      0x145FEF
#define REG_BK145F_78_L      0x145FF0
#define REG_BK145F_78_H      0x145FF1
#define REG_BK145F_79_L      0x145FF2
#define REG_BK145F_79_H      0x145FF3
#define REG_BK145F_7A_L      0x145FF4
#define REG_BK145F_7A_H      0x145FF5
#define REG_BK145F_7B_L      0x145FF6
#define REG_BK145F_7B_H      0x145FF7
#define REG_BK145F_7C_L      0x145FF8
#define REG_BK145F_7C_H      0x145FF9
#define REG_BK145F_7D_L      0x145FFA
#define REG_BK145F_7D_H      0x145FFB
#define REG_BK145F_7E_L      0x145FFC
#define REG_BK145F_7E_H      0x145FFD
#define REG_BK145F_7F_L      0x145FFE
#define REG_BK145F_7F_H      0x145FFF
//----------------------------------------------
#define REG_BK1470_00_L      0x147000
#define REG_BK1470_00_H      0x147001
#define REG_BK1470_01_L      0x147002
#define REG_BK1470_01_H      0x147003
#define REG_BK1470_02_L      0x147004
#define REG_BK1470_02_H      0x147005
#define REG_BK1470_03_L      0x147006
#define REG_BK1470_03_H      0x147007
#define REG_BK1470_04_L      0x147008
#define REG_BK1470_04_H      0x147009
#define REG_BK1470_05_L      0x14700A
#define REG_BK1470_05_H      0x14700B
#define REG_BK1470_06_L      0x14700C
#define REG_BK1470_06_H      0x14700D
#define REG_BK1470_07_L      0x14700E
#define REG_BK1470_07_H      0x14700F
#define REG_BK1470_08_L      0x147010
#define REG_BK1470_08_H      0x147011
#define REG_BK1470_09_L      0x147012
#define REG_BK1470_09_H      0x147013
#define REG_BK1470_0A_L      0x147014
#define REG_BK1470_0A_H      0x147015
#define REG_BK1470_0B_L      0x147016
#define REG_BK1470_0B_H      0x147017
#define REG_BK1470_0C_L      0x147018
#define REG_BK1470_0C_H      0x147019
#define REG_BK1470_0D_L      0x14701A
#define REG_BK1470_0D_H      0x14701B
#define REG_BK1470_0E_L      0x14701C
#define REG_BK1470_0E_H      0x14701D
#define REG_BK1470_0F_L      0x14701E
#define REG_BK1470_0F_H      0x14701F
#define REG_BK1470_10_L      0x147020
#define REG_BK1470_10_H      0x147021
#define REG_BK1470_11_L      0x147022
#define REG_BK1470_11_H      0x147023
#define REG_BK1470_12_L      0x147024
#define REG_BK1470_12_H      0x147025
#define REG_BK1470_13_L      0x147026
#define REG_BK1470_13_H      0x147027
#define REG_BK1470_14_L      0x147028
#define REG_BK1470_14_H      0x147029
#define REG_BK1470_15_L      0x14702A
#define REG_BK1470_15_H      0x14702B
#define REG_BK1470_16_L      0x14702C
#define REG_BK1470_16_H      0x14702D
#define REG_BK1470_17_L      0x14702E
#define REG_BK1470_17_H      0x14702F
#define REG_BK1470_18_L      0x147030
#define REG_BK1470_18_H      0x147031
#define REG_BK1470_19_L      0x147032
#define REG_BK1470_19_H      0x147033
#define REG_BK1470_1A_L      0x147034
#define REG_BK1470_1A_H      0x147035
#define REG_BK1470_1B_L      0x147036
#define REG_BK1470_1B_H      0x147037
#define REG_BK1470_1C_L      0x147038
#define REG_BK1470_1C_H      0x147039
#define REG_BK1470_1D_L      0x14703A
#define REG_BK1470_1D_H      0x14703B
#define REG_BK1470_1E_L      0x14703C
#define REG_BK1470_1E_H      0x14703D
#define REG_BK1470_1F_L      0x14703E
#define REG_BK1470_1F_H      0x14703F
#define REG_BK1470_20_L      0x147040
#define REG_BK1470_20_H      0x147041
#define REG_BK1470_21_L      0x147042
#define REG_BK1470_21_H      0x147043
#define REG_BK1470_22_L      0x147044
#define REG_BK1470_22_H      0x147045
#define REG_BK1470_23_L      0x147046
#define REG_BK1470_23_H      0x147047
#define REG_BK1470_24_L      0x147048
#define REG_BK1470_24_H      0x147049
#define REG_BK1470_25_L      0x14704A
#define REG_BK1470_25_H      0x14704B
#define REG_BK1470_26_L      0x14704C
#define REG_BK1470_26_H      0x14704D
#define REG_BK1470_27_L      0x14704E
#define REG_BK1470_27_H      0x14704F
#define REG_BK1470_28_L      0x147050
#define REG_BK1470_28_H      0x147051
#define REG_BK1470_29_L      0x147052
#define REG_BK1470_29_H      0x147053
#define REG_BK1470_2A_L      0x147054
#define REG_BK1470_2A_H      0x147055
#define REG_BK1470_2B_L      0x147056
#define REG_BK1470_2B_H      0x147057
#define REG_BK1470_2C_L      0x147058
#define REG_BK1470_2C_H      0x147059
#define REG_BK1470_2D_L      0x14705A
#define REG_BK1470_2D_H      0x14705B
#define REG_BK1470_2E_L      0x14705C
#define REG_BK1470_2E_H      0x14705D
#define REG_BK1470_2F_L      0x14705E
#define REG_BK1470_2F_H      0x14705F
#define REG_BK1470_30_L      0x147060
#define REG_BK1470_30_H      0x147061
#define REG_BK1470_31_L      0x147062
#define REG_BK1470_31_H      0x147063
#define REG_BK1470_32_L      0x147064
#define REG_BK1470_32_H      0x147065
#define REG_BK1470_33_L      0x147066
#define REG_BK1470_33_H      0x147067
#define REG_BK1470_34_L      0x147068
#define REG_BK1470_34_H      0x147069
#define REG_BK1470_35_L      0x14706A
#define REG_BK1470_35_H      0x14706B
#define REG_BK1470_36_L      0x14706C
#define REG_BK1470_36_H      0x14706D
#define REG_BK1470_37_L      0x14706E
#define REG_BK1470_37_H      0x14706F
#define REG_BK1470_38_L      0x147070
#define REG_BK1470_38_H      0x147071
#define REG_BK1470_39_L      0x147072
#define REG_BK1470_39_H      0x147073
#define REG_BK1470_3A_L      0x147074
#define REG_BK1470_3A_H      0x147075
#define REG_BK1470_3B_L      0x147076
#define REG_BK1470_3B_H      0x147077
#define REG_BK1470_3C_L      0x147078
#define REG_BK1470_3C_H      0x147079
#define REG_BK1470_3D_L      0x14707A
#define REG_BK1470_3D_H      0x14707B
#define REG_BK1470_3E_L      0x14707C
#define REG_BK1470_3E_H      0x14707D
#define REG_BK1470_3F_L      0x14707E
#define REG_BK1470_3F_H      0x14707F
#define REG_BK1470_40_L      0x147080
#define REG_BK1470_40_H      0x147081
#define REG_BK1470_41_L      0x147082
#define REG_BK1470_41_H      0x147083
#define REG_BK1470_42_L      0x147084
#define REG_BK1470_42_H      0x147085
#define REG_BK1470_43_L      0x147086
#define REG_BK1470_43_H      0x147087
#define REG_BK1470_44_L      0x147088
#define REG_BK1470_44_H      0x147089
#define REG_BK1470_45_L      0x14708A
#define REG_BK1470_45_H      0x14708B
#define REG_BK1470_46_L      0x14708C
#define REG_BK1470_46_H      0x14708D
#define REG_BK1470_47_L      0x14708E
#define REG_BK1470_47_H      0x14708F
#define REG_BK1470_48_L      0x147090
#define REG_BK1470_48_H      0x147091
#define REG_BK1470_49_L      0x147092
#define REG_BK1470_49_H      0x147093
#define REG_BK1470_4A_L      0x147094
#define REG_BK1470_4A_H      0x147095
#define REG_BK1470_4B_L      0x147096
#define REG_BK1470_4B_H      0x147097
#define REG_BK1470_4C_L      0x147098
#define REG_BK1470_4C_H      0x147099
#define REG_BK1470_4D_L      0x14709A
#define REG_BK1470_4D_H      0x14709B
#define REG_BK1470_4E_L      0x14709C
#define REG_BK1470_4E_H      0x14709D
#define REG_BK1470_4F_L      0x14709E
#define REG_BK1470_4F_H      0x14709F
#define REG_BK1470_50_L      0x1470A0
#define REG_BK1470_50_H      0x1470A1
#define REG_BK1470_51_L      0x1470A2
#define REG_BK1470_51_H      0x1470A3
#define REG_BK1470_52_L      0x1470A4
#define REG_BK1470_52_H      0x1470A5
#define REG_BK1470_53_L      0x1470A6
#define REG_BK1470_53_H      0x1470A7
#define REG_BK1470_54_L      0x1470A8
#define REG_BK1470_54_H      0x1470A9
#define REG_BK1470_55_L      0x1470AA
#define REG_BK1470_55_H      0x1470AB
#define REG_BK1470_56_L      0x1470AC
#define REG_BK1470_56_H      0x1470AD
#define REG_BK1470_57_L      0x1470AE
#define REG_BK1470_57_H      0x1470AF
#define REG_BK1470_58_L      0x1470B0
#define REG_BK1470_58_H      0x1470B1
#define REG_BK1470_59_L      0x1470B2
#define REG_BK1470_59_H      0x1470B3
#define REG_BK1470_5A_L      0x1470B4
#define REG_BK1470_5A_H      0x1470B5
#define REG_BK1470_5B_L      0x1470B6
#define REG_BK1470_5B_H      0x1470B7
#define REG_BK1470_5C_L      0x1470B8
#define REG_BK1470_5C_H      0x1470B9
#define REG_BK1470_5D_L      0x1470BA
#define REG_BK1470_5D_H      0x1470BB
#define REG_BK1470_5E_L      0x1470BC
#define REG_BK1470_5E_H      0x1470BD
#define REG_BK1470_5F_L      0x1470BE
#define REG_BK1470_5F_H      0x1470BF
#define REG_BK1470_60_L      0x1470C0
#define REG_BK1470_60_H      0x1470C1
#define REG_BK1470_61_L      0x1470C2
#define REG_BK1470_61_H      0x1470C3
#define REG_BK1470_62_L      0x1470C4
#define REG_BK1470_62_H      0x1470C5
#define REG_BK1470_63_L      0x1470C6
#define REG_BK1470_63_H      0x1470C7
#define REG_BK1470_64_L      0x1470C8
#define REG_BK1470_64_H      0x1470C9
#define REG_BK1470_65_L      0x1470CA
#define REG_BK1470_65_H      0x1470CB
#define REG_BK1470_66_L      0x1470CC
#define REG_BK1470_66_H      0x1470CD
#define REG_BK1470_67_L      0x1470CE
#define REG_BK1470_67_H      0x1470CF
#define REG_BK1470_68_L      0x1470D0
#define REG_BK1470_68_H      0x1470D1
#define REG_BK1470_69_L      0x1470D2
#define REG_BK1470_69_H      0x1470D3
#define REG_BK1470_6A_L      0x1470D4
#define REG_BK1470_6A_H      0x1470D5
#define REG_BK1470_6B_L      0x1470D6
#define REG_BK1470_6B_H      0x1470D7
#define REG_BK1470_6C_L      0x1470D8
#define REG_BK1470_6C_H      0x1470D9
#define REG_BK1470_6D_L      0x1470DA
#define REG_BK1470_6D_H      0x1470DB
#define REG_BK1470_6E_L      0x1470DC
#define REG_BK1470_6E_H      0x1470DD
#define REG_BK1470_6F_L      0x1470DE
#define REG_BK1470_6F_H      0x1470DF
#define REG_BK1470_70_L      0x1470E0
#define REG_BK1470_70_H      0x1470E1
#define REG_BK1470_71_L      0x1470E2
#define REG_BK1470_71_H      0x1470E3
#define REG_BK1470_72_L      0x1470E4
#define REG_BK1470_72_H      0x1470E5
#define REG_BK1470_73_L      0x1470E6
#define REG_BK1470_73_H      0x1470E7
#define REG_BK1470_74_L      0x1470E8
#define REG_BK1470_74_H      0x1470E9
#define REG_BK1470_75_L      0x1470EA
#define REG_BK1470_75_H      0x1470EB
#define REG_BK1470_76_L      0x1470EC
#define REG_BK1470_76_H      0x1470ED
#define REG_BK1470_77_L      0x1470EE
#define REG_BK1470_77_H      0x1470EF
#define REG_BK1470_78_L      0x1470F0
#define REG_BK1470_78_H      0x1470F1
#define REG_BK1470_79_L      0x1470F2
#define REG_BK1470_79_H      0x1470F3
#define REG_BK1470_7A_L      0x1470F4
#define REG_BK1470_7A_H      0x1470F5
#define REG_BK1470_7B_L      0x1470F6
#define REG_BK1470_7B_H      0x1470F7
#define REG_BK1470_7C_L      0x1470F8
#define REG_BK1470_7C_H      0x1470F9
#define REG_BK1470_7D_L      0x1470FA
#define REG_BK1470_7D_H      0x1470FB
#define REG_BK1470_7E_L      0x1470FC
#define REG_BK1470_7E_H      0x1470FD
#define REG_BK1470_7F_L      0x1470FE
#define REG_BK1470_7F_H      0x1470FF
//----------------------------------------------
#define REG_BK1471_00_L      0x147100
#define REG_BK1471_00_H      0x147101
#define REG_BK1471_01_L      0x147102
#define REG_BK1471_01_H      0x147103
#define REG_BK1471_02_L      0x147104
#define REG_BK1471_02_H      0x147105
#define REG_BK1471_03_L      0x147106
#define REG_BK1471_03_H      0x147107
#define REG_BK1471_04_L      0x147108
#define REG_BK1471_04_H      0x147109
#define REG_BK1471_05_L      0x14710A
#define REG_BK1471_05_H      0x14710B
#define REG_BK1471_06_L      0x14710C
#define REG_BK1471_06_H      0x14710D
#define REG_BK1471_07_L      0x14710E
#define REG_BK1471_07_H      0x14710F
#define REG_BK1471_08_L      0x147110
#define REG_BK1471_08_H      0x147111
#define REG_BK1471_09_L      0x147112
#define REG_BK1471_09_H      0x147113
#define REG_BK1471_0A_L      0x147114
#define REG_BK1471_0A_H      0x147115
#define REG_BK1471_0B_L      0x147116
#define REG_BK1471_0B_H      0x147117
#define REG_BK1471_0C_L      0x147118
#define REG_BK1471_0C_H      0x147119
#define REG_BK1471_0D_L      0x14711A
#define REG_BK1471_0D_H      0x14711B
#define REG_BK1471_0E_L      0x14711C
#define REG_BK1471_0E_H      0x14711D
#define REG_BK1471_0F_L      0x14711E
#define REG_BK1471_0F_H      0x14711F
#define REG_BK1471_10_L      0x147120
#define REG_BK1471_10_H      0x147121
#define REG_BK1471_11_L      0x147122
#define REG_BK1471_11_H      0x147123
#define REG_BK1471_12_L      0x147124
#define REG_BK1471_12_H      0x147125
#define REG_BK1471_13_L      0x147126
#define REG_BK1471_13_H      0x147127
#define REG_BK1471_14_L      0x147128
#define REG_BK1471_14_H      0x147129
#define REG_BK1471_15_L      0x14712A
#define REG_BK1471_15_H      0x14712B
#define REG_BK1471_16_L      0x14712C
#define REG_BK1471_16_H      0x14712D
#define REG_BK1471_17_L      0x14712E
#define REG_BK1471_17_H      0x14712F
#define REG_BK1471_18_L      0x147130
#define REG_BK1471_18_H      0x147131
#define REG_BK1471_19_L      0x147132
#define REG_BK1471_19_H      0x147133
#define REG_BK1471_1A_L      0x147134
#define REG_BK1471_1A_H      0x147135
#define REG_BK1471_1B_L      0x147136
#define REG_BK1471_1B_H      0x147137
#define REG_BK1471_1C_L      0x147138
#define REG_BK1471_1C_H      0x147139
#define REG_BK1471_1D_L      0x14713A
#define REG_BK1471_1D_H      0x14713B
#define REG_BK1471_1E_L      0x14713C
#define REG_BK1471_1E_H      0x14713D
#define REG_BK1471_1F_L      0x14713E
#define REG_BK1471_1F_H      0x14713F
#define REG_BK1471_20_L      0x147140
#define REG_BK1471_20_H      0x147141
#define REG_BK1471_21_L      0x147142
#define REG_BK1471_21_H      0x147143
#define REG_BK1471_22_L      0x147144
#define REG_BK1471_22_H      0x147145
#define REG_BK1471_23_L      0x147146
#define REG_BK1471_23_H      0x147147
#define REG_BK1471_24_L      0x147148
#define REG_BK1471_24_H      0x147149
#define REG_BK1471_25_L      0x14714A
#define REG_BK1471_25_H      0x14714B
#define REG_BK1471_26_L      0x14714C
#define REG_BK1471_26_H      0x14714D
#define REG_BK1471_27_L      0x14714E
#define REG_BK1471_27_H      0x14714F
#define REG_BK1471_28_L      0x147150
#define REG_BK1471_28_H      0x147151
#define REG_BK1471_29_L      0x147152
#define REG_BK1471_29_H      0x147153
#define REG_BK1471_2A_L      0x147154
#define REG_BK1471_2A_H      0x147155
#define REG_BK1471_2B_L      0x147156
#define REG_BK1471_2B_H      0x147157
#define REG_BK1471_2C_L      0x147158
#define REG_BK1471_2C_H      0x147159
#define REG_BK1471_2D_L      0x14715A
#define REG_BK1471_2D_H      0x14715B
#define REG_BK1471_2E_L      0x14715C
#define REG_BK1471_2E_H      0x14715D
#define REG_BK1471_2F_L      0x14715E
#define REG_BK1471_2F_H      0x14715F
#define REG_BK1471_30_L      0x147160
#define REG_BK1471_30_H      0x147161
#define REG_BK1471_31_L      0x147162
#define REG_BK1471_31_H      0x147163
#define REG_BK1471_32_L      0x147164
#define REG_BK1471_32_H      0x147165
#define REG_BK1471_33_L      0x147166
#define REG_BK1471_33_H      0x147167
#define REG_BK1471_34_L      0x147168
#define REG_BK1471_34_H      0x147169
#define REG_BK1471_35_L      0x14716A
#define REG_BK1471_35_H      0x14716B
#define REG_BK1471_36_L      0x14716C
#define REG_BK1471_36_H      0x14716D
#define REG_BK1471_37_L      0x14716E
#define REG_BK1471_37_H      0x14716F
#define REG_BK1471_38_L      0x147170
#define REG_BK1471_38_H      0x147171
#define REG_BK1471_39_L      0x147172
#define REG_BK1471_39_H      0x147173
#define REG_BK1471_3A_L      0x147174
#define REG_BK1471_3A_H      0x147175
#define REG_BK1471_3B_L      0x147176
#define REG_BK1471_3B_H      0x147177
#define REG_BK1471_3C_L      0x147178
#define REG_BK1471_3C_H      0x147179
#define REG_BK1471_3D_L      0x14717A
#define REG_BK1471_3D_H      0x14717B
#define REG_BK1471_3E_L      0x14717C
#define REG_BK1471_3E_H      0x14717D
#define REG_BK1471_3F_L      0x14717E
#define REG_BK1471_3F_H      0x14717F
#define REG_BK1471_40_L      0x147180
#define REG_BK1471_40_H      0x147181
#define REG_BK1471_41_L      0x147182
#define REG_BK1471_41_H      0x147183
#define REG_BK1471_42_L      0x147184
#define REG_BK1471_42_H      0x147185
#define REG_BK1471_43_L      0x147186
#define REG_BK1471_43_H      0x147187
#define REG_BK1471_44_L      0x147188
#define REG_BK1471_44_H      0x147189
#define REG_BK1471_45_L      0x14718A
#define REG_BK1471_45_H      0x14718B
#define REG_BK1471_46_L      0x14718C
#define REG_BK1471_46_H      0x14718D
#define REG_BK1471_47_L      0x14718E
#define REG_BK1471_47_H      0x14718F
#define REG_BK1471_48_L      0x147190
#define REG_BK1471_48_H      0x147191
#define REG_BK1471_49_L      0x147192
#define REG_BK1471_49_H      0x147193
#define REG_BK1471_4A_L      0x147194
#define REG_BK1471_4A_H      0x147195
#define REG_BK1471_4B_L      0x147196
#define REG_BK1471_4B_H      0x147197
#define REG_BK1471_4C_L      0x147198
#define REG_BK1471_4C_H      0x147199
#define REG_BK1471_4D_L      0x14719A
#define REG_BK1471_4D_H      0x14719B
#define REG_BK1471_4E_L      0x14719C
#define REG_BK1471_4E_H      0x14719D
#define REG_BK1471_4F_L      0x14719E
#define REG_BK1471_4F_H      0x14719F
#define REG_BK1471_50_L      0x1471A0
#define REG_BK1471_50_H      0x1471A1
#define REG_BK1471_51_L      0x1471A2
#define REG_BK1471_51_H      0x1471A3
#define REG_BK1471_52_L      0x1471A4
#define REG_BK1471_52_H      0x1471A5
#define REG_BK1471_53_L      0x1471A6
#define REG_BK1471_53_H      0x1471A7
#define REG_BK1471_54_L      0x1471A8
#define REG_BK1471_54_H      0x1471A9
#define REG_BK1471_55_L      0x1471AA
#define REG_BK1471_55_H      0x1471AB
#define REG_BK1471_56_L      0x1471AC
#define REG_BK1471_56_H      0x1471AD
#define REG_BK1471_57_L      0x1471AE
#define REG_BK1471_57_H      0x1471AF
#define REG_BK1471_58_L      0x1471B0
#define REG_BK1471_58_H      0x1471B1
#define REG_BK1471_59_L      0x1471B2
#define REG_BK1471_59_H      0x1471B3
#define REG_BK1471_5A_L      0x1471B4
#define REG_BK1471_5A_H      0x1471B5
#define REG_BK1471_5B_L      0x1471B6
#define REG_BK1471_5B_H      0x1471B7
#define REG_BK1471_5C_L      0x1471B8
#define REG_BK1471_5C_H      0x1471B9
#define REG_BK1471_5D_L      0x1471BA
#define REG_BK1471_5D_H      0x1471BB
#define REG_BK1471_5E_L      0x1471BC
#define REG_BK1471_5E_H      0x1471BD
#define REG_BK1471_5F_L      0x1471BE
#define REG_BK1471_5F_H      0x1471BF
#define REG_BK1471_60_L      0x1471C0
#define REG_BK1471_60_H      0x1471C1
#define REG_BK1471_61_L      0x1471C2
#define REG_BK1471_61_H      0x1471C3
#define REG_BK1471_62_L      0x1471C4
#define REG_BK1471_62_H      0x1471C5
#define REG_BK1471_63_L      0x1471C6
#define REG_BK1471_63_H      0x1471C7
#define REG_BK1471_64_L      0x1471C8
#define REG_BK1471_64_H      0x1471C9
#define REG_BK1471_65_L      0x1471CA
#define REG_BK1471_65_H      0x1471CB
#define REG_BK1471_66_L      0x1471CC
#define REG_BK1471_66_H      0x1471CD
#define REG_BK1471_67_L      0x1471CE
#define REG_BK1471_67_H      0x1471CF
#define REG_BK1471_68_L      0x1471D0
#define REG_BK1471_68_H      0x1471D1
#define REG_BK1471_69_L      0x1471D2
#define REG_BK1471_69_H      0x1471D3
#define REG_BK1471_6A_L      0x1471D4
#define REG_BK1471_6A_H      0x1471D5
#define REG_BK1471_6B_L      0x1471D6
#define REG_BK1471_6B_H      0x1471D7
#define REG_BK1471_6C_L      0x1471D8
#define REG_BK1471_6C_H      0x1471D9
#define REG_BK1471_6D_L      0x1471DA
#define REG_BK1471_6D_H      0x1471DB
#define REG_BK1471_6E_L      0x1471DC
#define REG_BK1471_6E_H      0x1471DD
#define REG_BK1471_6F_L      0x1471DE
#define REG_BK1471_6F_H      0x1471DF
#define REG_BK1471_70_L      0x1471E0
#define REG_BK1471_70_H      0x1471E1
#define REG_BK1471_71_L      0x1471E2
#define REG_BK1471_71_H      0x1471E3
#define REG_BK1471_72_L      0x1471E4
#define REG_BK1471_72_H      0x1471E5
#define REG_BK1471_73_L      0x1471E6
#define REG_BK1471_73_H      0x1471E7
#define REG_BK1471_74_L      0x1471E8
#define REG_BK1471_74_H      0x1471E9
#define REG_BK1471_75_L      0x1471EA
#define REG_BK1471_75_H      0x1471EB
#define REG_BK1471_76_L      0x1471EC
#define REG_BK1471_76_H      0x1471ED
#define REG_BK1471_77_L      0x1471EE
#define REG_BK1471_77_H      0x1471EF
#define REG_BK1471_78_L      0x1471F0
#define REG_BK1471_78_H      0x1471F1
#define REG_BK1471_79_L      0x1471F2
#define REG_BK1471_79_H      0x1471F3
#define REG_BK1471_7A_L      0x1471F4
#define REG_BK1471_7A_H      0x1471F5
#define REG_BK1471_7B_L      0x1471F6
#define REG_BK1471_7B_H      0x1471F7
#define REG_BK1471_7C_L      0x1471F8
#define REG_BK1471_7C_H      0x1471F9
#define REG_BK1471_7D_L      0x1471FA
#define REG_BK1471_7D_H      0x1471FB
#define REG_BK1471_7E_L      0x1471FC
#define REG_BK1471_7E_H      0x1471FD
#define REG_BK1471_7F_L      0x1471FE
#define REG_BK1471_7F_H      0x1471FF
//----------------------------------------------
#define REG_BK1472_00_L      0x147200
#define REG_BK1472_00_H      0x147201
#define REG_BK1472_01_L      0x147202
#define REG_BK1472_01_H      0x147203
#define REG_BK1472_02_L      0x147204
#define REG_BK1472_02_H      0x147205
#define REG_BK1472_03_L      0x147206
#define REG_BK1472_03_H      0x147207
#define REG_BK1472_04_L      0x147208
#define REG_BK1472_04_H      0x147209
#define REG_BK1472_05_L      0x14720A
#define REG_BK1472_05_H      0x14720B
#define REG_BK1472_06_L      0x14720C
#define REG_BK1472_06_H      0x14720D
#define REG_BK1472_07_L      0x14720E
#define REG_BK1472_07_H      0x14720F
#define REG_BK1472_08_L      0x147210
#define REG_BK1472_08_H      0x147211
#define REG_BK1472_09_L      0x147212
#define REG_BK1472_09_H      0x147213
#define REG_BK1472_0A_L      0x147214
#define REG_BK1472_0A_H      0x147215
#define REG_BK1472_0B_L      0x147216
#define REG_BK1472_0B_H      0x147217
#define REG_BK1472_0C_L      0x147218
#define REG_BK1472_0C_H      0x147219
#define REG_BK1472_0D_L      0x14721A
#define REG_BK1472_0D_H      0x14721B
#define REG_BK1472_0E_L      0x14721C
#define REG_BK1472_0E_H      0x14721D
#define REG_BK1472_0F_L      0x14721E
#define REG_BK1472_0F_H      0x14721F
#define REG_BK1472_10_L      0x147220
#define REG_BK1472_10_H      0x147221
#define REG_BK1472_11_L      0x147222
#define REG_BK1472_11_H      0x147223
#define REG_BK1472_12_L      0x147224
#define REG_BK1472_12_H      0x147225
#define REG_BK1472_13_L      0x147226
#define REG_BK1472_13_H      0x147227
#define REG_BK1472_14_L      0x147228
#define REG_BK1472_14_H      0x147229
#define REG_BK1472_15_L      0x14722A
#define REG_BK1472_15_H      0x14722B
#define REG_BK1472_16_L      0x14722C
#define REG_BK1472_16_H      0x14722D
#define REG_BK1472_17_L      0x14722E
#define REG_BK1472_17_H      0x14722F
#define REG_BK1472_18_L      0x147230
#define REG_BK1472_18_H      0x147231
#define REG_BK1472_19_L      0x147232
#define REG_BK1472_19_H      0x147233
#define REG_BK1472_1A_L      0x147234
#define REG_BK1472_1A_H      0x147235
#define REG_BK1472_1B_L      0x147236
#define REG_BK1472_1B_H      0x147237
#define REG_BK1472_1C_L      0x147238
#define REG_BK1472_1C_H      0x147239
#define REG_BK1472_1D_L      0x14723A
#define REG_BK1472_1D_H      0x14723B
#define REG_BK1472_1E_L      0x14723C
#define REG_BK1472_1E_H      0x14723D
#define REG_BK1472_1F_L      0x14723E
#define REG_BK1472_1F_H      0x14723F
#define REG_BK1472_20_L      0x147240
#define REG_BK1472_20_H      0x147241
#define REG_BK1472_21_L      0x147242
#define REG_BK1472_21_H      0x147243
#define REG_BK1472_22_L      0x147244
#define REG_BK1472_22_H      0x147245
#define REG_BK1472_23_L      0x147246
#define REG_BK1472_23_H      0x147247
#define REG_BK1472_24_L      0x147248
#define REG_BK1472_24_H      0x147249
#define REG_BK1472_25_L      0x14724A
#define REG_BK1472_25_H      0x14724B
#define REG_BK1472_26_L      0x14724C
#define REG_BK1472_26_H      0x14724D
#define REG_BK1472_27_L      0x14724E
#define REG_BK1472_27_H      0x14724F
#define REG_BK1472_28_L      0x147250
#define REG_BK1472_28_H      0x147251
#define REG_BK1472_29_L      0x147252
#define REG_BK1472_29_H      0x147253
#define REG_BK1472_2A_L      0x147254
#define REG_BK1472_2A_H      0x147255
#define REG_BK1472_2B_L      0x147256
#define REG_BK1472_2B_H      0x147257
#define REG_BK1472_2C_L      0x147258
#define REG_BK1472_2C_H      0x147259
#define REG_BK1472_2D_L      0x14725A
#define REG_BK1472_2D_H      0x14725B
#define REG_BK1472_2E_L      0x14725C
#define REG_BK1472_2E_H      0x14725D
#define REG_BK1472_2F_L      0x14725E
#define REG_BK1472_2F_H      0x14725F
#define REG_BK1472_30_L      0x147260
#define REG_BK1472_30_H      0x147261
#define REG_BK1472_31_L      0x147262
#define REG_BK1472_31_H      0x147263
#define REG_BK1472_32_L      0x147264
#define REG_BK1472_32_H      0x147265
#define REG_BK1472_33_L      0x147266
#define REG_BK1472_33_H      0x147267
#define REG_BK1472_34_L      0x147268
#define REG_BK1472_34_H      0x147269
#define REG_BK1472_35_L      0x14726A
#define REG_BK1472_35_H      0x14726B
#define REG_BK1472_36_L      0x14726C
#define REG_BK1472_36_H      0x14726D
#define REG_BK1472_37_L      0x14726E
#define REG_BK1472_37_H      0x14726F
#define REG_BK1472_38_L      0x147270
#define REG_BK1472_38_H      0x147271
#define REG_BK1472_39_L      0x147272
#define REG_BK1472_39_H      0x147273
#define REG_BK1472_3A_L      0x147274
#define REG_BK1472_3A_H      0x147275
#define REG_BK1472_3B_L      0x147276
#define REG_BK1472_3B_H      0x147277
#define REG_BK1472_3C_L      0x147278
#define REG_BK1472_3C_H      0x147279
#define REG_BK1472_3D_L      0x14727A
#define REG_BK1472_3D_H      0x14727B
#define REG_BK1472_3E_L      0x14727C
#define REG_BK1472_3E_H      0x14727D
#define REG_BK1472_3F_L      0x14727E
#define REG_BK1472_3F_H      0x14727F
#define REG_BK1472_40_L      0x147280
#define REG_BK1472_40_H      0x147281
#define REG_BK1472_41_L      0x147282
#define REG_BK1472_41_H      0x147283
#define REG_BK1472_42_L      0x147284
#define REG_BK1472_42_H      0x147285
#define REG_BK1472_43_L      0x147286
#define REG_BK1472_43_H      0x147287
#define REG_BK1472_44_L      0x147288
#define REG_BK1472_44_H      0x147289
#define REG_BK1472_45_L      0x14728A
#define REG_BK1472_45_H      0x14728B
#define REG_BK1472_46_L      0x14728C
#define REG_BK1472_46_H      0x14728D
#define REG_BK1472_47_L      0x14728E
#define REG_BK1472_47_H      0x14728F
#define REG_BK1472_48_L      0x147290
#define REG_BK1472_48_H      0x147291
#define REG_BK1472_49_L      0x147292
#define REG_BK1472_49_H      0x147293
#define REG_BK1472_4A_L      0x147294
#define REG_BK1472_4A_H      0x147295
#define REG_BK1472_4B_L      0x147296
#define REG_BK1472_4B_H      0x147297
#define REG_BK1472_4C_L      0x147298
#define REG_BK1472_4C_H      0x147299
#define REG_BK1472_4D_L      0x14729A
#define REG_BK1472_4D_H      0x14729B
#define REG_BK1472_4E_L      0x14729C
#define REG_BK1472_4E_H      0x14729D
#define REG_BK1472_4F_L      0x14729E
#define REG_BK1472_4F_H      0x14729F
#define REG_BK1472_50_L      0x1472A0
#define REG_BK1472_50_H      0x1472A1
#define REG_BK1472_51_L      0x1472A2
#define REG_BK1472_51_H      0x1472A3
#define REG_BK1472_52_L      0x1472A4
#define REG_BK1472_52_H      0x1472A5
#define REG_BK1472_53_L      0x1472A6
#define REG_BK1472_53_H      0x1472A7
#define REG_BK1472_54_L      0x1472A8
#define REG_BK1472_54_H      0x1472A9
#define REG_BK1472_55_L      0x1472AA
#define REG_BK1472_55_H      0x1472AB
#define REG_BK1472_56_L      0x1472AC
#define REG_BK1472_56_H      0x1472AD
#define REG_BK1472_57_L      0x1472AE
#define REG_BK1472_57_H      0x1472AF
#define REG_BK1472_58_L      0x1472B0
#define REG_BK1472_58_H      0x1472B1
#define REG_BK1472_59_L      0x1472B2
#define REG_BK1472_59_H      0x1472B3
#define REG_BK1472_5A_L      0x1472B4
#define REG_BK1472_5A_H      0x1472B5
#define REG_BK1472_5B_L      0x1472B6
#define REG_BK1472_5B_H      0x1472B7
#define REG_BK1472_5C_L      0x1472B8
#define REG_BK1472_5C_H      0x1472B9
#define REG_BK1472_5D_L      0x1472BA
#define REG_BK1472_5D_H      0x1472BB
#define REG_BK1472_5E_L      0x1472BC
#define REG_BK1472_5E_H      0x1472BD
#define REG_BK1472_5F_L      0x1472BE
#define REG_BK1472_5F_H      0x1472BF
#define REG_BK1472_60_L      0x1472C0
#define REG_BK1472_60_H      0x1472C1
#define REG_BK1472_61_L      0x1472C2
#define REG_BK1472_61_H      0x1472C3
#define REG_BK1472_62_L      0x1472C4
#define REG_BK1472_62_H      0x1472C5
#define REG_BK1472_63_L      0x1472C6
#define REG_BK1472_63_H      0x1472C7
#define REG_BK1472_64_L      0x1472C8
#define REG_BK1472_64_H      0x1472C9
#define REG_BK1472_65_L      0x1472CA
#define REG_BK1472_65_H      0x1472CB
#define REG_BK1472_66_L      0x1472CC
#define REG_BK1472_66_H      0x1472CD
#define REG_BK1472_67_L      0x1472CE
#define REG_BK1472_67_H      0x1472CF
#define REG_BK1472_68_L      0x1472D0
#define REG_BK1472_68_H      0x1472D1
#define REG_BK1472_69_L      0x1472D2
#define REG_BK1472_69_H      0x1472D3
#define REG_BK1472_6A_L      0x1472D4
#define REG_BK1472_6A_H      0x1472D5
#define REG_BK1472_6B_L      0x1472D6
#define REG_BK1472_6B_H      0x1472D7
#define REG_BK1472_6C_L      0x1472D8
#define REG_BK1472_6C_H      0x1472D9
#define REG_BK1472_6D_L      0x1472DA
#define REG_BK1472_6D_H      0x1472DB
#define REG_BK1472_6E_L      0x1472DC
#define REG_BK1472_6E_H      0x1472DD
#define REG_BK1472_6F_L      0x1472DE
#define REG_BK1472_6F_H      0x1472DF
#define REG_BK1472_70_L      0x1472E0
#define REG_BK1472_70_H      0x1472E1
#define REG_BK1472_71_L      0x1472E2
#define REG_BK1472_71_H      0x1472E3
#define REG_BK1472_72_L      0x1472E4
#define REG_BK1472_72_H      0x1472E5
#define REG_BK1472_73_L      0x1472E6
#define REG_BK1472_73_H      0x1472E7
#define REG_BK1472_74_L      0x1472E8
#define REG_BK1472_74_H      0x1472E9
#define REG_BK1472_75_L      0x1472EA
#define REG_BK1472_75_H      0x1472EB
#define REG_BK1472_76_L      0x1472EC
#define REG_BK1472_76_H      0x1472ED
#define REG_BK1472_77_L      0x1472EE
#define REG_BK1472_77_H      0x1472EF
#define REG_BK1472_78_L      0x1472F0
#define REG_BK1472_78_H      0x1472F1
#define REG_BK1472_79_L      0x1472F2
#define REG_BK1472_79_H      0x1472F3
#define REG_BK1472_7A_L      0x1472F4
#define REG_BK1472_7A_H      0x1472F5
#define REG_BK1472_7B_L      0x1472F6
#define REG_BK1472_7B_H      0x1472F7
#define REG_BK1472_7C_L      0x1472F8
#define REG_BK1472_7C_H      0x1472F9
#define REG_BK1472_7D_L      0x1472FA
#define REG_BK1472_7D_H      0x1472FB
#define REG_BK1472_7E_L      0x1472FC
#define REG_BK1472_7E_H      0x1472FD
#define REG_BK1472_7F_L      0x1472FE
#define REG_BK1472_7F_H      0x1472FF
//----------------------------------------------
#define REG_BK1474_00_L      0x147400
#define REG_BK1474_00_H      0x147401
#define REG_BK1474_01_L      0x147402
#define REG_BK1474_01_H      0x147403
#define REG_BK1474_02_L      0x147404
#define REG_BK1474_02_H      0x147405
#define REG_BK1474_03_L      0x147406
#define REG_BK1474_03_H      0x147407
#define REG_BK1474_04_L      0x147408
#define REG_BK1474_04_H      0x147409
#define REG_BK1474_05_L      0x14740A
#define REG_BK1474_05_H      0x14740B
#define REG_BK1474_06_L      0x14740C
#define REG_BK1474_06_H      0x14740D
#define REG_BK1474_07_L      0x14740E
#define REG_BK1474_07_H      0x14740F
#define REG_BK1474_08_L      0x147410
#define REG_BK1474_08_H      0x147411
#define REG_BK1474_09_L      0x147412
#define REG_BK1474_09_H      0x147413
#define REG_BK1474_0A_L      0x147414
#define REG_BK1474_0A_H      0x147415
#define REG_BK1474_0B_L      0x147416
#define REG_BK1474_0B_H      0x147417
#define REG_BK1474_0C_L      0x147418
#define REG_BK1474_0C_H      0x147419
#define REG_BK1474_0D_L      0x14741A
#define REG_BK1474_0D_H      0x14741B
#define REG_BK1474_0E_L      0x14741C
#define REG_BK1474_0E_H      0x14741D
#define REG_BK1474_0F_L      0x14741E
#define REG_BK1474_0F_H      0x14741F
#define REG_BK1474_10_L      0x147420
#define REG_BK1474_10_H      0x147421
#define REG_BK1474_11_L      0x147422
#define REG_BK1474_11_H      0x147423
#define REG_BK1474_12_L      0x147424
#define REG_BK1474_12_H      0x147425
#define REG_BK1474_13_L      0x147426
#define REG_BK1474_13_H      0x147427
#define REG_BK1474_14_L      0x147428
#define REG_BK1474_14_H      0x147429
#define REG_BK1474_15_L      0x14742A
#define REG_BK1474_15_H      0x14742B
#define REG_BK1474_16_L      0x14742C
#define REG_BK1474_16_H      0x14742D
#define REG_BK1474_17_L      0x14742E
#define REG_BK1474_17_H      0x14742F
#define REG_BK1474_18_L      0x147430
#define REG_BK1474_18_H      0x147431
#define REG_BK1474_19_L      0x147432
#define REG_BK1474_19_H      0x147433
#define REG_BK1474_1A_L      0x147434
#define REG_BK1474_1A_H      0x147435
#define REG_BK1474_1B_L      0x147436
#define REG_BK1474_1B_H      0x147437
#define REG_BK1474_1C_L      0x147438
#define REG_BK1474_1C_H      0x147439
#define REG_BK1474_1D_L      0x14743A
#define REG_BK1474_1D_H      0x14743B
#define REG_BK1474_1E_L      0x14743C
#define REG_BK1474_1E_H      0x14743D
#define REG_BK1474_1F_L      0x14743E
#define REG_BK1474_1F_H      0x14743F
#define REG_BK1474_20_L      0x147440
#define REG_BK1474_20_H      0x147441
#define REG_BK1474_21_L      0x147442
#define REG_BK1474_21_H      0x147443
#define REG_BK1474_22_L      0x147444
#define REG_BK1474_22_H      0x147445
#define REG_BK1474_23_L      0x147446
#define REG_BK1474_23_H      0x147447
#define REG_BK1474_24_L      0x147448
#define REG_BK1474_24_H      0x147449
#define REG_BK1474_25_L      0x14744A
#define REG_BK1474_25_H      0x14744B
#define REG_BK1474_26_L      0x14744C
#define REG_BK1474_26_H      0x14744D
#define REG_BK1474_27_L      0x14744E
#define REG_BK1474_27_H      0x14744F
#define REG_BK1474_28_L      0x147450
#define REG_BK1474_28_H      0x147451
#define REG_BK1474_29_L      0x147452
#define REG_BK1474_29_H      0x147453
#define REG_BK1474_2A_L      0x147454
#define REG_BK1474_2A_H      0x147455
#define REG_BK1474_2B_L      0x147456
#define REG_BK1474_2B_H      0x147457
#define REG_BK1474_2C_L      0x147458
#define REG_BK1474_2C_H      0x147459
#define REG_BK1474_2D_L      0x14745A
#define REG_BK1474_2D_H      0x14745B
#define REG_BK1474_2E_L      0x14745C
#define REG_BK1474_2E_H      0x14745D
#define REG_BK1474_2F_L      0x14745E
#define REG_BK1474_2F_H      0x14745F
#define REG_BK1474_30_L      0x147460
#define REG_BK1474_30_H      0x147461
#define REG_BK1474_31_L      0x147462
#define REG_BK1474_31_H      0x147463
#define REG_BK1474_32_L      0x147464
#define REG_BK1474_32_H      0x147465
#define REG_BK1474_33_L      0x147466
#define REG_BK1474_33_H      0x147467
#define REG_BK1474_34_L      0x147468
#define REG_BK1474_34_H      0x147469
#define REG_BK1474_35_L      0x14746A
#define REG_BK1474_35_H      0x14746B
#define REG_BK1474_36_L      0x14746C
#define REG_BK1474_36_H      0x14746D
#define REG_BK1474_37_L      0x14746E
#define REG_BK1474_37_H      0x14746F
#define REG_BK1474_38_L      0x147470
#define REG_BK1474_38_H      0x147471
#define REG_BK1474_39_L      0x147472
#define REG_BK1474_39_H      0x147473
#define REG_BK1474_3A_L      0x147474
#define REG_BK1474_3A_H      0x147475
#define REG_BK1474_3B_L      0x147476
#define REG_BK1474_3B_H      0x147477
#define REG_BK1474_3C_L      0x147478
#define REG_BK1474_3C_H      0x147479
#define REG_BK1474_3D_L      0x14747A
#define REG_BK1474_3D_H      0x14747B
#define REG_BK1474_3E_L      0x14747C
#define REG_BK1474_3E_H      0x14747D
#define REG_BK1474_3F_L      0x14747E
#define REG_BK1474_3F_H      0x14747F
#define REG_BK1474_40_L      0x147480
#define REG_BK1474_40_H      0x147481
#define REG_BK1474_41_L      0x147482
#define REG_BK1474_41_H      0x147483
#define REG_BK1474_42_L      0x147484
#define REG_BK1474_42_H      0x147485
#define REG_BK1474_43_L      0x147486
#define REG_BK1474_43_H      0x147487
#define REG_BK1474_44_L      0x147488
#define REG_BK1474_44_H      0x147489
#define REG_BK1474_45_L      0x14748A
#define REG_BK1474_45_H      0x14748B
#define REG_BK1474_46_L      0x14748C
#define REG_BK1474_46_H      0x14748D
#define REG_BK1474_47_L      0x14748E
#define REG_BK1474_47_H      0x14748F
#define REG_BK1474_48_L      0x147490
#define REG_BK1474_48_H      0x147491
#define REG_BK1474_49_L      0x147492
#define REG_BK1474_49_H      0x147493
#define REG_BK1474_4A_L      0x147494
#define REG_BK1474_4A_H      0x147495
#define REG_BK1474_4B_L      0x147496
#define REG_BK1474_4B_H      0x147497
#define REG_BK1474_4C_L      0x147498
#define REG_BK1474_4C_H      0x147499
#define REG_BK1474_4D_L      0x14749A
#define REG_BK1474_4D_H      0x14749B
#define REG_BK1474_4E_L      0x14749C
#define REG_BK1474_4E_H      0x14749D
#define REG_BK1474_4F_L      0x14749E
#define REG_BK1474_4F_H      0x14749F
#define REG_BK1474_50_L      0x1474A0
#define REG_BK1474_50_H      0x1474A1
#define REG_BK1474_51_L      0x1474A2
#define REG_BK1474_51_H      0x1474A3
#define REG_BK1474_52_L      0x1474A4
#define REG_BK1474_52_H      0x1474A5
#define REG_BK1474_53_L      0x1474A6
#define REG_BK1474_53_H      0x1474A7
#define REG_BK1474_54_L      0x1474A8
#define REG_BK1474_54_H      0x1474A9
#define REG_BK1474_55_L      0x1474AA
#define REG_BK1474_55_H      0x1474AB
#define REG_BK1474_56_L      0x1474AC
#define REG_BK1474_56_H      0x1474AD
#define REG_BK1474_57_L      0x1474AE
#define REG_BK1474_57_H      0x1474AF
#define REG_BK1474_58_L      0x1474B0
#define REG_BK1474_58_H      0x1474B1
#define REG_BK1474_59_L      0x1474B2
#define REG_BK1474_59_H      0x1474B3
#define REG_BK1474_5A_L      0x1474B4
#define REG_BK1474_5A_H      0x1474B5
#define REG_BK1474_5B_L      0x1474B6
#define REG_BK1474_5B_H      0x1474B7
#define REG_BK1474_5C_L      0x1474B8
#define REG_BK1474_5C_H      0x1474B9
#define REG_BK1474_5D_L      0x1474BA
#define REG_BK1474_5D_H      0x1474BB
#define REG_BK1474_5E_L      0x1474BC
#define REG_BK1474_5E_H      0x1474BD
#define REG_BK1474_5F_L      0x1474BE
#define REG_BK1474_5F_H      0x1474BF
#define REG_BK1474_60_L      0x1474C0
#define REG_BK1474_60_H      0x1474C1
#define REG_BK1474_61_L      0x1474C2
#define REG_BK1474_61_H      0x1474C3
#define REG_BK1474_62_L      0x1474C4
#define REG_BK1474_62_H      0x1474C5
#define REG_BK1474_63_L      0x1474C6
#define REG_BK1474_63_H      0x1474C7
#define REG_BK1474_64_L      0x1474C8
#define REG_BK1474_64_H      0x1474C9
#define REG_BK1474_65_L      0x1474CA
#define REG_BK1474_65_H      0x1474CB
#define REG_BK1474_66_L      0x1474CC
#define REG_BK1474_66_H      0x1474CD
#define REG_BK1474_67_L      0x1474CE
#define REG_BK1474_67_H      0x1474CF
#define REG_BK1474_68_L      0x1474D0
#define REG_BK1474_68_H      0x1474D1
#define REG_BK1474_69_L      0x1474D2
#define REG_BK1474_69_H      0x1474D3
#define REG_BK1474_6A_L      0x1474D4
#define REG_BK1474_6A_H      0x1474D5
#define REG_BK1474_6B_L      0x1474D6
#define REG_BK1474_6B_H      0x1474D7
#define REG_BK1474_6C_L      0x1474D8
#define REG_BK1474_6C_H      0x1474D9
#define REG_BK1474_6D_L      0x1474DA
#define REG_BK1474_6D_H      0x1474DB
#define REG_BK1474_6E_L      0x1474DC
#define REG_BK1474_6E_H      0x1474DD
#define REG_BK1474_6F_L      0x1474DE
#define REG_BK1474_6F_H      0x1474DF
#define REG_BK1474_70_L      0x1474E0
#define REG_BK1474_70_H      0x1474E1
#define REG_BK1474_71_L      0x1474E2
#define REG_BK1474_71_H      0x1474E3
#define REG_BK1474_72_L      0x1474E4
#define REG_BK1474_72_H      0x1474E5
#define REG_BK1474_73_L      0x1474E6
#define REG_BK1474_73_H      0x1474E7
#define REG_BK1474_74_L      0x1474E8
#define REG_BK1474_74_H      0x1474E9
#define REG_BK1474_75_L      0x1474EA
#define REG_BK1474_75_H      0x1474EB
#define REG_BK1474_76_L      0x1474EC
#define REG_BK1474_76_H      0x1474ED
#define REG_BK1474_77_L      0x1474EE
#define REG_BK1474_77_H      0x1474EF
#define REG_BK1474_78_L      0x1474F0
#define REG_BK1474_78_H      0x1474F1
#define REG_BK1474_79_L      0x1474F2
#define REG_BK1474_79_H      0x1474F3
#define REG_BK1474_7A_L      0x1474F4
#define REG_BK1474_7A_H      0x1474F5
#define REG_BK1474_7B_L      0x1474F6
#define REG_BK1474_7B_H      0x1474F7
#define REG_BK1474_7C_L      0x1474F8
#define REG_BK1474_7C_H      0x1474F9
#define REG_BK1474_7D_L      0x1474FA
#define REG_BK1474_7D_H      0x1474FB
#define REG_BK1474_7E_L      0x1474FC
#define REG_BK1474_7E_H      0x1474FD
#define REG_BK1474_7F_L      0x1474FE
#define REG_BK1474_7F_H      0x1474FF
//----------------------------------------------
#define REG_BK1475_00_L      0x147500
#define REG_BK1475_00_H      0x147501
#define REG_BK1475_01_L      0x147502
#define REG_BK1475_01_H      0x147503
#define REG_BK1475_02_L      0x147504
#define REG_BK1475_02_H      0x147505
#define REG_BK1475_03_L      0x147506
#define REG_BK1475_03_H      0x147507
#define REG_BK1475_04_L      0x147508
#define REG_BK1475_04_H      0x147509
#define REG_BK1475_05_L      0x14750A
#define REG_BK1475_05_H      0x14750B
#define REG_BK1475_06_L      0x14750C
#define REG_BK1475_06_H      0x14750D
#define REG_BK1475_07_L      0x14750E
#define REG_BK1475_07_H      0x14750F
#define REG_BK1475_08_L      0x147510
#define REG_BK1475_08_H      0x147511
#define REG_BK1475_09_L      0x147512
#define REG_BK1475_09_H      0x147513
#define REG_BK1475_0A_L      0x147514
#define REG_BK1475_0A_H      0x147515
#define REG_BK1475_0B_L      0x147516
#define REG_BK1475_0B_H      0x147517
#define REG_BK1475_0C_L      0x147518
#define REG_BK1475_0C_H      0x147519
#define REG_BK1475_0D_L      0x14751A
#define REG_BK1475_0D_H      0x14751B
#define REG_BK1475_0E_L      0x14751C
#define REG_BK1475_0E_H      0x14751D
#define REG_BK1475_0F_L      0x14751E
#define REG_BK1475_0F_H      0x14751F
#define REG_BK1475_10_L      0x147520
#define REG_BK1475_10_H      0x147521
#define REG_BK1475_11_L      0x147522
#define REG_BK1475_11_H      0x147523
#define REG_BK1475_12_L      0x147524
#define REG_BK1475_12_H      0x147525
#define REG_BK1475_13_L      0x147526
#define REG_BK1475_13_H      0x147527
#define REG_BK1475_14_L      0x147528
#define REG_BK1475_14_H      0x147529
#define REG_BK1475_15_L      0x14752A
#define REG_BK1475_15_H      0x14752B
#define REG_BK1475_16_L      0x14752C
#define REG_BK1475_16_H      0x14752D
#define REG_BK1475_17_L      0x14752E
#define REG_BK1475_17_H      0x14752F
#define REG_BK1475_18_L      0x147530
#define REG_BK1475_18_H      0x147531
#define REG_BK1475_19_L      0x147532
#define REG_BK1475_19_H      0x147533
#define REG_BK1475_1A_L      0x147534
#define REG_BK1475_1A_H      0x147535
#define REG_BK1475_1B_L      0x147536
#define REG_BK1475_1B_H      0x147537
#define REG_BK1475_1C_L      0x147538
#define REG_BK1475_1C_H      0x147539
#define REG_BK1475_1D_L      0x14753A
#define REG_BK1475_1D_H      0x14753B
#define REG_BK1475_1E_L      0x14753C
#define REG_BK1475_1E_H      0x14753D
#define REG_BK1475_1F_L      0x14753E
#define REG_BK1475_1F_H      0x14753F
#define REG_BK1475_20_L      0x147540
#define REG_BK1475_20_H      0x147541
#define REG_BK1475_21_L      0x147542
#define REG_BK1475_21_H      0x147543
#define REG_BK1475_22_L      0x147544
#define REG_BK1475_22_H      0x147545
#define REG_BK1475_23_L      0x147546
#define REG_BK1475_23_H      0x147547
#define REG_BK1475_24_L      0x147548
#define REG_BK1475_24_H      0x147549
#define REG_BK1475_25_L      0x14754A
#define REG_BK1475_25_H      0x14754B
#define REG_BK1475_26_L      0x14754C
#define REG_BK1475_26_H      0x14754D
#define REG_BK1475_27_L      0x14754E
#define REG_BK1475_27_H      0x14754F
#define REG_BK1475_28_L      0x147550
#define REG_BK1475_28_H      0x147551
#define REG_BK1475_29_L      0x147552
#define REG_BK1475_29_H      0x147553
#define REG_BK1475_2A_L      0x147554
#define REG_BK1475_2A_H      0x147555
#define REG_BK1475_2B_L      0x147556
#define REG_BK1475_2B_H      0x147557
#define REG_BK1475_2C_L      0x147558
#define REG_BK1475_2C_H      0x147559
#define REG_BK1475_2D_L      0x14755A
#define REG_BK1475_2D_H      0x14755B
#define REG_BK1475_2E_L      0x14755C
#define REG_BK1475_2E_H      0x14755D
#define REG_BK1475_2F_L      0x14755E
#define REG_BK1475_2F_H      0x14755F
#define REG_BK1475_30_L      0x147560
#define REG_BK1475_30_H      0x147561
#define REG_BK1475_31_L      0x147562
#define REG_BK1475_31_H      0x147563
#define REG_BK1475_32_L      0x147564
#define REG_BK1475_32_H      0x147565
#define REG_BK1475_33_L      0x147566
#define REG_BK1475_33_H      0x147567
#define REG_BK1475_34_L      0x147568
#define REG_BK1475_34_H      0x147569
#define REG_BK1475_35_L      0x14756A
#define REG_BK1475_35_H      0x14756B
#define REG_BK1475_36_L      0x14756C
#define REG_BK1475_36_H      0x14756D
#define REG_BK1475_37_L      0x14756E
#define REG_BK1475_37_H      0x14756F
#define REG_BK1475_38_L      0x147570
#define REG_BK1475_38_H      0x147571
#define REG_BK1475_39_L      0x147572
#define REG_BK1475_39_H      0x147573
#define REG_BK1475_3A_L      0x147574
#define REG_BK1475_3A_H      0x147575
#define REG_BK1475_3B_L      0x147576
#define REG_BK1475_3B_H      0x147577
#define REG_BK1475_3C_L      0x147578
#define REG_BK1475_3C_H      0x147579
#define REG_BK1475_3D_L      0x14757A
#define REG_BK1475_3D_H      0x14757B
#define REG_BK1475_3E_L      0x14757C
#define REG_BK1475_3E_H      0x14757D
#define REG_BK1475_3F_L      0x14757E
#define REG_BK1475_3F_H      0x14757F
#define REG_BK1475_40_L      0x147580
#define REG_BK1475_40_H      0x147581
#define REG_BK1475_41_L      0x147582
#define REG_BK1475_41_H      0x147583
#define REG_BK1475_42_L      0x147584
#define REG_BK1475_42_H      0x147585
#define REG_BK1475_43_L      0x147586
#define REG_BK1475_43_H      0x147587
#define REG_BK1475_44_L      0x147588
#define REG_BK1475_44_H      0x147589
#define REG_BK1475_45_L      0x14758A
#define REG_BK1475_45_H      0x14758B
#define REG_BK1475_46_L      0x14758C
#define REG_BK1475_46_H      0x14758D
#define REG_BK1475_47_L      0x14758E
#define REG_BK1475_47_H      0x14758F
#define REG_BK1475_48_L      0x147590
#define REG_BK1475_48_H      0x147591
#define REG_BK1475_49_L      0x147592
#define REG_BK1475_49_H      0x147593
#define REG_BK1475_4A_L      0x147594
#define REG_BK1475_4A_H      0x147595
#define REG_BK1475_4B_L      0x147596
#define REG_BK1475_4B_H      0x147597
#define REG_BK1475_4C_L      0x147598
#define REG_BK1475_4C_H      0x147599
#define REG_BK1475_4D_L      0x14759A
#define REG_BK1475_4D_H      0x14759B
#define REG_BK1475_4E_L      0x14759C
#define REG_BK1475_4E_H      0x14759D
#define REG_BK1475_4F_L      0x14759E
#define REG_BK1475_4F_H      0x14759F
#define REG_BK1475_50_L      0x1475A0
#define REG_BK1475_50_H      0x1475A1
#define REG_BK1475_51_L      0x1475A2
#define REG_BK1475_51_H      0x1475A3
#define REG_BK1475_52_L      0x1475A4
#define REG_BK1475_52_H      0x1475A5
#define REG_BK1475_53_L      0x1475A6
#define REG_BK1475_53_H      0x1475A7
#define REG_BK1475_54_L      0x1475A8
#define REG_BK1475_54_H      0x1475A9
#define REG_BK1475_55_L      0x1475AA
#define REG_BK1475_55_H      0x1475AB
#define REG_BK1475_56_L      0x1475AC
#define REG_BK1475_56_H      0x1475AD
#define REG_BK1475_57_L      0x1475AE
#define REG_BK1475_57_H      0x1475AF
#define REG_BK1475_58_L      0x1475B0
#define REG_BK1475_58_H      0x1475B1
#define REG_BK1475_59_L      0x1475B2
#define REG_BK1475_59_H      0x1475B3
#define REG_BK1475_5A_L      0x1475B4
#define REG_BK1475_5A_H      0x1475B5
#define REG_BK1475_5B_L      0x1475B6
#define REG_BK1475_5B_H      0x1475B7
#define REG_BK1475_5C_L      0x1475B8
#define REG_BK1475_5C_H      0x1475B9
#define REG_BK1475_5D_L      0x1475BA
#define REG_BK1475_5D_H      0x1475BB
#define REG_BK1475_5E_L      0x1475BC
#define REG_BK1475_5E_H      0x1475BD
#define REG_BK1475_5F_L      0x1475BE
#define REG_BK1475_5F_H      0x1475BF
#define REG_BK1475_60_L      0x1475C0
#define REG_BK1475_60_H      0x1475C1
#define REG_BK1475_61_L      0x1475C2
#define REG_BK1475_61_H      0x1475C3
#define REG_BK1475_62_L      0x1475C4
#define REG_BK1475_62_H      0x1475C5
#define REG_BK1475_63_L      0x1475C6
#define REG_BK1475_63_H      0x1475C7
#define REG_BK1475_64_L      0x1475C8
#define REG_BK1475_64_H      0x1475C9
#define REG_BK1475_65_L      0x1475CA
#define REG_BK1475_65_H      0x1475CB
#define REG_BK1475_66_L      0x1475CC
#define REG_BK1475_66_H      0x1475CD
#define REG_BK1475_67_L      0x1475CE
#define REG_BK1475_67_H      0x1475CF
#define REG_BK1475_68_L      0x1475D0
#define REG_BK1475_68_H      0x1475D1
#define REG_BK1475_69_L      0x1475D2
#define REG_BK1475_69_H      0x1475D3
#define REG_BK1475_6A_L      0x1475D4
#define REG_BK1475_6A_H      0x1475D5
#define REG_BK1475_6B_L      0x1475D6
#define REG_BK1475_6B_H      0x1475D7
#define REG_BK1475_6C_L      0x1475D8
#define REG_BK1475_6C_H      0x1475D9
#define REG_BK1475_6D_L      0x1475DA
#define REG_BK1475_6D_H      0x1475DB
#define REG_BK1475_6E_L      0x1475DC
#define REG_BK1475_6E_H      0x1475DD
#define REG_BK1475_6F_L      0x1475DE
#define REG_BK1475_6F_H      0x1475DF
#define REG_BK1475_70_L      0x1475E0
#define REG_BK1475_70_H      0x1475E1
#define REG_BK1475_71_L      0x1475E2
#define REG_BK1475_71_H      0x1475E3
#define REG_BK1475_72_L      0x1475E4
#define REG_BK1475_72_H      0x1475E5
#define REG_BK1475_73_L      0x1475E6
#define REG_BK1475_73_H      0x1475E7
#define REG_BK1475_74_L      0x1475E8
#define REG_BK1475_74_H      0x1475E9
#define REG_BK1475_75_L      0x1475EA
#define REG_BK1475_75_H      0x1475EB
#define REG_BK1475_76_L      0x1475EC
#define REG_BK1475_76_H      0x1475ED
#define REG_BK1475_77_L      0x1475EE
#define REG_BK1475_77_H      0x1475EF
#define REG_BK1475_78_L      0x1475F0
#define REG_BK1475_78_H      0x1475F1
#define REG_BK1475_79_L      0x1475F2
#define REG_BK1475_79_H      0x1475F3
#define REG_BK1475_7A_L      0x1475F4
#define REG_BK1475_7A_H      0x1475F5
#define REG_BK1475_7B_L      0x1475F6
#define REG_BK1475_7B_H      0x1475F7
#define REG_BK1475_7C_L      0x1475F8
#define REG_BK1475_7C_H      0x1475F9
#define REG_BK1475_7D_L      0x1475FA
#define REG_BK1475_7D_H      0x1475FB
#define REG_BK1475_7E_L      0x1475FC
#define REG_BK1475_7E_H      0x1475FD
#define REG_BK1475_7F_L      0x1475FE
#define REG_BK1475_7F_H      0x1475FF
//----------------------------------------------
#define REG_BK1476_00_L      0x147600
#define REG_BK1476_00_H      0x147601
#define REG_BK1476_01_L      0x147602
#define REG_BK1476_01_H      0x147603
#define REG_BK1476_02_L      0x147604
#define REG_BK1476_02_H      0x147605
#define REG_BK1476_03_L      0x147606
#define REG_BK1476_03_H      0x147607
#define REG_BK1476_04_L      0x147608
#define REG_BK1476_04_H      0x147609
#define REG_BK1476_05_L      0x14760A
#define REG_BK1476_05_H      0x14760B
#define REG_BK1476_06_L      0x14760C
#define REG_BK1476_06_H      0x14760D
#define REG_BK1476_07_L      0x14760E
#define REG_BK1476_07_H      0x14760F
#define REG_BK1476_08_L      0x147610
#define REG_BK1476_08_H      0x147611
#define REG_BK1476_09_L      0x147612
#define REG_BK1476_09_H      0x147613
#define REG_BK1476_0A_L      0x147614
#define REG_BK1476_0A_H      0x147615
#define REG_BK1476_0B_L      0x147616
#define REG_BK1476_0B_H      0x147617
#define REG_BK1476_0C_L      0x147618
#define REG_BK1476_0C_H      0x147619
#define REG_BK1476_0D_L      0x14761A
#define REG_BK1476_0D_H      0x14761B
#define REG_BK1476_0E_L      0x14761C
#define REG_BK1476_0E_H      0x14761D
#define REG_BK1476_0F_L      0x14761E
#define REG_BK1476_0F_H      0x14761F
#define REG_BK1476_10_L      0x147620
#define REG_BK1476_10_H      0x147621
#define REG_BK1476_11_L      0x147622
#define REG_BK1476_11_H      0x147623
#define REG_BK1476_12_L      0x147624
#define REG_BK1476_12_H      0x147625
#define REG_BK1476_13_L      0x147626
#define REG_BK1476_13_H      0x147627
#define REG_BK1476_14_L      0x147628
#define REG_BK1476_14_H      0x147629
#define REG_BK1476_15_L      0x14762A
#define REG_BK1476_15_H      0x14762B
#define REG_BK1476_16_L      0x14762C
#define REG_BK1476_16_H      0x14762D
#define REG_BK1476_17_L      0x14762E
#define REG_BK1476_17_H      0x14762F
#define REG_BK1476_18_L      0x147630
#define REG_BK1476_18_H      0x147631
#define REG_BK1476_19_L      0x147632
#define REG_BK1476_19_H      0x147633
#define REG_BK1476_1A_L      0x147634
#define REG_BK1476_1A_H      0x147635
#define REG_BK1476_1B_L      0x147636
#define REG_BK1476_1B_H      0x147637
#define REG_BK1476_1C_L      0x147638
#define REG_BK1476_1C_H      0x147639
#define REG_BK1476_1D_L      0x14763A
#define REG_BK1476_1D_H      0x14763B
#define REG_BK1476_1E_L      0x14763C
#define REG_BK1476_1E_H      0x14763D
#define REG_BK1476_1F_L      0x14763E
#define REG_BK1476_1F_H      0x14763F
#define REG_BK1476_20_L      0x147640
#define REG_BK1476_20_H      0x147641
#define REG_BK1476_21_L      0x147642
#define REG_BK1476_21_H      0x147643
#define REG_BK1476_22_L      0x147644
#define REG_BK1476_22_H      0x147645
#define REG_BK1476_23_L      0x147646
#define REG_BK1476_23_H      0x147647
#define REG_BK1476_24_L      0x147648
#define REG_BK1476_24_H      0x147649
#define REG_BK1476_25_L      0x14764A
#define REG_BK1476_25_H      0x14764B
#define REG_BK1476_26_L      0x14764C
#define REG_BK1476_26_H      0x14764D
#define REG_BK1476_27_L      0x14764E
#define REG_BK1476_27_H      0x14764F
#define REG_BK1476_28_L      0x147650
#define REG_BK1476_28_H      0x147651
#define REG_BK1476_29_L      0x147652
#define REG_BK1476_29_H      0x147653
#define REG_BK1476_2A_L      0x147654
#define REG_BK1476_2A_H      0x147655
#define REG_BK1476_2B_L      0x147656
#define REG_BK1476_2B_H      0x147657
#define REG_BK1476_2C_L      0x147658
#define REG_BK1476_2C_H      0x147659
#define REG_BK1476_2D_L      0x14765A
#define REG_BK1476_2D_H      0x14765B
#define REG_BK1476_2E_L      0x14765C
#define REG_BK1476_2E_H      0x14765D
#define REG_BK1476_2F_L      0x14765E
#define REG_BK1476_2F_H      0x14765F
#define REG_BK1476_30_L      0x147660
#define REG_BK1476_30_H      0x147661
#define REG_BK1476_31_L      0x147662
#define REG_BK1476_31_H      0x147663
#define REG_BK1476_32_L      0x147664
#define REG_BK1476_32_H      0x147665
#define REG_BK1476_33_L      0x147666
#define REG_BK1476_33_H      0x147667
#define REG_BK1476_34_L      0x147668
#define REG_BK1476_34_H      0x147669
#define REG_BK1476_35_L      0x14766A
#define REG_BK1476_35_H      0x14766B
#define REG_BK1476_36_L      0x14766C
#define REG_BK1476_36_H      0x14766D
#define REG_BK1476_37_L      0x14766E
#define REG_BK1476_37_H      0x14766F
#define REG_BK1476_38_L      0x147670
#define REG_BK1476_38_H      0x147671
#define REG_BK1476_39_L      0x147672
#define REG_BK1476_39_H      0x147673
#define REG_BK1476_3A_L      0x147674
#define REG_BK1476_3A_H      0x147675
#define REG_BK1476_3B_L      0x147676
#define REG_BK1476_3B_H      0x147677
#define REG_BK1476_3C_L      0x147678
#define REG_BK1476_3C_H      0x147679
#define REG_BK1476_3D_L      0x14767A
#define REG_BK1476_3D_H      0x14767B
#define REG_BK1476_3E_L      0x14767C
#define REG_BK1476_3E_H      0x14767D
#define REG_BK1476_3F_L      0x14767E
#define REG_BK1476_3F_H      0x14767F
#define REG_BK1476_40_L      0x147680
#define REG_BK1476_40_H      0x147681
#define REG_BK1476_41_L      0x147682
#define REG_BK1476_41_H      0x147683
#define REG_BK1476_42_L      0x147684
#define REG_BK1476_42_H      0x147685
#define REG_BK1476_43_L      0x147686
#define REG_BK1476_43_H      0x147687
#define REG_BK1476_44_L      0x147688
#define REG_BK1476_44_H      0x147689
#define REG_BK1476_45_L      0x14768A
#define REG_BK1476_45_H      0x14768B
#define REG_BK1476_46_L      0x14768C
#define REG_BK1476_46_H      0x14768D
#define REG_BK1476_47_L      0x14768E
#define REG_BK1476_47_H      0x14768F
#define REG_BK1476_48_L      0x147690
#define REG_BK1476_48_H      0x147691
#define REG_BK1476_49_L      0x147692
#define REG_BK1476_49_H      0x147693
#define REG_BK1476_4A_L      0x147694
#define REG_BK1476_4A_H      0x147695
#define REG_BK1476_4B_L      0x147696
#define REG_BK1476_4B_H      0x147697
#define REG_BK1476_4C_L      0x147698
#define REG_BK1476_4C_H      0x147699
#define REG_BK1476_4D_L      0x14769A
#define REG_BK1476_4D_H      0x14769B
#define REG_BK1476_4E_L      0x14769C
#define REG_BK1476_4E_H      0x14769D
#define REG_BK1476_4F_L      0x14769E
#define REG_BK1476_4F_H      0x14769F
#define REG_BK1476_50_L      0x1476A0
#define REG_BK1476_50_H      0x1476A1
#define REG_BK1476_51_L      0x1476A2
#define REG_BK1476_51_H      0x1476A3
#define REG_BK1476_52_L      0x1476A4
#define REG_BK1476_52_H      0x1476A5
#define REG_BK1476_53_L      0x1476A6
#define REG_BK1476_53_H      0x1476A7
#define REG_BK1476_54_L      0x1476A8
#define REG_BK1476_54_H      0x1476A9
#define REG_BK1476_55_L      0x1476AA
#define REG_BK1476_55_H      0x1476AB
#define REG_BK1476_56_L      0x1476AC
#define REG_BK1476_56_H      0x1476AD
#define REG_BK1476_57_L      0x1476AE
#define REG_BK1476_57_H      0x1476AF
#define REG_BK1476_58_L      0x1476B0
#define REG_BK1476_58_H      0x1476B1
#define REG_BK1476_59_L      0x1476B2
#define REG_BK1476_59_H      0x1476B3
#define REG_BK1476_5A_L      0x1476B4
#define REG_BK1476_5A_H      0x1476B5
#define REG_BK1476_5B_L      0x1476B6
#define REG_BK1476_5B_H      0x1476B7
#define REG_BK1476_5C_L      0x1476B8
#define REG_BK1476_5C_H      0x1476B9
#define REG_BK1476_5D_L      0x1476BA
#define REG_BK1476_5D_H      0x1476BB
#define REG_BK1476_5E_L      0x1476BC
#define REG_BK1476_5E_H      0x1476BD
#define REG_BK1476_5F_L      0x1476BE
#define REG_BK1476_5F_H      0x1476BF
#define REG_BK1476_60_L      0x1476C0
#define REG_BK1476_60_H      0x1476C1
#define REG_BK1476_61_L      0x1476C2
#define REG_BK1476_61_H      0x1476C3
#define REG_BK1476_62_L      0x1476C4
#define REG_BK1476_62_H      0x1476C5
#define REG_BK1476_63_L      0x1476C6
#define REG_BK1476_63_H      0x1476C7
#define REG_BK1476_64_L      0x1476C8
#define REG_BK1476_64_H      0x1476C9
#define REG_BK1476_65_L      0x1476CA
#define REG_BK1476_65_H      0x1476CB
#define REG_BK1476_66_L      0x1476CC
#define REG_BK1476_66_H      0x1476CD
#define REG_BK1476_67_L      0x1476CE
#define REG_BK1476_67_H      0x1476CF
#define REG_BK1476_68_L      0x1476D0
#define REG_BK1476_68_H      0x1476D1
#define REG_BK1476_69_L      0x1476D2
#define REG_BK1476_69_H      0x1476D3
#define REG_BK1476_6A_L      0x1476D4
#define REG_BK1476_6A_H      0x1476D5
#define REG_BK1476_6B_L      0x1476D6
#define REG_BK1476_6B_H      0x1476D7
#define REG_BK1476_6C_L      0x1476D8
#define REG_BK1476_6C_H      0x1476D9
#define REG_BK1476_6D_L      0x1476DA
#define REG_BK1476_6D_H      0x1476DB
#define REG_BK1476_6E_L      0x1476DC
#define REG_BK1476_6E_H      0x1476DD
#define REG_BK1476_6F_L      0x1476DE
#define REG_BK1476_6F_H      0x1476DF
#define REG_BK1476_70_L      0x1476E0
#define REG_BK1476_70_H      0x1476E1
#define REG_BK1476_71_L      0x1476E2
#define REG_BK1476_71_H      0x1476E3
#define REG_BK1476_72_L      0x1476E4
#define REG_BK1476_72_H      0x1476E5
#define REG_BK1476_73_L      0x1476E6
#define REG_BK1476_73_H      0x1476E7
#define REG_BK1476_74_L      0x1476E8
#define REG_BK1476_74_H      0x1476E9
#define REG_BK1476_75_L      0x1476EA
#define REG_BK1476_75_H      0x1476EB
#define REG_BK1476_76_L      0x1476EC
#define REG_BK1476_76_H      0x1476ED
#define REG_BK1476_77_L      0x1476EE
#define REG_BK1476_77_H      0x1476EF
#define REG_BK1476_78_L      0x1476F0
#define REG_BK1476_78_H      0x1476F1
#define REG_BK1476_79_L      0x1476F2
#define REG_BK1476_79_H      0x1476F3
#define REG_BK1476_7A_L      0x1476F4
#define REG_BK1476_7A_H      0x1476F5
#define REG_BK1476_7B_L      0x1476F6
#define REG_BK1476_7B_H      0x1476F7
#define REG_BK1476_7C_L      0x1476F8
#define REG_BK1476_7C_H      0x1476F9
#define REG_BK1476_7D_L      0x1476FA
#define REG_BK1476_7D_H      0x1476FB
#define REG_BK1476_7E_L      0x1476FC
#define REG_BK1476_7E_H      0x1476FD
#define REG_BK1476_7F_L      0x1476FE
#define REG_BK1476_7F_H      0x1476FF
//----------------------------------------------
#define REG_BK14AC_00_L      0x14AC00
#define REG_BK14AC_00_H      0x14AC01
#define REG_BK14AC_01_L      0x14AC02
#define REG_BK14AC_01_H      0x14AC03
#define REG_BK14AC_02_L      0x14AC04
#define REG_BK14AC_02_H      0x14AC05
#define REG_BK14AC_03_L      0x14AC06
#define REG_BK14AC_03_H      0x14AC07
#define REG_BK14AC_04_L      0x14AC08
#define REG_BK14AC_04_H      0x14AC09
#define REG_BK14AC_05_L      0x14AC0A
#define REG_BK14AC_05_H      0x14AC0B
#define REG_BK14AC_06_L      0x14AC0C
#define REG_BK14AC_06_H      0x14AC0D
#define REG_BK14AC_07_L      0x14AC0E
#define REG_BK14AC_07_H      0x14AC0F
#define REG_BK14AC_08_L      0x14AC10
#define REG_BK14AC_08_H      0x14AC11
#define REG_BK14AC_09_L      0x14AC12
#define REG_BK14AC_09_H      0x14AC13
#define REG_BK14AC_0A_L      0x14AC14
#define REG_BK14AC_0A_H      0x14AC15
#define REG_BK14AC_0B_L      0x14AC16
#define REG_BK14AC_0B_H      0x14AC17
#define REG_BK14AC_0C_L      0x14AC18
#define REG_BK14AC_0C_H      0x14AC19
#define REG_BK14AC_0D_L      0x14AC1A
#define REG_BK14AC_0D_H      0x14AC1B
#define REG_BK14AC_0E_L      0x14AC1C
#define REG_BK14AC_0E_H      0x14AC1D
#define REG_BK14AC_0F_L      0x14AC1E
#define REG_BK14AC_0F_H      0x14AC1F
#define REG_BK14AC_10_L      0x14AC20
#define REG_BK14AC_10_H      0x14AC21
#define REG_BK14AC_11_L      0x14AC22
#define REG_BK14AC_11_H      0x14AC23
#define REG_BK14AC_12_L      0x14AC24
#define REG_BK14AC_12_H      0x14AC25
#define REG_BK14AC_13_L      0x14AC26
#define REG_BK14AC_13_H      0x14AC27
#define REG_BK14AC_14_L      0x14AC28
#define REG_BK14AC_14_H      0x14AC29
#define REG_BK14AC_15_L      0x14AC2A
#define REG_BK14AC_15_H      0x14AC2B
#define REG_BK14AC_16_L      0x14AC2C
#define REG_BK14AC_16_H      0x14AC2D
#define REG_BK14AC_17_L      0x14AC2E
#define REG_BK14AC_17_H      0x14AC2F
#define REG_BK14AC_18_L      0x14AC30
#define REG_BK14AC_18_H      0x14AC31
#define REG_BK14AC_19_L      0x14AC32
#define REG_BK14AC_19_H      0x14AC33
#define REG_BK14AC_1A_L      0x14AC34
#define REG_BK14AC_1A_H      0x14AC35
#define REG_BK14AC_1B_L      0x14AC36
#define REG_BK14AC_1B_H      0x14AC37
#define REG_BK14AC_1C_L      0x14AC38
#define REG_BK14AC_1C_H      0x14AC39
#define REG_BK14AC_1D_L      0x14AC3A
#define REG_BK14AC_1D_H      0x14AC3B
#define REG_BK14AC_1E_L      0x14AC3C
#define REG_BK14AC_1E_H      0x14AC3D
#define REG_BK14AC_1F_L      0x14AC3E
#define REG_BK14AC_1F_H      0x14AC3F
#define REG_BK14AC_20_L      0x14AC40
#define REG_BK14AC_20_H      0x14AC41
#define REG_BK14AC_21_L      0x14AC42
#define REG_BK14AC_21_H      0x14AC43
#define REG_BK14AC_22_L      0x14AC44
#define REG_BK14AC_22_H      0x14AC45
#define REG_BK14AC_23_L      0x14AC46
#define REG_BK14AC_23_H      0x14AC47
#define REG_BK14AC_24_L      0x14AC48
#define REG_BK14AC_24_H      0x14AC49
#define REG_BK14AC_25_L      0x14AC4A
#define REG_BK14AC_25_H      0x14AC4B
#define REG_BK14AC_26_L      0x14AC4C
#define REG_BK14AC_26_H      0x14AC4D
#define REG_BK14AC_27_L      0x14AC4E
#define REG_BK14AC_27_H      0x14AC4F
#define REG_BK14AC_28_L      0x14AC50
#define REG_BK14AC_28_H      0x14AC51
#define REG_BK14AC_29_L      0x14AC52
#define REG_BK14AC_29_H      0x14AC53
#define REG_BK14AC_2A_L      0x14AC54
#define REG_BK14AC_2A_H      0x14AC55
#define REG_BK14AC_2B_L      0x14AC56
#define REG_BK14AC_2B_H      0x14AC57
#define REG_BK14AC_2C_L      0x14AC58
#define REG_BK14AC_2C_H      0x14AC59
#define REG_BK14AC_2D_L      0x14AC5A
#define REG_BK14AC_2D_H      0x14AC5B
#define REG_BK14AC_2E_L      0x14AC5C
#define REG_BK14AC_2E_H      0x14AC5D
#define REG_BK14AC_2F_L      0x14AC5E
#define REG_BK14AC_2F_H      0x14AC5F
#define REG_BK14AC_30_L      0x14AC60
#define REG_BK14AC_30_H      0x14AC61
#define REG_BK14AC_31_L      0x14AC62
#define REG_BK14AC_31_H      0x14AC63
#define REG_BK14AC_32_L      0x14AC64
#define REG_BK14AC_32_H      0x14AC65
#define REG_BK14AC_33_L      0x14AC66
#define REG_BK14AC_33_H      0x14AC67
#define REG_BK14AC_34_L      0x14AC68
#define REG_BK14AC_34_H      0x14AC69
#define REG_BK14AC_35_L      0x14AC6A
#define REG_BK14AC_35_H      0x14AC6B
#define REG_BK14AC_36_L      0x14AC6C
#define REG_BK14AC_36_H      0x14AC6D
#define REG_BK14AC_37_L      0x14AC6E
#define REG_BK14AC_37_H      0x14AC6F
#define REG_BK14AC_38_L      0x14AC70
#define REG_BK14AC_38_H      0x14AC71
#define REG_BK14AC_39_L      0x14AC72
#define REG_BK14AC_39_H      0x14AC73
#define REG_BK14AC_3A_L      0x14AC74
#define REG_BK14AC_3A_H      0x14AC75
#define REG_BK14AC_3B_L      0x14AC76
#define REG_BK14AC_3B_H      0x14AC77
#define REG_BK14AC_3C_L      0x14AC78
#define REG_BK14AC_3C_H      0x14AC79
#define REG_BK14AC_3D_L      0x14AC7A
#define REG_BK14AC_3D_H      0x14AC7B
#define REG_BK14AC_3E_L      0x14AC7C
#define REG_BK14AC_3E_H      0x14AC7D
#define REG_BK14AC_3F_L      0x14AC7E
#define REG_BK14AC_3F_H      0x14AC7F
#define REG_BK14AC_40_L      0x14AC80
#define REG_BK14AC_40_H      0x14AC81
#define REG_BK14AC_41_L      0x14AC82
#define REG_BK14AC_41_H      0x14AC83
#define REG_BK14AC_42_L      0x14AC84
#define REG_BK14AC_42_H      0x14AC85
#define REG_BK14AC_43_L      0x14AC86
#define REG_BK14AC_43_H      0x14AC87
#define REG_BK14AC_44_L      0x14AC88
#define REG_BK14AC_44_H      0x14AC89
#define REG_BK14AC_45_L      0x14AC8A
#define REG_BK14AC_45_H      0x14AC8B
#define REG_BK14AC_46_L      0x14AC8C
#define REG_BK14AC_46_H      0x14AC8D
#define REG_BK14AC_47_L      0x14AC8E
#define REG_BK14AC_47_H      0x14AC8F
#define REG_BK14AC_48_L      0x14AC90
#define REG_BK14AC_48_H      0x14AC91
#define REG_BK14AC_49_L      0x14AC92
#define REG_BK14AC_49_H      0x14AC93
#define REG_BK14AC_4A_L      0x14AC94
#define REG_BK14AC_4A_H      0x14AC95
#define REG_BK14AC_4B_L      0x14AC96
#define REG_BK14AC_4B_H      0x14AC97
#define REG_BK14AC_4C_L      0x14AC98
#define REG_BK14AC_4C_H      0x14AC99
#define REG_BK14AC_4D_L      0x14AC9A
#define REG_BK14AC_4D_H      0x14AC9B
#define REG_BK14AC_4E_L      0x14AC9C
#define REG_BK14AC_4E_H      0x14AC9D
#define REG_BK14AC_4F_L      0x14AC9E
#define REG_BK14AC_4F_H      0x14AC9F
#define REG_BK14AC_50_L      0x14ACA0
#define REG_BK14AC_50_H      0x14ACA1
#define REG_BK14AC_51_L      0x14ACA2
#define REG_BK14AC_51_H      0x14ACA3
#define REG_BK14AC_52_L      0x14ACA4
#define REG_BK14AC_52_H      0x14ACA5
#define REG_BK14AC_53_L      0x14ACA6
#define REG_BK14AC_53_H      0x14ACA7
#define REG_BK14AC_54_L      0x14ACA8
#define REG_BK14AC_54_H      0x14ACA9
#define REG_BK14AC_55_L      0x14ACAA
#define REG_BK14AC_55_H      0x14ACAB
#define REG_BK14AC_56_L      0x14ACAC
#define REG_BK14AC_56_H      0x14ACAD
#define REG_BK14AC_57_L      0x14ACAE
#define REG_BK14AC_57_H      0x14ACAF
#define REG_BK14AC_58_L      0x14ACB0
#define REG_BK14AC_58_H      0x14ACB1
#define REG_BK14AC_59_L      0x14ACB2
#define REG_BK14AC_59_H      0x14ACB3
#define REG_BK14AC_5A_L      0x14ACB4
#define REG_BK14AC_5A_H      0x14ACB5
#define REG_BK14AC_5B_L      0x14ACB6
#define REG_BK14AC_5B_H      0x14ACB7
#define REG_BK14AC_5C_L      0x14ACB8
#define REG_BK14AC_5C_H      0x14ACB9
#define REG_BK14AC_5D_L      0x14ACBA
#define REG_BK14AC_5D_H      0x14ACBB
#define REG_BK14AC_5E_L      0x14ACBC
#define REG_BK14AC_5E_H      0x14ACBD
#define REG_BK14AC_5F_L      0x14ACBE
#define REG_BK14AC_5F_H      0x14ACBF
#define REG_BK14AC_60_L      0x14ACC0
#define REG_BK14AC_60_H      0x14ACC1
#define REG_BK14AC_61_L      0x14ACC2
#define REG_BK14AC_61_H      0x14ACC3
#define REG_BK14AC_62_L      0x14ACC4
#define REG_BK14AC_62_H      0x14ACC5
#define REG_BK14AC_63_L      0x14ACC6
#define REG_BK14AC_63_H      0x14ACC7
#define REG_BK14AC_64_L      0x14ACC8
#define REG_BK14AC_64_H      0x14ACC9
#define REG_BK14AC_65_L      0x14ACCA
#define REG_BK14AC_65_H      0x14ACCB
#define REG_BK14AC_66_L      0x14ACCC
#define REG_BK14AC_66_H      0x14ACCD
#define REG_BK14AC_67_L      0x14ACCE
#define REG_BK14AC_67_H      0x14ACCF
#define REG_BK14AC_68_L      0x14ACD0
#define REG_BK14AC_68_H      0x14ACD1
#define REG_BK14AC_69_L      0x14ACD2
#define REG_BK14AC_69_H      0x14ACD3
#define REG_BK14AC_6A_L      0x14ACD4
#define REG_BK14AC_6A_H      0x14ACD5
#define REG_BK14AC_6B_L      0x14ACD6
#define REG_BK14AC_6B_H      0x14ACD7
#define REG_BK14AC_6C_L      0x14ACD8
#define REG_BK14AC_6C_H      0x14ACD9
#define REG_BK14AC_6D_L      0x14ACDA
#define REG_BK14AC_6D_H      0x14ACDB
#define REG_BK14AC_6E_L      0x14ACDC
#define REG_BK14AC_6E_H      0x14ACDD
#define REG_BK14AC_6F_L      0x14ACDE
#define REG_BK14AC_6F_H      0x14ACDF
#define REG_BK14AC_70_L      0x14ACE0
#define REG_BK14AC_70_H      0x14ACE1
#define REG_BK14AC_71_L      0x14ACE2
#define REG_BK14AC_71_H      0x14ACE3
#define REG_BK14AC_72_L      0x14ACE4
#define REG_BK14AC_72_H      0x14ACE5
#define REG_BK14AC_73_L      0x14ACE6
#define REG_BK14AC_73_H      0x14ACE7
#define REG_BK14AC_74_L      0x14ACE8
#define REG_BK14AC_74_H      0x14ACE9
#define REG_BK14AC_75_L      0x14ACEA
#define REG_BK14AC_75_H      0x14ACEB
#define REG_BK14AC_76_L      0x14ACEC
#define REG_BK14AC_76_H      0x14ACED
#define REG_BK14AC_77_L      0x14ACEE
#define REG_BK14AC_77_H      0x14ACEF
#define REG_BK14AC_78_L      0x14ACF0
#define REG_BK14AC_78_H      0x14ACF1
#define REG_BK14AC_79_L      0x14ACF2
#define REG_BK14AC_79_H      0x14ACF3
#define REG_BK14AC_7A_L      0x14ACF4
#define REG_BK14AC_7A_H      0x14ACF5
#define REG_BK14AC_7B_L      0x14ACF6
#define REG_BK14AC_7B_H      0x14ACF7
#define REG_BK14AC_7C_L      0x14ACF8
#define REG_BK14AC_7C_H      0x14ACF9
#define REG_BK14AC_7D_L      0x14ACFA
#define REG_BK14AC_7D_H      0x14ACFB
#define REG_BK14AC_7E_L      0x14ACFC
#define REG_BK14AC_7E_H      0x14ACFD
#define REG_BK14AC_7F_L      0x14ACFE
#define REG_BK14AC_7F_H      0x14ACFF
//----------------------------------------------
#define REG_BK14CD_00_L      0x14CD00
#define REG_BK14CD_00_H      0x14CD01
#define REG_BK14CD_01_L      0x14CD02
#define REG_BK14CD_01_H      0x14CD03
#define REG_BK14CD_02_L      0x14CD04
#define REG_BK14CD_02_H      0x14CD05
#define REG_BK14CD_03_L      0x14CD06
#define REG_BK14CD_03_H      0x14CD07
#define REG_BK14CD_04_L      0x14CD08
#define REG_BK14CD_04_H      0x14CD09
#define REG_BK14CD_05_L      0x14CD0A
#define REG_BK14CD_05_H      0x14CD0B
#define REG_BK14CD_06_L      0x14CD0C
#define REG_BK14CD_06_H      0x14CD0D
#define REG_BK14CD_07_L      0x14CD0E
#define REG_BK14CD_07_H      0x14CD0F
#define REG_BK14CD_08_L      0x14CD10
#define REG_BK14CD_08_H      0x14CD11
#define REG_BK14CD_09_L      0x14CD12
#define REG_BK14CD_09_H      0x14CD13
#define REG_BK14CD_0A_L      0x14CD14
#define REG_BK14CD_0A_H      0x14CD15
#define REG_BK14CD_0B_L      0x14CD16
#define REG_BK14CD_0B_H      0x14CD17
#define REG_BK14CD_0C_L      0x14CD18
#define REG_BK14CD_0C_H      0x14CD19
#define REG_BK14CD_0D_L      0x14CD1A
#define REG_BK14CD_0D_H      0x14CD1B
#define REG_BK14CD_0E_L      0x14CD1C
#define REG_BK14CD_0E_H      0x14CD1D
#define REG_BK14CD_0F_L      0x14CD1E
#define REG_BK14CD_0F_H      0x14CD1F
#define REG_BK14CD_10_L      0x14CD20
#define REG_BK14CD_10_H      0x14CD21
#define REG_BK14CD_11_L      0x14CD22
#define REG_BK14CD_11_H      0x14CD23
#define REG_BK14CD_12_L      0x14CD24
#define REG_BK14CD_12_H      0x14CD25
#define REG_BK14CD_13_L      0x14CD26
#define REG_BK14CD_13_H      0x14CD27
#define REG_BK14CD_14_L      0x14CD28
#define REG_BK14CD_14_H      0x14CD29
#define REG_BK14CD_15_L      0x14CD2A
#define REG_BK14CD_15_H      0x14CD2B
#define REG_BK14CD_16_L      0x14CD2C
#define REG_BK14CD_16_H      0x14CD2D
#define REG_BK14CD_17_L      0x14CD2E
#define REG_BK14CD_17_H      0x14CD2F
#define REG_BK14CD_18_L      0x14CD30
#define REG_BK14CD_18_H      0x14CD31
#define REG_BK14CD_19_L      0x14CD32
#define REG_BK14CD_19_H      0x14CD33
#define REG_BK14CD_1A_L      0x14CD34
#define REG_BK14CD_1A_H      0x14CD35
#define REG_BK14CD_1B_L      0x14CD36
#define REG_BK14CD_1B_H      0x14CD37
#define REG_BK14CD_1C_L      0x14CD38
#define REG_BK14CD_1C_H      0x14CD39
#define REG_BK14CD_1D_L      0x14CD3A
#define REG_BK14CD_1D_H      0x14CD3B
#define REG_BK14CD_1E_L      0x14CD3C
#define REG_BK14CD_1E_H      0x14CD3D
#define REG_BK14CD_1F_L      0x14CD3E
#define REG_BK14CD_1F_H      0x14CD3F
#define REG_BK14CD_20_L      0x14CD40
#define REG_BK14CD_20_H      0x14CD41
#define REG_BK14CD_21_L      0x14CD42
#define REG_BK14CD_21_H      0x14CD43
#define REG_BK14CD_22_L      0x14CD44
#define REG_BK14CD_22_H      0x14CD45
#define REG_BK14CD_23_L      0x14CD46
#define REG_BK14CD_23_H      0x14CD47
#define REG_BK14CD_24_L      0x14CD48
#define REG_BK14CD_24_H      0x14CD49
#define REG_BK14CD_25_L      0x14CD4A
#define REG_BK14CD_25_H      0x14CD4B
#define REG_BK14CD_26_L      0x14CD4C
#define REG_BK14CD_26_H      0x14CD4D
#define REG_BK14CD_27_L      0x14CD4E
#define REG_BK14CD_27_H      0x14CD4F
#define REG_BK14CD_28_L      0x14CD50
#define REG_BK14CD_28_H      0x14CD51
#define REG_BK14CD_29_L      0x14CD52
#define REG_BK14CD_29_H      0x14CD53
#define REG_BK14CD_2A_L      0x14CD54
#define REG_BK14CD_2A_H      0x14CD55
#define REG_BK14CD_2B_L      0x14CD56
#define REG_BK14CD_2B_H      0x14CD57
#define REG_BK14CD_2C_L      0x14CD58
#define REG_BK14CD_2C_H      0x14CD59
#define REG_BK14CD_2D_L      0x14CD5A
#define REG_BK14CD_2D_H      0x14CD5B
#define REG_BK14CD_2E_L      0x14CD5C
#define REG_BK14CD_2E_H      0x14CD5D
#define REG_BK14CD_2F_L      0x14CD5E
#define REG_BK14CD_2F_H      0x14CD5F
#define REG_BK14CD_30_L      0x14CD60
#define REG_BK14CD_30_H      0x14CD61
#define REG_BK14CD_31_L      0x14CD62
#define REG_BK14CD_31_H      0x14CD63
#define REG_BK14CD_32_L      0x14CD64
#define REG_BK14CD_32_H      0x14CD65
#define REG_BK14CD_33_L      0x14CD66
#define REG_BK14CD_33_H      0x14CD67
#define REG_BK14CD_34_L      0x14CD68
#define REG_BK14CD_34_H      0x14CD69
#define REG_BK14CD_35_L      0x14CD6A
#define REG_BK14CD_35_H      0x14CD6B
#define REG_BK14CD_36_L      0x14CD6C
#define REG_BK14CD_36_H      0x14CD6D
#define REG_BK14CD_37_L      0x14CD6E
#define REG_BK14CD_37_H      0x14CD6F
#define REG_BK14CD_38_L      0x14CD70
#define REG_BK14CD_38_H      0x14CD71
#define REG_BK14CD_39_L      0x14CD72
#define REG_BK14CD_39_H      0x14CD73
#define REG_BK14CD_3A_L      0x14CD74
#define REG_BK14CD_3A_H      0x14CD75
#define REG_BK14CD_3B_L      0x14CD76
#define REG_BK14CD_3B_H      0x14CD77
#define REG_BK14CD_3C_L      0x14CD78
#define REG_BK14CD_3C_H      0x14CD79
#define REG_BK14CD_3D_L      0x14CD7A
#define REG_BK14CD_3D_H      0x14CD7B
#define REG_BK14CD_3E_L      0x14CD7C
#define REG_BK14CD_3E_H      0x14CD7D
#define REG_BK14CD_3F_L      0x14CD7E
#define REG_BK14CD_3F_H      0x14CD7F
#define REG_BK14CD_40_L      0x14CD80
#define REG_BK14CD_40_H      0x14CD81
#define REG_BK14CD_41_L      0x14CD82
#define REG_BK14CD_41_H      0x14CD83
#define REG_BK14CD_42_L      0x14CD84
#define REG_BK14CD_42_H      0x14CD85
#define REG_BK14CD_43_L      0x14CD86
#define REG_BK14CD_43_H      0x14CD87
#define REG_BK14CD_44_L      0x14CD88
#define REG_BK14CD_44_H      0x14CD89
#define REG_BK14CD_45_L      0x14CD8A
#define REG_BK14CD_45_H      0x14CD8B
#define REG_BK14CD_46_L      0x14CD8C
#define REG_BK14CD_46_H      0x14CD8D
#define REG_BK14CD_47_L      0x14CD8E
#define REG_BK14CD_47_H      0x14CD8F
#define REG_BK14CD_48_L      0x14CD90
#define REG_BK14CD_48_H      0x14CD91
#define REG_BK14CD_49_L      0x14CD92
#define REG_BK14CD_49_H      0x14CD93
#define REG_BK14CD_4A_L      0x14CD94
#define REG_BK14CD_4A_H      0x14CD95
#define REG_BK14CD_4B_L      0x14CD96
#define REG_BK14CD_4B_H      0x14CD97
#define REG_BK14CD_4C_L      0x14CD98
#define REG_BK14CD_4C_H      0x14CD99
#define REG_BK14CD_4D_L      0x14CD9A
#define REG_BK14CD_4D_H      0x14CD9B
#define REG_BK14CD_4E_L      0x14CD9C
#define REG_BK14CD_4E_H      0x14CD9D
#define REG_BK14CD_4F_L      0x14CD9E
#define REG_BK14CD_4F_H      0x14CD9F
#define REG_BK14CD_50_L      0x14CDA0
#define REG_BK14CD_50_H      0x14CDA1
#define REG_BK14CD_51_L      0x14CDA2
#define REG_BK14CD_51_H      0x14CDA3
#define REG_BK14CD_52_L      0x14CDA4
#define REG_BK14CD_52_H      0x14CDA5
#define REG_BK14CD_53_L      0x14CDA6
#define REG_BK14CD_53_H      0x14CDA7
#define REG_BK14CD_54_L      0x14CDA8
#define REG_BK14CD_54_H      0x14CDA9
#define REG_BK14CD_55_L      0x14CDAA
#define REG_BK14CD_55_H      0x14CDAB
#define REG_BK14CD_56_L      0x14CDAC
#define REG_BK14CD_56_H      0x14CDAD
#define REG_BK14CD_57_L      0x14CDAE
#define REG_BK14CD_57_H      0x14CDAF
#define REG_BK14CD_58_L      0x14CDB0
#define REG_BK14CD_58_H      0x14CDB1
#define REG_BK14CD_59_L      0x14CDB2
#define REG_BK14CD_59_H      0x14CDB3
#define REG_BK14CD_5A_L      0x14CDB4
#define REG_BK14CD_5A_H      0x14CDB5
#define REG_BK14CD_5B_L      0x14CDB6
#define REG_BK14CD_5B_H      0x14CDB7
#define REG_BK14CD_5C_L      0x14CDB8
#define REG_BK14CD_5C_H      0x14CDB9
#define REG_BK14CD_5D_L      0x14CDBA
#define REG_BK14CD_5D_H      0x14CDBB
#define REG_BK14CD_5E_L      0x14CDBC
#define REG_BK14CD_5E_H      0x14CDBD
#define REG_BK14CD_5F_L      0x14CDBE
#define REG_BK14CD_5F_H      0x14CDBF
#define REG_BK14CD_60_L      0x14CDC0
#define REG_BK14CD_60_H      0x14CDC1
#define REG_BK14CD_61_L      0x14CDC2
#define REG_BK14CD_61_H      0x14CDC3
#define REG_BK14CD_62_L      0x14CDC4
#define REG_BK14CD_62_H      0x14CDC5
#define REG_BK14CD_63_L      0x14CDC6
#define REG_BK14CD_63_H      0x14CDC7
#define REG_BK14CD_64_L      0x14CDC8
#define REG_BK14CD_64_H      0x14CDC9
#define REG_BK14CD_65_L      0x14CDCA
#define REG_BK14CD_65_H      0x14CDCB
#define REG_BK14CD_66_L      0x14CDCC
#define REG_BK14CD_66_H      0x14CDCD
#define REG_BK14CD_67_L      0x14CDCE
#define REG_BK14CD_67_H      0x14CDCF
#define REG_BK14CD_68_L      0x14CDD0
#define REG_BK14CD_68_H      0x14CDD1
#define REG_BK14CD_69_L      0x14CDD2
#define REG_BK14CD_69_H      0x14CDD3
#define REG_BK14CD_6A_L      0x14CDD4
#define REG_BK14CD_6A_H      0x14CDD5
#define REG_BK14CD_6B_L      0x14CDD6
#define REG_BK14CD_6B_H      0x14CDD7
#define REG_BK14CD_6C_L      0x14CDD8
#define REG_BK14CD_6C_H      0x14CDD9
#define REG_BK14CD_6D_L      0x14CDDA
#define REG_BK14CD_6D_H      0x14CDDB
#define REG_BK14CD_6E_L      0x14CDDC
#define REG_BK14CD_6E_H      0x14CDDD
#define REG_BK14CD_6F_L      0x14CDDE
#define REG_BK14CD_6F_H      0x14CDDF
#define REG_BK14CD_70_L      0x14CDE0
#define REG_BK14CD_70_H      0x14CDE1
#define REG_BK14CD_71_L      0x14CDE2
#define REG_BK14CD_71_H      0x14CDE3
#define REG_BK14CD_72_L      0x14CDE4
#define REG_BK14CD_72_H      0x14CDE5
#define REG_BK14CD_73_L      0x14CDE6
#define REG_BK14CD_73_H      0x14CDE7
#define REG_BK14CD_74_L      0x14CDE8
#define REG_BK14CD_74_H      0x14CDE9
#define REG_BK14CD_75_L      0x14CDEA
#define REG_BK14CD_75_H      0x14CDEB
#define REG_BK14CD_76_L      0x14CDEC
#define REG_BK14CD_76_H      0x14CDED
#define REG_BK14CD_77_L      0x14CDEE
#define REG_BK14CD_77_H      0x14CDEF
#define REG_BK14CD_78_L      0x14CDF0
#define REG_BK14CD_78_H      0x14CDF1
#define REG_BK14CD_79_L      0x14CDF2
#define REG_BK14CD_79_H      0x14CDF3
#define REG_BK14CD_7A_L      0x14CDF4
#define REG_BK14CD_7A_H      0x14CDF5
#define REG_BK14CD_7B_L      0x14CDF6
#define REG_BK14CD_7B_H      0x14CDF7
#define REG_BK14CD_7C_L      0x14CDF8
#define REG_BK14CD_7C_H      0x14CDF9
#define REG_BK14CD_7D_L      0x14CDFA
#define REG_BK14CD_7D_H      0x14CDFB
#define REG_BK14CD_7E_L      0x14CDFC
#define REG_BK14CD_7E_H      0x14CDFD
#define REG_BK14CD_7F_L      0x14CDFE
#define REG_BK14CD_7F_H      0x14CDFF
//----------------------------------------------
#define REG_BK14F2_00_L      0x14F200
#define REG_BK14F2_00_H      0x14F201
#define REG_BK14F2_01_L      0x14F202
#define REG_BK14F2_01_H      0x14F203
#define REG_BK14F2_02_L      0x14F204
#define REG_BK14F2_02_H      0x14F205
#define REG_BK14F2_03_L      0x14F206
#define REG_BK14F2_03_H      0x14F207
#define REG_BK14F2_04_L      0x14F208
#define REG_BK14F2_04_H      0x14F209
#define REG_BK14F2_05_L      0x14F20A
#define REG_BK14F2_05_H      0x14F20B
#define REG_BK14F2_06_L      0x14F20C
#define REG_BK14F2_06_H      0x14F20D
#define REG_BK14F2_07_L      0x14F20E
#define REG_BK14F2_07_H      0x14F20F
#define REG_BK14F2_08_L      0x14F210
#define REG_BK14F2_08_H      0x14F211
#define REG_BK14F2_09_L      0x14F212
#define REG_BK14F2_09_H      0x14F213
#define REG_BK14F2_0A_L      0x14F214
#define REG_BK14F2_0A_H      0x14F215
#define REG_BK14F2_0B_L      0x14F216
#define REG_BK14F2_0B_H      0x14F217
#define REG_BK14F2_0C_L      0x14F218
#define REG_BK14F2_0C_H      0x14F219
#define REG_BK14F2_0D_L      0x14F21A
#define REG_BK14F2_0D_H      0x14F21B
#define REG_BK14F2_0E_L      0x14F21C
#define REG_BK14F2_0E_H      0x14F21D
#define REG_BK14F2_0F_L      0x14F21E
#define REG_BK14F2_0F_H      0x14F21F
#define REG_BK14F2_10_L      0x14F220
#define REG_BK14F2_10_H      0x14F221
#define REG_BK14F2_11_L      0x14F222
#define REG_BK14F2_11_H      0x14F223
#define REG_BK14F2_12_L      0x14F224
#define REG_BK14F2_12_H      0x14F225
#define REG_BK14F2_13_L      0x14F226
#define REG_BK14F2_13_H      0x14F227
#define REG_BK14F2_14_L      0x14F228
#define REG_BK14F2_14_H      0x14F229
#define REG_BK14F2_15_L      0x14F22A
#define REG_BK14F2_15_H      0x14F22B
#define REG_BK14F2_16_L      0x14F22C
#define REG_BK14F2_16_H      0x14F22D
#define REG_BK14F2_17_L      0x14F22E
#define REG_BK14F2_17_H      0x14F22F
#define REG_BK14F2_18_L      0x14F230
#define REG_BK14F2_18_H      0x14F231
#define REG_BK14F2_19_L      0x14F232
#define REG_BK14F2_19_H      0x14F233
#define REG_BK14F2_1A_L      0x14F234
#define REG_BK14F2_1A_H      0x14F235
#define REG_BK14F2_1B_L      0x14F236
#define REG_BK14F2_1B_H      0x14F237
#define REG_BK14F2_1C_L      0x14F238
#define REG_BK14F2_1C_H      0x14F239
#define REG_BK14F2_1D_L      0x14F23A
#define REG_BK14F2_1D_H      0x14F23B
#define REG_BK14F2_1E_L      0x14F23C
#define REG_BK14F2_1E_H      0x14F23D
#define REG_BK14F2_1F_L      0x14F23E
#define REG_BK14F2_1F_H      0x14F23F
#define REG_BK14F2_20_L      0x14F240
#define REG_BK14F2_20_H      0x14F241
#define REG_BK14F2_21_L      0x14F242
#define REG_BK14F2_21_H      0x14F243
#define REG_BK14F2_22_L      0x14F244
#define REG_BK14F2_22_H      0x14F245
#define REG_BK14F2_23_L      0x14F246
#define REG_BK14F2_23_H      0x14F247
#define REG_BK14F2_24_L      0x14F248
#define REG_BK14F2_24_H      0x14F249
#define REG_BK14F2_25_L      0x14F24A
#define REG_BK14F2_25_H      0x14F24B
#define REG_BK14F2_26_L      0x14F24C
#define REG_BK14F2_26_H      0x14F24D
#define REG_BK14F2_27_L      0x14F24E
#define REG_BK14F2_27_H      0x14F24F
#define REG_BK14F2_28_L      0x14F250
#define REG_BK14F2_28_H      0x14F251
#define REG_BK14F2_29_L      0x14F252
#define REG_BK14F2_29_H      0x14F253
#define REG_BK14F2_2A_L      0x14F254
#define REG_BK14F2_2A_H      0x14F255
#define REG_BK14F2_2B_L      0x14F256
#define REG_BK14F2_2B_H      0x14F257
#define REG_BK14F2_2C_L      0x14F258
#define REG_BK14F2_2C_H      0x14F259
#define REG_BK14F2_2D_L      0x14F25A
#define REG_BK14F2_2D_H      0x14F25B
#define REG_BK14F2_2E_L      0x14F25C
#define REG_BK14F2_2E_H      0x14F25D
#define REG_BK14F2_2F_L      0x14F25E
#define REG_BK14F2_2F_H      0x14F25F
#define REG_BK14F2_30_L      0x14F260
#define REG_BK14F2_30_H      0x14F261
#define REG_BK14F2_31_L      0x14F262
#define REG_BK14F2_31_H      0x14F263
#define REG_BK14F2_32_L      0x14F264
#define REG_BK14F2_32_H      0x14F265
#define REG_BK14F2_33_L      0x14F266
#define REG_BK14F2_33_H      0x14F267
#define REG_BK14F2_34_L      0x14F268
#define REG_BK14F2_34_H      0x14F269
#define REG_BK14F2_35_L      0x14F26A
#define REG_BK14F2_35_H      0x14F26B
#define REG_BK14F2_36_L      0x14F26C
#define REG_BK14F2_36_H      0x14F26D
#define REG_BK14F2_37_L      0x14F26E
#define REG_BK14F2_37_H      0x14F26F
#define REG_BK14F2_38_L      0x14F270
#define REG_BK14F2_38_H      0x14F271
#define REG_BK14F2_39_L      0x14F272
#define REG_BK14F2_39_H      0x14F273
#define REG_BK14F2_3A_L      0x14F274
#define REG_BK14F2_3A_H      0x14F275
#define REG_BK14F2_3B_L      0x14F276
#define REG_BK14F2_3B_H      0x14F277
#define REG_BK14F2_3C_L      0x14F278
#define REG_BK14F2_3C_H      0x14F279
#define REG_BK14F2_3D_L      0x14F27A
#define REG_BK14F2_3D_H      0x14F27B
#define REG_BK14F2_3E_L      0x14F27C
#define REG_BK14F2_3E_H      0x14F27D
#define REG_BK14F2_3F_L      0x14F27E
#define REG_BK14F2_3F_H      0x14F27F
#define REG_BK14F2_40_L      0x14F280
#define REG_BK14F2_40_H      0x14F281
#define REG_BK14F2_41_L      0x14F282
#define REG_BK14F2_41_H      0x14F283
#define REG_BK14F2_42_L      0x14F284
#define REG_BK14F2_42_H      0x14F285
#define REG_BK14F2_43_L      0x14F286
#define REG_BK14F2_43_H      0x14F287
#define REG_BK14F2_44_L      0x14F288
#define REG_BK14F2_44_H      0x14F289
#define REG_BK14F2_45_L      0x14F28A
#define REG_BK14F2_45_H      0x14F28B
#define REG_BK14F2_46_L      0x14F28C
#define REG_BK14F2_46_H      0x14F28D
#define REG_BK14F2_47_L      0x14F28E
#define REG_BK14F2_47_H      0x14F28F
#define REG_BK14F2_48_L      0x14F290
#define REG_BK14F2_48_H      0x14F291
#define REG_BK14F2_49_L      0x14F292
#define REG_BK14F2_49_H      0x14F293
#define REG_BK14F2_4A_L      0x14F294
#define REG_BK14F2_4A_H      0x14F295
#define REG_BK14F2_4B_L      0x14F296
#define REG_BK14F2_4B_H      0x14F297
#define REG_BK14F2_4C_L      0x14F298
#define REG_BK14F2_4C_H      0x14F299
#define REG_BK14F2_4D_L      0x14F29A
#define REG_BK14F2_4D_H      0x14F29B
#define REG_BK14F2_4E_L      0x14F29C
#define REG_BK14F2_4E_H      0x14F29D
#define REG_BK14F2_4F_L      0x14F29E
#define REG_BK14F2_4F_H      0x14F29F
#define REG_BK14F2_50_L      0x14F2A0
#define REG_BK14F2_50_H      0x14F2A1
#define REG_BK14F2_51_L      0x14F2A2
#define REG_BK14F2_51_H      0x14F2A3
#define REG_BK14F2_52_L      0x14F2A4
#define REG_BK14F2_52_H      0x14F2A5
#define REG_BK14F2_53_L      0x14F2A6
#define REG_BK14F2_53_H      0x14F2A7
#define REG_BK14F2_54_L      0x14F2A8
#define REG_BK14F2_54_H      0x14F2A9
#define REG_BK14F2_55_L      0x14F2AA
#define REG_BK14F2_55_H      0x14F2AB
#define REG_BK14F2_56_L      0x14F2AC
#define REG_BK14F2_56_H      0x14F2AD
#define REG_BK14F2_57_L      0x14F2AE
#define REG_BK14F2_57_H      0x14F2AF
#define REG_BK14F2_58_L      0x14F2B0
#define REG_BK14F2_58_H      0x14F2B1
#define REG_BK14F2_59_L      0x14F2B2
#define REG_BK14F2_59_H      0x14F2B3
#define REG_BK14F2_5A_L      0x14F2B4
#define REG_BK14F2_5A_H      0x14F2B5
#define REG_BK14F2_5B_L      0x14F2B6
#define REG_BK14F2_5B_H      0x14F2B7
#define REG_BK14F2_5C_L      0x14F2B8
#define REG_BK14F2_5C_H      0x14F2B9
#define REG_BK14F2_5D_L      0x14F2BA
#define REG_BK14F2_5D_H      0x14F2BB
#define REG_BK14F2_5E_L      0x14F2BC
#define REG_BK14F2_5E_H      0x14F2BD
#define REG_BK14F2_5F_L      0x14F2BE
#define REG_BK14F2_5F_H      0x14F2BF
#define REG_BK14F2_60_L      0x14F2C0
#define REG_BK14F2_60_H      0x14F2C1
#define REG_BK14F2_61_L      0x14F2C2
#define REG_BK14F2_61_H      0x14F2C3
#define REG_BK14F2_62_L      0x14F2C4
#define REG_BK14F2_62_H      0x14F2C5
#define REG_BK14F2_63_L      0x14F2C6
#define REG_BK14F2_63_H      0x14F2C7
#define REG_BK14F2_64_L      0x14F2C8
#define REG_BK14F2_64_H      0x14F2C9
#define REG_BK14F2_65_L      0x14F2CA
#define REG_BK14F2_65_H      0x14F2CB
#define REG_BK14F2_66_L      0x14F2CC
#define REG_BK14F2_66_H      0x14F2CD
#define REG_BK14F2_67_L      0x14F2CE
#define REG_BK14F2_67_H      0x14F2CF
#define REG_BK14F2_68_L      0x14F2D0
#define REG_BK14F2_68_H      0x14F2D1
#define REG_BK14F2_69_L      0x14F2D2
#define REG_BK14F2_69_H      0x14F2D3
#define REG_BK14F2_6A_L      0x14F2D4
#define REG_BK14F2_6A_H      0x14F2D5
#define REG_BK14F2_6B_L      0x14F2D6
#define REG_BK14F2_6B_H      0x14F2D7
#define REG_BK14F2_6C_L      0x14F2D8
#define REG_BK14F2_6C_H      0x14F2D9
#define REG_BK14F2_6D_L      0x14F2DA
#define REG_BK14F2_6D_H      0x14F2DB
#define REG_BK14F2_6E_L      0x14F2DC
#define REG_BK14F2_6E_H      0x14F2DD
#define REG_BK14F2_6F_L      0x14F2DE
#define REG_BK14F2_6F_H      0x14F2DF
#define REG_BK14F2_70_L      0x14F2E0
#define REG_BK14F2_70_H      0x14F2E1
#define REG_BK14F2_71_L      0x14F2E2
#define REG_BK14F2_71_H      0x14F2E3
#define REG_BK14F2_72_L      0x14F2E4
#define REG_BK14F2_72_H      0x14F2E5
#define REG_BK14F2_73_L      0x14F2E6
#define REG_BK14F2_73_H      0x14F2E7
#define REG_BK14F2_74_L      0x14F2E8
#define REG_BK14F2_74_H      0x14F2E9
#define REG_BK14F2_75_L      0x14F2EA
#define REG_BK14F2_75_H      0x14F2EB
#define REG_BK14F2_76_L      0x14F2EC
#define REG_BK14F2_76_H      0x14F2ED
#define REG_BK14F2_77_L      0x14F2EE
#define REG_BK14F2_77_H      0x14F2EF
#define REG_BK14F2_78_L      0x14F2F0
#define REG_BK14F2_78_H      0x14F2F1
#define REG_BK14F2_79_L      0x14F2F2
#define REG_BK14F2_79_H      0x14F2F3
#define REG_BK14F2_7A_L      0x14F2F4
#define REG_BK14F2_7A_H      0x14F2F5
#define REG_BK14F2_7B_L      0x14F2F6
#define REG_BK14F2_7B_H      0x14F2F7
#define REG_BK14F2_7C_L      0x14F2F8
#define REG_BK14F2_7C_H      0x14F2F9
#define REG_BK14F2_7D_L      0x14F2FA
#define REG_BK14F2_7D_H      0x14F2FB
#define REG_BK14F2_7E_L      0x14F2FC
#define REG_BK14F2_7E_H      0x14F2FD
#define REG_BK14F2_7F_L      0x14F2FE
#define REG_BK14F2_7F_H      0x14F2FF
//----------------------------------------------
#define REG_BKF000_00_L      _PK_L_(0x00, 0x00)
#define REG_BKF000_00_H      _PK_H_(0x00, 0x00)
#define REG_BKF000_01_L      _PK_L_(0x00, 0x01)
#define REG_BKF000_01_H      _PK_H_(0x00, 0x01)
#define REG_BKF000_02_L      _PK_L_(0x00, 0x02)
#define REG_BKF000_02_H      _PK_H_(0x00, 0x02)
#define REG_BKF000_03_L      _PK_L_(0x00, 0x03)
#define REG_BKF000_03_H      _PK_H_(0x00, 0x03)
#define REG_BKF000_04_L      _PK_L_(0x00, 0x04)
#define REG_BKF000_04_H      _PK_H_(0x00, 0x04)
#define REG_BKF000_05_L      _PK_L_(0x00, 0x05)
#define REG_BKF000_05_H      _PK_H_(0x00, 0x05)
#define REG_BKF000_06_L      _PK_L_(0x00, 0x06)
#define REG_BKF000_06_H      _PK_H_(0x00, 0x06)
#define REG_BKF000_07_L      _PK_L_(0x00, 0x07)
#define REG_BKF000_07_H      _PK_H_(0x00, 0x07)
#define REG_BKF000_08_L      _PK_L_(0x00, 0x08)
#define REG_BKF000_08_H      _PK_H_(0x00, 0x08)
#define REG_BKF000_09_L      _PK_L_(0x00, 0x09)
#define REG_BKF000_09_H      _PK_H_(0x00, 0x09)
#define REG_BKF000_0A_L      _PK_L_(0x00, 0x0A)
#define REG_BKF000_0A_H      _PK_H_(0x00, 0x0A)
#define REG_BKF000_0B_L      _PK_L_(0x00, 0x0B)
#define REG_BKF000_0B_H      _PK_H_(0x00, 0x0B)
#define REG_BKF000_0C_L      _PK_L_(0x00, 0x0C)
#define REG_BKF000_0C_H      _PK_H_(0x00, 0x0C)
#define REG_BKF000_0D_L      _PK_L_(0x00, 0x0D)
#define REG_BKF000_0D_H      _PK_H_(0x00, 0x0D)
#define REG_BKF000_0E_L      _PK_L_(0x00, 0x0E)
#define REG_BKF000_0E_H      _PK_H_(0x00, 0x0E)
#define REG_BKF000_0F_L      _PK_L_(0x00, 0x0F)
#define REG_BKF000_0F_H      _PK_H_(0x00, 0x0F)
#define REG_BKF000_10_L      _PK_L_(0x00, 0x10)
#define REG_BKF000_10_H      _PK_H_(0x00, 0x10)
#define REG_BKF000_11_L      _PK_L_(0x00, 0x11)
#define REG_BKF000_11_H      _PK_H_(0x00, 0x11)
#define REG_BKF000_12_L      _PK_L_(0x00, 0x12)
#define REG_BKF000_12_H      _PK_H_(0x00, 0x12)
#define REG_BKF000_13_L      _PK_L_(0x00, 0x13)
#define REG_BKF000_13_H      _PK_H_(0x00, 0x13)
#define REG_BKF000_14_L      _PK_L_(0x00, 0x14)
#define REG_BKF000_14_H      _PK_H_(0x00, 0x14)
#define REG_BKF000_15_L      _PK_L_(0x00, 0x15)
#define REG_BKF000_15_H      _PK_H_(0x00, 0x15)
#define REG_BKF000_16_L      _PK_L_(0x00, 0x16)
#define REG_BKF000_16_H      _PK_H_(0x00, 0x16)
#define REG_BKF000_17_L      _PK_L_(0x00, 0x17)
#define REG_BKF000_17_H      _PK_H_(0x00, 0x17)
#define REG_BKF000_18_L      _PK_L_(0x00, 0x18)
#define REG_BKF000_18_H      _PK_H_(0x00, 0x18)
#define REG_BKF000_19_L      _PK_L_(0x00, 0x19)
#define REG_BKF000_19_H      _PK_H_(0x00, 0x19)
#define REG_BKF000_1A_L      _PK_L_(0x00, 0x1A)
#define REG_BKF000_1A_H      _PK_H_(0x00, 0x1A)
#define REG_BKF000_1B_L      _PK_L_(0x00, 0x1B)
#define REG_BKF000_1B_H      _PK_H_(0x00, 0x1B)
#define REG_BKF000_1C_L      _PK_L_(0x00, 0x1C)
#define REG_BKF000_1C_H      _PK_H_(0x00, 0x1C)
#define REG_BKF000_1D_L      _PK_L_(0x00, 0x1D)
#define REG_BKF000_1D_H      _PK_H_(0x00, 0x1D)
#define REG_BKF000_1E_L      _PK_L_(0x00, 0x1E)
#define REG_BKF000_1E_H      _PK_H_(0x00, 0x1E)
#define REG_BKF000_1F_L      _PK_L_(0x00, 0x1F)
#define REG_BKF000_1F_H      _PK_H_(0x00, 0x1F)
#define REG_BKF000_20_L      _PK_L_(0x00, 0x20)
#define REG_BKF000_20_H      _PK_H_(0x00, 0x20)
#define REG_BKF000_21_L      _PK_L_(0x00, 0x21)
#define REG_BKF000_21_H      _PK_H_(0x00, 0x21)
#define REG_BKF000_22_L      _PK_L_(0x00, 0x22)
#define REG_BKF000_22_H      _PK_H_(0x00, 0x22)
#define REG_BKF000_23_L      _PK_L_(0x00, 0x23)
#define REG_BKF000_23_H      _PK_H_(0x00, 0x23)
#define REG_BKF000_24_L      _PK_L_(0x00, 0x24)
#define REG_BKF000_24_H      _PK_H_(0x00, 0x24)
#define REG_BKF000_25_L      _PK_L_(0x00, 0x25)
#define REG_BKF000_25_H      _PK_H_(0x00, 0x25)
#define REG_BKF000_26_L      _PK_L_(0x00, 0x26)
#define REG_BKF000_26_H      _PK_H_(0x00, 0x26)
#define REG_BKF000_27_L      _PK_L_(0x00, 0x27)
#define REG_BKF000_27_H      _PK_H_(0x00, 0x27)
#define REG_BKF000_28_L      _PK_L_(0x00, 0x28)
#define REG_BKF000_28_H      _PK_H_(0x00, 0x28)
#define REG_BKF000_29_L      _PK_L_(0x00, 0x29)
#define REG_BKF000_29_H      _PK_H_(0x00, 0x29)
#define REG_BKF000_2A_L      _PK_L_(0x00, 0x2A)
#define REG_BKF000_2A_H      _PK_H_(0x00, 0x2A)
#define REG_BKF000_2B_L      _PK_L_(0x00, 0x2B)
#define REG_BKF000_2B_H      _PK_H_(0x00, 0x2B)
#define REG_BKF000_2C_L      _PK_L_(0x00, 0x2C)
#define REG_BKF000_2C_H      _PK_H_(0x00, 0x2C)
#define REG_BKF000_2D_L      _PK_L_(0x00, 0x2D)
#define REG_BKF000_2D_H      _PK_H_(0x00, 0x2D)
#define REG_BKF000_2E_L      _PK_L_(0x00, 0x2E)
#define REG_BKF000_2E_H      _PK_H_(0x00, 0x2E)
#define REG_BKF000_2F_L      _PK_L_(0x00, 0x2F)
#define REG_BKF000_2F_H      _PK_H_(0x00, 0x2F)
#define REG_BKF000_30_L      _PK_L_(0x00, 0x30)
#define REG_BKF000_30_H      _PK_H_(0x00, 0x30)
#define REG_BKF000_31_L      _PK_L_(0x00, 0x31)
#define REG_BKF000_31_H      _PK_H_(0x00, 0x31)
#define REG_BKF000_32_L      _PK_L_(0x00, 0x32)
#define REG_BKF000_32_H      _PK_H_(0x00, 0x32)
#define REG_BKF000_33_L      _PK_L_(0x00, 0x33)
#define REG_BKF000_33_H      _PK_H_(0x00, 0x33)
#define REG_BKF000_34_L      _PK_L_(0x00, 0x34)
#define REG_BKF000_34_H      _PK_H_(0x00, 0x34)
#define REG_BKF000_35_L      _PK_L_(0x00, 0x35)
#define REG_BKF000_35_H      _PK_H_(0x00, 0x35)
#define REG_BKF000_36_L      _PK_L_(0x00, 0x36)
#define REG_BKF000_36_H      _PK_H_(0x00, 0x36)
#define REG_BKF000_37_L      _PK_L_(0x00, 0x37)
#define REG_BKF000_37_H      _PK_H_(0x00, 0x37)
#define REG_BKF000_38_L      _PK_L_(0x00, 0x38)
#define REG_BKF000_38_H      _PK_H_(0x00, 0x38)
#define REG_BKF000_39_L      _PK_L_(0x00, 0x39)
#define REG_BKF000_39_H      _PK_H_(0x00, 0x39)
#define REG_BKF000_3A_L      _PK_L_(0x00, 0x3A)
#define REG_BKF000_3A_H      _PK_H_(0x00, 0x3A)
#define REG_BKF000_3B_L      _PK_L_(0x00, 0x3B)
#define REG_BKF000_3B_H      _PK_H_(0x00, 0x3B)
#define REG_BKF000_3C_L      _PK_L_(0x00, 0x3C)
#define REG_BKF000_3C_H      _PK_H_(0x00, 0x3C)
#define REG_BKF000_3D_L      _PK_L_(0x00, 0x3D)
#define REG_BKF000_3D_H      _PK_H_(0x00, 0x3D)
#define REG_BKF000_3E_L      _PK_L_(0x00, 0x3E)
#define REG_BKF000_3E_H      _PK_H_(0x00, 0x3E)
#define REG_BKF000_3F_L      _PK_L_(0x00, 0x3F)
#define REG_BKF000_3F_H      _PK_H_(0x00, 0x3F)
#define REG_BKF000_40_L      _PK_L_(0x00, 0x40)
#define REG_BKF000_40_H      _PK_H_(0x00, 0x40)
#define REG_BKF000_41_L      _PK_L_(0x00, 0x41)
#define REG_BKF000_41_H      _PK_H_(0x00, 0x41)
#define REG_BKF000_42_L      _PK_L_(0x00, 0x42)
#define REG_BKF000_42_H      _PK_H_(0x00, 0x42)
#define REG_BKF000_43_L      _PK_L_(0x00, 0x43)
#define REG_BKF000_43_H      _PK_H_(0x00, 0x43)
#define REG_BKF000_44_L      _PK_L_(0x00, 0x44)
#define REG_BKF000_44_H      _PK_H_(0x00, 0x44)
#define REG_BKF000_45_L      _PK_L_(0x00, 0x45)
#define REG_BKF000_45_H      _PK_H_(0x00, 0x45)
#define REG_BKF000_46_L      _PK_L_(0x00, 0x46)
#define REG_BKF000_46_H      _PK_H_(0x00, 0x46)
#define REG_BKF000_47_L      _PK_L_(0x00, 0x47)
#define REG_BKF000_47_H      _PK_H_(0x00, 0x47)
#define REG_BKF000_48_L      _PK_L_(0x00, 0x48)
#define REG_BKF000_48_H      _PK_H_(0x00, 0x48)
#define REG_BKF000_49_L      _PK_L_(0x00, 0x49)
#define REG_BKF000_49_H      _PK_H_(0x00, 0x49)
#define REG_BKF000_4A_L      _PK_L_(0x00, 0x4A)
#define REG_BKF000_4A_H      _PK_H_(0x00, 0x4A)
#define REG_BKF000_4B_L      _PK_L_(0x00, 0x4B)
#define REG_BKF000_4B_H      _PK_H_(0x00, 0x4B)
#define REG_BKF000_4C_L      _PK_L_(0x00, 0x4C)
#define REG_BKF000_4C_H      _PK_H_(0x00, 0x4C)
#define REG_BKF000_4D_L      _PK_L_(0x00, 0x4D)
#define REG_BKF000_4D_H      _PK_H_(0x00, 0x4D)
#define REG_BKF000_4E_L      _PK_L_(0x00, 0x4E)
#define REG_BKF000_4E_H      _PK_H_(0x00, 0x4E)
#define REG_BKF000_4F_L      _PK_L_(0x00, 0x4F)
#define REG_BKF000_4F_H      _PK_H_(0x00, 0x4F)
#define REG_BKF000_50_L      _PK_L_(0x00, 0x50)
#define REG_BKF000_50_H      _PK_H_(0x00, 0x50)
#define REG_BKF000_51_L      _PK_L_(0x00, 0x51)
#define REG_BKF000_51_H      _PK_H_(0x00, 0x51)
#define REG_BKF000_52_L      _PK_L_(0x00, 0x52)
#define REG_BKF000_52_H      _PK_H_(0x00, 0x52)
#define REG_BKF000_53_L      _PK_L_(0x00, 0x53)
#define REG_BKF000_53_H      _PK_H_(0x00, 0x53)
#define REG_BKF000_54_L      _PK_L_(0x00, 0x54)
#define REG_BKF000_54_H      _PK_H_(0x00, 0x54)
#define REG_BKF000_55_L      _PK_L_(0x00, 0x55)
#define REG_BKF000_55_H      _PK_H_(0x00, 0x55)
#define REG_BKF000_56_L      _PK_L_(0x00, 0x56)
#define REG_BKF000_56_H      _PK_H_(0x00, 0x56)
#define REG_BKF000_57_L      _PK_L_(0x00, 0x57)
#define REG_BKF000_57_H      _PK_H_(0x00, 0x57)
#define REG_BKF000_58_L      _PK_L_(0x00, 0x58)
#define REG_BKF000_58_H      _PK_H_(0x00, 0x58)
#define REG_BKF000_59_L      _PK_L_(0x00, 0x59)
#define REG_BKF000_59_H      _PK_H_(0x00, 0x59)
#define REG_BKF000_5A_L      _PK_L_(0x00, 0x5A)
#define REG_BKF000_5A_H      _PK_H_(0x00, 0x5A)
#define REG_BKF000_5B_L      _PK_L_(0x00, 0x5B)
#define REG_BKF000_5B_H      _PK_H_(0x00, 0x5B)
#define REG_BKF000_5C_L      _PK_L_(0x00, 0x5C)
#define REG_BKF000_5C_H      _PK_H_(0x00, 0x5C)
#define REG_BKF000_5D_L      _PK_L_(0x00, 0x5D)
#define REG_BKF000_5D_H      _PK_H_(0x00, 0x5D)
#define REG_BKF000_5E_L      _PK_L_(0x00, 0x5E)
#define REG_BKF000_5E_H      _PK_H_(0x00, 0x5E)
#define REG_BKF000_5F_L      _PK_L_(0x00, 0x5F)
#define REG_BKF000_5F_H      _PK_H_(0x00, 0x5F)
#define REG_BKF000_60_L      _PK_L_(0x00, 0x60)
#define REG_BKF000_60_H      _PK_H_(0x00, 0x60)
#define REG_BKF000_61_L      _PK_L_(0x00, 0x61)
#define REG_BKF000_61_H      _PK_H_(0x00, 0x61)
#define REG_BKF000_62_L      _PK_L_(0x00, 0x62)
#define REG_BKF000_62_H      _PK_H_(0x00, 0x62)
#define REG_BKF000_63_L      _PK_L_(0x00, 0x63)
#define REG_BKF000_63_H      _PK_H_(0x00, 0x63)
#define REG_BKF000_64_L      _PK_L_(0x00, 0x64)
#define REG_BKF000_64_H      _PK_H_(0x00, 0x64)
#define REG_BKF000_65_L      _PK_L_(0x00, 0x65)
#define REG_BKF000_65_H      _PK_H_(0x00, 0x65)
#define REG_BKF000_66_L      _PK_L_(0x00, 0x66)
#define REG_BKF000_66_H      _PK_H_(0x00, 0x66)
#define REG_BKF000_67_L      _PK_L_(0x00, 0x67)
#define REG_BKF000_67_H      _PK_H_(0x00, 0x67)
#define REG_BKF000_68_L      _PK_L_(0x00, 0x68)
#define REG_BKF000_68_H      _PK_H_(0x00, 0x68)
#define REG_BKF000_69_L      _PK_L_(0x00, 0x69)
#define REG_BKF000_69_H      _PK_H_(0x00, 0x69)
#define REG_BKF000_6A_L      _PK_L_(0x00, 0x6A)
#define REG_BKF000_6A_H      _PK_H_(0x00, 0x6A)
#define REG_BKF000_6B_L      _PK_L_(0x00, 0x6B)
#define REG_BKF000_6B_H      _PK_H_(0x00, 0x6B)
#define REG_BKF000_6C_L      _PK_L_(0x00, 0x6C)
#define REG_BKF000_6C_H      _PK_H_(0x00, 0x6C)
#define REG_BKF000_6D_L      _PK_L_(0x00, 0x6D)
#define REG_BKF000_6D_H      _PK_H_(0x00, 0x6D)
#define REG_BKF000_6E_L      _PK_L_(0x00, 0x6E)
#define REG_BKF000_6E_H      _PK_H_(0x00, 0x6E)
#define REG_BKF000_6F_L      _PK_L_(0x00, 0x6F)
#define REG_BKF000_6F_H      _PK_H_(0x00, 0x6F)
#define REG_BKF000_70_L      _PK_L_(0x00, 0x70)
#define REG_BKF000_70_H      _PK_H_(0x00, 0x70)
#define REG_BKF000_71_L      _PK_L_(0x00, 0x71)
#define REG_BKF000_71_H      _PK_H_(0x00, 0x71)
#define REG_BKF000_72_L      _PK_L_(0x00, 0x72)
#define REG_BKF000_72_H      _PK_H_(0x00, 0x72)
#define REG_BKF000_73_L      _PK_L_(0x00, 0x73)
#define REG_BKF000_73_H      _PK_H_(0x00, 0x73)
#define REG_BKF000_74_L      _PK_L_(0x00, 0x74)
#define REG_BKF000_74_H      _PK_H_(0x00, 0x74)
#define REG_BKF000_75_L      _PK_L_(0x00, 0x75)
#define REG_BKF000_75_H      _PK_H_(0x00, 0x75)
#define REG_BKF000_76_L      _PK_L_(0x00, 0x76)
#define REG_BKF000_76_H      _PK_H_(0x00, 0x76)
#define REG_BKF000_77_L      _PK_L_(0x00, 0x77)
#define REG_BKF000_77_H      _PK_H_(0x00, 0x77)
#define REG_BKF000_78_L      _PK_L_(0x00, 0x78)
#define REG_BKF000_78_H      _PK_H_(0x00, 0x78)
#define REG_BKF000_79_L      _PK_L_(0x00, 0x79)
#define REG_BKF000_79_H      _PK_H_(0x00, 0x79)
#define REG_BKF000_7A_L      _PK_L_(0x00, 0x7A)
#define REG_BKF000_7A_H      _PK_H_(0x00, 0x7A)
#define REG_BKF000_7B_L      _PK_L_(0x00, 0x7B)
#define REG_BKF000_7B_H      _PK_H_(0x00, 0x7B)
#define REG_BKF000_7C_L      _PK_L_(0x00, 0x7C)
#define REG_BKF000_7C_H      _PK_H_(0x00, 0x7C)
#define REG_BKF000_7D_L      _PK_L_(0x00, 0x7D)
#define REG_BKF000_7D_H      _PK_H_(0x00, 0x7D)
#define REG_BKF000_7E_L      _PK_L_(0x00, 0x7E)
#define REG_BKF000_7E_H      _PK_H_(0x00, 0x7E)
#define REG_BKF000_7F_L      _PK_L_(0x00, 0x7F)
#define REG_BKF000_7F_H      _PK_H_(0x00, 0x7F)
//----------------------------------------------
#define REG_BKF001_00_L      _PK_L_(0x01, 0x00)
#define REG_BKF001_00_H      _PK_H_(0x01, 0x00)
#define REG_BKF001_01_L      _PK_L_(0x01, 0x01)
#define REG_BKF001_01_H      _PK_H_(0x01, 0x01)
#define REG_BKF001_02_L      _PK_L_(0x01, 0x02)
#define REG_BKF001_02_H      _PK_H_(0x01, 0x02)
#define REG_BKF001_03_L      _PK_L_(0x01, 0x03)
#define REG_BKF001_03_H      _PK_H_(0x01, 0x03)
#define REG_BKF001_04_L      _PK_L_(0x01, 0x04)
#define REG_BKF001_04_H      _PK_H_(0x01, 0x04)
#define REG_BKF001_05_L      _PK_L_(0x01, 0x05)
#define REG_BKF001_05_H      _PK_H_(0x01, 0x05)
#define REG_BKF001_06_L      _PK_L_(0x01, 0x06)
#define REG_BKF001_06_H      _PK_H_(0x01, 0x06)
#define REG_BKF001_07_L      _PK_L_(0x01, 0x07)
#define REG_BKF001_07_H      _PK_H_(0x01, 0x07)
#define REG_BKF001_08_L      _PK_L_(0x01, 0x08)
#define REG_BKF001_08_H      _PK_H_(0x01, 0x08)
#define REG_BKF001_09_L      _PK_L_(0x01, 0x09)
#define REG_BKF001_09_H      _PK_H_(0x01, 0x09)
#define REG_BKF001_0A_L      _PK_L_(0x01, 0x0A)
#define REG_BKF001_0A_H      _PK_H_(0x01, 0x0A)
#define REG_BKF001_0B_L      _PK_L_(0x01, 0x0B)
#define REG_BKF001_0B_H      _PK_H_(0x01, 0x0B)
#define REG_BKF001_0C_L      _PK_L_(0x01, 0x0C)
#define REG_BKF001_0C_H      _PK_H_(0x01, 0x0C)
#define REG_BKF001_0D_L      _PK_L_(0x01, 0x0D)
#define REG_BKF001_0D_H      _PK_H_(0x01, 0x0D)
#define REG_BKF001_0E_L      _PK_L_(0x01, 0x0E)
#define REG_BKF001_0E_H      _PK_H_(0x01, 0x0E)
#define REG_BKF001_0F_L      _PK_L_(0x01, 0x0F)
#define REG_BKF001_0F_H      _PK_H_(0x01, 0x0F)
#define REG_BKF001_10_L      _PK_L_(0x01, 0x10)
#define REG_BKF001_10_H      _PK_H_(0x01, 0x10)
#define REG_BKF001_11_L      _PK_L_(0x01, 0x11)
#define REG_BKF001_11_H      _PK_H_(0x01, 0x11)
#define REG_BKF001_12_L      _PK_L_(0x01, 0x12)
#define REG_BKF001_12_H      _PK_H_(0x01, 0x12)
#define REG_BKF001_13_L      _PK_L_(0x01, 0x13)
#define REG_BKF001_13_H      _PK_H_(0x01, 0x13)
#define REG_BKF001_14_L      _PK_L_(0x01, 0x14)
#define REG_BKF001_14_H      _PK_H_(0x01, 0x14)
#define REG_BKF001_15_L      _PK_L_(0x01, 0x15)
#define REG_BKF001_15_H      _PK_H_(0x01, 0x15)
#define REG_BKF001_16_L      _PK_L_(0x01, 0x16)
#define REG_BKF001_16_H      _PK_H_(0x01, 0x16)
#define REG_BKF001_17_L      _PK_L_(0x01, 0x17)
#define REG_BKF001_17_H      _PK_H_(0x01, 0x17)
#define REG_BKF001_18_L      _PK_L_(0x01, 0x18)
#define REG_BKF001_18_H      _PK_H_(0x01, 0x18)
#define REG_BKF001_19_L      _PK_L_(0x01, 0x19)
#define REG_BKF001_19_H      _PK_H_(0x01, 0x19)
#define REG_BKF001_1A_L      _PK_L_(0x01, 0x1A)
#define REG_BKF001_1A_H      _PK_H_(0x01, 0x1A)
#define REG_BKF001_1B_L      _PK_L_(0x01, 0x1B)
#define REG_BKF001_1B_H      _PK_H_(0x01, 0x1B)
#define REG_BKF001_1C_L      _PK_L_(0x01, 0x1C)
#define REG_BKF001_1C_H      _PK_H_(0x01, 0x1C)
#define REG_BKF001_1D_L      _PK_L_(0x01, 0x1D)
#define REG_BKF001_1D_H      _PK_H_(0x01, 0x1D)
#define REG_BKF001_1E_L      _PK_L_(0x01, 0x1E)
#define REG_BKF001_1E_H      _PK_H_(0x01, 0x1E)
#define REG_BKF001_1F_L      _PK_L_(0x01, 0x1F)
#define REG_BKF001_1F_H      _PK_H_(0x01, 0x1F)
#define REG_BKF001_20_L      _PK_L_(0x01, 0x20)
#define REG_BKF001_20_H      _PK_H_(0x01, 0x20)
#define REG_BKF001_21_L      _PK_L_(0x01, 0x21)
#define REG_BKF001_21_H      _PK_H_(0x01, 0x21)
#define REG_BKF001_22_L      _PK_L_(0x01, 0x22)
#define REG_BKF001_22_H      _PK_H_(0x01, 0x22)
#define REG_BKF001_23_L      _PK_L_(0x01, 0x23)
#define REG_BKF001_23_H      _PK_H_(0x01, 0x23)
#define REG_BKF001_24_L      _PK_L_(0x01, 0x24)
#define REG_BKF001_24_H      _PK_H_(0x01, 0x24)
#define REG_BKF001_25_L      _PK_L_(0x01, 0x25)
#define REG_BKF001_25_H      _PK_H_(0x01, 0x25)
#define REG_BKF001_26_L      _PK_L_(0x01, 0x26)
#define REG_BKF001_26_H      _PK_H_(0x01, 0x26)
#define REG_BKF001_27_L      _PK_L_(0x01, 0x27)
#define REG_BKF001_27_H      _PK_H_(0x01, 0x27)
#define REG_BKF001_28_L      _PK_L_(0x01, 0x28)
#define REG_BKF001_28_H      _PK_H_(0x01, 0x28)
#define REG_BKF001_29_L      _PK_L_(0x01, 0x29)
#define REG_BKF001_29_H      _PK_H_(0x01, 0x29)
#define REG_BKF001_2A_L      _PK_L_(0x01, 0x2A)
#define REG_BKF001_2A_H      _PK_H_(0x01, 0x2A)
#define REG_BKF001_2B_L      _PK_L_(0x01, 0x2B)
#define REG_BKF001_2B_H      _PK_H_(0x01, 0x2B)
#define REG_BKF001_2C_L      _PK_L_(0x01, 0x2C)
#define REG_BKF001_2C_H      _PK_H_(0x01, 0x2C)
#define REG_BKF001_2D_L      _PK_L_(0x01, 0x2D)
#define REG_BKF001_2D_H      _PK_H_(0x01, 0x2D)
#define REG_BKF001_2E_L      _PK_L_(0x01, 0x2E)
#define REG_BKF001_2E_H      _PK_H_(0x01, 0x2E)
#define REG_BKF001_2F_L      _PK_L_(0x01, 0x2F)
#define REG_BKF001_2F_H      _PK_H_(0x01, 0x2F)
#define REG_BKF001_30_L      _PK_L_(0x01, 0x30)
#define REG_BKF001_30_H      _PK_H_(0x01, 0x30)
#define REG_BKF001_31_L      _PK_L_(0x01, 0x31)
#define REG_BKF001_31_H      _PK_H_(0x01, 0x31)
#define REG_BKF001_32_L      _PK_L_(0x01, 0x32)
#define REG_BKF001_32_H      _PK_H_(0x01, 0x32)
#define REG_BKF001_33_L      _PK_L_(0x01, 0x33)
#define REG_BKF001_33_H      _PK_H_(0x01, 0x33)
#define REG_BKF001_34_L      _PK_L_(0x01, 0x34)
#define REG_BKF001_34_H      _PK_H_(0x01, 0x34)
#define REG_BKF001_35_L      _PK_L_(0x01, 0x35)
#define REG_BKF001_35_H      _PK_H_(0x01, 0x35)
#define REG_BKF001_36_L      _PK_L_(0x01, 0x36)
#define REG_BKF001_36_H      _PK_H_(0x01, 0x36)
#define REG_BKF001_37_L      _PK_L_(0x01, 0x37)
#define REG_BKF001_37_H      _PK_H_(0x01, 0x37)
#define REG_BKF001_38_L      _PK_L_(0x01, 0x38)
#define REG_BKF001_38_H      _PK_H_(0x01, 0x38)
#define REG_BKF001_39_L      _PK_L_(0x01, 0x39)
#define REG_BKF001_39_H      _PK_H_(0x01, 0x39)
#define REG_BKF001_3A_L      _PK_L_(0x01, 0x3A)
#define REG_BKF001_3A_H      _PK_H_(0x01, 0x3A)
#define REG_BKF001_3B_L      _PK_L_(0x01, 0x3B)
#define REG_BKF001_3B_H      _PK_H_(0x01, 0x3B)
#define REG_BKF001_3C_L      _PK_L_(0x01, 0x3C)
#define REG_BKF001_3C_H      _PK_H_(0x01, 0x3C)
#define REG_BKF001_3D_L      _PK_L_(0x01, 0x3D)
#define REG_BKF001_3D_H      _PK_H_(0x01, 0x3D)
#define REG_BKF001_3E_L      _PK_L_(0x01, 0x3E)
#define REG_BKF001_3E_H      _PK_H_(0x01, 0x3E)
#define REG_BKF001_3F_L      _PK_L_(0x01, 0x3F)
#define REG_BKF001_3F_H      _PK_H_(0x01, 0x3F)
#define REG_BKF001_40_L      _PK_L_(0x01, 0x40)
#define REG_BKF001_40_H      _PK_H_(0x01, 0x40)
#define REG_BKF001_41_L      _PK_L_(0x01, 0x41)
#define REG_BKF001_41_H      _PK_H_(0x01, 0x41)
#define REG_BKF001_42_L      _PK_L_(0x01, 0x42)
#define REG_BKF001_42_H      _PK_H_(0x01, 0x42)
#define REG_BKF001_43_L      _PK_L_(0x01, 0x43)
#define REG_BKF001_43_H      _PK_H_(0x01, 0x43)
#define REG_BKF001_44_L      _PK_L_(0x01, 0x44)
#define REG_BKF001_44_H      _PK_H_(0x01, 0x44)
#define REG_BKF001_45_L      _PK_L_(0x01, 0x45)
#define REG_BKF001_45_H      _PK_H_(0x01, 0x45)
#define REG_BKF001_46_L      _PK_L_(0x01, 0x46)
#define REG_BKF001_46_H      _PK_H_(0x01, 0x46)
#define REG_BKF001_47_L      _PK_L_(0x01, 0x47)
#define REG_BKF001_47_H      _PK_H_(0x01, 0x47)
#define REG_BKF001_48_L      _PK_L_(0x01, 0x48)
#define REG_BKF001_48_H      _PK_H_(0x01, 0x48)
#define REG_BKF001_49_L      _PK_L_(0x01, 0x49)
#define REG_BKF001_49_H      _PK_H_(0x01, 0x49)
#define REG_BKF001_4A_L      _PK_L_(0x01, 0x4A)
#define REG_BKF001_4A_H      _PK_H_(0x01, 0x4A)
#define REG_BKF001_4B_L      _PK_L_(0x01, 0x4B)
#define REG_BKF001_4B_H      _PK_H_(0x01, 0x4B)
#define REG_BKF001_4C_L      _PK_L_(0x01, 0x4C)
#define REG_BKF001_4C_H      _PK_H_(0x01, 0x4C)
#define REG_BKF001_4D_L      _PK_L_(0x01, 0x4D)
#define REG_BKF001_4D_H      _PK_H_(0x01, 0x4D)
#define REG_BKF001_4E_L      _PK_L_(0x01, 0x4E)
#define REG_BKF001_4E_H      _PK_H_(0x01, 0x4E)
#define REG_BKF001_4F_L      _PK_L_(0x01, 0x4F)
#define REG_BKF001_4F_H      _PK_H_(0x01, 0x4F)
#define REG_BKF001_50_L      _PK_L_(0x01, 0x50)
#define REG_BKF001_50_H      _PK_H_(0x01, 0x50)
#define REG_BKF001_51_L      _PK_L_(0x01, 0x51)
#define REG_BKF001_51_H      _PK_H_(0x01, 0x51)
#define REG_BKF001_52_L      _PK_L_(0x01, 0x52)
#define REG_BKF001_52_H      _PK_H_(0x01, 0x52)
#define REG_BKF001_53_L      _PK_L_(0x01, 0x53)
#define REG_BKF001_53_H      _PK_H_(0x01, 0x53)
#define REG_BKF001_54_L      _PK_L_(0x01, 0x54)
#define REG_BKF001_54_H      _PK_H_(0x01, 0x54)
#define REG_BKF001_55_L      _PK_L_(0x01, 0x55)
#define REG_BKF001_55_H      _PK_H_(0x01, 0x55)
#define REG_BKF001_56_L      _PK_L_(0x01, 0x56)
#define REG_BKF001_56_H      _PK_H_(0x01, 0x56)
#define REG_BKF001_57_L      _PK_L_(0x01, 0x57)
#define REG_BKF001_57_H      _PK_H_(0x01, 0x57)
#define REG_BKF001_58_L      _PK_L_(0x01, 0x58)
#define REG_BKF001_58_H      _PK_H_(0x01, 0x58)
#define REG_BKF001_59_L      _PK_L_(0x01, 0x59)
#define REG_BKF001_59_H      _PK_H_(0x01, 0x59)
#define REG_BKF001_5A_L      _PK_L_(0x01, 0x5A)
#define REG_BKF001_5A_H      _PK_H_(0x01, 0x5A)
#define REG_BKF001_5B_L      _PK_L_(0x01, 0x5B)
#define REG_BKF001_5B_H      _PK_H_(0x01, 0x5B)
#define REG_BKF001_5C_L      _PK_L_(0x01, 0x5C)
#define REG_BKF001_5C_H      _PK_H_(0x01, 0x5C)
#define REG_BKF001_5D_L      _PK_L_(0x01, 0x5D)
#define REG_BKF001_5D_H      _PK_H_(0x01, 0x5D)
#define REG_BKF001_5E_L      _PK_L_(0x01, 0x5E)
#define REG_BKF001_5E_H      _PK_H_(0x01, 0x5E)
#define REG_BKF001_5F_L      _PK_L_(0x01, 0x5F)
#define REG_BKF001_5F_H      _PK_H_(0x01, 0x5F)
#define REG_BKF001_60_L      _PK_L_(0x01, 0x60)
#define REG_BKF001_60_H      _PK_H_(0x01, 0x60)
#define REG_BKF001_61_L      _PK_L_(0x01, 0x61)
#define REG_BKF001_61_H      _PK_H_(0x01, 0x61)
#define REG_BKF001_62_L      _PK_L_(0x01, 0x62)
#define REG_BKF001_62_H      _PK_H_(0x01, 0x62)
#define REG_BKF001_63_L      _PK_L_(0x01, 0x63)
#define REG_BKF001_63_H      _PK_H_(0x01, 0x63)
#define REG_BKF001_64_L      _PK_L_(0x01, 0x64)
#define REG_BKF001_64_H      _PK_H_(0x01, 0x64)
#define REG_BKF001_65_L      _PK_L_(0x01, 0x65)
#define REG_BKF001_65_H      _PK_H_(0x01, 0x65)
#define REG_BKF001_66_L      _PK_L_(0x01, 0x66)
#define REG_BKF001_66_H      _PK_H_(0x01, 0x66)
#define REG_BKF001_67_L      _PK_L_(0x01, 0x67)
#define REG_BKF001_67_H      _PK_H_(0x01, 0x67)
#define REG_BKF001_68_L      _PK_L_(0x01, 0x68)
#define REG_BKF001_68_H      _PK_H_(0x01, 0x68)
#define REG_BKF001_69_L      _PK_L_(0x01, 0x69)
#define REG_BKF001_69_H      _PK_H_(0x01, 0x69)
#define REG_BKF001_6A_L      _PK_L_(0x01, 0x6A)
#define REG_BKF001_6A_H      _PK_H_(0x01, 0x6A)
#define REG_BKF001_6B_L      _PK_L_(0x01, 0x6B)
#define REG_BKF001_6B_H      _PK_H_(0x01, 0x6B)
#define REG_BKF001_6C_L      _PK_L_(0x01, 0x6C)
#define REG_BKF001_6C_H      _PK_H_(0x01, 0x6C)
#define REG_BKF001_6D_L      _PK_L_(0x01, 0x6D)
#define REG_BKF001_6D_H      _PK_H_(0x01, 0x6D)
#define REG_BKF001_6E_L      _PK_L_(0x01, 0x6E)
#define REG_BKF001_6E_H      _PK_H_(0x01, 0x6E)
#define REG_BKF001_6F_L      _PK_L_(0x01, 0x6F)
#define REG_BKF001_6F_H      _PK_H_(0x01, 0x6F)
#define REG_BKF001_70_L      _PK_L_(0x01, 0x70)
#define REG_BKF001_70_H      _PK_H_(0x01, 0x70)
#define REG_BKF001_71_L      _PK_L_(0x01, 0x71)
#define REG_BKF001_71_H      _PK_H_(0x01, 0x71)
#define REG_BKF001_72_L      _PK_L_(0x01, 0x72)
#define REG_BKF001_72_H      _PK_H_(0x01, 0x72)
#define REG_BKF001_73_L      _PK_L_(0x01, 0x73)
#define REG_BKF001_73_H      _PK_H_(0x01, 0x73)
#define REG_BKF001_74_L      _PK_L_(0x01, 0x74)
#define REG_BKF001_74_H      _PK_H_(0x01, 0x74)
#define REG_BKF001_75_L      _PK_L_(0x01, 0x75)
#define REG_BKF001_75_H      _PK_H_(0x01, 0x75)
#define REG_BKF001_76_L      _PK_L_(0x01, 0x76)
#define REG_BKF001_76_H      _PK_H_(0x01, 0x76)
#define REG_BKF001_77_L      _PK_L_(0x01, 0x77)
#define REG_BKF001_77_H      _PK_H_(0x01, 0x77)
#define REG_BKF001_78_L      _PK_L_(0x01, 0x78)
#define REG_BKF001_78_H      _PK_H_(0x01, 0x78)
#define REG_BKF001_79_L      _PK_L_(0x01, 0x79)
#define REG_BKF001_79_H      _PK_H_(0x01, 0x79)
#define REG_BKF001_7A_L      _PK_L_(0x01, 0x7A)
#define REG_BKF001_7A_H      _PK_H_(0x01, 0x7A)
#define REG_BKF001_7B_L      _PK_L_(0x01, 0x7B)
#define REG_BKF001_7B_H      _PK_H_(0x01, 0x7B)
#define REG_BKF001_7C_L      _PK_L_(0x01, 0x7C)
#define REG_BKF001_7C_H      _PK_H_(0x01, 0x7C)
#define REG_BKF001_7D_L      _PK_L_(0x01, 0x7D)
#define REG_BKF001_7D_H      _PK_H_(0x01, 0x7D)
#define REG_BKF001_7E_L      _PK_L_(0x01, 0x7E)
#define REG_BKF001_7E_H      _PK_H_(0x01, 0x7E)
#define REG_BKF001_7F_L      _PK_L_(0x01, 0x7F)
#define REG_BKF001_7F_H      _PK_H_(0x01, 0x7F)
//----------------------------------------------
#define REG_BKF002_00_L      _PK_L_(0x02, 0x00)
#define REG_BKF002_00_H      _PK_H_(0x02, 0x00)
#define REG_BKF002_01_L      _PK_L_(0x02, 0x01)
#define REG_BKF002_01_H      _PK_H_(0x02, 0x01)
#define REG_BKF002_02_L      _PK_L_(0x02, 0x02)
#define REG_BKF002_02_H      _PK_H_(0x02, 0x02)
#define REG_BKF002_03_L      _PK_L_(0x02, 0x03)
#define REG_BKF002_03_H      _PK_H_(0x02, 0x03)
#define REG_BKF002_04_L      _PK_L_(0x02, 0x04)
#define REG_BKF002_04_H      _PK_H_(0x02, 0x04)
#define REG_BKF002_05_L      _PK_L_(0x02, 0x05)
#define REG_BKF002_05_H      _PK_H_(0x02, 0x05)
#define REG_BKF002_06_L      _PK_L_(0x02, 0x06)
#define REG_BKF002_06_H      _PK_H_(0x02, 0x06)
#define REG_BKF002_07_L      _PK_L_(0x02, 0x07)
#define REG_BKF002_07_H      _PK_H_(0x02, 0x07)
#define REG_BKF002_08_L      _PK_L_(0x02, 0x08)
#define REG_BKF002_08_H      _PK_H_(0x02, 0x08)
#define REG_BKF002_09_L      _PK_L_(0x02, 0x09)
#define REG_BKF002_09_H      _PK_H_(0x02, 0x09)
#define REG_BKF002_0A_L      _PK_L_(0x02, 0x0A)
#define REG_BKF002_0A_H      _PK_H_(0x02, 0x0A)
#define REG_BKF002_0B_L      _PK_L_(0x02, 0x0B)
#define REG_BKF002_0B_H      _PK_H_(0x02, 0x0B)
#define REG_BKF002_0C_L      _PK_L_(0x02, 0x0C)
#define REG_BKF002_0C_H      _PK_H_(0x02, 0x0C)
#define REG_BKF002_0D_L      _PK_L_(0x02, 0x0D)
#define REG_BKF002_0D_H      _PK_H_(0x02, 0x0D)
#define REG_BKF002_0E_L      _PK_L_(0x02, 0x0E)
#define REG_BKF002_0E_H      _PK_H_(0x02, 0x0E)
#define REG_BKF002_0F_L      _PK_L_(0x02, 0x0F)
#define REG_BKF002_0F_H      _PK_H_(0x02, 0x0F)
#define REG_BKF002_10_L      _PK_L_(0x02, 0x10)
#define REG_BKF002_10_H      _PK_H_(0x02, 0x10)
#define REG_BKF002_11_L      _PK_L_(0x02, 0x11)
#define REG_BKF002_11_H      _PK_H_(0x02, 0x11)
#define REG_BKF002_12_L      _PK_L_(0x02, 0x12)
#define REG_BKF002_12_H      _PK_H_(0x02, 0x12)
#define REG_BKF002_13_L      _PK_L_(0x02, 0x13)
#define REG_BKF002_13_H      _PK_H_(0x02, 0x13)
#define REG_BKF002_14_L      _PK_L_(0x02, 0x14)
#define REG_BKF002_14_H      _PK_H_(0x02, 0x14)
#define REG_BKF002_15_L      _PK_L_(0x02, 0x15)
#define REG_BKF002_15_H      _PK_H_(0x02, 0x15)
#define REG_BKF002_16_L      _PK_L_(0x02, 0x16)
#define REG_BKF002_16_H      _PK_H_(0x02, 0x16)
#define REG_BKF002_17_L      _PK_L_(0x02, 0x17)
#define REG_BKF002_17_H      _PK_H_(0x02, 0x17)
#define REG_BKF002_18_L      _PK_L_(0x02, 0x18)
#define REG_BKF002_18_H      _PK_H_(0x02, 0x18)
#define REG_BKF002_19_L      _PK_L_(0x02, 0x19)
#define REG_BKF002_19_H      _PK_H_(0x02, 0x19)
#define REG_BKF002_1A_L      _PK_L_(0x02, 0x1A)
#define REG_BKF002_1A_H      _PK_H_(0x02, 0x1A)
#define REG_BKF002_1B_L      _PK_L_(0x02, 0x1B)
#define REG_BKF002_1B_H      _PK_H_(0x02, 0x1B)
#define REG_BKF002_1C_L      _PK_L_(0x02, 0x1C)
#define REG_BKF002_1C_H      _PK_H_(0x02, 0x1C)
#define REG_BKF002_1D_L      _PK_L_(0x02, 0x1D)
#define REG_BKF002_1D_H      _PK_H_(0x02, 0x1D)
#define REG_BKF002_1E_L      _PK_L_(0x02, 0x1E)
#define REG_BKF002_1E_H      _PK_H_(0x02, 0x1E)
#define REG_BKF002_1F_L      _PK_L_(0x02, 0x1F)
#define REG_BKF002_1F_H      _PK_H_(0x02, 0x1F)
#define REG_BKF002_20_L      _PK_L_(0x02, 0x20)
#define REG_BKF002_20_H      _PK_H_(0x02, 0x20)
#define REG_BKF002_21_L      _PK_L_(0x02, 0x21)
#define REG_BKF002_21_H      _PK_H_(0x02, 0x21)
#define REG_BKF002_22_L      _PK_L_(0x02, 0x22)
#define REG_BKF002_22_H      _PK_H_(0x02, 0x22)
#define REG_BKF002_23_L      _PK_L_(0x02, 0x23)
#define REG_BKF002_23_H      _PK_H_(0x02, 0x23)
#define REG_BKF002_24_L      _PK_L_(0x02, 0x24)
#define REG_BKF002_24_H      _PK_H_(0x02, 0x24)
#define REG_BKF002_25_L      _PK_L_(0x02, 0x25)
#define REG_BKF002_25_H      _PK_H_(0x02, 0x25)
#define REG_BKF002_26_L      _PK_L_(0x02, 0x26)
#define REG_BKF002_26_H      _PK_H_(0x02, 0x26)
#define REG_BKF002_27_L      _PK_L_(0x02, 0x27)
#define REG_BKF002_27_H      _PK_H_(0x02, 0x27)
#define REG_BKF002_28_L      _PK_L_(0x02, 0x28)
#define REG_BKF002_28_H      _PK_H_(0x02, 0x28)
#define REG_BKF002_29_L      _PK_L_(0x02, 0x29)
#define REG_BKF002_29_H      _PK_H_(0x02, 0x29)
#define REG_BKF002_2A_L      _PK_L_(0x02, 0x2A)
#define REG_BKF002_2A_H      _PK_H_(0x02, 0x2A)
#define REG_BKF002_2B_L      _PK_L_(0x02, 0x2B)
#define REG_BKF002_2B_H      _PK_H_(0x02, 0x2B)
#define REG_BKF002_2C_L      _PK_L_(0x02, 0x2C)
#define REG_BKF002_2C_H      _PK_H_(0x02, 0x2C)
#define REG_BKF002_2D_L      _PK_L_(0x02, 0x2D)
#define REG_BKF002_2D_H      _PK_H_(0x02, 0x2D)
#define REG_BKF002_2E_L      _PK_L_(0x02, 0x2E)
#define REG_BKF002_2E_H      _PK_H_(0x02, 0x2E)
#define REG_BKF002_2F_L      _PK_L_(0x02, 0x2F)
#define REG_BKF002_2F_H      _PK_H_(0x02, 0x2F)
#define REG_BKF002_30_L      _PK_L_(0x02, 0x30)
#define REG_BKF002_30_H      _PK_H_(0x02, 0x30)
#define REG_BKF002_31_L      _PK_L_(0x02, 0x31)
#define REG_BKF002_31_H      _PK_H_(0x02, 0x31)
#define REG_BKF002_32_L      _PK_L_(0x02, 0x32)
#define REG_BKF002_32_H      _PK_H_(0x02, 0x32)
#define REG_BKF002_33_L      _PK_L_(0x02, 0x33)
#define REG_BKF002_33_H      _PK_H_(0x02, 0x33)
#define REG_BKF002_34_L      _PK_L_(0x02, 0x34)
#define REG_BKF002_34_H      _PK_H_(0x02, 0x34)
#define REG_BKF002_35_L      _PK_L_(0x02, 0x35)
#define REG_BKF002_35_H      _PK_H_(0x02, 0x35)
#define REG_BKF002_36_L      _PK_L_(0x02, 0x36)
#define REG_BKF002_36_H      _PK_H_(0x02, 0x36)
#define REG_BKF002_37_L      _PK_L_(0x02, 0x37)
#define REG_BKF002_37_H      _PK_H_(0x02, 0x37)
#define REG_BKF002_38_L      _PK_L_(0x02, 0x38)
#define REG_BKF002_38_H      _PK_H_(0x02, 0x38)
#define REG_BKF002_39_L      _PK_L_(0x02, 0x39)
#define REG_BKF002_39_H      _PK_H_(0x02, 0x39)
#define REG_BKF002_3A_L      _PK_L_(0x02, 0x3A)
#define REG_BKF002_3A_H      _PK_H_(0x02, 0x3A)
#define REG_BKF002_3B_L      _PK_L_(0x02, 0x3B)
#define REG_BKF002_3B_H      _PK_H_(0x02, 0x3B)
#define REG_BKF002_3C_L      _PK_L_(0x02, 0x3C)
#define REG_BKF002_3C_H      _PK_H_(0x02, 0x3C)
#define REG_BKF002_3D_L      _PK_L_(0x02, 0x3D)
#define REG_BKF002_3D_H      _PK_H_(0x02, 0x3D)
#define REG_BKF002_3E_L      _PK_L_(0x02, 0x3E)
#define REG_BKF002_3E_H      _PK_H_(0x02, 0x3E)
#define REG_BKF002_3F_L      _PK_L_(0x02, 0x3F)
#define REG_BKF002_3F_H      _PK_H_(0x02, 0x3F)
#define REG_BKF002_40_L      _PK_L_(0x02, 0x40)
#define REG_BKF002_40_H      _PK_H_(0x02, 0x40)
#define REG_BKF002_41_L      _PK_L_(0x02, 0x41)
#define REG_BKF002_41_H      _PK_H_(0x02, 0x41)
#define REG_BKF002_42_L      _PK_L_(0x02, 0x42)
#define REG_BKF002_42_H      _PK_H_(0x02, 0x42)
#define REG_BKF002_43_L      _PK_L_(0x02, 0x43)
#define REG_BKF002_43_H      _PK_H_(0x02, 0x43)
#define REG_BKF002_44_L      _PK_L_(0x02, 0x44)
#define REG_BKF002_44_H      _PK_H_(0x02, 0x44)
#define REG_BKF002_45_L      _PK_L_(0x02, 0x45)
#define REG_BKF002_45_H      _PK_H_(0x02, 0x45)
#define REG_BKF002_46_L      _PK_L_(0x02, 0x46)
#define REG_BKF002_46_H      _PK_H_(0x02, 0x46)
#define REG_BKF002_47_L      _PK_L_(0x02, 0x47)
#define REG_BKF002_47_H      _PK_H_(0x02, 0x47)
#define REG_BKF002_48_L      _PK_L_(0x02, 0x48)
#define REG_BKF002_48_H      _PK_H_(0x02, 0x48)
#define REG_BKF002_49_L      _PK_L_(0x02, 0x49)
#define REG_BKF002_49_H      _PK_H_(0x02, 0x49)
#define REG_BKF002_4A_L      _PK_L_(0x02, 0x4A)
#define REG_BKF002_4A_H      _PK_H_(0x02, 0x4A)
#define REG_BKF002_4B_L      _PK_L_(0x02, 0x4B)
#define REG_BKF002_4B_H      _PK_H_(0x02, 0x4B)
#define REG_BKF002_4C_L      _PK_L_(0x02, 0x4C)
#define REG_BKF002_4C_H      _PK_H_(0x02, 0x4C)
#define REG_BKF002_4D_L      _PK_L_(0x02, 0x4D)
#define REG_BKF002_4D_H      _PK_H_(0x02, 0x4D)
#define REG_BKF002_4E_L      _PK_L_(0x02, 0x4E)
#define REG_BKF002_4E_H      _PK_H_(0x02, 0x4E)
#define REG_BKF002_4F_L      _PK_L_(0x02, 0x4F)
#define REG_BKF002_4F_H      _PK_H_(0x02, 0x4F)
#define REG_BKF002_50_L      _PK_L_(0x02, 0x50)
#define REG_BKF002_50_H      _PK_H_(0x02, 0x50)
#define REG_BKF002_51_L      _PK_L_(0x02, 0x51)
#define REG_BKF002_51_H      _PK_H_(0x02, 0x51)
#define REG_BKF002_52_L      _PK_L_(0x02, 0x52)
#define REG_BKF002_52_H      _PK_H_(0x02, 0x52)
#define REG_BKF002_53_L      _PK_L_(0x02, 0x53)
#define REG_BKF002_53_H      _PK_H_(0x02, 0x53)
#define REG_BKF002_54_L      _PK_L_(0x02, 0x54)
#define REG_BKF002_54_H      _PK_H_(0x02, 0x54)
#define REG_BKF002_55_L      _PK_L_(0x02, 0x55)
#define REG_BKF002_55_H      _PK_H_(0x02, 0x55)
#define REG_BKF002_56_L      _PK_L_(0x02, 0x56)
#define REG_BKF002_56_H      _PK_H_(0x02, 0x56)
#define REG_BKF002_57_L      _PK_L_(0x02, 0x57)
#define REG_BKF002_57_H      _PK_H_(0x02, 0x57)
#define REG_BKF002_58_L      _PK_L_(0x02, 0x58)
#define REG_BKF002_58_H      _PK_H_(0x02, 0x58)
#define REG_BKF002_59_L      _PK_L_(0x02, 0x59)
#define REG_BKF002_59_H      _PK_H_(0x02, 0x59)
#define REG_BKF002_5A_L      _PK_L_(0x02, 0x5A)
#define REG_BKF002_5A_H      _PK_H_(0x02, 0x5A)
#define REG_BKF002_5B_L      _PK_L_(0x02, 0x5B)
#define REG_BKF002_5B_H      _PK_H_(0x02, 0x5B)
#define REG_BKF002_5C_L      _PK_L_(0x02, 0x5C)
#define REG_BKF002_5C_H      _PK_H_(0x02, 0x5C)
#define REG_BKF002_5D_L      _PK_L_(0x02, 0x5D)
#define REG_BKF002_5D_H      _PK_H_(0x02, 0x5D)
#define REG_BKF002_5E_L      _PK_L_(0x02, 0x5E)
#define REG_BKF002_5E_H      _PK_H_(0x02, 0x5E)
#define REG_BKF002_5F_L      _PK_L_(0x02, 0x5F)
#define REG_BKF002_5F_H      _PK_H_(0x02, 0x5F)
#define REG_BKF002_60_L      _PK_L_(0x02, 0x60)
#define REG_BKF002_60_H      _PK_H_(0x02, 0x60)
#define REG_BKF002_61_L      _PK_L_(0x02, 0x61)
#define REG_BKF002_61_H      _PK_H_(0x02, 0x61)
#define REG_BKF002_62_L      _PK_L_(0x02, 0x62)
#define REG_BKF002_62_H      _PK_H_(0x02, 0x62)
#define REG_BKF002_63_L      _PK_L_(0x02, 0x63)
#define REG_BKF002_63_H      _PK_H_(0x02, 0x63)
#define REG_BKF002_64_L      _PK_L_(0x02, 0x64)
#define REG_BKF002_64_H      _PK_H_(0x02, 0x64)
#define REG_BKF002_65_L      _PK_L_(0x02, 0x65)
#define REG_BKF002_65_H      _PK_H_(0x02, 0x65)
#define REG_BKF002_66_L      _PK_L_(0x02, 0x66)
#define REG_BKF002_66_H      _PK_H_(0x02, 0x66)
#define REG_BKF002_67_L      _PK_L_(0x02, 0x67)
#define REG_BKF002_67_H      _PK_H_(0x02, 0x67)
#define REG_BKF002_68_L      _PK_L_(0x02, 0x68)
#define REG_BKF002_68_H      _PK_H_(0x02, 0x68)
#define REG_BKF002_69_L      _PK_L_(0x02, 0x69)
#define REG_BKF002_69_H      _PK_H_(0x02, 0x69)
#define REG_BKF002_6A_L      _PK_L_(0x02, 0x6A)
#define REG_BKF002_6A_H      _PK_H_(0x02, 0x6A)
#define REG_BKF002_6B_L      _PK_L_(0x02, 0x6B)
#define REG_BKF002_6B_H      _PK_H_(0x02, 0x6B)
#define REG_BKF002_6C_L      _PK_L_(0x02, 0x6C)
#define REG_BKF002_6C_H      _PK_H_(0x02, 0x6C)
#define REG_BKF002_6D_L      _PK_L_(0x02, 0x6D)
#define REG_BKF002_6D_H      _PK_H_(0x02, 0x6D)
#define REG_BKF002_6E_L      _PK_L_(0x02, 0x6E)
#define REG_BKF002_6E_H      _PK_H_(0x02, 0x6E)
#define REG_BKF002_6F_L      _PK_L_(0x02, 0x6F)
#define REG_BKF002_6F_H      _PK_H_(0x02, 0x6F)
#define REG_BKF002_70_L      _PK_L_(0x02, 0x70)
#define REG_BKF002_70_H      _PK_H_(0x02, 0x70)
#define REG_BKF002_71_L      _PK_L_(0x02, 0x71)
#define REG_BKF002_71_H      _PK_H_(0x02, 0x71)
#define REG_BKF002_72_L      _PK_L_(0x02, 0x72)
#define REG_BKF002_72_H      _PK_H_(0x02, 0x72)
#define REG_BKF002_73_L      _PK_L_(0x02, 0x73)
#define REG_BKF002_73_H      _PK_H_(0x02, 0x73)
#define REG_BKF002_74_L      _PK_L_(0x02, 0x74)
#define REG_BKF002_74_H      _PK_H_(0x02, 0x74)
#define REG_BKF002_75_L      _PK_L_(0x02, 0x75)
#define REG_BKF002_75_H      _PK_H_(0x02, 0x75)
#define REG_BKF002_76_L      _PK_L_(0x02, 0x76)
#define REG_BKF002_76_H      _PK_H_(0x02, 0x76)
#define REG_BKF002_77_L      _PK_L_(0x02, 0x77)
#define REG_BKF002_77_H      _PK_H_(0x02, 0x77)
#define REG_BKF002_78_L      _PK_L_(0x02, 0x78)
#define REG_BKF002_78_H      _PK_H_(0x02, 0x78)
#define REG_BKF002_79_L      _PK_L_(0x02, 0x79)
#define REG_BKF002_79_H      _PK_H_(0x02, 0x79)
#define REG_BKF002_7A_L      _PK_L_(0x02, 0x7A)
#define REG_BKF002_7A_H      _PK_H_(0x02, 0x7A)
#define REG_BKF002_7B_L      _PK_L_(0x02, 0x7B)
#define REG_BKF002_7B_H      _PK_H_(0x02, 0x7B)
#define REG_BKF002_7C_L      _PK_L_(0x02, 0x7C)
#define REG_BKF002_7C_H      _PK_H_(0x02, 0x7C)
#define REG_BKF002_7D_L      _PK_L_(0x02, 0x7D)
#define REG_BKF002_7D_H      _PK_H_(0x02, 0x7D)
#define REG_BKF002_7E_L      _PK_L_(0x02, 0x7E)
#define REG_BKF002_7E_H      _PK_H_(0x02, 0x7E)
#define REG_BKF002_7F_L      _PK_L_(0x02, 0x7F)
#define REG_BKF002_7F_H      _PK_H_(0x02, 0x7F)
//----------------------------------------------
#define REG_BKF003_00_L      _PK_L_(0x03, 0x00)
#define REG_BKF003_00_H      _PK_H_(0x03, 0x00)
#define REG_BKF003_01_L      _PK_L_(0x03, 0x01)
#define REG_BKF003_01_H      _PK_H_(0x03, 0x01)
#define REG_BKF003_02_L      _PK_L_(0x03, 0x02)
#define REG_BKF003_02_H      _PK_H_(0x03, 0x02)
#define REG_BKF003_03_L      _PK_L_(0x03, 0x03)
#define REG_BKF003_03_H      _PK_H_(0x03, 0x03)
#define REG_BKF003_04_L      _PK_L_(0x03, 0x04)
#define REG_BKF003_04_H      _PK_H_(0x03, 0x04)
#define REG_BKF003_05_L      _PK_L_(0x03, 0x05)
#define REG_BKF003_05_H      _PK_H_(0x03, 0x05)
#define REG_BKF003_06_L      _PK_L_(0x03, 0x06)
#define REG_BKF003_06_H      _PK_H_(0x03, 0x06)
#define REG_BKF003_07_L      _PK_L_(0x03, 0x07)
#define REG_BKF003_07_H      _PK_H_(0x03, 0x07)
#define REG_BKF003_08_L      _PK_L_(0x03, 0x08)
#define REG_BKF003_08_H      _PK_H_(0x03, 0x08)
#define REG_BKF003_09_L      _PK_L_(0x03, 0x09)
#define REG_BKF003_09_H      _PK_H_(0x03, 0x09)
#define REG_BKF003_0A_L      _PK_L_(0x03, 0x0A)
#define REG_BKF003_0A_H      _PK_H_(0x03, 0x0A)
#define REG_BKF003_0B_L      _PK_L_(0x03, 0x0B)
#define REG_BKF003_0B_H      _PK_H_(0x03, 0x0B)
#define REG_BKF003_0C_L      _PK_L_(0x03, 0x0C)
#define REG_BKF003_0C_H      _PK_H_(0x03, 0x0C)
#define REG_BKF003_0D_L      _PK_L_(0x03, 0x0D)
#define REG_BKF003_0D_H      _PK_H_(0x03, 0x0D)
#define REG_BKF003_0E_L      _PK_L_(0x03, 0x0E)
#define REG_BKF003_0E_H      _PK_H_(0x03, 0x0E)
#define REG_BKF003_0F_L      _PK_L_(0x03, 0x0F)
#define REG_BKF003_0F_H      _PK_H_(0x03, 0x0F)
#define REG_BKF003_10_L      _PK_L_(0x03, 0x10)
#define REG_BKF003_10_H      _PK_H_(0x03, 0x10)
#define REG_BKF003_11_L      _PK_L_(0x03, 0x11)
#define REG_BKF003_11_H      _PK_H_(0x03, 0x11)
#define REG_BKF003_12_L      _PK_L_(0x03, 0x12)
#define REG_BKF003_12_H      _PK_H_(0x03, 0x12)
#define REG_BKF003_13_L      _PK_L_(0x03, 0x13)
#define REG_BKF003_13_H      _PK_H_(0x03, 0x13)
#define REG_BKF003_14_L      _PK_L_(0x03, 0x14)
#define REG_BKF003_14_H      _PK_H_(0x03, 0x14)
#define REG_BKF003_15_L      _PK_L_(0x03, 0x15)
#define REG_BKF003_15_H      _PK_H_(0x03, 0x15)
#define REG_BKF003_16_L      _PK_L_(0x03, 0x16)
#define REG_BKF003_16_H      _PK_H_(0x03, 0x16)
#define REG_BKF003_17_L      _PK_L_(0x03, 0x17)
#define REG_BKF003_17_H      _PK_H_(0x03, 0x17)
#define REG_BKF003_18_L      _PK_L_(0x03, 0x18)
#define REG_BKF003_18_H      _PK_H_(0x03, 0x18)
#define REG_BKF003_19_L      _PK_L_(0x03, 0x19)
#define REG_BKF003_19_H      _PK_H_(0x03, 0x19)
#define REG_BKF003_1A_L      _PK_L_(0x03, 0x1A)
#define REG_BKF003_1A_H      _PK_H_(0x03, 0x1A)
#define REG_BKF003_1B_L      _PK_L_(0x03, 0x1B)
#define REG_BKF003_1B_H      _PK_H_(0x03, 0x1B)
#define REG_BKF003_1C_L      _PK_L_(0x03, 0x1C)
#define REG_BKF003_1C_H      _PK_H_(0x03, 0x1C)
#define REG_BKF003_1D_L      _PK_L_(0x03, 0x1D)
#define REG_BKF003_1D_H      _PK_H_(0x03, 0x1D)
#define REG_BKF003_1E_L      _PK_L_(0x03, 0x1E)
#define REG_BKF003_1E_H      _PK_H_(0x03, 0x1E)
#define REG_BKF003_1F_L      _PK_L_(0x03, 0x1F)
#define REG_BKF003_1F_H      _PK_H_(0x03, 0x1F)
#define REG_BKF003_20_L      _PK_L_(0x03, 0x20)
#define REG_BKF003_20_H      _PK_H_(0x03, 0x20)
#define REG_BKF003_21_L      _PK_L_(0x03, 0x21)
#define REG_BKF003_21_H      _PK_H_(0x03, 0x21)
#define REG_BKF003_22_L      _PK_L_(0x03, 0x22)
#define REG_BKF003_22_H      _PK_H_(0x03, 0x22)
#define REG_BKF003_23_L      _PK_L_(0x03, 0x23)
#define REG_BKF003_23_H      _PK_H_(0x03, 0x23)
#define REG_BKF003_24_L      _PK_L_(0x03, 0x24)
#define REG_BKF003_24_H      _PK_H_(0x03, 0x24)
#define REG_BKF003_25_L      _PK_L_(0x03, 0x25)
#define REG_BKF003_25_H      _PK_H_(0x03, 0x25)
#define REG_BKF003_26_L      _PK_L_(0x03, 0x26)
#define REG_BKF003_26_H      _PK_H_(0x03, 0x26)
#define REG_BKF003_27_L      _PK_L_(0x03, 0x27)
#define REG_BKF003_27_H      _PK_H_(0x03, 0x27)
#define REG_BKF003_28_L      _PK_L_(0x03, 0x28)
#define REG_BKF003_28_H      _PK_H_(0x03, 0x28)
#define REG_BKF003_29_L      _PK_L_(0x03, 0x29)
#define REG_BKF003_29_H      _PK_H_(0x03, 0x29)
#define REG_BKF003_2A_L      _PK_L_(0x03, 0x2A)
#define REG_BKF003_2A_H      _PK_H_(0x03, 0x2A)
#define REG_BKF003_2B_L      _PK_L_(0x03, 0x2B)
#define REG_BKF003_2B_H      _PK_H_(0x03, 0x2B)
#define REG_BKF003_2C_L      _PK_L_(0x03, 0x2C)
#define REG_BKF003_2C_H      _PK_H_(0x03, 0x2C)
#define REG_BKF003_2D_L      _PK_L_(0x03, 0x2D)
#define REG_BKF003_2D_H      _PK_H_(0x03, 0x2D)
#define REG_BKF003_2E_L      _PK_L_(0x03, 0x2E)
#define REG_BKF003_2E_H      _PK_H_(0x03, 0x2E)
#define REG_BKF003_2F_L      _PK_L_(0x03, 0x2F)
#define REG_BKF003_2F_H      _PK_H_(0x03, 0x2F)
#define REG_BKF003_30_L      _PK_L_(0x03, 0x30)
#define REG_BKF003_30_H      _PK_H_(0x03, 0x30)
#define REG_BKF003_31_L      _PK_L_(0x03, 0x31)
#define REG_BKF003_31_H      _PK_H_(0x03, 0x31)
#define REG_BKF003_32_L      _PK_L_(0x03, 0x32)
#define REG_BKF003_32_H      _PK_H_(0x03, 0x32)
#define REG_BKF003_33_L      _PK_L_(0x03, 0x33)
#define REG_BKF003_33_H      _PK_H_(0x03, 0x33)
#define REG_BKF003_34_L      _PK_L_(0x03, 0x34)
#define REG_BKF003_34_H      _PK_H_(0x03, 0x34)
#define REG_BKF003_35_L      _PK_L_(0x03, 0x35)
#define REG_BKF003_35_H      _PK_H_(0x03, 0x35)
#define REG_BKF003_36_L      _PK_L_(0x03, 0x36)
#define REG_BKF003_36_H      _PK_H_(0x03, 0x36)
#define REG_BKF003_37_L      _PK_L_(0x03, 0x37)
#define REG_BKF003_37_H      _PK_H_(0x03, 0x37)
#define REG_BKF003_38_L      _PK_L_(0x03, 0x38)
#define REG_BKF003_38_H      _PK_H_(0x03, 0x38)
#define REG_BKF003_39_L      _PK_L_(0x03, 0x39)
#define REG_BKF003_39_H      _PK_H_(0x03, 0x39)
#define REG_BKF003_3A_L      _PK_L_(0x03, 0x3A)
#define REG_BKF003_3A_H      _PK_H_(0x03, 0x3A)
#define REG_BKF003_3B_L      _PK_L_(0x03, 0x3B)
#define REG_BKF003_3B_H      _PK_H_(0x03, 0x3B)
#define REG_BKF003_3C_L      _PK_L_(0x03, 0x3C)
#define REG_BKF003_3C_H      _PK_H_(0x03, 0x3C)
#define REG_BKF003_3D_L      _PK_L_(0x03, 0x3D)
#define REG_BKF003_3D_H      _PK_H_(0x03, 0x3D)
#define REG_BKF003_3E_L      _PK_L_(0x03, 0x3E)
#define REG_BKF003_3E_H      _PK_H_(0x03, 0x3E)
#define REG_BKF003_3F_L      _PK_L_(0x03, 0x3F)
#define REG_BKF003_3F_H      _PK_H_(0x03, 0x3F)
#define REG_BKF003_40_L      _PK_L_(0x03, 0x40)
#define REG_BKF003_40_H      _PK_H_(0x03, 0x40)
#define REG_BKF003_41_L      _PK_L_(0x03, 0x41)
#define REG_BKF003_41_H      _PK_H_(0x03, 0x41)
#define REG_BKF003_42_L      _PK_L_(0x03, 0x42)
#define REG_BKF003_42_H      _PK_H_(0x03, 0x42)
#define REG_BKF003_43_L      _PK_L_(0x03, 0x43)
#define REG_BKF003_43_H      _PK_H_(0x03, 0x43)
#define REG_BKF003_44_L      _PK_L_(0x03, 0x44)
#define REG_BKF003_44_H      _PK_H_(0x03, 0x44)
#define REG_BKF003_45_L      _PK_L_(0x03, 0x45)
#define REG_BKF003_45_H      _PK_H_(0x03, 0x45)
#define REG_BKF003_46_L      _PK_L_(0x03, 0x46)
#define REG_BKF003_46_H      _PK_H_(0x03, 0x46)
#define REG_BKF003_47_L      _PK_L_(0x03, 0x47)
#define REG_BKF003_47_H      _PK_H_(0x03, 0x47)
#define REG_BKF003_48_L      _PK_L_(0x03, 0x48)
#define REG_BKF003_48_H      _PK_H_(0x03, 0x48)
#define REG_BKF003_49_L      _PK_L_(0x03, 0x49)
#define REG_BKF003_49_H      _PK_H_(0x03, 0x49)
#define REG_BKF003_4A_L      _PK_L_(0x03, 0x4A)
#define REG_BKF003_4A_H      _PK_H_(0x03, 0x4A)
#define REG_BKF003_4B_L      _PK_L_(0x03, 0x4B)
#define REG_BKF003_4B_H      _PK_H_(0x03, 0x4B)
#define REG_BKF003_4C_L      _PK_L_(0x03, 0x4C)
#define REG_BKF003_4C_H      _PK_H_(0x03, 0x4C)
#define REG_BKF003_4D_L      _PK_L_(0x03, 0x4D)
#define REG_BKF003_4D_H      _PK_H_(0x03, 0x4D)
#define REG_BKF003_4E_L      _PK_L_(0x03, 0x4E)
#define REG_BKF003_4E_H      _PK_H_(0x03, 0x4E)
#define REG_BKF003_4F_L      _PK_L_(0x03, 0x4F)
#define REG_BKF003_4F_H      _PK_H_(0x03, 0x4F)
#define REG_BKF003_50_L      _PK_L_(0x03, 0x50)
#define REG_BKF003_50_H      _PK_H_(0x03, 0x50)
#define REG_BKF003_51_L      _PK_L_(0x03, 0x51)
#define REG_BKF003_51_H      _PK_H_(0x03, 0x51)
#define REG_BKF003_52_L      _PK_L_(0x03, 0x52)
#define REG_BKF003_52_H      _PK_H_(0x03, 0x52)
#define REG_BKF003_53_L      _PK_L_(0x03, 0x53)
#define REG_BKF003_53_H      _PK_H_(0x03, 0x53)
#define REG_BKF003_54_L      _PK_L_(0x03, 0x54)
#define REG_BKF003_54_H      _PK_H_(0x03, 0x54)
#define REG_BKF003_55_L      _PK_L_(0x03, 0x55)
#define REG_BKF003_55_H      _PK_H_(0x03, 0x55)
#define REG_BKF003_56_L      _PK_L_(0x03, 0x56)
#define REG_BKF003_56_H      _PK_H_(0x03, 0x56)
#define REG_BKF003_57_L      _PK_L_(0x03, 0x57)
#define REG_BKF003_57_H      _PK_H_(0x03, 0x57)
#define REG_BKF003_58_L      _PK_L_(0x03, 0x58)
#define REG_BKF003_58_H      _PK_H_(0x03, 0x58)
#define REG_BKF003_59_L      _PK_L_(0x03, 0x59)
#define REG_BKF003_59_H      _PK_H_(0x03, 0x59)
#define REG_BKF003_5A_L      _PK_L_(0x03, 0x5A)
#define REG_BKF003_5A_H      _PK_H_(0x03, 0x5A)
#define REG_BKF003_5B_L      _PK_L_(0x03, 0x5B)
#define REG_BKF003_5B_H      _PK_H_(0x03, 0x5B)
#define REG_BKF003_5C_L      _PK_L_(0x03, 0x5C)
#define REG_BKF003_5C_H      _PK_H_(0x03, 0x5C)
#define REG_BKF003_5D_L      _PK_L_(0x03, 0x5D)
#define REG_BKF003_5D_H      _PK_H_(0x03, 0x5D)
#define REG_BKF003_5E_L      _PK_L_(0x03, 0x5E)
#define REG_BKF003_5E_H      _PK_H_(0x03, 0x5E)
#define REG_BKF003_5F_L      _PK_L_(0x03, 0x5F)
#define REG_BKF003_5F_H      _PK_H_(0x03, 0x5F)
#define REG_BKF003_60_L      _PK_L_(0x03, 0x60)
#define REG_BKF003_60_H      _PK_H_(0x03, 0x60)
#define REG_BKF003_61_L      _PK_L_(0x03, 0x61)
#define REG_BKF003_61_H      _PK_H_(0x03, 0x61)
#define REG_BKF003_62_L      _PK_L_(0x03, 0x62)
#define REG_BKF003_62_H      _PK_H_(0x03, 0x62)
#define REG_BKF003_63_L      _PK_L_(0x03, 0x63)
#define REG_BKF003_63_H      _PK_H_(0x03, 0x63)
#define REG_BKF003_64_L      _PK_L_(0x03, 0x64)
#define REG_BKF003_64_H      _PK_H_(0x03, 0x64)
#define REG_BKF003_65_L      _PK_L_(0x03, 0x65)
#define REG_BKF003_65_H      _PK_H_(0x03, 0x65)
#define REG_BKF003_66_L      _PK_L_(0x03, 0x66)
#define REG_BKF003_66_H      _PK_H_(0x03, 0x66)
#define REG_BKF003_67_L      _PK_L_(0x03, 0x67)
#define REG_BKF003_67_H      _PK_H_(0x03, 0x67)
#define REG_BKF003_68_L      _PK_L_(0x03, 0x68)
#define REG_BKF003_68_H      _PK_H_(0x03, 0x68)
#define REG_BKF003_69_L      _PK_L_(0x03, 0x69)
#define REG_BKF003_69_H      _PK_H_(0x03, 0x69)
#define REG_BKF003_6A_L      _PK_L_(0x03, 0x6A)
#define REG_BKF003_6A_H      _PK_H_(0x03, 0x6A)
#define REG_BKF003_6B_L      _PK_L_(0x03, 0x6B)
#define REG_BKF003_6B_H      _PK_H_(0x03, 0x6B)
#define REG_BKF003_6C_L      _PK_L_(0x03, 0x6C)
#define REG_BKF003_6C_H      _PK_H_(0x03, 0x6C)
#define REG_BKF003_6D_L      _PK_L_(0x03, 0x6D)
#define REG_BKF003_6D_H      _PK_H_(0x03, 0x6D)
#define REG_BKF003_6E_L      _PK_L_(0x03, 0x6E)
#define REG_BKF003_6E_H      _PK_H_(0x03, 0x6E)
#define REG_BKF003_6F_L      _PK_L_(0x03, 0x6F)
#define REG_BKF003_6F_H      _PK_H_(0x03, 0x6F)
#define REG_BKF003_70_L      _PK_L_(0x03, 0x70)
#define REG_BKF003_70_H      _PK_H_(0x03, 0x70)
#define REG_BKF003_71_L      _PK_L_(0x03, 0x71)
#define REG_BKF003_71_H      _PK_H_(0x03, 0x71)
#define REG_BKF003_72_L      _PK_L_(0x03, 0x72)
#define REG_BKF003_72_H      _PK_H_(0x03, 0x72)
#define REG_BKF003_73_L      _PK_L_(0x03, 0x73)
#define REG_BKF003_73_H      _PK_H_(0x03, 0x73)
#define REG_BKF003_74_L      _PK_L_(0x03, 0x74)
#define REG_BKF003_74_H      _PK_H_(0x03, 0x74)
#define REG_BKF003_75_L      _PK_L_(0x03, 0x75)
#define REG_BKF003_75_H      _PK_H_(0x03, 0x75)
#define REG_BKF003_76_L      _PK_L_(0x03, 0x76)
#define REG_BKF003_76_H      _PK_H_(0x03, 0x76)
#define REG_BKF003_77_L      _PK_L_(0x03, 0x77)
#define REG_BKF003_77_H      _PK_H_(0x03, 0x77)
#define REG_BKF003_78_L      _PK_L_(0x03, 0x78)
#define REG_BKF003_78_H      _PK_H_(0x03, 0x78)
#define REG_BKF003_79_L      _PK_L_(0x03, 0x79)
#define REG_BKF003_79_H      _PK_H_(0x03, 0x79)
#define REG_BKF003_7A_L      _PK_L_(0x03, 0x7A)
#define REG_BKF003_7A_H      _PK_H_(0x03, 0x7A)
#define REG_BKF003_7B_L      _PK_L_(0x03, 0x7B)
#define REG_BKF003_7B_H      _PK_H_(0x03, 0x7B)
#define REG_BKF003_7C_L      _PK_L_(0x03, 0x7C)
#define REG_BKF003_7C_H      _PK_H_(0x03, 0x7C)
#define REG_BKF003_7D_L      _PK_L_(0x03, 0x7D)
#define REG_BKF003_7D_H      _PK_H_(0x03, 0x7D)
#define REG_BKF003_7E_L      _PK_L_(0x03, 0x7E)
#define REG_BKF003_7E_H      _PK_H_(0x03, 0x7E)
#define REG_BKF003_7F_L      _PK_L_(0x03, 0x7F)
#define REG_BKF003_7F_H      _PK_H_(0x03, 0x7F)
//----------------------------------------------
#define REG_BKF004_00_L      _PK_L_(0x04, 0x00)
#define REG_BKF004_00_H      _PK_H_(0x04, 0x00)
#define REG_BKF004_01_L      _PK_L_(0x04, 0x01)
#define REG_BKF004_01_H      _PK_H_(0x04, 0x01)
#define REG_BKF004_02_L      _PK_L_(0x04, 0x02)
#define REG_BKF004_02_H      _PK_H_(0x04, 0x02)
#define REG_BKF004_03_L      _PK_L_(0x04, 0x03)
#define REG_BKF004_03_H      _PK_H_(0x04, 0x03)
#define REG_BKF004_04_L      _PK_L_(0x04, 0x04)
#define REG_BKF004_04_H      _PK_H_(0x04, 0x04)
#define REG_BKF004_05_L      _PK_L_(0x04, 0x05)
#define REG_BKF004_05_H      _PK_H_(0x04, 0x05)
#define REG_BKF004_06_L      _PK_L_(0x04, 0x06)
#define REG_BKF004_06_H      _PK_H_(0x04, 0x06)
#define REG_BKF004_07_L      _PK_L_(0x04, 0x07)
#define REG_BKF004_07_H      _PK_H_(0x04, 0x07)
#define REG_BKF004_08_L      _PK_L_(0x04, 0x08)
#define REG_BKF004_08_H      _PK_H_(0x04, 0x08)
#define REG_BKF004_09_L      _PK_L_(0x04, 0x09)
#define REG_BKF004_09_H      _PK_H_(0x04, 0x09)
#define REG_BKF004_0A_L      _PK_L_(0x04, 0x0A)
#define REG_BKF004_0A_H      _PK_H_(0x04, 0x0A)
#define REG_BKF004_0B_L      _PK_L_(0x04, 0x0B)
#define REG_BKF004_0B_H      _PK_H_(0x04, 0x0B)
#define REG_BKF004_0C_L      _PK_L_(0x04, 0x0C)
#define REG_BKF004_0C_H      _PK_H_(0x04, 0x0C)
#define REG_BKF004_0D_L      _PK_L_(0x04, 0x0D)
#define REG_BKF004_0D_H      _PK_H_(0x04, 0x0D)
#define REG_BKF004_0E_L      _PK_L_(0x04, 0x0E)
#define REG_BKF004_0E_H      _PK_H_(0x04, 0x0E)
#define REG_BKF004_0F_L      _PK_L_(0x04, 0x0F)
#define REG_BKF004_0F_H      _PK_H_(0x04, 0x0F)
#define REG_BKF004_10_L      _PK_L_(0x04, 0x10)
#define REG_BKF004_10_H      _PK_H_(0x04, 0x10)
#define REG_BKF004_11_L      _PK_L_(0x04, 0x11)
#define REG_BKF004_11_H      _PK_H_(0x04, 0x11)
#define REG_BKF004_12_L      _PK_L_(0x04, 0x12)
#define REG_BKF004_12_H      _PK_H_(0x04, 0x12)
#define REG_BKF004_13_L      _PK_L_(0x04, 0x13)
#define REG_BKF004_13_H      _PK_H_(0x04, 0x13)
#define REG_BKF004_14_L      _PK_L_(0x04, 0x14)
#define REG_BKF004_14_H      _PK_H_(0x04, 0x14)
#define REG_BKF004_15_L      _PK_L_(0x04, 0x15)
#define REG_BKF004_15_H      _PK_H_(0x04, 0x15)
#define REG_BKF004_16_L      _PK_L_(0x04, 0x16)
#define REG_BKF004_16_H      _PK_H_(0x04, 0x16)
#define REG_BKF004_17_L      _PK_L_(0x04, 0x17)
#define REG_BKF004_17_H      _PK_H_(0x04, 0x17)
#define REG_BKF004_18_L      _PK_L_(0x04, 0x18)
#define REG_BKF004_18_H      _PK_H_(0x04, 0x18)
#define REG_BKF004_19_L      _PK_L_(0x04, 0x19)
#define REG_BKF004_19_H      _PK_H_(0x04, 0x19)
#define REG_BKF004_1A_L      _PK_L_(0x04, 0x1A)
#define REG_BKF004_1A_H      _PK_H_(0x04, 0x1A)
#define REG_BKF004_1B_L      _PK_L_(0x04, 0x1B)
#define REG_BKF004_1B_H      _PK_H_(0x04, 0x1B)
#define REG_BKF004_1C_L      _PK_L_(0x04, 0x1C)
#define REG_BKF004_1C_H      _PK_H_(0x04, 0x1C)
#define REG_BKF004_1D_L      _PK_L_(0x04, 0x1D)
#define REG_BKF004_1D_H      _PK_H_(0x04, 0x1D)
#define REG_BKF004_1E_L      _PK_L_(0x04, 0x1E)
#define REG_BKF004_1E_H      _PK_H_(0x04, 0x1E)
#define REG_BKF004_1F_L      _PK_L_(0x04, 0x1F)
#define REG_BKF004_1F_H      _PK_H_(0x04, 0x1F)
#define REG_BKF004_20_L      _PK_L_(0x04, 0x20)
#define REG_BKF004_20_H      _PK_H_(0x04, 0x20)
#define REG_BKF004_21_L      _PK_L_(0x04, 0x21)
#define REG_BKF004_21_H      _PK_H_(0x04, 0x21)
#define REG_BKF004_22_L      _PK_L_(0x04, 0x22)
#define REG_BKF004_22_H      _PK_H_(0x04, 0x22)
#define REG_BKF004_23_L      _PK_L_(0x04, 0x23)
#define REG_BKF004_23_H      _PK_H_(0x04, 0x23)
#define REG_BKF004_24_L      _PK_L_(0x04, 0x24)
#define REG_BKF004_24_H      _PK_H_(0x04, 0x24)
#define REG_BKF004_25_L      _PK_L_(0x04, 0x25)
#define REG_BKF004_25_H      _PK_H_(0x04, 0x25)
#define REG_BKF004_26_L      _PK_L_(0x04, 0x26)
#define REG_BKF004_26_H      _PK_H_(0x04, 0x26)
#define REG_BKF004_27_L      _PK_L_(0x04, 0x27)
#define REG_BKF004_27_H      _PK_H_(0x04, 0x27)
#define REG_BKF004_28_L      _PK_L_(0x04, 0x28)
#define REG_BKF004_28_H      _PK_H_(0x04, 0x28)
#define REG_BKF004_29_L      _PK_L_(0x04, 0x29)
#define REG_BKF004_29_H      _PK_H_(0x04, 0x29)
#define REG_BKF004_2A_L      _PK_L_(0x04, 0x2A)
#define REG_BKF004_2A_H      _PK_H_(0x04, 0x2A)
#define REG_BKF004_2B_L      _PK_L_(0x04, 0x2B)
#define REG_BKF004_2B_H      _PK_H_(0x04, 0x2B)
#define REG_BKF004_2C_L      _PK_L_(0x04, 0x2C)
#define REG_BKF004_2C_H      _PK_H_(0x04, 0x2C)
#define REG_BKF004_2D_L      _PK_L_(0x04, 0x2D)
#define REG_BKF004_2D_H      _PK_H_(0x04, 0x2D)
#define REG_BKF004_2E_L      _PK_L_(0x04, 0x2E)
#define REG_BKF004_2E_H      _PK_H_(0x04, 0x2E)
#define REG_BKF004_2F_L      _PK_L_(0x04, 0x2F)
#define REG_BKF004_2F_H      _PK_H_(0x04, 0x2F)
#define REG_BKF004_30_L      _PK_L_(0x04, 0x30)
#define REG_BKF004_30_H      _PK_H_(0x04, 0x30)
#define REG_BKF004_31_L      _PK_L_(0x04, 0x31)
#define REG_BKF004_31_H      _PK_H_(0x04, 0x31)
#define REG_BKF004_32_L      _PK_L_(0x04, 0x32)
#define REG_BKF004_32_H      _PK_H_(0x04, 0x32)
#define REG_BKF004_33_L      _PK_L_(0x04, 0x33)
#define REG_BKF004_33_H      _PK_H_(0x04, 0x33)
#define REG_BKF004_34_L      _PK_L_(0x04, 0x34)
#define REG_BKF004_34_H      _PK_H_(0x04, 0x34)
#define REG_BKF004_35_L      _PK_L_(0x04, 0x35)
#define REG_BKF004_35_H      _PK_H_(0x04, 0x35)
#define REG_BKF004_36_L      _PK_L_(0x04, 0x36)
#define REG_BKF004_36_H      _PK_H_(0x04, 0x36)
#define REG_BKF004_37_L      _PK_L_(0x04, 0x37)
#define REG_BKF004_37_H      _PK_H_(0x04, 0x37)
#define REG_BKF004_38_L      _PK_L_(0x04, 0x38)
#define REG_BKF004_38_H      _PK_H_(0x04, 0x38)
#define REG_BKF004_39_L      _PK_L_(0x04, 0x39)
#define REG_BKF004_39_H      _PK_H_(0x04, 0x39)
#define REG_BKF004_3A_L      _PK_L_(0x04, 0x3A)
#define REG_BKF004_3A_H      _PK_H_(0x04, 0x3A)
#define REG_BKF004_3B_L      _PK_L_(0x04, 0x3B)
#define REG_BKF004_3B_H      _PK_H_(0x04, 0x3B)
#define REG_BKF004_3C_L      _PK_L_(0x04, 0x3C)
#define REG_BKF004_3C_H      _PK_H_(0x04, 0x3C)
#define REG_BKF004_3D_L      _PK_L_(0x04, 0x3D)
#define REG_BKF004_3D_H      _PK_H_(0x04, 0x3D)
#define REG_BKF004_3E_L      _PK_L_(0x04, 0x3E)
#define REG_BKF004_3E_H      _PK_H_(0x04, 0x3E)
#define REG_BKF004_3F_L      _PK_L_(0x04, 0x3F)
#define REG_BKF004_3F_H      _PK_H_(0x04, 0x3F)
#define REG_BKF004_40_L      _PK_L_(0x04, 0x40)
#define REG_BKF004_40_H      _PK_H_(0x04, 0x40)
#define REG_BKF004_41_L      _PK_L_(0x04, 0x41)
#define REG_BKF004_41_H      _PK_H_(0x04, 0x41)
#define REG_BKF004_42_L      _PK_L_(0x04, 0x42)
#define REG_BKF004_42_H      _PK_H_(0x04, 0x42)
#define REG_BKF004_43_L      _PK_L_(0x04, 0x43)
#define REG_BKF004_43_H      _PK_H_(0x04, 0x43)
#define REG_BKF004_44_L      _PK_L_(0x04, 0x44)
#define REG_BKF004_44_H      _PK_H_(0x04, 0x44)
#define REG_BKF004_45_L      _PK_L_(0x04, 0x45)
#define REG_BKF004_45_H      _PK_H_(0x04, 0x45)
#define REG_BKF004_46_L      _PK_L_(0x04, 0x46)
#define REG_BKF004_46_H      _PK_H_(0x04, 0x46)
#define REG_BKF004_47_L      _PK_L_(0x04, 0x47)
#define REG_BKF004_47_H      _PK_H_(0x04, 0x47)
#define REG_BKF004_48_L      _PK_L_(0x04, 0x48)
#define REG_BKF004_48_H      _PK_H_(0x04, 0x48)
#define REG_BKF004_49_L      _PK_L_(0x04, 0x49)
#define REG_BKF004_49_H      _PK_H_(0x04, 0x49)
#define REG_BKF004_4A_L      _PK_L_(0x04, 0x4A)
#define REG_BKF004_4A_H      _PK_H_(0x04, 0x4A)
#define REG_BKF004_4B_L      _PK_L_(0x04, 0x4B)
#define REG_BKF004_4B_H      _PK_H_(0x04, 0x4B)
#define REG_BKF004_4C_L      _PK_L_(0x04, 0x4C)
#define REG_BKF004_4C_H      _PK_H_(0x04, 0x4C)
#define REG_BKF004_4D_L      _PK_L_(0x04, 0x4D)
#define REG_BKF004_4D_H      _PK_H_(0x04, 0x4D)
#define REG_BKF004_4E_L      _PK_L_(0x04, 0x4E)
#define REG_BKF004_4E_H      _PK_H_(0x04, 0x4E)
#define REG_BKF004_4F_L      _PK_L_(0x04, 0x4F)
#define REG_BKF004_4F_H      _PK_H_(0x04, 0x4F)
#define REG_BKF004_50_L      _PK_L_(0x04, 0x50)
#define REG_BKF004_50_H      _PK_H_(0x04, 0x50)
#define REG_BKF004_51_L      _PK_L_(0x04, 0x51)
#define REG_BKF004_51_H      _PK_H_(0x04, 0x51)
#define REG_BKF004_52_L      _PK_L_(0x04, 0x52)
#define REG_BKF004_52_H      _PK_H_(0x04, 0x52)
#define REG_BKF004_53_L      _PK_L_(0x04, 0x53)
#define REG_BKF004_53_H      _PK_H_(0x04, 0x53)
#define REG_BKF004_54_L      _PK_L_(0x04, 0x54)
#define REG_BKF004_54_H      _PK_H_(0x04, 0x54)
#define REG_BKF004_55_L      _PK_L_(0x04, 0x55)
#define REG_BKF004_55_H      _PK_H_(0x04, 0x55)
#define REG_BKF004_56_L      _PK_L_(0x04, 0x56)
#define REG_BKF004_56_H      _PK_H_(0x04, 0x56)
#define REG_BKF004_57_L      _PK_L_(0x04, 0x57)
#define REG_BKF004_57_H      _PK_H_(0x04, 0x57)
#define REG_BKF004_58_L      _PK_L_(0x04, 0x58)
#define REG_BKF004_58_H      _PK_H_(0x04, 0x58)
#define REG_BKF004_59_L      _PK_L_(0x04, 0x59)
#define REG_BKF004_59_H      _PK_H_(0x04, 0x59)
#define REG_BKF004_5A_L      _PK_L_(0x04, 0x5A)
#define REG_BKF004_5A_H      _PK_H_(0x04, 0x5A)
#define REG_BKF004_5B_L      _PK_L_(0x04, 0x5B)
#define REG_BKF004_5B_H      _PK_H_(0x04, 0x5B)
#define REG_BKF004_5C_L      _PK_L_(0x04, 0x5C)
#define REG_BKF004_5C_H      _PK_H_(0x04, 0x5C)
#define REG_BKF004_5D_L      _PK_L_(0x04, 0x5D)
#define REG_BKF004_5D_H      _PK_H_(0x04, 0x5D)
#define REG_BKF004_5E_L      _PK_L_(0x04, 0x5E)
#define REG_BKF004_5E_H      _PK_H_(0x04, 0x5E)
#define REG_BKF004_5F_L      _PK_L_(0x04, 0x5F)
#define REG_BKF004_5F_H      _PK_H_(0x04, 0x5F)
#define REG_BKF004_60_L      _PK_L_(0x04, 0x60)
#define REG_BKF004_60_H      _PK_H_(0x04, 0x60)
#define REG_BKF004_61_L      _PK_L_(0x04, 0x61)
#define REG_BKF004_61_H      _PK_H_(0x04, 0x61)
#define REG_BKF004_62_L      _PK_L_(0x04, 0x62)
#define REG_BKF004_62_H      _PK_H_(0x04, 0x62)
#define REG_BKF004_63_L      _PK_L_(0x04, 0x63)
#define REG_BKF004_63_H      _PK_H_(0x04, 0x63)
#define REG_BKF004_64_L      _PK_L_(0x04, 0x64)
#define REG_BKF004_64_H      _PK_H_(0x04, 0x64)
#define REG_BKF004_65_L      _PK_L_(0x04, 0x65)
#define REG_BKF004_65_H      _PK_H_(0x04, 0x65)
#define REG_BKF004_66_L      _PK_L_(0x04, 0x66)
#define REG_BKF004_66_H      _PK_H_(0x04, 0x66)
#define REG_BKF004_67_L      _PK_L_(0x04, 0x67)
#define REG_BKF004_67_H      _PK_H_(0x04, 0x67)
#define REG_BKF004_68_L      _PK_L_(0x04, 0x68)
#define REG_BKF004_68_H      _PK_H_(0x04, 0x68)
#define REG_BKF004_69_L      _PK_L_(0x04, 0x69)
#define REG_BKF004_69_H      _PK_H_(0x04, 0x69)
#define REG_BKF004_6A_L      _PK_L_(0x04, 0x6A)
#define REG_BKF004_6A_H      _PK_H_(0x04, 0x6A)
#define REG_BKF004_6B_L      _PK_L_(0x04, 0x6B)
#define REG_BKF004_6B_H      _PK_H_(0x04, 0x6B)
#define REG_BKF004_6C_L      _PK_L_(0x04, 0x6C)
#define REG_BKF004_6C_H      _PK_H_(0x04, 0x6C)
#define REG_BKF004_6D_L      _PK_L_(0x04, 0x6D)
#define REG_BKF004_6D_H      _PK_H_(0x04, 0x6D)
#define REG_BKF004_6E_L      _PK_L_(0x04, 0x6E)
#define REG_BKF004_6E_H      _PK_H_(0x04, 0x6E)
#define REG_BKF004_6F_L      _PK_L_(0x04, 0x6F)
#define REG_BKF004_6F_H      _PK_H_(0x04, 0x6F)
#define REG_BKF004_70_L      _PK_L_(0x04, 0x70)
#define REG_BKF004_70_H      _PK_H_(0x04, 0x70)
#define REG_BKF004_71_L      _PK_L_(0x04, 0x71)
#define REG_BKF004_71_H      _PK_H_(0x04, 0x71)
#define REG_BKF004_72_L      _PK_L_(0x04, 0x72)
#define REG_BKF004_72_H      _PK_H_(0x04, 0x72)
#define REG_BKF004_73_L      _PK_L_(0x04, 0x73)
#define REG_BKF004_73_H      _PK_H_(0x04, 0x73)
#define REG_BKF004_74_L      _PK_L_(0x04, 0x74)
#define REG_BKF004_74_H      _PK_H_(0x04, 0x74)
#define REG_BKF004_75_L      _PK_L_(0x04, 0x75)
#define REG_BKF004_75_H      _PK_H_(0x04, 0x75)
#define REG_BKF004_76_L      _PK_L_(0x04, 0x76)
#define REG_BKF004_76_H      _PK_H_(0x04, 0x76)
#define REG_BKF004_77_L      _PK_L_(0x04, 0x77)
#define REG_BKF004_77_H      _PK_H_(0x04, 0x77)
#define REG_BKF004_78_L      _PK_L_(0x04, 0x78)
#define REG_BKF004_78_H      _PK_H_(0x04, 0x78)
#define REG_BKF004_79_L      _PK_L_(0x04, 0x79)
#define REG_BKF004_79_H      _PK_H_(0x04, 0x79)
#define REG_BKF004_7A_L      _PK_L_(0x04, 0x7A)
#define REG_BKF004_7A_H      _PK_H_(0x04, 0x7A)
#define REG_BKF004_7B_L      _PK_L_(0x04, 0x7B)
#define REG_BKF004_7B_H      _PK_H_(0x04, 0x7B)
#define REG_BKF004_7C_L      _PK_L_(0x04, 0x7C)
#define REG_BKF004_7C_H      _PK_H_(0x04, 0x7C)
#define REG_BKF004_7D_L      _PK_L_(0x04, 0x7D)
#define REG_BKF004_7D_H      _PK_H_(0x04, 0x7D)
#define REG_BKF004_7E_L      _PK_L_(0x04, 0x7E)
#define REG_BKF004_7E_H      _PK_H_(0x04, 0x7E)
#define REG_BKF004_7F_L      _PK_L_(0x04, 0x7F)
#define REG_BKF004_7F_H      _PK_H_(0x04, 0x7F)
//----------------------------------------------
#define REG_BKF005_00_L      _PK_L_(0x05, 0x00)
#define REG_BKF005_00_H      _PK_H_(0x05, 0x00)
#define REG_BKF005_01_L      _PK_L_(0x05, 0x01)
#define REG_BKF005_01_H      _PK_H_(0x05, 0x01)
#define REG_BKF005_02_L      _PK_L_(0x05, 0x02)
#define REG_BKF005_02_H      _PK_H_(0x05, 0x02)
#define REG_BKF005_03_L      _PK_L_(0x05, 0x03)
#define REG_BKF005_03_H      _PK_H_(0x05, 0x03)
#define REG_BKF005_04_L      _PK_L_(0x05, 0x04)
#define REG_BKF005_04_H      _PK_H_(0x05, 0x04)
#define REG_BKF005_05_L      _PK_L_(0x05, 0x05)
#define REG_BKF005_05_H      _PK_H_(0x05, 0x05)
#define REG_BKF005_06_L      _PK_L_(0x05, 0x06)
#define REG_BKF005_06_H      _PK_H_(0x05, 0x06)
#define REG_BKF005_07_L      _PK_L_(0x05, 0x07)
#define REG_BKF005_07_H      _PK_H_(0x05, 0x07)
#define REG_BKF005_08_L      _PK_L_(0x05, 0x08)
#define REG_BKF005_08_H      _PK_H_(0x05, 0x08)
#define REG_BKF005_09_L      _PK_L_(0x05, 0x09)
#define REG_BKF005_09_H      _PK_H_(0x05, 0x09)
#define REG_BKF005_0A_L      _PK_L_(0x05, 0x0A)
#define REG_BKF005_0A_H      _PK_H_(0x05, 0x0A)
#define REG_BKF005_0B_L      _PK_L_(0x05, 0x0B)
#define REG_BKF005_0B_H      _PK_H_(0x05, 0x0B)
#define REG_BKF005_0C_L      _PK_L_(0x05, 0x0C)
#define REG_BKF005_0C_H      _PK_H_(0x05, 0x0C)
#define REG_BKF005_0D_L      _PK_L_(0x05, 0x0D)
#define REG_BKF005_0D_H      _PK_H_(0x05, 0x0D)
#define REG_BKF005_0E_L      _PK_L_(0x05, 0x0E)
#define REG_BKF005_0E_H      _PK_H_(0x05, 0x0E)
#define REG_BKF005_0F_L      _PK_L_(0x05, 0x0F)
#define REG_BKF005_0F_H      _PK_H_(0x05, 0x0F)
#define REG_BKF005_10_L      _PK_L_(0x05, 0x10)
#define REG_BKF005_10_H      _PK_H_(0x05, 0x10)
#define REG_BKF005_11_L      _PK_L_(0x05, 0x11)
#define REG_BKF005_11_H      _PK_H_(0x05, 0x11)
#define REG_BKF005_12_L      _PK_L_(0x05, 0x12)
#define REG_BKF005_12_H      _PK_H_(0x05, 0x12)
#define REG_BKF005_13_L      _PK_L_(0x05, 0x13)
#define REG_BKF005_13_H      _PK_H_(0x05, 0x13)
#define REG_BKF005_14_L      _PK_L_(0x05, 0x14)
#define REG_BKF005_14_H      _PK_H_(0x05, 0x14)
#define REG_BKF005_15_L      _PK_L_(0x05, 0x15)
#define REG_BKF005_15_H      _PK_H_(0x05, 0x15)
#define REG_BKF005_16_L      _PK_L_(0x05, 0x16)
#define REG_BKF005_16_H      _PK_H_(0x05, 0x16)
#define REG_BKF005_17_L      _PK_L_(0x05, 0x17)
#define REG_BKF005_17_H      _PK_H_(0x05, 0x17)
#define REG_BKF005_18_L      _PK_L_(0x05, 0x18)
#define REG_BKF005_18_H      _PK_H_(0x05, 0x18)
#define REG_BKF005_19_L      _PK_L_(0x05, 0x19)
#define REG_BKF005_19_H      _PK_H_(0x05, 0x19)
#define REG_BKF005_1A_L      _PK_L_(0x05, 0x1A)
#define REG_BKF005_1A_H      _PK_H_(0x05, 0x1A)
#define REG_BKF005_1B_L      _PK_L_(0x05, 0x1B)
#define REG_BKF005_1B_H      _PK_H_(0x05, 0x1B)
#define REG_BKF005_1C_L      _PK_L_(0x05, 0x1C)
#define REG_BKF005_1C_H      _PK_H_(0x05, 0x1C)
#define REG_BKF005_1D_L      _PK_L_(0x05, 0x1D)
#define REG_BKF005_1D_H      _PK_H_(0x05, 0x1D)
#define REG_BKF005_1E_L      _PK_L_(0x05, 0x1E)
#define REG_BKF005_1E_H      _PK_H_(0x05, 0x1E)
#define REG_BKF005_1F_L      _PK_L_(0x05, 0x1F)
#define REG_BKF005_1F_H      _PK_H_(0x05, 0x1F)
#define REG_BKF005_20_L      _PK_L_(0x05, 0x20)
#define REG_BKF005_20_H      _PK_H_(0x05, 0x20)
#define REG_BKF005_21_L      _PK_L_(0x05, 0x21)
#define REG_BKF005_21_H      _PK_H_(0x05, 0x21)
#define REG_BKF005_22_L      _PK_L_(0x05, 0x22)
#define REG_BKF005_22_H      _PK_H_(0x05, 0x22)
#define REG_BKF005_23_L      _PK_L_(0x05, 0x23)
#define REG_BKF005_23_H      _PK_H_(0x05, 0x23)
#define REG_BKF005_24_L      _PK_L_(0x05, 0x24)
#define REG_BKF005_24_H      _PK_H_(0x05, 0x24)
#define REG_BKF005_25_L      _PK_L_(0x05, 0x25)
#define REG_BKF005_25_H      _PK_H_(0x05, 0x25)
#define REG_BKF005_26_L      _PK_L_(0x05, 0x26)
#define REG_BKF005_26_H      _PK_H_(0x05, 0x26)
#define REG_BKF005_27_L      _PK_L_(0x05, 0x27)
#define REG_BKF005_27_H      _PK_H_(0x05, 0x27)
#define REG_BKF005_28_L      _PK_L_(0x05, 0x28)
#define REG_BKF005_28_H      _PK_H_(0x05, 0x28)
#define REG_BKF005_29_L      _PK_L_(0x05, 0x29)
#define REG_BKF005_29_H      _PK_H_(0x05, 0x29)
#define REG_BKF005_2A_L      _PK_L_(0x05, 0x2A)
#define REG_BKF005_2A_H      _PK_H_(0x05, 0x2A)
#define REG_BKF005_2B_L      _PK_L_(0x05, 0x2B)
#define REG_BKF005_2B_H      _PK_H_(0x05, 0x2B)
#define REG_BKF005_2C_L      _PK_L_(0x05, 0x2C)
#define REG_BKF005_2C_H      _PK_H_(0x05, 0x2C)
#define REG_BKF005_2D_L      _PK_L_(0x05, 0x2D)
#define REG_BKF005_2D_H      _PK_H_(0x05, 0x2D)
#define REG_BKF005_2E_L      _PK_L_(0x05, 0x2E)
#define REG_BKF005_2E_H      _PK_H_(0x05, 0x2E)
#define REG_BKF005_2F_L      _PK_L_(0x05, 0x2F)
#define REG_BKF005_2F_H      _PK_H_(0x05, 0x2F)
#define REG_BKF005_30_L      _PK_L_(0x05, 0x30)
#define REG_BKF005_30_H      _PK_H_(0x05, 0x30)
#define REG_BKF005_31_L      _PK_L_(0x05, 0x31)
#define REG_BKF005_31_H      _PK_H_(0x05, 0x31)
#define REG_BKF005_32_L      _PK_L_(0x05, 0x32)
#define REG_BKF005_32_H      _PK_H_(0x05, 0x32)
#define REG_BKF005_33_L      _PK_L_(0x05, 0x33)
#define REG_BKF005_33_H      _PK_H_(0x05, 0x33)
#define REG_BKF005_34_L      _PK_L_(0x05, 0x34)
#define REG_BKF005_34_H      _PK_H_(0x05, 0x34)
#define REG_BKF005_35_L      _PK_L_(0x05, 0x35)
#define REG_BKF005_35_H      _PK_H_(0x05, 0x35)
#define REG_BKF005_36_L      _PK_L_(0x05, 0x36)
#define REG_BKF005_36_H      _PK_H_(0x05, 0x36)
#define REG_BKF005_37_L      _PK_L_(0x05, 0x37)
#define REG_BKF005_37_H      _PK_H_(0x05, 0x37)
#define REG_BKF005_38_L      _PK_L_(0x05, 0x38)
#define REG_BKF005_38_H      _PK_H_(0x05, 0x38)
#define REG_BKF005_39_L      _PK_L_(0x05, 0x39)
#define REG_BKF005_39_H      _PK_H_(0x05, 0x39)
#define REG_BKF005_3A_L      _PK_L_(0x05, 0x3A)
#define REG_BKF005_3A_H      _PK_H_(0x05, 0x3A)
#define REG_BKF005_3B_L      _PK_L_(0x05, 0x3B)
#define REG_BKF005_3B_H      _PK_H_(0x05, 0x3B)
#define REG_BKF005_3C_L      _PK_L_(0x05, 0x3C)
#define REG_BKF005_3C_H      _PK_H_(0x05, 0x3C)
#define REG_BKF005_3D_L      _PK_L_(0x05, 0x3D)
#define REG_BKF005_3D_H      _PK_H_(0x05, 0x3D)
#define REG_BKF005_3E_L      _PK_L_(0x05, 0x3E)
#define REG_BKF005_3E_H      _PK_H_(0x05, 0x3E)
#define REG_BKF005_3F_L      _PK_L_(0x05, 0x3F)
#define REG_BKF005_3F_H      _PK_H_(0x05, 0x3F)
#define REG_BKF005_40_L      _PK_L_(0x05, 0x40)
#define REG_BKF005_40_H      _PK_H_(0x05, 0x40)
#define REG_BKF005_41_L      _PK_L_(0x05, 0x41)
#define REG_BKF005_41_H      _PK_H_(0x05, 0x41)
#define REG_BKF005_42_L      _PK_L_(0x05, 0x42)
#define REG_BKF005_42_H      _PK_H_(0x05, 0x42)
#define REG_BKF005_43_L      _PK_L_(0x05, 0x43)
#define REG_BKF005_43_H      _PK_H_(0x05, 0x43)
#define REG_BKF005_44_L      _PK_L_(0x05, 0x44)
#define REG_BKF005_44_H      _PK_H_(0x05, 0x44)
#define REG_BKF005_45_L      _PK_L_(0x05, 0x45)
#define REG_BKF005_45_H      _PK_H_(0x05, 0x45)
#define REG_BKF005_46_L      _PK_L_(0x05, 0x46)
#define REG_BKF005_46_H      _PK_H_(0x05, 0x46)
#define REG_BKF005_47_L      _PK_L_(0x05, 0x47)
#define REG_BKF005_47_H      _PK_H_(0x05, 0x47)
#define REG_BKF005_48_L      _PK_L_(0x05, 0x48)
#define REG_BKF005_48_H      _PK_H_(0x05, 0x48)
#define REG_BKF005_49_L      _PK_L_(0x05, 0x49)
#define REG_BKF005_49_H      _PK_H_(0x05, 0x49)
#define REG_BKF005_4A_L      _PK_L_(0x05, 0x4A)
#define REG_BKF005_4A_H      _PK_H_(0x05, 0x4A)
#define REG_BKF005_4B_L      _PK_L_(0x05, 0x4B)
#define REG_BKF005_4B_H      _PK_H_(0x05, 0x4B)
#define REG_BKF005_4C_L      _PK_L_(0x05, 0x4C)
#define REG_BKF005_4C_H      _PK_H_(0x05, 0x4C)
#define REG_BKF005_4D_L      _PK_L_(0x05, 0x4D)
#define REG_BKF005_4D_H      _PK_H_(0x05, 0x4D)
#define REG_BKF005_4E_L      _PK_L_(0x05, 0x4E)
#define REG_BKF005_4E_H      _PK_H_(0x05, 0x4E)
#define REG_BKF005_4F_L      _PK_L_(0x05, 0x4F)
#define REG_BKF005_4F_H      _PK_H_(0x05, 0x4F)
#define REG_BKF005_50_L      _PK_L_(0x05, 0x50)
#define REG_BKF005_50_H      _PK_H_(0x05, 0x50)
#define REG_BKF005_51_L      _PK_L_(0x05, 0x51)
#define REG_BKF005_51_H      _PK_H_(0x05, 0x51)
#define REG_BKF005_52_L      _PK_L_(0x05, 0x52)
#define REG_BKF005_52_H      _PK_H_(0x05, 0x52)
#define REG_BKF005_53_L      _PK_L_(0x05, 0x53)
#define REG_BKF005_53_H      _PK_H_(0x05, 0x53)
#define REG_BKF005_54_L      _PK_L_(0x05, 0x54)
#define REG_BKF005_54_H      _PK_H_(0x05, 0x54)
#define REG_BKF005_55_L      _PK_L_(0x05, 0x55)
#define REG_BKF005_55_H      _PK_H_(0x05, 0x55)
#define REG_BKF005_56_L      _PK_L_(0x05, 0x56)
#define REG_BKF005_56_H      _PK_H_(0x05, 0x56)
#define REG_BKF005_57_L      _PK_L_(0x05, 0x57)
#define REG_BKF005_57_H      _PK_H_(0x05, 0x57)
#define REG_BKF005_58_L      _PK_L_(0x05, 0x58)
#define REG_BKF005_58_H      _PK_H_(0x05, 0x58)
#define REG_BKF005_59_L      _PK_L_(0x05, 0x59)
#define REG_BKF005_59_H      _PK_H_(0x05, 0x59)
#define REG_BKF005_5A_L      _PK_L_(0x05, 0x5A)
#define REG_BKF005_5A_H      _PK_H_(0x05, 0x5A)
#define REG_BKF005_5B_L      _PK_L_(0x05, 0x5B)
#define REG_BKF005_5B_H      _PK_H_(0x05, 0x5B)
#define REG_BKF005_5C_L      _PK_L_(0x05, 0x5C)
#define REG_BKF005_5C_H      _PK_H_(0x05, 0x5C)
#define REG_BKF005_5D_L      _PK_L_(0x05, 0x5D)
#define REG_BKF005_5D_H      _PK_H_(0x05, 0x5D)
#define REG_BKF005_5E_L      _PK_L_(0x05, 0x5E)
#define REG_BKF005_5E_H      _PK_H_(0x05, 0x5E)
#define REG_BKF005_5F_L      _PK_L_(0x05, 0x5F)
#define REG_BKF005_5F_H      _PK_H_(0x05, 0x5F)
#define REG_BKF005_60_L      _PK_L_(0x05, 0x60)
#define REG_BKF005_60_H      _PK_H_(0x05, 0x60)
#define REG_BKF005_61_L      _PK_L_(0x05, 0x61)
#define REG_BKF005_61_H      _PK_H_(0x05, 0x61)
#define REG_BKF005_62_L      _PK_L_(0x05, 0x62)
#define REG_BKF005_62_H      _PK_H_(0x05, 0x62)
#define REG_BKF005_63_L      _PK_L_(0x05, 0x63)
#define REG_BKF005_63_H      _PK_H_(0x05, 0x63)
#define REG_BKF005_64_L      _PK_L_(0x05, 0x64)
#define REG_BKF005_64_H      _PK_H_(0x05, 0x64)
#define REG_BKF005_65_L      _PK_L_(0x05, 0x65)
#define REG_BKF005_65_H      _PK_H_(0x05, 0x65)
#define REG_BKF005_66_L      _PK_L_(0x05, 0x66)
#define REG_BKF005_66_H      _PK_H_(0x05, 0x66)
#define REG_BKF005_67_L      _PK_L_(0x05, 0x67)
#define REG_BKF005_67_H      _PK_H_(0x05, 0x67)
#define REG_BKF005_68_L      _PK_L_(0x05, 0x68)
#define REG_BKF005_68_H      _PK_H_(0x05, 0x68)
#define REG_BKF005_69_L      _PK_L_(0x05, 0x69)
#define REG_BKF005_69_H      _PK_H_(0x05, 0x69)
#define REG_BKF005_6A_L      _PK_L_(0x05, 0x6A)
#define REG_BKF005_6A_H      _PK_H_(0x05, 0x6A)
#define REG_BKF005_6B_L      _PK_L_(0x05, 0x6B)
#define REG_BKF005_6B_H      _PK_H_(0x05, 0x6B)
#define REG_BKF005_6C_L      _PK_L_(0x05, 0x6C)
#define REG_BKF005_6C_H      _PK_H_(0x05, 0x6C)
#define REG_BKF005_6D_L      _PK_L_(0x05, 0x6D)
#define REG_BKF005_6D_H      _PK_H_(0x05, 0x6D)
#define REG_BKF005_6E_L      _PK_L_(0x05, 0x6E)
#define REG_BKF005_6E_H      _PK_H_(0x05, 0x6E)
#define REG_BKF005_6F_L      _PK_L_(0x05, 0x6F)
#define REG_BKF005_6F_H      _PK_H_(0x05, 0x6F)
#define REG_BKF005_70_L      _PK_L_(0x05, 0x70)
#define REG_BKF005_70_H      _PK_H_(0x05, 0x70)
#define REG_BKF005_71_L      _PK_L_(0x05, 0x71)
#define REG_BKF005_71_H      _PK_H_(0x05, 0x71)
#define REG_BKF005_72_L      _PK_L_(0x05, 0x72)
#define REG_BKF005_72_H      _PK_H_(0x05, 0x72)
#define REG_BKF005_73_L      _PK_L_(0x05, 0x73)
#define REG_BKF005_73_H      _PK_H_(0x05, 0x73)
#define REG_BKF005_74_L      _PK_L_(0x05, 0x74)
#define REG_BKF005_74_H      _PK_H_(0x05, 0x74)
#define REG_BKF005_75_L      _PK_L_(0x05, 0x75)
#define REG_BKF005_75_H      _PK_H_(0x05, 0x75)
#define REG_BKF005_76_L      _PK_L_(0x05, 0x76)
#define REG_BKF005_76_H      _PK_H_(0x05, 0x76)
#define REG_BKF005_77_L      _PK_L_(0x05, 0x77)
#define REG_BKF005_77_H      _PK_H_(0x05, 0x77)
#define REG_BKF005_78_L      _PK_L_(0x05, 0x78)
#define REG_BKF005_78_H      _PK_H_(0x05, 0x78)
#define REG_BKF005_79_L      _PK_L_(0x05, 0x79)
#define REG_BKF005_79_H      _PK_H_(0x05, 0x79)
#define REG_BKF005_7A_L      _PK_L_(0x05, 0x7A)
#define REG_BKF005_7A_H      _PK_H_(0x05, 0x7A)
#define REG_BKF005_7B_L      _PK_L_(0x05, 0x7B)
#define REG_BKF005_7B_H      _PK_H_(0x05, 0x7B)
#define REG_BKF005_7C_L      _PK_L_(0x05, 0x7C)
#define REG_BKF005_7C_H      _PK_H_(0x05, 0x7C)
#define REG_BKF005_7D_L      _PK_L_(0x05, 0x7D)
#define REG_BKF005_7D_H      _PK_H_(0x05, 0x7D)
#define REG_BKF005_7E_L      _PK_L_(0x05, 0x7E)
#define REG_BKF005_7E_H      _PK_H_(0x05, 0x7E)
#define REG_BKF005_7F_L      _PK_L_(0x05, 0x7F)
#define REG_BKF005_7F_H      _PK_H_(0x05, 0x7F)
//----------------------------------------------
#define REG_BKF006_00_L      _PK_L_(0x06, 0x00)
#define REG_BKF006_00_H      _PK_H_(0x06, 0x00)
#define REG_BKF006_01_L      _PK_L_(0x06, 0x01)
#define REG_BKF006_01_H      _PK_H_(0x06, 0x01)
#define REG_BKF006_02_L      _PK_L_(0x06, 0x02)
#define REG_BKF006_02_H      _PK_H_(0x06, 0x02)
#define REG_BKF006_03_L      _PK_L_(0x06, 0x03)
#define REG_BKF006_03_H      _PK_H_(0x06, 0x03)
#define REG_BKF006_04_L      _PK_L_(0x06, 0x04)
#define REG_BKF006_04_H      _PK_H_(0x06, 0x04)
#define REG_BKF006_05_L      _PK_L_(0x06, 0x05)
#define REG_BKF006_05_H      _PK_H_(0x06, 0x05)
#define REG_BKF006_06_L      _PK_L_(0x06, 0x06)
#define REG_BKF006_06_H      _PK_H_(0x06, 0x06)
#define REG_BKF006_07_L      _PK_L_(0x06, 0x07)
#define REG_BKF006_07_H      _PK_H_(0x06, 0x07)
#define REG_BKF006_08_L      _PK_L_(0x06, 0x08)
#define REG_BKF006_08_H      _PK_H_(0x06, 0x08)
#define REG_BKF006_09_L      _PK_L_(0x06, 0x09)
#define REG_BKF006_09_H      _PK_H_(0x06, 0x09)
#define REG_BKF006_0A_L      _PK_L_(0x06, 0x0A)
#define REG_BKF006_0A_H      _PK_H_(0x06, 0x0A)
#define REG_BKF006_0B_L      _PK_L_(0x06, 0x0B)
#define REG_BKF006_0B_H      _PK_H_(0x06, 0x0B)
#define REG_BKF006_0C_L      _PK_L_(0x06, 0x0C)
#define REG_BKF006_0C_H      _PK_H_(0x06, 0x0C)
#define REG_BKF006_0D_L      _PK_L_(0x06, 0x0D)
#define REG_BKF006_0D_H      _PK_H_(0x06, 0x0D)
#define REG_BKF006_0E_L      _PK_L_(0x06, 0x0E)
#define REG_BKF006_0E_H      _PK_H_(0x06, 0x0E)
#define REG_BKF006_0F_L      _PK_L_(0x06, 0x0F)
#define REG_BKF006_0F_H      _PK_H_(0x06, 0x0F)
#define REG_BKF006_10_L      _PK_L_(0x06, 0x10)
#define REG_BKF006_10_H      _PK_H_(0x06, 0x10)
#define REG_BKF006_11_L      _PK_L_(0x06, 0x11)
#define REG_BKF006_11_H      _PK_H_(0x06, 0x11)
#define REG_BKF006_12_L      _PK_L_(0x06, 0x12)
#define REG_BKF006_12_H      _PK_H_(0x06, 0x12)
#define REG_BKF006_13_L      _PK_L_(0x06, 0x13)
#define REG_BKF006_13_H      _PK_H_(0x06, 0x13)
#define REG_BKF006_14_L      _PK_L_(0x06, 0x14)
#define REG_BKF006_14_H      _PK_H_(0x06, 0x14)
#define REG_BKF006_15_L      _PK_L_(0x06, 0x15)
#define REG_BKF006_15_H      _PK_H_(0x06, 0x15)
#define REG_BKF006_16_L      _PK_L_(0x06, 0x16)
#define REG_BKF006_16_H      _PK_H_(0x06, 0x16)
#define REG_BKF006_17_L      _PK_L_(0x06, 0x17)
#define REG_BKF006_17_H      _PK_H_(0x06, 0x17)
#define REG_BKF006_18_L      _PK_L_(0x06, 0x18)
#define REG_BKF006_18_H      _PK_H_(0x06, 0x18)
#define REG_BKF006_19_L      _PK_L_(0x06, 0x19)
#define REG_BKF006_19_H      _PK_H_(0x06, 0x19)
#define REG_BKF006_1A_L      _PK_L_(0x06, 0x1A)
#define REG_BKF006_1A_H      _PK_H_(0x06, 0x1A)
#define REG_BKF006_1B_L      _PK_L_(0x06, 0x1B)
#define REG_BKF006_1B_H      _PK_H_(0x06, 0x1B)
#define REG_BKF006_1C_L      _PK_L_(0x06, 0x1C)
#define REG_BKF006_1C_H      _PK_H_(0x06, 0x1C)
#define REG_BKF006_1D_L      _PK_L_(0x06, 0x1D)
#define REG_BKF006_1D_H      _PK_H_(0x06, 0x1D)
#define REG_BKF006_1E_L      _PK_L_(0x06, 0x1E)
#define REG_BKF006_1E_H      _PK_H_(0x06, 0x1E)
#define REG_BKF006_1F_L      _PK_L_(0x06, 0x1F)
#define REG_BKF006_1F_H      _PK_H_(0x06, 0x1F)
#define REG_BKF006_20_L      _PK_L_(0x06, 0x20)
#define REG_BKF006_20_H      _PK_H_(0x06, 0x20)
#define REG_BKF006_21_L      _PK_L_(0x06, 0x21)
#define REG_BKF006_21_H      _PK_H_(0x06, 0x21)
#define REG_BKF006_22_L      _PK_L_(0x06, 0x22)
#define REG_BKF006_22_H      _PK_H_(0x06, 0x22)
#define REG_BKF006_23_L      _PK_L_(0x06, 0x23)
#define REG_BKF006_23_H      _PK_H_(0x06, 0x23)
#define REG_BKF006_24_L      _PK_L_(0x06, 0x24)
#define REG_BKF006_24_H      _PK_H_(0x06, 0x24)
#define REG_BKF006_25_L      _PK_L_(0x06, 0x25)
#define REG_BKF006_25_H      _PK_H_(0x06, 0x25)
#define REG_BKF006_26_L      _PK_L_(0x06, 0x26)
#define REG_BKF006_26_H      _PK_H_(0x06, 0x26)
#define REG_BKF006_27_L      _PK_L_(0x06, 0x27)
#define REG_BKF006_27_H      _PK_H_(0x06, 0x27)
#define REG_BKF006_28_L      _PK_L_(0x06, 0x28)
#define REG_BKF006_28_H      _PK_H_(0x06, 0x28)
#define REG_BKF006_29_L      _PK_L_(0x06, 0x29)
#define REG_BKF006_29_H      _PK_H_(0x06, 0x29)
#define REG_BKF006_2A_L      _PK_L_(0x06, 0x2A)
#define REG_BKF006_2A_H      _PK_H_(0x06, 0x2A)
#define REG_BKF006_2B_L      _PK_L_(0x06, 0x2B)
#define REG_BKF006_2B_H      _PK_H_(0x06, 0x2B)
#define REG_BKF006_2C_L      _PK_L_(0x06, 0x2C)
#define REG_BKF006_2C_H      _PK_H_(0x06, 0x2C)
#define REG_BKF006_2D_L      _PK_L_(0x06, 0x2D)
#define REG_BKF006_2D_H      _PK_H_(0x06, 0x2D)
#define REG_BKF006_2E_L      _PK_L_(0x06, 0x2E)
#define REG_BKF006_2E_H      _PK_H_(0x06, 0x2E)
#define REG_BKF006_2F_L      _PK_L_(0x06, 0x2F)
#define REG_BKF006_2F_H      _PK_H_(0x06, 0x2F)
#define REG_BKF006_30_L      _PK_L_(0x06, 0x30)
#define REG_BKF006_30_H      _PK_H_(0x06, 0x30)
#define REG_BKF006_31_L      _PK_L_(0x06, 0x31)
#define REG_BKF006_31_H      _PK_H_(0x06, 0x31)
#define REG_BKF006_32_L      _PK_L_(0x06, 0x32)
#define REG_BKF006_32_H      _PK_H_(0x06, 0x32)
#define REG_BKF006_33_L      _PK_L_(0x06, 0x33)
#define REG_BKF006_33_H      _PK_H_(0x06, 0x33)
#define REG_BKF006_34_L      _PK_L_(0x06, 0x34)
#define REG_BKF006_34_H      _PK_H_(0x06, 0x34)
#define REG_BKF006_35_L      _PK_L_(0x06, 0x35)
#define REG_BKF006_35_H      _PK_H_(0x06, 0x35)
#define REG_BKF006_36_L      _PK_L_(0x06, 0x36)
#define REG_BKF006_36_H      _PK_H_(0x06, 0x36)
#define REG_BKF006_37_L      _PK_L_(0x06, 0x37)
#define REG_BKF006_37_H      _PK_H_(0x06, 0x37)
#define REG_BKF006_38_L      _PK_L_(0x06, 0x38)
#define REG_BKF006_38_H      _PK_H_(0x06, 0x38)
#define REG_BKF006_39_L      _PK_L_(0x06, 0x39)
#define REG_BKF006_39_H      _PK_H_(0x06, 0x39)
#define REG_BKF006_3A_L      _PK_L_(0x06, 0x3A)
#define REG_BKF006_3A_H      _PK_H_(0x06, 0x3A)
#define REG_BKF006_3B_L      _PK_L_(0x06, 0x3B)
#define REG_BKF006_3B_H      _PK_H_(0x06, 0x3B)
#define REG_BKF006_3C_L      _PK_L_(0x06, 0x3C)
#define REG_BKF006_3C_H      _PK_H_(0x06, 0x3C)
#define REG_BKF006_3D_L      _PK_L_(0x06, 0x3D)
#define REG_BKF006_3D_H      _PK_H_(0x06, 0x3D)
#define REG_BKF006_3E_L      _PK_L_(0x06, 0x3E)
#define REG_BKF006_3E_H      _PK_H_(0x06, 0x3E)
#define REG_BKF006_3F_L      _PK_L_(0x06, 0x3F)
#define REG_BKF006_3F_H      _PK_H_(0x06, 0x3F)
#define REG_BKF006_40_L      _PK_L_(0x06, 0x40)
#define REG_BKF006_40_H      _PK_H_(0x06, 0x40)
#define REG_BKF006_41_L      _PK_L_(0x06, 0x41)
#define REG_BKF006_41_H      _PK_H_(0x06, 0x41)
#define REG_BKF006_42_L      _PK_L_(0x06, 0x42)
#define REG_BKF006_42_H      _PK_H_(0x06, 0x42)
#define REG_BKF006_43_L      _PK_L_(0x06, 0x43)
#define REG_BKF006_43_H      _PK_H_(0x06, 0x43)
#define REG_BKF006_44_L      _PK_L_(0x06, 0x44)
#define REG_BKF006_44_H      _PK_H_(0x06, 0x44)
#define REG_BKF006_45_L      _PK_L_(0x06, 0x45)
#define REG_BKF006_45_H      _PK_H_(0x06, 0x45)
#define REG_BKF006_46_L      _PK_L_(0x06, 0x46)
#define REG_BKF006_46_H      _PK_H_(0x06, 0x46)
#define REG_BKF006_47_L      _PK_L_(0x06, 0x47)
#define REG_BKF006_47_H      _PK_H_(0x06, 0x47)
#define REG_BKF006_48_L      _PK_L_(0x06, 0x48)
#define REG_BKF006_48_H      _PK_H_(0x06, 0x48)
#define REG_BKF006_49_L      _PK_L_(0x06, 0x49)
#define REG_BKF006_49_H      _PK_H_(0x06, 0x49)
#define REG_BKF006_4A_L      _PK_L_(0x06, 0x4A)
#define REG_BKF006_4A_H      _PK_H_(0x06, 0x4A)
#define REG_BKF006_4B_L      _PK_L_(0x06, 0x4B)
#define REG_BKF006_4B_H      _PK_H_(0x06, 0x4B)
#define REG_BKF006_4C_L      _PK_L_(0x06, 0x4C)
#define REG_BKF006_4C_H      _PK_H_(0x06, 0x4C)
#define REG_BKF006_4D_L      _PK_L_(0x06, 0x4D)
#define REG_BKF006_4D_H      _PK_H_(0x06, 0x4D)
#define REG_BKF006_4E_L      _PK_L_(0x06, 0x4E)
#define REG_BKF006_4E_H      _PK_H_(0x06, 0x4E)
#define REG_BKF006_4F_L      _PK_L_(0x06, 0x4F)
#define REG_BKF006_4F_H      _PK_H_(0x06, 0x4F)
#define REG_BKF006_50_L      _PK_L_(0x06, 0x50)
#define REG_BKF006_50_H      _PK_H_(0x06, 0x50)
#define REG_BKF006_51_L      _PK_L_(0x06, 0x51)
#define REG_BKF006_51_H      _PK_H_(0x06, 0x51)
#define REG_BKF006_52_L      _PK_L_(0x06, 0x52)
#define REG_BKF006_52_H      _PK_H_(0x06, 0x52)
#define REG_BKF006_53_L      _PK_L_(0x06, 0x53)
#define REG_BKF006_53_H      _PK_H_(0x06, 0x53)
#define REG_BKF006_54_L      _PK_L_(0x06, 0x54)
#define REG_BKF006_54_H      _PK_H_(0x06, 0x54)
#define REG_BKF006_55_L      _PK_L_(0x06, 0x55)
#define REG_BKF006_55_H      _PK_H_(0x06, 0x55)
#define REG_BKF006_56_L      _PK_L_(0x06, 0x56)
#define REG_BKF006_56_H      _PK_H_(0x06, 0x56)
#define REG_BKF006_57_L      _PK_L_(0x06, 0x57)
#define REG_BKF006_57_H      _PK_H_(0x06, 0x57)
#define REG_BKF006_58_L      _PK_L_(0x06, 0x58)
#define REG_BKF006_58_H      _PK_H_(0x06, 0x58)
#define REG_BKF006_59_L      _PK_L_(0x06, 0x59)
#define REG_BKF006_59_H      _PK_H_(0x06, 0x59)
#define REG_BKF006_5A_L      _PK_L_(0x06, 0x5A)
#define REG_BKF006_5A_H      _PK_H_(0x06, 0x5A)
#define REG_BKF006_5B_L      _PK_L_(0x06, 0x5B)
#define REG_BKF006_5B_H      _PK_H_(0x06, 0x5B)
#define REG_BKF006_5C_L      _PK_L_(0x06, 0x5C)
#define REG_BKF006_5C_H      _PK_H_(0x06, 0x5C)
#define REG_BKF006_5D_L      _PK_L_(0x06, 0x5D)
#define REG_BKF006_5D_H      _PK_H_(0x06, 0x5D)
#define REG_BKF006_5E_L      _PK_L_(0x06, 0x5E)
#define REG_BKF006_5E_H      _PK_H_(0x06, 0x5E)
#define REG_BKF006_5F_L      _PK_L_(0x06, 0x5F)
#define REG_BKF006_5F_H      _PK_H_(0x06, 0x5F)
#define REG_BKF006_60_L      _PK_L_(0x06, 0x60)
#define REG_BKF006_60_H      _PK_H_(0x06, 0x60)
#define REG_BKF006_61_L      _PK_L_(0x06, 0x61)
#define REG_BKF006_61_H      _PK_H_(0x06, 0x61)
#define REG_BKF006_62_L      _PK_L_(0x06, 0x62)
#define REG_BKF006_62_H      _PK_H_(0x06, 0x62)
#define REG_BKF006_63_L      _PK_L_(0x06, 0x63)
#define REG_BKF006_63_H      _PK_H_(0x06, 0x63)
#define REG_BKF006_64_L      _PK_L_(0x06, 0x64)
#define REG_BKF006_64_H      _PK_H_(0x06, 0x64)
#define REG_BKF006_65_L      _PK_L_(0x06, 0x65)
#define REG_BKF006_65_H      _PK_H_(0x06, 0x65)
#define REG_BKF006_66_L      _PK_L_(0x06, 0x66)
#define REG_BKF006_66_H      _PK_H_(0x06, 0x66)
#define REG_BKF006_67_L      _PK_L_(0x06, 0x67)
#define REG_BKF006_67_H      _PK_H_(0x06, 0x67)
#define REG_BKF006_68_L      _PK_L_(0x06, 0x68)
#define REG_BKF006_68_H      _PK_H_(0x06, 0x68)
#define REG_BKF006_69_L      _PK_L_(0x06, 0x69)
#define REG_BKF006_69_H      _PK_H_(0x06, 0x69)
#define REG_BKF006_6A_L      _PK_L_(0x06, 0x6A)
#define REG_BKF006_6A_H      _PK_H_(0x06, 0x6A)
#define REG_BKF006_6B_L      _PK_L_(0x06, 0x6B)
#define REG_BKF006_6B_H      _PK_H_(0x06, 0x6B)
#define REG_BKF006_6C_L      _PK_L_(0x06, 0x6C)
#define REG_BKF006_6C_H      _PK_H_(0x06, 0x6C)
#define REG_BKF006_6D_L      _PK_L_(0x06, 0x6D)
#define REG_BKF006_6D_H      _PK_H_(0x06, 0x6D)
#define REG_BKF006_6E_L      _PK_L_(0x06, 0x6E)
#define REG_BKF006_6E_H      _PK_H_(0x06, 0x6E)
#define REG_BKF006_6F_L      _PK_L_(0x06, 0x6F)
#define REG_BKF006_6F_H      _PK_H_(0x06, 0x6F)
#define REG_BKF006_70_L      _PK_L_(0x06, 0x70)
#define REG_BKF006_70_H      _PK_H_(0x06, 0x70)
#define REG_BKF006_71_L      _PK_L_(0x06, 0x71)
#define REG_BKF006_71_H      _PK_H_(0x06, 0x71)
#define REG_BKF006_72_L      _PK_L_(0x06, 0x72)
#define REG_BKF006_72_H      _PK_H_(0x06, 0x72)
#define REG_BKF006_73_L      _PK_L_(0x06, 0x73)
#define REG_BKF006_73_H      _PK_H_(0x06, 0x73)
#define REG_BKF006_74_L      _PK_L_(0x06, 0x74)
#define REG_BKF006_74_H      _PK_H_(0x06, 0x74)
#define REG_BKF006_75_L      _PK_L_(0x06, 0x75)
#define REG_BKF006_75_H      _PK_H_(0x06, 0x75)
#define REG_BKF006_76_L      _PK_L_(0x06, 0x76)
#define REG_BKF006_76_H      _PK_H_(0x06, 0x76)
#define REG_BKF006_77_L      _PK_L_(0x06, 0x77)
#define REG_BKF006_77_H      _PK_H_(0x06, 0x77)
#define REG_BKF006_78_L      _PK_L_(0x06, 0x78)
#define REG_BKF006_78_H      _PK_H_(0x06, 0x78)
#define REG_BKF006_79_L      _PK_L_(0x06, 0x79)
#define REG_BKF006_79_H      _PK_H_(0x06, 0x79)
#define REG_BKF006_7A_L      _PK_L_(0x06, 0x7A)
#define REG_BKF006_7A_H      _PK_H_(0x06, 0x7A)
#define REG_BKF006_7B_L      _PK_L_(0x06, 0x7B)
#define REG_BKF006_7B_H      _PK_H_(0x06, 0x7B)
#define REG_BKF006_7C_L      _PK_L_(0x06, 0x7C)
#define REG_BKF006_7C_H      _PK_H_(0x06, 0x7C)
#define REG_BKF006_7D_L      _PK_L_(0x06, 0x7D)
#define REG_BKF006_7D_H      _PK_H_(0x06, 0x7D)
#define REG_BKF006_7E_L      _PK_L_(0x06, 0x7E)
#define REG_BKF006_7E_H      _PK_H_(0x06, 0x7E)
#define REG_BKF006_7F_L      _PK_L_(0x06, 0x7F)
#define REG_BKF006_7F_H      _PK_H_(0x06, 0x7F)
//----------------------------------------------
#define REG_BKF007_00_L      _PK_L_(0x07, 0x00)
#define REG_BKF007_00_H      _PK_H_(0x07, 0x00)
#define REG_BKF007_01_L      _PK_L_(0x07, 0x01)
#define REG_BKF007_01_H      _PK_H_(0x07, 0x01)
#define REG_BKF007_02_L      _PK_L_(0x07, 0x02)
#define REG_BKF007_02_H      _PK_H_(0x07, 0x02)
#define REG_BKF007_03_L      _PK_L_(0x07, 0x03)
#define REG_BKF007_03_H      _PK_H_(0x07, 0x03)
#define REG_BKF007_04_L      _PK_L_(0x07, 0x04)
#define REG_BKF007_04_H      _PK_H_(0x07, 0x04)
#define REG_BKF007_05_L      _PK_L_(0x07, 0x05)
#define REG_BKF007_05_H      _PK_H_(0x07, 0x05)
#define REG_BKF007_06_L      _PK_L_(0x07, 0x06)
#define REG_BKF007_06_H      _PK_H_(0x07, 0x06)
#define REG_BKF007_07_L      _PK_L_(0x07, 0x07)
#define REG_BKF007_07_H      _PK_H_(0x07, 0x07)
#define REG_BKF007_08_L      _PK_L_(0x07, 0x08)
#define REG_BKF007_08_H      _PK_H_(0x07, 0x08)
#define REG_BKF007_09_L      _PK_L_(0x07, 0x09)
#define REG_BKF007_09_H      _PK_H_(0x07, 0x09)
#define REG_BKF007_0A_L      _PK_L_(0x07, 0x0A)
#define REG_BKF007_0A_H      _PK_H_(0x07, 0x0A)
#define REG_BKF007_0B_L      _PK_L_(0x07, 0x0B)
#define REG_BKF007_0B_H      _PK_H_(0x07, 0x0B)
#define REG_BKF007_0C_L      _PK_L_(0x07, 0x0C)
#define REG_BKF007_0C_H      _PK_H_(0x07, 0x0C)
#define REG_BKF007_0D_L      _PK_L_(0x07, 0x0D)
#define REG_BKF007_0D_H      _PK_H_(0x07, 0x0D)
#define REG_BKF007_0E_L      _PK_L_(0x07, 0x0E)
#define REG_BKF007_0E_H      _PK_H_(0x07, 0x0E)
#define REG_BKF007_0F_L      _PK_L_(0x07, 0x0F)
#define REG_BKF007_0F_H      _PK_H_(0x07, 0x0F)
#define REG_BKF007_10_L      _PK_L_(0x07, 0x10)
#define REG_BKF007_10_H      _PK_H_(0x07, 0x10)
#define REG_BKF007_11_L      _PK_L_(0x07, 0x11)
#define REG_BKF007_11_H      _PK_H_(0x07, 0x11)
#define REG_BKF007_12_L      _PK_L_(0x07, 0x12)
#define REG_BKF007_12_H      _PK_H_(0x07, 0x12)
#define REG_BKF007_13_L      _PK_L_(0x07, 0x13)
#define REG_BKF007_13_H      _PK_H_(0x07, 0x13)
#define REG_BKF007_14_L      _PK_L_(0x07, 0x14)
#define REG_BKF007_14_H      _PK_H_(0x07, 0x14)
#define REG_BKF007_15_L      _PK_L_(0x07, 0x15)
#define REG_BKF007_15_H      _PK_H_(0x07, 0x15)
#define REG_BKF007_16_L      _PK_L_(0x07, 0x16)
#define REG_BKF007_16_H      _PK_H_(0x07, 0x16)
#define REG_BKF007_17_L      _PK_L_(0x07, 0x17)
#define REG_BKF007_17_H      _PK_H_(0x07, 0x17)
#define REG_BKF007_18_L      _PK_L_(0x07, 0x18)
#define REG_BKF007_18_H      _PK_H_(0x07, 0x18)
#define REG_BKF007_19_L      _PK_L_(0x07, 0x19)
#define REG_BKF007_19_H      _PK_H_(0x07, 0x19)
#define REG_BKF007_1A_L      _PK_L_(0x07, 0x1A)
#define REG_BKF007_1A_H      _PK_H_(0x07, 0x1A)
#define REG_BKF007_1B_L      _PK_L_(0x07, 0x1B)
#define REG_BKF007_1B_H      _PK_H_(0x07, 0x1B)
#define REG_BKF007_1C_L      _PK_L_(0x07, 0x1C)
#define REG_BKF007_1C_H      _PK_H_(0x07, 0x1C)
#define REG_BKF007_1D_L      _PK_L_(0x07, 0x1D)
#define REG_BKF007_1D_H      _PK_H_(0x07, 0x1D)
#define REG_BKF007_1E_L      _PK_L_(0x07, 0x1E)
#define REG_BKF007_1E_H      _PK_H_(0x07, 0x1E)
#define REG_BKF007_1F_L      _PK_L_(0x07, 0x1F)
#define REG_BKF007_1F_H      _PK_H_(0x07, 0x1F)
#define REG_BKF007_20_L      _PK_L_(0x07, 0x20)
#define REG_BKF007_20_H      _PK_H_(0x07, 0x20)
#define REG_BKF007_21_L      _PK_L_(0x07, 0x21)
#define REG_BKF007_21_H      _PK_H_(0x07, 0x21)
#define REG_BKF007_22_L      _PK_L_(0x07, 0x22)
#define REG_BKF007_22_H      _PK_H_(0x07, 0x22)
#define REG_BKF007_23_L      _PK_L_(0x07, 0x23)
#define REG_BKF007_23_H      _PK_H_(0x07, 0x23)
#define REG_BKF007_24_L      _PK_L_(0x07, 0x24)
#define REG_BKF007_24_H      _PK_H_(0x07, 0x24)
#define REG_BKF007_25_L      _PK_L_(0x07, 0x25)
#define REG_BKF007_25_H      _PK_H_(0x07, 0x25)
#define REG_BKF007_26_L      _PK_L_(0x07, 0x26)
#define REG_BKF007_26_H      _PK_H_(0x07, 0x26)
#define REG_BKF007_27_L      _PK_L_(0x07, 0x27)
#define REG_BKF007_27_H      _PK_H_(0x07, 0x27)
#define REG_BKF007_28_L      _PK_L_(0x07, 0x28)
#define REG_BKF007_28_H      _PK_H_(0x07, 0x28)
#define REG_BKF007_29_L      _PK_L_(0x07, 0x29)
#define REG_BKF007_29_H      _PK_H_(0x07, 0x29)
#define REG_BKF007_2A_L      _PK_L_(0x07, 0x2A)
#define REG_BKF007_2A_H      _PK_H_(0x07, 0x2A)
#define REG_BKF007_2B_L      _PK_L_(0x07, 0x2B)
#define REG_BKF007_2B_H      _PK_H_(0x07, 0x2B)
#define REG_BKF007_2C_L      _PK_L_(0x07, 0x2C)
#define REG_BKF007_2C_H      _PK_H_(0x07, 0x2C)
#define REG_BKF007_2D_L      _PK_L_(0x07, 0x2D)
#define REG_BKF007_2D_H      _PK_H_(0x07, 0x2D)
#define REG_BKF007_2E_L      _PK_L_(0x07, 0x2E)
#define REG_BKF007_2E_H      _PK_H_(0x07, 0x2E)
#define REG_BKF007_2F_L      _PK_L_(0x07, 0x2F)
#define REG_BKF007_2F_H      _PK_H_(0x07, 0x2F)
#define REG_BKF007_30_L      _PK_L_(0x07, 0x30)
#define REG_BKF007_30_H      _PK_H_(0x07, 0x30)
#define REG_BKF007_31_L      _PK_L_(0x07, 0x31)
#define REG_BKF007_31_H      _PK_H_(0x07, 0x31)
#define REG_BKF007_32_L      _PK_L_(0x07, 0x32)
#define REG_BKF007_32_H      _PK_H_(0x07, 0x32)
#define REG_BKF007_33_L      _PK_L_(0x07, 0x33)
#define REG_BKF007_33_H      _PK_H_(0x07, 0x33)
#define REG_BKF007_34_L      _PK_L_(0x07, 0x34)
#define REG_BKF007_34_H      _PK_H_(0x07, 0x34)
#define REG_BKF007_35_L      _PK_L_(0x07, 0x35)
#define REG_BKF007_35_H      _PK_H_(0x07, 0x35)
#define REG_BKF007_36_L      _PK_L_(0x07, 0x36)
#define REG_BKF007_36_H      _PK_H_(0x07, 0x36)
#define REG_BKF007_37_L      _PK_L_(0x07, 0x37)
#define REG_BKF007_37_H      _PK_H_(0x07, 0x37)
#define REG_BKF007_38_L      _PK_L_(0x07, 0x38)
#define REG_BKF007_38_H      _PK_H_(0x07, 0x38)
#define REG_BKF007_39_L      _PK_L_(0x07, 0x39)
#define REG_BKF007_39_H      _PK_H_(0x07, 0x39)
#define REG_BKF007_3A_L      _PK_L_(0x07, 0x3A)
#define REG_BKF007_3A_H      _PK_H_(0x07, 0x3A)
#define REG_BKF007_3B_L      _PK_L_(0x07, 0x3B)
#define REG_BKF007_3B_H      _PK_H_(0x07, 0x3B)
#define REG_BKF007_3C_L      _PK_L_(0x07, 0x3C)
#define REG_BKF007_3C_H      _PK_H_(0x07, 0x3C)
#define REG_BKF007_3D_L      _PK_L_(0x07, 0x3D)
#define REG_BKF007_3D_H      _PK_H_(0x07, 0x3D)
#define REG_BKF007_3E_L      _PK_L_(0x07, 0x3E)
#define REG_BKF007_3E_H      _PK_H_(0x07, 0x3E)
#define REG_BKF007_3F_L      _PK_L_(0x07, 0x3F)
#define REG_BKF007_3F_H      _PK_H_(0x07, 0x3F)
#define REG_BKF007_40_L      _PK_L_(0x07, 0x40)
#define REG_BKF007_40_H      _PK_H_(0x07, 0x40)
#define REG_BKF007_41_L      _PK_L_(0x07, 0x41)
#define REG_BKF007_41_H      _PK_H_(0x07, 0x41)
#define REG_BKF007_42_L      _PK_L_(0x07, 0x42)
#define REG_BKF007_42_H      _PK_H_(0x07, 0x42)
#define REG_BKF007_43_L      _PK_L_(0x07, 0x43)
#define REG_BKF007_43_H      _PK_H_(0x07, 0x43)
#define REG_BKF007_44_L      _PK_L_(0x07, 0x44)
#define REG_BKF007_44_H      _PK_H_(0x07, 0x44)
#define REG_BKF007_45_L      _PK_L_(0x07, 0x45)
#define REG_BKF007_45_H      _PK_H_(0x07, 0x45)
#define REG_BKF007_46_L      _PK_L_(0x07, 0x46)
#define REG_BKF007_46_H      _PK_H_(0x07, 0x46)
#define REG_BKF007_47_L      _PK_L_(0x07, 0x47)
#define REG_BKF007_47_H      _PK_H_(0x07, 0x47)
#define REG_BKF007_48_L      _PK_L_(0x07, 0x48)
#define REG_BKF007_48_H      _PK_H_(0x07, 0x48)
#define REG_BKF007_49_L      _PK_L_(0x07, 0x49)
#define REG_BKF007_49_H      _PK_H_(0x07, 0x49)
#define REG_BKF007_4A_L      _PK_L_(0x07, 0x4A)
#define REG_BKF007_4A_H      _PK_H_(0x07, 0x4A)
#define REG_BKF007_4B_L      _PK_L_(0x07, 0x4B)
#define REG_BKF007_4B_H      _PK_H_(0x07, 0x4B)
#define REG_BKF007_4C_L      _PK_L_(0x07, 0x4C)
#define REG_BKF007_4C_H      _PK_H_(0x07, 0x4C)
#define REG_BKF007_4D_L      _PK_L_(0x07, 0x4D)
#define REG_BKF007_4D_H      _PK_H_(0x07, 0x4D)
#define REG_BKF007_4E_L      _PK_L_(0x07, 0x4E)
#define REG_BKF007_4E_H      _PK_H_(0x07, 0x4E)
#define REG_BKF007_4F_L      _PK_L_(0x07, 0x4F)
#define REG_BKF007_4F_H      _PK_H_(0x07, 0x4F)
#define REG_BKF007_50_L      _PK_L_(0x07, 0x50)
#define REG_BKF007_50_H      _PK_H_(0x07, 0x50)
#define REG_BKF007_51_L      _PK_L_(0x07, 0x51)
#define REG_BKF007_51_H      _PK_H_(0x07, 0x51)
#define REG_BKF007_52_L      _PK_L_(0x07, 0x52)
#define REG_BKF007_52_H      _PK_H_(0x07, 0x52)
#define REG_BKF007_53_L      _PK_L_(0x07, 0x53)
#define REG_BKF007_53_H      _PK_H_(0x07, 0x53)
#define REG_BKF007_54_L      _PK_L_(0x07, 0x54)
#define REG_BKF007_54_H      _PK_H_(0x07, 0x54)
#define REG_BKF007_55_L      _PK_L_(0x07, 0x55)
#define REG_BKF007_55_H      _PK_H_(0x07, 0x55)
#define REG_BKF007_56_L      _PK_L_(0x07, 0x56)
#define REG_BKF007_56_H      _PK_H_(0x07, 0x56)
#define REG_BKF007_57_L      _PK_L_(0x07, 0x57)
#define REG_BKF007_57_H      _PK_H_(0x07, 0x57)
#define REG_BKF007_58_L      _PK_L_(0x07, 0x58)
#define REG_BKF007_58_H      _PK_H_(0x07, 0x58)
#define REG_BKF007_59_L      _PK_L_(0x07, 0x59)
#define REG_BKF007_59_H      _PK_H_(0x07, 0x59)
#define REG_BKF007_5A_L      _PK_L_(0x07, 0x5A)
#define REG_BKF007_5A_H      _PK_H_(0x07, 0x5A)
#define REG_BKF007_5B_L      _PK_L_(0x07, 0x5B)
#define REG_BKF007_5B_H      _PK_H_(0x07, 0x5B)
#define REG_BKF007_5C_L      _PK_L_(0x07, 0x5C)
#define REG_BKF007_5C_H      _PK_H_(0x07, 0x5C)
#define REG_BKF007_5D_L      _PK_L_(0x07, 0x5D)
#define REG_BKF007_5D_H      _PK_H_(0x07, 0x5D)
#define REG_BKF007_5E_L      _PK_L_(0x07, 0x5E)
#define REG_BKF007_5E_H      _PK_H_(0x07, 0x5E)
#define REG_BKF007_5F_L      _PK_L_(0x07, 0x5F)
#define REG_BKF007_5F_H      _PK_H_(0x07, 0x5F)
#define REG_BKF007_60_L      _PK_L_(0x07, 0x60)
#define REG_BKF007_60_H      _PK_H_(0x07, 0x60)
#define REG_BKF007_61_L      _PK_L_(0x07, 0x61)
#define REG_BKF007_61_H      _PK_H_(0x07, 0x61)
#define REG_BKF007_62_L      _PK_L_(0x07, 0x62)
#define REG_BKF007_62_H      _PK_H_(0x07, 0x62)
#define REG_BKF007_63_L      _PK_L_(0x07, 0x63)
#define REG_BKF007_63_H      _PK_H_(0x07, 0x63)
#define REG_BKF007_64_L      _PK_L_(0x07, 0x64)
#define REG_BKF007_64_H      _PK_H_(0x07, 0x64)
#define REG_BKF007_65_L      _PK_L_(0x07, 0x65)
#define REG_BKF007_65_H      _PK_H_(0x07, 0x65)
#define REG_BKF007_66_L      _PK_L_(0x07, 0x66)
#define REG_BKF007_66_H      _PK_H_(0x07, 0x66)
#define REG_BKF007_67_L      _PK_L_(0x07, 0x67)
#define REG_BKF007_67_H      _PK_H_(0x07, 0x67)
#define REG_BKF007_68_L      _PK_L_(0x07, 0x68)
#define REG_BKF007_68_H      _PK_H_(0x07, 0x68)
#define REG_BKF007_69_L      _PK_L_(0x07, 0x69)
#define REG_BKF007_69_H      _PK_H_(0x07, 0x69)
#define REG_BKF007_6A_L      _PK_L_(0x07, 0x6A)
#define REG_BKF007_6A_H      _PK_H_(0x07, 0x6A)
#define REG_BKF007_6B_L      _PK_L_(0x07, 0x6B)
#define REG_BKF007_6B_H      _PK_H_(0x07, 0x6B)
#define REG_BKF007_6C_L      _PK_L_(0x07, 0x6C)
#define REG_BKF007_6C_H      _PK_H_(0x07, 0x6C)
#define REG_BKF007_6D_L      _PK_L_(0x07, 0x6D)
#define REG_BKF007_6D_H      _PK_H_(0x07, 0x6D)
#define REG_BKF007_6E_L      _PK_L_(0x07, 0x6E)
#define REG_BKF007_6E_H      _PK_H_(0x07, 0x6E)
#define REG_BKF007_6F_L      _PK_L_(0x07, 0x6F)
#define REG_BKF007_6F_H      _PK_H_(0x07, 0x6F)
#define REG_BKF007_70_L      _PK_L_(0x07, 0x70)
#define REG_BKF007_70_H      _PK_H_(0x07, 0x70)
#define REG_BKF007_71_L      _PK_L_(0x07, 0x71)
#define REG_BKF007_71_H      _PK_H_(0x07, 0x71)
#define REG_BKF007_72_L      _PK_L_(0x07, 0x72)
#define REG_BKF007_72_H      _PK_H_(0x07, 0x72)
#define REG_BKF007_73_L      _PK_L_(0x07, 0x73)
#define REG_BKF007_73_H      _PK_H_(0x07, 0x73)
#define REG_BKF007_74_L      _PK_L_(0x07, 0x74)
#define REG_BKF007_74_H      _PK_H_(0x07, 0x74)
#define REG_BKF007_75_L      _PK_L_(0x07, 0x75)
#define REG_BKF007_75_H      _PK_H_(0x07, 0x75)
#define REG_BKF007_76_L      _PK_L_(0x07, 0x76)
#define REG_BKF007_76_H      _PK_H_(0x07, 0x76)
#define REG_BKF007_77_L      _PK_L_(0x07, 0x77)
#define REG_BKF007_77_H      _PK_H_(0x07, 0x77)
#define REG_BKF007_78_L      _PK_L_(0x07, 0x78)
#define REG_BKF007_78_H      _PK_H_(0x07, 0x78)
#define REG_BKF007_79_L      _PK_L_(0x07, 0x79)
#define REG_BKF007_79_H      _PK_H_(0x07, 0x79)
#define REG_BKF007_7A_L      _PK_L_(0x07, 0x7A)
#define REG_BKF007_7A_H      _PK_H_(0x07, 0x7A)
#define REG_BKF007_7B_L      _PK_L_(0x07, 0x7B)
#define REG_BKF007_7B_H      _PK_H_(0x07, 0x7B)
#define REG_BKF007_7C_L      _PK_L_(0x07, 0x7C)
#define REG_BKF007_7C_H      _PK_H_(0x07, 0x7C)
#define REG_BKF007_7D_L      _PK_L_(0x07, 0x7D)
#define REG_BKF007_7D_H      _PK_H_(0x07, 0x7D)
#define REG_BKF007_7E_L      _PK_L_(0x07, 0x7E)
#define REG_BKF007_7E_H      _PK_H_(0x07, 0x7E)
#define REG_BKF007_7F_L      _PK_L_(0x07, 0x7F)
#define REG_BKF007_7F_H      _PK_H_(0x07, 0x7F)
//----------------------------------------------
#define REG_BKF008_00_L      _PK_L_(0x08, 0x00)
#define REG_BKF008_00_H      _PK_H_(0x08, 0x00)
#define REG_BKF008_01_L      _PK_L_(0x08, 0x01)
#define REG_BKF008_01_H      _PK_H_(0x08, 0x01)
#define REG_BKF008_02_L      _PK_L_(0x08, 0x02)
#define REG_BKF008_02_H      _PK_H_(0x08, 0x02)
#define REG_BKF008_03_L      _PK_L_(0x08, 0x03)
#define REG_BKF008_03_H      _PK_H_(0x08, 0x03)
#define REG_BKF008_04_L      _PK_L_(0x08, 0x04)
#define REG_BKF008_04_H      _PK_H_(0x08, 0x04)
#define REG_BKF008_05_L      _PK_L_(0x08, 0x05)
#define REG_BKF008_05_H      _PK_H_(0x08, 0x05)
#define REG_BKF008_06_L      _PK_L_(0x08, 0x06)
#define REG_BKF008_06_H      _PK_H_(0x08, 0x06)
#define REG_BKF008_07_L      _PK_L_(0x08, 0x07)
#define REG_BKF008_07_H      _PK_H_(0x08, 0x07)
#define REG_BKF008_08_L      _PK_L_(0x08, 0x08)
#define REG_BKF008_08_H      _PK_H_(0x08, 0x08)
#define REG_BKF008_09_L      _PK_L_(0x08, 0x09)
#define REG_BKF008_09_H      _PK_H_(0x08, 0x09)
#define REG_BKF008_0A_L      _PK_L_(0x08, 0x0A)
#define REG_BKF008_0A_H      _PK_H_(0x08, 0x0A)
#define REG_BKF008_0B_L      _PK_L_(0x08, 0x0B)
#define REG_BKF008_0B_H      _PK_H_(0x08, 0x0B)
#define REG_BKF008_0C_L      _PK_L_(0x08, 0x0C)
#define REG_BKF008_0C_H      _PK_H_(0x08, 0x0C)
#define REG_BKF008_0D_L      _PK_L_(0x08, 0x0D)
#define REG_BKF008_0D_H      _PK_H_(0x08, 0x0D)
#define REG_BKF008_0E_L      _PK_L_(0x08, 0x0E)
#define REG_BKF008_0E_H      _PK_H_(0x08, 0x0E)
#define REG_BKF008_0F_L      _PK_L_(0x08, 0x0F)
#define REG_BKF008_0F_H      _PK_H_(0x08, 0x0F)
#define REG_BKF008_10_L      _PK_L_(0x08, 0x10)
#define REG_BKF008_10_H      _PK_H_(0x08, 0x10)
#define REG_BKF008_11_L      _PK_L_(0x08, 0x11)
#define REG_BKF008_11_H      _PK_H_(0x08, 0x11)
#define REG_BKF008_12_L      _PK_L_(0x08, 0x12)
#define REG_BKF008_12_H      _PK_H_(0x08, 0x12)
#define REG_BKF008_13_L      _PK_L_(0x08, 0x13)
#define REG_BKF008_13_H      _PK_H_(0x08, 0x13)
#define REG_BKF008_14_L      _PK_L_(0x08, 0x14)
#define REG_BKF008_14_H      _PK_H_(0x08, 0x14)
#define REG_BKF008_15_L      _PK_L_(0x08, 0x15)
#define REG_BKF008_15_H      _PK_H_(0x08, 0x15)
#define REG_BKF008_16_L      _PK_L_(0x08, 0x16)
#define REG_BKF008_16_H      _PK_H_(0x08, 0x16)
#define REG_BKF008_17_L      _PK_L_(0x08, 0x17)
#define REG_BKF008_17_H      _PK_H_(0x08, 0x17)
#define REG_BKF008_18_L      _PK_L_(0x08, 0x18)
#define REG_BKF008_18_H      _PK_H_(0x08, 0x18)
#define REG_BKF008_19_L      _PK_L_(0x08, 0x19)
#define REG_BKF008_19_H      _PK_H_(0x08, 0x19)
#define REG_BKF008_1A_L      _PK_L_(0x08, 0x1A)
#define REG_BKF008_1A_H      _PK_H_(0x08, 0x1A)
#define REG_BKF008_1B_L      _PK_L_(0x08, 0x1B)
#define REG_BKF008_1B_H      _PK_H_(0x08, 0x1B)
#define REG_BKF008_1C_L      _PK_L_(0x08, 0x1C)
#define REG_BKF008_1C_H      _PK_H_(0x08, 0x1C)
#define REG_BKF008_1D_L      _PK_L_(0x08, 0x1D)
#define REG_BKF008_1D_H      _PK_H_(0x08, 0x1D)
#define REG_BKF008_1E_L      _PK_L_(0x08, 0x1E)
#define REG_BKF008_1E_H      _PK_H_(0x08, 0x1E)
#define REG_BKF008_1F_L      _PK_L_(0x08, 0x1F)
#define REG_BKF008_1F_H      _PK_H_(0x08, 0x1F)
#define REG_BKF008_20_L      _PK_L_(0x08, 0x20)
#define REG_BKF008_20_H      _PK_H_(0x08, 0x20)
#define REG_BKF008_21_L      _PK_L_(0x08, 0x21)
#define REG_BKF008_21_H      _PK_H_(0x08, 0x21)
#define REG_BKF008_22_L      _PK_L_(0x08, 0x22)
#define REG_BKF008_22_H      _PK_H_(0x08, 0x22)
#define REG_BKF008_23_L      _PK_L_(0x08, 0x23)
#define REG_BKF008_23_H      _PK_H_(0x08, 0x23)
#define REG_BKF008_24_L      _PK_L_(0x08, 0x24)
#define REG_BKF008_24_H      _PK_H_(0x08, 0x24)
#define REG_BKF008_25_L      _PK_L_(0x08, 0x25)
#define REG_BKF008_25_H      _PK_H_(0x08, 0x25)
#define REG_BKF008_26_L      _PK_L_(0x08, 0x26)
#define REG_BKF008_26_H      _PK_H_(0x08, 0x26)
#define REG_BKF008_27_L      _PK_L_(0x08, 0x27)
#define REG_BKF008_27_H      _PK_H_(0x08, 0x27)
#define REG_BKF008_28_L      _PK_L_(0x08, 0x28)
#define REG_BKF008_28_H      _PK_H_(0x08, 0x28)
#define REG_BKF008_29_L      _PK_L_(0x08, 0x29)
#define REG_BKF008_29_H      _PK_H_(0x08, 0x29)
#define REG_BKF008_2A_L      _PK_L_(0x08, 0x2A)
#define REG_BKF008_2A_H      _PK_H_(0x08, 0x2A)
#define REG_BKF008_2B_L      _PK_L_(0x08, 0x2B)
#define REG_BKF008_2B_H      _PK_H_(0x08, 0x2B)
#define REG_BKF008_2C_L      _PK_L_(0x08, 0x2C)
#define REG_BKF008_2C_H      _PK_H_(0x08, 0x2C)
#define REG_BKF008_2D_L      _PK_L_(0x08, 0x2D)
#define REG_BKF008_2D_H      _PK_H_(0x08, 0x2D)
#define REG_BKF008_2E_L      _PK_L_(0x08, 0x2E)
#define REG_BKF008_2E_H      _PK_H_(0x08, 0x2E)
#define REG_BKF008_2F_L      _PK_L_(0x08, 0x2F)
#define REG_BKF008_2F_H      _PK_H_(0x08, 0x2F)
#define REG_BKF008_30_L      _PK_L_(0x08, 0x30)
#define REG_BKF008_30_H      _PK_H_(0x08, 0x30)
#define REG_BKF008_31_L      _PK_L_(0x08, 0x31)
#define REG_BKF008_31_H      _PK_H_(0x08, 0x31)
#define REG_BKF008_32_L      _PK_L_(0x08, 0x32)
#define REG_BKF008_32_H      _PK_H_(0x08, 0x32)
#define REG_BKF008_33_L      _PK_L_(0x08, 0x33)
#define REG_BKF008_33_H      _PK_H_(0x08, 0x33)
#define REG_BKF008_34_L      _PK_L_(0x08, 0x34)
#define REG_BKF008_34_H      _PK_H_(0x08, 0x34)
#define REG_BKF008_35_L      _PK_L_(0x08, 0x35)
#define REG_BKF008_35_H      _PK_H_(0x08, 0x35)
#define REG_BKF008_36_L      _PK_L_(0x08, 0x36)
#define REG_BKF008_36_H      _PK_H_(0x08, 0x36)
#define REG_BKF008_37_L      _PK_L_(0x08, 0x37)
#define REG_BKF008_37_H      _PK_H_(0x08, 0x37)
#define REG_BKF008_38_L      _PK_L_(0x08, 0x38)
#define REG_BKF008_38_H      _PK_H_(0x08, 0x38)
#define REG_BKF008_39_L      _PK_L_(0x08, 0x39)
#define REG_BKF008_39_H      _PK_H_(0x08, 0x39)
#define REG_BKF008_3A_L      _PK_L_(0x08, 0x3A)
#define REG_BKF008_3A_H      _PK_H_(0x08, 0x3A)
#define REG_BKF008_3B_L      _PK_L_(0x08, 0x3B)
#define REG_BKF008_3B_H      _PK_H_(0x08, 0x3B)
#define REG_BKF008_3C_L      _PK_L_(0x08, 0x3C)
#define REG_BKF008_3C_H      _PK_H_(0x08, 0x3C)
#define REG_BKF008_3D_L      _PK_L_(0x08, 0x3D)
#define REG_BKF008_3D_H      _PK_H_(0x08, 0x3D)
#define REG_BKF008_3E_L      _PK_L_(0x08, 0x3E)
#define REG_BKF008_3E_H      _PK_H_(0x08, 0x3E)
#define REG_BKF008_3F_L      _PK_L_(0x08, 0x3F)
#define REG_BKF008_3F_H      _PK_H_(0x08, 0x3F)
#define REG_BKF008_40_L      _PK_L_(0x08, 0x40)
#define REG_BKF008_40_H      _PK_H_(0x08, 0x40)
#define REG_BKF008_41_L      _PK_L_(0x08, 0x41)
#define REG_BKF008_41_H      _PK_H_(0x08, 0x41)
#define REG_BKF008_42_L      _PK_L_(0x08, 0x42)
#define REG_BKF008_42_H      _PK_H_(0x08, 0x42)
#define REG_BKF008_43_L      _PK_L_(0x08, 0x43)
#define REG_BKF008_43_H      _PK_H_(0x08, 0x43)
#define REG_BKF008_44_L      _PK_L_(0x08, 0x44)
#define REG_BKF008_44_H      _PK_H_(0x08, 0x44)
#define REG_BKF008_45_L      _PK_L_(0x08, 0x45)
#define REG_BKF008_45_H      _PK_H_(0x08, 0x45)
#define REG_BKF008_46_L      _PK_L_(0x08, 0x46)
#define REG_BKF008_46_H      _PK_H_(0x08, 0x46)
#define REG_BKF008_47_L      _PK_L_(0x08, 0x47)
#define REG_BKF008_47_H      _PK_H_(0x08, 0x47)
#define REG_BKF008_48_L      _PK_L_(0x08, 0x48)
#define REG_BKF008_48_H      _PK_H_(0x08, 0x48)
#define REG_BKF008_49_L      _PK_L_(0x08, 0x49)
#define REG_BKF008_49_H      _PK_H_(0x08, 0x49)
#define REG_BKF008_4A_L      _PK_L_(0x08, 0x4A)
#define REG_BKF008_4A_H      _PK_H_(0x08, 0x4A)
#define REG_BKF008_4B_L      _PK_L_(0x08, 0x4B)
#define REG_BKF008_4B_H      _PK_H_(0x08, 0x4B)
#define REG_BKF008_4C_L      _PK_L_(0x08, 0x4C)
#define REG_BKF008_4C_H      _PK_H_(0x08, 0x4C)
#define REG_BKF008_4D_L      _PK_L_(0x08, 0x4D)
#define REG_BKF008_4D_H      _PK_H_(0x08, 0x4D)
#define REG_BKF008_4E_L      _PK_L_(0x08, 0x4E)
#define REG_BKF008_4E_H      _PK_H_(0x08, 0x4E)
#define REG_BKF008_4F_L      _PK_L_(0x08, 0x4F)
#define REG_BKF008_4F_H      _PK_H_(0x08, 0x4F)
#define REG_BKF008_50_L      _PK_L_(0x08, 0x50)
#define REG_BKF008_50_H      _PK_H_(0x08, 0x50)
#define REG_BKF008_51_L      _PK_L_(0x08, 0x51)
#define REG_BKF008_51_H      _PK_H_(0x08, 0x51)
#define REG_BKF008_52_L      _PK_L_(0x08, 0x52)
#define REG_BKF008_52_H      _PK_H_(0x08, 0x52)
#define REG_BKF008_53_L      _PK_L_(0x08, 0x53)
#define REG_BKF008_53_H      _PK_H_(0x08, 0x53)
#define REG_BKF008_54_L      _PK_L_(0x08, 0x54)
#define REG_BKF008_54_H      _PK_H_(0x08, 0x54)
#define REG_BKF008_55_L      _PK_L_(0x08, 0x55)
#define REG_BKF008_55_H      _PK_H_(0x08, 0x55)
#define REG_BKF008_56_L      _PK_L_(0x08, 0x56)
#define REG_BKF008_56_H      _PK_H_(0x08, 0x56)
#define REG_BKF008_57_L      _PK_L_(0x08, 0x57)
#define REG_BKF008_57_H      _PK_H_(0x08, 0x57)
#define REG_BKF008_58_L      _PK_L_(0x08, 0x58)
#define REG_BKF008_58_H      _PK_H_(0x08, 0x58)
#define REG_BKF008_59_L      _PK_L_(0x08, 0x59)
#define REG_BKF008_59_H      _PK_H_(0x08, 0x59)
#define REG_BKF008_5A_L      _PK_L_(0x08, 0x5A)
#define REG_BKF008_5A_H      _PK_H_(0x08, 0x5A)
#define REG_BKF008_5B_L      _PK_L_(0x08, 0x5B)
#define REG_BKF008_5B_H      _PK_H_(0x08, 0x5B)
#define REG_BKF008_5C_L      _PK_L_(0x08, 0x5C)
#define REG_BKF008_5C_H      _PK_H_(0x08, 0x5C)
#define REG_BKF008_5D_L      _PK_L_(0x08, 0x5D)
#define REG_BKF008_5D_H      _PK_H_(0x08, 0x5D)
#define REG_BKF008_5E_L      _PK_L_(0x08, 0x5E)
#define REG_BKF008_5E_H      _PK_H_(0x08, 0x5E)
#define REG_BKF008_5F_L      _PK_L_(0x08, 0x5F)
#define REG_BKF008_5F_H      _PK_H_(0x08, 0x5F)
#define REG_BKF008_60_L      _PK_L_(0x08, 0x60)
#define REG_BKF008_60_H      _PK_H_(0x08, 0x60)
#define REG_BKF008_61_L      _PK_L_(0x08, 0x61)
#define REG_BKF008_61_H      _PK_H_(0x08, 0x61)
#define REG_BKF008_62_L      _PK_L_(0x08, 0x62)
#define REG_BKF008_62_H      _PK_H_(0x08, 0x62)
#define REG_BKF008_63_L      _PK_L_(0x08, 0x63)
#define REG_BKF008_63_H      _PK_H_(0x08, 0x63)
#define REG_BKF008_64_L      _PK_L_(0x08, 0x64)
#define REG_BKF008_64_H      _PK_H_(0x08, 0x64)
#define REG_BKF008_65_L      _PK_L_(0x08, 0x65)
#define REG_BKF008_65_H      _PK_H_(0x08, 0x65)
#define REG_BKF008_66_L      _PK_L_(0x08, 0x66)
#define REG_BKF008_66_H      _PK_H_(0x08, 0x66)
#define REG_BKF008_67_L      _PK_L_(0x08, 0x67)
#define REG_BKF008_67_H      _PK_H_(0x08, 0x67)
#define REG_BKF008_68_L      _PK_L_(0x08, 0x68)
#define REG_BKF008_68_H      _PK_H_(0x08, 0x68)
#define REG_BKF008_69_L      _PK_L_(0x08, 0x69)
#define REG_BKF008_69_H      _PK_H_(0x08, 0x69)
#define REG_BKF008_6A_L      _PK_L_(0x08, 0x6A)
#define REG_BKF008_6A_H      _PK_H_(0x08, 0x6A)
#define REG_BKF008_6B_L      _PK_L_(0x08, 0x6B)
#define REG_BKF008_6B_H      _PK_H_(0x08, 0x6B)
#define REG_BKF008_6C_L      _PK_L_(0x08, 0x6C)
#define REG_BKF008_6C_H      _PK_H_(0x08, 0x6C)
#define REG_BKF008_6D_L      _PK_L_(0x08, 0x6D)
#define REG_BKF008_6D_H      _PK_H_(0x08, 0x6D)
#define REG_BKF008_6E_L      _PK_L_(0x08, 0x6E)
#define REG_BKF008_6E_H      _PK_H_(0x08, 0x6E)
#define REG_BKF008_6F_L      _PK_L_(0x08, 0x6F)
#define REG_BKF008_6F_H      _PK_H_(0x08, 0x6F)
#define REG_BKF008_70_L      _PK_L_(0x08, 0x70)
#define REG_BKF008_70_H      _PK_H_(0x08, 0x70)
#define REG_BKF008_71_L      _PK_L_(0x08, 0x71)
#define REG_BKF008_71_H      _PK_H_(0x08, 0x71)
#define REG_BKF008_72_L      _PK_L_(0x08, 0x72)
#define REG_BKF008_72_H      _PK_H_(0x08, 0x72)
#define REG_BKF008_73_L      _PK_L_(0x08, 0x73)
#define REG_BKF008_73_H      _PK_H_(0x08, 0x73)
#define REG_BKF008_74_L      _PK_L_(0x08, 0x74)
#define REG_BKF008_74_H      _PK_H_(0x08, 0x74)
#define REG_BKF008_75_L      _PK_L_(0x08, 0x75)
#define REG_BKF008_75_H      _PK_H_(0x08, 0x75)
#define REG_BKF008_76_L      _PK_L_(0x08, 0x76)
#define REG_BKF008_76_H      _PK_H_(0x08, 0x76)
#define REG_BKF008_77_L      _PK_L_(0x08, 0x77)
#define REG_BKF008_77_H      _PK_H_(0x08, 0x77)
#define REG_BKF008_78_L      _PK_L_(0x08, 0x78)
#define REG_BKF008_78_H      _PK_H_(0x08, 0x78)
#define REG_BKF008_79_L      _PK_L_(0x08, 0x79)
#define REG_BKF008_79_H      _PK_H_(0x08, 0x79)
#define REG_BKF008_7A_L      _PK_L_(0x08, 0x7A)
#define REG_BKF008_7A_H      _PK_H_(0x08, 0x7A)
#define REG_BKF008_7B_L      _PK_L_(0x08, 0x7B)
#define REG_BKF008_7B_H      _PK_H_(0x08, 0x7B)
#define REG_BKF008_7C_L      _PK_L_(0x08, 0x7C)
#define REG_BKF008_7C_H      _PK_H_(0x08, 0x7C)
#define REG_BKF008_7D_L      _PK_L_(0x08, 0x7D)
#define REG_BKF008_7D_H      _PK_H_(0x08, 0x7D)
#define REG_BKF008_7E_L      _PK_L_(0x08, 0x7E)
#define REG_BKF008_7E_H      _PK_H_(0x08, 0x7E)
#define REG_BKF008_7F_L      _PK_L_(0x08, 0x7F)
#define REG_BKF008_7F_H      _PK_H_(0x08, 0x7F)
//----------------------------------------------
#define REG_BKF009_00_L      _PK_L_(0x09, 0x00)
#define REG_BKF009_00_H      _PK_H_(0x09, 0x00)
#define REG_BKF009_01_L      _PK_L_(0x09, 0x01)
#define REG_BKF009_01_H      _PK_H_(0x09, 0x01)
#define REG_BKF009_02_L      _PK_L_(0x09, 0x02)
#define REG_BKF009_02_H      _PK_H_(0x09, 0x02)
#define REG_BKF009_03_L      _PK_L_(0x09, 0x03)
#define REG_BKF009_03_H      _PK_H_(0x09, 0x03)
#define REG_BKF009_04_L      _PK_L_(0x09, 0x04)
#define REG_BKF009_04_H      _PK_H_(0x09, 0x04)
#define REG_BKF009_05_L      _PK_L_(0x09, 0x05)
#define REG_BKF009_05_H      _PK_H_(0x09, 0x05)
#define REG_BKF009_06_L      _PK_L_(0x09, 0x06)
#define REG_BKF009_06_H      _PK_H_(0x09, 0x06)
#define REG_BKF009_07_L      _PK_L_(0x09, 0x07)
#define REG_BKF009_07_H      _PK_H_(0x09, 0x07)
#define REG_BKF009_08_L      _PK_L_(0x09, 0x08)
#define REG_BKF009_08_H      _PK_H_(0x09, 0x08)
#define REG_BKF009_09_L      _PK_L_(0x09, 0x09)
#define REG_BKF009_09_H      _PK_H_(0x09, 0x09)
#define REG_BKF009_0A_L      _PK_L_(0x09, 0x0A)
#define REG_BKF009_0A_H      _PK_H_(0x09, 0x0A)
#define REG_BKF009_0B_L      _PK_L_(0x09, 0x0B)
#define REG_BKF009_0B_H      _PK_H_(0x09, 0x0B)
#define REG_BKF009_0C_L      _PK_L_(0x09, 0x0C)
#define REG_BKF009_0C_H      _PK_H_(0x09, 0x0C)
#define REG_BKF009_0D_L      _PK_L_(0x09, 0x0D)
#define REG_BKF009_0D_H      _PK_H_(0x09, 0x0D)
#define REG_BKF009_0E_L      _PK_L_(0x09, 0x0E)
#define REG_BKF009_0E_H      _PK_H_(0x09, 0x0E)
#define REG_BKF009_0F_L      _PK_L_(0x09, 0x0F)
#define REG_BKF009_0F_H      _PK_H_(0x09, 0x0F)
#define REG_BKF009_10_L      _PK_L_(0x09, 0x10)
#define REG_BKF009_10_H      _PK_H_(0x09, 0x10)
#define REG_BKF009_11_L      _PK_L_(0x09, 0x11)
#define REG_BKF009_11_H      _PK_H_(0x09, 0x11)
#define REG_BKF009_12_L      _PK_L_(0x09, 0x12)
#define REG_BKF009_12_H      _PK_H_(0x09, 0x12)
#define REG_BKF009_13_L      _PK_L_(0x09, 0x13)
#define REG_BKF009_13_H      _PK_H_(0x09, 0x13)
#define REG_BKF009_14_L      _PK_L_(0x09, 0x14)
#define REG_BKF009_14_H      _PK_H_(0x09, 0x14)
#define REG_BKF009_15_L      _PK_L_(0x09, 0x15)
#define REG_BKF009_15_H      _PK_H_(0x09, 0x15)
#define REG_BKF009_16_L      _PK_L_(0x09, 0x16)
#define REG_BKF009_16_H      _PK_H_(0x09, 0x16)
#define REG_BKF009_17_L      _PK_L_(0x09, 0x17)
#define REG_BKF009_17_H      _PK_H_(0x09, 0x17)
#define REG_BKF009_18_L      _PK_L_(0x09, 0x18)
#define REG_BKF009_18_H      _PK_H_(0x09, 0x18)
#define REG_BKF009_19_L      _PK_L_(0x09, 0x19)
#define REG_BKF009_19_H      _PK_H_(0x09, 0x19)
#define REG_BKF009_1A_L      _PK_L_(0x09, 0x1A)
#define REG_BKF009_1A_H      _PK_H_(0x09, 0x1A)
#define REG_BKF009_1B_L      _PK_L_(0x09, 0x1B)
#define REG_BKF009_1B_H      _PK_H_(0x09, 0x1B)
#define REG_BKF009_1C_L      _PK_L_(0x09, 0x1C)
#define REG_BKF009_1C_H      _PK_H_(0x09, 0x1C)
#define REG_BKF009_1D_L      _PK_L_(0x09, 0x1D)
#define REG_BKF009_1D_H      _PK_H_(0x09, 0x1D)
#define REG_BKF009_1E_L      _PK_L_(0x09, 0x1E)
#define REG_BKF009_1E_H      _PK_H_(0x09, 0x1E)
#define REG_BKF009_1F_L      _PK_L_(0x09, 0x1F)
#define REG_BKF009_1F_H      _PK_H_(0x09, 0x1F)
#define REG_BKF009_20_L      _PK_L_(0x09, 0x20)
#define REG_BKF009_20_H      _PK_H_(0x09, 0x20)
#define REG_BKF009_21_L      _PK_L_(0x09, 0x21)
#define REG_BKF009_21_H      _PK_H_(0x09, 0x21)
#define REG_BKF009_22_L      _PK_L_(0x09, 0x22)
#define REG_BKF009_22_H      _PK_H_(0x09, 0x22)
#define REG_BKF009_23_L      _PK_L_(0x09, 0x23)
#define REG_BKF009_23_H      _PK_H_(0x09, 0x23)
#define REG_BKF009_24_L      _PK_L_(0x09, 0x24)
#define REG_BKF009_24_H      _PK_H_(0x09, 0x24)
#define REG_BKF009_25_L      _PK_L_(0x09, 0x25)
#define REG_BKF009_25_H      _PK_H_(0x09, 0x25)
#define REG_BKF009_26_L      _PK_L_(0x09, 0x26)
#define REG_BKF009_26_H      _PK_H_(0x09, 0x26)
#define REG_BKF009_27_L      _PK_L_(0x09, 0x27)
#define REG_BKF009_27_H      _PK_H_(0x09, 0x27)
#define REG_BKF009_28_L      _PK_L_(0x09, 0x28)
#define REG_BKF009_28_H      _PK_H_(0x09, 0x28)
#define REG_BKF009_29_L      _PK_L_(0x09, 0x29)
#define REG_BKF009_29_H      _PK_H_(0x09, 0x29)
#define REG_BKF009_2A_L      _PK_L_(0x09, 0x2A)
#define REG_BKF009_2A_H      _PK_H_(0x09, 0x2A)
#define REG_BKF009_2B_L      _PK_L_(0x09, 0x2B)
#define REG_BKF009_2B_H      _PK_H_(0x09, 0x2B)
#define REG_BKF009_2C_L      _PK_L_(0x09, 0x2C)
#define REG_BKF009_2C_H      _PK_H_(0x09, 0x2C)
#define REG_BKF009_2D_L      _PK_L_(0x09, 0x2D)
#define REG_BKF009_2D_H      _PK_H_(0x09, 0x2D)
#define REG_BKF009_2E_L      _PK_L_(0x09, 0x2E)
#define REG_BKF009_2E_H      _PK_H_(0x09, 0x2E)
#define REG_BKF009_2F_L      _PK_L_(0x09, 0x2F)
#define REG_BKF009_2F_H      _PK_H_(0x09, 0x2F)
#define REG_BKF009_30_L      _PK_L_(0x09, 0x30)
#define REG_BKF009_30_H      _PK_H_(0x09, 0x30)
#define REG_BKF009_31_L      _PK_L_(0x09, 0x31)
#define REG_BKF009_31_H      _PK_H_(0x09, 0x31)
#define REG_BKF009_32_L      _PK_L_(0x09, 0x32)
#define REG_BKF009_32_H      _PK_H_(0x09, 0x32)
#define REG_BKF009_33_L      _PK_L_(0x09, 0x33)
#define REG_BKF009_33_H      _PK_H_(0x09, 0x33)
#define REG_BKF009_34_L      _PK_L_(0x09, 0x34)
#define REG_BKF009_34_H      _PK_H_(0x09, 0x34)
#define REG_BKF009_35_L      _PK_L_(0x09, 0x35)
#define REG_BKF009_35_H      _PK_H_(0x09, 0x35)
#define REG_BKF009_36_L      _PK_L_(0x09, 0x36)
#define REG_BKF009_36_H      _PK_H_(0x09, 0x36)
#define REG_BKF009_37_L      _PK_L_(0x09, 0x37)
#define REG_BKF009_37_H      _PK_H_(0x09, 0x37)
#define REG_BKF009_38_L      _PK_L_(0x09, 0x38)
#define REG_BKF009_38_H      _PK_H_(0x09, 0x38)
#define REG_BKF009_39_L      _PK_L_(0x09, 0x39)
#define REG_BKF009_39_H      _PK_H_(0x09, 0x39)
#define REG_BKF009_3A_L      _PK_L_(0x09, 0x3A)
#define REG_BKF009_3A_H      _PK_H_(0x09, 0x3A)
#define REG_BKF009_3B_L      _PK_L_(0x09, 0x3B)
#define REG_BKF009_3B_H      _PK_H_(0x09, 0x3B)
#define REG_BKF009_3C_L      _PK_L_(0x09, 0x3C)
#define REG_BKF009_3C_H      _PK_H_(0x09, 0x3C)
#define REG_BKF009_3D_L      _PK_L_(0x09, 0x3D)
#define REG_BKF009_3D_H      _PK_H_(0x09, 0x3D)
#define REG_BKF009_3E_L      _PK_L_(0x09, 0x3E)
#define REG_BKF009_3E_H      _PK_H_(0x09, 0x3E)
#define REG_BKF009_3F_L      _PK_L_(0x09, 0x3F)
#define REG_BKF009_3F_H      _PK_H_(0x09, 0x3F)
#define REG_BKF009_40_L      _PK_L_(0x09, 0x40)
#define REG_BKF009_40_H      _PK_H_(0x09, 0x40)
#define REG_BKF009_41_L      _PK_L_(0x09, 0x41)
#define REG_BKF009_41_H      _PK_H_(0x09, 0x41)
#define REG_BKF009_42_L      _PK_L_(0x09, 0x42)
#define REG_BKF009_42_H      _PK_H_(0x09, 0x42)
#define REG_BKF009_43_L      _PK_L_(0x09, 0x43)
#define REG_BKF009_43_H      _PK_H_(0x09, 0x43)
#define REG_BKF009_44_L      _PK_L_(0x09, 0x44)
#define REG_BKF009_44_H      _PK_H_(0x09, 0x44)
#define REG_BKF009_45_L      _PK_L_(0x09, 0x45)
#define REG_BKF009_45_H      _PK_H_(0x09, 0x45)
#define REG_BKF009_46_L      _PK_L_(0x09, 0x46)
#define REG_BKF009_46_H      _PK_H_(0x09, 0x46)
#define REG_BKF009_47_L      _PK_L_(0x09, 0x47)
#define REG_BKF009_47_H      _PK_H_(0x09, 0x47)
#define REG_BKF009_48_L      _PK_L_(0x09, 0x48)
#define REG_BKF009_48_H      _PK_H_(0x09, 0x48)
#define REG_BKF009_49_L      _PK_L_(0x09, 0x49)
#define REG_BKF009_49_H      _PK_H_(0x09, 0x49)
#define REG_BKF009_4A_L      _PK_L_(0x09, 0x4A)
#define REG_BKF009_4A_H      _PK_H_(0x09, 0x4A)
#define REG_BKF009_4B_L      _PK_L_(0x09, 0x4B)
#define REG_BKF009_4B_H      _PK_H_(0x09, 0x4B)
#define REG_BKF009_4C_L      _PK_L_(0x09, 0x4C)
#define REG_BKF009_4C_H      _PK_H_(0x09, 0x4C)
#define REG_BKF009_4D_L      _PK_L_(0x09, 0x4D)
#define REG_BKF009_4D_H      _PK_H_(0x09, 0x4D)
#define REG_BKF009_4E_L      _PK_L_(0x09, 0x4E)
#define REG_BKF009_4E_H      _PK_H_(0x09, 0x4E)
#define REG_BKF009_4F_L      _PK_L_(0x09, 0x4F)
#define REG_BKF009_4F_H      _PK_H_(0x09, 0x4F)
#define REG_BKF009_50_L      _PK_L_(0x09, 0x50)
#define REG_BKF009_50_H      _PK_H_(0x09, 0x50)
#define REG_BKF009_51_L      _PK_L_(0x09, 0x51)
#define REG_BKF009_51_H      _PK_H_(0x09, 0x51)
#define REG_BKF009_52_L      _PK_L_(0x09, 0x52)
#define REG_BKF009_52_H      _PK_H_(0x09, 0x52)
#define REG_BKF009_53_L      _PK_L_(0x09, 0x53)
#define REG_BKF009_53_H      _PK_H_(0x09, 0x53)
#define REG_BKF009_54_L      _PK_L_(0x09, 0x54)
#define REG_BKF009_54_H      _PK_H_(0x09, 0x54)
#define REG_BKF009_55_L      _PK_L_(0x09, 0x55)
#define REG_BKF009_55_H      _PK_H_(0x09, 0x55)
#define REG_BKF009_56_L      _PK_L_(0x09, 0x56)
#define REG_BKF009_56_H      _PK_H_(0x09, 0x56)
#define REG_BKF009_57_L      _PK_L_(0x09, 0x57)
#define REG_BKF009_57_H      _PK_H_(0x09, 0x57)
#define REG_BKF009_58_L      _PK_L_(0x09, 0x58)
#define REG_BKF009_58_H      _PK_H_(0x09, 0x58)
#define REG_BKF009_59_L      _PK_L_(0x09, 0x59)
#define REG_BKF009_59_H      _PK_H_(0x09, 0x59)
#define REG_BKF009_5A_L      _PK_L_(0x09, 0x5A)
#define REG_BKF009_5A_H      _PK_H_(0x09, 0x5A)
#define REG_BKF009_5B_L      _PK_L_(0x09, 0x5B)
#define REG_BKF009_5B_H      _PK_H_(0x09, 0x5B)
#define REG_BKF009_5C_L      _PK_L_(0x09, 0x5C)
#define REG_BKF009_5C_H      _PK_H_(0x09, 0x5C)
#define REG_BKF009_5D_L      _PK_L_(0x09, 0x5D)
#define REG_BKF009_5D_H      _PK_H_(0x09, 0x5D)
#define REG_BKF009_5E_L      _PK_L_(0x09, 0x5E)
#define REG_BKF009_5E_H      _PK_H_(0x09, 0x5E)
#define REG_BKF009_5F_L      _PK_L_(0x09, 0x5F)
#define REG_BKF009_5F_H      _PK_H_(0x09, 0x5F)
#define REG_BKF009_60_L      _PK_L_(0x09, 0x60)
#define REG_BKF009_60_H      _PK_H_(0x09, 0x60)
#define REG_BKF009_61_L      _PK_L_(0x09, 0x61)
#define REG_BKF009_61_H      _PK_H_(0x09, 0x61)
#define REG_BKF009_62_L      _PK_L_(0x09, 0x62)
#define REG_BKF009_62_H      _PK_H_(0x09, 0x62)
#define REG_BKF009_63_L      _PK_L_(0x09, 0x63)
#define REG_BKF009_63_H      _PK_H_(0x09, 0x63)
#define REG_BKF009_64_L      _PK_L_(0x09, 0x64)
#define REG_BKF009_64_H      _PK_H_(0x09, 0x64)
#define REG_BKF009_65_L      _PK_L_(0x09, 0x65)
#define REG_BKF009_65_H      _PK_H_(0x09, 0x65)
#define REG_BKF009_66_L      _PK_L_(0x09, 0x66)
#define REG_BKF009_66_H      _PK_H_(0x09, 0x66)
#define REG_BKF009_67_L      _PK_L_(0x09, 0x67)
#define REG_BKF009_67_H      _PK_H_(0x09, 0x67)
#define REG_BKF009_68_L      _PK_L_(0x09, 0x68)
#define REG_BKF009_68_H      _PK_H_(0x09, 0x68)
#define REG_BKF009_69_L      _PK_L_(0x09, 0x69)
#define REG_BKF009_69_H      _PK_H_(0x09, 0x69)
#define REG_BKF009_6A_L      _PK_L_(0x09, 0x6A)
#define REG_BKF009_6A_H      _PK_H_(0x09, 0x6A)
#define REG_BKF009_6B_L      _PK_L_(0x09, 0x6B)
#define REG_BKF009_6B_H      _PK_H_(0x09, 0x6B)
#define REG_BKF009_6C_L      _PK_L_(0x09, 0x6C)
#define REG_BKF009_6C_H      _PK_H_(0x09, 0x6C)
#define REG_BKF009_6D_L      _PK_L_(0x09, 0x6D)
#define REG_BKF009_6D_H      _PK_H_(0x09, 0x6D)
#define REG_BKF009_6E_L      _PK_L_(0x09, 0x6E)
#define REG_BKF009_6E_H      _PK_H_(0x09, 0x6E)
#define REG_BKF009_6F_L      _PK_L_(0x09, 0x6F)
#define REG_BKF009_6F_H      _PK_H_(0x09, 0x6F)
#define REG_BKF009_70_L      _PK_L_(0x09, 0x70)
#define REG_BKF009_70_H      _PK_H_(0x09, 0x70)
#define REG_BKF009_71_L      _PK_L_(0x09, 0x71)
#define REG_BKF009_71_H      _PK_H_(0x09, 0x71)
#define REG_BKF009_72_L      _PK_L_(0x09, 0x72)
#define REG_BKF009_72_H      _PK_H_(0x09, 0x72)
#define REG_BKF009_73_L      _PK_L_(0x09, 0x73)
#define REG_BKF009_73_H      _PK_H_(0x09, 0x73)
#define REG_BKF009_74_L      _PK_L_(0x09, 0x74)
#define REG_BKF009_74_H      _PK_H_(0x09, 0x74)
#define REG_BKF009_75_L      _PK_L_(0x09, 0x75)
#define REG_BKF009_75_H      _PK_H_(0x09, 0x75)
#define REG_BKF009_76_L      _PK_L_(0x09, 0x76)
#define REG_BKF009_76_H      _PK_H_(0x09, 0x76)
#define REG_BKF009_77_L      _PK_L_(0x09, 0x77)
#define REG_BKF009_77_H      _PK_H_(0x09, 0x77)
#define REG_BKF009_78_L      _PK_L_(0x09, 0x78)
#define REG_BKF009_78_H      _PK_H_(0x09, 0x78)
#define REG_BKF009_79_L      _PK_L_(0x09, 0x79)
#define REG_BKF009_79_H      _PK_H_(0x09, 0x79)
#define REG_BKF009_7A_L      _PK_L_(0x09, 0x7A)
#define REG_BKF009_7A_H      _PK_H_(0x09, 0x7A)
#define REG_BKF009_7B_L      _PK_L_(0x09, 0x7B)
#define REG_BKF009_7B_H      _PK_H_(0x09, 0x7B)
#define REG_BKF009_7C_L      _PK_L_(0x09, 0x7C)
#define REG_BKF009_7C_H      _PK_H_(0x09, 0x7C)
#define REG_BKF009_7D_L      _PK_L_(0x09, 0x7D)
#define REG_BKF009_7D_H      _PK_H_(0x09, 0x7D)
#define REG_BKF009_7E_L      _PK_L_(0x09, 0x7E)
#define REG_BKF009_7E_H      _PK_H_(0x09, 0x7E)
#define REG_BKF009_7F_L      _PK_L_(0x09, 0x7F)
#define REG_BKF009_7F_H      _PK_H_(0x09, 0x7F)
//----------------------------------------------
#define REG_BKF00A_00_L      _PK_L_(0x0A, 0x00)
#define REG_BKF00A_00_H      _PK_H_(0x0A, 0x00)
#define REG_BKF00A_01_L      _PK_L_(0x0A, 0x01)
#define REG_BKF00A_01_H      _PK_H_(0x0A, 0x01)
#define REG_BKF00A_02_L      _PK_L_(0x0A, 0x02)
#define REG_BKF00A_02_H      _PK_H_(0x0A, 0x02)
#define REG_BKF00A_03_L      _PK_L_(0x0A, 0x03)
#define REG_BKF00A_03_H      _PK_H_(0x0A, 0x03)
#define REG_BKF00A_04_L      _PK_L_(0x0A, 0x04)
#define REG_BKF00A_04_H      _PK_H_(0x0A, 0x04)
#define REG_BKF00A_05_L      _PK_L_(0x0A, 0x05)
#define REG_BKF00A_05_H      _PK_H_(0x0A, 0x05)
#define REG_BKF00A_06_L      _PK_L_(0x0A, 0x06)
#define REG_BKF00A_06_H      _PK_H_(0x0A, 0x06)
#define REG_BKF00A_07_L      _PK_L_(0x0A, 0x07)
#define REG_BKF00A_07_H      _PK_H_(0x0A, 0x07)
#define REG_BKF00A_08_L      _PK_L_(0x0A, 0x08)
#define REG_BKF00A_08_H      _PK_H_(0x0A, 0x08)
#define REG_BKF00A_09_L      _PK_L_(0x0A, 0x09)
#define REG_BKF00A_09_H      _PK_H_(0x0A, 0x09)
#define REG_BKF00A_0A_L      _PK_L_(0x0A, 0x0A)
#define REG_BKF00A_0A_H      _PK_H_(0x0A, 0x0A)
#define REG_BKF00A_0B_L      _PK_L_(0x0A, 0x0B)
#define REG_BKF00A_0B_H      _PK_H_(0x0A, 0x0B)
#define REG_BKF00A_0C_L      _PK_L_(0x0A, 0x0C)
#define REG_BKF00A_0C_H      _PK_H_(0x0A, 0x0C)
#define REG_BKF00A_0D_L      _PK_L_(0x0A, 0x0D)
#define REG_BKF00A_0D_H      _PK_H_(0x0A, 0x0D)
#define REG_BKF00A_0E_L      _PK_L_(0x0A, 0x0E)
#define REG_BKF00A_0E_H      _PK_H_(0x0A, 0x0E)
#define REG_BKF00A_0F_L      _PK_L_(0x0A, 0x0F)
#define REG_BKF00A_0F_H      _PK_H_(0x0A, 0x0F)
#define REG_BKF00A_10_L      _PK_L_(0x0A, 0x10)
#define REG_BKF00A_10_H      _PK_H_(0x0A, 0x10)
#define REG_BKF00A_11_L      _PK_L_(0x0A, 0x11)
#define REG_BKF00A_11_H      _PK_H_(0x0A, 0x11)
#define REG_BKF00A_12_L      _PK_L_(0x0A, 0x12)
#define REG_BKF00A_12_H      _PK_H_(0x0A, 0x12)
#define REG_BKF00A_13_L      _PK_L_(0x0A, 0x13)
#define REG_BKF00A_13_H      _PK_H_(0x0A, 0x13)
#define REG_BKF00A_14_L      _PK_L_(0x0A, 0x14)
#define REG_BKF00A_14_H      _PK_H_(0x0A, 0x14)
#define REG_BKF00A_15_L      _PK_L_(0x0A, 0x15)
#define REG_BKF00A_15_H      _PK_H_(0x0A, 0x15)
#define REG_BKF00A_16_L      _PK_L_(0x0A, 0x16)
#define REG_BKF00A_16_H      _PK_H_(0x0A, 0x16)
#define REG_BKF00A_17_L      _PK_L_(0x0A, 0x17)
#define REG_BKF00A_17_H      _PK_H_(0x0A, 0x17)
#define REG_BKF00A_18_L      _PK_L_(0x0A, 0x18)
#define REG_BKF00A_18_H      _PK_H_(0x0A, 0x18)
#define REG_BKF00A_19_L      _PK_L_(0x0A, 0x19)
#define REG_BKF00A_19_H      _PK_H_(0x0A, 0x19)
#define REG_BKF00A_1A_L      _PK_L_(0x0A, 0x1A)
#define REG_BKF00A_1A_H      _PK_H_(0x0A, 0x1A)
#define REG_BKF00A_1B_L      _PK_L_(0x0A, 0x1B)
#define REG_BKF00A_1B_H      _PK_H_(0x0A, 0x1B)
#define REG_BKF00A_1C_L      _PK_L_(0x0A, 0x1C)
#define REG_BKF00A_1C_H      _PK_H_(0x0A, 0x1C)
#define REG_BKF00A_1D_L      _PK_L_(0x0A, 0x1D)
#define REG_BKF00A_1D_H      _PK_H_(0x0A, 0x1D)
#define REG_BKF00A_1E_L      _PK_L_(0x0A, 0x1E)
#define REG_BKF00A_1E_H      _PK_H_(0x0A, 0x1E)
#define REG_BKF00A_1F_L      _PK_L_(0x0A, 0x1F)
#define REG_BKF00A_1F_H      _PK_H_(0x0A, 0x1F)
#define REG_BKF00A_20_L      _PK_L_(0x0A, 0x20)
#define REG_BKF00A_20_H      _PK_H_(0x0A, 0x20)
#define REG_BKF00A_21_L      _PK_L_(0x0A, 0x21)
#define REG_BKF00A_21_H      _PK_H_(0x0A, 0x21)
#define REG_BKF00A_22_L      _PK_L_(0x0A, 0x22)
#define REG_BKF00A_22_H      _PK_H_(0x0A, 0x22)
#define REG_BKF00A_23_L      _PK_L_(0x0A, 0x23)
#define REG_BKF00A_23_H      _PK_H_(0x0A, 0x23)
#define REG_BKF00A_24_L      _PK_L_(0x0A, 0x24)
#define REG_BKF00A_24_H      _PK_H_(0x0A, 0x24)
#define REG_BKF00A_25_L      _PK_L_(0x0A, 0x25)
#define REG_BKF00A_25_H      _PK_H_(0x0A, 0x25)
#define REG_BKF00A_26_L      _PK_L_(0x0A, 0x26)
#define REG_BKF00A_26_H      _PK_H_(0x0A, 0x26)
#define REG_BKF00A_27_L      _PK_L_(0x0A, 0x27)
#define REG_BKF00A_27_H      _PK_H_(0x0A, 0x27)
#define REG_BKF00A_28_L      _PK_L_(0x0A, 0x28)
#define REG_BKF00A_28_H      _PK_H_(0x0A, 0x28)
#define REG_BKF00A_29_L      _PK_L_(0x0A, 0x29)
#define REG_BKF00A_29_H      _PK_H_(0x0A, 0x29)
#define REG_BKF00A_2A_L      _PK_L_(0x0A, 0x2A)
#define REG_BKF00A_2A_H      _PK_H_(0x0A, 0x2A)
#define REG_BKF00A_2B_L      _PK_L_(0x0A, 0x2B)
#define REG_BKF00A_2B_H      _PK_H_(0x0A, 0x2B)
#define REG_BKF00A_2C_L      _PK_L_(0x0A, 0x2C)
#define REG_BKF00A_2C_H      _PK_H_(0x0A, 0x2C)
#define REG_BKF00A_2D_L      _PK_L_(0x0A, 0x2D)
#define REG_BKF00A_2D_H      _PK_H_(0x0A, 0x2D)
#define REG_BKF00A_2E_L      _PK_L_(0x0A, 0x2E)
#define REG_BKF00A_2E_H      _PK_H_(0x0A, 0x2E)
#define REG_BKF00A_2F_L      _PK_L_(0x0A, 0x2F)
#define REG_BKF00A_2F_H      _PK_H_(0x0A, 0x2F)
#define REG_BKF00A_30_L      _PK_L_(0x0A, 0x30)
#define REG_BKF00A_30_H      _PK_H_(0x0A, 0x30)
#define REG_BKF00A_31_L      _PK_L_(0x0A, 0x31)
#define REG_BKF00A_31_H      _PK_H_(0x0A, 0x31)
#define REG_BKF00A_32_L      _PK_L_(0x0A, 0x32)
#define REG_BKF00A_32_H      _PK_H_(0x0A, 0x32)
#define REG_BKF00A_33_L      _PK_L_(0x0A, 0x33)
#define REG_BKF00A_33_H      _PK_H_(0x0A, 0x33)
#define REG_BKF00A_34_L      _PK_L_(0x0A, 0x34)
#define REG_BKF00A_34_H      _PK_H_(0x0A, 0x34)
#define REG_BKF00A_35_L      _PK_L_(0x0A, 0x35)
#define REG_BKF00A_35_H      _PK_H_(0x0A, 0x35)
#define REG_BKF00A_36_L      _PK_L_(0x0A, 0x36)
#define REG_BKF00A_36_H      _PK_H_(0x0A, 0x36)
#define REG_BKF00A_37_L      _PK_L_(0x0A, 0x37)
#define REG_BKF00A_37_H      _PK_H_(0x0A, 0x37)
#define REG_BKF00A_38_L      _PK_L_(0x0A, 0x38)
#define REG_BKF00A_38_H      _PK_H_(0x0A, 0x38)
#define REG_BKF00A_39_L      _PK_L_(0x0A, 0x39)
#define REG_BKF00A_39_H      _PK_H_(0x0A, 0x39)
#define REG_BKF00A_3A_L      _PK_L_(0x0A, 0x3A)
#define REG_BKF00A_3A_H      _PK_H_(0x0A, 0x3A)
#define REG_BKF00A_3B_L      _PK_L_(0x0A, 0x3B)
#define REG_BKF00A_3B_H      _PK_H_(0x0A, 0x3B)
#define REG_BKF00A_3C_L      _PK_L_(0x0A, 0x3C)
#define REG_BKF00A_3C_H      _PK_H_(0x0A, 0x3C)
#define REG_BKF00A_3D_L      _PK_L_(0x0A, 0x3D)
#define REG_BKF00A_3D_H      _PK_H_(0x0A, 0x3D)
#define REG_BKF00A_3E_L      _PK_L_(0x0A, 0x3E)
#define REG_BKF00A_3E_H      _PK_H_(0x0A, 0x3E)
#define REG_BKF00A_3F_L      _PK_L_(0x0A, 0x3F)
#define REG_BKF00A_3F_H      _PK_H_(0x0A, 0x3F)
#define REG_BKF00A_40_L      _PK_L_(0x0A, 0x40)
#define REG_BKF00A_40_H      _PK_H_(0x0A, 0x40)
#define REG_BKF00A_41_L      _PK_L_(0x0A, 0x41)
#define REG_BKF00A_41_H      _PK_H_(0x0A, 0x41)
#define REG_BKF00A_42_L      _PK_L_(0x0A, 0x42)
#define REG_BKF00A_42_H      _PK_H_(0x0A, 0x42)
#define REG_BKF00A_43_L      _PK_L_(0x0A, 0x43)
#define REG_BKF00A_43_H      _PK_H_(0x0A, 0x43)
#define REG_BKF00A_44_L      _PK_L_(0x0A, 0x44)
#define REG_BKF00A_44_H      _PK_H_(0x0A, 0x44)
#define REG_BKF00A_45_L      _PK_L_(0x0A, 0x45)
#define REG_BKF00A_45_H      _PK_H_(0x0A, 0x45)
#define REG_BKF00A_46_L      _PK_L_(0x0A, 0x46)
#define REG_BKF00A_46_H      _PK_H_(0x0A, 0x46)
#define REG_BKF00A_47_L      _PK_L_(0x0A, 0x47)
#define REG_BKF00A_47_H      _PK_H_(0x0A, 0x47)
#define REG_BKF00A_48_L      _PK_L_(0x0A, 0x48)
#define REG_BKF00A_48_H      _PK_H_(0x0A, 0x48)
#define REG_BKF00A_49_L      _PK_L_(0x0A, 0x49)
#define REG_BKF00A_49_H      _PK_H_(0x0A, 0x49)
#define REG_BKF00A_4A_L      _PK_L_(0x0A, 0x4A)
#define REG_BKF00A_4A_H      _PK_H_(0x0A, 0x4A)
#define REG_BKF00A_4B_L      _PK_L_(0x0A, 0x4B)
#define REG_BKF00A_4B_H      _PK_H_(0x0A, 0x4B)
#define REG_BKF00A_4C_L      _PK_L_(0x0A, 0x4C)
#define REG_BKF00A_4C_H      _PK_H_(0x0A, 0x4C)
#define REG_BKF00A_4D_L      _PK_L_(0x0A, 0x4D)
#define REG_BKF00A_4D_H      _PK_H_(0x0A, 0x4D)
#define REG_BKF00A_4E_L      _PK_L_(0x0A, 0x4E)
#define REG_BKF00A_4E_H      _PK_H_(0x0A, 0x4E)
#define REG_BKF00A_4F_L      _PK_L_(0x0A, 0x4F)
#define REG_BKF00A_4F_H      _PK_H_(0x0A, 0x4F)
#define REG_BKF00A_50_L      _PK_L_(0x0A, 0x50)
#define REG_BKF00A_50_H      _PK_H_(0x0A, 0x50)
#define REG_BKF00A_51_L      _PK_L_(0x0A, 0x51)
#define REG_BKF00A_51_H      _PK_H_(0x0A, 0x51)
#define REG_BKF00A_52_L      _PK_L_(0x0A, 0x52)
#define REG_BKF00A_52_H      _PK_H_(0x0A, 0x52)
#define REG_BKF00A_53_L      _PK_L_(0x0A, 0x53)
#define REG_BKF00A_53_H      _PK_H_(0x0A, 0x53)
#define REG_BKF00A_54_L      _PK_L_(0x0A, 0x54)
#define REG_BKF00A_54_H      _PK_H_(0x0A, 0x54)
#define REG_BKF00A_55_L      _PK_L_(0x0A, 0x55)
#define REG_BKF00A_55_H      _PK_H_(0x0A, 0x55)
#define REG_BKF00A_56_L      _PK_L_(0x0A, 0x56)
#define REG_BKF00A_56_H      _PK_H_(0x0A, 0x56)
#define REG_BKF00A_57_L      _PK_L_(0x0A, 0x57)
#define REG_BKF00A_57_H      _PK_H_(0x0A, 0x57)
#define REG_BKF00A_58_L      _PK_L_(0x0A, 0x58)
#define REG_BKF00A_58_H      _PK_H_(0x0A, 0x58)
#define REG_BKF00A_59_L      _PK_L_(0x0A, 0x59)
#define REG_BKF00A_59_H      _PK_H_(0x0A, 0x59)
#define REG_BKF00A_5A_L      _PK_L_(0x0A, 0x5A)
#define REG_BKF00A_5A_H      _PK_H_(0x0A, 0x5A)
#define REG_BKF00A_5B_L      _PK_L_(0x0A, 0x5B)
#define REG_BKF00A_5B_H      _PK_H_(0x0A, 0x5B)
#define REG_BKF00A_5C_L      _PK_L_(0x0A, 0x5C)
#define REG_BKF00A_5C_H      _PK_H_(0x0A, 0x5C)
#define REG_BKF00A_5D_L      _PK_L_(0x0A, 0x5D)
#define REG_BKF00A_5D_H      _PK_H_(0x0A, 0x5D)
#define REG_BKF00A_5E_L      _PK_L_(0x0A, 0x5E)
#define REG_BKF00A_5E_H      _PK_H_(0x0A, 0x5E)
#define REG_BKF00A_5F_L      _PK_L_(0x0A, 0x5F)
#define REG_BKF00A_5F_H      _PK_H_(0x0A, 0x5F)
#define REG_BKF00A_60_L      _PK_L_(0x0A, 0x60)
#define REG_BKF00A_60_H      _PK_H_(0x0A, 0x60)
#define REG_BKF00A_61_L      _PK_L_(0x0A, 0x61)
#define REG_BKF00A_61_H      _PK_H_(0x0A, 0x61)
#define REG_BKF00A_62_L      _PK_L_(0x0A, 0x62)
#define REG_BKF00A_62_H      _PK_H_(0x0A, 0x62)
#define REG_BKF00A_63_L      _PK_L_(0x0A, 0x63)
#define REG_BKF00A_63_H      _PK_H_(0x0A, 0x63)
#define REG_BKF00A_64_L      _PK_L_(0x0A, 0x64)
#define REG_BKF00A_64_H      _PK_H_(0x0A, 0x64)
#define REG_BKF00A_65_L      _PK_L_(0x0A, 0x65)
#define REG_BKF00A_65_H      _PK_H_(0x0A, 0x65)
#define REG_BKF00A_66_L      _PK_L_(0x0A, 0x66)
#define REG_BKF00A_66_H      _PK_H_(0x0A, 0x66)
#define REG_BKF00A_67_L      _PK_L_(0x0A, 0x67)
#define REG_BKF00A_67_H      _PK_H_(0x0A, 0x67)
#define REG_BKF00A_68_L      _PK_L_(0x0A, 0x68)
#define REG_BKF00A_68_H      _PK_H_(0x0A, 0x68)
#define REG_BKF00A_69_L      _PK_L_(0x0A, 0x69)
#define REG_BKF00A_69_H      _PK_H_(0x0A, 0x69)
#define REG_BKF00A_6A_L      _PK_L_(0x0A, 0x6A)
#define REG_BKF00A_6A_H      _PK_H_(0x0A, 0x6A)
#define REG_BKF00A_6B_L      _PK_L_(0x0A, 0x6B)
#define REG_BKF00A_6B_H      _PK_H_(0x0A, 0x6B)
#define REG_BKF00A_6C_L      _PK_L_(0x0A, 0x6C)
#define REG_BKF00A_6C_H      _PK_H_(0x0A, 0x6C)
#define REG_BKF00A_6D_L      _PK_L_(0x0A, 0x6D)
#define REG_BKF00A_6D_H      _PK_H_(0x0A, 0x6D)
#define REG_BKF00A_6E_L      _PK_L_(0x0A, 0x6E)
#define REG_BKF00A_6E_H      _PK_H_(0x0A, 0x6E)
#define REG_BKF00A_6F_L      _PK_L_(0x0A, 0x6F)
#define REG_BKF00A_6F_H      _PK_H_(0x0A, 0x6F)
#define REG_BKF00A_70_L      _PK_L_(0x0A, 0x70)
#define REG_BKF00A_70_H      _PK_H_(0x0A, 0x70)
#define REG_BKF00A_71_L      _PK_L_(0x0A, 0x71)
#define REG_BKF00A_71_H      _PK_H_(0x0A, 0x71)
#define REG_BKF00A_72_L      _PK_L_(0x0A, 0x72)
#define REG_BKF00A_72_H      _PK_H_(0x0A, 0x72)
#define REG_BKF00A_73_L      _PK_L_(0x0A, 0x73)
#define REG_BKF00A_73_H      _PK_H_(0x0A, 0x73)
#define REG_BKF00A_74_L      _PK_L_(0x0A, 0x74)
#define REG_BKF00A_74_H      _PK_H_(0x0A, 0x74)
#define REG_BKF00A_75_L      _PK_L_(0x0A, 0x75)
#define REG_BKF00A_75_H      _PK_H_(0x0A, 0x75)
#define REG_BKF00A_76_L      _PK_L_(0x0A, 0x76)
#define REG_BKF00A_76_H      _PK_H_(0x0A, 0x76)
#define REG_BKF00A_77_L      _PK_L_(0x0A, 0x77)
#define REG_BKF00A_77_H      _PK_H_(0x0A, 0x77)
#define REG_BKF00A_78_L      _PK_L_(0x0A, 0x78)
#define REG_BKF00A_78_H      _PK_H_(0x0A, 0x78)
#define REG_BKF00A_79_L      _PK_L_(0x0A, 0x79)
#define REG_BKF00A_79_H      _PK_H_(0x0A, 0x79)
#define REG_BKF00A_7A_L      _PK_L_(0x0A, 0x7A)
#define REG_BKF00A_7A_H      _PK_H_(0x0A, 0x7A)
#define REG_BKF00A_7B_L      _PK_L_(0x0A, 0x7B)
#define REG_BKF00A_7B_H      _PK_H_(0x0A, 0x7B)
#define REG_BKF00A_7C_L      _PK_L_(0x0A, 0x7C)
#define REG_BKF00A_7C_H      _PK_H_(0x0A, 0x7C)
#define REG_BKF00A_7D_L      _PK_L_(0x0A, 0x7D)
#define REG_BKF00A_7D_H      _PK_H_(0x0A, 0x7D)
#define REG_BKF00A_7E_L      _PK_L_(0x0A, 0x7E)
#define REG_BKF00A_7E_H      _PK_H_(0x0A, 0x7E)
#define REG_BKF00A_7F_L      _PK_L_(0x0A, 0x7F)
#define REG_BKF00A_7F_H      _PK_H_(0x0A, 0x7F)
//----------------------------------------------
#define REG_BKF00B_00_L      _PK_L_(0x0B, 0x00)
#define REG_BKF00B_00_H      _PK_H_(0x0B, 0x00)
#define REG_BKF00B_01_L      _PK_L_(0x0B, 0x01)
#define REG_BKF00B_01_H      _PK_H_(0x0B, 0x01)
#define REG_BKF00B_02_L      _PK_L_(0x0B, 0x02)
#define REG_BKF00B_02_H      _PK_H_(0x0B, 0x02)
#define REG_BKF00B_03_L      _PK_L_(0x0B, 0x03)
#define REG_BKF00B_03_H      _PK_H_(0x0B, 0x03)
#define REG_BKF00B_04_L      _PK_L_(0x0B, 0x04)
#define REG_BKF00B_04_H      _PK_H_(0x0B, 0x04)
#define REG_BKF00B_05_L      _PK_L_(0x0B, 0x05)
#define REG_BKF00B_05_H      _PK_H_(0x0B, 0x05)
#define REG_BKF00B_06_L      _PK_L_(0x0B, 0x06)
#define REG_BKF00B_06_H      _PK_H_(0x0B, 0x06)
#define REG_BKF00B_07_L      _PK_L_(0x0B, 0x07)
#define REG_BKF00B_07_H      _PK_H_(0x0B, 0x07)
#define REG_BKF00B_08_L      _PK_L_(0x0B, 0x08)
#define REG_BKF00B_08_H      _PK_H_(0x0B, 0x08)
#define REG_BKF00B_09_L      _PK_L_(0x0B, 0x09)
#define REG_BKF00B_09_H      _PK_H_(0x0B, 0x09)
#define REG_BKF00B_0A_L      _PK_L_(0x0B, 0x0A)
#define REG_BKF00B_0A_H      _PK_H_(0x0B, 0x0A)
#define REG_BKF00B_0B_L      _PK_L_(0x0B, 0x0B)
#define REG_BKF00B_0B_H      _PK_H_(0x0B, 0x0B)
#define REG_BKF00B_0C_L      _PK_L_(0x0B, 0x0C)
#define REG_BKF00B_0C_H      _PK_H_(0x0B, 0x0C)
#define REG_BKF00B_0D_L      _PK_L_(0x0B, 0x0D)
#define REG_BKF00B_0D_H      _PK_H_(0x0B, 0x0D)
#define REG_BKF00B_0E_L      _PK_L_(0x0B, 0x0E)
#define REG_BKF00B_0E_H      _PK_H_(0x0B, 0x0E)
#define REG_BKF00B_0F_L      _PK_L_(0x0B, 0x0F)
#define REG_BKF00B_0F_H      _PK_H_(0x0B, 0x0F)
#define REG_BKF00B_10_L      _PK_L_(0x0B, 0x10)
#define REG_BKF00B_10_H      _PK_H_(0x0B, 0x10)
#define REG_BKF00B_11_L      _PK_L_(0x0B, 0x11)
#define REG_BKF00B_11_H      _PK_H_(0x0B, 0x11)
#define REG_BKF00B_12_L      _PK_L_(0x0B, 0x12)
#define REG_BKF00B_12_H      _PK_H_(0x0B, 0x12)
#define REG_BKF00B_13_L      _PK_L_(0x0B, 0x13)
#define REG_BKF00B_13_H      _PK_H_(0x0B, 0x13)
#define REG_BKF00B_14_L      _PK_L_(0x0B, 0x14)
#define REG_BKF00B_14_H      _PK_H_(0x0B, 0x14)
#define REG_BKF00B_15_L      _PK_L_(0x0B, 0x15)
#define REG_BKF00B_15_H      _PK_H_(0x0B, 0x15)
#define REG_BKF00B_16_L      _PK_L_(0x0B, 0x16)
#define REG_BKF00B_16_H      _PK_H_(0x0B, 0x16)
#define REG_BKF00B_17_L      _PK_L_(0x0B, 0x17)
#define REG_BKF00B_17_H      _PK_H_(0x0B, 0x17)
#define REG_BKF00B_18_L      _PK_L_(0x0B, 0x18)
#define REG_BKF00B_18_H      _PK_H_(0x0B, 0x18)
#define REG_BKF00B_19_L      _PK_L_(0x0B, 0x19)
#define REG_BKF00B_19_H      _PK_H_(0x0B, 0x19)
#define REG_BKF00B_1A_L      _PK_L_(0x0B, 0x1A)
#define REG_BKF00B_1A_H      _PK_H_(0x0B, 0x1A)
#define REG_BKF00B_1B_L      _PK_L_(0x0B, 0x1B)
#define REG_BKF00B_1B_H      _PK_H_(0x0B, 0x1B)
#define REG_BKF00B_1C_L      _PK_L_(0x0B, 0x1C)
#define REG_BKF00B_1C_H      _PK_H_(0x0B, 0x1C)
#define REG_BKF00B_1D_L      _PK_L_(0x0B, 0x1D)
#define REG_BKF00B_1D_H      _PK_H_(0x0B, 0x1D)
#define REG_BKF00B_1E_L      _PK_L_(0x0B, 0x1E)
#define REG_BKF00B_1E_H      _PK_H_(0x0B, 0x1E)
#define REG_BKF00B_1F_L      _PK_L_(0x0B, 0x1F)
#define REG_BKF00B_1F_H      _PK_H_(0x0B, 0x1F)
#define REG_BKF00B_20_L      _PK_L_(0x0B, 0x20)
#define REG_BKF00B_20_H      _PK_H_(0x0B, 0x20)
#define REG_BKF00B_21_L      _PK_L_(0x0B, 0x21)
#define REG_BKF00B_21_H      _PK_H_(0x0B, 0x21)
#define REG_BKF00B_22_L      _PK_L_(0x0B, 0x22)
#define REG_BKF00B_22_H      _PK_H_(0x0B, 0x22)
#define REG_BKF00B_23_L      _PK_L_(0x0B, 0x23)
#define REG_BKF00B_23_H      _PK_H_(0x0B, 0x23)
#define REG_BKF00B_24_L      _PK_L_(0x0B, 0x24)
#define REG_BKF00B_24_H      _PK_H_(0x0B, 0x24)
#define REG_BKF00B_25_L      _PK_L_(0x0B, 0x25)
#define REG_BKF00B_25_H      _PK_H_(0x0B, 0x25)
#define REG_BKF00B_26_L      _PK_L_(0x0B, 0x26)
#define REG_BKF00B_26_H      _PK_H_(0x0B, 0x26)
#define REG_BKF00B_27_L      _PK_L_(0x0B, 0x27)
#define REG_BKF00B_27_H      _PK_H_(0x0B, 0x27)
#define REG_BKF00B_28_L      _PK_L_(0x0B, 0x28)
#define REG_BKF00B_28_H      _PK_H_(0x0B, 0x28)
#define REG_BKF00B_29_L      _PK_L_(0x0B, 0x29)
#define REG_BKF00B_29_H      _PK_H_(0x0B, 0x29)
#define REG_BKF00B_2A_L      _PK_L_(0x0B, 0x2A)
#define REG_BKF00B_2A_H      _PK_H_(0x0B, 0x2A)
#define REG_BKF00B_2B_L      _PK_L_(0x0B, 0x2B)
#define REG_BKF00B_2B_H      _PK_H_(0x0B, 0x2B)
#define REG_BKF00B_2C_L      _PK_L_(0x0B, 0x2C)
#define REG_BKF00B_2C_H      _PK_H_(0x0B, 0x2C)
#define REG_BKF00B_2D_L      _PK_L_(0x0B, 0x2D)
#define REG_BKF00B_2D_H      _PK_H_(0x0B, 0x2D)
#define REG_BKF00B_2E_L      _PK_L_(0x0B, 0x2E)
#define REG_BKF00B_2E_H      _PK_H_(0x0B, 0x2E)
#define REG_BKF00B_2F_L      _PK_L_(0x0B, 0x2F)
#define REG_BKF00B_2F_H      _PK_H_(0x0B, 0x2F)
#define REG_BKF00B_30_L      _PK_L_(0x0B, 0x30)
#define REG_BKF00B_30_H      _PK_H_(0x0B, 0x30)
#define REG_BKF00B_31_L      _PK_L_(0x0B, 0x31)
#define REG_BKF00B_31_H      _PK_H_(0x0B, 0x31)
#define REG_BKF00B_32_L      _PK_L_(0x0B, 0x32)
#define REG_BKF00B_32_H      _PK_H_(0x0B, 0x32)
#define REG_BKF00B_33_L      _PK_L_(0x0B, 0x33)
#define REG_BKF00B_33_H      _PK_H_(0x0B, 0x33)
#define REG_BKF00B_34_L      _PK_L_(0x0B, 0x34)
#define REG_BKF00B_34_H      _PK_H_(0x0B, 0x34)
#define REG_BKF00B_35_L      _PK_L_(0x0B, 0x35)
#define REG_BKF00B_35_H      _PK_H_(0x0B, 0x35)
#define REG_BKF00B_36_L      _PK_L_(0x0B, 0x36)
#define REG_BKF00B_36_H      _PK_H_(0x0B, 0x36)
#define REG_BKF00B_37_L      _PK_L_(0x0B, 0x37)
#define REG_BKF00B_37_H      _PK_H_(0x0B, 0x37)
#define REG_BKF00B_38_L      _PK_L_(0x0B, 0x38)
#define REG_BKF00B_38_H      _PK_H_(0x0B, 0x38)
#define REG_BKF00B_39_L      _PK_L_(0x0B, 0x39)
#define REG_BKF00B_39_H      _PK_H_(0x0B, 0x39)
#define REG_BKF00B_3A_L      _PK_L_(0x0B, 0x3A)
#define REG_BKF00B_3A_H      _PK_H_(0x0B, 0x3A)
#define REG_BKF00B_3B_L      _PK_L_(0x0B, 0x3B)
#define REG_BKF00B_3B_H      _PK_H_(0x0B, 0x3B)
#define REG_BKF00B_3C_L      _PK_L_(0x0B, 0x3C)
#define REG_BKF00B_3C_H      _PK_H_(0x0B, 0x3C)
#define REG_BKF00B_3D_L      _PK_L_(0x0B, 0x3D)
#define REG_BKF00B_3D_H      _PK_H_(0x0B, 0x3D)
#define REG_BKF00B_3E_L      _PK_L_(0x0B, 0x3E)
#define REG_BKF00B_3E_H      _PK_H_(0x0B, 0x3E)
#define REG_BKF00B_3F_L      _PK_L_(0x0B, 0x3F)
#define REG_BKF00B_3F_H      _PK_H_(0x0B, 0x3F)
#define REG_BKF00B_40_L      _PK_L_(0x0B, 0x40)
#define REG_BKF00B_40_H      _PK_H_(0x0B, 0x40)
#define REG_BKF00B_41_L      _PK_L_(0x0B, 0x41)
#define REG_BKF00B_41_H      _PK_H_(0x0B, 0x41)
#define REG_BKF00B_42_L      _PK_L_(0x0B, 0x42)
#define REG_BKF00B_42_H      _PK_H_(0x0B, 0x42)
#define REG_BKF00B_43_L      _PK_L_(0x0B, 0x43)
#define REG_BKF00B_43_H      _PK_H_(0x0B, 0x43)
#define REG_BKF00B_44_L      _PK_L_(0x0B, 0x44)
#define REG_BKF00B_44_H      _PK_H_(0x0B, 0x44)
#define REG_BKF00B_45_L      _PK_L_(0x0B, 0x45)
#define REG_BKF00B_45_H      _PK_H_(0x0B, 0x45)
#define REG_BKF00B_46_L      _PK_L_(0x0B, 0x46)
#define REG_BKF00B_46_H      _PK_H_(0x0B, 0x46)
#define REG_BKF00B_47_L      _PK_L_(0x0B, 0x47)
#define REG_BKF00B_47_H      _PK_H_(0x0B, 0x47)
#define REG_BKF00B_48_L      _PK_L_(0x0B, 0x48)
#define REG_BKF00B_48_H      _PK_H_(0x0B, 0x48)
#define REG_BKF00B_49_L      _PK_L_(0x0B, 0x49)
#define REG_BKF00B_49_H      _PK_H_(0x0B, 0x49)
#define REG_BKF00B_4A_L      _PK_L_(0x0B, 0x4A)
#define REG_BKF00B_4A_H      _PK_H_(0x0B, 0x4A)
#define REG_BKF00B_4B_L      _PK_L_(0x0B, 0x4B)
#define REG_BKF00B_4B_H      _PK_H_(0x0B, 0x4B)
#define REG_BKF00B_4C_L      _PK_L_(0x0B, 0x4C)
#define REG_BKF00B_4C_H      _PK_H_(0x0B, 0x4C)
#define REG_BKF00B_4D_L      _PK_L_(0x0B, 0x4D)
#define REG_BKF00B_4D_H      _PK_H_(0x0B, 0x4D)
#define REG_BKF00B_4E_L      _PK_L_(0x0B, 0x4E)
#define REG_BKF00B_4E_H      _PK_H_(0x0B, 0x4E)
#define REG_BKF00B_4F_L      _PK_L_(0x0B, 0x4F)
#define REG_BKF00B_4F_H      _PK_H_(0x0B, 0x4F)
#define REG_BKF00B_50_L      _PK_L_(0x0B, 0x50)
#define REG_BKF00B_50_H      _PK_H_(0x0B, 0x50)
#define REG_BKF00B_51_L      _PK_L_(0x0B, 0x51)
#define REG_BKF00B_51_H      _PK_H_(0x0B, 0x51)
#define REG_BKF00B_52_L      _PK_L_(0x0B, 0x52)
#define REG_BKF00B_52_H      _PK_H_(0x0B, 0x52)
#define REG_BKF00B_53_L      _PK_L_(0x0B, 0x53)
#define REG_BKF00B_53_H      _PK_H_(0x0B, 0x53)
#define REG_BKF00B_54_L      _PK_L_(0x0B, 0x54)
#define REG_BKF00B_54_H      _PK_H_(0x0B, 0x54)
#define REG_BKF00B_55_L      _PK_L_(0x0B, 0x55)
#define REG_BKF00B_55_H      _PK_H_(0x0B, 0x55)
#define REG_BKF00B_56_L      _PK_L_(0x0B, 0x56)
#define REG_BKF00B_56_H      _PK_H_(0x0B, 0x56)
#define REG_BKF00B_57_L      _PK_L_(0x0B, 0x57)
#define REG_BKF00B_57_H      _PK_H_(0x0B, 0x57)
#define REG_BKF00B_58_L      _PK_L_(0x0B, 0x58)
#define REG_BKF00B_58_H      _PK_H_(0x0B, 0x58)
#define REG_BKF00B_59_L      _PK_L_(0x0B, 0x59)
#define REG_BKF00B_59_H      _PK_H_(0x0B, 0x59)
#define REG_BKF00B_5A_L      _PK_L_(0x0B, 0x5A)
#define REG_BKF00B_5A_H      _PK_H_(0x0B, 0x5A)
#define REG_BKF00B_5B_L      _PK_L_(0x0B, 0x5B)
#define REG_BKF00B_5B_H      _PK_H_(0x0B, 0x5B)
#define REG_BKF00B_5C_L      _PK_L_(0x0B, 0x5C)
#define REG_BKF00B_5C_H      _PK_H_(0x0B, 0x5C)
#define REG_BKF00B_5D_L      _PK_L_(0x0B, 0x5D)
#define REG_BKF00B_5D_H      _PK_H_(0x0B, 0x5D)
#define REG_BKF00B_5E_L      _PK_L_(0x0B, 0x5E)
#define REG_BKF00B_5E_H      _PK_H_(0x0B, 0x5E)
#define REG_BKF00B_5F_L      _PK_L_(0x0B, 0x5F)
#define REG_BKF00B_5F_H      _PK_H_(0x0B, 0x5F)
#define REG_BKF00B_60_L      _PK_L_(0x0B, 0x60)
#define REG_BKF00B_60_H      _PK_H_(0x0B, 0x60)
#define REG_BKF00B_61_L      _PK_L_(0x0B, 0x61)
#define REG_BKF00B_61_H      _PK_H_(0x0B, 0x61)
#define REG_BKF00B_62_L      _PK_L_(0x0B, 0x62)
#define REG_BKF00B_62_H      _PK_H_(0x0B, 0x62)
#define REG_BKF00B_63_L      _PK_L_(0x0B, 0x63)
#define REG_BKF00B_63_H      _PK_H_(0x0B, 0x63)
#define REG_BKF00B_64_L      _PK_L_(0x0B, 0x64)
#define REG_BKF00B_64_H      _PK_H_(0x0B, 0x64)
#define REG_BKF00B_65_L      _PK_L_(0x0B, 0x65)
#define REG_BKF00B_65_H      _PK_H_(0x0B, 0x65)
#define REG_BKF00B_66_L      _PK_L_(0x0B, 0x66)
#define REG_BKF00B_66_H      _PK_H_(0x0B, 0x66)
#define REG_BKF00B_67_L      _PK_L_(0x0B, 0x67)
#define REG_BKF00B_67_H      _PK_H_(0x0B, 0x67)
#define REG_BKF00B_68_L      _PK_L_(0x0B, 0x68)
#define REG_BKF00B_68_H      _PK_H_(0x0B, 0x68)
#define REG_BKF00B_69_L      _PK_L_(0x0B, 0x69)
#define REG_BKF00B_69_H      _PK_H_(0x0B, 0x69)
#define REG_BKF00B_6A_L      _PK_L_(0x0B, 0x6A)
#define REG_BKF00B_6A_H      _PK_H_(0x0B, 0x6A)
#define REG_BKF00B_6B_L      _PK_L_(0x0B, 0x6B)
#define REG_BKF00B_6B_H      _PK_H_(0x0B, 0x6B)
#define REG_BKF00B_6C_L      _PK_L_(0x0B, 0x6C)
#define REG_BKF00B_6C_H      _PK_H_(0x0B, 0x6C)
#define REG_BKF00B_6D_L      _PK_L_(0x0B, 0x6D)
#define REG_BKF00B_6D_H      _PK_H_(0x0B, 0x6D)
#define REG_BKF00B_6E_L      _PK_L_(0x0B, 0x6E)
#define REG_BKF00B_6E_H      _PK_H_(0x0B, 0x6E)
#define REG_BKF00B_6F_L      _PK_L_(0x0B, 0x6F)
#define REG_BKF00B_6F_H      _PK_H_(0x0B, 0x6F)
#define REG_BKF00B_70_L      _PK_L_(0x0B, 0x70)
#define REG_BKF00B_70_H      _PK_H_(0x0B, 0x70)
#define REG_BKF00B_71_L      _PK_L_(0x0B, 0x71)
#define REG_BKF00B_71_H      _PK_H_(0x0B, 0x71)
#define REG_BKF00B_72_L      _PK_L_(0x0B, 0x72)
#define REG_BKF00B_72_H      _PK_H_(0x0B, 0x72)
#define REG_BKF00B_73_L      _PK_L_(0x0B, 0x73)
#define REG_BKF00B_73_H      _PK_H_(0x0B, 0x73)
#define REG_BKF00B_74_L      _PK_L_(0x0B, 0x74)
#define REG_BKF00B_74_H      _PK_H_(0x0B, 0x74)
#define REG_BKF00B_75_L      _PK_L_(0x0B, 0x75)
#define REG_BKF00B_75_H      _PK_H_(0x0B, 0x75)
#define REG_BKF00B_76_L      _PK_L_(0x0B, 0x76)
#define REG_BKF00B_76_H      _PK_H_(0x0B, 0x76)
#define REG_BKF00B_77_L      _PK_L_(0x0B, 0x77)
#define REG_BKF00B_77_H      _PK_H_(0x0B, 0x77)
#define REG_BKF00B_78_L      _PK_L_(0x0B, 0x78)
#define REG_BKF00B_78_H      _PK_H_(0x0B, 0x78)
#define REG_BKF00B_79_L      _PK_L_(0x0B, 0x79)
#define REG_BKF00B_79_H      _PK_H_(0x0B, 0x79)
#define REG_BKF00B_7A_L      _PK_L_(0x0B, 0x7A)
#define REG_BKF00B_7A_H      _PK_H_(0x0B, 0x7A)
#define REG_BKF00B_7B_L      _PK_L_(0x0B, 0x7B)
#define REG_BKF00B_7B_H      _PK_H_(0x0B, 0x7B)
#define REG_BKF00B_7C_L      _PK_L_(0x0B, 0x7C)
#define REG_BKF00B_7C_H      _PK_H_(0x0B, 0x7C)
#define REG_BKF00B_7D_L      _PK_L_(0x0B, 0x7D)
#define REG_BKF00B_7D_H      _PK_H_(0x0B, 0x7D)
#define REG_BKF00B_7E_L      _PK_L_(0x0B, 0x7E)
#define REG_BKF00B_7E_H      _PK_H_(0x0B, 0x7E)
#define REG_BKF00B_7F_L      _PK_L_(0x0B, 0x7F)
#define REG_BKF00B_7F_H      _PK_H_(0x0B, 0x7F)
//----------------------------------------------
#define REG_BKF00C_00_L      _PK_L_(0x0C, 0x00)
#define REG_BKF00C_00_H      _PK_H_(0x0C, 0x00)
#define REG_BKF00C_01_L      _PK_L_(0x0C, 0x01)
#define REG_BKF00C_01_H      _PK_H_(0x0C, 0x01)
#define REG_BKF00C_02_L      _PK_L_(0x0C, 0x02)
#define REG_BKF00C_02_H      _PK_H_(0x0C, 0x02)
#define REG_BKF00C_03_L      _PK_L_(0x0C, 0x03)
#define REG_BKF00C_03_H      _PK_H_(0x0C, 0x03)
#define REG_BKF00C_04_L      _PK_L_(0x0C, 0x04)
#define REG_BKF00C_04_H      _PK_H_(0x0C, 0x04)
#define REG_BKF00C_05_L      _PK_L_(0x0C, 0x05)
#define REG_BKF00C_05_H      _PK_H_(0x0C, 0x05)
#define REG_BKF00C_06_L      _PK_L_(0x0C, 0x06)
#define REG_BKF00C_06_H      _PK_H_(0x0C, 0x06)
#define REG_BKF00C_07_L      _PK_L_(0x0C, 0x07)
#define REG_BKF00C_07_H      _PK_H_(0x0C, 0x07)
#define REG_BKF00C_08_L      _PK_L_(0x0C, 0x08)
#define REG_BKF00C_08_H      _PK_H_(0x0C, 0x08)
#define REG_BKF00C_09_L      _PK_L_(0x0C, 0x09)
#define REG_BKF00C_09_H      _PK_H_(0x0C, 0x09)
#define REG_BKF00C_0A_L      _PK_L_(0x0C, 0x0A)
#define REG_BKF00C_0A_H      _PK_H_(0x0C, 0x0A)
#define REG_BKF00C_0B_L      _PK_L_(0x0C, 0x0B)
#define REG_BKF00C_0B_H      _PK_H_(0x0C, 0x0B)
#define REG_BKF00C_0C_L      _PK_L_(0x0C, 0x0C)
#define REG_BKF00C_0C_H      _PK_H_(0x0C, 0x0C)
#define REG_BKF00C_0D_L      _PK_L_(0x0C, 0x0D)
#define REG_BKF00C_0D_H      _PK_H_(0x0C, 0x0D)
#define REG_BKF00C_0E_L      _PK_L_(0x0C, 0x0E)
#define REG_BKF00C_0E_H      _PK_H_(0x0C, 0x0E)
#define REG_BKF00C_0F_L      _PK_L_(0x0C, 0x0F)
#define REG_BKF00C_0F_H      _PK_H_(0x0C, 0x0F)
#define REG_BKF00C_10_L      _PK_L_(0x0C, 0x10)
#define REG_BKF00C_10_H      _PK_H_(0x0C, 0x10)
#define REG_BKF00C_11_L      _PK_L_(0x0C, 0x11)
#define REG_BKF00C_11_H      _PK_H_(0x0C, 0x11)
#define REG_BKF00C_12_L      _PK_L_(0x0C, 0x12)
#define REG_BKF00C_12_H      _PK_H_(0x0C, 0x12)
#define REG_BKF00C_13_L      _PK_L_(0x0C, 0x13)
#define REG_BKF00C_13_H      _PK_H_(0x0C, 0x13)
#define REG_BKF00C_14_L      _PK_L_(0x0C, 0x14)
#define REG_BKF00C_14_H      _PK_H_(0x0C, 0x14)
#define REG_BKF00C_15_L      _PK_L_(0x0C, 0x15)
#define REG_BKF00C_15_H      _PK_H_(0x0C, 0x15)
#define REG_BKF00C_16_L      _PK_L_(0x0C, 0x16)
#define REG_BKF00C_16_H      _PK_H_(0x0C, 0x16)
#define REG_BKF00C_17_L      _PK_L_(0x0C, 0x17)
#define REG_BKF00C_17_H      _PK_H_(0x0C, 0x17)
#define REG_BKF00C_18_L      _PK_L_(0x0C, 0x18)
#define REG_BKF00C_18_H      _PK_H_(0x0C, 0x18)
#define REG_BKF00C_19_L      _PK_L_(0x0C, 0x19)
#define REG_BKF00C_19_H      _PK_H_(0x0C, 0x19)
#define REG_BKF00C_1A_L      _PK_L_(0x0C, 0x1A)
#define REG_BKF00C_1A_H      _PK_H_(0x0C, 0x1A)
#define REG_BKF00C_1B_L      _PK_L_(0x0C, 0x1B)
#define REG_BKF00C_1B_H      _PK_H_(0x0C, 0x1B)
#define REG_BKF00C_1C_L      _PK_L_(0x0C, 0x1C)
#define REG_BKF00C_1C_H      _PK_H_(0x0C, 0x1C)
#define REG_BKF00C_1D_L      _PK_L_(0x0C, 0x1D)
#define REG_BKF00C_1D_H      _PK_H_(0x0C, 0x1D)
#define REG_BKF00C_1E_L      _PK_L_(0x0C, 0x1E)
#define REG_BKF00C_1E_H      _PK_H_(0x0C, 0x1E)
#define REG_BKF00C_1F_L      _PK_L_(0x0C, 0x1F)
#define REG_BKF00C_1F_H      _PK_H_(0x0C, 0x1F)
#define REG_BKF00C_20_L      _PK_L_(0x0C, 0x20)
#define REG_BKF00C_20_H      _PK_H_(0x0C, 0x20)
#define REG_BKF00C_21_L      _PK_L_(0x0C, 0x21)
#define REG_BKF00C_21_H      _PK_H_(0x0C, 0x21)
#define REG_BKF00C_22_L      _PK_L_(0x0C, 0x22)
#define REG_BKF00C_22_H      _PK_H_(0x0C, 0x22)
#define REG_BKF00C_23_L      _PK_L_(0x0C, 0x23)
#define REG_BKF00C_23_H      _PK_H_(0x0C, 0x23)
#define REG_BKF00C_24_L      _PK_L_(0x0C, 0x24)
#define REG_BKF00C_24_H      _PK_H_(0x0C, 0x24)
#define REG_BKF00C_25_L      _PK_L_(0x0C, 0x25)
#define REG_BKF00C_25_H      _PK_H_(0x0C, 0x25)
#define REG_BKF00C_26_L      _PK_L_(0x0C, 0x26)
#define REG_BKF00C_26_H      _PK_H_(0x0C, 0x26)
#define REG_BKF00C_27_L      _PK_L_(0x0C, 0x27)
#define REG_BKF00C_27_H      _PK_H_(0x0C, 0x27)
#define REG_BKF00C_28_L      _PK_L_(0x0C, 0x28)
#define REG_BKF00C_28_H      _PK_H_(0x0C, 0x28)
#define REG_BKF00C_29_L      _PK_L_(0x0C, 0x29)
#define REG_BKF00C_29_H      _PK_H_(0x0C, 0x29)
#define REG_BKF00C_2A_L      _PK_L_(0x0C, 0x2A)
#define REG_BKF00C_2A_H      _PK_H_(0x0C, 0x2A)
#define REG_BKF00C_2B_L      _PK_L_(0x0C, 0x2B)
#define REG_BKF00C_2B_H      _PK_H_(0x0C, 0x2B)
#define REG_BKF00C_2C_L      _PK_L_(0x0C, 0x2C)
#define REG_BKF00C_2C_H      _PK_H_(0x0C, 0x2C)
#define REG_BKF00C_2D_L      _PK_L_(0x0C, 0x2D)
#define REG_BKF00C_2D_H      _PK_H_(0x0C, 0x2D)
#define REG_BKF00C_2E_L      _PK_L_(0x0C, 0x2E)
#define REG_BKF00C_2E_H      _PK_H_(0x0C, 0x2E)
#define REG_BKF00C_2F_L      _PK_L_(0x0C, 0x2F)
#define REG_BKF00C_2F_H      _PK_H_(0x0C, 0x2F)
#define REG_BKF00C_30_L      _PK_L_(0x0C, 0x30)
#define REG_BKF00C_30_H      _PK_H_(0x0C, 0x30)
#define REG_BKF00C_31_L      _PK_L_(0x0C, 0x31)
#define REG_BKF00C_31_H      _PK_H_(0x0C, 0x31)
#define REG_BKF00C_32_L      _PK_L_(0x0C, 0x32)
#define REG_BKF00C_32_H      _PK_H_(0x0C, 0x32)
#define REG_BKF00C_33_L      _PK_L_(0x0C, 0x33)
#define REG_BKF00C_33_H      _PK_H_(0x0C, 0x33)
#define REG_BKF00C_34_L      _PK_L_(0x0C, 0x34)
#define REG_BKF00C_34_H      _PK_H_(0x0C, 0x34)
#define REG_BKF00C_35_L      _PK_L_(0x0C, 0x35)
#define REG_BKF00C_35_H      _PK_H_(0x0C, 0x35)
#define REG_BKF00C_36_L      _PK_L_(0x0C, 0x36)
#define REG_BKF00C_36_H      _PK_H_(0x0C, 0x36)
#define REG_BKF00C_37_L      _PK_L_(0x0C, 0x37)
#define REG_BKF00C_37_H      _PK_H_(0x0C, 0x37)
#define REG_BKF00C_38_L      _PK_L_(0x0C, 0x38)
#define REG_BKF00C_38_H      _PK_H_(0x0C, 0x38)
#define REG_BKF00C_39_L      _PK_L_(0x0C, 0x39)
#define REG_BKF00C_39_H      _PK_H_(0x0C, 0x39)
#define REG_BKF00C_3A_L      _PK_L_(0x0C, 0x3A)
#define REG_BKF00C_3A_H      _PK_H_(0x0C, 0x3A)
#define REG_BKF00C_3B_L      _PK_L_(0x0C, 0x3B)
#define REG_BKF00C_3B_H      _PK_H_(0x0C, 0x3B)
#define REG_BKF00C_3C_L      _PK_L_(0x0C, 0x3C)
#define REG_BKF00C_3C_H      _PK_H_(0x0C, 0x3C)
#define REG_BKF00C_3D_L      _PK_L_(0x0C, 0x3D)
#define REG_BKF00C_3D_H      _PK_H_(0x0C, 0x3D)
#define REG_BKF00C_3E_L      _PK_L_(0x0C, 0x3E)
#define REG_BKF00C_3E_H      _PK_H_(0x0C, 0x3E)
#define REG_BKF00C_3F_L      _PK_L_(0x0C, 0x3F)
#define REG_BKF00C_3F_H      _PK_H_(0x0C, 0x3F)
#define REG_BKF00C_40_L      _PK_L_(0x0C, 0x40)
#define REG_BKF00C_40_H      _PK_H_(0x0C, 0x40)
#define REG_BKF00C_41_L      _PK_L_(0x0C, 0x41)
#define REG_BKF00C_41_H      _PK_H_(0x0C, 0x41)
#define REG_BKF00C_42_L      _PK_L_(0x0C, 0x42)
#define REG_BKF00C_42_H      _PK_H_(0x0C, 0x42)
#define REG_BKF00C_43_L      _PK_L_(0x0C, 0x43)
#define REG_BKF00C_43_H      _PK_H_(0x0C, 0x43)
#define REG_BKF00C_44_L      _PK_L_(0x0C, 0x44)
#define REG_BKF00C_44_H      _PK_H_(0x0C, 0x44)
#define REG_BKF00C_45_L      _PK_L_(0x0C, 0x45)
#define REG_BKF00C_45_H      _PK_H_(0x0C, 0x45)
#define REG_BKF00C_46_L      _PK_L_(0x0C, 0x46)
#define REG_BKF00C_46_H      _PK_H_(0x0C, 0x46)
#define REG_BKF00C_47_L      _PK_L_(0x0C, 0x47)
#define REG_BKF00C_47_H      _PK_H_(0x0C, 0x47)
#define REG_BKF00C_48_L      _PK_L_(0x0C, 0x48)
#define REG_BKF00C_48_H      _PK_H_(0x0C, 0x48)
#define REG_BKF00C_49_L      _PK_L_(0x0C, 0x49)
#define REG_BKF00C_49_H      _PK_H_(0x0C, 0x49)
#define REG_BKF00C_4A_L      _PK_L_(0x0C, 0x4A)
#define REG_BKF00C_4A_H      _PK_H_(0x0C, 0x4A)
#define REG_BKF00C_4B_L      _PK_L_(0x0C, 0x4B)
#define REG_BKF00C_4B_H      _PK_H_(0x0C, 0x4B)
#define REG_BKF00C_4C_L      _PK_L_(0x0C, 0x4C)
#define REG_BKF00C_4C_H      _PK_H_(0x0C, 0x4C)
#define REG_BKF00C_4D_L      _PK_L_(0x0C, 0x4D)
#define REG_BKF00C_4D_H      _PK_H_(0x0C, 0x4D)
#define REG_BKF00C_4E_L      _PK_L_(0x0C, 0x4E)
#define REG_BKF00C_4E_H      _PK_H_(0x0C, 0x4E)
#define REG_BKF00C_4F_L      _PK_L_(0x0C, 0x4F)
#define REG_BKF00C_4F_H      _PK_H_(0x0C, 0x4F)
#define REG_BKF00C_50_L      _PK_L_(0x0C, 0x50)
#define REG_BKF00C_50_H      _PK_H_(0x0C, 0x50)
#define REG_BKF00C_51_L      _PK_L_(0x0C, 0x51)
#define REG_BKF00C_51_H      _PK_H_(0x0C, 0x51)
#define REG_BKF00C_52_L      _PK_L_(0x0C, 0x52)
#define REG_BKF00C_52_H      _PK_H_(0x0C, 0x52)
#define REG_BKF00C_53_L      _PK_L_(0x0C, 0x53)
#define REG_BKF00C_53_H      _PK_H_(0x0C, 0x53)
#define REG_BKF00C_54_L      _PK_L_(0x0C, 0x54)
#define REG_BKF00C_54_H      _PK_H_(0x0C, 0x54)
#define REG_BKF00C_55_L      _PK_L_(0x0C, 0x55)
#define REG_BKF00C_55_H      _PK_H_(0x0C, 0x55)
#define REG_BKF00C_56_L      _PK_L_(0x0C, 0x56)
#define REG_BKF00C_56_H      _PK_H_(0x0C, 0x56)
#define REG_BKF00C_57_L      _PK_L_(0x0C, 0x57)
#define REG_BKF00C_57_H      _PK_H_(0x0C, 0x57)
#define REG_BKF00C_58_L      _PK_L_(0x0C, 0x58)
#define REG_BKF00C_58_H      _PK_H_(0x0C, 0x58)
#define REG_BKF00C_59_L      _PK_L_(0x0C, 0x59)
#define REG_BKF00C_59_H      _PK_H_(0x0C, 0x59)
#define REG_BKF00C_5A_L      _PK_L_(0x0C, 0x5A)
#define REG_BKF00C_5A_H      _PK_H_(0x0C, 0x5A)
#define REG_BKF00C_5B_L      _PK_L_(0x0C, 0x5B)
#define REG_BKF00C_5B_H      _PK_H_(0x0C, 0x5B)
#define REG_BKF00C_5C_L      _PK_L_(0x0C, 0x5C)
#define REG_BKF00C_5C_H      _PK_H_(0x0C, 0x5C)
#define REG_BKF00C_5D_L      _PK_L_(0x0C, 0x5D)
#define REG_BKF00C_5D_H      _PK_H_(0x0C, 0x5D)
#define REG_BKF00C_5E_L      _PK_L_(0x0C, 0x5E)
#define REG_BKF00C_5E_H      _PK_H_(0x0C, 0x5E)
#define REG_BKF00C_5F_L      _PK_L_(0x0C, 0x5F)
#define REG_BKF00C_5F_H      _PK_H_(0x0C, 0x5F)
#define REG_BKF00C_60_L      _PK_L_(0x0C, 0x60)
#define REG_BKF00C_60_H      _PK_H_(0x0C, 0x60)
#define REG_BKF00C_61_L      _PK_L_(0x0C, 0x61)
#define REG_BKF00C_61_H      _PK_H_(0x0C, 0x61)
#define REG_BKF00C_62_L      _PK_L_(0x0C, 0x62)
#define REG_BKF00C_62_H      _PK_H_(0x0C, 0x62)
#define REG_BKF00C_63_L      _PK_L_(0x0C, 0x63)
#define REG_BKF00C_63_H      _PK_H_(0x0C, 0x63)
#define REG_BKF00C_64_L      _PK_L_(0x0C, 0x64)
#define REG_BKF00C_64_H      _PK_H_(0x0C, 0x64)
#define REG_BKF00C_65_L      _PK_L_(0x0C, 0x65)
#define REG_BKF00C_65_H      _PK_H_(0x0C, 0x65)
#define REG_BKF00C_66_L      _PK_L_(0x0C, 0x66)
#define REG_BKF00C_66_H      _PK_H_(0x0C, 0x66)
#define REG_BKF00C_67_L      _PK_L_(0x0C, 0x67)
#define REG_BKF00C_67_H      _PK_H_(0x0C, 0x67)
#define REG_BKF00C_68_L      _PK_L_(0x0C, 0x68)
#define REG_BKF00C_68_H      _PK_H_(0x0C, 0x68)
#define REG_BKF00C_69_L      _PK_L_(0x0C, 0x69)
#define REG_BKF00C_69_H      _PK_H_(0x0C, 0x69)
#define REG_BKF00C_6A_L      _PK_L_(0x0C, 0x6A)
#define REG_BKF00C_6A_H      _PK_H_(0x0C, 0x6A)
#define REG_BKF00C_6B_L      _PK_L_(0x0C, 0x6B)
#define REG_BKF00C_6B_H      _PK_H_(0x0C, 0x6B)
#define REG_BKF00C_6C_L      _PK_L_(0x0C, 0x6C)
#define REG_BKF00C_6C_H      _PK_H_(0x0C, 0x6C)
#define REG_BKF00C_6D_L      _PK_L_(0x0C, 0x6D)
#define REG_BKF00C_6D_H      _PK_H_(0x0C, 0x6D)
#define REG_BKF00C_6E_L      _PK_L_(0x0C, 0x6E)
#define REG_BKF00C_6E_H      _PK_H_(0x0C, 0x6E)
#define REG_BKF00C_6F_L      _PK_L_(0x0C, 0x6F)
#define REG_BKF00C_6F_H      _PK_H_(0x0C, 0x6F)
#define REG_BKF00C_70_L      _PK_L_(0x0C, 0x70)
#define REG_BKF00C_70_H      _PK_H_(0x0C, 0x70)
#define REG_BKF00C_71_L      _PK_L_(0x0C, 0x71)
#define REG_BKF00C_71_H      _PK_H_(0x0C, 0x71)
#define REG_BKF00C_72_L      _PK_L_(0x0C, 0x72)
#define REG_BKF00C_72_H      _PK_H_(0x0C, 0x72)
#define REG_BKF00C_73_L      _PK_L_(0x0C, 0x73)
#define REG_BKF00C_73_H      _PK_H_(0x0C, 0x73)
#define REG_BKF00C_74_L      _PK_L_(0x0C, 0x74)
#define REG_BKF00C_74_H      _PK_H_(0x0C, 0x74)
#define REG_BKF00C_75_L      _PK_L_(0x0C, 0x75)
#define REG_BKF00C_75_H      _PK_H_(0x0C, 0x75)
#define REG_BKF00C_76_L      _PK_L_(0x0C, 0x76)
#define REG_BKF00C_76_H      _PK_H_(0x0C, 0x76)
#define REG_BKF00C_77_L      _PK_L_(0x0C, 0x77)
#define REG_BKF00C_77_H      _PK_H_(0x0C, 0x77)
#define REG_BKF00C_78_L      _PK_L_(0x0C, 0x78)
#define REG_BKF00C_78_H      _PK_H_(0x0C, 0x78)
#define REG_BKF00C_79_L      _PK_L_(0x0C, 0x79)
#define REG_BKF00C_79_H      _PK_H_(0x0C, 0x79)
#define REG_BKF00C_7A_L      _PK_L_(0x0C, 0x7A)
#define REG_BKF00C_7A_H      _PK_H_(0x0C, 0x7A)
#define REG_BKF00C_7B_L      _PK_L_(0x0C, 0x7B)
#define REG_BKF00C_7B_H      _PK_H_(0x0C, 0x7B)
#define REG_BKF00C_7C_L      _PK_L_(0x0C, 0x7C)
#define REG_BKF00C_7C_H      _PK_H_(0x0C, 0x7C)
#define REG_BKF00C_7D_L      _PK_L_(0x0C, 0x7D)
#define REG_BKF00C_7D_H      _PK_H_(0x0C, 0x7D)
#define REG_BKF00C_7E_L      _PK_L_(0x0C, 0x7E)
#define REG_BKF00C_7E_H      _PK_H_(0x0C, 0x7E)
#define REG_BKF00C_7F_L      _PK_L_(0x0C, 0x7F)
#define REG_BKF00C_7F_H      _PK_H_(0x0C, 0x7F)
//----------------------------------------------
#define REG_BKF00D_00_L      _PK_L_(0x0D, 0x00)
#define REG_BKF00D_00_H      _PK_H_(0x0D, 0x00)
#define REG_BKF00D_01_L      _PK_L_(0x0D, 0x01)
#define REG_BKF00D_01_H      _PK_H_(0x0D, 0x01)
#define REG_BKF00D_02_L      _PK_L_(0x0D, 0x02)
#define REG_BKF00D_02_H      _PK_H_(0x0D, 0x02)
#define REG_BKF00D_03_L      _PK_L_(0x0D, 0x03)
#define REG_BKF00D_03_H      _PK_H_(0x0D, 0x03)
#define REG_BKF00D_04_L      _PK_L_(0x0D, 0x04)
#define REG_BKF00D_04_H      _PK_H_(0x0D, 0x04)
#define REG_BKF00D_05_L      _PK_L_(0x0D, 0x05)
#define REG_BKF00D_05_H      _PK_H_(0x0D, 0x05)
#define REG_BKF00D_06_L      _PK_L_(0x0D, 0x06)
#define REG_BKF00D_06_H      _PK_H_(0x0D, 0x06)
#define REG_BKF00D_07_L      _PK_L_(0x0D, 0x07)
#define REG_BKF00D_07_H      _PK_H_(0x0D, 0x07)
#define REG_BKF00D_08_L      _PK_L_(0x0D, 0x08)
#define REG_BKF00D_08_H      _PK_H_(0x0D, 0x08)
#define REG_BKF00D_09_L      _PK_L_(0x0D, 0x09)
#define REG_BKF00D_09_H      _PK_H_(0x0D, 0x09)
#define REG_BKF00D_0A_L      _PK_L_(0x0D, 0x0A)
#define REG_BKF00D_0A_H      _PK_H_(0x0D, 0x0A)
#define REG_BKF00D_0B_L      _PK_L_(0x0D, 0x0B)
#define REG_BKF00D_0B_H      _PK_H_(0x0D, 0x0B)
#define REG_BKF00D_0C_L      _PK_L_(0x0D, 0x0C)
#define REG_BKF00D_0C_H      _PK_H_(0x0D, 0x0C)
#define REG_BKF00D_0D_L      _PK_L_(0x0D, 0x0D)
#define REG_BKF00D_0D_H      _PK_H_(0x0D, 0x0D)
#define REG_BKF00D_0E_L      _PK_L_(0x0D, 0x0E)
#define REG_BKF00D_0E_H      _PK_H_(0x0D, 0x0E)
#define REG_BKF00D_0F_L      _PK_L_(0x0D, 0x0F)
#define REG_BKF00D_0F_H      _PK_H_(0x0D, 0x0F)
#define REG_BKF00D_10_L      _PK_L_(0x0D, 0x10)
#define REG_BKF00D_10_H      _PK_H_(0x0D, 0x10)
#define REG_BKF00D_11_L      _PK_L_(0x0D, 0x11)
#define REG_BKF00D_11_H      _PK_H_(0x0D, 0x11)
#define REG_BKF00D_12_L      _PK_L_(0x0D, 0x12)
#define REG_BKF00D_12_H      _PK_H_(0x0D, 0x12)
#define REG_BKF00D_13_L      _PK_L_(0x0D, 0x13)
#define REG_BKF00D_13_H      _PK_H_(0x0D, 0x13)
#define REG_BKF00D_14_L      _PK_L_(0x0D, 0x14)
#define REG_BKF00D_14_H      _PK_H_(0x0D, 0x14)
#define REG_BKF00D_15_L      _PK_L_(0x0D, 0x15)
#define REG_BKF00D_15_H      _PK_H_(0x0D, 0x15)
#define REG_BKF00D_16_L      _PK_L_(0x0D, 0x16)
#define REG_BKF00D_16_H      _PK_H_(0x0D, 0x16)
#define REG_BKF00D_17_L      _PK_L_(0x0D, 0x17)
#define REG_BKF00D_17_H      _PK_H_(0x0D, 0x17)
#define REG_BKF00D_18_L      _PK_L_(0x0D, 0x18)
#define REG_BKF00D_18_H      _PK_H_(0x0D, 0x18)
#define REG_BKF00D_19_L      _PK_L_(0x0D, 0x19)
#define REG_BKF00D_19_H      _PK_H_(0x0D, 0x19)
#define REG_BKF00D_1A_L      _PK_L_(0x0D, 0x1A)
#define REG_BKF00D_1A_H      _PK_H_(0x0D, 0x1A)
#define REG_BKF00D_1B_L      _PK_L_(0x0D, 0x1B)
#define REG_BKF00D_1B_H      _PK_H_(0x0D, 0x1B)
#define REG_BKF00D_1C_L      _PK_L_(0x0D, 0x1C)
#define REG_BKF00D_1C_H      _PK_H_(0x0D, 0x1C)
#define REG_BKF00D_1D_L      _PK_L_(0x0D, 0x1D)
#define REG_BKF00D_1D_H      _PK_H_(0x0D, 0x1D)
#define REG_BKF00D_1E_L      _PK_L_(0x0D, 0x1E)
#define REG_BKF00D_1E_H      _PK_H_(0x0D, 0x1E)
#define REG_BKF00D_1F_L      _PK_L_(0x0D, 0x1F)
#define REG_BKF00D_1F_H      _PK_H_(0x0D, 0x1F)
#define REG_BKF00D_20_L      _PK_L_(0x0D, 0x20)
#define REG_BKF00D_20_H      _PK_H_(0x0D, 0x20)
#define REG_BKF00D_21_L      _PK_L_(0x0D, 0x21)
#define REG_BKF00D_21_H      _PK_H_(0x0D, 0x21)
#define REG_BKF00D_22_L      _PK_L_(0x0D, 0x22)
#define REG_BKF00D_22_H      _PK_H_(0x0D, 0x22)
#define REG_BKF00D_23_L      _PK_L_(0x0D, 0x23)
#define REG_BKF00D_23_H      _PK_H_(0x0D, 0x23)
#define REG_BKF00D_24_L      _PK_L_(0x0D, 0x24)
#define REG_BKF00D_24_H      _PK_H_(0x0D, 0x24)
#define REG_BKF00D_25_L      _PK_L_(0x0D, 0x25)
#define REG_BKF00D_25_H      _PK_H_(0x0D, 0x25)
#define REG_BKF00D_26_L      _PK_L_(0x0D, 0x26)
#define REG_BKF00D_26_H      _PK_H_(0x0D, 0x26)
#define REG_BKF00D_27_L      _PK_L_(0x0D, 0x27)
#define REG_BKF00D_27_H      _PK_H_(0x0D, 0x27)
#define REG_BKF00D_28_L      _PK_L_(0x0D, 0x28)
#define REG_BKF00D_28_H      _PK_H_(0x0D, 0x28)
#define REG_BKF00D_29_L      _PK_L_(0x0D, 0x29)
#define REG_BKF00D_29_H      _PK_H_(0x0D, 0x29)
#define REG_BKF00D_2A_L      _PK_L_(0x0D, 0x2A)
#define REG_BKF00D_2A_H      _PK_H_(0x0D, 0x2A)
#define REG_BKF00D_2B_L      _PK_L_(0x0D, 0x2B)
#define REG_BKF00D_2B_H      _PK_H_(0x0D, 0x2B)
#define REG_BKF00D_2C_L      _PK_L_(0x0D, 0x2C)
#define REG_BKF00D_2C_H      _PK_H_(0x0D, 0x2C)
#define REG_BKF00D_2D_L      _PK_L_(0x0D, 0x2D)
#define REG_BKF00D_2D_H      _PK_H_(0x0D, 0x2D)
#define REG_BKF00D_2E_L      _PK_L_(0x0D, 0x2E)
#define REG_BKF00D_2E_H      _PK_H_(0x0D, 0x2E)
#define REG_BKF00D_2F_L      _PK_L_(0x0D, 0x2F)
#define REG_BKF00D_2F_H      _PK_H_(0x0D, 0x2F)
#define REG_BKF00D_30_L      _PK_L_(0x0D, 0x30)
#define REG_BKF00D_30_H      _PK_H_(0x0D, 0x30)
#define REG_BKF00D_31_L      _PK_L_(0x0D, 0x31)
#define REG_BKF00D_31_H      _PK_H_(0x0D, 0x31)
#define REG_BKF00D_32_L      _PK_L_(0x0D, 0x32)
#define REG_BKF00D_32_H      _PK_H_(0x0D, 0x32)
#define REG_BKF00D_33_L      _PK_L_(0x0D, 0x33)
#define REG_BKF00D_33_H      _PK_H_(0x0D, 0x33)
#define REG_BKF00D_34_L      _PK_L_(0x0D, 0x34)
#define REG_BKF00D_34_H      _PK_H_(0x0D, 0x34)
#define REG_BKF00D_35_L      _PK_L_(0x0D, 0x35)
#define REG_BKF00D_35_H      _PK_H_(0x0D, 0x35)
#define REG_BKF00D_36_L      _PK_L_(0x0D, 0x36)
#define REG_BKF00D_36_H      _PK_H_(0x0D, 0x36)
#define REG_BKF00D_37_L      _PK_L_(0x0D, 0x37)
#define REG_BKF00D_37_H      _PK_H_(0x0D, 0x37)
#define REG_BKF00D_38_L      _PK_L_(0x0D, 0x38)
#define REG_BKF00D_38_H      _PK_H_(0x0D, 0x38)
#define REG_BKF00D_39_L      _PK_L_(0x0D, 0x39)
#define REG_BKF00D_39_H      _PK_H_(0x0D, 0x39)
#define REG_BKF00D_3A_L      _PK_L_(0x0D, 0x3A)
#define REG_BKF00D_3A_H      _PK_H_(0x0D, 0x3A)
#define REG_BKF00D_3B_L      _PK_L_(0x0D, 0x3B)
#define REG_BKF00D_3B_H      _PK_H_(0x0D, 0x3B)
#define REG_BKF00D_3C_L      _PK_L_(0x0D, 0x3C)
#define REG_BKF00D_3C_H      _PK_H_(0x0D, 0x3C)
#define REG_BKF00D_3D_L      _PK_L_(0x0D, 0x3D)
#define REG_BKF00D_3D_H      _PK_H_(0x0D, 0x3D)
#define REG_BKF00D_3E_L      _PK_L_(0x0D, 0x3E)
#define REG_BKF00D_3E_H      _PK_H_(0x0D, 0x3E)
#define REG_BKF00D_3F_L      _PK_L_(0x0D, 0x3F)
#define REG_BKF00D_3F_H      _PK_H_(0x0D, 0x3F)
#define REG_BKF00D_40_L      _PK_L_(0x0D, 0x40)
#define REG_BKF00D_40_H      _PK_H_(0x0D, 0x40)
#define REG_BKF00D_41_L      _PK_L_(0x0D, 0x41)
#define REG_BKF00D_41_H      _PK_H_(0x0D, 0x41)
#define REG_BKF00D_42_L      _PK_L_(0x0D, 0x42)
#define REG_BKF00D_42_H      _PK_H_(0x0D, 0x42)
#define REG_BKF00D_43_L      _PK_L_(0x0D, 0x43)
#define REG_BKF00D_43_H      _PK_H_(0x0D, 0x43)
#define REG_BKF00D_44_L      _PK_L_(0x0D, 0x44)
#define REG_BKF00D_44_H      _PK_H_(0x0D, 0x44)
#define REG_BKF00D_45_L      _PK_L_(0x0D, 0x45)
#define REG_BKF00D_45_H      _PK_H_(0x0D, 0x45)
#define REG_BKF00D_46_L      _PK_L_(0x0D, 0x46)
#define REG_BKF00D_46_H      _PK_H_(0x0D, 0x46)
#define REG_BKF00D_47_L      _PK_L_(0x0D, 0x47)
#define REG_BKF00D_47_H      _PK_H_(0x0D, 0x47)
#define REG_BKF00D_48_L      _PK_L_(0x0D, 0x48)
#define REG_BKF00D_48_H      _PK_H_(0x0D, 0x48)
#define REG_BKF00D_49_L      _PK_L_(0x0D, 0x49)
#define REG_BKF00D_49_H      _PK_H_(0x0D, 0x49)
#define REG_BKF00D_4A_L      _PK_L_(0x0D, 0x4A)
#define REG_BKF00D_4A_H      _PK_H_(0x0D, 0x4A)
#define REG_BKF00D_4B_L      _PK_L_(0x0D, 0x4B)
#define REG_BKF00D_4B_H      _PK_H_(0x0D, 0x4B)
#define REG_BKF00D_4C_L      _PK_L_(0x0D, 0x4C)
#define REG_BKF00D_4C_H      _PK_H_(0x0D, 0x4C)
#define REG_BKF00D_4D_L      _PK_L_(0x0D, 0x4D)
#define REG_BKF00D_4D_H      _PK_H_(0x0D, 0x4D)
#define REG_BKF00D_4E_L      _PK_L_(0x0D, 0x4E)
#define REG_BKF00D_4E_H      _PK_H_(0x0D, 0x4E)
#define REG_BKF00D_4F_L      _PK_L_(0x0D, 0x4F)
#define REG_BKF00D_4F_H      _PK_H_(0x0D, 0x4F)
#define REG_BKF00D_50_L      _PK_L_(0x0D, 0x50)
#define REG_BKF00D_50_H      _PK_H_(0x0D, 0x50)
#define REG_BKF00D_51_L      _PK_L_(0x0D, 0x51)
#define REG_BKF00D_51_H      _PK_H_(0x0D, 0x51)
#define REG_BKF00D_52_L      _PK_L_(0x0D, 0x52)
#define REG_BKF00D_52_H      _PK_H_(0x0D, 0x52)
#define REG_BKF00D_53_L      _PK_L_(0x0D, 0x53)
#define REG_BKF00D_53_H      _PK_H_(0x0D, 0x53)
#define REG_BKF00D_54_L      _PK_L_(0x0D, 0x54)
#define REG_BKF00D_54_H      _PK_H_(0x0D, 0x54)
#define REG_BKF00D_55_L      _PK_L_(0x0D, 0x55)
#define REG_BKF00D_55_H      _PK_H_(0x0D, 0x55)
#define REG_BKF00D_56_L      _PK_L_(0x0D, 0x56)
#define REG_BKF00D_56_H      _PK_H_(0x0D, 0x56)
#define REG_BKF00D_57_L      _PK_L_(0x0D, 0x57)
#define REG_BKF00D_57_H      _PK_H_(0x0D, 0x57)
#define REG_BKF00D_58_L      _PK_L_(0x0D, 0x58)
#define REG_BKF00D_58_H      _PK_H_(0x0D, 0x58)
#define REG_BKF00D_59_L      _PK_L_(0x0D, 0x59)
#define REG_BKF00D_59_H      _PK_H_(0x0D, 0x59)
#define REG_BKF00D_5A_L      _PK_L_(0x0D, 0x5A)
#define REG_BKF00D_5A_H      _PK_H_(0x0D, 0x5A)
#define REG_BKF00D_5B_L      _PK_L_(0x0D, 0x5B)
#define REG_BKF00D_5B_H      _PK_H_(0x0D, 0x5B)
#define REG_BKF00D_5C_L      _PK_L_(0x0D, 0x5C)
#define REG_BKF00D_5C_H      _PK_H_(0x0D, 0x5C)
#define REG_BKF00D_5D_L      _PK_L_(0x0D, 0x5D)
#define REG_BKF00D_5D_H      _PK_H_(0x0D, 0x5D)
#define REG_BKF00D_5E_L      _PK_L_(0x0D, 0x5E)
#define REG_BKF00D_5E_H      _PK_H_(0x0D, 0x5E)
#define REG_BKF00D_5F_L      _PK_L_(0x0D, 0x5F)
#define REG_BKF00D_5F_H      _PK_H_(0x0D, 0x5F)
#define REG_BKF00D_60_L      _PK_L_(0x0D, 0x60)
#define REG_BKF00D_60_H      _PK_H_(0x0D, 0x60)
#define REG_BKF00D_61_L      _PK_L_(0x0D, 0x61)
#define REG_BKF00D_61_H      _PK_H_(0x0D, 0x61)
#define REG_BKF00D_62_L      _PK_L_(0x0D, 0x62)
#define REG_BKF00D_62_H      _PK_H_(0x0D, 0x62)
#define REG_BKF00D_63_L      _PK_L_(0x0D, 0x63)
#define REG_BKF00D_63_H      _PK_H_(0x0D, 0x63)
#define REG_BKF00D_64_L      _PK_L_(0x0D, 0x64)
#define REG_BKF00D_64_H      _PK_H_(0x0D, 0x64)
#define REG_BKF00D_65_L      _PK_L_(0x0D, 0x65)
#define REG_BKF00D_65_H      _PK_H_(0x0D, 0x65)
#define REG_BKF00D_66_L      _PK_L_(0x0D, 0x66)
#define REG_BKF00D_66_H      _PK_H_(0x0D, 0x66)
#define REG_BKF00D_67_L      _PK_L_(0x0D, 0x67)
#define REG_BKF00D_67_H      _PK_H_(0x0D, 0x67)
#define REG_BKF00D_68_L      _PK_L_(0x0D, 0x68)
#define REG_BKF00D_68_H      _PK_H_(0x0D, 0x68)
#define REG_BKF00D_69_L      _PK_L_(0x0D, 0x69)
#define REG_BKF00D_69_H      _PK_H_(0x0D, 0x69)
#define REG_BKF00D_6A_L      _PK_L_(0x0D, 0x6A)
#define REG_BKF00D_6A_H      _PK_H_(0x0D, 0x6A)
#define REG_BKF00D_6B_L      _PK_L_(0x0D, 0x6B)
#define REG_BKF00D_6B_H      _PK_H_(0x0D, 0x6B)
#define REG_BKF00D_6C_L      _PK_L_(0x0D, 0x6C)
#define REG_BKF00D_6C_H      _PK_H_(0x0D, 0x6C)
#define REG_BKF00D_6D_L      _PK_L_(0x0D, 0x6D)
#define REG_BKF00D_6D_H      _PK_H_(0x0D, 0x6D)
#define REG_BKF00D_6E_L      _PK_L_(0x0D, 0x6E)
#define REG_BKF00D_6E_H      _PK_H_(0x0D, 0x6E)
#define REG_BKF00D_6F_L      _PK_L_(0x0D, 0x6F)
#define REG_BKF00D_6F_H      _PK_H_(0x0D, 0x6F)
#define REG_BKF00D_70_L      _PK_L_(0x0D, 0x70)
#define REG_BKF00D_70_H      _PK_H_(0x0D, 0x70)
#define REG_BKF00D_71_L      _PK_L_(0x0D, 0x71)
#define REG_BKF00D_71_H      _PK_H_(0x0D, 0x71)
#define REG_BKF00D_72_L      _PK_L_(0x0D, 0x72)
#define REG_BKF00D_72_H      _PK_H_(0x0D, 0x72)
#define REG_BKF00D_73_L      _PK_L_(0x0D, 0x73)
#define REG_BKF00D_73_H      _PK_H_(0x0D, 0x73)
#define REG_BKF00D_74_L      _PK_L_(0x0D, 0x74)
#define REG_BKF00D_74_H      _PK_H_(0x0D, 0x74)
#define REG_BKF00D_75_L      _PK_L_(0x0D, 0x75)
#define REG_BKF00D_75_H      _PK_H_(0x0D, 0x75)
#define REG_BKF00D_76_L      _PK_L_(0x0D, 0x76)
#define REG_BKF00D_76_H      _PK_H_(0x0D, 0x76)
#define REG_BKF00D_77_L      _PK_L_(0x0D, 0x77)
#define REG_BKF00D_77_H      _PK_H_(0x0D, 0x77)
#define REG_BKF00D_78_L      _PK_L_(0x0D, 0x78)
#define REG_BKF00D_78_H      _PK_H_(0x0D, 0x78)
#define REG_BKF00D_79_L      _PK_L_(0x0D, 0x79)
#define REG_BKF00D_79_H      _PK_H_(0x0D, 0x79)
#define REG_BKF00D_7A_L      _PK_L_(0x0D, 0x7A)
#define REG_BKF00D_7A_H      _PK_H_(0x0D, 0x7A)
#define REG_BKF00D_7B_L      _PK_L_(0x0D, 0x7B)
#define REG_BKF00D_7B_H      _PK_H_(0x0D, 0x7B)
#define REG_BKF00D_7C_L      _PK_L_(0x0D, 0x7C)
#define REG_BKF00D_7C_H      _PK_H_(0x0D, 0x7C)
#define REG_BKF00D_7D_L      _PK_L_(0x0D, 0x7D)
#define REG_BKF00D_7D_H      _PK_H_(0x0D, 0x7D)
#define REG_BKF00D_7E_L      _PK_L_(0x0D, 0x7E)
#define REG_BKF00D_7E_H      _PK_H_(0x0D, 0x7E)
#define REG_BKF00D_7F_L      _PK_L_(0x0D, 0x7F)
#define REG_BKF00D_7F_H      _PK_H_(0x0D, 0x7F)
//----------------------------------------------
#define REG_BKF00E_00_L      _PK_L_(0x0E, 0x00)
#define REG_BKF00E_00_H      _PK_H_(0x0E, 0x00)
#define REG_BKF00E_01_L      _PK_L_(0x0E, 0x01)
#define REG_BKF00E_01_H      _PK_H_(0x0E, 0x01)
#define REG_BKF00E_02_L      _PK_L_(0x0E, 0x02)
#define REG_BKF00E_02_H      _PK_H_(0x0E, 0x02)
#define REG_BKF00E_03_L      _PK_L_(0x0E, 0x03)
#define REG_BKF00E_03_H      _PK_H_(0x0E, 0x03)
#define REG_BKF00E_04_L      _PK_L_(0x0E, 0x04)
#define REG_BKF00E_04_H      _PK_H_(0x0E, 0x04)
#define REG_BKF00E_05_L      _PK_L_(0x0E, 0x05)
#define REG_BKF00E_05_H      _PK_H_(0x0E, 0x05)
#define REG_BKF00E_06_L      _PK_L_(0x0E, 0x06)
#define REG_BKF00E_06_H      _PK_H_(0x0E, 0x06)
#define REG_BKF00E_07_L      _PK_L_(0x0E, 0x07)
#define REG_BKF00E_07_H      _PK_H_(0x0E, 0x07)
#define REG_BKF00E_08_L      _PK_L_(0x0E, 0x08)
#define REG_BKF00E_08_H      _PK_H_(0x0E, 0x08)
#define REG_BKF00E_09_L      _PK_L_(0x0E, 0x09)
#define REG_BKF00E_09_H      _PK_H_(0x0E, 0x09)
#define REG_BKF00E_0A_L      _PK_L_(0x0E, 0x0A)
#define REG_BKF00E_0A_H      _PK_H_(0x0E, 0x0A)
#define REG_BKF00E_0B_L      _PK_L_(0x0E, 0x0B)
#define REG_BKF00E_0B_H      _PK_H_(0x0E, 0x0B)
#define REG_BKF00E_0C_L      _PK_L_(0x0E, 0x0C)
#define REG_BKF00E_0C_H      _PK_H_(0x0E, 0x0C)
#define REG_BKF00E_0D_L      _PK_L_(0x0E, 0x0D)
#define REG_BKF00E_0D_H      _PK_H_(0x0E, 0x0D)
#define REG_BKF00E_0E_L      _PK_L_(0x0E, 0x0E)
#define REG_BKF00E_0E_H      _PK_H_(0x0E, 0x0E)
#define REG_BKF00E_0F_L      _PK_L_(0x0E, 0x0F)
#define REG_BKF00E_0F_H      _PK_H_(0x0E, 0x0F)
#define REG_BKF00E_10_L      _PK_L_(0x0E, 0x10)
#define REG_BKF00E_10_H      _PK_H_(0x0E, 0x10)
#define REG_BKF00E_11_L      _PK_L_(0x0E, 0x11)
#define REG_BKF00E_11_H      _PK_H_(0x0E, 0x11)
#define REG_BKF00E_12_L      _PK_L_(0x0E, 0x12)
#define REG_BKF00E_12_H      _PK_H_(0x0E, 0x12)
#define REG_BKF00E_13_L      _PK_L_(0x0E, 0x13)
#define REG_BKF00E_13_H      _PK_H_(0x0E, 0x13)
#define REG_BKF00E_14_L      _PK_L_(0x0E, 0x14)
#define REG_BKF00E_14_H      _PK_H_(0x0E, 0x14)
#define REG_BKF00E_15_L      _PK_L_(0x0E, 0x15)
#define REG_BKF00E_15_H      _PK_H_(0x0E, 0x15)
#define REG_BKF00E_16_L      _PK_L_(0x0E, 0x16)
#define REG_BKF00E_16_H      _PK_H_(0x0E, 0x16)
#define REG_BKF00E_17_L      _PK_L_(0x0E, 0x17)
#define REG_BKF00E_17_H      _PK_H_(0x0E, 0x17)
#define REG_BKF00E_18_L      _PK_L_(0x0E, 0x18)
#define REG_BKF00E_18_H      _PK_H_(0x0E, 0x18)
#define REG_BKF00E_19_L      _PK_L_(0x0E, 0x19)
#define REG_BKF00E_19_H      _PK_H_(0x0E, 0x19)
#define REG_BKF00E_1A_L      _PK_L_(0x0E, 0x1A)
#define REG_BKF00E_1A_H      _PK_H_(0x0E, 0x1A)
#define REG_BKF00E_1B_L      _PK_L_(0x0E, 0x1B)
#define REG_BKF00E_1B_H      _PK_H_(0x0E, 0x1B)
#define REG_BKF00E_1C_L      _PK_L_(0x0E, 0x1C)
#define REG_BKF00E_1C_H      _PK_H_(0x0E, 0x1C)
#define REG_BKF00E_1D_L      _PK_L_(0x0E, 0x1D)
#define REG_BKF00E_1D_H      _PK_H_(0x0E, 0x1D)
#define REG_BKF00E_1E_L      _PK_L_(0x0E, 0x1E)
#define REG_BKF00E_1E_H      _PK_H_(0x0E, 0x1E)
#define REG_BKF00E_1F_L      _PK_L_(0x0E, 0x1F)
#define REG_BKF00E_1F_H      _PK_H_(0x0E, 0x1F)
#define REG_BKF00E_20_L      _PK_L_(0x0E, 0x20)
#define REG_BKF00E_20_H      _PK_H_(0x0E, 0x20)
#define REG_BKF00E_21_L      _PK_L_(0x0E, 0x21)
#define REG_BKF00E_21_H      _PK_H_(0x0E, 0x21)
#define REG_BKF00E_22_L      _PK_L_(0x0E, 0x22)
#define REG_BKF00E_22_H      _PK_H_(0x0E, 0x22)
#define REG_BKF00E_23_L      _PK_L_(0x0E, 0x23)
#define REG_BKF00E_23_H      _PK_H_(0x0E, 0x23)
#define REG_BKF00E_24_L      _PK_L_(0x0E, 0x24)
#define REG_BKF00E_24_H      _PK_H_(0x0E, 0x24)
#define REG_BKF00E_25_L      _PK_L_(0x0E, 0x25)
#define REG_BKF00E_25_H      _PK_H_(0x0E, 0x25)
#define REG_BKF00E_26_L      _PK_L_(0x0E, 0x26)
#define REG_BKF00E_26_H      _PK_H_(0x0E, 0x26)
#define REG_BKF00E_27_L      _PK_L_(0x0E, 0x27)
#define REG_BKF00E_27_H      _PK_H_(0x0E, 0x27)
#define REG_BKF00E_28_L      _PK_L_(0x0E, 0x28)
#define REG_BKF00E_28_H      _PK_H_(0x0E, 0x28)
#define REG_BKF00E_29_L      _PK_L_(0x0E, 0x29)
#define REG_BKF00E_29_H      _PK_H_(0x0E, 0x29)
#define REG_BKF00E_2A_L      _PK_L_(0x0E, 0x2A)
#define REG_BKF00E_2A_H      _PK_H_(0x0E, 0x2A)
#define REG_BKF00E_2B_L      _PK_L_(0x0E, 0x2B)
#define REG_BKF00E_2B_H      _PK_H_(0x0E, 0x2B)
#define REG_BKF00E_2C_L      _PK_L_(0x0E, 0x2C)
#define REG_BKF00E_2C_H      _PK_H_(0x0E, 0x2C)
#define REG_BKF00E_2D_L      _PK_L_(0x0E, 0x2D)
#define REG_BKF00E_2D_H      _PK_H_(0x0E, 0x2D)
#define REG_BKF00E_2E_L      _PK_L_(0x0E, 0x2E)
#define REG_BKF00E_2E_H      _PK_H_(0x0E, 0x2E)
#define REG_BKF00E_2F_L      _PK_L_(0x0E, 0x2F)
#define REG_BKF00E_2F_H      _PK_H_(0x0E, 0x2F)
#define REG_BKF00E_30_L      _PK_L_(0x0E, 0x30)
#define REG_BKF00E_30_H      _PK_H_(0x0E, 0x30)
#define REG_BKF00E_31_L      _PK_L_(0x0E, 0x31)
#define REG_BKF00E_31_H      _PK_H_(0x0E, 0x31)
#define REG_BKF00E_32_L      _PK_L_(0x0E, 0x32)
#define REG_BKF00E_32_H      _PK_H_(0x0E, 0x32)
#define REG_BKF00E_33_L      _PK_L_(0x0E, 0x33)
#define REG_BKF00E_33_H      _PK_H_(0x0E, 0x33)
#define REG_BKF00E_34_L      _PK_L_(0x0E, 0x34)
#define REG_BKF00E_34_H      _PK_H_(0x0E, 0x34)
#define REG_BKF00E_35_L      _PK_L_(0x0E, 0x35)
#define REG_BKF00E_35_H      _PK_H_(0x0E, 0x35)
#define REG_BKF00E_36_L      _PK_L_(0x0E, 0x36)
#define REG_BKF00E_36_H      _PK_H_(0x0E, 0x36)
#define REG_BKF00E_37_L      _PK_L_(0x0E, 0x37)
#define REG_BKF00E_37_H      _PK_H_(0x0E, 0x37)
#define REG_BKF00E_38_L      _PK_L_(0x0E, 0x38)
#define REG_BKF00E_38_H      _PK_H_(0x0E, 0x38)
#define REG_BKF00E_39_L      _PK_L_(0x0E, 0x39)
#define REG_BKF00E_39_H      _PK_H_(0x0E, 0x39)
#define REG_BKF00E_3A_L      _PK_L_(0x0E, 0x3A)
#define REG_BKF00E_3A_H      _PK_H_(0x0E, 0x3A)
#define REG_BKF00E_3B_L      _PK_L_(0x0E, 0x3B)
#define REG_BKF00E_3B_H      _PK_H_(0x0E, 0x3B)
#define REG_BKF00E_3C_L      _PK_L_(0x0E, 0x3C)
#define REG_BKF00E_3C_H      _PK_H_(0x0E, 0x3C)
#define REG_BKF00E_3D_L      _PK_L_(0x0E, 0x3D)
#define REG_BKF00E_3D_H      _PK_H_(0x0E, 0x3D)
#define REG_BKF00E_3E_L      _PK_L_(0x0E, 0x3E)
#define REG_BKF00E_3E_H      _PK_H_(0x0E, 0x3E)
#define REG_BKF00E_3F_L      _PK_L_(0x0E, 0x3F)
#define REG_BKF00E_3F_H      _PK_H_(0x0E, 0x3F)
#define REG_BKF00E_40_L      _PK_L_(0x0E, 0x40)
#define REG_BKF00E_40_H      _PK_H_(0x0E, 0x40)
#define REG_BKF00E_41_L      _PK_L_(0x0E, 0x41)
#define REG_BKF00E_41_H      _PK_H_(0x0E, 0x41)
#define REG_BKF00E_42_L      _PK_L_(0x0E, 0x42)
#define REG_BKF00E_42_H      _PK_H_(0x0E, 0x42)
#define REG_BKF00E_43_L      _PK_L_(0x0E, 0x43)
#define REG_BKF00E_43_H      _PK_H_(0x0E, 0x43)
#define REG_BKF00E_44_L      _PK_L_(0x0E, 0x44)
#define REG_BKF00E_44_H      _PK_H_(0x0E, 0x44)
#define REG_BKF00E_45_L      _PK_L_(0x0E, 0x45)
#define REG_BKF00E_45_H      _PK_H_(0x0E, 0x45)
#define REG_BKF00E_46_L      _PK_L_(0x0E, 0x46)
#define REG_BKF00E_46_H      _PK_H_(0x0E, 0x46)
#define REG_BKF00E_47_L      _PK_L_(0x0E, 0x47)
#define REG_BKF00E_47_H      _PK_H_(0x0E, 0x47)
#define REG_BKF00E_48_L      _PK_L_(0x0E, 0x48)
#define REG_BKF00E_48_H      _PK_H_(0x0E, 0x48)
#define REG_BKF00E_49_L      _PK_L_(0x0E, 0x49)
#define REG_BKF00E_49_H      _PK_H_(0x0E, 0x49)
#define REG_BKF00E_4A_L      _PK_L_(0x0E, 0x4A)
#define REG_BKF00E_4A_H      _PK_H_(0x0E, 0x4A)
#define REG_BKF00E_4B_L      _PK_L_(0x0E, 0x4B)
#define REG_BKF00E_4B_H      _PK_H_(0x0E, 0x4B)
#define REG_BKF00E_4C_L      _PK_L_(0x0E, 0x4C)
#define REG_BKF00E_4C_H      _PK_H_(0x0E, 0x4C)
#define REG_BKF00E_4D_L      _PK_L_(0x0E, 0x4D)
#define REG_BKF00E_4D_H      _PK_H_(0x0E, 0x4D)
#define REG_BKF00E_4E_L      _PK_L_(0x0E, 0x4E)
#define REG_BKF00E_4E_H      _PK_H_(0x0E, 0x4E)
#define REG_BKF00E_4F_L      _PK_L_(0x0E, 0x4F)
#define REG_BKF00E_4F_H      _PK_H_(0x0E, 0x4F)
#define REG_BKF00E_50_L      _PK_L_(0x0E, 0x50)
#define REG_BKF00E_50_H      _PK_H_(0x0E, 0x50)
#define REG_BKF00E_51_L      _PK_L_(0x0E, 0x51)
#define REG_BKF00E_51_H      _PK_H_(0x0E, 0x51)
#define REG_BKF00E_52_L      _PK_L_(0x0E, 0x52)
#define REG_BKF00E_52_H      _PK_H_(0x0E, 0x52)
#define REG_BKF00E_53_L      _PK_L_(0x0E, 0x53)
#define REG_BKF00E_53_H      _PK_H_(0x0E, 0x53)
#define REG_BKF00E_54_L      _PK_L_(0x0E, 0x54)
#define REG_BKF00E_54_H      _PK_H_(0x0E, 0x54)
#define REG_BKF00E_55_L      _PK_L_(0x0E, 0x55)
#define REG_BKF00E_55_H      _PK_H_(0x0E, 0x55)
#define REG_BKF00E_56_L      _PK_L_(0x0E, 0x56)
#define REG_BKF00E_56_H      _PK_H_(0x0E, 0x56)
#define REG_BKF00E_57_L      _PK_L_(0x0E, 0x57)
#define REG_BKF00E_57_H      _PK_H_(0x0E, 0x57)
#define REG_BKF00E_58_L      _PK_L_(0x0E, 0x58)
#define REG_BKF00E_58_H      _PK_H_(0x0E, 0x58)
#define REG_BKF00E_59_L      _PK_L_(0x0E, 0x59)
#define REG_BKF00E_59_H      _PK_H_(0x0E, 0x59)
#define REG_BKF00E_5A_L      _PK_L_(0x0E, 0x5A)
#define REG_BKF00E_5A_H      _PK_H_(0x0E, 0x5A)
#define REG_BKF00E_5B_L      _PK_L_(0x0E, 0x5B)
#define REG_BKF00E_5B_H      _PK_H_(0x0E, 0x5B)
#define REG_BKF00E_5C_L      _PK_L_(0x0E, 0x5C)
#define REG_BKF00E_5C_H      _PK_H_(0x0E, 0x5C)
#define REG_BKF00E_5D_L      _PK_L_(0x0E, 0x5D)
#define REG_BKF00E_5D_H      _PK_H_(0x0E, 0x5D)
#define REG_BKF00E_5E_L      _PK_L_(0x0E, 0x5E)
#define REG_BKF00E_5E_H      _PK_H_(0x0E, 0x5E)
#define REG_BKF00E_5F_L      _PK_L_(0x0E, 0x5F)
#define REG_BKF00E_5F_H      _PK_H_(0x0E, 0x5F)
#define REG_BKF00E_60_L      _PK_L_(0x0E, 0x60)
#define REG_BKF00E_60_H      _PK_H_(0x0E, 0x60)
#define REG_BKF00E_61_L      _PK_L_(0x0E, 0x61)
#define REG_BKF00E_61_H      _PK_H_(0x0E, 0x61)
#define REG_BKF00E_62_L      _PK_L_(0x0E, 0x62)
#define REG_BKF00E_62_H      _PK_H_(0x0E, 0x62)
#define REG_BKF00E_63_L      _PK_L_(0x0E, 0x63)
#define REG_BKF00E_63_H      _PK_H_(0x0E, 0x63)
#define REG_BKF00E_64_L      _PK_L_(0x0E, 0x64)
#define REG_BKF00E_64_H      _PK_H_(0x0E, 0x64)
#define REG_BKF00E_65_L      _PK_L_(0x0E, 0x65)
#define REG_BKF00E_65_H      _PK_H_(0x0E, 0x65)
#define REG_BKF00E_66_L      _PK_L_(0x0E, 0x66)
#define REG_BKF00E_66_H      _PK_H_(0x0E, 0x66)
#define REG_BKF00E_67_L      _PK_L_(0x0E, 0x67)
#define REG_BKF00E_67_H      _PK_H_(0x0E, 0x67)
#define REG_BKF00E_68_L      _PK_L_(0x0E, 0x68)
#define REG_BKF00E_68_H      _PK_H_(0x0E, 0x68)
#define REG_BKF00E_69_L      _PK_L_(0x0E, 0x69)
#define REG_BKF00E_69_H      _PK_H_(0x0E, 0x69)
#define REG_BKF00E_6A_L      _PK_L_(0x0E, 0x6A)
#define REG_BKF00E_6A_H      _PK_H_(0x0E, 0x6A)
#define REG_BKF00E_6B_L      _PK_L_(0x0E, 0x6B)
#define REG_BKF00E_6B_H      _PK_H_(0x0E, 0x6B)
#define REG_BKF00E_6C_L      _PK_L_(0x0E, 0x6C)
#define REG_BKF00E_6C_H      _PK_H_(0x0E, 0x6C)
#define REG_BKF00E_6D_L      _PK_L_(0x0E, 0x6D)
#define REG_BKF00E_6D_H      _PK_H_(0x0E, 0x6D)
#define REG_BKF00E_6E_L      _PK_L_(0x0E, 0x6E)
#define REG_BKF00E_6E_H      _PK_H_(0x0E, 0x6E)
#define REG_BKF00E_6F_L      _PK_L_(0x0E, 0x6F)
#define REG_BKF00E_6F_H      _PK_H_(0x0E, 0x6F)
#define REG_BKF00E_70_L      _PK_L_(0x0E, 0x70)
#define REG_BKF00E_70_H      _PK_H_(0x0E, 0x70)
#define REG_BKF00E_71_L      _PK_L_(0x0E, 0x71)
#define REG_BKF00E_71_H      _PK_H_(0x0E, 0x71)
#define REG_BKF00E_72_L      _PK_L_(0x0E, 0x72)
#define REG_BKF00E_72_H      _PK_H_(0x0E, 0x72)
#define REG_BKF00E_73_L      _PK_L_(0x0E, 0x73)
#define REG_BKF00E_73_H      _PK_H_(0x0E, 0x73)
#define REG_BKF00E_74_L      _PK_L_(0x0E, 0x74)
#define REG_BKF00E_74_H      _PK_H_(0x0E, 0x74)
#define REG_BKF00E_75_L      _PK_L_(0x0E, 0x75)
#define REG_BKF00E_75_H      _PK_H_(0x0E, 0x75)
#define REG_BKF00E_76_L      _PK_L_(0x0E, 0x76)
#define REG_BKF00E_76_H      _PK_H_(0x0E, 0x76)
#define REG_BKF00E_77_L      _PK_L_(0x0E, 0x77)
#define REG_BKF00E_77_H      _PK_H_(0x0E, 0x77)
#define REG_BKF00E_78_L      _PK_L_(0x0E, 0x78)
#define REG_BKF00E_78_H      _PK_H_(0x0E, 0x78)
#define REG_BKF00E_79_L      _PK_L_(0x0E, 0x79)
#define REG_BKF00E_79_H      _PK_H_(0x0E, 0x79)
#define REG_BKF00E_7A_L      _PK_L_(0x0E, 0x7A)
#define REG_BKF00E_7A_H      _PK_H_(0x0E, 0x7A)
#define REG_BKF00E_7B_L      _PK_L_(0x0E, 0x7B)
#define REG_BKF00E_7B_H      _PK_H_(0x0E, 0x7B)
#define REG_BKF00E_7C_L      _PK_L_(0x0E, 0x7C)
#define REG_BKF00E_7C_H      _PK_H_(0x0E, 0x7C)
#define REG_BKF00E_7D_L      _PK_L_(0x0E, 0x7D)
#define REG_BKF00E_7D_H      _PK_H_(0x0E, 0x7D)
#define REG_BKF00E_7E_L      _PK_L_(0x0E, 0x7E)
#define REG_BKF00E_7E_H      _PK_H_(0x0E, 0x7E)
#define REG_BKF00E_7F_L      _PK_L_(0x0E, 0x7F)
#define REG_BKF00E_7F_H      _PK_H_(0x0E, 0x7F)
//----------------------------------------------
#define REG_BKF00F_00_L      _PK_L_(0x0F, 0x00)
#define REG_BKF00F_00_H      _PK_H_(0x0F, 0x00)
#define REG_BKF00F_01_L      _PK_L_(0x0F, 0x01)
#define REG_BKF00F_01_H      _PK_H_(0x0F, 0x01)
#define REG_BKF00F_02_L      _PK_L_(0x0F, 0x02)
#define REG_BKF00F_02_H      _PK_H_(0x0F, 0x02)
#define REG_BKF00F_03_L      _PK_L_(0x0F, 0x03)
#define REG_BKF00F_03_H      _PK_H_(0x0F, 0x03)
#define REG_BKF00F_04_L      _PK_L_(0x0F, 0x04)
#define REG_BKF00F_04_H      _PK_H_(0x0F, 0x04)
#define REG_BKF00F_05_L      _PK_L_(0x0F, 0x05)
#define REG_BKF00F_05_H      _PK_H_(0x0F, 0x05)
#define REG_BKF00F_06_L      _PK_L_(0x0F, 0x06)
#define REG_BKF00F_06_H      _PK_H_(0x0F, 0x06)
#define REG_BKF00F_07_L      _PK_L_(0x0F, 0x07)
#define REG_BKF00F_07_H      _PK_H_(0x0F, 0x07)
#define REG_BKF00F_08_L      _PK_L_(0x0F, 0x08)
#define REG_BKF00F_08_H      _PK_H_(0x0F, 0x08)
#define REG_BKF00F_09_L      _PK_L_(0x0F, 0x09)
#define REG_BKF00F_09_H      _PK_H_(0x0F, 0x09)
#define REG_BKF00F_0A_L      _PK_L_(0x0F, 0x0A)
#define REG_BKF00F_0A_H      _PK_H_(0x0F, 0x0A)
#define REG_BKF00F_0B_L      _PK_L_(0x0F, 0x0B)
#define REG_BKF00F_0B_H      _PK_H_(0x0F, 0x0B)
#define REG_BKF00F_0C_L      _PK_L_(0x0F, 0x0C)
#define REG_BKF00F_0C_H      _PK_H_(0x0F, 0x0C)
#define REG_BKF00F_0D_L      _PK_L_(0x0F, 0x0D)
#define REG_BKF00F_0D_H      _PK_H_(0x0F, 0x0D)
#define REG_BKF00F_0E_L      _PK_L_(0x0F, 0x0E)
#define REG_BKF00F_0E_H      _PK_H_(0x0F, 0x0E)
#define REG_BKF00F_0F_L      _PK_L_(0x0F, 0x0F)
#define REG_BKF00F_0F_H      _PK_H_(0x0F, 0x0F)
#define REG_BKF00F_10_L      _PK_L_(0x0F, 0x10)
#define REG_BKF00F_10_H      _PK_H_(0x0F, 0x10)
#define REG_BKF00F_11_L      _PK_L_(0x0F, 0x11)
#define REG_BKF00F_11_H      _PK_H_(0x0F, 0x11)
#define REG_BKF00F_12_L      _PK_L_(0x0F, 0x12)
#define REG_BKF00F_12_H      _PK_H_(0x0F, 0x12)
#define REG_BKF00F_13_L      _PK_L_(0x0F, 0x13)
#define REG_BKF00F_13_H      _PK_H_(0x0F, 0x13)
#define REG_BKF00F_14_L      _PK_L_(0x0F, 0x14)
#define REG_BKF00F_14_H      _PK_H_(0x0F, 0x14)
#define REG_BKF00F_15_L      _PK_L_(0x0F, 0x15)
#define REG_BKF00F_15_H      _PK_H_(0x0F, 0x15)
#define REG_BKF00F_16_L      _PK_L_(0x0F, 0x16)
#define REG_BKF00F_16_H      _PK_H_(0x0F, 0x16)
#define REG_BKF00F_17_L      _PK_L_(0x0F, 0x17)
#define REG_BKF00F_17_H      _PK_H_(0x0F, 0x17)
#define REG_BKF00F_18_L      _PK_L_(0x0F, 0x18)
#define REG_BKF00F_18_H      _PK_H_(0x0F, 0x18)
#define REG_BKF00F_19_L      _PK_L_(0x0F, 0x19)
#define REG_BKF00F_19_H      _PK_H_(0x0F, 0x19)
#define REG_BKF00F_1A_L      _PK_L_(0x0F, 0x1A)
#define REG_BKF00F_1A_H      _PK_H_(0x0F, 0x1A)
#define REG_BKF00F_1B_L      _PK_L_(0x0F, 0x1B)
#define REG_BKF00F_1B_H      _PK_H_(0x0F, 0x1B)
#define REG_BKF00F_1C_L      _PK_L_(0x0F, 0x1C)
#define REG_BKF00F_1C_H      _PK_H_(0x0F, 0x1C)
#define REG_BKF00F_1D_L      _PK_L_(0x0F, 0x1D)
#define REG_BKF00F_1D_H      _PK_H_(0x0F, 0x1D)
#define REG_BKF00F_1E_L      _PK_L_(0x0F, 0x1E)
#define REG_BKF00F_1E_H      _PK_H_(0x0F, 0x1E)
#define REG_BKF00F_1F_L      _PK_L_(0x0F, 0x1F)
#define REG_BKF00F_1F_H      _PK_H_(0x0F, 0x1F)
#define REG_BKF00F_20_L      _PK_L_(0x0F, 0x20)
#define REG_BKF00F_20_H      _PK_H_(0x0F, 0x20)
#define REG_BKF00F_21_L      _PK_L_(0x0F, 0x21)
#define REG_BKF00F_21_H      _PK_H_(0x0F, 0x21)
#define REG_BKF00F_22_L      _PK_L_(0x0F, 0x22)
#define REG_BKF00F_22_H      _PK_H_(0x0F, 0x22)
#define REG_BKF00F_23_L      _PK_L_(0x0F, 0x23)
#define REG_BKF00F_23_H      _PK_H_(0x0F, 0x23)
#define REG_BKF00F_24_L      _PK_L_(0x0F, 0x24)
#define REG_BKF00F_24_H      _PK_H_(0x0F, 0x24)
#define REG_BKF00F_25_L      _PK_L_(0x0F, 0x25)
#define REG_BKF00F_25_H      _PK_H_(0x0F, 0x25)
#define REG_BKF00F_26_L      _PK_L_(0x0F, 0x26)
#define REG_BKF00F_26_H      _PK_H_(0x0F, 0x26)
#define REG_BKF00F_27_L      _PK_L_(0x0F, 0x27)
#define REG_BKF00F_27_H      _PK_H_(0x0F, 0x27)
#define REG_BKF00F_28_L      _PK_L_(0x0F, 0x28)
#define REG_BKF00F_28_H      _PK_H_(0x0F, 0x28)
#define REG_BKF00F_29_L      _PK_L_(0x0F, 0x29)
#define REG_BKF00F_29_H      _PK_H_(0x0F, 0x29)
#define REG_BKF00F_2A_L      _PK_L_(0x0F, 0x2A)
#define REG_BKF00F_2A_H      _PK_H_(0x0F, 0x2A)
#define REG_BKF00F_2B_L      _PK_L_(0x0F, 0x2B)
#define REG_BKF00F_2B_H      _PK_H_(0x0F, 0x2B)
#define REG_BKF00F_2C_L      _PK_L_(0x0F, 0x2C)
#define REG_BKF00F_2C_H      _PK_H_(0x0F, 0x2C)
#define REG_BKF00F_2D_L      _PK_L_(0x0F, 0x2D)
#define REG_BKF00F_2D_H      _PK_H_(0x0F, 0x2D)
#define REG_BKF00F_2E_L      _PK_L_(0x0F, 0x2E)
#define REG_BKF00F_2E_H      _PK_H_(0x0F, 0x2E)
#define REG_BKF00F_2F_L      _PK_L_(0x0F, 0x2F)
#define REG_BKF00F_2F_H      _PK_H_(0x0F, 0x2F)
#define REG_BKF00F_30_L      _PK_L_(0x0F, 0x30)
#define REG_BKF00F_30_H      _PK_H_(0x0F, 0x30)
#define REG_BKF00F_31_L      _PK_L_(0x0F, 0x31)
#define REG_BKF00F_31_H      _PK_H_(0x0F, 0x31)
#define REG_BKF00F_32_L      _PK_L_(0x0F, 0x32)
#define REG_BKF00F_32_H      _PK_H_(0x0F, 0x32)
#define REG_BKF00F_33_L      _PK_L_(0x0F, 0x33)
#define REG_BKF00F_33_H      _PK_H_(0x0F, 0x33)
#define REG_BKF00F_34_L      _PK_L_(0x0F, 0x34)
#define REG_BKF00F_34_H      _PK_H_(0x0F, 0x34)
#define REG_BKF00F_35_L      _PK_L_(0x0F, 0x35)
#define REG_BKF00F_35_H      _PK_H_(0x0F, 0x35)
#define REG_BKF00F_36_L      _PK_L_(0x0F, 0x36)
#define REG_BKF00F_36_H      _PK_H_(0x0F, 0x36)
#define REG_BKF00F_37_L      _PK_L_(0x0F, 0x37)
#define REG_BKF00F_37_H      _PK_H_(0x0F, 0x37)
#define REG_BKF00F_38_L      _PK_L_(0x0F, 0x38)
#define REG_BKF00F_38_H      _PK_H_(0x0F, 0x38)
#define REG_BKF00F_39_L      _PK_L_(0x0F, 0x39)
#define REG_BKF00F_39_H      _PK_H_(0x0F, 0x39)
#define REG_BKF00F_3A_L      _PK_L_(0x0F, 0x3A)
#define REG_BKF00F_3A_H      _PK_H_(0x0F, 0x3A)
#define REG_BKF00F_3B_L      _PK_L_(0x0F, 0x3B)
#define REG_BKF00F_3B_H      _PK_H_(0x0F, 0x3B)
#define REG_BKF00F_3C_L      _PK_L_(0x0F, 0x3C)
#define REG_BKF00F_3C_H      _PK_H_(0x0F, 0x3C)
#define REG_BKF00F_3D_L      _PK_L_(0x0F, 0x3D)
#define REG_BKF00F_3D_H      _PK_H_(0x0F, 0x3D)
#define REG_BKF00F_3E_L      _PK_L_(0x0F, 0x3E)
#define REG_BKF00F_3E_H      _PK_H_(0x0F, 0x3E)
#define REG_BKF00F_3F_L      _PK_L_(0x0F, 0x3F)
#define REG_BKF00F_3F_H      _PK_H_(0x0F, 0x3F)
#define REG_BKF00F_40_L      _PK_L_(0x0F, 0x40)
#define REG_BKF00F_40_H      _PK_H_(0x0F, 0x40)
#define REG_BKF00F_41_L      _PK_L_(0x0F, 0x41)
#define REG_BKF00F_41_H      _PK_H_(0x0F, 0x41)
#define REG_BKF00F_42_L      _PK_L_(0x0F, 0x42)
#define REG_BKF00F_42_H      _PK_H_(0x0F, 0x42)
#define REG_BKF00F_43_L      _PK_L_(0x0F, 0x43)
#define REG_BKF00F_43_H      _PK_H_(0x0F, 0x43)
#define REG_BKF00F_44_L      _PK_L_(0x0F, 0x44)
#define REG_BKF00F_44_H      _PK_H_(0x0F, 0x44)
#define REG_BKF00F_45_L      _PK_L_(0x0F, 0x45)
#define REG_BKF00F_45_H      _PK_H_(0x0F, 0x45)
#define REG_BKF00F_46_L      _PK_L_(0x0F, 0x46)
#define REG_BKF00F_46_H      _PK_H_(0x0F, 0x46)
#define REG_BKF00F_47_L      _PK_L_(0x0F, 0x47)
#define REG_BKF00F_47_H      _PK_H_(0x0F, 0x47)
#define REG_BKF00F_48_L      _PK_L_(0x0F, 0x48)
#define REG_BKF00F_48_H      _PK_H_(0x0F, 0x48)
#define REG_BKF00F_49_L      _PK_L_(0x0F, 0x49)
#define REG_BKF00F_49_H      _PK_H_(0x0F, 0x49)
#define REG_BKF00F_4A_L      _PK_L_(0x0F, 0x4A)
#define REG_BKF00F_4A_H      _PK_H_(0x0F, 0x4A)
#define REG_BKF00F_4B_L      _PK_L_(0x0F, 0x4B)
#define REG_BKF00F_4B_H      _PK_H_(0x0F, 0x4B)
#define REG_BKF00F_4C_L      _PK_L_(0x0F, 0x4C)
#define REG_BKF00F_4C_H      _PK_H_(0x0F, 0x4C)
#define REG_BKF00F_4D_L      _PK_L_(0x0F, 0x4D)
#define REG_BKF00F_4D_H      _PK_H_(0x0F, 0x4D)
#define REG_BKF00F_4E_L      _PK_L_(0x0F, 0x4E)
#define REG_BKF00F_4E_H      _PK_H_(0x0F, 0x4E)
#define REG_BKF00F_4F_L      _PK_L_(0x0F, 0x4F)
#define REG_BKF00F_4F_H      _PK_H_(0x0F, 0x4F)
#define REG_BKF00F_50_L      _PK_L_(0x0F, 0x50)
#define REG_BKF00F_50_H      _PK_H_(0x0F, 0x50)
#define REG_BKF00F_51_L      _PK_L_(0x0F, 0x51)
#define REG_BKF00F_51_H      _PK_H_(0x0F, 0x51)
#define REG_BKF00F_52_L      _PK_L_(0x0F, 0x52)
#define REG_BKF00F_52_H      _PK_H_(0x0F, 0x52)
#define REG_BKF00F_53_L      _PK_L_(0x0F, 0x53)
#define REG_BKF00F_53_H      _PK_H_(0x0F, 0x53)
#define REG_BKF00F_54_L      _PK_L_(0x0F, 0x54)
#define REG_BKF00F_54_H      _PK_H_(0x0F, 0x54)
#define REG_BKF00F_55_L      _PK_L_(0x0F, 0x55)
#define REG_BKF00F_55_H      _PK_H_(0x0F, 0x55)
#define REG_BKF00F_56_L      _PK_L_(0x0F, 0x56)
#define REG_BKF00F_56_H      _PK_H_(0x0F, 0x56)
#define REG_BKF00F_57_L      _PK_L_(0x0F, 0x57)
#define REG_BKF00F_57_H      _PK_H_(0x0F, 0x57)
#define REG_BKF00F_58_L      _PK_L_(0x0F, 0x58)
#define REG_BKF00F_58_H      _PK_H_(0x0F, 0x58)
#define REG_BKF00F_59_L      _PK_L_(0x0F, 0x59)
#define REG_BKF00F_59_H      _PK_H_(0x0F, 0x59)
#define REG_BKF00F_5A_L      _PK_L_(0x0F, 0x5A)
#define REG_BKF00F_5A_H      _PK_H_(0x0F, 0x5A)
#define REG_BKF00F_5B_L      _PK_L_(0x0F, 0x5B)
#define REG_BKF00F_5B_H      _PK_H_(0x0F, 0x5B)
#define REG_BKF00F_5C_L      _PK_L_(0x0F, 0x5C)
#define REG_BKF00F_5C_H      _PK_H_(0x0F, 0x5C)
#define REG_BKF00F_5D_L      _PK_L_(0x0F, 0x5D)
#define REG_BKF00F_5D_H      _PK_H_(0x0F, 0x5D)
#define REG_BKF00F_5E_L      _PK_L_(0x0F, 0x5E)
#define REG_BKF00F_5E_H      _PK_H_(0x0F, 0x5E)
#define REG_BKF00F_5F_L      _PK_L_(0x0F, 0x5F)
#define REG_BKF00F_5F_H      _PK_H_(0x0F, 0x5F)
#define REG_BKF00F_60_L      _PK_L_(0x0F, 0x60)
#define REG_BKF00F_60_H      _PK_H_(0x0F, 0x60)
#define REG_BKF00F_61_L      _PK_L_(0x0F, 0x61)
#define REG_BKF00F_61_H      _PK_H_(0x0F, 0x61)
#define REG_BKF00F_62_L      _PK_L_(0x0F, 0x62)
#define REG_BKF00F_62_H      _PK_H_(0x0F, 0x62)
#define REG_BKF00F_63_L      _PK_L_(0x0F, 0x63)
#define REG_BKF00F_63_H      _PK_H_(0x0F, 0x63)
#define REG_BKF00F_64_L      _PK_L_(0x0F, 0x64)
#define REG_BKF00F_64_H      _PK_H_(0x0F, 0x64)
#define REG_BKF00F_65_L      _PK_L_(0x0F, 0x65)
#define REG_BKF00F_65_H      _PK_H_(0x0F, 0x65)
#define REG_BKF00F_66_L      _PK_L_(0x0F, 0x66)
#define REG_BKF00F_66_H      _PK_H_(0x0F, 0x66)
#define REG_BKF00F_67_L      _PK_L_(0x0F, 0x67)
#define REG_BKF00F_67_H      _PK_H_(0x0F, 0x67)
#define REG_BKF00F_68_L      _PK_L_(0x0F, 0x68)
#define REG_BKF00F_68_H      _PK_H_(0x0F, 0x68)
#define REG_BKF00F_69_L      _PK_L_(0x0F, 0x69)
#define REG_BKF00F_69_H      _PK_H_(0x0F, 0x69)
#define REG_BKF00F_6A_L      _PK_L_(0x0F, 0x6A)
#define REG_BKF00F_6A_H      _PK_H_(0x0F, 0x6A)
#define REG_BKF00F_6B_L      _PK_L_(0x0F, 0x6B)
#define REG_BKF00F_6B_H      _PK_H_(0x0F, 0x6B)
#define REG_BKF00F_6C_L      _PK_L_(0x0F, 0x6C)
#define REG_BKF00F_6C_H      _PK_H_(0x0F, 0x6C)
#define REG_BKF00F_6D_L      _PK_L_(0x0F, 0x6D)
#define REG_BKF00F_6D_H      _PK_H_(0x0F, 0x6D)
#define REG_BKF00F_6E_L      _PK_L_(0x0F, 0x6E)
#define REG_BKF00F_6E_H      _PK_H_(0x0F, 0x6E)
#define REG_BKF00F_6F_L      _PK_L_(0x0F, 0x6F)
#define REG_BKF00F_6F_H      _PK_H_(0x0F, 0x6F)
#define REG_BKF00F_70_L      _PK_L_(0x0F, 0x70)
#define REG_BKF00F_70_H      _PK_H_(0x0F, 0x70)
#define REG_BKF00F_71_L      _PK_L_(0x0F, 0x71)
#define REG_BKF00F_71_H      _PK_H_(0x0F, 0x71)
#define REG_BKF00F_72_L      _PK_L_(0x0F, 0x72)
#define REG_BKF00F_72_H      _PK_H_(0x0F, 0x72)
#define REG_BKF00F_73_L      _PK_L_(0x0F, 0x73)
#define REG_BKF00F_73_H      _PK_H_(0x0F, 0x73)
#define REG_BKF00F_74_L      _PK_L_(0x0F, 0x74)
#define REG_BKF00F_74_H      _PK_H_(0x0F, 0x74)
#define REG_BKF00F_75_L      _PK_L_(0x0F, 0x75)
#define REG_BKF00F_75_H      _PK_H_(0x0F, 0x75)
#define REG_BKF00F_76_L      _PK_L_(0x0F, 0x76)
#define REG_BKF00F_76_H      _PK_H_(0x0F, 0x76)
#define REG_BKF00F_77_L      _PK_L_(0x0F, 0x77)
#define REG_BKF00F_77_H      _PK_H_(0x0F, 0x77)
#define REG_BKF00F_78_L      _PK_L_(0x0F, 0x78)
#define REG_BKF00F_78_H      _PK_H_(0x0F, 0x78)
#define REG_BKF00F_79_L      _PK_L_(0x0F, 0x79)
#define REG_BKF00F_79_H      _PK_H_(0x0F, 0x79)
#define REG_BKF00F_7A_L      _PK_L_(0x0F, 0x7A)
#define REG_BKF00F_7A_H      _PK_H_(0x0F, 0x7A)
#define REG_BKF00F_7B_L      _PK_L_(0x0F, 0x7B)
#define REG_BKF00F_7B_H      _PK_H_(0x0F, 0x7B)
#define REG_BKF00F_7C_L      _PK_L_(0x0F, 0x7C)
#define REG_BKF00F_7C_H      _PK_H_(0x0F, 0x7C)
#define REG_BKF00F_7D_L      _PK_L_(0x0F, 0x7D)
#define REG_BKF00F_7D_H      _PK_H_(0x0F, 0x7D)
#define REG_BKF00F_7E_L      _PK_L_(0x0F, 0x7E)
#define REG_BKF00F_7E_H      _PK_H_(0x0F, 0x7E)
#define REG_BKF00F_7F_L      _PK_L_(0x0F, 0x7F)
#define REG_BKF00F_7F_H      _PK_H_(0x0F, 0x7F)
//----------------------------------------------
#define REG_BKF044_00_L      _PK_L_(0x44, 0x00)
#define REG_BKF044_00_H      _PK_H_(0x44, 0x00)
#define REG_BKF044_01_L      _PK_L_(0x44, 0x01)
#define REG_BKF044_01_H      _PK_H_(0x44, 0x01)
#define REG_BKF044_02_L      _PK_L_(0x44, 0x02)
#define REG_BKF044_02_H      _PK_H_(0x44, 0x02)
#define REG_BKF044_03_L      _PK_L_(0x44, 0x03)
#define REG_BKF044_03_H      _PK_H_(0x44, 0x03)
#define REG_BKF044_04_L      _PK_L_(0x44, 0x04)
#define REG_BKF044_04_H      _PK_H_(0x44, 0x04)
#define REG_BKF044_05_L      _PK_L_(0x44, 0x05)
#define REG_BKF044_05_H      _PK_H_(0x44, 0x05)
#define REG_BKF044_06_L      _PK_L_(0x44, 0x06)
#define REG_BKF044_06_H      _PK_H_(0x44, 0x06)
#define REG_BKF044_07_L      _PK_L_(0x44, 0x07)
#define REG_BKF044_07_H      _PK_H_(0x44, 0x07)
#define REG_BKF044_08_L      _PK_L_(0x44, 0x08)
#define REG_BKF044_08_H      _PK_H_(0x44, 0x08)
#define REG_BKF044_09_L      _PK_L_(0x44, 0x09)
#define REG_BKF044_09_H      _PK_H_(0x44, 0x09)
#define REG_BKF044_0A_L      _PK_L_(0x44, 0x0A)
#define REG_BKF044_0A_H      _PK_H_(0x44, 0x0A)
#define REG_BKF044_0B_L      _PK_L_(0x44, 0x0B)
#define REG_BKF044_0B_H      _PK_H_(0x44, 0x0B)
#define REG_BKF044_0C_L      _PK_L_(0x44, 0x0C)
#define REG_BKF044_0C_H      _PK_H_(0x44, 0x0C)
#define REG_BKF044_0D_L      _PK_L_(0x44, 0x0D)
#define REG_BKF044_0D_H      _PK_H_(0x44, 0x0D)
#define REG_BKF044_0E_L      _PK_L_(0x44, 0x0E)
#define REG_BKF044_0E_H      _PK_H_(0x44, 0x0E)
#define REG_BKF044_0F_L      _PK_L_(0x44, 0x0F)
#define REG_BKF044_0F_H      _PK_H_(0x44, 0x0F)
#define REG_BKF044_10_L      _PK_L_(0x44, 0x10)
#define REG_BKF044_10_H      _PK_H_(0x44, 0x10)
#define REG_BKF044_11_L      _PK_L_(0x44, 0x11)
#define REG_BKF044_11_H      _PK_H_(0x44, 0x11)
#define REG_BKF044_12_L      _PK_L_(0x44, 0x12)
#define REG_BKF044_12_H      _PK_H_(0x44, 0x12)
#define REG_BKF044_13_L      _PK_L_(0x44, 0x13)
#define REG_BKF044_13_H      _PK_H_(0x44, 0x13)
#define REG_BKF044_14_L      _PK_L_(0x44, 0x14)
#define REG_BKF044_14_H      _PK_H_(0x44, 0x14)
#define REG_BKF044_15_L      _PK_L_(0x44, 0x15)
#define REG_BKF044_15_H      _PK_H_(0x44, 0x15)
#define REG_BKF044_16_L      _PK_L_(0x44, 0x16)
#define REG_BKF044_16_H      _PK_H_(0x44, 0x16)
#define REG_BKF044_17_L      _PK_L_(0x44, 0x17)
#define REG_BKF044_17_H      _PK_H_(0x44, 0x17)
#define REG_BKF044_18_L      _PK_L_(0x44, 0x18)
#define REG_BKF044_18_H      _PK_H_(0x44, 0x18)
#define REG_BKF044_19_L      _PK_L_(0x44, 0x19)
#define REG_BKF044_19_H      _PK_H_(0x44, 0x19)
#define REG_BKF044_1A_L      _PK_L_(0x44, 0x1A)
#define REG_BKF044_1A_H      _PK_H_(0x44, 0x1A)
#define REG_BKF044_1B_L      _PK_L_(0x44, 0x1B)
#define REG_BKF044_1B_H      _PK_H_(0x44, 0x1B)
#define REG_BKF044_1C_L      _PK_L_(0x44, 0x1C)
#define REG_BKF044_1C_H      _PK_H_(0x44, 0x1C)
#define REG_BKF044_1D_L      _PK_L_(0x44, 0x1D)
#define REG_BKF044_1D_H      _PK_H_(0x44, 0x1D)
#define REG_BKF044_1E_L      _PK_L_(0x44, 0x1E)
#define REG_BKF044_1E_H      _PK_H_(0x44, 0x1E)
#define REG_BKF044_1F_L      _PK_L_(0x44, 0x1F)
#define REG_BKF044_1F_H      _PK_H_(0x44, 0x1F)
#define REG_BKF044_20_L      _PK_L_(0x44, 0x20)
#define REG_BKF044_20_H      _PK_H_(0x44, 0x20)
#define REG_BKF044_21_L      _PK_L_(0x44, 0x21)
#define REG_BKF044_21_H      _PK_H_(0x44, 0x21)
#define REG_BKF044_22_L      _PK_L_(0x44, 0x22)
#define REG_BKF044_22_H      _PK_H_(0x44, 0x22)
#define REG_BKF044_23_L      _PK_L_(0x44, 0x23)
#define REG_BKF044_23_H      _PK_H_(0x44, 0x23)
#define REG_BKF044_24_L      _PK_L_(0x44, 0x24)
#define REG_BKF044_24_H      _PK_H_(0x44, 0x24)
#define REG_BKF044_25_L      _PK_L_(0x44, 0x25)
#define REG_BKF044_25_H      _PK_H_(0x44, 0x25)
#define REG_BKF044_26_L      _PK_L_(0x44, 0x26)
#define REG_BKF044_26_H      _PK_H_(0x44, 0x26)
#define REG_BKF044_27_L      _PK_L_(0x44, 0x27)
#define REG_BKF044_27_H      _PK_H_(0x44, 0x27)
#define REG_BKF044_28_L      _PK_L_(0x44, 0x28)
#define REG_BKF044_28_H      _PK_H_(0x44, 0x28)
#define REG_BKF044_29_L      _PK_L_(0x44, 0x29)
#define REG_BKF044_29_H      _PK_H_(0x44, 0x29)
#define REG_BKF044_2A_L      _PK_L_(0x44, 0x2A)
#define REG_BKF044_2A_H      _PK_H_(0x44, 0x2A)
#define REG_BKF044_2B_L      _PK_L_(0x44, 0x2B)
#define REG_BKF044_2B_H      _PK_H_(0x44, 0x2B)
#define REG_BKF044_2C_L      _PK_L_(0x44, 0x2C)
#define REG_BKF044_2C_H      _PK_H_(0x44, 0x2C)
#define REG_BKF044_2D_L      _PK_L_(0x44, 0x2D)
#define REG_BKF044_2D_H      _PK_H_(0x44, 0x2D)
#define REG_BKF044_2E_L      _PK_L_(0x44, 0x2E)
#define REG_BKF044_2E_H      _PK_H_(0x44, 0x2E)
#define REG_BKF044_2F_L      _PK_L_(0x44, 0x2F)
#define REG_BKF044_2F_H      _PK_H_(0x44, 0x2F)
#define REG_BKF044_30_L      _PK_L_(0x44, 0x30)
#define REG_BKF044_30_H      _PK_H_(0x44, 0x30)
#define REG_BKF044_31_L      _PK_L_(0x44, 0x31)
#define REG_BKF044_31_H      _PK_H_(0x44, 0x31)
#define REG_BKF044_32_L      _PK_L_(0x44, 0x32)
#define REG_BKF044_32_H      _PK_H_(0x44, 0x32)
#define REG_BKF044_33_L      _PK_L_(0x44, 0x33)
#define REG_BKF044_33_H      _PK_H_(0x44, 0x33)
#define REG_BKF044_34_L      _PK_L_(0x44, 0x34)
#define REG_BKF044_34_H      _PK_H_(0x44, 0x34)
#define REG_BKF044_35_L      _PK_L_(0x44, 0x35)
#define REG_BKF044_35_H      _PK_H_(0x44, 0x35)
#define REG_BKF044_36_L      _PK_L_(0x44, 0x36)
#define REG_BKF044_36_H      _PK_H_(0x44, 0x36)
#define REG_BKF044_37_L      _PK_L_(0x44, 0x37)
#define REG_BKF044_37_H      _PK_H_(0x44, 0x37)
#define REG_BKF044_38_L      _PK_L_(0x44, 0x38)
#define REG_BKF044_38_H      _PK_H_(0x44, 0x38)
#define REG_BKF044_39_L      _PK_L_(0x44, 0x39)
#define REG_BKF044_39_H      _PK_H_(0x44, 0x39)
#define REG_BKF044_3A_L      _PK_L_(0x44, 0x3A)
#define REG_BKF044_3A_H      _PK_H_(0x44, 0x3A)
#define REG_BKF044_3B_L      _PK_L_(0x44, 0x3B)
#define REG_BKF044_3B_H      _PK_H_(0x44, 0x3B)
#define REG_BKF044_3C_L      _PK_L_(0x44, 0x3C)
#define REG_BKF044_3C_H      _PK_H_(0x44, 0x3C)
#define REG_BKF044_3D_L      _PK_L_(0x44, 0x3D)
#define REG_BKF044_3D_H      _PK_H_(0x44, 0x3D)
#define REG_BKF044_3E_L      _PK_L_(0x44, 0x3E)
#define REG_BKF044_3E_H      _PK_H_(0x44, 0x3E)
#define REG_BKF044_3F_L      _PK_L_(0x44, 0x3F)
#define REG_BKF044_3F_H      _PK_H_(0x44, 0x3F)
#define REG_BKF044_40_L      _PK_L_(0x44, 0x40)
#define REG_BKF044_40_H      _PK_H_(0x44, 0x40)
#define REG_BKF044_41_L      _PK_L_(0x44, 0x41)
#define REG_BKF044_41_H      _PK_H_(0x44, 0x41)
#define REG_BKF044_42_L      _PK_L_(0x44, 0x42)
#define REG_BKF044_42_H      _PK_H_(0x44, 0x42)
#define REG_BKF044_43_L      _PK_L_(0x44, 0x43)
#define REG_BKF044_43_H      _PK_H_(0x44, 0x43)
#define REG_BKF044_44_L      _PK_L_(0x44, 0x44)
#define REG_BKF044_44_H      _PK_H_(0x44, 0x44)
#define REG_BKF044_45_L      _PK_L_(0x44, 0x45)
#define REG_BKF044_45_H      _PK_H_(0x44, 0x45)
#define REG_BKF044_46_L      _PK_L_(0x44, 0x46)
#define REG_BKF044_46_H      _PK_H_(0x44, 0x46)
#define REG_BKF044_47_L      _PK_L_(0x44, 0x47)
#define REG_BKF044_47_H      _PK_H_(0x44, 0x47)
#define REG_BKF044_48_L      _PK_L_(0x44, 0x48)
#define REG_BKF044_48_H      _PK_H_(0x44, 0x48)
#define REG_BKF044_49_L      _PK_L_(0x44, 0x49)
#define REG_BKF044_49_H      _PK_H_(0x44, 0x49)
#define REG_BKF044_4A_L      _PK_L_(0x44, 0x4A)
#define REG_BKF044_4A_H      _PK_H_(0x44, 0x4A)
#define REG_BKF044_4B_L      _PK_L_(0x44, 0x4B)
#define REG_BKF044_4B_H      _PK_H_(0x44, 0x4B)
#define REG_BKF044_4C_L      _PK_L_(0x44, 0x4C)
#define REG_BKF044_4C_H      _PK_H_(0x44, 0x4C)
#define REG_BKF044_4D_L      _PK_L_(0x44, 0x4D)
#define REG_BKF044_4D_H      _PK_H_(0x44, 0x4D)
#define REG_BKF044_4E_L      _PK_L_(0x44, 0x4E)
#define REG_BKF044_4E_H      _PK_H_(0x44, 0x4E)
#define REG_BKF044_4F_L      _PK_L_(0x44, 0x4F)
#define REG_BKF044_4F_H      _PK_H_(0x44, 0x4F)
#define REG_BKF044_50_L      _PK_L_(0x44, 0x50)
#define REG_BKF044_50_H      _PK_H_(0x44, 0x50)
#define REG_BKF044_51_L      _PK_L_(0x44, 0x51)
#define REG_BKF044_51_H      _PK_H_(0x44, 0x51)
#define REG_BKF044_52_L      _PK_L_(0x44, 0x52)
#define REG_BKF044_52_H      _PK_H_(0x44, 0x52)
#define REG_BKF044_53_L      _PK_L_(0x44, 0x53)
#define REG_BKF044_53_H      _PK_H_(0x44, 0x53)
#define REG_BKF044_54_L      _PK_L_(0x44, 0x54)
#define REG_BKF044_54_H      _PK_H_(0x44, 0x54)
#define REG_BKF044_55_L      _PK_L_(0x44, 0x55)
#define REG_BKF044_55_H      _PK_H_(0x44, 0x55)
#define REG_BKF044_56_L      _PK_L_(0x44, 0x56)
#define REG_BKF044_56_H      _PK_H_(0x44, 0x56)
#define REG_BKF044_57_L      _PK_L_(0x44, 0x57)
#define REG_BKF044_57_H      _PK_H_(0x44, 0x57)
#define REG_BKF044_58_L      _PK_L_(0x44, 0x58)
#define REG_BKF044_58_H      _PK_H_(0x44, 0x58)
#define REG_BKF044_59_L      _PK_L_(0x44, 0x59)
#define REG_BKF044_59_H      _PK_H_(0x44, 0x59)
#define REG_BKF044_5A_L      _PK_L_(0x44, 0x5A)
#define REG_BKF044_5A_H      _PK_H_(0x44, 0x5A)
#define REG_BKF044_5B_L      _PK_L_(0x44, 0x5B)
#define REG_BKF044_5B_H      _PK_H_(0x44, 0x5B)
#define REG_BKF044_5C_L      _PK_L_(0x44, 0x5C)
#define REG_BKF044_5C_H      _PK_H_(0x44, 0x5C)
#define REG_BKF044_5D_L      _PK_L_(0x44, 0x5D)
#define REG_BKF044_5D_H      _PK_H_(0x44, 0x5D)
#define REG_BKF044_5E_L      _PK_L_(0x44, 0x5E)
#define REG_BKF044_5E_H      _PK_H_(0x44, 0x5E)
#define REG_BKF044_5F_L      _PK_L_(0x44, 0x5F)
#define REG_BKF044_5F_H      _PK_H_(0x44, 0x5F)
#define REG_BKF044_60_L      _PK_L_(0x44, 0x60)
#define REG_BKF044_60_H      _PK_H_(0x44, 0x60)
#define REG_BKF044_61_L      _PK_L_(0x44, 0x61)
#define REG_BKF044_61_H      _PK_H_(0x44, 0x61)
#define REG_BKF044_62_L      _PK_L_(0x44, 0x62)
#define REG_BKF044_62_H      _PK_H_(0x44, 0x62)
#define REG_BKF044_63_L      _PK_L_(0x44, 0x63)
#define REG_BKF044_63_H      _PK_H_(0x44, 0x63)
#define REG_BKF044_64_L      _PK_L_(0x44, 0x64)
#define REG_BKF044_64_H      _PK_H_(0x44, 0x64)
#define REG_BKF044_65_L      _PK_L_(0x44, 0x65)
#define REG_BKF044_65_H      _PK_H_(0x44, 0x65)
#define REG_BKF044_66_L      _PK_L_(0x44, 0x66)
#define REG_BKF044_66_H      _PK_H_(0x44, 0x66)
#define REG_BKF044_67_L      _PK_L_(0x44, 0x67)
#define REG_BKF044_67_H      _PK_H_(0x44, 0x67)
#define REG_BKF044_68_L      _PK_L_(0x44, 0x68)
#define REG_BKF044_68_H      _PK_H_(0x44, 0x68)
#define REG_BKF044_69_L      _PK_L_(0x44, 0x69)
#define REG_BKF044_69_H      _PK_H_(0x44, 0x69)
#define REG_BKF044_6A_L      _PK_L_(0x44, 0x6A)
#define REG_BKF044_6A_H      _PK_H_(0x44, 0x6A)
#define REG_BKF044_6B_L      _PK_L_(0x44, 0x6B)
#define REG_BKF044_6B_H      _PK_H_(0x44, 0x6B)
#define REG_BKF044_6C_L      _PK_L_(0x44, 0x6C)
#define REG_BKF044_6C_H      _PK_H_(0x44, 0x6C)
#define REG_BKF044_6D_L      _PK_L_(0x44, 0x6D)
#define REG_BKF044_6D_H      _PK_H_(0x44, 0x6D)
#define REG_BKF044_6E_L      _PK_L_(0x44, 0x6E)
#define REG_BKF044_6E_H      _PK_H_(0x44, 0x6E)
#define REG_BKF044_6F_L      _PK_L_(0x44, 0x6F)
#define REG_BKF044_6F_H      _PK_H_(0x44, 0x6F)
#define REG_BKF044_70_L      _PK_L_(0x44, 0x70)
#define REG_BKF044_70_H      _PK_H_(0x44, 0x70)
#define REG_BKF044_71_L      _PK_L_(0x44, 0x71)
#define REG_BKF044_71_H      _PK_H_(0x44, 0x71)
#define REG_BKF044_72_L      _PK_L_(0x44, 0x72)
#define REG_BKF044_72_H      _PK_H_(0x44, 0x72)
#define REG_BKF044_73_L      _PK_L_(0x44, 0x73)
#define REG_BKF044_73_H      _PK_H_(0x44, 0x73)
#define REG_BKF044_74_L      _PK_L_(0x44, 0x74)
#define REG_BKF044_74_H      _PK_H_(0x44, 0x74)
#define REG_BKF044_75_L      _PK_L_(0x44, 0x75)
#define REG_BKF044_75_H      _PK_H_(0x44, 0x75)
#define REG_BKF044_76_L      _PK_L_(0x44, 0x76)
#define REG_BKF044_76_H      _PK_H_(0x44, 0x76)
#define REG_BKF044_77_L      _PK_L_(0x44, 0x77)
#define REG_BKF044_77_H      _PK_H_(0x44, 0x77)
#define REG_BKF044_78_L      _PK_L_(0x44, 0x78)
#define REG_BKF044_78_H      _PK_H_(0x44, 0x78)
#define REG_BKF044_79_L      _PK_L_(0x44, 0x79)
#define REG_BKF044_79_H      _PK_H_(0x44, 0x79)
#define REG_BKF044_7A_L      _PK_L_(0x44, 0x7A)
#define REG_BKF044_7A_H      _PK_H_(0x44, 0x7A)
#define REG_BKF044_7B_L      _PK_L_(0x44, 0x7B)
#define REG_BKF044_7B_H      _PK_H_(0x44, 0x7B)
#define REG_BKF044_7C_L      _PK_L_(0x44, 0x7C)
#define REG_BKF044_7C_H      _PK_H_(0x44, 0x7C)
#define REG_BKF044_7D_L      _PK_L_(0x44, 0x7D)
#define REG_BKF044_7D_H      _PK_H_(0x44, 0x7D)
#define REG_BKF044_7E_L      _PK_L_(0x44, 0x7E)
#define REG_BKF044_7E_H      _PK_H_(0x44, 0x7E)
#define REG_BKF044_7F_L      _PK_L_(0x44, 0x7F)
#define REG_BKF044_7F_H      _PK_H_(0x44, 0x7F)
//----------------------------------------------
#define REG_BKF045_00_L      _PK_L_(0x45, 0x00)
#define REG_BKF045_00_H      _PK_H_(0x45, 0x00)
#define REG_BKF045_01_L      _PK_L_(0x45, 0x01)
#define REG_BKF045_01_H      _PK_H_(0x45, 0x01)
#define REG_BKF045_02_L      _PK_L_(0x45, 0x02)
#define REG_BKF045_02_H      _PK_H_(0x45, 0x02)
#define REG_BKF045_03_L      _PK_L_(0x45, 0x03)
#define REG_BKF045_03_H      _PK_H_(0x45, 0x03)
#define REG_BKF045_04_L      _PK_L_(0x45, 0x04)
#define REG_BKF045_04_H      _PK_H_(0x45, 0x04)
#define REG_BKF045_05_L      _PK_L_(0x45, 0x05)
#define REG_BKF045_05_H      _PK_H_(0x45, 0x05)
#define REG_BKF045_06_L      _PK_L_(0x45, 0x06)
#define REG_BKF045_06_H      _PK_H_(0x45, 0x06)
#define REG_BKF045_07_L      _PK_L_(0x45, 0x07)
#define REG_BKF045_07_H      _PK_H_(0x45, 0x07)
#define REG_BKF045_08_L      _PK_L_(0x45, 0x08)
#define REG_BKF045_08_H      _PK_H_(0x45, 0x08)
#define REG_BKF045_09_L      _PK_L_(0x45, 0x09)
#define REG_BKF045_09_H      _PK_H_(0x45, 0x09)
#define REG_BKF045_0A_L      _PK_L_(0x45, 0x0A)
#define REG_BKF045_0A_H      _PK_H_(0x45, 0x0A)
#define REG_BKF045_0B_L      _PK_L_(0x45, 0x0B)
#define REG_BKF045_0B_H      _PK_H_(0x45, 0x0B)
#define REG_BKF045_0C_L      _PK_L_(0x45, 0x0C)
#define REG_BKF045_0C_H      _PK_H_(0x45, 0x0C)
#define REG_BKF045_0D_L      _PK_L_(0x45, 0x0D)
#define REG_BKF045_0D_H      _PK_H_(0x45, 0x0D)
#define REG_BKF045_0E_L      _PK_L_(0x45, 0x0E)
#define REG_BKF045_0E_H      _PK_H_(0x45, 0x0E)
#define REG_BKF045_0F_L      _PK_L_(0x45, 0x0F)
#define REG_BKF045_0F_H      _PK_H_(0x45, 0x0F)
#define REG_BKF045_10_L      _PK_L_(0x45, 0x10)
#define REG_BKF045_10_H      _PK_H_(0x45, 0x10)
#define REG_BKF045_11_L      _PK_L_(0x45, 0x11)
#define REG_BKF045_11_H      _PK_H_(0x45, 0x11)
#define REG_BKF045_12_L      _PK_L_(0x45, 0x12)
#define REG_BKF045_12_H      _PK_H_(0x45, 0x12)
#define REG_BKF045_13_L      _PK_L_(0x45, 0x13)
#define REG_BKF045_13_H      _PK_H_(0x45, 0x13)
#define REG_BKF045_14_L      _PK_L_(0x45, 0x14)
#define REG_BKF045_14_H      _PK_H_(0x45, 0x14)
#define REG_BKF045_15_L      _PK_L_(0x45, 0x15)
#define REG_BKF045_15_H      _PK_H_(0x45, 0x15)
#define REG_BKF045_16_L      _PK_L_(0x45, 0x16)
#define REG_BKF045_16_H      _PK_H_(0x45, 0x16)
#define REG_BKF045_17_L      _PK_L_(0x45, 0x17)
#define REG_BKF045_17_H      _PK_H_(0x45, 0x17)
#define REG_BKF045_18_L      _PK_L_(0x45, 0x18)
#define REG_BKF045_18_H      _PK_H_(0x45, 0x18)
#define REG_BKF045_19_L      _PK_L_(0x45, 0x19)
#define REG_BKF045_19_H      _PK_H_(0x45, 0x19)
#define REG_BKF045_1A_L      _PK_L_(0x45, 0x1A)
#define REG_BKF045_1A_H      _PK_H_(0x45, 0x1A)
#define REG_BKF045_1B_L      _PK_L_(0x45, 0x1B)
#define REG_BKF045_1B_H      _PK_H_(0x45, 0x1B)
#define REG_BKF045_1C_L      _PK_L_(0x45, 0x1C)
#define REG_BKF045_1C_H      _PK_H_(0x45, 0x1C)
#define REG_BKF045_1D_L      _PK_L_(0x45, 0x1D)
#define REG_BKF045_1D_H      _PK_H_(0x45, 0x1D)
#define REG_BKF045_1E_L      _PK_L_(0x45, 0x1E)
#define REG_BKF045_1E_H      _PK_H_(0x45, 0x1E)
#define REG_BKF045_1F_L      _PK_L_(0x45, 0x1F)
#define REG_BKF045_1F_H      _PK_H_(0x45, 0x1F)
#define REG_BKF045_20_L      _PK_L_(0x45, 0x20)
#define REG_BKF045_20_H      _PK_H_(0x45, 0x20)
#define REG_BKF045_21_L      _PK_L_(0x45, 0x21)
#define REG_BKF045_21_H      _PK_H_(0x45, 0x21)
#define REG_BKF045_22_L      _PK_L_(0x45, 0x22)
#define REG_BKF045_22_H      _PK_H_(0x45, 0x22)
#define REG_BKF045_23_L      _PK_L_(0x45, 0x23)
#define REG_BKF045_23_H      _PK_H_(0x45, 0x23)
#define REG_BKF045_24_L      _PK_L_(0x45, 0x24)
#define REG_BKF045_24_H      _PK_H_(0x45, 0x24)
#define REG_BKF045_25_L      _PK_L_(0x45, 0x25)
#define REG_BKF045_25_H      _PK_H_(0x45, 0x25)
#define REG_BKF045_26_L      _PK_L_(0x45, 0x26)
#define REG_BKF045_26_H      _PK_H_(0x45, 0x26)
#define REG_BKF045_27_L      _PK_L_(0x45, 0x27)
#define REG_BKF045_27_H      _PK_H_(0x45, 0x27)
#define REG_BKF045_28_L      _PK_L_(0x45, 0x28)
#define REG_BKF045_28_H      _PK_H_(0x45, 0x28)
#define REG_BKF045_29_L      _PK_L_(0x45, 0x29)
#define REG_BKF045_29_H      _PK_H_(0x45, 0x29)
#define REG_BKF045_2A_L      _PK_L_(0x45, 0x2A)
#define REG_BKF045_2A_H      _PK_H_(0x45, 0x2A)
#define REG_BKF045_2B_L      _PK_L_(0x45, 0x2B)
#define REG_BKF045_2B_H      _PK_H_(0x45, 0x2B)
#define REG_BKF045_2C_L      _PK_L_(0x45, 0x2C)
#define REG_BKF045_2C_H      _PK_H_(0x45, 0x2C)
#define REG_BKF045_2D_L      _PK_L_(0x45, 0x2D)
#define REG_BKF045_2D_H      _PK_H_(0x45, 0x2D)
#define REG_BKF045_2E_L      _PK_L_(0x45, 0x2E)
#define REG_BKF045_2E_H      _PK_H_(0x45, 0x2E)
#define REG_BKF045_2F_L      _PK_L_(0x45, 0x2F)
#define REG_BKF045_2F_H      _PK_H_(0x45, 0x2F)
#define REG_BKF045_30_L      _PK_L_(0x45, 0x30)
#define REG_BKF045_30_H      _PK_H_(0x45, 0x30)
#define REG_BKF045_31_L      _PK_L_(0x45, 0x31)
#define REG_BKF045_31_H      _PK_H_(0x45, 0x31)
#define REG_BKF045_32_L      _PK_L_(0x45, 0x32)
#define REG_BKF045_32_H      _PK_H_(0x45, 0x32)
#define REG_BKF045_33_L      _PK_L_(0x45, 0x33)
#define REG_BKF045_33_H      _PK_H_(0x45, 0x33)
#define REG_BKF045_34_L      _PK_L_(0x45, 0x34)
#define REG_BKF045_34_H      _PK_H_(0x45, 0x34)
#define REG_BKF045_35_L      _PK_L_(0x45, 0x35)
#define REG_BKF045_35_H      _PK_H_(0x45, 0x35)
#define REG_BKF045_36_L      _PK_L_(0x45, 0x36)
#define REG_BKF045_36_H      _PK_H_(0x45, 0x36)
#define REG_BKF045_37_L      _PK_L_(0x45, 0x37)
#define REG_BKF045_37_H      _PK_H_(0x45, 0x37)
#define REG_BKF045_38_L      _PK_L_(0x45, 0x38)
#define REG_BKF045_38_H      _PK_H_(0x45, 0x38)
#define REG_BKF045_39_L      _PK_L_(0x45, 0x39)
#define REG_BKF045_39_H      _PK_H_(0x45, 0x39)
#define REG_BKF045_3A_L      _PK_L_(0x45, 0x3A)
#define REG_BKF045_3A_H      _PK_H_(0x45, 0x3A)
#define REG_BKF045_3B_L      _PK_L_(0x45, 0x3B)
#define REG_BKF045_3B_H      _PK_H_(0x45, 0x3B)
#define REG_BKF045_3C_L      _PK_L_(0x45, 0x3C)
#define REG_BKF045_3C_H      _PK_H_(0x45, 0x3C)
#define REG_BKF045_3D_L      _PK_L_(0x45, 0x3D)
#define REG_BKF045_3D_H      _PK_H_(0x45, 0x3D)
#define REG_BKF045_3E_L      _PK_L_(0x45, 0x3E)
#define REG_BKF045_3E_H      _PK_H_(0x45, 0x3E)
#define REG_BKF045_3F_L      _PK_L_(0x45, 0x3F)
#define REG_BKF045_3F_H      _PK_H_(0x45, 0x3F)
#define REG_BKF045_40_L      _PK_L_(0x45, 0x40)
#define REG_BKF045_40_H      _PK_H_(0x45, 0x40)
#define REG_BKF045_41_L      _PK_L_(0x45, 0x41)
#define REG_BKF045_41_H      _PK_H_(0x45, 0x41)
#define REG_BKF045_42_L      _PK_L_(0x45, 0x42)
#define REG_BKF045_42_H      _PK_H_(0x45, 0x42)
#define REG_BKF045_43_L      _PK_L_(0x45, 0x43)
#define REG_BKF045_43_H      _PK_H_(0x45, 0x43)
#define REG_BKF045_44_L      _PK_L_(0x45, 0x44)
#define REG_BKF045_44_H      _PK_H_(0x45, 0x44)
#define REG_BKF045_45_L      _PK_L_(0x45, 0x45)
#define REG_BKF045_45_H      _PK_H_(0x45, 0x45)
#define REG_BKF045_46_L      _PK_L_(0x45, 0x46)
#define REG_BKF045_46_H      _PK_H_(0x45, 0x46)
#define REG_BKF045_47_L      _PK_L_(0x45, 0x47)
#define REG_BKF045_47_H      _PK_H_(0x45, 0x47)
#define REG_BKF045_48_L      _PK_L_(0x45, 0x48)
#define REG_BKF045_48_H      _PK_H_(0x45, 0x48)
#define REG_BKF045_49_L      _PK_L_(0x45, 0x49)
#define REG_BKF045_49_H      _PK_H_(0x45, 0x49)
#define REG_BKF045_4A_L      _PK_L_(0x45, 0x4A)
#define REG_BKF045_4A_H      _PK_H_(0x45, 0x4A)
#define REG_BKF045_4B_L      _PK_L_(0x45, 0x4B)
#define REG_BKF045_4B_H      _PK_H_(0x45, 0x4B)
#define REG_BKF045_4C_L      _PK_L_(0x45, 0x4C)
#define REG_BKF045_4C_H      _PK_H_(0x45, 0x4C)
#define REG_BKF045_4D_L      _PK_L_(0x45, 0x4D)
#define REG_BKF045_4D_H      _PK_H_(0x45, 0x4D)
#define REG_BKF045_4E_L      _PK_L_(0x45, 0x4E)
#define REG_BKF045_4E_H      _PK_H_(0x45, 0x4E)
#define REG_BKF045_4F_L      _PK_L_(0x45, 0x4F)
#define REG_BKF045_4F_H      _PK_H_(0x45, 0x4F)
#define REG_BKF045_50_L      _PK_L_(0x45, 0x50)
#define REG_BKF045_50_H      _PK_H_(0x45, 0x50)
#define REG_BKF045_51_L      _PK_L_(0x45, 0x51)
#define REG_BKF045_51_H      _PK_H_(0x45, 0x51)
#define REG_BKF045_52_L      _PK_L_(0x45, 0x52)
#define REG_BKF045_52_H      _PK_H_(0x45, 0x52)
#define REG_BKF045_53_L      _PK_L_(0x45, 0x53)
#define REG_BKF045_53_H      _PK_H_(0x45, 0x53)
#define REG_BKF045_54_L      _PK_L_(0x45, 0x54)
#define REG_BKF045_54_H      _PK_H_(0x45, 0x54)
#define REG_BKF045_55_L      _PK_L_(0x45, 0x55)
#define REG_BKF045_55_H      _PK_H_(0x45, 0x55)
#define REG_BKF045_56_L      _PK_L_(0x45, 0x56)
#define REG_BKF045_56_H      _PK_H_(0x45, 0x56)
#define REG_BKF045_57_L      _PK_L_(0x45, 0x57)
#define REG_BKF045_57_H      _PK_H_(0x45, 0x57)
#define REG_BKF045_58_L      _PK_L_(0x45, 0x58)
#define REG_BKF045_58_H      _PK_H_(0x45, 0x58)
#define REG_BKF045_59_L      _PK_L_(0x45, 0x59)
#define REG_BKF045_59_H      _PK_H_(0x45, 0x59)
#define REG_BKF045_5A_L      _PK_L_(0x45, 0x5A)
#define REG_BKF045_5A_H      _PK_H_(0x45, 0x5A)
#define REG_BKF045_5B_L      _PK_L_(0x45, 0x5B)
#define REG_BKF045_5B_H      _PK_H_(0x45, 0x5B)
#define REG_BKF045_5C_L      _PK_L_(0x45, 0x5C)
#define REG_BKF045_5C_H      _PK_H_(0x45, 0x5C)
#define REG_BKF045_5D_L      _PK_L_(0x45, 0x5D)
#define REG_BKF045_5D_H      _PK_H_(0x45, 0x5D)
#define REG_BKF045_5E_L      _PK_L_(0x45, 0x5E)
#define REG_BKF045_5E_H      _PK_H_(0x45, 0x5E)
#define REG_BKF045_5F_L      _PK_L_(0x45, 0x5F)
#define REG_BKF045_5F_H      _PK_H_(0x45, 0x5F)
#define REG_BKF045_60_L      _PK_L_(0x45, 0x60)
#define REG_BKF045_60_H      _PK_H_(0x45, 0x60)
#define REG_BKF045_61_L      _PK_L_(0x45, 0x61)
#define REG_BKF045_61_H      _PK_H_(0x45, 0x61)
#define REG_BKF045_62_L      _PK_L_(0x45, 0x62)
#define REG_BKF045_62_H      _PK_H_(0x45, 0x62)
#define REG_BKF045_63_L      _PK_L_(0x45, 0x63)
#define REG_BKF045_63_H      _PK_H_(0x45, 0x63)
#define REG_BKF045_64_L      _PK_L_(0x45, 0x64)
#define REG_BKF045_64_H      _PK_H_(0x45, 0x64)
#define REG_BKF045_65_L      _PK_L_(0x45, 0x65)
#define REG_BKF045_65_H      _PK_H_(0x45, 0x65)
#define REG_BKF045_66_L      _PK_L_(0x45, 0x66)
#define REG_BKF045_66_H      _PK_H_(0x45, 0x66)
#define REG_BKF045_67_L      _PK_L_(0x45, 0x67)
#define REG_BKF045_67_H      _PK_H_(0x45, 0x67)
#define REG_BKF045_68_L      _PK_L_(0x45, 0x68)
#define REG_BKF045_68_H      _PK_H_(0x45, 0x68)
#define REG_BKF045_69_L      _PK_L_(0x45, 0x69)
#define REG_BKF045_69_H      _PK_H_(0x45, 0x69)
#define REG_BKF045_6A_L      _PK_L_(0x45, 0x6A)
#define REG_BKF045_6A_H      _PK_H_(0x45, 0x6A)
#define REG_BKF045_6B_L      _PK_L_(0x45, 0x6B)
#define REG_BKF045_6B_H      _PK_H_(0x45, 0x6B)
#define REG_BKF045_6C_L      _PK_L_(0x45, 0x6C)
#define REG_BKF045_6C_H      _PK_H_(0x45, 0x6C)
#define REG_BKF045_6D_L      _PK_L_(0x45, 0x6D)
#define REG_BKF045_6D_H      _PK_H_(0x45, 0x6D)
#define REG_BKF045_6E_L      _PK_L_(0x45, 0x6E)
#define REG_BKF045_6E_H      _PK_H_(0x45, 0x6E)
#define REG_BKF045_6F_L      _PK_L_(0x45, 0x6F)
#define REG_BKF045_6F_H      _PK_H_(0x45, 0x6F)
#define REG_BKF045_70_L      _PK_L_(0x45, 0x70)
#define REG_BKF045_70_H      _PK_H_(0x45, 0x70)
#define REG_BKF045_71_L      _PK_L_(0x45, 0x71)
#define REG_BKF045_71_H      _PK_H_(0x45, 0x71)
#define REG_BKF045_72_L      _PK_L_(0x45, 0x72)
#define REG_BKF045_72_H      _PK_H_(0x45, 0x72)
#define REG_BKF045_73_L      _PK_L_(0x45, 0x73)
#define REG_BKF045_73_H      _PK_H_(0x45, 0x73)
#define REG_BKF045_74_L      _PK_L_(0x45, 0x74)
#define REG_BKF045_74_H      _PK_H_(0x45, 0x74)
#define REG_BKF045_75_L      _PK_L_(0x45, 0x75)
#define REG_BKF045_75_H      _PK_H_(0x45, 0x75)
#define REG_BKF045_76_L      _PK_L_(0x45, 0x76)
#define REG_BKF045_76_H      _PK_H_(0x45, 0x76)
#define REG_BKF045_77_L      _PK_L_(0x45, 0x77)
#define REG_BKF045_77_H      _PK_H_(0x45, 0x77)
#define REG_BKF045_78_L      _PK_L_(0x45, 0x78)
#define REG_BKF045_78_H      _PK_H_(0x45, 0x78)
#define REG_BKF045_79_L      _PK_L_(0x45, 0x79)
#define REG_BKF045_79_H      _PK_H_(0x45, 0x79)
#define REG_BKF045_7A_L      _PK_L_(0x45, 0x7A)
#define REG_BKF045_7A_H      _PK_H_(0x45, 0x7A)
#define REG_BKF045_7B_L      _PK_L_(0x45, 0x7B)
#define REG_BKF045_7B_H      _PK_H_(0x45, 0x7B)
#define REG_BKF045_7C_L      _PK_L_(0x45, 0x7C)
#define REG_BKF045_7C_H      _PK_H_(0x45, 0x7C)
#define REG_BKF045_7D_L      _PK_L_(0x45, 0x7D)
#define REG_BKF045_7D_H      _PK_H_(0x45, 0x7D)
#define REG_BKF045_7E_L      _PK_L_(0x45, 0x7E)
#define REG_BKF045_7E_H      _PK_H_(0x45, 0x7E)
#define REG_BKF045_7F_L      _PK_L_(0x45, 0x7F)
#define REG_BKF045_7F_H      _PK_H_(0x45, 0x7F)
//----------------------------------------------
#define REG_BKF04A_00_L      _PK_L_(0x4A, 0x00)
#define REG_BKF04A_00_H      _PK_H_(0x4A, 0x00)
#define REG_BKF04A_01_L      _PK_L_(0x4A, 0x01)
#define REG_BKF04A_01_H      _PK_H_(0x4A, 0x01)
#define REG_BKF04A_02_L      _PK_L_(0x4A, 0x02)
#define REG_BKF04A_02_H      _PK_H_(0x4A, 0x02)
#define REG_BKF04A_03_L      _PK_L_(0x4A, 0x03)
#define REG_BKF04A_03_H      _PK_H_(0x4A, 0x03)
#define REG_BKF04A_04_L      _PK_L_(0x4A, 0x04)
#define REG_BKF04A_04_H      _PK_H_(0x4A, 0x04)
#define REG_BKF04A_05_L      _PK_L_(0x4A, 0x05)
#define REG_BKF04A_05_H      _PK_H_(0x4A, 0x05)
#define REG_BKF04A_06_L      _PK_L_(0x4A, 0x06)
#define REG_BKF04A_06_H      _PK_H_(0x4A, 0x06)
#define REG_BKF04A_07_L      _PK_L_(0x4A, 0x07)
#define REG_BKF04A_07_H      _PK_H_(0x4A, 0x07)
#define REG_BKF04A_08_L      _PK_L_(0x4A, 0x08)
#define REG_BKF04A_08_H      _PK_H_(0x4A, 0x08)
#define REG_BKF04A_09_L      _PK_L_(0x4A, 0x09)
#define REG_BKF04A_09_H      _PK_H_(0x4A, 0x09)
#define REG_BKF04A_0A_L      _PK_L_(0x4A, 0x0A)
#define REG_BKF04A_0A_H      _PK_H_(0x4A, 0x0A)
#define REG_BKF04A_0B_L      _PK_L_(0x4A, 0x0B)
#define REG_BKF04A_0B_H      _PK_H_(0x4A, 0x0B)
#define REG_BKF04A_0C_L      _PK_L_(0x4A, 0x0C)
#define REG_BKF04A_0C_H      _PK_H_(0x4A, 0x0C)
#define REG_BKF04A_0D_L      _PK_L_(0x4A, 0x0D)
#define REG_BKF04A_0D_H      _PK_H_(0x4A, 0x0D)
#define REG_BKF04A_0E_L      _PK_L_(0x4A, 0x0E)
#define REG_BKF04A_0E_H      _PK_H_(0x4A, 0x0E)
#define REG_BKF04A_0F_L      _PK_L_(0x4A, 0x0F)
#define REG_BKF04A_0F_H      _PK_H_(0x4A, 0x0F)
#define REG_BKF04A_10_L      _PK_L_(0x4A, 0x10)
#define REG_BKF04A_10_H      _PK_H_(0x4A, 0x10)
#define REG_BKF04A_11_L      _PK_L_(0x4A, 0x11)
#define REG_BKF04A_11_H      _PK_H_(0x4A, 0x11)
#define REG_BKF04A_12_L      _PK_L_(0x4A, 0x12)
#define REG_BKF04A_12_H      _PK_H_(0x4A, 0x12)
#define REG_BKF04A_13_L      _PK_L_(0x4A, 0x13)
#define REG_BKF04A_13_H      _PK_H_(0x4A, 0x13)
#define REG_BKF04A_14_L      _PK_L_(0x4A, 0x14)
#define REG_BKF04A_14_H      _PK_H_(0x4A, 0x14)
#define REG_BKF04A_15_L      _PK_L_(0x4A, 0x15)
#define REG_BKF04A_15_H      _PK_H_(0x4A, 0x15)
#define REG_BKF04A_16_L      _PK_L_(0x4A, 0x16)
#define REG_BKF04A_16_H      _PK_H_(0x4A, 0x16)
#define REG_BKF04A_17_L      _PK_L_(0x4A, 0x17)
#define REG_BKF04A_17_H      _PK_H_(0x4A, 0x17)
#define REG_BKF04A_18_L      _PK_L_(0x4A, 0x18)
#define REG_BKF04A_18_H      _PK_H_(0x4A, 0x18)
#define REG_BKF04A_19_L      _PK_L_(0x4A, 0x19)
#define REG_BKF04A_19_H      _PK_H_(0x4A, 0x19)
#define REG_BKF04A_1A_L      _PK_L_(0x4A, 0x1A)
#define REG_BKF04A_1A_H      _PK_H_(0x4A, 0x1A)
#define REG_BKF04A_1B_L      _PK_L_(0x4A, 0x1B)
#define REG_BKF04A_1B_H      _PK_H_(0x4A, 0x1B)
#define REG_BKF04A_1C_L      _PK_L_(0x4A, 0x1C)
#define REG_BKF04A_1C_H      _PK_H_(0x4A, 0x1C)
#define REG_BKF04A_1D_L      _PK_L_(0x4A, 0x1D)
#define REG_BKF04A_1D_H      _PK_H_(0x4A, 0x1D)
#define REG_BKF04A_1E_L      _PK_L_(0x4A, 0x1E)
#define REG_BKF04A_1E_H      _PK_H_(0x4A, 0x1E)
#define REG_BKF04A_1F_L      _PK_L_(0x4A, 0x1F)
#define REG_BKF04A_1F_H      _PK_H_(0x4A, 0x1F)
#define REG_BKF04A_20_L      _PK_L_(0x4A, 0x20)
#define REG_BKF04A_20_H      _PK_H_(0x4A, 0x20)
#define REG_BKF04A_21_L      _PK_L_(0x4A, 0x21)
#define REG_BKF04A_21_H      _PK_H_(0x4A, 0x21)
#define REG_BKF04A_22_L      _PK_L_(0x4A, 0x22)
#define REG_BKF04A_22_H      _PK_H_(0x4A, 0x22)
#define REG_BKF04A_23_L      _PK_L_(0x4A, 0x23)
#define REG_BKF04A_23_H      _PK_H_(0x4A, 0x23)
#define REG_BKF04A_24_L      _PK_L_(0x4A, 0x24)
#define REG_BKF04A_24_H      _PK_H_(0x4A, 0x24)
#define REG_BKF04A_25_L      _PK_L_(0x4A, 0x25)
#define REG_BKF04A_25_H      _PK_H_(0x4A, 0x25)
#define REG_BKF04A_26_L      _PK_L_(0x4A, 0x26)
#define REG_BKF04A_26_H      _PK_H_(0x4A, 0x26)
#define REG_BKF04A_27_L      _PK_L_(0x4A, 0x27)
#define REG_BKF04A_27_H      _PK_H_(0x4A, 0x27)
#define REG_BKF04A_28_L      _PK_L_(0x4A, 0x28)
#define REG_BKF04A_28_H      _PK_H_(0x4A, 0x28)
#define REG_BKF04A_29_L      _PK_L_(0x4A, 0x29)
#define REG_BKF04A_29_H      _PK_H_(0x4A, 0x29)
#define REG_BKF04A_2A_L      _PK_L_(0x4A, 0x2A)
#define REG_BKF04A_2A_H      _PK_H_(0x4A, 0x2A)
#define REG_BKF04A_2B_L      _PK_L_(0x4A, 0x2B)
#define REG_BKF04A_2B_H      _PK_H_(0x4A, 0x2B)
#define REG_BKF04A_2C_L      _PK_L_(0x4A, 0x2C)
#define REG_BKF04A_2C_H      _PK_H_(0x4A, 0x2C)
#define REG_BKF04A_2D_L      _PK_L_(0x4A, 0x2D)
#define REG_BKF04A_2D_H      _PK_H_(0x4A, 0x2D)
#define REG_BKF04A_2E_L      _PK_L_(0x4A, 0x2E)
#define REG_BKF04A_2E_H      _PK_H_(0x4A, 0x2E)
#define REG_BKF04A_2F_L      _PK_L_(0x4A, 0x2F)
#define REG_BKF04A_2F_H      _PK_H_(0x4A, 0x2F)
#define REG_BKF04A_30_L      _PK_L_(0x4A, 0x30)
#define REG_BKF04A_30_H      _PK_H_(0x4A, 0x30)
#define REG_BKF04A_31_L      _PK_L_(0x4A, 0x31)
#define REG_BKF04A_31_H      _PK_H_(0x4A, 0x31)
#define REG_BKF04A_32_L      _PK_L_(0x4A, 0x32)
#define REG_BKF04A_32_H      _PK_H_(0x4A, 0x32)
#define REG_BKF04A_33_L      _PK_L_(0x4A, 0x33)
#define REG_BKF04A_33_H      _PK_H_(0x4A, 0x33)
#define REG_BKF04A_34_L      _PK_L_(0x4A, 0x34)
#define REG_BKF04A_34_H      _PK_H_(0x4A, 0x34)
#define REG_BKF04A_35_L      _PK_L_(0x4A, 0x35)
#define REG_BKF04A_35_H      _PK_H_(0x4A, 0x35)
#define REG_BKF04A_36_L      _PK_L_(0x4A, 0x36)
#define REG_BKF04A_36_H      _PK_H_(0x4A, 0x36)
#define REG_BKF04A_37_L      _PK_L_(0x4A, 0x37)
#define REG_BKF04A_37_H      _PK_H_(0x4A, 0x37)
#define REG_BKF04A_38_L      _PK_L_(0x4A, 0x38)
#define REG_BKF04A_38_H      _PK_H_(0x4A, 0x38)
#define REG_BKF04A_39_L      _PK_L_(0x4A, 0x39)
#define REG_BKF04A_39_H      _PK_H_(0x4A, 0x39)
#define REG_BKF04A_3A_L      _PK_L_(0x4A, 0x3A)
#define REG_BKF04A_3A_H      _PK_H_(0x4A, 0x3A)
#define REG_BKF04A_3B_L      _PK_L_(0x4A, 0x3B)
#define REG_BKF04A_3B_H      _PK_H_(0x4A, 0x3B)
#define REG_BKF04A_3C_L      _PK_L_(0x4A, 0x3C)
#define REG_BKF04A_3C_H      _PK_H_(0x4A, 0x3C)
#define REG_BKF04A_3D_L      _PK_L_(0x4A, 0x3D)
#define REG_BKF04A_3D_H      _PK_H_(0x4A, 0x3D)
#define REG_BKF04A_3E_L      _PK_L_(0x4A, 0x3E)
#define REG_BKF04A_3E_H      _PK_H_(0x4A, 0x3E)
#define REG_BKF04A_3F_L      _PK_L_(0x4A, 0x3F)
#define REG_BKF04A_3F_H      _PK_H_(0x4A, 0x3F)
#define REG_BKF04A_40_L      _PK_L_(0x4A, 0x40)
#define REG_BKF04A_40_H      _PK_H_(0x4A, 0x40)
#define REG_BKF04A_41_L      _PK_L_(0x4A, 0x41)
#define REG_BKF04A_41_H      _PK_H_(0x4A, 0x41)
#define REG_BKF04A_42_L      _PK_L_(0x4A, 0x42)
#define REG_BKF04A_42_H      _PK_H_(0x4A, 0x42)
#define REG_BKF04A_43_L      _PK_L_(0x4A, 0x43)
#define REG_BKF04A_43_H      _PK_H_(0x4A, 0x43)
#define REG_BKF04A_44_L      _PK_L_(0x4A, 0x44)
#define REG_BKF04A_44_H      _PK_H_(0x4A, 0x44)
#define REG_BKF04A_45_L      _PK_L_(0x4A, 0x45)
#define REG_BKF04A_45_H      _PK_H_(0x4A, 0x45)
#define REG_BKF04A_46_L      _PK_L_(0x4A, 0x46)
#define REG_BKF04A_46_H      _PK_H_(0x4A, 0x46)
#define REG_BKF04A_47_L      _PK_L_(0x4A, 0x47)
#define REG_BKF04A_47_H      _PK_H_(0x4A, 0x47)
#define REG_BKF04A_48_L      _PK_L_(0x4A, 0x48)
#define REG_BKF04A_48_H      _PK_H_(0x4A, 0x48)
#define REG_BKF04A_49_L      _PK_L_(0x4A, 0x49)
#define REG_BKF04A_49_H      _PK_H_(0x4A, 0x49)
#define REG_BKF04A_4A_L      _PK_L_(0x4A, 0x4A)
#define REG_BKF04A_4A_H      _PK_H_(0x4A, 0x4A)
#define REG_BKF04A_4B_L      _PK_L_(0x4A, 0x4B)
#define REG_BKF04A_4B_H      _PK_H_(0x4A, 0x4B)
#define REG_BKF04A_4C_L      _PK_L_(0x4A, 0x4C)
#define REG_BKF04A_4C_H      _PK_H_(0x4A, 0x4C)
#define REG_BKF04A_4D_L      _PK_L_(0x4A, 0x4D)
#define REG_BKF04A_4D_H      _PK_H_(0x4A, 0x4D)
#define REG_BKF04A_4E_L      _PK_L_(0x4A, 0x4E)
#define REG_BKF04A_4E_H      _PK_H_(0x4A, 0x4E)
#define REG_BKF04A_4F_L      _PK_L_(0x4A, 0x4F)
#define REG_BKF04A_4F_H      _PK_H_(0x4A, 0x4F)
#define REG_BKF04A_50_L      _PK_L_(0x4A, 0x50)
#define REG_BKF04A_50_H      _PK_H_(0x4A, 0x50)
#define REG_BKF04A_51_L      _PK_L_(0x4A, 0x51)
#define REG_BKF04A_51_H      _PK_H_(0x4A, 0x51)
#define REG_BKF04A_52_L      _PK_L_(0x4A, 0x52)
#define REG_BKF04A_52_H      _PK_H_(0x4A, 0x52)
#define REG_BKF04A_53_L      _PK_L_(0x4A, 0x53)
#define REG_BKF04A_53_H      _PK_H_(0x4A, 0x53)
#define REG_BKF04A_54_L      _PK_L_(0x4A, 0x54)
#define REG_BKF04A_54_H      _PK_H_(0x4A, 0x54)
#define REG_BKF04A_55_L      _PK_L_(0x4A, 0x55)
#define REG_BKF04A_55_H      _PK_H_(0x4A, 0x55)
#define REG_BKF04A_56_L      _PK_L_(0x4A, 0x56)
#define REG_BKF04A_56_H      _PK_H_(0x4A, 0x56)
#define REG_BKF04A_57_L      _PK_L_(0x4A, 0x57)
#define REG_BKF04A_57_H      _PK_H_(0x4A, 0x57)
#define REG_BKF04A_58_L      _PK_L_(0x4A, 0x58)
#define REG_BKF04A_58_H      _PK_H_(0x4A, 0x58)
#define REG_BKF04A_59_L      _PK_L_(0x4A, 0x59)
#define REG_BKF04A_59_H      _PK_H_(0x4A, 0x59)
#define REG_BKF04A_5A_L      _PK_L_(0x4A, 0x5A)
#define REG_BKF04A_5A_H      _PK_H_(0x4A, 0x5A)
#define REG_BKF04A_5B_L      _PK_L_(0x4A, 0x5B)
#define REG_BKF04A_5B_H      _PK_H_(0x4A, 0x5B)
#define REG_BKF04A_5C_L      _PK_L_(0x4A, 0x5C)
#define REG_BKF04A_5C_H      _PK_H_(0x4A, 0x5C)
#define REG_BKF04A_5D_L      _PK_L_(0x4A, 0x5D)
#define REG_BKF04A_5D_H      _PK_H_(0x4A, 0x5D)
#define REG_BKF04A_5E_L      _PK_L_(0x4A, 0x5E)
#define REG_BKF04A_5E_H      _PK_H_(0x4A, 0x5E)
#define REG_BKF04A_5F_L      _PK_L_(0x4A, 0x5F)
#define REG_BKF04A_5F_H      _PK_H_(0x4A, 0x5F)
#define REG_BKF04A_60_L      _PK_L_(0x4A, 0x60)
#define REG_BKF04A_60_H      _PK_H_(0x4A, 0x60)
#define REG_BKF04A_61_L      _PK_L_(0x4A, 0x61)
#define REG_BKF04A_61_H      _PK_H_(0x4A, 0x61)
#define REG_BKF04A_62_L      _PK_L_(0x4A, 0x62)
#define REG_BKF04A_62_H      _PK_H_(0x4A, 0x62)
#define REG_BKF04A_63_L      _PK_L_(0x4A, 0x63)
#define REG_BKF04A_63_H      _PK_H_(0x4A, 0x63)
#define REG_BKF04A_64_L      _PK_L_(0x4A, 0x64)
#define REG_BKF04A_64_H      _PK_H_(0x4A, 0x64)
#define REG_BKF04A_65_L      _PK_L_(0x4A, 0x65)
#define REG_BKF04A_65_H      _PK_H_(0x4A, 0x65)
#define REG_BKF04A_66_L      _PK_L_(0x4A, 0x66)
#define REG_BKF04A_66_H      _PK_H_(0x4A, 0x66)
#define REG_BKF04A_67_L      _PK_L_(0x4A, 0x67)
#define REG_BKF04A_67_H      _PK_H_(0x4A, 0x67)
#define REG_BKF04A_68_L      _PK_L_(0x4A, 0x68)
#define REG_BKF04A_68_H      _PK_H_(0x4A, 0x68)
#define REG_BKF04A_69_L      _PK_L_(0x4A, 0x69)
#define REG_BKF04A_69_H      _PK_H_(0x4A, 0x69)
#define REG_BKF04A_6A_L      _PK_L_(0x4A, 0x6A)
#define REG_BKF04A_6A_H      _PK_H_(0x4A, 0x6A)
#define REG_BKF04A_6B_L      _PK_L_(0x4A, 0x6B)
#define REG_BKF04A_6B_H      _PK_H_(0x4A, 0x6B)
#define REG_BKF04A_6C_L      _PK_L_(0x4A, 0x6C)
#define REG_BKF04A_6C_H      _PK_H_(0x4A, 0x6C)
#define REG_BKF04A_6D_L      _PK_L_(0x4A, 0x6D)
#define REG_BKF04A_6D_H      _PK_H_(0x4A, 0x6D)
#define REG_BKF04A_6E_L      _PK_L_(0x4A, 0x6E)
#define REG_BKF04A_6E_H      _PK_H_(0x4A, 0x6E)
#define REG_BKF04A_6F_L      _PK_L_(0x4A, 0x6F)
#define REG_BKF04A_6F_H      _PK_H_(0x4A, 0x6F)
#define REG_BKF04A_70_L      _PK_L_(0x4A, 0x70)
#define REG_BKF04A_70_H      _PK_H_(0x4A, 0x70)
#define REG_BKF04A_71_L      _PK_L_(0x4A, 0x71)
#define REG_BKF04A_71_H      _PK_H_(0x4A, 0x71)
#define REG_BKF04A_72_L      _PK_L_(0x4A, 0x72)
#define REG_BKF04A_72_H      _PK_H_(0x4A, 0x72)
#define REG_BKF04A_73_L      _PK_L_(0x4A, 0x73)
#define REG_BKF04A_73_H      _PK_H_(0x4A, 0x73)
#define REG_BKF04A_74_L      _PK_L_(0x4A, 0x74)
#define REG_BKF04A_74_H      _PK_H_(0x4A, 0x74)
#define REG_BKF04A_75_L      _PK_L_(0x4A, 0x75)
#define REG_BKF04A_75_H      _PK_H_(0x4A, 0x75)
#define REG_BKF04A_76_L      _PK_L_(0x4A, 0x76)
#define REG_BKF04A_76_H      _PK_H_(0x4A, 0x76)
#define REG_BKF04A_77_L      _PK_L_(0x4A, 0x77)
#define REG_BKF04A_77_H      _PK_H_(0x4A, 0x77)
#define REG_BKF04A_78_L      _PK_L_(0x4A, 0x78)
#define REG_BKF04A_78_H      _PK_H_(0x4A, 0x78)
#define REG_BKF04A_79_L      _PK_L_(0x4A, 0x79)
#define REG_BKF04A_79_H      _PK_H_(0x4A, 0x79)
#define REG_BKF04A_7A_L      _PK_L_(0x4A, 0x7A)
#define REG_BKF04A_7A_H      _PK_H_(0x4A, 0x7A)
#define REG_BKF04A_7B_L      _PK_L_(0x4A, 0x7B)
#define REG_BKF04A_7B_H      _PK_H_(0x4A, 0x7B)
#define REG_BKF04A_7C_L      _PK_L_(0x4A, 0x7C)
#define REG_BKF04A_7C_H      _PK_H_(0x4A, 0x7C)
#define REG_BKF04A_7D_L      _PK_L_(0x4A, 0x7D)
#define REG_BKF04A_7D_H      _PK_H_(0x4A, 0x7D)
#define REG_BKF04A_7E_L      _PK_L_(0x4A, 0x7E)
#define REG_BKF04A_7E_H      _PK_H_(0x4A, 0x7E)
#define REG_BKF04A_7F_L      _PK_L_(0x4A, 0x7F)
#define REG_BKF04A_7F_H      _PK_H_(0x4A, 0x7F)
//----------------------------------------------
#define REG_BKF04B_00_L      _PK_L_(0x4B, 0x00)
#define REG_BKF04B_00_H      _PK_H_(0x4B, 0x00)
#define REG_BKF04B_01_L      _PK_L_(0x4B, 0x01)
#define REG_BKF04B_01_H      _PK_H_(0x4B, 0x01)
#define REG_BKF04B_02_L      _PK_L_(0x4B, 0x02)
#define REG_BKF04B_02_H      _PK_H_(0x4B, 0x02)
#define REG_BKF04B_03_L      _PK_L_(0x4B, 0x03)
#define REG_BKF04B_03_H      _PK_H_(0x4B, 0x03)
#define REG_BKF04B_04_L      _PK_L_(0x4B, 0x04)
#define REG_BKF04B_04_H      _PK_H_(0x4B, 0x04)
#define REG_BKF04B_05_L      _PK_L_(0x4B, 0x05)
#define REG_BKF04B_05_H      _PK_H_(0x4B, 0x05)
#define REG_BKF04B_06_L      _PK_L_(0x4B, 0x06)
#define REG_BKF04B_06_H      _PK_H_(0x4B, 0x06)
#define REG_BKF04B_07_L      _PK_L_(0x4B, 0x07)
#define REG_BKF04B_07_H      _PK_H_(0x4B, 0x07)
#define REG_BKF04B_08_L      _PK_L_(0x4B, 0x08)
#define REG_BKF04B_08_H      _PK_H_(0x4B, 0x08)
#define REG_BKF04B_09_L      _PK_L_(0x4B, 0x09)
#define REG_BKF04B_09_H      _PK_H_(0x4B, 0x09)
#define REG_BKF04B_0A_L      _PK_L_(0x4B, 0x0A)
#define REG_BKF04B_0A_H      _PK_H_(0x4B, 0x0A)
#define REG_BKF04B_0B_L      _PK_L_(0x4B, 0x0B)
#define REG_BKF04B_0B_H      _PK_H_(0x4B, 0x0B)
#define REG_BKF04B_0C_L      _PK_L_(0x4B, 0x0C)
#define REG_BKF04B_0C_H      _PK_H_(0x4B, 0x0C)
#define REG_BKF04B_0D_L      _PK_L_(0x4B, 0x0D)
#define REG_BKF04B_0D_H      _PK_H_(0x4B, 0x0D)
#define REG_BKF04B_0E_L      _PK_L_(0x4B, 0x0E)
#define REG_BKF04B_0E_H      _PK_H_(0x4B, 0x0E)
#define REG_BKF04B_0F_L      _PK_L_(0x4B, 0x0F)
#define REG_BKF04B_0F_H      _PK_H_(0x4B, 0x0F)
#define REG_BKF04B_10_L      _PK_L_(0x4B, 0x10)
#define REG_BKF04B_10_H      _PK_H_(0x4B, 0x10)
#define REG_BKF04B_11_L      _PK_L_(0x4B, 0x11)
#define REG_BKF04B_11_H      _PK_H_(0x4B, 0x11)
#define REG_BKF04B_12_L      _PK_L_(0x4B, 0x12)
#define REG_BKF04B_12_H      _PK_H_(0x4B, 0x12)
#define REG_BKF04B_13_L      _PK_L_(0x4B, 0x13)
#define REG_BKF04B_13_H      _PK_H_(0x4B, 0x13)
#define REG_BKF04B_14_L      _PK_L_(0x4B, 0x14)
#define REG_BKF04B_14_H      _PK_H_(0x4B, 0x14)
#define REG_BKF04B_15_L      _PK_L_(0x4B, 0x15)
#define REG_BKF04B_15_H      _PK_H_(0x4B, 0x15)
#define REG_BKF04B_16_L      _PK_L_(0x4B, 0x16)
#define REG_BKF04B_16_H      _PK_H_(0x4B, 0x16)
#define REG_BKF04B_17_L      _PK_L_(0x4B, 0x17)
#define REG_BKF04B_17_H      _PK_H_(0x4B, 0x17)
#define REG_BKF04B_18_L      _PK_L_(0x4B, 0x18)
#define REG_BKF04B_18_H      _PK_H_(0x4B, 0x18)
#define REG_BKF04B_19_L      _PK_L_(0x4B, 0x19)
#define REG_BKF04B_19_H      _PK_H_(0x4B, 0x19)
#define REG_BKF04B_1A_L      _PK_L_(0x4B, 0x1A)
#define REG_BKF04B_1A_H      _PK_H_(0x4B, 0x1A)
#define REG_BKF04B_1B_L      _PK_L_(0x4B, 0x1B)
#define REG_BKF04B_1B_H      _PK_H_(0x4B, 0x1B)
#define REG_BKF04B_1C_L      _PK_L_(0x4B, 0x1C)
#define REG_BKF04B_1C_H      _PK_H_(0x4B, 0x1C)
#define REG_BKF04B_1D_L      _PK_L_(0x4B, 0x1D)
#define REG_BKF04B_1D_H      _PK_H_(0x4B, 0x1D)
#define REG_BKF04B_1E_L      _PK_L_(0x4B, 0x1E)
#define REG_BKF04B_1E_H      _PK_H_(0x4B, 0x1E)
#define REG_BKF04B_1F_L      _PK_L_(0x4B, 0x1F)
#define REG_BKF04B_1F_H      _PK_H_(0x4B, 0x1F)
#define REG_BKF04B_20_L      _PK_L_(0x4B, 0x20)
#define REG_BKF04B_20_H      _PK_H_(0x4B, 0x20)
#define REG_BKF04B_21_L      _PK_L_(0x4B, 0x21)
#define REG_BKF04B_21_H      _PK_H_(0x4B, 0x21)
#define REG_BKF04B_22_L      _PK_L_(0x4B, 0x22)
#define REG_BKF04B_22_H      _PK_H_(0x4B, 0x22)
#define REG_BKF04B_23_L      _PK_L_(0x4B, 0x23)
#define REG_BKF04B_23_H      _PK_H_(0x4B, 0x23)
#define REG_BKF04B_24_L      _PK_L_(0x4B, 0x24)
#define REG_BKF04B_24_H      _PK_H_(0x4B, 0x24)
#define REG_BKF04B_25_L      _PK_L_(0x4B, 0x25)
#define REG_BKF04B_25_H      _PK_H_(0x4B, 0x25)
#define REG_BKF04B_26_L      _PK_L_(0x4B, 0x26)
#define REG_BKF04B_26_H      _PK_H_(0x4B, 0x26)
#define REG_BKF04B_27_L      _PK_L_(0x4B, 0x27)
#define REG_BKF04B_27_H      _PK_H_(0x4B, 0x27)
#define REG_BKF04B_28_L      _PK_L_(0x4B, 0x28)
#define REG_BKF04B_28_H      _PK_H_(0x4B, 0x28)
#define REG_BKF04B_29_L      _PK_L_(0x4B, 0x29)
#define REG_BKF04B_29_H      _PK_H_(0x4B, 0x29)
#define REG_BKF04B_2A_L      _PK_L_(0x4B, 0x2A)
#define REG_BKF04B_2A_H      _PK_H_(0x4B, 0x2A)
#define REG_BKF04B_2B_L      _PK_L_(0x4B, 0x2B)
#define REG_BKF04B_2B_H      _PK_H_(0x4B, 0x2B)
#define REG_BKF04B_2C_L      _PK_L_(0x4B, 0x2C)
#define REG_BKF04B_2C_H      _PK_H_(0x4B, 0x2C)
#define REG_BKF04B_2D_L      _PK_L_(0x4B, 0x2D)
#define REG_BKF04B_2D_H      _PK_H_(0x4B, 0x2D)
#define REG_BKF04B_2E_L      _PK_L_(0x4B, 0x2E)
#define REG_BKF04B_2E_H      _PK_H_(0x4B, 0x2E)
#define REG_BKF04B_2F_L      _PK_L_(0x4B, 0x2F)
#define REG_BKF04B_2F_H      _PK_H_(0x4B, 0x2F)
#define REG_BKF04B_30_L      _PK_L_(0x4B, 0x30)
#define REG_BKF04B_30_H      _PK_H_(0x4B, 0x30)
#define REG_BKF04B_31_L      _PK_L_(0x4B, 0x31)
#define REG_BKF04B_31_H      _PK_H_(0x4B, 0x31)
#define REG_BKF04B_32_L      _PK_L_(0x4B, 0x32)
#define REG_BKF04B_32_H      _PK_H_(0x4B, 0x32)
#define REG_BKF04B_33_L      _PK_L_(0x4B, 0x33)
#define REG_BKF04B_33_H      _PK_H_(0x4B, 0x33)
#define REG_BKF04B_34_L      _PK_L_(0x4B, 0x34)
#define REG_BKF04B_34_H      _PK_H_(0x4B, 0x34)
#define REG_BKF04B_35_L      _PK_L_(0x4B, 0x35)
#define REG_BKF04B_35_H      _PK_H_(0x4B, 0x35)
#define REG_BKF04B_36_L      _PK_L_(0x4B, 0x36)
#define REG_BKF04B_36_H      _PK_H_(0x4B, 0x36)
#define REG_BKF04B_37_L      _PK_L_(0x4B, 0x37)
#define REG_BKF04B_37_H      _PK_H_(0x4B, 0x37)
#define REG_BKF04B_38_L      _PK_L_(0x4B, 0x38)
#define REG_BKF04B_38_H      _PK_H_(0x4B, 0x38)
#define REG_BKF04B_39_L      _PK_L_(0x4B, 0x39)
#define REG_BKF04B_39_H      _PK_H_(0x4B, 0x39)
#define REG_BKF04B_3A_L      _PK_L_(0x4B, 0x3A)
#define REG_BKF04B_3A_H      _PK_H_(0x4B, 0x3A)
#define REG_BKF04B_3B_L      _PK_L_(0x4B, 0x3B)
#define REG_BKF04B_3B_H      _PK_H_(0x4B, 0x3B)
#define REG_BKF04B_3C_L      _PK_L_(0x4B, 0x3C)
#define REG_BKF04B_3C_H      _PK_H_(0x4B, 0x3C)
#define REG_BKF04B_3D_L      _PK_L_(0x4B, 0x3D)
#define REG_BKF04B_3D_H      _PK_H_(0x4B, 0x3D)
#define REG_BKF04B_3E_L      _PK_L_(0x4B, 0x3E)
#define REG_BKF04B_3E_H      _PK_H_(0x4B, 0x3E)
#define REG_BKF04B_3F_L      _PK_L_(0x4B, 0x3F)
#define REG_BKF04B_3F_H      _PK_H_(0x4B, 0x3F)
#define REG_BKF04B_40_L      _PK_L_(0x4B, 0x40)
#define REG_BKF04B_40_H      _PK_H_(0x4B, 0x40)
#define REG_BKF04B_41_L      _PK_L_(0x4B, 0x41)
#define REG_BKF04B_41_H      _PK_H_(0x4B, 0x41)
#define REG_BKF04B_42_L      _PK_L_(0x4B, 0x42)
#define REG_BKF04B_42_H      _PK_H_(0x4B, 0x42)
#define REG_BKF04B_43_L      _PK_L_(0x4B, 0x43)
#define REG_BKF04B_43_H      _PK_H_(0x4B, 0x43)
#define REG_BKF04B_44_L      _PK_L_(0x4B, 0x44)
#define REG_BKF04B_44_H      _PK_H_(0x4B, 0x44)
#define REG_BKF04B_45_L      _PK_L_(0x4B, 0x45)
#define REG_BKF04B_45_H      _PK_H_(0x4B, 0x45)
#define REG_BKF04B_46_L      _PK_L_(0x4B, 0x46)
#define REG_BKF04B_46_H      _PK_H_(0x4B, 0x46)
#define REG_BKF04B_47_L      _PK_L_(0x4B, 0x47)
#define REG_BKF04B_47_H      _PK_H_(0x4B, 0x47)
#define REG_BKF04B_48_L      _PK_L_(0x4B, 0x48)
#define REG_BKF04B_48_H      _PK_H_(0x4B, 0x48)
#define REG_BKF04B_49_L      _PK_L_(0x4B, 0x49)
#define REG_BKF04B_49_H      _PK_H_(0x4B, 0x49)
#define REG_BKF04B_4A_L      _PK_L_(0x4B, 0x4A)
#define REG_BKF04B_4A_H      _PK_H_(0x4B, 0x4A)
#define REG_BKF04B_4B_L      _PK_L_(0x4B, 0x4B)
#define REG_BKF04B_4B_H      _PK_H_(0x4B, 0x4B)
#define REG_BKF04B_4C_L      _PK_L_(0x4B, 0x4C)
#define REG_BKF04B_4C_H      _PK_H_(0x4B, 0x4C)
#define REG_BKF04B_4D_L      _PK_L_(0x4B, 0x4D)
#define REG_BKF04B_4D_H      _PK_H_(0x4B, 0x4D)
#define REG_BKF04B_4E_L      _PK_L_(0x4B, 0x4E)
#define REG_BKF04B_4E_H      _PK_H_(0x4B, 0x4E)
#define REG_BKF04B_4F_L      _PK_L_(0x4B, 0x4F)
#define REG_BKF04B_4F_H      _PK_H_(0x4B, 0x4F)
#define REG_BKF04B_50_L      _PK_L_(0x4B, 0x50)
#define REG_BKF04B_50_H      _PK_H_(0x4B, 0x50)
#define REG_BKF04B_51_L      _PK_L_(0x4B, 0x51)
#define REG_BKF04B_51_H      _PK_H_(0x4B, 0x51)
#define REG_BKF04B_52_L      _PK_L_(0x4B, 0x52)
#define REG_BKF04B_52_H      _PK_H_(0x4B, 0x52)
#define REG_BKF04B_53_L      _PK_L_(0x4B, 0x53)
#define REG_BKF04B_53_H      _PK_H_(0x4B, 0x53)
#define REG_BKF04B_54_L      _PK_L_(0x4B, 0x54)
#define REG_BKF04B_54_H      _PK_H_(0x4B, 0x54)
#define REG_BKF04B_55_L      _PK_L_(0x4B, 0x55)
#define REG_BKF04B_55_H      _PK_H_(0x4B, 0x55)
#define REG_BKF04B_56_L      _PK_L_(0x4B, 0x56)
#define REG_BKF04B_56_H      _PK_H_(0x4B, 0x56)
#define REG_BKF04B_57_L      _PK_L_(0x4B, 0x57)
#define REG_BKF04B_57_H      _PK_H_(0x4B, 0x57)
#define REG_BKF04B_58_L      _PK_L_(0x4B, 0x58)
#define REG_BKF04B_58_H      _PK_H_(0x4B, 0x58)
#define REG_BKF04B_59_L      _PK_L_(0x4B, 0x59)
#define REG_BKF04B_59_H      _PK_H_(0x4B, 0x59)
#define REG_BKF04B_5A_L      _PK_L_(0x4B, 0x5A)
#define REG_BKF04B_5A_H      _PK_H_(0x4B, 0x5A)
#define REG_BKF04B_5B_L      _PK_L_(0x4B, 0x5B)
#define REG_BKF04B_5B_H      _PK_H_(0x4B, 0x5B)
#define REG_BKF04B_5C_L      _PK_L_(0x4B, 0x5C)
#define REG_BKF04B_5C_H      _PK_H_(0x4B, 0x5C)
#define REG_BKF04B_5D_L      _PK_L_(0x4B, 0x5D)
#define REG_BKF04B_5D_H      _PK_H_(0x4B, 0x5D)
#define REG_BKF04B_5E_L      _PK_L_(0x4B, 0x5E)
#define REG_BKF04B_5E_H      _PK_H_(0x4B, 0x5E)
#define REG_BKF04B_5F_L      _PK_L_(0x4B, 0x5F)
#define REG_BKF04B_5F_H      _PK_H_(0x4B, 0x5F)
#define REG_BKF04B_60_L      _PK_L_(0x4B, 0x60)
#define REG_BKF04B_60_H      _PK_H_(0x4B, 0x60)
#define REG_BKF04B_61_L      _PK_L_(0x4B, 0x61)
#define REG_BKF04B_61_H      _PK_H_(0x4B, 0x61)
#define REG_BKF04B_62_L      _PK_L_(0x4B, 0x62)
#define REG_BKF04B_62_H      _PK_H_(0x4B, 0x62)
#define REG_BKF04B_63_L      _PK_L_(0x4B, 0x63)
#define REG_BKF04B_63_H      _PK_H_(0x4B, 0x63)
#define REG_BKF04B_64_L      _PK_L_(0x4B, 0x64)
#define REG_BKF04B_64_H      _PK_H_(0x4B, 0x64)
#define REG_BKF04B_65_L      _PK_L_(0x4B, 0x65)
#define REG_BKF04B_65_H      _PK_H_(0x4B, 0x65)
#define REG_BKF04B_66_L      _PK_L_(0x4B, 0x66)
#define REG_BKF04B_66_H      _PK_H_(0x4B, 0x66)
#define REG_BKF04B_67_L      _PK_L_(0x4B, 0x67)
#define REG_BKF04B_67_H      _PK_H_(0x4B, 0x67)
#define REG_BKF04B_68_L      _PK_L_(0x4B, 0x68)
#define REG_BKF04B_68_H      _PK_H_(0x4B, 0x68)
#define REG_BKF04B_69_L      _PK_L_(0x4B, 0x69)
#define REG_BKF04B_69_H      _PK_H_(0x4B, 0x69)
#define REG_BKF04B_6A_L      _PK_L_(0x4B, 0x6A)
#define REG_BKF04B_6A_H      _PK_H_(0x4B, 0x6A)
#define REG_BKF04B_6B_L      _PK_L_(0x4B, 0x6B)
#define REG_BKF04B_6B_H      _PK_H_(0x4B, 0x6B)
#define REG_BKF04B_6C_L      _PK_L_(0x4B, 0x6C)
#define REG_BKF04B_6C_H      _PK_H_(0x4B, 0x6C)
#define REG_BKF04B_6D_L      _PK_L_(0x4B, 0x6D)
#define REG_BKF04B_6D_H      _PK_H_(0x4B, 0x6D)
#define REG_BKF04B_6E_L      _PK_L_(0x4B, 0x6E)
#define REG_BKF04B_6E_H      _PK_H_(0x4B, 0x6E)
#define REG_BKF04B_6F_L      _PK_L_(0x4B, 0x6F)
#define REG_BKF04B_6F_H      _PK_H_(0x4B, 0x6F)
#define REG_BKF04B_70_L      _PK_L_(0x4B, 0x70)
#define REG_BKF04B_70_H      _PK_H_(0x4B, 0x70)
#define REG_BKF04B_71_L      _PK_L_(0x4B, 0x71)
#define REG_BKF04B_71_H      _PK_H_(0x4B, 0x71)
#define REG_BKF04B_72_L      _PK_L_(0x4B, 0x72)
#define REG_BKF04B_72_H      _PK_H_(0x4B, 0x72)
#define REG_BKF04B_73_L      _PK_L_(0x4B, 0x73)
#define REG_BKF04B_73_H      _PK_H_(0x4B, 0x73)
#define REG_BKF04B_74_L      _PK_L_(0x4B, 0x74)
#define REG_BKF04B_74_H      _PK_H_(0x4B, 0x74)
#define REG_BKF04B_75_L      _PK_L_(0x4B, 0x75)
#define REG_BKF04B_75_H      _PK_H_(0x4B, 0x75)
#define REG_BKF04B_76_L      _PK_L_(0x4B, 0x76)
#define REG_BKF04B_76_H      _PK_H_(0x4B, 0x76)
#define REG_BKF04B_77_L      _PK_L_(0x4B, 0x77)
#define REG_BKF04B_77_H      _PK_H_(0x4B, 0x77)
#define REG_BKF04B_78_L      _PK_L_(0x4B, 0x78)
#define REG_BKF04B_78_H      _PK_H_(0x4B, 0x78)
#define REG_BKF04B_79_L      _PK_L_(0x4B, 0x79)
#define REG_BKF04B_79_H      _PK_H_(0x4B, 0x79)
#define REG_BKF04B_7A_L      _PK_L_(0x4B, 0x7A)
#define REG_BKF04B_7A_H      _PK_H_(0x4B, 0x7A)
#define REG_BKF04B_7B_L      _PK_L_(0x4B, 0x7B)
#define REG_BKF04B_7B_H      _PK_H_(0x4B, 0x7B)
#define REG_BKF04B_7C_L      _PK_L_(0x4B, 0x7C)
#define REG_BKF04B_7C_H      _PK_H_(0x4B, 0x7C)
#define REG_BKF04B_7D_L      _PK_L_(0x4B, 0x7D)
#define REG_BKF04B_7D_H      _PK_H_(0x4B, 0x7D)
#define REG_BKF04B_7E_L      _PK_L_(0x4B, 0x7E)
#define REG_BKF04B_7E_H      _PK_H_(0x4B, 0x7E)
#define REG_BKF04B_7F_L      _PK_L_(0x4B, 0x7F)
#define REG_BKF04B_7F_H      _PK_H_(0x4B, 0x7F)
//----------------------------------------------
#define REG_BKF04C_00_L      _PK_L_(0x4C, 0x00)
#define REG_BKF04C_00_H      _PK_H_(0x4C, 0x00)
#define REG_BKF04C_01_L      _PK_L_(0x4C, 0x01)
#define REG_BKF04C_01_H      _PK_H_(0x4C, 0x01)
#define REG_BKF04C_02_L      _PK_L_(0x4C, 0x02)
#define REG_BKF04C_02_H      _PK_H_(0x4C, 0x02)
#define REG_BKF04C_03_L      _PK_L_(0x4C, 0x03)
#define REG_BKF04C_03_H      _PK_H_(0x4C, 0x03)
#define REG_BKF04C_04_L      _PK_L_(0x4C, 0x04)
#define REG_BKF04C_04_H      _PK_H_(0x4C, 0x04)
#define REG_BKF04C_05_L      _PK_L_(0x4C, 0x05)
#define REG_BKF04C_05_H      _PK_H_(0x4C, 0x05)
#define REG_BKF04C_06_L      _PK_L_(0x4C, 0x06)
#define REG_BKF04C_06_H      _PK_H_(0x4C, 0x06)
#define REG_BKF04C_07_L      _PK_L_(0x4C, 0x07)
#define REG_BKF04C_07_H      _PK_H_(0x4C, 0x07)
#define REG_BKF04C_08_L      _PK_L_(0x4C, 0x08)
#define REG_BKF04C_08_H      _PK_H_(0x4C, 0x08)
#define REG_BKF04C_09_L      _PK_L_(0x4C, 0x09)
#define REG_BKF04C_09_H      _PK_H_(0x4C, 0x09)
#define REG_BKF04C_0A_L      _PK_L_(0x4C, 0x0A)
#define REG_BKF04C_0A_H      _PK_H_(0x4C, 0x0A)
#define REG_BKF04C_0B_L      _PK_L_(0x4C, 0x0B)
#define REG_BKF04C_0B_H      _PK_H_(0x4C, 0x0B)
#define REG_BKF04C_0C_L      _PK_L_(0x4C, 0x0C)
#define REG_BKF04C_0C_H      _PK_H_(0x4C, 0x0C)
#define REG_BKF04C_0D_L      _PK_L_(0x4C, 0x0D)
#define REG_BKF04C_0D_H      _PK_H_(0x4C, 0x0D)
#define REG_BKF04C_0E_L      _PK_L_(0x4C, 0x0E)
#define REG_BKF04C_0E_H      _PK_H_(0x4C, 0x0E)
#define REG_BKF04C_0F_L      _PK_L_(0x4C, 0x0F)
#define REG_BKF04C_0F_H      _PK_H_(0x4C, 0x0F)
#define REG_BKF04C_10_L      _PK_L_(0x4C, 0x10)
#define REG_BKF04C_10_H      _PK_H_(0x4C, 0x10)
#define REG_BKF04C_11_L      _PK_L_(0x4C, 0x11)
#define REG_BKF04C_11_H      _PK_H_(0x4C, 0x11)
#define REG_BKF04C_12_L      _PK_L_(0x4C, 0x12)
#define REG_BKF04C_12_H      _PK_H_(0x4C, 0x12)
#define REG_BKF04C_13_L      _PK_L_(0x4C, 0x13)
#define REG_BKF04C_13_H      _PK_H_(0x4C, 0x13)
#define REG_BKF04C_14_L      _PK_L_(0x4C, 0x14)
#define REG_BKF04C_14_H      _PK_H_(0x4C, 0x14)
#define REG_BKF04C_15_L      _PK_L_(0x4C, 0x15)
#define REG_BKF04C_15_H      _PK_H_(0x4C, 0x15)
#define REG_BKF04C_16_L      _PK_L_(0x4C, 0x16)
#define REG_BKF04C_16_H      _PK_H_(0x4C, 0x16)
#define REG_BKF04C_17_L      _PK_L_(0x4C, 0x17)
#define REG_BKF04C_17_H      _PK_H_(0x4C, 0x17)
#define REG_BKF04C_18_L      _PK_L_(0x4C, 0x18)
#define REG_BKF04C_18_H      _PK_H_(0x4C, 0x18)
#define REG_BKF04C_19_L      _PK_L_(0x4C, 0x19)
#define REG_BKF04C_19_H      _PK_H_(0x4C, 0x19)
#define REG_BKF04C_1A_L      _PK_L_(0x4C, 0x1A)
#define REG_BKF04C_1A_H      _PK_H_(0x4C, 0x1A)
#define REG_BKF04C_1B_L      _PK_L_(0x4C, 0x1B)
#define REG_BKF04C_1B_H      _PK_H_(0x4C, 0x1B)
#define REG_BKF04C_1C_L      _PK_L_(0x4C, 0x1C)
#define REG_BKF04C_1C_H      _PK_H_(0x4C, 0x1C)
#define REG_BKF04C_1D_L      _PK_L_(0x4C, 0x1D)
#define REG_BKF04C_1D_H      _PK_H_(0x4C, 0x1D)
#define REG_BKF04C_1E_L      _PK_L_(0x4C, 0x1E)
#define REG_BKF04C_1E_H      _PK_H_(0x4C, 0x1E)
#define REG_BKF04C_1F_L      _PK_L_(0x4C, 0x1F)
#define REG_BKF04C_1F_H      _PK_H_(0x4C, 0x1F)
#define REG_BKF04C_20_L      _PK_L_(0x4C, 0x20)
#define REG_BKF04C_20_H      _PK_H_(0x4C, 0x20)
#define REG_BKF04C_21_L      _PK_L_(0x4C, 0x21)
#define REG_BKF04C_21_H      _PK_H_(0x4C, 0x21)
#define REG_BKF04C_22_L      _PK_L_(0x4C, 0x22)
#define REG_BKF04C_22_H      _PK_H_(0x4C, 0x22)
#define REG_BKF04C_23_L      _PK_L_(0x4C, 0x23)
#define REG_BKF04C_23_H      _PK_H_(0x4C, 0x23)
#define REG_BKF04C_24_L      _PK_L_(0x4C, 0x24)
#define REG_BKF04C_24_H      _PK_H_(0x4C, 0x24)
#define REG_BKF04C_25_L      _PK_L_(0x4C, 0x25)
#define REG_BKF04C_25_H      _PK_H_(0x4C, 0x25)
#define REG_BKF04C_26_L      _PK_L_(0x4C, 0x26)
#define REG_BKF04C_26_H      _PK_H_(0x4C, 0x26)
#define REG_BKF04C_27_L      _PK_L_(0x4C, 0x27)
#define REG_BKF04C_27_H      _PK_H_(0x4C, 0x27)
#define REG_BKF04C_28_L      _PK_L_(0x4C, 0x28)
#define REG_BKF04C_28_H      _PK_H_(0x4C, 0x28)
#define REG_BKF04C_29_L      _PK_L_(0x4C, 0x29)
#define REG_BKF04C_29_H      _PK_H_(0x4C, 0x29)
#define REG_BKF04C_2A_L      _PK_L_(0x4C, 0x2A)
#define REG_BKF04C_2A_H      _PK_H_(0x4C, 0x2A)
#define REG_BKF04C_2B_L      _PK_L_(0x4C, 0x2B)
#define REG_BKF04C_2B_H      _PK_H_(0x4C, 0x2B)
#define REG_BKF04C_2C_L      _PK_L_(0x4C, 0x2C)
#define REG_BKF04C_2C_H      _PK_H_(0x4C, 0x2C)
#define REG_BKF04C_2D_L      _PK_L_(0x4C, 0x2D)
#define REG_BKF04C_2D_H      _PK_H_(0x4C, 0x2D)
#define REG_BKF04C_2E_L      _PK_L_(0x4C, 0x2E)
#define REG_BKF04C_2E_H      _PK_H_(0x4C, 0x2E)
#define REG_BKF04C_2F_L      _PK_L_(0x4C, 0x2F)
#define REG_BKF04C_2F_H      _PK_H_(0x4C, 0x2F)
#define REG_BKF04C_30_L      _PK_L_(0x4C, 0x30)
#define REG_BKF04C_30_H      _PK_H_(0x4C, 0x30)
#define REG_BKF04C_31_L      _PK_L_(0x4C, 0x31)
#define REG_BKF04C_31_H      _PK_H_(0x4C, 0x31)
#define REG_BKF04C_32_L      _PK_L_(0x4C, 0x32)
#define REG_BKF04C_32_H      _PK_H_(0x4C, 0x32)
#define REG_BKF04C_33_L      _PK_L_(0x4C, 0x33)
#define REG_BKF04C_33_H      _PK_H_(0x4C, 0x33)
#define REG_BKF04C_34_L      _PK_L_(0x4C, 0x34)
#define REG_BKF04C_34_H      _PK_H_(0x4C, 0x34)
#define REG_BKF04C_35_L      _PK_L_(0x4C, 0x35)
#define REG_BKF04C_35_H      _PK_H_(0x4C, 0x35)
#define REG_BKF04C_36_L      _PK_L_(0x4C, 0x36)
#define REG_BKF04C_36_H      _PK_H_(0x4C, 0x36)
#define REG_BKF04C_37_L      _PK_L_(0x4C, 0x37)
#define REG_BKF04C_37_H      _PK_H_(0x4C, 0x37)
#define REG_BKF04C_38_L      _PK_L_(0x4C, 0x38)
#define REG_BKF04C_38_H      _PK_H_(0x4C, 0x38)
#define REG_BKF04C_39_L      _PK_L_(0x4C, 0x39)
#define REG_BKF04C_39_H      _PK_H_(0x4C, 0x39)
#define REG_BKF04C_3A_L      _PK_L_(0x4C, 0x3A)
#define REG_BKF04C_3A_H      _PK_H_(0x4C, 0x3A)
#define REG_BKF04C_3B_L      _PK_L_(0x4C, 0x3B)
#define REG_BKF04C_3B_H      _PK_H_(0x4C, 0x3B)
#define REG_BKF04C_3C_L      _PK_L_(0x4C, 0x3C)
#define REG_BKF04C_3C_H      _PK_H_(0x4C, 0x3C)
#define REG_BKF04C_3D_L      _PK_L_(0x4C, 0x3D)
#define REG_BKF04C_3D_H      _PK_H_(0x4C, 0x3D)
#define REG_BKF04C_3E_L      _PK_L_(0x4C, 0x3E)
#define REG_BKF04C_3E_H      _PK_H_(0x4C, 0x3E)
#define REG_BKF04C_3F_L      _PK_L_(0x4C, 0x3F)
#define REG_BKF04C_3F_H      _PK_H_(0x4C, 0x3F)
#define REG_BKF04C_40_L      _PK_L_(0x4C, 0x40)
#define REG_BKF04C_40_H      _PK_H_(0x4C, 0x40)
#define REG_BKF04C_41_L      _PK_L_(0x4C, 0x41)
#define REG_BKF04C_41_H      _PK_H_(0x4C, 0x41)
#define REG_BKF04C_42_L      _PK_L_(0x4C, 0x42)
#define REG_BKF04C_42_H      _PK_H_(0x4C, 0x42)
#define REG_BKF04C_43_L      _PK_L_(0x4C, 0x43)
#define REG_BKF04C_43_H      _PK_H_(0x4C, 0x43)
#define REG_BKF04C_44_L      _PK_L_(0x4C, 0x44)
#define REG_BKF04C_44_H      _PK_H_(0x4C, 0x44)
#define REG_BKF04C_45_L      _PK_L_(0x4C, 0x45)
#define REG_BKF04C_45_H      _PK_H_(0x4C, 0x45)
#define REG_BKF04C_46_L      _PK_L_(0x4C, 0x46)
#define REG_BKF04C_46_H      _PK_H_(0x4C, 0x46)
#define REG_BKF04C_47_L      _PK_L_(0x4C, 0x47)
#define REG_BKF04C_47_H      _PK_H_(0x4C, 0x47)
#define REG_BKF04C_48_L      _PK_L_(0x4C, 0x48)
#define REG_BKF04C_48_H      _PK_H_(0x4C, 0x48)
#define REG_BKF04C_49_L      _PK_L_(0x4C, 0x49)
#define REG_BKF04C_49_H      _PK_H_(0x4C, 0x49)
#define REG_BKF04C_4A_L      _PK_L_(0x4C, 0x4A)
#define REG_BKF04C_4A_H      _PK_H_(0x4C, 0x4A)
#define REG_BKF04C_4B_L      _PK_L_(0x4C, 0x4B)
#define REG_BKF04C_4B_H      _PK_H_(0x4C, 0x4B)
#define REG_BKF04C_4C_L      _PK_L_(0x4C, 0x4C)
#define REG_BKF04C_4C_H      _PK_H_(0x4C, 0x4C)
#define REG_BKF04C_4D_L      _PK_L_(0x4C, 0x4D)
#define REG_BKF04C_4D_H      _PK_H_(0x4C, 0x4D)
#define REG_BKF04C_4E_L      _PK_L_(0x4C, 0x4E)
#define REG_BKF04C_4E_H      _PK_H_(0x4C, 0x4E)
#define REG_BKF04C_4F_L      _PK_L_(0x4C, 0x4F)
#define REG_BKF04C_4F_H      _PK_H_(0x4C, 0x4F)
#define REG_BKF04C_50_L      _PK_L_(0x4C, 0x50)
#define REG_BKF04C_50_H      _PK_H_(0x4C, 0x50)
#define REG_BKF04C_51_L      _PK_L_(0x4C, 0x51)
#define REG_BKF04C_51_H      _PK_H_(0x4C, 0x51)
#define REG_BKF04C_52_L      _PK_L_(0x4C, 0x52)
#define REG_BKF04C_52_H      _PK_H_(0x4C, 0x52)
#define REG_BKF04C_53_L      _PK_L_(0x4C, 0x53)
#define REG_BKF04C_53_H      _PK_H_(0x4C, 0x53)
#define REG_BKF04C_54_L      _PK_L_(0x4C, 0x54)
#define REG_BKF04C_54_H      _PK_H_(0x4C, 0x54)
#define REG_BKF04C_55_L      _PK_L_(0x4C, 0x55)
#define REG_BKF04C_55_H      _PK_H_(0x4C, 0x55)
#define REG_BKF04C_56_L      _PK_L_(0x4C, 0x56)
#define REG_BKF04C_56_H      _PK_H_(0x4C, 0x56)
#define REG_BKF04C_57_L      _PK_L_(0x4C, 0x57)
#define REG_BKF04C_57_H      _PK_H_(0x4C, 0x57)
#define REG_BKF04C_58_L      _PK_L_(0x4C, 0x58)
#define REG_BKF04C_58_H      _PK_H_(0x4C, 0x58)
#define REG_BKF04C_59_L      _PK_L_(0x4C, 0x59)
#define REG_BKF04C_59_H      _PK_H_(0x4C, 0x59)
#define REG_BKF04C_5A_L      _PK_L_(0x4C, 0x5A)
#define REG_BKF04C_5A_H      _PK_H_(0x4C, 0x5A)
#define REG_BKF04C_5B_L      _PK_L_(0x4C, 0x5B)
#define REG_BKF04C_5B_H      _PK_H_(0x4C, 0x5B)
#define REG_BKF04C_5C_L      _PK_L_(0x4C, 0x5C)
#define REG_BKF04C_5C_H      _PK_H_(0x4C, 0x5C)
#define REG_BKF04C_5D_L      _PK_L_(0x4C, 0x5D)
#define REG_BKF04C_5D_H      _PK_H_(0x4C, 0x5D)
#define REG_BKF04C_5E_L      _PK_L_(0x4C, 0x5E)
#define REG_BKF04C_5E_H      _PK_H_(0x4C, 0x5E)
#define REG_BKF04C_5F_L      _PK_L_(0x4C, 0x5F)
#define REG_BKF04C_5F_H      _PK_H_(0x4C, 0x5F)
#define REG_BKF04C_60_L      _PK_L_(0x4C, 0x60)
#define REG_BKF04C_60_H      _PK_H_(0x4C, 0x60)
#define REG_BKF04C_61_L      _PK_L_(0x4C, 0x61)
#define REG_BKF04C_61_H      _PK_H_(0x4C, 0x61)
#define REG_BKF04C_62_L      _PK_L_(0x4C, 0x62)
#define REG_BKF04C_62_H      _PK_H_(0x4C, 0x62)
#define REG_BKF04C_63_L      _PK_L_(0x4C, 0x63)
#define REG_BKF04C_63_H      _PK_H_(0x4C, 0x63)
#define REG_BKF04C_64_L      _PK_L_(0x4C, 0x64)
#define REG_BKF04C_64_H      _PK_H_(0x4C, 0x64)
#define REG_BKF04C_65_L      _PK_L_(0x4C, 0x65)
#define REG_BKF04C_65_H      _PK_H_(0x4C, 0x65)
#define REG_BKF04C_66_L      _PK_L_(0x4C, 0x66)
#define REG_BKF04C_66_H      _PK_H_(0x4C, 0x66)
#define REG_BKF04C_67_L      _PK_L_(0x4C, 0x67)
#define REG_BKF04C_67_H      _PK_H_(0x4C, 0x67)
#define REG_BKF04C_68_L      _PK_L_(0x4C, 0x68)
#define REG_BKF04C_68_H      _PK_H_(0x4C, 0x68)
#define REG_BKF04C_69_L      _PK_L_(0x4C, 0x69)
#define REG_BKF04C_69_H      _PK_H_(0x4C, 0x69)
#define REG_BKF04C_6A_L      _PK_L_(0x4C, 0x6A)
#define REG_BKF04C_6A_H      _PK_H_(0x4C, 0x6A)
#define REG_BKF04C_6B_L      _PK_L_(0x4C, 0x6B)
#define REG_BKF04C_6B_H      _PK_H_(0x4C, 0x6B)
#define REG_BKF04C_6C_L      _PK_L_(0x4C, 0x6C)
#define REG_BKF04C_6C_H      _PK_H_(0x4C, 0x6C)
#define REG_BKF04C_6D_L      _PK_L_(0x4C, 0x6D)
#define REG_BKF04C_6D_H      _PK_H_(0x4C, 0x6D)
#define REG_BKF04C_6E_L      _PK_L_(0x4C, 0x6E)
#define REG_BKF04C_6E_H      _PK_H_(0x4C, 0x6E)
#define REG_BKF04C_6F_L      _PK_L_(0x4C, 0x6F)
#define REG_BKF04C_6F_H      _PK_H_(0x4C, 0x6F)
#define REG_BKF04C_70_L      _PK_L_(0x4C, 0x70)
#define REG_BKF04C_70_H      _PK_H_(0x4C, 0x70)
#define REG_BKF04C_71_L      _PK_L_(0x4C, 0x71)
#define REG_BKF04C_71_H      _PK_H_(0x4C, 0x71)
#define REG_BKF04C_72_L      _PK_L_(0x4C, 0x72)
#define REG_BKF04C_72_H      _PK_H_(0x4C, 0x72)
#define REG_BKF04C_73_L      _PK_L_(0x4C, 0x73)
#define REG_BKF04C_73_H      _PK_H_(0x4C, 0x73)
#define REG_BKF04C_74_L      _PK_L_(0x4C, 0x74)
#define REG_BKF04C_74_H      _PK_H_(0x4C, 0x74)
#define REG_BKF04C_75_L      _PK_L_(0x4C, 0x75)
#define REG_BKF04C_75_H      _PK_H_(0x4C, 0x75)
#define REG_BKF04C_76_L      _PK_L_(0x4C, 0x76)
#define REG_BKF04C_76_H      _PK_H_(0x4C, 0x76)
#define REG_BKF04C_77_L      _PK_L_(0x4C, 0x77)
#define REG_BKF04C_77_H      _PK_H_(0x4C, 0x77)
#define REG_BKF04C_78_L      _PK_L_(0x4C, 0x78)
#define REG_BKF04C_78_H      _PK_H_(0x4C, 0x78)
#define REG_BKF04C_79_L      _PK_L_(0x4C, 0x79)
#define REG_BKF04C_79_H      _PK_H_(0x4C, 0x79)
#define REG_BKF04C_7A_L      _PK_L_(0x4C, 0x7A)
#define REG_BKF04C_7A_H      _PK_H_(0x4C, 0x7A)
#define REG_BKF04C_7B_L      _PK_L_(0x4C, 0x7B)
#define REG_BKF04C_7B_H      _PK_H_(0x4C, 0x7B)
#define REG_BKF04C_7C_L      _PK_L_(0x4C, 0x7C)
#define REG_BKF04C_7C_H      _PK_H_(0x4C, 0x7C)
#define REG_BKF04C_7D_L      _PK_L_(0x4C, 0x7D)
#define REG_BKF04C_7D_H      _PK_H_(0x4C, 0x7D)
#define REG_BKF04C_7E_L      _PK_L_(0x4C, 0x7E)
#define REG_BKF04C_7E_H      _PK_H_(0x4C, 0x7E)
#define REG_BKF04C_7F_L      _PK_L_(0x4C, 0x7F)
#define REG_BKF04C_7F_H      _PK_H_(0x4C, 0x7F)
//----------------------------------------------
#define REG_BKF04D_00_L      _PK_L_(0x4D, 0x00)
#define REG_BKF04D_00_H      _PK_H_(0x4D, 0x00)
#define REG_BKF04D_01_L      _PK_L_(0x4D, 0x01)
#define REG_BKF04D_01_H      _PK_H_(0x4D, 0x01)
#define REG_BKF04D_02_L      _PK_L_(0x4D, 0x02)
#define REG_BKF04D_02_H      _PK_H_(0x4D, 0x02)
#define REG_BKF04D_03_L      _PK_L_(0x4D, 0x03)
#define REG_BKF04D_03_H      _PK_H_(0x4D, 0x03)
#define REG_BKF04D_04_L      _PK_L_(0x4D, 0x04)
#define REG_BKF04D_04_H      _PK_H_(0x4D, 0x04)
#define REG_BKF04D_05_L      _PK_L_(0x4D, 0x05)
#define REG_BKF04D_05_H      _PK_H_(0x4D, 0x05)
#define REG_BKF04D_06_L      _PK_L_(0x4D, 0x06)
#define REG_BKF04D_06_H      _PK_H_(0x4D, 0x06)
#define REG_BKF04D_07_L      _PK_L_(0x4D, 0x07)
#define REG_BKF04D_07_H      _PK_H_(0x4D, 0x07)
#define REG_BKF04D_08_L      _PK_L_(0x4D, 0x08)
#define REG_BKF04D_08_H      _PK_H_(0x4D, 0x08)
#define REG_BKF04D_09_L      _PK_L_(0x4D, 0x09)
#define REG_BKF04D_09_H      _PK_H_(0x4D, 0x09)
#define REG_BKF04D_0A_L      _PK_L_(0x4D, 0x0A)
#define REG_BKF04D_0A_H      _PK_H_(0x4D, 0x0A)
#define REG_BKF04D_0B_L      _PK_L_(0x4D, 0x0B)
#define REG_BKF04D_0B_H      _PK_H_(0x4D, 0x0B)
#define REG_BKF04D_0C_L      _PK_L_(0x4D, 0x0C)
#define REG_BKF04D_0C_H      _PK_H_(0x4D, 0x0C)
#define REG_BKF04D_0D_L      _PK_L_(0x4D, 0x0D)
#define REG_BKF04D_0D_H      _PK_H_(0x4D, 0x0D)
#define REG_BKF04D_0E_L      _PK_L_(0x4D, 0x0E)
#define REG_BKF04D_0E_H      _PK_H_(0x4D, 0x0E)
#define REG_BKF04D_0F_L      _PK_L_(0x4D, 0x0F)
#define REG_BKF04D_0F_H      _PK_H_(0x4D, 0x0F)
#define REG_BKF04D_10_L      _PK_L_(0x4D, 0x10)
#define REG_BKF04D_10_H      _PK_H_(0x4D, 0x10)
#define REG_BKF04D_11_L      _PK_L_(0x4D, 0x11)
#define REG_BKF04D_11_H      _PK_H_(0x4D, 0x11)
#define REG_BKF04D_12_L      _PK_L_(0x4D, 0x12)
#define REG_BKF04D_12_H      _PK_H_(0x4D, 0x12)
#define REG_BKF04D_13_L      _PK_L_(0x4D, 0x13)
#define REG_BKF04D_13_H      _PK_H_(0x4D, 0x13)
#define REG_BKF04D_14_L      _PK_L_(0x4D, 0x14)
#define REG_BKF04D_14_H      _PK_H_(0x4D, 0x14)
#define REG_BKF04D_15_L      _PK_L_(0x4D, 0x15)
#define REG_BKF04D_15_H      _PK_H_(0x4D, 0x15)
#define REG_BKF04D_16_L      _PK_L_(0x4D, 0x16)
#define REG_BKF04D_16_H      _PK_H_(0x4D, 0x16)
#define REG_BKF04D_17_L      _PK_L_(0x4D, 0x17)
#define REG_BKF04D_17_H      _PK_H_(0x4D, 0x17)
#define REG_BKF04D_18_L      _PK_L_(0x4D, 0x18)
#define REG_BKF04D_18_H      _PK_H_(0x4D, 0x18)
#define REG_BKF04D_19_L      _PK_L_(0x4D, 0x19)
#define REG_BKF04D_19_H      _PK_H_(0x4D, 0x19)
#define REG_BKF04D_1A_L      _PK_L_(0x4D, 0x1A)
#define REG_BKF04D_1A_H      _PK_H_(0x4D, 0x1A)
#define REG_BKF04D_1B_L      _PK_L_(0x4D, 0x1B)
#define REG_BKF04D_1B_H      _PK_H_(0x4D, 0x1B)
#define REG_BKF04D_1C_L      _PK_L_(0x4D, 0x1C)
#define REG_BKF04D_1C_H      _PK_H_(0x4D, 0x1C)
#define REG_BKF04D_1D_L      _PK_L_(0x4D, 0x1D)
#define REG_BKF04D_1D_H      _PK_H_(0x4D, 0x1D)
#define REG_BKF04D_1E_L      _PK_L_(0x4D, 0x1E)
#define REG_BKF04D_1E_H      _PK_H_(0x4D, 0x1E)
#define REG_BKF04D_1F_L      _PK_L_(0x4D, 0x1F)
#define REG_BKF04D_1F_H      _PK_H_(0x4D, 0x1F)
#define REG_BKF04D_20_L      _PK_L_(0x4D, 0x20)
#define REG_BKF04D_20_H      _PK_H_(0x4D, 0x20)
#define REG_BKF04D_21_L      _PK_L_(0x4D, 0x21)
#define REG_BKF04D_21_H      _PK_H_(0x4D, 0x21)
#define REG_BKF04D_22_L      _PK_L_(0x4D, 0x22)
#define REG_BKF04D_22_H      _PK_H_(0x4D, 0x22)
#define REG_BKF04D_23_L      _PK_L_(0x4D, 0x23)
#define REG_BKF04D_23_H      _PK_H_(0x4D, 0x23)
#define REG_BKF04D_24_L      _PK_L_(0x4D, 0x24)
#define REG_BKF04D_24_H      _PK_H_(0x4D, 0x24)
#define REG_BKF04D_25_L      _PK_L_(0x4D, 0x25)
#define REG_BKF04D_25_H      _PK_H_(0x4D, 0x25)
#define REG_BKF04D_26_L      _PK_L_(0x4D, 0x26)
#define REG_BKF04D_26_H      _PK_H_(0x4D, 0x26)
#define REG_BKF04D_27_L      _PK_L_(0x4D, 0x27)
#define REG_BKF04D_27_H      _PK_H_(0x4D, 0x27)
#define REG_BKF04D_28_L      _PK_L_(0x4D, 0x28)
#define REG_BKF04D_28_H      _PK_H_(0x4D, 0x28)
#define REG_BKF04D_29_L      _PK_L_(0x4D, 0x29)
#define REG_BKF04D_29_H      _PK_H_(0x4D, 0x29)
#define REG_BKF04D_2A_L      _PK_L_(0x4D, 0x2A)
#define REG_BKF04D_2A_H      _PK_H_(0x4D, 0x2A)
#define REG_BKF04D_2B_L      _PK_L_(0x4D, 0x2B)
#define REG_BKF04D_2B_H      _PK_H_(0x4D, 0x2B)
#define REG_BKF04D_2C_L      _PK_L_(0x4D, 0x2C)
#define REG_BKF04D_2C_H      _PK_H_(0x4D, 0x2C)
#define REG_BKF04D_2D_L      _PK_L_(0x4D, 0x2D)
#define REG_BKF04D_2D_H      _PK_H_(0x4D, 0x2D)
#define REG_BKF04D_2E_L      _PK_L_(0x4D, 0x2E)
#define REG_BKF04D_2E_H      _PK_H_(0x4D, 0x2E)
#define REG_BKF04D_2F_L      _PK_L_(0x4D, 0x2F)
#define REG_BKF04D_2F_H      _PK_H_(0x4D, 0x2F)
#define REG_BKF04D_30_L      _PK_L_(0x4D, 0x30)
#define REG_BKF04D_30_H      _PK_H_(0x4D, 0x30)
#define REG_BKF04D_31_L      _PK_L_(0x4D, 0x31)
#define REG_BKF04D_31_H      _PK_H_(0x4D, 0x31)
#define REG_BKF04D_32_L      _PK_L_(0x4D, 0x32)
#define REG_BKF04D_32_H      _PK_H_(0x4D, 0x32)
#define REG_BKF04D_33_L      _PK_L_(0x4D, 0x33)
#define REG_BKF04D_33_H      _PK_H_(0x4D, 0x33)
#define REG_BKF04D_34_L      _PK_L_(0x4D, 0x34)
#define REG_BKF04D_34_H      _PK_H_(0x4D, 0x34)
#define REG_BKF04D_35_L      _PK_L_(0x4D, 0x35)
#define REG_BKF04D_35_H      _PK_H_(0x4D, 0x35)
#define REG_BKF04D_36_L      _PK_L_(0x4D, 0x36)
#define REG_BKF04D_36_H      _PK_H_(0x4D, 0x36)
#define REG_BKF04D_37_L      _PK_L_(0x4D, 0x37)
#define REG_BKF04D_37_H      _PK_H_(0x4D, 0x37)
#define REG_BKF04D_38_L      _PK_L_(0x4D, 0x38)
#define REG_BKF04D_38_H      _PK_H_(0x4D, 0x38)
#define REG_BKF04D_39_L      _PK_L_(0x4D, 0x39)
#define REG_BKF04D_39_H      _PK_H_(0x4D, 0x39)
#define REG_BKF04D_3A_L      _PK_L_(0x4D, 0x3A)
#define REG_BKF04D_3A_H      _PK_H_(0x4D, 0x3A)
#define REG_BKF04D_3B_L      _PK_L_(0x4D, 0x3B)
#define REG_BKF04D_3B_H      _PK_H_(0x4D, 0x3B)
#define REG_BKF04D_3C_L      _PK_L_(0x4D, 0x3C)
#define REG_BKF04D_3C_H      _PK_H_(0x4D, 0x3C)
#define REG_BKF04D_3D_L      _PK_L_(0x4D, 0x3D)
#define REG_BKF04D_3D_H      _PK_H_(0x4D, 0x3D)
#define REG_BKF04D_3E_L      _PK_L_(0x4D, 0x3E)
#define REG_BKF04D_3E_H      _PK_H_(0x4D, 0x3E)
#define REG_BKF04D_3F_L      _PK_L_(0x4D, 0x3F)
#define REG_BKF04D_3F_H      _PK_H_(0x4D, 0x3F)
#define REG_BKF04D_40_L      _PK_L_(0x4D, 0x40)
#define REG_BKF04D_40_H      _PK_H_(0x4D, 0x40)
#define REG_BKF04D_41_L      _PK_L_(0x4D, 0x41)
#define REG_BKF04D_41_H      _PK_H_(0x4D, 0x41)
#define REG_BKF04D_42_L      _PK_L_(0x4D, 0x42)
#define REG_BKF04D_42_H      _PK_H_(0x4D, 0x42)
#define REG_BKF04D_43_L      _PK_L_(0x4D, 0x43)
#define REG_BKF04D_43_H      _PK_H_(0x4D, 0x43)
#define REG_BKF04D_44_L      _PK_L_(0x4D, 0x44)
#define REG_BKF04D_44_H      _PK_H_(0x4D, 0x44)
#define REG_BKF04D_45_L      _PK_L_(0x4D, 0x45)
#define REG_BKF04D_45_H      _PK_H_(0x4D, 0x45)
#define REG_BKF04D_46_L      _PK_L_(0x4D, 0x46)
#define REG_BKF04D_46_H      _PK_H_(0x4D, 0x46)
#define REG_BKF04D_47_L      _PK_L_(0x4D, 0x47)
#define REG_BKF04D_47_H      _PK_H_(0x4D, 0x47)
#define REG_BKF04D_48_L      _PK_L_(0x4D, 0x48)
#define REG_BKF04D_48_H      _PK_H_(0x4D, 0x48)
#define REG_BKF04D_49_L      _PK_L_(0x4D, 0x49)
#define REG_BKF04D_49_H      _PK_H_(0x4D, 0x49)
#define REG_BKF04D_4A_L      _PK_L_(0x4D, 0x4A)
#define REG_BKF04D_4A_H      _PK_H_(0x4D, 0x4A)
#define REG_BKF04D_4B_L      _PK_L_(0x4D, 0x4B)
#define REG_BKF04D_4B_H      _PK_H_(0x4D, 0x4B)
#define REG_BKF04D_4C_L      _PK_L_(0x4D, 0x4C)
#define REG_BKF04D_4C_H      _PK_H_(0x4D, 0x4C)
#define REG_BKF04D_4D_L      _PK_L_(0x4D, 0x4D)
#define REG_BKF04D_4D_H      _PK_H_(0x4D, 0x4D)
#define REG_BKF04D_4E_L      _PK_L_(0x4D, 0x4E)
#define REG_BKF04D_4E_H      _PK_H_(0x4D, 0x4E)
#define REG_BKF04D_4F_L      _PK_L_(0x4D, 0x4F)
#define REG_BKF04D_4F_H      _PK_H_(0x4D, 0x4F)
#define REG_BKF04D_50_L      _PK_L_(0x4D, 0x50)
#define REG_BKF04D_50_H      _PK_H_(0x4D, 0x50)
#define REG_BKF04D_51_L      _PK_L_(0x4D, 0x51)
#define REG_BKF04D_51_H      _PK_H_(0x4D, 0x51)
#define REG_BKF04D_52_L      _PK_L_(0x4D, 0x52)
#define REG_BKF04D_52_H      _PK_H_(0x4D, 0x52)
#define REG_BKF04D_53_L      _PK_L_(0x4D, 0x53)
#define REG_BKF04D_53_H      _PK_H_(0x4D, 0x53)
#define REG_BKF04D_54_L      _PK_L_(0x4D, 0x54)
#define REG_BKF04D_54_H      _PK_H_(0x4D, 0x54)
#define REG_BKF04D_55_L      _PK_L_(0x4D, 0x55)
#define REG_BKF04D_55_H      _PK_H_(0x4D, 0x55)
#define REG_BKF04D_56_L      _PK_L_(0x4D, 0x56)
#define REG_BKF04D_56_H      _PK_H_(0x4D, 0x56)
#define REG_BKF04D_57_L      _PK_L_(0x4D, 0x57)
#define REG_BKF04D_57_H      _PK_H_(0x4D, 0x57)
#define REG_BKF04D_58_L      _PK_L_(0x4D, 0x58)
#define REG_BKF04D_58_H      _PK_H_(0x4D, 0x58)
#define REG_BKF04D_59_L      _PK_L_(0x4D, 0x59)
#define REG_BKF04D_59_H      _PK_H_(0x4D, 0x59)
#define REG_BKF04D_5A_L      _PK_L_(0x4D, 0x5A)
#define REG_BKF04D_5A_H      _PK_H_(0x4D, 0x5A)
#define REG_BKF04D_5B_L      _PK_L_(0x4D, 0x5B)
#define REG_BKF04D_5B_H      _PK_H_(0x4D, 0x5B)
#define REG_BKF04D_5C_L      _PK_L_(0x4D, 0x5C)
#define REG_BKF04D_5C_H      _PK_H_(0x4D, 0x5C)
#define REG_BKF04D_5D_L      _PK_L_(0x4D, 0x5D)
#define REG_BKF04D_5D_H      _PK_H_(0x4D, 0x5D)
#define REG_BKF04D_5E_L      _PK_L_(0x4D, 0x5E)
#define REG_BKF04D_5E_H      _PK_H_(0x4D, 0x5E)
#define REG_BKF04D_5F_L      _PK_L_(0x4D, 0x5F)
#define REG_BKF04D_5F_H      _PK_H_(0x4D, 0x5F)
#define REG_BKF04D_60_L      _PK_L_(0x4D, 0x60)
#define REG_BKF04D_60_H      _PK_H_(0x4D, 0x60)
#define REG_BKF04D_61_L      _PK_L_(0x4D, 0x61)
#define REG_BKF04D_61_H      _PK_H_(0x4D, 0x61)
#define REG_BKF04D_62_L      _PK_L_(0x4D, 0x62)
#define REG_BKF04D_62_H      _PK_H_(0x4D, 0x62)
#define REG_BKF04D_63_L      _PK_L_(0x4D, 0x63)
#define REG_BKF04D_63_H      _PK_H_(0x4D, 0x63)
#define REG_BKF04D_64_L      _PK_L_(0x4D, 0x64)
#define REG_BKF04D_64_H      _PK_H_(0x4D, 0x64)
#define REG_BKF04D_65_L      _PK_L_(0x4D, 0x65)
#define REG_BKF04D_65_H      _PK_H_(0x4D, 0x65)
#define REG_BKF04D_66_L      _PK_L_(0x4D, 0x66)
#define REG_BKF04D_66_H      _PK_H_(0x4D, 0x66)
#define REG_BKF04D_67_L      _PK_L_(0x4D, 0x67)
#define REG_BKF04D_67_H      _PK_H_(0x4D, 0x67)
#define REG_BKF04D_68_L      _PK_L_(0x4D, 0x68)
#define REG_BKF04D_68_H      _PK_H_(0x4D, 0x68)
#define REG_BKF04D_69_L      _PK_L_(0x4D, 0x69)
#define REG_BKF04D_69_H      _PK_H_(0x4D, 0x69)
#define REG_BKF04D_6A_L      _PK_L_(0x4D, 0x6A)
#define REG_BKF04D_6A_H      _PK_H_(0x4D, 0x6A)
#define REG_BKF04D_6B_L      _PK_L_(0x4D, 0x6B)
#define REG_BKF04D_6B_H      _PK_H_(0x4D, 0x6B)
#define REG_BKF04D_6C_L      _PK_L_(0x4D, 0x6C)
#define REG_BKF04D_6C_H      _PK_H_(0x4D, 0x6C)
#define REG_BKF04D_6D_L      _PK_L_(0x4D, 0x6D)
#define REG_BKF04D_6D_H      _PK_H_(0x4D, 0x6D)
#define REG_BKF04D_6E_L      _PK_L_(0x4D, 0x6E)
#define REG_BKF04D_6E_H      _PK_H_(0x4D, 0x6E)
#define REG_BKF04D_6F_L      _PK_L_(0x4D, 0x6F)
#define REG_BKF04D_6F_H      _PK_H_(0x4D, 0x6F)
#define REG_BKF04D_70_L      _PK_L_(0x4D, 0x70)
#define REG_BKF04D_70_H      _PK_H_(0x4D, 0x70)
#define REG_BKF04D_71_L      _PK_L_(0x4D, 0x71)
#define REG_BKF04D_71_H      _PK_H_(0x4D, 0x71)
#define REG_BKF04D_72_L      _PK_L_(0x4D, 0x72)
#define REG_BKF04D_72_H      _PK_H_(0x4D, 0x72)
#define REG_BKF04D_73_L      _PK_L_(0x4D, 0x73)
#define REG_BKF04D_73_H      _PK_H_(0x4D, 0x73)
#define REG_BKF04D_74_L      _PK_L_(0x4D, 0x74)
#define REG_BKF04D_74_H      _PK_H_(0x4D, 0x74)
#define REG_BKF04D_75_L      _PK_L_(0x4D, 0x75)
#define REG_BKF04D_75_H      _PK_H_(0x4D, 0x75)
#define REG_BKF04D_76_L      _PK_L_(0x4D, 0x76)
#define REG_BKF04D_76_H      _PK_H_(0x4D, 0x76)
#define REG_BKF04D_77_L      _PK_L_(0x4D, 0x77)
#define REG_BKF04D_77_H      _PK_H_(0x4D, 0x77)
#define REG_BKF04D_78_L      _PK_L_(0x4D, 0x78)
#define REG_BKF04D_78_H      _PK_H_(0x4D, 0x78)
#define REG_BKF04D_79_L      _PK_L_(0x4D, 0x79)
#define REG_BKF04D_79_H      _PK_H_(0x4D, 0x79)
#define REG_BKF04D_7A_L      _PK_L_(0x4D, 0x7A)
#define REG_BKF04D_7A_H      _PK_H_(0x4D, 0x7A)
#define REG_BKF04D_7B_L      _PK_L_(0x4D, 0x7B)
#define REG_BKF04D_7B_H      _PK_H_(0x4D, 0x7B)
#define REG_BKF04D_7C_L      _PK_L_(0x4D, 0x7C)
#define REG_BKF04D_7C_H      _PK_H_(0x4D, 0x7C)
#define REG_BKF04D_7D_L      _PK_L_(0x4D, 0x7D)
#define REG_BKF04D_7D_H      _PK_H_(0x4D, 0x7D)
#define REG_BKF04D_7E_L      _PK_L_(0x4D, 0x7E)
#define REG_BKF04D_7E_H      _PK_H_(0x4D, 0x7E)
#define REG_BKF04D_7F_L      _PK_L_(0x4D, 0x7F)
#define REG_BKF04D_7F_H      _PK_H_(0x4D, 0x7F)
//----------------------------------------------
#define REG_BKF04E_00_L      _PK_L_(0x4E, 0x00)
#define REG_BKF04E_00_H      _PK_H_(0x4E, 0x00)
#define REG_BKF04E_01_L      _PK_L_(0x4E, 0x01)
#define REG_BKF04E_01_H      _PK_H_(0x4E, 0x01)
#define REG_BKF04E_02_L      _PK_L_(0x4E, 0x02)
#define REG_BKF04E_02_H      _PK_H_(0x4E, 0x02)
#define REG_BKF04E_03_L      _PK_L_(0x4E, 0x03)
#define REG_BKF04E_03_H      _PK_H_(0x4E, 0x03)
#define REG_BKF04E_04_L      _PK_L_(0x4E, 0x04)
#define REG_BKF04E_04_H      _PK_H_(0x4E, 0x04)
#define REG_BKF04E_05_L      _PK_L_(0x4E, 0x05)
#define REG_BKF04E_05_H      _PK_H_(0x4E, 0x05)
#define REG_BKF04E_06_L      _PK_L_(0x4E, 0x06)
#define REG_BKF04E_06_H      _PK_H_(0x4E, 0x06)
#define REG_BKF04E_07_L      _PK_L_(0x4E, 0x07)
#define REG_BKF04E_07_H      _PK_H_(0x4E, 0x07)
#define REG_BKF04E_08_L      _PK_L_(0x4E, 0x08)
#define REG_BKF04E_08_H      _PK_H_(0x4E, 0x08)
#define REG_BKF04E_09_L      _PK_L_(0x4E, 0x09)
#define REG_BKF04E_09_H      _PK_H_(0x4E, 0x09)
#define REG_BKF04E_0A_L      _PK_L_(0x4E, 0x0A)
#define REG_BKF04E_0A_H      _PK_H_(0x4E, 0x0A)
#define REG_BKF04E_0B_L      _PK_L_(0x4E, 0x0B)
#define REG_BKF04E_0B_H      _PK_H_(0x4E, 0x0B)
#define REG_BKF04E_0C_L      _PK_L_(0x4E, 0x0C)
#define REG_BKF04E_0C_H      _PK_H_(0x4E, 0x0C)
#define REG_BKF04E_0D_L      _PK_L_(0x4E, 0x0D)
#define REG_BKF04E_0D_H      _PK_H_(0x4E, 0x0D)
#define REG_BKF04E_0E_L      _PK_L_(0x4E, 0x0E)
#define REG_BKF04E_0E_H      _PK_H_(0x4E, 0x0E)
#define REG_BKF04E_0F_L      _PK_L_(0x4E, 0x0F)
#define REG_BKF04E_0F_H      _PK_H_(0x4E, 0x0F)
#define REG_BKF04E_10_L      _PK_L_(0x4E, 0x10)
#define REG_BKF04E_10_H      _PK_H_(0x4E, 0x10)
#define REG_BKF04E_11_L      _PK_L_(0x4E, 0x11)
#define REG_BKF04E_11_H      _PK_H_(0x4E, 0x11)
#define REG_BKF04E_12_L      _PK_L_(0x4E, 0x12)
#define REG_BKF04E_12_H      _PK_H_(0x4E, 0x12)
#define REG_BKF04E_13_L      _PK_L_(0x4E, 0x13)
#define REG_BKF04E_13_H      _PK_H_(0x4E, 0x13)
#define REG_BKF04E_14_L      _PK_L_(0x4E, 0x14)
#define REG_BKF04E_14_H      _PK_H_(0x4E, 0x14)
#define REG_BKF04E_15_L      _PK_L_(0x4E, 0x15)
#define REG_BKF04E_15_H      _PK_H_(0x4E, 0x15)
#define REG_BKF04E_16_L      _PK_L_(0x4E, 0x16)
#define REG_BKF04E_16_H      _PK_H_(0x4E, 0x16)
#define REG_BKF04E_17_L      _PK_L_(0x4E, 0x17)
#define REG_BKF04E_17_H      _PK_H_(0x4E, 0x17)
#define REG_BKF04E_18_L      _PK_L_(0x4E, 0x18)
#define REG_BKF04E_18_H      _PK_H_(0x4E, 0x18)
#define REG_BKF04E_19_L      _PK_L_(0x4E, 0x19)
#define REG_BKF04E_19_H      _PK_H_(0x4E, 0x19)
#define REG_BKF04E_1A_L      _PK_L_(0x4E, 0x1A)
#define REG_BKF04E_1A_H      _PK_H_(0x4E, 0x1A)
#define REG_BKF04E_1B_L      _PK_L_(0x4E, 0x1B)
#define REG_BKF04E_1B_H      _PK_H_(0x4E, 0x1B)
#define REG_BKF04E_1C_L      _PK_L_(0x4E, 0x1C)
#define REG_BKF04E_1C_H      _PK_H_(0x4E, 0x1C)
#define REG_BKF04E_1D_L      _PK_L_(0x4E, 0x1D)
#define REG_BKF04E_1D_H      _PK_H_(0x4E, 0x1D)
#define REG_BKF04E_1E_L      _PK_L_(0x4E, 0x1E)
#define REG_BKF04E_1E_H      _PK_H_(0x4E, 0x1E)
#define REG_BKF04E_1F_L      _PK_L_(0x4E, 0x1F)
#define REG_BKF04E_1F_H      _PK_H_(0x4E, 0x1F)
#define REG_BKF04E_20_L      _PK_L_(0x4E, 0x20)
#define REG_BKF04E_20_H      _PK_H_(0x4E, 0x20)
#define REG_BKF04E_21_L      _PK_L_(0x4E, 0x21)
#define REG_BKF04E_21_H      _PK_H_(0x4E, 0x21)
#define REG_BKF04E_22_L      _PK_L_(0x4E, 0x22)
#define REG_BKF04E_22_H      _PK_H_(0x4E, 0x22)
#define REG_BKF04E_23_L      _PK_L_(0x4E, 0x23)
#define REG_BKF04E_23_H      _PK_H_(0x4E, 0x23)
#define REG_BKF04E_24_L      _PK_L_(0x4E, 0x24)
#define REG_BKF04E_24_H      _PK_H_(0x4E, 0x24)
#define REG_BKF04E_25_L      _PK_L_(0x4E, 0x25)
#define REG_BKF04E_25_H      _PK_H_(0x4E, 0x25)
#define REG_BKF04E_26_L      _PK_L_(0x4E, 0x26)
#define REG_BKF04E_26_H      _PK_H_(0x4E, 0x26)
#define REG_BKF04E_27_L      _PK_L_(0x4E, 0x27)
#define REG_BKF04E_27_H      _PK_H_(0x4E, 0x27)
#define REG_BKF04E_28_L      _PK_L_(0x4E, 0x28)
#define REG_BKF04E_28_H      _PK_H_(0x4E, 0x28)
#define REG_BKF04E_29_L      _PK_L_(0x4E, 0x29)
#define REG_BKF04E_29_H      _PK_H_(0x4E, 0x29)
#define REG_BKF04E_2A_L      _PK_L_(0x4E, 0x2A)
#define REG_BKF04E_2A_H      _PK_H_(0x4E, 0x2A)
#define REG_BKF04E_2B_L      _PK_L_(0x4E, 0x2B)
#define REG_BKF04E_2B_H      _PK_H_(0x4E, 0x2B)
#define REG_BKF04E_2C_L      _PK_L_(0x4E, 0x2C)
#define REG_BKF04E_2C_H      _PK_H_(0x4E, 0x2C)
#define REG_BKF04E_2D_L      _PK_L_(0x4E, 0x2D)
#define REG_BKF04E_2D_H      _PK_H_(0x4E, 0x2D)
#define REG_BKF04E_2E_L      _PK_L_(0x4E, 0x2E)
#define REG_BKF04E_2E_H      _PK_H_(0x4E, 0x2E)
#define REG_BKF04E_2F_L      _PK_L_(0x4E, 0x2F)
#define REG_BKF04E_2F_H      _PK_H_(0x4E, 0x2F)
#define REG_BKF04E_30_L      _PK_L_(0x4E, 0x30)
#define REG_BKF04E_30_H      _PK_H_(0x4E, 0x30)
#define REG_BKF04E_31_L      _PK_L_(0x4E, 0x31)
#define REG_BKF04E_31_H      _PK_H_(0x4E, 0x31)
#define REG_BKF04E_32_L      _PK_L_(0x4E, 0x32)
#define REG_BKF04E_32_H      _PK_H_(0x4E, 0x32)
#define REG_BKF04E_33_L      _PK_L_(0x4E, 0x33)
#define REG_BKF04E_33_H      _PK_H_(0x4E, 0x33)
#define REG_BKF04E_34_L      _PK_L_(0x4E, 0x34)
#define REG_BKF04E_34_H      _PK_H_(0x4E, 0x34)
#define REG_BKF04E_35_L      _PK_L_(0x4E, 0x35)
#define REG_BKF04E_35_H      _PK_H_(0x4E, 0x35)
#define REG_BKF04E_36_L      _PK_L_(0x4E, 0x36)
#define REG_BKF04E_36_H      _PK_H_(0x4E, 0x36)
#define REG_BKF04E_37_L      _PK_L_(0x4E, 0x37)
#define REG_BKF04E_37_H      _PK_H_(0x4E, 0x37)
#define REG_BKF04E_38_L      _PK_L_(0x4E, 0x38)
#define REG_BKF04E_38_H      _PK_H_(0x4E, 0x38)
#define REG_BKF04E_39_L      _PK_L_(0x4E, 0x39)
#define REG_BKF04E_39_H      _PK_H_(0x4E, 0x39)
#define REG_BKF04E_3A_L      _PK_L_(0x4E, 0x3A)
#define REG_BKF04E_3A_H      _PK_H_(0x4E, 0x3A)
#define REG_BKF04E_3B_L      _PK_L_(0x4E, 0x3B)
#define REG_BKF04E_3B_H      _PK_H_(0x4E, 0x3B)
#define REG_BKF04E_3C_L      _PK_L_(0x4E, 0x3C)
#define REG_BKF04E_3C_H      _PK_H_(0x4E, 0x3C)
#define REG_BKF04E_3D_L      _PK_L_(0x4E, 0x3D)
#define REG_BKF04E_3D_H      _PK_H_(0x4E, 0x3D)
#define REG_BKF04E_3E_L      _PK_L_(0x4E, 0x3E)
#define REG_BKF04E_3E_H      _PK_H_(0x4E, 0x3E)
#define REG_BKF04E_3F_L      _PK_L_(0x4E, 0x3F)
#define REG_BKF04E_3F_H      _PK_H_(0x4E, 0x3F)
#define REG_BKF04E_40_L      _PK_L_(0x4E, 0x40)
#define REG_BKF04E_40_H      _PK_H_(0x4E, 0x40)
#define REG_BKF04E_41_L      _PK_L_(0x4E, 0x41)
#define REG_BKF04E_41_H      _PK_H_(0x4E, 0x41)
#define REG_BKF04E_42_L      _PK_L_(0x4E, 0x42)
#define REG_BKF04E_42_H      _PK_H_(0x4E, 0x42)
#define REG_BKF04E_43_L      _PK_L_(0x4E, 0x43)
#define REG_BKF04E_43_H      _PK_H_(0x4E, 0x43)
#define REG_BKF04E_44_L      _PK_L_(0x4E, 0x44)
#define REG_BKF04E_44_H      _PK_H_(0x4E, 0x44)
#define REG_BKF04E_45_L      _PK_L_(0x4E, 0x45)
#define REG_BKF04E_45_H      _PK_H_(0x4E, 0x45)
#define REG_BKF04E_46_L      _PK_L_(0x4E, 0x46)
#define REG_BKF04E_46_H      _PK_H_(0x4E, 0x46)
#define REG_BKF04E_47_L      _PK_L_(0x4E, 0x47)
#define REG_BKF04E_47_H      _PK_H_(0x4E, 0x47)
#define REG_BKF04E_48_L      _PK_L_(0x4E, 0x48)
#define REG_BKF04E_48_H      _PK_H_(0x4E, 0x48)
#define REG_BKF04E_49_L      _PK_L_(0x4E, 0x49)
#define REG_BKF04E_49_H      _PK_H_(0x4E, 0x49)
#define REG_BKF04E_4A_L      _PK_L_(0x4E, 0x4A)
#define REG_BKF04E_4A_H      _PK_H_(0x4E, 0x4A)
#define REG_BKF04E_4B_L      _PK_L_(0x4E, 0x4B)
#define REG_BKF04E_4B_H      _PK_H_(0x4E, 0x4B)
#define REG_BKF04E_4C_L      _PK_L_(0x4E, 0x4C)
#define REG_BKF04E_4C_H      _PK_H_(0x4E, 0x4C)
#define REG_BKF04E_4D_L      _PK_L_(0x4E, 0x4D)
#define REG_BKF04E_4D_H      _PK_H_(0x4E, 0x4D)
#define REG_BKF04E_4E_L      _PK_L_(0x4E, 0x4E)
#define REG_BKF04E_4E_H      _PK_H_(0x4E, 0x4E)
#define REG_BKF04E_4F_L      _PK_L_(0x4E, 0x4F)
#define REG_BKF04E_4F_H      _PK_H_(0x4E, 0x4F)
#define REG_BKF04E_50_L      _PK_L_(0x4E, 0x50)
#define REG_BKF04E_50_H      _PK_H_(0x4E, 0x50)
#define REG_BKF04E_51_L      _PK_L_(0x4E, 0x51)
#define REG_BKF04E_51_H      _PK_H_(0x4E, 0x51)
#define REG_BKF04E_52_L      _PK_L_(0x4E, 0x52)
#define REG_BKF04E_52_H      _PK_H_(0x4E, 0x52)
#define REG_BKF04E_53_L      _PK_L_(0x4E, 0x53)
#define REG_BKF04E_53_H      _PK_H_(0x4E, 0x53)
#define REG_BKF04E_54_L      _PK_L_(0x4E, 0x54)
#define REG_BKF04E_54_H      _PK_H_(0x4E, 0x54)
#define REG_BKF04E_55_L      _PK_L_(0x4E, 0x55)
#define REG_BKF04E_55_H      _PK_H_(0x4E, 0x55)
#define REG_BKF04E_56_L      _PK_L_(0x4E, 0x56)
#define REG_BKF04E_56_H      _PK_H_(0x4E, 0x56)
#define REG_BKF04E_57_L      _PK_L_(0x4E, 0x57)
#define REG_BKF04E_57_H      _PK_H_(0x4E, 0x57)
#define REG_BKF04E_58_L      _PK_L_(0x4E, 0x58)
#define REG_BKF04E_58_H      _PK_H_(0x4E, 0x58)
#define REG_BKF04E_59_L      _PK_L_(0x4E, 0x59)
#define REG_BKF04E_59_H      _PK_H_(0x4E, 0x59)
#define REG_BKF04E_5A_L      _PK_L_(0x4E, 0x5A)
#define REG_BKF04E_5A_H      _PK_H_(0x4E, 0x5A)
#define REG_BKF04E_5B_L      _PK_L_(0x4E, 0x5B)
#define REG_BKF04E_5B_H      _PK_H_(0x4E, 0x5B)
#define REG_BKF04E_5C_L      _PK_L_(0x4E, 0x5C)
#define REG_BKF04E_5C_H      _PK_H_(0x4E, 0x5C)
#define REG_BKF04E_5D_L      _PK_L_(0x4E, 0x5D)
#define REG_BKF04E_5D_H      _PK_H_(0x4E, 0x5D)
#define REG_BKF04E_5E_L      _PK_L_(0x4E, 0x5E)
#define REG_BKF04E_5E_H      _PK_H_(0x4E, 0x5E)
#define REG_BKF04E_5F_L      _PK_L_(0x4E, 0x5F)
#define REG_BKF04E_5F_H      _PK_H_(0x4E, 0x5F)
#define REG_BKF04E_60_L      _PK_L_(0x4E, 0x60)
#define REG_BKF04E_60_H      _PK_H_(0x4E, 0x60)
#define REG_BKF04E_61_L      _PK_L_(0x4E, 0x61)
#define REG_BKF04E_61_H      _PK_H_(0x4E, 0x61)
#define REG_BKF04E_62_L      _PK_L_(0x4E, 0x62)
#define REG_BKF04E_62_H      _PK_H_(0x4E, 0x62)
#define REG_BKF04E_63_L      _PK_L_(0x4E, 0x63)
#define REG_BKF04E_63_H      _PK_H_(0x4E, 0x63)
#define REG_BKF04E_64_L      _PK_L_(0x4E, 0x64)
#define REG_BKF04E_64_H      _PK_H_(0x4E, 0x64)
#define REG_BKF04E_65_L      _PK_L_(0x4E, 0x65)
#define REG_BKF04E_65_H      _PK_H_(0x4E, 0x65)
#define REG_BKF04E_66_L      _PK_L_(0x4E, 0x66)
#define REG_BKF04E_66_H      _PK_H_(0x4E, 0x66)
#define REG_BKF04E_67_L      _PK_L_(0x4E, 0x67)
#define REG_BKF04E_67_H      _PK_H_(0x4E, 0x67)
#define REG_BKF04E_68_L      _PK_L_(0x4E, 0x68)
#define REG_BKF04E_68_H      _PK_H_(0x4E, 0x68)
#define REG_BKF04E_69_L      _PK_L_(0x4E, 0x69)
#define REG_BKF04E_69_H      _PK_H_(0x4E, 0x69)
#define REG_BKF04E_6A_L      _PK_L_(0x4E, 0x6A)
#define REG_BKF04E_6A_H      _PK_H_(0x4E, 0x6A)
#define REG_BKF04E_6B_L      _PK_L_(0x4E, 0x6B)
#define REG_BKF04E_6B_H      _PK_H_(0x4E, 0x6B)
#define REG_BKF04E_6C_L      _PK_L_(0x4E, 0x6C)
#define REG_BKF04E_6C_H      _PK_H_(0x4E, 0x6C)
#define REG_BKF04E_6D_L      _PK_L_(0x4E, 0x6D)
#define REG_BKF04E_6D_H      _PK_H_(0x4E, 0x6D)
#define REG_BKF04E_6E_L      _PK_L_(0x4E, 0x6E)
#define REG_BKF04E_6E_H      _PK_H_(0x4E, 0x6E)
#define REG_BKF04E_6F_L      _PK_L_(0x4E, 0x6F)
#define REG_BKF04E_6F_H      _PK_H_(0x4E, 0x6F)
#define REG_BKF04E_70_L      _PK_L_(0x4E, 0x70)
#define REG_BKF04E_70_H      _PK_H_(0x4E, 0x70)
#define REG_BKF04E_71_L      _PK_L_(0x4E, 0x71)
#define REG_BKF04E_71_H      _PK_H_(0x4E, 0x71)
#define REG_BKF04E_72_L      _PK_L_(0x4E, 0x72)
#define REG_BKF04E_72_H      _PK_H_(0x4E, 0x72)
#define REG_BKF04E_73_L      _PK_L_(0x4E, 0x73)
#define REG_BKF04E_73_H      _PK_H_(0x4E, 0x73)
#define REG_BKF04E_74_L      _PK_L_(0x4E, 0x74)
#define REG_BKF04E_74_H      _PK_H_(0x4E, 0x74)
#define REG_BKF04E_75_L      _PK_L_(0x4E, 0x75)
#define REG_BKF04E_75_H      _PK_H_(0x4E, 0x75)
#define REG_BKF04E_76_L      _PK_L_(0x4E, 0x76)
#define REG_BKF04E_76_H      _PK_H_(0x4E, 0x76)
#define REG_BKF04E_77_L      _PK_L_(0x4E, 0x77)
#define REG_BKF04E_77_H      _PK_H_(0x4E, 0x77)
#define REG_BKF04E_78_L      _PK_L_(0x4E, 0x78)
#define REG_BKF04E_78_H      _PK_H_(0x4E, 0x78)
#define REG_BKF04E_79_L      _PK_L_(0x4E, 0x79)
#define REG_BKF04E_79_H      _PK_H_(0x4E, 0x79)
#define REG_BKF04E_7A_L      _PK_L_(0x4E, 0x7A)
#define REG_BKF04E_7A_H      _PK_H_(0x4E, 0x7A)
#define REG_BKF04E_7B_L      _PK_L_(0x4E, 0x7B)
#define REG_BKF04E_7B_H      _PK_H_(0x4E, 0x7B)
#define REG_BKF04E_7C_L      _PK_L_(0x4E, 0x7C)
#define REG_BKF04E_7C_H      _PK_H_(0x4E, 0x7C)
#define REG_BKF04E_7D_L      _PK_L_(0x4E, 0x7D)
#define REG_BKF04E_7D_H      _PK_H_(0x4E, 0x7D)
#define REG_BKF04E_7E_L      _PK_L_(0x4E, 0x7E)
#define REG_BKF04E_7E_H      _PK_H_(0x4E, 0x7E)
#define REG_BKF04E_7F_L      _PK_L_(0x4E, 0x7F)
#define REG_BKF04E_7F_H      _PK_H_(0x4E, 0x7F)
//----------------------------------------------
#define REG_BKF04F_00_L      _PK_L_(0x4F, 0x00)
#define REG_BKF04F_00_H      _PK_H_(0x4F, 0x00)
#define REG_BKF04F_01_L      _PK_L_(0x4F, 0x01)
#define REG_BKF04F_01_H      _PK_H_(0x4F, 0x01)
#define REG_BKF04F_02_L      _PK_L_(0x4F, 0x02)
#define REG_BKF04F_02_H      _PK_H_(0x4F, 0x02)
#define REG_BKF04F_03_L      _PK_L_(0x4F, 0x03)
#define REG_BKF04F_03_H      _PK_H_(0x4F, 0x03)
#define REG_BKF04F_04_L      _PK_L_(0x4F, 0x04)
#define REG_BKF04F_04_H      _PK_H_(0x4F, 0x04)
#define REG_BKF04F_05_L      _PK_L_(0x4F, 0x05)
#define REG_BKF04F_05_H      _PK_H_(0x4F, 0x05)
#define REG_BKF04F_06_L      _PK_L_(0x4F, 0x06)
#define REG_BKF04F_06_H      _PK_H_(0x4F, 0x06)
#define REG_BKF04F_07_L      _PK_L_(0x4F, 0x07)
#define REG_BKF04F_07_H      _PK_H_(0x4F, 0x07)
#define REG_BKF04F_08_L      _PK_L_(0x4F, 0x08)
#define REG_BKF04F_08_H      _PK_H_(0x4F, 0x08)
#define REG_BKF04F_09_L      _PK_L_(0x4F, 0x09)
#define REG_BKF04F_09_H      _PK_H_(0x4F, 0x09)
#define REG_BKF04F_0A_L      _PK_L_(0x4F, 0x0A)
#define REG_BKF04F_0A_H      _PK_H_(0x4F, 0x0A)
#define REG_BKF04F_0B_L      _PK_L_(0x4F, 0x0B)
#define REG_BKF04F_0B_H      _PK_H_(0x4F, 0x0B)
#define REG_BKF04F_0C_L      _PK_L_(0x4F, 0x0C)
#define REG_BKF04F_0C_H      _PK_H_(0x4F, 0x0C)
#define REG_BKF04F_0D_L      _PK_L_(0x4F, 0x0D)
#define REG_BKF04F_0D_H      _PK_H_(0x4F, 0x0D)
#define REG_BKF04F_0E_L      _PK_L_(0x4F, 0x0E)
#define REG_BKF04F_0E_H      _PK_H_(0x4F, 0x0E)
#define REG_BKF04F_0F_L      _PK_L_(0x4F, 0x0F)
#define REG_BKF04F_0F_H      _PK_H_(0x4F, 0x0F)
#define REG_BKF04F_10_L      _PK_L_(0x4F, 0x10)
#define REG_BKF04F_10_H      _PK_H_(0x4F, 0x10)
#define REG_BKF04F_11_L      _PK_L_(0x4F, 0x11)
#define REG_BKF04F_11_H      _PK_H_(0x4F, 0x11)
#define REG_BKF04F_12_L      _PK_L_(0x4F, 0x12)
#define REG_BKF04F_12_H      _PK_H_(0x4F, 0x12)
#define REG_BKF04F_13_L      _PK_L_(0x4F, 0x13)
#define REG_BKF04F_13_H      _PK_H_(0x4F, 0x13)
#define REG_BKF04F_14_L      _PK_L_(0x4F, 0x14)
#define REG_BKF04F_14_H      _PK_H_(0x4F, 0x14)
#define REG_BKF04F_15_L      _PK_L_(0x4F, 0x15)
#define REG_BKF04F_15_H      _PK_H_(0x4F, 0x15)
#define REG_BKF04F_16_L      _PK_L_(0x4F, 0x16)
#define REG_BKF04F_16_H      _PK_H_(0x4F, 0x16)
#define REG_BKF04F_17_L      _PK_L_(0x4F, 0x17)
#define REG_BKF04F_17_H      _PK_H_(0x4F, 0x17)
#define REG_BKF04F_18_L      _PK_L_(0x4F, 0x18)
#define REG_BKF04F_18_H      _PK_H_(0x4F, 0x18)
#define REG_BKF04F_19_L      _PK_L_(0x4F, 0x19)
#define REG_BKF04F_19_H      _PK_H_(0x4F, 0x19)
#define REG_BKF04F_1A_L      _PK_L_(0x4F, 0x1A)
#define REG_BKF04F_1A_H      _PK_H_(0x4F, 0x1A)
#define REG_BKF04F_1B_L      _PK_L_(0x4F, 0x1B)
#define REG_BKF04F_1B_H      _PK_H_(0x4F, 0x1B)
#define REG_BKF04F_1C_L      _PK_L_(0x4F, 0x1C)
#define REG_BKF04F_1C_H      _PK_H_(0x4F, 0x1C)
#define REG_BKF04F_1D_L      _PK_L_(0x4F, 0x1D)
#define REG_BKF04F_1D_H      _PK_H_(0x4F, 0x1D)
#define REG_BKF04F_1E_L      _PK_L_(0x4F, 0x1E)
#define REG_BKF04F_1E_H      _PK_H_(0x4F, 0x1E)
#define REG_BKF04F_1F_L      _PK_L_(0x4F, 0x1F)
#define REG_BKF04F_1F_H      _PK_H_(0x4F, 0x1F)
#define REG_BKF04F_20_L      _PK_L_(0x4F, 0x20)
#define REG_BKF04F_20_H      _PK_H_(0x4F, 0x20)
#define REG_BKF04F_21_L      _PK_L_(0x4F, 0x21)
#define REG_BKF04F_21_H      _PK_H_(0x4F, 0x21)
#define REG_BKF04F_22_L      _PK_L_(0x4F, 0x22)
#define REG_BKF04F_22_H      _PK_H_(0x4F, 0x22)
#define REG_BKF04F_23_L      _PK_L_(0x4F, 0x23)
#define REG_BKF04F_23_H      _PK_H_(0x4F, 0x23)
#define REG_BKF04F_24_L      _PK_L_(0x4F, 0x24)
#define REG_BKF04F_24_H      _PK_H_(0x4F, 0x24)
#define REG_BKF04F_25_L      _PK_L_(0x4F, 0x25)
#define REG_BKF04F_25_H      _PK_H_(0x4F, 0x25)
#define REG_BKF04F_26_L      _PK_L_(0x4F, 0x26)
#define REG_BKF04F_26_H      _PK_H_(0x4F, 0x26)
#define REG_BKF04F_27_L      _PK_L_(0x4F, 0x27)
#define REG_BKF04F_27_H      _PK_H_(0x4F, 0x27)
#define REG_BKF04F_28_L      _PK_L_(0x4F, 0x28)
#define REG_BKF04F_28_H      _PK_H_(0x4F, 0x28)
#define REG_BKF04F_29_L      _PK_L_(0x4F, 0x29)
#define REG_BKF04F_29_H      _PK_H_(0x4F, 0x29)
#define REG_BKF04F_2A_L      _PK_L_(0x4F, 0x2A)
#define REG_BKF04F_2A_H      _PK_H_(0x4F, 0x2A)
#define REG_BKF04F_2B_L      _PK_L_(0x4F, 0x2B)
#define REG_BKF04F_2B_H      _PK_H_(0x4F, 0x2B)
#define REG_BKF04F_2C_L      _PK_L_(0x4F, 0x2C)
#define REG_BKF04F_2C_H      _PK_H_(0x4F, 0x2C)
#define REG_BKF04F_2D_L      _PK_L_(0x4F, 0x2D)
#define REG_BKF04F_2D_H      _PK_H_(0x4F, 0x2D)
#define REG_BKF04F_2E_L      _PK_L_(0x4F, 0x2E)
#define REG_BKF04F_2E_H      _PK_H_(0x4F, 0x2E)
#define REG_BKF04F_2F_L      _PK_L_(0x4F, 0x2F)
#define REG_BKF04F_2F_H      _PK_H_(0x4F, 0x2F)
#define REG_BKF04F_30_L      _PK_L_(0x4F, 0x30)
#define REG_BKF04F_30_H      _PK_H_(0x4F, 0x30)
#define REG_BKF04F_31_L      _PK_L_(0x4F, 0x31)
#define REG_BKF04F_31_H      _PK_H_(0x4F, 0x31)
#define REG_BKF04F_32_L      _PK_L_(0x4F, 0x32)
#define REG_BKF04F_32_H      _PK_H_(0x4F, 0x32)
#define REG_BKF04F_33_L      _PK_L_(0x4F, 0x33)
#define REG_BKF04F_33_H      _PK_H_(0x4F, 0x33)
#define REG_BKF04F_34_L      _PK_L_(0x4F, 0x34)
#define REG_BKF04F_34_H      _PK_H_(0x4F, 0x34)
#define REG_BKF04F_35_L      _PK_L_(0x4F, 0x35)
#define REG_BKF04F_35_H      _PK_H_(0x4F, 0x35)
#define REG_BKF04F_36_L      _PK_L_(0x4F, 0x36)
#define REG_BKF04F_36_H      _PK_H_(0x4F, 0x36)
#define REG_BKF04F_37_L      _PK_L_(0x4F, 0x37)
#define REG_BKF04F_37_H      _PK_H_(0x4F, 0x37)
#define REG_BKF04F_38_L      _PK_L_(0x4F, 0x38)
#define REG_BKF04F_38_H      _PK_H_(0x4F, 0x38)
#define REG_BKF04F_39_L      _PK_L_(0x4F, 0x39)
#define REG_BKF04F_39_H      _PK_H_(0x4F, 0x39)
#define REG_BKF04F_3A_L      _PK_L_(0x4F, 0x3A)
#define REG_BKF04F_3A_H      _PK_H_(0x4F, 0x3A)
#define REG_BKF04F_3B_L      _PK_L_(0x4F, 0x3B)
#define REG_BKF04F_3B_H      _PK_H_(0x4F, 0x3B)
#define REG_BKF04F_3C_L      _PK_L_(0x4F, 0x3C)
#define REG_BKF04F_3C_H      _PK_H_(0x4F, 0x3C)
#define REG_BKF04F_3D_L      _PK_L_(0x4F, 0x3D)
#define REG_BKF04F_3D_H      _PK_H_(0x4F, 0x3D)
#define REG_BKF04F_3E_L      _PK_L_(0x4F, 0x3E)
#define REG_BKF04F_3E_H      _PK_H_(0x4F, 0x3E)
#define REG_BKF04F_3F_L      _PK_L_(0x4F, 0x3F)
#define REG_BKF04F_3F_H      _PK_H_(0x4F, 0x3F)
#define REG_BKF04F_40_L      _PK_L_(0x4F, 0x40)
#define REG_BKF04F_40_H      _PK_H_(0x4F, 0x40)
#define REG_BKF04F_41_L      _PK_L_(0x4F, 0x41)
#define REG_BKF04F_41_H      _PK_H_(0x4F, 0x41)
#define REG_BKF04F_42_L      _PK_L_(0x4F, 0x42)
#define REG_BKF04F_42_H      _PK_H_(0x4F, 0x42)
#define REG_BKF04F_43_L      _PK_L_(0x4F, 0x43)
#define REG_BKF04F_43_H      _PK_H_(0x4F, 0x43)
#define REG_BKF04F_44_L      _PK_L_(0x4F, 0x44)
#define REG_BKF04F_44_H      _PK_H_(0x4F, 0x44)
#define REG_BKF04F_45_L      _PK_L_(0x4F, 0x45)
#define REG_BKF04F_45_H      _PK_H_(0x4F, 0x45)
#define REG_BKF04F_46_L      _PK_L_(0x4F, 0x46)
#define REG_BKF04F_46_H      _PK_H_(0x4F, 0x46)
#define REG_BKF04F_47_L      _PK_L_(0x4F, 0x47)
#define REG_BKF04F_47_H      _PK_H_(0x4F, 0x47)
#define REG_BKF04F_48_L      _PK_L_(0x4F, 0x48)
#define REG_BKF04F_48_H      _PK_H_(0x4F, 0x48)
#define REG_BKF04F_49_L      _PK_L_(0x4F, 0x49)
#define REG_BKF04F_49_H      _PK_H_(0x4F, 0x49)
#define REG_BKF04F_4A_L      _PK_L_(0x4F, 0x4A)
#define REG_BKF04F_4A_H      _PK_H_(0x4F, 0x4A)
#define REG_BKF04F_4B_L      _PK_L_(0x4F, 0x4B)
#define REG_BKF04F_4B_H      _PK_H_(0x4F, 0x4B)
#define REG_BKF04F_4C_L      _PK_L_(0x4F, 0x4C)
#define REG_BKF04F_4C_H      _PK_H_(0x4F, 0x4C)
#define REG_BKF04F_4D_L      _PK_L_(0x4F, 0x4D)
#define REG_BKF04F_4D_H      _PK_H_(0x4F, 0x4D)
#define REG_BKF04F_4E_L      _PK_L_(0x4F, 0x4E)
#define REG_BKF04F_4E_H      _PK_H_(0x4F, 0x4E)
#define REG_BKF04F_4F_L      _PK_L_(0x4F, 0x4F)
#define REG_BKF04F_4F_H      _PK_H_(0x4F, 0x4F)
#define REG_BKF04F_50_L      _PK_L_(0x4F, 0x50)
#define REG_BKF04F_50_H      _PK_H_(0x4F, 0x50)
#define REG_BKF04F_51_L      _PK_L_(0x4F, 0x51)
#define REG_BKF04F_51_H      _PK_H_(0x4F, 0x51)
#define REG_BKF04F_52_L      _PK_L_(0x4F, 0x52)
#define REG_BKF04F_52_H      _PK_H_(0x4F, 0x52)
#define REG_BKF04F_53_L      _PK_L_(0x4F, 0x53)
#define REG_BKF04F_53_H      _PK_H_(0x4F, 0x53)
#define REG_BKF04F_54_L      _PK_L_(0x4F, 0x54)
#define REG_BKF04F_54_H      _PK_H_(0x4F, 0x54)
#define REG_BKF04F_55_L      _PK_L_(0x4F, 0x55)
#define REG_BKF04F_55_H      _PK_H_(0x4F, 0x55)
#define REG_BKF04F_56_L      _PK_L_(0x4F, 0x56)
#define REG_BKF04F_56_H      _PK_H_(0x4F, 0x56)
#define REG_BKF04F_57_L      _PK_L_(0x4F, 0x57)
#define REG_BKF04F_57_H      _PK_H_(0x4F, 0x57)
#define REG_BKF04F_58_L      _PK_L_(0x4F, 0x58)
#define REG_BKF04F_58_H      _PK_H_(0x4F, 0x58)
#define REG_BKF04F_59_L      _PK_L_(0x4F, 0x59)
#define REG_BKF04F_59_H      _PK_H_(0x4F, 0x59)
#define REG_BKF04F_5A_L      _PK_L_(0x4F, 0x5A)
#define REG_BKF04F_5A_H      _PK_H_(0x4F, 0x5A)
#define REG_BKF04F_5B_L      _PK_L_(0x4F, 0x5B)
#define REG_BKF04F_5B_H      _PK_H_(0x4F, 0x5B)
#define REG_BKF04F_5C_L      _PK_L_(0x4F, 0x5C)
#define REG_BKF04F_5C_H      _PK_H_(0x4F, 0x5C)
#define REG_BKF04F_5D_L      _PK_L_(0x4F, 0x5D)
#define REG_BKF04F_5D_H      _PK_H_(0x4F, 0x5D)
#define REG_BKF04F_5E_L      _PK_L_(0x4F, 0x5E)
#define REG_BKF04F_5E_H      _PK_H_(0x4F, 0x5E)
#define REG_BKF04F_5F_L      _PK_L_(0x4F, 0x5F)
#define REG_BKF04F_5F_H      _PK_H_(0x4F, 0x5F)
#define REG_BKF04F_60_L      _PK_L_(0x4F, 0x60)
#define REG_BKF04F_60_H      _PK_H_(0x4F, 0x60)
#define REG_BKF04F_61_L      _PK_L_(0x4F, 0x61)
#define REG_BKF04F_61_H      _PK_H_(0x4F, 0x61)
#define REG_BKF04F_62_L      _PK_L_(0x4F, 0x62)
#define REG_BKF04F_62_H      _PK_H_(0x4F, 0x62)
#define REG_BKF04F_63_L      _PK_L_(0x4F, 0x63)
#define REG_BKF04F_63_H      _PK_H_(0x4F, 0x63)
#define REG_BKF04F_64_L      _PK_L_(0x4F, 0x64)
#define REG_BKF04F_64_H      _PK_H_(0x4F, 0x64)
#define REG_BKF04F_65_L      _PK_L_(0x4F, 0x65)
#define REG_BKF04F_65_H      _PK_H_(0x4F, 0x65)
#define REG_BKF04F_66_L      _PK_L_(0x4F, 0x66)
#define REG_BKF04F_66_H      _PK_H_(0x4F, 0x66)
#define REG_BKF04F_67_L      _PK_L_(0x4F, 0x67)
#define REG_BKF04F_67_H      _PK_H_(0x4F, 0x67)
#define REG_BKF04F_68_L      _PK_L_(0x4F, 0x68)
#define REG_BKF04F_68_H      _PK_H_(0x4F, 0x68)
#define REG_BKF04F_69_L      _PK_L_(0x4F, 0x69)
#define REG_BKF04F_69_H      _PK_H_(0x4F, 0x69)
#define REG_BKF04F_6A_L      _PK_L_(0x4F, 0x6A)
#define REG_BKF04F_6A_H      _PK_H_(0x4F, 0x6A)
#define REG_BKF04F_6B_L      _PK_L_(0x4F, 0x6B)
#define REG_BKF04F_6B_H      _PK_H_(0x4F, 0x6B)
#define REG_BKF04F_6C_L      _PK_L_(0x4F, 0x6C)
#define REG_BKF04F_6C_H      _PK_H_(0x4F, 0x6C)
#define REG_BKF04F_6D_L      _PK_L_(0x4F, 0x6D)
#define REG_BKF04F_6D_H      _PK_H_(0x4F, 0x6D)
#define REG_BKF04F_6E_L      _PK_L_(0x4F, 0x6E)
#define REG_BKF04F_6E_H      _PK_H_(0x4F, 0x6E)
#define REG_BKF04F_6F_L      _PK_L_(0x4F, 0x6F)
#define REG_BKF04F_6F_H      _PK_H_(0x4F, 0x6F)
#define REG_BKF04F_70_L      _PK_L_(0x4F, 0x70)
#define REG_BKF04F_70_H      _PK_H_(0x4F, 0x70)
#define REG_BKF04F_71_L      _PK_L_(0x4F, 0x71)
#define REG_BKF04F_71_H      _PK_H_(0x4F, 0x71)
#define REG_BKF04F_72_L      _PK_L_(0x4F, 0x72)
#define REG_BKF04F_72_H      _PK_H_(0x4F, 0x72)
#define REG_BKF04F_73_L      _PK_L_(0x4F, 0x73)
#define REG_BKF04F_73_H      _PK_H_(0x4F, 0x73)
#define REG_BKF04F_74_L      _PK_L_(0x4F, 0x74)
#define REG_BKF04F_74_H      _PK_H_(0x4F, 0x74)
#define REG_BKF04F_75_L      _PK_L_(0x4F, 0x75)
#define REG_BKF04F_75_H      _PK_H_(0x4F, 0x75)
#define REG_BKF04F_76_L      _PK_L_(0x4F, 0x76)
#define REG_BKF04F_76_H      _PK_H_(0x4F, 0x76)
#define REG_BKF04F_77_L      _PK_L_(0x4F, 0x77)
#define REG_BKF04F_77_H      _PK_H_(0x4F, 0x77)
#define REG_BKF04F_78_L      _PK_L_(0x4F, 0x78)
#define REG_BKF04F_78_H      _PK_H_(0x4F, 0x78)
#define REG_BKF04F_79_L      _PK_L_(0x4F, 0x79)
#define REG_BKF04F_79_H      _PK_H_(0x4F, 0x79)
#define REG_BKF04F_7A_L      _PK_L_(0x4F, 0x7A)
#define REG_BKF04F_7A_H      _PK_H_(0x4F, 0x7A)
#define REG_BKF04F_7B_L      _PK_L_(0x4F, 0x7B)
#define REG_BKF04F_7B_H      _PK_H_(0x4F, 0x7B)
#define REG_BKF04F_7C_L      _PK_L_(0x4F, 0x7C)
#define REG_BKF04F_7C_H      _PK_H_(0x4F, 0x7C)
#define REG_BKF04F_7D_L      _PK_L_(0x4F, 0x7D)
#define REG_BKF04F_7D_H      _PK_H_(0x4F, 0x7D)
#define REG_BKF04F_7E_L      _PK_L_(0x4F, 0x7E)
#define REG_BKF04F_7E_H      _PK_H_(0x4F, 0x7E)
#define REG_BKF04F_7F_L      _PK_L_(0x4F, 0x7F)
#define REG_BKF04F_7F_H      _PK_H_(0x4F, 0x7F)
//----------------------------------------------
#define REG_BKF050_00_L      _PK_L_(0x50, 0x00)
#define REG_BKF050_00_H      _PK_H_(0x50, 0x00)
#define REG_BKF050_01_L      _PK_L_(0x50, 0x01)
#define REG_BKF050_01_H      _PK_H_(0x50, 0x01)
#define REG_BKF050_02_L      _PK_L_(0x50, 0x02)
#define REG_BKF050_02_H      _PK_H_(0x50, 0x02)
#define REG_BKF050_03_L      _PK_L_(0x50, 0x03)
#define REG_BKF050_03_H      _PK_H_(0x50, 0x03)
#define REG_BKF050_04_L      _PK_L_(0x50, 0x04)
#define REG_BKF050_04_H      _PK_H_(0x50, 0x04)
#define REG_BKF050_05_L      _PK_L_(0x50, 0x05)
#define REG_BKF050_05_H      _PK_H_(0x50, 0x05)
#define REG_BKF050_06_L      _PK_L_(0x50, 0x06)
#define REG_BKF050_06_H      _PK_H_(0x50, 0x06)
#define REG_BKF050_07_L      _PK_L_(0x50, 0x07)
#define REG_BKF050_07_H      _PK_H_(0x50, 0x07)
#define REG_BKF050_08_L      _PK_L_(0x50, 0x08)
#define REG_BKF050_08_H      _PK_H_(0x50, 0x08)
#define REG_BKF050_09_L      _PK_L_(0x50, 0x09)
#define REG_BKF050_09_H      _PK_H_(0x50, 0x09)
#define REG_BKF050_0A_L      _PK_L_(0x50, 0x0A)
#define REG_BKF050_0A_H      _PK_H_(0x50, 0x0A)
#define REG_BKF050_0B_L      _PK_L_(0x50, 0x0B)
#define REG_BKF050_0B_H      _PK_H_(0x50, 0x0B)
#define REG_BKF050_0C_L      _PK_L_(0x50, 0x0C)
#define REG_BKF050_0C_H      _PK_H_(0x50, 0x0C)
#define REG_BKF050_0D_L      _PK_L_(0x50, 0x0D)
#define REG_BKF050_0D_H      _PK_H_(0x50, 0x0D)
#define REG_BKF050_0E_L      _PK_L_(0x50, 0x0E)
#define REG_BKF050_0E_H      _PK_H_(0x50, 0x0E)
#define REG_BKF050_0F_L      _PK_L_(0x50, 0x0F)
#define REG_BKF050_0F_H      _PK_H_(0x50, 0x0F)
#define REG_BKF050_10_L      _PK_L_(0x50, 0x10)
#define REG_BKF050_10_H      _PK_H_(0x50, 0x10)
#define REG_BKF050_11_L      _PK_L_(0x50, 0x11)
#define REG_BKF050_11_H      _PK_H_(0x50, 0x11)
#define REG_BKF050_12_L      _PK_L_(0x50, 0x12)
#define REG_BKF050_12_H      _PK_H_(0x50, 0x12)
#define REG_BKF050_13_L      _PK_L_(0x50, 0x13)
#define REG_BKF050_13_H      _PK_H_(0x50, 0x13)
#define REG_BKF050_14_L      _PK_L_(0x50, 0x14)
#define REG_BKF050_14_H      _PK_H_(0x50, 0x14)
#define REG_BKF050_15_L      _PK_L_(0x50, 0x15)
#define REG_BKF050_15_H      _PK_H_(0x50, 0x15)
#define REG_BKF050_16_L      _PK_L_(0x50, 0x16)
#define REG_BKF050_16_H      _PK_H_(0x50, 0x16)
#define REG_BKF050_17_L      _PK_L_(0x50, 0x17)
#define REG_BKF050_17_H      _PK_H_(0x50, 0x17)
#define REG_BKF050_18_L      _PK_L_(0x50, 0x18)
#define REG_BKF050_18_H      _PK_H_(0x50, 0x18)
#define REG_BKF050_19_L      _PK_L_(0x50, 0x19)
#define REG_BKF050_19_H      _PK_H_(0x50, 0x19)
#define REG_BKF050_1A_L      _PK_L_(0x50, 0x1A)
#define REG_BKF050_1A_H      _PK_H_(0x50, 0x1A)
#define REG_BKF050_1B_L      _PK_L_(0x50, 0x1B)
#define REG_BKF050_1B_H      _PK_H_(0x50, 0x1B)
#define REG_BKF050_1C_L      _PK_L_(0x50, 0x1C)
#define REG_BKF050_1C_H      _PK_H_(0x50, 0x1C)
#define REG_BKF050_1D_L      _PK_L_(0x50, 0x1D)
#define REG_BKF050_1D_H      _PK_H_(0x50, 0x1D)
#define REG_BKF050_1E_L      _PK_L_(0x50, 0x1E)
#define REG_BKF050_1E_H      _PK_H_(0x50, 0x1E)
#define REG_BKF050_1F_L      _PK_L_(0x50, 0x1F)
#define REG_BKF050_1F_H      _PK_H_(0x50, 0x1F)
#define REG_BKF050_20_L      _PK_L_(0x50, 0x20)
#define REG_BKF050_20_H      _PK_H_(0x50, 0x20)
#define REG_BKF050_21_L      _PK_L_(0x50, 0x21)
#define REG_BKF050_21_H      _PK_H_(0x50, 0x21)
#define REG_BKF050_22_L      _PK_L_(0x50, 0x22)
#define REG_BKF050_22_H      _PK_H_(0x50, 0x22)
#define REG_BKF050_23_L      _PK_L_(0x50, 0x23)
#define REG_BKF050_23_H      _PK_H_(0x50, 0x23)
#define REG_BKF050_24_L      _PK_L_(0x50, 0x24)
#define REG_BKF050_24_H      _PK_H_(0x50, 0x24)
#define REG_BKF050_25_L      _PK_L_(0x50, 0x25)
#define REG_BKF050_25_H      _PK_H_(0x50, 0x25)
#define REG_BKF050_26_L      _PK_L_(0x50, 0x26)
#define REG_BKF050_26_H      _PK_H_(0x50, 0x26)
#define REG_BKF050_27_L      _PK_L_(0x50, 0x27)
#define REG_BKF050_27_H      _PK_H_(0x50, 0x27)
#define REG_BKF050_28_L      _PK_L_(0x50, 0x28)
#define REG_BKF050_28_H      _PK_H_(0x50, 0x28)
#define REG_BKF050_29_L      _PK_L_(0x50, 0x29)
#define REG_BKF050_29_H      _PK_H_(0x50, 0x29)
#define REG_BKF050_2A_L      _PK_L_(0x50, 0x2A)
#define REG_BKF050_2A_H      _PK_H_(0x50, 0x2A)
#define REG_BKF050_2B_L      _PK_L_(0x50, 0x2B)
#define REG_BKF050_2B_H      _PK_H_(0x50, 0x2B)
#define REG_BKF050_2C_L      _PK_L_(0x50, 0x2C)
#define REG_BKF050_2C_H      _PK_H_(0x50, 0x2C)
#define REG_BKF050_2D_L      _PK_L_(0x50, 0x2D)
#define REG_BKF050_2D_H      _PK_H_(0x50, 0x2D)
#define REG_BKF050_2E_L      _PK_L_(0x50, 0x2E)
#define REG_BKF050_2E_H      _PK_H_(0x50, 0x2E)
#define REG_BKF050_2F_L      _PK_L_(0x50, 0x2F)
#define REG_BKF050_2F_H      _PK_H_(0x50, 0x2F)
#define REG_BKF050_30_L      _PK_L_(0x50, 0x30)
#define REG_BKF050_30_H      _PK_H_(0x50, 0x30)
#define REG_BKF050_31_L      _PK_L_(0x50, 0x31)
#define REG_BKF050_31_H      _PK_H_(0x50, 0x31)
#define REG_BKF050_32_L      _PK_L_(0x50, 0x32)
#define REG_BKF050_32_H      _PK_H_(0x50, 0x32)
#define REG_BKF050_33_L      _PK_L_(0x50, 0x33)
#define REG_BKF050_33_H      _PK_H_(0x50, 0x33)
#define REG_BKF050_34_L      _PK_L_(0x50, 0x34)
#define REG_BKF050_34_H      _PK_H_(0x50, 0x34)
#define REG_BKF050_35_L      _PK_L_(0x50, 0x35)
#define REG_BKF050_35_H      _PK_H_(0x50, 0x35)
#define REG_BKF050_36_L      _PK_L_(0x50, 0x36)
#define REG_BKF050_36_H      _PK_H_(0x50, 0x36)
#define REG_BKF050_37_L      _PK_L_(0x50, 0x37)
#define REG_BKF050_37_H      _PK_H_(0x50, 0x37)
#define REG_BKF050_38_L      _PK_L_(0x50, 0x38)
#define REG_BKF050_38_H      _PK_H_(0x50, 0x38)
#define REG_BKF050_39_L      _PK_L_(0x50, 0x39)
#define REG_BKF050_39_H      _PK_H_(0x50, 0x39)
#define REG_BKF050_3A_L      _PK_L_(0x50, 0x3A)
#define REG_BKF050_3A_H      _PK_H_(0x50, 0x3A)
#define REG_BKF050_3B_L      _PK_L_(0x50, 0x3B)
#define REG_BKF050_3B_H      _PK_H_(0x50, 0x3B)
#define REG_BKF050_3C_L      _PK_L_(0x50, 0x3C)
#define REG_BKF050_3C_H      _PK_H_(0x50, 0x3C)
#define REG_BKF050_3D_L      _PK_L_(0x50, 0x3D)
#define REG_BKF050_3D_H      _PK_H_(0x50, 0x3D)
#define REG_BKF050_3E_L      _PK_L_(0x50, 0x3E)
#define REG_BKF050_3E_H      _PK_H_(0x50, 0x3E)
#define REG_BKF050_3F_L      _PK_L_(0x50, 0x3F)
#define REG_BKF050_3F_H      _PK_H_(0x50, 0x3F)
#define REG_BKF050_40_L      _PK_L_(0x50, 0x40)
#define REG_BKF050_40_H      _PK_H_(0x50, 0x40)
#define REG_BKF050_41_L      _PK_L_(0x50, 0x41)
#define REG_BKF050_41_H      _PK_H_(0x50, 0x41)
#define REG_BKF050_42_L      _PK_L_(0x50, 0x42)
#define REG_BKF050_42_H      _PK_H_(0x50, 0x42)
#define REG_BKF050_43_L      _PK_L_(0x50, 0x43)
#define REG_BKF050_43_H      _PK_H_(0x50, 0x43)
#define REG_BKF050_44_L      _PK_L_(0x50, 0x44)
#define REG_BKF050_44_H      _PK_H_(0x50, 0x44)
#define REG_BKF050_45_L      _PK_L_(0x50, 0x45)
#define REG_BKF050_45_H      _PK_H_(0x50, 0x45)
#define REG_BKF050_46_L      _PK_L_(0x50, 0x46)
#define REG_BKF050_46_H      _PK_H_(0x50, 0x46)
#define REG_BKF050_47_L      _PK_L_(0x50, 0x47)
#define REG_BKF050_47_H      _PK_H_(0x50, 0x47)
#define REG_BKF050_48_L      _PK_L_(0x50, 0x48)
#define REG_BKF050_48_H      _PK_H_(0x50, 0x48)
#define REG_BKF050_49_L      _PK_L_(0x50, 0x49)
#define REG_BKF050_49_H      _PK_H_(0x50, 0x49)
#define REG_BKF050_4A_L      _PK_L_(0x50, 0x4A)
#define REG_BKF050_4A_H      _PK_H_(0x50, 0x4A)
#define REG_BKF050_4B_L      _PK_L_(0x50, 0x4B)
#define REG_BKF050_4B_H      _PK_H_(0x50, 0x4B)
#define REG_BKF050_4C_L      _PK_L_(0x50, 0x4C)
#define REG_BKF050_4C_H      _PK_H_(0x50, 0x4C)
#define REG_BKF050_4D_L      _PK_L_(0x50, 0x4D)
#define REG_BKF050_4D_H      _PK_H_(0x50, 0x4D)
#define REG_BKF050_4E_L      _PK_L_(0x50, 0x4E)
#define REG_BKF050_4E_H      _PK_H_(0x50, 0x4E)
#define REG_BKF050_4F_L      _PK_L_(0x50, 0x4F)
#define REG_BKF050_4F_H      _PK_H_(0x50, 0x4F)
#define REG_BKF050_50_L      _PK_L_(0x50, 0x50)
#define REG_BKF050_50_H      _PK_H_(0x50, 0x50)
#define REG_BKF050_51_L      _PK_L_(0x50, 0x51)
#define REG_BKF050_51_H      _PK_H_(0x50, 0x51)
#define REG_BKF050_52_L      _PK_L_(0x50, 0x52)
#define REG_BKF050_52_H      _PK_H_(0x50, 0x52)
#define REG_BKF050_53_L      _PK_L_(0x50, 0x53)
#define REG_BKF050_53_H      _PK_H_(0x50, 0x53)
#define REG_BKF050_54_L      _PK_L_(0x50, 0x54)
#define REG_BKF050_54_H      _PK_H_(0x50, 0x54)
#define REG_BKF050_55_L      _PK_L_(0x50, 0x55)
#define REG_BKF050_55_H      _PK_H_(0x50, 0x55)
#define REG_BKF050_56_L      _PK_L_(0x50, 0x56)
#define REG_BKF050_56_H      _PK_H_(0x50, 0x56)
#define REG_BKF050_57_L      _PK_L_(0x50, 0x57)
#define REG_BKF050_57_H      _PK_H_(0x50, 0x57)
#define REG_BKF050_58_L      _PK_L_(0x50, 0x58)
#define REG_BKF050_58_H      _PK_H_(0x50, 0x58)
#define REG_BKF050_59_L      _PK_L_(0x50, 0x59)
#define REG_BKF050_59_H      _PK_H_(0x50, 0x59)
#define REG_BKF050_5A_L      _PK_L_(0x50, 0x5A)
#define REG_BKF050_5A_H      _PK_H_(0x50, 0x5A)
#define REG_BKF050_5B_L      _PK_L_(0x50, 0x5B)
#define REG_BKF050_5B_H      _PK_H_(0x50, 0x5B)
#define REG_BKF050_5C_L      _PK_L_(0x50, 0x5C)
#define REG_BKF050_5C_H      _PK_H_(0x50, 0x5C)
#define REG_BKF050_5D_L      _PK_L_(0x50, 0x5D)
#define REG_BKF050_5D_H      _PK_H_(0x50, 0x5D)
#define REG_BKF050_5E_L      _PK_L_(0x50, 0x5E)
#define REG_BKF050_5E_H      _PK_H_(0x50, 0x5E)
#define REG_BKF050_5F_L      _PK_L_(0x50, 0x5F)
#define REG_BKF050_5F_H      _PK_H_(0x50, 0x5F)
#define REG_BKF050_60_L      _PK_L_(0x50, 0x60)
#define REG_BKF050_60_H      _PK_H_(0x50, 0x60)
#define REG_BKF050_61_L      _PK_L_(0x50, 0x61)
#define REG_BKF050_61_H      _PK_H_(0x50, 0x61)
#define REG_BKF050_62_L      _PK_L_(0x50, 0x62)
#define REG_BKF050_62_H      _PK_H_(0x50, 0x62)
#define REG_BKF050_63_L      _PK_L_(0x50, 0x63)
#define REG_BKF050_63_H      _PK_H_(0x50, 0x63)
#define REG_BKF050_64_L      _PK_L_(0x50, 0x64)
#define REG_BKF050_64_H      _PK_H_(0x50, 0x64)
#define REG_BKF050_65_L      _PK_L_(0x50, 0x65)
#define REG_BKF050_65_H      _PK_H_(0x50, 0x65)
#define REG_BKF050_66_L      _PK_L_(0x50, 0x66)
#define REG_BKF050_66_H      _PK_H_(0x50, 0x66)
#define REG_BKF050_67_L      _PK_L_(0x50, 0x67)
#define REG_BKF050_67_H      _PK_H_(0x50, 0x67)
#define REG_BKF050_68_L      _PK_L_(0x50, 0x68)
#define REG_BKF050_68_H      _PK_H_(0x50, 0x68)
#define REG_BKF050_69_L      _PK_L_(0x50, 0x69)
#define REG_BKF050_69_H      _PK_H_(0x50, 0x69)
#define REG_BKF050_6A_L      _PK_L_(0x50, 0x6A)
#define REG_BKF050_6A_H      _PK_H_(0x50, 0x6A)
#define REG_BKF050_6B_L      _PK_L_(0x50, 0x6B)
#define REG_BKF050_6B_H      _PK_H_(0x50, 0x6B)
#define REG_BKF050_6C_L      _PK_L_(0x50, 0x6C)
#define REG_BKF050_6C_H      _PK_H_(0x50, 0x6C)
#define REG_BKF050_6D_L      _PK_L_(0x50, 0x6D)
#define REG_BKF050_6D_H      _PK_H_(0x50, 0x6D)
#define REG_BKF050_6E_L      _PK_L_(0x50, 0x6E)
#define REG_BKF050_6E_H      _PK_H_(0x50, 0x6E)
#define REG_BKF050_6F_L      _PK_L_(0x50, 0x6F)
#define REG_BKF050_6F_H      _PK_H_(0x50, 0x6F)
#define REG_BKF050_70_L      _PK_L_(0x50, 0x70)
#define REG_BKF050_70_H      _PK_H_(0x50, 0x70)
#define REG_BKF050_71_L      _PK_L_(0x50, 0x71)
#define REG_BKF050_71_H      _PK_H_(0x50, 0x71)
#define REG_BKF050_72_L      _PK_L_(0x50, 0x72)
#define REG_BKF050_72_H      _PK_H_(0x50, 0x72)
#define REG_BKF050_73_L      _PK_L_(0x50, 0x73)
#define REG_BKF050_73_H      _PK_H_(0x50, 0x73)
#define REG_BKF050_74_L      _PK_L_(0x50, 0x74)
#define REG_BKF050_74_H      _PK_H_(0x50, 0x74)
#define REG_BKF050_75_L      _PK_L_(0x50, 0x75)
#define REG_BKF050_75_H      _PK_H_(0x50, 0x75)
#define REG_BKF050_76_L      _PK_L_(0x50, 0x76)
#define REG_BKF050_76_H      _PK_H_(0x50, 0x76)
#define REG_BKF050_77_L      _PK_L_(0x50, 0x77)
#define REG_BKF050_77_H      _PK_H_(0x50, 0x77)
#define REG_BKF050_78_L      _PK_L_(0x50, 0x78)
#define REG_BKF050_78_H      _PK_H_(0x50, 0x78)
#define REG_BKF050_79_L      _PK_L_(0x50, 0x79)
#define REG_BKF050_79_H      _PK_H_(0x50, 0x79)
#define REG_BKF050_7A_L      _PK_L_(0x50, 0x7A)
#define REG_BKF050_7A_H      _PK_H_(0x50, 0x7A)
#define REG_BKF050_7B_L      _PK_L_(0x50, 0x7B)
#define REG_BKF050_7B_H      _PK_H_(0x50, 0x7B)
#define REG_BKF050_7C_L      _PK_L_(0x50, 0x7C)
#define REG_BKF050_7C_H      _PK_H_(0x50, 0x7C)
#define REG_BKF050_7D_L      _PK_L_(0x50, 0x7D)
#define REG_BKF050_7D_H      _PK_H_(0x50, 0x7D)
#define REG_BKF050_7E_L      _PK_L_(0x50, 0x7E)
#define REG_BKF050_7E_H      _PK_H_(0x50, 0x7E)
#define REG_BKF050_7F_L      _PK_L_(0x50, 0x7F)
#define REG_BKF050_7F_H      _PK_H_(0x50, 0x7F)
//----------------------------------------------
#define REG_BKF051_00_L      _PK_L_(0x51, 0x00)
#define REG_BKF051_00_H      _PK_H_(0x51, 0x00)
#define REG_BKF051_01_L      _PK_L_(0x51, 0x01)
#define REG_BKF051_01_H      _PK_H_(0x51, 0x01)
#define REG_BKF051_02_L      _PK_L_(0x51, 0x02)
#define REG_BKF051_02_H      _PK_H_(0x51, 0x02)
#define REG_BKF051_03_L      _PK_L_(0x51, 0x03)
#define REG_BKF051_03_H      _PK_H_(0x51, 0x03)
#define REG_BKF051_04_L      _PK_L_(0x51, 0x04)
#define REG_BKF051_04_H      _PK_H_(0x51, 0x04)
#define REG_BKF051_05_L      _PK_L_(0x51, 0x05)
#define REG_BKF051_05_H      _PK_H_(0x51, 0x05)
#define REG_BKF051_06_L      _PK_L_(0x51, 0x06)
#define REG_BKF051_06_H      _PK_H_(0x51, 0x06)
#define REG_BKF051_07_L      _PK_L_(0x51, 0x07)
#define REG_BKF051_07_H      _PK_H_(0x51, 0x07)
#define REG_BKF051_08_L      _PK_L_(0x51, 0x08)
#define REG_BKF051_08_H      _PK_H_(0x51, 0x08)
#define REG_BKF051_09_L      _PK_L_(0x51, 0x09)
#define REG_BKF051_09_H      _PK_H_(0x51, 0x09)
#define REG_BKF051_0A_L      _PK_L_(0x51, 0x0A)
#define REG_BKF051_0A_H      _PK_H_(0x51, 0x0A)
#define REG_BKF051_0B_L      _PK_L_(0x51, 0x0B)
#define REG_BKF051_0B_H      _PK_H_(0x51, 0x0B)
#define REG_BKF051_0C_L      _PK_L_(0x51, 0x0C)
#define REG_BKF051_0C_H      _PK_H_(0x51, 0x0C)
#define REG_BKF051_0D_L      _PK_L_(0x51, 0x0D)
#define REG_BKF051_0D_H      _PK_H_(0x51, 0x0D)
#define REG_BKF051_0E_L      _PK_L_(0x51, 0x0E)
#define REG_BKF051_0E_H      _PK_H_(0x51, 0x0E)
#define REG_BKF051_0F_L      _PK_L_(0x51, 0x0F)
#define REG_BKF051_0F_H      _PK_H_(0x51, 0x0F)
#define REG_BKF051_10_L      _PK_L_(0x51, 0x10)
#define REG_BKF051_10_H      _PK_H_(0x51, 0x10)
#define REG_BKF051_11_L      _PK_L_(0x51, 0x11)
#define REG_BKF051_11_H      _PK_H_(0x51, 0x11)
#define REG_BKF051_12_L      _PK_L_(0x51, 0x12)
#define REG_BKF051_12_H      _PK_H_(0x51, 0x12)
#define REG_BKF051_13_L      _PK_L_(0x51, 0x13)
#define REG_BKF051_13_H      _PK_H_(0x51, 0x13)
#define REG_BKF051_14_L      _PK_L_(0x51, 0x14)
#define REG_BKF051_14_H      _PK_H_(0x51, 0x14)
#define REG_BKF051_15_L      _PK_L_(0x51, 0x15)
#define REG_BKF051_15_H      _PK_H_(0x51, 0x15)
#define REG_BKF051_16_L      _PK_L_(0x51, 0x16)
#define REG_BKF051_16_H      _PK_H_(0x51, 0x16)
#define REG_BKF051_17_L      _PK_L_(0x51, 0x17)
#define REG_BKF051_17_H      _PK_H_(0x51, 0x17)
#define REG_BKF051_18_L      _PK_L_(0x51, 0x18)
#define REG_BKF051_18_H      _PK_H_(0x51, 0x18)
#define REG_BKF051_19_L      _PK_L_(0x51, 0x19)
#define REG_BKF051_19_H      _PK_H_(0x51, 0x19)
#define REG_BKF051_1A_L      _PK_L_(0x51, 0x1A)
#define REG_BKF051_1A_H      _PK_H_(0x51, 0x1A)
#define REG_BKF051_1B_L      _PK_L_(0x51, 0x1B)
#define REG_BKF051_1B_H      _PK_H_(0x51, 0x1B)
#define REG_BKF051_1C_L      _PK_L_(0x51, 0x1C)
#define REG_BKF051_1C_H      _PK_H_(0x51, 0x1C)
#define REG_BKF051_1D_L      _PK_L_(0x51, 0x1D)
#define REG_BKF051_1D_H      _PK_H_(0x51, 0x1D)
#define REG_BKF051_1E_L      _PK_L_(0x51, 0x1E)
#define REG_BKF051_1E_H      _PK_H_(0x51, 0x1E)
#define REG_BKF051_1F_L      _PK_L_(0x51, 0x1F)
#define REG_BKF051_1F_H      _PK_H_(0x51, 0x1F)
#define REG_BKF051_20_L      _PK_L_(0x51, 0x20)
#define REG_BKF051_20_H      _PK_H_(0x51, 0x20)
#define REG_BKF051_21_L      _PK_L_(0x51, 0x21)
#define REG_BKF051_21_H      _PK_H_(0x51, 0x21)
#define REG_BKF051_22_L      _PK_L_(0x51, 0x22)
#define REG_BKF051_22_H      _PK_H_(0x51, 0x22)
#define REG_BKF051_23_L      _PK_L_(0x51, 0x23)
#define REG_BKF051_23_H      _PK_H_(0x51, 0x23)
#define REG_BKF051_24_L      _PK_L_(0x51, 0x24)
#define REG_BKF051_24_H      _PK_H_(0x51, 0x24)
#define REG_BKF051_25_L      _PK_L_(0x51, 0x25)
#define REG_BKF051_25_H      _PK_H_(0x51, 0x25)
#define REG_BKF051_26_L      _PK_L_(0x51, 0x26)
#define REG_BKF051_26_H      _PK_H_(0x51, 0x26)
#define REG_BKF051_27_L      _PK_L_(0x51, 0x27)
#define REG_BKF051_27_H      _PK_H_(0x51, 0x27)
#define REG_BKF051_28_L      _PK_L_(0x51, 0x28)
#define REG_BKF051_28_H      _PK_H_(0x51, 0x28)
#define REG_BKF051_29_L      _PK_L_(0x51, 0x29)
#define REG_BKF051_29_H      _PK_H_(0x51, 0x29)
#define REG_BKF051_2A_L      _PK_L_(0x51, 0x2A)
#define REG_BKF051_2A_H      _PK_H_(0x51, 0x2A)
#define REG_BKF051_2B_L      _PK_L_(0x51, 0x2B)
#define REG_BKF051_2B_H      _PK_H_(0x51, 0x2B)
#define REG_BKF051_2C_L      _PK_L_(0x51, 0x2C)
#define REG_BKF051_2C_H      _PK_H_(0x51, 0x2C)
#define REG_BKF051_2D_L      _PK_L_(0x51, 0x2D)
#define REG_BKF051_2D_H      _PK_H_(0x51, 0x2D)
#define REG_BKF051_2E_L      _PK_L_(0x51, 0x2E)
#define REG_BKF051_2E_H      _PK_H_(0x51, 0x2E)
#define REG_BKF051_2F_L      _PK_L_(0x51, 0x2F)
#define REG_BKF051_2F_H      _PK_H_(0x51, 0x2F)
#define REG_BKF051_30_L      _PK_L_(0x51, 0x30)
#define REG_BKF051_30_H      _PK_H_(0x51, 0x30)
#define REG_BKF051_31_L      _PK_L_(0x51, 0x31)
#define REG_BKF051_31_H      _PK_H_(0x51, 0x31)
#define REG_BKF051_32_L      _PK_L_(0x51, 0x32)
#define REG_BKF051_32_H      _PK_H_(0x51, 0x32)
#define REG_BKF051_33_L      _PK_L_(0x51, 0x33)
#define REG_BKF051_33_H      _PK_H_(0x51, 0x33)
#define REG_BKF051_34_L      _PK_L_(0x51, 0x34)
#define REG_BKF051_34_H      _PK_H_(0x51, 0x34)
#define REG_BKF051_35_L      _PK_L_(0x51, 0x35)
#define REG_BKF051_35_H      _PK_H_(0x51, 0x35)
#define REG_BKF051_36_L      _PK_L_(0x51, 0x36)
#define REG_BKF051_36_H      _PK_H_(0x51, 0x36)
#define REG_BKF051_37_L      _PK_L_(0x51, 0x37)
#define REG_BKF051_37_H      _PK_H_(0x51, 0x37)
#define REG_BKF051_38_L      _PK_L_(0x51, 0x38)
#define REG_BKF051_38_H      _PK_H_(0x51, 0x38)
#define REG_BKF051_39_L      _PK_L_(0x51, 0x39)
#define REG_BKF051_39_H      _PK_H_(0x51, 0x39)
#define REG_BKF051_3A_L      _PK_L_(0x51, 0x3A)
#define REG_BKF051_3A_H      _PK_H_(0x51, 0x3A)
#define REG_BKF051_3B_L      _PK_L_(0x51, 0x3B)
#define REG_BKF051_3B_H      _PK_H_(0x51, 0x3B)
#define REG_BKF051_3C_L      _PK_L_(0x51, 0x3C)
#define REG_BKF051_3C_H      _PK_H_(0x51, 0x3C)
#define REG_BKF051_3D_L      _PK_L_(0x51, 0x3D)
#define REG_BKF051_3D_H      _PK_H_(0x51, 0x3D)
#define REG_BKF051_3E_L      _PK_L_(0x51, 0x3E)
#define REG_BKF051_3E_H      _PK_H_(0x51, 0x3E)
#define REG_BKF051_3F_L      _PK_L_(0x51, 0x3F)
#define REG_BKF051_3F_H      _PK_H_(0x51, 0x3F)
#define REG_BKF051_40_L      _PK_L_(0x51, 0x40)
#define REG_BKF051_40_H      _PK_H_(0x51, 0x40)
#define REG_BKF051_41_L      _PK_L_(0x51, 0x41)
#define REG_BKF051_41_H      _PK_H_(0x51, 0x41)
#define REG_BKF051_42_L      _PK_L_(0x51, 0x42)
#define REG_BKF051_42_H      _PK_H_(0x51, 0x42)
#define REG_BKF051_43_L      _PK_L_(0x51, 0x43)
#define REG_BKF051_43_H      _PK_H_(0x51, 0x43)
#define REG_BKF051_44_L      _PK_L_(0x51, 0x44)
#define REG_BKF051_44_H      _PK_H_(0x51, 0x44)
#define REG_BKF051_45_L      _PK_L_(0x51, 0x45)
#define REG_BKF051_45_H      _PK_H_(0x51, 0x45)
#define REG_BKF051_46_L      _PK_L_(0x51, 0x46)
#define REG_BKF051_46_H      _PK_H_(0x51, 0x46)
#define REG_BKF051_47_L      _PK_L_(0x51, 0x47)
#define REG_BKF051_47_H      _PK_H_(0x51, 0x47)
#define REG_BKF051_48_L      _PK_L_(0x51, 0x48)
#define REG_BKF051_48_H      _PK_H_(0x51, 0x48)
#define REG_BKF051_49_L      _PK_L_(0x51, 0x49)
#define REG_BKF051_49_H      _PK_H_(0x51, 0x49)
#define REG_BKF051_4A_L      _PK_L_(0x51, 0x4A)
#define REG_BKF051_4A_H      _PK_H_(0x51, 0x4A)
#define REG_BKF051_4B_L      _PK_L_(0x51, 0x4B)
#define REG_BKF051_4B_H      _PK_H_(0x51, 0x4B)
#define REG_BKF051_4C_L      _PK_L_(0x51, 0x4C)
#define REG_BKF051_4C_H      _PK_H_(0x51, 0x4C)
#define REG_BKF051_4D_L      _PK_L_(0x51, 0x4D)
#define REG_BKF051_4D_H      _PK_H_(0x51, 0x4D)
#define REG_BKF051_4E_L      _PK_L_(0x51, 0x4E)
#define REG_BKF051_4E_H      _PK_H_(0x51, 0x4E)
#define REG_BKF051_4F_L      _PK_L_(0x51, 0x4F)
#define REG_BKF051_4F_H      _PK_H_(0x51, 0x4F)
#define REG_BKF051_50_L      _PK_L_(0x51, 0x50)
#define REG_BKF051_50_H      _PK_H_(0x51, 0x50)
#define REG_BKF051_51_L      _PK_L_(0x51, 0x51)
#define REG_BKF051_51_H      _PK_H_(0x51, 0x51)
#define REG_BKF051_52_L      _PK_L_(0x51, 0x52)
#define REG_BKF051_52_H      _PK_H_(0x51, 0x52)
#define REG_BKF051_53_L      _PK_L_(0x51, 0x53)
#define REG_BKF051_53_H      _PK_H_(0x51, 0x53)
#define REG_BKF051_54_L      _PK_L_(0x51, 0x54)
#define REG_BKF051_54_H      _PK_H_(0x51, 0x54)
#define REG_BKF051_55_L      _PK_L_(0x51, 0x55)
#define REG_BKF051_55_H      _PK_H_(0x51, 0x55)
#define REG_BKF051_56_L      _PK_L_(0x51, 0x56)
#define REG_BKF051_56_H      _PK_H_(0x51, 0x56)
#define REG_BKF051_57_L      _PK_L_(0x51, 0x57)
#define REG_BKF051_57_H      _PK_H_(0x51, 0x57)
#define REG_BKF051_58_L      _PK_L_(0x51, 0x58)
#define REG_BKF051_58_H      _PK_H_(0x51, 0x58)
#define REG_BKF051_59_L      _PK_L_(0x51, 0x59)
#define REG_BKF051_59_H      _PK_H_(0x51, 0x59)
#define REG_BKF051_5A_L      _PK_L_(0x51, 0x5A)
#define REG_BKF051_5A_H      _PK_H_(0x51, 0x5A)
#define REG_BKF051_5B_L      _PK_L_(0x51, 0x5B)
#define REG_BKF051_5B_H      _PK_H_(0x51, 0x5B)
#define REG_BKF051_5C_L      _PK_L_(0x51, 0x5C)
#define REG_BKF051_5C_H      _PK_H_(0x51, 0x5C)
#define REG_BKF051_5D_L      _PK_L_(0x51, 0x5D)
#define REG_BKF051_5D_H      _PK_H_(0x51, 0x5D)
#define REG_BKF051_5E_L      _PK_L_(0x51, 0x5E)
#define REG_BKF051_5E_H      _PK_H_(0x51, 0x5E)
#define REG_BKF051_5F_L      _PK_L_(0x51, 0x5F)
#define REG_BKF051_5F_H      _PK_H_(0x51, 0x5F)
#define REG_BKF051_60_L      _PK_L_(0x51, 0x60)
#define REG_BKF051_60_H      _PK_H_(0x51, 0x60)
#define REG_BKF051_61_L      _PK_L_(0x51, 0x61)
#define REG_BKF051_61_H      _PK_H_(0x51, 0x61)
#define REG_BKF051_62_L      _PK_L_(0x51, 0x62)
#define REG_BKF051_62_H      _PK_H_(0x51, 0x62)
#define REG_BKF051_63_L      _PK_L_(0x51, 0x63)
#define REG_BKF051_63_H      _PK_H_(0x51, 0x63)
#define REG_BKF051_64_L      _PK_L_(0x51, 0x64)
#define REG_BKF051_64_H      _PK_H_(0x51, 0x64)
#define REG_BKF051_65_L      _PK_L_(0x51, 0x65)
#define REG_BKF051_65_H      _PK_H_(0x51, 0x65)
#define REG_BKF051_66_L      _PK_L_(0x51, 0x66)
#define REG_BKF051_66_H      _PK_H_(0x51, 0x66)
#define REG_BKF051_67_L      _PK_L_(0x51, 0x67)
#define REG_BKF051_67_H      _PK_H_(0x51, 0x67)
#define REG_BKF051_68_L      _PK_L_(0x51, 0x68)
#define REG_BKF051_68_H      _PK_H_(0x51, 0x68)
#define REG_BKF051_69_L      _PK_L_(0x51, 0x69)
#define REG_BKF051_69_H      _PK_H_(0x51, 0x69)
#define REG_BKF051_6A_L      _PK_L_(0x51, 0x6A)
#define REG_BKF051_6A_H      _PK_H_(0x51, 0x6A)
#define REG_BKF051_6B_L      _PK_L_(0x51, 0x6B)
#define REG_BKF051_6B_H      _PK_H_(0x51, 0x6B)
#define REG_BKF051_6C_L      _PK_L_(0x51, 0x6C)
#define REG_BKF051_6C_H      _PK_H_(0x51, 0x6C)
#define REG_BKF051_6D_L      _PK_L_(0x51, 0x6D)
#define REG_BKF051_6D_H      _PK_H_(0x51, 0x6D)
#define REG_BKF051_6E_L      _PK_L_(0x51, 0x6E)
#define REG_BKF051_6E_H      _PK_H_(0x51, 0x6E)
#define REG_BKF051_6F_L      _PK_L_(0x51, 0x6F)
#define REG_BKF051_6F_H      _PK_H_(0x51, 0x6F)
#define REG_BKF051_70_L      _PK_L_(0x51, 0x70)
#define REG_BKF051_70_H      _PK_H_(0x51, 0x70)
#define REG_BKF051_71_L      _PK_L_(0x51, 0x71)
#define REG_BKF051_71_H      _PK_H_(0x51, 0x71)
#define REG_BKF051_72_L      _PK_L_(0x51, 0x72)
#define REG_BKF051_72_H      _PK_H_(0x51, 0x72)
#define REG_BKF051_73_L      _PK_L_(0x51, 0x73)
#define REG_BKF051_73_H      _PK_H_(0x51, 0x73)
#define REG_BKF051_74_L      _PK_L_(0x51, 0x74)
#define REG_BKF051_74_H      _PK_H_(0x51, 0x74)
#define REG_BKF051_75_L      _PK_L_(0x51, 0x75)
#define REG_BKF051_75_H      _PK_H_(0x51, 0x75)
#define REG_BKF051_76_L      _PK_L_(0x51, 0x76)
#define REG_BKF051_76_H      _PK_H_(0x51, 0x76)
#define REG_BKF051_77_L      _PK_L_(0x51, 0x77)
#define REG_BKF051_77_H      _PK_H_(0x51, 0x77)
#define REG_BKF051_78_L      _PK_L_(0x51, 0x78)
#define REG_BKF051_78_H      _PK_H_(0x51, 0x78)
#define REG_BKF051_79_L      _PK_L_(0x51, 0x79)
#define REG_BKF051_79_H      _PK_H_(0x51, 0x79)
#define REG_BKF051_7A_L      _PK_L_(0x51, 0x7A)
#define REG_BKF051_7A_H      _PK_H_(0x51, 0x7A)
#define REG_BKF051_7B_L      _PK_L_(0x51, 0x7B)
#define REG_BKF051_7B_H      _PK_H_(0x51, 0x7B)
#define REG_BKF051_7C_L      _PK_L_(0x51, 0x7C)
#define REG_BKF051_7C_H      _PK_H_(0x51, 0x7C)
#define REG_BKF051_7D_L      _PK_L_(0x51, 0x7D)
#define REG_BKF051_7D_H      _PK_H_(0x51, 0x7D)
#define REG_BKF051_7E_L      _PK_L_(0x51, 0x7E)
#define REG_BKF051_7E_H      _PK_H_(0x51, 0x7E)
#define REG_BKF051_7F_L      _PK_L_(0x51, 0x7F)
#define REG_BKF051_7F_H      _PK_H_(0x51, 0x7F)
//----------------------------------------------
#define REG_BKF052_00_L      _PK_L_(0x52, 0x00)
#define REG_BKF052_00_H      _PK_H_(0x52, 0x00)
#define REG_BKF052_01_L      _PK_L_(0x52, 0x01)
#define REG_BKF052_01_H      _PK_H_(0x52, 0x01)
#define REG_BKF052_02_L      _PK_L_(0x52, 0x02)
#define REG_BKF052_02_H      _PK_H_(0x52, 0x02)
#define REG_BKF052_03_L      _PK_L_(0x52, 0x03)
#define REG_BKF052_03_H      _PK_H_(0x52, 0x03)
#define REG_BKF052_04_L      _PK_L_(0x52, 0x04)
#define REG_BKF052_04_H      _PK_H_(0x52, 0x04)
#define REG_BKF052_05_L      _PK_L_(0x52, 0x05)
#define REG_BKF052_05_H      _PK_H_(0x52, 0x05)
#define REG_BKF052_06_L      _PK_L_(0x52, 0x06)
#define REG_BKF052_06_H      _PK_H_(0x52, 0x06)
#define REG_BKF052_07_L      _PK_L_(0x52, 0x07)
#define REG_BKF052_07_H      _PK_H_(0x52, 0x07)
#define REG_BKF052_08_L      _PK_L_(0x52, 0x08)
#define REG_BKF052_08_H      _PK_H_(0x52, 0x08)
#define REG_BKF052_09_L      _PK_L_(0x52, 0x09)
#define REG_BKF052_09_H      _PK_H_(0x52, 0x09)
#define REG_BKF052_0A_L      _PK_L_(0x52, 0x0A)
#define REG_BKF052_0A_H      _PK_H_(0x52, 0x0A)
#define REG_BKF052_0B_L      _PK_L_(0x52, 0x0B)
#define REG_BKF052_0B_H      _PK_H_(0x52, 0x0B)
#define REG_BKF052_0C_L      _PK_L_(0x52, 0x0C)
#define REG_BKF052_0C_H      _PK_H_(0x52, 0x0C)
#define REG_BKF052_0D_L      _PK_L_(0x52, 0x0D)
#define REG_BKF052_0D_H      _PK_H_(0x52, 0x0D)
#define REG_BKF052_0E_L      _PK_L_(0x52, 0x0E)
#define REG_BKF052_0E_H      _PK_H_(0x52, 0x0E)
#define REG_BKF052_0F_L      _PK_L_(0x52, 0x0F)
#define REG_BKF052_0F_H      _PK_H_(0x52, 0x0F)
#define REG_BKF052_10_L      _PK_L_(0x52, 0x10)
#define REG_BKF052_10_H      _PK_H_(0x52, 0x10)
#define REG_BKF052_11_L      _PK_L_(0x52, 0x11)
#define REG_BKF052_11_H      _PK_H_(0x52, 0x11)
#define REG_BKF052_12_L      _PK_L_(0x52, 0x12)
#define REG_BKF052_12_H      _PK_H_(0x52, 0x12)
#define REG_BKF052_13_L      _PK_L_(0x52, 0x13)
#define REG_BKF052_13_H      _PK_H_(0x52, 0x13)
#define REG_BKF052_14_L      _PK_L_(0x52, 0x14)
#define REG_BKF052_14_H      _PK_H_(0x52, 0x14)
#define REG_BKF052_15_L      _PK_L_(0x52, 0x15)
#define REG_BKF052_15_H      _PK_H_(0x52, 0x15)
#define REG_BKF052_16_L      _PK_L_(0x52, 0x16)
#define REG_BKF052_16_H      _PK_H_(0x52, 0x16)
#define REG_BKF052_17_L      _PK_L_(0x52, 0x17)
#define REG_BKF052_17_H      _PK_H_(0x52, 0x17)
#define REG_BKF052_18_L      _PK_L_(0x52, 0x18)
#define REG_BKF052_18_H      _PK_H_(0x52, 0x18)
#define REG_BKF052_19_L      _PK_L_(0x52, 0x19)
#define REG_BKF052_19_H      _PK_H_(0x52, 0x19)
#define REG_BKF052_1A_L      _PK_L_(0x52, 0x1A)
#define REG_BKF052_1A_H      _PK_H_(0x52, 0x1A)
#define REG_BKF052_1B_L      _PK_L_(0x52, 0x1B)
#define REG_BKF052_1B_H      _PK_H_(0x52, 0x1B)
#define REG_BKF052_1C_L      _PK_L_(0x52, 0x1C)
#define REG_BKF052_1C_H      _PK_H_(0x52, 0x1C)
#define REG_BKF052_1D_L      _PK_L_(0x52, 0x1D)
#define REG_BKF052_1D_H      _PK_H_(0x52, 0x1D)
#define REG_BKF052_1E_L      _PK_L_(0x52, 0x1E)
#define REG_BKF052_1E_H      _PK_H_(0x52, 0x1E)
#define REG_BKF052_1F_L      _PK_L_(0x52, 0x1F)
#define REG_BKF052_1F_H      _PK_H_(0x52, 0x1F)
#define REG_BKF052_20_L      _PK_L_(0x52, 0x20)
#define REG_BKF052_20_H      _PK_H_(0x52, 0x20)
#define REG_BKF052_21_L      _PK_L_(0x52, 0x21)
#define REG_BKF052_21_H      _PK_H_(0x52, 0x21)
#define REG_BKF052_22_L      _PK_L_(0x52, 0x22)
#define REG_BKF052_22_H      _PK_H_(0x52, 0x22)
#define REG_BKF052_23_L      _PK_L_(0x52, 0x23)
#define REG_BKF052_23_H      _PK_H_(0x52, 0x23)
#define REG_BKF052_24_L      _PK_L_(0x52, 0x24)
#define REG_BKF052_24_H      _PK_H_(0x52, 0x24)
#define REG_BKF052_25_L      _PK_L_(0x52, 0x25)
#define REG_BKF052_25_H      _PK_H_(0x52, 0x25)
#define REG_BKF052_26_L      _PK_L_(0x52, 0x26)
#define REG_BKF052_26_H      _PK_H_(0x52, 0x26)
#define REG_BKF052_27_L      _PK_L_(0x52, 0x27)
#define REG_BKF052_27_H      _PK_H_(0x52, 0x27)
#define REG_BKF052_28_L      _PK_L_(0x52, 0x28)
#define REG_BKF052_28_H      _PK_H_(0x52, 0x28)
#define REG_BKF052_29_L      _PK_L_(0x52, 0x29)
#define REG_BKF052_29_H      _PK_H_(0x52, 0x29)
#define REG_BKF052_2A_L      _PK_L_(0x52, 0x2A)
#define REG_BKF052_2A_H      _PK_H_(0x52, 0x2A)
#define REG_BKF052_2B_L      _PK_L_(0x52, 0x2B)
#define REG_BKF052_2B_H      _PK_H_(0x52, 0x2B)
#define REG_BKF052_2C_L      _PK_L_(0x52, 0x2C)
#define REG_BKF052_2C_H      _PK_H_(0x52, 0x2C)
#define REG_BKF052_2D_L      _PK_L_(0x52, 0x2D)
#define REG_BKF052_2D_H      _PK_H_(0x52, 0x2D)
#define REG_BKF052_2E_L      _PK_L_(0x52, 0x2E)
#define REG_BKF052_2E_H      _PK_H_(0x52, 0x2E)
#define REG_BKF052_2F_L      _PK_L_(0x52, 0x2F)
#define REG_BKF052_2F_H      _PK_H_(0x52, 0x2F)
#define REG_BKF052_30_L      _PK_L_(0x52, 0x30)
#define REG_BKF052_30_H      _PK_H_(0x52, 0x30)
#define REG_BKF052_31_L      _PK_L_(0x52, 0x31)
#define REG_BKF052_31_H      _PK_H_(0x52, 0x31)
#define REG_BKF052_32_L      _PK_L_(0x52, 0x32)
#define REG_BKF052_32_H      _PK_H_(0x52, 0x32)
#define REG_BKF052_33_L      _PK_L_(0x52, 0x33)
#define REG_BKF052_33_H      _PK_H_(0x52, 0x33)
#define REG_BKF052_34_L      _PK_L_(0x52, 0x34)
#define REG_BKF052_34_H      _PK_H_(0x52, 0x34)
#define REG_BKF052_35_L      _PK_L_(0x52, 0x35)
#define REG_BKF052_35_H      _PK_H_(0x52, 0x35)
#define REG_BKF052_36_L      _PK_L_(0x52, 0x36)
#define REG_BKF052_36_H      _PK_H_(0x52, 0x36)
#define REG_BKF052_37_L      _PK_L_(0x52, 0x37)
#define REG_BKF052_37_H      _PK_H_(0x52, 0x37)
#define REG_BKF052_38_L      _PK_L_(0x52, 0x38)
#define REG_BKF052_38_H      _PK_H_(0x52, 0x38)
#define REG_BKF052_39_L      _PK_L_(0x52, 0x39)
#define REG_BKF052_39_H      _PK_H_(0x52, 0x39)
#define REG_BKF052_3A_L      _PK_L_(0x52, 0x3A)
#define REG_BKF052_3A_H      _PK_H_(0x52, 0x3A)
#define REG_BKF052_3B_L      _PK_L_(0x52, 0x3B)
#define REG_BKF052_3B_H      _PK_H_(0x52, 0x3B)
#define REG_BKF052_3C_L      _PK_L_(0x52, 0x3C)
#define REG_BKF052_3C_H      _PK_H_(0x52, 0x3C)
#define REG_BKF052_3D_L      _PK_L_(0x52, 0x3D)
#define REG_BKF052_3D_H      _PK_H_(0x52, 0x3D)
#define REG_BKF052_3E_L      _PK_L_(0x52, 0x3E)
#define REG_BKF052_3E_H      _PK_H_(0x52, 0x3E)
#define REG_BKF052_3F_L      _PK_L_(0x52, 0x3F)
#define REG_BKF052_3F_H      _PK_H_(0x52, 0x3F)
#define REG_BKF052_40_L      _PK_L_(0x52, 0x40)
#define REG_BKF052_40_H      _PK_H_(0x52, 0x40)
#define REG_BKF052_41_L      _PK_L_(0x52, 0x41)
#define REG_BKF052_41_H      _PK_H_(0x52, 0x41)
#define REG_BKF052_42_L      _PK_L_(0x52, 0x42)
#define REG_BKF052_42_H      _PK_H_(0x52, 0x42)
#define REG_BKF052_43_L      _PK_L_(0x52, 0x43)
#define REG_BKF052_43_H      _PK_H_(0x52, 0x43)
#define REG_BKF052_44_L      _PK_L_(0x52, 0x44)
#define REG_BKF052_44_H      _PK_H_(0x52, 0x44)
#define REG_BKF052_45_L      _PK_L_(0x52, 0x45)
#define REG_BKF052_45_H      _PK_H_(0x52, 0x45)
#define REG_BKF052_46_L      _PK_L_(0x52, 0x46)
#define REG_BKF052_46_H      _PK_H_(0x52, 0x46)
#define REG_BKF052_47_L      _PK_L_(0x52, 0x47)
#define REG_BKF052_47_H      _PK_H_(0x52, 0x47)
#define REG_BKF052_48_L      _PK_L_(0x52, 0x48)
#define REG_BKF052_48_H      _PK_H_(0x52, 0x48)
#define REG_BKF052_49_L      _PK_L_(0x52, 0x49)
#define REG_BKF052_49_H      _PK_H_(0x52, 0x49)
#define REG_BKF052_4A_L      _PK_L_(0x52, 0x4A)
#define REG_BKF052_4A_H      _PK_H_(0x52, 0x4A)
#define REG_BKF052_4B_L      _PK_L_(0x52, 0x4B)
#define REG_BKF052_4B_H      _PK_H_(0x52, 0x4B)
#define REG_BKF052_4C_L      _PK_L_(0x52, 0x4C)
#define REG_BKF052_4C_H      _PK_H_(0x52, 0x4C)
#define REG_BKF052_4D_L      _PK_L_(0x52, 0x4D)
#define REG_BKF052_4D_H      _PK_H_(0x52, 0x4D)
#define REG_BKF052_4E_L      _PK_L_(0x52, 0x4E)
#define REG_BKF052_4E_H      _PK_H_(0x52, 0x4E)
#define REG_BKF052_4F_L      _PK_L_(0x52, 0x4F)
#define REG_BKF052_4F_H      _PK_H_(0x52, 0x4F)
#define REG_BKF052_50_L      _PK_L_(0x52, 0x50)
#define REG_BKF052_50_H      _PK_H_(0x52, 0x50)
#define REG_BKF052_51_L      _PK_L_(0x52, 0x51)
#define REG_BKF052_51_H      _PK_H_(0x52, 0x51)
#define REG_BKF052_52_L      _PK_L_(0x52, 0x52)
#define REG_BKF052_52_H      _PK_H_(0x52, 0x52)
#define REG_BKF052_53_L      _PK_L_(0x52, 0x53)
#define REG_BKF052_53_H      _PK_H_(0x52, 0x53)
#define REG_BKF052_54_L      _PK_L_(0x52, 0x54)
#define REG_BKF052_54_H      _PK_H_(0x52, 0x54)
#define REG_BKF052_55_L      _PK_L_(0x52, 0x55)
#define REG_BKF052_55_H      _PK_H_(0x52, 0x55)
#define REG_BKF052_56_L      _PK_L_(0x52, 0x56)
#define REG_BKF052_56_H      _PK_H_(0x52, 0x56)
#define REG_BKF052_57_L      _PK_L_(0x52, 0x57)
#define REG_BKF052_57_H      _PK_H_(0x52, 0x57)
#define REG_BKF052_58_L      _PK_L_(0x52, 0x58)
#define REG_BKF052_58_H      _PK_H_(0x52, 0x58)
#define REG_BKF052_59_L      _PK_L_(0x52, 0x59)
#define REG_BKF052_59_H      _PK_H_(0x52, 0x59)
#define REG_BKF052_5A_L      _PK_L_(0x52, 0x5A)
#define REG_BKF052_5A_H      _PK_H_(0x52, 0x5A)
#define REG_BKF052_5B_L      _PK_L_(0x52, 0x5B)
#define REG_BKF052_5B_H      _PK_H_(0x52, 0x5B)
#define REG_BKF052_5C_L      _PK_L_(0x52, 0x5C)
#define REG_BKF052_5C_H      _PK_H_(0x52, 0x5C)
#define REG_BKF052_5D_L      _PK_L_(0x52, 0x5D)
#define REG_BKF052_5D_H      _PK_H_(0x52, 0x5D)
#define REG_BKF052_5E_L      _PK_L_(0x52, 0x5E)
#define REG_BKF052_5E_H      _PK_H_(0x52, 0x5E)
#define REG_BKF052_5F_L      _PK_L_(0x52, 0x5F)
#define REG_BKF052_5F_H      _PK_H_(0x52, 0x5F)
#define REG_BKF052_60_L      _PK_L_(0x52, 0x60)
#define REG_BKF052_60_H      _PK_H_(0x52, 0x60)
#define REG_BKF052_61_L      _PK_L_(0x52, 0x61)
#define REG_BKF052_61_H      _PK_H_(0x52, 0x61)
#define REG_BKF052_62_L      _PK_L_(0x52, 0x62)
#define REG_BKF052_62_H      _PK_H_(0x52, 0x62)
#define REG_BKF052_63_L      _PK_L_(0x52, 0x63)
#define REG_BKF052_63_H      _PK_H_(0x52, 0x63)
#define REG_BKF052_64_L      _PK_L_(0x52, 0x64)
#define REG_BKF052_64_H      _PK_H_(0x52, 0x64)
#define REG_BKF052_65_L      _PK_L_(0x52, 0x65)
#define REG_BKF052_65_H      _PK_H_(0x52, 0x65)
#define REG_BKF052_66_L      _PK_L_(0x52, 0x66)
#define REG_BKF052_66_H      _PK_H_(0x52, 0x66)
#define REG_BKF052_67_L      _PK_L_(0x52, 0x67)
#define REG_BKF052_67_H      _PK_H_(0x52, 0x67)
#define REG_BKF052_68_L      _PK_L_(0x52, 0x68)
#define REG_BKF052_68_H      _PK_H_(0x52, 0x68)
#define REG_BKF052_69_L      _PK_L_(0x52, 0x69)
#define REG_BKF052_69_H      _PK_H_(0x52, 0x69)
#define REG_BKF052_6A_L      _PK_L_(0x52, 0x6A)
#define REG_BKF052_6A_H      _PK_H_(0x52, 0x6A)
#define REG_BKF052_6B_L      _PK_L_(0x52, 0x6B)
#define REG_BKF052_6B_H      _PK_H_(0x52, 0x6B)
#define REG_BKF052_6C_L      _PK_L_(0x52, 0x6C)
#define REG_BKF052_6C_H      _PK_H_(0x52, 0x6C)
#define REG_BKF052_6D_L      _PK_L_(0x52, 0x6D)
#define REG_BKF052_6D_H      _PK_H_(0x52, 0x6D)
#define REG_BKF052_6E_L      _PK_L_(0x52, 0x6E)
#define REG_BKF052_6E_H      _PK_H_(0x52, 0x6E)
#define REG_BKF052_6F_L      _PK_L_(0x52, 0x6F)
#define REG_BKF052_6F_H      _PK_H_(0x52, 0x6F)
#define REG_BKF052_70_L      _PK_L_(0x52, 0x70)
#define REG_BKF052_70_H      _PK_H_(0x52, 0x70)
#define REG_BKF052_71_L      _PK_L_(0x52, 0x71)
#define REG_BKF052_71_H      _PK_H_(0x52, 0x71)
#define REG_BKF052_72_L      _PK_L_(0x52, 0x72)
#define REG_BKF052_72_H      _PK_H_(0x52, 0x72)
#define REG_BKF052_73_L      _PK_L_(0x52, 0x73)
#define REG_BKF052_73_H      _PK_H_(0x52, 0x73)
#define REG_BKF052_74_L      _PK_L_(0x52, 0x74)
#define REG_BKF052_74_H      _PK_H_(0x52, 0x74)
#define REG_BKF052_75_L      _PK_L_(0x52, 0x75)
#define REG_BKF052_75_H      _PK_H_(0x52, 0x75)
#define REG_BKF052_76_L      _PK_L_(0x52, 0x76)
#define REG_BKF052_76_H      _PK_H_(0x52, 0x76)
#define REG_BKF052_77_L      _PK_L_(0x52, 0x77)
#define REG_BKF052_77_H      _PK_H_(0x52, 0x77)
#define REG_BKF052_78_L      _PK_L_(0x52, 0x78)
#define REG_BKF052_78_H      _PK_H_(0x52, 0x78)
#define REG_BKF052_79_L      _PK_L_(0x52, 0x79)
#define REG_BKF052_79_H      _PK_H_(0x52, 0x79)
#define REG_BKF052_7A_L      _PK_L_(0x52, 0x7A)
#define REG_BKF052_7A_H      _PK_H_(0x52, 0x7A)
#define REG_BKF052_7B_L      _PK_L_(0x52, 0x7B)
#define REG_BKF052_7B_H      _PK_H_(0x52, 0x7B)
#define REG_BKF052_7C_L      _PK_L_(0x52, 0x7C)
#define REG_BKF052_7C_H      _PK_H_(0x52, 0x7C)
#define REG_BKF052_7D_L      _PK_L_(0x52, 0x7D)
#define REG_BKF052_7D_H      _PK_H_(0x52, 0x7D)
#define REG_BKF052_7E_L      _PK_L_(0x52, 0x7E)
#define REG_BKF052_7E_H      _PK_H_(0x52, 0x7E)
#define REG_BKF052_7F_L      _PK_L_(0x52, 0x7F)
#define REG_BKF052_7F_H      _PK_H_(0x52, 0x7F)
//----------------------------------------------
#define REG_BKF053_00_L      _PK_L_(0x53, 0x00)
#define REG_BKF053_00_H      _PK_H_(0x53, 0x00)
#define REG_BKF053_01_L      _PK_L_(0x53, 0x01)
#define REG_BKF053_01_H      _PK_H_(0x53, 0x01)
#define REG_BKF053_02_L      _PK_L_(0x53, 0x02)
#define REG_BKF053_02_H      _PK_H_(0x53, 0x02)
#define REG_BKF053_03_L      _PK_L_(0x53, 0x03)
#define REG_BKF053_03_H      _PK_H_(0x53, 0x03)
#define REG_BKF053_04_L      _PK_L_(0x53, 0x04)
#define REG_BKF053_04_H      _PK_H_(0x53, 0x04)
#define REG_BKF053_05_L      _PK_L_(0x53, 0x05)
#define REG_BKF053_05_H      _PK_H_(0x53, 0x05)
#define REG_BKF053_06_L      _PK_L_(0x53, 0x06)
#define REG_BKF053_06_H      _PK_H_(0x53, 0x06)
#define REG_BKF053_07_L      _PK_L_(0x53, 0x07)
#define REG_BKF053_07_H      _PK_H_(0x53, 0x07)
#define REG_BKF053_08_L      _PK_L_(0x53, 0x08)
#define REG_BKF053_08_H      _PK_H_(0x53, 0x08)
#define REG_BKF053_09_L      _PK_L_(0x53, 0x09)
#define REG_BKF053_09_H      _PK_H_(0x53, 0x09)
#define REG_BKF053_0A_L      _PK_L_(0x53, 0x0A)
#define REG_BKF053_0A_H      _PK_H_(0x53, 0x0A)
#define REG_BKF053_0B_L      _PK_L_(0x53, 0x0B)
#define REG_BKF053_0B_H      _PK_H_(0x53, 0x0B)
#define REG_BKF053_0C_L      _PK_L_(0x53, 0x0C)
#define REG_BKF053_0C_H      _PK_H_(0x53, 0x0C)
#define REG_BKF053_0D_L      _PK_L_(0x53, 0x0D)
#define REG_BKF053_0D_H      _PK_H_(0x53, 0x0D)
#define REG_BKF053_0E_L      _PK_L_(0x53, 0x0E)
#define REG_BKF053_0E_H      _PK_H_(0x53, 0x0E)
#define REG_BKF053_0F_L      _PK_L_(0x53, 0x0F)
#define REG_BKF053_0F_H      _PK_H_(0x53, 0x0F)
#define REG_BKF053_10_L      _PK_L_(0x53, 0x10)
#define REG_BKF053_10_H      _PK_H_(0x53, 0x10)
#define REG_BKF053_11_L      _PK_L_(0x53, 0x11)
#define REG_BKF053_11_H      _PK_H_(0x53, 0x11)
#define REG_BKF053_12_L      _PK_L_(0x53, 0x12)
#define REG_BKF053_12_H      _PK_H_(0x53, 0x12)
#define REG_BKF053_13_L      _PK_L_(0x53, 0x13)
#define REG_BKF053_13_H      _PK_H_(0x53, 0x13)
#define REG_BKF053_14_L      _PK_L_(0x53, 0x14)
#define REG_BKF053_14_H      _PK_H_(0x53, 0x14)
#define REG_BKF053_15_L      _PK_L_(0x53, 0x15)
#define REG_BKF053_15_H      _PK_H_(0x53, 0x15)
#define REG_BKF053_16_L      _PK_L_(0x53, 0x16)
#define REG_BKF053_16_H      _PK_H_(0x53, 0x16)
#define REG_BKF053_17_L      _PK_L_(0x53, 0x17)
#define REG_BKF053_17_H      _PK_H_(0x53, 0x17)
#define REG_BKF053_18_L      _PK_L_(0x53, 0x18)
#define REG_BKF053_18_H      _PK_H_(0x53, 0x18)
#define REG_BKF053_19_L      _PK_L_(0x53, 0x19)
#define REG_BKF053_19_H      _PK_H_(0x53, 0x19)
#define REG_BKF053_1A_L      _PK_L_(0x53, 0x1A)
#define REG_BKF053_1A_H      _PK_H_(0x53, 0x1A)
#define REG_BKF053_1B_L      _PK_L_(0x53, 0x1B)
#define REG_BKF053_1B_H      _PK_H_(0x53, 0x1B)
#define REG_BKF053_1C_L      _PK_L_(0x53, 0x1C)
#define REG_BKF053_1C_H      _PK_H_(0x53, 0x1C)
#define REG_BKF053_1D_L      _PK_L_(0x53, 0x1D)
#define REG_BKF053_1D_H      _PK_H_(0x53, 0x1D)
#define REG_BKF053_1E_L      _PK_L_(0x53, 0x1E)
#define REG_BKF053_1E_H      _PK_H_(0x53, 0x1E)
#define REG_BKF053_1F_L      _PK_L_(0x53, 0x1F)
#define REG_BKF053_1F_H      _PK_H_(0x53, 0x1F)
#define REG_BKF053_20_L      _PK_L_(0x53, 0x20)
#define REG_BKF053_20_H      _PK_H_(0x53, 0x20)
#define REG_BKF053_21_L      _PK_L_(0x53, 0x21)
#define REG_BKF053_21_H      _PK_H_(0x53, 0x21)
#define REG_BKF053_22_L      _PK_L_(0x53, 0x22)
#define REG_BKF053_22_H      _PK_H_(0x53, 0x22)
#define REG_BKF053_23_L      _PK_L_(0x53, 0x23)
#define REG_BKF053_23_H      _PK_H_(0x53, 0x23)
#define REG_BKF053_24_L      _PK_L_(0x53, 0x24)
#define REG_BKF053_24_H      _PK_H_(0x53, 0x24)
#define REG_BKF053_25_L      _PK_L_(0x53, 0x25)
#define REG_BKF053_25_H      _PK_H_(0x53, 0x25)
#define REG_BKF053_26_L      _PK_L_(0x53, 0x26)
#define REG_BKF053_26_H      _PK_H_(0x53, 0x26)
#define REG_BKF053_27_L      _PK_L_(0x53, 0x27)
#define REG_BKF053_27_H      _PK_H_(0x53, 0x27)
#define REG_BKF053_28_L      _PK_L_(0x53, 0x28)
#define REG_BKF053_28_H      _PK_H_(0x53, 0x28)
#define REG_BKF053_29_L      _PK_L_(0x53, 0x29)
#define REG_BKF053_29_H      _PK_H_(0x53, 0x29)
#define REG_BKF053_2A_L      _PK_L_(0x53, 0x2A)
#define REG_BKF053_2A_H      _PK_H_(0x53, 0x2A)
#define REG_BKF053_2B_L      _PK_L_(0x53, 0x2B)
#define REG_BKF053_2B_H      _PK_H_(0x53, 0x2B)
#define REG_BKF053_2C_L      _PK_L_(0x53, 0x2C)
#define REG_BKF053_2C_H      _PK_H_(0x53, 0x2C)
#define REG_BKF053_2D_L      _PK_L_(0x53, 0x2D)
#define REG_BKF053_2D_H      _PK_H_(0x53, 0x2D)
#define REG_BKF053_2E_L      _PK_L_(0x53, 0x2E)
#define REG_BKF053_2E_H      _PK_H_(0x53, 0x2E)
#define REG_BKF053_2F_L      _PK_L_(0x53, 0x2F)
#define REG_BKF053_2F_H      _PK_H_(0x53, 0x2F)
#define REG_BKF053_30_L      _PK_L_(0x53, 0x30)
#define REG_BKF053_30_H      _PK_H_(0x53, 0x30)
#define REG_BKF053_31_L      _PK_L_(0x53, 0x31)
#define REG_BKF053_31_H      _PK_H_(0x53, 0x31)
#define REG_BKF053_32_L      _PK_L_(0x53, 0x32)
#define REG_BKF053_32_H      _PK_H_(0x53, 0x32)
#define REG_BKF053_33_L      _PK_L_(0x53, 0x33)
#define REG_BKF053_33_H      _PK_H_(0x53, 0x33)
#define REG_BKF053_34_L      _PK_L_(0x53, 0x34)
#define REG_BKF053_34_H      _PK_H_(0x53, 0x34)
#define REG_BKF053_35_L      _PK_L_(0x53, 0x35)
#define REG_BKF053_35_H      _PK_H_(0x53, 0x35)
#define REG_BKF053_36_L      _PK_L_(0x53, 0x36)
#define REG_BKF053_36_H      _PK_H_(0x53, 0x36)
#define REG_BKF053_37_L      _PK_L_(0x53, 0x37)
#define REG_BKF053_37_H      _PK_H_(0x53, 0x37)
#define REG_BKF053_38_L      _PK_L_(0x53, 0x38)
#define REG_BKF053_38_H      _PK_H_(0x53, 0x38)
#define REG_BKF053_39_L      _PK_L_(0x53, 0x39)
#define REG_BKF053_39_H      _PK_H_(0x53, 0x39)
#define REG_BKF053_3A_L      _PK_L_(0x53, 0x3A)
#define REG_BKF053_3A_H      _PK_H_(0x53, 0x3A)
#define REG_BKF053_3B_L      _PK_L_(0x53, 0x3B)
#define REG_BKF053_3B_H      _PK_H_(0x53, 0x3B)
#define REG_BKF053_3C_L      _PK_L_(0x53, 0x3C)
#define REG_BKF053_3C_H      _PK_H_(0x53, 0x3C)
#define REG_BKF053_3D_L      _PK_L_(0x53, 0x3D)
#define REG_BKF053_3D_H      _PK_H_(0x53, 0x3D)
#define REG_BKF053_3E_L      _PK_L_(0x53, 0x3E)
#define REG_BKF053_3E_H      _PK_H_(0x53, 0x3E)
#define REG_BKF053_3F_L      _PK_L_(0x53, 0x3F)
#define REG_BKF053_3F_H      _PK_H_(0x53, 0x3F)
#define REG_BKF053_40_L      _PK_L_(0x53, 0x40)
#define REG_BKF053_40_H      _PK_H_(0x53, 0x40)
#define REG_BKF053_41_L      _PK_L_(0x53, 0x41)
#define REG_BKF053_41_H      _PK_H_(0x53, 0x41)
#define REG_BKF053_42_L      _PK_L_(0x53, 0x42)
#define REG_BKF053_42_H      _PK_H_(0x53, 0x42)
#define REG_BKF053_43_L      _PK_L_(0x53, 0x43)
#define REG_BKF053_43_H      _PK_H_(0x53, 0x43)
#define REG_BKF053_44_L      _PK_L_(0x53, 0x44)
#define REG_BKF053_44_H      _PK_H_(0x53, 0x44)
#define REG_BKF053_45_L      _PK_L_(0x53, 0x45)
#define REG_BKF053_45_H      _PK_H_(0x53, 0x45)
#define REG_BKF053_46_L      _PK_L_(0x53, 0x46)
#define REG_BKF053_46_H      _PK_H_(0x53, 0x46)
#define REG_BKF053_47_L      _PK_L_(0x53, 0x47)
#define REG_BKF053_47_H      _PK_H_(0x53, 0x47)
#define REG_BKF053_48_L      _PK_L_(0x53, 0x48)
#define REG_BKF053_48_H      _PK_H_(0x53, 0x48)
#define REG_BKF053_49_L      _PK_L_(0x53, 0x49)
#define REG_BKF053_49_H      _PK_H_(0x53, 0x49)
#define REG_BKF053_4A_L      _PK_L_(0x53, 0x4A)
#define REG_BKF053_4A_H      _PK_H_(0x53, 0x4A)
#define REG_BKF053_4B_L      _PK_L_(0x53, 0x4B)
#define REG_BKF053_4B_H      _PK_H_(0x53, 0x4B)
#define REG_BKF053_4C_L      _PK_L_(0x53, 0x4C)
#define REG_BKF053_4C_H      _PK_H_(0x53, 0x4C)
#define REG_BKF053_4D_L      _PK_L_(0x53, 0x4D)
#define REG_BKF053_4D_H      _PK_H_(0x53, 0x4D)
#define REG_BKF053_4E_L      _PK_L_(0x53, 0x4E)
#define REG_BKF053_4E_H      _PK_H_(0x53, 0x4E)
#define REG_BKF053_4F_L      _PK_L_(0x53, 0x4F)
#define REG_BKF053_4F_H      _PK_H_(0x53, 0x4F)
#define REG_BKF053_50_L      _PK_L_(0x53, 0x50)
#define REG_BKF053_50_H      _PK_H_(0x53, 0x50)
#define REG_BKF053_51_L      _PK_L_(0x53, 0x51)
#define REG_BKF053_51_H      _PK_H_(0x53, 0x51)
#define REG_BKF053_52_L      _PK_L_(0x53, 0x52)
#define REG_BKF053_52_H      _PK_H_(0x53, 0x52)
#define REG_BKF053_53_L      _PK_L_(0x53, 0x53)
#define REG_BKF053_53_H      _PK_H_(0x53, 0x53)
#define REG_BKF053_54_L      _PK_L_(0x53, 0x54)
#define REG_BKF053_54_H      _PK_H_(0x53, 0x54)
#define REG_BKF053_55_L      _PK_L_(0x53, 0x55)
#define REG_BKF053_55_H      _PK_H_(0x53, 0x55)
#define REG_BKF053_56_L      _PK_L_(0x53, 0x56)
#define REG_BKF053_56_H      _PK_H_(0x53, 0x56)
#define REG_BKF053_57_L      _PK_L_(0x53, 0x57)
#define REG_BKF053_57_H      _PK_H_(0x53, 0x57)
#define REG_BKF053_58_L      _PK_L_(0x53, 0x58)
#define REG_BKF053_58_H      _PK_H_(0x53, 0x58)
#define REG_BKF053_59_L      _PK_L_(0x53, 0x59)
#define REG_BKF053_59_H      _PK_H_(0x53, 0x59)
#define REG_BKF053_5A_L      _PK_L_(0x53, 0x5A)
#define REG_BKF053_5A_H      _PK_H_(0x53, 0x5A)
#define REG_BKF053_5B_L      _PK_L_(0x53, 0x5B)
#define REG_BKF053_5B_H      _PK_H_(0x53, 0x5B)
#define REG_BKF053_5C_L      _PK_L_(0x53, 0x5C)
#define REG_BKF053_5C_H      _PK_H_(0x53, 0x5C)
#define REG_BKF053_5D_L      _PK_L_(0x53, 0x5D)
#define REG_BKF053_5D_H      _PK_H_(0x53, 0x5D)
#define REG_BKF053_5E_L      _PK_L_(0x53, 0x5E)
#define REG_BKF053_5E_H      _PK_H_(0x53, 0x5E)
#define REG_BKF053_5F_L      _PK_L_(0x53, 0x5F)
#define REG_BKF053_5F_H      _PK_H_(0x53, 0x5F)
#define REG_BKF053_60_L      _PK_L_(0x53, 0x60)
#define REG_BKF053_60_H      _PK_H_(0x53, 0x60)
#define REG_BKF053_61_L      _PK_L_(0x53, 0x61)
#define REG_BKF053_61_H      _PK_H_(0x53, 0x61)
#define REG_BKF053_62_L      _PK_L_(0x53, 0x62)
#define REG_BKF053_62_H      _PK_H_(0x53, 0x62)
#define REG_BKF053_63_L      _PK_L_(0x53, 0x63)
#define REG_BKF053_63_H      _PK_H_(0x53, 0x63)
#define REG_BKF053_64_L      _PK_L_(0x53, 0x64)
#define REG_BKF053_64_H      _PK_H_(0x53, 0x64)
#define REG_BKF053_65_L      _PK_L_(0x53, 0x65)
#define REG_BKF053_65_H      _PK_H_(0x53, 0x65)
#define REG_BKF053_66_L      _PK_L_(0x53, 0x66)
#define REG_BKF053_66_H      _PK_H_(0x53, 0x66)
#define REG_BKF053_67_L      _PK_L_(0x53, 0x67)
#define REG_BKF053_67_H      _PK_H_(0x53, 0x67)
#define REG_BKF053_68_L      _PK_L_(0x53, 0x68)
#define REG_BKF053_68_H      _PK_H_(0x53, 0x68)
#define REG_BKF053_69_L      _PK_L_(0x53, 0x69)
#define REG_BKF053_69_H      _PK_H_(0x53, 0x69)
#define REG_BKF053_6A_L      _PK_L_(0x53, 0x6A)
#define REG_BKF053_6A_H      _PK_H_(0x53, 0x6A)
#define REG_BKF053_6B_L      _PK_L_(0x53, 0x6B)
#define REG_BKF053_6B_H      _PK_H_(0x53, 0x6B)
#define REG_BKF053_6C_L      _PK_L_(0x53, 0x6C)
#define REG_BKF053_6C_H      _PK_H_(0x53, 0x6C)
#define REG_BKF053_6D_L      _PK_L_(0x53, 0x6D)
#define REG_BKF053_6D_H      _PK_H_(0x53, 0x6D)
#define REG_BKF053_6E_L      _PK_L_(0x53, 0x6E)
#define REG_BKF053_6E_H      _PK_H_(0x53, 0x6E)
#define REG_BKF053_6F_L      _PK_L_(0x53, 0x6F)
#define REG_BKF053_6F_H      _PK_H_(0x53, 0x6F)
#define REG_BKF053_70_L      _PK_L_(0x53, 0x70)
#define REG_BKF053_70_H      _PK_H_(0x53, 0x70)
#define REG_BKF053_71_L      _PK_L_(0x53, 0x71)
#define REG_BKF053_71_H      _PK_H_(0x53, 0x71)
#define REG_BKF053_72_L      _PK_L_(0x53, 0x72)
#define REG_BKF053_72_H      _PK_H_(0x53, 0x72)
#define REG_BKF053_73_L      _PK_L_(0x53, 0x73)
#define REG_BKF053_73_H      _PK_H_(0x53, 0x73)
#define REG_BKF053_74_L      _PK_L_(0x53, 0x74)
#define REG_BKF053_74_H      _PK_H_(0x53, 0x74)
#define REG_BKF053_75_L      _PK_L_(0x53, 0x75)
#define REG_BKF053_75_H      _PK_H_(0x53, 0x75)
#define REG_BKF053_76_L      _PK_L_(0x53, 0x76)
#define REG_BKF053_76_H      _PK_H_(0x53, 0x76)
#define REG_BKF053_77_L      _PK_L_(0x53, 0x77)
#define REG_BKF053_77_H      _PK_H_(0x53, 0x77)
#define REG_BKF053_78_L      _PK_L_(0x53, 0x78)
#define REG_BKF053_78_H      _PK_H_(0x53, 0x78)
#define REG_BKF053_79_L      _PK_L_(0x53, 0x79)
#define REG_BKF053_79_H      _PK_H_(0x53, 0x79)
#define REG_BKF053_7A_L      _PK_L_(0x53, 0x7A)
#define REG_BKF053_7A_H      _PK_H_(0x53, 0x7A)
#define REG_BKF053_7B_L      _PK_L_(0x53, 0x7B)
#define REG_BKF053_7B_H      _PK_H_(0x53, 0x7B)
#define REG_BKF053_7C_L      _PK_L_(0x53, 0x7C)
#define REG_BKF053_7C_H      _PK_H_(0x53, 0x7C)
#define REG_BKF053_7D_L      _PK_L_(0x53, 0x7D)
#define REG_BKF053_7D_H      _PK_H_(0x53, 0x7D)
#define REG_BKF053_7E_L      _PK_L_(0x53, 0x7E)
#define REG_BKF053_7E_H      _PK_H_(0x53, 0x7E)
#define REG_BKF053_7F_L      _PK_L_(0x53, 0x7F)
#define REG_BKF053_7F_H      _PK_H_(0x53, 0x7F)
//----------------------------------------------
#define REG_BKF054_00_L      _PK_L_(0x54, 0x00)
#define REG_BKF054_00_H      _PK_H_(0x54, 0x00)
#define REG_BKF054_01_L      _PK_L_(0x54, 0x01)
#define REG_BKF054_01_H      _PK_H_(0x54, 0x01)
#define REG_BKF054_02_L      _PK_L_(0x54, 0x02)
#define REG_BKF054_02_H      _PK_H_(0x54, 0x02)
#define REG_BKF054_03_L      _PK_L_(0x54, 0x03)
#define REG_BKF054_03_H      _PK_H_(0x54, 0x03)
#define REG_BKF054_04_L      _PK_L_(0x54, 0x04)
#define REG_BKF054_04_H      _PK_H_(0x54, 0x04)
#define REG_BKF054_05_L      _PK_L_(0x54, 0x05)
#define REG_BKF054_05_H      _PK_H_(0x54, 0x05)
#define REG_BKF054_06_L      _PK_L_(0x54, 0x06)
#define REG_BKF054_06_H      _PK_H_(0x54, 0x06)
#define REG_BKF054_07_L      _PK_L_(0x54, 0x07)
#define REG_BKF054_07_H      _PK_H_(0x54, 0x07)
#define REG_BKF054_08_L      _PK_L_(0x54, 0x08)
#define REG_BKF054_08_H      _PK_H_(0x54, 0x08)
#define REG_BKF054_09_L      _PK_L_(0x54, 0x09)
#define REG_BKF054_09_H      _PK_H_(0x54, 0x09)
#define REG_BKF054_0A_L      _PK_L_(0x54, 0x0A)
#define REG_BKF054_0A_H      _PK_H_(0x54, 0x0A)
#define REG_BKF054_0B_L      _PK_L_(0x54, 0x0B)
#define REG_BKF054_0B_H      _PK_H_(0x54, 0x0B)
#define REG_BKF054_0C_L      _PK_L_(0x54, 0x0C)
#define REG_BKF054_0C_H      _PK_H_(0x54, 0x0C)
#define REG_BKF054_0D_L      _PK_L_(0x54, 0x0D)
#define REG_BKF054_0D_H      _PK_H_(0x54, 0x0D)
#define REG_BKF054_0E_L      _PK_L_(0x54, 0x0E)
#define REG_BKF054_0E_H      _PK_H_(0x54, 0x0E)
#define REG_BKF054_0F_L      _PK_L_(0x54, 0x0F)
#define REG_BKF054_0F_H      _PK_H_(0x54, 0x0F)
#define REG_BKF054_10_L      _PK_L_(0x54, 0x10)
#define REG_BKF054_10_H      _PK_H_(0x54, 0x10)
#define REG_BKF054_11_L      _PK_L_(0x54, 0x11)
#define REG_BKF054_11_H      _PK_H_(0x54, 0x11)
#define REG_BKF054_12_L      _PK_L_(0x54, 0x12)
#define REG_BKF054_12_H      _PK_H_(0x54, 0x12)
#define REG_BKF054_13_L      _PK_L_(0x54, 0x13)
#define REG_BKF054_13_H      _PK_H_(0x54, 0x13)
#define REG_BKF054_14_L      _PK_L_(0x54, 0x14)
#define REG_BKF054_14_H      _PK_H_(0x54, 0x14)
#define REG_BKF054_15_L      _PK_L_(0x54, 0x15)
#define REG_BKF054_15_H      _PK_H_(0x54, 0x15)
#define REG_BKF054_16_L      _PK_L_(0x54, 0x16)
#define REG_BKF054_16_H      _PK_H_(0x54, 0x16)
#define REG_BKF054_17_L      _PK_L_(0x54, 0x17)
#define REG_BKF054_17_H      _PK_H_(0x54, 0x17)
#define REG_BKF054_18_L      _PK_L_(0x54, 0x18)
#define REG_BKF054_18_H      _PK_H_(0x54, 0x18)
#define REG_BKF054_19_L      _PK_L_(0x54, 0x19)
#define REG_BKF054_19_H      _PK_H_(0x54, 0x19)
#define REG_BKF054_1A_L      _PK_L_(0x54, 0x1A)
#define REG_BKF054_1A_H      _PK_H_(0x54, 0x1A)
#define REG_BKF054_1B_L      _PK_L_(0x54, 0x1B)
#define REG_BKF054_1B_H      _PK_H_(0x54, 0x1B)
#define REG_BKF054_1C_L      _PK_L_(0x54, 0x1C)
#define REG_BKF054_1C_H      _PK_H_(0x54, 0x1C)
#define REG_BKF054_1D_L      _PK_L_(0x54, 0x1D)
#define REG_BKF054_1D_H      _PK_H_(0x54, 0x1D)
#define REG_BKF054_1E_L      _PK_L_(0x54, 0x1E)
#define REG_BKF054_1E_H      _PK_H_(0x54, 0x1E)
#define REG_BKF054_1F_L      _PK_L_(0x54, 0x1F)
#define REG_BKF054_1F_H      _PK_H_(0x54, 0x1F)
#define REG_BKF054_20_L      _PK_L_(0x54, 0x20)
#define REG_BKF054_20_H      _PK_H_(0x54, 0x20)
#define REG_BKF054_21_L      _PK_L_(0x54, 0x21)
#define REG_BKF054_21_H      _PK_H_(0x54, 0x21)
#define REG_BKF054_22_L      _PK_L_(0x54, 0x22)
#define REG_BKF054_22_H      _PK_H_(0x54, 0x22)
#define REG_BKF054_23_L      _PK_L_(0x54, 0x23)
#define REG_BKF054_23_H      _PK_H_(0x54, 0x23)
#define REG_BKF054_24_L      _PK_L_(0x54, 0x24)
#define REG_BKF054_24_H      _PK_H_(0x54, 0x24)
#define REG_BKF054_25_L      _PK_L_(0x54, 0x25)
#define REG_BKF054_25_H      _PK_H_(0x54, 0x25)
#define REG_BKF054_26_L      _PK_L_(0x54, 0x26)
#define REG_BKF054_26_H      _PK_H_(0x54, 0x26)
#define REG_BKF054_27_L      _PK_L_(0x54, 0x27)
#define REG_BKF054_27_H      _PK_H_(0x54, 0x27)
#define REG_BKF054_28_L      _PK_L_(0x54, 0x28)
#define REG_BKF054_28_H      _PK_H_(0x54, 0x28)
#define REG_BKF054_29_L      _PK_L_(0x54, 0x29)
#define REG_BKF054_29_H      _PK_H_(0x54, 0x29)
#define REG_BKF054_2A_L      _PK_L_(0x54, 0x2A)
#define REG_BKF054_2A_H      _PK_H_(0x54, 0x2A)
#define REG_BKF054_2B_L      _PK_L_(0x54, 0x2B)
#define REG_BKF054_2B_H      _PK_H_(0x54, 0x2B)
#define REG_BKF054_2C_L      _PK_L_(0x54, 0x2C)
#define REG_BKF054_2C_H      _PK_H_(0x54, 0x2C)
#define REG_BKF054_2D_L      _PK_L_(0x54, 0x2D)
#define REG_BKF054_2D_H      _PK_H_(0x54, 0x2D)
#define REG_BKF054_2E_L      _PK_L_(0x54, 0x2E)
#define REG_BKF054_2E_H      _PK_H_(0x54, 0x2E)
#define REG_BKF054_2F_L      _PK_L_(0x54, 0x2F)
#define REG_BKF054_2F_H      _PK_H_(0x54, 0x2F)
#define REG_BKF054_30_L      _PK_L_(0x54, 0x30)
#define REG_BKF054_30_H      _PK_H_(0x54, 0x30)
#define REG_BKF054_31_L      _PK_L_(0x54, 0x31)
#define REG_BKF054_31_H      _PK_H_(0x54, 0x31)
#define REG_BKF054_32_L      _PK_L_(0x54, 0x32)
#define REG_BKF054_32_H      _PK_H_(0x54, 0x32)
#define REG_BKF054_33_L      _PK_L_(0x54, 0x33)
#define REG_BKF054_33_H      _PK_H_(0x54, 0x33)
#define REG_BKF054_34_L      _PK_L_(0x54, 0x34)
#define REG_BKF054_34_H      _PK_H_(0x54, 0x34)
#define REG_BKF054_35_L      _PK_L_(0x54, 0x35)
#define REG_BKF054_35_H      _PK_H_(0x54, 0x35)
#define REG_BKF054_36_L      _PK_L_(0x54, 0x36)
#define REG_BKF054_36_H      _PK_H_(0x54, 0x36)
#define REG_BKF054_37_L      _PK_L_(0x54, 0x37)
#define REG_BKF054_37_H      _PK_H_(0x54, 0x37)
#define REG_BKF054_38_L      _PK_L_(0x54, 0x38)
#define REG_BKF054_38_H      _PK_H_(0x54, 0x38)
#define REG_BKF054_39_L      _PK_L_(0x54, 0x39)
#define REG_BKF054_39_H      _PK_H_(0x54, 0x39)
#define REG_BKF054_3A_L      _PK_L_(0x54, 0x3A)
#define REG_BKF054_3A_H      _PK_H_(0x54, 0x3A)
#define REG_BKF054_3B_L      _PK_L_(0x54, 0x3B)
#define REG_BKF054_3B_H      _PK_H_(0x54, 0x3B)
#define REG_BKF054_3C_L      _PK_L_(0x54, 0x3C)
#define REG_BKF054_3C_H      _PK_H_(0x54, 0x3C)
#define REG_BKF054_3D_L      _PK_L_(0x54, 0x3D)
#define REG_BKF054_3D_H      _PK_H_(0x54, 0x3D)
#define REG_BKF054_3E_L      _PK_L_(0x54, 0x3E)
#define REG_BKF054_3E_H      _PK_H_(0x54, 0x3E)
#define REG_BKF054_3F_L      _PK_L_(0x54, 0x3F)
#define REG_BKF054_3F_H      _PK_H_(0x54, 0x3F)
#define REG_BKF054_40_L      _PK_L_(0x54, 0x40)
#define REG_BKF054_40_H      _PK_H_(0x54, 0x40)
#define REG_BKF054_41_L      _PK_L_(0x54, 0x41)
#define REG_BKF054_41_H      _PK_H_(0x54, 0x41)
#define REG_BKF054_42_L      _PK_L_(0x54, 0x42)
#define REG_BKF054_42_H      _PK_H_(0x54, 0x42)
#define REG_BKF054_43_L      _PK_L_(0x54, 0x43)
#define REG_BKF054_43_H      _PK_H_(0x54, 0x43)
#define REG_BKF054_44_L      _PK_L_(0x54, 0x44)
#define REG_BKF054_44_H      _PK_H_(0x54, 0x44)
#define REG_BKF054_45_L      _PK_L_(0x54, 0x45)
#define REG_BKF054_45_H      _PK_H_(0x54, 0x45)
#define REG_BKF054_46_L      _PK_L_(0x54, 0x46)
#define REG_BKF054_46_H      _PK_H_(0x54, 0x46)
#define REG_BKF054_47_L      _PK_L_(0x54, 0x47)
#define REG_BKF054_47_H      _PK_H_(0x54, 0x47)
#define REG_BKF054_48_L      _PK_L_(0x54, 0x48)
#define REG_BKF054_48_H      _PK_H_(0x54, 0x48)
#define REG_BKF054_49_L      _PK_L_(0x54, 0x49)
#define REG_BKF054_49_H      _PK_H_(0x54, 0x49)
#define REG_BKF054_4A_L      _PK_L_(0x54, 0x4A)
#define REG_BKF054_4A_H      _PK_H_(0x54, 0x4A)
#define REG_BKF054_4B_L      _PK_L_(0x54, 0x4B)
#define REG_BKF054_4B_H      _PK_H_(0x54, 0x4B)
#define REG_BKF054_4C_L      _PK_L_(0x54, 0x4C)
#define REG_BKF054_4C_H      _PK_H_(0x54, 0x4C)
#define REG_BKF054_4D_L      _PK_L_(0x54, 0x4D)
#define REG_BKF054_4D_H      _PK_H_(0x54, 0x4D)
#define REG_BKF054_4E_L      _PK_L_(0x54, 0x4E)
#define REG_BKF054_4E_H      _PK_H_(0x54, 0x4E)
#define REG_BKF054_4F_L      _PK_L_(0x54, 0x4F)
#define REG_BKF054_4F_H      _PK_H_(0x54, 0x4F)
#define REG_BKF054_50_L      _PK_L_(0x54, 0x50)
#define REG_BKF054_50_H      _PK_H_(0x54, 0x50)
#define REG_BKF054_51_L      _PK_L_(0x54, 0x51)
#define REG_BKF054_51_H      _PK_H_(0x54, 0x51)
#define REG_BKF054_52_L      _PK_L_(0x54, 0x52)
#define REG_BKF054_52_H      _PK_H_(0x54, 0x52)
#define REG_BKF054_53_L      _PK_L_(0x54, 0x53)
#define REG_BKF054_53_H      _PK_H_(0x54, 0x53)
#define REG_BKF054_54_L      _PK_L_(0x54, 0x54)
#define REG_BKF054_54_H      _PK_H_(0x54, 0x54)
#define REG_BKF054_55_L      _PK_L_(0x54, 0x55)
#define REG_BKF054_55_H      _PK_H_(0x54, 0x55)
#define REG_BKF054_56_L      _PK_L_(0x54, 0x56)
#define REG_BKF054_56_H      _PK_H_(0x54, 0x56)
#define REG_BKF054_57_L      _PK_L_(0x54, 0x57)
#define REG_BKF054_57_H      _PK_H_(0x54, 0x57)
#define REG_BKF054_58_L      _PK_L_(0x54, 0x58)
#define REG_BKF054_58_H      _PK_H_(0x54, 0x58)
#define REG_BKF054_59_L      _PK_L_(0x54, 0x59)
#define REG_BKF054_59_H      _PK_H_(0x54, 0x59)
#define REG_BKF054_5A_L      _PK_L_(0x54, 0x5A)
#define REG_BKF054_5A_H      _PK_H_(0x54, 0x5A)
#define REG_BKF054_5B_L      _PK_L_(0x54, 0x5B)
#define REG_BKF054_5B_H      _PK_H_(0x54, 0x5B)
#define REG_BKF054_5C_L      _PK_L_(0x54, 0x5C)
#define REG_BKF054_5C_H      _PK_H_(0x54, 0x5C)
#define REG_BKF054_5D_L      _PK_L_(0x54, 0x5D)
#define REG_BKF054_5D_H      _PK_H_(0x54, 0x5D)
#define REG_BKF054_5E_L      _PK_L_(0x54, 0x5E)
#define REG_BKF054_5E_H      _PK_H_(0x54, 0x5E)
#define REG_BKF054_5F_L      _PK_L_(0x54, 0x5F)
#define REG_BKF054_5F_H      _PK_H_(0x54, 0x5F)
#define REG_BKF054_60_L      _PK_L_(0x54, 0x60)
#define REG_BKF054_60_H      _PK_H_(0x54, 0x60)
#define REG_BKF054_61_L      _PK_L_(0x54, 0x61)
#define REG_BKF054_61_H      _PK_H_(0x54, 0x61)
#define REG_BKF054_62_L      _PK_L_(0x54, 0x62)
#define REG_BKF054_62_H      _PK_H_(0x54, 0x62)
#define REG_BKF054_63_L      _PK_L_(0x54, 0x63)
#define REG_BKF054_63_H      _PK_H_(0x54, 0x63)
#define REG_BKF054_64_L      _PK_L_(0x54, 0x64)
#define REG_BKF054_64_H      _PK_H_(0x54, 0x64)
#define REG_BKF054_65_L      _PK_L_(0x54, 0x65)
#define REG_BKF054_65_H      _PK_H_(0x54, 0x65)
#define REG_BKF054_66_L      _PK_L_(0x54, 0x66)
#define REG_BKF054_66_H      _PK_H_(0x54, 0x66)
#define REG_BKF054_67_L      _PK_L_(0x54, 0x67)
#define REG_BKF054_67_H      _PK_H_(0x54, 0x67)
#define REG_BKF054_68_L      _PK_L_(0x54, 0x68)
#define REG_BKF054_68_H      _PK_H_(0x54, 0x68)
#define REG_BKF054_69_L      _PK_L_(0x54, 0x69)
#define REG_BKF054_69_H      _PK_H_(0x54, 0x69)
#define REG_BKF054_6A_L      _PK_L_(0x54, 0x6A)
#define REG_BKF054_6A_H      _PK_H_(0x54, 0x6A)
#define REG_BKF054_6B_L      _PK_L_(0x54, 0x6B)
#define REG_BKF054_6B_H      _PK_H_(0x54, 0x6B)
#define REG_BKF054_6C_L      _PK_L_(0x54, 0x6C)
#define REG_BKF054_6C_H      _PK_H_(0x54, 0x6C)
#define REG_BKF054_6D_L      _PK_L_(0x54, 0x6D)
#define REG_BKF054_6D_H      _PK_H_(0x54, 0x6D)
#define REG_BKF054_6E_L      _PK_L_(0x54, 0x6E)
#define REG_BKF054_6E_H      _PK_H_(0x54, 0x6E)
#define REG_BKF054_6F_L      _PK_L_(0x54, 0x6F)
#define REG_BKF054_6F_H      _PK_H_(0x54, 0x6F)
#define REG_BKF054_70_L      _PK_L_(0x54, 0x70)
#define REG_BKF054_70_H      _PK_H_(0x54, 0x70)
#define REG_BKF054_71_L      _PK_L_(0x54, 0x71)
#define REG_BKF054_71_H      _PK_H_(0x54, 0x71)
#define REG_BKF054_72_L      _PK_L_(0x54, 0x72)
#define REG_BKF054_72_H      _PK_H_(0x54, 0x72)
#define REG_BKF054_73_L      _PK_L_(0x54, 0x73)
#define REG_BKF054_73_H      _PK_H_(0x54, 0x73)
#define REG_BKF054_74_L      _PK_L_(0x54, 0x74)
#define REG_BKF054_74_H      _PK_H_(0x54, 0x74)
#define REG_BKF054_75_L      _PK_L_(0x54, 0x75)
#define REG_BKF054_75_H      _PK_H_(0x54, 0x75)
#define REG_BKF054_76_L      _PK_L_(0x54, 0x76)
#define REG_BKF054_76_H      _PK_H_(0x54, 0x76)
#define REG_BKF054_77_L      _PK_L_(0x54, 0x77)
#define REG_BKF054_77_H      _PK_H_(0x54, 0x77)
#define REG_BKF054_78_L      _PK_L_(0x54, 0x78)
#define REG_BKF054_78_H      _PK_H_(0x54, 0x78)
#define REG_BKF054_79_L      _PK_L_(0x54, 0x79)
#define REG_BKF054_79_H      _PK_H_(0x54, 0x79)
#define REG_BKF054_7A_L      _PK_L_(0x54, 0x7A)
#define REG_BKF054_7A_H      _PK_H_(0x54, 0x7A)
#define REG_BKF054_7B_L      _PK_L_(0x54, 0x7B)
#define REG_BKF054_7B_H      _PK_H_(0x54, 0x7B)
#define REG_BKF054_7C_L      _PK_L_(0x54, 0x7C)
#define REG_BKF054_7C_H      _PK_H_(0x54, 0x7C)
#define REG_BKF054_7D_L      _PK_L_(0x54, 0x7D)
#define REG_BKF054_7D_H      _PK_H_(0x54, 0x7D)
#define REG_BKF054_7E_L      _PK_L_(0x54, 0x7E)
#define REG_BKF054_7E_H      _PK_H_(0x54, 0x7E)
#define REG_BKF054_7F_L      _PK_L_(0x54, 0x7F)
#define REG_BKF054_7F_H      _PK_H_(0x54, 0x7F)
//----------------------------------------------
#define REG_BKF055_00_L      _PK_L_(0x55, 0x00)
#define REG_BKF055_00_H      _PK_H_(0x55, 0x00)
#define REG_BKF055_01_L      _PK_L_(0x55, 0x01)
#define REG_BKF055_01_H      _PK_H_(0x55, 0x01)
#define REG_BKF055_02_L      _PK_L_(0x55, 0x02)
#define REG_BKF055_02_H      _PK_H_(0x55, 0x02)
#define REG_BKF055_03_L      _PK_L_(0x55, 0x03)
#define REG_BKF055_03_H      _PK_H_(0x55, 0x03)
#define REG_BKF055_04_L      _PK_L_(0x55, 0x04)
#define REG_BKF055_04_H      _PK_H_(0x55, 0x04)
#define REG_BKF055_05_L      _PK_L_(0x55, 0x05)
#define REG_BKF055_05_H      _PK_H_(0x55, 0x05)
#define REG_BKF055_06_L      _PK_L_(0x55, 0x06)
#define REG_BKF055_06_H      _PK_H_(0x55, 0x06)
#define REG_BKF055_07_L      _PK_L_(0x55, 0x07)
#define REG_BKF055_07_H      _PK_H_(0x55, 0x07)
#define REG_BKF055_08_L      _PK_L_(0x55, 0x08)
#define REG_BKF055_08_H      _PK_H_(0x55, 0x08)
#define REG_BKF055_09_L      _PK_L_(0x55, 0x09)
#define REG_BKF055_09_H      _PK_H_(0x55, 0x09)
#define REG_BKF055_0A_L      _PK_L_(0x55, 0x0A)
#define REG_BKF055_0A_H      _PK_H_(0x55, 0x0A)
#define REG_BKF055_0B_L      _PK_L_(0x55, 0x0B)
#define REG_BKF055_0B_H      _PK_H_(0x55, 0x0B)
#define REG_BKF055_0C_L      _PK_L_(0x55, 0x0C)
#define REG_BKF055_0C_H      _PK_H_(0x55, 0x0C)
#define REG_BKF055_0D_L      _PK_L_(0x55, 0x0D)
#define REG_BKF055_0D_H      _PK_H_(0x55, 0x0D)
#define REG_BKF055_0E_L      _PK_L_(0x55, 0x0E)
#define REG_BKF055_0E_H      _PK_H_(0x55, 0x0E)
#define REG_BKF055_0F_L      _PK_L_(0x55, 0x0F)
#define REG_BKF055_0F_H      _PK_H_(0x55, 0x0F)
#define REG_BKF055_10_L      _PK_L_(0x55, 0x10)
#define REG_BKF055_10_H      _PK_H_(0x55, 0x10)
#define REG_BKF055_11_L      _PK_L_(0x55, 0x11)
#define REG_BKF055_11_H      _PK_H_(0x55, 0x11)
#define REG_BKF055_12_L      _PK_L_(0x55, 0x12)
#define REG_BKF055_12_H      _PK_H_(0x55, 0x12)
#define REG_BKF055_13_L      _PK_L_(0x55, 0x13)
#define REG_BKF055_13_H      _PK_H_(0x55, 0x13)
#define REG_BKF055_14_L      _PK_L_(0x55, 0x14)
#define REG_BKF055_14_H      _PK_H_(0x55, 0x14)
#define REG_BKF055_15_L      _PK_L_(0x55, 0x15)
#define REG_BKF055_15_H      _PK_H_(0x55, 0x15)
#define REG_BKF055_16_L      _PK_L_(0x55, 0x16)
#define REG_BKF055_16_H      _PK_H_(0x55, 0x16)
#define REG_BKF055_17_L      _PK_L_(0x55, 0x17)
#define REG_BKF055_17_H      _PK_H_(0x55, 0x17)
#define REG_BKF055_18_L      _PK_L_(0x55, 0x18)
#define REG_BKF055_18_H      _PK_H_(0x55, 0x18)
#define REG_BKF055_19_L      _PK_L_(0x55, 0x19)
#define REG_BKF055_19_H      _PK_H_(0x55, 0x19)
#define REG_BKF055_1A_L      _PK_L_(0x55, 0x1A)
#define REG_BKF055_1A_H      _PK_H_(0x55, 0x1A)
#define REG_BKF055_1B_L      _PK_L_(0x55, 0x1B)
#define REG_BKF055_1B_H      _PK_H_(0x55, 0x1B)
#define REG_BKF055_1C_L      _PK_L_(0x55, 0x1C)
#define REG_BKF055_1C_H      _PK_H_(0x55, 0x1C)
#define REG_BKF055_1D_L      _PK_L_(0x55, 0x1D)
#define REG_BKF055_1D_H      _PK_H_(0x55, 0x1D)
#define REG_BKF055_1E_L      _PK_L_(0x55, 0x1E)
#define REG_BKF055_1E_H      _PK_H_(0x55, 0x1E)
#define REG_BKF055_1F_L      _PK_L_(0x55, 0x1F)
#define REG_BKF055_1F_H      _PK_H_(0x55, 0x1F)
#define REG_BKF055_20_L      _PK_L_(0x55, 0x20)
#define REG_BKF055_20_H      _PK_H_(0x55, 0x20)
#define REG_BKF055_21_L      _PK_L_(0x55, 0x21)
#define REG_BKF055_21_H      _PK_H_(0x55, 0x21)
#define REG_BKF055_22_L      _PK_L_(0x55, 0x22)
#define REG_BKF055_22_H      _PK_H_(0x55, 0x22)
#define REG_BKF055_23_L      _PK_L_(0x55, 0x23)
#define REG_BKF055_23_H      _PK_H_(0x55, 0x23)
#define REG_BKF055_24_L      _PK_L_(0x55, 0x24)
#define REG_BKF055_24_H      _PK_H_(0x55, 0x24)
#define REG_BKF055_25_L      _PK_L_(0x55, 0x25)
#define REG_BKF055_25_H      _PK_H_(0x55, 0x25)
#define REG_BKF055_26_L      _PK_L_(0x55, 0x26)
#define REG_BKF055_26_H      _PK_H_(0x55, 0x26)
#define REG_BKF055_27_L      _PK_L_(0x55, 0x27)
#define REG_BKF055_27_H      _PK_H_(0x55, 0x27)
#define REG_BKF055_28_L      _PK_L_(0x55, 0x28)
#define REG_BKF055_28_H      _PK_H_(0x55, 0x28)
#define REG_BKF055_29_L      _PK_L_(0x55, 0x29)
#define REG_BKF055_29_H      _PK_H_(0x55, 0x29)
#define REG_BKF055_2A_L      _PK_L_(0x55, 0x2A)
#define REG_BKF055_2A_H      _PK_H_(0x55, 0x2A)
#define REG_BKF055_2B_L      _PK_L_(0x55, 0x2B)
#define REG_BKF055_2B_H      _PK_H_(0x55, 0x2B)
#define REG_BKF055_2C_L      _PK_L_(0x55, 0x2C)
#define REG_BKF055_2C_H      _PK_H_(0x55, 0x2C)
#define REG_BKF055_2D_L      _PK_L_(0x55, 0x2D)
#define REG_BKF055_2D_H      _PK_H_(0x55, 0x2D)
#define REG_BKF055_2E_L      _PK_L_(0x55, 0x2E)
#define REG_BKF055_2E_H      _PK_H_(0x55, 0x2E)
#define REG_BKF055_2F_L      _PK_L_(0x55, 0x2F)
#define REG_BKF055_2F_H      _PK_H_(0x55, 0x2F)
#define REG_BKF055_30_L      _PK_L_(0x55, 0x30)
#define REG_BKF055_30_H      _PK_H_(0x55, 0x30)
#define REG_BKF055_31_L      _PK_L_(0x55, 0x31)
#define REG_BKF055_31_H      _PK_H_(0x55, 0x31)
#define REG_BKF055_32_L      _PK_L_(0x55, 0x32)
#define REG_BKF055_32_H      _PK_H_(0x55, 0x32)
#define REG_BKF055_33_L      _PK_L_(0x55, 0x33)
#define REG_BKF055_33_H      _PK_H_(0x55, 0x33)
#define REG_BKF055_34_L      _PK_L_(0x55, 0x34)
#define REG_BKF055_34_H      _PK_H_(0x55, 0x34)
#define REG_BKF055_35_L      _PK_L_(0x55, 0x35)
#define REG_BKF055_35_H      _PK_H_(0x55, 0x35)
#define REG_BKF055_36_L      _PK_L_(0x55, 0x36)
#define REG_BKF055_36_H      _PK_H_(0x55, 0x36)
#define REG_BKF055_37_L      _PK_L_(0x55, 0x37)
#define REG_BKF055_37_H      _PK_H_(0x55, 0x37)
#define REG_BKF055_38_L      _PK_L_(0x55, 0x38)
#define REG_BKF055_38_H      _PK_H_(0x55, 0x38)
#define REG_BKF055_39_L      _PK_L_(0x55, 0x39)
#define REG_BKF055_39_H      _PK_H_(0x55, 0x39)
#define REG_BKF055_3A_L      _PK_L_(0x55, 0x3A)
#define REG_BKF055_3A_H      _PK_H_(0x55, 0x3A)
#define REG_BKF055_3B_L      _PK_L_(0x55, 0x3B)
#define REG_BKF055_3B_H      _PK_H_(0x55, 0x3B)
#define REG_BKF055_3C_L      _PK_L_(0x55, 0x3C)
#define REG_BKF055_3C_H      _PK_H_(0x55, 0x3C)
#define REG_BKF055_3D_L      _PK_L_(0x55, 0x3D)
#define REG_BKF055_3D_H      _PK_H_(0x55, 0x3D)
#define REG_BKF055_3E_L      _PK_L_(0x55, 0x3E)
#define REG_BKF055_3E_H      _PK_H_(0x55, 0x3E)
#define REG_BKF055_3F_L      _PK_L_(0x55, 0x3F)
#define REG_BKF055_3F_H      _PK_H_(0x55, 0x3F)
#define REG_BKF055_40_L      _PK_L_(0x55, 0x40)
#define REG_BKF055_40_H      _PK_H_(0x55, 0x40)
#define REG_BKF055_41_L      _PK_L_(0x55, 0x41)
#define REG_BKF055_41_H      _PK_H_(0x55, 0x41)
#define REG_BKF055_42_L      _PK_L_(0x55, 0x42)
#define REG_BKF055_42_H      _PK_H_(0x55, 0x42)
#define REG_BKF055_43_L      _PK_L_(0x55, 0x43)
#define REG_BKF055_43_H      _PK_H_(0x55, 0x43)
#define REG_BKF055_44_L      _PK_L_(0x55, 0x44)
#define REG_BKF055_44_H      _PK_H_(0x55, 0x44)
#define REG_BKF055_45_L      _PK_L_(0x55, 0x45)
#define REG_BKF055_45_H      _PK_H_(0x55, 0x45)
#define REG_BKF055_46_L      _PK_L_(0x55, 0x46)
#define REG_BKF055_46_H      _PK_H_(0x55, 0x46)
#define REG_BKF055_47_L      _PK_L_(0x55, 0x47)
#define REG_BKF055_47_H      _PK_H_(0x55, 0x47)
#define REG_BKF055_48_L      _PK_L_(0x55, 0x48)
#define REG_BKF055_48_H      _PK_H_(0x55, 0x48)
#define REG_BKF055_49_L      _PK_L_(0x55, 0x49)
#define REG_BKF055_49_H      _PK_H_(0x55, 0x49)
#define REG_BKF055_4A_L      _PK_L_(0x55, 0x4A)
#define REG_BKF055_4A_H      _PK_H_(0x55, 0x4A)
#define REG_BKF055_4B_L      _PK_L_(0x55, 0x4B)
#define REG_BKF055_4B_H      _PK_H_(0x55, 0x4B)
#define REG_BKF055_4C_L      _PK_L_(0x55, 0x4C)
#define REG_BKF055_4C_H      _PK_H_(0x55, 0x4C)
#define REG_BKF055_4D_L      _PK_L_(0x55, 0x4D)
#define REG_BKF055_4D_H      _PK_H_(0x55, 0x4D)
#define REG_BKF055_4E_L      _PK_L_(0x55, 0x4E)
#define REG_BKF055_4E_H      _PK_H_(0x55, 0x4E)
#define REG_BKF055_4F_L      _PK_L_(0x55, 0x4F)
#define REG_BKF055_4F_H      _PK_H_(0x55, 0x4F)
#define REG_BKF055_50_L      _PK_L_(0x55, 0x50)
#define REG_BKF055_50_H      _PK_H_(0x55, 0x50)
#define REG_BKF055_51_L      _PK_L_(0x55, 0x51)
#define REG_BKF055_51_H      _PK_H_(0x55, 0x51)
#define REG_BKF055_52_L      _PK_L_(0x55, 0x52)
#define REG_BKF055_52_H      _PK_H_(0x55, 0x52)
#define REG_BKF055_53_L      _PK_L_(0x55, 0x53)
#define REG_BKF055_53_H      _PK_H_(0x55, 0x53)
#define REG_BKF055_54_L      _PK_L_(0x55, 0x54)
#define REG_BKF055_54_H      _PK_H_(0x55, 0x54)
#define REG_BKF055_55_L      _PK_L_(0x55, 0x55)
#define REG_BKF055_55_H      _PK_H_(0x55, 0x55)
#define REG_BKF055_56_L      _PK_L_(0x55, 0x56)
#define REG_BKF055_56_H      _PK_H_(0x55, 0x56)
#define REG_BKF055_57_L      _PK_L_(0x55, 0x57)
#define REG_BKF055_57_H      _PK_H_(0x55, 0x57)
#define REG_BKF055_58_L      _PK_L_(0x55, 0x58)
#define REG_BKF055_58_H      _PK_H_(0x55, 0x58)
#define REG_BKF055_59_L      _PK_L_(0x55, 0x59)
#define REG_BKF055_59_H      _PK_H_(0x55, 0x59)
#define REG_BKF055_5A_L      _PK_L_(0x55, 0x5A)
#define REG_BKF055_5A_H      _PK_H_(0x55, 0x5A)
#define REG_BKF055_5B_L      _PK_L_(0x55, 0x5B)
#define REG_BKF055_5B_H      _PK_H_(0x55, 0x5B)
#define REG_BKF055_5C_L      _PK_L_(0x55, 0x5C)
#define REG_BKF055_5C_H      _PK_H_(0x55, 0x5C)
#define REG_BKF055_5D_L      _PK_L_(0x55, 0x5D)
#define REG_BKF055_5D_H      _PK_H_(0x55, 0x5D)
#define REG_BKF055_5E_L      _PK_L_(0x55, 0x5E)
#define REG_BKF055_5E_H      _PK_H_(0x55, 0x5E)
#define REG_BKF055_5F_L      _PK_L_(0x55, 0x5F)
#define REG_BKF055_5F_H      _PK_H_(0x55, 0x5F)
#define REG_BKF055_60_L      _PK_L_(0x55, 0x60)
#define REG_BKF055_60_H      _PK_H_(0x55, 0x60)
#define REG_BKF055_61_L      _PK_L_(0x55, 0x61)
#define REG_BKF055_61_H      _PK_H_(0x55, 0x61)
#define REG_BKF055_62_L      _PK_L_(0x55, 0x62)
#define REG_BKF055_62_H      _PK_H_(0x55, 0x62)
#define REG_BKF055_63_L      _PK_L_(0x55, 0x63)
#define REG_BKF055_63_H      _PK_H_(0x55, 0x63)
#define REG_BKF055_64_L      _PK_L_(0x55, 0x64)
#define REG_BKF055_64_H      _PK_H_(0x55, 0x64)
#define REG_BKF055_65_L      _PK_L_(0x55, 0x65)
#define REG_BKF055_65_H      _PK_H_(0x55, 0x65)
#define REG_BKF055_66_L      _PK_L_(0x55, 0x66)
#define REG_BKF055_66_H      _PK_H_(0x55, 0x66)
#define REG_BKF055_67_L      _PK_L_(0x55, 0x67)
#define REG_BKF055_67_H      _PK_H_(0x55, 0x67)
#define REG_BKF055_68_L      _PK_L_(0x55, 0x68)
#define REG_BKF055_68_H      _PK_H_(0x55, 0x68)
#define REG_BKF055_69_L      _PK_L_(0x55, 0x69)
#define REG_BKF055_69_H      _PK_H_(0x55, 0x69)
#define REG_BKF055_6A_L      _PK_L_(0x55, 0x6A)
#define REG_BKF055_6A_H      _PK_H_(0x55, 0x6A)
#define REG_BKF055_6B_L      _PK_L_(0x55, 0x6B)
#define REG_BKF055_6B_H      _PK_H_(0x55, 0x6B)
#define REG_BKF055_6C_L      _PK_L_(0x55, 0x6C)
#define REG_BKF055_6C_H      _PK_H_(0x55, 0x6C)
#define REG_BKF055_6D_L      _PK_L_(0x55, 0x6D)
#define REG_BKF055_6D_H      _PK_H_(0x55, 0x6D)
#define REG_BKF055_6E_L      _PK_L_(0x55, 0x6E)
#define REG_BKF055_6E_H      _PK_H_(0x55, 0x6E)
#define REG_BKF055_6F_L      _PK_L_(0x55, 0x6F)
#define REG_BKF055_6F_H      _PK_H_(0x55, 0x6F)
#define REG_BKF055_70_L      _PK_L_(0x55, 0x70)
#define REG_BKF055_70_H      _PK_H_(0x55, 0x70)
#define REG_BKF055_71_L      _PK_L_(0x55, 0x71)
#define REG_BKF055_71_H      _PK_H_(0x55, 0x71)
#define REG_BKF055_72_L      _PK_L_(0x55, 0x72)
#define REG_BKF055_72_H      _PK_H_(0x55, 0x72)
#define REG_BKF055_73_L      _PK_L_(0x55, 0x73)
#define REG_BKF055_73_H      _PK_H_(0x55, 0x73)
#define REG_BKF055_74_L      _PK_L_(0x55, 0x74)
#define REG_BKF055_74_H      _PK_H_(0x55, 0x74)
#define REG_BKF055_75_L      _PK_L_(0x55, 0x75)
#define REG_BKF055_75_H      _PK_H_(0x55, 0x75)
#define REG_BKF055_76_L      _PK_L_(0x55, 0x76)
#define REG_BKF055_76_H      _PK_H_(0x55, 0x76)
#define REG_BKF055_77_L      _PK_L_(0x55, 0x77)
#define REG_BKF055_77_H      _PK_H_(0x55, 0x77)
#define REG_BKF055_78_L      _PK_L_(0x55, 0x78)
#define REG_BKF055_78_H      _PK_H_(0x55, 0x78)
#define REG_BKF055_79_L      _PK_L_(0x55, 0x79)
#define REG_BKF055_79_H      _PK_H_(0x55, 0x79)
#define REG_BKF055_7A_L      _PK_L_(0x55, 0x7A)
#define REG_BKF055_7A_H      _PK_H_(0x55, 0x7A)
#define REG_BKF055_7B_L      _PK_L_(0x55, 0x7B)
#define REG_BKF055_7B_H      _PK_H_(0x55, 0x7B)
#define REG_BKF055_7C_L      _PK_L_(0x55, 0x7C)
#define REG_BKF055_7C_H      _PK_H_(0x55, 0x7C)
#define REG_BKF055_7D_L      _PK_L_(0x55, 0x7D)
#define REG_BKF055_7D_H      _PK_H_(0x55, 0x7D)
#define REG_BKF055_7E_L      _PK_L_(0x55, 0x7E)
#define REG_BKF055_7E_H      _PK_H_(0x55, 0x7E)
#define REG_BKF055_7F_L      _PK_L_(0x55, 0x7F)
#define REG_BKF055_7F_H      _PK_H_(0x55, 0x7F)
//----------------------------------------------
#define REG_BKF05D_00_L      _PK_L_(0x5D, 0x00)
#define REG_BKF05D_00_H      _PK_H_(0x5D, 0x00)
#define REG_BKF05D_01_L      _PK_L_(0x5D, 0x01)
#define REG_BKF05D_01_H      _PK_H_(0x5D, 0x01)
#define REG_BKF05D_02_L      _PK_L_(0x5D, 0x02)
#define REG_BKF05D_02_H      _PK_H_(0x5D, 0x02)
#define REG_BKF05D_03_L      _PK_L_(0x5D, 0x03)
#define REG_BKF05D_03_H      _PK_H_(0x5D, 0x03)
#define REG_BKF05D_04_L      _PK_L_(0x5D, 0x04)
#define REG_BKF05D_04_H      _PK_H_(0x5D, 0x04)
#define REG_BKF05D_05_L      _PK_L_(0x5D, 0x05)
#define REG_BKF05D_05_H      _PK_H_(0x5D, 0x05)
#define REG_BKF05D_06_L      _PK_L_(0x5D, 0x06)
#define REG_BKF05D_06_H      _PK_H_(0x5D, 0x06)
#define REG_BKF05D_07_L      _PK_L_(0x5D, 0x07)
#define REG_BKF05D_07_H      _PK_H_(0x5D, 0x07)
#define REG_BKF05D_08_L      _PK_L_(0x5D, 0x08)
#define REG_BKF05D_08_H      _PK_H_(0x5D, 0x08)
#define REG_BKF05D_09_L      _PK_L_(0x5D, 0x09)
#define REG_BKF05D_09_H      _PK_H_(0x5D, 0x09)
#define REG_BKF05D_0A_L      _PK_L_(0x5D, 0x0A)
#define REG_BKF05D_0A_H      _PK_H_(0x5D, 0x0A)
#define REG_BKF05D_0B_L      _PK_L_(0x5D, 0x0B)
#define REG_BKF05D_0B_H      _PK_H_(0x5D, 0x0B)
#define REG_BKF05D_0C_L      _PK_L_(0x5D, 0x0C)
#define REG_BKF05D_0C_H      _PK_H_(0x5D, 0x0C)
#define REG_BKF05D_0D_L      _PK_L_(0x5D, 0x0D)
#define REG_BKF05D_0D_H      _PK_H_(0x5D, 0x0D)
#define REG_BKF05D_0E_L      _PK_L_(0x5D, 0x0E)
#define REG_BKF05D_0E_H      _PK_H_(0x5D, 0x0E)
#define REG_BKF05D_0F_L      _PK_L_(0x5D, 0x0F)
#define REG_BKF05D_0F_H      _PK_H_(0x5D, 0x0F)
#define REG_BKF05D_10_L      _PK_L_(0x5D, 0x10)
#define REG_BKF05D_10_H      _PK_H_(0x5D, 0x10)
#define REG_BKF05D_11_L      _PK_L_(0x5D, 0x11)
#define REG_BKF05D_11_H      _PK_H_(0x5D, 0x11)
#define REG_BKF05D_12_L      _PK_L_(0x5D, 0x12)
#define REG_BKF05D_12_H      _PK_H_(0x5D, 0x12)
#define REG_BKF05D_13_L      _PK_L_(0x5D, 0x13)
#define REG_BKF05D_13_H      _PK_H_(0x5D, 0x13)
#define REG_BKF05D_14_L      _PK_L_(0x5D, 0x14)
#define REG_BKF05D_14_H      _PK_H_(0x5D, 0x14)
#define REG_BKF05D_15_L      _PK_L_(0x5D, 0x15)
#define REG_BKF05D_15_H      _PK_H_(0x5D, 0x15)
#define REG_BKF05D_16_L      _PK_L_(0x5D, 0x16)
#define REG_BKF05D_16_H      _PK_H_(0x5D, 0x16)
#define REG_BKF05D_17_L      _PK_L_(0x5D, 0x17)
#define REG_BKF05D_17_H      _PK_H_(0x5D, 0x17)
#define REG_BKF05D_18_L      _PK_L_(0x5D, 0x18)
#define REG_BKF05D_18_H      _PK_H_(0x5D, 0x18)
#define REG_BKF05D_19_L      _PK_L_(0x5D, 0x19)
#define REG_BKF05D_19_H      _PK_H_(0x5D, 0x19)
#define REG_BKF05D_1A_L      _PK_L_(0x5D, 0x1A)
#define REG_BKF05D_1A_H      _PK_H_(0x5D, 0x1A)
#define REG_BKF05D_1B_L      _PK_L_(0x5D, 0x1B)
#define REG_BKF05D_1B_H      _PK_H_(0x5D, 0x1B)
#define REG_BKF05D_1C_L      _PK_L_(0x5D, 0x1C)
#define REG_BKF05D_1C_H      _PK_H_(0x5D, 0x1C)
#define REG_BKF05D_1D_L      _PK_L_(0x5D, 0x1D)
#define REG_BKF05D_1D_H      _PK_H_(0x5D, 0x1D)
#define REG_BKF05D_1E_L      _PK_L_(0x5D, 0x1E)
#define REG_BKF05D_1E_H      _PK_H_(0x5D, 0x1E)
#define REG_BKF05D_1F_L      _PK_L_(0x5D, 0x1F)
#define REG_BKF05D_1F_H      _PK_H_(0x5D, 0x1F)
#define REG_BKF05D_20_L      _PK_L_(0x5D, 0x20)
#define REG_BKF05D_20_H      _PK_H_(0x5D, 0x20)
#define REG_BKF05D_21_L      _PK_L_(0x5D, 0x21)
#define REG_BKF05D_21_H      _PK_H_(0x5D, 0x21)
#define REG_BKF05D_22_L      _PK_L_(0x5D, 0x22)
#define REG_BKF05D_22_H      _PK_H_(0x5D, 0x22)
#define REG_BKF05D_23_L      _PK_L_(0x5D, 0x23)
#define REG_BKF05D_23_H      _PK_H_(0x5D, 0x23)
#define REG_BKF05D_24_L      _PK_L_(0x5D, 0x24)
#define REG_BKF05D_24_H      _PK_H_(0x5D, 0x24)
#define REG_BKF05D_25_L      _PK_L_(0x5D, 0x25)
#define REG_BKF05D_25_H      _PK_H_(0x5D, 0x25)
#define REG_BKF05D_26_L      _PK_L_(0x5D, 0x26)
#define REG_BKF05D_26_H      _PK_H_(0x5D, 0x26)
#define REG_BKF05D_27_L      _PK_L_(0x5D, 0x27)
#define REG_BKF05D_27_H      _PK_H_(0x5D, 0x27)
#define REG_BKF05D_28_L      _PK_L_(0x5D, 0x28)
#define REG_BKF05D_28_H      _PK_H_(0x5D, 0x28)
#define REG_BKF05D_29_L      _PK_L_(0x5D, 0x29)
#define REG_BKF05D_29_H      _PK_H_(0x5D, 0x29)
#define REG_BKF05D_2A_L      _PK_L_(0x5D, 0x2A)
#define REG_BKF05D_2A_H      _PK_H_(0x5D, 0x2A)
#define REG_BKF05D_2B_L      _PK_L_(0x5D, 0x2B)
#define REG_BKF05D_2B_H      _PK_H_(0x5D, 0x2B)
#define REG_BKF05D_2C_L      _PK_L_(0x5D, 0x2C)
#define REG_BKF05D_2C_H      _PK_H_(0x5D, 0x2C)
#define REG_BKF05D_2D_L      _PK_L_(0x5D, 0x2D)
#define REG_BKF05D_2D_H      _PK_H_(0x5D, 0x2D)
#define REG_BKF05D_2E_L      _PK_L_(0x5D, 0x2E)
#define REG_BKF05D_2E_H      _PK_H_(0x5D, 0x2E)
#define REG_BKF05D_2F_L      _PK_L_(0x5D, 0x2F)
#define REG_BKF05D_2F_H      _PK_H_(0x5D, 0x2F)
#define REG_BKF05D_30_L      _PK_L_(0x5D, 0x30)
#define REG_BKF05D_30_H      _PK_H_(0x5D, 0x30)
#define REG_BKF05D_31_L      _PK_L_(0x5D, 0x31)
#define REG_BKF05D_31_H      _PK_H_(0x5D, 0x31)
#define REG_BKF05D_32_L      _PK_L_(0x5D, 0x32)
#define REG_BKF05D_32_H      _PK_H_(0x5D, 0x32)
#define REG_BKF05D_33_L      _PK_L_(0x5D, 0x33)
#define REG_BKF05D_33_H      _PK_H_(0x5D, 0x33)
#define REG_BKF05D_34_L      _PK_L_(0x5D, 0x34)
#define REG_BKF05D_34_H      _PK_H_(0x5D, 0x34)
#define REG_BKF05D_35_L      _PK_L_(0x5D, 0x35)
#define REG_BKF05D_35_H      _PK_H_(0x5D, 0x35)
#define REG_BKF05D_36_L      _PK_L_(0x5D, 0x36)
#define REG_BKF05D_36_H      _PK_H_(0x5D, 0x36)
#define REG_BKF05D_37_L      _PK_L_(0x5D, 0x37)
#define REG_BKF05D_37_H      _PK_H_(0x5D, 0x37)
#define REG_BKF05D_38_L      _PK_L_(0x5D, 0x38)
#define REG_BKF05D_38_H      _PK_H_(0x5D, 0x38)
#define REG_BKF05D_39_L      _PK_L_(0x5D, 0x39)
#define REG_BKF05D_39_H      _PK_H_(0x5D, 0x39)
#define REG_BKF05D_3A_L      _PK_L_(0x5D, 0x3A)
#define REG_BKF05D_3A_H      _PK_H_(0x5D, 0x3A)
#define REG_BKF05D_3B_L      _PK_L_(0x5D, 0x3B)
#define REG_BKF05D_3B_H      _PK_H_(0x5D, 0x3B)
#define REG_BKF05D_3C_L      _PK_L_(0x5D, 0x3C)
#define REG_BKF05D_3C_H      _PK_H_(0x5D, 0x3C)
#define REG_BKF05D_3D_L      _PK_L_(0x5D, 0x3D)
#define REG_BKF05D_3D_H      _PK_H_(0x5D, 0x3D)
#define REG_BKF05D_3E_L      _PK_L_(0x5D, 0x3E)
#define REG_BKF05D_3E_H      _PK_H_(0x5D, 0x3E)
#define REG_BKF05D_3F_L      _PK_L_(0x5D, 0x3F)
#define REG_BKF05D_3F_H      _PK_H_(0x5D, 0x3F)
#define REG_BKF05D_40_L      _PK_L_(0x5D, 0x40)
#define REG_BKF05D_40_H      _PK_H_(0x5D, 0x40)
#define REG_BKF05D_41_L      _PK_L_(0x5D, 0x41)
#define REG_BKF05D_41_H      _PK_H_(0x5D, 0x41)
#define REG_BKF05D_42_L      _PK_L_(0x5D, 0x42)
#define REG_BKF05D_42_H      _PK_H_(0x5D, 0x42)
#define REG_BKF05D_43_L      _PK_L_(0x5D, 0x43)
#define REG_BKF05D_43_H      _PK_H_(0x5D, 0x43)
#define REG_BKF05D_44_L      _PK_L_(0x5D, 0x44)
#define REG_BKF05D_44_H      _PK_H_(0x5D, 0x44)
#define REG_BKF05D_45_L      _PK_L_(0x5D, 0x45)
#define REG_BKF05D_45_H      _PK_H_(0x5D, 0x45)
#define REG_BKF05D_46_L      _PK_L_(0x5D, 0x46)
#define REG_BKF05D_46_H      _PK_H_(0x5D, 0x46)
#define REG_BKF05D_47_L      _PK_L_(0x5D, 0x47)
#define REG_BKF05D_47_H      _PK_H_(0x5D, 0x47)
#define REG_BKF05D_48_L      _PK_L_(0x5D, 0x48)
#define REG_BKF05D_48_H      _PK_H_(0x5D, 0x48)
#define REG_BKF05D_49_L      _PK_L_(0x5D, 0x49)
#define REG_BKF05D_49_H      _PK_H_(0x5D, 0x49)
#define REG_BKF05D_4A_L      _PK_L_(0x5D, 0x4A)
#define REG_BKF05D_4A_H      _PK_H_(0x5D, 0x4A)
#define REG_BKF05D_4B_L      _PK_L_(0x5D, 0x4B)
#define REG_BKF05D_4B_H      _PK_H_(0x5D, 0x4B)
#define REG_BKF05D_4C_L      _PK_L_(0x5D, 0x4C)
#define REG_BKF05D_4C_H      _PK_H_(0x5D, 0x4C)
#define REG_BKF05D_4D_L      _PK_L_(0x5D, 0x4D)
#define REG_BKF05D_4D_H      _PK_H_(0x5D, 0x4D)
#define REG_BKF05D_4E_L      _PK_L_(0x5D, 0x4E)
#define REG_BKF05D_4E_H      _PK_H_(0x5D, 0x4E)
#define REG_BKF05D_4F_L      _PK_L_(0x5D, 0x4F)
#define REG_BKF05D_4F_H      _PK_H_(0x5D, 0x4F)
#define REG_BKF05D_50_L      _PK_L_(0x5D, 0x50)
#define REG_BKF05D_50_H      _PK_H_(0x5D, 0x50)
#define REG_BKF05D_51_L      _PK_L_(0x5D, 0x51)
#define REG_BKF05D_51_H      _PK_H_(0x5D, 0x51)
#define REG_BKF05D_52_L      _PK_L_(0x5D, 0x52)
#define REG_BKF05D_52_H      _PK_H_(0x5D, 0x52)
#define REG_BKF05D_53_L      _PK_L_(0x5D, 0x53)
#define REG_BKF05D_53_H      _PK_H_(0x5D, 0x53)
#define REG_BKF05D_54_L      _PK_L_(0x5D, 0x54)
#define REG_BKF05D_54_H      _PK_H_(0x5D, 0x54)
#define REG_BKF05D_55_L      _PK_L_(0x5D, 0x55)
#define REG_BKF05D_55_H      _PK_H_(0x5D, 0x55)
#define REG_BKF05D_56_L      _PK_L_(0x5D, 0x56)
#define REG_BKF05D_56_H      _PK_H_(0x5D, 0x56)
#define REG_BKF05D_57_L      _PK_L_(0x5D, 0x57)
#define REG_BKF05D_57_H      _PK_H_(0x5D, 0x57)
#define REG_BKF05D_58_L      _PK_L_(0x5D, 0x58)
#define REG_BKF05D_58_H      _PK_H_(0x5D, 0x58)
#define REG_BKF05D_59_L      _PK_L_(0x5D, 0x59)
#define REG_BKF05D_59_H      _PK_H_(0x5D, 0x59)
#define REG_BKF05D_5A_L      _PK_L_(0x5D, 0x5A)
#define REG_BKF05D_5A_H      _PK_H_(0x5D, 0x5A)
#define REG_BKF05D_5B_L      _PK_L_(0x5D, 0x5B)
#define REG_BKF05D_5B_H      _PK_H_(0x5D, 0x5B)
#define REG_BKF05D_5C_L      _PK_L_(0x5D, 0x5C)
#define REG_BKF05D_5C_H      _PK_H_(0x5D, 0x5C)
#define REG_BKF05D_5D_L      _PK_L_(0x5D, 0x5D)
#define REG_BKF05D_5D_H      _PK_H_(0x5D, 0x5D)
#define REG_BKF05D_5E_L      _PK_L_(0x5D, 0x5E)
#define REG_BKF05D_5E_H      _PK_H_(0x5D, 0x5E)
#define REG_BKF05D_5F_L      _PK_L_(0x5D, 0x5F)
#define REG_BKF05D_5F_H      _PK_H_(0x5D, 0x5F)
#define REG_BKF05D_60_L      _PK_L_(0x5D, 0x60)
#define REG_BKF05D_60_H      _PK_H_(0x5D, 0x60)
#define REG_BKF05D_61_L      _PK_L_(0x5D, 0x61)
#define REG_BKF05D_61_H      _PK_H_(0x5D, 0x61)
#define REG_BKF05D_62_L      _PK_L_(0x5D, 0x62)
#define REG_BKF05D_62_H      _PK_H_(0x5D, 0x62)
#define REG_BKF05D_63_L      _PK_L_(0x5D, 0x63)
#define REG_BKF05D_63_H      _PK_H_(0x5D, 0x63)
#define REG_BKF05D_64_L      _PK_L_(0x5D, 0x64)
#define REG_BKF05D_64_H      _PK_H_(0x5D, 0x64)
#define REG_BKF05D_65_L      _PK_L_(0x5D, 0x65)
#define REG_BKF05D_65_H      _PK_H_(0x5D, 0x65)
#define REG_BKF05D_66_L      _PK_L_(0x5D, 0x66)
#define REG_BKF05D_66_H      _PK_H_(0x5D, 0x66)
#define REG_BKF05D_67_L      _PK_L_(0x5D, 0x67)
#define REG_BKF05D_67_H      _PK_H_(0x5D, 0x67)
#define REG_BKF05D_68_L      _PK_L_(0x5D, 0x68)
#define REG_BKF05D_68_H      _PK_H_(0x5D, 0x68)
#define REG_BKF05D_69_L      _PK_L_(0x5D, 0x69)
#define REG_BKF05D_69_H      _PK_H_(0x5D, 0x69)
#define REG_BKF05D_6A_L      _PK_L_(0x5D, 0x6A)
#define REG_BKF05D_6A_H      _PK_H_(0x5D, 0x6A)
#define REG_BKF05D_6B_L      _PK_L_(0x5D, 0x6B)
#define REG_BKF05D_6B_H      _PK_H_(0x5D, 0x6B)
#define REG_BKF05D_6C_L      _PK_L_(0x5D, 0x6C)
#define REG_BKF05D_6C_H      _PK_H_(0x5D, 0x6C)
#define REG_BKF05D_6D_L      _PK_L_(0x5D, 0x6D)
#define REG_BKF05D_6D_H      _PK_H_(0x5D, 0x6D)
#define REG_BKF05D_6E_L      _PK_L_(0x5D, 0x6E)
#define REG_BKF05D_6E_H      _PK_H_(0x5D, 0x6E)
#define REG_BKF05D_6F_L      _PK_L_(0x5D, 0x6F)
#define REG_BKF05D_6F_H      _PK_H_(0x5D, 0x6F)
#define REG_BKF05D_70_L      _PK_L_(0x5D, 0x70)
#define REG_BKF05D_70_H      _PK_H_(0x5D, 0x70)
#define REG_BKF05D_71_L      _PK_L_(0x5D, 0x71)
#define REG_BKF05D_71_H      _PK_H_(0x5D, 0x71)
#define REG_BKF05D_72_L      _PK_L_(0x5D, 0x72)
#define REG_BKF05D_72_H      _PK_H_(0x5D, 0x72)
#define REG_BKF05D_73_L      _PK_L_(0x5D, 0x73)
#define REG_BKF05D_73_H      _PK_H_(0x5D, 0x73)
#define REG_BKF05D_74_L      _PK_L_(0x5D, 0x74)
#define REG_BKF05D_74_H      _PK_H_(0x5D, 0x74)
#define REG_BKF05D_75_L      _PK_L_(0x5D, 0x75)
#define REG_BKF05D_75_H      _PK_H_(0x5D, 0x75)
#define REG_BKF05D_76_L      _PK_L_(0x5D, 0x76)
#define REG_BKF05D_76_H      _PK_H_(0x5D, 0x76)
#define REG_BKF05D_77_L      _PK_L_(0x5D, 0x77)
#define REG_BKF05D_77_H      _PK_H_(0x5D, 0x77)
#define REG_BKF05D_78_L      _PK_L_(0x5D, 0x78)
#define REG_BKF05D_78_H      _PK_H_(0x5D, 0x78)
#define REG_BKF05D_79_L      _PK_L_(0x5D, 0x79)
#define REG_BKF05D_79_H      _PK_H_(0x5D, 0x79)
#define REG_BKF05D_7A_L      _PK_L_(0x5D, 0x7A)
#define REG_BKF05D_7A_H      _PK_H_(0x5D, 0x7A)
#define REG_BKF05D_7B_L      _PK_L_(0x5D, 0x7B)
#define REG_BKF05D_7B_H      _PK_H_(0x5D, 0x7B)
#define REG_BKF05D_7C_L      _PK_L_(0x5D, 0x7C)
#define REG_BKF05D_7C_H      _PK_H_(0x5D, 0x7C)
#define REG_BKF05D_7D_L      _PK_L_(0x5D, 0x7D)
#define REG_BKF05D_7D_H      _PK_H_(0x5D, 0x7D)
#define REG_BKF05D_7E_L      _PK_L_(0x5D, 0x7E)
#define REG_BKF05D_7E_H      _PK_H_(0x5D, 0x7E)
#define REG_BKF05D_7F_L      _PK_L_(0x5D, 0x7F)
#define REG_BKF05D_7F_H      _PK_H_(0x5D, 0x7F)
//----------------------------------------------
#define REG_BKF06A_00_L      _PK_L_(0x6A, 0x00)
#define REG_BKF06A_00_H      _PK_H_(0x6A, 0x00)
#define REG_BKF06A_01_L      _PK_L_(0x6A, 0x01)
#define REG_BKF06A_01_H      _PK_H_(0x6A, 0x01)
#define REG_BKF06A_02_L      _PK_L_(0x6A, 0x02)
#define REG_BKF06A_02_H      _PK_H_(0x6A, 0x02)
#define REG_BKF06A_03_L      _PK_L_(0x6A, 0x03)
#define REG_BKF06A_03_H      _PK_H_(0x6A, 0x03)
#define REG_BKF06A_04_L      _PK_L_(0x6A, 0x04)
#define REG_BKF06A_04_H      _PK_H_(0x6A, 0x04)
#define REG_BKF06A_05_L      _PK_L_(0x6A, 0x05)
#define REG_BKF06A_05_H      _PK_H_(0x6A, 0x05)
#define REG_BKF06A_06_L      _PK_L_(0x6A, 0x06)
#define REG_BKF06A_06_H      _PK_H_(0x6A, 0x06)
#define REG_BKF06A_07_L      _PK_L_(0x6A, 0x07)
#define REG_BKF06A_07_H      _PK_H_(0x6A, 0x07)
#define REG_BKF06A_08_L      _PK_L_(0x6A, 0x08)
#define REG_BKF06A_08_H      _PK_H_(0x6A, 0x08)
#define REG_BKF06A_09_L      _PK_L_(0x6A, 0x09)
#define REG_BKF06A_09_H      _PK_H_(0x6A, 0x09)
#define REG_BKF06A_0A_L      _PK_L_(0x6A, 0x0A)
#define REG_BKF06A_0A_H      _PK_H_(0x6A, 0x0A)
#define REG_BKF06A_0B_L      _PK_L_(0x6A, 0x0B)
#define REG_BKF06A_0B_H      _PK_H_(0x6A, 0x0B)
#define REG_BKF06A_0C_L      _PK_L_(0x6A, 0x0C)
#define REG_BKF06A_0C_H      _PK_H_(0x6A, 0x0C)
#define REG_BKF06A_0D_L      _PK_L_(0x6A, 0x0D)
#define REG_BKF06A_0D_H      _PK_H_(0x6A, 0x0D)
#define REG_BKF06A_0E_L      _PK_L_(0x6A, 0x0E)
#define REG_BKF06A_0E_H      _PK_H_(0x6A, 0x0E)
#define REG_BKF06A_0F_L      _PK_L_(0x6A, 0x0F)
#define REG_BKF06A_0F_H      _PK_H_(0x6A, 0x0F)
#define REG_BKF06A_10_L      _PK_L_(0x6A, 0x10)
#define REG_BKF06A_10_H      _PK_H_(0x6A, 0x10)
#define REG_BKF06A_11_L      _PK_L_(0x6A, 0x11)
#define REG_BKF06A_11_H      _PK_H_(0x6A, 0x11)
#define REG_BKF06A_12_L      _PK_L_(0x6A, 0x12)
#define REG_BKF06A_12_H      _PK_H_(0x6A, 0x12)
#define REG_BKF06A_13_L      _PK_L_(0x6A, 0x13)
#define REG_BKF06A_13_H      _PK_H_(0x6A, 0x13)
#define REG_BKF06A_14_L      _PK_L_(0x6A, 0x14)
#define REG_BKF06A_14_H      _PK_H_(0x6A, 0x14)
#define REG_BKF06A_15_L      _PK_L_(0x6A, 0x15)
#define REG_BKF06A_15_H      _PK_H_(0x6A, 0x15)
#define REG_BKF06A_16_L      _PK_L_(0x6A, 0x16)
#define REG_BKF06A_16_H      _PK_H_(0x6A, 0x16)
#define REG_BKF06A_17_L      _PK_L_(0x6A, 0x17)
#define REG_BKF06A_17_H      _PK_H_(0x6A, 0x17)
#define REG_BKF06A_18_L      _PK_L_(0x6A, 0x18)
#define REG_BKF06A_18_H      _PK_H_(0x6A, 0x18)
#define REG_BKF06A_19_L      _PK_L_(0x6A, 0x19)
#define REG_BKF06A_19_H      _PK_H_(0x6A, 0x19)
#define REG_BKF06A_1A_L      _PK_L_(0x6A, 0x1A)
#define REG_BKF06A_1A_H      _PK_H_(0x6A, 0x1A)
#define REG_BKF06A_1B_L      _PK_L_(0x6A, 0x1B)
#define REG_BKF06A_1B_H      _PK_H_(0x6A, 0x1B)
#define REG_BKF06A_1C_L      _PK_L_(0x6A, 0x1C)
#define REG_BKF06A_1C_H      _PK_H_(0x6A, 0x1C)
#define REG_BKF06A_1D_L      _PK_L_(0x6A, 0x1D)
#define REG_BKF06A_1D_H      _PK_H_(0x6A, 0x1D)
#define REG_BKF06A_1E_L      _PK_L_(0x6A, 0x1E)
#define REG_BKF06A_1E_H      _PK_H_(0x6A, 0x1E)
#define REG_BKF06A_1F_L      _PK_L_(0x6A, 0x1F)
#define REG_BKF06A_1F_H      _PK_H_(0x6A, 0x1F)
#define REG_BKF06A_20_L      _PK_L_(0x6A, 0x20)
#define REG_BKF06A_20_H      _PK_H_(0x6A, 0x20)
#define REG_BKF06A_21_L      _PK_L_(0x6A, 0x21)
#define REG_BKF06A_21_H      _PK_H_(0x6A, 0x21)
#define REG_BKF06A_22_L      _PK_L_(0x6A, 0x22)
#define REG_BKF06A_22_H      _PK_H_(0x6A, 0x22)
#define REG_BKF06A_23_L      _PK_L_(0x6A, 0x23)
#define REG_BKF06A_23_H      _PK_H_(0x6A, 0x23)
#define REG_BKF06A_24_L      _PK_L_(0x6A, 0x24)
#define REG_BKF06A_24_H      _PK_H_(0x6A, 0x24)
#define REG_BKF06A_25_L      _PK_L_(0x6A, 0x25)
#define REG_BKF06A_25_H      _PK_H_(0x6A, 0x25)
#define REG_BKF06A_26_L      _PK_L_(0x6A, 0x26)
#define REG_BKF06A_26_H      _PK_H_(0x6A, 0x26)
#define REG_BKF06A_27_L      _PK_L_(0x6A, 0x27)
#define REG_BKF06A_27_H      _PK_H_(0x6A, 0x27)
#define REG_BKF06A_28_L      _PK_L_(0x6A, 0x28)
#define REG_BKF06A_28_H      _PK_H_(0x6A, 0x28)
#define REG_BKF06A_29_L      _PK_L_(0x6A, 0x29)
#define REG_BKF06A_29_H      _PK_H_(0x6A, 0x29)
#define REG_BKF06A_2A_L      _PK_L_(0x6A, 0x2A)
#define REG_BKF06A_2A_H      _PK_H_(0x6A, 0x2A)
#define REG_BKF06A_2B_L      _PK_L_(0x6A, 0x2B)
#define REG_BKF06A_2B_H      _PK_H_(0x6A, 0x2B)
#define REG_BKF06A_2C_L      _PK_L_(0x6A, 0x2C)
#define REG_BKF06A_2C_H      _PK_H_(0x6A, 0x2C)
#define REG_BKF06A_2D_L      _PK_L_(0x6A, 0x2D)
#define REG_BKF06A_2D_H      _PK_H_(0x6A, 0x2D)
#define REG_BKF06A_2E_L      _PK_L_(0x6A, 0x2E)
#define REG_BKF06A_2E_H      _PK_H_(0x6A, 0x2E)
#define REG_BKF06A_2F_L      _PK_L_(0x6A, 0x2F)
#define REG_BKF06A_2F_H      _PK_H_(0x6A, 0x2F)
#define REG_BKF06A_30_L      _PK_L_(0x6A, 0x30)
#define REG_BKF06A_30_H      _PK_H_(0x6A, 0x30)
#define REG_BKF06A_31_L      _PK_L_(0x6A, 0x31)
#define REG_BKF06A_31_H      _PK_H_(0x6A, 0x31)
#define REG_BKF06A_32_L      _PK_L_(0x6A, 0x32)
#define REG_BKF06A_32_H      _PK_H_(0x6A, 0x32)
#define REG_BKF06A_33_L      _PK_L_(0x6A, 0x33)
#define REG_BKF06A_33_H      _PK_H_(0x6A, 0x33)
#define REG_BKF06A_34_L      _PK_L_(0x6A, 0x34)
#define REG_BKF06A_34_H      _PK_H_(0x6A, 0x34)
#define REG_BKF06A_35_L      _PK_L_(0x6A, 0x35)
#define REG_BKF06A_35_H      _PK_H_(0x6A, 0x35)
#define REG_BKF06A_36_L      _PK_L_(0x6A, 0x36)
#define REG_BKF06A_36_H      _PK_H_(0x6A, 0x36)
#define REG_BKF06A_37_L      _PK_L_(0x6A, 0x37)
#define REG_BKF06A_37_H      _PK_H_(0x6A, 0x37)
#define REG_BKF06A_38_L      _PK_L_(0x6A, 0x38)
#define REG_BKF06A_38_H      _PK_H_(0x6A, 0x38)
#define REG_BKF06A_39_L      _PK_L_(0x6A, 0x39)
#define REG_BKF06A_39_H      _PK_H_(0x6A, 0x39)
#define REG_BKF06A_3A_L      _PK_L_(0x6A, 0x3A)
#define REG_BKF06A_3A_H      _PK_H_(0x6A, 0x3A)
#define REG_BKF06A_3B_L      _PK_L_(0x6A, 0x3B)
#define REG_BKF06A_3B_H      _PK_H_(0x6A, 0x3B)
#define REG_BKF06A_3C_L      _PK_L_(0x6A, 0x3C)
#define REG_BKF06A_3C_H      _PK_H_(0x6A, 0x3C)
#define REG_BKF06A_3D_L      _PK_L_(0x6A, 0x3D)
#define REG_BKF06A_3D_H      _PK_H_(0x6A, 0x3D)
#define REG_BKF06A_3E_L      _PK_L_(0x6A, 0x3E)
#define REG_BKF06A_3E_H      _PK_H_(0x6A, 0x3E)
#define REG_BKF06A_3F_L      _PK_L_(0x6A, 0x3F)
#define REG_BKF06A_3F_H      _PK_H_(0x6A, 0x3F)
#define REG_BKF06A_40_L      _PK_L_(0x6A, 0x40)
#define REG_BKF06A_40_H      _PK_H_(0x6A, 0x40)
#define REG_BKF06A_41_L      _PK_L_(0x6A, 0x41)
#define REG_BKF06A_41_H      _PK_H_(0x6A, 0x41)
#define REG_BKF06A_42_L      _PK_L_(0x6A, 0x42)
#define REG_BKF06A_42_H      _PK_H_(0x6A, 0x42)
#define REG_BKF06A_43_L      _PK_L_(0x6A, 0x43)
#define REG_BKF06A_43_H      _PK_H_(0x6A, 0x43)
#define REG_BKF06A_44_L      _PK_L_(0x6A, 0x44)
#define REG_BKF06A_44_H      _PK_H_(0x6A, 0x44)
#define REG_BKF06A_45_L      _PK_L_(0x6A, 0x45)
#define REG_BKF06A_45_H      _PK_H_(0x6A, 0x45)
#define REG_BKF06A_46_L      _PK_L_(0x6A, 0x46)
#define REG_BKF06A_46_H      _PK_H_(0x6A, 0x46)
#define REG_BKF06A_47_L      _PK_L_(0x6A, 0x47)
#define REG_BKF06A_47_H      _PK_H_(0x6A, 0x47)
#define REG_BKF06A_48_L      _PK_L_(0x6A, 0x48)
#define REG_BKF06A_48_H      _PK_H_(0x6A, 0x48)
#define REG_BKF06A_49_L      _PK_L_(0x6A, 0x49)
#define REG_BKF06A_49_H      _PK_H_(0x6A, 0x49)
#define REG_BKF06A_4A_L      _PK_L_(0x6A, 0x4A)
#define REG_BKF06A_4A_H      _PK_H_(0x6A, 0x4A)
#define REG_BKF06A_4B_L      _PK_L_(0x6A, 0x4B)
#define REG_BKF06A_4B_H      _PK_H_(0x6A, 0x4B)
#define REG_BKF06A_4C_L      _PK_L_(0x6A, 0x4C)
#define REG_BKF06A_4C_H      _PK_H_(0x6A, 0x4C)
#define REG_BKF06A_4D_L      _PK_L_(0x6A, 0x4D)
#define REG_BKF06A_4D_H      _PK_H_(0x6A, 0x4D)
#define REG_BKF06A_4E_L      _PK_L_(0x6A, 0x4E)
#define REG_BKF06A_4E_H      _PK_H_(0x6A, 0x4E)
#define REG_BKF06A_4F_L      _PK_L_(0x6A, 0x4F)
#define REG_BKF06A_4F_H      _PK_H_(0x6A, 0x4F)
#define REG_BKF06A_50_L      _PK_L_(0x6A, 0x50)
#define REG_BKF06A_50_H      _PK_H_(0x6A, 0x50)
#define REG_BKF06A_51_L      _PK_L_(0x6A, 0x51)
#define REG_BKF06A_51_H      _PK_H_(0x6A, 0x51)
#define REG_BKF06A_52_L      _PK_L_(0x6A, 0x52)
#define REG_BKF06A_52_H      _PK_H_(0x6A, 0x52)
#define REG_BKF06A_53_L      _PK_L_(0x6A, 0x53)
#define REG_BKF06A_53_H      _PK_H_(0x6A, 0x53)
#define REG_BKF06A_54_L      _PK_L_(0x6A, 0x54)
#define REG_BKF06A_54_H      _PK_H_(0x6A, 0x54)
#define REG_BKF06A_55_L      _PK_L_(0x6A, 0x55)
#define REG_BKF06A_55_H      _PK_H_(0x6A, 0x55)
#define REG_BKF06A_56_L      _PK_L_(0x6A, 0x56)
#define REG_BKF06A_56_H      _PK_H_(0x6A, 0x56)
#define REG_BKF06A_57_L      _PK_L_(0x6A, 0x57)
#define REG_BKF06A_57_H      _PK_H_(0x6A, 0x57)
#define REG_BKF06A_58_L      _PK_L_(0x6A, 0x58)
#define REG_BKF06A_58_H      _PK_H_(0x6A, 0x58)
#define REG_BKF06A_59_L      _PK_L_(0x6A, 0x59)
#define REG_BKF06A_59_H      _PK_H_(0x6A, 0x59)
#define REG_BKF06A_5A_L      _PK_L_(0x6A, 0x5A)
#define REG_BKF06A_5A_H      _PK_H_(0x6A, 0x5A)
#define REG_BKF06A_5B_L      _PK_L_(0x6A, 0x5B)
#define REG_BKF06A_5B_H      _PK_H_(0x6A, 0x5B)
#define REG_BKF06A_5C_L      _PK_L_(0x6A, 0x5C)
#define REG_BKF06A_5C_H      _PK_H_(0x6A, 0x5C)
#define REG_BKF06A_5D_L      _PK_L_(0x6A, 0x5D)
#define REG_BKF06A_5D_H      _PK_H_(0x6A, 0x5D)
#define REG_BKF06A_5E_L      _PK_L_(0x6A, 0x5E)
#define REG_BKF06A_5E_H      _PK_H_(0x6A, 0x5E)
#define REG_BKF06A_5F_L      _PK_L_(0x6A, 0x5F)
#define REG_BKF06A_5F_H      _PK_H_(0x6A, 0x5F)
#define REG_BKF06A_60_L      _PK_L_(0x6A, 0x60)
#define REG_BKF06A_60_H      _PK_H_(0x6A, 0x60)
#define REG_BKF06A_61_L      _PK_L_(0x6A, 0x61)
#define REG_BKF06A_61_H      _PK_H_(0x6A, 0x61)
#define REG_BKF06A_62_L      _PK_L_(0x6A, 0x62)
#define REG_BKF06A_62_H      _PK_H_(0x6A, 0x62)
#define REG_BKF06A_63_L      _PK_L_(0x6A, 0x63)
#define REG_BKF06A_63_H      _PK_H_(0x6A, 0x63)
#define REG_BKF06A_64_L      _PK_L_(0x6A, 0x64)
#define REG_BKF06A_64_H      _PK_H_(0x6A, 0x64)
#define REG_BKF06A_65_L      _PK_L_(0x6A, 0x65)
#define REG_BKF06A_65_H      _PK_H_(0x6A, 0x65)
#define REG_BKF06A_66_L      _PK_L_(0x6A, 0x66)
#define REG_BKF06A_66_H      _PK_H_(0x6A, 0x66)
#define REG_BKF06A_67_L      _PK_L_(0x6A, 0x67)
#define REG_BKF06A_67_H      _PK_H_(0x6A, 0x67)
#define REG_BKF06A_68_L      _PK_L_(0x6A, 0x68)
#define REG_BKF06A_68_H      _PK_H_(0x6A, 0x68)
#define REG_BKF06A_69_L      _PK_L_(0x6A, 0x69)
#define REG_BKF06A_69_H      _PK_H_(0x6A, 0x69)
#define REG_BKF06A_6A_L      _PK_L_(0x6A, 0x6A)
#define REG_BKF06A_6A_H      _PK_H_(0x6A, 0x6A)
#define REG_BKF06A_6B_L      _PK_L_(0x6A, 0x6B)
#define REG_BKF06A_6B_H      _PK_H_(0x6A, 0x6B)
#define REG_BKF06A_6C_L      _PK_L_(0x6A, 0x6C)
#define REG_BKF06A_6C_H      _PK_H_(0x6A, 0x6C)
#define REG_BKF06A_6D_L      _PK_L_(0x6A, 0x6D)
#define REG_BKF06A_6D_H      _PK_H_(0x6A, 0x6D)
#define REG_BKF06A_6E_L      _PK_L_(0x6A, 0x6E)
#define REG_BKF06A_6E_H      _PK_H_(0x6A, 0x6E)
#define REG_BKF06A_6F_L      _PK_L_(0x6A, 0x6F)
#define REG_BKF06A_6F_H      _PK_H_(0x6A, 0x6F)
#define REG_BKF06A_70_L      _PK_L_(0x6A, 0x70)
#define REG_BKF06A_70_H      _PK_H_(0x6A, 0x70)
#define REG_BKF06A_71_L      _PK_L_(0x6A, 0x71)
#define REG_BKF06A_71_H      _PK_H_(0x6A, 0x71)
#define REG_BKF06A_72_L      _PK_L_(0x6A, 0x72)
#define REG_BKF06A_72_H      _PK_H_(0x6A, 0x72)
#define REG_BKF06A_73_L      _PK_L_(0x6A, 0x73)
#define REG_BKF06A_73_H      _PK_H_(0x6A, 0x73)
#define REG_BKF06A_74_L      _PK_L_(0x6A, 0x74)
#define REG_BKF06A_74_H      _PK_H_(0x6A, 0x74)
#define REG_BKF06A_75_L      _PK_L_(0x6A, 0x75)
#define REG_BKF06A_75_H      _PK_H_(0x6A, 0x75)
#define REG_BKF06A_76_L      _PK_L_(0x6A, 0x76)
#define REG_BKF06A_76_H      _PK_H_(0x6A, 0x76)
#define REG_BKF06A_77_L      _PK_L_(0x6A, 0x77)
#define REG_BKF06A_77_H      _PK_H_(0x6A, 0x77)
#define REG_BKF06A_78_L      _PK_L_(0x6A, 0x78)
#define REG_BKF06A_78_H      _PK_H_(0x6A, 0x78)
#define REG_BKF06A_79_L      _PK_L_(0x6A, 0x79)
#define REG_BKF06A_79_H      _PK_H_(0x6A, 0x79)
#define REG_BKF06A_7A_L      _PK_L_(0x6A, 0x7A)
#define REG_BKF06A_7A_H      _PK_H_(0x6A, 0x7A)
#define REG_BKF06A_7B_L      _PK_L_(0x6A, 0x7B)
#define REG_BKF06A_7B_H      _PK_H_(0x6A, 0x7B)
#define REG_BKF06A_7C_L      _PK_L_(0x6A, 0x7C)
#define REG_BKF06A_7C_H      _PK_H_(0x6A, 0x7C)
#define REG_BKF06A_7D_L      _PK_L_(0x6A, 0x7D)
#define REG_BKF06A_7D_H      _PK_H_(0x6A, 0x7D)
#define REG_BKF06A_7E_L      _PK_L_(0x6A, 0x7E)
#define REG_BKF06A_7E_H      _PK_H_(0x6A, 0x7E)
#define REG_BKF06A_7F_L      _PK_L_(0x6A, 0x7F)
#define REG_BKF06A_7F_H      _PK_H_(0x6A, 0x7F)
//----------------------------------------------
#define REG_FSC_BK132_4A_L      0x413294
#define REG_VR_BK05_06_L     _PK_L_(0x05,0x06)
#define REG_VR_BK09_09_L    _PK_L_(0x09,0x09)
#define REG_VR_BK09_09_H    _PK_H_(0x09,0x09)
#define REG_VR_BK09_0A_L    _PK_L_(0x09,0x0A)
#define REG_VR_BK09_0A_H    _PK_H_(0x09,0x0A)
#define REG_VR_BK09_0B_L    _PK_L_(0x09,0x0B)
#define REG_VR_BK09_0B_H    _PK_H_(0x09,0x0B)
#define REG_VR_BK09_0C_L    _PK_L_(0x09,0x0C)
#define REG_VR_BK09_0C_H    _PK_H_(0x09,0x0C)
#endif
