//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef _HWREG_SC_H_
#define _HWREG_SC_H_

#include "MsCommon.h"

#define _PK_L_(bank, addr)   (((MS_U16)(bank) << 8) | (MS_U16)((addr)*2))
#define _PK_H_(bank, addr)   (((MS_U16)(bank) << 8) | (MS_U16)((addr)*2+1))

#define REG_TABLE_END      0xFFFF

//=============================================================

//----------------------------------------------
//  BK5D:
//----------------------------------------------
#define REG_SC_BK5D_61_L      _PK_L_(0x5D, 0x61)
#define REG_SC_BK5D_61_H      _PK_H_(0x5D, 0x61)
#define REG_SC_BK5D_62_L      _PK_L_(0x5D, 0x62)
#define REG_SC_BK5D_62_H      _PK_H_(0x5D, 0x62)
#define REG_SC_BK5D_63_L      _PK_L_(0x5D, 0x63)
#define REG_SC_BK5D_63_H      _PK_H_(0x5D, 0x63)
#define REG_SC_BK5D_64_L      _PK_L_(0x5D, 0x64)
#define REG_SC_BK5D_64_H      _PK_H_(0x5D, 0x64)
#define REG_SC_BK5D_65_L      _PK_L_(0x5D, 0x65)
#define REG_SC_BK5D_65_H      _PK_H_(0x5D, 0x65)
#define REG_SC_BK5D_66_L      _PK_L_(0x5D, 0x66)
#define REG_SC_BK5D_66_H      _PK_H_(0x5D, 0x66)
#define REG_SC_BK5D_67_L      _PK_L_(0x5D, 0x67)
#define REG_SC_BK5D_67_H      _PK_H_(0x5D, 0x67)
#define REG_SC_BK5D_68_L      _PK_L_(0x5D, 0x68)
#define REG_SC_BK5D_68_H      _PK_H_(0x5D, 0x68)
#define REG_SC_BK5D_69_L      _PK_L_(0x5D, 0x69)
//  BK00: GOPINT
//----------------------------------------------
#define REG_SC_BK00_00_L      _PK_L_(0x00, 0x00)
#define REG_SC_BK00_00_H      _PK_H_(0x00, 0x00)
#define REG_SC_BK00_01_L      _PK_L_(0x00, 0x01)
#define REG_SC_BK00_01_H      _PK_H_(0x00, 0x01)
#define REG_SC_BK00_02_L      _PK_L_(0x00, 0x02)
#define REG_SC_BK00_02_H      _PK_H_(0x00, 0x02)
#define REG_SC_BK00_03_L      _PK_L_(0x00, 0x03)
#define REG_SC_BK00_03_H      _PK_H_(0x00, 0x03)
#define REG_SC_BK00_04_L      _PK_L_(0x00, 0x04)
#define REG_SC_BK00_04_H      _PK_H_(0x00, 0x04)
#define REG_SC_BK00_05_L      _PK_L_(0x00, 0x05)
#define REG_SC_BK00_05_H      _PK_H_(0x00, 0x05)
#define REG_SC_BK00_06_L      _PK_L_(0x00, 0x06)
#define REG_SC_BK00_06_H      _PK_H_(0x00, 0x06)
#define REG_SC_BK00_07_L      _PK_L_(0x00, 0x07)
#define REG_SC_BK00_07_H      _PK_H_(0x00, 0x07)
#define REG_SC_BK00_08_L      _PK_L_(0x00, 0x08)
#define REG_SC_BK00_08_H      _PK_H_(0x00, 0x08)
#define REG_SC_BK00_09_L      _PK_L_(0x00, 0x09)
#define REG_SC_BK00_09_H      _PK_H_(0x00, 0x09)
#define REG_SC_BK00_0A_L      _PK_L_(0x00, 0x0A)
#define REG_SC_BK00_0A_H      _PK_H_(0x00, 0x0A)
#define REG_SC_BK00_0B_L      _PK_L_(0x00, 0x0B)
#define REG_SC_BK00_0B_H      _PK_H_(0x00, 0x0B)
#define REG_SC_BK00_0C_L      _PK_L_(0x00, 0x0C)
#define REG_SC_BK00_0C_H      _PK_H_(0x00, 0x0C)
#define REG_SC_BK00_0D_L      _PK_L_(0x00, 0x0D)
#define REG_SC_BK00_0D_H      _PK_H_(0x00, 0x0D)
#define REG_SC_BK00_0E_L      _PK_L_(0x00, 0x0E)
#define REG_SC_BK00_0E_H      _PK_H_(0x00, 0x0E)
#define REG_SC_BK00_0F_L      _PK_L_(0x00, 0x0F)
#define REG_SC_BK00_0F_H      _PK_H_(0x00, 0x0F)
#define REG_SC_BK00_10_L      _PK_L_(0x00, 0x10)
#define REG_SC_BK00_10_H      _PK_H_(0x00, 0x10)
#define REG_SC_BK00_11_L      _PK_L_(0x00, 0x11)
#define REG_SC_BK00_11_H      _PK_H_(0x00, 0x11)
#define REG_SC_BK00_12_L      _PK_L_(0x00, 0x12)
#define REG_SC_BK00_12_H      _PK_H_(0x00, 0x12)
#define REG_SC_BK00_13_L      _PK_L_(0x00, 0x13)
#define REG_SC_BK00_13_H      _PK_H_(0x00, 0x13)
#define REG_SC_BK00_14_L      _PK_L_(0x00, 0x14)
#define REG_SC_BK00_14_H      _PK_H_(0x00, 0x14)
#define REG_SC_BK00_15_L      _PK_L_(0x00, 0x15)
#define REG_SC_BK00_15_H      _PK_H_(0x00, 0x15)
#define REG_SC_BK00_16_L      _PK_L_(0x00, 0x16)
#define REG_SC_BK00_16_H      _PK_H_(0x00, 0x16)
#define REG_SC_BK00_17_L      _PK_L_(0x00, 0x17)
#define REG_SC_BK00_17_H      _PK_H_(0x00, 0x17)
#define REG_SC_BK00_18_L      _PK_L_(0x00, 0x18)
#define REG_SC_BK00_18_H      _PK_H_(0x00, 0x18)
#define REG_SC_BK00_19_L      _PK_L_(0x00, 0x19)
#define REG_SC_BK00_19_H      _PK_H_(0x00, 0x19)
#define REG_SC_BK00_1A_L      _PK_L_(0x00, 0x1A)
#define REG_SC_BK00_1A_H      _PK_H_(0x00, 0x1A)
#define REG_SC_BK00_1B_L      _PK_L_(0x00, 0x1B)
#define REG_SC_BK00_1B_H      _PK_H_(0x00, 0x1B)
#define REG_SC_BK00_1C_L      _PK_L_(0x00, 0x1C)
#define REG_SC_BK00_1C_H      _PK_H_(0x00, 0x1C)
#define REG_SC_BK00_1D_L      _PK_L_(0x00, 0x1D)
#define REG_SC_BK00_1D_H      _PK_H_(0x00, 0x1D)
#define REG_SC_BK00_1E_L      _PK_L_(0x00, 0x1E)
#define REG_SC_BK00_1E_H      _PK_H_(0x00, 0x1E)
#define REG_SC_BK00_1F_L      _PK_L_(0x00, 0x1F)
#define REG_SC_BK00_1F_H      _PK_H_(0x00, 0x1F)
#define REG_SC_BK00_20_L      _PK_L_(0x00, 0x20)
#define REG_SC_BK00_20_H      _PK_H_(0x00, 0x20)
#define REG_SC_BK00_21_L      _PK_L_(0x00, 0x21)
#define REG_SC_BK00_21_H      _PK_H_(0x00, 0x21)
#define REG_SC_BK00_22_L      _PK_L_(0x00, 0x22)
#define REG_SC_BK00_22_H      _PK_H_(0x00, 0x22)
#define REG_SC_BK00_23_L      _PK_L_(0x00, 0x23)
#define REG_SC_BK00_23_H      _PK_H_(0x00, 0x23)
#define REG_SC_BK00_24_L      _PK_L_(0x00, 0x24)
#define REG_SC_BK00_24_H      _PK_H_(0x00, 0x24)
#define REG_SC_BK00_25_L      _PK_L_(0x00, 0x25)
#define REG_SC_BK00_25_H      _PK_H_(0x00, 0x25)
#define REG_SC_BK00_26_L      _PK_L_(0x00, 0x26)
#define REG_SC_BK00_26_H      _PK_H_(0x00, 0x26)
#define REG_SC_BK00_27_L      _PK_L_(0x00, 0x27)
#define REG_SC_BK00_27_H      _PK_H_(0x00, 0x27)
#define REG_SC_BK00_28_L      _PK_L_(0x00, 0x28)
#define REG_SC_BK00_28_H      _PK_H_(0x00, 0x28)
#define REG_SC_BK00_29_L      _PK_L_(0x00, 0x29)
#define REG_SC_BK00_29_H      _PK_H_(0x00, 0x29)
#define REG_SC_BK00_2A_L      _PK_L_(0x00, 0x2A)
#define REG_SC_BK00_2A_H      _PK_H_(0x00, 0x2A)
#define REG_SC_BK00_2B_L      _PK_L_(0x00, 0x2B)
#define REG_SC_BK00_2B_H      _PK_H_(0x00, 0x2B)
#define REG_SC_BK00_2C_L      _PK_L_(0x00, 0x2C)
#define REG_SC_BK00_2C_H      _PK_H_(0x00, 0x2C)
#define REG_SC_BK00_2D_L      _PK_L_(0x00, 0x2D)
#define REG_SC_BK00_2D_H      _PK_H_(0x00, 0x2D)
#define REG_SC_BK00_2E_L      _PK_L_(0x00, 0x2E)
#define REG_SC_BK00_2E_H      _PK_H_(0x00, 0x2E)
#define REG_SC_BK00_2F_L      _PK_L_(0x00, 0x2F)
#define REG_SC_BK00_2F_H      _PK_H_(0x00, 0x2F)
#define REG_SC_BK00_30_L      _PK_L_(0x00, 0x30)
#define REG_SC_BK00_30_H      _PK_H_(0x00, 0x30)
#define REG_SC_BK00_31_L      _PK_L_(0x00, 0x31)
#define REG_SC_BK00_31_H      _PK_H_(0x00, 0x31)
#define REG_SC_BK00_32_L      _PK_L_(0x00, 0x32)
#define REG_SC_BK00_32_H      _PK_H_(0x00, 0x32)
#define REG_SC_BK00_33_L      _PK_L_(0x00, 0x33)
#define REG_SC_BK00_33_H      _PK_H_(0x00, 0x33)
#define REG_SC_BK00_34_L      _PK_L_(0x00, 0x34)
#define REG_SC_BK00_34_H      _PK_H_(0x00, 0x34)
#define REG_SC_BK00_35_L      _PK_L_(0x00, 0x35)
#define REG_SC_BK00_35_H      _PK_H_(0x00, 0x35)
#define REG_SC_BK00_36_L      _PK_L_(0x00, 0x36)
#define REG_SC_BK00_36_H      _PK_H_(0x00, 0x36)
#define REG_SC_BK00_37_L      _PK_L_(0x00, 0x37)
#define REG_SC_BK00_37_H      _PK_H_(0x00, 0x37)
#define REG_SC_BK00_38_L      _PK_L_(0x00, 0x38)
#define REG_SC_BK00_38_H      _PK_H_(0x00, 0x38)
#define REG_SC_BK00_39_L      _PK_L_(0x00, 0x39)
#define REG_SC_BK00_39_H      _PK_H_(0x00, 0x39)
#define REG_SC_BK00_3A_L      _PK_L_(0x00, 0x3A)
#define REG_SC_BK00_3A_H      _PK_H_(0x00, 0x3A)
#define REG_SC_BK00_3B_L      _PK_L_(0x00, 0x3B)
#define REG_SC_BK00_3B_H      _PK_H_(0x00, 0x3B)
#define REG_SC_BK00_3C_L      _PK_L_(0x00, 0x3C)
#define REG_SC_BK00_3C_H      _PK_H_(0x00, 0x3C)
#define REG_SC_BK00_3D_L      _PK_L_(0x00, 0x3D)
#define REG_SC_BK00_3D_H      _PK_H_(0x00, 0x3D)
#define REG_SC_BK00_3E_L      _PK_L_(0x00, 0x3E)
#define REG_SC_BK00_3E_H      _PK_H_(0x00, 0x3E)
#define REG_SC_BK00_3F_L      _PK_L_(0x00, 0x3F)
#define REG_SC_BK00_3F_H      _PK_H_(0x00, 0x3F)
#define REG_SC_BK00_40_L      _PK_L_(0x00, 0x40)
#define REG_SC_BK00_40_H      _PK_H_(0x00, 0x40)
#define REG_SC_BK00_41_L      _PK_L_(0x00, 0x41)
#define REG_SC_BK00_41_H      _PK_H_(0x00, 0x41)
#define REG_SC_BK00_42_L      _PK_L_(0x00, 0x42)
#define REG_SC_BK00_42_H      _PK_H_(0x00, 0x42)
#define REG_SC_BK00_43_L      _PK_L_(0x00, 0x43)
#define REG_SC_BK00_43_H      _PK_H_(0x00, 0x43)
#define REG_SC_BK00_44_L      _PK_L_(0x00, 0x44)
#define REG_SC_BK00_44_H      _PK_H_(0x00, 0x44)
#define REG_SC_BK00_45_L      _PK_L_(0x00, 0x45)
#define REG_SC_BK00_45_H      _PK_H_(0x00, 0x45)
#define REG_SC_BK00_46_L      _PK_L_(0x00, 0x46)
#define REG_SC_BK00_46_H      _PK_H_(0x00, 0x46)
#define REG_SC_BK00_47_L      _PK_L_(0x00, 0x47)
#define REG_SC_BK00_47_H      _PK_H_(0x00, 0x47)
#define REG_SC_BK00_48_L      _PK_L_(0x00, 0x48)
#define REG_SC_BK00_48_H      _PK_H_(0x00, 0x48)
#define REG_SC_BK00_49_L      _PK_L_(0x00, 0x49)
#define REG_SC_BK00_49_H      _PK_H_(0x00, 0x49)
#define REG_SC_BK00_4A_L      _PK_L_(0x00, 0x4A)
#define REG_SC_BK00_4A_H      _PK_H_(0x00, 0x4A)
#define REG_SC_BK00_4B_L      _PK_L_(0x00, 0x4B)
#define REG_SC_BK00_4B_H      _PK_H_(0x00, 0x4B)
#define REG_SC_BK00_4C_L      _PK_L_(0x00, 0x4C)
#define REG_SC_BK00_4C_H      _PK_H_(0x00, 0x4C)
#define REG_SC_BK00_4D_L      _PK_L_(0x00, 0x4D)
#define REG_SC_BK00_4D_H      _PK_H_(0x00, 0x4D)
#define REG_SC_BK00_4E_L      _PK_L_(0x00, 0x4E)
#define REG_SC_BK00_4E_H      _PK_H_(0x00, 0x4E)
#define REG_SC_BK00_4F_L      _PK_L_(0x00, 0x4F)
#define REG_SC_BK00_4F_H      _PK_H_(0x00, 0x4F)
#define REG_SC_BK00_50_L      _PK_L_(0x00, 0x50)
#define REG_SC_BK00_50_H      _PK_H_(0x00, 0x50)
#define REG_SC_BK00_51_L      _PK_L_(0x00, 0x51)
#define REG_SC_BK00_51_H      _PK_H_(0x00, 0x51)
#define REG_SC_BK00_52_L      _PK_L_(0x00, 0x52)
#define REG_SC_BK00_52_H      _PK_H_(0x00, 0x52)
#define REG_SC_BK00_53_L      _PK_L_(0x00, 0x53)
#define REG_SC_BK00_53_H      _PK_H_(0x00, 0x53)
#define REG_SC_BK00_54_L      _PK_L_(0x00, 0x54)
#define REG_SC_BK00_54_H      _PK_H_(0x00, 0x54)
#define REG_SC_BK00_55_L      _PK_L_(0x00, 0x55)
#define REG_SC_BK00_55_H      _PK_H_(0x00, 0x55)
#define REG_SC_BK00_56_L      _PK_L_(0x00, 0x56)
#define REG_SC_BK00_56_H      _PK_H_(0x00, 0x56)
#define REG_SC_BK00_57_L      _PK_L_(0x00, 0x57)
#define REG_SC_BK00_57_H      _PK_H_(0x00, 0x57)
#define REG_SC_BK00_58_L      _PK_L_(0x00, 0x58)
#define REG_SC_BK00_58_H      _PK_H_(0x00, 0x58)
#define REG_SC_BK00_59_L      _PK_L_(0x00, 0x59)
#define REG_SC_BK00_59_H      _PK_H_(0x00, 0x59)
#define REG_SC_BK00_5A_L      _PK_L_(0x00, 0x5A)
#define REG_SC_BK00_5A_H      _PK_H_(0x00, 0x5A)
#define REG_SC_BK00_5B_L      _PK_L_(0x00, 0x5B)
#define REG_SC_BK00_5B_H      _PK_H_(0x00, 0x5B)
#define REG_SC_BK00_5C_L      _PK_L_(0x00, 0x5C)
#define REG_SC_BK00_5C_H      _PK_H_(0x00, 0x5C)
#define REG_SC_BK00_5D_L      _PK_L_(0x00, 0x5D)
#define REG_SC_BK00_5D_H      _PK_H_(0x00, 0x5D)
#define REG_SC_BK00_5E_L      _PK_L_(0x00, 0x5E)
#define REG_SC_BK00_5E_H      _PK_H_(0x00, 0x5E)
#define REG_SC_BK00_5F_L      _PK_L_(0x00, 0x5F)
#define REG_SC_BK00_5F_H      _PK_H_(0x00, 0x5F)
#define REG_SC_BK00_60_L      _PK_L_(0x00, 0x60)
#define REG_SC_BK00_60_H      _PK_H_(0x00, 0x60)
#define REG_SC_BK00_61_L      _PK_L_(0x00, 0x61)
#define REG_SC_BK00_61_H      _PK_H_(0x00, 0x61)
#define REG_SC_BK00_62_L      _PK_L_(0x00, 0x62)
#define REG_SC_BK00_62_H      _PK_H_(0x00, 0x62)
#define REG_SC_BK00_63_L      _PK_L_(0x00, 0x63)
#define REG_SC_BK00_63_H      _PK_H_(0x00, 0x63)
#define REG_SC_BK00_64_L      _PK_L_(0x00, 0x64)
#define REG_SC_BK00_64_H      _PK_H_(0x00, 0x64)
#define REG_SC_BK00_65_L      _PK_L_(0x00, 0x65)
#define REG_SC_BK00_65_H      _PK_H_(0x00, 0x65)
#define REG_SC_BK00_66_L      _PK_L_(0x00, 0x66)
#define REG_SC_BK00_66_H      _PK_H_(0x00, 0x66)
#define REG_SC_BK00_67_L      _PK_L_(0x00, 0x67)
#define REG_SC_BK00_67_H      _PK_H_(0x00, 0x67)
#define REG_SC_BK00_68_L      _PK_L_(0x00, 0x68)
#define REG_SC_BK00_68_H      _PK_H_(0x00, 0x68)
#define REG_SC_BK00_69_L      _PK_L_(0x00, 0x69)
#define REG_SC_BK00_69_H      _PK_H_(0x00, 0x69)
#define REG_SC_BK00_6A_L      _PK_L_(0x00, 0x6A)
#define REG_SC_BK00_6A_H      _PK_H_(0x00, 0x6A)
#define REG_SC_BK00_6B_L      _PK_L_(0x00, 0x6B)
#define REG_SC_BK00_6B_H      _PK_H_(0x00, 0x6B)
#define REG_SC_BK00_6C_L      _PK_L_(0x00, 0x6C)
#define REG_SC_BK00_6C_H      _PK_H_(0x00, 0x6C)
#define REG_SC_BK00_6D_L      _PK_L_(0x00, 0x6D)
#define REG_SC_BK00_6D_H      _PK_H_(0x00, 0x6D)
#define REG_SC_BK00_6E_L      _PK_L_(0x00, 0x6E)
#define REG_SC_BK00_6E_H      _PK_H_(0x00, 0x6E)
#define REG_SC_BK00_6F_L      _PK_L_(0x00, 0x6F)
#define REG_SC_BK00_6F_H      _PK_H_(0x00, 0x6F)
#define REG_SC_BK00_70_L      _PK_L_(0x00, 0x70)
#define REG_SC_BK00_70_H      _PK_H_(0x00, 0x70)
#define REG_SC_BK00_71_L      _PK_L_(0x00, 0x71)
#define REG_SC_BK00_71_H      _PK_H_(0x00, 0x71)
#define REG_SC_BK00_72_L      _PK_L_(0x00, 0x72)
#define REG_SC_BK00_72_H      _PK_H_(0x00, 0x72)
#define REG_SC_BK00_73_L      _PK_L_(0x00, 0x73)
#define REG_SC_BK00_73_H      _PK_H_(0x00, 0x73)
#define REG_SC_BK00_74_L      _PK_L_(0x00, 0x74)
#define REG_SC_BK00_74_H      _PK_H_(0x00, 0x74)
#define REG_SC_BK00_75_L      _PK_L_(0x00, 0x75)
#define REG_SC_BK00_75_H      _PK_H_(0x00, 0x75)
#define REG_SC_BK00_76_L      _PK_L_(0x00, 0x76)
#define REG_SC_BK00_76_H      _PK_H_(0x00, 0x76)
#define REG_SC_BK00_77_L      _PK_L_(0x00, 0x77)
#define REG_SC_BK00_77_H      _PK_H_(0x00, 0x77)
#define REG_SC_BK00_78_L      _PK_L_(0x00, 0x78)
#define REG_SC_BK00_78_H      _PK_H_(0x00, 0x78)
#define REG_SC_BK00_79_L      _PK_L_(0x00, 0x79)
#define REG_SC_BK00_79_H      _PK_H_(0x00, 0x79)
#define REG_SC_BK00_7A_L      _PK_L_(0x00, 0x7A)
#define REG_SC_BK00_7A_H      _PK_H_(0x00, 0x7A)
#define REG_SC_BK00_7B_L      _PK_L_(0x00, 0x7B)
#define REG_SC_BK00_7B_H      _PK_H_(0x00, 0x7B)
#define REG_SC_BK00_7C_L      _PK_L_(0x00, 0x7C)
#define REG_SC_BK00_7C_H      _PK_H_(0x00, 0x7C)
#define REG_SC_BK00_7D_L      _PK_L_(0x00, 0x7D)
#define REG_SC_BK00_7D_H      _PK_H_(0x00, 0x7D)
#define REG_SC_BK00_7E_L      _PK_L_(0x00, 0x7E)
#define REG_SC_BK00_7E_H      _PK_H_(0x00, 0x7E)
#define REG_SC_BK00_7F_L      _PK_L_(0x00, 0x7F)
#define REG_SC_BK00_7F_H      _PK_H_(0x00, 0x7F)


//----------------------------------------------
//  BK01: IP1F2
//----------------------------------------------
#define REG_SC_BK01_00_L      _PK_L_(0x01, 0x00)
#define REG_SC_BK01_00_H      _PK_H_(0x01, 0x00)
#define REG_SC_BK01_01_L      _PK_L_(0x01, 0x01)
#define REG_SC_BK01_01_H      _PK_H_(0x01, 0x01)
#define REG_SC_BK01_02_L      _PK_L_(0x01, 0x02)
#define REG_SC_BK01_02_H      _PK_H_(0x01, 0x02)
#define REG_SC_BK01_03_L      _PK_L_(0x01, 0x03)
#define REG_SC_BK01_03_H      _PK_H_(0x01, 0x03)
#define REG_SC_BK01_04_L      _PK_L_(0x01, 0x04)
#define REG_SC_BK01_04_H      _PK_H_(0x01, 0x04)
#define REG_SC_BK01_05_L      _PK_L_(0x01, 0x05)
#define REG_SC_BK01_05_H      _PK_H_(0x01, 0x05)
#define REG_SC_BK01_06_L      _PK_L_(0x01, 0x06)
#define REG_SC_BK01_06_H      _PK_H_(0x01, 0x06)
#define REG_SC_BK01_07_L      _PK_L_(0x01, 0x07)
#define REG_SC_BK01_07_H      _PK_H_(0x01, 0x07)
#define REG_SC_BK01_08_L      _PK_L_(0x01, 0x08)
#define REG_SC_BK01_08_H      _PK_H_(0x01, 0x08)
#define REG_SC_BK01_09_L      _PK_L_(0x01, 0x09)
#define REG_SC_BK01_09_H      _PK_H_(0x01, 0x09)
#define REG_SC_BK01_0A_L      _PK_L_(0x01, 0x0A)
#define REG_SC_BK01_0A_H      _PK_H_(0x01, 0x0A)
#define REG_SC_BK01_0B_L      _PK_L_(0x01, 0x0B)
#define REG_SC_BK01_0B_H      _PK_H_(0x01, 0x0B)
#define REG_SC_BK01_0C_L      _PK_L_(0x01, 0x0C)
#define REG_SC_BK01_0C_H      _PK_H_(0x01, 0x0C)
#define REG_SC_BK01_0D_L      _PK_L_(0x01, 0x0D)
#define REG_SC_BK01_0D_H      _PK_H_(0x01, 0x0D)
#define REG_SC_BK01_0E_L      _PK_L_(0x01, 0x0E)
#define REG_SC_BK01_0E_H      _PK_H_(0x01, 0x0E)
#define REG_SC_BK01_0F_L      _PK_L_(0x01, 0x0F)
#define REG_SC_BK01_0F_H      _PK_H_(0x01, 0x0F)
#define REG_SC_BK01_10_L      _PK_L_(0x01, 0x10)
#define REG_SC_BK01_10_H      _PK_H_(0x01, 0x10)
#define REG_SC_BK01_11_L      _PK_L_(0x01, 0x11)
#define REG_SC_BK01_11_H      _PK_H_(0x01, 0x11)
#define REG_SC_BK01_12_L      _PK_L_(0x01, 0x12)
#define REG_SC_BK01_12_H      _PK_H_(0x01, 0x12)
#define REG_SC_BK01_13_L      _PK_L_(0x01, 0x13)
#define REG_SC_BK01_13_H      _PK_H_(0x01, 0x13)
#define REG_SC_BK01_14_L      _PK_L_(0x01, 0x14)
#define REG_SC_BK01_14_H      _PK_H_(0x01, 0x14)
#define REG_SC_BK01_15_L      _PK_L_(0x01, 0x15)
#define REG_SC_BK01_15_H      _PK_H_(0x01, 0x15)
#define REG_SC_BK01_16_L      _PK_L_(0x01, 0x16)
#define REG_SC_BK01_16_H      _PK_H_(0x01, 0x16)
#define REG_SC_BK01_17_L      _PK_L_(0x01, 0x17)
#define REG_SC_BK01_17_H      _PK_H_(0x01, 0x17)
#define REG_SC_BK01_18_L      _PK_L_(0x01, 0x18)
#define REG_SC_BK01_18_H      _PK_H_(0x01, 0x18)
#define REG_SC_BK01_19_L      _PK_L_(0x01, 0x19)
#define REG_SC_BK01_19_H      _PK_H_(0x01, 0x19)
#define REG_SC_BK01_1A_L      _PK_L_(0x01, 0x1A)
#define REG_SC_BK01_1A_H      _PK_H_(0x01, 0x1A)
#define REG_SC_BK01_1B_L      _PK_L_(0x01, 0x1B)
#define REG_SC_BK01_1B_H      _PK_H_(0x01, 0x1B)
#define REG_SC_BK01_1C_L      _PK_L_(0x01, 0x1C)
#define REG_SC_BK01_1C_H      _PK_H_(0x01, 0x1C)
#define REG_SC_BK01_1D_L      _PK_L_(0x01, 0x1D)
#define REG_SC_BK01_1D_H      _PK_H_(0x01, 0x1D)
#define REG_SC_BK01_1E_L      _PK_L_(0x01, 0x1E)
#define REG_SC_BK01_1E_H      _PK_H_(0x01, 0x1E)
#define REG_SC_BK01_1F_L      _PK_L_(0x01, 0x1F)
#define REG_SC_BK01_1F_H      _PK_H_(0x01, 0x1F)
#define REG_SC_BK01_20_L      _PK_L_(0x01, 0x20)
#define REG_SC_BK01_20_H      _PK_H_(0x01, 0x20)
#define REG_SC_BK01_21_L      _PK_L_(0x01, 0x21)
#define REG_SC_BK01_21_H      _PK_H_(0x01, 0x21)
#define REG_SC_BK01_22_L      _PK_L_(0x01, 0x22)
#define REG_SC_BK01_22_H      _PK_H_(0x01, 0x22)
#define REG_SC_BK01_23_L      _PK_L_(0x01, 0x23)
#define REG_SC_BK01_23_H      _PK_H_(0x01, 0x23)
#define REG_SC_BK01_24_L      _PK_L_(0x01, 0x24)
#define REG_SC_BK01_24_H      _PK_H_(0x01, 0x24)
#define REG_SC_BK01_25_L      _PK_L_(0x01, 0x25)
#define REG_SC_BK01_25_H      _PK_H_(0x01, 0x25)
#define REG_SC_BK01_26_L      _PK_L_(0x01, 0x26)
#define REG_SC_BK01_26_H      _PK_H_(0x01, 0x26)
#define REG_SC_BK01_27_L      _PK_L_(0x01, 0x27)
#define REG_SC_BK01_27_H      _PK_H_(0x01, 0x27)
#define REG_SC_BK01_28_L      _PK_L_(0x01, 0x28)
#define REG_SC_BK01_28_H      _PK_H_(0x01, 0x28)
#define REG_SC_BK01_29_L      _PK_L_(0x01, 0x29)
#define REG_SC_BK01_29_H      _PK_H_(0x01, 0x29)
#define REG_SC_BK01_2A_L      _PK_L_(0x01, 0x2A)
#define REG_SC_BK01_2A_H      _PK_H_(0x01, 0x2A)
#define REG_SC_BK01_2B_L      _PK_L_(0x01, 0x2B)
#define REG_SC_BK01_2B_H      _PK_H_(0x01, 0x2B)
#define REG_SC_BK01_2C_L      _PK_L_(0x01, 0x2C)
#define REG_SC_BK01_2C_H      _PK_H_(0x01, 0x2C)
#define REG_SC_BK01_2D_L      _PK_L_(0x01, 0x2D)
#define REG_SC_BK01_2D_H      _PK_H_(0x01, 0x2D)
#define REG_SC_BK01_2E_L      _PK_L_(0x01, 0x2E)
#define REG_SC_BK01_2E_H      _PK_H_(0x01, 0x2E)
#define REG_SC_BK01_2F_L      _PK_L_(0x01, 0x2F)
#define REG_SC_BK01_2F_H      _PK_H_(0x01, 0x2F)
#define REG_SC_BK01_30_L      _PK_L_(0x01, 0x30)
#define REG_SC_BK01_30_H      _PK_H_(0x01, 0x30)
#define REG_SC_BK01_31_L      _PK_L_(0x01, 0x31)
#define REG_SC_BK01_31_H      _PK_H_(0x01, 0x31)
#define REG_SC_BK01_32_L      _PK_L_(0x01, 0x32)
#define REG_SC_BK01_32_H      _PK_H_(0x01, 0x32)
#define REG_SC_BK01_33_L      _PK_L_(0x01, 0x33)
#define REG_SC_BK01_33_H      _PK_H_(0x01, 0x33)
#define REG_SC_BK01_34_L      _PK_L_(0x01, 0x34)
#define REG_SC_BK01_34_H      _PK_H_(0x01, 0x34)
#define REG_SC_BK01_35_L      _PK_L_(0x01, 0x35)
#define REG_SC_BK01_35_H      _PK_H_(0x01, 0x35)
#define REG_SC_BK01_36_L      _PK_L_(0x01, 0x36)
#define REG_SC_BK01_36_H      _PK_H_(0x01, 0x36)
#define REG_SC_BK01_37_L      _PK_L_(0x01, 0x37)
#define REG_SC_BK01_37_H      _PK_H_(0x01, 0x37)
#define REG_SC_BK01_38_L      _PK_L_(0x01, 0x38)
#define REG_SC_BK01_38_H      _PK_H_(0x01, 0x38)
#define REG_SC_BK01_39_L      _PK_L_(0x01, 0x39)
#define REG_SC_BK01_39_H      _PK_H_(0x01, 0x39)
#define REG_SC_BK01_3A_L      _PK_L_(0x01, 0x3A)
#define REG_SC_BK01_3A_H      _PK_H_(0x01, 0x3A)
#define REG_SC_BK01_3B_L      _PK_L_(0x01, 0x3B)
#define REG_SC_BK01_3B_H      _PK_H_(0x01, 0x3B)
#define REG_SC_BK01_3C_L      _PK_L_(0x01, 0x3C)
#define REG_SC_BK01_3C_H      _PK_H_(0x01, 0x3C)
#define REG_SC_BK01_3D_L      _PK_L_(0x01, 0x3D)
#define REG_SC_BK01_3D_H      _PK_H_(0x01, 0x3D)
#define REG_SC_BK01_3E_L      _PK_L_(0x01, 0x3E)
#define REG_SC_BK01_3E_H      _PK_H_(0x01, 0x3E)
#define REG_SC_BK01_3F_L      _PK_L_(0x01, 0x3F)
#define REG_SC_BK01_3F_H      _PK_H_(0x01, 0x3F)
#define REG_SC_BK01_40_L      _PK_L_(0x01, 0x40)
#define REG_SC_BK01_40_H      _PK_H_(0x01, 0x40)
#define REG_SC_BK01_41_L      _PK_L_(0x01, 0x41)
#define REG_SC_BK01_41_H      _PK_H_(0x01, 0x41)
#define REG_SC_BK01_42_L      _PK_L_(0x01, 0x42)
#define REG_SC_BK01_42_H      _PK_H_(0x01, 0x42)
#define REG_SC_BK01_43_L      _PK_L_(0x01, 0x43)
#define REG_SC_BK01_43_H      _PK_H_(0x01, 0x43)
#define REG_SC_BK01_44_L      _PK_L_(0x01, 0x44)
#define REG_SC_BK01_44_H      _PK_H_(0x01, 0x44)
#define REG_SC_BK01_45_L      _PK_L_(0x01, 0x45)
#define REG_SC_BK01_45_H      _PK_H_(0x01, 0x45)
#define REG_SC_BK01_46_L      _PK_L_(0x01, 0x46)
#define REG_SC_BK01_46_H      _PK_H_(0x01, 0x46)
#define REG_SC_BK01_47_L      _PK_L_(0x01, 0x47)
#define REG_SC_BK01_47_H      _PK_H_(0x01, 0x47)
#define REG_SC_BK01_48_L      _PK_L_(0x01, 0x48)
#define REG_SC_BK01_48_H      _PK_H_(0x01, 0x48)
#define REG_SC_BK01_49_L      _PK_L_(0x01, 0x49)
#define REG_SC_BK01_49_H      _PK_H_(0x01, 0x49)
#define REG_SC_BK01_4A_L      _PK_L_(0x01, 0x4A)
#define REG_SC_BK01_4A_H      _PK_H_(0x01, 0x4A)
#define REG_SC_BK01_4B_L      _PK_L_(0x01, 0x4B)
#define REG_SC_BK01_4B_H      _PK_H_(0x01, 0x4B)
#define REG_SC_BK01_4C_L      _PK_L_(0x01, 0x4C)
#define REG_SC_BK01_4C_H      _PK_H_(0x01, 0x4C)
#define REG_SC_BK01_4D_L      _PK_L_(0x01, 0x4D)
#define REG_SC_BK01_4D_H      _PK_H_(0x01, 0x4D)
#define REG_SC_BK01_4E_L      _PK_L_(0x01, 0x4E)
#define REG_SC_BK01_4E_H      _PK_H_(0x01, 0x4E)
#define REG_SC_BK01_4F_L      _PK_L_(0x01, 0x4F)
#define REG_SC_BK01_4F_H      _PK_H_(0x01, 0x4F)
#define REG_SC_BK01_50_L      _PK_L_(0x01, 0x50)
#define REG_SC_BK01_50_H      _PK_H_(0x01, 0x50)
#define REG_SC_BK01_51_L      _PK_L_(0x01, 0x51)
#define REG_SC_BK01_51_H      _PK_H_(0x01, 0x51)
#define REG_SC_BK01_52_L      _PK_L_(0x01, 0x52)
#define REG_SC_BK01_52_H      _PK_H_(0x01, 0x52)
#define REG_SC_BK01_53_L      _PK_L_(0x01, 0x53)
#define REG_SC_BK01_53_H      _PK_H_(0x01, 0x53)
#define REG_SC_BK01_54_L      _PK_L_(0x01, 0x54)
#define REG_SC_BK01_54_H      _PK_H_(0x01, 0x54)
#define REG_SC_BK01_55_L      _PK_L_(0x01, 0x55)
#define REG_SC_BK01_55_H      _PK_H_(0x01, 0x55)
#define REG_SC_BK01_56_L      _PK_L_(0x01, 0x56)
#define REG_SC_BK01_56_H      _PK_H_(0x01, 0x56)
#define REG_SC_BK01_57_L      _PK_L_(0x01, 0x57)
#define REG_SC_BK01_57_H      _PK_H_(0x01, 0x57)
#define REG_SC_BK01_58_L      _PK_L_(0x01, 0x58)
#define REG_SC_BK01_58_H      _PK_H_(0x01, 0x58)
#define REG_SC_BK01_59_L      _PK_L_(0x01, 0x59)
#define REG_SC_BK01_59_H      _PK_H_(0x01, 0x59)
#define REG_SC_BK01_5A_L      _PK_L_(0x01, 0x5A)
#define REG_SC_BK01_5A_H      _PK_H_(0x01, 0x5A)
#define REG_SC_BK01_5B_L      _PK_L_(0x01, 0x5B)
#define REG_SC_BK01_5B_H      _PK_H_(0x01, 0x5B)
#define REG_SC_BK01_5C_L      _PK_L_(0x01, 0x5C)
#define REG_SC_BK01_5C_H      _PK_H_(0x01, 0x5C)
#define REG_SC_BK01_5D_L      _PK_L_(0x01, 0x5D)
#define REG_SC_BK01_5D_H      _PK_H_(0x01, 0x5D)
#define REG_SC_BK01_5E_L      _PK_L_(0x01, 0x5E)
#define REG_SC_BK01_5E_H      _PK_H_(0x01, 0x5E)
#define REG_SC_BK01_5F_L      _PK_L_(0x01, 0x5F)
#define REG_SC_BK01_5F_H      _PK_H_(0x01, 0x5F)
#define REG_SC_BK01_60_L      _PK_L_(0x01, 0x60)
#define REG_SC_BK01_60_H      _PK_H_(0x01, 0x60)
#define REG_SC_BK01_61_L      _PK_L_(0x01, 0x61)
#define REG_SC_BK01_61_H      _PK_H_(0x01, 0x61)
#define REG_SC_BK01_62_L      _PK_L_(0x01, 0x62)
#define REG_SC_BK01_62_H      _PK_H_(0x01, 0x62)
#define REG_SC_BK01_63_L      _PK_L_(0x01, 0x63)
#define REG_SC_BK01_63_H      _PK_H_(0x01, 0x63)
#define REG_SC_BK01_64_L      _PK_L_(0x01, 0x64)
#define REG_SC_BK01_64_H      _PK_H_(0x01, 0x64)
#define REG_SC_BK01_65_L      _PK_L_(0x01, 0x65)
#define REG_SC_BK01_65_H      _PK_H_(0x01, 0x65)
#define REG_SC_BK01_66_L      _PK_L_(0x01, 0x66)
#define REG_SC_BK01_66_H      _PK_H_(0x01, 0x66)
#define REG_SC_BK01_67_L      _PK_L_(0x01, 0x67)
#define REG_SC_BK01_67_H      _PK_H_(0x01, 0x67)
#define REG_SC_BK01_68_L      _PK_L_(0x01, 0x68)
#define REG_SC_BK01_68_H      _PK_H_(0x01, 0x68)
#define REG_SC_BK01_69_L      _PK_L_(0x01, 0x69)
#define REG_SC_BK01_69_H      _PK_H_(0x01, 0x69)
#define REG_SC_BK01_6A_L      _PK_L_(0x01, 0x6A)
#define REG_SC_BK01_6A_H      _PK_H_(0x01, 0x6A)
#define REG_SC_BK01_6B_L      _PK_L_(0x01, 0x6B)
#define REG_SC_BK01_6B_H      _PK_H_(0x01, 0x6B)
#define REG_SC_BK01_6C_L      _PK_L_(0x01, 0x6C)
#define REG_SC_BK01_6C_H      _PK_H_(0x01, 0x6C)
#define REG_SC_BK01_6D_L      _PK_L_(0x01, 0x6D)
#define REG_SC_BK01_6D_H      _PK_H_(0x01, 0x6D)
#define REG_SC_BK01_6E_L      _PK_L_(0x01, 0x6E)
#define REG_SC_BK01_6E_H      _PK_H_(0x01, 0x6E)
#define REG_SC_BK01_6F_L      _PK_L_(0x01, 0x6F)
#define REG_SC_BK01_6F_H      _PK_H_(0x01, 0x6F)
#define REG_SC_BK01_70_L      _PK_L_(0x01, 0x70)
#define REG_SC_BK01_70_H      _PK_H_(0x01, 0x70)
#define REG_SC_BK01_71_L      _PK_L_(0x01, 0x71)
#define REG_SC_BK01_71_H      _PK_H_(0x01, 0x71)
#define REG_SC_BK01_72_L      _PK_L_(0x01, 0x72)
#define REG_SC_BK01_72_H      _PK_H_(0x01, 0x72)
#define REG_SC_BK01_73_L      _PK_L_(0x01, 0x73)
#define REG_SC_BK01_73_H      _PK_H_(0x01, 0x73)
#define REG_SC_BK01_74_L      _PK_L_(0x01, 0x74)
#define REG_SC_BK01_74_H      _PK_H_(0x01, 0x74)
#define REG_SC_BK01_75_L      _PK_L_(0x01, 0x75)
#define REG_SC_BK01_75_H      _PK_H_(0x01, 0x75)
#define REG_SC_BK01_76_L      _PK_L_(0x01, 0x76)
#define REG_SC_BK01_76_H      _PK_H_(0x01, 0x76)
#define REG_SC_BK01_77_L      _PK_L_(0x01, 0x77)
#define REG_SC_BK01_77_H      _PK_H_(0x01, 0x77)
#define REG_SC_BK01_78_L      _PK_L_(0x01, 0x78)
#define REG_SC_BK01_78_H      _PK_H_(0x01, 0x78)
#define REG_SC_BK01_79_L      _PK_L_(0x01, 0x79)
#define REG_SC_BK01_79_H      _PK_H_(0x01, 0x79)
#define REG_SC_BK01_7A_L      _PK_L_(0x01, 0x7A)
#define REG_SC_BK01_7A_H      _PK_H_(0x01, 0x7A)
#define REG_SC_BK01_7B_L      _PK_L_(0x01, 0x7B)
#define REG_SC_BK01_7B_H      _PK_H_(0x01, 0x7B)
#define REG_SC_BK01_7C_L      _PK_L_(0x01, 0x7C)
#define REG_SC_BK01_7C_H      _PK_H_(0x01, 0x7C)
#define REG_SC_BK01_7D_L      _PK_L_(0x01, 0x7D)
#define REG_SC_BK01_7D_H      _PK_H_(0x01, 0x7D)
#define REG_SC_BK01_7E_L      _PK_L_(0x01, 0x7E)
#define REG_SC_BK01_7E_H      _PK_H_(0x01, 0x7E)
#define REG_SC_BK01_7F_L      _PK_L_(0x01, 0x7F)
#define REG_SC_BK01_7F_H      _PK_H_(0x01, 0x7F)


//----------------------------------------------
//  BK02: IP2F2
//----------------------------------------------
#define REG_SC_BK02_00_L      _PK_L_(0x02, 0x00)
#define REG_SC_BK02_00_H      _PK_H_(0x02, 0x00)
#define REG_SC_BK02_01_L      _PK_L_(0x02, 0x01)
#define REG_SC_BK02_01_H      _PK_H_(0x02, 0x01)
#define REG_SC_BK02_02_L      _PK_L_(0x02, 0x02)
#define REG_SC_BK02_02_H      _PK_H_(0x02, 0x02)
#define REG_SC_BK02_03_L      _PK_L_(0x02, 0x03)
#define REG_SC_BK02_03_H      _PK_H_(0x02, 0x03)
#define REG_SC_BK02_04_L      _PK_L_(0x02, 0x04)
#define REG_SC_BK02_04_H      _PK_H_(0x02, 0x04)
#define REG_SC_BK02_05_L      _PK_L_(0x02, 0x05)
#define REG_SC_BK02_05_H      _PK_H_(0x02, 0x05)
#define REG_SC_BK02_06_L      _PK_L_(0x02, 0x06)
#define REG_SC_BK02_06_H      _PK_H_(0x02, 0x06)
#define REG_SC_BK02_07_L      _PK_L_(0x02, 0x07)
#define REG_SC_BK02_07_H      _PK_H_(0x02, 0x07)
#define REG_SC_BK02_08_L      _PK_L_(0x02, 0x08)
#define REG_SC_BK02_08_H      _PK_H_(0x02, 0x08)
#define REG_SC_BK02_09_L      _PK_L_(0x02, 0x09)
#define REG_SC_BK02_09_H      _PK_H_(0x02, 0x09)
#define REG_SC_BK02_0A_L      _PK_L_(0x02, 0x0A)
#define REG_SC_BK02_0A_H      _PK_H_(0x02, 0x0A)
#define REG_SC_BK02_0B_L      _PK_L_(0x02, 0x0B)
#define REG_SC_BK02_0B_H      _PK_H_(0x02, 0x0B)
#define REG_SC_BK02_0C_L      _PK_L_(0x02, 0x0C)
#define REG_SC_BK02_0C_H      _PK_H_(0x02, 0x0C)
#define REG_SC_BK02_0D_L      _PK_L_(0x02, 0x0D)
#define REG_SC_BK02_0D_H      _PK_H_(0x02, 0x0D)
#define REG_SC_BK02_0E_L      _PK_L_(0x02, 0x0E)
#define REG_SC_BK02_0E_H      _PK_H_(0x02, 0x0E)
#define REG_SC_BK02_0F_L      _PK_L_(0x02, 0x0F)
#define REG_SC_BK02_0F_H      _PK_H_(0x02, 0x0F)
#define REG_SC_BK02_10_L      _PK_L_(0x02, 0x10)
#define REG_SC_BK02_10_H      _PK_H_(0x02, 0x10)
#define REG_SC_BK02_11_L      _PK_L_(0x02, 0x11)
#define REG_SC_BK02_11_H      _PK_H_(0x02, 0x11)
#define REG_SC_BK02_12_L      _PK_L_(0x02, 0x12)
#define REG_SC_BK02_12_H      _PK_H_(0x02, 0x12)
#define REG_SC_BK02_13_L      _PK_L_(0x02, 0x13)
#define REG_SC_BK02_13_H      _PK_H_(0x02, 0x13)
#define REG_SC_BK02_14_L      _PK_L_(0x02, 0x14)
#define REG_SC_BK02_14_H      _PK_H_(0x02, 0x14)
#define REG_SC_BK02_15_L      _PK_L_(0x02, 0x15)
#define REG_SC_BK02_15_H      _PK_H_(0x02, 0x15)
#define REG_SC_BK02_16_L      _PK_L_(0x02, 0x16)
#define REG_SC_BK02_16_H      _PK_H_(0x02, 0x16)
#define REG_SC_BK02_17_L      _PK_L_(0x02, 0x17)
#define REG_SC_BK02_17_H      _PK_H_(0x02, 0x17)
#define REG_SC_BK02_18_L      _PK_L_(0x02, 0x18)
#define REG_SC_BK02_18_H      _PK_H_(0x02, 0x18)
#define REG_SC_BK02_19_L      _PK_L_(0x02, 0x19)
#define REG_SC_BK02_19_H      _PK_H_(0x02, 0x19)
#define REG_SC_BK02_1A_L      _PK_L_(0x02, 0x1A)
#define REG_SC_BK02_1A_H      _PK_H_(0x02, 0x1A)
#define REG_SC_BK02_1B_L      _PK_L_(0x02, 0x1B)
#define REG_SC_BK02_1B_H      _PK_H_(0x02, 0x1B)
#define REG_SC_BK02_1C_L      _PK_L_(0x02, 0x1C)
#define REG_SC_BK02_1C_H      _PK_H_(0x02, 0x1C)
#define REG_SC_BK02_1D_L      _PK_L_(0x02, 0x1D)
#define REG_SC_BK02_1D_H      _PK_H_(0x02, 0x1D)
#define REG_SC_BK02_1E_L      _PK_L_(0x02, 0x1E)
#define REG_SC_BK02_1E_H      _PK_H_(0x02, 0x1E)
#define REG_SC_BK02_1F_L      _PK_L_(0x02, 0x1F)
#define REG_SC_BK02_1F_H      _PK_H_(0x02, 0x1F)
#define REG_SC_BK02_20_L      _PK_L_(0x02, 0x20)
#define REG_SC_BK02_20_H      _PK_H_(0x02, 0x20)
#define REG_SC_BK02_21_L      _PK_L_(0x02, 0x21)
#define REG_SC_BK02_21_H      _PK_H_(0x02, 0x21)
#define REG_SC_BK02_22_L      _PK_L_(0x02, 0x22)
#define REG_SC_BK02_22_H      _PK_H_(0x02, 0x22)
#define REG_SC_BK02_23_L      _PK_L_(0x02, 0x23)
#define REG_SC_BK02_23_H      _PK_H_(0x02, 0x23)
#define REG_SC_BK02_24_L      _PK_L_(0x02, 0x24)
#define REG_SC_BK02_24_H      _PK_H_(0x02, 0x24)
#define REG_SC_BK02_25_L      _PK_L_(0x02, 0x25)
#define REG_SC_BK02_25_H      _PK_H_(0x02, 0x25)
#define REG_SC_BK02_26_L      _PK_L_(0x02, 0x26)
#define REG_SC_BK02_26_H      _PK_H_(0x02, 0x26)
#define REG_SC_BK02_27_L      _PK_L_(0x02, 0x27)
#define REG_SC_BK02_27_H      _PK_H_(0x02, 0x27)
#define REG_SC_BK02_28_L      _PK_L_(0x02, 0x28)
#define REG_SC_BK02_28_H      _PK_H_(0x02, 0x28)
#define REG_SC_BK02_29_L      _PK_L_(0x02, 0x29)
#define REG_SC_BK02_29_H      _PK_H_(0x02, 0x29)
#define REG_SC_BK02_2A_L      _PK_L_(0x02, 0x2A)
#define REG_SC_BK02_2A_H      _PK_H_(0x02, 0x2A)
#define REG_SC_BK02_2B_L      _PK_L_(0x02, 0x2B)
#define REG_SC_BK02_2B_H      _PK_H_(0x02, 0x2B)
#define REG_SC_BK02_2C_L      _PK_L_(0x02, 0x2C)
#define REG_SC_BK02_2C_H      _PK_H_(0x02, 0x2C)
#define REG_SC_BK02_2D_L      _PK_L_(0x02, 0x2D)
#define REG_SC_BK02_2D_H      _PK_H_(0x02, 0x2D)
#define REG_SC_BK02_2E_L      _PK_L_(0x02, 0x2E)
#define REG_SC_BK02_2E_H      _PK_H_(0x02, 0x2E)
#define REG_SC_BK02_2F_L      _PK_L_(0x02, 0x2F)
#define REG_SC_BK02_2F_H      _PK_H_(0x02, 0x2F)
#define REG_SC_BK02_30_L      _PK_L_(0x02, 0x30)
#define REG_SC_BK02_30_H      _PK_H_(0x02, 0x30)
#define REG_SC_BK02_31_L      _PK_L_(0x02, 0x31)
#define REG_SC_BK02_31_H      _PK_H_(0x02, 0x31)
#define REG_SC_BK02_32_L      _PK_L_(0x02, 0x32)
#define REG_SC_BK02_32_H      _PK_H_(0x02, 0x32)
#define REG_SC_BK02_33_L      _PK_L_(0x02, 0x33)
#define REG_SC_BK02_33_H      _PK_H_(0x02, 0x33)
#define REG_SC_BK02_34_L      _PK_L_(0x02, 0x34)
#define REG_SC_BK02_34_H      _PK_H_(0x02, 0x34)
#define REG_SC_BK02_35_L      _PK_L_(0x02, 0x35)
#define REG_SC_BK02_35_H      _PK_H_(0x02, 0x35)
#define REG_SC_BK02_36_L      _PK_L_(0x02, 0x36)
#define REG_SC_BK02_36_H      _PK_H_(0x02, 0x36)
#define REG_SC_BK02_37_L      _PK_L_(0x02, 0x37)
#define REG_SC_BK02_37_H      _PK_H_(0x02, 0x37)
#define REG_SC_BK02_38_L      _PK_L_(0x02, 0x38)
#define REG_SC_BK02_38_H      _PK_H_(0x02, 0x38)
#define REG_SC_BK02_39_L      _PK_L_(0x02, 0x39)
#define REG_SC_BK02_39_H      _PK_H_(0x02, 0x39)
#define REG_SC_BK02_3A_L      _PK_L_(0x02, 0x3A)
#define REG_SC_BK02_3A_H      _PK_H_(0x02, 0x3A)
#define REG_SC_BK02_3B_L      _PK_L_(0x02, 0x3B)
#define REG_SC_BK02_3B_H      _PK_H_(0x02, 0x3B)
#define REG_SC_BK02_3C_L      _PK_L_(0x02, 0x3C)
#define REG_SC_BK02_3C_H      _PK_H_(0x02, 0x3C)
#define REG_SC_BK02_3D_L      _PK_L_(0x02, 0x3D)
#define REG_SC_BK02_3D_H      _PK_H_(0x02, 0x3D)
#define REG_SC_BK02_3E_L      _PK_L_(0x02, 0x3E)
#define REG_SC_BK02_3E_H      _PK_H_(0x02, 0x3E)
#define REG_SC_BK02_3F_L      _PK_L_(0x02, 0x3F)
#define REG_SC_BK02_3F_H      _PK_H_(0x02, 0x3F)
#define REG_SC_BK02_40_L      _PK_L_(0x02, 0x40)
#define REG_SC_BK02_40_H      _PK_H_(0x02, 0x40)
#define REG_SC_BK02_41_L      _PK_L_(0x02, 0x41)
#define REG_SC_BK02_41_H      _PK_H_(0x02, 0x41)
#define REG_SC_BK02_42_L      _PK_L_(0x02, 0x42)
#define REG_SC_BK02_42_H      _PK_H_(0x02, 0x42)
#define REG_SC_BK02_43_L      _PK_L_(0x02, 0x43)
#define REG_SC_BK02_43_H      _PK_H_(0x02, 0x43)
#define REG_SC_BK02_44_L      _PK_L_(0x02, 0x44)
#define REG_SC_BK02_44_H      _PK_H_(0x02, 0x44)
#define REG_SC_BK02_45_L      _PK_L_(0x02, 0x45)
#define REG_SC_BK02_45_H      _PK_H_(0x02, 0x45)
#define REG_SC_BK02_46_L      _PK_L_(0x02, 0x46)
#define REG_SC_BK02_46_H      _PK_H_(0x02, 0x46)
#define REG_SC_BK02_47_L      _PK_L_(0x02, 0x47)
#define REG_SC_BK02_47_H      _PK_H_(0x02, 0x47)
#define REG_SC_BK02_48_L      _PK_L_(0x02, 0x48)
#define REG_SC_BK02_48_H      _PK_H_(0x02, 0x48)
#define REG_SC_BK02_49_L      _PK_L_(0x02, 0x49)
#define REG_SC_BK02_49_H      _PK_H_(0x02, 0x49)
#define REG_SC_BK02_4A_L      _PK_L_(0x02, 0x4A)
#define REG_SC_BK02_4A_H      _PK_H_(0x02, 0x4A)
#define REG_SC_BK02_4B_L      _PK_L_(0x02, 0x4B)
#define REG_SC_BK02_4B_H      _PK_H_(0x02, 0x4B)
#define REG_SC_BK02_4C_L      _PK_L_(0x02, 0x4C)
#define REG_SC_BK02_4C_H      _PK_H_(0x02, 0x4C)
#define REG_SC_BK02_4D_L      _PK_L_(0x02, 0x4D)
#define REG_SC_BK02_4D_H      _PK_H_(0x02, 0x4D)
#define REG_SC_BK02_4E_L      _PK_L_(0x02, 0x4E)
#define REG_SC_BK02_4E_H      _PK_H_(0x02, 0x4E)
#define REG_SC_BK02_4F_L      _PK_L_(0x02, 0x4F)
#define REG_SC_BK02_4F_H      _PK_H_(0x02, 0x4F)
#define REG_SC_BK02_50_L      _PK_L_(0x02, 0x50)
#define REG_SC_BK02_50_H      _PK_H_(0x02, 0x50)
#define REG_SC_BK02_51_L      _PK_L_(0x02, 0x51)
#define REG_SC_BK02_51_H      _PK_H_(0x02, 0x51)
#define REG_SC_BK02_52_L      _PK_L_(0x02, 0x52)
#define REG_SC_BK02_52_H      _PK_H_(0x02, 0x52)
#define REG_SC_BK02_53_L      _PK_L_(0x02, 0x53)
#define REG_SC_BK02_53_H      _PK_H_(0x02, 0x53)
#define REG_SC_BK02_54_L      _PK_L_(0x02, 0x54)
#define REG_SC_BK02_54_H      _PK_H_(0x02, 0x54)
#define REG_SC_BK02_55_L      _PK_L_(0x02, 0x55)
#define REG_SC_BK02_55_H      _PK_H_(0x02, 0x55)
#define REG_SC_BK02_56_L      _PK_L_(0x02, 0x56)
#define REG_SC_BK02_56_H      _PK_H_(0x02, 0x56)
#define REG_SC_BK02_57_L      _PK_L_(0x02, 0x57)
#define REG_SC_BK02_57_H      _PK_H_(0x02, 0x57)
#define REG_SC_BK02_58_L      _PK_L_(0x02, 0x58)
#define REG_SC_BK02_58_H      _PK_H_(0x02, 0x58)
#define REG_SC_BK02_59_L      _PK_L_(0x02, 0x59)
#define REG_SC_BK02_59_H      _PK_H_(0x02, 0x59)
#define REG_SC_BK02_5A_L      _PK_L_(0x02, 0x5A)
#define REG_SC_BK02_5A_H      _PK_H_(0x02, 0x5A)
#define REG_SC_BK02_5B_L      _PK_L_(0x02, 0x5B)
#define REG_SC_BK02_5B_H      _PK_H_(0x02, 0x5B)
#define REG_SC_BK02_5C_L      _PK_L_(0x02, 0x5C)
#define REG_SC_BK02_5C_H      _PK_H_(0x02, 0x5C)
#define REG_SC_BK02_5D_L      _PK_L_(0x02, 0x5D)
#define REG_SC_BK02_5D_H      _PK_H_(0x02, 0x5D)
#define REG_SC_BK02_5E_L      _PK_L_(0x02, 0x5E)
#define REG_SC_BK02_5E_H      _PK_H_(0x02, 0x5E)
#define REG_SC_BK02_5F_L      _PK_L_(0x02, 0x5F)
#define REG_SC_BK02_5F_H      _PK_H_(0x02, 0x5F)
#define REG_SC_BK02_60_L      _PK_L_(0x02, 0x60)
#define REG_SC_BK02_60_H      _PK_H_(0x02, 0x60)
#define REG_SC_BK02_61_L      _PK_L_(0x02, 0x61)
#define REG_SC_BK02_61_H      _PK_H_(0x02, 0x61)
#define REG_SC_BK02_62_L      _PK_L_(0x02, 0x62)
#define REG_SC_BK02_62_H      _PK_H_(0x02, 0x62)
#define REG_SC_BK02_63_L      _PK_L_(0x02, 0x63)
#define REG_SC_BK02_63_H      _PK_H_(0x02, 0x63)
#define REG_SC_BK02_64_L      _PK_L_(0x02, 0x64)
#define REG_SC_BK02_64_H      _PK_H_(0x02, 0x64)
#define REG_SC_BK02_65_L      _PK_L_(0x02, 0x65)
#define REG_SC_BK02_65_H      _PK_H_(0x02, 0x65)
#define REG_SC_BK02_66_L      _PK_L_(0x02, 0x66)
#define REG_SC_BK02_66_H      _PK_H_(0x02, 0x66)
#define REG_SC_BK02_67_L      _PK_L_(0x02, 0x67)
#define REG_SC_BK02_67_H      _PK_H_(0x02, 0x67)
#define REG_SC_BK02_68_L      _PK_L_(0x02, 0x68)
#define REG_SC_BK02_68_H      _PK_H_(0x02, 0x68)
#define REG_SC_BK02_69_L      _PK_L_(0x02, 0x69)
#define REG_SC_BK02_69_H      _PK_H_(0x02, 0x69)
#define REG_SC_BK02_6A_L      _PK_L_(0x02, 0x6A)
#define REG_SC_BK02_6A_H      _PK_H_(0x02, 0x6A)
#define REG_SC_BK02_6B_L      _PK_L_(0x02, 0x6B)
#define REG_SC_BK02_6B_H      _PK_H_(0x02, 0x6B)
#define REG_SC_BK02_6C_L      _PK_L_(0x02, 0x6C)
#define REG_SC_BK02_6C_H      _PK_H_(0x02, 0x6C)
#define REG_SC_BK02_6D_L      _PK_L_(0x02, 0x6D)
#define REG_SC_BK02_6D_H      _PK_H_(0x02, 0x6D)
#define REG_SC_BK02_6E_L      _PK_L_(0x02, 0x6E)
#define REG_SC_BK02_6E_H      _PK_H_(0x02, 0x6E)
#define REG_SC_BK02_6F_L      _PK_L_(0x02, 0x6F)
#define REG_SC_BK02_6F_H      _PK_H_(0x02, 0x6F)
#define REG_SC_BK02_70_L      _PK_L_(0x02, 0x70)
#define REG_SC_BK02_70_H      _PK_H_(0x02, 0x70)
#define REG_SC_BK02_71_L      _PK_L_(0x02, 0x71)
#define REG_SC_BK02_71_H      _PK_H_(0x02, 0x71)
#define REG_SC_BK02_72_L      _PK_L_(0x02, 0x72)
#define REG_SC_BK02_72_H      _PK_H_(0x02, 0x72)
#define REG_SC_BK02_73_L      _PK_L_(0x02, 0x73)
#define REG_SC_BK02_73_H      _PK_H_(0x02, 0x73)
#define REG_SC_BK02_74_L      _PK_L_(0x02, 0x74)
#define REG_SC_BK02_74_H      _PK_H_(0x02, 0x74)
#define REG_SC_BK02_75_L      _PK_L_(0x02, 0x75)
#define REG_SC_BK02_75_H      _PK_H_(0x02, 0x75)
#define REG_SC_BK02_76_L      _PK_L_(0x02, 0x76)
#define REG_SC_BK02_76_H      _PK_H_(0x02, 0x76)
#define REG_SC_BK02_77_L      _PK_L_(0x02, 0x77)
#define REG_SC_BK02_77_H      _PK_H_(0x02, 0x77)
#define REG_SC_BK02_78_L      _PK_L_(0x02, 0x78)
#define REG_SC_BK02_78_H      _PK_H_(0x02, 0x78)
#define REG_SC_BK02_79_L      _PK_L_(0x02, 0x79)
#define REG_SC_BK02_79_H      _PK_H_(0x02, 0x79)
#define REG_SC_BK02_7A_L      _PK_L_(0x02, 0x7A)
#define REG_SC_BK02_7A_H      _PK_H_(0x02, 0x7A)
#define REG_SC_BK02_7B_L      _PK_L_(0x02, 0x7B)
#define REG_SC_BK02_7B_H      _PK_H_(0x02, 0x7B)
#define REG_SC_BK02_7C_L      _PK_L_(0x02, 0x7C)
#define REG_SC_BK02_7C_H      _PK_H_(0x02, 0x7C)
#define REG_SC_BK02_7D_L      _PK_L_(0x02, 0x7D)
#define REG_SC_BK02_7D_H      _PK_H_(0x02, 0x7D)
#define REG_SC_BK02_7E_L      _PK_L_(0x02, 0x7E)
#define REG_SC_BK02_7E_H      _PK_H_(0x02, 0x7E)
#define REG_SC_BK02_7F_L      _PK_L_(0x02, 0x7F)
#define REG_SC_BK02_7F_H      _PK_H_(0x02, 0x7F)


//----------------------------------------------
//  BK03: IP1F1
//----------------------------------------------
#define REG_SC_BK03_00_L      _PK_L_(0x03, 0x00)
#define REG_SC_BK03_00_H      _PK_H_(0x03, 0x00)
#define REG_SC_BK03_01_L      _PK_L_(0x03, 0x01)
#define REG_SC_BK03_01_H      _PK_H_(0x03, 0x01)
#define REG_SC_BK03_02_L      _PK_L_(0x03, 0x02)
#define REG_SC_BK03_02_H      _PK_H_(0x03, 0x02)
#define REG_SC_BK03_03_L      _PK_L_(0x03, 0x03)
#define REG_SC_BK03_03_H      _PK_H_(0x03, 0x03)
#define REG_SC_BK03_04_L      _PK_L_(0x03, 0x04)
#define REG_SC_BK03_04_H      _PK_H_(0x03, 0x04)
#define REG_SC_BK03_05_L      _PK_L_(0x03, 0x05)
#define REG_SC_BK03_05_H      _PK_H_(0x03, 0x05)
#define REG_SC_BK03_06_L      _PK_L_(0x03, 0x06)
#define REG_SC_BK03_06_H      _PK_H_(0x03, 0x06)
#define REG_SC_BK03_07_L      _PK_L_(0x03, 0x07)
#define REG_SC_BK03_07_H      _PK_H_(0x03, 0x07)
#define REG_SC_BK03_08_L      _PK_L_(0x03, 0x08)
#define REG_SC_BK03_08_H      _PK_H_(0x03, 0x08)
#define REG_SC_BK03_09_L      _PK_L_(0x03, 0x09)
#define REG_SC_BK03_09_H      _PK_H_(0x03, 0x09)
#define REG_SC_BK03_0A_L      _PK_L_(0x03, 0x0A)
#define REG_SC_BK03_0A_H      _PK_H_(0x03, 0x0A)
#define REG_SC_BK03_0B_L      _PK_L_(0x03, 0x0B)
#define REG_SC_BK03_0B_H      _PK_H_(0x03, 0x0B)
#define REG_SC_BK03_0C_L      _PK_L_(0x03, 0x0C)
#define REG_SC_BK03_0C_H      _PK_H_(0x03, 0x0C)
#define REG_SC_BK03_0D_L      _PK_L_(0x03, 0x0D)
#define REG_SC_BK03_0D_H      _PK_H_(0x03, 0x0D)
#define REG_SC_BK03_0E_L      _PK_L_(0x03, 0x0E)
#define REG_SC_BK03_0E_H      _PK_H_(0x03, 0x0E)
#define REG_SC_BK03_0F_L      _PK_L_(0x03, 0x0F)
#define REG_SC_BK03_0F_H      _PK_H_(0x03, 0x0F)
#define REG_SC_BK03_10_L      _PK_L_(0x03, 0x10)
#define REG_SC_BK03_10_H      _PK_H_(0x03, 0x10)
#define REG_SC_BK03_11_L      _PK_L_(0x03, 0x11)
#define REG_SC_BK03_11_H      _PK_H_(0x03, 0x11)
#define REG_SC_BK03_12_L      _PK_L_(0x03, 0x12)
#define REG_SC_BK03_12_H      _PK_H_(0x03, 0x12)
#define REG_SC_BK03_13_L      _PK_L_(0x03, 0x13)
#define REG_SC_BK03_13_H      _PK_H_(0x03, 0x13)
#define REG_SC_BK03_14_L      _PK_L_(0x03, 0x14)
#define REG_SC_BK03_14_H      _PK_H_(0x03, 0x14)
#define REG_SC_BK03_15_L      _PK_L_(0x03, 0x15)
#define REG_SC_BK03_15_H      _PK_H_(0x03, 0x15)
#define REG_SC_BK03_16_L      _PK_L_(0x03, 0x16)
#define REG_SC_BK03_16_H      _PK_H_(0x03, 0x16)
#define REG_SC_BK03_17_L      _PK_L_(0x03, 0x17)
#define REG_SC_BK03_17_H      _PK_H_(0x03, 0x17)
#define REG_SC_BK03_18_L      _PK_L_(0x03, 0x18)
#define REG_SC_BK03_18_H      _PK_H_(0x03, 0x18)
#define REG_SC_BK03_19_L      _PK_L_(0x03, 0x19)
#define REG_SC_BK03_19_H      _PK_H_(0x03, 0x19)
#define REG_SC_BK03_1A_L      _PK_L_(0x03, 0x1A)
#define REG_SC_BK03_1A_H      _PK_H_(0x03, 0x1A)
#define REG_SC_BK03_1B_L      _PK_L_(0x03, 0x1B)
#define REG_SC_BK03_1B_H      _PK_H_(0x03, 0x1B)
#define REG_SC_BK03_1C_L      _PK_L_(0x03, 0x1C)
#define REG_SC_BK03_1C_H      _PK_H_(0x03, 0x1C)
#define REG_SC_BK03_1D_L      _PK_L_(0x03, 0x1D)
#define REG_SC_BK03_1D_H      _PK_H_(0x03, 0x1D)
#define REG_SC_BK03_1E_L      _PK_L_(0x03, 0x1E)
#define REG_SC_BK03_1E_H      _PK_H_(0x03, 0x1E)
#define REG_SC_BK03_1F_L      _PK_L_(0x03, 0x1F)
#define REG_SC_BK03_1F_H      _PK_H_(0x03, 0x1F)
#define REG_SC_BK03_20_L      _PK_L_(0x03, 0x20)
#define REG_SC_BK03_20_H      _PK_H_(0x03, 0x20)
#define REG_SC_BK03_21_L      _PK_L_(0x03, 0x21)
#define REG_SC_BK03_21_H      _PK_H_(0x03, 0x21)
#define REG_SC_BK03_22_L      _PK_L_(0x03, 0x22)
#define REG_SC_BK03_22_H      _PK_H_(0x03, 0x22)
#define REG_SC_BK03_23_L      _PK_L_(0x03, 0x23)
#define REG_SC_BK03_23_H      _PK_H_(0x03, 0x23)
#define REG_SC_BK03_24_L      _PK_L_(0x03, 0x24)
#define REG_SC_BK03_24_H      _PK_H_(0x03, 0x24)
#define REG_SC_BK03_25_L      _PK_L_(0x03, 0x25)
#define REG_SC_BK03_25_H      _PK_H_(0x03, 0x25)
#define REG_SC_BK03_26_L      _PK_L_(0x03, 0x26)
#define REG_SC_BK03_26_H      _PK_H_(0x03, 0x26)
#define REG_SC_BK03_27_L      _PK_L_(0x03, 0x27)
#define REG_SC_BK03_27_H      _PK_H_(0x03, 0x27)
#define REG_SC_BK03_28_L      _PK_L_(0x03, 0x28)
#define REG_SC_BK03_28_H      _PK_H_(0x03, 0x28)
#define REG_SC_BK03_29_L      _PK_L_(0x03, 0x29)
#define REG_SC_BK03_29_H      _PK_H_(0x03, 0x29)
#define REG_SC_BK03_2A_L      _PK_L_(0x03, 0x2A)
#define REG_SC_BK03_2A_H      _PK_H_(0x03, 0x2A)
#define REG_SC_BK03_2B_L      _PK_L_(0x03, 0x2B)
#define REG_SC_BK03_2B_H      _PK_H_(0x03, 0x2B)
#define REG_SC_BK03_2C_L      _PK_L_(0x03, 0x2C)
#define REG_SC_BK03_2C_H      _PK_H_(0x03, 0x2C)
#define REG_SC_BK03_2D_L      _PK_L_(0x03, 0x2D)
#define REG_SC_BK03_2D_H      _PK_H_(0x03, 0x2D)
#define REG_SC_BK03_2E_L      _PK_L_(0x03, 0x2E)
#define REG_SC_BK03_2E_H      _PK_H_(0x03, 0x2E)
#define REG_SC_BK03_2F_L      _PK_L_(0x03, 0x2F)
#define REG_SC_BK03_2F_H      _PK_H_(0x03, 0x2F)
#define REG_SC_BK03_30_L      _PK_L_(0x03, 0x30)
#define REG_SC_BK03_30_H      _PK_H_(0x03, 0x30)
#define REG_SC_BK03_31_L      _PK_L_(0x03, 0x31)
#define REG_SC_BK03_31_H      _PK_H_(0x03, 0x31)
#define REG_SC_BK03_32_L      _PK_L_(0x03, 0x32)
#define REG_SC_BK03_32_H      _PK_H_(0x03, 0x32)
#define REG_SC_BK03_33_L      _PK_L_(0x03, 0x33)
#define REG_SC_BK03_33_H      _PK_H_(0x03, 0x33)
#define REG_SC_BK03_34_L      _PK_L_(0x03, 0x34)
#define REG_SC_BK03_34_H      _PK_H_(0x03, 0x34)
#define REG_SC_BK03_35_L      _PK_L_(0x03, 0x35)
#define REG_SC_BK03_35_H      _PK_H_(0x03, 0x35)
#define REG_SC_BK03_36_L      _PK_L_(0x03, 0x36)
#define REG_SC_BK03_36_H      _PK_H_(0x03, 0x36)
#define REG_SC_BK03_37_L      _PK_L_(0x03, 0x37)
#define REG_SC_BK03_37_H      _PK_H_(0x03, 0x37)
#define REG_SC_BK03_38_L      _PK_L_(0x03, 0x38)
#define REG_SC_BK03_38_H      _PK_H_(0x03, 0x38)
#define REG_SC_BK03_39_L      _PK_L_(0x03, 0x39)
#define REG_SC_BK03_39_H      _PK_H_(0x03, 0x39)
#define REG_SC_BK03_3A_L      _PK_L_(0x03, 0x3A)
#define REG_SC_BK03_3A_H      _PK_H_(0x03, 0x3A)
#define REG_SC_BK03_3B_L      _PK_L_(0x03, 0x3B)
#define REG_SC_BK03_3B_H      _PK_H_(0x03, 0x3B)
#define REG_SC_BK03_3C_L      _PK_L_(0x03, 0x3C)
#define REG_SC_BK03_3C_H      _PK_H_(0x03, 0x3C)
#define REG_SC_BK03_3D_L      _PK_L_(0x03, 0x3D)
#define REG_SC_BK03_3D_H      _PK_H_(0x03, 0x3D)
#define REG_SC_BK03_3E_L      _PK_L_(0x03, 0x3E)
#define REG_SC_BK03_3E_H      _PK_H_(0x03, 0x3E)
#define REG_SC_BK03_3F_L      _PK_L_(0x03, 0x3F)
#define REG_SC_BK03_3F_H      _PK_H_(0x03, 0x3F)
#define REG_SC_BK03_40_L      _PK_L_(0x03, 0x40)
#define REG_SC_BK03_40_H      _PK_H_(0x03, 0x40)
#define REG_SC_BK03_41_L      _PK_L_(0x03, 0x41)
#define REG_SC_BK03_41_H      _PK_H_(0x03, 0x41)
#define REG_SC_BK03_42_L      _PK_L_(0x03, 0x42)
#define REG_SC_BK03_42_H      _PK_H_(0x03, 0x42)
#define REG_SC_BK03_43_L      _PK_L_(0x03, 0x43)
#define REG_SC_BK03_43_H      _PK_H_(0x03, 0x43)
#define REG_SC_BK03_44_L      _PK_L_(0x03, 0x44)
#define REG_SC_BK03_44_H      _PK_H_(0x03, 0x44)
#define REG_SC_BK03_45_L      _PK_L_(0x03, 0x45)
#define REG_SC_BK03_45_H      _PK_H_(0x03, 0x45)
#define REG_SC_BK03_46_L      _PK_L_(0x03, 0x46)
#define REG_SC_BK03_46_H      _PK_H_(0x03, 0x46)
#define REG_SC_BK03_47_L      _PK_L_(0x03, 0x47)
#define REG_SC_BK03_47_H      _PK_H_(0x03, 0x47)
#define REG_SC_BK03_48_L      _PK_L_(0x03, 0x48)
#define REG_SC_BK03_48_H      _PK_H_(0x03, 0x48)
#define REG_SC_BK03_49_L      _PK_L_(0x03, 0x49)
#define REG_SC_BK03_49_H      _PK_H_(0x03, 0x49)
#define REG_SC_BK03_4A_L      _PK_L_(0x03, 0x4A)
#define REG_SC_BK03_4A_H      _PK_H_(0x03, 0x4A)
#define REG_SC_BK03_4B_L      _PK_L_(0x03, 0x4B)
#define REG_SC_BK03_4B_H      _PK_H_(0x03, 0x4B)
#define REG_SC_BK03_4C_L      _PK_L_(0x03, 0x4C)
#define REG_SC_BK03_4C_H      _PK_H_(0x03, 0x4C)
#define REG_SC_BK03_4D_L      _PK_L_(0x03, 0x4D)
#define REG_SC_BK03_4D_H      _PK_H_(0x03, 0x4D)
#define REG_SC_BK03_4E_L      _PK_L_(0x03, 0x4E)
#define REG_SC_BK03_4E_H      _PK_H_(0x03, 0x4E)
#define REG_SC_BK03_4F_L      _PK_L_(0x03, 0x4F)
#define REG_SC_BK03_4F_H      _PK_H_(0x03, 0x4F)
#define REG_SC_BK03_50_L      _PK_L_(0x03, 0x50)
#define REG_SC_BK03_50_H      _PK_H_(0x03, 0x50)
#define REG_SC_BK03_51_L      _PK_L_(0x03, 0x51)
#define REG_SC_BK03_51_H      _PK_H_(0x03, 0x51)
#define REG_SC_BK03_52_L      _PK_L_(0x03, 0x52)
#define REG_SC_BK03_52_H      _PK_H_(0x03, 0x52)
#define REG_SC_BK03_53_L      _PK_L_(0x03, 0x53)
#define REG_SC_BK03_53_H      _PK_H_(0x03, 0x53)
#define REG_SC_BK03_54_L      _PK_L_(0x03, 0x54)
#define REG_SC_BK03_54_H      _PK_H_(0x03, 0x54)
#define REG_SC_BK03_55_L      _PK_L_(0x03, 0x55)
#define REG_SC_BK03_55_H      _PK_H_(0x03, 0x55)
#define REG_SC_BK03_56_L      _PK_L_(0x03, 0x56)
#define REG_SC_BK03_56_H      _PK_H_(0x03, 0x56)
#define REG_SC_BK03_57_L      _PK_L_(0x03, 0x57)
#define REG_SC_BK03_57_H      _PK_H_(0x03, 0x57)
#define REG_SC_BK03_58_L      _PK_L_(0x03, 0x58)
#define REG_SC_BK03_58_H      _PK_H_(0x03, 0x58)
#define REG_SC_BK03_59_L      _PK_L_(0x03, 0x59)
#define REG_SC_BK03_59_H      _PK_H_(0x03, 0x59)
#define REG_SC_BK03_5A_L      _PK_L_(0x03, 0x5A)
#define REG_SC_BK03_5A_H      _PK_H_(0x03, 0x5A)
#define REG_SC_BK03_5B_L      _PK_L_(0x03, 0x5B)
#define REG_SC_BK03_5B_H      _PK_H_(0x03, 0x5B)
#define REG_SC_BK03_5C_L      _PK_L_(0x03, 0x5C)
#define REG_SC_BK03_5C_H      _PK_H_(0x03, 0x5C)
#define REG_SC_BK03_5D_L      _PK_L_(0x03, 0x5D)
#define REG_SC_BK03_5D_H      _PK_H_(0x03, 0x5D)
#define REG_SC_BK03_5E_L      _PK_L_(0x03, 0x5E)
#define REG_SC_BK03_5E_H      _PK_H_(0x03, 0x5E)
#define REG_SC_BK03_5F_L      _PK_L_(0x03, 0x5F)
#define REG_SC_BK03_5F_H      _PK_H_(0x03, 0x5F)
#define REG_SC_BK03_60_L      _PK_L_(0x03, 0x60)
#define REG_SC_BK03_60_H      _PK_H_(0x03, 0x60)
#define REG_SC_BK03_61_L      _PK_L_(0x03, 0x61)
#define REG_SC_BK03_61_H      _PK_H_(0x03, 0x61)
#define REG_SC_BK03_62_L      _PK_L_(0x03, 0x62)
#define REG_SC_BK03_62_H      _PK_H_(0x03, 0x62)
#define REG_SC_BK03_63_L      _PK_L_(0x03, 0x63)
#define REG_SC_BK03_63_H      _PK_H_(0x03, 0x63)
#define REG_SC_BK03_64_L      _PK_L_(0x03, 0x64)
#define REG_SC_BK03_64_H      _PK_H_(0x03, 0x64)
#define REG_SC_BK03_65_L      _PK_L_(0x03, 0x65)
#define REG_SC_BK03_65_H      _PK_H_(0x03, 0x65)
#define REG_SC_BK03_66_L      _PK_L_(0x03, 0x66)
#define REG_SC_BK03_66_H      _PK_H_(0x03, 0x66)
#define REG_SC_BK03_67_L      _PK_L_(0x03, 0x67)
#define REG_SC_BK03_67_H      _PK_H_(0x03, 0x67)
#define REG_SC_BK03_68_L      _PK_L_(0x03, 0x68)
#define REG_SC_BK03_68_H      _PK_H_(0x03, 0x68)
#define REG_SC_BK03_69_L      _PK_L_(0x03, 0x69)
#define REG_SC_BK03_69_H      _PK_H_(0x03, 0x69)
#define REG_SC_BK03_6A_L      _PK_L_(0x03, 0x6A)
#define REG_SC_BK03_6A_H      _PK_H_(0x03, 0x6A)
#define REG_SC_BK03_6B_L      _PK_L_(0x03, 0x6B)
#define REG_SC_BK03_6B_H      _PK_H_(0x03, 0x6B)
#define REG_SC_BK03_6C_L      _PK_L_(0x03, 0x6C)
#define REG_SC_BK03_6C_H      _PK_H_(0x03, 0x6C)
#define REG_SC_BK03_6D_L      _PK_L_(0x03, 0x6D)
#define REG_SC_BK03_6D_H      _PK_H_(0x03, 0x6D)
#define REG_SC_BK03_6E_L      _PK_L_(0x03, 0x6E)
#define REG_SC_BK03_6E_H      _PK_H_(0x03, 0x6E)
#define REG_SC_BK03_6F_L      _PK_L_(0x03, 0x6F)
#define REG_SC_BK03_6F_H      _PK_H_(0x03, 0x6F)
#define REG_SC_BK03_70_L      _PK_L_(0x03, 0x70)
#define REG_SC_BK03_70_H      _PK_H_(0x03, 0x70)
#define REG_SC_BK03_71_L      _PK_L_(0x03, 0x71)
#define REG_SC_BK03_71_H      _PK_H_(0x03, 0x71)
#define REG_SC_BK03_72_L      _PK_L_(0x03, 0x72)
#define REG_SC_BK03_72_H      _PK_H_(0x03, 0x72)
#define REG_SC_BK03_73_L      _PK_L_(0x03, 0x73)
#define REG_SC_BK03_73_H      _PK_H_(0x03, 0x73)
#define REG_SC_BK03_74_L      _PK_L_(0x03, 0x74)
#define REG_SC_BK03_74_H      _PK_H_(0x03, 0x74)
#define REG_SC_BK03_75_L      _PK_L_(0x03, 0x75)
#define REG_SC_BK03_75_H      _PK_H_(0x03, 0x75)
#define REG_SC_BK03_76_L      _PK_L_(0x03, 0x76)
#define REG_SC_BK03_76_H      _PK_H_(0x03, 0x76)
#define REG_SC_BK03_77_L      _PK_L_(0x03, 0x77)
#define REG_SC_BK03_77_H      _PK_H_(0x03, 0x77)
#define REG_SC_BK03_78_L      _PK_L_(0x03, 0x78)
#define REG_SC_BK03_78_H      _PK_H_(0x03, 0x78)
#define REG_SC_BK03_79_L      _PK_L_(0x03, 0x79)
#define REG_SC_BK03_79_H      _PK_H_(0x03, 0x79)
#define REG_SC_BK03_7A_L      _PK_L_(0x03, 0x7A)
#define REG_SC_BK03_7A_H      _PK_H_(0x03, 0x7A)
#define REG_SC_BK03_7B_L      _PK_L_(0x03, 0x7B)
#define REG_SC_BK03_7B_H      _PK_H_(0x03, 0x7B)
#define REG_SC_BK03_7C_L      _PK_L_(0x03, 0x7C)
#define REG_SC_BK03_7C_H      _PK_H_(0x03, 0x7C)
#define REG_SC_BK03_7D_L      _PK_L_(0x03, 0x7D)
#define REG_SC_BK03_7D_H      _PK_H_(0x03, 0x7D)
#define REG_SC_BK03_7E_L      _PK_L_(0x03, 0x7E)
#define REG_SC_BK03_7E_H      _PK_H_(0x03, 0x7E)
#define REG_SC_BK03_7F_L      _PK_L_(0x03, 0x7F)
#define REG_SC_BK03_7F_H      _PK_H_(0x03, 0x7F)


//----------------------------------------------
//  BK04: IP2F1
//----------------------------------------------
#define REG_SC_BK04_00_L      _PK_L_(0x04, 0x00)
#define REG_SC_BK04_00_H      _PK_H_(0x04, 0x00)
#define REG_SC_BK04_01_L      _PK_L_(0x04, 0x01)
#define REG_SC_BK04_01_H      _PK_H_(0x04, 0x01)
#define REG_SC_BK04_02_L      _PK_L_(0x04, 0x02)
#define REG_SC_BK04_02_H      _PK_H_(0x04, 0x02)
#define REG_SC_BK04_03_L      _PK_L_(0x04, 0x03)
#define REG_SC_BK04_03_H      _PK_H_(0x04, 0x03)
#define REG_SC_BK04_04_L      _PK_L_(0x04, 0x04)
#define REG_SC_BK04_04_H      _PK_H_(0x04, 0x04)
#define REG_SC_BK04_05_L      _PK_L_(0x04, 0x05)
#define REG_SC_BK04_05_H      _PK_H_(0x04, 0x05)
#define REG_SC_BK04_06_L      _PK_L_(0x04, 0x06)
#define REG_SC_BK04_06_H      _PK_H_(0x04, 0x06)
#define REG_SC_BK04_07_L      _PK_L_(0x04, 0x07)
#define REG_SC_BK04_07_H      _PK_H_(0x04, 0x07)
#define REG_SC_BK04_08_L      _PK_L_(0x04, 0x08)
#define REG_SC_BK04_08_H      _PK_H_(0x04, 0x08)
#define REG_SC_BK04_09_L      _PK_L_(0x04, 0x09)
#define REG_SC_BK04_09_H      _PK_H_(0x04, 0x09)
#define REG_SC_BK04_0A_L      _PK_L_(0x04, 0x0A)
#define REG_SC_BK04_0A_H      _PK_H_(0x04, 0x0A)
#define REG_SC_BK04_0B_L      _PK_L_(0x04, 0x0B)
#define REG_SC_BK04_0B_H      _PK_H_(0x04, 0x0B)
#define REG_SC_BK04_0C_L      _PK_L_(0x04, 0x0C)
#define REG_SC_BK04_0C_H      _PK_H_(0x04, 0x0C)
#define REG_SC_BK04_0D_L      _PK_L_(0x04, 0x0D)
#define REG_SC_BK04_0D_H      _PK_H_(0x04, 0x0D)
#define REG_SC_BK04_0E_L      _PK_L_(0x04, 0x0E)
#define REG_SC_BK04_0E_H      _PK_H_(0x04, 0x0E)
#define REG_SC_BK04_0F_L      _PK_L_(0x04, 0x0F)
#define REG_SC_BK04_0F_H      _PK_H_(0x04, 0x0F)
#define REG_SC_BK04_10_L      _PK_L_(0x04, 0x10)
#define REG_SC_BK04_10_H      _PK_H_(0x04, 0x10)
#define REG_SC_BK04_11_L      _PK_L_(0x04, 0x11)
#define REG_SC_BK04_11_H      _PK_H_(0x04, 0x11)
#define REG_SC_BK04_12_L      _PK_L_(0x04, 0x12)
#define REG_SC_BK04_12_H      _PK_H_(0x04, 0x12)
#define REG_SC_BK04_13_L      _PK_L_(0x04, 0x13)
#define REG_SC_BK04_13_H      _PK_H_(0x04, 0x13)
#define REG_SC_BK04_14_L      _PK_L_(0x04, 0x14)
#define REG_SC_BK04_14_H      _PK_H_(0x04, 0x14)
#define REG_SC_BK04_15_L      _PK_L_(0x04, 0x15)
#define REG_SC_BK04_15_H      _PK_H_(0x04, 0x15)
#define REG_SC_BK04_16_L      _PK_L_(0x04, 0x16)
#define REG_SC_BK04_16_H      _PK_H_(0x04, 0x16)
#define REG_SC_BK04_17_L      _PK_L_(0x04, 0x17)
#define REG_SC_BK04_17_H      _PK_H_(0x04, 0x17)
#define REG_SC_BK04_18_L      _PK_L_(0x04, 0x18)
#define REG_SC_BK04_18_H      _PK_H_(0x04, 0x18)
#define REG_SC_BK04_19_L      _PK_L_(0x04, 0x19)
#define REG_SC_BK04_19_H      _PK_H_(0x04, 0x19)
#define REG_SC_BK04_1A_L      _PK_L_(0x04, 0x1A)
#define REG_SC_BK04_1A_H      _PK_H_(0x04, 0x1A)
#define REG_SC_BK04_1B_L      _PK_L_(0x04, 0x1B)
#define REG_SC_BK04_1B_H      _PK_H_(0x04, 0x1B)
#define REG_SC_BK04_1C_L      _PK_L_(0x04, 0x1C)
#define REG_SC_BK04_1C_H      _PK_H_(0x04, 0x1C)
#define REG_SC_BK04_1D_L      _PK_L_(0x04, 0x1D)
#define REG_SC_BK04_1D_H      _PK_H_(0x04, 0x1D)
#define REG_SC_BK04_1E_L      _PK_L_(0x04, 0x1E)
#define REG_SC_BK04_1E_H      _PK_H_(0x04, 0x1E)
#define REG_SC_BK04_1F_L      _PK_L_(0x04, 0x1F)
#define REG_SC_BK04_1F_H      _PK_H_(0x04, 0x1F)
#define REG_SC_BK04_20_L      _PK_L_(0x04, 0x20)
#define REG_SC_BK04_20_H      _PK_H_(0x04, 0x20)
#define REG_SC_BK04_21_L      _PK_L_(0x04, 0x21)
#define REG_SC_BK04_21_H      _PK_H_(0x04, 0x21)
#define REG_SC_BK04_22_L      _PK_L_(0x04, 0x22)
#define REG_SC_BK04_22_H      _PK_H_(0x04, 0x22)
#define REG_SC_BK04_23_L      _PK_L_(0x04, 0x23)
#define REG_SC_BK04_23_H      _PK_H_(0x04, 0x23)
#define REG_SC_BK04_24_L      _PK_L_(0x04, 0x24)
#define REG_SC_BK04_24_H      _PK_H_(0x04, 0x24)
#define REG_SC_BK04_25_L      _PK_L_(0x04, 0x25)
#define REG_SC_BK04_25_H      _PK_H_(0x04, 0x25)
#define REG_SC_BK04_26_L      _PK_L_(0x04, 0x26)
#define REG_SC_BK04_26_H      _PK_H_(0x04, 0x26)
#define REG_SC_BK04_27_L      _PK_L_(0x04, 0x27)
#define REG_SC_BK04_27_H      _PK_H_(0x04, 0x27)
#define REG_SC_BK04_28_L      _PK_L_(0x04, 0x28)
#define REG_SC_BK04_28_H      _PK_H_(0x04, 0x28)
#define REG_SC_BK04_29_L      _PK_L_(0x04, 0x29)
#define REG_SC_BK04_29_H      _PK_H_(0x04, 0x29)
#define REG_SC_BK04_2A_L      _PK_L_(0x04, 0x2A)
#define REG_SC_BK04_2A_H      _PK_H_(0x04, 0x2A)
#define REG_SC_BK04_2B_L      _PK_L_(0x04, 0x2B)
#define REG_SC_BK04_2B_H      _PK_H_(0x04, 0x2B)
#define REG_SC_BK04_2C_L      _PK_L_(0x04, 0x2C)
#define REG_SC_BK04_2C_H      _PK_H_(0x04, 0x2C)
#define REG_SC_BK04_2D_L      _PK_L_(0x04, 0x2D)
#define REG_SC_BK04_2D_H      _PK_H_(0x04, 0x2D)
#define REG_SC_BK04_2E_L      _PK_L_(0x04, 0x2E)
#define REG_SC_BK04_2E_H      _PK_H_(0x04, 0x2E)
#define REG_SC_BK04_2F_L      _PK_L_(0x04, 0x2F)
#define REG_SC_BK04_2F_H      _PK_H_(0x04, 0x2F)
#define REG_SC_BK04_30_L      _PK_L_(0x04, 0x30)
#define REG_SC_BK04_30_H      _PK_H_(0x04, 0x30)
#define REG_SC_BK04_31_L      _PK_L_(0x04, 0x31)
#define REG_SC_BK04_31_H      _PK_H_(0x04, 0x31)
#define REG_SC_BK04_32_L      _PK_L_(0x04, 0x32)
#define REG_SC_BK04_32_H      _PK_H_(0x04, 0x32)
#define REG_SC_BK04_33_L      _PK_L_(0x04, 0x33)
#define REG_SC_BK04_33_H      _PK_H_(0x04, 0x33)
#define REG_SC_BK04_34_L      _PK_L_(0x04, 0x34)
#define REG_SC_BK04_34_H      _PK_H_(0x04, 0x34)
#define REG_SC_BK04_35_L      _PK_L_(0x04, 0x35)
#define REG_SC_BK04_35_H      _PK_H_(0x04, 0x35)
#define REG_SC_BK04_36_L      _PK_L_(0x04, 0x36)
#define REG_SC_BK04_36_H      _PK_H_(0x04, 0x36)
#define REG_SC_BK04_37_L      _PK_L_(0x04, 0x37)
#define REG_SC_BK04_37_H      _PK_H_(0x04, 0x37)
#define REG_SC_BK04_38_L      _PK_L_(0x04, 0x38)
#define REG_SC_BK04_38_H      _PK_H_(0x04, 0x38)
#define REG_SC_BK04_39_L      _PK_L_(0x04, 0x39)
#define REG_SC_BK04_39_H      _PK_H_(0x04, 0x39)
#define REG_SC_BK04_3A_L      _PK_L_(0x04, 0x3A)
#define REG_SC_BK04_3A_H      _PK_H_(0x04, 0x3A)
#define REG_SC_BK04_3B_L      _PK_L_(0x04, 0x3B)
#define REG_SC_BK04_3B_H      _PK_H_(0x04, 0x3B)
#define REG_SC_BK04_3C_L      _PK_L_(0x04, 0x3C)
#define REG_SC_BK04_3C_H      _PK_H_(0x04, 0x3C)
#define REG_SC_BK04_3D_L      _PK_L_(0x04, 0x3D)
#define REG_SC_BK04_3D_H      _PK_H_(0x04, 0x3D)
#define REG_SC_BK04_3E_L      _PK_L_(0x04, 0x3E)
#define REG_SC_BK04_3E_H      _PK_H_(0x04, 0x3E)
#define REG_SC_BK04_3F_L      _PK_L_(0x04, 0x3F)
#define REG_SC_BK04_3F_H      _PK_H_(0x04, 0x3F)
#define REG_SC_BK04_40_L      _PK_L_(0x04, 0x40)
#define REG_SC_BK04_40_H      _PK_H_(0x04, 0x40)
#define REG_SC_BK04_41_L      _PK_L_(0x04, 0x41)
#define REG_SC_BK04_41_H      _PK_H_(0x04, 0x41)
#define REG_SC_BK04_42_L      _PK_L_(0x04, 0x42)
#define REG_SC_BK04_42_H      _PK_H_(0x04, 0x42)
#define REG_SC_BK04_43_L      _PK_L_(0x04, 0x43)
#define REG_SC_BK04_43_H      _PK_H_(0x04, 0x43)
#define REG_SC_BK04_44_L      _PK_L_(0x04, 0x44)
#define REG_SC_BK04_44_H      _PK_H_(0x04, 0x44)
#define REG_SC_BK04_45_L      _PK_L_(0x04, 0x45)
#define REG_SC_BK04_45_H      _PK_H_(0x04, 0x45)
#define REG_SC_BK04_46_L      _PK_L_(0x04, 0x46)
#define REG_SC_BK04_46_H      _PK_H_(0x04, 0x46)
#define REG_SC_BK04_47_L      _PK_L_(0x04, 0x47)
#define REG_SC_BK04_47_H      _PK_H_(0x04, 0x47)
#define REG_SC_BK04_48_L      _PK_L_(0x04, 0x48)
#define REG_SC_BK04_48_H      _PK_H_(0x04, 0x48)
#define REG_SC_BK04_49_L      _PK_L_(0x04, 0x49)
#define REG_SC_BK04_49_H      _PK_H_(0x04, 0x49)
#define REG_SC_BK04_4A_L      _PK_L_(0x04, 0x4A)
#define REG_SC_BK04_4A_H      _PK_H_(0x04, 0x4A)
#define REG_SC_BK04_4B_L      _PK_L_(0x04, 0x4B)
#define REG_SC_BK04_4B_H      _PK_H_(0x04, 0x4B)
#define REG_SC_BK04_4C_L      _PK_L_(0x04, 0x4C)
#define REG_SC_BK04_4C_H      _PK_H_(0x04, 0x4C)
#define REG_SC_BK04_4D_L      _PK_L_(0x04, 0x4D)
#define REG_SC_BK04_4D_H      _PK_H_(0x04, 0x4D)
#define REG_SC_BK04_4E_L      _PK_L_(0x04, 0x4E)
#define REG_SC_BK04_4E_H      _PK_H_(0x04, 0x4E)
#define REG_SC_BK04_4F_L      _PK_L_(0x04, 0x4F)
#define REG_SC_BK04_4F_H      _PK_H_(0x04, 0x4F)
#define REG_SC_BK04_50_L      _PK_L_(0x04, 0x50)
#define REG_SC_BK04_50_H      _PK_H_(0x04, 0x50)
#define REG_SC_BK04_51_L      _PK_L_(0x04, 0x51)
#define REG_SC_BK04_51_H      _PK_H_(0x04, 0x51)
#define REG_SC_BK04_52_L      _PK_L_(0x04, 0x52)
#define REG_SC_BK04_52_H      _PK_H_(0x04, 0x52)
#define REG_SC_BK04_53_L      _PK_L_(0x04, 0x53)
#define REG_SC_BK04_53_H      _PK_H_(0x04, 0x53)
#define REG_SC_BK04_54_L      _PK_L_(0x04, 0x54)
#define REG_SC_BK04_54_H      _PK_H_(0x04, 0x54)
#define REG_SC_BK04_55_L      _PK_L_(0x04, 0x55)
#define REG_SC_BK04_55_H      _PK_H_(0x04, 0x55)
#define REG_SC_BK04_56_L      _PK_L_(0x04, 0x56)
#define REG_SC_BK04_56_H      _PK_H_(0x04, 0x56)
#define REG_SC_BK04_57_L      _PK_L_(0x04, 0x57)
#define REG_SC_BK04_57_H      _PK_H_(0x04, 0x57)
#define REG_SC_BK04_58_L      _PK_L_(0x04, 0x58)
#define REG_SC_BK04_58_H      _PK_H_(0x04, 0x58)
#define REG_SC_BK04_59_L      _PK_L_(0x04, 0x59)
#define REG_SC_BK04_59_H      _PK_H_(0x04, 0x59)
#define REG_SC_BK04_5A_L      _PK_L_(0x04, 0x5A)
#define REG_SC_BK04_5A_H      _PK_H_(0x04, 0x5A)
#define REG_SC_BK04_5B_L      _PK_L_(0x04, 0x5B)
#define REG_SC_BK04_5B_H      _PK_H_(0x04, 0x5B)
#define REG_SC_BK04_5C_L      _PK_L_(0x04, 0x5C)
#define REG_SC_BK04_5C_H      _PK_H_(0x04, 0x5C)
#define REG_SC_BK04_5D_L      _PK_L_(0x04, 0x5D)
#define REG_SC_BK04_5D_H      _PK_H_(0x04, 0x5D)
#define REG_SC_BK04_5E_L      _PK_L_(0x04, 0x5E)
#define REG_SC_BK04_5E_H      _PK_H_(0x04, 0x5E)
#define REG_SC_BK04_5F_L      _PK_L_(0x04, 0x5F)
#define REG_SC_BK04_5F_H      _PK_H_(0x04, 0x5F)
#define REG_SC_BK04_60_L      _PK_L_(0x04, 0x60)
#define REG_SC_BK04_60_H      _PK_H_(0x04, 0x60)
#define REG_SC_BK04_61_L      _PK_L_(0x04, 0x61)
#define REG_SC_BK04_61_H      _PK_H_(0x04, 0x61)
#define REG_SC_BK04_62_L      _PK_L_(0x04, 0x62)
#define REG_SC_BK04_62_H      _PK_H_(0x04, 0x62)
#define REG_SC_BK04_63_L      _PK_L_(0x04, 0x63)
#define REG_SC_BK04_63_H      _PK_H_(0x04, 0x63)
#define REG_SC_BK04_64_L      _PK_L_(0x04, 0x64)
#define REG_SC_BK04_64_H      _PK_H_(0x04, 0x64)
#define REG_SC_BK04_65_L      _PK_L_(0x04, 0x65)
#define REG_SC_BK04_65_H      _PK_H_(0x04, 0x65)
#define REG_SC_BK04_66_L      _PK_L_(0x04, 0x66)
#define REG_SC_BK04_66_H      _PK_H_(0x04, 0x66)
#define REG_SC_BK04_67_L      _PK_L_(0x04, 0x67)
#define REG_SC_BK04_67_H      _PK_H_(0x04, 0x67)
#define REG_SC_BK04_68_L      _PK_L_(0x04, 0x68)
#define REG_SC_BK04_68_H      _PK_H_(0x04, 0x68)
#define REG_SC_BK04_69_L      _PK_L_(0x04, 0x69)
#define REG_SC_BK04_69_H      _PK_H_(0x04, 0x69)
#define REG_SC_BK04_6A_L      _PK_L_(0x04, 0x6A)
#define REG_SC_BK04_6A_H      _PK_H_(0x04, 0x6A)
#define REG_SC_BK04_6B_L      _PK_L_(0x04, 0x6B)
#define REG_SC_BK04_6B_H      _PK_H_(0x04, 0x6B)
#define REG_SC_BK04_6C_L      _PK_L_(0x04, 0x6C)
#define REG_SC_BK04_6C_H      _PK_H_(0x04, 0x6C)
#define REG_SC_BK04_6D_L      _PK_L_(0x04, 0x6D)
#define REG_SC_BK04_6D_H      _PK_H_(0x04, 0x6D)
#define REG_SC_BK04_6E_L      _PK_L_(0x04, 0x6E)
#define REG_SC_BK04_6E_H      _PK_H_(0x04, 0x6E)
#define REG_SC_BK04_6F_L      _PK_L_(0x04, 0x6F)
#define REG_SC_BK04_6F_H      _PK_H_(0x04, 0x6F)
#define REG_SC_BK04_70_L      _PK_L_(0x04, 0x70)
#define REG_SC_BK04_70_H      _PK_H_(0x04, 0x70)
#define REG_SC_BK04_71_L      _PK_L_(0x04, 0x71)
#define REG_SC_BK04_71_H      _PK_H_(0x04, 0x71)
#define REG_SC_BK04_72_L      _PK_L_(0x04, 0x72)
#define REG_SC_BK04_72_H      _PK_H_(0x04, 0x72)
#define REG_SC_BK04_73_L      _PK_L_(0x04, 0x73)
#define REG_SC_BK04_73_H      _PK_H_(0x04, 0x73)
#define REG_SC_BK04_74_L      _PK_L_(0x04, 0x74)
#define REG_SC_BK04_74_H      _PK_H_(0x04, 0x74)
#define REG_SC_BK04_75_L      _PK_L_(0x04, 0x75)
#define REG_SC_BK04_75_H      _PK_H_(0x04, 0x75)
#define REG_SC_BK04_76_L      _PK_L_(0x04, 0x76)
#define REG_SC_BK04_76_H      _PK_H_(0x04, 0x76)
#define REG_SC_BK04_77_L      _PK_L_(0x04, 0x77)
#define REG_SC_BK04_77_H      _PK_H_(0x04, 0x77)
#define REG_SC_BK04_78_L      _PK_L_(0x04, 0x78)
#define REG_SC_BK04_78_H      _PK_H_(0x04, 0x78)
#define REG_SC_BK04_79_L      _PK_L_(0x04, 0x79)
#define REG_SC_BK04_79_H      _PK_H_(0x04, 0x79)
#define REG_SC_BK04_7A_L      _PK_L_(0x04, 0x7A)
#define REG_SC_BK04_7A_H      _PK_H_(0x04, 0x7A)
#define REG_SC_BK04_7B_L      _PK_L_(0x04, 0x7B)
#define REG_SC_BK04_7B_H      _PK_H_(0x04, 0x7B)
#define REG_SC_BK04_7C_L      _PK_L_(0x04, 0x7C)
#define REG_SC_BK04_7C_H      _PK_H_(0x04, 0x7C)
#define REG_SC_BK04_7D_L      _PK_L_(0x04, 0x7D)
#define REG_SC_BK04_7D_H      _PK_H_(0x04, 0x7D)
#define REG_SC_BK04_7E_L      _PK_L_(0x04, 0x7E)
#define REG_SC_BK04_7E_H      _PK_H_(0x04, 0x7E)
#define REG_SC_BK04_7F_L      _PK_L_(0x04, 0x7F)
#define REG_SC_BK04_7F_H      _PK_H_(0x04, 0x7F)


//----------------------------------------------
//  BK05: OPM
//----------------------------------------------
#define REG_SC_BK05_00_L      _PK_L_(0x05, 0x00)
#define REG_SC_BK05_00_H      _PK_H_(0x05, 0x00)
#define REG_SC_BK05_01_L      _PK_L_(0x05, 0x01)
#define REG_SC_BK05_01_H      _PK_H_(0x05, 0x01)
#define REG_SC_BK05_02_L      _PK_L_(0x05, 0x02)
#define REG_SC_BK05_02_H      _PK_H_(0x05, 0x02)
#define REG_SC_BK05_03_L      _PK_L_(0x05, 0x03)
#define REG_SC_BK05_03_H      _PK_H_(0x05, 0x03)
#define REG_SC_BK05_04_L      _PK_L_(0x05, 0x04)
#define REG_SC_BK05_04_H      _PK_H_(0x05, 0x04)
#define REG_SC_BK05_05_L      _PK_L_(0x05, 0x05)
#define REG_SC_BK05_05_H      _PK_H_(0x05, 0x05)
#define REG_SC_BK05_06_L      _PK_L_(0x05, 0x06)
#define REG_SC_BK05_06_H      _PK_H_(0x05, 0x06)
#define REG_SC_BK05_07_L      _PK_L_(0x05, 0x07)
#define REG_SC_BK05_07_H      _PK_H_(0x05, 0x07)
#define REG_SC_BK05_08_L      _PK_L_(0x05, 0x08)
#define REG_SC_BK05_08_H      _PK_H_(0x05, 0x08)
#define REG_SC_BK05_09_L      _PK_L_(0x05, 0x09)
#define REG_SC_BK05_09_H      _PK_H_(0x05, 0x09)
#define REG_SC_BK05_0A_L      _PK_L_(0x05, 0x0A)
#define REG_SC_BK05_0A_H      _PK_H_(0x05, 0x0A)
#define REG_SC_BK05_0B_L      _PK_L_(0x05, 0x0B)
#define REG_SC_BK05_0B_H      _PK_H_(0x05, 0x0B)
#define REG_SC_BK05_0C_L      _PK_L_(0x05, 0x0C)
#define REG_SC_BK05_0C_H      _PK_H_(0x05, 0x0C)
#define REG_SC_BK05_0D_L      _PK_L_(0x05, 0x0D)
#define REG_SC_BK05_0D_H      _PK_H_(0x05, 0x0D)
#define REG_SC_BK05_0E_L      _PK_L_(0x05, 0x0E)
#define REG_SC_BK05_0E_H      _PK_H_(0x05, 0x0E)
#define REG_SC_BK05_0F_L      _PK_L_(0x05, 0x0F)
#define REG_SC_BK05_0F_H      _PK_H_(0x05, 0x0F)
#define REG_SC_BK05_10_L      _PK_L_(0x05, 0x10)
#define REG_SC_BK05_10_H      _PK_H_(0x05, 0x10)
#define REG_SC_BK05_11_L      _PK_L_(0x05, 0x11)
#define REG_SC_BK05_11_H      _PK_H_(0x05, 0x11)
#define REG_SC_BK05_12_L      _PK_L_(0x05, 0x12)
#define REG_SC_BK05_12_H      _PK_H_(0x05, 0x12)
#define REG_SC_BK05_13_L      _PK_L_(0x05, 0x13)
#define REG_SC_BK05_13_H      _PK_H_(0x05, 0x13)
#define REG_SC_BK05_14_L      _PK_L_(0x05, 0x14)
#define REG_SC_BK05_14_H      _PK_H_(0x05, 0x14)
#define REG_SC_BK05_15_L      _PK_L_(0x05, 0x15)
#define REG_SC_BK05_15_H      _PK_H_(0x05, 0x15)
#define REG_SC_BK05_16_L      _PK_L_(0x05, 0x16)
#define REG_SC_BK05_16_H      _PK_H_(0x05, 0x16)
#define REG_SC_BK05_17_L      _PK_L_(0x05, 0x17)
#define REG_SC_BK05_17_H      _PK_H_(0x05, 0x17)
#define REG_SC_BK05_18_L      _PK_L_(0x05, 0x18)
#define REG_SC_BK05_18_H      _PK_H_(0x05, 0x18)
#define REG_SC_BK05_19_L      _PK_L_(0x05, 0x19)
#define REG_SC_BK05_19_H      _PK_H_(0x05, 0x19)
#define REG_SC_BK05_1A_L      _PK_L_(0x05, 0x1A)
#define REG_SC_BK05_1A_H      _PK_H_(0x05, 0x1A)
#define REG_SC_BK05_1B_L      _PK_L_(0x05, 0x1B)
#define REG_SC_BK05_1B_H      _PK_H_(0x05, 0x1B)
#define REG_SC_BK05_1C_L      _PK_L_(0x05, 0x1C)
#define REG_SC_BK05_1C_H      _PK_H_(0x05, 0x1C)
#define REG_SC_BK05_1D_L      _PK_L_(0x05, 0x1D)
#define REG_SC_BK05_1D_H      _PK_H_(0x05, 0x1D)
#define REG_SC_BK05_1E_L      _PK_L_(0x05, 0x1E)
#define REG_SC_BK05_1E_H      _PK_H_(0x05, 0x1E)
#define REG_SC_BK05_1F_L      _PK_L_(0x05, 0x1F)
#define REG_SC_BK05_1F_H      _PK_H_(0x05, 0x1F)
#define REG_SC_BK05_20_L      _PK_L_(0x05, 0x20)
#define REG_SC_BK05_20_H      _PK_H_(0x05, 0x20)
#define REG_SC_BK05_21_L      _PK_L_(0x05, 0x21)
#define REG_SC_BK05_21_H      _PK_H_(0x05, 0x21)
#define REG_SC_BK05_22_L      _PK_L_(0x05, 0x22)
#define REG_SC_BK05_22_H      _PK_H_(0x05, 0x22)
#define REG_SC_BK05_23_L      _PK_L_(0x05, 0x23)
#define REG_SC_BK05_23_H      _PK_H_(0x05, 0x23)
#define REG_SC_BK05_24_L      _PK_L_(0x05, 0x24)
#define REG_SC_BK05_24_H      _PK_H_(0x05, 0x24)
#define REG_SC_BK05_25_L      _PK_L_(0x05, 0x25)
#define REG_SC_BK05_25_H      _PK_H_(0x05, 0x25)
#define REG_SC_BK05_26_L      _PK_L_(0x05, 0x26)
#define REG_SC_BK05_26_H      _PK_H_(0x05, 0x26)
#define REG_SC_BK05_27_L      _PK_L_(0x05, 0x27)
#define REG_SC_BK05_27_H      _PK_H_(0x05, 0x27)
#define REG_SC_BK05_28_L      _PK_L_(0x05, 0x28)
#define REG_SC_BK05_28_H      _PK_H_(0x05, 0x28)
#define REG_SC_BK05_29_L      _PK_L_(0x05, 0x29)
#define REG_SC_BK05_29_H      _PK_H_(0x05, 0x29)
#define REG_SC_BK05_2A_L      _PK_L_(0x05, 0x2A)
#define REG_SC_BK05_2A_H      _PK_H_(0x05, 0x2A)
#define REG_SC_BK05_2B_L      _PK_L_(0x05, 0x2B)
#define REG_SC_BK05_2B_H      _PK_H_(0x05, 0x2B)
#define REG_SC_BK05_2C_L      _PK_L_(0x05, 0x2C)
#define REG_SC_BK05_2C_H      _PK_H_(0x05, 0x2C)
#define REG_SC_BK05_2D_L      _PK_L_(0x05, 0x2D)
#define REG_SC_BK05_2D_H      _PK_H_(0x05, 0x2D)
#define REG_SC_BK05_2E_L      _PK_L_(0x05, 0x2E)
#define REG_SC_BK05_2E_H      _PK_H_(0x05, 0x2E)
#define REG_SC_BK05_2F_L      _PK_L_(0x05, 0x2F)
#define REG_SC_BK05_2F_H      _PK_H_(0x05, 0x2F)
#define REG_SC_BK05_30_L      _PK_L_(0x05, 0x30)
#define REG_SC_BK05_30_H      _PK_H_(0x05, 0x30)
#define REG_SC_BK05_31_L      _PK_L_(0x05, 0x31)
#define REG_SC_BK05_31_H      _PK_H_(0x05, 0x31)
#define REG_SC_BK05_32_L      _PK_L_(0x05, 0x32)
#define REG_SC_BK05_32_H      _PK_H_(0x05, 0x32)
#define REG_SC_BK05_33_L      _PK_L_(0x05, 0x33)
#define REG_SC_BK05_33_H      _PK_H_(0x05, 0x33)
#define REG_SC_BK05_34_L      _PK_L_(0x05, 0x34)
#define REG_SC_BK05_34_H      _PK_H_(0x05, 0x34)
#define REG_SC_BK05_35_L      _PK_L_(0x05, 0x35)
#define REG_SC_BK05_35_H      _PK_H_(0x05, 0x35)
#define REG_SC_BK05_36_L      _PK_L_(0x05, 0x36)
#define REG_SC_BK05_36_H      _PK_H_(0x05, 0x36)
#define REG_SC_BK05_37_L      _PK_L_(0x05, 0x37)
#define REG_SC_BK05_37_H      _PK_H_(0x05, 0x37)
#define REG_SC_BK05_38_L      _PK_L_(0x05, 0x38)
#define REG_SC_BK05_38_H      _PK_H_(0x05, 0x38)
#define REG_SC_BK05_39_L      _PK_L_(0x05, 0x39)
#define REG_SC_BK05_39_H      _PK_H_(0x05, 0x39)
#define REG_SC_BK05_3A_L      _PK_L_(0x05, 0x3A)
#define REG_SC_BK05_3A_H      _PK_H_(0x05, 0x3A)
#define REG_SC_BK05_3B_L      _PK_L_(0x05, 0x3B)
#define REG_SC_BK05_3B_H      _PK_H_(0x05, 0x3B)
#define REG_SC_BK05_3C_L      _PK_L_(0x05, 0x3C)
#define REG_SC_BK05_3C_H      _PK_H_(0x05, 0x3C)
#define REG_SC_BK05_3D_L      _PK_L_(0x05, 0x3D)
#define REG_SC_BK05_3D_H      _PK_H_(0x05, 0x3D)
#define REG_SC_BK05_3E_L      _PK_L_(0x05, 0x3E)
#define REG_SC_BK05_3E_H      _PK_H_(0x05, 0x3E)
#define REG_SC_BK05_3F_L      _PK_L_(0x05, 0x3F)
#define REG_SC_BK05_3F_H      _PK_H_(0x05, 0x3F)
#define REG_SC_BK05_40_L      _PK_L_(0x05, 0x40)
#define REG_SC_BK05_40_H      _PK_H_(0x05, 0x40)
#define REG_SC_BK05_41_L      _PK_L_(0x05, 0x41)
#define REG_SC_BK05_41_H      _PK_H_(0x05, 0x41)
#define REG_SC_BK05_42_L      _PK_L_(0x05, 0x42)
#define REG_SC_BK05_42_H      _PK_H_(0x05, 0x42)
#define REG_SC_BK05_43_L      _PK_L_(0x05, 0x43)
#define REG_SC_BK05_43_H      _PK_H_(0x05, 0x43)
#define REG_SC_BK05_44_L      _PK_L_(0x05, 0x44)
#define REG_SC_BK05_44_H      _PK_H_(0x05, 0x44)
#define REG_SC_BK05_45_L      _PK_L_(0x05, 0x45)
#define REG_SC_BK05_45_H      _PK_H_(0x05, 0x45)
#define REG_SC_BK05_46_L      _PK_L_(0x05, 0x46)
#define REG_SC_BK05_46_H      _PK_H_(0x05, 0x46)
#define REG_SC_BK05_47_L      _PK_L_(0x05, 0x47)
#define REG_SC_BK05_47_H      _PK_H_(0x05, 0x47)
#define REG_SC_BK05_48_L      _PK_L_(0x05, 0x48)
#define REG_SC_BK05_48_H      _PK_H_(0x05, 0x48)
#define REG_SC_BK05_49_L      _PK_L_(0x05, 0x49)
#define REG_SC_BK05_49_H      _PK_H_(0x05, 0x49)
#define REG_SC_BK05_4A_L      _PK_L_(0x05, 0x4A)
#define REG_SC_BK05_4A_H      _PK_H_(0x05, 0x4A)
#define REG_SC_BK05_4B_L      _PK_L_(0x05, 0x4B)
#define REG_SC_BK05_4B_H      _PK_H_(0x05, 0x4B)
#define REG_SC_BK05_4C_L      _PK_L_(0x05, 0x4C)
#define REG_SC_BK05_4C_H      _PK_H_(0x05, 0x4C)
#define REG_SC_BK05_4D_L      _PK_L_(0x05, 0x4D)
#define REG_SC_BK05_4D_H      _PK_H_(0x05, 0x4D)
#define REG_SC_BK05_4E_L      _PK_L_(0x05, 0x4E)
#define REG_SC_BK05_4E_H      _PK_H_(0x05, 0x4E)
#define REG_SC_BK05_4F_L      _PK_L_(0x05, 0x4F)
#define REG_SC_BK05_4F_H      _PK_H_(0x05, 0x4F)
#define REG_SC_BK05_50_L      _PK_L_(0x05, 0x50)
#define REG_SC_BK05_50_H      _PK_H_(0x05, 0x50)
#define REG_SC_BK05_51_L      _PK_L_(0x05, 0x51)
#define REG_SC_BK05_51_H      _PK_H_(0x05, 0x51)
#define REG_SC_BK05_52_L      _PK_L_(0x05, 0x52)
#define REG_SC_BK05_52_H      _PK_H_(0x05, 0x52)
#define REG_SC_BK05_53_L      _PK_L_(0x05, 0x53)
#define REG_SC_BK05_53_H      _PK_H_(0x05, 0x53)
#define REG_SC_BK05_54_L      _PK_L_(0x05, 0x54)
#define REG_SC_BK05_54_H      _PK_H_(0x05, 0x54)
#define REG_SC_BK05_55_L      _PK_L_(0x05, 0x55)
#define REG_SC_BK05_55_H      _PK_H_(0x05, 0x55)
#define REG_SC_BK05_56_L      _PK_L_(0x05, 0x56)
#define REG_SC_BK05_56_H      _PK_H_(0x05, 0x56)
#define REG_SC_BK05_57_L      _PK_L_(0x05, 0x57)
#define REG_SC_BK05_57_H      _PK_H_(0x05, 0x57)
#define REG_SC_BK05_58_L      _PK_L_(0x05, 0x58)
#define REG_SC_BK05_58_H      _PK_H_(0x05, 0x58)
#define REG_SC_BK05_59_L      _PK_L_(0x05, 0x59)
#define REG_SC_BK05_59_H      _PK_H_(0x05, 0x59)
#define REG_SC_BK05_5A_L      _PK_L_(0x05, 0x5A)
#define REG_SC_BK05_5A_H      _PK_H_(0x05, 0x5A)
#define REG_SC_BK05_5B_L      _PK_L_(0x05, 0x5B)
#define REG_SC_BK05_5B_H      _PK_H_(0x05, 0x5B)
#define REG_SC_BK05_5C_L      _PK_L_(0x05, 0x5C)
#define REG_SC_BK05_5C_H      _PK_H_(0x05, 0x5C)
#define REG_SC_BK05_5D_L      _PK_L_(0x05, 0x5D)
#define REG_SC_BK05_5D_H      _PK_H_(0x05, 0x5D)
#define REG_SC_BK05_5E_L      _PK_L_(0x05, 0x5E)
#define REG_SC_BK05_5E_H      _PK_H_(0x05, 0x5E)
#define REG_SC_BK05_5F_L      _PK_L_(0x05, 0x5F)
#define REG_SC_BK05_5F_H      _PK_H_(0x05, 0x5F)
#define REG_SC_BK05_60_L      _PK_L_(0x05, 0x60)
#define REG_SC_BK05_60_H      _PK_H_(0x05, 0x60)
#define REG_SC_BK05_61_L      _PK_L_(0x05, 0x61)
#define REG_SC_BK05_61_H      _PK_H_(0x05, 0x61)
#define REG_SC_BK05_62_L      _PK_L_(0x05, 0x62)
#define REG_SC_BK05_62_H      _PK_H_(0x05, 0x62)
#define REG_SC_BK05_63_L      _PK_L_(0x05, 0x63)
#define REG_SC_BK05_63_H      _PK_H_(0x05, 0x63)
#define REG_SC_BK05_64_L      _PK_L_(0x05, 0x64)
#define REG_SC_BK05_64_H      _PK_H_(0x05, 0x64)
#define REG_SC_BK05_65_L      _PK_L_(0x05, 0x65)
#define REG_SC_BK05_65_H      _PK_H_(0x05, 0x65)
#define REG_SC_BK05_66_L      _PK_L_(0x05, 0x66)
#define REG_SC_BK05_66_H      _PK_H_(0x05, 0x66)
#define REG_SC_BK05_67_L      _PK_L_(0x05, 0x67)
#define REG_SC_BK05_67_H      _PK_H_(0x05, 0x67)
#define REG_SC_BK05_68_L      _PK_L_(0x05, 0x68)
#define REG_SC_BK05_68_H      _PK_H_(0x05, 0x68)
#define REG_SC_BK05_69_L      _PK_L_(0x05, 0x69)
#define REG_SC_BK05_69_H      _PK_H_(0x05, 0x69)
#define REG_SC_BK05_6A_L      _PK_L_(0x05, 0x6A)
#define REG_SC_BK05_6A_H      _PK_H_(0x05, 0x6A)
#define REG_SC_BK05_6B_L      _PK_L_(0x05, 0x6B)
#define REG_SC_BK05_6B_H      _PK_H_(0x05, 0x6B)
#define REG_SC_BK05_6C_L      _PK_L_(0x05, 0x6C)
#define REG_SC_BK05_6C_H      _PK_H_(0x05, 0x6C)
#define REG_SC_BK05_6D_L      _PK_L_(0x05, 0x6D)
#define REG_SC_BK05_6D_H      _PK_H_(0x05, 0x6D)
#define REG_SC_BK05_6E_L      _PK_L_(0x05, 0x6E)
#define REG_SC_BK05_6E_H      _PK_H_(0x05, 0x6E)
#define REG_SC_BK05_6F_L      _PK_L_(0x05, 0x6F)
#define REG_SC_BK05_6F_H      _PK_H_(0x05, 0x6F)
#define REG_SC_BK05_70_L      _PK_L_(0x05, 0x70)
#define REG_SC_BK05_70_H      _PK_H_(0x05, 0x70)
#define REG_SC_BK05_71_L      _PK_L_(0x05, 0x71)
#define REG_SC_BK05_71_H      _PK_H_(0x05, 0x71)
#define REG_SC_BK05_72_L      _PK_L_(0x05, 0x72)
#define REG_SC_BK05_72_H      _PK_H_(0x05, 0x72)
#define REG_SC_BK05_73_L      _PK_L_(0x05, 0x73)
#define REG_SC_BK05_73_H      _PK_H_(0x05, 0x73)
#define REG_SC_BK05_74_L      _PK_L_(0x05, 0x74)
#define REG_SC_BK05_74_H      _PK_H_(0x05, 0x74)
#define REG_SC_BK05_75_L      _PK_L_(0x05, 0x75)
#define REG_SC_BK05_75_H      _PK_H_(0x05, 0x75)
#define REG_SC_BK05_76_L      _PK_L_(0x05, 0x76)
#define REG_SC_BK05_76_H      _PK_H_(0x05, 0x76)
#define REG_SC_BK05_77_L      _PK_L_(0x05, 0x77)
#define REG_SC_BK05_77_H      _PK_H_(0x05, 0x77)
#define REG_SC_BK05_78_L      _PK_L_(0x05, 0x78)
#define REG_SC_BK05_78_H      _PK_H_(0x05, 0x78)
#define REG_SC_BK05_79_L      _PK_L_(0x05, 0x79)
#define REG_SC_BK05_79_H      _PK_H_(0x05, 0x79)
#define REG_SC_BK05_7A_L      _PK_L_(0x05, 0x7A)
#define REG_SC_BK05_7A_H      _PK_H_(0x05, 0x7A)
#define REG_SC_BK05_7B_L      _PK_L_(0x05, 0x7B)
#define REG_SC_BK05_7B_H      _PK_H_(0x05, 0x7B)
#define REG_SC_BK05_7C_L      _PK_L_(0x05, 0x7C)
#define REG_SC_BK05_7C_H      _PK_H_(0x05, 0x7C)
#define REG_SC_BK05_7D_L      _PK_L_(0x05, 0x7D)
#define REG_SC_BK05_7D_H      _PK_H_(0x05, 0x7D)
#define REG_SC_BK05_7E_L      _PK_L_(0x05, 0x7E)
#define REG_SC_BK05_7E_H      _PK_H_(0x05, 0x7E)
#define REG_SC_BK05_7F_L      _PK_L_(0x05, 0x7F)
#define REG_SC_BK05_7F_H      _PK_H_(0x05, 0x7F)


//----------------------------------------------
//  BK06: DNR
//----------------------------------------------
#define REG_SC_BK06_00_L      _PK_L_(0x06, 0x00)
#define REG_SC_BK06_00_H      _PK_H_(0x06, 0x00)
#define REG_SC_BK06_01_L      _PK_L_(0x06, 0x01)
#define REG_SC_BK06_01_H      _PK_H_(0x06, 0x01)
#define REG_SC_BK06_02_L      _PK_L_(0x06, 0x02)
#define REG_SC_BK06_02_H      _PK_H_(0x06, 0x02)
#define REG_SC_BK06_03_L      _PK_L_(0x06, 0x03)
#define REG_SC_BK06_03_H      _PK_H_(0x06, 0x03)
#define REG_SC_BK06_04_L      _PK_L_(0x06, 0x04)
#define REG_SC_BK06_04_H      _PK_H_(0x06, 0x04)
#define REG_SC_BK06_05_L      _PK_L_(0x06, 0x05)
#define REG_SC_BK06_05_H      _PK_H_(0x06, 0x05)
#define REG_SC_BK06_06_L      _PK_L_(0x06, 0x06)
#define REG_SC_BK06_06_H      _PK_H_(0x06, 0x06)
#define REG_SC_BK06_07_L      _PK_L_(0x06, 0x07)
#define REG_SC_BK06_07_H      _PK_H_(0x06, 0x07)
#define REG_SC_BK06_08_L      _PK_L_(0x06, 0x08)
#define REG_SC_BK06_08_H      _PK_H_(0x06, 0x08)
#define REG_SC_BK06_09_L      _PK_L_(0x06, 0x09)
#define REG_SC_BK06_09_H      _PK_H_(0x06, 0x09)
#define REG_SC_BK06_0A_L      _PK_L_(0x06, 0x0A)
#define REG_SC_BK06_0A_H      _PK_H_(0x06, 0x0A)
#define REG_SC_BK06_0B_L      _PK_L_(0x06, 0x0B)
#define REG_SC_BK06_0B_H      _PK_H_(0x06, 0x0B)
#define REG_SC_BK06_0C_L      _PK_L_(0x06, 0x0C)
#define REG_SC_BK06_0C_H      _PK_H_(0x06, 0x0C)
#define REG_SC_BK06_0D_L      _PK_L_(0x06, 0x0D)
#define REG_SC_BK06_0D_H      _PK_H_(0x06, 0x0D)
#define REG_SC_BK06_0E_L      _PK_L_(0x06, 0x0E)
#define REG_SC_BK06_0E_H      _PK_H_(0x06, 0x0E)
#define REG_SC_BK06_0F_L      _PK_L_(0x06, 0x0F)
#define REG_SC_BK06_0F_H      _PK_H_(0x06, 0x0F)
#define REG_SC_BK06_10_L      _PK_L_(0x06, 0x10)
#define REG_SC_BK06_10_H      _PK_H_(0x06, 0x10)
#define REG_SC_BK06_11_L      _PK_L_(0x06, 0x11)
#define REG_SC_BK06_11_H      _PK_H_(0x06, 0x11)
#define REG_SC_BK06_12_L      _PK_L_(0x06, 0x12)
#define REG_SC_BK06_12_H      _PK_H_(0x06, 0x12)
#define REG_SC_BK06_13_L      _PK_L_(0x06, 0x13)
#define REG_SC_BK06_13_H      _PK_H_(0x06, 0x13)
#define REG_SC_BK06_14_L      _PK_L_(0x06, 0x14)
#define REG_SC_BK06_14_H      _PK_H_(0x06, 0x14)
#define REG_SC_BK06_15_L      _PK_L_(0x06, 0x15)
#define REG_SC_BK06_15_H      _PK_H_(0x06, 0x15)
#define REG_SC_BK06_16_L      _PK_L_(0x06, 0x16)
#define REG_SC_BK06_16_H      _PK_H_(0x06, 0x16)
#define REG_SC_BK06_17_L      _PK_L_(0x06, 0x17)
#define REG_SC_BK06_17_H      _PK_H_(0x06, 0x17)
#define REG_SC_BK06_18_L      _PK_L_(0x06, 0x18)
#define REG_SC_BK06_18_H      _PK_H_(0x06, 0x18)
#define REG_SC_BK06_19_L      _PK_L_(0x06, 0x19)
#define REG_SC_BK06_19_H      _PK_H_(0x06, 0x19)
#define REG_SC_BK06_1A_L      _PK_L_(0x06, 0x1A)
#define REG_SC_BK06_1A_H      _PK_H_(0x06, 0x1A)
#define REG_SC_BK06_1B_L      _PK_L_(0x06, 0x1B)
#define REG_SC_BK06_1B_H      _PK_H_(0x06, 0x1B)
#define REG_SC_BK06_1C_L      _PK_L_(0x06, 0x1C)
#define REG_SC_BK06_1C_H      _PK_H_(0x06, 0x1C)
#define REG_SC_BK06_1D_L      _PK_L_(0x06, 0x1D)
#define REG_SC_BK06_1D_H      _PK_H_(0x06, 0x1D)
#define REG_SC_BK06_1E_L      _PK_L_(0x06, 0x1E)
#define REG_SC_BK06_1E_H      _PK_H_(0x06, 0x1E)
#define REG_SC_BK06_1F_L      _PK_L_(0x06, 0x1F)
#define REG_SC_BK06_1F_H      _PK_H_(0x06, 0x1F)
#define REG_SC_BK06_20_L      _PK_L_(0x06, 0x20)
#define REG_SC_BK06_20_H      _PK_H_(0x06, 0x20)
#define REG_SC_BK06_21_L      _PK_L_(0x06, 0x21)
#define REG_SC_BK06_21_H      _PK_H_(0x06, 0x21)
#define REG_SC_BK06_22_L      _PK_L_(0x06, 0x22)
#define REG_SC_BK06_22_H      _PK_H_(0x06, 0x22)
#define REG_SC_BK06_23_L      _PK_L_(0x06, 0x23)
#define REG_SC_BK06_23_H      _PK_H_(0x06, 0x23)
#define REG_SC_BK06_24_L      _PK_L_(0x06, 0x24)
#define REG_SC_BK06_24_H      _PK_H_(0x06, 0x24)
#define REG_SC_BK06_25_L      _PK_L_(0x06, 0x25)
#define REG_SC_BK06_25_H      _PK_H_(0x06, 0x25)
#define REG_SC_BK06_26_L      _PK_L_(0x06, 0x26)
#define REG_SC_BK06_26_H      _PK_H_(0x06, 0x26)
#define REG_SC_BK06_27_L      _PK_L_(0x06, 0x27)
#define REG_SC_BK06_27_H      _PK_H_(0x06, 0x27)
#define REG_SC_BK06_28_L      _PK_L_(0x06, 0x28)
#define REG_SC_BK06_28_H      _PK_H_(0x06, 0x28)
#define REG_SC_BK06_29_L      _PK_L_(0x06, 0x29)
#define REG_SC_BK06_29_H      _PK_H_(0x06, 0x29)
#define REG_SC_BK06_2A_L      _PK_L_(0x06, 0x2A)
#define REG_SC_BK06_2A_H      _PK_H_(0x06, 0x2A)
#define REG_SC_BK06_2B_L      _PK_L_(0x06, 0x2B)
#define REG_SC_BK06_2B_H      _PK_H_(0x06, 0x2B)
#define REG_SC_BK06_2C_L      _PK_L_(0x06, 0x2C)
#define REG_SC_BK06_2C_H      _PK_H_(0x06, 0x2C)
#define REG_SC_BK06_2D_L      _PK_L_(0x06, 0x2D)
#define REG_SC_BK06_2D_H      _PK_H_(0x06, 0x2D)
#define REG_SC_BK06_2E_L      _PK_L_(0x06, 0x2E)
#define REG_SC_BK06_2E_H      _PK_H_(0x06, 0x2E)
#define REG_SC_BK06_2F_L      _PK_L_(0x06, 0x2F)
#define REG_SC_BK06_2F_H      _PK_H_(0x06, 0x2F)
#define REG_SC_BK06_30_L      _PK_L_(0x06, 0x30)
#define REG_SC_BK06_30_H      _PK_H_(0x06, 0x30)
#define REG_SC_BK06_31_L      _PK_L_(0x06, 0x31)
#define REG_SC_BK06_31_H      _PK_H_(0x06, 0x31)
#define REG_SC_BK06_32_L      _PK_L_(0x06, 0x32)
#define REG_SC_BK06_32_H      _PK_H_(0x06, 0x32)
#define REG_SC_BK06_33_L      _PK_L_(0x06, 0x33)
#define REG_SC_BK06_33_H      _PK_H_(0x06, 0x33)
#define REG_SC_BK06_34_L      _PK_L_(0x06, 0x34)
#define REG_SC_BK06_34_H      _PK_H_(0x06, 0x34)
#define REG_SC_BK06_35_L      _PK_L_(0x06, 0x35)
#define REG_SC_BK06_35_H      _PK_H_(0x06, 0x35)
#define REG_SC_BK06_36_L      _PK_L_(0x06, 0x36)
#define REG_SC_BK06_36_H      _PK_H_(0x06, 0x36)
#define REG_SC_BK06_37_L      _PK_L_(0x06, 0x37)
#define REG_SC_BK06_37_H      _PK_H_(0x06, 0x37)
#define REG_SC_BK06_38_L      _PK_L_(0x06, 0x38)
#define REG_SC_BK06_38_H      _PK_H_(0x06, 0x38)
#define REG_SC_BK06_39_L      _PK_L_(0x06, 0x39)
#define REG_SC_BK06_39_H      _PK_H_(0x06, 0x39)
#define REG_SC_BK06_3A_L      _PK_L_(0x06, 0x3A)
#define REG_SC_BK06_3A_H      _PK_H_(0x06, 0x3A)
#define REG_SC_BK06_3B_L      _PK_L_(0x06, 0x3B)
#define REG_SC_BK06_3B_H      _PK_H_(0x06, 0x3B)
#define REG_SC_BK06_3C_L      _PK_L_(0x06, 0x3C)
#define REG_SC_BK06_3C_H      _PK_H_(0x06, 0x3C)
#define REG_SC_BK06_3D_L      _PK_L_(0x06, 0x3D)
#define REG_SC_BK06_3D_H      _PK_H_(0x06, 0x3D)
#define REG_SC_BK06_3E_L      _PK_L_(0x06, 0x3E)
#define REG_SC_BK06_3E_H      _PK_H_(0x06, 0x3E)
#define REG_SC_BK06_3F_L      _PK_L_(0x06, 0x3F)
#define REG_SC_BK06_3F_H      _PK_H_(0x06, 0x3F)
#define REG_SC_BK06_40_L      _PK_L_(0x06, 0x40)
#define REG_SC_BK06_40_H      _PK_H_(0x06, 0x40)
#define REG_SC_BK06_41_L      _PK_L_(0x06, 0x41)
#define REG_SC_BK06_41_H      _PK_H_(0x06, 0x41)
#define REG_SC_BK06_42_L      _PK_L_(0x06, 0x42)
#define REG_SC_BK06_42_H      _PK_H_(0x06, 0x42)
#define REG_SC_BK06_43_L      _PK_L_(0x06, 0x43)
#define REG_SC_BK06_43_H      _PK_H_(0x06, 0x43)
#define REG_SC_BK06_44_L      _PK_L_(0x06, 0x44)
#define REG_SC_BK06_44_H      _PK_H_(0x06, 0x44)
#define REG_SC_BK06_45_L      _PK_L_(0x06, 0x45)
#define REG_SC_BK06_45_H      _PK_H_(0x06, 0x45)
#define REG_SC_BK06_46_L      _PK_L_(0x06, 0x46)
#define REG_SC_BK06_46_H      _PK_H_(0x06, 0x46)
#define REG_SC_BK06_47_L      _PK_L_(0x06, 0x47)
#define REG_SC_BK06_47_H      _PK_H_(0x06, 0x47)
#define REG_SC_BK06_48_L      _PK_L_(0x06, 0x48)
#define REG_SC_BK06_48_H      _PK_H_(0x06, 0x48)
#define REG_SC_BK06_49_L      _PK_L_(0x06, 0x49)
#define REG_SC_BK06_49_H      _PK_H_(0x06, 0x49)
#define REG_SC_BK06_4A_L      _PK_L_(0x06, 0x4A)
#define REG_SC_BK06_4A_H      _PK_H_(0x06, 0x4A)
#define REG_SC_BK06_4B_L      _PK_L_(0x06, 0x4B)
#define REG_SC_BK06_4B_H      _PK_H_(0x06, 0x4B)
#define REG_SC_BK06_4C_L      _PK_L_(0x06, 0x4C)
#define REG_SC_BK06_4C_H      _PK_H_(0x06, 0x4C)
#define REG_SC_BK06_4D_L      _PK_L_(0x06, 0x4D)
#define REG_SC_BK06_4D_H      _PK_H_(0x06, 0x4D)
#define REG_SC_BK06_4E_L      _PK_L_(0x06, 0x4E)
#define REG_SC_BK06_4E_H      _PK_H_(0x06, 0x4E)
#define REG_SC_BK06_4F_L      _PK_L_(0x06, 0x4F)
#define REG_SC_BK06_4F_H      _PK_H_(0x06, 0x4F)
#define REG_SC_BK06_50_L      _PK_L_(0x06, 0x50)
#define REG_SC_BK06_50_H      _PK_H_(0x06, 0x50)
#define REG_SC_BK06_51_L      _PK_L_(0x06, 0x51)
#define REG_SC_BK06_51_H      _PK_H_(0x06, 0x51)
#define REG_SC_BK06_52_L      _PK_L_(0x06, 0x52)
#define REG_SC_BK06_52_H      _PK_H_(0x06, 0x52)
#define REG_SC_BK06_53_L      _PK_L_(0x06, 0x53)
#define REG_SC_BK06_53_H      _PK_H_(0x06, 0x53)
#define REG_SC_BK06_54_L      _PK_L_(0x06, 0x54)
#define REG_SC_BK06_54_H      _PK_H_(0x06, 0x54)
#define REG_SC_BK06_55_L      _PK_L_(0x06, 0x55)
#define REG_SC_BK06_55_H      _PK_H_(0x06, 0x55)
#define REG_SC_BK06_56_L      _PK_L_(0x06, 0x56)
#define REG_SC_BK06_56_H      _PK_H_(0x06, 0x56)
#define REG_SC_BK06_57_L      _PK_L_(0x06, 0x57)
#define REG_SC_BK06_57_H      _PK_H_(0x06, 0x57)
#define REG_SC_BK06_58_L      _PK_L_(0x06, 0x58)
#define REG_SC_BK06_58_H      _PK_H_(0x06, 0x58)
#define REG_SC_BK06_59_L      _PK_L_(0x06, 0x59)
#define REG_SC_BK06_59_H      _PK_H_(0x06, 0x59)
#define REG_SC_BK06_5A_L      _PK_L_(0x06, 0x5A)
#define REG_SC_BK06_5A_H      _PK_H_(0x06, 0x5A)
#define REG_SC_BK06_5B_L      _PK_L_(0x06, 0x5B)
#define REG_SC_BK06_5B_H      _PK_H_(0x06, 0x5B)
#define REG_SC_BK06_5C_L      _PK_L_(0x06, 0x5C)
#define REG_SC_BK06_5C_H      _PK_H_(0x06, 0x5C)
#define REG_SC_BK06_5D_L      _PK_L_(0x06, 0x5D)
#define REG_SC_BK06_5D_H      _PK_H_(0x06, 0x5D)
#define REG_SC_BK06_5E_L      _PK_L_(0x06, 0x5E)
#define REG_SC_BK06_5E_H      _PK_H_(0x06, 0x5E)
#define REG_SC_BK06_5F_L      _PK_L_(0x06, 0x5F)
#define REG_SC_BK06_5F_H      _PK_H_(0x06, 0x5F)
#define REG_SC_BK06_60_L      _PK_L_(0x06, 0x60)
#define REG_SC_BK06_60_H      _PK_H_(0x06, 0x60)
#define REG_SC_BK06_61_L      _PK_L_(0x06, 0x61)
#define REG_SC_BK06_61_H      _PK_H_(0x06, 0x61)
#define REG_SC_BK06_62_L      _PK_L_(0x06, 0x62)
#define REG_SC_BK06_62_H      _PK_H_(0x06, 0x62)
#define REG_SC_BK06_63_L      _PK_L_(0x06, 0x63)
#define REG_SC_BK06_63_H      _PK_H_(0x06, 0x63)
#define REG_SC_BK06_64_L      _PK_L_(0x06, 0x64)
#define REG_SC_BK06_64_H      _PK_H_(0x06, 0x64)
#define REG_SC_BK06_65_L      _PK_L_(0x06, 0x65)
#define REG_SC_BK06_65_H      _PK_H_(0x06, 0x65)
#define REG_SC_BK06_66_L      _PK_L_(0x06, 0x66)
#define REG_SC_BK06_66_H      _PK_H_(0x06, 0x66)
#define REG_SC_BK06_67_L      _PK_L_(0x06, 0x67)
#define REG_SC_BK06_67_H      _PK_H_(0x06, 0x67)
#define REG_SC_BK06_68_L      _PK_L_(0x06, 0x68)
#define REG_SC_BK06_68_H      _PK_H_(0x06, 0x68)
#define REG_SC_BK06_69_L      _PK_L_(0x06, 0x69)
#define REG_SC_BK06_69_H      _PK_H_(0x06, 0x69)
#define REG_SC_BK06_6A_L      _PK_L_(0x06, 0x6A)
#define REG_SC_BK06_6A_H      _PK_H_(0x06, 0x6A)
#define REG_SC_BK06_6B_L      _PK_L_(0x06, 0x6B)
#define REG_SC_BK06_6B_H      _PK_H_(0x06, 0x6B)
#define REG_SC_BK06_6C_L      _PK_L_(0x06, 0x6C)
#define REG_SC_BK06_6C_H      _PK_H_(0x06, 0x6C)
#define REG_SC_BK06_6D_L      _PK_L_(0x06, 0x6D)
#define REG_SC_BK06_6D_H      _PK_H_(0x06, 0x6D)
#define REG_SC_BK06_6E_L      _PK_L_(0x06, 0x6E)
#define REG_SC_BK06_6E_H      _PK_H_(0x06, 0x6E)
#define REG_SC_BK06_6F_L      _PK_L_(0x06, 0x6F)
#define REG_SC_BK06_6F_H      _PK_H_(0x06, 0x6F)
#define REG_SC_BK06_70_L      _PK_L_(0x06, 0x70)
#define REG_SC_BK06_70_H      _PK_H_(0x06, 0x70)
#define REG_SC_BK06_71_L      _PK_L_(0x06, 0x71)
#define REG_SC_BK06_71_H      _PK_H_(0x06, 0x71)
#define REG_SC_BK06_72_L      _PK_L_(0x06, 0x72)
#define REG_SC_BK06_72_H      _PK_H_(0x06, 0x72)
#define REG_SC_BK06_73_L      _PK_L_(0x06, 0x73)
#define REG_SC_BK06_73_H      _PK_H_(0x06, 0x73)
#define REG_SC_BK06_74_L      _PK_L_(0x06, 0x74)
#define REG_SC_BK06_74_H      _PK_H_(0x06, 0x74)
#define REG_SC_BK06_75_L      _PK_L_(0x06, 0x75)
#define REG_SC_BK06_75_H      _PK_H_(0x06, 0x75)
#define REG_SC_BK06_76_L      _PK_L_(0x06, 0x76)
#define REG_SC_BK06_76_H      _PK_H_(0x06, 0x76)
#define REG_SC_BK06_77_L      _PK_L_(0x06, 0x77)
#define REG_SC_BK06_77_H      _PK_H_(0x06, 0x77)
#define REG_SC_BK06_78_L      _PK_L_(0x06, 0x78)
#define REG_SC_BK06_78_H      _PK_H_(0x06, 0x78)
#define REG_SC_BK06_79_L      _PK_L_(0x06, 0x79)
#define REG_SC_BK06_79_H      _PK_H_(0x06, 0x79)
#define REG_SC_BK06_7A_L      _PK_L_(0x06, 0x7A)
#define REG_SC_BK06_7A_H      _PK_H_(0x06, 0x7A)
#define REG_SC_BK06_7B_L      _PK_L_(0x06, 0x7B)
#define REG_SC_BK06_7B_H      _PK_H_(0x06, 0x7B)
#define REG_SC_BK06_7C_L      _PK_L_(0x06, 0x7C)
#define REG_SC_BK06_7C_H      _PK_H_(0x06, 0x7C)
#define REG_SC_BK06_7D_L      _PK_L_(0x06, 0x7D)
#define REG_SC_BK06_7D_H      _PK_H_(0x06, 0x7D)
#define REG_SC_BK06_7E_L      _PK_L_(0x06, 0x7E)
#define REG_SC_BK06_7E_H      _PK_H_(0x06, 0x7E)
#define REG_SC_BK06_7F_L      _PK_L_(0x06, 0x7F)
#define REG_SC_BK06_7F_H      _PK_H_(0x06, 0x7F)


//----------------------------------------------
//  BK07: OP1
//----------------------------------------------
#define REG_SC_BK07_00_L      _PK_L_(0x07, 0x00)
#define REG_SC_BK07_00_H      _PK_H_(0x07, 0x00)
#define REG_SC_BK07_01_L      _PK_L_(0x07, 0x01)
#define REG_SC_BK07_01_H      _PK_H_(0x07, 0x01)
#define REG_SC_BK07_02_L      _PK_L_(0x07, 0x02)
#define REG_SC_BK07_02_H      _PK_H_(0x07, 0x02)
#define REG_SC_BK07_03_L      _PK_L_(0x07, 0x03)
#define REG_SC_BK07_03_H      _PK_H_(0x07, 0x03)
#define REG_SC_BK07_04_L      _PK_L_(0x07, 0x04)
#define REG_SC_BK07_04_H      _PK_H_(0x07, 0x04)
#define REG_SC_BK07_05_L      _PK_L_(0x07, 0x05)
#define REG_SC_BK07_05_H      _PK_H_(0x07, 0x05)
#define REG_SC_BK07_06_L      _PK_L_(0x07, 0x06)
#define REG_SC_BK07_06_H      _PK_H_(0x07, 0x06)
#define REG_SC_BK07_07_L      _PK_L_(0x07, 0x07)
#define REG_SC_BK07_07_H      _PK_H_(0x07, 0x07)
#define REG_SC_BK07_08_L      _PK_L_(0x07, 0x08)
#define REG_SC_BK07_08_H      _PK_H_(0x07, 0x08)
#define REG_SC_BK07_09_L      _PK_L_(0x07, 0x09)
#define REG_SC_BK07_09_H      _PK_H_(0x07, 0x09)
#define REG_SC_BK07_0A_L      _PK_L_(0x07, 0x0A)
#define REG_SC_BK07_0A_H      _PK_H_(0x07, 0x0A)
#define REG_SC_BK07_0B_L      _PK_L_(0x07, 0x0B)
#define REG_SC_BK07_0B_H      _PK_H_(0x07, 0x0B)
#define REG_SC_BK07_0C_L      _PK_L_(0x07, 0x0C)
#define REG_SC_BK07_0C_H      _PK_H_(0x07, 0x0C)
#define REG_SC_BK07_0D_L      _PK_L_(0x07, 0x0D)
#define REG_SC_BK07_0D_H      _PK_H_(0x07, 0x0D)
#define REG_SC_BK07_0E_L      _PK_L_(0x07, 0x0E)
#define REG_SC_BK07_0E_H      _PK_H_(0x07, 0x0E)
#define REG_SC_BK07_0F_L      _PK_L_(0x07, 0x0F)
#define REG_SC_BK07_0F_H      _PK_H_(0x07, 0x0F)
#define REG_SC_BK07_10_L      _PK_L_(0x07, 0x10)
#define REG_SC_BK07_10_H      _PK_H_(0x07, 0x10)
#define REG_SC_BK07_11_L      _PK_L_(0x07, 0x11)
#define REG_SC_BK07_11_H      _PK_H_(0x07, 0x11)
#define REG_SC_BK07_12_L      _PK_L_(0x07, 0x12)
#define REG_SC_BK07_12_H      _PK_H_(0x07, 0x12)
#define REG_SC_BK07_13_L      _PK_L_(0x07, 0x13)
#define REG_SC_BK07_13_H      _PK_H_(0x07, 0x13)
#define REG_SC_BK07_14_L      _PK_L_(0x07, 0x14)
#define REG_SC_BK07_14_H      _PK_H_(0x07, 0x14)
#define REG_SC_BK07_15_L      _PK_L_(0x07, 0x15)
#define REG_SC_BK07_15_H      _PK_H_(0x07, 0x15)
#define REG_SC_BK07_16_L      _PK_L_(0x07, 0x16)
#define REG_SC_BK07_16_H      _PK_H_(0x07, 0x16)
#define REG_SC_BK07_17_L      _PK_L_(0x07, 0x17)
#define REG_SC_BK07_17_H      _PK_H_(0x07, 0x17)
#define REG_SC_BK07_18_L      _PK_L_(0x07, 0x18)
#define REG_SC_BK07_18_H      _PK_H_(0x07, 0x18)
#define REG_SC_BK07_19_L      _PK_L_(0x07, 0x19)
#define REG_SC_BK07_19_H      _PK_H_(0x07, 0x19)
#define REG_SC_BK07_1A_L      _PK_L_(0x07, 0x1A)
#define REG_SC_BK07_1A_H      _PK_H_(0x07, 0x1A)
#define REG_SC_BK07_1B_L      _PK_L_(0x07, 0x1B)
#define REG_SC_BK07_1B_H      _PK_H_(0x07, 0x1B)
#define REG_SC_BK07_1C_L      _PK_L_(0x07, 0x1C)
#define REG_SC_BK07_1C_H      _PK_H_(0x07, 0x1C)
#define REG_SC_BK07_1D_L      _PK_L_(0x07, 0x1D)
#define REG_SC_BK07_1D_H      _PK_H_(0x07, 0x1D)
#define REG_SC_BK07_1E_L      _PK_L_(0x07, 0x1E)
#define REG_SC_BK07_1E_H      _PK_H_(0x07, 0x1E)
#define REG_SC_BK07_1F_L      _PK_L_(0x07, 0x1F)
#define REG_SC_BK07_1F_H      _PK_H_(0x07, 0x1F)
#define REG_SC_BK07_20_L      _PK_L_(0x07, 0x20)
#define REG_SC_BK07_20_H      _PK_H_(0x07, 0x20)
#define REG_SC_BK07_21_L      _PK_L_(0x07, 0x21)
#define REG_SC_BK07_21_H      _PK_H_(0x07, 0x21)
#define REG_SC_BK07_22_L      _PK_L_(0x07, 0x22)
#define REG_SC_BK07_22_H      _PK_H_(0x07, 0x22)
#define REG_SC_BK07_23_L      _PK_L_(0x07, 0x23)
#define REG_SC_BK07_23_H      _PK_H_(0x07, 0x23)
#define REG_SC_BK07_24_L      _PK_L_(0x07, 0x24)
#define REG_SC_BK07_24_H      _PK_H_(0x07, 0x24)
#define REG_SC_BK07_25_L      _PK_L_(0x07, 0x25)
#define REG_SC_BK07_25_H      _PK_H_(0x07, 0x25)
#define REG_SC_BK07_26_L      _PK_L_(0x07, 0x26)
#define REG_SC_BK07_26_H      _PK_H_(0x07, 0x26)
#define REG_SC_BK07_27_L      _PK_L_(0x07, 0x27)
#define REG_SC_BK07_27_H      _PK_H_(0x07, 0x27)
#define REG_SC_BK07_28_L      _PK_L_(0x07, 0x28)
#define REG_SC_BK07_28_H      _PK_H_(0x07, 0x28)
#define REG_SC_BK07_29_L      _PK_L_(0x07, 0x29)
#define REG_SC_BK07_29_H      _PK_H_(0x07, 0x29)
#define REG_SC_BK07_2A_L      _PK_L_(0x07, 0x2A)
#define REG_SC_BK07_2A_H      _PK_H_(0x07, 0x2A)
#define REG_SC_BK07_2B_L      _PK_L_(0x07, 0x2B)
#define REG_SC_BK07_2B_H      _PK_H_(0x07, 0x2B)
#define REG_SC_BK07_2C_L      _PK_L_(0x07, 0x2C)
#define REG_SC_BK07_2C_H      _PK_H_(0x07, 0x2C)
#define REG_SC_BK07_2D_L      _PK_L_(0x07, 0x2D)
#define REG_SC_BK07_2D_H      _PK_H_(0x07, 0x2D)
#define REG_SC_BK07_2E_L      _PK_L_(0x07, 0x2E)
#define REG_SC_BK07_2E_H      _PK_H_(0x07, 0x2E)
#define REG_SC_BK07_2F_L      _PK_L_(0x07, 0x2F)
#define REG_SC_BK07_2F_H      _PK_H_(0x07, 0x2F)
#define REG_SC_BK07_30_L      _PK_L_(0x07, 0x30)
#define REG_SC_BK07_30_H      _PK_H_(0x07, 0x30)
#define REG_SC_BK07_31_L      _PK_L_(0x07, 0x31)
#define REG_SC_BK07_31_H      _PK_H_(0x07, 0x31)
#define REG_SC_BK07_32_L      _PK_L_(0x07, 0x32)
#define REG_SC_BK07_32_H      _PK_H_(0x07, 0x32)
#define REG_SC_BK07_33_L      _PK_L_(0x07, 0x33)
#define REG_SC_BK07_33_H      _PK_H_(0x07, 0x33)
#define REG_SC_BK07_34_L      _PK_L_(0x07, 0x34)
#define REG_SC_BK07_34_H      _PK_H_(0x07, 0x34)
#define REG_SC_BK07_35_L      _PK_L_(0x07, 0x35)
#define REG_SC_BK07_35_H      _PK_H_(0x07, 0x35)
#define REG_SC_BK07_36_L      _PK_L_(0x07, 0x36)
#define REG_SC_BK07_36_H      _PK_H_(0x07, 0x36)
#define REG_SC_BK07_37_L      _PK_L_(0x07, 0x37)
#define REG_SC_BK07_37_H      _PK_H_(0x07, 0x37)
#define REG_SC_BK07_38_L      _PK_L_(0x07, 0x38)
#define REG_SC_BK07_38_H      _PK_H_(0x07, 0x38)
#define REG_SC_BK07_39_L      _PK_L_(0x07, 0x39)
#define REG_SC_BK07_39_H      _PK_H_(0x07, 0x39)
#define REG_SC_BK07_3A_L      _PK_L_(0x07, 0x3A)
#define REG_SC_BK07_3A_H      _PK_H_(0x07, 0x3A)
#define REG_SC_BK07_3B_L      _PK_L_(0x07, 0x3B)
#define REG_SC_BK07_3B_H      _PK_H_(0x07, 0x3B)
#define REG_SC_BK07_3C_L      _PK_L_(0x07, 0x3C)
#define REG_SC_BK07_3C_H      _PK_H_(0x07, 0x3C)
#define REG_SC_BK07_3D_L      _PK_L_(0x07, 0x3D)
#define REG_SC_BK07_3D_H      _PK_H_(0x07, 0x3D)
#define REG_SC_BK07_3E_L      _PK_L_(0x07, 0x3E)
#define REG_SC_BK07_3E_H      _PK_H_(0x07, 0x3E)
#define REG_SC_BK07_3F_L      _PK_L_(0x07, 0x3F)
#define REG_SC_BK07_3F_H      _PK_H_(0x07, 0x3F)
#define REG_SC_BK07_40_L      _PK_L_(0x07, 0x40)
#define REG_SC_BK07_40_H      _PK_H_(0x07, 0x40)
#define REG_SC_BK07_41_L      _PK_L_(0x07, 0x41)
#define REG_SC_BK07_41_H      _PK_H_(0x07, 0x41)
#define REG_SC_BK07_42_L      _PK_L_(0x07, 0x42)
#define REG_SC_BK07_42_H      _PK_H_(0x07, 0x42)
#define REG_SC_BK07_43_L      _PK_L_(0x07, 0x43)
#define REG_SC_BK07_43_H      _PK_H_(0x07, 0x43)
#define REG_SC_BK07_44_L      _PK_L_(0x07, 0x44)
#define REG_SC_BK07_44_H      _PK_H_(0x07, 0x44)
#define REG_SC_BK07_45_L      _PK_L_(0x07, 0x45)
#define REG_SC_BK07_45_H      _PK_H_(0x07, 0x45)
#define REG_SC_BK07_46_L      _PK_L_(0x07, 0x46)
#define REG_SC_BK07_46_H      _PK_H_(0x07, 0x46)
#define REG_SC_BK07_47_L      _PK_L_(0x07, 0x47)
#define REG_SC_BK07_47_H      _PK_H_(0x07, 0x47)
#define REG_SC_BK07_48_L      _PK_L_(0x07, 0x48)
#define REG_SC_BK07_48_H      _PK_H_(0x07, 0x48)
#define REG_SC_BK07_49_L      _PK_L_(0x07, 0x49)
#define REG_SC_BK07_49_H      _PK_H_(0x07, 0x49)
#define REG_SC_BK07_4A_L      _PK_L_(0x07, 0x4A)
#define REG_SC_BK07_4A_H      _PK_H_(0x07, 0x4A)
#define REG_SC_BK07_4B_L      _PK_L_(0x07, 0x4B)
#define REG_SC_BK07_4B_H      _PK_H_(0x07, 0x4B)
#define REG_SC_BK07_4C_L      _PK_L_(0x07, 0x4C)
#define REG_SC_BK07_4C_H      _PK_H_(0x07, 0x4C)
#define REG_SC_BK07_4D_L      _PK_L_(0x07, 0x4D)
#define REG_SC_BK07_4D_H      _PK_H_(0x07, 0x4D)
#define REG_SC_BK07_4E_L      _PK_L_(0x07, 0x4E)
#define REG_SC_BK07_4E_H      _PK_H_(0x07, 0x4E)
#define REG_SC_BK07_4F_L      _PK_L_(0x07, 0x4F)
#define REG_SC_BK07_4F_H      _PK_H_(0x07, 0x4F)
#define REG_SC_BK07_50_L      _PK_L_(0x07, 0x50)
#define REG_SC_BK07_50_H      _PK_H_(0x07, 0x50)
#define REG_SC_BK07_51_L      _PK_L_(0x07, 0x51)
#define REG_SC_BK07_51_H      _PK_H_(0x07, 0x51)
#define REG_SC_BK07_52_L      _PK_L_(0x07, 0x52)
#define REG_SC_BK07_52_H      _PK_H_(0x07, 0x52)
#define REG_SC_BK07_53_L      _PK_L_(0x07, 0x53)
#define REG_SC_BK07_53_H      _PK_H_(0x07, 0x53)
#define REG_SC_BK07_54_L      _PK_L_(0x07, 0x54)
#define REG_SC_BK07_54_H      _PK_H_(0x07, 0x54)
#define REG_SC_BK07_55_L      _PK_L_(0x07, 0x55)
#define REG_SC_BK07_55_H      _PK_H_(0x07, 0x55)
#define REG_SC_BK07_56_L      _PK_L_(0x07, 0x56)
#define REG_SC_BK07_56_H      _PK_H_(0x07, 0x56)
#define REG_SC_BK07_57_L      _PK_L_(0x07, 0x57)
#define REG_SC_BK07_57_H      _PK_H_(0x07, 0x57)
#define REG_SC_BK07_58_L      _PK_L_(0x07, 0x58)
#define REG_SC_BK07_58_H      _PK_H_(0x07, 0x58)
#define REG_SC_BK07_59_L      _PK_L_(0x07, 0x59)
#define REG_SC_BK07_59_H      _PK_H_(0x07, 0x59)
#define REG_SC_BK07_5A_L      _PK_L_(0x07, 0x5A)
#define REG_SC_BK07_5A_H      _PK_H_(0x07, 0x5A)
#define REG_SC_BK07_5B_L      _PK_L_(0x07, 0x5B)
#define REG_SC_BK07_5B_H      _PK_H_(0x07, 0x5B)
#define REG_SC_BK07_5C_L      _PK_L_(0x07, 0x5C)
#define REG_SC_BK07_5C_H      _PK_H_(0x07, 0x5C)
#define REG_SC_BK07_5D_L      _PK_L_(0x07, 0x5D)
#define REG_SC_BK07_5D_H      _PK_H_(0x07, 0x5D)
#define REG_SC_BK07_5E_L      _PK_L_(0x07, 0x5E)
#define REG_SC_BK07_5E_H      _PK_H_(0x07, 0x5E)
#define REG_SC_BK07_5F_L      _PK_L_(0x07, 0x5F)
#define REG_SC_BK07_5F_H      _PK_H_(0x07, 0x5F)
#define REG_SC_BK07_60_L      _PK_L_(0x07, 0x60)
#define REG_SC_BK07_60_H      _PK_H_(0x07, 0x60)
#define REG_SC_BK07_61_L      _PK_L_(0x07, 0x61)
#define REG_SC_BK07_61_H      _PK_H_(0x07, 0x61)
#define REG_SC_BK07_62_L      _PK_L_(0x07, 0x62)
#define REG_SC_BK07_62_H      _PK_H_(0x07, 0x62)
#define REG_SC_BK07_63_L      _PK_L_(0x07, 0x63)
#define REG_SC_BK07_63_H      _PK_H_(0x07, 0x63)
#define REG_SC_BK07_64_L      _PK_L_(0x07, 0x64)
#define REG_SC_BK07_64_H      _PK_H_(0x07, 0x64)
#define REG_SC_BK07_65_L      _PK_L_(0x07, 0x65)
#define REG_SC_BK07_65_H      _PK_H_(0x07, 0x65)
#define REG_SC_BK07_66_L      _PK_L_(0x07, 0x66)
#define REG_SC_BK07_66_H      _PK_H_(0x07, 0x66)
#define REG_SC_BK07_67_L      _PK_L_(0x07, 0x67)
#define REG_SC_BK07_67_H      _PK_H_(0x07, 0x67)
#define REG_SC_BK07_68_L      _PK_L_(0x07, 0x68)
#define REG_SC_BK07_68_H      _PK_H_(0x07, 0x68)
#define REG_SC_BK07_69_L      _PK_L_(0x07, 0x69)
#define REG_SC_BK07_69_H      _PK_H_(0x07, 0x69)
#define REG_SC_BK07_6A_L      _PK_L_(0x07, 0x6A)
#define REG_SC_BK07_6A_H      _PK_H_(0x07, 0x6A)
#define REG_SC_BK07_6B_L      _PK_L_(0x07, 0x6B)
#define REG_SC_BK07_6B_H      _PK_H_(0x07, 0x6B)
#define REG_SC_BK07_6C_L      _PK_L_(0x07, 0x6C)
#define REG_SC_BK07_6C_H      _PK_H_(0x07, 0x6C)
#define REG_SC_BK07_6D_L      _PK_L_(0x07, 0x6D)
#define REG_SC_BK07_6D_H      _PK_H_(0x07, 0x6D)
#define REG_SC_BK07_6E_L      _PK_L_(0x07, 0x6E)
#define REG_SC_BK07_6E_H      _PK_H_(0x07, 0x6E)
#define REG_SC_BK07_6F_L      _PK_L_(0x07, 0x6F)
#define REG_SC_BK07_6F_H      _PK_H_(0x07, 0x6F)
#define REG_SC_BK07_70_L      _PK_L_(0x07, 0x70)
#define REG_SC_BK07_70_H      _PK_H_(0x07, 0x70)
#define REG_SC_BK07_71_L      _PK_L_(0x07, 0x71)
#define REG_SC_BK07_71_H      _PK_H_(0x07, 0x71)
#define REG_SC_BK07_72_L      _PK_L_(0x07, 0x72)
#define REG_SC_BK07_72_H      _PK_H_(0x07, 0x72)
#define REG_SC_BK07_73_L      _PK_L_(0x07, 0x73)
#define REG_SC_BK07_73_H      _PK_H_(0x07, 0x73)
#define REG_SC_BK07_74_L      _PK_L_(0x07, 0x74)
#define REG_SC_BK07_74_H      _PK_H_(0x07, 0x74)
#define REG_SC_BK07_75_L      _PK_L_(0x07, 0x75)
#define REG_SC_BK07_75_H      _PK_H_(0x07, 0x75)
#define REG_SC_BK07_76_L      _PK_L_(0x07, 0x76)
#define REG_SC_BK07_76_H      _PK_H_(0x07, 0x76)
#define REG_SC_BK07_77_L      _PK_L_(0x07, 0x77)
#define REG_SC_BK07_77_H      _PK_H_(0x07, 0x77)
#define REG_SC_BK07_78_L      _PK_L_(0x07, 0x78)
#define REG_SC_BK07_78_H      _PK_H_(0x07, 0x78)
#define REG_SC_BK07_79_L      _PK_L_(0x07, 0x79)
#define REG_SC_BK07_79_H      _PK_H_(0x07, 0x79)
#define REG_SC_BK07_7A_L      _PK_L_(0x07, 0x7A)
#define REG_SC_BK07_7A_H      _PK_H_(0x07, 0x7A)
#define REG_SC_BK07_7B_L      _PK_L_(0x07, 0x7B)
#define REG_SC_BK07_7B_H      _PK_H_(0x07, 0x7B)
#define REG_SC_BK07_7C_L      _PK_L_(0x07, 0x7C)
#define REG_SC_BK07_7C_H      _PK_H_(0x07, 0x7C)
#define REG_SC_BK07_7D_L      _PK_L_(0x07, 0x7D)
#define REG_SC_BK07_7D_H      _PK_H_(0x07, 0x7D)
#define REG_SC_BK07_7E_L      _PK_L_(0x07, 0x7E)
#define REG_SC_BK07_7E_H      _PK_H_(0x07, 0x7E)
#define REG_SC_BK07_7F_L      _PK_L_(0x07, 0x7F)
#define REG_SC_BK07_7F_H      _PK_H_(0x07, 0x7F)

//----------------------------------------------
//  BK08: CE
//----------------------------------------------
#define REG_SC_BK08_00_L      _PK_L_(0x08, 0x00)
#define REG_SC_BK08_00_H      _PK_H_(0x08, 0x00)
#define REG_SC_BK08_01_L      _PK_L_(0x08, 0x01)
#define REG_SC_BK08_01_H      _PK_H_(0x08, 0x01)
#define REG_SC_BK08_02_L      _PK_L_(0x08, 0x02)
#define REG_SC_BK08_02_H      _PK_H_(0x08, 0x02)
#define REG_SC_BK08_03_L      _PK_L_(0x08, 0x03)
#define REG_SC_BK08_03_H      _PK_H_(0x08, 0x03)
#define REG_SC_BK08_04_L      _PK_L_(0x08, 0x04)
#define REG_SC_BK08_04_H      _PK_H_(0x08, 0x04)
#define REG_SC_BK08_05_L      _PK_L_(0x08, 0x05)
#define REG_SC_BK08_05_H      _PK_H_(0x08, 0x05)
#define REG_SC_BK08_06_L      _PK_L_(0x08, 0x06)
#define REG_SC_BK08_06_H      _PK_H_(0x08, 0x06)
#define REG_SC_BK08_07_L      _PK_L_(0x08, 0x07)
#define REG_SC_BK08_07_H      _PK_H_(0x08, 0x07)
#define REG_SC_BK08_08_L      _PK_L_(0x08, 0x08)
#define REG_SC_BK08_08_H      _PK_H_(0x08, 0x08)
#define REG_SC_BK08_09_L      _PK_L_(0x08, 0x09)
#define REG_SC_BK08_09_H      _PK_H_(0x08, 0x09)
#define REG_SC_BK08_0A_L      _PK_L_(0x08, 0x0A)
#define REG_SC_BK08_0A_H      _PK_H_(0x08, 0x0A)
#define REG_SC_BK08_0B_L      _PK_L_(0x08, 0x0B)
#define REG_SC_BK08_0B_H      _PK_H_(0x08, 0x0B)
#define REG_SC_BK08_0C_L      _PK_L_(0x08, 0x0C)
#define REG_SC_BK08_0C_H      _PK_H_(0x08, 0x0C)
#define REG_SC_BK08_0D_L      _PK_L_(0x08, 0x0D)
#define REG_SC_BK08_0D_H      _PK_H_(0x08, 0x0D)
#define REG_SC_BK08_0E_L      _PK_L_(0x08, 0x0E)
#define REG_SC_BK08_0E_H      _PK_H_(0x08, 0x0E)
#define REG_SC_BK08_0F_L      _PK_L_(0x08, 0x0F)
#define REG_SC_BK08_0F_H      _PK_H_(0x08, 0x0F)
#define REG_SC_BK08_10_L      _PK_L_(0x08, 0x10)
#define REG_SC_BK08_10_H      _PK_H_(0x08, 0x10)
#define REG_SC_BK08_11_L      _PK_L_(0x08, 0x11)
#define REG_SC_BK08_11_H      _PK_H_(0x08, 0x11)
#define REG_SC_BK08_12_L      _PK_L_(0x08, 0x12)
#define REG_SC_BK08_12_H      _PK_H_(0x08, 0x12)
#define REG_SC_BK08_13_L      _PK_L_(0x08, 0x13)
#define REG_SC_BK08_13_H      _PK_H_(0x08, 0x13)
#define REG_SC_BK08_14_L      _PK_L_(0x08, 0x14)
#define REG_SC_BK08_14_H      _PK_H_(0x08, 0x14)
#define REG_SC_BK08_15_L      _PK_L_(0x08, 0x15)
#define REG_SC_BK08_15_H      _PK_H_(0x08, 0x15)
#define REG_SC_BK08_16_L      _PK_L_(0x08, 0x16)
#define REG_SC_BK08_16_H      _PK_H_(0x08, 0x16)
#define REG_SC_BK08_17_L      _PK_L_(0x08, 0x17)
#define REG_SC_BK08_17_H      _PK_H_(0x08, 0x17)
#define REG_SC_BK08_18_L      _PK_L_(0x08, 0x18)
#define REG_SC_BK08_18_H      _PK_H_(0x08, 0x18)
#define REG_SC_BK08_19_L      _PK_L_(0x08, 0x19)
#define REG_SC_BK08_19_H      _PK_H_(0x08, 0x19)
#define REG_SC_BK08_1A_L      _PK_L_(0x08, 0x1A)
#define REG_SC_BK08_1A_H      _PK_H_(0x08, 0x1A)
#define REG_SC_BK08_1B_L      _PK_L_(0x08, 0x1B)
#define REG_SC_BK08_1B_H      _PK_H_(0x08, 0x1B)
#define REG_SC_BK08_1C_L      _PK_L_(0x08, 0x1C)
#define REG_SC_BK08_1C_H      _PK_H_(0x08, 0x1C)
#define REG_SC_BK08_1D_L      _PK_L_(0x08, 0x1D)
#define REG_SC_BK08_1D_H      _PK_H_(0x08, 0x1D)
#define REG_SC_BK08_1E_L      _PK_L_(0x08, 0x1E)
#define REG_SC_BK08_1E_H      _PK_H_(0x08, 0x1E)
#define REG_SC_BK08_1F_L      _PK_L_(0x08, 0x1F)
#define REG_SC_BK08_1F_H      _PK_H_(0x08, 0x1F)
#define REG_SC_BK08_20_L      _PK_L_(0x08, 0x20)
#define REG_SC_BK08_20_H      _PK_H_(0x08, 0x20)
#define REG_SC_BK08_21_L      _PK_L_(0x08, 0x21)
#define REG_SC_BK08_21_H      _PK_H_(0x08, 0x21)
#define REG_SC_BK08_22_L      _PK_L_(0x08, 0x22)
#define REG_SC_BK08_22_H      _PK_H_(0x08, 0x22)
#define REG_SC_BK08_23_L      _PK_L_(0x08, 0x23)
#define REG_SC_BK08_23_H      _PK_H_(0x08, 0x23)
#define REG_SC_BK08_24_L      _PK_L_(0x08, 0x24)
#define REG_SC_BK08_24_H      _PK_H_(0x08, 0x24)
#define REG_SC_BK08_25_L      _PK_L_(0x08, 0x25)
#define REG_SC_BK08_25_H      _PK_H_(0x08, 0x25)
#define REG_SC_BK08_26_L      _PK_L_(0x08, 0x26)
#define REG_SC_BK08_26_H      _PK_H_(0x08, 0x26)
#define REG_SC_BK08_27_L      _PK_L_(0x08, 0x27)
#define REG_SC_BK08_27_H      _PK_H_(0x08, 0x27)
#define REG_SC_BK08_28_L      _PK_L_(0x08, 0x28)
#define REG_SC_BK08_28_H      _PK_H_(0x08, 0x28)
#define REG_SC_BK08_29_L      _PK_L_(0x08, 0x29)
#define REG_SC_BK08_29_H      _PK_H_(0x08, 0x29)
#define REG_SC_BK08_2A_L      _PK_L_(0x08, 0x2A)
#define REG_SC_BK08_2A_H      _PK_H_(0x08, 0x2A)
#define REG_SC_BK08_2B_L      _PK_L_(0x08, 0x2B)
#define REG_SC_BK08_2B_H      _PK_H_(0x08, 0x2B)
#define REG_SC_BK08_2C_L      _PK_L_(0x08, 0x2C)
#define REG_SC_BK08_2C_H      _PK_H_(0x08, 0x2C)
#define REG_SC_BK08_2D_L      _PK_L_(0x08, 0x2D)
#define REG_SC_BK08_2D_H      _PK_H_(0x08, 0x2D)
#define REG_SC_BK08_2E_L      _PK_L_(0x08, 0x2E)
#define REG_SC_BK08_2E_H      _PK_H_(0x08, 0x2E)
#define REG_SC_BK08_2F_L      _PK_L_(0x08, 0x2F)
#define REG_SC_BK08_2F_H      _PK_H_(0x08, 0x2F)
#define REG_SC_BK08_30_L      _PK_L_(0x08, 0x30)
#define REG_SC_BK08_30_H      _PK_H_(0x08, 0x30)
#define REG_SC_BK08_31_L      _PK_L_(0x08, 0x31)
#define REG_SC_BK08_31_H      _PK_H_(0x08, 0x31)
#define REG_SC_BK08_32_L      _PK_L_(0x08, 0x32)
#define REG_SC_BK08_32_H      _PK_H_(0x08, 0x32)
#define REG_SC_BK08_33_L      _PK_L_(0x08, 0x33)
#define REG_SC_BK08_33_H      _PK_H_(0x08, 0x33)
#define REG_SC_BK08_34_L      _PK_L_(0x08, 0x34)
#define REG_SC_BK08_34_H      _PK_H_(0x08, 0x34)
#define REG_SC_BK08_35_L      _PK_L_(0x08, 0x35)
#define REG_SC_BK08_35_H      _PK_H_(0x08, 0x35)
#define REG_SC_BK08_36_L      _PK_L_(0x08, 0x36)
#define REG_SC_BK08_36_H      _PK_H_(0x08, 0x36)
#define REG_SC_BK08_37_L      _PK_L_(0x08, 0x37)
#define REG_SC_BK08_37_H      _PK_H_(0x08, 0x37)
#define REG_SC_BK08_38_L      _PK_L_(0x08, 0x38)
#define REG_SC_BK08_38_H      _PK_H_(0x08, 0x38)
#define REG_SC_BK08_39_L      _PK_L_(0x08, 0x39)
#define REG_SC_BK08_39_H      _PK_H_(0x08, 0x39)
#define REG_SC_BK08_3A_L      _PK_L_(0x08, 0x3A)
#define REG_SC_BK08_3A_H      _PK_H_(0x08, 0x3A)
#define REG_SC_BK08_3B_L      _PK_L_(0x08, 0x3B)
#define REG_SC_BK08_3B_H      _PK_H_(0x08, 0x3B)
#define REG_SC_BK08_3C_L      _PK_L_(0x08, 0x3C)
#define REG_SC_BK08_3C_H      _PK_H_(0x08, 0x3C)
#define REG_SC_BK08_3D_L      _PK_L_(0x08, 0x3D)
#define REG_SC_BK08_3D_H      _PK_H_(0x08, 0x3D)
#define REG_SC_BK08_3E_L      _PK_L_(0x08, 0x3E)
#define REG_SC_BK08_3E_H      _PK_H_(0x08, 0x3E)
#define REG_SC_BK08_3F_L      _PK_L_(0x08, 0x3F)
#define REG_SC_BK08_3F_H      _PK_H_(0x08, 0x3F)
#define REG_SC_BK08_40_L      _PK_L_(0x08, 0x40)
#define REG_SC_BK08_40_H      _PK_H_(0x08, 0x40)
#define REG_SC_BK08_41_L      _PK_L_(0x08, 0x41)
#define REG_SC_BK08_41_H      _PK_H_(0x08, 0x41)
#define REG_SC_BK08_42_L      _PK_L_(0x08, 0x42)
#define REG_SC_BK08_42_H      _PK_H_(0x08, 0x42)
#define REG_SC_BK08_43_L      _PK_L_(0x08, 0x43)
#define REG_SC_BK08_43_H      _PK_H_(0x08, 0x43)
#define REG_SC_BK08_44_L      _PK_L_(0x08, 0x44)
#define REG_SC_BK08_44_H      _PK_H_(0x08, 0x44)
#define REG_SC_BK08_45_L      _PK_L_(0x08, 0x45)
#define REG_SC_BK08_45_H      _PK_H_(0x08, 0x45)
#define REG_SC_BK08_46_L      _PK_L_(0x08, 0x46)
#define REG_SC_BK08_46_H      _PK_H_(0x08, 0x46)
#define REG_SC_BK08_47_L      _PK_L_(0x08, 0x47)
#define REG_SC_BK08_47_H      _PK_H_(0x08, 0x47)
#define REG_SC_BK08_48_L      _PK_L_(0x08, 0x48)
#define REG_SC_BK08_48_H      _PK_H_(0x08, 0x48)
#define REG_SC_BK08_49_L      _PK_L_(0x08, 0x49)
#define REG_SC_BK08_49_H      _PK_H_(0x08, 0x49)
#define REG_SC_BK08_4A_L      _PK_L_(0x08, 0x4A)
#define REG_SC_BK08_4A_H      _PK_H_(0x08, 0x4A)
#define REG_SC_BK08_4B_L      _PK_L_(0x08, 0x4B)
#define REG_SC_BK08_4B_H      _PK_H_(0x08, 0x4B)
#define REG_SC_BK08_4C_L      _PK_L_(0x08, 0x4C)
#define REG_SC_BK08_4C_H      _PK_H_(0x08, 0x4C)
#define REG_SC_BK08_4D_L      _PK_L_(0x08, 0x4D)
#define REG_SC_BK08_4D_H      _PK_H_(0x08, 0x4D)
#define REG_SC_BK08_4E_L      _PK_L_(0x08, 0x4E)
#define REG_SC_BK08_4E_H      _PK_H_(0x08, 0x4E)
#define REG_SC_BK08_4F_L      _PK_L_(0x08, 0x4F)
#define REG_SC_BK08_4F_H      _PK_H_(0x08, 0x4F)
#define REG_SC_BK08_50_L      _PK_L_(0x08, 0x50)
#define REG_SC_BK08_50_H      _PK_H_(0x08, 0x50)
#define REG_SC_BK08_51_L      _PK_L_(0x08, 0x51)
#define REG_SC_BK08_51_H      _PK_H_(0x08, 0x51)
#define REG_SC_BK08_52_L      _PK_L_(0x08, 0x52)
#define REG_SC_BK08_52_H      _PK_H_(0x08, 0x52)
#define REG_SC_BK08_53_L      _PK_L_(0x08, 0x53)
#define REG_SC_BK08_53_H      _PK_H_(0x08, 0x53)
#define REG_SC_BK08_54_L      _PK_L_(0x08, 0x54)
#define REG_SC_BK08_54_H      _PK_H_(0x08, 0x54)
#define REG_SC_BK08_55_L      _PK_L_(0x08, 0x55)
#define REG_SC_BK08_55_H      _PK_H_(0x08, 0x55)
#define REG_SC_BK08_56_L      _PK_L_(0x08, 0x56)
#define REG_SC_BK08_56_H      _PK_H_(0x08, 0x56)
#define REG_SC_BK08_57_L      _PK_L_(0x08, 0x57)
#define REG_SC_BK08_57_H      _PK_H_(0x08, 0x57)
#define REG_SC_BK08_58_L      _PK_L_(0x08, 0x58)
#define REG_SC_BK08_58_H      _PK_H_(0x08, 0x58)
#define REG_SC_BK08_59_L      _PK_L_(0x08, 0x59)
#define REG_SC_BK08_59_H      _PK_H_(0x08, 0x59)
#define REG_SC_BK08_5A_L      _PK_L_(0x08, 0x5A)
#define REG_SC_BK08_5A_H      _PK_H_(0x08, 0x5A)
#define REG_SC_BK08_5B_L      _PK_L_(0x08, 0x5B)
#define REG_SC_BK08_5B_H      _PK_H_(0x08, 0x5B)
#define REG_SC_BK08_5C_L      _PK_L_(0x08, 0x5C)
#define REG_SC_BK08_5C_H      _PK_H_(0x08, 0x5C)
#define REG_SC_BK08_5D_L      _PK_L_(0x08, 0x5D)
#define REG_SC_BK08_5D_H      _PK_H_(0x08, 0x5D)
#define REG_SC_BK08_5E_L      _PK_L_(0x08, 0x5E)
#define REG_SC_BK08_5E_H      _PK_H_(0x08, 0x5E)
#define REG_SC_BK08_5F_L      _PK_L_(0x08, 0x5F)
#define REG_SC_BK08_5F_H      _PK_H_(0x08, 0x5F)
#define REG_SC_BK08_60_L      _PK_L_(0x08, 0x60)
#define REG_SC_BK08_60_H      _PK_H_(0x08, 0x60)
#define REG_SC_BK08_61_L      _PK_L_(0x08, 0x61)
#define REG_SC_BK08_61_H      _PK_H_(0x08, 0x61)
#define REG_SC_BK08_62_L      _PK_L_(0x08, 0x62)
#define REG_SC_BK08_62_H      _PK_H_(0x08, 0x62)
#define REG_SC_BK08_63_L      _PK_L_(0x08, 0x63)
#define REG_SC_BK08_63_H      _PK_H_(0x08, 0x63)
#define REG_SC_BK08_64_L      _PK_L_(0x08, 0x64)
#define REG_SC_BK08_64_H      _PK_H_(0x08, 0x64)
#define REG_SC_BK08_65_L      _PK_L_(0x08, 0x65)
#define REG_SC_BK08_65_H      _PK_H_(0x08, 0x65)
#define REG_SC_BK08_66_L      _PK_L_(0x08, 0x66)
#define REG_SC_BK08_66_H      _PK_H_(0x08, 0x66)
#define REG_SC_BK08_67_L      _PK_L_(0x08, 0x67)
#define REG_SC_BK08_67_H      _PK_H_(0x08, 0x67)
#define REG_SC_BK08_68_L      _PK_L_(0x08, 0x68)
#define REG_SC_BK08_68_H      _PK_H_(0x08, 0x68)
#define REG_SC_BK08_69_L      _PK_L_(0x08, 0x69)
#define REG_SC_BK08_69_H      _PK_H_(0x08, 0x69)
#define REG_SC_BK08_6A_L      _PK_L_(0x08, 0x6A)
#define REG_SC_BK08_6A_H      _PK_H_(0x08, 0x6A)
#define REG_SC_BK08_6B_L      _PK_L_(0x08, 0x6B)
#define REG_SC_BK08_6B_H      _PK_H_(0x08, 0x6B)
#define REG_SC_BK08_6C_L      _PK_L_(0x08, 0x6C)
#define REG_SC_BK08_6C_H      _PK_H_(0x08, 0x6C)
#define REG_SC_BK08_6D_L      _PK_L_(0x08, 0x6D)
#define REG_SC_BK08_6D_H      _PK_H_(0x08, 0x6D)
#define REG_SC_BK08_6E_L      _PK_L_(0x08, 0x6E)
#define REG_SC_BK08_6E_H      _PK_H_(0x08, 0x6E)
#define REG_SC_BK08_6F_L      _PK_L_(0x08, 0x6F)
#define REG_SC_BK08_6F_H      _PK_H_(0x08, 0x6F)
#define REG_SC_BK08_70_L      _PK_L_(0x08, 0x70)
#define REG_SC_BK08_70_H      _PK_H_(0x08, 0x70)
#define REG_SC_BK08_71_L      _PK_L_(0x08, 0x71)
#define REG_SC_BK08_71_H      _PK_H_(0x08, 0x71)
#define REG_SC_BK08_72_L      _PK_L_(0x08, 0x72)
#define REG_SC_BK08_72_H      _PK_H_(0x08, 0x72)
#define REG_SC_BK08_73_L      _PK_L_(0x08, 0x73)
#define REG_SC_BK08_73_H      _PK_H_(0x08, 0x73)
#define REG_SC_BK08_74_L      _PK_L_(0x08, 0x74)
#define REG_SC_BK08_74_H      _PK_H_(0x08, 0x74)
#define REG_SC_BK08_75_L      _PK_L_(0x08, 0x75)
#define REG_SC_BK08_75_H      _PK_H_(0x08, 0x75)
#define REG_SC_BK08_76_L      _PK_L_(0x08, 0x76)
#define REG_SC_BK08_76_H      _PK_H_(0x08, 0x76)
#define REG_SC_BK08_77_L      _PK_L_(0x08, 0x77)
#define REG_SC_BK08_77_H      _PK_H_(0x08, 0x77)
#define REG_SC_BK08_78_L      _PK_L_(0x08, 0x78)
#define REG_SC_BK08_78_H      _PK_H_(0x08, 0x78)
#define REG_SC_BK08_79_L      _PK_L_(0x08, 0x79)
#define REG_SC_BK08_79_H      _PK_H_(0x08, 0x79)
#define REG_SC_BK08_7A_L      _PK_L_(0x08, 0x7A)
#define REG_SC_BK08_7A_H      _PK_H_(0x08, 0x7A)
#define REG_SC_BK08_7B_L      _PK_L_(0x08, 0x7B)
#define REG_SC_BK08_7B_H      _PK_H_(0x08, 0x7B)
#define REG_SC_BK08_7C_L      _PK_L_(0x08, 0x7C)
#define REG_SC_BK08_7C_H      _PK_H_(0x08, 0x7C)
#define REG_SC_BK08_7D_L      _PK_L_(0x08, 0x7D)
#define REG_SC_BK08_7D_H      _PK_H_(0x08, 0x7D)
#define REG_SC_BK08_7E_L      _PK_L_(0x08, 0x7E)
#define REG_SC_BK08_7E_H      _PK_H_(0x08, 0x7E)
#define REG_SC_BK08_7F_L      _PK_L_(0x08, 0x7F)
#define REG_SC_BK08_7F_H      _PK_H_(0x08, 0x7F)


//----------------------------------------------
//  BK09: OP1HVSP
//----------------------------------------------
#define REG_SC_BK09_00_L      _PK_L_(0x09, 0x00)
#define REG_SC_BK09_00_H      _PK_H_(0x09, 0x00)
#define REG_SC_BK09_01_L      _PK_L_(0x09, 0x01)
#define REG_SC_BK09_01_H      _PK_H_(0x09, 0x01)
#define REG_SC_BK09_02_L      _PK_L_(0x09, 0x02)
#define REG_SC_BK09_02_H      _PK_H_(0x09, 0x02)
#define REG_SC_BK09_03_L      _PK_L_(0x09, 0x03)
#define REG_SC_BK09_03_H      _PK_H_(0x09, 0x03)
#define REG_SC_BK09_04_L      _PK_L_(0x09, 0x04)
#define REG_SC_BK09_04_H      _PK_H_(0x09, 0x04)
#define REG_SC_BK09_05_L      _PK_L_(0x09, 0x05)
#define REG_SC_BK09_05_H      _PK_H_(0x09, 0x05)
#define REG_SC_BK09_06_L      _PK_L_(0x09, 0x06)
#define REG_SC_BK09_06_H      _PK_H_(0x09, 0x06)
#define REG_SC_BK09_07_L      _PK_L_(0x09, 0x07)
#define REG_SC_BK09_07_H      _PK_H_(0x09, 0x07)
#define REG_SC_BK09_08_L      _PK_L_(0x09, 0x08)
#define REG_SC_BK09_08_H      _PK_H_(0x09, 0x08)
#define REG_SC_BK09_09_L      _PK_L_(0x09, 0x09)
#define REG_SC_BK09_09_H      _PK_H_(0x09, 0x09)
#define REG_SC_BK09_0A_L      _PK_L_(0x09, 0x0A)
#define REG_SC_BK09_0A_H      _PK_H_(0x09, 0x0A)
#define REG_SC_BK09_0B_L      _PK_L_(0x09, 0x0B)
#define REG_SC_BK09_0B_H      _PK_H_(0x09, 0x0B)
#define REG_SC_BK09_0C_L      _PK_L_(0x09, 0x0C)
#define REG_SC_BK09_0C_H      _PK_H_(0x09, 0x0C)
#define REG_SC_BK09_0D_L      _PK_L_(0x09, 0x0D)
#define REG_SC_BK09_0D_H      _PK_H_(0x09, 0x0D)
#define REG_SC_BK09_0E_L      _PK_L_(0x09, 0x0E)
#define REG_SC_BK09_0E_H      _PK_H_(0x09, 0x0E)
#define REG_SC_BK09_0F_L      _PK_L_(0x09, 0x0F)
#define REG_SC_BK09_0F_H      _PK_H_(0x09, 0x0F)
#define REG_SC_BK09_10_L      _PK_L_(0x09, 0x10)
#define REG_SC_BK09_10_H      _PK_H_(0x09, 0x10)
#define REG_SC_BK09_11_L      _PK_L_(0x09, 0x11)
#define REG_SC_BK09_11_H      _PK_H_(0x09, 0x11)
#define REG_SC_BK09_12_L      _PK_L_(0x09, 0x12)
#define REG_SC_BK09_12_H      _PK_H_(0x09, 0x12)
#define REG_SC_BK09_13_L      _PK_L_(0x09, 0x13)
#define REG_SC_BK09_13_H      _PK_H_(0x09, 0x13)
#define REG_SC_BK09_14_L      _PK_L_(0x09, 0x14)
#define REG_SC_BK09_14_H      _PK_H_(0x09, 0x14)
#define REG_SC_BK09_15_L      _PK_L_(0x09, 0x15)
#define REG_SC_BK09_15_H      _PK_H_(0x09, 0x15)
#define REG_SC_BK09_16_L      _PK_L_(0x09, 0x16)
#define REG_SC_BK09_16_H      _PK_H_(0x09, 0x16)
#define REG_SC_BK09_17_L      _PK_L_(0x09, 0x17)
#define REG_SC_BK09_17_H      _PK_H_(0x09, 0x17)
#define REG_SC_BK09_18_L      _PK_L_(0x09, 0x18)
#define REG_SC_BK09_18_H      _PK_H_(0x09, 0x18)
#define REG_SC_BK09_19_L      _PK_L_(0x09, 0x19)
#define REG_SC_BK09_19_H      _PK_H_(0x09, 0x19)
#define REG_SC_BK09_1A_L      _PK_L_(0x09, 0x1A)
#define REG_SC_BK09_1A_H      _PK_H_(0x09, 0x1A)
#define REG_SC_BK09_1B_L      _PK_L_(0x09, 0x1B)
#define REG_SC_BK09_1B_H      _PK_H_(0x09, 0x1B)
#define REG_SC_BK09_1C_L      _PK_L_(0x09, 0x1C)
#define REG_SC_BK09_1C_H      _PK_H_(0x09, 0x1C)
#define REG_SC_BK09_1D_L      _PK_L_(0x09, 0x1D)
#define REG_SC_BK09_1D_H      _PK_H_(0x09, 0x1D)
#define REG_SC_BK09_1E_L      _PK_L_(0x09, 0x1E)
#define REG_SC_BK09_1E_H      _PK_H_(0x09, 0x1E)
#define REG_SC_BK09_1F_L      _PK_L_(0x09, 0x1F)
#define REG_SC_BK09_1F_H      _PK_H_(0x09, 0x1F)
#define REG_SC_BK09_20_L      _PK_L_(0x09, 0x20)
#define REG_SC_BK09_20_H      _PK_H_(0x09, 0x20)
#define REG_SC_BK09_21_L      _PK_L_(0x09, 0x21)
#define REG_SC_BK09_21_H      _PK_H_(0x09, 0x21)
#define REG_SC_BK09_22_L      _PK_L_(0x09, 0x22)
#define REG_SC_BK09_22_H      _PK_H_(0x09, 0x22)
#define REG_SC_BK09_23_L      _PK_L_(0x09, 0x23)
#define REG_SC_BK09_23_H      _PK_H_(0x09, 0x23)
#define REG_SC_BK09_24_L      _PK_L_(0x09, 0x24)
#define REG_SC_BK09_24_H      _PK_H_(0x09, 0x24)
#define REG_SC_BK09_25_L      _PK_L_(0x09, 0x25)
#define REG_SC_BK09_25_H      _PK_H_(0x09, 0x25)
#define REG_SC_BK09_26_L      _PK_L_(0x09, 0x26)
#define REG_SC_BK09_26_H      _PK_H_(0x09, 0x26)
#define REG_SC_BK09_27_L      _PK_L_(0x09, 0x27)
#define REG_SC_BK09_27_H      _PK_H_(0x09, 0x27)
#define REG_SC_BK09_28_L      _PK_L_(0x09, 0x28)
#define REG_SC_BK09_28_H      _PK_H_(0x09, 0x28)
#define REG_SC_BK09_29_L      _PK_L_(0x09, 0x29)
#define REG_SC_BK09_29_H      _PK_H_(0x09, 0x29)
#define REG_SC_BK09_2A_L      _PK_L_(0x09, 0x2A)
#define REG_SC_BK09_2A_H      _PK_H_(0x09, 0x2A)
#define REG_SC_BK09_2B_L      _PK_L_(0x09, 0x2B)
#define REG_SC_BK09_2B_H      _PK_H_(0x09, 0x2B)
#define REG_SC_BK09_2C_L      _PK_L_(0x09, 0x2C)
#define REG_SC_BK09_2C_H      _PK_H_(0x09, 0x2C)
#define REG_SC_BK09_2D_L      _PK_L_(0x09, 0x2D)
#define REG_SC_BK09_2D_H      _PK_H_(0x09, 0x2D)
#define REG_SC_BK09_2E_L      _PK_L_(0x09, 0x2E)
#define REG_SC_BK09_2E_H      _PK_H_(0x09, 0x2E)
#define REG_SC_BK09_2F_L      _PK_L_(0x09, 0x2F)
#define REG_SC_BK09_2F_H      _PK_H_(0x09, 0x2F)
#define REG_SC_BK09_30_L      _PK_L_(0x09, 0x30)
#define REG_SC_BK09_30_H      _PK_H_(0x09, 0x30)
#define REG_SC_BK09_31_L      _PK_L_(0x09, 0x31)
#define REG_SC_BK09_31_H      _PK_H_(0x09, 0x31)
#define REG_SC_BK09_32_L      _PK_L_(0x09, 0x32)
#define REG_SC_BK09_32_H      _PK_H_(0x09, 0x32)
#define REG_SC_BK09_33_L      _PK_L_(0x09, 0x33)
#define REG_SC_BK09_33_H      _PK_H_(0x09, 0x33)
#define REG_SC_BK09_34_L      _PK_L_(0x09, 0x34)
#define REG_SC_BK09_34_H      _PK_H_(0x09, 0x34)
#define REG_SC_BK09_35_L      _PK_L_(0x09, 0x35)
#define REG_SC_BK09_35_H      _PK_H_(0x09, 0x35)
#define REG_SC_BK09_36_L      _PK_L_(0x09, 0x36)
#define REG_SC_BK09_36_H      _PK_H_(0x09, 0x36)
#define REG_SC_BK09_37_L      _PK_L_(0x09, 0x37)
#define REG_SC_BK09_37_H      _PK_H_(0x09, 0x37)
#define REG_SC_BK09_38_L      _PK_L_(0x09, 0x38)
#define REG_SC_BK09_38_H      _PK_H_(0x09, 0x38)
#define REG_SC_BK09_39_L      _PK_L_(0x09, 0x39)
#define REG_SC_BK09_39_H      _PK_H_(0x09, 0x39)
#define REG_SC_BK09_3A_L      _PK_L_(0x09, 0x3A)
#define REG_SC_BK09_3A_H      _PK_H_(0x09, 0x3A)
#define REG_SC_BK09_3B_L      _PK_L_(0x09, 0x3B)
#define REG_SC_BK09_3B_H      _PK_H_(0x09, 0x3B)
#define REG_SC_BK09_3C_L      _PK_L_(0x09, 0x3C)
#define REG_SC_BK09_3C_H      _PK_H_(0x09, 0x3C)
#define REG_SC_BK09_3D_L      _PK_L_(0x09, 0x3D)
#define REG_SC_BK09_3D_H      _PK_H_(0x09, 0x3D)
#define REG_SC_BK09_3E_L      _PK_L_(0x09, 0x3E)
#define REG_SC_BK09_3E_H      _PK_H_(0x09, 0x3E)
#define REG_SC_BK09_3F_L      _PK_L_(0x09, 0x3F)
#define REG_SC_BK09_3F_H      _PK_H_(0x09, 0x3F)
#define REG_SC_BK09_40_L      _PK_L_(0x09, 0x40)
#define REG_SC_BK09_40_H      _PK_H_(0x09, 0x40)
#define REG_SC_BK09_41_L      _PK_L_(0x09, 0x41)
#define REG_SC_BK09_41_H      _PK_H_(0x09, 0x41)
#define REG_SC_BK09_42_L      _PK_L_(0x09, 0x42)
#define REG_SC_BK09_42_H      _PK_H_(0x09, 0x42)
#define REG_SC_BK09_43_L      _PK_L_(0x09, 0x43)
#define REG_SC_BK09_43_H      _PK_H_(0x09, 0x43)
#define REG_SC_BK09_44_L      _PK_L_(0x09, 0x44)
#define REG_SC_BK09_44_H      _PK_H_(0x09, 0x44)
#define REG_SC_BK09_45_L      _PK_L_(0x09, 0x45)
#define REG_SC_BK09_45_H      _PK_H_(0x09, 0x45)
#define REG_SC_BK09_46_L      _PK_L_(0x09, 0x46)
#define REG_SC_BK09_46_H      _PK_H_(0x09, 0x46)
#define REG_SC_BK09_47_L      _PK_L_(0x09, 0x47)
#define REG_SC_BK09_47_H      _PK_H_(0x09, 0x47)
#define REG_SC_BK09_48_L      _PK_L_(0x09, 0x48)
#define REG_SC_BK09_48_H      _PK_H_(0x09, 0x48)
#define REG_SC_BK09_49_L      _PK_L_(0x09, 0x49)
#define REG_SC_BK09_49_H      _PK_H_(0x09, 0x49)
#define REG_SC_BK09_4A_L      _PK_L_(0x09, 0x4A)
#define REG_SC_BK09_4A_H      _PK_H_(0x09, 0x4A)
#define REG_SC_BK09_4B_L      _PK_L_(0x09, 0x4B)
#define REG_SC_BK09_4B_H      _PK_H_(0x09, 0x4B)
#define REG_SC_BK09_4C_L      _PK_L_(0x09, 0x4C)
#define REG_SC_BK09_4C_H      _PK_H_(0x09, 0x4C)
#define REG_SC_BK09_4D_L      _PK_L_(0x09, 0x4D)
#define REG_SC_BK09_4D_H      _PK_H_(0x09, 0x4D)
#define REG_SC_BK09_4E_L      _PK_L_(0x09, 0x4E)
#define REG_SC_BK09_4E_H      _PK_H_(0x09, 0x4E)
#define REG_SC_BK09_4F_L      _PK_L_(0x09, 0x4F)
#define REG_SC_BK09_4F_H      _PK_H_(0x09, 0x4F)
#define REG_SC_BK09_50_L      _PK_L_(0x09, 0x50)
#define REG_SC_BK09_50_H      _PK_H_(0x09, 0x50)
#define REG_SC_BK09_51_L      _PK_L_(0x09, 0x51)
#define REG_SC_BK09_51_H      _PK_H_(0x09, 0x51)
#define REG_SC_BK09_52_L      _PK_L_(0x09, 0x52)
#define REG_SC_BK09_52_H      _PK_H_(0x09, 0x52)
#define REG_SC_BK09_53_L      _PK_L_(0x09, 0x53)
#define REG_SC_BK09_53_H      _PK_H_(0x09, 0x53)
#define REG_SC_BK09_54_L      _PK_L_(0x09, 0x54)
#define REG_SC_BK09_54_H      _PK_H_(0x09, 0x54)
#define REG_SC_BK09_55_L      _PK_L_(0x09, 0x55)
#define REG_SC_BK09_55_H      _PK_H_(0x09, 0x55)
#define REG_SC_BK09_56_L      _PK_L_(0x09, 0x56)
#define REG_SC_BK09_56_H      _PK_H_(0x09, 0x56)
#define REG_SC_BK09_57_L      _PK_L_(0x09, 0x57)
#define REG_SC_BK09_57_H      _PK_H_(0x09, 0x57)
#define REG_SC_BK09_58_L      _PK_L_(0x09, 0x58)
#define REG_SC_BK09_58_H      _PK_H_(0x09, 0x58)
#define REG_SC_BK09_59_L      _PK_L_(0x09, 0x59)
#define REG_SC_BK09_59_H      _PK_H_(0x09, 0x59)
#define REG_SC_BK09_5A_L      _PK_L_(0x09, 0x5A)
#define REG_SC_BK09_5A_H      _PK_H_(0x09, 0x5A)
#define REG_SC_BK09_5B_L      _PK_L_(0x09, 0x5B)
#define REG_SC_BK09_5B_H      _PK_H_(0x09, 0x5B)
#define REG_SC_BK09_5C_L      _PK_L_(0x09, 0x5C)
#define REG_SC_BK09_5C_H      _PK_H_(0x09, 0x5C)
#define REG_SC_BK09_5D_L      _PK_L_(0x09, 0x5D)
#define REG_SC_BK09_5D_H      _PK_H_(0x09, 0x5D)
#define REG_SC_BK09_5E_L      _PK_L_(0x09, 0x5E)
#define REG_SC_BK09_5E_H      _PK_H_(0x09, 0x5E)
#define REG_SC_BK09_5F_L      _PK_L_(0x09, 0x5F)
#define REG_SC_BK09_5F_H      _PK_H_(0x09, 0x5F)
#define REG_SC_BK09_60_L      _PK_L_(0x09, 0x60)
#define REG_SC_BK09_60_H      _PK_H_(0x09, 0x60)
#define REG_SC_BK09_61_L      _PK_L_(0x09, 0x61)
#define REG_SC_BK09_61_H      _PK_H_(0x09, 0x61)
#define REG_SC_BK09_62_L      _PK_L_(0x09, 0x62)
#define REG_SC_BK09_62_H      _PK_H_(0x09, 0x62)
#define REG_SC_BK09_63_L      _PK_L_(0x09, 0x63)
#define REG_SC_BK09_63_H      _PK_H_(0x09, 0x63)
#define REG_SC_BK09_64_L      _PK_L_(0x09, 0x64)
#define REG_SC_BK09_64_H      _PK_H_(0x09, 0x64)
#define REG_SC_BK09_65_L      _PK_L_(0x09, 0x65)
#define REG_SC_BK09_65_H      _PK_H_(0x09, 0x65)
#define REG_SC_BK09_66_L      _PK_L_(0x09, 0x66)
#define REG_SC_BK09_66_H      _PK_H_(0x09, 0x66)
#define REG_SC_BK09_67_L      _PK_L_(0x09, 0x67)
#define REG_SC_BK09_67_H      _PK_H_(0x09, 0x67)
#define REG_SC_BK09_68_L      _PK_L_(0x09, 0x68)
#define REG_SC_BK09_68_H      _PK_H_(0x09, 0x68)
#define REG_SC_BK09_69_L      _PK_L_(0x09, 0x69)
#define REG_SC_BK09_69_H      _PK_H_(0x09, 0x69)
#define REG_SC_BK09_6A_L      _PK_L_(0x09, 0x6A)
#define REG_SC_BK09_6A_H      _PK_H_(0x09, 0x6A)
#define REG_SC_BK09_6B_L      _PK_L_(0x09, 0x6B)
#define REG_SC_BK09_6B_H      _PK_H_(0x09, 0x6B)
#define REG_SC_BK09_6C_L      _PK_L_(0x09, 0x6C)
#define REG_SC_BK09_6C_H      _PK_H_(0x09, 0x6C)
#define REG_SC_BK09_6D_L      _PK_L_(0x09, 0x6D)
#define REG_SC_BK09_6D_H      _PK_H_(0x09, 0x6D)
#define REG_SC_BK09_6E_L      _PK_L_(0x09, 0x6E)
#define REG_SC_BK09_6E_H      _PK_H_(0x09, 0x6E)
#define REG_SC_BK09_6F_L      _PK_L_(0x09, 0x6F)
#define REG_SC_BK09_6F_H      _PK_H_(0x09, 0x6F)
#define REG_SC_BK09_70_L      _PK_L_(0x09, 0x70)
#define REG_SC_BK09_70_H      _PK_H_(0x09, 0x70)
#define REG_SC_BK09_71_L      _PK_L_(0x09, 0x71)
#define REG_SC_BK09_71_H      _PK_H_(0x09, 0x71)
#define REG_SC_BK09_72_L      _PK_L_(0x09, 0x72)
#define REG_SC_BK09_72_H      _PK_H_(0x09, 0x72)
#define REG_SC_BK09_73_L      _PK_L_(0x09, 0x73)
#define REG_SC_BK09_73_H      _PK_H_(0x09, 0x73)
#define REG_SC_BK09_74_L      _PK_L_(0x09, 0x74)
#define REG_SC_BK09_74_H      _PK_H_(0x09, 0x74)
#define REG_SC_BK09_75_L      _PK_L_(0x09, 0x75)
#define REG_SC_BK09_75_H      _PK_H_(0x09, 0x75)
#define REG_SC_BK09_76_L      _PK_L_(0x09, 0x76)
#define REG_SC_BK09_76_H      _PK_H_(0x09, 0x76)
#define REG_SC_BK09_77_L      _PK_L_(0x09, 0x77)
#define REG_SC_BK09_77_H      _PK_H_(0x09, 0x77)
#define REG_SC_BK09_78_L      _PK_L_(0x09, 0x78)
#define REG_SC_BK09_78_H      _PK_H_(0x09, 0x78)
#define REG_SC_BK09_79_L      _PK_L_(0x09, 0x79)
#define REG_SC_BK09_79_H      _PK_H_(0x09, 0x79)
#define REG_SC_BK09_7A_L      _PK_L_(0x09, 0x7A)
#define REG_SC_BK09_7A_H      _PK_H_(0x09, 0x7A)
#define REG_SC_BK09_7B_L      _PK_L_(0x09, 0x7B)
#define REG_SC_BK09_7B_H      _PK_H_(0x09, 0x7B)
#define REG_SC_BK09_7C_L      _PK_L_(0x09, 0x7C)
#define REG_SC_BK09_7C_H      _PK_H_(0x09, 0x7C)
#define REG_SC_BK09_7D_L      _PK_L_(0x09, 0x7D)
#define REG_SC_BK09_7D_H      _PK_H_(0x09, 0x7D)
#define REG_SC_BK09_7E_L      _PK_L_(0x09, 0x7E)
#define REG_SC_BK09_7E_H      _PK_H_(0x09, 0x7E)
#define REG_SC_BK09_7F_L      _PK_L_(0x09, 0x7F)
#define REG_SC_BK09_7F_H      _PK_H_(0x09, 0x7F)

//----------------------------------------------
//  BK0A: OP1ZZ
//----------------------------------------------
#define REG_SC_BK0A_00_L      _PK_L_(0x0A, 0x00)
#define REG_SC_BK0A_00_H      _PK_H_(0x0A, 0x00)
#define REG_SC_BK0A_01_L      _PK_L_(0x0A, 0x01)
#define REG_SC_BK0A_01_H      _PK_H_(0x0A, 0x01)
#define REG_SC_BK0A_02_L      _PK_L_(0x0A, 0x02)
#define REG_SC_BK0A_02_H      _PK_H_(0x0A, 0x02)
#define REG_SC_BK0A_03_L      _PK_L_(0x0A, 0x03)
#define REG_SC_BK0A_03_H      _PK_H_(0x0A, 0x03)
#define REG_SC_BK0A_04_L      _PK_L_(0x0A, 0x04)
#define REG_SC_BK0A_04_H      _PK_H_(0x0A, 0x04)
#define REG_SC_BK0A_05_L      _PK_L_(0x0A, 0x05)
#define REG_SC_BK0A_05_H      _PK_H_(0x0A, 0x05)
#define REG_SC_BK0A_06_L      _PK_L_(0x0A, 0x06)
#define REG_SC_BK0A_06_H      _PK_H_(0x0A, 0x06)
#define REG_SC_BK0A_07_L      _PK_L_(0x0A, 0x07)
#define REG_SC_BK0A_07_H      _PK_H_(0x0A, 0x07)
#define REG_SC_BK0A_08_L      _PK_L_(0x0A, 0x08)
#define REG_SC_BK0A_08_H      _PK_H_(0x0A, 0x08)
#define REG_SC_BK0A_09_L      _PK_L_(0x0A, 0x09)
#define REG_SC_BK0A_09_H      _PK_H_(0x0A, 0x09)
#define REG_SC_BK0A_0A_L      _PK_L_(0x0A, 0x0A)
#define REG_SC_BK0A_0A_H      _PK_H_(0x0A, 0x0A)
#define REG_SC_BK0A_0B_L      _PK_L_(0x0A, 0x0B)
#define REG_SC_BK0A_0B_H      _PK_H_(0x0A, 0x0B)
#define REG_SC_BK0A_0C_L      _PK_L_(0x0A, 0x0C)
#define REG_SC_BK0A_0C_H      _PK_H_(0x0A, 0x0C)
#define REG_SC_BK0A_0D_L      _PK_L_(0x0A, 0x0D)
#define REG_SC_BK0A_0D_H      _PK_H_(0x0A, 0x0D)
#define REG_SC_BK0A_0E_L      _PK_L_(0x0A, 0x0E)
#define REG_SC_BK0A_0E_H      _PK_H_(0x0A, 0x0E)
#define REG_SC_BK0A_0F_L      _PK_L_(0x0A, 0x0F)
#define REG_SC_BK0A_0F_H      _PK_H_(0x0A, 0x0F)
#define REG_SC_BK0A_10_L      _PK_L_(0x0A, 0x10)
#define REG_SC_BK0A_10_H      _PK_H_(0x0A, 0x10)
#define REG_SC_BK0A_11_L      _PK_L_(0x0A, 0x11)
#define REG_SC_BK0A_11_H      _PK_H_(0x0A, 0x11)
#define REG_SC_BK0A_12_L      _PK_L_(0x0A, 0x12)
#define REG_SC_BK0A_12_H      _PK_H_(0x0A, 0x12)
#define REG_SC_BK0A_13_L      _PK_L_(0x0A, 0x13)
#define REG_SC_BK0A_13_H      _PK_H_(0x0A, 0x13)
#define REG_SC_BK0A_14_L      _PK_L_(0x0A, 0x14)
#define REG_SC_BK0A_14_H      _PK_H_(0x0A, 0x14)
#define REG_SC_BK0A_15_L      _PK_L_(0x0A, 0x15)
#define REG_SC_BK0A_15_H      _PK_H_(0x0A, 0x15)
#define REG_SC_BK0A_16_L      _PK_L_(0x0A, 0x16)
#define REG_SC_BK0A_16_H      _PK_H_(0x0A, 0x16)
#define REG_SC_BK0A_17_L      _PK_L_(0x0A, 0x17)
#define REG_SC_BK0A_17_H      _PK_H_(0x0A, 0x17)
#define REG_SC_BK0A_18_L      _PK_L_(0x0A, 0x18)
#define REG_SC_BK0A_18_H      _PK_H_(0x0A, 0x18)
#define REG_SC_BK0A_19_L      _PK_L_(0x0A, 0x19)
#define REG_SC_BK0A_19_H      _PK_H_(0x0A, 0x19)
#define REG_SC_BK0A_1A_L      _PK_L_(0x0A, 0x1A)
#define REG_SC_BK0A_1A_H      _PK_H_(0x0A, 0x1A)
#define REG_SC_BK0A_1B_L      _PK_L_(0x0A, 0x1B)
#define REG_SC_BK0A_1B_H      _PK_H_(0x0A, 0x1B)
#define REG_SC_BK0A_1C_L      _PK_L_(0x0A, 0x1C)
#define REG_SC_BK0A_1C_H      _PK_H_(0x0A, 0x1C)
#define REG_SC_BK0A_1D_L      _PK_L_(0x0A, 0x1D)
#define REG_SC_BK0A_1D_H      _PK_H_(0x0A, 0x1D)
#define REG_SC_BK0A_1E_L      _PK_L_(0x0A, 0x1E)
#define REG_SC_BK0A_1E_H      _PK_H_(0x0A, 0x1E)
#define REG_SC_BK0A_1F_L      _PK_L_(0x0A, 0x1F)
#define REG_SC_BK0A_1F_H      _PK_H_(0x0A, 0x1F)
#define REG_SC_BK0A_20_L      _PK_L_(0x0A, 0x20)
#define REG_SC_BK0A_20_H      _PK_H_(0x0A, 0x20)
#define REG_SC_BK0A_21_L      _PK_L_(0x0A, 0x21)
#define REG_SC_BK0A_21_H      _PK_H_(0x0A, 0x21)
#define REG_SC_BK0A_22_L      _PK_L_(0x0A, 0x22)
#define REG_SC_BK0A_22_H      _PK_H_(0x0A, 0x22)
#define REG_SC_BK0A_23_L      _PK_L_(0x0A, 0x23)
#define REG_SC_BK0A_23_H      _PK_H_(0x0A, 0x23)
#define REG_SC_BK0A_24_L      _PK_L_(0x0A, 0x24)
#define REG_SC_BK0A_24_H      _PK_H_(0x0A, 0x24)
#define REG_SC_BK0A_25_L      _PK_L_(0x0A, 0x25)
#define REG_SC_BK0A_25_H      _PK_H_(0x0A, 0x25)
#define REG_SC_BK0A_26_L      _PK_L_(0x0A, 0x26)
#define REG_SC_BK0A_26_H      _PK_H_(0x0A, 0x26)
#define REG_SC_BK0A_27_L      _PK_L_(0x0A, 0x27)
#define REG_SC_BK0A_27_H      _PK_H_(0x0A, 0x27)
#define REG_SC_BK0A_28_L      _PK_L_(0x0A, 0x28)
#define REG_SC_BK0A_28_H      _PK_H_(0x0A, 0x28)
#define REG_SC_BK0A_29_L      _PK_L_(0x0A, 0x29)
#define REG_SC_BK0A_29_H      _PK_H_(0x0A, 0x29)
#define REG_SC_BK0A_2A_L      _PK_L_(0x0A, 0x2A)
#define REG_SC_BK0A_2A_H      _PK_H_(0x0A, 0x2A)
#define REG_SC_BK0A_2B_L      _PK_L_(0x0A, 0x2B)
#define REG_SC_BK0A_2B_H      _PK_H_(0x0A, 0x2B)
#define REG_SC_BK0A_2C_L      _PK_L_(0x0A, 0x2C)
#define REG_SC_BK0A_2C_H      _PK_H_(0x0A, 0x2C)
#define REG_SC_BK0A_2D_L      _PK_L_(0x0A, 0x2D)
#define REG_SC_BK0A_2D_H      _PK_H_(0x0A, 0x2D)
#define REG_SC_BK0A_2E_L      _PK_L_(0x0A, 0x2E)
#define REG_SC_BK0A_2E_H      _PK_H_(0x0A, 0x2E)
#define REG_SC_BK0A_2F_L      _PK_L_(0x0A, 0x2F)
#define REG_SC_BK0A_2F_H      _PK_H_(0x0A, 0x2F)
#define REG_SC_BK0A_30_L      _PK_L_(0x0A, 0x30)
#define REG_SC_BK0A_30_H      _PK_H_(0x0A, 0x30)
#define REG_SC_BK0A_31_L      _PK_L_(0x0A, 0x31)
#define REG_SC_BK0A_31_H      _PK_H_(0x0A, 0x31)
#define REG_SC_BK0A_32_L      _PK_L_(0x0A, 0x32)
#define REG_SC_BK0A_32_H      _PK_H_(0x0A, 0x32)
#define REG_SC_BK0A_33_L      _PK_L_(0x0A, 0x33)
#define REG_SC_BK0A_33_H      _PK_H_(0x0A, 0x33)
#define REG_SC_BK0A_34_L      _PK_L_(0x0A, 0x34)
#define REG_SC_BK0A_34_H      _PK_H_(0x0A, 0x34)
#define REG_SC_BK0A_35_L      _PK_L_(0x0A, 0x35)
#define REG_SC_BK0A_35_H      _PK_H_(0x0A, 0x35)
#define REG_SC_BK0A_36_L      _PK_L_(0x0A, 0x36)
#define REG_SC_BK0A_36_H      _PK_H_(0x0A, 0x36)
#define REG_SC_BK0A_37_L      _PK_L_(0x0A, 0x37)
#define REG_SC_BK0A_37_H      _PK_H_(0x0A, 0x37)
#define REG_SC_BK0A_38_L      _PK_L_(0x0A, 0x38)
#define REG_SC_BK0A_38_H      _PK_H_(0x0A, 0x38)
#define REG_SC_BK0A_39_L      _PK_L_(0x0A, 0x39)
#define REG_SC_BK0A_39_H      _PK_H_(0x0A, 0x39)
#define REG_SC_BK0A_3A_L      _PK_L_(0x0A, 0x3A)
#define REG_SC_BK0A_3A_H      _PK_H_(0x0A, 0x3A)
#define REG_SC_BK0A_3B_L      _PK_L_(0x0A, 0x3B)
#define REG_SC_BK0A_3B_H      _PK_H_(0x0A, 0x3B)
#define REG_SC_BK0A_3C_L      _PK_L_(0x0A, 0x3C)
#define REG_SC_BK0A_3C_H      _PK_H_(0x0A, 0x3C)
#define REG_SC_BK0A_3D_L      _PK_L_(0x0A, 0x3D)
#define REG_SC_BK0A_3D_H      _PK_H_(0x0A, 0x3D)
#define REG_SC_BK0A_3E_L      _PK_L_(0x0A, 0x3E)
#define REG_SC_BK0A_3E_H      _PK_H_(0x0A, 0x3E)
#define REG_SC_BK0A_3F_L      _PK_L_(0x0A, 0x3F)
#define REG_SC_BK0A_3F_H      _PK_H_(0x0A, 0x3F)
#define REG_SC_BK0A_40_L      _PK_L_(0x0A, 0x40)
#define REG_SC_BK0A_40_H      _PK_H_(0x0A, 0x40)
#define REG_SC_BK0A_41_L      _PK_L_(0x0A, 0x41)
#define REG_SC_BK0A_41_H      _PK_H_(0x0A, 0x41)
#define REG_SC_BK0A_42_L      _PK_L_(0x0A, 0x42)
#define REG_SC_BK0A_42_H      _PK_H_(0x0A, 0x42)
#define REG_SC_BK0A_43_L      _PK_L_(0x0A, 0x43)
#define REG_SC_BK0A_43_H      _PK_H_(0x0A, 0x43)
#define REG_SC_BK0A_44_L      _PK_L_(0x0A, 0x44)
#define REG_SC_BK0A_44_H      _PK_H_(0x0A, 0x44)
#define REG_SC_BK0A_45_L      _PK_L_(0x0A, 0x45)
#define REG_SC_BK0A_45_H      _PK_H_(0x0A, 0x45)
#define REG_SC_BK0A_46_L      _PK_L_(0x0A, 0x46)
#define REG_SC_BK0A_46_H      _PK_H_(0x0A, 0x46)
#define REG_SC_BK0A_47_L      _PK_L_(0x0A, 0x47)
#define REG_SC_BK0A_47_H      _PK_H_(0x0A, 0x47)
#define REG_SC_BK0A_48_L      _PK_L_(0x0A, 0x48)
#define REG_SC_BK0A_48_H      _PK_H_(0x0A, 0x48)
#define REG_SC_BK0A_49_L      _PK_L_(0x0A, 0x49)
#define REG_SC_BK0A_49_H      _PK_H_(0x0A, 0x49)
#define REG_SC_BK0A_4A_L      _PK_L_(0x0A, 0x4A)
#define REG_SC_BK0A_4A_H      _PK_H_(0x0A, 0x4A)
#define REG_SC_BK0A_4B_L      _PK_L_(0x0A, 0x4B)
#define REG_SC_BK0A_4B_H      _PK_H_(0x0A, 0x4B)
#define REG_SC_BK0A_4C_L      _PK_L_(0x0A, 0x4C)
#define REG_SC_BK0A_4C_H      _PK_H_(0x0A, 0x4C)
#define REG_SC_BK0A_4D_L      _PK_L_(0x0A, 0x4D)
#define REG_SC_BK0A_4D_H      _PK_H_(0x0A, 0x4D)
#define REG_SC_BK0A_4E_L      _PK_L_(0x0A, 0x4E)
#define REG_SC_BK0A_4E_H      _PK_H_(0x0A, 0x4E)
#define REG_SC_BK0A_4F_L      _PK_L_(0x0A, 0x4F)
#define REG_SC_BK0A_4F_H      _PK_H_(0x0A, 0x4F)
#define REG_SC_BK0A_50_L      _PK_L_(0x0A, 0x50)
#define REG_SC_BK0A_50_H      _PK_H_(0x0A, 0x50)
#define REG_SC_BK0A_51_L      _PK_L_(0x0A, 0x51)
#define REG_SC_BK0A_51_H      _PK_H_(0x0A, 0x51)
#define REG_SC_BK0A_52_L      _PK_L_(0x0A, 0x52)
#define REG_SC_BK0A_52_H      _PK_H_(0x0A, 0x52)
#define REG_SC_BK0A_53_L      _PK_L_(0x0A, 0x53)
#define REG_SC_BK0A_53_H      _PK_H_(0x0A, 0x53)
#define REG_SC_BK0A_54_L      _PK_L_(0x0A, 0x54)
#define REG_SC_BK0A_54_H      _PK_H_(0x0A, 0x54)
#define REG_SC_BK0A_55_L      _PK_L_(0x0A, 0x55)
#define REG_SC_BK0A_55_H      _PK_H_(0x0A, 0x55)
#define REG_SC_BK0A_56_L      _PK_L_(0x0A, 0x56)
#define REG_SC_BK0A_56_H      _PK_H_(0x0A, 0x56)
#define REG_SC_BK0A_57_L      _PK_L_(0x0A, 0x57)
#define REG_SC_BK0A_57_H      _PK_H_(0x0A, 0x57)
#define REG_SC_BK0A_58_L      _PK_L_(0x0A, 0x58)
#define REG_SC_BK0A_58_H      _PK_H_(0x0A, 0x58)
#define REG_SC_BK0A_59_L      _PK_L_(0x0A, 0x59)
#define REG_SC_BK0A_59_H      _PK_H_(0x0A, 0x59)
#define REG_SC_BK0A_5A_L      _PK_L_(0x0A, 0x5A)
#define REG_SC_BK0A_5A_H      _PK_H_(0x0A, 0x5A)
#define REG_SC_BK0A_5B_L      _PK_L_(0x0A, 0x5B)
#define REG_SC_BK0A_5B_H      _PK_H_(0x0A, 0x5B)
#define REG_SC_BK0A_5C_L      _PK_L_(0x0A, 0x5C)
#define REG_SC_BK0A_5C_H      _PK_H_(0x0A, 0x5C)
#define REG_SC_BK0A_5D_L      _PK_L_(0x0A, 0x5D)
#define REG_SC_BK0A_5D_H      _PK_H_(0x0A, 0x5D)
#define REG_SC_BK0A_5E_L      _PK_L_(0x0A, 0x5E)
#define REG_SC_BK0A_5E_H      _PK_H_(0x0A, 0x5E)
#define REG_SC_BK0A_5F_L      _PK_L_(0x0A, 0x5F)
#define REG_SC_BK0A_5F_H      _PK_H_(0x0A, 0x5F)
#define REG_SC_BK0A_60_L      _PK_L_(0x0A, 0x60)
#define REG_SC_BK0A_60_H      _PK_H_(0x0A, 0x60)
#define REG_SC_BK0A_61_L      _PK_L_(0x0A, 0x61)
#define REG_SC_BK0A_61_H      _PK_H_(0x0A, 0x61)
#define REG_SC_BK0A_62_L      _PK_L_(0x0A, 0x62)
#define REG_SC_BK0A_62_H      _PK_H_(0x0A, 0x62)
#define REG_SC_BK0A_63_L      _PK_L_(0x0A, 0x63)
#define REG_SC_BK0A_63_H      _PK_H_(0x0A, 0x63)
#define REG_SC_BK0A_64_L      _PK_L_(0x0A, 0x64)
#define REG_SC_BK0A_64_H      _PK_H_(0x0A, 0x64)
#define REG_SC_BK0A_65_L      _PK_L_(0x0A, 0x65)
#define REG_SC_BK0A_65_H      _PK_H_(0x0A, 0x65)
#define REG_SC_BK0A_66_L      _PK_L_(0x0A, 0x66)
#define REG_SC_BK0A_66_H      _PK_H_(0x0A, 0x66)
#define REG_SC_BK0A_67_L      _PK_L_(0x0A, 0x67)
#define REG_SC_BK0A_67_H      _PK_H_(0x0A, 0x67)
#define REG_SC_BK0A_68_L      _PK_L_(0x0A, 0x68)
#define REG_SC_BK0A_68_H      _PK_H_(0x0A, 0x68)
#define REG_SC_BK0A_69_L      _PK_L_(0x0A, 0x69)
#define REG_SC_BK0A_69_H      _PK_H_(0x0A, 0x69)
#define REG_SC_BK0A_6A_L      _PK_L_(0x0A, 0x6A)
#define REG_SC_BK0A_6A_H      _PK_H_(0x0A, 0x6A)
#define REG_SC_BK0A_6B_L      _PK_L_(0x0A, 0x6B)
#define REG_SC_BK0A_6B_H      _PK_H_(0x0A, 0x6B)
#define REG_SC_BK0A_6C_L      _PK_L_(0x0A, 0x6C)
#define REG_SC_BK0A_6C_H      _PK_H_(0x0A, 0x6C)
#define REG_SC_BK0A_6D_L      _PK_L_(0x0A, 0x6D)
#define REG_SC_BK0A_6D_H      _PK_H_(0x0A, 0x6D)
#define REG_SC_BK0A_6E_L      _PK_L_(0x0A, 0x6E)
#define REG_SC_BK0A_6E_H      _PK_H_(0x0A, 0x6E)
#define REG_SC_BK0A_6F_L      _PK_L_(0x0A, 0x6F)
#define REG_SC_BK0A_6F_H      _PK_H_(0x0A, 0x6F)
#define REG_SC_BK0A_70_L      _PK_L_(0x0A, 0x70)
#define REG_SC_BK0A_70_H      _PK_H_(0x0A, 0x70)
#define REG_SC_BK0A_71_L      _PK_L_(0x0A, 0x71)
#define REG_SC_BK0A_71_H      _PK_H_(0x0A, 0x71)
#define REG_SC_BK0A_72_L      _PK_L_(0x0A, 0x72)
#define REG_SC_BK0A_72_H      _PK_H_(0x0A, 0x72)
#define REG_SC_BK0A_73_L      _PK_L_(0x0A, 0x73)
#define REG_SC_BK0A_73_H      _PK_H_(0x0A, 0x73)
#define REG_SC_BK0A_74_L      _PK_L_(0x0A, 0x74)
#define REG_SC_BK0A_74_H      _PK_H_(0x0A, 0x74)
#define REG_SC_BK0A_75_L      _PK_L_(0x0A, 0x75)
#define REG_SC_BK0A_75_H      _PK_H_(0x0A, 0x75)
#define REG_SC_BK0A_76_L      _PK_L_(0x0A, 0x76)
#define REG_SC_BK0A_76_H      _PK_H_(0x0A, 0x76)
#define REG_SC_BK0A_77_L      _PK_L_(0x0A, 0x77)
#define REG_SC_BK0A_77_H      _PK_H_(0x0A, 0x77)
#define REG_SC_BK0A_78_L      _PK_L_(0x0A, 0x78)
#define REG_SC_BK0A_78_H      _PK_H_(0x0A, 0x78)
#define REG_SC_BK0A_79_L      _PK_L_(0x0A, 0x79)
#define REG_SC_BK0A_79_H      _PK_H_(0x0A, 0x79)
#define REG_SC_BK0A_7A_L      _PK_L_(0x0A, 0x7A)
#define REG_SC_BK0A_7A_H      _PK_H_(0x0A, 0x7A)
#define REG_SC_BK0A_7B_L      _PK_L_(0x0A, 0x7B)
#define REG_SC_BK0A_7B_H      _PK_H_(0x0A, 0x7B)
#define REG_SC_BK0A_7C_L      _PK_L_(0x0A, 0x7C)
#define REG_SC_BK0A_7C_H      _PK_H_(0x0A, 0x7C)
#define REG_SC_BK0A_7D_L      _PK_L_(0x0A, 0x7D)
#define REG_SC_BK0A_7D_H      _PK_H_(0x0A, 0x7D)
#define REG_SC_BK0A_7E_L      _PK_L_(0x0A, 0x7E)
#define REG_SC_BK0A_7E_H      _PK_H_(0x0A, 0x7E)
#define REG_SC_BK0A_7F_L      _PK_L_(0x0A, 0x7F)
#define REG_SC_BK0A_7F_H      _PK_H_(0x0A, 0x7F)


//----------------------------------------------
//  BK0B: ELA
//----------------------------------------------
#define REG_SC_BK0B_00_L      _PK_L_(0x0B, 0x00)
#define REG_SC_BK0B_00_H      _PK_H_(0x0B, 0x00)
#define REG_SC_BK0B_01_L      _PK_L_(0x0B, 0x01)
#define REG_SC_BK0B_01_H      _PK_H_(0x0B, 0x01)
#define REG_SC_BK0B_02_L      _PK_L_(0x0B, 0x02)
#define REG_SC_BK0B_02_H      _PK_H_(0x0B, 0x02)
#define REG_SC_BK0B_03_L      _PK_L_(0x0B, 0x03)
#define REG_SC_BK0B_03_H      _PK_H_(0x0B, 0x03)
#define REG_SC_BK0B_04_L      _PK_L_(0x0B, 0x04)
#define REG_SC_BK0B_04_H      _PK_H_(0x0B, 0x04)
#define REG_SC_BK0B_05_L      _PK_L_(0x0B, 0x05)
#define REG_SC_BK0B_05_H      _PK_H_(0x0B, 0x05)
#define REG_SC_BK0B_06_L      _PK_L_(0x0B, 0x06)
#define REG_SC_BK0B_06_H      _PK_H_(0x0B, 0x06)
#define REG_SC_BK0B_07_L      _PK_L_(0x0B, 0x07)
#define REG_SC_BK0B_07_H      _PK_H_(0x0B, 0x07)
#define REG_SC_BK0B_08_L      _PK_L_(0x0B, 0x08)
#define REG_SC_BK0B_08_H      _PK_H_(0x0B, 0x08)
#define REG_SC_BK0B_09_L      _PK_L_(0x0B, 0x09)
#define REG_SC_BK0B_09_H      _PK_H_(0x0B, 0x09)
#define REG_SC_BK0B_0A_L      _PK_L_(0x0B, 0x0A)
#define REG_SC_BK0B_0A_H      _PK_H_(0x0B, 0x0A)
#define REG_SC_BK0B_0B_L      _PK_L_(0x0B, 0x0B)
#define REG_SC_BK0B_0B_H      _PK_H_(0x0B, 0x0B)
#define REG_SC_BK0B_0C_L      _PK_L_(0x0B, 0x0C)
#define REG_SC_BK0B_0C_H      _PK_H_(0x0B, 0x0C)
#define REG_SC_BK0B_0D_L      _PK_L_(0x0B, 0x0D)
#define REG_SC_BK0B_0D_H      _PK_H_(0x0B, 0x0D)
#define REG_SC_BK0B_0E_L      _PK_L_(0x0B, 0x0E)
#define REG_SC_BK0B_0E_H      _PK_H_(0x0B, 0x0E)
#define REG_SC_BK0B_0F_L      _PK_L_(0x0B, 0x0F)
#define REG_SC_BK0B_0F_H      _PK_H_(0x0B, 0x0F)
#define REG_SC_BK0B_10_L      _PK_L_(0x0B, 0x10)
#define REG_SC_BK0B_10_H      _PK_H_(0x0B, 0x10)
#define REG_SC_BK0B_11_L      _PK_L_(0x0B, 0x11)
#define REG_SC_BK0B_11_H      _PK_H_(0x0B, 0x11)
#define REG_SC_BK0B_12_L      _PK_L_(0x0B, 0x12)
#define REG_SC_BK0B_12_H      _PK_H_(0x0B, 0x12)
#define REG_SC_BK0B_13_L      _PK_L_(0x0B, 0x13)
#define REG_SC_BK0B_13_H      _PK_H_(0x0B, 0x13)
#define REG_SC_BK0B_14_L      _PK_L_(0x0B, 0x14)
#define REG_SC_BK0B_14_H      _PK_H_(0x0B, 0x14)
#define REG_SC_BK0B_15_L      _PK_L_(0x0B, 0x15)
#define REG_SC_BK0B_15_H      _PK_H_(0x0B, 0x15)
#define REG_SC_BK0B_16_L      _PK_L_(0x0B, 0x16)
#define REG_SC_BK0B_16_H      _PK_H_(0x0B, 0x16)
#define REG_SC_BK0B_17_L      _PK_L_(0x0B, 0x17)
#define REG_SC_BK0B_17_H      _PK_H_(0x0B, 0x17)
#define REG_SC_BK0B_18_L      _PK_L_(0x0B, 0x18)
#define REG_SC_BK0B_18_H      _PK_H_(0x0B, 0x18)
#define REG_SC_BK0B_19_L      _PK_L_(0x0B, 0x19)
#define REG_SC_BK0B_19_H      _PK_H_(0x0B, 0x19)
#define REG_SC_BK0B_1A_L      _PK_L_(0x0B, 0x1A)
#define REG_SC_BK0B_1A_H      _PK_H_(0x0B, 0x1A)
#define REG_SC_BK0B_1B_L      _PK_L_(0x0B, 0x1B)
#define REG_SC_BK0B_1B_H      _PK_H_(0x0B, 0x1B)
#define REG_SC_BK0B_1C_L      _PK_L_(0x0B, 0x1C)
#define REG_SC_BK0B_1C_H      _PK_H_(0x0B, 0x1C)
#define REG_SC_BK0B_1D_L      _PK_L_(0x0B, 0x1D)
#define REG_SC_BK0B_1D_H      _PK_H_(0x0B, 0x1D)
#define REG_SC_BK0B_1E_L      _PK_L_(0x0B, 0x1E)
#define REG_SC_BK0B_1E_H      _PK_H_(0x0B, 0x1E)
#define REG_SC_BK0B_1F_L      _PK_L_(0x0B, 0x1F)
#define REG_SC_BK0B_1F_H      _PK_H_(0x0B, 0x1F)
#define REG_SC_BK0B_20_L      _PK_L_(0x0B, 0x20)
#define REG_SC_BK0B_20_H      _PK_H_(0x0B, 0x20)
#define REG_SC_BK0B_21_L      _PK_L_(0x0B, 0x21)
#define REG_SC_BK0B_21_H      _PK_H_(0x0B, 0x21)
#define REG_SC_BK0B_22_L      _PK_L_(0x0B, 0x22)
#define REG_SC_BK0B_22_H      _PK_H_(0x0B, 0x22)
#define REG_SC_BK0B_23_L      _PK_L_(0x0B, 0x23)
#define REG_SC_BK0B_23_H      _PK_H_(0x0B, 0x23)
#define REG_SC_BK0B_24_L      _PK_L_(0x0B, 0x24)
#define REG_SC_BK0B_24_H      _PK_H_(0x0B, 0x24)
#define REG_SC_BK0B_25_L      _PK_L_(0x0B, 0x25)
#define REG_SC_BK0B_25_H      _PK_H_(0x0B, 0x25)
#define REG_SC_BK0B_26_L      _PK_L_(0x0B, 0x26)
#define REG_SC_BK0B_26_H      _PK_H_(0x0B, 0x26)
#define REG_SC_BK0B_27_L      _PK_L_(0x0B, 0x27)
#define REG_SC_BK0B_27_H      _PK_H_(0x0B, 0x27)
#define REG_SC_BK0B_28_L      _PK_L_(0x0B, 0x28)
#define REG_SC_BK0B_28_H      _PK_H_(0x0B, 0x28)
#define REG_SC_BK0B_29_L      _PK_L_(0x0B, 0x29)
#define REG_SC_BK0B_29_H      _PK_H_(0x0B, 0x29)
#define REG_SC_BK0B_2A_L      _PK_L_(0x0B, 0x2A)
#define REG_SC_BK0B_2A_H      _PK_H_(0x0B, 0x2A)
#define REG_SC_BK0B_2B_L      _PK_L_(0x0B, 0x2B)
#define REG_SC_BK0B_2B_H      _PK_H_(0x0B, 0x2B)
#define REG_SC_BK0B_2C_L      _PK_L_(0x0B, 0x2C)
#define REG_SC_BK0B_2C_H      _PK_H_(0x0B, 0x2C)
#define REG_SC_BK0B_2D_L      _PK_L_(0x0B, 0x2D)
#define REG_SC_BK0B_2D_H      _PK_H_(0x0B, 0x2D)
#define REG_SC_BK0B_2E_L      _PK_L_(0x0B, 0x2E)
#define REG_SC_BK0B_2E_H      _PK_H_(0x0B, 0x2E)
#define REG_SC_BK0B_2F_L      _PK_L_(0x0B, 0x2F)
#define REG_SC_BK0B_2F_H      _PK_H_(0x0B, 0x2F)
#define REG_SC_BK0B_30_L      _PK_L_(0x0B, 0x30)
#define REG_SC_BK0B_30_H      _PK_H_(0x0B, 0x30)
#define REG_SC_BK0B_31_L      _PK_L_(0x0B, 0x31)
#define REG_SC_BK0B_31_H      _PK_H_(0x0B, 0x31)
#define REG_SC_BK0B_32_L      _PK_L_(0x0B, 0x32)
#define REG_SC_BK0B_32_H      _PK_H_(0x0B, 0x32)
#define REG_SC_BK0B_33_L      _PK_L_(0x0B, 0x33)
#define REG_SC_BK0B_33_H      _PK_H_(0x0B, 0x33)
#define REG_SC_BK0B_34_L      _PK_L_(0x0B, 0x34)
#define REG_SC_BK0B_34_H      _PK_H_(0x0B, 0x34)
#define REG_SC_BK0B_35_L      _PK_L_(0x0B, 0x35)
#define REG_SC_BK0B_35_H      _PK_H_(0x0B, 0x35)
#define REG_SC_BK0B_36_L      _PK_L_(0x0B, 0x36)
#define REG_SC_BK0B_36_H      _PK_H_(0x0B, 0x36)
#define REG_SC_BK0B_37_L      _PK_L_(0x0B, 0x37)
#define REG_SC_BK0B_37_H      _PK_H_(0x0B, 0x37)
#define REG_SC_BK0B_38_L      _PK_L_(0x0B, 0x38)
#define REG_SC_BK0B_38_H      _PK_H_(0x0B, 0x38)
#define REG_SC_BK0B_39_L      _PK_L_(0x0B, 0x39)
#define REG_SC_BK0B_39_H      _PK_H_(0x0B, 0x39)
#define REG_SC_BK0B_3A_L      _PK_L_(0x0B, 0x3A)
#define REG_SC_BK0B_3A_H      _PK_H_(0x0B, 0x3A)
#define REG_SC_BK0B_3B_L      _PK_L_(0x0B, 0x3B)
#define REG_SC_BK0B_3B_H      _PK_H_(0x0B, 0x3B)
#define REG_SC_BK0B_3C_L      _PK_L_(0x0B, 0x3C)
#define REG_SC_BK0B_3C_H      _PK_H_(0x0B, 0x3C)
#define REG_SC_BK0B_3D_L      _PK_L_(0x0B, 0x3D)
#define REG_SC_BK0B_3D_H      _PK_H_(0x0B, 0x3D)
#define REG_SC_BK0B_3E_L      _PK_L_(0x0B, 0x3E)
#define REG_SC_BK0B_3E_H      _PK_H_(0x0B, 0x3E)
#define REG_SC_BK0B_3F_L      _PK_L_(0x0B, 0x3F)
#define REG_SC_BK0B_3F_H      _PK_H_(0x0B, 0x3F)
#define REG_SC_BK0B_40_L      _PK_L_(0x0B, 0x40)
#define REG_SC_BK0B_40_H      _PK_H_(0x0B, 0x40)
#define REG_SC_BK0B_41_L      _PK_L_(0x0B, 0x41)
#define REG_SC_BK0B_41_H      _PK_H_(0x0B, 0x41)
#define REG_SC_BK0B_42_L      _PK_L_(0x0B, 0x42)
#define REG_SC_BK0B_42_H      _PK_H_(0x0B, 0x42)
#define REG_SC_BK0B_43_L      _PK_L_(0x0B, 0x43)
#define REG_SC_BK0B_43_H      _PK_H_(0x0B, 0x43)
#define REG_SC_BK0B_44_L      _PK_L_(0x0B, 0x44)
#define REG_SC_BK0B_44_H      _PK_H_(0x0B, 0x44)
#define REG_SC_BK0B_45_L      _PK_L_(0x0B, 0x45)
#define REG_SC_BK0B_45_H      _PK_H_(0x0B, 0x45)
#define REG_SC_BK0B_46_L      _PK_L_(0x0B, 0x46)
#define REG_SC_BK0B_46_H      _PK_H_(0x0B, 0x46)
#define REG_SC_BK0B_47_L      _PK_L_(0x0B, 0x47)
#define REG_SC_BK0B_47_H      _PK_H_(0x0B, 0x47)
#define REG_SC_BK0B_48_L      _PK_L_(0x0B, 0x48)
#define REG_SC_BK0B_48_H      _PK_H_(0x0B, 0x48)
#define REG_SC_BK0B_49_L      _PK_L_(0x0B, 0x49)
#define REG_SC_BK0B_49_H      _PK_H_(0x0B, 0x49)
#define REG_SC_BK0B_4A_L      _PK_L_(0x0B, 0x4A)
#define REG_SC_BK0B_4A_H      _PK_H_(0x0B, 0x4A)
#define REG_SC_BK0B_4B_L      _PK_L_(0x0B, 0x4B)
#define REG_SC_BK0B_4B_H      _PK_H_(0x0B, 0x4B)
#define REG_SC_BK0B_4C_L      _PK_L_(0x0B, 0x4C)
#define REG_SC_BK0B_4C_H      _PK_H_(0x0B, 0x4C)
#define REG_SC_BK0B_4D_L      _PK_L_(0x0B, 0x4D)
#define REG_SC_BK0B_4D_H      _PK_H_(0x0B, 0x4D)
#define REG_SC_BK0B_4E_L      _PK_L_(0x0B, 0x4E)
#define REG_SC_BK0B_4E_H      _PK_H_(0x0B, 0x4E)
#define REG_SC_BK0B_4F_L      _PK_L_(0x0B, 0x4F)
#define REG_SC_BK0B_4F_H      _PK_H_(0x0B, 0x4F)
#define REG_SC_BK0B_50_L      _PK_L_(0x0B, 0x50)
#define REG_SC_BK0B_50_H      _PK_H_(0x0B, 0x50)
#define REG_SC_BK0B_51_L      _PK_L_(0x0B, 0x51)
#define REG_SC_BK0B_51_H      _PK_H_(0x0B, 0x51)
#define REG_SC_BK0B_52_L      _PK_L_(0x0B, 0x52)
#define REG_SC_BK0B_52_H      _PK_H_(0x0B, 0x52)
#define REG_SC_BK0B_53_L      _PK_L_(0x0B, 0x53)
#define REG_SC_BK0B_53_H      _PK_H_(0x0B, 0x53)
#define REG_SC_BK0B_54_L      _PK_L_(0x0B, 0x54)
#define REG_SC_BK0B_54_H      _PK_H_(0x0B, 0x54)
#define REG_SC_BK0B_55_L      _PK_L_(0x0B, 0x55)
#define REG_SC_BK0B_55_H      _PK_H_(0x0B, 0x55)
#define REG_SC_BK0B_56_L      _PK_L_(0x0B, 0x56)
#define REG_SC_BK0B_56_H      _PK_H_(0x0B, 0x56)
#define REG_SC_BK0B_57_L      _PK_L_(0x0B, 0x57)
#define REG_SC_BK0B_57_H      _PK_H_(0x0B, 0x57)
#define REG_SC_BK0B_58_L      _PK_L_(0x0B, 0x58)
#define REG_SC_BK0B_58_H      _PK_H_(0x0B, 0x58)
#define REG_SC_BK0B_59_L      _PK_L_(0x0B, 0x59)
#define REG_SC_BK0B_59_H      _PK_H_(0x0B, 0x59)
#define REG_SC_BK0B_5A_L      _PK_L_(0x0B, 0x5A)
#define REG_SC_BK0B_5A_H      _PK_H_(0x0B, 0x5A)
#define REG_SC_BK0B_5B_L      _PK_L_(0x0B, 0x5B)
#define REG_SC_BK0B_5B_H      _PK_H_(0x0B, 0x5B)
#define REG_SC_BK0B_5C_L      _PK_L_(0x0B, 0x5C)
#define REG_SC_BK0B_5C_H      _PK_H_(0x0B, 0x5C)
#define REG_SC_BK0B_5D_L      _PK_L_(0x0B, 0x5D)
#define REG_SC_BK0B_5D_H      _PK_H_(0x0B, 0x5D)
#define REG_SC_BK0B_5E_L      _PK_L_(0x0B, 0x5E)
#define REG_SC_BK0B_5E_H      _PK_H_(0x0B, 0x5E)
#define REG_SC_BK0B_5F_L      _PK_L_(0x0B, 0x5F)
#define REG_SC_BK0B_5F_H      _PK_H_(0x0B, 0x5F)
#define REG_SC_BK0B_60_L      _PK_L_(0x0B, 0x60)
#define REG_SC_BK0B_60_H      _PK_H_(0x0B, 0x60)
#define REG_SC_BK0B_61_L      _PK_L_(0x0B, 0x61)
#define REG_SC_BK0B_61_H      _PK_H_(0x0B, 0x61)
#define REG_SC_BK0B_62_L      _PK_L_(0x0B, 0x62)
#define REG_SC_BK0B_62_H      _PK_H_(0x0B, 0x62)
#define REG_SC_BK0B_63_L      _PK_L_(0x0B, 0x63)
#define REG_SC_BK0B_63_H      _PK_H_(0x0B, 0x63)
#define REG_SC_BK0B_64_L      _PK_L_(0x0B, 0x64)
#define REG_SC_BK0B_64_H      _PK_H_(0x0B, 0x64)
#define REG_SC_BK0B_65_L      _PK_L_(0x0B, 0x65)
#define REG_SC_BK0B_65_H      _PK_H_(0x0B, 0x65)
#define REG_SC_BK0B_66_L      _PK_L_(0x0B, 0x66)
#define REG_SC_BK0B_66_H      _PK_H_(0x0B, 0x66)
#define REG_SC_BK0B_67_L      _PK_L_(0x0B, 0x67)
#define REG_SC_BK0B_67_H      _PK_H_(0x0B, 0x67)
#define REG_SC_BK0B_68_L      _PK_L_(0x0B, 0x68)
#define REG_SC_BK0B_68_H      _PK_H_(0x0B, 0x68)
#define REG_SC_BK0B_69_L      _PK_L_(0x0B, 0x69)
#define REG_SC_BK0B_69_H      _PK_H_(0x0B, 0x69)
#define REG_SC_BK0B_6A_L      _PK_L_(0x0B, 0x6A)
#define REG_SC_BK0B_6A_H      _PK_H_(0x0B, 0x6A)
#define REG_SC_BK0B_6B_L      _PK_L_(0x0B, 0x6B)
#define REG_SC_BK0B_6B_H      _PK_H_(0x0B, 0x6B)
#define REG_SC_BK0B_6C_L      _PK_L_(0x0B, 0x6C)
#define REG_SC_BK0B_6C_H      _PK_H_(0x0B, 0x6C)
#define REG_SC_BK0B_6D_L      _PK_L_(0x0B, 0x6D)
#define REG_SC_BK0B_6D_H      _PK_H_(0x0B, 0x6D)
#define REG_SC_BK0B_6E_L      _PK_L_(0x0B, 0x6E)
#define REG_SC_BK0B_6E_H      _PK_H_(0x0B, 0x6E)
#define REG_SC_BK0B_6F_L      _PK_L_(0x0B, 0x6F)
#define REG_SC_BK0B_6F_H      _PK_H_(0x0B, 0x6F)
#define REG_SC_BK0B_70_L      _PK_L_(0x0B, 0x70)
#define REG_SC_BK0B_70_H      _PK_H_(0x0B, 0x70)
#define REG_SC_BK0B_71_L      _PK_L_(0x0B, 0x71)
#define REG_SC_BK0B_71_H      _PK_H_(0x0B, 0x71)
#define REG_SC_BK0B_72_L      _PK_L_(0x0B, 0x72)
#define REG_SC_BK0B_72_H      _PK_H_(0x0B, 0x72)
#define REG_SC_BK0B_73_L      _PK_L_(0x0B, 0x73)
#define REG_SC_BK0B_73_H      _PK_H_(0x0B, 0x73)
#define REG_SC_BK0B_74_L      _PK_L_(0x0B, 0x74)
#define REG_SC_BK0B_74_H      _PK_H_(0x0B, 0x74)
#define REG_SC_BK0B_75_L      _PK_L_(0x0B, 0x75)
#define REG_SC_BK0B_75_H      _PK_H_(0x0B, 0x75)
#define REG_SC_BK0B_76_L      _PK_L_(0x0B, 0x76)
#define REG_SC_BK0B_76_H      _PK_H_(0x0B, 0x76)
#define REG_SC_BK0B_77_L      _PK_L_(0x0B, 0x77)
#define REG_SC_BK0B_77_H      _PK_H_(0x0B, 0x77)
#define REG_SC_BK0B_78_L      _PK_L_(0x0B, 0x78)
#define REG_SC_BK0B_78_H      _PK_H_(0x0B, 0x78)
#define REG_SC_BK0B_79_L      _PK_L_(0x0B, 0x79)
#define REG_SC_BK0B_79_H      _PK_H_(0x0B, 0x79)
#define REG_SC_BK0B_7A_L      _PK_L_(0x0B, 0x7A)
#define REG_SC_BK0B_7A_H      _PK_H_(0x0B, 0x7A)
#define REG_SC_BK0B_7B_L      _PK_L_(0x0B, 0x7B)
#define REG_SC_BK0B_7B_H      _PK_H_(0x0B, 0x7B)
#define REG_SC_BK0B_7C_L      _PK_L_(0x0B, 0x7C)
#define REG_SC_BK0B_7C_H      _PK_H_(0x0B, 0x7C)
#define REG_SC_BK0B_7D_L      _PK_L_(0x0B, 0x7D)
#define REG_SC_BK0B_7D_H      _PK_H_(0x0B, 0x7D)
#define REG_SC_BK0B_7E_L      _PK_L_(0x0B, 0x7E)
#define REG_SC_BK0B_7E_H      _PK_H_(0x0B, 0x7E)
#define REG_SC_BK0B_7F_L      _PK_L_(0x0B, 0x7F)
#define REG_SC_BK0B_7F_H      _PK_H_(0x0B, 0x7F)

//----------------------------------------------
//  BK0C: SNR
//----------------------------------------------
#define REG_SC_BK0C_00_L      _PK_L_(0x0C, 0x00)
#define REG_SC_BK0C_00_H      _PK_H_(0x0C, 0x00)
#define REG_SC_BK0C_01_L      _PK_L_(0x0C, 0x01)
#define REG_SC_BK0C_01_H      _PK_H_(0x0C, 0x01)
#define REG_SC_BK0C_02_L      _PK_L_(0x0C, 0x02)
#define REG_SC_BK0C_02_H      _PK_H_(0x0C, 0x02)
#define REG_SC_BK0C_03_L      _PK_L_(0x0C, 0x03)
#define REG_SC_BK0C_03_H      _PK_H_(0x0C, 0x03)
#define REG_SC_BK0C_04_L      _PK_L_(0x0C, 0x04)
#define REG_SC_BK0C_04_H      _PK_H_(0x0C, 0x04)
#define REG_SC_BK0C_05_L      _PK_L_(0x0C, 0x05)
#define REG_SC_BK0C_05_H      _PK_H_(0x0C, 0x05)
#define REG_SC_BK0C_06_L      _PK_L_(0x0C, 0x06)
#define REG_SC_BK0C_06_H      _PK_H_(0x0C, 0x06)
#define REG_SC_BK0C_07_L      _PK_L_(0x0C, 0x07)
#define REG_SC_BK0C_07_H      _PK_H_(0x0C, 0x07)
#define REG_SC_BK0C_08_L      _PK_L_(0x0C, 0x08)
#define REG_SC_BK0C_08_H      _PK_H_(0x0C, 0x08)
#define REG_SC_BK0C_09_L      _PK_L_(0x0C, 0x09)
#define REG_SC_BK0C_09_H      _PK_H_(0x0C, 0x09)
#define REG_SC_BK0C_0A_L      _PK_L_(0x0C, 0x0A)
#define REG_SC_BK0C_0A_H      _PK_H_(0x0C, 0x0A)
#define REG_SC_BK0C_0B_L      _PK_L_(0x0C, 0x0B)
#define REG_SC_BK0C_0B_H      _PK_H_(0x0C, 0x0B)
#define REG_SC_BK0C_0C_L      _PK_L_(0x0C, 0x0C)
#define REG_SC_BK0C_0C_H      _PK_H_(0x0C, 0x0C)
#define REG_SC_BK0C_0D_L      _PK_L_(0x0C, 0x0D)
#define REG_SC_BK0C_0D_H      _PK_H_(0x0C, 0x0D)
#define REG_SC_BK0C_0E_L      _PK_L_(0x0C, 0x0E)
#define REG_SC_BK0C_0E_H      _PK_H_(0x0C, 0x0E)
#define REG_SC_BK0C_0F_L      _PK_L_(0x0C, 0x0F)
#define REG_SC_BK0C_0F_H      _PK_H_(0x0C, 0x0F)
#define REG_SC_BK0C_10_L      _PK_L_(0x0C, 0x10)
#define REG_SC_BK0C_10_H      _PK_H_(0x0C, 0x10)
#define REG_SC_BK0C_11_L      _PK_L_(0x0C, 0x11)
#define REG_SC_BK0C_11_H      _PK_H_(0x0C, 0x11)
#define REG_SC_BK0C_12_L      _PK_L_(0x0C, 0x12)
#define REG_SC_BK0C_12_H      _PK_H_(0x0C, 0x12)
#define REG_SC_BK0C_13_L      _PK_L_(0x0C, 0x13)
#define REG_SC_BK0C_13_H      _PK_H_(0x0C, 0x13)
#define REG_SC_BK0C_14_L      _PK_L_(0x0C, 0x14)
#define REG_SC_BK0C_14_H      _PK_H_(0x0C, 0x14)
#define REG_SC_BK0C_15_L      _PK_L_(0x0C, 0x15)
#define REG_SC_BK0C_15_H      _PK_H_(0x0C, 0x15)
#define REG_SC_BK0C_16_L      _PK_L_(0x0C, 0x16)
#define REG_SC_BK0C_16_H      _PK_H_(0x0C, 0x16)
#define REG_SC_BK0C_17_L      _PK_L_(0x0C, 0x17)
#define REG_SC_BK0C_17_H      _PK_H_(0x0C, 0x17)
#define REG_SC_BK0C_18_L      _PK_L_(0x0C, 0x18)
#define REG_SC_BK0C_18_H      _PK_H_(0x0C, 0x18)
#define REG_SC_BK0C_19_L      _PK_L_(0x0C, 0x19)
#define REG_SC_BK0C_19_H      _PK_H_(0x0C, 0x19)
#define REG_SC_BK0C_1A_L      _PK_L_(0x0C, 0x1A)
#define REG_SC_BK0C_1A_H      _PK_H_(0x0C, 0x1A)
#define REG_SC_BK0C_1B_L      _PK_L_(0x0C, 0x1B)
#define REG_SC_BK0C_1B_H      _PK_H_(0x0C, 0x1B)
#define REG_SC_BK0C_1C_L      _PK_L_(0x0C, 0x1C)
#define REG_SC_BK0C_1C_H      _PK_H_(0x0C, 0x1C)
#define REG_SC_BK0C_1D_L      _PK_L_(0x0C, 0x1D)
#define REG_SC_BK0C_1D_H      _PK_H_(0x0C, 0x1D)
#define REG_SC_BK0C_1E_L      _PK_L_(0x0C, 0x1E)
#define REG_SC_BK0C_1E_H      _PK_H_(0x0C, 0x1E)
#define REG_SC_BK0C_1F_L      _PK_L_(0x0C, 0x1F)
#define REG_SC_BK0C_1F_H      _PK_H_(0x0C, 0x1F)
#define REG_SC_BK0C_20_L      _PK_L_(0x0C, 0x20)
#define REG_SC_BK0C_20_H      _PK_H_(0x0C, 0x20)
#define REG_SC_BK0C_21_L      _PK_L_(0x0C, 0x21)
#define REG_SC_BK0C_21_H      _PK_H_(0x0C, 0x21)
#define REG_SC_BK0C_22_L      _PK_L_(0x0C, 0x22)
#define REG_SC_BK0C_22_H      _PK_H_(0x0C, 0x22)
#define REG_SC_BK0C_23_L      _PK_L_(0x0C, 0x23)
#define REG_SC_BK0C_23_H      _PK_H_(0x0C, 0x23)
#define REG_SC_BK0C_24_L      _PK_L_(0x0C, 0x24)
#define REG_SC_BK0C_24_H      _PK_H_(0x0C, 0x24)
#define REG_SC_BK0C_25_L      _PK_L_(0x0C, 0x25)
#define REG_SC_BK0C_25_H      _PK_H_(0x0C, 0x25)
#define REG_SC_BK0C_26_L      _PK_L_(0x0C, 0x26)
#define REG_SC_BK0C_26_H      _PK_H_(0x0C, 0x26)
#define REG_SC_BK0C_27_L      _PK_L_(0x0C, 0x27)
#define REG_SC_BK0C_27_H      _PK_H_(0x0C, 0x27)
#define REG_SC_BK0C_28_L      _PK_L_(0x0C, 0x28)
#define REG_SC_BK0C_28_H      _PK_H_(0x0C, 0x28)
#define REG_SC_BK0C_29_L      _PK_L_(0x0C, 0x29)
#define REG_SC_BK0C_29_H      _PK_H_(0x0C, 0x29)
#define REG_SC_BK0C_2A_L      _PK_L_(0x0C, 0x2A)
#define REG_SC_BK0C_2A_H      _PK_H_(0x0C, 0x2A)
#define REG_SC_BK0C_2B_L      _PK_L_(0x0C, 0x2B)
#define REG_SC_BK0C_2B_H      _PK_H_(0x0C, 0x2B)
#define REG_SC_BK0C_2C_L      _PK_L_(0x0C, 0x2C)
#define REG_SC_BK0C_2C_H      _PK_H_(0x0C, 0x2C)
#define REG_SC_BK0C_2D_L      _PK_L_(0x0C, 0x2D)
#define REG_SC_BK0C_2D_H      _PK_H_(0x0C, 0x2D)
#define REG_SC_BK0C_2E_L      _PK_L_(0x0C, 0x2E)
#define REG_SC_BK0C_2E_H      _PK_H_(0x0C, 0x2E)
#define REG_SC_BK0C_2F_L      _PK_L_(0x0C, 0x2F)
#define REG_SC_BK0C_2F_H      _PK_H_(0x0C, 0x2F)
#define REG_SC_BK0C_30_L      _PK_L_(0x0C, 0x30)
#define REG_SC_BK0C_30_H      _PK_H_(0x0C, 0x30)
#define REG_SC_BK0C_31_L      _PK_L_(0x0C, 0x31)
#define REG_SC_BK0C_31_H      _PK_H_(0x0C, 0x31)
#define REG_SC_BK0C_32_L      _PK_L_(0x0C, 0x32)
#define REG_SC_BK0C_32_H      _PK_H_(0x0C, 0x32)
#define REG_SC_BK0C_33_L      _PK_L_(0x0C, 0x33)
#define REG_SC_BK0C_33_H      _PK_H_(0x0C, 0x33)
#define REG_SC_BK0C_34_L      _PK_L_(0x0C, 0x34)
#define REG_SC_BK0C_34_H      _PK_H_(0x0C, 0x34)
#define REG_SC_BK0C_35_L      _PK_L_(0x0C, 0x35)
#define REG_SC_BK0C_35_H      _PK_H_(0x0C, 0x35)
#define REG_SC_BK0C_36_L      _PK_L_(0x0C, 0x36)
#define REG_SC_BK0C_36_H      _PK_H_(0x0C, 0x36)
#define REG_SC_BK0C_37_L      _PK_L_(0x0C, 0x37)
#define REG_SC_BK0C_37_H      _PK_H_(0x0C, 0x37)
#define REG_SC_BK0C_38_L      _PK_L_(0x0C, 0x38)
#define REG_SC_BK0C_38_H      _PK_H_(0x0C, 0x38)
#define REG_SC_BK0C_39_L      _PK_L_(0x0C, 0x39)
#define REG_SC_BK0C_39_H      _PK_H_(0x0C, 0x39)
#define REG_SC_BK0C_3A_L      _PK_L_(0x0C, 0x3A)
#define REG_SC_BK0C_3A_H      _PK_H_(0x0C, 0x3A)
#define REG_SC_BK0C_3B_L      _PK_L_(0x0C, 0x3B)
#define REG_SC_BK0C_3B_H      _PK_H_(0x0C, 0x3B)
#define REG_SC_BK0C_3C_L      _PK_L_(0x0C, 0x3C)
#define REG_SC_BK0C_3C_H      _PK_H_(0x0C, 0x3C)
#define REG_SC_BK0C_3D_L      _PK_L_(0x0C, 0x3D)
#define REG_SC_BK0C_3D_H      _PK_H_(0x0C, 0x3D)
#define REG_SC_BK0C_3E_L      _PK_L_(0x0C, 0x3E)
#define REG_SC_BK0C_3E_H      _PK_H_(0x0C, 0x3E)
#define REG_SC_BK0C_3F_L      _PK_L_(0x0C, 0x3F)
#define REG_SC_BK0C_3F_H      _PK_H_(0x0C, 0x3F)
#define REG_SC_BK0C_40_L      _PK_L_(0x0C, 0x40)
#define REG_SC_BK0C_40_H      _PK_H_(0x0C, 0x40)
#define REG_SC_BK0C_41_L      _PK_L_(0x0C, 0x41)
#define REG_SC_BK0C_41_H      _PK_H_(0x0C, 0x41)
#define REG_SC_BK0C_42_L      _PK_L_(0x0C, 0x42)
#define REG_SC_BK0C_42_H      _PK_H_(0x0C, 0x42)
#define REG_SC_BK0C_43_L      _PK_L_(0x0C, 0x43)
#define REG_SC_BK0C_43_H      _PK_H_(0x0C, 0x43)
#define REG_SC_BK0C_44_L      _PK_L_(0x0C, 0x44)
#define REG_SC_BK0C_44_H      _PK_H_(0x0C, 0x44)
#define REG_SC_BK0C_45_L      _PK_L_(0x0C, 0x45)
#define REG_SC_BK0C_45_H      _PK_H_(0x0C, 0x45)
#define REG_SC_BK0C_46_L      _PK_L_(0x0C, 0x46)
#define REG_SC_BK0C_46_H      _PK_H_(0x0C, 0x46)
#define REG_SC_BK0C_47_L      _PK_L_(0x0C, 0x47)
#define REG_SC_BK0C_47_H      _PK_H_(0x0C, 0x47)
#define REG_SC_BK0C_48_L      _PK_L_(0x0C, 0x48)
#define REG_SC_BK0C_48_H      _PK_H_(0x0C, 0x48)
#define REG_SC_BK0C_49_L      _PK_L_(0x0C, 0x49)
#define REG_SC_BK0C_49_H      _PK_H_(0x0C, 0x49)
#define REG_SC_BK0C_4A_L      _PK_L_(0x0C, 0x4A)
#define REG_SC_BK0C_4A_H      _PK_H_(0x0C, 0x4A)
#define REG_SC_BK0C_4B_L      _PK_L_(0x0C, 0x4B)
#define REG_SC_BK0C_4B_H      _PK_H_(0x0C, 0x4B)
#define REG_SC_BK0C_4C_L      _PK_L_(0x0C, 0x4C)
#define REG_SC_BK0C_4C_H      _PK_H_(0x0C, 0x4C)
#define REG_SC_BK0C_4D_L      _PK_L_(0x0C, 0x4D)
#define REG_SC_BK0C_4D_H      _PK_H_(0x0C, 0x4D)
#define REG_SC_BK0C_4E_L      _PK_L_(0x0C, 0x4E)
#define REG_SC_BK0C_4E_H      _PK_H_(0x0C, 0x4E)
#define REG_SC_BK0C_4F_L      _PK_L_(0x0C, 0x4F)
#define REG_SC_BK0C_4F_H      _PK_H_(0x0C, 0x4F)
#define REG_SC_BK0C_50_L      _PK_L_(0x0C, 0x50)
#define REG_SC_BK0C_50_H      _PK_H_(0x0C, 0x50)
#define REG_SC_BK0C_51_L      _PK_L_(0x0C, 0x51)
#define REG_SC_BK0C_51_H      _PK_H_(0x0C, 0x51)
#define REG_SC_BK0C_52_L      _PK_L_(0x0C, 0x52)
#define REG_SC_BK0C_52_H      _PK_H_(0x0C, 0x52)
#define REG_SC_BK0C_53_L      _PK_L_(0x0C, 0x53)
#define REG_SC_BK0C_53_H      _PK_H_(0x0C, 0x53)
#define REG_SC_BK0C_54_L      _PK_L_(0x0C, 0x54)
#define REG_SC_BK0C_54_H      _PK_H_(0x0C, 0x54)
#define REG_SC_BK0C_55_L      _PK_L_(0x0C, 0x55)
#define REG_SC_BK0C_55_H      _PK_H_(0x0C, 0x55)
#define REG_SC_BK0C_56_L      _PK_L_(0x0C, 0x56)
#define REG_SC_BK0C_56_H      _PK_H_(0x0C, 0x56)
#define REG_SC_BK0C_57_L      _PK_L_(0x0C, 0x57)
#define REG_SC_BK0C_57_H      _PK_H_(0x0C, 0x57)
#define REG_SC_BK0C_58_L      _PK_L_(0x0C, 0x58)
#define REG_SC_BK0C_58_H      _PK_H_(0x0C, 0x58)
#define REG_SC_BK0C_59_L      _PK_L_(0x0C, 0x59)
#define REG_SC_BK0C_59_H      _PK_H_(0x0C, 0x59)
#define REG_SC_BK0C_5A_L      _PK_L_(0x0C, 0x5A)
#define REG_SC_BK0C_5A_H      _PK_H_(0x0C, 0x5A)
#define REG_SC_BK0C_5B_L      _PK_L_(0x0C, 0x5B)
#define REG_SC_BK0C_5B_H      _PK_H_(0x0C, 0x5B)
#define REG_SC_BK0C_5C_L      _PK_L_(0x0C, 0x5C)
#define REG_SC_BK0C_5C_H      _PK_H_(0x0C, 0x5C)
#define REG_SC_BK0C_5D_L      _PK_L_(0x0C, 0x5D)
#define REG_SC_BK0C_5D_H      _PK_H_(0x0C, 0x5D)
#define REG_SC_BK0C_5E_L      _PK_L_(0x0C, 0x5E)
#define REG_SC_BK0C_5E_H      _PK_H_(0x0C, 0x5E)
#define REG_SC_BK0C_5F_L      _PK_L_(0x0C, 0x5F)
#define REG_SC_BK0C_5F_H      _PK_H_(0x0C, 0x5F)
#define REG_SC_BK0C_60_L      _PK_L_(0x0C, 0x60)
#define REG_SC_BK0C_60_H      _PK_H_(0x0C, 0x60)
#define REG_SC_BK0C_61_L      _PK_L_(0x0C, 0x61)
#define REG_SC_BK0C_61_H      _PK_H_(0x0C, 0x61)
#define REG_SC_BK0C_62_L      _PK_L_(0x0C, 0x62)
#define REG_SC_BK0C_62_H      _PK_H_(0x0C, 0x62)
#define REG_SC_BK0C_63_L      _PK_L_(0x0C, 0x63)
#define REG_SC_BK0C_63_H      _PK_H_(0x0C, 0x63)
#define REG_SC_BK0C_64_L      _PK_L_(0x0C, 0x64)
#define REG_SC_BK0C_64_H      _PK_H_(0x0C, 0x64)
#define REG_SC_BK0C_65_L      _PK_L_(0x0C, 0x65)
#define REG_SC_BK0C_65_H      _PK_H_(0x0C, 0x65)
#define REG_SC_BK0C_66_L      _PK_L_(0x0C, 0x66)
#define REG_SC_BK0C_66_H      _PK_H_(0x0C, 0x66)
#define REG_SC_BK0C_67_L      _PK_L_(0x0C, 0x67)
#define REG_SC_BK0C_67_H      _PK_H_(0x0C, 0x67)
#define REG_SC_BK0C_68_L      _PK_L_(0x0C, 0x68)
#define REG_SC_BK0C_68_H      _PK_H_(0x0C, 0x68)
#define REG_SC_BK0C_69_L      _PK_L_(0x0C, 0x69)
#define REG_SC_BK0C_69_H      _PK_H_(0x0C, 0x69)
#define REG_SC_BK0C_6A_L      _PK_L_(0x0C, 0x6A)
#define REG_SC_BK0C_6A_H      _PK_H_(0x0C, 0x6A)
#define REG_SC_BK0C_6B_L      _PK_L_(0x0C, 0x6B)
#define REG_SC_BK0C_6B_H      _PK_H_(0x0C, 0x6B)
#define REG_SC_BK0C_6C_L      _PK_L_(0x0C, 0x6C)
#define REG_SC_BK0C_6C_H      _PK_H_(0x0C, 0x6C)
#define REG_SC_BK0C_6D_L      _PK_L_(0x0C, 0x6D)
#define REG_SC_BK0C_6D_H      _PK_H_(0x0C, 0x6D)
#define REG_SC_BK0C_6E_L      _PK_L_(0x0C, 0x6E)
#define REG_SC_BK0C_6E_H      _PK_H_(0x0C, 0x6E)
#define REG_SC_BK0C_6F_L      _PK_L_(0x0C, 0x6F)
#define REG_SC_BK0C_6F_H      _PK_H_(0x0C, 0x6F)
#define REG_SC_BK0C_70_L      _PK_L_(0x0C, 0x70)
#define REG_SC_BK0C_70_H      _PK_H_(0x0C, 0x70)
#define REG_SC_BK0C_71_L      _PK_L_(0x0C, 0x71)
#define REG_SC_BK0C_71_H      _PK_H_(0x0C, 0x71)
#define REG_SC_BK0C_72_L      _PK_L_(0x0C, 0x72)
#define REG_SC_BK0C_72_H      _PK_H_(0x0C, 0x72)
#define REG_SC_BK0C_73_L      _PK_L_(0x0C, 0x73)
#define REG_SC_BK0C_73_H      _PK_H_(0x0C, 0x73)
#define REG_SC_BK0C_74_L      _PK_L_(0x0C, 0x74)
#define REG_SC_BK0C_74_H      _PK_H_(0x0C, 0x74)
#define REG_SC_BK0C_75_L      _PK_L_(0x0C, 0x75)
#define REG_SC_BK0C_75_H      _PK_H_(0x0C, 0x75)
#define REG_SC_BK0C_76_L      _PK_L_(0x0C, 0x76)
#define REG_SC_BK0C_76_H      _PK_H_(0x0C, 0x76)
#define REG_SC_BK0C_77_L      _PK_L_(0x0C, 0x77)
#define REG_SC_BK0C_77_H      _PK_H_(0x0C, 0x77)
#define REG_SC_BK0C_78_L      _PK_L_(0x0C, 0x78)
#define REG_SC_BK0C_78_H      _PK_H_(0x0C, 0x78)
#define REG_SC_BK0C_79_L      _PK_L_(0x0C, 0x79)
#define REG_SC_BK0C_79_H      _PK_H_(0x0C, 0x79)
#define REG_SC_BK0C_7A_L      _PK_L_(0x0C, 0x7A)
#define REG_SC_BK0C_7A_H      _PK_H_(0x0C, 0x7A)
#define REG_SC_BK0C_7B_L      _PK_L_(0x0C, 0x7B)
#define REG_SC_BK0C_7B_H      _PK_H_(0x0C, 0x7B)
#define REG_SC_BK0C_7C_L      _PK_L_(0x0C, 0x7C)
#define REG_SC_BK0C_7C_H      _PK_H_(0x0C, 0x7C)
#define REG_SC_BK0C_7D_L      _PK_L_(0x0C, 0x7D)
#define REG_SC_BK0C_7D_H      _PK_H_(0x0C, 0x7D)
#define REG_SC_BK0C_7E_L      _PK_L_(0x0C, 0x7E)
#define REG_SC_BK0C_7E_H      _PK_H_(0x0C, 0x7E)
#define REG_SC_BK0C_7F_L      _PK_L_(0x0C, 0x7F)
#define REG_SC_BK0C_7F_H      _PK_H_(0x0C, 0x7F)

//----------------------------------------------
//  BK0D: MRQ
//----------------------------------------------
#define REG_SC_BK0D_00_L      _PK_L_(0x0D, 0x00)
#define REG_SC_BK0D_00_H      _PK_H_(0x0D, 0x00)
#define REG_SC_BK0D_01_L      _PK_L_(0x0D, 0x01)
#define REG_SC_BK0D_01_H      _PK_H_(0x0D, 0x01)
#define REG_SC_BK0D_02_L      _PK_L_(0x0D, 0x02)
#define REG_SC_BK0D_02_H      _PK_H_(0x0D, 0x02)
#define REG_SC_BK0D_03_L      _PK_L_(0x0D, 0x03)
#define REG_SC_BK0D_03_H      _PK_H_(0x0D, 0x03)
#define REG_SC_BK0D_04_L      _PK_L_(0x0D, 0x04)
#define REG_SC_BK0D_04_H      _PK_H_(0x0D, 0x04)
#define REG_SC_BK0D_05_L      _PK_L_(0x0D, 0x05)
#define REG_SC_BK0D_05_H      _PK_H_(0x0D, 0x05)
#define REG_SC_BK0D_06_L      _PK_L_(0x0D, 0x06)
#define REG_SC_BK0D_06_H      _PK_H_(0x0D, 0x06)
#define REG_SC_BK0D_07_L      _PK_L_(0x0D, 0x07)
#define REG_SC_BK0D_07_H      _PK_H_(0x0D, 0x07)
#define REG_SC_BK0D_08_L      _PK_L_(0x0D, 0x08)
#define REG_SC_BK0D_08_H      _PK_H_(0x0D, 0x08)
#define REG_SC_BK0D_09_L      _PK_L_(0x0D, 0x09)
#define REG_SC_BK0D_09_H      _PK_H_(0x0D, 0x09)
#define REG_SC_BK0D_0A_L      _PK_L_(0x0D, 0x0A)
#define REG_SC_BK0D_0A_H      _PK_H_(0x0D, 0x0A)
#define REG_SC_BK0D_0B_L      _PK_L_(0x0D, 0x0B)
#define REG_SC_BK0D_0B_H      _PK_H_(0x0D, 0x0B)
#define REG_SC_BK0D_0C_L      _PK_L_(0x0D, 0x0C)
#define REG_SC_BK0D_0C_H      _PK_H_(0x0D, 0x0C)
#define REG_SC_BK0D_0D_L      _PK_L_(0x0D, 0x0D)
#define REG_SC_BK0D_0D_H      _PK_H_(0x0D, 0x0D)
#define REG_SC_BK0D_0E_L      _PK_L_(0x0D, 0x0E)
#define REG_SC_BK0D_0E_H      _PK_H_(0x0D, 0x0E)
#define REG_SC_BK0D_0F_L      _PK_L_(0x0D, 0x0F)
#define REG_SC_BK0D_0F_H      _PK_H_(0x0D, 0x0F)
#define REG_SC_BK0D_10_L      _PK_L_(0x0D, 0x10)
#define REG_SC_BK0D_10_H      _PK_H_(0x0D, 0x10)
#define REG_SC_BK0D_11_L      _PK_L_(0x0D, 0x11)
#define REG_SC_BK0D_11_H      _PK_H_(0x0D, 0x11)
#define REG_SC_BK0D_12_L      _PK_L_(0x0D, 0x12)
#define REG_SC_BK0D_12_H      _PK_H_(0x0D, 0x12)
#define REG_SC_BK0D_13_L      _PK_L_(0x0D, 0x13)
#define REG_SC_BK0D_13_H      _PK_H_(0x0D, 0x13)
#define REG_SC_BK0D_14_L      _PK_L_(0x0D, 0x14)
#define REG_SC_BK0D_14_H      _PK_H_(0x0D, 0x14)
#define REG_SC_BK0D_15_L      _PK_L_(0x0D, 0x15)
#define REG_SC_BK0D_15_H      _PK_H_(0x0D, 0x15)
#define REG_SC_BK0D_16_L      _PK_L_(0x0D, 0x16)
#define REG_SC_BK0D_16_H      _PK_H_(0x0D, 0x16)
#define REG_SC_BK0D_17_L      _PK_L_(0x0D, 0x17)
#define REG_SC_BK0D_17_H      _PK_H_(0x0D, 0x17)
#define REG_SC_BK0D_18_L      _PK_L_(0x0D, 0x18)
#define REG_SC_BK0D_18_H      _PK_H_(0x0D, 0x18)
#define REG_SC_BK0D_19_L      _PK_L_(0x0D, 0x19)
#define REG_SC_BK0D_19_H      _PK_H_(0x0D, 0x19)
#define REG_SC_BK0D_1A_L      _PK_L_(0x0D, 0x1A)
#define REG_SC_BK0D_1A_H      _PK_H_(0x0D, 0x1A)
#define REG_SC_BK0D_1B_L      _PK_L_(0x0D, 0x1B)
#define REG_SC_BK0D_1B_H      _PK_H_(0x0D, 0x1B)
#define REG_SC_BK0D_1C_L      _PK_L_(0x0D 0x1C)
#define REG_SC_BK0D_1C_H      _PK_H_(0x0D, 0x1C)
#define REG_SC_BK0D_1D_L      _PK_L_(0x0D, 0x1D)
#define REG_SC_BK0D_1D_H      _PK_H_(0x0D, 0x1D)
#define REG_SC_BK0D_1E_L      _PK_L_(0x0D, 0x1E)
#define REG_SC_BK0D_1E_H      _PK_H_(0x0D, 0x1E)
#define REG_SC_BK0D_1F_L      _PK_L_(0x0D, 0x1F)
#define REG_SC_BK0D_1F_H      _PK_H_(0x0D, 0x1F)
#define REG_SC_BK0D_20_L      _PK_L_(0x0D, 0x20)
#define REG_SC_BK0D_20_H      _PK_H_(0x0D, 0x20)
#define REG_SC_BK0D_21_L      _PK_L_(0x0D, 0x21)
#define REG_SC_BK0D_21_H      _PK_H_(0x0D, 0x21)
#define REG_SC_BK0D_22_L      _PK_L_(0x0D, 0x22)
#define REG_SC_BK0D_22_H      _PK_H_(0x0D, 0x22)
#define REG_SC_BK0D_23_L      _PK_L_(0x0D, 0x23)
#define REG_SC_BK0D_23_H      _PK_H_(0x0D, 0x23)
#define REG_SC_BK0D_24_L      _PK_L_(0x0D, 0x24)
#define REG_SC_BK0D_24_H      _PK_H_(0x0D, 0x24)
#define REG_SC_BK0D_25_L      _PK_L_(0x0D, 0x25)
#define REG_SC_BK0D_25_H      _PK_H_(0x0D, 0x25)
#define REG_SC_BK0D_26_L      _PK_L_(0x0D, 0x26)
#define REG_SC_BK0D_26_H      _PK_H_(0x0D, 0x26)
#define REG_SC_BK0D_27_L      _PK_L_(0x0D, 0x27)
#define REG_SC_BK0D_27_H      _PK_H_(0x0D, 0x27)
#define REG_SC_BK0D_28_L      _PK_L_(0x0D, 0x28)
#define REG_SC_BK0D_28_H      _PK_H_(0x0D, 0x28)
#define REG_SC_BK0D_29_L      _PK_L_(0x0D, 0x29)
#define REG_SC_BK0D_29_H      _PK_H_(0x0D, 0x29)
#define REG_SC_BK0D_2A_L      _PK_L_(0x0D, 0x2A)
#define REG_SC_BK0D_2A_H      _PK_H_(0x0D, 0x2A)
#define REG_SC_BK0D_2B_L      _PK_L_(0x0D, 0x2B)
#define REG_SC_BK0D_2B_H      _PK_H_(0x0D, 0x2B)
#define REG_SC_BK0D_2C_L      _PK_L_(0x0D, 0x2C)
#define REG_SC_BK0D_2C_H      _PK_H_(0x0D, 0x2C)
#define REG_SC_BK0D_2D_L      _PK_L_(0x0D, 0x2D)
#define REG_SC_BK0D_2D_H      _PK_H_(0x0D, 0x2D)
#define REG_SC_BK0D_2E_L      _PK_L_(0x0D, 0x2E)
#define REG_SC_BK0D_2E_H      _PK_H_(0x0D, 0x2E)
#define REG_SC_BK0D_2F_L      _PK_L_(0x0D, 0x2F)
#define REG_SC_BK0D_2F_H      _PK_H_(0x0D, 0x2F)
#define REG_SC_BK0D_30_L      _PK_L_(0x0D, 0x30)
#define REG_SC_BK0D_30_H      _PK_H_(0x0D, 0x30)
#define REG_SC_BK0D_31_L      _PK_L_(0x0D, 0x31)
#define REG_SC_BK0D_31_H      _PK_H_(0x0D, 0x31)
#define REG_SC_BK0D_32_L      _PK_L_(0x0D, 0x32)
#define REG_SC_BK0D_32_H      _PK_H_(0x0D, 0x32)
#define REG_SC_BK0D_33_L      _PK_L_(0x0D, 0x33)
#define REG_SC_BK0D_33_H      _PK_H_(0x0D, 0x33)
#define REG_SC_BK0D_34_L      _PK_L_(0x0D, 0x34)
#define REG_SC_BK0D_34_H      _PK_H_(0x0D, 0x34)
#define REG_SC_BK0D_35_L      _PK_L_(0x0D, 0x35)
#define REG_SC_BK0D_35_H      _PK_H_(0x0D, 0x35)
#define REG_SC_BK0D_36_L      _PK_L_(0x0D, 0x36)
#define REG_SC_BK0D_36_H      _PK_H_(0x0D, 0x36)
#define REG_SC_BK0D_37_L      _PK_L_(0x0D, 0x37)
#define REG_SC_BK0D_37_H      _PK_H_(0x0D, 0x37)
#define REG_SC_BK0D_38_L      _PK_L_(0x0D, 0x38)
#define REG_SC_BK0D_38_H      _PK_H_(0x0D, 0x38)
#define REG_SC_BK0D_39_L      _PK_L_(0x0D, 0x39)
#define REG_SC_BK0D_39_H      _PK_H_(0x0D, 0x39)
#define REG_SC_BK0D_3A_L      _PK_L_(0x0D, 0x3A)
#define REG_SC_BK0D_3A_H      _PK_H_(0x0D, 0x3A)
#define REG_SC_BK0D_3B_L      _PK_L_(0x0D, 0x3B)
#define REG_SC_BK0D_3B_H      _PK_H_(0x0D, 0x3B)
#define REG_SC_BK0D_3C_L      _PK_L_(0x0D, 0x3C)
#define REG_SC_BK0D_3C_H      _PK_H_(0x0D, 0x3C)
#define REG_SC_BK0D_3D_L      _PK_L_(0x0D, 0x3D)
#define REG_SC_BK0D_3D_H      _PK_H_(0x0D, 0x3D)
#define REG_SC_BK0D_3E_L      _PK_L_(0x0D, 0x3E)
#define REG_SC_BK0D_3E_H      _PK_H_(0x0D, 0x3E)
#define REG_SC_BK0D_3F_L      _PK_L_(0x0D, 0x3F)
#define REG_SC_BK0D_3F_H      _PK_H_(0x0D, 0x3F)
#define REG_SC_BK0D_40_L      _PK_L_(0x0D, 0x40)
#define REG_SC_BK0D_40_H      _PK_H_(0x0D, 0x40)
#define REG_SC_BK0D_41_L      _PK_L_(0x0D, 0x41)
#define REG_SC_BK0D_41_H      _PK_H_(0x0D, 0x41)
#define REG_SC_BK0D_42_L      _PK_L_(0x0D, 0x42)
#define REG_SC_BK0D_42_H      _PK_H_(0x0D, 0x42)
#define REG_SC_BK0D_43_L      _PK_L_(0x0D, 0x43)
#define REG_SC_BK0D_43_H      _PK_H_(0x0D, 0x43)
#define REG_SC_BK0D_44_L      _PK_L_(0x0D, 0x44)
#define REG_SC_BK0D_44_H      _PK_H_(0x0D, 0x44)
#define REG_SC_BK0D_45_L      _PK_L_(0x0D, 0x45)
#define REG_SC_BK0D_45_H      _PK_H_(0x0D, 0x45)
#define REG_SC_BK0D_46_L      _PK_L_(0x0D, 0x46)
#define REG_SC_BK0D_46_H      _PK_H_(0x0D, 0x46)
#define REG_SC_BK0D_47_L      _PK_L_(0x0D, 0x47)
#define REG_SC_BK0D_47_H      _PK_H_(0x0D, 0x47)
#define REG_SC_BK0D_48_L      _PK_L_(0x0D, 0x48)
#define REG_SC_BK0D_48_H      _PK_H_(0x0D, 0x48)
#define REG_SC_BK0D_49_L      _PK_L_(0x0D, 0x49)
#define REG_SC_BK0D_49_H      _PK_H_(0x0D, 0x49)
#define REG_SC_BK0D_4A_L      _PK_L_(0x0D, 0x4A)
#define REG_SC_BK0D_4A_H      _PK_H_(0x0D, 0x4A)
#define REG_SC_BK0D_4B_L      _PK_L_(0x0D, 0x4B)
#define REG_SC_BK0D_4B_H      _PK_H_(0x0D, 0x4B)
#define REG_SC_BK0D_4C_L      _PK_L_(0x0D, 0x4C)
#define REG_SC_BK0D_4C_H      _PK_H_(0x0D, 0x4C)
#define REG_SC_BK0D_4D_L      _PK_L_(0x0D, 0x4D)
#define REG_SC_BK0D_4D_H      _PK_H_(0x0D, 0x4D)
#define REG_SC_BK0D_4E_L      _PK_L_(0x0D, 0x4E)
#define REG_SC_BK0D_4E_H      _PK_H_(0x0D, 0x4E)
#define REG_SC_BK0D_4F_L      _PK_L_(0x0D, 0x4F)
#define REG_SC_BK0D_4F_H      _PK_H_(0x0D, 0x4F)
#define REG_SC_BK0D_50_L      _PK_L_(0x0D, 0x50)
#define REG_SC_BK0D_50_H      _PK_H_(0x0D, 0x50)
#define REG_SC_BK0D_51_L      _PK_L_(0x0D, 0x51)
#define REG_SC_BK0D_51_H      _PK_H_(0x0D, 0x51)
#define REG_SC_BK0D_52_L      _PK_L_(0x0D, 0x52)
#define REG_SC_BK0D_52_H      _PK_H_(0x0D, 0x52)
#define REG_SC_BK0D_53_L      _PK_L_(0x0D, 0x53)
#define REG_SC_BK0D_53_H      _PK_H_(0x0D, 0x53)
#define REG_SC_BK0D_54_L      _PK_L_(0x0D, 0x54)
#define REG_SC_BK0D_54_H      _PK_H_(0x0D, 0x54)
#define REG_SC_BK0D_55_L      _PK_L_(0x0D, 0x55)
#define REG_SC_BK0D_55_H      _PK_H_(0x0D, 0x55)
#define REG_SC_BK0D_56_L      _PK_L_(0x0D, 0x56)
#define REG_SC_BK0D_56_H      _PK_H_(0x0D, 0x56)
#define REG_SC_BK0D_57_L      _PK_L_(0x0D, 0x57)
#define REG_SC_BK0D_57_H      _PK_H_(0x0D, 0x57)
#define REG_SC_BK0D_58_L      _PK_L_(0x0D, 0x58)
#define REG_SC_BK0D_58_H      _PK_H_(0x0D, 0x58)
#define REG_SC_BK0D_59_L      _PK_L_(0x0D, 0x59)
#define REG_SC_BK0D_59_H      _PK_H_(0x0D, 0x59)
#define REG_SC_BK0D_5A_L      _PK_L_(0x0D, 0x5A)
#define REG_SC_BK0D_5A_H      _PK_H_(0x0D, 0x5A)
#define REG_SC_BK0D_5B_L      _PK_L_(0x0D, 0x5B)
#define REG_SC_BK0D_5B_H      _PK_H_(0x0D, 0x5B)
#define REG_SC_BK0D_5C_L      _PK_L_(0x0D, 0x5C)
#define REG_SC_BK0D_5C_H      _PK_H_(0x0D, 0x5C)
#define REG_SC_BK0D_5D_L      _PK_L_(0x0D, 0x5D)
#define REG_SC_BK0D_5D_H      _PK_H_(0x0D, 0x5D)
#define REG_SC_BK0D_5E_L      _PK_L_(0x0D, 0x5E)
#define REG_SC_BK0D_5E_H      _PK_H_(0x0D, 0x5E)
#define REG_SC_BK0D_5F_L      _PK_L_(0x0D, 0x5F)
#define REG_SC_BK0D_5F_H      _PK_H_(0x0D, 0x5F)
#define REG_SC_BK0D_60_L      _PK_L_(0x0D, 0x60)
#define REG_SC_BK0D_60_H      _PK_H_(0x0D, 0x60)
#define REG_SC_BK0D_61_L      _PK_L_(0x0D, 0x61)
#define REG_SC_BK0D_61_H      _PK_H_(0x0D, 0x61)
#define REG_SC_BK0D_62_L      _PK_L_(0x0D, 0x62)
#define REG_SC_BK0D_62_H      _PK_H_(0x0D, 0x62)
#define REG_SC_BK0D_63_L      _PK_L_(0x0D, 0x63)
#define REG_SC_BK0D_63_H      _PK_H_(0x0D, 0x63)
#define REG_SC_BK0D_64_L      _PK_L_(0x0D, 0x64)
#define REG_SC_BK0D_64_H      _PK_H_(0x0D, 0x64)
#define REG_SC_BK0D_65_L      _PK_L_(0x0D, 0x65)
#define REG_SC_BK0D_65_H      _PK_H_(0x0D, 0x65)
#define REG_SC_BK0D_66_L      _PK_L_(0x0D, 0x66)
#define REG_SC_BK0D_66_H      _PK_H_(0x0D, 0x66)
#define REG_SC_BK0D_67_L      _PK_L_(0x0D, 0x67)
#define REG_SC_BK0D_67_H      _PK_H_(0x0D, 0x67)
#define REG_SC_BK0D_68_L      _PK_L_(0x0D, 0x68)
#define REG_SC_BK0D_68_H      _PK_H_(0x0D, 0x68)
#define REG_SC_BK0D_69_L      _PK_L_(0x0D, 0x69)
#define REG_SC_BK0D_69_H      _PK_H_(0x0D, 0x69)
#define REG_SC_BK0D_6A_L      _PK_L_(0x0D, 0x6A)
#define REG_SC_BK0D_6A_H      _PK_H_(0x0D, 0x6A)
#define REG_SC_BK0D_6B_L      _PK_L_(0x0D, 0x6B)
#define REG_SC_BK0D_6B_H      _PK_H_(0x0D, 0x6B)
#define REG_SC_BK0D_6C_L      _PK_L_(0x0D, 0x6C)
#define REG_SC_BK0D_6C_H      _PK_H_(0x0D, 0x6C)
#define REG_SC_BK0D_6D_L      _PK_L_(0x0D, 0x6D)
#define REG_SC_BK0D_6D_H      _PK_H_(0x0D, 0x6D)
#define REG_SC_BK0D_6E_L      _PK_L_(0x0D, 0x6E)
#define REG_SC_BK0D_6E_H      _PK_H_(0x0D, 0x6E)
#define REG_SC_BK0D_6F_L      _PK_L_(0x0D, 0x6F)
#define REG_SC_BK0D_6F_H      _PK_H_(0x0D, 0x6F)
#define REG_SC_BK0D_70_L      _PK_L_(0x0D, 0x70)
#define REG_SC_BK0D_70_H      _PK_H_(0x0D, 0x70)
#define REG_SC_BK0D_71_L      _PK_L_(0x0D, 0x71)
#define REG_SC_BK0D_71_H      _PK_H_(0x0D, 0x71)
#define REG_SC_BK0D_72_L      _PK_L_(0x0D, 0x72)
#define REG_SC_BK0D_72_H      _PK_H_(0x0D, 0x72)
#define REG_SC_BK0D_73_L      _PK_L_(0x0D, 0x73)
#define REG_SC_BK0D_73_H      _PK_H_(0x0D, 0x73)
#define REG_SC_BK0D_74_L      _PK_L_(0x0D, 0x74)
#define REG_SC_BK0D_74_H      _PK_H_(0x0D, 0x74)
#define REG_SC_BK0D_75_L      _PK_L_(0x0D, 0x75)
#define REG_SC_BK0D_75_H      _PK_H_(0x0D, 0x75)
#define REG_SC_BK0D_76_L      _PK_L_(0x0D, 0x76)
#define REG_SC_BK0D_76_H      _PK_H_(0x0D, 0x76)
#define REG_SC_BK0D_77_L      _PK_L_(0x0D, 0x77)
#define REG_SC_BK0D_77_H      _PK_H_(0x0D, 0x77)
#define REG_SC_BK0D_78_L      _PK_L_(0x0D, 0x78)
#define REG_SC_BK0D_78_H      _PK_H_(0x0D, 0x78)
#define REG_SC_BK0D_79_L      _PK_L_(0x0D, 0x79)
#define REG_SC_BK0D_79_H      _PK_H_(0x0D, 0x79)
#define REG_SC_BK0D_7A_L      _PK_L_(0x0D, 0x7A)
#define REG_SC_BK0D_7A_H      _PK_H_(0x0D, 0x7A)
#define REG_SC_BK0D_7B_L      _PK_L_(0x0D, 0x7B)
#define REG_SC_BK0D_7B_H      _PK_H_(0x0D, 0x7B)
#define REG_SC_BK0D_7C_L      _PK_L_(0x0D, 0x7C)
#define REG_SC_BK0D_7C_H      _PK_H_(0x0D, 0x7C)
#define REG_SC_BK0D_7D_L      _PK_L_(0x0D, 0x7D)
#define REG_SC_BK0D_7D_H      _PK_H_(0x0D, 0x7D)
#define REG_SC_BK0D_7E_L      _PK_L_(0x0D, 0x7E)
#define REG_SC_BK0D_7E_H      _PK_H_(0x0D, 0x7E)
#define REG_SC_BK0D_7F_L      _PK_L_(0x0D, 0x7F)
#define REG_SC_BK0D_7F_H      _PK_H_(0x0D, 0x7F)

//----------------------------------------------
//  BK0F: SVOP
//----------------------------------------------
#define REG_SC_BK0F_00_L      _PK_L_(0x0F, 0x00)
#define REG_SC_BK0F_00_H      _PK_H_(0x0F, 0x00)
#define REG_SC_BK0F_01_L      _PK_L_(0x0F, 0x01)
#define REG_SC_BK0F_01_H      _PK_H_(0x0F, 0x01)
#define REG_SC_BK0F_02_L      _PK_L_(0x0F, 0x02)
#define REG_SC_BK0F_02_H      _PK_H_(0x0F, 0x02)
#define REG_SC_BK0F_03_L      _PK_L_(0x0F, 0x03)
#define REG_SC_BK0F_03_H      _PK_H_(0x0F, 0x03)
#define REG_SC_BK0F_04_L      _PK_L_(0x0F, 0x04)
#define REG_SC_BK0F_04_H      _PK_H_(0x0F, 0x04)
#define REG_SC_BK0F_05_L      _PK_L_(0x0F, 0x05)
#define REG_SC_BK0F_05_H      _PK_H_(0x0F, 0x05)
#define REG_SC_BK0F_06_L      _PK_L_(0x0F, 0x06)
#define REG_SC_BK0F_06_H      _PK_H_(0x0F, 0x06)
#define REG_SC_BK0F_07_L      _PK_L_(0x0F, 0x07)
#define REG_SC_BK0F_07_H      _PK_H_(0x0F, 0x07)
#define REG_SC_BK0F_08_L      _PK_L_(0x0F, 0x08)
#define REG_SC_BK0F_08_H      _PK_H_(0x0F, 0x08)
#define REG_SC_BK0F_09_L      _PK_L_(0x0F, 0x09)
#define REG_SC_BK0F_09_H      _PK_H_(0x0F, 0x09)
#define REG_SC_BK0F_0A_L      _PK_L_(0x0F, 0x0A)
#define REG_SC_BK0F_0A_H      _PK_H_(0x0F, 0x0A)
#define REG_SC_BK0F_0B_L      _PK_L_(0x0F, 0x0B)
#define REG_SC_BK0F_0B_H      _PK_H_(0x0F, 0x0B)
#define REG_SC_BK0F_0C_L      _PK_L_(0x0F, 0x0C)
#define REG_SC_BK0F_0C_H      _PK_H_(0x0F, 0x0C)
#define REG_SC_BK0F_0D_L      _PK_L_(0x0F, 0x0D)
#define REG_SC_BK0F_0D_H      _PK_H_(0x0F, 0x0D)
#define REG_SC_BK0F_0E_L      _PK_L_(0x0F, 0x0E)
#define REG_SC_BK0F_0E_H      _PK_H_(0x0F, 0x0E)
#define REG_SC_BK0F_0F_L      _PK_L_(0x0F, 0x0F)
#define REG_SC_BK0F_0F_H      _PK_H_(0x0F, 0x0F)
#define REG_SC_BK0F_10_L      _PK_L_(0x0F, 0x10)
#define REG_SC_BK0F_10_H      _PK_H_(0x0F, 0x10)
#define REG_SC_BK0F_11_L      _PK_L_(0x0F, 0x11)
#define REG_SC_BK0F_11_H      _PK_H_(0x0F, 0x11)
#define REG_SC_BK0F_12_L      _PK_L_(0x0F, 0x12)
#define REG_SC_BK0F_12_H      _PK_H_(0x0F, 0x12)
#define REG_SC_BK0F_13_L      _PK_L_(0x0F, 0x13)
#define REG_SC_BK0F_13_H      _PK_H_(0x0F, 0x13)
#define REG_SC_BK0F_14_L      _PK_L_(0x0F, 0x14)
#define REG_SC_BK0F_14_H      _PK_H_(0x0F, 0x14)
#define REG_SC_BK0F_15_L      _PK_L_(0x0F, 0x15)
#define REG_SC_BK0F_15_H      _PK_H_(0x0F, 0x15)
#define REG_SC_BK0F_16_L      _PK_L_(0x0F, 0x16)
#define REG_SC_BK0F_16_H      _PK_H_(0x0F, 0x16)
#define REG_SC_BK0F_17_L      _PK_L_(0x0F, 0x17)
#define REG_SC_BK0F_17_H      _PK_H_(0x0F, 0x17)
#define REG_SC_BK0F_18_L      _PK_L_(0x0F, 0x18)
#define REG_SC_BK0F_18_H      _PK_H_(0x0F, 0x18)
#define REG_SC_BK0F_19_L      _PK_L_(0x0F, 0x19)
#define REG_SC_BK0F_19_H      _PK_H_(0x0F, 0x19)
#define REG_SC_BK0F_1A_L      _PK_L_(0x0F, 0x1A)
#define REG_SC_BK0F_1A_H      _PK_H_(0x0F, 0x1A)
#define REG_SC_BK0F_1B_L      _PK_L_(0x0F, 0x1B)
#define REG_SC_BK0F_1B_H      _PK_H_(0x0F, 0x1B)
#define REG_SC_BK0F_1C_L      _PK_L_(0x0F, 0x1C)
#define REG_SC_BK0F_1C_H      _PK_H_(0x0F, 0x1C)
#define REG_SC_BK0F_1D_L      _PK_L_(0x0F, 0x1D)
#define REG_SC_BK0F_1D_H      _PK_H_(0x0F, 0x1D)
#define REG_SC_BK0F_1E_L      _PK_L_(0x0F, 0x1E)
#define REG_SC_BK0F_1E_H      _PK_H_(0x0F, 0x1E)
#define REG_SC_BK0F_1F_L      _PK_L_(0x0F, 0x1F)
#define REG_SC_BK0F_1F_H      _PK_H_(0x0F, 0x1F)
#define REG_SC_BK0F_20_L      _PK_L_(0x0F, 0x20)
#define REG_SC_BK0F_20_H      _PK_H_(0x0F, 0x20)
#define REG_SC_BK0F_21_L      _PK_L_(0x0F, 0x21)
#define REG_SC_BK0F_21_H      _PK_H_(0x0F, 0x21)
#define REG_SC_BK0F_22_L      _PK_L_(0x0F, 0x22)
#define REG_SC_BK0F_22_H      _PK_H_(0x0F, 0x22)
#define REG_SC_BK0F_23_L      _PK_L_(0x0F, 0x23)
#define REG_SC_BK0F_23_H      _PK_H_(0x0F, 0x23)
#define REG_SC_BK0F_24_L      _PK_L_(0x0F, 0x24)
#define REG_SC_BK0F_24_H      _PK_H_(0x0F, 0x24)
#define REG_SC_BK0F_25_L      _PK_L_(0x0F, 0x25)
#define REG_SC_BK0F_25_H      _PK_H_(0x0F, 0x25)
#define REG_SC_BK0F_26_L      _PK_L_(0x0F, 0x26)
#define REG_SC_BK0F_26_H      _PK_H_(0x0F, 0x26)
#define REG_SC_BK0F_27_L      _PK_L_(0x0F, 0x27)
#define REG_SC_BK0F_27_H      _PK_H_(0x0F, 0x27)
#define REG_SC_BK0F_28_L      _PK_L_(0x0F, 0x28)
#define REG_SC_BK0F_28_H      _PK_H_(0x0F, 0x28)
#define REG_SC_BK0F_29_L      _PK_L_(0x0F, 0x29)
#define REG_SC_BK0F_29_H      _PK_H_(0x0F, 0x29)
#define REG_SC_BK0F_2A_L      _PK_L_(0x0F, 0x2A)
#define REG_SC_BK0F_2A_H      _PK_H_(0x0F, 0x2A)
#define REG_SC_BK0F_2B_L      _PK_L_(0x0F, 0x2B)
#define REG_SC_BK0F_2B_H      _PK_H_(0x0F, 0x2B)
#define REG_SC_BK0F_2C_L      _PK_L_(0x0F, 0x2C)
#define REG_SC_BK0F_2C_H      _PK_H_(0x0F, 0x2C)
#define REG_SC_BK0F_2D_L      _PK_L_(0x0F, 0x2D)
#define REG_SC_BK0F_2D_H      _PK_H_(0x0F, 0x2D)
#define REG_SC_BK0F_2E_L      _PK_L_(0x0F, 0x2E)
#define REG_SC_BK0F_2E_H      _PK_H_(0x0F, 0x2E)
#define REG_SC_BK0F_2F_L      _PK_L_(0x0F, 0x2F)
#define REG_SC_BK0F_2F_H      _PK_H_(0x0F, 0x2F)
#define REG_SC_BK0F_30_L      _PK_L_(0x0F, 0x30)
#define REG_SC_BK0F_30_H      _PK_H_(0x0F, 0x30)
#define REG_SC_BK0F_31_L      _PK_L_(0x0F, 0x31)
#define REG_SC_BK0F_31_H      _PK_H_(0x0F, 0x31)
#define REG_SC_BK0F_32_L      _PK_L_(0x0F, 0x32)
#define REG_SC_BK0F_32_H      _PK_H_(0x0F, 0x32)
#define REG_SC_BK0F_33_L      _PK_L_(0x0F, 0x33)
#define REG_SC_BK0F_33_H      _PK_H_(0x0F, 0x33)
#define REG_SC_BK0F_34_L      _PK_L_(0x0F, 0x34)
#define REG_SC_BK0F_34_H      _PK_H_(0x0F, 0x34)
#define REG_SC_BK0F_35_L      _PK_L_(0x0F, 0x35)
#define REG_SC_BK0F_35_H      _PK_H_(0x0F, 0x35)
#define REG_SC_BK0F_36_L      _PK_L_(0x0F, 0x36)
#define REG_SC_BK0F_36_H      _PK_H_(0x0F, 0x36)
#define REG_SC_BK0F_37_L      _PK_L_(0x0F, 0x37)
#define REG_SC_BK0F_37_H      _PK_H_(0x0F, 0x37)
#define REG_SC_BK0F_38_L      _PK_L_(0x0F, 0x38)
#define REG_SC_BK0F_38_H      _PK_H_(0x0F, 0x38)
#define REG_SC_BK0F_39_L      _PK_L_(0x0F, 0x39)
#define REG_SC_BK0F_39_H      _PK_H_(0x0F, 0x39)
#define REG_SC_BK0F_3A_L      _PK_L_(0x0F, 0x3A)
#define REG_SC_BK0F_3A_H      _PK_H_(0x0F, 0x3A)
#define REG_SC_BK0F_3B_L      _PK_L_(0x0F, 0x3B)
#define REG_SC_BK0F_3B_H      _PK_H_(0x0F, 0x3B)
#define REG_SC_BK0F_3C_L      _PK_L_(0x0F, 0x3C)
#define REG_SC_BK0F_3C_H      _PK_H_(0x0F, 0x3C)
#define REG_SC_BK0F_3D_L      _PK_L_(0x0F, 0x3D)
#define REG_SC_BK0F_3D_H      _PK_H_(0x0F, 0x3D)
#define REG_SC_BK0F_3E_L      _PK_L_(0x0F, 0x3E)
#define REG_SC_BK0F_3E_H      _PK_H_(0x0F, 0x3E)
#define REG_SC_BK0F_3F_L      _PK_L_(0x0F, 0x3F)
#define REG_SC_BK0F_3F_H      _PK_H_(0x0F, 0x3F)
#define REG_SC_BK0F_40_L      _PK_L_(0x0F, 0x40)
#define REG_SC_BK0F_40_H      _PK_H_(0x0F, 0x40)
#define REG_SC_BK0F_41_L      _PK_L_(0x0F, 0x41)
#define REG_SC_BK0F_41_H      _PK_H_(0x0F, 0x41)
#define REG_SC_BK0F_42_L      _PK_L_(0x0F, 0x42)
#define REG_SC_BK0F_42_H      _PK_H_(0x0F, 0x42)
#define REG_SC_BK0F_43_L      _PK_L_(0x0F, 0x43)
#define REG_SC_BK0F_43_H      _PK_H_(0x0F, 0x43)
#define REG_SC_BK0F_44_L      _PK_L_(0x0F, 0x44)
#define REG_SC_BK0F_44_H      _PK_H_(0x0F, 0x44)
#define REG_SC_BK0F_45_L      _PK_L_(0x0F, 0x45)
#define REG_SC_BK0F_45_H      _PK_H_(0x0F, 0x45)
#define REG_SC_BK0F_46_L      _PK_L_(0x0F, 0x46)
#define REG_SC_BK0F_46_H      _PK_H_(0x0F, 0x46)
#define REG_SC_BK0F_47_L      _PK_L_(0x0F, 0x47)
#define REG_SC_BK0F_47_H      _PK_H_(0x0F, 0x47)
#define REG_SC_BK0F_48_L      _PK_L_(0x0F, 0x48)
#define REG_SC_BK0F_48_H      _PK_H_(0x0F, 0x48)
#define REG_SC_BK0F_49_L      _PK_L_(0x0F, 0x49)
#define REG_SC_BK0F_49_H      _PK_H_(0x0F, 0x49)
#define REG_SC_BK0F_4A_L      _PK_L_(0x0F, 0x4A)
#define REG_SC_BK0F_4A_H      _PK_H_(0x0F, 0x4A)
#define REG_SC_BK0F_4B_L      _PK_L_(0x0F, 0x4B)
#define REG_SC_BK0F_4B_H      _PK_H_(0x0F, 0x4B)
#define REG_SC_BK0F_4C_L      _PK_L_(0x0F, 0x4C)
#define REG_SC_BK0F_4C_H      _PK_H_(0x0F, 0x4C)
#define REG_SC_BK0F_4D_L      _PK_L_(0x0F, 0x4D)
#define REG_SC_BK0F_4D_H      _PK_H_(0x0F, 0x4D)
#define REG_SC_BK0F_4E_L      _PK_L_(0x0F, 0x4E)
#define REG_SC_BK0F_4E_H      _PK_H_(0x0F, 0x4E)
#define REG_SC_BK0F_4F_L      _PK_L_(0x0F, 0x4F)
#define REG_SC_BK0F_4F_H      _PK_H_(0x0F, 0x4F)
#define REG_SC_BK0F_50_L      _PK_L_(0x0F, 0x50)
#define REG_SC_BK0F_50_H      _PK_H_(0x0F, 0x50)
#define REG_SC_BK0F_51_L      _PK_L_(0x0F, 0x51)
#define REG_SC_BK0F_51_H      _PK_H_(0x0F, 0x51)
#define REG_SC_BK0F_52_L      _PK_L_(0x0F, 0x52)
#define REG_SC_BK0F_52_H      _PK_H_(0x0F, 0x52)
#define REG_SC_BK0F_53_L      _PK_L_(0x0F, 0x53)
#define REG_SC_BK0F_53_H      _PK_H_(0x0F, 0x53)
#define REG_SC_BK0F_54_L      _PK_L_(0x0F, 0x54)
#define REG_SC_BK0F_54_H      _PK_H_(0x0F, 0x54)
#define REG_SC_BK0F_55_L      _PK_L_(0x0F, 0x55)
#define REG_SC_BK0F_55_H      _PK_H_(0x0F, 0x55)
#define REG_SC_BK0F_56_L      _PK_L_(0x0F, 0x56)
#define REG_SC_BK0F_56_H      _PK_H_(0x0F, 0x56)
#define REG_SC_BK0F_57_L      _PK_L_(0x0F, 0x57)
#define REG_SC_BK0F_57_H      _PK_H_(0x0F, 0x57)
#define REG_SC_BK0F_58_L      _PK_L_(0x0F, 0x58)
#define REG_SC_BK0F_58_H      _PK_H_(0x0F, 0x58)
#define REG_SC_BK0F_59_L      _PK_L_(0x0F, 0x59)
#define REG_SC_BK0F_59_H      _PK_H_(0x0F, 0x59)
#define REG_SC_BK0F_5A_L      _PK_L_(0x0F, 0x5A)
#define REG_SC_BK0F_5A_H      _PK_H_(0x0F, 0x5A)
#define REG_SC_BK0F_5B_L      _PK_L_(0x0F, 0x5B)
#define REG_SC_BK0F_5B_H      _PK_H_(0x0F, 0x5B)
#define REG_SC_BK0F_5C_L      _PK_L_(0x0F, 0x5C)
#define REG_SC_BK0F_5C_H      _PK_H_(0x0F, 0x5C)
#define REG_SC_BK0F_5D_L      _PK_L_(0x0F, 0x5D)
#define REG_SC_BK0F_5D_H      _PK_H_(0x0F, 0x5D)
#define REG_SC_BK0F_5E_L      _PK_L_(0x0F, 0x5E)
#define REG_SC_BK0F_5E_H      _PK_H_(0x0F, 0x5E)
#define REG_SC_BK0F_5F_L      _PK_L_(0x0F, 0x5F)
#define REG_SC_BK0F_5F_H      _PK_H_(0x0F, 0x5F)
#define REG_SC_BK0F_60_L      _PK_L_(0x0F, 0x60)
#define REG_SC_BK0F_60_H      _PK_H_(0x0F, 0x60)
#define REG_SC_BK0F_61_L      _PK_L_(0x0F, 0x61)
#define REG_SC_BK0F_61_H      _PK_H_(0x0F, 0x61)
#define REG_SC_BK0F_62_L      _PK_L_(0x0F, 0x62)
#define REG_SC_BK0F_62_H      _PK_H_(0x0F, 0x62)
#define REG_SC_BK0F_63_L      _PK_L_(0x0F, 0x63)
#define REG_SC_BK0F_63_H      _PK_H_(0x0F, 0x63)
#define REG_SC_BK0F_64_L      _PK_L_(0x0F, 0x64)
#define REG_SC_BK0F_64_H      _PK_H_(0x0F, 0x64)
#define REG_SC_BK0F_65_L      _PK_L_(0x0F, 0x65)
#define REG_SC_BK0F_65_H      _PK_H_(0x0F, 0x65)
#define REG_SC_BK0F_66_L      _PK_L_(0x0F, 0x66)
#define REG_SC_BK0F_66_H      _PK_H_(0x0F, 0x66)
#define REG_SC_BK0F_67_L      _PK_L_(0x0F, 0x67)
#define REG_SC_BK0F_67_H      _PK_H_(0x0F, 0x67)
#define REG_SC_BK0F_68_L      _PK_L_(0x0F, 0x68)
#define REG_SC_BK0F_68_H      _PK_H_(0x0F, 0x68)
#define REG_SC_BK0F_69_L      _PK_L_(0x0F, 0x69)
#define REG_SC_BK0F_69_H      _PK_H_(0x0F, 0x69)
#define REG_SC_BK0F_6A_L      _PK_L_(0x0F, 0x6A)
#define REG_SC_BK0F_6A_H      _PK_H_(0x0F, 0x6A)
#define REG_SC_BK0F_6B_L      _PK_L_(0x0F, 0x6B)
#define REG_SC_BK0F_6B_H      _PK_H_(0x0F, 0x6B)
#define REG_SC_BK0F_6C_L      _PK_L_(0x0F, 0x6C)
#define REG_SC_BK0F_6C_H      _PK_H_(0x0F, 0x6C)
#define REG_SC_BK0F_6D_L      _PK_L_(0x0F, 0x6D)
#define REG_SC_BK0F_6D_H      _PK_H_(0x0F, 0x6D)
#define REG_SC_BK0F_6E_L      _PK_L_(0x0F, 0x6E)
#define REG_SC_BK0F_6E_H      _PK_H_(0x0F, 0x6E)
#define REG_SC_BK0F_6F_L      _PK_L_(0x0F, 0x6F)
#define REG_SC_BK0F_6F_H      _PK_H_(0x0F, 0x6F)
#define REG_SC_BK0F_70_L      _PK_L_(0x0F, 0x70)
#define REG_SC_BK0F_70_H      _PK_H_(0x0F, 0x70)
#define REG_SC_BK0F_71_L      _PK_L_(0x0F, 0x71)
#define REG_SC_BK0F_71_H      _PK_H_(0x0F, 0x71)
#define REG_SC_BK0F_72_L      _PK_L_(0x0F, 0x72)
#define REG_SC_BK0F_72_H      _PK_H_(0x0F, 0x72)
#define REG_SC_BK0F_73_L      _PK_L_(0x0F, 0x73)
#define REG_SC_BK0F_73_H      _PK_H_(0x0F, 0x73)
#define REG_SC_BK0F_74_L      _PK_L_(0x0F, 0x74)
#define REG_SC_BK0F_74_H      _PK_H_(0x0F, 0x74)
#define REG_SC_BK0F_75_L      _PK_L_(0x0F, 0x75)
#define REG_SC_BK0F_75_H      _PK_H_(0x0F, 0x75)
#define REG_SC_BK0F_76_L      _PK_L_(0x0F, 0x76)
#define REG_SC_BK0F_76_H      _PK_H_(0x0F, 0x76)
#define REG_SC_BK0F_77_L      _PK_L_(0x0F, 0x77)
#define REG_SC_BK0F_77_H      _PK_H_(0x0F, 0x77)
#define REG_SC_BK0F_78_L      _PK_L_(0x0F, 0x78)
#define REG_SC_BK0F_78_H      _PK_H_(0x0F, 0x78)
#define REG_SC_BK0F_79_L      _PK_L_(0x0F, 0x79)
#define REG_SC_BK0F_79_H      _PK_H_(0x0F, 0x79)
#define REG_SC_BK0F_7A_L      _PK_L_(0x0F, 0x7A)
#define REG_SC_BK0F_7A_H      _PK_H_(0x0F, 0x7A)
#define REG_SC_BK0F_7B_L      _PK_L_(0x0F, 0x7B)
#define REG_SC_BK0F_7B_H      _PK_H_(0x0F, 0x7B)
#define REG_SC_BK0F_7C_L      _PK_L_(0x0F, 0x7C)
#define REG_SC_BK0F_7C_H      _PK_H_(0x0F, 0x7C)
#define REG_SC_BK0F_7D_L      _PK_L_(0x0F, 0x7D)
#define REG_SC_BK0F_7D_H      _PK_H_(0x0F, 0x7D)
#define REG_SC_BK0F_7E_L      _PK_L_(0x0F, 0x7E)
#define REG_SC_BK0F_7E_H      _PK_H_(0x0F, 0x7E)
#define REG_SC_BK0F_7F_L      _PK_L_(0x0F, 0x7F)
#define REG_SC_BK0F_7F_H      _PK_H_(0x0F, 0x7F)

//----------------------------------------------
//  BK10: VOP
//----------------------------------------------
#define REG_SC_BK10_00_L      _PK_L_(0x10, 0x00)
#define REG_SC_BK10_00_H      _PK_H_(0x10, 0x00)
#define REG_SC_BK10_01_L      _PK_L_(0x10, 0x01)
#define REG_SC_BK10_01_H      _PK_H_(0x10, 0x01)
#define REG_SC_BK10_02_L      _PK_L_(0x10, 0x02)
#define REG_SC_BK10_02_H      _PK_H_(0x10, 0x02)
#define REG_SC_BK10_03_L      _PK_L_(0x10, 0x03)
#define REG_SC_BK10_03_H      _PK_H_(0x10, 0x03)
#define REG_SC_BK10_04_L      _PK_L_(0x10, 0x04)
#define REG_SC_BK10_04_H      _PK_H_(0x10, 0x04)
#define REG_SC_BK10_05_L      _PK_L_(0x10, 0x05)
#define REG_SC_BK10_05_H      _PK_H_(0x10, 0x05)
#define REG_SC_BK10_06_L      _PK_L_(0x10, 0x06)
#define REG_SC_BK10_06_H      _PK_H_(0x10, 0x06)
#define REG_SC_BK10_07_L      _PK_L_(0x10, 0x07)
#define REG_SC_BK10_07_H      _PK_H_(0x10, 0x07)
#define REG_SC_BK10_08_L      _PK_L_(0x10, 0x08)
#define REG_SC_BK10_08_H      _PK_H_(0x10, 0x08)
#define REG_SC_BK10_09_L      _PK_L_(0x10, 0x09)
#define REG_SC_BK10_09_H      _PK_H_(0x10, 0x09)
#define REG_SC_BK10_0A_L      _PK_L_(0x10, 0x0A)
#define REG_SC_BK10_0A_H      _PK_H_(0x10, 0x0A)
#define REG_SC_BK10_0B_L      _PK_L_(0x10, 0x0B)
#define REG_SC_BK10_0B_H      _PK_H_(0x10, 0x0B)
#define REG_SC_BK10_0C_L      _PK_L_(0x10, 0x0C)
#define REG_SC_BK10_0C_H      _PK_H_(0x10, 0x0C)
#define REG_SC_BK10_0D_L      _PK_L_(0x10, 0x0D)
#define REG_SC_BK10_0D_H      _PK_H_(0x10, 0x0D)
#define REG_SC_BK10_0E_L      _PK_L_(0x10, 0x0E)
#define REG_SC_BK10_0E_H      _PK_H_(0x10, 0x0E)
#define REG_SC_BK10_0F_L      _PK_L_(0x10, 0x0F)
#define REG_SC_BK10_0F_H      _PK_H_(0x10, 0x0F)
#define REG_SC_BK10_10_L      _PK_L_(0x10, 0x10)
#define REG_SC_BK10_10_H      _PK_H_(0x10, 0x10)
#define REG_SC_BK10_11_L      _PK_L_(0x10, 0x11)
#define REG_SC_BK10_11_H      _PK_H_(0x10, 0x11)
#define REG_SC_BK10_12_L      _PK_L_(0x10, 0x12)
#define REG_SC_BK10_12_H      _PK_H_(0x10, 0x12)
#define REG_SC_BK10_13_L      _PK_L_(0x10, 0x13)
#define REG_SC_BK10_13_H      _PK_H_(0x10, 0x13)
#define REG_SC_BK10_14_L      _PK_L_(0x10, 0x14)
#define REG_SC_BK10_14_H      _PK_H_(0x10, 0x14)
#define REG_SC_BK10_15_L      _PK_L_(0x10, 0x15)
#define REG_SC_BK10_15_H      _PK_H_(0x10, 0x15)
#define REG_SC_BK10_16_L      _PK_L_(0x10, 0x16)
#define REG_SC_BK10_16_H      _PK_H_(0x10, 0x16)
#define REG_SC_BK10_17_L      _PK_L_(0x10, 0x17)
#define REG_SC_BK10_17_H      _PK_H_(0x10, 0x17)
#define REG_SC_BK10_18_L      _PK_L_(0x10, 0x18)
#define REG_SC_BK10_18_H      _PK_H_(0x10, 0x18)
#define REG_SC_BK10_19_L      _PK_L_(0x10, 0x19)
#define REG_SC_BK10_19_H      _PK_H_(0x10, 0x19)
#define REG_SC_BK10_1A_L      _PK_L_(0x10, 0x1A)
#define REG_SC_BK10_1A_H      _PK_H_(0x10, 0x1A)
#define REG_SC_BK10_1B_L      _PK_L_(0x10, 0x1B)
#define REG_SC_BK10_1B_H      _PK_H_(0x10, 0x1B)
#define REG_SC_BK10_1C_L      _PK_L_(0x10, 0x1C)
#define REG_SC_BK10_1C_H      _PK_H_(0x10, 0x1C)
#define REG_SC_BK10_1D_L      _PK_L_(0x10, 0x1D)
#define REG_SC_BK10_1D_H      _PK_H_(0x10, 0x1D)
#define REG_SC_BK10_1E_L      _PK_L_(0x10, 0x1E)
#define REG_SC_BK10_1E_H      _PK_H_(0x10, 0x1E)
#define REG_SC_BK10_1F_L      _PK_L_(0x10, 0x1F)
#define REG_SC_BK10_1F_H      _PK_H_(0x10, 0x1F)
#define REG_SC_BK10_20_L      _PK_L_(0x10, 0x20)
#define REG_SC_BK10_20_H      _PK_H_(0x10, 0x20)
#define REG_SC_BK10_21_L      _PK_L_(0x10, 0x21)
#define REG_SC_BK10_21_H      _PK_H_(0x10, 0x21)
#define REG_SC_BK10_22_L      _PK_L_(0x10, 0x22)
#define REG_SC_BK10_22_H      _PK_H_(0x10, 0x22)
#define REG_SC_BK10_23_L      _PK_L_(0x10, 0x23)
#define REG_SC_BK10_23_H      _PK_H_(0x10, 0x23)
#define REG_SC_BK10_24_L      _PK_L_(0x10, 0x24)
#define REG_SC_BK10_24_H      _PK_H_(0x10, 0x24)
#define REG_SC_BK10_25_L      _PK_L_(0x10, 0x25)
#define REG_SC_BK10_25_H      _PK_H_(0x10, 0x25)
#define REG_SC_BK10_26_L      _PK_L_(0x10, 0x26)
#define REG_SC_BK10_26_H      _PK_H_(0x10, 0x26)
#define REG_SC_BK10_27_L      _PK_L_(0x10, 0x27)
#define REG_SC_BK10_27_H      _PK_H_(0x10, 0x27)
#define REG_SC_BK10_28_L      _PK_L_(0x10, 0x28)
#define REG_SC_BK10_28_H      _PK_H_(0x10, 0x28)
#define REG_SC_BK10_29_L      _PK_L_(0x10, 0x29)
#define REG_SC_BK10_29_H      _PK_H_(0x10, 0x29)
#define REG_SC_BK10_2A_L      _PK_L_(0x10, 0x2A)
#define REG_SC_BK10_2A_H      _PK_H_(0x10, 0x2A)
#define REG_SC_BK10_2B_L      _PK_L_(0x10, 0x2B)
#define REG_SC_BK10_2B_H      _PK_H_(0x10, 0x2B)
#define REG_SC_BK10_2C_L      _PK_L_(0x10, 0x2C)
#define REG_SC_BK10_2C_H      _PK_H_(0x10, 0x2C)
#define REG_SC_BK10_2D_L      _PK_L_(0x10, 0x2D)
#define REG_SC_BK10_2D_H      _PK_H_(0x10, 0x2D)
#define REG_SC_BK10_2E_L      _PK_L_(0x10, 0x2E)
#define REG_SC_BK10_2E_H      _PK_H_(0x10, 0x2E)
#define REG_SC_BK10_2F_L      _PK_L_(0x10, 0x2F)
#define REG_SC_BK10_2F_H      _PK_H_(0x10, 0x2F)
#define REG_SC_BK10_30_L      _PK_L_(0x10, 0x30)
#define REG_SC_BK10_30_H      _PK_H_(0x10, 0x30)
#define REG_SC_BK10_31_L      _PK_L_(0x10, 0x31)
#define REG_SC_BK10_31_H      _PK_H_(0x10, 0x31)
#define REG_SC_BK10_32_L      _PK_L_(0x10, 0x32)
#define REG_SC_BK10_32_H      _PK_H_(0x10, 0x32)
#define REG_SC_BK10_33_L      _PK_L_(0x10, 0x33)
#define REG_SC_BK10_33_H      _PK_H_(0x10, 0x33)
#define REG_SC_BK10_34_L      _PK_L_(0x10, 0x34)
#define REG_SC_BK10_34_H      _PK_H_(0x10, 0x34)
#define REG_SC_BK10_35_L      _PK_L_(0x10, 0x35)
#define REG_SC_BK10_35_H      _PK_H_(0x10, 0x35)
#define REG_SC_BK10_36_L      _PK_L_(0x10, 0x36)
#define REG_SC_BK10_36_H      _PK_H_(0x10, 0x36)
#define REG_SC_BK10_37_L      _PK_L_(0x10, 0x37)
#define REG_SC_BK10_37_H      _PK_H_(0x10, 0x37)
#define REG_SC_BK10_38_L      _PK_L_(0x10, 0x38)
#define REG_SC_BK10_38_H      _PK_H_(0x10, 0x38)
#define REG_SC_BK10_39_L      _PK_L_(0x10, 0x39)
#define REG_SC_BK10_39_H      _PK_H_(0x10, 0x39)
#define REG_SC_BK10_3A_L      _PK_L_(0x10, 0x3A)
#define REG_SC_BK10_3A_H      _PK_H_(0x10, 0x3A)
#define REG_SC_BK10_3B_L      _PK_L_(0x10, 0x3B)
#define REG_SC_BK10_3B_H      _PK_H_(0x10, 0x3B)
#define REG_SC_BK10_3C_L      _PK_L_(0x10, 0x3C)
#define REG_SC_BK10_3C_H      _PK_H_(0x10, 0x3C)
#define REG_SC_BK10_3D_L      _PK_L_(0x10, 0x3D)
#define REG_SC_BK10_3D_H      _PK_H_(0x10, 0x3D)
#define REG_SC_BK10_3E_L      _PK_L_(0x10, 0x3E)
#define REG_SC_BK10_3E_H      _PK_H_(0x10, 0x3E)
#define REG_SC_BK10_3F_L      _PK_L_(0x10, 0x3F)
#define REG_SC_BK10_3F_H      _PK_H_(0x10, 0x3F)
#define REG_SC_BK10_40_L      _PK_L_(0x10, 0x40)
#define REG_SC_BK10_40_H      _PK_H_(0x10, 0x40)
#define REG_SC_BK10_41_L      _PK_L_(0x10, 0x41)
#define REG_SC_BK10_41_H      _PK_H_(0x10, 0x41)
#define REG_SC_BK10_42_L      _PK_L_(0x10, 0x42)
#define REG_SC_BK10_42_H      _PK_H_(0x10, 0x42)
#define REG_SC_BK10_43_L      _PK_L_(0x10, 0x43)
#define REG_SC_BK10_43_H      _PK_H_(0x10, 0x43)
#define REG_SC_BK10_44_L      _PK_L_(0x10, 0x44)
#define REG_SC_BK10_44_H      _PK_H_(0x10, 0x44)
#define REG_SC_BK10_45_L      _PK_L_(0x10, 0x45)
#define REG_SC_BK10_45_H      _PK_H_(0x10, 0x45)
#define REG_SC_BK10_46_L      _PK_L_(0x10, 0x46)
#define REG_SC_BK10_46_H      _PK_H_(0x10, 0x46)
#define REG_SC_BK10_47_L      _PK_L_(0x10, 0x47)
#define REG_SC_BK10_47_H      _PK_H_(0x10, 0x47)
#define REG_SC_BK10_48_L      _PK_L_(0x10, 0x48)
#define REG_SC_BK10_48_H      _PK_H_(0x10, 0x48)
#define REG_SC_BK10_49_L      _PK_L_(0x10, 0x49)
#define REG_SC_BK10_49_H      _PK_H_(0x10, 0x49)
#define REG_SC_BK10_4A_L      _PK_L_(0x10, 0x4A)
#define REG_SC_BK10_4A_H      _PK_H_(0x10, 0x4A)
#define REG_SC_BK10_4B_L      _PK_L_(0x10, 0x4B)
#define REG_SC_BK10_4B_H      _PK_H_(0x10, 0x4B)
#define REG_SC_BK10_4C_L      _PK_L_(0x10, 0x4C)
#define REG_SC_BK10_4C_H      _PK_H_(0x10, 0x4C)
#define REG_SC_BK10_4D_L      _PK_L_(0x10, 0x4D)
#define REG_SC_BK10_4D_H      _PK_H_(0x10, 0x4D)
#define REG_SC_BK10_4E_L      _PK_L_(0x10, 0x4E)
#define REG_SC_BK10_4E_H      _PK_H_(0x10, 0x4E)
#define REG_SC_BK10_4F_L      _PK_L_(0x10, 0x4F)
#define REG_SC_BK10_4F_H      _PK_H_(0x10, 0x4F)
#define REG_SC_BK10_50_L      _PK_L_(0x10, 0x50)
#define REG_SC_BK10_50_H      _PK_H_(0x10, 0x50)
#define REG_SC_BK10_51_L      _PK_L_(0x10, 0x51)
#define REG_SC_BK10_51_H      _PK_H_(0x10, 0x51)
#define REG_SC_BK10_52_L      _PK_L_(0x10, 0x52)
#define REG_SC_BK10_52_H      _PK_H_(0x10, 0x52)
#define REG_SC_BK10_53_L      _PK_L_(0x10, 0x53)
#define REG_SC_BK10_53_H      _PK_H_(0x10, 0x53)
#define REG_SC_BK10_54_L      _PK_L_(0x10, 0x54)
#define REG_SC_BK10_54_H      _PK_H_(0x10, 0x54)
#define REG_SC_BK10_55_L      _PK_L_(0x10, 0x55)
#define REG_SC_BK10_55_H      _PK_H_(0x10, 0x55)
#define REG_SC_BK10_56_L      _PK_L_(0x10, 0x56)
#define REG_SC_BK10_56_H      _PK_H_(0x10, 0x56)
#define REG_SC_BK10_57_L      _PK_L_(0x10, 0x57)
#define REG_SC_BK10_57_H      _PK_H_(0x10, 0x57)
#define REG_SC_BK10_58_L      _PK_L_(0x10, 0x58)
#define REG_SC_BK10_58_H      _PK_H_(0x10, 0x58)
#define REG_SC_BK10_59_L      _PK_L_(0x10, 0x59)
#define REG_SC_BK10_59_H      _PK_H_(0x10, 0x59)
#define REG_SC_BK10_5A_L      _PK_L_(0x10, 0x5A)
#define REG_SC_BK10_5A_H      _PK_H_(0x10, 0x5A)
#define REG_SC_BK10_5B_L      _PK_L_(0x10, 0x5B)
#define REG_SC_BK10_5B_H      _PK_H_(0x10, 0x5B)
#define REG_SC_BK10_5C_L      _PK_L_(0x10, 0x5C)
#define REG_SC_BK10_5C_H      _PK_H_(0x10, 0x5C)
#define REG_SC_BK10_5D_L      _PK_L_(0x10, 0x5D)
#define REG_SC_BK10_5D_H      _PK_H_(0x10, 0x5D)
#define REG_SC_BK10_5E_L      _PK_L_(0x10, 0x5E)
#define REG_SC_BK10_5E_H      _PK_H_(0x10, 0x5E)
#define REG_SC_BK10_5F_L      _PK_L_(0x10, 0x5F)
#define REG_SC_BK10_5F_H      _PK_H_(0x10, 0x5F)
#define REG_SC_BK10_60_L      _PK_L_(0x10, 0x60)
#define REG_SC_BK10_60_H      _PK_H_(0x10, 0x60)
#define REG_SC_BK10_61_L      _PK_L_(0x10, 0x61)
#define REG_SC_BK10_61_H      _PK_H_(0x10, 0x61)
#define REG_SC_BK10_62_L      _PK_L_(0x10, 0x62)
#define REG_SC_BK10_62_H      _PK_H_(0x10, 0x62)
#define REG_SC_BK10_63_L      _PK_L_(0x10, 0x63)
#define REG_SC_BK10_63_H      _PK_H_(0x10, 0x63)
#define REG_SC_BK10_64_L      _PK_L_(0x10, 0x64)
#define REG_SC_BK10_64_H      _PK_H_(0x10, 0x64)
#define REG_SC_BK10_65_L      _PK_L_(0x10, 0x65)
#define REG_SC_BK10_65_H      _PK_H_(0x10, 0x65)
#define REG_SC_BK10_66_L      _PK_L_(0x10, 0x66)
#define REG_SC_BK10_66_H      _PK_H_(0x10, 0x66)
#define REG_SC_BK10_67_L      _PK_L_(0x10, 0x67)
#define REG_SC_BK10_67_H      _PK_H_(0x10, 0x67)
#define REG_SC_BK10_68_L      _PK_L_(0x10, 0x68)
#define REG_SC_BK10_68_H      _PK_H_(0x10, 0x68)
#define REG_SC_BK10_69_L      _PK_L_(0x10, 0x69)
#define REG_SC_BK10_69_H      _PK_H_(0x10, 0x69)
#define REG_SC_BK10_6A_L      _PK_L_(0x10, 0x6A)
#define REG_SC_BK10_6A_H      _PK_H_(0x10, 0x6A)
#define REG_SC_BK10_6B_L      _PK_L_(0x10, 0x6B)
#define REG_SC_BK10_6B_H      _PK_H_(0x10, 0x6B)
#define REG_SC_BK10_6C_L      _PK_L_(0x10, 0x6C)
#define REG_SC_BK10_6C_H      _PK_H_(0x10, 0x6C)
#define REG_SC_BK10_6D_L      _PK_L_(0x10, 0x6D)
#define REG_SC_BK10_6D_H      _PK_H_(0x10, 0x6D)
#define REG_SC_BK10_6E_L      _PK_L_(0x10, 0x6E)
#define REG_SC_BK10_6E_H      _PK_H_(0x10, 0x6E)
#define REG_SC_BK10_6F_L      _PK_L_(0x10, 0x6F)
#define REG_SC_BK10_6F_H      _PK_H_(0x10, 0x6F)
#define REG_SC_BK10_70_L      _PK_L_(0x10, 0x70)
#define REG_SC_BK10_70_H      _PK_H_(0x10, 0x70)
#define REG_SC_BK10_71_L      _PK_L_(0x10, 0x71)
#define REG_SC_BK10_71_H      _PK_H_(0x10, 0x71)
#define REG_SC_BK10_72_L      _PK_L_(0x10, 0x72)
#define REG_SC_BK10_72_H      _PK_H_(0x10, 0x72)
#define REG_SC_BK10_73_L      _PK_L_(0x10, 0x73)
#define REG_SC_BK10_73_H      _PK_H_(0x10, 0x73)
#define REG_SC_BK10_74_L      _PK_L_(0x10, 0x74)
#define REG_SC_BK10_74_H      _PK_H_(0x10, 0x74)
#define REG_SC_BK10_75_L      _PK_L_(0x10, 0x75)
#define REG_SC_BK10_75_H      _PK_H_(0x10, 0x75)
#define REG_SC_BK10_76_L      _PK_L_(0x10, 0x76)
#define REG_SC_BK10_76_H      _PK_H_(0x10, 0x76)
#define REG_SC_BK10_77_L      _PK_L_(0x10, 0x77)
#define REG_SC_BK10_77_H      _PK_H_(0x10, 0x77)
#define REG_SC_BK10_78_L      _PK_L_(0x10, 0x78)
#define REG_SC_BK10_78_H      _PK_H_(0x10, 0x78)
#define REG_SC_BK10_79_L      _PK_L_(0x10, 0x79)
#define REG_SC_BK10_79_H      _PK_H_(0x10, 0x79)
#define REG_SC_BK10_7A_L      _PK_L_(0x10, 0x7A)
#define REG_SC_BK10_7A_H      _PK_H_(0x10, 0x7A)
#define REG_SC_BK10_7B_L      _PK_L_(0x10, 0x7B)
#define REG_SC_BK10_7B_H      _PK_H_(0x10, 0x7B)
#define REG_SC_BK10_7C_L      _PK_L_(0x10, 0x7C)
#define REG_SC_BK10_7C_H      _PK_H_(0x10, 0x7C)
#define REG_SC_BK10_7D_L      _PK_L_(0x10, 0x7D)
#define REG_SC_BK10_7D_H      _PK_H_(0x10, 0x7D)
#define REG_SC_BK10_7E_L      _PK_L_(0x10, 0x7E)
#define REG_SC_BK10_7E_H      _PK_H_(0x10, 0x7E)
#define REG_SC_BK10_7F_L      _PK_L_(0x10, 0x7F)
#define REG_SC_BK10_7F_H      _PK_H_(0x10, 0x7F)

//----------------------------------------------
//  BK11: TCON
//----------------------------------------------
#define REG_SC_BK11_00_L      _PK_L_(0x11, 0x00)
#define REG_SC_BK11_00_H      _PK_H_(0x11, 0x00)
#define REG_SC_BK11_01_L      _PK_L_(0x11, 0x01)
#define REG_SC_BK11_01_H      _PK_H_(0x11, 0x01)
#define REG_SC_BK11_02_L      _PK_L_(0x11, 0x02)
#define REG_SC_BK11_02_H      _PK_H_(0x11, 0x02)
#define REG_SC_BK11_03_L      _PK_L_(0x11, 0x03)
#define REG_SC_BK11_03_H      _PK_H_(0x11, 0x03)
#define REG_SC_BK11_04_L      _PK_L_(0x11, 0x04)
#define REG_SC_BK11_04_H      _PK_H_(0x11, 0x04)
#define REG_SC_BK11_05_L      _PK_L_(0x11, 0x05)
#define REG_SC_BK11_05_H      _PK_H_(0x11, 0x05)
#define REG_SC_BK11_06_L      _PK_L_(0x11, 0x06)
#define REG_SC_BK11_06_H      _PK_H_(0x11, 0x06)
#define REG_SC_BK11_07_L      _PK_L_(0x11, 0x07)
#define REG_SC_BK11_07_H      _PK_H_(0x11, 0x07)
#define REG_SC_BK11_08_L      _PK_L_(0x11, 0x08)
#define REG_SC_BK11_08_H      _PK_H_(0x11, 0x08)
#define REG_SC_BK11_09_L      _PK_L_(0x11, 0x09)
#define REG_SC_BK11_09_H      _PK_H_(0x11, 0x09)
#define REG_SC_BK11_0A_L      _PK_L_(0x11, 0x0A)
#define REG_SC_BK11_0A_H      _PK_H_(0x11, 0x0A)
#define REG_SC_BK11_0B_L      _PK_L_(0x11, 0x0B)
#define REG_SC_BK11_0B_H      _PK_H_(0x11, 0x0B)
#define REG_SC_BK11_0C_L      _PK_L_(0x11, 0x0C)
#define REG_SC_BK11_0C_H      _PK_H_(0x11, 0x0C)
#define REG_SC_BK11_0D_L      _PK_L_(0x11, 0x0D)
#define REG_SC_BK11_0D_H      _PK_H_(0x11, 0x0D)
#define REG_SC_BK11_0E_L      _PK_L_(0x11, 0x0E)
#define REG_SC_BK11_0E_H      _PK_H_(0x11, 0x0E)
#define REG_SC_BK11_0F_L      _PK_L_(0x11, 0x0F)
#define REG_SC_BK11_0F_H      _PK_H_(0x11, 0x0F)
#define REG_SC_BK11_10_L      _PK_L_(0x11, 0x10)
#define REG_SC_BK11_10_H      _PK_H_(0x11, 0x10)
#define REG_SC_BK11_11_L      _PK_L_(0x11, 0x11)
#define REG_SC_BK11_11_H      _PK_H_(0x11, 0x11)
#define REG_SC_BK11_12_L      _PK_L_(0x11, 0x12)
#define REG_SC_BK11_12_H      _PK_H_(0x11, 0x12)
#define REG_SC_BK11_13_L      _PK_L_(0x11, 0x13)
#define REG_SC_BK11_13_H      _PK_H_(0x11, 0x13)
#define REG_SC_BK11_14_L      _PK_L_(0x11, 0x14)
#define REG_SC_BK11_14_H      _PK_H_(0x11, 0x14)
#define REG_SC_BK11_15_L      _PK_L_(0x11, 0x15)
#define REG_SC_BK11_15_H      _PK_H_(0x11, 0x15)
#define REG_SC_BK11_16_L      _PK_L_(0x11, 0x16)
#define REG_SC_BK11_16_H      _PK_H_(0x11, 0x16)
#define REG_SC_BK11_17_L      _PK_L_(0x11, 0x17)
#define REG_SC_BK11_17_H      _PK_H_(0x11, 0x17)
#define REG_SC_BK11_18_L      _PK_L_(0x11, 0x18)
#define REG_SC_BK11_18_H      _PK_H_(0x11, 0x18)
#define REG_SC_BK11_19_L      _PK_L_(0x11, 0x19)
#define REG_SC_BK11_19_H      _PK_H_(0x11, 0x19)
#define REG_SC_BK11_1A_L      _PK_L_(0x11, 0x1A)
#define REG_SC_BK11_1A_H      _PK_H_(0x11, 0x1A)
#define REG_SC_BK11_1B_L      _PK_L_(0x11, 0x1B)
#define REG_SC_BK11_1B_H      _PK_H_(0x11, 0x1B)
#define REG_SC_BK11_1C_L      _PK_L_(0x11, 0x1C)
#define REG_SC_BK11_1C_H      _PK_H_(0x11, 0x1C)
#define REG_SC_BK11_1D_L      _PK_L_(0x11, 0x1D)
#define REG_SC_BK11_1D_H      _PK_H_(0x11, 0x1D)
#define REG_SC_BK11_1E_L      _PK_L_(0x11, 0x1E)
#define REG_SC_BK11_1E_H      _PK_H_(0x11, 0x1E)
#define REG_SC_BK11_1F_L      _PK_L_(0x11, 0x1F)
#define REG_SC_BK11_1F_H      _PK_H_(0x11, 0x1F)
#define REG_SC_BK11_20_L      _PK_L_(0x11, 0x20)
#define REG_SC_BK11_20_H      _PK_H_(0x11, 0x20)
#define REG_SC_BK11_21_L      _PK_L_(0x11, 0x21)
#define REG_SC_BK11_21_H      _PK_H_(0x11, 0x21)
#define REG_SC_BK11_22_L      _PK_L_(0x11, 0x22)
#define REG_SC_BK11_22_H      _PK_H_(0x11, 0x22)
#define REG_SC_BK11_23_L      _PK_L_(0x11, 0x23)
#define REG_SC_BK11_23_H      _PK_H_(0x11, 0x23)
#define REG_SC_BK11_24_L      _PK_L_(0x11, 0x24)
#define REG_SC_BK11_24_H      _PK_H_(0x11, 0x24)
#define REG_SC_BK11_25_L      _PK_L_(0x11, 0x25)
#define REG_SC_BK11_25_H      _PK_H_(0x11, 0x25)
#define REG_SC_BK11_26_L      _PK_L_(0x11, 0x26)
#define REG_SC_BK11_26_H      _PK_H_(0x11, 0x26)
#define REG_SC_BK11_27_L      _PK_L_(0x11, 0x27)
#define REG_SC_BK11_27_H      _PK_H_(0x11, 0x27)
#define REG_SC_BK11_28_L      _PK_L_(0x11, 0x28)
#define REG_SC_BK11_28_H      _PK_H_(0x11, 0x28)
#define REG_SC_BK11_29_L      _PK_L_(0x11, 0x29)
#define REG_SC_BK11_29_H      _PK_H_(0x11, 0x29)
#define REG_SC_BK11_2A_L      _PK_L_(0x11, 0x2A)
#define REG_SC_BK11_2A_H      _PK_H_(0x11, 0x2A)
#define REG_SC_BK11_2B_L      _PK_L_(0x11, 0x2B)
#define REG_SC_BK11_2B_H      _PK_H_(0x11, 0x2B)
#define REG_SC_BK11_2C_L      _PK_L_(0x11, 0x2C)
#define REG_SC_BK11_2C_H      _PK_H_(0x11, 0x2C)
#define REG_SC_BK11_2D_L      _PK_L_(0x11, 0x2D)
#define REG_SC_BK11_2D_H      _PK_H_(0x11, 0x2D)
#define REG_SC_BK11_2E_L      _PK_L_(0x11, 0x2E)
#define REG_SC_BK11_2E_H      _PK_H_(0x11, 0x2E)
#define REG_SC_BK11_2F_L      _PK_L_(0x11, 0x2F)
#define REG_SC_BK11_2F_H      _PK_H_(0x11, 0x2F)
#define REG_SC_BK11_30_L      _PK_L_(0x11, 0x30)
#define REG_SC_BK11_30_H      _PK_H_(0x11, 0x30)
#define REG_SC_BK11_31_L      _PK_L_(0x11, 0x31)
#define REG_SC_BK11_31_H      _PK_H_(0x11, 0x31)
#define REG_SC_BK11_32_L      _PK_L_(0x11, 0x32)
#define REG_SC_BK11_32_H      _PK_H_(0x11, 0x32)
#define REG_SC_BK11_33_L      _PK_L_(0x11, 0x33)
#define REG_SC_BK11_33_H      _PK_H_(0x11, 0x33)
#define REG_SC_BK11_34_L      _PK_L_(0x11, 0x34)
#define REG_SC_BK11_34_H      _PK_H_(0x11, 0x34)
#define REG_SC_BK11_35_L      _PK_L_(0x11, 0x35)
#define REG_SC_BK11_35_H      _PK_H_(0x11, 0x35)
#define REG_SC_BK11_36_L      _PK_L_(0x11, 0x36)
#define REG_SC_BK11_36_H      _PK_H_(0x11, 0x36)
#define REG_SC_BK11_37_L      _PK_L_(0x11, 0x37)
#define REG_SC_BK11_37_H      _PK_H_(0x11, 0x37)
#define REG_SC_BK11_38_L      _PK_L_(0x11, 0x38)
#define REG_SC_BK11_38_H      _PK_H_(0x11, 0x38)
#define REG_SC_BK11_39_L      _PK_L_(0x11, 0x39)
#define REG_SC_BK11_39_H      _PK_H_(0x11, 0x39)
#define REG_SC_BK11_3A_L      _PK_L_(0x11, 0x3A)
#define REG_SC_BK11_3A_H      _PK_H_(0x11, 0x3A)
#define REG_SC_BK11_3B_L      _PK_L_(0x11, 0x3B)
#define REG_SC_BK11_3B_H      _PK_H_(0x11, 0x3B)
#define REG_SC_BK11_3C_L      _PK_L_(0x11, 0x3C)
#define REG_SC_BK11_3C_H      _PK_H_(0x11, 0x3C)
#define REG_SC_BK11_3D_L      _PK_L_(0x11, 0x3D)
#define REG_SC_BK11_3D_H      _PK_H_(0x11, 0x3D)
#define REG_SC_BK11_3E_L      _PK_L_(0x11, 0x3E)
#define REG_SC_BK11_3E_H      _PK_H_(0x11, 0x3E)
#define REG_SC_BK11_3F_L      _PK_L_(0x11, 0x3F)
#define REG_SC_BK11_3F_H      _PK_H_(0x11, 0x3F)
#define REG_SC_BK11_40_L      _PK_L_(0x11, 0x40)
#define REG_SC_BK11_40_H      _PK_H_(0x11, 0x40)
#define REG_SC_BK11_41_L      _PK_L_(0x11, 0x41)
#define REG_SC_BK11_41_H      _PK_H_(0x11, 0x41)
#define REG_SC_BK11_42_L      _PK_L_(0x11, 0x42)
#define REG_SC_BK11_42_H      _PK_H_(0x11, 0x42)
#define REG_SC_BK11_43_L      _PK_L_(0x11, 0x43)
#define REG_SC_BK11_43_H      _PK_H_(0x11, 0x43)
#define REG_SC_BK11_44_L      _PK_L_(0x11, 0x44)
#define REG_SC_BK11_44_H      _PK_H_(0x11, 0x44)
#define REG_SC_BK11_45_L      _PK_L_(0x11, 0x45)
#define REG_SC_BK11_45_H      _PK_H_(0x11, 0x45)
#define REG_SC_BK11_46_L      _PK_L_(0x11, 0x46)
#define REG_SC_BK11_46_H      _PK_H_(0x11, 0x46)
#define REG_SC_BK11_47_L      _PK_L_(0x11, 0x47)
#define REG_SC_BK11_47_H      _PK_H_(0x11, 0x47)
#define REG_SC_BK11_48_L      _PK_L_(0x11, 0x48)
#define REG_SC_BK11_48_H      _PK_H_(0x11, 0x48)
#define REG_SC_BK11_49_L      _PK_L_(0x11, 0x49)
#define REG_SC_BK11_49_H      _PK_H_(0x11, 0x49)
#define REG_SC_BK11_4A_L      _PK_L_(0x11, 0x4A)
#define REG_SC_BK11_4A_H      _PK_H_(0x11, 0x4A)
#define REG_SC_BK11_4B_L      _PK_L_(0x11, 0x4B)
#define REG_SC_BK11_4B_H      _PK_H_(0x11, 0x4B)
#define REG_SC_BK11_4C_L      _PK_L_(0x11, 0x4C)
#define REG_SC_BK11_4C_H      _PK_H_(0x11, 0x4C)
#define REG_SC_BK11_4D_L      _PK_L_(0x11, 0x4D)
#define REG_SC_BK11_4D_H      _PK_H_(0x11, 0x4D)
#define REG_SC_BK11_4E_L      _PK_L_(0x11, 0x4E)
#define REG_SC_BK11_4E_H      _PK_H_(0x11, 0x4E)
#define REG_SC_BK11_4F_L      _PK_L_(0x11, 0x4F)
#define REG_SC_BK11_4F_H      _PK_H_(0x11, 0x4F)
#define REG_SC_BK11_50_L      _PK_L_(0x11, 0x50)
#define REG_SC_BK11_50_H      _PK_H_(0x11, 0x50)
#define REG_SC_BK11_51_L      _PK_L_(0x11, 0x51)
#define REG_SC_BK11_51_H      _PK_H_(0x11, 0x51)
#define REG_SC_BK11_52_L      _PK_L_(0x11, 0x52)
#define REG_SC_BK11_52_H      _PK_H_(0x11, 0x52)
#define REG_SC_BK11_53_L      _PK_L_(0x11, 0x53)
#define REG_SC_BK11_53_H      _PK_H_(0x11, 0x53)
#define REG_SC_BK11_54_L      _PK_L_(0x11, 0x54)
#define REG_SC_BK11_54_H      _PK_H_(0x11, 0x54)
#define REG_SC_BK11_55_L      _PK_L_(0x11, 0x55)
#define REG_SC_BK11_55_H      _PK_H_(0x11, 0x55)
#define REG_SC_BK11_56_L      _PK_L_(0x11, 0x56)
#define REG_SC_BK11_56_H      _PK_H_(0x11, 0x56)
#define REG_SC_BK11_57_L      _PK_L_(0x11, 0x57)
#define REG_SC_BK11_57_H      _PK_H_(0x11, 0x57)
#define REG_SC_BK11_58_L      _PK_L_(0x11, 0x58)
#define REG_SC_BK11_58_H      _PK_H_(0x11, 0x58)
#define REG_SC_BK11_59_L      _PK_L_(0x11, 0x59)
#define REG_SC_BK11_59_H      _PK_H_(0x11, 0x59)
#define REG_SC_BK11_5A_L      _PK_L_(0x11, 0x5A)
#define REG_SC_BK11_5A_H      _PK_H_(0x11, 0x5A)
#define REG_SC_BK11_5B_L      _PK_L_(0x11, 0x5B)
#define REG_SC_BK11_5B_H      _PK_H_(0x11, 0x5B)
#define REG_SC_BK11_5C_L      _PK_L_(0x11, 0x5C)
#define REG_SC_BK11_5C_H      _PK_H_(0x11, 0x5C)
#define REG_SC_BK11_5D_L      _PK_L_(0x11, 0x5D)
#define REG_SC_BK11_5D_H      _PK_H_(0x11, 0x5D)
#define REG_SC_BK11_5E_L      _PK_L_(0x11, 0x5E)
#define REG_SC_BK11_5E_H      _PK_H_(0x11, 0x5E)
#define REG_SC_BK11_5F_L      _PK_L_(0x11, 0x5F)
#define REG_SC_BK11_5F_H      _PK_H_(0x11, 0x5F)
#define REG_SC_BK11_60_L      _PK_L_(0x11, 0x60)
#define REG_SC_BK11_60_H      _PK_H_(0x11, 0x60)
#define REG_SC_BK11_61_L      _PK_L_(0x11, 0x61)
#define REG_SC_BK11_61_H      _PK_H_(0x11, 0x61)
#define REG_SC_BK11_62_L      _PK_L_(0x11, 0x62)
#define REG_SC_BK11_62_H      _PK_H_(0x11, 0x62)
#define REG_SC_BK11_63_L      _PK_L_(0x11, 0x63)
#define REG_SC_BK11_63_H      _PK_H_(0x11, 0x63)
#define REG_SC_BK11_64_L      _PK_L_(0x11, 0x64)
#define REG_SC_BK11_64_H      _PK_H_(0x11, 0x64)
#define REG_SC_BK11_65_L      _PK_L_(0x11, 0x65)
#define REG_SC_BK11_65_H      _PK_H_(0x11, 0x65)
#define REG_SC_BK11_66_L      _PK_L_(0x11, 0x66)
#define REG_SC_BK11_66_H      _PK_H_(0x11, 0x66)
#define REG_SC_BK11_67_L      _PK_L_(0x11, 0x67)
#define REG_SC_BK11_67_H      _PK_H_(0x11, 0x67)
#define REG_SC_BK11_68_L      _PK_L_(0x11, 0x68)
#define REG_SC_BK11_68_H      _PK_H_(0x11, 0x68)
#define REG_SC_BK11_69_L      _PK_L_(0x11, 0x69)
#define REG_SC_BK11_69_H      _PK_H_(0x11, 0x69)
#define REG_SC_BK11_6A_L      _PK_L_(0x11, 0x6A)
#define REG_SC_BK11_6A_H      _PK_H_(0x11, 0x6A)
#define REG_SC_BK11_6B_L      _PK_L_(0x11, 0x6B)
#define REG_SC_BK11_6B_H      _PK_H_(0x11, 0x6B)
#define REG_SC_BK11_6C_L      _PK_L_(0x11, 0x6C)
#define REG_SC_BK11_6C_H      _PK_H_(0x11, 0x6C)
#define REG_SC_BK11_6D_L      _PK_L_(0x11, 0x6D)
#define REG_SC_BK11_6D_H      _PK_H_(0x11, 0x6D)
#define REG_SC_BK11_6E_L      _PK_L_(0x11, 0x6E)
#define REG_SC_BK11_6E_H      _PK_H_(0x11, 0x6E)
#define REG_SC_BK11_6F_L      _PK_L_(0x11, 0x6F)
#define REG_SC_BK11_6F_H      _PK_H_(0x11, 0x6F)
#define REG_SC_BK11_70_L      _PK_L_(0x11, 0x70)
#define REG_SC_BK11_70_H      _PK_H_(0x11, 0x70)
#define REG_SC_BK11_71_L      _PK_L_(0x11, 0x71)
#define REG_SC_BK11_71_H      _PK_H_(0x11, 0x71)
#define REG_SC_BK11_72_L      _PK_L_(0x11, 0x72)
#define REG_SC_BK11_72_H      _PK_H_(0x11, 0x72)
#define REG_SC_BK11_73_L      _PK_L_(0x11, 0x73)
#define REG_SC_BK11_73_H      _PK_H_(0x11, 0x73)
#define REG_SC_BK11_74_L      _PK_L_(0x11, 0x74)
#define REG_SC_BK11_74_H      _PK_H_(0x11, 0x74)
#define REG_SC_BK11_75_L      _PK_L_(0x11, 0x75)
#define REG_SC_BK11_75_H      _PK_H_(0x11, 0x75)
#define REG_SC_BK11_76_L      _PK_L_(0x11, 0x76)
#define REG_SC_BK11_76_H      _PK_H_(0x11, 0x76)
#define REG_SC_BK11_77_L      _PK_L_(0x11, 0x77)
#define REG_SC_BK11_77_H      _PK_H_(0x11, 0x77)
#define REG_SC_BK11_78_L      _PK_L_(0x11, 0x78)
#define REG_SC_BK11_78_H      _PK_H_(0x11, 0x78)
#define REG_SC_BK11_79_L      _PK_L_(0x11, 0x79)
#define REG_SC_BK11_79_H      _PK_H_(0x11, 0x79)
#define REG_SC_BK11_7A_L      _PK_L_(0x11, 0x7A)
#define REG_SC_BK11_7A_H      _PK_H_(0x11, 0x7A)
#define REG_SC_BK11_7B_L      _PK_L_(0x11, 0x7B)
#define REG_SC_BK11_7B_H      _PK_H_(0x11, 0x7B)
#define REG_SC_BK11_7C_L      _PK_L_(0x11, 0x7C)
#define REG_SC_BK11_7C_H      _PK_H_(0x11, 0x7C)
#define REG_SC_BK11_7D_L      _PK_L_(0x11, 0x7D)
#define REG_SC_BK11_7D_H      _PK_H_(0x11, 0x7D)
#define REG_SC_BK11_7E_L      _PK_L_(0x11, 0x7E)
#define REG_SC_BK11_7E_H      _PK_H_(0x11, 0x7E)
#define REG_SC_BK11_7F_L      _PK_L_(0x11, 0x7F)
#define REG_SC_BK11_7F_H      _PK_H_(0x11, 0x7F)



//----------------------------------------------
//  BK12
//----------------------------------------------
#define REG_SC_BK12_00_L      _PK_L_(0x12, 0x00)
#define REG_SC_BK12_00_H      _PK_H_(0x12, 0x00)
#define REG_SC_BK12_01_L      _PK_L_(0x12, 0x01)
#define REG_SC_BK12_01_H      _PK_H_(0x12, 0x01)
#define REG_SC_BK12_02_L      _PK_L_(0x12, 0x02)
#define REG_SC_BK12_02_H      _PK_H_(0x12, 0x02)
#define REG_SC_BK12_03_L      _PK_L_(0x12, 0x03)
#define REG_SC_BK12_03_H      _PK_H_(0x12, 0x03)
#define REG_SC_BK12_04_L      _PK_L_(0x12, 0x04)
#define REG_SC_BK12_04_H      _PK_H_(0x12, 0x04)
#define REG_SC_BK12_05_L      _PK_L_(0x12, 0x05)
#define REG_SC_BK12_05_H      _PK_H_(0x12, 0x05)
#define REG_SC_BK12_06_L      _PK_L_(0x12, 0x06)
#define REG_SC_BK12_06_H      _PK_H_(0x12, 0x06)
#define REG_SC_BK12_07_L      _PK_L_(0x12, 0x07)
#define REG_SC_BK12_07_H      _PK_H_(0x12, 0x07)
#define REG_SC_BK12_08_L      _PK_L_(0x12, 0x08)
#define REG_SC_BK12_08_H      _PK_H_(0x12, 0x08)
#define REG_SC_BK12_09_L      _PK_L_(0x12, 0x09)
#define REG_SC_BK12_09_H      _PK_H_(0x12, 0x09)
#define REG_SC_BK12_0A_L      _PK_L_(0x12, 0x0A)
#define REG_SC_BK12_0A_H      _PK_H_(0x12, 0x0A)
#define REG_SC_BK12_0B_L      _PK_L_(0x12, 0x0B)
#define REG_SC_BK12_0B_H      _PK_H_(0x12, 0x0B)
#define REG_SC_BK12_0C_L      _PK_L_(0x12, 0x0C)
#define REG_SC_BK12_0C_H      _PK_H_(0x12, 0x0C)
#define REG_SC_BK12_0D_L      _PK_L_(0x12, 0x0D)
#define REG_SC_BK12_0D_H      _PK_H_(0x12, 0x0D)
#define REG_SC_BK12_0E_L      _PK_L_(0x12, 0x0E)
#define REG_SC_BK12_0E_H      _PK_H_(0x12, 0x0E)
#define REG_SC_BK12_0F_L      _PK_L_(0x12, 0x0F)
#define REG_SC_BK12_0F_H      _PK_H_(0x12, 0x0F)
#define REG_SC_BK12_10_L      _PK_L_(0x12, 0x10)
#define REG_SC_BK12_10_H      _PK_H_(0x12, 0x10)
#define REG_SC_BK12_11_L      _PK_L_(0x12, 0x11)
#define REG_SC_BK12_11_H      _PK_H_(0x12, 0x11)
#define REG_SC_BK12_12_L      _PK_L_(0x12, 0x12)
#define REG_SC_BK12_12_H      _PK_H_(0x12, 0x12)
#define REG_SC_BK12_13_L      _PK_L_(0x12, 0x13)
#define REG_SC_BK12_13_H      _PK_H_(0x12, 0x13)
#define REG_SC_BK12_14_L      _PK_L_(0x12, 0x14)
#define REG_SC_BK12_14_H      _PK_H_(0x12, 0x14)
#define REG_SC_BK12_15_L      _PK_L_(0x12, 0x15)
#define REG_SC_BK12_15_H      _PK_H_(0x12, 0x15)
#define REG_SC_BK12_16_L      _PK_L_(0x12, 0x16)
#define REG_SC_BK12_16_H      _PK_H_(0x12, 0x16)
#define REG_SC_BK12_17_L      _PK_L_(0x12, 0x17)
#define REG_SC_BK12_17_H      _PK_H_(0x12, 0x17)
#define REG_SC_BK12_18_L      _PK_L_(0x12, 0x18)
#define REG_SC_BK12_18_H      _PK_H_(0x12, 0x18)
#define REG_SC_BK12_19_L      _PK_L_(0x12, 0x19)
#define REG_SC_BK12_19_H      _PK_H_(0x12, 0x19)
#define REG_SC_BK12_1A_L      _PK_L_(0x12, 0x1A)
#define REG_SC_BK12_1A_H      _PK_H_(0x12, 0x1A)
#define REG_SC_BK12_1B_L      _PK_L_(0x12, 0x1B)
#define REG_SC_BK12_1B_H      _PK_H_(0x12, 0x1B)
#define REG_SC_BK12_1C_L      _PK_L_(0x12, 0x1C)
#define REG_SC_BK12_1C_H      _PK_H_(0x12, 0x1C)
#define REG_SC_BK12_1D_L      _PK_L_(0x12, 0x1D)
#define REG_SC_BK12_1D_H      _PK_H_(0x12, 0x1D)
#define REG_SC_BK12_1E_L      _PK_L_(0x12, 0x1E)
#define REG_SC_BK12_1E_H      _PK_H_(0x12, 0x1E)
#define REG_SC_BK12_1F_L      _PK_L_(0x12, 0x1F)
#define REG_SC_BK12_1F_H      _PK_H_(0x12, 0x1F)
#define REG_SC_BK12_20_L      _PK_L_(0x12, 0x20)
#define REG_SC_BK12_20_H      _PK_H_(0x12, 0x20)
#define REG_SC_BK12_21_L      _PK_L_(0x12, 0x21)
#define REG_SC_BK12_21_H      _PK_H_(0x12, 0x21)
#define REG_SC_BK12_22_L      _PK_L_(0x12, 0x22)
#define REG_SC_BK12_22_H      _PK_H_(0x12, 0x22)
#define REG_SC_BK12_23_L      _PK_L_(0x12, 0x23)
#define REG_SC_BK12_23_H      _PK_H_(0x12, 0x23)
#define REG_SC_BK12_24_L      _PK_L_(0x12, 0x24)
#define REG_SC_BK12_24_H      _PK_H_(0x12, 0x24)
#define REG_SC_BK12_25_L      _PK_L_(0x12, 0x25)
#define REG_SC_BK12_25_H      _PK_H_(0x12, 0x25)
#define REG_SC_BK12_26_L      _PK_L_(0x12, 0x26)
#define REG_SC_BK12_26_H      _PK_H_(0x12, 0x26)
#define REG_SC_BK12_27_L      _PK_L_(0x12, 0x27)
#define REG_SC_BK12_27_H      _PK_H_(0x12, 0x27)
#define REG_SC_BK12_28_L      _PK_L_(0x12, 0x28)
#define REG_SC_BK12_28_H      _PK_H_(0x12, 0x28)
#define REG_SC_BK12_29_L      _PK_L_(0x12, 0x29)
#define REG_SC_BK12_29_H      _PK_H_(0x12, 0x29)
#define REG_SC_BK12_2A_L      _PK_L_(0x12, 0x2A)
#define REG_SC_BK12_2A_H      _PK_H_(0x12, 0x2A)
#define REG_SC_BK12_2B_L      _PK_L_(0x12, 0x2B)
#define REG_SC_BK12_2B_H      _PK_H_(0x12, 0x2B)
#define REG_SC_BK12_2C_L      _PK_L_(0x12, 0x2C)
#define REG_SC_BK12_2C_H      _PK_H_(0x12, 0x2C)
#define REG_SC_BK12_2D_L      _PK_L_(0x12, 0x2D)
#define REG_SC_BK12_2D_H      _PK_H_(0x12, 0x2D)
#define REG_SC_BK12_2E_L      _PK_L_(0x12, 0x2E)
#define REG_SC_BK12_2E_H      _PK_H_(0x12, 0x2E)
#define REG_SC_BK12_2F_L      _PK_L_(0x12, 0x2F)
#define REG_SC_BK12_2F_H      _PK_H_(0x12, 0x2F)
#define REG_SC_BK12_30_L      _PK_L_(0x12, 0x30)
#define REG_SC_BK12_30_H      _PK_H_(0x12, 0x30)
#define REG_SC_BK12_31_L      _PK_L_(0x12, 0x31)
#define REG_SC_BK12_31_H      _PK_H_(0x12, 0x31)
#define REG_SC_BK12_32_L      _PK_L_(0x12, 0x32)
#define REG_SC_BK12_32_H      _PK_H_(0x12, 0x32)
#define REG_SC_BK12_33_L      _PK_L_(0x12, 0x33)
#define REG_SC_BK12_33_H      _PK_H_(0x12, 0x33)
#define REG_SC_BK12_34_L      _PK_L_(0x12, 0x34)
#define REG_SC_BK12_34_H      _PK_H_(0x12, 0x34)
#define REG_SC_BK12_35_L      _PK_L_(0x12, 0x35)
#define REG_SC_BK12_35_H      _PK_H_(0x12, 0x35)
#define REG_SC_BK12_36_L      _PK_L_(0x12, 0x36)
#define REG_SC_BK12_36_H      _PK_H_(0x12, 0x36)
#define REG_SC_BK12_37_L      _PK_L_(0x12, 0x37)
#define REG_SC_BK12_37_H      _PK_H_(0x12, 0x37)
#define REG_SC_BK12_38_L      _PK_L_(0x12, 0x38)
#define REG_SC_BK12_38_H      _PK_H_(0x12, 0x38)
#define REG_SC_BK12_39_L      _PK_L_(0x12, 0x39)
#define REG_SC_BK12_39_H      _PK_H_(0x12, 0x39)
#define REG_SC_BK12_3A_L      _PK_L_(0x12, 0x3A)
#define REG_SC_BK12_3A_H      _PK_H_(0x12, 0x3A)
#define REG_SC_BK12_3B_L      _PK_L_(0x12, 0x3B)
#define REG_SC_BK12_3B_H      _PK_H_(0x12, 0x3B)
#define REG_SC_BK12_3C_L      _PK_L_(0x12, 0x3C)
#define REG_SC_BK12_3C_H      _PK_H_(0x12, 0x3C)
#define REG_SC_BK12_3D_L      _PK_L_(0x12, 0x3D)
#define REG_SC_BK12_3D_H      _PK_H_(0x12, 0x3D)
#define REG_SC_BK12_3E_L      _PK_L_(0x12, 0x3E)
#define REG_SC_BK12_3E_H      _PK_H_(0x12, 0x3E)
#define REG_SC_BK12_3F_L      _PK_L_(0x12, 0x3F)
#define REG_SC_BK12_3F_H      _PK_H_(0x12, 0x3F)
#define REG_SC_BK12_40_L      _PK_L_(0x12, 0x40)
#define REG_SC_BK12_40_H      _PK_H_(0x12, 0x40)
#define REG_SC_BK12_41_L      _PK_L_(0x12, 0x41)
#define REG_SC_BK12_41_H      _PK_H_(0x12, 0x41)
#define REG_SC_BK12_42_L      _PK_L_(0x12, 0x42)
#define REG_SC_BK12_42_H      _PK_H_(0x12, 0x42)
#define REG_SC_BK12_43_L      _PK_L_(0x12, 0x43)
#define REG_SC_BK12_43_H      _PK_H_(0x12, 0x43)
#define REG_SC_BK12_44_L      _PK_L_(0x12, 0x44)
#define REG_SC_BK12_44_H      _PK_H_(0x12, 0x44)
#define REG_SC_BK12_45_L      _PK_L_(0x12, 0x45)
#define REG_SC_BK12_45_H      _PK_H_(0x12, 0x45)
#define REG_SC_BK12_46_L      _PK_L_(0x12, 0x46)
#define REG_SC_BK12_46_H      _PK_H_(0x12, 0x46)
#define REG_SC_BK12_47_L      _PK_L_(0x12, 0x47)
#define REG_SC_BK12_47_H      _PK_H_(0x12, 0x47)
#define REG_SC_BK12_48_L      _PK_L_(0x12, 0x48)
#define REG_SC_BK12_48_H      _PK_H_(0x12, 0x48)
#define REG_SC_BK12_49_L      _PK_L_(0x12, 0x49)
#define REG_SC_BK12_49_H      _PK_H_(0x12, 0x49)
#define REG_SC_BK12_4A_L      _PK_L_(0x12, 0x4A)
#define REG_SC_BK12_4A_H      _PK_H_(0x12, 0x4A)
#define REG_SC_BK12_4B_L      _PK_L_(0x12, 0x4B)
#define REG_SC_BK12_4B_H      _PK_H_(0x12, 0x4B)
#define REG_SC_BK12_4C_L      _PK_L_(0x12, 0x4C)
#define REG_SC_BK12_4C_H      _PK_H_(0x12, 0x4C)
#define REG_SC_BK12_4D_L      _PK_L_(0x12, 0x4D)
#define REG_SC_BK12_4D_H      _PK_H_(0x12, 0x4D)
#define REG_SC_BK12_4E_L      _PK_L_(0x12, 0x4E)
#define REG_SC_BK12_4E_H      _PK_H_(0x12, 0x4E)
#define REG_SC_BK12_4F_L      _PK_L_(0x12, 0x4F)
#define REG_SC_BK12_4F_H      _PK_H_(0x12, 0x4F)
#define REG_SC_BK12_50_L      _PK_L_(0x12, 0x50)
#define REG_SC_BK12_50_H      _PK_H_(0x12, 0x50)
#define REG_SC_BK12_51_L      _PK_L_(0x12, 0x51)
#define REG_SC_BK12_51_H      _PK_H_(0x12, 0x51)
#define REG_SC_BK12_52_L      _PK_L_(0x12, 0x52)
#define REG_SC_BK12_52_H      _PK_H_(0x12, 0x52)
#define REG_SC_BK12_53_L      _PK_L_(0x12, 0x53)
#define REG_SC_BK12_53_H      _PK_H_(0x12, 0x53)
#define REG_SC_BK12_54_L      _PK_L_(0x12, 0x54)
#define REG_SC_BK12_54_H      _PK_H_(0x12, 0x54)
#define REG_SC_BK12_55_L      _PK_L_(0x12, 0x55)
#define REG_SC_BK12_55_H      _PK_H_(0x12, 0x55)
#define REG_SC_BK12_56_L      _PK_L_(0x12, 0x56)
#define REG_SC_BK12_56_H      _PK_H_(0x12, 0x56)
#define REG_SC_BK12_57_L      _PK_L_(0x12, 0x57)
#define REG_SC_BK12_57_H      _PK_H_(0x12, 0x57)
#define REG_SC_BK12_58_L      _PK_L_(0x12, 0x58)
#define REG_SC_BK12_58_H      _PK_H_(0x12, 0x58)
#define REG_SC_BK12_59_L      _PK_L_(0x12, 0x59)
#define REG_SC_BK12_59_H      _PK_H_(0x12, 0x59)
#define REG_SC_BK12_5A_L      _PK_L_(0x12, 0x5A)
#define REG_SC_BK12_5A_H      _PK_H_(0x12, 0x5A)
#define REG_SC_BK12_5B_L      _PK_L_(0x12, 0x5B)
#define REG_SC_BK12_5B_H      _PK_H_(0x12, 0x5B)
#define REG_SC_BK12_5C_L      _PK_L_(0x12, 0x5C)
#define REG_SC_BK12_5C_H      _PK_H_(0x12, 0x5C)
#define REG_SC_BK12_5D_L      _PK_L_(0x12, 0x5D)
#define REG_SC_BK12_5D_H      _PK_H_(0x12, 0x5D)
#define REG_SC_BK12_5E_L      _PK_L_(0x12, 0x5E)
#define REG_SC_BK12_5E_H      _PK_H_(0x12, 0x5E)
#define REG_SC_BK12_5F_L      _PK_L_(0x12, 0x5F)
#define REG_SC_BK12_5F_H      _PK_H_(0x12, 0x5F)
#define REG_SC_BK12_60_L      _PK_L_(0x12, 0x60)
#define REG_SC_BK12_60_H      _PK_H_(0x12, 0x60)
#define REG_SC_BK12_61_L      _PK_L_(0x12, 0x61)
#define REG_SC_BK12_61_H      _PK_H_(0x12, 0x61)
#define REG_SC_BK12_62_L      _PK_L_(0x12, 0x62)
#define REG_SC_BK12_62_H      _PK_H_(0x12, 0x62)
#define REG_SC_BK12_63_L      _PK_L_(0x12, 0x63)
#define REG_SC_BK12_63_H      _PK_H_(0x12, 0x63)
#define REG_SC_BK12_64_L      _PK_L_(0x12, 0x64)
#define REG_SC_BK12_64_H      _PK_H_(0x12, 0x64)
#define REG_SC_BK12_65_L      _PK_L_(0x12, 0x65)
#define REG_SC_BK12_65_H      _PK_H_(0x12, 0x65)
#define REG_SC_BK12_66_L      _PK_L_(0x12, 0x66)
#define REG_SC_BK12_66_H      _PK_H_(0x12, 0x66)
#define REG_SC_BK12_67_L      _PK_L_(0x12, 0x67)
#define REG_SC_BK12_67_H      _PK_H_(0x12, 0x67)
#define REG_SC_BK12_68_L      _PK_L_(0x12, 0x68)
#define REG_SC_BK12_68_H      _PK_H_(0x12, 0x68)
#define REG_SC_BK12_69_L      _PK_L_(0x12, 0x69)
#define REG_SC_BK12_69_H      _PK_H_(0x12, 0x69)
#define REG_SC_BK12_6A_L      _PK_L_(0x12, 0x6A)
#define REG_SC_BK12_6A_H      _PK_H_(0x12, 0x6A)
#define REG_SC_BK12_6B_L      _PK_L_(0x12, 0x6B)
#define REG_SC_BK12_6B_H      _PK_H_(0x12, 0x6B)
#define REG_SC_BK12_6C_L      _PK_L_(0x12, 0x6C)
#define REG_SC_BK12_6C_H      _PK_H_(0x12, 0x6C)
#define REG_SC_BK12_6D_L      _PK_L_(0x12, 0x6D)
#define REG_SC_BK12_6D_H      _PK_H_(0x12, 0x6D)
#define REG_SC_BK12_6E_L      _PK_L_(0x12, 0x6E)
#define REG_SC_BK12_6E_H      _PK_H_(0x12, 0x6E)
#define REG_SC_BK12_6F_L      _PK_L_(0x12, 0x6F)
#define REG_SC_BK12_6F_H      _PK_H_(0x12, 0x6F)
#define REG_SC_BK12_70_L      _PK_L_(0x12, 0x70)
#define REG_SC_BK12_70_H      _PK_H_(0x12, 0x70)
#define REG_SC_BK12_71_L      _PK_L_(0x12, 0x71)
#define REG_SC_BK12_71_H      _PK_H_(0x12, 0x71)
#define REG_SC_BK12_72_L      _PK_L_(0x12, 0x72)
#define REG_SC_BK12_72_H      _PK_H_(0x12, 0x72)
#define REG_SC_BK12_73_L      _PK_L_(0x12, 0x73)
#define REG_SC_BK12_73_H      _PK_H_(0x12, 0x73)
#define REG_SC_BK12_74_L      _PK_L_(0x12, 0x74)
#define REG_SC_BK12_74_H      _PK_H_(0x12, 0x74)
#define REG_SC_BK12_75_L      _PK_L_(0x12, 0x75)
#define REG_SC_BK12_75_H      _PK_H_(0x12, 0x75)
#define REG_SC_BK12_76_L      _PK_L_(0x12, 0x76)
#define REG_SC_BK12_76_H      _PK_H_(0x12, 0x76)
#define REG_SC_BK12_77_L      _PK_L_(0x12, 0x77)
#define REG_SC_BK12_77_H      _PK_H_(0x12, 0x77)
#define REG_SC_BK12_78_L      _PK_L_(0x12, 0x78)
#define REG_SC_BK12_78_H      _PK_H_(0x12, 0x78)
#define REG_SC_BK12_79_L      _PK_L_(0x12, 0x79)
#define REG_SC_BK12_79_H      _PK_H_(0x12, 0x79)
#define REG_SC_BK12_7A_L      _PK_L_(0x12, 0x7A)
#define REG_SC_BK12_7A_H      _PK_H_(0x12, 0x7A)
#define REG_SC_BK12_7B_L      _PK_L_(0x12, 0x7B)
#define REG_SC_BK12_7B_H      _PK_H_(0x12, 0x7B)
#define REG_SC_BK12_7C_L      _PK_L_(0x12, 0x7C)
#define REG_SC_BK12_7C_H      _PK_H_(0x12, 0x7C)
#define REG_SC_BK12_7D_L      _PK_L_(0x12, 0x7D)
#define REG_SC_BK12_7D_H      _PK_H_(0x12, 0x7D)
#define REG_SC_BK12_7E_L      _PK_L_(0x12, 0x7E)
#define REG_SC_BK12_7E_H      _PK_H_(0x12, 0x7E)
#define REG_SC_BK12_7F_L      _PK_L_(0x12, 0x7F)
#define REG_SC_BK12_7F_H      _PK_H_(0x12, 0x7F)

//----------------------------------------------
#define REG_SC_BK13_00_L      _PK_L_(0x13, 0x00)
#define REG_SC_BK13_00_H      _PK_H_(0x13, 0x00)
#define REG_SC_BK13_01_L      _PK_L_(0x13, 0x01)
#define REG_SC_BK13_01_H      _PK_H_(0x13, 0x01)
#define REG_SC_BK13_02_L      _PK_L_(0x13, 0x02)
#define REG_SC_BK13_02_H      _PK_H_(0x13, 0x02)
#define REG_SC_BK13_03_L      _PK_L_(0x13, 0x03)
#define REG_SC_BK13_03_H      _PK_H_(0x13, 0x03)
#define REG_SC_BK13_04_L      _PK_L_(0x13, 0x04)
#define REG_SC_BK13_04_H      _PK_H_(0x13, 0x04)
#define REG_SC_BK13_05_L      _PK_L_(0x13, 0x05)
#define REG_SC_BK13_05_H      _PK_H_(0x13, 0x05)
#define REG_SC_BK13_06_L      _PK_L_(0x13, 0x06)
#define REG_SC_BK13_06_H      _PK_H_(0x13, 0x06)
#define REG_SC_BK13_07_L      _PK_L_(0x13, 0x07)
#define REG_SC_BK13_07_H      _PK_H_(0x13, 0x07)
#define REG_SC_BK13_08_L      _PK_L_(0x13, 0x08)
#define REG_SC_BK13_08_H      _PK_H_(0x13, 0x08)
#define REG_SC_BK13_09_L      _PK_L_(0x13, 0x09)
#define REG_SC_BK13_09_H      _PK_H_(0x13, 0x09)
#define REG_SC_BK13_0A_L      _PK_L_(0x13, 0x0A)
#define REG_SC_BK13_0A_H      _PK_H_(0x13, 0x0A)
#define REG_SC_BK13_0B_L      _PK_L_(0x13, 0x0B)
#define REG_SC_BK13_0B_H      _PK_H_(0x13, 0x0B)
#define REG_SC_BK13_0C_L      _PK_L_(0x13, 0x0C)
#define REG_SC_BK13_0C_H      _PK_H_(0x13, 0x0C)
#define REG_SC_BK13_0D_L      _PK_L_(0x13, 0x0D)
#define REG_SC_BK13_0D_H      _PK_H_(0x13, 0x0D)
#define REG_SC_BK13_0E_L      _PK_L_(0x13, 0x0E)
#define REG_SC_BK13_0E_H      _PK_H_(0x13, 0x0E)
#define REG_SC_BK13_0F_L      _PK_L_(0x13, 0x0F)
#define REG_SC_BK13_0F_H      _PK_H_(0x13, 0x0F)
#define REG_SC_BK13_10_L      _PK_L_(0x13, 0x10)
#define REG_SC_BK13_10_H      _PK_H_(0x13, 0x10)
#define REG_SC_BK13_11_L      _PK_L_(0x13, 0x11)
#define REG_SC_BK13_11_H      _PK_H_(0x13, 0x11)
#define REG_SC_BK13_12_L      _PK_L_(0x13, 0x12)
#define REG_SC_BK13_12_H      _PK_H_(0x13, 0x12)
#define REG_SC_BK13_13_L      _PK_L_(0x13, 0x13)
#define REG_SC_BK13_13_H      _PK_H_(0x13, 0x13)
#define REG_SC_BK13_14_L      _PK_L_(0x13, 0x14)
#define REG_SC_BK13_14_H      _PK_H_(0x13, 0x14)
#define REG_SC_BK13_15_L      _PK_L_(0x13, 0x15)
#define REG_SC_BK13_15_H      _PK_H_(0x13, 0x15)
#define REG_SC_BK13_16_L      _PK_L_(0x13, 0x16)
#define REG_SC_BK13_16_H      _PK_H_(0x13, 0x16)
#define REG_SC_BK13_17_L      _PK_L_(0x13, 0x17)
#define REG_SC_BK13_17_H      _PK_H_(0x13, 0x17)
#define REG_SC_BK13_18_L      _PK_L_(0x13, 0x18)
#define REG_SC_BK13_18_H      _PK_H_(0x13, 0x18)
#define REG_SC_BK13_19_L      _PK_L_(0x13, 0x19)
#define REG_SC_BK13_19_H      _PK_H_(0x13, 0x19)
#define REG_SC_BK13_1A_L      _PK_L_(0x13, 0x1A)
#define REG_SC_BK13_1A_H      _PK_H_(0x13, 0x1A)
#define REG_SC_BK13_1B_L      _PK_L_(0x13, 0x1B)
#define REG_SC_BK13_1B_H      _PK_H_(0x13, 0x1B)
#define REG_SC_BK13_1C_L      _PK_L_(0x13, 0x1C)
#define REG_SC_BK13_1C_H      _PK_H_(0x13, 0x1C)
#define REG_SC_BK13_1D_L      _PK_L_(0x13, 0x1D)
#define REG_SC_BK13_1D_H      _PK_H_(0x13, 0x1D)
#define REG_SC_BK13_1E_L      _PK_L_(0x13, 0x1E)
#define REG_SC_BK13_1E_H      _PK_H_(0x13, 0x1E)
#define REG_SC_BK13_1F_L      _PK_L_(0x13, 0x1F)
#define REG_SC_BK13_1F_H      _PK_H_(0x13, 0x1F)
#define REG_SC_BK13_20_L      _PK_L_(0x13, 0x20)
#define REG_SC_BK13_20_H      _PK_H_(0x13, 0x20)
#define REG_SC_BK13_21_L      _PK_L_(0x13, 0x21)
#define REG_SC_BK13_21_H      _PK_H_(0x13, 0x21)
#define REG_SC_BK13_22_L      _PK_L_(0x13, 0x22)
#define REG_SC_BK13_22_H      _PK_H_(0x13, 0x22)
#define REG_SC_BK13_23_L      _PK_L_(0x13, 0x23)
#define REG_SC_BK13_23_H      _PK_H_(0x13, 0x23)
#define REG_SC_BK13_24_L      _PK_L_(0x13, 0x24)
#define REG_SC_BK13_24_H      _PK_H_(0x13, 0x24)
#define REG_SC_BK13_25_L      _PK_L_(0x13, 0x25)
#define REG_SC_BK13_25_H      _PK_H_(0x13, 0x25)
#define REG_SC_BK13_26_L      _PK_L_(0x13, 0x26)
#define REG_SC_BK13_26_H      _PK_H_(0x13, 0x26)
#define REG_SC_BK13_27_L      _PK_L_(0x13, 0x27)
#define REG_SC_BK13_27_H      _PK_H_(0x13, 0x27)
#define REG_SC_BK13_28_L      _PK_L_(0x13, 0x28)
#define REG_SC_BK13_28_H      _PK_H_(0x13, 0x28)
#define REG_SC_BK13_29_L      _PK_L_(0x13, 0x29)
#define REG_SC_BK13_29_H      _PK_H_(0x13, 0x29)
#define REG_SC_BK13_2A_L      _PK_L_(0x13, 0x2A)
#define REG_SC_BK13_2A_H      _PK_H_(0x13, 0x2A)
#define REG_SC_BK13_2B_L      _PK_L_(0x13, 0x2B)
#define REG_SC_BK13_2B_H      _PK_H_(0x13, 0x2B)
#define REG_SC_BK13_2C_L      _PK_L_(0x13, 0x2C)
#define REG_SC_BK13_2C_H      _PK_H_(0x13, 0x2C)
#define REG_SC_BK13_2D_L      _PK_L_(0x13, 0x2D)
#define REG_SC_BK13_2D_H      _PK_H_(0x13, 0x2D)
#define REG_SC_BK13_2E_L      _PK_L_(0x13, 0x2E)
#define REG_SC_BK13_2E_H      _PK_H_(0x13, 0x2E)
#define REG_SC_BK13_2F_L      _PK_L_(0x13, 0x2F)
#define REG_SC_BK13_2F_H      _PK_H_(0x13, 0x2F)
#define REG_SC_BK13_30_L      _PK_L_(0x13, 0x30)
#define REG_SC_BK13_30_H      _PK_H_(0x13, 0x30)
#define REG_SC_BK13_31_L      _PK_L_(0x13, 0x31)
#define REG_SC_BK13_31_H      _PK_H_(0x13, 0x31)
#define REG_SC_BK13_32_L      _PK_L_(0x13, 0x32)
#define REG_SC_BK13_32_H      _PK_H_(0x13, 0x32)
#define REG_SC_BK13_33_L      _PK_L_(0x13, 0x33)
#define REG_SC_BK13_33_H      _PK_H_(0x13, 0x33)
#define REG_SC_BK13_34_L      _PK_L_(0x13, 0x34)
#define REG_SC_BK13_34_H      _PK_H_(0x13, 0x34)
#define REG_SC_BK13_35_L      _PK_L_(0x13, 0x35)
#define REG_SC_BK13_35_H      _PK_H_(0x13, 0x35)
#define REG_SC_BK13_36_L      _PK_L_(0x13, 0x36)
#define REG_SC_BK13_36_H      _PK_H_(0x13, 0x36)
#define REG_SC_BK13_37_L      _PK_L_(0x13, 0x37)
#define REG_SC_BK13_37_H      _PK_H_(0x13, 0x37)
#define REG_SC_BK13_38_L      _PK_L_(0x13, 0x38)
#define REG_SC_BK13_38_H      _PK_H_(0x13, 0x38)
#define REG_SC_BK13_39_L      _PK_L_(0x13, 0x39)
#define REG_SC_BK13_39_H      _PK_H_(0x13, 0x39)
#define REG_SC_BK13_3A_L      _PK_L_(0x13, 0x3A)
#define REG_SC_BK13_3A_H      _PK_H_(0x13, 0x3A)
#define REG_SC_BK13_3B_L      _PK_L_(0x13, 0x3B)
#define REG_SC_BK13_3B_H      _PK_H_(0x13, 0x3B)
#define REG_SC_BK13_3C_L      _PK_L_(0x13, 0x3C)
#define REG_SC_BK13_3C_H      _PK_H_(0x13, 0x3C)
#define REG_SC_BK13_3D_L      _PK_L_(0x13, 0x3D)
#define REG_SC_BK13_3D_H      _PK_H_(0x13, 0x3D)
#define REG_SC_BK13_3E_L      _PK_L_(0x13, 0x3E)
#define REG_SC_BK13_3E_H      _PK_H_(0x13, 0x3E)
#define REG_SC_BK13_3F_L      _PK_L_(0x13, 0x3F)
#define REG_SC_BK13_3F_H      _PK_H_(0x13, 0x3F)
#define REG_SC_BK13_40_L      _PK_L_(0x13, 0x40)
#define REG_SC_BK13_40_H      _PK_H_(0x13, 0x40)
#define REG_SC_BK13_41_L      _PK_L_(0x13, 0x41)
#define REG_SC_BK13_41_H      _PK_H_(0x13, 0x41)
#define REG_SC_BK13_42_L      _PK_L_(0x13, 0x42)
#define REG_SC_BK13_42_H      _PK_H_(0x13, 0x42)
#define REG_SC_BK13_43_L      _PK_L_(0x13, 0x43)
#define REG_SC_BK13_43_H      _PK_H_(0x13, 0x43)
#define REG_SC_BK13_44_L      _PK_L_(0x13, 0x44)
#define REG_SC_BK13_44_H      _PK_H_(0x13, 0x44)
#define REG_SC_BK13_45_L      _PK_L_(0x13, 0x45)
#define REG_SC_BK13_45_H      _PK_H_(0x13, 0x45)
#define REG_SC_BK13_46_L      _PK_L_(0x13, 0x46)
#define REG_SC_BK13_46_H      _PK_H_(0x13, 0x46)
#define REG_SC_BK13_47_L      _PK_L_(0x13, 0x47)
#define REG_SC_BK13_47_H      _PK_H_(0x13, 0x47)
#define REG_SC_BK13_48_L      _PK_L_(0x13, 0x48)
#define REG_SC_BK13_48_H      _PK_H_(0x13, 0x48)
#define REG_SC_BK13_49_L      _PK_L_(0x13, 0x49)
#define REG_SC_BK13_49_H      _PK_H_(0x13, 0x49)
#define REG_SC_BK13_4A_L      _PK_L_(0x13, 0x4A)
#define REG_SC_BK13_4A_H      _PK_H_(0x13, 0x4A)
#define REG_SC_BK13_4B_L      _PK_L_(0x13, 0x4B)
#define REG_SC_BK13_4B_H      _PK_H_(0x13, 0x4B)
#define REG_SC_BK13_4C_L      _PK_L_(0x13, 0x4C)
#define REG_SC_BK13_4C_H      _PK_H_(0x13, 0x4C)
#define REG_SC_BK13_4D_L      _PK_L_(0x13, 0x4D)
#define REG_SC_BK13_4D_H      _PK_H_(0x13, 0x4D)
#define REG_SC_BK13_4E_L      _PK_L_(0x13, 0x4E)
#define REG_SC_BK13_4E_H      _PK_H_(0x13, 0x4E)
#define REG_SC_BK13_4F_L      _PK_L_(0x13, 0x4F)
#define REG_SC_BK13_4F_H      _PK_H_(0x13, 0x4F)
#define REG_SC_BK13_50_L      _PK_L_(0x13, 0x50)
#define REG_SC_BK13_50_H      _PK_H_(0x13, 0x50)
#define REG_SC_BK13_51_L      _PK_L_(0x13, 0x51)
#define REG_SC_BK13_51_H      _PK_H_(0x13, 0x51)
#define REG_SC_BK13_52_L      _PK_L_(0x13, 0x52)
#define REG_SC_BK13_52_H      _PK_H_(0x13, 0x52)
#define REG_SC_BK13_53_L      _PK_L_(0x13, 0x53)
#define REG_SC_BK13_53_H      _PK_H_(0x13, 0x53)
#define REG_SC_BK13_54_L      _PK_L_(0x13, 0x54)
#define REG_SC_BK13_54_H      _PK_H_(0x13, 0x54)
#define REG_SC_BK13_55_L      _PK_L_(0x13, 0x55)
#define REG_SC_BK13_55_H      _PK_H_(0x13, 0x55)
#define REG_SC_BK13_56_L      _PK_L_(0x13, 0x56)
#define REG_SC_BK13_56_H      _PK_H_(0x13, 0x56)
#define REG_SC_BK13_57_L      _PK_L_(0x13, 0x57)
#define REG_SC_BK13_57_H      _PK_H_(0x13, 0x57)
#define REG_SC_BK13_58_L      _PK_L_(0x13, 0x58)
#define REG_SC_BK13_58_H      _PK_H_(0x13, 0x58)
#define REG_SC_BK13_59_L      _PK_L_(0x13, 0x59)
#define REG_SC_BK13_59_H      _PK_H_(0x13, 0x59)
#define REG_SC_BK13_5A_L      _PK_L_(0x13, 0x5A)
#define REG_SC_BK13_5A_H      _PK_H_(0x13, 0x5A)
#define REG_SC_BK13_5B_L      _PK_L_(0x13, 0x5B)
#define REG_SC_BK13_5B_H      _PK_H_(0x13, 0x5B)
#define REG_SC_BK13_5C_L      _PK_L_(0x13, 0x5C)
#define REG_SC_BK13_5C_H      _PK_H_(0x13, 0x5C)
#define REG_SC_BK13_5D_L      _PK_L_(0x13, 0x5D)
#define REG_SC_BK13_5D_H      _PK_H_(0x13, 0x5D)
#define REG_SC_BK13_5E_L      _PK_L_(0x13, 0x5E)
#define REG_SC_BK13_5E_H      _PK_H_(0x13, 0x5E)
#define REG_SC_BK13_5F_L      _PK_L_(0x13, 0x5F)
#define REG_SC_BK13_5F_H      _PK_H_(0x13, 0x5F)
#define REG_SC_BK13_60_L      _PK_L_(0x13, 0x60)
#define REG_SC_BK13_60_H      _PK_H_(0x13, 0x60)
#define REG_SC_BK13_61_L      _PK_L_(0x13, 0x61)
#define REG_SC_BK13_61_H      _PK_H_(0x13, 0x61)
#define REG_SC_BK13_62_L      _PK_L_(0x13, 0x62)
#define REG_SC_BK13_62_H      _PK_H_(0x13, 0x62)
#define REG_SC_BK13_63_L      _PK_L_(0x13, 0x63)
#define REG_SC_BK13_63_H      _PK_H_(0x13, 0x63)
#define REG_SC_BK13_64_L      _PK_L_(0x13, 0x64)
#define REG_SC_BK13_64_H      _PK_H_(0x13, 0x64)
#define REG_SC_BK13_65_L      _PK_L_(0x13, 0x65)
#define REG_SC_BK13_65_H      _PK_H_(0x13, 0x65)
#define REG_SC_BK13_66_L      _PK_L_(0x13, 0x66)
#define REG_SC_BK13_66_H      _PK_H_(0x13, 0x66)
#define REG_SC_BK13_67_L      _PK_L_(0x13, 0x67)
#define REG_SC_BK13_67_H      _PK_H_(0x13, 0x67)
#define REG_SC_BK13_68_L      _PK_L_(0x13, 0x68)
#define REG_SC_BK13_68_H      _PK_H_(0x13, 0x68)
#define REG_SC_BK13_69_L      _PK_L_(0x13, 0x69)
#define REG_SC_BK13_69_H      _PK_H_(0x13, 0x69)
#define REG_SC_BK13_6A_L      _PK_L_(0x13, 0x6A)
#define REG_SC_BK13_6A_H      _PK_H_(0x13, 0x6A)
#define REG_SC_BK13_6B_L      _PK_L_(0x13, 0x6B)
#define REG_SC_BK13_6B_H      _PK_H_(0x13, 0x6B)
#define REG_SC_BK13_6C_L      _PK_L_(0x13, 0x6C)
#define REG_SC_BK13_6C_H      _PK_H_(0x13, 0x6C)
#define REG_SC_BK13_6D_L      _PK_L_(0x13, 0x6D)
#define REG_SC_BK13_6D_H      _PK_H_(0x13, 0x6D)
#define REG_SC_BK13_6E_L      _PK_L_(0x13, 0x6E)
#define REG_SC_BK13_6E_H      _PK_H_(0x13, 0x6E)
#define REG_SC_BK13_6F_L      _PK_L_(0x13, 0x6F)
#define REG_SC_BK13_6F_H      _PK_H_(0x13, 0x6F)
#define REG_SC_BK13_70_L      _PK_L_(0x13, 0x70)
#define REG_SC_BK13_70_H      _PK_H_(0x13, 0x70)
#define REG_SC_BK13_71_L      _PK_L_(0x13, 0x71)
#define REG_SC_BK13_71_H      _PK_H_(0x13, 0x71)
#define REG_SC_BK13_72_L      _PK_L_(0x13, 0x72)
#define REG_SC_BK13_72_H      _PK_H_(0x13, 0x72)
#define REG_SC_BK13_73_L      _PK_L_(0x13, 0x73)
#define REG_SC_BK13_73_H      _PK_H_(0x13, 0x73)
#define REG_SC_BK13_74_L      _PK_L_(0x13, 0x74)
#define REG_SC_BK13_74_H      _PK_H_(0x13, 0x74)
#define REG_SC_BK13_75_L      _PK_L_(0x13, 0x75)
#define REG_SC_BK13_75_H      _PK_H_(0x13, 0x75)
#define REG_SC_BK13_76_L      _PK_L_(0x13, 0x76)
#define REG_SC_BK13_76_H      _PK_H_(0x13, 0x76)
#define REG_SC_BK13_77_L      _PK_L_(0x13, 0x77)
#define REG_SC_BK13_77_H      _PK_H_(0x13, 0x77)
#define REG_SC_BK13_78_L      _PK_L_(0x13, 0x78)
#define REG_SC_BK13_78_H      _PK_H_(0x13, 0x78)
#define REG_SC_BK13_79_L      _PK_L_(0x13, 0x79)
#define REG_SC_BK13_79_H      _PK_H_(0x13, 0x79)
#define REG_SC_BK13_7A_L      _PK_L_(0x13, 0x7A)
#define REG_SC_BK13_7A_H      _PK_H_(0x13, 0x7A)
#define REG_SC_BK13_7B_L      _PK_L_(0x13, 0x7B)
#define REG_SC_BK13_7B_H      _PK_H_(0x13, 0x7B)
#define REG_SC_BK13_7C_L      _PK_L_(0x13, 0x7C)
#define REG_SC_BK13_7C_H      _PK_H_(0x13, 0x7C)
#define REG_SC_BK13_7D_L      _PK_L_(0x13, 0x7D)
#define REG_SC_BK13_7D_H      _PK_H_(0x13, 0x7D)
#define REG_SC_BK13_7E_L      _PK_L_(0x13, 0x7E)
#define REG_SC_BK13_7E_H      _PK_H_(0x13, 0x7E)
#define REG_SC_BK13_7F_L      _PK_L_(0x13, 0x7F)
#define REG_SC_BK13_7F_H      _PK_H_(0x13, 0x7F)

//----------------------------------------------
//  BK15: 2D23D
//----------------------------------------------
#define REG_SC_BK15_00_L      _PK_L_(0x15, 0x00)
#define REG_SC_BK15_00_H      _PK_H_(0x15, 0x00)
#define REG_SC_BK15_01_L      _PK_L_(0x15, 0x01)
#define REG_SC_BK15_01_H      _PK_H_(0x15, 0x01)
#define REG_SC_BK15_02_L      _PK_L_(0x15, 0x02)
#define REG_SC_BK15_02_H      _PK_H_(0x15, 0x02)
#define REG_SC_BK15_03_L      _PK_L_(0x15, 0x03)
#define REG_SC_BK15_03_H      _PK_H_(0x15, 0x03)
#define REG_SC_BK15_04_L      _PK_L_(0x15, 0x04)
#define REG_SC_BK15_04_H      _PK_H_(0x15, 0x04)
#define REG_SC_BK15_05_L      _PK_L_(0x15, 0x05)
#define REG_SC_BK15_05_H      _PK_H_(0x15, 0x05)
#define REG_SC_BK15_06_L      _PK_L_(0x15, 0x06)
#define REG_SC_BK15_06_H      _PK_H_(0x15, 0x06)
#define REG_SC_BK15_07_L      _PK_L_(0x15, 0x07)
#define REG_SC_BK15_07_H      _PK_H_(0x15, 0x07)
#define REG_SC_BK15_08_L      _PK_L_(0x15, 0x08)
#define REG_SC_BK15_08_H      _PK_H_(0x15, 0x08)
#define REG_SC_BK15_09_L      _PK_L_(0x15, 0x09)
#define REG_SC_BK15_09_H      _PK_H_(0x15, 0x09)
#define REG_SC_BK15_0A_L      _PK_L_(0x15, 0x0A)
#define REG_SC_BK15_0A_H      _PK_H_(0x15, 0x0A)
#define REG_SC_BK15_0B_L      _PK_L_(0x15, 0x0B)
#define REG_SC_BK15_0B_H      _PK_H_(0x15, 0x0B)
#define REG_SC_BK15_0C_L      _PK_L_(0x15, 0x0C)
#define REG_SC_BK15_0C_H      _PK_H_(0x15, 0x0C)
#define REG_SC_BK15_0D_L      _PK_L_(0x15, 0x0D)
#define REG_SC_BK15_0D_H      _PK_H_(0x15, 0x0D)
#define REG_SC_BK15_0E_L      _PK_L_(0x15, 0x0E)
#define REG_SC_BK15_0E_H      _PK_H_(0x15, 0x0E)
#define REG_SC_BK15_0F_L      _PK_L_(0x15, 0x0F)
#define REG_SC_BK15_0F_H      _PK_H_(0x15, 0x0F)
#define REG_SC_BK15_10_L      _PK_L_(0x15, 0x10)
#define REG_SC_BK15_10_H      _PK_H_(0x15, 0x10)
#define REG_SC_BK15_11_L      _PK_L_(0x15, 0x11)
#define REG_SC_BK15_11_H      _PK_H_(0x15, 0x11)
#define REG_SC_BK15_12_L      _PK_L_(0x15, 0x12)
#define REG_SC_BK15_12_H      _PK_H_(0x15, 0x12)
#define REG_SC_BK15_13_L      _PK_L_(0x15, 0x13)
#define REG_SC_BK15_13_H      _PK_H_(0x15, 0x13)
#define REG_SC_BK15_14_L      _PK_L_(0x15, 0x14)
#define REG_SC_BK15_14_H      _PK_H_(0x15, 0x14)
#define REG_SC_BK15_15_L      _PK_L_(0x15, 0x15)
#define REG_SC_BK15_15_H      _PK_H_(0x15, 0x15)
#define REG_SC_BK15_16_L      _PK_L_(0x15, 0x16)
#define REG_SC_BK15_16_H      _PK_H_(0x15, 0x16)
#define REG_SC_BK15_17_L      _PK_L_(0x15, 0x17)
#define REG_SC_BK15_17_H      _PK_H_(0x15, 0x17)
#define REG_SC_BK15_18_L      _PK_L_(0x15, 0x18)
#define REG_SC_BK15_18_H      _PK_H_(0x15, 0x18)
#define REG_SC_BK15_19_L      _PK_L_(0x15, 0x19)
#define REG_SC_BK15_19_H      _PK_H_(0x15, 0x19)
#define REG_SC_BK15_1A_L      _PK_L_(0x15, 0x1A)
#define REG_SC_BK15_1A_H      _PK_H_(0x15, 0x1A)
#define REG_SC_BK15_1B_L      _PK_L_(0x15, 0x1B)
#define REG_SC_BK15_1B_H      _PK_H_(0x15, 0x1B)
#define REG_SC_BK15_1C_L      _PK_L_(0x15, 0x1C)
#define REG_SC_BK15_1C_H      _PK_H_(0x15, 0x1C)
#define REG_SC_BK15_1D_L      _PK_L_(0x15, 0x1D)
#define REG_SC_BK15_1D_H      _PK_H_(0x15, 0x1D)
#define REG_SC_BK15_1E_L      _PK_L_(0x15, 0x1E)
#define REG_SC_BK15_1E_H      _PK_H_(0x15, 0x1E)
#define REG_SC_BK15_1F_L      _PK_L_(0x15, 0x1F)
#define REG_SC_BK15_1F_H      _PK_H_(0x15, 0x1F)
#define REG_SC_BK15_20_L      _PK_L_(0x15, 0x20)
#define REG_SC_BK15_20_H      _PK_H_(0x15, 0x20)
#define REG_SC_BK15_21_L      _PK_L_(0x15, 0x21)
#define REG_SC_BK15_21_H      _PK_H_(0x15, 0x21)
#define REG_SC_BK15_22_L      _PK_L_(0x15, 0x22)
#define REG_SC_BK15_22_H      _PK_H_(0x15, 0x22)
#define REG_SC_BK15_23_L      _PK_L_(0x15, 0x23)
#define REG_SC_BK15_23_H      _PK_H_(0x15, 0x23)
#define REG_SC_BK15_24_L      _PK_L_(0x15, 0x24)
#define REG_SC_BK15_24_H      _PK_H_(0x15, 0x24)
#define REG_SC_BK15_25_L      _PK_L_(0x15, 0x25)
#define REG_SC_BK15_25_H      _PK_H_(0x15, 0x25)
#define REG_SC_BK15_26_L      _PK_L_(0x15, 0x26)
#define REG_SC_BK15_26_H      _PK_H_(0x15, 0x26)
#define REG_SC_BK15_27_L      _PK_L_(0x15, 0x27)
#define REG_SC_BK15_27_H      _PK_H_(0x15, 0x27)
#define REG_SC_BK15_28_L      _PK_L_(0x15, 0x28)
#define REG_SC_BK15_28_H      _PK_H_(0x15, 0x28)
#define REG_SC_BK15_29_L      _PK_L_(0x15, 0x29)
#define REG_SC_BK15_29_H      _PK_H_(0x15, 0x29)
#define REG_SC_BK15_2A_L      _PK_L_(0x15, 0x2A)
#define REG_SC_BK15_2A_H      _PK_H_(0x15, 0x2A)
#define REG_SC_BK15_2B_L      _PK_L_(0x15, 0x2B)
#define REG_SC_BK15_2B_H      _PK_H_(0x15, 0x2B)
#define REG_SC_BK15_2C_L      _PK_L_(0x15, 0x2C)
#define REG_SC_BK15_2C_H      _PK_H_(0x15, 0x2C)
#define REG_SC_BK15_2D_L      _PK_L_(0x15, 0x2D)
#define REG_SC_BK15_2D_H      _PK_H_(0x15, 0x2D)
#define REG_SC_BK15_2E_L      _PK_L_(0x15, 0x2E)
#define REG_SC_BK15_2E_H      _PK_H_(0x15, 0x2E)
#define REG_SC_BK15_2F_L      _PK_L_(0x15, 0x2F)
#define REG_SC_BK15_2F_H      _PK_H_(0x15, 0x2F)
#define REG_SC_BK15_30_L      _PK_L_(0x15, 0x30)
#define REG_SC_BK15_30_H      _PK_H_(0x15, 0x30)
#define REG_SC_BK15_31_L      _PK_L_(0x15, 0x31)
#define REG_SC_BK15_31_H      _PK_H_(0x15, 0x31)
#define REG_SC_BK15_32_L      _PK_L_(0x15, 0x32)
#define REG_SC_BK15_32_H      _PK_H_(0x15, 0x32)
#define REG_SC_BK15_33_L      _PK_L_(0x15, 0x33)
#define REG_SC_BK15_33_H      _PK_H_(0x15, 0x33)
#define REG_SC_BK15_34_L      _PK_L_(0x15, 0x34)
#define REG_SC_BK15_34_H      _PK_H_(0x15, 0x34)
#define REG_SC_BK15_35_L      _PK_L_(0x15, 0x35)
#define REG_SC_BK15_35_H      _PK_H_(0x15, 0x35)
#define REG_SC_BK15_36_L      _PK_L_(0x15, 0x36)
#define REG_SC_BK15_36_H      _PK_H_(0x15, 0x36)
#define REG_SC_BK15_37_L      _PK_L_(0x15, 0x37)
#define REG_SC_BK15_37_H      _PK_H_(0x15, 0x37)
#define REG_SC_BK15_38_L      _PK_L_(0x15, 0x38)
#define REG_SC_BK15_38_H      _PK_H_(0x15, 0x38)
#define REG_SC_BK15_39_L      _PK_L_(0x15, 0x39)
#define REG_SC_BK15_39_H      _PK_H_(0x15, 0x39)
#define REG_SC_BK15_3A_L      _PK_L_(0x15, 0x3A)
#define REG_SC_BK15_3A_H      _PK_H_(0x15, 0x3A)
#define REG_SC_BK15_3B_L      _PK_L_(0x15, 0x3B)
#define REG_SC_BK15_3B_H      _PK_H_(0x15, 0x3B)
#define REG_SC_BK15_3C_L      _PK_L_(0x15, 0x3C)
#define REG_SC_BK15_3C_H      _PK_H_(0x15, 0x3C)
#define REG_SC_BK15_3D_L      _PK_L_(0x15, 0x3D)
#define REG_SC_BK15_3D_H      _PK_H_(0x15, 0x3D)
#define REG_SC_BK15_3E_L      _PK_L_(0x15, 0x3E)
#define REG_SC_BK15_3E_H      _PK_H_(0x15, 0x3E)
#define REG_SC_BK15_3F_L      _PK_L_(0x15, 0x3F)
#define REG_SC_BK15_3F_H      _PK_H_(0x15, 0x3F)
#define REG_SC_BK15_40_L      _PK_L_(0x15, 0x40)
#define REG_SC_BK15_40_H      _PK_H_(0x15, 0x40)
#define REG_SC_BK15_41_L      _PK_L_(0x15, 0x41)
#define REG_SC_BK15_41_H      _PK_H_(0x15, 0x41)
#define REG_SC_BK15_42_L      _PK_L_(0x15, 0x42)
#define REG_SC_BK15_42_H      _PK_H_(0x15, 0x42)
#define REG_SC_BK15_43_L      _PK_L_(0x15, 0x43)
#define REG_SC_BK15_43_H      _PK_H_(0x15, 0x43)
#define REG_SC_BK15_44_L      _PK_L_(0x15, 0x44)
#define REG_SC_BK15_44_H      _PK_H_(0x15, 0x44)
#define REG_SC_BK15_45_L      _PK_L_(0x15, 0x45)
#define REG_SC_BK15_45_H      _PK_H_(0x15, 0x45)
#define REG_SC_BK15_46_L      _PK_L_(0x15, 0x46)
#define REG_SC_BK15_46_H      _PK_H_(0x15, 0x46)
#define REG_SC_BK15_47_L      _PK_L_(0x15, 0x47)
#define REG_SC_BK15_47_H      _PK_H_(0x15, 0x47)
#define REG_SC_BK15_48_L      _PK_L_(0x15, 0x48)
#define REG_SC_BK15_48_H      _PK_H_(0x15, 0x48)
#define REG_SC_BK15_49_L      _PK_L_(0x15, 0x49)
#define REG_SC_BK15_49_H      _PK_H_(0x15, 0x49)
#define REG_SC_BK15_4A_L      _PK_L_(0x15, 0x4A)
#define REG_SC_BK15_4A_H      _PK_H_(0x15, 0x4A)
#define REG_SC_BK15_4B_L      _PK_L_(0x15, 0x4B)
#define REG_SC_BK15_4B_H      _PK_H_(0x15, 0x4B)
#define REG_SC_BK15_4C_L      _PK_L_(0x15, 0x4C)
#define REG_SC_BK15_4C_H      _PK_H_(0x15, 0x4C)
#define REG_SC_BK15_4D_L      _PK_L_(0x15, 0x4D)
#define REG_SC_BK15_4D_H      _PK_H_(0x15, 0x4D)
#define REG_SC_BK15_4E_L      _PK_L_(0x15, 0x4E)
#define REG_SC_BK15_4E_H      _PK_H_(0x15, 0x4E)
#define REG_SC_BK15_4F_L      _PK_L_(0x15, 0x4F)
#define REG_SC_BK15_4F_H      _PK_H_(0x15, 0x4F)
#define REG_SC_BK15_50_L      _PK_L_(0x15, 0x50)
#define REG_SC_BK15_50_H      _PK_H_(0x15, 0x50)
#define REG_SC_BK15_51_L      _PK_L_(0x15, 0x51)
#define REG_SC_BK15_51_H      _PK_H_(0x15, 0x51)
#define REG_SC_BK15_52_L      _PK_L_(0x15, 0x52)
#define REG_SC_BK15_52_H      _PK_H_(0x15, 0x52)
#define REG_SC_BK15_53_L      _PK_L_(0x15, 0x53)
#define REG_SC_BK15_53_H      _PK_H_(0x15, 0x53)
#define REG_SC_BK15_54_L      _PK_L_(0x15, 0x54)
#define REG_SC_BK15_54_H      _PK_H_(0x15, 0x54)
#define REG_SC_BK15_55_L      _PK_L_(0x15, 0x55)
#define REG_SC_BK15_55_H      _PK_H_(0x15, 0x55)
#define REG_SC_BK15_56_L      _PK_L_(0x15, 0x56)
#define REG_SC_BK15_56_H      _PK_H_(0x15, 0x56)
#define REG_SC_BK15_57_L      _PK_L_(0x15, 0x57)
#define REG_SC_BK15_57_H      _PK_H_(0x15, 0x57)
#define REG_SC_BK15_58_L      _PK_L_(0x15, 0x58)
#define REG_SC_BK15_58_H      _PK_H_(0x15, 0x58)
#define REG_SC_BK15_59_L      _PK_L_(0x15, 0x59)
#define REG_SC_BK15_59_H      _PK_H_(0x15, 0x59)
#define REG_SC_BK15_5A_L      _PK_L_(0x15, 0x5A)
#define REG_SC_BK15_5A_H      _PK_H_(0x15, 0x5A)
#define REG_SC_BK15_5B_L      _PK_L_(0x15, 0x5B)
#define REG_SC_BK15_5B_H      _PK_H_(0x15, 0x5B)
#define REG_SC_BK15_5C_L      _PK_L_(0x15, 0x5C)
#define REG_SC_BK15_5C_H      _PK_H_(0x15, 0x5C)
#define REG_SC_BK15_5D_L      _PK_L_(0x15, 0x5D)
#define REG_SC_BK15_5D_H      _PK_H_(0x15, 0x5D)
#define REG_SC_BK15_5E_L      _PK_L_(0x15, 0x5E)
#define REG_SC_BK15_5E_H      _PK_H_(0x15, 0x5E)
#define REG_SC_BK15_5F_L      _PK_L_(0x15, 0x5F)
#define REG_SC_BK15_5F_H      _PK_H_(0x15, 0x5F)
#define REG_SC_BK15_60_L      _PK_L_(0x15, 0x60)
#define REG_SC_BK15_60_H      _PK_H_(0x15, 0x60)
#define REG_SC_BK15_61_L      _PK_L_(0x15, 0x61)
#define REG_SC_BK15_61_H      _PK_H_(0x15, 0x61)
#define REG_SC_BK15_62_L      _PK_L_(0x15, 0x62)
#define REG_SC_BK15_62_H      _PK_H_(0x15, 0x62)
#define REG_SC_BK15_63_L      _PK_L_(0x15, 0x63)
#define REG_SC_BK15_63_H      _PK_H_(0x15, 0x63)
#define REG_SC_BK15_64_L      _PK_L_(0x15, 0x64)
#define REG_SC_BK15_64_H      _PK_H_(0x15, 0x64)
#define REG_SC_BK15_65_L      _PK_L_(0x15, 0x65)
#define REG_SC_BK15_65_H      _PK_H_(0x15, 0x65)
#define REG_SC_BK15_66_L      _PK_L_(0x15, 0x66)
#define REG_SC_BK15_66_H      _PK_H_(0x15, 0x66)
#define REG_SC_BK15_67_L      _PK_L_(0x15, 0x67)
#define REG_SC_BK15_67_H      _PK_H_(0x15, 0x67)
#define REG_SC_BK15_68_L      _PK_L_(0x15, 0x68)
#define REG_SC_BK15_68_H      _PK_H_(0x15, 0x68)
#define REG_SC_BK15_69_L      _PK_L_(0x15, 0x69)
#define REG_SC_BK15_69_H      _PK_H_(0x15, 0x69)
#define REG_SC_BK15_6A_L      _PK_L_(0x15, 0x6A)
#define REG_SC_BK15_6A_H      _PK_H_(0x15, 0x6A)
#define REG_SC_BK15_6B_L      _PK_L_(0x15, 0x6B)
#define REG_SC_BK15_6B_H      _PK_H_(0x15, 0x6B)
#define REG_SC_BK15_6C_L      _PK_L_(0x15, 0x6C)
#define REG_SC_BK15_6C_H      _PK_H_(0x15, 0x6C)
#define REG_SC_BK15_6D_L      _PK_L_(0x15, 0x6D)
#define REG_SC_BK15_6D_H      _PK_H_(0x15, 0x6D)
#define REG_SC_BK15_6E_L      _PK_L_(0x15, 0x6E)
#define REG_SC_BK15_6E_H      _PK_H_(0x15, 0x6E)
#define REG_SC_BK15_6F_L      _PK_L_(0x15, 0x6F)
#define REG_SC_BK15_6F_H      _PK_H_(0x15, 0x6F)
#define REG_SC_BK15_70_L      _PK_L_(0x15, 0x70)
#define REG_SC_BK15_70_H      _PK_H_(0x15, 0x70)
#define REG_SC_BK15_71_L      _PK_L_(0x15, 0x71)
#define REG_SC_BK15_71_H      _PK_H_(0x15, 0x71)
#define REG_SC_BK15_72_L      _PK_L_(0x15, 0x72)
#define REG_SC_BK15_72_H      _PK_H_(0x15, 0x72)
#define REG_SC_BK15_73_L      _PK_L_(0x15, 0x73)
#define REG_SC_BK15_73_H      _PK_H_(0x15, 0x73)
#define REG_SC_BK15_74_L      _PK_L_(0x15, 0x74)
#define REG_SC_BK15_74_H      _PK_H_(0x15, 0x74)
#define REG_SC_BK15_75_L      _PK_L_(0x15, 0x75)
#define REG_SC_BK15_75_H      _PK_H_(0x15, 0x75)
#define REG_SC_BK15_76_L      _PK_L_(0x15, 0x76)
#define REG_SC_BK15_76_H      _PK_H_(0x15, 0x76)
#define REG_SC_BK15_77_L      _PK_L_(0x15, 0x77)
#define REG_SC_BK15_77_H      _PK_H_(0x15, 0x77)
#define REG_SC_BK15_78_L      _PK_L_(0x15, 0x78)
#define REG_SC_BK15_78_H      _PK_H_(0x15, 0x78)
#define REG_SC_BK15_79_L      _PK_L_(0x15, 0x79)
#define REG_SC_BK15_79_H      _PK_H_(0x15, 0x79)
#define REG_SC_BK15_7A_L      _PK_L_(0x15, 0x7A)
#define REG_SC_BK15_7A_H      _PK_H_(0x15, 0x7A)
#define REG_SC_BK15_7B_L      _PK_L_(0x15, 0x7B)
#define REG_SC_BK15_7B_H      _PK_H_(0x15, 0x7B)
#define REG_SC_BK15_7C_L      _PK_L_(0x15, 0x7C)
#define REG_SC_BK15_7C_H      _PK_H_(0x15, 0x7C)
#define REG_SC_BK15_7D_L      _PK_L_(0x15, 0x7D)
#define REG_SC_BK15_7D_H      _PK_H_(0x15, 0x7D)
#define REG_SC_BK15_7E_L      _PK_L_(0x15, 0x7E)
#define REG_SC_BK15_7E_H      _PK_H_(0x15, 0x7E)
#define REG_SC_BK15_7F_L      _PK_L_(0x15, 0x7F)
#define REG_SC_BK15_7F_H      _PK_H_(0x15, 0x7F)

//----------------------------------------------
//  BK17: SRAM
//----------------------------------------------
#define REG_SC_BK17_00_L      _PK_L_(0x17, 0x00)
#define REG_SC_BK17_00_H      _PK_H_(0x17, 0x00)
#define REG_SC_BK17_01_L      _PK_L_(0x17, 0x01)
#define REG_SC_BK17_01_H      _PK_H_(0x17, 0x01)
#define REG_SC_BK17_02_L      _PK_L_(0x17, 0x02)
#define REG_SC_BK17_02_H      _PK_H_(0x17, 0x02)
#define REG_SC_BK17_03_L      _PK_L_(0x17, 0x03)
#define REG_SC_BK17_03_H      _PK_H_(0x17, 0x03)
#define REG_SC_BK17_04_L      _PK_L_(0x17, 0x04)
#define REG_SC_BK17_04_H      _PK_H_(0x17, 0x04)
#define REG_SC_BK17_05_L      _PK_L_(0x17, 0x05)
#define REG_SC_BK17_05_H      _PK_H_(0x17, 0x05)
#define REG_SC_BK17_06_L      _PK_L_(0x17, 0x06)
#define REG_SC_BK17_06_H      _PK_H_(0x17, 0x06)
#define REG_SC_BK17_07_L      _PK_L_(0x17, 0x07)
#define REG_SC_BK17_07_H      _PK_H_(0x17, 0x07)
#define REG_SC_BK17_08_L      _PK_L_(0x17, 0x08)
#define REG_SC_BK17_08_H      _PK_H_(0x17, 0x08)
#define REG_SC_BK17_09_L      _PK_L_(0x17, 0x09)
#define REG_SC_BK17_09_H      _PK_H_(0x17, 0x09)
#define REG_SC_BK17_0A_L      _PK_L_(0x17, 0x0A)
#define REG_SC_BK17_0A_H      _PK_H_(0x17, 0x0A)
#define REG_SC_BK17_0B_L      _PK_L_(0x17, 0x0B)
#define REG_SC_BK17_0B_H      _PK_H_(0x17, 0x0B)
#define REG_SC_BK17_0C_L      _PK_L_(0x17, 0x0C)
#define REG_SC_BK17_0C_H      _PK_H_(0x17, 0x0C)
#define REG_SC_BK17_0D_L      _PK_L_(0x17, 0x0D)
#define REG_SC_BK17_0D_H      _PK_H_(0x17, 0x0D)
#define REG_SC_BK17_0E_L      _PK_L_(0x17, 0x0E)
#define REG_SC_BK17_0E_H      _PK_H_(0x17, 0x0E)
#define REG_SC_BK17_0F_L      _PK_L_(0x17, 0x0F)
#define REG_SC_BK17_0F_H      _PK_H_(0x17, 0x0F)
#define REG_SC_BK17_10_L      _PK_L_(0x17, 0x10)
#define REG_SC_BK17_10_H      _PK_H_(0x17, 0x10)
#define REG_SC_BK17_11_L      _PK_L_(0x17, 0x11)
#define REG_SC_BK17_11_H      _PK_H_(0x17, 0x11)
#define REG_SC_BK17_12_L      _PK_L_(0x17, 0x12)
#define REG_SC_BK17_12_H      _PK_H_(0x17, 0x12)
#define REG_SC_BK17_13_L      _PK_L_(0x17, 0x13)
#define REG_SC_BK17_13_H      _PK_H_(0x17, 0x13)
#define REG_SC_BK17_14_L      _PK_L_(0x17, 0x14)
#define REG_SC_BK17_14_H      _PK_H_(0x17, 0x14)
#define REG_SC_BK17_15_L      _PK_L_(0x17, 0x15)
#define REG_SC_BK17_15_H      _PK_H_(0x17, 0x15)
#define REG_SC_BK17_16_L      _PK_L_(0x17, 0x16)
#define REG_SC_BK17_16_H      _PK_H_(0x17, 0x16)
#define REG_SC_BK17_17_L      _PK_L_(0x17, 0x17)
#define REG_SC_BK17_17_H      _PK_H_(0x17, 0x17)
#define REG_SC_BK17_18_L      _PK_L_(0x17, 0x18)
#define REG_SC_BK17_18_H      _PK_H_(0x17, 0x18)
#define REG_SC_BK17_19_L      _PK_L_(0x17, 0x19)
#define REG_SC_BK17_19_H      _PK_H_(0x17, 0x19)
#define REG_SC_BK17_1A_L      _PK_L_(0x17, 0x1A)
#define REG_SC_BK17_1A_H      _PK_H_(0x17, 0x1A)
#define REG_SC_BK17_1B_L      _PK_L_(0x17, 0x1B)
#define REG_SC_BK17_1B_H      _PK_H_(0x17, 0x1B)
#define REG_SC_BK17_1C_L      _PK_L_(0x17, 0x1C)
#define REG_SC_BK17_1C_H      _PK_H_(0x17, 0x1C)
#define REG_SC_BK17_1D_L      _PK_L_(0x17, 0x1D)
#define REG_SC_BK17_1D_H      _PK_H_(0x17, 0x1D)
#define REG_SC_BK17_1E_L      _PK_L_(0x17, 0x1E)
#define REG_SC_BK17_1E_H      _PK_H_(0x17, 0x1E)
#define REG_SC_BK17_1F_L      _PK_L_(0x17, 0x1F)
#define REG_SC_BK17_1F_H      _PK_H_(0x17, 0x1F)
#define REG_SC_BK17_20_L      _PK_L_(0x17, 0x20)
#define REG_SC_BK17_20_H      _PK_H_(0x17, 0x20)
#define REG_SC_BK17_21_L      _PK_L_(0x17, 0x21)
#define REG_SC_BK17_21_H      _PK_H_(0x17, 0x21)
#define REG_SC_BK17_22_L      _PK_L_(0x17, 0x22)
#define REG_SC_BK17_22_H      _PK_H_(0x17, 0x22)
#define REG_SC_BK17_23_L      _PK_L_(0x17, 0x23)
#define REG_SC_BK17_23_H      _PK_H_(0x17, 0x23)
#define REG_SC_BK17_24_L      _PK_L_(0x17, 0x24)
#define REG_SC_BK17_24_H      _PK_H_(0x17, 0x24)
#define REG_SC_BK17_25_L      _PK_L_(0x17, 0x25)
#define REG_SC_BK17_25_H      _PK_H_(0x17, 0x25)
#define REG_SC_BK17_26_L      _PK_L_(0x17, 0x26)
#define REG_SC_BK17_26_H      _PK_H_(0x17, 0x26)
#define REG_SC_BK17_27_L      _PK_L_(0x17, 0x27)
#define REG_SC_BK17_27_H      _PK_H_(0x17, 0x27)
#define REG_SC_BK17_28_L      _PK_L_(0x17, 0x28)
#define REG_SC_BK17_28_H      _PK_H_(0x17, 0x28)
#define REG_SC_BK17_29_L      _PK_L_(0x17, 0x29)
#define REG_SC_BK17_29_H      _PK_H_(0x17, 0x29)
#define REG_SC_BK17_2A_L      _PK_L_(0x17, 0x2A)
#define REG_SC_BK17_2A_H      _PK_H_(0x17, 0x2A)
#define REG_SC_BK17_2B_L      _PK_L_(0x17, 0x2B)
#define REG_SC_BK17_2B_H      _PK_H_(0x17, 0x2B)
#define REG_SC_BK17_2C_L      _PK_L_(0x17, 0x2C)
#define REG_SC_BK17_2C_H      _PK_H_(0x17, 0x2C)
#define REG_SC_BK17_2D_L      _PK_L_(0x17, 0x2D)
#define REG_SC_BK17_2D_H      _PK_H_(0x17, 0x2D)
#define REG_SC_BK17_2E_L      _PK_L_(0x17, 0x2E)
#define REG_SC_BK17_2E_H      _PK_H_(0x17, 0x2E)
#define REG_SC_BK17_2F_L      _PK_L_(0x17, 0x2F)
#define REG_SC_BK17_2F_H      _PK_H_(0x17, 0x2F)
#define REG_SC_BK17_30_L      _PK_L_(0x17, 0x30)
#define REG_SC_BK17_30_H      _PK_H_(0x17, 0x30)
#define REG_SC_BK17_31_L      _PK_L_(0x17, 0x31)
#define REG_SC_BK17_31_H      _PK_H_(0x17, 0x31)
#define REG_SC_BK17_32_L      _PK_L_(0x17, 0x32)
#define REG_SC_BK17_32_H      _PK_H_(0x17, 0x32)
#define REG_SC_BK17_33_L      _PK_L_(0x17, 0x33)
#define REG_SC_BK17_33_H      _PK_H_(0x17, 0x33)
#define REG_SC_BK17_34_L      _PK_L_(0x17, 0x34)
#define REG_SC_BK17_34_H      _PK_H_(0x17, 0x34)
#define REG_SC_BK17_35_L      _PK_L_(0x17, 0x35)
#define REG_SC_BK17_35_H      _PK_H_(0x17, 0x35)
#define REG_SC_BK17_36_L      _PK_L_(0x17, 0x36)
#define REG_SC_BK17_36_H      _PK_H_(0x17, 0x36)
#define REG_SC_BK17_37_L      _PK_L_(0x17, 0x37)
#define REG_SC_BK17_37_H      _PK_H_(0x17, 0x37)
#define REG_SC_BK17_38_L      _PK_L_(0x17, 0x38)
#define REG_SC_BK17_38_H      _PK_H_(0x17, 0x38)
#define REG_SC_BK17_39_L      _PK_L_(0x17, 0x39)
#define REG_SC_BK17_39_H      _PK_H_(0x17, 0x39)
#define REG_SC_BK17_3A_L      _PK_L_(0x17, 0x3A)
#define REG_SC_BK17_3A_H      _PK_H_(0x17, 0x3A)
#define REG_SC_BK17_3B_L      _PK_L_(0x17, 0x3B)
#define REG_SC_BK17_3B_H      _PK_H_(0x17, 0x3B)
#define REG_SC_BK17_3C_L      _PK_L_(0x17, 0x3C)
#define REG_SC_BK17_3C_H      _PK_H_(0x17, 0x3C)
#define REG_SC_BK17_3D_L      _PK_L_(0x17, 0x3D)
#define REG_SC_BK17_3D_H      _PK_H_(0x17, 0x3D)
#define REG_SC_BK17_3E_L      _PK_L_(0x17, 0x3E)
#define REG_SC_BK17_3E_H      _PK_H_(0x17, 0x3E)
#define REG_SC_BK17_3F_L      _PK_L_(0x17, 0x3F)
#define REG_SC_BK17_3F_H      _PK_H_(0x17, 0x3F)
#define REG_SC_BK17_40_L      _PK_L_(0x17, 0x40)
#define REG_SC_BK17_40_H      _PK_H_(0x17, 0x40)
#define REG_SC_BK17_41_L      _PK_L_(0x17, 0x41)
#define REG_SC_BK17_41_H      _PK_H_(0x17, 0x41)
#define REG_SC_BK17_42_L      _PK_L_(0x17, 0x42)
#define REG_SC_BK17_42_H      _PK_H_(0x17, 0x42)
#define REG_SC_BK17_43_L      _PK_L_(0x17, 0x43)
#define REG_SC_BK17_43_H      _PK_H_(0x17, 0x43)
#define REG_SC_BK17_44_L      _PK_L_(0x17, 0x44)
#define REG_SC_BK17_44_H      _PK_H_(0x17, 0x44)
#define REG_SC_BK17_45_L      _PK_L_(0x17, 0x45)
#define REG_SC_BK17_45_H      _PK_H_(0x17, 0x45)
#define REG_SC_BK17_46_L      _PK_L_(0x17, 0x46)
#define REG_SC_BK17_46_H      _PK_H_(0x17, 0x46)
#define REG_SC_BK17_47_L      _PK_L_(0x17, 0x47)
#define REG_SC_BK17_47_H      _PK_H_(0x17, 0x47)
#define REG_SC_BK17_48_L      _PK_L_(0x17, 0x48)
#define REG_SC_BK17_48_H      _PK_H_(0x17, 0x48)
#define REG_SC_BK17_49_L      _PK_L_(0x17, 0x49)
#define REG_SC_BK17_49_H      _PK_H_(0x17, 0x49)
#define REG_SC_BK17_4A_L      _PK_L_(0x17, 0x4A)
#define REG_SC_BK17_4A_H      _PK_H_(0x17, 0x4A)
#define REG_SC_BK17_4B_L      _PK_L_(0x17, 0x4B)
#define REG_SC_BK17_4B_H      _PK_H_(0x17, 0x4B)
#define REG_SC_BK17_4C_L      _PK_L_(0x17, 0x4C)
#define REG_SC_BK17_4C_H      _PK_H_(0x17, 0x4C)
#define REG_SC_BK17_4D_L      _PK_L_(0x17, 0x4D)
#define REG_SC_BK17_4D_H      _PK_H_(0x17, 0x4D)
#define REG_SC_BK17_4E_L      _PK_L_(0x17, 0x4E)
#define REG_SC_BK17_4E_H      _PK_H_(0x17, 0x4E)
#define REG_SC_BK17_4F_L      _PK_L_(0x17, 0x4F)
#define REG_SC_BK17_4F_H      _PK_H_(0x17, 0x4F)
#define REG_SC_BK17_50_L      _PK_L_(0x17, 0x50)
#define REG_SC_BK17_50_H      _PK_H_(0x17, 0x50)
#define REG_SC_BK17_51_L      _PK_L_(0x17, 0x51)
#define REG_SC_BK17_51_H      _PK_H_(0x17, 0x51)
#define REG_SC_BK17_52_L      _PK_L_(0x17, 0x52)
#define REG_SC_BK17_52_H      _PK_H_(0x17, 0x52)
#define REG_SC_BK17_53_L      _PK_L_(0x17, 0x53)
#define REG_SC_BK17_53_H      _PK_H_(0x17, 0x53)
#define REG_SC_BK17_54_L      _PK_L_(0x17, 0x54)
#define REG_SC_BK17_54_H      _PK_H_(0x17, 0x54)
#define REG_SC_BK17_55_L      _PK_L_(0x17, 0x55)
#define REG_SC_BK17_55_H      _PK_H_(0x17, 0x55)
#define REG_SC_BK17_56_L      _PK_L_(0x17, 0x56)
#define REG_SC_BK17_56_H      _PK_H_(0x17, 0x56)
#define REG_SC_BK17_57_L      _PK_L_(0x17, 0x57)
#define REG_SC_BK17_57_H      _PK_H_(0x17, 0x57)
#define REG_SC_BK17_58_L      _PK_L_(0x17, 0x58)
#define REG_SC_BK17_58_H      _PK_H_(0x17, 0x58)
#define REG_SC_BK17_59_L      _PK_L_(0x17, 0x59)
#define REG_SC_BK17_59_H      _PK_H_(0x17, 0x59)
#define REG_SC_BK17_5A_L      _PK_L_(0x17, 0x5A)
#define REG_SC_BK17_5A_H      _PK_H_(0x17, 0x5A)
#define REG_SC_BK17_5B_L      _PK_L_(0x17, 0x5B)
#define REG_SC_BK17_5B_H      _PK_H_(0x17, 0x5B)
#define REG_SC_BK17_5C_L      _PK_L_(0x17, 0x5C)
#define REG_SC_BK17_5C_H      _PK_H_(0x17, 0x5C)
#define REG_SC_BK17_5D_L      _PK_L_(0x17, 0x5D)
#define REG_SC_BK17_5D_H      _PK_H_(0x17, 0x5D)
#define REG_SC_BK17_5E_L      _PK_L_(0x17, 0x5E)
#define REG_SC_BK17_5E_H      _PK_H_(0x17, 0x5E)
#define REG_SC_BK17_5F_L      _PK_L_(0x17, 0x5F)
#define REG_SC_BK17_5F_H      _PK_H_(0x17, 0x5F)
#define REG_SC_BK17_60_L      _PK_L_(0x17, 0x60)
#define REG_SC_BK17_60_H      _PK_H_(0x17, 0x60)
#define REG_SC_BK17_61_L      _PK_L_(0x17, 0x61)
#define REG_SC_BK17_61_H      _PK_H_(0x17, 0x61)
#define REG_SC_BK17_62_L      _PK_L_(0x17, 0x62)
#define REG_SC_BK17_62_H      _PK_H_(0x17, 0x62)
#define REG_SC_BK17_63_L      _PK_L_(0x17, 0x63)
#define REG_SC_BK17_63_H      _PK_H_(0x17, 0x63)
#define REG_SC_BK17_64_L      _PK_L_(0x17, 0x64)
#define REG_SC_BK17_64_H      _PK_H_(0x17, 0x64)
#define REG_SC_BK17_65_L      _PK_L_(0x17, 0x65)
#define REG_SC_BK17_65_H      _PK_H_(0x17, 0x65)
#define REG_SC_BK17_66_L      _PK_L_(0x17, 0x66)
#define REG_SC_BK17_66_H      _PK_H_(0x17, 0x66)
#define REG_SC_BK17_67_L      _PK_L_(0x17, 0x67)
#define REG_SC_BK17_67_H      _PK_H_(0x17, 0x67)
#define REG_SC_BK17_68_L      _PK_L_(0x17, 0x68)
#define REG_SC_BK17_68_H      _PK_H_(0x17, 0x68)
#define REG_SC_BK17_69_L      _PK_L_(0x17, 0x69)
#define REG_SC_BK17_69_H      _PK_H_(0x17, 0x69)
#define REG_SC_BK17_6A_L      _PK_L_(0x17, 0x6A)
#define REG_SC_BK17_6A_H      _PK_H_(0x17, 0x6A)
#define REG_SC_BK17_6B_L      _PK_L_(0x17, 0x6B)
#define REG_SC_BK17_6B_H      _PK_H_(0x17, 0x6B)
#define REG_SC_BK17_6C_L      _PK_L_(0x17, 0x6C)
#define REG_SC_BK17_6C_H      _PK_H_(0x17, 0x6C)
#define REG_SC_BK17_6D_L      _PK_L_(0x17, 0x6D)
#define REG_SC_BK17_6D_H      _PK_H_(0x17, 0x6D)
#define REG_SC_BK17_6E_L      _PK_L_(0x17, 0x6E)
#define REG_SC_BK17_6E_H      _PK_H_(0x17, 0x6E)
#define REG_SC_BK17_6F_L      _PK_L_(0x17, 0x6F)
#define REG_SC_BK17_6F_H      _PK_H_(0x17, 0x6F)
#define REG_SC_BK17_70_L      _PK_L_(0x17, 0x70)
#define REG_SC_BK17_70_H      _PK_H_(0x17, 0x70)
#define REG_SC_BK17_71_L      _PK_L_(0x17, 0x71)
#define REG_SC_BK17_71_H      _PK_H_(0x17, 0x71)
#define REG_SC_BK17_72_L      _PK_L_(0x17, 0x72)
#define REG_SC_BK17_72_H      _PK_H_(0x17, 0x72)
#define REG_SC_BK17_73_L      _PK_L_(0x17, 0x73)
#define REG_SC_BK17_73_H      _PK_H_(0x17, 0x73)
#define REG_SC_BK17_74_L      _PK_L_(0x17, 0x74)
#define REG_SC_BK17_74_H      _PK_H_(0x17, 0x74)
#define REG_SC_BK17_75_L      _PK_L_(0x17, 0x75)
#define REG_SC_BK17_75_H      _PK_H_(0x17, 0x75)
#define REG_SC_BK17_76_L      _PK_L_(0x17, 0x76)
#define REG_SC_BK17_76_H      _PK_H_(0x17, 0x76)
#define REG_SC_BK17_77_L      _PK_L_(0x17, 0x77)
#define REG_SC_BK17_77_H      _PK_H_(0x17, 0x77)
#define REG_SC_BK17_78_L      _PK_L_(0x17, 0x78)
#define REG_SC_BK17_78_H      _PK_H_(0x17, 0x78)
#define REG_SC_BK17_79_L      _PK_L_(0x17, 0x79)
#define REG_SC_BK17_79_H      _PK_H_(0x17, 0x79)
#define REG_SC_BK17_7A_L      _PK_L_(0x17, 0x7A)
#define REG_SC_BK17_7A_H      _PK_H_(0x17, 0x7A)
#define REG_SC_BK17_7B_L      _PK_L_(0x17, 0x7B)
#define REG_SC_BK17_7B_H      _PK_H_(0x17, 0x7B)
#define REG_SC_BK17_7C_L      _PK_L_(0x17, 0x7C)
#define REG_SC_BK17_7C_H      _PK_H_(0x17, 0x7C)
#define REG_SC_BK17_7D_L      _PK_L_(0x17, 0x7D)
#define REG_SC_BK17_7D_H      _PK_H_(0x17, 0x7D)
#define REG_SC_BK17_7E_L      _PK_L_(0x17, 0x7E)
#define REG_SC_BK17_7E_H      _PK_H_(0x17, 0x7E)
#define REG_SC_BK17_7F_L      _PK_L_(0x17, 0x7F)
#define REG_SC_BK17_7F_H      _PK_H_(0x17, 0x7F)

//----------------------------------------------
//  BK18: ACE
//----------------------------------------------
#define REG_SC_BK18_00_L      _PK_L_(0x18, 0x00)
#define REG_SC_BK18_00_H      _PK_H_(0x18, 0x00)
#define REG_SC_BK18_01_L      _PK_L_(0x18, 0x01)
#define REG_SC_BK18_01_H      _PK_H_(0x18, 0x01)
#define REG_SC_BK18_02_L      _PK_L_(0x18, 0x02)
#define REG_SC_BK18_02_H      _PK_H_(0x18, 0x02)
#define REG_SC_BK18_03_L      _PK_L_(0x18, 0x03)
#define REG_SC_BK18_03_H      _PK_H_(0x18, 0x03)
#define REG_SC_BK18_04_L      _PK_L_(0x18, 0x04)
#define REG_SC_BK18_04_H      _PK_H_(0x18, 0x04)
#define REG_SC_BK18_05_L      _PK_L_(0x18, 0x05)
#define REG_SC_BK18_05_H      _PK_H_(0x18, 0x05)
#define REG_SC_BK18_06_L      _PK_L_(0x18, 0x06)
#define REG_SC_BK18_06_H      _PK_H_(0x18, 0x06)
#define REG_SC_BK18_07_L      _PK_L_(0x18, 0x07)
#define REG_SC_BK18_07_H      _PK_H_(0x18, 0x07)
#define REG_SC_BK18_08_L      _PK_L_(0x18, 0x08)
#define REG_SC_BK18_08_H      _PK_H_(0x18, 0x08)
#define REG_SC_BK18_09_L      _PK_L_(0x18, 0x09)
#define REG_SC_BK18_09_H      _PK_H_(0x18, 0x09)
#define REG_SC_BK18_0A_L      _PK_L_(0x18, 0x0A)
#define REG_SC_BK18_0A_H      _PK_H_(0x18, 0x0A)
#define REG_SC_BK18_0B_L      _PK_L_(0x18, 0x0B)
#define REG_SC_BK18_0B_H      _PK_H_(0x18, 0x0B)
#define REG_SC_BK18_0C_L      _PK_L_(0x18, 0x0C)
#define REG_SC_BK18_0C_H      _PK_H_(0x18, 0x0C)
#define REG_SC_BK18_0D_L      _PK_L_(0x18, 0x0D)
#define REG_SC_BK18_0D_H      _PK_H_(0x18, 0x0D)
#define REG_SC_BK18_0E_L      _PK_L_(0x18, 0x0E)
#define REG_SC_BK18_0E_H      _PK_H_(0x18, 0x0E)
#define REG_SC_BK18_0F_L      _PK_L_(0x18, 0x0F)
#define REG_SC_BK18_0F_H      _PK_H_(0x18, 0x0F)
#define REG_SC_BK18_10_L      _PK_L_(0x18, 0x10)
#define REG_SC_BK18_10_H      _PK_H_(0x18, 0x10)
#define REG_SC_BK18_11_L      _PK_L_(0x18, 0x11)
#define REG_SC_BK18_11_H      _PK_H_(0x18, 0x11)
#define REG_SC_BK18_12_L      _PK_L_(0x18, 0x12)
#define REG_SC_BK18_12_H      _PK_H_(0x18, 0x12)
#define REG_SC_BK18_13_L      _PK_L_(0x18, 0x13)
#define REG_SC_BK18_13_H      _PK_H_(0x18, 0x13)
#define REG_SC_BK18_14_L      _PK_L_(0x18, 0x14)
#define REG_SC_BK18_14_H      _PK_H_(0x18, 0x14)
#define REG_SC_BK18_15_L      _PK_L_(0x18, 0x15)
#define REG_SC_BK18_15_H      _PK_H_(0x18, 0x15)
#define REG_SC_BK18_16_L      _PK_L_(0x18, 0x16)
#define REG_SC_BK18_16_H      _PK_H_(0x18, 0x16)
#define REG_SC_BK18_17_L      _PK_L_(0x18, 0x17)
#define REG_SC_BK18_17_H      _PK_H_(0x18, 0x17)
#define REG_SC_BK18_18_L      _PK_L_(0x18, 0x18)
#define REG_SC_BK18_18_H      _PK_H_(0x18, 0x18)
#define REG_SC_BK18_19_L      _PK_L_(0x18, 0x19)
#define REG_SC_BK18_19_H      _PK_H_(0x18, 0x19)
#define REG_SC_BK18_1A_L      _PK_L_(0x18, 0x1A)
#define REG_SC_BK18_1A_H      _PK_H_(0x18, 0x1A)
#define REG_SC_BK18_1B_L      _PK_L_(0x18, 0x1B)
#define REG_SC_BK18_1B_H      _PK_H_(0x18, 0x1B)
#define REG_SC_BK18_1C_L      _PK_L_(0x18, 0x1C)
#define REG_SC_BK18_1C_H      _PK_H_(0x18, 0x1C)
#define REG_SC_BK18_1D_L      _PK_L_(0x18, 0x1D)
#define REG_SC_BK18_1D_H      _PK_H_(0x18, 0x1D)
#define REG_SC_BK18_1E_L      _PK_L_(0x18, 0x1E)
#define REG_SC_BK18_1E_H      _PK_H_(0x18, 0x1E)
#define REG_SC_BK18_1F_L      _PK_L_(0x18, 0x1F)
#define REG_SC_BK18_1F_H      _PK_H_(0x18, 0x1F)
#define REG_SC_BK18_20_L      _PK_L_(0x18, 0x20)
#define REG_SC_BK18_20_H      _PK_H_(0x18, 0x20)
#define REG_SC_BK18_21_L      _PK_L_(0x18, 0x21)
#define REG_SC_BK18_21_H      _PK_H_(0x18, 0x21)
#define REG_SC_BK18_22_L      _PK_L_(0x18, 0x22)
#define REG_SC_BK18_22_H      _PK_H_(0x18, 0x22)
#define REG_SC_BK18_23_L      _PK_L_(0x18, 0x23)
#define REG_SC_BK18_23_H      _PK_H_(0x18, 0x23)
#define REG_SC_BK18_24_L      _PK_L_(0x18, 0x24)
#define REG_SC_BK18_24_H      _PK_H_(0x18, 0x24)
#define REG_SC_BK18_25_L      _PK_L_(0x18, 0x25)
#define REG_SC_BK18_25_H      _PK_H_(0x18, 0x25)
#define REG_SC_BK18_26_L      _PK_L_(0x18, 0x26)
#define REG_SC_BK18_26_H      _PK_H_(0x18, 0x26)
#define REG_SC_BK18_27_L      _PK_L_(0x18, 0x27)
#define REG_SC_BK18_27_H      _PK_H_(0x18, 0x27)
#define REG_SC_BK18_28_L      _PK_L_(0x18, 0x28)
#define REG_SC_BK18_28_H      _PK_H_(0x18, 0x28)
#define REG_SC_BK18_29_L      _PK_L_(0x18, 0x29)
#define REG_SC_BK18_29_H      _PK_H_(0x18, 0x29)
#define REG_SC_BK18_2A_L      _PK_L_(0x18, 0x2A)
#define REG_SC_BK18_2A_H      _PK_H_(0x18, 0x2A)
#define REG_SC_BK18_2B_L      _PK_L_(0x18, 0x2B)
#define REG_SC_BK18_2B_H      _PK_H_(0x18, 0x2B)
#define REG_SC_BK18_2C_L      _PK_L_(0x18, 0x2C)
#define REG_SC_BK18_2C_H      _PK_H_(0x18, 0x2C)
#define REG_SC_BK18_2D_L      _PK_L_(0x18, 0x2D)
#define REG_SC_BK18_2D_H      _PK_H_(0x18, 0x2D)
#define REG_SC_BK18_2E_L      _PK_L_(0x18, 0x2E)
#define REG_SC_BK18_2E_H      _PK_H_(0x18, 0x2E)
#define REG_SC_BK18_2F_L      _PK_L_(0x18, 0x2F)
#define REG_SC_BK18_2F_H      _PK_H_(0x18, 0x2F)
#define REG_SC_BK18_30_L      _PK_L_(0x18, 0x30)
#define REG_SC_BK18_30_H      _PK_H_(0x18, 0x30)
#define REG_SC_BK18_31_L      _PK_L_(0x18, 0x31)
#define REG_SC_BK18_31_H      _PK_H_(0x18, 0x31)
#define REG_SC_BK18_32_L      _PK_L_(0x18, 0x32)
#define REG_SC_BK18_32_H      _PK_H_(0x18, 0x32)
#define REG_SC_BK18_33_L      _PK_L_(0x18, 0x33)
#define REG_SC_BK18_33_H      _PK_H_(0x18, 0x33)
#define REG_SC_BK18_34_L      _PK_L_(0x18, 0x34)
#define REG_SC_BK18_34_H      _PK_H_(0x18, 0x34)
#define REG_SC_BK18_35_L      _PK_L_(0x18, 0x35)
#define REG_SC_BK18_35_H      _PK_H_(0x18, 0x35)
#define REG_SC_BK18_36_L      _PK_L_(0x18, 0x36)
#define REG_SC_BK18_36_H      _PK_H_(0x18, 0x36)
#define REG_SC_BK18_37_L      _PK_L_(0x18, 0x37)
#define REG_SC_BK18_37_H      _PK_H_(0x18, 0x37)
#define REG_SC_BK18_38_L      _PK_L_(0x18, 0x38)
#define REG_SC_BK18_38_H      _PK_H_(0x18, 0x38)
#define REG_SC_BK18_39_L      _PK_L_(0x18, 0x39)
#define REG_SC_BK18_39_H      _PK_H_(0x18, 0x39)
#define REG_SC_BK18_3A_L      _PK_L_(0x18, 0x3A)
#define REG_SC_BK18_3A_H      _PK_H_(0x18, 0x3A)
#define REG_SC_BK18_3B_L      _PK_L_(0x18, 0x3B)
#define REG_SC_BK18_3B_H      _PK_H_(0x18, 0x3B)
#define REG_SC_BK18_3C_L      _PK_L_(0x18, 0x3C)
#define REG_SC_BK18_3C_H      _PK_H_(0x18, 0x3C)
#define REG_SC_BK18_3D_L      _PK_L_(0x18, 0x3D)
#define REG_SC_BK18_3D_H      _PK_H_(0x18, 0x3D)
#define REG_SC_BK18_3E_L      _PK_L_(0x18, 0x3E)
#define REG_SC_BK18_3E_H      _PK_H_(0x18, 0x3E)
#define REG_SC_BK18_3F_L      _PK_L_(0x18, 0x3F)
#define REG_SC_BK18_3F_H      _PK_H_(0x18, 0x3F)
#define REG_SC_BK18_40_L      _PK_L_(0x18, 0x40)
#define REG_SC_BK18_40_H      _PK_H_(0x18, 0x40)
#define REG_SC_BK18_41_L      _PK_L_(0x18, 0x41)
#define REG_SC_BK18_41_H      _PK_H_(0x18, 0x41)
#define REG_SC_BK18_42_L      _PK_L_(0x18, 0x42)
#define REG_SC_BK18_42_H      _PK_H_(0x18, 0x42)
#define REG_SC_BK18_43_L      _PK_L_(0x18, 0x43)
#define REG_SC_BK18_43_H      _PK_H_(0x18, 0x43)
#define REG_SC_BK18_44_L      _PK_L_(0x18, 0x44)
#define REG_SC_BK18_44_H      _PK_H_(0x18, 0x44)
#define REG_SC_BK18_45_L      _PK_L_(0x18, 0x45)
#define REG_SC_BK18_45_H      _PK_H_(0x18, 0x45)
#define REG_SC_BK18_46_L      _PK_L_(0x18, 0x46)
#define REG_SC_BK18_46_H      _PK_H_(0x18, 0x46)
#define REG_SC_BK18_47_L      _PK_L_(0x18, 0x47)
#define REG_SC_BK18_47_H      _PK_H_(0x18, 0x47)
#define REG_SC_BK18_48_L      _PK_L_(0x18, 0x48)
#define REG_SC_BK18_48_H      _PK_H_(0x18, 0x48)
#define REG_SC_BK18_49_L      _PK_L_(0x18, 0x49)
#define REG_SC_BK18_49_H      _PK_H_(0x18, 0x49)
#define REG_SC_BK18_4A_L      _PK_L_(0x18, 0x4A)
#define REG_SC_BK18_4A_H      _PK_H_(0x18, 0x4A)
#define REG_SC_BK18_4B_L      _PK_L_(0x18, 0x4B)
#define REG_SC_BK18_4B_H      _PK_H_(0x18, 0x4B)
#define REG_SC_BK18_4C_L      _PK_L_(0x18, 0x4C)
#define REG_SC_BK18_4C_H      _PK_H_(0x18, 0x4C)
#define REG_SC_BK18_4D_L      _PK_L_(0x18, 0x4D)
#define REG_SC_BK18_4D_H      _PK_H_(0x18, 0x4D)
#define REG_SC_BK18_4E_L      _PK_L_(0x18, 0x4E)
#define REG_SC_BK18_4E_H      _PK_H_(0x18, 0x4E)
#define REG_SC_BK18_4F_L      _PK_L_(0x18, 0x4F)
#define REG_SC_BK18_4F_H      _PK_H_(0x18, 0x4F)
#define REG_SC_BK18_50_L      _PK_L_(0x18, 0x50)
#define REG_SC_BK18_50_H      _PK_H_(0x18, 0x50)
#define REG_SC_BK18_51_L      _PK_L_(0x18, 0x51)
#define REG_SC_BK18_51_H      _PK_H_(0x18, 0x51)
#define REG_SC_BK18_52_L      _PK_L_(0x18, 0x52)
#define REG_SC_BK18_52_H      _PK_H_(0x18, 0x52)
#define REG_SC_BK18_53_L      _PK_L_(0x18, 0x53)
#define REG_SC_BK18_53_H      _PK_H_(0x18, 0x53)
#define REG_SC_BK18_54_L      _PK_L_(0x18, 0x54)
#define REG_SC_BK18_54_H      _PK_H_(0x18, 0x54)
#define REG_SC_BK18_55_L      _PK_L_(0x18, 0x55)
#define REG_SC_BK18_55_H      _PK_H_(0x18, 0x55)
#define REG_SC_BK18_56_L      _PK_L_(0x18, 0x56)
#define REG_SC_BK18_56_H      _PK_H_(0x18, 0x56)
#define REG_SC_BK18_57_L      _PK_L_(0x18, 0x57)
#define REG_SC_BK18_57_H      _PK_H_(0x18, 0x57)
#define REG_SC_BK18_58_L      _PK_L_(0x18, 0x58)
#define REG_SC_BK18_58_H      _PK_H_(0x18, 0x58)
#define REG_SC_BK18_59_L      _PK_L_(0x18, 0x59)
#define REG_SC_BK18_59_H      _PK_H_(0x18, 0x59)
#define REG_SC_BK18_5A_L      _PK_L_(0x18, 0x5A)
#define REG_SC_BK18_5A_H      _PK_H_(0x18, 0x5A)
#define REG_SC_BK18_5B_L      _PK_L_(0x18, 0x5B)
#define REG_SC_BK18_5B_H      _PK_H_(0x18, 0x5B)
#define REG_SC_BK18_5C_L      _PK_L_(0x18, 0x5C)
#define REG_SC_BK18_5C_H      _PK_H_(0x18, 0x5C)
#define REG_SC_BK18_5D_L      _PK_L_(0x18, 0x5D)
#define REG_SC_BK18_5D_H      _PK_H_(0x18, 0x5D)
#define REG_SC_BK18_5E_L      _PK_L_(0x18, 0x5E)
#define REG_SC_BK18_5E_H      _PK_H_(0x18, 0x5E)
#define REG_SC_BK18_5F_L      _PK_L_(0x18, 0x5F)
#define REG_SC_BK18_5F_H      _PK_H_(0x18, 0x5F)
#define REG_SC_BK18_60_L      _PK_L_(0x18, 0x60)
#define REG_SC_BK18_60_H      _PK_H_(0x18, 0x60)
#define REG_SC_BK18_61_L      _PK_L_(0x18, 0x61)
#define REG_SC_BK18_61_H      _PK_H_(0x18, 0x61)
#define REG_SC_BK18_62_L      _PK_L_(0x18, 0x62)
#define REG_SC_BK18_62_H      _PK_H_(0x18, 0x62)
#define REG_SC_BK18_63_L      _PK_L_(0x18, 0x63)
#define REG_SC_BK18_63_H      _PK_H_(0x18, 0x63)
#define REG_SC_BK18_64_L      _PK_L_(0x18, 0x64)
#define REG_SC_BK18_64_H      _PK_H_(0x18, 0x64)
#define REG_SC_BK18_65_L      _PK_L_(0x18, 0x65)
#define REG_SC_BK18_65_H      _PK_H_(0x18, 0x65)
#define REG_SC_BK18_66_L      _PK_L_(0x18, 0x66)
#define REG_SC_BK18_66_H      _PK_H_(0x18, 0x66)
#define REG_SC_BK18_67_L      _PK_L_(0x18, 0x67)
#define REG_SC_BK18_67_H      _PK_H_(0x18, 0x67)
#define REG_SC_BK18_68_L      _PK_L_(0x18, 0x68)
#define REG_SC_BK18_68_H      _PK_H_(0x18, 0x68)
#define REG_SC_BK18_69_L      _PK_L_(0x18, 0x69)
#define REG_SC_BK18_69_H      _PK_H_(0x18, 0x69)
#define REG_SC_BK18_6A_L      _PK_L_(0x18, 0x6A)
#define REG_SC_BK18_6A_H      _PK_H_(0x18, 0x6A)
#define REG_SC_BK18_6B_L      _PK_L_(0x18, 0x6B)
#define REG_SC_BK18_6B_H      _PK_H_(0x18, 0x6B)
#define REG_SC_BK18_6C_L      _PK_L_(0x18, 0x6C)
#define REG_SC_BK18_6C_H      _PK_H_(0x18, 0x6C)
#define REG_SC_BK18_6D_L      _PK_L_(0x18, 0x6D)
#define REG_SC_BK18_6D_H      _PK_H_(0x18, 0x6D)
#define REG_SC_BK18_6E_L      _PK_L_(0x18, 0x6E)
#define REG_SC_BK18_6E_H      _PK_H_(0x18, 0x6E)
#define REG_SC_BK18_6F_L      _PK_L_(0x18, 0x6F)
#define REG_SC_BK18_6F_H      _PK_H_(0x18, 0x6F)
#define REG_SC_BK18_70_L      _PK_L_(0x18, 0x70)
#define REG_SC_BK18_70_H      _PK_H_(0x18, 0x70)
#define REG_SC_BK18_71_L      _PK_L_(0x18, 0x71)
#define REG_SC_BK18_71_H      _PK_H_(0x18, 0x71)
#define REG_SC_BK18_72_L      _PK_L_(0x18, 0x72)
#define REG_SC_BK18_72_H      _PK_H_(0x18, 0x72)
#define REG_SC_BK18_73_L      _PK_L_(0x18, 0x73)
#define REG_SC_BK18_73_H      _PK_H_(0x18, 0x73)
#define REG_SC_BK18_74_L      _PK_L_(0x18, 0x74)
#define REG_SC_BK18_74_H      _PK_H_(0x18, 0x74)
#define REG_SC_BK18_75_L      _PK_L_(0x18, 0x75)
#define REG_SC_BK18_75_H      _PK_H_(0x18, 0x75)
#define REG_SC_BK18_76_L      _PK_L_(0x18, 0x76)
#define REG_SC_BK18_76_H      _PK_H_(0x18, 0x76)
#define REG_SC_BK18_77_L      _PK_L_(0x18, 0x77)
#define REG_SC_BK18_77_H      _PK_H_(0x18, 0x77)
#define REG_SC_BK18_78_L      _PK_L_(0x18, 0x78)
#define REG_SC_BK18_78_H      _PK_H_(0x18, 0x78)
#define REG_SC_BK18_79_L      _PK_L_(0x18, 0x79)
#define REG_SC_BK18_79_H      _PK_H_(0x18, 0x79)
#define REG_SC_BK18_7A_L      _PK_L_(0x18, 0x7A)
#define REG_SC_BK18_7A_H      _PK_H_(0x18, 0x7A)
#define REG_SC_BK18_7B_L      _PK_L_(0x18, 0x7B)
#define REG_SC_BK18_7B_H      _PK_H_(0x18, 0x7B)
#define REG_SC_BK18_7C_L      _PK_L_(0x18, 0x7C)
#define REG_SC_BK18_7C_H      _PK_H_(0x18, 0x7C)
#define REG_SC_BK18_7D_L      _PK_L_(0x18, 0x7D)
#define REG_SC_BK18_7D_H      _PK_H_(0x18, 0x7D)
#define REG_SC_BK18_7E_L      _PK_L_(0x18, 0x7E)
#define REG_SC_BK18_7E_H      _PK_H_(0x18, 0x7E)
#define REG_SC_BK18_7F_L      _PK_L_(0x18, 0x7F)
#define REG_SC_BK18_7F_H      _PK_H_(0x18, 0x7F)

//----------------------------------------------
//  BK19: PEAKING
//----------------------------------------------
#define REG_SC_BK19_00_L      _PK_L_(0x19, 0x00)
#define REG_SC_BK19_00_H      _PK_H_(0x19, 0x00)
#define REG_SC_BK19_01_L      _PK_L_(0x19, 0x01)
#define REG_SC_BK19_01_H      _PK_H_(0x19, 0x01)
#define REG_SC_BK19_02_L      _PK_L_(0x19, 0x02)
#define REG_SC_BK19_02_H      _PK_H_(0x19, 0x02)
#define REG_SC_BK19_03_L      _PK_L_(0x19, 0x03)
#define REG_SC_BK19_03_H      _PK_H_(0x19, 0x03)
#define REG_SC_BK19_04_L      _PK_L_(0x19, 0x04)
#define REG_SC_BK19_04_H      _PK_H_(0x19, 0x04)
#define REG_SC_BK19_05_L      _PK_L_(0x19, 0x05)
#define REG_SC_BK19_05_H      _PK_H_(0x19, 0x05)
#define REG_SC_BK19_06_L      _PK_L_(0x19, 0x06)
#define REG_SC_BK19_06_H      _PK_H_(0x19, 0x06)
#define REG_SC_BK19_07_L      _PK_L_(0x19, 0x07)
#define REG_SC_BK19_07_H      _PK_H_(0x19, 0x07)
#define REG_SC_BK19_08_L      _PK_L_(0x19, 0x08)
#define REG_SC_BK19_08_H      _PK_H_(0x19, 0x08)
#define REG_SC_BK19_09_L      _PK_L_(0x19, 0x09)
#define REG_SC_BK19_09_H      _PK_H_(0x19, 0x09)
#define REG_SC_BK19_0A_L      _PK_L_(0x19, 0x0A)
#define REG_SC_BK19_0A_H      _PK_H_(0x19, 0x0A)
#define REG_SC_BK19_0B_L      _PK_L_(0x19, 0x0B)
#define REG_SC_BK19_0B_H      _PK_H_(0x19, 0x0B)
#define REG_SC_BK19_0C_L      _PK_L_(0x19, 0x0C)
#define REG_SC_BK19_0C_H      _PK_H_(0x19, 0x0C)
#define REG_SC_BK19_0D_L      _PK_L_(0x19, 0x0D)
#define REG_SC_BK19_0D_H      _PK_H_(0x19, 0x0D)
#define REG_SC_BK19_0E_L      _PK_L_(0x19, 0x0E)
#define REG_SC_BK19_0E_H      _PK_H_(0x19, 0x0E)
#define REG_SC_BK19_0F_L      _PK_L_(0x19, 0x0F)
#define REG_SC_BK19_0F_H      _PK_H_(0x19, 0x0F)
#define REG_SC_BK19_10_L      _PK_L_(0x19, 0x10)
#define REG_SC_BK19_10_H      _PK_H_(0x19, 0x10)
#define REG_SC_BK19_11_L      _PK_L_(0x19, 0x11)
#define REG_SC_BK19_11_H      _PK_H_(0x19, 0x11)
#define REG_SC_BK19_12_L      _PK_L_(0x19, 0x12)
#define REG_SC_BK19_12_H      _PK_H_(0x19, 0x12)
#define REG_SC_BK19_13_L      _PK_L_(0x19, 0x13)
#define REG_SC_BK19_13_H      _PK_H_(0x19, 0x13)
#define REG_SC_BK19_14_L      _PK_L_(0x19, 0x14)
#define REG_SC_BK19_14_H      _PK_H_(0x19, 0x14)
#define REG_SC_BK19_15_L      _PK_L_(0x19, 0x15)
#define REG_SC_BK19_15_H      _PK_H_(0x19, 0x15)
#define REG_SC_BK19_16_L      _PK_L_(0x19, 0x16)
#define REG_SC_BK19_16_H      _PK_H_(0x19, 0x16)
#define REG_SC_BK19_17_L      _PK_L_(0x19, 0x17)
#define REG_SC_BK19_17_H      _PK_H_(0x19, 0x17)
#define REG_SC_BK19_18_L      _PK_L_(0x19, 0x18)
#define REG_SC_BK19_18_H      _PK_H_(0x19, 0x18)
#define REG_SC_BK19_19_L      _PK_L_(0x19, 0x19)
#define REG_SC_BK19_19_H      _PK_H_(0x19, 0x19)
#define REG_SC_BK19_1A_L      _PK_L_(0x19, 0x1A)
#define REG_SC_BK19_1A_H      _PK_H_(0x19, 0x1A)
#define REG_SC_BK19_1B_L      _PK_L_(0x19, 0x1B)
#define REG_SC_BK19_1B_H      _PK_H_(0x19, 0x1B)
#define REG_SC_BK19_1C_L      _PK_L_(0x19, 0x1C)
#define REG_SC_BK19_1C_H      _PK_H_(0x19, 0x1C)
#define REG_SC_BK19_1D_L      _PK_L_(0x19, 0x1D)
#define REG_SC_BK19_1D_H      _PK_H_(0x19, 0x1D)
#define REG_SC_BK19_1E_L      _PK_L_(0x19, 0x1E)
#define REG_SC_BK19_1E_H      _PK_H_(0x19, 0x1E)
#define REG_SC_BK19_1F_L      _PK_L_(0x19, 0x1F)
#define REG_SC_BK19_1F_H      _PK_H_(0x19, 0x1F)
#define REG_SC_BK19_20_L      _PK_L_(0x19, 0x20)
#define REG_SC_BK19_20_H      _PK_H_(0x19, 0x20)
#define REG_SC_BK19_21_L      _PK_L_(0x19, 0x21)
#define REG_SC_BK19_21_H      _PK_H_(0x19, 0x21)
#define REG_SC_BK19_22_L      _PK_L_(0x19, 0x22)
#define REG_SC_BK19_22_H      _PK_H_(0x19, 0x22)
#define REG_SC_BK19_23_L      _PK_L_(0x19, 0x23)
#define REG_SC_BK19_23_H      _PK_H_(0x19, 0x23)
#define REG_SC_BK19_24_L      _PK_L_(0x19, 0x24)
#define REG_SC_BK19_24_H      _PK_H_(0x19, 0x24)
#define REG_SC_BK19_25_L      _PK_L_(0x19, 0x25)
#define REG_SC_BK19_25_H      _PK_H_(0x19, 0x25)
#define REG_SC_BK19_26_L      _PK_L_(0x19, 0x26)
#define REG_SC_BK19_26_H      _PK_H_(0x19, 0x26)
#define REG_SC_BK19_27_L      _PK_L_(0x19, 0x27)
#define REG_SC_BK19_27_H      _PK_H_(0x19, 0x27)
#define REG_SC_BK19_28_L      _PK_L_(0x19, 0x28)
#define REG_SC_BK19_28_H      _PK_H_(0x19, 0x28)
#define REG_SC_BK19_29_L      _PK_L_(0x19, 0x29)
#define REG_SC_BK19_29_H      _PK_H_(0x19, 0x29)
#define REG_SC_BK19_2A_L      _PK_L_(0x19, 0x2A)
#define REG_SC_BK19_2A_H      _PK_H_(0x19, 0x2A)
#define REG_SC_BK19_2B_L      _PK_L_(0x19, 0x2B)
#define REG_SC_BK19_2B_H      _PK_H_(0x19, 0x2B)
#define REG_SC_BK19_2C_L      _PK_L_(0x19, 0x2C)
#define REG_SC_BK19_2C_H      _PK_H_(0x19, 0x2C)
#define REG_SC_BK19_2D_L      _PK_L_(0x19, 0x2D)
#define REG_SC_BK19_2D_H      _PK_H_(0x19, 0x2D)
#define REG_SC_BK19_2E_L      _PK_L_(0x19, 0x2E)
#define REG_SC_BK19_2E_H      _PK_H_(0x19, 0x2E)
#define REG_SC_BK19_2F_L      _PK_L_(0x19, 0x2F)
#define REG_SC_BK19_2F_H      _PK_H_(0x19, 0x2F)
#define REG_SC_BK19_30_L      _PK_L_(0x19, 0x30)
#define REG_SC_BK19_30_H      _PK_H_(0x19, 0x30)
#define REG_SC_BK19_31_L      _PK_L_(0x19, 0x31)
#define REG_SC_BK19_31_H      _PK_H_(0x19, 0x31)
#define REG_SC_BK19_32_L      _PK_L_(0x19, 0x32)
#define REG_SC_BK19_32_H      _PK_H_(0x19, 0x32)
#define REG_SC_BK19_33_L      _PK_L_(0x19, 0x33)
#define REG_SC_BK19_33_H      _PK_H_(0x19, 0x33)
#define REG_SC_BK19_34_L      _PK_L_(0x19, 0x34)
#define REG_SC_BK19_34_H      _PK_H_(0x19, 0x34)
#define REG_SC_BK19_35_L      _PK_L_(0x19, 0x35)
#define REG_SC_BK19_35_H      _PK_H_(0x19, 0x35)
#define REG_SC_BK19_36_L      _PK_L_(0x19, 0x36)
#define REG_SC_BK19_36_H      _PK_H_(0x19, 0x36)
#define REG_SC_BK19_37_L      _PK_L_(0x19, 0x37)
#define REG_SC_BK19_37_H      _PK_H_(0x19, 0x37)
#define REG_SC_BK19_38_L      _PK_L_(0x19, 0x38)
#define REG_SC_BK19_38_H      _PK_H_(0x19, 0x38)
#define REG_SC_BK19_39_L      _PK_L_(0x19, 0x39)
#define REG_SC_BK19_39_H      _PK_H_(0x19, 0x39)
#define REG_SC_BK19_3A_L      _PK_L_(0x19, 0x3A)
#define REG_SC_BK19_3A_H      _PK_H_(0x19, 0x3A)
#define REG_SC_BK19_3B_L      _PK_L_(0x19, 0x3B)
#define REG_SC_BK19_3B_H      _PK_H_(0x19, 0x3B)
#define REG_SC_BK19_3C_L      _PK_L_(0x19, 0x3C)
#define REG_SC_BK19_3C_H      _PK_H_(0x19, 0x3C)
#define REG_SC_BK19_3D_L      _PK_L_(0x19, 0x3D)
#define REG_SC_BK19_3D_H      _PK_H_(0x19, 0x3D)
#define REG_SC_BK19_3E_L      _PK_L_(0x19, 0x3E)
#define REG_SC_BK19_3E_H      _PK_H_(0x19, 0x3E)
#define REG_SC_BK19_3F_L      _PK_L_(0x19, 0x3F)
#define REG_SC_BK19_3F_H      _PK_H_(0x19, 0x3F)
#define REG_SC_BK19_40_L      _PK_L_(0x19, 0x40)
#define REG_SC_BK19_40_H      _PK_H_(0x19, 0x40)
#define REG_SC_BK19_41_L      _PK_L_(0x19, 0x41)
#define REG_SC_BK19_41_H      _PK_H_(0x19, 0x41)
#define REG_SC_BK19_42_L      _PK_L_(0x19, 0x42)
#define REG_SC_BK19_42_H      _PK_H_(0x19, 0x42)
#define REG_SC_BK19_43_L      _PK_L_(0x19, 0x43)
#define REG_SC_BK19_43_H      _PK_H_(0x19, 0x43)
#define REG_SC_BK19_44_L      _PK_L_(0x19, 0x44)
#define REG_SC_BK19_44_H      _PK_H_(0x19, 0x44)
#define REG_SC_BK19_45_L      _PK_L_(0x19, 0x45)
#define REG_SC_BK19_45_H      _PK_H_(0x19, 0x45)
#define REG_SC_BK19_46_L      _PK_L_(0x19, 0x46)
#define REG_SC_BK19_46_H      _PK_H_(0x19, 0x46)
#define REG_SC_BK19_47_L      _PK_L_(0x19, 0x47)
#define REG_SC_BK19_47_H      _PK_H_(0x19, 0x47)
#define REG_SC_BK19_48_L      _PK_L_(0x19, 0x48)
#define REG_SC_BK19_48_H      _PK_H_(0x19, 0x48)
#define REG_SC_BK19_49_L      _PK_L_(0x19, 0x49)
#define REG_SC_BK19_49_H      _PK_H_(0x19, 0x49)
#define REG_SC_BK19_4A_L      _PK_L_(0x19, 0x4A)
#define REG_SC_BK19_4A_H      _PK_H_(0x19, 0x4A)
#define REG_SC_BK19_4B_L      _PK_L_(0x19, 0x4B)
#define REG_SC_BK19_4B_H      _PK_H_(0x19, 0x4B)
#define REG_SC_BK19_4C_L      _PK_L_(0x19, 0x4C)
#define REG_SC_BK19_4C_H      _PK_H_(0x19, 0x4C)
#define REG_SC_BK19_4D_L      _PK_L_(0x19, 0x4D)
#define REG_SC_BK19_4D_H      _PK_H_(0x19, 0x4D)
#define REG_SC_BK19_4E_L      _PK_L_(0x19, 0x4E)
#define REG_SC_BK19_4E_H      _PK_H_(0x19, 0x4E)
#define REG_SC_BK19_4F_L      _PK_L_(0x19, 0x4F)
#define REG_SC_BK19_4F_H      _PK_H_(0x19, 0x4F)
#define REG_SC_BK19_50_L      _PK_L_(0x19, 0x50)
#define REG_SC_BK19_50_H      _PK_H_(0x19, 0x50)
#define REG_SC_BK19_51_L      _PK_L_(0x19, 0x51)
#define REG_SC_BK19_51_H      _PK_H_(0x19, 0x51)
#define REG_SC_BK19_52_L      _PK_L_(0x19, 0x52)
#define REG_SC_BK19_52_H      _PK_H_(0x19, 0x52)
#define REG_SC_BK19_53_L      _PK_L_(0x19, 0x53)
#define REG_SC_BK19_53_H      _PK_H_(0x19, 0x53)
#define REG_SC_BK19_54_L      _PK_L_(0x19, 0x54)
#define REG_SC_BK19_54_H      _PK_H_(0x19, 0x54)
#define REG_SC_BK19_55_L      _PK_L_(0x19, 0x55)
#define REG_SC_BK19_55_H      _PK_H_(0x19, 0x55)
#define REG_SC_BK19_56_L      _PK_L_(0x19, 0x56)
#define REG_SC_BK19_56_H      _PK_H_(0x19, 0x56)
#define REG_SC_BK19_57_L      _PK_L_(0x19, 0x57)
#define REG_SC_BK19_57_H      _PK_H_(0x19, 0x57)
#define REG_SC_BK19_58_L      _PK_L_(0x19, 0x58)
#define REG_SC_BK19_58_H      _PK_H_(0x19, 0x58)
#define REG_SC_BK19_59_L      _PK_L_(0x19, 0x59)
#define REG_SC_BK19_59_H      _PK_H_(0x19, 0x59)
#define REG_SC_BK19_5A_L      _PK_L_(0x19, 0x5A)
#define REG_SC_BK19_5A_H      _PK_H_(0x19, 0x5A)
#define REG_SC_BK19_5B_L      _PK_L_(0x19, 0x5B)
#define REG_SC_BK19_5B_H      _PK_H_(0x19, 0x5B)
#define REG_SC_BK19_5C_L      _PK_L_(0x19, 0x5C)
#define REG_SC_BK19_5C_H      _PK_H_(0x19, 0x5C)
#define REG_SC_BK19_5D_L      _PK_L_(0x19, 0x5D)
#define REG_SC_BK19_5D_H      _PK_H_(0x19, 0x5D)
#define REG_SC_BK19_5E_L      _PK_L_(0x19, 0x5E)
#define REG_SC_BK19_5E_H      _PK_H_(0x19, 0x5E)
#define REG_SC_BK19_5F_L      _PK_L_(0x19, 0x5F)
#define REG_SC_BK19_5F_H      _PK_H_(0x19, 0x5F)
#define REG_SC_BK19_60_L      _PK_L_(0x19, 0x60)
#define REG_SC_BK19_60_H      _PK_H_(0x19, 0x60)
#define REG_SC_BK19_61_L      _PK_L_(0x19, 0x61)
#define REG_SC_BK19_61_H      _PK_H_(0x19, 0x61)
#define REG_SC_BK19_62_L      _PK_L_(0x19, 0x62)
#define REG_SC_BK19_62_H      _PK_H_(0x19, 0x62)
#define REG_SC_BK19_63_L      _PK_L_(0x19, 0x63)
#define REG_SC_BK19_63_H      _PK_H_(0x19, 0x63)
#define REG_SC_BK19_64_L      _PK_L_(0x19, 0x64)
#define REG_SC_BK19_64_H      _PK_H_(0x19, 0x64)
#define REG_SC_BK19_65_L      _PK_L_(0x19, 0x65)
#define REG_SC_BK19_65_H      _PK_H_(0x19, 0x65)
#define REG_SC_BK19_66_L      _PK_L_(0x19, 0x66)
#define REG_SC_BK19_66_H      _PK_H_(0x19, 0x66)
#define REG_SC_BK19_67_L      _PK_L_(0x19, 0x67)
#define REG_SC_BK19_67_H      _PK_H_(0x19, 0x67)
#define REG_SC_BK19_68_L      _PK_L_(0x19, 0x68)
#define REG_SC_BK19_68_H      _PK_H_(0x19, 0x68)
#define REG_SC_BK19_69_L      _PK_L_(0x19, 0x69)
#define REG_SC_BK19_69_H      _PK_H_(0x19, 0x69)
#define REG_SC_BK19_6A_L      _PK_L_(0x19, 0x6A)
#define REG_SC_BK19_6A_H      _PK_H_(0x19, 0x6A)
#define REG_SC_BK19_6B_L      _PK_L_(0x19, 0x6B)
#define REG_SC_BK19_6B_H      _PK_H_(0x19, 0x6B)
#define REG_SC_BK19_6C_L      _PK_L_(0x19, 0x6C)
#define REG_SC_BK19_6C_H      _PK_H_(0x19, 0x6C)
#define REG_SC_BK19_6D_L      _PK_L_(0x19, 0x6D)
#define REG_SC_BK19_6D_H      _PK_H_(0x19, 0x6D)
#define REG_SC_BK19_6E_L      _PK_L_(0x19, 0x6E)
#define REG_SC_BK19_6E_H      _PK_H_(0x19, 0x6E)
#define REG_SC_BK19_6F_L      _PK_L_(0x19, 0x6F)
#define REG_SC_BK19_6F_H      _PK_H_(0x19, 0x6F)
#define REG_SC_BK19_70_L      _PK_L_(0x19, 0x70)
#define REG_SC_BK19_70_H      _PK_H_(0x19, 0x70)
#define REG_SC_BK19_71_L      _PK_L_(0x19, 0x71)
#define REG_SC_BK19_71_H      _PK_H_(0x19, 0x71)
#define REG_SC_BK19_72_L      _PK_L_(0x19, 0x72)
#define REG_SC_BK19_72_H      _PK_H_(0x19, 0x72)
#define REG_SC_BK19_73_L      _PK_L_(0x19, 0x73)
#define REG_SC_BK19_73_H      _PK_H_(0x19, 0x73)
#define REG_SC_BK19_74_L      _PK_L_(0x19, 0x74)
#define REG_SC_BK19_74_H      _PK_H_(0x19, 0x74)
#define REG_SC_BK19_75_L      _PK_L_(0x19, 0x75)
#define REG_SC_BK19_75_H      _PK_H_(0x19, 0x75)
#define REG_SC_BK19_76_L      _PK_L_(0x19, 0x76)
#define REG_SC_BK19_76_H      _PK_H_(0x19, 0x76)
#define REG_SC_BK19_77_L      _PK_L_(0x19, 0x77)
#define REG_SC_BK19_77_H      _PK_H_(0x19, 0x77)
#define REG_SC_BK19_78_L      _PK_L_(0x19, 0x78)
#define REG_SC_BK19_78_H      _PK_H_(0x19, 0x78)
#define REG_SC_BK19_79_L      _PK_L_(0x19, 0x79)
#define REG_SC_BK19_79_H      _PK_H_(0x19, 0x79)
#define REG_SC_BK19_7A_L      _PK_L_(0x19, 0x7A)
#define REG_SC_BK19_7A_H      _PK_H_(0x19, 0x7A)
#define REG_SC_BK19_7B_L      _PK_L_(0x19, 0x7B)
#define REG_SC_BK19_7B_H      _PK_H_(0x19, 0x7B)
#define REG_SC_BK19_7C_L      _PK_L_(0x19, 0x7C)
#define REG_SC_BK19_7C_H      _PK_H_(0x19, 0x7C)
#define REG_SC_BK19_7D_L      _PK_L_(0x19, 0x7D)
#define REG_SC_BK19_7D_H      _PK_H_(0x19, 0x7D)
#define REG_SC_BK19_7E_L      _PK_L_(0x19, 0x7E)
#define REG_SC_BK19_7E_H      _PK_H_(0x19, 0x7E)
#define REG_SC_BK19_7F_L      _PK_L_(0x19, 0x7F)
#define REG_SC_BK19_7F_H      _PK_H_(0x19, 0x7F)

//----------------------------------------------
//  BK1A: DLC
//----------------------------------------------
#define REG_SC_BK1A_00_L      _PK_L_(0x1A, 0x00)
#define REG_SC_BK1A_00_H      _PK_H_(0x1A, 0x00)
#define REG_SC_BK1A_01_L      _PK_L_(0x1A, 0x01)
#define REG_SC_BK1A_01_H      _PK_H_(0x1A, 0x01)
#define REG_SC_BK1A_02_L      _PK_L_(0x1A, 0x02)
#define REG_SC_BK1A_02_H      _PK_H_(0x1A, 0x02)
#define REG_SC_BK1A_03_L      _PK_L_(0x1A, 0x03)
#define REG_SC_BK1A_03_H      _PK_H_(0x1A, 0x03)
#define REG_SC_BK1A_04_L      _PK_L_(0x1A, 0x04)
#define REG_SC_BK1A_04_H      _PK_H_(0x1A, 0x04)
#define REG_SC_BK1A_05_L      _PK_L_(0x1A, 0x05)
#define REG_SC_BK1A_05_H      _PK_H_(0x1A, 0x05)
#define REG_SC_BK1A_06_L      _PK_L_(0x1A, 0x06)
#define REG_SC_BK1A_06_H      _PK_H_(0x1A, 0x06)
#define REG_SC_BK1A_07_L      _PK_L_(0x1A, 0x07)
#define REG_SC_BK1A_07_H      _PK_H_(0x1A, 0x07)
#define REG_SC_BK1A_08_L      _PK_L_(0x1A, 0x08)
#define REG_SC_BK1A_08_H      _PK_H_(0x1A, 0x08)
#define REG_SC_BK1A_09_L      _PK_L_(0x1A, 0x09)
#define REG_SC_BK1A_09_H      _PK_H_(0x1A, 0x09)
#define REG_SC_BK1A_0A_L      _PK_L_(0x1A, 0x0A)
#define REG_SC_BK1A_0A_H      _PK_H_(0x1A, 0x0A)
#define REG_SC_BK1A_0B_L      _PK_L_(0x1A, 0x0B)
#define REG_SC_BK1A_0B_H      _PK_H_(0x1A, 0x0B)
#define REG_SC_BK1A_0C_L      _PK_L_(0x1A, 0x0C)
#define REG_SC_BK1A_0C_H      _PK_H_(0x1A, 0x0C)
#define REG_SC_BK1A_0D_L      _PK_L_(0x1A, 0x0D)
#define REG_SC_BK1A_0D_H      _PK_H_(0x1A, 0x0D)
#define REG_SC_BK1A_0E_L      _PK_L_(0x1A, 0x0E)
#define REG_SC_BK1A_0E_H      _PK_H_(0x1A, 0x0E)
#define REG_SC_BK1A_0F_L      _PK_L_(0x1A, 0x0F)
#define REG_SC_BK1A_0F_H      _PK_H_(0x1A, 0x0F)
#define REG_SC_BK1A_10_L      _PK_L_(0x1A, 0x10)
#define REG_SC_BK1A_10_H      _PK_H_(0x1A, 0x10)
#define REG_SC_BK1A_11_L      _PK_L_(0x1A, 0x11)
#define REG_SC_BK1A_11_H      _PK_H_(0x1A, 0x11)
#define REG_SC_BK1A_12_L      _PK_L_(0x1A, 0x12)
#define REG_SC_BK1A_12_H      _PK_H_(0x1A, 0x12)
#define REG_SC_BK1A_13_L      _PK_L_(0x1A, 0x13)
#define REG_SC_BK1A_13_H      _PK_H_(0x1A, 0x13)
#define REG_SC_BK1A_14_L      _PK_L_(0x1A, 0x14)
#define REG_SC_BK1A_14_H      _PK_H_(0x1A, 0x14)
#define REG_SC_BK1A_15_L      _PK_L_(0x1A, 0x15)
#define REG_SC_BK1A_15_H      _PK_H_(0x1A, 0x15)
#define REG_SC_BK1A_16_L      _PK_L_(0x1A, 0x16)
#define REG_SC_BK1A_16_H      _PK_H_(0x1A, 0x16)
#define REG_SC_BK1A_17_L      _PK_L_(0x1A, 0x17)
#define REG_SC_BK1A_17_H      _PK_H_(0x1A, 0x17)
#define REG_SC_BK1A_18_L      _PK_L_(0x1A, 0x18)
#define REG_SC_BK1A_18_H      _PK_H_(0x1A, 0x18)
#define REG_SC_BK1A_19_L      _PK_L_(0x1A, 0x19)
#define REG_SC_BK1A_19_H      _PK_H_(0x1A, 0x19)
#define REG_SC_BK1A_1A_L      _PK_L_(0x1A, 0x1A)
#define REG_SC_BK1A_1A_H      _PK_H_(0x1A, 0x1A)
#define REG_SC_BK1A_1B_L      _PK_L_(0x1A, 0x1B)
#define REG_SC_BK1A_1B_H      _PK_H_(0x1A, 0x1B)
#define REG_SC_BK1A_1C_L      _PK_L_(0x1A, 0x1C)
#define REG_SC_BK1A_1C_H      _PK_H_(0x1A, 0x1C)
#define REG_SC_BK1A_1D_L      _PK_L_(0x1A, 0x1D)
#define REG_SC_BK1A_1D_H      _PK_H_(0x1A, 0x1D)
#define REG_SC_BK1A_1E_L      _PK_L_(0x1A, 0x1E)
#define REG_SC_BK1A_1E_H      _PK_H_(0x1A, 0x1E)
#define REG_SC_BK1A_1F_L      _PK_L_(0x1A, 0x1F)
#define REG_SC_BK1A_1F_H      _PK_H_(0x1A, 0x1F)
#define REG_SC_BK1A_20_L      _PK_L_(0x1A, 0x20)
#define REG_SC_BK1A_20_H      _PK_H_(0x1A, 0x20)
#define REG_SC_BK1A_21_L      _PK_L_(0x1A, 0x21)
#define REG_SC_BK1A_21_H      _PK_H_(0x1A, 0x21)
#define REG_SC_BK1A_22_L      _PK_L_(0x1A, 0x22)
#define REG_SC_BK1A_22_H      _PK_H_(0x1A, 0x22)
#define REG_SC_BK1A_23_L      _PK_L_(0x1A, 0x23)
#define REG_SC_BK1A_23_H      _PK_H_(0x1A, 0x23)
#define REG_SC_BK1A_24_L      _PK_L_(0x1A, 0x24)
#define REG_SC_BK1A_24_H      _PK_H_(0x1A, 0x24)
#define REG_SC_BK1A_25_L      _PK_L_(0x1A, 0x25)
#define REG_SC_BK1A_25_H      _PK_H_(0x1A, 0x25)
#define REG_SC_BK1A_26_L      _PK_L_(0x1A, 0x26)
#define REG_SC_BK1A_26_H      _PK_H_(0x1A, 0x26)
#define REG_SC_BK1A_27_L      _PK_L_(0x1A, 0x27)
#define REG_SC_BK1A_27_H      _PK_H_(0x1A, 0x27)
#define REG_SC_BK1A_28_L      _PK_L_(0x1A, 0x28)
#define REG_SC_BK1A_28_H      _PK_H_(0x1A, 0x28)
#define REG_SC_BK1A_29_L      _PK_L_(0x1A, 0x29)
#define REG_SC_BK1A_29_H      _PK_H_(0x1A, 0x29)
#define REG_SC_BK1A_2A_L      _PK_L_(0x1A, 0x2A)
#define REG_SC_BK1A_2A_H      _PK_H_(0x1A, 0x2A)
#define REG_SC_BK1A_2B_L      _PK_L_(0x1A, 0x2B)
#define REG_SC_BK1A_2B_H      _PK_H_(0x1A, 0x2B)
#define REG_SC_BK1A_2C_L      _PK_L_(0x1A, 0x2C)
#define REG_SC_BK1A_2C_H      _PK_H_(0x1A, 0x2C)
#define REG_SC_BK1A_2D_L      _PK_L_(0x1A, 0x2D)
#define REG_SC_BK1A_2D_H      _PK_H_(0x1A, 0x2D)
#define REG_SC_BK1A_2E_L      _PK_L_(0x1A, 0x2E)
#define REG_SC_BK1A_2E_H      _PK_H_(0x1A, 0x2E)
#define REG_SC_BK1A_2F_L      _PK_L_(0x1A, 0x2F)
#define REG_SC_BK1A_2F_H      _PK_H_(0x1A, 0x2F)
#define REG_SC_BK1A_30_L      _PK_L_(0x1A, 0x30)
#define REG_SC_BK1A_30_H      _PK_H_(0x1A, 0x30)
#define REG_SC_BK1A_31_L      _PK_L_(0x1A, 0x31)
#define REG_SC_BK1A_31_H      _PK_H_(0x1A, 0x31)
#define REG_SC_BK1A_32_L      _PK_L_(0x1A, 0x32)
#define REG_SC_BK1A_32_H      _PK_H_(0x1A, 0x32)
#define REG_SC_BK1A_33_L      _PK_L_(0x1A, 0x33)
#define REG_SC_BK1A_33_H      _PK_H_(0x1A, 0x33)
#define REG_SC_BK1A_34_L      _PK_L_(0x1A, 0x34)
#define REG_SC_BK1A_34_H      _PK_H_(0x1A, 0x34)
#define REG_SC_BK1A_35_L      _PK_L_(0x1A, 0x35)
#define REG_SC_BK1A_35_H      _PK_H_(0x1A, 0x35)
#define REG_SC_BK1A_36_L      _PK_L_(0x1A, 0x36)
#define REG_SC_BK1A_36_H      _PK_H_(0x1A, 0x36)
#define REG_SC_BK1A_37_L      _PK_L_(0x1A, 0x37)
#define REG_SC_BK1A_37_H      _PK_H_(0x1A, 0x37)
#define REG_SC_BK1A_38_L      _PK_L_(0x1A, 0x38)
#define REG_SC_BK1A_38_H      _PK_H_(0x1A, 0x38)
#define REG_SC_BK1A_39_L      _PK_L_(0x1A, 0x39)
#define REG_SC_BK1A_39_H      _PK_H_(0x1A, 0x39)
#define REG_SC_BK1A_3A_L      _PK_L_(0x1A, 0x3A)
#define REG_SC_BK1A_3A_H      _PK_H_(0x1A, 0x3A)
#define REG_SC_BK1A_3B_L      _PK_L_(0x1A, 0x3B)
#define REG_SC_BK1A_3B_H      _PK_H_(0x1A, 0x3B)
#define REG_SC_BK1A_3C_L      _PK_L_(0x1A, 0x3C)
#define REG_SC_BK1A_3C_H      _PK_H_(0x1A, 0x3C)
#define REG_SC_BK1A_3D_L      _PK_L_(0x1A, 0x3D)
#define REG_SC_BK1A_3D_H      _PK_H_(0x1A, 0x3D)
#define REG_SC_BK1A_3E_L      _PK_L_(0x1A, 0x3E)
#define REG_SC_BK1A_3E_H      _PK_H_(0x1A, 0x3E)
#define REG_SC_BK1A_3F_L      _PK_L_(0x1A, 0x3F)
#define REG_SC_BK1A_3F_H      _PK_H_(0x1A, 0x3F)
#define REG_SC_BK1A_40_L      _PK_L_(0x1A, 0x40)
#define REG_SC_BK1A_40_H      _PK_H_(0x1A, 0x40)
#define REG_SC_BK1A_41_L      _PK_L_(0x1A, 0x41)
#define REG_SC_BK1A_41_H      _PK_H_(0x1A, 0x41)
#define REG_SC_BK1A_42_L      _PK_L_(0x1A, 0x42)
#define REG_SC_BK1A_42_H      _PK_H_(0x1A, 0x42)
#define REG_SC_BK1A_43_L      _PK_L_(0x1A, 0x43)
#define REG_SC_BK1A_43_H      _PK_H_(0x1A, 0x43)
#define REG_SC_BK1A_44_L      _PK_L_(0x1A, 0x44)
#define REG_SC_BK1A_44_H      _PK_H_(0x1A, 0x44)
#define REG_SC_BK1A_45_L      _PK_L_(0x1A, 0x45)
#define REG_SC_BK1A_45_H      _PK_H_(0x1A, 0x45)
#define REG_SC_BK1A_46_L      _PK_L_(0x1A, 0x46)
#define REG_SC_BK1A_46_H      _PK_H_(0x1A, 0x46)
#define REG_SC_BK1A_47_L      _PK_L_(0x1A, 0x47)
#define REG_SC_BK1A_47_H      _PK_H_(0x1A, 0x47)
#define REG_SC_BK1A_48_L      _PK_L_(0x1A, 0x48)
#define REG_SC_BK1A_48_H      _PK_H_(0x1A, 0x48)
#define REG_SC_BK1A_49_L      _PK_L_(0x1A, 0x49)
#define REG_SC_BK1A_49_H      _PK_H_(0x1A, 0x49)
#define REG_SC_BK1A_4A_L      _PK_L_(0x1A, 0x4A)
#define REG_SC_BK1A_4A_H      _PK_H_(0x1A, 0x4A)
#define REG_SC_BK1A_4B_L      _PK_L_(0x1A, 0x4B)
#define REG_SC_BK1A_4B_H      _PK_H_(0x1A, 0x4B)
#define REG_SC_BK1A_4C_L      _PK_L_(0x1A, 0x4C)
#define REG_SC_BK1A_4C_H      _PK_H_(0x1A, 0x4C)
#define REG_SC_BK1A_4D_L      _PK_L_(0x1A, 0x4D)
#define REG_SC_BK1A_4D_H      _PK_H_(0x1A, 0x4D)
#define REG_SC_BK1A_4E_L      _PK_L_(0x1A, 0x4E)
#define REG_SC_BK1A_4E_H      _PK_H_(0x1A, 0x4E)
#define REG_SC_BK1A_4F_L      _PK_L_(0x1A, 0x4F)
#define REG_SC_BK1A_4F_H      _PK_H_(0x1A, 0x4F)
#define REG_SC_BK1A_50_L      _PK_L_(0x1A, 0x50)
#define REG_SC_BK1A_50_H      _PK_H_(0x1A, 0x50)
#define REG_SC_BK1A_51_L      _PK_L_(0x1A, 0x51)
#define REG_SC_BK1A_51_H      _PK_H_(0x1A, 0x51)
#define REG_SC_BK1A_52_L      _PK_L_(0x1A, 0x52)
#define REG_SC_BK1A_52_H      _PK_H_(0x1A, 0x52)
#define REG_SC_BK1A_53_L      _PK_L_(0x1A, 0x53)
#define REG_SC_BK1A_53_H      _PK_H_(0x1A, 0x53)
#define REG_SC_BK1A_54_L      _PK_L_(0x1A, 0x54)
#define REG_SC_BK1A_54_H      _PK_H_(0x1A, 0x54)
#define REG_SC_BK1A_55_L      _PK_L_(0x1A, 0x55)
#define REG_SC_BK1A_55_H      _PK_H_(0x1A, 0x55)
#define REG_SC_BK1A_56_L      _PK_L_(0x1A, 0x56)
#define REG_SC_BK1A_56_H      _PK_H_(0x1A, 0x56)
#define REG_SC_BK1A_57_L      _PK_L_(0x1A, 0x57)
#define REG_SC_BK1A_57_H      _PK_H_(0x1A, 0x57)
#define REG_SC_BK1A_58_L      _PK_L_(0x1A, 0x58)
#define REG_SC_BK1A_58_H      _PK_H_(0x1A, 0x58)
#define REG_SC_BK1A_59_L      _PK_L_(0x1A, 0x59)
#define REG_SC_BK1A_59_H      _PK_H_(0x1A, 0x59)
#define REG_SC_BK1A_5A_L      _PK_L_(0x1A, 0x5A)
#define REG_SC_BK1A_5A_H      _PK_H_(0x1A, 0x5A)
#define REG_SC_BK1A_5B_L      _PK_L_(0x1A, 0x5B)
#define REG_SC_BK1A_5B_H      _PK_H_(0x1A, 0x5B)
#define REG_SC_BK1A_5C_L      _PK_L_(0x1A, 0x5C)
#define REG_SC_BK1A_5C_H      _PK_H_(0x1A, 0x5C)
#define REG_SC_BK1A_5D_L      _PK_L_(0x1A, 0x5D)
#define REG_SC_BK1A_5D_H      _PK_H_(0x1A, 0x5D)
#define REG_SC_BK1A_5E_L      _PK_L_(0x1A, 0x5E)
#define REG_SC_BK1A_5E_H      _PK_H_(0x1A, 0x5E)
#define REG_SC_BK1A_5F_L      _PK_L_(0x1A, 0x5F)
#define REG_SC_BK1A_5F_H      _PK_H_(0x1A, 0x5F)
#define REG_SC_BK1A_60_L      _PK_L_(0x1A, 0x60)
#define REG_SC_BK1A_60_H      _PK_H_(0x1A, 0x60)
#define REG_SC_BK1A_61_L      _PK_L_(0x1A, 0x61)
#define REG_SC_BK1A_61_H      _PK_H_(0x1A, 0x61)
#define REG_SC_BK1A_62_L      _PK_L_(0x1A, 0x62)
#define REG_SC_BK1A_62_H      _PK_H_(0x1A, 0x62)
#define REG_SC_BK1A_63_L      _PK_L_(0x1A, 0x63)
#define REG_SC_BK1A_63_H      _PK_H_(0x1A, 0x63)
#define REG_SC_BK1A_64_L      _PK_L_(0x1A, 0x64)
#define REG_SC_BK1A_64_H      _PK_H_(0x1A, 0x64)
#define REG_SC_BK1A_65_L      _PK_L_(0x1A, 0x65)
#define REG_SC_BK1A_65_H      _PK_H_(0x1A, 0x65)
#define REG_SC_BK1A_66_L      _PK_L_(0x1A, 0x66)
#define REG_SC_BK1A_66_H      _PK_H_(0x1A, 0x66)
#define REG_SC_BK1A_67_L      _PK_L_(0x1A, 0x67)
#define REG_SC_BK1A_67_H      _PK_H_(0x1A, 0x67)
#define REG_SC_BK1A_68_L      _PK_L_(0x1A, 0x68)
#define REG_SC_BK1A_68_H      _PK_H_(0x1A, 0x68)
#define REG_SC_BK1A_69_L      _PK_L_(0x1A, 0x69)
#define REG_SC_BK1A_69_H      _PK_H_(0x1A, 0x69)
#define REG_SC_BK1A_6A_L      _PK_L_(0x1A, 0x6A)
#define REG_SC_BK1A_6A_H      _PK_H_(0x1A, 0x6A)
#define REG_SC_BK1A_6B_L      _PK_L_(0x1A, 0x6B)
#define REG_SC_BK1A_6B_H      _PK_H_(0x1A, 0x6B)
#define REG_SC_BK1A_6C_L      _PK_L_(0x1A, 0x6C)
#define REG_SC_BK1A_6C_H      _PK_H_(0x1A, 0x6C)
#define REG_SC_BK1A_6D_L      _PK_L_(0x1A, 0x6D)
#define REG_SC_BK1A_6D_H      _PK_H_(0x1A, 0x6D)
#define REG_SC_BK1A_6E_L      _PK_L_(0x1A, 0x6E)
#define REG_SC_BK1A_6E_H      _PK_H_(0x1A, 0x6E)
#define REG_SC_BK1A_6F_L      _PK_L_(0x1A, 0x6F)
#define REG_SC_BK1A_6F_H      _PK_H_(0x1A, 0x6F)
#define REG_SC_BK1A_70_L      _PK_L_(0x1A, 0x70)
#define REG_SC_BK1A_70_H      _PK_H_(0x1A, 0x70)
#define REG_SC_BK1A_71_L      _PK_L_(0x1A, 0x71)
#define REG_SC_BK1A_71_H      _PK_H_(0x1A, 0x71)
#define REG_SC_BK1A_72_L      _PK_L_(0x1A, 0x72)
#define REG_SC_BK1A_72_H      _PK_H_(0x1A, 0x72)
#define REG_SC_BK1A_73_L      _PK_L_(0x1A, 0x73)
#define REG_SC_BK1A_73_H      _PK_H_(0x1A, 0x73)
#define REG_SC_BK1A_74_L      _PK_L_(0x1A, 0x74)
#define REG_SC_BK1A_74_H      _PK_H_(0x1A, 0x74)
#define REG_SC_BK1A_75_L      _PK_L_(0x1A, 0x75)
#define REG_SC_BK1A_75_H      _PK_H_(0x1A, 0x75)
#define REG_SC_BK1A_76_L      _PK_L_(0x1A, 0x76)
#define REG_SC_BK1A_76_H      _PK_H_(0x1A, 0x76)
#define REG_SC_BK1A_77_L      _PK_L_(0x1A, 0x77)
#define REG_SC_BK1A_77_H      _PK_H_(0x1A, 0x77)
#define REG_SC_BK1A_78_L      _PK_L_(0x1A, 0x78)
#define REG_SC_BK1A_78_H      _PK_H_(0x1A, 0x78)
#define REG_SC_BK1A_79_L      _PK_L_(0x1A, 0x79)
#define REG_SC_BK1A_79_H      _PK_H_(0x1A, 0x79)
#define REG_SC_BK1A_7A_L      _PK_L_(0x1A, 0x7A)
#define REG_SC_BK1A_7A_H      _PK_H_(0x1A, 0x7A)
#define REG_SC_BK1A_7B_L      _PK_L_(0x1A, 0x7B)
#define REG_SC_BK1A_7B_H      _PK_H_(0x1A, 0x7B)
#define REG_SC_BK1A_7C_L      _PK_L_(0x1A, 0x7C)
#define REG_SC_BK1A_7C_H      _PK_H_(0x1A, 0x7C)
#define REG_SC_BK1A_7D_L      _PK_L_(0x1A, 0x7D)
#define REG_SC_BK1A_7D_H      _PK_H_(0x1A, 0x7D)
#define REG_SC_BK1A_7E_L      _PK_L_(0x1A, 0x7E)
#define REG_SC_BK1A_7E_H      _PK_H_(0x1A, 0x7E)
#define REG_SC_BK1A_7F_L      _PK_L_(0x1A, 0x7F)
#define REG_SC_BK1A_7F_H      _PK_H_(0x1A, 0x7F)

////
////?????????????????????????

#define REG_SC_BK1B_00_L      _PK_L_(0x1B, 0x00)
#define REG_SC_BK1B_00_H      _PK_H_(0x1B, 0x00)
#define REG_SC_BK1B_01_L      _PK_L_(0x1B, 0x01)
#define REG_SC_BK1B_01_H      _PK_H_(0x1B, 0x01)
#define REG_SC_BK1B_02_L      _PK_L_(0x1B, 0x02)
#define REG_SC_BK1B_02_H      _PK_H_(0x1B, 0x02)
#define REG_SC_BK1B_03_L      _PK_L_(0x1B, 0x03)
#define REG_SC_BK1B_03_H      _PK_H_(0x1B, 0x03)
#define REG_SC_BK1B_04_L      _PK_L_(0x1B, 0x04)
#define REG_SC_BK1B_04_H      _PK_H_(0x1B, 0x04)
#define REG_SC_BK1B_05_L      _PK_L_(0x1B, 0x05)
#define REG_SC_BK1B_05_H      _PK_H_(0x1B, 0x05)
#define REG_SC_BK1B_06_L      _PK_L_(0x1B, 0x06)
#define REG_SC_BK1B_06_H      _PK_H_(0x1B, 0x06)
#define REG_SC_BK1B_07_L      _PK_L_(0x1B, 0x07)
#define REG_SC_BK1B_07_H      _PK_H_(0x1B, 0x07)
#define REG_SC_BK1B_08_L      _PK_L_(0x1B, 0x08)
#define REG_SC_BK1B_08_H      _PK_H_(0x1B, 0x08)
#define REG_SC_BK1B_09_L      _PK_L_(0x1B, 0x09)
#define REG_SC_BK1B_09_H      _PK_H_(0x1B, 0x09)
#define REG_SC_BK1B_0A_L      _PK_L_(0x1B, 0x0A)
#define REG_SC_BK1B_0A_H      _PK_H_(0x1B, 0x0A)
#define REG_SC_BK1B_0B_L      _PK_L_(0x1B, 0x0B)
#define REG_SC_BK1B_0B_H      _PK_H_(0x1B, 0x0B)
#define REG_SC_BK1B_0C_L      _PK_L_(0x1B, 0x0C)
#define REG_SC_BK1B_0C_H      _PK_H_(0x1B, 0x0C)
#define REG_SC_BK1B_0D_L      _PK_L_(0x1B, 0x0D)
#define REG_SC_BK1B_0D_H      _PK_H_(0x1B, 0x0D)
#define REG_SC_BK1B_0E_L      _PK_L_(0x1B, 0x0E)
#define REG_SC_BK1B_0E_H      _PK_H_(0x1B, 0x0E)
#define REG_SC_BK1B_0F_L      _PK_L_(0x1B, 0x0F)
#define REG_SC_BK1B_0F_H      _PK_H_(0x1B, 0x0F)
#define REG_SC_BK1B_10_L      _PK_L_(0x1B, 0x10)
#define REG_SC_BK1B_10_H      _PK_H_(0x1B, 0x10)
#define REG_SC_BK1B_11_L      _PK_L_(0x1B, 0x11)
#define REG_SC_BK1B_11_H      _PK_H_(0x1B, 0x11)
#define REG_SC_BK1B_12_L      _PK_L_(0x1B, 0x12)
#define REG_SC_BK1B_12_H      _PK_H_(0x1B, 0x12)
#define REG_SC_BK1B_13_L      _PK_L_(0x1B, 0x13)
#define REG_SC_BK1B_13_H      _PK_H_(0x1B, 0x13)
#define REG_SC_BK1B_14_L      _PK_L_(0x1B, 0x14)
#define REG_SC_BK1B_14_H      _PK_H_(0x1B, 0x14)
#define REG_SC_BK1B_15_L      _PK_L_(0x1B, 0x15)
#define REG_SC_BK1B_15_H      _PK_H_(0x1B, 0x15)
#define REG_SC_BK1B_16_L      _PK_L_(0x1B, 0x16)
#define REG_SC_BK1B_16_H      _PK_H_(0x1B, 0x16)
#define REG_SC_BK1B_17_L      _PK_L_(0x1B, 0x17)
#define REG_SC_BK1B_17_H      _PK_H_(0x1B, 0x17)
#define REG_SC_BK1B_18_L      _PK_L_(0x1B, 0x18)
#define REG_SC_BK1B_18_H      _PK_H_(0x1B, 0x18)
#define REG_SC_BK1B_19_L      _PK_L_(0x1B, 0x19)
#define REG_SC_BK1B_19_H      _PK_H_(0x1B, 0x19)
#define REG_SC_BK1B_1A_L      _PK_L_(0x1B, 0x1A)
#define REG_SC_BK1B_1A_H      _PK_H_(0x1B, 0x1A)
#define REG_SC_BK1B_1B_L      _PK_L_(0x1B, 0x1B)
#define REG_SC_BK1B_1B_H      _PK_H_(0x1B, 0x1B)
#define REG_SC_BK1B_1C_L      _PK_L_(0x1B, 0x1C)
#define REG_SC_BK1B_1C_H      _PK_H_(0x1B, 0x1C)
#define REG_SC_BK1B_1D_L      _PK_L_(0x1B, 0x1D)
#define REG_SC_BK1B_1D_H      _PK_H_(0x1B, 0x1D)
#define REG_SC_BK1B_1E_L      _PK_L_(0x1B, 0x1E)
#define REG_SC_BK1B_1E_H      _PK_H_(0x1B, 0x1E)
#define REG_SC_BK1B_1F_L      _PK_L_(0x1B, 0x1F)
#define REG_SC_BK1B_1F_H      _PK_H_(0x1B, 0x1F)
#define REG_SC_BK1B_20_L      _PK_L_(0x1B, 0x20)
#define REG_SC_BK1B_20_H      _PK_H_(0x1B, 0x20)
#define REG_SC_BK1B_21_L      _PK_L_(0x1B, 0x21)
#define REG_SC_BK1B_21_H      _PK_H_(0x1B, 0x21)
#define REG_SC_BK1B_22_L      _PK_L_(0x1B, 0x22)
#define REG_SC_BK1B_22_H      _PK_H_(0x1B, 0x22)
#define REG_SC_BK1B_23_L      _PK_L_(0x1B, 0x23)
#define REG_SC_BK1B_23_H      _PK_H_(0x1B, 0x23)
#define REG_SC_BK1B_24_L      _PK_L_(0x1B, 0x24)
#define REG_SC_BK1B_24_H      _PK_H_(0x1B, 0x24)
#define REG_SC_BK1B_25_L      _PK_L_(0x1B, 0x25)
#define REG_SC_BK1B_25_H      _PK_H_(0x1B, 0x25)
#define REG_SC_BK1B_26_L      _PK_L_(0x1B, 0x26)
#define REG_SC_BK1B_26_H      _PK_H_(0x1B, 0x26)
#define REG_SC_BK1B_27_L      _PK_L_(0x1B, 0x27)
#define REG_SC_BK1B_27_H      _PK_H_(0x1B, 0x27)
#define REG_SC_BK1B_28_L      _PK_L_(0x1B, 0x28)
#define REG_SC_BK1B_28_H      _PK_H_(0x1B, 0x28)
#define REG_SC_BK1B_29_L      _PK_L_(0x1B, 0x29)
#define REG_SC_BK1B_29_H      _PK_H_(0x1B, 0x29)
#define REG_SC_BK1B_2A_L      _PK_L_(0x1B, 0x2A)
#define REG_SC_BK1B_2A_H      _PK_H_(0x1B, 0x2A)
#define REG_SC_BK1B_2B_L      _PK_L_(0x1B, 0x2B)
#define REG_SC_BK1B_2B_H      _PK_H_(0x1B, 0x2B)
#define REG_SC_BK1B_2C_L      _PK_L_(0x1B, 0x2C)
#define REG_SC_BK1B_2C_H      _PK_H_(0x1B, 0x2C)
#define REG_SC_BK1B_2D_L      _PK_L_(0x1B, 0x2D)
#define REG_SC_BK1B_2D_H      _PK_H_(0x1B, 0x2D)
#define REG_SC_BK1B_2E_L      _PK_L_(0x1B, 0x2E)
#define REG_SC_BK1B_2E_H      _PK_H_(0x1B, 0x2E)
#define REG_SC_BK1B_2F_L      _PK_L_(0x1B, 0x2F)
#define REG_SC_BK1B_2F_H      _PK_H_(0x1B, 0x2F)
#define REG_SC_BK1B_30_L      _PK_L_(0x1B, 0x30)
#define REG_SC_BK1B_30_H      _PK_H_(0x1B, 0x30)
#define REG_SC_BK1B_31_L      _PK_L_(0x1B, 0x31)
#define REG_SC_BK1B_31_H      _PK_H_(0x1B, 0x31)
#define REG_SC_BK1B_32_L      _PK_L_(0x1B, 0x32)
#define REG_SC_BK1B_32_H      _PK_H_(0x1B, 0x32)
#define REG_SC_BK1B_33_L      _PK_L_(0x1B, 0x33)
#define REG_SC_BK1B_33_H      _PK_H_(0x1B, 0x33)
#define REG_SC_BK1B_34_L      _PK_L_(0x1B, 0x34)
#define REG_SC_BK1B_34_H      _PK_H_(0x1B, 0x34)
#define REG_SC_BK1B_35_L      _PK_L_(0x1B, 0x35)
#define REG_SC_BK1B_35_H      _PK_H_(0x1B, 0x35)
#define REG_SC_BK1B_36_L      _PK_L_(0x1B, 0x36)
#define REG_SC_BK1B_36_H      _PK_H_(0x1B, 0x36)
#define REG_SC_BK1B_37_L      _PK_L_(0x1B, 0x37)
#define REG_SC_BK1B_37_H      _PK_H_(0x1B, 0x37)
#define REG_SC_BK1B_38_L      _PK_L_(0x1B, 0x38)
#define REG_SC_BK1B_38_H      _PK_H_(0x1B, 0x38)
#define REG_SC_BK1B_39_L      _PK_L_(0x1B, 0x39)
#define REG_SC_BK1B_39_H      _PK_H_(0x1B, 0x39)
#define REG_SC_BK1B_3A_L      _PK_L_(0x1B, 0x3A)
#define REG_SC_BK1B_3A_H      _PK_H_(0x1B, 0x3A)
#define REG_SC_BK1B_3B_L      _PK_L_(0x1B, 0x3B)
#define REG_SC_BK1B_3B_H      _PK_H_(0x1B, 0x3B)
#define REG_SC_BK1B_3C_L      _PK_L_(0x1B, 0x3C)
#define REG_SC_BK1B_3C_H      _PK_H_(0x1B, 0x3C)
#define REG_SC_BK1B_3D_L      _PK_L_(0x1B, 0x3D)
#define REG_SC_BK1B_3D_H      _PK_H_(0x1B, 0x3D)
#define REG_SC_BK1B_3E_L      _PK_L_(0x1B, 0x3E)
#define REG_SC_BK1B_3E_H      _PK_H_(0x1B, 0x3E)
#define REG_SC_BK1B_3F_L      _PK_L_(0x1B, 0x3F)
#define REG_SC_BK1B_3F_H      _PK_H_(0x1B, 0x3F)
#define REG_SC_BK1B_40_L      _PK_L_(0x1B, 0x40)
#define REG_SC_BK1B_40_H      _PK_H_(0x1B, 0x40)
#define REG_SC_BK1B_41_L      _PK_L_(0x1B, 0x41)
#define REG_SC_BK1B_41_H      _PK_H_(0x1B, 0x41)
#define REG_SC_BK1B_42_L      _PK_L_(0x1B, 0x42)
#define REG_SC_BK1B_42_H      _PK_H_(0x1B, 0x42)
#define REG_SC_BK1B_43_L      _PK_L_(0x1B, 0x43)
#define REG_SC_BK1B_43_H      _PK_H_(0x1B, 0x43)
#define REG_SC_BK1B_44_L      _PK_L_(0x1B, 0x44)
#define REG_SC_BK1B_44_H      _PK_H_(0x1B, 0x44)
#define REG_SC_BK1B_45_L      _PK_L_(0x1B, 0x45)
#define REG_SC_BK1B_45_H      _PK_H_(0x1B, 0x45)
#define REG_SC_BK1B_46_L      _PK_L_(0x1B, 0x46)
#define REG_SC_BK1B_46_H      _PK_H_(0x1B, 0x46)
#define REG_SC_BK1B_47_L      _PK_L_(0x1B, 0x47)
#define REG_SC_BK1B_47_H      _PK_H_(0x1B, 0x47)
#define REG_SC_BK1B_48_L      _PK_L_(0x1B, 0x48)
#define REG_SC_BK1B_48_H      _PK_H_(0x1B, 0x48)
#define REG_SC_BK1B_49_L      _PK_L_(0x1B, 0x49)
#define REG_SC_BK1B_49_H      _PK_H_(0x1B, 0x49)
#define REG_SC_BK1B_4A_L      _PK_L_(0x1B, 0x4A)
#define REG_SC_BK1B_4A_H      _PK_H_(0x1B, 0x4A)
#define REG_SC_BK1B_4B_L      _PK_L_(0x1B, 0x4B)
#define REG_SC_BK1B_4B_H      _PK_H_(0x1B, 0x4B)
#define REG_SC_BK1B_4C_L      _PK_L_(0x1B, 0x4C)
#define REG_SC_BK1B_4C_H      _PK_H_(0x1B, 0x4C)
#define REG_SC_BK1B_4D_L      _PK_L_(0x1B, 0x4D)
#define REG_SC_BK1B_4D_H      _PK_H_(0x1B, 0x4D)
#define REG_SC_BK1B_4E_L      _PK_L_(0x1B, 0x4E)
#define REG_SC_BK1B_4E_H      _PK_H_(0x1B, 0x4E)
#define REG_SC_BK1B_4F_L      _PK_L_(0x1B, 0x4F)
#define REG_SC_BK1B_4F_H      _PK_H_(0x1B, 0x4F)
#define REG_SC_BK1B_50_L      _PK_L_(0x1B, 0x50)
#define REG_SC_BK1B_50_H      _PK_H_(0x1B, 0x50)
#define REG_SC_BK1B_51_L      _PK_L_(0x1B, 0x51)
#define REG_SC_BK1B_51_H      _PK_H_(0x1B, 0x51)
#define REG_SC_BK1B_52_L      _PK_L_(0x1B, 0x52)
#define REG_SC_BK1B_52_H      _PK_H_(0x1B, 0x52)
#define REG_SC_BK1B_53_L      _PK_L_(0x1B, 0x53)
#define REG_SC_BK1B_53_H      _PK_H_(0x1B, 0x53)
#define REG_SC_BK1B_54_L      _PK_L_(0x1B, 0x54)
#define REG_SC_BK1B_54_H      _PK_H_(0x1B, 0x54)
#define REG_SC_BK1B_55_L      _PK_L_(0x1B, 0x55)
#define REG_SC_BK1B_55_H      _PK_H_(0x1B, 0x55)
#define REG_SC_BK1B_56_L      _PK_L_(0x1B, 0x56)
#define REG_SC_BK1B_56_H      _PK_H_(0x1B, 0x56)
#define REG_SC_BK1B_57_L      _PK_L_(0x1B, 0x57)
#define REG_SC_BK1B_57_H      _PK_H_(0x1B, 0x57)
#define REG_SC_BK1B_58_L      _PK_L_(0x1B, 0x58)
#define REG_SC_BK1B_58_H      _PK_H_(0x1B, 0x58)
#define REG_SC_BK1B_59_L      _PK_L_(0x1B, 0x59)
#define REG_SC_BK1B_59_H      _PK_H_(0x1B, 0x59)
#define REG_SC_BK1B_5A_L      _PK_L_(0x1B, 0x5A)
#define REG_SC_BK1B_5A_H      _PK_H_(0x1B, 0x5A)
#define REG_SC_BK1B_5B_L      _PK_L_(0x1B, 0x5B)
#define REG_SC_BK1B_5B_H      _PK_H_(0x1B, 0x5B)
#define REG_SC_BK1B_5C_L      _PK_L_(0x1B, 0x5C)
#define REG_SC_BK1B_5C_H      _PK_H_(0x1B, 0x5C)
#define REG_SC_BK1B_5D_L      _PK_L_(0x1B, 0x5D)
#define REG_SC_BK1B_5D_H      _PK_H_(0x1B, 0x5D)
#define REG_SC_BK1B_5E_L      _PK_L_(0x1B, 0x5E)
#define REG_SC_BK1B_5E_H      _PK_H_(0x1B, 0x5E)
#define REG_SC_BK1B_5F_L      _PK_L_(0x1B, 0x5F)
#define REG_SC_BK1B_5F_H      _PK_H_(0x1B, 0x5F)
#define REG_SC_BK1B_60_L      _PK_L_(0x1B, 0x60)
#define REG_SC_BK1B_60_H      _PK_H_(0x1B, 0x60)
#define REG_SC_BK1B_61_L      _PK_L_(0x1B, 0x61)
#define REG_SC_BK1B_61_H      _PK_H_(0x1B, 0x61)
#define REG_SC_BK1B_62_L      _PK_L_(0x1B, 0x62)
#define REG_SC_BK1B_62_H      _PK_H_(0x1B, 0x62)
#define REG_SC_BK1B_63_L      _PK_L_(0x1B, 0x63)
#define REG_SC_BK1B_63_H      _PK_H_(0x1B, 0x63)
#define REG_SC_BK1B_64_L      _PK_L_(0x1B, 0x64)
#define REG_SC_BK1B_64_H      _PK_H_(0x1B, 0x64)
#define REG_SC_BK1B_65_L      _PK_L_(0x1B, 0x65)
#define REG_SC_BK1B_65_H      _PK_H_(0x1B, 0x65)
#define REG_SC_BK1B_66_L      _PK_L_(0x1B, 0x66)
#define REG_SC_BK1B_66_H      _PK_H_(0x1B, 0x66)
#define REG_SC_BK1B_67_L      _PK_L_(0x1B, 0x67)
#define REG_SC_BK1B_67_H      _PK_H_(0x1B, 0x67)
#define REG_SC_BK1B_68_L      _PK_L_(0x1B, 0x68)
#define REG_SC_BK1B_68_H      _PK_H_(0x1B, 0x68)
#define REG_SC_BK1B_69_L      _PK_L_(0x1B, 0x69)
#define REG_SC_BK1B_69_H      _PK_H_(0x1B, 0x69)
#define REG_SC_BK1B_6A_L      _PK_L_(0x1B, 0x6A)
#define REG_SC_BK1B_6A_H      _PK_H_(0x1B, 0x6A)
#define REG_SC_BK1B_6B_L      _PK_L_(0x1B, 0x6B)
#define REG_SC_BK1B_6B_H      _PK_H_(0x1B, 0x6B)
#define REG_SC_BK1B_6C_L      _PK_L_(0x1B, 0x6C)
#define REG_SC_BK1B_6C_H      _PK_H_(0x1B, 0x6C)
#define REG_SC_BK1B_6D_L      _PK_L_(0x1B, 0x6D)
#define REG_SC_BK1B_6D_H      _PK_H_(0x1B, 0x6D)
#define REG_SC_BK1B_6E_L      _PK_L_(0x1B, 0x6E)
#define REG_SC_BK1B_6E_H      _PK_H_(0x1B, 0x6E)
#define REG_SC_BK1B_6F_L      _PK_L_(0x1B, 0x6F)
#define REG_SC_BK1B_6F_H      _PK_H_(0x1B, 0x6F)
#define REG_SC_BK1B_70_L      _PK_L_(0x1B, 0x70)
#define REG_SC_BK1B_70_H      _PK_H_(0x1B, 0x70)
#define REG_SC_BK1B_71_L      _PK_L_(0x1B, 0x71)
#define REG_SC_BK1B_71_H      _PK_H_(0x1B, 0x71)
#define REG_SC_BK1B_72_L      _PK_L_(0x1B, 0x72)
#define REG_SC_BK1B_72_H      _PK_H_(0x1B, 0x72)
#define REG_SC_BK1B_73_L      _PK_L_(0x1B, 0x73)
#define REG_SC_BK1B_73_H      _PK_H_(0x1B, 0x73)
#define REG_SC_BK1B_74_L      _PK_L_(0x1B, 0x74)
#define REG_SC_BK1B_74_H      _PK_H_(0x1B, 0x74)
#define REG_SC_BK1B_75_L      _PK_L_(0x1B, 0x75)
#define REG_SC_BK1B_75_H      _PK_H_(0x1B, 0x75)
#define REG_SC_BK1B_76_L      _PK_L_(0x1B, 0x76)
#define REG_SC_BK1B_76_H      _PK_H_(0x1B, 0x76)
#define REG_SC_BK1B_77_L      _PK_L_(0x1B, 0x77)
#define REG_SC_BK1B_77_H      _PK_H_(0x1B, 0x77)
#define REG_SC_BK1B_78_L      _PK_L_(0x1B, 0x78)
#define REG_SC_BK1B_78_H      _PK_H_(0x1B, 0x78)
#define REG_SC_BK1B_79_L      _PK_L_(0x1B, 0x79)
#define REG_SC_BK1B_79_H      _PK_H_(0x1B, 0x79)
#define REG_SC_BK1B_7A_L      _PK_L_(0x1B, 0x7A)
#define REG_SC_BK1B_7A_H      _PK_H_(0x1B, 0x7A)
#define REG_SC_BK1B_7B_L      _PK_L_(0x1B, 0x7B)
#define REG_SC_BK1B_7B_H      _PK_H_(0x1B, 0x7B)
#define REG_SC_BK1B_7C_L      _PK_L_(0x1B, 0x7C)
#define REG_SC_BK1B_7C_H      _PK_H_(0x1B, 0x7C)
#define REG_SC_BK1B_7D_L      _PK_L_(0x1B, 0x7D)
#define REG_SC_BK1B_7D_H      _PK_H_(0x1B, 0x7D)
#define REG_SC_BK1B_7E_L      _PK_L_(0x1B, 0x7E)
#define REG_SC_BK1B_7E_H      _PK_H_(0x1B, 0x7E)
#define REG_SC_BK1B_7F_L      _PK_L_(0x1B, 0x7F)
#define REG_SC_BK1B_7F_H      _PK_H_(0x1B, 0x7F)



#define REG_SC_BK1C_00_L      _PK_L_(0x1C, 0x00)
#define REG_SC_BK1C_00_H      _PK_H_(0x1C, 0x00)
#define REG_SC_BK1C_01_L      _PK_L_(0x1C, 0x01)
#define REG_SC_BK1C_01_H      _PK_H_(0x1C, 0x01)
#define REG_SC_BK1C_02_L      _PK_L_(0x1C, 0x02)
#define REG_SC_BK1C_02_H      _PK_H_(0x1C, 0x02)
#define REG_SC_BK1C_03_L      _PK_L_(0x1C, 0x03)
#define REG_SC_BK1C_03_H      _PK_H_(0x1C, 0x03)
#define REG_SC_BK1C_04_L      _PK_L_(0x1C, 0x04)
#define REG_SC_BK1C_04_H      _PK_H_(0x1C, 0x04)
#define REG_SC_BK1C_05_L      _PK_L_(0x1C, 0x05)
#define REG_SC_BK1C_05_H      _PK_H_(0x1C, 0x05)
#define REG_SC_BK1C_06_L      _PK_L_(0x1C, 0x06)
#define REG_SC_BK1C_06_H      _PK_H_(0x1C, 0x06)
#define REG_SC_BK1C_07_L      _PK_L_(0x1C, 0x07)
#define REG_SC_BK1C_07_H      _PK_H_(0x1C, 0x07)
#define REG_SC_BK1C_08_L      _PK_L_(0x1C, 0x08)
#define REG_SC_BK1C_08_H      _PK_H_(0x1C, 0x08)
#define REG_SC_BK1C_09_L      _PK_L_(0x1C, 0x09)
#define REG_SC_BK1C_09_H      _PK_H_(0x1C, 0x09)
#define REG_SC_BK1C_0A_L      _PK_L_(0x1C, 0x0A)
#define REG_SC_BK1C_0A_H      _PK_H_(0x1C, 0x0A)
#define REG_SC_BK1C_0B_L      _PK_L_(0x1C, 0x0B)
#define REG_SC_BK1C_0B_H      _PK_H_(0x1C, 0x0B)
#define REG_SC_BK1C_0C_L      _PK_L_(0x1C, 0x0C)
#define REG_SC_BK1C_0C_H      _PK_H_(0x1C, 0x0C)
#define REG_SC_BK1C_0D_L      _PK_L_(0x1C, 0x0D)
#define REG_SC_BK1C_0D_H      _PK_H_(0x1C, 0x0D)
#define REG_SC_BK1C_0E_L      _PK_L_(0x1C, 0x0E)
#define REG_SC_BK1C_0E_H      _PK_H_(0x1C, 0x0E)
#define REG_SC_BK1C_0F_L      _PK_L_(0x1C, 0x0F)
#define REG_SC_BK1C_0F_H      _PK_H_(0x1C, 0x0F)
#define REG_SC_BK1C_10_L      _PK_L_(0x1C, 0x10)
#define REG_SC_BK1C_10_H      _PK_H_(0x1C, 0x10)
#define REG_SC_BK1C_11_L      _PK_L_(0x1C, 0x11)
#define REG_SC_BK1C_11_H      _PK_H_(0x1C, 0x11)
#define REG_SC_BK1C_12_L      _PK_L_(0x1C, 0x12)
#define REG_SC_BK1C_12_H      _PK_H_(0x1C, 0x12)
#define REG_SC_BK1C_13_L      _PK_L_(0x1C, 0x13)
#define REG_SC_BK1C_13_H      _PK_H_(0x1C, 0x13)
#define REG_SC_BK1C_14_L      _PK_L_(0x1C, 0x14)
#define REG_SC_BK1C_14_H      _PK_H_(0x1C, 0x14)
#define REG_SC_BK1C_15_L      _PK_L_(0x1C, 0x15)
#define REG_SC_BK1C_15_H      _PK_H_(0x1C, 0x15)
#define REG_SC_BK1C_16_L      _PK_L_(0x1C, 0x16)
#define REG_SC_BK1C_16_H      _PK_H_(0x1C, 0x16)
#define REG_SC_BK1C_17_L      _PK_L_(0x1C, 0x17)
#define REG_SC_BK1C_17_H      _PK_H_(0x1C, 0x17)
#define REG_SC_BK1C_18_L      _PK_L_(0x1C, 0x18)
#define REG_SC_BK1C_18_H      _PK_H_(0x1C, 0x18)
#define REG_SC_BK1C_19_L      _PK_L_(0x1C, 0x19)
#define REG_SC_BK1C_19_H      _PK_H_(0x1C, 0x19)
#define REG_SC_BK1C_1A_L      _PK_L_(0x1C, 0x1A)
#define REG_SC_BK1C_1A_H      _PK_H_(0x1C, 0x1A)
#define REG_SC_BK1C_1B_L      _PK_L_(0x1C, 0x1B)
#define REG_SC_BK1C_1B_H      _PK_H_(0x1C, 0x1B)
#define REG_SC_BK1C_1C_L      _PK_L_(0x1C, 0x1C)
#define REG_SC_BK1C_1C_H      _PK_H_(0x1C, 0x1C)
#define REG_SC_BK1C_1D_L      _PK_L_(0x1C, 0x1D)
#define REG_SC_BK1C_1D_H      _PK_H_(0x1C, 0x1D)
#define REG_SC_BK1C_1E_L      _PK_L_(0x1C, 0x1E)
#define REG_SC_BK1C_1E_H      _PK_H_(0x1C, 0x1E)
#define REG_SC_BK1C_1F_L      _PK_L_(0x1C, 0x1F)
#define REG_SC_BK1C_1F_H      _PK_H_(0x1C, 0x1F)
#define REG_SC_BK1C_20_L      _PK_L_(0x1C, 0x20)
#define REG_SC_BK1C_20_H      _PK_H_(0x1C, 0x20)
#define REG_SC_BK1C_21_L      _PK_L_(0x1C, 0x21)
#define REG_SC_BK1C_21_H      _PK_H_(0x1C, 0x21)
#define REG_SC_BK1C_22_L      _PK_L_(0x1C, 0x22)
#define REG_SC_BK1C_22_H      _PK_H_(0x1C, 0x22)
#define REG_SC_BK1C_23_L      _PK_L_(0x1C, 0x23)
#define REG_SC_BK1C_23_H      _PK_H_(0x1C, 0x23)
#define REG_SC_BK1C_24_L      _PK_L_(0x1C, 0x24)
#define REG_SC_BK1C_24_H      _PK_H_(0x1C, 0x24)
#define REG_SC_BK1C_25_L      _PK_L_(0x1C, 0x25)
#define REG_SC_BK1C_25_H      _PK_H_(0x1C, 0x25)
#define REG_SC_BK1C_26_L      _PK_L_(0x1C, 0x26)
#define REG_SC_BK1C_26_H      _PK_H_(0x1C, 0x26)
#define REG_SC_BK1C_27_L      _PK_L_(0x1C, 0x27)
#define REG_SC_BK1C_27_H      _PK_H_(0x1C, 0x27)
#define REG_SC_BK1C_28_L      _PK_L_(0x1C, 0x28)
#define REG_SC_BK1C_28_H      _PK_H_(0x1C, 0x28)
#define REG_SC_BK1C_29_L      _PK_L_(0x1C, 0x29)
#define REG_SC_BK1C_29_H      _PK_H_(0x1C, 0x29)
#define REG_SC_BK1C_2A_L      _PK_L_(0x1C, 0x2A)
#define REG_SC_BK1C_2A_H      _PK_H_(0x1C, 0x2A)
#define REG_SC_BK1C_2B_L      _PK_L_(0x1C, 0x2B)
#define REG_SC_BK1C_2B_H      _PK_H_(0x1C, 0x2B)
#define REG_SC_BK1C_2C_L      _PK_L_(0x1C, 0x2C)
#define REG_SC_BK1C_2C_H      _PK_H_(0x1C, 0x2C)
#define REG_SC_BK1C_2D_L      _PK_L_(0x1C, 0x2D)
#define REG_SC_BK1C_2D_H      _PK_H_(0x1C, 0x2D)
#define REG_SC_BK1C_2E_L      _PK_L_(0x1C, 0x2E)
#define REG_SC_BK1C_2E_H      _PK_H_(0x1C, 0x2E)
#define REG_SC_BK1C_2F_L      _PK_L_(0x1C, 0x2F)
#define REG_SC_BK1C_2F_H      _PK_H_(0x1C, 0x2F)
#define REG_SC_BK1C_30_L      _PK_L_(0x1C, 0x30)
#define REG_SC_BK1C_30_H      _PK_H_(0x1C, 0x30)
#define REG_SC_BK1C_31_L      _PK_L_(0x1C, 0x31)
#define REG_SC_BK1C_31_H      _PK_H_(0x1C, 0x31)
#define REG_SC_BK1C_32_L      _PK_L_(0x1C, 0x32)
#define REG_SC_BK1C_32_H      _PK_H_(0x1C, 0x32)
#define REG_SC_BK1C_33_L      _PK_L_(0x1C, 0x33)
#define REG_SC_BK1C_33_H      _PK_H_(0x1C, 0x33)
#define REG_SC_BK1C_34_L      _PK_L_(0x1C, 0x34)
#define REG_SC_BK1C_34_H      _PK_H_(0x1C, 0x34)
#define REG_SC_BK1C_35_L      _PK_L_(0x1C, 0x35)
#define REG_SC_BK1C_35_H      _PK_H_(0x1C, 0x35)
#define REG_SC_BK1C_36_L      _PK_L_(0x1C, 0x36)
#define REG_SC_BK1C_36_H      _PK_H_(0x1C, 0x36)
#define REG_SC_BK1C_37_L      _PK_L_(0x1C, 0x37)
#define REG_SC_BK1C_37_H      _PK_H_(0x1C, 0x37)
#define REG_SC_BK1C_38_L      _PK_L_(0x1C, 0x38)
#define REG_SC_BK1C_38_H      _PK_H_(0x1C, 0x38)
#define REG_SC_BK1C_39_L      _PK_L_(0x1C, 0x39)
#define REG_SC_BK1C_39_H      _PK_H_(0x1C, 0x39)
#define REG_SC_BK1C_3A_L      _PK_L_(0x1C, 0x3A)
#define REG_SC_BK1C_3A_H      _PK_H_(0x1C, 0x3A)
#define REG_SC_BK1C_3B_L      _PK_L_(0x1C, 0x3B)
#define REG_SC_BK1C_3B_H      _PK_H_(0x1C, 0x3B)
#define REG_SC_BK1C_3C_L      _PK_L_(0x1C, 0x3C)
#define REG_SC_BK1C_3C_H      _PK_H_(0x1C, 0x3C)
#define REG_SC_BK1C_3D_L      _PK_L_(0x1C, 0x3D)
#define REG_SC_BK1C_3D_H      _PK_H_(0x1C, 0x3D)
#define REG_SC_BK1C_3E_L      _PK_L_(0x1C, 0x3E)
#define REG_SC_BK1C_3E_H      _PK_H_(0x1C, 0x3E)
#define REG_SC_BK1C_3F_L      _PK_L_(0x1C, 0x3F)
#define REG_SC_BK1C_3F_H      _PK_H_(0x1C, 0x3F)
#define REG_SC_BK1C_40_L      _PK_L_(0x1C, 0x40)
#define REG_SC_BK1C_40_H      _PK_H_(0x1C, 0x40)
#define REG_SC_BK1C_41_L      _PK_L_(0x1C, 0x41)
#define REG_SC_BK1C_41_H      _PK_H_(0x1C, 0x41)
#define REG_SC_BK1C_42_L      _PK_L_(0x1C, 0x42)
#define REG_SC_BK1C_42_H      _PK_H_(0x1C, 0x42)
#define REG_SC_BK1C_43_L      _PK_L_(0x1C, 0x43)
#define REG_SC_BK1C_43_H      _PK_H_(0x1C, 0x43)
#define REG_SC_BK1C_44_L      _PK_L_(0x1C, 0x44)
#define REG_SC_BK1C_44_H      _PK_H_(0x1C, 0x44)
#define REG_SC_BK1C_45_L      _PK_L_(0x1C, 0x45)
#define REG_SC_BK1C_45_H      _PK_H_(0x1C, 0x45)
#define REG_SC_BK1C_46_L      _PK_L_(0x1C, 0x46)
#define REG_SC_BK1C_46_H      _PK_H_(0x1C, 0x46)
#define REG_SC_BK1C_47_L      _PK_L_(0x1C, 0x47)
#define REG_SC_BK1C_47_H      _PK_H_(0x1C, 0x47)
#define REG_SC_BK1C_48_L      _PK_L_(0x1C, 0x48)
#define REG_SC_BK1C_48_H      _PK_H_(0x1C, 0x48)
#define REG_SC_BK1C_49_L      _PK_L_(0x1C, 0x49)
#define REG_SC_BK1C_49_H      _PK_H_(0x1C, 0x49)
#define REG_SC_BK1C_4A_L      _PK_L_(0x1C, 0x4A)
#define REG_SC_BK1C_4A_H      _PK_H_(0x1C, 0x4A)
#define REG_SC_BK1C_4B_L      _PK_L_(0x1C, 0x4B)
#define REG_SC_BK1C_4B_H      _PK_H_(0x1C, 0x4B)
#define REG_SC_BK1C_4C_L      _PK_L_(0x1C, 0x4C)
#define REG_SC_BK1C_4C_H      _PK_H_(0x1C, 0x4C)
#define REG_SC_BK1C_4D_L      _PK_L_(0x1C, 0x4D)
#define REG_SC_BK1C_4D_H      _PK_H_(0x1C, 0x4D)
#define REG_SC_BK1C_4E_L      _PK_L_(0x1C, 0x4E)
#define REG_SC_BK1C_4E_H      _PK_H_(0x1C, 0x4E)
#define REG_SC_BK1C_4F_L      _PK_L_(0x1C, 0x4F)
#define REG_SC_BK1C_4F_H      _PK_H_(0x1C, 0x4F)
#define REG_SC_BK1C_50_L      _PK_L_(0x1C, 0x50)
#define REG_SC_BK1C_50_H      _PK_H_(0x1C, 0x50)
#define REG_SC_BK1C_51_L      _PK_L_(0x1C, 0x51)
#define REG_SC_BK1C_51_H      _PK_H_(0x1C, 0x51)
#define REG_SC_BK1C_52_L      _PK_L_(0x1C, 0x52)
#define REG_SC_BK1C_52_H      _PK_H_(0x1C, 0x52)
#define REG_SC_BK1C_53_L      _PK_L_(0x1C, 0x53)
#define REG_SC_BK1C_53_H      _PK_H_(0x1C, 0x53)
#define REG_SC_BK1C_54_L      _PK_L_(0x1C, 0x54)
#define REG_SC_BK1C_54_H      _PK_H_(0x1C, 0x54)
#define REG_SC_BK1C_55_L      _PK_L_(0x1C, 0x55)
#define REG_SC_BK1C_55_H      _PK_H_(0x1C, 0x55)
#define REG_SC_BK1C_56_L      _PK_L_(0x1C, 0x56)
#define REG_SC_BK1C_56_H      _PK_H_(0x1C, 0x56)
#define REG_SC_BK1C_57_L      _PK_L_(0x1C, 0x57)
#define REG_SC_BK1C_57_H      _PK_H_(0x1C, 0x57)
#define REG_SC_BK1C_58_L      _PK_L_(0x1C, 0x58)
#define REG_SC_BK1C_58_H      _PK_H_(0x1C, 0x58)
#define REG_SC_BK1C_59_L      _PK_L_(0x1C, 0x59)
#define REG_SC_BK1C_59_H      _PK_H_(0x1C, 0x59)
#define REG_SC_BK1C_5A_L      _PK_L_(0x1C, 0x5A)
#define REG_SC_BK1C_5A_H      _PK_H_(0x1C, 0x5A)
#define REG_SC_BK1C_5B_L      _PK_L_(0x1C, 0x5B)
#define REG_SC_BK1C_5B_H      _PK_H_(0x1C, 0x5B)
#define REG_SC_BK1C_5C_L      _PK_L_(0x1C, 0x5C)
#define REG_SC_BK1C_5C_H      _PK_H_(0x1C, 0x5C)
#define REG_SC_BK1C_5D_L      _PK_L_(0x1C, 0x5D)
#define REG_SC_BK1C_5D_H      _PK_H_(0x1C, 0x5D)
#define REG_SC_BK1C_5E_L      _PK_L_(0x1C, 0x5E)
#define REG_SC_BK1C_5E_H      _PK_H_(0x1C, 0x5E)
#define REG_SC_BK1C_5F_L      _PK_L_(0x1C, 0x5F)
#define REG_SC_BK1C_5F_H      _PK_H_(0x1C, 0x5F)
#define REG_SC_BK1C_60_L      _PK_L_(0x1C, 0x60)
#define REG_SC_BK1C_60_H      _PK_H_(0x1C, 0x60)
#define REG_SC_BK1C_61_L      _PK_L_(0x1C, 0x61)
#define REG_SC_BK1C_61_H      _PK_H_(0x1C, 0x61)
#define REG_SC_BK1C_62_L      _PK_L_(0x1C, 0x62)
#define REG_SC_BK1C_62_H      _PK_H_(0x1C, 0x62)
#define REG_SC_BK1C_63_L      _PK_L_(0x1C, 0x63)
#define REG_SC_BK1C_63_H      _PK_H_(0x1C, 0x63)
#define REG_SC_BK1C_64_L      _PK_L_(0x1C, 0x64)
#define REG_SC_BK1C_64_H      _PK_H_(0x1C, 0x64)
#define REG_SC_BK1C_65_L      _PK_L_(0x1C, 0x65)
#define REG_SC_BK1C_65_H      _PK_H_(0x1C, 0x65)
#define REG_SC_BK1C_66_L      _PK_L_(0x1C, 0x66)
#define REG_SC_BK1C_66_H      _PK_H_(0x1C, 0x66)
#define REG_SC_BK1C_67_L      _PK_L_(0x1C, 0x67)
#define REG_SC_BK1C_67_H      _PK_H_(0x1C, 0x67)
#define REG_SC_BK1C_68_L      _PK_L_(0x1C, 0x68)
#define REG_SC_BK1C_68_H      _PK_H_(0x1C, 0x68)
#define REG_SC_BK1C_69_L      _PK_L_(0x1C, 0x69)
#define REG_SC_BK1C_69_H      _PK_H_(0x1C, 0x69)
#define REG_SC_BK1C_6A_L      _PK_L_(0x1C, 0x6A)
#define REG_SC_BK1C_6A_H      _PK_H_(0x1C, 0x6A)
#define REG_SC_BK1C_6B_L      _PK_L_(0x1C, 0x6B)
#define REG_SC_BK1C_6B_H      _PK_H_(0x1C, 0x6B)
#define REG_SC_BK1C_6C_L      _PK_L_(0x1C, 0x6C)
#define REG_SC_BK1C_6C_H      _PK_H_(0x1C, 0x6C)
#define REG_SC_BK1C_6D_L      _PK_L_(0x1C, 0x6D)
#define REG_SC_BK1C_6D_H      _PK_H_(0x1C, 0x6D)
#define REG_SC_BK1C_6E_L      _PK_L_(0x1C, 0x6E)
#define REG_SC_BK1C_6E_H      _PK_H_(0x1C, 0x6E)
#define REG_SC_BK1C_6F_L      _PK_L_(0x1C, 0x6F)
#define REG_SC_BK1C_6F_H      _PK_H_(0x1C, 0x6F)
#define REG_SC_BK1C_70_L      _PK_L_(0x1C, 0x70)
#define REG_SC_BK1C_70_H      _PK_H_(0x1C, 0x70)
#define REG_SC_BK1C_71_L      _PK_L_(0x1C, 0x71)
#define REG_SC_BK1C_71_H      _PK_H_(0x1C, 0x71)
#define REG_SC_BK1C_72_L      _PK_L_(0x1C, 0x72)
#define REG_SC_BK1C_72_H      _PK_H_(0x1C, 0x72)
#define REG_SC_BK1C_73_L      _PK_L_(0x1C, 0x73)
#define REG_SC_BK1C_73_H      _PK_H_(0x1C, 0x73)
#define REG_SC_BK1C_74_L      _PK_L_(0x1C, 0x74)
#define REG_SC_BK1C_74_H      _PK_H_(0x1C, 0x74)
#define REG_SC_BK1C_75_L      _PK_L_(0x1C, 0x75)
#define REG_SC_BK1C_75_H      _PK_H_(0x1C, 0x75)
#define REG_SC_BK1C_76_L      _PK_L_(0x1C, 0x76)
#define REG_SC_BK1C_76_H      _PK_H_(0x1C, 0x76)
#define REG_SC_BK1C_77_L      _PK_L_(0x1C, 0x77)
#define REG_SC_BK1C_77_H      _PK_H_(0x1C, 0x77)
#define REG_SC_BK1C_78_L      _PK_L_(0x1C, 0x78)
#define REG_SC_BK1C_78_H      _PK_H_(0x1C, 0x78)
#define REG_SC_BK1C_79_L      _PK_L_(0x1C, 0x79)
#define REG_SC_BK1C_79_H      _PK_H_(0x1C, 0x79)
#define REG_SC_BK1C_7A_L      _PK_L_(0x1C, 0x7A)
#define REG_SC_BK1C_7A_H      _PK_H_(0x1C, 0x7A)
#define REG_SC_BK1C_7B_L      _PK_L_(0x1C, 0x7B)
#define REG_SC_BK1C_7B_H      _PK_H_(0x1C, 0x7B)
#define REG_SC_BK1C_7C_L      _PK_L_(0x1C, 0x7C)
#define REG_SC_BK1C_7C_H      _PK_H_(0x1C, 0x7C)
#define REG_SC_BK1C_7D_L      _PK_L_(0x1C, 0x7D)
#define REG_SC_BK1C_7D_H      _PK_H_(0x1C, 0x7D)
#define REG_SC_BK1C_7E_L      _PK_L_(0x1C, 0x7E)
#define REG_SC_BK1C_7E_H      _PK_H_(0x1C, 0x7E)
#define REG_SC_BK1C_7F_L      _PK_L_(0x1C, 0x7F)
#define REG_SC_BK1C_7F_H      _PK_H_(0x1C, 0x7F)

////

//----------------------------------------------
//  BK1D: MFC
//----------------------------------------------
#define REG_SC_BK1D_00_L      _PK_L_(0x1D, 0x00)
#define REG_SC_BK1D_00_H      _PK_H_(0x1D, 0x00)
#define REG_SC_BK1D_01_L      _PK_L_(0x1D, 0x01)
#define REG_SC_BK1D_01_H      _PK_H_(0x1D, 0x01)
#define REG_SC_BK1D_02_L      _PK_L_(0x1D, 0x02)
#define REG_SC_BK1D_02_H      _PK_H_(0x1D, 0x02)
#define REG_SC_BK1D_03_L      _PK_L_(0x1D, 0x03)
#define REG_SC_BK1D_03_H      _PK_H_(0x1D, 0x03)
#define REG_SC_BK1D_04_L      _PK_L_(0x1D, 0x04)
#define REG_SC_BK1D_04_H      _PK_H_(0x1D, 0x04)
#define REG_SC_BK1D_05_L      _PK_L_(0x1D, 0x05)
#define REG_SC_BK1D_05_H      _PK_H_(0x1D, 0x05)
#define REG_SC_BK1D_06_L      _PK_L_(0x1D, 0x06)
#define REG_SC_BK1D_06_H      _PK_H_(0x1D, 0x06)
#define REG_SC_BK1D_07_L      _PK_L_(0x1D, 0x07)
#define REG_SC_BK1D_07_H      _PK_H_(0x1D, 0x07)
#define REG_SC_BK1D_08_L      _PK_L_(0x1D, 0x08)
#define REG_SC_BK1D_08_H      _PK_H_(0x1D, 0x08)
#define REG_SC_BK1D_09_L      _PK_L_(0x1D, 0x09)
#define REG_SC_BK1D_09_H      _PK_H_(0x1D, 0x09)
#define REG_SC_BK1D_0A_L      _PK_L_(0x1D, 0x0A)
#define REG_SC_BK1D_0A_H      _PK_H_(0x1D, 0x0A)
#define REG_SC_BK1D_0B_L      _PK_L_(0x1D, 0x0B)
#define REG_SC_BK1D_0B_H      _PK_H_(0x1D, 0x0B)
#define REG_SC_BK1D_0C_L      _PK_L_(0x1D, 0x0C)
#define REG_SC_BK1D_0C_H      _PK_H_(0x1D, 0x0C)
#define REG_SC_BK1D_0D_L      _PK_L_(0x1D, 0x0D)
#define REG_SC_BK1D_0D_H      _PK_H_(0x1D, 0x0D)
#define REG_SC_BK1D_0E_L      _PK_L_(0x1D, 0x0E)
#define REG_SC_BK1D_0E_H      _PK_H_(0x1D, 0x0E)
#define REG_SC_BK1D_0F_L      _PK_L_(0x1D, 0x0F)
#define REG_SC_BK1D_0F_H      _PK_H_(0x1D, 0x0F)
#define REG_SC_BK1D_10_L      _PK_L_(0x1D, 0x10)
#define REG_SC_BK1D_10_H      _PK_H_(0x1D, 0x10)
#define REG_SC_BK1D_11_L      _PK_L_(0x1D, 0x11)
#define REG_SC_BK1D_11_H      _PK_H_(0x1D, 0x11)
#define REG_SC_BK1D_12_L      _PK_L_(0x1D, 0x12)
#define REG_SC_BK1D_12_H      _PK_H_(0x1D, 0x12)
#define REG_SC_BK1D_13_L      _PK_L_(0x1D, 0x13)
#define REG_SC_BK1D_13_H      _PK_H_(0x1D, 0x13)
#define REG_SC_BK1D_14_L      _PK_L_(0x1D, 0x14)
#define REG_SC_BK1D_14_H      _PK_H_(0x1D, 0x14)
#define REG_SC_BK1D_15_L      _PK_L_(0x1D, 0x15)
#define REG_SC_BK1D_15_H      _PK_H_(0x1D, 0x15)
#define REG_SC_BK1D_16_L      _PK_L_(0x1D, 0x16)
#define REG_SC_BK1D_16_H      _PK_H_(0x1D, 0x16)
#define REG_SC_BK1D_17_L      _PK_L_(0x1D, 0x17)
#define REG_SC_BK1D_17_H      _PK_H_(0x1D, 0x17)
#define REG_SC_BK1D_18_L      _PK_L_(0x1D, 0x18)
#define REG_SC_BK1D_18_H      _PK_H_(0x1D, 0x18)
#define REG_SC_BK1D_19_L      _PK_L_(0x1D, 0x19)
#define REG_SC_BK1D_19_H      _PK_H_(0x1D, 0x19)
#define REG_SC_BK1D_1A_L      _PK_L_(0x1D, 0x1A)
#define REG_SC_BK1D_1A_H      _PK_H_(0x1D, 0x1A)
#define REG_SC_BK1D_1B_L      _PK_L_(0x1D, 0x1B)
#define REG_SC_BK1D_1B_H      _PK_H_(0x1D, 0x1B)
#define REG_SC_BK1D_1C_L      _PK_L_(0x1D, 0x1C)
#define REG_SC_BK1D_1C_H      _PK_H_(0x1D, 0x1C)
#define REG_SC_BK1D_1D_L      _PK_L_(0x1D, 0x1D)
#define REG_SC_BK1D_1D_H      _PK_H_(0x1D, 0x1D)
#define REG_SC_BK1D_1E_L      _PK_L_(0x1D, 0x1E)
#define REG_SC_BK1D_1E_H      _PK_H_(0x1D, 0x1E)
#define REG_SC_BK1D_1F_L      _PK_L_(0x1D, 0x1F)
#define REG_SC_BK1D_1F_H      _PK_H_(0x1D, 0x1F)
#define REG_SC_BK1D_20_L      _PK_L_(0x1D, 0x20)
#define REG_SC_BK1D_20_H      _PK_H_(0x1D, 0x20)
#define REG_SC_BK1D_21_L      _PK_L_(0x1D, 0x21)
#define REG_SC_BK1D_21_H      _PK_H_(0x1D, 0x21)
#define REG_SC_BK1D_22_L      _PK_L_(0x1D, 0x22)
#define REG_SC_BK1D_22_H      _PK_H_(0x1D, 0x22)
#define REG_SC_BK1D_23_L      _PK_L_(0x1D, 0x23)
#define REG_SC_BK1D_23_H      _PK_H_(0x1D, 0x23)
#define REG_SC_BK1D_24_L      _PK_L_(0x1D, 0x24)
#define REG_SC_BK1D_24_H      _PK_H_(0x1D, 0x24)
#define REG_SC_BK1D_25_L      _PK_L_(0x1D, 0x25)
#define REG_SC_BK1D_25_H      _PK_H_(0x1D, 0x25)
#define REG_SC_BK1D_26_L      _PK_L_(0x1D, 0x26)
#define REG_SC_BK1D_26_H      _PK_H_(0x1D, 0x26)
#define REG_SC_BK1D_27_L      _PK_L_(0x1D, 0x27)
#define REG_SC_BK1D_27_H      _PK_H_(0x1D, 0x27)
#define REG_SC_BK1D_28_L      _PK_L_(0x1D, 0x28)
#define REG_SC_BK1D_28_H      _PK_H_(0x1D, 0x28)
#define REG_SC_BK1D_29_L      _PK_L_(0x1D, 0x29)
#define REG_SC_BK1D_29_H      _PK_H_(0x1D, 0x29)
#define REG_SC_BK1D_2A_L      _PK_L_(0x1D, 0x2A)
#define REG_SC_BK1D_2A_H      _PK_H_(0x1D, 0x2A)
#define REG_SC_BK1D_2B_L      _PK_L_(0x1D, 0x2B)
#define REG_SC_BK1D_2B_H      _PK_H_(0x1D, 0x2B)
#define REG_SC_BK1D_2C_L      _PK_L_(0x1D, 0x2C)
#define REG_SC_BK1D_2C_H      _PK_H_(0x1D, 0x2C)
#define REG_SC_BK1D_2D_L      _PK_L_(0x1D, 0x2D)
#define REG_SC_BK1D_2D_H      _PK_H_(0x1D, 0x2D)
#define REG_SC_BK1D_2E_L      _PK_L_(0x1D, 0x2E)
#define REG_SC_BK1D_2E_H      _PK_H_(0x1D, 0x2E)
#define REG_SC_BK1D_2F_L      _PK_L_(0x1D, 0x2F)
#define REG_SC_BK1D_2F_H      _PK_H_(0x1D, 0x2F)
#define REG_SC_BK1D_30_L      _PK_L_(0x1D, 0x30)
#define REG_SC_BK1D_30_H      _PK_H_(0x1D, 0x30)
#define REG_SC_BK1D_31_L      _PK_L_(0x1D, 0x31)
#define REG_SC_BK1D_31_H      _PK_H_(0x1D, 0x31)
#define REG_SC_BK1D_32_L      _PK_L_(0x1D, 0x32)
#define REG_SC_BK1D_32_H      _PK_H_(0x1D, 0x32)
#define REG_SC_BK1D_33_L      _PK_L_(0x1D, 0x33)
#define REG_SC_BK1D_33_H      _PK_H_(0x1D, 0x33)
#define REG_SC_BK1D_34_L      _PK_L_(0x1D, 0x34)
#define REG_SC_BK1D_34_H      _PK_H_(0x1D, 0x34)
#define REG_SC_BK1D_35_L      _PK_L_(0x1D, 0x35)
#define REG_SC_BK1D_35_H      _PK_H_(0x1D, 0x35)
#define REG_SC_BK1D_36_L      _PK_L_(0x1D, 0x36)
#define REG_SC_BK1D_36_H      _PK_H_(0x1D, 0x36)
#define REG_SC_BK1D_37_L      _PK_L_(0x1D, 0x37)
#define REG_SC_BK1D_37_H      _PK_H_(0x1D, 0x37)
#define REG_SC_BK1D_38_L      _PK_L_(0x1D, 0x38)
#define REG_SC_BK1D_38_H      _PK_H_(0x1D, 0x38)
#define REG_SC_BK1D_39_L      _PK_L_(0x1D, 0x39)
#define REG_SC_BK1D_39_H      _PK_H_(0x1D, 0x39)
#define REG_SC_BK1D_3A_L      _PK_L_(0x1D, 0x3A)
#define REG_SC_BK1D_3A_H      _PK_H_(0x1D, 0x3A)
#define REG_SC_BK1D_3B_L      _PK_L_(0x1D, 0x3B)
#define REG_SC_BK1D_3B_H      _PK_H_(0x1D, 0x3B)
#define REG_SC_BK1D_3C_L      _PK_L_(0x1D, 0x3C)
#define REG_SC_BK1D_3C_H      _PK_H_(0x1D, 0x3C)
#define REG_SC_BK1D_3D_L      _PK_L_(0x1D, 0x3D)
#define REG_SC_BK1D_3D_H      _PK_H_(0x1D, 0x3D)
#define REG_SC_BK1D_3E_L      _PK_L_(0x1D, 0x3E)
#define REG_SC_BK1D_3E_H      _PK_H_(0x1D, 0x3E)
#define REG_SC_BK1D_3F_L      _PK_L_(0x1D, 0x3F)
#define REG_SC_BK1D_3F_H      _PK_H_(0x1D, 0x3F)
#define REG_SC_BK1D_40_L      _PK_L_(0x1D, 0x40)
#define REG_SC_BK1D_40_H      _PK_H_(0x1D, 0x40)
#define REG_SC_BK1D_41_L      _PK_L_(0x1D, 0x41)
#define REG_SC_BK1D_41_H      _PK_H_(0x1D, 0x41)
#define REG_SC_BK1D_42_L      _PK_L_(0x1D, 0x42)
#define REG_SC_BK1D_42_H      _PK_H_(0x1D, 0x42)
#define REG_SC_BK1D_43_L      _PK_L_(0x1D, 0x43)
#define REG_SC_BK1D_43_H      _PK_H_(0x1D, 0x43)
#define REG_SC_BK1D_44_L      _PK_L_(0x1D, 0x44)
#define REG_SC_BK1D_44_H      _PK_H_(0x1D, 0x44)
#define REG_SC_BK1D_45_L      _PK_L_(0x1D, 0x45)
#define REG_SC_BK1D_45_H      _PK_H_(0x1D, 0x45)
#define REG_SC_BK1D_46_L      _PK_L_(0x1D, 0x46)
#define REG_SC_BK1D_46_H      _PK_H_(0x1D, 0x46)
#define REG_SC_BK1D_47_L      _PK_L_(0x1D, 0x47)
#define REG_SC_BK1D_47_H      _PK_H_(0x1D, 0x47)
#define REG_SC_BK1D_48_L      _PK_L_(0x1D, 0x48)
#define REG_SC_BK1D_48_H      _PK_H_(0x1D, 0x48)
#define REG_SC_BK1D_49_L      _PK_L_(0x1D, 0x49)
#define REG_SC_BK1D_49_H      _PK_H_(0x1D, 0x49)
#define REG_SC_BK1D_4A_L      _PK_L_(0x1D, 0x4A)
#define REG_SC_BK1D_4A_H      _PK_H_(0x1D, 0x4A)
#define REG_SC_BK1D_4B_L      _PK_L_(0x1D, 0x4B)
#define REG_SC_BK1D_4B_H      _PK_H_(0x1D, 0x4B)
#define REG_SC_BK1D_4C_L      _PK_L_(0x1D, 0x4C)
#define REG_SC_BK1D_4C_H      _PK_H_(0x1D, 0x4C)
#define REG_SC_BK1D_4D_L      _PK_L_(0x1D, 0x4D)
#define REG_SC_BK1D_4D_H      _PK_H_(0x1D, 0x4D)
#define REG_SC_BK1D_4E_L      _PK_L_(0x1D, 0x4E)
#define REG_SC_BK1D_4E_H      _PK_H_(0x1D, 0x4E)
#define REG_SC_BK1D_4F_L      _PK_L_(0x1D, 0x4F)
#define REG_SC_BK1D_4F_H      _PK_H_(0x1D, 0x4F)
#define REG_SC_BK1D_50_L      _PK_L_(0x1D, 0x50)
#define REG_SC_BK1D_50_H      _PK_H_(0x1D, 0x50)
#define REG_SC_BK1D_51_L      _PK_L_(0x1D, 0x51)
#define REG_SC_BK1D_51_H      _PK_H_(0x1D, 0x51)
#define REG_SC_BK1D_52_L      _PK_L_(0x1D, 0x52)
#define REG_SC_BK1D_52_H      _PK_H_(0x1D, 0x52)
#define REG_SC_BK1D_53_L      _PK_L_(0x1D, 0x53)
#define REG_SC_BK1D_53_H      _PK_H_(0x1D, 0x53)
#define REG_SC_BK1D_54_L      _PK_L_(0x1D, 0x54)
#define REG_SC_BK1D_54_H      _PK_H_(0x1D, 0x54)
#define REG_SC_BK1D_55_L      _PK_L_(0x1D, 0x55)
#define REG_SC_BK1D_55_H      _PK_H_(0x1D, 0x55)
#define REG_SC_BK1D_56_L      _PK_L_(0x1D, 0x56)
#define REG_SC_BK1D_56_H      _PK_H_(0x1D, 0x56)
#define REG_SC_BK1D_57_L      _PK_L_(0x1D, 0x57)
#define REG_SC_BK1D_57_H      _PK_H_(0x1D, 0x57)
#define REG_SC_BK1D_58_L      _PK_L_(0x1D, 0x58)
#define REG_SC_BK1D_58_H      _PK_H_(0x1D, 0x58)
#define REG_SC_BK1D_59_L      _PK_L_(0x1D, 0x59)
#define REG_SC_BK1D_59_H      _PK_H_(0x1D, 0x59)
#define REG_SC_BK1D_5A_L      _PK_L_(0x1D, 0x5A)
#define REG_SC_BK1D_5A_H      _PK_H_(0x1D, 0x5A)
#define REG_SC_BK1D_5B_L      _PK_L_(0x1D, 0x5B)
#define REG_SC_BK1D_5B_H      _PK_H_(0x1D, 0x5B)
#define REG_SC_BK1D_5C_L      _PK_L_(0x1D, 0x5C)
#define REG_SC_BK1D_5C_H      _PK_H_(0x1D, 0x5C)
#define REG_SC_BK1D_5D_L      _PK_L_(0x1D, 0x5D)
#define REG_SC_BK1D_5D_H      _PK_H_(0x1D, 0x5D)
#define REG_SC_BK1D_5E_L      _PK_L_(0x1D, 0x5E)
#define REG_SC_BK1D_5E_H      _PK_H_(0x1D, 0x5E)
#define REG_SC_BK1D_5F_L      _PK_L_(0x1D, 0x5F)
#define REG_SC_BK1D_5F_H      _PK_H_(0x1D, 0x5F)
#define REG_SC_BK1D_60_L      _PK_L_(0x1D, 0x60)
#define REG_SC_BK1D_60_H      _PK_H_(0x1D, 0x60)
#define REG_SC_BK1D_61_L      _PK_L_(0x1D, 0x61)
#define REG_SC_BK1D_61_H      _PK_H_(0x1D, 0x61)
#define REG_SC_BK1D_62_L      _PK_L_(0x1D, 0x62)
#define REG_SC_BK1D_62_H      _PK_H_(0x1D, 0x62)
#define REG_SC_BK1D_63_L      _PK_L_(0x1D, 0x63)
#define REG_SC_BK1D_63_H      _PK_H_(0x1D, 0x63)
#define REG_SC_BK1D_64_L      _PK_L_(0x1D, 0x64)
#define REG_SC_BK1D_64_H      _PK_H_(0x1D, 0x64)
#define REG_SC_BK1D_65_L      _PK_L_(0x1D, 0x65)
#define REG_SC_BK1D_65_H      _PK_H_(0x1D, 0x65)
#define REG_SC_BK1D_66_L      _PK_L_(0x1D, 0x66)
#define REG_SC_BK1D_66_H      _PK_H_(0x1D, 0x66)
#define REG_SC_BK1D_67_L      _PK_L_(0x1D, 0x67)
#define REG_SC_BK1D_67_H      _PK_H_(0x1D, 0x67)
#define REG_SC_BK1D_68_L      _PK_L_(0x1D, 0x68)
#define REG_SC_BK1D_68_H      _PK_H_(0x1D, 0x68)
#define REG_SC_BK1D_69_L      _PK_L_(0x1D, 0x69)
#define REG_SC_BK1D_69_H      _PK_H_(0x1D, 0x69)
#define REG_SC_BK1D_6A_L      _PK_L_(0x1D, 0x6A)
#define REG_SC_BK1D_6A_H      _PK_H_(0x1D, 0x6A)
#define REG_SC_BK1D_6B_L      _PK_L_(0x1D, 0x6B)
#define REG_SC_BK1D_6B_H      _PK_H_(0x1D, 0x6B)
#define REG_SC_BK1D_6C_L      _PK_L_(0x1D, 0x6C)
#define REG_SC_BK1D_6C_H      _PK_H_(0x1D, 0x6C)
#define REG_SC_BK1D_6D_L      _PK_L_(0x1D, 0x6D)
#define REG_SC_BK1D_6D_H      _PK_H_(0x1D, 0x6D)
#define REG_SC_BK1D_6E_L      _PK_L_(0x1D, 0x6E)
#define REG_SC_BK1D_6E_H      _PK_H_(0x1D, 0x6E)
#define REG_SC_BK1D_6F_L      _PK_L_(0x1D, 0x6F)
#define REG_SC_BK1D_6F_H      _PK_H_(0x1D, 0x6F)
#define REG_SC_BK1D_70_L      _PK_L_(0x1D, 0x70)
#define REG_SC_BK1D_70_H      _PK_H_(0x1D, 0x70)
#define REG_SC_BK1D_71_L      _PK_L_(0x1D, 0x71)
#define REG_SC_BK1D_71_H      _PK_H_(0x1D, 0x71)
#define REG_SC_BK1D_72_L      _PK_L_(0x1D, 0x72)
#define REG_SC_BK1D_72_H      _PK_H_(0x1D, 0x72)
#define REG_SC_BK1D_73_L      _PK_L_(0x1D, 0x73)
#define REG_SC_BK1D_73_H      _PK_H_(0x1D, 0x73)
#define REG_SC_BK1D_74_L      _PK_L_(0x1D, 0x74)
#define REG_SC_BK1D_74_H      _PK_H_(0x1D, 0x74)
#define REG_SC_BK1D_75_L      _PK_L_(0x1D, 0x75)
#define REG_SC_BK1D_75_H      _PK_H_(0x1D, 0x75)
#define REG_SC_BK1D_76_L      _PK_L_(0x1D, 0x76)
#define REG_SC_BK1D_76_H      _PK_H_(0x1D, 0x76)
#define REG_SC_BK1D_77_L      _PK_L_(0x1D, 0x77)
#define REG_SC_BK1D_77_H      _PK_H_(0x1D, 0x77)
#define REG_SC_BK1D_78_L      _PK_L_(0x1D, 0x78)
#define REG_SC_BK1D_78_H      _PK_H_(0x1D, 0x78)
#define REG_SC_BK1D_79_L      _PK_L_(0x1D, 0x79)
#define REG_SC_BK1D_79_H      _PK_H_(0x1D, 0x79)
#define REG_SC_BK1D_7A_L      _PK_L_(0x1D, 0x7A)
#define REG_SC_BK1D_7A_H      _PK_H_(0x1D, 0x7A)
#define REG_SC_BK1D_7B_L      _PK_L_(0x1D, 0x7B)
#define REG_SC_BK1D_7B_H      _PK_H_(0x1D, 0x7B)
#define REG_SC_BK1D_7C_L      _PK_L_(0x1D, 0x7C)
#define REG_SC_BK1D_7C_H      _PK_H_(0x1D, 0x7C)
#define REG_SC_BK1D_7D_L      _PK_L_(0x1D, 0x7D)
#define REG_SC_BK1D_7D_H      _PK_H_(0x1D, 0x7D)
#define REG_SC_BK1D_7E_L      _PK_L_(0x1D, 0x7E)
#define REG_SC_BK1D_7E_H      _PK_H_(0x1D, 0x7E)
#define REG_SC_BK1D_7F_L      _PK_L_(0x1D, 0x7F)
#define REG_SC_BK1D_7F_H      _PK_H_(0x1D, 0x7F)


//----------------------------------------------
//  BK1F: DYN_SCL---only for T4&Janus
//----------------------------------------------
#define REG_SC_BK1F_00_L      _PK_L_(0x1F, 0x00)
#define REG_SC_BK1F_00_H      _PK_H_(0x1F, 0x00)
#define REG_SC_BK1F_01_L      _PK_L_(0x1F, 0x01)
#define REG_SC_BK1F_01_H      _PK_H_(0x1F, 0x01)
#define REG_SC_BK1F_02_L      _PK_L_(0x1F, 0x02)
#define REG_SC_BK1F_02_H      _PK_H_(0x1F, 0x02)
#define REG_SC_BK1F_03_L      _PK_L_(0x1F, 0x03)
#define REG_SC_BK1F_03_H      _PK_H_(0x1F, 0x03)
#define REG_SC_BK1F_04_L      _PK_L_(0x1F, 0x04)
#define REG_SC_BK1F_04_H      _PK_H_(0x1F, 0x04)
#define REG_SC_BK1F_05_L      _PK_L_(0x1F, 0x05)
#define REG_SC_BK1F_05_H      _PK_H_(0x1F, 0x05)
#define REG_SC_BK1F_06_L      _PK_L_(0x1F, 0x06)
#define REG_SC_BK1F_06_H      _PK_H_(0x1F, 0x06)
#define REG_SC_BK1F_07_L      _PK_L_(0x1F, 0x07)
#define REG_SC_BK1F_07_H      _PK_H_(0x1F, 0x07)
#define REG_SC_BK1F_08_L      _PK_L_(0x1F, 0x08)
#define REG_SC_BK1F_08_H      _PK_H_(0x1F, 0x08)
#define REG_SC_BK1F_09_L      _PK_L_(0x1F, 0x09)
#define REG_SC_BK1F_09_H      _PK_H_(0x1F, 0x09)
#define REG_SC_BK1F_0A_L      _PK_L_(0x1F, 0x0A)
#define REG_SC_BK1F_0A_H      _PK_H_(0x1F, 0x0A)
#define REG_SC_BK1F_0B_L      _PK_L_(0x1F, 0x0B)
#define REG_SC_BK1F_0B_H      _PK_H_(0x1F, 0x0B)
#define REG_SC_BK1F_0C_L      _PK_L_(0x1F, 0x0C)
#define REG_SC_BK1F_0C_H      _PK_H_(0x1F, 0x0C)
#define REG_SC_BK1F_0D_L      _PK_L_(0x1F, 0x0D)
#define REG_SC_BK1F_0D_H      _PK_H_(0x1F, 0x0D)
#define REG_SC_BK1F_0E_L      _PK_L_(0x1F, 0x0E)
#define REG_SC_BK1F_0E_H      _PK_H_(0x1F, 0x0E)
#define REG_SC_BK1F_0F_L      _PK_L_(0x1F, 0x0F)
#define REG_SC_BK1F_0F_H      _PK_H_(0x1F, 0x0F)
#define REG_SC_BK1F_10_L      _PK_L_(0x1F, 0x10)
#define REG_SC_BK1F_10_H      _PK_H_(0x1F, 0x10)
#define REG_SC_BK1F_11_L      _PK_L_(0x1F, 0x11)
#define REG_SC_BK1F_11_H      _PK_H_(0x1F, 0x11)
#define REG_SC_BK1F_12_L      _PK_L_(0x1F, 0x12)
#define REG_SC_BK1F_12_H      _PK_H_(0x1F, 0x12)
#define REG_SC_BK1F_13_L      _PK_L_(0x1F, 0x13)
#define REG_SC_BK1F_13_H      _PK_H_(0x1F, 0x13)
#define REG_SC_BK1F_14_L      _PK_L_(0x1F, 0x14)
#define REG_SC_BK1F_14_H      _PK_H_(0x1F, 0x14)
#define REG_SC_BK1F_15_L      _PK_L_(0x1F, 0x15)
#define REG_SC_BK1F_15_H      _PK_H_(0x1F, 0x15)
#define REG_SC_BK1F_16_L      _PK_L_(0x1F, 0x16)
#define REG_SC_BK1F_16_H      _PK_H_(0x1F, 0x16)
#define REG_SC_BK1F_17_L      _PK_L_(0x1F, 0x17)
#define REG_SC_BK1F_17_H      _PK_H_(0x1F, 0x17)
#define REG_SC_BK1F_18_L      _PK_L_(0x1F, 0x18)
#define REG_SC_BK1F_18_H      _PK_H_(0x1F, 0x18)
#define REG_SC_BK1F_19_L      _PK_L_(0x1F, 0x19)
#define REG_SC_BK1F_19_H      _PK_H_(0x1F, 0x19)
#define REG_SC_BK1F_1A_L      _PK_L_(0x1F, 0x1A)
#define REG_SC_BK1F_1A_H      _PK_H_(0x1F, 0x1A)
#define REG_SC_BK1F_1B_L      _PK_L_(0x1F, 0x1B)
#define REG_SC_BK1F_1B_H      _PK_H_(0x1F, 0x1B)
#define REG_SC_BK1F_1C_L      _PK_L_(0x1F, 0x1C)
#define REG_SC_BK1F_1C_H      _PK_H_(0x1F, 0x1C)
#define REG_SC_BK1F_1D_L      _PK_L_(0x1F, 0x1D)
#define REG_SC_BK1F_1D_H      _PK_H_(0x1F, 0x1D)
#define REG_SC_BK1F_1E_L      _PK_L_(0x1F, 0x1E)
#define REG_SC_BK1F_1E_H      _PK_H_(0x1F, 0x1E)
#define REG_SC_BK1F_1F_L      _PK_L_(0x1F, 0x1F)
#define REG_SC_BK1F_1F_H      _PK_H_(0x1F, 0x1F)
#define REG_SC_BK1F_20_L      _PK_L_(0x1F, 0x20)
#define REG_SC_BK1F_20_H      _PK_H_(0x1F, 0x20)
#define REG_SC_BK1F_21_L      _PK_L_(0x1F, 0x21)
#define REG_SC_BK1F_21_H      _PK_H_(0x1F, 0x21)
#define REG_SC_BK1F_22_L      _PK_L_(0x1F, 0x22)
#define REG_SC_BK1F_22_H      _PK_H_(0x1F, 0x22)
#define REG_SC_BK1F_23_L      _PK_L_(0x1F, 0x23)
#define REG_SC_BK1F_23_H      _PK_H_(0x1F, 0x23)
#define REG_SC_BK1F_24_L      _PK_L_(0x1F, 0x24)
#define REG_SC_BK1F_24_H      _PK_H_(0x1F, 0x24)
#define REG_SC_BK1F_25_L      _PK_L_(0x1F, 0x25)
#define REG_SC_BK1F_25_H      _PK_H_(0x1F, 0x25)
#define REG_SC_BK1F_26_L      _PK_L_(0x1F, 0x26)
#define REG_SC_BK1F_26_H      _PK_H_(0x1F, 0x26)
#define REG_SC_BK1F_27_L      _PK_L_(0x1F, 0x27)
#define REG_SC_BK1F_27_H      _PK_H_(0x1F, 0x27)
#define REG_SC_BK1F_28_L      _PK_L_(0x1F, 0x28)
#define REG_SC_BK1F_28_H      _PK_H_(0x1F, 0x28)
#define REG_SC_BK1F_29_L      _PK_L_(0x1F, 0x29)
#define REG_SC_BK1F_29_H      _PK_H_(0x1F, 0x29)
#define REG_SC_BK1F_2A_L      _PK_L_(0x1F, 0x2A)
#define REG_SC_BK1F_2A_H      _PK_H_(0x1F, 0x2A)
#define REG_SC_BK1F_2B_L      _PK_L_(0x1F, 0x2B)
#define REG_SC_BK1F_2B_H      _PK_H_(0x1F, 0x2B)
#define REG_SC_BK1F_2C_L      _PK_L_(0x1F, 0x2C)
#define REG_SC_BK1F_2C_H      _PK_H_(0x1F, 0x2C)
#define REG_SC_BK1F_2D_L      _PK_L_(0x1F, 0x2D)
#define REG_SC_BK1F_2D_H      _PK_H_(0x1F, 0x2D)
#define REG_SC_BK1F_2E_L      _PK_L_(0x1F, 0x2E)
#define REG_SC_BK1F_2E_H      _PK_H_(0x1F, 0x2E)
#define REG_SC_BK1F_2F_L      _PK_L_(0x1F, 0x2F)
#define REG_SC_BK1F_2F_H      _PK_H_(0x1F, 0x2F)
#define REG_SC_BK1F_30_L      _PK_L_(0x1F, 0x30)
#define REG_SC_BK1F_30_H      _PK_H_(0x1F, 0x30)
#define REG_SC_BK1F_31_L      _PK_L_(0x1F, 0x31)
#define REG_SC_BK1F_31_H      _PK_H_(0x1F, 0x31)
#define REG_SC_BK1F_32_L      _PK_L_(0x1F, 0x32)
#define REG_SC_BK1F_32_H      _PK_H_(0x1F, 0x32)
#define REG_SC_BK1F_33_L      _PK_L_(0x1F, 0x33)
#define REG_SC_BK1F_33_H      _PK_H_(0x1F, 0x33)
#define REG_SC_BK1F_34_L      _PK_L_(0x1F, 0x34)
#define REG_SC_BK1F_34_H      _PK_H_(0x1F, 0x34)
#define REG_SC_BK1F_35_L      _PK_L_(0x1F, 0x35)
#define REG_SC_BK1F_35_H      _PK_H_(0x1F, 0x35)
#define REG_SC_BK1F_36_L      _PK_L_(0x1F, 0x36)
#define REG_SC_BK1F_36_H      _PK_H_(0x1F, 0x36)
#define REG_SC_BK1F_37_L      _PK_L_(0x1F, 0x37)
#define REG_SC_BK1F_37_H      _PK_H_(0x1F, 0x37)
#define REG_SC_BK1F_38_L      _PK_L_(0x1F, 0x38)
#define REG_SC_BK1F_38_H      _PK_H_(0x1F, 0x38)
#define REG_SC_BK1F_39_L      _PK_L_(0x1F, 0x39)
#define REG_SC_BK1F_39_H      _PK_H_(0x1F, 0x39)
#define REG_SC_BK1F_3A_L      _PK_L_(0x1F, 0x3A)
#define REG_SC_BK1F_3A_H      _PK_H_(0x1F, 0x3A)
#define REG_SC_BK1F_3B_L      _PK_L_(0x1F, 0x3B)
#define REG_SC_BK1F_3B_H      _PK_H_(0x1F, 0x3B)
#define REG_SC_BK1F_3C_L      _PK_L_(0x1F, 0x3C)
#define REG_SC_BK1F_3C_H      _PK_H_(0x1F, 0x3C)
#define REG_SC_BK1F_3D_L      _PK_L_(0x1F, 0x3D)
#define REG_SC_BK1F_3D_H      _PK_H_(0x1F, 0x3D)
#define REG_SC_BK1F_3E_L      _PK_L_(0x1F, 0x3E)
#define REG_SC_BK1F_3E_H      _PK_H_(0x1F, 0x3E)
#define REG_SC_BK1F_3F_L      _PK_L_(0x1F, 0x3F)
#define REG_SC_BK1F_3F_H      _PK_H_(0x1F, 0x3F)
#define REG_SC_BK1F_40_L      _PK_L_(0x1F, 0x40)
#define REG_SC_BK1F_40_H      _PK_H_(0x1F, 0x40)
#define REG_SC_BK1F_41_L      _PK_L_(0x1F, 0x41)
#define REG_SC_BK1F_41_H      _PK_H_(0x1F, 0x41)
#define REG_SC_BK1F_42_L      _PK_L_(0x1F, 0x42)
#define REG_SC_BK1F_42_H      _PK_H_(0x1F, 0x42)
#define REG_SC_BK1F_43_L      _PK_L_(0x1F, 0x43)
#define REG_SC_BK1F_43_H      _PK_H_(0x1F, 0x43)
#define REG_SC_BK1F_44_L      _PK_L_(0x1F, 0x44)
#define REG_SC_BK1F_44_H      _PK_H_(0x1F, 0x44)
#define REG_SC_BK1F_45_L      _PK_L_(0x1F, 0x45)
#define REG_SC_BK1F_45_H      _PK_H_(0x1F, 0x45)
#define REG_SC_BK1F_46_L      _PK_L_(0x1F, 0x46)
#define REG_SC_BK1F_46_H      _PK_H_(0x1F, 0x46)
#define REG_SC_BK1F_47_L      _PK_L_(0x1F, 0x47)
#define REG_SC_BK1F_47_H      _PK_H_(0x1F, 0x47)
#define REG_SC_BK1F_48_L      _PK_L_(0x1F, 0x48)
#define REG_SC_BK1F_48_H      _PK_H_(0x1F, 0x48)
#define REG_SC_BK1F_49_L      _PK_L_(0x1F, 0x49)
#define REG_SC_BK1F_49_H      _PK_H_(0x1F, 0x49)
#define REG_SC_BK1F_4A_L      _PK_L_(0x1F, 0x4A)
#define REG_SC_BK1F_4A_H      _PK_H_(0x1F, 0x4A)
#define REG_SC_BK1F_4B_L      _PK_L_(0x1F, 0x4B)
#define REG_SC_BK1F_4B_H      _PK_H_(0x1F, 0x4B)
#define REG_SC_BK1F_4C_L      _PK_L_(0x1F, 0x4C)
#define REG_SC_BK1F_4C_H      _PK_H_(0x1F, 0x4C)
#define REG_SC_BK1F_4D_L      _PK_L_(0x1F, 0x4D)
#define REG_SC_BK1F_4D_H      _PK_H_(0x1F, 0x4D)
#define REG_SC_BK1F_4E_L      _PK_L_(0x1F, 0x4E)
#define REG_SC_BK1F_4E_H      _PK_H_(0x1F, 0x4E)
#define REG_SC_BK1F_4F_L      _PK_L_(0x1F, 0x4F)
#define REG_SC_BK1F_4F_H      _PK_H_(0x1F, 0x4F)
#define REG_SC_BK1F_50_L      _PK_L_(0x1F, 0x50)
#define REG_SC_BK1F_50_H      _PK_H_(0x1F, 0x50)
#define REG_SC_BK1F_51_L      _PK_L_(0x1F, 0x51)
#define REG_SC_BK1F_51_H      _PK_H_(0x1F, 0x51)
#define REG_SC_BK1F_52_L      _PK_L_(0x1F, 0x52)
#define REG_SC_BK1F_52_H      _PK_H_(0x1F, 0x52)
#define REG_SC_BK1F_53_L      _PK_L_(0x1F, 0x53)
#define REG_SC_BK1F_53_H      _PK_H_(0x1F, 0x53)
#define REG_SC_BK1F_54_L      _PK_L_(0x1F, 0x54)
#define REG_SC_BK1F_54_H      _PK_H_(0x1F, 0x54)
#define REG_SC_BK1F_55_L      _PK_L_(0x1F, 0x55)
#define REG_SC_BK1F_55_H      _PK_H_(0x1F, 0x55)
#define REG_SC_BK1F_56_L      _PK_L_(0x1F, 0x56)
#define REG_SC_BK1F_56_H      _PK_H_(0x1F, 0x56)
#define REG_SC_BK1F_57_L      _PK_L_(0x1F, 0x57)
#define REG_SC_BK1F_57_H      _PK_H_(0x1F, 0x57)
#define REG_SC_BK1F_58_L      _PK_L_(0x1F, 0x58)
#define REG_SC_BK1F_58_H      _PK_H_(0x1F, 0x58)
#define REG_SC_BK1F_59_L      _PK_L_(0x1F, 0x59)
#define REG_SC_BK1F_59_H      _PK_H_(0x1F, 0x59)
#define REG_SC_BK1F_5A_L      _PK_L_(0x1F, 0x5A)
#define REG_SC_BK1F_5A_H      _PK_H_(0x1F, 0x5A)
#define REG_SC_BK1F_5B_L      _PK_L_(0x1F, 0x5B)
#define REG_SC_BK1F_5B_H      _PK_H_(0x1F, 0x5B)
#define REG_SC_BK1F_5C_L      _PK_L_(0x1F, 0x5C)
#define REG_SC_BK1F_5C_H      _PK_H_(0x1F, 0x5C)
#define REG_SC_BK1F_5D_L      _PK_L_(0x1F, 0x5D)
#define REG_SC_BK1F_5D_H      _PK_H_(0x1F, 0x5D)
#define REG_SC_BK1F_5E_L      _PK_L_(0x1F, 0x5E)
#define REG_SC_BK1F_5E_H      _PK_H_(0x1F, 0x5E)
#define REG_SC_BK1F_5F_L      _PK_L_(0x1F, 0x5F)
#define REG_SC_BK1F_5F_H      _PK_H_(0x1F, 0x5F)
#define REG_SC_BK1F_60_L      _PK_L_(0x1F, 0x60)
#define REG_SC_BK1F_60_H      _PK_H_(0x1F, 0x60)
#define REG_SC_BK1F_61_L      _PK_L_(0x1F, 0x61)
#define REG_SC_BK1F_61_H      _PK_H_(0x1F, 0x61)
#define REG_SC_BK1F_62_L      _PK_L_(0x1F, 0x62)
#define REG_SC_BK1F_62_H      _PK_H_(0x1F, 0x62)
#define REG_SC_BK1F_63_L      _PK_L_(0x1F, 0x63)
#define REG_SC_BK1F_63_H      _PK_H_(0x1F, 0x63)
#define REG_SC_BK1F_64_L      _PK_L_(0x1F, 0x64)
#define REG_SC_BK1F_64_H      _PK_H_(0x1F, 0x64)
#define REG_SC_BK1F_65_L      _PK_L_(0x1F, 0x65)
#define REG_SC_BK1F_65_H      _PK_H_(0x1F, 0x65)
#define REG_SC_BK1F_66_L      _PK_L_(0x1F, 0x66)
#define REG_SC_BK1F_66_H      _PK_H_(0x1F, 0x66)
#define REG_SC_BK1F_67_L      _PK_L_(0x1F, 0x67)
#define REG_SC_BK1F_67_H      _PK_H_(0x1F, 0x67)
#define REG_SC_BK1F_68_L      _PK_L_(0x1F, 0x68)
#define REG_SC_BK1F_68_H      _PK_H_(0x1F, 0x68)
#define REG_SC_BK1F_69_L      _PK_L_(0x1F, 0x69)
#define REG_SC_BK1F_69_H      _PK_H_(0x1F, 0x69)
#define REG_SC_BK1F_6A_L      _PK_L_(0x1F, 0x6A)
#define REG_SC_BK1F_6A_H      _PK_H_(0x1F, 0x6A)
#define REG_SC_BK1F_6B_L      _PK_L_(0x1F, 0x6B)
#define REG_SC_BK1F_6B_H      _PK_H_(0x1F, 0x6B)
#define REG_SC_BK1F_6C_L      _PK_L_(0x1F, 0x6C)
#define REG_SC_BK1F_6C_H      _PK_H_(0x1F, 0x6C)
#define REG_SC_BK1F_6D_L      _PK_L_(0x1F, 0x6D)
#define REG_SC_BK1F_6D_H      _PK_H_(0x1F, 0x6D)
#define REG_SC_BK1F_6E_L      _PK_L_(0x1F, 0x6E)
#define REG_SC_BK1F_6E_H      _PK_H_(0x1F, 0x6E)
#define REG_SC_BK1F_6F_L      _PK_L_(0x1F, 0x6F)
#define REG_SC_BK1F_6F_H      _PK_H_(0x1F, 0x6F)
#define REG_SC_BK1F_70_L      _PK_L_(0x1F, 0x70)
#define REG_SC_BK1F_70_H      _PK_H_(0x1F, 0x70)
#define REG_SC_BK1F_71_L      _PK_L_(0x1F, 0x71)
#define REG_SC_BK1F_71_H      _PK_H_(0x1F, 0x71)
#define REG_SC_BK1F_72_L      _PK_L_(0x1F, 0x72)
#define REG_SC_BK1F_72_H      _PK_H_(0x1F, 0x72)
#define REG_SC_BK1F_73_L      _PK_L_(0x1F, 0x73)
#define REG_SC_BK1F_73_H      _PK_H_(0x1F, 0x73)
#define REG_SC_BK1F_74_L      _PK_L_(0x1F, 0x74)
#define REG_SC_BK1F_74_H      _PK_H_(0x1F, 0x74)
#define REG_SC_BK1F_75_L      _PK_L_(0x1F, 0x75)
#define REG_SC_BK1F_75_H      _PK_H_(0x1F, 0x75)
#define REG_SC_BK1F_76_L      _PK_L_(0x1F, 0x76)
#define REG_SC_BK1F_76_H      _PK_H_(0x1F, 0x76)
#define REG_SC_BK1F_77_L      _PK_L_(0x1F, 0x77)
#define REG_SC_BK1F_77_H      _PK_H_(0x1F, 0x77)
#define REG_SC_BK1F_78_L      _PK_L_(0x1F, 0x78)
#define REG_SC_BK1F_78_H      _PK_H_(0x1F, 0x78)
#define REG_SC_BK1F_79_L      _PK_L_(0x1F, 0x79)
#define REG_SC_BK1F_79_H      _PK_H_(0x1F, 0x79)
#define REG_SC_BK1F_7A_L      _PK_L_(0x1F, 0x7A)
#define REG_SC_BK1F_7A_H      _PK_H_(0x1F, 0x7A)
#define REG_SC_BK1F_7B_L      _PK_L_(0x1F, 0x7B)
#define REG_SC_BK1F_7B_H      _PK_H_(0x1F, 0x7B)
#define REG_SC_BK1F_7C_L      _PK_L_(0x1F, 0x7C)
#define REG_SC_BK1F_7C_H      _PK_H_(0x1F, 0x7C)
#define REG_SC_BK1F_7D_L      _PK_L_(0x1F, 0x7D)
#define REG_SC_BK1F_7D_H      _PK_H_(0x1F, 0x7D)
#define REG_SC_BK1F_7E_L      _PK_L_(0x1F, 0x7E)
#define REG_SC_BK1F_7E_H      _PK_H_(0x1F, 0x7E)
#define REG_SC_BK1F_7F_L      _PK_L_(0x1F, 0x7F)
#define REG_SC_BK1F_7F_H      _PK_H_(0x1F, 0x7F)



//----------------------------------------------
//  BK20
//----------------------------------------------
#define REG_SC_BK20_00_L      _PK_L_(0x20, 0x00)
#define REG_SC_BK20_00_H      _PK_H_(0x20, 0x00)
#define REG_SC_BK20_01_L      _PK_L_(0x20, 0x01)
#define REG_SC_BK20_01_H      _PK_H_(0x20, 0x01)
#define REG_SC_BK20_02_L      _PK_L_(0x20, 0x02)
#define REG_SC_BK20_02_H      _PK_H_(0x20, 0x02)
#define REG_SC_BK20_03_L      _PK_L_(0x20, 0x03)
#define REG_SC_BK20_03_H      _PK_H_(0x20, 0x03)
#define REG_SC_BK20_04_L      _PK_L_(0x20, 0x04)
#define REG_SC_BK20_04_H      _PK_H_(0x20, 0x04)
#define REG_SC_BK20_05_L      _PK_L_(0x20, 0x05)
#define REG_SC_BK20_05_H      _PK_H_(0x20, 0x05)
#define REG_SC_BK20_06_L      _PK_L_(0x20, 0x06)
#define REG_SC_BK20_06_H      _PK_H_(0x20, 0x06)
#define REG_SC_BK20_07_L      _PK_L_(0x20, 0x07)
#define REG_SC_BK20_07_H      _PK_H_(0x20, 0x07)
#define REG_SC_BK20_08_L      _PK_L_(0x20, 0x08)
#define REG_SC_BK20_08_H      _PK_H_(0x20, 0x08)
#define REG_SC_BK20_09_L      _PK_L_(0x20, 0x09)
#define REG_SC_BK20_09_H      _PK_H_(0x20, 0x09)
#define REG_SC_BK20_0A_L      _PK_L_(0x20, 0x0A)
#define REG_SC_BK20_0A_H      _PK_H_(0x20, 0x0A)
#define REG_SC_BK20_0B_L      _PK_L_(0x20, 0x0B)
#define REG_SC_BK20_0B_H      _PK_H_(0x20, 0x0B)
#define REG_SC_BK20_0C_L      _PK_L_(0x20, 0x0C)
#define REG_SC_BK20_0C_H      _PK_H_(0x20, 0x0C)
#define REG_SC_BK20_0D_L      _PK_L_(0x20, 0x0D)
#define REG_SC_BK20_0D_H      _PK_H_(0x20, 0x0D)
#define REG_SC_BK20_0E_L      _PK_L_(0x20, 0x0E)
#define REG_SC_BK20_0E_H      _PK_H_(0x20, 0x0E)
#define REG_SC_BK20_0F_L      _PK_L_(0x20, 0x0F)
#define REG_SC_BK20_0F_H      _PK_H_(0x20, 0x0F)
#define REG_SC_BK20_10_L      _PK_L_(0x20, 0x10)
#define REG_SC_BK20_10_H      _PK_H_(0x20, 0x10)
#define REG_SC_BK20_11_L      _PK_L_(0x20, 0x11)
#define REG_SC_BK20_11_H      _PK_H_(0x20, 0x11)
#define REG_SC_BK20_12_L      _PK_L_(0x20, 0x12)
#define REG_SC_BK20_12_H      _PK_H_(0x20, 0x12)
#define REG_SC_BK20_13_L      _PK_L_(0x20, 0x13)
#define REG_SC_BK20_13_H      _PK_H_(0x20, 0x13)
#define REG_SC_BK20_14_L      _PK_L_(0x20, 0x14)
#define REG_SC_BK20_14_H      _PK_H_(0x20, 0x14)
#define REG_SC_BK20_15_L      _PK_L_(0x20, 0x15)
#define REG_SC_BK20_15_H      _PK_H_(0x20, 0x15)
#define REG_SC_BK20_16_L      _PK_L_(0x20, 0x16)
#define REG_SC_BK20_16_H      _PK_H_(0x20, 0x16)
#define REG_SC_BK20_17_L      _PK_L_(0x20, 0x17)
#define REG_SC_BK20_17_H      _PK_H_(0x20, 0x17)
#define REG_SC_BK20_18_L      _PK_L_(0x20, 0x18)
#define REG_SC_BK20_18_H      _PK_H_(0x20, 0x18)
#define REG_SC_BK20_19_L      _PK_L_(0x20, 0x19)
#define REG_SC_BK20_19_H      _PK_H_(0x20, 0x19)
#define REG_SC_BK20_1A_L      _PK_L_(0x20, 0x1A)
#define REG_SC_BK20_1A_H      _PK_H_(0x20, 0x1A)
#define REG_SC_BK20_1B_L      _PK_L_(0x20, 0x1B)
#define REG_SC_BK20_1B_H      _PK_H_(0x20, 0x1B)
#define REG_SC_BK20_1C_L      _PK_L_(0x20, 0x1C)
#define REG_SC_BK20_1C_H      _PK_H_(0x20, 0x1C)
#define REG_SC_BK20_1D_L      _PK_L_(0x20, 0x1D)
#define REG_SC_BK20_1D_H      _PK_H_(0x20, 0x1D)
#define REG_SC_BK20_1E_L      _PK_L_(0x20, 0x1E)
#define REG_SC_BK20_1E_H      _PK_H_(0x20, 0x1E)
#define REG_SC_BK20_1F_L      _PK_L_(0x20, 0x1F)
#define REG_SC_BK20_1F_H      _PK_H_(0x20, 0x1F)
#define REG_SC_BK20_20_L      _PK_L_(0x20, 0x20)
#define REG_SC_BK20_20_H      _PK_H_(0x20, 0x20)
#define REG_SC_BK20_21_L      _PK_L_(0x20, 0x21)
#define REG_SC_BK20_21_H      _PK_H_(0x20, 0x21)
#define REG_SC_BK20_22_L      _PK_L_(0x20, 0x22)
#define REG_SC_BK20_22_H      _PK_H_(0x20, 0x22)
#define REG_SC_BK20_23_L      _PK_L_(0x20, 0x23)
#define REG_SC_BK20_23_H      _PK_H_(0x20, 0x23)
#define REG_SC_BK20_24_L      _PK_L_(0x20, 0x24)
#define REG_SC_BK20_24_H      _PK_H_(0x20, 0x24)
#define REG_SC_BK20_25_L      _PK_L_(0x20, 0x25)
#define REG_SC_BK20_25_H      _PK_H_(0x20, 0x25)
#define REG_SC_BK20_26_L      _PK_L_(0x20, 0x26)
#define REG_SC_BK20_26_H      _PK_H_(0x20, 0x26)
#define REG_SC_BK20_27_L      _PK_L_(0x20, 0x27)
#define REG_SC_BK20_27_H      _PK_H_(0x20, 0x27)
#define REG_SC_BK20_28_L      _PK_L_(0x20, 0x28)
#define REG_SC_BK20_28_H      _PK_H_(0x20, 0x28)
#define REG_SC_BK20_29_L      _PK_L_(0x20, 0x29)
#define REG_SC_BK20_29_H      _PK_H_(0x20, 0x29)
#define REG_SC_BK20_2A_L      _PK_L_(0x20, 0x2A)
#define REG_SC_BK20_2A_H      _PK_H_(0x20, 0x2A)
#define REG_SC_BK20_2B_L      _PK_L_(0x20, 0x2B)
#define REG_SC_BK20_2B_H      _PK_H_(0x20, 0x2B)
#define REG_SC_BK20_2C_L      _PK_L_(0x20, 0x2C)
#define REG_SC_BK20_2C_H      _PK_H_(0x20, 0x2C)
#define REG_SC_BK20_2D_L      _PK_L_(0x20, 0x2D)
#define REG_SC_BK20_2D_H      _PK_H_(0x20, 0x2D)
#define REG_SC_BK20_2E_L      _PK_L_(0x20, 0x2E)
#define REG_SC_BK20_2E_H      _PK_H_(0x20, 0x2E)
#define REG_SC_BK20_2F_L      _PK_L_(0x20, 0x2F)
#define REG_SC_BK20_2F_H      _PK_H_(0x20, 0x2F)
#define REG_SC_BK20_30_L      _PK_L_(0x20, 0x30)
#define REG_SC_BK20_30_H      _PK_H_(0x20, 0x30)
#define REG_SC_BK20_31_L      _PK_L_(0x20, 0x31)
#define REG_SC_BK20_31_H      _PK_H_(0x20, 0x31)
#define REG_SC_BK20_32_L      _PK_L_(0x20, 0x32)
#define REG_SC_BK20_32_H      _PK_H_(0x20, 0x32)
#define REG_SC_BK20_33_L      _PK_L_(0x20, 0x33)
#define REG_SC_BK20_33_H      _PK_H_(0x20, 0x33)
#define REG_SC_BK20_34_L      _PK_L_(0x20, 0x34)
#define REG_SC_BK20_34_H      _PK_H_(0x20, 0x34)
#define REG_SC_BK20_35_L      _PK_L_(0x20, 0x35)
#define REG_SC_BK20_35_H      _PK_H_(0x20, 0x35)
#define REG_SC_BK20_36_L      _PK_L_(0x20, 0x36)
#define REG_SC_BK20_36_H      _PK_H_(0x20, 0x36)
#define REG_SC_BK20_37_L      _PK_L_(0x20, 0x37)
#define REG_SC_BK20_37_H      _PK_H_(0x20, 0x37)
#define REG_SC_BK20_38_L      _PK_L_(0x20, 0x38)
#define REG_SC_BK20_38_H      _PK_H_(0x20, 0x38)
#define REG_SC_BK20_39_L      _PK_L_(0x20, 0x39)
#define REG_SC_BK20_39_H      _PK_H_(0x20, 0x39)
#define REG_SC_BK20_3A_L      _PK_L_(0x20, 0x3A)
#define REG_SC_BK20_3A_H      _PK_H_(0x20, 0x3A)
#define REG_SC_BK20_3B_L      _PK_L_(0x20, 0x3B)
#define REG_SC_BK20_3B_H      _PK_H_(0x20, 0x3B)
#define REG_SC_BK20_3C_L      _PK_L_(0x20, 0x3C)
#define REG_SC_BK20_3C_H      _PK_H_(0x20, 0x3C)
#define REG_SC_BK20_3D_L      _PK_L_(0x20, 0x3D)
#define REG_SC_BK20_3D_H      _PK_H_(0x20, 0x3D)
#define REG_SC_BK20_3E_L      _PK_L_(0x20, 0x3E)
#define REG_SC_BK20_3E_H      _PK_H_(0x20, 0x3E)
#define REG_SC_BK20_3F_L      _PK_L_(0x20, 0x3F)
#define REG_SC_BK20_3F_H      _PK_H_(0x20, 0x3F)
#define REG_SC_BK20_40_L      _PK_L_(0x20, 0x40)
#define REG_SC_BK20_40_H      _PK_H_(0x20, 0x40)
#define REG_SC_BK20_41_L      _PK_L_(0x20, 0x41)
#define REG_SC_BK20_41_H      _PK_H_(0x20, 0x41)
#define REG_SC_BK20_42_L      _PK_L_(0x20, 0x42)
#define REG_SC_BK20_42_H      _PK_H_(0x20, 0x42)
#define REG_SC_BK20_43_L      _PK_L_(0x20, 0x43)
#define REG_SC_BK20_43_H      _PK_H_(0x20, 0x43)
#define REG_SC_BK20_44_L      _PK_L_(0x20, 0x44)
#define REG_SC_BK20_44_H      _PK_H_(0x20, 0x44)
#define REG_SC_BK20_45_L      _PK_L_(0x20, 0x45)
#define REG_SC_BK20_45_H      _PK_H_(0x20, 0x45)
#define REG_SC_BK20_46_L      _PK_L_(0x20, 0x46)
#define REG_SC_BK20_46_H      _PK_H_(0x20, 0x46)
#define REG_SC_BK20_47_L      _PK_L_(0x20, 0x47)
#define REG_SC_BK20_47_H      _PK_H_(0x20, 0x47)
#define REG_SC_BK20_48_L      _PK_L_(0x20, 0x48)
#define REG_SC_BK20_48_H      _PK_H_(0x20, 0x48)
#define REG_SC_BK20_49_L      _PK_L_(0x20, 0x49)
#define REG_SC_BK20_49_H      _PK_H_(0x20, 0x49)
#define REG_SC_BK20_4A_L      _PK_L_(0x20, 0x4A)
#define REG_SC_BK20_4A_H      _PK_H_(0x20, 0x4A)
#define REG_SC_BK20_4B_L      _PK_L_(0x20, 0x4B)
#define REG_SC_BK20_4B_H      _PK_H_(0x20, 0x4B)
#define REG_SC_BK20_4C_L      _PK_L_(0x20, 0x4C)
#define REG_SC_BK20_4C_H      _PK_H_(0x20, 0x4C)
#define REG_SC_BK20_4D_L      _PK_L_(0x20, 0x4D)
#define REG_SC_BK20_4D_H      _PK_H_(0x20, 0x4D)
#define REG_SC_BK20_4E_L      _PK_L_(0x20, 0x4E)
#define REG_SC_BK20_4E_H      _PK_H_(0x20, 0x4E)
#define REG_SC_BK20_4F_L      _PK_L_(0x20, 0x4F)
#define REG_SC_BK20_4F_H      _PK_H_(0x20, 0x4F)
#define REG_SC_BK20_50_L      _PK_L_(0x20, 0x50)
#define REG_SC_BK20_50_H      _PK_H_(0x20, 0x50)
#define REG_SC_BK20_51_L      _PK_L_(0x20, 0x51)
#define REG_SC_BK20_51_H      _PK_H_(0x20, 0x51)
#define REG_SC_BK20_52_L      _PK_L_(0x20, 0x52)
#define REG_SC_BK20_52_H      _PK_H_(0x20, 0x52)
#define REG_SC_BK20_53_L      _PK_L_(0x20, 0x53)
#define REG_SC_BK20_53_H      _PK_H_(0x20, 0x53)
#define REG_SC_BK20_54_L      _PK_L_(0x20, 0x54)
#define REG_SC_BK20_54_H      _PK_H_(0x20, 0x54)
#define REG_SC_BK20_55_L      _PK_L_(0x20, 0x55)
#define REG_SC_BK20_55_H      _PK_H_(0x20, 0x55)
#define REG_SC_BK20_56_L      _PK_L_(0x20, 0x56)
#define REG_SC_BK20_56_H      _PK_H_(0x20, 0x56)
#define REG_SC_BK20_57_L      _PK_L_(0x20, 0x57)
#define REG_SC_BK20_57_H      _PK_H_(0x20, 0x57)
#define REG_SC_BK20_58_L      _PK_L_(0x20, 0x58)
#define REG_SC_BK20_58_H      _PK_H_(0x20, 0x58)
#define REG_SC_BK20_59_L      _PK_L_(0x20, 0x59)
#define REG_SC_BK20_59_H      _PK_H_(0x20, 0x59)
#define REG_SC_BK20_5A_L      _PK_L_(0x20, 0x5A)
#define REG_SC_BK20_5A_H      _PK_H_(0x20, 0x5A)
#define REG_SC_BK20_5B_L      _PK_L_(0x20, 0x5B)
#define REG_SC_BK20_5B_H      _PK_H_(0x20, 0x5B)
#define REG_SC_BK20_5C_L      _PK_L_(0x20, 0x5C)
#define REG_SC_BK20_5C_H      _PK_H_(0x20, 0x5C)
#define REG_SC_BK20_5D_L      _PK_L_(0x20, 0x5D)
#define REG_SC_BK20_5D_H      _PK_H_(0x20, 0x5D)
#define REG_SC_BK20_5E_L      _PK_L_(0x20, 0x5E)
#define REG_SC_BK20_5E_H      _PK_H_(0x20, 0x5E)
#define REG_SC_BK20_5F_L      _PK_L_(0x20, 0x5F)
#define REG_SC_BK20_5F_H      _PK_H_(0x20, 0x5F)
#define REG_SC_BK20_60_L      _PK_L_(0x20, 0x60)
#define REG_SC_BK20_60_H      _PK_H_(0x20, 0x60)
#define REG_SC_BK20_61_L      _PK_L_(0x20, 0x61)
#define REG_SC_BK20_61_H      _PK_H_(0x20, 0x61)
#define REG_SC_BK20_62_L      _PK_L_(0x20, 0x62)
#define REG_SC_BK20_62_H      _PK_H_(0x20, 0x62)
#define REG_SC_BK20_63_L      _PK_L_(0x20, 0x63)
#define REG_SC_BK20_63_H      _PK_H_(0x20, 0x63)
#define REG_SC_BK20_64_L      _PK_L_(0x20, 0x64)
#define REG_SC_BK20_64_H      _PK_H_(0x20, 0x64)
#define REG_SC_BK20_65_L      _PK_L_(0x20, 0x65)
#define REG_SC_BK20_65_H      _PK_H_(0x20, 0x65)
#define REG_SC_BK20_66_L      _PK_L_(0x20, 0x66)
#define REG_SC_BK20_66_H      _PK_H_(0x20, 0x66)
#define REG_SC_BK20_67_L      _PK_L_(0x20, 0x67)
#define REG_SC_BK20_67_H      _PK_H_(0x20, 0x67)
#define REG_SC_BK20_68_L      _PK_L_(0x20, 0x68)
#define REG_SC_BK20_68_H      _PK_H_(0x20, 0x68)
#define REG_SC_BK20_69_L      _PK_L_(0x20, 0x69)
#define REG_SC_BK20_69_H      _PK_H_(0x20, 0x69)
#define REG_SC_BK20_6A_L      _PK_L_(0x20, 0x6A)
#define REG_SC_BK20_6A_H      _PK_H_(0x20, 0x6A)
#define REG_SC_BK20_6B_L      _PK_L_(0x20, 0x6B)
#define REG_SC_BK20_6B_H      _PK_H_(0x20, 0x6B)
#define REG_SC_BK20_6C_L      _PK_L_(0x20, 0x6C)
#define REG_SC_BK20_6C_H      _PK_H_(0x20, 0x6C)
#define REG_SC_BK20_6D_L      _PK_L_(0x20, 0x6D)
#define REG_SC_BK20_6D_H      _PK_H_(0x20, 0x6D)
#define REG_SC_BK20_6E_L      _PK_L_(0x20, 0x6E)
#define REG_SC_BK20_6E_H      _PK_H_(0x20, 0x6E)
#define REG_SC_BK20_6F_L      _PK_L_(0x20, 0x6F)
#define REG_SC_BK20_6F_H      _PK_H_(0x20, 0x6F)
#define REG_SC_BK20_70_L      _PK_L_(0x20, 0x70)
#define REG_SC_BK20_70_H      _PK_H_(0x20, 0x70)
#define REG_SC_BK20_71_L      _PK_L_(0x20, 0x71)
#define REG_SC_BK20_71_H      _PK_H_(0x20, 0x71)
#define REG_SC_BK20_72_L      _PK_L_(0x20, 0x72)
#define REG_SC_BK20_72_H      _PK_H_(0x20, 0x72)
#define REG_SC_BK20_73_L      _PK_L_(0x20, 0x73)
#define REG_SC_BK20_73_H      _PK_H_(0x20, 0x73)
#define REG_SC_BK20_74_L      _PK_L_(0x20, 0x74)
#define REG_SC_BK20_74_H      _PK_H_(0x20, 0x74)
#define REG_SC_BK20_75_L      _PK_L_(0x20, 0x75)
#define REG_SC_BK20_75_H      _PK_H_(0x20, 0x75)
#define REG_SC_BK20_76_L      _PK_L_(0x20, 0x76)
#define REG_SC_BK20_76_H      _PK_H_(0x20, 0x76)
#define REG_SC_BK20_77_L      _PK_L_(0x20, 0x77)
#define REG_SC_BK20_77_H      _PK_H_(0x20, 0x77)
#define REG_SC_BK20_78_L      _PK_L_(0x20, 0x78)
#define REG_SC_BK20_78_H      _PK_H_(0x20, 0x78)
#define REG_SC_BK20_79_L      _PK_L_(0x20, 0x79)
#define REG_SC_BK20_79_H      _PK_H_(0x20, 0x79)
#define REG_SC_BK20_7A_L      _PK_L_(0x20, 0x7A)
#define REG_SC_BK20_7A_H      _PK_H_(0x20, 0x7A)
#define REG_SC_BK20_7B_L      _PK_L_(0x20, 0x7B)
#define REG_SC_BK20_7B_H      _PK_H_(0x20, 0x7B)
#define REG_SC_BK20_7C_L      _PK_L_(0x20, 0x7C)
#define REG_SC_BK20_7C_H      _PK_H_(0x20, 0x7C)
#define REG_SC_BK20_7D_L      _PK_L_(0x20, 0x7D)
#define REG_SC_BK20_7D_H      _PK_H_(0x20, 0x7D)
#define REG_SC_BK20_7E_L      _PK_L_(0x20, 0x7E)
#define REG_SC_BK20_7E_H      _PK_H_(0x20, 0x7E)
#define REG_SC_BK20_7F_L      _PK_L_(0x20, 0x7F)
#define REG_SC_BK20_7F_H      _PK_H_(0x20, 0x7F)

//----------------------------------------------
//  BK21
//----------------------------------------------
#define REG_SC_BK21_00_L      _PK_L_(0x21, 0x00)
#define REG_SC_BK21_00_H      _PK_H_(0x21, 0x00)
#define REG_SC_BK21_01_L      _PK_L_(0x21, 0x01)
#define REG_SC_BK21_01_H      _PK_H_(0x21, 0x01)
#define REG_SC_BK21_02_L      _PK_L_(0x21, 0x02)
#define REG_SC_BK21_02_H      _PK_H_(0x21, 0x02)
#define REG_SC_BK21_03_L      _PK_L_(0x21, 0x03)
#define REG_SC_BK21_03_H      _PK_H_(0x21, 0x03)
#define REG_SC_BK21_04_L      _PK_L_(0x21, 0x04)
#define REG_SC_BK21_04_H      _PK_H_(0x21, 0x04)
#define REG_SC_BK21_05_L      _PK_L_(0x21, 0x05)
#define REG_SC_BK21_05_H      _PK_H_(0x21, 0x05)
#define REG_SC_BK21_06_L      _PK_L_(0x21, 0x06)
#define REG_SC_BK21_06_H      _PK_H_(0x21, 0x06)
#define REG_SC_BK21_07_L      _PK_L_(0x21, 0x07)
#define REG_SC_BK21_07_H      _PK_H_(0x21, 0x07)
#define REG_SC_BK21_08_L      _PK_L_(0x21, 0x08)
#define REG_SC_BK21_08_H      _PK_H_(0x21, 0x08)
#define REG_SC_BK21_09_L      _PK_L_(0x21, 0x09)
#define REG_SC_BK21_09_H      _PK_H_(0x21, 0x09)
#define REG_SC_BK21_0A_L      _PK_L_(0x21, 0x0A)
#define REG_SC_BK21_0A_H      _PK_H_(0x21, 0x0A)
#define REG_SC_BK21_0B_L      _PK_L_(0x21, 0x0B)
#define REG_SC_BK21_0B_H      _PK_H_(0x21, 0x0B)
#define REG_SC_BK21_0C_L      _PK_L_(0x21, 0x0C)
#define REG_SC_BK21_0C_H      _PK_H_(0x21, 0x0C)
#define REG_SC_BK21_0D_L      _PK_L_(0x21, 0x0d)
#define REG_SC_BK21_0D_H      _PK_H_(0x21, 0x0d)
#define REG_SC_BK21_0E_L      _PK_L_(0x21, 0x0e)
#define REG_SC_BK21_0E_H      _PK_H_(0x21, 0x0e)
#define REG_SC_BK21_0F_L      _PK_L_(0x21, 0x0f)
#define REG_SC_BK21_0F_H      _PK_H_(0x21, 0x0f)

#define REG_SC_BK21_10_L      _PK_L_(0x21, 0x10)
#define REG_SC_BK21_10_H      _PK_H_(0x21, 0x10)
#define REG_SC_BK21_11_L      _PK_L_(0x21, 0x11)
#define REG_SC_BK21_11_H      _PK_H_(0x21, 0x11)
#define REG_SC_BK21_12_L      _PK_L_(0x21, 0x12)
#define REG_SC_BK21_12_H      _PK_H_(0x21, 0x12)
#define REG_SC_BK21_13_L      _PK_L_(0x21, 0x13)
#define REG_SC_BK21_13_H      _PK_H_(0x21, 0x13)
#define REG_SC_BK21_14_L      _PK_L_(0x21, 0x14)
#define REG_SC_BK21_14_H      _PK_H_(0x21, 0x14)
#define REG_SC_BK21_15_L      _PK_L_(0x21, 0x15)
#define REG_SC_BK21_15_H      _PK_H_(0x21, 0x15)
#define REG_SC_BK21_16_L      _PK_L_(0x21, 0x16)
#define REG_SC_BK21_16_H      _PK_H_(0x21, 0x16)
#define REG_SC_BK21_17_L      _PK_L_(0x21, 0x17)
#define REG_SC_BK21_17_H      _PK_H_(0x21, 0x17)
#define REG_SC_BK21_18_L      _PK_L_(0x21, 0x18)
#define REG_SC_BK21_18_H      _PK_H_(0x21, 0x18)
#define REG_SC_BK21_19_L      _PK_L_(0x21, 0x19)
#define REG_SC_BK21_19_H      _PK_H_(0x21, 0x19)
#define REG_SC_BK21_1A_L      _PK_L_(0x21, 0x1A)
#define REG_SC_BK21_1A_H      _PK_H_(0x21, 0x1A)
#define REG_SC_BK21_1B_L      _PK_L_(0x21, 0x1B)
#define REG_SC_BK21_1B_H      _PK_H_(0x21, 0x1B)
#define REG_SC_BK21_1C_L      _PK_L_(0x21, 0x1C)
#define REG_SC_BK21_1C_H      _PK_H_(0x21, 0x1C)
#define REG_SC_BK21_1D_L      _PK_L_(0x21, 0x1d)
#define REG_SC_BK21_1D_H      _PK_H_(0x21, 0x1d)
#define REG_SC_BK21_1E_L      _PK_L_(0x21, 0x1e)
#define REG_SC_BK21_1E_H      _PK_H_(0x21, 0x1e)
#define REG_SC_BK21_1F_L      _PK_L_(0x21, 0x1f)
#define REG_SC_BK21_1F_H      _PK_H_(0x21, 0x1f)

#define REG_SC_BK21_20_L      _PK_L_(0x21, 0x20)
#define REG_SC_BK21_20_H      _PK_H_(0x21, 0x20)
#define REG_SC_BK21_21_L      _PK_L_(0x21, 0x21)
#define REG_SC_BK21_21_H      _PK_H_(0x21, 0x21)
#define REG_SC_BK21_22_L      _PK_L_(0x21, 0x22)
#define REG_SC_BK21_22_H      _PK_H_(0x21, 0x22)
#define REG_SC_BK21_23_L      _PK_L_(0x21, 0x23)
#define REG_SC_BK21_23_H      _PK_H_(0x21, 0x23)
#define REG_SC_BK21_24_L      _PK_L_(0x21, 0x24)
#define REG_SC_BK21_24_H      _PK_H_(0x21, 0x24)
#define REG_SC_BK21_25_L      _PK_L_(0x21, 0x25)
#define REG_SC_BK21_25_H      _PK_H_(0x21, 0x25)
#define REG_SC_BK21_26_L      _PK_L_(0x21, 0x26)
#define REG_SC_BK21_26_H      _PK_H_(0x21, 0x26)
#define REG_SC_BK21_27_L      _PK_L_(0x21, 0x27)
#define REG_SC_BK21_27_H      _PK_H_(0x21, 0x27)
#define REG_SC_BK21_28_L      _PK_L_(0x21, 0x28)
#define REG_SC_BK21_28_H      _PK_H_(0x21, 0x28)
#define REG_SC_BK21_29_L      _PK_L_(0x21, 0x29)
#define REG_SC_BK21_29_H      _PK_H_(0x21, 0x29)
#define REG_SC_BK21_2A_L      _PK_L_(0x21, 0x2A)
#define REG_SC_BK21_2A_H      _PK_H_(0x21, 0x2A)
#define REG_SC_BK21_2B_L      _PK_L_(0x21, 0x2B)
#define REG_SC_BK21_2B_H      _PK_H_(0x21, 0x2B)
#define REG_SC_BK21_2C_L      _PK_L_(0x21, 0x2C)
#define REG_SC_BK21_2C_H      _PK_H_(0x21, 0x2C)
#define REG_SC_BK21_2D_L      _PK_L_(0x21, 0x2d)
#define REG_SC_BK21_2D_H      _PK_H_(0x21, 0x2d)
#define REG_SC_BK21_2E_L      _PK_L_(0x21, 0x2e)
#define REG_SC_BK21_2E_H      _PK_H_(0x21, 0x2e)
#define REG_SC_BK21_2F_L      _PK_L_(0x21, 0x2f)
#define REG_SC_BK21_2F_H      _PK_H_(0x21, 0x2f)
#define REG_SC_BK21_77_L      _PK_L_(0x21, 0x77)

//----------------------------------------------
//  BK22
//----------------------------------------------
#define REG_SC_BK22_00_L      _PK_L_(0x22, 0x00)
#define REG_SC_BK22_00_H      _PK_H_(0x22, 0x00)
#define REG_SC_BK22_01_L      _PK_L_(0x22, 0x01)
#define REG_SC_BK22_01_H      _PK_H_(0x22, 0x01)
#define REG_SC_BK22_02_L      _PK_L_(0x22, 0x02)
#define REG_SC_BK22_02_H      _PK_H_(0x22, 0x02)
#define REG_SC_BK22_03_L      _PK_L_(0x22, 0x03)
#define REG_SC_BK22_03_H      _PK_H_(0x22, 0x03)
#define REG_SC_BK22_04_L      _PK_L_(0x22, 0x04)
#define REG_SC_BK22_04_H      _PK_H_(0x22, 0x04)
#define REG_SC_BK22_05_L      _PK_L_(0x22, 0x05)
#define REG_SC_BK22_05_H      _PK_H_(0x22, 0x05)
#define REG_SC_BK22_06_L      _PK_L_(0x22, 0x06)
#define REG_SC_BK22_06_H      _PK_H_(0x22, 0x06)
#define REG_SC_BK22_07_L      _PK_L_(0x22, 0x07)
#define REG_SC_BK22_07_H      _PK_H_(0x22, 0x07)
#define REG_SC_BK22_08_L      _PK_L_(0x22, 0x08)
#define REG_SC_BK22_08_H      _PK_H_(0x22, 0x08)
#define REG_SC_BK22_09_L      _PK_L_(0x22, 0x09)
#define REG_SC_BK22_09_H      _PK_H_(0x22, 0x09)
#define REG_SC_BK22_0A_L      _PK_L_(0x22, 0x0A)
#define REG_SC_BK22_0A_H      _PK_H_(0x22, 0x0A)
#define REG_SC_BK22_0B_L      _PK_L_(0x22, 0x0B)
#define REG_SC_BK22_0B_H      _PK_H_(0x22, 0x0B)
#define REG_SC_BK22_0C_L      _PK_L_(0x22, 0x0C)
#define REG_SC_BK22_0C_H      _PK_H_(0x22, 0x0C)
#define REG_SC_BK22_0D_L      _PK_L_(0x22, 0x0d)
#define REG_SC_BK22_0D_H      _PK_H_(0x22, 0x0d)
#define REG_SC_BK22_0E_L      _PK_L_(0x22, 0x0e)
#define REG_SC_BK22_0E_H      _PK_H_(0x22, 0x0e)
#define REG_SC_BK22_0F_L      _PK_L_(0x22, 0x0f)
#define REG_SC_BK22_0F_H      _PK_H_(0x22, 0x0f)

#define REG_SC_BK22_10_L      _PK_L_(0x22, 0x10)
#define REG_SC_BK22_10_H      _PK_H_(0x22, 0x10)
#define REG_SC_BK22_11_L      _PK_L_(0x22, 0x11)
#define REG_SC_BK22_11_H      _PK_H_(0x22, 0x11)
#define REG_SC_BK22_12_L      _PK_L_(0x22, 0x12)
#define REG_SC_BK22_12_H      _PK_H_(0x22, 0x12)
#define REG_SC_BK22_13_L      _PK_L_(0x22, 0x13)
#define REG_SC_BK22_13_H      _PK_H_(0x22, 0x13)
#define REG_SC_BK22_14_L      _PK_L_(0x22, 0x14)
#define REG_SC_BK22_14_H      _PK_H_(0x22, 0x14)
#define REG_SC_BK22_15_L      _PK_L_(0x22, 0x15)
#define REG_SC_BK22_15_H      _PK_H_(0x22, 0x15)
#define REG_SC_BK22_16_L      _PK_L_(0x22, 0x16)
#define REG_SC_BK22_16_H      _PK_H_(0x22, 0x16)
#define REG_SC_BK22_17_L      _PK_L_(0x22, 0x17)
#define REG_SC_BK22_17_H      _PK_H_(0x22, 0x17)
#define REG_SC_BK22_18_L      _PK_L_(0x22, 0x18)
#define REG_SC_BK22_18_H      _PK_H_(0x22, 0x18)
#define REG_SC_BK22_19_L      _PK_L_(0x22, 0x19)
#define REG_SC_BK22_19_H      _PK_H_(0x22, 0x19)
#define REG_SC_BK22_1A_L      _PK_L_(0x22, 0x1A)
#define REG_SC_BK22_1A_H      _PK_H_(0x22, 0x1A)
#define REG_SC_BK22_1B_L      _PK_L_(0x22, 0x1B)
#define REG_SC_BK22_1B_H      _PK_H_(0x22, 0x1B)
#define REG_SC_BK22_1C_L      _PK_L_(0x22, 0x1C)
#define REG_SC_BK22_1C_H      _PK_H_(0x22, 0x1C)
#define REG_SC_BK22_1D_L      _PK_L_(0x22, 0x1d)
#define REG_SC_BK22_1D_H      _PK_H_(0x22, 0x1d)
#define REG_SC_BK22_1E_L      _PK_L_(0x22, 0x1e)
#define REG_SC_BK22_1E_H      _PK_H_(0x22, 0x1e)
#define REG_SC_BK22_1F_L      _PK_L_(0x22, 0x1f)
#define REG_SC_BK22_1F_H      _PK_H_(0x22, 0x1f)

#define REG_SC_BK22_40_L      _PK_L_(0x22, 0x40)
#define REG_SC_BK22_40_H      _PK_H_(0x22, 0x40)
#define REG_SC_BK22_41_L      _PK_L_(0x22, 0x41)
#define REG_SC_BK22_41_H      _PK_H_(0x22, 0x41)
#define REG_SC_BK22_42_L      _PK_L_(0x22, 0x42)
#define REG_SC_BK22_42_H      _PK_H_(0x22, 0x42)
#define REG_SC_BK22_43_L      _PK_L_(0x22, 0x43)
#define REG_SC_BK22_43_H      _PK_H_(0x22, 0x43)
#define REG_SC_BK22_44_L      _PK_L_(0x22, 0x44)
#define REG_SC_BK22_44_H      _PK_H_(0x22, 0x44)
#define REG_SC_BK22_45_L      _PK_L_(0x22, 0x45)
#define REG_SC_BK22_45_H      _PK_H_(0x22, 0x45)
#define REG_SC_BK22_46_L      _PK_L_(0x22, 0x46)
#define REG_SC_BK22_46_H      _PK_H_(0x22, 0x46)
#define REG_SC_BK22_47_L      _PK_L_(0x22, 0x47)
#define REG_SC_BK22_47_H      _PK_H_(0x22, 0x47)
#define REG_SC_BK22_48_L      _PK_L_(0x22, 0x48)
#define REG_SC_BK22_48_H      _PK_H_(0x22, 0x48)
#define REG_SC_BK22_49_L      _PK_L_(0x22, 0x49)
#define REG_SC_BK22_49_H      _PK_H_(0x22, 0x49)
#define REG_SC_BK22_4A_L      _PK_L_(0x22, 0x4A)
#define REG_SC_BK22_4A_H      _PK_H_(0x22, 0x4A)
#define REG_SC_BK22_4B_L      _PK_L_(0x22, 0x4B)
#define REG_SC_BK22_4B_H      _PK_H_(0x22, 0x4B)
#define REG_SC_BK22_4C_L      _PK_L_(0x22, 0x4C)
#define REG_SC_BK22_4C_H      _PK_H_(0x22, 0x4C)
#define REG_SC_BK22_4D_L      _PK_L_(0x22, 0x4d)
#define REG_SC_BK22_4D_H      _PK_H_(0x22, 0x4d)
#define REG_SC_BK22_4E_L      _PK_L_(0x22, 0x4e)
#define REG_SC_BK22_4E_H      _PK_H_(0x22, 0x4e)
#define REG_SC_BK22_4F_L      _PK_L_(0x22, 0x4f)
#define REG_SC_BK22_4F_H      _PK_H_(0x22, 0x4f)

#define REG_SC_BK22_70_L      _PK_L_(0x22, 0x70)
#define REG_SC_BK22_70_H      _PK_H_(0x22, 0x70)
#define REG_SC_BK22_71_L      _PK_L_(0x22, 0x71)
#define REG_SC_BK22_71_H      _PK_H_(0x22, 0x71)
#define REG_SC_BK22_72_L      _PK_L_(0x22, 0x72)
#define REG_SC_BK22_72_H      _PK_H_(0x22, 0x72)
#define REG_SC_BK22_73_L      _PK_L_(0x22, 0x73)
#define REG_SC_BK22_73_H      _PK_H_(0x22, 0x73)
#define REG_SC_BK22_74_L      _PK_L_(0x22, 0x74)
#define REG_SC_BK22_74_H      _PK_H_(0x22, 0x74)
#define REG_SC_BK22_75_L      _PK_L_(0x22, 0x75)
#define REG_SC_BK22_75_H      _PK_H_(0x22, 0x75)
#define REG_SC_BK22_76_L      _PK_L_(0x22, 0x76)
#define REG_SC_BK22_76_H      _PK_H_(0x22, 0x76)
#define REG_SC_BK22_77_L      _PK_L_(0x22, 0x77)
#define REG_SC_BK22_77_H      _PK_H_(0x22, 0x77)
#define REG_SC_BK22_78_L      _PK_L_(0x22, 0x78)
#define REG_SC_BK22_78_H      _PK_H_(0x22, 0x78)
#define REG_SC_BK22_79_L      _PK_L_(0x22, 0x79)
#define REG_SC_BK22_79_H      _PK_H_(0x22, 0x79)
#define REG_SC_BK22_7A_L      _PK_L_(0x22, 0x7A)
#define REG_SC_BK22_7A_H      _PK_H_(0x22, 0x7A)
#define REG_SC_BK22_7B_L      _PK_L_(0x22, 0x7B)
#define REG_SC_BK22_7B_H      _PK_H_(0x22, 0x7B)
#define REG_SC_BK22_7C_L      _PK_L_(0x22, 0x7C)
#define REG_SC_BK22_7C_H      _PK_H_(0x22, 0x7C)
#define REG_SC_BK22_7D_L      _PK_L_(0x22, 0x7d)
#define REG_SC_BK22_7D_H      _PK_H_(0x22, 0x7d)
#define REG_SC_BK22_7E_L      _PK_L_(0x22, 0x7e)
#define REG_SC_BK22_7E_H      _PK_H_(0x22, 0x7e)
#define REG_SC_BK22_7F_L      _PK_L_(0x22, 0x7f)
#define REG_SC_BK22_7F_H      _PK_H_(0x22, 0x7f)

//----------------------------------------------
//  BK23
//----------------------------------------------
#define REG_SC_BK23_00_L      _PK_L_(0x23, 0x00)
#define REG_SC_BK23_00_H      _PK_H_(0x23, 0x00)
#define REG_SC_BK23_01_L      _PK_L_(0x23, 0x01)
#define REG_SC_BK23_01_H      _PK_H_(0x23, 0x01)
#define REG_SC_BK23_02_L      _PK_L_(0x23, 0x02)
#define REG_SC_BK23_02_H      _PK_H_(0x23, 0x02)
#define REG_SC_BK23_03_L      _PK_L_(0x23, 0x03)
#define REG_SC_BK23_03_H      _PK_H_(0x23, 0x03)
#define REG_SC_BK23_04_L      _PK_L_(0x23, 0x04)
#define REG_SC_BK23_04_H      _PK_H_(0x23, 0x04)
#define REG_SC_BK23_05_L      _PK_L_(0x23, 0x05)
#define REG_SC_BK23_05_H      _PK_H_(0x23, 0x05)
#define REG_SC_BK23_06_L      _PK_L_(0x23, 0x06)
#define REG_SC_BK23_06_H      _PK_H_(0x23, 0x06)
#define REG_SC_BK23_07_L      _PK_L_(0x23, 0x07)
#define REG_SC_BK23_07_H      _PK_H_(0x23, 0x07)
#define REG_SC_BK23_08_L      _PK_L_(0x23, 0x08)
#define REG_SC_BK23_08_H      _PK_H_(0x23, 0x08)
#define REG_SC_BK23_09_L      _PK_L_(0x23, 0x09)
#define REG_SC_BK23_09_H      _PK_H_(0x23, 0x09)
#define REG_SC_BK23_0A_L      _PK_L_(0x23, 0x0A)
#define REG_SC_BK23_0A_H      _PK_H_(0x23, 0x0A)
#define REG_SC_BK23_0B_L      _PK_L_(0x23, 0x0B)
#define REG_SC_BK23_0B_H      _PK_H_(0x23, 0x0B)
#define REG_SC_BK23_0C_L      _PK_L_(0x23, 0x0C)
#define REG_SC_BK23_0C_H      _PK_H_(0x23, 0x0C)
#define REG_SC_BK23_0D_L      _PK_L_(0x23, 0x0d)
#define REG_SC_BK23_0D_H      _PK_H_(0x23, 0x0d)
#define REG_SC_BK23_0E_L      _PK_L_(0x23, 0x0e)
#define REG_SC_BK23_0E_H      _PK_H_(0x23, 0x0e)
#define REG_SC_BK23_0F_L      _PK_L_(0x23, 0x0f)
#define REG_SC_BK23_0F_H      _PK_H_(0x23, 0x0f)

#define REG_SC_BK23_10_L      _PK_L_(0x23, 0x10)
#define REG_SC_BK23_10_H      _PK_H_(0x23, 0x10)
#define REG_SC_BK23_11_L      _PK_L_(0x23, 0x11)
#define REG_SC_BK23_11_H      _PK_H_(0x23, 0x11)
#define REG_SC_BK23_12_L      _PK_L_(0x23, 0x12)
#define REG_SC_BK23_12_H      _PK_H_(0x23, 0x12)
#define REG_SC_BK23_13_L      _PK_L_(0x23, 0x13)
#define REG_SC_BK23_13_H      _PK_H_(0x23, 0x13)
#define REG_SC_BK23_14_L      _PK_L_(0x23, 0x14)
#define REG_SC_BK23_14_H      _PK_H_(0x23, 0x14)
#define REG_SC_BK23_15_L      _PK_L_(0x23, 0x15)
#define REG_SC_BK23_15_H      _PK_H_(0x23, 0x15)
#define REG_SC_BK23_16_L      _PK_L_(0x23, 0x16)
#define REG_SC_BK23_16_H      _PK_H_(0x23, 0x16)
#define REG_SC_BK23_17_L      _PK_L_(0x23, 0x17)
#define REG_SC_BK23_17_H      _PK_H_(0x23, 0x17)
#define REG_SC_BK23_18_L      _PK_L_(0x23, 0x18)
#define REG_SC_BK23_18_H      _PK_H_(0x23, 0x18)
#define REG_SC_BK23_19_L      _PK_L_(0x23, 0x19)
#define REG_SC_BK23_19_H      _PK_H_(0x23, 0x19)
#define REG_SC_BK23_1A_L      _PK_L_(0x23, 0x1A)
#define REG_SC_BK23_1A_H      _PK_H_(0x23, 0x1A)
#define REG_SC_BK23_1B_L      _PK_L_(0x23, 0x1B)
#define REG_SC_BK23_1B_H      _PK_H_(0x23, 0x1B)
#define REG_SC_BK23_1C_L      _PK_L_(0x23, 0x1C)
#define REG_SC_BK23_1C_H      _PK_H_(0x23, 0x1C)
#define REG_SC_BK23_1D_L      _PK_L_(0x23, 0x1d)
#define REG_SC_BK23_1D_H      _PK_H_(0x23, 0x1d)
#define REG_SC_BK23_1E_L      _PK_L_(0x23, 0x1e)
#define REG_SC_BK23_1E_H      _PK_H_(0x23, 0x1e)
#define REG_SC_BK23_1F_L      _PK_L_(0x23, 0x1f)
#define REG_SC_BK23_1F_H      _PK_H_(0x23, 0x1f)
#define REG_SC_BK23_20_L      _PK_L_(0x23, 0x20)
#define REG_SC_BK23_20_H      _PK_H_(0x23, 0x20)
#define REG_SC_BK23_21_L      _PK_L_(0x23, 0x21)
#define REG_SC_BK23_21_H      _PK_H_(0x23, 0x21)
#define REG_SC_BK23_22_L      _PK_L_(0x23, 0x22)
#define REG_SC_BK23_22_H      _PK_H_(0x23, 0x22)
#define REG_SC_BK23_23_L      _PK_L_(0x23, 0x23)
#define REG_SC_BK23_23_H      _PK_H_(0x23, 0x23)
#define REG_SC_BK23_24_L      _PK_L_(0x23, 0x24)
#define REG_SC_BK23_24_H      _PK_H_(0x23, 0x24)
#define REG_SC_BK23_25_L      _PK_L_(0x23, 0x25)
#define REG_SC_BK23_25_H      _PK_H_(0x23, 0x25)
#define REG_SC_BK23_26_L      _PK_L_(0x23, 0x26)
#define REG_SC_BK23_26_H      _PK_H_(0x23, 0x26)
#define REG_SC_BK23_27_L      _PK_L_(0x23, 0x27)
#define REG_SC_BK23_27_H      _PK_H_(0x23, 0x27)
#define REG_SC_BK23_28_L      _PK_L_(0x23, 0x28)
#define REG_SC_BK23_28_H      _PK_H_(0x23, 0x28)
#define REG_SC_BK23_29_L      _PK_L_(0x23, 0x29)
#define REG_SC_BK23_29_H      _PK_H_(0x23, 0x29)
#define REG_SC_BK23_2A_L      _PK_L_(0x23, 0x2A)
#define REG_SC_BK23_2A_H      _PK_H_(0x23, 0x2A)
#define REG_SC_BK23_2B_L      _PK_L_(0x23, 0x2B)
#define REG_SC_BK23_2B_H      _PK_H_(0x23, 0x2B)
#define REG_SC_BK23_2C_L      _PK_L_(0x23, 0x2C)
#define REG_SC_BK23_2C_H      _PK_H_(0x23, 0x2C)
#define REG_SC_BK23_2D_L      _PK_L_(0x23, 0x2D)
#define REG_SC_BK23_2D_H      _PK_H_(0x23, 0x2D)
#define REG_SC_BK23_2E_L      _PK_L_(0x23, 0x2E)
#define REG_SC_BK23_2E_H      _PK_H_(0x23, 0x2E)
#define REG_SC_BK23_2F_L      _PK_L_(0x23, 0x2F)
#define REG_SC_BK23_2F_H      _PK_H_(0x23, 0x2F)
#define REG_SC_BK23_30_L      _PK_L_(0x23, 0x30)
#define REG_SC_BK23_30_H      _PK_H_(0x23, 0x30)
#define REG_SC_BK23_31_L      _PK_L_(0x23, 0x31)
#define REG_SC_BK23_31_H      _PK_H_(0x23, 0x31)
#define REG_SC_BK23_32_L      _PK_L_(0x23, 0x32)
#define REG_SC_BK23_32_H      _PK_H_(0x23, 0x32)
#define REG_SC_BK23_33_L      _PK_L_(0x23, 0x33)
#define REG_SC_BK23_33_H      _PK_H_(0x23, 0x33)
#define REG_SC_BK23_34_L      _PK_L_(0x23, 0x34)
#define REG_SC_BK23_34_H      _PK_H_(0x23, 0x34)
#define REG_SC_BK23_35_L      _PK_L_(0x23, 0x35)
#define REG_SC_BK23_35_H      _PK_H_(0x23, 0x35)
#define REG_SC_BK23_36_L      _PK_L_(0x23, 0x36)
#define REG_SC_BK23_36_H      _PK_H_(0x23, 0x36)
#define REG_SC_BK23_37_L      _PK_L_(0x23, 0x37)
#define REG_SC_BK23_37_H      _PK_H_(0x23, 0x37)
#define REG_SC_BK23_38_L      _PK_L_(0x23, 0x38)
#define REG_SC_BK23_38_H      _PK_H_(0x23, 0x38)
#define REG_SC_BK23_39_L      _PK_L_(0x23, 0x39)
#define REG_SC_BK23_39_H      _PK_H_(0x23, 0x39)
#define REG_SC_BK23_3A_L      _PK_L_(0x23, 0x3A)
#define REG_SC_BK23_3A_H      _PK_H_(0x23, 0x3A)
#define REG_SC_BK23_3B_L      _PK_L_(0x23, 0x3B)
#define REG_SC_BK23_3B_H      _PK_H_(0x23, 0x3B)
#define REG_SC_BK23_3C_L      _PK_L_(0x23, 0x3C)
#define REG_SC_BK23_3C_H      _PK_H_(0x23, 0x3C)
#define REG_SC_BK23_3D_L      _PK_L_(0x23, 0x3D)
#define REG_SC_BK23_3D_H      _PK_H_(0x23, 0x3D)
#define REG_SC_BK23_3E_L      _PK_L_(0x23, 0x3E)
#define REG_SC_BK23_3E_H      _PK_H_(0x23, 0x3E)
#define REG_SC_BK23_3F_L      _PK_L_(0x23, 0x3F)
#define REG_SC_BK23_3F_H      _PK_H_(0x23, 0x3F)
#define REG_SC_BK23_40_L      _PK_L_(0x23, 0x40)
#define REG_SC_BK23_40_H      _PK_H_(0x23, 0x40)
#define REG_SC_BK23_41_L      _PK_L_(0x23, 0x41)
#define REG_SC_BK23_41_H      _PK_H_(0x23, 0x41)
#define REG_SC_BK23_42_L      _PK_L_(0x23, 0x42)
#define REG_SC_BK23_42_H      _PK_H_(0x23, 0x42)
#define REG_SC_BK23_43_L      _PK_L_(0x23, 0x43)
#define REG_SC_BK23_43_H      _PK_H_(0x23, 0x43)
#define REG_SC_BK23_44_L      _PK_L_(0x23, 0x44)
#define REG_SC_BK23_44_H      _PK_H_(0x23, 0x44)
#define REG_SC_BK23_45_L      _PK_L_(0x23, 0x45)
#define REG_SC_BK23_45_H      _PK_H_(0x23, 0x45)
#define REG_SC_BK23_46_L      _PK_L_(0x23, 0x46)
#define REG_SC_BK23_46_H      _PK_H_(0x23, 0x46)
#define REG_SC_BK23_47_L      _PK_L_(0x23, 0x47)
#define REG_SC_BK23_47_H      _PK_H_(0x23, 0x47)
#define REG_SC_BK23_48_L      _PK_L_(0x23, 0x48)
#define REG_SC_BK23_48_H      _PK_H_(0x23, 0x48)
#define REG_SC_BK23_49_L      _PK_L_(0x23, 0x49)
#define REG_SC_BK23_49_H      _PK_H_(0x23, 0x49)
#define REG_SC_BK23_4A_L      _PK_L_(0x23, 0x4A)
#define REG_SC_BK23_4A_H      _PK_H_(0x23, 0x4A)
#define REG_SC_BK23_4B_L      _PK_L_(0x23, 0x4B)
#define REG_SC_BK23_4B_H      _PK_H_(0x23, 0x4B)
#define REG_SC_BK23_4C_L      _PK_L_(0x23, 0x4C)
#define REG_SC_BK23_4C_H      _PK_H_(0x23, 0x4C)
#define REG_SC_BK23_4D_L      _PK_L_(0x23, 0x4D)
#define REG_SC_BK23_4D_H      _PK_H_(0x23, 0x4D)
#define REG_SC_BK23_4E_L      _PK_L_(0x23, 0x4E)
#define REG_SC_BK23_4E_H      _PK_H_(0x23, 0x4E)
#define REG_SC_BK23_4F_L      _PK_L_(0x23, 0x4F)
#define REG_SC_BK23_4F_H      _PK_H_(0x23, 0x4F)
#define REG_SC_BK23_50_L      _PK_L_(0x23, 0x50)
#define REG_SC_BK23_50_H      _PK_H_(0x23, 0x50)
#define REG_SC_BK23_51_L      _PK_L_(0x23, 0x51)
#define REG_SC_BK23_51_H      _PK_H_(0x23, 0x51)
#define REG_SC_BK23_52_L      _PK_L_(0x23, 0x52)
#define REG_SC_BK23_52_H      _PK_H_(0x23, 0x52)
#define REG_SC_BK23_53_L      _PK_L_(0x23, 0x53)
#define REG_SC_BK23_53_H      _PK_H_(0x23, 0x53)
#define REG_SC_BK23_54_L      _PK_L_(0x23, 0x54)
#define REG_SC_BK23_54_H      _PK_H_(0x23, 0x54)
#define REG_SC_BK23_55_L      _PK_L_(0x23, 0x55)
#define REG_SC_BK23_55_H      _PK_H_(0x23, 0x55)
#define REG_SC_BK23_56_L      _PK_L_(0x23, 0x56)
#define REG_SC_BK23_56_H      _PK_H_(0x23, 0x56)
#define REG_SC_BK23_57_L      _PK_L_(0x23, 0x57)
#define REG_SC_BK23_57_H      _PK_H_(0x23, 0x57)
#define REG_SC_BK23_58_L      _PK_L_(0x23, 0x58)
#define REG_SC_BK23_58_H      _PK_H_(0x23, 0x58)
#define REG_SC_BK23_59_L      _PK_L_(0x23, 0x59)
#define REG_SC_BK23_59_H      _PK_H_(0x23, 0x59)
#define REG_SC_BK23_5A_L      _PK_L_(0x23, 0x5A)
#define REG_SC_BK23_5A_H      _PK_H_(0x23, 0x5A)
#define REG_SC_BK23_5B_L      _PK_L_(0x23, 0x5B)
#define REG_SC_BK23_5B_H      _PK_H_(0x23, 0x5B)
#define REG_SC_BK23_5C_L      _PK_L_(0x23, 0x5C)
#define REG_SC_BK23_5C_H      _PK_H_(0x23, 0x5C)
#define REG_SC_BK23_5D_L      _PK_L_(0x23, 0x5D)
#define REG_SC_BK23_5D_H      _PK_H_(0x23, 0x5D)
#define REG_SC_BK23_5E_L      _PK_L_(0x23, 0x5E)
#define REG_SC_BK23_5E_H      _PK_H_(0x23, 0x5E)
#define REG_SC_BK23_5F_L      _PK_L_(0x23, 0x5F)
#define REG_SC_BK23_5F_H      _PK_H_(0x23, 0x5F)
#define REG_SC_BK23_60_L      _PK_L_(0x23, 0x60)
#define REG_SC_BK23_60_H      _PK_H_(0x23, 0x60)
#define REG_SC_BK23_61_L      _PK_L_(0x23, 0x61)
#define REG_SC_BK23_61_H      _PK_H_(0x23, 0x61)
#define REG_SC_BK23_62_L      _PK_L_(0x23, 0x62)
#define REG_SC_BK23_62_H      _PK_H_(0x23, 0x62)
#define REG_SC_BK23_63_L      _PK_L_(0x23, 0x63)
#define REG_SC_BK23_63_H      _PK_H_(0x23, 0x63)
#define REG_SC_BK23_64_L      _PK_L_(0x23, 0x64)
#define REG_SC_BK23_64_H      _PK_H_(0x23, 0x64)
#define REG_SC_BK23_65_L      _PK_L_(0x23, 0x65)
#define REG_SC_BK23_65_H      _PK_H_(0x23, 0x65)
#define REG_SC_BK23_66_L      _PK_L_(0x23, 0x66)
#define REG_SC_BK23_66_H      _PK_H_(0x23, 0x66)
#define REG_SC_BK23_67_L      _PK_L_(0x23, 0x67)
#define REG_SC_BK23_67_H      _PK_H_(0x23, 0x67)
#define REG_SC_BK23_68_L      _PK_L_(0x23, 0x68)
#define REG_SC_BK23_68_H      _PK_H_(0x23, 0x68)
#define REG_SC_BK23_69_L      _PK_L_(0x23, 0x69)
#define REG_SC_BK23_69_H      _PK_H_(0x23, 0x69)
#define REG_SC_BK23_6A_L      _PK_L_(0x23, 0x6A)
#define REG_SC_BK23_6A_H      _PK_H_(0x23, 0x6A)
#define REG_SC_BK23_6B_L      _PK_L_(0x23, 0x6B)
#define REG_SC_BK23_6B_H      _PK_H_(0x23, 0x6B)
#define REG_SC_BK23_6C_L      _PK_L_(0x23, 0x6C)
#define REG_SC_BK23_6C_H      _PK_H_(0x23, 0x6C)
#define REG_SC_BK23_6D_L      _PK_L_(0x23, 0x6D)
#define REG_SC_BK23_6D_H      _PK_H_(0x23, 0x6D)
#define REG_SC_BK23_6E_L      _PK_L_(0x23, 0x6E)
#define REG_SC_BK23_6E_H      _PK_H_(0x23, 0x6E)
#define REG_SC_BK23_6F_L      _PK_L_(0x23, 0x6F)
#define REG_SC_BK23_6F_H      _PK_H_(0x23, 0x6F)
#define REG_SC_BK23_70_L      _PK_L_(0x23, 0x70)
#define REG_SC_BK23_70_H      _PK_H_(0x23, 0x70)
#define REG_SC_BK23_71_L      _PK_L_(0x23, 0x71)
#define REG_SC_BK23_71_H      _PK_H_(0x23, 0x71)
#define REG_SC_BK23_72_L      _PK_L_(0x23, 0x72)
#define REG_SC_BK23_72_H      _PK_H_(0x23, 0x72)
#define REG_SC_BK23_73_L      _PK_L_(0x23, 0x73)
#define REG_SC_BK23_73_H      _PK_H_(0x23, 0x73)
#define REG_SC_BK23_74_L      _PK_L_(0x23, 0x74)
#define REG_SC_BK23_74_H      _PK_H_(0x23, 0x74)
#define REG_SC_BK23_75_L      _PK_L_(0x23, 0x75)
#define REG_SC_BK23_75_H      _PK_H_(0x23, 0x75)
#define REG_SC_BK23_76_L      _PK_L_(0x23, 0x76)
#define REG_SC_BK23_76_H      _PK_H_(0x23, 0x76)
#define REG_SC_BK23_77_L      _PK_L_(0x23, 0x77)
#define REG_SC_BK23_77_H      _PK_H_(0x23, 0x77)


//----------------------------------------------
//  BK24
//----------------------------------------------
#define REG_SC_BK24_00_L      _PK_L_(0x24, 0x00)
#define REG_SC_BK24_00_H      _PK_H_(0x24, 0x00)
#define REG_SC_BK24_01_L      _PK_L_(0x24, 0x01)
#define REG_SC_BK24_01_H      _PK_H_(0x24, 0x01)
#define REG_SC_BK24_02_L      _PK_L_(0x24, 0x02)
#define REG_SC_BK24_02_H      _PK_H_(0x24, 0x02)
#define REG_SC_BK24_03_L      _PK_L_(0x24, 0x03)
#define REG_SC_BK24_03_H      _PK_H_(0x24, 0x03)
#define REG_SC_BK24_04_L      _PK_L_(0x24, 0x04)
#define REG_SC_BK24_04_H      _PK_H_(0x24, 0x04)
#define REG_SC_BK24_05_L      _PK_L_(0x24, 0x05)
#define REG_SC_BK24_05_H      _PK_H_(0x24, 0x05)
#define REG_SC_BK24_06_L      _PK_L_(0x24, 0x06)
#define REG_SC_BK24_06_H      _PK_H_(0x24, 0x06)
#define REG_SC_BK24_07_L      _PK_L_(0x24, 0x07)
#define REG_SC_BK24_07_H      _PK_H_(0x24, 0x07)
#define REG_SC_BK24_08_L      _PK_L_(0x24, 0x08)
#define REG_SC_BK24_08_H      _PK_H_(0x24, 0x08)
#define REG_SC_BK24_09_L      _PK_L_(0x24, 0x09)
#define REG_SC_BK24_09_H      _PK_H_(0x24, 0x09)
#define REG_SC_BK24_0A_L      _PK_L_(0x24, 0x0A)
#define REG_SC_BK24_0A_H      _PK_H_(0x24, 0x0A)
#define REG_SC_BK24_0B_L      _PK_L_(0x24, 0x0B)
#define REG_SC_BK24_0B_H      _PK_H_(0x24, 0x0B)
#define REG_SC_BK24_0C_L      _PK_L_(0x24, 0x0C)
#define REG_SC_BK24_0C_H      _PK_H_(0x24, 0x0C)
#define REG_SC_BK24_0D_L      _PK_L_(0x24, 0x0d)
#define REG_SC_BK24_0D_H      _PK_H_(0x24, 0x0d)
#define REG_SC_BK24_0E_L      _PK_L_(0x24, 0x0e)
#define REG_SC_BK24_0E_H      _PK_H_(0x24, 0x0e)
#define REG_SC_BK24_0F_L      _PK_L_(0x24, 0x0f)
#define REG_SC_BK24_0F_H      _PK_H_(0x24, 0x0f)
#define REG_SC_BK24_10_L      _PK_L_(0x24, 0x10)
#define REG_SC_BK24_10_H      _PK_H_(0x24, 0x10)
#define REG_SC_BK24_11_L      _PK_L_(0x24, 0x11)
#define REG_SC_BK24_11_H      _PK_H_(0x24, 0x11)
#define REG_SC_BK24_12_L      _PK_L_(0x24, 0x12)
#define REG_SC_BK24_12_H      _PK_H_(0x24, 0x12)
#define REG_SC_BK24_13_L      _PK_L_(0x24, 0x13)
#define REG_SC_BK24_13_H      _PK_H_(0x24, 0x13)
#define REG_SC_BK24_14_L      _PK_L_(0x24, 0x14)
#define REG_SC_BK24_14_H      _PK_H_(0x24, 0x14)
#define REG_SC_BK24_15_L      _PK_L_(0x24, 0x15)
#define REG_SC_BK24_15_H      _PK_H_(0x24, 0x15)
#define REG_SC_BK24_16_L      _PK_L_(0x24, 0x16)
#define REG_SC_BK24_16_H      _PK_H_(0x24, 0x16)
#define REG_SC_BK24_17_L      _PK_L_(0x24, 0x17)
#define REG_SC_BK24_17_H      _PK_H_(0x24, 0x17)
#define REG_SC_BK24_18_L      _PK_L_(0x24, 0x18)
#define REG_SC_BK24_18_H      _PK_H_(0x24, 0x18)
#define REG_SC_BK24_19_L      _PK_L_(0x24, 0x19)
#define REG_SC_BK24_19_H      _PK_H_(0x24, 0x19)
#define REG_SC_BK24_1A_L      _PK_L_(0x24, 0x1A)
#define REG_SC_BK24_1A_H      _PK_H_(0x24, 0x1A)
#define REG_SC_BK24_1B_L      _PK_L_(0x24, 0x1B)
#define REG_SC_BK24_1B_H      _PK_H_(0x24, 0x1B)
#define REG_SC_BK24_1C_L      _PK_L_(0x24, 0x1C)
#define REG_SC_BK24_1C_H      _PK_H_(0x24, 0x1C)
#define REG_SC_BK24_1D_L      _PK_L_(0x24, 0x1d)
#define REG_SC_BK24_1D_H      _PK_H_(0x24, 0x1d)
#define REG_SC_BK24_1E_L      _PK_L_(0x24, 0x1e)
#define REG_SC_BK24_1E_H      _PK_H_(0x24, 0x1e)
#define REG_SC_BK24_1F_L      _PK_L_(0x24, 0x1f)
#define REG_SC_BK24_1F_H      _PK_H_(0x24, 0x1f)
#define REG_SC_BK24_20_L      _PK_L_(0x24, 0x20)
#define REG_SC_BK24_20_H      _PK_H_(0x24, 0x20)
#define REG_SC_BK24_21_L      _PK_L_(0x24, 0x21)
#define REG_SC_BK24_21_H      _PK_H_(0x24, 0x21)
#define REG_SC_BK24_22_L      _PK_L_(0x24, 0x22)
#define REG_SC_BK24_22_H      _PK_H_(0x24, 0x22)
#define REG_SC_BK24_23_L      _PK_L_(0x24, 0x23)
#define REG_SC_BK24_23_H      _PK_H_(0x24, 0x23)
#define REG_SC_BK24_24_L      _PK_L_(0x24, 0x24)
#define REG_SC_BK24_24_H      _PK_H_(0x24, 0x24)
#define REG_SC_BK24_25_L      _PK_L_(0x24, 0x25)
#define REG_SC_BK24_25_H      _PK_H_(0x24, 0x25)
#define REG_SC_BK24_26_L      _PK_L_(0x24, 0x26)
#define REG_SC_BK24_26_H      _PK_H_(0x24, 0x26)
#define REG_SC_BK24_27_L      _PK_L_(0x24, 0x27)
#define REG_SC_BK24_27_H      _PK_H_(0x24, 0x27)
#define REG_SC_BK24_28_L      _PK_L_(0x24, 0x28)
#define REG_SC_BK24_28_H      _PK_H_(0x24, 0x28)
#define REG_SC_BK24_29_L      _PK_L_(0x24, 0x29)
#define REG_SC_BK24_29_H      _PK_H_(0x24, 0x29)
#define REG_SC_BK24_2A_L      _PK_L_(0x24, 0x2A)
#define REG_SC_BK24_2A_H      _PK_H_(0x24, 0x2A)
#define REG_SC_BK24_2B_L      _PK_L_(0x24, 0x2B)
#define REG_SC_BK24_2B_H      _PK_H_(0x24, 0x2B)
#define REG_SC_BK24_2C_L      _PK_L_(0x24, 0x2C)
#define REG_SC_BK24_2C_H      _PK_H_(0x24, 0x2C)
#define REG_SC_BK24_2D_L      _PK_L_(0x24, 0x2D)
#define REG_SC_BK24_2D_H      _PK_H_(0x24, 0x2D)
#define REG_SC_BK24_2E_L      _PK_L_(0x24, 0x2E)
#define REG_SC_BK24_2E_H      _PK_H_(0x24, 0x2E)
#define REG_SC_BK24_2F_L      _PK_L_(0x24, 0x2F)
#define REG_SC_BK24_2F_H      _PK_H_(0x24, 0x2F)
#define REG_SC_BK24_30_L      _PK_L_(0x24, 0x30)
#define REG_SC_BK24_30_H      _PK_H_(0x24, 0x30)
#define REG_SC_BK24_31_L      _PK_L_(0x24, 0x31)
#define REG_SC_BK24_31_H      _PK_H_(0x24, 0x31)
#define REG_SC_BK24_32_L      _PK_L_(0x24, 0x32)
#define REG_SC_BK24_32_H      _PK_H_(0x24, 0x32)
#define REG_SC_BK24_33_L      _PK_L_(0x24, 0x33)
#define REG_SC_BK24_33_H      _PK_H_(0x24, 0x33)
#define REG_SC_BK24_34_L      _PK_L_(0x24, 0x34)
#define REG_SC_BK24_34_H      _PK_H_(0x24, 0x34)
#define REG_SC_BK24_35_L      _PK_L_(0x24, 0x35)
#define REG_SC_BK24_35_H      _PK_H_(0x24, 0x35)
#define REG_SC_BK24_36_L      _PK_L_(0x24, 0x36)
#define REG_SC_BK24_36_H      _PK_H_(0x24, 0x36)
#define REG_SC_BK24_37_L      _PK_L_(0x24, 0x37)
#define REG_SC_BK24_37_H      _PK_H_(0x24, 0x37)
#define REG_SC_BK24_38_L      _PK_L_(0x24, 0x38)
#define REG_SC_BK24_38_H      _PK_H_(0x24, 0x38)
#define REG_SC_BK24_39_L      _PK_L_(0x24, 0x39)
#define REG_SC_BK24_39_H      _PK_H_(0x24, 0x39)
#define REG_SC_BK24_3A_L      _PK_L_(0x24, 0x3A)
#define REG_SC_BK24_3A_H      _PK_H_(0x24, 0x3A)
#define REG_SC_BK24_3B_L      _PK_L_(0x24, 0x3B)
#define REG_SC_BK24_3B_H      _PK_H_(0x24, 0x3B)
#define REG_SC_BK24_3C_L      _PK_L_(0x24, 0x3C)
#define REG_SC_BK24_3C_H      _PK_H_(0x24, 0x3C)
#define REG_SC_BK24_3D_L      _PK_L_(0x24, 0x3D)
#define REG_SC_BK24_3D_H      _PK_H_(0x24, 0x3D)
#define REG_SC_BK24_3E_L      _PK_L_(0x24, 0x3E)
#define REG_SC_BK24_3E_H      _PK_H_(0x24, 0x3E)
#define REG_SC_BK24_3F_L      _PK_L_(0x24, 0x3F)
#define REG_SC_BK24_3F_H      _PK_H_(0x24, 0x3F)
#define REG_SC_BK24_40_L      _PK_L_(0x24, 0x40)
#define REG_SC_BK24_40_H      _PK_H_(0x24, 0x40)
#define REG_SC_BK24_41_L      _PK_L_(0x24, 0x41)
#define REG_SC_BK24_41_H      _PK_H_(0x24, 0x41)
#define REG_SC_BK24_42_L      _PK_L_(0x24, 0x42)
#define REG_SC_BK24_42_H      _PK_H_(0x24, 0x42)
#define REG_SC_BK24_43_L      _PK_L_(0x24, 0x43)
#define REG_SC_BK24_43_H      _PK_H_(0x24, 0x43)
#define REG_SC_BK24_44_L      _PK_L_(0x24, 0x44)
#define REG_SC_BK24_44_H      _PK_H_(0x24, 0x44)
#define REG_SC_BK24_45_L      _PK_L_(0x24, 0x45)
#define REG_SC_BK24_45_H      _PK_H_(0x24, 0x45)
#define REG_SC_BK24_46_L      _PK_L_(0x24, 0x46)
#define REG_SC_BK24_46_H      _PK_H_(0x24, 0x46)
#define REG_SC_BK24_47_L      _PK_L_(0x24, 0x47)
#define REG_SC_BK24_47_H      _PK_H_(0x24, 0x47)
#define REG_SC_BK24_48_L      _PK_L_(0x24, 0x48)
#define REG_SC_BK24_48_H      _PK_H_(0x24, 0x48)
#define REG_SC_BK24_49_L      _PK_L_(0x24, 0x49)
#define REG_SC_BK24_49_H      _PK_H_(0x24, 0x49)
#define REG_SC_BK24_4A_L      _PK_L_(0x24, 0x4A)
#define REG_SC_BK24_4A_H      _PK_H_(0x24, 0x4A)
#define REG_SC_BK24_4B_L      _PK_L_(0x24, 0x4B)
#define REG_SC_BK24_4B_H      _PK_H_(0x24, 0x4B)
#define REG_SC_BK24_4C_L      _PK_L_(0x24, 0x4C)
#define REG_SC_BK24_4C_H      _PK_H_(0x24, 0x4C)
#define REG_SC_BK24_4D_L      _PK_L_(0x24, 0x4D)
#define REG_SC_BK24_4D_H      _PK_H_(0x24, 0x4D)
#define REG_SC_BK24_4E_L      _PK_L_(0x24, 0x4E)
#define REG_SC_BK24_4E_H      _PK_H_(0x24, 0x4E)
#define REG_SC_BK24_4F_L      _PK_L_(0x24, 0x4F)
#define REG_SC_BK24_4F_H      _PK_H_(0x24, 0x4F)
#define REG_SC_BK24_50_L      _PK_L_(0x24, 0x50)
#define REG_SC_BK24_50_H      _PK_H_(0x24, 0x50)
#define REG_SC_BK24_51_L      _PK_L_(0x24, 0x51)
#define REG_SC_BK24_51_H      _PK_H_(0x24, 0x51)
#define REG_SC_BK24_52_L      _PK_L_(0x24, 0x52)
#define REG_SC_BK24_52_H      _PK_H_(0x24, 0x52)
#define REG_SC_BK24_53_L      _PK_L_(0x24, 0x53)
#define REG_SC_BK24_53_H      _PK_H_(0x24, 0x53)
#define REG_SC_BK24_54_L      _PK_L_(0x24, 0x54)
#define REG_SC_BK24_54_H      _PK_H_(0x24, 0x54)
#define REG_SC_BK24_55_L      _PK_L_(0x24, 0x55)
#define REG_SC_BK24_55_H      _PK_H_(0x24, 0x55)
#define REG_SC_BK24_56_L      _PK_L_(0x24, 0x56)
#define REG_SC_BK24_56_H      _PK_H_(0x24, 0x56)
#define REG_SC_BK24_57_L      _PK_L_(0x24, 0x57)
#define REG_SC_BK24_57_H      _PK_H_(0x24, 0x57)
#define REG_SC_BK24_58_L      _PK_L_(0x24, 0x58)
#define REG_SC_BK24_58_H      _PK_H_(0x24, 0x58)
#define REG_SC_BK24_59_L      _PK_L_(0x24, 0x59)
#define REG_SC_BK24_59_H      _PK_H_(0x24, 0x59)
#define REG_SC_BK24_5A_L      _PK_L_(0x24, 0x5A)
#define REG_SC_BK24_5A_H      _PK_H_(0x24, 0x5A)
#define REG_SC_BK24_5B_L      _PK_L_(0x24, 0x5B)
#define REG_SC_BK24_5B_H      _PK_H_(0x24, 0x5B)
#define REG_SC_BK24_5C_L      _PK_L_(0x24, 0x5C)
#define REG_SC_BK24_5C_H      _PK_H_(0x24, 0x5C)
#define REG_SC_BK24_5D_L      _PK_L_(0x24, 0x5D)
#define REG_SC_BK24_5D_H      _PK_H_(0x24, 0x5D)
#define REG_SC_BK24_5E_L      _PK_L_(0x24, 0x5E)
#define REG_SC_BK24_5E_H      _PK_H_(0x24, 0x5E)
#define REG_SC_BK24_5F_L      _PK_L_(0x24, 0x5F)
#define REG_SC_BK24_5F_H      _PK_H_(0x24, 0x5F)
#define REG_SC_BK24_60_L      _PK_L_(0x24, 0x60)
#define REG_SC_BK24_60_H      _PK_H_(0x24, 0x60)
#define REG_SC_BK24_61_L      _PK_L_(0x24, 0x61)
#define REG_SC_BK24_61_H      _PK_H_(0x24, 0x61)
#define REG_SC_BK24_62_L      _PK_L_(0x24, 0x62)
#define REG_SC_BK24_62_H      _PK_H_(0x24, 0x62)
#define REG_SC_BK24_63_L      _PK_L_(0x24, 0x63)
#define REG_SC_BK24_63_H      _PK_H_(0x24, 0x63)
#define REG_SC_BK24_64_L      _PK_L_(0x24, 0x64)
#define REG_SC_BK24_64_H      _PK_H_(0x24, 0x64)
#define REG_SC_BK24_65_L      _PK_L_(0x24, 0x65)
#define REG_SC_BK24_65_H      _PK_H_(0x24, 0x65)
#define REG_SC_BK24_66_L      _PK_L_(0x24, 0x66)
#define REG_SC_BK24_66_H      _PK_H_(0x24, 0x66)
#define REG_SC_BK24_67_L      _PK_L_(0x24, 0x67)
#define REG_SC_BK24_67_H      _PK_H_(0x24, 0x67)
#define REG_SC_BK24_68_L      _PK_L_(0x24, 0x68)
#define REG_SC_BK24_68_H      _PK_H_(0x24, 0x68)
#define REG_SC_BK24_69_L      _PK_L_(0x24, 0x69)
#define REG_SC_BK24_69_H      _PK_H_(0x24, 0x69)
#define REG_SC_BK24_6A_L      _PK_L_(0x24, 0x6A)
#define REG_SC_BK24_6A_H      _PK_H_(0x24, 0x6A)
#define REG_SC_BK24_6B_L      _PK_L_(0x24, 0x6B)
#define REG_SC_BK24_6B_H      _PK_H_(0x24, 0x6B)
#define REG_SC_BK24_6C_L      _PK_L_(0x24, 0x6C)
#define REG_SC_BK24_6C_H      _PK_H_(0x24, 0x6C)
#define REG_SC_BK24_6D_L      _PK_L_(0x24, 0x6D)
#define REG_SC_BK24_6D_H      _PK_H_(0x24, 0x6D)
#define REG_SC_BK24_6E_L      _PK_L_(0x24, 0x6E)
#define REG_SC_BK24_6E_H      _PK_H_(0x24, 0x6E)
#define REG_SC_BK24_6F_L      _PK_L_(0x24, 0x6F)
#define REG_SC_BK24_6F_H      _PK_H_(0x24, 0x6F)
#define REG_SC_BK24_70_L      _PK_L_(0x24, 0x70)
#define REG_SC_BK24_70_H      _PK_H_(0x24, 0x70)
#define REG_SC_BK24_71_L      _PK_L_(0x24, 0x71)
#define REG_SC_BK24_71_H      _PK_H_(0x24, 0x71)
#define REG_SC_BK24_72_L      _PK_L_(0x24, 0x72)
#define REG_SC_BK24_72_H      _PK_H_(0x24, 0x72)
#define REG_SC_BK24_73_L      _PK_L_(0x24, 0x73)
#define REG_SC_BK24_73_H      _PK_H_(0x24, 0x73)
#define REG_SC_BK24_74_L      _PK_L_(0x24, 0x74)
#define REG_SC_BK24_74_H      _PK_H_(0x24, 0x74)
#define REG_SC_BK24_75_L      _PK_L_(0x24, 0x75)
#define REG_SC_BK24_75_H      _PK_H_(0x24, 0x75)
#define REG_SC_BK24_76_L      _PK_L_(0x24, 0x76)
#define REG_SC_BK24_76_H      _PK_H_(0x24, 0x76)
#define REG_SC_BK24_77_L      _PK_L_(0x24, 0x77)
#define REG_SC_BK24_77_H      _PK_H_(0x24, 0x77)
//----------------------------------------------
//  BK25
//----------------------------------------------
#define REG_SC_BK25_01_L      _PK_L_(0x25, 0x01)
#define REG_SC_BK25_01_H      _PK_H_(0x25, 0x01)
#define REG_SC_BK25_02_L      _PK_L_(0x25, 0x02)
#define REG_SC_BK25_02_H      _PK_H_(0x25, 0x02)
#define REG_SC_BK25_03_L      _PK_L_(0x25, 0x03)
#define REG_SC_BK25_03_H      _PK_H_(0x25, 0x03)
#define REG_SC_BK25_04_L      _PK_L_(0x25, 0x04)
#define REG_SC_BK25_04_H      _PK_H_(0x25, 0x04)
#define REG_SC_BK25_05_L      _PK_L_(0x25, 0x05)
#define REG_SC_BK25_05_H      _PK_H_(0x25, 0x05)
#define REG_SC_BK25_06_L      _PK_L_(0x25, 0x06)
#define REG_SC_BK25_06_H      _PK_H_(0x25, 0x06)
#define REG_SC_BK25_07_L      _PK_L_(0x25, 0x07)
#define REG_SC_BK25_07_H      _PK_H_(0x25, 0x07)
#define REG_SC_BK25_08_L      _PK_L_(0x25, 0x08)
#define REG_SC_BK25_08_H      _PK_H_(0x25, 0x08)
#define REG_SC_BK25_09_L      _PK_L_(0x25, 0x09)
#define REG_SC_BK25_09_H      _PK_H_(0x25, 0x09)
#define REG_SC_BK25_0A_L      _PK_L_(0x25, 0x0A)
#define REG_SC_BK25_0A_H      _PK_H_(0x25, 0x0A)
#define REG_SC_BK25_0B_L      _PK_L_(0x25, 0x0B)
#define REG_SC_BK25_0B_H      _PK_H_(0x25, 0x0B)
#define REG_SC_BK25_0C_L      _PK_L_(0x25, 0x0C)
#define REG_SC_BK25_0C_H      _PK_H_(0x25, 0x0C)
#define REG_SC_BK25_0D_L      _PK_L_(0x25, 0x0d)
#define REG_SC_BK25_0D_H      _PK_H_(0x25, 0x0d)
#define REG_SC_BK25_0E_L      _PK_L_(0x25, 0x0e)
#define REG_SC_BK25_0E_H      _PK_H_(0x25, 0x0e)
#define REG_SC_BK25_0F_L      _PK_L_(0x25, 0x0f)
#define REG_SC_BK25_0F_H      _PK_H_(0x25, 0x0f)
#define REG_SC_BK25_10_L      _PK_L_(0x25, 0x10)
#define REG_SC_BK25_10_H      _PK_H_(0x25, 0x10)
#define REG_SC_BK25_11_L      _PK_L_(0x25, 0x11)
#define REG_SC_BK25_11_H      _PK_H_(0x25, 0x11)
#define REG_SC_BK25_12_L      _PK_L_(0x25, 0x12)
#define REG_SC_BK25_12_H      _PK_H_(0x25, 0x12)
#define REG_SC_BK25_13_L      _PK_L_(0x25, 0x13)
#define REG_SC_BK25_13_H      _PK_H_(0x25, 0x13)
#define REG_SC_BK25_14_L      _PK_L_(0x25, 0x14)
#define REG_SC_BK25_14_H      _PK_H_(0x25, 0x14)
#define REG_SC_BK25_15_L      _PK_L_(0x25, 0x15)
#define REG_SC_BK25_15_H      _PK_H_(0x25, 0x15)
#define REG_SC_BK25_16_L      _PK_L_(0x25, 0x16)
#define REG_SC_BK25_16_H      _PK_H_(0x25, 0x16)
#define REG_SC_BK25_17_L      _PK_L_(0x25, 0x17)
#define REG_SC_BK25_17_H      _PK_H_(0x25, 0x17)
#define REG_SC_BK25_18_L      _PK_L_(0x25, 0x18)
#define REG_SC_BK25_18_H      _PK_H_(0x25, 0x18)
#define REG_SC_BK25_19_L      _PK_L_(0x25, 0x19)
#define REG_SC_BK25_19_H      _PK_H_(0x25, 0x19)
#define REG_SC_BK25_1A_L      _PK_L_(0x25, 0x1A)
#define REG_SC_BK25_1A_H      _PK_H_(0x25, 0x1A)
#define REG_SC_BK25_1B_L      _PK_L_(0x25, 0x1B)
#define REG_SC_BK25_1B_H      _PK_H_(0x25, 0x1B)
#define REG_SC_BK25_1C_L      _PK_L_(0x25, 0x1C)
#define REG_SC_BK25_1C_H      _PK_H_(0x25, 0x1C)
#define REG_SC_BK25_1D_L      _PK_L_(0x25, 0x1d)
#define REG_SC_BK25_1D_H      _PK_H_(0x25, 0x1d)
#define REG_SC_BK25_1E_L      _PK_L_(0x25, 0x1e)
#define REG_SC_BK25_1E_H      _PK_H_(0x25, 0x1e)
#define REG_SC_BK25_1F_L      _PK_L_(0x25, 0x1f)
#define REG_SC_BK25_1F_H      _PK_H_(0x25, 0x1f)
#define REG_SC_BK25_20_L      _PK_L_(0x25, 0x20)
#define REG_SC_BK25_20_H      _PK_H_(0x25, 0x20)
#define REG_SC_BK25_21_L      _PK_L_(0x25, 0x21)
#define REG_SC_BK25_21_H      _PK_H_(0x25, 0x21)
#define REG_SC_BK25_22_L      _PK_L_(0x25, 0x22)
#define REG_SC_BK25_22_H      _PK_H_(0x25, 0x22)
#define REG_SC_BK25_23_L      _PK_L_(0x25, 0x23)
#define REG_SC_BK25_23_H      _PK_H_(0x25, 0x23)
#define REG_SC_BK25_24_L      _PK_L_(0x25, 0x24)
#define REG_SC_BK25_24_H      _PK_H_(0x25, 0x24)
#define REG_SC_BK25_25_L      _PK_L_(0x25, 0x25)
#define REG_SC_BK25_25_H      _PK_H_(0x25, 0x25)
#define REG_SC_BK25_26_L      _PK_L_(0x25, 0x26)
#define REG_SC_BK25_26_H      _PK_H_(0x25, 0x26)
#define REG_SC_BK25_27_L      _PK_L_(0x25, 0x27)
#define REG_SC_BK25_27_H      _PK_H_(0x25, 0x27)
#define REG_SC_BK25_28_L      _PK_L_(0x25, 0x28)
#define REG_SC_BK25_28_H      _PK_H_(0x25, 0x28)
#define REG_SC_BK25_29_L      _PK_L_(0x25, 0x29)
#define REG_SC_BK25_29_H      _PK_H_(0x25, 0x29)
#define REG_SC_BK25_2A_L      _PK_L_(0x25, 0x2A)
#define REG_SC_BK25_2A_H      _PK_H_(0x25, 0x2A)
#define REG_SC_BK25_2B_L      _PK_L_(0x25, 0x2B)
#define REG_SC_BK25_2B_H      _PK_H_(0x25, 0x2B)
#define REG_SC_BK25_2C_L      _PK_L_(0x25, 0x2C)
#define REG_SC_BK25_2C_H      _PK_H_(0x25, 0x2C)
#define REG_SC_BK25_2D_L      _PK_L_(0x25, 0x2d)
#define REG_SC_BK25_2D_H      _PK_H_(0x25, 0x2d)
#define REG_SC_BK25_2E_L      _PK_L_(0x25, 0x2E)
#define REG_SC_BK25_2E_H      _PK_H_(0x25, 0x2E)
#define REG_SC_BK25_2F_L      _PK_L_(0x25, 0x2F)
#define REG_SC_BK25_2F_H      _PK_H_(0x25, 0x2F)
#define REG_SC_BK25_30_L      _PK_L_(0x25, 0x30)
#define REG_SC_BK25_30_H      _PK_H_(0x25, 0x30)
#define REG_SC_BK25_31_L      _PK_L_(0x25, 0x31)
#define REG_SC_BK25_31_H      _PK_H_(0x25, 0x31)
#define REG_SC_BK25_32_L      _PK_L_(0x25, 0x32)
#define REG_SC_BK25_32_H      _PK_H_(0x25, 0x32)
#define REG_SC_BK25_33_L      _PK_L_(0x25, 0x33)
#define REG_SC_BK25_33_H      _PK_H_(0x25, 0x33)
#define REG_SC_BK25_34_L      _PK_L_(0x25, 0x34)
#define REG_SC_BK25_34_H      _PK_H_(0x25, 0x34)
//----------------------------------------------
//  BK26
//----------------------------------------------
#define REG_SC_BK26_10_L      _PK_L_(0x26, 0x10)
#define REG_SC_BK26_10_H      _PK_H_(0x26, 0x10)
#define REG_SC_BK26_11_L      _PK_L_(0x26, 0x11)
#define REG_SC_BK26_11_H      _PK_H_(0x26, 0x11)
#define REG_SC_BK26_12_L      _PK_L_(0x26, 0x12)
#define REG_SC_BK26_12_H      _PK_H_(0x26, 0x12)
#define REG_SC_BK26_13_L      _PK_L_(0x26, 0x13)
#define REG_SC_BK26_13_H      _PK_H_(0x26, 0x13)
#define REG_SC_BK26_14_L      _PK_L_(0x26, 0x14)
#define REG_SC_BK26_14_H      _PK_H_(0x26, 0x14)
#define REG_SC_BK26_15_L      _PK_L_(0x26, 0x15)
#define REG_SC_BK26_15_H      _PK_H_(0x26, 0x15)
#define REG_SC_BK26_16_L      _PK_L_(0x26, 0x16)
#define REG_SC_BK26_16_H      _PK_H_(0x26, 0x16)
#define REG_SC_BK26_17_L      _PK_L_(0x26, 0x17)
#define REG_SC_BK26_17_H      _PK_H_(0x26, 0x17)
#define REG_SC_BK26_18_L      _PK_L_(0x26, 0x18)
#define REG_SC_BK26_18_H      _PK_H_(0x26, 0x18)
#define REG_SC_BK26_19_L      _PK_L_(0x26, 0x19)
#define REG_SC_BK26_19_H      _PK_H_(0x26, 0x19)
#define REG_SC_BK26_1A_L      _PK_L_(0x26, 0x1a)
#define REG_SC_BK26_1A_H      _PK_H_(0x26, 0x1a)
#define REG_SC_BK26_1B_L      _PK_L_(0x26, 0x1b)
#define REG_SC_BK26_1B_H      _PK_H_(0x26, 0x1b)
#define REG_SC_BK26_1C_L      _PK_L_(0x26, 0x1c)
#define REG_SC_BK26_1C_H      _PK_H_(0x26, 0x1c)
#define REG_SC_BK26_1D_L      _PK_L_(0x26, 0x1d)
#define REG_SC_BK26_1D_H      _PK_H_(0x26, 0x1d)
#define REG_SC_BK26_1E_L      _PK_L_(0x26, 0x1e)
#define REG_SC_BK26_1E_H      _PK_H_(0x26, 0x1e)
#define REG_SC_BK26_1F_L      _PK_L_(0x26, 0x1f)
#define REG_SC_BK26_1F_H      _PK_H_(0x26, 0x1f)

#define REG_SC_BK26_31_L      _PK_L_(0x26, 0x31)
#define REG_SC_BK26_31_H      _PK_H_(0x26, 0x31)

#define REG_SC_BK26_50_L      _PK_L_(0x26, 0x50)
#define REG_SC_BK26_50_H      _PK_H_(0x26, 0x50)
#define REG_SC_BK26_51_L      _PK_L_(0x26, 0x51)
#define REG_SC_BK26_51_H      _PK_H_(0x26, 0x51)
#define REG_SC_BK26_52_L      _PK_L_(0x26, 0x52)
#define REG_SC_BK26_52_H      _PK_H_(0x26, 0x52)
#define REG_SC_BK26_53_L      _PK_L_(0x26, 0x53)
#define REG_SC_BK26_53_H      _PK_H_(0x26, 0x53)
#define REG_SC_BK26_54_L      _PK_L_(0x26, 0x54)
#define REG_SC_BK26_54_H      _PK_H_(0x26, 0x54)
#define REG_SC_BK26_55_L      _PK_L_(0x26, 0x55)
#define REG_SC_BK26_55_H      _PK_H_(0x26, 0x55)
#define REG_SC_BK26_56_L      _PK_L_(0x26, 0x56)
#define REG_SC_BK26_56_H      _PK_H_(0x26, 0x56)
#define REG_SC_BK26_57_L      _PK_L_(0x26, 0x57)
#define REG_SC_BK26_57_H      _PK_H_(0x26, 0x57)
#define REG_SC_BK26_58_L      _PK_L_(0x26, 0x58)
#define REG_SC_BK26_58_H      _PK_H_(0x26, 0x58)
#define REG_SC_BK26_59_L      _PK_L_(0x26, 0x59)
#define REG_SC_BK26_59_H      _PK_H_(0x26, 0x59)
#define REG_SC_BK26_5A_L      _PK_L_(0x26, 0x5a)
#define REG_SC_BK26_5A_H      _PK_H_(0x26, 0x5a)
#define REG_SC_BK26_5B_L      _PK_L_(0x26, 0x5b)
#define REG_SC_BK26_5B_H      _PK_H_(0x26, 0x5b)
#define REG_SC_BK26_5C_L      _PK_L_(0x26, 0x5c)
#define REG_SC_BK26_5C_H      _PK_H_(0x26, 0x5c)
#define REG_SC_BK26_5D_L      _PK_L_(0x26, 0x5d)
#define REG_SC_BK26_5D_H      _PK_H_(0x26, 0x5d)
#define REG_SC_BK26_5E_L      _PK_L_(0x26, 0x5e)
#define REG_SC_BK26_5E_H      _PK_H_(0x26, 0x5e)
#define REG_SC_BK26_5F_L      _PK_L_(0x26, 0x5f)
#define REG_SC_BK26_5F_H      _PK_H_(0x26, 0x5f)
//--------------------------------------------------------
#define REG_SC_BK27_20_L      _PK_L_(0x27, 0x20)
#define REG_SC_BK27_20_H      _PK_H_(0x27, 0x20)
#define REG_SC_BK27_21_L      _PK_L_(0x27, 0x21)
#define REG_SC_BK27_21_H      _PK_H_(0x27, 0x21)
#define REG_SC_BK27_22_L      _PK_L_(0x27, 0x22)
#define REG_SC_BK27_22_H      _PK_H_(0x27, 0x22)
#define REG_SC_BK27_23_L      _PK_L_(0x27, 0x23)
#define REG_SC_BK27_23_H      _PK_H_(0x27, 0x23)
#define REG_SC_BK27_24_L      _PK_L_(0x27, 0x24)
#define REG_SC_BK27_24_H      _PK_H_(0x27, 0x24)
#define REG_SC_BK27_25_L      _PK_L_(0x27, 0x25)
#define REG_SC_BK27_25_H      _PK_H_(0x27, 0x25)
#define REG_SC_BK27_26_L      _PK_L_(0x27, 0x26)
#define REG_SC_BK27_26_H      _PK_H_(0x27, 0x26)
#define REG_SC_BK27_27_L      _PK_L_(0x27, 0x27)
#define REG_SC_BK27_27_H      _PK_H_(0x27, 0x27)
#define REG_SC_BK27_28_L      _PK_L_(0x27, 0x28)
#define REG_SC_BK27_28_H      _PK_H_(0x27, 0x28)
#define REG_SC_BK27_29_L      _PK_L_(0x27, 0x29)
#define REG_SC_BK27_29_H      _PK_H_(0x27, 0x29)
#define REG_SC_BK27_2A_L      _PK_L_(0x27, 0x2a)
#define REG_SC_BK27_2A_H      _PK_H_(0x27, 0x2a)
#define REG_SC_BK27_2B_L      _PK_L_(0x27, 0x2b)
#define REG_SC_BK27_2B_H      _PK_H_(0x27, 0x2b)
#define REG_SC_BK27_2C_L      _PK_L_(0x27, 0x2c)
#define REG_SC_BK27_2C_H      _PK_H_(0x27, 0x2c)
#define REG_SC_BK27_2D_L      _PK_L_(0x27, 0x2d)
#define REG_SC_BK27_2D_H      _PK_H_(0x27, 0x2d)
#define REG_SC_BK27_2E_L      _PK_L_(0x27, 0x2e)
#define REG_SC_BK27_2E_H      _PK_H_(0x27, 0x2e)
#define REG_SC_BK27_2F_L      _PK_L_(0x27, 0x2f)
#define REG_SC_BK27_2F_H      _PK_H_(0x27, 0x2f)

#define REG_SC_BK27_30_L      _PK_L_(0x27, 0x30)
#define REG_SC_BK27_30_H      _PK_H_(0x27, 0x30)
#define REG_SC_BK27_31_L      _PK_L_(0x27, 0x31)
#define REG_SC_BK27_31_H      _PK_H_(0x27, 0x31)
#define REG_SC_BK27_32_L      _PK_L_(0x27, 0x32)
#define REG_SC_BK27_32_H      _PK_H_(0x27, 0x32)
#define REG_SC_BK27_33_L      _PK_L_(0x27, 0x33)
#define REG_SC_BK27_33_H      _PK_H_(0x27, 0x33)
#define REG_SC_BK27_34_L      _PK_L_(0x27, 0x34)
#define REG_SC_BK27_34_H      _PK_H_(0x27, 0x34)
#define REG_SC_BK27_35_L      _PK_L_(0x27, 0x35)
#define REG_SC_BK27_35_H      _PK_H_(0x27, 0x35)
#define REG_SC_BK27_36_L      _PK_L_(0x27, 0x36)
#define REG_SC_BK27_36_H      _PK_H_(0x27, 0x36)
#define REG_SC_BK27_37_L      _PK_L_(0x27, 0x37)
#define REG_SC_BK27_37_H      _PK_H_(0x27, 0x37)
#define REG_SC_BK27_38_L      _PK_L_(0x27, 0x38)
#define REG_SC_BK27_38_H      _PK_H_(0x27, 0x38)
#define REG_SC_BK27_39_L      _PK_L_(0x27, 0x39)
#define REG_SC_BK27_39_H      _PK_H_(0x27, 0x39)
#define REG_SC_BK27_3A_L      _PK_L_(0x27, 0x3a)
#define REG_SC_BK27_3A_H      _PK_H_(0x27, 0x3a)
#define REG_SC_BK27_3B_L      _PK_L_(0x27, 0x3b)
#define REG_SC_BK27_3B_H      _PK_H_(0x27, 0x3b)
#define REG_SC_BK27_3C_L      _PK_L_(0x27, 0x3c)
#define REG_SC_BK27_3C_H      _PK_H_(0x27, 0x3c)
#define REG_SC_BK27_3D_L      _PK_L_(0x27, 0x3d)
#define REG_SC_BK27_3D_H      _PK_H_(0x27, 0x3d)
#define REG_SC_BK27_3E_L      _PK_L_(0x27, 0x3e)
#define REG_SC_BK27_3E_H      _PK_H_(0x27, 0x3e)
#define REG_SC_BK27_3F_L      _PK_L_(0x27, 0x3f)
#define REG_SC_BK27_3F_H      _PK_H_(0x27, 0x3f)


#define REG_SC_BK27_60_L      _PK_L_(0x27, 0x60)
#define REG_SC_BK27_60_H      _PK_H_(0x27, 0x60)
#define REG_SC_BK27_61_L      _PK_L_(0x27, 0x61)
#define REG_SC_BK27_61_H      _PK_H_(0x27, 0x61)
#define REG_SC_BK27_62_L      _PK_L_(0x27, 0x62)
#define REG_SC_BK27_62_H      _PK_H_(0x27, 0x62)
#define REG_SC_BK27_63_L      _PK_L_(0x27, 0x63)
#define REG_SC_BK27_63_H      _PK_H_(0x27, 0x63)
#define REG_SC_BK27_64_L      _PK_L_(0x27, 0x64)
#define REG_SC_BK27_64_H      _PK_H_(0x27, 0x64)
#define REG_SC_BK27_65_L      _PK_L_(0x27, 0x65)
#define REG_SC_BK27_65_H      _PK_H_(0x27, 0x65)
#define REG_SC_BK27_66_L      _PK_L_(0x27, 0x66)
#define REG_SC_BK27_66_H      _PK_H_(0x27, 0x66)
#define REG_SC_BK27_67_L      _PK_L_(0x27, 0x67)
#define REG_SC_BK27_67_H      _PK_H_(0x27, 0x67)
#define REG_SC_BK27_68_L      _PK_L_(0x27, 0x68)
#define REG_SC_BK27_68_H      _PK_H_(0x27, 0x68)
#define REG_SC_BK27_69_L      _PK_L_(0x27, 0x69)
#define REG_SC_BK27_69_H      _PK_H_(0x27, 0x69)
#define REG_SC_BK27_6A_L      _PK_L_(0x27, 0x6a)
#define REG_SC_BK27_6A_H      _PK_H_(0x27, 0x6a)
#define REG_SC_BK27_6B_L      _PK_L_(0x27, 0x6b)
#define REG_SC_BK27_6B_H      _PK_H_(0x27, 0x6b)
#define REG_SC_BK27_6C_L      _PK_L_(0x27, 0x6c)
#define REG_SC_BK27_6C_H      _PK_H_(0x27, 0x6c)
#define REG_SC_BK27_6D_L      _PK_L_(0x27, 0x6d)
#define REG_SC_BK27_6D_H      _PK_H_(0x27, 0x6d)
#define REG_SC_BK27_6E_L      _PK_L_(0x27, 0x6e)
#define REG_SC_BK27_6E_H      _PK_H_(0x27, 0x6e)

#define REG_SC_BK27_70_L      _PK_L_(0x27, 0x70)
#define REG_SC_BK27_70_H      _PK_H_(0x27, 0x70)
#define REG_SC_BK27_71_L      _PK_L_(0x27, 0x71)
#define REG_SC_BK27_71_H      _PK_H_(0x27, 0x71)
#define REG_SC_BK27_72_L      _PK_L_(0x27, 0x72)
#define REG_SC_BK27_72_H      _PK_H_(0x27, 0x72)
#define REG_SC_BK27_73_L      _PK_L_(0x27, 0x73)
#define REG_SC_BK27_73_H      _PK_H_(0x27, 0x73)
#define REG_SC_BK27_74_L      _PK_L_(0x27, 0x74)
#define REG_SC_BK27_74_H      _PK_H_(0x27, 0x74)
#define REG_SC_BK27_75_L      _PK_L_(0x27, 0x75)
#define REG_SC_BK27_75_H      _PK_H_(0x27, 0x75)
#define REG_SC_BK27_76_L      _PK_L_(0x27, 0x76)
#define REG_SC_BK27_76_H      _PK_H_(0x27, 0x76)
#define REG_SC_BK27_77_L      _PK_L_(0x27, 0x77)
#define REG_SC_BK27_77_H      _PK_H_(0x27, 0x77)
#define REG_SC_BK27_78_L      _PK_L_(0x27, 0x78)
#define REG_SC_BK27_78_H      _PK_H_(0x27, 0x78)
#define REG_SC_BK27_79_L      _PK_L_(0x27, 0x79)
#define REG_SC_BK27_79_H      _PK_H_(0x27, 0x79)
#define REG_SC_BK27_7A_L      _PK_L_(0x27, 0x7a)
#define REG_SC_BK27_7A_H      _PK_H_(0x27, 0x7a)
#define REG_SC_BK27_7B_L      _PK_L_(0x27, 0x7b)
#define REG_SC_BK27_7B_H      _PK_H_(0x27, 0x7b)
#define REG_SC_BK27_7C_L      _PK_L_(0x27, 0x7c)
#define REG_SC_BK27_7C_H      _PK_H_(0x27, 0x7c)
#define REG_SC_BK27_7D_L      _PK_L_(0x27, 0x7d)
#define REG_SC_BK27_7D_H      _PK_H_(0x27, 0x7d)
#define REG_SC_BK27_7E_L      _PK_L_(0x27, 0x7e)
#define REG_SC_BK27_7E_H      _PK_H_(0x27, 0x7e)

//----------------------------------------------
//  BK2A
//----------------------------------------------
#define REG_SC_BK2A_00_L      _PK_L_(0x2A, 0x00)
#define REG_SC_BK2A_00_H      _PK_H_(0x2A, 0x00)
#define REG_SC_BK2A_01_L      _PK_L_(0x2A, 0x01)
#define REG_SC_BK2A_01_H      _PK_H_(0x2A, 0x01)
#define REG_SC_BK2A_02_L      _PK_L_(0x2A, 0x02)
#define REG_SC_BK2A_02_H      _PK_H_(0x2A, 0x02)
#define REG_SC_BK2A_03_L      _PK_L_(0x2A, 0x03)
#define REG_SC_BK2A_03_H      _PK_H_(0x2A, 0x03)
#define REG_SC_BK2A_04_L      _PK_L_(0x2A, 0x04)
#define REG_SC_BK2A_04_H      _PK_H_(0x2A, 0x04)
#define REG_SC_BK2A_05_L      _PK_L_(0x2A, 0x05)
#define REG_SC_BK2A_05_H      _PK_H_(0x2A, 0x05)
#define REG_SC_BK2A_06_L      _PK_L_(0x2A, 0x06)
#define REG_SC_BK2A_06_H      _PK_H_(0x2A, 0x06)
#define REG_SC_BK2A_07_L      _PK_L_(0x2A, 0x07)
#define REG_SC_BK2A_07_H      _PK_H_(0x2A, 0x07)
#define REG_SC_BK2A_08_L      _PK_L_(0x2A, 0x08)
#define REG_SC_BK2A_08_H      _PK_H_(0x2A, 0x08)
#define REG_SC_BK2A_09_L      _PK_L_(0x2A, 0x09)
#define REG_SC_BK2A_09_H      _PK_H_(0x2A, 0x09)
#define REG_SC_BK2A_0A_L      _PK_L_(0x2A, 0x0A)
#define REG_SC_BK2A_0A_H      _PK_H_(0x2A, 0x0A)
#define REG_SC_BK2A_0B_L      _PK_L_(0x2A, 0x0B)
#define REG_SC_BK2A_0B_H      _PK_H_(0x2A, 0x0B)
#define REG_SC_BK2A_0C_L      _PK_L_(0x2A, 0x0C)
#define REG_SC_BK2A_0C_H      _PK_H_(0x2A, 0x0C)
#define REG_SC_BK2A_0D_L      _PK_L_(0x2A, 0x0D)
#define REG_SC_BK2A_0D_H      _PK_H_(0x2A, 0x0D)
#define REG_SC_BK2A_0E_L      _PK_L_(0x2A, 0x0E)
#define REG_SC_BK2A_0E_H      _PK_H_(0x2A, 0x0E)
#define REG_SC_BK2A_0F_L      _PK_L_(0x2A, 0x0F)
#define REG_SC_BK2A_0F_H      _PK_H_(0x2A, 0x0F)
#define REG_SC_BK2A_10_L      _PK_L_(0x2A, 0x10)
#define REG_SC_BK2A_10_H      _PK_H_(0x2A, 0x10)
#define REG_SC_BK2A_11_L      _PK_L_(0x2A, 0x11)
#define REG_SC_BK2A_11_H      _PK_H_(0x2A, 0x11)
#define REG_SC_BK2A_12_L      _PK_L_(0x2A, 0x12)
#define REG_SC_BK2A_12_H      _PK_H_(0x2A, 0x12)
#define REG_SC_BK2A_13_L      _PK_L_(0x2A, 0x13)
#define REG_SC_BK2A_13_H      _PK_H_(0x2A, 0x13)
#define REG_SC_BK2A_14_L      _PK_L_(0x2A, 0x14)
#define REG_SC_BK2A_14_H      _PK_H_(0x2A, 0x14)
#define REG_SC_BK2A_15_L      _PK_L_(0x2A, 0x15)
#define REG_SC_BK2A_15_H      _PK_H_(0x2A, 0x15)
#define REG_SC_BK2A_16_L      _PK_L_(0x2A, 0x16)
#define REG_SC_BK2A_16_H      _PK_H_(0x2A, 0x16)
#define REG_SC_BK2A_17_L      _PK_L_(0x2A, 0x17)
#define REG_SC_BK2A_17_H      _PK_H_(0x2A, 0x17)
#define REG_SC_BK2A_18_L      _PK_L_(0x2A, 0x18)
#define REG_SC_BK2A_18_H      _PK_H_(0x2A, 0x18)
#define REG_SC_BK2A_19_L      _PK_L_(0x2A, 0x19)
#define REG_SC_BK2A_19_H      _PK_H_(0x2A, 0x19)
#define REG_SC_BK2A_1A_L      _PK_L_(0x2A, 0x1A)
#define REG_SC_BK2A_1A_H      _PK_H_(0x2A, 0x1A)
#define REG_SC_BK2A_1B_L      _PK_L_(0x2A, 0x1B)
#define REG_SC_BK2A_1B_H      _PK_H_(0x2A, 0x1B)
#define REG_SC_BK2A_1C_L      _PK_L_(0x2A, 0x1C)
#define REG_SC_BK2A_1C_H      _PK_H_(0x2A, 0x1C)
#define REG_SC_BK2A_1D_L      _PK_L_(0x2A, 0x1D)
#define REG_SC_BK2A_1D_H      _PK_H_(0x2A, 0x1D)
#define REG_SC_BK2A_1E_L      _PK_L_(0x2A, 0x1E)
#define REG_SC_BK2A_1E_H      _PK_H_(0x2A, 0x1E)
#define REG_SC_BK2A_1F_L      _PK_L_(0x2A, 0x1F)
#define REG_SC_BK2A_1F_H      _PK_H_(0x2A, 0x1F)
#define REG_SC_BK2A_20_L      _PK_L_(0x2A, 0x20)
#define REG_SC_BK2A_20_H      _PK_H_(0x2A, 0x20)
#define REG_SC_BK2A_21_L      _PK_L_(0x2A, 0x21)
#define REG_SC_BK2A_21_H      _PK_H_(0x2A, 0x21)
#define REG_SC_BK2A_22_L      _PK_L_(0x2A, 0x22)
#define REG_SC_BK2A_22_H      _PK_H_(0x2A, 0x22)
#define REG_SC_BK2A_23_L      _PK_L_(0x2A, 0x23)
#define REG_SC_BK2A_23_H      _PK_H_(0x2A, 0x23)
#define REG_SC_BK2A_24_L      _PK_L_(0x2A, 0x24)
#define REG_SC_BK2A_24_H      _PK_H_(0x2A, 0x24)
#define REG_SC_BK2A_25_L      _PK_L_(0x2A, 0x25)
#define REG_SC_BK2A_25_H      _PK_H_(0x2A, 0x25)
#define REG_SC_BK2A_26_L      _PK_L_(0x2A, 0x26)
#define REG_SC_BK2A_26_H      _PK_H_(0x2A, 0x26)
#define REG_SC_BK2A_27_L      _PK_L_(0x2A, 0x27)
#define REG_SC_BK2A_27_H      _PK_H_(0x2A, 0x27)
#define REG_SC_BK2A_28_L      _PK_L_(0x2A, 0x28)
#define REG_SC_BK2A_28_H      _PK_H_(0x2A, 0x28)
#define REG_SC_BK2A_29_L      _PK_L_(0x2A, 0x29)
#define REG_SC_BK2A_29_H      _PK_H_(0x2A, 0x29)
#define REG_SC_BK2A_2A_L      _PK_L_(0x2A, 0x2A)
#define REG_SC_BK2A_2A_H      _PK_H_(0x2A, 0x2A)
#define REG_SC_BK2A_2B_L      _PK_L_(0x2A, 0x2B)
#define REG_SC_BK2A_2B_H      _PK_H_(0x2A, 0x2B)
#define REG_SC_BK2A_2C_L      _PK_L_(0x2A, 0x2C)
#define REG_SC_BK2A_2C_H      _PK_H_(0x2A, 0x2C)
#define REG_SC_BK2A_2D_L      _PK_L_(0x2A, 0x2D)
#define REG_SC_BK2A_2D_H      _PK_H_(0x2A, 0x2D)
#define REG_SC_BK2A_2E_L      _PK_L_(0x2A, 0x2E)
#define REG_SC_BK2A_2E_H      _PK_H_(0x2A, 0x2E)
#define REG_SC_BK2A_2F_L      _PK_L_(0x2A, 0x2F)
#define REG_SC_BK2A_2F_H      _PK_H_(0x2A, 0x2F)
#define REG_SC_BK2A_30_L      _PK_L_(0x2A, 0x30)
#define REG_SC_BK2A_30_H      _PK_H_(0x2A, 0x30)
#define REG_SC_BK2A_31_L      _PK_L_(0x2A, 0x31)
#define REG_SC_BK2A_31_H      _PK_H_(0x2A, 0x31)
#define REG_SC_BK2A_32_L      _PK_L_(0x2A, 0x32)
#define REG_SC_BK2A_32_H      _PK_H_(0x2A, 0x32)
#define REG_SC_BK2A_33_L      _PK_L_(0x2A, 0x33)
#define REG_SC_BK2A_33_H      _PK_H_(0x2A, 0x33)
#define REG_SC_BK2A_34_L      _PK_L_(0x2A, 0x34)
#define REG_SC_BK2A_34_H      _PK_H_(0x2A, 0x34)
#define REG_SC_BK2A_35_L      _PK_L_(0x2A, 0x35)
#define REG_SC_BK2A_35_H      _PK_H_(0x2A, 0x35)
#define REG_SC_BK2A_36_L      _PK_L_(0x2A, 0x36)
#define REG_SC_BK2A_36_H      _PK_H_(0x2A, 0x36)
#define REG_SC_BK2A_37_L      _PK_L_(0x2A, 0x37)
#define REG_SC_BK2A_37_H      _PK_H_(0x2A, 0x37)
#define REG_SC_BK2A_38_L      _PK_L_(0x2A, 0x38)
#define REG_SC_BK2A_38_H      _PK_H_(0x2A, 0x38)
#define REG_SC_BK2A_39_L      _PK_L_(0x2A, 0x39)
#define REG_SC_BK2A_39_H      _PK_H_(0x2A, 0x39)
#define REG_SC_BK2A_3A_L      _PK_L_(0x2A, 0x3A)
#define REG_SC_BK2A_3A_H      _PK_H_(0x2A, 0x3A)
#define REG_SC_BK2A_3B_L      _PK_L_(0x2A, 0x3B)
#define REG_SC_BK2A_3B_H      _PK_H_(0x2A, 0x3B)
#define REG_SC_BK2A_3C_L      _PK_L_(0x2A, 0x3C)
#define REG_SC_BK2A_3C_H      _PK_H_(0x2A, 0x3C)
#define REG_SC_BK2A_3D_L      _PK_L_(0x2A, 0x3D)
#define REG_SC_BK2A_3D_H      _PK_H_(0x2A, 0x3D)
#define REG_SC_BK2A_3E_L      _PK_L_(0x2A, 0x3E)
#define REG_SC_BK2A_3E_H      _PK_H_(0x2A, 0x3E)
#define REG_SC_BK2A_3F_L      _PK_L_(0x2A, 0x3F)
#define REG_SC_BK2A_3F_H      _PK_H_(0x2A, 0x3F)
#define REG_SC_BK2A_40_L      _PK_L_(0x2A, 0x40)
#define REG_SC_BK2A_40_H      _PK_H_(0x2A, 0x40)
#define REG_SC_BK2A_41_L      _PK_L_(0x2A, 0x41)
#define REG_SC_BK2A_41_H      _PK_H_(0x2A, 0x41)
#define REG_SC_BK2A_42_L      _PK_L_(0x2A, 0x42)
#define REG_SC_BK2A_42_H      _PK_H_(0x2A, 0x42)
#define REG_SC_BK2A_43_L      _PK_L_(0x2A, 0x43)
#define REG_SC_BK2A_43_H      _PK_H_(0x2A, 0x43)
#define REG_SC_BK2A_44_L      _PK_L_(0x2A, 0x44)
#define REG_SC_BK2A_44_H      _PK_H_(0x2A, 0x44)
#define REG_SC_BK2A_45_L      _PK_L_(0x2A, 0x45)
#define REG_SC_BK2A_45_H      _PK_H_(0x2A, 0x45)
#define REG_SC_BK2A_46_L      _PK_L_(0x2A, 0x46)
#define REG_SC_BK2A_46_H      _PK_H_(0x2A, 0x46)
#define REG_SC_BK2A_47_L      _PK_L_(0x2A, 0x47)
#define REG_SC_BK2A_47_H      _PK_H_(0x2A, 0x47)
#define REG_SC_BK2A_48_L      _PK_L_(0x2A, 0x48)
#define REG_SC_BK2A_48_H      _PK_H_(0x2A, 0x48)
#define REG_SC_BK2A_49_L      _PK_L_(0x2A, 0x49)
#define REG_SC_BK2A_49_H      _PK_H_(0x2A, 0x49)
#define REG_SC_BK2A_4A_L      _PK_L_(0x2A, 0x4A)
#define REG_SC_BK2A_4A_H      _PK_H_(0x2A, 0x4A)
#define REG_SC_BK2A_4B_L      _PK_L_(0x2A, 0x4B)
#define REG_SC_BK2A_4B_H      _PK_H_(0x2A, 0x4B)
#define REG_SC_BK2A_4C_L      _PK_L_(0x2A, 0x4C)
#define REG_SC_BK2A_4C_H      _PK_H_(0x2A, 0x4C)
#define REG_SC_BK2A_4D_L      _PK_L_(0x2A, 0x4D)
#define REG_SC_BK2A_4D_H      _PK_H_(0x2A, 0x4D)
#define REG_SC_BK2A_4E_L      _PK_L_(0x2A, 0x4E)
#define REG_SC_BK2A_4E_H      _PK_H_(0x2A, 0x4E)
#define REG_SC_BK2A_4F_L      _PK_L_(0x2A, 0x4F)
#define REG_SC_BK2A_4F_H      _PK_H_(0x2A, 0x4F)
#define REG_SC_BK2A_50_L      _PK_L_(0x2A, 0x50)
#define REG_SC_BK2A_50_H      _PK_H_(0x2A, 0x50)
#define REG_SC_BK2A_51_L      _PK_L_(0x2A, 0x51)
#define REG_SC_BK2A_51_H      _PK_H_(0x2A, 0x51)
#define REG_SC_BK2A_52_L      _PK_L_(0x2A, 0x52)
#define REG_SC_BK2A_52_H      _PK_H_(0x2A, 0x52)
#define REG_SC_BK2A_53_L      _PK_L_(0x2A, 0x53)
#define REG_SC_BK2A_53_H      _PK_H_(0x2A, 0x53)
#define REG_SC_BK2A_54_L      _PK_L_(0x2A, 0x54)
#define REG_SC_BK2A_54_H      _PK_H_(0x2A, 0x54)
#define REG_SC_BK2A_55_L      _PK_L_(0x2A, 0x55)
#define REG_SC_BK2A_55_H      _PK_H_(0x2A, 0x55)
#define REG_SC_BK2A_56_L      _PK_L_(0x2A, 0x56)
#define REG_SC_BK2A_56_H      _PK_H_(0x2A, 0x56)
#define REG_SC_BK2A_57_L      _PK_L_(0x2A, 0x57)
#define REG_SC_BK2A_57_H      _PK_H_(0x2A, 0x57)
#define REG_SC_BK2A_58_L      _PK_L_(0x2A, 0x58)
#define REG_SC_BK2A_58_H      _PK_H_(0x2A, 0x58)
#define REG_SC_BK2A_59_L      _PK_L_(0x2A, 0x59)
#define REG_SC_BK2A_59_H      _PK_H_(0x2A, 0x59)
#define REG_SC_BK2A_5A_L      _PK_L_(0x2A, 0x5A)
#define REG_SC_BK2A_5A_H      _PK_H_(0x2A, 0x5A)
#define REG_SC_BK2A_5B_L      _PK_L_(0x2A, 0x5B)
#define REG_SC_BK2A_5B_H      _PK_H_(0x2A, 0x5B)
#define REG_SC_BK2A_5C_L      _PK_L_(0x2A, 0x5C)
#define REG_SC_BK2A_5C_H      _PK_H_(0x2A, 0x5C)
#define REG_SC_BK2A_5D_L      _PK_L_(0x2A, 0x5D)
#define REG_SC_BK2A_5D_H      _PK_H_(0x2A, 0x5D)
#define REG_SC_BK2A_5E_L      _PK_L_(0x2A, 0x5E)
#define REG_SC_BK2A_5E_H      _PK_H_(0x2A, 0x5E)
#define REG_SC_BK2A_5F_L      _PK_L_(0x2A, 0x5F)
#define REG_SC_BK2A_5F_H      _PK_H_(0x2A, 0x5F)
#define REG_SC_BK2A_60_L      _PK_L_(0x2A, 0x60)
#define REG_SC_BK2A_60_H      _PK_H_(0x2A, 0x60)
#define REG_SC_BK2A_61_L      _PK_L_(0x2A, 0x61)
#define REG_SC_BK2A_61_H      _PK_H_(0x2A, 0x61)
#define REG_SC_BK2A_62_L      _PK_L_(0x2A, 0x62)
#define REG_SC_BK2A_62_H      _PK_H_(0x2A, 0x62)
#define REG_SC_BK2A_63_L      _PK_L_(0x2A, 0x63)
#define REG_SC_BK2A_63_H      _PK_H_(0x2A, 0x63)
#define REG_SC_BK2A_64_L      _PK_L_(0x2A, 0x64)
#define REG_SC_BK2A_64_H      _PK_H_(0x2A, 0x64)
#define REG_SC_BK2A_65_L      _PK_L_(0x2A, 0x65)
#define REG_SC_BK2A_65_H      _PK_H_(0x2A, 0x65)
#define REG_SC_BK2A_66_L      _PK_L_(0x2A, 0x66)
#define REG_SC_BK2A_66_H      _PK_H_(0x2A, 0x66)
#define REG_SC_BK2A_67_L      _PK_L_(0x2A, 0x67)
#define REG_SC_BK2A_67_H      _PK_H_(0x2A, 0x67)
#define REG_SC_BK2A_68_L      _PK_L_(0x2A, 0x68)
#define REG_SC_BK2A_68_H      _PK_H_(0x2A, 0x68)
#define REG_SC_BK2A_69_L      _PK_L_(0x2A, 0x69)
#define REG_SC_BK2A_69_H      _PK_H_(0x2A, 0x69)
#define REG_SC_BK2A_6A_L      _PK_L_(0x2A, 0x6A)
#define REG_SC_BK2A_6A_H      _PK_H_(0x2A, 0x6A)
#define REG_SC_BK2A_6B_L      _PK_L_(0x2A, 0x6B)
#define REG_SC_BK2A_6B_H      _PK_H_(0x2A, 0x6B)
#define REG_SC_BK2A_6C_L      _PK_L_(0x2A, 0x6C)
#define REG_SC_BK2A_6C_H      _PK_H_(0x2A, 0x6C)
#define REG_SC_BK2A_6D_L      _PK_L_(0x2A, 0x6D)
#define REG_SC_BK2A_6D_H      _PK_H_(0x2A, 0x6D)
#define REG_SC_BK2A_6E_L      _PK_L_(0x2A, 0x6E)
#define REG_SC_BK2A_6E_H      _PK_H_(0x2A, 0x6E)
#define REG_SC_BK2A_6F_L      _PK_L_(0x2A, 0x6F)
#define REG_SC_BK2A_6F_H      _PK_H_(0x2A, 0x6F)
#define REG_SC_BK2A_70_L      _PK_L_(0x2A, 0x70)
#define REG_SC_BK2A_70_H      _PK_H_(0x2A, 0x70)
#define REG_SC_BK2A_71_L      _PK_L_(0x2A, 0x71)
#define REG_SC_BK2A_71_H      _PK_H_(0x2A, 0x71)
#define REG_SC_BK2A_72_L      _PK_L_(0x2A, 0x72)
#define REG_SC_BK2A_72_H      _PK_H_(0x2A, 0x72)
#define REG_SC_BK2A_73_L      _PK_L_(0x2A, 0x73)
#define REG_SC_BK2A_73_H      _PK_H_(0x2A, 0x73)
#define REG_SC_BK2A_74_L      _PK_L_(0x2A, 0x74)
#define REG_SC_BK2A_74_H      _PK_H_(0x2A, 0x74)
#define REG_SC_BK2A_75_L      _PK_L_(0x2A, 0x75)
#define REG_SC_BK2A_75_H      _PK_H_(0x2A, 0x75)
#define REG_SC_BK2A_76_L      _PK_L_(0x2A, 0x76)
#define REG_SC_BK2A_76_H      _PK_H_(0x2A, 0x76)
#define REG_SC_BK2A_77_L      _PK_L_(0x2A, 0x77)
#define REG_SC_BK2A_77_H      _PK_H_(0x2A, 0x77)
#define REG_SC_BK2A_78_L      _PK_L_(0x2A, 0x78)
#define REG_SC_BK2A_78_H      _PK_H_(0x2A, 0x78)
#define REG_SC_BK2A_79_L      _PK_L_(0x2A, 0x79)
#define REG_SC_BK2A_79_H      _PK_H_(0x2A, 0x79)
#define REG_SC_BK2A_7A_L      _PK_L_(0x2A, 0x7A)
#define REG_SC_BK2A_7A_H      _PK_H_(0x2A, 0x7A)
#define REG_SC_BK2A_7B_L      _PK_L_(0x2A, 0x7B)
#define REG_SC_BK2A_7B_H      _PK_H_(0x2A, 0x7B)
#define REG_SC_BK2A_7C_L      _PK_L_(0x2A, 0x7C)
#define REG_SC_BK2A_7C_H      _PK_H_(0x2A, 0x7C)
#define REG_SC_BK2A_7D_L      _PK_L_(0x2A, 0x7D)
#define REG_SC_BK2A_7D_H      _PK_H_(0x2A, 0x7D)
#define REG_SC_BK2A_7E_L      _PK_L_(0x2A, 0x7E)
#define REG_SC_BK2A_7E_H      _PK_H_(0x2A, 0x7E)
#define REG_SC_BK2A_7F_L      _PK_L_(0x2A, 0x7F)
#define REG_SC_BK2A_7F_H      _PK_H_(0x2A, 0x7F)

//----------------------------------------------
//  BK2C
//----------------------------------------------
#define REG_SC_BK2C_00_L      _PK_L_(0x2C, 0x00)
#define REG_SC_BK2C_00_H      _PK_H_(0x2C, 0x00)
#define REG_SC_BK2C_01_L      _PK_L_(0x2C, 0x01)
#define REG_SC_BK2C_01_H      _PK_H_(0x2C, 0x01)
#define REG_SC_BK2C_02_L      _PK_L_(0x2C, 0x02)
#define REG_SC_BK2C_02_H      _PK_H_(0x2C, 0x02)
#define REG_SC_BK2C_03_L      _PK_L_(0x2C, 0x03)
#define REG_SC_BK2C_03_H      _PK_H_(0x2C, 0x03)
#define REG_SC_BK2C_04_L      _PK_L_(0x2C, 0x04)
#define REG_SC_BK2C_04_H      _PK_H_(0x2C, 0x04)
#define REG_SC_BK2C_05_L      _PK_L_(0x2C, 0x05)
#define REG_SC_BK2C_05_H      _PK_H_(0x2C, 0x05)
#define REG_SC_BK2C_06_L      _PK_L_(0x2C, 0x06)
#define REG_SC_BK2C_06_H      _PK_H_(0x2C, 0x06)
#define REG_SC_BK2C_07_L      _PK_L_(0x2C, 0x07)
#define REG_SC_BK2C_07_H      _PK_H_(0x2C, 0x07)
#define REG_SC_BK2C_08_L      _PK_L_(0x2C, 0x08)
#define REG_SC_BK2C_08_H      _PK_H_(0x2C, 0x08)
#define REG_SC_BK2C_09_L      _PK_L_(0x2C, 0x09)
#define REG_SC_BK2C_09_H      _PK_H_(0x2C, 0x09)
#define REG_SC_BK2C_0A_L      _PK_L_(0x2C, 0x0A)
#define REG_SC_BK2C_0A_H      _PK_H_(0x2C, 0x0A)
#define REG_SC_BK2C_0B_L      _PK_L_(0x2C, 0x0B)
#define REG_SC_BK2C_0B_H      _PK_H_(0x2C, 0x0B)
#define REG_SC_BK2C_0C_L      _PK_L_(0x2C, 0x0C)
#define REG_SC_BK2C_0C_H      _PK_H_(0x2C, 0x0C)
#define REG_SC_BK2C_0D_L      _PK_L_(0x2C, 0x0D)
#define REG_SC_BK2C_0D_H      _PK_H_(0x2C, 0x0D)
#define REG_SC_BK2C_0E_L      _PK_L_(0x2C, 0x0E)
#define REG_SC_BK2C_0E_H      _PK_H_(0x2C, 0x0E)
#define REG_SC_BK2C_0F_L      _PK_L_(0x2C, 0x0F)
#define REG_SC_BK2C_0F_H      _PK_H_(0x2C, 0x0F)
#define REG_SC_BK2C_10_L      _PK_L_(0x2C, 0x10)
#define REG_SC_BK2C_10_H      _PK_H_(0x2C, 0x10)
#define REG_SC_BK2C_11_L      _PK_L_(0x2C, 0x11)
#define REG_SC_BK2C_11_H      _PK_H_(0x2C, 0x11)
#define REG_SC_BK2C_12_L      _PK_L_(0x2C, 0x12)
#define REG_SC_BK2C_12_H      _PK_H_(0x2C, 0x12)
#define REG_SC_BK2C_13_L      _PK_L_(0x2C, 0x13)
#define REG_SC_BK2C_13_H      _PK_H_(0x2C, 0x13)
#define REG_SC_BK2C_14_L      _PK_L_(0x2C, 0x14)
#define REG_SC_BK2C_14_H      _PK_H_(0x2C, 0x14)
#define REG_SC_BK2C_15_L      _PK_L_(0x2C, 0x15)
#define REG_SC_BK2C_15_H      _PK_H_(0x2C, 0x15)
#define REG_SC_BK2C_16_L      _PK_L_(0x2C, 0x16)
#define REG_SC_BK2C_16_H      _PK_H_(0x2C, 0x16)
#define REG_SC_BK2C_17_L      _PK_L_(0x2C, 0x17)
#define REG_SC_BK2C_17_H      _PK_H_(0x2C, 0x17)
#define REG_SC_BK2C_18_L      _PK_L_(0x2C, 0x18)
#define REG_SC_BK2C_18_H      _PK_H_(0x2C, 0x18)
#define REG_SC_BK2C_19_L      _PK_L_(0x2C, 0x19)
#define REG_SC_BK2C_19_H      _PK_H_(0x2C, 0x19)
#define REG_SC_BK2C_1A_L      _PK_L_(0x2C, 0x1A)
#define REG_SC_BK2C_1A_H      _PK_H_(0x2C, 0x1A)
#define REG_SC_BK2C_1B_L      _PK_L_(0x2C, 0x1B)
#define REG_SC_BK2C_1B_H      _PK_H_(0x2C, 0x1B)
#define REG_SC_BK2C_1C_L      _PK_L_(0x2C, 0x1C)
#define REG_SC_BK2C_1C_H      _PK_H_(0x2C, 0x1C)
#define REG_SC_BK2C_1D_L      _PK_L_(0x2C, 0x1D)
#define REG_SC_BK2C_1D_H      _PK_H_(0x2C, 0x1D)
#define REG_SC_BK2C_1E_L      _PK_L_(0x2C, 0x1E)
#define REG_SC_BK2C_1E_H      _PK_H_(0x2C, 0x1E)
#define REG_SC_BK2C_1F_L      _PK_L_(0x2C, 0x1F)
#define REG_SC_BK2C_1F_H      _PK_H_(0x2C, 0x1F)
#define REG_SC_BK2C_20_L      _PK_L_(0x2C, 0x20)
#define REG_SC_BK2C_20_H      _PK_H_(0x2C, 0x20)
#define REG_SC_BK2C_21_L      _PK_L_(0x2C, 0x21)
#define REG_SC_BK2C_21_H      _PK_H_(0x2C, 0x21)
#define REG_SC_BK2C_22_L      _PK_L_(0x2C, 0x22)
#define REG_SC_BK2C_22_H      _PK_H_(0x2C, 0x22)
#define REG_SC_BK2C_23_L      _PK_L_(0x2C, 0x23)
#define REG_SC_BK2C_23_H      _PK_H_(0x2C, 0x23)
#define REG_SC_BK2C_24_L      _PK_L_(0x2C, 0x24)
#define REG_SC_BK2C_24_H      _PK_H_(0x2C, 0x24)
#define REG_SC_BK2C_25_L      _PK_L_(0x2C, 0x25)
#define REG_SC_BK2C_25_H      _PK_H_(0x2C, 0x25)
#define REG_SC_BK2C_26_L      _PK_L_(0x2C, 0x26)
#define REG_SC_BK2C_26_H      _PK_H_(0x2C, 0x26)
#define REG_SC_BK2C_27_L      _PK_L_(0x2C, 0x27)
#define REG_SC_BK2C_27_H      _PK_H_(0x2C, 0x27)
#define REG_SC_BK2C_28_L      _PK_L_(0x2C, 0x28)
#define REG_SC_BK2C_28_H      _PK_H_(0x2C, 0x28)
#define REG_SC_BK2C_29_L      _PK_L_(0x2C, 0x29)
#define REG_SC_BK2C_29_H      _PK_H_(0x2C, 0x29)
#define REG_SC_BK2C_2A_L      _PK_L_(0x2C, 0x2A)
#define REG_SC_BK2C_2A_H      _PK_H_(0x2C, 0x2A)
#define REG_SC_BK2C_2B_L      _PK_L_(0x2C, 0x2B)
#define REG_SC_BK2C_2B_H      _PK_H_(0x2C, 0x2B)
#define REG_SC_BK2C_2C_L      _PK_L_(0x2C, 0x2C)
#define REG_SC_BK2C_2C_H      _PK_H_(0x2C, 0x2C)
#define REG_SC_BK2C_2D_L      _PK_L_(0x2C, 0x2D)
#define REG_SC_BK2C_2D_H      _PK_H_(0x2C, 0x2D)
#define REG_SC_BK2C_2E_L      _PK_L_(0x2C, 0x2E)
#define REG_SC_BK2C_2E_H      _PK_H_(0x2C, 0x2E)
#define REG_SC_BK2C_2F_L      _PK_L_(0x2C, 0x2F)
#define REG_SC_BK2C_2F_H      _PK_H_(0x2C, 0x2F)
#define REG_SC_BK2C_30_L      _PK_L_(0x2C, 0x30)
#define REG_SC_BK2C_30_H      _PK_H_(0x2C, 0x30)
#define REG_SC_BK2C_31_L      _PK_L_(0x2C, 0x31)
#define REG_SC_BK2C_31_H      _PK_H_(0x2C, 0x31)
#define REG_SC_BK2C_32_L      _PK_L_(0x2C, 0x32)
#define REG_SC_BK2C_32_H      _PK_H_(0x2C, 0x32)
#define REG_SC_BK2C_33_L      _PK_L_(0x2C, 0x33)
#define REG_SC_BK2C_33_H      _PK_H_(0x2C, 0x33)
#define REG_SC_BK2C_34_L      _PK_L_(0x2C, 0x34)
#define REG_SC_BK2C_34_H      _PK_H_(0x2C, 0x34)
#define REG_SC_BK2C_35_L      _PK_L_(0x2C, 0x35)
#define REG_SC_BK2C_35_H      _PK_H_(0x2C, 0x35)
#define REG_SC_BK2C_36_L      _PK_L_(0x2C, 0x36)
#define REG_SC_BK2C_36_H      _PK_H_(0x2C, 0x36)
#define REG_SC_BK2C_37_L      _PK_L_(0x2C, 0x37)
#define REG_SC_BK2C_37_H      _PK_H_(0x2C, 0x37)
#define REG_SC_BK2C_38_L      _PK_L_(0x2C, 0x38)
#define REG_SC_BK2C_38_H      _PK_H_(0x2C, 0x38)
#define REG_SC_BK2C_39_L      _PK_L_(0x2C, 0x39)
#define REG_SC_BK2C_39_H      _PK_H_(0x2C, 0x39)
#define REG_SC_BK2C_3A_L      _PK_L_(0x2C, 0x3A)
#define REG_SC_BK2C_3A_H      _PK_H_(0x2C, 0x3A)
#define REG_SC_BK2C_3B_L      _PK_L_(0x2C, 0x3B)
#define REG_SC_BK2C_3B_H      _PK_H_(0x2C, 0x3B)
#define REG_SC_BK2C_3C_L      _PK_L_(0x2C, 0x3C)
#define REG_SC_BK2C_3C_H      _PK_H_(0x2C, 0x3C)
#define REG_SC_BK2C_3D_L      _PK_L_(0x2C, 0x3D)
#define REG_SC_BK2C_3D_H      _PK_H_(0x2C, 0x3D)
#define REG_SC_BK2C_3E_L      _PK_L_(0x2C, 0x3E)
#define REG_SC_BK2C_3E_H      _PK_H_(0x2C, 0x3E)
#define REG_SC_BK2C_3F_L      _PK_L_(0x2C, 0x3F)
#define REG_SC_BK2C_3F_H      _PK_H_(0x2C, 0x3F)
#define REG_SC_BK2C_40_L      _PK_L_(0x2C, 0x40)
#define REG_SC_BK2C_40_H      _PK_H_(0x2C, 0x40)
#define REG_SC_BK2C_41_L      _PK_L_(0x2C, 0x41)
#define REG_SC_BK2C_41_H      _PK_H_(0x2C, 0x41)
#define REG_SC_BK2C_42_L      _PK_L_(0x2C, 0x42)
#define REG_SC_BK2C_42_H      _PK_H_(0x2C, 0x42)
#define REG_SC_BK2C_43_L      _PK_L_(0x2C, 0x43)
#define REG_SC_BK2C_43_H      _PK_H_(0x2C, 0x43)
#define REG_SC_BK2C_44_L      _PK_L_(0x2C, 0x44)
#define REG_SC_BK2C_44_H      _PK_H_(0x2C, 0x44)
#define REG_SC_BK2C_45_L      _PK_L_(0x2C, 0x45)
#define REG_SC_BK2C_45_H      _PK_H_(0x2C, 0x45)
#define REG_SC_BK2C_46_L      _PK_L_(0x2C, 0x46)
#define REG_SC_BK2C_46_H      _PK_H_(0x2C, 0x46)
#define REG_SC_BK2C_47_L      _PK_L_(0x2C, 0x47)
#define REG_SC_BK2C_47_H      _PK_H_(0x2C, 0x47)
#define REG_SC_BK2C_48_L      _PK_L_(0x2C, 0x48)
#define REG_SC_BK2C_48_H      _PK_H_(0x2C, 0x48)
#define REG_SC_BK2C_49_L      _PK_L_(0x2C, 0x49)
#define REG_SC_BK2C_49_H      _PK_H_(0x2C, 0x49)
#define REG_SC_BK2C_4A_L      _PK_L_(0x2C, 0x4A)
#define REG_SC_BK2C_4A_H      _PK_H_(0x2C, 0x4A)
#define REG_SC_BK2C_4B_L      _PK_L_(0x2C, 0x4B)
#define REG_SC_BK2C_4B_H      _PK_H_(0x2C, 0x4B)
#define REG_SC_BK2C_4C_L      _PK_L_(0x2C, 0x4C)
#define REG_SC_BK2C_4C_H      _PK_H_(0x2C, 0x4C)
#define REG_SC_BK2C_4D_L      _PK_L_(0x2C, 0x4D)
#define REG_SC_BK2C_4D_H      _PK_H_(0x2C, 0x4D)
#define REG_SC_BK2C_4E_L      _PK_L_(0x2C, 0x4E)
#define REG_SC_BK2C_4E_H      _PK_H_(0x2C, 0x4E)
#define REG_SC_BK2C_4F_L      _PK_L_(0x2C, 0x4F)
#define REG_SC_BK2C_4F_H      _PK_H_(0x2C, 0x4F)
#define REG_SC_BK2C_50_L      _PK_L_(0x2C, 0x50)
#define REG_SC_BK2C_50_H      _PK_H_(0x2C, 0x50)
#define REG_SC_BK2C_51_L      _PK_L_(0x2C, 0x51)
#define REG_SC_BK2C_51_H      _PK_H_(0x2C, 0x51)
#define REG_SC_BK2C_52_L      _PK_L_(0x2C, 0x52)
#define REG_SC_BK2C_52_H      _PK_H_(0x2C, 0x52)
#define REG_SC_BK2C_53_L      _PK_L_(0x2C, 0x53)
#define REG_SC_BK2C_53_H      _PK_H_(0x2C, 0x53)
#define REG_SC_BK2C_54_L      _PK_L_(0x2C, 0x54)
#define REG_SC_BK2C_54_H      _PK_H_(0x2C, 0x54)
#define REG_SC_BK2C_55_L      _PK_L_(0x2C, 0x55)
#define REG_SC_BK2C_55_H      _PK_H_(0x2C, 0x55)
#define REG_SC_BK2C_56_L      _PK_L_(0x2C, 0x56)
#define REG_SC_BK2C_56_H      _PK_H_(0x2C, 0x56)
#define REG_SC_BK2C_57_L      _PK_L_(0x2C, 0x57)
#define REG_SC_BK2C_57_H      _PK_H_(0x2C, 0x57)
#define REG_SC_BK2C_58_L      _PK_L_(0x2C, 0x58)
#define REG_SC_BK2C_58_H      _PK_H_(0x2C, 0x58)
#define REG_SC_BK2C_59_L      _PK_L_(0x2C, 0x59)
#define REG_SC_BK2C_59_H      _PK_H_(0x2C, 0x59)
#define REG_SC_BK2C_5A_L      _PK_L_(0x2C, 0x5A)
#define REG_SC_BK2C_5A_H      _PK_H_(0x2C, 0x5A)
#define REG_SC_BK2C_5B_L      _PK_L_(0x2C, 0x5B)
#define REG_SC_BK2C_5B_H      _PK_H_(0x2C, 0x5B)
#define REG_SC_BK2C_5C_L      _PK_L_(0x2C, 0x5C)
#define REG_SC_BK2C_5C_H      _PK_H_(0x2C, 0x5C)
#define REG_SC_BK2C_5D_L      _PK_L_(0x2C, 0x5D)
#define REG_SC_BK2C_5D_H      _PK_H_(0x2C, 0x5D)
#define REG_SC_BK2C_5E_L      _PK_L_(0x2C, 0x5E)
#define REG_SC_BK2C_5E_H      _PK_H_(0x2C, 0x5E)
#define REG_SC_BK2C_5F_L      _PK_L_(0x2C, 0x5F)
#define REG_SC_BK2C_5F_H      _PK_H_(0x2C, 0x5F)
#define REG_SC_BK2C_60_L      _PK_L_(0x2C, 0x60)
#define REG_SC_BK2C_60_H      _PK_H_(0x2C, 0x60)
#define REG_SC_BK2C_61_L      _PK_L_(0x2C, 0x61)
#define REG_SC_BK2C_61_H      _PK_H_(0x2C, 0x61)
#define REG_SC_BK2C_62_L      _PK_L_(0x2C, 0x62)
#define REG_SC_BK2C_62_H      _PK_H_(0x2C, 0x62)
#define REG_SC_BK2C_63_L      _PK_L_(0x2C, 0x63)
#define REG_SC_BK2C_63_H      _PK_H_(0x2C, 0x63)
#define REG_SC_BK2C_64_L      _PK_L_(0x2C, 0x64)
#define REG_SC_BK2C_64_H      _PK_H_(0x2C, 0x64)
#define REG_SC_BK2C_65_L      _PK_L_(0x2C, 0x65)
#define REG_SC_BK2C_65_H      _PK_H_(0x2C, 0x65)
#define REG_SC_BK2C_66_L      _PK_L_(0x2C, 0x66)
#define REG_SC_BK2C_66_H      _PK_H_(0x2C, 0x66)
#define REG_SC_BK2C_67_L      _PK_L_(0x2C, 0x67)
#define REG_SC_BK2C_67_H      _PK_H_(0x2C, 0x67)
#define REG_SC_BK2C_68_L      _PK_L_(0x2C, 0x68)
#define REG_SC_BK2C_68_H      _PK_H_(0x2C, 0x68)
#define REG_SC_BK2C_69_L      _PK_L_(0x2C, 0x69)
#define REG_SC_BK2C_69_H      _PK_H_(0x2C, 0x69)
#define REG_SC_BK2C_6A_L      _PK_L_(0x2C, 0x6A)
#define REG_SC_BK2C_6A_H      _PK_H_(0x2C, 0x6A)
#define REG_SC_BK2C_6B_L      _PK_L_(0x2C, 0x6B)
#define REG_SC_BK2C_6B_H      _PK_H_(0x2C, 0x6B)
#define REG_SC_BK2C_6C_L      _PK_L_(0x2C, 0x6C)
#define REG_SC_BK2C_6C_H      _PK_H_(0x2C, 0x6C)
#define REG_SC_BK2C_6D_L      _PK_L_(0x2C, 0x6D)
#define REG_SC_BK2C_6D_H      _PK_H_(0x2C, 0x6D)
#define REG_SC_BK2C_6E_L      _PK_L_(0x2C, 0x6E)
#define REG_SC_BK2C_6E_H      _PK_H_(0x2C, 0x6E)
#define REG_SC_BK2C_6F_L      _PK_L_(0x2C, 0x6F)
#define REG_SC_BK2C_6F_H      _PK_H_(0x2C, 0x6F)
#define REG_SC_BK2C_70_L      _PK_L_(0x2C, 0x70)
#define REG_SC_BK2C_70_H      _PK_H_(0x2C, 0x70)
#define REG_SC_BK2C_71_L      _PK_L_(0x2C, 0x71)
#define REG_SC_BK2C_71_H      _PK_H_(0x2C, 0x71)
#define REG_SC_BK2C_72_L      _PK_L_(0x2C, 0x72)
#define REG_SC_BK2C_72_H      _PK_H_(0x2C, 0x72)
#define REG_SC_BK2C_73_L      _PK_L_(0x2C, 0x73)
#define REG_SC_BK2C_73_H      _PK_H_(0x2C, 0x73)
#define REG_SC_BK2C_74_L      _PK_L_(0x2C, 0x74)
#define REG_SC_BK2C_74_H      _PK_H_(0x2C, 0x74)
#define REG_SC_BK2C_75_L      _PK_L_(0x2C, 0x75)
#define REG_SC_BK2C_75_H      _PK_H_(0x2C, 0x75)
#define REG_SC_BK2C_76_L      _PK_L_(0x2C, 0x76)
#define REG_SC_BK2C_76_H      _PK_H_(0x2C, 0x76)
#define REG_SC_BK2C_77_L      _PK_L_(0x2C, 0x77)
#define REG_SC_BK2C_77_H      _PK_H_(0x2C, 0x77)
#define REG_SC_BK2C_78_L      _PK_L_(0x2C, 0x78)
#define REG_SC_BK2C_78_H      _PK_H_(0x2C, 0x78)
#define REG_SC_BK2C_79_L      _PK_L_(0x2C, 0x79)
#define REG_SC_BK2C_79_H      _PK_H_(0x2C, 0x79)
#define REG_SC_BK2C_7A_L      _PK_L_(0x2C, 0x7A)
#define REG_SC_BK2C_7A_H      _PK_H_(0x2C, 0x7A)
#define REG_SC_BK2C_7B_L      _PK_L_(0x2C, 0x7B)
#define REG_SC_BK2C_7B_H      _PK_H_(0x2C, 0x7B)
#define REG_SC_BK2C_7C_L      _PK_L_(0x2C, 0x7C)
#define REG_SC_BK2C_7C_H      _PK_H_(0x2C, 0x7C)
#define REG_SC_BK2C_7D_L      _PK_L_(0x2C, 0x7D)
#define REG_SC_BK2C_7D_H      _PK_H_(0x2C, 0x7D)
#define REG_SC_BK2C_7E_L      _PK_L_(0x2C, 0x7E)
#define REG_SC_BK2C_7E_H      _PK_H_(0x2C, 0x7E)
#define REG_SC_BK2C_7F_L      _PK_L_(0x2C, 0x7F)
#define REG_SC_BK2C_7F_H      _PK_H_(0x2C, 0x7F)

//----------------------------------------------
//  BK2D
//----------------------------------------------
#define REG_SC_BK2D_01_L      _PK_L_(0x2D, 0x01)
#define REG_SC_BK2D_01_H      _PK_H_(0x2D, 0x01)
#define REG_SC_BK2D_02_L      _PK_L_(0x2D, 0x02)
#define REG_SC_BK2D_02_H      _PK_H_(0x2D, 0x02)
#define REG_SC_BK2D_03_L      _PK_L_(0x2D, 0x03)
#define REG_SC_BK2D_03_H      _PK_H_(0x2D, 0x03)
#define REG_SC_BK2D_04_L      _PK_L_(0x2D, 0x04)
#define REG_SC_BK2D_04_H      _PK_H_(0x2D, 0x04)
#define REG_SC_BK2D_05_L      _PK_L_(0x2D, 0x05)
#define REG_SC_BK2D_05_H      _PK_H_(0x2D, 0x05)
#define REG_SC_BK2D_06_L      _PK_L_(0x2D, 0x06)
#define REG_SC_BK2D_06_H      _PK_H_(0x2D, 0x06)
#define REG_SC_BK2D_10_L      _PK_L_(0x2D, 0x10)
#define REG_SC_BK2D_10_H      _PK_H_(0x2D, 0x10)
#define REG_SC_BK2D_11_L      _PK_L_(0x2D, 0x11)
#define REG_SC_BK2D_11_H      _PK_H_(0x2D, 0x11)
#define REG_SC_BK2D_12_L      _PK_L_(0x2D, 0x12)
#define REG_SC_BK2D_12_H      _PK_H_(0x2D, 0x12)
#define REG_SC_BK2D_13_L      _PK_L_(0x2D, 0x13)
#define REG_SC_BK2D_13_H      _PK_H_(0x2D, 0x13)

//----------------------------------------------
//  BK2E: Local Dimming
//----------------------------------------------
#define REG_SC_BK2E_00_L      _PK_L_(0x2E, 0x00)
#define REG_SC_BK2E_00_H      _PK_H_(0x2E, 0x00)
#define REG_SC_BK2E_01_L      _PK_L_(0x2E, 0x01)
#define REG_SC_BK2E_01_H      _PK_H_(0x2E, 0x01)
#define REG_SC_BK2E_02_L      _PK_L_(0x2E, 0x02)
#define REG_SC_BK2E_02_H      _PK_H_(0x2E, 0x02)
#define REG_SC_BK2E_03_L      _PK_L_(0x2E, 0x03)
#define REG_SC_BK2E_03_H      _PK_H_(0x2E, 0x03)
#define REG_SC_BK2E_04_L      _PK_L_(0x2E, 0x04)
#define REG_SC_BK2E_04_H      _PK_H_(0x2E, 0x04)
#define REG_SC_BK2E_05_L      _PK_L_(0x2E, 0x05)
#define REG_SC_BK2E_05_H      _PK_H_(0x2E, 0x05)
#define REG_SC_BK2E_06_L      _PK_L_(0x2E, 0x06)
#define REG_SC_BK2E_06_H      _PK_H_(0x2E, 0x06)
#define REG_SC_BK2E_07_L      _PK_L_(0x2E, 0x07)
#define REG_SC_BK2E_07_H      _PK_H_(0x2E, 0x07)
#define REG_SC_BK2E_08_L      _PK_L_(0x2E, 0x08)
#define REG_SC_BK2E_08_H      _PK_H_(0x2E, 0x08)
#define REG_SC_BK2E_09_L      _PK_L_(0x2E, 0x09)
#define REG_SC_BK2E_09_H      _PK_H_(0x2E, 0x09)
#define REG_SC_BK2E_0A_L      _PK_L_(0x2E, 0x0A)
#define REG_SC_BK2E_0A_H      _PK_H_(0x2E, 0x0A)
#define REG_SC_BK2E_0B_L      _PK_L_(0x2E, 0x0B)
#define REG_SC_BK2E_0B_H      _PK_H_(0x2E, 0x0B)
#define REG_SC_BK2E_0C_L      _PK_L_(0x2E, 0x0C)
#define REG_SC_BK2E_0C_H      _PK_H_(0x2E, 0x0C)
#define REG_SC_BK2E_0D_L      _PK_L_(0x2E, 0x0D)
#define REG_SC_BK2E_0D_H      _PK_H_(0x2E, 0x0D)
#define REG_SC_BK2E_0E_L      _PK_L_(0x2E, 0x0E)
#define REG_SC_BK2E_0E_H      _PK_H_(0x2E, 0x0E)
#define REG_SC_BK2E_0F_L      _PK_L_(0x2E, 0x0F)
#define REG_SC_BK2E_0F_H      _PK_H_(0x2E, 0x0F)
#define REG_SC_BK2E_10_L      _PK_L_(0x2E, 0x10)
#define REG_SC_BK2E_10_H      _PK_H_(0x2E, 0x10)
#define REG_SC_BK2E_11_L      _PK_L_(0x2E, 0x11)
#define REG_SC_BK2E_11_H      _PK_H_(0x2E, 0x11)
#define REG_SC_BK2E_12_L      _PK_L_(0x2E, 0x12)
#define REG_SC_BK2E_12_H      _PK_H_(0x2E, 0x12)
#define REG_SC_BK2E_13_L      _PK_L_(0x2E, 0x13)
#define REG_SC_BK2E_13_H      _PK_H_(0x2E, 0x13)
#define REG_SC_BK2E_14_L      _PK_L_(0x2E, 0x14)
#define REG_SC_BK2E_14_H      _PK_H_(0x2E, 0x14)
#define REG_SC_BK2E_15_L      _PK_L_(0x2E, 0x15)
#define REG_SC_BK2E_15_H      _PK_H_(0x2E, 0x15)
#define REG_SC_BK2E_16_L      _PK_L_(0x2E, 0x16)
#define REG_SC_BK2E_16_H      _PK_H_(0x2E, 0x16)
#define REG_SC_BK2E_17_L      _PK_L_(0x2E, 0x17)
#define REG_SC_BK2E_17_H      _PK_H_(0x2E, 0x17)
#define REG_SC_BK2E_18_L      _PK_L_(0x2E, 0x18)
#define REG_SC_BK2E_18_H      _PK_H_(0x2E, 0x18)
#define REG_SC_BK2E_19_L      _PK_L_(0x2E, 0x19)
#define REG_SC_BK2E_19_H      _PK_H_(0x2E, 0x19)
#define REG_SC_BK2E_1A_L      _PK_L_(0x2E, 0x1A)
#define REG_SC_BK2E_1A_H      _PK_H_(0x2E, 0x1A)
#define REG_SC_BK2E_1B_L      _PK_L_(0x2E, 0x1B)
#define REG_SC_BK2E_1B_H      _PK_H_(0x2E, 0x1B)
#define REG_SC_BK2E_1C_L      _PK_L_(0x2E, 0x1C)
#define REG_SC_BK2E_1C_H      _PK_H_(0x2E, 0x1C)
#define REG_SC_BK2E_1D_L      _PK_L_(0x2E, 0x1D)
#define REG_SC_BK2E_1D_H      _PK_H_(0x2E, 0x1D)
#define REG_SC_BK2E_1E_L      _PK_L_(0x2E, 0x1E)
#define REG_SC_BK2E_1E_H      _PK_H_(0x2E, 0x1E)
#define REG_SC_BK2E_1F_L      _PK_L_(0x2E, 0x1F)
#define REG_SC_BK2E_1F_H      _PK_H_(0x2E, 0x1F)
#define REG_SC_BK2E_20_L      _PK_L_(0x2E, 0x20)
#define REG_SC_BK2E_20_H      _PK_H_(0x2E, 0x20)
#define REG_SC_BK2E_21_L      _PK_L_(0x2E, 0x21)
#define REG_SC_BK2E_21_H      _PK_H_(0x2E, 0x21)
#define REG_SC_BK2E_22_L      _PK_L_(0x2E, 0x22)
#define REG_SC_BK2E_22_H      _PK_H_(0x2E, 0x22)
#define REG_SC_BK2E_23_L      _PK_L_(0x2E, 0x23)
#define REG_SC_BK2E_23_H      _PK_H_(0x2E, 0x23)
#define REG_SC_BK2E_24_L      _PK_L_(0x2E, 0x24)
#define REG_SC_BK2E_24_H      _PK_H_(0x2E, 0x24)
#define REG_SC_BK2E_25_L      _PK_L_(0x2E, 0x25)
#define REG_SC_BK2E_25_H      _PK_H_(0x2E, 0x25)
#define REG_SC_BK2E_26_L      _PK_L_(0x2E, 0x26)
#define REG_SC_BK2E_26_H      _PK_H_(0x2E, 0x26)
#define REG_SC_BK2E_27_L      _PK_L_(0x2E, 0x27)
#define REG_SC_BK2E_27_H      _PK_H_(0x2E, 0x27)
#define REG_SC_BK2E_28_L      _PK_L_(0x2E, 0x28)
#define REG_SC_BK2E_28_H      _PK_H_(0x2E, 0x28)
#define REG_SC_BK2E_29_L      _PK_L_(0x2E, 0x29)
#define REG_SC_BK2E_29_H      _PK_H_(0x2E, 0x29)
#define REG_SC_BK2E_2A_L      _PK_L_(0x2E, 0x2A)
#define REG_SC_BK2E_2A_H      _PK_H_(0x2E, 0x2A)
#define REG_SC_BK2E_2B_L      _PK_L_(0x2E, 0x2B)
#define REG_SC_BK2E_2B_H      _PK_H_(0x2E, 0x2B)
#define REG_SC_BK2E_2C_L      _PK_L_(0x2E, 0x2C)
#define REG_SC_BK2E_2C_H      _PK_H_(0x2E, 0x2C)
#define REG_SC_BK2E_2D_L      _PK_L_(0x2E, 0x2D)
#define REG_SC_BK2E_2D_H      _PK_H_(0x2E, 0x2D)
#define REG_SC_BK2E_2E_L      _PK_L_(0x2E, 0x2E)
#define REG_SC_BK2E_2E_H      _PK_H_(0x2E, 0x2E)
#define REG_SC_BK2E_2F_L      _PK_L_(0x2E, 0x2F)
#define REG_SC_BK2E_2F_H      _PK_H_(0x2E, 0x2F)
#define REG_SC_BK2E_30_L      _PK_L_(0x2E, 0x30)
#define REG_SC_BK2E_30_H      _PK_H_(0x2E, 0x30)
#define REG_SC_BK2E_31_L      _PK_L_(0x2E, 0x31)
#define REG_SC_BK2E_31_H      _PK_H_(0x2E, 0x31)
#define REG_SC_BK2E_32_L      _PK_L_(0x2E, 0x32)
#define REG_SC_BK2E_32_H      _PK_H_(0x2E, 0x32)
#define REG_SC_BK2E_33_L      _PK_L_(0x2E, 0x33)
#define REG_SC_BK2E_33_H      _PK_H_(0x2E, 0x33)
#define REG_SC_BK2E_34_L      _PK_L_(0x2E, 0x34)
#define REG_SC_BK2E_34_H      _PK_H_(0x2E, 0x34)
#define REG_SC_BK2E_35_L      _PK_L_(0x2E, 0x35)
#define REG_SC_BK2E_35_H      _PK_H_(0x2E, 0x35)
#define REG_SC_BK2E_36_L      _PK_L_(0x2E, 0x36)
#define REG_SC_BK2E_36_H      _PK_H_(0x2E, 0x36)
#define REG_SC_BK2E_37_L      _PK_L_(0x2E, 0x37)
#define REG_SC_BK2E_37_H      _PK_H_(0x2E, 0x37)
#define REG_SC_BK2E_38_L      _PK_L_(0x2E, 0x38)
#define REG_SC_BK2E_38_H      _PK_H_(0x2E, 0x38)
#define REG_SC_BK2E_39_L      _PK_L_(0x2E, 0x39)
#define REG_SC_BK2E_39_H      _PK_H_(0x2E, 0x39)
#define REG_SC_BK2E_3A_L      _PK_L_(0x2E, 0x3A)
#define REG_SC_BK2E_3A_H      _PK_H_(0x2E, 0x3A)
#define REG_SC_BK2E_3B_L      _PK_L_(0x2E, 0x3B)
#define REG_SC_BK2E_3B_H      _PK_H_(0x2E, 0x3B)
#define REG_SC_BK2E_3C_L      _PK_L_(0x2E, 0x3C)
#define REG_SC_BK2E_3C_H      _PK_H_(0x2E, 0x3C)
#define REG_SC_BK2E_3D_L      _PK_L_(0x2E, 0x3D)
#define REG_SC_BK2E_3D_H      _PK_H_(0x2E, 0x3D)
#define REG_SC_BK2E_3E_L      _PK_L_(0x2E, 0x3E)
#define REG_SC_BK2E_3E_H      _PK_H_(0x2E, 0x3E)
#define REG_SC_BK2E_3F_L      _PK_L_(0x2E, 0x3F)
#define REG_SC_BK2E_3F_H      _PK_H_(0x2E, 0x3F)
#define REG_SC_BK2E_40_L      _PK_L_(0x2E, 0x40)
#define REG_SC_BK2E_40_H      _PK_H_(0x2E, 0x40)
#define REG_SC_BK2E_41_L      _PK_L_(0x2E, 0x41)
#define REG_SC_BK2E_41_H      _PK_H_(0x2E, 0x41)
#define REG_SC_BK2E_42_L      _PK_L_(0x2E, 0x42)
#define REG_SC_BK2E_42_H      _PK_H_(0x2E, 0x42)
#define REG_SC_BK2E_43_L      _PK_L_(0x2E, 0x43)
#define REG_SC_BK2E_43_H      _PK_H_(0x2E, 0x43)
#define REG_SC_BK2E_44_L      _PK_L_(0x2E, 0x44)
#define REG_SC_BK2E_44_H      _PK_H_(0x2E, 0x44)
#define REG_SC_BK2E_45_L      _PK_L_(0x2E, 0x45)
#define REG_SC_BK2E_45_H      _PK_H_(0x2E, 0x45)
#define REG_SC_BK2E_46_L      _PK_L_(0x2E, 0x46)
#define REG_SC_BK2E_46_H      _PK_H_(0x2E, 0x46)
#define REG_SC_BK2E_47_L      _PK_L_(0x2E, 0x47)
#define REG_SC_BK2E_47_H      _PK_H_(0x2E, 0x47)
#define REG_SC_BK2E_48_L      _PK_L_(0x2E, 0x48)
#define REG_SC_BK2E_48_H      _PK_H_(0x2E, 0x48)
#define REG_SC_BK2E_49_L      _PK_L_(0x2E, 0x49)
#define REG_SC_BK2E_49_H      _PK_H_(0x2E, 0x49)
#define REG_SC_BK2E_4A_L      _PK_L_(0x2E, 0x4A)
#define REG_SC_BK2E_4A_H      _PK_H_(0x2E, 0x4A)
#define REG_SC_BK2E_4B_L      _PK_L_(0x2E, 0x4B)
#define REG_SC_BK2E_4B_H      _PK_H_(0x2E, 0x4B)
#define REG_SC_BK2E_4C_L      _PK_L_(0x2E, 0x4C)
#define REG_SC_BK2E_4C_H      _PK_H_(0x2E, 0x4C)
#define REG_SC_BK2E_4D_L      _PK_L_(0x2E, 0x4D)
#define REG_SC_BK2E_4D_H      _PK_H_(0x2E, 0x4D)
#define REG_SC_BK2E_4E_L      _PK_L_(0x2E, 0x4E)
#define REG_SC_BK2E_4E_H      _PK_H_(0x2E, 0x4E)
#define REG_SC_BK2E_4F_L      _PK_L_(0x2E, 0x4F)
#define REG_SC_BK2E_4F_H      _PK_H_(0x2E, 0x4F)
#define REG_SC_BK2E_50_L      _PK_L_(0x2E, 0x50)
#define REG_SC_BK2E_50_H      _PK_H_(0x2E, 0x50)
#define REG_SC_BK2E_51_L      _PK_L_(0x2E, 0x51)
#define REG_SC_BK2E_51_H      _PK_H_(0x2E, 0x51)
#define REG_SC_BK2E_52_L      _PK_L_(0x2E, 0x52)
#define REG_SC_BK2E_52_H      _PK_H_(0x2E, 0x52)
#define REG_SC_BK2E_53_L      _PK_L_(0x2E, 0x53)
#define REG_SC_BK2E_53_H      _PK_H_(0x2E, 0x53)
#define REG_SC_BK2E_54_L      _PK_L_(0x2E, 0x54)
#define REG_SC_BK2E_54_H      _PK_H_(0x2E, 0x54)
#define REG_SC_BK2E_55_L      _PK_L_(0x2E, 0x55)
#define REG_SC_BK2E_55_H      _PK_H_(0x2E, 0x55)
#define REG_SC_BK2E_56_L      _PK_L_(0x2E, 0x56)
#define REG_SC_BK2E_56_H      _PK_H_(0x2E, 0x56)
#define REG_SC_BK2E_57_L      _PK_L_(0x2E, 0x57)
#define REG_SC_BK2E_57_H      _PK_H_(0x2E, 0x57)
#define REG_SC_BK2E_58_L      _PK_L_(0x2E, 0x58)
#define REG_SC_BK2E_58_H      _PK_H_(0x2E, 0x58)
#define REG_SC_BK2E_59_L      _PK_L_(0x2E, 0x59)
#define REG_SC_BK2E_59_H      _PK_H_(0x2E, 0x59)
#define REG_SC_BK2E_5A_L      _PK_L_(0x2E, 0x5A)
#define REG_SC_BK2E_5A_H      _PK_H_(0x2E, 0x5A)
#define REG_SC_BK2E_5B_L      _PK_L_(0x2E, 0x5B)
#define REG_SC_BK2E_5B_H      _PK_H_(0x2E, 0x5B)
#define REG_SC_BK2E_5C_L      _PK_L_(0x2E, 0x5C)
#define REG_SC_BK2E_5C_H      _PK_H_(0x2E, 0x5C)
#define REG_SC_BK2E_5D_L      _PK_L_(0x2E, 0x5D)
#define REG_SC_BK2E_5D_H      _PK_H_(0x2E, 0x5D)
#define REG_SC_BK2E_5E_L      _PK_L_(0x2E, 0x5E)
#define REG_SC_BK2E_5E_H      _PK_H_(0x2E, 0x5E)
#define REG_SC_BK2E_5F_L      _PK_L_(0x2E, 0x5F)
#define REG_SC_BK2E_5F_H      _PK_H_(0x2E, 0x5F)
#define REG_SC_BK2E_60_L      _PK_L_(0x2E, 0x60)
#define REG_SC_BK2E_60_H      _PK_H_(0x2E, 0x60)
#define REG_SC_BK2E_61_L      _PK_L_(0x2E, 0x61)
#define REG_SC_BK2E_61_H      _PK_H_(0x2E, 0x61)
#define REG_SC_BK2E_62_L      _PK_L_(0x2E, 0x62)
#define REG_SC_BK2E_62_H      _PK_H_(0x2E, 0x62)
#define REG_SC_BK2E_63_L      _PK_L_(0x2E, 0x63)
#define REG_SC_BK2E_63_H      _PK_H_(0x2E, 0x63)
#define REG_SC_BK2E_64_L      _PK_L_(0x2E, 0x64)
#define REG_SC_BK2E_64_H      _PK_H_(0x2E, 0x64)
#define REG_SC_BK2E_65_L      _PK_L_(0x2E, 0x65)
#define REG_SC_BK2E_65_H      _PK_H_(0x2E, 0x65)
#define REG_SC_BK2E_66_L      _PK_L_(0x2E, 0x66)
#define REG_SC_BK2E_66_H      _PK_H_(0x2E, 0x66)
#define REG_SC_BK2E_67_L      _PK_L_(0x2E, 0x67)
#define REG_SC_BK2E_67_H      _PK_H_(0x2E, 0x67)
#define REG_SC_BK2E_68_L      _PK_L_(0x2E, 0x68)
#define REG_SC_BK2E_68_H      _PK_H_(0x2E, 0x68)
#define REG_SC_BK2E_69_L      _PK_L_(0x2E, 0x69)
#define REG_SC_BK2E_69_H      _PK_H_(0x2E, 0x69)
#define REG_SC_BK2E_6A_L      _PK_L_(0x2E, 0x6A)
#define REG_SC_BK2E_6A_H      _PK_H_(0x2E, 0x6A)
#define REG_SC_BK2E_6B_L      _PK_L_(0x2E, 0x6B)
#define REG_SC_BK2E_6B_H      _PK_H_(0x2E, 0x6B)
#define REG_SC_BK2E_6C_L      _PK_L_(0x2E, 0x6C)
#define REG_SC_BK2E_6C_H      _PK_H_(0x2E, 0x6C)
#define REG_SC_BK2E_6D_L      _PK_L_(0x2E, 0x6D)
#define REG_SC_BK2E_6D_H      _PK_H_(0x2E, 0x6D)
#define REG_SC_BK2E_6E_L      _PK_L_(0x2E, 0x6E)
#define REG_SC_BK2E_6E_H      _PK_H_(0x2E, 0x6E)
#define REG_SC_BK2E_6F_L      _PK_L_(0x2E, 0x6F)
#define REG_SC_BK2E_6F_H      _PK_H_(0x2E, 0x6F)
#define REG_SC_BK2E_70_L      _PK_L_(0x2E, 0x70)
#define REG_SC_BK2E_70_H      _PK_H_(0x2E, 0x70)
#define REG_SC_BK2E_71_L      _PK_L_(0x2E, 0x71)
#define REG_SC_BK2E_71_H      _PK_H_(0x2E, 0x71)
#define REG_SC_BK2E_72_L      _PK_L_(0x2E, 0x72)
#define REG_SC_BK2E_72_H      _PK_H_(0x2E, 0x72)
#define REG_SC_BK2E_73_L      _PK_L_(0x2E, 0x73)
#define REG_SC_BK2E_73_H      _PK_H_(0x2E, 0x73)
#define REG_SC_BK2E_74_L      _PK_L_(0x2E, 0x74)
#define REG_SC_BK2E_74_H      _PK_H_(0x2E, 0x74)
#define REG_SC_BK2E_75_L      _PK_L_(0x2E, 0x75)
#define REG_SC_BK2E_75_H      _PK_H_(0x2E, 0x75)
#define REG_SC_BK2E_76_L      _PK_L_(0x2E, 0x76)
#define REG_SC_BK2E_76_H      _PK_H_(0x2E, 0x76)
#define REG_SC_BK2E_77_L      _PK_L_(0x2E, 0x77)
#define REG_SC_BK2E_77_H      _PK_H_(0x2E, 0x77)
#define REG_SC_BK2E_78_L      _PK_L_(0x2E, 0x78)
#define REG_SC_BK2E_78_H      _PK_H_(0x2E, 0x78)
#define REG_SC_BK2E_79_L      _PK_L_(0x2E, 0x79)
#define REG_SC_BK2E_79_H      _PK_H_(0x2E, 0x79)
#define REG_SC_BK2E_7A_L      _PK_L_(0x2E, 0x7A)
#define REG_SC_BK2E_7A_H      _PK_H_(0x2E, 0x7A)
#define REG_SC_BK2E_7B_L      _PK_L_(0x2E, 0x7B)
#define REG_SC_BK2E_7B_H      _PK_H_(0x2E, 0x7B)
#define REG_SC_BK2E_7C_L      _PK_L_(0x2E, 0x7C)
#define REG_SC_BK2E_7C_H      _PK_H_(0x2E, 0x7C)
#define REG_SC_BK2E_7D_L      _PK_L_(0x2E, 0x7D)
#define REG_SC_BK2E_7D_H      _PK_H_(0x2E, 0x7D)
#define REG_SC_BK2E_7E_L      _PK_L_(0x2E, 0x7E)
#define REG_SC_BK2E_7E_H      _PK_H_(0x2E, 0x7E)
#define REG_SC_BK2E_7F_L      _PK_L_(0x2E, 0x7F)
#define REG_SC_BK2E_7F_H      _PK_H_(0x2E, 0x7F)

//----------------------------------------------
//  BK2F: VTRACK
//----------------------------------------------
#define REG_SC_BK2F_00_L      _PK_L_(0x2F, 0x00)
#define REG_SC_BK2F_00_H      _PK_H_(0x2F, 0x00)
#define REG_SC_BK2F_01_L      _PK_L_(0x2F, 0x01)
#define REG_SC_BK2F_01_H      _PK_H_(0x2F, 0x01)
#define REG_SC_BK2F_02_L      _PK_L_(0x2F, 0x02)
#define REG_SC_BK2F_02_H      _PK_H_(0x2F, 0x02)
#define REG_SC_BK2F_03_L      _PK_L_(0x2F, 0x03)
#define REG_SC_BK2F_03_H      _PK_H_(0x2F, 0x03)
#define REG_SC_BK2F_04_L      _PK_L_(0x2F, 0x04)
#define REG_SC_BK2F_04_H      _PK_H_(0x2F, 0x04)
#define REG_SC_BK2F_05_L      _PK_L_(0x2F, 0x05)
#define REG_SC_BK2F_05_H      _PK_H_(0x2F, 0x05)
#define REG_SC_BK2F_06_L      _PK_L_(0x2F, 0x06)
#define REG_SC_BK2F_06_H      _PK_H_(0x2F, 0x06)
#define REG_SC_BK2F_07_L      _PK_L_(0x2F, 0x07)
#define REG_SC_BK2F_07_H      _PK_H_(0x2F, 0x07)
#define REG_SC_BK2F_08_L      _PK_L_(0x2F, 0x08)
#define REG_SC_BK2F_08_H      _PK_H_(0x2F, 0x08)
#define REG_SC_BK2F_09_L      _PK_L_(0x2F, 0x09)
#define REG_SC_BK2F_09_H      _PK_H_(0x2F, 0x09)
#define REG_SC_BK2F_0A_L      _PK_L_(0x2F, 0x0A)
#define REG_SC_BK2F_0A_H      _PK_H_(0x2F, 0x0A)
#define REG_SC_BK2F_0B_L      _PK_L_(0x2F, 0x0B)
#define REG_SC_BK2F_0B_H      _PK_H_(0x2F, 0x0B)
#define REG_SC_BK2F_0C_L      _PK_L_(0x2F, 0x0C)
#define REG_SC_BK2F_0C_H      _PK_H_(0x2F, 0x0C)
#define REG_SC_BK2F_0D_L      _PK_L_(0x2F, 0x0D)
#define REG_SC_BK2F_0D_H      _PK_H_(0x2F, 0x0D)
#define REG_SC_BK2F_0E_L      _PK_L_(0x2F, 0x0E)
#define REG_SC_BK2F_0E_H      _PK_H_(0x2F, 0x0E)
#define REG_SC_BK2F_0F_L      _PK_L_(0x2F, 0x0F)
#define REG_SC_BK2F_0F_H      _PK_H_(0x2F, 0x0F)
#define REG_SC_BK2F_10_L      _PK_L_(0x2F, 0x10)
#define REG_SC_BK2F_10_H      _PK_H_(0x2F, 0x10)
#define REG_SC_BK2F_11_L      _PK_L_(0x2F, 0x11)
#define REG_SC_BK2F_11_H      _PK_H_(0x2F, 0x11)
#define REG_SC_BK2F_12_L      _PK_L_(0x2F, 0x12)
#define REG_SC_BK2F_12_H      _PK_H_(0x2F, 0x12)
#define REG_SC_BK2F_13_L      _PK_L_(0x2F, 0x13)
#define REG_SC_BK2F_13_H      _PK_H_(0x2F, 0x13)
#define REG_SC_BK2F_14_L      _PK_L_(0x2F, 0x14)
#define REG_SC_BK2F_14_H      _PK_H_(0x2F, 0x14)
#define REG_SC_BK2F_15_L      _PK_L_(0x2F, 0x15)
#define REG_SC_BK2F_15_H      _PK_H_(0x2F, 0x15)
#define REG_SC_BK2F_16_L      _PK_L_(0x2F, 0x16)
#define REG_SC_BK2F_16_H      _PK_H_(0x2F, 0x16)
#define REG_SC_BK2F_17_L      _PK_L_(0x2F, 0x17)
#define REG_SC_BK2F_17_H      _PK_H_(0x2F, 0x17)
#define REG_SC_BK2F_18_L      _PK_L_(0x2F, 0x18)
#define REG_SC_BK2F_18_H      _PK_H_(0x2F, 0x18)
#define REG_SC_BK2F_19_L      _PK_L_(0x2F, 0x19)
#define REG_SC_BK2F_19_H      _PK_H_(0x2F, 0x19)
#define REG_SC_BK2F_1A_L      _PK_L_(0x2F, 0x1A)
#define REG_SC_BK2F_1A_H      _PK_H_(0x2F, 0x1A)
#define REG_SC_BK2F_1B_L      _PK_L_(0x2F, 0x1B)
#define REG_SC_BK2F_1B_H      _PK_H_(0x2F, 0x1B)
#define REG_SC_BK2F_1C_L      _PK_L_(0x2F, 0x1C)
#define REG_SC_BK2F_1C_H      _PK_H_(0x2F, 0x1C)
#define REG_SC_BK2F_1D_L      _PK_L_(0x2F, 0x1D)
#define REG_SC_BK2F_1D_H      _PK_H_(0x2F, 0x1D)
#define REG_SC_BK2F_1E_L      _PK_L_(0x2F, 0x1E)
#define REG_SC_BK2F_1E_H      _PK_H_(0x2F, 0x1E)
#define REG_SC_BK2F_1F_L      _PK_L_(0x2F, 0x1F)
#define REG_SC_BK2F_1F_H      _PK_H_(0x2F, 0x1F)
#define REG_SC_BK2F_20_L      _PK_L_(0x2F, 0x20)
#define REG_SC_BK2F_20_H      _PK_H_(0x2F, 0x20)
#define REG_SC_BK2F_21_L      _PK_L_(0x2F, 0x21)
#define REG_SC_BK2F_21_H      _PK_H_(0x2F, 0x21)
#define REG_SC_BK2F_22_L      _PK_L_(0x2F, 0x22)
#define REG_SC_BK2F_22_H      _PK_H_(0x2F, 0x22)
#define REG_SC_BK2F_23_L      _PK_L_(0x2F, 0x23)
#define REG_SC_BK2F_23_H      _PK_H_(0x2F, 0x23)
#define REG_SC_BK2F_24_L      _PK_L_(0x2F, 0x24)
#define REG_SC_BK2F_24_H      _PK_H_(0x2F, 0x24)
#define REG_SC_BK2F_25_L      _PK_L_(0x2F, 0x25)
#define REG_SC_BK2F_25_H      _PK_H_(0x2F, 0x25)
#define REG_SC_BK2F_26_L      _PK_L_(0x2F, 0x26)
#define REG_SC_BK2F_26_H      _PK_H_(0x2F, 0x26)
#define REG_SC_BK2F_27_L      _PK_L_(0x2F, 0x27)
#define REG_SC_BK2F_27_H      _PK_H_(0x2F, 0x27)
#define REG_SC_BK2F_28_L      _PK_L_(0x2F, 0x28)
#define REG_SC_BK2F_28_H      _PK_H_(0x2F, 0x28)
#define REG_SC_BK2F_29_L      _PK_L_(0x2F, 0x29)
#define REG_SC_BK2F_29_H      _PK_H_(0x2F, 0x29)
#define REG_SC_BK2F_2A_L      _PK_L_(0x2F, 0x2A)
#define REG_SC_BK2F_2A_H      _PK_H_(0x2F, 0x2A)
#define REG_SC_BK2F_2B_L      _PK_L_(0x2F, 0x2B)
#define REG_SC_BK2F_2B_H      _PK_H_(0x2F, 0x2B)
#define REG_SC_BK2F_2C_L      _PK_L_(0x2F, 0x2C)
#define REG_SC_BK2F_2C_H      _PK_H_(0x2F, 0x2C)
#define REG_SC_BK2F_2D_L      _PK_L_(0x2F, 0x2D)
#define REG_SC_BK2F_2D_H      _PK_H_(0x2F, 0x2D)
#define REG_SC_BK2F_2E_L      _PK_L_(0x2F, 0x2E)
#define REG_SC_BK2F_2E_H      _PK_H_(0x2F, 0x2E)
#define REG_SC_BK2F_2F_L      _PK_L_(0x2F, 0x2F)
#define REG_SC_BK2F_2F_H      _PK_H_(0x2F, 0x2F)
#define REG_SC_BK2F_30_L      _PK_L_(0x2F, 0x30)
#define REG_SC_BK2F_30_H      _PK_H_(0x2F, 0x30)
#define REG_SC_BK2F_31_L      _PK_L_(0x2F, 0x31)
#define REG_SC_BK2F_31_H      _PK_H_(0x2F, 0x31)
#define REG_SC_BK2F_32_L      _PK_L_(0x2F, 0x32)
#define REG_SC_BK2F_32_H      _PK_H_(0x2F, 0x32)
#define REG_SC_BK2F_33_L      _PK_L_(0x2F, 0x33)
#define REG_SC_BK2F_33_H      _PK_H_(0x2F, 0x33)
#define REG_SC_BK2F_34_L      _PK_L_(0x2F, 0x34)
#define REG_SC_BK2F_34_H      _PK_H_(0x2F, 0x34)
#define REG_SC_BK2F_35_L      _PK_L_(0x2F, 0x35)
#define REG_SC_BK2F_35_H      _PK_H_(0x2F, 0x35)
#define REG_SC_BK2F_36_L      _PK_L_(0x2F, 0x36)
#define REG_SC_BK2F_36_H      _PK_H_(0x2F, 0x36)
#define REG_SC_BK2F_37_L      _PK_L_(0x2F, 0x37)
#define REG_SC_BK2F_37_H      _PK_H_(0x2F, 0x37)
#define REG_SC_BK2F_38_L      _PK_L_(0x2F, 0x38)
#define REG_SC_BK2F_38_H      _PK_H_(0x2F, 0x38)
#define REG_SC_BK2F_39_L      _PK_L_(0x2F, 0x39)
#define REG_SC_BK2F_39_H      _PK_H_(0x2F, 0x39)
#define REG_SC_BK2F_3A_L      _PK_L_(0x2F, 0x3A)
#define REG_SC_BK2F_3A_H      _PK_H_(0x2F, 0x3A)
#define REG_SC_BK2F_3B_L      _PK_L_(0x2F, 0x3B)
#define REG_SC_BK2F_3B_H      _PK_H_(0x2F, 0x3B)
#define REG_SC_BK2F_3C_L      _PK_L_(0x2F, 0x3C)
#define REG_SC_BK2F_3C_H      _PK_H_(0x2F, 0x3C)
#define REG_SC_BK2F_3D_L      _PK_L_(0x2F, 0x3D)
#define REG_SC_BK2F_3D_H      _PK_H_(0x2F, 0x3D)
#define REG_SC_BK2F_3E_L      _PK_L_(0x2F, 0x3E)
#define REG_SC_BK2F_3E_H      _PK_H_(0x2F, 0x3E)
#define REG_SC_BK2F_3F_L      _PK_L_(0x2F, 0x3F)
#define REG_SC_BK2F_3F_H      _PK_H_(0x2F, 0x3F)
#define REG_SC_BK2F_40_L      _PK_L_(0x2F, 0x40)
#define REG_SC_BK2F_40_H      _PK_H_(0x2F, 0x40)
#define REG_SC_BK2F_41_L      _PK_L_(0x2F, 0x41)
#define REG_SC_BK2F_41_H      _PK_H_(0x2F, 0x41)
#define REG_SC_BK2F_42_L      _PK_L_(0x2F, 0x42)
#define REG_SC_BK2F_42_H      _PK_H_(0x2F, 0x42)
#define REG_SC_BK2F_43_L      _PK_L_(0x2F, 0x43)
#define REG_SC_BK2F_43_H      _PK_H_(0x2F, 0x43)
#define REG_SC_BK2F_44_L      _PK_L_(0x2F, 0x44)
#define REG_SC_BK2F_44_H      _PK_H_(0x2F, 0x44)
#define REG_SC_BK2F_45_L      _PK_L_(0x2F, 0x45)
#define REG_SC_BK2F_45_H      _PK_H_(0x2F, 0x45)
#define REG_SC_BK2F_46_L      _PK_L_(0x2F, 0x46)
#define REG_SC_BK2F_46_H      _PK_H_(0x2F, 0x46)
#define REG_SC_BK2F_47_L      _PK_L_(0x2F, 0x47)
#define REG_SC_BK2F_47_H      _PK_H_(0x2F, 0x47)
#define REG_SC_BK2F_48_L      _PK_L_(0x2F, 0x48)
#define REG_SC_BK2F_48_H      _PK_H_(0x2F, 0x48)
#define REG_SC_BK2F_49_L      _PK_L_(0x2F, 0x49)
#define REG_SC_BK2F_49_H      _PK_H_(0x2F, 0x49)
#define REG_SC_BK2F_4A_L      _PK_L_(0x2F, 0x4A)
#define REG_SC_BK2F_4A_H      _PK_H_(0x2F, 0x4A)
#define REG_SC_BK2F_4B_L      _PK_L_(0x2F, 0x4B)
#define REG_SC_BK2F_4B_H      _PK_H_(0x2F, 0x4B)
#define REG_SC_BK2F_4C_L      _PK_L_(0x2F, 0x4C)
#define REG_SC_BK2F_4C_H      _PK_H_(0x2F, 0x4C)
#define REG_SC_BK2F_4D_L      _PK_L_(0x2F, 0x4D)
#define REG_SC_BK2F_4D_H      _PK_H_(0x2F, 0x4D)
#define REG_SC_BK2F_4E_L      _PK_L_(0x2F, 0x4E)
#define REG_SC_BK2F_4E_H      _PK_H_(0x2F, 0x4E)
#define REG_SC_BK2F_4F_L      _PK_L_(0x2F, 0x4F)
#define REG_SC_BK2F_4F_H      _PK_H_(0x2F, 0x4F)
#define REG_SC_BK2F_50_L      _PK_L_(0x2F, 0x50)
#define REG_SC_BK2F_50_H      _PK_H_(0x2F, 0x50)
#define REG_SC_BK2F_51_L      _PK_L_(0x2F, 0x51)
#define REG_SC_BK2F_51_H      _PK_H_(0x2F, 0x51)
#define REG_SC_BK2F_52_L      _PK_L_(0x2F, 0x52)
#define REG_SC_BK2F_52_H      _PK_H_(0x2F, 0x52)
#define REG_SC_BK2F_53_L      _PK_L_(0x2F, 0x53)
#define REG_SC_BK2F_53_H      _PK_H_(0x2F, 0x53)
#define REG_SC_BK2F_54_L      _PK_L_(0x2F, 0x54)
#define REG_SC_BK2F_54_H      _PK_H_(0x2F, 0x54)
#define REG_SC_BK2F_55_L      _PK_L_(0x2F, 0x55)
#define REG_SC_BK2F_55_H      _PK_H_(0x2F, 0x55)
#define REG_SC_BK2F_56_L      _PK_L_(0x2F, 0x56)
#define REG_SC_BK2F_56_H      _PK_H_(0x2F, 0x56)
#define REG_SC_BK2F_57_L      _PK_L_(0x2F, 0x57)
#define REG_SC_BK2F_57_H      _PK_H_(0x2F, 0x57)
#define REG_SC_BK2F_58_L      _PK_L_(0x2F, 0x58)
#define REG_SC_BK2F_58_H      _PK_H_(0x2F, 0x58)
#define REG_SC_BK2F_59_L      _PK_L_(0x2F, 0x59)
#define REG_SC_BK2F_59_H      _PK_H_(0x2F, 0x59)
#define REG_SC_BK2F_5A_L      _PK_L_(0x2F, 0x5A)
#define REG_SC_BK2F_5A_H      _PK_H_(0x2F, 0x5A)
#define REG_SC_BK2F_5B_L      _PK_L_(0x2F, 0x5B)
#define REG_SC_BK2F_5B_H      _PK_H_(0x2F, 0x5B)
#define REG_SC_BK2F_5C_L      _PK_L_(0x2F, 0x5C)
#define REG_SC_BK2F_5C_H      _PK_H_(0x2F, 0x5C)
#define REG_SC_BK2F_5D_L      _PK_L_(0x2F, 0x5D)
#define REG_SC_BK2F_5D_H      _PK_H_(0x2F, 0x5D)
#define REG_SC_BK2F_5E_L      _PK_L_(0x2F, 0x5E)
#define REG_SC_BK2F_5E_H      _PK_H_(0x2F, 0x5E)
#define REG_SC_BK2F_5F_L      _PK_L_(0x2F, 0x5F)
#define REG_SC_BK2F_5F_H      _PK_H_(0x2F, 0x5F)
#define REG_SC_BK2F_60_L      _PK_L_(0x2F, 0x60)
#define REG_SC_BK2F_60_H      _PK_H_(0x2F, 0x60)
#define REG_SC_BK2F_61_L      _PK_L_(0x2F, 0x61)
#define REG_SC_BK2F_61_H      _PK_H_(0x2F, 0x61)
#define REG_SC_BK2F_62_L      _PK_L_(0x2F, 0x62)
#define REG_SC_BK2F_62_H      _PK_H_(0x2F, 0x62)
#define REG_SC_BK2F_63_L      _PK_L_(0x2F, 0x63)
#define REG_SC_BK2F_63_H      _PK_H_(0x2F, 0x63)
#define REG_SC_BK2F_64_L      _PK_L_(0x2F, 0x64)
#define REG_SC_BK2F_64_H      _PK_H_(0x2F, 0x64)
#define REG_SC_BK2F_65_L      _PK_L_(0x2F, 0x65)
#define REG_SC_BK2F_65_H      _PK_H_(0x2F, 0x65)
#define REG_SC_BK2F_66_L      _PK_L_(0x2F, 0x66)
#define REG_SC_BK2F_66_H      _PK_H_(0x2F, 0x66)
#define REG_SC_BK2F_67_L      _PK_L_(0x2F, 0x67)
#define REG_SC_BK2F_67_H      _PK_H_(0x2F, 0x67)
#define REG_SC_BK2F_68_L      _PK_L_(0x2F, 0x68)
#define REG_SC_BK2F_68_H      _PK_H_(0x2F, 0x68)
#define REG_SC_BK2F_69_L      _PK_L_(0x2F, 0x69)
#define REG_SC_BK2F_69_H      _PK_H_(0x2F, 0x69)
#define REG_SC_BK2F_6A_L      _PK_L_(0x2F, 0x6A)
#define REG_SC_BK2F_6A_H      _PK_H_(0x2F, 0x6A)
#define REG_SC_BK2F_6B_L      _PK_L_(0x2F, 0x6B)
#define REG_SC_BK2F_6B_H      _PK_H_(0x2F, 0x6B)
#define REG_SC_BK2F_6C_L      _PK_L_(0x2F, 0x6C)
#define REG_SC_BK2F_6C_H      _PK_H_(0x2F, 0x6C)
#define REG_SC_BK2F_6D_L      _PK_L_(0x2F, 0x6D)
#define REG_SC_BK2F_6D_H      _PK_H_(0x2F, 0x6D)
#define REG_SC_BK2F_6E_L      _PK_L_(0x2F, 0x6E)
#define REG_SC_BK2F_6E_H      _PK_H_(0x2F, 0x6E)
#define REG_SC_BK2F_6F_L      _PK_L_(0x2F, 0x6F)
#define REG_SC_BK2F_6F_H      _PK_H_(0x2F, 0x6F)
#define REG_SC_BK2F_70_L      _PK_L_(0x2F, 0x70)
#define REG_SC_BK2F_70_H      _PK_H_(0x2F, 0x70)
#define REG_SC_BK2F_71_L      _PK_L_(0x2F, 0x71)
#define REG_SC_BK2F_71_H      _PK_H_(0x2F, 0x71)
#define REG_SC_BK2F_72_L      _PK_L_(0x2F, 0x72)
#define REG_SC_BK2F_72_H      _PK_H_(0x2F, 0x72)
#define REG_SC_BK2F_73_L      _PK_L_(0x2F, 0x73)
#define REG_SC_BK2F_73_H      _PK_H_(0x2F, 0x73)
#define REG_SC_BK2F_74_L      _PK_L_(0x2F, 0x74)
#define REG_SC_BK2F_74_H      _PK_H_(0x2F, 0x74)
#define REG_SC_BK2F_75_L      _PK_L_(0x2F, 0x75)
#define REG_SC_BK2F_75_H      _PK_H_(0x2F, 0x75)
#define REG_SC_BK2F_76_L      _PK_L_(0x2F, 0x76)
#define REG_SC_BK2F_76_H      _PK_H_(0x2F, 0x76)
#define REG_SC_BK2F_77_L      _PK_L_(0x2F, 0x77)
#define REG_SC_BK2F_77_H      _PK_H_(0x2F, 0x77)
#define REG_SC_BK2F_78_L      _PK_L_(0x2F, 0x78)
#define REG_SC_BK2F_78_H      _PK_H_(0x2F, 0x78)
#define REG_SC_BK2F_79_L      _PK_L_(0x2F, 0x79)
#define REG_SC_BK2F_79_H      _PK_H_(0x2F, 0x79)
#define REG_SC_BK2F_7A_L      _PK_L_(0x2F, 0x7A)
#define REG_SC_BK2F_7A_H      _PK_H_(0x2F, 0x7A)
#define REG_SC_BK2F_7B_L      _PK_L_(0x2F, 0x7B)
#define REG_SC_BK2F_7B_H      _PK_H_(0x2F, 0x7B)
#define REG_SC_BK2F_7C_L      _PK_L_(0x2F, 0x7C)
#define REG_SC_BK2F_7C_H      _PK_H_(0x2F, 0x7C)
#define REG_SC_BK2F_7D_L      _PK_L_(0x2F, 0x7D)
#define REG_SC_BK2F_7D_H      _PK_H_(0x2F, 0x7D)
#define REG_SC_BK2F_7E_L      _PK_L_(0x2F, 0x7E)
#define REG_SC_BK2F_7E_H      _PK_H_(0x2F, 0x7E)
#define REG_SC_BK2F_7F_L      _PK_L_(0x2F, 0x7F)
#define REG_SC_BK2F_7F_H      _PK_H_(0x2F, 0x7F)

//----------------------------------------------
//  BK30: DUMMY REGISTER
//----------------------------------------------
#define REG_SC_BK30_4C_L      _PK_L_(0x30, 0x4C)
#define REG_SC_BK30_4D_L      _PK_L_(0x30, 0x4D)

#define REG_SC_BK30_50_L        _PK_L_(0x30, 0x50)
//----------------------------------------------
//  BK31: FRCM2
//----------------------------------------------
#define REG_SC_BK31_00_L      _PK_L_(0x31, 0x00)
#define REG_SC_BK31_00_H      _PK_H_(0x31, 0x00)
#define REG_SC_BK31_01_L      _PK_L_(0x31, 0x01)
#define REG_SC_BK31_01_H      _PK_H_(0x31, 0x01)
#define REG_SC_BK31_02_L      _PK_L_(0x31, 0x02)
#define REG_SC_BK31_02_H      _PK_H_(0x31, 0x02)
#define REG_SC_BK31_03_L      _PK_L_(0x31, 0x03)
#define REG_SC_BK31_03_H      _PK_H_(0x31, 0x03)
#define REG_SC_BK31_04_L      _PK_L_(0x31, 0x04)
#define REG_SC_BK31_04_H      _PK_H_(0x31, 0x04)
#define REG_SC_BK31_05_L      _PK_L_(0x31, 0x05)
#define REG_SC_BK31_05_H      _PK_H_(0x31, 0x05)
#define REG_SC_BK31_06_L      _PK_L_(0x31, 0x06)
#define REG_SC_BK31_06_H      _PK_H_(0x31, 0x06)
#define REG_SC_BK31_07_L      _PK_L_(0x31, 0x07)
#define REG_SC_BK31_07_H      _PK_H_(0x31, 0x07)
#define REG_SC_BK31_08_L      _PK_L_(0x31, 0x08)
#define REG_SC_BK31_08_H      _PK_H_(0x31, 0x08)
#define REG_SC_BK31_09_L      _PK_L_(0x31, 0x09)
#define REG_SC_BK31_09_H      _PK_H_(0x31, 0x09)
#define REG_SC_BK31_0A_L      _PK_L_(0x31, 0x0A)
#define REG_SC_BK31_0A_H      _PK_H_(0x31, 0x0A)
#define REG_SC_BK31_0B_L      _PK_L_(0x31, 0x0B)
#define REG_SC_BK31_0B_H      _PK_H_(0x31, 0x0B)
#define REG_SC_BK31_0C_L      _PK_L_(0x31, 0x0C)
#define REG_SC_BK31_0C_H      _PK_H_(0x31, 0x0C)
#define REG_SC_BK31_0D_L      _PK_L_(0x31, 0x0D)
#define REG_SC_BK31_0D_H      _PK_H_(0x31, 0x0D)
#define REG_SC_BK31_0E_L      _PK_L_(0x31, 0x0E)
#define REG_SC_BK31_0E_H      _PK_H_(0x31, 0x0E)
#define REG_SC_BK31_0F_L      _PK_L_(0x31, 0x0F)
#define REG_SC_BK31_0F_H      _PK_H_(0x31, 0x0F)
#define REG_SC_BK31_10_L      _PK_L_(0x31, 0x10)
#define REG_SC_BK31_10_H      _PK_H_(0x31, 0x10)
#define REG_SC_BK31_11_L      _PK_L_(0x31, 0x11)
#define REG_SC_BK31_11_H      _PK_H_(0x31, 0x11)
#define REG_SC_BK31_12_L      _PK_L_(0x31, 0x12)
#define REG_SC_BK31_12_H      _PK_H_(0x31, 0x12)
#define REG_SC_BK31_13_L      _PK_L_(0x31, 0x13)
#define REG_SC_BK31_13_H      _PK_H_(0x31, 0x13)
#define REG_SC_BK31_14_L      _PK_L_(0x31, 0x14)
#define REG_SC_BK31_14_H      _PK_H_(0x31, 0x14)
#define REG_SC_BK31_15_L      _PK_L_(0x31, 0x15)
#define REG_SC_BK31_15_H      _PK_H_(0x31, 0x15)
#define REG_SC_BK31_16_L      _PK_L_(0x31, 0x16)
#define REG_SC_BK31_16_H      _PK_H_(0x31, 0x16)
#define REG_SC_BK31_17_L      _PK_L_(0x31, 0x17)
#define REG_SC_BK31_17_H      _PK_H_(0x31, 0x17)
#define REG_SC_BK31_18_L      _PK_L_(0x31, 0x18)
#define REG_SC_BK31_18_H      _PK_H_(0x31, 0x18)
#define REG_SC_BK31_19_L      _PK_L_(0x31, 0x19)
#define REG_SC_BK31_19_H      _PK_H_(0x31, 0x19)
#define REG_SC_BK31_1A_L      _PK_L_(0x31, 0x1A)
#define REG_SC_BK31_1A_H      _PK_H_(0x31, 0x1A)
#define REG_SC_BK31_1B_L      _PK_L_(0x31, 0x1B)
#define REG_SC_BK31_1B_H      _PK_H_(0x31, 0x1B)
#define REG_SC_BK31_1C_L      _PK_L_(0x31, 0x1C)
#define REG_SC_BK31_1C_H      _PK_H_(0x31, 0x1C)
#define REG_SC_BK31_1D_L      _PK_L_(0x31, 0x1D)
#define REG_SC_BK31_1D_H      _PK_H_(0x31, 0x1D)
#define REG_SC_BK31_1E_L      _PK_L_(0x31, 0x1E)
#define REG_SC_BK31_1E_H      _PK_H_(0x31, 0x1E)
#define REG_SC_BK31_1F_L      _PK_L_(0x31, 0x1F)
#define REG_SC_BK31_1F_H      _PK_H_(0x31, 0x1F)
#define REG_SC_BK31_20_L      _PK_L_(0x31, 0x20)
#define REG_SC_BK31_20_H      _PK_H_(0x31, 0x20)
#define REG_SC_BK31_21_L      _PK_L_(0x31, 0x21)
#define REG_SC_BK31_21_H      _PK_H_(0x31, 0x21)
#define REG_SC_BK31_22_L      _PK_L_(0x31, 0x22)
#define REG_SC_BK31_22_H      _PK_H_(0x31, 0x22)
#define REG_SC_BK31_23_L      _PK_L_(0x31, 0x23)
#define REG_SC_BK31_23_H      _PK_H_(0x31, 0x23)
#define REG_SC_BK31_24_L      _PK_L_(0x31, 0x24)
#define REG_SC_BK31_24_H      _PK_H_(0x31, 0x24)
#define REG_SC_BK31_25_L      _PK_L_(0x31, 0x25)
#define REG_SC_BK31_25_H      _PK_H_(0x31, 0x25)
#define REG_SC_BK31_26_L      _PK_L_(0x31, 0x26)
#define REG_SC_BK31_26_H      _PK_H_(0x31, 0x26)
#define REG_SC_BK31_27_L      _PK_L_(0x31, 0x27)
#define REG_SC_BK31_27_H      _PK_H_(0x31, 0x27)
#define REG_SC_BK31_28_L      _PK_L_(0x31, 0x28)
#define REG_SC_BK31_28_H      _PK_H_(0x31, 0x28)
#define REG_SC_BK31_29_L      _PK_L_(0x31, 0x29)
#define REG_SC_BK31_29_H      _PK_H_(0x31, 0x29)
#define REG_SC_BK31_2A_L      _PK_L_(0x31, 0x2A)
#define REG_SC_BK31_2A_H      _PK_H_(0x31, 0x2A)
#define REG_SC_BK31_2B_L      _PK_L_(0x31, 0x2B)
#define REG_SC_BK31_2B_H      _PK_H_(0x31, 0x2B)
#define REG_SC_BK31_2C_L      _PK_L_(0x31, 0x2C)
#define REG_SC_BK31_2C_H      _PK_H_(0x31, 0x2C)
#define REG_SC_BK31_2D_L      _PK_L_(0x31, 0x2D)
#define REG_SC_BK31_2D_H      _PK_H_(0x31, 0x2D)
#define REG_SC_BK31_2E_L      _PK_L_(0x31, 0x2E)
#define REG_SC_BK31_2E_H      _PK_H_(0x31, 0x2E)
#define REG_SC_BK31_2F_L      _PK_L_(0x31, 0x2F)
#define REG_SC_BK31_2F_H      _PK_H_(0x31, 0x2F)
#define REG_SC_BK31_30_L      _PK_L_(0x31, 0x30)
#define REG_SC_BK31_30_H      _PK_H_(0x31, 0x30)
#define REG_SC_BK31_31_L      _PK_L_(0x31, 0x31)
#define REG_SC_BK31_31_H      _PK_H_(0x31, 0x31)
#define REG_SC_BK31_32_L      _PK_L_(0x31, 0x32)
#define REG_SC_BK31_32_H      _PK_H_(0x31, 0x32)
#define REG_SC_BK31_33_L      _PK_L_(0x31, 0x33)
#define REG_SC_BK31_33_H      _PK_H_(0x31, 0x33)
#define REG_SC_BK31_34_L      _PK_L_(0x31, 0x34)
#define REG_SC_BK31_34_H      _PK_H_(0x31, 0x34)
#define REG_SC_BK31_35_L      _PK_L_(0x31, 0x35)
#define REG_SC_BK31_35_H      _PK_H_(0x31, 0x35)
#define REG_SC_BK31_36_L      _PK_L_(0x31, 0x36)
#define REG_SC_BK31_36_H      _PK_H_(0x31, 0x36)
#define REG_SC_BK31_37_L      _PK_L_(0x31, 0x37)
#define REG_SC_BK31_37_H      _PK_H_(0x31, 0x37)
#define REG_SC_BK31_38_L      _PK_L_(0x31, 0x38)
#define REG_SC_BK31_38_H      _PK_H_(0x31, 0x38)
#define REG_SC_BK31_39_L      _PK_L_(0x31, 0x39)
#define REG_SC_BK31_39_H      _PK_H_(0x31, 0x39)
#define REG_SC_BK31_3A_L      _PK_L_(0x31, 0x3A)
#define REG_SC_BK31_3A_H      _PK_H_(0x31, 0x3A)
#define REG_SC_BK31_3B_L      _PK_L_(0x31, 0x3B)
#define REG_SC_BK31_3B_H      _PK_H_(0x31, 0x3B)
#define REG_SC_BK31_3C_L      _PK_L_(0x31, 0x3C)
#define REG_SC_BK31_3C_H      _PK_H_(0x31, 0x3C)
#define REG_SC_BK31_3D_L      _PK_L_(0x31, 0x3D)
#define REG_SC_BK31_3D_H      _PK_H_(0x31, 0x3D)
#define REG_SC_BK31_3E_L      _PK_L_(0x31, 0x3E)
#define REG_SC_BK31_3E_H      _PK_H_(0x31, 0x3E)
#define REG_SC_BK31_3F_L      _PK_L_(0x31, 0x3F)
#define REG_SC_BK31_3F_H      _PK_H_(0x31, 0x3F)
#define REG_SC_BK31_40_L      _PK_L_(0x31, 0x40)
#define REG_SC_BK31_40_H      _PK_H_(0x31, 0x40)
#define REG_SC_BK31_41_L      _PK_L_(0x31, 0x41)
#define REG_SC_BK31_41_H      _PK_H_(0x31, 0x41)
#define REG_SC_BK31_42_L      _PK_L_(0x31, 0x42)
#define REG_SC_BK31_42_H      _PK_H_(0x31, 0x42)
#define REG_SC_BK31_43_L      _PK_L_(0x31, 0x43)
#define REG_SC_BK31_43_H      _PK_H_(0x31, 0x43)
#define REG_SC_BK31_44_L      _PK_L_(0x31, 0x44)
#define REG_SC_BK31_44_H      _PK_H_(0x31, 0x44)
#define REG_SC_BK31_45_L      _PK_L_(0x31, 0x45)
#define REG_SC_BK31_45_H      _PK_H_(0x31, 0x45)
#define REG_SC_BK31_46_L      _PK_L_(0x31, 0x46)
#define REG_SC_BK31_46_H      _PK_H_(0x31, 0x46)
#define REG_SC_BK31_47_L      _PK_L_(0x31, 0x47)
#define REG_SC_BK31_47_H      _PK_H_(0x31, 0x47)
#define REG_SC_BK31_48_L      _PK_L_(0x31, 0x48)
#define REG_SC_BK31_48_H      _PK_H_(0x31, 0x48)
#define REG_SC_BK31_49_L      _PK_L_(0x31, 0x49)
#define REG_SC_BK31_49_H      _PK_H_(0x31, 0x49)
#define REG_SC_BK31_4A_L      _PK_L_(0x31, 0x4A)
#define REG_SC_BK31_4A_H      _PK_H_(0x31, 0x4A)
#define REG_SC_BK31_4B_L      _PK_L_(0x31, 0x4B)
#define REG_SC_BK31_4B_H      _PK_H_(0x31, 0x4B)
#define REG_SC_BK31_4C_L      _PK_L_(0x31, 0x4C)
#define REG_SC_BK31_4C_H      _PK_H_(0x31, 0x4C)
#define REG_SC_BK31_4D_L      _PK_L_(0x31, 0x4D)
#define REG_SC_BK31_4D_H      _PK_H_(0x31, 0x4D)
#define REG_SC_BK31_4E_L      _PK_L_(0x31, 0x4E)
#define REG_SC_BK31_4E_H      _PK_H_(0x31, 0x4E)
#define REG_SC_BK31_4F_L      _PK_L_(0x31, 0x4F)
#define REG_SC_BK31_4F_H      _PK_H_(0x31, 0x4F)
#define REG_SC_BK31_50_L      _PK_L_(0x31, 0x50)
#define REG_SC_BK31_50_H      _PK_H_(0x31, 0x50)
#define REG_SC_BK31_51_L      _PK_L_(0x31, 0x51)
#define REG_SC_BK31_51_H      _PK_H_(0x31, 0x51)
#define REG_SC_BK31_52_L      _PK_L_(0x31, 0x52)
#define REG_SC_BK31_52_H      _PK_H_(0x31, 0x52)
#define REG_SC_BK31_53_L      _PK_L_(0x31, 0x53)
#define REG_SC_BK31_53_H      _PK_H_(0x31, 0x53)
#define REG_SC_BK31_54_L      _PK_L_(0x31, 0x54)
#define REG_SC_BK31_54_H      _PK_H_(0x31, 0x54)
#define REG_SC_BK31_55_L      _PK_L_(0x31, 0x55)
#define REG_SC_BK31_55_H      _PK_H_(0x31, 0x55)
#define REG_SC_BK31_56_L      _PK_L_(0x31, 0x56)
#define REG_SC_BK31_56_H      _PK_H_(0x31, 0x56)
#define REG_SC_BK31_57_L      _PK_L_(0x31, 0x57)
#define REG_SC_BK31_57_H      _PK_H_(0x31, 0x57)
#define REG_SC_BK31_58_L      _PK_L_(0x31, 0x58)
#define REG_SC_BK31_58_H      _PK_H_(0x31, 0x58)
#define REG_SC_BK31_59_L      _PK_L_(0x31, 0x59)
#define REG_SC_BK31_59_H      _PK_H_(0x31, 0x59)
#define REG_SC_BK31_5A_L      _PK_L_(0x31, 0x5A)
#define REG_SC_BK31_5A_H      _PK_H_(0x31, 0x5A)
#define REG_SC_BK31_5B_L      _PK_L_(0x31, 0x5B)
#define REG_SC_BK31_5B_H      _PK_H_(0x31, 0x5B)
#define REG_SC_BK31_5C_L      _PK_L_(0x31, 0x5C)
#define REG_SC_BK31_5C_H      _PK_H_(0x31, 0x5C)
#define REG_SC_BK31_5D_L      _PK_L_(0x31, 0x5D)
#define REG_SC_BK31_5D_H      _PK_H_(0x31, 0x5D)
#define REG_SC_BK31_5E_L      _PK_L_(0x31, 0x5E)
#define REG_SC_BK31_5E_H      _PK_H_(0x31, 0x5E)
#define REG_SC_BK31_5F_L      _PK_L_(0x31, 0x5F)
#define REG_SC_BK31_5F_H      _PK_H_(0x31, 0x5F)
#define REG_SC_BK31_60_L      _PK_L_(0x31, 0x60)
#define REG_SC_BK31_60_H      _PK_H_(0x31, 0x60)
#define REG_SC_BK31_61_L      _PK_L_(0x31, 0x61)
#define REG_SC_BK31_61_H      _PK_H_(0x31, 0x61)
#define REG_SC_BK31_62_L      _PK_L_(0x31, 0x62)
#define REG_SC_BK31_62_H      _PK_H_(0x31, 0x62)
#define REG_SC_BK31_63_L      _PK_L_(0x31, 0x63)
#define REG_SC_BK31_63_H      _PK_H_(0x31, 0x63)
#define REG_SC_BK31_64_L      _PK_L_(0x31, 0x64)
#define REG_SC_BK31_64_H      _PK_H_(0x31, 0x64)
#define REG_SC_BK31_65_L      _PK_L_(0x31, 0x65)
#define REG_SC_BK31_65_H      _PK_H_(0x31, 0x65)
#define REG_SC_BK31_66_L      _PK_L_(0x31, 0x66)
#define REG_SC_BK31_66_H      _PK_H_(0x31, 0x66)
#define REG_SC_BK31_67_L      _PK_L_(0x31, 0x67)
#define REG_SC_BK31_67_H      _PK_H_(0x31, 0x67)
#define REG_SC_BK31_68_L      _PK_L_(0x31, 0x68)
#define REG_SC_BK31_68_H      _PK_H_(0x31, 0x68)
#define REG_SC_BK31_69_L      _PK_L_(0x31, 0x69)
#define REG_SC_BK31_69_H      _PK_H_(0x31, 0x69)
#define REG_SC_BK31_6A_L      _PK_L_(0x31, 0x6A)
#define REG_SC_BK31_6A_H      _PK_H_(0x31, 0x6A)
#define REG_SC_BK31_6B_L      _PK_L_(0x31, 0x6B)
#define REG_SC_BK31_6B_H      _PK_H_(0x31, 0x6B)
#define REG_SC_BK31_6C_L      _PK_L_(0x31, 0x6C)
#define REG_SC_BK31_6C_H      _PK_H_(0x31, 0x6C)
#define REG_SC_BK31_6D_L      _PK_L_(0x31, 0x6D)
#define REG_SC_BK31_6D_H      _PK_H_(0x31, 0x6D)
#define REG_SC_BK31_6E_L      _PK_L_(0x31, 0x6E)
#define REG_SC_BK31_6E_H      _PK_H_(0x31, 0x6E)
#define REG_SC_BK31_6F_L      _PK_L_(0x31, 0x6F)
#define REG_SC_BK31_6F_H      _PK_H_(0x31, 0x6F)
#define REG_SC_BK31_70_L      _PK_L_(0x31, 0x70)
#define REG_SC_BK31_70_H      _PK_H_(0x31, 0x70)
#define REG_SC_BK31_71_L      _PK_L_(0x31, 0x71)
#define REG_SC_BK31_71_H      _PK_H_(0x31, 0x71)
#define REG_SC_BK31_72_L      _PK_L_(0x31, 0x72)
#define REG_SC_BK31_72_H      _PK_H_(0x31, 0x72)
#define REG_SC_BK31_73_L      _PK_L_(0x31, 0x73)
#define REG_SC_BK31_73_H      _PK_H_(0x31, 0x73)
#define REG_SC_BK31_74_L      _PK_L_(0x31, 0x74)
#define REG_SC_BK31_74_H      _PK_H_(0x31, 0x74)
#define REG_SC_BK31_75_L      _PK_L_(0x31, 0x75)
#define REG_SC_BK31_75_H      _PK_H_(0x31, 0x75)
#define REG_SC_BK31_76_L      _PK_L_(0x31, 0x76)
#define REG_SC_BK31_76_H      _PK_H_(0x31, 0x76)
#define REG_SC_BK31_77_L      _PK_L_(0x31, 0x77)
#define REG_SC_BK31_77_H      _PK_H_(0x31, 0x77)
#define REG_SC_BK31_78_L      _PK_L_(0x31, 0x78)
#define REG_SC_BK31_78_H      _PK_H_(0x31, 0x78)
#define REG_SC_BK31_79_L      _PK_L_(0x31, 0x79)
#define REG_SC_BK31_79_H      _PK_H_(0x31, 0x79)
#define REG_SC_BK31_7A_L      _PK_L_(0x31, 0x7A)
#define REG_SC_BK31_7A_H      _PK_H_(0x31, 0x7A)
#define REG_SC_BK31_7B_L      _PK_L_(0x31, 0x7B)
#define REG_SC_BK31_7B_H      _PK_H_(0x31, 0x7B)
#define REG_SC_BK31_7C_L      _PK_L_(0x31, 0x7C)
#define REG_SC_BK31_7C_H      _PK_H_(0x31, 0x7C)
#define REG_SC_BK31_7D_L      _PK_L_(0x31, 0x7D)
#define REG_SC_BK31_7D_H      _PK_H_(0x31, 0x7D)
#define REG_SC_BK31_7E_L      _PK_L_(0x31, 0x7E)
#define REG_SC_BK31_7E_H      _PK_H_(0x31, 0x7E)
#define REG_SC_BK31_7F_L      _PK_L_(0x31, 0x7F)
#define REG_SC_BK31_7F_H      _PK_H_(0x31, 0x7F)

//----------------------------------------------
//  BK32: FRCM
//----------------------------------------------
#define REG_SC_BK32_00_L      _PK_L_(0x32, 0x00)
#define REG_SC_BK32_00_H      _PK_H_(0x32, 0x00)
#define REG_SC_BK32_01_L      _PK_L_(0x32, 0x01)
#define REG_SC_BK32_01_H      _PK_H_(0x32, 0x01)
#define REG_SC_BK32_02_L      _PK_L_(0x32, 0x02)
#define REG_SC_BK32_02_H      _PK_H_(0x32, 0x02)
#define REG_SC_BK32_03_L      _PK_L_(0x32, 0x03)
#define REG_SC_BK32_03_H      _PK_H_(0x32, 0x03)
#define REG_SC_BK32_04_L      _PK_L_(0x32, 0x04)
#define REG_SC_BK32_04_H      _PK_H_(0x32, 0x04)
#define REG_SC_BK32_05_L      _PK_L_(0x32, 0x05)
#define REG_SC_BK32_05_H      _PK_H_(0x32, 0x05)
#define REG_SC_BK32_06_L      _PK_L_(0x32, 0x06)
#define REG_SC_BK32_06_H      _PK_H_(0x32, 0x06)
#define REG_SC_BK32_07_L      _PK_L_(0x32, 0x07)
#define REG_SC_BK32_07_H      _PK_H_(0x32, 0x07)
#define REG_SC_BK32_08_L      _PK_L_(0x32, 0x08)
#define REG_SC_BK32_08_H      _PK_H_(0x32, 0x08)
#define REG_SC_BK32_09_L      _PK_L_(0x32, 0x09)
#define REG_SC_BK32_09_H      _PK_H_(0x32, 0x09)
#define REG_SC_BK32_0A_L      _PK_L_(0x32, 0x0A)
#define REG_SC_BK32_0A_H      _PK_H_(0x32, 0x0A)
#define REG_SC_BK32_0B_L      _PK_L_(0x32, 0x0B)
#define REG_SC_BK32_0B_H      _PK_H_(0x32, 0x0B)
#define REG_SC_BK32_0C_L      _PK_L_(0x32, 0x0C)
#define REG_SC_BK32_0C_H      _PK_H_(0x32, 0x0C)
#define REG_SC_BK32_0D_L      _PK_L_(0x32, 0x0D)
#define REG_SC_BK32_0D_H      _PK_H_(0x32, 0x0D)
#define REG_SC_BK32_0E_L      _PK_L_(0x32, 0x0E)
#define REG_SC_BK32_0E_H      _PK_H_(0x32, 0x0E)
#define REG_SC_BK32_0F_L      _PK_L_(0x32, 0x0F)
#define REG_SC_BK32_0F_H      _PK_H_(0x32, 0x0F)
#define REG_SC_BK32_10_L      _PK_L_(0x32, 0x10)
#define REG_SC_BK32_10_H      _PK_H_(0x32, 0x10)
#define REG_SC_BK32_11_L      _PK_L_(0x32, 0x11)
#define REG_SC_BK32_11_H      _PK_H_(0x32, 0x11)
#define REG_SC_BK32_12_L      _PK_L_(0x32, 0x12)
#define REG_SC_BK32_12_H      _PK_H_(0x32, 0x12)
#define REG_SC_BK32_13_L      _PK_L_(0x32, 0x13)
#define REG_SC_BK32_13_H      _PK_H_(0x32, 0x13)
#define REG_SC_BK32_14_L      _PK_L_(0x32, 0x14)
#define REG_SC_BK32_14_H      _PK_H_(0x32, 0x14)
#define REG_SC_BK32_15_L      _PK_L_(0x32, 0x15)
#define REG_SC_BK32_15_H      _PK_H_(0x32, 0x15)
#define REG_SC_BK32_16_L      _PK_L_(0x32, 0x16)
#define REG_SC_BK32_16_H      _PK_H_(0x32, 0x16)
#define REG_SC_BK32_17_L      _PK_L_(0x32, 0x17)
#define REG_SC_BK32_17_H      _PK_H_(0x32, 0x17)
#define REG_SC_BK32_18_L      _PK_L_(0x32, 0x18)
#define REG_SC_BK32_18_H      _PK_H_(0x32, 0x18)
#define REG_SC_BK32_19_L      _PK_L_(0x32, 0x19)
#define REG_SC_BK32_19_H      _PK_H_(0x32, 0x19)
#define REG_SC_BK32_1A_L      _PK_L_(0x32, 0x1A)
#define REG_SC_BK32_1A_H      _PK_H_(0x32, 0x1A)
#define REG_SC_BK32_1B_L      _PK_L_(0x32, 0x1B)
#define REG_SC_BK32_1B_H      _PK_H_(0x32, 0x1B)
#define REG_SC_BK32_1C_L      _PK_L_(0x32, 0x1C)
#define REG_SC_BK32_1C_H      _PK_H_(0x32, 0x1C)
#define REG_SC_BK32_1D_L      _PK_L_(0x32, 0x1D)
#define REG_SC_BK32_1D_H      _PK_H_(0x32, 0x1D)
#define REG_SC_BK32_1E_L      _PK_L_(0x32, 0x1E)
#define REG_SC_BK32_1E_H      _PK_H_(0x32, 0x1E)
#define REG_SC_BK32_1F_L      _PK_L_(0x32, 0x1F)
#define REG_SC_BK32_1F_H      _PK_H_(0x32, 0x1F)
#define REG_SC_BK32_20_L      _PK_L_(0x32, 0x20)
#define REG_SC_BK32_20_H      _PK_H_(0x32, 0x20)
#define REG_SC_BK32_21_L      _PK_L_(0x32, 0x21)
#define REG_SC_BK32_21_H      _PK_H_(0x32, 0x21)
#define REG_SC_BK32_22_L      _PK_L_(0x32, 0x22)
#define REG_SC_BK32_22_H      _PK_H_(0x32, 0x22)
#define REG_SC_BK32_23_L      _PK_L_(0x32, 0x23)
#define REG_SC_BK32_23_H      _PK_H_(0x32, 0x23)
#define REG_SC_BK32_24_L      _PK_L_(0x32, 0x24)
#define REG_SC_BK32_24_H      _PK_H_(0x32, 0x24)
#define REG_SC_BK32_25_L      _PK_L_(0x32, 0x25)
#define REG_SC_BK32_25_H      _PK_H_(0x32, 0x25)
#define REG_SC_BK32_26_L      _PK_L_(0x32, 0x26)
#define REG_SC_BK32_26_H      _PK_H_(0x32, 0x26)
#define REG_SC_BK32_27_L      _PK_L_(0x32, 0x27)
#define REG_SC_BK32_27_H      _PK_H_(0x32, 0x27)
#define REG_SC_BK32_28_L      _PK_L_(0x32, 0x28)
#define REG_SC_BK32_28_H      _PK_H_(0x32, 0x28)
#define REG_SC_BK32_29_L      _PK_L_(0x32, 0x29)
#define REG_SC_BK32_29_H      _PK_H_(0x32, 0x29)
#define REG_SC_BK32_2A_L      _PK_L_(0x32, 0x2A)
#define REG_SC_BK32_2A_H      _PK_H_(0x32, 0x2A)
#define REG_SC_BK32_2B_L      _PK_L_(0x32, 0x2B)
#define REG_SC_BK32_2B_H      _PK_H_(0x32, 0x2B)
#define REG_SC_BK32_2C_L      _PK_L_(0x32, 0x2C)
#define REG_SC_BK32_2C_H      _PK_H_(0x32, 0x2C)
#define REG_SC_BK32_2D_L      _PK_L_(0x32, 0x2D)
#define REG_SC_BK32_2D_H      _PK_H_(0x32, 0x2D)
#define REG_SC_BK32_2E_L      _PK_L_(0x32, 0x2E)
#define REG_SC_BK32_2E_H      _PK_H_(0x32, 0x2E)
#define REG_SC_BK32_2F_L      _PK_L_(0x32, 0x2F)
#define REG_SC_BK32_2F_H      _PK_H_(0x32, 0x2F)
#define REG_SC_BK32_30_L      _PK_L_(0x32, 0x30)
#define REG_SC_BK32_30_H      _PK_H_(0x32, 0x30)
#define REG_SC_BK32_31_L      _PK_L_(0x32, 0x31)
#define REG_SC_BK32_31_H      _PK_H_(0x32, 0x31)
#define REG_SC_BK32_32_L      _PK_L_(0x32, 0x32)
#define REG_SC_BK32_32_H      _PK_H_(0x32, 0x32)
#define REG_SC_BK32_33_L      _PK_L_(0x32, 0x33)
#define REG_SC_BK32_33_H      _PK_H_(0x32, 0x33)
#define REG_SC_BK32_34_L      _PK_L_(0x32, 0x34)
#define REG_SC_BK32_34_H      _PK_H_(0x32, 0x34)
#define REG_SC_BK32_35_L      _PK_L_(0x32, 0x35)
#define REG_SC_BK32_35_H      _PK_H_(0x32, 0x35)
#define REG_SC_BK32_36_L      _PK_L_(0x32, 0x36)
#define REG_SC_BK32_36_H      _PK_H_(0x32, 0x36)
#define REG_SC_BK32_37_L      _PK_L_(0x32, 0x37)
#define REG_SC_BK32_37_H      _PK_H_(0x32, 0x37)
#define REG_SC_BK32_38_L      _PK_L_(0x32, 0x38)
#define REG_SC_BK32_38_H      _PK_H_(0x32, 0x38)
#define REG_SC_BK32_39_L      _PK_L_(0x32, 0x39)
#define REG_SC_BK32_39_H      _PK_H_(0x32, 0x39)
#define REG_SC_BK32_3A_L      _PK_L_(0x32, 0x3A)
#define REG_SC_BK32_3A_H      _PK_H_(0x32, 0x3A)
#define REG_SC_BK32_3B_L      _PK_L_(0x32, 0x3B)
#define REG_SC_BK32_3B_H      _PK_H_(0x32, 0x3B)
#define REG_SC_BK32_3C_L      _PK_L_(0x32, 0x3C)
#define REG_SC_BK32_3C_H      _PK_H_(0x32, 0x3C)
#define REG_SC_BK32_3D_L      _PK_L_(0x32, 0x3D)
#define REG_SC_BK32_3D_H      _PK_H_(0x32, 0x3D)
#define REG_SC_BK32_3E_L      _PK_L_(0x32, 0x3E)
#define REG_SC_BK32_3E_H      _PK_H_(0x32, 0x3E)
#define REG_SC_BK32_3F_L      _PK_L_(0x32, 0x3F)
#define REG_SC_BK32_3F_H      _PK_H_(0x32, 0x3F)
#define REG_SC_BK32_40_L      _PK_L_(0x32, 0x40)
#define REG_SC_BK32_40_H      _PK_H_(0x32, 0x40)
#define REG_SC_BK32_41_L      _PK_L_(0x32, 0x41)
#define REG_SC_BK32_41_H      _PK_H_(0x32, 0x41)
#define REG_SC_BK32_42_L      _PK_L_(0x32, 0x42)
#define REG_SC_BK32_42_H      _PK_H_(0x32, 0x42)
#define REG_SC_BK32_43_L      _PK_L_(0x32, 0x43)
#define REG_SC_BK32_43_H      _PK_H_(0x32, 0x43)
#define REG_SC_BK32_44_L      _PK_L_(0x32, 0x44)
#define REG_SC_BK32_44_H      _PK_H_(0x32, 0x44)
#define REG_SC_BK32_45_L      _PK_L_(0x32, 0x45)
#define REG_SC_BK32_45_H      _PK_H_(0x32, 0x45)
#define REG_SC_BK32_46_L      _PK_L_(0x32, 0x46)
#define REG_SC_BK32_46_H      _PK_H_(0x32, 0x46)
#define REG_SC_BK32_47_L      _PK_L_(0x32, 0x47)
#define REG_SC_BK32_47_H      _PK_H_(0x32, 0x47)
#define REG_SC_BK32_48_L      _PK_L_(0x32, 0x48)
#define REG_SC_BK32_48_H      _PK_H_(0x32, 0x48)
#define REG_SC_BK32_49_L      _PK_L_(0x32, 0x49)
#define REG_SC_BK32_49_H      _PK_H_(0x32, 0x49)
#define REG_SC_BK32_4A_L      _PK_L_(0x32, 0x4A)
#define REG_SC_BK32_4A_H      _PK_H_(0x32, 0x4A)
#define REG_SC_BK32_4B_L      _PK_L_(0x32, 0x4B)
#define REG_SC_BK32_4B_H      _PK_H_(0x32, 0x4B)
#define REG_SC_BK32_4C_L      _PK_L_(0x32, 0x4C)
#define REG_SC_BK32_4C_H      _PK_H_(0x32, 0x4C)
#define REG_SC_BK32_4D_L      _PK_L_(0x32, 0x4D)
#define REG_SC_BK32_4D_H      _PK_H_(0x32, 0x4D)
#define REG_SC_BK32_4E_L      _PK_L_(0x32, 0x4E)
#define REG_SC_BK32_4E_H      _PK_H_(0x32, 0x4E)
#define REG_SC_BK32_4F_L      _PK_L_(0x32, 0x4F)
#define REG_SC_BK32_4F_H      _PK_H_(0x32, 0x4F)
#define REG_SC_BK32_50_L      _PK_L_(0x32, 0x50)
#define REG_SC_BK32_50_H      _PK_H_(0x32, 0x50)
#define REG_SC_BK32_51_L      _PK_L_(0x32, 0x51)
#define REG_SC_BK32_51_H      _PK_H_(0x32, 0x51)
#define REG_SC_BK32_52_L      _PK_L_(0x32, 0x52)
#define REG_SC_BK32_52_H      _PK_H_(0x32, 0x52)
#define REG_SC_BK32_53_L      _PK_L_(0x32, 0x53)
#define REG_SC_BK32_53_H      _PK_H_(0x32, 0x53)
#define REG_SC_BK32_54_L      _PK_L_(0x32, 0x54)
#define REG_SC_BK32_54_H      _PK_H_(0x32, 0x54)
#define REG_SC_BK32_55_L      _PK_L_(0x32, 0x55)
#define REG_SC_BK32_55_H      _PK_H_(0x32, 0x55)
#define REG_SC_BK32_56_L      _PK_L_(0x32, 0x56)
#define REG_SC_BK32_56_H      _PK_H_(0x32, 0x56)
#define REG_SC_BK32_57_L      _PK_L_(0x32, 0x57)
#define REG_SC_BK32_57_H      _PK_H_(0x32, 0x57)
#define REG_SC_BK32_58_L      _PK_L_(0x32, 0x58)
#define REG_SC_BK32_58_H      _PK_H_(0x32, 0x58)
#define REG_SC_BK32_59_L      _PK_L_(0x32, 0x59)
#define REG_SC_BK32_59_H      _PK_H_(0x32, 0x59)
#define REG_SC_BK32_5A_L      _PK_L_(0x32, 0x5A)
#define REG_SC_BK32_5A_H      _PK_H_(0x32, 0x5A)
#define REG_SC_BK32_5B_L      _PK_L_(0x32, 0x5B)
#define REG_SC_BK32_5B_H      _PK_H_(0x32, 0x5B)
#define REG_SC_BK32_5C_L      _PK_L_(0x32, 0x5C)
#define REG_SC_BK32_5C_H      _PK_H_(0x32, 0x5C)
#define REG_SC_BK32_5D_L      _PK_L_(0x32, 0x5D)
#define REG_SC_BK32_5D_H      _PK_H_(0x32, 0x5D)
#define REG_SC_BK32_5E_L      _PK_L_(0x32, 0x5E)
#define REG_SC_BK32_5E_H      _PK_H_(0x32, 0x5E)
#define REG_SC_BK32_5F_L      _PK_L_(0x32, 0x5F)
#define REG_SC_BK32_5F_H      _PK_H_(0x32, 0x5F)
#define REG_SC_BK32_60_L      _PK_L_(0x32, 0x60)
#define REG_SC_BK32_60_H      _PK_H_(0x32, 0x60)
#define REG_SC_BK32_61_L      _PK_L_(0x32, 0x61)
#define REG_SC_BK32_61_H      _PK_H_(0x32, 0x61)
#define REG_SC_BK32_62_L      _PK_L_(0x32, 0x62)
#define REG_SC_BK32_62_H      _PK_H_(0x32, 0x62)
#define REG_SC_BK32_63_L      _PK_L_(0x32, 0x63)
#define REG_SC_BK32_63_H      _PK_H_(0x32, 0x63)
#define REG_SC_BK32_64_L      _PK_L_(0x32, 0x64)
#define REG_SC_BK32_64_H      _PK_H_(0x32, 0x64)
#define REG_SC_BK32_65_L      _PK_L_(0x32, 0x65)
#define REG_SC_BK32_65_H      _PK_H_(0x32, 0x65)
#define REG_SC_BK32_66_L      _PK_L_(0x32, 0x66)
#define REG_SC_BK32_66_H      _PK_H_(0x32, 0x66)
#define REG_SC_BK32_67_L      _PK_L_(0x32, 0x67)
#define REG_SC_BK32_67_H      _PK_H_(0x32, 0x67)
#define REG_SC_BK32_68_L      _PK_L_(0x32, 0x68)
#define REG_SC_BK32_68_H      _PK_H_(0x32, 0x68)
#define REG_SC_BK32_69_L      _PK_L_(0x32, 0x69)
#define REG_SC_BK32_69_H      _PK_H_(0x32, 0x69)
#define REG_SC_BK32_6A_L      _PK_L_(0x32, 0x6A)
#define REG_SC_BK32_6A_H      _PK_H_(0x32, 0x6A)
#define REG_SC_BK32_6B_L      _PK_L_(0x32, 0x6B)
#define REG_SC_BK32_6B_H      _PK_H_(0x32, 0x6B)
#define REG_SC_BK32_6C_L      _PK_L_(0x32, 0x6C)
#define REG_SC_BK32_6C_H      _PK_H_(0x32, 0x6C)
#define REG_SC_BK32_6D_L      _PK_L_(0x32, 0x6D)
#define REG_SC_BK32_6D_H      _PK_H_(0x32, 0x6D)
#define REG_SC_BK32_6E_L      _PK_L_(0x32, 0x6E)
#define REG_SC_BK32_6E_H      _PK_H_(0x32, 0x6E)
#define REG_SC_BK32_6F_L      _PK_L_(0x32, 0x6F)
#define REG_SC_BK32_6F_H      _PK_H_(0x32, 0x6F)
#define REG_SC_BK32_70_L      _PK_L_(0x32, 0x70)
#define REG_SC_BK32_70_H      _PK_H_(0x32, 0x70)
#define REG_SC_BK32_71_L      _PK_L_(0x32, 0x71)
#define REG_SC_BK32_71_H      _PK_H_(0x32, 0x71)
#define REG_SC_BK32_72_L      _PK_L_(0x32, 0x72)
#define REG_SC_BK32_72_H      _PK_H_(0x32, 0x72)
#define REG_SC_BK32_73_L      _PK_L_(0x32, 0x73)
#define REG_SC_BK32_73_H      _PK_H_(0x32, 0x73)
#define REG_SC_BK32_74_L      _PK_L_(0x32, 0x74)
#define REG_SC_BK32_74_H      _PK_H_(0x32, 0x74)
#define REG_SC_BK32_75_L      _PK_L_(0x32, 0x75)
#define REG_SC_BK32_75_H      _PK_H_(0x32, 0x75)
#define REG_SC_BK32_76_L      _PK_L_(0x32, 0x76)
#define REG_SC_BK32_76_H      _PK_H_(0x32, 0x76)
#define REG_SC_BK32_77_L      _PK_L_(0x32, 0x77)
#define REG_SC_BK32_77_H      _PK_H_(0x32, 0x77)
#define REG_SC_BK32_78_L      _PK_L_(0x32, 0x78)
#define REG_SC_BK32_78_H      _PK_H_(0x32, 0x78)
#define REG_SC_BK32_79_L      _PK_L_(0x32, 0x79)
#define REG_SC_BK32_79_H      _PK_H_(0x32, 0x79)
#define REG_SC_BK32_7A_L      _PK_L_(0x32, 0x7A)
#define REG_SC_BK32_7A_H      _PK_H_(0x32, 0x7A)
#define REG_SC_BK32_7B_L      _PK_L_(0x32, 0x7B)
#define REG_SC_BK32_7B_H      _PK_H_(0x32, 0x7B)
#define REG_SC_BK32_7C_L      _PK_L_(0x32, 0x7C)
#define REG_SC_BK32_7C_H      _PK_H_(0x32, 0x7C)
#define REG_SC_BK32_7D_L      _PK_L_(0x32, 0x7D)
#define REG_SC_BK32_7D_H      _PK_H_(0x32, 0x7D)
#define REG_SC_BK32_7E_L      _PK_L_(0x32, 0x7E)
#define REG_SC_BK32_7E_H      _PK_H_(0x32, 0x7E)
#define REG_SC_BK32_7F_L      _PK_L_(0x32, 0x7F)
#define REG_SC_BK32_7F_H      _PK_H_(0x32, 0x7F)

//----------------------------------------------
//  BK33: IP1_S2
//----------------------------------------------
#define REG_SC_BK33_00_L      _PK_L_(0x33, 0x00)
#define REG_SC_BK33_00_H      _PK_H_(0x33, 0x00)
#define REG_SC_BK33_01_L      _PK_L_(0x33, 0x01)
#define REG_SC_BK33_01_H      _PK_H_(0x33, 0x01)
#define REG_SC_BK33_02_L      _PK_L_(0x33, 0x02)
#define REG_SC_BK33_02_H      _PK_H_(0x33, 0x02)
#define REG_SC_BK33_03_L      _PK_L_(0x33, 0x03)
#define REG_SC_BK33_03_H      _PK_H_(0x33, 0x03)
#define REG_SC_BK33_04_L      _PK_L_(0x33, 0x04)
#define REG_SC_BK33_04_H      _PK_H_(0x33, 0x04)
#define REG_SC_BK33_05_L      _PK_L_(0x33, 0x05)
#define REG_SC_BK33_05_H      _PK_H_(0x33, 0x05)
#define REG_SC_BK33_06_L      _PK_L_(0x33, 0x06)
#define REG_SC_BK33_06_H      _PK_H_(0x33, 0x06)
#define REG_SC_BK33_07_L      _PK_L_(0x33, 0x07)
#define REG_SC_BK33_07_H      _PK_H_(0x33, 0x07)
#define REG_SC_BK33_08_L      _PK_L_(0x33, 0x08)
#define REG_SC_BK33_08_H      _PK_H_(0x33, 0x08)
#define REG_SC_BK33_09_L      _PK_L_(0x33, 0x09)
#define REG_SC_BK33_09_H      _PK_H_(0x33, 0x09)
#define REG_SC_BK33_0A_L      _PK_L_(0x33, 0x0A)
#define REG_SC_BK33_0A_H      _PK_H_(0x33, 0x0A)
#define REG_SC_BK33_0B_L      _PK_L_(0x33, 0x0B)
#define REG_SC_BK33_0B_H      _PK_H_(0x33, 0x0B)
#define REG_SC_BK33_0C_L      _PK_L_(0x33, 0x0C)
#define REG_SC_BK33_0C_H      _PK_H_(0x33, 0x0C)
#define REG_SC_BK33_0D_L      _PK_L_(0x33, 0x0D)
#define REG_SC_BK33_0D_H      _PK_H_(0x33, 0x0D)
#define REG_SC_BK33_0E_L      _PK_L_(0x33, 0x0E)
#define REG_SC_BK33_0E_H      _PK_H_(0x33, 0x0E)
#define REG_SC_BK33_0F_L      _PK_L_(0x33, 0x0F)
#define REG_SC_BK33_0F_H      _PK_H_(0x33, 0x0F)
#define REG_SC_BK33_10_L      _PK_L_(0x33, 0x10)
#define REG_SC_BK33_10_H      _PK_H_(0x33, 0x10)
#define REG_SC_BK33_11_L      _PK_L_(0x33, 0x11)
#define REG_SC_BK33_11_H      _PK_H_(0x33, 0x11)
#define REG_SC_BK33_12_L      _PK_L_(0x33, 0x12)
#define REG_SC_BK33_12_H      _PK_H_(0x33, 0x12)
#define REG_SC_BK33_13_L      _PK_L_(0x33, 0x13)
#define REG_SC_BK33_13_H      _PK_H_(0x33, 0x13)
#define REG_SC_BK33_14_L      _PK_L_(0x33, 0x14)
#define REG_SC_BK33_14_H      _PK_H_(0x33, 0x14)
#define REG_SC_BK33_15_L      _PK_L_(0x33, 0x15)
#define REG_SC_BK33_15_H      _PK_H_(0x33, 0x15)
#define REG_SC_BK33_16_L      _PK_L_(0x33, 0x16)
#define REG_SC_BK33_16_H      _PK_H_(0x33, 0x16)
#define REG_SC_BK33_17_L      _PK_L_(0x33, 0x17)
#define REG_SC_BK33_17_H      _PK_H_(0x33, 0x17)
#define REG_SC_BK33_18_L      _PK_L_(0x33, 0x18)
#define REG_SC_BK33_18_H      _PK_H_(0x33, 0x18)
#define REG_SC_BK33_19_L      _PK_L_(0x33, 0x19)
#define REG_SC_BK33_19_H      _PK_H_(0x33, 0x19)
#define REG_SC_BK33_1A_L      _PK_L_(0x33, 0x1A)
#define REG_SC_BK33_1A_H      _PK_H_(0x33, 0x1A)
#define REG_SC_BK33_1B_L      _PK_L_(0x33, 0x1B)
#define REG_SC_BK33_1B_H      _PK_H_(0x33, 0x1B)
#define REG_SC_BK33_1C_L      _PK_L_(0x33, 0x1C)
#define REG_SC_BK33_1C_H      _PK_H_(0x33, 0x1C)
#define REG_SC_BK33_1D_L      _PK_L_(0x33, 0x1D)
#define REG_SC_BK33_1D_H      _PK_H_(0x33, 0x1D)
#define REG_SC_BK33_1E_L      _PK_L_(0x33, 0x1E)
#define REG_SC_BK33_1E_H      _PK_H_(0x33, 0x1E)
#define REG_SC_BK33_1F_L      _PK_L_(0x33, 0x1F)
#define REG_SC_BK33_1F_H      _PK_H_(0x33, 0x1F)
#define REG_SC_BK33_20_L      _PK_L_(0x33, 0x20)
#define REG_SC_BK33_20_H      _PK_H_(0x33, 0x20)
#define REG_SC_BK33_21_L      _PK_L_(0x33, 0x21)
#define REG_SC_BK33_21_H      _PK_H_(0x33, 0x21)
#define REG_SC_BK33_22_L      _PK_L_(0x33, 0x22)
#define REG_SC_BK33_22_H      _PK_H_(0x33, 0x22)
#define REG_SC_BK33_23_L      _PK_L_(0x33, 0x23)
#define REG_SC_BK33_23_H      _PK_H_(0x33, 0x23)
#define REG_SC_BK33_24_L      _PK_L_(0x33, 0x24)
#define REG_SC_BK33_24_H      _PK_H_(0x33, 0x24)
#define REG_SC_BK33_25_L      _PK_L_(0x33, 0x25)
#define REG_SC_BK33_25_H      _PK_H_(0x33, 0x25)
#define REG_SC_BK33_26_L      _PK_L_(0x33, 0x26)
#define REG_SC_BK33_26_H      _PK_H_(0x33, 0x26)
#define REG_SC_BK33_27_L      _PK_L_(0x33, 0x27)
#define REG_SC_BK33_27_H      _PK_H_(0x33, 0x27)
#define REG_SC_BK33_28_L      _PK_L_(0x33, 0x28)
#define REG_SC_BK33_28_H      _PK_H_(0x33, 0x28)
#define REG_SC_BK33_29_L      _PK_L_(0x33, 0x29)
#define REG_SC_BK33_29_H      _PK_H_(0x33, 0x29)
#define REG_SC_BK33_2A_L      _PK_L_(0x33, 0x2A)
#define REG_SC_BK33_2A_H      _PK_H_(0x33, 0x2A)
#define REG_SC_BK33_2B_L      _PK_L_(0x33, 0x2B)
#define REG_SC_BK33_2B_H      _PK_H_(0x33, 0x2B)
#define REG_SC_BK33_2C_L      _PK_L_(0x33, 0x2C)
#define REG_SC_BK33_2C_H      _PK_H_(0x33, 0x2C)
#define REG_SC_BK33_2D_L      _PK_L_(0x33, 0x2D)
#define REG_SC_BK33_2D_H      _PK_H_(0x33, 0x2D)
#define REG_SC_BK33_2E_L      _PK_L_(0x33, 0x2E)
#define REG_SC_BK33_2E_H      _PK_H_(0x33, 0x2E)
#define REG_SC_BK33_2F_L      _PK_L_(0x33, 0x2F)
#define REG_SC_BK33_2F_H      _PK_H_(0x33, 0x2F)
#define REG_SC_BK33_30_L      _PK_L_(0x33, 0x30)
#define REG_SC_BK33_30_H      _PK_H_(0x33, 0x30)
#define REG_SC_BK33_31_L      _PK_L_(0x33, 0x31)
#define REG_SC_BK33_31_H      _PK_H_(0x33, 0x31)
#define REG_SC_BK33_32_L      _PK_L_(0x33, 0x32)
#define REG_SC_BK33_32_H      _PK_H_(0x33, 0x32)
#define REG_SC_BK33_33_L      _PK_L_(0x33, 0x33)
#define REG_SC_BK33_33_H      _PK_H_(0x33, 0x33)
#define REG_SC_BK33_34_L      _PK_L_(0x33, 0x34)
#define REG_SC_BK33_34_H      _PK_H_(0x33, 0x34)
#define REG_SC_BK33_35_L      _PK_L_(0x33, 0x35)
#define REG_SC_BK33_35_H      _PK_H_(0x33, 0x35)
#define REG_SC_BK33_36_L      _PK_L_(0x33, 0x36)
#define REG_SC_BK33_36_H      _PK_H_(0x33, 0x36)
#define REG_SC_BK33_37_L      _PK_L_(0x33, 0x37)
#define REG_SC_BK33_37_H      _PK_H_(0x33, 0x37)
#define REG_SC_BK33_38_L      _PK_L_(0x33, 0x38)
#define REG_SC_BK33_38_H      _PK_H_(0x33, 0x38)
#define REG_SC_BK33_39_L      _PK_L_(0x33, 0x39)
#define REG_SC_BK33_39_H      _PK_H_(0x33, 0x39)
#define REG_SC_BK33_3A_L      _PK_L_(0x33, 0x3A)
#define REG_SC_BK33_3A_H      _PK_H_(0x33, 0x3A)
#define REG_SC_BK33_3B_L      _PK_L_(0x33, 0x3B)
#define REG_SC_BK33_3B_H      _PK_H_(0x33, 0x3B)
#define REG_SC_BK33_3C_L      _PK_L_(0x33, 0x3C)
#define REG_SC_BK33_3C_H      _PK_H_(0x33, 0x3C)
#define REG_SC_BK33_3D_L      _PK_L_(0x33, 0x3D)
#define REG_SC_BK33_3D_H      _PK_H_(0x33, 0x3D)
#define REG_SC_BK33_3E_L      _PK_L_(0x33, 0x3E)
#define REG_SC_BK33_3E_H      _PK_H_(0x33, 0x3E)
#define REG_SC_BK33_3F_L      _PK_L_(0x33, 0x3F)
#define REG_SC_BK33_3F_H      _PK_H_(0x33, 0x3F)
#define REG_SC_BK33_40_L      _PK_L_(0x33, 0x40)
#define REG_SC_BK33_40_H      _PK_H_(0x33, 0x40)
#define REG_SC_BK33_41_L      _PK_L_(0x33, 0x41)
#define REG_SC_BK33_41_H      _PK_H_(0x33, 0x41)
#define REG_SC_BK33_42_L      _PK_L_(0x33, 0x42)
#define REG_SC_BK33_42_H      _PK_H_(0x33, 0x42)
#define REG_SC_BK33_43_L      _PK_L_(0x33, 0x43)
#define REG_SC_BK33_43_H      _PK_H_(0x33, 0x43)
#define REG_SC_BK33_44_L      _PK_L_(0x33, 0x44)
#define REG_SC_BK33_44_H      _PK_H_(0x33, 0x44)
#define REG_SC_BK33_45_L      _PK_L_(0x33, 0x45)
#define REG_SC_BK33_45_H      _PK_H_(0x33, 0x45)
#define REG_SC_BK33_46_L      _PK_L_(0x33, 0x46)
#define REG_SC_BK33_46_H      _PK_H_(0x33, 0x46)
#define REG_SC_BK33_47_L      _PK_L_(0x33, 0x47)
#define REG_SC_BK33_47_H      _PK_H_(0x33, 0x47)
#define REG_SC_BK33_48_L      _PK_L_(0x33, 0x48)
#define REG_SC_BK33_48_H      _PK_H_(0x33, 0x48)
#define REG_SC_BK33_49_L      _PK_L_(0x33, 0x49)
#define REG_SC_BK33_49_H      _PK_H_(0x33, 0x49)
#define REG_SC_BK33_4A_L      _PK_L_(0x33, 0x4A)
#define REG_SC_BK33_4A_H      _PK_H_(0x33, 0x4A)
#define REG_SC_BK33_4B_L      _PK_L_(0x33, 0x4B)
#define REG_SC_BK33_4B_H      _PK_H_(0x33, 0x4B)
#define REG_SC_BK33_4C_L      _PK_L_(0x33, 0x4C)
#define REG_SC_BK33_4C_H      _PK_H_(0x33, 0x4C)
#define REG_SC_BK33_4D_L      _PK_L_(0x33, 0x4D)
#define REG_SC_BK33_4D_H      _PK_H_(0x33, 0x4D)
#define REG_SC_BK33_4E_L      _PK_L_(0x33, 0x4E)
#define REG_SC_BK33_4E_H      _PK_H_(0x33, 0x4E)
#define REG_SC_BK33_4F_L      _PK_L_(0x33, 0x4F)
#define REG_SC_BK33_4F_H      _PK_H_(0x33, 0x4F)
#define REG_SC_BK33_50_L      _PK_L_(0x33, 0x50)
#define REG_SC_BK33_50_H      _PK_H_(0x33, 0x50)
#define REG_SC_BK33_51_L      _PK_L_(0x33, 0x51)
#define REG_SC_BK33_51_H      _PK_H_(0x33, 0x51)
#define REG_SC_BK33_52_L      _PK_L_(0x33, 0x52)
#define REG_SC_BK33_52_H      _PK_H_(0x33, 0x52)
#define REG_SC_BK33_53_L      _PK_L_(0x33, 0x53)
#define REG_SC_BK33_53_H      _PK_H_(0x33, 0x53)
#define REG_SC_BK33_54_L      _PK_L_(0x33, 0x54)
#define REG_SC_BK33_54_H      _PK_H_(0x33, 0x54)
#define REG_SC_BK33_55_L      _PK_L_(0x33, 0x55)
#define REG_SC_BK33_55_H      _PK_H_(0x33, 0x55)
#define REG_SC_BK33_56_L      _PK_L_(0x33, 0x56)
#define REG_SC_BK33_56_H      _PK_H_(0x33, 0x56)
#define REG_SC_BK33_57_L      _PK_L_(0x33, 0x57)
#define REG_SC_BK33_57_H      _PK_H_(0x33, 0x57)
#define REG_SC_BK33_58_L      _PK_L_(0x33, 0x58)
#define REG_SC_BK33_58_H      _PK_H_(0x33, 0x58)
#define REG_SC_BK33_59_L      _PK_L_(0x33, 0x59)
#define REG_SC_BK33_59_H      _PK_H_(0x33, 0x59)
#define REG_SC_BK33_5A_L      _PK_L_(0x33, 0x5A)
#define REG_SC_BK33_5A_H      _PK_H_(0x33, 0x5A)
#define REG_SC_BK33_5B_L      _PK_L_(0x33, 0x5B)
#define REG_SC_BK33_5B_H      _PK_H_(0x33, 0x5B)
#define REG_SC_BK33_5C_L      _PK_L_(0x33, 0x5C)
#define REG_SC_BK33_5C_H      _PK_H_(0x33, 0x5C)
#define REG_SC_BK33_5D_L      _PK_L_(0x33, 0x5D)
#define REG_SC_BK33_5D_H      _PK_H_(0x33, 0x5D)
#define REG_SC_BK33_5E_L      _PK_L_(0x33, 0x5E)
#define REG_SC_BK33_5E_H      _PK_H_(0x33, 0x5E)
#define REG_SC_BK33_5F_L      _PK_L_(0x33, 0x5F)
#define REG_SC_BK33_5F_H      _PK_H_(0x33, 0x5F)
#define REG_SC_BK33_60_L      _PK_L_(0x33, 0x60)
#define REG_SC_BK33_60_H      _PK_H_(0x33, 0x60)
#define REG_SC_BK33_61_L      _PK_L_(0x33, 0x61)
#define REG_SC_BK33_61_H      _PK_H_(0x33, 0x61)
#define REG_SC_BK33_62_L      _PK_L_(0x33, 0x62)
#define REG_SC_BK33_62_H      _PK_H_(0x33, 0x62)
#define REG_SC_BK33_63_L      _PK_L_(0x33, 0x63)
#define REG_SC_BK33_63_H      _PK_H_(0x33, 0x63)
#define REG_SC_BK33_64_L      _PK_L_(0x33, 0x64)
#define REG_SC_BK33_64_H      _PK_H_(0x33, 0x64)
#define REG_SC_BK33_65_L      _PK_L_(0x33, 0x65)
#define REG_SC_BK33_65_H      _PK_H_(0x33, 0x65)
#define REG_SC_BK33_66_L      _PK_L_(0x33, 0x66)
#define REG_SC_BK33_66_H      _PK_H_(0x33, 0x66)
#define REG_SC_BK33_67_L      _PK_L_(0x33, 0x67)
#define REG_SC_BK33_67_H      _PK_H_(0x33, 0x67)
#define REG_SC_BK33_68_L      _PK_L_(0x33, 0x68)
#define REG_SC_BK33_68_H      _PK_H_(0x33, 0x68)
#define REG_SC_BK33_69_L      _PK_L_(0x33, 0x69)
#define REG_SC_BK33_69_H      _PK_H_(0x33, 0x69)
#define REG_SC_BK33_6A_L      _PK_L_(0x33, 0x6A)
#define REG_SC_BK33_6A_H      _PK_H_(0x33, 0x6A)
#define REG_SC_BK33_6B_L      _PK_L_(0x33, 0x6B)
#define REG_SC_BK33_6B_H      _PK_H_(0x33, 0x6B)
#define REG_SC_BK33_6C_L      _PK_L_(0x33, 0x6C)
#define REG_SC_BK33_6C_H      _PK_H_(0x33, 0x6C)
#define REG_SC_BK33_6D_L      _PK_L_(0x33, 0x6D)
#define REG_SC_BK33_6D_H      _PK_H_(0x33, 0x6D)
#define REG_SC_BK33_6E_L      _PK_L_(0x33, 0x6E)
#define REG_SC_BK33_6E_H      _PK_H_(0x33, 0x6E)
#define REG_SC_BK33_6F_L      _PK_L_(0x33, 0x6F)
#define REG_SC_BK33_6F_H      _PK_H_(0x33, 0x6F)
#define REG_SC_BK33_70_L      _PK_L_(0x33, 0x70)
#define REG_SC_BK33_70_H      _PK_H_(0x33, 0x70)
#define REG_SC_BK33_71_L      _PK_L_(0x33, 0x71)
#define REG_SC_BK33_71_H      _PK_H_(0x33, 0x71)
#define REG_SC_BK33_72_L      _PK_L_(0x33, 0x72)
#define REG_SC_BK33_72_H      _PK_H_(0x33, 0x72)
#define REG_SC_BK33_73_L      _PK_L_(0x33, 0x73)
#define REG_SC_BK33_73_H      _PK_H_(0x33, 0x73)
#define REG_SC_BK33_74_L      _PK_L_(0x33, 0x74)
#define REG_SC_BK33_74_H      _PK_H_(0x33, 0x74)
#define REG_SC_BK33_75_L      _PK_L_(0x33, 0x75)
#define REG_SC_BK33_75_H      _PK_H_(0x33, 0x75)
#define REG_SC_BK33_76_L      _PK_L_(0x33, 0x76)
#define REG_SC_BK33_76_H      _PK_H_(0x33, 0x76)
#define REG_SC_BK33_77_L      _PK_L_(0x33, 0x77)
#define REG_SC_BK33_77_H      _PK_H_(0x33, 0x77)
#define REG_SC_BK33_78_L      _PK_L_(0x33, 0x78)
#define REG_SC_BK33_78_H      _PK_H_(0x33, 0x78)
#define REG_SC_BK33_79_L      _PK_L_(0x33, 0x79)
#define REG_SC_BK33_79_H      _PK_H_(0x33, 0x79)
#define REG_SC_BK33_7A_L      _PK_L_(0x33, 0x7A)
#define REG_SC_BK33_7A_H      _PK_H_(0x33, 0x7A)
#define REG_SC_BK33_7B_L      _PK_L_(0x33, 0x7B)
#define REG_SC_BK33_7B_H      _PK_H_(0x33, 0x7B)
#define REG_SC_BK33_7C_L      _PK_L_(0x33, 0x7C)
#define REG_SC_BK33_7C_H      _PK_H_(0x33, 0x7C)
#define REG_SC_BK33_7D_L      _PK_L_(0x33, 0x7D)
#define REG_SC_BK33_7D_H      _PK_H_(0x33, 0x7D)
#define REG_SC_BK33_7E_L      _PK_L_(0x33, 0x7E)
#define REG_SC_BK33_7E_H      _PK_H_(0x33, 0x7E)
#define REG_SC_BK33_7F_L      _PK_L_(0x33, 0x7F)
#define REG_SC_BK33_7F_H      _PK_H_(0x33, 0x7F)

//----------------------------------------------
//  BK34
//----------------------------------------------
#define REG_SC_BK34_00_L      _PK_L_(0x34, 0x00)
#define REG_SC_BK34_00_H      _PK_H_(0x34, 0x00)
#define REG_SC_BK34_01_L      _PK_L_(0x34, 0x01)
#define REG_SC_BK34_01_H      _PK_H_(0x34, 0x01)
#define REG_SC_BK34_02_L      _PK_L_(0x34, 0x02)
#define REG_SC_BK34_02_H      _PK_H_(0x34, 0x02)
#define REG_SC_BK34_03_L      _PK_L_(0x34, 0x03)
#define REG_SC_BK34_03_H      _PK_H_(0x34, 0x03)
#define REG_SC_BK34_04_L      _PK_L_(0x34, 0x04)
#define REG_SC_BK34_04_H      _PK_H_(0x34, 0x04)
#define REG_SC_BK34_05_L      _PK_L_(0x34, 0x05)
#define REG_SC_BK34_05_H      _PK_H_(0x34, 0x05)
#define REG_SC_BK34_06_L      _PK_L_(0x34, 0x06)
#define REG_SC_BK34_06_H      _PK_H_(0x34, 0x06)
#define REG_SC_BK34_07_L      _PK_L_(0x34, 0x07)
#define REG_SC_BK34_07_H      _PK_H_(0x34, 0x07)
#define REG_SC_BK34_08_L      _PK_L_(0x34, 0x08)
#define REG_SC_BK34_08_H      _PK_H_(0x34, 0x08)
#define REG_SC_BK34_09_L      _PK_L_(0x34, 0x09)
#define REG_SC_BK34_09_H      _PK_H_(0x34, 0x09)
#define REG_SC_BK34_0A_L      _PK_L_(0x34, 0x0A)
#define REG_SC_BK34_0A_H      _PK_H_(0x34, 0x0A)
#define REG_SC_BK34_0B_L      _PK_L_(0x34, 0x0B)
#define REG_SC_BK34_0B_H      _PK_H_(0x34, 0x0B)
#define REG_SC_BK34_0C_L      _PK_L_(0x34, 0x0C)
#define REG_SC_BK34_0C_H      _PK_H_(0x34, 0x0C)
#define REG_SC_BK34_0D_L      _PK_L_(0x34, 0x0D)
#define REG_SC_BK34_0D_H      _PK_H_(0x34, 0x0D)
#define REG_SC_BK34_0E_L      _PK_L_(0x34, 0x0E)
#define REG_SC_BK34_0E_H      _PK_H_(0x34, 0x0E)
#define REG_SC_BK34_0F_L      _PK_L_(0x34, 0x0F)
#define REG_SC_BK34_0F_H      _PK_H_(0x34, 0x0F)
#define REG_SC_BK34_10_L      _PK_L_(0x34, 0x10)
#define REG_SC_BK34_10_H      _PK_H_(0x34, 0x10)
#define REG_SC_BK34_11_L      _PK_L_(0x34, 0x11)
#define REG_SC_BK34_11_H      _PK_H_(0x34, 0x11)
#define REG_SC_BK34_12_L      _PK_L_(0x34, 0x12)
#define REG_SC_BK34_12_H      _PK_H_(0x34, 0x12)
#define REG_SC_BK34_13_L      _PK_L_(0x34, 0x13)
#define REG_SC_BK34_13_H      _PK_H_(0x34, 0x13)
#define REG_SC_BK34_14_L      _PK_L_(0x34, 0x14)
#define REG_SC_BK34_14_H      _PK_H_(0x34, 0x14)
#define REG_SC_BK34_15_L      _PK_L_(0x34, 0x15)
#define REG_SC_BK34_15_H      _PK_H_(0x34, 0x15)
#define REG_SC_BK34_16_L      _PK_L_(0x34, 0x16)
#define REG_SC_BK34_16_H      _PK_H_(0x34, 0x16)
#define REG_SC_BK34_17_L      _PK_L_(0x34, 0x17)
#define REG_SC_BK34_17_H      _PK_H_(0x34, 0x17)
#define REG_SC_BK34_18_L      _PK_L_(0x34, 0x18)
#define REG_SC_BK34_18_H      _PK_H_(0x34, 0x18)
#define REG_SC_BK34_19_L      _PK_L_(0x34, 0x19)
#define REG_SC_BK34_19_H      _PK_H_(0x34, 0x19)
#define REG_SC_BK34_1A_L      _PK_L_(0x34, 0x1A)
#define REG_SC_BK34_1A_H      _PK_H_(0x34, 0x1A)
#define REG_SC_BK34_1B_L      _PK_L_(0x34, 0x1B)
#define REG_SC_BK34_1B_H      _PK_H_(0x34, 0x1B)
#define REG_SC_BK34_1C_L      _PK_L_(0x34, 0x1C)
#define REG_SC_BK34_1C_H      _PK_H_(0x34, 0x1C)
#define REG_SC_BK34_1D_L      _PK_L_(0x34, 0x1D)
#define REG_SC_BK34_1D_H      _PK_H_(0x34, 0x1D)
#define REG_SC_BK34_1E_L      _PK_L_(0x34, 0x1E)
#define REG_SC_BK34_1E_H      _PK_H_(0x34, 0x1E)
#define REG_SC_BK34_1F_L      _PK_L_(0x34, 0x1F)
#define REG_SC_BK34_1F_H      _PK_H_(0x34, 0x1F)
#define REG_SC_BK34_20_L      _PK_L_(0x34, 0x20)
#define REG_SC_BK34_20_H      _PK_H_(0x34, 0x20)
#define REG_SC_BK34_21_L      _PK_L_(0x34, 0x21)
#define REG_SC_BK34_21_H      _PK_H_(0x34, 0x21)
#define REG_SC_BK34_22_L      _PK_L_(0x34, 0x22)
#define REG_SC_BK34_22_H      _PK_H_(0x34, 0x22)
#define REG_SC_BK34_23_L      _PK_L_(0x34, 0x23)
#define REG_SC_BK34_23_H      _PK_H_(0x34, 0x23)
#define REG_SC_BK34_24_L      _PK_L_(0x34, 0x24)
#define REG_SC_BK34_24_H      _PK_H_(0x34, 0x24)
#define REG_SC_BK34_25_L      _PK_L_(0x34, 0x25)
#define REG_SC_BK34_25_H      _PK_H_(0x34, 0x25)
#define REG_SC_BK34_26_L      _PK_L_(0x34, 0x26)
#define REG_SC_BK34_26_H      _PK_H_(0x34, 0x26)
#define REG_SC_BK34_27_L      _PK_L_(0x34, 0x27)
#define REG_SC_BK34_27_H      _PK_H_(0x34, 0x27)
#define REG_SC_BK34_28_L      _PK_L_(0x34, 0x28)
#define REG_SC_BK34_28_H      _PK_H_(0x34, 0x28)
#define REG_SC_BK34_29_L      _PK_L_(0x34, 0x29)
#define REG_SC_BK34_29_H      _PK_H_(0x34, 0x29)
#define REG_SC_BK34_2A_L      _PK_L_(0x34, 0x2A)
#define REG_SC_BK34_2A_H      _PK_H_(0x34, 0x2A)
#define REG_SC_BK34_2B_L      _PK_L_(0x34, 0x2B)
#define REG_SC_BK34_2B_H      _PK_H_(0x34, 0x2B)
#define REG_SC_BK34_2C_L      _PK_L_(0x34, 0x2C)
#define REG_SC_BK34_2C_H      _PK_H_(0x34, 0x2C)
#define REG_SC_BK34_2D_L      _PK_L_(0x34, 0x2D)
#define REG_SC_BK34_2D_H      _PK_H_(0x34, 0x2D)
#define REG_SC_BK34_2E_L      _PK_L_(0x34, 0x2E)
#define REG_SC_BK34_2E_H      _PK_H_(0x34, 0x2E)
#define REG_SC_BK34_2F_L      _PK_L_(0x34, 0x2F)
#define REG_SC_BK34_2F_H      _PK_H_(0x34, 0x2F)
#define REG_SC_BK34_30_L      _PK_L_(0x34, 0x30)
#define REG_SC_BK34_30_H      _PK_H_(0x34, 0x30)
#define REG_SC_BK34_31_L      _PK_L_(0x34, 0x31)
#define REG_SC_BK34_31_H      _PK_H_(0x34, 0x31)
#define REG_SC_BK34_32_L      _PK_L_(0x34, 0x32)
#define REG_SC_BK34_32_H      _PK_H_(0x34, 0x32)
#define REG_SC_BK34_33_L      _PK_L_(0x34, 0x33)
#define REG_SC_BK34_33_H      _PK_H_(0x34, 0x33)
#define REG_SC_BK34_34_L      _PK_L_(0x34, 0x34)
#define REG_SC_BK34_34_H      _PK_H_(0x34, 0x34)
#define REG_SC_BK34_35_L      _PK_L_(0x34, 0x35)
#define REG_SC_BK34_35_H      _PK_H_(0x34, 0x35)
#define REG_SC_BK34_36_L      _PK_L_(0x34, 0x36)
#define REG_SC_BK34_36_H      _PK_H_(0x34, 0x36)
#define REG_SC_BK34_37_L      _PK_L_(0x34, 0x37)
#define REG_SC_BK34_37_H      _PK_H_(0x34, 0x37)
#define REG_SC_BK34_38_L      _PK_L_(0x34, 0x38)
#define REG_SC_BK34_38_H      _PK_H_(0x34, 0x38)
#define REG_SC_BK34_39_L      _PK_L_(0x34, 0x39)
#define REG_SC_BK34_39_H      _PK_H_(0x34, 0x39)
#define REG_SC_BK34_3A_L      _PK_L_(0x34, 0x3A)
#define REG_SC_BK34_3A_H      _PK_H_(0x34, 0x3A)
#define REG_SC_BK34_3B_L      _PK_L_(0x34, 0x3B)
#define REG_SC_BK34_3B_H      _PK_H_(0x34, 0x3B)
#define REG_SC_BK34_3C_L      _PK_L_(0x34, 0x3C)
#define REG_SC_BK34_3C_H      _PK_H_(0x34, 0x3C)
#define REG_SC_BK34_3D_L      _PK_L_(0x34, 0x3D)
#define REG_SC_BK34_3D_H      _PK_H_(0x34, 0x3D)
#define REG_SC_BK34_3E_L      _PK_L_(0x34, 0x3E)
#define REG_SC_BK34_3E_H      _PK_H_(0x34, 0x3E)
#define REG_SC_BK34_3F_L      _PK_L_(0x34, 0x3F)
#define REG_SC_BK34_3F_H      _PK_H_(0x34, 0x3F)
#define REG_SC_BK34_40_L      _PK_L_(0x34, 0x40)
#define REG_SC_BK34_40_H      _PK_H_(0x34, 0x40)
#define REG_SC_BK34_41_L      _PK_L_(0x34, 0x41)
#define REG_SC_BK34_41_H      _PK_H_(0x34, 0x41)
#define REG_SC_BK34_42_L      _PK_L_(0x34, 0x42)
#define REG_SC_BK34_42_H      _PK_H_(0x34, 0x42)
#define REG_SC_BK34_43_L      _PK_L_(0x34, 0x43)
#define REG_SC_BK34_43_H      _PK_H_(0x34, 0x43)
#define REG_SC_BK34_44_L      _PK_L_(0x34, 0x44)
#define REG_SC_BK34_44_H      _PK_H_(0x34, 0x44)
#define REG_SC_BK34_45_L      _PK_L_(0x34, 0x45)
#define REG_SC_BK34_45_H      _PK_H_(0x34, 0x45)
#define REG_SC_BK34_46_L      _PK_L_(0x34, 0x46)
#define REG_SC_BK34_46_H      _PK_H_(0x34, 0x46)
#define REG_SC_BK34_47_L      _PK_L_(0x34, 0x47)
#define REG_SC_BK34_47_H      _PK_H_(0x34, 0x47)
#define REG_SC_BK34_48_L      _PK_L_(0x34, 0x48)
#define REG_SC_BK34_48_H      _PK_H_(0x34, 0x48)
#define REG_SC_BK34_49_L      _PK_L_(0x34, 0x49)
#define REG_SC_BK34_49_H      _PK_H_(0x34, 0x49)
#define REG_SC_BK34_4A_L      _PK_L_(0x34, 0x4A)
#define REG_SC_BK34_4A_H      _PK_H_(0x34, 0x4A)
#define REG_SC_BK34_4B_L      _PK_L_(0x34, 0x4B)
#define REG_SC_BK34_4B_H      _PK_H_(0x34, 0x4B)
#define REG_SC_BK34_4C_L      _PK_L_(0x34, 0x4C)
#define REG_SC_BK34_4C_H      _PK_H_(0x34, 0x4C)
#define REG_SC_BK34_4D_L      _PK_L_(0x34, 0x4D)
#define REG_SC_BK34_4D_H      _PK_H_(0x34, 0x4D)
#define REG_SC_BK34_4E_L      _PK_L_(0x34, 0x4E)
#define REG_SC_BK34_4E_H      _PK_H_(0x34, 0x4E)
#define REG_SC_BK34_4F_L      _PK_L_(0x34, 0x4F)
#define REG_SC_BK34_4F_H      _PK_H_(0x34, 0x4F)
#define REG_SC_BK34_50_L      _PK_L_(0x34, 0x50)
#define REG_SC_BK34_50_H      _PK_H_(0x34, 0x50)
#define REG_SC_BK34_51_L      _PK_L_(0x34, 0x51)
#define REG_SC_BK34_51_H      _PK_H_(0x34, 0x51)
#define REG_SC_BK34_52_L      _PK_L_(0x34, 0x52)
#define REG_SC_BK34_52_H      _PK_H_(0x34, 0x52)
#define REG_SC_BK34_53_L      _PK_L_(0x34, 0x53)
#define REG_SC_BK34_53_H      _PK_H_(0x34, 0x53)
#define REG_SC_BK34_54_L      _PK_L_(0x34, 0x54)
#define REG_SC_BK34_54_H      _PK_H_(0x34, 0x54)
#define REG_SC_BK34_55_L      _PK_L_(0x34, 0x55)
#define REG_SC_BK34_55_H      _PK_H_(0x34, 0x55)
#define REG_SC_BK34_56_L      _PK_L_(0x34, 0x56)
#define REG_SC_BK34_56_H      _PK_H_(0x34, 0x56)
#define REG_SC_BK34_57_L      _PK_L_(0x34, 0x57)
#define REG_SC_BK34_57_H      _PK_H_(0x34, 0x57)
#define REG_SC_BK34_58_L      _PK_L_(0x34, 0x58)
#define REG_SC_BK34_58_H      _PK_H_(0x34, 0x58)
#define REG_SC_BK34_59_L      _PK_L_(0x34, 0x59)
#define REG_SC_BK34_59_H      _PK_H_(0x34, 0x59)
#define REG_SC_BK34_5A_L      _PK_L_(0x34, 0x5A)
#define REG_SC_BK34_5A_H      _PK_H_(0x34, 0x5A)
#define REG_SC_BK34_5B_L      _PK_L_(0x34, 0x5B)
#define REG_SC_BK34_5B_H      _PK_H_(0x34, 0x5B)
#define REG_SC_BK34_5C_L      _PK_L_(0x34, 0x5C)
#define REG_SC_BK34_5C_H      _PK_H_(0x34, 0x5C)
#define REG_SC_BK34_5D_L      _PK_L_(0x34, 0x5D)
#define REG_SC_BK34_5D_H      _PK_H_(0x34, 0x5D)
#define REG_SC_BK34_5E_L      _PK_L_(0x34, 0x5E)
#define REG_SC_BK34_5E_H      _PK_H_(0x34, 0x5E)
#define REG_SC_BK34_5F_L      _PK_L_(0x34, 0x5F)
#define REG_SC_BK34_5F_H      _PK_H_(0x34, 0x5F)
#define REG_SC_BK34_60_L      _PK_L_(0x34, 0x60)
#define REG_SC_BK34_60_H      _PK_H_(0x34, 0x60)
#define REG_SC_BK34_61_L      _PK_L_(0x34, 0x61)
#define REG_SC_BK34_61_H      _PK_H_(0x34, 0x61)
#define REG_SC_BK34_62_L      _PK_L_(0x34, 0x62)
#define REG_SC_BK34_62_H      _PK_H_(0x34, 0x62)
#define REG_SC_BK34_63_L      _PK_L_(0x34, 0x63)
#define REG_SC_BK34_63_H      _PK_H_(0x34, 0x63)
#define REG_SC_BK34_64_L      _PK_L_(0x34, 0x64)
#define REG_SC_BK34_64_H      _PK_H_(0x34, 0x64)
#define REG_SC_BK34_65_L      _PK_L_(0x34, 0x65)
#define REG_SC_BK34_65_H      _PK_H_(0x34, 0x65)
#define REG_SC_BK34_66_L      _PK_L_(0x34, 0x66)
#define REG_SC_BK34_66_H      _PK_H_(0x34, 0x66)
#define REG_SC_BK34_67_L      _PK_L_(0x34, 0x67)
#define REG_SC_BK34_67_H      _PK_H_(0x34, 0x67)
#define REG_SC_BK34_68_L      _PK_L_(0x34, 0x68)
#define REG_SC_BK34_68_H      _PK_H_(0x34, 0x68)
#define REG_SC_BK34_69_L      _PK_L_(0x34, 0x69)
#define REG_SC_BK34_69_H      _PK_H_(0x34, 0x69)
#define REG_SC_BK34_6A_L      _PK_L_(0x34, 0x6A)
#define REG_SC_BK34_6A_H      _PK_H_(0x34, 0x6A)
#define REG_SC_BK34_6B_L      _PK_L_(0x34, 0x6B)
#define REG_SC_BK34_6B_H      _PK_H_(0x34, 0x6B)
#define REG_SC_BK34_6C_L      _PK_L_(0x34, 0x6C)
#define REG_SC_BK34_6C_H      _PK_H_(0x34, 0x6C)
#define REG_SC_BK34_6D_L      _PK_L_(0x34, 0x6D)
#define REG_SC_BK34_6D_H      _PK_H_(0x34, 0x6D)
#define REG_SC_BK34_6E_L      _PK_L_(0x34, 0x6E)
#define REG_SC_BK34_6E_H      _PK_H_(0x34, 0x6E)
#define REG_SC_BK34_6F_L      _PK_L_(0x34, 0x6F)
#define REG_SC_BK34_6F_H      _PK_H_(0x34, 0x6F)
#define REG_SC_BK34_70_L      _PK_L_(0x34, 0x70)
#define REG_SC_BK34_70_H      _PK_H_(0x34, 0x70)
#define REG_SC_BK34_71_L      _PK_L_(0x34, 0x71)
#define REG_SC_BK34_71_H      _PK_H_(0x34, 0x71)
#define REG_SC_BK34_72_L      _PK_L_(0x34, 0x72)
#define REG_SC_BK34_72_H      _PK_H_(0x34, 0x72)
#define REG_SC_BK34_73_L      _PK_L_(0x34, 0x73)
#define REG_SC_BK34_73_H      _PK_H_(0x34, 0x73)
#define REG_SC_BK34_74_L      _PK_L_(0x34, 0x74)
#define REG_SC_BK34_74_H      _PK_H_(0x34, 0x74)
#define REG_SC_BK34_75_L      _PK_L_(0x34, 0x75)
#define REG_SC_BK34_75_H      _PK_H_(0x34, 0x75)
#define REG_SC_BK34_76_L      _PK_L_(0x34, 0x76)
#define REG_SC_BK34_76_H      _PK_H_(0x34, 0x76)
#define REG_SC_BK34_77_L      _PK_L_(0x34, 0x77)
#define REG_SC_BK34_77_H      _PK_H_(0x34, 0x77)
#define REG_SC_BK34_78_L      _PK_L_(0x34, 0x78)
#define REG_SC_BK34_78_H      _PK_H_(0x34, 0x78)
#define REG_SC_BK34_79_L      _PK_L_(0x34, 0x79)
#define REG_SC_BK34_79_H      _PK_H_(0x34, 0x79)
#define REG_SC_BK34_7A_L      _PK_L_(0x34, 0x7A)
#define REG_SC_BK34_7A_H      _PK_H_(0x34, 0x7A)
#define REG_SC_BK34_7B_L      _PK_L_(0x34, 0x7B)
#define REG_SC_BK34_7B_H      _PK_H_(0x34, 0x7B)
#define REG_SC_BK34_7C_L      _PK_L_(0x34, 0x7C)
#define REG_SC_BK34_7C_H      _PK_H_(0x34, 0x7C)
#define REG_SC_BK34_7D_L      _PK_L_(0x34, 0x7D)
#define REG_SC_BK34_7D_H      _PK_H_(0x34, 0x7D)
#define REG_SC_BK34_7E_L      _PK_L_(0x34, 0x7E)
#define REG_SC_BK34_7E_H      _PK_H_(0x34, 0x7E)
#define REG_SC_BK34_7F_L      _PK_L_(0x34, 0x7F)
#define REG_SC_BK34_7F_H      _PK_H_(0x34, 0x7F)

//----------------------------------------------
//  BK35
//----------------------------------------------
#define REG_SC_BK35_00_L      _PK_L_(0x35, 0x00)
#define REG_SC_BK35_00_H      _PK_H_(0x35, 0x00)
#define REG_SC_BK35_01_L      _PK_L_(0x35, 0x01)
#define REG_SC_BK35_01_H      _PK_H_(0x35, 0x01)
#define REG_SC_BK35_02_L      _PK_L_(0x35, 0x02)
#define REG_SC_BK35_02_H      _PK_H_(0x35, 0x02)
#define REG_SC_BK35_03_L      _PK_L_(0x35, 0x03)
#define REG_SC_BK35_03_H      _PK_H_(0x35, 0x03)
#define REG_SC_BK35_04_L      _PK_L_(0x35, 0x04)
#define REG_SC_BK35_04_H      _PK_H_(0x35, 0x04)
#define REG_SC_BK35_05_L      _PK_L_(0x35, 0x05)
#define REG_SC_BK35_05_H      _PK_H_(0x35, 0x05)
#define REG_SC_BK35_06_L      _PK_L_(0x35, 0x06)
#define REG_SC_BK35_06_H      _PK_H_(0x35, 0x06)
#define REG_SC_BK35_07_L      _PK_L_(0x35, 0x07)
#define REG_SC_BK35_07_H      _PK_H_(0x35, 0x07)
#define REG_SC_BK35_08_L      _PK_L_(0x35, 0x08)
#define REG_SC_BK35_08_H      _PK_H_(0x35, 0x08)
#define REG_SC_BK35_09_L      _PK_L_(0x35, 0x09)
#define REG_SC_BK35_09_H      _PK_H_(0x35, 0x09)
#define REG_SC_BK35_0A_L      _PK_L_(0x35, 0x0A)
#define REG_SC_BK35_0A_H      _PK_H_(0x35, 0x0A)
#define REG_SC_BK35_0B_L      _PK_L_(0x35, 0x0B)
#define REG_SC_BK35_0B_H      _PK_H_(0x35, 0x0B)
#define REG_SC_BK35_0C_L      _PK_L_(0x35, 0x0C)
#define REG_SC_BK35_0C_H      _PK_H_(0x35, 0x0C)
#define REG_SC_BK35_0D_L      _PK_L_(0x35, 0x0D)
#define REG_SC_BK35_0D_H      _PK_H_(0x35, 0x0D)
#define REG_SC_BK35_0E_L      _PK_L_(0x35, 0x0E)
#define REG_SC_BK35_0E_H      _PK_H_(0x35, 0x0E)
#define REG_SC_BK35_0F_L      _PK_L_(0x35, 0x0F)
#define REG_SC_BK35_0F_H      _PK_H_(0x35, 0x0F)
#define REG_SC_BK35_10_L      _PK_L_(0x35, 0x10)
#define REG_SC_BK35_10_H      _PK_H_(0x35, 0x10)
#define REG_SC_BK35_11_L      _PK_L_(0x35, 0x11)
#define REG_SC_BK35_11_H      _PK_H_(0x35, 0x11)
#define REG_SC_BK35_12_L      _PK_L_(0x35, 0x12)
#define REG_SC_BK35_12_H      _PK_H_(0x35, 0x12)
#define REG_SC_BK35_13_L      _PK_L_(0x35, 0x13)
#define REG_SC_BK35_13_H      _PK_H_(0x35, 0x13)
#define REG_SC_BK35_14_L      _PK_L_(0x35, 0x14)
#define REG_SC_BK35_14_H      _PK_H_(0x35, 0x14)
#define REG_SC_BK35_15_L      _PK_L_(0x35, 0x15)
#define REG_SC_BK35_15_H      _PK_H_(0x35, 0x15)
#define REG_SC_BK35_16_L      _PK_L_(0x35, 0x16)
#define REG_SC_BK35_16_H      _PK_H_(0x35, 0x16)
#define REG_SC_BK35_17_L      _PK_L_(0x35, 0x17)
#define REG_SC_BK35_17_H      _PK_H_(0x35, 0x17)
#define REG_SC_BK35_18_L      _PK_L_(0x35, 0x18)
#define REG_SC_BK35_18_H      _PK_H_(0x35, 0x18)
#define REG_SC_BK35_19_L      _PK_L_(0x35, 0x19)
#define REG_SC_BK35_19_H      _PK_H_(0x35, 0x19)
#define REG_SC_BK35_1A_L      _PK_L_(0x35, 0x1A)
#define REG_SC_BK35_1A_H      _PK_H_(0x35, 0x1A)
#define REG_SC_BK35_1B_L      _PK_L_(0x35, 0x1B)
#define REG_SC_BK35_1B_H      _PK_H_(0x35, 0x1B)
#define REG_SC_BK35_1C_L      _PK_L_(0x35, 0x1C)
#define REG_SC_BK35_1C_H      _PK_H_(0x35, 0x1C)
#define REG_SC_BK35_1D_L      _PK_L_(0x35, 0x1D)
#define REG_SC_BK35_1D_H      _PK_H_(0x35, 0x1D)
#define REG_SC_BK35_1E_L      _PK_L_(0x35, 0x1E)
#define REG_SC_BK35_1E_H      _PK_H_(0x35, 0x1E)
#define REG_SC_BK35_1F_L      _PK_L_(0x35, 0x1F)
#define REG_SC_BK35_1F_H      _PK_H_(0x35, 0x1F)
#define REG_SC_BK35_20_L      _PK_L_(0x35, 0x20)
#define REG_SC_BK35_20_H      _PK_H_(0x35, 0x20)
#define REG_SC_BK35_21_L      _PK_L_(0x35, 0x21)
#define REG_SC_BK35_21_H      _PK_H_(0x35, 0x21)
#define REG_SC_BK35_22_L      _PK_L_(0x35, 0x22)
#define REG_SC_BK35_22_H      _PK_H_(0x35, 0x22)
#define REG_SC_BK35_23_L      _PK_L_(0x35, 0x23)
#define REG_SC_BK35_23_H      _PK_H_(0x35, 0x23)
#define REG_SC_BK35_24_L      _PK_L_(0x35, 0x24)
#define REG_SC_BK35_24_H      _PK_H_(0x35, 0x24)
#define REG_SC_BK35_25_L      _PK_L_(0x35, 0x25)
#define REG_SC_BK35_25_H      _PK_H_(0x35, 0x25)
#define REG_SC_BK35_26_L      _PK_L_(0x35, 0x26)
#define REG_SC_BK35_26_H      _PK_H_(0x35, 0x26)
#define REG_SC_BK35_27_L      _PK_L_(0x35, 0x27)
#define REG_SC_BK35_27_H      _PK_H_(0x35, 0x27)
#define REG_SC_BK35_28_L      _PK_L_(0x35, 0x28)
#define REG_SC_BK35_28_H      _PK_H_(0x35, 0x28)
#define REG_SC_BK35_29_L      _PK_L_(0x35, 0x29)
#define REG_SC_BK35_29_H      _PK_H_(0x35, 0x29)
#define REG_SC_BK35_2A_L      _PK_L_(0x35, 0x2A)
#define REG_SC_BK35_2A_H      _PK_H_(0x35, 0x2A)
#define REG_SC_BK35_2B_L      _PK_L_(0x35, 0x2B)
#define REG_SC_BK35_2B_H      _PK_H_(0x35, 0x2B)
#define REG_SC_BK35_2C_L      _PK_L_(0x35, 0x2C)
#define REG_SC_BK35_2C_H      _PK_H_(0x35, 0x2C)
#define REG_SC_BK35_2D_L      _PK_L_(0x35, 0x2D)
#define REG_SC_BK35_2D_H      _PK_H_(0x35, 0x2D)
#define REG_SC_BK35_2E_L      _PK_L_(0x35, 0x2E)
#define REG_SC_BK35_2E_H      _PK_H_(0x35, 0x2E)
#define REG_SC_BK35_2F_L      _PK_L_(0x35, 0x2F)
#define REG_SC_BK35_2F_H      _PK_H_(0x35, 0x2F)
#define REG_SC_BK35_30_L      _PK_L_(0x35, 0x30)
#define REG_SC_BK35_30_H      _PK_H_(0x35, 0x30)
#define REG_SC_BK35_31_L      _PK_L_(0x35, 0x31)
#define REG_SC_BK35_31_H      _PK_H_(0x35, 0x31)
#define REG_SC_BK35_32_L      _PK_L_(0x35, 0x32)
#define REG_SC_BK35_32_H      _PK_H_(0x35, 0x32)
#define REG_SC_BK35_33_L      _PK_L_(0x35, 0x33)
#define REG_SC_BK35_33_H      _PK_H_(0x35, 0x33)
#define REG_SC_BK35_34_L      _PK_L_(0x35, 0x34)
#define REG_SC_BK35_34_H      _PK_H_(0x35, 0x34)
#define REG_SC_BK35_35_L      _PK_L_(0x35, 0x35)
#define REG_SC_BK35_35_H      _PK_H_(0x35, 0x35)
#define REG_SC_BK35_36_L      _PK_L_(0x35, 0x36)
#define REG_SC_BK35_36_H      _PK_H_(0x35, 0x36)
#define REG_SC_BK35_37_L      _PK_L_(0x35, 0x37)
#define REG_SC_BK35_37_H      _PK_H_(0x35, 0x37)
#define REG_SC_BK35_38_L      _PK_L_(0x35, 0x38)
#define REG_SC_BK35_38_H      _PK_H_(0x35, 0x38)
#define REG_SC_BK35_39_L      _PK_L_(0x35, 0x39)
#define REG_SC_BK35_39_H      _PK_H_(0x35, 0x39)
#define REG_SC_BK35_3A_L      _PK_L_(0x35, 0x3A)
#define REG_SC_BK35_3A_H      _PK_H_(0x35, 0x3A)
#define REG_SC_BK35_3B_L      _PK_L_(0x35, 0x3B)
#define REG_SC_BK35_3B_H      _PK_H_(0x35, 0x3B)
#define REG_SC_BK35_3C_L      _PK_L_(0x35, 0x3C)
#define REG_SC_BK35_3C_H      _PK_H_(0x35, 0x3C)
#define REG_SC_BK35_3D_L      _PK_L_(0x35, 0x3D)
#define REG_SC_BK35_3D_H      _PK_H_(0x35, 0x3D)
#define REG_SC_BK35_3E_L      _PK_L_(0x35, 0x3E)
#define REG_SC_BK35_3E_H      _PK_H_(0x35, 0x3E)
#define REG_SC_BK35_3F_L      _PK_L_(0x35, 0x3F)
#define REG_SC_BK35_3F_H      _PK_H_(0x35, 0x3F)
#define REG_SC_BK35_40_L      _PK_L_(0x35, 0x40)
#define REG_SC_BK35_40_H      _PK_H_(0x35, 0x40)
#define REG_SC_BK35_41_L      _PK_L_(0x35, 0x41)
#define REG_SC_BK35_41_H      _PK_H_(0x35, 0x41)
#define REG_SC_BK35_42_L      _PK_L_(0x35, 0x42)
#define REG_SC_BK35_42_H      _PK_H_(0x35, 0x42)
#define REG_SC_BK35_43_L      _PK_L_(0x35, 0x43)
#define REG_SC_BK35_43_H      _PK_H_(0x35, 0x43)
#define REG_SC_BK35_44_L      _PK_L_(0x35, 0x44)
#define REG_SC_BK35_44_H      _PK_H_(0x35, 0x44)
#define REG_SC_BK35_45_L      _PK_L_(0x35, 0x45)
#define REG_SC_BK35_45_H      _PK_H_(0x35, 0x45)
#define REG_SC_BK35_46_L      _PK_L_(0x35, 0x46)
#define REG_SC_BK35_46_H      _PK_H_(0x35, 0x46)
#define REG_SC_BK35_47_L      _PK_L_(0x35, 0x47)
#define REG_SC_BK35_47_H      _PK_H_(0x35, 0x47)
#define REG_SC_BK35_48_L      _PK_L_(0x35, 0x48)
#define REG_SC_BK35_48_H      _PK_H_(0x35, 0x48)
#define REG_SC_BK35_49_L      _PK_L_(0x35, 0x49)
#define REG_SC_BK35_49_H      _PK_H_(0x35, 0x49)
#define REG_SC_BK35_4A_L      _PK_L_(0x35, 0x4A)
#define REG_SC_BK35_4A_H      _PK_H_(0x35, 0x4A)
#define REG_SC_BK35_4B_L      _PK_L_(0x35, 0x4B)
#define REG_SC_BK35_4B_H      _PK_H_(0x35, 0x4B)
#define REG_SC_BK35_4C_L      _PK_L_(0x35, 0x4C)
#define REG_SC_BK35_4C_H      _PK_H_(0x35, 0x4C)
#define REG_SC_BK35_4D_L      _PK_L_(0x35, 0x4D)
#define REG_SC_BK35_4D_H      _PK_H_(0x35, 0x4D)
#define REG_SC_BK35_4E_L      _PK_L_(0x35, 0x4E)
#define REG_SC_BK35_4E_H      _PK_H_(0x35, 0x4E)
#define REG_SC_BK35_4F_L      _PK_L_(0x35, 0x4F)
#define REG_SC_BK35_4F_H      _PK_H_(0x35, 0x4F)
#define REG_SC_BK35_50_L      _PK_L_(0x35, 0x50)
#define REG_SC_BK35_50_H      _PK_H_(0x35, 0x50)
#define REG_SC_BK35_51_L      _PK_L_(0x35, 0x51)
#define REG_SC_BK35_51_H      _PK_H_(0x35, 0x51)
#define REG_SC_BK35_52_L      _PK_L_(0x35, 0x52)
#define REG_SC_BK35_52_H      _PK_H_(0x35, 0x52)
#define REG_SC_BK35_53_L      _PK_L_(0x35, 0x53)
#define REG_SC_BK35_53_H      _PK_H_(0x35, 0x53)
#define REG_SC_BK35_54_L      _PK_L_(0x35, 0x54)
#define REG_SC_BK35_54_H      _PK_H_(0x35, 0x54)
#define REG_SC_BK35_55_L      _PK_L_(0x35, 0x55)
#define REG_SC_BK35_55_H      _PK_H_(0x35, 0x55)
#define REG_SC_BK35_56_L      _PK_L_(0x35, 0x56)
#define REG_SC_BK35_56_H      _PK_H_(0x35, 0x56)
#define REG_SC_BK35_57_L      _PK_L_(0x35, 0x57)
#define REG_SC_BK35_57_H      _PK_H_(0x35, 0x57)
#define REG_SC_BK35_58_L      _PK_L_(0x35, 0x58)
#define REG_SC_BK35_58_H      _PK_H_(0x35, 0x58)
#define REG_SC_BK35_59_L      _PK_L_(0x35, 0x59)
#define REG_SC_BK35_59_H      _PK_H_(0x35, 0x59)
#define REG_SC_BK35_5A_L      _PK_L_(0x35, 0x5A)
#define REG_SC_BK35_5A_H      _PK_H_(0x35, 0x5A)
#define REG_SC_BK35_5B_L      _PK_L_(0x35, 0x5B)
#define REG_SC_BK35_5B_H      _PK_H_(0x35, 0x5B)
#define REG_SC_BK35_5C_L      _PK_L_(0x35, 0x5C)
#define REG_SC_BK35_5C_H      _PK_H_(0x35, 0x5C)
#define REG_SC_BK35_5D_L      _PK_L_(0x35, 0x5D)
#define REG_SC_BK35_5D_H      _PK_H_(0x35, 0x5D)
#define REG_SC_BK35_5E_L      _PK_L_(0x35, 0x5E)
#define REG_SC_BK35_5E_H      _PK_H_(0x35, 0x5E)
#define REG_SC_BK35_5F_L      _PK_L_(0x35, 0x5F)
#define REG_SC_BK35_5F_H      _PK_H_(0x35, 0x5F)
#define REG_SC_BK35_60_L      _PK_L_(0x35, 0x60)
#define REG_SC_BK35_60_H      _PK_H_(0x35, 0x60)
#define REG_SC_BK35_61_L      _PK_L_(0x35, 0x61)
#define REG_SC_BK35_61_H      _PK_H_(0x35, 0x61)
#define REG_SC_BK35_62_L      _PK_L_(0x35, 0x62)
#define REG_SC_BK35_62_H      _PK_H_(0x35, 0x62)
#define REG_SC_BK35_63_L      _PK_L_(0x35, 0x63)
#define REG_SC_BK35_63_H      _PK_H_(0x35, 0x63)
#define REG_SC_BK35_64_L      _PK_L_(0x35, 0x64)
#define REG_SC_BK35_64_H      _PK_H_(0x35, 0x64)
#define REG_SC_BK35_65_L      _PK_L_(0x35, 0x65)
#define REG_SC_BK35_65_H      _PK_H_(0x35, 0x65)
#define REG_SC_BK35_66_L      _PK_L_(0x35, 0x66)
#define REG_SC_BK35_66_H      _PK_H_(0x35, 0x66)
#define REG_SC_BK35_67_L      _PK_L_(0x35, 0x67)
#define REG_SC_BK35_67_H      _PK_H_(0x35, 0x67)
#define REG_SC_BK35_68_L      _PK_L_(0x35, 0x68)
#define REG_SC_BK35_68_H      _PK_H_(0x35, 0x68)
#define REG_SC_BK35_69_L      _PK_L_(0x35, 0x69)
#define REG_SC_BK35_69_H      _PK_H_(0x35, 0x69)
#define REG_SC_BK35_6A_L      _PK_L_(0x35, 0x6A)
#define REG_SC_BK35_6A_H      _PK_H_(0x35, 0x6A)
#define REG_SC_BK35_6B_L      _PK_L_(0x35, 0x6B)
#define REG_SC_BK35_6B_H      _PK_H_(0x35, 0x6B)
#define REG_SC_BK35_6C_L      _PK_L_(0x35, 0x6C)
#define REG_SC_BK35_6C_H      _PK_H_(0x35, 0x6C)
#define REG_SC_BK35_6D_L      _PK_L_(0x35, 0x6D)
#define REG_SC_BK35_6D_H      _PK_H_(0x35, 0x6D)
#define REG_SC_BK35_6E_L      _PK_L_(0x35, 0x6E)
#define REG_SC_BK35_6E_H      _PK_H_(0x35, 0x6E)
#define REG_SC_BK35_6F_L      _PK_L_(0x35, 0x6F)
#define REG_SC_BK35_6F_H      _PK_H_(0x35, 0x6F)
#define REG_SC_BK35_70_L      _PK_L_(0x35, 0x70)
#define REG_SC_BK35_70_H      _PK_H_(0x35, 0x70)
#define REG_SC_BK35_71_L      _PK_L_(0x35, 0x71)
#define REG_SC_BK35_71_H      _PK_H_(0x35, 0x71)
#define REG_SC_BK35_72_L      _PK_L_(0x35, 0x72)
#define REG_SC_BK35_72_H      _PK_H_(0x35, 0x72)
#define REG_SC_BK35_73_L      _PK_L_(0x35, 0x73)
#define REG_SC_BK35_73_H      _PK_H_(0x35, 0x73)
#define REG_SC_BK35_74_L      _PK_L_(0x35, 0x74)
#define REG_SC_BK35_74_H      _PK_H_(0x35, 0x74)
#define REG_SC_BK35_75_L      _PK_L_(0x35, 0x75)
#define REG_SC_BK35_75_H      _PK_H_(0x35, 0x75)
#define REG_SC_BK35_76_L      _PK_L_(0x35, 0x76)
#define REG_SC_BK35_76_H      _PK_H_(0x35, 0x76)
#define REG_SC_BK35_77_L      _PK_L_(0x35, 0x77)
#define REG_SC_BK35_77_H      _PK_H_(0x35, 0x77)
#define REG_SC_BK35_78_L      _PK_L_(0x35, 0x78)
#define REG_SC_BK35_78_H      _PK_H_(0x35, 0x78)
#define REG_SC_BK35_79_L      _PK_L_(0x35, 0x79)
#define REG_SC_BK35_79_H      _PK_H_(0x35, 0x79)
#define REG_SC_BK35_7A_L      _PK_L_(0x35, 0x7A)
#define REG_SC_BK35_7A_H      _PK_H_(0x35, 0x7A)
#define REG_SC_BK35_7B_L      _PK_L_(0x35, 0x7B)
#define REG_SC_BK35_7B_H      _PK_H_(0x35, 0x7B)
#define REG_SC_BK35_7C_L      _PK_L_(0x35, 0x7C)
#define REG_SC_BK35_7C_H      _PK_H_(0x35, 0x7C)
#define REG_SC_BK35_7D_L      _PK_L_(0x35, 0x7D)
#define REG_SC_BK35_7D_H      _PK_H_(0x35, 0x7D)
#define REG_SC_BK35_7E_L      _PK_L_(0x35, 0x7E)
#define REG_SC_BK35_7E_H      _PK_H_(0x35, 0x7E)
#define REG_SC_BK35_7F_L      _PK_L_(0x35, 0x7F)
#define REG_SC_BK35_7F_H      _PK_H_(0x35, 0x7F)

//----------------------------------------------
//  BK36
//----------------------------------------------
#define REG_SC_BK36_00_L      _PK_L_(0x36, 0x00)
#define REG_SC_BK36_00_H      _PK_H_(0x36, 0x00)
#define REG_SC_BK36_01_L      _PK_L_(0x36, 0x01)
#define REG_SC_BK36_01_H      _PK_H_(0x36, 0x01)
#define REG_SC_BK36_02_L      _PK_L_(0x36, 0x02)
#define REG_SC_BK36_02_H      _PK_H_(0x36, 0x02)
#define REG_SC_BK36_03_L      _PK_L_(0x36, 0x03)
#define REG_SC_BK36_03_H      _PK_H_(0x36, 0x03)
#define REG_SC_BK36_04_L      _PK_L_(0x36, 0x04)
#define REG_SC_BK36_04_H      _PK_H_(0x36, 0x04)
#define REG_SC_BK36_05_L      _PK_L_(0x36, 0x05)
#define REG_SC_BK36_05_H      _PK_H_(0x36, 0x05)
#define REG_SC_BK36_06_L      _PK_L_(0x36, 0x06)
#define REG_SC_BK36_06_H      _PK_H_(0x36, 0x06)
#define REG_SC_BK36_07_L      _PK_L_(0x36, 0x07)
#define REG_SC_BK36_07_H      _PK_H_(0x36, 0x07)
#define REG_SC_BK36_08_L      _PK_L_(0x36, 0x08)
#define REG_SC_BK36_08_H      _PK_H_(0x36, 0x08)
#define REG_SC_BK36_09_L      _PK_L_(0x36, 0x09)
#define REG_SC_BK36_09_H      _PK_H_(0x36, 0x09)
#define REG_SC_BK36_0A_L      _PK_L_(0x36, 0x0A)
#define REG_SC_BK36_0A_H      _PK_H_(0x36, 0x0A)
#define REG_SC_BK36_0B_L      _PK_L_(0x36, 0x0B)
#define REG_SC_BK36_0B_H      _PK_H_(0x36, 0x0B)
#define REG_SC_BK36_0C_L      _PK_L_(0x36, 0x0C)
#define REG_SC_BK36_0C_H      _PK_H_(0x36, 0x0C)
#define REG_SC_BK36_0D_L      _PK_L_(0x36, 0x0D)
#define REG_SC_BK36_0D_H      _PK_H_(0x36, 0x0D)
#define REG_SC_BK36_0E_L      _PK_L_(0x36, 0x0E)
#define REG_SC_BK36_0E_H      _PK_H_(0x36, 0x0E)
#define REG_SC_BK36_0F_L      _PK_L_(0x36, 0x0F)
#define REG_SC_BK36_0F_H      _PK_H_(0x36, 0x0F)
#define REG_SC_BK36_10_L      _PK_L_(0x36, 0x10)
#define REG_SC_BK36_10_H      _PK_H_(0x36, 0x10)
#define REG_SC_BK36_11_L      _PK_L_(0x36, 0x11)
#define REG_SC_BK36_11_H      _PK_H_(0x36, 0x11)
#define REG_SC_BK36_12_L      _PK_L_(0x36, 0x12)
#define REG_SC_BK36_12_H      _PK_H_(0x36, 0x12)
#define REG_SC_BK36_13_L      _PK_L_(0x36, 0x13)
#define REG_SC_BK36_13_H      _PK_H_(0x36, 0x13)
#define REG_SC_BK36_14_L      _PK_L_(0x36, 0x14)
#define REG_SC_BK36_14_H      _PK_H_(0x36, 0x14)
#define REG_SC_BK36_15_L      _PK_L_(0x36, 0x15)
#define REG_SC_BK36_15_H      _PK_H_(0x36, 0x15)
#define REG_SC_BK36_16_L      _PK_L_(0x36, 0x16)
#define REG_SC_BK36_16_H      _PK_H_(0x36, 0x16)
#define REG_SC_BK36_17_L      _PK_L_(0x36, 0x17)
#define REG_SC_BK36_17_H      _PK_H_(0x36, 0x17)
#define REG_SC_BK36_18_L      _PK_L_(0x36, 0x18)
#define REG_SC_BK36_18_H      _PK_H_(0x36, 0x18)
#define REG_SC_BK36_19_L      _PK_L_(0x36, 0x19)
#define REG_SC_BK36_19_H      _PK_H_(0x36, 0x19)
#define REG_SC_BK36_1A_L      _PK_L_(0x36, 0x1A)
#define REG_SC_BK36_1A_H      _PK_H_(0x36, 0x1A)
#define REG_SC_BK36_1B_L      _PK_L_(0x36, 0x1B)
#define REG_SC_BK36_1B_H      _PK_H_(0x36, 0x1B)
#define REG_SC_BK36_1C_L      _PK_L_(0x36, 0x1C)
#define REG_SC_BK36_1C_H      _PK_H_(0x36, 0x1C)
#define REG_SC_BK36_1D_L      _PK_L_(0x36, 0x1D)
#define REG_SC_BK36_1D_H      _PK_H_(0x36, 0x1D)
#define REG_SC_BK36_1E_L      _PK_L_(0x36, 0x1E)
#define REG_SC_BK36_1E_H      _PK_H_(0x36, 0x1E)
#define REG_SC_BK36_1F_L      _PK_L_(0x36, 0x1F)
#define REG_SC_BK36_1F_H      _PK_H_(0x36, 0x1F)
#define REG_SC_BK36_20_L      _PK_L_(0x36, 0x20)
#define REG_SC_BK36_20_H      _PK_H_(0x36, 0x20)
#define REG_SC_BK36_21_L      _PK_L_(0x36, 0x21)
#define REG_SC_BK36_21_H      _PK_H_(0x36, 0x21)
#define REG_SC_BK36_22_L      _PK_L_(0x36, 0x22)
#define REG_SC_BK36_22_H      _PK_H_(0x36, 0x22)
#define REG_SC_BK36_23_L      _PK_L_(0x36, 0x23)
#define REG_SC_BK36_23_H      _PK_H_(0x36, 0x23)
#define REG_SC_BK36_24_L      _PK_L_(0x36, 0x24)
#define REG_SC_BK36_24_H      _PK_H_(0x36, 0x24)
#define REG_SC_BK36_25_L      _PK_L_(0x36, 0x25)
#define REG_SC_BK36_25_H      _PK_H_(0x36, 0x25)
#define REG_SC_BK36_26_L      _PK_L_(0x36, 0x26)
#define REG_SC_BK36_26_H      _PK_H_(0x36, 0x26)
#define REG_SC_BK36_27_L      _PK_L_(0x36, 0x27)
#define REG_SC_BK36_27_H      _PK_H_(0x36, 0x27)
#define REG_SC_BK36_28_L      _PK_L_(0x36, 0x28)
#define REG_SC_BK36_28_H      _PK_H_(0x36, 0x28)
#define REG_SC_BK36_29_L      _PK_L_(0x36, 0x29)
#define REG_SC_BK36_29_H      _PK_H_(0x36, 0x29)
#define REG_SC_BK36_2A_L      _PK_L_(0x36, 0x2A)
#define REG_SC_BK36_2A_H      _PK_H_(0x36, 0x2A)
#define REG_SC_BK36_2B_L      _PK_L_(0x36, 0x2B)
#define REG_SC_BK36_2B_H      _PK_H_(0x36, 0x2B)
#define REG_SC_BK36_2C_L      _PK_L_(0x36, 0x2C)
#define REG_SC_BK36_2C_H      _PK_H_(0x36, 0x2C)
#define REG_SC_BK36_2D_L      _PK_L_(0x36, 0x2D)
#define REG_SC_BK36_2D_H      _PK_H_(0x36, 0x2D)
#define REG_SC_BK36_2E_L      _PK_L_(0x36, 0x2E)
#define REG_SC_BK36_2E_H      _PK_H_(0x36, 0x2E)
#define REG_SC_BK36_2F_L      _PK_L_(0x36, 0x2F)
#define REG_SC_BK36_2F_H      _PK_H_(0x36, 0x2F)
#define REG_SC_BK36_30_L      _PK_L_(0x36, 0x30)
#define REG_SC_BK36_30_H      _PK_H_(0x36, 0x30)
#define REG_SC_BK36_31_L      _PK_L_(0x36, 0x31)
#define REG_SC_BK36_31_H      _PK_H_(0x36, 0x31)
#define REG_SC_BK36_32_L      _PK_L_(0x36, 0x32)
#define REG_SC_BK36_32_H      _PK_H_(0x36, 0x32)
#define REG_SC_BK36_33_L      _PK_L_(0x36, 0x33)
#define REG_SC_BK36_33_H      _PK_H_(0x36, 0x33)
#define REG_SC_BK36_34_L      _PK_L_(0x36, 0x34)
#define REG_SC_BK36_34_H      _PK_H_(0x36, 0x34)
#define REG_SC_BK36_35_L      _PK_L_(0x36, 0x35)
#define REG_SC_BK36_35_H      _PK_H_(0x36, 0x35)
#define REG_SC_BK36_36_L      _PK_L_(0x36, 0x36)
#define REG_SC_BK36_36_H      _PK_H_(0x36, 0x36)
#define REG_SC_BK36_37_L      _PK_L_(0x36, 0x37)
#define REG_SC_BK36_37_H      _PK_H_(0x36, 0x37)
#define REG_SC_BK36_38_L      _PK_L_(0x36, 0x38)
#define REG_SC_BK36_38_H      _PK_H_(0x36, 0x38)
#define REG_SC_BK36_39_L      _PK_L_(0x36, 0x39)
#define REG_SC_BK36_39_H      _PK_H_(0x36, 0x39)
#define REG_SC_BK36_3A_L      _PK_L_(0x36, 0x3A)
#define REG_SC_BK36_3A_H      _PK_H_(0x36, 0x3A)
#define REG_SC_BK36_3B_L      _PK_L_(0x36, 0x3B)
#define REG_SC_BK36_3B_H      _PK_H_(0x36, 0x3B)
#define REG_SC_BK36_3C_L      _PK_L_(0x36, 0x3C)
#define REG_SC_BK36_3C_H      _PK_H_(0x36, 0x3C)
#define REG_SC_BK36_3D_L      _PK_L_(0x36, 0x3D)
#define REG_SC_BK36_3D_H      _PK_H_(0x36, 0x3D)
#define REG_SC_BK36_3E_L      _PK_L_(0x36, 0x3E)
#define REG_SC_BK36_3E_H      _PK_H_(0x36, 0x3E)
#define REG_SC_BK36_3F_L      _PK_L_(0x36, 0x3F)
#define REG_SC_BK36_3F_H      _PK_H_(0x36, 0x3F)
#define REG_SC_BK36_40_L      _PK_L_(0x36, 0x40)
#define REG_SC_BK36_40_H      _PK_H_(0x36, 0x40)
#define REG_SC_BK36_41_L      _PK_L_(0x36, 0x41)
#define REG_SC_BK36_41_H      _PK_H_(0x36, 0x41)
#define REG_SC_BK36_42_L      _PK_L_(0x36, 0x42)
#define REG_SC_BK36_42_H      _PK_H_(0x36, 0x42)
#define REG_SC_BK36_43_L      _PK_L_(0x36, 0x43)
#define REG_SC_BK36_43_H      _PK_H_(0x36, 0x43)
#define REG_SC_BK36_44_L      _PK_L_(0x36, 0x44)
#define REG_SC_BK36_44_H      _PK_H_(0x36, 0x44)
#define REG_SC_BK36_45_L      _PK_L_(0x36, 0x45)
#define REG_SC_BK36_45_H      _PK_H_(0x36, 0x45)
#define REG_SC_BK36_46_L      _PK_L_(0x36, 0x46)
#define REG_SC_BK36_46_H      _PK_H_(0x36, 0x46)
#define REG_SC_BK36_47_L      _PK_L_(0x36, 0x47)
#define REG_SC_BK36_47_H      _PK_H_(0x36, 0x47)
#define REG_SC_BK36_48_L      _PK_L_(0x36, 0x48)
#define REG_SC_BK36_48_H      _PK_H_(0x36, 0x48)
#define REG_SC_BK36_49_L      _PK_L_(0x36, 0x49)
#define REG_SC_BK36_49_H      _PK_H_(0x36, 0x49)
#define REG_SC_BK36_4A_L      _PK_L_(0x36, 0x4A)
#define REG_SC_BK36_4A_H      _PK_H_(0x36, 0x4A)
#define REG_SC_BK36_4B_L      _PK_L_(0x36, 0x4B)
#define REG_SC_BK36_4B_H      _PK_H_(0x36, 0x4B)
#define REG_SC_BK36_4C_L      _PK_L_(0x36, 0x4C)
#define REG_SC_BK36_4C_H      _PK_H_(0x36, 0x4C)
#define REG_SC_BK36_4D_L      _PK_L_(0x36, 0x4D)
#define REG_SC_BK36_4D_H      _PK_H_(0x36, 0x4D)
#define REG_SC_BK36_4E_L      _PK_L_(0x36, 0x4E)
#define REG_SC_BK36_4E_H      _PK_H_(0x36, 0x4E)
#define REG_SC_BK36_4F_L      _PK_L_(0x36, 0x4F)
#define REG_SC_BK36_4F_H      _PK_H_(0x36, 0x4F)
#define REG_SC_BK36_50_L      _PK_L_(0x36, 0x50)
#define REG_SC_BK36_50_H      _PK_H_(0x36, 0x50)
#define REG_SC_BK36_51_L      _PK_L_(0x36, 0x51)
#define REG_SC_BK36_51_H      _PK_H_(0x36, 0x51)
#define REG_SC_BK36_52_L      _PK_L_(0x36, 0x52)
#define REG_SC_BK36_52_H      _PK_H_(0x36, 0x52)
#define REG_SC_BK36_53_L      _PK_L_(0x36, 0x53)
#define REG_SC_BK36_53_H      _PK_H_(0x36, 0x53)
#define REG_SC_BK36_54_L      _PK_L_(0x36, 0x54)
#define REG_SC_BK36_54_H      _PK_H_(0x36, 0x54)
#define REG_SC_BK36_55_L      _PK_L_(0x36, 0x55)
#define REG_SC_BK36_55_H      _PK_H_(0x36, 0x55)
#define REG_SC_BK36_56_L      _PK_L_(0x36, 0x56)
#define REG_SC_BK36_56_H      _PK_H_(0x36, 0x56)
#define REG_SC_BK36_57_L      _PK_L_(0x36, 0x57)
#define REG_SC_BK36_57_H      _PK_H_(0x36, 0x57)
#define REG_SC_BK36_58_L      _PK_L_(0x36, 0x58)
#define REG_SC_BK36_58_H      _PK_H_(0x36, 0x58)
#define REG_SC_BK36_59_L      _PK_L_(0x36, 0x59)
#define REG_SC_BK36_59_H      _PK_H_(0x36, 0x59)
#define REG_SC_BK36_5A_L      _PK_L_(0x36, 0x5A)
#define REG_SC_BK36_5A_H      _PK_H_(0x36, 0x5A)
#define REG_SC_BK36_5B_L      _PK_L_(0x36, 0x5B)
#define REG_SC_BK36_5B_H      _PK_H_(0x36, 0x5B)
#define REG_SC_BK36_5C_L      _PK_L_(0x36, 0x5C)
#define REG_SC_BK36_5C_H      _PK_H_(0x36, 0x5C)
#define REG_SC_BK36_5D_L      _PK_L_(0x36, 0x5D)
#define REG_SC_BK36_5D_H      _PK_H_(0x36, 0x5D)
#define REG_SC_BK36_5E_L      _PK_L_(0x36, 0x5E)
#define REG_SC_BK36_5E_H      _PK_H_(0x36, 0x5E)
#define REG_SC_BK36_5F_L      _PK_L_(0x36, 0x5F)
#define REG_SC_BK36_5F_H      _PK_H_(0x36, 0x5F)
#define REG_SC_BK36_60_L      _PK_L_(0x36, 0x60)
#define REG_SC_BK36_60_H      _PK_H_(0x36, 0x60)
#define REG_SC_BK36_61_L      _PK_L_(0x36, 0x61)
#define REG_SC_BK36_61_H      _PK_H_(0x36, 0x61)
#define REG_SC_BK36_62_L      _PK_L_(0x36, 0x62)
#define REG_SC_BK36_62_H      _PK_H_(0x36, 0x62)
#define REG_SC_BK36_63_L      _PK_L_(0x36, 0x63)
#define REG_SC_BK36_63_H      _PK_H_(0x36, 0x63)
#define REG_SC_BK36_64_L      _PK_L_(0x36, 0x64)
#define REG_SC_BK36_64_H      _PK_H_(0x36, 0x64)
#define REG_SC_BK36_65_L      _PK_L_(0x36, 0x65)
#define REG_SC_BK36_65_H      _PK_H_(0x36, 0x65)
#define REG_SC_BK36_66_L      _PK_L_(0x36, 0x66)
#define REG_SC_BK36_66_H      _PK_H_(0x36, 0x66)
#define REG_SC_BK36_67_L      _PK_L_(0x36, 0x67)
#define REG_SC_BK36_67_H      _PK_H_(0x36, 0x67)
#define REG_SC_BK36_68_L      _PK_L_(0x36, 0x68)
#define REG_SC_BK36_68_H      _PK_H_(0x36, 0x68)
#define REG_SC_BK36_69_L      _PK_L_(0x36, 0x69)
#define REG_SC_BK36_69_H      _PK_H_(0x36, 0x69)
#define REG_SC_BK36_6A_L      _PK_L_(0x36, 0x6A)
#define REG_SC_BK36_6A_H      _PK_H_(0x36, 0x6A)
#define REG_SC_BK36_6B_L      _PK_L_(0x36, 0x6B)
#define REG_SC_BK36_6B_H      _PK_H_(0x36, 0x6B)
#define REG_SC_BK36_6C_L      _PK_L_(0x36, 0x6C)
#define REG_SC_BK36_6C_H      _PK_H_(0x36, 0x6C)
#define REG_SC_BK36_6D_L      _PK_L_(0x36, 0x6D)
#define REG_SC_BK36_6D_H      _PK_H_(0x36, 0x6D)
#define REG_SC_BK36_6E_L      _PK_L_(0x36, 0x6E)
#define REG_SC_BK36_6E_H      _PK_H_(0x36, 0x6E)
#define REG_SC_BK36_6F_L      _PK_L_(0x36, 0x6F)
#define REG_SC_BK36_6F_H      _PK_H_(0x36, 0x6F)
#define REG_SC_BK36_70_L      _PK_L_(0x36, 0x70)
#define REG_SC_BK36_70_H      _PK_H_(0x36, 0x70)
#define REG_SC_BK36_71_L      _PK_L_(0x36, 0x71)
#define REG_SC_BK36_71_H      _PK_H_(0x36, 0x71)
#define REG_SC_BK36_72_L      _PK_L_(0x36, 0x72)
#define REG_SC_BK36_72_H      _PK_H_(0x36, 0x72)
#define REG_SC_BK36_73_L      _PK_L_(0x36, 0x73)
#define REG_SC_BK36_73_H      _PK_H_(0x36, 0x73)
#define REG_SC_BK36_74_L      _PK_L_(0x36, 0x74)
#define REG_SC_BK36_74_H      _PK_H_(0x36, 0x74)
#define REG_SC_BK36_75_L      _PK_L_(0x36, 0x75)
#define REG_SC_BK36_75_H      _PK_H_(0x36, 0x75)
#define REG_SC_BK36_76_L      _PK_L_(0x36, 0x76)
#define REG_SC_BK36_76_H      _PK_H_(0x36, 0x76)
#define REG_SC_BK36_77_L      _PK_L_(0x36, 0x77)
#define REG_SC_BK36_77_H      _PK_H_(0x36, 0x77)
#define REG_SC_BK36_78_L      _PK_L_(0x36, 0x78)
#define REG_SC_BK36_78_H      _PK_H_(0x36, 0x78)
#define REG_SC_BK36_79_L      _PK_L_(0x36, 0x79)
#define REG_SC_BK36_79_H      _PK_H_(0x36, 0x79)
#define REG_SC_BK36_7A_L      _PK_L_(0x36, 0x7A)
#define REG_SC_BK36_7A_H      _PK_H_(0x36, 0x7A)
#define REG_SC_BK36_7B_L      _PK_L_(0x36, 0x7B)
#define REG_SC_BK36_7B_H      _PK_H_(0x36, 0x7B)
#define REG_SC_BK36_7C_L      _PK_L_(0x36, 0x7C)
#define REG_SC_BK36_7C_H      _PK_H_(0x36, 0x7C)
#define REG_SC_BK36_7D_L      _PK_L_(0x36, 0x7D)
#define REG_SC_BK36_7D_H      _PK_H_(0x36, 0x7D)
#define REG_SC_BK36_7E_L      _PK_L_(0x36, 0x7E)
#define REG_SC_BK36_7E_H      _PK_H_(0x36, 0x7E)
#define REG_SC_BK36_7F_L      _PK_L_(0x36, 0x7F)
#define REG_SC_BK36_7F_H      _PK_H_(0x36, 0x7F)

//----------------------------------------------
//  BK37: OC
//----------------------------------------------
#define REG_SC_BK37_01_L      _PK_L_(0x37, 0x01)
#define REG_SC_BK37_01_H      _PK_H_(0x37, 0x01)
#define REG_SC_BK37_02_L      _PK_L_(0x37, 0x02)
#define REG_SC_BK37_02_H      _PK_H_(0x37, 0x02)
#define REG_SC_BK37_03_L      _PK_L_(0x37, 0x03)
#define REG_SC_BK37_03_H      _PK_H_(0x37, 0x03)
#define REG_SC_BK37_04_L      _PK_L_(0x37, 0x04)
#define REG_SC_BK37_04_H      _PK_H_(0x37, 0x04)
#define REG_SC_BK37_05_L      _PK_L_(0x37, 0x05)
#define REG_SC_BK37_05_H      _PK_H_(0x37, 0x05)
#define REG_SC_BK37_06_L      _PK_L_(0x37, 0x06)
#define REG_SC_BK37_06_H      _PK_H_(0x37, 0x06)
#define REG_SC_BK37_07_L      _PK_L_(0x37, 0x07)
#define REG_SC_BK37_07_H      _PK_H_(0x37, 0x07)
#define REG_SC_BK37_08_L      _PK_L_(0x37, 0x08)
#define REG_SC_BK37_08_H      _PK_H_(0x37, 0x08)
#define REG_SC_BK37_09_L      _PK_L_(0x37, 0x09)
#define REG_SC_BK37_09_H      _PK_H_(0x37, 0x09)
#define REG_SC_BK37_0A_L      _PK_L_(0x37, 0x0A)
#define REG_SC_BK37_0A_H      _PK_H_(0x37, 0x0A)
#define REG_SC_BK37_0B_L      _PK_L_(0x37, 0x0B)
#define REG_SC_BK37_0B_H      _PK_H_(0x37, 0x0B)
#define REG_SC_BK37_0C_L      _PK_L_(0x37, 0x0C)
#define REG_SC_BK37_0C_H      _PK_H_(0x37, 0x0C)
#define REG_SC_BK37_0D_L      _PK_L_(0x37, 0x0D)
#define REG_SC_BK37_0D_H      _PK_H_(0x37, 0x0D)
#define REG_SC_BK37_0E_L      _PK_L_(0x37, 0x0E)
#define REG_SC_BK37_0E_H      _PK_H_(0x37, 0x0E)
#define REG_SC_BK37_0F_L      _PK_L_(0x37, 0x0F)
#define REG_SC_BK37_0F_H      _PK_H_(0x37, 0x0F)
#define REG_SC_BK37_10_L      _PK_L_(0x37, 0x10)
#define REG_SC_BK37_10_H      _PK_H_(0x37, 0x10)
#define REG_SC_BK37_11_L      _PK_L_(0x37, 0x11)
#define REG_SC_BK37_11_H      _PK_H_(0x37, 0x11)
#define REG_SC_BK37_12_L      _PK_L_(0x37, 0x12)
#define REG_SC_BK37_12_H      _PK_H_(0x37, 0x12)
#define REG_SC_BK37_13_L      _PK_L_(0x37, 0x13)
#define REG_SC_BK37_13_H      _PK_H_(0x37, 0x13)
#define REG_SC_BK37_14_L      _PK_L_(0x37, 0x14)
#define REG_SC_BK37_14_H      _PK_H_(0x37, 0x14)
#define REG_SC_BK37_15_L      _PK_L_(0x37, 0x15)
#define REG_SC_BK37_15_H      _PK_H_(0x37, 0x15)
#define REG_SC_BK37_16_L      _PK_L_(0x37, 0x16)
#define REG_SC_BK37_16_H      _PK_H_(0x37, 0x16)
#define REG_SC_BK37_17_L      _PK_L_(0x37, 0x17)
#define REG_SC_BK37_17_H      _PK_H_(0x37, 0x17)
#define REG_SC_BK37_18_L      _PK_L_(0x37, 0x18)
#define REG_SC_BK37_18_H      _PK_H_(0x37, 0x18)
#define REG_SC_BK37_19_L      _PK_L_(0x37, 0x19)
#define REG_SC_BK37_19_H      _PK_H_(0x37, 0x19)
#define REG_SC_BK37_1A_L      _PK_L_(0x37, 0x1A)
#define REG_SC_BK37_1A_H      _PK_H_(0x37, 0x1A)
#define REG_SC_BK37_1B_L      _PK_L_(0x37, 0x1B)
#define REG_SC_BK37_1B_H      _PK_H_(0x37, 0x1B)
#define REG_SC_BK37_1C_L      _PK_L_(0x37, 0x1C)
#define REG_SC_BK37_1C_H      _PK_H_(0x37, 0x1C)
#define REG_SC_BK37_1D_L      _PK_L_(0x37, 0x1D)
#define REG_SC_BK37_1D_H      _PK_H_(0x37, 0x1D)
#define REG_SC_BK37_1E_L      _PK_L_(0x37, 0x1E)
#define REG_SC_BK37_1E_H      _PK_H_(0x37, 0x1E)
#define REG_SC_BK37_1F_L      _PK_L_(0x37, 0x1F)
#define REG_SC_BK37_1F_H      _PK_H_(0x37, 0x1F)
#define REG_SC_BK37_20_L      _PK_L_(0x37, 0x20)
#define REG_SC_BK37_20_H      _PK_H_(0x37, 0x20)
#define REG_SC_BK37_21_L      _PK_L_(0x37, 0x21)
#define REG_SC_BK37_21_H      _PK_H_(0x37, 0x21)
#define REG_SC_BK37_22_L      _PK_L_(0x37, 0x22)
#define REG_SC_BK37_22_H      _PK_H_(0x37, 0x22)
#define REG_SC_BK37_23_L      _PK_L_(0x37, 0x23)
#define REG_SC_BK37_23_H      _PK_H_(0x37, 0x23)
#define REG_SC_BK37_24_L      _PK_L_(0x37, 0x24)
#define REG_SC_BK37_24_H      _PK_H_(0x37, 0x24)
#define REG_SC_BK37_25_L      _PK_L_(0x37, 0x25)
#define REG_SC_BK37_25_H      _PK_H_(0x37, 0x25)
#define REG_SC_BK37_26_L      _PK_L_(0x37, 0x26)
#define REG_SC_BK37_26_H      _PK_H_(0x37, 0x26)
#define REG_SC_BK37_27_L      _PK_L_(0x37, 0x27)
#define REG_SC_BK37_27_H      _PK_H_(0x37, 0x27)
#define REG_SC_BK37_28_L      _PK_L_(0x37, 0x28)
#define REG_SC_BK37_28_H      _PK_H_(0x37, 0x28)
#define REG_SC_BK37_29_L      _PK_L_(0x37, 0x29)
#define REG_SC_BK37_29_H      _PK_H_(0x37, 0x29)
#define REG_SC_BK37_2A_L      _PK_L_(0x37, 0x2A)
#define REG_SC_BK37_2A_H      _PK_H_(0x37, 0x2A)
#define REG_SC_BK37_2B_L      _PK_L_(0x37, 0x2B)
#define REG_SC_BK37_2B_H      _PK_H_(0x37, 0x2B)
#define REG_SC_BK37_2C_L      _PK_L_(0x37, 0x2C)
#define REG_SC_BK37_2C_H      _PK_H_(0x37, 0x2C)
#define REG_SC_BK37_2D_L      _PK_L_(0x37, 0x2D)
#define REG_SC_BK37_2D_H      _PK_H_(0x37, 0x2D)
#define REG_SC_BK37_2E_L      _PK_L_(0x37, 0x2E)
#define REG_SC_BK37_2E_H      _PK_H_(0x37, 0x2E)
#define REG_SC_BK37_2F_L      _PK_L_(0x37, 0x2F)
#define REG_SC_BK37_2F_H      _PK_H_(0x37, 0x2F)

//----------------------------------------------
//  BK38
//----------------------------------------------
#define REG_SC_BK38_00_L      _PK_L_(0x38, 0x00)
#define REG_SC_BK38_00_H      _PK_H_(0x38, 0x00)
#define REG_SC_BK38_01_L      _PK_L_(0x38, 0x01)
#define REG_SC_BK38_01_H      _PK_H_(0x38, 0x01)
#define REG_SC_BK38_02_L      _PK_L_(0x38, 0x02)
#define REG_SC_BK38_02_H      _PK_H_(0x38, 0x02)
#define REG_SC_BK38_03_L      _PK_L_(0x38, 0x03)
#define REG_SC_BK38_03_H      _PK_H_(0x38, 0x03)
#define REG_SC_BK38_04_L      _PK_L_(0x38, 0x04)
#define REG_SC_BK38_04_H      _PK_H_(0x38, 0x04)
#define REG_SC_BK38_05_L      _PK_L_(0x38, 0x05)
#define REG_SC_BK38_05_H      _PK_H_(0x38, 0x05)
#define REG_SC_BK38_06_L      _PK_L_(0x38, 0x06)
#define REG_SC_BK38_06_H      _PK_H_(0x38, 0x06)
#define REG_SC_BK38_07_L      _PK_L_(0x38, 0x07)
#define REG_SC_BK38_07_H      _PK_H_(0x38, 0x07)
#define REG_SC_BK38_08_L      _PK_L_(0x38, 0x08)
#define REG_SC_BK38_08_H      _PK_H_(0x38, 0x08)
#define REG_SC_BK38_09_L      _PK_L_(0x38, 0x09)
#define REG_SC_BK38_09_H      _PK_H_(0x38, 0x09)
#define REG_SC_BK38_0A_L      _PK_L_(0x38, 0x0A)
#define REG_SC_BK38_0A_H      _PK_H_(0x38, 0x0A)
#define REG_SC_BK38_0B_L      _PK_L_(0x38, 0x0B)
#define REG_SC_BK38_0B_H      _PK_H_(0x38, 0x0B)
#define REG_SC_BK38_0C_L      _PK_L_(0x38, 0x0C)
#define REG_SC_BK38_0C_H      _PK_H_(0x38, 0x0C)
#define REG_SC_BK38_0D_L      _PK_L_(0x38, 0x0D)
#define REG_SC_BK38_0D_H      _PK_H_(0x38, 0x0D)
#define REG_SC_BK38_0E_L      _PK_L_(0x38, 0x0E)
#define REG_SC_BK38_0E_H      _PK_H_(0x38, 0x0E)
#define REG_SC_BK38_0F_L      _PK_L_(0x38, 0x0F)
#define REG_SC_BK38_0F_H      _PK_H_(0x38, 0x0F)
#define REG_SC_BK38_10_L      _PK_L_(0x38, 0x10)
#define REG_SC_BK38_10_H      _PK_H_(0x38, 0x10)
#define REG_SC_BK38_11_L      _PK_L_(0x38, 0x11)
#define REG_SC_BK38_11_H      _PK_H_(0x38, 0x11)
#define REG_SC_BK38_12_L      _PK_L_(0x38, 0x12)
#define REG_SC_BK38_12_H      _PK_H_(0x38, 0x12)
#define REG_SC_BK38_13_L      _PK_L_(0x38, 0x13)
#define REG_SC_BK38_13_H      _PK_H_(0x38, 0x13)
#define REG_SC_BK38_14_L      _PK_L_(0x38, 0x14)
#define REG_SC_BK38_14_H      _PK_H_(0x38, 0x14)
#define REG_SC_BK38_15_L      _PK_L_(0x38, 0x15)
#define REG_SC_BK38_15_H      _PK_H_(0x38, 0x15)
#define REG_SC_BK38_16_L      _PK_L_(0x38, 0x16)
#define REG_SC_BK38_16_H      _PK_H_(0x38, 0x16)
#define REG_SC_BK38_17_L      _PK_L_(0x38, 0x17)
#define REG_SC_BK38_17_H      _PK_H_(0x38, 0x17)
#define REG_SC_BK38_18_L      _PK_L_(0x38, 0x18)
#define REG_SC_BK38_18_H      _PK_H_(0x38, 0x18)
#define REG_SC_BK38_19_L      _PK_L_(0x38, 0x19)
#define REG_SC_BK38_19_H      _PK_H_(0x38, 0x19)
#define REG_SC_BK38_1A_L      _PK_L_(0x38, 0x1A)
#define REG_SC_BK38_1A_H      _PK_H_(0x38, 0x1A)
#define REG_SC_BK38_1B_L      _PK_L_(0x38, 0x1B)
#define REG_SC_BK38_1B_H      _PK_H_(0x38, 0x1B)
#define REG_SC_BK38_1C_L      _PK_L_(0x38, 0x1C)
#define REG_SC_BK38_1C_H      _PK_H_(0x38, 0x1C)
#define REG_SC_BK38_1D_L      _PK_L_(0x38, 0x1D)
#define REG_SC_BK38_1D_H      _PK_H_(0x38, 0x1D)
#define REG_SC_BK38_1E_L      _PK_L_(0x38, 0x1E)
#define REG_SC_BK38_1E_H      _PK_H_(0x38, 0x1E)
#define REG_SC_BK38_1F_L      _PK_L_(0x38, 0x1F)
#define REG_SC_BK38_1F_H      _PK_H_(0x38, 0x1F)
#define REG_SC_BK38_20_L      _PK_L_(0x38, 0x20)
#define REG_SC_BK38_20_H      _PK_H_(0x38, 0x20)
#define REG_SC_BK38_21_L      _PK_L_(0x38, 0x21)
#define REG_SC_BK38_21_H      _PK_H_(0x38, 0x21)
#define REG_SC_BK38_22_L      _PK_L_(0x38, 0x22)
#define REG_SC_BK38_22_H      _PK_H_(0x38, 0x22)
#define REG_SC_BK38_23_L      _PK_L_(0x38, 0x23)
#define REG_SC_BK38_23_H      _PK_H_(0x38, 0x23)
#define REG_SC_BK38_24_L      _PK_L_(0x38, 0x24)
#define REG_SC_BK38_24_H      _PK_H_(0x38, 0x24)
#define REG_SC_BK38_25_L      _PK_L_(0x38, 0x25)
#define REG_SC_BK38_25_H      _PK_H_(0x38, 0x25)
#define REG_SC_BK38_26_L      _PK_L_(0x38, 0x26)
#define REG_SC_BK38_26_H      _PK_H_(0x38, 0x26)
#define REG_SC_BK38_27_L      _PK_L_(0x38, 0x27)
#define REG_SC_BK38_27_H      _PK_H_(0x38, 0x27)
#define REG_SC_BK38_28_L      _PK_L_(0x38, 0x28)
#define REG_SC_BK38_28_H      _PK_H_(0x38, 0x28)
#define REG_SC_BK38_29_L      _PK_L_(0x38, 0x29)
#define REG_SC_BK38_29_H      _PK_H_(0x38, 0x29)
#define REG_SC_BK38_2A_L      _PK_L_(0x38, 0x2A)
#define REG_SC_BK38_2A_H      _PK_H_(0x38, 0x2A)
#define REG_SC_BK38_2B_L      _PK_L_(0x38, 0x2B)
#define REG_SC_BK38_2B_H      _PK_H_(0x38, 0x2B)
#define REG_SC_BK38_2C_L      _PK_L_(0x38, 0x2C)
#define REG_SC_BK38_2C_H      _PK_H_(0x38, 0x2C)
#define REG_SC_BK38_2D_L      _PK_L_(0x38, 0x2D)
#define REG_SC_BK38_2D_H      _PK_H_(0x38, 0x2D)
#define REG_SC_BK38_2E_L      _PK_L_(0x38, 0x2E)
#define REG_SC_BK38_2E_H      _PK_H_(0x38, 0x2E)
#define REG_SC_BK38_2F_L      _PK_L_(0x38, 0x2F)
#define REG_SC_BK38_2F_H      _PK_H_(0x38, 0x2F)
#define REG_SC_BK38_30_L      _PK_L_(0x38, 0x30)
#define REG_SC_BK38_30_H      _PK_H_(0x38, 0x30)
#define REG_SC_BK38_31_L      _PK_L_(0x38, 0x31)
#define REG_SC_BK38_31_H      _PK_H_(0x38, 0x31)
#define REG_SC_BK38_32_L      _PK_L_(0x38, 0x32)
#define REG_SC_BK38_32_H      _PK_H_(0x38, 0x32)
#define REG_SC_BK38_33_L      _PK_L_(0x38, 0x33)
#define REG_SC_BK38_33_H      _PK_H_(0x38, 0x33)
#define REG_SC_BK38_34_L      _PK_L_(0x38, 0x34)
#define REG_SC_BK38_34_H      _PK_H_(0x38, 0x34)
#define REG_SC_BK38_35_L      _PK_L_(0x38, 0x35)
#define REG_SC_BK38_35_H      _PK_H_(0x38, 0x35)
#define REG_SC_BK38_36_L      _PK_L_(0x38, 0x36)
#define REG_SC_BK38_36_H      _PK_H_(0x38, 0x36)
#define REG_SC_BK38_37_L      _PK_L_(0x38, 0x37)
#define REG_SC_BK38_37_H      _PK_H_(0x38, 0x37)
#define REG_SC_BK38_38_L      _PK_L_(0x38, 0x38)
#define REG_SC_BK38_38_H      _PK_H_(0x38, 0x38)
#define REG_SC_BK38_39_L      _PK_L_(0x38, 0x39)
#define REG_SC_BK38_39_H      _PK_H_(0x38, 0x39)
#define REG_SC_BK38_3A_L      _PK_L_(0x38, 0x3A)
#define REG_SC_BK38_3A_H      _PK_H_(0x38, 0x3A)
#define REG_SC_BK38_3B_L      _PK_L_(0x38, 0x3B)
#define REG_SC_BK38_3B_H      _PK_H_(0x38, 0x3B)
#define REG_SC_BK38_3C_L      _PK_L_(0x38, 0x3C)
#define REG_SC_BK38_3C_H      _PK_H_(0x38, 0x3C)
#define REG_SC_BK38_3D_L      _PK_L_(0x38, 0x3D)
#define REG_SC_BK38_3D_H      _PK_H_(0x38, 0x3D)
#define REG_SC_BK38_3E_L      _PK_L_(0x38, 0x3E)
#define REG_SC_BK38_3E_H      _PK_H_(0x38, 0x3E)
#define REG_SC_BK38_3F_L      _PK_L_(0x38, 0x3F)
#define REG_SC_BK38_3F_H      _PK_H_(0x38, 0x3F)
#define REG_SC_BK38_40_L      _PK_L_(0x38, 0x40)
#define REG_SC_BK38_40_H      _PK_H_(0x38, 0x40)
#define REG_SC_BK38_41_L      _PK_L_(0x38, 0x41)
#define REG_SC_BK38_41_H      _PK_H_(0x38, 0x41)
#define REG_SC_BK38_42_L      _PK_L_(0x38, 0x42)
#define REG_SC_BK38_42_H      _PK_H_(0x38, 0x42)
#define REG_SC_BK38_43_L      _PK_L_(0x38, 0x43)
#define REG_SC_BK38_43_H      _PK_H_(0x38, 0x43)
#define REG_SC_BK38_44_L      _PK_L_(0x38, 0x44)
#define REG_SC_BK38_44_H      _PK_H_(0x38, 0x44)
#define REG_SC_BK38_45_L      _PK_L_(0x38, 0x45)
#define REG_SC_BK38_45_H      _PK_H_(0x38, 0x45)
#define REG_SC_BK38_46_L      _PK_L_(0x38, 0x46)
#define REG_SC_BK38_46_H      _PK_H_(0x38, 0x46)
#define REG_SC_BK38_47_L      _PK_L_(0x38, 0x47)
#define REG_SC_BK38_47_H      _PK_H_(0x38, 0x47)
#define REG_SC_BK38_48_L      _PK_L_(0x38, 0x48)
#define REG_SC_BK38_48_H      _PK_H_(0x38, 0x48)
#define REG_SC_BK38_49_L      _PK_L_(0x38, 0x49)
#define REG_SC_BK38_49_H      _PK_H_(0x38, 0x49)
#define REG_SC_BK38_4A_L      _PK_L_(0x38, 0x4A)
#define REG_SC_BK38_4A_H      _PK_H_(0x38, 0x4A)
#define REG_SC_BK38_4B_L      _PK_L_(0x38, 0x4B)
#define REG_SC_BK38_4B_H      _PK_H_(0x38, 0x4B)
#define REG_SC_BK38_4C_L      _PK_L_(0x38, 0x4C)
#define REG_SC_BK38_4C_H      _PK_H_(0x38, 0x4C)
#define REG_SC_BK38_4D_L      _PK_L_(0x38, 0x4D)
#define REG_SC_BK38_4D_H      _PK_H_(0x38, 0x4D)
#define REG_SC_BK38_4E_L      _PK_L_(0x38, 0x4E)
#define REG_SC_BK38_4E_H      _PK_H_(0x38, 0x4E)
#define REG_SC_BK38_4F_L      _PK_L_(0x38, 0x4F)
#define REG_SC_BK38_4F_H      _PK_H_(0x38, 0x4F)
#define REG_SC_BK38_50_L      _PK_L_(0x38, 0x50)
#define REG_SC_BK38_50_H      _PK_H_(0x38, 0x50)
#define REG_SC_BK38_51_L      _PK_L_(0x38, 0x51)
#define REG_SC_BK38_51_H      _PK_H_(0x38, 0x51)
#define REG_SC_BK38_52_L      _PK_L_(0x38, 0x52)
#define REG_SC_BK38_52_H      _PK_H_(0x38, 0x52)
#define REG_SC_BK38_53_L      _PK_L_(0x38, 0x53)
#define REG_SC_BK38_53_H      _PK_H_(0x38, 0x53)
#define REG_SC_BK38_54_L      _PK_L_(0x38, 0x54)
#define REG_SC_BK38_54_H      _PK_H_(0x38, 0x54)
#define REG_SC_BK38_55_L      _PK_L_(0x38, 0x55)
#define REG_SC_BK38_55_H      _PK_H_(0x38, 0x55)
#define REG_SC_BK38_56_L      _PK_L_(0x38, 0x56)
#define REG_SC_BK38_56_H      _PK_H_(0x38, 0x56)
#define REG_SC_BK38_57_L      _PK_L_(0x38, 0x57)
#define REG_SC_BK38_57_H      _PK_H_(0x38, 0x57)
#define REG_SC_BK38_58_L      _PK_L_(0x38, 0x58)
#define REG_SC_BK38_58_H      _PK_H_(0x38, 0x58)
#define REG_SC_BK38_59_L      _PK_L_(0x38, 0x59)
#define REG_SC_BK38_59_H      _PK_H_(0x38, 0x59)
#define REG_SC_BK38_5A_L      _PK_L_(0x38, 0x5A)
#define REG_SC_BK38_5A_H      _PK_H_(0x38, 0x5A)
#define REG_SC_BK38_5B_L      _PK_L_(0x38, 0x5B)
#define REG_SC_BK38_5B_H      _PK_H_(0x38, 0x5B)
#define REG_SC_BK38_5C_L      _PK_L_(0x38, 0x5C)
#define REG_SC_BK38_5C_H      _PK_H_(0x38, 0x5C)
#define REG_SC_BK38_5D_L      _PK_L_(0x38, 0x5D)
#define REG_SC_BK38_5D_H      _PK_H_(0x38, 0x5D)
#define REG_SC_BK38_5E_L      _PK_L_(0x38, 0x5E)
#define REG_SC_BK38_5E_H      _PK_H_(0x38, 0x5E)
#define REG_SC_BK38_5F_L      _PK_L_(0x38, 0x5F)
#define REG_SC_BK38_5F_H      _PK_H_(0x38, 0x5F)
#define REG_SC_BK38_60_L      _PK_L_(0x38, 0x60)
#define REG_SC_BK38_60_H      _PK_H_(0x38, 0x60)
#define REG_SC_BK38_61_L      _PK_L_(0x38, 0x61)
#define REG_SC_BK38_61_H      _PK_H_(0x38, 0x61)
#define REG_SC_BK38_62_L      _PK_L_(0x38, 0x62)
#define REG_SC_BK38_62_H      _PK_H_(0x38, 0x62)
#define REG_SC_BK38_63_L      _PK_L_(0x38, 0x63)
#define REG_SC_BK38_63_H      _PK_H_(0x38, 0x63)
#define REG_SC_BK38_64_L      _PK_L_(0x38, 0x64)
#define REG_SC_BK38_64_H      _PK_H_(0x38, 0x64)
#define REG_SC_BK38_65_L      _PK_L_(0x38, 0x65)
#define REG_SC_BK38_65_H      _PK_H_(0x38, 0x65)
#define REG_SC_BK38_66_L      _PK_L_(0x38, 0x66)
#define REG_SC_BK38_66_H      _PK_H_(0x38, 0x66)
#define REG_SC_BK38_67_L      _PK_L_(0x38, 0x67)
#define REG_SC_BK38_67_H      _PK_H_(0x38, 0x67)
#define REG_SC_BK38_68_L      _PK_L_(0x38, 0x68)
#define REG_SC_BK38_68_H      _PK_H_(0x38, 0x68)
#define REG_SC_BK38_69_L      _PK_L_(0x38, 0x69)
#define REG_SC_BK38_69_H      _PK_H_(0x38, 0x69)
#define REG_SC_BK38_6A_L      _PK_L_(0x38, 0x6A)
#define REG_SC_BK38_6A_H      _PK_H_(0x38, 0x6A)
#define REG_SC_BK38_6B_L      _PK_L_(0x38, 0x6B)
#define REG_SC_BK38_6B_H      _PK_H_(0x38, 0x6B)
#define REG_SC_BK38_6C_L      _PK_L_(0x38, 0x6C)
#define REG_SC_BK38_6C_H      _PK_H_(0x38, 0x6C)
#define REG_SC_BK38_6D_L      _PK_L_(0x38, 0x6D)
#define REG_SC_BK38_6D_H      _PK_H_(0x38, 0x6D)
#define REG_SC_BK38_6E_L      _PK_L_(0x38, 0x6E)
#define REG_SC_BK38_6E_H      _PK_H_(0x38, 0x6E)
#define REG_SC_BK38_6F_L      _PK_L_(0x38, 0x6F)
#define REG_SC_BK38_6F_H      _PK_H_(0x38, 0x6F)
#define REG_SC_BK38_70_L      _PK_L_(0x38, 0x70)
#define REG_SC_BK38_70_H      _PK_H_(0x38, 0x70)
#define REG_SC_BK38_71_L      _PK_L_(0x38, 0x71)
#define REG_SC_BK38_71_H      _PK_H_(0x38, 0x71)
#define REG_SC_BK38_72_L      _PK_L_(0x38, 0x72)
#define REG_SC_BK38_72_H      _PK_H_(0x38, 0x72)
#define REG_SC_BK38_73_L      _PK_L_(0x38, 0x73)
#define REG_SC_BK38_73_H      _PK_H_(0x38, 0x73)
#define REG_SC_BK38_74_L      _PK_L_(0x38, 0x74)
#define REG_SC_BK38_74_H      _PK_H_(0x38, 0x74)
#define REG_SC_BK38_75_L      _PK_L_(0x38, 0x75)
#define REG_SC_BK38_75_H      _PK_H_(0x38, 0x75)
#define REG_SC_BK38_76_L      _PK_L_(0x38, 0x76)
#define REG_SC_BK38_76_H      _PK_H_(0x38, 0x76)
#define REG_SC_BK38_77_L      _PK_L_(0x38, 0x77)
#define REG_SC_BK38_77_H      _PK_H_(0x38, 0x77)
#define REG_SC_BK38_78_L      _PK_L_(0x38, 0x78)
#define REG_SC_BK38_78_H      _PK_H_(0x38, 0x78)
#define REG_SC_BK38_79_L      _PK_L_(0x38, 0x79)
#define REG_SC_BK38_79_H      _PK_H_(0x38, 0x79)
#define REG_SC_BK38_7A_L      _PK_L_(0x38, 0x7A)
#define REG_SC_BK38_7A_H      _PK_H_(0x38, 0x7A)
#define REG_SC_BK38_7B_L      _PK_L_(0x38, 0x7B)
#define REG_SC_BK38_7B_H      _PK_H_(0x38, 0x7B)
#define REG_SC_BK38_7C_L      _PK_L_(0x38, 0x7C)
#define REG_SC_BK38_7C_H      _PK_H_(0x38, 0x7C)
#define REG_SC_BK38_7D_L      _PK_L_(0x38, 0x7D)
#define REG_SC_BK38_7D_H      _PK_H_(0x38, 0x7D)
#define REG_SC_BK38_7E_L      _PK_L_(0x38, 0x7E)
#define REG_SC_BK38_7E_H      _PK_H_(0x38, 0x7E)
#define REG_SC_BK38_7F_L      _PK_L_(0x38, 0x7F)
#define REG_SC_BK38_7F_H      _PK_H_(0x38, 0x7F)

//----------------------------------------------
//  BK3C
//----------------------------------------------
#define REG_SC_BK39_00_L      _PK_L_(0x39, 0x00)
#define REG_SC_BK39_00_H      _PK_H_(0x39, 0x00)
#define REG_SC_BK39_01_L      _PK_L_(0x39, 0x01)
#define REG_SC_BK39_01_H      _PK_H_(0x39, 0x01)
#define REG_SC_BK39_02_L      _PK_L_(0x39, 0x02)
#define REG_SC_BK39_02_H      _PK_H_(0x39, 0x02)
#define REG_SC_BK39_03_L      _PK_L_(0x39, 0x03)
#define REG_SC_BK39_03_H      _PK_H_(0x39, 0x03)
#define REG_SC_BK39_04_L      _PK_L_(0x39, 0x04)
#define REG_SC_BK39_04_H      _PK_H_(0x39, 0x04)
#define REG_SC_BK39_05_L      _PK_L_(0x39, 0x05)
#define REG_SC_BK39_05_H      _PK_H_(0x39, 0x05)
#define REG_SC_BK39_06_L      _PK_L_(0x39, 0x06)
#define REG_SC_BK39_06_H      _PK_H_(0x39, 0x06)
#define REG_SC_BK39_07_L      _PK_L_(0x39, 0x07)
#define REG_SC_BK39_07_H      _PK_H_(0x39, 0x07)
#define REG_SC_BK39_08_L      _PK_L_(0x39, 0x08)
#define REG_SC_BK39_08_H      _PK_H_(0x39, 0x08)
#define REG_SC_BK39_09_L      _PK_L_(0x39, 0x09)
#define REG_SC_BK39_09_H      _PK_H_(0x39, 0x09)
#define REG_SC_BK39_0A_L      _PK_L_(0x39, 0x0A)
#define REG_SC_BK39_0A_H      _PK_H_(0x39, 0x0A)
#define REG_SC_BK39_0B_L      _PK_L_(0x39, 0x0B)
#define REG_SC_BK39_0B_H      _PK_H_(0x39, 0x0B)
#define REG_SC_BK39_0C_L      _PK_L_(0x39, 0x0C)
#define REG_SC_BK39_0C_H      _PK_H_(0x39, 0x0C)
#define REG_SC_BK39_0D_L      _PK_L_(0x39, 0x0D)
#define REG_SC_BK39_0D_H      _PK_H_(0x39, 0x0D)
#define REG_SC_BK39_0E_L      _PK_L_(0x39, 0x0E)
#define REG_SC_BK39_0E_H      _PK_H_(0x39, 0x0E)
#define REG_SC_BK39_0F_L      _PK_L_(0x39, 0x0F)
#define REG_SC_BK39_0F_H      _PK_H_(0x39, 0x0F)
#define REG_SC_BK39_10_L      _PK_L_(0x39, 0x10)
#define REG_SC_BK39_10_H      _PK_H_(0x39, 0x10)
#define REG_SC_BK39_11_L      _PK_L_(0x39, 0x11)
#define REG_SC_BK39_11_H      _PK_H_(0x39, 0x11)
#define REG_SC_BK39_12_L      _PK_L_(0x39, 0x12)
#define REG_SC_BK39_12_H      _PK_H_(0x39, 0x12)
#define REG_SC_BK39_13_L      _PK_L_(0x39, 0x13)
#define REG_SC_BK39_13_H      _PK_H_(0x39, 0x13)
#define REG_SC_BK39_14_L      _PK_L_(0x39, 0x14)
#define REG_SC_BK39_14_H      _PK_H_(0x39, 0x14)
#define REG_SC_BK39_15_L      _PK_L_(0x39, 0x15)
#define REG_SC_BK39_15_H      _PK_H_(0x39, 0x15)
#define REG_SC_BK39_16_L      _PK_L_(0x39, 0x16)
#define REG_SC_BK39_16_H      _PK_H_(0x39, 0x16)
#define REG_SC_BK39_17_L      _PK_L_(0x39, 0x17)
#define REG_SC_BK39_17_H      _PK_H_(0x39, 0x17)
#define REG_SC_BK39_18_L      _PK_L_(0x39, 0x18)
#define REG_SC_BK39_18_H      _PK_H_(0x39, 0x18)
#define REG_SC_BK39_19_L      _PK_L_(0x39, 0x19)
#define REG_SC_BK39_19_H      _PK_H_(0x39, 0x19)
#define REG_SC_BK39_1A_L      _PK_L_(0x39, 0x1A)
#define REG_SC_BK39_1A_H      _PK_H_(0x39, 0x1A)
#define REG_SC_BK39_1B_L      _PK_L_(0x39, 0x1B)
#define REG_SC_BK39_1B_H      _PK_H_(0x39, 0x1B)
#define REG_SC_BK39_1C_L      _PK_L_(0x39, 0x1C)
#define REG_SC_BK39_1C_H      _PK_H_(0x39, 0x1C)
#define REG_SC_BK39_1D_L      _PK_L_(0x39, 0x1D)
#define REG_SC_BK39_1D_H      _PK_H_(0x39, 0x1D)
#define REG_SC_BK39_1E_L      _PK_L_(0x39, 0x1E)
#define REG_SC_BK39_1E_H      _PK_H_(0x39, 0x1E)
#define REG_SC_BK39_1F_L      _PK_L_(0x39, 0x1F)
#define REG_SC_BK39_1F_H      _PK_H_(0x39, 0x1F)
#define REG_SC_BK39_20_L      _PK_L_(0x39, 0x20)
#define REG_SC_BK39_20_H      _PK_H_(0x39, 0x20)
#define REG_SC_BK39_21_L      _PK_L_(0x39, 0x21)
#define REG_SC_BK39_21_H      _PK_H_(0x39, 0x21)
#define REG_SC_BK39_22_L      _PK_L_(0x39, 0x22)
#define REG_SC_BK39_22_H      _PK_H_(0x39, 0x22)
#define REG_SC_BK39_23_L      _PK_L_(0x39, 0x23)
#define REG_SC_BK39_23_H      _PK_H_(0x39, 0x23)
#define REG_SC_BK39_24_L      _PK_L_(0x39, 0x24)
#define REG_SC_BK39_24_H      _PK_H_(0x39, 0x24)
#define REG_SC_BK39_25_L      _PK_L_(0x39, 0x25)
#define REG_SC_BK39_25_H      _PK_H_(0x39, 0x25)
#define REG_SC_BK39_26_L      _PK_L_(0x39, 0x26)
#define REG_SC_BK39_26_H      _PK_H_(0x39, 0x26)
#define REG_SC_BK39_27_L      _PK_L_(0x39, 0x27)
#define REG_SC_BK39_27_H      _PK_H_(0x39, 0x27)
#define REG_SC_BK39_28_L      _PK_L_(0x39, 0x28)
#define REG_SC_BK39_28_H      _PK_H_(0x39, 0x28)
#define REG_SC_BK39_29_L      _PK_L_(0x39, 0x29)
#define REG_SC_BK39_29_H      _PK_H_(0x39, 0x29)
#define REG_SC_BK39_2A_L      _PK_L_(0x39, 0x2A)
#define REG_SC_BK39_2A_H      _PK_H_(0x39, 0x2A)
#define REG_SC_BK39_2B_L      _PK_L_(0x39, 0x2B)
#define REG_SC_BK39_2B_H      _PK_H_(0x39, 0x2B)
#define REG_SC_BK39_2C_L      _PK_L_(0x39, 0x2C)
#define REG_SC_BK39_2C_H      _PK_H_(0x39, 0x2C)
#define REG_SC_BK39_2D_L      _PK_L_(0x39, 0x2D)
#define REG_SC_BK39_2D_H      _PK_H_(0x39, 0x2D)
#define REG_SC_BK39_2E_L      _PK_L_(0x39, 0x2E)
#define REG_SC_BK39_2E_H      _PK_H_(0x39, 0x2E)
#define REG_SC_BK39_2F_L      _PK_L_(0x39, 0x2F)
#define REG_SC_BK39_2F_H      _PK_H_(0x39, 0x2F)
#define REG_SC_BK39_30_L      _PK_L_(0x39, 0x30)
#define REG_SC_BK39_30_H      _PK_H_(0x39, 0x30)
#define REG_SC_BK39_31_L      _PK_L_(0x39, 0x31)
#define REG_SC_BK39_31_H      _PK_H_(0x39, 0x31)
#define REG_SC_BK39_32_L      _PK_L_(0x39, 0x32)
#define REG_SC_BK39_32_H      _PK_H_(0x39, 0x32)
#define REG_SC_BK39_33_L      _PK_L_(0x39, 0x33)
#define REG_SC_BK39_33_H      _PK_H_(0x39, 0x33)
#define REG_SC_BK39_34_L      _PK_L_(0x39, 0x34)
#define REG_SC_BK39_34_H      _PK_H_(0x39, 0x34)
#define REG_SC_BK39_35_L      _PK_L_(0x39, 0x35)
#define REG_SC_BK39_35_H      _PK_H_(0x39, 0x35)
#define REG_SC_BK39_36_L      _PK_L_(0x39, 0x36)
#define REG_SC_BK39_36_H      _PK_H_(0x39, 0x36)
#define REG_SC_BK39_37_L      _PK_L_(0x39, 0x37)
#define REG_SC_BK39_37_H      _PK_H_(0x39, 0x37)
#define REG_SC_BK39_38_L      _PK_L_(0x39, 0x38)
#define REG_SC_BK39_38_H      _PK_H_(0x39, 0x38)
#define REG_SC_BK39_39_L      _PK_L_(0x39, 0x39)
#define REG_SC_BK39_39_H      _PK_H_(0x39, 0x39)
#define REG_SC_BK39_3A_L      _PK_L_(0x39, 0x3A)
#define REG_SC_BK39_3A_H      _PK_H_(0x39, 0x3A)
#define REG_SC_BK39_3B_L      _PK_L_(0x39, 0x3B)
#define REG_SC_BK39_3B_H      _PK_H_(0x39, 0x3B)
#define REG_SC_BK39_3C_L      _PK_L_(0x39, 0x3C)
#define REG_SC_BK39_3C_H      _PK_H_(0x39, 0x3C)
#define REG_SC_BK39_3D_L      _PK_L_(0x39, 0x3D)
#define REG_SC_BK39_3D_H      _PK_H_(0x39, 0x3D)
#define REG_SC_BK39_3E_L      _PK_L_(0x39, 0x3E)
#define REG_SC_BK39_3E_H      _PK_H_(0x39, 0x3E)
#define REG_SC_BK39_3F_L      _PK_L_(0x39, 0x3F)
#define REG_SC_BK39_3F_H      _PK_H_(0x39, 0x3F)
#define REG_SC_BK39_40_L      _PK_L_(0x39, 0x40)
#define REG_SC_BK39_40_H      _PK_H_(0x39, 0x40)
#define REG_SC_BK39_41_L      _PK_L_(0x39, 0x41)
#define REG_SC_BK39_41_H      _PK_H_(0x39, 0x41)
#define REG_SC_BK39_42_L      _PK_L_(0x39, 0x42)
#define REG_SC_BK39_42_H      _PK_H_(0x39, 0x42)
#define REG_SC_BK39_43_L      _PK_L_(0x39, 0x43)
#define REG_SC_BK39_43_H      _PK_H_(0x39, 0x43)
#define REG_SC_BK39_44_L      _PK_L_(0x39, 0x44)
#define REG_SC_BK39_44_H      _PK_H_(0x39, 0x44)
#define REG_SC_BK39_45_L      _PK_L_(0x39, 0x45)
#define REG_SC_BK39_45_H      _PK_H_(0x39, 0x45)
#define REG_SC_BK39_46_L      _PK_L_(0x39, 0x46)
#define REG_SC_BK39_46_H      _PK_H_(0x39, 0x46)
#define REG_SC_BK39_47_L      _PK_L_(0x39, 0x47)
#define REG_SC_BK39_47_H      _PK_H_(0x39, 0x47)
#define REG_SC_BK39_48_L      _PK_L_(0x39, 0x48)
#define REG_SC_BK39_48_H      _PK_H_(0x39, 0x48)
#define REG_SC_BK39_49_L      _PK_L_(0x39, 0x49)
#define REG_SC_BK39_49_H      _PK_H_(0x39, 0x49)
#define REG_SC_BK39_4A_L      _PK_L_(0x39, 0x4A)
#define REG_SC_BK39_4A_H      _PK_H_(0x39, 0x4A)
#define REG_SC_BK39_4B_L      _PK_L_(0x39, 0x4B)
#define REG_SC_BK39_4B_H      _PK_H_(0x39, 0x4B)
#define REG_SC_BK39_4C_L      _PK_L_(0x39, 0x4C)
#define REG_SC_BK39_4C_H      _PK_H_(0x39, 0x4C)
#define REG_SC_BK39_4D_L      _PK_L_(0x39, 0x4D)
#define REG_SC_BK39_4D_H      _PK_H_(0x39, 0x4D)
#define REG_SC_BK39_4E_L      _PK_L_(0x39, 0x4E)
#define REG_SC_BK39_4E_H      _PK_H_(0x39, 0x4E)
#define REG_SC_BK39_4F_L      _PK_L_(0x39, 0x4F)
#define REG_SC_BK39_4F_H      _PK_H_(0x39, 0x4F)
#define REG_SC_BK39_50_L      _PK_L_(0x39, 0x50)
#define REG_SC_BK39_50_H      _PK_H_(0x39, 0x50)
#define REG_SC_BK39_51_L      _PK_L_(0x39, 0x51)
#define REG_SC_BK39_51_H      _PK_H_(0x39, 0x51)
#define REG_SC_BK39_52_L      _PK_L_(0x39, 0x52)
#define REG_SC_BK39_52_H      _PK_H_(0x39, 0x52)
#define REG_SC_BK39_53_L      _PK_L_(0x39, 0x53)
#define REG_SC_BK39_53_H      _PK_H_(0x39, 0x53)
#define REG_SC_BK39_54_L      _PK_L_(0x39, 0x54)
#define REG_SC_BK39_54_H      _PK_H_(0x39, 0x54)
#define REG_SC_BK39_55_L      _PK_L_(0x39, 0x55)
#define REG_SC_BK39_55_H      _PK_H_(0x39, 0x55)
#define REG_SC_BK39_56_L      _PK_L_(0x39, 0x56)
#define REG_SC_BK39_56_H      _PK_H_(0x39, 0x56)
#define REG_SC_BK39_57_L      _PK_L_(0x39, 0x57)
#define REG_SC_BK39_57_H      _PK_H_(0x39, 0x57)
#define REG_SC_BK39_58_L      _PK_L_(0x39, 0x58)
#define REG_SC_BK39_58_H      _PK_H_(0x39, 0x58)
#define REG_SC_BK39_59_L      _PK_L_(0x39, 0x59)
#define REG_SC_BK39_59_H      _PK_H_(0x39, 0x59)
#define REG_SC_BK39_5A_L      _PK_L_(0x39, 0x5A)
#define REG_SC_BK39_5A_H      _PK_H_(0x39, 0x5A)
#define REG_SC_BK39_5B_L      _PK_L_(0x39, 0x5B)
#define REG_SC_BK39_5B_H      _PK_H_(0x39, 0x5B)
#define REG_SC_BK39_5C_L      _PK_L_(0x39, 0x5C)
#define REG_SC_BK39_5C_H      _PK_H_(0x39, 0x5C)
#define REG_SC_BK39_5D_L      _PK_L_(0x39, 0x5D)
#define REG_SC_BK39_5D_H      _PK_H_(0x39, 0x5D)
#define REG_SC_BK39_5E_L      _PK_L_(0x39, 0x5E)
#define REG_SC_BK39_5E_H      _PK_H_(0x39, 0x5E)
#define REG_SC_BK39_5F_L      _PK_L_(0x39, 0x5F)
#define REG_SC_BK39_5F_H      _PK_H_(0x39, 0x5F)
#define REG_SC_BK39_60_L      _PK_L_(0x39, 0x60)
#define REG_SC_BK39_60_H      _PK_H_(0x39, 0x60)
#define REG_SC_BK39_61_L      _PK_L_(0x39, 0x61)
#define REG_SC_BK39_61_H      _PK_H_(0x39, 0x61)
#define REG_SC_BK39_62_L      _PK_L_(0x39, 0x62)
#define REG_SC_BK39_62_H      _PK_H_(0x39, 0x62)
#define REG_SC_BK39_63_L      _PK_L_(0x39, 0x63)
#define REG_SC_BK39_63_H      _PK_H_(0x39, 0x63)
#define REG_SC_BK39_64_L      _PK_L_(0x39, 0x64)
#define REG_SC_BK39_64_H      _PK_H_(0x39, 0x64)
#define REG_SC_BK39_65_L      _PK_L_(0x39, 0x65)
#define REG_SC_BK39_65_H      _PK_H_(0x39, 0x65)
#define REG_SC_BK39_66_L      _PK_L_(0x39, 0x66)
#define REG_SC_BK39_66_H      _PK_H_(0x39, 0x66)
#define REG_SC_BK39_67_L      _PK_L_(0x39, 0x67)
#define REG_SC_BK39_67_H      _PK_H_(0x39, 0x67)
#define REG_SC_BK39_68_L      _PK_L_(0x39, 0x68)
#define REG_SC_BK39_68_H      _PK_H_(0x39, 0x68)
#define REG_SC_BK39_69_L      _PK_L_(0x39, 0x69)
#define REG_SC_BK39_69_H      _PK_H_(0x39, 0x69)
#define REG_SC_BK39_6A_L      _PK_L_(0x39, 0x6A)
#define REG_SC_BK39_6A_H      _PK_H_(0x39, 0x6A)
#define REG_SC_BK39_6B_L      _PK_L_(0x39, 0x6B)
#define REG_SC_BK39_6B_H      _PK_H_(0x39, 0x6B)
#define REG_SC_BK39_6C_L      _PK_L_(0x39, 0x6C)
#define REG_SC_BK39_6C_H      _PK_H_(0x39, 0x6C)
#define REG_SC_BK39_6D_L      _PK_L_(0x39, 0x6D)
#define REG_SC_BK39_6D_H      _PK_H_(0x39, 0x6D)
#define REG_SC_BK39_6E_L      _PK_L_(0x39, 0x6E)
#define REG_SC_BK39_6E_H      _PK_H_(0x39, 0x6E)
#define REG_SC_BK39_6F_L      _PK_L_(0x39, 0x6F)
#define REG_SC_BK39_6F_H      _PK_H_(0x39, 0x6F)
#define REG_SC_BK39_70_L      _PK_L_(0x39, 0x70)
#define REG_SC_BK39_70_H      _PK_H_(0x39, 0x70)
#define REG_SC_BK39_71_L      _PK_L_(0x39, 0x71)
#define REG_SC_BK39_71_H      _PK_H_(0x39, 0x71)
#define REG_SC_BK39_72_L      _PK_L_(0x39, 0x72)
#define REG_SC_BK39_72_H      _PK_H_(0x39, 0x72)
#define REG_SC_BK39_73_L      _PK_L_(0x39, 0x73)
#define REG_SC_BK39_73_H      _PK_H_(0x39, 0x73)
#define REG_SC_BK39_74_L      _PK_L_(0x39, 0x74)
#define REG_SC_BK39_74_H      _PK_H_(0x39, 0x74)
#define REG_SC_BK39_75_L      _PK_L_(0x39, 0x75)
#define REG_SC_BK39_75_H      _PK_H_(0x39, 0x75)
#define REG_SC_BK39_76_L      _PK_L_(0x39, 0x76)
#define REG_SC_BK39_76_H      _PK_H_(0x39, 0x76)
#define REG_SC_BK39_77_L      _PK_L_(0x39, 0x77)
#define REG_SC_BK39_77_H      _PK_H_(0x39, 0x77)
#define REG_SC_BK39_78_L      _PK_L_(0x39, 0x78)
#define REG_SC_BK39_78_H      _PK_H_(0x39, 0x78)
#define REG_SC_BK39_79_L      _PK_L_(0x39, 0x79)
#define REG_SC_BK39_79_H      _PK_H_(0x39, 0x79)
#define REG_SC_BK39_7A_L      _PK_L_(0x39, 0x7A)
#define REG_SC_BK39_7A_H      _PK_H_(0x39, 0x7A)
#define REG_SC_BK39_7B_L      _PK_L_(0x39, 0x7B)
#define REG_SC_BK39_7B_H      _PK_H_(0x39, 0x7B)
#define REG_SC_BK39_7C_L      _PK_L_(0x39, 0x7C)
#define REG_SC_BK39_7C_H      _PK_H_(0x39, 0x7C)
#define REG_SC_BK39_7D_L      _PK_L_(0x39, 0x7D)
#define REG_SC_BK39_7D_H      _PK_H_(0x39, 0x7D)
#define REG_SC_BK39_7E_L      _PK_L_(0x39, 0x7E)
#define REG_SC_BK39_7E_H      _PK_H_(0x39, 0x7E)
#define REG_SC_BK39_7F_L      _PK_L_(0x39, 0x7F)
#define REG_SC_BK39_7F_H      _PK_H_(0x39, 0x7F)

//----------------------------------------------
//  BK3B
//----------------------------------------------
#define REG_SC_BK3B_00_L      _PK_L_(0x3B, 0x00)
#define REG_SC_BK3B_00_H      _PK_H_(0x3B, 0x00)
#define REG_SC_BK3B_01_L      _PK_L_(0x3B, 0x01)
#define REG_SC_BK3B_01_H      _PK_H_(0x3B, 0x01)
#define REG_SC_BK3B_02_L      _PK_L_(0x3B, 0x02)
#define REG_SC_BK3B_02_H      _PK_H_(0x3B, 0x02)
#define REG_SC_BK3B_03_L      _PK_L_(0x3B, 0x03)
#define REG_SC_BK3B_03_H      _PK_H_(0x3B, 0x03)
#define REG_SC_BK3B_04_L      _PK_L_(0x3B, 0x04)
#define REG_SC_BK3B_04_H      _PK_H_(0x3B, 0x04)
#define REG_SC_BK3B_05_L      _PK_L_(0x3B, 0x05)
#define REG_SC_BK3B_05_H      _PK_H_(0x3B, 0x05)
#define REG_SC_BK3B_06_L      _PK_L_(0x3B, 0x06)
#define REG_SC_BK3B_06_H      _PK_H_(0x3B, 0x06)
#define REG_SC_BK3B_07_L      _PK_L_(0x3B, 0x07)
#define REG_SC_BK3B_07_H      _PK_H_(0x3B, 0x07)
#define REG_SC_BK3B_08_L      _PK_L_(0x3B, 0x08)
#define REG_SC_BK3B_08_H      _PK_H_(0x3B, 0x08)
#define REG_SC_BK3B_09_L      _PK_L_(0x3B, 0x09)
#define REG_SC_BK3B_09_H      _PK_H_(0x3B, 0x09)
#define REG_SC_BK3B_0A_L      _PK_L_(0x3B, 0x0A)
#define REG_SC_BK3B_0A_H      _PK_H_(0x3B, 0x0A)
#define REG_SC_BK3B_0B_L      _PK_L_(0x3B, 0x0B)
#define REG_SC_BK3B_0B_H      _PK_H_(0x3B, 0x0B)
#define REG_SC_BK3B_0C_L      _PK_L_(0x3B, 0x0C)
#define REG_SC_BK3B_0C_H      _PK_H_(0x3B, 0x0C)
#define REG_SC_BK3B_0D_L      _PK_L_(0x3B, 0x0D)
#define REG_SC_BK3B_0D_H      _PK_H_(0x3B, 0x0D)
#define REG_SC_BK3B_0E_L      _PK_L_(0x3B, 0x0E)
#define REG_SC_BK3B_0E_H      _PK_H_(0x3B, 0x0E)
#define REG_SC_BK3B_0F_L      _PK_L_(0x3B, 0x0F)
#define REG_SC_BK3B_0F_H      _PK_H_(0x3B, 0x0F)
#define REG_SC_BK3B_10_L      _PK_L_(0x3B, 0x10)
#define REG_SC_BK3B_10_H      _PK_H_(0x3B, 0x10)
#define REG_SC_BK3B_11_L      _PK_L_(0x3B, 0x11)
#define REG_SC_BK3B_11_H      _PK_H_(0x3B, 0x11)
#define REG_SC_BK3B_12_L      _PK_L_(0x3B, 0x12)
#define REG_SC_BK3B_12_H      _PK_H_(0x3B, 0x12)
#define REG_SC_BK3B_13_L      _PK_L_(0x3B, 0x13)
#define REG_SC_BK3B_13_H      _PK_H_(0x3B, 0x13)
#define REG_SC_BK3B_14_L      _PK_L_(0x3B, 0x14)
#define REG_SC_BK3B_14_H      _PK_H_(0x3B, 0x14)
#define REG_SC_BK3B_15_L      _PK_L_(0x3B, 0x15)
#define REG_SC_BK3B_15_H      _PK_H_(0x3B, 0x15)
#define REG_SC_BK3B_16_L      _PK_L_(0x3B, 0x16)
#define REG_SC_BK3B_16_H      _PK_H_(0x3B, 0x16)
#define REG_SC_BK3B_17_L      _PK_L_(0x3B, 0x17)
#define REG_SC_BK3B_17_H      _PK_H_(0x3B, 0x17)
#define REG_SC_BK3B_18_L      _PK_L_(0x3B, 0x18)
#define REG_SC_BK3B_18_H      _PK_H_(0x3B, 0x18)
#define REG_SC_BK3B_19_L      _PK_L_(0x3B, 0x19)
#define REG_SC_BK3B_19_H      _PK_H_(0x3B, 0x19)
#define REG_SC_BK3B_1A_L      _PK_L_(0x3B, 0x1A)
#define REG_SC_BK3B_1A_H      _PK_H_(0x3B, 0x1A)
#define REG_SC_BK3B_1B_L      _PK_L_(0x3B, 0x1B)
#define REG_SC_BK3B_1B_H      _PK_H_(0x3B, 0x1B)
#define REG_SC_BK3B_1C_L      _PK_L_(0x3B, 0x1C)
#define REG_SC_BK3B_1C_H      _PK_H_(0x3B, 0x1C)
#define REG_SC_BK3B_1D_L      _PK_L_(0x3B, 0x1D)
#define REG_SC_BK3B_1D_H      _PK_H_(0x3B, 0x1D)
#define REG_SC_BK3B_1E_L      _PK_L_(0x3B, 0x1E)
#define REG_SC_BK3B_1E_H      _PK_H_(0x3B, 0x1E)
#define REG_SC_BK3B_1F_L      _PK_L_(0x3B, 0x1F)
#define REG_SC_BK3B_1F_H      _PK_H_(0x3B, 0x1F)
#define REG_SC_BK3B_20_L      _PK_L_(0x3B, 0x20)
#define REG_SC_BK3B_20_H      _PK_H_(0x3B, 0x20)
#define REG_SC_BK3B_21_L      _PK_L_(0x3B, 0x21)
#define REG_SC_BK3B_21_H      _PK_H_(0x3B, 0x21)
#define REG_SC_BK3B_22_L      _PK_L_(0x3B, 0x22)
#define REG_SC_BK3B_22_H      _PK_H_(0x3B, 0x22)
#define REG_SC_BK3B_23_L      _PK_L_(0x3B, 0x23)
#define REG_SC_BK3B_23_H      _PK_H_(0x3B, 0x23)
#define REG_SC_BK3B_24_L      _PK_L_(0x3B, 0x24)
#define REG_SC_BK3B_24_H      _PK_H_(0x3B, 0x24)
#define REG_SC_BK3B_25_L      _PK_L_(0x3B, 0x25)
#define REG_SC_BK3B_25_H      _PK_H_(0x3B, 0x25)
#define REG_SC_BK3B_26_L      _PK_L_(0x3B, 0x26)
#define REG_SC_BK3B_26_H      _PK_H_(0x3B, 0x26)
#define REG_SC_BK3B_27_L      _PK_L_(0x3B, 0x27)
#define REG_SC_BK3B_27_H      _PK_H_(0x3B, 0x27)
#define REG_SC_BK3B_28_L      _PK_L_(0x3B, 0x28)
#define REG_SC_BK3B_28_H      _PK_H_(0x3B, 0x28)
#define REG_SC_BK3B_29_L      _PK_L_(0x3B, 0x29)
#define REG_SC_BK3B_29_H      _PK_H_(0x3B, 0x29)
#define REG_SC_BK3B_2A_L      _PK_L_(0x3B, 0x2A)
#define REG_SC_BK3B_2A_H      _PK_H_(0x3B, 0x2A)
#define REG_SC_BK3B_2B_L      _PK_L_(0x3B, 0x2B)
#define REG_SC_BK3B_2B_H      _PK_H_(0x3B, 0x2B)
#define REG_SC_BK3B_2C_L      _PK_L_(0x3B, 0x2C)
#define REG_SC_BK3B_2C_H      _PK_H_(0x3B, 0x2C)
#define REG_SC_BK3B_2D_L      _PK_L_(0x3B, 0x2D)
#define REG_SC_BK3B_2D_H      _PK_H_(0x3B, 0x2D)
#define REG_SC_BK3B_2E_L      _PK_L_(0x3B, 0x2E)
#define REG_SC_BK3B_2E_H      _PK_H_(0x3B, 0x2E)
#define REG_SC_BK3B_2F_L      _PK_L_(0x3B, 0x2F)
#define REG_SC_BK3B_2F_H      _PK_H_(0x3B, 0x2F)
#define REG_SC_BK3B_30_L      _PK_L_(0x3B, 0x30)
#define REG_SC_BK3B_30_H      _PK_H_(0x3B, 0x30)
#define REG_SC_BK3B_31_L      _PK_L_(0x3B, 0x31)
#define REG_SC_BK3B_31_H      _PK_H_(0x3B, 0x31)
#define REG_SC_BK3B_32_L      _PK_L_(0x3B, 0x32)
#define REG_SC_BK3B_32_H      _PK_H_(0x3B, 0x32)
#define REG_SC_BK3B_33_L      _PK_L_(0x3B, 0x33)
#define REG_SC_BK3B_33_H      _PK_H_(0x3B, 0x33)
#define REG_SC_BK3B_34_L      _PK_L_(0x3B, 0x34)
#define REG_SC_BK3B_34_H      _PK_H_(0x3B, 0x34)
#define REG_SC_BK3B_35_L      _PK_L_(0x3B, 0x35)
#define REG_SC_BK3B_35_H      _PK_H_(0x3B, 0x35)
#define REG_SC_BK3B_36_L      _PK_L_(0x3B, 0x36)
#define REG_SC_BK3B_36_H      _PK_H_(0x3B, 0x36)
#define REG_SC_BK3B_37_L      _PK_L_(0x3B, 0x37)
#define REG_SC_BK3B_37_H      _PK_H_(0x3B, 0x37)
#define REG_SC_BK3B_38_L      _PK_L_(0x3B, 0x38)
#define REG_SC_BK3B_38_H      _PK_H_(0x3B, 0x38)
#define REG_SC_BK3B_39_L      _PK_L_(0x3B, 0x39)
#define REG_SC_BK3B_39_H      _PK_H_(0x3B, 0x39)
#define REG_SC_BK3B_3A_L      _PK_L_(0x3B, 0x3A)
#define REG_SC_BK3B_3A_H      _PK_H_(0x3B, 0x3A)
#define REG_SC_BK3B_3B_L      _PK_L_(0x3B, 0x3B)
#define REG_SC_BK3B_3B_H      _PK_H_(0x3B, 0x3B)
#define REG_SC_BK3B_3C_L      _PK_L_(0x3B, 0x3C)
#define REG_SC_BK3B_3C_H      _PK_H_(0x3B, 0x3C)
#define REG_SC_BK3B_3D_L      _PK_L_(0x3B, 0x3D)
#define REG_SC_BK3B_3D_H      _PK_H_(0x3B, 0x3D)
#define REG_SC_BK3B_3E_L      _PK_L_(0x3B, 0x3E)
#define REG_SC_BK3B_3E_H      _PK_H_(0x3B, 0x3E)
#define REG_SC_BK3B_3F_L      _PK_L_(0x3B, 0x3F)
#define REG_SC_BK3B_3F_H      _PK_H_(0x3B, 0x3F)
#define REG_SC_BK3B_40_L      _PK_L_(0x3B, 0x40)
#define REG_SC_BK3B_40_H      _PK_H_(0x3B, 0x40)
#define REG_SC_BK3B_41_L      _PK_L_(0x3B, 0x41)
#define REG_SC_BK3B_41_H      _PK_H_(0x3B, 0x41)
#define REG_SC_BK3B_42_L      _PK_L_(0x3B, 0x42)
#define REG_SC_BK3B_42_H      _PK_H_(0x3B, 0x42)
#define REG_SC_BK3B_43_L      _PK_L_(0x3B, 0x43)
#define REG_SC_BK3B_43_H      _PK_H_(0x3B, 0x43)
#define REG_SC_BK3B_44_L      _PK_L_(0x3B, 0x44)
#define REG_SC_BK3B_44_H      _PK_H_(0x3B, 0x44)
#define REG_SC_BK3B_45_L      _PK_L_(0x3B, 0x45)
#define REG_SC_BK3B_45_H      _PK_H_(0x3B, 0x45)
#define REG_SC_BK3B_46_L      _PK_L_(0x3B, 0x46)
#define REG_SC_BK3B_46_H      _PK_H_(0x3B, 0x46)
#define REG_SC_BK3B_47_L      _PK_L_(0x3B, 0x47)
#define REG_SC_BK3B_47_H      _PK_H_(0x3B, 0x47)
#define REG_SC_BK3B_48_L      _PK_L_(0x3B, 0x48)
#define REG_SC_BK3B_48_H      _PK_H_(0x3B, 0x48)
#define REG_SC_BK3B_49_L      _PK_L_(0x3B, 0x49)
#define REG_SC_BK3B_49_H      _PK_H_(0x3B, 0x49)
#define REG_SC_BK3B_4A_L      _PK_L_(0x3B, 0x4A)
#define REG_SC_BK3B_4A_H      _PK_H_(0x3B, 0x4A)
#define REG_SC_BK3B_4B_L      _PK_L_(0x3B, 0x4B)
#define REG_SC_BK3B_4B_H      _PK_H_(0x3B, 0x4B)
#define REG_SC_BK3B_4C_L      _PK_L_(0x3B, 0x4C)
#define REG_SC_BK3B_4C_H      _PK_H_(0x3B, 0x4C)
#define REG_SC_BK3B_4D_L      _PK_L_(0x3B, 0x4D)
#define REG_SC_BK3B_4D_H      _PK_H_(0x3B, 0x4D)
#define REG_SC_BK3B_4E_L      _PK_L_(0x3B, 0x4E)
#define REG_SC_BK3B_4E_H      _PK_H_(0x3B, 0x4E)
#define REG_SC_BK3B_4F_L      _PK_L_(0x3B, 0x4F)
#define REG_SC_BK3B_4F_H      _PK_H_(0x3B, 0x4F)
#define REG_SC_BK3B_50_L      _PK_L_(0x3B, 0x50)
#define REG_SC_BK3B_50_H      _PK_H_(0x3B, 0x50)
#define REG_SC_BK3B_51_L      _PK_L_(0x3B, 0x51)
#define REG_SC_BK3B_51_H      _PK_H_(0x3B, 0x51)
#define REG_SC_BK3B_52_L      _PK_L_(0x3B, 0x52)
#define REG_SC_BK3B_52_H      _PK_H_(0x3B, 0x52)
#define REG_SC_BK3B_53_L      _PK_L_(0x3B, 0x53)
#define REG_SC_BK3B_53_H      _PK_H_(0x3B, 0x53)
#define REG_SC_BK3B_54_L      _PK_L_(0x3B, 0x54)
#define REG_SC_BK3B_54_H      _PK_H_(0x3B, 0x54)
#define REG_SC_BK3B_55_L      _PK_L_(0x3B, 0x55)
#define REG_SC_BK3B_55_H      _PK_H_(0x3B, 0x55)
#define REG_SC_BK3B_56_L      _PK_L_(0x3B, 0x56)
#define REG_SC_BK3B_56_H      _PK_H_(0x3B, 0x56)
#define REG_SC_BK3B_57_L      _PK_L_(0x3B, 0x57)
#define REG_SC_BK3B_57_H      _PK_H_(0x3B, 0x57)
#define REG_SC_BK3B_58_L      _PK_L_(0x3B, 0x58)
#define REG_SC_BK3B_58_H      _PK_H_(0x3B, 0x58)
#define REG_SC_BK3B_59_L      _PK_L_(0x3B, 0x59)
#define REG_SC_BK3B_59_H      _PK_H_(0x3B, 0x59)
#define REG_SC_BK3B_5A_L      _PK_L_(0x3B, 0x5A)
#define REG_SC_BK3B_5A_H      _PK_H_(0x3B, 0x5A)
#define REG_SC_BK3B_5B_L      _PK_L_(0x3B, 0x5B)
#define REG_SC_BK3B_5B_H      _PK_H_(0x3B, 0x5B)
#define REG_SC_BK3B_5C_L      _PK_L_(0x3B, 0x5C)
#define REG_SC_BK3B_5C_H      _PK_H_(0x3B, 0x5C)
#define REG_SC_BK3B_5D_L      _PK_L_(0x3B, 0x5D)
#define REG_SC_BK3B_5D_H      _PK_H_(0x3B, 0x5D)
#define REG_SC_BK3B_5E_L      _PK_L_(0x3B, 0x5E)
#define REG_SC_BK3B_5E_H      _PK_H_(0x3B, 0x5E)
#define REG_SC_BK3B_5F_L      _PK_L_(0x3B, 0x5F)
#define REG_SC_BK3B_5F_H      _PK_H_(0x3B, 0x5F)
#define REG_SC_BK3B_60_L      _PK_L_(0x3B, 0x60)
#define REG_SC_BK3B_60_H      _PK_H_(0x3B, 0x60)
#define REG_SC_BK3B_61_L      _PK_L_(0x3B, 0x61)
#define REG_SC_BK3B_61_H      _PK_H_(0x3B, 0x61)
#define REG_SC_BK3B_62_L      _PK_L_(0x3B, 0x62)
#define REG_SC_BK3B_62_H      _PK_H_(0x3B, 0x62)
#define REG_SC_BK3B_63_L      _PK_L_(0x3B, 0x63)
#define REG_SC_BK3B_63_H      _PK_H_(0x3B, 0x63)
#define REG_SC_BK3B_64_L      _PK_L_(0x3B, 0x64)
#define REG_SC_BK3B_64_H      _PK_H_(0x3B, 0x64)
#define REG_SC_BK3B_65_L      _PK_L_(0x3B, 0x65)
#define REG_SC_BK3B_65_H      _PK_H_(0x3B, 0x65)
#define REG_SC_BK3B_66_L      _PK_L_(0x3B, 0x66)
#define REG_SC_BK3B_66_H      _PK_H_(0x3B, 0x66)
#define REG_SC_BK3B_67_L      _PK_L_(0x3B, 0x67)
#define REG_SC_BK3B_67_H      _PK_H_(0x3B, 0x67)
#define REG_SC_BK3B_68_L      _PK_L_(0x3B, 0x68)
#define REG_SC_BK3B_68_H      _PK_H_(0x3B, 0x68)
#define REG_SC_BK3B_69_L      _PK_L_(0x3B, 0x69)
#define REG_SC_BK3B_69_H      _PK_H_(0x3B, 0x69)
#define REG_SC_BK3B_6A_L      _PK_L_(0x3B, 0x6A)
#define REG_SC_BK3B_6A_H      _PK_H_(0x3B, 0x6A)
#define REG_SC_BK3B_6B_L      _PK_L_(0x3B, 0x6B)
#define REG_SC_BK3B_6B_H      _PK_H_(0x3B, 0x6B)
#define REG_SC_BK3B_6C_L      _PK_L_(0x3B, 0x6C)
#define REG_SC_BK3B_6C_H      _PK_H_(0x3B, 0x6C)
#define REG_SC_BK3B_6D_L      _PK_L_(0x3B, 0x6D)
#define REG_SC_BK3B_6D_H      _PK_H_(0x3B, 0x6D)
#define REG_SC_BK3B_6E_L      _PK_L_(0x3B, 0x6E)
#define REG_SC_BK3B_6E_H      _PK_H_(0x3B, 0x6E)
#define REG_SC_BK3B_6F_L      _PK_L_(0x3B, 0x6F)
#define REG_SC_BK3B_6F_H      _PK_H_(0x3B, 0x6F)
#define REG_SC_BK3B_70_L      _PK_L_(0x3B, 0x70)
#define REG_SC_BK3B_70_H      _PK_H_(0x3B, 0x70)
#define REG_SC_BK3B_71_L      _PK_L_(0x3B, 0x71)
#define REG_SC_BK3B_71_H      _PK_H_(0x3B, 0x71)
#define REG_SC_BK3B_72_L      _PK_L_(0x3B, 0x72)
#define REG_SC_BK3B_72_H      _PK_H_(0x3B, 0x72)
#define REG_SC_BK3B_73_L      _PK_L_(0x3B, 0x73)
#define REG_SC_BK3B_73_H      _PK_H_(0x3B, 0x73)
#define REG_SC_BK3B_74_L      _PK_L_(0x3B, 0x74)
#define REG_SC_BK3B_74_H      _PK_H_(0x3B, 0x74)
#define REG_SC_BK3B_75_L      _PK_L_(0x3B, 0x75)
#define REG_SC_BK3B_75_H      _PK_H_(0x3B, 0x75)
#define REG_SC_BK3B_76_L      _PK_L_(0x3B, 0x76)
#define REG_SC_BK3B_76_H      _PK_H_(0x3B, 0x76)
#define REG_SC_BK3B_77_L      _PK_L_(0x3B, 0x77)
#define REG_SC_BK3B_77_H      _PK_H_(0x3B, 0x77)
#define REG_SC_BK3B_78_L      _PK_L_(0x3B, 0x78)
#define REG_SC_BK3B_78_H      _PK_H_(0x3B, 0x78)
#define REG_SC_BK3B_79_L      _PK_L_(0x3B, 0x79)
#define REG_SC_BK3B_79_H      _PK_H_(0x3B, 0x79)
#define REG_SC_BK3B_7A_L      _PK_L_(0x3B, 0x7A)
#define REG_SC_BK3B_7A_H      _PK_H_(0x3B, 0x7A)
#define REG_SC_BK3B_7B_L      _PK_L_(0x3B, 0x7B)
#define REG_SC_BK3B_7B_H      _PK_H_(0x3B, 0x7B)
#define REG_SC_BK3B_7C_L      _PK_L_(0x3B, 0x7C)
#define REG_SC_BK3B_7C_H      _PK_H_(0x3B, 0x7C)
#define REG_SC_BK3B_7D_L      _PK_L_(0x3B, 0x7D)
#define REG_SC_BK3B_7D_H      _PK_H_(0x3B, 0x7D)
#define REG_SC_BK3B_7E_L      _PK_L_(0x3B, 0x7E)
#define REG_SC_BK3B_7E_H      _PK_H_(0x3B, 0x7E)
#define REG_SC_BK3B_7F_L      _PK_L_(0x3B, 0x7F)
#define REG_SC_BK3B_7F_H      _PK_H_(0x3B, 0x7F)

//----------------------------------------------
//  BK3C
//----------------------------------------------
#define REG_SC_BK3C_00_L      _PK_L_(0x3C, 0x00)
#define REG_SC_BK3C_00_H      _PK_H_(0x3C, 0x00)
#define REG_SC_BK3C_01_L      _PK_L_(0x3C, 0x01)
#define REG_SC_BK3C_01_H      _PK_H_(0x3C, 0x01)
#define REG_SC_BK3C_02_L      _PK_L_(0x3C, 0x02)
#define REG_SC_BK3C_02_H      _PK_H_(0x3C, 0x02)
#define REG_SC_BK3C_03_L      _PK_L_(0x3C, 0x03)
#define REG_SC_BK3C_03_H      _PK_H_(0x3C, 0x03)
#define REG_SC_BK3C_04_L      _PK_L_(0x3C, 0x04)
#define REG_SC_BK3C_04_H      _PK_H_(0x3C, 0x04)
#define REG_SC_BK3C_05_L      _PK_L_(0x3C, 0x05)
#define REG_SC_BK3C_05_H      _PK_H_(0x3C, 0x05)
#define REG_SC_BK3C_06_L      _PK_L_(0x3C, 0x06)
#define REG_SC_BK3C_06_H      _PK_H_(0x3C, 0x06)
#define REG_SC_BK3C_07_L      _PK_L_(0x3C, 0x07)
#define REG_SC_BK3C_07_H      _PK_H_(0x3C, 0x07)
#define REG_SC_BK3C_08_L      _PK_L_(0x3C, 0x08)
#define REG_SC_BK3C_08_H      _PK_H_(0x3C, 0x08)
#define REG_SC_BK3C_09_L      _PK_L_(0x3C, 0x09)
#define REG_SC_BK3C_09_H      _PK_H_(0x3C, 0x09)
#define REG_SC_BK3C_0A_L      _PK_L_(0x3C, 0x0A)
#define REG_SC_BK3C_0A_H      _PK_H_(0x3C, 0x0A)
#define REG_SC_BK3C_0B_L      _PK_L_(0x3C, 0x0B)
#define REG_SC_BK3C_0B_H      _PK_H_(0x3C, 0x0B)
#define REG_SC_BK3C_0C_L      _PK_L_(0x3C, 0x0C)
#define REG_SC_BK3C_0C_H      _PK_H_(0x3C, 0x0C)
#define REG_SC_BK3C_0D_L      _PK_L_(0x3C, 0x0D)
#define REG_SC_BK3C_0D_H      _PK_H_(0x3C, 0x0D)
#define REG_SC_BK3C_0E_L      _PK_L_(0x3C, 0x0E)
#define REG_SC_BK3C_0E_H      _PK_H_(0x3C, 0x0E)
#define REG_SC_BK3C_0F_L      _PK_L_(0x3C, 0x0F)
#define REG_SC_BK3C_0F_H      _PK_H_(0x3C, 0x0F)
#define REG_SC_BK3C_10_L      _PK_L_(0x3C, 0x10)
#define REG_SC_BK3C_10_H      _PK_H_(0x3C, 0x10)
#define REG_SC_BK3C_11_L      _PK_L_(0x3C, 0x11)
#define REG_SC_BK3C_11_H      _PK_H_(0x3C, 0x11)
#define REG_SC_BK3C_12_L      _PK_L_(0x3C, 0x12)
#define REG_SC_BK3C_12_H      _PK_H_(0x3C, 0x12)
#define REG_SC_BK3C_13_L      _PK_L_(0x3C, 0x13)
#define REG_SC_BK3C_13_H      _PK_H_(0x3C, 0x13)
#define REG_SC_BK3C_14_L      _PK_L_(0x3C, 0x14)
#define REG_SC_BK3C_14_H      _PK_H_(0x3C, 0x14)
#define REG_SC_BK3C_15_L      _PK_L_(0x3C, 0x15)
#define REG_SC_BK3C_15_H      _PK_H_(0x3C, 0x15)
#define REG_SC_BK3C_16_L      _PK_L_(0x3C, 0x16)
#define REG_SC_BK3C_16_H      _PK_H_(0x3C, 0x16)
#define REG_SC_BK3C_17_L      _PK_L_(0x3C, 0x17)
#define REG_SC_BK3C_17_H      _PK_H_(0x3C, 0x17)
#define REG_SC_BK3C_18_L      _PK_L_(0x3C, 0x18)
#define REG_SC_BK3C_18_H      _PK_H_(0x3C, 0x18)
#define REG_SC_BK3C_19_L      _PK_L_(0x3C, 0x19)
#define REG_SC_BK3C_19_H      _PK_H_(0x3C, 0x19)
#define REG_SC_BK3C_1A_L      _PK_L_(0x3C, 0x1A)
#define REG_SC_BK3C_1A_H      _PK_H_(0x3C, 0x1A)
#define REG_SC_BK3C_1B_L      _PK_L_(0x3C, 0x1B)
#define REG_SC_BK3C_1B_H      _PK_H_(0x3C, 0x1B)
#define REG_SC_BK3C_1C_L      _PK_L_(0x3C, 0x1C)
#define REG_SC_BK3C_1C_H      _PK_H_(0x3C, 0x1C)
#define REG_SC_BK3C_1D_L      _PK_L_(0x3C, 0x1D)
#define REG_SC_BK3C_1D_H      _PK_H_(0x3C, 0x1D)
#define REG_SC_BK3C_1E_L      _PK_L_(0x3C, 0x1E)
#define REG_SC_BK3C_1E_H      _PK_H_(0x3C, 0x1E)
#define REG_SC_BK3C_1F_L      _PK_L_(0x3C, 0x1F)
#define REG_SC_BK3C_1F_H      _PK_H_(0x3C, 0x1F)
#define REG_SC_BK3C_20_L      _PK_L_(0x3C, 0x20)
#define REG_SC_BK3C_20_H      _PK_H_(0x3C, 0x20)
#define REG_SC_BK3C_21_L      _PK_L_(0x3C, 0x21)
#define REG_SC_BK3C_21_H      _PK_H_(0x3C, 0x21)
#define REG_SC_BK3C_22_L      _PK_L_(0x3C, 0x22)
#define REG_SC_BK3C_22_H      _PK_H_(0x3C, 0x22)
#define REG_SC_BK3C_23_L      _PK_L_(0x3C, 0x23)
#define REG_SC_BK3C_23_H      _PK_H_(0x3C, 0x23)
#define REG_SC_BK3C_24_L      _PK_L_(0x3C, 0x24)
#define REG_SC_BK3C_24_H      _PK_H_(0x3C, 0x24)
#define REG_SC_BK3C_25_L      _PK_L_(0x3C, 0x25)
#define REG_SC_BK3C_25_H      _PK_H_(0x3C, 0x25)
#define REG_SC_BK3C_26_L      _PK_L_(0x3C, 0x26)
#define REG_SC_BK3C_26_H      _PK_H_(0x3C, 0x26)
#define REG_SC_BK3C_27_L      _PK_L_(0x3C, 0x27)
#define REG_SC_BK3C_27_H      _PK_H_(0x3C, 0x27)
#define REG_SC_BK3C_28_L      _PK_L_(0x3C, 0x28)
#define REG_SC_BK3C_28_H      _PK_H_(0x3C, 0x28)
#define REG_SC_BK3C_29_L      _PK_L_(0x3C, 0x29)
#define REG_SC_BK3C_29_H      _PK_H_(0x3C, 0x29)
#define REG_SC_BK3C_2A_L      _PK_L_(0x3C, 0x2A)
#define REG_SC_BK3C_2A_H      _PK_H_(0x3C, 0x2A)
#define REG_SC_BK3C_2B_L      _PK_L_(0x3C, 0x2B)
#define REG_SC_BK3C_2B_H      _PK_H_(0x3C, 0x2B)
#define REG_SC_BK3C_2C_L      _PK_L_(0x3C, 0x2C)
#define REG_SC_BK3C_2C_H      _PK_H_(0x3C, 0x2C)
#define REG_SC_BK3C_2D_L      _PK_L_(0x3C, 0x2D)
#define REG_SC_BK3C_2D_H      _PK_H_(0x3C, 0x2D)
#define REG_SC_BK3C_2E_L      _PK_L_(0x3C, 0x2E)
#define REG_SC_BK3C_2E_H      _PK_H_(0x3C, 0x2E)
#define REG_SC_BK3C_2F_L      _PK_L_(0x3C, 0x2F)
#define REG_SC_BK3C_2F_H      _PK_H_(0x3C, 0x2F)
#define REG_SC_BK3C_30_L      _PK_L_(0x3C, 0x30)
#define REG_SC_BK3C_30_H      _PK_H_(0x3C, 0x30)
#define REG_SC_BK3C_31_L      _PK_L_(0x3C, 0x31)
#define REG_SC_BK3C_31_H      _PK_H_(0x3C, 0x31)
#define REG_SC_BK3C_32_L      _PK_L_(0x3C, 0x32)
#define REG_SC_BK3C_32_H      _PK_H_(0x3C, 0x32)
#define REG_SC_BK3C_33_L      _PK_L_(0x3C, 0x33)
#define REG_SC_BK3C_33_H      _PK_H_(0x3C, 0x33)
#define REG_SC_BK3C_34_L      _PK_L_(0x3C, 0x34)
#define REG_SC_BK3C_34_H      _PK_H_(0x3C, 0x34)
#define REG_SC_BK3C_35_L      _PK_L_(0x3C, 0x35)
#define REG_SC_BK3C_35_H      _PK_H_(0x3C, 0x35)
#define REG_SC_BK3C_36_L      _PK_L_(0x3C, 0x36)
#define REG_SC_BK3C_36_H      _PK_H_(0x3C, 0x36)
#define REG_SC_BK3C_37_L      _PK_L_(0x3C, 0x37)
#define REG_SC_BK3C_37_H      _PK_H_(0x3C, 0x37)
#define REG_SC_BK3C_38_L      _PK_L_(0x3C, 0x38)
#define REG_SC_BK3C_38_H      _PK_H_(0x3C, 0x38)
#define REG_SC_BK3C_39_L      _PK_L_(0x3C, 0x39)
#define REG_SC_BK3C_39_H      _PK_H_(0x3C, 0x39)
#define REG_SC_BK3C_3A_L      _PK_L_(0x3C, 0x3A)
#define REG_SC_BK3C_3A_H      _PK_H_(0x3C, 0x3A)
#define REG_SC_BK3C_3B_L      _PK_L_(0x3C, 0x3B)
#define REG_SC_BK3C_3B_H      _PK_H_(0x3C, 0x3B)
#define REG_SC_BK3C_3C_L      _PK_L_(0x3C, 0x3C)
#define REG_SC_BK3C_3C_H      _PK_H_(0x3C, 0x3C)
#define REG_SC_BK3C_3D_L      _PK_L_(0x3C, 0x3D)
#define REG_SC_BK3C_3D_H      _PK_H_(0x3C, 0x3D)
#define REG_SC_BK3C_3E_L      _PK_L_(0x3C, 0x3E)
#define REG_SC_BK3C_3E_H      _PK_H_(0x3C, 0x3E)
#define REG_SC_BK3C_3F_L      _PK_L_(0x3C, 0x3F)
#define REG_SC_BK3C_3F_H      _PK_H_(0x3C, 0x3F)
#define REG_SC_BK3C_40_L      _PK_L_(0x3C, 0x40)
#define REG_SC_BK3C_40_H      _PK_H_(0x3C, 0x40)
#define REG_SC_BK3C_41_L      _PK_L_(0x3C, 0x41)
#define REG_SC_BK3C_41_H      _PK_H_(0x3C, 0x41)
#define REG_SC_BK3C_42_L      _PK_L_(0x3C, 0x42)
#define REG_SC_BK3C_42_H      _PK_H_(0x3C, 0x42)
#define REG_SC_BK3C_43_L      _PK_L_(0x3C, 0x43)
#define REG_SC_BK3C_43_H      _PK_H_(0x3C, 0x43)
#define REG_SC_BK3C_44_L      _PK_L_(0x3C, 0x44)
#define REG_SC_BK3C_44_H      _PK_H_(0x3C, 0x44)
#define REG_SC_BK3C_45_L      _PK_L_(0x3C, 0x45)
#define REG_SC_BK3C_45_H      _PK_H_(0x3C, 0x45)
#define REG_SC_BK3C_46_L      _PK_L_(0x3C, 0x46)
#define REG_SC_BK3C_46_H      _PK_H_(0x3C, 0x46)
#define REG_SC_BK3C_47_L      _PK_L_(0x3C, 0x47)
#define REG_SC_BK3C_47_H      _PK_H_(0x3C, 0x47)
#define REG_SC_BK3C_48_L      _PK_L_(0x3C, 0x48)
#define REG_SC_BK3C_48_H      _PK_H_(0x3C, 0x48)
#define REG_SC_BK3C_49_L      _PK_L_(0x3C, 0x49)
#define REG_SC_BK3C_49_H      _PK_H_(0x3C, 0x49)
#define REG_SC_BK3C_4A_L      _PK_L_(0x3C, 0x4A)
#define REG_SC_BK3C_4A_H      _PK_H_(0x3C, 0x4A)
#define REG_SC_BK3C_4B_L      _PK_L_(0x3C, 0x4B)
#define REG_SC_BK3C_4B_H      _PK_H_(0x3C, 0x4B)
#define REG_SC_BK3C_4C_L      _PK_L_(0x3C, 0x4C)
#define REG_SC_BK3C_4C_H      _PK_H_(0x3C, 0x4C)
#define REG_SC_BK3C_4D_L      _PK_L_(0x3C, 0x4D)
#define REG_SC_BK3C_4D_H      _PK_H_(0x3C, 0x4D)
#define REG_SC_BK3C_4E_L      _PK_L_(0x3C, 0x4E)
#define REG_SC_BK3C_4E_H      _PK_H_(0x3C, 0x4E)
#define REG_SC_BK3C_4F_L      _PK_L_(0x3C, 0x4F)
#define REG_SC_BK3C_4F_H      _PK_H_(0x3C, 0x4F)
#define REG_SC_BK3C_50_L      _PK_L_(0x3C, 0x50)
#define REG_SC_BK3C_50_H      _PK_H_(0x3C, 0x50)
#define REG_SC_BK3C_51_L      _PK_L_(0x3C, 0x51)
#define REG_SC_BK3C_51_H      _PK_H_(0x3C, 0x51)
#define REG_SC_BK3C_52_L      _PK_L_(0x3C, 0x52)
#define REG_SC_BK3C_52_H      _PK_H_(0x3C, 0x52)
#define REG_SC_BK3C_53_L      _PK_L_(0x3C, 0x53)
#define REG_SC_BK3C_53_H      _PK_H_(0x3C, 0x53)
#define REG_SC_BK3C_54_L      _PK_L_(0x3C, 0x54)
#define REG_SC_BK3C_54_H      _PK_H_(0x3C, 0x54)
#define REG_SC_BK3C_55_L      _PK_L_(0x3C, 0x55)
#define REG_SC_BK3C_55_H      _PK_H_(0x3C, 0x55)
#define REG_SC_BK3C_56_L      _PK_L_(0x3C, 0x56)
#define REG_SC_BK3C_56_H      _PK_H_(0x3C, 0x56)
#define REG_SC_BK3C_57_L      _PK_L_(0x3C, 0x57)
#define REG_SC_BK3C_57_H      _PK_H_(0x3C, 0x57)
#define REG_SC_BK3C_58_L      _PK_L_(0x3C, 0x58)
#define REG_SC_BK3C_58_H      _PK_H_(0x3C, 0x58)
#define REG_SC_BK3C_59_L      _PK_L_(0x3C, 0x59)
#define REG_SC_BK3C_59_H      _PK_H_(0x3C, 0x59)
#define REG_SC_BK3C_5A_L      _PK_L_(0x3C, 0x5A)
#define REG_SC_BK3C_5A_H      _PK_H_(0x3C, 0x5A)
#define REG_SC_BK3C_5B_L      _PK_L_(0x3C, 0x5B)
#define REG_SC_BK3C_5B_H      _PK_H_(0x3C, 0x5B)
#define REG_SC_BK3C_5C_L      _PK_L_(0x3C, 0x5C)
#define REG_SC_BK3C_5C_H      _PK_H_(0x3C, 0x5C)
#define REG_SC_BK3C_5D_L      _PK_L_(0x3C, 0x5D)
#define REG_SC_BK3C_5D_H      _PK_H_(0x3C, 0x5D)
#define REG_SC_BK3C_5E_L      _PK_L_(0x3C, 0x5E)
#define REG_SC_BK3C_5E_H      _PK_H_(0x3C, 0x5E)
#define REG_SC_BK3C_5F_L      _PK_L_(0x3C, 0x5F)
#define REG_SC_BK3C_5F_H      _PK_H_(0x3C, 0x5F)
#define REG_SC_BK3C_60_L      _PK_L_(0x3C, 0x60)
#define REG_SC_BK3C_60_H      _PK_H_(0x3C, 0x60)
#define REG_SC_BK3C_61_L      _PK_L_(0x3C, 0x61)
#define REG_SC_BK3C_61_H      _PK_H_(0x3C, 0x61)
#define REG_SC_BK3C_62_L      _PK_L_(0x3C, 0x62)
#define REG_SC_BK3C_62_H      _PK_H_(0x3C, 0x62)
#define REG_SC_BK3C_63_L      _PK_L_(0x3C, 0x63)
#define REG_SC_BK3C_63_H      _PK_H_(0x3C, 0x63)
#define REG_SC_BK3C_64_L      _PK_L_(0x3C, 0x64)
#define REG_SC_BK3C_64_H      _PK_H_(0x3C, 0x64)
#define REG_SC_BK3C_65_L      _PK_L_(0x3C, 0x65)
#define REG_SC_BK3C_65_H      _PK_H_(0x3C, 0x65)
#define REG_SC_BK3C_66_L      _PK_L_(0x3C, 0x66)
#define REG_SC_BK3C_66_H      _PK_H_(0x3C, 0x66)
#define REG_SC_BK3C_67_L      _PK_L_(0x3C, 0x67)
#define REG_SC_BK3C_67_H      _PK_H_(0x3C, 0x67)
#define REG_SC_BK3C_68_L      _PK_L_(0x3C, 0x68)
#define REG_SC_BK3C_68_H      _PK_H_(0x3C, 0x68)
#define REG_SC_BK3C_69_L      _PK_L_(0x3C, 0x69)
#define REG_SC_BK3C_69_H      _PK_H_(0x3C, 0x69)
#define REG_SC_BK3C_6A_L      _PK_L_(0x3C, 0x6A)
#define REG_SC_BK3C_6A_H      _PK_H_(0x3C, 0x6A)
#define REG_SC_BK3C_6B_L      _PK_L_(0x3C, 0x6B)
#define REG_SC_BK3C_6B_H      _PK_H_(0x3C, 0x6B)
#define REG_SC_BK3C_6C_L      _PK_L_(0x3C, 0x6C)
#define REG_SC_BK3C_6C_H      _PK_H_(0x3C, 0x6C)
#define REG_SC_BK3C_6D_L      _PK_L_(0x3C, 0x6D)
#define REG_SC_BK3C_6D_H      _PK_H_(0x3C, 0x6D)
#define REG_SC_BK3C_6E_L      _PK_L_(0x3C, 0x6E)
#define REG_SC_BK3C_6E_H      _PK_H_(0x3C, 0x6E)
#define REG_SC_BK3C_6F_L      _PK_L_(0x3C, 0x6F)
#define REG_SC_BK3C_6F_H      _PK_H_(0x3C, 0x6F)
#define REG_SC_BK3C_70_L      _PK_L_(0x3C, 0x70)
#define REG_SC_BK3C_70_H      _PK_H_(0x3C, 0x70)
#define REG_SC_BK3C_71_L      _PK_L_(0x3C, 0x71)
#define REG_SC_BK3C_71_H      _PK_H_(0x3C, 0x71)
#define REG_SC_BK3C_72_L      _PK_L_(0x3C, 0x72)
#define REG_SC_BK3C_72_H      _PK_H_(0x3C, 0x72)
#define REG_SC_BK3C_73_L      _PK_L_(0x3C, 0x73)
#define REG_SC_BK3C_73_H      _PK_H_(0x3C, 0x73)
#define REG_SC_BK3C_74_L      _PK_L_(0x3C, 0x74)
#define REG_SC_BK3C_74_H      _PK_H_(0x3C, 0x74)
#define REG_SC_BK3C_75_L      _PK_L_(0x3C, 0x75)
#define REG_SC_BK3C_75_H      _PK_H_(0x3C, 0x75)
#define REG_SC_BK3C_76_L      _PK_L_(0x3C, 0x76)
#define REG_SC_BK3C_76_H      _PK_H_(0x3C, 0x76)
#define REG_SC_BK3C_77_L      _PK_L_(0x3C, 0x77)
#define REG_SC_BK3C_77_H      _PK_H_(0x3C, 0x77)
#define REG_SC_BK3C_78_L      _PK_L_(0x3C, 0x78)
#define REG_SC_BK3C_78_H      _PK_H_(0x3C, 0x78)
#define REG_SC_BK3C_79_L      _PK_L_(0x3C, 0x79)
#define REG_SC_BK3C_79_H      _PK_H_(0x3C, 0x79)
#define REG_SC_BK3C_7A_L      _PK_L_(0x3C, 0x7A)
#define REG_SC_BK3C_7A_H      _PK_H_(0x3C, 0x7A)
#define REG_SC_BK3C_7B_L      _PK_L_(0x3C, 0x7B)
#define REG_SC_BK3C_7B_H      _PK_H_(0x3C, 0x7B)
#define REG_SC_BK3C_7C_L      _PK_L_(0x3C, 0x7C)
#define REG_SC_BK3C_7C_H      _PK_H_(0x3C, 0x7C)
#define REG_SC_BK3C_7D_L      _PK_L_(0x3C, 0x7D)
#define REG_SC_BK3C_7D_H      _PK_H_(0x3C, 0x7D)
#define REG_SC_BK3C_7E_L      _PK_L_(0x3C, 0x7E)
#define REG_SC_BK3C_7E_H      _PK_H_(0x3C, 0x7E)
#define REG_SC_BK3C_7F_L      _PK_L_(0x3C, 0x7F)
#define REG_SC_BK3C_7F_H      _PK_H_(0x3C, 0x7F)

//----------------------------------------------
//  BK3D: BYPASS
//----------------------------------------------
#define REG_SC_BK3D_00_L      _PK_L_(0x3D, 0x00)
#define REG_SC_BK3D_00_H      _PK_H_(0x3D, 0x00)
#define REG_SC_BK3D_01_L      _PK_L_(0x3D, 0x01)
#define REG_SC_BK3D_01_H      _PK_H_(0x3D, 0x01)
#define REG_SC_BK3D_02_L      _PK_L_(0x3D, 0x02)
#define REG_SC_BK3D_02_H      _PK_H_(0x3D, 0x02)
#define REG_SC_BK3D_03_L      _PK_L_(0x3D, 0x03)
#define REG_SC_BK3D_03_H      _PK_H_(0x3D, 0x03)
#define REG_SC_BK3D_04_L      _PK_L_(0x3D, 0x04)
#define REG_SC_BK3D_04_H      _PK_H_(0x3D, 0x04)
#define REG_SC_BK3D_05_L      _PK_L_(0x3D, 0x05)
#define REG_SC_BK3D_05_H      _PK_H_(0x3D, 0x05)
#define REG_SC_BK3D_06_L      _PK_L_(0x3D, 0x06)
#define REG_SC_BK3D_06_H      _PK_H_(0x3D, 0x06)
#define REG_SC_BK3D_07_L      _PK_L_(0x3D, 0x07)
#define REG_SC_BK3D_07_H      _PK_H_(0x3D, 0x07)
#define REG_SC_BK3D_08_L      _PK_L_(0x3D, 0x08)
#define REG_SC_BK3D_08_H      _PK_H_(0x3D, 0x08)
#define REG_SC_BK3D_09_L      _PK_L_(0x3D, 0x09)
#define REG_SC_BK3D_09_H      _PK_H_(0x3D, 0x09)
#define REG_SC_BK3D_0A_L      _PK_L_(0x3D, 0x0A)
#define REG_SC_BK3D_0A_H      _PK_H_(0x3D, 0x0A)
#define REG_SC_BK3D_0B_L      _PK_L_(0x3D, 0x0B)
#define REG_SC_BK3D_0B_H      _PK_H_(0x3D, 0x0B)
#define REG_SC_BK3D_0C_L      _PK_L_(0x3D, 0x0C)
#define REG_SC_BK3D_0C_H      _PK_H_(0x3D, 0x0C)
#define REG_SC_BK3D_0D_L      _PK_L_(0x3D, 0x0D)
#define REG_SC_BK3D_0D_H      _PK_H_(0x3D, 0x0D)
#define REG_SC_BK3D_0E_L      _PK_L_(0x3D, 0x0E)
#define REG_SC_BK3D_0E_H      _PK_H_(0x3D, 0x0E)
#define REG_SC_BK3D_0F_L      _PK_L_(0x3D, 0x0F)
#define REG_SC_BK3D_0F_H      _PK_H_(0x3D, 0x0F)
#define REG_SC_BK3D_10_L      _PK_L_(0x3D, 0x10)
#define REG_SC_BK3D_10_H      _PK_H_(0x3D, 0x10)
#define REG_SC_BK3D_11_L      _PK_L_(0x3D, 0x11)
#define REG_SC_BK3D_11_H      _PK_H_(0x3D, 0x11)
#define REG_SC_BK3D_12_L      _PK_L_(0x3D, 0x12)
#define REG_SC_BK3D_12_H      _PK_H_(0x3D, 0x12)
#define REG_SC_BK3D_13_L      _PK_L_(0x3D, 0x13)
#define REG_SC_BK3D_13_H      _PK_H_(0x3D, 0x13)
#define REG_SC_BK3D_14_L      _PK_L_(0x3D, 0x14)
#define REG_SC_BK3D_14_H      _PK_H_(0x3D, 0x14)
#define REG_SC_BK3D_15_L      _PK_L_(0x3D, 0x15)
#define REG_SC_BK3D_15_H      _PK_H_(0x3D, 0x15)
#define REG_SC_BK3D_16_L      _PK_L_(0x3D, 0x16)
#define REG_SC_BK3D_16_H      _PK_H_(0x3D, 0x16)
#define REG_SC_BK3D_17_L      _PK_L_(0x3D, 0x17)
#define REG_SC_BK3D_17_H      _PK_H_(0x3D, 0x17)
#define REG_SC_BK3D_18_L      _PK_L_(0x3D, 0x18)
#define REG_SC_BK3D_18_H      _PK_H_(0x3D, 0x18)
#define REG_SC_BK3D_19_L      _PK_L_(0x3D, 0x19)
#define REG_SC_BK3D_19_H      _PK_H_(0x3D, 0x19)
#define REG_SC_BK3D_1A_L      _PK_L_(0x3D, 0x1A)
#define REG_SC_BK3D_1A_H      _PK_H_(0x3D, 0x1A)
#define REG_SC_BK3D_1B_L      _PK_L_(0x3D, 0x1B)
#define REG_SC_BK3D_1B_H      _PK_H_(0x3D, 0x1B)
#define REG_SC_BK3D_1C_L      _PK_L_(0x3D, 0x1C)
#define REG_SC_BK3D_1C_H      _PK_H_(0x3D, 0x1C)
#define REG_SC_BK3D_1D_L      _PK_L_(0x3D, 0x1D)
#define REG_SC_BK3D_1D_H      _PK_H_(0x3D, 0x1D)
#define REG_SC_BK3D_1E_L      _PK_L_(0x3D, 0x1E)
#define REG_SC_BK3D_1E_H      _PK_H_(0x3D, 0x1E)
#define REG_SC_BK3D_1F_L      _PK_L_(0x3D, 0x1F)
#define REG_SC_BK3D_1F_H      _PK_H_(0x3D, 0x1F)

//----------------------------------------------
//  BK3E: BYPASS
//----------------------------------------------
#define REG_SC_BK3E_00_L      _PK_L_(0x3E, 0x00)
#define REG_SC_BK3E_00_H      _PK_H_(0x3E, 0x00)
#define REG_SC_BK3E_01_L      _PK_L_(0x3E, 0x01)
#define REG_SC_BK3E_01_H      _PK_H_(0x3E, 0x01)
#define REG_SC_BK3E_02_L      _PK_L_(0x3E, 0x02)
#define REG_SC_BK3E_02_H      _PK_H_(0x3E, 0x02)
#define REG_SC_BK3E_03_L      _PK_L_(0x3E, 0x03)
#define REG_SC_BK3E_03_H      _PK_H_(0x3E, 0x03)
#define REG_SC_BK3E_04_L      _PK_L_(0x3E, 0x04)
#define REG_SC_BK3E_04_H      _PK_H_(0x3E, 0x04)
#define REG_SC_BK3E_05_L      _PK_L_(0x3E, 0x05)
#define REG_SC_BK3E_05_H      _PK_H_(0x3E, 0x05)
#define REG_SC_BK3E_06_L      _PK_L_(0x3E, 0x06)
#define REG_SC_BK3E_06_H      _PK_H_(0x3E, 0x06)
#define REG_SC_BK3E_07_L      _PK_L_(0x3E, 0x07)
#define REG_SC_BK3E_07_H      _PK_H_(0x3E, 0x07)
#define REG_SC_BK3E_08_L      _PK_L_(0x3E, 0x08)
#define REG_SC_BK3E_08_H      _PK_H_(0x3E, 0x08)
#define REG_SC_BK3E_09_L      _PK_L_(0x3E, 0x09)
#define REG_SC_BK3E_09_H      _PK_H_(0x3E, 0x09)
#define REG_SC_BK3E_0A_L      _PK_L_(0x3E, 0x0A)
#define REG_SC_BK3E_0A_H      _PK_H_(0x3E, 0x0A)
#define REG_SC_BK3E_0B_L      _PK_L_(0x3E, 0x0B)
#define REG_SC_BK3E_0B_H      _PK_H_(0x3E, 0x0B)
#define REG_SC_BK3E_0C_L      _PK_L_(0x3E, 0x0C)
#define REG_SC_BK3E_0C_H      _PK_H_(0x3E, 0x0C)
#define REG_SC_BK3E_0D_L      _PK_L_(0x3E, 0x0D)
#define REG_SC_BK3E_0D_H      _PK_H_(0x3E, 0x0D)
#define REG_SC_BK3E_0E_L      _PK_L_(0x3E, 0x0E)
#define REG_SC_BK3E_0E_H      _PK_H_(0x3E, 0x0E)
#define REG_SC_BK3E_0F_L      _PK_L_(0x3E, 0x0F)
#define REG_SC_BK3E_0F_H      _PK_H_(0x3E, 0x0F)
#define REG_SC_BK3E_10_L      _PK_L_(0x3E, 0x10)
#define REG_SC_BK3E_10_H      _PK_H_(0x3E, 0x10)
#define REG_SC_BK3E_11_L      _PK_L_(0x3E, 0x11)
#define REG_SC_BK3E_11_H      _PK_H_(0x3E, 0x11)
#define REG_SC_BK3E_12_L      _PK_L_(0x3E, 0x12)
#define REG_SC_BK3E_12_H      _PK_H_(0x3E, 0x12)
#define REG_SC_BK3E_13_L      _PK_L_(0x3E, 0x13)
#define REG_SC_BK3E_13_H      _PK_H_(0x3E, 0x13)
#define REG_SC_BK3E_14_L      _PK_L_(0x3E, 0x14)
#define REG_SC_BK3E_14_H      _PK_H_(0x3E, 0x14)
#define REG_SC_BK3E_15_L      _PK_L_(0x3E, 0x15)
#define REG_SC_BK3E_15_H      _PK_H_(0x3E, 0x15)
#define REG_SC_BK3E_16_L      _PK_L_(0x3E, 0x16)
#define REG_SC_BK3E_16_H      _PK_H_(0x3E, 0x16)
#define REG_SC_BK3E_17_L      _PK_L_(0x3E, 0x17)
#define REG_SC_BK3E_17_H      _PK_H_(0x3E, 0x17)
#define REG_SC_BK3E_18_L      _PK_L_(0x3E, 0x18)
#define REG_SC_BK3E_18_H      _PK_H_(0x3E, 0x18)
#define REG_SC_BK3E_19_L      _PK_L_(0x3E, 0x19)
#define REG_SC_BK3E_19_H      _PK_H_(0x3E, 0x19)
#define REG_SC_BK3E_1A_L      _PK_L_(0x3E, 0x1A)
#define REG_SC_BK3E_1A_H      _PK_H_(0x3E, 0x1A)
#define REG_SC_BK3E_1B_L      _PK_L_(0x3E, 0x1B)
#define REG_SC_BK3E_1B_H      _PK_H_(0x3E, 0x1B)
#define REG_SC_BK3E_1C_L      _PK_L_(0x3E, 0x1C)
#define REG_SC_BK3E_1C_H      _PK_H_(0x3E, 0x1C)
#define REG_SC_BK3E_1D_L      _PK_L_(0x3E, 0x1D)
#define REG_SC_BK3E_1D_H      _PK_H_(0x3E, 0x1D)
#define REG_SC_BK3E_1E_L      _PK_L_(0x3E, 0x1E)
#define REG_SC_BK3E_1E_H      _PK_H_(0x3E, 0x1E)
#define REG_SC_BK3E_1F_L      _PK_L_(0x3E, 0x1F)
#define REG_SC_BK3E_1F_H      _PK_H_(0x3E, 0x1F)
#define REG_SC_BK3E_20_L      _PK_L_(0x3E, 0x20)
#define REG_SC_BK3E_20_H      _PK_H_(0x3E, 0x20)
#define REG_SC_BK3E_21_L      _PK_L_(0x3E, 0x21)
#define REG_SC_BK3E_21_H      _PK_H_(0x3E, 0x21)
#define REG_SC_BK3E_22_L      _PK_L_(0x3E, 0x22)
#define REG_SC_BK3E_22_H      _PK_H_(0x3E, 0x22)
#define REG_SC_BK3E_23_L      _PK_L_(0x3E, 0x23)
#define REG_SC_BK3E_23_H      _PK_H_(0x3E, 0x23)
#define REG_SC_BK3E_24_L      _PK_L_(0x3E, 0x24)
#define REG_SC_BK3E_24_H      _PK_H_(0x3E, 0x24)
#define REG_SC_BK3E_25_L      _PK_L_(0x3E, 0x25)
#define REG_SC_BK3E_25_H      _PK_H_(0x3E, 0x25)
#define REG_SC_BK3E_26_L      _PK_L_(0x3E, 0x26)
#define REG_SC_BK3E_26_H      _PK_H_(0x3E, 0x26)
#define REG_SC_BK3E_27_L      _PK_L_(0x3E, 0x27)
#define REG_SC_BK3E_27_H      _PK_H_(0x3E, 0x27)
#define REG_SC_BK3E_28_L      _PK_L_(0x3E, 0x28)
#define REG_SC_BK3E_28_H      _PK_H_(0x3E, 0x28)
#define REG_SC_BK3E_29_L      _PK_L_(0x3E, 0x29)
#define REG_SC_BK3E_29_H      _PK_H_(0x3E, 0x29)
#define REG_SC_BK3E_2A_L      _PK_L_(0x3E, 0x2A)
#define REG_SC_BK3E_2A_H      _PK_H_(0x3E, 0x2A)
#define REG_SC_BK3E_2B_L      _PK_L_(0x3E, 0x2B)
#define REG_SC_BK3E_2B_H      _PK_H_(0x3E, 0x2B)
#define REG_SC_BK3E_2C_L      _PK_L_(0x3E, 0x2C)
#define REG_SC_BK3E_2C_H      _PK_H_(0x3E, 0x2C)
#define REG_SC_BK3E_2D_L      _PK_L_(0x3E, 0x2D)
#define REG_SC_BK3E_2D_H      _PK_H_(0x3E, 0x2D)
#define REG_SC_BK3E_2E_L      _PK_L_(0x3E, 0x2E)
#define REG_SC_BK3E_2E_H      _PK_H_(0x3E, 0x2E)
#define REG_SC_BK3E_2F_L      _PK_L_(0x3E, 0x2F)
#define REG_SC_BK3E_2F_H      _PK_H_(0x3E, 0x2F)

//----------------------------------------------
//  BK3F:
//----------------------------------------------
#define REG_SC_BK3F_00_L      _PK_L_(0x3F, 0x00)
#define REG_SC_BK3F_00_H      _PK_H_(0x3F, 0x00)
#define REG_SC_BK3F_01_L      _PK_L_(0x3F, 0x01)
#define REG_SC_BK3F_01_H      _PK_H_(0x3F, 0x01)
#define REG_SC_BK3F_02_L      _PK_L_(0x3F, 0x02)
#define REG_SC_BK3F_02_H      _PK_H_(0x3F, 0x02)
#define REG_SC_BK3F_03_L      _PK_L_(0x3F, 0x03)
#define REG_SC_BK3F_03_H      _PK_H_(0x3F, 0x03)
#define REG_SC_BK3F_04_L      _PK_L_(0x3F, 0x04)
#define REG_SC_BK3F_04_H      _PK_H_(0x3F, 0x04)
#define REG_SC_BK3F_05_L      _PK_L_(0x3F, 0x05)
#define REG_SC_BK3F_05_H      _PK_H_(0x3F, 0x05)
#define REG_SC_BK3F_06_L      _PK_L_(0x3F, 0x06)
#define REG_SC_BK3F_06_H      _PK_H_(0x3F, 0x06)
#define REG_SC_BK3F_07_L      _PK_L_(0x3F, 0x07)
#define REG_SC_BK3F_07_H      _PK_H_(0x3F, 0x07)
#define REG_SC_BK3F_08_L      _PK_L_(0x3F, 0x08)
#define REG_SC_BK3F_08_H      _PK_H_(0x3F, 0x08)
#define REG_SC_BK3F_09_L      _PK_L_(0x3F, 0x09)
#define REG_SC_BK3F_09_H      _PK_H_(0x3F, 0x09)
#define REG_SC_BK3F_0A_L      _PK_L_(0x3F, 0x0A)
#define REG_SC_BK3F_0A_H      _PK_H_(0x3F, 0x0A)
#define REG_SC_BK3F_0B_L      _PK_L_(0x3F, 0x0B)
#define REG_SC_BK3F_0B_H      _PK_H_(0x3F, 0x0B)
#define REG_SC_BK3F_0C_L      _PK_L_(0x3F, 0x0C)
#define REG_SC_BK3F_0C_H      _PK_H_(0x3F, 0x0C)
#define REG_SC_BK3F_0D_L      _PK_L_(0x3F, 0x0D)
#define REG_SC_BK3F_0D_H      _PK_H_(0x3F, 0x0D)
#define REG_SC_BK3F_0E_L      _PK_L_(0x3F, 0x0E)
#define REG_SC_BK3F_0E_H      _PK_H_(0x3F, 0x0E)
#define REG_SC_BK3F_0F_L      _PK_L_(0x3F, 0x0F)
#define REG_SC_BK3F_0F_H      _PK_H_(0x3F, 0x0F)
#define REG_SC_BK3F_10_L      _PK_L_(0x3F, 0x10)
#define REG_SC_BK3F_10_H      _PK_H_(0x3F, 0x10)
#define REG_SC_BK3F_11_L      _PK_L_(0x3F, 0x11)
#define REG_SC_BK3F_11_H      _PK_H_(0x3F, 0x11)
#define REG_SC_BK3F_12_L      _PK_L_(0x3F, 0x12)
#define REG_SC_BK3F_12_H      _PK_H_(0x3F, 0x12)
#define REG_SC_BK3F_13_L      _PK_L_(0x3F, 0x13)
#define REG_SC_BK3F_13_H      _PK_H_(0x3F, 0x13)
#define REG_SC_BK3F_14_L      _PK_L_(0x3F, 0x14)
#define REG_SC_BK3F_14_H      _PK_H_(0x3F, 0x14)
#define REG_SC_BK3F_15_L      _PK_L_(0x3F, 0x15)
#define REG_SC_BK3F_15_H      _PK_H_(0x3F, 0x15)
#define REG_SC_BK3F_16_L      _PK_L_(0x3F, 0x16)
#define REG_SC_BK3F_16_H      _PK_H_(0x3F, 0x16)
#define REG_SC_BK3F_17_L      _PK_L_(0x3F, 0x17)
#define REG_SC_BK3F_17_H      _PK_H_(0x3F, 0x17)
#define REG_SC_BK3F_18_L      _PK_L_(0x3F, 0x18)
#define REG_SC_BK3F_18_H      _PK_H_(0x3F, 0x18)
#define REG_SC_BK3F_19_L      _PK_L_(0x3F, 0x19)
#define REG_SC_BK3F_19_H      _PK_H_(0x3F, 0x19)
#define REG_SC_BK3F_1A_L      _PK_L_(0x3F, 0x1A)
#define REG_SC_BK3F_1A_H      _PK_H_(0x3F, 0x1A)
#define REG_SC_BK3F_1B_L      _PK_L_(0x3F, 0x1B)
#define REG_SC_BK3F_1B_H      _PK_H_(0x3F, 0x1B)
#define REG_SC_BK3F_1C_L      _PK_L_(0x3F, 0x1C)
#define REG_SC_BK3F_1C_H      _PK_H_(0x3F, 0x1C)
#define REG_SC_BK3F_1D_L      _PK_L_(0x3F, 0x1D)
#define REG_SC_BK3F_1D_H      _PK_H_(0x3F, 0x1D)
#define REG_SC_BK3F_1E_L      _PK_L_(0x3F, 0x1E)
#define REG_SC_BK3F_1E_H      _PK_H_(0x3F, 0x1E)
#define REG_SC_BK3F_1F_L      _PK_L_(0x3F, 0x1F)
#define REG_SC_BK3F_1F_H      _PK_H_(0x3F, 0x1F)
#define REG_SC_BK3F_20_L      _PK_L_(0x3F, 0x20)
#define REG_SC_BK3F_20_H      _PK_H_(0x3F, 0x20)
#define REG_SC_BK3F_21_L      _PK_L_(0x3F, 0x21)
#define REG_SC_BK3F_21_H      _PK_H_(0x3F, 0x21)
#define REG_SC_BK3F_22_L      _PK_L_(0x3F, 0x22)
#define REG_SC_BK3F_22_H      _PK_H_(0x3F, 0x22)
#define REG_SC_BK3F_23_L      _PK_L_(0x3F, 0x23)
#define REG_SC_BK3F_23_H      _PK_H_(0x3F, 0x23)
#define REG_SC_BK3F_24_L      _PK_L_(0x3F, 0x24)
#define REG_SC_BK3F_24_H      _PK_H_(0x3F, 0x24)
#define REG_SC_BK3F_25_L      _PK_L_(0x3F, 0x25)
#define REG_SC_BK3F_25_H      _PK_H_(0x3F, 0x25)
#define REG_SC_BK3F_26_L      _PK_L_(0x3F, 0x26)
#define REG_SC_BK3F_26_H      _PK_H_(0x3F, 0x26)
#define REG_SC_BK3F_27_L      _PK_L_(0x3F, 0x27)
#define REG_SC_BK3F_27_H      _PK_H_(0x3F, 0x27)
#define REG_SC_BK3F_28_L      _PK_L_(0x3F, 0x28)
#define REG_SC_BK3F_28_H      _PK_H_(0x3F, 0x28)
#define REG_SC_BK3F_29_L      _PK_L_(0x3F, 0x29)
#define REG_SC_BK3F_29_H      _PK_H_(0x3F, 0x29)
#define REG_SC_BK3F_2A_L      _PK_L_(0x3F, 0x2A)
#define REG_SC_BK3F_2A_H      _PK_H_(0x3F, 0x2A)
#define REG_SC_BK3F_2B_L      _PK_L_(0x3F, 0x2B)
#define REG_SC_BK3F_2B_H      _PK_H_(0x3F, 0x2B)
#define REG_SC_BK3F_2C_L      _PK_L_(0x3F, 0x2C)
#define REG_SC_BK3F_2C_H      _PK_H_(0x3F, 0x2C)
#define REG_SC_BK3F_2D_L      _PK_L_(0x3F, 0x2D)
#define REG_SC_BK3F_2D_H      _PK_H_(0x3F, 0x2D)
#define REG_SC_BK3F_2E_L      _PK_L_(0x3F, 0x2E)
#define REG_SC_BK3F_2E_H      _PK_H_(0x3F, 0x2E)
#define REG_SC_BK3F_2F_L      _PK_L_(0x3F, 0x2F)
#define REG_SC_BK3F_2F_H      _PK_H_(0x3F, 0x2F)
#define REG_SC_BK3F_30_L      _PK_L_(0x3F, 0x30)
#define REG_SC_BK3F_30_H      _PK_H_(0x3F, 0x30)
#define REG_SC_BK3F_31_L      _PK_L_(0x3F, 0x31)
#define REG_SC_BK3F_31_H      _PK_H_(0x3F, 0x31)
#define REG_SC_BK3F_32_L      _PK_L_(0x3F, 0x32)
#define REG_SC_BK3F_32_H      _PK_H_(0x3F, 0x32)
#define REG_SC_BK3F_33_L      _PK_L_(0x3F, 0x33)
#define REG_SC_BK3F_33_H      _PK_H_(0x3F, 0x33)
#define REG_SC_BK3F_34_L      _PK_L_(0x3F, 0x34)
#define REG_SC_BK3F_34_H      _PK_H_(0x3F, 0x34)
#define REG_SC_BK3F_35_L      _PK_L_(0x3F, 0x35)
#define REG_SC_BK3F_35_H      _PK_H_(0x3F, 0x35)
#define REG_SC_BK3F_36_L      _PK_L_(0x3F, 0x36)
#define REG_SC_BK3F_36_H      _PK_H_(0x3F, 0x36)
#define REG_SC_BK3F_37_L      _PK_L_(0x3F, 0x37)
#define REG_SC_BK3F_37_H      _PK_H_(0x3F, 0x37)
#define REG_SC_BK3F_38_L      _PK_L_(0x3F, 0x38)
#define REG_SC_BK3F_38_H      _PK_H_(0x3F, 0x38)
#define REG_SC_BK3F_39_L      _PK_L_(0x3F, 0x39)
#define REG_SC_BK3F_39_H      _PK_H_(0x3F, 0x39)
#define REG_SC_BK3F_3A_L      _PK_L_(0x3F, 0x3A)
#define REG_SC_BK3F_3A_H      _PK_H_(0x3F, 0x3A)
#define REG_SC_BK3F_3B_L      _PK_L_(0x3F, 0x3B)
#define REG_SC_BK3F_3B_H      _PK_H_(0x3F, 0x3B)
#define REG_SC_BK3F_3C_L      _PK_L_(0x3F, 0x3C)
#define REG_SC_BK3F_3C_H      _PK_H_(0x3F, 0x3C)
#define REG_SC_BK3F_3D_L      _PK_L_(0x3F, 0x3D)
#define REG_SC_BK3F_3D_H      _PK_H_(0x3F, 0x3D)
#define REG_SC_BK3F_3E_L      _PK_L_(0x3F, 0x3E)
#define REG_SC_BK3F_3E_H      _PK_H_(0x3F, 0x3E)
#define REG_SC_BK3F_3F_L      _PK_L_(0x3F, 0x3F)
#define REG_SC_BK3F_3F_H      _PK_H_(0x3F, 0x3F)
#define REG_SC_BK3F_40_L      _PK_L_(0x3F, 0x40)
#define REG_SC_BK3F_40_H      _PK_H_(0x3F, 0x40)
#define REG_SC_BK3F_41_L      _PK_L_(0x3F, 0x41)
#define REG_SC_BK3F_41_H      _PK_H_(0x3F, 0x41)
#define REG_SC_BK3F_42_L      _PK_L_(0x3F, 0x42)
#define REG_SC_BK3F_42_H      _PK_H_(0x3F, 0x42)
#define REG_SC_BK3F_43_L      _PK_L_(0x3F, 0x43)
#define REG_SC_BK3F_43_H      _PK_H_(0x3F, 0x43)
#define REG_SC_BK3F_44_L      _PK_L_(0x3F, 0x44)
#define REG_SC_BK3F_44_H      _PK_H_(0x3F, 0x44)
#define REG_SC_BK3F_45_L      _PK_L_(0x3F, 0x45)
#define REG_SC_BK3F_45_H      _PK_H_(0x3F, 0x45)
#define REG_SC_BK3F_46_L      _PK_L_(0x3F, 0x46)
#define REG_SC_BK3F_46_H      _PK_H_(0x3F, 0x46)
#define REG_SC_BK3F_47_L      _PK_L_(0x3F, 0x47)
#define REG_SC_BK3F_47_H      _PK_H_(0x3F, 0x47)
#define REG_SC_BK3F_48_L      _PK_L_(0x3F, 0x48)
#define REG_SC_BK3F_48_H      _PK_H_(0x3F, 0x48)
#define REG_SC_BK3F_49_L      _PK_L_(0x3F, 0x49)
#define REG_SC_BK3F_49_H      _PK_H_(0x3F, 0x49)
#define REG_SC_BK3F_4A_L      _PK_L_(0x3F, 0x4A)
#define REG_SC_BK3F_4A_H      _PK_H_(0x3F, 0x4A)
#define REG_SC_BK3F_4B_L      _PK_L_(0x3F, 0x4B)
#define REG_SC_BK3F_4B_H      _PK_H_(0x3F, 0x4B)
#define REG_SC_BK3F_4C_L      _PK_L_(0x3F, 0x4C)
#define REG_SC_BK3F_4C_H      _PK_H_(0x3F, 0x4C)
#define REG_SC_BK3F_4D_L      _PK_L_(0x3F, 0x4D)
#define REG_SC_BK3F_4D_H      _PK_H_(0x3F, 0x4D)
#define REG_SC_BK3F_4E_L      _PK_L_(0x3F, 0x4E)
#define REG_SC_BK3F_4E_H      _PK_H_(0x3F, 0x4E)
#define REG_SC_BK3F_4F_L      _PK_L_(0x3F, 0x4F)
#define REG_SC_BK3F_4F_H      _PK_H_(0x3F, 0x4F)
#define REG_SC_BK3F_50_L      _PK_L_(0x3F, 0x50)
#define REG_SC_BK3F_50_H      _PK_H_(0x3F, 0x50)
#define REG_SC_BK3F_51_L      _PK_L_(0x3F, 0x51)
#define REG_SC_BK3F_51_H      _PK_H_(0x3F, 0x51)
#define REG_SC_BK3F_52_L      _PK_L_(0x3F, 0x52)
#define REG_SC_BK3F_52_H      _PK_H_(0x3F, 0x52)
#define REG_SC_BK3F_53_L      _PK_L_(0x3F, 0x53)
#define REG_SC_BK3F_53_H      _PK_H_(0x3F, 0x53)
#define REG_SC_BK3F_54_L      _PK_L_(0x3F, 0x54)
#define REG_SC_BK3F_54_H      _PK_H_(0x3F, 0x54)
#define REG_SC_BK3F_55_L      _PK_L_(0x3F, 0x55)
#define REG_SC_BK3F_55_H      _PK_H_(0x3F, 0x55)
#define REG_SC_BK3F_56_L      _PK_L_(0x3F, 0x56)
#define REG_SC_BK3F_56_H      _PK_H_(0x3F, 0x56)
#define REG_SC_BK3F_57_L      _PK_L_(0x3F, 0x57)
#define REG_SC_BK3F_57_H      _PK_H_(0x3F, 0x57)
#define REG_SC_BK3F_58_L      _PK_L_(0x3F, 0x58)
#define REG_SC_BK3F_58_H      _PK_H_(0x3F, 0x58)
#define REG_SC_BK3F_59_L      _PK_L_(0x3F, 0x59)
#define REG_SC_BK3F_59_H      _PK_H_(0x3F, 0x59)
#define REG_SC_BK3F_5A_L      _PK_L_(0x3F, 0x5A)
#define REG_SC_BK3F_5A_H      _PK_H_(0x3F, 0x5A)
#define REG_SC_BK3F_5B_L      _PK_L_(0x3F, 0x5B)
#define REG_SC_BK3F_5B_H      _PK_H_(0x3F, 0x5B)
#define REG_SC_BK3F_5C_L      _PK_L_(0x3F, 0x5C)
#define REG_SC_BK3F_5C_H      _PK_H_(0x3F, 0x5C)
#define REG_SC_BK3F_5D_L      _PK_L_(0x3F, 0x5D)
#define REG_SC_BK3F_5D_H      _PK_H_(0x3F, 0x5D)
#define REG_SC_BK3F_5E_L      _PK_L_(0x3F, 0x5E)
#define REG_SC_BK3F_5E_H      _PK_H_(0x3F, 0x5E)
#define REG_SC_BK3F_5F_L      _PK_L_(0x3F, 0x5F)
#define REG_SC_BK3F_5F_H      _PK_H_(0x3F, 0x5F)
#define REG_SC_BK3F_60_L      _PK_L_(0x3F, 0x60)
#define REG_SC_BK3F_60_H      _PK_H_(0x3F, 0x60)
#define REG_SC_BK3F_61_L      _PK_L_(0x3F, 0x61)
#define REG_SC_BK3F_61_H      _PK_H_(0x3F, 0x61)
#define REG_SC_BK3F_62_L      _PK_L_(0x3F, 0x62)
#define REG_SC_BK3F_62_H      _PK_H_(0x3F, 0x62)
#define REG_SC_BK3F_63_L      _PK_L_(0x3F, 0x63)
#define REG_SC_BK3F_63_H      _PK_H_(0x3F, 0x63)
#define REG_SC_BK3F_64_L      _PK_L_(0x3F, 0x64)
#define REG_SC_BK3F_64_H      _PK_H_(0x3F, 0x64)
#define REG_SC_BK3F_65_L      _PK_L_(0x3F, 0x65)
#define REG_SC_BK3F_65_H      _PK_H_(0x3F, 0x65)
#define REG_SC_BK3F_66_L      _PK_L_(0x3F, 0x66)
#define REG_SC_BK3F_66_H      _PK_H_(0x3F, 0x66)
#define REG_SC_BK3F_67_L      _PK_L_(0x3F, 0x67)
#define REG_SC_BK3F_67_H      _PK_H_(0x3F, 0x67)
#define REG_SC_BK3F_68_L      _PK_L_(0x3F, 0x68)
#define REG_SC_BK3F_68_H      _PK_H_(0x3F, 0x68)
#define REG_SC_BK3F_69_L      _PK_L_(0x3F, 0x69)
#define REG_SC_BK3F_69_H      _PK_H_(0x3F, 0x69)
#define REG_SC_BK3F_6A_L      _PK_L_(0x3F, 0x6A)
#define REG_SC_BK3F_6A_H      _PK_H_(0x3F, 0x6A)
#define REG_SC_BK3F_6B_L      _PK_L_(0x3F, 0x6B)
#define REG_SC_BK3F_6B_H      _PK_H_(0x3F, 0x6B)
#define REG_SC_BK3F_6C_L      _PK_L_(0x3F, 0x6C)
#define REG_SC_BK3F_6C_H      _PK_H_(0x3F, 0x6C)
#define REG_SC_BK3F_6D_L      _PK_L_(0x3F, 0x6D)
#define REG_SC_BK3F_6D_H      _PK_H_(0x3F, 0x6D)
#define REG_SC_BK3F_6E_L      _PK_L_(0x3F, 0x6E)
#define REG_SC_BK3F_6E_H      _PK_H_(0x3F, 0x6E)
#define REG_SC_BK3F_6F_L      _PK_L_(0x3F, 0x6F)
#define REG_SC_BK3F_6F_H      _PK_H_(0x3F, 0x6F)
#define REG_SC_BK3F_70_L      _PK_L_(0x3F, 0x70)
#define REG_SC_BK3F_70_H      _PK_H_(0x3F, 0x70)
#define REG_SC_BK3F_71_L      _PK_L_(0x3F, 0x71)
#define REG_SC_BK3F_71_H      _PK_H_(0x3F, 0x71)
#define REG_SC_BK3F_72_L      _PK_L_(0x3F, 0x72)
#define REG_SC_BK3F_72_H      _PK_H_(0x3F, 0x72)
#define REG_SC_BK3F_73_L      _PK_L_(0x3F, 0x73)
#define REG_SC_BK3F_73_H      _PK_H_(0x3F, 0x73)
#define REG_SC_BK3F_74_L      _PK_L_(0x3F, 0x74)
#define REG_SC_BK3F_74_H      _PK_H_(0x3F, 0x74)
#define REG_SC_BK3F_75_L      _PK_L_(0x3F, 0x75)
#define REG_SC_BK3F_75_H      _PK_H_(0x3F, 0x75)
#define REG_SC_BK3F_76_L      _PK_L_(0x3F, 0x76)
#define REG_SC_BK3F_76_H      _PK_H_(0x3F, 0x76)
#define REG_SC_BK3F_77_L      _PK_L_(0x3F, 0x77)
#define REG_SC_BK3F_77_H      _PK_H_(0x3F, 0x77)
#define REG_SC_BK3F_78_L      _PK_L_(0x3F, 0x78)
#define REG_SC_BK3F_78_H      _PK_H_(0x3F, 0x78)
#define REG_SC_BK3F_79_L      _PK_L_(0x3F, 0x79)
#define REG_SC_BK3F_79_H      _PK_H_(0x3F, 0x79)
#define REG_SC_BK3F_7A_L      _PK_L_(0x3F, 0x7A)
#define REG_SC_BK3F_7A_H      _PK_H_(0x3F, 0x7A)
#define REG_SC_BK3F_7B_L      _PK_L_(0x3F, 0x7B)
#define REG_SC_BK3F_7B_H      _PK_H_(0x3F, 0x7B)
#define REG_SC_BK3F_7C_L      _PK_L_(0x3F, 0x7C)
#define REG_SC_BK3F_7C_H      _PK_H_(0x3F, 0x7C)
#define REG_SC_BK3F_7D_L      _PK_L_(0x3F, 0x7D)
#define REG_SC_BK3F_7D_H      _PK_H_(0x3F, 0x7D)
#define REG_SC_BK3F_7E_L      _PK_L_(0x3F, 0x7E)
#define REG_SC_BK3F_7E_H      _PK_H_(0x3F, 0x7E)
#define REG_SC_BK3F_7F_L      _PK_L_(0x3F, 0x7F)
#define REG_SC_BK3F_7F_H      _PK_H_(0x3F, 0x7F)

//----------------------------------------------
//  BK40: FRC TOP
//----------------------------------------------
#define REG_SC_BK40_00_L      _PK_L_(0x40, 0x00)
#define REG_SC_BK40_00_H      _PK_H_(0x40, 0x00)
#define REG_SC_BK40_01_L      _PK_L_(0x40, 0x01)
#define REG_SC_BK40_01_H      _PK_H_(0x40, 0x01)
#define REG_SC_BK40_02_L      _PK_L_(0x40, 0x02)
#define REG_SC_BK40_02_H      _PK_H_(0x40, 0x02)
#define REG_SC_BK40_03_L      _PK_L_(0x40, 0x03)
#define REG_SC_BK40_03_H      _PK_H_(0x40, 0x03)
#define REG_SC_BK40_04_L      _PK_L_(0x40, 0x04)
#define REG_SC_BK40_04_H      _PK_H_(0x40, 0x04)
#define REG_SC_BK40_05_L      _PK_L_(0x40, 0x05)
#define REG_SC_BK40_05_H      _PK_H_(0x40, 0x05)
#define REG_SC_BK40_06_L      _PK_L_(0x40, 0x06)
#define REG_SC_BK40_06_H      _PK_H_(0x40, 0x06)
#define REG_SC_BK40_07_L      _PK_L_(0x40, 0x07)
#define REG_SC_BK40_07_H      _PK_H_(0x40, 0x07)
#define REG_SC_BK40_08_L      _PK_L_(0x40, 0x08)
#define REG_SC_BK40_08_H      _PK_H_(0x40, 0x08)
#define REG_SC_BK40_09_L      _PK_L_(0x40, 0x09)
#define REG_SC_BK40_09_H      _PK_H_(0x40, 0x09)
#define REG_SC_BK40_0A_L      _PK_L_(0x40, 0x0A)
#define REG_SC_BK40_0A_H      _PK_H_(0x40, 0x0A)
#define REG_SC_BK40_0B_L      _PK_L_(0x40, 0x0B)
#define REG_SC_BK40_0B_H      _PK_H_(0x40, 0x0B)
#define REG_SC_BK40_0C_L      _PK_L_(0x40, 0x0C)
#define REG_SC_BK40_0C_H      _PK_H_(0x40, 0x0C)
#define REG_SC_BK40_0D_L      _PK_L_(0x40, 0x0D)
#define REG_SC_BK40_0D_H      _PK_H_(0x40, 0x0D)
#define REG_SC_BK40_0E_L      _PK_L_(0x40, 0x0E)
#define REG_SC_BK40_0E_H      _PK_H_(0x40, 0x0E)
#define REG_SC_BK40_0F_L      _PK_L_(0x40, 0x0F)
#define REG_SC_BK40_0F_H      _PK_H_(0x40, 0x0F)
#define REG_SC_BK40_10_L      _PK_L_(0x40, 0x10)
#define REG_SC_BK40_10_H      _PK_H_(0x40, 0x10)
#define REG_SC_BK40_11_L      _PK_L_(0x40, 0x11)
#define REG_SC_BK40_11_H      _PK_H_(0x40, 0x11)
#define REG_SC_BK40_12_L      _PK_L_(0x40, 0x12)
#define REG_SC_BK40_12_H      _PK_H_(0x40, 0x12)
#define REG_SC_BK40_13_L      _PK_L_(0x40, 0x13)
#define REG_SC_BK40_13_H      _PK_H_(0x40, 0x13)
#define REG_SC_BK40_14_L      _PK_L_(0x40, 0x14)
#define REG_SC_BK40_14_H      _PK_H_(0x40, 0x14)
#define REG_SC_BK40_15_L      _PK_L_(0x40, 0x15)
#define REG_SC_BK40_15_H      _PK_H_(0x40, 0x15)
#define REG_SC_BK40_16_L      _PK_L_(0x40, 0x16)
#define REG_SC_BK40_16_H      _PK_H_(0x40, 0x16)
#define REG_SC_BK40_17_L      _PK_L_(0x40, 0x17)
#define REG_SC_BK40_17_H      _PK_H_(0x40, 0x17)
#define REG_SC_BK40_18_L      _PK_L_(0x40, 0x18)
#define REG_SC_BK40_18_H      _PK_H_(0x40, 0x18)
#define REG_SC_BK40_19_L      _PK_L_(0x40, 0x19)
#define REG_SC_BK40_19_H      _PK_H_(0x40, 0x19)
#define REG_SC_BK40_1A_L      _PK_L_(0x40, 0x1A)
#define REG_SC_BK40_1A_H      _PK_H_(0x40, 0x1A)
#define REG_SC_BK40_1B_L      _PK_L_(0x40, 0x1B)
#define REG_SC_BK40_1B_H      _PK_H_(0x40, 0x1B)
#define REG_SC_BK40_1C_L      _PK_L_(0x40, 0x1C)
#define REG_SC_BK40_1C_H      _PK_H_(0x40, 0x1C)
#define REG_SC_BK40_1D_L      _PK_L_(0x40, 0x1D)
#define REG_SC_BK40_1D_H      _PK_H_(0x40, 0x1D)
#define REG_SC_BK40_1E_L      _PK_L_(0x40, 0x1E)
#define REG_SC_BK40_1E_H      _PK_H_(0x40, 0x1E)
#define REG_SC_BK40_1F_L      _PK_L_(0x40, 0x1F)
#define REG_SC_BK40_1F_H      _PK_H_(0x40, 0x1F)
#define REG_SC_BK40_20_L      _PK_L_(0x40, 0x20)
#define REG_SC_BK40_20_H      _PK_H_(0x40, 0x20)
#define REG_SC_BK40_21_L      _PK_L_(0x40, 0x21)
#define REG_SC_BK40_21_H      _PK_H_(0x40, 0x21)
#define REG_SC_BK40_22_L      _PK_L_(0x40, 0x22)
#define REG_SC_BK40_22_H      _PK_H_(0x40, 0x22)
#define REG_SC_BK40_23_L      _PK_L_(0x40, 0x23)
#define REG_SC_BK40_23_H      _PK_H_(0x40, 0x23)
#define REG_SC_BK40_24_L      _PK_L_(0x40, 0x24)
#define REG_SC_BK40_24_H      _PK_H_(0x40, 0x24)
#define REG_SC_BK40_25_L      _PK_L_(0x40, 0x25)
#define REG_SC_BK40_25_H      _PK_H_(0x40, 0x25)
#define REG_SC_BK40_26_L      _PK_L_(0x40, 0x26)
#define REG_SC_BK40_26_H      _PK_H_(0x40, 0x26)
#define REG_SC_BK40_27_L      _PK_L_(0x40, 0x27)
#define REG_SC_BK40_27_H      _PK_H_(0x40, 0x27)
#define REG_SC_BK40_28_L      _PK_L_(0x40, 0x28)
#define REG_SC_BK40_28_H      _PK_H_(0x40, 0x28)
#define REG_SC_BK40_29_L      _PK_L_(0x40, 0x29)
#define REG_SC_BK40_29_H      _PK_H_(0x40, 0x29)
#define REG_SC_BK40_2A_L      _PK_L_(0x40, 0x2A)
#define REG_SC_BK40_2A_H      _PK_H_(0x40, 0x2A)
#define REG_SC_BK40_2B_L      _PK_L_(0x40, 0x2B)
#define REG_SC_BK40_2B_H      _PK_H_(0x40, 0x2B)
#define REG_SC_BK40_2C_L      _PK_L_(0x40, 0x2C)
#define REG_SC_BK40_2C_H      _PK_H_(0x40, 0x2C)
#define REG_SC_BK40_2D_L      _PK_L_(0x40, 0x2D)
#define REG_SC_BK40_2D_H      _PK_H_(0x40, 0x2D)
#define REG_SC_BK40_2E_L      _PK_L_(0x40, 0x2E)
#define REG_SC_BK40_2E_H      _PK_H_(0x40, 0x2E)
#define REG_SC_BK40_2F_L      _PK_L_(0x40, 0x2F)
#define REG_SC_BK40_2F_H      _PK_H_(0x40, 0x2F)
#define REG_SC_BK40_30_L      _PK_L_(0x40, 0x30)
#define REG_SC_BK40_30_H      _PK_H_(0x40, 0x30)
#define REG_SC_BK40_31_L      _PK_L_(0x40, 0x31)
#define REG_SC_BK40_31_H      _PK_H_(0x40, 0x31)
#define REG_SC_BK40_32_L      _PK_L_(0x40, 0x32)
#define REG_SC_BK40_32_H      _PK_H_(0x40, 0x32)
#define REG_SC_BK40_33_L      _PK_L_(0x40, 0x33)
#define REG_SC_BK40_33_H      _PK_H_(0x40, 0x33)
#define REG_SC_BK40_34_L      _PK_L_(0x40, 0x34)
#define REG_SC_BK40_34_H      _PK_H_(0x40, 0x34)
#define REG_SC_BK40_35_L      _PK_L_(0x40, 0x35)
#define REG_SC_BK40_35_H      _PK_H_(0x40, 0x35)
#define REG_SC_BK40_36_L      _PK_L_(0x40, 0x36)
#define REG_SC_BK40_36_H      _PK_H_(0x40, 0x36)
#define REG_SC_BK40_37_L      _PK_L_(0x40, 0x37)
#define REG_SC_BK40_37_H      _PK_H_(0x40, 0x37)
#define REG_SC_BK40_38_L      _PK_L_(0x40, 0x38)
#define REG_SC_BK40_38_H      _PK_H_(0x40, 0x38)
#define REG_SC_BK40_39_L      _PK_L_(0x40, 0x39)
#define REG_SC_BK40_39_H      _PK_H_(0x40, 0x39)
#define REG_SC_BK40_3A_L      _PK_L_(0x40, 0x3A)
#define REG_SC_BK40_3A_H      _PK_H_(0x40, 0x3A)
#define REG_SC_BK40_3B_L      _PK_L_(0x40, 0x3B)
#define REG_SC_BK40_3B_H      _PK_H_(0x40, 0x3B)
#define REG_SC_BK40_3C_L      _PK_L_(0x40, 0x3C)
#define REG_SC_BK40_3C_H      _PK_H_(0x40, 0x3C)
#define REG_SC_BK40_3D_L      _PK_L_(0x40, 0x3D)
#define REG_SC_BK40_3D_H      _PK_H_(0x40, 0x3D)
#define REG_SC_BK40_3E_L      _PK_L_(0x40, 0x3E)
#define REG_SC_BK40_3E_H      _PK_H_(0x40, 0x3E)
#define REG_SC_BK40_3F_L      _PK_L_(0x40, 0x3F)
#define REG_SC_BK40_3F_H      _PK_H_(0x40, 0x3F)
#define REG_SC_BK40_40_L      _PK_L_(0x40, 0x40)
#define REG_SC_BK40_40_H      _PK_H_(0x40, 0x40)
#define REG_SC_BK40_41_L      _PK_L_(0x40, 0x41)
#define REG_SC_BK40_41_H      _PK_H_(0x40, 0x41)
#define REG_SC_BK40_42_L      _PK_L_(0x40, 0x42)
#define REG_SC_BK40_42_H      _PK_H_(0x40, 0x42)
#define REG_SC_BK40_43_L      _PK_L_(0x40, 0x43)
#define REG_SC_BK40_43_H      _PK_H_(0x40, 0x43)
#define REG_SC_BK40_44_L      _PK_L_(0x40, 0x44)
#define REG_SC_BK40_44_H      _PK_H_(0x40, 0x44)
#define REG_SC_BK40_45_L      _PK_L_(0x40, 0x45)
#define REG_SC_BK40_45_H      _PK_H_(0x40, 0x45)
#define REG_SC_BK40_46_L      _PK_L_(0x40, 0x46)
#define REG_SC_BK40_46_H      _PK_H_(0x40, 0x46)
#define REG_SC_BK40_47_L      _PK_L_(0x40, 0x47)
#define REG_SC_BK40_47_H      _PK_H_(0x40, 0x47)
#define REG_SC_BK40_48_L      _PK_L_(0x40, 0x48)
#define REG_SC_BK40_48_H      _PK_H_(0x40, 0x48)
#define REG_SC_BK40_49_L      _PK_L_(0x40, 0x49)
#define REG_SC_BK40_49_H      _PK_H_(0x40, 0x49)
#define REG_SC_BK40_4A_L      _PK_L_(0x40, 0x4A)
#define REG_SC_BK40_4A_H      _PK_H_(0x40, 0x4A)
#define REG_SC_BK40_4B_L      _PK_L_(0x40, 0x4B)
#define REG_SC_BK40_4B_H      _PK_H_(0x40, 0x4B)
#define REG_SC_BK40_4C_L      _PK_L_(0x40, 0x4C)
#define REG_SC_BK40_4C_H      _PK_H_(0x40, 0x4C)
#define REG_SC_BK40_4D_L      _PK_L_(0x40, 0x4D)
#define REG_SC_BK40_4D_H      _PK_H_(0x40, 0x4D)
#define REG_SC_BK40_4E_L      _PK_L_(0x40, 0x4E)
#define REG_SC_BK40_4E_H      _PK_H_(0x40, 0x4E)
#define REG_SC_BK40_4F_L      _PK_L_(0x40, 0x4F)
#define REG_SC_BK40_4F_H      _PK_H_(0x40, 0x4F)
#define REG_SC_BK40_50_L      _PK_L_(0x40, 0x50)
#define REG_SC_BK40_50_H      _PK_H_(0x40, 0x50)
#define REG_SC_BK40_51_L      _PK_L_(0x40, 0x51)
#define REG_SC_BK40_51_H      _PK_H_(0x40, 0x51)
#define REG_SC_BK40_52_L      _PK_L_(0x40, 0x52)
#define REG_SC_BK40_52_H      _PK_H_(0x40, 0x52)
#define REG_SC_BK40_53_L      _PK_L_(0x40, 0x53)
#define REG_SC_BK40_53_H      _PK_H_(0x40, 0x53)
#define REG_SC_BK40_54_L      _PK_L_(0x40, 0x54)
#define REG_SC_BK40_54_H      _PK_H_(0x40, 0x54)
#define REG_SC_BK40_55_L      _PK_L_(0x40, 0x55)
#define REG_SC_BK40_55_H      _PK_H_(0x40, 0x55)
#define REG_SC_BK40_56_L      _PK_L_(0x40, 0x56)
#define REG_SC_BK40_56_H      _PK_H_(0x40, 0x56)
#define REG_SC_BK40_57_L      _PK_L_(0x40, 0x57)
#define REG_SC_BK40_57_H      _PK_H_(0x40, 0x57)
#define REG_SC_BK40_58_L      _PK_L_(0x40, 0x58)
#define REG_SC_BK40_58_H      _PK_H_(0x40, 0x58)
#define REG_SC_BK40_59_L      _PK_L_(0x40, 0x59)
#define REG_SC_BK40_59_H      _PK_H_(0x40, 0x59)
#define REG_SC_BK40_5A_L      _PK_L_(0x40, 0x5A)
#define REG_SC_BK40_5A_H      _PK_H_(0x40, 0x5A)
#define REG_SC_BK40_5B_L      _PK_L_(0x40, 0x5B)
#define REG_SC_BK40_5B_H      _PK_H_(0x40, 0x5B)
#define REG_SC_BK40_5C_L      _PK_L_(0x40, 0x5C)
#define REG_SC_BK40_5C_H      _PK_H_(0x40, 0x5C)
#define REG_SC_BK40_5D_L      _PK_L_(0x40, 0x5D)
#define REG_SC_BK40_5D_H      _PK_H_(0x40, 0x5D)
#define REG_SC_BK40_5E_L      _PK_L_(0x40, 0x5E)
#define REG_SC_BK40_5E_H      _PK_H_(0x40, 0x5E)
#define REG_SC_BK40_5F_L      _PK_L_(0x40, 0x5F)
#define REG_SC_BK40_5F_H      _PK_H_(0x40, 0x5F)
#define REG_SC_BK40_60_L      _PK_L_(0x40, 0x60)
#define REG_SC_BK40_60_H      _PK_H_(0x40, 0x60)
#define REG_SC_BK40_61_L      _PK_L_(0x40, 0x61)
#define REG_SC_BK40_61_H      _PK_H_(0x40, 0x61)
#define REG_SC_BK40_62_L      _PK_L_(0x40, 0x62)
#define REG_SC_BK40_62_H      _PK_H_(0x40, 0x62)
#define REG_SC_BK40_63_L      _PK_L_(0x40, 0x63)
#define REG_SC_BK40_63_H      _PK_H_(0x40, 0x63)
#define REG_SC_BK40_64_L      _PK_L_(0x40, 0x64)
#define REG_SC_BK40_64_H      _PK_H_(0x40, 0x64)
#define REG_SC_BK40_65_L      _PK_L_(0x40, 0x65)
#define REG_SC_BK40_65_H      _PK_H_(0x40, 0x65)
#define REG_SC_BK40_66_L      _PK_L_(0x40, 0x66)
#define REG_SC_BK40_66_H      _PK_H_(0x40, 0x66)
#define REG_SC_BK40_67_L      _PK_L_(0x40, 0x67)
#define REG_SC_BK40_67_H      _PK_H_(0x40, 0x67)
#define REG_SC_BK40_68_L      _PK_L_(0x40, 0x68)
#define REG_SC_BK40_68_H      _PK_H_(0x40, 0x68)
#define REG_SC_BK40_69_L      _PK_L_(0x40, 0x69)
#define REG_SC_BK40_69_H      _PK_H_(0x40, 0x69)
#define REG_SC_BK40_6A_L      _PK_L_(0x40, 0x6A)
#define REG_SC_BK40_6A_H      _PK_H_(0x40, 0x6A)
#define REG_SC_BK40_6B_L      _PK_L_(0x40, 0x6B)
#define REG_SC_BK40_6B_H      _PK_H_(0x40, 0x6B)
#define REG_SC_BK40_6C_L      _PK_L_(0x40, 0x6C)
#define REG_SC_BK40_6C_H      _PK_H_(0x40, 0x6C)
#define REG_SC_BK40_6D_L      _PK_L_(0x40, 0x6D)
#define REG_SC_BK40_6D_H      _PK_H_(0x40, 0x6D)
#define REG_SC_BK40_6E_L      _PK_L_(0x40, 0x6E)
#define REG_SC_BK40_6E_H      _PK_H_(0x40, 0x6E)
#define REG_SC_BK40_6F_L      _PK_L_(0x40, 0x6F)
#define REG_SC_BK40_6F_H      _PK_H_(0x40, 0x6F)
#define REG_SC_BK40_70_L      _PK_L_(0x40, 0x70)
#define REG_SC_BK40_70_H      _PK_H_(0x40, 0x70)
#define REG_SC_BK40_71_L      _PK_L_(0x40, 0x71)
#define REG_SC_BK40_71_H      _PK_H_(0x40, 0x71)
#define REG_SC_BK40_72_L      _PK_L_(0x40, 0x72)
#define REG_SC_BK40_72_H      _PK_H_(0x40, 0x72)
#define REG_SC_BK40_73_L      _PK_L_(0x40, 0x73)
#define REG_SC_BK40_73_H      _PK_H_(0x40, 0x73)
#define REG_SC_BK40_74_L      _PK_L_(0x40, 0x74)
#define REG_SC_BK40_74_H      _PK_H_(0x40, 0x74)
#define REG_SC_BK40_75_L      _PK_L_(0x40, 0x75)
#define REG_SC_BK40_75_H      _PK_H_(0x40, 0x75)
#define REG_SC_BK40_76_L      _PK_L_(0x40, 0x76)
#define REG_SC_BK40_76_H      _PK_H_(0x40, 0x76)
#define REG_SC_BK40_77_L      _PK_L_(0x40, 0x77)
#define REG_SC_BK40_77_H      _PK_H_(0x40, 0x77)
#define REG_SC_BK40_78_L      _PK_L_(0x40, 0x78)
#define REG_SC_BK40_78_H      _PK_H_(0x40, 0x78)
#define REG_SC_BK40_79_L      _PK_L_(0x40, 0x79)
#define REG_SC_BK40_79_H      _PK_H_(0x40, 0x79)
#define REG_SC_BK40_7A_L      _PK_L_(0x40, 0x7A)
#define REG_SC_BK40_7A_H      _PK_H_(0x40, 0x7A)
#define REG_SC_BK40_7B_L      _PK_L_(0x40, 0x7B)
#define REG_SC_BK40_7B_H      _PK_H_(0x40, 0x7B)
#define REG_SC_BK40_7C_L      _PK_L_(0x40, 0x7C)
#define REG_SC_BK40_7C_H      _PK_H_(0x40, 0x7C)
#define REG_SC_BK40_7D_L      _PK_L_(0x40, 0x7D)
#define REG_SC_BK40_7D_H      _PK_H_(0x40, 0x7D)
#define REG_SC_BK40_7E_L      _PK_L_(0x40, 0x7E)
#define REG_SC_BK40_7E_H      _PK_H_(0x40, 0x7E)
#define REG_SC_BK40_7F_L      _PK_L_(0x40, 0x7F)
#define REG_SC_BK40_7F_H      _PK_H_(0x40, 0x7F)

//----------------------------------------------
//  BK41: FRC IP 1ST
//----------------------------------------------
#define REG_SC_BK41_00_L      _PK_L_(0x41, 0x00)
#define REG_SC_BK41_00_H      _PK_H_(0x41, 0x00)
#define REG_SC_BK41_01_L      _PK_L_(0x41, 0x01)
#define REG_SC_BK41_01_H      _PK_H_(0x41, 0x01)
#define REG_SC_BK41_02_L      _PK_L_(0x41, 0x02)
#define REG_SC_BK41_02_H      _PK_H_(0x41, 0x02)
#define REG_SC_BK41_03_L      _PK_L_(0x41, 0x03)
#define REG_SC_BK41_03_H      _PK_H_(0x41, 0x03)
#define REG_SC_BK41_04_L      _PK_L_(0x41, 0x04)
#define REG_SC_BK41_04_H      _PK_H_(0x41, 0x04)
#define REG_SC_BK41_05_L      _PK_L_(0x41, 0x05)
#define REG_SC_BK41_05_H      _PK_H_(0x41, 0x05)
#define REG_SC_BK41_06_L      _PK_L_(0x41, 0x06)
#define REG_SC_BK41_06_H      _PK_H_(0x41, 0x06)
#define REG_SC_BK41_07_L      _PK_L_(0x41, 0x07)
#define REG_SC_BK41_07_H      _PK_H_(0x41, 0x07)
#define REG_SC_BK41_08_L      _PK_L_(0x41, 0x08)
#define REG_SC_BK41_08_H      _PK_H_(0x41, 0x08)
#define REG_SC_BK41_09_L      _PK_L_(0x41, 0x09)
#define REG_SC_BK41_09_H      _PK_H_(0x41, 0x09)
#define REG_SC_BK41_0A_L      _PK_L_(0x41, 0x0A)
#define REG_SC_BK41_0A_H      _PK_H_(0x41, 0x0A)
#define REG_SC_BK41_0B_L      _PK_L_(0x41, 0x0B)
#define REG_SC_BK41_0B_H      _PK_H_(0x41, 0x0B)
#define REG_SC_BK41_0C_L      _PK_L_(0x41, 0x0C)
#define REG_SC_BK41_0C_H      _PK_H_(0x41, 0x0C)
#define REG_SC_BK41_0D_L      _PK_L_(0x41, 0x0D)
#define REG_SC_BK41_0D_H      _PK_H_(0x41, 0x0D)
#define REG_SC_BK41_0E_L      _PK_L_(0x41, 0x0E)
#define REG_SC_BK41_0E_H      _PK_H_(0x41, 0x0E)
#define REG_SC_BK41_0F_L      _PK_L_(0x41, 0x0F)
#define REG_SC_BK41_0F_H      _PK_H_(0x41, 0x0F)
#define REG_SC_BK41_10_L      _PK_L_(0x41, 0x10)
#define REG_SC_BK41_10_H      _PK_H_(0x41, 0x10)
#define REG_SC_BK41_11_L      _PK_L_(0x41, 0x11)
#define REG_SC_BK41_11_H      _PK_H_(0x41, 0x11)
#define REG_SC_BK41_12_L      _PK_L_(0x41, 0x12)
#define REG_SC_BK41_12_H      _PK_H_(0x41, 0x12)
#define REG_SC_BK41_13_L      _PK_L_(0x41, 0x13)
#define REG_SC_BK41_13_H      _PK_H_(0x41, 0x13)
#define REG_SC_BK41_14_L      _PK_L_(0x41, 0x14)
#define REG_SC_BK41_14_H      _PK_H_(0x41, 0x14)
#define REG_SC_BK41_15_L      _PK_L_(0x41, 0x15)
#define REG_SC_BK41_15_H      _PK_H_(0x41, 0x15)
#define REG_SC_BK41_16_L      _PK_L_(0x41, 0x16)
#define REG_SC_BK41_16_H      _PK_H_(0x41, 0x16)
#define REG_SC_BK41_17_L      _PK_L_(0x41, 0x17)
#define REG_SC_BK41_17_H      _PK_H_(0x41, 0x17)
#define REG_SC_BK41_18_L      _PK_L_(0x41, 0x18)
#define REG_SC_BK41_18_H      _PK_H_(0x41, 0x18)
#define REG_SC_BK41_19_L      _PK_L_(0x41, 0x19)
#define REG_SC_BK41_19_H      _PK_H_(0x41, 0x19)
#define REG_SC_BK41_1A_L      _PK_L_(0x41, 0x1A)
#define REG_SC_BK41_1A_H      _PK_H_(0x41, 0x1A)
#define REG_SC_BK41_1B_L      _PK_L_(0x41, 0x1B)
#define REG_SC_BK41_1B_H      _PK_H_(0x41, 0x1B)
#define REG_SC_BK41_1C_L      _PK_L_(0x41, 0x1C)
#define REG_SC_BK41_1C_H      _PK_H_(0x41, 0x1C)
#define REG_SC_BK41_1D_L      _PK_L_(0x41, 0x1D)
#define REG_SC_BK41_1D_H      _PK_H_(0x41, 0x1D)
#define REG_SC_BK41_1E_L      _PK_L_(0x41, 0x1E)
#define REG_SC_BK41_1E_H      _PK_H_(0x41, 0x1E)
#define REG_SC_BK41_1F_L      _PK_L_(0x41, 0x1F)
#define REG_SC_BK41_1F_H      _PK_H_(0x41, 0x1F)
#define REG_SC_BK41_20_L      _PK_L_(0x41, 0x20)
#define REG_SC_BK41_20_H      _PK_H_(0x41, 0x20)
#define REG_SC_BK41_21_L      _PK_L_(0x41, 0x21)
#define REG_SC_BK41_21_H      _PK_H_(0x41, 0x21)
#define REG_SC_BK41_22_L      _PK_L_(0x41, 0x22)
#define REG_SC_BK41_22_H      _PK_H_(0x41, 0x22)
#define REG_SC_BK41_23_L      _PK_L_(0x41, 0x23)
#define REG_SC_BK41_23_H      _PK_H_(0x41, 0x23)
#define REG_SC_BK41_24_L      _PK_L_(0x41, 0x24)
#define REG_SC_BK41_24_H      _PK_H_(0x41, 0x24)
#define REG_SC_BK41_25_L      _PK_L_(0x41, 0x25)
#define REG_SC_BK41_25_H      _PK_H_(0x41, 0x25)
#define REG_SC_BK41_26_L      _PK_L_(0x41, 0x26)
#define REG_SC_BK41_26_H      _PK_H_(0x41, 0x26)
#define REG_SC_BK41_27_L      _PK_L_(0x41, 0x27)
#define REG_SC_BK41_27_H      _PK_H_(0x41, 0x27)
#define REG_SC_BK41_28_L      _PK_L_(0x41, 0x28)
#define REG_SC_BK41_28_H      _PK_H_(0x41, 0x28)
#define REG_SC_BK41_29_L      _PK_L_(0x41, 0x29)
#define REG_SC_BK41_29_H      _PK_H_(0x41, 0x29)
#define REG_SC_BK41_2A_L      _PK_L_(0x41, 0x2A)
#define REG_SC_BK41_2A_H      _PK_H_(0x41, 0x2A)
#define REG_SC_BK41_2B_L      _PK_L_(0x41, 0x2B)
#define REG_SC_BK41_2B_H      _PK_H_(0x41, 0x2B)
#define REG_SC_BK41_2C_L      _PK_L_(0x41, 0x2C)
#define REG_SC_BK41_2C_H      _PK_H_(0x41, 0x2C)
#define REG_SC_BK41_2D_L      _PK_L_(0x41, 0x2D)
#define REG_SC_BK41_2D_H      _PK_H_(0x41, 0x2D)
#define REG_SC_BK41_2E_L      _PK_L_(0x41, 0x2E)
#define REG_SC_BK41_2E_H      _PK_H_(0x41, 0x2E)
#define REG_SC_BK41_2F_L      _PK_L_(0x41, 0x2F)
#define REG_SC_BK41_2F_H      _PK_H_(0x41, 0x2F)
#define REG_SC_BK41_30_L      _PK_L_(0x41, 0x30)
#define REG_SC_BK41_30_H      _PK_H_(0x41, 0x30)
#define REG_SC_BK41_31_L      _PK_L_(0x41, 0x31)
#define REG_SC_BK41_31_H      _PK_H_(0x41, 0x31)
#define REG_SC_BK41_32_L      _PK_L_(0x41, 0x32)
#define REG_SC_BK41_32_H      _PK_H_(0x41, 0x32)
#define REG_SC_BK41_33_L      _PK_L_(0x41, 0x33)
#define REG_SC_BK41_33_H      _PK_H_(0x41, 0x33)
#define REG_SC_BK41_34_L      _PK_L_(0x41, 0x34)
#define REG_SC_BK41_34_H      _PK_H_(0x41, 0x34)
#define REG_SC_BK41_35_L      _PK_L_(0x41, 0x35)
#define REG_SC_BK41_35_H      _PK_H_(0x41, 0x35)
#define REG_SC_BK41_36_L      _PK_L_(0x41, 0x36)
#define REG_SC_BK41_36_H      _PK_H_(0x41, 0x36)
#define REG_SC_BK41_37_L      _PK_L_(0x41, 0x37)
#define REG_SC_BK41_37_H      _PK_H_(0x41, 0x37)
#define REG_SC_BK41_38_L      _PK_L_(0x41, 0x38)
#define REG_SC_BK41_38_H      _PK_H_(0x41, 0x38)
#define REG_SC_BK41_39_L      _PK_L_(0x41, 0x39)
#define REG_SC_BK41_39_H      _PK_H_(0x41, 0x39)
#define REG_SC_BK41_3A_L      _PK_L_(0x41, 0x3A)
#define REG_SC_BK41_3A_H      _PK_H_(0x41, 0x3A)
#define REG_SC_BK41_3B_L      _PK_L_(0x41, 0x3B)
#define REG_SC_BK41_3B_H      _PK_H_(0x41, 0x3B)
#define REG_SC_BK41_3C_L      _PK_L_(0x41, 0x3C)
#define REG_SC_BK41_3C_H      _PK_H_(0x41, 0x3C)
#define REG_SC_BK41_3D_L      _PK_L_(0x41, 0x3D)
#define REG_SC_BK41_3D_H      _PK_H_(0x41, 0x3D)
#define REG_SC_BK41_3E_L      _PK_L_(0x41, 0x3E)
#define REG_SC_BK41_3E_H      _PK_H_(0x41, 0x3E)
#define REG_SC_BK41_3F_L      _PK_L_(0x41, 0x3F)
#define REG_SC_BK41_3F_H      _PK_H_(0x41, 0x3F)
#define REG_SC_BK41_40_L      _PK_L_(0x41, 0x40)
#define REG_SC_BK41_40_H      _PK_H_(0x41, 0x40)
#define REG_SC_BK41_41_L      _PK_L_(0x41, 0x41)
#define REG_SC_BK41_41_H      _PK_H_(0x41, 0x41)
#define REG_SC_BK41_42_L      _PK_L_(0x41, 0x42)
#define REG_SC_BK41_42_H      _PK_H_(0x41, 0x42)
#define REG_SC_BK41_43_L      _PK_L_(0x41, 0x43)
#define REG_SC_BK41_43_H      _PK_H_(0x41, 0x43)
#define REG_SC_BK41_44_L      _PK_L_(0x41, 0x44)
#define REG_SC_BK41_44_H      _PK_H_(0x41, 0x44)
#define REG_SC_BK41_45_L      _PK_L_(0x41, 0x45)
#define REG_SC_BK41_45_H      _PK_H_(0x41, 0x45)
#define REG_SC_BK41_46_L      _PK_L_(0x41, 0x46)
#define REG_SC_BK41_46_H      _PK_H_(0x41, 0x46)
#define REG_SC_BK41_47_L      _PK_L_(0x41, 0x47)
#define REG_SC_BK41_47_H      _PK_H_(0x41, 0x47)
#define REG_SC_BK41_48_L      _PK_L_(0x41, 0x48)
#define REG_SC_BK41_48_H      _PK_H_(0x41, 0x48)
#define REG_SC_BK41_49_L      _PK_L_(0x41, 0x49)
#define REG_SC_BK41_49_H      _PK_H_(0x41, 0x49)
#define REG_SC_BK41_4A_L      _PK_L_(0x41, 0x4A)
#define REG_SC_BK41_4A_H      _PK_H_(0x41, 0x4A)
#define REG_SC_BK41_4B_L      _PK_L_(0x41, 0x4B)
#define REG_SC_BK41_4B_H      _PK_H_(0x41, 0x4B)
#define REG_SC_BK41_4C_L      _PK_L_(0x41, 0x4C)
#define REG_SC_BK41_4C_H      _PK_H_(0x41, 0x4C)
#define REG_SC_BK41_4D_L      _PK_L_(0x41, 0x4D)
#define REG_SC_BK41_4D_H      _PK_H_(0x41, 0x4D)
#define REG_SC_BK41_4E_L      _PK_L_(0x41, 0x4E)
#define REG_SC_BK41_4E_H      _PK_H_(0x41, 0x4E)
#define REG_SC_BK41_4F_L      _PK_L_(0x41, 0x4F)
#define REG_SC_BK41_4F_H      _PK_H_(0x41, 0x4F)
#define REG_SC_BK41_50_L      _PK_L_(0x41, 0x50)
#define REG_SC_BK41_50_H      _PK_H_(0x41, 0x50)
#define REG_SC_BK41_51_L      _PK_L_(0x41, 0x51)
#define REG_SC_BK41_51_H      _PK_H_(0x41, 0x51)
#define REG_SC_BK41_52_L      _PK_L_(0x41, 0x52)
#define REG_SC_BK41_52_H      _PK_H_(0x41, 0x52)
#define REG_SC_BK41_53_L      _PK_L_(0x41, 0x53)
#define REG_SC_BK41_53_H      _PK_H_(0x41, 0x53)
#define REG_SC_BK41_54_L      _PK_L_(0x41, 0x54)
#define REG_SC_BK41_54_H      _PK_H_(0x41, 0x54)
#define REG_SC_BK41_55_L      _PK_L_(0x41, 0x55)
#define REG_SC_BK41_55_H      _PK_H_(0x41, 0x55)
#define REG_SC_BK41_56_L      _PK_L_(0x41, 0x56)
#define REG_SC_BK41_56_H      _PK_H_(0x41, 0x56)
#define REG_SC_BK41_57_L      _PK_L_(0x41, 0x57)
#define REG_SC_BK41_57_H      _PK_H_(0x41, 0x57)
#define REG_SC_BK41_58_L      _PK_L_(0x41, 0x58)
#define REG_SC_BK41_58_H      _PK_H_(0x41, 0x58)
#define REG_SC_BK41_59_L      _PK_L_(0x41, 0x59)
#define REG_SC_BK41_59_H      _PK_H_(0x41, 0x59)
#define REG_SC_BK41_5A_L      _PK_L_(0x41, 0x5A)
#define REG_SC_BK41_5A_H      _PK_H_(0x41, 0x5A)
#define REG_SC_BK41_5B_L      _PK_L_(0x41, 0x5B)
#define REG_SC_BK41_5B_H      _PK_H_(0x41, 0x5B)
#define REG_SC_BK41_5C_L      _PK_L_(0x41, 0x5C)
#define REG_SC_BK41_5C_H      _PK_H_(0x41, 0x5C)
#define REG_SC_BK41_5D_L      _PK_L_(0x41, 0x5D)
#define REG_SC_BK41_5D_H      _PK_H_(0x41, 0x5D)
#define REG_SC_BK41_5E_L      _PK_L_(0x41, 0x5E)
#define REG_SC_BK41_5E_H      _PK_H_(0x41, 0x5E)
#define REG_SC_BK41_5F_L      _PK_L_(0x41, 0x5F)
#define REG_SC_BK41_5F_H      _PK_H_(0x41, 0x5F)
#define REG_SC_BK41_60_L      _PK_L_(0x41, 0x60)
#define REG_SC_BK41_60_H      _PK_H_(0x41, 0x60)
#define REG_SC_BK41_61_L      _PK_L_(0x41, 0x61)
#define REG_SC_BK41_61_H      _PK_H_(0x41, 0x61)
#define REG_SC_BK41_62_L      _PK_L_(0x41, 0x62)
#define REG_SC_BK41_62_H      _PK_H_(0x41, 0x62)
#define REG_SC_BK41_63_L      _PK_L_(0x41, 0x63)
#define REG_SC_BK41_63_H      _PK_H_(0x41, 0x63)
#define REG_SC_BK41_64_L      _PK_L_(0x41, 0x64)
#define REG_SC_BK41_64_H      _PK_H_(0x41, 0x64)
#define REG_SC_BK41_65_L      _PK_L_(0x41, 0x65)
#define REG_SC_BK41_65_H      _PK_H_(0x41, 0x65)
#define REG_SC_BK41_66_L      _PK_L_(0x41, 0x66)
#define REG_SC_BK41_66_H      _PK_H_(0x41, 0x66)
#define REG_SC_BK41_67_L      _PK_L_(0x41, 0x67)
#define REG_SC_BK41_67_H      _PK_H_(0x41, 0x67)
#define REG_SC_BK41_68_L      _PK_L_(0x41, 0x68)
#define REG_SC_BK41_68_H      _PK_H_(0x41, 0x68)
#define REG_SC_BK41_69_L      _PK_L_(0x41, 0x69)
#define REG_SC_BK41_69_H      _PK_H_(0x41, 0x69)
#define REG_SC_BK41_6A_L      _PK_L_(0x41, 0x6A)
#define REG_SC_BK41_6A_H      _PK_H_(0x41, 0x6A)
#define REG_SC_BK41_6B_L      _PK_L_(0x41, 0x6B)
#define REG_SC_BK41_6B_H      _PK_H_(0x41, 0x6B)
#define REG_SC_BK41_6C_L      _PK_L_(0x41, 0x6C)
#define REG_SC_BK41_6C_H      _PK_H_(0x41, 0x6C)
#define REG_SC_BK41_6D_L      _PK_L_(0x41, 0x6D)
#define REG_SC_BK41_6D_H      _PK_H_(0x41, 0x6D)
#define REG_SC_BK41_6E_L      _PK_L_(0x41, 0x6E)
#define REG_SC_BK41_6E_H      _PK_H_(0x41, 0x6E)
#define REG_SC_BK41_6F_L      _PK_L_(0x41, 0x6F)
#define REG_SC_BK41_6F_H      _PK_H_(0x41, 0x6F)
#define REG_SC_BK41_70_L      _PK_L_(0x41, 0x70)
#define REG_SC_BK41_70_H      _PK_H_(0x41, 0x70)
#define REG_SC_BK41_71_L      _PK_L_(0x41, 0x71)
#define REG_SC_BK41_71_H      _PK_H_(0x41, 0x71)
#define REG_SC_BK41_72_L      _PK_L_(0x41, 0x72)
#define REG_SC_BK41_72_H      _PK_H_(0x41, 0x72)
#define REG_SC_BK41_73_L      _PK_L_(0x41, 0x73)
#define REG_SC_BK41_73_H      _PK_H_(0x41, 0x73)
#define REG_SC_BK41_74_L      _PK_L_(0x41, 0x74)
#define REG_SC_BK41_74_H      _PK_H_(0x41, 0x74)
#define REG_SC_BK41_75_L      _PK_L_(0x41, 0x75)
#define REG_SC_BK41_75_H      _PK_H_(0x41, 0x75)
#define REG_SC_BK41_76_L      _PK_L_(0x41, 0x76)
#define REG_SC_BK41_76_H      _PK_H_(0x41, 0x76)
#define REG_SC_BK41_77_L      _PK_L_(0x41, 0x77)
#define REG_SC_BK41_77_H      _PK_H_(0x41, 0x77)
#define REG_SC_BK41_78_L      _PK_L_(0x41, 0x78)
#define REG_SC_BK41_78_H      _PK_H_(0x41, 0x78)
#define REG_SC_BK41_79_L      _PK_L_(0x41, 0x79)
#define REG_SC_BK41_79_H      _PK_H_(0x41, 0x79)
#define REG_SC_BK41_7A_L      _PK_L_(0x41, 0x7A)
#define REG_SC_BK41_7A_H      _PK_H_(0x41, 0x7A)
#define REG_SC_BK41_7B_L      _PK_L_(0x41, 0x7B)
#define REG_SC_BK41_7B_H      _PK_H_(0x41, 0x7B)
#define REG_SC_BK41_7C_L      _PK_L_(0x41, 0x7C)
#define REG_SC_BK41_7C_H      _PK_H_(0x41, 0x7C)
#define REG_SC_BK41_7D_L      _PK_L_(0x41, 0x7D)
#define REG_SC_BK41_7D_H      _PK_H_(0x41, 0x7D)
#define REG_SC_BK41_7E_L      _PK_L_(0x41, 0x7E)
#define REG_SC_BK41_7E_H      _PK_H_(0x41, 0x7E)
#define REG_SC_BK41_7F_L      _PK_L_(0x41, 0x7F)
#define REG_SC_BK41_7F_H      _PK_H_(0x41, 0x7F)

//----------------------------------------------
//  BK42: FRC IP 2ND
//----------------------------------------------
#define REG_SC_BK42_00_L      _PK_L_(0x42, 0x00)
#define REG_SC_BK42_00_H      _PK_H_(0x42, 0x00)
#define REG_SC_BK42_01_L      _PK_L_(0x42, 0x01)
#define REG_SC_BK42_01_H      _PK_H_(0x42, 0x01)
#define REG_SC_BK42_02_L      _PK_L_(0x42, 0x02)
#define REG_SC_BK42_02_H      _PK_H_(0x42, 0x02)
#define REG_SC_BK42_03_L      _PK_L_(0x42, 0x03)
#define REG_SC_BK42_03_H      _PK_H_(0x42, 0x03)
#define REG_SC_BK42_04_L      _PK_L_(0x42, 0x04)
#define REG_SC_BK42_04_H      _PK_H_(0x42, 0x04)
#define REG_SC_BK42_05_L      _PK_L_(0x42, 0x05)
#define REG_SC_BK42_05_H      _PK_H_(0x42, 0x05)
#define REG_SC_BK42_06_L      _PK_L_(0x42, 0x06)
#define REG_SC_BK42_06_H      _PK_H_(0x42, 0x06)
#define REG_SC_BK42_07_L      _PK_L_(0x42, 0x07)
#define REG_SC_BK42_07_H      _PK_H_(0x42, 0x07)
#define REG_SC_BK42_08_L      _PK_L_(0x42, 0x08)
#define REG_SC_BK42_08_H      _PK_H_(0x42, 0x08)
#define REG_SC_BK42_09_L      _PK_L_(0x42, 0x09)
#define REG_SC_BK42_09_H      _PK_H_(0x42, 0x09)
#define REG_SC_BK42_0A_L      _PK_L_(0x42, 0x0A)
#define REG_SC_BK42_0A_H      _PK_H_(0x42, 0x0A)
#define REG_SC_BK42_0B_L      _PK_L_(0x42, 0x0B)
#define REG_SC_BK42_0B_H      _PK_H_(0x42, 0x0B)
#define REG_SC_BK42_0C_L      _PK_L_(0x42, 0x0C)
#define REG_SC_BK42_0C_H      _PK_H_(0x42, 0x0C)
#define REG_SC_BK42_0D_L      _PK_L_(0x42, 0x0D)
#define REG_SC_BK42_0D_H      _PK_H_(0x42, 0x0D)
#define REG_SC_BK42_0E_L      _PK_L_(0x42, 0x0E)
#define REG_SC_BK42_0E_H      _PK_H_(0x42, 0x0E)
#define REG_SC_BK42_0F_L      _PK_L_(0x42, 0x0F)
#define REG_SC_BK42_0F_H      _PK_H_(0x42, 0x0F)
#define REG_SC_BK42_10_L      _PK_L_(0x42, 0x10)
#define REG_SC_BK42_10_H      _PK_H_(0x42, 0x10)
#define REG_SC_BK42_11_L      _PK_L_(0x42, 0x11)
#define REG_SC_BK42_11_H      _PK_H_(0x42, 0x11)
#define REG_SC_BK42_12_L      _PK_L_(0x42, 0x12)
#define REG_SC_BK42_12_H      _PK_H_(0x42, 0x12)
#define REG_SC_BK42_13_L      _PK_L_(0x42, 0x13)
#define REG_SC_BK42_13_H      _PK_H_(0x42, 0x13)
#define REG_SC_BK42_14_L      _PK_L_(0x42, 0x14)
#define REG_SC_BK42_14_H      _PK_H_(0x42, 0x14)
#define REG_SC_BK42_15_L      _PK_L_(0x42, 0x15)
#define REG_SC_BK42_15_H      _PK_H_(0x42, 0x15)
#define REG_SC_BK42_16_L      _PK_L_(0x42, 0x16)
#define REG_SC_BK42_16_H      _PK_H_(0x42, 0x16)
#define REG_SC_BK42_17_L      _PK_L_(0x42, 0x17)
#define REG_SC_BK42_17_H      _PK_H_(0x42, 0x17)
#define REG_SC_BK42_18_L      _PK_L_(0x42, 0x18)
#define REG_SC_BK42_18_H      _PK_H_(0x42, 0x18)
#define REG_SC_BK42_19_L      _PK_L_(0x42, 0x19)
#define REG_SC_BK42_19_H      _PK_H_(0x42, 0x19)
#define REG_SC_BK42_1A_L      _PK_L_(0x42, 0x1A)
#define REG_SC_BK42_1A_H      _PK_H_(0x42, 0x1A)
#define REG_SC_BK42_1B_L      _PK_L_(0x42, 0x1B)
#define REG_SC_BK42_1B_H      _PK_H_(0x42, 0x1B)
#define REG_SC_BK42_1C_L      _PK_L_(0x42, 0x1C)
#define REG_SC_BK42_1C_H      _PK_H_(0x42, 0x1C)
#define REG_SC_BK42_1D_L      _PK_L_(0x42, 0x1D)
#define REG_SC_BK42_1D_H      _PK_H_(0x42, 0x1D)
#define REG_SC_BK42_1E_L      _PK_L_(0x42, 0x1E)
#define REG_SC_BK42_1E_H      _PK_H_(0x42, 0x1E)
#define REG_SC_BK42_1F_L      _PK_L_(0x42, 0x1F)
#define REG_SC_BK42_1F_H      _PK_H_(0x42, 0x1F)
#define REG_SC_BK42_20_L      _PK_L_(0x42, 0x20)
#define REG_SC_BK42_20_H      _PK_H_(0x42, 0x20)
#define REG_SC_BK42_21_L      _PK_L_(0x42, 0x21)
#define REG_SC_BK42_21_H      _PK_H_(0x42, 0x21)
#define REG_SC_BK42_22_L      _PK_L_(0x42, 0x22)
#define REG_SC_BK42_22_H      _PK_H_(0x42, 0x22)
#define REG_SC_BK42_23_L      _PK_L_(0x42, 0x23)
#define REG_SC_BK42_23_H      _PK_H_(0x42, 0x23)
#define REG_SC_BK42_24_L      _PK_L_(0x42, 0x24)
#define REG_SC_BK42_24_H      _PK_H_(0x42, 0x24)
#define REG_SC_BK42_25_L      _PK_L_(0x42, 0x25)
#define REG_SC_BK42_25_H      _PK_H_(0x42, 0x25)
#define REG_SC_BK42_26_L      _PK_L_(0x42, 0x26)
#define REG_SC_BK42_26_H      _PK_H_(0x42, 0x26)
#define REG_SC_BK42_27_L      _PK_L_(0x42, 0x27)
#define REG_SC_BK42_27_H      _PK_H_(0x42, 0x27)
#define REG_SC_BK42_28_L      _PK_L_(0x42, 0x28)
#define REG_SC_BK42_28_H      _PK_H_(0x42, 0x28)
#define REG_SC_BK42_29_L      _PK_L_(0x42, 0x29)
#define REG_SC_BK42_29_H      _PK_H_(0x42, 0x29)
#define REG_SC_BK42_2A_L      _PK_L_(0x42, 0x2A)
#define REG_SC_BK42_2A_H      _PK_H_(0x42, 0x2A)
#define REG_SC_BK42_2B_L      _PK_L_(0x42, 0x2B)
#define REG_SC_BK42_2B_H      _PK_H_(0x42, 0x2B)
#define REG_SC_BK42_2C_L      _PK_L_(0x42, 0x2C)
#define REG_SC_BK42_2C_H      _PK_H_(0x42, 0x2C)
#define REG_SC_BK42_2D_L      _PK_L_(0x42, 0x2D)
#define REG_SC_BK42_2D_H      _PK_H_(0x42, 0x2D)
#define REG_SC_BK42_2E_L      _PK_L_(0x42, 0x2E)
#define REG_SC_BK42_2E_H      _PK_H_(0x42, 0x2E)
#define REG_SC_BK42_2F_L      _PK_L_(0x42, 0x2F)
#define REG_SC_BK42_2F_H      _PK_H_(0x42, 0x2F)
#define REG_SC_BK42_30_L      _PK_L_(0x42, 0x30)
#define REG_SC_BK42_30_H      _PK_H_(0x42, 0x30)
#define REG_SC_BK42_31_L      _PK_L_(0x42, 0x31)
#define REG_SC_BK42_31_H      _PK_H_(0x42, 0x31)
#define REG_SC_BK42_32_L      _PK_L_(0x42, 0x32)
#define REG_SC_BK42_32_H      _PK_H_(0x42, 0x32)
#define REG_SC_BK42_33_L      _PK_L_(0x42, 0x33)
#define REG_SC_BK42_33_H      _PK_H_(0x42, 0x33)
#define REG_SC_BK42_34_L      _PK_L_(0x42, 0x34)
#define REG_SC_BK42_34_H      _PK_H_(0x42, 0x34)
#define REG_SC_BK42_35_L      _PK_L_(0x42, 0x35)
#define REG_SC_BK42_35_H      _PK_H_(0x42, 0x35)
#define REG_SC_BK42_36_L      _PK_L_(0x42, 0x36)
#define REG_SC_BK42_36_H      _PK_H_(0x42, 0x36)
#define REG_SC_BK42_37_L      _PK_L_(0x42, 0x37)
#define REG_SC_BK42_37_H      _PK_H_(0x42, 0x37)
#define REG_SC_BK42_38_L      _PK_L_(0x42, 0x38)
#define REG_SC_BK42_38_H      _PK_H_(0x42, 0x38)
#define REG_SC_BK42_39_L      _PK_L_(0x42, 0x39)
#define REG_SC_BK42_39_H      _PK_H_(0x42, 0x39)
#define REG_SC_BK42_3A_L      _PK_L_(0x42, 0x3A)
#define REG_SC_BK42_3A_H      _PK_H_(0x42, 0x3A)
#define REG_SC_BK42_3B_L      _PK_L_(0x42, 0x3B)
#define REG_SC_BK42_3B_H      _PK_H_(0x42, 0x3B)
#define REG_SC_BK42_3C_L      _PK_L_(0x42, 0x3C)
#define REG_SC_BK42_3C_H      _PK_H_(0x42, 0x3C)
#define REG_SC_BK42_3D_L      _PK_L_(0x42, 0x3D)
#define REG_SC_BK42_3D_H      _PK_H_(0x42, 0x3D)
#define REG_SC_BK42_3E_L      _PK_L_(0x42, 0x3E)
#define REG_SC_BK42_3E_H      _PK_H_(0x42, 0x3E)
#define REG_SC_BK42_3F_L      _PK_L_(0x42, 0x3F)
#define REG_SC_BK42_3F_H      _PK_H_(0x42, 0x3F)
#define REG_SC_BK42_40_L      _PK_L_(0x42, 0x40)
#define REG_SC_BK42_40_H      _PK_H_(0x42, 0x40)
#define REG_SC_BK42_41_L      _PK_L_(0x42, 0x41)
#define REG_SC_BK42_41_H      _PK_H_(0x42, 0x41)
#define REG_SC_BK42_42_L      _PK_L_(0x42, 0x42)
#define REG_SC_BK42_42_H      _PK_H_(0x42, 0x42)
#define REG_SC_BK42_43_L      _PK_L_(0x42, 0x43)
#define REG_SC_BK42_43_H      _PK_H_(0x42, 0x43)
#define REG_SC_BK42_44_L      _PK_L_(0x42, 0x44)
#define REG_SC_BK42_44_H      _PK_H_(0x42, 0x44)
#define REG_SC_BK42_45_L      _PK_L_(0x42, 0x45)
#define REG_SC_BK42_45_H      _PK_H_(0x42, 0x45)
#define REG_SC_BK42_46_L      _PK_L_(0x42, 0x46)
#define REG_SC_BK42_46_H      _PK_H_(0x42, 0x46)
#define REG_SC_BK42_47_L      _PK_L_(0x42, 0x47)
#define REG_SC_BK42_47_H      _PK_H_(0x42, 0x47)
#define REG_SC_BK42_48_L      _PK_L_(0x42, 0x48)
#define REG_SC_BK42_48_H      _PK_H_(0x42, 0x48)
#define REG_SC_BK42_49_L      _PK_L_(0x42, 0x49)
#define REG_SC_BK42_49_H      _PK_H_(0x42, 0x49)
#define REG_SC_BK42_4A_L      _PK_L_(0x42, 0x4A)
#define REG_SC_BK42_4A_H      _PK_H_(0x42, 0x4A)
#define REG_SC_BK42_4B_L      _PK_L_(0x42, 0x4B)
#define REG_SC_BK42_4B_H      _PK_H_(0x42, 0x4B)
#define REG_SC_BK42_4C_L      _PK_L_(0x42, 0x4C)
#define REG_SC_BK42_4C_H      _PK_H_(0x42, 0x4C)
#define REG_SC_BK42_4D_L      _PK_L_(0x42, 0x4D)
#define REG_SC_BK42_4D_H      _PK_H_(0x42, 0x4D)
#define REG_SC_BK42_4E_L      _PK_L_(0x42, 0x4E)
#define REG_SC_BK42_4E_H      _PK_H_(0x42, 0x4E)
#define REG_SC_BK42_4F_L      _PK_L_(0x42, 0x4F)
#define REG_SC_BK42_4F_H      _PK_H_(0x42, 0x4F)
#define REG_SC_BK42_50_L      _PK_L_(0x42, 0x50)
#define REG_SC_BK42_50_H      _PK_H_(0x42, 0x50)
#define REG_SC_BK42_51_L      _PK_L_(0x42, 0x51)
#define REG_SC_BK42_51_H      _PK_H_(0x42, 0x51)
#define REG_SC_BK42_52_L      _PK_L_(0x42, 0x52)
#define REG_SC_BK42_52_H      _PK_H_(0x42, 0x52)
#define REG_SC_BK42_53_L      _PK_L_(0x42, 0x53)
#define REG_SC_BK42_53_H      _PK_H_(0x42, 0x53)
#define REG_SC_BK42_54_L      _PK_L_(0x42, 0x54)
#define REG_SC_BK42_54_H      _PK_H_(0x42, 0x54)
#define REG_SC_BK42_55_L      _PK_L_(0x42, 0x55)
#define REG_SC_BK42_55_H      _PK_H_(0x42, 0x55)
#define REG_SC_BK42_56_L      _PK_L_(0x42, 0x56)
#define REG_SC_BK42_56_H      _PK_H_(0x42, 0x56)
#define REG_SC_BK42_57_L      _PK_L_(0x42, 0x57)
#define REG_SC_BK42_57_H      _PK_H_(0x42, 0x57)
#define REG_SC_BK42_58_L      _PK_L_(0x42, 0x58)
#define REG_SC_BK42_58_H      _PK_H_(0x42, 0x58)
#define REG_SC_BK42_59_L      _PK_L_(0x42, 0x59)
#define REG_SC_BK42_59_H      _PK_H_(0x42, 0x59)
#define REG_SC_BK42_5A_L      _PK_L_(0x42, 0x5A)
#define REG_SC_BK42_5A_H      _PK_H_(0x42, 0x5A)
#define REG_SC_BK42_5B_L      _PK_L_(0x42, 0x5B)
#define REG_SC_BK42_5B_H      _PK_H_(0x42, 0x5B)
#define REG_SC_BK42_5C_L      _PK_L_(0x42, 0x5C)
#define REG_SC_BK42_5C_H      _PK_H_(0x42, 0x5C)
#define REG_SC_BK42_5D_L      _PK_L_(0x42, 0x5D)
#define REG_SC_BK42_5D_H      _PK_H_(0x42, 0x5D)
#define REG_SC_BK42_5E_L      _PK_L_(0x42, 0x5E)
#define REG_SC_BK42_5E_H      _PK_H_(0x42, 0x5E)
#define REG_SC_BK42_5F_L      _PK_L_(0x42, 0x5F)
#define REG_SC_BK42_5F_H      _PK_H_(0x42, 0x5F)
#define REG_SC_BK42_60_L      _PK_L_(0x42, 0x60)
#define REG_SC_BK42_60_H      _PK_H_(0x42, 0x60)
#define REG_SC_BK42_61_L      _PK_L_(0x42, 0x61)
#define REG_SC_BK42_61_H      _PK_H_(0x42, 0x61)
#define REG_SC_BK42_62_L      _PK_L_(0x42, 0x62)
#define REG_SC_BK42_62_H      _PK_H_(0x42, 0x62)
#define REG_SC_BK42_63_L      _PK_L_(0x42, 0x63)
#define REG_SC_BK42_63_H      _PK_H_(0x42, 0x63)
#define REG_SC_BK42_64_L      _PK_L_(0x42, 0x64)
#define REG_SC_BK42_64_H      _PK_H_(0x42, 0x64)
#define REG_SC_BK42_65_L      _PK_L_(0x42, 0x65)
#define REG_SC_BK42_65_H      _PK_H_(0x42, 0x65)
#define REG_SC_BK42_66_L      _PK_L_(0x42, 0x66)
#define REG_SC_BK42_66_H      _PK_H_(0x42, 0x66)
#define REG_SC_BK42_67_L      _PK_L_(0x42, 0x67)
#define REG_SC_BK42_67_H      _PK_H_(0x42, 0x67)
#define REG_SC_BK42_68_L      _PK_L_(0x42, 0x68)
#define REG_SC_BK42_68_H      _PK_H_(0x42, 0x68)
#define REG_SC_BK42_69_L      _PK_L_(0x42, 0x69)
#define REG_SC_BK42_69_H      _PK_H_(0x42, 0x69)
#define REG_SC_BK42_6A_L      _PK_L_(0x42, 0x6A)
#define REG_SC_BK42_6A_H      _PK_H_(0x42, 0x6A)
#define REG_SC_BK42_6B_L      _PK_L_(0x42, 0x6B)
#define REG_SC_BK42_6B_H      _PK_H_(0x42, 0x6B)
#define REG_SC_BK42_6C_L      _PK_L_(0x42, 0x6C)
#define REG_SC_BK42_6C_H      _PK_H_(0x42, 0x6C)
#define REG_SC_BK42_6D_L      _PK_L_(0x42, 0x6D)
#define REG_SC_BK42_6D_H      _PK_H_(0x42, 0x6D)
#define REG_SC_BK42_6E_L      _PK_L_(0x42, 0x6E)
#define REG_SC_BK42_6E_H      _PK_H_(0x42, 0x6E)
#define REG_SC_BK42_6F_L      _PK_L_(0x42, 0x6F)
#define REG_SC_BK42_6F_H      _PK_H_(0x42, 0x6F)
#define REG_SC_BK42_70_L      _PK_L_(0x42, 0x70)
#define REG_SC_BK42_70_H      _PK_H_(0x42, 0x70)
#define REG_SC_BK42_71_L      _PK_L_(0x42, 0x71)
#define REG_SC_BK42_71_H      _PK_H_(0x42, 0x71)
#define REG_SC_BK42_72_L      _PK_L_(0x42, 0x72)
#define REG_SC_BK42_72_H      _PK_H_(0x42, 0x72)
#define REG_SC_BK42_73_L      _PK_L_(0x42, 0x73)
#define REG_SC_BK42_73_H      _PK_H_(0x42, 0x73)
#define REG_SC_BK42_74_L      _PK_L_(0x42, 0x74)
#define REG_SC_BK42_74_H      _PK_H_(0x42, 0x74)
#define REG_SC_BK42_75_L      _PK_L_(0x42, 0x75)
#define REG_SC_BK42_75_H      _PK_H_(0x42, 0x75)
#define REG_SC_BK42_76_L      _PK_L_(0x42, 0x76)
#define REG_SC_BK42_76_H      _PK_H_(0x42, 0x76)
#define REG_SC_BK42_77_L      _PK_L_(0x42, 0x77)
#define REG_SC_BK42_77_H      _PK_H_(0x42, 0x77)
#define REG_SC_BK42_78_L      _PK_L_(0x42, 0x78)
#define REG_SC_BK42_78_H      _PK_H_(0x42, 0x78)
#define REG_SC_BK42_79_L      _PK_L_(0x42, 0x79)
#define REG_SC_BK42_79_H      _PK_H_(0x42, 0x79)
#define REG_SC_BK42_7A_L      _PK_L_(0x42, 0x7A)
#define REG_SC_BK42_7A_H      _PK_H_(0x42, 0x7A)
#define REG_SC_BK42_7B_L      _PK_L_(0x42, 0x7B)
#define REG_SC_BK42_7B_H      _PK_H_(0x42, 0x7B)
#define REG_SC_BK42_7C_L      _PK_L_(0x42, 0x7C)
#define REG_SC_BK42_7C_H      _PK_H_(0x42, 0x7C)
#define REG_SC_BK42_7D_L      _PK_L_(0x42, 0x7D)
#define REG_SC_BK42_7D_H      _PK_H_(0x42, 0x7D)
#define REG_SC_BK42_7E_L      _PK_L_(0x42, 0x7E)
#define REG_SC_BK42_7E_H      _PK_H_(0x42, 0x7E)
#define REG_SC_BK42_7F_L      _PK_L_(0x42, 0x7F)
#define REG_SC_BK42_7F_H      _PK_H_(0x42, 0x7F)

//----------------------------------------------
//  BK43: FRCM
//----------------------------------------------
#define REG_SC_BK43_00_L      _PK_L_(0x43, 0x00)
#define REG_SC_BK43_00_H      _PK_H_(0x43, 0x00)
#define REG_SC_BK43_01_L      _PK_L_(0x43, 0x01)
#define REG_SC_BK43_01_H      _PK_H_(0x43, 0x01)
#define REG_SC_BK43_02_L      _PK_L_(0x43, 0x02)
#define REG_SC_BK43_02_H      _PK_H_(0x43, 0x02)
#define REG_SC_BK43_03_L      _PK_L_(0x43, 0x03)
#define REG_SC_BK43_03_H      _PK_H_(0x43, 0x03)
#define REG_SC_BK43_04_L      _PK_L_(0x43, 0x04)
#define REG_SC_BK43_04_H      _PK_H_(0x43, 0x04)
#define REG_SC_BK43_05_L      _PK_L_(0x43, 0x05)
#define REG_SC_BK43_05_H      _PK_H_(0x43, 0x05)
#define REG_SC_BK43_06_L      _PK_L_(0x43, 0x06)
#define REG_SC_BK43_06_H      _PK_H_(0x43, 0x06)
#define REG_SC_BK43_07_L      _PK_L_(0x43, 0x07)
#define REG_SC_BK43_07_H      _PK_H_(0x43, 0x07)
#define REG_SC_BK43_08_L      _PK_L_(0x43, 0x08)
#define REG_SC_BK43_08_H      _PK_H_(0x43, 0x08)
#define REG_SC_BK43_09_L      _PK_L_(0x43, 0x09)
#define REG_SC_BK43_09_H      _PK_H_(0x43, 0x09)
#define REG_SC_BK43_0A_L      _PK_L_(0x43, 0x0A)
#define REG_SC_BK43_0A_H      _PK_H_(0x43, 0x0A)
#define REG_SC_BK43_0B_L      _PK_L_(0x43, 0x0B)
#define REG_SC_BK43_0B_H      _PK_H_(0x43, 0x0B)
#define REG_SC_BK43_0C_L      _PK_L_(0x43, 0x0C)
#define REG_SC_BK43_0C_H      _PK_H_(0x43, 0x0C)
#define REG_SC_BK43_0D_L      _PK_L_(0x43, 0x0D)
#define REG_SC_BK43_0D_H      _PK_H_(0x43, 0x0D)
#define REG_SC_BK43_0E_L      _PK_L_(0x43, 0x0E)
#define REG_SC_BK43_0E_H      _PK_H_(0x43, 0x0E)
#define REG_SC_BK43_0F_L      _PK_L_(0x43, 0x0F)
#define REG_SC_BK43_0F_H      _PK_H_(0x43, 0x0F)
#define REG_SC_BK43_10_L      _PK_L_(0x43, 0x10)
#define REG_SC_BK43_10_H      _PK_H_(0x43, 0x10)
#define REG_SC_BK43_11_L      _PK_L_(0x43, 0x11)
#define REG_SC_BK43_11_H      _PK_H_(0x43, 0x11)
#define REG_SC_BK43_12_L      _PK_L_(0x43, 0x12)
#define REG_SC_BK43_12_H      _PK_H_(0x43, 0x12)
#define REG_SC_BK43_13_L      _PK_L_(0x43, 0x13)
#define REG_SC_BK43_13_H      _PK_H_(0x43, 0x13)
#define REG_SC_BK43_14_L      _PK_L_(0x43, 0x14)
#define REG_SC_BK43_14_H      _PK_H_(0x43, 0x14)
#define REG_SC_BK43_15_L      _PK_L_(0x43, 0x15)
#define REG_SC_BK43_15_H      _PK_H_(0x43, 0x15)
#define REG_SC_BK43_16_L      _PK_L_(0x43, 0x16)
#define REG_SC_BK43_16_H      _PK_H_(0x43, 0x16)
#define REG_SC_BK43_17_L      _PK_L_(0x43, 0x17)
#define REG_SC_BK43_17_H      _PK_H_(0x43, 0x17)
#define REG_SC_BK43_18_L      _PK_L_(0x43, 0x18)
#define REG_SC_BK43_18_H      _PK_H_(0x43, 0x18)
#define REG_SC_BK43_19_L      _PK_L_(0x43, 0x19)
#define REG_SC_BK43_19_H      _PK_H_(0x43, 0x19)
#define REG_SC_BK43_1A_L      _PK_L_(0x43, 0x1A)
#define REG_SC_BK43_1A_H      _PK_H_(0x43, 0x1A)
#define REG_SC_BK43_1B_L      _PK_L_(0x43, 0x1B)
#define REG_SC_BK43_1B_H      _PK_H_(0x43, 0x1B)
#define REG_SC_BK43_1C_L      _PK_L_(0x43, 0x1C)
#define REG_SC_BK43_1C_H      _PK_H_(0x43, 0x1C)
#define REG_SC_BK43_1D_L      _PK_L_(0x43, 0x1D)
#define REG_SC_BK43_1D_H      _PK_H_(0x43, 0x1D)
#define REG_SC_BK43_1E_L      _PK_L_(0x43, 0x1E)
#define REG_SC_BK43_1E_H      _PK_H_(0x43, 0x1E)
#define REG_SC_BK43_1F_L      _PK_L_(0x43, 0x1F)
#define REG_SC_BK43_1F_H      _PK_H_(0x43, 0x1F)
#define REG_SC_BK43_20_L      _PK_L_(0x43, 0x20)
#define REG_SC_BK43_20_H      _PK_H_(0x43, 0x20)
#define REG_SC_BK43_21_L      _PK_L_(0x43, 0x21)
#define REG_SC_BK43_21_H      _PK_H_(0x43, 0x21)
#define REG_SC_BK43_22_L      _PK_L_(0x43, 0x22)
#define REG_SC_BK43_22_H      _PK_H_(0x43, 0x22)
#define REG_SC_BK43_23_L      _PK_L_(0x43, 0x23)
#define REG_SC_BK43_23_H      _PK_H_(0x43, 0x23)
#define REG_SC_BK43_24_L      _PK_L_(0x43, 0x24)
#define REG_SC_BK43_24_H      _PK_H_(0x43, 0x24)
#define REG_SC_BK43_25_L      _PK_L_(0x43, 0x25)
#define REG_SC_BK43_25_H      _PK_H_(0x43, 0x25)
#define REG_SC_BK43_26_L      _PK_L_(0x43, 0x26)
#define REG_SC_BK43_26_H      _PK_H_(0x43, 0x26)
#define REG_SC_BK43_27_L      _PK_L_(0x43, 0x27)
#define REG_SC_BK43_27_H      _PK_H_(0x43, 0x27)
#define REG_SC_BK43_28_L      _PK_L_(0x43, 0x28)
#define REG_SC_BK43_28_H      _PK_H_(0x43, 0x28)
#define REG_SC_BK43_29_L      _PK_L_(0x43, 0x29)
#define REG_SC_BK43_29_H      _PK_H_(0x43, 0x29)
#define REG_SC_BK43_2A_L      _PK_L_(0x43, 0x2A)
#define REG_SC_BK43_2A_H      _PK_H_(0x43, 0x2A)
#define REG_SC_BK43_2B_L      _PK_L_(0x43, 0x2B)
#define REG_SC_BK43_2B_H      _PK_H_(0x43, 0x2B)
#define REG_SC_BK43_2C_L      _PK_L_(0x43, 0x2C)
#define REG_SC_BK43_2C_H      _PK_H_(0x43, 0x2C)
#define REG_SC_BK43_2D_L      _PK_L_(0x43, 0x2D)
#define REG_SC_BK43_2D_H      _PK_H_(0x43, 0x2D)
#define REG_SC_BK43_2E_L      _PK_L_(0x43, 0x2E)
#define REG_SC_BK43_2E_H      _PK_H_(0x43, 0x2E)
#define REG_SC_BK43_2F_L      _PK_L_(0x43, 0x2F)
#define REG_SC_BK43_2F_H      _PK_H_(0x43, 0x2F)
#define REG_SC_BK43_30_L      _PK_L_(0x43, 0x30)
#define REG_SC_BK43_30_H      _PK_H_(0x43, 0x30)
#define REG_SC_BK43_31_L      _PK_L_(0x43, 0x31)
#define REG_SC_BK43_31_H      _PK_H_(0x43, 0x31)
#define REG_SC_BK43_32_L      _PK_L_(0x43, 0x32)
#define REG_SC_BK43_32_H      _PK_H_(0x43, 0x32)
#define REG_SC_BK43_33_L      _PK_L_(0x43, 0x33)
#define REG_SC_BK43_33_H      _PK_H_(0x43, 0x33)
#define REG_SC_BK43_34_L      _PK_L_(0x43, 0x34)
#define REG_SC_BK43_34_H      _PK_H_(0x43, 0x34)
#define REG_SC_BK43_35_L      _PK_L_(0x43, 0x35)
#define REG_SC_BK43_35_H      _PK_H_(0x43, 0x35)
#define REG_SC_BK43_36_L      _PK_L_(0x43, 0x36)
#define REG_SC_BK43_36_H      _PK_H_(0x43, 0x36)
#define REG_SC_BK43_37_L      _PK_L_(0x43, 0x37)
#define REG_SC_BK43_37_H      _PK_H_(0x43, 0x37)
#define REG_SC_BK43_38_L      _PK_L_(0x43, 0x38)
#define REG_SC_BK43_38_H      _PK_H_(0x43, 0x38)
#define REG_SC_BK43_39_L      _PK_L_(0x43, 0x39)
#define REG_SC_BK43_39_H      _PK_H_(0x43, 0x39)
#define REG_SC_BK43_3A_L      _PK_L_(0x43, 0x3A)
#define REG_SC_BK43_3A_H      _PK_H_(0x43, 0x3A)
#define REG_SC_BK43_3B_L      _PK_L_(0x43, 0x3B)
#define REG_SC_BK43_3B_H      _PK_H_(0x43, 0x3B)
#define REG_SC_BK43_3C_L      _PK_L_(0x43, 0x3C)
#define REG_SC_BK43_3C_H      _PK_H_(0x43, 0x3C)
#define REG_SC_BK43_3D_L      _PK_L_(0x43, 0x3D)
#define REG_SC_BK43_3D_H      _PK_H_(0x43, 0x3D)
#define REG_SC_BK43_3E_L      _PK_L_(0x43, 0x3E)
#define REG_SC_BK43_3E_H      _PK_H_(0x43, 0x3E)
#define REG_SC_BK43_3F_L      _PK_L_(0x43, 0x3F)
#define REG_SC_BK43_3F_H      _PK_H_(0x43, 0x3F)
#define REG_SC_BK43_40_L      _PK_L_(0x43, 0x40)
#define REG_SC_BK43_40_H      _PK_H_(0x43, 0x40)
#define REG_SC_BK43_41_L      _PK_L_(0x43, 0x41)
#define REG_SC_BK43_41_H      _PK_H_(0x43, 0x41)
#define REG_SC_BK43_42_L      _PK_L_(0x43, 0x42)
#define REG_SC_BK43_42_H      _PK_H_(0x43, 0x42)
#define REG_SC_BK43_43_L      _PK_L_(0x43, 0x43)
#define REG_SC_BK43_43_H      _PK_H_(0x43, 0x43)
#define REG_SC_BK43_44_L      _PK_L_(0x43, 0x44)
#define REG_SC_BK43_44_H      _PK_H_(0x43, 0x44)
#define REG_SC_BK43_45_L      _PK_L_(0x43, 0x45)
#define REG_SC_BK43_45_H      _PK_H_(0x43, 0x45)
#define REG_SC_BK43_46_L      _PK_L_(0x43, 0x46)
#define REG_SC_BK43_46_H      _PK_H_(0x43, 0x46)
#define REG_SC_BK43_47_L      _PK_L_(0x43, 0x47)
#define REG_SC_BK43_47_H      _PK_H_(0x43, 0x47)
#define REG_SC_BK43_48_L      _PK_L_(0x43, 0x48)
#define REG_SC_BK43_48_H      _PK_H_(0x43, 0x48)
#define REG_SC_BK43_49_L      _PK_L_(0x43, 0x49)
#define REG_SC_BK43_49_H      _PK_H_(0x43, 0x49)
#define REG_SC_BK43_4A_L      _PK_L_(0x43, 0x4A)
#define REG_SC_BK43_4A_H      _PK_H_(0x43, 0x4A)
#define REG_SC_BK43_4B_L      _PK_L_(0x43, 0x4B)
#define REG_SC_BK43_4B_H      _PK_H_(0x43, 0x4B)
#define REG_SC_BK43_4C_L      _PK_L_(0x43, 0x4C)
#define REG_SC_BK43_4C_H      _PK_H_(0x43, 0x4C)
#define REG_SC_BK43_4D_L      _PK_L_(0x43, 0x4D)
#define REG_SC_BK43_4D_H      _PK_H_(0x43, 0x4D)
#define REG_SC_BK43_4E_L      _PK_L_(0x43, 0x4E)
#define REG_SC_BK43_4E_H      _PK_H_(0x43, 0x4E)
#define REG_SC_BK43_4F_L      _PK_L_(0x43, 0x4F)
#define REG_SC_BK43_4F_H      _PK_H_(0x43, 0x4F)
#define REG_SC_BK43_50_L      _PK_L_(0x43, 0x50)
#define REG_SC_BK43_50_H      _PK_H_(0x43, 0x50)
#define REG_SC_BK43_51_L      _PK_L_(0x43, 0x51)
#define REG_SC_BK43_51_H      _PK_H_(0x43, 0x51)
#define REG_SC_BK43_52_L      _PK_L_(0x43, 0x52)
#define REG_SC_BK43_52_H      _PK_H_(0x43, 0x52)
#define REG_SC_BK43_53_L      _PK_L_(0x43, 0x53)
#define REG_SC_BK43_53_H      _PK_H_(0x43, 0x53)
#define REG_SC_BK43_54_L      _PK_L_(0x43, 0x54)
#define REG_SC_BK43_54_H      _PK_H_(0x43, 0x54)
#define REG_SC_BK43_55_L      _PK_L_(0x43, 0x55)
#define REG_SC_BK43_55_H      _PK_H_(0x43, 0x55)
#define REG_SC_BK43_56_L      _PK_L_(0x43, 0x56)
#define REG_SC_BK43_56_H      _PK_H_(0x43, 0x56)
#define REG_SC_BK43_57_L      _PK_L_(0x43, 0x57)
#define REG_SC_BK43_57_H      _PK_H_(0x43, 0x57)
#define REG_SC_BK43_58_L      _PK_L_(0x43, 0x58)
#define REG_SC_BK43_58_H      _PK_H_(0x43, 0x58)
#define REG_SC_BK43_59_L      _PK_L_(0x43, 0x59)
#define REG_SC_BK43_59_H      _PK_H_(0x43, 0x59)
#define REG_SC_BK43_5A_L      _PK_L_(0x43, 0x5A)
#define REG_SC_BK43_5A_H      _PK_H_(0x43, 0x5A)
#define REG_SC_BK43_5B_L      _PK_L_(0x43, 0x5B)
#define REG_SC_BK43_5B_H      _PK_H_(0x43, 0x5B)
#define REG_SC_BK43_5C_L      _PK_L_(0x43, 0x5C)
#define REG_SC_BK43_5C_H      _PK_H_(0x43, 0x5C)
#define REG_SC_BK43_5D_L      _PK_L_(0x43, 0x5D)
#define REG_SC_BK43_5D_H      _PK_H_(0x43, 0x5D)
#define REG_SC_BK43_5E_L      _PK_L_(0x43, 0x5E)
#define REG_SC_BK43_5E_H      _PK_H_(0x43, 0x5E)
#define REG_SC_BK43_5F_L      _PK_L_(0x43, 0x5F)
#define REG_SC_BK43_5F_H      _PK_H_(0x43, 0x5F)
#define REG_SC_BK43_60_L      _PK_L_(0x43, 0x60)
#define REG_SC_BK43_60_H      _PK_H_(0x43, 0x60)
#define REG_SC_BK43_61_L      _PK_L_(0x43, 0x61)
#define REG_SC_BK43_61_H      _PK_H_(0x43, 0x61)
#define REG_SC_BK43_62_L      _PK_L_(0x43, 0x62)
#define REG_SC_BK43_62_H      _PK_H_(0x43, 0x62)
#define REG_SC_BK43_63_L      _PK_L_(0x43, 0x63)
#define REG_SC_BK43_63_H      _PK_H_(0x43, 0x63)
#define REG_SC_BK43_64_L      _PK_L_(0x43, 0x64)
#define REG_SC_BK43_64_H      _PK_H_(0x43, 0x64)
#define REG_SC_BK43_65_L      _PK_L_(0x43, 0x65)
#define REG_SC_BK43_65_H      _PK_H_(0x43, 0x65)
#define REG_SC_BK43_66_L      _PK_L_(0x43, 0x66)
#define REG_SC_BK43_66_H      _PK_H_(0x43, 0x66)
#define REG_SC_BK43_67_L      _PK_L_(0x43, 0x67)
#define REG_SC_BK43_67_H      _PK_H_(0x43, 0x67)
#define REG_SC_BK43_68_L      _PK_L_(0x43, 0x68)
#define REG_SC_BK43_68_H      _PK_H_(0x43, 0x68)
#define REG_SC_BK43_69_L      _PK_L_(0x43, 0x69)
#define REG_SC_BK43_69_H      _PK_H_(0x43, 0x69)
#define REG_SC_BK43_6A_L      _PK_L_(0x43, 0x6A)
#define REG_SC_BK43_6A_H      _PK_H_(0x43, 0x6A)
#define REG_SC_BK43_6B_L      _PK_L_(0x43, 0x6B)
#define REG_SC_BK43_6B_H      _PK_H_(0x43, 0x6B)
#define REG_SC_BK43_6C_L      _PK_L_(0x43, 0x6C)
#define REG_SC_BK43_6C_H      _PK_H_(0x43, 0x6C)
#define REG_SC_BK43_6D_L      _PK_L_(0x43, 0x6D)
#define REG_SC_BK43_6D_H      _PK_H_(0x43, 0x6D)
#define REG_SC_BK43_6E_L      _PK_L_(0x43, 0x6E)
#define REG_SC_BK43_6E_H      _PK_H_(0x43, 0x6E)
#define REG_SC_BK43_6F_L      _PK_L_(0x43, 0x6F)
#define REG_SC_BK43_6F_H      _PK_H_(0x43, 0x6F)
#define REG_SC_BK43_70_L      _PK_L_(0x43, 0x70)
#define REG_SC_BK43_70_H      _PK_H_(0x43, 0x70)
#define REG_SC_BK43_71_L      _PK_L_(0x43, 0x71)
#define REG_SC_BK43_71_H      _PK_H_(0x43, 0x71)
#define REG_SC_BK43_72_L      _PK_L_(0x43, 0x72)
#define REG_SC_BK43_72_H      _PK_H_(0x43, 0x72)
#define REG_SC_BK43_73_L      _PK_L_(0x43, 0x73)
#define REG_SC_BK43_73_H      _PK_H_(0x43, 0x73)
#define REG_SC_BK43_74_L      _PK_L_(0x43, 0x74)
#define REG_SC_BK43_74_H      _PK_H_(0x43, 0x74)
#define REG_SC_BK43_75_L      _PK_L_(0x43, 0x75)
#define REG_SC_BK43_75_H      _PK_H_(0x43, 0x75)
#define REG_SC_BK43_76_L      _PK_L_(0x43, 0x76)
#define REG_SC_BK43_76_H      _PK_H_(0x43, 0x76)
#define REG_SC_BK43_77_L      _PK_L_(0x43, 0x77)
#define REG_SC_BK43_77_H      _PK_H_(0x43, 0x77)
#define REG_SC_BK43_78_L      _PK_L_(0x43, 0x78)
#define REG_SC_BK43_78_H      _PK_H_(0x43, 0x78)
#define REG_SC_BK43_79_L      _PK_L_(0x43, 0x79)
#define REG_SC_BK43_79_H      _PK_H_(0x43, 0x79)
#define REG_SC_BK43_7A_L      _PK_L_(0x43, 0x7A)
#define REG_SC_BK43_7A_H      _PK_H_(0x43, 0x7A)
#define REG_SC_BK43_7B_L      _PK_L_(0x43, 0x7B)
#define REG_SC_BK43_7B_H      _PK_H_(0x43, 0x7B)
#define REG_SC_BK43_7C_L      _PK_L_(0x43, 0x7C)
#define REG_SC_BK43_7C_H      _PK_H_(0x43, 0x7C)
#define REG_SC_BK43_7D_L      _PK_L_(0x43, 0x7D)
#define REG_SC_BK43_7D_H      _PK_H_(0x43, 0x7D)
#define REG_SC_BK43_7E_L      _PK_L_(0x43, 0x7E)
#define REG_SC_BK43_7E_H      _PK_H_(0x43, 0x7E)
#define REG_SC_BK43_7F_L      _PK_L_(0x43, 0x7F)
#define REG_SC_BK43_7F_H      _PK_H_(0x43, 0x7F)

//----------------------------------------------
//  BK44: FRC OP1
//----------------------------------------------
#define REG_SC_BK44_00_L      _PK_L_(0x44, 0x00)
#define REG_SC_BK44_00_H      _PK_H_(0x44, 0x00)
#define REG_SC_BK44_01_L      _PK_L_(0x44, 0x01)
#define REG_SC_BK44_01_H      _PK_H_(0x44, 0x01)
#define REG_SC_BK44_02_L      _PK_L_(0x44, 0x02)
#define REG_SC_BK44_02_H      _PK_H_(0x44, 0x02)
#define REG_SC_BK44_03_L      _PK_L_(0x44, 0x03)
#define REG_SC_BK44_03_H      _PK_H_(0x44, 0x03)
#define REG_SC_BK44_04_L      _PK_L_(0x44, 0x04)
#define REG_SC_BK44_04_H      _PK_H_(0x44, 0x04)
#define REG_SC_BK44_05_L      _PK_L_(0x44, 0x05)
#define REG_SC_BK44_05_H      _PK_H_(0x44, 0x05)
#define REG_SC_BK44_06_L      _PK_L_(0x44, 0x06)
#define REG_SC_BK44_06_H      _PK_H_(0x44, 0x06)
#define REG_SC_BK44_07_L      _PK_L_(0x44, 0x07)
#define REG_SC_BK44_07_H      _PK_H_(0x44, 0x07)
#define REG_SC_BK44_08_L      _PK_L_(0x44, 0x08)
#define REG_SC_BK44_08_H      _PK_H_(0x44, 0x08)
#define REG_SC_BK44_09_L      _PK_L_(0x44, 0x09)
#define REG_SC_BK44_09_H      _PK_H_(0x44, 0x09)
#define REG_SC_BK44_0A_L      _PK_L_(0x44, 0x0A)
#define REG_SC_BK44_0A_H      _PK_H_(0x44, 0x0A)
#define REG_SC_BK44_0B_L      _PK_L_(0x44, 0x0B)
#define REG_SC_BK44_0B_H      _PK_H_(0x44, 0x0B)
#define REG_SC_BK44_0C_L      _PK_L_(0x44, 0x0C)
#define REG_SC_BK44_0C_H      _PK_H_(0x44, 0x0C)
#define REG_SC_BK44_0D_L      _PK_L_(0x44, 0x0D)
#define REG_SC_BK44_0D_H      _PK_H_(0x44, 0x0D)
#define REG_SC_BK44_0E_L      _PK_L_(0x44, 0x0E)
#define REG_SC_BK44_0E_H      _PK_H_(0x44, 0x0E)
#define REG_SC_BK44_0F_L      _PK_L_(0x44, 0x0F)
#define REG_SC_BK44_0F_H      _PK_H_(0x44, 0x0F)
#define REG_SC_BK44_10_L      _PK_L_(0x44, 0x10)
#define REG_SC_BK44_10_H      _PK_H_(0x44, 0x10)
#define REG_SC_BK44_11_L      _PK_L_(0x44, 0x11)
#define REG_SC_BK44_11_H      _PK_H_(0x44, 0x11)
#define REG_SC_BK44_12_L      _PK_L_(0x44, 0x12)
#define REG_SC_BK44_12_H      _PK_H_(0x44, 0x12)
#define REG_SC_BK44_13_L      _PK_L_(0x44, 0x13)
#define REG_SC_BK44_13_H      _PK_H_(0x44, 0x13)
#define REG_SC_BK44_14_L      _PK_L_(0x44, 0x14)
#define REG_SC_BK44_14_H      _PK_H_(0x44, 0x14)
#define REG_SC_BK44_15_L      _PK_L_(0x44, 0x15)
#define REG_SC_BK44_15_H      _PK_H_(0x44, 0x15)
#define REG_SC_BK44_16_L      _PK_L_(0x44, 0x16)
#define REG_SC_BK44_16_H      _PK_H_(0x44, 0x16)
#define REG_SC_BK44_17_L      _PK_L_(0x44, 0x17)
#define REG_SC_BK44_17_H      _PK_H_(0x44, 0x17)
#define REG_SC_BK44_18_L      _PK_L_(0x44, 0x18)
#define REG_SC_BK44_18_H      _PK_H_(0x44, 0x18)
#define REG_SC_BK44_19_L      _PK_L_(0x44, 0x19)
#define REG_SC_BK44_19_H      _PK_H_(0x44, 0x19)
#define REG_SC_BK44_1A_L      _PK_L_(0x44, 0x1A)
#define REG_SC_BK44_1A_H      _PK_H_(0x44, 0x1A)
#define REG_SC_BK44_1B_L      _PK_L_(0x44, 0x1B)
#define REG_SC_BK44_1B_H      _PK_H_(0x44, 0x1B)
#define REG_SC_BK44_1C_L      _PK_L_(0x44, 0x1C)
#define REG_SC_BK44_1C_H      _PK_H_(0x44, 0x1C)
#define REG_SC_BK44_1D_L      _PK_L_(0x44, 0x1D)
#define REG_SC_BK44_1D_H      _PK_H_(0x44, 0x1D)
#define REG_SC_BK44_1E_L      _PK_L_(0x44, 0x1E)
#define REG_SC_BK44_1E_H      _PK_H_(0x44, 0x1E)
#define REG_SC_BK44_1F_L      _PK_L_(0x44, 0x1F)
#define REG_SC_BK44_1F_H      _PK_H_(0x44, 0x1F)
#define REG_SC_BK44_20_L      _PK_L_(0x44, 0x20)
#define REG_SC_BK44_20_H      _PK_H_(0x44, 0x20)
#define REG_SC_BK44_21_L      _PK_L_(0x44, 0x21)
#define REG_SC_BK44_21_H      _PK_H_(0x44, 0x21)
#define REG_SC_BK44_22_L      _PK_L_(0x44, 0x22)
#define REG_SC_BK44_22_H      _PK_H_(0x44, 0x22)
#define REG_SC_BK44_23_L      _PK_L_(0x44, 0x23)
#define REG_SC_BK44_23_H      _PK_H_(0x44, 0x23)
#define REG_SC_BK44_24_L      _PK_L_(0x44, 0x24)
#define REG_SC_BK44_24_H      _PK_H_(0x44, 0x24)
#define REG_SC_BK44_25_L      _PK_L_(0x44, 0x25)
#define REG_SC_BK44_25_H      _PK_H_(0x44, 0x25)
#define REG_SC_BK44_26_L      _PK_L_(0x44, 0x26)
#define REG_SC_BK44_26_H      _PK_H_(0x44, 0x26)
#define REG_SC_BK44_27_L      _PK_L_(0x44, 0x27)
#define REG_SC_BK44_27_H      _PK_H_(0x44, 0x27)
#define REG_SC_BK44_28_L      _PK_L_(0x44, 0x28)
#define REG_SC_BK44_28_H      _PK_H_(0x44, 0x28)
#define REG_SC_BK44_29_L      _PK_L_(0x44, 0x29)
#define REG_SC_BK44_29_H      _PK_H_(0x44, 0x29)
#define REG_SC_BK44_2A_L      _PK_L_(0x44, 0x2A)
#define REG_SC_BK44_2A_H      _PK_H_(0x44, 0x2A)
#define REG_SC_BK44_2B_L      _PK_L_(0x44, 0x2B)
#define REG_SC_BK44_2B_H      _PK_H_(0x44, 0x2B)
#define REG_SC_BK44_2C_L      _PK_L_(0x44, 0x2C)
#define REG_SC_BK44_2C_H      _PK_H_(0x44, 0x2C)
#define REG_SC_BK44_2D_L      _PK_L_(0x44, 0x2D)
#define REG_SC_BK44_2D_H      _PK_H_(0x44, 0x2D)
#define REG_SC_BK44_2E_L      _PK_L_(0x44, 0x2E)
#define REG_SC_BK44_2E_H      _PK_H_(0x44, 0x2E)
#define REG_SC_BK44_2F_L      _PK_L_(0x44, 0x2F)
#define REG_SC_BK44_2F_H      _PK_H_(0x44, 0x2F)
#define REG_SC_BK44_30_L      _PK_L_(0x44, 0x30)
#define REG_SC_BK44_30_H      _PK_H_(0x44, 0x30)
#define REG_SC_BK44_31_L      _PK_L_(0x44, 0x31)
#define REG_SC_BK44_31_H      _PK_H_(0x44, 0x31)
#define REG_SC_BK44_32_L      _PK_L_(0x44, 0x32)
#define REG_SC_BK44_32_H      _PK_H_(0x44, 0x32)
#define REG_SC_BK44_33_L      _PK_L_(0x44, 0x33)
#define REG_SC_BK44_33_H      _PK_H_(0x44, 0x33)
#define REG_SC_BK44_34_L      _PK_L_(0x44, 0x34)
#define REG_SC_BK44_34_H      _PK_H_(0x44, 0x34)
#define REG_SC_BK44_35_L      _PK_L_(0x44, 0x35)
#define REG_SC_BK44_35_H      _PK_H_(0x44, 0x35)
#define REG_SC_BK44_36_L      _PK_L_(0x44, 0x36)
#define REG_SC_BK44_36_H      _PK_H_(0x44, 0x36)
#define REG_SC_BK44_37_L      _PK_L_(0x44, 0x37)
#define REG_SC_BK44_37_H      _PK_H_(0x44, 0x37)
#define REG_SC_BK44_38_L      _PK_L_(0x44, 0x38)
#define REG_SC_BK44_38_H      _PK_H_(0x44, 0x38)
#define REG_SC_BK44_39_L      _PK_L_(0x44, 0x39)
#define REG_SC_BK44_39_H      _PK_H_(0x44, 0x39)
#define REG_SC_BK44_3A_L      _PK_L_(0x44, 0x3A)
#define REG_SC_BK44_3A_H      _PK_H_(0x44, 0x3A)
#define REG_SC_BK44_3B_L      _PK_L_(0x44, 0x3B)
#define REG_SC_BK44_3B_H      _PK_H_(0x44, 0x3B)
#define REG_SC_BK44_3C_L      _PK_L_(0x44, 0x3C)
#define REG_SC_BK44_3C_H      _PK_H_(0x44, 0x3C)
#define REG_SC_BK44_3D_L      _PK_L_(0x44, 0x3D)
#define REG_SC_BK44_3D_H      _PK_H_(0x44, 0x3D)
#define REG_SC_BK44_3E_L      _PK_L_(0x44, 0x3E)
#define REG_SC_BK44_3E_H      _PK_H_(0x44, 0x3E)
#define REG_SC_BK44_3F_L      _PK_L_(0x44, 0x3F)
#define REG_SC_BK44_3F_H      _PK_H_(0x44, 0x3F)
#define REG_SC_BK44_40_L      _PK_L_(0x44, 0x40)
#define REG_SC_BK44_40_H      _PK_H_(0x44, 0x40)
#define REG_SC_BK44_41_L      _PK_L_(0x44, 0x41)
#define REG_SC_BK44_41_H      _PK_H_(0x44, 0x41)
#define REG_SC_BK44_42_L      _PK_L_(0x44, 0x42)
#define REG_SC_BK44_42_H      _PK_H_(0x44, 0x42)
#define REG_SC_BK44_43_L      _PK_L_(0x44, 0x43)
#define REG_SC_BK44_43_H      _PK_H_(0x44, 0x43)
#define REG_SC_BK44_44_L      _PK_L_(0x44, 0x44)
#define REG_SC_BK44_44_H      _PK_H_(0x44, 0x44)
#define REG_SC_BK44_45_L      _PK_L_(0x44, 0x45)
#define REG_SC_BK44_45_H      _PK_H_(0x44, 0x45)
#define REG_SC_BK44_46_L      _PK_L_(0x44, 0x46)
#define REG_SC_BK44_46_H      _PK_H_(0x44, 0x46)
#define REG_SC_BK44_47_L      _PK_L_(0x44, 0x47)
#define REG_SC_BK44_47_H      _PK_H_(0x44, 0x47)
#define REG_SC_BK44_48_L      _PK_L_(0x44, 0x48)
#define REG_SC_BK44_48_H      _PK_H_(0x44, 0x48)
#define REG_SC_BK44_49_L      _PK_L_(0x44, 0x49)
#define REG_SC_BK44_49_H      _PK_H_(0x44, 0x49)
#define REG_SC_BK44_4A_L      _PK_L_(0x44, 0x4A)
#define REG_SC_BK44_4A_H      _PK_H_(0x44, 0x4A)
#define REG_SC_BK44_4B_L      _PK_L_(0x44, 0x4B)
#define REG_SC_BK44_4B_H      _PK_H_(0x44, 0x4B)
#define REG_SC_BK44_4C_L      _PK_L_(0x44, 0x4C)
#define REG_SC_BK44_4C_H      _PK_H_(0x44, 0x4C)
#define REG_SC_BK44_4D_L      _PK_L_(0x44, 0x4D)
#define REG_SC_BK44_4D_H      _PK_H_(0x44, 0x4D)
#define REG_SC_BK44_4E_L      _PK_L_(0x44, 0x4E)
#define REG_SC_BK44_4E_H      _PK_H_(0x44, 0x4E)
#define REG_SC_BK44_4F_L      _PK_L_(0x44, 0x4F)
#define REG_SC_BK44_4F_H      _PK_H_(0x44, 0x4F)
#define REG_SC_BK44_50_L      _PK_L_(0x44, 0x50)
#define REG_SC_BK44_50_H      _PK_H_(0x44, 0x50)
#define REG_SC_BK44_51_L      _PK_L_(0x44, 0x51)
#define REG_SC_BK44_51_H      _PK_H_(0x44, 0x51)
#define REG_SC_BK44_52_L      _PK_L_(0x44, 0x52)
#define REG_SC_BK44_52_H      _PK_H_(0x44, 0x52)
#define REG_SC_BK44_53_L      _PK_L_(0x44, 0x53)
#define REG_SC_BK44_53_H      _PK_H_(0x44, 0x53)
#define REG_SC_BK44_54_L      _PK_L_(0x44, 0x54)
#define REG_SC_BK44_54_H      _PK_H_(0x44, 0x54)
#define REG_SC_BK44_55_L      _PK_L_(0x44, 0x55)
#define REG_SC_BK44_55_H      _PK_H_(0x44, 0x55)
#define REG_SC_BK44_56_L      _PK_L_(0x44, 0x56)
#define REG_SC_BK44_56_H      _PK_H_(0x44, 0x56)
#define REG_SC_BK44_57_L      _PK_L_(0x44, 0x57)
#define REG_SC_BK44_57_H      _PK_H_(0x44, 0x57)
#define REG_SC_BK44_58_L      _PK_L_(0x44, 0x58)
#define REG_SC_BK44_58_H      _PK_H_(0x44, 0x58)
#define REG_SC_BK44_59_L      _PK_L_(0x44, 0x59)
#define REG_SC_BK44_59_H      _PK_H_(0x44, 0x59)
#define REG_SC_BK44_5A_L      _PK_L_(0x44, 0x5A)
#define REG_SC_BK44_5A_H      _PK_H_(0x44, 0x5A)
#define REG_SC_BK44_5B_L      _PK_L_(0x44, 0x5B)
#define REG_SC_BK44_5B_H      _PK_H_(0x44, 0x5B)
#define REG_SC_BK44_5C_L      _PK_L_(0x44, 0x5C)
#define REG_SC_BK44_5C_H      _PK_H_(0x44, 0x5C)
#define REG_SC_BK44_5D_L      _PK_L_(0x44, 0x5D)
#define REG_SC_BK44_5D_H      _PK_H_(0x44, 0x5D)
#define REG_SC_BK44_5E_L      _PK_L_(0x44, 0x5E)
#define REG_SC_BK44_5E_H      _PK_H_(0x44, 0x5E)
#define REG_SC_BK44_5F_L      _PK_L_(0x44, 0x5F)
#define REG_SC_BK44_5F_H      _PK_H_(0x44, 0x5F)
#define REG_SC_BK44_60_L      _PK_L_(0x44, 0x60)
#define REG_SC_BK44_60_H      _PK_H_(0x44, 0x60)
#define REG_SC_BK44_61_L      _PK_L_(0x44, 0x61)
#define REG_SC_BK44_61_H      _PK_H_(0x44, 0x61)
#define REG_SC_BK44_62_L      _PK_L_(0x44, 0x62)
#define REG_SC_BK44_62_H      _PK_H_(0x44, 0x62)
#define REG_SC_BK44_63_L      _PK_L_(0x44, 0x63)
#define REG_SC_BK44_63_H      _PK_H_(0x44, 0x63)
#define REG_SC_BK44_64_L      _PK_L_(0x44, 0x64)
#define REG_SC_BK44_64_H      _PK_H_(0x44, 0x64)
#define REG_SC_BK44_65_L      _PK_L_(0x44, 0x65)
#define REG_SC_BK44_65_H      _PK_H_(0x44, 0x65)
#define REG_SC_BK44_66_L      _PK_L_(0x44, 0x66)
#define REG_SC_BK44_66_H      _PK_H_(0x44, 0x66)
#define REG_SC_BK44_67_L      _PK_L_(0x44, 0x67)
#define REG_SC_BK44_67_H      _PK_H_(0x44, 0x67)
#define REG_SC_BK44_68_L      _PK_L_(0x44, 0x68)
#define REG_SC_BK44_68_H      _PK_H_(0x44, 0x68)
#define REG_SC_BK44_69_L      _PK_L_(0x44, 0x69)
#define REG_SC_BK44_69_H      _PK_H_(0x44, 0x69)
#define REG_SC_BK44_6A_L      _PK_L_(0x44, 0x6A)
#define REG_SC_BK44_6A_H      _PK_H_(0x44, 0x6A)
#define REG_SC_BK44_6B_L      _PK_L_(0x44, 0x6B)
#define REG_SC_BK44_6B_H      _PK_H_(0x44, 0x6B)
#define REG_SC_BK44_6C_L      _PK_L_(0x44, 0x6C)
#define REG_SC_BK44_6C_H      _PK_H_(0x44, 0x6C)
#define REG_SC_BK44_6D_L      _PK_L_(0x44, 0x6D)
#define REG_SC_BK44_6D_H      _PK_H_(0x44, 0x6D)
#define REG_SC_BK44_6E_L      _PK_L_(0x44, 0x6E)
#define REG_SC_BK44_6E_H      _PK_H_(0x44, 0x6E)
#define REG_SC_BK44_6F_L      _PK_L_(0x44, 0x6F)
#define REG_SC_BK44_6F_H      _PK_H_(0x44, 0x6F)
#define REG_SC_BK44_70_L      _PK_L_(0x44, 0x70)
#define REG_SC_BK44_70_H      _PK_H_(0x44, 0x70)
#define REG_SC_BK44_71_L      _PK_L_(0x44, 0x71)
#define REG_SC_BK44_71_H      _PK_H_(0x44, 0x71)
#define REG_SC_BK44_72_L      _PK_L_(0x44, 0x72)
#define REG_SC_BK44_72_H      _PK_H_(0x44, 0x72)
#define REG_SC_BK44_73_L      _PK_L_(0x44, 0x73)
#define REG_SC_BK44_73_H      _PK_H_(0x44, 0x73)
#define REG_SC_BK44_74_L      _PK_L_(0x44, 0x74)
#define REG_SC_BK44_74_H      _PK_H_(0x44, 0x74)
#define REG_SC_BK44_75_L      _PK_L_(0x44, 0x75)
#define REG_SC_BK44_75_H      _PK_H_(0x44, 0x75)
#define REG_SC_BK44_76_L      _PK_L_(0x44, 0x76)
#define REG_SC_BK44_76_H      _PK_H_(0x44, 0x76)
#define REG_SC_BK44_77_L      _PK_L_(0x44, 0x77)
#define REG_SC_BK44_77_H      _PK_H_(0x44, 0x77)
#define REG_SC_BK44_78_L      _PK_L_(0x44, 0x78)
#define REG_SC_BK44_78_H      _PK_H_(0x44, 0x78)
#define REG_SC_BK44_79_L      _PK_L_(0x44, 0x79)
#define REG_SC_BK44_79_H      _PK_H_(0x44, 0x79)
#define REG_SC_BK44_7A_L      _PK_L_(0x44, 0x7A)
#define REG_SC_BK44_7A_H      _PK_H_(0x44, 0x7A)
#define REG_SC_BK44_7B_L      _PK_L_(0x44, 0x7B)
#define REG_SC_BK44_7B_H      _PK_H_(0x44, 0x7B)
#define REG_SC_BK44_7C_L      _PK_L_(0x44, 0x7C)
#define REG_SC_BK44_7C_H      _PK_H_(0x44, 0x7C)
#define REG_SC_BK44_7D_L      _PK_L_(0x44, 0x7D)
#define REG_SC_BK44_7D_H      _PK_H_(0x44, 0x7D)
#define REG_SC_BK44_7E_L      _PK_L_(0x44, 0x7E)
#define REG_SC_BK44_7E_H      _PK_H_(0x44, 0x7E)
#define REG_SC_BK44_7F_L      _PK_L_(0x44, 0x7F)
#define REG_SC_BK44_7F_H      _PK_H_(0x44, 0x7F)

//----------------------------------------------
//  BK45: FRC OP2
//----------------------------------------------
#define REG_SC_BK45_00_L      _PK_L_(0x45, 0x00)
#define REG_SC_BK45_00_H      _PK_H_(0x45, 0x00)
#define REG_SC_BK45_01_L      _PK_L_(0x45, 0x01)
#define REG_SC_BK45_01_H      _PK_H_(0x45, 0x01)
#define REG_SC_BK45_02_L      _PK_L_(0x45, 0x02)
#define REG_SC_BK45_02_H      _PK_H_(0x45, 0x02)
#define REG_SC_BK45_03_L      _PK_L_(0x45, 0x03)
#define REG_SC_BK45_03_H      _PK_H_(0x45, 0x03)
#define REG_SC_BK45_04_L      _PK_L_(0x45, 0x04)
#define REG_SC_BK45_04_H      _PK_H_(0x45, 0x04)
#define REG_SC_BK45_05_L      _PK_L_(0x45, 0x05)
#define REG_SC_BK45_05_H      _PK_H_(0x45, 0x05)
#define REG_SC_BK45_06_L      _PK_L_(0x45, 0x06)
#define REG_SC_BK45_06_H      _PK_H_(0x45, 0x06)
#define REG_SC_BK45_07_L      _PK_L_(0x45, 0x07)
#define REG_SC_BK45_07_H      _PK_H_(0x45, 0x07)
#define REG_SC_BK45_08_L      _PK_L_(0x45, 0x08)
#define REG_SC_BK45_08_H      _PK_H_(0x45, 0x08)
#define REG_SC_BK45_09_L      _PK_L_(0x45, 0x09)
#define REG_SC_BK45_09_H      _PK_H_(0x45, 0x09)
#define REG_SC_BK45_0A_L      _PK_L_(0x45, 0x0A)
#define REG_SC_BK45_0A_H      _PK_H_(0x45, 0x0A)
#define REG_SC_BK45_0B_L      _PK_L_(0x45, 0x0B)
#define REG_SC_BK45_0B_H      _PK_H_(0x45, 0x0B)
#define REG_SC_BK45_0C_L      _PK_L_(0x45, 0x0C)
#define REG_SC_BK45_0C_H      _PK_H_(0x45, 0x0C)
#define REG_SC_BK45_0D_L      _PK_L_(0x45, 0x0D)
#define REG_SC_BK45_0D_H      _PK_H_(0x45, 0x0D)
#define REG_SC_BK45_0E_L      _PK_L_(0x45, 0x0E)
#define REG_SC_BK45_0E_H      _PK_H_(0x45, 0x0E)
#define REG_SC_BK45_0F_L      _PK_L_(0x45, 0x0F)
#define REG_SC_BK45_0F_H      _PK_H_(0x45, 0x0F)
#define REG_SC_BK45_10_L      _PK_L_(0x45, 0x10)
#define REG_SC_BK45_10_H      _PK_H_(0x45, 0x10)
#define REG_SC_BK45_11_L      _PK_L_(0x45, 0x11)
#define REG_SC_BK45_11_H      _PK_H_(0x45, 0x11)
#define REG_SC_BK45_12_L      _PK_L_(0x45, 0x12)
#define REG_SC_BK45_12_H      _PK_H_(0x45, 0x12)
#define REG_SC_BK45_13_L      _PK_L_(0x45, 0x13)
#define REG_SC_BK45_13_H      _PK_H_(0x45, 0x13)
#define REG_SC_BK45_14_L      _PK_L_(0x45, 0x14)
#define REG_SC_BK45_14_H      _PK_H_(0x45, 0x14)
#define REG_SC_BK45_15_L      _PK_L_(0x45, 0x15)
#define REG_SC_BK45_15_H      _PK_H_(0x45, 0x15)
#define REG_SC_BK45_16_L      _PK_L_(0x45, 0x16)
#define REG_SC_BK45_16_H      _PK_H_(0x45, 0x16)
#define REG_SC_BK45_17_L      _PK_L_(0x45, 0x17)
#define REG_SC_BK45_17_H      _PK_H_(0x45, 0x17)
#define REG_SC_BK45_18_L      _PK_L_(0x45, 0x18)
#define REG_SC_BK45_18_H      _PK_H_(0x45, 0x18)
#define REG_SC_BK45_19_L      _PK_L_(0x45, 0x19)
#define REG_SC_BK45_19_H      _PK_H_(0x45, 0x19)
#define REG_SC_BK45_1A_L      _PK_L_(0x45, 0x1A)
#define REG_SC_BK45_1A_H      _PK_H_(0x45, 0x1A)
#define REG_SC_BK45_1B_L      _PK_L_(0x45, 0x1B)
#define REG_SC_BK45_1B_H      _PK_H_(0x45, 0x1B)
#define REG_SC_BK45_1C_L      _PK_L_(0x45, 0x1C)
#define REG_SC_BK45_1C_H      _PK_H_(0x45, 0x1C)
#define REG_SC_BK45_1D_L      _PK_L_(0x45, 0x1D)
#define REG_SC_BK45_1D_H      _PK_H_(0x45, 0x1D)
#define REG_SC_BK45_1E_L      _PK_L_(0x45, 0x1E)
#define REG_SC_BK45_1E_H      _PK_H_(0x45, 0x1E)
#define REG_SC_BK45_1F_L      _PK_L_(0x45, 0x1F)
#define REG_SC_BK45_1F_H      _PK_H_(0x45, 0x1F)
#define REG_SC_BK45_20_L      _PK_L_(0x45, 0x20)
#define REG_SC_BK45_20_H      _PK_H_(0x45, 0x20)
#define REG_SC_BK45_21_L      _PK_L_(0x45, 0x21)
#define REG_SC_BK45_21_H      _PK_H_(0x45, 0x21)
#define REG_SC_BK45_22_L      _PK_L_(0x45, 0x22)
#define REG_SC_BK45_22_H      _PK_H_(0x45, 0x22)
#define REG_SC_BK45_23_L      _PK_L_(0x45, 0x23)
#define REG_SC_BK45_23_H      _PK_H_(0x45, 0x23)
#define REG_SC_BK45_24_L      _PK_L_(0x45, 0x24)
#define REG_SC_BK45_24_H      _PK_H_(0x45, 0x24)
#define REG_SC_BK45_25_L      _PK_L_(0x45, 0x25)
#define REG_SC_BK45_25_H      _PK_H_(0x45, 0x25)
#define REG_SC_BK45_26_L      _PK_L_(0x45, 0x26)
#define REG_SC_BK45_26_H      _PK_H_(0x45, 0x26)
#define REG_SC_BK45_27_L      _PK_L_(0x45, 0x27)
#define REG_SC_BK45_27_H      _PK_H_(0x45, 0x27)
#define REG_SC_BK45_28_L      _PK_L_(0x45, 0x28)
#define REG_SC_BK45_28_H      _PK_H_(0x45, 0x28)
#define REG_SC_BK45_29_L      _PK_L_(0x45, 0x29)
#define REG_SC_BK45_29_H      _PK_H_(0x45, 0x29)
#define REG_SC_BK45_2A_L      _PK_L_(0x45, 0x2A)
#define REG_SC_BK45_2A_H      _PK_H_(0x45, 0x2A)
#define REG_SC_BK45_2B_L      _PK_L_(0x45, 0x2B)
#define REG_SC_BK45_2B_H      _PK_H_(0x45, 0x2B)
#define REG_SC_BK45_2C_L      _PK_L_(0x45, 0x2C)
#define REG_SC_BK45_2C_H      _PK_H_(0x45, 0x2C)
#define REG_SC_BK45_2D_L      _PK_L_(0x45, 0x2D)
#define REG_SC_BK45_2D_H      _PK_H_(0x45, 0x2D)
#define REG_SC_BK45_2E_L      _PK_L_(0x45, 0x2E)
#define REG_SC_BK45_2E_H      _PK_H_(0x45, 0x2E)
#define REG_SC_BK45_2F_L      _PK_L_(0x45, 0x2F)
#define REG_SC_BK45_2F_H      _PK_H_(0x45, 0x2F)
#define REG_SC_BK45_30_L      _PK_L_(0x45, 0x30)
#define REG_SC_BK45_30_H      _PK_H_(0x45, 0x30)
#define REG_SC_BK45_31_L      _PK_L_(0x45, 0x31)
#define REG_SC_BK45_31_H      _PK_H_(0x45, 0x31)
#define REG_SC_BK45_32_L      _PK_L_(0x45, 0x32)
#define REG_SC_BK45_32_H      _PK_H_(0x45, 0x32)
#define REG_SC_BK45_33_L      _PK_L_(0x45, 0x33)
#define REG_SC_BK45_33_H      _PK_H_(0x45, 0x33)
#define REG_SC_BK45_34_L      _PK_L_(0x45, 0x34)
#define REG_SC_BK45_34_H      _PK_H_(0x45, 0x34)
#define REG_SC_BK45_35_L      _PK_L_(0x45, 0x35)
#define REG_SC_BK45_35_H      _PK_H_(0x45, 0x35)
#define REG_SC_BK45_36_L      _PK_L_(0x45, 0x36)
#define REG_SC_BK45_36_H      _PK_H_(0x45, 0x36)
#define REG_SC_BK45_37_L      _PK_L_(0x45, 0x37)
#define REG_SC_BK45_37_H      _PK_H_(0x45, 0x37)
#define REG_SC_BK45_38_L      _PK_L_(0x45, 0x38)
#define REG_SC_BK45_38_H      _PK_H_(0x45, 0x38)
#define REG_SC_BK45_39_L      _PK_L_(0x45, 0x39)
#define REG_SC_BK45_39_H      _PK_H_(0x45, 0x39)
#define REG_SC_BK45_3A_L      _PK_L_(0x45, 0x3A)
#define REG_SC_BK45_3A_H      _PK_H_(0x45, 0x3A)
#define REG_SC_BK45_3B_L      _PK_L_(0x45, 0x3B)
#define REG_SC_BK45_3B_H      _PK_H_(0x45, 0x3B)
#define REG_SC_BK45_3C_L      _PK_L_(0x45, 0x3C)
#define REG_SC_BK45_3C_H      _PK_H_(0x45, 0x3C)
#define REG_SC_BK45_3D_L      _PK_L_(0x45, 0x3D)
#define REG_SC_BK45_3D_H      _PK_H_(0x45, 0x3D)
#define REG_SC_BK45_3E_L      _PK_L_(0x45, 0x3E)
#define REG_SC_BK45_3E_H      _PK_H_(0x45, 0x3E)
#define REG_SC_BK45_3F_L      _PK_L_(0x45, 0x3F)
#define REG_SC_BK45_3F_H      _PK_H_(0x45, 0x3F)
#define REG_SC_BK45_40_L      _PK_L_(0x45, 0x40)
#define REG_SC_BK45_40_H      _PK_H_(0x45, 0x40)
#define REG_SC_BK45_41_L      _PK_L_(0x45, 0x41)
#define REG_SC_BK45_41_H      _PK_H_(0x45, 0x41)
#define REG_SC_BK45_42_L      _PK_L_(0x45, 0x42)
#define REG_SC_BK45_42_H      _PK_H_(0x45, 0x42)
#define REG_SC_BK45_43_L      _PK_L_(0x45, 0x43)
#define REG_SC_BK45_43_H      _PK_H_(0x45, 0x43)
#define REG_SC_BK45_44_L      _PK_L_(0x45, 0x44)
#define REG_SC_BK45_44_H      _PK_H_(0x45, 0x44)
#define REG_SC_BK45_45_L      _PK_L_(0x45, 0x45)
#define REG_SC_BK45_45_H      _PK_H_(0x45, 0x45)
#define REG_SC_BK45_46_L      _PK_L_(0x45, 0x46)
#define REG_SC_BK45_46_H      _PK_H_(0x45, 0x46)
#define REG_SC_BK45_47_L      _PK_L_(0x45, 0x47)
#define REG_SC_BK45_47_H      _PK_H_(0x45, 0x47)
#define REG_SC_BK45_48_L      _PK_L_(0x45, 0x48)
#define REG_SC_BK45_48_H      _PK_H_(0x45, 0x48)
#define REG_SC_BK45_49_L      _PK_L_(0x45, 0x49)
#define REG_SC_BK45_49_H      _PK_H_(0x45, 0x49)
#define REG_SC_BK45_4A_L      _PK_L_(0x45, 0x4A)
#define REG_SC_BK45_4A_H      _PK_H_(0x45, 0x4A)
#define REG_SC_BK45_4B_L      _PK_L_(0x45, 0x4B)
#define REG_SC_BK45_4B_H      _PK_H_(0x45, 0x4B)
#define REG_SC_BK45_4C_L      _PK_L_(0x45, 0x4C)
#define REG_SC_BK45_4C_H      _PK_H_(0x45, 0x4C)
#define REG_SC_BK45_4D_L      _PK_L_(0x45, 0x4D)
#define REG_SC_BK45_4D_H      _PK_H_(0x45, 0x4D)
#define REG_SC_BK45_4E_L      _PK_L_(0x45, 0x4E)
#define REG_SC_BK45_4E_H      _PK_H_(0x45, 0x4E)
#define REG_SC_BK45_4F_L      _PK_L_(0x45, 0x4F)
#define REG_SC_BK45_4F_H      _PK_H_(0x45, 0x4F)
#define REG_SC_BK45_50_L      _PK_L_(0x45, 0x50)
#define REG_SC_BK45_50_H      _PK_H_(0x45, 0x50)
#define REG_SC_BK45_51_L      _PK_L_(0x45, 0x51)
#define REG_SC_BK45_51_H      _PK_H_(0x45, 0x51)
#define REG_SC_BK45_52_L      _PK_L_(0x45, 0x52)
#define REG_SC_BK45_52_H      _PK_H_(0x45, 0x52)
#define REG_SC_BK45_53_L      _PK_L_(0x45, 0x53)
#define REG_SC_BK45_53_H      _PK_H_(0x45, 0x53)
#define REG_SC_BK45_54_L      _PK_L_(0x45, 0x54)
#define REG_SC_BK45_54_H      _PK_H_(0x45, 0x54)
#define REG_SC_BK45_55_L      _PK_L_(0x45, 0x55)
#define REG_SC_BK45_55_H      _PK_H_(0x45, 0x55)
#define REG_SC_BK45_56_L      _PK_L_(0x45, 0x56)
#define REG_SC_BK45_56_H      _PK_H_(0x45, 0x56)
#define REG_SC_BK45_57_L      _PK_L_(0x45, 0x57)
#define REG_SC_BK45_57_H      _PK_H_(0x45, 0x57)
#define REG_SC_BK45_58_L      _PK_L_(0x45, 0x58)
#define REG_SC_BK45_58_H      _PK_H_(0x45, 0x58)
#define REG_SC_BK45_59_L      _PK_L_(0x45, 0x59)
#define REG_SC_BK45_59_H      _PK_H_(0x45, 0x59)
#define REG_SC_BK45_5A_L      _PK_L_(0x45, 0x5A)
#define REG_SC_BK45_5A_H      _PK_H_(0x45, 0x5A)
#define REG_SC_BK45_5B_L      _PK_L_(0x45, 0x5B)
#define REG_SC_BK45_5B_H      _PK_H_(0x45, 0x5B)
#define REG_SC_BK45_5C_L      _PK_L_(0x45, 0x5C)
#define REG_SC_BK45_5C_H      _PK_H_(0x45, 0x5C)
#define REG_SC_BK45_5D_L      _PK_L_(0x45, 0x5D)
#define REG_SC_BK45_5D_H      _PK_H_(0x45, 0x5D)
#define REG_SC_BK45_5E_L      _PK_L_(0x45, 0x5E)
#define REG_SC_BK45_5E_H      _PK_H_(0x45, 0x5E)
#define REG_SC_BK45_5F_L      _PK_L_(0x45, 0x5F)
#define REG_SC_BK45_5F_H      _PK_H_(0x45, 0x5F)
#define REG_SC_BK45_60_L      _PK_L_(0x45, 0x60)
#define REG_SC_BK45_60_H      _PK_H_(0x45, 0x60)
#define REG_SC_BK45_61_L      _PK_L_(0x45, 0x61)
#define REG_SC_BK45_61_H      _PK_H_(0x45, 0x61)
#define REG_SC_BK45_62_L      _PK_L_(0x45, 0x62)
#define REG_SC_BK45_62_H      _PK_H_(0x45, 0x62)
#define REG_SC_BK45_63_L      _PK_L_(0x45, 0x63)
#define REG_SC_BK45_63_H      _PK_H_(0x45, 0x63)
#define REG_SC_BK45_64_L      _PK_L_(0x45, 0x64)
#define REG_SC_BK45_64_H      _PK_H_(0x45, 0x64)
#define REG_SC_BK45_65_L      _PK_L_(0x45, 0x65)
#define REG_SC_BK45_65_H      _PK_H_(0x45, 0x65)
#define REG_SC_BK45_66_L      _PK_L_(0x45, 0x66)
#define REG_SC_BK45_66_H      _PK_H_(0x45, 0x66)
#define REG_SC_BK45_67_L      _PK_L_(0x45, 0x67)
#define REG_SC_BK45_67_H      _PK_H_(0x45, 0x67)
#define REG_SC_BK45_68_L      _PK_L_(0x45, 0x68)
#define REG_SC_BK45_68_H      _PK_H_(0x45, 0x68)
#define REG_SC_BK45_69_L      _PK_L_(0x45, 0x69)
#define REG_SC_BK45_69_H      _PK_H_(0x45, 0x69)
#define REG_SC_BK45_6A_L      _PK_L_(0x45, 0x6A)
#define REG_SC_BK45_6A_H      _PK_H_(0x45, 0x6A)
#define REG_SC_BK45_6B_L      _PK_L_(0x45, 0x6B)
#define REG_SC_BK45_6B_H      _PK_H_(0x45, 0x6B)
#define REG_SC_BK45_6C_L      _PK_L_(0x45, 0x6C)
#define REG_SC_BK45_6C_H      _PK_H_(0x45, 0x6C)
#define REG_SC_BK45_6D_L      _PK_L_(0x45, 0x6D)
#define REG_SC_BK45_6D_H      _PK_H_(0x45, 0x6D)
#define REG_SC_BK45_6E_L      _PK_L_(0x45, 0x6E)
#define REG_SC_BK45_6E_H      _PK_H_(0x45, 0x6E)
#define REG_SC_BK45_6F_L      _PK_L_(0x45, 0x6F)
#define REG_SC_BK45_6F_H      _PK_H_(0x45, 0x6F)
#define REG_SC_BK45_70_L      _PK_L_(0x45, 0x70)
#define REG_SC_BK45_70_H      _PK_H_(0x45, 0x70)
#define REG_SC_BK45_71_L      _PK_L_(0x45, 0x71)
#define REG_SC_BK45_71_H      _PK_H_(0x45, 0x71)
#define REG_SC_BK45_72_L      _PK_L_(0x45, 0x72)
#define REG_SC_BK45_72_H      _PK_H_(0x45, 0x72)
#define REG_SC_BK45_73_L      _PK_L_(0x45, 0x73)
#define REG_SC_BK45_73_H      _PK_H_(0x45, 0x73)
#define REG_SC_BK45_74_L      _PK_L_(0x45, 0x74)
#define REG_SC_BK45_74_H      _PK_H_(0x45, 0x74)
#define REG_SC_BK45_75_L      _PK_L_(0x45, 0x75)
#define REG_SC_BK45_75_H      _PK_H_(0x45, 0x75)
#define REG_SC_BK45_76_L      _PK_L_(0x45, 0x76)
#define REG_SC_BK45_76_H      _PK_H_(0x45, 0x76)
#define REG_SC_BK45_77_L      _PK_L_(0x45, 0x77)
#define REG_SC_BK45_77_H      _PK_H_(0x45, 0x77)
#define REG_SC_BK45_78_L      _PK_L_(0x45, 0x78)
#define REG_SC_BK45_78_H      _PK_H_(0x45, 0x78)
#define REG_SC_BK45_79_L      _PK_L_(0x45, 0x79)
#define REG_SC_BK45_79_H      _PK_H_(0x45, 0x79)
#define REG_SC_BK45_7A_L      _PK_L_(0x45, 0x7A)
#define REG_SC_BK45_7A_H      _PK_H_(0x45, 0x7A)
#define REG_SC_BK45_7B_L      _PK_L_(0x45, 0x7B)
#define REG_SC_BK45_7B_H      _PK_H_(0x45, 0x7B)
#define REG_SC_BK45_7C_L      _PK_L_(0x45, 0x7C)
#define REG_SC_BK45_7C_H      _PK_H_(0x45, 0x7C)
#define REG_SC_BK45_7D_L      _PK_L_(0x45, 0x7D)
#define REG_SC_BK45_7D_H      _PK_H_(0x45, 0x7D)
#define REG_SC_BK45_7E_L      _PK_L_(0x45, 0x7E)
#define REG_SC_BK45_7E_H      _PK_H_(0x45, 0x7E)
#define REG_SC_BK45_7F_L      _PK_L_(0x45, 0x7F)
#define REG_SC_BK45_7F_H      _PK_H_(0x45, 0x7F)

//----------------------------------------------
//  BK46: FRC TGEN
//----------------------------------------------
#define REG_SC_BK46_00_L      _PK_L_(0x46, 0x00)
#define REG_SC_BK46_00_H      _PK_H_(0x46, 0x00)
#define REG_SC_BK46_01_L      _PK_L_(0x46, 0x01)
#define REG_SC_BK46_01_H      _PK_H_(0x46, 0x01)
#define REG_SC_BK46_02_L      _PK_L_(0x46, 0x02)
#define REG_SC_BK46_02_H      _PK_H_(0x46, 0x02)
#define REG_SC_BK46_03_L      _PK_L_(0x46, 0x03)
#define REG_SC_BK46_03_H      _PK_H_(0x46, 0x03)
#define REG_SC_BK46_04_L      _PK_L_(0x46, 0x04)
#define REG_SC_BK46_04_H      _PK_H_(0x46, 0x04)
#define REG_SC_BK46_05_L      _PK_L_(0x46, 0x05)
#define REG_SC_BK46_05_H      _PK_H_(0x46, 0x05)
#define REG_SC_BK46_06_L      _PK_L_(0x46, 0x06)
#define REG_SC_BK46_06_H      _PK_H_(0x46, 0x06)
#define REG_SC_BK46_07_L      _PK_L_(0x46, 0x07)
#define REG_SC_BK46_07_H      _PK_H_(0x46, 0x07)
#define REG_SC_BK46_08_L      _PK_L_(0x46, 0x08)
#define REG_SC_BK46_08_H      _PK_H_(0x46, 0x08)
#define REG_SC_BK46_09_L      _PK_L_(0x46, 0x09)
#define REG_SC_BK46_09_H      _PK_H_(0x46, 0x09)
#define REG_SC_BK46_0A_L      _PK_L_(0x46, 0x0A)
#define REG_SC_BK46_0A_H      _PK_H_(0x46, 0x0A)
#define REG_SC_BK46_0B_L      _PK_L_(0x46, 0x0B)
#define REG_SC_BK46_0B_H      _PK_H_(0x46, 0x0B)
#define REG_SC_BK46_0C_L      _PK_L_(0x46, 0x0C)
#define REG_SC_BK46_0C_H      _PK_H_(0x46, 0x0C)
#define REG_SC_BK46_0D_L      _PK_L_(0x46, 0x0D)
#define REG_SC_BK46_0D_H      _PK_H_(0x46, 0x0D)
#define REG_SC_BK46_0E_L      _PK_L_(0x46, 0x0E)
#define REG_SC_BK46_0E_H      _PK_H_(0x46, 0x0E)
#define REG_SC_BK46_0F_L      _PK_L_(0x46, 0x0F)
#define REG_SC_BK46_0F_H      _PK_H_(0x46, 0x0F)
#define REG_SC_BK46_10_L      _PK_L_(0x46, 0x10)
#define REG_SC_BK46_10_H      _PK_H_(0x46, 0x10)
#define REG_SC_BK46_11_L      _PK_L_(0x46, 0x11)
#define REG_SC_BK46_11_H      _PK_H_(0x46, 0x11)
#define REG_SC_BK46_12_L      _PK_L_(0x46, 0x12)
#define REG_SC_BK46_12_H      _PK_H_(0x46, 0x12)
#define REG_SC_BK46_13_L      _PK_L_(0x46, 0x13)
#define REG_SC_BK46_13_H      _PK_H_(0x46, 0x13)
#define REG_SC_BK46_14_L      _PK_L_(0x46, 0x14)
#define REG_SC_BK46_14_H      _PK_H_(0x46, 0x14)
#define REG_SC_BK46_15_L      _PK_L_(0x46, 0x15)
#define REG_SC_BK46_15_H      _PK_H_(0x46, 0x15)
#define REG_SC_BK46_16_L      _PK_L_(0x46, 0x16)
#define REG_SC_BK46_16_H      _PK_H_(0x46, 0x16)
#define REG_SC_BK46_17_L      _PK_L_(0x46, 0x17)
#define REG_SC_BK46_17_H      _PK_H_(0x46, 0x17)
#define REG_SC_BK46_18_L      _PK_L_(0x46, 0x18)
#define REG_SC_BK46_18_H      _PK_H_(0x46, 0x18)
#define REG_SC_BK46_19_L      _PK_L_(0x46, 0x19)
#define REG_SC_BK46_19_H      _PK_H_(0x46, 0x19)
#define REG_SC_BK46_1A_L      _PK_L_(0x46, 0x1A)
#define REG_SC_BK46_1A_H      _PK_H_(0x46, 0x1A)
#define REG_SC_BK46_1B_L      _PK_L_(0x46, 0x1B)
#define REG_SC_BK46_1B_H      _PK_H_(0x46, 0x1B)
#define REG_SC_BK46_1C_L      _PK_L_(0x46, 0x1C)
#define REG_SC_BK46_1C_H      _PK_H_(0x46, 0x1C)
#define REG_SC_BK46_1D_L      _PK_L_(0x46, 0x1D)
#define REG_SC_BK46_1D_H      _PK_H_(0x46, 0x1D)
#define REG_SC_BK46_1E_L      _PK_L_(0x46, 0x1E)
#define REG_SC_BK46_1E_H      _PK_H_(0x46, 0x1E)
#define REG_SC_BK46_1F_L      _PK_L_(0x46, 0x1F)
#define REG_SC_BK46_1F_H      _PK_H_(0x46, 0x1F)
#define REG_SC_BK46_20_L      _PK_L_(0x46, 0x20)
#define REG_SC_BK46_20_H      _PK_H_(0x46, 0x20)
#define REG_SC_BK46_21_L      _PK_L_(0x46, 0x21)
#define REG_SC_BK46_21_H      _PK_H_(0x46, 0x21)
#define REG_SC_BK46_22_L      _PK_L_(0x46, 0x22)
#define REG_SC_BK46_22_H      _PK_H_(0x46, 0x22)
#define REG_SC_BK46_23_L      _PK_L_(0x46, 0x23)
#define REG_SC_BK46_23_H      _PK_H_(0x46, 0x23)
#define REG_SC_BK46_24_L      _PK_L_(0x46, 0x24)
#define REG_SC_BK46_24_H      _PK_H_(0x46, 0x24)
#define REG_SC_BK46_25_L      _PK_L_(0x46, 0x25)
#define REG_SC_BK46_25_H      _PK_H_(0x46, 0x25)
#define REG_SC_BK46_26_L      _PK_L_(0x46, 0x26)
#define REG_SC_BK46_26_H      _PK_H_(0x46, 0x26)
#define REG_SC_BK46_27_L      _PK_L_(0x46, 0x27)
#define REG_SC_BK46_27_H      _PK_H_(0x46, 0x27)
#define REG_SC_BK46_28_L      _PK_L_(0x46, 0x28)
#define REG_SC_BK46_28_H      _PK_H_(0x46, 0x28)
#define REG_SC_BK46_29_L      _PK_L_(0x46, 0x29)
#define REG_SC_BK46_29_H      _PK_H_(0x46, 0x29)
#define REG_SC_BK46_2A_L      _PK_L_(0x46, 0x2A)
#define REG_SC_BK46_2A_H      _PK_H_(0x46, 0x2A)
#define REG_SC_BK46_2B_L      _PK_L_(0x46, 0x2B)
#define REG_SC_BK46_2B_H      _PK_H_(0x46, 0x2B)
#define REG_SC_BK46_2C_L      _PK_L_(0x46, 0x2C)
#define REG_SC_BK46_2C_H      _PK_H_(0x46, 0x2C)
#define REG_SC_BK46_2D_L      _PK_L_(0x46, 0x2D)
#define REG_SC_BK46_2D_H      _PK_H_(0x46, 0x2D)
#define REG_SC_BK46_2E_L      _PK_L_(0x46, 0x2E)
#define REG_SC_BK46_2E_H      _PK_H_(0x46, 0x2E)
#define REG_SC_BK46_2F_L      _PK_L_(0x46, 0x2F)
#define REG_SC_BK46_2F_H      _PK_H_(0x46, 0x2F)
#define REG_SC_BK46_30_L      _PK_L_(0x46, 0x30)
#define REG_SC_BK46_30_H      _PK_H_(0x46, 0x30)
#define REG_SC_BK46_31_L      _PK_L_(0x46, 0x31)
#define REG_SC_BK46_31_H      _PK_H_(0x46, 0x31)
#define REG_SC_BK46_32_L      _PK_L_(0x46, 0x32)
#define REG_SC_BK46_32_H      _PK_H_(0x46, 0x32)
#define REG_SC_BK46_33_L      _PK_L_(0x46, 0x33)
#define REG_SC_BK46_33_H      _PK_H_(0x46, 0x33)
#define REG_SC_BK46_34_L      _PK_L_(0x46, 0x34)
#define REG_SC_BK46_34_H      _PK_H_(0x46, 0x34)
#define REG_SC_BK46_35_L      _PK_L_(0x46, 0x35)
#define REG_SC_BK46_35_H      _PK_H_(0x46, 0x35)
#define REG_SC_BK46_36_L      _PK_L_(0x46, 0x36)
#define REG_SC_BK46_36_H      _PK_H_(0x46, 0x36)
#define REG_SC_BK46_37_L      _PK_L_(0x46, 0x37)
#define REG_SC_BK46_37_H      _PK_H_(0x46, 0x37)
#define REG_SC_BK46_38_L      _PK_L_(0x46, 0x38)
#define REG_SC_BK46_38_H      _PK_H_(0x46, 0x38)
#define REG_SC_BK46_39_L      _PK_L_(0x46, 0x39)
#define REG_SC_BK46_39_H      _PK_H_(0x46, 0x39)
#define REG_SC_BK46_3A_L      _PK_L_(0x46, 0x3A)
#define REG_SC_BK46_3A_H      _PK_H_(0x46, 0x3A)
#define REG_SC_BK46_3B_L      _PK_L_(0x46, 0x3B)
#define REG_SC_BK46_3B_H      _PK_H_(0x46, 0x3B)
#define REG_SC_BK46_3C_L      _PK_L_(0x46, 0x3C)
#define REG_SC_BK46_3C_H      _PK_H_(0x46, 0x3C)
#define REG_SC_BK46_3D_L      _PK_L_(0x46, 0x3D)
#define REG_SC_BK46_3D_H      _PK_H_(0x46, 0x3D)
#define REG_SC_BK46_3E_L      _PK_L_(0x46, 0x3E)
#define REG_SC_BK46_3E_H      _PK_H_(0x46, 0x3E)
#define REG_SC_BK46_3F_L      _PK_L_(0x46, 0x3F)
#define REG_SC_BK46_3F_H      _PK_H_(0x46, 0x3F)
#define REG_SC_BK46_40_L      _PK_L_(0x46, 0x40)
#define REG_SC_BK46_40_H      _PK_H_(0x46, 0x40)
#define REG_SC_BK46_41_L      _PK_L_(0x46, 0x41)
#define REG_SC_BK46_41_H      _PK_H_(0x46, 0x41)
#define REG_SC_BK46_42_L      _PK_L_(0x46, 0x42)
#define REG_SC_BK46_42_H      _PK_H_(0x46, 0x42)
#define REG_SC_BK46_43_L      _PK_L_(0x46, 0x43)
#define REG_SC_BK46_43_H      _PK_H_(0x46, 0x43)
#define REG_SC_BK46_44_L      _PK_L_(0x46, 0x44)
#define REG_SC_BK46_44_H      _PK_H_(0x46, 0x44)
#define REG_SC_BK46_45_L      _PK_L_(0x46, 0x45)
#define REG_SC_BK46_45_H      _PK_H_(0x46, 0x45)
#define REG_SC_BK46_46_L      _PK_L_(0x46, 0x46)
#define REG_SC_BK46_46_H      _PK_H_(0x46, 0x46)
#define REG_SC_BK46_47_L      _PK_L_(0x46, 0x47)
#define REG_SC_BK46_47_H      _PK_H_(0x46, 0x47)
#define REG_SC_BK46_48_L      _PK_L_(0x46, 0x48)
#define REG_SC_BK46_48_H      _PK_H_(0x46, 0x48)
#define REG_SC_BK46_49_L      _PK_L_(0x46, 0x49)
#define REG_SC_BK46_49_H      _PK_H_(0x46, 0x49)
#define REG_SC_BK46_4A_L      _PK_L_(0x46, 0x4A)
#define REG_SC_BK46_4A_H      _PK_H_(0x46, 0x4A)
#define REG_SC_BK46_4B_L      _PK_L_(0x46, 0x4B)
#define REG_SC_BK46_4B_H      _PK_H_(0x46, 0x4B)
#define REG_SC_BK46_4C_L      _PK_L_(0x46, 0x4C)
#define REG_SC_BK46_4C_H      _PK_H_(0x46, 0x4C)
#define REG_SC_BK46_4D_L      _PK_L_(0x46, 0x4D)
#define REG_SC_BK46_4D_H      _PK_H_(0x46, 0x4D)
#define REG_SC_BK46_4E_L      _PK_L_(0x46, 0x4E)
#define REG_SC_BK46_4E_H      _PK_H_(0x46, 0x4E)
#define REG_SC_BK46_4F_L      _PK_L_(0x46, 0x4F)
#define REG_SC_BK46_4F_H      _PK_H_(0x46, 0x4F)
#define REG_SC_BK46_50_L      _PK_L_(0x46, 0x50)
#define REG_SC_BK46_50_H      _PK_H_(0x46, 0x50)
#define REG_SC_BK46_51_L      _PK_L_(0x46, 0x51)
#define REG_SC_BK46_51_H      _PK_H_(0x46, 0x51)
#define REG_SC_BK46_52_L      _PK_L_(0x46, 0x52)
#define REG_SC_BK46_52_H      _PK_H_(0x46, 0x52)
#define REG_SC_BK46_53_L      _PK_L_(0x46, 0x53)
#define REG_SC_BK46_53_H      _PK_H_(0x46, 0x53)
#define REG_SC_BK46_54_L      _PK_L_(0x46, 0x54)
#define REG_SC_BK46_54_H      _PK_H_(0x46, 0x54)
#define REG_SC_BK46_55_L      _PK_L_(0x46, 0x55)
#define REG_SC_BK46_55_H      _PK_H_(0x46, 0x55)
#define REG_SC_BK46_56_L      _PK_L_(0x46, 0x56)
#define REG_SC_BK46_56_H      _PK_H_(0x46, 0x56)
#define REG_SC_BK46_57_L      _PK_L_(0x46, 0x57)
#define REG_SC_BK46_57_H      _PK_H_(0x46, 0x57)
#define REG_SC_BK46_58_L      _PK_L_(0x46, 0x58)
#define REG_SC_BK46_58_H      _PK_H_(0x46, 0x58)
#define REG_SC_BK46_59_L      _PK_L_(0x46, 0x59)
#define REG_SC_BK46_59_H      _PK_H_(0x46, 0x59)
#define REG_SC_BK46_5A_L      _PK_L_(0x46, 0x5A)
#define REG_SC_BK46_5A_H      _PK_H_(0x46, 0x5A)
#define REG_SC_BK46_5B_L      _PK_L_(0x46, 0x5B)
#define REG_SC_BK46_5B_H      _PK_H_(0x46, 0x5B)
#define REG_SC_BK46_5C_L      _PK_L_(0x46, 0x5C)
#define REG_SC_BK46_5C_H      _PK_H_(0x46, 0x5C)
#define REG_SC_BK46_5D_L      _PK_L_(0x46, 0x5D)
#define REG_SC_BK46_5D_H      _PK_H_(0x46, 0x5D)
#define REG_SC_BK46_5E_L      _PK_L_(0x46, 0x5E)
#define REG_SC_BK46_5E_H      _PK_H_(0x46, 0x5E)
#define REG_SC_BK46_5F_L      _PK_L_(0x46, 0x5F)
#define REG_SC_BK46_5F_H      _PK_H_(0x46, 0x5F)
#define REG_SC_BK46_60_L      _PK_L_(0x46, 0x60)
#define REG_SC_BK46_60_H      _PK_H_(0x46, 0x60)
#define REG_SC_BK46_61_L      _PK_L_(0x46, 0x61)
#define REG_SC_BK46_61_H      _PK_H_(0x46, 0x61)
#define REG_SC_BK46_62_L      _PK_L_(0x46, 0x62)
#define REG_SC_BK46_62_H      _PK_H_(0x46, 0x62)
#define REG_SC_BK46_63_L      _PK_L_(0x46, 0x63)
#define REG_SC_BK46_63_H      _PK_H_(0x46, 0x63)
#define REG_SC_BK46_64_L      _PK_L_(0x46, 0x64)
#define REG_SC_BK46_64_H      _PK_H_(0x46, 0x64)
#define REG_SC_BK46_65_L      _PK_L_(0x46, 0x65)
#define REG_SC_BK46_65_H      _PK_H_(0x46, 0x65)
#define REG_SC_BK46_66_L      _PK_L_(0x46, 0x66)
#define REG_SC_BK46_66_H      _PK_H_(0x46, 0x66)
#define REG_SC_BK46_67_L      _PK_L_(0x46, 0x67)
#define REG_SC_BK46_67_H      _PK_H_(0x46, 0x67)
#define REG_SC_BK46_68_L      _PK_L_(0x46, 0x68)
#define REG_SC_BK46_68_H      _PK_H_(0x46, 0x68)
#define REG_SC_BK46_69_L      _PK_L_(0x46, 0x69)
#define REG_SC_BK46_69_H      _PK_H_(0x46, 0x69)
#define REG_SC_BK46_6A_L      _PK_L_(0x46, 0x6A)
#define REG_SC_BK46_6A_H      _PK_H_(0x46, 0x6A)
#define REG_SC_BK46_6B_L      _PK_L_(0x46, 0x6B)
#define REG_SC_BK46_6B_H      _PK_H_(0x46, 0x6B)
#define REG_SC_BK46_6C_L      _PK_L_(0x46, 0x6C)
#define REG_SC_BK46_6C_H      _PK_H_(0x46, 0x6C)
#define REG_SC_BK46_6D_L      _PK_L_(0x46, 0x6D)
#define REG_SC_BK46_6D_H      _PK_H_(0x46, 0x6D)
#define REG_SC_BK46_6E_L      _PK_L_(0x46, 0x6E)
#define REG_SC_BK46_6E_H      _PK_H_(0x46, 0x6E)
#define REG_SC_BK46_6F_L      _PK_L_(0x46, 0x6F)
#define REG_SC_BK46_6F_H      _PK_H_(0x46, 0x6F)
#define REG_SC_BK46_70_L      _PK_L_(0x46, 0x70)
#define REG_SC_BK46_70_H      _PK_H_(0x46, 0x70)
#define REG_SC_BK46_71_L      _PK_L_(0x46, 0x71)
#define REG_SC_BK46_71_H      _PK_H_(0x46, 0x71)
#define REG_SC_BK46_72_L      _PK_L_(0x46, 0x72)
#define REG_SC_BK46_72_H      _PK_H_(0x46, 0x72)
#define REG_SC_BK46_73_L      _PK_L_(0x46, 0x73)
#define REG_SC_BK46_73_H      _PK_H_(0x46, 0x73)
#define REG_SC_BK46_74_L      _PK_L_(0x46, 0x74)
#define REG_SC_BK46_74_H      _PK_H_(0x46, 0x74)
#define REG_SC_BK46_75_L      _PK_L_(0x46, 0x75)
#define REG_SC_BK46_75_H      _PK_H_(0x46, 0x75)
#define REG_SC_BK46_76_L      _PK_L_(0x46, 0x76)
#define REG_SC_BK46_76_H      _PK_H_(0x46, 0x76)
#define REG_SC_BK46_77_L      _PK_L_(0x46, 0x77)
#define REG_SC_BK46_77_H      _PK_H_(0x46, 0x77)
#define REG_SC_BK46_78_L      _PK_L_(0x46, 0x78)
#define REG_SC_BK46_78_H      _PK_H_(0x46, 0x78)
#define REG_SC_BK46_79_L      _PK_L_(0x46, 0x79)
#define REG_SC_BK46_79_H      _PK_H_(0x46, 0x79)
#define REG_SC_BK46_7A_L      _PK_L_(0x46, 0x7A)
#define REG_SC_BK46_7A_H      _PK_H_(0x46, 0x7A)
#define REG_SC_BK46_7B_L      _PK_L_(0x46, 0x7B)
#define REG_SC_BK46_7B_H      _PK_H_(0x46, 0x7B)
#define REG_SC_BK46_7C_L      _PK_L_(0x46, 0x7C)
#define REG_SC_BK46_7C_H      _PK_H_(0x46, 0x7C)
#define REG_SC_BK46_7D_L      _PK_L_(0x46, 0x7D)
#define REG_SC_BK46_7D_H      _PK_H_(0x46, 0x7D)
#define REG_SC_BK46_7E_L      _PK_L_(0x46, 0x7E)
#define REG_SC_BK46_7E_H      _PK_H_(0x46, 0x7E)
#define REG_SC_BK46_7F_L      _PK_L_(0x46, 0x7F)
#define REG_SC_BK46_7F_H      _PK_H_(0x46, 0x7F)

//----------------------------------------------
//  BK47: DIP DI
//----------------------------------------------
#define REG_SC_BK47_10_L      _PK_L_(0x47, 0x10)
#define REG_SC_BK47_10_H      _PK_H_(0x47, 0x10)
#define REG_SC_BK47_72_L      _PK_L_(0x47, 0x72)
#define REG_SC_BK47_78_L      _PK_L_(0x47, 0x78)
#define REG_SC_BK47_78_H      _PK_H_(0x47, 0x78)
#define REG_SC_BK47_79_L      _PK_L_(0x47, 0x79)
#define REG_SC_BK47_79_H      _PK_H_(0x47, 0x79)

//----------------------------------------------
//  BK48: 3D
//----------------------------------------------
#define REG_SC_BK48_00_L      _PK_L_(0x48, 0x00)
#define REG_SC_BK48_00_H      _PK_H_(0x48, 0x00)
#define REG_SC_BK48_01_L      _PK_L_(0x48, 0x01)
#define REG_SC_BK48_01_H      _PK_H_(0x48, 0x01)
#define REG_SC_BK48_02_L      _PK_L_(0x48, 0x02)
#define REG_SC_BK48_02_H      _PK_H_(0x48, 0x02)
#define REG_SC_BK48_03_L      _PK_L_(0x48, 0x03)
#define REG_SC_BK48_03_H      _PK_H_(0x48, 0x03)
#define REG_SC_BK48_04_L      _PK_L_(0x48, 0x04)
#define REG_SC_BK48_04_H      _PK_H_(0x48, 0x04)
#define REG_SC_BK48_05_L      _PK_L_(0x48, 0x05)
#define REG_SC_BK48_05_H      _PK_H_(0x48, 0x05)
#define REG_SC_BK48_06_L      _PK_L_(0x48, 0x06)
#define REG_SC_BK48_06_H      _PK_H_(0x48, 0x06)
#define REG_SC_BK48_07_L      _PK_L_(0x48, 0x07)
#define REG_SC_BK48_07_H      _PK_H_(0x48, 0x07)
#define REG_SC_BK48_08_L      _PK_L_(0x48, 0x08)
#define REG_SC_BK48_08_H      _PK_H_(0x48, 0x08)
#define REG_SC_BK48_09_L      _PK_L_(0x48, 0x09)
#define REG_SC_BK48_09_H      _PK_H_(0x48, 0x09)
#define REG_SC_BK48_0A_L      _PK_L_(0x48, 0x0A)
#define REG_SC_BK48_0A_H      _PK_H_(0x48, 0x0A)
#define REG_SC_BK48_0B_L      _PK_L_(0x48, 0x0B)
#define REG_SC_BK48_0B_H      _PK_H_(0x48, 0x0B)
#define REG_SC_BK48_0C_L      _PK_L_(0x48, 0x0C)
#define REG_SC_BK48_0C_H      _PK_H_(0x48, 0x0C)
#define REG_SC_BK48_0D_L      _PK_L_(0x48, 0x0D)
#define REG_SC_BK48_0D_H      _PK_H_(0x48, 0x0D)
#define REG_SC_BK48_0E_L      _PK_L_(0x48, 0x0E)
#define REG_SC_BK48_0E_H      _PK_H_(0x48, 0x0E)
#define REG_SC_BK48_0F_L      _PK_L_(0x48, 0x0F)
#define REG_SC_BK48_0F_H      _PK_H_(0x48, 0x0F)
#define REG_SC_BK48_10_L      _PK_L_(0x48, 0x10)
#define REG_SC_BK48_10_H      _PK_H_(0x48, 0x10)
#define REG_SC_BK48_11_L      _PK_L_(0x48, 0x11)
#define REG_SC_BK48_11_H      _PK_H_(0x48, 0x11)
#define REG_SC_BK48_12_L      _PK_L_(0x48, 0x12)
#define REG_SC_BK48_12_H      _PK_H_(0x48, 0x12)
#define REG_SC_BK48_13_L      _PK_L_(0x48, 0x13)
#define REG_SC_BK48_13_H      _PK_H_(0x48, 0x13)
#define REG_SC_BK48_14_L      _PK_L_(0x48, 0x14)
#define REG_SC_BK48_14_H      _PK_H_(0x48, 0x14)
#define REG_SC_BK48_15_L      _PK_L_(0x48, 0x15)
#define REG_SC_BK48_15_H      _PK_H_(0x48, 0x15)
#define REG_SC_BK48_16_L      _PK_L_(0x48, 0x16)
#define REG_SC_BK48_16_H      _PK_H_(0x48, 0x16)
#define REG_SC_BK48_17_L      _PK_L_(0x48, 0x17)
#define REG_SC_BK48_17_H      _PK_H_(0x48, 0x17)
#define REG_SC_BK48_18_L      _PK_L_(0x48, 0x18)
#define REG_SC_BK48_18_H      _PK_H_(0x48, 0x18)
#define REG_SC_BK48_19_L      _PK_L_(0x48, 0x19)
#define REG_SC_BK48_19_H      _PK_H_(0x48, 0x19)
#define REG_SC_BK48_1A_L      _PK_L_(0x48, 0x1A)
#define REG_SC_BK48_1A_H      _PK_H_(0x48, 0x1A)
#define REG_SC_BK48_1B_L      _PK_L_(0x48, 0x1B)
#define REG_SC_BK48_1B_H      _PK_H_(0x48, 0x1B)
#define REG_SC_BK48_1C_L      _PK_L_(0x48, 0x1C)
#define REG_SC_BK48_1C_H      _PK_H_(0x48, 0x1C)
#define REG_SC_BK48_1D_L      _PK_L_(0x48, 0x1D)
#define REG_SC_BK48_1D_H      _PK_H_(0x48, 0x1D)
#define REG_SC_BK48_1E_L      _PK_L_(0x48, 0x1E)
#define REG_SC_BK48_1E_H      _PK_H_(0x48, 0x1E)
#define REG_SC_BK48_1F_L      _PK_L_(0x48, 0x1F)
#define REG_SC_BK48_1F_H      _PK_H_(0x48, 0x1F)
#define REG_SC_BK48_20_L      _PK_L_(0x48, 0x20)
#define REG_SC_BK48_20_H      _PK_H_(0x48, 0x20)
#define REG_SC_BK48_21_L      _PK_L_(0x48, 0x21)
#define REG_SC_BK48_21_H      _PK_H_(0x48, 0x21)
#define REG_SC_BK48_22_L      _PK_L_(0x48, 0x22)
#define REG_SC_BK48_22_H      _PK_H_(0x48, 0x22)
#define REG_SC_BK48_23_L      _PK_L_(0x48, 0x23)
#define REG_SC_BK48_23_H      _PK_H_(0x48, 0x23)
#define REG_SC_BK48_24_L      _PK_L_(0x48, 0x24)
#define REG_SC_BK48_24_H      _PK_H_(0x48, 0x24)
#define REG_SC_BK48_25_L      _PK_L_(0x48, 0x25)
#define REG_SC_BK48_25_H      _PK_H_(0x48, 0x25)
#define REG_SC_BK48_26_L      _PK_L_(0x48, 0x26)
#define REG_SC_BK48_26_H      _PK_H_(0x48, 0x26)
#define REG_SC_BK48_27_L      _PK_L_(0x48, 0x27)
#define REG_SC_BK48_27_H      _PK_H_(0x48, 0x27)
#define REG_SC_BK48_28_L      _PK_L_(0x48, 0x28)
#define REG_SC_BK48_28_H      _PK_H_(0x48, 0x28)
#define REG_SC_BK48_29_L      _PK_L_(0x48, 0x29)
#define REG_SC_BK48_29_H      _PK_H_(0x48, 0x29)
#define REG_SC_BK48_2A_L      _PK_L_(0x48, 0x2A)
#define REG_SC_BK48_2A_H      _PK_H_(0x48, 0x2A)
#define REG_SC_BK48_2B_L      _PK_L_(0x48, 0x2B)
#define REG_SC_BK48_2B_H      _PK_H_(0x48, 0x2B)
#define REG_SC_BK48_2C_L      _PK_L_(0x48, 0x2C)
#define REG_SC_BK48_2C_H      _PK_H_(0x48, 0x2C)
#define REG_SC_BK48_2D_L      _PK_L_(0x48, 0x2D)
#define REG_SC_BK48_2D_H      _PK_H_(0x48, 0x2D)
#define REG_SC_BK48_2E_L      _PK_L_(0x48, 0x2E)
#define REG_SC_BK48_2E_H      _PK_H_(0x48, 0x2E)
#define REG_SC_BK48_2F_L      _PK_L_(0x48, 0x2F)
#define REG_SC_BK48_2F_H      _PK_H_(0x48, 0x2F)
#define REG_SC_BK48_30_L      _PK_L_(0x48, 0x30)
#define REG_SC_BK48_30_H      _PK_H_(0x48, 0x30)
#define REG_SC_BK48_31_L      _PK_L_(0x48, 0x31)
#define REG_SC_BK48_31_H      _PK_H_(0x48, 0x31)
#define REG_SC_BK48_32_L      _PK_L_(0x48, 0x32)
#define REG_SC_BK48_32_H      _PK_H_(0x48, 0x32)
#define REG_SC_BK48_33_L      _PK_L_(0x48, 0x33)
#define REG_SC_BK48_33_H      _PK_H_(0x48, 0x33)
#define REG_SC_BK48_34_L      _PK_L_(0x48, 0x34)
#define REG_SC_BK48_34_H      _PK_H_(0x48, 0x34)
#define REG_SC_BK48_35_L      _PK_L_(0x48, 0x35)
#define REG_SC_BK48_35_H      _PK_H_(0x48, 0x35)
#define REG_SC_BK48_36_L      _PK_L_(0x48, 0x36)
#define REG_SC_BK48_36_H      _PK_H_(0x48, 0x36)
#define REG_SC_BK48_37_L      _PK_L_(0x48, 0x37)
#define REG_SC_BK48_37_H      _PK_H_(0x48, 0x37)
#define REG_SC_BK48_38_L      _PK_L_(0x48, 0x38)
#define REG_SC_BK48_38_H      _PK_H_(0x48, 0x38)
#define REG_SC_BK48_39_L      _PK_L_(0x48, 0x39)
#define REG_SC_BK48_39_H      _PK_H_(0x48, 0x39)
#define REG_SC_BK48_3A_L      _PK_L_(0x48, 0x3A)
#define REG_SC_BK48_3A_H      _PK_H_(0x48, 0x3A)
#define REG_SC_BK48_3B_L      _PK_L_(0x48, 0x3B)
#define REG_SC_BK48_3B_H      _PK_H_(0x48, 0x3B)
#define REG_SC_BK48_3C_L      _PK_L_(0x48, 0x3C)
#define REG_SC_BK48_3C_H      _PK_H_(0x48, 0x3C)
#define REG_SC_BK48_3D_L      _PK_L_(0x48, 0x3D)
#define REG_SC_BK48_3D_H      _PK_H_(0x48, 0x3D)
#define REG_SC_BK48_3E_L      _PK_L_(0x48, 0x3E)
#define REG_SC_BK48_3E_H      _PK_H_(0x48, 0x3E)
#define REG_SC_BK48_3F_L      _PK_L_(0x48, 0x3F)
#define REG_SC_BK48_3F_H      _PK_H_(0x48, 0x3F)
#define REG_SC_BK48_40_L      _PK_L_(0x48, 0x40)
#define REG_SC_BK48_40_H      _PK_H_(0x48, 0x40)
#define REG_SC_BK48_41_L      _PK_L_(0x48, 0x41)
#define REG_SC_BK48_41_H      _PK_H_(0x48, 0x41)
#define REG_SC_BK48_42_L      _PK_L_(0x48, 0x42)
#define REG_SC_BK48_42_H      _PK_H_(0x48, 0x42)
#define REG_SC_BK48_43_L      _PK_L_(0x48, 0x43)
#define REG_SC_BK48_43_H      _PK_H_(0x48, 0x43)
#define REG_SC_BK48_44_L      _PK_L_(0x48, 0x44)
#define REG_SC_BK48_44_H      _PK_H_(0x48, 0x44)
#define REG_SC_BK48_45_L      _PK_L_(0x48, 0x45)
#define REG_SC_BK48_45_H      _PK_H_(0x48, 0x45)
#define REG_SC_BK48_46_L      _PK_L_(0x48, 0x46)
#define REG_SC_BK48_46_H      _PK_H_(0x48, 0x46)
#define REG_SC_BK48_47_L      _PK_L_(0x48, 0x47)
#define REG_SC_BK48_47_H      _PK_H_(0x48, 0x47)
#define REG_SC_BK48_48_L      _PK_L_(0x48, 0x48)
#define REG_SC_BK48_48_H      _PK_H_(0x48, 0x48)
#define REG_SC_BK48_49_L      _PK_L_(0x48, 0x49)
#define REG_SC_BK48_49_H      _PK_H_(0x48, 0x49)
#define REG_SC_BK48_4A_L      _PK_L_(0x48, 0x4A)
#define REG_SC_BK48_4A_H      _PK_H_(0x48, 0x4A)
#define REG_SC_BK48_4B_L      _PK_L_(0x48, 0x4B)
#define REG_SC_BK48_4B_H      _PK_H_(0x48, 0x4B)
#define REG_SC_BK48_4C_L      _PK_L_(0x48, 0x4C)
#define REG_SC_BK48_4C_H      _PK_H_(0x48, 0x4C)
#define REG_SC_BK48_4D_L      _PK_L_(0x48, 0x4D)
#define REG_SC_BK48_4D_H      _PK_H_(0x48, 0x4D)
#define REG_SC_BK48_4E_L      _PK_L_(0x48, 0x4E)
#define REG_SC_BK48_4E_H      _PK_H_(0x48, 0x4E)
#define REG_SC_BK48_4F_L      _PK_L_(0x48, 0x4F)
#define REG_SC_BK48_4F_H      _PK_H_(0x48, 0x4F)
#define REG_SC_BK48_50_L      _PK_L_(0x48, 0x50)
#define REG_SC_BK48_50_H      _PK_H_(0x48, 0x50)
#define REG_SC_BK48_51_L      _PK_L_(0x48, 0x51)
#define REG_SC_BK48_51_H      _PK_H_(0x48, 0x51)
#define REG_SC_BK48_52_L      _PK_L_(0x48, 0x52)
#define REG_SC_BK48_52_H      _PK_H_(0x48, 0x52)
#define REG_SC_BK48_53_L      _PK_L_(0x48, 0x53)
#define REG_SC_BK48_53_H      _PK_H_(0x48, 0x53)
#define REG_SC_BK48_54_L      _PK_L_(0x48, 0x54)
#define REG_SC_BK48_54_H      _PK_H_(0x48, 0x54)
#define REG_SC_BK48_55_L      _PK_L_(0x48, 0x55)
#define REG_SC_BK48_55_H      _PK_H_(0x48, 0x55)
#define REG_SC_BK48_56_L      _PK_L_(0x48, 0x56)
#define REG_SC_BK48_56_H      _PK_H_(0x48, 0x56)
#define REG_SC_BK48_57_L      _PK_L_(0x48, 0x57)
#define REG_SC_BK48_57_H      _PK_H_(0x48, 0x57)
#define REG_SC_BK48_58_L      _PK_L_(0x48, 0x58)
#define REG_SC_BK48_58_H      _PK_H_(0x48, 0x58)
#define REG_SC_BK48_59_L      _PK_L_(0x48, 0x59)
#define REG_SC_BK48_59_H      _PK_H_(0x48, 0x59)
#define REG_SC_BK48_5A_L      _PK_L_(0x48, 0x5A)
#define REG_SC_BK48_5A_H      _PK_H_(0x48, 0x5A)
#define REG_SC_BK48_5B_L      _PK_L_(0x48, 0x5B)
#define REG_SC_BK48_5B_H      _PK_H_(0x48, 0x5B)
#define REG_SC_BK48_5C_L      _PK_L_(0x48, 0x5C)
#define REG_SC_BK48_5C_H      _PK_H_(0x48, 0x5C)
#define REG_SC_BK48_5D_L      _PK_L_(0x48, 0x5D)
#define REG_SC_BK48_5D_H      _PK_H_(0x48, 0x5D)
#define REG_SC_BK48_5E_L      _PK_L_(0x48, 0x5E)
#define REG_SC_BK48_5E_H      _PK_H_(0x48, 0x5E)
#define REG_SC_BK48_5F_L      _PK_L_(0x48, 0x5F)
#define REG_SC_BK48_5F_H      _PK_H_(0x48, 0x5F)
#define REG_SC_BK48_60_L      _PK_L_(0x48, 0x60)
#define REG_SC_BK48_60_H      _PK_H_(0x48, 0x60)
#define REG_SC_BK48_61_L      _PK_L_(0x48, 0x61)
#define REG_SC_BK48_61_H      _PK_H_(0x48, 0x61)
#define REG_SC_BK48_62_L      _PK_L_(0x48, 0x62)
#define REG_SC_BK48_62_H      _PK_H_(0x48, 0x62)
#define REG_SC_BK48_63_L      _PK_L_(0x48, 0x63)
#define REG_SC_BK48_63_H      _PK_H_(0x48, 0x63)
#define REG_SC_BK48_64_L      _PK_L_(0x48, 0x64)
#define REG_SC_BK48_64_H      _PK_H_(0x48, 0x64)
#define REG_SC_BK48_65_L      _PK_L_(0x48, 0x65)
#define REG_SC_BK48_65_H      _PK_H_(0x48, 0x65)
#define REG_SC_BK48_66_L      _PK_L_(0x48, 0x66)
#define REG_SC_BK48_66_H      _PK_H_(0x48, 0x66)
#define REG_SC_BK48_67_L      _PK_L_(0x48, 0x67)
#define REG_SC_BK48_67_H      _PK_H_(0x48, 0x67)
#define REG_SC_BK48_68_L      _PK_L_(0x48, 0x68)
#define REG_SC_BK48_68_H      _PK_H_(0x48, 0x68)
#define REG_SC_BK48_69_L      _PK_L_(0x48, 0x69)
#define REG_SC_BK48_69_H      _PK_H_(0x48, 0x69)
#define REG_SC_BK48_6A_L      _PK_L_(0x48, 0x6A)
#define REG_SC_BK48_6A_H      _PK_H_(0x48, 0x6A)
#define REG_SC_BK48_6B_L      _PK_L_(0x48, 0x6B)
#define REG_SC_BK48_6B_H      _PK_H_(0x48, 0x6B)
#define REG_SC_BK48_6C_L      _PK_L_(0x48, 0x6C)
#define REG_SC_BK48_6C_H      _PK_H_(0x48, 0x6C)
#define REG_SC_BK48_6D_L      _PK_L_(0x48, 0x6D)
#define REG_SC_BK48_6D_H      _PK_H_(0x48, 0x6D)
#define REG_SC_BK48_6E_L      _PK_L_(0x48, 0x6E)
#define REG_SC_BK48_6E_H      _PK_H_(0x48, 0x6E)
#define REG_SC_BK48_6F_L      _PK_L_(0x48, 0x6F)
#define REG_SC_BK48_6F_H      _PK_H_(0x48, 0x6F)
#define REG_SC_BK48_70_L      _PK_L_(0x48, 0x70)
#define REG_SC_BK48_70_H      _PK_H_(0x48, 0x70)
#define REG_SC_BK48_71_L      _PK_L_(0x48, 0x71)
#define REG_SC_BK48_71_H      _PK_H_(0x48, 0x71)
#define REG_SC_BK48_72_L      _PK_L_(0x48, 0x72)
#define REG_SC_BK48_72_H      _PK_H_(0x48, 0x72)
#define REG_SC_BK48_73_L      _PK_L_(0x48, 0x73)
#define REG_SC_BK48_73_H      _PK_H_(0x48, 0x73)
#define REG_SC_BK48_74_L      _PK_L_(0x48, 0x74)
#define REG_SC_BK48_74_H      _PK_H_(0x48, 0x74)
#define REG_SC_BK48_75_L      _PK_L_(0x48, 0x75)
#define REG_SC_BK48_75_H      _PK_H_(0x48, 0x75)
#define REG_SC_BK48_76_L      _PK_L_(0x48, 0x76)
#define REG_SC_BK48_76_H      _PK_H_(0x48, 0x76)
#define REG_SC_BK48_77_L      _PK_L_(0x48, 0x77)
#define REG_SC_BK48_77_H      _PK_H_(0x48, 0x77)
#define REG_SC_BK48_78_L      _PK_L_(0x48, 0x78)
#define REG_SC_BK48_78_H      _PK_H_(0x48, 0x78)
#define REG_SC_BK48_79_L      _PK_L_(0x48, 0x79)
#define REG_SC_BK48_79_H      _PK_H_(0x48, 0x79)
#define REG_SC_BK48_7A_L      _PK_L_(0x48, 0x7A)
#define REG_SC_BK48_7A_H      _PK_H_(0x48, 0x7A)
#define REG_SC_BK48_7B_L      _PK_L_(0x48, 0x7B)
#define REG_SC_BK48_7B_H      _PK_H_(0x48, 0x7B)
#define REG_SC_BK48_7C_L      _PK_L_(0x48, 0x7C)
#define REG_SC_BK48_7C_H      _PK_H_(0x48, 0x7C)
#define REG_SC_BK48_7D_L      _PK_L_(0x48, 0x7D)
#define REG_SC_BK48_7D_H      _PK_H_(0x48, 0x7D)
#define REG_SC_BK48_7E_L      _PK_L_(0x48, 0x7E)
#define REG_SC_BK48_7E_H      _PK_H_(0x48, 0x7E)
#define REG_SC_BK48_7F_L      _PK_L_(0x48, 0x7F)
#define REG_SC_BK48_7F_H      _PK_H_(0x48, 0x7F)

//----------------------------------------------
//  BK49: DIP HVSP
#define REG_SC_BK49_07_L      _PK_L_(0x49, 0x07)
#define REG_SC_BK49_07_H      _PK_H_(0x49, 0x07)
#define REG_SC_BK49_08_L      _PK_L_(0x49, 0x08)
#define REG_SC_BK49_08_H      _PK_H_(0x49, 0x08)
#define REG_SC_BK49_09_L      _PK_L_(0x49, 0x09)
#define REG_SC_BK49_09_H      _PK_H_(0x49, 0x09)
#define REG_SC_BK49_13_L      _PK_L_(0x49, 0x13)
#define REG_SC_BK49_22_L      _PK_L_(0x49, 0x22)
#define REG_SC_BK49_22_H      _PK_H_(0x49, 0x22)
#define REG_SC_BK49_23_L      _PK_L_(0x49, 0x23)
#define REG_SC_BK49_23_H      _PK_H_(0x49, 0x23)
#define REG_SC_BK49_24_L      _PK_L_(0x49, 0x24)
#define REG_SC_BK49_24_H      _PK_H_(0x49, 0x24)
#define REG_SC_BK49_25_L      _PK_L_(0x49, 0x25)
#define REG_SC_BK49_25_H      _PK_H_(0x49, 0x25)
#define REG_SC_BK49_41_L      _PK_L_(0x49, 0x41)
#define REG_SC_BK49_42_L      _PK_L_(0x49, 0x42)
#define REG_SC_BK49_43_L      _PK_L_(0x49, 0x43)
#define REG_SC_BK49_44_L      _PK_L_(0x49, 0x44)
#define REG_SC_BK49_45_L      _PK_L_(0x49, 0x45)
#define REG_SC_BK49_49_L      _PK_L_(0x49, 0x49)
#define REG_SC_BK49_4A_L      _PK_L_(0x49, 0x4A)
#define REG_SC_BK49_5F_L      _PK_L_(0x49, 0x5F)
#define REG_SC_BK49_0A_L      _PK_L_(0x49, 0x0A)
#define REG_SC_BK49_0A_H      _PK_H_(0x49, 0x0A)
#define REG_SC_BK49_0B_L      _PK_L_(0x49, 0x0B)
#define REG_SC_BK49_70_L      _PK_L_(0x49, 0x70)
#define REG_SC_BK49_70_H      _PK_H_(0x49, 0x70)
//----------------------------------------------
//----------------------------------------------
//  BK4A: 3D
//----------------------------------------------
#define REG_SC_BK4A_00_L      _PK_L_(0x4A, 0x00)
#define REG_SC_BK4A_00_H      _PK_H_(0x4A, 0x00)
#define REG_SC_BK4A_01_L      _PK_L_(0x4A, 0x01)
#define REG_SC_BK4A_01_H      _PK_H_(0x4A, 0x01)
#define REG_SC_BK4A_02_L      _PK_L_(0x4A, 0x02)
#define REG_SC_BK4A_02_H      _PK_H_(0x4A, 0x02)
#define REG_SC_BK4A_03_L      _PK_L_(0x4A, 0x03)
#define REG_SC_BK4A_03_H      _PK_H_(0x4A, 0x03)
#define REG_SC_BK4A_04_L      _PK_L_(0x4A, 0x04)
#define REG_SC_BK4A_04_H      _PK_H_(0x4A, 0x04)
#define REG_SC_BK4A_05_L      _PK_L_(0x4A, 0x05)
#define REG_SC_BK4A_05_H      _PK_H_(0x4A, 0x05)
#define REG_SC_BK4A_06_L      _PK_L_(0x4A, 0x06)
#define REG_SC_BK4A_06_H      _PK_H_(0x4A, 0x06)
#define REG_SC_BK4A_07_L      _PK_L_(0x4A, 0x07)
#define REG_SC_BK4A_07_H      _PK_H_(0x4A, 0x07)
#define REG_SC_BK4A_08_L      _PK_L_(0x4A, 0x08)
#define REG_SC_BK4A_08_H      _PK_H_(0x4A, 0x08)
#define REG_SC_BK4A_09_L      _PK_L_(0x4A, 0x09)
#define REG_SC_BK4A_09_H      _PK_H_(0x4A, 0x09)
#define REG_SC_BK4A_0A_L      _PK_L_(0x4A, 0x0A)
#define REG_SC_BK4A_0A_H      _PK_H_(0x4A, 0x0A)
#define REG_SC_BK4A_0B_L      _PK_L_(0x4A, 0x0B)
#define REG_SC_BK4A_0B_H      _PK_H_(0x4A, 0x0B)
#define REG_SC_BK4A_0C_L      _PK_L_(0x4A, 0x0C)
#define REG_SC_BK4A_0C_H      _PK_H_(0x4A, 0x0C)
#define REG_SC_BK4A_0D_L      _PK_L_(0x4A, 0x0D)
#define REG_SC_BK4A_0D_H      _PK_H_(0x4A, 0x0D)
#define REG_SC_BK4A_0E_L      _PK_L_(0x4A, 0x0E)
#define REG_SC_BK4A_0E_H      _PK_H_(0x4A, 0x0E)
#define REG_SC_BK4A_0F_L      _PK_L_(0x4A, 0x0F)
#define REG_SC_BK4A_0F_H      _PK_H_(0x4A, 0x0F)
#define REG_SC_BK4A_10_L      _PK_L_(0x4A, 0x10)
#define REG_SC_BK4A_10_H      _PK_H_(0x4A, 0x10)
#define REG_SC_BK4A_11_L      _PK_L_(0x4A, 0x11)
#define REG_SC_BK4A_11_H      _PK_H_(0x4A, 0x11)
#define REG_SC_BK4A_12_L      _PK_L_(0x4A, 0x12)
#define REG_SC_BK4A_12_H      _PK_H_(0x4A, 0x12)
#define REG_SC_BK4A_13_L      _PK_L_(0x4A, 0x13)
#define REG_SC_BK4A_13_H      _PK_H_(0x4A, 0x13)
#define REG_SC_BK4A_14_L      _PK_L_(0x4A, 0x14)
#define REG_SC_BK4A_14_H      _PK_H_(0x4A, 0x14)
#define REG_SC_BK4A_15_L      _PK_L_(0x4A, 0x15)
#define REG_SC_BK4A_15_H      _PK_H_(0x4A, 0x15)
#define REG_SC_BK4A_16_L      _PK_L_(0x4A, 0x16)
#define REG_SC_BK4A_16_H      _PK_H_(0x4A, 0x16)
#define REG_SC_BK4A_17_L      _PK_L_(0x4A, 0x17)
#define REG_SC_BK4A_17_H      _PK_H_(0x4A, 0x17)
#define REG_SC_BK4A_18_L      _PK_L_(0x4A, 0x18)
#define REG_SC_BK4A_18_H      _PK_H_(0x4A, 0x18)
#define REG_SC_BK4A_19_L      _PK_L_(0x4A, 0x19)
#define REG_SC_BK4A_19_H      _PK_H_(0x4A, 0x19)
#define REG_SC_BK4A_1A_L      _PK_L_(0x4A, 0x1A)
#define REG_SC_BK4A_1A_H      _PK_H_(0x4A, 0x1A)
#define REG_SC_BK4A_1B_L      _PK_L_(0x4A, 0x1B)
#define REG_SC_BK4A_1B_H      _PK_H_(0x4A, 0x1B)
#define REG_SC_BK4A_1C_L      _PK_L_(0x4A, 0x1C)
#define REG_SC_BK4A_1C_H      _PK_H_(0x4A, 0x1C)
#define REG_SC_BK4A_1D_L      _PK_L_(0x4A, 0x1D)
#define REG_SC_BK4A_1D_H      _PK_H_(0x4A, 0x1D)
#define REG_SC_BK4A_1E_L      _PK_L_(0x4A, 0x1E)
#define REG_SC_BK4A_1E_H      _PK_H_(0x4A, 0x1E)
#define REG_SC_BK4A_1F_L      _PK_L_(0x4A, 0x1F)
#define REG_SC_BK4A_1F_H      _PK_H_(0x4A, 0x1F)
#define REG_SC_BK4A_20_L      _PK_L_(0x4A, 0x20)
#define REG_SC_BK4A_20_H      _PK_H_(0x4A, 0x20)
#define REG_SC_BK4A_21_L      _PK_L_(0x4A, 0x21)
#define REG_SC_BK4A_21_H      _PK_H_(0x4A, 0x21)
#define REG_SC_BK4A_22_L      _PK_L_(0x4A, 0x22)
#define REG_SC_BK4A_22_H      _PK_H_(0x4A, 0x22)
#define REG_SC_BK4A_23_L      _PK_L_(0x4A, 0x23)
#define REG_SC_BK4A_23_H      _PK_H_(0x4A, 0x23)
#define REG_SC_BK4A_24_L      _PK_L_(0x4A, 0x24)
#define REG_SC_BK4A_24_H      _PK_H_(0x4A, 0x24)
#define REG_SC_BK4A_25_L      _PK_L_(0x4A, 0x25)
#define REG_SC_BK4A_25_H      _PK_H_(0x4A, 0x25)
#define REG_SC_BK4A_26_L      _PK_L_(0x4A, 0x26)
#define REG_SC_BK4A_26_H      _PK_H_(0x4A, 0x26)
#define REG_SC_BK4A_27_L      _PK_L_(0x4A, 0x27)
#define REG_SC_BK4A_27_H      _PK_H_(0x4A, 0x27)
#define REG_SC_BK4A_28_L      _PK_L_(0x4A, 0x28)
#define REG_SC_BK4A_28_H      _PK_H_(0x4A, 0x28)
#define REG_SC_BK4A_29_L      _PK_L_(0x4A, 0x29)
#define REG_SC_BK4A_29_H      _PK_H_(0x4A, 0x29)
#define REG_SC_BK4A_2A_L      _PK_L_(0x4A, 0x2A)
#define REG_SC_BK4A_2A_H      _PK_H_(0x4A, 0x2A)
#define REG_SC_BK4A_2B_L      _PK_L_(0x4A, 0x2B)
#define REG_SC_BK4A_2B_H      _PK_H_(0x4A, 0x2B)
#define REG_SC_BK4A_2C_L      _PK_L_(0x4A, 0x2C)
#define REG_SC_BK4A_2C_H      _PK_H_(0x4A, 0x2C)
#define REG_SC_BK4A_2D_L      _PK_L_(0x4A, 0x2D)
#define REG_SC_BK4A_2D_H      _PK_H_(0x4A, 0x2D)
#define REG_SC_BK4A_2E_L      _PK_L_(0x4A, 0x2E)
#define REG_SC_BK4A_2E_H      _PK_H_(0x4A, 0x2E)
#define REG_SC_BK4A_2F_L      _PK_L_(0x4A, 0x2F)
#define REG_SC_BK4A_2F_H      _PK_H_(0x4A, 0x2F)
#define REG_SC_BK4A_30_L      _PK_L_(0x4A, 0x30)
#define REG_SC_BK4A_30_H      _PK_H_(0x4A, 0x30)
#define REG_SC_BK4A_31_L      _PK_L_(0x4A, 0x31)
#define REG_SC_BK4A_31_H      _PK_H_(0x4A, 0x31)
#define REG_SC_BK4A_32_L      _PK_L_(0x4A, 0x32)
#define REG_SC_BK4A_32_H      _PK_H_(0x4A, 0x32)
#define REG_SC_BK4A_33_L      _PK_L_(0x4A, 0x33)
#define REG_SC_BK4A_33_H      _PK_H_(0x4A, 0x33)
#define REG_SC_BK4A_34_L      _PK_L_(0x4A, 0x34)
#define REG_SC_BK4A_34_H      _PK_H_(0x4A, 0x34)
#define REG_SC_BK4A_35_L      _PK_L_(0x4A, 0x35)
#define REG_SC_BK4A_35_H      _PK_H_(0x4A, 0x35)
#define REG_SC_BK4A_36_L      _PK_L_(0x4A, 0x36)
#define REG_SC_BK4A_36_H      _PK_H_(0x4A, 0x36)
#define REG_SC_BK4A_37_L      _PK_L_(0x4A, 0x37)
#define REG_SC_BK4A_37_H      _PK_H_(0x4A, 0x37)
#define REG_SC_BK4A_38_L      _PK_L_(0x4A, 0x38)
#define REG_SC_BK4A_38_H      _PK_H_(0x4A, 0x38)
#define REG_SC_BK4A_39_L      _PK_L_(0x4A, 0x39)
#define REG_SC_BK4A_39_H      _PK_H_(0x4A, 0x39)
#define REG_SC_BK4A_3A_L      _PK_L_(0x4A, 0x3A)
#define REG_SC_BK4A_3A_H      _PK_H_(0x4A, 0x3A)
#define REG_SC_BK4A_3B_L      _PK_L_(0x4A, 0x3B)
#define REG_SC_BK4A_3B_H      _PK_H_(0x4A, 0x3B)
#define REG_SC_BK4A_3C_L      _PK_L_(0x4A, 0x3C)
#define REG_SC_BK4A_3C_H      _PK_H_(0x4A, 0x3C)
#define REG_SC_BK4A_3D_L      _PK_L_(0x4A, 0x3D)
#define REG_SC_BK4A_3D_H      _PK_H_(0x4A, 0x3D)
#define REG_SC_BK4A_3E_L      _PK_L_(0x4A, 0x3E)
#define REG_SC_BK4A_3E_H      _PK_H_(0x4A, 0x3E)
#define REG_SC_BK4A_3F_L      _PK_L_(0x4A, 0x3F)
#define REG_SC_BK4A_3F_H      _PK_H_(0x4A, 0x3F)
#define REG_SC_BK4A_40_L      _PK_L_(0x4A, 0x40)
#define REG_SC_BK4A_40_H      _PK_H_(0x4A, 0x40)
#define REG_SC_BK4A_41_L      _PK_L_(0x4A, 0x41)
#define REG_SC_BK4A_41_H      _PK_H_(0x4A, 0x41)
#define REG_SC_BK4A_42_L      _PK_L_(0x4A, 0x42)
#define REG_SC_BK4A_42_H      _PK_H_(0x4A, 0x42)
#define REG_SC_BK4A_43_L      _PK_L_(0x4A, 0x43)
#define REG_SC_BK4A_43_H      _PK_H_(0x4A, 0x43)
#define REG_SC_BK4A_44_L      _PK_L_(0x4A, 0x44)
#define REG_SC_BK4A_44_H      _PK_H_(0x4A, 0x44)
#define REG_SC_BK4A_45_L      _PK_L_(0x4A, 0x45)
#define REG_SC_BK4A_45_H      _PK_H_(0x4A, 0x45)
#define REG_SC_BK4A_46_L      _PK_L_(0x4A, 0x46)
#define REG_SC_BK4A_46_H      _PK_H_(0x4A, 0x46)
#define REG_SC_BK4A_47_L      _PK_L_(0x4A, 0x47)
#define REG_SC_BK4A_47_H      _PK_H_(0x4A, 0x47)
#define REG_SC_BK4A_48_L      _PK_L_(0x4A, 0x48)
#define REG_SC_BK4A_48_H      _PK_H_(0x4A, 0x48)
#define REG_SC_BK4A_49_L      _PK_L_(0x4A, 0x49)
#define REG_SC_BK4A_49_H      _PK_H_(0x4A, 0x49)
#define REG_SC_BK4A_4A_L      _PK_L_(0x4A, 0x4A)
#define REG_SC_BK4A_4A_H      _PK_H_(0x4A, 0x4A)
#define REG_SC_BK4A_4B_L      _PK_L_(0x4A, 0x4B)
#define REG_SC_BK4A_4B_H      _PK_H_(0x4A, 0x4B)
#define REG_SC_BK4A_4C_L      _PK_L_(0x4A, 0x4C)
#define REG_SC_BK4A_4C_H      _PK_H_(0x4A, 0x4C)
#define REG_SC_BK4A_4D_L      _PK_L_(0x4A, 0x4D)
#define REG_SC_BK4A_4D_H      _PK_H_(0x4A, 0x4D)
#define REG_SC_BK4A_4E_L      _PK_L_(0x4A, 0x4E)
#define REG_SC_BK4A_4E_H      _PK_H_(0x4A, 0x4E)
#define REG_SC_BK4A_4F_L      _PK_L_(0x4A, 0x4F)
#define REG_SC_BK4A_4F_H      _PK_H_(0x4A, 0x4F)
#define REG_SC_BK4A_50_L      _PK_L_(0x4A, 0x50)
#define REG_SC_BK4A_50_H      _PK_H_(0x4A, 0x50)
#define REG_SC_BK4A_51_L      _PK_L_(0x4A, 0x51)
#define REG_SC_BK4A_51_H      _PK_H_(0x4A, 0x51)
#define REG_SC_BK4A_52_L      _PK_L_(0x4A, 0x52)
#define REG_SC_BK4A_52_H      _PK_H_(0x4A, 0x52)
#define REG_SC_BK4A_53_L      _PK_L_(0x4A, 0x53)
#define REG_SC_BK4A_53_H      _PK_H_(0x4A, 0x53)
#define REG_SC_BK4A_54_L      _PK_L_(0x4A, 0x54)
#define REG_SC_BK4A_54_H      _PK_H_(0x4A, 0x54)
#define REG_SC_BK4A_55_L      _PK_L_(0x4A, 0x55)
#define REG_SC_BK4A_55_H      _PK_H_(0x4A, 0x55)
#define REG_SC_BK4A_56_L      _PK_L_(0x4A, 0x56)
#define REG_SC_BK4A_56_H      _PK_H_(0x4A, 0x56)
#define REG_SC_BK4A_57_L      _PK_L_(0x4A, 0x57)
#define REG_SC_BK4A_57_H      _PK_H_(0x4A, 0x57)
#define REG_SC_BK4A_58_L      _PK_L_(0x4A, 0x58)
#define REG_SC_BK4A_58_H      _PK_H_(0x4A, 0x58)
#define REG_SC_BK4A_59_L      _PK_L_(0x4A, 0x59)
#define REG_SC_BK4A_59_H      _PK_H_(0x4A, 0x59)
#define REG_SC_BK4A_5A_L      _PK_L_(0x4A, 0x5A)
#define REG_SC_BK4A_5A_H      _PK_H_(0x4A, 0x5A)
#define REG_SC_BK4A_5B_L      _PK_L_(0x4A, 0x5B)
#define REG_SC_BK4A_5B_H      _PK_H_(0x4A, 0x5B)
#define REG_SC_BK4A_5C_L      _PK_L_(0x4A, 0x5C)
#define REG_SC_BK4A_5C_H      _PK_H_(0x4A, 0x5C)
#define REG_SC_BK4A_5D_L      _PK_L_(0x4A, 0x5D)
#define REG_SC_BK4A_5D_H      _PK_H_(0x4A, 0x5D)
#define REG_SC_BK4A_5E_L      _PK_L_(0x4A, 0x5E)
#define REG_SC_BK4A_5E_H      _PK_H_(0x4A, 0x5E)
#define REG_SC_BK4A_5F_L      _PK_L_(0x4A, 0x5F)
#define REG_SC_BK4A_5F_H      _PK_H_(0x4A, 0x5F)
#define REG_SC_BK4A_60_L      _PK_L_(0x4A, 0x60)
#define REG_SC_BK4A_60_H      _PK_H_(0x4A, 0x60)
#define REG_SC_BK4A_61_L      _PK_L_(0x4A, 0x61)
#define REG_SC_BK4A_61_H      _PK_H_(0x4A, 0x61)
#define REG_SC_BK4A_62_L      _PK_L_(0x4A, 0x62)
#define REG_SC_BK4A_62_H      _PK_H_(0x4A, 0x62)
#define REG_SC_BK4A_63_L      _PK_L_(0x4A, 0x63)
#define REG_SC_BK4A_63_H      _PK_H_(0x4A, 0x63)
#define REG_SC_BK4A_64_L      _PK_L_(0x4A, 0x64)
#define REG_SC_BK4A_64_H      _PK_H_(0x4A, 0x64)
#define REG_SC_BK4A_65_L      _PK_L_(0x4A, 0x65)
#define REG_SC_BK4A_65_H      _PK_H_(0x4A, 0x65)
#define REG_SC_BK4A_66_L      _PK_L_(0x4A, 0x66)
#define REG_SC_BK4A_66_H      _PK_H_(0x4A, 0x66)
#define REG_SC_BK4A_67_L      _PK_L_(0x4A, 0x67)
#define REG_SC_BK4A_67_H      _PK_H_(0x4A, 0x67)
#define REG_SC_BK4A_68_L      _PK_L_(0x4A, 0x68)
#define REG_SC_BK4A_68_H      _PK_H_(0x4A, 0x68)
#define REG_SC_BK4A_69_L      _PK_L_(0x4A, 0x69)
#define REG_SC_BK4A_69_H      _PK_H_(0x4A, 0x69)
#define REG_SC_BK4A_6A_L      _PK_L_(0x4A, 0x6A)
#define REG_SC_BK4A_6A_H      _PK_H_(0x4A, 0x6A)
#define REG_SC_BK4A_6B_L      _PK_L_(0x4A, 0x6B)
#define REG_SC_BK4A_6B_H      _PK_H_(0x4A, 0x6B)
#define REG_SC_BK4A_6C_L      _PK_L_(0x4A, 0x6C)
#define REG_SC_BK4A_6C_H      _PK_H_(0x4A, 0x6C)
#define REG_SC_BK4A_6D_L      _PK_L_(0x4A, 0x6D)
#define REG_SC_BK4A_6D_H      _PK_H_(0x4A, 0x6D)
#define REG_SC_BK4A_6E_L      _PK_L_(0x4A, 0x6E)
#define REG_SC_BK4A_6E_H      _PK_H_(0x4A, 0x6E)
#define REG_SC_BK4A_6F_L      _PK_L_(0x4A, 0x6F)
#define REG_SC_BK4A_6F_H      _PK_H_(0x4A, 0x6F)
#define REG_SC_BK4A_70_L      _PK_L_(0x4A, 0x70)
#define REG_SC_BK4A_70_H      _PK_H_(0x4A, 0x70)
#define REG_SC_BK4A_71_L      _PK_L_(0x4A, 0x71)
#define REG_SC_BK4A_71_H      _PK_H_(0x4A, 0x71)
#define REG_SC_BK4A_72_L      _PK_L_(0x4A, 0x72)
#define REG_SC_BK4A_72_H      _PK_H_(0x4A, 0x72)
#define REG_SC_BK4A_73_L      _PK_L_(0x4A, 0x73)
#define REG_SC_BK4A_73_H      _PK_H_(0x4A, 0x73)
#define REG_SC_BK4A_74_L      _PK_L_(0x4A, 0x74)
#define REG_SC_BK4A_74_H      _PK_H_(0x4A, 0x74)
#define REG_SC_BK4A_75_L      _PK_L_(0x4A, 0x75)
#define REG_SC_BK4A_75_H      _PK_H_(0x4A, 0x75)
#define REG_SC_BK4A_76_L      _PK_L_(0x4A, 0x76)
#define REG_SC_BK4A_76_H      _PK_H_(0x4A, 0x76)
#define REG_SC_BK4A_77_L      _PK_L_(0x4A, 0x77)
#define REG_SC_BK4A_77_H      _PK_H_(0x4A, 0x77)
#define REG_SC_BK4A_78_L      _PK_L_(0x4A, 0x78)
#define REG_SC_BK4A_78_H      _PK_H_(0x4A, 0x78)
#define REG_SC_BK4A_79_L      _PK_L_(0x4A, 0x79)
#define REG_SC_BK4A_79_H      _PK_H_(0x4A, 0x79)
#define REG_SC_BK4A_7A_L      _PK_L_(0x4A, 0x7A)
#define REG_SC_BK4A_7A_H      _PK_H_(0x4A, 0x7A)
#define REG_SC_BK4A_7B_L      _PK_L_(0x4A, 0x7B)
#define REG_SC_BK4A_7B_H      _PK_H_(0x4A, 0x7B)
#define REG_SC_BK4A_7C_L      _PK_L_(0x4A, 0x7C)
#define REG_SC_BK4A_7C_H      _PK_H_(0x4A, 0x7C)
#define REG_SC_BK4A_7D_L      _PK_L_(0x4A, 0x7D)
#define REG_SC_BK4A_7D_H      _PK_H_(0x4A, 0x7D)
#define REG_SC_BK4A_7E_L      _PK_L_(0x4A, 0x7E)
#define REG_SC_BK4A_7E_H      _PK_H_(0x4A, 0x7E)
#define REG_SC_BK4A_7F_L      _PK_L_(0x4A, 0x7F)
#define REG_SC_BK4A_7F_H      _PK_H_(0x4A, 0x7F)


//----------------------------------------------
//  BK4B: DWIN0 DI
//----------------------------------------------
#define REG_SC_BK4B_10_L      _PK_L_(0x4B, 0x10)
#define REG_SC_BK4B_10_H      _PK_H_(0x4B, 0x10)
#define REG_SC_BK4B_78_L      _PK_L_(0x4B, 0x78)
#define REG_SC_BK4B_78_H      _PK_H_(0x4B, 0x78)
#define REG_SC_BK4B_79_L      _PK_L_(0x4B, 0x79)
#define REG_SC_BK4B_79_H      _PK_H_(0x4B, 0x79)

//----------------------------------------------
//  BK4C
//----------------------------------------------
#define REG_SC_BK4C_00_L      _PK_L_(0x4C, 0x00)
#define REG_SC_BK4C_00_H      _PK_H_(0x4C, 0x00)
#define REG_SC_BK4C_01_L      _PK_L_(0x4C, 0x01)
#define REG_SC_BK4C_01_H      _PK_H_(0x4C, 0x01)
#define REG_SC_BK4C_02_L      _PK_L_(0x4C, 0x02)
#define REG_SC_BK4C_02_H      _PK_H_(0x4C, 0x02)
#define REG_SC_BK4C_03_L      _PK_L_(0x4C, 0x03)
#define REG_SC_BK4C_03_H      _PK_H_(0x4C, 0x03)
#define REG_SC_BK4C_04_L      _PK_L_(0x4C, 0x04)
#define REG_SC_BK4C_04_H      _PK_H_(0x4C, 0x04)
#define REG_SC_BK4C_05_L      _PK_L_(0x4C, 0x05)
#define REG_SC_BK4C_05_H      _PK_H_(0x4C, 0x05)
#define REG_SC_BK4C_06_L      _PK_L_(0x4C, 0x06)
#define REG_SC_BK4C_06_H      _PK_H_(0x4C, 0x06)
#define REG_SC_BK4C_07_L      _PK_L_(0x4C, 0x07)
#define REG_SC_BK4C_07_H      _PK_H_(0x4C, 0x07)
#define REG_SC_BK4C_08_L      _PK_L_(0x4C, 0x08)
#define REG_SC_BK4C_08_H      _PK_H_(0x4C, 0x08)
#define REG_SC_BK4C_09_L      _PK_L_(0x4C, 0x09)
#define REG_SC_BK4C_09_H      _PK_H_(0x4C, 0x09)
#define REG_SC_BK4C_0A_L      _PK_L_(0x4C, 0x0A)
#define REG_SC_BK4C_0A_H      _PK_H_(0x4C, 0x0A)
#define REG_SC_BK4C_0B_L      _PK_L_(0x4C, 0x0B)
#define REG_SC_BK4C_0B_H      _PK_H_(0x4C, 0x0B)
#define REG_SC_BK4C_0C_L      _PK_L_(0x4C, 0x0C)
#define REG_SC_BK4C_0C_H      _PK_H_(0x4C, 0x0C)
#define REG_SC_BK4C_0D_L      _PK_L_(0x4C, 0x0D)
#define REG_SC_BK4C_0D_H      _PK_H_(0x4C, 0x0D)
#define REG_SC_BK4C_0E_L      _PK_L_(0x4C, 0x0E)
#define REG_SC_BK4C_0E_H      _PK_H_(0x4C, 0x0E)
#define REG_SC_BK4C_0F_L      _PK_L_(0x4C, 0x0F)
#define REG_SC_BK4C_0F_H      _PK_H_(0x4C, 0x0F)
#define REG_SC_BK4C_10_L      _PK_L_(0x4C, 0x10)
#define REG_SC_BK4C_10_H      _PK_H_(0x4C, 0x10)
#define REG_SC_BK4C_11_L      _PK_L_(0x4C, 0x11)
#define REG_SC_BK4C_11_H      _PK_H_(0x4C, 0x11)
#define REG_SC_BK4C_12_L      _PK_L_(0x4C, 0x12)
#define REG_SC_BK4C_12_H      _PK_H_(0x4C, 0x12)
#define REG_SC_BK4C_13_L      _PK_L_(0x4C, 0x13)
#define REG_SC_BK4C_13_H      _PK_H_(0x4C, 0x13)
#define REG_SC_BK4C_14_L      _PK_L_(0x4C, 0x14)
#define REG_SC_BK4C_14_H      _PK_H_(0x4C, 0x14)
#define REG_SC_BK4C_15_L      _PK_L_(0x4C, 0x15)
#define REG_SC_BK4C_15_H      _PK_H_(0x4C, 0x15)
#define REG_SC_BK4C_16_L      _PK_L_(0x4C, 0x16)
#define REG_SC_BK4C_16_H      _PK_H_(0x4C, 0x16)
#define REG_SC_BK4C_17_L      _PK_L_(0x4C, 0x17)
#define REG_SC_BK4C_17_H      _PK_H_(0x4C, 0x17)
#define REG_SC_BK4C_18_L      _PK_L_(0x4C, 0x18)
#define REG_SC_BK4C_18_H      _PK_H_(0x4C, 0x18)
#define REG_SC_BK4C_19_L      _PK_L_(0x4C, 0x19)
#define REG_SC_BK4C_19_H      _PK_H_(0x4C, 0x19)
#define REG_SC_BK4C_1A_L      _PK_L_(0x4C, 0x1A)
#define REG_SC_BK4C_1A_H      _PK_H_(0x4C, 0x1A)
#define REG_SC_BK4C_1B_L      _PK_L_(0x4C, 0x1B)
#define REG_SC_BK4C_1B_H      _PK_H_(0x4C, 0x1B)
#define REG_SC_BK4C_1C_L      _PK_L_(0x4C, 0x1C)
#define REG_SC_BK4C_1C_H      _PK_H_(0x4C, 0x1C)
#define REG_SC_BK4C_1D_L      _PK_L_(0x4C, 0x1D)
#define REG_SC_BK4C_1D_H      _PK_H_(0x4C, 0x1D)
#define REG_SC_BK4C_1E_L      _PK_L_(0x4C, 0x1E)
#define REG_SC_BK4C_1E_H      _PK_H_(0x4C, 0x1E)
#define REG_SC_BK4C_1F_L      _PK_L_(0x4C, 0x1F)
#define REG_SC_BK4C_1F_H      _PK_H_(0x4C, 0x1F)
#define REG_SC_BK4C_20_L      _PK_L_(0x4C, 0x20)
#define REG_SC_BK4C_20_H      _PK_H_(0x4C, 0x20)
#define REG_SC_BK4C_21_L      _PK_L_(0x4C, 0x21)
#define REG_SC_BK4C_21_H      _PK_H_(0x4C, 0x21)
#define REG_SC_BK4C_22_L      _PK_L_(0x4C, 0x22)
#define REG_SC_BK4C_22_H      _PK_H_(0x4C, 0x22)
#define REG_SC_BK4C_23_L      _PK_L_(0x4C, 0x23)
#define REG_SC_BK4C_23_H      _PK_H_(0x4C, 0x23)
#define REG_SC_BK4C_24_L      _PK_L_(0x4C, 0x24)
#define REG_SC_BK4C_24_H      _PK_H_(0x4C, 0x24)
#define REG_SC_BK4C_25_L      _PK_L_(0x4C, 0x25)
#define REG_SC_BK4C_25_H      _PK_H_(0x4C, 0x25)
#define REG_SC_BK4C_26_L      _PK_L_(0x4C, 0x26)
#define REG_SC_BK4C_26_H      _PK_H_(0x4C, 0x26)
#define REG_SC_BK4C_27_L      _PK_L_(0x4C, 0x27)
#define REG_SC_BK4C_27_H      _PK_H_(0x4C, 0x27)
#define REG_SC_BK4C_28_L      _PK_L_(0x4C, 0x28)
#define REG_SC_BK4C_28_H      _PK_H_(0x4C, 0x28)
#define REG_SC_BK4C_29_L      _PK_L_(0x4C, 0x29)
#define REG_SC_BK4C_29_H      _PK_H_(0x4C, 0x29)
#define REG_SC_BK4C_2A_L      _PK_L_(0x4C, 0x2A)
#define REG_SC_BK4C_2A_H      _PK_H_(0x4C, 0x2A)
#define REG_SC_BK4C_2B_L      _PK_L_(0x4C, 0x2B)
#define REG_SC_BK4C_2B_H      _PK_H_(0x4C, 0x2B)
#define REG_SC_BK4C_2C_L      _PK_L_(0x4C, 0x2C)
#define REG_SC_BK4C_2C_H      _PK_H_(0x4C, 0x2C)
#define REG_SC_BK4C_2D_L      _PK_L_(0x4C, 0x2D)
#define REG_SC_BK4C_2D_H      _PK_H_(0x4C, 0x2D)
#define REG_SC_BK4C_2E_L      _PK_L_(0x4C, 0x2E)
#define REG_SC_BK4C_2E_H      _PK_H_(0x4C, 0x2E)
#define REG_SC_BK4C_2F_L      _PK_L_(0x4C, 0x2F)
#define REG_SC_BK4C_2F_H      _PK_H_(0x4C, 0x2F)
#define REG_SC_BK4C_30_L      _PK_L_(0x4C, 0x30)
#define REG_SC_BK4C_30_H      _PK_H_(0x4C, 0x30)
#define REG_SC_BK4C_31_L      _PK_L_(0x4C, 0x31)
#define REG_SC_BK4C_31_H      _PK_H_(0x4C, 0x31)
#define REG_SC_BK4C_32_L      _PK_L_(0x4C, 0x32)
#define REG_SC_BK4C_32_H      _PK_H_(0x4C, 0x32)
#define REG_SC_BK4C_33_L      _PK_L_(0x4C, 0x33)
#define REG_SC_BK4C_33_H      _PK_H_(0x4C, 0x33)
#define REG_SC_BK4C_34_L      _PK_L_(0x4C, 0x34)
#define REG_SC_BK4C_34_H      _PK_H_(0x4C, 0x34)
#define REG_SC_BK4C_35_L      _PK_L_(0x4C, 0x35)
#define REG_SC_BK4C_35_H      _PK_H_(0x4C, 0x35)
#define REG_SC_BK4C_36_L      _PK_L_(0x4C, 0x36)
#define REG_SC_BK4C_36_H      _PK_H_(0x4C, 0x36)
#define REG_SC_BK4C_37_L      _PK_L_(0x4C, 0x37)
#define REG_SC_BK4C_37_H      _PK_H_(0x4C, 0x37)
#define REG_SC_BK4C_38_L      _PK_L_(0x4C, 0x38)
#define REG_SC_BK4C_38_H      _PK_H_(0x4C, 0x38)
#define REG_SC_BK4C_39_L      _PK_L_(0x4C, 0x39)
#define REG_SC_BK4C_39_H      _PK_H_(0x4C, 0x39)
#define REG_SC_BK4C_3A_L      _PK_L_(0x4C, 0x3A)
#define REG_SC_BK4C_3A_H      _PK_H_(0x4C, 0x3A)
#define REG_SC_BK4C_3B_L      _PK_L_(0x4C, 0x3B)
#define REG_SC_BK4C_3B_H      _PK_H_(0x4C, 0x3B)
#define REG_SC_BK4C_3C_L      _PK_L_(0x4C, 0x3C)
#define REG_SC_BK4C_3C_H      _PK_H_(0x4C, 0x3C)
#define REG_SC_BK4C_3D_L      _PK_L_(0x4C, 0x3D)
#define REG_SC_BK4C_3D_H      _PK_H_(0x4C, 0x3D)
#define REG_SC_BK4C_3E_L      _PK_L_(0x4C, 0x3E)
#define REG_SC_BK4C_3E_H      _PK_H_(0x4C, 0x3E)
#define REG_SC_BK4C_3F_L      _PK_L_(0x4C, 0x3F)
#define REG_SC_BK4C_3F_H      _PK_H_(0x4C, 0x3F)
#define REG_SC_BK4C_40_L      _PK_L_(0x4C, 0x40)
#define REG_SC_BK4C_40_H      _PK_H_(0x4C, 0x40)
#define REG_SC_BK4C_41_L      _PK_L_(0x4C, 0x41)
#define REG_SC_BK4C_41_H      _PK_H_(0x4C, 0x41)
#define REG_SC_BK4C_42_L      _PK_L_(0x4C, 0x42)
#define REG_SC_BK4C_42_H      _PK_H_(0x4C, 0x42)
#define REG_SC_BK4C_43_L      _PK_L_(0x4C, 0x43)
#define REG_SC_BK4C_43_H      _PK_H_(0x4C, 0x43)
#define REG_SC_BK4C_44_L      _PK_L_(0x4C, 0x44)
#define REG_SC_BK4C_44_H      _PK_H_(0x4C, 0x44)
#define REG_SC_BK4C_45_L      _PK_L_(0x4C, 0x45)
#define REG_SC_BK4C_45_H      _PK_H_(0x4C, 0x45)
#define REG_SC_BK4C_46_L      _PK_L_(0x4C, 0x46)
#define REG_SC_BK4C_46_H      _PK_H_(0x4C, 0x46)
#define REG_SC_BK4C_47_L      _PK_L_(0x4C, 0x47)
#define REG_SC_BK4C_47_H      _PK_H_(0x4C, 0x47)
#define REG_SC_BK4C_48_L      _PK_L_(0x4C, 0x48)
#define REG_SC_BK4C_48_H      _PK_H_(0x4C, 0x48)
#define REG_SC_BK4C_49_H      _PK_H_(0x4C, 0x49)
#define REG_SC_BK4C_4A_L      _PK_L_(0x4C, 0x4A)
#define REG_SC_BK4C_4A_H      _PK_H_(0x4C, 0x4A)
#define REG_SC_BK4C_4B_L      _PK_L_(0x4C, 0x4B)
#define REG_SC_BK4C_4B_H      _PK_H_(0x4C, 0x4B)
#define REG_SC_BK4C_4C_L      _PK_L_(0x4C, 0x4C)
#define REG_SC_BK4C_4C_H      _PK_H_(0x4C, 0x4C)
#define REG_SC_BK4C_4D_L      _PK_L_(0x4C, 0x4D)
#define REG_SC_BK4C_4D_H      _PK_H_(0x4C, 0x4D)
#define REG_SC_BK4C_4E_L      _PK_L_(0x4C, 0x4E)
#define REG_SC_BK4C_4E_H      _PK_H_(0x4C, 0x4E)
#define REG_SC_BK4C_4F_L      _PK_L_(0x4C, 0x4F)
#define REG_SC_BK4C_4F_H      _PK_H_(0x4C, 0x4F)
#define REG_SC_BK4C_50_L      _PK_L_(0x4C, 0x50)
#define REG_SC_BK4C_50_H      _PK_H_(0x4C, 0x50)
#define REG_SC_BK4C_51_L      _PK_L_(0x4C, 0x51)
#define REG_SC_BK4C_51_H      _PK_H_(0x4C, 0x51)
#define REG_SC_BK4C_52_L      _PK_L_(0x4C, 0x52)
#define REG_SC_BK4C_52_H      _PK_H_(0x4C, 0x52)
#define REG_SC_BK4C_53_L      _PK_L_(0x4C, 0x53)
#define REG_SC_BK4C_53_H      _PK_H_(0x4C, 0x53)
#define REG_SC_BK4C_54_L      _PK_L_(0x4C, 0x54)
#define REG_SC_BK4C_54_H      _PK_H_(0x4C, 0x54)
#define REG_SC_BK4C_55_L      _PK_L_(0x4C, 0x55)
#define REG_SC_BK4C_55_H      _PK_H_(0x4C, 0x55)
#define REG_SC_BK4C_56_L      _PK_L_(0x4C, 0x56)
#define REG_SC_BK4C_56_H      _PK_H_(0x4C, 0x56)
#define REG_SC_BK4C_57_L      _PK_L_(0x4C, 0x57)
#define REG_SC_BK4C_57_H      _PK_H_(0x4C, 0x57)
#define REG_SC_BK4C_58_L      _PK_L_(0x4C, 0x58)
#define REG_SC_BK4C_58_H      _PK_H_(0x4C, 0x58)
#define REG_SC_BK4C_59_L      _PK_L_(0x4C, 0x59)
#define REG_SC_BK4C_59_H      _PK_H_(0x4C, 0x59)
#define REG_SC_BK4C_5A_L      _PK_L_(0x4C, 0x5A)
#define REG_SC_BK4C_5A_H      _PK_H_(0x4C, 0x5A)
#define REG_SC_BK4C_5B_L      _PK_L_(0x4C, 0x5B)
#define REG_SC_BK4C_5B_H      _PK_H_(0x4C, 0x5B)
#define REG_SC_BK4C_5C_L      _PK_L_(0x4C, 0x5C)
#define REG_SC_BK4C_5C_H      _PK_H_(0x4C, 0x5C)
#define REG_SC_BK4C_5D_L      _PK_L_(0x4C, 0x5D)
#define REG_SC_BK4C_5D_H      _PK_H_(0x4C, 0x5D)
#define REG_SC_BK4C_5E_L      _PK_L_(0x4C, 0x5E)
#define REG_SC_BK4C_5E_H      _PK_H_(0x4C, 0x5E)
#define REG_SC_BK4C_5F_L      _PK_L_(0x4C, 0x5F)
#define REG_SC_BK4C_5F_H      _PK_H_(0x4C, 0x5F)
#define REG_SC_BK4C_60_L      _PK_L_(0x4C, 0x60)
#define REG_SC_BK4C_60_H      _PK_H_(0x4C, 0x60)
#define REG_SC_BK4C_61_L      _PK_L_(0x4C, 0x61)
#define REG_SC_BK4C_61_H      _PK_H_(0x4C, 0x61)
#define REG_SC_BK4C_62_L      _PK_L_(0x4C, 0x62)
#define REG_SC_BK4C_62_H      _PK_H_(0x4C, 0x62)
#define REG_SC_BK4C_63_L      _PK_L_(0x4C, 0x63)
#define REG_SC_BK4C_63_H      _PK_H_(0x4C, 0x63)
#define REG_SC_BK4C_64_L      _PK_L_(0x4C, 0x64)
#define REG_SC_BK4C_64_H      _PK_H_(0x4C, 0x64)
#define REG_SC_BK4C_65_L      _PK_L_(0x4C, 0x65)
#define REG_SC_BK4C_65_H      _PK_H_(0x4C, 0x65)
#define REG_SC_BK4C_66_L      _PK_L_(0x4C, 0x66)
#define REG_SC_BK4C_66_H      _PK_H_(0x4C, 0x66)
#define REG_SC_BK4C_67_L      _PK_L_(0x4C, 0x67)
#define REG_SC_BK4C_67_H      _PK_H_(0x4C, 0x67)
#define REG_SC_BK4C_68_L      _PK_L_(0x4C, 0x68)
#define REG_SC_BK4C_68_H      _PK_H_(0x4C, 0x68)
#define REG_SC_BK4C_69_L      _PK_L_(0x4C, 0x69)
#define REG_SC_BK4C_69_H      _PK_H_(0x4C, 0x69)
#define REG_SC_BK4C_6A_L      _PK_L_(0x4C, 0x6A)
#define REG_SC_BK4C_6A_H      _PK_H_(0x4C, 0x6A)
#define REG_SC_BK4C_6B_L      _PK_L_(0x4C, 0x6B)
#define REG_SC_BK4C_6B_H      _PK_H_(0x4C, 0x6B)
#define REG_SC_BK4C_6C_L      _PK_L_(0x4C, 0x6C)
#define REG_SC_BK4C_6C_H      _PK_H_(0x4C, 0x6C)
#define REG_SC_BK4C_6D_L      _PK_L_(0x4C, 0x6D)
#define REG_SC_BK4C_6D_H      _PK_H_(0x4C, 0x6D)
#define REG_SC_BK4C_6E_L      _PK_L_(0x4C, 0x6E)
#define REG_SC_BK4C_6E_H      _PK_H_(0x4C, 0x6E)
#define REG_SC_BK4C_6F_L      _PK_L_(0x4C, 0x6F)
#define REG_SC_BK4C_6F_H      _PK_H_(0x4C, 0x6F)
#define REG_SC_BK4C_70_L      _PK_L_(0x4C, 0x70)
#define REG_SC_BK4C_70_H      _PK_H_(0x4C, 0x70)
#define REG_SC_BK4C_71_L      _PK_L_(0x4C, 0x71)
#define REG_SC_BK4C_71_H      _PK_H_(0x4C, 0x71)
#define REG_SC_BK4C_72_L      _PK_L_(0x4C, 0x72)
#define REG_SC_BK4C_72_H      _PK_H_(0x4C, 0x72)
#define REG_SC_BK4C_73_L      _PK_L_(0x4C, 0x73)
#define REG_SC_BK4C_73_H      _PK_H_(0x4C, 0x73)
#define REG_SC_BK4C_74_L      _PK_L_(0x4C, 0x74)
#define REG_SC_BK4C_74_H      _PK_H_(0x4C, 0x74)
#define REG_SC_BK4C_75_L      _PK_L_(0x4C, 0x75)
#define REG_SC_BK4C_75_H      _PK_H_(0x4C, 0x75)
#define REG_SC_BK4C_76_L      _PK_L_(0x4C, 0x76)
#define REG_SC_BK4C_76_H      _PK_H_(0x4C, 0x76)
#define REG_SC_BK4C_77_L      _PK_L_(0x4C, 0x77)
#define REG_SC_BK4C_77_H      _PK_H_(0x4C, 0x77)
#define REG_SC_BK4C_78_L      _PK_L_(0x4C, 0x78)
#define REG_SC_BK4C_78_H      _PK_H_(0x4C, 0x78)
#define REG_SC_BK4C_79_L      _PK_L_(0x4C, 0x79)
#define REG_SC_BK4C_79_H      _PK_H_(0x4C, 0x79)
#define REG_SC_BK4C_7A_L      _PK_L_(0x4C, 0x7A)
#define REG_SC_BK4C_7A_H      _PK_H_(0x4C, 0x7A)
#define REG_SC_BK4C_7B_L      _PK_L_(0x4C, 0x7B)
#define REG_SC_BK4C_7B_H      _PK_H_(0x4C, 0x7B)
#define REG_SC_BK4C_7C_L      _PK_L_(0x4C, 0x7C)
#define REG_SC_BK4C_7C_H      _PK_H_(0x4C, 0x7C)
#define REG_SC_BK4C_7D_L      _PK_L_(0x4C, 0x7D)
#define REG_SC_BK4C_7D_H      _PK_H_(0x4C, 0x7D)
#define REG_SC_BK4C_7E_L      _PK_L_(0x4C, 0x7E)
#define REG_SC_BK4C_7E_H      _PK_H_(0x4C, 0x7E)
#define REG_SC_BK4C_7F_L      _PK_L_(0x4C, 0x7F)
#define REG_SC_BK4C_7F_H      _PK_H_(0x4C, 0x7F)


//  BK4E: DWIN0 HVSP
#define REG_SC_BK4E_07_L      _PK_L_(0x4E, 0x07)
#define REG_SC_BK4E_07_H      _PK_H_(0x4E, 0x07)
#define REG_SC_BK4E_08_L      _PK_L_(0x4E, 0x08)
#define REG_SC_BK4E_08_H      _PK_H_(0x4E, 0x08)
#define REG_SC_BK4E_09_L      _PK_L_(0x4E, 0x09)
#define REG_SC_BK4E_09_H      _PK_H_(0x4E, 0x09)
#define REG_SC_BK4E_13_L      _PK_L_(0x4E, 0x13)
#define REG_SC_BK4E_21_L      _PK_L_(0x4E, 0x21)
#define REG_SC_BK4E_21_H      _PK_H_(0x4E, 0x21)
#define REG_SC_BK4E_22_L      _PK_L_(0x4E, 0x22)
#define REG_SC_BK4E_22_H      _PK_H_(0x4E, 0x22)
#define REG_SC_BK4E_23_L      _PK_L_(0x4E, 0x23)
#define REG_SC_BK4E_23_H      _PK_H_(0x4E, 0x23)
#define REG_SC_BK4E_24_L      _PK_L_(0x4E, 0x24)
#define REG_SC_BK4E_24_H      _PK_H_(0x4E, 0x24)
#define REG_SC_BK4E_25_L      _PK_L_(0x4E, 0x25)
#define REG_SC_BK4E_25_H      _PK_H_(0x4E, 0x25)
#define REG_SC_BK4E_41_L      _PK_L_(0x4E, 0x41)
#define REG_SC_BK4E_42_L      _PK_L_(0x4E, 0x42)
#define REG_SC_BK4E_43_L      _PK_L_(0x4E, 0x43)
#define REG_SC_BK4E_44_L      _PK_L_(0x4E, 0x44)
#define REG_SC_BK4E_45_L      _PK_L_(0x4E, 0x45)
#define REG_SC_BK4E_49_L      _PK_L_(0x4E, 0x49)
#define REG_SC_BK4E_4A_L      _PK_L_(0x4E, 0x4A)
#define REG_SC_BK4E_5F_L      _PK_L_(0x4E, 0x5F)
#define REG_SC_BK4E_0A_L      _PK_L_(0x4E, 0x0A)
#define REG_SC_BK4E_0A_H      _PK_H_(0x4E, 0x0A)
#define REG_SC_BK4E_0B_L      _PK_L_(0x4E, 0x0B)
#define REG_SC_BK4E_70_L      _PK_L_(0x4E, 0x70)
#define REG_SC_BK4E_70_H      _PK_H_(0x4E, 0x70)
//----------------------------------------------

//----------------------------------------------
//  BK4F
//----------------------------------------------
#define REG_SC_BK4F_00_L      _PK_L_(0x4F, 0x00)
#define REG_SC_BK4F_00_H      _PK_H_(0x4F, 0x00)
#define REG_SC_BK4F_01_L      _PK_L_(0x4F, 0x01)
#define REG_SC_BK4F_01_H      _PK_H_(0x4F, 0x01)
#define REG_SC_BK4F_02_L      _PK_L_(0x4F, 0x02)
#define REG_SC_BK4F_02_H      _PK_H_(0x4F, 0x02)
#define REG_SC_BK4F_03_L      _PK_L_(0x4F, 0x03)
#define REG_SC_BK4F_03_H      _PK_H_(0x4F, 0x03)
#define REG_SC_BK4F_04_L      _PK_L_(0x4F, 0x04)
#define REG_SC_BK4F_04_H      _PK_H_(0x4F, 0x04)
#define REG_SC_BK4F_05_L      _PK_L_(0x4F, 0x05)
#define REG_SC_BK4F_05_H      _PK_H_(0x4F, 0x05)
#define REG_SC_BK4F_06_L      _PK_L_(0x4F, 0x06)
#define REG_SC_BK4F_06_H      _PK_H_(0x4F, 0x06)
#define REG_SC_BK4F_07_L      _PK_L_(0x4F, 0x07)
#define REG_SC_BK4F_07_H      _PK_H_(0x4F, 0x07)
#define REG_SC_BK4F_08_L      _PK_L_(0x4F, 0x08)
#define REG_SC_BK4F_08_H      _PK_H_(0x4F, 0x08)
#define REG_SC_BK4F_09_L      _PK_L_(0x4F, 0x09)
#define REG_SC_BK4F_09_H      _PK_H_(0x4F, 0x09)
#define REG_SC_BK4F_0A_L      _PK_L_(0x4F, 0x0A)
#define REG_SC_BK4F_0A_H      _PK_H_(0x4F, 0x0A)
#define REG_SC_BK4F_0B_L      _PK_L_(0x4F, 0x0B)
#define REG_SC_BK4F_0B_H      _PK_H_(0x4F, 0x0B)
#define REG_SC_BK4F_0C_L      _PK_L_(0x4F, 0x0C)
#define REG_SC_BK4F_0C_H      _PK_H_(0x4F, 0x0C)
#define REG_SC_BK4F_0D_L      _PK_L_(0x4F, 0x0D)
#define REG_SC_BK4F_0D_H      _PK_H_(0x4F, 0x0D)
#define REG_SC_BK4F_0E_L      _PK_L_(0x4F, 0x0E)
#define REG_SC_BK4F_0E_H      _PK_H_(0x4F, 0x0E)
#define REG_SC_BK4F_0F_L      _PK_L_(0x4F, 0x0F)
#define REG_SC_BK4F_0F_H      _PK_H_(0x4F, 0x0F)
#define REG_SC_BK4F_10_L      _PK_L_(0x4F, 0x10)
#define REG_SC_BK4F_10_H      _PK_H_(0x4F, 0x10)
#define REG_SC_BK4F_11_L      _PK_L_(0x4F, 0x11)
#define REG_SC_BK4F_11_H      _PK_H_(0x4F, 0x11)
#define REG_SC_BK4F_12_L      _PK_L_(0x4F, 0x12)
#define REG_SC_BK4F_12_H      _PK_H_(0x4F, 0x12)
#define REG_SC_BK4F_13_L      _PK_L_(0x4F, 0x13)
#define REG_SC_BK4F_13_H      _PK_H_(0x4F, 0x13)
#define REG_SC_BK4F_14_L      _PK_L_(0x4F, 0x14)
#define REG_SC_BK4F_14_H      _PK_H_(0x4F, 0x14)
#define REG_SC_BK4F_15_L      _PK_L_(0x4F, 0x15)
#define REG_SC_BK4F_15_H      _PK_H_(0x4F, 0x15)
#define REG_SC_BK4F_16_L      _PK_L_(0x4F, 0x16)
#define REG_SC_BK4F_16_H      _PK_H_(0x4F, 0x16)
#define REG_SC_BK4F_17_L      _PK_L_(0x4F, 0x17)
#define REG_SC_BK4F_17_H      _PK_H_(0x4F, 0x17)
#define REG_SC_BK4F_18_L      _PK_L_(0x4F, 0x18)
#define REG_SC_BK4F_18_H      _PK_H_(0x4F, 0x18)
#define REG_SC_BK4F_19_L      _PK_L_(0x4F, 0x19)
#define REG_SC_BK4F_19_H      _PK_H_(0x4F, 0x19)
#define REG_SC_BK4F_1A_L      _PK_L_(0x4F, 0x1A)
#define REG_SC_BK4F_1A_H      _PK_H_(0x4F, 0x1A)
#define REG_SC_BK4F_1B_L      _PK_L_(0x4F, 0x1B)
#define REG_SC_BK4F_1B_H      _PK_H_(0x4F, 0x1B)
#define REG_SC_BK4F_1C_L      _PK_L_(0x4F, 0x1C)
#define REG_SC_BK4F_1C_H      _PK_H_(0x4F, 0x1C)
#define REG_SC_BK4F_1D_L      _PK_L_(0x4F, 0x1D)
#define REG_SC_BK4F_1D_H      _PK_H_(0x4F, 0x1D)
#define REG_SC_BK4F_1E_L      _PK_L_(0x4F, 0x1E)
#define REG_SC_BK4F_1E_H      _PK_H_(0x4F, 0x1E)
#define REG_SC_BK4F_1F_L      _PK_L_(0x4F, 0x1F)
#define REG_SC_BK4F_1F_H      _PK_H_(0x4F, 0x1F)
#define REG_SC_BK4F_20_L      _PK_L_(0x4F, 0x20)
#define REG_SC_BK4F_20_H      _PK_H_(0x4F, 0x20)
#define REG_SC_BK4F_21_L      _PK_L_(0x4F, 0x21)
#define REG_SC_BK4F_21_H      _PK_H_(0x4F, 0x21)
#define REG_SC_BK4F_22_L      _PK_L_(0x4F, 0x22)
#define REG_SC_BK4F_22_H      _PK_H_(0x4F, 0x22)
#define REG_SC_BK4F_23_L      _PK_L_(0x4F, 0x23)
#define REG_SC_BK4F_23_H      _PK_H_(0x4F, 0x23)
#define REG_SC_BK4F_24_L      _PK_L_(0x4F, 0x24)
#define REG_SC_BK4F_24_H      _PK_H_(0x4F, 0x24)
#define REG_SC_BK4F_25_L      _PK_L_(0x4F, 0x25)
#define REG_SC_BK4F_25_H      _PK_H_(0x4F, 0x25)
#define REG_SC_BK4F_26_L      _PK_L_(0x4F, 0x26)
#define REG_SC_BK4F_26_H      _PK_H_(0x4F, 0x26)
#define REG_SC_BK4F_27_L      _PK_L_(0x4F, 0x27)
#define REG_SC_BK4F_27_H      _PK_H_(0x4F, 0x27)
#define REG_SC_BK4F_28_L      _PK_L_(0x4F, 0x28)
#define REG_SC_BK4F_28_H      _PK_H_(0x4F, 0x28)
#define REG_SC_BK4F_29_L      _PK_L_(0x4F, 0x29)
#define REG_SC_BK4F_29_H      _PK_H_(0x4F, 0x29)
#define REG_SC_BK4F_2A_L      _PK_L_(0x4F, 0x2A)
#define REG_SC_BK4F_2A_H      _PK_H_(0x4F, 0x2A)
#define REG_SC_BK4F_2B_L      _PK_L_(0x4F, 0x2B)
#define REG_SC_BK4F_2B_H      _PK_H_(0x4F, 0x2B)
#define REG_SC_BK4F_2C_L      _PK_L_(0x4F, 0x2C)
#define REG_SC_BK4F_2C_H      _PK_H_(0x4F, 0x2C)
#define REG_SC_BK4F_2D_L      _PK_L_(0x4F, 0x2D)
#define REG_SC_BK4F_2D_H      _PK_H_(0x4F, 0x2D)
#define REG_SC_BK4F_2E_L      _PK_L_(0x4F, 0x2E)
#define REG_SC_BK4F_2E_H      _PK_H_(0x4F, 0x2E)
#define REG_SC_BK4F_2F_L      _PK_L_(0x4F, 0x2F)
#define REG_SC_BK4F_2F_H      _PK_H_(0x4F, 0x2F)
#define REG_SC_BK4F_30_L      _PK_L_(0x4F, 0x30)
#define REG_SC_BK4F_30_H      _PK_H_(0x4F, 0x30)
#define REG_SC_BK4F_31_L      _PK_L_(0x4F, 0x31)
#define REG_SC_BK4F_31_H      _PK_H_(0x4F, 0x31)
#define REG_SC_BK4F_32_L      _PK_L_(0x4F, 0x32)
#define REG_SC_BK4F_32_H      _PK_H_(0x4F, 0x32)
#define REG_SC_BK4F_33_L      _PK_L_(0x4F, 0x33)
#define REG_SC_BK4F_33_H      _PK_H_(0x4F, 0x33)
#define REG_SC_BK4F_34_L      _PK_L_(0x4F, 0x34)
#define REG_SC_BK4F_34_H      _PK_H_(0x4F, 0x34)
#define REG_SC_BK4F_35_L      _PK_L_(0x4F, 0x35)
#define REG_SC_BK4F_35_H      _PK_H_(0x4F, 0x35)
#define REG_SC_BK4F_36_L      _PK_L_(0x4F, 0x36)
#define REG_SC_BK4F_36_H      _PK_H_(0x4F, 0x36)
#define REG_SC_BK4F_37_L      _PK_L_(0x4F, 0x37)
#define REG_SC_BK4F_37_H      _PK_H_(0x4F, 0x37)
#define REG_SC_BK4F_38_L      _PK_L_(0x4F, 0x38)
#define REG_SC_BK4F_38_H      _PK_H_(0x4F, 0x38)
#define REG_SC_BK4F_39_L      _PK_L_(0x4F, 0x39)
#define REG_SC_BK4F_39_H      _PK_H_(0x4F, 0x39)
#define REG_SC_BK4F_3A_L      _PK_L_(0x4F, 0x3A)
#define REG_SC_BK4F_3A_H      _PK_H_(0x4F, 0x3A)
#define REG_SC_BK4F_3B_L      _PK_L_(0x4F, 0x3B)
#define REG_SC_BK4F_3B_H      _PK_H_(0x4F, 0x3B)
#define REG_SC_BK4F_3C_L      _PK_L_(0x4F, 0x3C)
#define REG_SC_BK4F_3C_H      _PK_H_(0x4F, 0x3C)
#define REG_SC_BK4F_3D_L      _PK_L_(0x4F, 0x3D)
#define REG_SC_BK4F_3D_H      _PK_H_(0x4F, 0x3D)
#define REG_SC_BK4F_3E_L      _PK_L_(0x4F, 0x3E)
#define REG_SC_BK4F_3E_H      _PK_H_(0x4F, 0x3E)
#define REG_SC_BK4F_3F_L      _PK_L_(0x4F, 0x3F)
#define REG_SC_BK4F_3F_H      _PK_H_(0x4F, 0x3F)
#define REG_SC_BK4F_40_L      _PK_L_(0x4F, 0x40)
#define REG_SC_BK4F_40_H      _PK_H_(0x4F, 0x40)
#define REG_SC_BK4F_41_L      _PK_L_(0x4F, 0x41)
#define REG_SC_BK4F_41_H      _PK_H_(0x4F, 0x41)
#define REG_SC_BK4F_42_L      _PK_L_(0x4F, 0x42)
#define REG_SC_BK4F_42_H      _PK_H_(0x4F, 0x42)
#define REG_SC_BK4F_43_L      _PK_L_(0x4F, 0x43)
#define REG_SC_BK4F_43_H      _PK_H_(0x4F, 0x43)
#define REG_SC_BK4F_44_L      _PK_L_(0x4F, 0x44)
#define REG_SC_BK4F_44_H      _PK_H_(0x4F, 0x44)
#define REG_SC_BK4F_45_L      _PK_L_(0x4F, 0x45)
#define REG_SC_BK4F_45_H      _PK_H_(0x4F, 0x45)
#define REG_SC_BK4F_46_L      _PK_L_(0x4F, 0x46)
#define REG_SC_BK4F_46_H      _PK_H_(0x4F, 0x46)
#define REG_SC_BK4F_47_L      _PK_L_(0x4F, 0x47)
#define REG_SC_BK4F_47_H      _PK_H_(0x4F, 0x47)
#define REG_SC_BK4F_48_L      _PK_L_(0x4F, 0x48)
#define REG_SC_BK4F_48_H      _PK_H_(0x4F, 0x48)
#define REG_SC_BK4F_49_H      _PK_H_(0x4F, 0x49)
#define REG_SC_BK4F_4A_L      _PK_L_(0x4F, 0x4A)
#define REG_SC_BK4F_4A_H      _PK_H_(0x4F, 0x4A)
#define REG_SC_BK4F_4B_L      _PK_L_(0x4F, 0x4B)
#define REG_SC_BK4F_4B_H      _PK_H_(0x4F, 0x4B)
#define REG_SC_BK4F_4C_L      _PK_L_(0x4F, 0x4C)
#define REG_SC_BK4F_4C_H      _PK_H_(0x4F, 0x4C)
#define REG_SC_BK4F_4D_L      _PK_L_(0x4F, 0x4D)
#define REG_SC_BK4F_4D_H      _PK_H_(0x4F, 0x4D)
#define REG_SC_BK4F_4E_L      _PK_L_(0x4F, 0x4E)
#define REG_SC_BK4F_4E_H      _PK_H_(0x4F, 0x4E)
#define REG_SC_BK4F_4F_L      _PK_L_(0x4F, 0x4F)
#define REG_SC_BK4F_4F_H      _PK_H_(0x4F, 0x4F)
#define REG_SC_BK4F_50_L      _PK_L_(0x4F, 0x50)
#define REG_SC_BK4F_50_H      _PK_H_(0x4F, 0x50)
#define REG_SC_BK4F_51_L      _PK_L_(0x4F, 0x51)
#define REG_SC_BK4F_51_H      _PK_H_(0x4F, 0x51)
#define REG_SC_BK4F_52_L      _PK_L_(0x4F, 0x52)
#define REG_SC_BK4F_52_H      _PK_H_(0x4F, 0x52)
#define REG_SC_BK4F_53_L      _PK_L_(0x4F, 0x53)
#define REG_SC_BK4F_53_H      _PK_H_(0x4F, 0x53)
#define REG_SC_BK4F_54_L      _PK_L_(0x4F, 0x54)
#define REG_SC_BK4F_54_H      _PK_H_(0x4F, 0x54)
#define REG_SC_BK4F_55_L      _PK_L_(0x4F, 0x55)
#define REG_SC_BK4F_55_H      _PK_H_(0x4F, 0x55)
#define REG_SC_BK4F_56_L      _PK_L_(0x4F, 0x56)
#define REG_SC_BK4F_56_H      _PK_H_(0x4F, 0x56)
#define REG_SC_BK4F_57_L      _PK_L_(0x4F, 0x57)
#define REG_SC_BK4F_57_H      _PK_H_(0x4F, 0x57)
#define REG_SC_BK4F_58_L      _PK_L_(0x4F, 0x58)
#define REG_SC_BK4F_58_H      _PK_H_(0x4F, 0x58)
#define REG_SC_BK4F_59_L      _PK_L_(0x4F, 0x59)
#define REG_SC_BK4F_59_H      _PK_H_(0x4F, 0x59)
#define REG_SC_BK4F_5A_L      _PK_L_(0x4F, 0x5A)
#define REG_SC_BK4F_5A_H      _PK_H_(0x4F, 0x5A)
#define REG_SC_BK4F_5B_L      _PK_L_(0x4F, 0x5B)
#define REG_SC_BK4F_5B_H      _PK_H_(0x4F, 0x5B)
#define REG_SC_BK4F_5C_L      _PK_L_(0x4F, 0x5C)
#define REG_SC_BK4F_5C_H      _PK_H_(0x4F, 0x5C)
#define REG_SC_BK4F_5D_L      _PK_L_(0x4F, 0x5D)
#define REG_SC_BK4F_5D_H      _PK_H_(0x4F, 0x5D)
#define REG_SC_BK4F_5E_L      _PK_L_(0x4F, 0x5E)
#define REG_SC_BK4F_5E_H      _PK_H_(0x4F, 0x5E)
#define REG_SC_BK4F_5F_L      _PK_L_(0x4F, 0x5F)
#define REG_SC_BK4F_5F_H      _PK_H_(0x4F, 0x5F)
#define REG_SC_BK4F_60_L      _PK_L_(0x4F, 0x60)
#define REG_SC_BK4F_60_H      _PK_H_(0x4F, 0x60)
#define REG_SC_BK4F_61_L      _PK_L_(0x4F, 0x61)
#define REG_SC_BK4F_61_H      _PK_H_(0x4F, 0x61)
#define REG_SC_BK4F_62_L      _PK_L_(0x4F, 0x62)
#define REG_SC_BK4F_62_H      _PK_H_(0x4F, 0x62)
#define REG_SC_BK4F_63_L      _PK_L_(0x4F, 0x63)
#define REG_SC_BK4F_63_H      _PK_H_(0x4F, 0x63)
#define REG_SC_BK4F_64_L      _PK_L_(0x4F, 0x64)
#define REG_SC_BK4F_64_H      _PK_H_(0x4F, 0x64)
#define REG_SC_BK4F_65_L      _PK_L_(0x4F, 0x65)
#define REG_SC_BK4F_65_H      _PK_H_(0x4F, 0x65)
#define REG_SC_BK4F_66_L      _PK_L_(0x4F, 0x66)
#define REG_SC_BK4F_66_H      _PK_H_(0x4F, 0x66)
#define REG_SC_BK4F_67_L      _PK_L_(0x4F, 0x67)
#define REG_SC_BK4F_67_H      _PK_H_(0x4F, 0x67)
#define REG_SC_BK4F_68_L      _PK_L_(0x4F, 0x68)
#define REG_SC_BK4F_68_H      _PK_H_(0x4F, 0x68)
#define REG_SC_BK4F_69_L      _PK_L_(0x4F, 0x69)
#define REG_SC_BK4F_69_H      _PK_H_(0x4F, 0x69)
#define REG_SC_BK4F_6A_L      _PK_L_(0x4F, 0x6A)
#define REG_SC_BK4F_6A_H      _PK_H_(0x4F, 0x6A)
#define REG_SC_BK4F_6B_L      _PK_L_(0x4F, 0x6B)
#define REG_SC_BK4F_6B_H      _PK_H_(0x4F, 0x6B)
#define REG_SC_BK4F_6C_L      _PK_L_(0x4F, 0x6C)
#define REG_SC_BK4F_6C_H      _PK_H_(0x4F, 0x6C)
#define REG_SC_BK4F_6D_L      _PK_L_(0x4F, 0x6D)
#define REG_SC_BK4F_6D_H      _PK_H_(0x4F, 0x6D)
#define REG_SC_BK4F_6E_L      _PK_L_(0x4F, 0x6E)
#define REG_SC_BK4F_6E_H      _PK_H_(0x4F, 0x6E)
#define REG_SC_BK4F_6F_L      _PK_L_(0x4F, 0x6F)
#define REG_SC_BK4F_6F_H      _PK_H_(0x4F, 0x6F)
#define REG_SC_BK4F_70_L      _PK_L_(0x4F, 0x70)
#define REG_SC_BK4F_70_H      _PK_H_(0x4F, 0x70)
#define REG_SC_BK4F_71_L      _PK_L_(0x4F, 0x71)
#define REG_SC_BK4F_71_H      _PK_H_(0x4F, 0x71)
#define REG_SC_BK4F_72_L      _PK_L_(0x4F, 0x72)
#define REG_SC_BK4F_72_H      _PK_H_(0x4F, 0x72)
#define REG_SC_BK4F_73_L      _PK_L_(0x4F, 0x73)
#define REG_SC_BK4F_73_H      _PK_H_(0x4F, 0x73)
#define REG_SC_BK4F_74_L      _PK_L_(0x4F, 0x74)
#define REG_SC_BK4F_74_H      _PK_H_(0x4F, 0x74)
#define REG_SC_BK4F_75_L      _PK_L_(0x4F, 0x75)
#define REG_SC_BK4F_75_H      _PK_H_(0x4F, 0x75)
#define REG_SC_BK4F_76_L      _PK_L_(0x4F, 0x76)
#define REG_SC_BK4F_76_H      _PK_H_(0x4F, 0x76)
#define REG_SC_BK4F_77_L      _PK_L_(0x4F, 0x77)
#define REG_SC_BK4F_77_H      _PK_H_(0x4F, 0x77)
#define REG_SC_BK4F_78_L      _PK_L_(0x4F, 0x78)
#define REG_SC_BK4F_78_H      _PK_H_(0x4F, 0x78)
#define REG_SC_BK4F_79_L      _PK_L_(0x4F, 0x79)
#define REG_SC_BK4F_79_H      _PK_H_(0x4F, 0x79)
#define REG_SC_BK4F_7A_L      _PK_L_(0x4F, 0x7A)
#define REG_SC_BK4F_7A_H      _PK_H_(0x4F, 0x7A)
#define REG_SC_BK4F_7B_L      _PK_L_(0x4F, 0x7B)
#define REG_SC_BK4F_7B_H      _PK_H_(0x4F, 0x7B)
#define REG_SC_BK4F_7C_L      _PK_L_(0x4F, 0x7C)
#define REG_SC_BK4F_7C_H      _PK_H_(0x4F, 0x7C)
#define REG_SC_BK4F_7D_L      _PK_L_(0x4F, 0x7D)
#define REG_SC_BK4F_7D_H      _PK_H_(0x4F, 0x7D)
#define REG_SC_BK4F_7E_L      _PK_L_(0x4F, 0x7E)
#define REG_SC_BK4F_7E_H      _PK_H_(0x4F, 0x7E)
#define REG_SC_BK4F_7F_L      _PK_L_(0x4F, 0x7F)
#define REG_SC_BK4F_7F_H      _PK_H_(0x4F, 0x7F)

//----------------------------------------------
//  BK51:
//----------------------------------------------
#define REG_SC_BK51_00_L      _PK_L_(0x51, 0x00)
#define REG_SC_BK51_00_H      _PK_H_(0x51, 0x00)
#define REG_SC_BK51_01_L      _PK_L_(0x51, 0x01)
#define REG_SC_BK51_01_H      _PK_H_(0x51, 0x01)
#define REG_SC_BK51_02_L      _PK_L_(0x51, 0x02)
#define REG_SC_BK51_02_H      _PK_H_(0x51, 0x02)
#define REG_SC_BK51_03_L      _PK_L_(0x51, 0x03)
#define REG_SC_BK51_03_H      _PK_H_(0x51, 0x03)
#define REG_SC_BK51_04_L      _PK_L_(0x51, 0x04)
#define REG_SC_BK51_04_H      _PK_H_(0x51, 0x04)
#define REG_SC_BK51_05_L      _PK_L_(0x51, 0x05)
#define REG_SC_BK51_05_H      _PK_H_(0x51, 0x05)
#define REG_SC_BK51_06_L      _PK_L_(0x51, 0x06)
#define REG_SC_BK51_06_H      _PK_H_(0x51, 0x06)
#define REG_SC_BK51_07_L      _PK_L_(0x51, 0x07)
#define REG_SC_BK51_07_H      _PK_H_(0x51, 0x07)
#define REG_SC_BK51_08_L      _PK_L_(0x51, 0x08)
#define REG_SC_BK51_08_H      _PK_H_(0x51, 0x08)
#define REG_SC_BK51_09_L      _PK_L_(0x51, 0x09)
#define REG_SC_BK51_0A_L      _PK_L_(0x51, 0x0A)
#define REG_SC_BK51_0A_H      _PK_H_(0x51, 0x0A)
#define REG_SC_BK51_0B_L      _PK_L_(0x51, 0x0B)
#define REG_SC_BK51_0B_H      _PK_H_(0x51, 0x0B)
#define REG_SC_BK51_0C_L      _PK_L_(0x51, 0x0C)
#define REG_SC_BK51_0C_H      _PK_H_(0x51, 0x0C)
#define REG_SC_BK51_0D_L      _PK_L_(0x51, 0x0D)
#define REG_SC_BK51_0D_H      _PK_H_(0x51, 0x0D)
#define REG_SC_BK51_0E_L      _PK_L_(0x51, 0x0E)
#define REG_SC_BK51_0E_H      _PK_H_(0x51, 0x0E)
#define REG_SC_BK51_0F_L      _PK_L_(0x51, 0x0F)
#define REG_SC_BK51_0F_H      _PK_H_(0x51, 0x0F)
#define REG_SC_BK51_10_L      _PK_L_(0x51, 0x10)
#define REG_SC_BK51_10_H      _PK_H_(0x51, 0x10)
#define REG_SC_BK51_11_L      _PK_L_(0x51, 0x11)
#define REG_SC_BK51_11_H      _PK_H_(0x51, 0x11)
#define REG_SC_BK51_12_L      _PK_L_(0x51, 0x12)
#define REG_SC_BK51_12_H      _PK_H_(0x51, 0x12)
#define REG_SC_BK51_13_L      _PK_L_(0x51, 0x13)
#define REG_SC_BK51_13_H      _PK_H_(0x51, 0x13)
#define REG_SC_BK51_14_L      _PK_L_(0x51, 0x14)
#define REG_SC_BK51_14_H      _PK_H_(0x51, 0x14)
#define REG_SC_BK51_15_L      _PK_L_(0x51, 0x15)
#define REG_SC_BK51_15_H      _PK_H_(0x51, 0x15)
#define REG_SC_BK51_16_L      _PK_L_(0x51, 0x16)
#define REG_SC_BK51_16_H      _PK_H_(0x51, 0x16)
#define REG_SC_BK51_17_L      _PK_L_(0x51, 0x17)
#define REG_SC_BK51_17_H      _PK_H_(0x51, 0x17)
#define REG_SC_BK51_18_L      _PK_L_(0x51, 0x18)
#define REG_SC_BK51_18_H      _PK_H_(0x51, 0x18)
#define REG_SC_BK51_19_L      _PK_L_(0x51, 0x19)
#define REG_SC_BK51_19_H      _PK_H_(0x51, 0x19)
#define REG_SC_BK51_1A_L      _PK_L_(0x51, 0x1A)
#define REG_SC_BK51_1A_H      _PK_H_(0x51, 0x1A)
#define REG_SC_BK51_1B_L      _PK_L_(0x51, 0x1B)
#define REG_SC_BK51_1B_H      _PK_H_(0x51, 0x1B)
#define REG_SC_BK51_1C_L      _PK_L_(0x51, 0x1C)
#define REG_SC_BK51_1C_H      _PK_H_(0x51, 0x1C)
#define REG_SC_BK51_1D_L      _PK_L_(0x51, 0x1D)
#define REG_SC_BK51_1D_H      _PK_H_(0x51, 0x1D)
#define REG_SC_BK51_1E_L      _PK_L_(0x51, 0x1E)
#define REG_SC_BK51_1E_H      _PK_H_(0x51, 0x1E)
#define REG_SC_BK51_1F_L      _PK_L_(0x51, 0x1F)
#define REG_SC_BK51_1F_H      _PK_H_(0x51, 0x1F)
#define REG_SC_BK51_20_L      _PK_L_(0x51, 0x20)
#define REG_SC_BK51_20_H      _PK_H_(0x51, 0x20)
#define REG_SC_BK51_21_L      _PK_L_(0x51, 0x21)
#define REG_SC_BK51_21_H      _PK_H_(0x51, 0x21)
#define REG_SC_BK51_22_L      _PK_L_(0x51, 0x22)
#define REG_SC_BK51_22_H      _PK_H_(0x51, 0x22)
#define REG_SC_BK51_23_L      _PK_L_(0x51, 0x23)
#define REG_SC_BK51_23_H      _PK_H_(0x51, 0x23)
#define REG_SC_BK51_24_L      _PK_L_(0x51, 0x24)
#define REG_SC_BK51_24_H      _PK_H_(0x51, 0x24)
#define REG_SC_BK51_25_L      _PK_L_(0x51, 0x25)
#define REG_SC_BK51_25_H      _PK_H_(0x51, 0x25)
#define REG_SC_BK51_26_L      _PK_L_(0x51, 0x26)
#define REG_SC_BK51_26_H      _PK_H_(0x51, 0x26)
#define REG_SC_BK51_27_L      _PK_L_(0x51, 0x27)
#define REG_SC_BK51_27_H      _PK_H_(0x51, 0x27)
#define REG_SC_BK51_28_L      _PK_L_(0x51, 0x28)
#define REG_SC_BK51_28_H      _PK_H_(0x51, 0x28)
#define REG_SC_BK51_29_L      _PK_L_(0x51, 0x29)
#define REG_SC_BK51_29_H      _PK_H_(0x51, 0x29)
#define REG_SC_BK51_2A_L      _PK_L_(0x51, 0x2A)
#define REG_SC_BK51_2A_H      _PK_H_(0x51, 0x2A)
#define REG_SC_BK51_2B_L      _PK_L_(0x51, 0x2B)
#define REG_SC_BK51_2B_H      _PK_H_(0x51, 0x2B)
#define REG_SC_BK51_2C_L      _PK_L_(0x51, 0x2C)
#define REG_SC_BK51_2C_H      _PK_H_(0x51, 0x2C)
#define REG_SC_BK51_2D_L      _PK_L_(0x51, 0x2D)
#define REG_SC_BK51_2D_H      _PK_H_(0x51, 0x2D)
#define REG_SC_BK51_2E_L      _PK_L_(0x51, 0x2E)
#define REG_SC_BK51_2E_H      _PK_H_(0x51, 0x2E)
#define REG_SC_BK51_2F_L      _PK_L_(0x51, 0x2F)
#define REG_SC_BK51_2F_H      _PK_H_(0x51, 0x2F)
#define REG_SC_BK51_30_L      _PK_L_(0x51, 0x30)
#define REG_SC_BK51_30_H      _PK_H_(0x51, 0x30)
#define REG_SC_BK51_31_L      _PK_L_(0x51, 0x31)
#define REG_SC_BK51_31_H      _PK_H_(0x51, 0x31)
#define REG_SC_BK51_32_L      _PK_L_(0x51, 0x32)
#define REG_SC_BK51_32_H      _PK_H_(0x51, 0x32)
#define REG_SC_BK51_33_L      _PK_L_(0x51, 0x33)
#define REG_SC_BK51_33_H      _PK_H_(0x51, 0x33)
#define REG_SC_BK51_34_L      _PK_L_(0x51, 0x34)
#define REG_SC_BK51_34_H      _PK_H_(0x51, 0x34)
#define REG_SC_BK51_35_L      _PK_L_(0x51, 0x35)
#define REG_SC_BK51_35_H      _PK_H_(0x51, 0x35)
#define REG_SC_BK51_36_L      _PK_L_(0x51, 0x36)
#define REG_SC_BK51_36_H      _PK_H_(0x51, 0x36)
#define REG_SC_BK51_37_L      _PK_L_(0x51, 0x37)
#define REG_SC_BK51_37_H      _PK_H_(0x51, 0x37)
#define REG_SC_BK51_38_L      _PK_L_(0x51, 0x38)
#define REG_SC_BK51_38_H      _PK_H_(0x51, 0x38)
#define REG_SC_BK51_39_L      _PK_L_(0x51, 0x39)
#define REG_SC_BK51_39_H      _PK_H_(0x51, 0x39)
#define REG_SC_BK51_3A_L      _PK_L_(0x51, 0x3A)
#define REG_SC_BK51_3A_H      _PK_H_(0x51, 0x3A)
#define REG_SC_BK51_3B_L      _PK_L_(0x51, 0x3B)
#define REG_SC_BK51_3B_H      _PK_H_(0x51, 0x3B)
#define REG_SC_BK51_3C_L      _PK_L_(0x51, 0x3C)
#define REG_SC_BK51_3C_H      _PK_H_(0x51, 0x3C)
#define REG_SC_BK51_3D_L      _PK_L_(0x51, 0x3D)
#define REG_SC_BK51_3D_H      _PK_H_(0x51, 0x3D)
#define REG_SC_BK51_3E_L      _PK_L_(0x51, 0x3E)
#define REG_SC_BK51_3E_H      _PK_H_(0x51, 0x3E)
#define REG_SC_BK51_3F_L      _PK_L_(0x51, 0x3F)
#define REG_SC_BK51_3F_H      _PK_H_(0x51, 0x3F)
#define REG_SC_BK51_40_L      _PK_L_(0x51, 0x40)
#define REG_SC_BK51_40_H      _PK_H_(0x51, 0x40)
#define REG_SC_BK51_41_L      _PK_L_(0x51, 0x41)
#define REG_SC_BK51_41_H      _PK_H_(0x51, 0x41)
#define REG_SC_BK51_42_L      _PK_L_(0x51, 0x42)
#define REG_SC_BK51_42_H      _PK_H_(0x51, 0x42)
#define REG_SC_BK51_43_L      _PK_L_(0x51, 0x43)
#define REG_SC_BK51_43_H      _PK_H_(0x51, 0x43)
#define REG_SC_BK51_44_L      _PK_L_(0x51, 0x44)
#define REG_SC_BK51_44_H      _PK_H_(0x51, 0x44)
#define REG_SC_BK51_45_L      _PK_L_(0x51, 0x45)
#define REG_SC_BK51_45_H      _PK_H_(0x51, 0x45)
#define REG_SC_BK51_46_L      _PK_L_(0x51, 0x46)
#define REG_SC_BK51_46_H      _PK_H_(0x51, 0x46)
#define REG_SC_BK51_47_L      _PK_L_(0x51, 0x47)
#define REG_SC_BK51_47_H      _PK_H_(0x51, 0x47)
#define REG_SC_BK51_48_L      _PK_L_(0x51, 0x48)
#define REG_SC_BK51_48_H      _PK_H_(0x51, 0x48)
#define REG_SC_BK51_49_L      _PK_L_(0x51, 0x49)
#define REG_SC_BK51_49_H      _PK_H_(0x51, 0x49)
#define REG_SC_BK51_4A_L      _PK_L_(0x51, 0x4A)
#define REG_SC_BK51_4A_H      _PK_H_(0x51, 0x4A)
#define REG_SC_BK51_4B_L      _PK_L_(0x51, 0x4B)
#define REG_SC_BK51_4B_H      _PK_H_(0x51, 0x4B)
#define REG_SC_BK51_4C_L      _PK_L_(0x51, 0x4C)
#define REG_SC_BK51_4C_H      _PK_H_(0x51, 0x4C)
#define REG_SC_BK51_4D_L      _PK_L_(0x51, 0x4D)
#define REG_SC_BK51_4D_H      _PK_H_(0x51, 0x4D)
#define REG_SC_BK51_4E_L      _PK_L_(0x51, 0x4E)
#define REG_SC_BK51_4E_H      _PK_H_(0x51, 0x4E)
#define REG_SC_BK51_4F_L      _PK_L_(0x51, 0x4F)
#define REG_SC_BK51_4F_H      _PK_H_(0x51, 0x4F)
#define REG_SC_BK51_50_L      _PK_L_(0x51, 0x50)
#define REG_SC_BK51_50_H      _PK_H_(0x51, 0x50)
#define REG_SC_BK51_51_L      _PK_L_(0x51, 0x51)
#define REG_SC_BK51_51_H      _PK_H_(0x51, 0x51)
#define REG_SC_BK51_52_L      _PK_L_(0x51, 0x52)
#define REG_SC_BK51_52_H      _PK_H_(0x51, 0x52)
#define REG_SC_BK51_53_L      _PK_L_(0x51, 0x53)
#define REG_SC_BK51_53_H      _PK_H_(0x51, 0x53)
#define REG_SC_BK51_54_L      _PK_L_(0x51, 0x54)
#define REG_SC_BK51_54_H      _PK_H_(0x51, 0x54)
#define REG_SC_BK51_55_L      _PK_L_(0x51, 0x55)
#define REG_SC_BK51_55_H      _PK_H_(0x51, 0x55)
#define REG_SC_BK51_56_L      _PK_L_(0x51, 0x56)
#define REG_SC_BK51_56_H      _PK_H_(0x51, 0x56)
#define REG_SC_BK51_57_L      _PK_L_(0x51, 0x57)
#define REG_SC_BK51_57_H      _PK_H_(0x51, 0x57)
#define REG_SC_BK51_58_L      _PK_L_(0x51, 0x58)
#define REG_SC_BK51_58_H      _PK_H_(0x51, 0x58)
#define REG_SC_BK51_59_L      _PK_L_(0x51, 0x59)
#define REG_SC_BK51_59_H      _PK_H_(0x51, 0x59)
#define REG_SC_BK51_5A_L      _PK_L_(0x51, 0x5A)
#define REG_SC_BK51_5A_H      _PK_H_(0x51, 0x5A)
#define REG_SC_BK51_5B_L      _PK_L_(0x51, 0x5B)
#define REG_SC_BK51_5B_H      _PK_H_(0x51, 0x5B)
#define REG_SC_BK51_5C_L      _PK_L_(0x51, 0x5C)
#define REG_SC_BK51_5C_H      _PK_H_(0x51, 0x5C)
#define REG_SC_BK51_5D_L      _PK_L_(0x51, 0x5D)
#define REG_SC_BK51_5D_H      _PK_H_(0x51, 0x5D)
#define REG_SC_BK51_5E_L      _PK_L_(0x51, 0x5E)
#define REG_SC_BK51_5E_H      _PK_H_(0x51, 0x5E)
#define REG_SC_BK51_5F_L      _PK_L_(0x51, 0x5F)
#define REG_SC_BK51_5F_H      _PK_H_(0x51, 0x5F)
#define REG_SC_BK51_60_L      _PK_L_(0x51, 0x60)
#define REG_SC_BK51_60_H      _PK_H_(0x51, 0x60)
#define REG_SC_BK51_61_L      _PK_L_(0x51, 0x61)
#define REG_SC_BK51_61_H      _PK_H_(0x51, 0x61)
#define REG_SC_BK51_62_L      _PK_L_(0x51, 0x62)
#define REG_SC_BK51_62_H      _PK_H_(0x51, 0x62)
#define REG_SC_BK51_63_L      _PK_L_(0x51, 0x63)
#define REG_SC_BK51_63_H      _PK_H_(0x51, 0x63)
#define REG_SC_BK51_64_L      _PK_L_(0x51, 0x64)
#define REG_SC_BK51_64_H      _PK_H_(0x51, 0x64)
#define REG_SC_BK51_65_L      _PK_L_(0x51, 0x65)
#define REG_SC_BK51_65_H      _PK_H_(0x51, 0x65)
#define REG_SC_BK51_66_L      _PK_L_(0x51, 0x66)
#define REG_SC_BK51_66_H      _PK_H_(0x51, 0x66)
#define REG_SC_BK51_67_L      _PK_L_(0x51, 0x67)
#define REG_SC_BK51_67_H      _PK_H_(0x51, 0x67)
#define REG_SC_BK51_68_L      _PK_L_(0x51, 0x68)
#define REG_SC_BK51_68_H      _PK_H_(0x51, 0x68)
#define REG_SC_BK51_69_L      _PK_L_(0x51, 0x69)
#define REG_SC_BK51_69_H      _PK_H_(0x51, 0x69)
#define REG_SC_BK51_6A_L      _PK_L_(0x51, 0x6A)
#define REG_SC_BK51_6A_H      _PK_H_(0x51, 0x6A)
#define REG_SC_BK51_6B_L      _PK_L_(0x51, 0x6B)
#define REG_SC_BK51_6B_H      _PK_H_(0x51, 0x6B)
#define REG_SC_BK51_6C_L      _PK_L_(0x51, 0x6C)
#define REG_SC_BK51_6C_H      _PK_H_(0x51, 0x6C)
#define REG_SC_BK51_6D_L      _PK_L_(0x51, 0x6D)
#define REG_SC_BK51_6D_H      _PK_H_(0x51, 0x6D)
#define REG_SC_BK51_6E_L      _PK_L_(0x51, 0x6E)
#define REG_SC_BK51_6E_H      _PK_H_(0x51, 0x6E)
#define REG_SC_BK51_6F_L      _PK_L_(0x51, 0x6F)
#define REG_SC_BK51_6F_H      _PK_H_(0x51, 0x6F)
#define REG_SC_BK51_70_L      _PK_L_(0x51, 0x70)
#define REG_SC_BK51_70_H      _PK_H_(0x51, 0x70)
#define REG_SC_BK51_71_L      _PK_L_(0x51, 0x71)
#define REG_SC_BK51_71_H      _PK_H_(0x51, 0x71)
#define REG_SC_BK51_72_L      _PK_L_(0x51, 0x72)
#define REG_SC_BK51_72_H      _PK_H_(0x51, 0x72)
#define REG_SC_BK51_73_L      _PK_L_(0x51, 0x73)
#define REG_SC_BK51_73_H      _PK_H_(0x51, 0x73)
#define REG_SC_BK51_74_L      _PK_L_(0x51, 0x74)
#define REG_SC_BK51_74_H      _PK_H_(0x51, 0x74)
#define REG_SC_BK51_75_L      _PK_L_(0x51, 0x75)
#define REG_SC_BK51_75_H      _PK_H_(0x51, 0x75)
#define REG_SC_BK51_76_L      _PK_L_(0x51, 0x76)
#define REG_SC_BK51_76_H      _PK_H_(0x51, 0x76)
#define REG_SC_BK51_77_L      _PK_L_(0x51, 0x77)
#define REG_SC_BK51_77_H      _PK_H_(0x51, 0x77)
#define REG_SC_BK51_78_L      _PK_L_(0x51, 0x78)
#define REG_SC_BK51_78_H      _PK_H_(0x51, 0x78)
#define REG_SC_BK51_79_L      _PK_L_(0x51, 0x79)
#define REG_SC_BK51_79_H      _PK_H_(0x51, 0x79)
#define REG_SC_BK51_7A_L      _PK_L_(0x51, 0x7A)
#define REG_SC_BK51_7A_H      _PK_H_(0x51, 0x7A)
#define REG_SC_BK51_7B_L      _PK_L_(0x51, 0x7B)
#define REG_SC_BK51_7B_H      _PK_H_(0x51, 0x7B)
#define REG_SC_BK51_7C_L      _PK_L_(0x51, 0x7C)
#define REG_SC_BK51_7C_H      _PK_H_(0x51, 0x7C)
#define REG_SC_BK51_7D_L      _PK_L_(0x51, 0x7D)
#define REG_SC_BK51_7D_H      _PK_H_(0x51, 0x7D)
#define REG_SC_BK51_7E_L      _PK_L_(0x51, 0x7E)
#define REG_SC_BK51_7E_H      _PK_H_(0x51, 0x7E)
#define REG_SC_BK51_7F_L      _PK_L_(0x51, 0x7F)
#define REG_SC_BK51_7F_H      _PK_H_(0x51, 0x7F)



//----------------------------------------------
//  BK52:
//----------------------------------------------
#define REG_SC_BK52_00_L      _PK_L_(0x52, 0x00)
#define REG_SC_BK52_00_H      _PK_H_(0x52, 0x00)
#define REG_SC_BK52_01_L      _PK_L_(0x52, 0x01)
#define REG_SC_BK52_01_H      _PK_H_(0x52, 0x01)
#define REG_SC_BK52_02_L      _PK_L_(0x52, 0x02)
#define REG_SC_BK52_02_H      _PK_H_(0x52, 0x02)
#define REG_SC_BK52_03_L      _PK_L_(0x52, 0x03)
#define REG_SC_BK52_03_H      _PK_H_(0x52, 0x03)
#define REG_SC_BK52_04_L      _PK_L_(0x52, 0x04)
#define REG_SC_BK52_04_H      _PK_H_(0x52, 0x04)
#define REG_SC_BK52_05_L      _PK_L_(0x52, 0x05)
#define REG_SC_BK52_05_H      _PK_H_(0x52, 0x05)
#define REG_SC_BK52_06_L      _PK_L_(0x52, 0x06)
#define REG_SC_BK52_06_H      _PK_H_(0x52, 0x06)
#define REG_SC_BK52_07_L      _PK_L_(0x52, 0x07)
#define REG_SC_BK52_07_H      _PK_H_(0x52, 0x07)
#define REG_SC_BK52_08_L      _PK_L_(0x52, 0x08)
#define REG_SC_BK52_08_H      _PK_H_(0x52, 0x08)
#define REG_SC_BK52_09_L      _PK_L_(0x52, 0x09)
#define REG_SC_BK52_0A_L      _PK_L_(0x52, 0x0A)
#define REG_SC_BK52_0A_H      _PK_H_(0x52, 0x0A)
#define REG_SC_BK52_0B_L      _PK_L_(0x52, 0x0B)
#define REG_SC_BK52_0B_H      _PK_H_(0x52, 0x0B)
#define REG_SC_BK52_0C_L      _PK_L_(0x52, 0x0C)
#define REG_SC_BK52_0C_H      _PK_H_(0x52, 0x0C)
#define REG_SC_BK52_0D_L      _PK_L_(0x52, 0x0D)
#define REG_SC_BK52_0D_H      _PK_H_(0x52, 0x0D)
#define REG_SC_BK52_0E_L      _PK_L_(0x52, 0x0E)
#define REG_SC_BK52_0E_H      _PK_H_(0x52, 0x0E)
#define REG_SC_BK52_0F_L      _PK_L_(0x52, 0x0F)
#define REG_SC_BK52_0F_H      _PK_H_(0x52, 0x0F)
#define REG_SC_BK52_10_L      _PK_L_(0x52, 0x10)
#define REG_SC_BK52_10_H      _PK_H_(0x52, 0x10)
#define REG_SC_BK52_11_L      _PK_L_(0x52, 0x11)
#define REG_SC_BK52_11_H      _PK_H_(0x52, 0x11)
#define REG_SC_BK52_12_L      _PK_L_(0x52, 0x12)
#define REG_SC_BK52_12_H      _PK_H_(0x52, 0x12)
#define REG_SC_BK52_13_L      _PK_L_(0x52, 0x13)
#define REG_SC_BK52_13_H      _PK_H_(0x52, 0x13)
#define REG_SC_BK52_14_L      _PK_L_(0x52, 0x14)
#define REG_SC_BK52_14_H      _PK_H_(0x52, 0x14)
#define REG_SC_BK52_15_L      _PK_L_(0x52, 0x15)
#define REG_SC_BK52_15_H      _PK_H_(0x52, 0x15)
#define REG_SC_BK52_16_L      _PK_L_(0x52, 0x16)
#define REG_SC_BK52_16_H      _PK_H_(0x52, 0x16)
#define REG_SC_BK52_17_L      _PK_L_(0x52, 0x17)
#define REG_SC_BK52_17_H      _PK_H_(0x52, 0x17)
#define REG_SC_BK52_18_L      _PK_L_(0x52, 0x18)
#define REG_SC_BK52_18_H      _PK_H_(0x52, 0x18)
#define REG_SC_BK52_19_L      _PK_L_(0x52, 0x19)
#define REG_SC_BK52_19_H      _PK_H_(0x52, 0x19)
#define REG_SC_BK52_1A_L      _PK_L_(0x52, 0x1A)
#define REG_SC_BK52_1A_H      _PK_H_(0x52, 0x1A)
#define REG_SC_BK52_1B_L      _PK_L_(0x52, 0x1B)
#define REG_SC_BK52_1B_H      _PK_H_(0x52, 0x1B)
#define REG_SC_BK52_1C_L      _PK_L_(0x52, 0x1C)
#define REG_SC_BK52_1C_H      _PK_H_(0x52, 0x1C)
#define REG_SC_BK52_1D_L      _PK_L_(0x52, 0x1D)
#define REG_SC_BK52_1D_H      _PK_H_(0x52, 0x1D)
#define REG_SC_BK52_1E_L      _PK_L_(0x52, 0x1E)
#define REG_SC_BK52_1E_H      _PK_H_(0x52, 0x1E)
#define REG_SC_BK52_1F_L      _PK_L_(0x52, 0x1F)
#define REG_SC_BK52_1F_H      _PK_H_(0x52, 0x1F)
#define REG_SC_BK52_20_L      _PK_L_(0x52, 0x20)
#define REG_SC_BK52_20_H      _PK_H_(0x52, 0x20)
#define REG_SC_BK52_21_L      _PK_L_(0x52, 0x21)
#define REG_SC_BK52_21_H      _PK_H_(0x52, 0x21)
#define REG_SC_BK52_22_L      _PK_L_(0x52, 0x22)
#define REG_SC_BK52_22_H      _PK_H_(0x52, 0x22)
#define REG_SC_BK52_23_L      _PK_L_(0x52, 0x23)
#define REG_SC_BK52_23_H      _PK_H_(0x52, 0x23)
#define REG_SC_BK52_24_L      _PK_L_(0x52, 0x24)
#define REG_SC_BK52_24_H      _PK_H_(0x52, 0x24)
#define REG_SC_BK52_25_L      _PK_L_(0x52, 0x25)
#define REG_SC_BK52_25_H      _PK_H_(0x52, 0x25)
#define REG_SC_BK52_26_L      _PK_L_(0x52, 0x26)
#define REG_SC_BK52_26_H      _PK_H_(0x52, 0x26)
#define REG_SC_BK52_27_L      _PK_L_(0x52, 0x27)
#define REG_SC_BK52_27_H      _PK_H_(0x52, 0x27)
#define REG_SC_BK52_28_L      _PK_L_(0x52, 0x28)
#define REG_SC_BK52_28_H      _PK_H_(0x52, 0x28)
#define REG_SC_BK52_29_L      _PK_L_(0x52, 0x29)
#define REG_SC_BK52_29_H      _PK_H_(0x52, 0x29)
#define REG_SC_BK52_2A_L      _PK_L_(0x52, 0x2A)
#define REG_SC_BK52_2A_H      _PK_H_(0x52, 0x2A)
#define REG_SC_BK52_2B_L      _PK_L_(0x52, 0x2B)
#define REG_SC_BK52_2B_H      _PK_H_(0x52, 0x2B)
#define REG_SC_BK52_2C_L      _PK_L_(0x52, 0x2C)
#define REG_SC_BK52_2C_H      _PK_H_(0x52, 0x2C)
#define REG_SC_BK52_2D_L      _PK_L_(0x52, 0x2D)
#define REG_SC_BK52_2D_H      _PK_H_(0x52, 0x2D)
#define REG_SC_BK52_2E_L      _PK_L_(0x52, 0x2E)
#define REG_SC_BK52_2E_H      _PK_H_(0x52, 0x2E)
#define REG_SC_BK52_2F_L      _PK_L_(0x52, 0x2F)
#define REG_SC_BK52_2F_H      _PK_H_(0x52, 0x2F)
#define REG_SC_BK52_30_L      _PK_L_(0x52, 0x30)
#define REG_SC_BK52_30_H      _PK_H_(0x52, 0x30)
#define REG_SC_BK52_31_L      _PK_L_(0x52, 0x31)
#define REG_SC_BK52_31_H      _PK_H_(0x52, 0x31)
#define REG_SC_BK52_32_L      _PK_L_(0x52, 0x32)
#define REG_SC_BK52_32_H      _PK_H_(0x52, 0x32)
#define REG_SC_BK52_33_L      _PK_L_(0x52, 0x33)
#define REG_SC_BK52_33_H      _PK_H_(0x52, 0x33)
#define REG_SC_BK52_34_L      _PK_L_(0x52, 0x34)
#define REG_SC_BK52_34_H      _PK_H_(0x52, 0x34)
#define REG_SC_BK52_35_L      _PK_L_(0x52, 0x35)
#define REG_SC_BK52_35_H      _PK_H_(0x52, 0x35)
#define REG_SC_BK52_36_L      _PK_L_(0x52, 0x36)
#define REG_SC_BK52_36_H      _PK_H_(0x52, 0x36)
#define REG_SC_BK52_37_L      _PK_L_(0x52, 0x37)
#define REG_SC_BK52_37_H      _PK_H_(0x52, 0x37)
#define REG_SC_BK52_38_L      _PK_L_(0x52, 0x38)
#define REG_SC_BK52_38_H      _PK_H_(0x52, 0x38)
#define REG_SC_BK52_39_L      _PK_L_(0x52, 0x39)
#define REG_SC_BK52_39_H      _PK_H_(0x52, 0x39)
#define REG_SC_BK52_3A_L      _PK_L_(0x52, 0x3A)
#define REG_SC_BK52_3A_H      _PK_H_(0x52, 0x3A)
#define REG_SC_BK52_3B_L      _PK_L_(0x52, 0x3B)
#define REG_SC_BK52_3B_H      _PK_H_(0x52, 0x3B)
#define REG_SC_BK52_3C_L      _PK_L_(0x52, 0x3C)
#define REG_SC_BK52_3C_H      _PK_H_(0x52, 0x3C)
#define REG_SC_BK52_3D_L      _PK_L_(0x52, 0x3D)
#define REG_SC_BK52_3D_H      _PK_H_(0x52, 0x3D)
#define REG_SC_BK52_3E_L      _PK_L_(0x52, 0x3E)
#define REG_SC_BK52_3E_H      _PK_H_(0x52, 0x3E)
#define REG_SC_BK52_3F_L      _PK_L_(0x52, 0x3F)
#define REG_SC_BK52_3F_H      _PK_H_(0x52, 0x3F)
#define REG_SC_BK52_40_L      _PK_L_(0x52, 0x40)
#define REG_SC_BK52_40_H      _PK_H_(0x52, 0x40)
#define REG_SC_BK52_41_L      _PK_L_(0x52, 0x41)
#define REG_SC_BK52_41_H      _PK_H_(0x52, 0x41)
#define REG_SC_BK52_42_L      _PK_L_(0x52, 0x42)
#define REG_SC_BK52_42_H      _PK_H_(0x52, 0x42)
#define REG_SC_BK52_43_L      _PK_L_(0x52, 0x43)
#define REG_SC_BK52_43_H      _PK_H_(0x52, 0x43)
#define REG_SC_BK52_44_L      _PK_L_(0x52, 0x44)
#define REG_SC_BK52_44_H      _PK_H_(0x52, 0x44)
#define REG_SC_BK52_45_L      _PK_L_(0x52, 0x45)
#define REG_SC_BK52_45_H      _PK_H_(0x52, 0x45)
#define REG_SC_BK52_46_L      _PK_L_(0x52, 0x46)
#define REG_SC_BK52_46_H      _PK_H_(0x52, 0x46)
#define REG_SC_BK52_47_L      _PK_L_(0x52, 0x47)
#define REG_SC_BK52_47_H      _PK_H_(0x52, 0x47)
#define REG_SC_BK52_48_L      _PK_L_(0x52, 0x48)
#define REG_SC_BK52_48_H      _PK_H_(0x52, 0x48)
#define REG_SC_BK52_49_L      _PK_L_(0x52, 0x49)
#define REG_SC_BK52_49_H      _PK_H_(0x52, 0x49)
#define REG_SC_BK52_4A_L      _PK_L_(0x52, 0x4A)
#define REG_SC_BK52_4A_H      _PK_H_(0x52, 0x4A)
#define REG_SC_BK52_4B_L      _PK_L_(0x52, 0x4B)
#define REG_SC_BK52_4B_H      _PK_H_(0x52, 0x4B)
#define REG_SC_BK52_4C_L      _PK_L_(0x52, 0x4C)
#define REG_SC_BK52_4C_H      _PK_H_(0x52, 0x4C)
#define REG_SC_BK52_4D_L      _PK_L_(0x52, 0x4D)
#define REG_SC_BK52_4D_H      _PK_H_(0x52, 0x4D)
#define REG_SC_BK52_4E_L      _PK_L_(0x52, 0x4E)
#define REG_SC_BK52_4E_H      _PK_H_(0x52, 0x4E)
#define REG_SC_BK52_4F_L      _PK_L_(0x52, 0x4F)
#define REG_SC_BK52_4F_H      _PK_H_(0x52, 0x4F)
#define REG_SC_BK52_50_L      _PK_L_(0x52, 0x50)
#define REG_SC_BK52_50_H      _PK_H_(0x52, 0x50)
#define REG_SC_BK52_51_L      _PK_L_(0x52, 0x51)
#define REG_SC_BK52_51_H      _PK_H_(0x52, 0x51)
#define REG_SC_BK52_52_L      _PK_L_(0x52, 0x52)
#define REG_SC_BK52_52_H      _PK_H_(0x52, 0x52)
#define REG_SC_BK52_53_L      _PK_L_(0x52, 0x53)
#define REG_SC_BK52_53_H      _PK_H_(0x52, 0x53)
#define REG_SC_BK52_54_L      _PK_L_(0x52, 0x54)
#define REG_SC_BK52_54_H      _PK_H_(0x52, 0x54)
#define REG_SC_BK52_55_L      _PK_L_(0x52, 0x55)
#define REG_SC_BK52_55_H      _PK_H_(0x52, 0x55)
#define REG_SC_BK52_56_L      _PK_L_(0x52, 0x56)
#define REG_SC_BK52_56_H      _PK_H_(0x52, 0x56)
#define REG_SC_BK52_57_L      _PK_L_(0x52, 0x57)
#define REG_SC_BK52_57_H      _PK_H_(0x52, 0x57)
#define REG_SC_BK52_58_L      _PK_L_(0x52, 0x58)
#define REG_SC_BK52_58_H      _PK_H_(0x52, 0x58)
#define REG_SC_BK52_59_L      _PK_L_(0x52, 0x59)
#define REG_SC_BK52_59_H      _PK_H_(0x52, 0x59)
#define REG_SC_BK52_5A_L      _PK_L_(0x52, 0x5A)
#define REG_SC_BK52_5A_H      _PK_H_(0x52, 0x5A)
#define REG_SC_BK52_5B_L      _PK_L_(0x52, 0x5B)
#define REG_SC_BK52_5B_H      _PK_H_(0x52, 0x5B)
#define REG_SC_BK52_5C_L      _PK_L_(0x52, 0x5C)
#define REG_SC_BK52_5C_H      _PK_H_(0x52, 0x5C)
#define REG_SC_BK52_5D_L      _PK_L_(0x52, 0x5D)
#define REG_SC_BK52_5D_H      _PK_H_(0x52, 0x5D)
#define REG_SC_BK52_5E_L      _PK_L_(0x52, 0x5E)
#define REG_SC_BK52_5E_H      _PK_H_(0x52, 0x5E)
#define REG_SC_BK52_5F_L      _PK_L_(0x52, 0x5F)
#define REG_SC_BK52_5F_H      _PK_H_(0x52, 0x5F)
#define REG_SC_BK52_60_L      _PK_L_(0x52, 0x60)
#define REG_SC_BK52_60_H      _PK_H_(0x52, 0x60)
#define REG_SC_BK52_61_L      _PK_L_(0x52, 0x61)
#define REG_SC_BK52_61_H      _PK_H_(0x52, 0x61)
#define REG_SC_BK52_62_L      _PK_L_(0x52, 0x62)
#define REG_SC_BK52_62_H      _PK_H_(0x52, 0x62)
#define REG_SC_BK52_63_L      _PK_L_(0x52, 0x63)
#define REG_SC_BK52_63_H      _PK_H_(0x52, 0x63)
#define REG_SC_BK52_64_L      _PK_L_(0x52, 0x64)
#define REG_SC_BK52_64_H      _PK_H_(0x52, 0x64)
#define REG_SC_BK52_65_L      _PK_L_(0x52, 0x65)
#define REG_SC_BK52_65_H      _PK_H_(0x52, 0x65)
#define REG_SC_BK52_66_L      _PK_L_(0x52, 0x66)
#define REG_SC_BK52_66_H      _PK_H_(0x52, 0x66)
#define REG_SC_BK52_67_L      _PK_L_(0x52, 0x67)
#define REG_SC_BK52_67_H      _PK_H_(0x52, 0x67)
#define REG_SC_BK52_68_L      _PK_L_(0x52, 0x68)
#define REG_SC_BK52_68_H      _PK_H_(0x52, 0x68)
#define REG_SC_BK52_69_L      _PK_L_(0x52, 0x69)
#define REG_SC_BK52_69_H      _PK_H_(0x52, 0x69)
#define REG_SC_BK52_6A_L      _PK_L_(0x52, 0x6A)
#define REG_SC_BK52_6A_H      _PK_H_(0x52, 0x6A)
#define REG_SC_BK52_6B_L      _PK_L_(0x52, 0x6B)
#define REG_SC_BK52_6B_H      _PK_H_(0x52, 0x6B)
#define REG_SC_BK52_6C_L      _PK_L_(0x52, 0x6C)
#define REG_SC_BK52_6C_H      _PK_H_(0x52, 0x6C)
#define REG_SC_BK52_6D_L      _PK_L_(0x52, 0x6D)
#define REG_SC_BK52_6D_H      _PK_H_(0x52, 0x6D)
#define REG_SC_BK52_6E_L      _PK_L_(0x52, 0x6E)
#define REG_SC_BK52_6E_H      _PK_H_(0x52, 0x6E)
#define REG_SC_BK52_6F_L      _PK_L_(0x52, 0x6F)
#define REG_SC_BK52_6F_H      _PK_H_(0x52, 0x6F)
#define REG_SC_BK52_70_L      _PK_L_(0x52, 0x70)
#define REG_SC_BK52_70_H      _PK_H_(0x52, 0x70)
#define REG_SC_BK52_71_L      _PK_L_(0x52, 0x71)
#define REG_SC_BK52_71_H      _PK_H_(0x52, 0x71)
#define REG_SC_BK52_72_L      _PK_L_(0x52, 0x72)
#define REG_SC_BK52_72_H      _PK_H_(0x52, 0x72)
#define REG_SC_BK52_73_L      _PK_L_(0x52, 0x73)
#define REG_SC_BK52_73_H      _PK_H_(0x52, 0x73)
#define REG_SC_BK52_74_L      _PK_L_(0x52, 0x74)
#define REG_SC_BK52_74_H      _PK_H_(0x52, 0x74)
#define REG_SC_BK52_75_L      _PK_L_(0x52, 0x75)
#define REG_SC_BK52_75_H      _PK_H_(0x52, 0x75)
#define REG_SC_BK52_76_L      _PK_L_(0x52, 0x76)
#define REG_SC_BK52_76_H      _PK_H_(0x52, 0x76)
#define REG_SC_BK52_77_L      _PK_L_(0x52, 0x77)
#define REG_SC_BK52_77_H      _PK_H_(0x52, 0x77)
#define REG_SC_BK52_78_L      _PK_L_(0x52, 0x78)
#define REG_SC_BK52_78_H      _PK_H_(0x52, 0x78)
#define REG_SC_BK52_79_L      _PK_L_(0x52, 0x79)
#define REG_SC_BK52_79_H      _PK_H_(0x52, 0x79)
#define REG_SC_BK52_7A_L      _PK_L_(0x52, 0x7A)
#define REG_SC_BK52_7A_H      _PK_H_(0x52, 0x7A)
#define REG_SC_BK52_7B_L      _PK_L_(0x52, 0x7B)
#define REG_SC_BK52_7B_H      _PK_H_(0x52, 0x7B)
#define REG_SC_BK52_7C_L      _PK_L_(0x52, 0x7C)
#define REG_SC_BK52_7C_H      _PK_H_(0x52, 0x7C)
#define REG_SC_BK52_7D_L      _PK_L_(0x52, 0x7D)
#define REG_SC_BK52_7D_H      _PK_H_(0x52, 0x7D)
#define REG_SC_BK52_7E_L      _PK_L_(0x52, 0x7E)
#define REG_SC_BK52_7E_H      _PK_H_(0x52, 0x7E)
#define REG_SC_BK52_7F_L      _PK_L_(0x52, 0x7F)
#define REG_SC_BK52_7F_H      _PK_H_(0x52, 0x7F)


//----------------------------------------------
//  BK55:
//----------------------------------------------
#define REG_SC_BK55_10_L      _PK_L_(0x55, 0x10)
#define REG_SC_BK55_10_H      _PK_H_(0x55, 0x10)
#define REG_SC_BK55_11_L      _PK_L_(0x55, 0x11)
#define REG_SC_BK55_11_H      _PK_H_(0x55, 0x11)
#define REG_SC_BK55_12_L      _PK_L_(0x55, 0x12)
#define REG_SC_BK55_12_H      _PK_H_(0x55, 0x12)
#define REG_SC_BK55_13_L      _PK_L_(0x55, 0x13)
#define REG_SC_BK55_13_H      _PK_H_(0x55, 0x13)

//----------------------------------------------
//  BK57:
//----------------------------------------------
#define REG_SC_BK57_00_L      _PK_L_(0x57, 0x00)
#define REG_SC_BK57_00_H      _PK_H_(0x57, 0x00)
#define REG_SC_BK57_01_L      _PK_L_(0x57, 0x01)
#define REG_SC_BK57_01_H      _PK_H_(0x57, 0x01)
#define REG_SC_BK57_02_L      _PK_L_(0x57, 0x02)
#define REG_SC_BK57_02_H      _PK_H_(0x57, 0x02)
#define REG_SC_BK57_03_L      _PK_L_(0x57, 0x03)
#define REG_SC_BK57_03_H      _PK_H_(0x57, 0x03)
#define REG_SC_BK57_04_L      _PK_L_(0x57, 0x04)
#define REG_SC_BK57_04_H      _PK_H_(0x57, 0x04)
#define REG_SC_BK57_05_L      _PK_L_(0x57, 0x05)
#define REG_SC_BK57_05_H      _PK_H_(0x57, 0x05)
#define REG_SC_BK57_06_L      _PK_L_(0x57, 0x06)
#define REG_SC_BK57_06_H      _PK_H_(0x57, 0x06)
#define REG_SC_BK57_07_L      _PK_L_(0x57, 0x07)
#define REG_SC_BK57_07_H      _PK_H_(0x57, 0x07)
#define REG_SC_BK57_08_L      _PK_L_(0x57, 0x08)
#define REG_SC_BK57_08_H      _PK_H_(0x57, 0x08)
#define REG_SC_BK57_09_L      _PK_L_(0x57, 0x09)
#define REG_SC_BK57_09_H      _PK_H_(0x57, 0x09)
#define REG_SC_BK57_0A_L      _PK_L_(0x57, 0x0A)
#define REG_SC_BK57_0A_H      _PK_H_(0x57, 0x0A)
#define REG_SC_BK57_0B_L      _PK_L_(0x57, 0x0B)
#define REG_SC_BK57_0B_H      _PK_H_(0x57, 0x0B)
#define REG_SC_BK57_0C_L      _PK_L_(0x57, 0x0C)
#define REG_SC_BK57_0C_H      _PK_H_(0x57, 0x0C)
#define REG_SC_BK57_0D_L      _PK_L_(0x57, 0x0D)
#define REG_SC_BK57_0D_H      _PK_H_(0x57, 0x0D)
#define REG_SC_BK57_0E_L      _PK_L_(0x57, 0x0E)
#define REG_SC_BK57_0E_H      _PK_H_(0x57, 0x0E)
#define REG_SC_BK57_0F_L      _PK_L_(0x57, 0x0F)
#define REG_SC_BK57_0F_H      _PK_H_(0x57, 0x0F)
#define REG_SC_BK57_10_L      _PK_L_(0x57, 0x10)
#define REG_SC_BK57_10_H      _PK_H_(0x57, 0x10)
#define REG_SC_BK57_11_L      _PK_L_(0x57, 0x11)
#define REG_SC_BK57_11_H      _PK_H_(0x57, 0x11)
#define REG_SC_BK57_12_L      _PK_L_(0x57, 0x12)
#define REG_SC_BK57_12_H      _PK_H_(0x57, 0x12)
#define REG_SC_BK57_13_L      _PK_L_(0x57, 0x13)
#define REG_SC_BK57_13_H      _PK_H_(0x57, 0x13)
#define REG_SC_BK57_14_L      _PK_L_(0x57, 0x14)
#define REG_SC_BK57_14_H      _PK_H_(0x57, 0x14)
#define REG_SC_BK57_15_L      _PK_L_(0x57, 0x15)
#define REG_SC_BK57_15_H      _PK_H_(0x57, 0x15)
#define REG_SC_BK57_16_L      _PK_L_(0x57, 0x16)
#define REG_SC_BK57_16_H      _PK_H_(0x57, 0x16)
#define REG_SC_BK57_17_L      _PK_L_(0x57, 0x17)
#define REG_SC_BK57_17_H      _PK_H_(0x57, 0x17)
#define REG_SC_BK57_18_L      _PK_L_(0x57, 0x18)
#define REG_SC_BK57_18_H      _PK_H_(0x57, 0x18)
#define REG_SC_BK57_19_L      _PK_L_(0x57, 0x19)
#define REG_SC_BK57_19_H      _PK_H_(0x57, 0x19)
#define REG_SC_BK57_1A_L      _PK_L_(0x57, 0x1A)
#define REG_SC_BK57_1A_H      _PK_H_(0x57, 0x1A)
#define REG_SC_BK57_1B_L      _PK_L_(0x57, 0x1B)
#define REG_SC_BK57_1B_H      _PK_H_(0x57, 0x1B)
#define REG_SC_BK57_1C_L      _PK_L_(0x57, 0x1C)
#define REG_SC_BK57_1C_H      _PK_H_(0x57, 0x1C)
#define REG_SC_BK57_1D_L      _PK_L_(0x57, 0x1D)
#define REG_SC_BK57_1D_H      _PK_H_(0x57, 0x1D)
#define REG_SC_BK57_1E_L      _PK_L_(0x57, 0x1E)
#define REG_SC_BK57_1E_H      _PK_H_(0x57, 0x1E)
#define REG_SC_BK57_1F_L      _PK_L_(0x57, 0x1F)
#define REG_SC_BK57_1F_H      _PK_H_(0x57, 0x1F)
#define REG_SC_BK57_20_L      _PK_L_(0x57, 0x20)
#define REG_SC_BK57_20_H      _PK_H_(0x57, 0x20)
#define REG_SC_BK57_21_L      _PK_L_(0x57, 0x21)
#define REG_SC_BK57_21_H      _PK_H_(0x57, 0x21)
#define REG_SC_BK57_22_L      _PK_L_(0x57, 0x22)
#define REG_SC_BK57_22_H      _PK_H_(0x57, 0x22)
#define REG_SC_BK57_23_L      _PK_L_(0x57, 0x23)
#define REG_SC_BK57_23_H      _PK_H_(0x57, 0x23)
#define REG_SC_BK57_24_L      _PK_L_(0x57, 0x24)
#define REG_SC_BK57_24_H      _PK_H_(0x57, 0x24)
#define REG_SC_BK57_25_L      _PK_L_(0x57, 0x25)
#define REG_SC_BK57_25_H      _PK_H_(0x57, 0x25)
#define REG_SC_BK57_26_L      _PK_L_(0x57, 0x26)
#define REG_SC_BK57_26_H      _PK_H_(0x57, 0x26)
#define REG_SC_BK57_27_L      _PK_L_(0x57, 0x27)
#define REG_SC_BK57_27_H      _PK_H_(0x57, 0x27)
#define REG_SC_BK57_28_L      _PK_L_(0x57, 0x28)
#define REG_SC_BK57_28_H      _PK_H_(0x57, 0x28)
#define REG_SC_BK57_29_L      _PK_L_(0x57, 0x29)
#define REG_SC_BK57_29_H      _PK_H_(0x57, 0x29)
#define REG_SC_BK57_2A_L      _PK_L_(0x57, 0x2A)
#define REG_SC_BK57_2A_H      _PK_H_(0x57, 0x2A)
#define REG_SC_BK57_2B_L      _PK_L_(0x57, 0x2B)
#define REG_SC_BK57_2B_H      _PK_H_(0x57, 0x2B)
#define REG_SC_BK57_2C_L      _PK_L_(0x57, 0x2C)
#define REG_SC_BK57_2C_H      _PK_H_(0x57, 0x2C)
#define REG_SC_BK57_2D_L      _PK_L_(0x57, 0x2D)
#define REG_SC_BK57_2D_H      _PK_H_(0x57, 0x2D)
#define REG_SC_BK57_2E_L      _PK_L_(0x57, 0x2E)
#define REG_SC_BK57_2E_H      _PK_H_(0x57, 0x2E)
#define REG_SC_BK57_2F_L      _PK_L_(0x57, 0x2F)
#define REG_SC_BK57_2F_H      _PK_H_(0x57, 0x2F)
#define REG_SC_BK57_30_L      _PK_L_(0x57, 0x30)
#define REG_SC_BK57_30_H      _PK_H_(0x57, 0x30)
#define REG_SC_BK57_31_L      _PK_L_(0x57, 0x31)
#define REG_SC_BK57_31_H      _PK_H_(0x57, 0x31)
#define REG_SC_BK57_32_L      _PK_L_(0x57, 0x32)
#define REG_SC_BK57_32_H      _PK_H_(0x57, 0x32)
#define REG_SC_BK57_33_L      _PK_L_(0x57, 0x33)
#define REG_SC_BK57_33_H      _PK_H_(0x57, 0x33)
#define REG_SC_BK57_34_L      _PK_L_(0x57, 0x34)
#define REG_SC_BK57_34_H      _PK_H_(0x57, 0x34)
#define REG_SC_BK57_35_L      _PK_L_(0x57, 0x35)
#define REG_SC_BK57_35_H      _PK_H_(0x57, 0x35)
#define REG_SC_BK57_36_L      _PK_L_(0x57, 0x36)
#define REG_SC_BK57_36_H      _PK_H_(0x57, 0x36)
#define REG_SC_BK57_37_L      _PK_L_(0x57, 0x37)
#define REG_SC_BK57_37_H      _PK_H_(0x57, 0x37)
#define REG_SC_BK57_38_L      _PK_L_(0x57, 0x38)
#define REG_SC_BK57_38_H      _PK_H_(0x57, 0x38)
#define REG_SC_BK57_39_L      _PK_L_(0x57, 0x39)
#define REG_SC_BK57_39_H      _PK_H_(0x57, 0x39)
#define REG_SC_BK57_3A_L      _PK_L_(0x57, 0x3A)
#define REG_SC_BK57_3A_H      _PK_H_(0x57, 0x3A)
#define REG_SC_BK57_3B_L      _PK_L_(0x57, 0x3B)
#define REG_SC_BK57_3B_H      _PK_H_(0x57, 0x3B)
#define REG_SC_BK57_3C_L      _PK_L_(0x57, 0x3C)
#define REG_SC_BK57_3C_H      _PK_H_(0x57, 0x3C)
#define REG_SC_BK57_3D_L      _PK_L_(0x57, 0x3D)
#define REG_SC_BK57_3D_H      _PK_H_(0x57, 0x3D)
#define REG_SC_BK57_3E_L      _PK_L_(0x57, 0x3E)
#define REG_SC_BK57_3E_H      _PK_H_(0x57, 0x3E)
#define REG_SC_BK57_3F_L      _PK_L_(0x57, 0x3F)
#define REG_SC_BK57_3F_H      _PK_H_(0x57, 0x3F)
#define REG_SC_BK57_40_L      _PK_L_(0x57, 0x40)
#define REG_SC_BK57_40_H      _PK_H_(0x57, 0x40)
#define REG_SC_BK57_41_L      _PK_L_(0x57, 0x41)
#define REG_SC_BK57_41_H      _PK_H_(0x57, 0x41)
#define REG_SC_BK57_42_L      _PK_L_(0x57, 0x42)
#define REG_SC_BK57_42_H      _PK_H_(0x57, 0x42)
#define REG_SC_BK57_43_L      _PK_L_(0x57, 0x43)
#define REG_SC_BK57_43_H      _PK_H_(0x57, 0x43)
#define REG_SC_BK57_44_L      _PK_L_(0x57, 0x44)
#define REG_SC_BK57_44_H      _PK_H_(0x57, 0x44)
#define REG_SC_BK57_45_L      _PK_L_(0x57, 0x45)
#define REG_SC_BK57_45_H      _PK_H_(0x57, 0x45)
#define REG_SC_BK57_46_L      _PK_L_(0x57, 0x46)
#define REG_SC_BK57_46_H      _PK_H_(0x57, 0x46)
#define REG_SC_BK57_47_L      _PK_L_(0x57, 0x47)
#define REG_SC_BK57_47_H      _PK_H_(0x57, 0x47)
#define REG_SC_BK57_48_L      _PK_L_(0x57, 0x48)
#define REG_SC_BK57_48_H      _PK_H_(0x57, 0x48)
#define REG_SC_BK57_49_L      _PK_L_(0x57, 0x49)
#define REG_SC_BK57_49_H      _PK_H_(0x57, 0x49)
#define REG_SC_BK57_4A_L      _PK_L_(0x57, 0x4A)
#define REG_SC_BK57_4A_H      _PK_H_(0x57, 0x4A)
#define REG_SC_BK57_4B_L      _PK_L_(0x57, 0x4B)
#define REG_SC_BK57_4B_H      _PK_H_(0x57, 0x4B)
#define REG_SC_BK57_4C_L      _PK_L_(0x57, 0x4C)
#define REG_SC_BK57_4C_H      _PK_H_(0x57, 0x4C)
#define REG_SC_BK57_4D_L      _PK_L_(0x57, 0x4D)
#define REG_SC_BK57_4D_H      _PK_H_(0x57, 0x4D)
#define REG_SC_BK57_4E_L      _PK_L_(0x57, 0x4E)
#define REG_SC_BK57_4E_H      _PK_H_(0x57, 0x4E)
#define REG_SC_BK57_4F_L      _PK_L_(0x57, 0x4F)
#define REG_SC_BK57_4F_H      _PK_H_(0x57, 0x4F)
#define REG_SC_BK57_50_L      _PK_L_(0x57, 0x50)
#define REG_SC_BK57_50_H      _PK_H_(0x57, 0x50)
#define REG_SC_BK57_51_L      _PK_L_(0x57, 0x51)
#define REG_SC_BK57_51_H      _PK_H_(0x57, 0x51)
#define REG_SC_BK57_52_L      _PK_L_(0x57, 0x52)
#define REG_SC_BK57_52_H      _PK_H_(0x57, 0x52)
#define REG_SC_BK57_53_L      _PK_L_(0x57, 0x53)
#define REG_SC_BK57_53_H      _PK_H_(0x57, 0x53)
#define REG_SC_BK57_54_L      _PK_L_(0x57, 0x54)
#define REG_SC_BK57_54_H      _PK_H_(0x57, 0x54)
#define REG_SC_BK57_55_L      _PK_L_(0x57, 0x55)
#define REG_SC_BK57_55_H      _PK_H_(0x57, 0x55)
#define REG_SC_BK57_56_L      _PK_L_(0x57, 0x56)
#define REG_SC_BK57_56_H      _PK_H_(0x57, 0x56)
#define REG_SC_BK57_57_L      _PK_L_(0x57, 0x57)
#define REG_SC_BK57_57_H      _PK_H_(0x57, 0x57)
#define REG_SC_BK57_58_L      _PK_L_(0x57, 0x58)
#define REG_SC_BK57_58_H      _PK_H_(0x57, 0x58)
#define REG_SC_BK57_59_L      _PK_L_(0x57, 0x59)
#define REG_SC_BK57_59_H      _PK_H_(0x57, 0x59)
#define REG_SC_BK57_5A_L      _PK_L_(0x57, 0x5A)
#define REG_SC_BK57_5A_H      _PK_H_(0x57, 0x5A)
#define REG_SC_BK57_5B_L      _PK_L_(0x57, 0x5B)
#define REG_SC_BK57_5B_H      _PK_H_(0x57, 0x5B)
#define REG_SC_BK57_5C_L      _PK_L_(0x57, 0x5C)
#define REG_SC_BK57_5C_H      _PK_H_(0x57, 0x5C)
#define REG_SC_BK57_5D_L      _PK_L_(0x57, 0x5D)
#define REG_SC_BK57_5D_H      _PK_H_(0x57, 0x5D)
#define REG_SC_BK57_5E_L      _PK_L_(0x57, 0x5E)
#define REG_SC_BK57_5E_H      _PK_H_(0x57, 0x5E)
#define REG_SC_BK57_5F_L      _PK_L_(0x57, 0x5F)
#define REG_SC_BK57_5F_H      _PK_H_(0x57, 0x5F)
#define REG_SC_BK57_60_L      _PK_L_(0x57, 0x60)
#define REG_SC_BK57_60_H      _PK_H_(0x57, 0x60)
#define REG_SC_BK57_61_L      _PK_L_(0x57, 0x61)
#define REG_SC_BK57_61_H      _PK_H_(0x57, 0x61)
#define REG_SC_BK57_62_L      _PK_L_(0x57, 0x62)
#define REG_SC_BK57_62_H      _PK_H_(0x57, 0x62)
#define REG_SC_BK57_63_L      _PK_L_(0x57, 0x63)
#define REG_SC_BK57_63_H      _PK_H_(0x57, 0x63)
#define REG_SC_BK57_64_L      _PK_L_(0x57, 0x64)
#define REG_SC_BK57_64_H      _PK_H_(0x57, 0x64)
#define REG_SC_BK57_65_L      _PK_L_(0x57, 0x65)
#define REG_SC_BK57_65_H      _PK_H_(0x57, 0x65)
#define REG_SC_BK57_66_L      _PK_L_(0x57, 0x66)
#define REG_SC_BK57_66_H      _PK_H_(0x57, 0x66)
#define REG_SC_BK57_67_L      _PK_L_(0x57, 0x67)
#define REG_SC_BK57_67_H      _PK_H_(0x57, 0x67)
#define REG_SC_BK57_68_L      _PK_L_(0x57, 0x68)
#define REG_SC_BK57_68_H      _PK_H_(0x57, 0x68)
#define REG_SC_BK57_69_L      _PK_L_(0x57, 0x69)
#define REG_SC_BK57_69_H      _PK_H_(0x57, 0x69)
#define REG_SC_BK57_6A_L      _PK_L_(0x57, 0x6A)
#define REG_SC_BK57_6A_H      _PK_H_(0x57, 0x6A)
#define REG_SC_BK57_6B_L      _PK_L_(0x57, 0x6B)
#define REG_SC_BK57_6B_H      _PK_H_(0x57, 0x6B)
#define REG_SC_BK57_6C_L      _PK_L_(0x57, 0x6C)
#define REG_SC_BK57_6C_H      _PK_H_(0x57, 0x6C)
#define REG_SC_BK57_6D_L      _PK_L_(0x57, 0x6D)
#define REG_SC_BK57_6D_H      _PK_H_(0x57, 0x6D)
#define REG_SC_BK57_6E_L      _PK_L_(0x57, 0x6E)
#define REG_SC_BK57_6E_H      _PK_H_(0x57, 0x6E)
#define REG_SC_BK57_6F_L      _PK_L_(0x57, 0x6F)
#define REG_SC_BK57_6F_H      _PK_H_(0x57, 0x6F)
#define REG_SC_BK57_70_L      _PK_L_(0x57, 0x70)
#define REG_SC_BK57_70_H      _PK_H_(0x57, 0x70)
#define REG_SC_BK57_71_L      _PK_L_(0x57, 0x71)
#define REG_SC_BK57_71_H      _PK_H_(0x57, 0x71)
#define REG_SC_BK57_72_L      _PK_L_(0x57, 0x72)
#define REG_SC_BK57_72_H      _PK_H_(0x57, 0x72)
#define REG_SC_BK57_73_L      _PK_L_(0x57, 0x73)
#define REG_SC_BK57_73_H      _PK_H_(0x57, 0x73)
#define REG_SC_BK57_74_L      _PK_L_(0x57, 0x74)
#define REG_SC_BK57_74_H      _PK_H_(0x57, 0x74)
#define REG_SC_BK57_75_L      _PK_L_(0x57, 0x75)
#define REG_SC_BK57_75_H      _PK_H_(0x57, 0x75)
#define REG_SC_BK57_76_L      _PK_L_(0x57, 0x76)
#define REG_SC_BK57_76_H      _PK_H_(0x57, 0x76)
#define REG_SC_BK57_77_L      _PK_L_(0x57, 0x77)
#define REG_SC_BK57_77_H      _PK_H_(0x57, 0x77)
#define REG_SC_BK57_78_L      _PK_L_(0x57, 0x78)
#define REG_SC_BK57_78_H      _PK_H_(0x57, 0x78)
#define REG_SC_BK57_79_L      _PK_L_(0x57, 0x79)
#define REG_SC_BK57_79_H      _PK_H_(0x57, 0x79)
#define REG_SC_BK57_7A_L      _PK_L_(0x57, 0x7A)
#define REG_SC_BK57_7A_H      _PK_H_(0x57, 0x7A)
#define REG_SC_BK57_7B_L      _PK_L_(0x57, 0x7B)
#define REG_SC_BK57_7B_H      _PK_H_(0x57, 0x7B)
#define REG_SC_BK57_7C_L      _PK_L_(0x57, 0x7C)
#define REG_SC_BK57_7C_H      _PK_H_(0x57, 0x7C)
#define REG_SC_BK57_7D_L      _PK_L_(0x57, 0x7D)
#define REG_SC_BK57_7D_H      _PK_H_(0x57, 0x7D)
#define REG_SC_BK57_7E_L      _PK_L_(0x57, 0x7E)
#define REG_SC_BK57_7E_H      _PK_H_(0x57, 0x7E)
#define REG_SC_BK57_7F_L      _PK_L_(0x57, 0x7F)
#define REG_SC_BK57_7F_H      _PK_H_(0x57, 0x7F)

//----------------------------------------------
//  BK58:
//----------------------------------------------
#define REG_SC_BK58_00_L      _PK_L_(0x58, 0x00)
#define REG_SC_BK58_00_H      _PK_H_(0x58, 0x00)
#define REG_SC_BK58_01_L      _PK_L_(0x58, 0x01)
#define REG_SC_BK58_01_H      _PK_H_(0x58, 0x01)
#define REG_SC_BK58_02_L      _PK_L_(0x58, 0x02)
#define REG_SC_BK58_02_H      _PK_H_(0x58, 0x02)
#define REG_SC_BK58_03_L      _PK_L_(0x58, 0x03)
#define REG_SC_BK58_03_H      _PK_H_(0x58, 0x03)
#define REG_SC_BK58_04_L      _PK_L_(0x58, 0x04)
#define REG_SC_BK58_04_H      _PK_H_(0x58, 0x04)
#define REG_SC_BK58_05_L      _PK_L_(0x58, 0x05)
#define REG_SC_BK58_05_H      _PK_H_(0x58, 0x05)
#define REG_SC_BK58_06_L      _PK_L_(0x58, 0x06)
#define REG_SC_BK58_06_H      _PK_H_(0x58, 0x06)
#define REG_SC_BK58_07_L      _PK_L_(0x58, 0x07)
#define REG_SC_BK58_07_H      _PK_H_(0x58, 0x07)
#define REG_SC_BK58_08_L      _PK_L_(0x58, 0x08)
#define REG_SC_BK58_08_H      _PK_H_(0x58, 0x08)
#define REG_SC_BK58_09_L      _PK_L_(0x58, 0x09)
#define REG_SC_BK58_09_H      _PK_H_(0x58, 0x09)
#define REG_SC_BK58_0A_L      _PK_L_(0x58, 0x0A)
#define REG_SC_BK58_0A_H      _PK_H_(0x58, 0x0A)
#define REG_SC_BK58_0B_L      _PK_L_(0x58, 0x0B)
#define REG_SC_BK58_0B_H      _PK_H_(0x58, 0x0B)
#define REG_SC_BK58_0C_L      _PK_L_(0x58, 0x0C)
#define REG_SC_BK58_0C_H      _PK_H_(0x58, 0x0C)
#define REG_SC_BK58_0D_L      _PK_L_(0x58, 0x0D)
#define REG_SC_BK58_0D_H      _PK_H_(0x58, 0x0D)
#define REG_SC_BK58_0E_L      _PK_L_(0x58, 0x0E)
#define REG_SC_BK58_0E_H      _PK_H_(0x58, 0x0E)
#define REG_SC_BK58_0F_L      _PK_L_(0x58, 0x0F)
#define REG_SC_BK58_0F_H      _PK_H_(0x58, 0x0F)
#define REG_SC_BK58_10_L      _PK_L_(0x58, 0x10)
#define REG_SC_BK58_10_H      _PK_H_(0x58, 0x10)
#define REG_SC_BK58_11_L      _PK_L_(0x58, 0x11)
#define REG_SC_BK58_11_H      _PK_H_(0x58, 0x11)
#define REG_SC_BK58_12_L      _PK_L_(0x58, 0x12)
#define REG_SC_BK58_12_H      _PK_H_(0x58, 0x12)
#define REG_SC_BK58_13_L      _PK_L_(0x58, 0x13)
#define REG_SC_BK58_13_H      _PK_H_(0x58, 0x13)
#define REG_SC_BK58_14_L      _PK_L_(0x58, 0x14)
#define REG_SC_BK58_14_H      _PK_H_(0x58, 0x14)
#define REG_SC_BK58_15_L      _PK_L_(0x58, 0x15)
#define REG_SC_BK58_15_H      _PK_H_(0x58, 0x15)
#define REG_SC_BK58_16_L      _PK_L_(0x58, 0x16)
#define REG_SC_BK58_16_H      _PK_H_(0x58, 0x16)
#define REG_SC_BK58_17_L      _PK_L_(0x58, 0x17)
#define REG_SC_BK58_17_H      _PK_H_(0x58, 0x17)
#define REG_SC_BK58_18_L      _PK_L_(0x58, 0x18)
#define REG_SC_BK58_18_H      _PK_H_(0x58, 0x18)
#define REG_SC_BK58_19_L      _PK_L_(0x58, 0x19)
#define REG_SC_BK58_19_H      _PK_H_(0x58, 0x19)
#define REG_SC_BK58_1A_L      _PK_L_(0x58, 0x1A)
#define REG_SC_BK58_1A_H      _PK_H_(0x58, 0x1A)
#define REG_SC_BK58_1B_L      _PK_L_(0x58, 0x1B)
#define REG_SC_BK58_1B_H      _PK_H_(0x58, 0x1B)
#define REG_SC_BK58_1C_L      _PK_L_(0x58, 0x1C)
#define REG_SC_BK58_1C_H      _PK_H_(0x58, 0x1C)
#define REG_SC_BK58_1D_L      _PK_L_(0x58, 0x1D)
#define REG_SC_BK58_1D_H      _PK_H_(0x58, 0x1D)
#define REG_SC_BK58_1E_L      _PK_L_(0x58, 0x1E)
#define REG_SC_BK58_1E_H      _PK_H_(0x58, 0x1E)
#define REG_SC_BK58_1F_L      _PK_L_(0x58, 0x1F)
#define REG_SC_BK58_1F_H      _PK_H_(0x58, 0x1F)
#define REG_SC_BK58_20_L      _PK_L_(0x58, 0x20)
#define REG_SC_BK58_20_H      _PK_H_(0x58, 0x20)
#define REG_SC_BK58_21_L      _PK_L_(0x58, 0x21)
#define REG_SC_BK58_21_H      _PK_H_(0x58, 0x21)
#define REG_SC_BK58_22_L      _PK_L_(0x58, 0x22)
#define REG_SC_BK58_22_H      _PK_H_(0x58, 0x22)
#define REG_SC_BK58_23_L      _PK_L_(0x58, 0x23)
#define REG_SC_BK58_23_H      _PK_H_(0x58, 0x23)
#define REG_SC_BK58_24_L      _PK_L_(0x58, 0x24)
#define REG_SC_BK58_24_H      _PK_H_(0x58, 0x24)
#define REG_SC_BK58_25_L      _PK_L_(0x58, 0x25)
#define REG_SC_BK58_25_H      _PK_H_(0x58, 0x25)
#define REG_SC_BK58_26_L      _PK_L_(0x58, 0x26)
#define REG_SC_BK58_26_H      _PK_H_(0x58, 0x26)
#define REG_SC_BK58_27_L      _PK_L_(0x58, 0x27)
#define REG_SC_BK58_27_H      _PK_H_(0x58, 0x27)
#define REG_SC_BK58_28_L      _PK_L_(0x58, 0x28)
#define REG_SC_BK58_28_H      _PK_H_(0x58, 0x28)
#define REG_SC_BK58_29_L      _PK_L_(0x58, 0x29)
#define REG_SC_BK58_29_H      _PK_H_(0x58, 0x29)
#define REG_SC_BK58_2A_L      _PK_L_(0x58, 0x2A)
#define REG_SC_BK58_2A_H      _PK_H_(0x58, 0x2A)
#define REG_SC_BK58_2B_L      _PK_L_(0x58, 0x2B)
#define REG_SC_BK58_2B_H      _PK_H_(0x58, 0x2B)
#define REG_SC_BK58_2C_L      _PK_L_(0x58, 0x2C)
#define REG_SC_BK58_2C_H      _PK_H_(0x58, 0x2C)
#define REG_SC_BK58_2D_L      _PK_L_(0x58, 0x2D)
#define REG_SC_BK58_2D_H      _PK_H_(0x58, 0x2D)
#define REG_SC_BK58_2E_L      _PK_L_(0x58, 0x2E)
#define REG_SC_BK58_2E_H      _PK_H_(0x58, 0x2E)
#define REG_SC_BK58_2F_L      _PK_L_(0x58, 0x2F)
#define REG_SC_BK58_2F_H      _PK_H_(0x58, 0x2F)
#define REG_SC_BK58_30_L      _PK_L_(0x58, 0x30)
#define REG_SC_BK58_30_H      _PK_H_(0x58, 0x30)
#define REG_SC_BK58_31_L      _PK_L_(0x58, 0x31)
#define REG_SC_BK58_31_H      _PK_H_(0x58, 0x31)
#define REG_SC_BK58_32_L      _PK_L_(0x58, 0x32)
#define REG_SC_BK58_32_H      _PK_H_(0x58, 0x32)
#define REG_SC_BK58_33_L      _PK_L_(0x58, 0x33)
#define REG_SC_BK58_33_H      _PK_H_(0x58, 0x33)
#define REG_SC_BK58_34_L      _PK_L_(0x58, 0x34)
#define REG_SC_BK58_34_H      _PK_H_(0x58, 0x34)
#define REG_SC_BK58_35_L      _PK_L_(0x58, 0x35)
#define REG_SC_BK58_35_H      _PK_H_(0x58, 0x35)
#define REG_SC_BK58_36_L      _PK_L_(0x58, 0x36)
#define REG_SC_BK58_36_H      _PK_H_(0x58, 0x36)
#define REG_SC_BK58_37_L      _PK_L_(0x58, 0x37)
#define REG_SC_BK58_37_H      _PK_H_(0x58, 0x37)
#define REG_SC_BK58_38_L      _PK_L_(0x58, 0x38)
#define REG_SC_BK58_38_H      _PK_H_(0x58, 0x38)
#define REG_SC_BK58_39_L      _PK_L_(0x58, 0x39)
#define REG_SC_BK58_39_H      _PK_H_(0x58, 0x39)
#define REG_SC_BK58_3A_L      _PK_L_(0x58, 0x3A)
#define REG_SC_BK58_3A_H      _PK_H_(0x58, 0x3A)
#define REG_SC_BK58_3B_L      _PK_L_(0x58, 0x3B)
#define REG_SC_BK58_3B_H      _PK_H_(0x58, 0x3B)
#define REG_SC_BK58_3C_L      _PK_L_(0x58, 0x3C)
#define REG_SC_BK58_3C_H      _PK_H_(0x58, 0x3C)
#define REG_SC_BK58_3D_L      _PK_L_(0x58, 0x3D)
#define REG_SC_BK58_3D_H      _PK_H_(0x58, 0x3D)
#define REG_SC_BK58_3E_L      _PK_L_(0x58, 0x3E)
#define REG_SC_BK58_3E_H      _PK_H_(0x58, 0x3E)
#define REG_SC_BK58_3F_L      _PK_L_(0x58, 0x3F)
#define REG_SC_BK58_3F_H      _PK_H_(0x58, 0x3F)
#define REG_SC_BK58_40_L      _PK_L_(0x58, 0x40)
#define REG_SC_BK58_40_H      _PK_H_(0x58, 0x40)
#define REG_SC_BK58_41_L      _PK_L_(0x58, 0x41)
#define REG_SC_BK58_41_H      _PK_H_(0x58, 0x41)
#define REG_SC_BK58_42_L      _PK_L_(0x58, 0x42)
#define REG_SC_BK58_42_H      _PK_H_(0x58, 0x42)
#define REG_SC_BK58_43_L      _PK_L_(0x58, 0x43)
#define REG_SC_BK58_43_H      _PK_H_(0x58, 0x43)
#define REG_SC_BK58_44_L      _PK_L_(0x58, 0x44)
#define REG_SC_BK58_44_H      _PK_H_(0x58, 0x44)
#define REG_SC_BK58_45_L      _PK_L_(0x58, 0x45)
#define REG_SC_BK58_45_H      _PK_H_(0x58, 0x45)
#define REG_SC_BK58_46_L      _PK_L_(0x58, 0x46)
#define REG_SC_BK58_46_H      _PK_H_(0x58, 0x46)
#define REG_SC_BK58_47_L      _PK_L_(0x58, 0x47)
#define REG_SC_BK58_47_H      _PK_H_(0x58, 0x47)
#define REG_SC_BK58_48_L      _PK_L_(0x58, 0x48)
#define REG_SC_BK58_48_H      _PK_H_(0x58, 0x48)
#define REG_SC_BK58_49_L      _PK_L_(0x58, 0x49)
#define REG_SC_BK58_49_H      _PK_H_(0x58, 0x49)
#define REG_SC_BK58_4A_L      _PK_L_(0x58, 0x4A)
#define REG_SC_BK58_4A_H      _PK_H_(0x58, 0x4A)
#define REG_SC_BK58_4B_L      _PK_L_(0x58, 0x4B)
#define REG_SC_BK58_4B_H      _PK_H_(0x58, 0x4B)
#define REG_SC_BK58_4C_L      _PK_L_(0x58, 0x4C)
#define REG_SC_BK58_4C_H      _PK_H_(0x58, 0x4C)
#define REG_SC_BK58_4D_L      _PK_L_(0x58, 0x4D)
#define REG_SC_BK58_4D_H      _PK_H_(0x58, 0x4D)
#define REG_SC_BK58_4E_L      _PK_L_(0x58, 0x4E)
#define REG_SC_BK58_4E_H      _PK_H_(0x58, 0x4E)
#define REG_SC_BK58_4F_L      _PK_L_(0x58, 0x4F)
#define REG_SC_BK58_4F_H      _PK_H_(0x58, 0x4F)
#define REG_SC_BK58_50_L      _PK_L_(0x58, 0x50)
#define REG_SC_BK58_50_H      _PK_H_(0x58, 0x50)
#define REG_SC_BK58_51_L      _PK_L_(0x58, 0x51)
#define REG_SC_BK58_51_H      _PK_H_(0x58, 0x51)
#define REG_SC_BK58_52_L      _PK_L_(0x58, 0x52)
#define REG_SC_BK58_52_H      _PK_H_(0x58, 0x52)
#define REG_SC_BK58_53_L      _PK_L_(0x58, 0x53)
#define REG_SC_BK58_53_H      _PK_H_(0x58, 0x53)
#define REG_SC_BK58_54_L      _PK_L_(0x58, 0x54)
#define REG_SC_BK58_54_H      _PK_H_(0x58, 0x54)
#define REG_SC_BK58_55_L      _PK_L_(0x58, 0x55)
#define REG_SC_BK58_55_H      _PK_H_(0x58, 0x55)
#define REG_SC_BK58_56_L      _PK_L_(0x58, 0x56)
#define REG_SC_BK58_56_H      _PK_H_(0x58, 0x56)
#define REG_SC_BK58_57_L      _PK_L_(0x58, 0x57)
#define REG_SC_BK58_57_H      _PK_H_(0x58, 0x57)
#define REG_SC_BK58_58_L      _PK_L_(0x58, 0x58)
#define REG_SC_BK58_58_H      _PK_H_(0x58, 0x58)
#define REG_SC_BK58_59_L      _PK_L_(0x58, 0x59)
#define REG_SC_BK58_59_H      _PK_H_(0x58, 0x59)
#define REG_SC_BK58_5A_L      _PK_L_(0x58, 0x5A)
#define REG_SC_BK58_5A_H      _PK_H_(0x58, 0x5A)
#define REG_SC_BK58_5B_L      _PK_L_(0x58, 0x5B)
#define REG_SC_BK58_5B_H      _PK_H_(0x58, 0x5B)
#define REG_SC_BK58_5C_L      _PK_L_(0x58, 0x5C)
#define REG_SC_BK58_5C_H      _PK_H_(0x58, 0x5C)
#define REG_SC_BK58_5D_L      _PK_L_(0x58, 0x5D)
#define REG_SC_BK58_5D_H      _PK_H_(0x58, 0x5D)
#define REG_SC_BK58_5E_L      _PK_L_(0x58, 0x5E)
#define REG_SC_BK58_5E_H      _PK_H_(0x58, 0x5E)
#define REG_SC_BK58_5F_L      _PK_L_(0x58, 0x5F)
#define REG_SC_BK58_5F_H      _PK_H_(0x58, 0x5F)
#define REG_SC_BK58_60_L      _PK_L_(0x58, 0x60)
#define REG_SC_BK58_60_H      _PK_H_(0x58, 0x60)
#define REG_SC_BK58_61_L      _PK_L_(0x58, 0x61)
#define REG_SC_BK58_61_H      _PK_H_(0x58, 0x61)
#define REG_SC_BK58_62_L      _PK_L_(0x58, 0x62)
#define REG_SC_BK58_62_H      _PK_H_(0x58, 0x62)
#define REG_SC_BK58_63_L      _PK_L_(0x58, 0x63)
#define REG_SC_BK58_63_H      _PK_H_(0x58, 0x63)
#define REG_SC_BK58_64_L      _PK_L_(0x58, 0x64)
#define REG_SC_BK58_64_H      _PK_H_(0x58, 0x64)
#define REG_SC_BK58_65_L      _PK_L_(0x58, 0x65)
#define REG_SC_BK58_65_H      _PK_H_(0x58, 0x65)
#define REG_SC_BK58_66_L      _PK_L_(0x58, 0x66)
#define REG_SC_BK58_66_H      _PK_H_(0x58, 0x66)
#define REG_SC_BK58_67_L      _PK_L_(0x58, 0x67)
#define REG_SC_BK58_67_H      _PK_H_(0x58, 0x67)
#define REG_SC_BK58_68_L      _PK_L_(0x58, 0x68)
#define REG_SC_BK58_68_H      _PK_H_(0x58, 0x68)
#define REG_SC_BK58_69_L      _PK_L_(0x58, 0x69)
#define REG_SC_BK58_69_H      _PK_H_(0x58, 0x69)
#define REG_SC_BK58_6A_L      _PK_L_(0x58, 0x6A)
#define REG_SC_BK58_6A_H      _PK_H_(0x58, 0x6A)
#define REG_SC_BK58_6B_L      _PK_L_(0x58, 0x6B)
#define REG_SC_BK58_6B_H      _PK_H_(0x58, 0x6B)
#define REG_SC_BK58_6C_L      _PK_L_(0x58, 0x6C)
#define REG_SC_BK58_6C_H      _PK_H_(0x58, 0x6C)
#define REG_SC_BK58_6D_L      _PK_L_(0x58, 0x6D)
#define REG_SC_BK58_6D_H      _PK_H_(0x58, 0x6D)
#define REG_SC_BK58_6E_L      _PK_L_(0x58, 0x6E)
#define REG_SC_BK58_6E_H      _PK_H_(0x58, 0x6E)
#define REG_SC_BK58_6F_L      _PK_L_(0x58, 0x6F)
#define REG_SC_BK58_6F_H      _PK_H_(0x58, 0x6F)
#define REG_SC_BK58_70_L      _PK_L_(0x58, 0x70)
#define REG_SC_BK58_70_H      _PK_H_(0x58, 0x70)
#define REG_SC_BK58_71_L      _PK_L_(0x58, 0x71)
#define REG_SC_BK58_71_H      _PK_H_(0x58, 0x71)
#define REG_SC_BK58_72_L      _PK_L_(0x58, 0x72)
#define REG_SC_BK58_72_H      _PK_H_(0x58, 0x72)
#define REG_SC_BK58_73_L      _PK_L_(0x58, 0x73)
#define REG_SC_BK58_73_H      _PK_H_(0x58, 0x73)
#define REG_SC_BK58_74_L      _PK_L_(0x58, 0x74)
#define REG_SC_BK58_74_H      _PK_H_(0x58, 0x74)
#define REG_SC_BK58_75_L      _PK_L_(0x58, 0x75)
#define REG_SC_BK58_75_H      _PK_H_(0x58, 0x75)
#define REG_SC_BK58_76_L      _PK_L_(0x58, 0x76)
#define REG_SC_BK58_76_H      _PK_H_(0x58, 0x76)
#define REG_SC_BK58_77_L      _PK_L_(0x58, 0x77)
#define REG_SC_BK58_77_H      _PK_H_(0x58, 0x77)
#define REG_SC_BK58_78_L      _PK_L_(0x58, 0x78)
#define REG_SC_BK58_78_H      _PK_H_(0x58, 0x78)
#define REG_SC_BK58_79_L      _PK_L_(0x58, 0x79)
#define REG_SC_BK58_79_H      _PK_H_(0x58, 0x79)
#define REG_SC_BK58_7A_L      _PK_L_(0x58, 0x7A)
#define REG_SC_BK58_7A_H      _PK_H_(0x58, 0x7A)
#define REG_SC_BK58_7B_L      _PK_L_(0x58, 0x7B)
#define REG_SC_BK58_7B_H      _PK_H_(0x58, 0x7B)
#define REG_SC_BK58_7C_L      _PK_L_(0x58, 0x7C)
#define REG_SC_BK58_7C_H      _PK_H_(0x58, 0x7C)
#define REG_SC_BK58_7D_L      _PK_L_(0x58, 0x7D)
#define REG_SC_BK58_7D_H      _PK_H_(0x58, 0x7D)
#define REG_SC_BK58_7E_L      _PK_L_(0x58, 0x7E)
#define REG_SC_BK58_7E_H      _PK_H_(0x58, 0x7E)
#define REG_SC_BK58_7F_L      _PK_L_(0x58, 0x7F)
#define REG_SC_BK58_7F_H      _PK_H_(0x58, 0x7F)

//----------------------------------------------
//  BK59: DWIN1 DI
//----------------------------------------------
#define REG_SC_BK59_10_L      _PK_L_(0x59, 0x10)
#define REG_SC_BK59_10_H      _PK_H_(0x59, 0x10)
#define REG_SC_BK59_78_L      _PK_L_(0x59, 0x78)
#define REG_SC_BK59_78_H      _PK_H_(0x59, 0x78)
#define REG_SC_BK59_79_L      _PK_L_(0x59, 0x79)
#define REG_SC_BK59_79_H      _PK_H_(0x59, 0x79)

//----------------------------------------------
//  BK5B: DWIN1 HVSP
//----------------------------------------------
#define REG_SC_BK5B_07_L      _PK_L_(0x5B, 0x07)
#define REG_SC_BK5B_07_H      _PK_H_(0x5B, 0x07)
#define REG_SC_BK5B_08_L      _PK_L_(0x5B, 0x08)
#define REG_SC_BK5B_08_H      _PK_H_(0x5B, 0x08)
#define REG_SC_BK5B_09_L      _PK_L_(0x5B, 0x09)
#define REG_SC_BK5B_09_H      _PK_H_(0x5B, 0x09)
#define REG_SC_BK5B_13_L      _PK_L_(0x5B, 0x13)
#define REG_SC_BK5B_22_L      _PK_L_(0x5B, 0x22)
#define REG_SC_BK5B_22_H      _PK_H_(0x5B, 0x22)
#define REG_SC_BK5B_23_L      _PK_L_(0x5B, 0x23)
#define REG_SC_BK5B_23_H      _PK_H_(0x5B, 0x23)
#define REG_SC_BK5B_24_L      _PK_L_(0x5B, 0x24)
#define REG_SC_BK5B_24_H      _PK_H_(0x5B, 0x24)
#define REG_SC_BK5B_25_L      _PK_L_(0x5B, 0x25)
#define REG_SC_BK5B_25_H      _PK_H_(0x5B, 0x25)
#define REG_SC_BK5B_41_L      _PK_L_(0x5B, 0x41)
#define REG_SC_BK5B_42_L      _PK_L_(0x5B, 0x42)
#define REG_SC_BK5B_43_L      _PK_L_(0x5B, 0x43)
#define REG_SC_BK5B_44_L      _PK_L_(0x5B, 0x44)
#define REG_SC_BK5B_45_L      _PK_L_(0x5B, 0x45)
#define REG_SC_BK5B_49_L      _PK_L_(0x5B, 0x49)
#define REG_SC_BK5B_4A_L      _PK_L_(0x5B, 0x4A)
#define REG_SC_BK5B_5F_L      _PK_L_(0x5B, 0x5F)
#define REG_SC_BK5B_0A_L      _PK_L_(0x5B, 0x0A)
#define REG_SC_BK5B_0A_H      _PK_H_(0x5B, 0x0A)
#define REG_SC_BK5B_0B_L      _PK_L_(0x5B, 0x0B)
#define REG_SC_BK5B_70_L      _PK_L_(0x5B, 0x70)
#define REG_SC_BK5B_70_H      _PK_H_(0x5B, 0x70)

//----------------------------------------------
//  BK5C:
//----------------------------------------------
#define REG_SC_BK5C_00_L      _PK_L_(0x5C, 0x00)
#define REG_SC_BK5C_00_H      _PK_H_(0x5C, 0x00)
#define REG_SC_BK5C_01_L      _PK_L_(0x5C, 0x01)
#define REG_SC_BK5C_01_H      _PK_H_(0x5C, 0x01)
#define REG_SC_BK5C_02_L      _PK_L_(0x5C, 0x02)
#define REG_SC_BK5C_02_H      _PK_H_(0x5C, 0x02)
#define REG_SC_BK5C_03_L      _PK_L_(0x5C, 0x03)
#define REG_SC_BK5C_03_H      _PK_H_(0x5C, 0x03)
#define REG_SC_BK5C_04_L      _PK_L_(0x5C, 0x04)
#define REG_SC_BK5C_04_H      _PK_H_(0x5C, 0x04)
#define REG_SC_BK5C_05_L      _PK_L_(0x5C, 0x05)
#define REG_SC_BK5C_05_H      _PK_H_(0x5C, 0x05)
#define REG_SC_BK5C_06_L      _PK_L_(0x5C, 0x06)
#define REG_SC_BK5C_06_H      _PK_H_(0x5C, 0x06)
#define REG_SC_BK5C_07_L      _PK_L_(0x5C, 0x07)
#define REG_SC_BK5C_07_H      _PK_H_(0x5C, 0x07)
#define REG_SC_BK5C_08_L      _PK_L_(0x5C, 0x08)
#define REG_SC_BK5C_08_H      _PK_H_(0x5C, 0x08)
#define REG_SC_BK5C_09_L      _PK_L_(0x5C, 0x09)
#define REG_SC_BK5C_09_H      _PK_H_(0x5C, 0x09)
#define REG_SC_BK5C_0A_L      _PK_L_(0x5C, 0x0A)
#define REG_SC_BK5C_0A_H      _PK_H_(0x5C, 0x0A)
#define REG_SC_BK5C_0B_L      _PK_L_(0x5C, 0x0B)
#define REG_SC_BK5C_0B_H      _PK_H_(0x5C, 0x0B)
#define REG_SC_BK5C_0C_L      _PK_L_(0x5C, 0x0C)
#define REG_SC_BK5C_0C_H      _PK_H_(0x5C, 0x0C)
#define REG_SC_BK5C_0D_L      _PK_L_(0x5C, 0x0D)
#define REG_SC_BK5C_0D_H      _PK_H_(0x5C, 0x0D)
#define REG_SC_BK5C_0E_L      _PK_L_(0x5C, 0x0E)
#define REG_SC_BK5C_0E_H      _PK_H_(0x5C, 0x0E)
#define REG_SC_BK5C_0F_L      _PK_L_(0x5C, 0x0F)
#define REG_SC_BK5C_0F_H      _PK_H_(0x5C, 0x0F)
#define REG_SC_BK5C_10_L      _PK_L_(0x5C, 0x10)
#define REG_SC_BK5C_10_H      _PK_H_(0x5C, 0x10)
#define REG_SC_BK5C_11_L      _PK_L_(0x5C, 0x11)
#define REG_SC_BK5C_11_H      _PK_H_(0x5C, 0x11)
#define REG_SC_BK5C_12_L      _PK_L_(0x5C, 0x12)
#define REG_SC_BK5C_12_H      _PK_H_(0x5C, 0x12)
#define REG_SC_BK5C_13_L      _PK_L_(0x5C, 0x13)
#define REG_SC_BK5C_13_H      _PK_H_(0x5C, 0x13)
#define REG_SC_BK5C_14_L      _PK_L_(0x5C, 0x14)
#define REG_SC_BK5C_14_H      _PK_H_(0x5C, 0x14)
#define REG_SC_BK5C_15_L      _PK_L_(0x5C, 0x15)
#define REG_SC_BK5C_15_H      _PK_H_(0x5C, 0x15)
#define REG_SC_BK5C_16_L      _PK_L_(0x5C, 0x16)
#define REG_SC_BK5C_16_H      _PK_H_(0x5C, 0x16)
#define REG_SC_BK5C_17_L      _PK_L_(0x5C, 0x17)
#define REG_SC_BK5C_17_H      _PK_H_(0x5C, 0x17)
#define REG_SC_BK5C_18_L      _PK_L_(0x5C, 0x18)
#define REG_SC_BK5C_18_H      _PK_H_(0x5C, 0x18)
#define REG_SC_BK5C_19_L      _PK_L_(0x5C, 0x19)
#define REG_SC_BK5C_19_H      _PK_H_(0x5C, 0x19)
#define REG_SC_BK5C_1A_L      _PK_L_(0x5C, 0x1A)
#define REG_SC_BK5C_1A_H      _PK_H_(0x5C, 0x1A)
#define REG_SC_BK5C_1B_L      _PK_L_(0x5C, 0x1B)
#define REG_SC_BK5C_1B_H      _PK_H_(0x5C, 0x1B)
#define REG_SC_BK5C_1C_L      _PK_L_(0x5C, 0x1C)
#define REG_SC_BK5C_1C_H      _PK_H_(0x5C, 0x1C)
#define REG_SC_BK5C_1D_L      _PK_L_(0x5C, 0x1D)
#define REG_SC_BK5C_1D_H      _PK_H_(0x5C, 0x1D)
#define REG_SC_BK5C_1E_L      _PK_L_(0x5C, 0x1E)
#define REG_SC_BK5C_1E_H      _PK_H_(0x5C, 0x1E)
#define REG_SC_BK5C_1F_L      _PK_L_(0x5C, 0x1F)
#define REG_SC_BK5C_1F_H      _PK_H_(0x5C, 0x1F)
#define REG_SC_BK5C_20_L      _PK_L_(0x5C, 0x20)
#define REG_SC_BK5C_20_H      _PK_H_(0x5C, 0x20)
#define REG_SC_BK5C_21_L      _PK_L_(0x5C, 0x21)
#define REG_SC_BK5C_21_H      _PK_H_(0x5C, 0x21)
#define REG_SC_BK5C_22_L      _PK_L_(0x5C, 0x22)
#define REG_SC_BK5C_22_H      _PK_H_(0x5C, 0x22)
#define REG_SC_BK5C_23_L      _PK_L_(0x5C, 0x23)
#define REG_SC_BK5C_23_H      _PK_H_(0x5C, 0x23)
#define REG_SC_BK5C_24_L      _PK_L_(0x5C, 0x24)
#define REG_SC_BK5C_24_H      _PK_H_(0x5C, 0x24)
#define REG_SC_BK5C_25_L      _PK_L_(0x5C, 0x25)
#define REG_SC_BK5C_25_H      _PK_H_(0x5C, 0x25)
#define REG_SC_BK5C_26_L      _PK_L_(0x5C, 0x26)
#define REG_SC_BK5C_26_H      _PK_H_(0x5C, 0x26)
#define REG_SC_BK5C_27_L      _PK_L_(0x5C, 0x27)
#define REG_SC_BK5C_27_H      _PK_H_(0x5C, 0x27)
#define REG_SC_BK5C_28_L      _PK_L_(0x5C, 0x28)
#define REG_SC_BK5C_28_H      _PK_H_(0x5C, 0x28)
#define REG_SC_BK5C_29_L      _PK_L_(0x5C, 0x29)
#define REG_SC_BK5C_29_H      _PK_H_(0x5C, 0x29)
#define REG_SC_BK5C_2A_L      _PK_L_(0x5C, 0x2A)
#define REG_SC_BK5C_2A_H      _PK_H_(0x5C, 0x2A)
#define REG_SC_BK5C_2B_L      _PK_L_(0x5C, 0x2B)
#define REG_SC_BK5C_2B_H      _PK_H_(0x5C, 0x2B)
#define REG_SC_BK5C_2C_L      _PK_L_(0x5C, 0x2C)
#define REG_SC_BK5C_2C_H      _PK_H_(0x5C, 0x2C)
#define REG_SC_BK5C_2D_L      _PK_L_(0x5C, 0x2D)
#define REG_SC_BK5C_2D_H      _PK_H_(0x5C, 0x2D)
#define REG_SC_BK5C_2E_L      _PK_L_(0x5C, 0x2E)
#define REG_SC_BK5C_2E_H      _PK_H_(0x5C, 0x2E)
#define REG_SC_BK5C_2F_L      _PK_L_(0x5C, 0x2F)
#define REG_SC_BK5C_2F_H      _PK_H_(0x5C, 0x2F)
#define REG_SC_BK5C_30_L      _PK_L_(0x5C, 0x30)
#define REG_SC_BK5C_30_H      _PK_H_(0x5C, 0x30)
#define REG_SC_BK5C_31_L      _PK_L_(0x5C, 0x31)
#define REG_SC_BK5C_31_H      _PK_H_(0x5C, 0x31)
#define REG_SC_BK5C_32_L      _PK_L_(0x5C, 0x32)
#define REG_SC_BK5C_32_H      _PK_H_(0x5C, 0x32)
#define REG_SC_BK5C_33_L      _PK_L_(0x5C, 0x33)
#define REG_SC_BK5C_33_H      _PK_H_(0x5C, 0x33)
#define REG_SC_BK5C_34_L      _PK_L_(0x5C, 0x34)
#define REG_SC_BK5C_34_H      _PK_H_(0x5C, 0x34)
#define REG_SC_BK5C_35_L      _PK_L_(0x5C, 0x35)
#define REG_SC_BK5C_35_H      _PK_H_(0x5C, 0x35)
#define REG_SC_BK5C_36_L      _PK_L_(0x5C, 0x36)
#define REG_SC_BK5C_36_H      _PK_H_(0x5C, 0x36)
#define REG_SC_BK5C_37_L      _PK_L_(0x5C, 0x37)
#define REG_SC_BK5C_37_H      _PK_H_(0x5C, 0x37)
#define REG_SC_BK5C_38_L      _PK_L_(0x5C, 0x38)
#define REG_SC_BK5C_38_H      _PK_H_(0x5C, 0x38)
#define REG_SC_BK5C_39_L      _PK_L_(0x5C, 0x39)
#define REG_SC_BK5C_39_H      _PK_H_(0x5C, 0x39)
#define REG_SC_BK5C_3A_L      _PK_L_(0x5C, 0x3A)
#define REG_SC_BK5C_3A_H      _PK_H_(0x5C, 0x3A)
#define REG_SC_BK5C_3B_L      _PK_L_(0x5C, 0x3B)
#define REG_SC_BK5C_3B_H      _PK_H_(0x5C, 0x3B)
#define REG_SC_BK5C_3C_L      _PK_L_(0x5C, 0x3C)
#define REG_SC_BK5C_3C_H      _PK_H_(0x5C, 0x3C)
#define REG_SC_BK5C_3D_L      _PK_L_(0x5C, 0x3D)
#define REG_SC_BK5C_3D_H      _PK_H_(0x5C, 0x3D)
#define REG_SC_BK5C_3E_L      _PK_L_(0x5C, 0x3E)
#define REG_SC_BK5C_3E_H      _PK_H_(0x5C, 0x3E)
#define REG_SC_BK5C_3F_L      _PK_L_(0x5C, 0x3F)
#define REG_SC_BK5C_3F_H      _PK_H_(0x5C, 0x3F)
#define REG_SC_BK5C_40_L      _PK_L_(0x5C, 0x40)
#define REG_SC_BK5C_40_H      _PK_H_(0x5C, 0x40)
#define REG_SC_BK5C_41_L      _PK_L_(0x5C, 0x41)
#define REG_SC_BK5C_41_H      _PK_H_(0x5C, 0x41)
#define REG_SC_BK5C_42_L      _PK_L_(0x5C, 0x42)
#define REG_SC_BK5C_42_H      _PK_H_(0x5C, 0x42)
#define REG_SC_BK5C_43_L      _PK_L_(0x5C, 0x43)
#define REG_SC_BK5C_43_H      _PK_H_(0x5C, 0x43)
#define REG_SC_BK5C_44_L      _PK_L_(0x5C, 0x44)
#define REG_SC_BK5C_44_H      _PK_H_(0x5C, 0x44)
#define REG_SC_BK5C_45_L      _PK_L_(0x5C, 0x45)
#define REG_SC_BK5C_45_H      _PK_H_(0x5C, 0x45)
#define REG_SC_BK5C_46_L      _PK_L_(0x5C, 0x46)
#define REG_SC_BK5C_46_H      _PK_H_(0x5C, 0x46)
#define REG_SC_BK5C_47_L      _PK_L_(0x5C, 0x47)
#define REG_SC_BK5C_47_H      _PK_H_(0x5C, 0x47)
#define REG_SC_BK5C_48_L      _PK_L_(0x5C, 0x48)
#define REG_SC_BK5C_48_H      _PK_H_(0x5C, 0x48)
#define REG_SC_BK5C_49_L      _PK_L_(0x5C, 0x49)
#define REG_SC_BK5C_49_H      _PK_H_(0x5C, 0x49)
#define REG_SC_BK5C_4A_L      _PK_L_(0x5C, 0x4A)
#define REG_SC_BK5C_4A_H      _PK_H_(0x5C, 0x4A)
#define REG_SC_BK5C_4B_L      _PK_L_(0x5C, 0x4B)
#define REG_SC_BK5C_4B_H      _PK_H_(0x5C, 0x4B)
#define REG_SC_BK5C_4C_L      _PK_L_(0x5C, 0x4C)
#define REG_SC_BK5C_4C_H      _PK_H_(0x5C, 0x4C)
#define REG_SC_BK5C_4D_L      _PK_L_(0x5C, 0x4D)
#define REG_SC_BK5C_4D_H      _PK_H_(0x5C, 0x4D)
#define REG_SC_BK5C_4E_L      _PK_L_(0x5C, 0x4E)
#define REG_SC_BK5C_4E_H      _PK_H_(0x5C, 0x4E)
#define REG_SC_BK5C_4F_L      _PK_L_(0x5C, 0x4F)
#define REG_SC_BK5C_4F_H      _PK_H_(0x5C, 0x4F)
#define REG_SC_BK5C_50_L      _PK_L_(0x5C, 0x50)
#define REG_SC_BK5C_50_H      _PK_H_(0x5C, 0x50)
#define REG_SC_BK5C_51_L      _PK_L_(0x5C, 0x51)
#define REG_SC_BK5C_51_H      _PK_H_(0x5C, 0x51)
#define REG_SC_BK5C_52_L      _PK_L_(0x5C, 0x52)
#define REG_SC_BK5C_52_H      _PK_H_(0x5C, 0x52)
#define REG_SC_BK5C_53_L      _PK_L_(0x5C, 0x53)
#define REG_SC_BK5C_53_H      _PK_H_(0x5C, 0x53)
#define REG_SC_BK5C_54_L      _PK_L_(0x5C, 0x54)
#define REG_SC_BK5C_54_H      _PK_H_(0x5C, 0x54)
#define REG_SC_BK5C_55_L      _PK_L_(0x5C, 0x55)
#define REG_SC_BK5C_55_H      _PK_H_(0x5C, 0x55)
#define REG_SC_BK5C_56_L      _PK_L_(0x5C, 0x56)
#define REG_SC_BK5C_56_H      _PK_H_(0x5C, 0x56)
#define REG_SC_BK5C_57_L      _PK_L_(0x5C, 0x57)
#define REG_SC_BK5C_57_H      _PK_H_(0x5C, 0x57)
#define REG_SC_BK5C_58_L      _PK_L_(0x5C, 0x58)
#define REG_SC_BK5C_58_H      _PK_H_(0x5C, 0x58)
#define REG_SC_BK5C_59_L      _PK_L_(0x5C, 0x59)
#define REG_SC_BK5C_59_H      _PK_H_(0x5C, 0x59)
#define REG_SC_BK5C_5A_L      _PK_L_(0x5C, 0x5A)
#define REG_SC_BK5C_5A_H      _PK_H_(0x5C, 0x5A)
#define REG_SC_BK5C_5B_L      _PK_L_(0x5C, 0x5B)
#define REG_SC_BK5C_5B_H      _PK_H_(0x5C, 0x5B)
#define REG_SC_BK5C_5C_L      _PK_L_(0x5C, 0x5C)
#define REG_SC_BK5C_5C_H      _PK_H_(0x5C, 0x5C)
#define REG_SC_BK5C_5D_L      _PK_L_(0x5C, 0x5D)
#define REG_SC_BK5C_5D_H      _PK_H_(0x5C, 0x5D)
#define REG_SC_BK5C_5E_L      _PK_L_(0x5C, 0x5E)
#define REG_SC_BK5C_5E_H      _PK_H_(0x5C, 0x5E)
#define REG_SC_BK5C_5F_L      _PK_L_(0x5C, 0x5F)
#define REG_SC_BK5C_5F_H      _PK_H_(0x5C, 0x5F)
#define REG_SC_BK5C_60_L      _PK_L_(0x5C, 0x60)
#define REG_SC_BK5C_60_H      _PK_H_(0x5C, 0x60)
#define REG_SC_BK5C_61_L      _PK_L_(0x5C, 0x61)
#define REG_SC_BK5C_61_H      _PK_H_(0x5C, 0x61)
#define REG_SC_BK5C_62_L      _PK_L_(0x5C, 0x62)
#define REG_SC_BK5C_62_H      _PK_H_(0x5C, 0x62)
#define REG_SC_BK5C_63_L      _PK_L_(0x5C, 0x63)
#define REG_SC_BK5C_63_H      _PK_H_(0x5C, 0x63)
#define REG_SC_BK5C_64_L      _PK_L_(0x5C, 0x64)
#define REG_SC_BK5C_64_H      _PK_H_(0x5C, 0x64)
#define REG_SC_BK5C_65_L      _PK_L_(0x5C, 0x65)
#define REG_SC_BK5C_65_H      _PK_H_(0x5C, 0x65)
#define REG_SC_BK5C_66_L      _PK_L_(0x5C, 0x66)
#define REG_SC_BK5C_66_H      _PK_H_(0x5C, 0x66)
#define REG_SC_BK5C_67_L      _PK_L_(0x5C, 0x67)
#define REG_SC_BK5C_67_H      _PK_H_(0x5C, 0x67)
#define REG_SC_BK5C_68_L      _PK_L_(0x5C, 0x68)
#define REG_SC_BK5C_68_H      _PK_H_(0x5C, 0x68)
#define REG_SC_BK5C_69_L      _PK_L_(0x5C, 0x69)
#define REG_SC_BK5C_69_H      _PK_H_(0x5C, 0x69)
#define REG_SC_BK5C_6A_L      _PK_L_(0x5C, 0x6A)
#define REG_SC_BK5C_6A_H      _PK_H_(0x5C, 0x6A)
#define REG_SC_BK5C_6B_L      _PK_L_(0x5C, 0x6B)
#define REG_SC_BK5C_6B_H      _PK_H_(0x5C, 0x6B)
#define REG_SC_BK5C_6C_L      _PK_L_(0x5C, 0x6C)
#define REG_SC_BK5C_6C_H      _PK_H_(0x5C, 0x6C)
#define REG_SC_BK5C_6D_L      _PK_L_(0x5C, 0x6D)
#define REG_SC_BK5C_6D_H      _PK_H_(0x5C, 0x6D)
#define REG_SC_BK5C_6E_L      _PK_L_(0x5C, 0x6E)
#define REG_SC_BK5C_6E_H      _PK_H_(0x5C, 0x6E)
#define REG_SC_BK5C_6F_L      _PK_L_(0x5C, 0x6F)
#define REG_SC_BK5C_6F_H      _PK_H_(0x5C, 0x6F)
#define REG_SC_BK5C_70_L      _PK_L_(0x5C, 0x70)
#define REG_SC_BK5C_70_H      _PK_H_(0x5C, 0x70)
#define REG_SC_BK5C_71_L      _PK_L_(0x5C, 0x71)
#define REG_SC_BK5C_71_H      _PK_H_(0x5C, 0x71)
#define REG_SC_BK5C_72_L      _PK_L_(0x5C, 0x72)
#define REG_SC_BK5C_72_H      _PK_H_(0x5C, 0x72)
#define REG_SC_BK5C_73_L      _PK_L_(0x5C, 0x73)
#define REG_SC_BK5C_73_H      _PK_H_(0x5C, 0x73)
#define REG_SC_BK5C_74_L      _PK_L_(0x5C, 0x74)
#define REG_SC_BK5C_74_H      _PK_H_(0x5C, 0x74)
#define REG_SC_BK5C_75_L      _PK_L_(0x5C, 0x75)
#define REG_SC_BK5C_75_H      _PK_H_(0x5C, 0x75)
#define REG_SC_BK5C_76_L      _PK_L_(0x5C, 0x76)
#define REG_SC_BK5C_76_H      _PK_H_(0x5C, 0x76)
#define REG_SC_BK5C_77_L      _PK_L_(0x5C, 0x77)
#define REG_SC_BK5C_77_H      _PK_H_(0x5C, 0x77)
#define REG_SC_BK5C_78_L      _PK_L_(0x5C, 0x78)
#define REG_SC_BK5C_78_H      _PK_H_(0x5C, 0x78)
#define REG_SC_BK5C_79_L      _PK_L_(0x5C, 0x79)
#define REG_SC_BK5C_79_H      _PK_H_(0x5C, 0x79)
#define REG_SC_BK5C_7A_L      _PK_L_(0x5C, 0x7A)
#define REG_SC_BK5C_7A_H      _PK_H_(0x5C, 0x7A)
#define REG_SC_BK5C_7B_L      _PK_L_(0x5C, 0x7B)
#define REG_SC_BK5C_7B_H      _PK_H_(0x5C, 0x7B)
#define REG_SC_BK5C_7C_L      _PK_L_(0x5C, 0x7C)
#define REG_SC_BK5C_7C_H      _PK_H_(0x5C, 0x7C)
#define REG_SC_BK5C_7D_L      _PK_L_(0x5C, 0x7D)
#define REG_SC_BK5C_7D_H      _PK_H_(0x5C, 0x7D)
#define REG_SC_BK5C_7E_L      _PK_L_(0x5C, 0x7E)
#define REG_SC_BK5C_7E_H      _PK_H_(0x5C, 0x7E)
#define REG_SC_BK5C_7F_L      _PK_L_(0x5C, 0x7F)
#define REG_SC_BK5C_7F_H      _PK_H_(0x5C, 0x7F)

//----------------------------------------------
//  BK5E:
//----------------------------------------------
#define REG_SC_BK5E_00_L      _PK_L_(0x5E, 0x00)
#define REG_SC_BK5E_00_H      _PK_H_(0x5E, 0x00)
#define REG_SC_BK5E_01_L      _PK_L_(0x5E, 0x01)
#define REG_SC_BK5E_01_H      _PK_H_(0x5E, 0x01)
#define REG_SC_BK5E_02_L      _PK_L_(0x5E, 0x02)
#define REG_SC_BK5E_02_H      _PK_H_(0x5E, 0x02)
#define REG_SC_BK5E_03_L      _PK_L_(0x5E, 0x03)
#define REG_SC_BK5E_03_H      _PK_H_(0x5E, 0x03)
#define REG_SC_BK5E_04_L      _PK_L_(0x5E, 0x04)
#define REG_SC_BK5E_04_H      _PK_H_(0x5E, 0x04)
#define REG_SC_BK5E_05_L      _PK_L_(0x5E, 0x05)
#define REG_SC_BK5E_05_H      _PK_H_(0x5E, 0x05)
#define REG_SC_BK5E_06_L      _PK_L_(0x5E, 0x06)
#define REG_SC_BK5E_06_H      _PK_H_(0x5E, 0x06)
#define REG_SC_BK5E_07_L      _PK_L_(0x5E, 0x07)
#define REG_SC_BK5E_07_H      _PK_H_(0x5E, 0x07)
#define REG_SC_BK5E_08_L      _PK_L_(0x5E, 0x08)
#define REG_SC_BK5E_08_H      _PK_H_(0x5E, 0x08)
#define REG_SC_BK5E_09_L      _PK_L_(0x5E, 0x09)
#define REG_SC_BK5E_09_H      _PK_H_(0x5E, 0x09)
#define REG_SC_BK5E_0A_L      _PK_L_(0x5E, 0x0A)
#define REG_SC_BK5E_0A_H      _PK_H_(0x5E, 0x0A)
#define REG_SC_BK5E_0B_L      _PK_L_(0x5E, 0x0B)
#define REG_SC_BK5E_0B_H      _PK_H_(0x5E, 0x0B)
#define REG_SC_BK5E_0C_L      _PK_L_(0x5E, 0x0C)
#define REG_SC_BK5E_0C_H      _PK_H_(0x5E, 0x0C)
#define REG_SC_BK5E_0D_L      _PK_L_(0x5E, 0x0D)
#define REG_SC_BK5E_0D_H      _PK_H_(0x5E, 0x0D)
#define REG_SC_BK5E_0E_L      _PK_L_(0x5E, 0x0E)
#define REG_SC_BK5E_0E_H      _PK_H_(0x5E, 0x0E)
#define REG_SC_BK5E_0F_L      _PK_L_(0x5E, 0x0F)
#define REG_SC_BK5E_0F_H      _PK_H_(0x5E, 0x0F)
#define REG_SC_BK5E_10_L      _PK_L_(0x5E, 0x10)
#define REG_SC_BK5E_10_H      _PK_H_(0x5E, 0x10)
#define REG_SC_BK5E_11_L      _PK_L_(0x5E, 0x11)
#define REG_SC_BK5E_11_H      _PK_H_(0x5E, 0x11)
#define REG_SC_BK5E_12_L      _PK_L_(0x5E, 0x12)
#define REG_SC_BK5E_12_H      _PK_H_(0x5E, 0x12)
#define REG_SC_BK5E_13_L      _PK_L_(0x5E, 0x13)
#define REG_SC_BK5E_13_H      _PK_H_(0x5E, 0x13)
#define REG_SC_BK5E_14_L      _PK_L_(0x5E, 0x14)
#define REG_SC_BK5E_14_H      _PK_H_(0x5E, 0x14)
#define REG_SC_BK5E_15_L      _PK_L_(0x5E, 0x15)
#define REG_SC_BK5E_15_H      _PK_H_(0x5E, 0x15)
#define REG_SC_BK5E_16_L      _PK_L_(0x5E, 0x16)
#define REG_SC_BK5E_16_H      _PK_H_(0x5E, 0x16)
#define REG_SC_BK5E_17_L      _PK_L_(0x5E, 0x17)
#define REG_SC_BK5E_17_H      _PK_H_(0x5E, 0x17)
#define REG_SC_BK5E_18_L      _PK_L_(0x5E, 0x18)
#define REG_SC_BK5E_18_H      _PK_H_(0x5E, 0x18)
#define REG_SC_BK5E_19_L      _PK_L_(0x5E, 0x19)
#define REG_SC_BK5E_19_H      _PK_H_(0x5E, 0x19)
#define REG_SC_BK5E_1A_L      _PK_L_(0x5E, 0x1A)
#define REG_SC_BK5E_1A_H      _PK_H_(0x5E, 0x1A)
#define REG_SC_BK5E_1B_L      _PK_L_(0x5E, 0x1B)
#define REG_SC_BK5E_1B_H      _PK_H_(0x5E, 0x1B)
#define REG_SC_BK5E_1C_L      _PK_L_(0x5E, 0x1C)
#define REG_SC_BK5E_1C_H      _PK_H_(0x5E, 0x1C)
#define REG_SC_BK5E_1D_L      _PK_L_(0x5E, 0x1D)
#define REG_SC_BK5E_1D_H      _PK_H_(0x5E, 0x1D)
#define REG_SC_BK5E_1E_L      _PK_L_(0x5E, 0x1E)
#define REG_SC_BK5E_1E_H      _PK_H_(0x5E, 0x1E)
#define REG_SC_BK5E_1F_L      _PK_L_(0x5E, 0x1F)
#define REG_SC_BK5E_1F_H      _PK_H_(0x5E, 0x1F)
#define REG_SC_BK5E_20_L      _PK_L_(0x5E, 0x20)
#define REG_SC_BK5E_20_H      _PK_H_(0x5E, 0x20)
#define REG_SC_BK5E_21_L      _PK_L_(0x5E, 0x21)
#define REG_SC_BK5E_21_H      _PK_H_(0x5E, 0x21)
#define REG_SC_BK5E_22_L      _PK_L_(0x5E, 0x22)
#define REG_SC_BK5E_22_H      _PK_H_(0x5E, 0x22)
#define REG_SC_BK5E_23_L      _PK_L_(0x5E, 0x23)
#define REG_SC_BK5E_23_H      _PK_H_(0x5E, 0x23)
#define REG_SC_BK5E_24_L      _PK_L_(0x5E, 0x24)
#define REG_SC_BK5E_24_H      _PK_H_(0x5E, 0x24)
#define REG_SC_BK5E_25_L      _PK_L_(0x5E, 0x25)
#define REG_SC_BK5E_25_H      _PK_H_(0x5E, 0x25)
#define REG_SC_BK5E_26_L      _PK_L_(0x5E, 0x26)
#define REG_SC_BK5E_26_H      _PK_H_(0x5E, 0x26)
#define REG_SC_BK5E_27_L      _PK_L_(0x5E, 0x27)
#define REG_SC_BK5E_27_H      _PK_H_(0x5E, 0x27)
#define REG_SC_BK5E_28_L      _PK_L_(0x5E, 0x28)
#define REG_SC_BK5E_28_H      _PK_H_(0x5E, 0x28)
#define REG_SC_BK5E_29_L      _PK_L_(0x5E, 0x29)
#define REG_SC_BK5E_29_H      _PK_H_(0x5E, 0x29)
#define REG_SC_BK5E_2A_L      _PK_L_(0x5E, 0x2A)
#define REG_SC_BK5E_2A_H      _PK_H_(0x5E, 0x2A)
#define REG_SC_BK5E_2B_L      _PK_L_(0x5E, 0x2B)
#define REG_SC_BK5E_2B_H      _PK_H_(0x5E, 0x2B)
#define REG_SC_BK5E_2C_L      _PK_L_(0x5E, 0x2C)
#define REG_SC_BK5E_2C_H      _PK_H_(0x5E, 0x2C)
#define REG_SC_BK5E_2D_L      _PK_L_(0x5E, 0x2D)
#define REG_SC_BK5E_2D_H      _PK_H_(0x5E, 0x2D)
#define REG_SC_BK5E_2E_L      _PK_L_(0x5E, 0x2E)
#define REG_SC_BK5E_2E_H      _PK_H_(0x5E, 0x2E)
#define REG_SC_BK5E_2F_L      _PK_L_(0x5E, 0x2F)
#define REG_SC_BK5E_2F_H      _PK_H_(0x5E, 0x2F)
#define REG_SC_BK5E_30_L      _PK_L_(0x5E, 0x30)
#define REG_SC_BK5E_30_H      _PK_H_(0x5E, 0x30)
#define REG_SC_BK5E_31_L      _PK_L_(0x5E, 0x31)
#define REG_SC_BK5E_31_H      _PK_H_(0x5E, 0x31)
#define REG_SC_BK5E_32_L      _PK_L_(0x5E, 0x32)
#define REG_SC_BK5E_32_H      _PK_H_(0x5E, 0x32)
#define REG_SC_BK5E_33_L      _PK_L_(0x5E, 0x33)
#define REG_SC_BK5E_33_H      _PK_H_(0x5E, 0x33)
#define REG_SC_BK5E_34_L      _PK_L_(0x5E, 0x34)
#define REG_SC_BK5E_34_H      _PK_H_(0x5E, 0x34)
#define REG_SC_BK5E_35_L      _PK_L_(0x5E, 0x35)
#define REG_SC_BK5E_35_H      _PK_H_(0x5E, 0x35)
#define REG_SC_BK5E_36_L      _PK_L_(0x5E, 0x36)
#define REG_SC_BK5E_36_H      _PK_H_(0x5E, 0x36)
#define REG_SC_BK5E_37_L      _PK_L_(0x5E, 0x37)
#define REG_SC_BK5E_37_H      _PK_H_(0x5E, 0x37)
#define REG_SC_BK5E_38_L      _PK_L_(0x5E, 0x38)
#define REG_SC_BK5E_38_H      _PK_H_(0x5E, 0x38)
#define REG_SC_BK5E_39_L      _PK_L_(0x5E, 0x39)
#define REG_SC_BK5E_39_H      _PK_H_(0x5E, 0x39)
#define REG_SC_BK5E_3A_L      _PK_L_(0x5E, 0x3A)
#define REG_SC_BK5E_3A_H      _PK_H_(0x5E, 0x3A)
#define REG_SC_BK5E_3B_L      _PK_L_(0x5E, 0x3B)
#define REG_SC_BK5E_3B_H      _PK_H_(0x5E, 0x3B)
#define REG_SC_BK5E_3C_L      _PK_L_(0x5E, 0x3C)
#define REG_SC_BK5E_3C_H      _PK_H_(0x5E, 0x3C)
#define REG_SC_BK5E_3D_L      _PK_L_(0x5E, 0x3D)
#define REG_SC_BK5E_3D_H      _PK_H_(0x5E, 0x3D)
#define REG_SC_BK5E_3E_L      _PK_L_(0x5E, 0x3E)
#define REG_SC_BK5E_3E_H      _PK_H_(0x5E, 0x3E)
#define REG_SC_BK5E_3F_L      _PK_L_(0x5E, 0x3F)
#define REG_SC_BK5E_3F_H      _PK_H_(0x5E, 0x3F)
#define REG_SC_BK5E_40_L      _PK_L_(0x5E, 0x40)
#define REG_SC_BK5E_40_H      _PK_H_(0x5E, 0x40)
#define REG_SC_BK5E_41_L      _PK_L_(0x5E, 0x41)
#define REG_SC_BK5E_41_H      _PK_H_(0x5E, 0x41)
#define REG_SC_BK5E_42_L      _PK_L_(0x5E, 0x42)
#define REG_SC_BK5E_42_H      _PK_H_(0x5E, 0x42)
#define REG_SC_BK5E_43_L      _PK_L_(0x5E, 0x43)
#define REG_SC_BK5E_43_H      _PK_H_(0x5E, 0x43)
#define REG_SC_BK5E_44_L      _PK_L_(0x5E, 0x44)
#define REG_SC_BK5E_44_H      _PK_H_(0x5E, 0x44)
#define REG_SC_BK5E_45_L      _PK_L_(0x5E, 0x45)
#define REG_SC_BK5E_45_H      _PK_H_(0x5E, 0x45)
#define REG_SC_BK5E_46_L      _PK_L_(0x5E, 0x46)
#define REG_SC_BK5E_46_H      _PK_H_(0x5E, 0x46)
#define REG_SC_BK5E_47_L      _PK_L_(0x5E, 0x47)
#define REG_SC_BK5E_47_H      _PK_H_(0x5E, 0x47)
#define REG_SC_BK5E_48_L      _PK_L_(0x5E, 0x48)
#define REG_SC_BK5E_48_H      _PK_H_(0x5E, 0x48)
#define REG_SC_BK5E_49_L      _PK_L_(0x5E, 0x49)
#define REG_SC_BK5E_49_H      _PK_H_(0x5E, 0x49)
#define REG_SC_BK5E_4A_L      _PK_L_(0x5E, 0x4A)
#define REG_SC_BK5E_4A_H      _PK_H_(0x5E, 0x4A)
#define REG_SC_BK5E_4B_L      _PK_L_(0x5E, 0x4B)
#define REG_SC_BK5E_4B_H      _PK_H_(0x5E, 0x4B)
#define REG_SC_BK5E_4C_L      _PK_L_(0x5E, 0x4C)
#define REG_SC_BK5E_4C_H      _PK_H_(0x5E, 0x4C)
#define REG_SC_BK5E_4D_L      _PK_L_(0x5E, 0x4D)
#define REG_SC_BK5E_4D_H      _PK_H_(0x5E, 0x4D)
#define REG_SC_BK5E_4E_L      _PK_L_(0x5E, 0x4E)
#define REG_SC_BK5E_4E_H      _PK_H_(0x5E, 0x4E)
#define REG_SC_BK5E_4F_L      _PK_L_(0x5E, 0x4F)
#define REG_SC_BK5E_4F_H      _PK_H_(0x5E, 0x4F)
#define REG_SC_BK5E_50_L      _PK_L_(0x5E, 0x50)
#define REG_SC_BK5E_50_H      _PK_H_(0x5E, 0x50)
#define REG_SC_BK5E_51_L      _PK_L_(0x5E, 0x51)
#define REG_SC_BK5E_51_H      _PK_H_(0x5E, 0x51)
#define REG_SC_BK5E_52_L      _PK_L_(0x5E, 0x52)
#define REG_SC_BK5E_52_H      _PK_H_(0x5E, 0x52)
#define REG_SC_BK5E_53_L      _PK_L_(0x5E, 0x53)
#define REG_SC_BK5E_53_H      _PK_H_(0x5E, 0x53)
#define REG_SC_BK5E_54_L      _PK_L_(0x5E, 0x54)
#define REG_SC_BK5E_54_H      _PK_H_(0x5E, 0x54)
#define REG_SC_BK5E_55_L      _PK_L_(0x5E, 0x55)
#define REG_SC_BK5E_55_H      _PK_H_(0x5E, 0x55)
#define REG_SC_BK5E_56_L      _PK_L_(0x5E, 0x56)
#define REG_SC_BK5E_56_H      _PK_H_(0x5E, 0x56)
#define REG_SC_BK5E_57_L      _PK_L_(0x5E, 0x57)
#define REG_SC_BK5E_57_H      _PK_H_(0x5E, 0x57)
#define REG_SC_BK5E_58_L      _PK_L_(0x5E, 0x58)
#define REG_SC_BK5E_58_H      _PK_H_(0x5E, 0x58)
#define REG_SC_BK5E_59_L      _PK_L_(0x5E, 0x59)
#define REG_SC_BK5E_59_H      _PK_H_(0x5E, 0x59)
#define REG_SC_BK5E_5A_L      _PK_L_(0x5E, 0x5A)
#define REG_SC_BK5E_5A_H      _PK_H_(0x5E, 0x5A)
#define REG_SC_BK5E_5B_L      _PK_L_(0x5E, 0x5B)
#define REG_SC_BK5E_5B_H      _PK_H_(0x5E, 0x5B)
#define REG_SC_BK5E_5C_L      _PK_L_(0x5E, 0x5C)
#define REG_SC_BK5E_5C_H      _PK_H_(0x5E, 0x5C)
#define REG_SC_BK5E_5D_L      _PK_L_(0x5E, 0x5D)
#define REG_SC_BK5E_5D_H      _PK_H_(0x5E, 0x5D)
#define REG_SC_BK5E_5E_L      _PK_L_(0x5E, 0x5E)
#define REG_SC_BK5E_5E_H      _PK_H_(0x5E, 0x5E)
#define REG_SC_BK5E_5F_L      _PK_L_(0x5E, 0x5F)
#define REG_SC_BK5E_5F_H      _PK_H_(0x5E, 0x5F)
#define REG_SC_BK5E_60_L      _PK_L_(0x5E, 0x60)
#define REG_SC_BK5E_60_H      _PK_H_(0x5E, 0x60)
#define REG_SC_BK5E_61_L      _PK_L_(0x5E, 0x61)
#define REG_SC_BK5E_61_H      _PK_H_(0x5E, 0x61)
#define REG_SC_BK5E_62_L      _PK_L_(0x5E, 0x62)
#define REG_SC_BK5E_62_H      _PK_H_(0x5E, 0x62)
#define REG_SC_BK5E_63_L      _PK_L_(0x5E, 0x63)
#define REG_SC_BK5E_63_H      _PK_H_(0x5E, 0x63)
#define REG_SC_BK5E_64_L      _PK_L_(0x5E, 0x64)
#define REG_SC_BK5E_64_H      _PK_H_(0x5E, 0x64)
#define REG_SC_BK5E_65_L      _PK_L_(0x5E, 0x65)
#define REG_SC_BK5E_65_H      _PK_H_(0x5E, 0x65)
#define REG_SC_BK5E_66_L      _PK_L_(0x5E, 0x66)
#define REG_SC_BK5E_66_H      _PK_H_(0x5E, 0x66)
#define REG_SC_BK5E_67_L      _PK_L_(0x5E, 0x67)
#define REG_SC_BK5E_67_H      _PK_H_(0x5E, 0x67)
#define REG_SC_BK5E_68_L      _PK_L_(0x5E, 0x68)
#define REG_SC_BK5E_68_H      _PK_H_(0x5E, 0x68)
#define REG_SC_BK5E_69_L      _PK_L_(0x5E, 0x69)
#define REG_SC_BK5E_69_H      _PK_H_(0x5E, 0x69)
#define REG_SC_BK5E_6A_L      _PK_L_(0x5E, 0x6A)
#define REG_SC_BK5E_6A_H      _PK_H_(0x5E, 0x6A)
#define REG_SC_BK5E_6B_L      _PK_L_(0x5E, 0x6B)
#define REG_SC_BK5E_6B_H      _PK_H_(0x5E, 0x6B)
#define REG_SC_BK5E_6C_L      _PK_L_(0x5E, 0x6C)
#define REG_SC_BK5E_6C_H      _PK_H_(0x5E, 0x6C)
#define REG_SC_BK5E_6D_L      _PK_L_(0x5E, 0x6D)
#define REG_SC_BK5E_6D_H      _PK_H_(0x5E, 0x6D)
#define REG_SC_BK5E_6E_L      _PK_L_(0x5E, 0x6E)
#define REG_SC_BK5E_6E_H      _PK_H_(0x5E, 0x6E)
#define REG_SC_BK5E_6F_L      _PK_L_(0x5E, 0x6F)
#define REG_SC_BK5E_6F_H      _PK_H_(0x5E, 0x6F)
#define REG_SC_BK5E_70_L      _PK_L_(0x5E, 0x70)
#define REG_SC_BK5E_70_H      _PK_H_(0x5E, 0x70)
#define REG_SC_BK5E_71_L      _PK_L_(0x5E, 0x71)
#define REG_SC_BK5E_71_H      _PK_H_(0x5E, 0x71)
#define REG_SC_BK5E_72_L      _PK_L_(0x5E, 0x72)
#define REG_SC_BK5E_72_H      _PK_H_(0x5E, 0x72)
#define REG_SC_BK5E_73_L      _PK_L_(0x5E, 0x73)
#define REG_SC_BK5E_73_H      _PK_H_(0x5E, 0x73)
#define REG_SC_BK5E_74_L      _PK_L_(0x5E, 0x74)
#define REG_SC_BK5E_74_H      _PK_H_(0x5E, 0x74)
#define REG_SC_BK5E_75_L      _PK_L_(0x5E, 0x75)
#define REG_SC_BK5E_75_H      _PK_H_(0x5E, 0x75)
#define REG_SC_BK5E_76_L      _PK_L_(0x5E, 0x76)
#define REG_SC_BK5E_76_H      _PK_H_(0x5E, 0x76)
#define REG_SC_BK5E_77_L      _PK_L_(0x5E, 0x77)
#define REG_SC_BK5E_77_H      _PK_H_(0x5E, 0x77)
#define REG_SC_BK5E_78_L      _PK_L_(0x5E, 0x78)
#define REG_SC_BK5E_78_H      _PK_H_(0x5E, 0x78)
#define REG_SC_BK5E_79_L      _PK_L_(0x5E, 0x79)
#define REG_SC_BK5E_79_H      _PK_H_(0x5E, 0x79)
#define REG_SC_BK5E_7A_L      _PK_L_(0x5E, 0x7A)
#define REG_SC_BK5E_7A_H      _PK_H_(0x5E, 0x7A)
#define REG_SC_BK5E_7B_L      _PK_L_(0x5E, 0x7B)
#define REG_SC_BK5E_7B_H      _PK_H_(0x5E, 0x7B)
#define REG_SC_BK5E_7C_L      _PK_L_(0x5E, 0x7C)
#define REG_SC_BK5E_7C_H      _PK_H_(0x5E, 0x7C)
#define REG_SC_BK5E_7D_L      _PK_L_(0x5E, 0x7D)
#define REG_SC_BK5E_7D_H      _PK_H_(0x5E, 0x7D)
#define REG_SC_BK5E_7E_L      _PK_L_(0x5E, 0x7E)
#define REG_SC_BK5E_7E_H      _PK_H_(0x5E, 0x7E)
#define REG_SC_BK5E_7F_L      _PK_L_(0x5E, 0x7F)
#define REG_SC_BK5E_7F_H      _PK_H_(0x5E, 0x7F)

//----------------------------------------------
//  BK62: 2D TO 3D PIXEL
//----------------------------------------------
#define REG_SC_BK62_00_L      _PK_L_(0x62, 0x00)
#define REG_SC_BK62_00_H      _PK_H_(0x62, 0x00)
#define REG_SC_BK62_01_L      _PK_L_(0x62, 0x01)
#define REG_SC_BK62_01_H      _PK_H_(0x62, 0x01)
#define REG_SC_BK62_02_L      _PK_L_(0x62, 0x02)
#define REG_SC_BK62_02_H      _PK_H_(0x62, 0x02)
#define REG_SC_BK62_03_L      _PK_L_(0x62, 0x03)
#define REG_SC_BK62_03_H      _PK_H_(0x62, 0x03)
#define REG_SC_BK62_04_L      _PK_L_(0x62, 0x04)
#define REG_SC_BK62_04_H      _PK_H_(0x62, 0x04)
#define REG_SC_BK62_05_L      _PK_L_(0x62, 0x05)
#define REG_SC_BK62_05_H      _PK_H_(0x62, 0x05)
#define REG_SC_BK62_06_L      _PK_L_(0x62, 0x06)
#define REG_SC_BK62_06_H      _PK_H_(0x62, 0x06)
#define REG_SC_BK62_07_L      _PK_L_(0x62, 0x07)
#define REG_SC_BK62_07_H      _PK_H_(0x62, 0x07)
#define REG_SC_BK62_08_L      _PK_L_(0x62, 0x08)
#define REG_SC_BK62_08_H      _PK_H_(0x62, 0x08)
#define REG_SC_BK62_09_L      _PK_L_(0x62, 0x09)
#define REG_SC_BK62_09_H      _PK_H_(0x62, 0x09)
#define REG_SC_BK62_0A_L      _PK_L_(0x62, 0x0A)
#define REG_SC_BK62_0A_H      _PK_H_(0x62, 0x0A)
#define REG_SC_BK62_0B_L      _PK_L_(0x62, 0x0B)
#define REG_SC_BK62_0B_H      _PK_H_(0x62, 0x0B)
#define REG_SC_BK62_0C_L      _PK_L_(0x62, 0x0C)
#define REG_SC_BK62_0C_H      _PK_H_(0x62, 0x0C)
#define REG_SC_BK62_0D_L      _PK_L_(0x62, 0x0D)
#define REG_SC_BK62_0D_H      _PK_H_(0x62, 0x0D)
#define REG_SC_BK62_0E_L      _PK_L_(0x62, 0x0E)
#define REG_SC_BK62_0E_H      _PK_H_(0x62, 0x0E)
#define REG_SC_BK62_0F_L      _PK_L_(0x62, 0x0F)
#define REG_SC_BK62_0F_H      _PK_H_(0x62, 0x0F)
#define REG_SC_BK62_10_L      _PK_L_(0x62, 0x10)
#define REG_SC_BK62_10_H      _PK_H_(0x62, 0x10)
#define REG_SC_BK62_11_L      _PK_L_(0x62, 0x11)
#define REG_SC_BK62_11_H      _PK_H_(0x62, 0x11)
#define REG_SC_BK62_12_L      _PK_L_(0x62, 0x12)
#define REG_SC_BK62_12_H      _PK_H_(0x62, 0x12)
#define REG_SC_BK62_13_L      _PK_L_(0x62, 0x13)
#define REG_SC_BK62_13_H      _PK_H_(0x62, 0x13)
#define REG_SC_BK62_14_L      _PK_L_(0x62, 0x14)
#define REG_SC_BK62_14_H      _PK_H_(0x62, 0x14)
#define REG_SC_BK62_15_L      _PK_L_(0x62, 0x15)
#define REG_SC_BK62_15_H      _PK_H_(0x62, 0x15)
#define REG_SC_BK62_16_L      _PK_L_(0x62, 0x16)
#define REG_SC_BK62_16_H      _PK_H_(0x62, 0x16)
#define REG_SC_BK62_17_L      _PK_L_(0x62, 0x17)
#define REG_SC_BK62_17_H      _PK_H_(0x62, 0x17)
#define REG_SC_BK62_18_L      _PK_L_(0x62, 0x18)
#define REG_SC_BK62_18_H      _PK_H_(0x62, 0x18)
#define REG_SC_BK62_19_L      _PK_L_(0x62, 0x19)
#define REG_SC_BK62_19_H      _PK_H_(0x62, 0x19)
#define REG_SC_BK62_1A_L      _PK_L_(0x62, 0x1A)
#define REG_SC_BK62_1A_H      _PK_H_(0x62, 0x1A)
#define REG_SC_BK62_1B_L      _PK_L_(0x62, 0x1B)
#define REG_SC_BK62_1B_H      _PK_H_(0x62, 0x1B)
#define REG_SC_BK62_1C_L      _PK_L_(0x62, 0x1C)
#define REG_SC_BK62_1C_H      _PK_H_(0x62, 0x1C)
#define REG_SC_BK62_1D_L      _PK_L_(0x62, 0x1D)
#define REG_SC_BK62_1D_H      _PK_H_(0x62, 0x1D)
#define REG_SC_BK62_1E_L      _PK_L_(0x62, 0x1E)
#define REG_SC_BK62_1E_H      _PK_H_(0x62, 0x1E)
#define REG_SC_BK62_1F_L      _PK_L_(0x62, 0x1F)
#define REG_SC_BK62_1F_H      _PK_H_(0x62, 0x1F)
#define REG_SC_BK62_20_L      _PK_L_(0x62, 0x20)
#define REG_SC_BK62_20_H      _PK_H_(0x62, 0x20)
#define REG_SC_BK62_21_L      _PK_L_(0x62, 0x21)
#define REG_SC_BK62_21_H      _PK_H_(0x62, 0x21)
#define REG_SC_BK62_22_L      _PK_L_(0x62, 0x22)
#define REG_SC_BK62_22_H      _PK_H_(0x62, 0x22)
#define REG_SC_BK62_23_L      _PK_L_(0x62, 0x23)
#define REG_SC_BK62_23_H      _PK_H_(0x62, 0x23)
#define REG_SC_BK62_24_L      _PK_L_(0x62, 0x24)
#define REG_SC_BK62_24_H      _PK_H_(0x62, 0x24)
#define REG_SC_BK62_25_L      _PK_L_(0x62, 0x25)
#define REG_SC_BK62_25_H      _PK_H_(0x62, 0x25)
#define REG_SC_BK62_26_L      _PK_L_(0x62, 0x26)
#define REG_SC_BK62_26_H      _PK_H_(0x62, 0x26)
#define REG_SC_BK62_27_L      _PK_L_(0x62, 0x27)
#define REG_SC_BK62_27_H      _PK_H_(0x62, 0x27)
#define REG_SC_BK62_28_L      _PK_L_(0x62, 0x28)
#define REG_SC_BK62_28_H      _PK_H_(0x62, 0x28)
#define REG_SC_BK62_29_L      _PK_L_(0x62, 0x29)
#define REG_SC_BK62_29_H      _PK_H_(0x62, 0x29)
#define REG_SC_BK62_2A_L      _PK_L_(0x62, 0x2A)
#define REG_SC_BK62_2A_H      _PK_H_(0x62, 0x2A)
#define REG_SC_BK62_2B_L      _PK_L_(0x62, 0x2B)
#define REG_SC_BK62_2B_H      _PK_H_(0x62, 0x2B)
#define REG_SC_BK62_2C_L      _PK_L_(0x62, 0x2C)
#define REG_SC_BK62_2C_H      _PK_H_(0x62, 0x2C)
#define REG_SC_BK62_2D_L      _PK_L_(0x62, 0x2D)
#define REG_SC_BK62_2D_H      _PK_H_(0x62, 0x2D)
#define REG_SC_BK62_2E_L      _PK_L_(0x62, 0x2E)
#define REG_SC_BK62_2E_H      _PK_H_(0x62, 0x2E)
#define REG_SC_BK62_2F_L      _PK_L_(0x62, 0x2F)
#define REG_SC_BK62_2F_H      _PK_H_(0x62, 0x2F)
#define REG_SC_BK62_30_L      _PK_L_(0x62, 0x30)
#define REG_SC_BK62_30_H      _PK_H_(0x62, 0x30)
#define REG_SC_BK62_31_L      _PK_L_(0x62, 0x31)
#define REG_SC_BK62_31_H      _PK_H_(0x62, 0x31)
#define REG_SC_BK62_32_L      _PK_L_(0x62, 0x32)
#define REG_SC_BK62_32_H      _PK_H_(0x62, 0x32)
#define REG_SC_BK62_33_L      _PK_L_(0x62, 0x33)
#define REG_SC_BK62_33_H      _PK_H_(0x62, 0x33)
#define REG_SC_BK62_34_L      _PK_L_(0x62, 0x34)
#define REG_SC_BK62_34_H      _PK_H_(0x62, 0x34)
#define REG_SC_BK62_35_L      _PK_L_(0x62, 0x35)
#define REG_SC_BK62_35_H      _PK_H_(0x62, 0x35)
#define REG_SC_BK62_36_L      _PK_L_(0x62, 0x36)
#define REG_SC_BK62_36_H      _PK_H_(0x62, 0x36)
#define REG_SC_BK62_37_L      _PK_L_(0x62, 0x37)
#define REG_SC_BK62_37_H      _PK_H_(0x62, 0x37)
#define REG_SC_BK62_38_L      _PK_L_(0x62, 0x38)
#define REG_SC_BK62_38_H      _PK_H_(0x62, 0x38)
#define REG_SC_BK62_39_L      _PK_L_(0x62, 0x39)
#define REG_SC_BK62_39_H      _PK_H_(0x62, 0x39)
#define REG_SC_BK62_3A_L      _PK_L_(0x62, 0x3A)
#define REG_SC_BK62_3A_H      _PK_H_(0x62, 0x3A)
#define REG_SC_BK62_3B_L      _PK_L_(0x62, 0x3B)
#define REG_SC_BK62_3B_H      _PK_H_(0x62, 0x3B)
#define REG_SC_BK62_3C_L      _PK_L_(0x62, 0x3C)
#define REG_SC_BK62_3C_H      _PK_H_(0x62, 0x3C)
#define REG_SC_BK62_3D_L      _PK_L_(0x62, 0x3D)
#define REG_SC_BK62_3D_H      _PK_H_(0x62, 0x3D)
#define REG_SC_BK62_3E_L      _PK_L_(0x62, 0x3E)
#define REG_SC_BK62_3E_H      _PK_H_(0x62, 0x3E)
#define REG_SC_BK62_3F_L      _PK_L_(0x62, 0x3F)
#define REG_SC_BK62_3F_H      _PK_H_(0x62, 0x3F)
#define REG_SC_BK62_40_L      _PK_L_(0x62, 0x40)
#define REG_SC_BK62_40_H      _PK_H_(0x62, 0x40)
#define REG_SC_BK62_41_L      _PK_L_(0x62, 0x41)
#define REG_SC_BK62_41_H      _PK_H_(0x62, 0x41)
#define REG_SC_BK62_42_L      _PK_L_(0x62, 0x42)
#define REG_SC_BK62_42_H      _PK_H_(0x62, 0x42)
#define REG_SC_BK62_43_L      _PK_L_(0x62, 0x43)
#define REG_SC_BK62_43_H      _PK_H_(0x62, 0x43)
#define REG_SC_BK62_44_L      _PK_L_(0x62, 0x44)
#define REG_SC_BK62_44_H      _PK_H_(0x62, 0x44)
#define REG_SC_BK62_45_L      _PK_L_(0x62, 0x45)
#define REG_SC_BK62_45_H      _PK_H_(0x62, 0x45)
#define REG_SC_BK62_46_L      _PK_L_(0x62, 0x46)
#define REG_SC_BK62_46_H      _PK_H_(0x62, 0x46)
#define REG_SC_BK62_47_L      _PK_L_(0x62, 0x47)
#define REG_SC_BK62_47_H      _PK_H_(0x62, 0x47)
#define REG_SC_BK62_48_L      _PK_L_(0x62, 0x48)
#define REG_SC_BK62_48_H      _PK_H_(0x62, 0x48)
#define REG_SC_BK62_49_L      _PK_L_(0x62, 0x49)
#define REG_SC_BK62_49_H      _PK_H_(0x62, 0x49)
#define REG_SC_BK62_4A_L      _PK_L_(0x62, 0x4A)
#define REG_SC_BK62_4A_H      _PK_H_(0x62, 0x4A)
#define REG_SC_BK62_4B_L      _PK_L_(0x62, 0x4B)
#define REG_SC_BK62_4B_H      _PK_H_(0x62, 0x4B)
#define REG_SC_BK62_4C_L      _PK_L_(0x62, 0x4C)
#define REG_SC_BK62_4C_H      _PK_H_(0x62, 0x4C)
#define REG_SC_BK62_4D_L      _PK_L_(0x62, 0x4D)
#define REG_SC_BK62_4D_H      _PK_H_(0x62, 0x4D)
#define REG_SC_BK62_4E_L      _PK_L_(0x62, 0x4E)
#define REG_SC_BK62_4E_H      _PK_H_(0x62, 0x4E)
#define REG_SC_BK62_4F_L      _PK_L_(0x62, 0x4F)
#define REG_SC_BK62_4F_H      _PK_H_(0x62, 0x4F)
#define REG_SC_BK62_50_L      _PK_L_(0x62, 0x50)
#define REG_SC_BK62_50_H      _PK_H_(0x62, 0x50)
#define REG_SC_BK62_51_L      _PK_L_(0x62, 0x51)
#define REG_SC_BK62_51_H      _PK_H_(0x62, 0x51)
#define REG_SC_BK62_52_L      _PK_L_(0x62, 0x52)
#define REG_SC_BK62_52_H      _PK_H_(0x62, 0x52)
#define REG_SC_BK62_53_L      _PK_L_(0x62, 0x53)
#define REG_SC_BK62_53_H      _PK_H_(0x62, 0x53)
#define REG_SC_BK62_54_L      _PK_L_(0x62, 0x54)
#define REG_SC_BK62_54_H      _PK_H_(0x62, 0x54)
#define REG_SC_BK62_55_L      _PK_L_(0x62, 0x55)
#define REG_SC_BK62_55_H      _PK_H_(0x62, 0x55)
#define REG_SC_BK62_56_L      _PK_L_(0x62, 0x56)
#define REG_SC_BK62_56_H      _PK_H_(0x62, 0x56)
#define REG_SC_BK62_57_L      _PK_L_(0x62, 0x57)
#define REG_SC_BK62_57_H      _PK_H_(0x62, 0x57)
#define REG_SC_BK62_58_L      _PK_L_(0x62, 0x58)
#define REG_SC_BK62_58_H      _PK_H_(0x62, 0x58)
#define REG_SC_BK62_59_L      _PK_L_(0x62, 0x59)
#define REG_SC_BK62_59_H      _PK_H_(0x62, 0x59)
#define REG_SC_BK62_5A_L      _PK_L_(0x62, 0x5A)
#define REG_SC_BK62_5A_H      _PK_H_(0x62, 0x5A)
#define REG_SC_BK62_5B_L      _PK_L_(0x62, 0x5B)
#define REG_SC_BK62_5B_H      _PK_H_(0x62, 0x5B)
#define REG_SC_BK62_5C_L      _PK_L_(0x62, 0x5C)
#define REG_SC_BK62_5C_H      _PK_H_(0x62, 0x5C)
#define REG_SC_BK62_5D_L      _PK_L_(0x62, 0x5D)
#define REG_SC_BK62_5D_H      _PK_H_(0x62, 0x5D)
#define REG_SC_BK62_5E_L      _PK_L_(0x62, 0x5E)
#define REG_SC_BK62_5E_H      _PK_H_(0x62, 0x5E)
#define REG_SC_BK62_5F_L      _PK_L_(0x62, 0x5F)
#define REG_SC_BK62_5F_H      _PK_H_(0x62, 0x5F)
#define REG_SC_BK62_60_L      _PK_L_(0x62, 0x60)
#define REG_SC_BK62_60_H      _PK_H_(0x62, 0x60)
#define REG_SC_BK62_61_L      _PK_L_(0x62, 0x61)
#define REG_SC_BK62_61_H      _PK_H_(0x62, 0x61)
#define REG_SC_BK62_62_L      _PK_L_(0x62, 0x62)
#define REG_SC_BK62_62_H      _PK_H_(0x62, 0x62)
#define REG_SC_BK62_63_L      _PK_L_(0x62, 0x63)
#define REG_SC_BK62_63_H      _PK_H_(0x62, 0x63)
#define REG_SC_BK62_64_L      _PK_L_(0x62, 0x64)
#define REG_SC_BK62_64_H      _PK_H_(0x62, 0x64)
#define REG_SC_BK62_65_L      _PK_L_(0x62, 0x65)
#define REG_SC_BK62_65_H      _PK_H_(0x62, 0x65)
#define REG_SC_BK62_66_L      _PK_L_(0x62, 0x66)
#define REG_SC_BK62_66_H      _PK_H_(0x62, 0x66)
#define REG_SC_BK62_67_L      _PK_L_(0x62, 0x67)
#define REG_SC_BK62_67_H      _PK_H_(0x62, 0x67)
#define REG_SC_BK62_68_L      _PK_L_(0x62, 0x68)
#define REG_SC_BK62_68_H      _PK_H_(0x62, 0x68)
#define REG_SC_BK62_69_L      _PK_L_(0x62, 0x69)
#define REG_SC_BK62_69_H      _PK_H_(0x62, 0x69)
#define REG_SC_BK62_6A_L      _PK_L_(0x62, 0x6A)
#define REG_SC_BK62_6A_H      _PK_H_(0x62, 0x6A)
#define REG_SC_BK62_6B_L      _PK_L_(0x62, 0x6B)
#define REG_SC_BK62_6B_H      _PK_H_(0x62, 0x6B)
#define REG_SC_BK62_6C_L      _PK_L_(0x62, 0x6C)
#define REG_SC_BK62_6C_H      _PK_H_(0x62, 0x6C)
#define REG_SC_BK62_6D_L      _PK_L_(0x62, 0x6D)
#define REG_SC_BK62_6D_H      _PK_H_(0x62, 0x6D)
#define REG_SC_BK62_6E_L      _PK_L_(0x62, 0x6E)
#define REG_SC_BK62_6E_H      _PK_H_(0x62, 0x6E)
#define REG_SC_BK62_6F_L      _PK_L_(0x62, 0x6F)
#define REG_SC_BK62_6F_H      _PK_H_(0x62, 0x6F)
#define REG_SC_BK62_70_L      _PK_L_(0x62, 0x70)
#define REG_SC_BK62_70_H      _PK_H_(0x62, 0x70)
#define REG_SC_BK62_71_L      _PK_L_(0x62, 0x71)
#define REG_SC_BK62_71_H      _PK_H_(0x62, 0x71)
#define REG_SC_BK62_72_L      _PK_L_(0x62, 0x72)
#define REG_SC_BK62_72_H      _PK_H_(0x62, 0x72)
#define REG_SC_BK62_73_L      _PK_L_(0x62, 0x73)
#define REG_SC_BK62_73_H      _PK_H_(0x62, 0x73)
#define REG_SC_BK62_74_L      _PK_L_(0x62, 0x74)
#define REG_SC_BK62_74_H      _PK_H_(0x62, 0x74)
#define REG_SC_BK62_75_L      _PK_L_(0x62, 0x75)
#define REG_SC_BK62_75_H      _PK_H_(0x62, 0x75)
#define REG_SC_BK62_76_L      _PK_L_(0x62, 0x76)
#define REG_SC_BK62_76_H      _PK_H_(0x62, 0x76)
#define REG_SC_BK62_77_L      _PK_L_(0x62, 0x77)
#define REG_SC_BK62_77_H      _PK_H_(0x62, 0x77)
#define REG_SC_BK62_78_L      _PK_L_(0x62, 0x78)
#define REG_SC_BK62_78_H      _PK_H_(0x62, 0x78)
#define REG_SC_BK62_79_L      _PK_L_(0x62, 0x79)
#define REG_SC_BK62_79_H      _PK_H_(0x62, 0x79)
#define REG_SC_BK62_7A_L      _PK_L_(0x62, 0x7A)
#define REG_SC_BK62_7A_H      _PK_H_(0x62, 0x7A)
#define REG_SC_BK62_7B_L      _PK_L_(0x62, 0x7B)
#define REG_SC_BK62_7B_H      _PK_H_(0x62, 0x7B)
#define REG_SC_BK62_7C_L      _PK_L_(0x62, 0x7C)
#define REG_SC_BK62_7C_H      _PK_H_(0x62, 0x7C)
#define REG_SC_BK62_7D_L      _PK_L_(0x62, 0x7D)
#define REG_SC_BK62_7D_H      _PK_H_(0x62, 0x7D)
#define REG_SC_BK62_7E_L      _PK_L_(0x62, 0x7E)
#define REG_SC_BK62_7E_H      _PK_H_(0x62, 0x7E)
#define REG_SC_BK62_7F_L      _PK_L_(0x62, 0x7F)
#define REG_SC_BK62_7F_H      _PK_H_(0x62, 0x7F)

//----------------------------------------------
//  BK63: 2D TO 3D BLOCK
//----------------------------------------------
#define REG_SC_BK63_00_L      _PK_L_(0x63, 0x00)
#define REG_SC_BK63_00_H      _PK_H_(0x63, 0x00)
#define REG_SC_BK63_01_L      _PK_L_(0x63, 0x01)
#define REG_SC_BK63_01_H      _PK_H_(0x63, 0x01)
#define REG_SC_BK63_02_L      _PK_L_(0x63, 0x02)
#define REG_SC_BK63_02_H      _PK_H_(0x63, 0x02)
#define REG_SC_BK63_03_L      _PK_L_(0x63, 0x03)
#define REG_SC_BK63_03_H      _PK_H_(0x63, 0x03)
#define REG_SC_BK63_04_L      _PK_L_(0x63, 0x04)
#define REG_SC_BK63_04_H      _PK_H_(0x63, 0x04)
#define REG_SC_BK63_05_L      _PK_L_(0x63, 0x05)
#define REG_SC_BK63_05_H      _PK_H_(0x63, 0x05)
#define REG_SC_BK63_06_L      _PK_L_(0x63, 0x06)
#define REG_SC_BK63_06_H      _PK_H_(0x63, 0x06)
#define REG_SC_BK63_07_L      _PK_L_(0x63, 0x07)
#define REG_SC_BK63_07_H      _PK_H_(0x63, 0x07)
#define REG_SC_BK63_08_L      _PK_L_(0x63, 0x08)
#define REG_SC_BK63_08_H      _PK_H_(0x63, 0x08)
#define REG_SC_BK63_09_L      _PK_L_(0x63, 0x09)
#define REG_SC_BK63_09_H      _PK_H_(0x63, 0x09)
#define REG_SC_BK63_0A_L      _PK_L_(0x63, 0x0A)
#define REG_SC_BK63_0A_H      _PK_H_(0x63, 0x0A)
#define REG_SC_BK63_0B_L      _PK_L_(0x63, 0x0B)
#define REG_SC_BK63_0B_H      _PK_H_(0x63, 0x0B)
#define REG_SC_BK63_0C_L      _PK_L_(0x63, 0x0C)
#define REG_SC_BK63_0C_H      _PK_H_(0x63, 0x0C)
#define REG_SC_BK63_0D_L      _PK_L_(0x63, 0x0D)
#define REG_SC_BK63_0D_H      _PK_H_(0x63, 0x0D)
#define REG_SC_BK63_0E_L      _PK_L_(0x63, 0x0E)
#define REG_SC_BK63_0E_H      _PK_H_(0x63, 0x0E)
#define REG_SC_BK63_0F_L      _PK_L_(0x63, 0x0F)
#define REG_SC_BK63_0F_H      _PK_H_(0x63, 0x0F)
#define REG_SC_BK63_10_L      _PK_L_(0x63, 0x10)
#define REG_SC_BK63_10_H      _PK_H_(0x63, 0x10)
#define REG_SC_BK63_11_L      _PK_L_(0x63, 0x11)
#define REG_SC_BK63_11_H      _PK_H_(0x63, 0x11)
#define REG_SC_BK63_12_L      _PK_L_(0x63, 0x12)
#define REG_SC_BK63_12_H      _PK_H_(0x63, 0x12)
#define REG_SC_BK63_13_L      _PK_L_(0x63, 0x13)
#define REG_SC_BK63_13_H      _PK_H_(0x63, 0x13)
#define REG_SC_BK63_14_L      _PK_L_(0x63, 0x14)
#define REG_SC_BK63_14_H      _PK_H_(0x63, 0x14)
#define REG_SC_BK63_15_L      _PK_L_(0x63, 0x15)
#define REG_SC_BK63_15_H      _PK_H_(0x63, 0x15)
#define REG_SC_BK63_16_L      _PK_L_(0x63, 0x16)
#define REG_SC_BK63_16_H      _PK_H_(0x63, 0x16)
#define REG_SC_BK63_17_L      _PK_L_(0x63, 0x17)
#define REG_SC_BK63_17_H      _PK_H_(0x63, 0x17)
#define REG_SC_BK63_18_L      _PK_L_(0x63, 0x18)
#define REG_SC_BK63_18_H      _PK_H_(0x63, 0x18)
#define REG_SC_BK63_19_L      _PK_L_(0x63, 0x19)
#define REG_SC_BK63_19_H      _PK_H_(0x63, 0x19)
#define REG_SC_BK63_1A_L      _PK_L_(0x63, 0x1A)
#define REG_SC_BK63_1A_H      _PK_H_(0x63, 0x1A)
#define REG_SC_BK63_1B_L      _PK_L_(0x63, 0x1B)
#define REG_SC_BK63_1B_H      _PK_H_(0x63, 0x1B)
#define REG_SC_BK63_1C_L      _PK_L_(0x63, 0x1C)
#define REG_SC_BK63_1C_H      _PK_H_(0x63, 0x1C)
#define REG_SC_BK63_1D_L      _PK_L_(0x63, 0x1D)
#define REG_SC_BK63_1D_H      _PK_H_(0x63, 0x1D)
#define REG_SC_BK63_1E_L      _PK_L_(0x63, 0x1E)
#define REG_SC_BK63_1E_H      _PK_H_(0x63, 0x1E)
#define REG_SC_BK63_1F_L      _PK_L_(0x63, 0x1F)
#define REG_SC_BK63_1F_H      _PK_H_(0x63, 0x1F)
#define REG_SC_BK63_20_L      _PK_L_(0x63, 0x20)
#define REG_SC_BK63_20_H      _PK_H_(0x63, 0x20)
#define REG_SC_BK63_21_L      _PK_L_(0x63, 0x21)
#define REG_SC_BK63_21_H      _PK_H_(0x63, 0x21)
#define REG_SC_BK63_22_L      _PK_L_(0x63, 0x22)
#define REG_SC_BK63_22_H      _PK_H_(0x63, 0x22)
#define REG_SC_BK63_23_L      _PK_L_(0x63, 0x23)
#define REG_SC_BK63_23_H      _PK_H_(0x63, 0x23)
#define REG_SC_BK63_24_L      _PK_L_(0x63, 0x24)
#define REG_SC_BK63_24_H      _PK_H_(0x63, 0x24)
#define REG_SC_BK63_25_L      _PK_L_(0x63, 0x25)
#define REG_SC_BK63_25_H      _PK_H_(0x63, 0x25)
#define REG_SC_BK63_26_L      _PK_L_(0x63, 0x26)
#define REG_SC_BK63_26_H      _PK_H_(0x63, 0x26)
#define REG_SC_BK63_27_L      _PK_L_(0x63, 0x27)
#define REG_SC_BK63_27_H      _PK_H_(0x63, 0x27)
#define REG_SC_BK63_28_L      _PK_L_(0x63, 0x28)
#define REG_SC_BK63_28_H      _PK_H_(0x63, 0x28)
#define REG_SC_BK63_29_L      _PK_L_(0x63, 0x29)
#define REG_SC_BK63_29_H      _PK_H_(0x63, 0x29)
#define REG_SC_BK63_2A_L      _PK_L_(0x63, 0x2A)
#define REG_SC_BK63_2A_H      _PK_H_(0x63, 0x2A)
#define REG_SC_BK63_2B_L      _PK_L_(0x63, 0x2B)
#define REG_SC_BK63_2B_H      _PK_H_(0x63, 0x2B)
#define REG_SC_BK63_2C_L      _PK_L_(0x63, 0x2C)
#define REG_SC_BK63_2C_H      _PK_H_(0x63, 0x2C)
#define REG_SC_BK63_2D_L      _PK_L_(0x63, 0x2D)
#define REG_SC_BK63_2D_H      _PK_H_(0x63, 0x2D)
#define REG_SC_BK63_2E_L      _PK_L_(0x63, 0x2E)
#define REG_SC_BK63_2E_H      _PK_H_(0x63, 0x2E)
#define REG_SC_BK63_2F_L      _PK_L_(0x63, 0x2F)
#define REG_SC_BK63_2F_H      _PK_H_(0x63, 0x2F)
#define REG_SC_BK63_30_L      _PK_L_(0x63, 0x30)
#define REG_SC_BK63_30_H      _PK_H_(0x63, 0x30)
#define REG_SC_BK63_31_L      _PK_L_(0x63, 0x31)
#define REG_SC_BK63_31_H      _PK_H_(0x63, 0x31)
#define REG_SC_BK63_32_L      _PK_L_(0x63, 0x32)
#define REG_SC_BK63_32_H      _PK_H_(0x63, 0x32)
#define REG_SC_BK63_33_L      _PK_L_(0x63, 0x33)
#define REG_SC_BK63_33_H      _PK_H_(0x63, 0x33)
#define REG_SC_BK63_34_L      _PK_L_(0x63, 0x34)
#define REG_SC_BK63_34_H      _PK_H_(0x63, 0x34)
#define REG_SC_BK63_35_L      _PK_L_(0x63, 0x35)
#define REG_SC_BK63_35_H      _PK_H_(0x63, 0x35)
#define REG_SC_BK63_36_L      _PK_L_(0x63, 0x36)
#define REG_SC_BK63_36_H      _PK_H_(0x63, 0x36)
#define REG_SC_BK63_37_L      _PK_L_(0x63, 0x37)
#define REG_SC_BK63_37_H      _PK_H_(0x63, 0x37)
#define REG_SC_BK63_38_L      _PK_L_(0x63, 0x38)
#define REG_SC_BK63_38_H      _PK_H_(0x63, 0x38)
#define REG_SC_BK63_39_L      _PK_L_(0x63, 0x39)
#define REG_SC_BK63_39_H      _PK_H_(0x63, 0x39)
#define REG_SC_BK63_3A_L      _PK_L_(0x63, 0x3A)
#define REG_SC_BK63_3A_H      _PK_H_(0x63, 0x3A)
#define REG_SC_BK63_3B_L      _PK_L_(0x63, 0x3B)
#define REG_SC_BK63_3B_H      _PK_H_(0x63, 0x3B)
#define REG_SC_BK63_3C_L      _PK_L_(0x63, 0x3C)
#define REG_SC_BK63_3C_H      _PK_H_(0x63, 0x3C)
#define REG_SC_BK63_3D_L      _PK_L_(0x63, 0x3D)
#define REG_SC_BK63_3D_H      _PK_H_(0x63, 0x3D)
#define REG_SC_BK63_3E_L      _PK_L_(0x63, 0x3E)
#define REG_SC_BK63_3E_H      _PK_H_(0x63, 0x3E)
#define REG_SC_BK63_3F_L      _PK_L_(0x63, 0x3F)
#define REG_SC_BK63_3F_H      _PK_H_(0x63, 0x3F)
#define REG_SC_BK63_40_L      _PK_L_(0x63, 0x40)
#define REG_SC_BK63_40_H      _PK_H_(0x63, 0x40)
#define REG_SC_BK63_41_L      _PK_L_(0x63, 0x41)
#define REG_SC_BK63_41_H      _PK_H_(0x63, 0x41)
#define REG_SC_BK63_42_L      _PK_L_(0x63, 0x42)
#define REG_SC_BK63_42_H      _PK_H_(0x63, 0x42)
#define REG_SC_BK63_43_L      _PK_L_(0x63, 0x43)
#define REG_SC_BK63_43_H      _PK_H_(0x63, 0x43)
#define REG_SC_BK63_44_L      _PK_L_(0x63, 0x44)
#define REG_SC_BK63_44_H      _PK_H_(0x63, 0x44)
#define REG_SC_BK63_45_L      _PK_L_(0x63, 0x45)
#define REG_SC_BK63_45_H      _PK_H_(0x63, 0x45)
#define REG_SC_BK63_46_L      _PK_L_(0x63, 0x46)
#define REG_SC_BK63_46_H      _PK_H_(0x63, 0x46)
#define REG_SC_BK63_47_L      _PK_L_(0x63, 0x47)
#define REG_SC_BK63_47_H      _PK_H_(0x63, 0x47)
#define REG_SC_BK63_48_L      _PK_L_(0x63, 0x48)
#define REG_SC_BK63_48_H      _PK_H_(0x63, 0x48)
#define REG_SC_BK63_49_L      _PK_L_(0x63, 0x49)
#define REG_SC_BK63_49_H      _PK_H_(0x63, 0x49)
#define REG_SC_BK63_4A_L      _PK_L_(0x63, 0x4A)
#define REG_SC_BK63_4A_H      _PK_H_(0x63, 0x4A)
#define REG_SC_BK63_4B_L      _PK_L_(0x63, 0x4B)
#define REG_SC_BK63_4B_H      _PK_H_(0x63, 0x4B)
#define REG_SC_BK63_4C_L      _PK_L_(0x63, 0x4C)
#define REG_SC_BK63_4C_H      _PK_H_(0x63, 0x4C)
#define REG_SC_BK63_4D_L      _PK_L_(0x63, 0x4D)
#define REG_SC_BK63_4D_H      _PK_H_(0x63, 0x4D)
#define REG_SC_BK63_4E_L      _PK_L_(0x63, 0x4E)
#define REG_SC_BK63_4E_H      _PK_H_(0x63, 0x4E)
#define REG_SC_BK63_4F_L      _PK_L_(0x63, 0x4F)
#define REG_SC_BK63_4F_H      _PK_H_(0x63, 0x4F)
#define REG_SC_BK63_50_L      _PK_L_(0x63, 0x50)
#define REG_SC_BK63_50_H      _PK_H_(0x63, 0x50)
#define REG_SC_BK63_51_L      _PK_L_(0x63, 0x51)
#define REG_SC_BK63_51_H      _PK_H_(0x63, 0x51)
#define REG_SC_BK63_52_L      _PK_L_(0x63, 0x52)
#define REG_SC_BK63_52_H      _PK_H_(0x63, 0x52)
#define REG_SC_BK63_53_L      _PK_L_(0x63, 0x53)
#define REG_SC_BK63_53_H      _PK_H_(0x63, 0x53)
#define REG_SC_BK63_54_L      _PK_L_(0x63, 0x54)
#define REG_SC_BK63_54_H      _PK_H_(0x63, 0x54)
#define REG_SC_BK63_55_L      _PK_L_(0x63, 0x55)
#define REG_SC_BK63_55_H      _PK_H_(0x63, 0x55)
#define REG_SC_BK63_56_L      _PK_L_(0x63, 0x56)
#define REG_SC_BK63_56_H      _PK_H_(0x63, 0x56)
#define REG_SC_BK63_57_L      _PK_L_(0x63, 0x57)
#define REG_SC_BK63_57_H      _PK_H_(0x63, 0x57)
#define REG_SC_BK63_58_L      _PK_L_(0x63, 0x58)
#define REG_SC_BK63_58_H      _PK_H_(0x63, 0x58)
#define REG_SC_BK63_59_L      _PK_L_(0x63, 0x59)
#define REG_SC_BK63_59_H      _PK_H_(0x63, 0x59)
#define REG_SC_BK63_5A_L      _PK_L_(0x63, 0x5A)
#define REG_SC_BK63_5A_H      _PK_H_(0x63, 0x5A)
#define REG_SC_BK63_5B_L      _PK_L_(0x63, 0x5B)
#define REG_SC_BK63_5B_H      _PK_H_(0x63, 0x5B)
#define REG_SC_BK63_5C_L      _PK_L_(0x63, 0x5C)
#define REG_SC_BK63_5C_H      _PK_H_(0x63, 0x5C)
#define REG_SC_BK63_5D_L      _PK_L_(0x63, 0x5D)
#define REG_SC_BK63_5D_H      _PK_H_(0x63, 0x5D)
#define REG_SC_BK63_5E_L      _PK_L_(0x63, 0x5E)
#define REG_SC_BK63_5E_H      _PK_H_(0x63, 0x5E)
#define REG_SC_BK63_5F_L      _PK_L_(0x63, 0x5F)
#define REG_SC_BK63_5F_H      _PK_H_(0x63, 0x5F)
#define REG_SC_BK63_60_L      _PK_L_(0x63, 0x60)
#define REG_SC_BK63_60_H      _PK_H_(0x63, 0x60)
#define REG_SC_BK63_61_L      _PK_L_(0x63, 0x61)
#define REG_SC_BK63_61_H      _PK_H_(0x63, 0x61)
#define REG_SC_BK63_62_L      _PK_L_(0x63, 0x62)
#define REG_SC_BK63_62_H      _PK_H_(0x63, 0x62)
#define REG_SC_BK63_63_L      _PK_L_(0x63, 0x63)
#define REG_SC_BK63_63_H      _PK_H_(0x63, 0x63)
#define REG_SC_BK63_64_L      _PK_L_(0x63, 0x64)
#define REG_SC_BK63_64_H      _PK_H_(0x63, 0x64)
#define REG_SC_BK63_65_L      _PK_L_(0x63, 0x65)
#define REG_SC_BK63_65_H      _PK_H_(0x63, 0x65)
#define REG_SC_BK63_66_L      _PK_L_(0x63, 0x66)
#define REG_SC_BK63_66_H      _PK_H_(0x63, 0x66)
#define REG_SC_BK63_67_L      _PK_L_(0x63, 0x67)
#define REG_SC_BK63_67_H      _PK_H_(0x63, 0x67)
#define REG_SC_BK63_68_L      _PK_L_(0x63, 0x68)
#define REG_SC_BK63_68_H      _PK_H_(0x63, 0x68)
#define REG_SC_BK63_69_L      _PK_L_(0x63, 0x69)
#define REG_SC_BK63_69_H      _PK_H_(0x63, 0x69)
#define REG_SC_BK63_6A_L      _PK_L_(0x63, 0x6A)
#define REG_SC_BK63_6A_H      _PK_H_(0x63, 0x6A)
#define REG_SC_BK63_6B_L      _PK_L_(0x63, 0x6B)
#define REG_SC_BK63_6B_H      _PK_H_(0x63, 0x6B)
#define REG_SC_BK63_6C_L      _PK_L_(0x63, 0x6C)
#define REG_SC_BK63_6C_H      _PK_H_(0x63, 0x6C)
#define REG_SC_BK63_6D_L      _PK_L_(0x63, 0x6D)
#define REG_SC_BK63_6D_H      _PK_H_(0x63, 0x6D)
#define REG_SC_BK63_6E_L      _PK_L_(0x63, 0x6E)
#define REG_SC_BK63_6E_H      _PK_H_(0x63, 0x6E)
#define REG_SC_BK63_6F_L      _PK_L_(0x63, 0x6F)
#define REG_SC_BK63_6F_H      _PK_H_(0x63, 0x6F)
#define REG_SC_BK63_70_L      _PK_L_(0x63, 0x70)
#define REG_SC_BK63_70_H      _PK_H_(0x63, 0x70)
#define REG_SC_BK63_71_L      _PK_L_(0x63, 0x71)
#define REG_SC_BK63_71_H      _PK_H_(0x63, 0x71)
#define REG_SC_BK63_72_L      _PK_L_(0x63, 0x72)
#define REG_SC_BK63_72_H      _PK_H_(0x63, 0x72)
#define REG_SC_BK63_73_L      _PK_L_(0x63, 0x73)
#define REG_SC_BK63_73_H      _PK_H_(0x63, 0x73)
#define REG_SC_BK63_74_L      _PK_L_(0x63, 0x74)
#define REG_SC_BK63_74_H      _PK_H_(0x63, 0x74)
#define REG_SC_BK63_75_L      _PK_L_(0x63, 0x75)
#define REG_SC_BK63_75_H      _PK_H_(0x63, 0x75)
#define REG_SC_BK63_76_L      _PK_L_(0x63, 0x76)
#define REG_SC_BK63_76_H      _PK_H_(0x63, 0x76)
#define REG_SC_BK63_77_L      _PK_L_(0x63, 0x77)
#define REG_SC_BK63_77_H      _PK_H_(0x63, 0x77)
#define REG_SC_BK63_78_L      _PK_L_(0x63, 0x78)
#define REG_SC_BK63_78_H      _PK_H_(0x63, 0x78)
#define REG_SC_BK63_79_L      _PK_L_(0x63, 0x79)
#define REG_SC_BK63_79_H      _PK_H_(0x63, 0x79)
#define REG_SC_BK63_7A_L      _PK_L_(0x63, 0x7A)
#define REG_SC_BK63_7A_H      _PK_H_(0x63, 0x7A)
#define REG_SC_BK63_7B_L      _PK_L_(0x63, 0x7B)
#define REG_SC_BK63_7B_H      _PK_H_(0x63, 0x7B)
#define REG_SC_BK63_7C_L      _PK_L_(0x63, 0x7C)
#define REG_SC_BK63_7C_H      _PK_H_(0x63, 0x7C)
#define REG_SC_BK63_7D_L      _PK_L_(0x63, 0x7D)
#define REG_SC_BK63_7D_H      _PK_H_(0x63, 0x7D)
#define REG_SC_BK63_7E_L      _PK_L_(0x63, 0x7E)
#define REG_SC_BK63_7E_H      _PK_H_(0x63, 0x7E)
#define REG_SC_BK63_7F_L      _PK_L_(0x63, 0x7F)
#define REG_SC_BK63_7F_H      _PK_H_(0x63, 0x7F)


//----------------------------------------------
//  BK66:
//----------------------------------------------
#define REG_SC_BK66_00_L      _PK_L_(0x66, 0x00)
#define REG_SC_BK66_00_H      _PK_H_(0x66, 0x00)
#define REG_SC_BK66_01_L      _PK_L_(0x66, 0x01)
#define REG_SC_BK66_01_H      _PK_H_(0x66, 0x01)
#define REG_SC_BK66_02_L      _PK_L_(0x66, 0x02)
#define REG_SC_BK66_02_H      _PK_H_(0x66, 0x02)
#define REG_SC_BK66_03_L      _PK_L_(0x66, 0x03)
#define REG_SC_BK66_03_H      _PK_H_(0x66, 0x03)
#define REG_SC_BK66_04_L      _PK_L_(0x66, 0x04)
#define REG_SC_BK66_04_H      _PK_H_(0x66, 0x04)
#define REG_SC_BK66_05_L      _PK_L_(0x66, 0x05)
#define REG_SC_BK66_05_H      _PK_H_(0x66, 0x05)
#define REG_SC_BK66_06_L      _PK_L_(0x66, 0x06)
#define REG_SC_BK66_06_H      _PK_H_(0x66, 0x06)
#define REG_SC_BK66_07_L      _PK_L_(0x66, 0x07)
#define REG_SC_BK66_07_H      _PK_H_(0x66, 0x07)
#define REG_SC_BK66_08_L      _PK_L_(0x66, 0x08)
#define REG_SC_BK66_08_H      _PK_H_(0x66, 0x08)
#define REG_SC_BK66_09_L      _PK_L_(0x66, 0x09)
#define REG_SC_BK66_09_H      _PK_H_(0x66, 0x09)
#define REG_SC_BK66_0A_L      _PK_L_(0x66, 0x0A)
#define REG_SC_BK66_0A_H      _PK_H_(0x66, 0x0A)
#define REG_SC_BK66_0B_L      _PK_L_(0x66, 0x0B)
#define REG_SC_BK66_0B_H      _PK_H_(0x66, 0x0B)
#define REG_SC_BK66_0C_L      _PK_L_(0x66, 0x0C)
#define REG_SC_BK66_0C_H      _PK_H_(0x66, 0x0C)
#define REG_SC_BK66_0D_L      _PK_L_(0x66, 0x0D)
#define REG_SC_BK66_0D_H      _PK_H_(0x66, 0x0D)
#define REG_SC_BK66_0E_L      _PK_L_(0x66, 0x0E)
#define REG_SC_BK66_0E_H      _PK_H_(0x66, 0x0E)
#define REG_SC_BK66_0F_L      _PK_L_(0x66, 0x0F)
#define REG_SC_BK66_0F_H      _PK_H_(0x66, 0x0F)
#define REG_SC_BK66_10_L      _PK_L_(0x66, 0x10)
#define REG_SC_BK66_10_H      _PK_H_(0x66, 0x10)
#define REG_SC_BK66_11_L      _PK_L_(0x66, 0x11)
#define REG_SC_BK66_11_H      _PK_H_(0x66, 0x11)
#define REG_SC_BK66_12_L      _PK_L_(0x66, 0x12)
#define REG_SC_BK66_12_H      _PK_H_(0x66, 0x12)
#define REG_SC_BK66_13_L      _PK_L_(0x66, 0x13)
#define REG_SC_BK66_13_H      _PK_H_(0x66, 0x13)
#define REG_SC_BK66_14_L      _PK_L_(0x66, 0x14)
#define REG_SC_BK66_14_H      _PK_H_(0x66, 0x14)
#define REG_SC_BK66_15_L      _PK_L_(0x66, 0x15)
#define REG_SC_BK66_15_H      _PK_H_(0x66, 0x15)
#define REG_SC_BK66_16_L      _PK_L_(0x66, 0x16)
#define REG_SC_BK66_16_H      _PK_H_(0x66, 0x16)
#define REG_SC_BK66_17_L      _PK_L_(0x66, 0x17)
#define REG_SC_BK66_17_H      _PK_H_(0x66, 0x17)
#define REG_SC_BK66_18_L      _PK_L_(0x66, 0x18)
#define REG_SC_BK66_18_H      _PK_H_(0x66, 0x18)
#define REG_SC_BK66_19_L      _PK_L_(0x66, 0x19)
#define REG_SC_BK66_19_H      _PK_H_(0x66, 0x19)
#define REG_SC_BK66_1A_L      _PK_L_(0x66, 0x1A)
#define REG_SC_BK66_1A_H      _PK_H_(0x66, 0x1A)
#define REG_SC_BK66_1B_L      _PK_L_(0x66, 0x1B)
#define REG_SC_BK66_1B_H      _PK_H_(0x66, 0x1B)
#define REG_SC_BK66_1C_L      _PK_L_(0x66, 0x1C)
#define REG_SC_BK66_1C_H      _PK_H_(0x66, 0x1C)
#define REG_SC_BK66_1D_L      _PK_L_(0x66, 0x1D)
#define REG_SC_BK66_1D_H      _PK_H_(0x66, 0x1D)
#define REG_SC_BK66_1E_L      _PK_L_(0x66, 0x1E)
#define REG_SC_BK66_1E_H      _PK_H_(0x66, 0x1E)
#define REG_SC_BK66_1F_L      _PK_L_(0x66, 0x1F)
#define REG_SC_BK66_1F_H      _PK_H_(0x66, 0x1F)
#define REG_SC_BK66_20_L      _PK_L_(0x66, 0x20)
#define REG_SC_BK66_20_H      _PK_H_(0x66, 0x20)
#define REG_SC_BK66_21_L      _PK_L_(0x66, 0x21)
#define REG_SC_BK66_21_H      _PK_H_(0x66, 0x21)
#define REG_SC_BK66_22_L      _PK_L_(0x66, 0x22)
#define REG_SC_BK66_22_H      _PK_H_(0x66, 0x22)
#define REG_SC_BK66_23_L      _PK_L_(0x66, 0x23)
#define REG_SC_BK66_23_H      _PK_H_(0x66, 0x23)
#define REG_SC_BK66_24_L      _PK_L_(0x66, 0x24)
#define REG_SC_BK66_24_H      _PK_H_(0x66, 0x24)
#define REG_SC_BK66_25_L      _PK_L_(0x66, 0x25)
#define REG_SC_BK66_25_H      _PK_H_(0x66, 0x25)
#define REG_SC_BK66_26_L      _PK_L_(0x66, 0x26)
#define REG_SC_BK66_26_H      _PK_H_(0x66, 0x26)
#define REG_SC_BK66_27_L      _PK_L_(0x66, 0x27)
#define REG_SC_BK66_27_H      _PK_H_(0x66, 0x27)
#define REG_SC_BK66_28_L      _PK_L_(0x66, 0x28)
#define REG_SC_BK66_28_H      _PK_H_(0x66, 0x28)
#define REG_SC_BK66_29_L      _PK_L_(0x66, 0x29)
#define REG_SC_BK66_29_H      _PK_H_(0x66, 0x29)
#define REG_SC_BK66_2A_L      _PK_L_(0x66, 0x2A)
#define REG_SC_BK66_2A_H      _PK_H_(0x66, 0x2A)
#define REG_SC_BK66_2B_L      _PK_L_(0x66, 0x2B)
#define REG_SC_BK66_2B_H      _PK_H_(0x66, 0x2B)
#define REG_SC_BK66_2C_L      _PK_L_(0x66, 0x2C)
#define REG_SC_BK66_2C_H      _PK_H_(0x66, 0x2C)
#define REG_SC_BK66_2D_L      _PK_L_(0x66, 0x2D)
#define REG_SC_BK66_2D_H      _PK_H_(0x66, 0x2D)
#define REG_SC_BK66_2E_L      _PK_L_(0x66, 0x2E)
#define REG_SC_BK66_2E_H      _PK_H_(0x66, 0x2E)
#define REG_SC_BK66_2F_L      _PK_L_(0x66, 0x2F)
#define REG_SC_BK66_2F_H      _PK_H_(0x66, 0x2F)
#define REG_SC_BK66_30_L      _PK_L_(0x66, 0x30)
#define REG_SC_BK66_30_H      _PK_H_(0x66, 0x30)
#define REG_SC_BK66_31_L      _PK_L_(0x66, 0x31)
#define REG_SC_BK66_31_H      _PK_H_(0x66, 0x31)
#define REG_SC_BK66_32_L      _PK_L_(0x66, 0x32)
#define REG_SC_BK66_32_H      _PK_H_(0x66, 0x32)
#define REG_SC_BK66_33_L      _PK_L_(0x66, 0x33)
#define REG_SC_BK66_33_H      _PK_H_(0x66, 0x33)
#define REG_SC_BK66_34_L      _PK_L_(0x66, 0x34)
#define REG_SC_BK66_34_H      _PK_H_(0x66, 0x34)
#define REG_SC_BK66_35_L      _PK_L_(0x66, 0x35)
#define REG_SC_BK66_35_H      _PK_H_(0x66, 0x35)
#define REG_SC_BK66_36_L      _PK_L_(0x66, 0x36)
#define REG_SC_BK66_36_H      _PK_H_(0x66, 0x36)
#define REG_SC_BK66_37_L      _PK_L_(0x66, 0x37)
#define REG_SC_BK66_37_H      _PK_H_(0x66, 0x37)
#define REG_SC_BK66_38_L      _PK_L_(0x66, 0x38)
#define REG_SC_BK66_38_H      _PK_H_(0x66, 0x38)
#define REG_SC_BK66_39_L      _PK_L_(0x66, 0x39)
#define REG_SC_BK66_39_H      _PK_H_(0x66, 0x39)
#define REG_SC_BK66_3A_L      _PK_L_(0x66, 0x3A)
#define REG_SC_BK66_3A_H      _PK_H_(0x66, 0x3A)
#define REG_SC_BK66_3B_L      _PK_L_(0x66, 0x3B)
#define REG_SC_BK66_3B_H      _PK_H_(0x66, 0x3B)
#define REG_SC_BK66_3C_L      _PK_L_(0x66, 0x3C)
#define REG_SC_BK66_3C_H      _PK_H_(0x66, 0x3C)
#define REG_SC_BK66_3D_L      _PK_L_(0x66, 0x3D)
#define REG_SC_BK66_3D_H      _PK_H_(0x66, 0x3D)
#define REG_SC_BK66_3E_L      _PK_L_(0x66, 0x3E)
#define REG_SC_BK66_3E_H      _PK_H_(0x66, 0x3E)
#define REG_SC_BK66_3F_L      _PK_L_(0x66, 0x3F)
#define REG_SC_BK66_3F_H      _PK_H_(0x66, 0x3F)
#define REG_SC_BK66_40_L      _PK_L_(0x66, 0x40)
#define REG_SC_BK66_40_H      _PK_H_(0x66, 0x40)
#define REG_SC_BK66_41_L      _PK_L_(0x66, 0x41)
#define REG_SC_BK66_41_H      _PK_H_(0x66, 0x41)
#define REG_SC_BK66_42_L      _PK_L_(0x66, 0x42)
#define REG_SC_BK66_42_H      _PK_H_(0x66, 0x42)
#define REG_SC_BK66_43_L      _PK_L_(0x66, 0x43)
#define REG_SC_BK66_43_H      _PK_H_(0x66, 0x43)
#define REG_SC_BK66_44_L      _PK_L_(0x66, 0x44)
#define REG_SC_BK66_44_H      _PK_H_(0x66, 0x44)
#define REG_SC_BK66_45_L      _PK_L_(0x66, 0x45)
#define REG_SC_BK66_45_H      _PK_H_(0x66, 0x45)
#define REG_SC_BK66_46_L      _PK_L_(0x66, 0x46)
#define REG_SC_BK66_46_H      _PK_H_(0x66, 0x46)
#define REG_SC_BK66_47_L      _PK_L_(0x66, 0x47)
#define REG_SC_BK66_47_H      _PK_H_(0x66, 0x47)
#define REG_SC_BK66_48_L      _PK_L_(0x66, 0x48)
#define REG_SC_BK66_48_H      _PK_H_(0x66, 0x48)
#define REG_SC_BK66_49_L      _PK_L_(0x66, 0x49)
#define REG_SC_BK66_49_H      _PK_H_(0x66, 0x49)
#define REG_SC_BK66_4A_L      _PK_L_(0x66, 0x4A)
#define REG_SC_BK66_4A_H      _PK_H_(0x66, 0x4A)
#define REG_SC_BK66_4B_L      _PK_L_(0x66, 0x4B)
#define REG_SC_BK66_4B_H      _PK_H_(0x66, 0x4B)
#define REG_SC_BK66_4C_L      _PK_L_(0x66, 0x4C)
#define REG_SC_BK66_4C_H      _PK_H_(0x66, 0x4C)
#define REG_SC_BK66_4D_L      _PK_L_(0x66, 0x4D)
#define REG_SC_BK66_4D_H      _PK_H_(0x66, 0x4D)
#define REG_SC_BK66_4E_L      _PK_L_(0x66, 0x4E)
#define REG_SC_BK66_4E_H      _PK_H_(0x66, 0x4E)
#define REG_SC_BK66_4F_L      _PK_L_(0x66, 0x4F)
#define REG_SC_BK66_4F_H      _PK_H_(0x66, 0x4F)
#define REG_SC_BK66_50_L      _PK_L_(0x66, 0x50)
#define REG_SC_BK66_50_H      _PK_H_(0x66, 0x50)
#define REG_SC_BK66_51_L      _PK_L_(0x66, 0x51)
#define REG_SC_BK66_51_H      _PK_H_(0x66, 0x51)
#define REG_SC_BK66_52_L      _PK_L_(0x66, 0x52)
#define REG_SC_BK66_52_H      _PK_H_(0x66, 0x52)
#define REG_SC_BK66_53_L      _PK_L_(0x66, 0x53)
#define REG_SC_BK66_53_H      _PK_H_(0x66, 0x53)
#define REG_SC_BK66_54_L      _PK_L_(0x66, 0x54)
#define REG_SC_BK66_54_H      _PK_H_(0x66, 0x54)
#define REG_SC_BK66_55_L      _PK_L_(0x66, 0x55)
#define REG_SC_BK66_55_H      _PK_H_(0x66, 0x55)
#define REG_SC_BK66_56_L      _PK_L_(0x66, 0x56)
#define REG_SC_BK66_56_H      _PK_H_(0x66, 0x56)
#define REG_SC_BK66_57_L      _PK_L_(0x66, 0x57)
#define REG_SC_BK66_57_H      _PK_H_(0x66, 0x57)
#define REG_SC_BK66_58_L      _PK_L_(0x66, 0x58)
#define REG_SC_BK66_58_H      _PK_H_(0x66, 0x58)
#define REG_SC_BK66_59_L      _PK_L_(0x66, 0x59)
#define REG_SC_BK66_59_H      _PK_H_(0x66, 0x59)
#define REG_SC_BK66_5A_L      _PK_L_(0x66, 0x5A)
#define REG_SC_BK66_5A_H      _PK_H_(0x66, 0x5A)
#define REG_SC_BK66_5B_L      _PK_L_(0x66, 0x5B)
#define REG_SC_BK66_5B_H      _PK_H_(0x66, 0x5B)
#define REG_SC_BK66_5C_L      _PK_L_(0x66, 0x5C)
#define REG_SC_BK66_5C_H      _PK_H_(0x66, 0x5C)
#define REG_SC_BK66_5D_L      _PK_L_(0x66, 0x5D)
#define REG_SC_BK66_5D_H      _PK_H_(0x66, 0x5D)
#define REG_SC_BK66_5E_L      _PK_L_(0x66, 0x5E)
#define REG_SC_BK66_5E_H      _PK_H_(0x66, 0x5E)
#define REG_SC_BK66_5F_L      _PK_L_(0x66, 0x5F)
#define REG_SC_BK66_5F_H      _PK_H_(0x66, 0x5F)
#define REG_SC_BK66_60_L      _PK_L_(0x66, 0x60)
#define REG_SC_BK66_60_H      _PK_H_(0x66, 0x60)
#define REG_SC_BK66_61_L      _PK_L_(0x66, 0x61)
#define REG_SC_BK66_61_H      _PK_H_(0x66, 0x61)
#define REG_SC_BK66_62_L      _PK_L_(0x66, 0x62)
#define REG_SC_BK66_62_H      _PK_H_(0x66, 0x62)
#define REG_SC_BK66_63_L      _PK_L_(0x66, 0x63)
#define REG_SC_BK66_63_H      _PK_H_(0x66, 0x63)
#define REG_SC_BK66_64_L      _PK_L_(0x66, 0x64)
#define REG_SC_BK66_64_H      _PK_H_(0x66, 0x64)
#define REG_SC_BK66_65_L      _PK_L_(0x66, 0x65)
#define REG_SC_BK66_65_H      _PK_H_(0x66, 0x65)
#define REG_SC_BK66_66_L      _PK_L_(0x66, 0x66)
#define REG_SC_BK66_66_H      _PK_H_(0x66, 0x66)
#define REG_SC_BK66_67_L      _PK_L_(0x66, 0x67)
#define REG_SC_BK66_67_H      _PK_H_(0x66, 0x67)
#define REG_SC_BK66_68_L      _PK_L_(0x66, 0x68)
#define REG_SC_BK66_68_H      _PK_H_(0x66, 0x68)
#define REG_SC_BK66_69_L      _PK_L_(0x66, 0x69)
#define REG_SC_BK66_69_H      _PK_H_(0x66, 0x69)
#define REG_SC_BK66_6A_L      _PK_L_(0x66, 0x6A)
#define REG_SC_BK66_6A_H      _PK_H_(0x66, 0x6A)
#define REG_SC_BK66_6B_L      _PK_L_(0x66, 0x6B)
#define REG_SC_BK66_6B_H      _PK_H_(0x66, 0x6B)
#define REG_SC_BK66_6C_L      _PK_L_(0x66, 0x6C)
#define REG_SC_BK66_6C_H      _PK_H_(0x66, 0x6C)
#define REG_SC_BK66_6D_L      _PK_L_(0x66, 0x6D)
#define REG_SC_BK66_6D_H      _PK_H_(0x66, 0x6D)
#define REG_SC_BK66_6E_L      _PK_L_(0x66, 0x6E)
#define REG_SC_BK66_6E_H      _PK_H_(0x66, 0x6E)
#define REG_SC_BK66_6F_L      _PK_L_(0x66, 0x6F)
#define REG_SC_BK66_6F_H      _PK_H_(0x66, 0x6F)
#define REG_SC_BK66_70_L      _PK_L_(0x66, 0x70)
#define REG_SC_BK66_70_H      _PK_H_(0x66, 0x70)
#define REG_SC_BK66_71_L      _PK_L_(0x66, 0x71)
#define REG_SC_BK66_71_H      _PK_H_(0x66, 0x71)
#define REG_SC_BK66_72_L      _PK_L_(0x66, 0x72)
#define REG_SC_BK66_72_H      _PK_H_(0x66, 0x72)
#define REG_SC_BK66_73_L      _PK_L_(0x66, 0x73)
#define REG_SC_BK66_73_H      _PK_H_(0x66, 0x73)
#define REG_SC_BK66_74_L      _PK_L_(0x66, 0x74)
#define REG_SC_BK66_74_H      _PK_H_(0x66, 0x74)
#define REG_SC_BK66_75_L      _PK_L_(0x66, 0x75)
#define REG_SC_BK66_75_H      _PK_H_(0x66, 0x75)
#define REG_SC_BK66_76_L      _PK_L_(0x66, 0x76)
#define REG_SC_BK66_76_H      _PK_H_(0x66, 0x76)
#define REG_SC_BK66_77_L      _PK_L_(0x66, 0x77)
#define REG_SC_BK66_77_H      _PK_H_(0x66, 0x77)
#define REG_SC_BK66_78_L      _PK_L_(0x66, 0x78)
#define REG_SC_BK66_78_H      _PK_H_(0x66, 0x78)
#define REG_SC_BK66_79_L      _PK_L_(0x66, 0x79)
#define REG_SC_BK66_79_H      _PK_H_(0x66, 0x79)
#define REG_SC_BK66_7A_L      _PK_L_(0x66, 0x7A)
#define REG_SC_BK66_7A_H      _PK_H_(0x66, 0x7A)
#define REG_SC_BK66_7B_L      _PK_L_(0x66, 0x7B)
#define REG_SC_BK66_7B_H      _PK_H_(0x66, 0x7B)
#define REG_SC_BK66_7C_L      _PK_L_(0x66, 0x7C)
#define REG_SC_BK66_7C_H      _PK_H_(0x66, 0x7C)
#define REG_SC_BK66_7D_L      _PK_L_(0x66, 0x7D)
#define REG_SC_BK66_7D_H      _PK_H_(0x66, 0x7D)
#define REG_SC_BK66_7E_L      _PK_L_(0x66, 0x7E)
#define REG_SC_BK66_7E_H      _PK_H_(0x66, 0x7E)
#define REG_SC_BK66_7F_L      _PK_L_(0x66, 0x7F)
#define REG_SC_BK66_7F_H      _PK_H_(0x66, 0x7F)

//----------------------------------------------
//  BK67: auto download
//----------------------------------------------
#define REG_SC_BK67_00_L      _PK_L_(0x67, 0x00)
#define REG_SC_BK67_00_H      _PK_H_(0x67, 0x00)
#define REG_SC_BK67_01_L      _PK_L_(0x67, 0x01)
#define REG_SC_BK67_01_H      _PK_H_(0x67, 0x01)
#define REG_SC_BK67_02_L      _PK_L_(0x67, 0x02)
#define REG_SC_BK67_02_H      _PK_H_(0x67, 0x02)
#define REG_SC_BK67_03_L      _PK_L_(0x67, 0x03)
#define REG_SC_BK67_03_H      _PK_H_(0x67, 0x03)
#define REG_SC_BK67_04_L      _PK_L_(0x67, 0x04)
#define REG_SC_BK67_04_H      _PK_H_(0x67, 0x04)
#define REG_SC_BK67_05_L      _PK_L_(0x67, 0x05)
#define REG_SC_BK67_05_H      _PK_H_(0x67, 0x05)
#define REG_SC_BK67_06_L      _PK_L_(0x67, 0x06)
#define REG_SC_BK67_06_H      _PK_H_(0x67, 0x06)
#define REG_SC_BK67_07_L      _PK_L_(0x67, 0x07)
#define REG_SC_BK67_07_H      _PK_H_(0x67, 0x07)
#define REG_SC_BK67_08_L      _PK_L_(0x67, 0x08)
#define REG_SC_BK67_08_H      _PK_H_(0x67, 0x08)
#define REG_SC_BK67_09_L      _PK_L_(0x67, 0x09)
#define REG_SC_BK67_09_H      _PK_H_(0x67, 0x09)
#define REG_SC_BK67_0A_L      _PK_L_(0x67, 0x0A)
#define REG_SC_BK67_0A_H      _PK_H_(0x67, 0x0A)
#define REG_SC_BK67_0B_L      _PK_L_(0x67, 0x0B)
#define REG_SC_BK67_0B_H      _PK_H_(0x67, 0x0B)
#define REG_SC_BK67_0C_L      _PK_L_(0x67, 0x0C)
#define REG_SC_BK67_0C_H      _PK_H_(0x67, 0x0C)
#define REG_SC_BK67_0D_L      _PK_L_(0x67, 0x0D)
#define REG_SC_BK67_0D_H      _PK_H_(0x67, 0x0D)
#define REG_SC_BK67_0E_L      _PK_L_(0x67, 0x0E)
#define REG_SC_BK67_0E_H      _PK_H_(0x67, 0x0E)
#define REG_SC_BK67_0F_L      _PK_L_(0x67, 0x0F)
#define REG_SC_BK67_0F_H      _PK_H_(0x67, 0x0F)
#define REG_SC_BK67_10_L      _PK_L_(0x67, 0x10)
#define REG_SC_BK67_10_H      _PK_H_(0x67, 0x10)
#define REG_SC_BK67_11_L      _PK_L_(0x67, 0x11)
#define REG_SC_BK67_11_H      _PK_H_(0x67, 0x11)
#define REG_SC_BK67_12_L      _PK_L_(0x67, 0x12)
#define REG_SC_BK67_12_H      _PK_H_(0x67, 0x12)
#define REG_SC_BK67_13_L      _PK_L_(0x67, 0x13)
#define REG_SC_BK67_13_H      _PK_H_(0x67, 0x13)
#define REG_SC_BK67_14_L      _PK_L_(0x67, 0x14)
#define REG_SC_BK67_14_H      _PK_H_(0x67, 0x14)
#define REG_SC_BK67_15_L      _PK_L_(0x67, 0x15)
#define REG_SC_BK67_15_H      _PK_H_(0x67, 0x15)
#define REG_SC_BK67_16_L      _PK_L_(0x67, 0x16)
#define REG_SC_BK67_16_H      _PK_H_(0x67, 0x16)
#define REG_SC_BK67_17_L      _PK_L_(0x67, 0x17)
#define REG_SC_BK67_17_H      _PK_H_(0x67, 0x17)
#define REG_SC_BK67_18_L      _PK_L_(0x67, 0x18)
#define REG_SC_BK67_18_H      _PK_H_(0x67, 0x18)
#define REG_SC_BK67_19_L      _PK_L_(0x67, 0x19)
#define REG_SC_BK67_19_H      _PK_H_(0x67, 0x19)
#define REG_SC_BK67_1A_L      _PK_L_(0x67, 0x1A)
#define REG_SC_BK67_1A_H      _PK_H_(0x67, 0x1A)
#define REG_SC_BK67_1B_L      _PK_L_(0x67, 0x1B)
#define REG_SC_BK67_1B_H      _PK_H_(0x67, 0x1B)
#define REG_SC_BK67_1C_L      _PK_L_(0x67, 0x1C)
#define REG_SC_BK67_1C_H      _PK_H_(0x67, 0x1C)
#define REG_SC_BK67_1D_L      _PK_L_(0x67, 0x1D)
#define REG_SC_BK67_1D_H      _PK_H_(0x67, 0x1D)
#define REG_SC_BK67_1E_L      _PK_L_(0x67, 0x1E)
#define REG_SC_BK67_1E_H      _PK_H_(0x67, 0x1E)
#define REG_SC_BK67_1F_L      _PK_L_(0x67, 0x1F)
#define REG_SC_BK67_1F_H      _PK_H_(0x67, 0x1F)
#define REG_SC_BK67_20_L      _PK_L_(0x67, 0x20)
#define REG_SC_BK67_20_H      _PK_H_(0x67, 0x20)
#define REG_SC_BK67_21_L      _PK_L_(0x67, 0x21)
#define REG_SC_BK67_21_H      _PK_H_(0x67, 0x21)
#define REG_SC_BK67_22_L      _PK_L_(0x67, 0x22)
#define REG_SC_BK67_22_H      _PK_H_(0x67, 0x22)
#define REG_SC_BK67_23_L      _PK_L_(0x67, 0x23)
#define REG_SC_BK67_23_H      _PK_H_(0x67, 0x23)
#define REG_SC_BK67_24_L      _PK_L_(0x67, 0x24)
#define REG_SC_BK67_24_H      _PK_H_(0x67, 0x24)
#define REG_SC_BK67_25_L      _PK_L_(0x67, 0x25)
#define REG_SC_BK67_25_H      _PK_H_(0x67, 0x25)
#define REG_SC_BK67_26_L      _PK_L_(0x67, 0x26)
#define REG_SC_BK67_26_H      _PK_H_(0x67, 0x26)
#define REG_SC_BK67_27_L      _PK_L_(0x67, 0x27)
#define REG_SC_BK67_27_H      _PK_H_(0x67, 0x27)
#define REG_SC_BK67_28_L      _PK_L_(0x67, 0x28)
#define REG_SC_BK67_28_H      _PK_H_(0x67, 0x28)
#define REG_SC_BK67_29_L      _PK_L_(0x67, 0x29)
#define REG_SC_BK67_29_H      _PK_H_(0x67, 0x29)
#define REG_SC_BK67_2A_L      _PK_L_(0x67, 0x2A)
#define REG_SC_BK67_2A_H      _PK_H_(0x67, 0x2A)
#define REG_SC_BK67_2B_L      _PK_L_(0x67, 0x2B)
#define REG_SC_BK67_2B_H      _PK_H_(0x67, 0x2B)
#define REG_SC_BK67_2C_L      _PK_L_(0x67, 0x2C)
#define REG_SC_BK67_2C_H      _PK_H_(0x67, 0x2C)
#define REG_SC_BK67_2D_L      _PK_L_(0x67, 0x2D)
#define REG_SC_BK67_2D_H      _PK_H_(0x67, 0x2D)
#define REG_SC_BK67_2E_L      _PK_L_(0x67, 0x2E)
#define REG_SC_BK67_2E_H      _PK_H_(0x67, 0x2E)
#define REG_SC_BK67_2F_L      _PK_L_(0x67, 0x2F)
#define REG_SC_BK67_2F_H      _PK_H_(0x67, 0x2F)
#define REG_SC_BK67_30_L      _PK_L_(0x67, 0x30)
#define REG_SC_BK67_30_H      _PK_H_(0x67, 0x30)
#define REG_SC_BK67_31_L      _PK_L_(0x67, 0x31)
#define REG_SC_BK67_31_H      _PK_H_(0x67, 0x31)
#define REG_SC_BK67_32_L      _PK_L_(0x67, 0x32)
#define REG_SC_BK67_32_H      _PK_H_(0x67, 0x32)
#define REG_SC_BK67_33_L      _PK_L_(0x67, 0x33)
#define REG_SC_BK67_33_H      _PK_H_(0x67, 0x33)
#define REG_SC_BK67_34_L      _PK_L_(0x67, 0x34)
#define REG_SC_BK67_34_H      _PK_H_(0x67, 0x34)
#define REG_SC_BK67_35_L      _PK_L_(0x67, 0x35)
#define REG_SC_BK67_35_H      _PK_H_(0x67, 0x35)
#define REG_SC_BK67_36_L      _PK_L_(0x67, 0x36)
#define REG_SC_BK67_36_H      _PK_H_(0x67, 0x36)
#define REG_SC_BK67_37_L      _PK_L_(0x67, 0x37)
#define REG_SC_BK67_37_H      _PK_H_(0x67, 0x37)
#define REG_SC_BK67_38_L      _PK_L_(0x67, 0x38)
#define REG_SC_BK67_38_H      _PK_H_(0x67, 0x38)
#define REG_SC_BK67_39_L      _PK_L_(0x67, 0x39)
#define REG_SC_BK67_39_H      _PK_H_(0x67, 0x39)
#define REG_SC_BK67_3A_L      _PK_L_(0x67, 0x3A)
#define REG_SC_BK67_3A_H      _PK_H_(0x67, 0x3A)
#define REG_SC_BK67_3B_L      _PK_L_(0x67, 0x3B)
#define REG_SC_BK67_3B_H      _PK_H_(0x67, 0x3B)
#define REG_SC_BK67_3C_L      _PK_L_(0x67, 0x3C)
#define REG_SC_BK67_3C_H      _PK_H_(0x67, 0x3C)
#define REG_SC_BK67_3D_L      _PK_L_(0x67, 0x3D)
#define REG_SC_BK67_3D_H      _PK_H_(0x67, 0x3D)
#define REG_SC_BK67_3E_L      _PK_L_(0x67, 0x3E)
#define REG_SC_BK67_3E_H      _PK_H_(0x67, 0x3E)
#define REG_SC_BK67_3F_L      _PK_L_(0x67, 0x3F)
#define REG_SC_BK67_3F_H      _PK_H_(0x67, 0x3F)
#define REG_SC_BK67_40_L      _PK_L_(0x67, 0x40)
#define REG_SC_BK67_40_H      _PK_H_(0x67, 0x40)
#define REG_SC_BK67_41_L      _PK_L_(0x67, 0x41)
#define REG_SC_BK67_41_H      _PK_H_(0x67, 0x41)
#define REG_SC_BK67_42_L      _PK_L_(0x67, 0x42)
#define REG_SC_BK67_42_H      _PK_H_(0x67, 0x42)
#define REG_SC_BK67_43_L      _PK_L_(0x67, 0x43)
#define REG_SC_BK67_43_H      _PK_H_(0x67, 0x43)
#define REG_SC_BK67_44_L      _PK_L_(0x67, 0x44)
#define REG_SC_BK67_44_H      _PK_H_(0x67, 0x44)
#define REG_SC_BK67_45_L      _PK_L_(0x67, 0x45)
#define REG_SC_BK67_45_H      _PK_H_(0x67, 0x45)
#define REG_SC_BK67_46_L      _PK_L_(0x67, 0x46)
#define REG_SC_BK67_46_H      _PK_H_(0x67, 0x46)
#define REG_SC_BK67_47_L      _PK_L_(0x67, 0x47)
#define REG_SC_BK67_47_H      _PK_H_(0x67, 0x47)
#define REG_SC_BK67_48_L      _PK_L_(0x67, 0x48)
#define REG_SC_BK67_48_H      _PK_H_(0x67, 0x48)
#define REG_SC_BK67_49_L      _PK_L_(0x67, 0x49)
#define REG_SC_BK67_49_H      _PK_H_(0x67, 0x49)
#define REG_SC_BK67_4A_L      _PK_L_(0x67, 0x4A)
#define REG_SC_BK67_4A_H      _PK_H_(0x67, 0x4A)
#define REG_SC_BK67_4B_L      _PK_L_(0x67, 0x4B)
#define REG_SC_BK67_4B_H      _PK_H_(0x67, 0x4B)
#define REG_SC_BK67_4C_L      _PK_L_(0x67, 0x4C)
#define REG_SC_BK67_4C_H      _PK_H_(0x67, 0x4C)
#define REG_SC_BK67_4D_L      _PK_L_(0x67, 0x4D)
#define REG_SC_BK67_4D_H      _PK_H_(0x67, 0x4D)
#define REG_SC_BK67_4E_L      _PK_L_(0x67, 0x4E)
#define REG_SC_BK67_4E_H      _PK_H_(0x67, 0x4E)
#define REG_SC_BK67_4F_L      _PK_L_(0x67, 0x4F)
#define REG_SC_BK67_4F_H      _PK_H_(0x67, 0x4F)
#define REG_SC_BK67_50_L      _PK_L_(0x67, 0x50)
#define REG_SC_BK67_50_H      _PK_H_(0x67, 0x50)
#define REG_SC_BK67_51_L      _PK_L_(0x67, 0x51)
#define REG_SC_BK67_51_H      _PK_H_(0x67, 0x51)
#define REG_SC_BK67_52_L      _PK_L_(0x67, 0x52)
#define REG_SC_BK67_52_H      _PK_H_(0x67, 0x52)
#define REG_SC_BK67_53_L      _PK_L_(0x67, 0x53)
#define REG_SC_BK67_53_H      _PK_H_(0x67, 0x53)
#define REG_SC_BK67_54_L      _PK_L_(0x67, 0x54)
#define REG_SC_BK67_54_H      _PK_H_(0x67, 0x54)
#define REG_SC_BK67_55_L      _PK_L_(0x67, 0x55)
#define REG_SC_BK67_55_H      _PK_H_(0x67, 0x55)
#define REG_SC_BK67_56_L      _PK_L_(0x67, 0x56)
#define REG_SC_BK67_56_H      _PK_H_(0x67, 0x56)
#define REG_SC_BK67_57_L      _PK_L_(0x67, 0x57)
#define REG_SC_BK67_57_H      _PK_H_(0x67, 0x57)
#define REG_SC_BK67_58_L      _PK_L_(0x67, 0x58)
#define REG_SC_BK67_58_H      _PK_H_(0x67, 0x58)
#define REG_SC_BK67_59_L      _PK_L_(0x67, 0x59)
#define REG_SC_BK67_59_H      _PK_H_(0x67, 0x59)
#define REG_SC_BK67_5A_L      _PK_L_(0x67, 0x5A)
#define REG_SC_BK67_5A_H      _PK_H_(0x67, 0x5A)
#define REG_SC_BK67_5B_L      _PK_L_(0x67, 0x5B)
#define REG_SC_BK67_5B_H      _PK_H_(0x67, 0x5B)
#define REG_SC_BK67_5C_L      _PK_L_(0x67, 0x5C)
#define REG_SC_BK67_5C_H      _PK_H_(0x67, 0x5C)
#define REG_SC_BK67_5D_L      _PK_L_(0x67, 0x5D)
#define REG_SC_BK67_5D_H      _PK_H_(0x67, 0x5D)
#define REG_SC_BK67_5E_L      _PK_L_(0x67, 0x5E)
#define REG_SC_BK67_5E_H      _PK_H_(0x67, 0x5E)
#define REG_SC_BK67_5F_L      _PK_L_(0x67, 0x5F)
#define REG_SC_BK67_5F_H      _PK_H_(0x67, 0x5F)
#define REG_SC_BK67_60_L      _PK_L_(0x67, 0x60)
#define REG_SC_BK67_60_H      _PK_H_(0x67, 0x60)
#define REG_SC_BK67_61_L      _PK_L_(0x67, 0x61)
#define REG_SC_BK67_61_H      _PK_H_(0x67, 0x61)
#define REG_SC_BK67_62_L      _PK_L_(0x67, 0x62)
#define REG_SC_BK67_62_H      _PK_H_(0x67, 0x62)
#define REG_SC_BK67_63_L      _PK_L_(0x67, 0x63)
#define REG_SC_BK67_63_H      _PK_H_(0x67, 0x63)
#define REG_SC_BK67_64_L      _PK_L_(0x67, 0x64)
#define REG_SC_BK67_64_H      _PK_H_(0x67, 0x64)
#define REG_SC_BK67_65_L      _PK_L_(0x67, 0x65)
#define REG_SC_BK67_65_H      _PK_H_(0x67, 0x65)
#define REG_SC_BK67_66_L      _PK_L_(0x67, 0x66)
#define REG_SC_BK67_66_H      _PK_H_(0x67, 0x66)
#define REG_SC_BK67_67_L      _PK_L_(0x67, 0x67)
#define REG_SC_BK67_67_H      _PK_H_(0x67, 0x67)
#define REG_SC_BK67_68_L      _PK_L_(0x67, 0x68)
#define REG_SC_BK67_68_H      _PK_H_(0x67, 0x68)
#define REG_SC_BK67_69_L      _PK_L_(0x67, 0x69)
#define REG_SC_BK67_69_H      _PK_H_(0x67, 0x69)
#define REG_SC_BK67_6A_L      _PK_L_(0x67, 0x6A)
#define REG_SC_BK67_6A_H      _PK_H_(0x67, 0x6A)
#define REG_SC_BK67_6B_L      _PK_L_(0x67, 0x6B)
#define REG_SC_BK67_6B_H      _PK_H_(0x67, 0x6B)
#define REG_SC_BK67_6C_L      _PK_L_(0x67, 0x6C)
#define REG_SC_BK67_6C_H      _PK_H_(0x67, 0x6C)
#define REG_SC_BK67_6D_L      _PK_L_(0x67, 0x6D)
#define REG_SC_BK67_6D_H      _PK_H_(0x67, 0x6D)
#define REG_SC_BK67_6E_L      _PK_L_(0x67, 0x6E)
#define REG_SC_BK67_6E_H      _PK_H_(0x67, 0x6E)
#define REG_SC_BK67_6F_L      _PK_L_(0x67, 0x6F)
#define REG_SC_BK67_6F_H      _PK_H_(0x67, 0x6F)
#define REG_SC_BK67_70_L      _PK_L_(0x67, 0x70)
#define REG_SC_BK67_70_H      _PK_H_(0x67, 0x70)
#define REG_SC_BK67_71_L      _PK_L_(0x67, 0x71)
#define REG_SC_BK67_71_H      _PK_H_(0x67, 0x71)
#define REG_SC_BK67_72_L      _PK_L_(0x67, 0x72)
#define REG_SC_BK67_72_H      _PK_H_(0x67, 0x72)
#define REG_SC_BK67_73_L      _PK_L_(0x67, 0x73)
#define REG_SC_BK67_73_H      _PK_H_(0x67, 0x73)
#define REG_SC_BK67_74_L      _PK_L_(0x67, 0x74)
#define REG_SC_BK67_74_H      _PK_H_(0x67, 0x74)
#define REG_SC_BK67_75_L      _PK_L_(0x67, 0x75)
#define REG_SC_BK67_75_H      _PK_H_(0x67, 0x75)
#define REG_SC_BK67_76_L      _PK_L_(0x67, 0x76)
#define REG_SC_BK67_76_H      _PK_H_(0x67, 0x76)
#define REG_SC_BK67_77_L      _PK_L_(0x67, 0x77)
#define REG_SC_BK67_77_H      _PK_H_(0x67, 0x77)
#define REG_SC_BK67_78_L      _PK_L_(0x67, 0x78)
#define REG_SC_BK67_78_H      _PK_H_(0x67, 0x78)
#define REG_SC_BK67_79_L      _PK_L_(0x67, 0x79)
#define REG_SC_BK67_79_H      _PK_H_(0x67, 0x79)
#define REG_SC_BK67_7A_L      _PK_L_(0x67, 0x7A)
#define REG_SC_BK67_7A_H      _PK_H_(0x67, 0x7A)
#define REG_SC_BK67_7B_L      _PK_L_(0x67, 0x7B)
#define REG_SC_BK67_7B_H      _PK_H_(0x67, 0x7B)
#define REG_SC_BK67_7C_L      _PK_L_(0x67, 0x7C)
#define REG_SC_BK67_7C_H      _PK_H_(0x67, 0x7C)
#define REG_SC_BK67_7D_L      _PK_L_(0x67, 0x7D)
#define REG_SC_BK67_7D_H      _PK_H_(0x67, 0x7D)
#define REG_SC_BK67_7E_L      _PK_L_(0x67, 0x7E)
#define REG_SC_BK67_7E_H      _PK_H_(0x67, 0x7E)
#define REG_SC_BK67_7F_L      _PK_L_(0x67, 0x7F)
#define REG_SC_BK67_7F_H      _PK_H_(0x67, 0x7F)

//----------------------------------------------
//  BK68: Simple TGEN
//----------------------------------------------
#define REG_SC_BK68_00_L      _PK_L_(0x68, 0x00)
#define REG_SC_BK68_00_H      _PK_H_(0x68, 0x00)
#define REG_SC_BK68_01_L      _PK_L_(0x68, 0x01)
#define REG_SC_BK68_01_H      _PK_H_(0x68, 0x01)
#define REG_SC_BK68_02_L      _PK_L_(0x68, 0x02)
#define REG_SC_BK68_02_H      _PK_H_(0x68, 0x02)
#define REG_SC_BK68_03_L      _PK_L_(0x68, 0x03)
#define REG_SC_BK68_03_H      _PK_H_(0x68, 0x03)
#define REG_SC_BK68_04_L      _PK_L_(0x68, 0x04)
#define REG_SC_BK68_04_H      _PK_H_(0x68, 0x04)
#define REG_SC_BK68_05_L      _PK_L_(0x68, 0x05)
#define REG_SC_BK68_05_H      _PK_H_(0x68, 0x05)
#define REG_SC_BK68_06_L      _PK_L_(0x68, 0x06)
#define REG_SC_BK68_06_H      _PK_H_(0x68, 0x06)
#define REG_SC_BK68_07_L      _PK_L_(0x68, 0x07)
#define REG_SC_BK68_07_H      _PK_H_(0x68, 0x07)
#define REG_SC_BK68_08_L      _PK_L_(0x68, 0x08)
#define REG_SC_BK68_08_H      _PK_H_(0x68, 0x08)
#define REG_SC_BK68_09_L      _PK_L_(0x68, 0x09)
#define REG_SC_BK68_09_H      _PK_H_(0x68, 0x09)
#define REG_SC_BK68_0A_L      _PK_L_(0x68, 0x0A)
#define REG_SC_BK68_0A_H      _PK_H_(0x68, 0x0A)
#define REG_SC_BK68_0B_L      _PK_L_(0x68, 0x0B)
#define REG_SC_BK68_0B_H      _PK_H_(0x68, 0x0B)
#define REG_SC_BK68_0C_L      _PK_L_(0x68, 0x0C)
#define REG_SC_BK68_0C_H      _PK_H_(0x68, 0x0C)
#define REG_SC_BK68_0D_L      _PK_L_(0x68, 0x0D)
#define REG_SC_BK68_0D_H      _PK_H_(0x68, 0x0D)
#define REG_SC_BK68_0E_L      _PK_L_(0x68, 0x0E)
#define REG_SC_BK68_0E_H      _PK_H_(0x68, 0x0E)
#define REG_SC_BK68_0F_L      _PK_L_(0x68, 0x0F)
#define REG_SC_BK68_0F_H      _PK_H_(0x68, 0x0F)
#define REG_SC_BK68_10_L      _PK_L_(0x68, 0x10)
#define REG_SC_BK68_10_H      _PK_H_(0x68, 0x10)
#define REG_SC_BK68_11_L      _PK_L_(0x68, 0x11)
#define REG_SC_BK68_11_H      _PK_H_(0x68, 0x11)
#define REG_SC_BK68_12_L      _PK_L_(0x68, 0x12)
#define REG_SC_BK68_12_H      _PK_H_(0x68, 0x12)
#define REG_SC_BK68_13_L      _PK_L_(0x68, 0x13)
#define REG_SC_BK68_13_H      _PK_H_(0x68, 0x13)
#define REG_SC_BK68_14_L      _PK_L_(0x68, 0x14)
#define REG_SC_BK68_14_H      _PK_H_(0x68, 0x14)
#define REG_SC_BK68_15_L      _PK_L_(0x68, 0x15)
#define REG_SC_BK68_15_H      _PK_H_(0x68, 0x15)
#define REG_SC_BK68_16_L      _PK_L_(0x68, 0x16)
#define REG_SC_BK68_16_H      _PK_H_(0x68, 0x16)
#define REG_SC_BK68_17_L      _PK_L_(0x68, 0x17)
#define REG_SC_BK68_17_H      _PK_H_(0x68, 0x17)
#define REG_SC_BK68_18_L      _PK_L_(0x68, 0x18)
#define REG_SC_BK68_18_H      _PK_H_(0x68, 0x18)
#define REG_SC_BK68_19_L      _PK_L_(0x68, 0x19)
#define REG_SC_BK68_19_H      _PK_H_(0x68, 0x19)
#define REG_SC_BK68_1A_L      _PK_L_(0x68, 0x1A)
#define REG_SC_BK68_1A_H      _PK_H_(0x68, 0x1A)
#define REG_SC_BK68_1B_L      _PK_L_(0x68, 0x1B)
#define REG_SC_BK68_1B_H      _PK_H_(0x68, 0x1B)
#define REG_SC_BK68_1C_L      _PK_L_(0x68, 0x1C)
#define REG_SC_BK68_1C_H      _PK_H_(0x68, 0x1C)
#define REG_SC_BK68_1D_L      _PK_L_(0x68, 0x1D)
#define REG_SC_BK68_1D_H      _PK_H_(0x68, 0x1D)
#define REG_SC_BK68_1E_L      _PK_L_(0x68, 0x1E)
#define REG_SC_BK68_1E_H      _PK_H_(0x68, 0x1E)
#define REG_SC_BK68_1F_L      _PK_L_(0x68, 0x1F)
#define REG_SC_BK68_1F_H      _PK_H_(0x68, 0x1F)
#define REG_SC_BK68_20_L      _PK_L_(0x68, 0x20)
#define REG_SC_BK68_20_H      _PK_H_(0x68, 0x20)
#define REG_SC_BK68_21_L      _PK_L_(0x68, 0x21)
#define REG_SC_BK68_21_H      _PK_H_(0x68, 0x21)
#define REG_SC_BK68_22_L      _PK_L_(0x68, 0x22)
#define REG_SC_BK68_22_H      _PK_H_(0x68, 0x22)
#define REG_SC_BK68_23_L      _PK_L_(0x68, 0x23)
#define REG_SC_BK68_23_H      _PK_H_(0x68, 0x23)
#define REG_SC_BK68_24_L      _PK_L_(0x68, 0x24)
#define REG_SC_BK68_24_H      _PK_H_(0x68, 0x24)
#define REG_SC_BK68_25_L      _PK_L_(0x68, 0x25)
#define REG_SC_BK68_25_H      _PK_H_(0x68, 0x25)
#define REG_SC_BK68_26_L      _PK_L_(0x68, 0x26)
#define REG_SC_BK68_26_H      _PK_H_(0x68, 0x26)
#define REG_SC_BK68_27_L      _PK_L_(0x68, 0x27)
#define REG_SC_BK68_27_H      _PK_H_(0x68, 0x27)
#define REG_SC_BK68_28_L      _PK_L_(0x68, 0x28)
#define REG_SC_BK68_28_H      _PK_H_(0x68, 0x28)
#define REG_SC_BK68_29_L      _PK_L_(0x68, 0x29)
#define REG_SC_BK68_29_H      _PK_H_(0x68, 0x29)
#define REG_SC_BK68_2A_L      _PK_L_(0x68, 0x2A)
#define REG_SC_BK68_2A_H      _PK_H_(0x68, 0x2A)
#define REG_SC_BK68_2B_L      _PK_L_(0x68, 0x2B)
#define REG_SC_BK68_2B_H      _PK_H_(0x68, 0x2B)
#define REG_SC_BK68_2C_L      _PK_L_(0x68, 0x2C)
#define REG_SC_BK68_2C_H      _PK_H_(0x68, 0x2C)
#define REG_SC_BK68_2D_L      _PK_L_(0x68, 0x2D)
#define REG_SC_BK68_2D_H      _PK_H_(0x68, 0x2D)
#define REG_SC_BK68_2E_L      _PK_L_(0x68, 0x2E)
#define REG_SC_BK68_2E_H      _PK_H_(0x68, 0x2E)
#define REG_SC_BK68_2F_L      _PK_L_(0x68, 0x2F)
#define REG_SC_BK68_2F_H      _PK_H_(0x68, 0x2F)
#define REG_SC_BK68_30_L      _PK_L_(0x68, 0x30)
#define REG_SC_BK68_30_H      _PK_H_(0x68, 0x30)
#define REG_SC_BK68_31_L      _PK_L_(0x68, 0x31)
#define REG_SC_BK68_31_H      _PK_H_(0x68, 0x31)
#define REG_SC_BK68_32_L      _PK_L_(0x68, 0x32)
#define REG_SC_BK68_32_H      _PK_H_(0x68, 0x32)
#define REG_SC_BK68_33_L      _PK_L_(0x68, 0x33)
#define REG_SC_BK68_33_H      _PK_H_(0x68, 0x33)
#define REG_SC_BK68_34_L      _PK_L_(0x68, 0x34)
#define REG_SC_BK68_34_H      _PK_H_(0x68, 0x34)
#define REG_SC_BK68_35_L      _PK_L_(0x68, 0x35)
#define REG_SC_BK68_35_H      _PK_H_(0x68, 0x35)
#define REG_SC_BK68_36_L      _PK_L_(0x68, 0x36)
#define REG_SC_BK68_36_H      _PK_H_(0x68, 0x36)
#define REG_SC_BK68_37_L      _PK_L_(0x68, 0x37)
#define REG_SC_BK68_37_H      _PK_H_(0x68, 0x37)
#define REG_SC_BK68_38_L      _PK_L_(0x68, 0x38)
#define REG_SC_BK68_38_H      _PK_H_(0x68, 0x38)
#define REG_SC_BK68_39_L      _PK_L_(0x68, 0x39)
#define REG_SC_BK68_39_H      _PK_H_(0x68, 0x39)
#define REG_SC_BK68_3A_L      _PK_L_(0x68, 0x3A)
#define REG_SC_BK68_3A_H      _PK_H_(0x68, 0x3A)
#define REG_SC_BK68_3B_L      _PK_L_(0x68, 0x3B)
#define REG_SC_BK68_3B_H      _PK_H_(0x68, 0x3B)
#define REG_SC_BK68_3C_L      _PK_L_(0x68, 0x3C)
#define REG_SC_BK68_3C_H      _PK_H_(0x68, 0x3C)
#define REG_SC_BK68_3D_L      _PK_L_(0x68, 0x3D)
#define REG_SC_BK68_3D_H      _PK_H_(0x68, 0x3D)
#define REG_SC_BK68_3E_L      _PK_L_(0x68, 0x3E)
#define REG_SC_BK68_3E_H      _PK_H_(0x68, 0x3E)
#define REG_SC_BK68_3F_L      _PK_L_(0x68, 0x3F)
#define REG_SC_BK68_3F_H      _PK_H_(0x68, 0x3F)
#define REG_SC_BK68_40_L      _PK_L_(0x68, 0x40)
#define REG_SC_BK68_40_H      _PK_H_(0x68, 0x40)
#define REG_SC_BK68_41_L      _PK_L_(0x68, 0x41)
#define REG_SC_BK68_41_H      _PK_H_(0x68, 0x41)
#define REG_SC_BK68_42_L      _PK_L_(0x68, 0x42)
#define REG_SC_BK68_42_H      _PK_H_(0x68, 0x42)
#define REG_SC_BK68_43_L      _PK_L_(0x68, 0x43)
#define REG_SC_BK68_43_H      _PK_H_(0x68, 0x43)
#define REG_SC_BK68_44_L      _PK_L_(0x68, 0x44)
#define REG_SC_BK68_44_H      _PK_H_(0x68, 0x44)
#define REG_SC_BK68_45_L      _PK_L_(0x68, 0x45)
#define REG_SC_BK68_45_H      _PK_H_(0x68, 0x45)
#define REG_SC_BK68_46_L      _PK_L_(0x68, 0x46)
#define REG_SC_BK68_46_H      _PK_H_(0x68, 0x46)
#define REG_SC_BK68_47_L      _PK_L_(0x68, 0x47)
#define REG_SC_BK68_47_H      _PK_H_(0x68, 0x47)
#define REG_SC_BK68_48_L      _PK_L_(0x68, 0x48)
#define REG_SC_BK68_48_H      _PK_H_(0x68, 0x48)
#define REG_SC_BK68_49_L      _PK_L_(0x68, 0x49)
#define REG_SC_BK68_49_H      _PK_H_(0x68, 0x49)
#define REG_SC_BK68_4A_L      _PK_L_(0x68, 0x4A)
#define REG_SC_BK68_4A_H      _PK_H_(0x68, 0x4A)
#define REG_SC_BK68_4B_L      _PK_L_(0x68, 0x4B)
#define REG_SC_BK68_4B_H      _PK_H_(0x68, 0x4B)
#define REG_SC_BK68_4C_L      _PK_L_(0x68, 0x4C)
#define REG_SC_BK68_4C_H      _PK_H_(0x68, 0x4C)
#define REG_SC_BK68_4D_L      _PK_L_(0x68, 0x4D)
#define REG_SC_BK68_4D_H      _PK_H_(0x68, 0x4D)
#define REG_SC_BK68_4E_L      _PK_L_(0x68, 0x4E)
#define REG_SC_BK68_4E_H      _PK_H_(0x68, 0x4E)
#define REG_SC_BK68_4F_L      _PK_L_(0x68, 0x4F)
#define REG_SC_BK68_4F_H      _PK_H_(0x68, 0x4F)
#define REG_SC_BK68_50_L      _PK_L_(0x68, 0x50)
#define REG_SC_BK68_50_H      _PK_H_(0x68, 0x50)
#define REG_SC_BK68_51_L      _PK_L_(0x68, 0x51)
#define REG_SC_BK68_51_H      _PK_H_(0x68, 0x51)
#define REG_SC_BK68_52_L      _PK_L_(0x68, 0x52)
#define REG_SC_BK68_52_H      _PK_H_(0x68, 0x52)
#define REG_SC_BK68_53_L      _PK_L_(0x68, 0x53)
#define REG_SC_BK68_53_H      _PK_H_(0x68, 0x53)
#define REG_SC_BK68_54_L      _PK_L_(0x68, 0x54)
#define REG_SC_BK68_54_H      _PK_H_(0x68, 0x54)
#define REG_SC_BK68_55_L      _PK_L_(0x68, 0x55)
#define REG_SC_BK68_55_H      _PK_H_(0x68, 0x55)
#define REG_SC_BK68_56_L      _PK_L_(0x68, 0x56)
#define REG_SC_BK68_56_H      _PK_H_(0x68, 0x56)
#define REG_SC_BK68_57_L      _PK_L_(0x68, 0x57)
#define REG_SC_BK68_57_H      _PK_H_(0x68, 0x57)
#define REG_SC_BK68_58_L      _PK_L_(0x68, 0x58)
#define REG_SC_BK68_58_H      _PK_H_(0x68, 0x58)
#define REG_SC_BK68_59_L      _PK_L_(0x68, 0x59)
#define REG_SC_BK68_59_H      _PK_H_(0x68, 0x59)
#define REG_SC_BK68_5A_L      _PK_L_(0x68, 0x5A)
#define REG_SC_BK68_5A_H      _PK_H_(0x68, 0x5A)
#define REG_SC_BK68_5B_L      _PK_L_(0x68, 0x5B)
#define REG_SC_BK68_5B_H      _PK_H_(0x68, 0x5B)
#define REG_SC_BK68_5C_L      _PK_L_(0x68, 0x5C)
#define REG_SC_BK68_5C_H      _PK_H_(0x68, 0x5C)
#define REG_SC_BK68_5D_L      _PK_L_(0x68, 0x5D)
#define REG_SC_BK68_5D_H      _PK_H_(0x68, 0x5D)
#define REG_SC_BK68_5E_L      _PK_L_(0x68, 0x5E)
#define REG_SC_BK68_5E_H      _PK_H_(0x68, 0x5E)
#define REG_SC_BK68_5F_L      _PK_L_(0x68, 0x5F)
#define REG_SC_BK68_5F_H      _PK_H_(0x68, 0x5F)
#define REG_SC_BK68_60_L      _PK_L_(0x68, 0x60)
#define REG_SC_BK68_60_H      _PK_H_(0x68, 0x60)
#define REG_SC_BK68_61_L      _PK_L_(0x68, 0x61)
#define REG_SC_BK68_61_H      _PK_H_(0x68, 0x61)
#define REG_SC_BK68_62_L      _PK_L_(0x68, 0x62)
#define REG_SC_BK68_62_H      _PK_H_(0x68, 0x62)
#define REG_SC_BK68_63_L      _PK_L_(0x68, 0x63)
#define REG_SC_BK68_63_H      _PK_H_(0x68, 0x63)
#define REG_SC_BK68_64_L      _PK_L_(0x68, 0x64)
#define REG_SC_BK68_64_H      _PK_H_(0x68, 0x64)
#define REG_SC_BK68_65_L      _PK_L_(0x68, 0x65)
#define REG_SC_BK68_65_H      _PK_H_(0x68, 0x65)
#define REG_SC_BK68_66_L      _PK_L_(0x68, 0x66)
#define REG_SC_BK68_66_H      _PK_H_(0x68, 0x66)
#define REG_SC_BK68_67_L      _PK_L_(0x68, 0x67)
#define REG_SC_BK68_67_H      _PK_H_(0x68, 0x67)
#define REG_SC_BK68_68_L      _PK_L_(0x68, 0x68)
#define REG_SC_BK68_68_H      _PK_H_(0x68, 0x68)
#define REG_SC_BK68_69_L      _PK_L_(0x68, 0x69)
#define REG_SC_BK68_69_H      _PK_H_(0x68, 0x69)
#define REG_SC_BK68_6A_L      _PK_L_(0x68, 0x6A)
#define REG_SC_BK68_6A_H      _PK_H_(0x68, 0x6A)
#define REG_SC_BK68_6B_L      _PK_L_(0x68, 0x6B)
#define REG_SC_BK68_6B_H      _PK_H_(0x68, 0x6B)
#define REG_SC_BK68_6C_L      _PK_L_(0x68, 0x6C)
#define REG_SC_BK68_6C_H      _PK_H_(0x68, 0x6C)
#define REG_SC_BK68_6D_L      _PK_L_(0x68, 0x6D)
#define REG_SC_BK68_6D_H      _PK_H_(0x68, 0x6D)
#define REG_SC_BK68_6E_L      _PK_L_(0x68, 0x6E)
#define REG_SC_BK68_6E_H      _PK_H_(0x68, 0x6E)
#define REG_SC_BK68_6F_L      _PK_L_(0x68, 0x6F)
#define REG_SC_BK68_6F_H      _PK_H_(0x68, 0x6F)
#define REG_SC_BK68_70_L      _PK_L_(0x68, 0x70)
#define REG_SC_BK68_70_H      _PK_H_(0x68, 0x70)
#define REG_SC_BK68_71_L      _PK_L_(0x68, 0x71)
#define REG_SC_BK68_71_H      _PK_H_(0x68, 0x71)
#define REG_SC_BK68_72_L      _PK_L_(0x68, 0x72)
#define REG_SC_BK68_72_H      _PK_H_(0x68, 0x72)
#define REG_SC_BK68_73_L      _PK_L_(0x68, 0x73)
#define REG_SC_BK68_73_H      _PK_H_(0x68, 0x73)
#define REG_SC_BK68_74_L      _PK_L_(0x68, 0x74)
#define REG_SC_BK68_74_H      _PK_H_(0x68, 0x74)
#define REG_SC_BK68_75_L      _PK_L_(0x68, 0x75)
#define REG_SC_BK68_75_H      _PK_H_(0x68, 0x75)
#define REG_SC_BK68_76_L      _PK_L_(0x68, 0x76)
#define REG_SC_BK68_76_H      _PK_H_(0x68, 0x76)
#define REG_SC_BK68_77_L      _PK_L_(0x68, 0x77)
#define REG_SC_BK68_77_H      _PK_H_(0x68, 0x77)
#define REG_SC_BK68_78_L      _PK_L_(0x68, 0x78)
#define REG_SC_BK68_78_H      _PK_H_(0x68, 0x78)
#define REG_SC_BK68_79_L      _PK_L_(0x68, 0x79)
#define REG_SC_BK68_79_H      _PK_H_(0x68, 0x79)
#define REG_SC_BK68_7A_L      _PK_L_(0x68, 0x7A)
#define REG_SC_BK68_7A_H      _PK_H_(0x68, 0x7A)
#define REG_SC_BK68_7B_L      _PK_L_(0x68, 0x7B)
#define REG_SC_BK68_7B_H      _PK_H_(0x68, 0x7B)
#define REG_SC_BK68_7C_L      _PK_L_(0x68, 0x7C)
#define REG_SC_BK68_7C_H      _PK_H_(0x68, 0x7C)
#define REG_SC_BK68_7D_L      _PK_L_(0x68, 0x7D)
#define REG_SC_BK68_7D_H      _PK_H_(0x68, 0x7D)
#define REG_SC_BK68_7E_L      _PK_L_(0x68, 0x7E)
#define REG_SC_BK68_7E_H      _PK_H_(0x68, 0x7E)
#define REG_SC_BK68_7F_L      _PK_L_(0x68, 0x7F)
#define REG_SC_BK68_7F_H      _PK_H_(0x68, 0x7F)

//----------------------------------------------
//  BK6A: H2V2
//----------------------------------------------
#define REG_SC_BK6A_00_L      _PK_L_(0x6A, 0x00)
#define REG_SC_BK6A_00_H      _PK_H_(0x6A, 0x00)
#define REG_SC_BK6A_01_L      _PK_L_(0x6A, 0x01)
#define REG_SC_BK6A_01_H      _PK_H_(0x6A, 0x01)
#define REG_SC_BK6A_02_L      _PK_L_(0x6A, 0x02)
#define REG_SC_BK6A_02_H      _PK_H_(0x6A, 0x02)
#define REG_SC_BK6A_03_L      _PK_L_(0x6A, 0x03)
#define REG_SC_BK6A_03_H      _PK_H_(0x6A, 0x03)
#define REG_SC_BK6A_04_L      _PK_L_(0x6A, 0x04)
#define REG_SC_BK6A_04_H      _PK_H_(0x6A, 0x04)
#define REG_SC_BK6A_05_L      _PK_L_(0x6A, 0x05)
#define REG_SC_BK6A_05_H      _PK_H_(0x6A, 0x05)
#define REG_SC_BK6A_06_L      _PK_L_(0x6A, 0x06)
#define REG_SC_BK6A_06_H      _PK_H_(0x6A, 0x06)
#define REG_SC_BK6A_07_L      _PK_L_(0x6A, 0x07)
#define REG_SC_BK6A_07_H      _PK_H_(0x6A, 0x07)
#define REG_SC_BK6A_08_L      _PK_L_(0x6A, 0x08)
#define REG_SC_BK6A_08_H      _PK_H_(0x6A, 0x08)
#define REG_SC_BK6A_09_L      _PK_L_(0x6A, 0x09)
#define REG_SC_BK6A_09_H      _PK_H_(0x6A, 0x09)
#define REG_SC_BK6A_0A_L      _PK_L_(0x6A, 0x0A)
#define REG_SC_BK6A_0A_H      _PK_H_(0x6A, 0x0A)
#define REG_SC_BK6A_0B_L      _PK_L_(0x6A, 0x0B)
#define REG_SC_BK6A_0B_H      _PK_H_(0x6A, 0x0B)
#define REG_SC_BK6A_0C_L      _PK_L_(0x6A, 0x0C)
#define REG_SC_BK6A_0C_H      _PK_H_(0x6A, 0x0C)
#define REG_SC_BK6A_0D_L      _PK_L_(0x6A, 0x0D)
#define REG_SC_BK6A_0D_H      _PK_H_(0x6A, 0x0D)
#define REG_SC_BK6A_0E_L      _PK_L_(0x6A, 0x0E)
#define REG_SC_BK6A_0E_H      _PK_H_(0x6A, 0x0E)
#define REG_SC_BK6A_0F_L      _PK_L_(0x6A, 0x0F)
#define REG_SC_BK6A_0F_H      _PK_H_(0x6A, 0x0F)
#define REG_SC_BK6A_10_L      _PK_L_(0x6A, 0x10)
#define REG_SC_BK6A_10_H      _PK_H_(0x6A, 0x10)
#define REG_SC_BK6A_11_L      _PK_L_(0x6A, 0x11)
#define REG_SC_BK6A_11_H      _PK_H_(0x6A, 0x11)
#define REG_SC_BK6A_12_L      _PK_L_(0x6A, 0x12)
#define REG_SC_BK6A_12_H      _PK_H_(0x6A, 0x12)
#define REG_SC_BK6A_13_L      _PK_L_(0x6A, 0x13)
#define REG_SC_BK6A_13_H      _PK_H_(0x6A, 0x13)
#define REG_SC_BK6A_14_L      _PK_L_(0x6A, 0x14)
#define REG_SC_BK6A_14_H      _PK_H_(0x6A, 0x14)
#define REG_SC_BK6A_15_L      _PK_L_(0x6A, 0x15)
#define REG_SC_BK6A_15_H      _PK_H_(0x6A, 0x15)
#define REG_SC_BK6A_16_L      _PK_L_(0x6A, 0x16)
#define REG_SC_BK6A_16_H      _PK_H_(0x6A, 0x16)
#define REG_SC_BK6A_17_L      _PK_L_(0x6A, 0x17)
#define REG_SC_BK6A_17_H      _PK_H_(0x6A, 0x17)
#define REG_SC_BK6A_18_L      _PK_L_(0x6A, 0x18)
#define REG_SC_BK6A_18_H      _PK_H_(0x6A, 0x18)
#define REG_SC_BK6A_19_L      _PK_L_(0x6A, 0x19)
#define REG_SC_BK6A_19_H      _PK_H_(0x6A, 0x19)
#define REG_SC_BK6A_1A_L      _PK_L_(0x6A, 0x1A)
#define REG_SC_BK6A_1A_H      _PK_H_(0x6A, 0x1A)
#define REG_SC_BK6A_1B_L      _PK_L_(0x6A, 0x1B)
#define REG_SC_BK6A_1B_H      _PK_H_(0x6A, 0x1B)
#define REG_SC_BK6A_1C_L      _PK_L_(0x6A, 0x1C)
#define REG_SC_BK6A_1C_H      _PK_H_(0x6A, 0x1C)
#define REG_SC_BK6A_1D_L      _PK_L_(0x6A, 0x1D)
#define REG_SC_BK6A_1D_H      _PK_H_(0x6A, 0x1D)
#define REG_SC_BK6A_1E_L      _PK_L_(0x6A, 0x1E)
#define REG_SC_BK6A_1E_H      _PK_H_(0x6A, 0x1E)
#define REG_SC_BK6A_1F_L      _PK_L_(0x6A, 0x1F)
#define REG_SC_BK6A_1F_H      _PK_H_(0x6A, 0x1F)
#define REG_SC_BK6A_20_L      _PK_L_(0x6A, 0x20)
#define REG_SC_BK6A_20_H      _PK_H_(0x6A, 0x20)
#define REG_SC_BK6A_21_L      _PK_L_(0x6A, 0x21)
#define REG_SC_BK6A_21_H      _PK_H_(0x6A, 0x21)
#define REG_SC_BK6A_22_L      _PK_L_(0x6A, 0x22)
#define REG_SC_BK6A_22_H      _PK_H_(0x6A, 0x22)
#define REG_SC_BK6A_23_L      _PK_L_(0x6A, 0x23)
#define REG_SC_BK6A_23_H      _PK_H_(0x6A, 0x23)
#define REG_SC_BK6A_24_L      _PK_L_(0x6A, 0x24)
#define REG_SC_BK6A_24_H      _PK_H_(0x6A, 0x24)
#define REG_SC_BK6A_25_L      _PK_L_(0x6A, 0x25)
#define REG_SC_BK6A_25_H      _PK_H_(0x6A, 0x25)
#define REG_SC_BK6A_26_L      _PK_L_(0x6A, 0x26)
#define REG_SC_BK6A_26_H      _PK_H_(0x6A, 0x26)
#define REG_SC_BK6A_27_L      _PK_L_(0x6A, 0x27)
#define REG_SC_BK6A_27_H      _PK_H_(0x6A, 0x27)
#define REG_SC_BK6A_28_L      _PK_L_(0x6A, 0x28)
#define REG_SC_BK6A_28_H      _PK_H_(0x6A, 0x28)
#define REG_SC_BK6A_29_L      _PK_L_(0x6A, 0x29)
#define REG_SC_BK6A_29_H      _PK_H_(0x6A, 0x29)
#define REG_SC_BK6A_2A_L      _PK_L_(0x6A, 0x2A)
#define REG_SC_BK6A_2A_H      _PK_H_(0x6A, 0x2A)
#define REG_SC_BK6A_2B_L      _PK_L_(0x6A, 0x2B)
#define REG_SC_BK6A_2B_H      _PK_H_(0x6A, 0x2B)
#define REG_SC_BK6A_2C_L      _PK_L_(0x6A, 0x2C)
#define REG_SC_BK6A_2C_H      _PK_H_(0x6A, 0x2C)
#define REG_SC_BK6A_2D_L      _PK_L_(0x6A, 0x2D)
#define REG_SC_BK6A_2D_H      _PK_H_(0x6A, 0x2D)
#define REG_SC_BK6A_2E_L      _PK_L_(0x6A, 0x2E)
#define REG_SC_BK6A_2E_H      _PK_H_(0x6A, 0x2E)
#define REG_SC_BK6A_2F_L      _PK_L_(0x6A, 0x2F)
#define REG_SC_BK6A_2F_H      _PK_H_(0x6A, 0x2F)
#define REG_SC_BK6A_30_L      _PK_L_(0x6A, 0x30)
#define REG_SC_BK6A_30_H      _PK_H_(0x6A, 0x30)
#define REG_SC_BK6A_31_L      _PK_L_(0x6A, 0x31)
#define REG_SC_BK6A_31_H      _PK_H_(0x6A, 0x31)
#define REG_SC_BK6A_32_L      _PK_L_(0x6A, 0x32)
#define REG_SC_BK6A_32_H      _PK_H_(0x6A, 0x32)
#define REG_SC_BK6A_33_L      _PK_L_(0x6A, 0x33)
#define REG_SC_BK6A_33_H      _PK_H_(0x6A, 0x33)
#define REG_SC_BK6A_34_L      _PK_L_(0x6A, 0x34)
#define REG_SC_BK6A_34_H      _PK_H_(0x6A, 0x34)
#define REG_SC_BK6A_35_L      _PK_L_(0x6A, 0x35)
#define REG_SC_BK6A_35_H      _PK_H_(0x6A, 0x35)
#define REG_SC_BK6A_36_L      _PK_L_(0x6A, 0x36)
#define REG_SC_BK6A_36_H      _PK_H_(0x6A, 0x36)
#define REG_SC_BK6A_37_L      _PK_L_(0x6A, 0x37)
#define REG_SC_BK6A_37_H      _PK_H_(0x6A, 0x37)
#define REG_SC_BK6A_38_L      _PK_L_(0x6A, 0x38)
#define REG_SC_BK6A_38_H      _PK_H_(0x6A, 0x38)
#define REG_SC_BK6A_39_L      _PK_L_(0x6A, 0x39)
#define REG_SC_BK6A_39_H      _PK_H_(0x6A, 0x39)
#define REG_SC_BK6A_3A_L      _PK_L_(0x6A, 0x3A)
#define REG_SC_BK6A_3A_H      _PK_H_(0x6A, 0x3A)
#define REG_SC_BK6A_3B_L      _PK_L_(0x6A, 0x3B)
#define REG_SC_BK6A_3B_H      _PK_H_(0x6A, 0x3B)
#define REG_SC_BK6A_3C_L      _PK_L_(0x6A, 0x3C)
#define REG_SC_BK6A_3C_H      _PK_H_(0x6A, 0x3C)
#define REG_SC_BK6A_3D_L      _PK_L_(0x6A, 0x3D)
#define REG_SC_BK6A_3D_H      _PK_H_(0x6A, 0x3D)
#define REG_SC_BK6A_3E_L      _PK_L_(0x6A, 0x3E)
#define REG_SC_BK6A_3E_H      _PK_H_(0x6A, 0x3E)
#define REG_SC_BK6A_3F_L      _PK_L_(0x6A, 0x3F)
#define REG_SC_BK6A_3F_H      _PK_H_(0x6A, 0x3F)
#define REG_SC_BK6A_40_L      _PK_L_(0x6A, 0x40)
#define REG_SC_BK6A_40_H      _PK_H_(0x6A, 0x40)
#define REG_SC_BK6A_41_L      _PK_L_(0x6A, 0x41)
#define REG_SC_BK6A_41_H      _PK_H_(0x6A, 0x41)
#define REG_SC_BK6A_42_L      _PK_L_(0x6A, 0x42)
#define REG_SC_BK6A_42_H      _PK_H_(0x6A, 0x42)
#define REG_SC_BK6A_43_L      _PK_L_(0x6A, 0x43)
#define REG_SC_BK6A_43_H      _PK_H_(0x6A, 0x43)
#define REG_SC_BK6A_44_L      _PK_L_(0x6A, 0x44)
#define REG_SC_BK6A_44_H      _PK_H_(0x6A, 0x44)
#define REG_SC_BK6A_45_L      _PK_L_(0x6A, 0x45)
#define REG_SC_BK6A_45_H      _PK_H_(0x6A, 0x45)
#define REG_SC_BK6A_46_L      _PK_L_(0x6A, 0x46)
#define REG_SC_BK6A_46_H      _PK_H_(0x6A, 0x46)
#define REG_SC_BK6A_47_L      _PK_L_(0x6A, 0x47)
#define REG_SC_BK6A_47_H      _PK_H_(0x6A, 0x47)
#define REG_SC_BK6A_48_L      _PK_L_(0x6A, 0x48)
#define REG_SC_BK6A_48_H      _PK_H_(0x6A, 0x48)
#define REG_SC_BK6A_49_L      _PK_L_(0x6A, 0x49)
#define REG_SC_BK6A_49_H      _PK_H_(0x6A, 0x49)
#define REG_SC_BK6A_4A_L      _PK_L_(0x6A, 0x4A)
#define REG_SC_BK6A_4A_H      _PK_H_(0x6A, 0x4A)
#define REG_SC_BK6A_4B_L      _PK_L_(0x6A, 0x4B)
#define REG_SC_BK6A_4B_H      _PK_H_(0x6A, 0x4B)
#define REG_SC_BK6A_4C_L      _PK_L_(0x6A, 0x4C)
#define REG_SC_BK6A_4C_H      _PK_H_(0x6A, 0x4C)
#define REG_SC_BK6A_4D_L      _PK_L_(0x6A, 0x4D)
#define REG_SC_BK6A_4D_H      _PK_H_(0x6A, 0x4D)
#define REG_SC_BK6A_4E_L      _PK_L_(0x6A, 0x4E)
#define REG_SC_BK6A_4E_H      _PK_H_(0x6A, 0x4E)
#define REG_SC_BK6A_4F_L      _PK_L_(0x6A, 0x4F)
#define REG_SC_BK6A_4F_H      _PK_H_(0x6A, 0x4F)
#define REG_SC_BK6A_50_L      _PK_L_(0x6A, 0x50)
#define REG_SC_BK6A_50_H      _PK_H_(0x6A, 0x50)
#define REG_SC_BK6A_51_L      _PK_L_(0x6A, 0x51)
#define REG_SC_BK6A_51_H      _PK_H_(0x6A, 0x51)
#define REG_SC_BK6A_52_L      _PK_L_(0x6A, 0x52)
#define REG_SC_BK6A_52_H      _PK_H_(0x6A, 0x52)
#define REG_SC_BK6A_53_L      _PK_L_(0x6A, 0x53)
#define REG_SC_BK6A_53_H      _PK_H_(0x6A, 0x53)
#define REG_SC_BK6A_54_L      _PK_L_(0x6A, 0x54)
#define REG_SC_BK6A_54_H      _PK_H_(0x6A, 0x54)
#define REG_SC_BK6A_55_L      _PK_L_(0x6A, 0x55)
#define REG_SC_BK6A_55_H      _PK_H_(0x6A, 0x55)
#define REG_SC_BK6A_56_L      _PK_L_(0x6A, 0x56)
#define REG_SC_BK6A_56_H      _PK_H_(0x6A, 0x56)
#define REG_SC_BK6A_57_L      _PK_L_(0x6A, 0x57)
#define REG_SC_BK6A_57_H      _PK_H_(0x6A, 0x57)
#define REG_SC_BK6A_58_L      _PK_L_(0x6A, 0x58)
#define REG_SC_BK6A_58_H      _PK_H_(0x6A, 0x58)
#define REG_SC_BK6A_59_L      _PK_L_(0x6A, 0x59)
#define REG_SC_BK6A_59_H      _PK_H_(0x6A, 0x59)
#define REG_SC_BK6A_5A_L      _PK_L_(0x6A, 0x5A)
#define REG_SC_BK6A_5A_H      _PK_H_(0x6A, 0x5A)
#define REG_SC_BK6A_5B_L      _PK_L_(0x6A, 0x5B)
#define REG_SC_BK6A_5B_H      _PK_H_(0x6A, 0x5B)
#define REG_SC_BK6A_5C_L      _PK_L_(0x6A, 0x5C)
#define REG_SC_BK6A_5C_H      _PK_H_(0x6A, 0x5C)
#define REG_SC_BK6A_5D_L      _PK_L_(0x6A, 0x5D)
#define REG_SC_BK6A_5D_H      _PK_H_(0x6A, 0x5D)
#define REG_SC_BK6A_5E_L      _PK_L_(0x6A, 0x5E)
#define REG_SC_BK6A_5E_H      _PK_H_(0x6A, 0x5E)
#define REG_SC_BK6A_5F_L      _PK_L_(0x6A, 0x5F)
#define REG_SC_BK6A_5F_H      _PK_H_(0x6A, 0x5F)
#define REG_SC_BK6A_60_L      _PK_L_(0x6A, 0x60)
#define REG_SC_BK6A_60_H      _PK_H_(0x6A, 0x60)
#define REG_SC_BK6A_61_L      _PK_L_(0x6A, 0x61)
#define REG_SC_BK6A_61_H      _PK_H_(0x6A, 0x61)
#define REG_SC_BK6A_62_L      _PK_L_(0x6A, 0x62)
#define REG_SC_BK6A_62_H      _PK_H_(0x6A, 0x62)
#define REG_SC_BK6A_63_L      _PK_L_(0x6A, 0x63)
#define REG_SC_BK6A_63_H      _PK_H_(0x6A, 0x63)
#define REG_SC_BK6A_64_L      _PK_L_(0x6A, 0x64)
#define REG_SC_BK6A_64_H      _PK_H_(0x6A, 0x64)
#define REG_SC_BK6A_65_L      _PK_L_(0x6A, 0x65)
#define REG_SC_BK6A_65_H      _PK_H_(0x6A, 0x65)
#define REG_SC_BK6A_66_L      _PK_L_(0x6A, 0x66)
#define REG_SC_BK6A_66_H      _PK_H_(0x6A, 0x66)
#define REG_SC_BK6A_67_L      _PK_L_(0x6A, 0x67)
#define REG_SC_BK6A_67_H      _PK_H_(0x6A, 0x67)
#define REG_SC_BK6A_68_L      _PK_L_(0x6A, 0x68)
#define REG_SC_BK6A_68_H      _PK_H_(0x6A, 0x68)
#define REG_SC_BK6A_69_L      _PK_L_(0x6A, 0x69)
#define REG_SC_BK6A_69_H      _PK_H_(0x6A, 0x69)
#define REG_SC_BK6A_6A_L      _PK_L_(0x6A, 0x6A)
#define REG_SC_BK6A_6A_H      _PK_H_(0x6A, 0x6A)
#define REG_SC_BK6A_6B_L      _PK_L_(0x6A, 0x6B)
#define REG_SC_BK6A_6B_H      _PK_H_(0x6A, 0x6B)
#define REG_SC_BK6A_6C_L      _PK_L_(0x6A, 0x6C)
#define REG_SC_BK6A_6C_H      _PK_H_(0x6A, 0x6C)
#define REG_SC_BK6A_6D_L      _PK_L_(0x6A, 0x6D)
#define REG_SC_BK6A_6D_H      _PK_H_(0x6A, 0x6D)
#define REG_SC_BK6A_6E_L      _PK_L_(0x6A, 0x6E)
#define REG_SC_BK6A_6E_H      _PK_H_(0x6A, 0x6E)
#define REG_SC_BK6A_6F_L      _PK_L_(0x6A, 0x6F)
#define REG_SC_BK6A_6F_H      _PK_H_(0x6A, 0x6F)
#define REG_SC_BK6A_70_L      _PK_L_(0x6A, 0x70)
#define REG_SC_BK6A_70_H      _PK_H_(0x6A, 0x70)
#define REG_SC_BK6A_71_L      _PK_L_(0x6A, 0x71)
#define REG_SC_BK6A_71_H      _PK_H_(0x6A, 0x71)
#define REG_SC_BK6A_72_L      _PK_L_(0x6A, 0x72)
#define REG_SC_BK6A_72_H      _PK_H_(0x6A, 0x72)
#define REG_SC_BK6A_73_L      _PK_L_(0x6A, 0x73)
#define REG_SC_BK6A_73_H      _PK_H_(0x6A, 0x73)
#define REG_SC_BK6A_74_L      _PK_L_(0x6A, 0x74)
#define REG_SC_BK6A_74_H      _PK_H_(0x6A, 0x74)
#define REG_SC_BK6A_75_L      _PK_L_(0x6A, 0x75)
#define REG_SC_BK6A_75_H      _PK_H_(0x6A, 0x75)
#define REG_SC_BK6A_76_L      _PK_L_(0x6A, 0x76)
#define REG_SC_BK6A_76_H      _PK_H_(0x6A, 0x76)
#define REG_SC_BK6A_77_L      _PK_L_(0x6A, 0x77)
#define REG_SC_BK6A_77_H      _PK_H_(0x6A, 0x77)
#define REG_SC_BK6A_78_L      _PK_L_(0x6A, 0x78)
#define REG_SC_BK6A_78_H      _PK_H_(0x6A, 0x78)
#define REG_SC_BK6A_79_L      _PK_L_(0x6A, 0x79)
#define REG_SC_BK6A_79_H      _PK_H_(0x6A, 0x79)
#define REG_SC_BK6A_7A_L      _PK_L_(0x6A, 0x7A)
#define REG_SC_BK6A_7A_H      _PK_H_(0x6A, 0x7A)
#define REG_SC_BK6A_7B_L      _PK_L_(0x6A, 0x7B)
#define REG_SC_BK6A_7B_H      _PK_H_(0x6A, 0x7B)
#define REG_SC_BK6A_7C_L      _PK_L_(0x6A, 0x7C)
#define REG_SC_BK6A_7C_H      _PK_H_(0x6A, 0x7C)
#define REG_SC_BK6A_7D_L      _PK_L_(0x6A, 0x7D)
#define REG_SC_BK6A_7D_H      _PK_H_(0x6A, 0x7D)
#define REG_SC_BK6A_7E_L      _PK_L_(0x6A, 0x7E)
#define REG_SC_BK6A_7E_H      _PK_H_(0x6A, 0x7E)
#define REG_SC_BK6A_7F_L      _PK_L_(0x6A, 0x7F)
#define REG_SC_BK6A_7F_H      _PK_H_(0x6A, 0x7F)

//----------------------------------------------
//  BK6C: FCLK_TUNE
//----------------------------------------------
#define REG_SC_BK6C_00_L      _PK_L_(0x6C, 0x00)
#define REG_SC_BK6C_00_H      _PK_H_(0x6C, 0x00)
#define REG_SC_BK6C_01_L      _PK_L_(0x6C, 0x01)
#define REG_SC_BK6C_01_H      _PK_H_(0x6C, 0x01)
#define REG_SC_BK6C_02_L      _PK_L_(0x6C, 0x02)
#define REG_SC_BK6C_02_H      _PK_H_(0x6C, 0x02)
#define REG_SC_BK6C_03_L      _PK_L_(0x6C, 0x03)
#define REG_SC_BK6C_03_H      _PK_H_(0x6C, 0x03)
#define REG_SC_BK6C_04_L      _PK_L_(0x6C, 0x04)
#define REG_SC_BK6C_04_H      _PK_H_(0x6C, 0x04)
#define REG_SC_BK6C_05_L      _PK_L_(0x6C, 0x05)
#define REG_SC_BK6C_05_H      _PK_H_(0x6C, 0x05)
#define REG_SC_BK6C_06_L      _PK_L_(0x6C, 0x06)
#define REG_SC_BK6C_06_H      _PK_H_(0x6C, 0x06)
#define REG_SC_BK6C_07_L      _PK_L_(0x6C, 0x07)
#define REG_SC_BK6C_07_H      _PK_H_(0x6C, 0x07)
#define REG_SC_BK6C_08_L      _PK_L_(0x6C, 0x08)
#define REG_SC_BK6C_08_H      _PK_H_(0x6C, 0x08)
#define REG_SC_BK6C_09_L      _PK_L_(0x6C, 0x09)
#define REG_SC_BK6C_09_H      _PK_H_(0x6C, 0x09)
#define REG_SC_BK6C_0A_L      _PK_L_(0x6C, 0x0A)
#define REG_SC_BK6C_0A_H      _PK_H_(0x6C, 0x0A)
#define REG_SC_BK6C_0B_L      _PK_L_(0x6C, 0x0B)
#define REG_SC_BK6C_0B_H      _PK_H_(0x6C, 0x0B)
#define REG_SC_BK6C_0C_L      _PK_L_(0x6C, 0x0C)
#define REG_SC_BK6C_0C_H      _PK_H_(0x6C, 0x0C)
#define REG_SC_BK6C_0D_L      _PK_L_(0x6C, 0x0D)
#define REG_SC_BK6C_0D_H      _PK_H_(0x6C, 0x0D)
#define REG_SC_BK6C_0E_L      _PK_L_(0x6C, 0x0E)
#define REG_SC_BK6C_0E_H      _PK_H_(0x6C, 0x0E)
#define REG_SC_BK6C_0F_L      _PK_L_(0x6C, 0x0F)
#define REG_SC_BK6C_0F_H      _PK_H_(0x6C, 0x0F)
#define REG_SC_BK6C_10_L      _PK_L_(0x6C, 0x10)
#define REG_SC_BK6C_10_H      _PK_H_(0x6C, 0x10)
#define REG_SC_BK6C_11_L      _PK_L_(0x6C, 0x11)
#define REG_SC_BK6C_11_H      _PK_H_(0x6C, 0x11)
#define REG_SC_BK6C_12_L      _PK_L_(0x6C, 0x12)
#define REG_SC_BK6C_12_H      _PK_H_(0x6C, 0x12)
#define REG_SC_BK6C_13_L      _PK_L_(0x6C, 0x13)
#define REG_SC_BK6C_13_H      _PK_H_(0x6C, 0x13)
#define REG_SC_BK6C_14_L      _PK_L_(0x6C, 0x14)
#define REG_SC_BK6C_14_H      _PK_H_(0x6C, 0x14)
#define REG_SC_BK6C_15_L      _PK_L_(0x6C, 0x15)
#define REG_SC_BK6C_15_H      _PK_H_(0x6C, 0x15)
#define REG_SC_BK6C_16_L      _PK_L_(0x6C, 0x16)
#define REG_SC_BK6C_16_H      _PK_H_(0x6C, 0x16)
#define REG_SC_BK6C_17_L      _PK_L_(0x6C, 0x17)
#define REG_SC_BK6C_17_H      _PK_H_(0x6C, 0x17)
#define REG_SC_BK6C_18_L      _PK_L_(0x6C, 0x18)
#define REG_SC_BK6C_18_H      _PK_H_(0x6C, 0x18)
#define REG_SC_BK6C_19_L      _PK_L_(0x6C, 0x19)
#define REG_SC_BK6C_19_H      _PK_H_(0x6C, 0x19)
#define REG_SC_BK6C_1A_L      _PK_L_(0x6C, 0x1A)
#define REG_SC_BK6C_1A_H      _PK_H_(0x6C, 0x1A)
#define REG_SC_BK6C_1B_L      _PK_L_(0x6C, 0x1B)
#define REG_SC_BK6C_1B_H      _PK_H_(0x6C, 0x1B)
#define REG_SC_BK6C_1C_L      _PK_L_(0x6C, 0x1C)
#define REG_SC_BK6C_1C_H      _PK_H_(0x6C, 0x1C)
#define REG_SC_BK6C_1D_L      _PK_L_(0x6C, 0x1D)
#define REG_SC_BK6C_1D_H      _PK_H_(0x6C, 0x1D)
#define REG_SC_BK6C_1E_L      _PK_L_(0x6C, 0x1E)
#define REG_SC_BK6C_1E_H      _PK_H_(0x6C, 0x1E)
#define REG_SC_BK6C_1F_L      _PK_L_(0x6C, 0x1F)
#define REG_SC_BK6C_1F_H      _PK_H_(0x6C, 0x1F)
#define REG_SC_BK6C_20_L      _PK_L_(0x6C, 0x20)
#define REG_SC_BK6C_20_H      _PK_H_(0x6C, 0x20)
#define REG_SC_BK6C_21_L      _PK_L_(0x6C, 0x21)
#define REG_SC_BK6C_21_H      _PK_H_(0x6C, 0x21)
#define REG_SC_BK6C_22_L      _PK_L_(0x6C, 0x22)
#define REG_SC_BK6C_22_H      _PK_H_(0x6C, 0x22)
#define REG_SC_BK6C_23_L      _PK_L_(0x6C, 0x23)
#define REG_SC_BK6C_23_H      _PK_H_(0x6C, 0x23)
#define REG_SC_BK6C_24_L      _PK_L_(0x6C, 0x24)
#define REG_SC_BK6C_24_H      _PK_H_(0x6C, 0x24)
#define REG_SC_BK6C_25_L      _PK_L_(0x6C, 0x25)
#define REG_SC_BK6C_25_H      _PK_H_(0x6C, 0x25)
#define REG_SC_BK6C_26_L      _PK_L_(0x6C, 0x26)
#define REG_SC_BK6C_26_H      _PK_H_(0x6C, 0x26)
#define REG_SC_BK6C_27_L      _PK_L_(0x6C, 0x27)
#define REG_SC_BK6C_27_H      _PK_H_(0x6C, 0x27)
#define REG_SC_BK6C_28_L      _PK_L_(0x6C, 0x28)
#define REG_SC_BK6C_28_H      _PK_H_(0x6C, 0x28)
#define REG_SC_BK6C_29_L      _PK_L_(0x6C, 0x29)
#define REG_SC_BK6C_29_H      _PK_H_(0x6C, 0x29)
#define REG_SC_BK6C_2A_L      _PK_L_(0x6C, 0x2A)
#define REG_SC_BK6C_2A_H      _PK_H_(0x6C, 0x2A)
#define REG_SC_BK6C_2B_L      _PK_L_(0x6C, 0x2B)
#define REG_SC_BK6C_2B_H      _PK_H_(0x6C, 0x2B)
#define REG_SC_BK6C_2C_L      _PK_L_(0x6C, 0x2C)
#define REG_SC_BK6C_2C_H      _PK_H_(0x6C, 0x2C)
#define REG_SC_BK6C_2D_L      _PK_L_(0x6C, 0x2D)
#define REG_SC_BK6C_2D_H      _PK_H_(0x6C, 0x2D)
#define REG_SC_BK6C_2E_L      _PK_L_(0x6C, 0x2E)
#define REG_SC_BK6C_2E_H      _PK_H_(0x6C, 0x2E)
#define REG_SC_BK6C_2F_L      _PK_L_(0x6C, 0x2F)
#define REG_SC_BK6C_2F_H      _PK_H_(0x6C, 0x2F)
#define REG_SC_BK6C_30_L      _PK_L_(0x6C, 0x30)
#define REG_SC_BK6C_30_H      _PK_H_(0x6C, 0x30)
#define REG_SC_BK6C_31_L      _PK_L_(0x6C, 0x31)
#define REG_SC_BK6C_31_H      _PK_H_(0x6C, 0x31)
#define REG_SC_BK6C_32_L      _PK_L_(0x6C, 0x32)
#define REG_SC_BK6C_32_H      _PK_H_(0x6C, 0x32)
#define REG_SC_BK6C_33_L      _PK_L_(0x6C, 0x33)
#define REG_SC_BK6C_33_H      _PK_H_(0x6C, 0x33)
#define REG_SC_BK6C_34_L      _PK_L_(0x6C, 0x34)
#define REG_SC_BK6C_34_H      _PK_H_(0x6C, 0x34)
#define REG_SC_BK6C_35_L      _PK_L_(0x6C, 0x35)
#define REG_SC_BK6C_35_H      _PK_H_(0x6C, 0x35)
#define REG_SC_BK6C_36_L      _PK_L_(0x6C, 0x36)
#define REG_SC_BK6C_36_H      _PK_H_(0x6C, 0x36)
#define REG_SC_BK6C_37_L      _PK_L_(0x6C, 0x37)
#define REG_SC_BK6C_37_H      _PK_H_(0x6C, 0x37)
#define REG_SC_BK6C_38_L      _PK_L_(0x6C, 0x38)
#define REG_SC_BK6C_38_H      _PK_H_(0x6C, 0x38)
#define REG_SC_BK6C_39_L      _PK_L_(0x6C, 0x39)
#define REG_SC_BK6C_39_H      _PK_H_(0x6C, 0x39)
#define REG_SC_BK6C_3A_L      _PK_L_(0x6C, 0x3A)
#define REG_SC_BK6C_3A_H      _PK_H_(0x6C, 0x3A)
#define REG_SC_BK6C_3B_L      _PK_L_(0x6C, 0x3B)
#define REG_SC_BK6C_3B_H      _PK_H_(0x6C, 0x3B)
#define REG_SC_BK6C_3C_L      _PK_L_(0x6C, 0x3C)
#define REG_SC_BK6C_3C_H      _PK_H_(0x6C, 0x3C)
#define REG_SC_BK6C_3D_L      _PK_L_(0x6C, 0x3D)
#define REG_SC_BK6C_3D_H      _PK_H_(0x6C, 0x3D)
#define REG_SC_BK6C_3E_L      _PK_L_(0x6C, 0x3E)
#define REG_SC_BK6C_3E_H      _PK_H_(0x6C, 0x3E)
#define REG_SC_BK6C_3F_L      _PK_L_(0x6C, 0x3F)
#define REG_SC_BK6C_3F_H      _PK_H_(0x6C, 0x3F)
#define REG_SC_BK6C_40_L      _PK_L_(0x6C, 0x40)
#define REG_SC_BK6C_40_H      _PK_H_(0x6C, 0x40)
#define REG_SC_BK6C_41_L      _PK_L_(0x6C, 0x41)
#define REG_SC_BK6C_41_H      _PK_H_(0x6C, 0x41)
#define REG_SC_BK6C_42_L      _PK_L_(0x6C, 0x42)
#define REG_SC_BK6C_42_H      _PK_H_(0x6C, 0x42)
#define REG_SC_BK6C_43_L      _PK_L_(0x6C, 0x43)
#define REG_SC_BK6C_43_H      _PK_H_(0x6C, 0x43)
#define REG_SC_BK6C_44_L      _PK_L_(0x6C, 0x44)
#define REG_SC_BK6C_44_H      _PK_H_(0x6C, 0x44)
#define REG_SC_BK6C_45_L      _PK_L_(0x6C, 0x45)
#define REG_SC_BK6C_45_H      _PK_H_(0x6C, 0x45)
#define REG_SC_BK6C_46_L      _PK_L_(0x6C, 0x46)
#define REG_SC_BK6C_46_H      _PK_H_(0x6C, 0x46)
#define REG_SC_BK6C_47_L      _PK_L_(0x6C, 0x47)
#define REG_SC_BK6C_47_H      _PK_H_(0x6C, 0x47)
#define REG_SC_BK6C_48_L      _PK_L_(0x6C, 0x48)
#define REG_SC_BK6C_48_H      _PK_H_(0x6C, 0x48)
#define REG_SC_BK6C_49_L      _PK_L_(0x6C, 0x49)
#define REG_SC_BK6C_49_H      _PK_H_(0x6C, 0x49)
#define REG_SC_BK6C_4A_L      _PK_L_(0x6C, 0x4A)
#define REG_SC_BK6C_4A_H      _PK_H_(0x6C, 0x4A)
#define REG_SC_BK6C_4B_L      _PK_L_(0x6C, 0x4B)
#define REG_SC_BK6C_4B_H      _PK_H_(0x6C, 0x4B)
#define REG_SC_BK6C_4C_L      _PK_L_(0x6C, 0x4C)
#define REG_SC_BK6C_4C_H      _PK_H_(0x6C, 0x4C)
#define REG_SC_BK6C_4D_L      _PK_L_(0x6C, 0x4D)
#define REG_SC_BK6C_4D_H      _PK_H_(0x6C, 0x4D)
#define REG_SC_BK6C_4E_L      _PK_L_(0x6C, 0x4E)
#define REG_SC_BK6C_4E_H      _PK_H_(0x6C, 0x4E)
#define REG_SC_BK6C_4F_L      _PK_L_(0x6C, 0x4F)
#define REG_SC_BK6C_4F_H      _PK_H_(0x6C, 0x4F)
#define REG_SC_BK6C_50_L      _PK_L_(0x6C, 0x50)
#define REG_SC_BK6C_50_H      _PK_H_(0x6C, 0x50)
#define REG_SC_BK6C_51_L      _PK_L_(0x6C, 0x51)
#define REG_SC_BK6C_51_H      _PK_H_(0x6C, 0x51)
#define REG_SC_BK6C_52_L      _PK_L_(0x6C, 0x52)
#define REG_SC_BK6C_52_H      _PK_H_(0x6C, 0x52)
#define REG_SC_BK6C_53_L      _PK_L_(0x6C, 0x53)
#define REG_SC_BK6C_53_H      _PK_H_(0x6C, 0x53)
#define REG_SC_BK6C_54_L      _PK_L_(0x6C, 0x54)
#define REG_SC_BK6C_54_H      _PK_H_(0x6C, 0x54)
#define REG_SC_BK6C_55_L      _PK_L_(0x6C, 0x55)
#define REG_SC_BK6C_55_H      _PK_H_(0x6C, 0x55)
#define REG_SC_BK6C_56_L      _PK_L_(0x6C, 0x56)
#define REG_SC_BK6C_56_H      _PK_H_(0x6C, 0x56)
#define REG_SC_BK6C_57_L      _PK_L_(0x6C, 0x57)
#define REG_SC_BK6C_57_H      _PK_H_(0x6C, 0x57)
#define REG_SC_BK6C_58_L      _PK_L_(0x6C, 0x58)
#define REG_SC_BK6C_58_H      _PK_H_(0x6C, 0x58)
#define REG_SC_BK6C_59_L      _PK_L_(0x6C, 0x59)
#define REG_SC_BK6C_59_H      _PK_H_(0x6C, 0x59)
#define REG_SC_BK6C_5A_L      _PK_L_(0x6C, 0x5A)
#define REG_SC_BK6C_5A_H      _PK_H_(0x6C, 0x5A)
#define REG_SC_BK6C_5B_L      _PK_L_(0x6C, 0x5B)
#define REG_SC_BK6C_5B_H      _PK_H_(0x6C, 0x5B)
#define REG_SC_BK6C_5C_L      _PK_L_(0x6C, 0x5C)
#define REG_SC_BK6C_5C_H      _PK_H_(0x6C, 0x5C)
#define REG_SC_BK6C_5D_L      _PK_L_(0x6C, 0x5D)
#define REG_SC_BK6C_5D_H      _PK_H_(0x6C, 0x5D)
#define REG_SC_BK6C_5E_L      _PK_L_(0x6C, 0x5E)
#define REG_SC_BK6C_5E_H      _PK_H_(0x6C, 0x5E)
#define REG_SC_BK6C_5F_L      _PK_L_(0x6C, 0x5F)
#define REG_SC_BK6C_5F_H      _PK_H_(0x6C, 0x5F)
#define REG_SC_BK6C_60_L      _PK_L_(0x6C, 0x60)
#define REG_SC_BK6C_60_H      _PK_H_(0x6C, 0x60)
#define REG_SC_BK6C_61_L      _PK_L_(0x6C, 0x61)
#define REG_SC_BK6C_61_H      _PK_H_(0x6C, 0x61)
#define REG_SC_BK6C_62_L      _PK_L_(0x6C, 0x62)
#define REG_SC_BK6C_62_H      _PK_H_(0x6C, 0x62)
#define REG_SC_BK6C_63_L      _PK_L_(0x6C, 0x63)
#define REG_SC_BK6C_63_H      _PK_H_(0x6C, 0x63)
#define REG_SC_BK6C_64_L      _PK_L_(0x6C, 0x64)
#define REG_SC_BK6C_64_H      _PK_H_(0x6C, 0x64)
#define REG_SC_BK6C_65_L      _PK_L_(0x6C, 0x65)
#define REG_SC_BK6C_65_H      _PK_H_(0x6C, 0x65)
#define REG_SC_BK6C_66_L      _PK_L_(0x6C, 0x66)
#define REG_SC_BK6C_66_H      _PK_H_(0x6C, 0x66)
#define REG_SC_BK6C_67_L      _PK_L_(0x6C, 0x67)
#define REG_SC_BK6C_67_H      _PK_H_(0x6C, 0x67)
#define REG_SC_BK6C_68_L      _PK_L_(0x6C, 0x68)
#define REG_SC_BK6C_68_H      _PK_H_(0x6C, 0x68)
#define REG_SC_BK6C_69_L      _PK_L_(0x6C, 0x69)
#define REG_SC_BK6C_69_H      _PK_H_(0x6C, 0x69)
#define REG_SC_BK6C_6A_L      _PK_L_(0x6C, 0x6A)
#define REG_SC_BK6C_6A_H      _PK_H_(0x6C, 0x6A)
#define REG_SC_BK6C_6B_L      _PK_L_(0x6C, 0x6B)
#define REG_SC_BK6C_6B_H      _PK_H_(0x6C, 0x6B)
#define REG_SC_BK6C_6C_L      _PK_L_(0x6C, 0x6C)
#define REG_SC_BK6C_6C_H      _PK_H_(0x6C, 0x6C)
#define REG_SC_BK6C_6D_L      _PK_L_(0x6C, 0x6D)
#define REG_SC_BK6C_6D_H      _PK_H_(0x6C, 0x6D)
#define REG_SC_BK6C_6E_L      _PK_L_(0x6C, 0x6E)
#define REG_SC_BK6C_6E_H      _PK_H_(0x6C, 0x6E)
#define REG_SC_BK6C_6F_L      _PK_L_(0x6C, 0x6F)
#define REG_SC_BK6C_6F_H      _PK_H_(0x6C, 0x6F)
#define REG_SC_BK6C_70_L      _PK_L_(0x6C, 0x70)
#define REG_SC_BK6C_70_H      _PK_H_(0x6C, 0x70)
#define REG_SC_BK6C_71_L      _PK_L_(0x6C, 0x71)
#define REG_SC_BK6C_71_H      _PK_H_(0x6C, 0x71)
#define REG_SC_BK6C_72_L      _PK_L_(0x6C, 0x72)
#define REG_SC_BK6C_72_H      _PK_H_(0x6C, 0x72)
#define REG_SC_BK6C_73_L      _PK_L_(0x6C, 0x73)
#define REG_SC_BK6C_73_H      _PK_H_(0x6C, 0x73)
#define REG_SC_BK6C_74_L      _PK_L_(0x6C, 0x74)
#define REG_SC_BK6C_74_H      _PK_H_(0x6C, 0x74)
#define REG_SC_BK6C_75_L      _PK_L_(0x6C, 0x75)
#define REG_SC_BK6C_75_H      _PK_H_(0x6C, 0x75)
#define REG_SC_BK6C_76_L      _PK_L_(0x6C, 0x76)
#define REG_SC_BK6C_76_H      _PK_H_(0x6C, 0x76)
#define REG_SC_BK6C_77_L      _PK_L_(0x6C, 0x77)
#define REG_SC_BK6C_77_H      _PK_H_(0x6C, 0x77)
#define REG_SC_BK6C_78_L      _PK_L_(0x6C, 0x78)
#define REG_SC_BK6C_78_H      _PK_H_(0x6C, 0x78)
#define REG_SC_BK6C_79_L      _PK_L_(0x6C, 0x79)
#define REG_SC_BK6C_79_H      _PK_H_(0x6C, 0x79)
#define REG_SC_BK6C_7A_L      _PK_L_(0x6C, 0x7A)
#define REG_SC_BK6C_7A_H      _PK_H_(0x6C, 0x7A)
#define REG_SC_BK6C_7B_L      _PK_L_(0x6C, 0x7B)
#define REG_SC_BK6C_7B_H      _PK_H_(0x6C, 0x7B)
#define REG_SC_BK6C_7C_L      _PK_L_(0x6C, 0x7C)
#define REG_SC_BK6C_7C_H      _PK_H_(0x6C, 0x7C)
#define REG_SC_BK6C_7D_L      _PK_L_(0x6C, 0x7D)
#define REG_SC_BK6C_7D_H      _PK_H_(0x6C, 0x7D)
#define REG_SC_BK6C_7E_L      _PK_L_(0x6C, 0x7E)
#define REG_SC_BK6C_7E_H      _PK_H_(0x6C, 0x7E)
#define REG_SC_BK6C_7F_L      _PK_L_(0x6C, 0x7F)
#define REG_SC_BK6C_7F_H      _PK_H_(0x6C, 0x7F)


//----------------------------------------------
// BK71:
//----------------------------------------------
#define REG_SC_BK71_01_L       _PK_L_(0x71, 0x01)
#define REG_SC_BK71_01_H       _PK_H_(0x71, 0x01)


//----------------------------------------------
// BK77:
//----------------------------------------------
#define REG_SC_BK77_26_L      _PK_L_(0x77, 0x26)
#define REG_SC_BK77_26_H      _PK_H_(0x77, 0x26)

//----------------------------------------------
//  BK79:
//----------------------------------------------
#define REG_SC_BK79_00_L      _PK_L_(0x79, 0x00)
#define REG_SC_BK79_00_H      _PK_H_(0x79, 0x00)
#define REG_SC_BK79_01_L      _PK_L_(0x79, 0x01)
#define REG_SC_BK79_01_H      _PK_H_(0x79, 0x01)
#define REG_SC_BK79_02_L      _PK_L_(0x79, 0x02)
#define REG_SC_BK79_02_H      _PK_H_(0x79, 0x02)
#define REG_SC_BK79_03_L      _PK_L_(0x79, 0x03)
#define REG_SC_BK79_03_H      _PK_H_(0x79, 0x03)
#define REG_SC_BK79_04_L      _PK_L_(0x79, 0x04)
#define REG_SC_BK79_04_H      _PK_H_(0x79, 0x04)
#define REG_SC_BK79_05_L      _PK_L_(0x79, 0x05)
#define REG_SC_BK79_05_H      _PK_H_(0x79, 0x05)
#define REG_SC_BK79_06_L      _PK_L_(0x79, 0x06)
#define REG_SC_BK79_06_H      _PK_H_(0x79, 0x06)
#define REG_SC_BK79_07_L      _PK_L_(0x79, 0x07)
#define REG_SC_BK79_07_H      _PK_H_(0x79, 0x07)
#define REG_SC_BK79_08_L      _PK_L_(0x79, 0x08)
#define REG_SC_BK79_08_H      _PK_H_(0x79, 0x08)
#define REG_SC_BK79_09_L      _PK_L_(0x79, 0x09)
#define REG_SC_BK79_09_H      _PK_H_(0x79, 0x09)
#define REG_SC_BK79_0A_L      _PK_L_(0x79, 0x0A)
#define REG_SC_BK79_0A_H      _PK_H_(0x79, 0x0A)
#define REG_SC_BK79_0B_L      _PK_L_(0x79, 0x0B)
#define REG_SC_BK79_0B_H      _PK_H_(0x79, 0x0B)
#define REG_SC_BK79_0C_L      _PK_L_(0x79, 0x0C)
#define REG_SC_BK79_0C_H      _PK_H_(0x79, 0x0C)
#define REG_SC_BK79_0D_L      _PK_L_(0x79, 0x0D)
#define REG_SC_BK79_0D_H      _PK_H_(0x79, 0x0D)
#define REG_SC_BK79_0E_L      _PK_L_(0x79, 0x0E)
#define REG_SC_BK79_0E_H      _PK_H_(0x79, 0x0E)
#define REG_SC_BK79_0F_L      _PK_L_(0x79, 0x0F)
#define REG_SC_BK79_0F_H      _PK_H_(0x79, 0x0F)
#define REG_SC_BK79_10_L      _PK_L_(0x79, 0x10)
#define REG_SC_BK79_10_H      _PK_H_(0x79, 0x10)
#define REG_SC_BK79_11_L      _PK_L_(0x79, 0x11)
#define REG_SC_BK79_11_H      _PK_H_(0x79, 0x11)
#define REG_SC_BK79_12_L      _PK_L_(0x79, 0x12)
#define REG_SC_BK79_12_H      _PK_H_(0x79, 0x12)
#define REG_SC_BK79_13_L      _PK_L_(0x79, 0x13)
#define REG_SC_BK79_13_H      _PK_H_(0x79, 0x13)
#define REG_SC_BK79_14_L      _PK_L_(0x79, 0x14)
#define REG_SC_BK79_14_H      _PK_H_(0x79, 0x14)
#define REG_SC_BK79_15_L      _PK_L_(0x79, 0x15)
#define REG_SC_BK79_15_H      _PK_H_(0x79, 0x15)
#define REG_SC_BK79_16_L      _PK_L_(0x79, 0x16)
#define REG_SC_BK79_16_H      _PK_H_(0x79, 0x16)
#define REG_SC_BK79_17_L      _PK_L_(0x79, 0x17)
#define REG_SC_BK79_17_H      _PK_H_(0x79, 0x17)
#define REG_SC_BK79_18_L      _PK_L_(0x79, 0x18)
#define REG_SC_BK79_18_H      _PK_H_(0x79, 0x18)
#define REG_SC_BK79_19_L      _PK_L_(0x79, 0x19)
#define REG_SC_BK79_19_H      _PK_H_(0x79, 0x19)
#define REG_SC_BK79_1A_L      _PK_L_(0x79, 0x1A)
#define REG_SC_BK79_1A_H      _PK_H_(0x79, 0x1A)
#define REG_SC_BK79_1B_L      _PK_L_(0x79, 0x1B)
#define REG_SC_BK79_1B_H      _PK_H_(0x79, 0x1B)
#define REG_SC_BK79_1C_L      _PK_L_(0x79, 0x1C)
#define REG_SC_BK79_1C_H      _PK_H_(0x79, 0x1C)
#define REG_SC_BK79_1D_L      _PK_L_(0x79, 0x1D)
#define REG_SC_BK79_1D_H      _PK_H_(0x79, 0x1D)
#define REG_SC_BK79_1E_L      _PK_L_(0x79, 0x1E)
#define REG_SC_BK79_1E_H      _PK_H_(0x79, 0x1E)
#define REG_SC_BK79_1F_L      _PK_L_(0x79, 0x1F)
#define REG_SC_BK79_1F_H      _PK_H_(0x79, 0x1F)
#define REG_SC_BK79_20_L      _PK_L_(0x79, 0x20)
#define REG_SC_BK79_20_H      _PK_H_(0x79, 0x20)
#define REG_SC_BK79_21_L      _PK_L_(0x79, 0x21)
#define REG_SC_BK79_21_H      _PK_H_(0x79, 0x21)
#define REG_SC_BK79_22_L      _PK_L_(0x79, 0x22)
#define REG_SC_BK79_22_H      _PK_H_(0x79, 0x22)
#define REG_SC_BK79_23_L      _PK_L_(0x79, 0x23)
#define REG_SC_BK79_23_H      _PK_H_(0x79, 0x23)
#define REG_SC_BK79_24_L      _PK_L_(0x79, 0x24)
#define REG_SC_BK79_24_H      _PK_H_(0x79, 0x24)
#define REG_SC_BK79_25_L      _PK_L_(0x79, 0x25)
#define REG_SC_BK79_25_H      _PK_H_(0x79, 0x25)
#define REG_SC_BK79_26_L      _PK_L_(0x79, 0x26)
#define REG_SC_BK79_26_H      _PK_H_(0x79, 0x26)
#define REG_SC_BK79_27_L      _PK_L_(0x79, 0x27)
#define REG_SC_BK79_27_H      _PK_H_(0x79, 0x27)
#define REG_SC_BK79_28_L      _PK_L_(0x79, 0x28)
#define REG_SC_BK79_28_H      _PK_H_(0x79, 0x28)
#define REG_SC_BK79_29_L      _PK_L_(0x79, 0x29)
#define REG_SC_BK79_29_H      _PK_H_(0x79, 0x29)
#define REG_SC_BK79_2A_L      _PK_L_(0x79, 0x2A)
#define REG_SC_BK79_2A_H      _PK_H_(0x79, 0x2A)
#define REG_SC_BK79_2B_L      _PK_L_(0x79, 0x2B)
#define REG_SC_BK79_2B_H      _PK_H_(0x79, 0x2B)
#define REG_SC_BK79_2C_L      _PK_L_(0x79, 0x2C)
#define REG_SC_BK79_2C_H      _PK_H_(0x79, 0x2C)
#define REG_SC_BK79_2D_L      _PK_L_(0x79, 0x2D)
#define REG_SC_BK79_2D_H      _PK_H_(0x79, 0x2D)
#define REG_SC_BK79_2E_L      _PK_L_(0x79, 0x2E)
#define REG_SC_BK79_2E_H      _PK_H_(0x79, 0x2E)
#define REG_SC_BK79_2F_L      _PK_L_(0x79, 0x2F)
#define REG_SC_BK79_2F_H      _PK_H_(0x79, 0x2F)
#define REG_SC_BK79_30_L      _PK_L_(0x79, 0x30)
#define REG_SC_BK79_30_H      _PK_H_(0x79, 0x30)
#define REG_SC_BK79_31_L      _PK_L_(0x79, 0x31)
#define REG_SC_BK79_31_H      _PK_H_(0x79, 0x31)
#define REG_SC_BK79_32_L      _PK_L_(0x79, 0x32)
#define REG_SC_BK79_32_H      _PK_H_(0x79, 0x32)
#define REG_SC_BK79_33_L      _PK_L_(0x79, 0x33)
#define REG_SC_BK79_33_H      _PK_H_(0x79, 0x33)
#define REG_SC_BK79_34_L      _PK_L_(0x79, 0x34)
#define REG_SC_BK79_34_H      _PK_H_(0x79, 0x34)
#define REG_SC_BK79_35_L      _PK_L_(0x79, 0x35)
#define REG_SC_BK79_35_H      _PK_H_(0x79, 0x35)
#define REG_SC_BK79_36_L      _PK_L_(0x79, 0x36)
#define REG_SC_BK79_36_H      _PK_H_(0x79, 0x36)
#define REG_SC_BK79_37_L      _PK_L_(0x79, 0x37)
#define REG_SC_BK79_37_H      _PK_H_(0x79, 0x37)
#define REG_SC_BK79_38_L      _PK_L_(0x79, 0x38)
#define REG_SC_BK79_38_H      _PK_H_(0x79, 0x38)
#define REG_SC_BK79_39_L      _PK_L_(0x79, 0x39)
#define REG_SC_BK79_39_H      _PK_H_(0x79, 0x39)
#define REG_SC_BK79_3A_L      _PK_L_(0x79, 0x3A)
#define REG_SC_BK79_3A_H      _PK_H_(0x79, 0x3A)
#define REG_SC_BK79_3B_L      _PK_L_(0x79, 0x3B)
#define REG_SC_BK79_3B_H      _PK_H_(0x79, 0x3B)
#define REG_SC_BK79_3C_L      _PK_L_(0x79, 0x3C)
#define REG_SC_BK79_3C_H      _PK_H_(0x79, 0x3C)
#define REG_SC_BK79_3D_L      _PK_L_(0x79, 0x3D)
#define REG_SC_BK79_3D_H      _PK_H_(0x79, 0x3D)
#define REG_SC_BK79_3E_L      _PK_L_(0x79, 0x3E)
#define REG_SC_BK79_3E_H      _PK_H_(0x79, 0x3E)
#define REG_SC_BK79_3F_L      _PK_L_(0x79, 0x3F)
#define REG_SC_BK79_3F_H      _PK_H_(0x79, 0x3F)
#define REG_SC_BK79_40_L      _PK_L_(0x79, 0x40)
#define REG_SC_BK79_40_H      _PK_H_(0x79, 0x40)
#define REG_SC_BK79_41_L      _PK_L_(0x79, 0x41)
#define REG_SC_BK79_41_H      _PK_H_(0x79, 0x41)
#define REG_SC_BK79_42_L      _PK_L_(0x79, 0x42)
#define REG_SC_BK79_42_H      _PK_H_(0x79, 0x42)
#define REG_SC_BK79_43_L      _PK_L_(0x79, 0x43)
#define REG_SC_BK79_43_H      _PK_H_(0x79, 0x43)
#define REG_SC_BK79_44_L      _PK_L_(0x79, 0x44)
#define REG_SC_BK79_44_H      _PK_H_(0x79, 0x44)
#define REG_SC_BK79_45_L      _PK_L_(0x79, 0x45)
#define REG_SC_BK79_45_H      _PK_H_(0x79, 0x45)
#define REG_SC_BK79_46_L      _PK_L_(0x79, 0x46)
#define REG_SC_BK79_46_H      _PK_H_(0x79, 0x46)
#define REG_SC_BK79_47_L      _PK_L_(0x79, 0x47)
#define REG_SC_BK79_47_H      _PK_H_(0x79, 0x47)
#define REG_SC_BK79_48_L      _PK_L_(0x79, 0x48)
#define REG_SC_BK79_48_H      _PK_H_(0x79, 0x48)
#define REG_SC_BK79_49_L      _PK_L_(0x79, 0x49)
#define REG_SC_BK79_49_H      _PK_H_(0x79, 0x49)
#define REG_SC_BK79_4A_L      _PK_L_(0x79, 0x4A)
#define REG_SC_BK79_4A_H      _PK_H_(0x79, 0x4A)
#define REG_SC_BK79_4B_L      _PK_L_(0x79, 0x4B)
#define REG_SC_BK79_4B_H      _PK_H_(0x79, 0x4B)
#define REG_SC_BK79_4C_L      _PK_L_(0x79, 0x4C)
#define REG_SC_BK79_4C_H      _PK_H_(0x79, 0x4C)
#define REG_SC_BK79_4D_L      _PK_L_(0x79, 0x4D)
#define REG_SC_BK79_4D_H      _PK_H_(0x79, 0x4D)
#define REG_SC_BK79_4E_L      _PK_L_(0x79, 0x4E)
#define REG_SC_BK79_4E_H      _PK_H_(0x79, 0x4E)
#define REG_SC_BK79_4F_L      _PK_L_(0x79, 0x4F)
#define REG_SC_BK79_4F_H      _PK_H_(0x79, 0x4F)
#define REG_SC_BK79_50_L      _PK_L_(0x79, 0x50)
#define REG_SC_BK79_50_H      _PK_H_(0x79, 0x50)
#define REG_SC_BK79_51_L      _PK_L_(0x79, 0x51)
#define REG_SC_BK79_51_H      _PK_H_(0x79, 0x51)
#define REG_SC_BK79_52_L      _PK_L_(0x79, 0x52)
#define REG_SC_BK79_52_H      _PK_H_(0x79, 0x52)
#define REG_SC_BK79_53_L      _PK_L_(0x79, 0x53)
#define REG_SC_BK79_53_H      _PK_H_(0x79, 0x53)
#define REG_SC_BK79_54_L      _PK_L_(0x79, 0x54)
#define REG_SC_BK79_54_H      _PK_H_(0x79, 0x54)
#define REG_SC_BK79_55_L      _PK_L_(0x79, 0x55)
#define REG_SC_BK79_55_H      _PK_H_(0x79, 0x55)
#define REG_SC_BK79_56_L      _PK_L_(0x79, 0x56)
#define REG_SC_BK79_56_H      _PK_H_(0x79, 0x56)
#define REG_SC_BK79_57_L      _PK_L_(0x79, 0x57)
#define REG_SC_BK79_57_H      _PK_H_(0x79, 0x57)
#define REG_SC_BK79_58_L      _PK_L_(0x79, 0x58)
#define REG_SC_BK79_58_H      _PK_H_(0x79, 0x58)
#define REG_SC_BK79_59_L      _PK_L_(0x79, 0x59)
#define REG_SC_BK79_59_H      _PK_H_(0x79, 0x59)
#define REG_SC_BK79_5A_L      _PK_L_(0x79, 0x5A)
#define REG_SC_BK79_5A_H      _PK_H_(0x79, 0x5A)
#define REG_SC_BK79_5B_L      _PK_L_(0x79, 0x5B)
#define REG_SC_BK79_5B_H      _PK_H_(0x79, 0x5B)
#define REG_SC_BK79_5C_L      _PK_L_(0x79, 0x5C)
#define REG_SC_BK79_5C_H      _PK_H_(0x79, 0x5C)
#define REG_SC_BK79_5D_L      _PK_L_(0x79, 0x5D)
#define REG_SC_BK79_5D_H      _PK_H_(0x79, 0x5D)
#define REG_SC_BK79_5E_L      _PK_L_(0x79, 0x5E)
#define REG_SC_BK79_5E_H      _PK_H_(0x79, 0x5E)
#define REG_SC_BK79_5F_L      _PK_L_(0x79, 0x5F)
#define REG_SC_BK79_5F_H      _PK_H_(0x79, 0x5F)
#define REG_SC_BK79_60_L      _PK_L_(0x79, 0x60)
#define REG_SC_BK79_60_H      _PK_H_(0x79, 0x60)
#define REG_SC_BK79_61_L      _PK_L_(0x79, 0x61)
#define REG_SC_BK79_61_H      _PK_H_(0x79, 0x61)
#define REG_SC_BK79_62_L      _PK_L_(0x79, 0x62)
#define REG_SC_BK79_62_H      _PK_H_(0x79, 0x62)
#define REG_SC_BK79_63_L      _PK_L_(0x79, 0x63)
#define REG_SC_BK79_63_H      _PK_H_(0x79, 0x63)
#define REG_SC_BK79_64_L      _PK_L_(0x79, 0x64)
#define REG_SC_BK79_64_H      _PK_H_(0x79, 0x64)
#define REG_SC_BK79_65_L      _PK_L_(0x79, 0x65)
#define REG_SC_BK79_65_H      _PK_H_(0x79, 0x65)
#define REG_SC_BK79_66_L      _PK_L_(0x79, 0x66)
#define REG_SC_BK79_66_H      _PK_H_(0x79, 0x66)
#define REG_SC_BK79_67_L      _PK_L_(0x79, 0x67)
#define REG_SC_BK79_67_H      _PK_H_(0x79, 0x67)
#define REG_SC_BK79_68_L      _PK_L_(0x79, 0x68)
#define REG_SC_BK79_68_H      _PK_H_(0x79, 0x68)
#define REG_SC_BK79_69_L      _PK_L_(0x79, 0x69)
#define REG_SC_BK79_69_H      _PK_H_(0x79, 0x69)
#define REG_SC_BK79_6A_L      _PK_L_(0x79, 0x6A)
#define REG_SC_BK79_6A_H      _PK_H_(0x79, 0x6A)
#define REG_SC_BK79_6B_L      _PK_L_(0x79, 0x6B)
#define REG_SC_BK79_6B_H      _PK_H_(0x79, 0x6B)
#define REG_SC_BK79_6C_L      _PK_L_(0x79, 0x6C)
#define REG_SC_BK79_6C_H      _PK_H_(0x79, 0x6C)
#define REG_SC_BK79_6D_L      _PK_L_(0x79, 0x6D)
#define REG_SC_BK79_6D_H      _PK_H_(0x79, 0x6D)
#define REG_SC_BK79_6E_L      _PK_L_(0x79, 0x6E)
#define REG_SC_BK79_6E_H      _PK_H_(0x79, 0x6E)
#define REG_SC_BK79_6F_L      _PK_L_(0x79, 0x6F)
#define REG_SC_BK79_6F_H      _PK_H_(0x79, 0x6F)
#define REG_SC_BK79_70_L      _PK_L_(0x79, 0x70)
#define REG_SC_BK79_70_H      _PK_H_(0x79, 0x70)
#define REG_SC_BK79_71_L      _PK_L_(0x79, 0x71)
#define REG_SC_BK79_71_H      _PK_H_(0x79, 0x71)
#define REG_SC_BK79_72_L      _PK_L_(0x79, 0x72)
#define REG_SC_BK79_72_H      _PK_H_(0x79, 0x72)
#define REG_SC_BK79_73_L      _PK_L_(0x79, 0x73)
#define REG_SC_BK79_73_H      _PK_H_(0x79, 0x73)
#define REG_SC_BK79_74_L      _PK_L_(0x79, 0x74)
#define REG_SC_BK79_74_H      _PK_H_(0x79, 0x74)
#define REG_SC_BK79_75_L      _PK_L_(0x79, 0x75)
#define REG_SC_BK79_75_H      _PK_H_(0x79, 0x75)
#define REG_SC_BK79_76_L      _PK_L_(0x79, 0x76)
#define REG_SC_BK79_76_H      _PK_H_(0x79, 0x76)
#define REG_SC_BK79_77_L      _PK_L_(0x79, 0x77)
#define REG_SC_BK79_77_H      _PK_H_(0x79, 0x77)
#define REG_SC_BK79_78_L      _PK_L_(0x79, 0x78)
#define REG_SC_BK79_78_H      _PK_H_(0x79, 0x78)
#define REG_SC_BK79_79_L      _PK_L_(0x79, 0x79)
#define REG_SC_BK79_79_H      _PK_H_(0x79, 0x79)
#define REG_SC_BK79_7A_L      _PK_L_(0x79, 0x7A)
#define REG_SC_BK79_7A_H      _PK_H_(0x79, 0x7A)
#define REG_SC_BK79_7B_L      _PK_L_(0x79, 0x7B)
#define REG_SC_BK79_7B_H      _PK_H_(0x79, 0x7B)
#define REG_SC_BK79_7C_L      _PK_L_(0x79, 0x7C)
#define REG_SC_BK79_7C_H      _PK_H_(0x79, 0x7C)
#define REG_SC_BK79_7D_L      _PK_L_(0x79, 0x7D)
#define REG_SC_BK79_7D_H      _PK_H_(0x79, 0x7D)
#define REG_SC_BK79_7E_L      _PK_L_(0x79, 0x7E)
#define REG_SC_BK79_7E_H      _PK_H_(0x79, 0x7E)
#define REG_SC_BK79_7F_L      _PK_L_(0x79, 0x7F)

//----------------------------------------------
//  BK7a:
//----------------------------------------------
#define REG_SC_BK7A_01_L      _PK_L_(0x7A, 0x01)
#define REG_SC_BK7A_01_H      _PK_H_(0x7A, 0x01)
#define REG_SC_BK7A_02_L      _PK_L_(0x7A, 0x02)
#define REG_SC_BK7A_02_H      _PK_H_(0x7A, 0x02)
#define REG_SC_BK7A_42_L      _PK_L_(0x7A, 0x42)
#define REG_SC_BK7A_42_H      _PK_H_(0x7A, 0x42)
#define REG_SC_BK7A_54_L      _PK_L_(0x7A, 0x54)
#define REG_SC_BK7A_54_H      _PK_H_(0x7A, 0x54)
#define REG_SC_BK7A_55_L      _PK_L_(0x7A, 0x55)
#define REG_SC_BK7A_55_H      _PK_H_(0x7A, 0x55)
#define REG_SC_BK7A_59_L      _PK_L_(0x7A, 0x59)
#define REG_SC_BK7A_59_H      _PK_H_(0x7A, 0x59)

//----------------------------------------------
//  BK7f:
//----------------------------------------------
#define REG_SC_BK7F_00_L      _PK_L_(0x7F, 0x00)
#define REG_SC_BK7F_00_H      _PK_H_(0x7F, 0x00)
#define REG_SC_BK7F_01_L      _PK_L_(0x7F, 0x01)
#define REG_SC_BK7F_01_H      _PK_H_(0x7F, 0x01)
#define REG_SC_BK7F_02_L      _PK_L_(0x7F, 0x02)
#define REG_SC_BK7F_02_H      _PK_H_(0x7F, 0x02)
#define REG_SC_BK7F_03_L      _PK_L_(0x7F, 0x03)
#define REG_SC_BK7F_03_H      _PK_H_(0x7F, 0x03)
#define REG_SC_BK7F_04_L      _PK_L_(0x7F, 0x04)
#define REG_SC_BK7F_04_H      _PK_H_(0x7F, 0x04)
#define REG_SC_BK7F_05_L      _PK_L_(0x7F, 0x05)
#define REG_SC_BK7F_05_H      _PK_H_(0x7F, 0x05)
#define REG_SC_BK7F_06_L      _PK_L_(0x7F, 0x06)
#define REG_SC_BK7F_06_H      _PK_H_(0x7F, 0x06)
#define REG_SC_BK7F_07_L      _PK_L_(0x7F, 0x07)
#define REG_SC_BK7F_07_H      _PK_H_(0x7F, 0x07)
#define REG_SC_BK7F_08_L      _PK_L_(0x7F, 0x08)
#define REG_SC_BK7F_08_H      _PK_H_(0x7F, 0x08)
#define REG_SC_BK7F_09_L      _PK_L_(0x7F, 0x09)
#define REG_SC_BK7F_09_H      _PK_H_(0x7F, 0x09)
#define REG_SC_BK7F_0A_L      _PK_L_(0x7F, 0x0A)
#define REG_SC_BK7F_0A_H      _PK_H_(0x7F, 0x0A)
#define REG_SC_BK7F_0B_L      _PK_L_(0x7F, 0x0B)
#define REG_SC_BK7F_0B_H      _PK_H_(0x7F, 0x0B)
#define REG_SC_BK7F_0C_L      _PK_L_(0x7F, 0x0C)
#define REG_SC_BK7F_0C_H      _PK_H_(0x7F, 0x0C)
#define REG_SC_BK7F_0D_L      _PK_L_(0x7F, 0x0D)
#define REG_SC_BK7F_0D_H      _PK_H_(0x7F, 0x0D)
#define REG_SC_BK7F_0E_L      _PK_L_(0x7F, 0x0E)
#define REG_SC_BK7F_0E_H      _PK_H_(0x7F, 0x0E)
#define REG_SC_BK7F_0F_L      _PK_L_(0x7F, 0x0F)
#define REG_SC_BK7F_0F_H      _PK_H_(0x7F, 0x0F)
#define REG_SC_BK7F_10_L      _PK_L_(0x7F, 0x10)
#define REG_SC_BK7F_10_H      _PK_H_(0x7F, 0x10)
#define REG_SC_BK7F_11_L      _PK_L_(0x7F, 0x11)
#define REG_SC_BK7F_11_H      _PK_H_(0x7F, 0x11)
#define REG_SC_BK7F_12_L      _PK_L_(0x7F, 0x12)
#define REG_SC_BK7F_12_H      _PK_H_(0x7F, 0x12)
#define REG_SC_BK7F_13_L      _PK_L_(0x7F, 0x13)
#define REG_SC_BK7F_13_H      _PK_H_(0x7F, 0x13)
#define REG_SC_BK7F_14_L      _PK_L_(0x7F, 0x14)
#define REG_SC_BK7F_14_H      _PK_H_(0x7F, 0x14)
#define REG_SC_BK7F_15_L      _PK_L_(0x7F, 0x15)
#define REG_SC_BK7F_15_H      _PK_H_(0x7F, 0x15)
#define REG_SC_BK7F_16_L      _PK_L_(0x7F, 0x16)
#define REG_SC_BK7F_16_H      _PK_H_(0x7F, 0x16)
#define REG_SC_BK7F_17_L      _PK_L_(0x7F, 0x17)
#define REG_SC_BK7F_17_H      _PK_H_(0x7F, 0x17)
#define REG_SC_BK7F_18_L      _PK_L_(0x7F, 0x18)
#define REG_SC_BK7F_18_H      _PK_H_(0x7F, 0x18)
#define REG_SC_BK7F_19_L      _PK_L_(0x7F, 0x19)
#define REG_SC_BK7F_19_H      _PK_H_(0x7F, 0x19)
#define REG_SC_BK7F_1A_L      _PK_L_(0x7F, 0x1A)
#define REG_SC_BK7F_1A_H      _PK_H_(0x7F, 0x1A)
#define REG_SC_BK7F_1B_L      _PK_L_(0x7F, 0x1B)
#define REG_SC_BK7F_1B_H      _PK_H_(0x7F, 0x1B)
#define REG_SC_BK7F_1C_L      _PK_L_(0x7F, 0x1C)
#define REG_SC_BK7F_1C_H      _PK_H_(0x7F, 0x1C)
#define REG_SC_BK7F_1D_L      _PK_L_(0x7F, 0x1D)
#define REG_SC_BK7F_1D_H      _PK_H_(0x7F, 0x1D)
#define REG_SC_BK7F_1E_L      _PK_L_(0x7F, 0x1E)
#define REG_SC_BK7F_1E_H      _PK_H_(0x7F, 0x1E)
#define REG_SC_BK7F_1F_L      _PK_L_(0x7F, 0x1F)
#define REG_SC_BK7F_1F_H      _PK_H_(0x7F, 0x1F)
#define REG_SC_BK7F_20_L      _PK_L_(0x7F, 0x20)
#define REG_SC_BK7F_20_H      _PK_H_(0x7F, 0x20)
#define REG_SC_BK7F_21_L      _PK_L_(0x7F, 0x21)
#define REG_SC_BK7F_21_H      _PK_H_(0x7F, 0x21)
#define REG_SC_BK7F_22_L      _PK_L_(0x7F, 0x22)
#define REG_SC_BK7F_22_H      _PK_H_(0x7F, 0x22)
#define REG_SC_BK7F_23_L      _PK_L_(0x7F, 0x23)
#define REG_SC_BK7F_23_H      _PK_H_(0x7F, 0x23)
#define REG_SC_BK7F_24_L      _PK_L_(0x7F, 0x24)
#define REG_SC_BK7F_24_H      _PK_H_(0x7F, 0x24)
#define REG_SC_BK7F_25_L      _PK_L_(0x7F, 0x25)
#define REG_SC_BK7F_25_H      _PK_H_(0x7F, 0x25)
#define REG_SC_BK7F_26_L      _PK_L_(0x7F, 0x26)
#define REG_SC_BK7F_26_H      _PK_H_(0x7F, 0x26)
#define REG_SC_BK7F_27_L      _PK_L_(0x7F, 0x27)
#define REG_SC_BK7F_27_H      _PK_H_(0x7F, 0x27)
#define REG_SC_BK7F_28_L      _PK_L_(0x7F, 0x28)
#define REG_SC_BK7F_28_H      _PK_H_(0x7F, 0x28)
#define REG_SC_BK7F_29_L      _PK_L_(0x7F, 0x29)
#define REG_SC_BK7F_29_H      _PK_H_(0x7F, 0x29)
#define REG_SC_BK7F_2A_L      _PK_L_(0x7F, 0x2A)
#define REG_SC_BK7F_2A_H      _PK_H_(0x7F, 0x2A)
#define REG_SC_BK7F_2B_L      _PK_L_(0x7F, 0x2B)
#define REG_SC_BK7F_2B_H      _PK_H_(0x7F, 0x2B)
#define REG_SC_BK7F_2C_L      _PK_L_(0x7F, 0x2C)
#define REG_SC_BK7F_2C_H      _PK_H_(0x7F, 0x2C)
#define REG_SC_BK7F_2D_L      _PK_L_(0x7F, 0x2D)
#define REG_SC_BK7F_2D_H      _PK_H_(0x7F, 0x2D)
#define REG_SC_BK7F_2E_L      _PK_L_(0x7F, 0x2E)
#define REG_SC_BK7F_2E_H      _PK_H_(0x7F, 0x2E)
#define REG_SC_BK7F_2F_L      _PK_L_(0x7F, 0x2F)
#define REG_SC_BK7F_2F_H      _PK_H_(0x7F, 0x2F)
#define REG_SC_BK7F_30_L      _PK_L_(0x7F, 0x30)
#define REG_SC_BK7F_30_H      _PK_H_(0x7F, 0x30)
#define REG_SC_BK7F_31_L      _PK_L_(0x7F, 0x31)
#define REG_SC_BK7F_31_H      _PK_H_(0x7F, 0x31)
#define REG_SC_BK7F_32_L      _PK_L_(0x7F, 0x32)
#define REG_SC_BK7F_32_H      _PK_H_(0x7F, 0x32)
#define REG_SC_BK7F_33_L      _PK_L_(0x7F, 0x33)
#define REG_SC_BK7F_33_H      _PK_H_(0x7F, 0x33)
#define REG_SC_BK7F_34_L      _PK_L_(0x7F, 0x34)
#define REG_SC_BK7F_34_H      _PK_H_(0x7F, 0x34)
#define REG_SC_BK7F_35_L      _PK_L_(0x7F, 0x35)
#define REG_SC_BK7F_35_H      _PK_H_(0x7F, 0x35)
#define REG_SC_BK7F_36_L      _PK_L_(0x7F, 0x36)
#define REG_SC_BK7F_36_H      _PK_H_(0x7F, 0x36)
#define REG_SC_BK7F_37_L      _PK_L_(0x7F, 0x37)
#define REG_SC_BK7F_37_H      _PK_H_(0x7F, 0x37)
#define REG_SC_BK7F_38_L      _PK_L_(0x7F, 0x38)
#define REG_SC_BK7F_38_H      _PK_H_(0x7F, 0x38)
#define REG_SC_BK7F_39_L      _PK_L_(0x7F, 0x39)
#define REG_SC_BK7F_39_H      _PK_H_(0x7F, 0x39)
#define REG_SC_BK7F_3A_L      _PK_L_(0x7F, 0x3A)
#define REG_SC_BK7F_3A_H      _PK_H_(0x7F, 0x3A)
#define REG_SC_BK7F_3B_L      _PK_L_(0x7F, 0x3B)
#define REG_SC_BK7F_3B_H      _PK_H_(0x7F, 0x3B)
#define REG_SC_BK7F_3C_L      _PK_L_(0x7F, 0x3C)
#define REG_SC_BK7F_3C_H      _PK_H_(0x7F, 0x3C)
#define REG_SC_BK7F_3D_L      _PK_L_(0x7F, 0x3D)
#define REG_SC_BK7F_3D_H      _PK_H_(0x7F, 0x3D)
#define REG_SC_BK7F_3E_L      _PK_L_(0x7F, 0x3E)
#define REG_SC_BK7F_3E_H      _PK_H_(0x7F, 0x3E)
#define REG_SC_BK7F_3F_L      _PK_L_(0x7F, 0x3F)
#define REG_SC_BK7F_3F_H      _PK_H_(0x7F, 0x3F)
#define REG_SC_BK7F_40_L      _PK_L_(0x7F, 0x40)
#define REG_SC_BK7F_40_H      _PK_H_(0x7F, 0x40)
#define REG_SC_BK7F_41_L      _PK_L_(0x7F, 0x41)
#define REG_SC_BK7F_41_H      _PK_H_(0x7F, 0x41)
#define REG_SC_BK7F_42_L      _PK_L_(0x7F, 0x42)
#define REG_SC_BK7F_42_H      _PK_H_(0x7F, 0x42)
#define REG_SC_BK7F_43_L      _PK_L_(0x7F, 0x43)
#define REG_SC_BK7F_43_H      _PK_H_(0x7F, 0x43)
#define REG_SC_BK7F_44_L      _PK_L_(0x7F, 0x44)
#define REG_SC_BK7F_44_H      _PK_H_(0x7F, 0x44)
#define REG_SC_BK7F_45_L      _PK_L_(0x7F, 0x45)
#define REG_SC_BK7F_45_H      _PK_H_(0x7F, 0x45)
#define REG_SC_BK7F_46_L      _PK_L_(0x7F, 0x46)
#define REG_SC_BK7F_46_H      _PK_H_(0x7F, 0x46)
#define REG_SC_BK7F_47_L      _PK_L_(0x7F, 0x47)
#define REG_SC_BK7F_47_H      _PK_H_(0x7F, 0x47)
#define REG_SC_BK7F_48_L      _PK_L_(0x7F, 0x48)
#define REG_SC_BK7F_48_H      _PK_H_(0x7F, 0x48)
#define REG_SC_BK7F_49_L      _PK_L_(0x7F, 0x49)
#define REG_SC_BK7F_49_H      _PK_H_(0x7F, 0x49)
#define REG_SC_BK7F_4A_L      _PK_L_(0x7F, 0x4A)
#define REG_SC_BK7F_4A_H      _PK_H_(0x7F, 0x4A)
#define REG_SC_BK7F_4B_L      _PK_L_(0x7F, 0x4B)
#define REG_SC_BK7F_4B_H      _PK_H_(0x7F, 0x4B)
#define REG_SC_BK7F_4C_L      _PK_L_(0x7F, 0x4C)
#define REG_SC_BK7F_4C_H      _PK_H_(0x7F, 0x4C)
#define REG_SC_BK7F_4D_L      _PK_L_(0x7F, 0x4D)
#define REG_SC_BK7F_4D_H      _PK_H_(0x7F, 0x4D)
#define REG_SC_BK7F_4E_L      _PK_L_(0x7F, 0x4E)
#define REG_SC_BK7F_4E_H      _PK_H_(0x7F, 0x4E)
#define REG_SC_BK7F_4F_L      _PK_L_(0x7F, 0x4F)
#define REG_SC_BK7F_4F_H      _PK_H_(0x7F, 0x4F)
#define REG_SC_BK7F_50_L      _PK_L_(0x7F, 0x50)
#define REG_SC_BK7F_50_H      _PK_H_(0x7F, 0x50)
#define REG_SC_BK7F_51_L      _PK_L_(0x7F, 0x51)
#define REG_SC_BK7F_51_H      _PK_H_(0x7F, 0x51)
#define REG_SC_BK7F_52_L      _PK_L_(0x7F, 0x52)
#define REG_SC_BK7F_52_H      _PK_H_(0x7F, 0x52)
#define REG_SC_BK7F_53_L      _PK_L_(0x7F, 0x53)
#define REG_SC_BK7F_53_H      _PK_H_(0x7F, 0x53)
#define REG_SC_BK7F_54_L      _PK_L_(0x7F, 0x54)
#define REG_SC_BK7F_54_H      _PK_H_(0x7F, 0x54)
#define REG_SC_BK7F_55_L      _PK_L_(0x7F, 0x55)
#define REG_SC_BK7F_55_H      _PK_H_(0x7F, 0x55)
#define REG_SC_BK7F_56_L      _PK_L_(0x7F, 0x56)
#define REG_SC_BK7F_56_H      _PK_H_(0x7F, 0x56)
#define REG_SC_BK7F_57_L      _PK_L_(0x7F, 0x57)
#define REG_SC_BK7F_57_H      _PK_H_(0x7F, 0x57)
#define REG_SC_BK7F_58_L      _PK_L_(0x7F, 0x58)
#define REG_SC_BK7F_58_H      _PK_H_(0x7F, 0x58)
#define REG_SC_BK7F_59_L      _PK_L_(0x7F, 0x59)
#define REG_SC_BK7F_59_H      _PK_H_(0x7F, 0x59)
#define REG_SC_BK7F_5A_L      _PK_L_(0x7F, 0x5A)
#define REG_SC_BK7F_5A_H      _PK_H_(0x7F, 0x5A)
#define REG_SC_BK7F_5B_L      _PK_L_(0x7F, 0x5B)
#define REG_SC_BK7F_5B_H      _PK_H_(0x7F, 0x5B)
#define REG_SC_BK7F_5C_L      _PK_L_(0x7F, 0x5C)
#define REG_SC_BK7F_5C_H      _PK_H_(0x7F, 0x5C)
#define REG_SC_BK7F_5D_L      _PK_L_(0x7F, 0x5D)
#define REG_SC_BK7F_5D_H      _PK_H_(0x7F, 0x5D)
#define REG_SC_BK7F_5E_L      _PK_L_(0x7F, 0x5E)
#define REG_SC_BK7F_5E_H      _PK_H_(0x7F, 0x5E)
#define REG_SC_BK7F_5F_L      _PK_L_(0x7F, 0x5F)
#define REG_SC_BK7F_5F_H      _PK_H_(0x7F, 0x5F)
#define REG_SC_BK7F_60_L      _PK_L_(0x7F, 0x60)
#define REG_SC_BK7F_60_H      _PK_H_(0x7F, 0x60)
#define REG_SC_BK7F_61_L      _PK_L_(0x7F, 0x61)
#define REG_SC_BK7F_61_H      _PK_H_(0x7F, 0x61)
#define REG_SC_BK7F_62_L      _PK_L_(0x7F, 0x62)
#define REG_SC_BK7F_62_H      _PK_H_(0x7F, 0x62)
#define REG_SC_BK7F_63_L      _PK_L_(0x7F, 0x63)
#define REG_SC_BK7F_63_H      _PK_H_(0x7F, 0x63)
#define REG_SC_BK7F_64_L      _PK_L_(0x7F, 0x64)
#define REG_SC_BK7F_64_H      _PK_H_(0x7F, 0x64)
#define REG_SC_BK7F_65_L      _PK_L_(0x7F, 0x65)
#define REG_SC_BK7F_65_H      _PK_H_(0x7F, 0x65)
#define REG_SC_BK7F_66_L      _PK_L_(0x7F, 0x66)
#define REG_SC_BK7F_66_H      _PK_H_(0x7F, 0x66)
#define REG_SC_BK7F_67_L      _PK_L_(0x7F, 0x67)
#define REG_SC_BK7F_67_H      _PK_H_(0x7F, 0x67)
#define REG_SC_BK7F_68_L      _PK_L_(0x7F, 0x68)
#define REG_SC_BK7F_68_H      _PK_H_(0x7F, 0x68)
#define REG_SC_BK7F_69_L      _PK_L_(0x7F, 0x69)
#define REG_SC_BK7F_69_H      _PK_H_(0x7F, 0x69)
#define REG_SC_BK7F_6A_L      _PK_L_(0x7F, 0x6A)
#define REG_SC_BK7F_6A_H      _PK_H_(0x7F, 0x6A)
#define REG_SC_BK7F_6B_L      _PK_L_(0x7F, 0x6B)
#define REG_SC_BK7F_6B_H      _PK_H_(0x7F, 0x6B)
#define REG_SC_BK7F_6C_L      _PK_L_(0x7F, 0x6C)
#define REG_SC_BK7F_6C_H      _PK_H_(0x7F, 0x6C)
#define REG_SC_BK7F_6D_L      _PK_L_(0x7F, 0x6D)
#define REG_SC_BK7F_6D_H      _PK_H_(0x7F, 0x6D)
#define REG_SC_BK7F_6E_L      _PK_L_(0x7F, 0x6E)
#define REG_SC_BK7F_6E_H      _PK_H_(0x7F, 0x6E)
#define REG_SC_BK7F_6F_L      _PK_L_(0x7F, 0x6F)
#define REG_SC_BK7F_6F_H      _PK_H_(0x7F, 0x6F)
#define REG_SC_BK7F_70_L      _PK_L_(0x7F, 0x70)
#define REG_SC_BK7F_70_H      _PK_H_(0x7F, 0x70)
#define REG_SC_BK7F_71_L      _PK_L_(0x7F, 0x71)
#define REG_SC_BK7F_71_H      _PK_H_(0x7F, 0x71)
#define REG_SC_BK7F_72_L      _PK_L_(0x7F, 0x72)
#define REG_SC_BK7F_72_H      _PK_H_(0x7F, 0x72)
#define REG_SC_BK7F_73_L      _PK_L_(0x7F, 0x73)
#define REG_SC_BK7F_73_H      _PK_H_(0x7F, 0x73)
#define REG_SC_BK7F_74_L      _PK_L_(0x7F, 0x74)
#define REG_SC_BK7F_74_H      _PK_H_(0x7F, 0x74)
#define REG_SC_BK7F_75_L      _PK_L_(0x7F, 0x75)
#define REG_SC_BK7F_75_H      _PK_H_(0x7F, 0x75)
#define REG_SC_BK7F_76_L      _PK_L_(0x7F, 0x76)
#define REG_SC_BK7F_76_H      _PK_H_(0x7F, 0x76)
#define REG_SC_BK7F_77_L      _PK_L_(0x7F, 0x77)
#define REG_SC_BK7F_77_H      _PK_H_(0x7F, 0x77)
#define REG_SC_BK7F_78_L      _PK_L_(0x7F, 0x78)
#define REG_SC_BK7F_78_H      _PK_H_(0x7F, 0x78)
#define REG_SC_BK7F_79_L      _PK_L_(0x7F, 0x79)
#define REG_SC_BK7F_79_H      _PK_H_(0x7F, 0x79)
#define REG_SC_BK7F_7A_L      _PK_L_(0x7F, 0x7A)
#define REG_SC_BK7F_7A_H      _PK_H_(0x7F, 0x7A)
#define REG_SC_BK7F_7B_L      _PK_L_(0x7F, 0x7B)
#define REG_SC_BK7F_7B_H      _PK_H_(0x7F, 0x7B)
#define REG_SC_BK7F_7C_L      _PK_L_(0x7F, 0x7C)
#define REG_SC_BK7F_7C_H      _PK_H_(0x7F, 0x7C)
#define REG_SC_BK7F_7D_L      _PK_L_(0x7F, 0x7D)
#define REG_SC_BK7F_7D_H      _PK_H_(0x7F, 0x7D)
#define REG_SC_BK7F_7E_L      _PK_L_(0x7F, 0x7E)
#define REG_SC_BK7F_7E_H      _PK_H_(0x7F, 0x7E)
#define REG_SC_BK7F_7F_L      _PK_L_(0x7F, 0x7F)

//----------------------------------------------
//  BK80
//----------------------------------------------
#define REG_SC_BK80_00_L      _PK_L_(0x80, 0x00)
#define REG_SC_BK80_00_H      _PK_H_(0x80, 0x00)
#define REG_SC_BK80_01_L      _PK_L_(0x80, 0x01)
#define REG_SC_BK80_01_H      _PK_H_(0x80, 0x01)
#define REG_SC_BK80_02_L      _PK_L_(0x80, 0x02)
#define REG_SC_BK80_02_H      _PK_H_(0x80, 0x02)
#define REG_SC_BK80_03_L      _PK_L_(0x80, 0x03)
#define REG_SC_BK80_03_H      _PK_H_(0x80, 0x03)
#define REG_SC_BK80_04_L      _PK_L_(0x80, 0x04)
#define REG_SC_BK80_04_H      _PK_H_(0x80, 0x04)
#define REG_SC_BK80_05_L      _PK_L_(0x80, 0x05)
#define REG_SC_BK80_05_H      _PK_H_(0x80, 0x05)
#define REG_SC_BK80_06_L      _PK_L_(0x80, 0x06)
#define REG_SC_BK80_06_H      _PK_H_(0x80, 0x06)
#define REG_SC_BK80_07_L      _PK_L_(0x80, 0x07)
#define REG_SC_BK80_07_H      _PK_H_(0x80, 0x07)
#define REG_SC_BK80_08_L      _PK_L_(0x80, 0x08)
#define REG_SC_BK80_08_H      _PK_H_(0x80, 0x08)
#define REG_SC_BK80_09_L      _PK_L_(0x80, 0x09)
#define REG_SC_BK80_09_H      _PK_H_(0x80, 0x09)
#define REG_SC_BK80_0A_L      _PK_L_(0x80, 0x0A)
#define REG_SC_BK80_0A_H      _PK_H_(0x80, 0x0A)
#define REG_SC_BK80_0B_L      _PK_L_(0x80, 0x0B)
#define REG_SC_BK80_0B_H      _PK_H_(0x80, 0x0B)
#define REG_SC_BK80_0C_L      _PK_L_(0x80, 0x0C)
#define REG_SC_BK80_0C_H      _PK_H_(0x80, 0x0C)
#define REG_SC_BK80_0D_L      _PK_L_(0x80, 0x0D)
#define REG_SC_BK80_0D_H      _PK_H_(0x80, 0x0D)
#define REG_SC_BK80_0E_L      _PK_L_(0x80, 0x0E)
#define REG_SC_BK80_0E_H      _PK_H_(0x80, 0x0E)
#define REG_SC_BK80_0F_L      _PK_L_(0x80, 0x0F)
#define REG_SC_BK80_0F_H      _PK_H_(0x80, 0x0F)
#define REG_SC_BK80_10_L      _PK_L_(0x80, 0x10)
#define REG_SC_BK80_10_H      _PK_H_(0x80, 0x10)
#define REG_SC_BK80_11_L      _PK_L_(0x80, 0x11)
#define REG_SC_BK80_11_H      _PK_H_(0x80, 0x11)
#define REG_SC_BK80_12_L      _PK_L_(0x80, 0x12)
#define REG_SC_BK80_12_H      _PK_H_(0x80, 0x12)
#define REG_SC_BK80_13_L      _PK_L_(0x80, 0x13)
#define REG_SC_BK80_13_H      _PK_H_(0x80, 0x13)
#define REG_SC_BK80_14_L      _PK_L_(0x80, 0x14)
#define REG_SC_BK80_14_H      _PK_H_(0x80, 0x14)
#define REG_SC_BK80_15_L      _PK_L_(0x80, 0x15)
#define REG_SC_BK80_15_H      _PK_H_(0x80, 0x15)
#define REG_SC_BK80_16_L      _PK_L_(0x80, 0x16)
#define REG_SC_BK80_16_H      _PK_H_(0x80, 0x16)
#define REG_SC_BK80_17_L      _PK_L_(0x80, 0x17)
#define REG_SC_BK80_17_H      _PK_H_(0x80, 0x17)
#define REG_SC_BK80_18_L      _PK_L_(0x80, 0x18)
#define REG_SC_BK80_18_H      _PK_H_(0x80, 0x18)
#define REG_SC_BK80_19_L      _PK_L_(0x80, 0x19)
#define REG_SC_BK80_19_H      _PK_H_(0x80, 0x19)
#define REG_SC_BK80_1A_L      _PK_L_(0x80, 0x1A)
#define REG_SC_BK80_1A_H      _PK_H_(0x80, 0x1A)
#define REG_SC_BK80_1B_L      _PK_L_(0x80, 0x1B)
#define REG_SC_BK80_1B_H      _PK_H_(0x80, 0x1B)
#define REG_SC_BK80_1C_L      _PK_L_(0x80, 0x1C)
#define REG_SC_BK80_1C_H      _PK_H_(0x80, 0x1C)
#define REG_SC_BK80_1D_L      _PK_L_(0x80, 0x1D)
#define REG_SC_BK80_1D_H      _PK_H_(0x80, 0x1D)
#define REG_SC_BK80_1E_L      _PK_L_(0x80, 0x1E)
#define REG_SC_BK80_1E_H      _PK_H_(0x80, 0x1E)
#define REG_SC_BK80_1F_L      _PK_L_(0x80, 0x1F)
#define REG_SC_BK80_1F_H      _PK_H_(0x80, 0x1F)
#define REG_SC_BK80_20_L      _PK_L_(0x80, 0x20)
#define REG_SC_BK80_20_H      _PK_H_(0x80, 0x20)
#define REG_SC_BK80_21_L      _PK_L_(0x80, 0x21)
#define REG_SC_BK80_21_H      _PK_H_(0x80, 0x21)
#define REG_SC_BK80_22_L      _PK_L_(0x80, 0x22)
#define REG_SC_BK80_22_H      _PK_H_(0x80, 0x22)
#define REG_SC_BK80_23_L      _PK_L_(0x80, 0x23)
#define REG_SC_BK80_23_H      _PK_H_(0x80, 0x23)
#define REG_SC_BK80_24_L      _PK_L_(0x80, 0x24)
#define REG_SC_BK80_24_H      _PK_H_(0x80, 0x24)
#define REG_SC_BK80_25_L      _PK_L_(0x80, 0x25)
#define REG_SC_BK80_25_H      _PK_H_(0x80, 0x25)
#define REG_SC_BK80_26_L      _PK_L_(0x80, 0x26)
#define REG_SC_BK80_26_H      _PK_H_(0x80, 0x26)
#define REG_SC_BK80_27_L      _PK_L_(0x80, 0x27)
#define REG_SC_BK80_27_H      _PK_H_(0x80, 0x27)
#define REG_SC_BK80_28_L      _PK_L_(0x80, 0x28)
#define REG_SC_BK80_28_H      _PK_H_(0x80, 0x28)
#define REG_SC_BK80_29_L      _PK_L_(0x80, 0x29)
#define REG_SC_BK80_29_H      _PK_H_(0x80, 0x29)
#define REG_SC_BK80_2A_L      _PK_L_(0x80, 0x2A)
#define REG_SC_BK80_2A_H      _PK_H_(0x80, 0x2A)
#define REG_SC_BK80_2B_L      _PK_L_(0x80, 0x2B)
#define REG_SC_BK80_2B_H      _PK_H_(0x80, 0x2B)
#define REG_SC_BK80_2C_L      _PK_L_(0x80, 0x2C)
#define REG_SC_BK80_2C_H      _PK_H_(0x80, 0x2C)
#define REG_SC_BK80_2D_L      _PK_L_(0x80, 0x2D)
#define REG_SC_BK80_2D_H      _PK_H_(0x80, 0x2D)
#define REG_SC_BK80_2E_L      _PK_L_(0x80, 0x2E)
#define REG_SC_BK80_2E_H      _PK_H_(0x80, 0x2E)
#define REG_SC_BK80_2F_L      _PK_L_(0x80, 0x2F)
#define REG_SC_BK80_2F_H      _PK_H_(0x80, 0x2F)
#define REG_SC_BK80_30_L      _PK_L_(0x80, 0x30)
#define REG_SC_BK80_30_H      _PK_H_(0x80, 0x30)
#define REG_SC_BK80_31_L      _PK_L_(0x80, 0x31)
#define REG_SC_BK80_31_H      _PK_H_(0x80, 0x31)
#define REG_SC_BK80_32_L      _PK_L_(0x80, 0x32)
#define REG_SC_BK80_32_H      _PK_H_(0x80, 0x32)
#define REG_SC_BK80_33_L      _PK_L_(0x80, 0x33)
#define REG_SC_BK80_33_H      _PK_H_(0x80, 0x33)
#define REG_SC_BK80_34_L      _PK_L_(0x80, 0x34)
#define REG_SC_BK80_34_H      _PK_H_(0x80, 0x34)
#define REG_SC_BK80_35_L      _PK_L_(0x80, 0x35)
#define REG_SC_BK80_35_H      _PK_H_(0x80, 0x35)
#define REG_SC_BK80_36_L      _PK_L_(0x80, 0x36)
#define REG_SC_BK80_36_H      _PK_H_(0x80, 0x36)
#define REG_SC_BK80_37_L      _PK_L_(0x80, 0x37)
#define REG_SC_BK80_37_H      _PK_H_(0x80, 0x37)
#define REG_SC_BK80_38_L      _PK_L_(0x80, 0x38)
#define REG_SC_BK80_38_H      _PK_H_(0x80, 0x38)
#define REG_SC_BK80_39_L      _PK_L_(0x80, 0x39)
#define REG_SC_BK80_39_H      _PK_H_(0x80, 0x39)
#define REG_SC_BK80_3A_L      _PK_L_(0x80, 0x3A)
#define REG_SC_BK80_3A_H      _PK_H_(0x80, 0x3A)
#define REG_SC_BK80_3B_L      _PK_L_(0x80, 0x3B)
#define REG_SC_BK80_3B_H      _PK_H_(0x80, 0x3B)
#define REG_SC_BK80_3C_L      _PK_L_(0x80, 0x3C)
#define REG_SC_BK80_3C_H      _PK_H_(0x80, 0x3C)
#define REG_SC_BK80_3D_L      _PK_L_(0x80, 0x3D)
#define REG_SC_BK80_3D_H      _PK_H_(0x80, 0x3D)
#define REG_SC_BK80_3E_L      _PK_L_(0x80, 0x3E)
#define REG_SC_BK80_3E_H      _PK_H_(0x80, 0x3E)
#define REG_SC_BK80_3F_L      _PK_L_(0x80, 0x3F)
#define REG_SC_BK80_3F_H      _PK_H_(0x80, 0x3F)
#define REG_SC_BK80_40_L      _PK_L_(0x80, 0x40)
#define REG_SC_BK80_40_H      _PK_H_(0x80, 0x40)
#define REG_SC_BK80_41_L      _PK_L_(0x80, 0x41)
#define REG_SC_BK80_41_H      _PK_H_(0x80, 0x41)
#define REG_SC_BK80_42_L      _PK_L_(0x80, 0x42)
#define REG_SC_BK80_42_H      _PK_H_(0x80, 0x42)
#define REG_SC_BK80_43_L      _PK_L_(0x80, 0x43)
#define REG_SC_BK80_43_H      _PK_H_(0x80, 0x43)
#define REG_SC_BK80_44_L      _PK_L_(0x80, 0x44)
#define REG_SC_BK80_44_H      _PK_H_(0x80, 0x44)
#define REG_SC_BK80_45_L      _PK_L_(0x80, 0x45)
#define REG_SC_BK80_45_H      _PK_H_(0x80, 0x45)
#define REG_SC_BK80_46_L      _PK_L_(0x80, 0x46)
#define REG_SC_BK80_46_H      _PK_H_(0x80, 0x46)
#define REG_SC_BK80_47_L      _PK_L_(0x80, 0x47)
#define REG_SC_BK80_47_H      _PK_H_(0x80, 0x47)
#define REG_SC_BK80_48_L      _PK_L_(0x80, 0x48)
#define REG_SC_BK80_48_H      _PK_H_(0x80, 0x48)
#define REG_SC_BK80_49_L      _PK_L_(0x80, 0x49)
#define REG_SC_BK80_49_H      _PK_H_(0x80, 0x49)
#define REG_SC_BK80_4A_L      _PK_L_(0x80, 0x4A)
#define REG_SC_BK80_4A_H      _PK_H_(0x80, 0x4A)
#define REG_SC_BK80_4B_L      _PK_L_(0x80, 0x4B)
#define REG_SC_BK80_4B_H      _PK_H_(0x80, 0x4B)
#define REG_SC_BK80_4C_L      _PK_L_(0x80, 0x4C)
#define REG_SC_BK80_4C_H      _PK_H_(0x80, 0x4C)
#define REG_SC_BK80_4D_L      _PK_L_(0x80, 0x4D)
#define REG_SC_BK80_4D_H      _PK_H_(0x80, 0x4D)
#define REG_SC_BK80_4E_L      _PK_L_(0x80, 0x4E)
#define REG_SC_BK80_4E_H      _PK_H_(0x80, 0x4E)
#define REG_SC_BK80_4F_L      _PK_L_(0x80, 0x4F)
#define REG_SC_BK80_4F_H      _PK_H_(0x80, 0x4F)
#define REG_SC_BK80_50_L      _PK_L_(0x80, 0x50)
#define REG_SC_BK80_50_H      _PK_H_(0x80, 0x50)
#define REG_SC_BK80_51_L      _PK_L_(0x80, 0x51)
#define REG_SC_BK80_51_H      _PK_H_(0x80, 0x51)
#define REG_SC_BK80_52_L      _PK_L_(0x80, 0x52)
#define REG_SC_BK80_52_H      _PK_H_(0x80, 0x52)
#define REG_SC_BK80_53_L      _PK_L_(0x80, 0x53)
#define REG_SC_BK80_53_H      _PK_H_(0x80, 0x53)
#define REG_SC_BK80_54_L      _PK_L_(0x80, 0x54)
#define REG_SC_BK80_54_H      _PK_H_(0x80, 0x54)
#define REG_SC_BK80_55_L      _PK_L_(0x80, 0x55)
#define REG_SC_BK80_55_H      _PK_H_(0x80, 0x55)
#define REG_SC_BK80_56_L      _PK_L_(0x80, 0x56)
#define REG_SC_BK80_56_H      _PK_H_(0x80, 0x56)
#define REG_SC_BK80_57_L      _PK_L_(0x80, 0x57)
#define REG_SC_BK80_57_H      _PK_H_(0x80, 0x57)
#define REG_SC_BK80_58_L      _PK_L_(0x80, 0x58)
#define REG_SC_BK80_58_H      _PK_H_(0x80, 0x58)
#define REG_SC_BK80_59_L      _PK_L_(0x80, 0x59)
#define REG_SC_BK80_59_H      _PK_H_(0x80, 0x59)
#define REG_SC_BK80_5A_L      _PK_L_(0x80, 0x5A)
#define REG_SC_BK80_5A_H      _PK_H_(0x80, 0x5A)
#define REG_SC_BK80_5B_L      _PK_L_(0x80, 0x5B)
#define REG_SC_BK80_5B_H      _PK_H_(0x80, 0x5B)
#define REG_SC_BK80_5C_L      _PK_L_(0x80, 0x5C)
#define REG_SC_BK80_5C_H      _PK_H_(0x80, 0x5C)
#define REG_SC_BK80_5D_L      _PK_L_(0x80, 0x5D)
#define REG_SC_BK80_5D_H      _PK_H_(0x80, 0x5D)
#define REG_SC_BK80_5E_L      _PK_L_(0x80, 0x5E)
#define REG_SC_BK80_5E_H      _PK_H_(0x80, 0x5E)
#define REG_SC_BK80_5F_L      _PK_L_(0x80, 0x5F)
#define REG_SC_BK80_5F_H      _PK_H_(0x80, 0x5F)
#define REG_SC_BK80_60_L      _PK_L_(0x80, 0x60)
#define REG_SC_BK80_60_H      _PK_H_(0x80, 0x60)
#define REG_SC_BK80_61_L      _PK_L_(0x80, 0x61)
#define REG_SC_BK80_61_H      _PK_H_(0x80, 0x61)
#define REG_SC_BK80_62_L      _PK_L_(0x80, 0x62)
#define REG_SC_BK80_62_H      _PK_H_(0x80, 0x62)
#define REG_SC_BK80_63_L      _PK_L_(0x80, 0x63)
#define REG_SC_BK80_63_H      _PK_H_(0x80, 0x63)
#define REG_SC_BK80_64_L      _PK_L_(0x80, 0x64)
#define REG_SC_BK80_64_H      _PK_H_(0x80, 0x64)
#define REG_SC_BK80_65_L      _PK_L_(0x80, 0x65)
#define REG_SC_BK80_65_H      _PK_H_(0x80, 0x65)
#define REG_SC_BK80_66_L      _PK_L_(0x80, 0x66)
#define REG_SC_BK80_66_H      _PK_H_(0x80, 0x66)
#define REG_SC_BK80_67_L      _PK_L_(0x80, 0x67)
#define REG_SC_BK80_67_H      _PK_H_(0x80, 0x67)
#define REG_SC_BK80_68_L      _PK_L_(0x80, 0x68)
#define REG_SC_BK80_68_H      _PK_H_(0x80, 0x68)
#define REG_SC_BK80_69_L      _PK_L_(0x80, 0x69)
#define REG_SC_BK80_69_H      _PK_H_(0x80, 0x69)
#define REG_SC_BK80_6A_L      _PK_L_(0x80, 0x6A)
#define REG_SC_BK80_6A_H      _PK_H_(0x80, 0x6A)
#define REG_SC_BK80_6B_L      _PK_L_(0x80, 0x6B)
#define REG_SC_BK80_6B_H      _PK_H_(0x80, 0x6B)
#define REG_SC_BK80_6C_L      _PK_L_(0x80, 0x6C)
#define REG_SC_BK80_6C_H      _PK_H_(0x80, 0x6C)
#define REG_SC_BK80_6D_L      _PK_L_(0x80, 0x6D)
#define REG_SC_BK80_6D_H      _PK_H_(0x80, 0x6D)
#define REG_SC_BK80_6E_L      _PK_L_(0x80, 0x6E)
#define REG_SC_BK80_6E_H      _PK_H_(0x80, 0x6E)
#define REG_SC_BK80_6F_L      _PK_L_(0x80, 0x6F)
#define REG_SC_BK80_6F_H      _PK_H_(0x80, 0x6F)
#define REG_SC_BK80_70_L      _PK_L_(0x80, 0x70)
#define REG_SC_BK80_70_H      _PK_H_(0x80, 0x70)
#define REG_SC_BK80_71_L      _PK_L_(0x80, 0x71)
#define REG_SC_BK80_71_H      _PK_H_(0x80, 0x71)
#define REG_SC_BK80_72_L      _PK_L_(0x80, 0x72)
#define REG_SC_BK80_72_H      _PK_H_(0x80, 0x72)
#define REG_SC_BK80_73_L      _PK_L_(0x80, 0x73)
#define REG_SC_BK80_73_H      _PK_H_(0x80, 0x73)
#define REG_SC_BK80_74_L      _PK_L_(0x80, 0x74)
#define REG_SC_BK80_74_H      _PK_H_(0x80, 0x74)
#define REG_SC_BK80_75_L      _PK_L_(0x80, 0x75)
#define REG_SC_BK80_75_H      _PK_H_(0x80, 0x75)
#define REG_SC_BK80_76_L      _PK_L_(0x80, 0x76)
#define REG_SC_BK80_76_H      _PK_H_(0x80, 0x76)
#define REG_SC_BK80_77_L      _PK_L_(0x80, 0x77)
#define REG_SC_BK80_77_H      _PK_H_(0x80, 0x77)
#define REG_SC_BK80_78_L      _PK_L_(0x80, 0x78)
#define REG_SC_BK80_78_H      _PK_H_(0x80, 0x78)
#define REG_SC_BK80_79_L      _PK_L_(0x80, 0x79)
#define REG_SC_BK80_79_H      _PK_H_(0x80, 0x79)
#define REG_SC_BK80_7A_L      _PK_L_(0x80, 0x7A)
#define REG_SC_BK80_7A_H      _PK_H_(0x80, 0x7A)
#define REG_SC_BK80_7B_L      _PK_L_(0x80, 0x7B)
#define REG_SC_BK80_7B_H      _PK_H_(0x80, 0x7B)
#define REG_SC_BK80_7C_L      _PK_L_(0x80, 0x7C)
#define REG_SC_BK80_7C_H      _PK_H_(0x80, 0x7C)
#define REG_SC_BK80_7D_L      _PK_L_(0x80, 0x7D)
#define REG_SC_BK80_7D_H      _PK_H_(0x80, 0x7D)
#define REG_SC_BK80_7E_L      _PK_L_(0x80, 0x7E)
#define REG_SC_BK80_7E_H      _PK_H_(0x80, 0x7E)
#define REG_SC_BK80_7F_L      _PK_L_(0x80, 0x7F)
#define REG_SC_BK80_7F_H      _PK_H_(0x80, 0x7F)

//----------------------------------------------
//  BK90
//----------------------------------------------
#define REG_SC_BK90_00_L      _PK_L_(0x90, 0x00)
#define REG_SC_BK90_00_H      _PK_H_(0x90, 0x00)
#define REG_SC_BK90_01_L      _PK_L_(0x90, 0x01)
#define REG_SC_BK90_01_H      _PK_H_(0x90, 0x01)
#define REG_SC_BK90_02_L      _PK_L_(0x90, 0x02)
#define REG_SC_BK90_02_H      _PK_H_(0x90, 0x02)
#define REG_SC_BK90_03_L      _PK_L_(0x90, 0x03)
#define REG_SC_BK90_03_H      _PK_H_(0x90, 0x03)
#define REG_SC_BK90_04_L      _PK_L_(0x90, 0x04)
#define REG_SC_BK90_04_H      _PK_H_(0x90, 0x04)
#define REG_SC_BK90_05_L      _PK_L_(0x90, 0x05)
#define REG_SC_BK90_05_H      _PK_H_(0x90, 0x05)
#define REG_SC_BK90_06_L      _PK_L_(0x90, 0x06)
#define REG_SC_BK90_06_H      _PK_H_(0x90, 0x06)
#define REG_SC_BK90_07_L      _PK_L_(0x90, 0x07)
#define REG_SC_BK90_07_H      _PK_H_(0x90, 0x07)
#define REG_SC_BK90_08_L      _PK_L_(0x90, 0x08)
#define REG_SC_BK90_08_H      _PK_H_(0x90, 0x08)
#define REG_SC_BK90_09_L      _PK_L_(0x90, 0x09)
#define REG_SC_BK90_09_H      _PK_H_(0x90, 0x09)
#define REG_SC_BK90_0A_L      _PK_L_(0x90, 0x0A)
#define REG_SC_BK90_0A_H      _PK_H_(0x90, 0x0A)
#define REG_SC_BK90_0B_L      _PK_L_(0x90, 0x0B)
#define REG_SC_BK90_0B_H      _PK_H_(0x90, 0x0B)
#define REG_SC_BK90_0C_L      _PK_L_(0x90, 0x0C)
#define REG_SC_BK90_0C_H      _PK_H_(0x90, 0x0C)
#define REG_SC_BK90_0D_L      _PK_L_(0x90, 0x0D)
#define REG_SC_BK90_0D_H      _PK_H_(0x90, 0x0D)
#define REG_SC_BK90_0E_L      _PK_L_(0x90, 0x0E)
#define REG_SC_BK90_0E_H      _PK_H_(0x90, 0x0E)
#define REG_SC_BK90_0F_L      _PK_L_(0x90, 0x0F)
#define REG_SC_BK90_0F_H      _PK_H_(0x90, 0x0F)
#define REG_SC_BK90_10_L      _PK_L_(0x90, 0x10)
#define REG_SC_BK90_10_H      _PK_H_(0x90, 0x10)
#define REG_SC_BK90_11_L      _PK_L_(0x90, 0x11)
#define REG_SC_BK90_11_H      _PK_H_(0x90, 0x11)
#define REG_SC_BK90_12_L      _PK_L_(0x90, 0x12)
#define REG_SC_BK90_12_H      _PK_H_(0x90, 0x12)
#define REG_SC_BK90_13_L      _PK_L_(0x90, 0x13)
#define REG_SC_BK90_13_H      _PK_H_(0x90, 0x13)
#define REG_SC_BK90_14_L      _PK_L_(0x90, 0x14)
#define REG_SC_BK90_14_H      _PK_H_(0x90, 0x14)
#define REG_SC_BK90_15_L      _PK_L_(0x90, 0x15)
#define REG_SC_BK90_15_H      _PK_H_(0x90, 0x15)
#define REG_SC_BK90_16_L      _PK_L_(0x90, 0x16)
#define REG_SC_BK90_16_H      _PK_H_(0x90, 0x16)
#define REG_SC_BK90_17_L      _PK_L_(0x90, 0x17)
#define REG_SC_BK90_17_H      _PK_H_(0x90, 0x17)
#define REG_SC_BK90_18_L      _PK_L_(0x90, 0x18)
#define REG_SC_BK90_18_H      _PK_H_(0x90, 0x18)
#define REG_SC_BK90_19_L      _PK_L_(0x90, 0x19)
#define REG_SC_BK90_19_H      _PK_H_(0x90, 0x19)
#define REG_SC_BK90_1A_L      _PK_L_(0x90, 0x1A)
#define REG_SC_BK90_1A_H      _PK_H_(0x90, 0x1A)
#define REG_SC_BK90_1B_L      _PK_L_(0x90, 0x1B)
#define REG_SC_BK90_1B_H      _PK_H_(0x90, 0x1B)
#define REG_SC_BK90_1C_L      _PK_L_(0x90, 0x1C)
#define REG_SC_BK90_1C_H      _PK_H_(0x90, 0x1C)
#define REG_SC_BK90_1D_L      _PK_L_(0x90, 0x1D)
#define REG_SC_BK90_1D_H      _PK_H_(0x90, 0x1D)
#define REG_SC_BK90_1E_L      _PK_L_(0x90, 0x1E)
#define REG_SC_BK90_1E_H      _PK_H_(0x90, 0x1E)
#define REG_SC_BK90_1F_L      _PK_L_(0x90, 0x1F)
#define REG_SC_BK90_1F_H      _PK_H_(0x90, 0x1F)
#define REG_SC_BK90_20_L      _PK_L_(0x90, 0x20)
#define REG_SC_BK90_20_H      _PK_H_(0x90, 0x20)
#define REG_SC_BK90_21_L      _PK_L_(0x90, 0x21)
#define REG_SC_BK90_21_H      _PK_H_(0x90, 0x21)
#define REG_SC_BK90_22_L      _PK_L_(0x90, 0x22)
#define REG_SC_BK90_22_H      _PK_H_(0x90, 0x22)
#define REG_SC_BK90_23_L      _PK_L_(0x90, 0x23)
#define REG_SC_BK90_23_H      _PK_H_(0x90, 0x23)
#define REG_SC_BK90_24_L      _PK_L_(0x90, 0x24)
#define REG_SC_BK90_24_H      _PK_H_(0x90, 0x24)
#define REG_SC_BK90_25_L      _PK_L_(0x90, 0x25)
#define REG_SC_BK90_25_H      _PK_H_(0x90, 0x25)
#define REG_SC_BK90_26_L      _PK_L_(0x90, 0x26)
#define REG_SC_BK90_26_H      _PK_H_(0x90, 0x26)
#define REG_SC_BK90_27_L      _PK_L_(0x90, 0x27)
#define REG_SC_BK90_27_H      _PK_H_(0x90, 0x27)
#define REG_SC_BK90_28_L      _PK_L_(0x90, 0x28)
#define REG_SC_BK90_28_H      _PK_H_(0x90, 0x28)
#define REG_SC_BK90_29_L      _PK_L_(0x90, 0x29)
#define REG_SC_BK90_29_H      _PK_H_(0x90, 0x29)
#define REG_SC_BK90_2A_L      _PK_L_(0x90, 0x2A)
#define REG_SC_BK90_2A_H      _PK_H_(0x90, 0x2A)
#define REG_SC_BK90_2B_L      _PK_L_(0x90, 0x2B)
#define REG_SC_BK90_2B_H      _PK_H_(0x90, 0x2B)
#define REG_SC_BK90_2C_L      _PK_L_(0x90, 0x2C)
#define REG_SC_BK90_2C_H      _PK_H_(0x90, 0x2C)
#define REG_SC_BK90_2D_L      _PK_L_(0x90, 0x2D)
#define REG_SC_BK90_2D_H      _PK_H_(0x90, 0x2D)
#define REG_SC_BK90_2E_L      _PK_L_(0x90, 0x2E)
#define REG_SC_BK90_2E_H      _PK_H_(0x90, 0x2E)
#define REG_SC_BK90_2F_L      _PK_L_(0x90, 0x2F)
#define REG_SC_BK90_2F_H      _PK_H_(0x90, 0x2F)
#define REG_SC_BK90_30_L      _PK_L_(0x90, 0x30)
#define REG_SC_BK90_30_H      _PK_H_(0x90, 0x30)
#define REG_SC_BK90_31_L      _PK_L_(0x90, 0x31)
#define REG_SC_BK90_31_H      _PK_H_(0x90, 0x31)
#define REG_SC_BK90_32_L      _PK_L_(0x90, 0x32)
#define REG_SC_BK90_32_H      _PK_H_(0x90, 0x32)
#define REG_SC_BK90_33_L      _PK_L_(0x90, 0x33)
#define REG_SC_BK90_33_H      _PK_H_(0x90, 0x33)
#define REG_SC_BK90_34_L      _PK_L_(0x90, 0x34)
#define REG_SC_BK90_34_H      _PK_H_(0x90, 0x34)
#define REG_SC_BK90_35_L      _PK_L_(0x90, 0x35)
#define REG_SC_BK90_35_H      _PK_H_(0x90, 0x35)
#define REG_SC_BK90_36_L      _PK_L_(0x90, 0x36)
#define REG_SC_BK90_36_H      _PK_H_(0x90, 0x36)
#define REG_SC_BK90_37_L      _PK_L_(0x90, 0x37)
#define REG_SC_BK90_37_H      _PK_H_(0x90, 0x37)
#define REG_SC_BK90_38_L      _PK_L_(0x90, 0x38)
#define REG_SC_BK90_38_H      _PK_H_(0x90, 0x38)
#define REG_SC_BK90_39_L      _PK_L_(0x90, 0x39)
#define REG_SC_BK90_39_H      _PK_H_(0x90, 0x39)
#define REG_SC_BK90_3A_L      _PK_L_(0x90, 0x3A)
#define REG_SC_BK90_3A_H      _PK_H_(0x90, 0x3A)
#define REG_SC_BK90_3B_L      _PK_L_(0x90, 0x3B)
#define REG_SC_BK90_3B_H      _PK_H_(0x90, 0x3B)
#define REG_SC_BK90_3C_L      _PK_L_(0x90, 0x3C)
#define REG_SC_BK90_3C_H      _PK_H_(0x90, 0x3C)
#define REG_SC_BK90_3D_L      _PK_L_(0x90, 0x3D)
#define REG_SC_BK90_3D_H      _PK_H_(0x90, 0x3D)
#define REG_SC_BK90_3E_L      _PK_L_(0x90, 0x3E)
#define REG_SC_BK90_3E_H      _PK_H_(0x90, 0x3E)
#define REG_SC_BK90_3F_L      _PK_L_(0x90, 0x3F)
#define REG_SC_BK90_3F_H      _PK_H_(0x90, 0x3F)
#define REG_SC_BK90_40_L      _PK_L_(0x90, 0x40)
#define REG_SC_BK90_40_H      _PK_H_(0x90, 0x40)
#define REG_SC_BK90_41_L      _PK_L_(0x90, 0x41)
#define REG_SC_BK90_41_H      _PK_H_(0x90, 0x41)
#define REG_SC_BK90_42_L      _PK_L_(0x90, 0x42)
#define REG_SC_BK90_42_H      _PK_H_(0x90, 0x42)
#define REG_SC_BK90_43_L      _PK_L_(0x90, 0x43)
#define REG_SC_BK90_43_H      _PK_H_(0x90, 0x43)
#define REG_SC_BK90_44_L      _PK_L_(0x90, 0x44)
#define REG_SC_BK90_44_H      _PK_H_(0x90, 0x44)
#define REG_SC_BK90_45_L      _PK_L_(0x90, 0x45)
#define REG_SC_BK90_45_H      _PK_H_(0x90, 0x45)
#define REG_SC_BK90_46_L      _PK_L_(0x90, 0x46)
#define REG_SC_BK90_46_H      _PK_H_(0x90, 0x46)
#define REG_SC_BK90_47_L      _PK_L_(0x90, 0x47)
#define REG_SC_BK90_47_H      _PK_H_(0x90, 0x47)
#define REG_SC_BK90_48_L      _PK_L_(0x90, 0x48)
#define REG_SC_BK90_48_H      _PK_H_(0x90, 0x48)
#define REG_SC_BK90_49_L      _PK_L_(0x90, 0x49)
#define REG_SC_BK90_49_H      _PK_H_(0x90, 0x49)
#define REG_SC_BK90_4A_L      _PK_L_(0x90, 0x4A)
#define REG_SC_BK90_4A_H      _PK_H_(0x90, 0x4A)
#define REG_SC_BK90_4B_L      _PK_L_(0x90, 0x4B)
#define REG_SC_BK90_4B_H      _PK_H_(0x90, 0x4B)
#define REG_SC_BK90_4C_L      _PK_L_(0x90, 0x4C)
#define REG_SC_BK90_4C_H      _PK_H_(0x90, 0x4C)
#define REG_SC_BK90_4D_L      _PK_L_(0x90, 0x4D)
#define REG_SC_BK90_4D_H      _PK_H_(0x90, 0x4D)
#define REG_SC_BK90_4E_L      _PK_L_(0x90, 0x4E)
#define REG_SC_BK90_4E_H      _PK_H_(0x90, 0x4E)
#define REG_SC_BK90_4F_L      _PK_L_(0x90, 0x4F)
#define REG_SC_BK90_4F_H      _PK_H_(0x90, 0x4F)
#define REG_SC_BK90_50_L      _PK_L_(0x90, 0x50)
#define REG_SC_BK90_50_H      _PK_H_(0x90, 0x50)
#define REG_SC_BK90_51_L      _PK_L_(0x90, 0x51)
#define REG_SC_BK90_51_H      _PK_H_(0x90, 0x51)
#define REG_SC_BK90_52_L      _PK_L_(0x90, 0x52)
#define REG_SC_BK90_52_H      _PK_H_(0x90, 0x52)
#define REG_SC_BK90_53_L      _PK_L_(0x90, 0x53)
#define REG_SC_BK90_53_H      _PK_H_(0x90, 0x53)
#define REG_SC_BK90_54_L      _PK_L_(0x90, 0x54)
#define REG_SC_BK90_54_H      _PK_H_(0x90, 0x54)
#define REG_SC_BK90_55_L      _PK_L_(0x90, 0x55)
#define REG_SC_BK90_55_H      _PK_H_(0x90, 0x55)
#define REG_SC_BK90_56_L      _PK_L_(0x90, 0x56)
#define REG_SC_BK90_56_H      _PK_H_(0x90, 0x56)
#define REG_SC_BK90_57_L      _PK_L_(0x90, 0x57)
#define REG_SC_BK90_57_H      _PK_H_(0x90, 0x57)
#define REG_SC_BK90_58_L      _PK_L_(0x90, 0x58)
#define REG_SC_BK90_58_H      _PK_H_(0x90, 0x58)
#define REG_SC_BK90_59_L      _PK_L_(0x90, 0x59)
#define REG_SC_BK90_59_H      _PK_H_(0x90, 0x59)
#define REG_SC_BK90_5A_L      _PK_L_(0x90, 0x5A)
#define REG_SC_BK90_5A_H      _PK_H_(0x90, 0x5A)
#define REG_SC_BK90_5B_L      _PK_L_(0x90, 0x5B)
#define REG_SC_BK90_5B_H      _PK_H_(0x90, 0x5B)
#define REG_SC_BK90_5C_L      _PK_L_(0x90, 0x5C)
#define REG_SC_BK90_5C_H      _PK_H_(0x90, 0x5C)
#define REG_SC_BK90_5D_L      _PK_L_(0x90, 0x5D)
#define REG_SC_BK90_5D_H      _PK_H_(0x90, 0x5D)
#define REG_SC_BK90_5E_L      _PK_L_(0x90, 0x5E)
#define REG_SC_BK90_5E_H      _PK_H_(0x90, 0x5E)
#define REG_SC_BK90_5F_L      _PK_L_(0x90, 0x5F)
#define REG_SC_BK90_5F_H      _PK_H_(0x90, 0x5F)
#define REG_SC_BK90_60_L      _PK_L_(0x90, 0x60)
#define REG_SC_BK90_60_H      _PK_H_(0x90, 0x60)
#define REG_SC_BK90_61_L      _PK_L_(0x90, 0x61)
#define REG_SC_BK90_61_H      _PK_H_(0x90, 0x61)
#define REG_SC_BK90_62_L      _PK_L_(0x90, 0x62)
#define REG_SC_BK90_62_H      _PK_H_(0x90, 0x62)
#define REG_SC_BK90_63_L      _PK_L_(0x90, 0x63)
#define REG_SC_BK90_63_H      _PK_H_(0x90, 0x63)
#define REG_SC_BK90_64_L      _PK_L_(0x90, 0x64)
#define REG_SC_BK90_64_H      _PK_H_(0x90, 0x64)
#define REG_SC_BK90_65_L      _PK_L_(0x90, 0x65)
#define REG_SC_BK90_65_H      _PK_H_(0x90, 0x65)
#define REG_SC_BK90_66_L      _PK_L_(0x90, 0x66)
#define REG_SC_BK90_66_H      _PK_H_(0x90, 0x66)
#define REG_SC_BK90_67_L      _PK_L_(0x90, 0x67)
#define REG_SC_BK90_67_H      _PK_H_(0x90, 0x67)
#define REG_SC_BK90_68_L      _PK_L_(0x90, 0x68)
#define REG_SC_BK90_68_H      _PK_H_(0x90, 0x68)
#define REG_SC_BK90_69_L      _PK_L_(0x90, 0x69)
#define REG_SC_BK90_69_H      _PK_H_(0x90, 0x69)
#define REG_SC_BK90_6A_L      _PK_L_(0x90, 0x6A)
#define REG_SC_BK90_6A_H      _PK_H_(0x90, 0x6A)
#define REG_SC_BK90_6B_L      _PK_L_(0x90, 0x6B)
#define REG_SC_BK90_6B_H      _PK_H_(0x90, 0x6B)
#define REG_SC_BK90_6C_L      _PK_L_(0x90, 0x6C)
#define REG_SC_BK90_6C_H      _PK_H_(0x90, 0x6C)
#define REG_SC_BK90_6D_L      _PK_L_(0x90, 0x6D)
#define REG_SC_BK90_6D_H      _PK_H_(0x90, 0x6D)
#define REG_SC_BK90_6E_L      _PK_L_(0x90, 0x6E)
#define REG_SC_BK90_6E_H      _PK_H_(0x90, 0x6E)
#define REG_SC_BK90_6F_L      _PK_L_(0x90, 0x6F)
#define REG_SC_BK90_6F_H      _PK_H_(0x90, 0x6F)
#define REG_SC_BK90_70_L      _PK_L_(0x90, 0x70)
#define REG_SC_BK90_70_H      _PK_H_(0x90, 0x70)
#define REG_SC_BK90_71_L      _PK_L_(0x90, 0x71)
#define REG_SC_BK90_71_H      _PK_H_(0x90, 0x71)
#define REG_SC_BK90_72_L      _PK_L_(0x90, 0x72)
#define REG_SC_BK90_72_H      _PK_H_(0x90, 0x72)
#define REG_SC_BK90_73_L      _PK_L_(0x90, 0x73)
#define REG_SC_BK90_73_H      _PK_H_(0x90, 0x73)
#define REG_SC_BK90_74_L      _PK_L_(0x90, 0x74)
#define REG_SC_BK90_74_H      _PK_H_(0x90, 0x74)
#define REG_SC_BK90_75_L      _PK_L_(0x90, 0x75)
#define REG_SC_BK90_75_H      _PK_H_(0x90, 0x75)
#define REG_SC_BK90_76_L      _PK_L_(0x90, 0x76)
#define REG_SC_BK90_76_H      _PK_H_(0x90, 0x76)
#define REG_SC_BK90_77_L      _PK_L_(0x90, 0x77)
#define REG_SC_BK90_77_H      _PK_H_(0x90, 0x77)
#define REG_SC_BK90_78_L      _PK_L_(0x90, 0x78)
#define REG_SC_BK90_78_H      _PK_H_(0x90, 0x78)
#define REG_SC_BK90_79_L      _PK_L_(0x90, 0x79)
#define REG_SC_BK90_79_H      _PK_H_(0x90, 0x79)
#define REG_SC_BK90_7A_L      _PK_L_(0x90, 0x7A)
#define REG_SC_BK90_7A_H      _PK_H_(0x90, 0x7A)
#define REG_SC_BK90_7B_L      _PK_L_(0x90, 0x7B)
#define REG_SC_BK90_7B_H      _PK_H_(0x90, 0x7B)
#define REG_SC_BK90_7C_L      _PK_L_(0x90, 0x7C)
#define REG_SC_BK90_7C_H      _PK_H_(0x90, 0x7C)
#define REG_SC_BK90_7D_L      _PK_L_(0x90, 0x7D)
#define REG_SC_BK90_7D_H      _PK_H_(0x90, 0x7D)
#define REG_SC_BK90_7E_L      _PK_L_(0x90, 0x7E)
#define REG_SC_BK90_7E_H      _PK_H_(0x90, 0x7E)
#define REG_SC_BK90_7F_L      _PK_L_(0x90, 0x7F)
#define REG_SC_BK90_7F_H      _PK_H_(0x90, 0x7F)

//----------------------------------------------
//  BK81
//----------------------------------------------
#define REG_SC_BK81_06_L      _PK_L_(0x81, 0x06)
#define REG_SC_BK81_07_L      _PK_L_(0x81, 0x07)

//----------------------------------------------
//  BK82
//----------------------------------------------
#define REG_SC_BK82_0A_L      _PK_L_(0x82, 0x0A)
#define REG_SC_BK82_10_L      _PK_L_(0x82, 0x10)
#define REG_SC_BK82_3E_L      _PK_L_(0x82, 0x3E)

//----------------------------------------------
//  BKB6
//----------------------------------------------
#define REG_SC_BKB6_01_L      _PK_L_(0xB6, 0x01)
#define REG_SC_BKB6_03_L      _PK_L_(0xB6, 0x03)
#define REG_SC_BKB6_07_L      _PK_L_(0xB6, 0x07)
#define REG_SC_BKB6_08_L      _PK_L_(0xB6, 0x08)
#define REG_SC_BKB6_09_L      _PK_L_(0xB6, 0x09)
#define REG_SC_BKB6_0A_L      _PK_L_(0xB6, 0x0A)
#define REG_SC_BKB6_0B_L      _PK_L_(0xB6, 0x0B)
#define REG_SC_BKB6_0C_L      _PK_L_(0xB6, 0x0C)
#define REG_SC_BKB6_0F_L      _PK_L_(0xB6, 0x0F)
#define REG_SC_BKB6_10_L      _PK_L_(0xB6, 0x10)
#define REG_SC_BKB6_11_L      _PK_L_(0xB6, 0x11)
#define REG_SC_BKB6_12_L      _PK_L_(0xB6, 0x12)
#define REG_SC_BKB6_13_L      _PK_L_(0xB6, 0x13)
#define REG_SC_BKB6_28_L      _PK_L_(0xB6, 0x28)
#define REG_SC_BKB6_2A_L      _PK_L_(0xB6, 0x2A)
#define REG_SC_BKB6_29_L      _PK_L_(0xB6, 0x29)
#define REG_SC_BKB6_2B_L      _PK_L_(0xB6, 0x2B)
#define REG_SC_BKB6_40_L      _PK_L_(0xB6, 0x40)
#define REG_SC_BKB6_41_L      _PK_L_(0xB6, 0x41)
#define REG_SC_BKB6_42_L      _PK_L_(0xB6, 0x42)
#define REG_SC_BKB6_43_L      _PK_L_(0xB6, 0x43)
#define REG_SC_BKB6_44_L      _PK_L_(0xB6, 0x44)
#define REG_SC_BKB6_45_L      _PK_L_(0xB6, 0x45)
#define REG_SC_BKB6_49_L      _PK_L_(0xB6, 0x49)
#define REG_SC_BKB6_4A_L      _PK_L_(0xB6, 0x4A)
#define REG_SC_BKB6_58_L      _PK_L_(0xB6, 0x58)
#define REG_SC_BKB6_5F_L      _PK_L_(0xB6, 0x5F)

//----------------------------------------------
//  BKB7
//----------------------------------------------
#define REG_SC_BKB7_01_L      _PK_L_(0xB7, 0x01)
#define REG_SC_BKB7_18_L      _PK_L_(0xB7, 0x18)
#define REG_SC_BKB7_77_L      _PK_L_(0xB7, 0x77)
#define REG_SC_BKB7_78_L      _PK_L_(0xB7, 0x78)

//----------------------------------------------
//  BKA2
//----------------------------------------------
#define REG_SC_BKA2_78_L      _PK_L_(0xA2, 0x78)

//----------------------------------------------
//  BKBF
//----------------------------------------------
#define REG_SC_BKBF_20_L      _PK_L_(0xBF, 0x20)
#define REG_SC_BKBF_20_H      _PK_H_(0xBF, 0x20)

//----------------------------------------------
//  BKC0
//----------------------------------------------
#define REG_SC_BKC0_00_L      _PK_L_(0xC0, 0x00)
#define REG_SC_BKC0_00_H      _PK_H_(0xC0, 0x00)
#define REG_SC_BKC0_01_L      _PK_L_(0xC0, 0x01)
#define REG_SC_BKC0_01_H      _PK_H_(0xC0, 0x01)
#define REG_SC_BKC0_02_L      _PK_L_(0xC0, 0x02)
#define REG_SC_BKC0_02_H      _PK_H_(0xC0, 0x02)
#define REG_SC_BKC0_03_L      _PK_L_(0xC0, 0x03)
#define REG_SC_BKC0_03_H      _PK_H_(0xC0, 0x03)
#define REG_SC_BKC0_04_L      _PK_L_(0xC0, 0x04)
#define REG_SC_BKC0_04_H      _PK_H_(0xC0, 0x04)
#define REG_SC_BKC0_05_L      _PK_L_(0xC0, 0x05)
#define REG_SC_BKC0_05_H      _PK_H_(0xC0, 0x05)
#define REG_SC_BKC0_06_L      _PK_L_(0xC0, 0x06)
#define REG_SC_BKC0_06_H      _PK_H_(0xC0, 0x06)
#define REG_SC_BKC0_07_L      _PK_L_(0xC0, 0x07)
#define REG_SC_BKC0_07_H      _PK_H_(0xC0, 0x07)
#define REG_SC_BKC0_08_L      _PK_L_(0xC0, 0x08)
#define REG_SC_BKC0_08_H      _PK_H_(0xC0, 0x08)
#define REG_SC_BKC0_09_L      _PK_L_(0xC0, 0x09)
#define REG_SC_BKC0_09_H      _PK_H_(0xC0, 0x09)
#define REG_SC_BKC0_0A_L      _PK_L_(0xC0, 0x0A)
#define REG_SC_BKC0_0A_H      _PK_H_(0xC0, 0x0A)
#define REG_SC_BKC0_0B_L      _PK_L_(0xC0, 0x0B)
#define REG_SC_BKC0_0B_H      _PK_H_(0xC0, 0x0B)
#define REG_SC_BKC0_0C_L      _PK_L_(0xC0, 0x0C)
#define REG_SC_BKC0_0C_H      _PK_H_(0xC0, 0x0C)
#define REG_SC_BKC0_0D_L      _PK_L_(0xC0, 0x0D)
#define REG_SC_BKC0_0D_H      _PK_H_(0xC0, 0x0D)
#define REG_SC_BKC0_0E_L      _PK_L_(0xC0, 0x0E)
#define REG_SC_BKC0_0E_H      _PK_H_(0xC0, 0x0E)
#define REG_SC_BKC0_0F_L      _PK_L_(0xC0, 0x0F)
#define REG_SC_BKC0_0F_H      _PK_H_(0xC0, 0x0F)
#define REG_SC_BKC0_10_L      _PK_L_(0xC0, 0x10)
#define REG_SC_BKC0_10_H      _PK_H_(0xC0, 0x10)
#define REG_SC_BKC0_11_L      _PK_L_(0xC0, 0x11)
#define REG_SC_BKC0_11_H      _PK_H_(0xC0, 0x11)
#define REG_SC_BKC0_12_L      _PK_L_(0xC0, 0x12)
#define REG_SC_BKC0_12_H      _PK_H_(0xC0, 0x12)
#define REG_SC_BKC0_13_L      _PK_L_(0xC0, 0x13)
#define REG_SC_BKC0_13_H      _PK_H_(0xC0, 0x13)
#define REG_SC_BKC0_14_L      _PK_L_(0xC0, 0x14)
#define REG_SC_BKC0_14_H      _PK_H_(0xC0, 0x14)
#define REG_SC_BKC0_15_L      _PK_L_(0xC0, 0x15)
#define REG_SC_BKC0_15_H      _PK_H_(0xC0, 0x15)
#define REG_SC_BKC0_16_L      _PK_L_(0xC0, 0x16)
#define REG_SC_BKC0_16_H      _PK_H_(0xC0, 0x16)
#define REG_SC_BKC0_17_L      _PK_L_(0xC0, 0x17)
#define REG_SC_BKC0_17_H      _PK_H_(0xC0, 0x17)
#define REG_SC_BKC0_18_L      _PK_L_(0xC0, 0x18)
#define REG_SC_BKC0_18_H      _PK_H_(0xC0, 0x18)
#define REG_SC_BKC0_19_L      _PK_L_(0xC0, 0x19)
#define REG_SC_BKC0_19_H      _PK_H_(0xC0, 0x19)
#define REG_SC_BKC0_1A_L      _PK_L_(0xC0, 0x1A)
#define REG_SC_BKC0_1A_H      _PK_H_(0xC0, 0x1A)
#define REG_SC_BKC0_1B_L      _PK_L_(0xC0, 0x1B)
#define REG_SC_BKC0_1B_H      _PK_H_(0xC0, 0x1B)
#define REG_SC_BKC0_1C_L      _PK_L_(0xC0, 0x1C)
#define REG_SC_BKC0_1C_H      _PK_H_(0xC0, 0x1C)
#define REG_SC_BKC0_1D_L      _PK_L_(0xC0, 0x1D)
#define REG_SC_BKC0_1D_H      _PK_H_(0xC0, 0x1D)
#define REG_SC_BKC0_1E_L      _PK_L_(0xC0, 0x1E)
#define REG_SC_BKC0_1E_H      _PK_H_(0xC0, 0x1E)
#define REG_SC_BKC0_1F_L      _PK_L_(0xC0, 0x1F)
#define REG_SC_BKC0_1F_H      _PK_H_(0xC0, 0x1F)
#define REG_SC_BKC0_20_L      _PK_L_(0xC0, 0x20)
#define REG_SC_BKC0_20_H      _PK_H_(0xC0, 0x20)
#define REG_SC_BKC0_21_L      _PK_L_(0xC0, 0x21)
#define REG_SC_BKC0_21_H      _PK_H_(0xC0, 0x21)
#define REG_SC_BKC0_22_L      _PK_L_(0xC0, 0x22)
#define REG_SC_BKC0_22_H      _PK_H_(0xC0, 0x22)
#define REG_SC_BKC0_23_L      _PK_L_(0xC0, 0x23)
#define REG_SC_BKC0_23_H      _PK_H_(0xC0, 0x23)
#define REG_SC_BKC0_24_L      _PK_L_(0xC0, 0x24)
#define REG_SC_BKC0_24_H      _PK_H_(0xC0, 0x24)
#define REG_SC_BKC0_25_L      _PK_L_(0xC0, 0x25)
#define REG_SC_BKC0_25_H      _PK_H_(0xC0, 0x25)
#define REG_SC_BKC0_26_L      _PK_L_(0xC0, 0x26)
#define REG_SC_BKC0_26_H      _PK_H_(0xC0, 0x26)
#define REG_SC_BKC0_27_L      _PK_L_(0xC0, 0x27)
#define REG_SC_BKC0_27_H      _PK_H_(0xC0, 0x27)
#define REG_SC_BKC0_28_L      _PK_L_(0xC0, 0x28)
#define REG_SC_BKC0_28_H      _PK_H_(0xC0, 0x28)
#define REG_SC_BKC0_29_L      _PK_L_(0xC0, 0x29)
#define REG_SC_BKC0_29_H      _PK_H_(0xC0, 0x29)
#define REG_SC_BKC0_2A_L      _PK_L_(0xC0, 0x2A)
#define REG_SC_BKC0_2A_H      _PK_H_(0xC0, 0x2A)
#define REG_SC_BKC0_2B_L      _PK_L_(0xC0, 0x2B)
#define REG_SC_BKC0_2B_H      _PK_H_(0xC0, 0x2B)
#define REG_SC_BKC0_2C_L      _PK_L_(0xC0, 0x2C)
#define REG_SC_BKC0_2C_H      _PK_H_(0xC0, 0x2C)
#define REG_SC_BKC0_2D_L      _PK_L_(0xC0, 0x2D)
#define REG_SC_BKC0_2D_H      _PK_H_(0xC0, 0x2D)
#define REG_SC_BKC0_2E_L      _PK_L_(0xC0, 0x2E)
#define REG_SC_BKC0_2E_H      _PK_H_(0xC0, 0x2E)
#define REG_SC_BKC0_2F_L      _PK_L_(0xC0, 0x2F)
#define REG_SC_BKC0_2F_H      _PK_H_(0xC0, 0x2F)
#define REG_SC_BKC0_30_L      _PK_L_(0xC0, 0x30)
#define REG_SC_BKC0_30_H      _PK_H_(0xC0, 0x30)
#define REG_SC_BKC0_31_L      _PK_L_(0xC0, 0x31)
#define REG_SC_BKC0_31_H      _PK_H_(0xC0, 0x31)
#define REG_SC_BKC0_32_L      _PK_L_(0xC0, 0x32)
#define REG_SC_BKC0_32_H      _PK_H_(0xC0, 0x32)
#define REG_SC_BKC0_33_L      _PK_L_(0xC0, 0x33)
#define REG_SC_BKC0_33_H      _PK_H_(0xC0, 0x33)
#define REG_SC_BKC0_34_L      _PK_L_(0xC0, 0x34)
#define REG_SC_BKC0_34_H      _PK_H_(0xC0, 0x34)
#define REG_SC_BKC0_35_L      _PK_L_(0xC0, 0x35)
#define REG_SC_BKC0_35_H      _PK_H_(0xC0, 0x35)
#define REG_SC_BKC0_36_L      _PK_L_(0xC0, 0x36)
#define REG_SC_BKC0_36_H      _PK_H_(0xC0, 0x36)
#define REG_SC_BKC0_37_L      _PK_L_(0xC0, 0x37)
#define REG_SC_BKC0_37_H      _PK_H_(0xC0, 0x37)
#define REG_SC_BKC0_38_L      _PK_L_(0xC0, 0x38)
#define REG_SC_BKC0_38_H      _PK_H_(0xC0, 0x38)
#define REG_SC_BKC0_39_L      _PK_L_(0xC0, 0x39)
#define REG_SC_BKC0_39_H      _PK_H_(0xC0, 0x39)
#define REG_SC_BKC0_3A_L      _PK_L_(0xC0, 0x3A)
#define REG_SC_BKC0_3A_H      _PK_H_(0xC0, 0x3A)
#define REG_SC_BKC0_3B_L      _PK_L_(0xC0, 0x3B)
#define REG_SC_BKC0_3B_H      _PK_H_(0xC0, 0x3B)
#define REG_SC_BKC0_3C_L      _PK_L_(0xC0, 0x3C)
#define REG_SC_BKC0_3C_H      _PK_H_(0xC0, 0x3C)
#define REG_SC_BKC0_3D_L      _PK_L_(0xC0, 0x3D)
#define REG_SC_BKC0_3D_H      _PK_H_(0xC0, 0x3D)
#define REG_SC_BKC0_3E_L      _PK_L_(0xC0, 0x3E)
#define REG_SC_BKC0_3E_H      _PK_H_(0xC0, 0x3E)
#define REG_SC_BKC0_3F_L      _PK_L_(0xC0, 0x3F)
#define REG_SC_BKC0_3F_H      _PK_H_(0xC0, 0x3F)
#define REG_SC_BKC0_40_L      _PK_L_(0xC0, 0x40)
#define REG_SC_BKC0_40_H      _PK_H_(0xC0, 0x40)
#define REG_SC_BKC0_41_L      _PK_L_(0xC0, 0x41)
#define REG_SC_BKC0_41_H      _PK_H_(0xC0, 0x41)
#define REG_SC_BKC0_42_L      _PK_L_(0xC0, 0x42)
#define REG_SC_BKC0_42_H      _PK_H_(0xC0, 0x42)
#define REG_SC_BKC0_43_L      _PK_L_(0xC0, 0x43)
#define REG_SC_BKC0_43_H      _PK_H_(0xC0, 0x43)
#define REG_SC_BKC0_44_L      _PK_L_(0xC0, 0x44)
#define REG_SC_BKC0_44_H      _PK_H_(0xC0, 0x44)
#define REG_SC_BKC0_45_L      _PK_L_(0xC0, 0x45)
#define REG_SC_BKC0_45_H      _PK_H_(0xC0, 0x45)
#define REG_SC_BKC0_46_L      _PK_L_(0xC0, 0x46)
#define REG_SC_BKC0_46_H      _PK_H_(0xC0, 0x46)
#define REG_SC_BKC0_47_L      _PK_L_(0xC0, 0x47)
#define REG_SC_BKC0_47_H      _PK_H_(0xC0, 0x47)
#define REG_SC_BKC0_48_L      _PK_L_(0xC0, 0x48)
#define REG_SC_BKC0_48_H      _PK_H_(0xC0, 0x48)
#define REG_SC_BKC0_49_L      _PK_L_(0xC0, 0x49)
#define REG_SC_BKC0_49_H      _PK_H_(0xC0, 0x49)
#define REG_SC_BKC0_4A_L      _PK_L_(0xC0, 0x4A)
#define REG_SC_BKC0_4A_H      _PK_H_(0xC0, 0x4A)
#define REG_SC_BKC0_4B_L      _PK_L_(0xC0, 0x4B)
#define REG_SC_BKC0_4B_H      _PK_H_(0xC0, 0x4B)
#define REG_SC_BKC0_4C_L      _PK_L_(0xC0, 0x4C)
#define REG_SC_BKC0_4C_H      _PK_H_(0xC0, 0x4C)
#define REG_SC_BKC0_4D_L      _PK_L_(0xC0, 0x4D)
#define REG_SC_BKC0_4D_H      _PK_H_(0xC0, 0x4D)
#define REG_SC_BKC0_4E_L      _PK_L_(0xC0, 0x4E)
#define REG_SC_BKC0_4E_H      _PK_H_(0xC0, 0x4E)
#define REG_SC_BKC0_4F_L      _PK_L_(0xC0, 0x4F)
#define REG_SC_BKC0_4F_H      _PK_H_(0xC0, 0x4F)
#define REG_SC_BKC0_50_L      _PK_L_(0xC0, 0x50)
#define REG_SC_BKC0_50_H      _PK_H_(0xC0, 0x50)
#define REG_SC_BKC0_51_L      _PK_L_(0xC0, 0x51)
#define REG_SC_BKC0_51_H      _PK_H_(0xC0, 0x51)
#define REG_SC_BKC0_52_L      _PK_L_(0xC0, 0x52)
#define REG_SC_BKC0_52_H      _PK_H_(0xC0, 0x52)
#define REG_SC_BKC0_53_L      _PK_L_(0xC0, 0x53)
#define REG_SC_BKC0_53_H      _PK_H_(0xC0, 0x53)
#define REG_SC_BKC0_54_L      _PK_L_(0xC0, 0x54)
#define REG_SC_BKC0_54_H      _PK_H_(0xC0, 0x54)
#define REG_SC_BKC0_55_L      _PK_L_(0xC0, 0x55)
#define REG_SC_BKC0_55_H      _PK_H_(0xC0, 0x55)
#define REG_SC_BKC0_56_L      _PK_L_(0xC0, 0x56)
#define REG_SC_BKC0_56_H      _PK_H_(0xC0, 0x56)
#define REG_SC_BKC0_57_L      _PK_L_(0xC0, 0x57)
#define REG_SC_BKC0_57_H      _PK_H_(0xC0, 0x57)
#define REG_SC_BKC0_58_L      _PK_L_(0xC0, 0x58)
#define REG_SC_BKC0_58_H      _PK_H_(0xC0, 0x58)
#define REG_SC_BKC0_59_L      _PK_L_(0xC0, 0x59)
#define REG_SC_BKC0_59_H      _PK_H_(0xC0, 0x59)
#define REG_SC_BKC0_5A_L      _PK_L_(0xC0, 0x5A)
#define REG_SC_BKC0_5A_H      _PK_H_(0xC0, 0x5A)
#define REG_SC_BKC0_5B_L      _PK_L_(0xC0, 0x5B)
#define REG_SC_BKC0_5B_H      _PK_H_(0xC0, 0x5B)
#define REG_SC_BKC0_5C_L      _PK_L_(0xC0, 0x5C)
#define REG_SC_BKC0_5C_H      _PK_H_(0xC0, 0x5C)
#define REG_SC_BKC0_5D_L      _PK_L_(0xC0, 0x5D)
#define REG_SC_BKC0_5D_H      _PK_H_(0xC0, 0x5D)
#define REG_SC_BKC0_5E_L      _PK_L_(0xC0, 0x5E)
#define REG_SC_BKC0_5E_H      _PK_H_(0xC0, 0x5E)
#define REG_SC_BKC0_5F_L      _PK_L_(0xC0, 0x5F)
#define REG_SC_BKC0_5F_H      _PK_H_(0xC0, 0x5F)
#define REG_SC_BKC0_60_L      _PK_L_(0xC0, 0x60)
#define REG_SC_BKC0_60_H      _PK_H_(0xC0, 0x60)
#define REG_SC_BKC0_61_L      _PK_L_(0xC0, 0x61)
#define REG_SC_BKC0_61_H      _PK_H_(0xC0, 0x61)
#define REG_SC_BKC0_62_L      _PK_L_(0xC0, 0x62)
#define REG_SC_BKC0_62_H      _PK_H_(0xC0, 0x62)
#define REG_SC_BKC0_63_L      _PK_L_(0xC0, 0x63)
#define REG_SC_BKC0_63_H      _PK_H_(0xC0, 0x63)
#define REG_SC_BKC0_64_L      _PK_L_(0xC0, 0x64)
#define REG_SC_BKC0_64_H      _PK_H_(0xC0, 0x64)
#define REG_SC_BKC0_65_L      _PK_L_(0xC0, 0x65)
#define REG_SC_BKC0_65_H      _PK_H_(0xC0, 0x65)
#define REG_SC_BKC0_66_L      _PK_L_(0xC0, 0x66)
#define REG_SC_BKC0_66_H      _PK_H_(0xC0, 0x66)
#define REG_SC_BKC0_67_L      _PK_L_(0xC0, 0x67)
#define REG_SC_BKC0_67_H      _PK_H_(0xC0, 0x67)
#define REG_SC_BKC0_68_L      _PK_L_(0xC0, 0x68)
#define REG_SC_BKC0_68_H      _PK_H_(0xC0, 0x68)
#define REG_SC_BKC0_69_L      _PK_L_(0xC0, 0x69)
#define REG_SC_BKC0_69_H      _PK_H_(0xC0, 0x69)
#define REG_SC_BKC0_6A_L      _PK_L_(0xC0, 0x6A)
#define REG_SC_BKC0_6A_H      _PK_H_(0xC0, 0x6A)
#define REG_SC_BKC0_6B_L      _PK_L_(0xC0, 0x6B)
#define REG_SC_BKC0_6B_H      _PK_H_(0xC0, 0x6B)
#define REG_SC_BKC0_6C_L      _PK_L_(0xC0, 0x6C)
#define REG_SC_BKC0_6C_H      _PK_H_(0xC0, 0x6C)
#define REG_SC_BKC0_6D_L      _PK_L_(0xC0, 0x6D)
#define REG_SC_BKC0_6D_H      _PK_H_(0xC0, 0x6D)
#define REG_SC_BKC0_6E_L      _PK_L_(0xC0, 0x6E)
#define REG_SC_BKC0_6E_H      _PK_H_(0xC0, 0x6E)
#define REG_SC_BKC0_6F_L      _PK_L_(0xC0, 0x6F)
#define REG_SC_BKC0_6F_H      _PK_H_(0xC0, 0x6F)
#define REG_SC_BKC0_70_L      _PK_L_(0xC0, 0x70)
#define REG_SC_BKC0_70_H      _PK_H_(0xC0, 0x70)
#define REG_SC_BKC0_71_L      _PK_L_(0xC0, 0x71)
#define REG_SC_BKC0_71_H      _PK_H_(0xC0, 0x71)
#define REG_SC_BKC0_72_L      _PK_L_(0xC0, 0x72)
#define REG_SC_BKC0_72_H      _PK_H_(0xC0, 0x72)
#define REG_SC_BKC0_73_L      _PK_L_(0xC0, 0x73)
#define REG_SC_BKC0_73_H      _PK_H_(0xC0, 0x73)
#define REG_SC_BKC0_74_L      _PK_L_(0xC0, 0x74)
#define REG_SC_BKC0_74_H      _PK_H_(0xC0, 0x74)
#define REG_SC_BKC0_75_L      _PK_L_(0xC0, 0x75)
#define REG_SC_BKC0_75_H      _PK_H_(0xC0, 0x75)
#define REG_SC_BKC0_76_L      _PK_L_(0xC0, 0x76)
#define REG_SC_BKC0_76_H      _PK_H_(0xC0, 0x76)
#define REG_SC_BKC0_77_L      _PK_L_(0xC0, 0x77)
#define REG_SC_BKC0_77_H      _PK_H_(0xC0, 0x77)
#define REG_SC_BKC0_78_L      _PK_L_(0xC0, 0x78)
#define REG_SC_BKC0_78_H      _PK_H_(0xC0, 0x78)
#define REG_SC_BKC0_79_L      _PK_L_(0xC0, 0x79)
#define REG_SC_BKC0_79_H      _PK_H_(0xC0, 0x79)
#define REG_SC_BKC0_7A_L      _PK_L_(0xC0, 0x7A)
#define REG_SC_BKC0_7A_H      _PK_H_(0xC0, 0x7A)
#define REG_SC_BKC0_7B_L      _PK_L_(0xC0, 0x7B)
#define REG_SC_BKC0_7B_H      _PK_H_(0xC0, 0x7B)
#define REG_SC_BKC0_7C_L      _PK_L_(0xC0, 0x7C)
#define REG_SC_BKC0_7C_H      _PK_H_(0xC0, 0x7C)
#define REG_SC_BKC0_7D_L      _PK_L_(0xC0, 0x7D)
#define REG_SC_BKC0_7D_H      _PK_H_(0xC0, 0x7D)
#define REG_SC_BKC0_7E_L      _PK_L_(0xC0, 0x7E)
#define REG_SC_BKC0_7E_H      _PK_H_(0xC0, 0x7E)
#define REG_SC_BKC0_7F_L      _PK_L_(0xC0, 0x7F)
#define REG_SC_BKC0_7F_H      _PK_H_(0xC0, 0x7F)

//----------------------------------------------
//  BKC1
//----------------------------------------------
#define REG_SC_BKC1_00_L      _PK_L_(0xC1, 0x00)
#define REG_SC_BKC1_00_H      _PK_H_(0xC1, 0x00)
#define REG_SC_BKC1_01_L      _PK_L_(0xC1, 0x01)
#define REG_SC_BKC1_01_H      _PK_H_(0xC1, 0x01)
#define REG_SC_BKC1_02_L      _PK_L_(0xC1, 0x02)
#define REG_SC_BKC1_02_H      _PK_H_(0xC1, 0x02)
#define REG_SC_BKC1_03_L      _PK_L_(0xC1, 0x03)
#define REG_SC_BKC1_03_H      _PK_H_(0xC1, 0x03)
#define REG_SC_BKC1_04_L      _PK_L_(0xC1, 0x04)
#define REG_SC_BKC1_04_H      _PK_H_(0xC1, 0x04)
#define REG_SC_BKC1_05_L      _PK_L_(0xC1, 0x05)
#define REG_SC_BKC1_05_H      _PK_H_(0xC1, 0x05)
#define REG_SC_BKC1_06_L      _PK_L_(0xC1, 0x06)
#define REG_SC_BKC1_06_H      _PK_H_(0xC1, 0x06)
#define REG_SC_BKC1_07_L      _PK_L_(0xC1, 0x07)
#define REG_SC_BKC1_07_H      _PK_H_(0xC1, 0x07)
#define REG_SC_BKC1_08_L      _PK_L_(0xC1, 0x08)
#define REG_SC_BKC1_08_H      _PK_H_(0xC1, 0x08)
#define REG_SC_BKC1_09_L      _PK_L_(0xC1, 0x09)
#define REG_SC_BKC1_09_H      _PK_H_(0xC1, 0x09)
#define REG_SC_BKC1_0A_L      _PK_L_(0xC1, 0x0A)
#define REG_SC_BKC1_0A_H      _PK_H_(0xC1, 0x0A)
#define REG_SC_BKC1_0B_L      _PK_L_(0xC1, 0x0B)
#define REG_SC_BKC1_0B_H      _PK_H_(0xC1, 0x0B)
#define REG_SC_BKC1_0C_L      _PK_L_(0xC1, 0x0C)
#define REG_SC_BKC1_0C_H      _PK_H_(0xC1, 0x0C)
#define REG_SC_BKC1_0D_L      _PK_L_(0xC1, 0x0D)
#define REG_SC_BKC1_0D_H      _PK_H_(0xC1, 0x0D)
#define REG_SC_BKC1_0E_L      _PK_L_(0xC1, 0x0E)
#define REG_SC_BKC1_0E_H      _PK_H_(0xC1, 0x0E)
#define REG_SC_BKC1_0F_L      _PK_L_(0xC1, 0x0F)
#define REG_SC_BKC1_0F_H      _PK_H_(0xC1, 0x0F)
#define REG_SC_BKC1_10_L      _PK_L_(0xC1, 0x10)
#define REG_SC_BKC1_10_H      _PK_H_(0xC1, 0x10)
#define REG_SC_BKC1_11_L      _PK_L_(0xC1, 0x11)
#define REG_SC_BKC1_11_H      _PK_H_(0xC1, 0x11)
#define REG_SC_BKC1_12_L      _PK_L_(0xC1, 0x12)
#define REG_SC_BKC1_12_H      _PK_H_(0xC1, 0x12)
#define REG_SC_BKC1_13_L      _PK_L_(0xC1, 0x13)
#define REG_SC_BKC1_13_H      _PK_H_(0xC1, 0x13)
#define REG_SC_BKC1_14_L      _PK_L_(0xC1, 0x14)
#define REG_SC_BKC1_14_H      _PK_H_(0xC1, 0x14)
#define REG_SC_BKC1_15_L      _PK_L_(0xC1, 0x15)
#define REG_SC_BKC1_15_H      _PK_H_(0xC1, 0x15)
#define REG_SC_BKC1_16_L      _PK_L_(0xC1, 0x16)
#define REG_SC_BKC1_16_H      _PK_H_(0xC1, 0x16)
#define REG_SC_BKC1_17_L      _PK_L_(0xC1, 0x17)
#define REG_SC_BKC1_17_H      _PK_H_(0xC1, 0x17)
#define REG_SC_BKC1_18_L      _PK_L_(0xC1, 0x18)
#define REG_SC_BKC1_18_H      _PK_H_(0xC1, 0x18)
#define REG_SC_BKC1_19_L      _PK_L_(0xC1, 0x19)
#define REG_SC_BKC1_19_H      _PK_H_(0xC1, 0x19)
#define REG_SC_BKC1_1A_L      _PK_L_(0xC1, 0x1A)
#define REG_SC_BKC1_1A_H      _PK_H_(0xC1, 0x1A)
#define REG_SC_BKC1_1B_L      _PK_L_(0xC1, 0x1B)
#define REG_SC_BKC1_1B_H      _PK_H_(0xC1, 0x1B)
#define REG_SC_BKC1_1C_L      _PK_L_(0xC1, 0x1C)
#define REG_SC_BKC1_1C_H      _PK_H_(0xC1, 0x1C)
#define REG_SC_BKC1_1D_L      _PK_L_(0xC1, 0x1D)
#define REG_SC_BKC1_1D_H      _PK_H_(0xC1, 0x1D)
#define REG_SC_BKC1_1E_L      _PK_L_(0xC1, 0x1E)
#define REG_SC_BKC1_1E_H      _PK_H_(0xC1, 0x1E)
#define REG_SC_BKC1_1F_L      _PK_L_(0xC1, 0x1F)
#define REG_SC_BKC1_1F_H      _PK_H_(0xC1, 0x1F)
#define REG_SC_BKC1_20_L      _PK_L_(0xC1, 0x20)
#define REG_SC_BKC1_20_H      _PK_H_(0xC1, 0x20)
#define REG_SC_BKC1_21_L      _PK_L_(0xC1, 0x21)
#define REG_SC_BKC1_21_H      _PK_H_(0xC1, 0x21)
#define REG_SC_BKC1_22_L      _PK_L_(0xC1, 0x22)
#define REG_SC_BKC1_22_H      _PK_H_(0xC1, 0x22)
#define REG_SC_BKC1_23_L      _PK_L_(0xC1, 0x23)
#define REG_SC_BKC1_23_H      _PK_H_(0xC1, 0x23)
#define REG_SC_BKC1_24_L      _PK_L_(0xC1, 0x24)
#define REG_SC_BKC1_24_H      _PK_H_(0xC1, 0x24)
#define REG_SC_BKC1_25_L      _PK_L_(0xC1, 0x25)
#define REG_SC_BKC1_25_H      _PK_H_(0xC1, 0x25)
#define REG_SC_BKC1_26_L      _PK_L_(0xC1, 0x26)
#define REG_SC_BKC1_26_H      _PK_H_(0xC1, 0x26)
#define REG_SC_BKC1_27_L      _PK_L_(0xC1, 0x27)
#define REG_SC_BKC1_27_H      _PK_H_(0xC1, 0x27)
#define REG_SC_BKC1_28_L      _PK_L_(0xC1, 0x28)
#define REG_SC_BKC1_28_H      _PK_H_(0xC1, 0x28)
#define REG_SC_BKC1_29_L      _PK_L_(0xC1, 0x29)
#define REG_SC_BKC1_29_H      _PK_H_(0xC1, 0x29)
#define REG_SC_BKC1_2A_L      _PK_L_(0xC1, 0x2A)
#define REG_SC_BKC1_2A_H      _PK_H_(0xC1, 0x2A)
#define REG_SC_BKC1_2B_L      _PK_L_(0xC1, 0x2B)
#define REG_SC_BKC1_2B_H      _PK_H_(0xC1, 0x2B)
#define REG_SC_BKC1_2C_L      _PK_L_(0xC1, 0x2C)
#define REG_SC_BKC1_2C_H      _PK_H_(0xC1, 0x2C)
#define REG_SC_BKC1_2D_L      _PK_L_(0xC1, 0x2D)
#define REG_SC_BKC1_2D_H      _PK_H_(0xC1, 0x2D)
#define REG_SC_BKC1_2E_L      _PK_L_(0xC1, 0x2E)
#define REG_SC_BKC1_2E_H      _PK_H_(0xC1, 0x2E)
#define REG_SC_BKC1_2F_L      _PK_L_(0xC1, 0x2F)
#define REG_SC_BKC1_2F_H      _PK_H_(0xC1, 0x2F)
#define REG_SC_BKC1_30_L      _PK_L_(0xC1, 0x30)
#define REG_SC_BKC1_30_H      _PK_H_(0xC1, 0x30)
#define REG_SC_BKC1_31_L      _PK_L_(0xC1, 0x31)
#define REG_SC_BKC1_31_H      _PK_H_(0xC1, 0x31)
#define REG_SC_BKC1_32_L      _PK_L_(0xC1, 0x32)
#define REG_SC_BKC1_32_H      _PK_H_(0xC1, 0x32)
#define REG_SC_BKC1_33_L      _PK_L_(0xC1, 0x33)
#define REG_SC_BKC1_33_H      _PK_H_(0xC1, 0x33)
#define REG_SC_BKC1_34_L      _PK_L_(0xC1, 0x34)
#define REG_SC_BKC1_34_H      _PK_H_(0xC1, 0x34)
#define REG_SC_BKC1_35_L      _PK_L_(0xC1, 0x35)
#define REG_SC_BKC1_35_H      _PK_H_(0xC1, 0x35)
#define REG_SC_BKC1_36_L      _PK_L_(0xC1, 0x36)
#define REG_SC_BKC1_36_H      _PK_H_(0xC1, 0x36)
#define REG_SC_BKC1_37_L      _PK_L_(0xC1, 0x37)
#define REG_SC_BKC1_37_H      _PK_H_(0xC1, 0x37)
#define REG_SC_BKC1_38_L      _PK_L_(0xC1, 0x38)
#define REG_SC_BKC1_38_H      _PK_H_(0xC1, 0x38)
#define REG_SC_BKC1_39_L      _PK_L_(0xC1, 0x39)
#define REG_SC_BKC1_39_H      _PK_H_(0xC1, 0x39)
#define REG_SC_BKC1_3A_L      _PK_L_(0xC1, 0x3A)
#define REG_SC_BKC1_3A_H      _PK_H_(0xC1, 0x3A)
#define REG_SC_BKC1_3B_L      _PK_L_(0xC1, 0x3B)
#define REG_SC_BKC1_3B_H      _PK_H_(0xC1, 0x3B)
#define REG_SC_BKC1_3C_L      _PK_L_(0xC1, 0x3C)
#define REG_SC_BKC1_3C_H      _PK_H_(0xC1, 0x3C)
#define REG_SC_BKC1_3D_L      _PK_L_(0xC1, 0x3D)
#define REG_SC_BKC1_3D_H      _PK_H_(0xC1, 0x3D)
#define REG_SC_BKC1_3E_L      _PK_L_(0xC1, 0x3E)
#define REG_SC_BKC1_3E_H      _PK_H_(0xC1, 0x3E)
#define REG_SC_BKC1_3F_L      _PK_L_(0xC1, 0x3F)
#define REG_SC_BKC1_3F_H      _PK_H_(0xC1, 0x3F)
#define REG_SC_BKC1_40_L      _PK_L_(0xC1, 0x40)
#define REG_SC_BKC1_40_H      _PK_H_(0xC1, 0x40)
#define REG_SC_BKC1_41_L      _PK_L_(0xC1, 0x41)
#define REG_SC_BKC1_41_H      _PK_H_(0xC1, 0x41)
#define REG_SC_BKC1_42_L      _PK_L_(0xC1, 0x42)
#define REG_SC_BKC1_42_H      _PK_H_(0xC1, 0x42)
#define REG_SC_BKC1_43_L      _PK_L_(0xC1, 0x43)
#define REG_SC_BKC1_43_H      _PK_H_(0xC1, 0x43)
#define REG_SC_BKC1_44_L      _PK_L_(0xC1, 0x44)
#define REG_SC_BKC1_44_H      _PK_H_(0xC1, 0x44)
#define REG_SC_BKC1_45_L      _PK_L_(0xC1, 0x45)
#define REG_SC_BKC1_45_H      _PK_H_(0xC1, 0x45)
#define REG_SC_BKC1_46_L      _PK_L_(0xC1, 0x46)
#define REG_SC_BKC1_46_H      _PK_H_(0xC1, 0x46)
#define REG_SC_BKC1_47_L      _PK_L_(0xC1, 0x47)
#define REG_SC_BKC1_47_H      _PK_H_(0xC1, 0x47)
#define REG_SC_BKC1_48_L      _PK_L_(0xC1, 0x48)
#define REG_SC_BKC1_48_H      _PK_H_(0xC1, 0x48)
#define REG_SC_BKC1_49_L      _PK_L_(0xC1, 0x49)
#define REG_SC_BKC1_49_H      _PK_H_(0xC1, 0x49)
#define REG_SC_BKC1_4A_L      _PK_L_(0xC1, 0x4A)
#define REG_SC_BKC1_4A_H      _PK_H_(0xC1, 0x4A)
#define REG_SC_BKC1_4B_L      _PK_L_(0xC1, 0x4B)
#define REG_SC_BKC1_4B_H      _PK_H_(0xC1, 0x4B)
#define REG_SC_BKC1_4C_L      _PK_L_(0xC1, 0x4C)
#define REG_SC_BKC1_4C_H      _PK_H_(0xC1, 0x4C)
#define REG_SC_BKC1_4D_L      _PK_L_(0xC1, 0x4D)
#define REG_SC_BKC1_4D_H      _PK_H_(0xC1, 0x4D)
#define REG_SC_BKC1_4E_L      _PK_L_(0xC1, 0x4E)
#define REG_SC_BKC1_4E_H      _PK_H_(0xC1, 0x4E)
#define REG_SC_BKC1_4F_L      _PK_L_(0xC1, 0x4F)
#define REG_SC_BKC1_4F_H      _PK_H_(0xC1, 0x4F)
#define REG_SC_BKC1_50_L      _PK_L_(0xC1, 0x50)
#define REG_SC_BKC1_50_H      _PK_H_(0xC1, 0x50)
#define REG_SC_BKC1_51_L      _PK_L_(0xC1, 0x51)
#define REG_SC_BKC1_51_H      _PK_H_(0xC1, 0x51)
#define REG_SC_BKC1_52_L      _PK_L_(0xC1, 0x52)
#define REG_SC_BKC1_52_H      _PK_H_(0xC1, 0x52)
#define REG_SC_BKC1_53_L      _PK_L_(0xC1, 0x53)
#define REG_SC_BKC1_53_H      _PK_H_(0xC1, 0x53)
#define REG_SC_BKC1_54_L      _PK_L_(0xC1, 0x54)
#define REG_SC_BKC1_54_H      _PK_H_(0xC1, 0x54)
#define REG_SC_BKC1_55_L      _PK_L_(0xC1, 0x55)
#define REG_SC_BKC1_55_H      _PK_H_(0xC1, 0x55)
#define REG_SC_BKC1_56_L      _PK_L_(0xC1, 0x56)
#define REG_SC_BKC1_56_H      _PK_H_(0xC1, 0x56)
#define REG_SC_BKC1_57_L      _PK_L_(0xC1, 0x57)
#define REG_SC_BKC1_57_H      _PK_H_(0xC1, 0x57)
#define REG_SC_BKC1_58_L      _PK_L_(0xC1, 0x58)
#define REG_SC_BKC1_58_H      _PK_H_(0xC1, 0x58)
#define REG_SC_BKC1_59_L      _PK_L_(0xC1, 0x59)
#define REG_SC_BKC1_59_H      _PK_H_(0xC1, 0x59)
#define REG_SC_BKC1_5A_L      _PK_L_(0xC1, 0x5A)
#define REG_SC_BKC1_5A_H      _PK_H_(0xC1, 0x5A)
#define REG_SC_BKC1_5B_L      _PK_L_(0xC1, 0x5B)
#define REG_SC_BKC1_5B_H      _PK_H_(0xC1, 0x5B)
#define REG_SC_BKC1_5C_L      _PK_L_(0xC1, 0x5C)
#define REG_SC_BKC1_5C_H      _PK_H_(0xC1, 0x5C)
#define REG_SC_BKC1_5D_L      _PK_L_(0xC1, 0x5D)
#define REG_SC_BKC1_5D_H      _PK_H_(0xC1, 0x5D)
#define REG_SC_BKC1_5E_L      _PK_L_(0xC1, 0x5E)
#define REG_SC_BKC1_5E_H      _PK_H_(0xC1, 0x5E)
#define REG_SC_BKC1_5F_L      _PK_L_(0xC1, 0x5F)
#define REG_SC_BKC1_5F_H      _PK_H_(0xC1, 0x5F)
#define REG_SC_BKC1_60_L      _PK_L_(0xC1, 0x60)
#define REG_SC_BKC1_60_H      _PK_H_(0xC1, 0x60)
#define REG_SC_BKC1_61_L      _PK_L_(0xC1, 0x61)
#define REG_SC_BKC1_61_H      _PK_H_(0xC1, 0x61)
#define REG_SC_BKC1_62_L      _PK_L_(0xC1, 0x62)
#define REG_SC_BKC1_62_H      _PK_H_(0xC1, 0x62)
#define REG_SC_BKC1_63_L      _PK_L_(0xC1, 0x63)
#define REG_SC_BKC1_63_H      _PK_H_(0xC1, 0x63)
#define REG_SC_BKC1_64_L      _PK_L_(0xC1, 0x64)
#define REG_SC_BKC1_64_H      _PK_H_(0xC1, 0x64)
#define REG_SC_BKC1_65_L      _PK_L_(0xC1, 0x65)
#define REG_SC_BKC1_65_H      _PK_H_(0xC1, 0x65)
#define REG_SC_BKC1_66_L      _PK_L_(0xC1, 0x66)
#define REG_SC_BKC1_66_H      _PK_H_(0xC1, 0x66)
#define REG_SC_BKC1_67_L      _PK_L_(0xC1, 0x67)
#define REG_SC_BKC1_67_H      _PK_H_(0xC1, 0x67)
#define REG_SC_BKC1_68_L      _PK_L_(0xC1, 0x68)
#define REG_SC_BKC1_68_H      _PK_H_(0xC1, 0x68)
#define REG_SC_BKC1_69_L      _PK_L_(0xC1, 0x69)
#define REG_SC_BKC1_69_H      _PK_H_(0xC1, 0x69)
#define REG_SC_BKC1_6A_L      _PK_L_(0xC1, 0x6A)
#define REG_SC_BKC1_6A_H      _PK_H_(0xC1, 0x6A)
#define REG_SC_BKC1_6B_L      _PK_L_(0xC1, 0x6B)
#define REG_SC_BKC1_6B_H      _PK_H_(0xC1, 0x6B)
#define REG_SC_BKC1_6C_L      _PK_L_(0xC1, 0x6C)
#define REG_SC_BKC1_6C_H      _PK_H_(0xC1, 0x6C)
#define REG_SC_BKC1_6D_L      _PK_L_(0xC1, 0x6D)
#define REG_SC_BKC1_6D_H      _PK_H_(0xC1, 0x6D)
#define REG_SC_BKC1_6E_L      _PK_L_(0xC1, 0x6E)
#define REG_SC_BKC1_6E_H      _PK_H_(0xC1, 0x6E)
#define REG_SC_BKC1_6F_L      _PK_L_(0xC1, 0x6F)
#define REG_SC_BKC1_6F_H      _PK_H_(0xC1, 0x6F)
#define REG_SC_BKC1_70_L      _PK_L_(0xC1, 0x70)
#define REG_SC_BKC1_70_H      _PK_H_(0xC1, 0x70)
#define REG_SC_BKC1_71_L      _PK_L_(0xC1, 0x71)
#define REG_SC_BKC1_71_H      _PK_H_(0xC1, 0x71)
#define REG_SC_BKC1_72_L      _PK_L_(0xC1, 0x72)
#define REG_SC_BKC1_72_H      _PK_H_(0xC1, 0x72)
#define REG_SC_BKC1_73_L      _PK_L_(0xC1, 0x73)
#define REG_SC_BKC1_73_H      _PK_H_(0xC1, 0x73)
#define REG_SC_BKC1_74_L      _PK_L_(0xC1, 0x74)
#define REG_SC_BKC1_74_H      _PK_H_(0xC1, 0x74)
#define REG_SC_BKC1_75_L      _PK_L_(0xC1, 0x75)
#define REG_SC_BKC1_75_H      _PK_H_(0xC1, 0x75)
#define REG_SC_BKC1_76_L      _PK_L_(0xC1, 0x76)
#define REG_SC_BKC1_76_H      _PK_H_(0xC1, 0x76)
#define REG_SC_BKC1_77_L      _PK_L_(0xC1, 0x77)
#define REG_SC_BKC1_77_H      _PK_H_(0xC1, 0x77)
#define REG_SC_BKC1_78_L      _PK_L_(0xC1, 0x78)
#define REG_SC_BKC1_78_H      _PK_H_(0xC1, 0x78)
#define REG_SC_BKC1_79_L      _PK_L_(0xC1, 0x79)
#define REG_SC_BKC1_79_H      _PK_H_(0xC1, 0x79)
#define REG_SC_BKC1_7A_L      _PK_L_(0xC1, 0x7A)
#define REG_SC_BKC1_7A_H      _PK_H_(0xC1, 0x7A)
#define REG_SC_BKC1_7B_L      _PK_L_(0xC1, 0x7B)
#define REG_SC_BKC1_7B_H      _PK_H_(0xC1, 0x7B)
#define REG_SC_BKC1_7C_L      _PK_L_(0xC1, 0x7C)
#define REG_SC_BKC1_7C_H      _PK_H_(0xC1, 0x7C)
#define REG_SC_BKC1_7D_L      _PK_L_(0xC1, 0x7D)
#define REG_SC_BKC1_7D_H      _PK_H_(0xC1, 0x7D)
#define REG_SC_BKC1_7E_L      _PK_L_(0xC1, 0x7E)
#define REG_SC_BKC1_7E_H      _PK_H_(0xC1, 0x7E)
#define REG_SC_BKC1_7F_L      _PK_L_(0xC1, 0x7F)
#define REG_SC_BKC1_7F_H      _PK_H_(0xC1, 0x7F)

//----------------------------------------------
//  BKC2
//----------------------------------------------
#define REG_SC_BKC2_00_L      _PK_L_(0xC2, 0x00)
#define REG_SC_BKC2_00_H      _PK_H_(0xC2, 0x00)
#define REG_SC_BKC2_01_L      _PK_L_(0xC2, 0x01)
#define REG_SC_BKC2_01_H      _PK_H_(0xC2, 0x01)
#define REG_SC_BKC2_02_L      _PK_L_(0xC2, 0x02)
#define REG_SC_BKC2_02_H      _PK_H_(0xC2, 0x02)
#define REG_SC_BKC2_03_L      _PK_L_(0xC2, 0x03)
#define REG_SC_BKC2_03_H      _PK_H_(0xC2, 0x03)
#define REG_SC_BKC2_04_L      _PK_L_(0xC2, 0x04)
#define REG_SC_BKC2_04_H      _PK_H_(0xC2, 0x04)
#define REG_SC_BKC2_05_L      _PK_L_(0xC2, 0x05)
#define REG_SC_BKC2_05_H      _PK_H_(0xC2, 0x05)
#define REG_SC_BKC2_06_L      _PK_L_(0xC2, 0x06)
#define REG_SC_BKC2_06_H      _PK_H_(0xC2, 0x06)
#define REG_SC_BKC2_07_L      _PK_L_(0xC2, 0x07)
#define REG_SC_BKC2_07_H      _PK_H_(0xC2, 0x07)
#define REG_SC_BKC2_08_L      _PK_L_(0xC2, 0x08)
#define REG_SC_BKC2_08_H      _PK_H_(0xC2, 0x08)
#define REG_SC_BKC2_09_L      _PK_L_(0xC2, 0x09)
#define REG_SC_BKC2_09_H      _PK_H_(0xC2, 0x09)
#define REG_SC_BKC2_0A_L      _PK_L_(0xC2, 0x0A)
#define REG_SC_BKC2_0A_H      _PK_H_(0xC2, 0x0A)
#define REG_SC_BKC2_0B_L      _PK_L_(0xC2, 0x0B)
#define REG_SC_BKC2_0B_H      _PK_H_(0xC2, 0x0B)
#define REG_SC_BKC2_0C_L      _PK_L_(0xC2, 0x0C)
#define REG_SC_BKC2_0C_H      _PK_H_(0xC2, 0x0C)
#define REG_SC_BKC2_0D_L      _PK_L_(0xC2, 0x0D)
#define REG_SC_BKC2_0D_H      _PK_H_(0xC2, 0x0D)
#define REG_SC_BKC2_0E_L      _PK_L_(0xC2, 0x0E)
#define REG_SC_BKC2_0E_H      _PK_H_(0xC2, 0x0E)
#define REG_SC_BKC2_0F_L      _PK_L_(0xC2, 0x0F)
#define REG_SC_BKC2_0F_H      _PK_H_(0xC2, 0x0F)
#define REG_SC_BKC2_10_L      _PK_L_(0xC2, 0x10)
#define REG_SC_BKC2_10_H      _PK_H_(0xC2, 0x10)
#define REG_SC_BKC2_11_L      _PK_L_(0xC2, 0x11)
#define REG_SC_BKC2_11_H      _PK_H_(0xC2, 0x11)
#define REG_SC_BKC2_12_L      _PK_L_(0xC2, 0x12)
#define REG_SC_BKC2_12_H      _PK_H_(0xC2, 0x12)
#define REG_SC_BKC2_13_L      _PK_L_(0xC2, 0x13)
#define REG_SC_BKC2_13_H      _PK_H_(0xC2, 0x13)
#define REG_SC_BKC2_14_L      _PK_L_(0xC2, 0x14)
#define REG_SC_BKC2_14_H      _PK_H_(0xC2, 0x14)
#define REG_SC_BKC2_15_L      _PK_L_(0xC2, 0x15)
#define REG_SC_BKC2_15_H      _PK_H_(0xC2, 0x15)
#define REG_SC_BKC2_16_L      _PK_L_(0xC2, 0x16)
#define REG_SC_BKC2_16_H      _PK_H_(0xC2, 0x16)
#define REG_SC_BKC2_17_L      _PK_L_(0xC2, 0x17)
#define REG_SC_BKC2_17_H      _PK_H_(0xC2, 0x17)
#define REG_SC_BKC2_18_L      _PK_L_(0xC2, 0x18)
#define REG_SC_BKC2_18_H      _PK_H_(0xC2, 0x18)
#define REG_SC_BKC2_19_L      _PK_L_(0xC2, 0x19)
#define REG_SC_BKC2_19_H      _PK_H_(0xC2, 0x19)
#define REG_SC_BKC2_1A_L      _PK_L_(0xC2, 0x1A)
#define REG_SC_BKC2_1A_H      _PK_H_(0xC2, 0x1A)
#define REG_SC_BKC2_1B_L      _PK_L_(0xC2, 0x1B)
#define REG_SC_BKC2_1B_H      _PK_H_(0xC2, 0x1B)
#define REG_SC_BKC2_1C_L      _PK_L_(0xC2, 0x1C)
#define REG_SC_BKC2_1C_H      _PK_H_(0xC2, 0x1C)
#define REG_SC_BKC2_1D_L      _PK_L_(0xC2, 0x1D)
#define REG_SC_BKC2_1D_H      _PK_H_(0xC2, 0x1D)
#define REG_SC_BKC2_1E_L      _PK_L_(0xC2, 0x1E)
#define REG_SC_BKC2_1E_H      _PK_H_(0xC2, 0x1E)
#define REG_SC_BKC2_1F_L      _PK_L_(0xC2, 0x1F)
#define REG_SC_BKC2_1F_H      _PK_H_(0xC2, 0x1F)
#define REG_SC_BKC2_20_L      _PK_L_(0xC2, 0x20)
#define REG_SC_BKC2_20_H      _PK_H_(0xC2, 0x20)
#define REG_SC_BKC2_21_L      _PK_L_(0xC2, 0x21)
#define REG_SC_BKC2_21_H      _PK_H_(0xC2, 0x21)
#define REG_SC_BKC2_22_L      _PK_L_(0xC2, 0x22)
#define REG_SC_BKC2_22_H      _PK_H_(0xC2, 0x22)
#define REG_SC_BKC2_23_L      _PK_L_(0xC2, 0x23)
#define REG_SC_BKC2_23_H      _PK_H_(0xC2, 0x23)
#define REG_SC_BKC2_24_L      _PK_L_(0xC2, 0x24)
#define REG_SC_BKC2_24_H      _PK_H_(0xC2, 0x24)
#define REG_SC_BKC2_25_L      _PK_L_(0xC2, 0x25)
#define REG_SC_BKC2_25_H      _PK_H_(0xC2, 0x25)
#define REG_SC_BKC2_26_L      _PK_L_(0xC2, 0x26)
#define REG_SC_BKC2_26_H      _PK_H_(0xC2, 0x26)
#define REG_SC_BKC2_27_L      _PK_L_(0xC2, 0x27)
#define REG_SC_BKC2_27_H      _PK_H_(0xC2, 0x27)
#define REG_SC_BKC2_28_L      _PK_L_(0xC2, 0x28)
#define REG_SC_BKC2_28_H      _PK_H_(0xC2, 0x28)
#define REG_SC_BKC2_29_L      _PK_L_(0xC2, 0x29)
#define REG_SC_BKC2_29_H      _PK_H_(0xC2, 0x29)
#define REG_SC_BKC2_2A_L      _PK_L_(0xC2, 0x2A)
#define REG_SC_BKC2_2A_H      _PK_H_(0xC2, 0x2A)
#define REG_SC_BKC2_2B_L      _PK_L_(0xC2, 0x2B)
#define REG_SC_BKC2_2B_H      _PK_H_(0xC2, 0x2B)
#define REG_SC_BKC2_2C_L      _PK_L_(0xC2, 0x2C)
#define REG_SC_BKC2_2C_H      _PK_H_(0xC2, 0x2C)
#define REG_SC_BKC2_2D_L      _PK_L_(0xC2, 0x2D)
#define REG_SC_BKC2_2D_H      _PK_H_(0xC2, 0x2D)
#define REG_SC_BKC2_2E_L      _PK_L_(0xC2, 0x2E)
#define REG_SC_BKC2_2E_H      _PK_H_(0xC2, 0x2E)
#define REG_SC_BKC2_2F_L      _PK_L_(0xC2, 0x2F)
#define REG_SC_BKC2_2F_H      _PK_H_(0xC2, 0x2F)
#define REG_SC_BKC2_30_L      _PK_L_(0xC2, 0x30)
#define REG_SC_BKC2_30_H      _PK_H_(0xC2, 0x30)
#define REG_SC_BKC2_31_L      _PK_L_(0xC2, 0x31)
#define REG_SC_BKC2_31_H      _PK_H_(0xC2, 0x31)
#define REG_SC_BKC2_32_L      _PK_L_(0xC2, 0x32)
#define REG_SC_BKC2_32_H      _PK_H_(0xC2, 0x32)
#define REG_SC_BKC2_33_L      _PK_L_(0xC2, 0x33)
#define REG_SC_BKC2_33_H      _PK_H_(0xC2, 0x33)
#define REG_SC_BKC2_34_L      _PK_L_(0xC2, 0x34)
#define REG_SC_BKC2_34_H      _PK_H_(0xC2, 0x34)
#define REG_SC_BKC2_35_L      _PK_L_(0xC2, 0x35)
#define REG_SC_BKC2_35_H      _PK_H_(0xC2, 0x35)
#define REG_SC_BKC2_36_L      _PK_L_(0xC2, 0x36)
#define REG_SC_BKC2_36_H      _PK_H_(0xC2, 0x36)
#define REG_SC_BKC2_37_L      _PK_L_(0xC2, 0x37)
#define REG_SC_BKC2_37_H      _PK_H_(0xC2, 0x37)
#define REG_SC_BKC2_38_L      _PK_L_(0xC2, 0x38)
#define REG_SC_BKC2_38_H      _PK_H_(0xC2, 0x38)
#define REG_SC_BKC2_39_L      _PK_L_(0xC2, 0x39)
#define REG_SC_BKC2_39_H      _PK_H_(0xC2, 0x39)
#define REG_SC_BKC2_3A_L      _PK_L_(0xC2, 0x3A)
#define REG_SC_BKC2_3A_H      _PK_H_(0xC2, 0x3A)
#define REG_SC_BKC2_3B_L      _PK_L_(0xC2, 0x3B)
#define REG_SC_BKC2_3B_H      _PK_H_(0xC2, 0x3B)
#define REG_SC_BKC2_3C_L      _PK_L_(0xC2, 0x3C)
#define REG_SC_BKC2_3C_H      _PK_H_(0xC2, 0x3C)
#define REG_SC_BKC2_3D_L      _PK_L_(0xC2, 0x3D)
#define REG_SC_BKC2_3D_H      _PK_H_(0xC2, 0x3D)
#define REG_SC_BKC2_3E_L      _PK_L_(0xC2, 0x3E)
#define REG_SC_BKC2_3E_H      _PK_H_(0xC2, 0x3E)
#define REG_SC_BKC2_3F_L      _PK_L_(0xC2, 0x3F)
#define REG_SC_BKC2_3F_H      _PK_H_(0xC2, 0x3F)
#define REG_SC_BKC2_40_L      _PK_L_(0xC2, 0x40)
#define REG_SC_BKC2_40_H      _PK_H_(0xC2, 0x40)
#define REG_SC_BKC2_41_L      _PK_L_(0xC2, 0x41)
#define REG_SC_BKC2_41_H      _PK_H_(0xC2, 0x41)
#define REG_SC_BKC2_42_L      _PK_L_(0xC2, 0x42)
#define REG_SC_BKC2_42_H      _PK_H_(0xC2, 0x42)
#define REG_SC_BKC2_43_L      _PK_L_(0xC2, 0x43)
#define REG_SC_BKC2_43_H      _PK_H_(0xC2, 0x43)
#define REG_SC_BKC2_44_L      _PK_L_(0xC2, 0x44)
#define REG_SC_BKC2_44_H      _PK_H_(0xC2, 0x44)
#define REG_SC_BKC2_45_L      _PK_L_(0xC2, 0x45)
#define REG_SC_BKC2_45_H      _PK_H_(0xC2, 0x45)
#define REG_SC_BKC2_46_L      _PK_L_(0xC2, 0x46)
#define REG_SC_BKC2_46_H      _PK_H_(0xC2, 0x46)
#define REG_SC_BKC2_47_L      _PK_L_(0xC2, 0x47)
#define REG_SC_BKC2_47_H      _PK_H_(0xC2, 0x47)
#define REG_SC_BKC2_48_L      _PK_L_(0xC2, 0x48)
#define REG_SC_BKC2_48_H      _PK_H_(0xC2, 0x48)
#define REG_SC_BKC2_49_L      _PK_L_(0xC2, 0x49)
#define REG_SC_BKC2_49_H      _PK_H_(0xC2, 0x49)
#define REG_SC_BKC2_4A_L      _PK_L_(0xC2, 0x4A)
#define REG_SC_BKC2_4A_H      _PK_H_(0xC2, 0x4A)
#define REG_SC_BKC2_4B_L      _PK_L_(0xC2, 0x4B)
#define REG_SC_BKC2_4B_H      _PK_H_(0xC2, 0x4B)
#define REG_SC_BKC2_4C_L      _PK_L_(0xC2, 0x4C)
#define REG_SC_BKC2_4C_H      _PK_H_(0xC2, 0x4C)
#define REG_SC_BKC2_4D_L      _PK_L_(0xC2, 0x4D)
#define REG_SC_BKC2_4D_H      _PK_H_(0xC2, 0x4D)
#define REG_SC_BKC2_4E_L      _PK_L_(0xC2, 0x4E)
#define REG_SC_BKC2_4E_H      _PK_H_(0xC2, 0x4E)
#define REG_SC_BKC2_4F_L      _PK_L_(0xC2, 0x4F)
#define REG_SC_BKC2_4F_H      _PK_H_(0xC2, 0x4F)
#define REG_SC_BKC2_50_L      _PK_L_(0xC2, 0x50)
#define REG_SC_BKC2_50_H      _PK_H_(0xC2, 0x50)
#define REG_SC_BKC2_51_L      _PK_L_(0xC2, 0x51)
#define REG_SC_BKC2_51_H      _PK_H_(0xC2, 0x51)
#define REG_SC_BKC2_52_L      _PK_L_(0xC2, 0x52)
#define REG_SC_BKC2_52_H      _PK_H_(0xC2, 0x52)
#define REG_SC_BKC2_53_L      _PK_L_(0xC2, 0x53)
#define REG_SC_BKC2_53_H      _PK_H_(0xC2, 0x53)
#define REG_SC_BKC2_54_L      _PK_L_(0xC2, 0x54)
#define REG_SC_BKC2_54_H      _PK_H_(0xC2, 0x54)
#define REG_SC_BKC2_55_L      _PK_L_(0xC2, 0x55)
#define REG_SC_BKC2_55_H      _PK_H_(0xC2, 0x55)
#define REG_SC_BKC2_56_L      _PK_L_(0xC2, 0x56)
#define REG_SC_BKC2_56_H      _PK_H_(0xC2, 0x56)
#define REG_SC_BKC2_57_L      _PK_L_(0xC2, 0x57)
#define REG_SC_BKC2_57_H      _PK_H_(0xC2, 0x57)
#define REG_SC_BKC2_58_L      _PK_L_(0xC2, 0x58)
#define REG_SC_BKC2_58_H      _PK_H_(0xC2, 0x58)
#define REG_SC_BKC2_59_L      _PK_L_(0xC2, 0x59)
#define REG_SC_BKC2_59_H      _PK_H_(0xC2, 0x59)
#define REG_SC_BKC2_5A_L      _PK_L_(0xC2, 0x5A)
#define REG_SC_BKC2_5A_H      _PK_H_(0xC2, 0x5A)
#define REG_SC_BKC2_5B_L      _PK_L_(0xC2, 0x5B)
#define REG_SC_BKC2_5B_H      _PK_H_(0xC2, 0x5B)
#define REG_SC_BKC2_5C_L      _PK_L_(0xC2, 0x5C)
#define REG_SC_BKC2_5C_H      _PK_H_(0xC2, 0x5C)
#define REG_SC_BKC2_5D_L      _PK_L_(0xC2, 0x5D)
#define REG_SC_BKC2_5D_H      _PK_H_(0xC2, 0x5D)
#define REG_SC_BKC2_5E_L      _PK_L_(0xC2, 0x5E)
#define REG_SC_BKC2_5E_H      _PK_H_(0xC2, 0x5E)
#define REG_SC_BKC2_5F_L      _PK_L_(0xC2, 0x5F)
#define REG_SC_BKC2_5F_H      _PK_H_(0xC2, 0x5F)
#define REG_SC_BKC2_60_L      _PK_L_(0xC2, 0x60)
#define REG_SC_BKC2_60_H      _PK_H_(0xC2, 0x60)
#define REG_SC_BKC2_61_L      _PK_L_(0xC2, 0x61)
#define REG_SC_BKC2_61_H      _PK_H_(0xC2, 0x61)
#define REG_SC_BKC2_62_L      _PK_L_(0xC2, 0x62)
#define REG_SC_BKC2_62_H      _PK_H_(0xC2, 0x62)
#define REG_SC_BKC2_63_L      _PK_L_(0xC2, 0x63)
#define REG_SC_BKC2_63_H      _PK_H_(0xC2, 0x63)
#define REG_SC_BKC2_64_L      _PK_L_(0xC2, 0x64)
#define REG_SC_BKC2_64_H      _PK_H_(0xC2, 0x64)
#define REG_SC_BKC2_65_L      _PK_L_(0xC2, 0x65)
#define REG_SC_BKC2_65_H      _PK_H_(0xC2, 0x65)
#define REG_SC_BKC2_66_L      _PK_L_(0xC2, 0x66)
#define REG_SC_BKC2_66_H      _PK_H_(0xC2, 0x66)
#define REG_SC_BKC2_67_L      _PK_L_(0xC2, 0x67)
#define REG_SC_BKC2_67_H      _PK_H_(0xC2, 0x67)
#define REG_SC_BKC2_68_L      _PK_L_(0xC2, 0x68)
#define REG_SC_BKC2_68_H      _PK_H_(0xC2, 0x68)
#define REG_SC_BKC2_69_L      _PK_L_(0xC2, 0x69)
#define REG_SC_BKC2_69_H      _PK_H_(0xC2, 0x69)
#define REG_SC_BKC2_6A_L      _PK_L_(0xC2, 0x6A)
#define REG_SC_BKC2_6A_H      _PK_H_(0xC2, 0x6A)
#define REG_SC_BKC2_6B_L      _PK_L_(0xC2, 0x6B)
#define REG_SC_BKC2_6B_H      _PK_H_(0xC2, 0x6B)
#define REG_SC_BKC2_6C_L      _PK_L_(0xC2, 0x6C)
#define REG_SC_BKC2_6C_H      _PK_H_(0xC2, 0x6C)
#define REG_SC_BKC2_6D_L      _PK_L_(0xC2, 0x6D)
#define REG_SC_BKC2_6D_H      _PK_H_(0xC2, 0x6D)
#define REG_SC_BKC2_6E_L      _PK_L_(0xC2, 0x6E)
#define REG_SC_BKC2_6E_H      _PK_H_(0xC2, 0x6E)
#define REG_SC_BKC2_6F_L      _PK_L_(0xC2, 0x6F)
#define REG_SC_BKC2_6F_H      _PK_H_(0xC2, 0x6F)
#define REG_SC_BKC2_70_L      _PK_L_(0xC2, 0x70)
#define REG_SC_BKC2_70_H      _PK_H_(0xC2, 0x70)
#define REG_SC_BKC2_71_L      _PK_L_(0xC2, 0x71)
#define REG_SC_BKC2_71_H      _PK_H_(0xC2, 0x71)
#define REG_SC_BKC2_72_L      _PK_L_(0xC2, 0x72)
#define REG_SC_BKC2_72_H      _PK_H_(0xC2, 0x72)
#define REG_SC_BKC2_73_L      _PK_L_(0xC2, 0x73)
#define REG_SC_BKC2_73_H      _PK_H_(0xC2, 0x73)
#define REG_SC_BKC2_74_L      _PK_L_(0xC2, 0x74)
#define REG_SC_BKC2_74_H      _PK_H_(0xC2, 0x74)
#define REG_SC_BKC2_75_L      _PK_L_(0xC2, 0x75)
#define REG_SC_BKC2_75_H      _PK_H_(0xC2, 0x75)
#define REG_SC_BKC2_76_L      _PK_L_(0xC2, 0x76)
#define REG_SC_BKC2_76_H      _PK_H_(0xC2, 0x76)
#define REG_SC_BKC2_77_L      _PK_L_(0xC2, 0x77)
#define REG_SC_BKC2_77_H      _PK_H_(0xC2, 0x77)
#define REG_SC_BKC2_78_L      _PK_L_(0xC2, 0x78)
#define REG_SC_BKC2_78_H      _PK_H_(0xC2, 0x78)
#define REG_SC_BKC2_79_L      _PK_L_(0xC2, 0x79)
#define REG_SC_BKC2_79_H      _PK_H_(0xC2, 0x79)
#define REG_SC_BKC2_7A_L      _PK_L_(0xC2, 0x7A)
#define REG_SC_BKC2_7A_H      _PK_H_(0xC2, 0x7A)
#define REG_SC_BKC2_7B_L      _PK_L_(0xC2, 0x7B)
#define REG_SC_BKC2_7B_H      _PK_H_(0xC2, 0x7B)
#define REG_SC_BKC2_7C_L      _PK_L_(0xC2, 0x7C)
#define REG_SC_BKC2_7C_H      _PK_H_(0xC2, 0x7C)
#define REG_SC_BKC2_7D_L      _PK_L_(0xC2, 0x7D)
#define REG_SC_BKC2_7D_H      _PK_H_(0xC2, 0x7D)
#define REG_SC_BKC2_7E_L      _PK_L_(0xC2, 0x7E)
#define REG_SC_BKC2_7E_H      _PK_H_(0xC2, 0x7E)
#define REG_SC_BKC2_7F_L      _PK_L_(0xC2, 0x7F)
#define REG_SC_BKC2_7F_H      _PK_H_(0xC2, 0x7F)

//----------------------------------------------
//  BKC3
//----------------------------------------------
#define REG_SC_BKC3_00_L      _PK_L_(0xC3, 0x00)
#define REG_SC_BKC3_00_H      _PK_H_(0xC3, 0x00)
#define REG_SC_BKC3_01_L      _PK_L_(0xC3, 0x01)
#define REG_SC_BKC3_01_H      _PK_H_(0xC3, 0x01)
#define REG_SC_BKC3_02_L      _PK_L_(0xC3, 0x02)
#define REG_SC_BKC3_02_H      _PK_H_(0xC3, 0x02)
#define REG_SC_BKC3_03_L      _PK_L_(0xC3, 0x03)
#define REG_SC_BKC3_03_H      _PK_H_(0xC3, 0x03)
#define REG_SC_BKC3_04_L      _PK_L_(0xC3, 0x04)
#define REG_SC_BKC3_04_H      _PK_H_(0xC3, 0x04)
#define REG_SC_BKC3_05_L      _PK_L_(0xC3, 0x05)
#define REG_SC_BKC3_05_H      _PK_H_(0xC3, 0x05)
#define REG_SC_BKC3_06_L      _PK_L_(0xC3, 0x06)
#define REG_SC_BKC3_06_H      _PK_H_(0xC3, 0x06)
#define REG_SC_BKC3_07_L      _PK_L_(0xC3, 0x07)
#define REG_SC_BKC3_07_H      _PK_H_(0xC3, 0x07)
#define REG_SC_BKC3_08_L      _PK_L_(0xC3, 0x08)
#define REG_SC_BKC3_08_H      _PK_H_(0xC3, 0x08)
#define REG_SC_BKC3_09_L      _PK_L_(0xC3, 0x09)
#define REG_SC_BKC3_09_H      _PK_H_(0xC3, 0x09)
#define REG_SC_BKC3_0A_L      _PK_L_(0xC3, 0x0A)
#define REG_SC_BKC3_0A_H      _PK_H_(0xC3, 0x0A)
#define REG_SC_BKC3_0B_L      _PK_L_(0xC3, 0x0B)
#define REG_SC_BKC3_0B_H      _PK_H_(0xC3, 0x0B)
#define REG_SC_BKC3_0C_L      _PK_L_(0xC3, 0x0C)
#define REG_SC_BKC3_0C_H      _PK_H_(0xC3, 0x0C)
#define REG_SC_BKC3_0D_L      _PK_L_(0xC3, 0x0D)
#define REG_SC_BKC3_0D_H      _PK_H_(0xC3, 0x0D)
#define REG_SC_BKC3_0E_L      _PK_L_(0xC3, 0x0E)
#define REG_SC_BKC3_0E_H      _PK_H_(0xC3, 0x0E)
#define REG_SC_BKC3_0F_L      _PK_L_(0xC3, 0x0F)
#define REG_SC_BKC3_0F_H      _PK_H_(0xC3, 0x0F)
#define REG_SC_BKC3_10_L      _PK_L_(0xC3, 0x10)
#define REG_SC_BKC3_10_H      _PK_H_(0xC3, 0x10)
#define REG_SC_BKC3_11_L      _PK_L_(0xC3, 0x11)
#define REG_SC_BKC3_11_H      _PK_H_(0xC3, 0x11)
#define REG_SC_BKC3_12_L      _PK_L_(0xC3, 0x12)
#define REG_SC_BKC3_12_H      _PK_H_(0xC3, 0x12)
#define REG_SC_BKC3_13_L      _PK_L_(0xC3, 0x13)
#define REG_SC_BKC3_13_H      _PK_H_(0xC3, 0x13)
#define REG_SC_BKC3_14_L      _PK_L_(0xC3, 0x14)
#define REG_SC_BKC3_14_H      _PK_H_(0xC3, 0x14)
#define REG_SC_BKC3_15_L      _PK_L_(0xC3, 0x15)
#define REG_SC_BKC3_15_H      _PK_H_(0xC3, 0x15)
#define REG_SC_BKC3_16_L      _PK_L_(0xC3, 0x16)
#define REG_SC_BKC3_16_H      _PK_H_(0xC3, 0x16)
#define REG_SC_BKC3_17_L      _PK_L_(0xC3, 0x17)
#define REG_SC_BKC3_17_H      _PK_H_(0xC3, 0x17)
#define REG_SC_BKC3_18_L      _PK_L_(0xC3, 0x18)
#define REG_SC_BKC3_18_H      _PK_H_(0xC3, 0x18)
#define REG_SC_BKC3_19_L      _PK_L_(0xC3, 0x19)
#define REG_SC_BKC3_19_H      _PK_H_(0xC3, 0x19)
#define REG_SC_BKC3_1A_L      _PK_L_(0xC3, 0x1A)
#define REG_SC_BKC3_1A_H      _PK_H_(0xC3, 0x1A)
#define REG_SC_BKC3_1B_L      _PK_L_(0xC3, 0x1B)
#define REG_SC_BKC3_1B_H      _PK_H_(0xC3, 0x1B)
#define REG_SC_BKC3_1C_L      _PK_L_(0xC3, 0x1C)
#define REG_SC_BKC3_1C_H      _PK_H_(0xC3, 0x1C)
#define REG_SC_BKC3_1D_L      _PK_L_(0xC3, 0x1D)
#define REG_SC_BKC3_1D_H      _PK_H_(0xC3, 0x1D)
#define REG_SC_BKC3_1E_L      _PK_L_(0xC3, 0x1E)
#define REG_SC_BKC3_1E_H      _PK_H_(0xC3, 0x1E)
#define REG_SC_BKC3_1F_L      _PK_L_(0xC3, 0x1F)
#define REG_SC_BKC3_1F_H      _PK_H_(0xC3, 0x1F)
#define REG_SC_BKC3_20_L      _PK_L_(0xC3, 0x20)
#define REG_SC_BKC3_20_H      _PK_H_(0xC3, 0x20)
#define REG_SC_BKC3_21_L      _PK_L_(0xC3, 0x21)
#define REG_SC_BKC3_21_H      _PK_H_(0xC3, 0x21)
#define REG_SC_BKC3_22_L      _PK_L_(0xC3, 0x22)
#define REG_SC_BKC3_22_H      _PK_H_(0xC3, 0x22)
#define REG_SC_BKC3_23_L      _PK_L_(0xC3, 0x23)
#define REG_SC_BKC3_23_H      _PK_H_(0xC3, 0x23)
#define REG_SC_BKC3_24_L      _PK_L_(0xC3, 0x24)
#define REG_SC_BKC3_24_H      _PK_H_(0xC3, 0x24)
#define REG_SC_BKC3_25_L      _PK_L_(0xC3, 0x25)
#define REG_SC_BKC3_25_H      _PK_H_(0xC3, 0x25)
#define REG_SC_BKC3_26_L      _PK_L_(0xC3, 0x26)
#define REG_SC_BKC3_26_H      _PK_H_(0xC3, 0x26)
#define REG_SC_BKC3_27_L      _PK_L_(0xC3, 0x27)
#define REG_SC_BKC3_27_H      _PK_H_(0xC3, 0x27)
#define REG_SC_BKC3_28_L      _PK_L_(0xC3, 0x28)
#define REG_SC_BKC3_28_H      _PK_H_(0xC3, 0x28)
#define REG_SC_BKC3_29_L      _PK_L_(0xC3, 0x29)
#define REG_SC_BKC3_29_H      _PK_H_(0xC3, 0x29)
#define REG_SC_BKC3_2A_L      _PK_L_(0xC3, 0x2A)
#define REG_SC_BKC3_2A_H      _PK_H_(0xC3, 0x2A)
#define REG_SC_BKC3_2B_L      _PK_L_(0xC3, 0x2B)
#define REG_SC_BKC3_2B_H      _PK_H_(0xC3, 0x2B)
#define REG_SC_BKC3_2C_L      _PK_L_(0xC3, 0x2C)
#define REG_SC_BKC3_2C_H      _PK_H_(0xC3, 0x2C)
#define REG_SC_BKC3_2D_L      _PK_L_(0xC3, 0x2D)
#define REG_SC_BKC3_2D_H      _PK_H_(0xC3, 0x2D)
#define REG_SC_BKC3_2E_L      _PK_L_(0xC3, 0x2E)
#define REG_SC_BKC3_2E_H      _PK_H_(0xC3, 0x2E)
#define REG_SC_BKC3_2F_L      _PK_L_(0xC3, 0x2F)
#define REG_SC_BKC3_2F_H      _PK_H_(0xC3, 0x2F)
#define REG_SC_BKC3_30_L      _PK_L_(0xC3, 0x30)
#define REG_SC_BKC3_30_H      _PK_H_(0xC3, 0x30)
#define REG_SC_BKC3_31_L      _PK_L_(0xC3, 0x31)
#define REG_SC_BKC3_31_H      _PK_H_(0xC3, 0x31)
#define REG_SC_BKC3_32_L      _PK_L_(0xC3, 0x32)
#define REG_SC_BKC3_32_H      _PK_H_(0xC3, 0x32)
#define REG_SC_BKC3_33_L      _PK_L_(0xC3, 0x33)
#define REG_SC_BKC3_33_H      _PK_H_(0xC3, 0x33)
#define REG_SC_BKC3_34_L      _PK_L_(0xC3, 0x34)
#define REG_SC_BKC3_34_H      _PK_H_(0xC3, 0x34)
#define REG_SC_BKC3_35_L      _PK_L_(0xC3, 0x35)
#define REG_SC_BKC3_35_H      _PK_H_(0xC3, 0x35)
#define REG_SC_BKC3_36_L      _PK_L_(0xC3, 0x36)
#define REG_SC_BKC3_36_H      _PK_H_(0xC3, 0x36)
#define REG_SC_BKC3_37_L      _PK_L_(0xC3, 0x37)
#define REG_SC_BKC3_37_H      _PK_H_(0xC3, 0x37)
#define REG_SC_BKC3_38_L      _PK_L_(0xC3, 0x38)
#define REG_SC_BKC3_38_H      _PK_H_(0xC3, 0x38)
#define REG_SC_BKC3_39_L      _PK_L_(0xC3, 0x39)
#define REG_SC_BKC3_39_H      _PK_H_(0xC3, 0x39)
#define REG_SC_BKC3_3A_L      _PK_L_(0xC3, 0x3A)
#define REG_SC_BKC3_3A_H      _PK_H_(0xC3, 0x3A)
#define REG_SC_BKC3_3B_L      _PK_L_(0xC3, 0x3B)
#define REG_SC_BKC3_3B_H      _PK_H_(0xC3, 0x3B)
#define REG_SC_BKC3_3C_L      _PK_L_(0xC3, 0x3C)
#define REG_SC_BKC3_3C_H      _PK_H_(0xC3, 0x3C)
#define REG_SC_BKC3_3D_L      _PK_L_(0xC3, 0x3D)
#define REG_SC_BKC3_3D_H      _PK_H_(0xC3, 0x3D)
#define REG_SC_BKC3_3E_L      _PK_L_(0xC3, 0x3E)
#define REG_SC_BKC3_3E_H      _PK_H_(0xC3, 0x3E)
#define REG_SC_BKC3_3F_L      _PK_L_(0xC3, 0x3F)
#define REG_SC_BKC3_3F_H      _PK_H_(0xC3, 0x3F)
#define REG_SC_BKC3_40_L      _PK_L_(0xC3, 0x40)
#define REG_SC_BKC3_40_H      _PK_H_(0xC3, 0x40)
#define REG_SC_BKC3_41_L      _PK_L_(0xC3, 0x41)
#define REG_SC_BKC3_41_H      _PK_H_(0xC3, 0x41)
#define REG_SC_BKC3_42_L      _PK_L_(0xC3, 0x42)
#define REG_SC_BKC3_42_H      _PK_H_(0xC3, 0x42)
#define REG_SC_BKC3_43_L      _PK_L_(0xC3, 0x43)
#define REG_SC_BKC3_43_H      _PK_H_(0xC3, 0x43)
#define REG_SC_BKC3_44_L      _PK_L_(0xC3, 0x44)
#define REG_SC_BKC3_44_H      _PK_H_(0xC3, 0x44)
#define REG_SC_BKC3_45_L      _PK_L_(0xC3, 0x45)
#define REG_SC_BKC3_45_H      _PK_H_(0xC3, 0x45)
#define REG_SC_BKC3_46_L      _PK_L_(0xC3, 0x46)
#define REG_SC_BKC3_46_H      _PK_H_(0xC3, 0x46)
#define REG_SC_BKC3_47_L      _PK_L_(0xC3, 0x47)
#define REG_SC_BKC3_47_H      _PK_H_(0xC3, 0x47)
#define REG_SC_BKC3_48_L      _PK_L_(0xC3, 0x48)
#define REG_SC_BKC3_48_H      _PK_H_(0xC3, 0x48)
#define REG_SC_BKC3_49_L      _PK_L_(0xC3, 0x49)
#define REG_SC_BKC3_49_H      _PK_H_(0xC3, 0x49)
#define REG_SC_BKC3_4A_L      _PK_L_(0xC3, 0x4A)
#define REG_SC_BKC3_4A_H      _PK_H_(0xC3, 0x4A)
#define REG_SC_BKC3_4B_L      _PK_L_(0xC3, 0x4B)
#define REG_SC_BKC3_4B_H      _PK_H_(0xC3, 0x4B)
#define REG_SC_BKC3_4C_L      _PK_L_(0xC3, 0x4C)
#define REG_SC_BKC3_4C_H      _PK_H_(0xC3, 0x4C)
#define REG_SC_BKC3_4D_L      _PK_L_(0xC3, 0x4D)
#define REG_SC_BKC3_4D_H      _PK_H_(0xC3, 0x4D)
#define REG_SC_BKC3_4E_L      _PK_L_(0xC3, 0x4E)
#define REG_SC_BKC3_4E_H      _PK_H_(0xC3, 0x4E)
#define REG_SC_BKC3_4F_L      _PK_L_(0xC3, 0x4F)
#define REG_SC_BKC3_4F_H      _PK_H_(0xC3, 0x4F)
#define REG_SC_BKC3_50_L      _PK_L_(0xC3, 0x50)
#define REG_SC_BKC3_50_H      _PK_H_(0xC3, 0x50)
#define REG_SC_BKC3_51_L      _PK_L_(0xC3, 0x51)
#define REG_SC_BKC3_51_H      _PK_H_(0xC3, 0x51)
#define REG_SC_BKC3_52_L      _PK_L_(0xC3, 0x52)
#define REG_SC_BKC3_52_H      _PK_H_(0xC3, 0x52)
#define REG_SC_BKC3_53_L      _PK_L_(0xC3, 0x53)
#define REG_SC_BKC3_53_H      _PK_H_(0xC3, 0x53)
#define REG_SC_BKC3_54_L      _PK_L_(0xC3, 0x54)
#define REG_SC_BKC3_54_H      _PK_H_(0xC3, 0x54)
#define REG_SC_BKC3_55_L      _PK_L_(0xC3, 0x55)
#define REG_SC_BKC3_55_H      _PK_H_(0xC3, 0x55)
#define REG_SC_BKC3_56_L      _PK_L_(0xC3, 0x56)
#define REG_SC_BKC3_56_H      _PK_H_(0xC3, 0x56)
#define REG_SC_BKC3_57_L      _PK_L_(0xC3, 0x57)
#define REG_SC_BKC3_57_H      _PK_H_(0xC3, 0x57)
#define REG_SC_BKC3_58_L      _PK_L_(0xC3, 0x58)
#define REG_SC_BKC3_58_H      _PK_H_(0xC3, 0x58)
#define REG_SC_BKC3_59_L      _PK_L_(0xC3, 0x59)
#define REG_SC_BKC3_59_H      _PK_H_(0xC3, 0x59)
#define REG_SC_BKC3_5A_L      _PK_L_(0xC3, 0x5A)
#define REG_SC_BKC3_5A_H      _PK_H_(0xC3, 0x5A)
#define REG_SC_BKC3_5B_L      _PK_L_(0xC3, 0x5B)
#define REG_SC_BKC3_5B_H      _PK_H_(0xC3, 0x5B)
#define REG_SC_BKC3_5C_L      _PK_L_(0xC3, 0x5C)
#define REG_SC_BKC3_5C_H      _PK_H_(0xC3, 0x5C)
#define REG_SC_BKC3_5D_L      _PK_L_(0xC3, 0x5D)
#define REG_SC_BKC3_5D_H      _PK_H_(0xC3, 0x5D)
#define REG_SC_BKC3_5E_L      _PK_L_(0xC3, 0x5E)
#define REG_SC_BKC3_5E_H      _PK_H_(0xC3, 0x5E)
#define REG_SC_BKC3_5F_L      _PK_L_(0xC3, 0x5F)
#define REG_SC_BKC3_5F_H      _PK_H_(0xC3, 0x5F)
#define REG_SC_BKC3_60_L      _PK_L_(0xC3, 0x60)
#define REG_SC_BKC3_60_H      _PK_H_(0xC3, 0x60)
#define REG_SC_BKC3_61_L      _PK_L_(0xC3, 0x61)
#define REG_SC_BKC3_61_H      _PK_H_(0xC3, 0x61)
#define REG_SC_BKC3_62_L      _PK_L_(0xC3, 0x62)
#define REG_SC_BKC3_62_H      _PK_H_(0xC3, 0x62)
#define REG_SC_BKC3_63_L      _PK_L_(0xC3, 0x63)
#define REG_SC_BKC3_63_H      _PK_H_(0xC3, 0x63)
#define REG_SC_BKC3_64_L      _PK_L_(0xC3, 0x64)
#define REG_SC_BKC3_64_H      _PK_H_(0xC3, 0x64)
#define REG_SC_BKC3_65_L      _PK_L_(0xC3, 0x65)
#define REG_SC_BKC3_65_H      _PK_H_(0xC3, 0x65)
#define REG_SC_BKC3_66_L      _PK_L_(0xC3, 0x66)
#define REG_SC_BKC3_66_H      _PK_H_(0xC3, 0x66)
#define REG_SC_BKC3_67_L      _PK_L_(0xC3, 0x67)
#define REG_SC_BKC3_67_H      _PK_H_(0xC3, 0x67)
#define REG_SC_BKC3_68_L      _PK_L_(0xC3, 0x68)
#define REG_SC_BKC3_68_H      _PK_H_(0xC3, 0x68)
#define REG_SC_BKC3_69_L      _PK_L_(0xC3, 0x69)
#define REG_SC_BKC3_69_H      _PK_H_(0xC3, 0x69)
#define REG_SC_BKC3_6A_L      _PK_L_(0xC3, 0x6A)
#define REG_SC_BKC3_6A_H      _PK_H_(0xC3, 0x6A)
#define REG_SC_BKC3_6B_L      _PK_L_(0xC3, 0x6B)
#define REG_SC_BKC3_6B_H      _PK_H_(0xC3, 0x6B)
#define REG_SC_BKC3_6C_L      _PK_L_(0xC3, 0x6C)
#define REG_SC_BKC3_6C_H      _PK_H_(0xC3, 0x6C)
#define REG_SC_BKC3_6D_L      _PK_L_(0xC3, 0x6D)
#define REG_SC_BKC3_6D_H      _PK_H_(0xC3, 0x6D)
#define REG_SC_BKC3_6E_L      _PK_L_(0xC3, 0x6E)
#define REG_SC_BKC3_6E_H      _PK_H_(0xC3, 0x6E)
#define REG_SC_BKC3_6F_L      _PK_L_(0xC3, 0x6F)
#define REG_SC_BKC3_6F_H      _PK_H_(0xC3, 0x6F)
#define REG_SC_BKC3_70_L      _PK_L_(0xC3, 0x70)
#define REG_SC_BKC3_70_H      _PK_H_(0xC3, 0x70)
#define REG_SC_BKC3_71_L      _PK_L_(0xC3, 0x71)
#define REG_SC_BKC3_71_H      _PK_H_(0xC3, 0x71)
#define REG_SC_BKC3_72_L      _PK_L_(0xC3, 0x72)
#define REG_SC_BKC3_72_H      _PK_H_(0xC3, 0x72)
#define REG_SC_BKC3_73_L      _PK_L_(0xC3, 0x73)
#define REG_SC_BKC3_73_H      _PK_H_(0xC3, 0x73)
#define REG_SC_BKC3_74_L      _PK_L_(0xC3, 0x74)
#define REG_SC_BKC3_74_H      _PK_H_(0xC3, 0x74)
#define REG_SC_BKC3_75_L      _PK_L_(0xC3, 0x75)
#define REG_SC_BKC3_75_H      _PK_H_(0xC3, 0x75)
#define REG_SC_BKC3_76_L      _PK_L_(0xC3, 0x76)
#define REG_SC_BKC3_76_H      _PK_H_(0xC3, 0x76)
#define REG_SC_BKC3_77_L      _PK_L_(0xC3, 0x77)
#define REG_SC_BKC3_77_H      _PK_H_(0xC3, 0x77)
#define REG_SC_BKC3_78_L      _PK_L_(0xC3, 0x78)
#define REG_SC_BKC3_78_H      _PK_H_(0xC3, 0x78)
#define REG_SC_BKC3_79_L      _PK_L_(0xC3, 0x79)
#define REG_SC_BKC3_79_H      _PK_H_(0xC3, 0x79)
#define REG_SC_BKC3_7A_L      _PK_L_(0xC3, 0x7A)
#define REG_SC_BKC3_7A_H      _PK_H_(0xC3, 0x7A)
#define REG_SC_BKC3_7B_L      _PK_L_(0xC3, 0x7B)
#define REG_SC_BKC3_7B_H      _PK_H_(0xC3, 0x7B)
#define REG_SC_BKC3_7C_L      _PK_L_(0xC3, 0x7C)
#define REG_SC_BKC3_7C_H      _PK_H_(0xC3, 0x7C)
#define REG_SC_BKC3_7D_L      _PK_L_(0xC3, 0x7D)
#define REG_SC_BKC3_7D_H      _PK_H_(0xC3, 0x7D)
#define REG_SC_BKC3_7E_L      _PK_L_(0xC3, 0x7E)
#define REG_SC_BKC3_7E_H      _PK_H_(0xC3, 0x7E)
#define REG_SC_BKC3_7F_L      _PK_L_(0xC3, 0x7F)
#define REG_SC_BKC3_7F_H      _PK_H_(0xC3, 0x7F)

//----------------------------------------------
//  BKC4
//----------------------------------------------
#define REG_SC_BKC4_00_L      _PK_L_(0xC4, 0x00)
#define REG_SC_BKC4_00_H      _PK_H_(0xC4, 0x00)
#define REG_SC_BKC4_01_L      _PK_L_(0xC4, 0x01)
#define REG_SC_BKC4_01_H      _PK_H_(0xC4, 0x01)
#define REG_SC_BKC4_02_L      _PK_L_(0xC4, 0x02)
#define REG_SC_BKC4_02_H      _PK_H_(0xC4, 0x02)
#define REG_SC_BKC4_03_L      _PK_L_(0xC4, 0x03)
#define REG_SC_BKC4_03_H      _PK_H_(0xC4, 0x03)
#define REG_SC_BKC4_04_L      _PK_L_(0xC4, 0x04)
#define REG_SC_BKC4_04_H      _PK_H_(0xC4, 0x04)
#define REG_SC_BKC4_05_L      _PK_L_(0xC4, 0x05)
#define REG_SC_BKC4_05_H      _PK_H_(0xC4, 0x05)
#define REG_SC_BKC4_06_L      _PK_L_(0xC4, 0x06)
#define REG_SC_BKC4_06_H      _PK_H_(0xC4, 0x06)
#define REG_SC_BKC4_07_L      _PK_L_(0xC4, 0x07)
#define REG_SC_BKC4_07_H      _PK_H_(0xC4, 0x07)
#define REG_SC_BKC4_08_L      _PK_L_(0xC4, 0x08)
#define REG_SC_BKC4_08_H      _PK_H_(0xC4, 0x08)
#define REG_SC_BKC4_09_L      _PK_L_(0xC4, 0x09)
#define REG_SC_BKC4_09_H      _PK_H_(0xC4, 0x09)
#define REG_SC_BKC4_0A_L      _PK_L_(0xC4, 0x0A)
#define REG_SC_BKC4_0A_H      _PK_H_(0xC4, 0x0A)
#define REG_SC_BKC4_0B_L      _PK_L_(0xC4, 0x0B)
#define REG_SC_BKC4_0B_H      _PK_H_(0xC4, 0x0B)
#define REG_SC_BKC4_0C_L      _PK_L_(0xC4, 0x0C)
#define REG_SC_BKC4_0C_H      _PK_H_(0xC4, 0x0C)
#define REG_SC_BKC4_0D_L      _PK_L_(0xC4, 0x0D)
#define REG_SC_BKC4_0D_H      _PK_H_(0xC4, 0x0D)
#define REG_SC_BKC4_0E_L      _PK_L_(0xC4, 0x0E)
#define REG_SC_BKC4_0E_H      _PK_H_(0xC4, 0x0E)
#define REG_SC_BKC4_0F_L      _PK_L_(0xC4, 0x0F)
#define REG_SC_BKC4_0F_H      _PK_H_(0xC4, 0x0F)
#define REG_SC_BKC4_10_L      _PK_L_(0xC4, 0x10)
#define REG_SC_BKC4_10_H      _PK_H_(0xC4, 0x10)
#define REG_SC_BKC4_11_L      _PK_L_(0xC4, 0x11)
#define REG_SC_BKC4_11_H      _PK_H_(0xC4, 0x11)
#define REG_SC_BKC4_12_L      _PK_L_(0xC4, 0x12)
#define REG_SC_BKC4_12_H      _PK_H_(0xC4, 0x12)
#define REG_SC_BKC4_13_L      _PK_L_(0xC4, 0x13)
#define REG_SC_BKC4_13_H      _PK_H_(0xC4, 0x13)
#define REG_SC_BKC4_14_L      _PK_L_(0xC4, 0x14)
#define REG_SC_BKC4_14_H      _PK_H_(0xC4, 0x14)
#define REG_SC_BKC4_15_L      _PK_L_(0xC4, 0x15)
#define REG_SC_BKC4_15_H      _PK_H_(0xC4, 0x15)
#define REG_SC_BKC4_16_L      _PK_L_(0xC4, 0x16)
#define REG_SC_BKC4_16_H      _PK_H_(0xC4, 0x16)
#define REG_SC_BKC4_17_L      _PK_L_(0xC4, 0x17)
#define REG_SC_BKC4_17_H      _PK_H_(0xC4, 0x17)
#define REG_SC_BKC4_18_L      _PK_L_(0xC4, 0x18)
#define REG_SC_BKC4_18_H      _PK_H_(0xC4, 0x18)
#define REG_SC_BKC4_19_L      _PK_L_(0xC4, 0x19)
#define REG_SC_BKC4_19_H      _PK_H_(0xC4, 0x19)
#define REG_SC_BKC4_1A_L      _PK_L_(0xC4, 0x1A)
#define REG_SC_BKC4_1A_H      _PK_H_(0xC4, 0x1A)
#define REG_SC_BKC4_1B_L      _PK_L_(0xC4, 0x1B)
#define REG_SC_BKC4_1B_H      _PK_H_(0xC4, 0x1B)
#define REG_SC_BKC4_1C_L      _PK_L_(0xC4, 0x1C)
#define REG_SC_BKC4_1C_H      _PK_H_(0xC4, 0x1C)
#define REG_SC_BKC4_1D_L      _PK_L_(0xC4, 0x1D)
#define REG_SC_BKC4_1D_H      _PK_H_(0xC4, 0x1D)
#define REG_SC_BKC4_1E_L      _PK_L_(0xC4, 0x1E)
#define REG_SC_BKC4_1E_H      _PK_H_(0xC4, 0x1E)
#define REG_SC_BKC4_1F_L      _PK_L_(0xC4, 0x1F)
#define REG_SC_BKC4_1F_H      _PK_H_(0xC4, 0x1F)
#define REG_SC_BKC4_20_L      _PK_L_(0xC4, 0x20)
#define REG_SC_BKC4_20_H      _PK_H_(0xC4, 0x20)
#define REG_SC_BKC4_21_L      _PK_L_(0xC4, 0x21)
#define REG_SC_BKC4_21_H      _PK_H_(0xC4, 0x21)
#define REG_SC_BKC4_22_L      _PK_L_(0xC4, 0x22)
#define REG_SC_BKC4_22_H      _PK_H_(0xC4, 0x22)
#define REG_SC_BKC4_23_L      _PK_L_(0xC4, 0x23)
#define REG_SC_BKC4_23_H      _PK_H_(0xC4, 0x23)
#define REG_SC_BKC4_24_L      _PK_L_(0xC4, 0x24)
#define REG_SC_BKC4_24_H      _PK_H_(0xC4, 0x24)
#define REG_SC_BKC4_25_L      _PK_L_(0xC4, 0x25)
#define REG_SC_BKC4_25_H      _PK_H_(0xC4, 0x25)
#define REG_SC_BKC4_26_L      _PK_L_(0xC4, 0x26)
#define REG_SC_BKC4_26_H      _PK_H_(0xC4, 0x26)
#define REG_SC_BKC4_27_L      _PK_L_(0xC4, 0x27)
#define REG_SC_BKC4_27_H      _PK_H_(0xC4, 0x27)
#define REG_SC_BKC4_28_L      _PK_L_(0xC4, 0x28)
#define REG_SC_BKC4_28_H      _PK_H_(0xC4, 0x28)
#define REG_SC_BKC4_29_L      _PK_L_(0xC4, 0x29)
#define REG_SC_BKC4_29_H      _PK_H_(0xC4, 0x29)
#define REG_SC_BKC4_2A_L      _PK_L_(0xC4, 0x2A)
#define REG_SC_BKC4_2A_H      _PK_H_(0xC4, 0x2A)
#define REG_SC_BKC4_2B_L      _PK_L_(0xC4, 0x2B)
#define REG_SC_BKC4_2B_H      _PK_H_(0xC4, 0x2B)
#define REG_SC_BKC4_2C_L      _PK_L_(0xC4, 0x2C)
#define REG_SC_BKC4_2C_H      _PK_H_(0xC4, 0x2C)
#define REG_SC_BKC4_2D_L      _PK_L_(0xC4, 0x2D)
#define REG_SC_BKC4_2D_H      _PK_H_(0xC4, 0x2D)
#define REG_SC_BKC4_2E_L      _PK_L_(0xC4, 0x2E)
#define REG_SC_BKC4_2E_H      _PK_H_(0xC4, 0x2E)
#define REG_SC_BKC4_2F_L      _PK_L_(0xC4, 0x2F)
#define REG_SC_BKC4_2F_H      _PK_H_(0xC4, 0x2F)
#define REG_SC_BKC4_30_L      _PK_L_(0xC4, 0x30)
#define REG_SC_BKC4_30_H      _PK_H_(0xC4, 0x30)
#define REG_SC_BKC4_31_L      _PK_L_(0xC4, 0x31)
#define REG_SC_BKC4_31_H      _PK_H_(0xC4, 0x31)
#define REG_SC_BKC4_32_L      _PK_L_(0xC4, 0x32)
#define REG_SC_BKC4_32_H      _PK_H_(0xC4, 0x32)
#define REG_SC_BKC4_33_L      _PK_L_(0xC4, 0x33)
#define REG_SC_BKC4_33_H      _PK_H_(0xC4, 0x33)
#define REG_SC_BKC4_34_L      _PK_L_(0xC4, 0x34)
#define REG_SC_BKC4_34_H      _PK_H_(0xC4, 0x34)
#define REG_SC_BKC4_35_L      _PK_L_(0xC4, 0x35)
#define REG_SC_BKC4_35_H      _PK_H_(0xC4, 0x35)
#define REG_SC_BKC4_36_L      _PK_L_(0xC4, 0x36)
#define REG_SC_BKC4_36_H      _PK_H_(0xC4, 0x36)
#define REG_SC_BKC4_37_L      _PK_L_(0xC4, 0x37)
#define REG_SC_BKC4_37_H      _PK_H_(0xC4, 0x37)
#define REG_SC_BKC4_38_L      _PK_L_(0xC4, 0x38)
#define REG_SC_BKC4_38_H      _PK_H_(0xC4, 0x38)
#define REG_SC_BKC4_39_L      _PK_L_(0xC4, 0x39)
#define REG_SC_BKC4_39_H      _PK_H_(0xC4, 0x39)
#define REG_SC_BKC4_3A_L      _PK_L_(0xC4, 0x3A)
#define REG_SC_BKC4_3A_H      _PK_H_(0xC4, 0x3A)
#define REG_SC_BKC4_3B_L      _PK_L_(0xC4, 0x3B)
#define REG_SC_BKC4_3B_H      _PK_H_(0xC4, 0x3B)
#define REG_SC_BKC4_3C_L      _PK_L_(0xC4, 0x3C)
#define REG_SC_BKC4_3C_H      _PK_H_(0xC4, 0x3C)
#define REG_SC_BKC4_3D_L      _PK_L_(0xC4, 0x3D)
#define REG_SC_BKC4_3D_H      _PK_H_(0xC4, 0x3D)
#define REG_SC_BKC4_3E_L      _PK_L_(0xC4, 0x3E)
#define REG_SC_BKC4_3E_H      _PK_H_(0xC4, 0x3E)
#define REG_SC_BKC4_3F_L      _PK_L_(0xC4, 0x3F)
#define REG_SC_BKC4_3F_H      _PK_H_(0xC4, 0x3F)
#define REG_SC_BKC4_40_L      _PK_L_(0xC4, 0x40)
#define REG_SC_BKC4_40_H      _PK_H_(0xC4, 0x40)
#define REG_SC_BKC4_41_L      _PK_L_(0xC4, 0x41)
#define REG_SC_BKC4_41_H      _PK_H_(0xC4, 0x41)
#define REG_SC_BKC4_42_L      _PK_L_(0xC4, 0x42)
#define REG_SC_BKC4_42_H      _PK_H_(0xC4, 0x42)
#define REG_SC_BKC4_43_L      _PK_L_(0xC4, 0x43)
#define REG_SC_BKC4_43_H      _PK_H_(0xC4, 0x43)
#define REG_SC_BKC4_44_L      _PK_L_(0xC4, 0x44)
#define REG_SC_BKC4_44_H      _PK_H_(0xC4, 0x44)
#define REG_SC_BKC4_45_L      _PK_L_(0xC4, 0x45)
#define REG_SC_BKC4_45_H      _PK_H_(0xC4, 0x45)
#define REG_SC_BKC4_46_L      _PK_L_(0xC4, 0x46)
#define REG_SC_BKC4_46_H      _PK_H_(0xC4, 0x46)
#define REG_SC_BKC4_47_L      _PK_L_(0xC4, 0x47)
#define REG_SC_BKC4_47_H      _PK_H_(0xC4, 0x47)
#define REG_SC_BKC4_48_L      _PK_L_(0xC4, 0x48)
#define REG_SC_BKC4_48_H      _PK_H_(0xC4, 0x48)
#define REG_SC_BKC4_49_L      _PK_L_(0xC4, 0x49)
#define REG_SC_BKC4_49_H      _PK_H_(0xC4, 0x49)
#define REG_SC_BKC4_4A_L      _PK_L_(0xC4, 0x4A)
#define REG_SC_BKC4_4A_H      _PK_H_(0xC4, 0x4A)
#define REG_SC_BKC4_4B_L      _PK_L_(0xC4, 0x4B)
#define REG_SC_BKC4_4B_H      _PK_H_(0xC4, 0x4B)
#define REG_SC_BKC4_4C_L      _PK_L_(0xC4, 0x4C)
#define REG_SC_BKC4_4C_H      _PK_H_(0xC4, 0x4C)
#define REG_SC_BKC4_4D_L      _PK_L_(0xC4, 0x4D)
#define REG_SC_BKC4_4D_H      _PK_H_(0xC4, 0x4D)
#define REG_SC_BKC4_4E_L      _PK_L_(0xC4, 0x4E)
#define REG_SC_BKC4_4E_H      _PK_H_(0xC4, 0x4E)
#define REG_SC_BKC4_4F_L      _PK_L_(0xC4, 0x4F)
#define REG_SC_BKC4_4F_H      _PK_H_(0xC4, 0x4F)
#define REG_SC_BKC4_50_L      _PK_L_(0xC4, 0x50)
#define REG_SC_BKC4_50_H      _PK_H_(0xC4, 0x50)
#define REG_SC_BKC4_51_L      _PK_L_(0xC4, 0x51)
#define REG_SC_BKC4_51_H      _PK_H_(0xC4, 0x51)
#define REG_SC_BKC4_52_L      _PK_L_(0xC4, 0x52)
#define REG_SC_BKC4_52_H      _PK_H_(0xC4, 0x52)
#define REG_SC_BKC4_53_L      _PK_L_(0xC4, 0x53)
#define REG_SC_BKC4_53_H      _PK_H_(0xC4, 0x53)
#define REG_SC_BKC4_54_L      _PK_L_(0xC4, 0x54)
#define REG_SC_BKC4_54_H      _PK_H_(0xC4, 0x54)
#define REG_SC_BKC4_55_L      _PK_L_(0xC4, 0x55)
#define REG_SC_BKC4_55_H      _PK_H_(0xC4, 0x55)
#define REG_SC_BKC4_56_L      _PK_L_(0xC4, 0x56)
#define REG_SC_BKC4_56_H      _PK_H_(0xC4, 0x56)
#define REG_SC_BKC4_57_L      _PK_L_(0xC4, 0x57)
#define REG_SC_BKC4_57_H      _PK_H_(0xC4, 0x57)
#define REG_SC_BKC4_58_L      _PK_L_(0xC4, 0x58)
#define REG_SC_BKC4_58_H      _PK_H_(0xC4, 0x58)
#define REG_SC_BKC4_59_L      _PK_L_(0xC4, 0x59)
#define REG_SC_BKC4_59_H      _PK_H_(0xC4, 0x59)
#define REG_SC_BKC4_5A_L      _PK_L_(0xC4, 0x5A)
#define REG_SC_BKC4_5A_H      _PK_H_(0xC4, 0x5A)
#define REG_SC_BKC4_5B_L      _PK_L_(0xC4, 0x5B)
#define REG_SC_BKC4_5B_H      _PK_H_(0xC4, 0x5B)
#define REG_SC_BKC4_5C_L      _PK_L_(0xC4, 0x5C)
#define REG_SC_BKC4_5C_H      _PK_H_(0xC4, 0x5C)
#define REG_SC_BKC4_5D_L      _PK_L_(0xC4, 0x5D)
#define REG_SC_BKC4_5D_H      _PK_H_(0xC4, 0x5D)
#define REG_SC_BKC4_5E_L      _PK_L_(0xC4, 0x5E)
#define REG_SC_BKC4_5E_H      _PK_H_(0xC4, 0x5E)
#define REG_SC_BKC4_5F_L      _PK_L_(0xC4, 0x5F)
#define REG_SC_BKC4_5F_H      _PK_H_(0xC4, 0x5F)
#define REG_SC_BKC4_60_L      _PK_L_(0xC4, 0x60)
#define REG_SC_BKC4_60_H      _PK_H_(0xC4, 0x60)
#define REG_SC_BKC4_61_L      _PK_L_(0xC4, 0x61)
#define REG_SC_BKC4_61_H      _PK_H_(0xC4, 0x61)
#define REG_SC_BKC4_62_L      _PK_L_(0xC4, 0x62)
#define REG_SC_BKC4_62_H      _PK_H_(0xC4, 0x62)
#define REG_SC_BKC4_63_L      _PK_L_(0xC4, 0x63)
#define REG_SC_BKC4_63_H      _PK_H_(0xC4, 0x63)
#define REG_SC_BKC4_64_L      _PK_L_(0xC4, 0x64)
#define REG_SC_BKC4_64_H      _PK_H_(0xC4, 0x64)
#define REG_SC_BKC4_65_L      _PK_L_(0xC4, 0x65)
#define REG_SC_BKC4_65_H      _PK_H_(0xC4, 0x65)
#define REG_SC_BKC4_66_L      _PK_L_(0xC4, 0x66)
#define REG_SC_BKC4_66_H      _PK_H_(0xC4, 0x66)
#define REG_SC_BKC4_67_L      _PK_L_(0xC4, 0x67)
#define REG_SC_BKC4_67_H      _PK_H_(0xC4, 0x67)
#define REG_SC_BKC4_68_L      _PK_L_(0xC4, 0x68)
#define REG_SC_BKC4_68_H      _PK_H_(0xC4, 0x68)
#define REG_SC_BKC4_69_L      _PK_L_(0xC4, 0x69)
#define REG_SC_BKC4_69_H      _PK_H_(0xC4, 0x69)
#define REG_SC_BKC4_6A_L      _PK_L_(0xC4, 0x6A)
#define REG_SC_BKC4_6A_H      _PK_H_(0xC4, 0x6A)
#define REG_SC_BKC4_6B_L      _PK_L_(0xC4, 0x6B)
#define REG_SC_BKC4_6B_H      _PK_H_(0xC4, 0x6B)
#define REG_SC_BKC4_6C_L      _PK_L_(0xC4, 0x6C)
#define REG_SC_BKC4_6C_H      _PK_H_(0xC4, 0x6C)
#define REG_SC_BKC4_6D_L      _PK_L_(0xC4, 0x6D)
#define REG_SC_BKC4_6D_H      _PK_H_(0xC4, 0x6D)
#define REG_SC_BKC4_6E_L      _PK_L_(0xC4, 0x6E)
#define REG_SC_BKC4_6E_H      _PK_H_(0xC4, 0x6E)
#define REG_SC_BKC4_6F_L      _PK_L_(0xC4, 0x6F)
#define REG_SC_BKC4_6F_H      _PK_H_(0xC4, 0x6F)
#define REG_SC_BKC4_70_L      _PK_L_(0xC4, 0x70)
#define REG_SC_BKC4_70_H      _PK_H_(0xC4, 0x70)
#define REG_SC_BKC4_71_L      _PK_L_(0xC4, 0x71)
#define REG_SC_BKC4_71_H      _PK_H_(0xC4, 0x71)
#define REG_SC_BKC4_72_L      _PK_L_(0xC4, 0x72)
#define REG_SC_BKC4_72_H      _PK_H_(0xC4, 0x72)
#define REG_SC_BKC4_73_L      _PK_L_(0xC4, 0x73)
#define REG_SC_BKC4_73_H      _PK_H_(0xC4, 0x73)
#define REG_SC_BKC4_74_L      _PK_L_(0xC4, 0x74)
#define REG_SC_BKC4_74_H      _PK_H_(0xC4, 0x74)
#define REG_SC_BKC4_75_L      _PK_L_(0xC4, 0x75)
#define REG_SC_BKC4_75_H      _PK_H_(0xC4, 0x75)
#define REG_SC_BKC4_76_L      _PK_L_(0xC4, 0x76)
#define REG_SC_BKC4_76_H      _PK_H_(0xC4, 0x76)
#define REG_SC_BKC4_77_L      _PK_L_(0xC4, 0x77)
#define REG_SC_BKC4_77_H      _PK_H_(0xC4, 0x77)
#define REG_SC_BKC4_78_L      _PK_L_(0xC4, 0x78)
#define REG_SC_BKC4_78_H      _PK_H_(0xC4, 0x78)
#define REG_SC_BKC4_79_L      _PK_L_(0xC4, 0x79)
#define REG_SC_BKC4_79_H      _PK_H_(0xC4, 0x79)
#define REG_SC_BKC4_7A_L      _PK_L_(0xC4, 0x7A)
#define REG_SC_BKC4_7A_H      _PK_H_(0xC4, 0x7A)
#define REG_SC_BKC4_7B_L      _PK_L_(0xC4, 0x7B)
#define REG_SC_BKC4_7B_H      _PK_H_(0xC4, 0x7B)
#define REG_SC_BKC4_7C_L      _PK_L_(0xC4, 0x7C)
#define REG_SC_BKC4_7C_H      _PK_H_(0xC4, 0x7C)
#define REG_SC_BKC4_7D_L      _PK_L_(0xC4, 0x7D)
#define REG_SC_BKC4_7D_H      _PK_H_(0xC4, 0x7D)
#define REG_SC_BKC4_7E_L      _PK_L_(0xC4, 0x7E)
#define REG_SC_BKC4_7E_H      _PK_H_(0xC4, 0x7E)
#define REG_SC_BKC4_7F_L      _PK_L_(0xC4, 0x7F)
#define REG_SC_BKC4_7F_H      _PK_H_(0xC4, 0x7F)

//----------------------------------------------
//  BKC5
//----------------------------------------------
#define REG_SC_BKC5_00_L      _PK_L_(0xC5, 0x00)
#define REG_SC_BKC5_00_H      _PK_H_(0xC5, 0x00)
#define REG_SC_BKC5_01_L      _PK_L_(0xC5, 0x01)
#define REG_SC_BKC5_01_H      _PK_H_(0xC5, 0x01)
#define REG_SC_BKC5_02_L      _PK_L_(0xC5, 0x02)
#define REG_SC_BKC5_02_H      _PK_H_(0xC5, 0x02)
#define REG_SC_BKC5_03_L      _PK_L_(0xC5, 0x03)
#define REG_SC_BKC5_03_H      _PK_H_(0xC5, 0x03)
#define REG_SC_BKC5_04_L      _PK_L_(0xC5, 0x04)
#define REG_SC_BKC5_04_H      _PK_H_(0xC5, 0x04)
#define REG_SC_BKC5_05_L      _PK_L_(0xC5, 0x05)
#define REG_SC_BKC5_05_H      _PK_H_(0xC5, 0x05)
#define REG_SC_BKC5_06_L      _PK_L_(0xC5, 0x06)
#define REG_SC_BKC5_06_H      _PK_H_(0xC5, 0x06)
#define REG_SC_BKC5_07_L      _PK_L_(0xC5, 0x07)
#define REG_SC_BKC5_07_H      _PK_H_(0xC5, 0x07)
#define REG_SC_BKC5_08_L      _PK_L_(0xC5, 0x08)
#define REG_SC_BKC5_08_H      _PK_H_(0xC5, 0x08)
#define REG_SC_BKC5_09_L      _PK_L_(0xC5, 0x09)
#define REG_SC_BKC5_09_H      _PK_H_(0xC5, 0x09)
#define REG_SC_BKC5_0A_L      _PK_L_(0xC5, 0x0A)
#define REG_SC_BKC5_0A_H      _PK_H_(0xC5, 0x0A)
#define REG_SC_BKC5_0B_L      _PK_L_(0xC5, 0x0B)
#define REG_SC_BKC5_0B_H      _PK_H_(0xC5, 0x0B)
#define REG_SC_BKC5_0C_L      _PK_L_(0xC5, 0x0C)
#define REG_SC_BKC5_0C_H      _PK_H_(0xC5, 0x0C)
#define REG_SC_BKC5_0D_L      _PK_L_(0xC5, 0x0D)
#define REG_SC_BKC5_0D_H      _PK_H_(0xC5, 0x0D)
#define REG_SC_BKC5_0E_L      _PK_L_(0xC5, 0x0E)
#define REG_SC_BKC5_0E_H      _PK_H_(0xC5, 0x0E)
#define REG_SC_BKC5_0F_L      _PK_L_(0xC5, 0x0F)
#define REG_SC_BKC5_0F_H      _PK_H_(0xC5, 0x0F)
#define REG_SC_BKC5_10_L      _PK_L_(0xC5, 0x10)
#define REG_SC_BKC5_10_H      _PK_H_(0xC5, 0x10)
#define REG_SC_BKC5_11_L      _PK_L_(0xC5, 0x11)
#define REG_SC_BKC5_11_H      _PK_H_(0xC5, 0x11)
#define REG_SC_BKC5_12_L      _PK_L_(0xC5, 0x12)
#define REG_SC_BKC5_12_H      _PK_H_(0xC5, 0x12)
#define REG_SC_BKC5_13_L      _PK_L_(0xC5, 0x13)
#define REG_SC_BKC5_13_H      _PK_H_(0xC5, 0x13)
#define REG_SC_BKC5_14_L      _PK_L_(0xC5, 0x14)
#define REG_SC_BKC5_14_H      _PK_H_(0xC5, 0x14)
#define REG_SC_BKC5_15_L      _PK_L_(0xC5, 0x15)
#define REG_SC_BKC5_15_H      _PK_H_(0xC5, 0x15)
#define REG_SC_BKC5_16_L      _PK_L_(0xC5, 0x16)
#define REG_SC_BKC5_16_H      _PK_H_(0xC5, 0x16)
#define REG_SC_BKC5_17_L      _PK_L_(0xC5, 0x17)
#define REG_SC_BKC5_17_H      _PK_H_(0xC5, 0x17)
#define REG_SC_BKC5_18_L      _PK_L_(0xC5, 0x18)
#define REG_SC_BKC5_18_H      _PK_H_(0xC5, 0x18)
#define REG_SC_BKC5_19_L      _PK_L_(0xC5, 0x19)
#define REG_SC_BKC5_19_H      _PK_H_(0xC5, 0x19)
#define REG_SC_BKC5_1A_L      _PK_L_(0xC5, 0x1A)
#define REG_SC_BKC5_1A_H      _PK_H_(0xC5, 0x1A)
#define REG_SC_BKC5_1B_L      _PK_L_(0xC5, 0x1B)
#define REG_SC_BKC5_1B_H      _PK_H_(0xC5, 0x1B)
#define REG_SC_BKC5_1C_L      _PK_L_(0xC5, 0x1C)
#define REG_SC_BKC5_1C_H      _PK_H_(0xC5, 0x1C)
#define REG_SC_BKC5_1D_L      _PK_L_(0xC5, 0x1D)
#define REG_SC_BKC5_1D_H      _PK_H_(0xC5, 0x1D)
#define REG_SC_BKC5_1E_L      _PK_L_(0xC5, 0x1E)
#define REG_SC_BKC5_1E_H      _PK_H_(0xC5, 0x1E)
#define REG_SC_BKC5_1F_L      _PK_L_(0xC5, 0x1F)
#define REG_SC_BKC5_1F_H      _PK_H_(0xC5, 0x1F)
#define REG_SC_BKC5_20_L      _PK_L_(0xC5, 0x20)
#define REG_SC_BKC5_20_H      _PK_H_(0xC5, 0x20)
#define REG_SC_BKC5_21_L      _PK_L_(0xC5, 0x21)
#define REG_SC_BKC5_21_H      _PK_H_(0xC5, 0x21)
#define REG_SC_BKC5_22_L      _PK_L_(0xC5, 0x22)
#define REG_SC_BKC5_22_H      _PK_H_(0xC5, 0x22)
#define REG_SC_BKC5_23_L      _PK_L_(0xC5, 0x23)
#define REG_SC_BKC5_23_H      _PK_H_(0xC5, 0x23)
#define REG_SC_BKC5_24_L      _PK_L_(0xC5, 0x24)
#define REG_SC_BKC5_24_H      _PK_H_(0xC5, 0x24)
#define REG_SC_BKC5_25_L      _PK_L_(0xC5, 0x25)
#define REG_SC_BKC5_25_H      _PK_H_(0xC5, 0x25)
#define REG_SC_BKC5_26_L      _PK_L_(0xC5, 0x26)
#define REG_SC_BKC5_26_H      _PK_H_(0xC5, 0x26)
#define REG_SC_BKC5_27_L      _PK_L_(0xC5, 0x27)
#define REG_SC_BKC5_27_H      _PK_H_(0xC5, 0x27)
#define REG_SC_BKC5_28_L      _PK_L_(0xC5, 0x28)
#define REG_SC_BKC5_28_H      _PK_H_(0xC5, 0x28)
#define REG_SC_BKC5_29_L      _PK_L_(0xC5, 0x29)
#define REG_SC_BKC5_29_H      _PK_H_(0xC5, 0x29)
#define REG_SC_BKC5_2A_L      _PK_L_(0xC5, 0x2A)
#define REG_SC_BKC5_2A_H      _PK_H_(0xC5, 0x2A)
#define REG_SC_BKC5_2B_L      _PK_L_(0xC5, 0x2B)
#define REG_SC_BKC5_2B_H      _PK_H_(0xC5, 0x2B)
#define REG_SC_BKC5_2C_L      _PK_L_(0xC5, 0x2C)
#define REG_SC_BKC5_2C_H      _PK_H_(0xC5, 0x2C)
#define REG_SC_BKC5_2D_L      _PK_L_(0xC5, 0x2D)
#define REG_SC_BKC5_2D_H      _PK_H_(0xC5, 0x2D)
#define REG_SC_BKC5_2E_L      _PK_L_(0xC5, 0x2E)
#define REG_SC_BKC5_2E_H      _PK_H_(0xC5, 0x2E)
#define REG_SC_BKC5_2F_L      _PK_L_(0xC5, 0x2F)
#define REG_SC_BKC5_2F_H      _PK_H_(0xC5, 0x2F)
#define REG_SC_BKC5_30_L      _PK_L_(0xC5, 0x30)
#define REG_SC_BKC5_30_H      _PK_H_(0xC5, 0x30)
#define REG_SC_BKC5_31_L      _PK_L_(0xC5, 0x31)
#define REG_SC_BKC5_31_H      _PK_H_(0xC5, 0x31)
#define REG_SC_BKC5_32_L      _PK_L_(0xC5, 0x32)
#define REG_SC_BKC5_32_H      _PK_H_(0xC5, 0x32)
#define REG_SC_BKC5_33_L      _PK_L_(0xC5, 0x33)
#define REG_SC_BKC5_33_H      _PK_H_(0xC5, 0x33)
#define REG_SC_BKC5_34_L      _PK_L_(0xC5, 0x34)
#define REG_SC_BKC5_34_H      _PK_H_(0xC5, 0x34)
#define REG_SC_BKC5_35_L      _PK_L_(0xC5, 0x35)
#define REG_SC_BKC5_35_H      _PK_H_(0xC5, 0x35)
#define REG_SC_BKC5_36_L      _PK_L_(0xC5, 0x36)
#define REG_SC_BKC5_36_H      _PK_H_(0xC5, 0x36)
#define REG_SC_BKC5_37_L      _PK_L_(0xC5, 0x37)
#define REG_SC_BKC5_37_H      _PK_H_(0xC5, 0x37)
#define REG_SC_BKC5_38_L      _PK_L_(0xC5, 0x38)
#define REG_SC_BKC5_38_H      _PK_H_(0xC5, 0x38)
#define REG_SC_BKC5_39_L      _PK_L_(0xC5, 0x39)
#define REG_SC_BKC5_39_H      _PK_H_(0xC5, 0x39)
#define REG_SC_BKC5_3A_L      _PK_L_(0xC5, 0x3A)
#define REG_SC_BKC5_3A_H      _PK_H_(0xC5, 0x3A)
#define REG_SC_BKC5_3B_L      _PK_L_(0xC5, 0x3B)
#define REG_SC_BKC5_3B_H      _PK_H_(0xC5, 0x3B)
#define REG_SC_BKC5_3C_L      _PK_L_(0xC5, 0x3C)
#define REG_SC_BKC5_3C_H      _PK_H_(0xC5, 0x3C)
#define REG_SC_BKC5_3D_L      _PK_L_(0xC5, 0x3D)
#define REG_SC_BKC5_3D_H      _PK_H_(0xC5, 0x3D)
#define REG_SC_BKC5_3E_L      _PK_L_(0xC5, 0x3E)
#define REG_SC_BKC5_3E_H      _PK_H_(0xC5, 0x3E)
#define REG_SC_BKC5_3F_L      _PK_L_(0xC5, 0x3F)
#define REG_SC_BKC5_3F_H      _PK_H_(0xC5, 0x3F)
#define REG_SC_BKC5_40_L      _PK_L_(0xC5, 0x40)
#define REG_SC_BKC5_40_H      _PK_H_(0xC5, 0x40)
#define REG_SC_BKC5_41_L      _PK_L_(0xC5, 0x41)
#define REG_SC_BKC5_41_H      _PK_H_(0xC5, 0x41)
#define REG_SC_BKC5_42_L      _PK_L_(0xC5, 0x42)
#define REG_SC_BKC5_42_H      _PK_H_(0xC5, 0x42)
#define REG_SC_BKC5_43_L      _PK_L_(0xC5, 0x43)
#define REG_SC_BKC5_43_H      _PK_H_(0xC5, 0x43)
#define REG_SC_BKC5_44_L      _PK_L_(0xC5, 0x44)
#define REG_SC_BKC5_44_H      _PK_H_(0xC5, 0x44)
#define REG_SC_BKC5_45_L      _PK_L_(0xC5, 0x45)
#define REG_SC_BKC5_45_H      _PK_H_(0xC5, 0x45)
#define REG_SC_BKC5_46_L      _PK_L_(0xC5, 0x46)
#define REG_SC_BKC5_46_H      _PK_H_(0xC5, 0x46)
#define REG_SC_BKC5_47_L      _PK_L_(0xC5, 0x47)
#define REG_SC_BKC5_47_H      _PK_H_(0xC5, 0x47)
#define REG_SC_BKC5_48_L      _PK_L_(0xC5, 0x48)
#define REG_SC_BKC5_48_H      _PK_H_(0xC5, 0x48)
#define REG_SC_BKC5_49_L      _PK_L_(0xC5, 0x49)
#define REG_SC_BKC5_49_H      _PK_H_(0xC5, 0x49)
#define REG_SC_BKC5_4A_L      _PK_L_(0xC5, 0x4A)
#define REG_SC_BKC5_4A_H      _PK_H_(0xC5, 0x4A)
#define REG_SC_BKC5_4B_L      _PK_L_(0xC5, 0x4B)
#define REG_SC_BKC5_4B_H      _PK_H_(0xC5, 0x4B)
#define REG_SC_BKC5_4C_L      _PK_L_(0xC5, 0x4C)
#define REG_SC_BKC5_4C_H      _PK_H_(0xC5, 0x4C)
#define REG_SC_BKC5_4D_L      _PK_L_(0xC5, 0x4D)
#define REG_SC_BKC5_4D_H      _PK_H_(0xC5, 0x4D)
#define REG_SC_BKC5_4E_L      _PK_L_(0xC5, 0x4E)
#define REG_SC_BKC5_4E_H      _PK_H_(0xC5, 0x4E)
#define REG_SC_BKC5_4F_L      _PK_L_(0xC5, 0x4F)
#define REG_SC_BKC5_4F_H      _PK_H_(0xC5, 0x4F)
#define REG_SC_BKC5_50_L      _PK_L_(0xC5, 0x50)
#define REG_SC_BKC5_50_H      _PK_H_(0xC5, 0x50)
#define REG_SC_BKC5_51_L      _PK_L_(0xC5, 0x51)
#define REG_SC_BKC5_51_H      _PK_H_(0xC5, 0x51)
#define REG_SC_BKC5_52_L      _PK_L_(0xC5, 0x52)
#define REG_SC_BKC5_52_H      _PK_H_(0xC5, 0x52)
#define REG_SC_BKC5_53_L      _PK_L_(0xC5, 0x53)
#define REG_SC_BKC5_53_H      _PK_H_(0xC5, 0x53)
#define REG_SC_BKC5_54_L      _PK_L_(0xC5, 0x54)
#define REG_SC_BKC5_54_H      _PK_H_(0xC5, 0x54)
#define REG_SC_BKC5_55_L      _PK_L_(0xC5, 0x55)
#define REG_SC_BKC5_55_H      _PK_H_(0xC5, 0x55)
#define REG_SC_BKC5_56_L      _PK_L_(0xC5, 0x56)
#define REG_SC_BKC5_56_H      _PK_H_(0xC5, 0x56)
#define REG_SC_BKC5_57_L      _PK_L_(0xC5, 0x57)
#define REG_SC_BKC5_57_H      _PK_H_(0xC5, 0x57)
#define REG_SC_BKC5_58_L      _PK_L_(0xC5, 0x58)
#define REG_SC_BKC5_58_H      _PK_H_(0xC5, 0x58)
#define REG_SC_BKC5_59_L      _PK_L_(0xC5, 0x59)
#define REG_SC_BKC5_59_H      _PK_H_(0xC5, 0x59)
#define REG_SC_BKC5_5A_L      _PK_L_(0xC5, 0x5A)
#define REG_SC_BKC5_5A_H      _PK_H_(0xC5, 0x5A)
#define REG_SC_BKC5_5B_L      _PK_L_(0xC5, 0x5B)
#define REG_SC_BKC5_5B_H      _PK_H_(0xC5, 0x5B)
#define REG_SC_BKC5_5C_L      _PK_L_(0xC5, 0x5C)
#define REG_SC_BKC5_5C_H      _PK_H_(0xC5, 0x5C)
#define REG_SC_BKC5_5D_L      _PK_L_(0xC5, 0x5D)
#define REG_SC_BKC5_5D_H      _PK_H_(0xC5, 0x5D)
#define REG_SC_BKC5_5E_L      _PK_L_(0xC5, 0x5E)
#define REG_SC_BKC5_5E_H      _PK_H_(0xC5, 0x5E)
#define REG_SC_BKC5_5F_L      _PK_L_(0xC5, 0x5F)
#define REG_SC_BKC5_5F_H      _PK_H_(0xC5, 0x5F)
#define REG_SC_BKC5_60_L      _PK_L_(0xC5, 0x60)
#define REG_SC_BKC5_60_H      _PK_H_(0xC5, 0x60)
#define REG_SC_BKC5_61_L      _PK_L_(0xC5, 0x61)
#define REG_SC_BKC5_61_H      _PK_H_(0xC5, 0x61)
#define REG_SC_BKC5_62_L      _PK_L_(0xC5, 0x62)
#define REG_SC_BKC5_62_H      _PK_H_(0xC5, 0x62)
#define REG_SC_BKC5_63_L      _PK_L_(0xC5, 0x63)
#define REG_SC_BKC5_63_H      _PK_H_(0xC5, 0x63)
#define REG_SC_BKC5_64_L      _PK_L_(0xC5, 0x64)
#define REG_SC_BKC5_64_H      _PK_H_(0xC5, 0x64)
#define REG_SC_BKC5_65_L      _PK_L_(0xC5, 0x65)
#define REG_SC_BKC5_65_H      _PK_H_(0xC5, 0x65)
#define REG_SC_BKC5_66_L      _PK_L_(0xC5, 0x66)
#define REG_SC_BKC5_66_H      _PK_H_(0xC5, 0x66)
#define REG_SC_BKC5_67_L      _PK_L_(0xC5, 0x67)
#define REG_SC_BKC5_67_H      _PK_H_(0xC5, 0x67)
#define REG_SC_BKC5_68_L      _PK_L_(0xC5, 0x68)
#define REG_SC_BKC5_68_H      _PK_H_(0xC5, 0x68)
#define REG_SC_BKC5_69_L      _PK_L_(0xC5, 0x69)
#define REG_SC_BKC5_69_H      _PK_H_(0xC5, 0x69)
#define REG_SC_BKC5_6A_L      _PK_L_(0xC5, 0x6A)
#define REG_SC_BKC5_6A_H      _PK_H_(0xC5, 0x6A)
#define REG_SC_BKC5_6B_L      _PK_L_(0xC5, 0x6B)
#define REG_SC_BKC5_6B_H      _PK_H_(0xC5, 0x6B)
#define REG_SC_BKC5_6C_L      _PK_L_(0xC5, 0x6C)
#define REG_SC_BKC5_6C_H      _PK_H_(0xC5, 0x6C)
#define REG_SC_BKC5_6D_L      _PK_L_(0xC5, 0x6D)
#define REG_SC_BKC5_6D_H      _PK_H_(0xC5, 0x6D)
#define REG_SC_BKC5_6E_L      _PK_L_(0xC5, 0x6E)
#define REG_SC_BKC5_6E_H      _PK_H_(0xC5, 0x6E)
#define REG_SC_BKC5_6F_L      _PK_L_(0xC5, 0x6F)
#define REG_SC_BKC5_6F_H      _PK_H_(0xC5, 0x6F)
#define REG_SC_BKC5_70_L      _PK_L_(0xC5, 0x70)
#define REG_SC_BKC5_70_H      _PK_H_(0xC5, 0x70)
#define REG_SC_BKC5_71_L      _PK_L_(0xC5, 0x71)
#define REG_SC_BKC5_71_H      _PK_H_(0xC5, 0x71)
#define REG_SC_BKC5_72_L      _PK_L_(0xC5, 0x72)
#define REG_SC_BKC5_72_H      _PK_H_(0xC5, 0x72)
#define REG_SC_BKC5_73_L      _PK_L_(0xC5, 0x73)
#define REG_SC_BKC5_73_H      _PK_H_(0xC5, 0x73)
#define REG_SC_BKC5_74_L      _PK_L_(0xC5, 0x74)
#define REG_SC_BKC5_74_H      _PK_H_(0xC5, 0x74)
#define REG_SC_BKC5_75_L      _PK_L_(0xC5, 0x75)
#define REG_SC_BKC5_75_H      _PK_H_(0xC5, 0x75)
#define REG_SC_BKC5_76_L      _PK_L_(0xC5, 0x76)
#define REG_SC_BKC5_76_H      _PK_H_(0xC5, 0x76)
#define REG_SC_BKC5_77_L      _PK_L_(0xC5, 0x77)
#define REG_SC_BKC5_77_H      _PK_H_(0xC5, 0x77)
#define REG_SC_BKC5_78_L      _PK_L_(0xC5, 0x78)
#define REG_SC_BKC5_78_H      _PK_H_(0xC5, 0x78)
#define REG_SC_BKC5_79_L      _PK_L_(0xC5, 0x79)
#define REG_SC_BKC5_79_H      _PK_H_(0xC5, 0x79)
#define REG_SC_BKC5_7A_L      _PK_L_(0xC5, 0x7A)
#define REG_SC_BKC5_7A_H      _PK_H_(0xC5, 0x7A)
#define REG_SC_BKC5_7B_L      _PK_L_(0xC5, 0x7B)
#define REG_SC_BKC5_7B_H      _PK_H_(0xC5, 0x7B)
#define REG_SC_BKC5_7C_L      _PK_L_(0xC5, 0x7C)
#define REG_SC_BKC5_7C_H      _PK_H_(0xC5, 0x7C)
#define REG_SC_BKC5_7D_L      _PK_L_(0xC5, 0x7D)
#define REG_SC_BKC5_7D_H      _PK_H_(0xC5, 0x7D)
#define REG_SC_BKC5_7E_L      _PK_L_(0xC5, 0x7E)
#define REG_SC_BKC5_7E_H      _PK_H_(0xC5, 0x7E)
#define REG_SC_BKC5_7F_L      _PK_L_(0xC5, 0x7F)
#define REG_SC_BKC5_7F_H      _PK_H_(0xC5, 0x7F)

//----------------------------------------------
//  BKC6
//----------------------------------------------
#define REG_SC_BKC6_00_L      _PK_L_(0xC6, 0x00)
#define REG_SC_BKC6_00_H      _PK_H_(0xC6, 0x00)
#define REG_SC_BKC6_01_L      _PK_L_(0xC6, 0x01)
#define REG_SC_BKC6_01_H      _PK_H_(0xC6, 0x01)
#define REG_SC_BKC6_02_L      _PK_L_(0xC6, 0x02)
#define REG_SC_BKC6_02_H      _PK_H_(0xC6, 0x02)
#define REG_SC_BKC6_03_L      _PK_L_(0xC6, 0x03)
#define REG_SC_BKC6_03_H      _PK_H_(0xC6, 0x03)
#define REG_SC_BKC6_04_L      _PK_L_(0xC6, 0x04)
#define REG_SC_BKC6_04_H      _PK_H_(0xC6, 0x04)
#define REG_SC_BKC6_05_L      _PK_L_(0xC6, 0x05)
#define REG_SC_BKC6_05_H      _PK_H_(0xC6, 0x05)
#define REG_SC_BKC6_06_L      _PK_L_(0xC6, 0x06)
#define REG_SC_BKC6_06_H      _PK_H_(0xC6, 0x06)
#define REG_SC_BKC6_07_L      _PK_L_(0xC6, 0x07)
#define REG_SC_BKC6_07_H      _PK_H_(0xC6, 0x07)
#define REG_SC_BKC6_08_L      _PK_L_(0xC6, 0x08)
#define REG_SC_BKC6_08_H      _PK_H_(0xC6, 0x08)
#define REG_SC_BKC6_09_L      _PK_L_(0xC6, 0x09)
#define REG_SC_BKC6_09_H      _PK_H_(0xC6, 0x09)
#define REG_SC_BKC6_0A_L      _PK_L_(0xC6, 0x0A)
#define REG_SC_BKC6_0A_H      _PK_H_(0xC6, 0x0A)
#define REG_SC_BKC6_0B_L      _PK_L_(0xC6, 0x0B)
#define REG_SC_BKC6_0B_H      _PK_H_(0xC6, 0x0B)
#define REG_SC_BKC6_0C_L      _PK_L_(0xC6, 0x0C)
#define REG_SC_BKC6_0C_H      _PK_H_(0xC6, 0x0C)
#define REG_SC_BKC6_0D_L      _PK_L_(0xC6, 0x0D)
#define REG_SC_BKC6_0D_H      _PK_H_(0xC6, 0x0D)
#define REG_SC_BKC6_0E_L      _PK_L_(0xC6, 0x0E)
#define REG_SC_BKC6_0E_H      _PK_H_(0xC6, 0x0E)
#define REG_SC_BKC6_0F_L      _PK_L_(0xC6, 0x0F)
#define REG_SC_BKC6_0F_H      _PK_H_(0xC6, 0x0F)
#define REG_SC_BKC6_10_L      _PK_L_(0xC6, 0x10)
#define REG_SC_BKC6_10_H      _PK_H_(0xC6, 0x10)
#define REG_SC_BKC6_11_L      _PK_L_(0xC6, 0x11)
#define REG_SC_BKC6_11_H      _PK_H_(0xC6, 0x11)
#define REG_SC_BKC6_12_L      _PK_L_(0xC6, 0x12)
#define REG_SC_BKC6_12_H      _PK_H_(0xC6, 0x12)
#define REG_SC_BKC6_13_L      _PK_L_(0xC6, 0x13)
#define REG_SC_BKC6_13_H      _PK_H_(0xC6, 0x13)
#define REG_SC_BKC6_14_L      _PK_L_(0xC6, 0x14)
#define REG_SC_BKC6_14_H      _PK_H_(0xC6, 0x14)
#define REG_SC_BKC6_15_L      _PK_L_(0xC6, 0x15)
#define REG_SC_BKC6_15_H      _PK_H_(0xC6, 0x15)
#define REG_SC_BKC6_16_L      _PK_L_(0xC6, 0x16)
#define REG_SC_BKC6_16_H      _PK_H_(0xC6, 0x16)
#define REG_SC_BKC6_17_L      _PK_L_(0xC6, 0x17)
#define REG_SC_BKC6_17_H      _PK_H_(0xC6, 0x17)
#define REG_SC_BKC6_18_L      _PK_L_(0xC6, 0x18)
#define REG_SC_BKC6_18_H      _PK_H_(0xC6, 0x18)
#define REG_SC_BKC6_19_L      _PK_L_(0xC6, 0x19)
#define REG_SC_BKC6_19_H      _PK_H_(0xC6, 0x19)
#define REG_SC_BKC6_1A_L      _PK_L_(0xC6, 0x1A)
#define REG_SC_BKC6_1A_H      _PK_H_(0xC6, 0x1A)
#define REG_SC_BKC6_1B_L      _PK_L_(0xC6, 0x1B)
#define REG_SC_BKC6_1B_H      _PK_H_(0xC6, 0x1B)
#define REG_SC_BKC6_1C_L      _PK_L_(0xC6, 0x1C)
#define REG_SC_BKC6_1C_H      _PK_H_(0xC6, 0x1C)
#define REG_SC_BKC6_1D_L      _PK_L_(0xC6, 0x1D)
#define REG_SC_BKC6_1D_H      _PK_H_(0xC6, 0x1D)
#define REG_SC_BKC6_1E_L      _PK_L_(0xC6, 0x1E)
#define REG_SC_BKC6_1E_H      _PK_H_(0xC6, 0x1E)
#define REG_SC_BKC6_1F_L      _PK_L_(0xC6, 0x1F)
#define REG_SC_BKC6_1F_H      _PK_H_(0xC6, 0x1F)
#define REG_SC_BKC6_20_L      _PK_L_(0xC6, 0x20)
#define REG_SC_BKC6_20_H      _PK_H_(0xC6, 0x20)
#define REG_SC_BKC6_21_L      _PK_L_(0xC6, 0x21)
#define REG_SC_BKC6_21_H      _PK_H_(0xC6, 0x21)
#define REG_SC_BKC6_22_L      _PK_L_(0xC6, 0x22)
#define REG_SC_BKC6_22_H      _PK_H_(0xC6, 0x22)
#define REG_SC_BKC6_23_L      _PK_L_(0xC6, 0x23)
#define REG_SC_BKC6_23_H      _PK_H_(0xC6, 0x23)
#define REG_SC_BKC6_24_L      _PK_L_(0xC6, 0x24)
#define REG_SC_BKC6_24_H      _PK_H_(0xC6, 0x24)
#define REG_SC_BKC6_25_L      _PK_L_(0xC6, 0x25)
#define REG_SC_BKC6_25_H      _PK_H_(0xC6, 0x25)
#define REG_SC_BKC6_26_L      _PK_L_(0xC6, 0x26)
#define REG_SC_BKC6_26_H      _PK_H_(0xC6, 0x26)
#define REG_SC_BKC6_27_L      _PK_L_(0xC6, 0x27)
#define REG_SC_BKC6_27_H      _PK_H_(0xC6, 0x27)
#define REG_SC_BKC6_28_L      _PK_L_(0xC6, 0x28)
#define REG_SC_BKC6_28_H      _PK_H_(0xC6, 0x28)
#define REG_SC_BKC6_29_L      _PK_L_(0xC6, 0x29)
#define REG_SC_BKC6_29_H      _PK_H_(0xC6, 0x29)
#define REG_SC_BKC6_2A_L      _PK_L_(0xC6, 0x2A)
#define REG_SC_BKC6_2A_H      _PK_H_(0xC6, 0x2A)
#define REG_SC_BKC6_2B_L      _PK_L_(0xC6, 0x2B)
#define REG_SC_BKC6_2B_H      _PK_H_(0xC6, 0x2B)
#define REG_SC_BKC6_2C_L      _PK_L_(0xC6, 0x2C)
#define REG_SC_BKC6_2C_H      _PK_H_(0xC6, 0x2C)
#define REG_SC_BKC6_2D_L      _PK_L_(0xC6, 0x2D)
#define REG_SC_BKC6_2D_H      _PK_H_(0xC6, 0x2D)
#define REG_SC_BKC6_2E_L      _PK_L_(0xC6, 0x2E)
#define REG_SC_BKC6_2E_H      _PK_H_(0xC6, 0x2E)
#define REG_SC_BKC6_2F_L      _PK_L_(0xC6, 0x2F)
#define REG_SC_BKC6_2F_H      _PK_H_(0xC6, 0x2F)
#define REG_SC_BKC6_30_L      _PK_L_(0xC6, 0x30)
#define REG_SC_BKC6_30_H      _PK_H_(0xC6, 0x30)
#define REG_SC_BKC6_31_L      _PK_L_(0xC6, 0x31)
#define REG_SC_BKC6_31_H      _PK_H_(0xC6, 0x31)
#define REG_SC_BKC6_32_L      _PK_L_(0xC6, 0x32)
#define REG_SC_BKC6_32_H      _PK_H_(0xC6, 0x32)
#define REG_SC_BKC6_33_L      _PK_L_(0xC6, 0x33)
#define REG_SC_BKC6_33_H      _PK_H_(0xC6, 0x33)
#define REG_SC_BKC6_34_L      _PK_L_(0xC6, 0x34)
#define REG_SC_BKC6_34_H      _PK_H_(0xC6, 0x34)
#define REG_SC_BKC6_35_L      _PK_L_(0xC6, 0x35)
#define REG_SC_BKC6_35_H      _PK_H_(0xC6, 0x35)
#define REG_SC_BKC6_36_L      _PK_L_(0xC6, 0x36)
#define REG_SC_BKC6_36_H      _PK_H_(0xC6, 0x36)
#define REG_SC_BKC6_37_L      _PK_L_(0xC6, 0x37)
#define REG_SC_BKC6_37_H      _PK_H_(0xC6, 0x37)
#define REG_SC_BKC6_38_L      _PK_L_(0xC6, 0x38)
#define REG_SC_BKC6_38_H      _PK_H_(0xC6, 0x38)
#define REG_SC_BKC6_39_L      _PK_L_(0xC6, 0x39)
#define REG_SC_BKC6_39_H      _PK_H_(0xC6, 0x39)
#define REG_SC_BKC6_3A_L      _PK_L_(0xC6, 0x3A)
#define REG_SC_BKC6_3A_H      _PK_H_(0xC6, 0x3A)
#define REG_SC_BKC6_3B_L      _PK_L_(0xC6, 0x3B)
#define REG_SC_BKC6_3B_H      _PK_H_(0xC6, 0x3B)
#define REG_SC_BKC6_3C_L      _PK_L_(0xC6, 0x3C)
#define REG_SC_BKC6_3C_H      _PK_H_(0xC6, 0x3C)
#define REG_SC_BKC6_3D_L      _PK_L_(0xC6, 0x3D)
#define REG_SC_BKC6_3D_H      _PK_H_(0xC6, 0x3D)
#define REG_SC_BKC6_3E_L      _PK_L_(0xC6, 0x3E)
#define REG_SC_BKC6_3E_H      _PK_H_(0xC6, 0x3E)
#define REG_SC_BKC6_3F_L      _PK_L_(0xC6, 0x3F)
#define REG_SC_BKC6_3F_H      _PK_H_(0xC6, 0x3F)
#define REG_SC_BKC6_40_L      _PK_L_(0xC6, 0x40)
#define REG_SC_BKC6_40_H      _PK_H_(0xC6, 0x40)
#define REG_SC_BKC6_41_L      _PK_L_(0xC6, 0x41)
#define REG_SC_BKC6_41_H      _PK_H_(0xC6, 0x41)
#define REG_SC_BKC6_42_L      _PK_L_(0xC6, 0x42)
#define REG_SC_BKC6_42_H      _PK_H_(0xC6, 0x42)
#define REG_SC_BKC6_43_L      _PK_L_(0xC6, 0x43)
#define REG_SC_BKC6_43_H      _PK_H_(0xC6, 0x43)
#define REG_SC_BKC6_44_L      _PK_L_(0xC6, 0x44)
#define REG_SC_BKC6_44_H      _PK_H_(0xC6, 0x44)
#define REG_SC_BKC6_45_L      _PK_L_(0xC6, 0x45)
#define REG_SC_BKC6_45_H      _PK_H_(0xC6, 0x45)
#define REG_SC_BKC6_46_L      _PK_L_(0xC6, 0x46)
#define REG_SC_BKC6_46_H      _PK_H_(0xC6, 0x46)
#define REG_SC_BKC6_47_L      _PK_L_(0xC6, 0x47)
#define REG_SC_BKC6_47_H      _PK_H_(0xC6, 0x47)
#define REG_SC_BKC6_48_L      _PK_L_(0xC6, 0x48)
#define REG_SC_BKC6_48_H      _PK_H_(0xC6, 0x48)
#define REG_SC_BKC6_49_L      _PK_L_(0xC6, 0x49)
#define REG_SC_BKC6_49_H      _PK_H_(0xC6, 0x49)
#define REG_SC_BKC6_4A_L      _PK_L_(0xC6, 0x4A)
#define REG_SC_BKC6_4A_H      _PK_H_(0xC6, 0x4A)
#define REG_SC_BKC6_4B_L      _PK_L_(0xC6, 0x4B)
#define REG_SC_BKC6_4B_H      _PK_H_(0xC6, 0x4B)
#define REG_SC_BKC6_4C_L      _PK_L_(0xC6, 0x4C)
#define REG_SC_BKC6_4C_H      _PK_H_(0xC6, 0x4C)
#define REG_SC_BKC6_4D_L      _PK_L_(0xC6, 0x4D)
#define REG_SC_BKC6_4D_H      _PK_H_(0xC6, 0x4D)
#define REG_SC_BKC6_4E_L      _PK_L_(0xC6, 0x4E)
#define REG_SC_BKC6_4E_H      _PK_H_(0xC6, 0x4E)
#define REG_SC_BKC6_4F_L      _PK_L_(0xC6, 0x4F)
#define REG_SC_BKC6_4F_H      _PK_H_(0xC6, 0x4F)
#define REG_SC_BKC6_50_L      _PK_L_(0xC6, 0x50)
#define REG_SC_BKC6_50_H      _PK_H_(0xC6, 0x50)
#define REG_SC_BKC6_51_L      _PK_L_(0xC6, 0x51)
#define REG_SC_BKC6_51_H      _PK_H_(0xC6, 0x51)
#define REG_SC_BKC6_52_L      _PK_L_(0xC6, 0x52)
#define REG_SC_BKC6_52_H      _PK_H_(0xC6, 0x52)
#define REG_SC_BKC6_53_L      _PK_L_(0xC6, 0x53)
#define REG_SC_BKC6_53_H      _PK_H_(0xC6, 0x53)
#define REG_SC_BKC6_54_L      _PK_L_(0xC6, 0x54)
#define REG_SC_BKC6_54_H      _PK_H_(0xC6, 0x54)
#define REG_SC_BKC6_55_L      _PK_L_(0xC6, 0x55)
#define REG_SC_BKC6_55_H      _PK_H_(0xC6, 0x55)
#define REG_SC_BKC6_56_L      _PK_L_(0xC6, 0x56)
#define REG_SC_BKC6_56_H      _PK_H_(0xC6, 0x56)
#define REG_SC_BKC6_57_L      _PK_L_(0xC6, 0x57)
#define REG_SC_BKC6_57_H      _PK_H_(0xC6, 0x57)
#define REG_SC_BKC6_58_L      _PK_L_(0xC6, 0x58)
#define REG_SC_BKC6_58_H      _PK_H_(0xC6, 0x58)
#define REG_SC_BKC6_59_L      _PK_L_(0xC6, 0x59)
#define REG_SC_BKC6_59_H      _PK_H_(0xC6, 0x59)
#define REG_SC_BKC6_5A_L      _PK_L_(0xC6, 0x5A)
#define REG_SC_BKC6_5A_H      _PK_H_(0xC6, 0x5A)
#define REG_SC_BKC6_5B_L      _PK_L_(0xC6, 0x5B)
#define REG_SC_BKC6_5B_H      _PK_H_(0xC6, 0x5B)
#define REG_SC_BKC6_5C_L      _PK_L_(0xC6, 0x5C)
#define REG_SC_BKC6_5C_H      _PK_H_(0xC6, 0x5C)
#define REG_SC_BKC6_5D_L      _PK_L_(0xC6, 0x5D)
#define REG_SC_BKC6_5D_H      _PK_H_(0xC6, 0x5D)
#define REG_SC_BKC6_5E_L      _PK_L_(0xC6, 0x5E)
#define REG_SC_BKC6_5E_H      _PK_H_(0xC6, 0x5E)
#define REG_SC_BKC6_5F_L      _PK_L_(0xC6, 0x5F)
#define REG_SC_BKC6_5F_H      _PK_H_(0xC6, 0x5F)
#define REG_SC_BKC6_60_L      _PK_L_(0xC6, 0x60)
#define REG_SC_BKC6_60_H      _PK_H_(0xC6, 0x60)
#define REG_SC_BKC6_61_L      _PK_L_(0xC6, 0x61)
#define REG_SC_BKC6_61_H      _PK_H_(0xC6, 0x61)
#define REG_SC_BKC6_62_L      _PK_L_(0xC6, 0x62)
#define REG_SC_BKC6_62_H      _PK_H_(0xC6, 0x62)
#define REG_SC_BKC6_63_L      _PK_L_(0xC6, 0x63)
#define REG_SC_BKC6_63_H      _PK_H_(0xC6, 0x63)
#define REG_SC_BKC6_64_L      _PK_L_(0xC6, 0x64)
#define REG_SC_BKC6_64_H      _PK_H_(0xC6, 0x64)
#define REG_SC_BKC6_65_L      _PK_L_(0xC6, 0x65)
#define REG_SC_BKC6_65_H      _PK_H_(0xC6, 0x65)
#define REG_SC_BKC6_66_L      _PK_L_(0xC6, 0x66)
#define REG_SC_BKC6_66_H      _PK_H_(0xC6, 0x66)
#define REG_SC_BKC6_67_L      _PK_L_(0xC6, 0x67)
#define REG_SC_BKC6_67_H      _PK_H_(0xC6, 0x67)
#define REG_SC_BKC6_68_L      _PK_L_(0xC6, 0x68)
#define REG_SC_BKC6_68_H      _PK_H_(0xC6, 0x68)
#define REG_SC_BKC6_69_L      _PK_L_(0xC6, 0x69)
#define REG_SC_BKC6_69_H      _PK_H_(0xC6, 0x69)
#define REG_SC_BKC6_6A_L      _PK_L_(0xC6, 0x6A)
#define REG_SC_BKC6_6A_H      _PK_H_(0xC6, 0x6A)
#define REG_SC_BKC6_6B_L      _PK_L_(0xC6, 0x6B)
#define REG_SC_BKC6_6B_H      _PK_H_(0xC6, 0x6B)
#define REG_SC_BKC6_6C_L      _PK_L_(0xC6, 0x6C)
#define REG_SC_BKC6_6C_H      _PK_H_(0xC6, 0x6C)
#define REG_SC_BKC6_6D_L      _PK_L_(0xC6, 0x6D)
#define REG_SC_BKC6_6D_H      _PK_H_(0xC6, 0x6D)
#define REG_SC_BKC6_6E_L      _PK_L_(0xC6, 0x6E)
#define REG_SC_BKC6_6E_H      _PK_H_(0xC6, 0x6E)
#define REG_SC_BKC6_6F_L      _PK_L_(0xC6, 0x6F)
#define REG_SC_BKC6_6F_H      _PK_H_(0xC6, 0x6F)
#define REG_SC_BKC6_70_L      _PK_L_(0xC6, 0x70)
#define REG_SC_BKC6_70_H      _PK_H_(0xC6, 0x70)
#define REG_SC_BKC6_71_L      _PK_L_(0xC6, 0x71)
#define REG_SC_BKC6_71_H      _PK_H_(0xC6, 0x71)
#define REG_SC_BKC6_72_L      _PK_L_(0xC6, 0x72)
#define REG_SC_BKC6_72_H      _PK_H_(0xC6, 0x72)
#define REG_SC_BKC6_73_L      _PK_L_(0xC6, 0x73)
#define REG_SC_BKC6_73_H      _PK_H_(0xC6, 0x73)
#define REG_SC_BKC6_74_L      _PK_L_(0xC6, 0x74)
#define REG_SC_BKC6_74_H      _PK_H_(0xC6, 0x74)
#define REG_SC_BKC6_75_L      _PK_L_(0xC6, 0x75)
#define REG_SC_BKC6_75_H      _PK_H_(0xC6, 0x75)
#define REG_SC_BKC6_76_L      _PK_L_(0xC6, 0x76)
#define REG_SC_BKC6_76_H      _PK_H_(0xC6, 0x76)
#define REG_SC_BKC6_77_L      _PK_L_(0xC6, 0x77)
#define REG_SC_BKC6_77_H      _PK_H_(0xC6, 0x77)
#define REG_SC_BKC6_78_L      _PK_L_(0xC6, 0x78)
#define REG_SC_BKC6_78_H      _PK_H_(0xC6, 0x78)
#define REG_SC_BKC6_79_L      _PK_L_(0xC6, 0x79)
#define REG_SC_BKC6_79_H      _PK_H_(0xC6, 0x79)
#define REG_SC_BKC6_7A_L      _PK_L_(0xC6, 0x7A)
#define REG_SC_BKC6_7A_H      _PK_H_(0xC6, 0x7A)
#define REG_SC_BKC6_7B_L      _PK_L_(0xC6, 0x7B)
#define REG_SC_BKC6_7B_H      _PK_H_(0xC6, 0x7B)
#define REG_SC_BKC6_7C_L      _PK_L_(0xC6, 0x7C)
#define REG_SC_BKC6_7C_H      _PK_H_(0xC6, 0x7C)
#define REG_SC_BKC6_7D_L      _PK_L_(0xC6, 0x7D)
#define REG_SC_BKC6_7D_H      _PK_H_(0xC6, 0x7D)
#define REG_SC_BKC6_7E_L      _PK_L_(0xC6, 0x7E)
#define REG_SC_BKC6_7E_H      _PK_H_(0xC6, 0x7E)
#define REG_SC_BKC6_7F_L      _PK_L_(0xC6, 0x7F)
#define REG_SC_BKC6_7F_H      _PK_H_(0xC6, 0x7F)
//----------------------------------------------
//  BKC7
//----------------------------------------------
#define REG_SC_BKC7_00_L      _PK_L_(0xC7, 0x00)
#define REG_SC_BKC7_00_H      _PK_H_(0xC7, 0x00)
#define REG_SC_BKC7_01_L      _PK_L_(0xC7, 0x01)
#define REG_SC_BKC7_01_H      _PK_H_(0xC7, 0x01)
#define REG_SC_BKC7_02_L      _PK_L_(0xC7, 0x02)
#define REG_SC_BKC7_02_H      _PK_H_(0xC7, 0x02)
#define REG_SC_BKC7_03_L      _PK_L_(0xC7, 0x03)
#define REG_SC_BKC7_03_H      _PK_H_(0xC7, 0x03)
#define REG_SC_BKC7_04_L      _PK_L_(0xC7, 0x04)
#define REG_SC_BKC7_04_H      _PK_H_(0xC7, 0x04)
#define REG_SC_BKC7_05_L      _PK_L_(0xC7, 0x05)
#define REG_SC_BKC7_05_H      _PK_H_(0xC7, 0x05)
#define REG_SC_BKC7_06_L      _PK_L_(0xC7, 0x06)
#define REG_SC_BKC7_06_H      _PK_H_(0xC7, 0x06)
#define REG_SC_BKC7_07_L      _PK_L_(0xC7, 0x07)
#define REG_SC_BKC7_07_H      _PK_H_(0xC7, 0x07)
#define REG_SC_BKC7_08_L      _PK_L_(0xC7, 0x08)
#define REG_SC_BKC7_08_H      _PK_H_(0xC7, 0x08)
#define REG_SC_BKC7_09_L      _PK_L_(0xC7, 0x09)
#define REG_SC_BKC7_09_H      _PK_H_(0xC7, 0x09)
#define REG_SC_BKC7_0A_L      _PK_L_(0xC7, 0x0A)
#define REG_SC_BKC7_0A_H      _PK_H_(0xC7, 0x0A)
#define REG_SC_BKC7_0B_L      _PK_L_(0xC7, 0x0B)
#define REG_SC_BKC7_0B_H      _PK_H_(0xC7, 0x0B)
#define REG_SC_BKC7_0C_L      _PK_L_(0xC7, 0x0C)
#define REG_SC_BKC7_0C_H      _PK_H_(0xC7, 0x0C)
#define REG_SC_BKC7_0D_L      _PK_L_(0xC7, 0x0D)
#define REG_SC_BKC7_0D_H      _PK_H_(0xC7, 0x0D)
#define REG_SC_BKC7_0E_L      _PK_L_(0xC7, 0x0E)
#define REG_SC_BKC7_0E_H      _PK_H_(0xC7, 0x0E)
#define REG_SC_BKC7_0F_L      _PK_L_(0xC7, 0x0F)
#define REG_SC_BKC7_0F_H      _PK_H_(0xC7, 0x0F)
#define REG_SC_BKC7_10_L      _PK_L_(0xC7, 0x10)
#define REG_SC_BKC7_10_H      _PK_H_(0xC7, 0x10)
#define REG_SC_BKC7_11_L      _PK_L_(0xC7, 0x11)
#define REG_SC_BKC7_11_H      _PK_H_(0xC7, 0x11)
#define REG_SC_BKC7_12_L      _PK_L_(0xC7, 0x12)
#define REG_SC_BKC7_12_H      _PK_H_(0xC7, 0x12)
#define REG_SC_BKC7_13_L      _PK_L_(0xC7, 0x13)
#define REG_SC_BKC7_13_H      _PK_H_(0xC7, 0x13)
#define REG_SC_BKC7_14_L      _PK_L_(0xC7, 0x14)
#define REG_SC_BKC7_14_H      _PK_H_(0xC7, 0x14)
#define REG_SC_BKC7_15_L      _PK_L_(0xC7, 0x15)
#define REG_SC_BKC7_15_H      _PK_H_(0xC7, 0x15)
#define REG_SC_BKC7_16_L      _PK_L_(0xC7, 0x16)
#define REG_SC_BKC7_16_H      _PK_H_(0xC7, 0x16)
#define REG_SC_BKC7_17_L      _PK_L_(0xC7, 0x17)
#define REG_SC_BKC7_17_H      _PK_H_(0xC7, 0x17)
#define REG_SC_BKC7_18_L      _PK_L_(0xC7, 0x18)
#define REG_SC_BKC7_18_H      _PK_H_(0xC7, 0x18)
#define REG_SC_BKC7_19_L      _PK_L_(0xC7, 0x19)
#define REG_SC_BKC7_19_H      _PK_H_(0xC7, 0x19)
#define REG_SC_BKC7_1A_L      _PK_L_(0xC7, 0x1A)
#define REG_SC_BKC7_1A_H      _PK_H_(0xC7, 0x1A)
#define REG_SC_BKC7_1B_L      _PK_L_(0xC7, 0x1B)
#define REG_SC_BKC7_1B_H      _PK_H_(0xC7, 0x1B)
#define REG_SC_BKC7_1C_L      _PK_L_(0xC7, 0x1C)
#define REG_SC_BKC7_1C_H      _PK_H_(0xC7, 0x1C)
#define REG_SC_BKC7_1D_L      _PK_L_(0xC7, 0x1D)
#define REG_SC_BKC7_1D_H      _PK_H_(0xC7, 0x1D)
#define REG_SC_BKC7_1E_L      _PK_L_(0xC7, 0x1E)
#define REG_SC_BKC7_1E_H      _PK_H_(0xC7, 0x1E)
#define REG_SC_BKC7_1F_L      _PK_L_(0xC7, 0x1F)
#define REG_SC_BKC7_1F_H      _PK_H_(0xC7, 0x1F)
#define REG_SC_BKC7_20_L      _PK_L_(0xC7, 0x20)
#define REG_SC_BKC7_20_H      _PK_H_(0xC7, 0x20)
#define REG_SC_BKC7_21_L      _PK_L_(0xC7, 0x21)
#define REG_SC_BKC7_21_H      _PK_H_(0xC7, 0x21)
#define REG_SC_BKC7_22_L      _PK_L_(0xC7, 0x22)
#define REG_SC_BKC7_22_H      _PK_H_(0xC7, 0x22)
#define REG_SC_BKC7_23_L      _PK_L_(0xC7, 0x23)
#define REG_SC_BKC7_23_H      _PK_H_(0xC7, 0x23)
#define REG_SC_BKC7_24_L      _PK_L_(0xC7, 0x24)
#define REG_SC_BKC7_24_H      _PK_H_(0xC7, 0x24)
#define REG_SC_BKC7_25_L      _PK_L_(0xC7, 0x25)
#define REG_SC_BKC7_25_H      _PK_H_(0xC7, 0x25)
#define REG_SC_BKC7_26_L      _PK_L_(0xC7, 0x26)
#define REG_SC_BKC7_26_H      _PK_H_(0xC7, 0x26)
#define REG_SC_BKC7_27_L      _PK_L_(0xC7, 0x27)
#define REG_SC_BKC7_27_H      _PK_H_(0xC7, 0x27)
#define REG_SC_BKC7_28_L      _PK_L_(0xC7, 0x28)
#define REG_SC_BKC7_28_H      _PK_H_(0xC7, 0x28)
#define REG_SC_BKC7_29_L      _PK_L_(0xC7, 0x29)
#define REG_SC_BKC7_29_H      _PK_H_(0xC7, 0x29)
#define REG_SC_BKC7_2A_L      _PK_L_(0xC7, 0x2A)
#define REG_SC_BKC7_2A_H      _PK_H_(0xC7, 0x2A)
#define REG_SC_BKC7_2B_L      _PK_L_(0xC7, 0x2B)
#define REG_SC_BKC7_2B_H      _PK_H_(0xC7, 0x2B)
#define REG_SC_BKC7_2C_L      _PK_L_(0xC7, 0x2C)
#define REG_SC_BKC7_2C_H      _PK_H_(0xC7, 0x2C)
#define REG_SC_BKC7_2D_L      _PK_L_(0xC7, 0x2D)
#define REG_SC_BKC7_2D_H      _PK_H_(0xC7, 0x2D)
#define REG_SC_BKC7_2E_L      _PK_L_(0xC7, 0x2E)
#define REG_SC_BKC7_2E_H      _PK_H_(0xC7, 0x2E)
#define REG_SC_BKC7_2F_L      _PK_L_(0xC7, 0x2F)
#define REG_SC_BKC7_2F_H      _PK_H_(0xC7, 0x2F)
#define REG_SC_BKC7_30_L      _PK_L_(0xC7, 0x30)
#define REG_SC_BKC7_30_H      _PK_H_(0xC7, 0x30)
#define REG_SC_BKC7_31_L      _PK_L_(0xC7, 0x31)
#define REG_SC_BKC7_31_H      _PK_H_(0xC7, 0x31)
#define REG_SC_BKC7_32_L      _PK_L_(0xC7, 0x32)
#define REG_SC_BKC7_32_H      _PK_H_(0xC7, 0x32)
#define REG_SC_BKC7_33_L      _PK_L_(0xC7, 0x33)
#define REG_SC_BKC7_33_H      _PK_H_(0xC7, 0x33)
#define REG_SC_BKC7_34_L      _PK_L_(0xC7, 0x34)
#define REG_SC_BKC7_34_H      _PK_H_(0xC7, 0x34)
#define REG_SC_BKC7_35_L      _PK_L_(0xC7, 0x35)
#define REG_SC_BKC7_35_H      _PK_H_(0xC7, 0x35)
#define REG_SC_BKC7_36_L      _PK_L_(0xC7, 0x36)
#define REG_SC_BKC7_36_H      _PK_H_(0xC7, 0x36)
#define REG_SC_BKC7_37_L      _PK_L_(0xC7, 0x37)
#define REG_SC_BKC7_37_H      _PK_H_(0xC7, 0x37)
#define REG_SC_BKC7_38_L      _PK_L_(0xC7, 0x38)
#define REG_SC_BKC7_38_H      _PK_H_(0xC7, 0x38)
#define REG_SC_BKC7_39_L      _PK_L_(0xC7, 0x39)
#define REG_SC_BKC7_39_H      _PK_H_(0xC7, 0x39)
#define REG_SC_BKC7_3A_L      _PK_L_(0xC7, 0x3A)
#define REG_SC_BKC7_3A_H      _PK_H_(0xC7, 0x3A)
#define REG_SC_BKC7_3B_L      _PK_L_(0xC7, 0x3B)
#define REG_SC_BKC7_3B_H      _PK_H_(0xC7, 0x3B)
#define REG_SC_BKC7_3C_L      _PK_L_(0xC7, 0x3C)
#define REG_SC_BKC7_3C_H      _PK_H_(0xC7, 0x3C)
#define REG_SC_BKC7_3D_L      _PK_L_(0xC7, 0x3D)
#define REG_SC_BKC7_3D_H      _PK_H_(0xC7, 0x3D)
#define REG_SC_BKC7_3E_L      _PK_L_(0xC7, 0x3E)
#define REG_SC_BKC7_3E_H      _PK_H_(0xC7, 0x3E)
#define REG_SC_BKC7_3F_L      _PK_L_(0xC7, 0x3F)
#define REG_SC_BKC7_3F_H      _PK_H_(0xC7, 0x3F)
#define REG_SC_BKC7_40_L      _PK_L_(0xC7, 0x40)
#define REG_SC_BKC7_40_H      _PK_H_(0xC7, 0x40)
#define REG_SC_BKC7_41_L      _PK_L_(0xC7, 0x41)
#define REG_SC_BKC7_41_H      _PK_H_(0xC7, 0x41)
#define REG_SC_BKC7_42_L      _PK_L_(0xC7, 0x42)
#define REG_SC_BKC7_42_H      _PK_H_(0xC7, 0x42)
#define REG_SC_BKC7_43_L      _PK_L_(0xC7, 0x43)
#define REG_SC_BKC7_43_H      _PK_H_(0xC7, 0x43)
#define REG_SC_BKC7_44_L      _PK_L_(0xC7, 0x44)
#define REG_SC_BKC7_44_H      _PK_H_(0xC7, 0x44)
#define REG_SC_BKC7_45_L      _PK_L_(0xC7, 0x45)
#define REG_SC_BKC7_45_H      _PK_H_(0xC7, 0x45)
#define REG_SC_BKC7_46_L      _PK_L_(0xC7, 0x46)
#define REG_SC_BKC7_46_H      _PK_H_(0xC7, 0x46)
#define REG_SC_BKC7_47_L      _PK_L_(0xC7, 0x47)
#define REG_SC_BKC7_47_H      _PK_H_(0xC7, 0x47)
#define REG_SC_BKC7_48_L      _PK_L_(0xC7, 0x48)
#define REG_SC_BKC7_48_H      _PK_H_(0xC7, 0x48)
#define REG_SC_BKC7_49_L      _PK_L_(0xC7, 0x49)
#define REG_SC_BKC7_49_H      _PK_H_(0xC7, 0x49)
#define REG_SC_BKC7_4A_L      _PK_L_(0xC7, 0x4A)
#define REG_SC_BKC7_4A_H      _PK_H_(0xC7, 0x4A)
#define REG_SC_BKC7_4B_L      _PK_L_(0xC7, 0x4B)
#define REG_SC_BKC7_4B_H      _PK_H_(0xC7, 0x4B)
#define REG_SC_BKC7_4C_L      _PK_L_(0xC7, 0x4C)
#define REG_SC_BKC7_4C_H      _PK_H_(0xC7, 0x4C)
#define REG_SC_BKC7_4D_L      _PK_L_(0xC7, 0x4D)
#define REG_SC_BKC7_4D_H      _PK_H_(0xC7, 0x4D)
#define REG_SC_BKC7_4E_L      _PK_L_(0xC7, 0x4E)
#define REG_SC_BKC7_4E_H      _PK_H_(0xC7, 0x4E)
#define REG_SC_BKC7_4F_L      _PK_L_(0xC7, 0x4F)
#define REG_SC_BKC7_4F_H      _PK_H_(0xC7, 0x4F)
#define REG_SC_BKC7_50_L      _PK_L_(0xC7, 0x50)
#define REG_SC_BKC7_50_H      _PK_H_(0xC7, 0x50)
#define REG_SC_BKC7_51_L      _PK_L_(0xC7, 0x51)
#define REG_SC_BKC7_51_H      _PK_H_(0xC7, 0x51)
#define REG_SC_BKC7_52_L      _PK_L_(0xC7, 0x52)
#define REG_SC_BKC7_52_H      _PK_H_(0xC7, 0x52)
#define REG_SC_BKC7_53_L      _PK_L_(0xC7, 0x53)
#define REG_SC_BKC7_53_H      _PK_H_(0xC7, 0x53)
#define REG_SC_BKC7_54_L      _PK_L_(0xC7, 0x54)
#define REG_SC_BKC7_54_H      _PK_H_(0xC7, 0x54)
#define REG_SC_BKC7_55_L      _PK_L_(0xC7, 0x55)
#define REG_SC_BKC7_55_H      _PK_H_(0xC7, 0x55)
#define REG_SC_BKC7_56_L      _PK_L_(0xC7, 0x56)
#define REG_SC_BKC7_56_H      _PK_H_(0xC7, 0x56)
#define REG_SC_BKC7_57_L      _PK_L_(0xC7, 0x57)
#define REG_SC_BKC7_57_H      _PK_H_(0xC7, 0x57)
#define REG_SC_BKC7_58_L      _PK_L_(0xC7, 0x58)
#define REG_SC_BKC7_58_H      _PK_H_(0xC7, 0x58)
#define REG_SC_BKC7_59_L      _PK_L_(0xC7, 0x59)
#define REG_SC_BKC7_59_H      _PK_H_(0xC7, 0x59)
#define REG_SC_BKC7_5A_L      _PK_L_(0xC7, 0x5A)
#define REG_SC_BKC7_5A_H      _PK_H_(0xC7, 0x5A)
#define REG_SC_BKC7_5B_L      _PK_L_(0xC7, 0x5B)
#define REG_SC_BKC7_5B_H      _PK_H_(0xC7, 0x5B)
#define REG_SC_BKC7_5C_L      _PK_L_(0xC7, 0x5C)
#define REG_SC_BKC7_5C_H      _PK_H_(0xC7, 0x5C)
#define REG_SC_BKC7_5D_L      _PK_L_(0xC7, 0x5D)
#define REG_SC_BKC7_5D_H      _PK_H_(0xC7, 0x5D)
#define REG_SC_BKC7_5E_L      _PK_L_(0xC7, 0x5E)
#define REG_SC_BKC7_5E_H      _PK_H_(0xC7, 0x5E)
#define REG_SC_BKC7_5F_L      _PK_L_(0xC7, 0x5F)
#define REG_SC_BKC7_5F_H      _PK_H_(0xC7, 0x5F)
#define REG_SC_BKC7_60_L      _PK_L_(0xC7, 0x60)
#define REG_SC_BKC7_60_H      _PK_H_(0xC7, 0x60)
#define REG_SC_BKC7_61_L      _PK_L_(0xC7, 0x61)
#define REG_SC_BKC7_61_H      _PK_H_(0xC7, 0x61)
#define REG_SC_BKC7_62_L      _PK_L_(0xC7, 0x62)
#define REG_SC_BKC7_62_H      _PK_H_(0xC7, 0x62)
#define REG_SC_BKC7_63_L      _PK_L_(0xC7, 0x63)
#define REG_SC_BKC7_63_H      _PK_H_(0xC7, 0x63)
#define REG_SC_BKC7_64_L      _PK_L_(0xC7, 0x64)
#define REG_SC_BKC7_64_H      _PK_H_(0xC7, 0x64)
#define REG_SC_BKC7_65_L      _PK_L_(0xC7, 0x65)
#define REG_SC_BKC7_65_H      _PK_H_(0xC7, 0x65)
#define REG_SC_BKC7_66_L      _PK_L_(0xC7, 0x66)
#define REG_SC_BKC7_66_H      _PK_H_(0xC7, 0x66)
#define REG_SC_BKC7_67_L      _PK_L_(0xC7, 0x67)
#define REG_SC_BKC7_67_H      _PK_H_(0xC7, 0x67)
#define REG_SC_BKC7_68_L      _PK_L_(0xC7, 0x68)
#define REG_SC_BKC7_68_H      _PK_H_(0xC7, 0x68)
#define REG_SC_BKC7_69_L      _PK_L_(0xC7, 0x69)
#define REG_SC_BKC7_69_H      _PK_H_(0xC7, 0x69)
#define REG_SC_BKC7_6A_L      _PK_L_(0xC7, 0x6A)
#define REG_SC_BKC7_6A_H      _PK_H_(0xC7, 0x6A)
#define REG_SC_BKC7_6B_L      _PK_L_(0xC7, 0x6B)
#define REG_SC_BKC7_6B_H      _PK_H_(0xC7, 0x6B)
#define REG_SC_BKC7_6C_L      _PK_L_(0xC7, 0x6C)
#define REG_SC_BKC7_6C_H      _PK_H_(0xC7, 0x6C)
#define REG_SC_BKC7_6D_L      _PK_L_(0xC7, 0x6D)
#define REG_SC_BKC7_6D_H      _PK_H_(0xC7, 0x6D)
#define REG_SC_BKC7_6E_L      _PK_L_(0xC7, 0x6E)
#define REG_SC_BKC7_6E_H      _PK_H_(0xC7, 0x6E)
#define REG_SC_BKC7_6F_L      _PK_L_(0xC7, 0x6F)
#define REG_SC_BKC7_6F_H      _PK_H_(0xC7, 0x6F)
#define REG_SC_BKC7_70_L      _PK_L_(0xC7, 0x70)
#define REG_SC_BKC7_70_H      _PK_H_(0xC7, 0x70)
#define REG_SC_BKC7_71_L      _PK_L_(0xC7, 0x71)
#define REG_SC_BKC7_71_H      _PK_H_(0xC7, 0x71)
#define REG_SC_BKC7_72_L      _PK_L_(0xC7, 0x72)
#define REG_SC_BKC7_72_H      _PK_H_(0xC7, 0x72)
#define REG_SC_BKC7_73_L      _PK_L_(0xC7, 0x73)
#define REG_SC_BKC7_73_H      _PK_H_(0xC7, 0x73)
#define REG_SC_BKC7_74_L      _PK_L_(0xC7, 0x74)
#define REG_SC_BKC7_74_H      _PK_H_(0xC7, 0x74)
#define REG_SC_BKC7_75_L      _PK_L_(0xC7, 0x75)
#define REG_SC_BKC7_75_H      _PK_H_(0xC7, 0x75)
#define REG_SC_BKC7_76_L      _PK_L_(0xC7, 0x76)
#define REG_SC_BKC7_76_H      _PK_H_(0xC7, 0x76)
#define REG_SC_BKC7_77_L      _PK_L_(0xC7, 0x77)
#define REG_SC_BKC7_77_H      _PK_H_(0xC7, 0x77)
#define REG_SC_BKC7_78_L      _PK_L_(0xC7, 0x78)
#define REG_SC_BKC7_78_H      _PK_H_(0xC7, 0x78)
#define REG_SC_BKC7_79_L      _PK_L_(0xC7, 0x79)
#define REG_SC_BKC7_79_H      _PK_H_(0xC7, 0x79)
#define REG_SC_BKC7_7A_L      _PK_L_(0xC7, 0x7A)
#define REG_SC_BKC7_7A_H      _PK_H_(0xC7, 0x7A)
#define REG_SC_BKC7_7B_L      _PK_L_(0xC7, 0x7B)
#define REG_SC_BKC7_7B_H      _PK_H_(0xC7, 0x7B)
#define REG_SC_BKC7_7C_L      _PK_L_(0xC7, 0x7C)
#define REG_SC_BKC7_7C_H      _PK_H_(0xC7, 0x7C)
#define REG_SC_BKC7_7D_L      _PK_L_(0xC7, 0x7D)
#define REG_SC_BKC7_7D_H      _PK_H_(0xC7, 0x7D)
#define REG_SC_BKC7_7E_L      _PK_L_(0xC7, 0x7E)
#define REG_SC_BKC7_7E_H      _PK_H_(0xC7, 0x7E)
#define REG_SC_BKC7_7F_L      _PK_L_(0xC7, 0x7F)
#define REG_SC_BKC7_7F_H      _PK_H_(0xC7, 0x7F)

//----------------------------------------------
//  BKC8
//----------------------------------------------
#define REG_SC_BKC8_00_L      _PK_L_(0xC8, 0x00)
#define REG_SC_BKC8_00_H      _PK_H_(0xC8, 0x00)
#define REG_SC_BKC8_01_L      _PK_L_(0xC8, 0x01)
#define REG_SC_BKC8_01_H      _PK_H_(0xC8, 0x01)
#define REG_SC_BKC8_02_L      _PK_L_(0xC8, 0x02)
#define REG_SC_BKC8_02_H      _PK_H_(0xC8, 0x02)
#define REG_SC_BKC8_03_L      _PK_L_(0xC8, 0x03)
#define REG_SC_BKC8_03_H      _PK_H_(0xC8, 0x03)
#define REG_SC_BKC8_04_L      _PK_L_(0xC8, 0x04)
#define REG_SC_BKC8_04_H      _PK_H_(0xC8, 0x04)
#define REG_SC_BKC8_05_L      _PK_L_(0xC8, 0x05)
#define REG_SC_BKC8_05_H      _PK_H_(0xC8, 0x05)
#define REG_SC_BKC8_06_L      _PK_L_(0xC8, 0x06)
#define REG_SC_BKC8_06_H      _PK_H_(0xC8, 0x06)
#define REG_SC_BKC8_07_L      _PK_L_(0xC8, 0x07)
#define REG_SC_BKC8_07_H      _PK_H_(0xC8, 0x07)
#define REG_SC_BKC8_08_L      _PK_L_(0xC8, 0x08)
#define REG_SC_BKC8_08_H      _PK_H_(0xC8, 0x08)
#define REG_SC_BKC8_09_L      _PK_L_(0xC8, 0x09)
#define REG_SC_BKC8_09_H      _PK_H_(0xC8, 0x09)
#define REG_SC_BKC8_0A_L      _PK_L_(0xC8, 0x0A)
#define REG_SC_BKC8_0A_H      _PK_H_(0xC8, 0x0A)
#define REG_SC_BKC8_0B_L      _PK_L_(0xC8, 0x0B)
#define REG_SC_BKC8_0B_H      _PK_H_(0xC8, 0x0B)
#define REG_SC_BKC8_0C_L      _PK_L_(0xC8, 0x0C)
#define REG_SC_BKC8_0C_H      _PK_H_(0xC8, 0x0C)
#define REG_SC_BKC8_0D_L      _PK_L_(0xC8, 0x0D)
#define REG_SC_BKC8_0D_H      _PK_H_(0xC8, 0x0D)
#define REG_SC_BKC8_0E_L      _PK_L_(0xC8, 0x0E)
#define REG_SC_BKC8_0E_H      _PK_H_(0xC8, 0x0E)
#define REG_SC_BKC8_0F_L      _PK_L_(0xC8, 0x0F)
#define REG_SC_BKC8_0F_H      _PK_H_(0xC8, 0x0F)
#define REG_SC_BKC8_10_L      _PK_L_(0xC8, 0x10)
#define REG_SC_BKC8_10_H      _PK_H_(0xC8, 0x10)
#define REG_SC_BKC8_11_L      _PK_L_(0xC8, 0x11)
#define REG_SC_BKC8_11_H      _PK_H_(0xC8, 0x11)
#define REG_SC_BKC8_12_L      _PK_L_(0xC8, 0x12)
#define REG_SC_BKC8_12_H      _PK_H_(0xC8, 0x12)
#define REG_SC_BKC8_13_L      _PK_L_(0xC8, 0x13)
#define REG_SC_BKC8_13_H      _PK_H_(0xC8, 0x13)
#define REG_SC_BKC8_14_L      _PK_L_(0xC8, 0x14)
#define REG_SC_BKC8_14_H      _PK_H_(0xC8, 0x14)
#define REG_SC_BKC8_15_L      _PK_L_(0xC8, 0x15)
#define REG_SC_BKC8_15_H      _PK_H_(0xC8, 0x15)
#define REG_SC_BKC8_16_L      _PK_L_(0xC8, 0x16)
#define REG_SC_BKC8_16_H      _PK_H_(0xC8, 0x16)
#define REG_SC_BKC8_17_L      _PK_L_(0xC8, 0x17)
#define REG_SC_BKC8_17_H      _PK_H_(0xC8, 0x17)
#define REG_SC_BKC8_18_L      _PK_L_(0xC8, 0x18)
#define REG_SC_BKC8_18_H      _PK_H_(0xC8, 0x18)
#define REG_SC_BKC8_19_L      _PK_L_(0xC8, 0x19)
#define REG_SC_BKC8_19_H      _PK_H_(0xC8, 0x19)
#define REG_SC_BKC8_1A_L      _PK_L_(0xC8, 0x1A)
#define REG_SC_BKC8_1A_H      _PK_H_(0xC8, 0x1A)
#define REG_SC_BKC8_1B_L      _PK_L_(0xC8, 0x1B)
#define REG_SC_BKC8_1B_H      _PK_H_(0xC8, 0x1B)
#define REG_SC_BKC8_1C_L      _PK_L_(0xC8, 0x1C)
#define REG_SC_BKC8_1C_H      _PK_H_(0xC8, 0x1C)
#define REG_SC_BKC8_1D_L      _PK_L_(0xC8, 0x1D)
#define REG_SC_BKC8_1D_H      _PK_H_(0xC8, 0x1D)
#define REG_SC_BKC8_1E_L      _PK_L_(0xC8, 0x1E)
#define REG_SC_BKC8_1E_H      _PK_H_(0xC8, 0x1E)
#define REG_SC_BKC8_1F_L      _PK_L_(0xC8, 0x1F)
#define REG_SC_BKC8_1F_H      _PK_H_(0xC8, 0x1F)
#define REG_SC_BKC8_20_L      _PK_L_(0xC8, 0x20)
#define REG_SC_BKC8_20_H      _PK_H_(0xC8, 0x20)
#define REG_SC_BKC8_21_L      _PK_L_(0xC8, 0x21)
#define REG_SC_BKC8_21_H      _PK_H_(0xC8, 0x21)
#define REG_SC_BKC8_22_L      _PK_L_(0xC8, 0x22)
#define REG_SC_BKC8_22_H      _PK_H_(0xC8, 0x22)
#define REG_SC_BKC8_23_L      _PK_L_(0xC8, 0x23)
#define REG_SC_BKC8_23_H      _PK_H_(0xC8, 0x23)
#define REG_SC_BKC8_24_L      _PK_L_(0xC8, 0x24)
#define REG_SC_BKC8_24_H      _PK_H_(0xC8, 0x24)
#define REG_SC_BKC8_25_L      _PK_L_(0xC8, 0x25)
#define REG_SC_BKC8_25_H      _PK_H_(0xC8, 0x25)
#define REG_SC_BKC8_26_L      _PK_L_(0xC8, 0x26)
#define REG_SC_BKC8_26_H      _PK_H_(0xC8, 0x26)
#define REG_SC_BKC8_27_L      _PK_L_(0xC8, 0x27)
#define REG_SC_BKC8_27_H      _PK_H_(0xC8, 0x27)
#define REG_SC_BKC8_28_L      _PK_L_(0xC8, 0x28)
#define REG_SC_BKC8_28_H      _PK_H_(0xC8, 0x28)
#define REG_SC_BKC8_29_L      _PK_L_(0xC8, 0x29)
#define REG_SC_BKC8_29_H      _PK_H_(0xC8, 0x29)
#define REG_SC_BKC8_2A_L      _PK_L_(0xC8, 0x2A)
#define REG_SC_BKC8_2A_H      _PK_H_(0xC8, 0x2A)
#define REG_SC_BKC8_2B_L      _PK_L_(0xC8, 0x2B)
#define REG_SC_BKC8_2B_H      _PK_H_(0xC8, 0x2B)
#define REG_SC_BKC8_2C_L      _PK_L_(0xC8, 0x2C)
#define REG_SC_BKC8_2C_H      _PK_H_(0xC8, 0x2C)
#define REG_SC_BKC8_2D_L      _PK_L_(0xC8, 0x2D)
#define REG_SC_BKC8_2D_H      _PK_H_(0xC8, 0x2D)
#define REG_SC_BKC8_2E_L      _PK_L_(0xC8, 0x2E)
#define REG_SC_BKC8_2E_H      _PK_H_(0xC8, 0x2E)
#define REG_SC_BKC8_2F_L      _PK_L_(0xC8, 0x2F)
#define REG_SC_BKC8_2F_H      _PK_H_(0xC8, 0x2F)
#define REG_SC_BKC8_30_L      _PK_L_(0xC8, 0x30)
#define REG_SC_BKC8_30_H      _PK_H_(0xC8, 0x30)
#define REG_SC_BKC8_31_L      _PK_L_(0xC8, 0x31)
#define REG_SC_BKC8_31_H      _PK_H_(0xC8, 0x31)
#define REG_SC_BKC8_32_L      _PK_L_(0xC8, 0x32)
#define REG_SC_BKC8_32_H      _PK_H_(0xC8, 0x32)
#define REG_SC_BKC8_33_L      _PK_L_(0xC8, 0x33)
#define REG_SC_BKC8_33_H      _PK_H_(0xC8, 0x33)
#define REG_SC_BKC8_34_L      _PK_L_(0xC8, 0x34)
#define REG_SC_BKC8_34_H      _PK_H_(0xC8, 0x34)
#define REG_SC_BKC8_35_L      _PK_L_(0xC8, 0x35)
#define REG_SC_BKC8_35_H      _PK_H_(0xC8, 0x35)
#define REG_SC_BKC8_36_L      _PK_L_(0xC8, 0x36)
#define REG_SC_BKC8_36_H      _PK_H_(0xC8, 0x36)
#define REG_SC_BKC8_37_L      _PK_L_(0xC8, 0x37)
#define REG_SC_BKC8_37_H      _PK_H_(0xC8, 0x37)
#define REG_SC_BKC8_38_L      _PK_L_(0xC8, 0x38)
#define REG_SC_BKC8_38_H      _PK_H_(0xC8, 0x38)
#define REG_SC_BKC8_39_L      _PK_L_(0xC8, 0x39)
#define REG_SC_BKC8_39_H      _PK_H_(0xC8, 0x39)
#define REG_SC_BKC8_3A_L      _PK_L_(0xC8, 0x3A)
#define REG_SC_BKC8_3A_H      _PK_H_(0xC8, 0x3A)
#define REG_SC_BKC8_3B_L      _PK_L_(0xC8, 0x3B)
#define REG_SC_BKC8_3B_H      _PK_H_(0xC8, 0x3B)
#define REG_SC_BKC8_3C_L      _PK_L_(0xC8, 0x3C)
#define REG_SC_BKC8_3C_H      _PK_H_(0xC8, 0x3C)
#define REG_SC_BKC8_3D_L      _PK_L_(0xC8, 0x3D)
#define REG_SC_BKC8_3D_H      _PK_H_(0xC8, 0x3D)
#define REG_SC_BKC8_3E_L      _PK_L_(0xC8, 0x3E)
#define REG_SC_BKC8_3E_H      _PK_H_(0xC8, 0x3E)
#define REG_SC_BKC8_3F_L      _PK_L_(0xC8, 0x3F)
#define REG_SC_BKC8_3F_H      _PK_H_(0xC8, 0x3F)
#define REG_SC_BKC8_40_L      _PK_L_(0xC8, 0x40)
#define REG_SC_BKC8_40_H      _PK_H_(0xC8, 0x40)
#define REG_SC_BKC8_41_L      _PK_L_(0xC8, 0x41)
#define REG_SC_BKC8_41_H      _PK_H_(0xC8, 0x41)
#define REG_SC_BKC8_42_L      _PK_L_(0xC8, 0x42)
#define REG_SC_BKC8_42_H      _PK_H_(0xC8, 0x42)
#define REG_SC_BKC8_43_L      _PK_L_(0xC8, 0x43)
#define REG_SC_BKC8_43_H      _PK_H_(0xC8, 0x43)
#define REG_SC_BKC8_44_L      _PK_L_(0xC8, 0x44)
#define REG_SC_BKC8_44_H      _PK_H_(0xC8, 0x44)
#define REG_SC_BKC8_45_L      _PK_L_(0xC8, 0x45)
#define REG_SC_BKC8_45_H      _PK_H_(0xC8, 0x45)
#define REG_SC_BKC8_46_L      _PK_L_(0xC8, 0x46)
#define REG_SC_BKC8_46_H      _PK_H_(0xC8, 0x46)
#define REG_SC_BKC8_47_L      _PK_L_(0xC8, 0x47)
#define REG_SC_BKC8_47_H      _PK_H_(0xC8, 0x47)
#define REG_SC_BKC8_48_L      _PK_L_(0xC8, 0x48)
#define REG_SC_BKC8_48_H      _PK_H_(0xC8, 0x48)
#define REG_SC_BKC8_49_L      _PK_L_(0xC8, 0x49)
#define REG_SC_BKC8_49_H      _PK_H_(0xC8, 0x49)
#define REG_SC_BKC8_4A_L      _PK_L_(0xC8, 0x4A)
#define REG_SC_BKC8_4A_H      _PK_H_(0xC8, 0x4A)
#define REG_SC_BKC8_4B_L      _PK_L_(0xC8, 0x4B)
#define REG_SC_BKC8_4B_H      _PK_H_(0xC8, 0x4B)
#define REG_SC_BKC8_4C_L      _PK_L_(0xC8, 0x4C)
#define REG_SC_BKC8_4C_H      _PK_H_(0xC8, 0x4C)
#define REG_SC_BKC8_4D_L      _PK_L_(0xC8, 0x4D)
#define REG_SC_BKC8_4D_H      _PK_H_(0xC8, 0x4D)
#define REG_SC_BKC8_4E_L      _PK_L_(0xC8, 0x4E)
#define REG_SC_BKC8_4E_H      _PK_H_(0xC8, 0x4E)
#define REG_SC_BKC8_4F_L      _PK_L_(0xC8, 0x4F)
#define REG_SC_BKC8_4F_H      _PK_H_(0xC8, 0x4F)
#define REG_SC_BKC8_50_L      _PK_L_(0xC8, 0x50)
#define REG_SC_BKC8_50_H      _PK_H_(0xC8, 0x50)
#define REG_SC_BKC8_51_L      _PK_L_(0xC8, 0x51)
#define REG_SC_BKC8_51_H      _PK_H_(0xC8, 0x51)
#define REG_SC_BKC8_52_L      _PK_L_(0xC8, 0x52)
#define REG_SC_BKC8_52_H      _PK_H_(0xC8, 0x52)
#define REG_SC_BKC8_53_L      _PK_L_(0xC8, 0x53)
#define REG_SC_BKC8_53_H      _PK_H_(0xC8, 0x53)
#define REG_SC_BKC8_54_L      _PK_L_(0xC8, 0x54)
#define REG_SC_BKC8_54_H      _PK_H_(0xC8, 0x54)
#define REG_SC_BKC8_55_L      _PK_L_(0xC8, 0x55)
#define REG_SC_BKC8_55_H      _PK_H_(0xC8, 0x55)
#define REG_SC_BKC8_56_L      _PK_L_(0xC8, 0x56)
#define REG_SC_BKC8_56_H      _PK_H_(0xC8, 0x56)
#define REG_SC_BKC8_57_L      _PK_L_(0xC8, 0x57)
#define REG_SC_BKC8_57_H      _PK_H_(0xC8, 0x57)
#define REG_SC_BKC8_58_L      _PK_L_(0xC8, 0x58)
#define REG_SC_BKC8_58_H      _PK_H_(0xC8, 0x58)
#define REG_SC_BKC8_59_L      _PK_L_(0xC8, 0x59)
#define REG_SC_BKC8_59_H      _PK_H_(0xC8, 0x59)
#define REG_SC_BKC8_5A_L      _PK_L_(0xC8, 0x5A)
#define REG_SC_BKC8_5A_H      _PK_H_(0xC8, 0x5A)
#define REG_SC_BKC8_5B_L      _PK_L_(0xC8, 0x5B)
#define REG_SC_BKC8_5B_H      _PK_H_(0xC8, 0x5B)
#define REG_SC_BKC8_5C_L      _PK_L_(0xC8, 0x5C)
#define REG_SC_BKC8_5C_H      _PK_H_(0xC8, 0x5C)
#define REG_SC_BKC8_5D_L      _PK_L_(0xC8, 0x5D)
#define REG_SC_BKC8_5D_H      _PK_H_(0xC8, 0x5D)
#define REG_SC_BKC8_5E_L      _PK_L_(0xC8, 0x5E)
#define REG_SC_BKC8_5E_H      _PK_H_(0xC8, 0x5E)
#define REG_SC_BKC8_5F_L      _PK_L_(0xC8, 0x5F)
#define REG_SC_BKC8_5F_H      _PK_H_(0xC8, 0x5F)
#define REG_SC_BKC8_60_L      _PK_L_(0xC8, 0x60)
#define REG_SC_BKC8_60_H      _PK_H_(0xC8, 0x60)
#define REG_SC_BKC8_61_L      _PK_L_(0xC8, 0x61)
#define REG_SC_BKC8_61_H      _PK_H_(0xC8, 0x61)
#define REG_SC_BKC8_62_L      _PK_L_(0xC8, 0x62)
#define REG_SC_BKC8_62_H      _PK_H_(0xC8, 0x62)
#define REG_SC_BKC8_63_L      _PK_L_(0xC8, 0x63)
#define REG_SC_BKC8_63_H      _PK_H_(0xC8, 0x63)
#define REG_SC_BKC8_64_L      _PK_L_(0xC8, 0x64)
#define REG_SC_BKC8_64_H      _PK_H_(0xC8, 0x64)
#define REG_SC_BKC8_65_L      _PK_L_(0xC8, 0x65)
#define REG_SC_BKC8_65_H      _PK_H_(0xC8, 0x65)
#define REG_SC_BKC8_66_L      _PK_L_(0xC8, 0x66)
#define REG_SC_BKC8_66_H      _PK_H_(0xC8, 0x66)
#define REG_SC_BKC8_67_L      _PK_L_(0xC8, 0x67)
#define REG_SC_BKC8_67_H      _PK_H_(0xC8, 0x67)
#define REG_SC_BKC8_68_L      _PK_L_(0xC8, 0x68)
#define REG_SC_BKC8_68_H      _PK_H_(0xC8, 0x68)
#define REG_SC_BKC8_69_L      _PK_L_(0xC8, 0x69)
#define REG_SC_BKC8_69_H      _PK_H_(0xC8, 0x69)
#define REG_SC_BKC8_6A_L      _PK_L_(0xC8, 0x6A)
#define REG_SC_BKC8_6A_H      _PK_H_(0xC8, 0x6A)
#define REG_SC_BKC8_6B_L      _PK_L_(0xC8, 0x6B)
#define REG_SC_BKC8_6B_H      _PK_H_(0xC8, 0x6B)
#define REG_SC_BKC8_6C_L      _PK_L_(0xC8, 0x6C)
#define REG_SC_BKC8_6C_H      _PK_H_(0xC8, 0x6C)
#define REG_SC_BKC8_6D_L      _PK_L_(0xC8, 0x6D)
#define REG_SC_BKC8_6D_H      _PK_H_(0xC8, 0x6D)
#define REG_SC_BKC8_6E_L      _PK_L_(0xC8, 0x6E)
#define REG_SC_BKC8_6E_H      _PK_H_(0xC8, 0x6E)
#define REG_SC_BKC8_6F_L      _PK_L_(0xC8, 0x6F)
#define REG_SC_BKC8_6F_H      _PK_H_(0xC8, 0x6F)
#define REG_SC_BKC8_70_L      _PK_L_(0xC8, 0x70)
#define REG_SC_BKC8_70_H      _PK_H_(0xC8, 0x70)
#define REG_SC_BKC8_71_L      _PK_L_(0xC8, 0x71)
#define REG_SC_BKC8_71_H      _PK_H_(0xC8, 0x71)
#define REG_SC_BKC8_72_L      _PK_L_(0xC8, 0x72)
#define REG_SC_BKC8_72_H      _PK_H_(0xC8, 0x72)
#define REG_SC_BKC8_73_L      _PK_L_(0xC8, 0x73)
#define REG_SC_BKC8_73_H      _PK_H_(0xC8, 0x73)
#define REG_SC_BKC8_74_L      _PK_L_(0xC8, 0x74)
#define REG_SC_BKC8_74_H      _PK_H_(0xC8, 0x74)
#define REG_SC_BKC8_75_L      _PK_L_(0xC8, 0x75)
#define REG_SC_BKC8_75_H      _PK_H_(0xC8, 0x75)
#define REG_SC_BKC8_76_L      _PK_L_(0xC8, 0x76)
#define REG_SC_BKC8_76_H      _PK_H_(0xC8, 0x76)
#define REG_SC_BKC8_77_L      _PK_L_(0xC8, 0x77)
#define REG_SC_BKC8_77_H      _PK_H_(0xC8, 0x77)
#define REG_SC_BKC8_78_L      _PK_L_(0xC8, 0x78)
#define REG_SC_BKC8_78_H      _PK_H_(0xC8, 0x78)
#define REG_SC_BKC8_79_L      _PK_L_(0xC8, 0x79)
#define REG_SC_BKC8_79_H      _PK_H_(0xC8, 0x79)
#define REG_SC_BKC8_7A_L      _PK_L_(0xC8, 0x7A)
#define REG_SC_BKC8_7A_H      _PK_H_(0xC8, 0x7A)
#define REG_SC_BKC8_7B_L      _PK_L_(0xC8, 0x7B)
#define REG_SC_BKC8_7B_H      _PK_H_(0xC8, 0x7B)
#define REG_SC_BKC8_7C_L      _PK_L_(0xC8, 0x7C)
#define REG_SC_BKC8_7C_H      _PK_H_(0xC8, 0x7C)
#define REG_SC_BKC8_7D_L      _PK_L_(0xC8, 0x7D)
#define REG_SC_BKC8_7D_H      _PK_H_(0xC8, 0x7D)
#define REG_SC_BKC8_7E_L      _PK_L_(0xC8, 0x7E)
#define REG_SC_BKC8_7E_H      _PK_H_(0xC8, 0x7E)
#define REG_SC_BKC8_7F_L      _PK_L_(0xC8, 0x7F)
#define REG_SC_BKC8_7F_H      _PK_H_(0xC8, 0x7F)

//----------------------------------------------
//  BKC9
//----------------------------------------------
#define REG_SC_BKC9_00_L      _PK_L_(0xC9, 0x00)
#define REG_SC_BKC9_00_H      _PK_H_(0xC9, 0x00)
#define REG_SC_BKC9_01_L      _PK_L_(0xC9, 0x01)
#define REG_SC_BKC9_01_H      _PK_H_(0xC9, 0x01)
#define REG_SC_BKC9_02_L      _PK_L_(0xC9, 0x02)
#define REG_SC_BKC9_02_H      _PK_H_(0xC9, 0x02)
#define REG_SC_BKC9_03_L      _PK_L_(0xC9, 0x03)
#define REG_SC_BKC9_03_H      _PK_H_(0xC9, 0x03)
#define REG_SC_BKC9_04_L      _PK_L_(0xC9, 0x04)
#define REG_SC_BKC9_04_H      _PK_H_(0xC9, 0x04)
#define REG_SC_BKC9_05_L      _PK_L_(0xC9, 0x05)
#define REG_SC_BKC9_05_H      _PK_H_(0xC9, 0x05)
#define REG_SC_BKC9_06_L      _PK_L_(0xC9, 0x06)
#define REG_SC_BKC9_06_H      _PK_H_(0xC9, 0x06)
#define REG_SC_BKC9_07_L      _PK_L_(0xC9, 0x07)
#define REG_SC_BKC9_07_H      _PK_H_(0xC9, 0x07)
#define REG_SC_BKC9_08_L      _PK_L_(0xC9, 0x08)
#define REG_SC_BKC9_08_H      _PK_H_(0xC9, 0x08)
#define REG_SC_BKC9_09_L      _PK_L_(0xC9, 0x09)
#define REG_SC_BKC9_09_H      _PK_H_(0xC9, 0x09)
#define REG_SC_BKC9_0A_L      _PK_L_(0xC9, 0x0A)
#define REG_SC_BKC9_0A_H      _PK_H_(0xC9, 0x0A)
#define REG_SC_BKC9_0B_L      _PK_L_(0xC9, 0x0B)
#define REG_SC_BKC9_0B_H      _PK_H_(0xC9, 0x0B)
#define REG_SC_BKC9_0C_L      _PK_L_(0xC9, 0x0C)
#define REG_SC_BKC9_0C_H      _PK_H_(0xC9, 0x0C)
#define REG_SC_BKC9_0D_L      _PK_L_(0xC9, 0x0D)
#define REG_SC_BKC9_0D_H      _PK_H_(0xC9, 0x0D)
#define REG_SC_BKC9_0E_L      _PK_L_(0xC9, 0x0E)
#define REG_SC_BKC9_0E_H      _PK_H_(0xC9, 0x0E)
#define REG_SC_BKC9_0F_L      _PK_L_(0xC9, 0x0F)
#define REG_SC_BKC9_0F_H      _PK_H_(0xC9, 0x0F)
#define REG_SC_BKC9_10_L      _PK_L_(0xC9, 0x10)
#define REG_SC_BKC9_10_H      _PK_H_(0xC9, 0x10)
#define REG_SC_BKC9_11_L      _PK_L_(0xC9, 0x11)
#define REG_SC_BKC9_11_H      _PK_H_(0xC9, 0x11)
#define REG_SC_BKC9_12_L      _PK_L_(0xC9, 0x12)
#define REG_SC_BKC9_12_H      _PK_H_(0xC9, 0x12)
#define REG_SC_BKC9_13_L      _PK_L_(0xC9, 0x13)
#define REG_SC_BKC9_13_H      _PK_H_(0xC9, 0x13)
#define REG_SC_BKC9_14_L      _PK_L_(0xC9, 0x14)
#define REG_SC_BKC9_14_H      _PK_H_(0xC9, 0x14)
#define REG_SC_BKC9_15_L      _PK_L_(0xC9, 0x15)
#define REG_SC_BKC9_15_H      _PK_H_(0xC9, 0x15)
#define REG_SC_BKC9_16_L      _PK_L_(0xC9, 0x16)
#define REG_SC_BKC9_16_H      _PK_H_(0xC9, 0x16)
#define REG_SC_BKC9_17_L      _PK_L_(0xC9, 0x17)
#define REG_SC_BKC9_17_H      _PK_H_(0xC9, 0x17)
#define REG_SC_BKC9_18_L      _PK_L_(0xC9, 0x18)
#define REG_SC_BKC9_18_H      _PK_H_(0xC9, 0x18)
#define REG_SC_BKC9_19_L      _PK_L_(0xC9, 0x19)
#define REG_SC_BKC9_19_H      _PK_H_(0xC9, 0x19)
#define REG_SC_BKC9_1A_L      _PK_L_(0xC9, 0x1A)
#define REG_SC_BKC9_1A_H      _PK_H_(0xC9, 0x1A)
#define REG_SC_BKC9_1B_L      _PK_L_(0xC9, 0x1B)
#define REG_SC_BKC9_1B_H      _PK_H_(0xC9, 0x1B)
#define REG_SC_BKC9_1C_L      _PK_L_(0xC9, 0x1C)
#define REG_SC_BKC9_1C_H      _PK_H_(0xC9, 0x1C)
#define REG_SC_BKC9_1D_L      _PK_L_(0xC9, 0x1D)
#define REG_SC_BKC9_1D_H      _PK_H_(0xC9, 0x1D)
#define REG_SC_BKC9_1E_L      _PK_L_(0xC9, 0x1E)
#define REG_SC_BKC9_1E_H      _PK_H_(0xC9, 0x1E)
#define REG_SC_BKC9_1F_L      _PK_L_(0xC9, 0x1F)
#define REG_SC_BKC9_1F_H      _PK_H_(0xC9, 0x1F)
#define REG_SC_BKC9_20_L      _PK_L_(0xC9, 0x20)
#define REG_SC_BKC9_20_H      _PK_H_(0xC9, 0x20)
#define REG_SC_BKC9_21_L      _PK_L_(0xC9, 0x21)
#define REG_SC_BKC9_21_H      _PK_H_(0xC9, 0x21)
#define REG_SC_BKC9_22_L      _PK_L_(0xC9, 0x22)
#define REG_SC_BKC9_22_H      _PK_H_(0xC9, 0x22)
#define REG_SC_BKC9_23_L      _PK_L_(0xC9, 0x23)
#define REG_SC_BKC9_23_H      _PK_H_(0xC9, 0x23)
#define REG_SC_BKC9_24_L      _PK_L_(0xC9, 0x24)
#define REG_SC_BKC9_24_H      _PK_H_(0xC9, 0x24)
#define REG_SC_BKC9_25_L      _PK_L_(0xC9, 0x25)
#define REG_SC_BKC9_25_H      _PK_H_(0xC9, 0x25)
#define REG_SC_BKC9_26_L      _PK_L_(0xC9, 0x26)
#define REG_SC_BKC9_26_H      _PK_H_(0xC9, 0x26)
#define REG_SC_BKC9_27_L      _PK_L_(0xC9, 0x27)
#define REG_SC_BKC9_27_H      _PK_H_(0xC9, 0x27)
#define REG_SC_BKC9_28_L      _PK_L_(0xC9, 0x28)
#define REG_SC_BKC9_28_H      _PK_H_(0xC9, 0x28)
#define REG_SC_BKC9_29_L      _PK_L_(0xC9, 0x29)
#define REG_SC_BKC9_29_H      _PK_H_(0xC9, 0x29)
#define REG_SC_BKC9_2A_L      _PK_L_(0xC9, 0x2A)
#define REG_SC_BKC9_2A_H      _PK_H_(0xC9, 0x2A)
#define REG_SC_BKC9_2B_L      _PK_L_(0xC9, 0x2B)
#define REG_SC_BKC9_2B_H      _PK_H_(0xC9, 0x2B)
#define REG_SC_BKC9_2C_L      _PK_L_(0xC9, 0x2C)
#define REG_SC_BKC9_2C_H      _PK_H_(0xC9, 0x2C)
#define REG_SC_BKC9_2D_L      _PK_L_(0xC9, 0x2D)
#define REG_SC_BKC9_2D_H      _PK_H_(0xC9, 0x2D)
#define REG_SC_BKC9_2E_L      _PK_L_(0xC9, 0x2E)
#define REG_SC_BKC9_2E_H      _PK_H_(0xC9, 0x2E)
#define REG_SC_BKC9_2F_L      _PK_L_(0xC9, 0x2F)
#define REG_SC_BKC9_2F_H      _PK_H_(0xC9, 0x2F)
#define REG_SC_BKC9_30_L      _PK_L_(0xC9, 0x30)
#define REG_SC_BKC9_30_H      _PK_H_(0xC9, 0x30)
#define REG_SC_BKC9_31_L      _PK_L_(0xC9, 0x31)
#define REG_SC_BKC9_31_H      _PK_H_(0xC9, 0x31)
#define REG_SC_BKC9_32_L      _PK_L_(0xC9, 0x32)
#define REG_SC_BKC9_32_H      _PK_H_(0xC9, 0x32)
#define REG_SC_BKC9_33_L      _PK_L_(0xC9, 0x33)
#define REG_SC_BKC9_33_H      _PK_H_(0xC9, 0x33)
#define REG_SC_BKC9_34_L      _PK_L_(0xC9, 0x34)
#define REG_SC_BKC9_34_H      _PK_H_(0xC9, 0x34)
#define REG_SC_BKC9_35_L      _PK_L_(0xC9, 0x35)
#define REG_SC_BKC9_35_H      _PK_H_(0xC9, 0x35)
#define REG_SC_BKC9_36_L      _PK_L_(0xC9, 0x36)
#define REG_SC_BKC9_36_H      _PK_H_(0xC9, 0x36)
#define REG_SC_BKC9_37_L      _PK_L_(0xC9, 0x37)
#define REG_SC_BKC9_37_H      _PK_H_(0xC9, 0x37)
#define REG_SC_BKC9_38_L      _PK_L_(0xC9, 0x38)
#define REG_SC_BKC9_38_H      _PK_H_(0xC9, 0x38)
#define REG_SC_BKC9_39_L      _PK_L_(0xC9, 0x39)
#define REG_SC_BKC9_39_H      _PK_H_(0xC9, 0x39)
#define REG_SC_BKC9_3A_L      _PK_L_(0xC9, 0x3A)
#define REG_SC_BKC9_3A_H      _PK_H_(0xC9, 0x3A)
#define REG_SC_BKC9_3B_L      _PK_L_(0xC9, 0x3B)
#define REG_SC_BKC9_3B_H      _PK_H_(0xC9, 0x3B)
#define REG_SC_BKC9_3C_L      _PK_L_(0xC9, 0x3C)
#define REG_SC_BKC9_3C_H      _PK_H_(0xC9, 0x3C)
#define REG_SC_BKC9_3D_L      _PK_L_(0xC9, 0x3D)
#define REG_SC_BKC9_3D_H      _PK_H_(0xC9, 0x3D)
#define REG_SC_BKC9_3E_L      _PK_L_(0xC9, 0x3E)
#define REG_SC_BKC9_3E_H      _PK_H_(0xC9, 0x3E)
#define REG_SC_BKC9_3F_L      _PK_L_(0xC9, 0x3F)
#define REG_SC_BKC9_3F_H      _PK_H_(0xC9, 0x3F)
#define REG_SC_BKC9_40_L      _PK_L_(0xC9, 0x40)
#define REG_SC_BKC9_40_H      _PK_H_(0xC9, 0x40)
#define REG_SC_BKC9_41_L      _PK_L_(0xC9, 0x41)
#define REG_SC_BKC9_41_H      _PK_H_(0xC9, 0x41)
#define REG_SC_BKC9_42_L      _PK_L_(0xC9, 0x42)
#define REG_SC_BKC9_42_H      _PK_H_(0xC9, 0x42)
#define REG_SC_BKC9_43_L      _PK_L_(0xC9, 0x43)
#define REG_SC_BKC9_43_H      _PK_H_(0xC9, 0x43)
#define REG_SC_BKC9_44_L      _PK_L_(0xC9, 0x44)
#define REG_SC_BKC9_44_H      _PK_H_(0xC9, 0x44)
#define REG_SC_BKC9_45_L      _PK_L_(0xC9, 0x45)
#define REG_SC_BKC9_45_H      _PK_H_(0xC9, 0x45)
#define REG_SC_BKC9_46_L      _PK_L_(0xC9, 0x46)
#define REG_SC_BKC9_46_H      _PK_H_(0xC9, 0x46)
#define REG_SC_BKC9_47_L      _PK_L_(0xC9, 0x47)
#define REG_SC_BKC9_47_H      _PK_H_(0xC9, 0x47)
#define REG_SC_BKC9_48_L      _PK_L_(0xC9, 0x48)
#define REG_SC_BKC9_48_H      _PK_H_(0xC9, 0x48)
#define REG_SC_BKC9_49_L      _PK_L_(0xC9, 0x49)
#define REG_SC_BKC9_49_H      _PK_H_(0xC9, 0x49)
#define REG_SC_BKC9_4A_L      _PK_L_(0xC9, 0x4A)
#define REG_SC_BKC9_4A_H      _PK_H_(0xC9, 0x4A)
#define REG_SC_BKC9_4B_L      _PK_L_(0xC9, 0x4B)
#define REG_SC_BKC9_4B_H      _PK_H_(0xC9, 0x4B)
#define REG_SC_BKC9_4C_L      _PK_L_(0xC9, 0x4C)
#define REG_SC_BKC9_4C_H      _PK_H_(0xC9, 0x4C)
#define REG_SC_BKC9_4D_L      _PK_L_(0xC9, 0x4D)
#define REG_SC_BKC9_4D_H      _PK_H_(0xC9, 0x4D)
#define REG_SC_BKC9_4E_L      _PK_L_(0xC9, 0x4E)
#define REG_SC_BKC9_4E_H      _PK_H_(0xC9, 0x4E)
#define REG_SC_BKC9_4F_L      _PK_L_(0xC9, 0x4F)
#define REG_SC_BKC9_4F_H      _PK_H_(0xC9, 0x4F)
#define REG_SC_BKC9_50_L      _PK_L_(0xC9, 0x50)
#define REG_SC_BKC9_50_H      _PK_H_(0xC9, 0x50)
#define REG_SC_BKC9_51_L      _PK_L_(0xC9, 0x51)
#define REG_SC_BKC9_51_H      _PK_H_(0xC9, 0x51)
#define REG_SC_BKC9_52_L      _PK_L_(0xC9, 0x52)
#define REG_SC_BKC9_52_H      _PK_H_(0xC9, 0x52)
#define REG_SC_BKC9_53_L      _PK_L_(0xC9, 0x53)
#define REG_SC_BKC9_53_H      _PK_H_(0xC9, 0x53)
#define REG_SC_BKC9_54_L      _PK_L_(0xC9, 0x54)
#define REG_SC_BKC9_54_H      _PK_H_(0xC9, 0x54)
#define REG_SC_BKC9_55_L      _PK_L_(0xC9, 0x55)
#define REG_SC_BKC9_55_H      _PK_H_(0xC9, 0x55)
#define REG_SC_BKC9_56_L      _PK_L_(0xC9, 0x56)
#define REG_SC_BKC9_56_H      _PK_H_(0xC9, 0x56)
#define REG_SC_BKC9_57_L      _PK_L_(0xC9, 0x57)
#define REG_SC_BKC9_57_H      _PK_H_(0xC9, 0x57)
#define REG_SC_BKC9_58_L      _PK_L_(0xC9, 0x58)
#define REG_SC_BKC9_58_H      _PK_H_(0xC9, 0x58)
#define REG_SC_BKC9_59_L      _PK_L_(0xC9, 0x59)
#define REG_SC_BKC9_59_H      _PK_H_(0xC9, 0x59)
#define REG_SC_BKC9_5A_L      _PK_L_(0xC9, 0x5A)
#define REG_SC_BKC9_5A_H      _PK_H_(0xC9, 0x5A)
#define REG_SC_BKC9_5B_L      _PK_L_(0xC9, 0x5B)
#define REG_SC_BKC9_5B_H      _PK_H_(0xC9, 0x5B)
#define REG_SC_BKC9_5C_L      _PK_L_(0xC9, 0x5C)
#define REG_SC_BKC9_5C_H      _PK_H_(0xC9, 0x5C)
#define REG_SC_BKC9_5D_L      _PK_L_(0xC9, 0x5D)
#define REG_SC_BKC9_5D_H      _PK_H_(0xC9, 0x5D)
#define REG_SC_BKC9_5E_L      _PK_L_(0xC9, 0x5E)
#define REG_SC_BKC9_5E_H      _PK_H_(0xC9, 0x5E)
#define REG_SC_BKC9_5F_L      _PK_L_(0xC9, 0x5F)
#define REG_SC_BKC9_5F_H      _PK_H_(0xC9, 0x5F)
#define REG_SC_BKC9_60_L      _PK_L_(0xC9, 0x60)
#define REG_SC_BKC9_60_H      _PK_H_(0xC9, 0x60)
#define REG_SC_BKC9_61_L      _PK_L_(0xC9, 0x61)
#define REG_SC_BKC9_61_H      _PK_H_(0xC9, 0x61)
#define REG_SC_BKC9_62_L      _PK_L_(0xC9, 0x62)
#define REG_SC_BKC9_62_H      _PK_H_(0xC9, 0x62)
#define REG_SC_BKC9_63_L      _PK_L_(0xC9, 0x63)
#define REG_SC_BKC9_63_H      _PK_H_(0xC9, 0x63)
#define REG_SC_BKC9_64_L      _PK_L_(0xC9, 0x64)
#define REG_SC_BKC9_64_H      _PK_H_(0xC9, 0x64)
#define REG_SC_BKC9_65_L      _PK_L_(0xC9, 0x65)
#define REG_SC_BKC9_65_H      _PK_H_(0xC9, 0x65)
#define REG_SC_BKC9_66_L      _PK_L_(0xC9, 0x66)
#define REG_SC_BKC9_66_H      _PK_H_(0xC9, 0x66)
#define REG_SC_BKC9_67_L      _PK_L_(0xC9, 0x67)
#define REG_SC_BKC9_67_H      _PK_H_(0xC9, 0x67)
#define REG_SC_BKC9_68_L      _PK_L_(0xC9, 0x68)
#define REG_SC_BKC9_68_H      _PK_H_(0xC9, 0x68)
#define REG_SC_BKC9_69_L      _PK_L_(0xC9, 0x69)
#define REG_SC_BKC9_69_H      _PK_H_(0xC9, 0x69)
#define REG_SC_BKC9_6A_L      _PK_L_(0xC9, 0x6A)
#define REG_SC_BKC9_6A_H      _PK_H_(0xC9, 0x6A)
#define REG_SC_BKC9_6B_L      _PK_L_(0xC9, 0x6B)
#define REG_SC_BKC9_6B_H      _PK_H_(0xC9, 0x6B)
#define REG_SC_BKC9_6C_L      _PK_L_(0xC9, 0x6C)
#define REG_SC_BKC9_6C_H      _PK_H_(0xC9, 0x6C)
#define REG_SC_BKC9_6D_L      _PK_L_(0xC9, 0x6D)
#define REG_SC_BKC9_6D_H      _PK_H_(0xC9, 0x6D)
#define REG_SC_BKC9_6E_L      _PK_L_(0xC9, 0x6E)
#define REG_SC_BKC9_6E_H      _PK_H_(0xC9, 0x6E)
#define REG_SC_BKC9_6F_L      _PK_L_(0xC9, 0x6F)
#define REG_SC_BKC9_6F_H      _PK_H_(0xC9, 0x6F)
#define REG_SC_BKC9_70_L      _PK_L_(0xC9, 0x70)
#define REG_SC_BKC9_70_H      _PK_H_(0xC9, 0x70)
#define REG_SC_BKC9_71_L      _PK_L_(0xC9, 0x71)
#define REG_SC_BKC9_71_H      _PK_H_(0xC9, 0x71)
#define REG_SC_BKC9_72_L      _PK_L_(0xC9, 0x72)
#define REG_SC_BKC9_72_H      _PK_H_(0xC9, 0x72)
#define REG_SC_BKC9_73_L      _PK_L_(0xC9, 0x73)
#define REG_SC_BKC9_73_H      _PK_H_(0xC9, 0x73)
#define REG_SC_BKC9_74_L      _PK_L_(0xC9, 0x74)
#define REG_SC_BKC9_74_H      _PK_H_(0xC9, 0x74)
#define REG_SC_BKC9_75_L      _PK_L_(0xC9, 0x75)
#define REG_SC_BKC9_75_H      _PK_H_(0xC9, 0x75)
#define REG_SC_BKC9_76_L      _PK_L_(0xC9, 0x76)
#define REG_SC_BKC9_76_H      _PK_H_(0xC9, 0x76)
#define REG_SC_BKC9_77_L      _PK_L_(0xC9, 0x77)
#define REG_SC_BKC9_77_H      _PK_H_(0xC9, 0x77)
#define REG_SC_BKC9_78_L      _PK_L_(0xC9, 0x78)
#define REG_SC_BKC9_78_H      _PK_H_(0xC9, 0x78)
#define REG_SC_BKC9_79_L      _PK_L_(0xC9, 0x79)
#define REG_SC_BKC9_79_H      _PK_H_(0xC9, 0x79)
#define REG_SC_BKC9_7A_L      _PK_L_(0xC9, 0x7A)
#define REG_SC_BKC9_7A_H      _PK_H_(0xC9, 0x7A)
#define REG_SC_BKC9_7B_L      _PK_L_(0xC9, 0x7B)
#define REG_SC_BKC9_7B_H      _PK_H_(0xC9, 0x7B)
#define REG_SC_BKC9_7C_L      _PK_L_(0xC9, 0x7C)
#define REG_SC_BKC9_7C_H      _PK_H_(0xC9, 0x7C)
#define REG_SC_BKC9_7D_L      _PK_L_(0xC9, 0x7D)
#define REG_SC_BKC9_7D_H      _PK_H_(0xC9, 0x7D)
#define REG_SC_BKC9_7E_L      _PK_L_(0xC9, 0x7E)
#define REG_SC_BKC9_7E_H      _PK_H_(0xC9, 0x7E)
#define REG_SC_BKC9_7F_L      _PK_L_(0xC9, 0x7F)
#define REG_SC_BKC9_7F_H      _PK_H_(0xC9, 0x7F)

//----------------------------------------------
//  BKCA
//----------------------------------------------
#define REG_SC_BKCA_00_L      _PK_L_(0xCA, 0x00)
#define REG_SC_BKCA_00_H      _PK_H_(0xCA, 0x00)
#define REG_SC_BKCA_01_L      _PK_L_(0xCA, 0x01)
#define REG_SC_BKCA_01_H      _PK_H_(0xCA, 0x01)
#define REG_SC_BKCA_02_L      _PK_L_(0xCA, 0x02)
#define REG_SC_BKCA_02_H      _PK_H_(0xCA, 0x02)
#define REG_SC_BKCA_03_L      _PK_L_(0xCA, 0x03)
#define REG_SC_BKCA_03_H      _PK_H_(0xCA, 0x03)
#define REG_SC_BKCA_04_L      _PK_L_(0xCA, 0x04)
#define REG_SC_BKCA_04_H      _PK_H_(0xCA, 0x04)
#define REG_SC_BKCA_05_L      _PK_L_(0xCA, 0x05)
#define REG_SC_BKCA_05_H      _PK_H_(0xCA, 0x05)
#define REG_SC_BKCA_06_L      _PK_L_(0xCA, 0x06)
#define REG_SC_BKCA_06_H      _PK_H_(0xCA, 0x06)
#define REG_SC_BKCA_07_L      _PK_L_(0xCA, 0x07)
#define REG_SC_BKCA_07_H      _PK_H_(0xCA, 0x07)
#define REG_SC_BKCA_08_L      _PK_L_(0xCA, 0x08)
#define REG_SC_BKCA_08_H      _PK_H_(0xCA, 0x08)
#define REG_SC_BKCA_09_L      _PK_L_(0xCA, 0x09)
#define REG_SC_BKCA_09_H      _PK_H_(0xCA, 0x09)
#define REG_SC_BKCA_0A_L      _PK_L_(0xCA, 0x0A)
#define REG_SC_BKCA_0A_H      _PK_H_(0xCA, 0x0A)
#define REG_SC_BKCA_0B_L      _PK_L_(0xCA, 0x0B)
#define REG_SC_BKCA_0B_H      _PK_H_(0xCA, 0x0B)
#define REG_SC_BKCA_0C_L      _PK_L_(0xCA, 0x0C)
#define REG_SC_BKCA_0C_H      _PK_H_(0xCA, 0x0C)
#define REG_SC_BKCA_0D_L      _PK_L_(0xCA, 0x0D)
#define REG_SC_BKCA_0D_H      _PK_H_(0xCA, 0x0D)
#define REG_SC_BKCA_0E_L      _PK_L_(0xCA, 0x0E)
#define REG_SC_BKCA_0E_H      _PK_H_(0xCA, 0x0E)
#define REG_SC_BKCA_0F_L      _PK_L_(0xCA, 0x0F)
#define REG_SC_BKCA_0F_H      _PK_H_(0xCA, 0x0F)
#define REG_SC_BKCA_10_L      _PK_L_(0xCA, 0x10)
#define REG_SC_BKCA_10_H      _PK_H_(0xCA, 0x10)
#define REG_SC_BKCA_11_L      _PK_L_(0xCA, 0x11)
#define REG_SC_BKCA_11_H      _PK_H_(0xCA, 0x11)
#define REG_SC_BKCA_12_L      _PK_L_(0xCA, 0x12)
#define REG_SC_BKCA_12_H      _PK_H_(0xCA, 0x12)
#define REG_SC_BKCA_13_L      _PK_L_(0xCA, 0x13)
#define REG_SC_BKCA_13_H      _PK_H_(0xCA, 0x13)
#define REG_SC_BKCA_14_L      _PK_L_(0xCA, 0x14)
#define REG_SC_BKCA_14_H      _PK_H_(0xCA, 0x14)
#define REG_SC_BKCA_15_L      _PK_L_(0xCA, 0x15)
#define REG_SC_BKCA_15_H      _PK_H_(0xCA, 0x15)
#define REG_SC_BKCA_16_L      _PK_L_(0xCA, 0x16)
#define REG_SC_BKCA_16_H      _PK_H_(0xCA, 0x16)
#define REG_SC_BKCA_17_L      _PK_L_(0xCA, 0x17)
#define REG_SC_BKCA_17_H      _PK_H_(0xCA, 0x17)
#define REG_SC_BKCA_18_L      _PK_L_(0xCA, 0x18)
#define REG_SC_BKCA_18_H      _PK_H_(0xCA, 0x18)
#define REG_SC_BKCA_19_L      _PK_L_(0xCA, 0x19)
#define REG_SC_BKCA_19_H      _PK_H_(0xCA, 0x19)
#define REG_SC_BKCA_1A_L      _PK_L_(0xCA, 0x1A)
#define REG_SC_BKCA_1A_H      _PK_H_(0xCA, 0x1A)
#define REG_SC_BKCA_1B_L      _PK_L_(0xCA, 0x1B)
#define REG_SC_BKCA_1B_H      _PK_H_(0xCA, 0x1B)
#define REG_SC_BKCA_1C_L      _PK_L_(0xCA, 0x1C)
#define REG_SC_BKCA_1C_H      _PK_H_(0xCA, 0x1C)
#define REG_SC_BKCA_1D_L      _PK_L_(0xCA, 0x1D)
#define REG_SC_BKCA_1D_H      _PK_H_(0xCA, 0x1D)
#define REG_SC_BKCA_1E_L      _PK_L_(0xCA, 0x1E)
#define REG_SC_BKCA_1E_H      _PK_H_(0xCA, 0x1E)
#define REG_SC_BKCA_1F_L      _PK_L_(0xCA, 0x1F)
#define REG_SC_BKCA_1F_H      _PK_H_(0xCA, 0x1F)
#define REG_SC_BKCA_20_L      _PK_L_(0xCA, 0x20)
#define REG_SC_BKCA_20_H      _PK_H_(0xCA, 0x20)
#define REG_SC_BKCA_21_L      _PK_L_(0xCA, 0x21)
#define REG_SC_BKCA_21_H      _PK_H_(0xCA, 0x21)
#define REG_SC_BKCA_22_L      _PK_L_(0xCA, 0x22)
#define REG_SC_BKCA_22_H      _PK_H_(0xCA, 0x22)
#define REG_SC_BKCA_23_L      _PK_L_(0xCA, 0x23)
#define REG_SC_BKCA_23_H      _PK_H_(0xCA, 0x23)
#define REG_SC_BKCA_24_L      _PK_L_(0xCA, 0x24)
#define REG_SC_BKCA_24_H      _PK_H_(0xCA, 0x24)
#define REG_SC_BKCA_25_L      _PK_L_(0xCA, 0x25)
#define REG_SC_BKCA_25_H      _PK_H_(0xCA, 0x25)
#define REG_SC_BKCA_26_L      _PK_L_(0xCA, 0x26)
#define REG_SC_BKCA_26_H      _PK_H_(0xCA, 0x26)
#define REG_SC_BKCA_27_L      _PK_L_(0xCA, 0x27)
#define REG_SC_BKCA_27_H      _PK_H_(0xCA, 0x27)
#define REG_SC_BKCA_28_L      _PK_L_(0xCA, 0x28)
#define REG_SC_BKCA_28_H      _PK_H_(0xCA, 0x28)
#define REG_SC_BKCA_29_L      _PK_L_(0xCA, 0x29)
#define REG_SC_BKCA_29_H      _PK_H_(0xCA, 0x29)
#define REG_SC_BKCA_2A_L      _PK_L_(0xCA, 0x2A)
#define REG_SC_BKCA_2A_H      _PK_H_(0xCA, 0x2A)
#define REG_SC_BKCA_2B_L      _PK_L_(0xCA, 0x2B)
#define REG_SC_BKCA_2B_H      _PK_H_(0xCA, 0x2B)
#define REG_SC_BKCA_2C_L      _PK_L_(0xCA, 0x2C)
#define REG_SC_BKCA_2C_H      _PK_H_(0xCA, 0x2C)
#define REG_SC_BKCA_2D_L      _PK_L_(0xCA, 0x2D)
#define REG_SC_BKCA_2D_H      _PK_H_(0xCA, 0x2D)
#define REG_SC_BKCA_2E_L      _PK_L_(0xCA, 0x2E)
#define REG_SC_BKCA_2E_H      _PK_H_(0xCA, 0x2E)
#define REG_SC_BKCA_2F_L      _PK_L_(0xCA, 0x2F)
#define REG_SC_BKCA_2F_H      _PK_H_(0xCA, 0x2F)
#define REG_SC_BKCA_30_L      _PK_L_(0xCA, 0x30)
#define REG_SC_BKCA_30_H      _PK_H_(0xCA, 0x30)
#define REG_SC_BKCA_31_L      _PK_L_(0xCA, 0x31)
#define REG_SC_BKCA_31_H      _PK_H_(0xCA, 0x31)
#define REG_SC_BKCA_32_L      _PK_L_(0xCA, 0x32)
#define REG_SC_BKCA_32_H      _PK_H_(0xCA, 0x32)
#define REG_SC_BKCA_33_L      _PK_L_(0xCA, 0x33)
#define REG_SC_BKCA_33_H      _PK_H_(0xCA, 0x33)
#define REG_SC_BKCA_34_L      _PK_L_(0xCA, 0x34)
#define REG_SC_BKCA_34_H      _PK_H_(0xCA, 0x34)
#define REG_SC_BKCA_35_L      _PK_L_(0xCA, 0x35)
#define REG_SC_BKCA_35_H      _PK_H_(0xCA, 0x35)
#define REG_SC_BKCA_36_L      _PK_L_(0xCA, 0x36)
#define REG_SC_BKCA_36_H      _PK_H_(0xCA, 0x36)
#define REG_SC_BKCA_37_L      _PK_L_(0xCA, 0x37)
#define REG_SC_BKCA_37_H      _PK_H_(0xCA, 0x37)
#define REG_SC_BKCA_38_L      _PK_L_(0xCA, 0x38)
#define REG_SC_BKCA_38_H      _PK_H_(0xCA, 0x38)
#define REG_SC_BKCA_39_L      _PK_L_(0xCA, 0x39)
#define REG_SC_BKCA_39_H      _PK_H_(0xCA, 0x39)
#define REG_SC_BKCA_3A_L      _PK_L_(0xCA, 0x3A)
#define REG_SC_BKCA_3A_H      _PK_H_(0xCA, 0x3A)
#define REG_SC_BKCA_3B_L      _PK_L_(0xCA, 0x3B)
#define REG_SC_BKCA_3B_H      _PK_H_(0xCA, 0x3B)
#define REG_SC_BKCA_3C_L      _PK_L_(0xCA, 0x3C)
#define REG_SC_BKCA_3C_H      _PK_H_(0xCA, 0x3C)
#define REG_SC_BKCA_3D_L      _PK_L_(0xCA, 0x3D)
#define REG_SC_BKCA_3D_H      _PK_H_(0xCA, 0x3D)
#define REG_SC_BKCA_3E_L      _PK_L_(0xCA, 0x3E)
#define REG_SC_BKCA_3E_H      _PK_H_(0xCA, 0x3E)
#define REG_SC_BKCA_3F_L      _PK_L_(0xCA, 0x3F)
#define REG_SC_BKCA_3F_H      _PK_H_(0xCA, 0x3F)
#define REG_SC_BKCA_40_L      _PK_L_(0xCA, 0x40)
#define REG_SC_BKCA_40_H      _PK_H_(0xCA, 0x40)
#define REG_SC_BKCA_41_L      _PK_L_(0xCA, 0x41)
#define REG_SC_BKCA_41_H      _PK_H_(0xCA, 0x41)
#define REG_SC_BKCA_42_L      _PK_L_(0xCA, 0x42)
#define REG_SC_BKCA_42_H      _PK_H_(0xCA, 0x42)
#define REG_SC_BKCA_43_L      _PK_L_(0xCA, 0x43)
#define REG_SC_BKCA_43_H      _PK_H_(0xCA, 0x43)
#define REG_SC_BKCA_44_L      _PK_L_(0xCA, 0x44)
#define REG_SC_BKCA_44_H      _PK_H_(0xCA, 0x44)
#define REG_SC_BKCA_45_L      _PK_L_(0xCA, 0x45)
#define REG_SC_BKCA_45_H      _PK_H_(0xCA, 0x45)
#define REG_SC_BKCA_46_L      _PK_L_(0xCA, 0x46)
#define REG_SC_BKCA_46_H      _PK_H_(0xCA, 0x46)
#define REG_SC_BKCA_47_L      _PK_L_(0xCA, 0x47)
#define REG_SC_BKCA_47_H      _PK_H_(0xCA, 0x47)
#define REG_SC_BKCA_48_L      _PK_L_(0xCA, 0x48)
#define REG_SC_BKCA_48_H      _PK_H_(0xCA, 0x48)
#define REG_SC_BKCA_49_L      _PK_L_(0xCA, 0x49)
#define REG_SC_BKCA_49_H      _PK_H_(0xCA, 0x49)
#define REG_SC_BKCA_4A_L      _PK_L_(0xCA, 0x4A)
#define REG_SC_BKCA_4A_H      _PK_H_(0xCA, 0x4A)
#define REG_SC_BKCA_4B_L      _PK_L_(0xCA, 0x4B)
#define REG_SC_BKCA_4B_H      _PK_H_(0xCA, 0x4B)
#define REG_SC_BKCA_4C_L      _PK_L_(0xCA, 0x4C)
#define REG_SC_BKCA_4C_H      _PK_H_(0xCA, 0x4C)
#define REG_SC_BKCA_4D_L      _PK_L_(0xCA, 0x4D)
#define REG_SC_BKCA_4D_H      _PK_H_(0xCA, 0x4D)
#define REG_SC_BKCA_4E_L      _PK_L_(0xCA, 0x4E)
#define REG_SC_BKCA_4E_H      _PK_H_(0xCA, 0x4E)
#define REG_SC_BKCA_4F_L      _PK_L_(0xCA, 0x4F)
#define REG_SC_BKCA_4F_H      _PK_H_(0xCA, 0x4F)
#define REG_SC_BKCA_50_L      _PK_L_(0xCA, 0x50)
#define REG_SC_BKCA_50_H      _PK_H_(0xCA, 0x50)
#define REG_SC_BKCA_51_L      _PK_L_(0xCA, 0x51)
#define REG_SC_BKCA_51_H      _PK_H_(0xCA, 0x51)
#define REG_SC_BKCA_52_L      _PK_L_(0xCA, 0x52)
#define REG_SC_BKCA_52_H      _PK_H_(0xCA, 0x52)
#define REG_SC_BKCA_53_L      _PK_L_(0xCA, 0x53)
#define REG_SC_BKCA_53_H      _PK_H_(0xCA, 0x53)
#define REG_SC_BKCA_54_L      _PK_L_(0xCA, 0x54)
#define REG_SC_BKCA_54_H      _PK_H_(0xCA, 0x54)
#define REG_SC_BKCA_55_L      _PK_L_(0xCA, 0x55)
#define REG_SC_BKCA_55_H      _PK_H_(0xCA, 0x55)
#define REG_SC_BKCA_56_L      _PK_L_(0xCA, 0x56)
#define REG_SC_BKCA_56_H      _PK_H_(0xCA, 0x56)
#define REG_SC_BKCA_57_L      _PK_L_(0xCA, 0x57)
#define REG_SC_BKCA_57_H      _PK_H_(0xCA, 0x57)
#define REG_SC_BKCA_58_L      _PK_L_(0xCA, 0x58)
#define REG_SC_BKCA_58_H      _PK_H_(0xCA, 0x58)
#define REG_SC_BKCA_59_L      _PK_L_(0xCA, 0x59)
#define REG_SC_BKCA_59_H      _PK_H_(0xCA, 0x59)
#define REG_SC_BKCA_5A_L      _PK_L_(0xCA, 0x5A)
#define REG_SC_BKCA_5A_H      _PK_H_(0xCA, 0x5A)
#define REG_SC_BKCA_5B_L      _PK_L_(0xCA, 0x5B)
#define REG_SC_BKCA_5B_H      _PK_H_(0xCA, 0x5B)
#define REG_SC_BKCA_5C_L      _PK_L_(0xCA, 0x5C)
#define REG_SC_BKCA_5C_H      _PK_H_(0xCA, 0x5C)
#define REG_SC_BKCA_5D_L      _PK_L_(0xCA, 0x5D)
#define REG_SC_BKCA_5D_H      _PK_H_(0xCA, 0x5D)
#define REG_SC_BKCA_5E_L      _PK_L_(0xCA, 0x5E)
#define REG_SC_BKCA_5E_H      _PK_H_(0xCA, 0x5E)
#define REG_SC_BKCA_5F_L      _PK_L_(0xCA, 0x5F)
#define REG_SC_BKCA_5F_H      _PK_H_(0xCA, 0x5F)
#define REG_SC_BKCA_60_L      _PK_L_(0xCA, 0x60)
#define REG_SC_BKCA_60_H      _PK_H_(0xCA, 0x60)
#define REG_SC_BKCA_61_L      _PK_L_(0xCA, 0x61)
#define REG_SC_BKCA_61_H      _PK_H_(0xCA, 0x61)
#define REG_SC_BKCA_62_L      _PK_L_(0xCA, 0x62)
#define REG_SC_BKCA_62_H      _PK_H_(0xCA, 0x62)
#define REG_SC_BKCA_63_L      _PK_L_(0xCA, 0x63)
#define REG_SC_BKCA_63_H      _PK_H_(0xCA, 0x63)
#define REG_SC_BKCA_64_L      _PK_L_(0xCA, 0x64)
#define REG_SC_BKCA_64_H      _PK_H_(0xCA, 0x64)
#define REG_SC_BKCA_65_L      _PK_L_(0xCA, 0x65)
#define REG_SC_BKCA_65_H      _PK_H_(0xCA, 0x65)
#define REG_SC_BKCA_66_L      _PK_L_(0xCA, 0x66)
#define REG_SC_BKCA_66_H      _PK_H_(0xCA, 0x66)
#define REG_SC_BKCA_67_L      _PK_L_(0xCA, 0x67)
#define REG_SC_BKCA_67_H      _PK_H_(0xCA, 0x67)
#define REG_SC_BKCA_68_L      _PK_L_(0xCA, 0x68)
#define REG_SC_BKCA_68_H      _PK_H_(0xCA, 0x68)
#define REG_SC_BKCA_69_L      _PK_L_(0xCA, 0x69)
#define REG_SC_BKCA_69_H      _PK_H_(0xCA, 0x69)
#define REG_SC_BKCA_6A_L      _PK_L_(0xCA, 0x6A)
#define REG_SC_BKCA_6A_H      _PK_H_(0xCA, 0x6A)
#define REG_SC_BKCA_6B_L      _PK_L_(0xCA, 0x6B)
#define REG_SC_BKCA_6B_H      _PK_H_(0xCA, 0x6B)
#define REG_SC_BKCA_6C_L      _PK_L_(0xCA, 0x6C)
#define REG_SC_BKCA_6C_H      _PK_H_(0xCA, 0x6C)
#define REG_SC_BKCA_6D_L      _PK_L_(0xCA, 0x6D)
#define REG_SC_BKCA_6D_H      _PK_H_(0xCA, 0x6D)
#define REG_SC_BKCA_6E_L      _PK_L_(0xCA, 0x6E)
#define REG_SC_BKCA_6E_H      _PK_H_(0xCA, 0x6E)
#define REG_SC_BKCA_6F_L      _PK_L_(0xCA, 0x6F)
#define REG_SC_BKCA_6F_H      _PK_H_(0xCA, 0x6F)
#define REG_SC_BKCA_70_L      _PK_L_(0xCA, 0x70)
#define REG_SC_BKCA_70_H      _PK_H_(0xCA, 0x70)
#define REG_SC_BKCA_71_L      _PK_L_(0xCA, 0x71)
#define REG_SC_BKCA_71_H      _PK_H_(0xCA, 0x71)
#define REG_SC_BKCA_72_L      _PK_L_(0xCA, 0x72)
#define REG_SC_BKCA_72_H      _PK_H_(0xCA, 0x72)
#define REG_SC_BKCA_73_L      _PK_L_(0xCA, 0x73)
#define REG_SC_BKCA_73_H      _PK_H_(0xCA, 0x73)
#define REG_SC_BKCA_74_L      _PK_L_(0xCA, 0x74)
#define REG_SC_BKCA_74_H      _PK_H_(0xCA, 0x74)
#define REG_SC_BKCA_75_L      _PK_L_(0xCA, 0x75)
#define REG_SC_BKCA_75_H      _PK_H_(0xCA, 0x75)
#define REG_SC_BKCA_76_L      _PK_L_(0xCA, 0x76)
#define REG_SC_BKCA_76_H      _PK_H_(0xCA, 0x76)
#define REG_SC_BKCA_77_L      _PK_L_(0xCA, 0x77)
#define REG_SC_BKCA_77_H      _PK_H_(0xCA, 0x77)
#define REG_SC_BKCA_78_L      _PK_L_(0xCA, 0x78)
#define REG_SC_BKCA_78_H      _PK_H_(0xCA, 0x78)
#define REG_SC_BKCA_79_L      _PK_L_(0xCA, 0x79)
#define REG_SC_BKCA_79_H      _PK_H_(0xCA, 0x79)
#define REG_SC_BKCA_7A_L      _PK_L_(0xCA, 0x7A)
#define REG_SC_BKCA_7A_H      _PK_H_(0xCA, 0x7A)
#define REG_SC_BKCA_7B_L      _PK_L_(0xCA, 0x7B)
#define REG_SC_BKCA_7B_H      _PK_H_(0xCA, 0x7B)
#define REG_SC_BKCA_7C_L      _PK_L_(0xCA, 0x7C)
#define REG_SC_BKCA_7C_H      _PK_H_(0xCA, 0x7C)
#define REG_SC_BKCA_7D_L      _PK_L_(0xCA, 0x7D)
#define REG_SC_BKCA_7D_H      _PK_H_(0xCA, 0x7D)
#define REG_SC_BKCA_7E_L      _PK_L_(0xCA, 0x7E)
#define REG_SC_BKCA_7E_H      _PK_H_(0xCA, 0x7E)
#define REG_SC_BKCA_7F_L      _PK_L_(0xCA, 0x7F)
#define REG_SC_BKCA_7F_H      _PK_H_(0xCA, 0x7F)

//----------------------------------------------
//  BKCB
//----------------------------------------------
#define REG_SC_BKCB_00_L      _PK_L_(0xCB, 0x00)
#define REG_SC_BKCB_00_H      _PK_H_(0xCB, 0x00)
#define REG_SC_BKCB_01_L      _PK_L_(0xCB, 0x01)
#define REG_SC_BKCB_01_H      _PK_H_(0xCB, 0x01)
#define REG_SC_BKCB_02_L      _PK_L_(0xCB, 0x02)
#define REG_SC_BKCB_02_H      _PK_H_(0xCB, 0x02)
#define REG_SC_BKCB_03_L      _PK_L_(0xCB, 0x03)
#define REG_SC_BKCB_03_H      _PK_H_(0xCB, 0x03)
#define REG_SC_BKCB_04_L      _PK_L_(0xCB, 0x04)
#define REG_SC_BKCB_04_H      _PK_H_(0xCB, 0x04)
#define REG_SC_BKCB_05_L      _PK_L_(0xCB, 0x05)
#define REG_SC_BKCB_05_H      _PK_H_(0xCB, 0x05)
#define REG_SC_BKCB_06_L      _PK_L_(0xCB, 0x06)
#define REG_SC_BKCB_06_H      _PK_H_(0xCB, 0x06)
#define REG_SC_BKCB_07_L      _PK_L_(0xCB, 0x07)
#define REG_SC_BKCB_07_H      _PK_H_(0xCB, 0x07)
#define REG_SC_BKCB_08_L      _PK_L_(0xCB, 0x08)
#define REG_SC_BKCB_08_H      _PK_H_(0xCB, 0x08)
#define REG_SC_BKCB_09_L      _PK_L_(0xCB, 0x09)
#define REG_SC_BKCB_09_H      _PK_H_(0xCB, 0x09)
#define REG_SC_BKCB_0A_L      _PK_L_(0xCB, 0x0A)
#define REG_SC_BKCB_0A_H      _PK_H_(0xCB, 0x0A)
#define REG_SC_BKCB_0B_L      _PK_L_(0xCB, 0x0B)
#define REG_SC_BKCB_0B_H      _PK_H_(0xCB, 0x0B)
#define REG_SC_BKCB_0C_L      _PK_L_(0xCB, 0x0C)
#define REG_SC_BKCB_0C_H      _PK_H_(0xCB, 0x0C)
#define REG_SC_BKCB_0D_L      _PK_L_(0xCB, 0x0D)
#define REG_SC_BKCB_0D_H      _PK_H_(0xCB, 0x0D)
#define REG_SC_BKCB_0E_L      _PK_L_(0xCB, 0x0E)
#define REG_SC_BKCB_0E_H      _PK_H_(0xCB, 0x0E)
#define REG_SC_BKCB_0F_L      _PK_L_(0xCB, 0x0F)
#define REG_SC_BKCB_0F_H      _PK_H_(0xCB, 0x0F)
#define REG_SC_BKCB_10_L      _PK_L_(0xCB, 0x10)
#define REG_SC_BKCB_10_H      _PK_H_(0xCB, 0x10)
#define REG_SC_BKCB_11_L      _PK_L_(0xCB, 0x11)
#define REG_SC_BKCB_11_H      _PK_H_(0xCB, 0x11)
#define REG_SC_BKCB_12_L      _PK_L_(0xCB, 0x12)
#define REG_SC_BKCB_12_H      _PK_H_(0xCB, 0x12)
#define REG_SC_BKCB_13_L      _PK_L_(0xCB, 0x13)
#define REG_SC_BKCB_13_H      _PK_H_(0xCB, 0x13)
#define REG_SC_BKCB_14_L      _PK_L_(0xCB, 0x14)
#define REG_SC_BKCB_14_H      _PK_H_(0xCB, 0x14)
#define REG_SC_BKCB_15_L      _PK_L_(0xCB, 0x15)
#define REG_SC_BKCB_15_H      _PK_H_(0xCB, 0x15)
#define REG_SC_BKCB_16_L      _PK_L_(0xCB, 0x16)
#define REG_SC_BKCB_16_H      _PK_H_(0xCB, 0x16)
#define REG_SC_BKCB_17_L      _PK_L_(0xCB, 0x17)
#define REG_SC_BKCB_17_H      _PK_H_(0xCB, 0x17)
#define REG_SC_BKCB_18_L      _PK_L_(0xCB, 0x18)
#define REG_SC_BKCB_18_H      _PK_H_(0xCB, 0x18)
#define REG_SC_BKCB_19_L      _PK_L_(0xCB, 0x19)
#define REG_SC_BKCB_19_H      _PK_H_(0xCB, 0x19)
#define REG_SC_BKCB_1A_L      _PK_L_(0xCB, 0x1A)
#define REG_SC_BKCB_1A_H      _PK_H_(0xCB, 0x1A)
#define REG_SC_BKCB_1B_L      _PK_L_(0xCB, 0x1B)
#define REG_SC_BKCB_1B_H      _PK_H_(0xCB, 0x1B)
#define REG_SC_BKCB_1C_L      _PK_L_(0xCB, 0x1C)
#define REG_SC_BKCB_1C_H      _PK_H_(0xCB, 0x1C)
#define REG_SC_BKCB_1D_L      _PK_L_(0xCB, 0x1D)
#define REG_SC_BKCB_1D_H      _PK_H_(0xCB, 0x1D)
#define REG_SC_BKCB_1E_L      _PK_L_(0xCB, 0x1E)
#define REG_SC_BKCB_1E_H      _PK_H_(0xCB, 0x1E)
#define REG_SC_BKCB_1F_L      _PK_L_(0xCB, 0x1F)
#define REG_SC_BKCB_1F_H      _PK_H_(0xCB, 0x1F)
#define REG_SC_BKCB_20_L      _PK_L_(0xCB, 0x20)
#define REG_SC_BKCB_20_H      _PK_H_(0xCB, 0x20)
#define REG_SC_BKCB_21_L      _PK_L_(0xCB, 0x21)
#define REG_SC_BKCB_21_H      _PK_H_(0xCB, 0x21)
#define REG_SC_BKCB_22_L      _PK_L_(0xCB, 0x22)
#define REG_SC_BKCB_22_H      _PK_H_(0xCB, 0x22)
#define REG_SC_BKCB_23_L      _PK_L_(0xCB, 0x23)
#define REG_SC_BKCB_23_H      _PK_H_(0xCB, 0x23)
#define REG_SC_BKCB_24_L      _PK_L_(0xCB, 0x24)
#define REG_SC_BKCB_24_H      _PK_H_(0xCB, 0x24)
#define REG_SC_BKCB_25_L      _PK_L_(0xCB, 0x25)
#define REG_SC_BKCB_25_H      _PK_H_(0xCB, 0x25)
#define REG_SC_BKCB_26_L      _PK_L_(0xCB, 0x26)
#define REG_SC_BKCB_26_H      _PK_H_(0xCB, 0x26)
#define REG_SC_BKCB_27_L      _PK_L_(0xCB, 0x27)
#define REG_SC_BKCB_27_H      _PK_H_(0xCB, 0x27)
#define REG_SC_BKCB_28_L      _PK_L_(0xCB, 0x28)
#define REG_SC_BKCB_28_H      _PK_H_(0xCB, 0x28)
#define REG_SC_BKCB_29_L      _PK_L_(0xCB, 0x29)
#define REG_SC_BKCB_29_H      _PK_H_(0xCB, 0x29)
#define REG_SC_BKCB_2A_L      _PK_L_(0xCB, 0x2A)
#define REG_SC_BKCB_2A_H      _PK_H_(0xCB, 0x2A)
#define REG_SC_BKCB_2B_L      _PK_L_(0xCB, 0x2B)
#define REG_SC_BKCB_2B_H      _PK_H_(0xCB, 0x2B)
#define REG_SC_BKCB_2C_L      _PK_L_(0xCB, 0x2C)
#define REG_SC_BKCB_2C_H      _PK_H_(0xCB, 0x2C)
#define REG_SC_BKCB_2D_L      _PK_L_(0xCB, 0x2D)
#define REG_SC_BKCB_2D_H      _PK_H_(0xCB, 0x2D)
#define REG_SC_BKCB_2E_L      _PK_L_(0xCB, 0x2E)
#define REG_SC_BKCB_2E_H      _PK_H_(0xCB, 0x2E)
#define REG_SC_BKCB_2F_L      _PK_L_(0xCB, 0x2F)
#define REG_SC_BKCB_2F_H      _PK_H_(0xCB, 0x2F)
#define REG_SC_BKCB_30_L      _PK_L_(0xCB, 0x30)
#define REG_SC_BKCB_30_H      _PK_H_(0xCB, 0x30)
#define REG_SC_BKCB_31_L      _PK_L_(0xCB, 0x31)
#define REG_SC_BKCB_31_H      _PK_H_(0xCB, 0x31)
#define REG_SC_BKCB_32_L      _PK_L_(0xCB, 0x32)
#define REG_SC_BKCB_32_H      _PK_H_(0xCB, 0x32)
#define REG_SC_BKCB_33_L      _PK_L_(0xCB, 0x33)
#define REG_SC_BKCB_33_H      _PK_H_(0xCB, 0x33)
#define REG_SC_BKCB_34_L      _PK_L_(0xCB, 0x34)
#define REG_SC_BKCB_34_H      _PK_H_(0xCB, 0x34)
#define REG_SC_BKCB_35_L      _PK_L_(0xCB, 0x35)
#define REG_SC_BKCB_35_H      _PK_H_(0xCB, 0x35)
#define REG_SC_BKCB_36_L      _PK_L_(0xCB, 0x36)
#define REG_SC_BKCB_36_H      _PK_H_(0xCB, 0x36)
#define REG_SC_BKCB_37_L      _PK_L_(0xCB, 0x37)
#define REG_SC_BKCB_37_H      _PK_H_(0xCB, 0x37)
#define REG_SC_BKCB_38_L      _PK_L_(0xCB, 0x38)
#define REG_SC_BKCB_38_H      _PK_H_(0xCB, 0x38)
#define REG_SC_BKCB_39_L      _PK_L_(0xCB, 0x39)
#define REG_SC_BKCB_39_H      _PK_H_(0xCB, 0x39)
#define REG_SC_BKCB_3A_L      _PK_L_(0xCB, 0x3A)
#define REG_SC_BKCB_3A_H      _PK_H_(0xCB, 0x3A)
#define REG_SC_BKCB_3B_L      _PK_L_(0xCB, 0x3B)
#define REG_SC_BKCB_3B_H      _PK_H_(0xCB, 0x3B)
#define REG_SC_BKCB_3C_L      _PK_L_(0xCB, 0x3C)
#define REG_SC_BKCB_3C_H      _PK_H_(0xCB, 0x3C)
#define REG_SC_BKCB_3D_L      _PK_L_(0xCB, 0x3D)
#define REG_SC_BKCB_3D_H      _PK_H_(0xCB, 0x3D)
#define REG_SC_BKCB_3E_L      _PK_L_(0xCB, 0x3E)
#define REG_SC_BKCB_3E_H      _PK_H_(0xCB, 0x3E)
#define REG_SC_BKCB_3F_L      _PK_L_(0xCB, 0x3F)
#define REG_SC_BKCB_3F_H      _PK_H_(0xCB, 0x3F)
#define REG_SC_BKCB_40_L      _PK_L_(0xCB, 0x40)
#define REG_SC_BKCB_40_H      _PK_H_(0xCB, 0x40)
#define REG_SC_BKCB_41_L      _PK_L_(0xCB, 0x41)
#define REG_SC_BKCB_41_H      _PK_H_(0xCB, 0x41)
#define REG_SC_BKCB_42_L      _PK_L_(0xCB, 0x42)
#define REG_SC_BKCB_42_H      _PK_H_(0xCB, 0x42)
#define REG_SC_BKCB_43_L      _PK_L_(0xCB, 0x43)
#define REG_SC_BKCB_43_H      _PK_H_(0xCB, 0x43)
#define REG_SC_BKCB_44_L      _PK_L_(0xCB, 0x44)
#define REG_SC_BKCB_44_H      _PK_H_(0xCB, 0x44)
#define REG_SC_BKCB_45_L      _PK_L_(0xCB, 0x45)
#define REG_SC_BKCB_45_H      _PK_H_(0xCB, 0x45)
#define REG_SC_BKCB_46_L      _PK_L_(0xCB, 0x46)
#define REG_SC_BKCB_46_H      _PK_H_(0xCB, 0x46)
#define REG_SC_BKCB_47_L      _PK_L_(0xCB, 0x47)
#define REG_SC_BKCB_47_H      _PK_H_(0xCB, 0x47)
#define REG_SC_BKCB_48_L      _PK_L_(0xCB, 0x48)
#define REG_SC_BKCB_48_H      _PK_H_(0xCB, 0x48)
#define REG_SC_BKCB_49_L      _PK_L_(0xCB, 0x49)
#define REG_SC_BKCB_49_H      _PK_H_(0xCB, 0x49)
#define REG_SC_BKCB_4A_L      _PK_L_(0xCB, 0x4A)
#define REG_SC_BKCB_4A_H      _PK_H_(0xCB, 0x4A)
#define REG_SC_BKCB_4B_L      _PK_L_(0xCB, 0x4B)
#define REG_SC_BKCB_4B_H      _PK_H_(0xCB, 0x4B)
#define REG_SC_BKCB_4C_L      _PK_L_(0xCB, 0x4C)
#define REG_SC_BKCB_4C_H      _PK_H_(0xCB, 0x4C)
#define REG_SC_BKCB_4D_L      _PK_L_(0xCB, 0x4D)
#define REG_SC_BKCB_4D_H      _PK_H_(0xCB, 0x4D)
#define REG_SC_BKCB_4E_L      _PK_L_(0xCB, 0x4E)
#define REG_SC_BKCB_4E_H      _PK_H_(0xCB, 0x4E)
#define REG_SC_BKCB_4F_L      _PK_L_(0xCB, 0x4F)
#define REG_SC_BKCB_4F_H      _PK_H_(0xCB, 0x4F)
#define REG_SC_BKCB_50_L      _PK_L_(0xCB, 0x50)
#define REG_SC_BKCB_50_H      _PK_H_(0xCB, 0x50)
#define REG_SC_BKCB_51_L      _PK_L_(0xCB, 0x51)
#define REG_SC_BKCB_51_H      _PK_H_(0xCB, 0x51)
#define REG_SC_BKCB_52_L      _PK_L_(0xCB, 0x52)
#define REG_SC_BKCB_52_H      _PK_H_(0xCB, 0x52)
#define REG_SC_BKCB_53_L      _PK_L_(0xCB, 0x53)
#define REG_SC_BKCB_53_H      _PK_H_(0xCB, 0x53)
#define REG_SC_BKCB_54_L      _PK_L_(0xCB, 0x54)
#define REG_SC_BKCB_54_H      _PK_H_(0xCB, 0x54)
#define REG_SC_BKCB_55_L      _PK_L_(0xCB, 0x55)
#define REG_SC_BKCB_55_H      _PK_H_(0xCB, 0x55)
#define REG_SC_BKCB_56_L      _PK_L_(0xCB, 0x56)
#define REG_SC_BKCB_56_H      _PK_H_(0xCB, 0x56)
#define REG_SC_BKCB_57_L      _PK_L_(0xCB, 0x57)
#define REG_SC_BKCB_57_H      _PK_H_(0xCB, 0x57)
#define REG_SC_BKCB_58_L      _PK_L_(0xCB, 0x58)
#define REG_SC_BKCB_58_H      _PK_H_(0xCB, 0x58)
#define REG_SC_BKCB_59_L      _PK_L_(0xCB, 0x59)
#define REG_SC_BKCB_59_H      _PK_H_(0xCB, 0x59)
#define REG_SC_BKCB_5A_L      _PK_L_(0xCB, 0x5A)
#define REG_SC_BKCB_5A_H      _PK_H_(0xCB, 0x5A)
#define REG_SC_BKCB_5B_L      _PK_L_(0xCB, 0x5B)
#define REG_SC_BKCB_5B_H      _PK_H_(0xCB, 0x5B)
#define REG_SC_BKCB_5C_L      _PK_L_(0xCB, 0x5C)
#define REG_SC_BKCB_5C_H      _PK_H_(0xCB, 0x5C)
#define REG_SC_BKCB_5D_L      _PK_L_(0xCB, 0x5D)
#define REG_SC_BKCB_5D_H      _PK_H_(0xCB, 0x5D)
#define REG_SC_BKCB_5E_L      _PK_L_(0xCB, 0x5E)
#define REG_SC_BKCB_5E_H      _PK_H_(0xCB, 0x5E)
#define REG_SC_BKCB_5F_L      _PK_L_(0xCB, 0x5F)
#define REG_SC_BKCB_5F_H      _PK_H_(0xCB, 0x5F)
#define REG_SC_BKCB_60_L      _PK_L_(0xCB, 0x60)
#define REG_SC_BKCB_60_H      _PK_H_(0xCB, 0x60)
#define REG_SC_BKCB_61_L      _PK_L_(0xCB, 0x61)
#define REG_SC_BKCB_61_H      _PK_H_(0xCB, 0x61)
#define REG_SC_BKCB_62_L      _PK_L_(0xCB, 0x62)
#define REG_SC_BKCB_62_H      _PK_H_(0xCB, 0x62)
#define REG_SC_BKCB_63_L      _PK_L_(0xCB, 0x63)
#define REG_SC_BKCB_63_H      _PK_H_(0xCB, 0x63)
#define REG_SC_BKCB_64_L      _PK_L_(0xCB, 0x64)
#define REG_SC_BKCB_64_H      _PK_H_(0xCB, 0x64)
#define REG_SC_BKCB_65_L      _PK_L_(0xCB, 0x65)
#define REG_SC_BKCB_65_H      _PK_H_(0xCB, 0x65)
#define REG_SC_BKCB_66_L      _PK_L_(0xCB, 0x66)
#define REG_SC_BKCB_66_H      _PK_H_(0xCB, 0x66)
#define REG_SC_BKCB_67_L      _PK_L_(0xCB, 0x67)
#define REG_SC_BKCB_67_H      _PK_H_(0xCB, 0x67)
#define REG_SC_BKCB_68_L      _PK_L_(0xCB, 0x68)
#define REG_SC_BKCB_68_H      _PK_H_(0xCB, 0x68)
#define REG_SC_BKCB_69_L      _PK_L_(0xCB, 0x69)
#define REG_SC_BKCB_69_H      _PK_H_(0xCB, 0x69)
#define REG_SC_BKCB_6A_L      _PK_L_(0xCB, 0x6A)
#define REG_SC_BKCB_6A_H      _PK_H_(0xCB, 0x6A)
#define REG_SC_BKCB_6B_L      _PK_L_(0xCB, 0x6B)
#define REG_SC_BKCB_6B_H      _PK_H_(0xCB, 0x6B)
#define REG_SC_BKCB_6C_L      _PK_L_(0xCB, 0x6C)
#define REG_SC_BKCB_6C_H      _PK_H_(0xCB, 0x6C)
#define REG_SC_BKCB_6D_L      _PK_L_(0xCB, 0x6D)
#define REG_SC_BKCB_6D_H      _PK_H_(0xCB, 0x6D)
#define REG_SC_BKCB_6E_L      _PK_L_(0xCB, 0x6E)
#define REG_SC_BKCB_6E_H      _PK_H_(0xCB, 0x6E)
#define REG_SC_BKCB_6F_L      _PK_L_(0xCB, 0x6F)
#define REG_SC_BKCB_6F_H      _PK_H_(0xCB, 0x6F)
#define REG_SC_BKCB_70_L      _PK_L_(0xCB, 0x70)
#define REG_SC_BKCB_70_H      _PK_H_(0xCB, 0x70)
#define REG_SC_BKCB_71_L      _PK_L_(0xCB, 0x71)
#define REG_SC_BKCB_71_H      _PK_H_(0xCB, 0x71)
#define REG_SC_BKCB_72_L      _PK_L_(0xCB, 0x72)
#define REG_SC_BKCB_72_H      _PK_H_(0xCB, 0x72)
#define REG_SC_BKCB_73_L      _PK_L_(0xCB, 0x73)
#define REG_SC_BKCB_73_H      _PK_H_(0xCB, 0x73)
#define REG_SC_BKCB_74_L      _PK_L_(0xCB, 0x74)
#define REG_SC_BKCB_74_H      _PK_H_(0xCB, 0x74)
#define REG_SC_BKCB_75_L      _PK_L_(0xCB, 0x75)
#define REG_SC_BKCB_75_H      _PK_H_(0xCB, 0x75)
#define REG_SC_BKCB_76_L      _PK_L_(0xCB, 0x76)
#define REG_SC_BKCB_76_H      _PK_H_(0xCB, 0x76)
#define REG_SC_BKCB_77_L      _PK_L_(0xCB, 0x77)
#define REG_SC_BKCB_77_H      _PK_H_(0xCB, 0x77)
#define REG_SC_BKCB_78_L      _PK_L_(0xCB, 0x78)
#define REG_SC_BKCB_78_H      _PK_H_(0xCB, 0x78)
#define REG_SC_BKCB_79_L      _PK_L_(0xCB, 0x79)
#define REG_SC_BKCB_79_H      _PK_H_(0xCB, 0x79)
#define REG_SC_BKCB_7A_L      _PK_L_(0xCB, 0x7A)
#define REG_SC_BKCB_7A_H      _PK_H_(0xCB, 0x7A)
#define REG_SC_BKCB_7B_L      _PK_L_(0xCB, 0x7B)
#define REG_SC_BKCB_7B_H      _PK_H_(0xCB, 0x7B)
#define REG_SC_BKCB_7C_L      _PK_L_(0xCB, 0x7C)
#define REG_SC_BKCB_7C_H      _PK_H_(0xCB, 0x7C)
#define REG_SC_BKCB_7D_L      _PK_L_(0xCB, 0x7D)
#define REG_SC_BKCB_7D_H      _PK_H_(0xCB, 0x7D)
#define REG_SC_BKCB_7E_L      _PK_L_(0xCB, 0x7E)
#define REG_SC_BKCB_7E_H      _PK_H_(0xCB, 0x7E)
#define REG_SC_BKCB_7F_L      _PK_L_(0xCB, 0x7F)
#define REG_SC_BKCB_7F_H      _PK_H_(0xCB, 0x7F)

#define REG_SC_BKCC_0B_L      _PK_L_(0xCC, 0x0B)
#define REG_SC_BKCC_0B_H      _PK_H_(0xCC, 0x0B)

#define REG_SC_BKCE_01_L      _PK_L_(0xCE, 0x01)
#define REG_SC_BKCE_37_L      _PK_L_(0xCE, 0x37)

//----------------------------------------------
//  BKDF
//----------------------------------------------
#define REG_SC_BKDF_20_L      _PK_L_(0xDF, 0x20)
#define REG_SC_BKDF_20_H      _PK_H_(0xDF, 0x20)
#define REG_SC_BKDF_21_L      _PK_L_(0xDF, 0x21)
#define REG_SC_BKDF_21_H      _PK_H_(0xDF, 0x21)

#define REG_SC_BKF0_31_L      _PK_L_(0xF0, 0x31)
#define REG_SC_BKF0_32_L      _PK_L_(0xF0, 0x32)

#define REG_SC_BKF8_40_L      _PK_L_(0xF8, 0x40)
#define REG_SC_BKF9_40_L      _PK_L_(0xF9, 0x40)
#define REG_SC_BKFA_40_L      _PK_L_(0xFA, 0x40)
#define REG_SC_BKFB_40_L      _PK_L_(0xFB, 0x40)
#define REG_SC_BKFC_40_L      _PK_L_(0xFC, 0x40)
#define REG_SC_BKFD_40_L      _PK_L_(0xFD, 0x40)
#define REG_SC_BKFE_40_L      _PK_L_(0xFE, 0x40)

//----------------------------------------------
//  BKF8: IP1_TOP_WP0
//----------------------------------------------
#define REG_SC_BKF8_00_L      _PK_L_(0xF8, 0x00)
#define REG_SC_BKF8_00_H      _PK_H_(0xF8, 0x00)
#define REG_SC_BKF8_01_L      _PK_L_(0xF8, 0x01)
#define REG_SC_BKF8_01_H      _PK_H_(0xF8, 0x01)
#define REG_SC_BKF8_02_L      _PK_L_(0xF8, 0x02)
#define REG_SC_BKF8_02_H      _PK_H_(0xF8, 0x02)
#define REG_SC_BKF8_03_L      _PK_L_(0xF8, 0x03)
#define REG_SC_BKF8_03_H      _PK_H_(0xF8, 0x03)
#define REG_SC_BKF8_04_L      _PK_L_(0xF8, 0x04)
#define REG_SC_BKF8_04_H      _PK_H_(0xF8, 0x04)
#define REG_SC_BKF8_1A_L      _PK_L_(0xF8, 0x1A)
#define REG_SC_BKF8_1A_H      _PK_H_(0xF8, 0x1A)
#define REG_SC_BKF8_20_L      _PK_L_(0xF8, 0x20)
#define REG_SC_BKF8_20_H      _PK_H_(0xF8, 0x20)
#define REG_SC_BKF8_21_L      _PK_L_(0xF8, 0x21)
#define REG_SC_BKF8_21_H      _PK_H_(0xF8, 0x21)
#define REG_SC_BKF8_40_L      _PK_L_(0xF8, 0x40)
#define REG_SC_BKF8_40_H      _PK_H_(0xF8, 0x40)
#define REG_SC_BKF8_41_L      _PK_L_(0xF8, 0x41)
#define REG_SC_BKF8_41_H      _PK_H_(0xF8, 0x41)
#define REG_SC_BKF8_42_L      _PK_L_(0xF8, 0x42)
#define REG_SC_BKF8_42_H      _PK_H_(0xF8, 0x42)
#define REG_SC_BKF8_43_L      _PK_L_(0xF8, 0x43)
#define REG_SC_BKF8_43_H      _PK_H_(0xF8, 0x43)
#define REG_SC_BKF8_44_L      _PK_L_(0xF8, 0x44)
#define REG_SC_BKF8_44_H      _PK_H_(0xF8, 0x44)
#define REG_SC_BKF8_7E_L      _PK_L_(0xF8, 0x7E)
#define REG_SC_BKF8_7E_H      _PK_H_(0xF8, 0x7E)
#define REG_SC_BKF8_7F_L      _PK_L_(0xF8, 0x7F)
#define REG_SC_BKF8_7F_H      _PK_H_(0xF8, 0x7F)


//----------------------------------------------
//  BKF9: IP1_TOP_WP1
//----------------------------------------------
#define REG_SC_BKF9_00_L      _PK_L_(0xF9, 0x00)
#define REG_SC_BKF9_00_H      _PK_H_(0xF9, 0x00)
#define REG_SC_BKF9_01_L      _PK_L_(0xF9, 0x01)
#define REG_SC_BKF9_01_H      _PK_H_(0xF9, 0x01)
#define REG_SC_BKF9_02_L      _PK_L_(0xF9, 0x02)
#define REG_SC_BKF9_02_H      _PK_H_(0xF9, 0x02)
#define REG_SC_BKF9_03_L      _PK_L_(0xF9, 0x03)
#define REG_SC_BKF9_03_H      _PK_H_(0xF9, 0x03)
#define REG_SC_BKF9_04_L      _PK_L_(0xF9, 0x04)
#define REG_SC_BKF9_04_H      _PK_H_(0xF9, 0x04)
#define REG_SC_BKF9_1A_L      _PK_L_(0xF9, 0x1A)
#define REG_SC_BKF9_1A_H      _PK_H_(0xF9, 0x1A)
#define REG_SC_BKF9_20_L      _PK_L_(0xF9, 0x20)
#define REG_SC_BKF9_20_H      _PK_H_(0xF9, 0x20)
#define REG_SC_BKF9_21_L      _PK_L_(0xF9, 0x21)
#define REG_SC_BKF9_21_H      _PK_H_(0xF9, 0x21)
#define REG_SC_BKF9_40_L      _PK_L_(0xF9, 0x40)
#define REG_SC_BKF9_40_H      _PK_H_(0xF9, 0x40)
#define REG_SC_BKF9_41_L      _PK_L_(0xF9, 0x41)
#define REG_SC_BKF9_41_H      _PK_H_(0xF9, 0x41)
#define REG_SC_BKF9_42_L      _PK_L_(0xF9, 0x42)
#define REG_SC_BKF9_42_H      _PK_H_(0xF9, 0x42)
#define REG_SC_BKF9_43_L      _PK_L_(0xF9, 0x43)
#define REG_SC_BKF9_43_H      _PK_H_(0xF9, 0x43)
#define REG_SC_BKF9_44_L      _PK_L_(0xF9, 0x44)
#define REG_SC_BKF9_44_H      _PK_H_(0xF9, 0x44)
#define REG_SC_BKF9_7E_L      _PK_L_(0xF9, 0x7E)
#define REG_SC_BKF9_7E_H      _PK_H_(0xF9, 0x7E)
#define REG_SC_BKF9_7F_L      _PK_L_(0xF9, 0x7F)
#define REG_SC_BKF9_7F_H      _PK_H_(0xF9, 0x7F)


//----------------------------------------------
//  BKFA: IP1_TOP_WP2
//----------------------------------------------
#define REG_SC_BKFA_00_L      _PK_L_(0xFA, 0x00)
#define REG_SC_BKFA_00_H      _PK_H_(0xFA, 0x00)
#define REG_SC_BKFA_01_L      _PK_L_(0xFA, 0x01)
#define REG_SC_BKFA_01_H      _PK_H_(0xFA, 0x01)
#define REG_SC_BKFA_02_L      _PK_L_(0xFA, 0x02)
#define REG_SC_BKFA_02_H      _PK_H_(0xFA, 0x02)
#define REG_SC_BKFA_03_L      _PK_L_(0xFA, 0x03)
#define REG_SC_BKFA_03_H      _PK_H_(0xFA, 0x03)
#define REG_SC_BKFA_04_L      _PK_L_(0xFA, 0x04)
#define REG_SC_BKFA_04_H      _PK_H_(0xFA, 0x04)
#define REG_SC_BKFA_1A_L      _PK_L_(0xFA, 0x1A)
#define REG_SC_BKFA_1A_H      _PK_H_(0xFA, 0x1A)
#define REG_SC_BKFA_20_L      _PK_L_(0xFA, 0x20)
#define REG_SC_BKFA_20_H      _PK_H_(0xFA, 0x20)
#define REG_SC_BKFA_21_L      _PK_L_(0xFA, 0x21)
#define REG_SC_BKFA_21_H      _PK_H_(0xFA, 0x21)
#define REG_SC_BKFA_40_L      _PK_L_(0xFA, 0x40)
#define REG_SC_BKFA_40_H      _PK_H_(0xFA, 0x40)
#define REG_SC_BKFA_41_L      _PK_L_(0xFA, 0x41)
#define REG_SC_BKFA_41_H      _PK_H_(0xFA, 0x41)
#define REG_SC_BKFA_42_L      _PK_L_(0xFA, 0x42)
#define REG_SC_BKFA_42_H      _PK_H_(0xFA, 0x42)
#define REG_SC_BKFA_43_L      _PK_L_(0xFA, 0x43)
#define REG_SC_BKFA_43_H      _PK_H_(0xFA, 0x43)
#define REG_SC_BKFA_44_L      _PK_L_(0xFA, 0x44)
#define REG_SC_BKFA_44_H      _PK_H_(0xFA, 0x44)
#define REG_SC_BKFA_7E_L      _PK_L_(0xFA, 0x7E)
#define REG_SC_BKFA_7E_H      _PK_H_(0xFA, 0x7E)
#define REG_SC_BKFA_7F_L      _PK_L_(0xFA, 0x7F)
#define REG_SC_BKFA_7F_H      _PK_H_(0xFA, 0x7F)


//----------------------------------------------
//  BKFB: IP1_TOP_WP3
//----------------------------------------------
#define REG_SC_BKFB_00_L      _PK_L_(0xFB, 0x00)
#define REG_SC_BKFB_00_H      _PK_H_(0xFB, 0x00)
#define REG_SC_BKFB_01_L      _PK_L_(0xFB, 0x01)
#define REG_SC_BKFB_01_H      _PK_H_(0xFB, 0x01)
#define REG_SC_BKFB_02_L      _PK_L_(0xFB, 0x02)
#define REG_SC_BKFB_02_H      _PK_H_(0xFB, 0x02)
#define REG_SC_BKFB_03_L      _PK_L_(0xFB, 0x03)
#define REG_SC_BKFB_03_H      _PK_H_(0xFB, 0x03)
#define REG_SC_BKFB_04_L      _PK_L_(0xFB, 0x04)
#define REG_SC_BKFB_04_H      _PK_H_(0xFB, 0x04)
#define REG_SC_BKFB_1A_L      _PK_L_(0xFB, 0x1A)
#define REG_SC_BKFB_1A_H      _PK_H_(0xFB, 0x1A)
#define REG_SC_BKFB_20_L      _PK_L_(0xFB, 0x20)
#define REG_SC_BKFB_20_H      _PK_H_(0xFB, 0x20)
#define REG_SC_BKFB_21_L      _PK_L_(0xFB, 0x21)
#define REG_SC_BKFB_21_H      _PK_H_(0xFB, 0x21)
#define REG_SC_BKFB_40_L      _PK_L_(0xFB, 0x40)
#define REG_SC_BKFB_40_H      _PK_H_(0xFB, 0x40)
#define REG_SC_BKFB_41_L      _PK_L_(0xFB, 0x41)
#define REG_SC_BKFB_41_H      _PK_H_(0xFB, 0x41)
#define REG_SC_BKFB_42_L      _PK_L_(0xFB, 0x42)
#define REG_SC_BKFB_42_H      _PK_H_(0xFB, 0x42)
#define REG_SC_BKFB_43_L      _PK_L_(0xFB, 0x43)
#define REG_SC_BKFB_43_H      _PK_H_(0xFB, 0x43)
#define REG_SC_BKFB_44_L      _PK_L_(0xFB, 0x44)
#define REG_SC_BKFB_44_H      _PK_H_(0xFB, 0x44)
#define REG_SC_BKFB_7E_L      _PK_L_(0xFB, 0x7E)
#define REG_SC_BKFB_7E_H      _PK_H_(0xFB, 0x7E)
#define REG_SC_BKFB_7F_L      _PK_L_(0xFB, 0x7F)
#define REG_SC_BKFB_7F_H      _PK_H_(0xFB, 0x7F)

//----------------------------------------------
//  BKFC: IP1_TOP_WP4
//----------------------------------------------
#define REG_SC_BKFC_00_L      _PK_L_(0xFC, 0x00)
#define REG_SC_BKFC_00_H      _PK_H_(0xFC, 0x00)
#define REG_SC_BKFC_01_L      _PK_L_(0xFC, 0x01)
#define REG_SC_BKFC_01_H      _PK_H_(0xFC, 0x01)
#define REG_SC_BKFC_02_L      _PK_L_(0xFC, 0x02)
#define REG_SC_BKFC_02_H      _PK_H_(0xFC, 0x02)
#define REG_SC_BKFC_03_L      _PK_L_(0xFC, 0x03)
#define REG_SC_BKFC_03_H      _PK_H_(0xFC, 0x03)
#define REG_SC_BKFC_04_L      _PK_L_(0xFC, 0x04)
#define REG_SC_BKFC_04_H      _PK_H_(0xFC, 0x04)
#define REG_SC_BKFC_1A_L      _PK_L_(0xFC, 0x1A)
#define REG_SC_BKFC_1A_H      _PK_H_(0xFC, 0x1A)
#define REG_SC_BKFC_20_L      _PK_L_(0xFC, 0x20)
#define REG_SC_BKFC_20_H      _PK_H_(0xFC, 0x20)
#define REG_SC_BKFC_21_L      _PK_L_(0xFC, 0x21)
#define REG_SC_BKFC_21_H      _PK_H_(0xFC, 0x21)
#define REG_SC_BKFC_40_L      _PK_L_(0xFC, 0x40)
#define REG_SC_BKFC_40_H      _PK_H_(0xFC, 0x40)
#define REG_SC_BKFC_41_L      _PK_L_(0xFC, 0x41)
#define REG_SC_BKFC_41_H      _PK_H_(0xFC, 0x41)
#define REG_SC_BKFC_42_L      _PK_L_(0xFC, 0x42)
#define REG_SC_BKFC_42_H      _PK_H_(0xFC, 0x42)
#define REG_SC_BKFC_43_L      _PK_L_(0xFC, 0x43)
#define REG_SC_BKFC_43_H      _PK_H_(0xFC, 0x43)
#define REG_SC_BKFC_44_L      _PK_L_(0xFC, 0x44)
#define REG_SC_BKFC_44_H      _PK_H_(0xFC, 0x44)
#define REG_SC_BKFC_7E_L      _PK_L_(0xFC, 0x7E)
#define REG_SC_BKFC_7E_H      _PK_H_(0xFC, 0x7E)
#define REG_SC_BKFC_7F_L      _PK_L_(0xFC, 0x7F)
#define REG_SC_BKFC_7F_H      _PK_H_(0xFC, 0x7F)


//----------------------------------------------
//  BKFD: IP1_TOP_WP5
//----------------------------------------------
#define REG_SC_BKFD_00_L      _PK_L_(0xFD, 0x00)
#define REG_SC_BKFD_00_H      _PK_H_(0xFD, 0x00)
#define REG_SC_BKFD_01_L      _PK_L_(0xFD, 0x01)
#define REG_SC_BKFD_01_H      _PK_H_(0xFD, 0x01)
#define REG_SC_BKFD_02_L      _PK_L_(0xFD, 0x02)
#define REG_SC_BKFD_02_H      _PK_H_(0xFD, 0x02)
#define REG_SC_BKFD_03_L      _PK_L_(0xFD, 0x03)
#define REG_SC_BKFD_03_H      _PK_H_(0xFD, 0x03)
#define REG_SC_BKFD_04_L      _PK_L_(0xFD, 0x04)
#define REG_SC_BKFD_04_H      _PK_H_(0xFD, 0x04)
#define REG_SC_BKFD_1A_L      _PK_L_(0xFD, 0x1A)
#define REG_SC_BKFD_1A_H      _PK_H_(0xFD, 0x1A)
#define REG_SC_BKFD_20_L      _PK_L_(0xFD, 0x20)
#define REG_SC_BKFD_20_H      _PK_H_(0xFD, 0x20)
#define REG_SC_BKFD_21_L      _PK_L_(0xFD, 0x21)
#define REG_SC_BKFD_21_H      _PK_H_(0xFD, 0x21)
#define REG_SC_BKFD_40_L      _PK_L_(0xFD, 0x40)
#define REG_SC_BKFD_40_H      _PK_H_(0xFD, 0x40)
#define REG_SC_BKFD_41_L      _PK_L_(0xFD, 0x41)
#define REG_SC_BKFD_41_H      _PK_H_(0xFD, 0x41)
#define REG_SC_BKFD_42_L      _PK_L_(0xFD, 0x42)
#define REG_SC_BKFD_42_H      _PK_H_(0xFD, 0x42)
#define REG_SC_BKFD_43_L      _PK_L_(0xFD, 0x43)
#define REG_SC_BKFD_43_H      _PK_H_(0xFD, 0x43)
#define REG_SC_BKFD_44_L      _PK_L_(0xFD, 0x44)
#define REG_SC_BKFD_44_H      _PK_H_(0xFD, 0x44)
#define REG_SC_BKFD_7E_L      _PK_L_(0xFD, 0x7E)
#define REG_SC_BKFD_7E_H      _PK_H_(0xFD, 0x7E)
#define REG_SC_BKFD_7F_L      _PK_L_(0xFD, 0x7F)
#define REG_SC_BKFD_7F_H      _PK_H_(0xFD, 0x7F)
//----------------------------------------------
//  BKFE: IP1_TOP_WP6
//----------------------------------------------
#define REG_SC_BKFE_00_L      _PK_L_(0xFE, 0x00)
#define REG_SC_BKFE_00_H      _PK_H_(0xFE, 0x00)
#define REG_SC_BKFE_01_L      _PK_L_(0xFE, 0x01)
#define REG_SC_BKFE_01_H      _PK_H_(0xFE, 0x01)
#define REG_SC_BKFE_02_L      _PK_L_(0xFE, 0x02)
#define REG_SC_BKFE_02_H      _PK_H_(0xFE, 0x02)
#define REG_SC_BKFE_03_L      _PK_L_(0xFE, 0x03)
#define REG_SC_BKFE_03_H      _PK_H_(0xFE, 0x03)
#define REG_SC_BKFE_04_L      _PK_L_(0xFE, 0x04)
#define REG_SC_BKFE_04_H      _PK_H_(0xFE, 0x04)
#define REG_SC_BKFE_1A_L      _PK_L_(0xFE, 0x1A)
#define REG_SC_BKFE_1A_H      _PK_H_(0xFE, 0x1A)
#define REG_SC_BKFE_20_L      _PK_L_(0xFE, 0x20)
#define REG_SC_BKFE_20_H      _PK_H_(0xFE, 0x20)
#define REG_SC_BKFE_21_L      _PK_L_(0xFE, 0x21)
#define REG_SC_BKFE_21_H      _PK_H_(0xFE, 0x21)
#define REG_SC_BKFE_40_L      _PK_L_(0xFE, 0x40)
#define REG_SC_BKFE_40_H      _PK_H_(0xFE, 0x40)
#define REG_SC_BKFE_41_L      _PK_L_(0xFE, 0x41)
#define REG_SC_BKFE_41_H      _PK_H_(0xFE, 0x41)
#define REG_SC_BKFE_42_L      _PK_L_(0xFE, 0x42)
#define REG_SC_BKFE_42_H      _PK_H_(0xFE, 0x42)
#define REG_SC_BKFE_43_L      _PK_L_(0xFE, 0x43)
#define REG_SC_BKFE_43_H      _PK_H_(0xFE, 0x43)
#define REG_SC_BKFE_44_L      _PK_L_(0xFE, 0x44)
#define REG_SC_BKFE_44_H      _PK_H_(0xFE, 0x44)
#define REG_SC_BKFE_7E_L      _PK_L_(0xFE, 0x7E)
#define REG_SC_BKFE_7E_H      _PK_H_(0xFE, 0x7E)
#define REG_SC_BKFE_7F_L      _PK_L_(0xFE, 0x7F)
#define REG_SC_BKFE_7F_H      _PK_H_(0xFE, 0x7F)

//----------------------------------------------
//  BK3300:
//----------------------------------------------
#define REG_SC_EXT_BK00_10_L    _PK_L_ (0x00, 0x10)
#define REG_SC_EXT_BK00_11_L    _PK_L_ (0x00, 0x11)
#define REG_SC_EXT_BK00_12_L    _PK_L_ (0x00, 0x12)
#define REG_SC_EXT_BK00_13_L    _PK_L_ (0x00, 0x13)
#define REG_SC_EXT_BK00_14_L    _PK_L_ (0x00, 0x14)
#define REG_SC_EXT_BK00_15_L    _PK_L_ (0x00, 0x15)

#define REG_SC_EXT_BK0C_03_L      _PK_L_(0x0C, 0x03)
#define REG_SC_EXT_BK0C_04_L      _PK_L_(0x0C, 0x04)
#define REG_SC_EXT_BK0C_05_L      _PK_L_(0x0C, 0x05)
#define REG_SC_EXT_BK0C_06_L      _PK_L_(0x0C, 0x06)

#define REG_SC_EXT_BK0D_50_L      _PK_L_(0x0D, 0x50)
#define REG_SC_EXT_BK0D_50_H      _PK_H_(0x0D, 0x50)

#define REG_SC_EXT_BK2F_01_L      _PK_L_(0x2F, 0x01)
#define REG_SC_EXT_BK2F_01_H      _PK_H_(0x2F, 0x01)
#define REG_SC_EXT_BK2F_20_L      _PK_L_(0x2F, 0x20)
#define REG_SC_EXT_BK2F_20_H      _PK_H_(0x2F, 0x20)

#define REG_SC_EXT_BKDF_18_L      _PK_L_(0xDF, 0x18)
#define REG_SC_EXT_BKDF_19_L      _PK_L_(0xDF, 0x19)
#define REG_SC_EXT_BKDF_1A_L      _PK_L_(0xDF, 0x1A)
#define REG_SC_EXT_BKDF_1B_L      _PK_L_(0xDF, 0x1B)
#define REG_SC_EXT_BKDF_1C_L      _PK_L_(0xDF, 0x1C)
#define REG_SC_EXT_BKDF_1D_L      _PK_L_(0xDF, 0x1D)
#define REG_SC_EXT_BKDF_20_L      _PK_L_(0xDF, 0x20)
#define REG_SC_EXT_BKDF_21_L      _PK_L_(0xDF, 0x21)

#define REG_SC_EXT_BKE0_00_L      _PK_L_(0xE0, 0x00)
#define REG_SC_EXT_BKE0_01_L      _PK_L_(0xE0, 0x01)
#define REG_SC_EXT_BKE0_02_L      _PK_L_(0xE0, 0x02)
#define REG_SC_EXT_BKE0_03_L      _PK_L_(0xE0, 0x03)

#define REG_SC_EXT_BKE1_00_L      _PK_L_(0xE1, 0x00)
#define REG_SC_EXT_BKE1_01_L      _PK_L_(0xE1, 0x01)
#define REG_SC_EXT_BKE1_02_L      _PK_L_(0xE1, 0x02)
#define REG_SC_EXT_BKE1_03_L      _PK_L_(0xE1, 0x03)

#define REG_SC_EXT_BK0F_01_L    _PK_L_(0x0F, 0x01)
#define REG_SC_EXT_BK0F_01_H    _PK_H_(0x0F, 0x01)
#define REG_SC_EXT_BK0F_20_L    _PK_L_(0x0F, 0x20)
#define REG_SC_EXT_BK0F_20_H    _PK_H_(0x0F, 0x20)
#define REG_SC_EXT_BK0F_28_L    _PK_L_(0x0F, 0x28)
#define REG_SC_EXT_BK0F_28_H    _PK_H_(0x0F, 0x28)
#define REG_SC_EXT_BK0F_30_L    _PK_L_(0x0F, 0x30)
#define REG_SC_EXT_BK0F_30_H    _PK_H_(0x0F, 0x30)
#define REG_SC_EXT_BK0F_38_L    _PK_L_(0x0F, 0x38)
#define REG_SC_EXT_BK0F_38_H    _PK_H_(0x0F, 0x38)
#define REG_SC_EXT_BK4B_1A_L    _PK_L_(0x4B, 0x1A)
#define REG_SC_EXT_BK4B_1A_H    _PK_H_(0x4B, 0x1A)
#define REG_SC_EXT_BK4C_0C_L    _PK_L_(0x4C, 0x0C)
#define REG_SC_EXT_BK4C_0D_L    _PK_L_(0x4C, 0x0D)
#define REG_SC_EXT_BK4C_0E_L    _PK_L_(0x4C, 0x0E)
#define REG_SC_EXT_BK4C_0F_L    _PK_L_(0x4C, 0x0F)
#define REG_SC_EXT_BK4C_10_L    _PK_L_(0x4C, 0x10)
#define REG_SC_EXT_BK4C_11_L    _PK_L_(0x4C, 0x11)
#define REG_SC_EXT_BK4C_12_L    _PK_L_(0x4C, 0x12)
#define REG_SC_EXT_BK4C_13_L    _PK_L_(0x4C, 0x13)
#define REG_SC_EXT_BK4C_14_L    _PK_L_(0x4C, 0x14)
#define REG_SC_EXT_BK4C_15_L    _PK_L_(0x4C, 0x15)
#define REG_SC_EXT_BK4C_16_L    _PK_L_(0x4C, 0x16)
#define REG_SC_EXT_BK4C_17_L    _PK_L_(0x4C, 0x17)
#define REG_SC_EXT_BK4C_18_L    _PK_L_(0x4C, 0x18)
#define REG_SC_EXT_BK4C_19_L    _PK_L_(0x4C, 0x19)
#define REG_SC_EXT_BK4C_1A_L    _PK_L_(0x4C, 0x1A)
#define REG_SC_EXT_BK4C_1B_L    _PK_L_(0x4C, 0x1B)
#define REG_SC_EXT_BK4C_1C_L    _PK_L_(0x4C, 0x1C)
#define REG_SC_EXT_BK4C_1D_L    _PK_L_(0x4C, 0x1D)
#define REG_SC_EXT_BK4C_1E_L    _PK_L_(0x4C, 0x1E)
#define REG_SC_EXT_BK4C_1F_L    _PK_L_(0x4C, 0x1F)

#define REG_SC_EXT_BK4D_01_L    _PK_L_(0x4D, 0x01)
#define REG_SC_EXT_BK4D_20_L    _PK_L_(0x4D, 0x20)
#define REG_SC_EXT_BK4D_21_L    _PK_L_(0x4D, 0x21)
#define REG_SC_EXT_BK4D_22_L    _PK_L_(0x4D, 0x22)
#define REG_SC_EXT_BK4D_23_L    _PK_L_(0x4D, 0x23)
#define REG_SC_EXT_BK4D_24_L    _PK_L_(0x4D, 0x24)
#define REG_SC_EXT_BK4D_25_L    _PK_L_(0x4D, 0x25)
#define REG_SC_EXT_BK4D_26_L    _PK_L_(0x4D, 0x26)
#define REG_SC_EXT_BK4D_27_L    _PK_L_(0x4D, 0x27)
#define REG_SC_EXT_BK4D_28_L    _PK_L_(0x4D, 0x28)
#define REG_SC_EXT_BK4D_29_L    _PK_L_(0x4D, 0x29)
#define REG_SC_EXT_BK4D_2A_L    _PK_L_(0x4D, 0x2A)
#define REG_SC_EXT_BK4D_2B_L    _PK_L_(0x4D, 0x2B)
#define REG_SC_EXT_BK4D_2C_L    _PK_L_(0x4D, 0x2C)
#define REG_SC_EXT_BK4D_2D_L    _PK_L_(0x4D, 0x2D)
#define REG_SC_EXT_BK4D_2E_L    _PK_L_(0x4D, 0x2E)
#define REG_SC_EXT_BK4D_2F_L    _PK_L_(0x4D, 0x2F)
#define REG_SC_EXT_BK4D_30_L    _PK_L_(0x4D, 0x30)
#define REG_SC_EXT_BK4D_31_L    _PK_L_(0x4D, 0x31)
#define REG_SC_EXT_BK4D_32_L    _PK_L_(0x4D, 0x32)
#define REG_SC_EXT_BK4D_33_L    _PK_L_(0x4D, 0x33)
#define REG_SC_EXT_BK4D_34_L    _PK_L_(0x4D, 0x34)
#define REG_SC_EXT_BK4D_35_L    _PK_L_(0x4D, 0x35)
#define REG_SC_EXT_BK4D_36_L    _PK_L_(0x4D, 0x36)
#define REG_SC_EXT_BK4D_37_L    _PK_L_(0x4D, 0x37)
#define REG_SC_EXT_BK4D_38_L    _PK_L_(0x4D, 0x38)
#define REG_SC_EXT_BK4D_39_L    _PK_L_(0x4D, 0x39)
#define REG_SC_EXT_BK4D_3A_L    _PK_L_(0x4D, 0x3A)
#define REG_SC_EXT_BK4D_3B_L    _PK_L_(0x4D, 0x3B)
#define REG_SC_EXT_BK4D_3C_L    _PK_L_(0x4D, 0x3C)
#define REG_SC_EXT_BK4D_3D_L    _PK_L_(0x4D, 0x3D)
#define REG_SC_EXT_BK4D_3E_L    _PK_L_(0x4D, 0x3E)
#define REG_SC_EXT_BK4D_3F_L    _PK_L_(0x4D, 0x3F)
#define REG_SC_EXT_BK4D_40_L    _PK_L_(0x4D, 0x40)
#define REG_SC_EXT_BK4D_41_L    _PK_L_(0x4D, 0x41)
#define REG_SC_EXT_BK4D_42_L    _PK_L_(0x4D, 0x42)
#define REG_SC_EXT_BK4D_43_L    _PK_L_(0x4D, 0x43)
#define REG_SC_EXT_BK4D_44_L    _PK_L_(0x4D, 0x44)
#define REG_SC_EXT_BK4D_45_L    _PK_L_(0x4D, 0x45)
#define REG_SC_EXT_BK4D_46_L    _PK_L_(0x4D, 0x46)
#define REG_SC_EXT_BK4D_47_L    _PK_L_(0x4D, 0x47)
#define REG_SC_EXT_BK4D_48_L    _PK_L_(0x4D, 0x48)
#define REG_SC_EXT_BK4D_49_L    _PK_L_(0x4D, 0x49)
#define REG_SC_EXT_BK4D_4A_L    _PK_L_(0x4D, 0x4A)
#define REG_SC_EXT_BK4D_4B_L    _PK_L_(0x4D, 0x4B)
#define REG_SC_EXT_BK4D_4C_L    _PK_L_(0x4D, 0x4C)
#define REG_SC_EXT_BK4D_4D_L    _PK_L_(0x4D, 0x4D)
#define REG_SC_EXT_BK4D_4E_L    _PK_L_(0x4D, 0x4E)
#define REG_SC_EXT_BK4D_4F_L    _PK_L_(0x4D, 0x4F)
#define REG_SC_EXT_BK4D_50_L    _PK_L_(0x4D, 0x50)
#define REG_SC_EXT_BK4D_51_L    _PK_L_(0x4D, 0x51)
#define REG_SC_EXT_BK4D_52_L    _PK_L_(0x4D, 0x52)
#define REG_SC_EXT_BK4D_53_L    _PK_L_(0x4D, 0x53)
#define REG_SC_EXT_BK4D_54_L    _PK_L_(0x4D, 0x54)
#define REG_SC_EXT_BK4D_55_L    _PK_L_(0x4D, 0x55)
#define REG_SC_EXT_BK4D_56_L    _PK_L_(0x4D, 0x56)
#define REG_SC_EXT_BK4D_57_L    _PK_L_(0x4D, 0x57)
#define REG_SC_EXT_BK4D_58_L    _PK_L_(0x4D, 0x58)
#define REG_SC_EXT_BK4D_59_L    _PK_L_(0x4D, 0x59)
#define REG_SC_EXT_BK4D_5A_L    _PK_L_(0x4D, 0x5A)
#define REG_SC_EXT_BK4D_5B_L    _PK_L_(0x4D, 0x5B)
#define REG_SC_EXT_BK4D_5C_L    _PK_L_(0x4D, 0x5C)
#define REG_SC_EXT_BK4D_5D_L    _PK_L_(0x4D, 0x5D)
#define REG_SC_EXT_BK4D_5E_L    _PK_L_(0x4D, 0x5E)
#define REG_SC_EXT_BK4D_5F_L    _PK_L_(0x4D, 0x5F)
#define REG_SC_EXT_BK4D_60_L    _PK_L_(0x4D, 0x60)
#define REG_SC_EXT_BK4D_61_L    _PK_L_(0x4D, 0x61)
#define REG_SC_EXT_BK4D_62_L    _PK_L_(0x4D, 0x62)
#define REG_SC_EXT_BK4D_63_L    _PK_L_(0x4D, 0x63)
#define REG_SC_EXT_BK4D_64_L    _PK_L_(0x4D, 0x64)
#define REG_SC_EXT_BK4D_65_L    _PK_L_(0x4D, 0x65)
#define REG_SC_EXT_BK4D_66_L    _PK_L_(0x4D, 0x66)
#define REG_SC_EXT_BK4D_67_L    _PK_L_(0x4D, 0x67)
#define REG_SC_EXT_BK4D_68_L    _PK_L_(0x4D, 0x68)
#define REG_SC_EXT_BK4D_69_L    _PK_L_(0x4D, 0x69)
#define REG_SC_EXT_BK4D_6A_L    _PK_L_(0x4D, 0x6A)
#define REG_SC_EXT_BK4D_6B_L    _PK_L_(0x4D, 0x6B)
#define REG_SC_EXT_BK4D_6C_L    _PK_L_(0x4D, 0x6C)
#define REG_SC_EXT_BK4D_6D_L    _PK_L_(0x4D, 0x6D)
#define REG_SC_EXT_BK4D_6E_L    _PK_L_(0x4D, 0x6E)
#define REG_SC_EXT_BK4D_6F_L    _PK_L_(0x4D, 0x6F)

#define REG_SC_EXT_BK4E_0C_L    _PK_L_(0x4E, 0x0C)
#define REG_SC_EXT_BK4E_0D_L    _PK_L_(0x4E, 0x0D)
#define REG_SC_EXT_BK4E_0E_L    _PK_L_(0x4E, 0x0E)
#define REG_SC_EXT_BK4E_0F_L    _PK_L_(0x4E, 0x0F)
#define REG_SC_EXT_BK4E_10_L    _PK_L_(0x4E, 0x10)
#define REG_SC_EXT_BK4E_11_L    _PK_L_(0x4E, 0x11)
#define REG_SC_EXT_BK4E_12_L    _PK_L_(0x4E, 0x12)
#define REG_SC_EXT_BK4E_13_L    _PK_L_(0x4E, 0x13)
#define REG_SC_EXT_BK4E_14_L    _PK_L_(0x4E, 0x14)
#define REG_SC_EXT_BK4E_15_L    _PK_L_(0x4E, 0x15)
#define REG_SC_EXT_BK4E_16_L    _PK_L_(0x4E, 0x16)
#define REG_SC_EXT_BK4E_17_L    _PK_L_(0x4E, 0x17)
#define REG_SC_EXT_BK4E_18_L    _PK_L_(0x4E, 0x18)
#define REG_SC_EXT_BK4E_19_L    _PK_L_(0x4E, 0x19)
#define REG_SC_EXT_BK4E_1A_L    _PK_L_(0x4E, 0x1A)
#define REG_SC_EXT_BK4E_1B_L    _PK_L_(0x4E, 0x1B)
#define REG_SC_EXT_BK4E_1C_L    _PK_L_(0x4E, 0x1C)
#define REG_SC_EXT_BK4E_1D_L    _PK_L_(0x4E, 0x1D)
#define REG_SC_EXT_BK4E_1E_L    _PK_L_(0x4E, 0x1E)
#define REG_SC_EXT_BK4E_1F_L    _PK_L_(0x4E, 0x1F)

#define REG_SC_EXT_BK4F_01_L    _PK_L_(0x4F, 0x01)
#define REG_SC_EXT_BK4F_08_L    _PK_L_(0x4F, 0x08)
#define REG_SC_EXT_BK4F_09_L    _PK_L_(0x4F, 0x09)
#define REG_SC_EXT_BK4F_20_L    _PK_L_(0x4F, 0x20)
#define REG_SC_EXT_BK4F_21_L    _PK_L_(0x4F, 0x21)
#define REG_SC_EXT_BK4F_22_L    _PK_L_(0x4F, 0x22)
#define REG_SC_EXT_BK4F_23_L    _PK_L_(0x4F, 0x23)
#define REG_SC_EXT_BK4F_24_L    _PK_L_(0x4F, 0x24)
#define REG_SC_EXT_BK4F_25_L    _PK_L_(0x4F, 0x25)
#define REG_SC_EXT_BK4F_26_L    _PK_L_(0x4F, 0x26)
#define REG_SC_EXT_BK4F_27_L    _PK_L_(0x4F, 0x27)
#define REG_SC_EXT_BK4F_28_L    _PK_L_(0x4F, 0x28)
#define REG_SC_EXT_BK4F_29_L    _PK_L_(0x4F, 0x29)
#define REG_SC_EXT_BK4F_2A_L    _PK_L_(0x4F, 0x2A)
#define REG_SC_EXT_BK4F_2B_L    _PK_L_(0x4F, 0x2B)
#define REG_SC_EXT_BK4F_2C_L    _PK_L_(0x4F, 0x2C)
#define REG_SC_EXT_BK4F_2D_L    _PK_L_(0x4F, 0x2D)
#define REG_SC_EXT_BK4F_2E_L    _PK_L_(0x4F, 0x2E)
#define REG_SC_EXT_BK4F_2F_L    _PK_L_(0x4F, 0x2F)
#define REG_SC_EXT_BK4F_30_L    _PK_L_(0x4F, 0x30)
#define REG_SC_EXT_BK4F_31_L    _PK_L_(0x4F, 0x31)
#define REG_SC_EXT_BK4F_32_L    _PK_L_(0x4F, 0x32)
#define REG_SC_EXT_BK4F_33_L    _PK_L_(0x4F, 0x33)
#define REG_SC_EXT_BK4F_34_L    _PK_L_(0x4F, 0x34)
#define REG_SC_EXT_BK4F_35_L    _PK_L_(0x4F, 0x35)
#define REG_SC_EXT_BK4F_36_L    _PK_L_(0x4F, 0x36)
#define REG_SC_EXT_BK4F_37_L    _PK_L_(0x4F, 0x37)
#define REG_SC_EXT_BK4F_38_L    _PK_L_(0x4F, 0x38)
#define REG_SC_EXT_BK4F_39_L    _PK_L_(0x4F, 0x39)
#define REG_SC_EXT_BK4F_3A_L    _PK_L_(0x4F, 0x3A)
#define REG_SC_EXT_BK4F_3B_L    _PK_L_(0x4F, 0x3B)
#define REG_SC_EXT_BK4F_3C_L    _PK_L_(0x4F, 0x3C)
#define REG_SC_EXT_BK4F_3D_L    _PK_L_(0x4F, 0x3D)
#define REG_SC_EXT_BK4F_3E_L    _PK_L_(0x4F, 0x3E)
#define REG_SC_EXT_BK4F_3F_L    _PK_L_(0x4F, 0x3F)
#define REG_SC_EXT_BK4F_40_L    _PK_L_(0x4F, 0x40)
#define REG_SC_EXT_BK4F_41_L    _PK_L_(0x4F, 0x41)
#define REG_SC_EXT_BK4F_42_L    _PK_L_(0x4F, 0x42)
#define REG_SC_EXT_BK4F_43_L    _PK_L_(0x4F, 0x43)
#define REG_SC_EXT_BK4F_44_L    _PK_L_(0x4F, 0x44)
#define REG_SC_EXT_BK4F_45_L    _PK_L_(0x4F, 0x45)
#define REG_SC_EXT_BK4F_46_L    _PK_L_(0x4F, 0x46)
#define REG_SC_EXT_BK4F_47_L    _PK_L_(0x4F, 0x47)
#define REG_SC_EXT_BK4F_48_L    _PK_L_(0x4F, 0x48)
#define REG_SC_EXT_BK4F_49_L    _PK_L_(0x4F, 0x49)
#define REG_SC_EXT_BK4F_4A_L    _PK_L_(0x4F, 0x4A)
#define REG_SC_EXT_BK4F_4B_L    _PK_L_(0x4F, 0x4B)
#define REG_SC_EXT_BK4F_4C_L    _PK_L_(0x4F, 0x4C)
#define REG_SC_EXT_BK4F_4D_L    _PK_L_(0x4F, 0x4D)
#define REG_SC_EXT_BK4F_4E_L    _PK_L_(0x4F, 0x4E)
#define REG_SC_EXT_BK4F_4F_L    _PK_L_(0x4F, 0x4F)
#define REG_SC_EXT_BK4F_50_L    _PK_L_(0x4F, 0x50)
#define REG_SC_EXT_BK4F_51_L    _PK_L_(0x4F, 0x51)
#define REG_SC_EXT_BK4F_52_L    _PK_L_(0x4F, 0x52)
#define REG_SC_EXT_BK4F_53_L    _PK_L_(0x4F, 0x53)
#define REG_SC_EXT_BK4F_54_L    _PK_L_(0x4F, 0x54)
#define REG_SC_EXT_BK4F_55_L    _PK_L_(0x4F, 0x55)
#define REG_SC_EXT_BK4F_56_L    _PK_L_(0x4F, 0x56)
#define REG_SC_EXT_BK4F_57_L    _PK_L_(0x4F, 0x57)
#define REG_SC_EXT_BK4F_58_L    _PK_L_(0x4F, 0x58)
#define REG_SC_EXT_BK4F_59_L    _PK_L_(0x4F, 0x59)
#define REG_SC_EXT_BK4F_5A_L    _PK_L_(0x4F, 0x5A)
#define REG_SC_EXT_BK4F_5B_L    _PK_L_(0x4F, 0x5B)
#define REG_SC_EXT_BK4F_5C_L    _PK_L_(0x4F, 0x5C)
#define REG_SC_EXT_BK4F_5D_L    _PK_L_(0x4F, 0x5D)
#define REG_SC_EXT_BK4F_5E_L    _PK_L_(0x4F, 0x5E)
#define REG_SC_EXT_BK4F_5F_L    _PK_L_(0x4F, 0x5F)
#define REG_SC_EXT_BK4F_60_L    _PK_L_(0x4F, 0x60)
#define REG_SC_EXT_BK4F_61_L    _PK_L_(0x4F, 0x61)
#define REG_SC_EXT_BK4F_62_L    _PK_L_(0x4F, 0x62)
#define REG_SC_EXT_BK4F_63_L    _PK_L_(0x4F, 0x63)
#define REG_SC_EXT_BK4F_64_L    _PK_L_(0x4F, 0x64)
#define REG_SC_EXT_BK4F_65_L    _PK_L_(0x4F, 0x65)
#define REG_SC_EXT_BK4F_66_L    _PK_L_(0x4F, 0x66)
#define REG_SC_EXT_BK4F_67_L    _PK_L_(0x4F, 0x67)
#define REG_SC_EXT_BK4F_68_L    _PK_L_(0x4F, 0x68)
#define REG_SC_EXT_BK4F_69_L    _PK_L_(0x4F, 0x69)
#define REG_SC_EXT_BK4F_6A_L    _PK_L_(0x4F, 0x6A)
#define REG_SC_EXT_BK4F_6B_L    _PK_L_(0x4F, 0x6B)
#define REG_SC_EXT_BK4F_6C_L    _PK_L_(0x4F, 0x6C)
#define REG_SC_EXT_BK4F_6D_L    _PK_L_(0x4F, 0x6D)
#define REG_SC_EXT_BK4F_6E_L    _PK_L_(0x4F, 0x6E)
#define REG_SC_EXT_BK4F_6F_L    _PK_L_(0x4F, 0x6F)

#define REG_SC_EXT_BK50_03_L      _PK_L_(0x50, 0x03)
#define REG_SC_EXT_BK50_03_H      _PK_H_(0x50, 0x03)

#define REG_SC_EXT_BK54_01_L      _PK_L_(0x54, 0x01)
#define REG_SC_EXT_BK54_01_H      _PK_H_(0x54, 0x01)
#define REG_SC_EXT_BK54_02_L      _PK_L_(0x54, 0x02)
#define REG_SC_EXT_BK54_02_H      _PK_H_(0x54, 0x02)
#define REG_SC_EXT_BK54_03_L      _PK_L_(0x54, 0x03)
#define REG_SC_EXT_BK54_03_H      _PK_H_(0x54, 0x03)
#define REG_SC_EXT_BK54_04_L      _PK_L_(0x54, 0x04)
#define REG_SC_EXT_BK54_04_H      _PK_H_(0x54, 0x04)

#define REG_SC_EXT_BK55_01_L      _PK_L_(0x55, 0x01)
#define REG_SC_EXT_BK55_01_H      _PK_H_(0x55, 0x01)
#define REG_SC_EXT_BK55_02_L      _PK_L_(0x55, 0x02)
#define REG_SC_EXT_BK55_02_H      _PK_H_(0x55, 0x02)
#define REG_SC_EXT_BK55_03_L      _PK_L_(0x55, 0x03)
#define REG_SC_EXT_BK55_03_H      _PK_H_(0x55, 0x03)
#define REG_SC_EXT_BK55_04_L      _PK_L_(0x55, 0x04)
#define REG_SC_EXT_BK55_04_H      _PK_H_(0x55, 0x04)

#define REG_SC_EXT_BK56_04_L      _PK_L_(0x56, 0x04)
#define REG_SC_EXT_BK56_04_H      _PK_H_(0x56, 0x04)
#define REG_SC_EXT_BK56_08_L      _PK_L_(0x56, 0x08)
#define REG_SC_EXT_BK56_08_H      _PK_H_(0x56, 0x08)
#define REG_SC_EXT_BK56_09_L      _PK_L_(0x56, 0x09)
#define REG_SC_EXT_BK56_09_H      _PK_H_(0x56, 0x09)
#define REG_SC_EXT_BK56_11_L      _PK_L_(0x56, 0x11)
#define REG_SC_EXT_BK56_11_H      _PK_H_(0x56, 0x11)
#define REG_SC_EXT_BK56_13_L      _PK_L_(0x56, 0x13)
#define REG_SC_EXT_BK56_13_H      _PK_H_(0x56, 0x13)
#define REG_SC_EXT_BK56_21_L      _PK_L_(0x56, 0x21)
#define REG_SC_EXT_BK56_21_H      _PK_H_(0x56, 0x21)
#define REG_SC_EXT_BK56_22_L      _PK_L_(0x56, 0x22)
#define REG_SC_EXT_BK56_22_H      _PK_H_(0x56, 0x22)
#define REG_SC_EXT_BK56_28_L      _PK_L_(0x56, 0x28)
#define REG_SC_EXT_BK56_28_H      _PK_H_(0x56, 0x28)
#define REG_SC_EXT_BK56_29_L      _PK_L_(0x56, 0x29)
#define REG_SC_EXT_BK56_29_H      _PK_H_(0x56, 0x29)
#define REG_SC_EXT_BK56_7E_L      _PK_L_(0x56, 0x7E)
#define REG_SC_EXT_BK56_7E_H      _PK_H_(0x56, 0x7E)

#define REG_SC_EXT_BK57_01_L      _PK_L_(0x57, 0x01)
#define REG_SC_EXT_BK57_01_H      _PK_H_(0x57, 0x01)
#define REG_SC_EXT_BK57_02_L      _PK_L_(0x57, 0x02)
#define REG_SC_EXT_BK57_02_H      _PK_H_(0x57, 0x02)
#define REG_SC_EXT_BK57_03_L      _PK_L_(0x57, 0x03)
#define REG_SC_EXT_BK57_03_H      _PK_H_(0x57, 0x03)
#define REG_SC_EXT_BK57_06_L      _PK_L_(0x57, 0x06)
#define REG_SC_EXT_BK57_06_H      _PK_H_(0x57, 0x06)
#define REG_SC_EXT_BK57_07_L      _PK_L_(0x57, 0x07)
#define REG_SC_EXT_BK57_07_H      _PK_H_(0x57, 0x07)
#define REG_SC_EXT_BK57_0F_L      _PK_L_(0x57, 0x0F)
#define REG_SC_EXT_BK57_0F_H      _PK_H_(0x57, 0x0F)
#define REG_SC_EXT_BK57_10_L      _PK_L_(0x57, 0x10)
#define REG_SC_EXT_BK57_10_H      _PK_H_(0x57, 0x10)
#define REG_SC_EXT_BK57_11_L      _PK_L_(0x57, 0x11)
#define REG_SC_EXT_BK57_11_H      _PK_H_(0x57, 0x11)
#define REG_SC_EXT_BK57_7E_L      _PK_L_(0x57, 0x7E)
#define REG_SC_EXT_BK57_7E_H      _PK_H_(0x57, 0x7E)

#define REG_SC_EXT_BK58_01_L      _PK_L_(0x58, 0x01)
#define REG_SC_EXT_BK58_01_H      _PK_H_(0x58, 0x01)
#define REG_SC_EXT_BK58_02_L      _PK_L_(0x58, 0x02)
#define REG_SC_EXT_BK58_02_H      _PK_H_(0x58, 0x02)
#define REG_SC_EXT_BK58_03_L      _PK_L_(0x58, 0x03)
#define REG_SC_EXT_BK58_03_H      _PK_H_(0x58, 0x03)
#define REG_SC_EXT_BK58_06_L      _PK_L_(0x58, 0x06)
#define REG_SC_EXT_BK58_06_H      _PK_H_(0x58, 0x06)
#define REG_SC_EXT_BK58_07_L      _PK_L_(0x58, 0x07)
#define REG_SC_EXT_BK58_07_H      _PK_H_(0x58, 0x07)
#define REG_SC_EXT_BK58_0F_L      _PK_L_(0x58, 0x0F)
#define REG_SC_EXT_BK58_0F_H      _PK_H_(0x58, 0x0F)
#define REG_SC_EXT_BK58_20_L      _PK_L_(0x58, 0x20)
#define REG_SC_EXT_BK58_20_H      _PK_H_(0x58, 0x20)
#define REG_SC_EXT_BK58_10_L      _PK_L_(0x58, 0x10)
#define REG_SC_EXT_BK58_10_H      _PK_H_(0x58, 0x10)
#define REG_SC_EXT_BK58_11_L      _PK_L_(0x58, 0x11)
#define REG_SC_EXT_BK58_11_H      _PK_H_(0x58, 0x11)
#define REG_SC_EXT_BK58_7E_L      _PK_L_(0x58, 0x7E)
#define REG_SC_EXT_BK58_7E_H      _PK_H_(0x58, 0x7E)

#define REG_SC_EXT_BK59_04_L      _PK_L_(0x59, 0x04)
#define REG_SC_EXT_BK59_04_H      _PK_H_(0x59, 0x04)
#define REG_SC_EXT_BK59_08_L      _PK_L_(0x59, 0x08)
#define REG_SC_EXT_BK59_08_H      _PK_H_(0x59, 0x08)
#define REG_SC_EXT_BK59_09_L      _PK_L_(0x59, 0x09)
#define REG_SC_EXT_BK59_09_H      _PK_H_(0x59, 0x09)
#define REG_SC_EXT_BK59_11_L      _PK_L_(0x59, 0x11)
#define REG_SC_EXT_BK59_11_H      _PK_H_(0x59, 0x11)
#define REG_SC_EXT_BK59_13_L      _PK_L_(0x59, 0x13)
#define REG_SC_EXT_BK59_13_H      _PK_H_(0x59, 0x13)
#define REG_SC_EXT_BK59_21_L      _PK_L_(0x59, 0x21)
#define REG_SC_EXT_BK59_21_H      _PK_H_(0x59, 0x21)
#define REG_SC_EXT_BK59_22_L      _PK_L_(0x59, 0x22)
#define REG_SC_EXT_BK59_22_H      _PK_H_(0x59, 0x22)
#define REG_SC_EXT_BK59_28_L      _PK_L_(0x59, 0x28)
#define REG_SC_EXT_BK59_28_H      _PK_H_(0x59, 0x28)
#define REG_SC_EXT_BK59_7E_L      _PK_L_(0x59, 0x7E)
#define REG_SC_EXT_BK59_7E_H      _PK_H_(0x59, 0x7E)

#define REG_SC_EXT_BK5A_01_L      _PK_L_(0x5A, 0x01)
#define REG_SC_EXT_BK5A_01_H      _PK_H_(0x5A, 0x01)
#define REG_SC_EXT_BK5A_02_L      _PK_L_(0x5A, 0x02)
#define REG_SC_EXT_BK5A_02_H      _PK_H_(0x5A, 0x02)
#define REG_SC_EXT_BK5A_03_L      _PK_L_(0x5A, 0x03)
#define REG_SC_EXT_BK5A_03_H      _PK_H_(0x5A, 0x03)
#define REG_SC_EXT_BK5A_06_L      _PK_L_(0x5A, 0x06)
#define REG_SC_EXT_BK5A_06_H      _PK_H_(0x5A, 0x06)
#define REG_SC_EXT_BK5A_07_L      _PK_L_(0x5A, 0x07)
#define REG_SC_EXT_BK5A_07_H      _PK_H_(0x5A, 0x07)
#define REG_SC_EXT_BK5A_0F_L      _PK_L_(0x5A, 0x0F)
#define REG_SC_EXT_BK5A_0F_H      _PK_H_(0x5A, 0x0F)
#define REG_SC_EXT_BK5A_10_L      _PK_L_(0x5A, 0x10)
#define REG_SC_EXT_BK5A_10_H      _PK_H_(0x5A, 0x10)
#define REG_SC_EXT_BK5A_11_L      _PK_L_(0x5A, 0x11)
#define REG_SC_EXT_BK5A_11_H      _PK_H_(0x5A, 0x11)
#define REG_SC_EXT_BK5A_7E_L      _PK_L_(0x5A, 0x7E)
#define REG_SC_EXT_BK5A_7E_H      _PK_H_(0x5A, 0x7E)

#define REG_SC_EXT_BK5B_01_L      _PK_L_(0x5B, 0x01)
#define REG_SC_EXT_BK5B_01_H      _PK_H_(0x5B, 0x01)
#define REG_SC_EXT_BK5B_02_L      _PK_L_(0x5B, 0x02)
#define REG_SC_EXT_BK5B_02_H      _PK_H_(0x5B, 0x02)
#define REG_SC_EXT_BK5B_03_L      _PK_L_(0x5B, 0x03)
#define REG_SC_EXT_BK5B_03_H      _PK_H_(0x5B, 0x03)
#define REG_SC_EXT_BK5B_06_L      _PK_L_(0x5B, 0x06)
#define REG_SC_EXT_BK5B_06_H      _PK_H_(0x5B, 0x06)
#define REG_SC_EXT_BK5B_07_L      _PK_L_(0x5B, 0x07)
#define REG_SC_EXT_BK5B_07_H      _PK_H_(0x5B, 0x07)
#define REG_SC_EXT_BK5B_0F_L      _PK_L_(0x5B, 0x0F)
#define REG_SC_EXT_BK5B_0F_H      _PK_H_(0x5B, 0x0F)
#define REG_SC_EXT_BK5B_10_L      _PK_L_(0x5B, 0x10)
#define REG_SC_EXT_BK5B_10_H      _PK_H_(0x5B, 0x10)
#define REG_SC_EXT_BK5B_11_L      _PK_L_(0x5B, 0x11)
#define REG_SC_EXT_BK5B_11_H      _PK_H_(0x5B, 0x11)
#define REG_SC_EXT_BK5B_20_L      _PK_L_(0x5B, 0x20)
#define REG_SC_EXT_BK5B_20_H      _PK_H_(0x5B, 0x20)
#define REG_SC_EXT_BK5B_7E_L      _PK_L_(0x5B, 0x7E)
#define REG_SC_EXT_BK5B_7E_H      _PK_H_(0x5B, 0x7E)

#define REG_SC_EXT_BK5D_04_L      _PK_L_(0x5D, 0x04)
#define REG_SC_EXT_BK5D_04_H      _PK_H_(0x5D, 0x04)
#define REG_SC_EXT_BK5D_05_L      _PK_L_(0x5D, 0x05)
#define REG_SC_EXT_BK5D_05_H      _PK_H_(0x5D, 0x05)
#define REG_SC_EXT_BK5D_06_L      _PK_L_(0x5D, 0x06)
#define REG_SC_EXT_BK5D_06_H      _PK_H_(0x5D, 0x06)
#define REG_SC_EXT_BK5D_07_L      _PK_L_(0x5D, 0x07)
#define REG_SC_EXT_BK5D_07_H      _PK_H_(0x5D, 0x07)

#define REG_SC_EXT_BK69_01_L      _PK_L_(0x69, 0x01)
#define REG_SC_EXT_BK69_01_H      _PK_H_(0x69, 0x01)
#define REG_SC_EXT_BK69_08_L      _PK_L_(0x69, 0x08)
#define REG_SC_EXT_BK69_08_H      _PK_H_(0x69, 0x08)
#define REG_SC_EXT_BK69_31_L      _PK_L_(0x69, 0x31)
#define REG_SC_EXT_BK69_31_H      _PK_H_(0x69, 0x31)
#define REG_SC_EXT_BK69_7F_L      _PK_L_(0x69, 0x7F)
#define REG_SC_EXT_BK69_7F_H      _PK_H_(0x69, 0x7F)

#define REG_SC_EXT_BK6B_01_L      _PK_L_(0x6B, 0x01)
#define REG_SC_EXT_BK6B_01_H      _PK_H_(0x6B, 0x01)

#define REG_SC_EXT_BK6B_02_L      _PK_L_(0x6B, 0x02)
#define REG_SC_EXT_BK6B_02_H      _PK_H_(0x6B, 0x02)

#define REG_SC_EXT_BK6B_03_L      _PK_L_(0x6B, 0x03)
#define REG_SC_EXT_BK6B_03_H      _PK_H_(0x6B, 0x03)

#define REG_SC_EXT_BK6B_04_L      _PK_L_(0x6B, 0x04)
#define REG_SC_EXT_BK6B_04_H      _PK_H_(0x6B, 0x04)

#define REG_SC_EXT_BK6B_73_L      _PK_L_(0x6B, 0x73)
#define REG_SC_EXT_BK6B_73_H      _PK_H_(0x6B, 0x73)

#define REG_SC_EXT_BK6B_7F_L      _PK_L_(0x6B, 0x7F)
#define REG_SC_EXT_BK6B_7F_H      _PK_H_(0x6B, 0x7F)

#define REG_SC_EXT_BK6D_01_L      _PK_L_(0x6D, 0x01)
#define REG_SC_EXT_BK6D_01_H      _PK_H_(0x6D, 0x01)

#define REG_SC_EXT_BK6D_52_L      _PK_L_(0x6D, 0x52)
#define REG_SC_EXT_BK6D_52_H      _PK_H_(0x6D, 0x52)

#define REG_SC_EXT_BK6D_54_L      _PK_L_(0x6D, 0x54)
#define REG_SC_EXT_BK6D_54_H      _PK_H_(0x6D, 0x54)

#define REG_SC_EXT_BK6D_59_L      _PK_L_(0x6D, 0x59)
#define REG_SC_EXT_BK6D_59_H      _PK_H_(0x6D, 0x59)

#define REG_SC_EXT_BK6D_5A_L      _PK_L_(0x6D, 0x5A)
#define REG_SC_EXT_BK6D_5A_H      _PK_H_(0x6D, 0x5A)

#define REG_SC_EXT_BK6D_76_L      _PK_L_(0x6D, 0x76)
#define REG_SC_EXT_BK6D_76_H      _PK_H_(0x6D, 0x76)
#define REG_SC_EXT_BK6D_77_L      _PK_L_(0x6D, 0x77)
#define REG_SC_EXT_BK6D_77_H      _PK_H_(0x6D, 0x77)

#define REG_SC_EXT_BK6D_7A_L      _PK_L_(0x6D, 0x7A)
#define REG_SC_EXT_BK6D_7A_H      _PK_H_(0x6D, 0x7A)
#define REG_SC_EXT_BK6D_7B_L      _PK_L_(0x6D, 0x7B)
#define REG_SC_EXT_BK6D_7B_H      _PK_H_(0x6D, 0x7B)

#define REG_SC_EXT_BK70_40_L      _PK_L_(0x70, 0x40)
#define REG_SC_EXT_BK70_40_H      _PK_H_(0x70, 0x40)
#define REG_SC_EXT_BK70_41_L      _PK_L_(0x70, 0x41)
#define REG_SC_EXT_BK70_41_H      _PK_H_(0x70, 0x41)
#define REG_SC_EXT_BK70_42_L      _PK_L_(0x70, 0x42)
#define REG_SC_EXT_BK70_42_H      _PK_H_(0x70, 0x42)
#define REG_SC_EXT_BK70_43_L      _PK_L_(0x70, 0x43)
#define REG_SC_EXT_BK70_43_H      _PK_H_(0x70, 0x43)
#define REG_SC_EXT_BK70_44_L      _PK_L_(0x70, 0x44)
#define REG_SC_EXT_BK70_44_H      _PK_H_(0x70, 0x44)
#define REG_SC_EXT_BK70_45_L      _PK_L_(0x70, 0x45)
#define REG_SC_EXT_BK70_45_H      _PK_H_(0x70, 0x45)
#define REG_SC_EXT_BK70_46_L      _PK_L_(0x70, 0x46)
#define REG_SC_EXT_BK70_46_H      _PK_H_(0x70, 0x46)
#define REG_SC_EXT_BK70_47_L      _PK_L_(0x70, 0x47)
#define REG_SC_EXT_BK70_47_H      _PK_H_(0x70, 0x47)
#define REG_SC_EXT_BK70_48_L      _PK_L_(0x70, 0x48)
#define REG_SC_EXT_BK70_48_H      _PK_H_(0x70, 0x48)
#define REG_SC_EXT_BK70_49_L      _PK_L_(0x70, 0x49)
#define REG_SC_EXT_BK70_49_H      _PK_H_(0x70, 0x49)
#define REG_SC_EXT_BK70_4A_L      _PK_L_(0x70, 0x4A)
#define REG_SC_EXT_BK70_4A_H      _PK_H_(0x70, 0x4A)
#define REG_SC_EXT_BK70_4B_L      _PK_L_(0x70, 0x4B)
#define REG_SC_EXT_BK70_4B_H      _PK_H_(0x70, 0x4B)
#define REG_SC_EXT_BK70_4C_L      _PK_L_(0x70, 0x4C)
#define REG_SC_EXT_BK70_4C_H      _PK_H_(0x70, 0x4C)
#define REG_SC_EXT_BK70_4D_L      _PK_L_(0x70, 0x4D)
#define REG_SC_EXT_BK70_4D_H      _PK_H_(0x70, 0x4D)
#define REG_SC_EXT_BK70_4E_L      _PK_L_(0x70, 0x4E)
#define REG_SC_EXT_BK70_4E_H      _PK_H_(0x70, 0x4E)
#define REG_SC_EXT_BK70_4F_L      _PK_L_(0x70, 0x4F)
#define REG_SC_EXT_BK70_4F_H      _PK_H_(0x70, 0x4F)
#define REG_SC_EXT_BK70_50_L      _PK_L_(0x70, 0x50)
#define REG_SC_EXT_BK70_50_H      _PK_H_(0x70, 0x50)
#define REG_SC_EXT_BK70_51_L      _PK_L_(0x70, 0x51)
#define REG_SC_EXT_BK70_51_H      _PK_H_(0x70, 0x51)
#define REG_SC_EXT_BK70_52_L      _PK_L_(0x70, 0x52)
#define REG_SC_EXT_BK70_52_H      _PK_H_(0x70, 0x52)
#define REG_SC_EXT_BK70_53_L      _PK_L_(0x70, 0x53)
#define REG_SC_EXT_BK70_53_H      _PK_H_(0x70, 0x53)
#define REG_SC_EXT_BK70_54_L      _PK_L_(0x70, 0x54)
#define REG_SC_EXT_BK70_54_H      _PK_H_(0x70, 0x54)
#define REG_SC_EXT_BK70_55_L      _PK_L_(0x70, 0x55)
#define REG_SC_EXT_BK70_55_H      _PK_H_(0x70, 0x55)
#define REG_SC_EXT_BK70_56_L      _PK_L_(0x70, 0x56)
#define REG_SC_EXT_BK70_56_H      _PK_H_(0x70, 0x56)
#define REG_SC_EXT_BK70_57_L      _PK_L_(0x70, 0x57)
#define REG_SC_EXT_BK70_57_H      _PK_H_(0x70, 0x57)
#define REG_SC_EXT_BK70_58_L      _PK_L_(0x70, 0x58)
#define REG_SC_EXT_BK70_58_H      _PK_H_(0x70, 0x58)
#define REG_SC_EXT_BK70_59_L      _PK_L_(0x70, 0x59)
#define REG_SC_EXT_BK70_59_H      _PK_H_(0x70, 0x59)
#define REG_SC_EXT_BK70_5A_L      _PK_L_(0x70, 0x5A)
#define REG_SC_EXT_BK70_5A_H      _PK_H_(0x70, 0x5A)
#define REG_SC_EXT_BK70_5B_L      _PK_L_(0x70, 0x5B)
#define REG_SC_EXT_BK70_5B_H      _PK_H_(0x70, 0x5B)
#define REG_SC_EXT_BK70_5C_L      _PK_L_(0x70, 0x5C)
#define REG_SC_EXT_BK70_5C_H      _PK_H_(0x70, 0x5C)

#define REG_SC_EXT_BK79_08_L      _PK_L_(0x79, 0x08)
#define REG_SC_EXT_BK79_08_H      _PK_H_(0x79, 0x08)
#define REG_SC_EXT_BK79_09_L      _PK_L_(0x79, 0x09)
#define REG_SC_EXT_BK79_09_H      _PK_H_(0x79, 0x09)

#define REG_SC_EXT_BK90 (0x3390)
#define REG_SC_EXT_BK90_01_L      _PK_L_(0x90, 0x01)
#define REG_SC_EXT_BK90_01_H      _PK_H_(0x90, 0x01)

#define REG_SC_EXT_BK91_01_L      _PK_L_(0x91, 0x01)
#define REG_SC_EXT_BK91_01_H      _PK_H_(0x91, 0x01)

#define REG_SC_EXT_BK93 (0x3393)
#define REG_SC_EXT_BK93_01_L      _PK_L_(0x93, 0x01)
#define REG_SC_EXT_BK93_01_H      _PK_H_(0x93, 0x01)

#define REG_SC_EXT_BK93_7E_L      _PK_L_(0x93, 0x7E)
#define REG_SC_EXT_BK93_7E_H      _PK_H_(0x93, 0x7E)

#define REG_SC_EXT_BK97_02_L      _PK_L_(0x97, 0x02)
#define REG_SC_EXT_BK97_02_H      _PK_H_(0x97, 0x02)
#define REG_SC_EXT_BK97_03_L      _PK_L_(0x97, 0x03)
#define REG_SC_EXT_BK97_03_H      _PK_H_(0x97, 0x03)

#define REG_SC_EXT_BK97_06_L      _PK_L_(0x97, 0x06)
#define REG_SC_EXT_BK97_06_H      _PK_H_(0x97, 0x06)
#define REG_SC_EXT_BK97_07_L      _PK_L_(0x97, 0x07)
#define REG_SC_EXT_BK97_07_H      _PK_H_(0x97, 0x07)
#define REG_SC_EXT_BK97_08_L      _PK_L_(0x97, 0x08)
#define REG_SC_EXT_BK97_08_H      _PK_H_(0x97, 0x08)
#define REG_SC_EXT_BK97_09_L      _PK_L_(0x97, 0x09)
#define REG_SC_EXT_BK97_09_H      _PK_H_(0x97, 0x09)
#define REG_SC_EXT_BK97_0A_L      _PK_L_(0x97, 0x0A)
#define REG_SC_EXT_BK97_0A_H      _PK_H_(0x97, 0x0A)
#define REG_SC_EXT_BK97_0B_L      _PK_L_(0x97, 0x0B)
#define REG_SC_EXT_BK97_0B_H      _PK_H_(0x97, 0x0B)

#define REG_SC_EXT_BK97_0E_L      _PK_L_(0x97, 0x0E)
#define REG_SC_EXT_BK97_0E_H      _PK_H_(0x97, 0x0E)

#define REG_SC_EXT_BK97_1B_L      _PK_L_(0x97, 0x1B)
#define REG_SC_EXT_BK97_1B_H      _PK_H_(0x97, 0x1B)

#define REG_SC_EXT_BK97_20_L      _PK_L_(0x97, 0x20)
#define REG_SC_EXT_BK97_20_H      _PK_H_(0x97, 0x20)
#define REG_SC_EXT_BK97_21_L      _PK_L_(0x97, 0x21)
#define REG_SC_EXT_BK97_21_H      _PK_H_(0x97, 0x21)
#define REG_SC_EXT_BK97_22_L      _PK_L_(0x97, 0x22)
#define REG_SC_EXT_BK97_22_H      _PK_H_(0x97, 0x22)

#define REG_SC_EXT_BK97_43_L      _PK_L_(0x97, 0x43)
#define REG_SC_EXT_BK97_43_H      _PK_H_(0x97, 0x43)
#define REG_SC_EXT_BK97_44_L      _PK_L_(0x97, 0x44)
#define REG_SC_EXT_BK97_44_H      _PK_H_(0x97, 0x44)
#define REG_SC_EXT_BK97_45_L      _PK_L_(0x97, 0x45)
#define REG_SC_EXT_BK97_45_H      _PK_H_(0x97, 0x45)

#define REG_SC_EXT_BK97_4C_L      _PK_L_(0x97, 0x4C)
#define REG_SC_EXT_BK97_4C_H      _PK_H_(0x97, 0x4C)
#define REG_SC_EXT_BK97_4D_L      _PK_L_(0x97, 0x4D)
#define REG_SC_EXT_BK97_4D_H      _PK_H_(0x97, 0x4D)

#define REG_SC_EXT_BK97_54_L      _PK_L_(0x97, 0x54)
#define REG_SC_EXT_BK97_54_H      _PK_H_(0x97, 0x54)

#define REG_SC_EXT_BK97_70_L      _PK_L_(0x97, 0x70)
#define REG_SC_EXT_BK97_70_H      _PK_H_(0x97, 0x70)
#define REG_SC_EXT_BK97_71_L      _PK_L_(0x97, 0x71)
#define REG_SC_EXT_BK97_71_H      _PK_H_(0x97, 0x71)
#define REG_SC_EXT_BK97_72_L      _PK_L_(0x97, 0x72)
#define REG_SC_EXT_BK97_72_H      _PK_H_(0x97, 0x72)
#define REG_SC_EXT_BK97_73_L      _PK_L_(0x97, 0x73)
#define REG_SC_EXT_BK97_73_H      _PK_H_(0x97, 0x73)
#define REG_SC_EXT_BK97_74_L      _PK_L_(0x97, 0x74)
#define REG_SC_EXT_BK97_74_H      _PK_H_(0x97, 0x74)
#define REG_SC_EXT_BK97_75_L      _PK_L_(0x97, 0x75)
#define REG_SC_EXT_BK97_75_H      _PK_H_(0x97, 0x75)
#define REG_SC_EXT_BK97_76_L      _PK_L_(0x97, 0x76)
#define REG_SC_EXT_BK97_76_H      _PK_H_(0x97, 0x76)
#define REG_SC_EXT_BK97_77_L      _PK_L_(0x97, 0x77)
#define REG_SC_EXT_BK97_77_H      _PK_H_(0x97, 0x77)
#define REG_SC_EXT_BK97_78_L      _PK_L_(0x97, 0x78)
#define REG_SC_EXT_BK97_78_H      _PK_H_(0x97, 0x78)
#define REG_SC_EXT_BK97_79_L      _PK_L_(0x97, 0x79)
#define REG_SC_EXT_BK97_79_H      _PK_H_(0x97, 0x79)
#define REG_SC_EXT_BK97_7A_L      _PK_L_(0x97, 0x7A)
#define REG_SC_EXT_BK97_7A_H      _PK_H_(0x97, 0x7A)
#define REG_SC_EXT_BK97_7B_L      _PK_L_(0x97, 0x7B)
#define REG_SC_EXT_BK97_7B_H      _PK_H_(0x97, 0x7B)

//BK0C
#define REG_SC_EXT_BK0C_17_L      _PK_L_(0x0C, 0x17)
#define REG_SC_EXT_BK0C_17_H      _PK_H_(0x0C, 0x17)

//BKA0
#define REG_SC_EXT_BKA0_01_L      _PK_L_(0xA0, 0x01)
#define REG_SC_EXT_BKA0_01_H      _PK_H_(0xA0, 0x01)
#define REG_SC_EXT_BKA0_30_L      _PK_L_(0xA0, 0x30)
#define REG_SC_EXT_BKA0_30_H      _PK_H_(0xA0, 0x30)
#define REG_SC_EXT_BKA0_31_L      _PK_L_(0xA0, 0x31)
#define REG_SC_EXT_BKA0_31_H      _PK_H_(0xA0, 0x31)
#define REG_SC_EXT_BKA0_32_L      _PK_L_(0xA0, 0x32)
#define REG_SC_EXT_BKA0_32_H      _PK_H_(0xA0, 0x32)
#define REG_SC_EXT_BKA0_50_L      _PK_L_(0xA0, 0x50)
#define REG_SC_EXT_BKA0_50_H      _PK_H_(0xA0, 0x50)
#define REG_SC_EXT_BKA0_51_L      _PK_L_(0xA0, 0x51)
#define REG_SC_EXT_BKA0_51_H      _PK_H_(0xA0, 0x51)
#define REG_SC_EXT_BKA0_52_L      _PK_L_(0xA0, 0x52)
#define REG_SC_EXT_BKA0_52_H      _PK_H_(0xA0, 0x52)
#define REG_SC_EXT_BKA0_53_L      _PK_L_(0xA0, 0x53)
#define REG_SC_EXT_BKA0_53_H      _PK_H_(0xA0, 0x53)
#define REG_SC_EXT_BKA0_54_L      _PK_L_(0xA0, 0x54)
#define REG_SC_EXT_BKA0_54_H      _PK_H_(0xA0, 0x54)
#define REG_SC_EXT_BKA0_55_L      _PK_L_(0xA0, 0x55)
#define REG_SC_EXT_BKA0_55_H      _PK_H_(0xA0, 0x55)
#define REG_SC_EXT_BKA0_56_L      _PK_L_(0xA0, 0x56)
#define REG_SC_EXT_BKA0_56_H      _PK_H_(0xA0, 0x56)
#define REG_SC_EXT_BKA0_57_L      _PK_L_(0xA0, 0x57)
#define REG_SC_EXT_BKA0_57_H      _PK_H_(0xA0, 0x57)
#define REG_SC_EXT_BKA0_58_L      _PK_L_(0xA0, 0x58)
#define REG_SC_EXT_BKA0_58_H      _PK_H_(0xA0, 0x58)
#define REG_SC_EXT_BKA0_59_L      _PK_L_(0xA0, 0x59)
#define REG_SC_EXT_BKA0_59_H      _PK_H_(0xA0, 0x59)
#define REG_SC_EXT_BKA0_5A_L      _PK_L_(0xA0, 0x5A)
#define REG_SC_EXT_BKA0_5A_H      _PK_H_(0xA0, 0x5A)
#define REG_SC_EXT_BKA0_5B_L      _PK_L_(0xA0, 0x5B)
#define REG_SC_EXT_BKA0_5B_H      _PK_H_(0xA0, 0x5B)
#define REG_SC_EXT_BKA0_5C_L      _PK_L_(0xA0, 0x5C)
#define REG_SC_EXT_BKA0_5C_H      _PK_H_(0xA0, 0x5C)
#define REG_SC_EXT_BKA0_5D_L      _PK_L_(0xA0, 0x5D)
#define REG_SC_EXT_BKA0_5D_H      _PK_H_(0xA0, 0x5D)
#define REG_SC_EXT_BKA0_5E_L      _PK_L_(0xA0, 0x5E)
#define REG_SC_EXT_BKA0_5E_H      _PK_H_(0xA0, 0x5E)
#define REG_SC_EXT_BKA0_5F_L      _PK_L_(0xA0, 0x5F)
#define REG_SC_EXT_BKA0_5F_H      _PK_H_(0xA0, 0x5F)
#define REG_SC_EXT_BKA0_61_L      _PK_L_(0xA0, 0x61)
#define REG_SC_EXT_BKA0_61_H      _PK_H_(0xA0, 0x61)
#define REG_SC_EXT_BKA0_62_L      _PK_L_(0xA0, 0x62)
#define REG_SC_EXT_BKA0_62_H      _PK_H_(0xA0, 0x62)
#define REG_SC_EXT_BKA0_63_L      _PK_L_(0xA0, 0x63)
#define REG_SC_EXT_BKA0_63_H      _PK_H_(0xA0, 0x63)
#define REG_SC_EXT_BKA0_64_L      _PK_L_(0xA0, 0x64)
#define REG_SC_EXT_BKA0_64_H      _PK_H_(0xA0, 0x64)
#define REG_SC_EXT_BKA0_65_L      _PK_L_(0xA0, 0x65)
#define REG_SC_EXT_BKA0_65_H      _PK_H_(0xA0, 0x65)
#define REG_SC_EXT_BKA0_66_L      _PK_L_(0xA0, 0x66)
#define REG_SC_EXT_BKA0_66_H      _PK_H_(0xA0, 0x66)
#define REG_SC_EXT_BKA0_67_L      _PK_L_(0xA0, 0x67)
#define REG_SC_EXT_BKA0_67_H      _PK_H_(0xA0, 0x67)
#define REG_SC_EXT_BKA0_68_L      _PK_L_(0xA0, 0x68)
#define REG_SC_EXT_BKA0_68_H      _PK_H_(0xA0, 0x68)
#define REG_SC_EXT_BKA0_69_L      _PK_L_(0xA0, 0x69)
#define REG_SC_EXT_BKA0_69_H      _PK_H_(0xA0, 0x69)
#define REG_SC_EXT_BKA0_6A_L      _PK_L_(0xA0, 0x6A)
#define REG_SC_EXT_BKA0_6A_H      _PK_H_(0xA0, 0x6A)
#define REG_SC_EXT_BKA0_6B_L      _PK_L_(0xA0, 0x6B)
#define REG_SC_EXT_BKA0_6B_H      _PK_H_(0xA0, 0x6B)
#define REG_SC_EXT_BKA0_6C_L      _PK_L_(0xA0, 0x6C)
#define REG_SC_EXT_BKA0_6C_H      _PK_H_(0xA0, 0x6C)
#define REG_SC_EXT_BKA0_6D_L      _PK_L_(0xA0, 0x6D)
#define REG_SC_EXT_BKA0_6D_H      _PK_H_(0xA0, 0x6D)
#define REG_SC_EXT_BKA0_6E_L      _PK_L_(0xA0, 0x6E)
#define REG_SC_EXT_BKA0_6E_H      _PK_H_(0xA0, 0x6E)
#define REG_SC_EXT_BKA0_6F_L      _PK_L_(0xA0, 0x6F)
#define REG_SC_EXT_BKA0_6F_H      _PK_H_(0xA0, 0x6F)

//BKB0
#define REG_SC_EXT_BKB0_04_L    _PK_L_(0xB0, 0x04)
#define REG_SC_EXT_BKB0_04_H    _PK_H_(0xB0, 0x04)
#define REG_SC_EXT_BKB0_05_L    _PK_L_(0xB0, 0x05)
#define REG_SC_EXT_BKB0_05_H    _PK_H_(0xB0, 0x05)
#define REG_SC_EXT_BKB0_08_L    _PK_L_(0xB0, 0x08)
#define REG_SC_EXT_BKB0_08_H    _PK_H_(0xB0, 0x08)
#define REG_SC_EXT_BKB0_09_L    _PK_L_(0xB0, 0x09)
#define REG_SC_EXT_BKB0_09_H    _PK_H_(0xB0, 0x09)
#define REG_SC_EXT_BKB0_0C_L    _PK_L_(0xB0, 0x0C)
#define REG_SC_EXT_BKB0_0C_H    _PK_H_(0xB0, 0x0C)
#define REG_SC_EXT_BKB0_0E_L    _PK_L_(0xB0, 0x0E)
#define REG_SC_EXT_BKB0_0E_H    _PK_H_(0xB0, 0x0E)
#define REG_SC_EXT_BKB0_2B_L    _PK_L_(0xB0, 0x2B)
#define REG_SC_EXT_BKB0_2B_H    _PK_H_(0xB0, 0x2B)

//BKB1
#define REG_SC_EXT_BKB1_05_L    _PK_L_(0xB1, 0x05)
#define REG_SC_EXT_BKB1_05_H    _PK_H_(0xB1, 0x05)

#define REG_SC_EXT_BKB1_40_L    _PK_L_(0xB1, 0x40)
#define REG_SC_EXT_BKB1_40_H    _PK_H_(0xB1, 0x40)

//BKB2
#define REG_SC_EXT_BKB2_04_L    _PK_L_(0xB2, 0x04)
#define REG_SC_EXT_BKB2_04_H    _PK_H_(0xB2, 0x04)
#define REG_SC_EXT_BKB2_05_L    _PK_L_(0xB2, 0x05)
#define REG_SC_EXT_BKB2_05_H    _PK_H_(0xB2, 0x05)
#define REG_SC_EXT_BKB2_06_L    _PK_L_(0xB2, 0x06)
#define REG_SC_EXT_BKB2_06_H    _PK_H_(0xB2, 0x06)
#define REG_SC_EXT_BKB2_07_L    _PK_L_(0xB2, 0x07)
#define REG_SC_EXT_BKB2_07_H    _PK_H_(0xB2, 0x07)

//BKC2
#define REG_SC_EXT_BKC2_10_L    _PK_L_(0xC2, 0x10)
#define REG_SC_EXT_BKC2_10_H    _PK_H_(0xC2, 0x10)
#define REG_SC_EXT_BKC2_11_L    _PK_L_(0xC2, 0x11)
#define REG_SC_EXT_BKC2_11_H    _PK_H_(0xC2, 0x11)
#define REG_SC_EXT_BKC2_12_L    _PK_L_(0xC2, 0x12)
#define REG_SC_EXT_BKC2_12_H    _PK_H_(0xC2, 0x12)
#define REG_SC_EXT_BKC2_13_L    _PK_L_(0xC2, 0x13)
#define REG_SC_EXT_BKC2_13_H    _PK_H_(0xC2, 0x13)

//BKC9
#define REG_SC_EXT_BKC9_01_L    _PK_L_(0xC9, 0x01)
#define REG_SC_EXT_BKC9_01_H    _PK_H_(0xC9, 0x01)
#define REG_SC_EXT_BKC9_02_L    _PK_L_(0xC9, 0x02)
#define REG_SC_EXT_BKC9_02_H    _PK_H_(0xC9, 0x02)
#define REG_SC_EXT_BKC9_03_L    _PK_L_(0xC9, 0x03)
#define REG_SC_EXT_BKC9_03_H    _PK_H_(0xC9, 0x03)
#define REG_SC_EXT_BKC9_04_L    _PK_L_(0xC9, 0x04)
#define REG_SC_EXT_BKC9_04_H    _PK_H_(0xC9, 0x04)
#define REG_SC_EXT_BKC9_05_L    _PK_L_(0xC9, 0x05)
#define REG_SC_EXT_BKC9_05_H    _PK_H_(0xC9, 0x05)
#define REG_SC_EXT_BKC9_06_L    _PK_L_(0xC9, 0x06)
#define REG_SC_EXT_BKC9_06_H    _PK_H_(0xC9, 0x06)
#define REG_SC_EXT_BKC9_07_L    _PK_L_(0xC9, 0x07)
#define REG_SC_EXT_BKC9_07_H    _PK_H_(0xC9, 0x07)
#define REG_SC_EXT_BKC9_08_L    _PK_L_(0xC9, 0x08)
#define REG_SC_EXT_BKC9_08_H    _PK_H_(0xC9, 0x08)
#define REG_SC_EXT_BKC9_09_L    _PK_L_(0xC9, 0x09)
#define REG_SC_EXT_BKC9_09_H    _PK_H_(0xC9, 0x09)
#define REG_SC_EXT_BKC9_0A_L    _PK_L_(0xC9, 0x0A)
#define REG_SC_EXT_BKC9_0A_H    _PK_H_(0xC9, 0x0A)
#define REG_SC_EXT_BKC9_28_L    _PK_L_(0xC9, 0x28)
#define REG_SC_EXT_BKC9_28_H    _PK_H_(0xC9, 0x28)
#define REG_SC_EXT_BKC9_29_L    _PK_L_(0xC9, 0x29)
#define REG_SC_EXT_BKC9_29_H    _PK_H_(0xC9, 0x29)
#define REG_SC_EXT_BKC9_2A_L    _PK_L_(0xC9, 0x2A)
#define REG_SC_EXT_BKC9_2A_H    _PK_H_(0xC9, 0x2A)
#define REG_SC_EXT_BKC9_2B_L    _PK_L_(0xC9, 0x2B)
#define REG_SC_EXT_BKC9_2B_H    _PK_H_(0xC9, 0x2B)
#define REG_SC_EXT_BKC9_60_L    _PK_L_(0xC9, 0x60)
#define REG_SC_EXT_BKC9_60_H    _PK_H_(0xC9, 0x60)

//BKCA
#define REG_SC_EXT_BKCA_01_L    _PK_L_(0xCA, 0x01)
#define REG_SC_EXT_BKCA_01_H    _PK_H_(0xCA, 0x01)
#define REG_SC_EXT_BKCA_02_L    _PK_L_(0xCA, 0x02)
#define REG_SC_EXT_BKCA_02_H    _PK_H_(0xCA, 0x02)
#define REG_SC_EXT_BKCA_03_L    _PK_L_(0xCA, 0x03)
#define REG_SC_EXT_BKCA_03_H    _PK_H_(0xCA, 0x03)
#define REG_SC_EXT_BKCA_04_L    _PK_L_(0xCA, 0x04)
#define REG_SC_EXT_BKCA_04_H    _PK_H_(0xCA, 0x04)
#define REG_SC_EXT_BKCA_05_L    _PK_L_(0xCA, 0x05)
#define REG_SC_EXT_BKCA_05_H    _PK_H_(0xCA, 0x05)
#define REG_SC_EXT_BKCA_06_L    _PK_L_(0xCA, 0x06)
#define REG_SC_EXT_BKCA_06_H    _PK_H_(0xCA, 0x06)
#define REG_SC_EXT_BKCA_07_L    _PK_L_(0xCA, 0x07)
#define REG_SC_EXT_BKCA_07_H    _PK_H_(0xCA, 0x07)
#define REG_SC_EXT_BKCA_08_L    _PK_L_(0xCA, 0x08)
#define REG_SC_EXT_BKCA_08_H    _PK_H_(0xCA, 0x08)
#define REG_SC_EXT_BKCA_09_L    _PK_L_(0xCA, 0x09)
#define REG_SC_EXT_BKCA_09_H    _PK_H_(0xCA, 0x09)
#define REG_SC_EXT_BKCA_0A_L    _PK_L_(0xCA, 0x0A)
#define REG_SC_EXT_BKCA_0A_H    _PK_H_(0xCA, 0x0A)
#define REG_SC_EXT_BKCA_0B_L    _PK_L_(0xCA, 0x0B)
#define REG_SC_EXT_BKCA_0B_H    _PK_H_(0xCA, 0x0B)
#define REG_SC_EXT_BKCA_20_L    _PK_L_(0xCA, 0x20)
#define REG_SC_EXT_BKCA_20_H    _PK_H_(0xCA, 0x20)
#define REG_SC_EXT_BKCA_21_L    _PK_L_(0xCA, 0x21)
#define REG_SC_EXT_BKCA_21_H    _PK_H_(0xCA, 0x21)
#define REG_SC_EXT_BKCA_22_L    _PK_L_(0xCA, 0x22)
#define REG_SC_EXT_BKCA_22_H    _PK_H_(0xCA, 0x22)
#define REG_SC_EXT_BKCA_23_L    _PK_L_(0xCA, 0x23)
#define REG_SC_EXT_BKCA_23_H    _PK_H_(0xCA, 0x23)
#define REG_SC_EXT_BKCA_60_L    _PK_L_(0xCA, 0x60)
#define REG_SC_EXT_BKCA_60_H    _PK_H_(0xCA, 0x60)

//BKCB
#define REG_SC_EXT_BKCB_07_L    _PK_L_(0xCB, 0x07)
#define REG_SC_EXT_BKCB_07_H    _PK_H_(0xCB, 0x07)
#define REG_SC_EXT_BKCB_08_L    _PK_L_(0xCB, 0x08)
#define REG_SC_EXT_BKCB_08_H    _PK_H_(0xCB, 0x08)
#define REG_SC_EXT_BKCB_09_L    _PK_L_(0xCB, 0x09)
#define REG_SC_EXT_BKCB_09_H    _PK_H_(0xCB, 0x09)
#define REG_SC_EXT_BKCB_0B_L    _PK_L_(0xCB, 0x0B)
#define REG_SC_EXT_BKCB_0B_H    _PK_H_(0xCB, 0x0B)
#define REG_SC_EXT_BKCB_0C_L    _PK_L_(0xCB, 0x0C)
#define REG_SC_EXT_BKCB_0C_H    _PK_H_(0xCB, 0x0C)

//BK65
#define REG_SC_EXT_BK65_01_L      _PK_L_(0x65, 0x01)
#define REG_SC_EXT_BK65_01_H      _PK_H_(0x65, 0x01)
#define REG_SC_EXT_BK65_02_L      _PK_L_(0x65, 0x02)
#define REG_SC_EXT_BK65_02_H      _PK_H_(0x65, 0x02)
#define REG_SC_EXT_BK65_03_L      _PK_L_(0x65, 0x03)
#define REG_SC_EXT_BK65_03_H      _PK_H_(0x65, 0x03)
#define REG_SC_EXT_BK65_04_L      _PK_L_(0x65, 0x04)
#define REG_SC_EXT_BK65_04_H      _PK_H_(0x65, 0x04)
#define REG_SC_EXT_BK65_05_L      _PK_L_(0x65, 0x05)
#define REG_SC_EXT_BK65_05_H      _PK_H_(0x65, 0x05)
#define REG_SC_EXT_BK65_06_L      _PK_L_(0x65, 0x06)
#define REG_SC_EXT_BK65_06_H      _PK_H_(0x65, 0x06)
#define REG_SC_EXT_BK65_07_L      _PK_L_(0x65, 0x07)
#define REG_SC_EXT_BK65_07_H      _PK_H_(0x65, 0x07)
#define REG_SC_EXT_BK65_08_L      _PK_L_(0x65, 0x08)
#define REG_SC_EXT_BK65_08_H      _PK_H_(0x65, 0x08)
#define REG_SC_EXT_BK65_09_L      _PK_L_(0x65, 0x09)
#define REG_SC_EXT_BK65_09_H      _PK_H_(0x65, 0x09)
#define REG_SC_EXT_BK65_0A_L      _PK_L_(0x65, 0x0A)
#define REG_SC_EXT_BK65_0A_H      _PK_H_(0x65, 0x0A)
#define REG_SC_EXT_BK65_0B_L      _PK_L_(0x65, 0x0B)
#define REG_SC_EXT_BK65_0B_H      _PK_H_(0x65, 0x0B)
#define REG_SC_EXT_BK65_0C_L      _PK_L_(0x65, 0x0C)
#define REG_SC_EXT_BK65_0C_H      _PK_H_(0x65, 0x0C)
#define REG_SC_EXT_BK65_0D_L      _PK_L_(0x65, 0x0D)
#define REG_SC_EXT_BK65_0D_H      _PK_H_(0x65, 0x0D)
#define REG_SC_EXT_BK65_0E_L      _PK_L_(0x65, 0x0E)
#define REG_SC_EXT_BK65_0E_H      _PK_H_(0x65, 0x0E)
#define REG_SC_EXT_BK65_0F_L      _PK_L_(0x65, 0x0F)
#define REG_SC_EXT_BK65_0F_H      _PK_H_(0x65, 0x0F)
#define REG_SC_EXT_BK65_10_L      _PK_L_(0x65, 0x10)
#define REG_SC_EXT_BK65_10_H      _PK_H_(0x65, 0x10)
#define REG_SC_EXT_BK65_11_L      _PK_L_(0x65, 0x11)
#define REG_SC_EXT_BK65_11_H      _PK_H_(0x65, 0x12)
#define REG_SC_EXT_BK65_12_L      _PK_L_(0x65, 0x12)
#define REG_SC_EXT_BK65_12_H      _PK_H_(0x65, 0x13)
#define REG_SC_EXT_BK65_13_L      _PK_L_(0x65, 0x13)
#define REG_SC_EXT_BK65_13_H      _PK_H_(0x65, 0x13)
#define REG_SC_EXT_BK65_14_L      _PK_L_(0x65, 0x14)
#define REG_SC_EXT_BK65_14_H      _PK_H_(0x65, 0x14)


#define REG_SC_EXT_BK8F_01_L    _PK_L_(0x8F, 0x01)
#define REG_SC_EXT_BK8F_01_H    _PK_H_(0x8F, 0x01)
#define REG_SC_EXT_BK8F_20_L    _PK_L_(0x8F, 0x20)
#define REG_SC_EXT_BK8F_20_H    _PK_H_(0x8F, 0x20)
#define REG_SC_EXT_BK8F_28_L    _PK_L_(0x8F, 0x28)
#define REG_SC_EXT_BK8F_28_H    _PK_H_(0x8F, 0x28)
#define REG_SC_EXT_BK8F_30_L    _PK_L_(0x8F, 0x30)
#define REG_SC_EXT_BK8F_30_H    _PK_H_(0x8F, 0x30)
#define REG_SC_EXT_BK8F_38_L    _PK_L_(0x8F, 0x38)
#define REG_SC_EXT_BK8F_38_H    _PK_H_(0x8F, 0x38)

// VR System
#define REG_VR_BK00_01_L    _PK_L_(0x00,0x01)
#define REG_VR_BK00_01_H    _PK_H_(0x00,0x01)

// VR DNR
#define REG_VR_BK08_00_L    _PK_L_(0x08,0x00)
#define REG_VR_BK08_00_H    _PK_H_(0x08,0x00)
#define REG_VR_BK08_05_L    _PK_L_(0x08,0x05)
#define REG_VR_BK08_05_H    _PK_H_(0x08,0x05)

// VR OSD on/off for SNR
#define REG_VR_BK08_41_L    _PK_L_(0x08,0x41)
#define REG_VR_BK08_41_H    _PK_H_(0x08,0x41)

#define REG_VR_BK0C_36_L          _PK_L_(0x0C,0x36)
#define REG_VR_BK0C_36_H          _PK_H_(0x0C,0x36)
#define REG_VR_BK0C_37_L          _PK_L_(0x0C,0x37)
#define REG_VR_BK0C_37_H          _PK_H_(0x0C,0x37)
#define REG_VR_BK0C_3C_L          _PK_L_(0x0C,0x3C)
#define REG_VR_BK0C_3C_H          _PK_H_(0x0C,0x3C)
#define REG_VR_BK0C_3D_L          _PK_L_(0x0C,0x3D)
#define REG_VR_BK0C_3D_H          _PK_H_(0x0C,0x3D)
#define REG_VR_BK0C_3E_L          _PK_L_(0x0C,0x3E)
#define REG_VR_BK0C_3E_H          _PK_H_(0x0C,0x3E)
#define REG_VR_BK0C_3F_L          _PK_L_(0x0C,0x3F)
#define REG_VR_BK0C_3F_H          _PK_H_(0x0C,0x3F)
#endif

// VR ABF
#define REG_VR_BK5F_10_L          _PK_L_(0x5F,0x10)
#define REG_VR_BK5F_10_H          _PK_H_(0x5F,0x10)
