//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef _HWREG_ACE_H_
#define _HWREG_ACE_H_

#include "MsCommon.h"

#define _PK_L_(bank, addr)   (((MS_U16)(bank) << 8) | (MS_U16)((addr)*2))
#define _PK_H_(bank, addr)   (((MS_U16)(bank) << 8) | (MS_U16)((addr)*2+1))

#define REG_TABLE_END      0xFFFF

//=============================================================
//----------------------------------------------
//  BK00: GOPINT
//----------------------------------------------
#define REG_SC_BK00_00_L      _PK_L_(0x00, 0x00)
#define REG_SC_BK00_00_H      _PK_H_(0x00, 0x00)
#define REG_SC_BK00_01_L      _PK_L_(0x00, 0x01)
#define REG_SC_BK00_01_H      _PK_H_(0x00, 0x01)
#define REG_SC_BK00_02_L      _PK_L_(0x00, 0x02)
#define REG_SC_BK00_02_H      _PK_H_(0x00, 0x02)
#define REG_SC_BK00_03_L      _PK_L_(0x00, 0x03)
#define REG_SC_BK00_03_H      _PK_H_(0x00, 0x03)
#define REG_SC_BK00_04_L      _PK_L_(0x00, 0x04)
#define REG_SC_BK00_04_H      _PK_H_(0x00, 0x04)
#define REG_SC_BK00_05_L      _PK_L_(0x00, 0x05)
#define REG_SC_BK00_05_H      _PK_H_(0x00, 0x05)
#define REG_SC_BK00_06_L      _PK_L_(0x00, 0x06)
#define REG_SC_BK00_06_H      _PK_H_(0x00, 0x06)
#define REG_SC_BK00_07_L      _PK_L_(0x00, 0x07)
#define REG_SC_BK00_07_H      _PK_H_(0x00, 0x07)
#define REG_SC_BK00_08_L      _PK_L_(0x00, 0x08)
#define REG_SC_BK00_08_H      _PK_H_(0x00, 0x08)
#define REG_SC_BK00_09_L      _PK_L_(0x00, 0x09)
#define REG_SC_BK00_09_H      _PK_H_(0x00, 0x09)
#define REG_SC_BK00_0A_L      _PK_L_(0x00, 0x0A)
#define REG_SC_BK00_0A_H      _PK_H_(0x00, 0x0A)
#define REG_SC_BK00_0B_L      _PK_L_(0x00, 0x0B)
#define REG_SC_BK00_0B_H      _PK_H_(0x00, 0x0B)
#define REG_SC_BK00_0C_L      _PK_L_(0x00, 0x0C)
#define REG_SC_BK00_0C_H      _PK_H_(0x00, 0x0C)
#define REG_SC_BK00_0D_L      _PK_L_(0x00, 0x0D)
#define REG_SC_BK00_0D_H      _PK_H_(0x00, 0x0D)
#define REG_SC_BK00_0E_L      _PK_L_(0x00, 0x0E)
#define REG_SC_BK00_0E_H      _PK_H_(0x00, 0x0E)
#define REG_SC_BK00_0F_L      _PK_L_(0x00, 0x0F)
#define REG_SC_BK00_0F_H      _PK_H_(0x00, 0x0F)
#define REG_SC_BK00_10_L      _PK_L_(0x00, 0x10)
#define REG_SC_BK00_10_H      _PK_H_(0x00, 0x10)
#define REG_SC_BK00_11_L      _PK_L_(0x00, 0x11)
#define REG_SC_BK00_11_H      _PK_H_(0x00, 0x11)
#define REG_SC_BK00_12_L      _PK_L_(0x00, 0x12)
#define REG_SC_BK00_12_H      _PK_H_(0x00, 0x12)
#define REG_SC_BK00_13_L      _PK_L_(0x00, 0x13)
#define REG_SC_BK00_13_H      _PK_H_(0x00, 0x13)
#define REG_SC_BK00_14_L      _PK_L_(0x00, 0x14)
#define REG_SC_BK00_14_H      _PK_H_(0x00, 0x14)
#define REG_SC_BK00_15_L      _PK_L_(0x00, 0x15)
#define REG_SC_BK00_15_H      _PK_H_(0x00, 0x15)
#define REG_SC_BK00_16_L      _PK_L_(0x00, 0x16)
#define REG_SC_BK00_16_H      _PK_H_(0x00, 0x16)
#define REG_SC_BK00_17_L      _PK_L_(0x00, 0x17)
#define REG_SC_BK00_17_H      _PK_H_(0x00, 0x17)
#define REG_SC_BK00_18_L      _PK_L_(0x00, 0x18)
#define REG_SC_BK00_18_H      _PK_H_(0x00, 0x18)
#define REG_SC_BK00_19_L      _PK_L_(0x00, 0x19)
#define REG_SC_BK00_19_H      _PK_H_(0x00, 0x19)
#define REG_SC_BK00_1A_L      _PK_L_(0x00, 0x1A)
#define REG_SC_BK00_1A_H      _PK_H_(0x00, 0x1A)
#define REG_SC_BK00_1B_L      _PK_L_(0x00, 0x1B)
#define REG_SC_BK00_1B_H      _PK_H_(0x00, 0x1B)
#define REG_SC_BK00_1C_L      _PK_L_(0x00, 0x1C)
#define REG_SC_BK00_1C_H      _PK_H_(0x00, 0x1C)
#define REG_SC_BK00_1D_L      _PK_L_(0x00, 0x1D)
#define REG_SC_BK00_1D_H      _PK_H_(0x00, 0x1D)
#define REG_SC_BK00_1E_L      _PK_L_(0x00, 0x1E)
#define REG_SC_BK00_1E_H      _PK_H_(0x00, 0x1E)
#define REG_SC_BK00_1F_L      _PK_L_(0x00, 0x1F)
#define REG_SC_BK00_1F_H      _PK_H_(0x00, 0x1F)
#define REG_SC_BK00_20_L      _PK_L_(0x00, 0x20)
#define REG_SC_BK00_20_H      _PK_H_(0x00, 0x20)
#define REG_SC_BK00_21_L      _PK_L_(0x00, 0x21)
#define REG_SC_BK00_21_H      _PK_H_(0x00, 0x21)
#define REG_SC_BK00_22_L      _PK_L_(0x00, 0x22)
#define REG_SC_BK00_22_H      _PK_H_(0x00, 0x22)
#define REG_SC_BK00_23_L      _PK_L_(0x00, 0x23)
#define REG_SC_BK00_23_H      _PK_H_(0x00, 0x23)
#define REG_SC_BK00_24_L      _PK_L_(0x00, 0x24)
#define REG_SC_BK00_24_H      _PK_H_(0x00, 0x24)
#define REG_SC_BK00_25_L      _PK_L_(0x00, 0x25)
#define REG_SC_BK00_25_H      _PK_H_(0x00, 0x25)
#define REG_SC_BK00_26_L      _PK_L_(0x00, 0x26)
#define REG_SC_BK00_26_H      _PK_H_(0x00, 0x26)
#define REG_SC_BK00_27_L      _PK_L_(0x00, 0x27)
#define REG_SC_BK00_27_H      _PK_H_(0x00, 0x27)
#define REG_SC_BK00_28_L      _PK_L_(0x00, 0x28)
#define REG_SC_BK00_28_H      _PK_H_(0x00, 0x28)
#define REG_SC_BK00_29_L      _PK_L_(0x00, 0x29)
#define REG_SC_BK00_29_H      _PK_H_(0x00, 0x29)
#define REG_SC_BK00_2A_L      _PK_L_(0x00, 0x2A)
#define REG_SC_BK00_2A_H      _PK_H_(0x00, 0x2A)
#define REG_SC_BK00_2B_L      _PK_L_(0x00, 0x2B)
#define REG_SC_BK00_2B_H      _PK_H_(0x00, 0x2B)
#define REG_SC_BK00_2C_L      _PK_L_(0x00, 0x2C)
#define REG_SC_BK00_2C_H      _PK_H_(0x00, 0x2C)
#define REG_SC_BK00_2D_L      _PK_L_(0x00, 0x2D)
#define REG_SC_BK00_2D_H      _PK_H_(0x00, 0x2D)
#define REG_SC_BK00_2E_L      _PK_L_(0x00, 0x2E)
#define REG_SC_BK00_2E_H      _PK_H_(0x00, 0x2E)
#define REG_SC_BK00_2F_L      _PK_L_(0x00, 0x2F)
#define REG_SC_BK00_2F_H      _PK_H_(0x00, 0x2F)
#define REG_SC_BK00_30_L      _PK_L_(0x00, 0x30)
#define REG_SC_BK00_30_H      _PK_H_(0x00, 0x30)
#define REG_SC_BK00_31_L      _PK_L_(0x00, 0x31)
#define REG_SC_BK00_31_H      _PK_H_(0x00, 0x31)
#define REG_SC_BK00_32_L      _PK_L_(0x00, 0x32)
#define REG_SC_BK00_32_H      _PK_H_(0x00, 0x32)
#define REG_SC_BK00_33_L      _PK_L_(0x00, 0x33)
#define REG_SC_BK00_33_H      _PK_H_(0x00, 0x33)
#define REG_SC_BK00_34_L      _PK_L_(0x00, 0x34)
#define REG_SC_BK00_34_H      _PK_H_(0x00, 0x34)
#define REG_SC_BK00_35_L      _PK_L_(0x00, 0x35)
#define REG_SC_BK00_35_H      _PK_H_(0x00, 0x35)
#define REG_SC_BK00_36_L      _PK_L_(0x00, 0x36)
#define REG_SC_BK00_36_H      _PK_H_(0x00, 0x36)
#define REG_SC_BK00_37_L      _PK_L_(0x00, 0x37)
#define REG_SC_BK00_37_H      _PK_H_(0x00, 0x37)
#define REG_SC_BK00_38_L      _PK_L_(0x00, 0x38)
#define REG_SC_BK00_38_H      _PK_H_(0x00, 0x38)
#define REG_SC_BK00_39_L      _PK_L_(0x00, 0x39)
#define REG_SC_BK00_39_H      _PK_H_(0x00, 0x39)
#define REG_SC_BK00_3A_L      _PK_L_(0x00, 0x3A)
#define REG_SC_BK00_3A_H      _PK_H_(0x00, 0x3A)
#define REG_SC_BK00_3B_L      _PK_L_(0x00, 0x3B)
#define REG_SC_BK00_3B_H      _PK_H_(0x00, 0x3B)
#define REG_SC_BK00_3C_L      _PK_L_(0x00, 0x3C)
#define REG_SC_BK00_3C_H      _PK_H_(0x00, 0x3C)
#define REG_SC_BK00_3D_L      _PK_L_(0x00, 0x3D)
#define REG_SC_BK00_3D_H      _PK_H_(0x00, 0x3D)
#define REG_SC_BK00_3E_L      _PK_L_(0x00, 0x3E)
#define REG_SC_BK00_3E_H      _PK_H_(0x00, 0x3E)
#define REG_SC_BK00_3F_L      _PK_L_(0x00, 0x3F)
#define REG_SC_BK00_3F_H      _PK_H_(0x00, 0x3F)
#define REG_SC_BK00_40_L      _PK_L_(0x00, 0x40)
#define REG_SC_BK00_40_H      _PK_H_(0x00, 0x40)
#define REG_SC_BK00_41_L      _PK_L_(0x00, 0x41)
#define REG_SC_BK00_41_H      _PK_H_(0x00, 0x41)
#define REG_SC_BK00_42_L      _PK_L_(0x00, 0x42)
#define REG_SC_BK00_42_H      _PK_H_(0x00, 0x42)
#define REG_SC_BK00_43_L      _PK_L_(0x00, 0x43)
#define REG_SC_BK00_43_H      _PK_H_(0x00, 0x43)
#define REG_SC_BK00_44_L      _PK_L_(0x00, 0x44)
#define REG_SC_BK00_44_H      _PK_H_(0x00, 0x44)
#define REG_SC_BK00_45_L      _PK_L_(0x00, 0x45)
#define REG_SC_BK00_45_H      _PK_H_(0x00, 0x45)
#define REG_SC_BK00_46_L      _PK_L_(0x00, 0x46)
#define REG_SC_BK00_46_H      _PK_H_(0x00, 0x46)
#define REG_SC_BK00_47_L      _PK_L_(0x00, 0x47)
#define REG_SC_BK00_47_H      _PK_H_(0x00, 0x47)
#define REG_SC_BK00_48_L      _PK_L_(0x00, 0x48)
#define REG_SC_BK00_48_H      _PK_H_(0x00, 0x48)
#define REG_SC_BK00_49_L      _PK_L_(0x00, 0x49)
#define REG_SC_BK00_49_H      _PK_H_(0x00, 0x49)
#define REG_SC_BK00_4A_L      _PK_L_(0x00, 0x4A)
#define REG_SC_BK00_4A_H      _PK_H_(0x00, 0x4A)
#define REG_SC_BK00_4B_L      _PK_L_(0x00, 0x4B)
#define REG_SC_BK00_4B_H      _PK_H_(0x00, 0x4B)
#define REG_SC_BK00_4C_L      _PK_L_(0x00, 0x4C)
#define REG_SC_BK00_4C_H      _PK_H_(0x00, 0x4C)
#define REG_SC_BK00_4D_L      _PK_L_(0x00, 0x4D)
#define REG_SC_BK00_4D_H      _PK_H_(0x00, 0x4D)
#define REG_SC_BK00_4E_L      _PK_L_(0x00, 0x4E)
#define REG_SC_BK00_4E_H      _PK_H_(0x00, 0x4E)
#define REG_SC_BK00_4F_L      _PK_L_(0x00, 0x4F)
#define REG_SC_BK00_4F_H      _PK_H_(0x00, 0x4F)
#define REG_SC_BK00_50_L      _PK_L_(0x00, 0x50)
#define REG_SC_BK00_50_H      _PK_H_(0x00, 0x50)
#define REG_SC_BK00_51_L      _PK_L_(0x00, 0x51)
#define REG_SC_BK00_51_H      _PK_H_(0x00, 0x51)
#define REG_SC_BK00_52_L      _PK_L_(0x00, 0x52)
#define REG_SC_BK00_52_H      _PK_H_(0x00, 0x52)
#define REG_SC_BK00_53_L      _PK_L_(0x00, 0x53)
#define REG_SC_BK00_53_H      _PK_H_(0x00, 0x53)
#define REG_SC_BK00_54_L      _PK_L_(0x00, 0x54)
#define REG_SC_BK00_54_H      _PK_H_(0x00, 0x54)
#define REG_SC_BK00_55_L      _PK_L_(0x00, 0x55)
#define REG_SC_BK00_55_H      _PK_H_(0x00, 0x55)
#define REG_SC_BK00_56_L      _PK_L_(0x00, 0x56)
#define REG_SC_BK00_56_H      _PK_H_(0x00, 0x56)
#define REG_SC_BK00_57_L      _PK_L_(0x00, 0x57)
#define REG_SC_BK00_57_H      _PK_H_(0x00, 0x57)
#define REG_SC_BK00_58_L      _PK_L_(0x00, 0x58)
#define REG_SC_BK00_58_H      _PK_H_(0x00, 0x58)
#define REG_SC_BK00_59_L      _PK_L_(0x00, 0x59)
#define REG_SC_BK00_59_H      _PK_H_(0x00, 0x59)
#define REG_SC_BK00_5A_L      _PK_L_(0x00, 0x5A)
#define REG_SC_BK00_5A_H      _PK_H_(0x00, 0x5A)
#define REG_SC_BK00_5B_L      _PK_L_(0x00, 0x5B)
#define REG_SC_BK00_5B_H      _PK_H_(0x00, 0x5B)
#define REG_SC_BK00_5C_L      _PK_L_(0x00, 0x5C)
#define REG_SC_BK00_5C_H      _PK_H_(0x00, 0x5C)
#define REG_SC_BK00_5D_L      _PK_L_(0x00, 0x5D)
#define REG_SC_BK00_5D_H      _PK_H_(0x00, 0x5D)
#define REG_SC_BK00_5E_L      _PK_L_(0x00, 0x5E)
#define REG_SC_BK00_5E_H      _PK_H_(0x00, 0x5E)
#define REG_SC_BK00_5F_L      _PK_L_(0x00, 0x5F)
#define REG_SC_BK00_5F_H      _PK_H_(0x00, 0x5F)
#define REG_SC_BK00_60_L      _PK_L_(0x00, 0x60)
#define REG_SC_BK00_60_H      _PK_H_(0x00, 0x60)
#define REG_SC_BK00_61_L      _PK_L_(0x00, 0x61)
#define REG_SC_BK00_61_H      _PK_H_(0x00, 0x61)
#define REG_SC_BK00_62_L      _PK_L_(0x00, 0x62)
#define REG_SC_BK00_62_H      _PK_H_(0x00, 0x62)
#define REG_SC_BK00_63_L      _PK_L_(0x00, 0x63)
#define REG_SC_BK00_63_H      _PK_H_(0x00, 0x63)
#define REG_SC_BK00_64_L      _PK_L_(0x00, 0x64)
#define REG_SC_BK00_64_H      _PK_H_(0x00, 0x64)
#define REG_SC_BK00_65_L      _PK_L_(0x00, 0x65)
#define REG_SC_BK00_65_H      _PK_H_(0x00, 0x65)
#define REG_SC_BK00_66_L      _PK_L_(0x00, 0x66)
#define REG_SC_BK00_66_H      _PK_H_(0x00, 0x66)
#define REG_SC_BK00_67_L      _PK_L_(0x00, 0x67)
#define REG_SC_BK00_67_H      _PK_H_(0x00, 0x67)
#define REG_SC_BK00_68_L      _PK_L_(0x00, 0x68)
#define REG_SC_BK00_68_H      _PK_H_(0x00, 0x68)
#define REG_SC_BK00_69_L      _PK_L_(0x00, 0x69)
#define REG_SC_BK00_69_H      _PK_H_(0x00, 0x69)
#define REG_SC_BK00_6A_L      _PK_L_(0x00, 0x6A)
#define REG_SC_BK00_6A_H      _PK_H_(0x00, 0x6A)
#define REG_SC_BK00_6B_L      _PK_L_(0x00, 0x6B)
#define REG_SC_BK00_6B_H      _PK_H_(0x00, 0x6B)
#define REG_SC_BK00_6C_L      _PK_L_(0x00, 0x6C)
#define REG_SC_BK00_6C_H      _PK_H_(0x00, 0x6C)
#define REG_SC_BK00_6D_L      _PK_L_(0x00, 0x6D)
#define REG_SC_BK00_6D_H      _PK_H_(0x00, 0x6D)
#define REG_SC_BK00_6E_L      _PK_L_(0x00, 0x6E)
#define REG_SC_BK00_6E_H      _PK_H_(0x00, 0x6E)
#define REG_SC_BK00_6F_L      _PK_L_(0x00, 0x6F)
#define REG_SC_BK00_6F_H      _PK_H_(0x00, 0x6F)
#define REG_SC_BK00_70_L      _PK_L_(0x00, 0x70)
#define REG_SC_BK00_70_H      _PK_H_(0x00, 0x70)
#define REG_SC_BK00_71_L      _PK_L_(0x00, 0x71)
#define REG_SC_BK00_71_H      _PK_H_(0x00, 0x71)
#define REG_SC_BK00_72_L      _PK_L_(0x00, 0x72)
#define REG_SC_BK00_72_H      _PK_H_(0x00, 0x72)
#define REG_SC_BK00_73_L      _PK_L_(0x00, 0x73)
#define REG_SC_BK00_73_H      _PK_H_(0x00, 0x73)
#define REG_SC_BK00_74_L      _PK_L_(0x00, 0x74)
#define REG_SC_BK00_74_H      _PK_H_(0x00, 0x74)
#define REG_SC_BK00_75_L      _PK_L_(0x00, 0x75)
#define REG_SC_BK00_75_H      _PK_H_(0x00, 0x75)
#define REG_SC_BK00_76_L      _PK_L_(0x00, 0x76)
#define REG_SC_BK00_76_H      _PK_H_(0x00, 0x76)
#define REG_SC_BK00_77_L      _PK_L_(0x00, 0x77)
#define REG_SC_BK00_77_H      _PK_H_(0x00, 0x77)
#define REG_SC_BK00_78_L      _PK_L_(0x00, 0x78)
#define REG_SC_BK00_78_H      _PK_H_(0x00, 0x78)
#define REG_SC_BK00_79_L      _PK_L_(0x00, 0x79)
#define REG_SC_BK00_79_H      _PK_H_(0x00, 0x79)
#define REG_SC_BK00_7A_L      _PK_L_(0x00, 0x7A)
#define REG_SC_BK00_7A_H      _PK_H_(0x00, 0x7A)
#define REG_SC_BK00_7B_L      _PK_L_(0x00, 0x7B)
#define REG_SC_BK00_7B_H      _PK_H_(0x00, 0x7B)
#define REG_SC_BK00_7C_L      _PK_L_(0x00, 0x7C)
#define REG_SC_BK00_7C_H      _PK_H_(0x00, 0x7C)
#define REG_SC_BK00_7D_L      _PK_L_(0x00, 0x7D)
#define REG_SC_BK00_7D_H      _PK_H_(0x00, 0x7D)
#define REG_SC_BK00_7E_L      _PK_L_(0x00, 0x7E)
#define REG_SC_BK00_7E_H      _PK_H_(0x00, 0x7E)
#define REG_SC_BK00_7F_L      _PK_L_(0x00, 0x7F)
#define REG_SC_BK00_7F_H      _PK_H_(0x00, 0x7F)


//----------------------------------------------
//  BK01: IP1F2
//----------------------------------------------
#define REG_SC_BK01_00_L      _PK_L_(0x01, 0x00)
#define REG_SC_BK01_00_H      _PK_H_(0x01, 0x00)
#define REG_SC_BK01_01_L      _PK_L_(0x01, 0x01)
#define REG_SC_BK01_01_H      _PK_H_(0x01, 0x01)
#define REG_SC_BK01_02_L      _PK_L_(0x01, 0x02)
#define REG_SC_BK01_02_H      _PK_H_(0x01, 0x02)
#define REG_SC_BK01_03_L      _PK_L_(0x01, 0x03)
#define REG_SC_BK01_03_H      _PK_H_(0x01, 0x03)
#define REG_SC_BK01_04_L      _PK_L_(0x01, 0x04)
#define REG_SC_BK01_04_H      _PK_H_(0x01, 0x04)
#define REG_SC_BK01_05_L      _PK_L_(0x01, 0x05)
#define REG_SC_BK01_05_H      _PK_H_(0x01, 0x05)
#define REG_SC_BK01_06_L      _PK_L_(0x01, 0x06)
#define REG_SC_BK01_06_H      _PK_H_(0x01, 0x06)
#define REG_SC_BK01_07_L      _PK_L_(0x01, 0x07)
#define REG_SC_BK01_07_H      _PK_H_(0x01, 0x07)
#define REG_SC_BK01_08_L      _PK_L_(0x01, 0x08)
#define REG_SC_BK01_08_H      _PK_H_(0x01, 0x08)
#define REG_SC_BK01_09_L      _PK_L_(0x01, 0x09)
#define REG_SC_BK01_09_H      _PK_H_(0x01, 0x09)
#define REG_SC_BK01_0A_L      _PK_L_(0x01, 0x0A)
#define REG_SC_BK01_0A_H      _PK_H_(0x01, 0x0A)
#define REG_SC_BK01_0B_L      _PK_L_(0x01, 0x0B)
#define REG_SC_BK01_0B_H      _PK_H_(0x01, 0x0B)
#define REG_SC_BK01_0C_L      _PK_L_(0x01, 0x0C)
#define REG_SC_BK01_0C_H      _PK_H_(0x01, 0x0C)
#define REG_SC_BK01_0D_L      _PK_L_(0x01, 0x0D)
#define REG_SC_BK01_0D_H      _PK_H_(0x01, 0x0D)
#define REG_SC_BK01_0E_L      _PK_L_(0x01, 0x0E)
#define REG_SC_BK01_0E_H      _PK_H_(0x01, 0x0E)
#define REG_SC_BK01_0F_L      _PK_L_(0x01, 0x0F)
#define REG_SC_BK01_0F_H      _PK_H_(0x01, 0x0F)
#define REG_SC_BK01_10_L      _PK_L_(0x01, 0x10)
#define REG_SC_BK01_10_H      _PK_H_(0x01, 0x10)
#define REG_SC_BK01_11_L      _PK_L_(0x01, 0x11)
#define REG_SC_BK01_11_H      _PK_H_(0x01, 0x11)
#define REG_SC_BK01_12_L      _PK_L_(0x01, 0x12)
#define REG_SC_BK01_12_H      _PK_H_(0x01, 0x12)
#define REG_SC_BK01_13_L      _PK_L_(0x01, 0x13)
#define REG_SC_BK01_13_H      _PK_H_(0x01, 0x13)
#define REG_SC_BK01_14_L      _PK_L_(0x01, 0x14)
#define REG_SC_BK01_14_H      _PK_H_(0x01, 0x14)
#define REG_SC_BK01_15_L      _PK_L_(0x01, 0x15)
#define REG_SC_BK01_15_H      _PK_H_(0x01, 0x15)
#define REG_SC_BK01_16_L      _PK_L_(0x01, 0x16)
#define REG_SC_BK01_16_H      _PK_H_(0x01, 0x16)
#define REG_SC_BK01_17_L      _PK_L_(0x01, 0x17)
#define REG_SC_BK01_17_H      _PK_H_(0x01, 0x17)
#define REG_SC_BK01_18_L      _PK_L_(0x01, 0x18)
#define REG_SC_BK01_18_H      _PK_H_(0x01, 0x18)
#define REG_SC_BK01_19_L      _PK_L_(0x01, 0x19)
#define REG_SC_BK01_19_H      _PK_H_(0x01, 0x19)
#define REG_SC_BK01_1A_L      _PK_L_(0x01, 0x1A)
#define REG_SC_BK01_1A_H      _PK_H_(0x01, 0x1A)
#define REG_SC_BK01_1B_L      _PK_L_(0x01, 0x1B)
#define REG_SC_BK01_1B_H      _PK_H_(0x01, 0x1B)
#define REG_SC_BK01_1C_L      _PK_L_(0x01, 0x1C)
#define REG_SC_BK01_1C_H      _PK_H_(0x01, 0x1C)
#define REG_SC_BK01_1D_L      _PK_L_(0x01, 0x1D)
#define REG_SC_BK01_1D_H      _PK_H_(0x01, 0x1D)
#define REG_SC_BK01_1E_L      _PK_L_(0x01, 0x1E)
#define REG_SC_BK01_1E_H      _PK_H_(0x01, 0x1E)
#define REG_SC_BK01_1F_L      _PK_L_(0x01, 0x1F)
#define REG_SC_BK01_1F_H      _PK_H_(0x01, 0x1F)
#define REG_SC_BK01_20_L      _PK_L_(0x01, 0x20)
#define REG_SC_BK01_20_H      _PK_H_(0x01, 0x20)
#define REG_SC_BK01_21_L      _PK_L_(0x01, 0x21)
#define REG_SC_BK01_21_H      _PK_H_(0x01, 0x21)
#define REG_SC_BK01_22_L      _PK_L_(0x01, 0x22)
#define REG_SC_BK01_22_H      _PK_H_(0x01, 0x22)
#define REG_SC_BK01_23_L      _PK_L_(0x01, 0x23)
#define REG_SC_BK01_23_H      _PK_H_(0x01, 0x23)
#define REG_SC_BK01_24_L      _PK_L_(0x01, 0x24)
#define REG_SC_BK01_24_H      _PK_H_(0x01, 0x24)
#define REG_SC_BK01_25_L      _PK_L_(0x01, 0x25)
#define REG_SC_BK01_25_H      _PK_H_(0x01, 0x25)
#define REG_SC_BK01_26_L      _PK_L_(0x01, 0x26)
#define REG_SC_BK01_26_H      _PK_H_(0x01, 0x26)
#define REG_SC_BK01_27_L      _PK_L_(0x01, 0x27)
#define REG_SC_BK01_27_H      _PK_H_(0x01, 0x27)
#define REG_SC_BK01_28_L      _PK_L_(0x01, 0x28)
#define REG_SC_BK01_28_H      _PK_H_(0x01, 0x28)
#define REG_SC_BK01_29_L      _PK_L_(0x01, 0x29)
#define REG_SC_BK01_29_H      _PK_H_(0x01, 0x29)
#define REG_SC_BK01_2A_L      _PK_L_(0x01, 0x2A)
#define REG_SC_BK01_2A_H      _PK_H_(0x01, 0x2A)
#define REG_SC_BK01_2B_L      _PK_L_(0x01, 0x2B)
#define REG_SC_BK01_2B_H      _PK_H_(0x01, 0x2B)
#define REG_SC_BK01_2C_L      _PK_L_(0x01, 0x2C)
#define REG_SC_BK01_2C_H      _PK_H_(0x01, 0x2C)
#define REG_SC_BK01_2D_L      _PK_L_(0x01, 0x2D)
#define REG_SC_BK01_2D_H      _PK_H_(0x01, 0x2D)
#define REG_SC_BK01_2E_L      _PK_L_(0x01, 0x2E)
#define REG_SC_BK01_2E_H      _PK_H_(0x01, 0x2E)
#define REG_SC_BK01_2F_L      _PK_L_(0x01, 0x2F)
#define REG_SC_BK01_2F_H      _PK_H_(0x01, 0x2F)
#define REG_SC_BK01_30_L      _PK_L_(0x01, 0x30)
#define REG_SC_BK01_30_H      _PK_H_(0x01, 0x30)
#define REG_SC_BK01_31_L      _PK_L_(0x01, 0x31)
#define REG_SC_BK01_31_H      _PK_H_(0x01, 0x31)
#define REG_SC_BK01_32_L      _PK_L_(0x01, 0x32)
#define REG_SC_BK01_32_H      _PK_H_(0x01, 0x32)
#define REG_SC_BK01_33_L      _PK_L_(0x01, 0x33)
#define REG_SC_BK01_33_H      _PK_H_(0x01, 0x33)
#define REG_SC_BK01_34_L      _PK_L_(0x01, 0x34)
#define REG_SC_BK01_34_H      _PK_H_(0x01, 0x34)
#define REG_SC_BK01_35_L      _PK_L_(0x01, 0x35)
#define REG_SC_BK01_35_H      _PK_H_(0x01, 0x35)
#define REG_SC_BK01_36_L      _PK_L_(0x01, 0x36)
#define REG_SC_BK01_36_H      _PK_H_(0x01, 0x36)
#define REG_SC_BK01_37_L      _PK_L_(0x01, 0x37)
#define REG_SC_BK01_37_H      _PK_H_(0x01, 0x37)
#define REG_SC_BK01_38_L      _PK_L_(0x01, 0x38)
#define REG_SC_BK01_38_H      _PK_H_(0x01, 0x38)
#define REG_SC_BK01_39_L      _PK_L_(0x01, 0x39)
#define REG_SC_BK01_39_H      _PK_H_(0x01, 0x39)
#define REG_SC_BK01_3A_L      _PK_L_(0x01, 0x3A)
#define REG_SC_BK01_3A_H      _PK_H_(0x01, 0x3A)
#define REG_SC_BK01_3B_L      _PK_L_(0x01, 0x3B)
#define REG_SC_BK01_3B_H      _PK_H_(0x01, 0x3B)
#define REG_SC_BK01_3C_L      _PK_L_(0x01, 0x3C)
#define REG_SC_BK01_3C_H      _PK_H_(0x01, 0x3C)
#define REG_SC_BK01_3D_L      _PK_L_(0x01, 0x3D)
#define REG_SC_BK01_3D_H      _PK_H_(0x01, 0x3D)
#define REG_SC_BK01_3E_L      _PK_L_(0x01, 0x3E)
#define REG_SC_BK01_3E_H      _PK_H_(0x01, 0x3E)
#define REG_SC_BK01_3F_L      _PK_L_(0x01, 0x3F)
#define REG_SC_BK01_3F_H      _PK_H_(0x01, 0x3F)
#define REG_SC_BK01_40_L      _PK_L_(0x01, 0x40)
#define REG_SC_BK01_40_H      _PK_H_(0x01, 0x40)
#define REG_SC_BK01_41_L      _PK_L_(0x01, 0x41)
#define REG_SC_BK01_41_H      _PK_H_(0x01, 0x41)
#define REG_SC_BK01_42_L      _PK_L_(0x01, 0x42)
#define REG_SC_BK01_42_H      _PK_H_(0x01, 0x42)
#define REG_SC_BK01_43_L      _PK_L_(0x01, 0x43)
#define REG_SC_BK01_43_H      _PK_H_(0x01, 0x43)
#define REG_SC_BK01_44_L      _PK_L_(0x01, 0x44)
#define REG_SC_BK01_44_H      _PK_H_(0x01, 0x44)
#define REG_SC_BK01_45_L      _PK_L_(0x01, 0x45)
#define REG_SC_BK01_45_H      _PK_H_(0x01, 0x45)
#define REG_SC_BK01_46_L      _PK_L_(0x01, 0x46)
#define REG_SC_BK01_46_H      _PK_H_(0x01, 0x46)
#define REG_SC_BK01_47_L      _PK_L_(0x01, 0x47)
#define REG_SC_BK01_47_H      _PK_H_(0x01, 0x47)
#define REG_SC_BK01_48_L      _PK_L_(0x01, 0x48)
#define REG_SC_BK01_48_H      _PK_H_(0x01, 0x48)
#define REG_SC_BK01_49_L      _PK_L_(0x01, 0x49)
#define REG_SC_BK01_49_H      _PK_H_(0x01, 0x49)
#define REG_SC_BK01_4A_L      _PK_L_(0x01, 0x4A)
#define REG_SC_BK01_4A_H      _PK_H_(0x01, 0x4A)
#define REG_SC_BK01_4B_L      _PK_L_(0x01, 0x4B)
#define REG_SC_BK01_4B_H      _PK_H_(0x01, 0x4B)
#define REG_SC_BK01_4C_L      _PK_L_(0x01, 0x4C)
#define REG_SC_BK01_4C_H      _PK_H_(0x01, 0x4C)
#define REG_SC_BK01_4D_L      _PK_L_(0x01, 0x4D)
#define REG_SC_BK01_4D_H      _PK_H_(0x01, 0x4D)
#define REG_SC_BK01_4E_L      _PK_L_(0x01, 0x4E)
#define REG_SC_BK01_4E_H      _PK_H_(0x01, 0x4E)
#define REG_SC_BK01_4F_L      _PK_L_(0x01, 0x4F)
#define REG_SC_BK01_4F_H      _PK_H_(0x01, 0x4F)
#define REG_SC_BK01_50_L      _PK_L_(0x01, 0x50)
#define REG_SC_BK01_50_H      _PK_H_(0x01, 0x50)
#define REG_SC_BK01_51_L      _PK_L_(0x01, 0x51)
#define REG_SC_BK01_51_H      _PK_H_(0x01, 0x51)
#define REG_SC_BK01_52_L      _PK_L_(0x01, 0x52)
#define REG_SC_BK01_52_H      _PK_H_(0x01, 0x52)
#define REG_SC_BK01_53_L      _PK_L_(0x01, 0x53)
#define REG_SC_BK01_53_H      _PK_H_(0x01, 0x53)
#define REG_SC_BK01_54_L      _PK_L_(0x01, 0x54)
#define REG_SC_BK01_54_H      _PK_H_(0x01, 0x54)
#define REG_SC_BK01_55_L      _PK_L_(0x01, 0x55)
#define REG_SC_BK01_55_H      _PK_H_(0x01, 0x55)
#define REG_SC_BK01_56_L      _PK_L_(0x01, 0x56)
#define REG_SC_BK01_56_H      _PK_H_(0x01, 0x56)
#define REG_SC_BK01_57_L      _PK_L_(0x01, 0x57)
#define REG_SC_BK01_57_H      _PK_H_(0x01, 0x57)
#define REG_SC_BK01_58_L      _PK_L_(0x01, 0x58)
#define REG_SC_BK01_58_H      _PK_H_(0x01, 0x58)
#define REG_SC_BK01_59_L      _PK_L_(0x01, 0x59)
#define REG_SC_BK01_59_H      _PK_H_(0x01, 0x59)
#define REG_SC_BK01_5A_L      _PK_L_(0x01, 0x5A)
#define REG_SC_BK01_5A_H      _PK_H_(0x01, 0x5A)
#define REG_SC_BK01_5B_L      _PK_L_(0x01, 0x5B)
#define REG_SC_BK01_5B_H      _PK_H_(0x01, 0x5B)
#define REG_SC_BK01_5C_L      _PK_L_(0x01, 0x5C)
#define REG_SC_BK01_5C_H      _PK_H_(0x01, 0x5C)
#define REG_SC_BK01_5D_L      _PK_L_(0x01, 0x5D)
#define REG_SC_BK01_5D_H      _PK_H_(0x01, 0x5D)
#define REG_SC_BK01_5E_L      _PK_L_(0x01, 0x5E)
#define REG_SC_BK01_5E_H      _PK_H_(0x01, 0x5E)
#define REG_SC_BK01_5F_L      _PK_L_(0x01, 0x5F)
#define REG_SC_BK01_5F_H      _PK_H_(0x01, 0x5F)
#define REG_SC_BK01_60_L      _PK_L_(0x01, 0x60)
#define REG_SC_BK01_60_H      _PK_H_(0x01, 0x60)
#define REG_SC_BK01_61_L      _PK_L_(0x01, 0x61)
#define REG_SC_BK01_61_H      _PK_H_(0x01, 0x61)
#define REG_SC_BK01_62_L      _PK_L_(0x01, 0x62)
#define REG_SC_BK01_62_H      _PK_H_(0x01, 0x62)
#define REG_SC_BK01_63_L      _PK_L_(0x01, 0x63)
#define REG_SC_BK01_63_H      _PK_H_(0x01, 0x63)
#define REG_SC_BK01_64_L      _PK_L_(0x01, 0x64)
#define REG_SC_BK01_64_H      _PK_H_(0x01, 0x64)
#define REG_SC_BK01_65_L      _PK_L_(0x01, 0x65)
#define REG_SC_BK01_65_H      _PK_H_(0x01, 0x65)
#define REG_SC_BK01_66_L      _PK_L_(0x01, 0x66)
#define REG_SC_BK01_66_H      _PK_H_(0x01, 0x66)
#define REG_SC_BK01_67_L      _PK_L_(0x01, 0x67)
#define REG_SC_BK01_67_H      _PK_H_(0x01, 0x67)
#define REG_SC_BK01_68_L      _PK_L_(0x01, 0x68)
#define REG_SC_BK01_68_H      _PK_H_(0x01, 0x68)
#define REG_SC_BK01_69_L      _PK_L_(0x01, 0x69)
#define REG_SC_BK01_69_H      _PK_H_(0x01, 0x69)
#define REG_SC_BK01_6A_L      _PK_L_(0x01, 0x6A)
#define REG_SC_BK01_6A_H      _PK_H_(0x01, 0x6A)
#define REG_SC_BK01_6B_L      _PK_L_(0x01, 0x6B)
#define REG_SC_BK01_6B_H      _PK_H_(0x01, 0x6B)
#define REG_SC_BK01_6C_L      _PK_L_(0x01, 0x6C)
#define REG_SC_BK01_6C_H      _PK_H_(0x01, 0x6C)
#define REG_SC_BK01_6D_L      _PK_L_(0x01, 0x6D)
#define REG_SC_BK01_6D_H      _PK_H_(0x01, 0x6D)
#define REG_SC_BK01_6E_L      _PK_L_(0x01, 0x6E)
#define REG_SC_BK01_6E_H      _PK_H_(0x01, 0x6E)
#define REG_SC_BK01_6F_L      _PK_L_(0x01, 0x6F)
#define REG_SC_BK01_6F_H      _PK_H_(0x01, 0x6F)
#define REG_SC_BK01_70_L      _PK_L_(0x01, 0x70)
#define REG_SC_BK01_70_H      _PK_H_(0x01, 0x70)
#define REG_SC_BK01_71_L      _PK_L_(0x01, 0x71)
#define REG_SC_BK01_71_H      _PK_H_(0x01, 0x71)
#define REG_SC_BK01_72_L      _PK_L_(0x01, 0x72)
#define REG_SC_BK01_72_H      _PK_H_(0x01, 0x72)
#define REG_SC_BK01_73_L      _PK_L_(0x01, 0x73)
#define REG_SC_BK01_73_H      _PK_H_(0x01, 0x73)
#define REG_SC_BK01_74_L      _PK_L_(0x01, 0x74)
#define REG_SC_BK01_74_H      _PK_H_(0x01, 0x74)
#define REG_SC_BK01_75_L      _PK_L_(0x01, 0x75)
#define REG_SC_BK01_75_H      _PK_H_(0x01, 0x75)
#define REG_SC_BK01_76_L      _PK_L_(0x01, 0x76)
#define REG_SC_BK01_76_H      _PK_H_(0x01, 0x76)
#define REG_SC_BK01_77_L      _PK_L_(0x01, 0x77)
#define REG_SC_BK01_77_H      _PK_H_(0x01, 0x77)
#define REG_SC_BK01_78_L      _PK_L_(0x01, 0x78)
#define REG_SC_BK01_78_H      _PK_H_(0x01, 0x78)
#define REG_SC_BK01_79_L      _PK_L_(0x01, 0x79)
#define REG_SC_BK01_79_H      _PK_H_(0x01, 0x79)
#define REG_SC_BK01_7A_L      _PK_L_(0x01, 0x7A)
#define REG_SC_BK01_7A_H      _PK_H_(0x01, 0x7A)
#define REG_SC_BK01_7B_L      _PK_L_(0x01, 0x7B)
#define REG_SC_BK01_7B_H      _PK_H_(0x01, 0x7B)
#define REG_SC_BK01_7C_L      _PK_L_(0x01, 0x7C)
#define REG_SC_BK01_7C_H      _PK_H_(0x01, 0x7C)
#define REG_SC_BK01_7D_L      _PK_L_(0x01, 0x7D)
#define REG_SC_BK01_7D_H      _PK_H_(0x01, 0x7D)
#define REG_SC_BK01_7E_L      _PK_L_(0x01, 0x7E)
#define REG_SC_BK01_7E_H      _PK_H_(0x01, 0x7E)
#define REG_SC_BK01_7F_L      _PK_L_(0x01, 0x7F)
#define REG_SC_BK01_7F_H      _PK_H_(0x01, 0x7F)


//----------------------------------------------
//  BK02: IP2F2
//----------------------------------------------
#define REG_SC_BK02_00_L      _PK_L_(0x02, 0x00)
#define REG_SC_BK02_00_H      _PK_H_(0x02, 0x00)
#define REG_SC_BK02_01_L      _PK_L_(0x02, 0x01)
#define REG_SC_BK02_01_H      _PK_H_(0x02, 0x01)
#define REG_SC_BK02_02_L      _PK_L_(0x02, 0x02)
#define REG_SC_BK02_02_H      _PK_H_(0x02, 0x02)
#define REG_SC_BK02_03_L      _PK_L_(0x02, 0x03)
#define REG_SC_BK02_03_H      _PK_H_(0x02, 0x03)
#define REG_SC_BK02_04_L      _PK_L_(0x02, 0x04)
#define REG_SC_BK02_04_H      _PK_H_(0x02, 0x04)
#define REG_SC_BK02_05_L      _PK_L_(0x02, 0x05)
#define REG_SC_BK02_05_H      _PK_H_(0x02, 0x05)
#define REG_SC_BK02_06_L      _PK_L_(0x02, 0x06)
#define REG_SC_BK02_06_H      _PK_H_(0x02, 0x06)
#define REG_SC_BK02_07_L      _PK_L_(0x02, 0x07)
#define REG_SC_BK02_07_H      _PK_H_(0x02, 0x07)
#define REG_SC_BK02_08_L      _PK_L_(0x02, 0x08)
#define REG_SC_BK02_08_H      _PK_H_(0x02, 0x08)
#define REG_SC_BK02_09_L      _PK_L_(0x02, 0x09)
#define REG_SC_BK02_09_H      _PK_H_(0x02, 0x09)
#define REG_SC_BK02_0A_L      _PK_L_(0x02, 0x0A)
#define REG_SC_BK02_0A_H      _PK_H_(0x02, 0x0A)
#define REG_SC_BK02_0B_L      _PK_L_(0x02, 0x0B)
#define REG_SC_BK02_0B_H      _PK_H_(0x02, 0x0B)
#define REG_SC_BK02_0C_L      _PK_L_(0x02, 0x0C)
#define REG_SC_BK02_0C_H      _PK_H_(0x02, 0x0C)
#define REG_SC_BK02_0D_L      _PK_L_(0x02, 0x0D)
#define REG_SC_BK02_0D_H      _PK_H_(0x02, 0x0D)
#define REG_SC_BK02_0E_L      _PK_L_(0x02, 0x0E)
#define REG_SC_BK02_0E_H      _PK_H_(0x02, 0x0E)
#define REG_SC_BK02_0F_L      _PK_L_(0x02, 0x0F)
#define REG_SC_BK02_0F_H      _PK_H_(0x02, 0x0F)
#define REG_SC_BK02_10_L      _PK_L_(0x02, 0x10)
#define REG_SC_BK02_10_H      _PK_H_(0x02, 0x10)
#define REG_SC_BK02_11_L      _PK_L_(0x02, 0x11)
#define REG_SC_BK02_11_H      _PK_H_(0x02, 0x11)
#define REG_SC_BK02_12_L      _PK_L_(0x02, 0x12)
#define REG_SC_BK02_12_H      _PK_H_(0x02, 0x12)
#define REG_SC_BK02_13_L      _PK_L_(0x02, 0x13)
#define REG_SC_BK02_13_H      _PK_H_(0x02, 0x13)
#define REG_SC_BK02_14_L      _PK_L_(0x02, 0x14)
#define REG_SC_BK02_14_H      _PK_H_(0x02, 0x14)
#define REG_SC_BK02_15_L      _PK_L_(0x02, 0x15)
#define REG_SC_BK02_15_H      _PK_H_(0x02, 0x15)
#define REG_SC_BK02_16_L      _PK_L_(0x02, 0x16)
#define REG_SC_BK02_16_H      _PK_H_(0x02, 0x16)
#define REG_SC_BK02_17_L      _PK_L_(0x02, 0x17)
#define REG_SC_BK02_17_H      _PK_H_(0x02, 0x17)
#define REG_SC_BK02_18_L      _PK_L_(0x02, 0x18)
#define REG_SC_BK02_18_H      _PK_H_(0x02, 0x18)
#define REG_SC_BK02_19_L      _PK_L_(0x02, 0x19)
#define REG_SC_BK02_19_H      _PK_H_(0x02, 0x19)
#define REG_SC_BK02_1A_L      _PK_L_(0x02, 0x1A)
#define REG_SC_BK02_1A_H      _PK_H_(0x02, 0x1A)
#define REG_SC_BK02_1B_L      _PK_L_(0x02, 0x1B)
#define REG_SC_BK02_1B_H      _PK_H_(0x02, 0x1B)
#define REG_SC_BK02_1C_L      _PK_L_(0x02, 0x1C)
#define REG_SC_BK02_1C_H      _PK_H_(0x02, 0x1C)
#define REG_SC_BK02_1D_L      _PK_L_(0x02, 0x1D)
#define REG_SC_BK02_1D_H      _PK_H_(0x02, 0x1D)
#define REG_SC_BK02_1E_L      _PK_L_(0x02, 0x1E)
#define REG_SC_BK02_1E_H      _PK_H_(0x02, 0x1E)
#define REG_SC_BK02_1F_L      _PK_L_(0x02, 0x1F)
#define REG_SC_BK02_1F_H      _PK_H_(0x02, 0x1F)
#define REG_SC_BK02_20_L      _PK_L_(0x02, 0x20)
#define REG_SC_BK02_20_H      _PK_H_(0x02, 0x20)
#define REG_SC_BK02_21_L      _PK_L_(0x02, 0x21)
#define REG_SC_BK02_21_H      _PK_H_(0x02, 0x21)
#define REG_SC_BK02_22_L      _PK_L_(0x02, 0x22)
#define REG_SC_BK02_22_H      _PK_H_(0x02, 0x22)
#define REG_SC_BK02_23_L      _PK_L_(0x02, 0x23)
#define REG_SC_BK02_23_H      _PK_H_(0x02, 0x23)
#define REG_SC_BK02_24_L      _PK_L_(0x02, 0x24)
#define REG_SC_BK02_24_H      _PK_H_(0x02, 0x24)
#define REG_SC_BK02_25_L      _PK_L_(0x02, 0x25)
#define REG_SC_BK02_25_H      _PK_H_(0x02, 0x25)
#define REG_SC_BK02_26_L      _PK_L_(0x02, 0x26)
#define REG_SC_BK02_26_H      _PK_H_(0x02, 0x26)
#define REG_SC_BK02_27_L      _PK_L_(0x02, 0x27)
#define REG_SC_BK02_27_H      _PK_H_(0x02, 0x27)
#define REG_SC_BK02_28_L      _PK_L_(0x02, 0x28)
#define REG_SC_BK02_28_H      _PK_H_(0x02, 0x28)
#define REG_SC_BK02_29_L      _PK_L_(0x02, 0x29)
#define REG_SC_BK02_29_H      _PK_H_(0x02, 0x29)
#define REG_SC_BK02_2A_L      _PK_L_(0x02, 0x2A)
#define REG_SC_BK02_2A_H      _PK_H_(0x02, 0x2A)
#define REG_SC_BK02_2B_L      _PK_L_(0x02, 0x2B)
#define REG_SC_BK02_2B_H      _PK_H_(0x02, 0x2B)
#define REG_SC_BK02_2C_L      _PK_L_(0x02, 0x2C)
#define REG_SC_BK02_2C_H      _PK_H_(0x02, 0x2C)
#define REG_SC_BK02_2D_L      _PK_L_(0x02, 0x2D)
#define REG_SC_BK02_2D_H      _PK_H_(0x02, 0x2D)
#define REG_SC_BK02_2E_L      _PK_L_(0x02, 0x2E)
#define REG_SC_BK02_2E_H      _PK_H_(0x02, 0x2E)
#define REG_SC_BK02_2F_L      _PK_L_(0x02, 0x2F)
#define REG_SC_BK02_2F_H      _PK_H_(0x02, 0x2F)
#define REG_SC_BK02_30_L      _PK_L_(0x02, 0x30)
#define REG_SC_BK02_30_H      _PK_H_(0x02, 0x30)
#define REG_SC_BK02_31_L      _PK_L_(0x02, 0x31)
#define REG_SC_BK02_31_H      _PK_H_(0x02, 0x31)
#define REG_SC_BK02_32_L      _PK_L_(0x02, 0x32)
#define REG_SC_BK02_32_H      _PK_H_(0x02, 0x32)
#define REG_SC_BK02_33_L      _PK_L_(0x02, 0x33)
#define REG_SC_BK02_33_H      _PK_H_(0x02, 0x33)
#define REG_SC_BK02_34_L      _PK_L_(0x02, 0x34)
#define REG_SC_BK02_34_H      _PK_H_(0x02, 0x34)
#define REG_SC_BK02_35_L      _PK_L_(0x02, 0x35)
#define REG_SC_BK02_35_H      _PK_H_(0x02, 0x35)
#define REG_SC_BK02_36_L      _PK_L_(0x02, 0x36)
#define REG_SC_BK02_36_H      _PK_H_(0x02, 0x36)
#define REG_SC_BK02_37_L      _PK_L_(0x02, 0x37)
#define REG_SC_BK02_37_H      _PK_H_(0x02, 0x37)
#define REG_SC_BK02_38_L      _PK_L_(0x02, 0x38)
#define REG_SC_BK02_38_H      _PK_H_(0x02, 0x38)
#define REG_SC_BK02_39_L      _PK_L_(0x02, 0x39)
#define REG_SC_BK02_39_H      _PK_H_(0x02, 0x39)
#define REG_SC_BK02_3A_L      _PK_L_(0x02, 0x3A)
#define REG_SC_BK02_3A_H      _PK_H_(0x02, 0x3A)
#define REG_SC_BK02_3B_L      _PK_L_(0x02, 0x3B)
#define REG_SC_BK02_3B_H      _PK_H_(0x02, 0x3B)
#define REG_SC_BK02_3C_L      _PK_L_(0x02, 0x3C)
#define REG_SC_BK02_3C_H      _PK_H_(0x02, 0x3C)
#define REG_SC_BK02_3D_L      _PK_L_(0x02, 0x3D)
#define REG_SC_BK02_3D_H      _PK_H_(0x02, 0x3D)
#define REG_SC_BK02_3E_L      _PK_L_(0x02, 0x3E)
#define REG_SC_BK02_3E_H      _PK_H_(0x02, 0x3E)
#define REG_SC_BK02_3F_L      _PK_L_(0x02, 0x3F)
#define REG_SC_BK02_3F_H      _PK_H_(0x02, 0x3F)
#define REG_SC_BK02_40_L      _PK_L_(0x02, 0x40)
#define REG_SC_BK02_40_H      _PK_H_(0x02, 0x40)
#define REG_SC_BK02_41_L      _PK_L_(0x02, 0x41)
#define REG_SC_BK02_41_H      _PK_H_(0x02, 0x41)
#define REG_SC_BK02_42_L      _PK_L_(0x02, 0x42)
#define REG_SC_BK02_42_H      _PK_H_(0x02, 0x42)
#define REG_SC_BK02_43_L      _PK_L_(0x02, 0x43)
#define REG_SC_BK02_43_H      _PK_H_(0x02, 0x43)
#define REG_SC_BK02_44_L      _PK_L_(0x02, 0x44)
#define REG_SC_BK02_44_H      _PK_H_(0x02, 0x44)
#define REG_SC_BK02_45_L      _PK_L_(0x02, 0x45)
#define REG_SC_BK02_45_H      _PK_H_(0x02, 0x45)
#define REG_SC_BK02_46_L      _PK_L_(0x02, 0x46)
#define REG_SC_BK02_46_H      _PK_H_(0x02, 0x46)
#define REG_SC_BK02_47_L      _PK_L_(0x02, 0x47)
#define REG_SC_BK02_47_H      _PK_H_(0x02, 0x47)
#define REG_SC_BK02_48_L      _PK_L_(0x02, 0x48)
#define REG_SC_BK02_48_H      _PK_H_(0x02, 0x48)
#define REG_SC_BK02_49_L      _PK_L_(0x02, 0x49)
#define REG_SC_BK02_49_H      _PK_H_(0x02, 0x49)
#define REG_SC_BK02_4A_L      _PK_L_(0x02, 0x4A)
#define REG_SC_BK02_4A_H      _PK_H_(0x02, 0x4A)
#define REG_SC_BK02_4B_L      _PK_L_(0x02, 0x4B)
#define REG_SC_BK02_4B_H      _PK_H_(0x02, 0x4B)
#define REG_SC_BK02_4C_L      _PK_L_(0x02, 0x4C)
#define REG_SC_BK02_4C_H      _PK_H_(0x02, 0x4C)
#define REG_SC_BK02_4D_L      _PK_L_(0x02, 0x4D)
#define REG_SC_BK02_4D_H      _PK_H_(0x02, 0x4D)
#define REG_SC_BK02_4E_L      _PK_L_(0x02, 0x4E)
#define REG_SC_BK02_4E_H      _PK_H_(0x02, 0x4E)
#define REG_SC_BK02_4F_L      _PK_L_(0x02, 0x4F)
#define REG_SC_BK02_4F_H      _PK_H_(0x02, 0x4F)
#define REG_SC_BK02_50_L      _PK_L_(0x02, 0x50)
#define REG_SC_BK02_50_H      _PK_H_(0x02, 0x50)
#define REG_SC_BK02_51_L      _PK_L_(0x02, 0x51)
#define REG_SC_BK02_51_H      _PK_H_(0x02, 0x51)
#define REG_SC_BK02_52_L      _PK_L_(0x02, 0x52)
#define REG_SC_BK02_52_H      _PK_H_(0x02, 0x52)
#define REG_SC_BK02_53_L      _PK_L_(0x02, 0x53)
#define REG_SC_BK02_53_H      _PK_H_(0x02, 0x53)
#define REG_SC_BK02_54_L      _PK_L_(0x02, 0x54)
#define REG_SC_BK02_54_H      _PK_H_(0x02, 0x54)
#define REG_SC_BK02_55_L      _PK_L_(0x02, 0x55)
#define REG_SC_BK02_55_H      _PK_H_(0x02, 0x55)
#define REG_SC_BK02_56_L      _PK_L_(0x02, 0x56)
#define REG_SC_BK02_56_H      _PK_H_(0x02, 0x56)
#define REG_SC_BK02_57_L      _PK_L_(0x02, 0x57)
#define REG_SC_BK02_57_H      _PK_H_(0x02, 0x57)
#define REG_SC_BK02_58_L      _PK_L_(0x02, 0x58)
#define REG_SC_BK02_58_H      _PK_H_(0x02, 0x58)
#define REG_SC_BK02_59_L      _PK_L_(0x02, 0x59)
#define REG_SC_BK02_59_H      _PK_H_(0x02, 0x59)
#define REG_SC_BK02_5A_L      _PK_L_(0x02, 0x5A)
#define REG_SC_BK02_5A_H      _PK_H_(0x02, 0x5A)
#define REG_SC_BK02_5B_L      _PK_L_(0x02, 0x5B)
#define REG_SC_BK02_5B_H      _PK_H_(0x02, 0x5B)
#define REG_SC_BK02_5C_L      _PK_L_(0x02, 0x5C)
#define REG_SC_BK02_5C_H      _PK_H_(0x02, 0x5C)
#define REG_SC_BK02_5D_L      _PK_L_(0x02, 0x5D)
#define REG_SC_BK02_5D_H      _PK_H_(0x02, 0x5D)
#define REG_SC_BK02_5E_L      _PK_L_(0x02, 0x5E)
#define REG_SC_BK02_5E_H      _PK_H_(0x02, 0x5E)
#define REG_SC_BK02_5F_L      _PK_L_(0x02, 0x5F)
#define REG_SC_BK02_5F_H      _PK_H_(0x02, 0x5F)
#define REG_SC_BK02_60_L      _PK_L_(0x02, 0x60)
#define REG_SC_BK02_60_H      _PK_H_(0x02, 0x60)
#define REG_SC_BK02_61_L      _PK_L_(0x02, 0x61)
#define REG_SC_BK02_61_H      _PK_H_(0x02, 0x61)
#define REG_SC_BK02_62_L      _PK_L_(0x02, 0x62)
#define REG_SC_BK02_62_H      _PK_H_(0x02, 0x62)
#define REG_SC_BK02_63_L      _PK_L_(0x02, 0x63)
#define REG_SC_BK02_63_H      _PK_H_(0x02, 0x63)
#define REG_SC_BK02_64_L      _PK_L_(0x02, 0x64)
#define REG_SC_BK02_64_H      _PK_H_(0x02, 0x64)
#define REG_SC_BK02_65_L      _PK_L_(0x02, 0x65)
#define REG_SC_BK02_65_H      _PK_H_(0x02, 0x65)
#define REG_SC_BK02_66_L      _PK_L_(0x02, 0x66)
#define REG_SC_BK02_66_H      _PK_H_(0x02, 0x66)
#define REG_SC_BK02_67_L      _PK_L_(0x02, 0x67)
#define REG_SC_BK02_67_H      _PK_H_(0x02, 0x67)
#define REG_SC_BK02_68_L      _PK_L_(0x02, 0x68)
#define REG_SC_BK02_68_H      _PK_H_(0x02, 0x68)
#define REG_SC_BK02_69_L      _PK_L_(0x02, 0x69)
#define REG_SC_BK02_69_H      _PK_H_(0x02, 0x69)
#define REG_SC_BK02_6A_L      _PK_L_(0x02, 0x6A)
#define REG_SC_BK02_6A_H      _PK_H_(0x02, 0x6A)
#define REG_SC_BK02_6B_L      _PK_L_(0x02, 0x6B)
#define REG_SC_BK02_6B_H      _PK_H_(0x02, 0x6B)
#define REG_SC_BK02_6C_L      _PK_L_(0x02, 0x6C)
#define REG_SC_BK02_6C_H      _PK_H_(0x02, 0x6C)
#define REG_SC_BK02_6D_L      _PK_L_(0x02, 0x6D)
#define REG_SC_BK02_6D_H      _PK_H_(0x02, 0x6D)
#define REG_SC_BK02_6E_L      _PK_L_(0x02, 0x6E)
#define REG_SC_BK02_6E_H      _PK_H_(0x02, 0x6E)
#define REG_SC_BK02_6F_L      _PK_L_(0x02, 0x6F)
#define REG_SC_BK02_6F_H      _PK_H_(0x02, 0x6F)
#define REG_SC_BK02_70_L      _PK_L_(0x02, 0x70)
#define REG_SC_BK02_70_H      _PK_H_(0x02, 0x70)
#define REG_SC_BK02_71_L      _PK_L_(0x02, 0x71)
#define REG_SC_BK02_71_H      _PK_H_(0x02, 0x71)
#define REG_SC_BK02_72_L      _PK_L_(0x02, 0x72)
#define REG_SC_BK02_72_H      _PK_H_(0x02, 0x72)
#define REG_SC_BK02_73_L      _PK_L_(0x02, 0x73)
#define REG_SC_BK02_73_H      _PK_H_(0x02, 0x73)
#define REG_SC_BK02_74_L      _PK_L_(0x02, 0x74)
#define REG_SC_BK02_74_H      _PK_H_(0x02, 0x74)
#define REG_SC_BK02_75_L      _PK_L_(0x02, 0x75)
#define REG_SC_BK02_75_H      _PK_H_(0x02, 0x75)
#define REG_SC_BK02_76_L      _PK_L_(0x02, 0x76)
#define REG_SC_BK02_76_H      _PK_H_(0x02, 0x76)
#define REG_SC_BK02_77_L      _PK_L_(0x02, 0x77)
#define REG_SC_BK02_77_H      _PK_H_(0x02, 0x77)
#define REG_SC_BK02_78_L      _PK_L_(0x02, 0x78)
#define REG_SC_BK02_78_H      _PK_H_(0x02, 0x78)
#define REG_SC_BK02_79_L      _PK_L_(0x02, 0x79)
#define REG_SC_BK02_79_H      _PK_H_(0x02, 0x79)
#define REG_SC_BK02_7A_L      _PK_L_(0x02, 0x7A)
#define REG_SC_BK02_7A_H      _PK_H_(0x02, 0x7A)
#define REG_SC_BK02_7B_L      _PK_L_(0x02, 0x7B)
#define REG_SC_BK02_7B_H      _PK_H_(0x02, 0x7B)
#define REG_SC_BK02_7C_L      _PK_L_(0x02, 0x7C)
#define REG_SC_BK02_7C_H      _PK_H_(0x02, 0x7C)
#define REG_SC_BK02_7D_L      _PK_L_(0x02, 0x7D)
#define REG_SC_BK02_7D_H      _PK_H_(0x02, 0x7D)
#define REG_SC_BK02_7E_L      _PK_L_(0x02, 0x7E)
#define REG_SC_BK02_7E_H      _PK_H_(0x02, 0x7E)
#define REG_SC_BK02_7F_L      _PK_L_(0x02, 0x7F)
#define REG_SC_BK02_7F_H      _PK_H_(0x02, 0x7F)


//----------------------------------------------
//  BK03: IP1F1
//----------------------------------------------
#define REG_SC_BK03_00_L      _PK_L_(0x03, 0x00)
#define REG_SC_BK03_00_H      _PK_H_(0x03, 0x00)
#define REG_SC_BK03_01_L      _PK_L_(0x03, 0x01)
#define REG_SC_BK03_01_H      _PK_H_(0x03, 0x01)
#define REG_SC_BK03_02_L      _PK_L_(0x03, 0x02)
#define REG_SC_BK03_02_H      _PK_H_(0x03, 0x02)
#define REG_SC_BK03_03_L      _PK_L_(0x03, 0x03)
#define REG_SC_BK03_03_H      _PK_H_(0x03, 0x03)
#define REG_SC_BK03_04_L      _PK_L_(0x03, 0x04)
#define REG_SC_BK03_04_H      _PK_H_(0x03, 0x04)
#define REG_SC_BK03_05_L      _PK_L_(0x03, 0x05)
#define REG_SC_BK03_05_H      _PK_H_(0x03, 0x05)
#define REG_SC_BK03_06_L      _PK_L_(0x03, 0x06)
#define REG_SC_BK03_06_H      _PK_H_(0x03, 0x06)
#define REG_SC_BK03_07_L      _PK_L_(0x03, 0x07)
#define REG_SC_BK03_07_H      _PK_H_(0x03, 0x07)
#define REG_SC_BK03_08_L      _PK_L_(0x03, 0x08)
#define REG_SC_BK03_08_H      _PK_H_(0x03, 0x08)
#define REG_SC_BK03_09_L      _PK_L_(0x03, 0x09)
#define REG_SC_BK03_09_H      _PK_H_(0x03, 0x09)
#define REG_SC_BK03_0A_L      _PK_L_(0x03, 0x0A)
#define REG_SC_BK03_0A_H      _PK_H_(0x03, 0x0A)
#define REG_SC_BK03_0B_L      _PK_L_(0x03, 0x0B)
#define REG_SC_BK03_0B_H      _PK_H_(0x03, 0x0B)
#define REG_SC_BK03_0C_L      _PK_L_(0x03, 0x0C)
#define REG_SC_BK03_0C_H      _PK_H_(0x03, 0x0C)
#define REG_SC_BK03_0D_L      _PK_L_(0x03, 0x0D)
#define REG_SC_BK03_0D_H      _PK_H_(0x03, 0x0D)
#define REG_SC_BK03_0E_L      _PK_L_(0x03, 0x0E)
#define REG_SC_BK03_0E_H      _PK_H_(0x03, 0x0E)
#define REG_SC_BK03_0F_L      _PK_L_(0x03, 0x0F)
#define REG_SC_BK03_0F_H      _PK_H_(0x03, 0x0F)
#define REG_SC_BK03_10_L      _PK_L_(0x03, 0x10)
#define REG_SC_BK03_10_H      _PK_H_(0x03, 0x10)
#define REG_SC_BK03_11_L      _PK_L_(0x03, 0x11)
#define REG_SC_BK03_11_H      _PK_H_(0x03, 0x11)
#define REG_SC_BK03_12_L      _PK_L_(0x03, 0x12)
#define REG_SC_BK03_12_H      _PK_H_(0x03, 0x12)
#define REG_SC_BK03_13_L      _PK_L_(0x03, 0x13)
#define REG_SC_BK03_13_H      _PK_H_(0x03, 0x13)
#define REG_SC_BK03_14_L      _PK_L_(0x03, 0x14)
#define REG_SC_BK03_14_H      _PK_H_(0x03, 0x14)
#define REG_SC_BK03_15_L      _PK_L_(0x03, 0x15)
#define REG_SC_BK03_15_H      _PK_H_(0x03, 0x15)
#define REG_SC_BK03_16_L      _PK_L_(0x03, 0x16)
#define REG_SC_BK03_16_H      _PK_H_(0x03, 0x16)
#define REG_SC_BK03_17_L      _PK_L_(0x03, 0x17)
#define REG_SC_BK03_17_H      _PK_H_(0x03, 0x17)
#define REG_SC_BK03_18_L      _PK_L_(0x03, 0x18)
#define REG_SC_BK03_18_H      _PK_H_(0x03, 0x18)
#define REG_SC_BK03_19_L      _PK_L_(0x03, 0x19)
#define REG_SC_BK03_19_H      _PK_H_(0x03, 0x19)
#define REG_SC_BK03_1A_L      _PK_L_(0x03, 0x1A)
#define REG_SC_BK03_1A_H      _PK_H_(0x03, 0x1A)
#define REG_SC_BK03_1B_L      _PK_L_(0x03, 0x1B)
#define REG_SC_BK03_1B_H      _PK_H_(0x03, 0x1B)
#define REG_SC_BK03_1C_L      _PK_L_(0x03, 0x1C)
#define REG_SC_BK03_1C_H      _PK_H_(0x03, 0x1C)
#define REG_SC_BK03_1D_L      _PK_L_(0x03, 0x1D)
#define REG_SC_BK03_1D_H      _PK_H_(0x03, 0x1D)
#define REG_SC_BK03_1E_L      _PK_L_(0x03, 0x1E)
#define REG_SC_BK03_1E_H      _PK_H_(0x03, 0x1E)
#define REG_SC_BK03_1F_L      _PK_L_(0x03, 0x1F)
#define REG_SC_BK03_1F_H      _PK_H_(0x03, 0x1F)
#define REG_SC_BK03_20_L      _PK_L_(0x03, 0x20)
#define REG_SC_BK03_20_H      _PK_H_(0x03, 0x20)
#define REG_SC_BK03_21_L      _PK_L_(0x03, 0x21)
#define REG_SC_BK03_21_H      _PK_H_(0x03, 0x21)
#define REG_SC_BK03_22_L      _PK_L_(0x03, 0x22)
#define REG_SC_BK03_22_H      _PK_H_(0x03, 0x22)
#define REG_SC_BK03_23_L      _PK_L_(0x03, 0x23)
#define REG_SC_BK03_23_H      _PK_H_(0x03, 0x23)
#define REG_SC_BK03_24_L      _PK_L_(0x03, 0x24)
#define REG_SC_BK03_24_H      _PK_H_(0x03, 0x24)
#define REG_SC_BK03_25_L      _PK_L_(0x03, 0x25)
#define REG_SC_BK03_25_H      _PK_H_(0x03, 0x25)
#define REG_SC_BK03_26_L      _PK_L_(0x03, 0x26)
#define REG_SC_BK03_26_H      _PK_H_(0x03, 0x26)
#define REG_SC_BK03_27_L      _PK_L_(0x03, 0x27)
#define REG_SC_BK03_27_H      _PK_H_(0x03, 0x27)
#define REG_SC_BK03_28_L      _PK_L_(0x03, 0x28)
#define REG_SC_BK03_28_H      _PK_H_(0x03, 0x28)
#define REG_SC_BK03_29_L      _PK_L_(0x03, 0x29)
#define REG_SC_BK03_29_H      _PK_H_(0x03, 0x29)
#define REG_SC_BK03_2A_L      _PK_L_(0x03, 0x2A)
#define REG_SC_BK03_2A_H      _PK_H_(0x03, 0x2A)
#define REG_SC_BK03_2B_L      _PK_L_(0x03, 0x2B)
#define REG_SC_BK03_2B_H      _PK_H_(0x03, 0x2B)
#define REG_SC_BK03_2C_L      _PK_L_(0x03, 0x2C)
#define REG_SC_BK03_2C_H      _PK_H_(0x03, 0x2C)
#define REG_SC_BK03_2D_L      _PK_L_(0x03, 0x2D)
#define REG_SC_BK03_2D_H      _PK_H_(0x03, 0x2D)
#define REG_SC_BK03_2E_L      _PK_L_(0x03, 0x2E)
#define REG_SC_BK03_2E_H      _PK_H_(0x03, 0x2E)
#define REG_SC_BK03_2F_L      _PK_L_(0x03, 0x2F)
#define REG_SC_BK03_2F_H      _PK_H_(0x03, 0x2F)
#define REG_SC_BK03_30_L      _PK_L_(0x03, 0x30)
#define REG_SC_BK03_30_H      _PK_H_(0x03, 0x30)
#define REG_SC_BK03_31_L      _PK_L_(0x03, 0x31)
#define REG_SC_BK03_31_H      _PK_H_(0x03, 0x31)
#define REG_SC_BK03_32_L      _PK_L_(0x03, 0x32)
#define REG_SC_BK03_32_H      _PK_H_(0x03, 0x32)
#define REG_SC_BK03_33_L      _PK_L_(0x03, 0x33)
#define REG_SC_BK03_33_H      _PK_H_(0x03, 0x33)
#define REG_SC_BK03_34_L      _PK_L_(0x03, 0x34)
#define REG_SC_BK03_34_H      _PK_H_(0x03, 0x34)
#define REG_SC_BK03_35_L      _PK_L_(0x03, 0x35)
#define REG_SC_BK03_35_H      _PK_H_(0x03, 0x35)
#define REG_SC_BK03_36_L      _PK_L_(0x03, 0x36)
#define REG_SC_BK03_36_H      _PK_H_(0x03, 0x36)
#define REG_SC_BK03_37_L      _PK_L_(0x03, 0x37)
#define REG_SC_BK03_37_H      _PK_H_(0x03, 0x37)
#define REG_SC_BK03_38_L      _PK_L_(0x03, 0x38)
#define REG_SC_BK03_38_H      _PK_H_(0x03, 0x38)
#define REG_SC_BK03_39_L      _PK_L_(0x03, 0x39)
#define REG_SC_BK03_39_H      _PK_H_(0x03, 0x39)
#define REG_SC_BK03_3A_L      _PK_L_(0x03, 0x3A)
#define REG_SC_BK03_3A_H      _PK_H_(0x03, 0x3A)
#define REG_SC_BK03_3B_L      _PK_L_(0x03, 0x3B)
#define REG_SC_BK03_3B_H      _PK_H_(0x03, 0x3B)
#define REG_SC_BK03_3C_L      _PK_L_(0x03, 0x3C)
#define REG_SC_BK03_3C_H      _PK_H_(0x03, 0x3C)
#define REG_SC_BK03_3D_L      _PK_L_(0x03, 0x3D)
#define REG_SC_BK03_3D_H      _PK_H_(0x03, 0x3D)
#define REG_SC_BK03_3E_L      _PK_L_(0x03, 0x3E)
#define REG_SC_BK03_3E_H      _PK_H_(0x03, 0x3E)
#define REG_SC_BK03_3F_L      _PK_L_(0x03, 0x3F)
#define REG_SC_BK03_3F_H      _PK_H_(0x03, 0x3F)
#define REG_SC_BK03_40_L      _PK_L_(0x03, 0x40)
#define REG_SC_BK03_40_H      _PK_H_(0x03, 0x40)
#define REG_SC_BK03_41_L      _PK_L_(0x03, 0x41)
#define REG_SC_BK03_41_H      _PK_H_(0x03, 0x41)
#define REG_SC_BK03_42_L      _PK_L_(0x03, 0x42)
#define REG_SC_BK03_42_H      _PK_H_(0x03, 0x42)
#define REG_SC_BK03_43_L      _PK_L_(0x03, 0x43)
#define REG_SC_BK03_43_H      _PK_H_(0x03, 0x43)
#define REG_SC_BK03_44_L      _PK_L_(0x03, 0x44)
#define REG_SC_BK03_44_H      _PK_H_(0x03, 0x44)
#define REG_SC_BK03_45_L      _PK_L_(0x03, 0x45)
#define REG_SC_BK03_45_H      _PK_H_(0x03, 0x45)
#define REG_SC_BK03_46_L      _PK_L_(0x03, 0x46)
#define REG_SC_BK03_46_H      _PK_H_(0x03, 0x46)
#define REG_SC_BK03_47_L      _PK_L_(0x03, 0x47)
#define REG_SC_BK03_47_H      _PK_H_(0x03, 0x47)
#define REG_SC_BK03_48_L      _PK_L_(0x03, 0x48)
#define REG_SC_BK03_48_H      _PK_H_(0x03, 0x48)
#define REG_SC_BK03_49_L      _PK_L_(0x03, 0x49)
#define REG_SC_BK03_49_H      _PK_H_(0x03, 0x49)
#define REG_SC_BK03_4A_L      _PK_L_(0x03, 0x4A)
#define REG_SC_BK03_4A_H      _PK_H_(0x03, 0x4A)
#define REG_SC_BK03_4B_L      _PK_L_(0x03, 0x4B)
#define REG_SC_BK03_4B_H      _PK_H_(0x03, 0x4B)
#define REG_SC_BK03_4C_L      _PK_L_(0x03, 0x4C)
#define REG_SC_BK03_4C_H      _PK_H_(0x03, 0x4C)
#define REG_SC_BK03_4D_L      _PK_L_(0x03, 0x4D)
#define REG_SC_BK03_4D_H      _PK_H_(0x03, 0x4D)
#define REG_SC_BK03_4E_L      _PK_L_(0x03, 0x4E)
#define REG_SC_BK03_4E_H      _PK_H_(0x03, 0x4E)
#define REG_SC_BK03_4F_L      _PK_L_(0x03, 0x4F)
#define REG_SC_BK03_4F_H      _PK_H_(0x03, 0x4F)
#define REG_SC_BK03_50_L      _PK_L_(0x03, 0x50)
#define REG_SC_BK03_50_H      _PK_H_(0x03, 0x50)
#define REG_SC_BK03_51_L      _PK_L_(0x03, 0x51)
#define REG_SC_BK03_51_H      _PK_H_(0x03, 0x51)
#define REG_SC_BK03_52_L      _PK_L_(0x03, 0x52)
#define REG_SC_BK03_52_H      _PK_H_(0x03, 0x52)
#define REG_SC_BK03_53_L      _PK_L_(0x03, 0x53)
#define REG_SC_BK03_53_H      _PK_H_(0x03, 0x53)
#define REG_SC_BK03_54_L      _PK_L_(0x03, 0x54)
#define REG_SC_BK03_54_H      _PK_H_(0x03, 0x54)
#define REG_SC_BK03_55_L      _PK_L_(0x03, 0x55)
#define REG_SC_BK03_55_H      _PK_H_(0x03, 0x55)
#define REG_SC_BK03_56_L      _PK_L_(0x03, 0x56)
#define REG_SC_BK03_56_H      _PK_H_(0x03, 0x56)
#define REG_SC_BK03_57_L      _PK_L_(0x03, 0x57)
#define REG_SC_BK03_57_H      _PK_H_(0x03, 0x57)
#define REG_SC_BK03_58_L      _PK_L_(0x03, 0x58)
#define REG_SC_BK03_58_H      _PK_H_(0x03, 0x58)
#define REG_SC_BK03_59_L      _PK_L_(0x03, 0x59)
#define REG_SC_BK03_59_H      _PK_H_(0x03, 0x59)
#define REG_SC_BK03_5A_L      _PK_L_(0x03, 0x5A)
#define REG_SC_BK03_5A_H      _PK_H_(0x03, 0x5A)
#define REG_SC_BK03_5B_L      _PK_L_(0x03, 0x5B)
#define REG_SC_BK03_5B_H      _PK_H_(0x03, 0x5B)
#define REG_SC_BK03_5C_L      _PK_L_(0x03, 0x5C)
#define REG_SC_BK03_5C_H      _PK_H_(0x03, 0x5C)
#define REG_SC_BK03_5D_L      _PK_L_(0x03, 0x5D)
#define REG_SC_BK03_5D_H      _PK_H_(0x03, 0x5D)
#define REG_SC_BK03_5E_L      _PK_L_(0x03, 0x5E)
#define REG_SC_BK03_5E_H      _PK_H_(0x03, 0x5E)
#define REG_SC_BK03_5F_L      _PK_L_(0x03, 0x5F)
#define REG_SC_BK03_5F_H      _PK_H_(0x03, 0x5F)
#define REG_SC_BK03_60_L      _PK_L_(0x03, 0x60)
#define REG_SC_BK03_60_H      _PK_H_(0x03, 0x60)
#define REG_SC_BK03_61_L      _PK_L_(0x03, 0x61)
#define REG_SC_BK03_61_H      _PK_H_(0x03, 0x61)
#define REG_SC_BK03_62_L      _PK_L_(0x03, 0x62)
#define REG_SC_BK03_62_H      _PK_H_(0x03, 0x62)
#define REG_SC_BK03_63_L      _PK_L_(0x03, 0x63)
#define REG_SC_BK03_63_H      _PK_H_(0x03, 0x63)
#define REG_SC_BK03_64_L      _PK_L_(0x03, 0x64)
#define REG_SC_BK03_64_H      _PK_H_(0x03, 0x64)
#define REG_SC_BK03_65_L      _PK_L_(0x03, 0x65)
#define REG_SC_BK03_65_H      _PK_H_(0x03, 0x65)
#define REG_SC_BK03_66_L      _PK_L_(0x03, 0x66)
#define REG_SC_BK03_66_H      _PK_H_(0x03, 0x66)
#define REG_SC_BK03_67_L      _PK_L_(0x03, 0x67)
#define REG_SC_BK03_67_H      _PK_H_(0x03, 0x67)
#define REG_SC_BK03_68_L      _PK_L_(0x03, 0x68)
#define REG_SC_BK03_68_H      _PK_H_(0x03, 0x68)
#define REG_SC_BK03_69_L      _PK_L_(0x03, 0x69)
#define REG_SC_BK03_69_H      _PK_H_(0x03, 0x69)
#define REG_SC_BK03_6A_L      _PK_L_(0x03, 0x6A)
#define REG_SC_BK03_6A_H      _PK_H_(0x03, 0x6A)
#define REG_SC_BK03_6B_L      _PK_L_(0x03, 0x6B)
#define REG_SC_BK03_6B_H      _PK_H_(0x03, 0x6B)
#define REG_SC_BK03_6C_L      _PK_L_(0x03, 0x6C)
#define REG_SC_BK03_6C_H      _PK_H_(0x03, 0x6C)
#define REG_SC_BK03_6D_L      _PK_L_(0x03, 0x6D)
#define REG_SC_BK03_6D_H      _PK_H_(0x03, 0x6D)
#define REG_SC_BK03_6E_L      _PK_L_(0x03, 0x6E)
#define REG_SC_BK03_6E_H      _PK_H_(0x03, 0x6E)
#define REG_SC_BK03_6F_L      _PK_L_(0x03, 0x6F)
#define REG_SC_BK03_6F_H      _PK_H_(0x03, 0x6F)
#define REG_SC_BK03_70_L      _PK_L_(0x03, 0x70)
#define REG_SC_BK03_70_H      _PK_H_(0x03, 0x70)
#define REG_SC_BK03_71_L      _PK_L_(0x03, 0x71)
#define REG_SC_BK03_71_H      _PK_H_(0x03, 0x71)
#define REG_SC_BK03_72_L      _PK_L_(0x03, 0x72)
#define REG_SC_BK03_72_H      _PK_H_(0x03, 0x72)
#define REG_SC_BK03_73_L      _PK_L_(0x03, 0x73)
#define REG_SC_BK03_73_H      _PK_H_(0x03, 0x73)
#define REG_SC_BK03_74_L      _PK_L_(0x03, 0x74)
#define REG_SC_BK03_74_H      _PK_H_(0x03, 0x74)
#define REG_SC_BK03_75_L      _PK_L_(0x03, 0x75)
#define REG_SC_BK03_75_H      _PK_H_(0x03, 0x75)
#define REG_SC_BK03_76_L      _PK_L_(0x03, 0x76)
#define REG_SC_BK03_76_H      _PK_H_(0x03, 0x76)
#define REG_SC_BK03_77_L      _PK_L_(0x03, 0x77)
#define REG_SC_BK03_77_H      _PK_H_(0x03, 0x77)
#define REG_SC_BK03_78_L      _PK_L_(0x03, 0x78)
#define REG_SC_BK03_78_H      _PK_H_(0x03, 0x78)
#define REG_SC_BK03_79_L      _PK_L_(0x03, 0x79)
#define REG_SC_BK03_79_H      _PK_H_(0x03, 0x79)
#define REG_SC_BK03_7A_L      _PK_L_(0x03, 0x7A)
#define REG_SC_BK03_7A_H      _PK_H_(0x03, 0x7A)
#define REG_SC_BK03_7B_L      _PK_L_(0x03, 0x7B)
#define REG_SC_BK03_7B_H      _PK_H_(0x03, 0x7B)
#define REG_SC_BK03_7C_L      _PK_L_(0x03, 0x7C)
#define REG_SC_BK03_7C_H      _PK_H_(0x03, 0x7C)
#define REG_SC_BK03_7D_L      _PK_L_(0x03, 0x7D)
#define REG_SC_BK03_7D_H      _PK_H_(0x03, 0x7D)
#define REG_SC_BK03_7E_L      _PK_L_(0x03, 0x7E)
#define REG_SC_BK03_7E_H      _PK_H_(0x03, 0x7E)
#define REG_SC_BK03_7F_L      _PK_L_(0x03, 0x7F)
#define REG_SC_BK03_7F_H      _PK_H_(0x03, 0x7F)


//----------------------------------------------
//  BK04: IP2F1
//----------------------------------------------
#define REG_SC_BK04_00_L      _PK_L_(0x04, 0x00)
#define REG_SC_BK04_00_H      _PK_H_(0x04, 0x00)
#define REG_SC_BK04_01_L      _PK_L_(0x04, 0x01)
#define REG_SC_BK04_01_H      _PK_H_(0x04, 0x01)
#define REG_SC_BK04_02_L      _PK_L_(0x04, 0x02)
#define REG_SC_BK04_02_H      _PK_H_(0x04, 0x02)
#define REG_SC_BK04_03_L      _PK_L_(0x04, 0x03)
#define REG_SC_BK04_03_H      _PK_H_(0x04, 0x03)
#define REG_SC_BK04_04_L      _PK_L_(0x04, 0x04)
#define REG_SC_BK04_04_H      _PK_H_(0x04, 0x04)
#define REG_SC_BK04_05_L      _PK_L_(0x04, 0x05)
#define REG_SC_BK04_05_H      _PK_H_(0x04, 0x05)
#define REG_SC_BK04_06_L      _PK_L_(0x04, 0x06)
#define REG_SC_BK04_06_H      _PK_H_(0x04, 0x06)
#define REG_SC_BK04_07_L      _PK_L_(0x04, 0x07)
#define REG_SC_BK04_07_H      _PK_H_(0x04, 0x07)
#define REG_SC_BK04_08_L      _PK_L_(0x04, 0x08)
#define REG_SC_BK04_08_H      _PK_H_(0x04, 0x08)
#define REG_SC_BK04_09_L      _PK_L_(0x04, 0x09)
#define REG_SC_BK04_09_H      _PK_H_(0x04, 0x09)
#define REG_SC_BK04_0A_L      _PK_L_(0x04, 0x0A)
#define REG_SC_BK04_0A_H      _PK_H_(0x04, 0x0A)
#define REG_SC_BK04_0B_L      _PK_L_(0x04, 0x0B)
#define REG_SC_BK04_0B_H      _PK_H_(0x04, 0x0B)
#define REG_SC_BK04_0C_L      _PK_L_(0x04, 0x0C)
#define REG_SC_BK04_0C_H      _PK_H_(0x04, 0x0C)
#define REG_SC_BK04_0D_L      _PK_L_(0x04, 0x0D)
#define REG_SC_BK04_0D_H      _PK_H_(0x04, 0x0D)
#define REG_SC_BK04_0E_L      _PK_L_(0x04, 0x0E)
#define REG_SC_BK04_0E_H      _PK_H_(0x04, 0x0E)
#define REG_SC_BK04_0F_L      _PK_L_(0x04, 0x0F)
#define REG_SC_BK04_0F_H      _PK_H_(0x04, 0x0F)
#define REG_SC_BK04_10_L      _PK_L_(0x04, 0x10)
#define REG_SC_BK04_10_H      _PK_H_(0x04, 0x10)
#define REG_SC_BK04_11_L      _PK_L_(0x04, 0x11)
#define REG_SC_BK04_11_H      _PK_H_(0x04, 0x11)
#define REG_SC_BK04_12_L      _PK_L_(0x04, 0x12)
#define REG_SC_BK04_12_H      _PK_H_(0x04, 0x12)
#define REG_SC_BK04_13_L      _PK_L_(0x04, 0x13)
#define REG_SC_BK04_13_H      _PK_H_(0x04, 0x13)
#define REG_SC_BK04_14_L      _PK_L_(0x04, 0x14)
#define REG_SC_BK04_14_H      _PK_H_(0x04, 0x14)
#define REG_SC_BK04_15_L      _PK_L_(0x04, 0x15)
#define REG_SC_BK04_15_H      _PK_H_(0x04, 0x15)
#define REG_SC_BK04_16_L      _PK_L_(0x04, 0x16)
#define REG_SC_BK04_16_H      _PK_H_(0x04, 0x16)
#define REG_SC_BK04_17_L      _PK_L_(0x04, 0x17)
#define REG_SC_BK04_17_H      _PK_H_(0x04, 0x17)
#define REG_SC_BK04_18_L      _PK_L_(0x04, 0x18)
#define REG_SC_BK04_18_H      _PK_H_(0x04, 0x18)
#define REG_SC_BK04_19_L      _PK_L_(0x04, 0x19)
#define REG_SC_BK04_19_H      _PK_H_(0x04, 0x19)
#define REG_SC_BK04_1A_L      _PK_L_(0x04, 0x1A)
#define REG_SC_BK04_1A_H      _PK_H_(0x04, 0x1A)
#define REG_SC_BK04_1B_L      _PK_L_(0x04, 0x1B)
#define REG_SC_BK04_1B_H      _PK_H_(0x04, 0x1B)
#define REG_SC_BK04_1C_L      _PK_L_(0x04, 0x1C)
#define REG_SC_BK04_1C_H      _PK_H_(0x04, 0x1C)
#define REG_SC_BK04_1D_L      _PK_L_(0x04, 0x1D)
#define REG_SC_BK04_1D_H      _PK_H_(0x04, 0x1D)
#define REG_SC_BK04_1E_L      _PK_L_(0x04, 0x1E)
#define REG_SC_BK04_1E_H      _PK_H_(0x04, 0x1E)
#define REG_SC_BK04_1F_L      _PK_L_(0x04, 0x1F)
#define REG_SC_BK04_1F_H      _PK_H_(0x04, 0x1F)
#define REG_SC_BK04_20_L      _PK_L_(0x04, 0x20)
#define REG_SC_BK04_20_H      _PK_H_(0x04, 0x20)
#define REG_SC_BK04_21_L      _PK_L_(0x04, 0x21)
#define REG_SC_BK04_21_H      _PK_H_(0x04, 0x21)
#define REG_SC_BK04_22_L      _PK_L_(0x04, 0x22)
#define REG_SC_BK04_22_H      _PK_H_(0x04, 0x22)
#define REG_SC_BK04_23_L      _PK_L_(0x04, 0x23)
#define REG_SC_BK04_23_H      _PK_H_(0x04, 0x23)
#define REG_SC_BK04_24_L      _PK_L_(0x04, 0x24)
#define REG_SC_BK04_24_H      _PK_H_(0x04, 0x24)
#define REG_SC_BK04_25_L      _PK_L_(0x04, 0x25)
#define REG_SC_BK04_25_H      _PK_H_(0x04, 0x25)
#define REG_SC_BK04_26_L      _PK_L_(0x04, 0x26)
#define REG_SC_BK04_26_H      _PK_H_(0x04, 0x26)
#define REG_SC_BK04_27_L      _PK_L_(0x04, 0x27)
#define REG_SC_BK04_27_H      _PK_H_(0x04, 0x27)
#define REG_SC_BK04_28_L      _PK_L_(0x04, 0x28)
#define REG_SC_BK04_28_H      _PK_H_(0x04, 0x28)
#define REG_SC_BK04_29_L      _PK_L_(0x04, 0x29)
#define REG_SC_BK04_29_H      _PK_H_(0x04, 0x29)
#define REG_SC_BK04_2A_L      _PK_L_(0x04, 0x2A)
#define REG_SC_BK04_2A_H      _PK_H_(0x04, 0x2A)
#define REG_SC_BK04_2B_L      _PK_L_(0x04, 0x2B)
#define REG_SC_BK04_2B_H      _PK_H_(0x04, 0x2B)
#define REG_SC_BK04_2C_L      _PK_L_(0x04, 0x2C)
#define REG_SC_BK04_2C_H      _PK_H_(0x04, 0x2C)
#define REG_SC_BK04_2D_L      _PK_L_(0x04, 0x2D)
#define REG_SC_BK04_2D_H      _PK_H_(0x04, 0x2D)
#define REG_SC_BK04_2E_L      _PK_L_(0x04, 0x2E)
#define REG_SC_BK04_2E_H      _PK_H_(0x04, 0x2E)
#define REG_SC_BK04_2F_L      _PK_L_(0x04, 0x2F)
#define REG_SC_BK04_2F_H      _PK_H_(0x04, 0x2F)
#define REG_SC_BK04_30_L      _PK_L_(0x04, 0x30)
#define REG_SC_BK04_30_H      _PK_H_(0x04, 0x30)
#define REG_SC_BK04_31_L      _PK_L_(0x04, 0x31)
#define REG_SC_BK04_31_H      _PK_H_(0x04, 0x31)
#define REG_SC_BK04_32_L      _PK_L_(0x04, 0x32)
#define REG_SC_BK04_32_H      _PK_H_(0x04, 0x32)
#define REG_SC_BK04_33_L      _PK_L_(0x04, 0x33)
#define REG_SC_BK04_33_H      _PK_H_(0x04, 0x33)
#define REG_SC_BK04_34_L      _PK_L_(0x04, 0x34)
#define REG_SC_BK04_34_H      _PK_H_(0x04, 0x34)
#define REG_SC_BK04_35_L      _PK_L_(0x04, 0x35)
#define REG_SC_BK04_35_H      _PK_H_(0x04, 0x35)
#define REG_SC_BK04_36_L      _PK_L_(0x04, 0x36)
#define REG_SC_BK04_36_H      _PK_H_(0x04, 0x36)
#define REG_SC_BK04_37_L      _PK_L_(0x04, 0x37)
#define REG_SC_BK04_37_H      _PK_H_(0x04, 0x37)
#define REG_SC_BK04_38_L      _PK_L_(0x04, 0x38)
#define REG_SC_BK04_38_H      _PK_H_(0x04, 0x38)
#define REG_SC_BK04_39_L      _PK_L_(0x04, 0x39)
#define REG_SC_BK04_39_H      _PK_H_(0x04, 0x39)
#define REG_SC_BK04_3A_L      _PK_L_(0x04, 0x3A)
#define REG_SC_BK04_3A_H      _PK_H_(0x04, 0x3A)
#define REG_SC_BK04_3B_L      _PK_L_(0x04, 0x3B)
#define REG_SC_BK04_3B_H      _PK_H_(0x04, 0x3B)
#define REG_SC_BK04_3C_L      _PK_L_(0x04, 0x3C)
#define REG_SC_BK04_3C_H      _PK_H_(0x04, 0x3C)
#define REG_SC_BK04_3D_L      _PK_L_(0x04, 0x3D)
#define REG_SC_BK04_3D_H      _PK_H_(0x04, 0x3D)
#define REG_SC_BK04_3E_L      _PK_L_(0x04, 0x3E)
#define REG_SC_BK04_3E_H      _PK_H_(0x04, 0x3E)
#define REG_SC_BK04_3F_L      _PK_L_(0x04, 0x3F)
#define REG_SC_BK04_3F_H      _PK_H_(0x04, 0x3F)
#define REG_SC_BK04_40_L      _PK_L_(0x04, 0x40)
#define REG_SC_BK04_40_H      _PK_H_(0x04, 0x40)
#define REG_SC_BK04_41_L      _PK_L_(0x04, 0x41)
#define REG_SC_BK04_41_H      _PK_H_(0x04, 0x41)
#define REG_SC_BK04_42_L      _PK_L_(0x04, 0x42)
#define REG_SC_BK04_42_H      _PK_H_(0x04, 0x42)
#define REG_SC_BK04_43_L      _PK_L_(0x04, 0x43)
#define REG_SC_BK04_43_H      _PK_H_(0x04, 0x43)
#define REG_SC_BK04_44_L      _PK_L_(0x04, 0x44)
#define REG_SC_BK04_44_H      _PK_H_(0x04, 0x44)
#define REG_SC_BK04_45_L      _PK_L_(0x04, 0x45)
#define REG_SC_BK04_45_H      _PK_H_(0x04, 0x45)
#define REG_SC_BK04_46_L      _PK_L_(0x04, 0x46)
#define REG_SC_BK04_46_H      _PK_H_(0x04, 0x46)
#define REG_SC_BK04_47_L      _PK_L_(0x04, 0x47)
#define REG_SC_BK04_47_H      _PK_H_(0x04, 0x47)
#define REG_SC_BK04_48_L      _PK_L_(0x04, 0x48)
#define REG_SC_BK04_48_H      _PK_H_(0x04, 0x48)
#define REG_SC_BK04_49_L      _PK_L_(0x04, 0x49)
#define REG_SC_BK04_49_H      _PK_H_(0x04, 0x49)
#define REG_SC_BK04_4A_L      _PK_L_(0x04, 0x4A)
#define REG_SC_BK04_4A_H      _PK_H_(0x04, 0x4A)
#define REG_SC_BK04_4B_L      _PK_L_(0x04, 0x4B)
#define REG_SC_BK04_4B_H      _PK_H_(0x04, 0x4B)
#define REG_SC_BK04_4C_L      _PK_L_(0x04, 0x4C)
#define REG_SC_BK04_4C_H      _PK_H_(0x04, 0x4C)
#define REG_SC_BK04_4D_L      _PK_L_(0x04, 0x4D)
#define REG_SC_BK04_4D_H      _PK_H_(0x04, 0x4D)
#define REG_SC_BK04_4E_L      _PK_L_(0x04, 0x4E)
#define REG_SC_BK04_4E_H      _PK_H_(0x04, 0x4E)
#define REG_SC_BK04_4F_L      _PK_L_(0x04, 0x4F)
#define REG_SC_BK04_4F_H      _PK_H_(0x04, 0x4F)
#define REG_SC_BK04_50_L      _PK_L_(0x04, 0x50)
#define REG_SC_BK04_50_H      _PK_H_(0x04, 0x50)
#define REG_SC_BK04_51_L      _PK_L_(0x04, 0x51)
#define REG_SC_BK04_51_H      _PK_H_(0x04, 0x51)
#define REG_SC_BK04_52_L      _PK_L_(0x04, 0x52)
#define REG_SC_BK04_52_H      _PK_H_(0x04, 0x52)
#define REG_SC_BK04_53_L      _PK_L_(0x04, 0x53)
#define REG_SC_BK04_53_H      _PK_H_(0x04, 0x53)
#define REG_SC_BK04_54_L      _PK_L_(0x04, 0x54)
#define REG_SC_BK04_54_H      _PK_H_(0x04, 0x54)
#define REG_SC_BK04_55_L      _PK_L_(0x04, 0x55)
#define REG_SC_BK04_55_H      _PK_H_(0x04, 0x55)
#define REG_SC_BK04_56_L      _PK_L_(0x04, 0x56)
#define REG_SC_BK04_56_H      _PK_H_(0x04, 0x56)
#define REG_SC_BK04_57_L      _PK_L_(0x04, 0x57)
#define REG_SC_BK04_57_H      _PK_H_(0x04, 0x57)
#define REG_SC_BK04_58_L      _PK_L_(0x04, 0x58)
#define REG_SC_BK04_58_H      _PK_H_(0x04, 0x58)
#define REG_SC_BK04_59_L      _PK_L_(0x04, 0x59)
#define REG_SC_BK04_59_H      _PK_H_(0x04, 0x59)
#define REG_SC_BK04_5A_L      _PK_L_(0x04, 0x5A)
#define REG_SC_BK04_5A_H      _PK_H_(0x04, 0x5A)
#define REG_SC_BK04_5B_L      _PK_L_(0x04, 0x5B)
#define REG_SC_BK04_5B_H      _PK_H_(0x04, 0x5B)
#define REG_SC_BK04_5C_L      _PK_L_(0x04, 0x5C)
#define REG_SC_BK04_5C_H      _PK_H_(0x04, 0x5C)
#define REG_SC_BK04_5D_L      _PK_L_(0x04, 0x5D)
#define REG_SC_BK04_5D_H      _PK_H_(0x04, 0x5D)
#define REG_SC_BK04_5E_L      _PK_L_(0x04, 0x5E)
#define REG_SC_BK04_5E_H      _PK_H_(0x04, 0x5E)
#define REG_SC_BK04_5F_L      _PK_L_(0x04, 0x5F)
#define REG_SC_BK04_5F_H      _PK_H_(0x04, 0x5F)
#define REG_SC_BK04_60_L      _PK_L_(0x04, 0x60)
#define REG_SC_BK04_60_H      _PK_H_(0x04, 0x60)
#define REG_SC_BK04_61_L      _PK_L_(0x04, 0x61)
#define REG_SC_BK04_61_H      _PK_H_(0x04, 0x61)
#define REG_SC_BK04_62_L      _PK_L_(0x04, 0x62)
#define REG_SC_BK04_62_H      _PK_H_(0x04, 0x62)
#define REG_SC_BK04_63_L      _PK_L_(0x04, 0x63)
#define REG_SC_BK04_63_H      _PK_H_(0x04, 0x63)
#define REG_SC_BK04_64_L      _PK_L_(0x04, 0x64)
#define REG_SC_BK04_64_H      _PK_H_(0x04, 0x64)
#define REG_SC_BK04_65_L      _PK_L_(0x04, 0x65)
#define REG_SC_BK04_65_H      _PK_H_(0x04, 0x65)
#define REG_SC_BK04_66_L      _PK_L_(0x04, 0x66)
#define REG_SC_BK04_66_H      _PK_H_(0x04, 0x66)
#define REG_SC_BK04_67_L      _PK_L_(0x04, 0x67)
#define REG_SC_BK04_67_H      _PK_H_(0x04, 0x67)
#define REG_SC_BK04_68_L      _PK_L_(0x04, 0x68)
#define REG_SC_BK04_68_H      _PK_H_(0x04, 0x68)
#define REG_SC_BK04_69_L      _PK_L_(0x04, 0x69)
#define REG_SC_BK04_69_H      _PK_H_(0x04, 0x69)
#define REG_SC_BK04_6A_L      _PK_L_(0x04, 0x6A)
#define REG_SC_BK04_6A_H      _PK_H_(0x04, 0x6A)
#define REG_SC_BK04_6B_L      _PK_L_(0x04, 0x6B)
#define REG_SC_BK04_6B_H      _PK_H_(0x04, 0x6B)
#define REG_SC_BK04_6C_L      _PK_L_(0x04, 0x6C)
#define REG_SC_BK04_6C_H      _PK_H_(0x04, 0x6C)
#define REG_SC_BK04_6D_L      _PK_L_(0x04, 0x6D)
#define REG_SC_BK04_6D_H      _PK_H_(0x04, 0x6D)
#define REG_SC_BK04_6E_L      _PK_L_(0x04, 0x6E)
#define REG_SC_BK04_6E_H      _PK_H_(0x04, 0x6E)
#define REG_SC_BK04_6F_L      _PK_L_(0x04, 0x6F)
#define REG_SC_BK04_6F_H      _PK_H_(0x04, 0x6F)
#define REG_SC_BK04_70_L      _PK_L_(0x04, 0x70)
#define REG_SC_BK04_70_H      _PK_H_(0x04, 0x70)
#define REG_SC_BK04_71_L      _PK_L_(0x04, 0x71)
#define REG_SC_BK04_71_H      _PK_H_(0x04, 0x71)
#define REG_SC_BK04_72_L      _PK_L_(0x04, 0x72)
#define REG_SC_BK04_72_H      _PK_H_(0x04, 0x72)
#define REG_SC_BK04_73_L      _PK_L_(0x04, 0x73)
#define REG_SC_BK04_73_H      _PK_H_(0x04, 0x73)
#define REG_SC_BK04_74_L      _PK_L_(0x04, 0x74)
#define REG_SC_BK04_74_H      _PK_H_(0x04, 0x74)
#define REG_SC_BK04_75_L      _PK_L_(0x04, 0x75)
#define REG_SC_BK04_75_H      _PK_H_(0x04, 0x75)
#define REG_SC_BK04_76_L      _PK_L_(0x04, 0x76)
#define REG_SC_BK04_76_H      _PK_H_(0x04, 0x76)
#define REG_SC_BK04_77_L      _PK_L_(0x04, 0x77)
#define REG_SC_BK04_77_H      _PK_H_(0x04, 0x77)
#define REG_SC_BK04_78_L      _PK_L_(0x04, 0x78)
#define REG_SC_BK04_78_H      _PK_H_(0x04, 0x78)
#define REG_SC_BK04_79_L      _PK_L_(0x04, 0x79)
#define REG_SC_BK04_79_H      _PK_H_(0x04, 0x79)
#define REG_SC_BK04_7A_L      _PK_L_(0x04, 0x7A)
#define REG_SC_BK04_7A_H      _PK_H_(0x04, 0x7A)
#define REG_SC_BK04_7B_L      _PK_L_(0x04, 0x7B)
#define REG_SC_BK04_7B_H      _PK_H_(0x04, 0x7B)
#define REG_SC_BK04_7C_L      _PK_L_(0x04, 0x7C)
#define REG_SC_BK04_7C_H      _PK_H_(0x04, 0x7C)
#define REG_SC_BK04_7D_L      _PK_L_(0x04, 0x7D)
#define REG_SC_BK04_7D_H      _PK_H_(0x04, 0x7D)
#define REG_SC_BK04_7E_L      _PK_L_(0x04, 0x7E)
#define REG_SC_BK04_7E_H      _PK_H_(0x04, 0x7E)
#define REG_SC_BK04_7F_L      _PK_L_(0x04, 0x7F)
#define REG_SC_BK04_7F_H      _PK_H_(0x04, 0x7F)


//----------------------------------------------
//  BK05: OPM
//----------------------------------------------
#define REG_SC_BK05_00_L      _PK_L_(0x05, 0x00)
#define REG_SC_BK05_00_H      _PK_H_(0x05, 0x00)
#define REG_SC_BK05_01_L      _PK_L_(0x05, 0x01)
#define REG_SC_BK05_01_H      _PK_H_(0x05, 0x01)
#define REG_SC_BK05_02_L      _PK_L_(0x05, 0x02)
#define REG_SC_BK05_02_H      _PK_H_(0x05, 0x02)
#define REG_SC_BK05_03_L      _PK_L_(0x05, 0x03)
#define REG_SC_BK05_03_H      _PK_H_(0x05, 0x03)
#define REG_SC_BK05_04_L      _PK_L_(0x05, 0x04)
#define REG_SC_BK05_04_H      _PK_H_(0x05, 0x04)
#define REG_SC_BK05_05_L      _PK_L_(0x05, 0x05)
#define REG_SC_BK05_05_H      _PK_H_(0x05, 0x05)
#define REG_SC_BK05_06_L      _PK_L_(0x05, 0x06)
#define REG_SC_BK05_06_H      _PK_H_(0x05, 0x06)
#define REG_SC_BK05_07_L      _PK_L_(0x05, 0x07)
#define REG_SC_BK05_07_H      _PK_H_(0x05, 0x07)
#define REG_SC_BK05_08_L      _PK_L_(0x05, 0x08)
#define REG_SC_BK05_08_H      _PK_H_(0x05, 0x08)
#define REG_SC_BK05_09_L      _PK_L_(0x05, 0x09)
#define REG_SC_BK05_09_H      _PK_H_(0x05, 0x09)
#define REG_SC_BK05_0A_L      _PK_L_(0x05, 0x0A)
#define REG_SC_BK05_0A_H      _PK_H_(0x05, 0x0A)
#define REG_SC_BK05_0B_L      _PK_L_(0x05, 0x0B)
#define REG_SC_BK05_0B_H      _PK_H_(0x05, 0x0B)
#define REG_SC_BK05_0C_L      _PK_L_(0x05, 0x0C)
#define REG_SC_BK05_0C_H      _PK_H_(0x05, 0x0C)
#define REG_SC_BK05_0D_L      _PK_L_(0x05, 0x0D)
#define REG_SC_BK05_0D_H      _PK_H_(0x05, 0x0D)
#define REG_SC_BK05_0E_L      _PK_L_(0x05, 0x0E)
#define REG_SC_BK05_0E_H      _PK_H_(0x05, 0x0E)
#define REG_SC_BK05_0F_L      _PK_L_(0x05, 0x0F)
#define REG_SC_BK05_0F_H      _PK_H_(0x05, 0x0F)
#define REG_SC_BK05_10_L      _PK_L_(0x05, 0x10)
#define REG_SC_BK05_10_H      _PK_H_(0x05, 0x10)
#define REG_SC_BK05_11_L      _PK_L_(0x05, 0x11)
#define REG_SC_BK05_11_H      _PK_H_(0x05, 0x11)
#define REG_SC_BK05_12_L      _PK_L_(0x05, 0x12)
#define REG_SC_BK05_12_H      _PK_H_(0x05, 0x12)
#define REG_SC_BK05_13_L      _PK_L_(0x05, 0x13)
#define REG_SC_BK05_13_H      _PK_H_(0x05, 0x13)
#define REG_SC_BK05_14_L      _PK_L_(0x05, 0x14)
#define REG_SC_BK05_14_H      _PK_H_(0x05, 0x14)
#define REG_SC_BK05_15_L      _PK_L_(0x05, 0x15)
#define REG_SC_BK05_15_H      _PK_H_(0x05, 0x15)
#define REG_SC_BK05_16_L      _PK_L_(0x05, 0x16)
#define REG_SC_BK05_16_H      _PK_H_(0x05, 0x16)
#define REG_SC_BK05_17_L      _PK_L_(0x05, 0x17)
#define REG_SC_BK05_17_H      _PK_H_(0x05, 0x17)
#define REG_SC_BK05_18_L      _PK_L_(0x05, 0x18)
#define REG_SC_BK05_18_H      _PK_H_(0x05, 0x18)
#define REG_SC_BK05_19_L      _PK_L_(0x05, 0x19)
#define REG_SC_BK05_19_H      _PK_H_(0x05, 0x19)
#define REG_SC_BK05_1A_L      _PK_L_(0x05, 0x1A)
#define REG_SC_BK05_1A_H      _PK_H_(0x05, 0x1A)
#define REG_SC_BK05_1B_L      _PK_L_(0x05, 0x1B)
#define REG_SC_BK05_1B_H      _PK_H_(0x05, 0x1B)
#define REG_SC_BK05_1C_L      _PK_L_(0x05, 0x1C)
#define REG_SC_BK05_1C_H      _PK_H_(0x05, 0x1C)
#define REG_SC_BK05_1D_L      _PK_L_(0x05, 0x1D)
#define REG_SC_BK05_1D_H      _PK_H_(0x05, 0x1D)
#define REG_SC_BK05_1E_L      _PK_L_(0x05, 0x1E)
#define REG_SC_BK05_1E_H      _PK_H_(0x05, 0x1E)
#define REG_SC_BK05_1F_L      _PK_L_(0x05, 0x1F)
#define REG_SC_BK05_1F_H      _PK_H_(0x05, 0x1F)
#define REG_SC_BK05_20_L      _PK_L_(0x05, 0x20)
#define REG_SC_BK05_20_H      _PK_H_(0x05, 0x20)
#define REG_SC_BK05_21_L      _PK_L_(0x05, 0x21)
#define REG_SC_BK05_21_H      _PK_H_(0x05, 0x21)
#define REG_SC_BK05_22_L      _PK_L_(0x05, 0x22)
#define REG_SC_BK05_22_H      _PK_H_(0x05, 0x22)
#define REG_SC_BK05_23_L      _PK_L_(0x05, 0x23)
#define REG_SC_BK05_23_H      _PK_H_(0x05, 0x23)
#define REG_SC_BK05_24_L      _PK_L_(0x05, 0x24)
#define REG_SC_BK05_24_H      _PK_H_(0x05, 0x24)
#define REG_SC_BK05_25_L      _PK_L_(0x05, 0x25)
#define REG_SC_BK05_25_H      _PK_H_(0x05, 0x25)
#define REG_SC_BK05_26_L      _PK_L_(0x05, 0x26)
#define REG_SC_BK05_26_H      _PK_H_(0x05, 0x26)
#define REG_SC_BK05_27_L      _PK_L_(0x05, 0x27)
#define REG_SC_BK05_27_H      _PK_H_(0x05, 0x27)
#define REG_SC_BK05_28_L      _PK_L_(0x05, 0x28)
#define REG_SC_BK05_28_H      _PK_H_(0x05, 0x28)
#define REG_SC_BK05_29_L      _PK_L_(0x05, 0x29)
#define REG_SC_BK05_29_H      _PK_H_(0x05, 0x29)
#define REG_SC_BK05_2A_L      _PK_L_(0x05, 0x2A)
#define REG_SC_BK05_2A_H      _PK_H_(0x05, 0x2A)
#define REG_SC_BK05_2B_L      _PK_L_(0x05, 0x2B)
#define REG_SC_BK05_2B_H      _PK_H_(0x05, 0x2B)
#define REG_SC_BK05_2C_L      _PK_L_(0x05, 0x2C)
#define REG_SC_BK05_2C_H      _PK_H_(0x05, 0x2C)
#define REG_SC_BK05_2D_L      _PK_L_(0x05, 0x2D)
#define REG_SC_BK05_2D_H      _PK_H_(0x05, 0x2D)
#define REG_SC_BK05_2E_L      _PK_L_(0x05, 0x2E)
#define REG_SC_BK05_2E_H      _PK_H_(0x05, 0x2E)
#define REG_SC_BK05_2F_L      _PK_L_(0x05, 0x2F)
#define REG_SC_BK05_2F_H      _PK_H_(0x05, 0x2F)
#define REG_SC_BK05_30_L      _PK_L_(0x05, 0x30)
#define REG_SC_BK05_30_H      _PK_H_(0x05, 0x30)
#define REG_SC_BK05_31_L      _PK_L_(0x05, 0x31)
#define REG_SC_BK05_31_H      _PK_H_(0x05, 0x31)
#define REG_SC_BK05_32_L      _PK_L_(0x05, 0x32)
#define REG_SC_BK05_32_H      _PK_H_(0x05, 0x32)
#define REG_SC_BK05_33_L      _PK_L_(0x05, 0x33)
#define REG_SC_BK05_33_H      _PK_H_(0x05, 0x33)
#define REG_SC_BK05_34_L      _PK_L_(0x05, 0x34)
#define REG_SC_BK05_34_H      _PK_H_(0x05, 0x34)
#define REG_SC_BK05_35_L      _PK_L_(0x05, 0x35)
#define REG_SC_BK05_35_H      _PK_H_(0x05, 0x35)
#define REG_SC_BK05_36_L      _PK_L_(0x05, 0x36)
#define REG_SC_BK05_36_H      _PK_H_(0x05, 0x36)
#define REG_SC_BK05_37_L      _PK_L_(0x05, 0x37)
#define REG_SC_BK05_37_H      _PK_H_(0x05, 0x37)
#define REG_SC_BK05_38_L      _PK_L_(0x05, 0x38)
#define REG_SC_BK05_38_H      _PK_H_(0x05, 0x38)
#define REG_SC_BK05_39_L      _PK_L_(0x05, 0x39)
#define REG_SC_BK05_39_H      _PK_H_(0x05, 0x39)
#define REG_SC_BK05_3A_L      _PK_L_(0x05, 0x3A)
#define REG_SC_BK05_3A_H      _PK_H_(0x05, 0x3A)
#define REG_SC_BK05_3B_L      _PK_L_(0x05, 0x3B)
#define REG_SC_BK05_3B_H      _PK_H_(0x05, 0x3B)
#define REG_SC_BK05_3C_L      _PK_L_(0x05, 0x3C)
#define REG_SC_BK05_3C_H      _PK_H_(0x05, 0x3C)
#define REG_SC_BK05_3D_L      _PK_L_(0x05, 0x3D)
#define REG_SC_BK05_3D_H      _PK_H_(0x05, 0x3D)
#define REG_SC_BK05_3E_L      _PK_L_(0x05, 0x3E)
#define REG_SC_BK05_3E_H      _PK_H_(0x05, 0x3E)
#define REG_SC_BK05_3F_L      _PK_L_(0x05, 0x3F)
#define REG_SC_BK05_3F_H      _PK_H_(0x05, 0x3F)
#define REG_SC_BK05_40_L      _PK_L_(0x05, 0x40)
#define REG_SC_BK05_40_H      _PK_H_(0x05, 0x40)
#define REG_SC_BK05_41_L      _PK_L_(0x05, 0x41)
#define REG_SC_BK05_41_H      _PK_H_(0x05, 0x41)
#define REG_SC_BK05_42_L      _PK_L_(0x05, 0x42)
#define REG_SC_BK05_42_H      _PK_H_(0x05, 0x42)
#define REG_SC_BK05_43_L      _PK_L_(0x05, 0x43)
#define REG_SC_BK05_43_H      _PK_H_(0x05, 0x43)
#define REG_SC_BK05_44_L      _PK_L_(0x05, 0x44)
#define REG_SC_BK05_44_H      _PK_H_(0x05, 0x44)
#define REG_SC_BK05_45_L      _PK_L_(0x05, 0x45)
#define REG_SC_BK05_45_H      _PK_H_(0x05, 0x45)
#define REG_SC_BK05_46_L      _PK_L_(0x05, 0x46)
#define REG_SC_BK05_46_H      _PK_H_(0x05, 0x46)
#define REG_SC_BK05_47_L      _PK_L_(0x05, 0x47)
#define REG_SC_BK05_47_H      _PK_H_(0x05, 0x47)
#define REG_SC_BK05_48_L      _PK_L_(0x05, 0x48)
#define REG_SC_BK05_48_H      _PK_H_(0x05, 0x48)
#define REG_SC_BK05_49_L      _PK_L_(0x05, 0x49)
#define REG_SC_BK05_49_H      _PK_H_(0x05, 0x49)
#define REG_SC_BK05_4A_L      _PK_L_(0x05, 0x4A)
#define REG_SC_BK05_4A_H      _PK_H_(0x05, 0x4A)
#define REG_SC_BK05_4B_L      _PK_L_(0x05, 0x4B)
#define REG_SC_BK05_4B_H      _PK_H_(0x05, 0x4B)
#define REG_SC_BK05_4C_L      _PK_L_(0x05, 0x4C)
#define REG_SC_BK05_4C_H      _PK_H_(0x05, 0x4C)
#define REG_SC_BK05_4D_L      _PK_L_(0x05, 0x4D)
#define REG_SC_BK05_4D_H      _PK_H_(0x05, 0x4D)
#define REG_SC_BK05_4E_L      _PK_L_(0x05, 0x4E)
#define REG_SC_BK05_4E_H      _PK_H_(0x05, 0x4E)
#define REG_SC_BK05_4F_L      _PK_L_(0x05, 0x4F)
#define REG_SC_BK05_4F_H      _PK_H_(0x05, 0x4F)
#define REG_SC_BK05_50_L      _PK_L_(0x05, 0x50)
#define REG_SC_BK05_50_H      _PK_H_(0x05, 0x50)
#define REG_SC_BK05_51_L      _PK_L_(0x05, 0x51)
#define REG_SC_BK05_51_H      _PK_H_(0x05, 0x51)
#define REG_SC_BK05_52_L      _PK_L_(0x05, 0x52)
#define REG_SC_BK05_52_H      _PK_H_(0x05, 0x52)
#define REG_SC_BK05_53_L      _PK_L_(0x05, 0x53)
#define REG_SC_BK05_53_H      _PK_H_(0x05, 0x53)
#define REG_SC_BK05_54_L      _PK_L_(0x05, 0x54)
#define REG_SC_BK05_54_H      _PK_H_(0x05, 0x54)
#define REG_SC_BK05_55_L      _PK_L_(0x05, 0x55)
#define REG_SC_BK05_55_H      _PK_H_(0x05, 0x55)
#define REG_SC_BK05_56_L      _PK_L_(0x05, 0x56)
#define REG_SC_BK05_56_H      _PK_H_(0x05, 0x56)
#define REG_SC_BK05_57_L      _PK_L_(0x05, 0x57)
#define REG_SC_BK05_57_H      _PK_H_(0x05, 0x57)
#define REG_SC_BK05_58_L      _PK_L_(0x05, 0x58)
#define REG_SC_BK05_58_H      _PK_H_(0x05, 0x58)
#define REG_SC_BK05_59_L      _PK_L_(0x05, 0x59)
#define REG_SC_BK05_59_H      _PK_H_(0x05, 0x59)
#define REG_SC_BK05_5A_L      _PK_L_(0x05, 0x5A)
#define REG_SC_BK05_5A_H      _PK_H_(0x05, 0x5A)
#define REG_SC_BK05_5B_L      _PK_L_(0x05, 0x5B)
#define REG_SC_BK05_5B_H      _PK_H_(0x05, 0x5B)
#define REG_SC_BK05_5C_L      _PK_L_(0x05, 0x5C)
#define REG_SC_BK05_5C_H      _PK_H_(0x05, 0x5C)
#define REG_SC_BK05_5D_L      _PK_L_(0x05, 0x5D)
#define REG_SC_BK05_5D_H      _PK_H_(0x05, 0x5D)
#define REG_SC_BK05_5E_L      _PK_L_(0x05, 0x5E)
#define REG_SC_BK05_5E_H      _PK_H_(0x05, 0x5E)
#define REG_SC_BK05_5F_L      _PK_L_(0x05, 0x5F)
#define REG_SC_BK05_5F_H      _PK_H_(0x05, 0x5F)
#define REG_SC_BK05_60_L      _PK_L_(0x05, 0x60)
#define REG_SC_BK05_60_H      _PK_H_(0x05, 0x60)
#define REG_SC_BK05_61_L      _PK_L_(0x05, 0x61)
#define REG_SC_BK05_61_H      _PK_H_(0x05, 0x61)
#define REG_SC_BK05_62_L      _PK_L_(0x05, 0x62)
#define REG_SC_BK05_62_H      _PK_H_(0x05, 0x62)
#define REG_SC_BK05_63_L      _PK_L_(0x05, 0x63)
#define REG_SC_BK05_63_H      _PK_H_(0x05, 0x63)
#define REG_SC_BK05_64_L      _PK_L_(0x05, 0x64)
#define REG_SC_BK05_64_H      _PK_H_(0x05, 0x64)
#define REG_SC_BK05_65_L      _PK_L_(0x05, 0x65)
#define REG_SC_BK05_65_H      _PK_H_(0x05, 0x65)
#define REG_SC_BK05_66_L      _PK_L_(0x05, 0x66)
#define REG_SC_BK05_66_H      _PK_H_(0x05, 0x66)
#define REG_SC_BK05_67_L      _PK_L_(0x05, 0x67)
#define REG_SC_BK05_67_H      _PK_H_(0x05, 0x67)
#define REG_SC_BK05_68_L      _PK_L_(0x05, 0x68)
#define REG_SC_BK05_68_H      _PK_H_(0x05, 0x68)
#define REG_SC_BK05_69_L      _PK_L_(0x05, 0x69)
#define REG_SC_BK05_69_H      _PK_H_(0x05, 0x69)
#define REG_SC_BK05_6A_L      _PK_L_(0x05, 0x6A)
#define REG_SC_BK05_6A_H      _PK_H_(0x05, 0x6A)
#define REG_SC_BK05_6B_L      _PK_L_(0x05, 0x6B)
#define REG_SC_BK05_6B_H      _PK_H_(0x05, 0x6B)
#define REG_SC_BK05_6C_L      _PK_L_(0x05, 0x6C)
#define REG_SC_BK05_6C_H      _PK_H_(0x05, 0x6C)
#define REG_SC_BK05_6D_L      _PK_L_(0x05, 0x6D)
#define REG_SC_BK05_6D_H      _PK_H_(0x05, 0x6D)
#define REG_SC_BK05_6E_L      _PK_L_(0x05, 0x6E)
#define REG_SC_BK05_6E_H      _PK_H_(0x05, 0x6E)
#define REG_SC_BK05_6F_L      _PK_L_(0x05, 0x6F)
#define REG_SC_BK05_6F_H      _PK_H_(0x05, 0x6F)
#define REG_SC_BK05_70_L      _PK_L_(0x05, 0x70)
#define REG_SC_BK05_70_H      _PK_H_(0x05, 0x70)
#define REG_SC_BK05_71_L      _PK_L_(0x05, 0x71)
#define REG_SC_BK05_71_H      _PK_H_(0x05, 0x71)
#define REG_SC_BK05_72_L      _PK_L_(0x05, 0x72)
#define REG_SC_BK05_72_H      _PK_H_(0x05, 0x72)
#define REG_SC_BK05_73_L      _PK_L_(0x05, 0x73)
#define REG_SC_BK05_73_H      _PK_H_(0x05, 0x73)
#define REG_SC_BK05_74_L      _PK_L_(0x05, 0x74)
#define REG_SC_BK05_74_H      _PK_H_(0x05, 0x74)
#define REG_SC_BK05_75_L      _PK_L_(0x05, 0x75)
#define REG_SC_BK05_75_H      _PK_H_(0x05, 0x75)
#define REG_SC_BK05_76_L      _PK_L_(0x05, 0x76)
#define REG_SC_BK05_76_H      _PK_H_(0x05, 0x76)
#define REG_SC_BK05_77_L      _PK_L_(0x05, 0x77)
#define REG_SC_BK05_77_H      _PK_H_(0x05, 0x77)
#define REG_SC_BK05_78_L      _PK_L_(0x05, 0x78)
#define REG_SC_BK05_78_H      _PK_H_(0x05, 0x78)
#define REG_SC_BK05_79_L      _PK_L_(0x05, 0x79)
#define REG_SC_BK05_79_H      _PK_H_(0x05, 0x79)
#define REG_SC_BK05_7A_L      _PK_L_(0x05, 0x7A)
#define REG_SC_BK05_7A_H      _PK_H_(0x05, 0x7A)
#define REG_SC_BK05_7B_L      _PK_L_(0x05, 0x7B)
#define REG_SC_BK05_7B_H      _PK_H_(0x05, 0x7B)
#define REG_SC_BK05_7C_L      _PK_L_(0x05, 0x7C)
#define REG_SC_BK05_7C_H      _PK_H_(0x05, 0x7C)
#define REG_SC_BK05_7D_L      _PK_L_(0x05, 0x7D)
#define REG_SC_BK05_7D_H      _PK_H_(0x05, 0x7D)
#define REG_SC_BK05_7E_L      _PK_L_(0x05, 0x7E)
#define REG_SC_BK05_7E_H      _PK_H_(0x05, 0x7E)
#define REG_SC_BK05_7F_L      _PK_L_(0x05, 0x7F)
#define REG_SC_BK05_7F_H      _PK_H_(0x05, 0x7F)


//----------------------------------------------
//  BK06: DNR
//----------------------------------------------
#define REG_SC_BK06_00_L      _PK_L_(0x06, 0x00)
#define REG_SC_BK06_00_H      _PK_H_(0x06, 0x00)
#define REG_SC_BK06_01_L      _PK_L_(0x06, 0x01)
#define REG_SC_BK06_01_H      _PK_H_(0x06, 0x01)
#define REG_SC_BK06_02_L      _PK_L_(0x06, 0x02)
#define REG_SC_BK06_02_H      _PK_H_(0x06, 0x02)
#define REG_SC_BK06_03_L      _PK_L_(0x06, 0x03)
#define REG_SC_BK06_03_H      _PK_H_(0x06, 0x03)
#define REG_SC_BK06_04_L      _PK_L_(0x06, 0x04)
#define REG_SC_BK06_04_H      _PK_H_(0x06, 0x04)
#define REG_SC_BK06_05_L      _PK_L_(0x06, 0x05)
#define REG_SC_BK06_05_H      _PK_H_(0x06, 0x05)
#define REG_SC_BK06_06_L      _PK_L_(0x06, 0x06)
#define REG_SC_BK06_06_H      _PK_H_(0x06, 0x06)
#define REG_SC_BK06_07_L      _PK_L_(0x06, 0x07)
#define REG_SC_BK06_07_H      _PK_H_(0x06, 0x07)
#define REG_SC_BK06_08_L      _PK_L_(0x06, 0x08)
#define REG_SC_BK06_08_H      _PK_H_(0x06, 0x08)
#define REG_SC_BK06_09_L      _PK_L_(0x06, 0x09)
#define REG_SC_BK06_09_H      _PK_H_(0x06, 0x09)
#define REG_SC_BK06_0A_L      _PK_L_(0x06, 0x0A)
#define REG_SC_BK06_0A_H      _PK_H_(0x06, 0x0A)
#define REG_SC_BK06_0B_L      _PK_L_(0x06, 0x0B)
#define REG_SC_BK06_0B_H      _PK_H_(0x06, 0x0B)
#define REG_SC_BK06_0C_L      _PK_L_(0x06, 0x0C)
#define REG_SC_BK06_0C_H      _PK_H_(0x06, 0x0C)
#define REG_SC_BK06_0D_L      _PK_L_(0x06, 0x0D)
#define REG_SC_BK06_0D_H      _PK_H_(0x06, 0x0D)
#define REG_SC_BK06_0E_L      _PK_L_(0x06, 0x0E)
#define REG_SC_BK06_0E_H      _PK_H_(0x06, 0x0E)
#define REG_SC_BK06_0F_L      _PK_L_(0x06, 0x0F)
#define REG_SC_BK06_0F_H      _PK_H_(0x06, 0x0F)
#define REG_SC_BK06_10_L      _PK_L_(0x06, 0x10)
#define REG_SC_BK06_10_H      _PK_H_(0x06, 0x10)
#define REG_SC_BK06_11_L      _PK_L_(0x06, 0x11)
#define REG_SC_BK06_11_H      _PK_H_(0x06, 0x11)
#define REG_SC_BK06_12_L      _PK_L_(0x06, 0x12)
#define REG_SC_BK06_12_H      _PK_H_(0x06, 0x12)
#define REG_SC_BK06_13_L      _PK_L_(0x06, 0x13)
#define REG_SC_BK06_13_H      _PK_H_(0x06, 0x13)
#define REG_SC_BK06_14_L      _PK_L_(0x06, 0x14)
#define REG_SC_BK06_14_H      _PK_H_(0x06, 0x14)
#define REG_SC_BK06_15_L      _PK_L_(0x06, 0x15)
#define REG_SC_BK06_15_H      _PK_H_(0x06, 0x15)
#define REG_SC_BK06_16_L      _PK_L_(0x06, 0x16)
#define REG_SC_BK06_16_H      _PK_H_(0x06, 0x16)
#define REG_SC_BK06_17_L      _PK_L_(0x06, 0x17)
#define REG_SC_BK06_17_H      _PK_H_(0x06, 0x17)
#define REG_SC_BK06_18_L      _PK_L_(0x06, 0x18)
#define REG_SC_BK06_18_H      _PK_H_(0x06, 0x18)
#define REG_SC_BK06_19_L      _PK_L_(0x06, 0x19)
#define REG_SC_BK06_19_H      _PK_H_(0x06, 0x19)
#define REG_SC_BK06_1A_L      _PK_L_(0x06, 0x1A)
#define REG_SC_BK06_1A_H      _PK_H_(0x06, 0x1A)
#define REG_SC_BK06_1B_L      _PK_L_(0x06, 0x1B)
#define REG_SC_BK06_1B_H      _PK_H_(0x06, 0x1B)
#define REG_SC_BK06_1C_L      _PK_L_(0x06, 0x1C)
#define REG_SC_BK06_1C_H      _PK_H_(0x06, 0x1C)
#define REG_SC_BK06_1D_L      _PK_L_(0x06, 0x1D)
#define REG_SC_BK06_1D_H      _PK_H_(0x06, 0x1D)
#define REG_SC_BK06_1E_L      _PK_L_(0x06, 0x1E)
#define REG_SC_BK06_1E_H      _PK_H_(0x06, 0x1E)
#define REG_SC_BK06_1F_L      _PK_L_(0x06, 0x1F)
#define REG_SC_BK06_1F_H      _PK_H_(0x06, 0x1F)
#define REG_SC_BK06_20_L      _PK_L_(0x06, 0x20)
#define REG_SC_BK06_20_H      _PK_H_(0x06, 0x20)
#define REG_SC_BK06_21_L      _PK_L_(0x06, 0x21)
#define REG_SC_BK06_21_H      _PK_H_(0x06, 0x21)
#define REG_SC_BK06_22_L      _PK_L_(0x06, 0x22)
#define REG_SC_BK06_22_H      _PK_H_(0x06, 0x22)
#define REG_SC_BK06_23_L      _PK_L_(0x06, 0x23)
#define REG_SC_BK06_23_H      _PK_H_(0x06, 0x23)
#define REG_SC_BK06_24_L      _PK_L_(0x06, 0x24)
#define REG_SC_BK06_24_H      _PK_H_(0x06, 0x24)
#define REG_SC_BK06_25_L      _PK_L_(0x06, 0x25)
#define REG_SC_BK06_25_H      _PK_H_(0x06, 0x25)
#define REG_SC_BK06_26_L      _PK_L_(0x06, 0x26)
#define REG_SC_BK06_26_H      _PK_H_(0x06, 0x26)
#define REG_SC_BK06_27_L      _PK_L_(0x06, 0x27)
#define REG_SC_BK06_27_H      _PK_H_(0x06, 0x27)
#define REG_SC_BK06_28_L      _PK_L_(0x06, 0x28)
#define REG_SC_BK06_28_H      _PK_H_(0x06, 0x28)
#define REG_SC_BK06_29_L      _PK_L_(0x06, 0x29)
#define REG_SC_BK06_29_H      _PK_H_(0x06, 0x29)
#define REG_SC_BK06_2A_L      _PK_L_(0x06, 0x2A)
#define REG_SC_BK06_2A_H      _PK_H_(0x06, 0x2A)
#define REG_SC_BK06_2B_L      _PK_L_(0x06, 0x2B)
#define REG_SC_BK06_2B_H      _PK_H_(0x06, 0x2B)
#define REG_SC_BK06_2C_L      _PK_L_(0x06, 0x2C)
#define REG_SC_BK06_2C_H      _PK_H_(0x06, 0x2C)
#define REG_SC_BK06_2D_L      _PK_L_(0x06, 0x2D)
#define REG_SC_BK06_2D_H      _PK_H_(0x06, 0x2D)
#define REG_SC_BK06_2E_L      _PK_L_(0x06, 0x2E)
#define REG_SC_BK06_2E_H      _PK_H_(0x06, 0x2E)
#define REG_SC_BK06_2F_L      _PK_L_(0x06, 0x2F)
#define REG_SC_BK06_2F_H      _PK_H_(0x06, 0x2F)
#define REG_SC_BK06_30_L      _PK_L_(0x06, 0x30)
#define REG_SC_BK06_30_H      _PK_H_(0x06, 0x30)
#define REG_SC_BK06_31_L      _PK_L_(0x06, 0x31)
#define REG_SC_BK06_31_H      _PK_H_(0x06, 0x31)
#define REG_SC_BK06_32_L      _PK_L_(0x06, 0x32)
#define REG_SC_BK06_32_H      _PK_H_(0x06, 0x32)
#define REG_SC_BK06_33_L      _PK_L_(0x06, 0x33)
#define REG_SC_BK06_33_H      _PK_H_(0x06, 0x33)
#define REG_SC_BK06_34_L      _PK_L_(0x06, 0x34)
#define REG_SC_BK06_34_H      _PK_H_(0x06, 0x34)
#define REG_SC_BK06_35_L      _PK_L_(0x06, 0x35)
#define REG_SC_BK06_35_H      _PK_H_(0x06, 0x35)
#define REG_SC_BK06_36_L      _PK_L_(0x06, 0x36)
#define REG_SC_BK06_36_H      _PK_H_(0x06, 0x36)
#define REG_SC_BK06_37_L      _PK_L_(0x06, 0x37)
#define REG_SC_BK06_37_H      _PK_H_(0x06, 0x37)
#define REG_SC_BK06_38_L      _PK_L_(0x06, 0x38)
#define REG_SC_BK06_38_H      _PK_H_(0x06, 0x38)
#define REG_SC_BK06_39_L      _PK_L_(0x06, 0x39)
#define REG_SC_BK06_39_H      _PK_H_(0x06, 0x39)
#define REG_SC_BK06_3A_L      _PK_L_(0x06, 0x3A)
#define REG_SC_BK06_3A_H      _PK_H_(0x06, 0x3A)
#define REG_SC_BK06_3B_L      _PK_L_(0x06, 0x3B)
#define REG_SC_BK06_3B_H      _PK_H_(0x06, 0x3B)
#define REG_SC_BK06_3C_L      _PK_L_(0x06, 0x3C)
#define REG_SC_BK06_3C_H      _PK_H_(0x06, 0x3C)
#define REG_SC_BK06_3D_L      _PK_L_(0x06, 0x3D)
#define REG_SC_BK06_3D_H      _PK_H_(0x06, 0x3D)
#define REG_SC_BK06_3E_L      _PK_L_(0x06, 0x3E)
#define REG_SC_BK06_3E_H      _PK_H_(0x06, 0x3E)
#define REG_SC_BK06_3F_L      _PK_L_(0x06, 0x3F)
#define REG_SC_BK06_3F_H      _PK_H_(0x06, 0x3F)
#define REG_SC_BK06_40_L      _PK_L_(0x06, 0x40)
#define REG_SC_BK06_40_H      _PK_H_(0x06, 0x40)
#define REG_SC_BK06_41_L      _PK_L_(0x06, 0x41)
#define REG_SC_BK06_41_H      _PK_H_(0x06, 0x41)
#define REG_SC_BK06_42_L      _PK_L_(0x06, 0x42)
#define REG_SC_BK06_42_H      _PK_H_(0x06, 0x42)
#define REG_SC_BK06_43_L      _PK_L_(0x06, 0x43)
#define REG_SC_BK06_43_H      _PK_H_(0x06, 0x43)
#define REG_SC_BK06_44_L      _PK_L_(0x06, 0x44)
#define REG_SC_BK06_44_H      _PK_H_(0x06, 0x44)
#define REG_SC_BK06_45_L      _PK_L_(0x06, 0x45)
#define REG_SC_BK06_45_H      _PK_H_(0x06, 0x45)
#define REG_SC_BK06_46_L      _PK_L_(0x06, 0x46)
#define REG_SC_BK06_46_H      _PK_H_(0x06, 0x46)
#define REG_SC_BK06_47_L      _PK_L_(0x06, 0x47)
#define REG_SC_BK06_47_H      _PK_H_(0x06, 0x47)
#define REG_SC_BK06_48_L      _PK_L_(0x06, 0x48)
#define REG_SC_BK06_48_H      _PK_H_(0x06, 0x48)
#define REG_SC_BK06_49_L      _PK_L_(0x06, 0x49)
#define REG_SC_BK06_49_H      _PK_H_(0x06, 0x49)
#define REG_SC_BK06_4A_L      _PK_L_(0x06, 0x4A)
#define REG_SC_BK06_4A_H      _PK_H_(0x06, 0x4A)
#define REG_SC_BK06_4B_L      _PK_L_(0x06, 0x4B)
#define REG_SC_BK06_4B_H      _PK_H_(0x06, 0x4B)
#define REG_SC_BK06_4C_L      _PK_L_(0x06, 0x4C)
#define REG_SC_BK06_4C_H      _PK_H_(0x06, 0x4C)
#define REG_SC_BK06_4D_L      _PK_L_(0x06, 0x4D)
#define REG_SC_BK06_4D_H      _PK_H_(0x06, 0x4D)
#define REG_SC_BK06_4E_L      _PK_L_(0x06, 0x4E)
#define REG_SC_BK06_4E_H      _PK_H_(0x06, 0x4E)
#define REG_SC_BK06_4F_L      _PK_L_(0x06, 0x4F)
#define REG_SC_BK06_4F_H      _PK_H_(0x06, 0x4F)
#define REG_SC_BK06_50_L      _PK_L_(0x06, 0x50)
#define REG_SC_BK06_50_H      _PK_H_(0x06, 0x50)
#define REG_SC_BK06_51_L      _PK_L_(0x06, 0x51)
#define REG_SC_BK06_51_H      _PK_H_(0x06, 0x51)
#define REG_SC_BK06_52_L      _PK_L_(0x06, 0x52)
#define REG_SC_BK06_52_H      _PK_H_(0x06, 0x52)
#define REG_SC_BK06_53_L      _PK_L_(0x06, 0x53)
#define REG_SC_BK06_53_H      _PK_H_(0x06, 0x53)
#define REG_SC_BK06_54_L      _PK_L_(0x06, 0x54)
#define REG_SC_BK06_54_H      _PK_H_(0x06, 0x54)
#define REG_SC_BK06_55_L      _PK_L_(0x06, 0x55)
#define REG_SC_BK06_55_H      _PK_H_(0x06, 0x55)
#define REG_SC_BK06_56_L      _PK_L_(0x06, 0x56)
#define REG_SC_BK06_56_H      _PK_H_(0x06, 0x56)
#define REG_SC_BK06_57_L      _PK_L_(0x06, 0x57)
#define REG_SC_BK06_57_H      _PK_H_(0x06, 0x57)
#define REG_SC_BK06_58_L      _PK_L_(0x06, 0x58)
#define REG_SC_BK06_58_H      _PK_H_(0x06, 0x58)
#define REG_SC_BK06_59_L      _PK_L_(0x06, 0x59)
#define REG_SC_BK06_59_H      _PK_H_(0x06, 0x59)
#define REG_SC_BK06_5A_L      _PK_L_(0x06, 0x5A)
#define REG_SC_BK06_5A_H      _PK_H_(0x06, 0x5A)
#define REG_SC_BK06_5B_L      _PK_L_(0x06, 0x5B)
#define REG_SC_BK06_5B_H      _PK_H_(0x06, 0x5B)
#define REG_SC_BK06_5C_L      _PK_L_(0x06, 0x5C)
#define REG_SC_BK06_5C_H      _PK_H_(0x06, 0x5C)
#define REG_SC_BK06_5D_L      _PK_L_(0x06, 0x5D)
#define REG_SC_BK06_5D_H      _PK_H_(0x06, 0x5D)
#define REG_SC_BK06_5E_L      _PK_L_(0x06, 0x5E)
#define REG_SC_BK06_5E_H      _PK_H_(0x06, 0x5E)
#define REG_SC_BK06_5F_L      _PK_L_(0x06, 0x5F)
#define REG_SC_BK06_5F_H      _PK_H_(0x06, 0x5F)
#define REG_SC_BK06_60_L      _PK_L_(0x06, 0x60)
#define REG_SC_BK06_60_H      _PK_H_(0x06, 0x60)
#define REG_SC_BK06_61_L      _PK_L_(0x06, 0x61)
#define REG_SC_BK06_61_H      _PK_H_(0x06, 0x61)
#define REG_SC_BK06_62_L      _PK_L_(0x06, 0x62)
#define REG_SC_BK06_62_H      _PK_H_(0x06, 0x62)
#define REG_SC_BK06_63_L      _PK_L_(0x06, 0x63)
#define REG_SC_BK06_63_H      _PK_H_(0x06, 0x63)
#define REG_SC_BK06_64_L      _PK_L_(0x06, 0x64)
#define REG_SC_BK06_64_H      _PK_H_(0x06, 0x64)
#define REG_SC_BK06_65_L      _PK_L_(0x06, 0x65)
#define REG_SC_BK06_65_H      _PK_H_(0x06, 0x65)
#define REG_SC_BK06_66_L      _PK_L_(0x06, 0x66)
#define REG_SC_BK06_66_H      _PK_H_(0x06, 0x66)
#define REG_SC_BK06_67_L      _PK_L_(0x06, 0x67)
#define REG_SC_BK06_67_H      _PK_H_(0x06, 0x67)
#define REG_SC_BK06_68_L      _PK_L_(0x06, 0x68)
#define REG_SC_BK06_68_H      _PK_H_(0x06, 0x68)
#define REG_SC_BK06_69_L      _PK_L_(0x06, 0x69)
#define REG_SC_BK06_69_H      _PK_H_(0x06, 0x69)
#define REG_SC_BK06_6A_L      _PK_L_(0x06, 0x6A)
#define REG_SC_BK06_6A_H      _PK_H_(0x06, 0x6A)
#define REG_SC_BK06_6B_L      _PK_L_(0x06, 0x6B)
#define REG_SC_BK06_6B_H      _PK_H_(0x06, 0x6B)
#define REG_SC_BK06_6C_L      _PK_L_(0x06, 0x6C)
#define REG_SC_BK06_6C_H      _PK_H_(0x06, 0x6C)
#define REG_SC_BK06_6D_L      _PK_L_(0x06, 0x6D)
#define REG_SC_BK06_6D_H      _PK_H_(0x06, 0x6D)
#define REG_SC_BK06_6E_L      _PK_L_(0x06, 0x6E)
#define REG_SC_BK06_6E_H      _PK_H_(0x06, 0x6E)
#define REG_SC_BK06_6F_L      _PK_L_(0x06, 0x6F)
#define REG_SC_BK06_6F_H      _PK_H_(0x06, 0x6F)
#define REG_SC_BK06_70_L      _PK_L_(0x06, 0x70)
#define REG_SC_BK06_70_H      _PK_H_(0x06, 0x70)
#define REG_SC_BK06_71_L      _PK_L_(0x06, 0x71)
#define REG_SC_BK06_71_H      _PK_H_(0x06, 0x71)
#define REG_SC_BK06_72_L      _PK_L_(0x06, 0x72)
#define REG_SC_BK06_72_H      _PK_H_(0x06, 0x72)
#define REG_SC_BK06_73_L      _PK_L_(0x06, 0x73)
#define REG_SC_BK06_73_H      _PK_H_(0x06, 0x73)
#define REG_SC_BK06_74_L      _PK_L_(0x06, 0x74)
#define REG_SC_BK06_74_H      _PK_H_(0x06, 0x74)
#define REG_SC_BK06_75_L      _PK_L_(0x06, 0x75)
#define REG_SC_BK06_75_H      _PK_H_(0x06, 0x75)
#define REG_SC_BK06_76_L      _PK_L_(0x06, 0x76)
#define REG_SC_BK06_76_H      _PK_H_(0x06, 0x76)
#define REG_SC_BK06_77_L      _PK_L_(0x06, 0x77)
#define REG_SC_BK06_77_H      _PK_H_(0x06, 0x77)
#define REG_SC_BK06_78_L      _PK_L_(0x06, 0x78)
#define REG_SC_BK06_78_H      _PK_H_(0x06, 0x78)
#define REG_SC_BK06_79_L      _PK_L_(0x06, 0x79)
#define REG_SC_BK06_79_H      _PK_H_(0x06, 0x79)
#define REG_SC_BK06_7A_L      _PK_L_(0x06, 0x7A)
#define REG_SC_BK06_7A_H      _PK_H_(0x06, 0x7A)
#define REG_SC_BK06_7B_L      _PK_L_(0x06, 0x7B)
#define REG_SC_BK06_7B_H      _PK_H_(0x06, 0x7B)
#define REG_SC_BK06_7C_L      _PK_L_(0x06, 0x7C)
#define REG_SC_BK06_7C_H      _PK_H_(0x06, 0x7C)
#define REG_SC_BK06_7D_L      _PK_L_(0x06, 0x7D)
#define REG_SC_BK06_7D_H      _PK_H_(0x06, 0x7D)
#define REG_SC_BK06_7E_L      _PK_L_(0x06, 0x7E)
#define REG_SC_BK06_7E_H      _PK_H_(0x06, 0x7E)
#define REG_SC_BK06_7F_L      _PK_L_(0x06, 0x7F)
#define REG_SC_BK06_7F_H      _PK_H_(0x06, 0x7F)


//----------------------------------------------
//  BK07: OP1
//----------------------------------------------
#define REG_SC_BK07_00_L      _PK_L_(0x07, 0x00)
#define REG_SC_BK07_00_H      _PK_H_(0x07, 0x00)
#define REG_SC_BK07_01_L      _PK_L_(0x07, 0x01)
#define REG_SC_BK07_01_H      _PK_H_(0x07, 0x01)
#define REG_SC_BK07_02_L      _PK_L_(0x07, 0x02)
#define REG_SC_BK07_02_H      _PK_H_(0x07, 0x02)
#define REG_SC_BK07_03_L      _PK_L_(0x07, 0x03)
#define REG_SC_BK07_03_H      _PK_H_(0x07, 0x03)
#define REG_SC_BK07_04_L      _PK_L_(0x07, 0x04)
#define REG_SC_BK07_04_H      _PK_H_(0x07, 0x04)
#define REG_SC_BK07_05_L      _PK_L_(0x07, 0x05)
#define REG_SC_BK07_05_H      _PK_H_(0x07, 0x05)
#define REG_SC_BK07_06_L      _PK_L_(0x07, 0x06)
#define REG_SC_BK07_06_H      _PK_H_(0x07, 0x06)
#define REG_SC_BK07_07_L      _PK_L_(0x07, 0x07)
#define REG_SC_BK07_07_H      _PK_H_(0x07, 0x07)
#define REG_SC_BK07_08_L      _PK_L_(0x07, 0x08)
#define REG_SC_BK07_08_H      _PK_H_(0x07, 0x08)
#define REG_SC_BK07_09_L      _PK_L_(0x07, 0x09)
#define REG_SC_BK07_09_H      _PK_H_(0x07, 0x09)
#define REG_SC_BK07_0A_L      _PK_L_(0x07, 0x0A)
#define REG_SC_BK07_0A_H      _PK_H_(0x07, 0x0A)
#define REG_SC_BK07_0B_L      _PK_L_(0x07, 0x0B)
#define REG_SC_BK07_0B_H      _PK_H_(0x07, 0x0B)
#define REG_SC_BK07_0C_L      _PK_L_(0x07, 0x0C)
#define REG_SC_BK07_0C_H      _PK_H_(0x07, 0x0C)
#define REG_SC_BK07_0D_L      _PK_L_(0x07, 0x0D)
#define REG_SC_BK07_0D_H      _PK_H_(0x07, 0x0D)
#define REG_SC_BK07_0E_L      _PK_L_(0x07, 0x0E)
#define REG_SC_BK07_0E_H      _PK_H_(0x07, 0x0E)
#define REG_SC_BK07_0F_L      _PK_L_(0x07, 0x0F)
#define REG_SC_BK07_0F_H      _PK_H_(0x07, 0x0F)
#define REG_SC_BK07_10_L      _PK_L_(0x07, 0x10)
#define REG_SC_BK07_10_H      _PK_H_(0x07, 0x10)
#define REG_SC_BK07_11_L      _PK_L_(0x07, 0x11)
#define REG_SC_BK07_11_H      _PK_H_(0x07, 0x11)
#define REG_SC_BK07_12_L      _PK_L_(0x07, 0x12)
#define REG_SC_BK07_12_H      _PK_H_(0x07, 0x12)
#define REG_SC_BK07_13_L      _PK_L_(0x07, 0x13)
#define REG_SC_BK07_13_H      _PK_H_(0x07, 0x13)
#define REG_SC_BK07_14_L      _PK_L_(0x07, 0x14)
#define REG_SC_BK07_14_H      _PK_H_(0x07, 0x14)
#define REG_SC_BK07_15_L      _PK_L_(0x07, 0x15)
#define REG_SC_BK07_15_H      _PK_H_(0x07, 0x15)
#define REG_SC_BK07_16_L      _PK_L_(0x07, 0x16)
#define REG_SC_BK07_16_H      _PK_H_(0x07, 0x16)
#define REG_SC_BK07_17_L      _PK_L_(0x07, 0x17)
#define REG_SC_BK07_17_H      _PK_H_(0x07, 0x17)
#define REG_SC_BK07_18_L      _PK_L_(0x07, 0x18)
#define REG_SC_BK07_18_H      _PK_H_(0x07, 0x18)
#define REG_SC_BK07_19_L      _PK_L_(0x07, 0x19)
#define REG_SC_BK07_19_H      _PK_H_(0x07, 0x19)
#define REG_SC_BK07_1A_L      _PK_L_(0x07, 0x1A)
#define REG_SC_BK07_1A_H      _PK_H_(0x07, 0x1A)
#define REG_SC_BK07_1B_L      _PK_L_(0x07, 0x1B)
#define REG_SC_BK07_1B_H      _PK_H_(0x07, 0x1B)
#define REG_SC_BK07_1C_L      _PK_L_(0x07, 0x1C)
#define REG_SC_BK07_1C_H      _PK_H_(0x07, 0x1C)
#define REG_SC_BK07_1D_L      _PK_L_(0x07, 0x1D)
#define REG_SC_BK07_1D_H      _PK_H_(0x07, 0x1D)
#define REG_SC_BK07_1E_L      _PK_L_(0x07, 0x1E)
#define REG_SC_BK07_1E_H      _PK_H_(0x07, 0x1E)
#define REG_SC_BK07_1F_L      _PK_L_(0x07, 0x1F)
#define REG_SC_BK07_1F_H      _PK_H_(0x07, 0x1F)
#define REG_SC_BK07_20_L      _PK_L_(0x07, 0x20)
#define REG_SC_BK07_20_H      _PK_H_(0x07, 0x20)
#define REG_SC_BK07_21_L      _PK_L_(0x07, 0x21)
#define REG_SC_BK07_21_H      _PK_H_(0x07, 0x21)
#define REG_SC_BK07_22_L      _PK_L_(0x07, 0x22)
#define REG_SC_BK07_22_H      _PK_H_(0x07, 0x22)
#define REG_SC_BK07_23_L      _PK_L_(0x07, 0x23)
#define REG_SC_BK07_23_H      _PK_H_(0x07, 0x23)
#define REG_SC_BK07_24_L      _PK_L_(0x07, 0x24)
#define REG_SC_BK07_24_H      _PK_H_(0x07, 0x24)
#define REG_SC_BK07_25_L      _PK_L_(0x07, 0x25)
#define REG_SC_BK07_25_H      _PK_H_(0x07, 0x25)
#define REG_SC_BK07_26_L      _PK_L_(0x07, 0x26)
#define REG_SC_BK07_26_H      _PK_H_(0x07, 0x26)
#define REG_SC_BK07_27_L      _PK_L_(0x07, 0x27)
#define REG_SC_BK07_27_H      _PK_H_(0x07, 0x27)
#define REG_SC_BK07_28_L      _PK_L_(0x07, 0x28)
#define REG_SC_BK07_28_H      _PK_H_(0x07, 0x28)
#define REG_SC_BK07_29_L      _PK_L_(0x07, 0x29)
#define REG_SC_BK07_29_H      _PK_H_(0x07, 0x29)
#define REG_SC_BK07_2A_L      _PK_L_(0x07, 0x2A)
#define REG_SC_BK07_2A_H      _PK_H_(0x07, 0x2A)
#define REG_SC_BK07_2B_L      _PK_L_(0x07, 0x2B)
#define REG_SC_BK07_2B_H      _PK_H_(0x07, 0x2B)
#define REG_SC_BK07_2C_L      _PK_L_(0x07, 0x2C)
#define REG_SC_BK07_2C_H      _PK_H_(0x07, 0x2C)
#define REG_SC_BK07_2D_L      _PK_L_(0x07, 0x2D)
#define REG_SC_BK07_2D_H      _PK_H_(0x07, 0x2D)
#define REG_SC_BK07_2E_L      _PK_L_(0x07, 0x2E)
#define REG_SC_BK07_2E_H      _PK_H_(0x07, 0x2E)
#define REG_SC_BK07_2F_L      _PK_L_(0x07, 0x2F)
#define REG_SC_BK07_2F_H      _PK_H_(0x07, 0x2F)
#define REG_SC_BK07_30_L      _PK_L_(0x07, 0x30)
#define REG_SC_BK07_30_H      _PK_H_(0x07, 0x30)
#define REG_SC_BK07_31_L      _PK_L_(0x07, 0x31)
#define REG_SC_BK07_31_H      _PK_H_(0x07, 0x31)
#define REG_SC_BK07_32_L      _PK_L_(0x07, 0x32)
#define REG_SC_BK07_32_H      _PK_H_(0x07, 0x32)
#define REG_SC_BK07_33_L      _PK_L_(0x07, 0x33)
#define REG_SC_BK07_33_H      _PK_H_(0x07, 0x33)
#define REG_SC_BK07_34_L      _PK_L_(0x07, 0x34)
#define REG_SC_BK07_34_H      _PK_H_(0x07, 0x34)
#define REG_SC_BK07_35_L      _PK_L_(0x07, 0x35)
#define REG_SC_BK07_35_H      _PK_H_(0x07, 0x35)
#define REG_SC_BK07_36_L      _PK_L_(0x07, 0x36)
#define REG_SC_BK07_36_H      _PK_H_(0x07, 0x36)
#define REG_SC_BK07_37_L      _PK_L_(0x07, 0x37)
#define REG_SC_BK07_37_H      _PK_H_(0x07, 0x37)
#define REG_SC_BK07_38_L      _PK_L_(0x07, 0x38)
#define REG_SC_BK07_38_H      _PK_H_(0x07, 0x38)
#define REG_SC_BK07_39_L      _PK_L_(0x07, 0x39)
#define REG_SC_BK07_39_H      _PK_H_(0x07, 0x39)
#define REG_SC_BK07_3A_L      _PK_L_(0x07, 0x3A)
#define REG_SC_BK07_3A_H      _PK_H_(0x07, 0x3A)
#define REG_SC_BK07_3B_L      _PK_L_(0x07, 0x3B)
#define REG_SC_BK07_3B_H      _PK_H_(0x07, 0x3B)
#define REG_SC_BK07_3C_L      _PK_L_(0x07, 0x3C)
#define REG_SC_BK07_3C_H      _PK_H_(0x07, 0x3C)
#define REG_SC_BK07_3D_L      _PK_L_(0x07, 0x3D)
#define REG_SC_BK07_3D_H      _PK_H_(0x07, 0x3D)
#define REG_SC_BK07_3E_L      _PK_L_(0x07, 0x3E)
#define REG_SC_BK07_3E_H      _PK_H_(0x07, 0x3E)
#define REG_SC_BK07_3F_L      _PK_L_(0x07, 0x3F)
#define REG_SC_BK07_3F_H      _PK_H_(0x07, 0x3F)
#define REG_SC_BK07_40_L      _PK_L_(0x07, 0x40)
#define REG_SC_BK07_40_H      _PK_H_(0x07, 0x40)
#define REG_SC_BK07_41_L      _PK_L_(0x07, 0x41)
#define REG_SC_BK07_41_H      _PK_H_(0x07, 0x41)
#define REG_SC_BK07_42_L      _PK_L_(0x07, 0x42)
#define REG_SC_BK07_42_H      _PK_H_(0x07, 0x42)
#define REG_SC_BK07_43_L      _PK_L_(0x07, 0x43)
#define REG_SC_BK07_43_H      _PK_H_(0x07, 0x43)
#define REG_SC_BK07_44_L      _PK_L_(0x07, 0x44)
#define REG_SC_BK07_44_H      _PK_H_(0x07, 0x44)
#define REG_SC_BK07_45_L      _PK_L_(0x07, 0x45)
#define REG_SC_BK07_45_H      _PK_H_(0x07, 0x45)
#define REG_SC_BK07_46_L      _PK_L_(0x07, 0x46)
#define REG_SC_BK07_46_H      _PK_H_(0x07, 0x46)
#define REG_SC_BK07_47_L      _PK_L_(0x07, 0x47)
#define REG_SC_BK07_47_H      _PK_H_(0x07, 0x47)
#define REG_SC_BK07_48_L      _PK_L_(0x07, 0x48)
#define REG_SC_BK07_48_H      _PK_H_(0x07, 0x48)
#define REG_SC_BK07_49_L      _PK_L_(0x07, 0x49)
#define REG_SC_BK07_49_H      _PK_H_(0x07, 0x49)
#define REG_SC_BK07_4A_L      _PK_L_(0x07, 0x4A)
#define REG_SC_BK07_4A_H      _PK_H_(0x07, 0x4A)
#define REG_SC_BK07_4B_L      _PK_L_(0x07, 0x4B)
#define REG_SC_BK07_4B_H      _PK_H_(0x07, 0x4B)
#define REG_SC_BK07_4C_L      _PK_L_(0x07, 0x4C)
#define REG_SC_BK07_4C_H      _PK_H_(0x07, 0x4C)
#define REG_SC_BK07_4D_L      _PK_L_(0x07, 0x4D)
#define REG_SC_BK07_4D_H      _PK_H_(0x07, 0x4D)
#define REG_SC_BK07_4E_L      _PK_L_(0x07, 0x4E)
#define REG_SC_BK07_4E_H      _PK_H_(0x07, 0x4E)
#define REG_SC_BK07_4F_L      _PK_L_(0x07, 0x4F)
#define REG_SC_BK07_4F_H      _PK_H_(0x07, 0x4F)
#define REG_SC_BK07_50_L      _PK_L_(0x07, 0x50)
#define REG_SC_BK07_50_H      _PK_H_(0x07, 0x50)
#define REG_SC_BK07_51_L      _PK_L_(0x07, 0x51)
#define REG_SC_BK07_51_H      _PK_H_(0x07, 0x51)
#define REG_SC_BK07_52_L      _PK_L_(0x07, 0x52)
#define REG_SC_BK07_52_H      _PK_H_(0x07, 0x52)
#define REG_SC_BK07_53_L      _PK_L_(0x07, 0x53)
#define REG_SC_BK07_53_H      _PK_H_(0x07, 0x53)
#define REG_SC_BK07_54_L      _PK_L_(0x07, 0x54)
#define REG_SC_BK07_54_H      _PK_H_(0x07, 0x54)
#define REG_SC_BK07_55_L      _PK_L_(0x07, 0x55)
#define REG_SC_BK07_55_H      _PK_H_(0x07, 0x55)
#define REG_SC_BK07_56_L      _PK_L_(0x07, 0x56)
#define REG_SC_BK07_56_H      _PK_H_(0x07, 0x56)
#define REG_SC_BK07_57_L      _PK_L_(0x07, 0x57)
#define REG_SC_BK07_57_H      _PK_H_(0x07, 0x57)
#define REG_SC_BK07_58_L      _PK_L_(0x07, 0x58)
#define REG_SC_BK07_58_H      _PK_H_(0x07, 0x58)
#define REG_SC_BK07_59_L      _PK_L_(0x07, 0x59)
#define REG_SC_BK07_59_H      _PK_H_(0x07, 0x59)
#define REG_SC_BK07_5A_L      _PK_L_(0x07, 0x5A)
#define REG_SC_BK07_5A_H      _PK_H_(0x07, 0x5A)
#define REG_SC_BK07_5B_L      _PK_L_(0x07, 0x5B)
#define REG_SC_BK07_5B_H      _PK_H_(0x07, 0x5B)
#define REG_SC_BK07_5C_L      _PK_L_(0x07, 0x5C)
#define REG_SC_BK07_5C_H      _PK_H_(0x07, 0x5C)
#define REG_SC_BK07_5D_L      _PK_L_(0x07, 0x5D)
#define REG_SC_BK07_5D_H      _PK_H_(0x07, 0x5D)
#define REG_SC_BK07_5E_L      _PK_L_(0x07, 0x5E)
#define REG_SC_BK07_5E_H      _PK_H_(0x07, 0x5E)
#define REG_SC_BK07_5F_L      _PK_L_(0x07, 0x5F)
#define REG_SC_BK07_5F_H      _PK_H_(0x07, 0x5F)
#define REG_SC_BK07_60_L      _PK_L_(0x07, 0x60)
#define REG_SC_BK07_60_H      _PK_H_(0x07, 0x60)
#define REG_SC_BK07_61_L      _PK_L_(0x07, 0x61)
#define REG_SC_BK07_61_H      _PK_H_(0x07, 0x61)
#define REG_SC_BK07_62_L      _PK_L_(0x07, 0x62)
#define REG_SC_BK07_62_H      _PK_H_(0x07, 0x62)
#define REG_SC_BK07_63_L      _PK_L_(0x07, 0x63)
#define REG_SC_BK07_63_H      _PK_H_(0x07, 0x63)
#define REG_SC_BK07_64_L      _PK_L_(0x07, 0x64)
#define REG_SC_BK07_64_H      _PK_H_(0x07, 0x64)
#define REG_SC_BK07_65_L      _PK_L_(0x07, 0x65)
#define REG_SC_BK07_65_H      _PK_H_(0x07, 0x65)
#define REG_SC_BK07_66_L      _PK_L_(0x07, 0x66)
#define REG_SC_BK07_66_H      _PK_H_(0x07, 0x66)
#define REG_SC_BK07_67_L      _PK_L_(0x07, 0x67)
#define REG_SC_BK07_67_H      _PK_H_(0x07, 0x67)
#define REG_SC_BK07_68_L      _PK_L_(0x07, 0x68)
#define REG_SC_BK07_68_H      _PK_H_(0x07, 0x68)
#define REG_SC_BK07_69_L      _PK_L_(0x07, 0x69)
#define REG_SC_BK07_69_H      _PK_H_(0x07, 0x69)
#define REG_SC_BK07_6A_L      _PK_L_(0x07, 0x6A)
#define REG_SC_BK07_6A_H      _PK_H_(0x07, 0x6A)
#define REG_SC_BK07_6B_L      _PK_L_(0x07, 0x6B)
#define REG_SC_BK07_6B_H      _PK_H_(0x07, 0x6B)
#define REG_SC_BK07_6C_L      _PK_L_(0x07, 0x6C)
#define REG_SC_BK07_6C_H      _PK_H_(0x07, 0x6C)
#define REG_SC_BK07_6D_L      _PK_L_(0x07, 0x6D)
#define REG_SC_BK07_6D_H      _PK_H_(0x07, 0x6D)
#define REG_SC_BK07_6E_L      _PK_L_(0x07, 0x6E)
#define REG_SC_BK07_6E_H      _PK_H_(0x07, 0x6E)
#define REG_SC_BK07_6F_L      _PK_L_(0x07, 0x6F)
#define REG_SC_BK07_6F_H      _PK_H_(0x07, 0x6F)
#define REG_SC_BK07_70_L      _PK_L_(0x07, 0x70)
#define REG_SC_BK07_70_H      _PK_H_(0x07, 0x70)
#define REG_SC_BK07_71_L      _PK_L_(0x07, 0x71)
#define REG_SC_BK07_71_H      _PK_H_(0x07, 0x71)
#define REG_SC_BK07_72_L      _PK_L_(0x07, 0x72)
#define REG_SC_BK07_72_H      _PK_H_(0x07, 0x72)
#define REG_SC_BK07_73_L      _PK_L_(0x07, 0x73)
#define REG_SC_BK07_73_H      _PK_H_(0x07, 0x73)
#define REG_SC_BK07_74_L      _PK_L_(0x07, 0x74)
#define REG_SC_BK07_74_H      _PK_H_(0x07, 0x74)
#define REG_SC_BK07_75_L      _PK_L_(0x07, 0x75)
#define REG_SC_BK07_75_H      _PK_H_(0x07, 0x75)
#define REG_SC_BK07_76_L      _PK_L_(0x07, 0x76)
#define REG_SC_BK07_76_H      _PK_H_(0x07, 0x76)
#define REG_SC_BK07_77_L      _PK_L_(0x07, 0x77)
#define REG_SC_BK07_77_H      _PK_H_(0x07, 0x77)
#define REG_SC_BK07_78_L      _PK_L_(0x07, 0x78)
#define REG_SC_BK07_78_H      _PK_H_(0x07, 0x78)
#define REG_SC_BK07_79_L      _PK_L_(0x07, 0x79)
#define REG_SC_BK07_79_H      _PK_H_(0x07, 0x79)
#define REG_SC_BK07_7A_L      _PK_L_(0x07, 0x7A)
#define REG_SC_BK07_7A_H      _PK_H_(0x07, 0x7A)
#define REG_SC_BK07_7B_L      _PK_L_(0x07, 0x7B)
#define REG_SC_BK07_7B_H      _PK_H_(0x07, 0x7B)
#define REG_SC_BK07_7C_L      _PK_L_(0x07, 0x7C)
#define REG_SC_BK07_7C_H      _PK_H_(0x07, 0x7C)
#define REG_SC_BK07_7D_L      _PK_L_(0x07, 0x7D)
#define REG_SC_BK07_7D_H      _PK_H_(0x07, 0x7D)
#define REG_SC_BK07_7E_L      _PK_L_(0x07, 0x7E)
#define REG_SC_BK07_7E_H      _PK_H_(0x07, 0x7E)
#define REG_SC_BK07_7F_L      _PK_L_(0x07, 0x7F)
#define REG_SC_BK07_7F_H      _PK_H_(0x07, 0x7F)


//----------------------------------------------
//  BK09: OP1HVSP
//----------------------------------------------
#define REG_SC_BK09_00_L      _PK_L_(0x09, 0x00)
#define REG_SC_BK09_00_H      _PK_H_(0x09, 0x00)
#define REG_SC_BK09_01_L      _PK_L_(0x09, 0x01)
#define REG_SC_BK09_01_H      _PK_H_(0x09, 0x01)
#define REG_SC_BK09_02_L      _PK_L_(0x09, 0x02)
#define REG_SC_BK09_02_H      _PK_H_(0x09, 0x02)
#define REG_SC_BK09_03_L      _PK_L_(0x09, 0x03)
#define REG_SC_BK09_03_H      _PK_H_(0x09, 0x03)
#define REG_SC_BK09_04_L      _PK_L_(0x09, 0x04)
#define REG_SC_BK09_04_H      _PK_H_(0x09, 0x04)
#define REG_SC_BK09_05_L      _PK_L_(0x09, 0x05)
#define REG_SC_BK09_05_H      _PK_H_(0x09, 0x05)
#define REG_SC_BK09_06_L      _PK_L_(0x09, 0x06)
#define REG_SC_BK09_06_H      _PK_H_(0x09, 0x06)
#define REG_SC_BK09_07_L      _PK_L_(0x09, 0x07)
#define REG_SC_BK09_07_H      _PK_H_(0x09, 0x07)
#define REG_SC_BK09_08_L      _PK_L_(0x09, 0x08)
#define REG_SC_BK09_08_H      _PK_H_(0x09, 0x08)
#define REG_SC_BK09_09_L      _PK_L_(0x09, 0x09)
#define REG_SC_BK09_09_H      _PK_H_(0x09, 0x09)
#define REG_SC_BK09_0A_L      _PK_L_(0x09, 0x0A)
#define REG_SC_BK09_0A_H      _PK_H_(0x09, 0x0A)
#define REG_SC_BK09_0B_L      _PK_L_(0x09, 0x0B)
#define REG_SC_BK09_0B_H      _PK_H_(0x09, 0x0B)
#define REG_SC_BK09_0C_L      _PK_L_(0x09, 0x0C)
#define REG_SC_BK09_0C_H      _PK_H_(0x09, 0x0C)
#define REG_SC_BK09_0D_L      _PK_L_(0x09, 0x0D)
#define REG_SC_BK09_0D_H      _PK_H_(0x09, 0x0D)
#define REG_SC_BK09_0E_L      _PK_L_(0x09, 0x0E)
#define REG_SC_BK09_0E_H      _PK_H_(0x09, 0x0E)
#define REG_SC_BK09_0F_L      _PK_L_(0x09, 0x0F)
#define REG_SC_BK09_0F_H      _PK_H_(0x09, 0x0F)
#define REG_SC_BK09_10_L      _PK_L_(0x09, 0x10)
#define REG_SC_BK09_10_H      _PK_H_(0x09, 0x10)
#define REG_SC_BK09_11_L      _PK_L_(0x09, 0x11)
#define REG_SC_BK09_11_H      _PK_H_(0x09, 0x11)
#define REG_SC_BK09_12_L      _PK_L_(0x09, 0x12)
#define REG_SC_BK09_12_H      _PK_H_(0x09, 0x12)
#define REG_SC_BK09_13_L      _PK_L_(0x09, 0x13)
#define REG_SC_BK09_13_H      _PK_H_(0x09, 0x13)
#define REG_SC_BK09_14_L      _PK_L_(0x09, 0x14)
#define REG_SC_BK09_14_H      _PK_H_(0x09, 0x14)
#define REG_SC_BK09_15_L      _PK_L_(0x09, 0x15)
#define REG_SC_BK09_15_H      _PK_H_(0x09, 0x15)
#define REG_SC_BK09_16_L      _PK_L_(0x09, 0x16)
#define REG_SC_BK09_16_H      _PK_H_(0x09, 0x16)
#define REG_SC_BK09_17_L      _PK_L_(0x09, 0x17)
#define REG_SC_BK09_17_H      _PK_H_(0x09, 0x17)
#define REG_SC_BK09_18_L      _PK_L_(0x09, 0x18)
#define REG_SC_BK09_18_H      _PK_H_(0x09, 0x18)
#define REG_SC_BK09_19_L      _PK_L_(0x09, 0x19)
#define REG_SC_BK09_19_H      _PK_H_(0x09, 0x19)
#define REG_SC_BK09_1A_L      _PK_L_(0x09, 0x1A)
#define REG_SC_BK09_1A_H      _PK_H_(0x09, 0x1A)
#define REG_SC_BK09_1B_L      _PK_L_(0x09, 0x1B)
#define REG_SC_BK09_1B_H      _PK_H_(0x09, 0x1B)
#define REG_SC_BK09_1C_L      _PK_L_(0x09, 0x1C)
#define REG_SC_BK09_1C_H      _PK_H_(0x09, 0x1C)
#define REG_SC_BK09_1D_L      _PK_L_(0x09, 0x1D)
#define REG_SC_BK09_1D_H      _PK_H_(0x09, 0x1D)
#define REG_SC_BK09_1E_L      _PK_L_(0x09, 0x1E)
#define REG_SC_BK09_1E_H      _PK_H_(0x09, 0x1E)
#define REG_SC_BK09_1F_L      _PK_L_(0x09, 0x1F)
#define REG_SC_BK09_1F_H      _PK_H_(0x09, 0x1F)
#define REG_SC_BK09_20_L      _PK_L_(0x09, 0x20)
#define REG_SC_BK09_20_H      _PK_H_(0x09, 0x20)
#define REG_SC_BK09_21_L      _PK_L_(0x09, 0x21)
#define REG_SC_BK09_21_H      _PK_H_(0x09, 0x21)
#define REG_SC_BK09_22_L      _PK_L_(0x09, 0x22)
#define REG_SC_BK09_22_H      _PK_H_(0x09, 0x22)
#define REG_SC_BK09_23_L      _PK_L_(0x09, 0x23)
#define REG_SC_BK09_23_H      _PK_H_(0x09, 0x23)
#define REG_SC_BK09_24_L      _PK_L_(0x09, 0x24)
#define REG_SC_BK09_24_H      _PK_H_(0x09, 0x24)
#define REG_SC_BK09_25_L      _PK_L_(0x09, 0x25)
#define REG_SC_BK09_25_H      _PK_H_(0x09, 0x25)
#define REG_SC_BK09_26_L      _PK_L_(0x09, 0x26)
#define REG_SC_BK09_26_H      _PK_H_(0x09, 0x26)
#define REG_SC_BK09_27_L      _PK_L_(0x09, 0x27)
#define REG_SC_BK09_27_H      _PK_H_(0x09, 0x27)
#define REG_SC_BK09_28_L      _PK_L_(0x09, 0x28)
#define REG_SC_BK09_28_H      _PK_H_(0x09, 0x28)
#define REG_SC_BK09_29_L      _PK_L_(0x09, 0x29)
#define REG_SC_BK09_29_H      _PK_H_(0x09, 0x29)
#define REG_SC_BK09_2A_L      _PK_L_(0x09, 0x2A)
#define REG_SC_BK09_2A_H      _PK_H_(0x09, 0x2A)
#define REG_SC_BK09_2B_L      _PK_L_(0x09, 0x2B)
#define REG_SC_BK09_2B_H      _PK_H_(0x09, 0x2B)
#define REG_SC_BK09_2C_L      _PK_L_(0x09, 0x2C)
#define REG_SC_BK09_2C_H      _PK_H_(0x09, 0x2C)
#define REG_SC_BK09_2D_L      _PK_L_(0x09, 0x2D)
#define REG_SC_BK09_2D_H      _PK_H_(0x09, 0x2D)
#define REG_SC_BK09_2E_L      _PK_L_(0x09, 0x2E)
#define REG_SC_BK09_2E_H      _PK_H_(0x09, 0x2E)
#define REG_SC_BK09_2F_L      _PK_L_(0x09, 0x2F)
#define REG_SC_BK09_2F_H      _PK_H_(0x09, 0x2F)
#define REG_SC_BK09_30_L      _PK_L_(0x09, 0x30)
#define REG_SC_BK09_30_H      _PK_H_(0x09, 0x30)
#define REG_SC_BK09_31_L      _PK_L_(0x09, 0x31)
#define REG_SC_BK09_31_H      _PK_H_(0x09, 0x31)
#define REG_SC_BK09_32_L      _PK_L_(0x09, 0x32)
#define REG_SC_BK09_32_H      _PK_H_(0x09, 0x32)
#define REG_SC_BK09_33_L      _PK_L_(0x09, 0x33)
#define REG_SC_BK09_33_H      _PK_H_(0x09, 0x33)
#define REG_SC_BK09_34_L      _PK_L_(0x09, 0x34)
#define REG_SC_BK09_34_H      _PK_H_(0x09, 0x34)
#define REG_SC_BK09_35_L      _PK_L_(0x09, 0x35)
#define REG_SC_BK09_35_H      _PK_H_(0x09, 0x35)
#define REG_SC_BK09_36_L      _PK_L_(0x09, 0x36)
#define REG_SC_BK09_36_H      _PK_H_(0x09, 0x36)
#define REG_SC_BK09_37_L      _PK_L_(0x09, 0x37)
#define REG_SC_BK09_37_H      _PK_H_(0x09, 0x37)
#define REG_SC_BK09_38_L      _PK_L_(0x09, 0x38)
#define REG_SC_BK09_38_H      _PK_H_(0x09, 0x38)
#define REG_SC_BK09_39_L      _PK_L_(0x09, 0x39)
#define REG_SC_BK09_39_H      _PK_H_(0x09, 0x39)
#define REG_SC_BK09_3A_L      _PK_L_(0x09, 0x3A)
#define REG_SC_BK09_3A_H      _PK_H_(0x09, 0x3A)
#define REG_SC_BK09_3B_L      _PK_L_(0x09, 0x3B)
#define REG_SC_BK09_3B_H      _PK_H_(0x09, 0x3B)
#define REG_SC_BK09_3C_L      _PK_L_(0x09, 0x3C)
#define REG_SC_BK09_3C_H      _PK_H_(0x09, 0x3C)
#define REG_SC_BK09_3D_L      _PK_L_(0x09, 0x3D)
#define REG_SC_BK09_3D_H      _PK_H_(0x09, 0x3D)
#define REG_SC_BK09_3E_L      _PK_L_(0x09, 0x3E)
#define REG_SC_BK09_3E_H      _PK_H_(0x09, 0x3E)
#define REG_SC_BK09_3F_L      _PK_L_(0x09, 0x3F)
#define REG_SC_BK09_3F_H      _PK_H_(0x09, 0x3F)
#define REG_SC_BK09_40_L      _PK_L_(0x09, 0x40)
#define REG_SC_BK09_40_H      _PK_H_(0x09, 0x40)
#define REG_SC_BK09_41_L      _PK_L_(0x09, 0x41)
#define REG_SC_BK09_41_H      _PK_H_(0x09, 0x41)
#define REG_SC_BK09_42_L      _PK_L_(0x09, 0x42)
#define REG_SC_BK09_42_H      _PK_H_(0x09, 0x42)
#define REG_SC_BK09_43_L      _PK_L_(0x09, 0x43)
#define REG_SC_BK09_43_H      _PK_H_(0x09, 0x43)
#define REG_SC_BK09_44_L      _PK_L_(0x09, 0x44)
#define REG_SC_BK09_44_H      _PK_H_(0x09, 0x44)
#define REG_SC_BK09_45_L      _PK_L_(0x09, 0x45)
#define REG_SC_BK09_45_H      _PK_H_(0x09, 0x45)
#define REG_SC_BK09_46_L      _PK_L_(0x09, 0x46)
#define REG_SC_BK09_46_H      _PK_H_(0x09, 0x46)
#define REG_SC_BK09_47_L      _PK_L_(0x09, 0x47)
#define REG_SC_BK09_47_H      _PK_H_(0x09, 0x47)
#define REG_SC_BK09_48_L      _PK_L_(0x09, 0x48)
#define REG_SC_BK09_48_H      _PK_H_(0x09, 0x48)
#define REG_SC_BK09_49_L      _PK_L_(0x09, 0x49)
#define REG_SC_BK09_49_H      _PK_H_(0x09, 0x49)
#define REG_SC_BK09_4A_L      _PK_L_(0x09, 0x4A)
#define REG_SC_BK09_4A_H      _PK_H_(0x09, 0x4A)
#define REG_SC_BK09_4B_L      _PK_L_(0x09, 0x4B)
#define REG_SC_BK09_4B_H      _PK_H_(0x09, 0x4B)
#define REG_SC_BK09_4C_L      _PK_L_(0x09, 0x4C)
#define REG_SC_BK09_4C_H      _PK_H_(0x09, 0x4C)
#define REG_SC_BK09_4D_L      _PK_L_(0x09, 0x4D)
#define REG_SC_BK09_4D_H      _PK_H_(0x09, 0x4D)
#define REG_SC_BK09_4E_L      _PK_L_(0x09, 0x4E)
#define REG_SC_BK09_4E_H      _PK_H_(0x09, 0x4E)
#define REG_SC_BK09_4F_L      _PK_L_(0x09, 0x4F)
#define REG_SC_BK09_4F_H      _PK_H_(0x09, 0x4F)
#define REG_SC_BK09_50_L      _PK_L_(0x09, 0x50)
#define REG_SC_BK09_50_H      _PK_H_(0x09, 0x50)
#define REG_SC_BK09_51_L      _PK_L_(0x09, 0x51)
#define REG_SC_BK09_51_H      _PK_H_(0x09, 0x51)
#define REG_SC_BK09_52_L      _PK_L_(0x09, 0x52)
#define REG_SC_BK09_52_H      _PK_H_(0x09, 0x52)
#define REG_SC_BK09_53_L      _PK_L_(0x09, 0x53)
#define REG_SC_BK09_53_H      _PK_H_(0x09, 0x53)
#define REG_SC_BK09_54_L      _PK_L_(0x09, 0x54)
#define REG_SC_BK09_54_H      _PK_H_(0x09, 0x54)
#define REG_SC_BK09_55_L      _PK_L_(0x09, 0x55)
#define REG_SC_BK09_55_H      _PK_H_(0x09, 0x55)
#define REG_SC_BK09_56_L      _PK_L_(0x09, 0x56)
#define REG_SC_BK09_56_H      _PK_H_(0x09, 0x56)
#define REG_SC_BK09_57_L      _PK_L_(0x09, 0x57)
#define REG_SC_BK09_57_H      _PK_H_(0x09, 0x57)
#define REG_SC_BK09_58_L      _PK_L_(0x09, 0x58)
#define REG_SC_BK09_58_H      _PK_H_(0x09, 0x58)
#define REG_SC_BK09_59_L      _PK_L_(0x09, 0x59)
#define REG_SC_BK09_59_H      _PK_H_(0x09, 0x59)
#define REG_SC_BK09_5A_L      _PK_L_(0x09, 0x5A)
#define REG_SC_BK09_5A_H      _PK_H_(0x09, 0x5A)
#define REG_SC_BK09_5B_L      _PK_L_(0x09, 0x5B)
#define REG_SC_BK09_5B_H      _PK_H_(0x09, 0x5B)
#define REG_SC_BK09_5C_L      _PK_L_(0x09, 0x5C)
#define REG_SC_BK09_5C_H      _PK_H_(0x09, 0x5C)
#define REG_SC_BK09_5D_L      _PK_L_(0x09, 0x5D)
#define REG_SC_BK09_5D_H      _PK_H_(0x09, 0x5D)
#define REG_SC_BK09_5E_L      _PK_L_(0x09, 0x5E)
#define REG_SC_BK09_5E_H      _PK_H_(0x09, 0x5E)
#define REG_SC_BK09_5F_L      _PK_L_(0x09, 0x5F)
#define REG_SC_BK09_5F_H      _PK_H_(0x09, 0x5F)
#define REG_SC_BK09_60_L      _PK_L_(0x09, 0x60)
#define REG_SC_BK09_60_H      _PK_H_(0x09, 0x60)
#define REG_SC_BK09_61_L      _PK_L_(0x09, 0x61)
#define REG_SC_BK09_61_H      _PK_H_(0x09, 0x61)
#define REG_SC_BK09_62_L      _PK_L_(0x09, 0x62)
#define REG_SC_BK09_62_H      _PK_H_(0x09, 0x62)
#define REG_SC_BK09_63_L      _PK_L_(0x09, 0x63)
#define REG_SC_BK09_63_H      _PK_H_(0x09, 0x63)
#define REG_SC_BK09_64_L      _PK_L_(0x09, 0x64)
#define REG_SC_BK09_64_H      _PK_H_(0x09, 0x64)
#define REG_SC_BK09_65_L      _PK_L_(0x09, 0x65)
#define REG_SC_BK09_65_H      _PK_H_(0x09, 0x65)
#define REG_SC_BK09_66_L      _PK_L_(0x09, 0x66)
#define REG_SC_BK09_66_H      _PK_H_(0x09, 0x66)
#define REG_SC_BK09_67_L      _PK_L_(0x09, 0x67)
#define REG_SC_BK09_67_H      _PK_H_(0x09, 0x67)
#define REG_SC_BK09_68_L      _PK_L_(0x09, 0x68)
#define REG_SC_BK09_68_H      _PK_H_(0x09, 0x68)
#define REG_SC_BK09_69_L      _PK_L_(0x09, 0x69)
#define REG_SC_BK09_69_H      _PK_H_(0x09, 0x69)
#define REG_SC_BK09_6A_L      _PK_L_(0x09, 0x6A)
#define REG_SC_BK09_6A_H      _PK_H_(0x09, 0x6A)
#define REG_SC_BK09_6B_L      _PK_L_(0x09, 0x6B)
#define REG_SC_BK09_6B_H      _PK_H_(0x09, 0x6B)
#define REG_SC_BK09_6C_L      _PK_L_(0x09, 0x6C)
#define REG_SC_BK09_6C_H      _PK_H_(0x09, 0x6C)
#define REG_SC_BK09_6D_L      _PK_L_(0x09, 0x6D)
#define REG_SC_BK09_6D_H      _PK_H_(0x09, 0x6D)
#define REG_SC_BK09_6E_L      _PK_L_(0x09, 0x6E)
#define REG_SC_BK09_6E_H      _PK_H_(0x09, 0x6E)
#define REG_SC_BK09_6F_L      _PK_L_(0x09, 0x6F)
#define REG_SC_BK09_6F_H      _PK_H_(0x09, 0x6F)
#define REG_SC_BK09_70_L      _PK_L_(0x09, 0x70)
#define REG_SC_BK09_70_H      _PK_H_(0x09, 0x70)
#define REG_SC_BK09_71_L      _PK_L_(0x09, 0x71)
#define REG_SC_BK09_71_H      _PK_H_(0x09, 0x71)
#define REG_SC_BK09_72_L      _PK_L_(0x09, 0x72)
#define REG_SC_BK09_72_H      _PK_H_(0x09, 0x72)
#define REG_SC_BK09_73_L      _PK_L_(0x09, 0x73)
#define REG_SC_BK09_73_H      _PK_H_(0x09, 0x73)
#define REG_SC_BK09_74_L      _PK_L_(0x09, 0x74)
#define REG_SC_BK09_74_H      _PK_H_(0x09, 0x74)
#define REG_SC_BK09_75_L      _PK_L_(0x09, 0x75)
#define REG_SC_BK09_75_H      _PK_H_(0x09, 0x75)
#define REG_SC_BK09_76_L      _PK_L_(0x09, 0x76)
#define REG_SC_BK09_76_H      _PK_H_(0x09, 0x76)
#define REG_SC_BK09_77_L      _PK_L_(0x09, 0x77)
#define REG_SC_BK09_77_H      _PK_H_(0x09, 0x77)
#define REG_SC_BK09_78_L      _PK_L_(0x09, 0x78)
#define REG_SC_BK09_78_H      _PK_H_(0x09, 0x78)
#define REG_SC_BK09_79_L      _PK_L_(0x09, 0x79)
#define REG_SC_BK09_79_H      _PK_H_(0x09, 0x79)
#define REG_SC_BK09_7A_L      _PK_L_(0x09, 0x7A)
#define REG_SC_BK09_7A_H      _PK_H_(0x09, 0x7A)
#define REG_SC_BK09_7B_L      _PK_L_(0x09, 0x7B)
#define REG_SC_BK09_7B_H      _PK_H_(0x09, 0x7B)
#define REG_SC_BK09_7C_L      _PK_L_(0x09, 0x7C)
#define REG_SC_BK09_7C_H      _PK_H_(0x09, 0x7C)
#define REG_SC_BK09_7D_L      _PK_L_(0x09, 0x7D)
#define REG_SC_BK09_7D_H      _PK_H_(0x09, 0x7D)
#define REG_SC_BK09_7E_L      _PK_L_(0x09, 0x7E)
#define REG_SC_BK09_7E_H      _PK_H_(0x09, 0x7E)
#define REG_SC_BK09_7F_L      _PK_L_(0x09, 0x7F)
#define REG_SC_BK09_7F_H      _PK_H_(0x09, 0x7F)

//----------------------------------------------
//  BK0A: OP1ZZ
//----------------------------------------------
#define REG_SC_BK0A_00_L      _PK_L_(0x0A, 0x00)
#define REG_SC_BK0A_00_H      _PK_H_(0x0A, 0x00)
#define REG_SC_BK0A_01_L      _PK_L_(0x0A, 0x01)
#define REG_SC_BK0A_01_H      _PK_H_(0x0A, 0x01)
#define REG_SC_BK0A_02_L      _PK_L_(0x0A, 0x02)
#define REG_SC_BK0A_02_H      _PK_H_(0x0A, 0x02)
#define REG_SC_BK0A_03_L      _PK_L_(0x0A, 0x03)
#define REG_SC_BK0A_03_H      _PK_H_(0x0A, 0x03)
#define REG_SC_BK0A_04_L      _PK_L_(0x0A, 0x04)
#define REG_SC_BK0A_04_H      _PK_H_(0x0A, 0x04)
#define REG_SC_BK0A_05_L      _PK_L_(0x0A, 0x05)
#define REG_SC_BK0A_05_H      _PK_H_(0x0A, 0x05)
#define REG_SC_BK0A_06_L      _PK_L_(0x0A, 0x06)
#define REG_SC_BK0A_06_H      _PK_H_(0x0A, 0x06)
#define REG_SC_BK0A_07_L      _PK_L_(0x0A, 0x07)
#define REG_SC_BK0A_07_H      _PK_H_(0x0A, 0x07)
#define REG_SC_BK0A_08_L      _PK_L_(0x0A, 0x08)
#define REG_SC_BK0A_08_H      _PK_H_(0x0A, 0x08)
#define REG_SC_BK0A_09_L      _PK_L_(0x0A, 0x09)
#define REG_SC_BK0A_09_H      _PK_H_(0x0A, 0x09)
#define REG_SC_BK0A_0A_L      _PK_L_(0x0A, 0x0A)
#define REG_SC_BK0A_0A_H      _PK_H_(0x0A, 0x0A)
#define REG_SC_BK0A_0B_L      _PK_L_(0x0A, 0x0B)
#define REG_SC_BK0A_0B_H      _PK_H_(0x0A, 0x0B)
#define REG_SC_BK0A_0C_L      _PK_L_(0x0A, 0x0C)
#define REG_SC_BK0A_0C_H      _PK_H_(0x0A, 0x0C)
#define REG_SC_BK0A_0D_L      _PK_L_(0x0A, 0x0D)
#define REG_SC_BK0A_0D_H      _PK_H_(0x0A, 0x0D)
#define REG_SC_BK0A_0E_L      _PK_L_(0x0A, 0x0E)
#define REG_SC_BK0A_0E_H      _PK_H_(0x0A, 0x0E)
#define REG_SC_BK0A_0F_L      _PK_L_(0x0A, 0x0F)
#define REG_SC_BK0A_0F_H      _PK_H_(0x0A, 0x0F)
#define REG_SC_BK0A_10_L      _PK_L_(0x0A, 0x10)
#define REG_SC_BK0A_10_H      _PK_H_(0x0A, 0x10)
#define REG_SC_BK0A_11_L      _PK_L_(0x0A, 0x11)
#define REG_SC_BK0A_11_H      _PK_H_(0x0A, 0x11)
#define REG_SC_BK0A_12_L      _PK_L_(0x0A, 0x12)
#define REG_SC_BK0A_12_H      _PK_H_(0x0A, 0x12)
#define REG_SC_BK0A_13_L      _PK_L_(0x0A, 0x13)
#define REG_SC_BK0A_13_H      _PK_H_(0x0A, 0x13)
#define REG_SC_BK0A_14_L      _PK_L_(0x0A, 0x14)
#define REG_SC_BK0A_14_H      _PK_H_(0x0A, 0x14)
#define REG_SC_BK0A_15_L      _PK_L_(0x0A, 0x15)
#define REG_SC_BK0A_15_H      _PK_H_(0x0A, 0x15)
#define REG_SC_BK0A_16_L      _PK_L_(0x0A, 0x16)
#define REG_SC_BK0A_16_H      _PK_H_(0x0A, 0x16)
#define REG_SC_BK0A_17_L      _PK_L_(0x0A, 0x17)
#define REG_SC_BK0A_17_H      _PK_H_(0x0A, 0x17)
#define REG_SC_BK0A_18_L      _PK_L_(0x0A, 0x18)
#define REG_SC_BK0A_18_H      _PK_H_(0x0A, 0x18)
#define REG_SC_BK0A_19_L      _PK_L_(0x0A, 0x19)
#define REG_SC_BK0A_19_H      _PK_H_(0x0A, 0x19)
#define REG_SC_BK0A_1A_L      _PK_L_(0x0A, 0x1A)
#define REG_SC_BK0A_1A_H      _PK_H_(0x0A, 0x1A)
#define REG_SC_BK0A_1B_L      _PK_L_(0x0A, 0x1B)
#define REG_SC_BK0A_1B_H      _PK_H_(0x0A, 0x1B)
#define REG_SC_BK0A_1C_L      _PK_L_(0x0A, 0x1C)
#define REG_SC_BK0A_1C_H      _PK_H_(0x0A, 0x1C)
#define REG_SC_BK0A_1D_L      _PK_L_(0x0A, 0x1D)
#define REG_SC_BK0A_1D_H      _PK_H_(0x0A, 0x1D)
#define REG_SC_BK0A_1E_L      _PK_L_(0x0A, 0x1E)
#define REG_SC_BK0A_1E_H      _PK_H_(0x0A, 0x1E)
#define REG_SC_BK0A_1F_L      _PK_L_(0x0A, 0x1F)
#define REG_SC_BK0A_1F_H      _PK_H_(0x0A, 0x1F)
#define REG_SC_BK0A_20_L      _PK_L_(0x0A, 0x20)
#define REG_SC_BK0A_20_H      _PK_H_(0x0A, 0x20)
#define REG_SC_BK0A_21_L      _PK_L_(0x0A, 0x21)
#define REG_SC_BK0A_21_H      _PK_H_(0x0A, 0x21)
#define REG_SC_BK0A_22_L      _PK_L_(0x0A, 0x22)
#define REG_SC_BK0A_22_H      _PK_H_(0x0A, 0x22)
#define REG_SC_BK0A_23_L      _PK_L_(0x0A, 0x23)
#define REG_SC_BK0A_23_H      _PK_H_(0x0A, 0x23)
#define REG_SC_BK0A_24_L      _PK_L_(0x0A, 0x24)
#define REG_SC_BK0A_24_H      _PK_H_(0x0A, 0x24)
#define REG_SC_BK0A_25_L      _PK_L_(0x0A, 0x25)
#define REG_SC_BK0A_25_H      _PK_H_(0x0A, 0x25)
#define REG_SC_BK0A_26_L      _PK_L_(0x0A, 0x26)
#define REG_SC_BK0A_26_H      _PK_H_(0x0A, 0x26)
#define REG_SC_BK0A_27_L      _PK_L_(0x0A, 0x27)
#define REG_SC_BK0A_27_H      _PK_H_(0x0A, 0x27)
#define REG_SC_BK0A_28_L      _PK_L_(0x0A, 0x28)
#define REG_SC_BK0A_28_H      _PK_H_(0x0A, 0x28)
#define REG_SC_BK0A_29_L      _PK_L_(0x0A, 0x29)
#define REG_SC_BK0A_29_H      _PK_H_(0x0A, 0x29)
#define REG_SC_BK0A_2A_L      _PK_L_(0x0A, 0x2A)
#define REG_SC_BK0A_2A_H      _PK_H_(0x0A, 0x2A)
#define REG_SC_BK0A_2B_L      _PK_L_(0x0A, 0x2B)
#define REG_SC_BK0A_2B_H      _PK_H_(0x0A, 0x2B)
#define REG_SC_BK0A_2C_L      _PK_L_(0x0A, 0x2C)
#define REG_SC_BK0A_2C_H      _PK_H_(0x0A, 0x2C)
#define REG_SC_BK0A_2D_L      _PK_L_(0x0A, 0x2D)
#define REG_SC_BK0A_2D_H      _PK_H_(0x0A, 0x2D)
#define REG_SC_BK0A_2E_L      _PK_L_(0x0A, 0x2E)
#define REG_SC_BK0A_2E_H      _PK_H_(0x0A, 0x2E)
#define REG_SC_BK0A_2F_L      _PK_L_(0x0A, 0x2F)
#define REG_SC_BK0A_2F_H      _PK_H_(0x0A, 0x2F)
#define REG_SC_BK0A_30_L      _PK_L_(0x0A, 0x30)
#define REG_SC_BK0A_30_H      _PK_H_(0x0A, 0x30)
#define REG_SC_BK0A_31_L      _PK_L_(0x0A, 0x31)
#define REG_SC_BK0A_31_H      _PK_H_(0x0A, 0x31)
#define REG_SC_BK0A_32_L      _PK_L_(0x0A, 0x32)
#define REG_SC_BK0A_32_H      _PK_H_(0x0A, 0x32)
#define REG_SC_BK0A_33_L      _PK_L_(0x0A, 0x33)
#define REG_SC_BK0A_33_H      _PK_H_(0x0A, 0x33)
#define REG_SC_BK0A_34_L      _PK_L_(0x0A, 0x34)
#define REG_SC_BK0A_34_H      _PK_H_(0x0A, 0x34)
#define REG_SC_BK0A_35_L      _PK_L_(0x0A, 0x35)
#define REG_SC_BK0A_35_H      _PK_H_(0x0A, 0x35)
#define REG_SC_BK0A_36_L      _PK_L_(0x0A, 0x36)
#define REG_SC_BK0A_36_H      _PK_H_(0x0A, 0x36)
#define REG_SC_BK0A_37_L      _PK_L_(0x0A, 0x37)
#define REG_SC_BK0A_37_H      _PK_H_(0x0A, 0x37)
#define REG_SC_BK0A_38_L      _PK_L_(0x0A, 0x38)
#define REG_SC_BK0A_38_H      _PK_H_(0x0A, 0x38)
#define REG_SC_BK0A_39_L      _PK_L_(0x0A, 0x39)
#define REG_SC_BK0A_39_H      _PK_H_(0x0A, 0x39)
#define REG_SC_BK0A_3A_L      _PK_L_(0x0A, 0x3A)
#define REG_SC_BK0A_3A_H      _PK_H_(0x0A, 0x3A)
#define REG_SC_BK0A_3B_L      _PK_L_(0x0A, 0x3B)
#define REG_SC_BK0A_3B_H      _PK_H_(0x0A, 0x3B)
#define REG_SC_BK0A_3C_L      _PK_L_(0x0A, 0x3C)
#define REG_SC_BK0A_3C_H      _PK_H_(0x0A, 0x3C)
#define REG_SC_BK0A_3D_L      _PK_L_(0x0A, 0x3D)
#define REG_SC_BK0A_3D_H      _PK_H_(0x0A, 0x3D)
#define REG_SC_BK0A_3E_L      _PK_L_(0x0A, 0x3E)
#define REG_SC_BK0A_3E_H      _PK_H_(0x0A, 0x3E)
#define REG_SC_BK0A_3F_L      _PK_L_(0x0A, 0x3F)
#define REG_SC_BK0A_3F_H      _PK_H_(0x0A, 0x3F)
#define REG_SC_BK0A_40_L      _PK_L_(0x0A, 0x40)
#define REG_SC_BK0A_40_H      _PK_H_(0x0A, 0x40)
#define REG_SC_BK0A_41_L      _PK_L_(0x0A, 0x41)
#define REG_SC_BK0A_41_H      _PK_H_(0x0A, 0x41)
#define REG_SC_BK0A_42_L      _PK_L_(0x0A, 0x42)
#define REG_SC_BK0A_42_H      _PK_H_(0x0A, 0x42)
#define REG_SC_BK0A_43_L      _PK_L_(0x0A, 0x43)
#define REG_SC_BK0A_43_H      _PK_H_(0x0A, 0x43)
#define REG_SC_BK0A_44_L      _PK_L_(0x0A, 0x44)
#define REG_SC_BK0A_44_H      _PK_H_(0x0A, 0x44)
#define REG_SC_BK0A_45_L      _PK_L_(0x0A, 0x45)
#define REG_SC_BK0A_45_H      _PK_H_(0x0A, 0x45)
#define REG_SC_BK0A_46_L      _PK_L_(0x0A, 0x46)
#define REG_SC_BK0A_46_H      _PK_H_(0x0A, 0x46)
#define REG_SC_BK0A_47_L      _PK_L_(0x0A, 0x47)
#define REG_SC_BK0A_47_H      _PK_H_(0x0A, 0x47)
#define REG_SC_BK0A_48_L      _PK_L_(0x0A, 0x48)
#define REG_SC_BK0A_48_H      _PK_H_(0x0A, 0x48)
#define REG_SC_BK0A_49_L      _PK_L_(0x0A, 0x49)
#define REG_SC_BK0A_49_H      _PK_H_(0x0A, 0x49)
#define REG_SC_BK0A_4A_L      _PK_L_(0x0A, 0x4A)
#define REG_SC_BK0A_4A_H      _PK_H_(0x0A, 0x4A)
#define REG_SC_BK0A_4B_L      _PK_L_(0x0A, 0x4B)
#define REG_SC_BK0A_4B_H      _PK_H_(0x0A, 0x4B)
#define REG_SC_BK0A_4C_L      _PK_L_(0x0A, 0x4C)
#define REG_SC_BK0A_4C_H      _PK_H_(0x0A, 0x4C)
#define REG_SC_BK0A_4D_L      _PK_L_(0x0A, 0x4D)
#define REG_SC_BK0A_4D_H      _PK_H_(0x0A, 0x4D)
#define REG_SC_BK0A_4E_L      _PK_L_(0x0A, 0x4E)
#define REG_SC_BK0A_4E_H      _PK_H_(0x0A, 0x4E)
#define REG_SC_BK0A_4F_L      _PK_L_(0x0A, 0x4F)
#define REG_SC_BK0A_4F_H      _PK_H_(0x0A, 0x4F)
#define REG_SC_BK0A_50_L      _PK_L_(0x0A, 0x50)
#define REG_SC_BK0A_50_H      _PK_H_(0x0A, 0x50)
#define REG_SC_BK0A_51_L      _PK_L_(0x0A, 0x51)
#define REG_SC_BK0A_51_H      _PK_H_(0x0A, 0x51)
#define REG_SC_BK0A_52_L      _PK_L_(0x0A, 0x52)
#define REG_SC_BK0A_52_H      _PK_H_(0x0A, 0x52)
#define REG_SC_BK0A_53_L      _PK_L_(0x0A, 0x53)
#define REG_SC_BK0A_53_H      _PK_H_(0x0A, 0x53)
#define REG_SC_BK0A_54_L      _PK_L_(0x0A, 0x54)
#define REG_SC_BK0A_54_H      _PK_H_(0x0A, 0x54)
#define REG_SC_BK0A_55_L      _PK_L_(0x0A, 0x55)
#define REG_SC_BK0A_55_H      _PK_H_(0x0A, 0x55)
#define REG_SC_BK0A_56_L      _PK_L_(0x0A, 0x56)
#define REG_SC_BK0A_56_H      _PK_H_(0x0A, 0x56)
#define REG_SC_BK0A_57_L      _PK_L_(0x0A, 0x57)
#define REG_SC_BK0A_57_H      _PK_H_(0x0A, 0x57)
#define REG_SC_BK0A_58_L      _PK_L_(0x0A, 0x58)
#define REG_SC_BK0A_58_H      _PK_H_(0x0A, 0x58)
#define REG_SC_BK0A_59_L      _PK_L_(0x0A, 0x59)
#define REG_SC_BK0A_59_H      _PK_H_(0x0A, 0x59)
#define REG_SC_BK0A_5A_L      _PK_L_(0x0A, 0x5A)
#define REG_SC_BK0A_5A_H      _PK_H_(0x0A, 0x5A)
#define REG_SC_BK0A_5B_L      _PK_L_(0x0A, 0x5B)
#define REG_SC_BK0A_5B_H      _PK_H_(0x0A, 0x5B)
#define REG_SC_BK0A_5C_L      _PK_L_(0x0A, 0x5C)
#define REG_SC_BK0A_5C_H      _PK_H_(0x0A, 0x5C)
#define REG_SC_BK0A_5D_L      _PK_L_(0x0A, 0x5D)
#define REG_SC_BK0A_5D_H      _PK_H_(0x0A, 0x5D)
#define REG_SC_BK0A_5E_L      _PK_L_(0x0A, 0x5E)
#define REG_SC_BK0A_5E_H      _PK_H_(0x0A, 0x5E)
#define REG_SC_BK0A_5F_L      _PK_L_(0x0A, 0x5F)
#define REG_SC_BK0A_5F_H      _PK_H_(0x0A, 0x5F)
#define REG_SC_BK0A_60_L      _PK_L_(0x0A, 0x60)
#define REG_SC_BK0A_60_H      _PK_H_(0x0A, 0x60)
#define REG_SC_BK0A_61_L      _PK_L_(0x0A, 0x61)
#define REG_SC_BK0A_61_H      _PK_H_(0x0A, 0x61)
#define REG_SC_BK0A_62_L      _PK_L_(0x0A, 0x62)
#define REG_SC_BK0A_62_H      _PK_H_(0x0A, 0x62)
#define REG_SC_BK0A_63_L      _PK_L_(0x0A, 0x63)
#define REG_SC_BK0A_63_H      _PK_H_(0x0A, 0x63)
#define REG_SC_BK0A_64_L      _PK_L_(0x0A, 0x64)
#define REG_SC_BK0A_64_H      _PK_H_(0x0A, 0x64)
#define REG_SC_BK0A_65_L      _PK_L_(0x0A, 0x65)
#define REG_SC_BK0A_65_H      _PK_H_(0x0A, 0x65)
#define REG_SC_BK0A_66_L      _PK_L_(0x0A, 0x66)
#define REG_SC_BK0A_66_H      _PK_H_(0x0A, 0x66)
#define REG_SC_BK0A_67_L      _PK_L_(0x0A, 0x67)
#define REG_SC_BK0A_67_H      _PK_H_(0x0A, 0x67)
#define REG_SC_BK0A_68_L      _PK_L_(0x0A, 0x68)
#define REG_SC_BK0A_68_H      _PK_H_(0x0A, 0x68)
#define REG_SC_BK0A_69_L      _PK_L_(0x0A, 0x69)
#define REG_SC_BK0A_69_H      _PK_H_(0x0A, 0x69)
#define REG_SC_BK0A_6A_L      _PK_L_(0x0A, 0x6A)
#define REG_SC_BK0A_6A_H      _PK_H_(0x0A, 0x6A)
#define REG_SC_BK0A_6B_L      _PK_L_(0x0A, 0x6B)
#define REG_SC_BK0A_6B_H      _PK_H_(0x0A, 0x6B)
#define REG_SC_BK0A_6C_L      _PK_L_(0x0A, 0x6C)
#define REG_SC_BK0A_6C_H      _PK_H_(0x0A, 0x6C)
#define REG_SC_BK0A_6D_L      _PK_L_(0x0A, 0x6D)
#define REG_SC_BK0A_6D_H      _PK_H_(0x0A, 0x6D)
#define REG_SC_BK0A_6E_L      _PK_L_(0x0A, 0x6E)
#define REG_SC_BK0A_6E_H      _PK_H_(0x0A, 0x6E)
#define REG_SC_BK0A_6F_L      _PK_L_(0x0A, 0x6F)
#define REG_SC_BK0A_6F_H      _PK_H_(0x0A, 0x6F)
#define REG_SC_BK0A_70_L      _PK_L_(0x0A, 0x70)
#define REG_SC_BK0A_70_H      _PK_H_(0x0A, 0x70)
#define REG_SC_BK0A_71_L      _PK_L_(0x0A, 0x71)
#define REG_SC_BK0A_71_H      _PK_H_(0x0A, 0x71)
#define REG_SC_BK0A_72_L      _PK_L_(0x0A, 0x72)
#define REG_SC_BK0A_72_H      _PK_H_(0x0A, 0x72)
#define REG_SC_BK0A_73_L      _PK_L_(0x0A, 0x73)
#define REG_SC_BK0A_73_H      _PK_H_(0x0A, 0x73)
#define REG_SC_BK0A_74_L      _PK_L_(0x0A, 0x74)
#define REG_SC_BK0A_74_H      _PK_H_(0x0A, 0x74)
#define REG_SC_BK0A_75_L      _PK_L_(0x0A, 0x75)
#define REG_SC_BK0A_75_H      _PK_H_(0x0A, 0x75)
#define REG_SC_BK0A_76_L      _PK_L_(0x0A, 0x76)
#define REG_SC_BK0A_76_H      _PK_H_(0x0A, 0x76)
#define REG_SC_BK0A_77_L      _PK_L_(0x0A, 0x77)
#define REG_SC_BK0A_77_H      _PK_H_(0x0A, 0x77)
#define REG_SC_BK0A_78_L      _PK_L_(0x0A, 0x78)
#define REG_SC_BK0A_78_H      _PK_H_(0x0A, 0x78)
#define REG_SC_BK0A_79_L      _PK_L_(0x0A, 0x79)
#define REG_SC_BK0A_79_H      _PK_H_(0x0A, 0x79)
#define REG_SC_BK0A_7A_L      _PK_L_(0x0A, 0x7A)
#define REG_SC_BK0A_7A_H      _PK_H_(0x0A, 0x7A)
#define REG_SC_BK0A_7B_L      _PK_L_(0x0A, 0x7B)
#define REG_SC_BK0A_7B_H      _PK_H_(0x0A, 0x7B)
#define REG_SC_BK0A_7C_L      _PK_L_(0x0A, 0x7C)
#define REG_SC_BK0A_7C_H      _PK_H_(0x0A, 0x7C)
#define REG_SC_BK0A_7D_L      _PK_L_(0x0A, 0x7D)
#define REG_SC_BK0A_7D_H      _PK_H_(0x0A, 0x7D)
#define REG_SC_BK0A_7E_L      _PK_L_(0x0A, 0x7E)
#define REG_SC_BK0A_7E_H      _PK_H_(0x0A, 0x7E)
#define REG_SC_BK0A_7F_L      _PK_L_(0x0A, 0x7F)
#define REG_SC_BK0A_7F_H      _PK_H_(0x0A, 0x7F)


//----------------------------------------------
//  BK0B: ELA
//----------------------------------------------
#define REG_SC_BK0B_00_L      _PK_L_(0x0B, 0x00)
#define REG_SC_BK0B_00_H      _PK_H_(0x0B, 0x00)
#define REG_SC_BK0B_01_L      _PK_L_(0x0B, 0x01)
#define REG_SC_BK0B_01_H      _PK_H_(0x0B, 0x01)
#define REG_SC_BK0B_02_L      _PK_L_(0x0B, 0x02)
#define REG_SC_BK0B_02_H      _PK_H_(0x0B, 0x02)
#define REG_SC_BK0B_03_L      _PK_L_(0x0B, 0x03)
#define REG_SC_BK0B_03_H      _PK_H_(0x0B, 0x03)
#define REG_SC_BK0B_04_L      _PK_L_(0x0B, 0x04)
#define REG_SC_BK0B_04_H      _PK_H_(0x0B, 0x04)
#define REG_SC_BK0B_05_L      _PK_L_(0x0B, 0x05)
#define REG_SC_BK0B_05_H      _PK_H_(0x0B, 0x05)
#define REG_SC_BK0B_06_L      _PK_L_(0x0B, 0x06)
#define REG_SC_BK0B_06_H      _PK_H_(0x0B, 0x06)
#define REG_SC_BK0B_07_L      _PK_L_(0x0B, 0x07)
#define REG_SC_BK0B_07_H      _PK_H_(0x0B, 0x07)
#define REG_SC_BK0B_08_L      _PK_L_(0x0B, 0x08)
#define REG_SC_BK0B_08_H      _PK_H_(0x0B, 0x08)
#define REG_SC_BK0B_09_L      _PK_L_(0x0B, 0x09)
#define REG_SC_BK0B_09_H      _PK_H_(0x0B, 0x09)
#define REG_SC_BK0B_0A_L      _PK_L_(0x0B, 0x0A)
#define REG_SC_BK0B_0A_H      _PK_H_(0x0B, 0x0A)
#define REG_SC_BK0B_0B_L      _PK_L_(0x0B, 0x0B)
#define REG_SC_BK0B_0B_H      _PK_H_(0x0B, 0x0B)
#define REG_SC_BK0B_0C_L      _PK_L_(0x0B, 0x0C)
#define REG_SC_BK0B_0C_H      _PK_H_(0x0B, 0x0C)
#define REG_SC_BK0B_0D_L      _PK_L_(0x0B, 0x0D)
#define REG_SC_BK0B_0D_H      _PK_H_(0x0B, 0x0D)
#define REG_SC_BK0B_0E_L      _PK_L_(0x0B, 0x0E)
#define REG_SC_BK0B_0E_H      _PK_H_(0x0B, 0x0E)
#define REG_SC_BK0B_0F_L      _PK_L_(0x0B, 0x0F)
#define REG_SC_BK0B_0F_H      _PK_H_(0x0B, 0x0F)
#define REG_SC_BK0B_10_L      _PK_L_(0x0B, 0x10)
#define REG_SC_BK0B_10_H      _PK_H_(0x0B, 0x10)
#define REG_SC_BK0B_11_L      _PK_L_(0x0B, 0x11)
#define REG_SC_BK0B_11_H      _PK_H_(0x0B, 0x11)
#define REG_SC_BK0B_12_L      _PK_L_(0x0B, 0x12)
#define REG_SC_BK0B_12_H      _PK_H_(0x0B, 0x12)
#define REG_SC_BK0B_13_L      _PK_L_(0x0B, 0x13)
#define REG_SC_BK0B_13_H      _PK_H_(0x0B, 0x13)
#define REG_SC_BK0B_14_L      _PK_L_(0x0B, 0x14)
#define REG_SC_BK0B_14_H      _PK_H_(0x0B, 0x14)
#define REG_SC_BK0B_15_L      _PK_L_(0x0B, 0x15)
#define REG_SC_BK0B_15_H      _PK_H_(0x0B, 0x15)
#define REG_SC_BK0B_16_L      _PK_L_(0x0B, 0x16)
#define REG_SC_BK0B_16_H      _PK_H_(0x0B, 0x16)
#define REG_SC_BK0B_17_L      _PK_L_(0x0B, 0x17)
#define REG_SC_BK0B_17_H      _PK_H_(0x0B, 0x17)
#define REG_SC_BK0B_18_L      _PK_L_(0x0B, 0x18)
#define REG_SC_BK0B_18_H      _PK_H_(0x0B, 0x18)
#define REG_SC_BK0B_19_L      _PK_L_(0x0B, 0x19)
#define REG_SC_BK0B_19_H      _PK_H_(0x0B, 0x19)
#define REG_SC_BK0B_1A_L      _PK_L_(0x0B, 0x1A)
#define REG_SC_BK0B_1A_H      _PK_H_(0x0B, 0x1A)
#define REG_SC_BK0B_1B_L      _PK_L_(0x0B, 0x1B)
#define REG_SC_BK0B_1B_H      _PK_H_(0x0B, 0x1B)
#define REG_SC_BK0B_1C_L      _PK_L_(0x0B, 0x1C)
#define REG_SC_BK0B_1C_H      _PK_H_(0x0B, 0x1C)
#define REG_SC_BK0B_1D_L      _PK_L_(0x0B, 0x1D)
#define REG_SC_BK0B_1D_H      _PK_H_(0x0B, 0x1D)
#define REG_SC_BK0B_1E_L      _PK_L_(0x0B, 0x1E)
#define REG_SC_BK0B_1E_H      _PK_H_(0x0B, 0x1E)
#define REG_SC_BK0B_1F_L      _PK_L_(0x0B, 0x1F)
#define REG_SC_BK0B_1F_H      _PK_H_(0x0B, 0x1F)
#define REG_SC_BK0B_20_L      _PK_L_(0x0B, 0x20)
#define REG_SC_BK0B_20_H      _PK_H_(0x0B, 0x20)
#define REG_SC_BK0B_21_L      _PK_L_(0x0B, 0x21)
#define REG_SC_BK0B_21_H      _PK_H_(0x0B, 0x21)
#define REG_SC_BK0B_22_L      _PK_L_(0x0B, 0x22)
#define REG_SC_BK0B_22_H      _PK_H_(0x0B, 0x22)
#define REG_SC_BK0B_23_L      _PK_L_(0x0B, 0x23)
#define REG_SC_BK0B_23_H      _PK_H_(0x0B, 0x23)
#define REG_SC_BK0B_24_L      _PK_L_(0x0B, 0x24)
#define REG_SC_BK0B_24_H      _PK_H_(0x0B, 0x24)
#define REG_SC_BK0B_25_L      _PK_L_(0x0B, 0x25)
#define REG_SC_BK0B_25_H      _PK_H_(0x0B, 0x25)
#define REG_SC_BK0B_26_L      _PK_L_(0x0B, 0x26)
#define REG_SC_BK0B_26_H      _PK_H_(0x0B, 0x26)
#define REG_SC_BK0B_27_L      _PK_L_(0x0B, 0x27)
#define REG_SC_BK0B_27_H      _PK_H_(0x0B, 0x27)
#define REG_SC_BK0B_28_L      _PK_L_(0x0B, 0x28)
#define REG_SC_BK0B_28_H      _PK_H_(0x0B, 0x28)
#define REG_SC_BK0B_29_L      _PK_L_(0x0B, 0x29)
#define REG_SC_BK0B_29_H      _PK_H_(0x0B, 0x29)
#define REG_SC_BK0B_2A_L      _PK_L_(0x0B, 0x2A)
#define REG_SC_BK0B_2A_H      _PK_H_(0x0B, 0x2A)
#define REG_SC_BK0B_2B_L      _PK_L_(0x0B, 0x2B)
#define REG_SC_BK0B_2B_H      _PK_H_(0x0B, 0x2B)
#define REG_SC_BK0B_2C_L      _PK_L_(0x0B, 0x2C)
#define REG_SC_BK0B_2C_H      _PK_H_(0x0B, 0x2C)
#define REG_SC_BK0B_2D_L      _PK_L_(0x0B, 0x2D)
#define REG_SC_BK0B_2D_H      _PK_H_(0x0B, 0x2D)
#define REG_SC_BK0B_2E_L      _PK_L_(0x0B, 0x2E)
#define REG_SC_BK0B_2E_H      _PK_H_(0x0B, 0x2E)
#define REG_SC_BK0B_2F_L      _PK_L_(0x0B, 0x2F)
#define REG_SC_BK0B_2F_H      _PK_H_(0x0B, 0x2F)
#define REG_SC_BK0B_30_L      _PK_L_(0x0B, 0x30)
#define REG_SC_BK0B_30_H      _PK_H_(0x0B, 0x30)
#define REG_SC_BK0B_31_L      _PK_L_(0x0B, 0x31)
#define REG_SC_BK0B_31_H      _PK_H_(0x0B, 0x31)
#define REG_SC_BK0B_32_L      _PK_L_(0x0B, 0x32)
#define REG_SC_BK0B_32_H      _PK_H_(0x0B, 0x32)
#define REG_SC_BK0B_33_L      _PK_L_(0x0B, 0x33)
#define REG_SC_BK0B_33_H      _PK_H_(0x0B, 0x33)
#define REG_SC_BK0B_34_L      _PK_L_(0x0B, 0x34)
#define REG_SC_BK0B_34_H      _PK_H_(0x0B, 0x34)
#define REG_SC_BK0B_35_L      _PK_L_(0x0B, 0x35)
#define REG_SC_BK0B_35_H      _PK_H_(0x0B, 0x35)
#define REG_SC_BK0B_36_L      _PK_L_(0x0B, 0x36)
#define REG_SC_BK0B_36_H      _PK_H_(0x0B, 0x36)
#define REG_SC_BK0B_37_L      _PK_L_(0x0B, 0x37)
#define REG_SC_BK0B_37_H      _PK_H_(0x0B, 0x37)
#define REG_SC_BK0B_38_L      _PK_L_(0x0B, 0x38)
#define REG_SC_BK0B_38_H      _PK_H_(0x0B, 0x38)
#define REG_SC_BK0B_39_L      _PK_L_(0x0B, 0x39)
#define REG_SC_BK0B_39_H      _PK_H_(0x0B, 0x39)
#define REG_SC_BK0B_3A_L      _PK_L_(0x0B, 0x3A)
#define REG_SC_BK0B_3A_H      _PK_H_(0x0B, 0x3A)
#define REG_SC_BK0B_3B_L      _PK_L_(0x0B, 0x3B)
#define REG_SC_BK0B_3B_H      _PK_H_(0x0B, 0x3B)
#define REG_SC_BK0B_3C_L      _PK_L_(0x0B, 0x3C)
#define REG_SC_BK0B_3C_H      _PK_H_(0x0B, 0x3C)
#define REG_SC_BK0B_3D_L      _PK_L_(0x0B, 0x3D)
#define REG_SC_BK0B_3D_H      _PK_H_(0x0B, 0x3D)
#define REG_SC_BK0B_3E_L      _PK_L_(0x0B, 0x3E)
#define REG_SC_BK0B_3E_H      _PK_H_(0x0B, 0x3E)
#define REG_SC_BK0B_3F_L      _PK_L_(0x0B, 0x3F)
#define REG_SC_BK0B_3F_H      _PK_H_(0x0B, 0x3F)
#define REG_SC_BK0B_40_L      _PK_L_(0x0B, 0x40)
#define REG_SC_BK0B_40_H      _PK_H_(0x0B, 0x40)
#define REG_SC_BK0B_41_L      _PK_L_(0x0B, 0x41)
#define REG_SC_BK0B_41_H      _PK_H_(0x0B, 0x41)
#define REG_SC_BK0B_42_L      _PK_L_(0x0B, 0x42)
#define REG_SC_BK0B_42_H      _PK_H_(0x0B, 0x42)
#define REG_SC_BK0B_43_L      _PK_L_(0x0B, 0x43)
#define REG_SC_BK0B_43_H      _PK_H_(0x0B, 0x43)
#define REG_SC_BK0B_44_L      _PK_L_(0x0B, 0x44)
#define REG_SC_BK0B_44_H      _PK_H_(0x0B, 0x44)
#define REG_SC_BK0B_45_L      _PK_L_(0x0B, 0x45)
#define REG_SC_BK0B_45_H      _PK_H_(0x0B, 0x45)
#define REG_SC_BK0B_46_L      _PK_L_(0x0B, 0x46)
#define REG_SC_BK0B_46_H      _PK_H_(0x0B, 0x46)
#define REG_SC_BK0B_47_L      _PK_L_(0x0B, 0x47)
#define REG_SC_BK0B_47_H      _PK_H_(0x0B, 0x47)
#define REG_SC_BK0B_48_L      _PK_L_(0x0B, 0x48)
#define REG_SC_BK0B_48_H      _PK_H_(0x0B, 0x48)
#define REG_SC_BK0B_49_L      _PK_L_(0x0B, 0x49)
#define REG_SC_BK0B_49_H      _PK_H_(0x0B, 0x49)
#define REG_SC_BK0B_4A_L      _PK_L_(0x0B, 0x4A)
#define REG_SC_BK0B_4A_H      _PK_H_(0x0B, 0x4A)
#define REG_SC_BK0B_4B_L      _PK_L_(0x0B, 0x4B)
#define REG_SC_BK0B_4B_H      _PK_H_(0x0B, 0x4B)
#define REG_SC_BK0B_4C_L      _PK_L_(0x0B, 0x4C)
#define REG_SC_BK0B_4C_H      _PK_H_(0x0B, 0x4C)
#define REG_SC_BK0B_4D_L      _PK_L_(0x0B, 0x4D)
#define REG_SC_BK0B_4D_H      _PK_H_(0x0B, 0x4D)
#define REG_SC_BK0B_4E_L      _PK_L_(0x0B, 0x4E)
#define REG_SC_BK0B_4E_H      _PK_H_(0x0B, 0x4E)
#define REG_SC_BK0B_4F_L      _PK_L_(0x0B, 0x4F)
#define REG_SC_BK0B_4F_H      _PK_H_(0x0B, 0x4F)
#define REG_SC_BK0B_50_L      _PK_L_(0x0B, 0x50)
#define REG_SC_BK0B_50_H      _PK_H_(0x0B, 0x50)
#define REG_SC_BK0B_51_L      _PK_L_(0x0B, 0x51)
#define REG_SC_BK0B_51_H      _PK_H_(0x0B, 0x51)
#define REG_SC_BK0B_52_L      _PK_L_(0x0B, 0x52)
#define REG_SC_BK0B_52_H      _PK_H_(0x0B, 0x52)
#define REG_SC_BK0B_53_L      _PK_L_(0x0B, 0x53)
#define REG_SC_BK0B_53_H      _PK_H_(0x0B, 0x53)
#define REG_SC_BK0B_54_L      _PK_L_(0x0B, 0x54)
#define REG_SC_BK0B_54_H      _PK_H_(0x0B, 0x54)
#define REG_SC_BK0B_55_L      _PK_L_(0x0B, 0x55)
#define REG_SC_BK0B_55_H      _PK_H_(0x0B, 0x55)
#define REG_SC_BK0B_56_L      _PK_L_(0x0B, 0x56)
#define REG_SC_BK0B_56_H      _PK_H_(0x0B, 0x56)
#define REG_SC_BK0B_57_L      _PK_L_(0x0B, 0x57)
#define REG_SC_BK0B_57_H      _PK_H_(0x0B, 0x57)
#define REG_SC_BK0B_58_L      _PK_L_(0x0B, 0x58)
#define REG_SC_BK0B_58_H      _PK_H_(0x0B, 0x58)
#define REG_SC_BK0B_59_L      _PK_L_(0x0B, 0x59)
#define REG_SC_BK0B_59_H      _PK_H_(0x0B, 0x59)
#define REG_SC_BK0B_5A_L      _PK_L_(0x0B, 0x5A)
#define REG_SC_BK0B_5A_H      _PK_H_(0x0B, 0x5A)
#define REG_SC_BK0B_5B_L      _PK_L_(0x0B, 0x5B)
#define REG_SC_BK0B_5B_H      _PK_H_(0x0B, 0x5B)
#define REG_SC_BK0B_5C_L      _PK_L_(0x0B, 0x5C)
#define REG_SC_BK0B_5C_H      _PK_H_(0x0B, 0x5C)
#define REG_SC_BK0B_5D_L      _PK_L_(0x0B, 0x5D)
#define REG_SC_BK0B_5D_H      _PK_H_(0x0B, 0x5D)
#define REG_SC_BK0B_5E_L      _PK_L_(0x0B, 0x5E)
#define REG_SC_BK0B_5E_H      _PK_H_(0x0B, 0x5E)
#define REG_SC_BK0B_5F_L      _PK_L_(0x0B, 0x5F)
#define REG_SC_BK0B_5F_H      _PK_H_(0x0B, 0x5F)
#define REG_SC_BK0B_60_L      _PK_L_(0x0B, 0x60)
#define REG_SC_BK0B_60_H      _PK_H_(0x0B, 0x60)
#define REG_SC_BK0B_61_L      _PK_L_(0x0B, 0x61)
#define REG_SC_BK0B_61_H      _PK_H_(0x0B, 0x61)
#define REG_SC_BK0B_62_L      _PK_L_(0x0B, 0x62)
#define REG_SC_BK0B_62_H      _PK_H_(0x0B, 0x62)
#define REG_SC_BK0B_63_L      _PK_L_(0x0B, 0x63)
#define REG_SC_BK0B_63_H      _PK_H_(0x0B, 0x63)
#define REG_SC_BK0B_64_L      _PK_L_(0x0B, 0x64)
#define REG_SC_BK0B_64_H      _PK_H_(0x0B, 0x64)
#define REG_SC_BK0B_65_L      _PK_L_(0x0B, 0x65)
#define REG_SC_BK0B_65_H      _PK_H_(0x0B, 0x65)
#define REG_SC_BK0B_66_L      _PK_L_(0x0B, 0x66)
#define REG_SC_BK0B_66_H      _PK_H_(0x0B, 0x66)
#define REG_SC_BK0B_67_L      _PK_L_(0x0B, 0x67)
#define REG_SC_BK0B_67_H      _PK_H_(0x0B, 0x67)
#define REG_SC_BK0B_68_L      _PK_L_(0x0B, 0x68)
#define REG_SC_BK0B_68_H      _PK_H_(0x0B, 0x68)
#define REG_SC_BK0B_69_L      _PK_L_(0x0B, 0x69)
#define REG_SC_BK0B_69_H      _PK_H_(0x0B, 0x69)
#define REG_SC_BK0B_6A_L      _PK_L_(0x0B, 0x6A)
#define REG_SC_BK0B_6A_H      _PK_H_(0x0B, 0x6A)
#define REG_SC_BK0B_6B_L      _PK_L_(0x0B, 0x6B)
#define REG_SC_BK0B_6B_H      _PK_H_(0x0B, 0x6B)
#define REG_SC_BK0B_6C_L      _PK_L_(0x0B, 0x6C)
#define REG_SC_BK0B_6C_H      _PK_H_(0x0B, 0x6C)
#define REG_SC_BK0B_6D_L      _PK_L_(0x0B, 0x6D)
#define REG_SC_BK0B_6D_H      _PK_H_(0x0B, 0x6D)
#define REG_SC_BK0B_6E_L      _PK_L_(0x0B, 0x6E)
#define REG_SC_BK0B_6E_H      _PK_H_(0x0B, 0x6E)
#define REG_SC_BK0B_6F_L      _PK_L_(0x0B, 0x6F)
#define REG_SC_BK0B_6F_H      _PK_H_(0x0B, 0x6F)
#define REG_SC_BK0B_70_L      _PK_L_(0x0B, 0x70)
#define REG_SC_BK0B_70_H      _PK_H_(0x0B, 0x70)
#define REG_SC_BK0B_71_L      _PK_L_(0x0B, 0x71)
#define REG_SC_BK0B_71_H      _PK_H_(0x0B, 0x71)
#define REG_SC_BK0B_72_L      _PK_L_(0x0B, 0x72)
#define REG_SC_BK0B_72_H      _PK_H_(0x0B, 0x72)
#define REG_SC_BK0B_73_L      _PK_L_(0x0B, 0x73)
#define REG_SC_BK0B_73_H      _PK_H_(0x0B, 0x73)
#define REG_SC_BK0B_74_L      _PK_L_(0x0B, 0x74)
#define REG_SC_BK0B_74_H      _PK_H_(0x0B, 0x74)
#define REG_SC_BK0B_75_L      _PK_L_(0x0B, 0x75)
#define REG_SC_BK0B_75_H      _PK_H_(0x0B, 0x75)
#define REG_SC_BK0B_76_L      _PK_L_(0x0B, 0x76)
#define REG_SC_BK0B_76_H      _PK_H_(0x0B, 0x76)
#define REG_SC_BK0B_77_L      _PK_L_(0x0B, 0x77)
#define REG_SC_BK0B_77_H      _PK_H_(0x0B, 0x77)
#define REG_SC_BK0B_78_L      _PK_L_(0x0B, 0x78)
#define REG_SC_BK0B_78_H      _PK_H_(0x0B, 0x78)
#define REG_SC_BK0B_79_L      _PK_L_(0x0B, 0x79)
#define REG_SC_BK0B_79_H      _PK_H_(0x0B, 0x79)
#define REG_SC_BK0B_7A_L      _PK_L_(0x0B, 0x7A)
#define REG_SC_BK0B_7A_H      _PK_H_(0x0B, 0x7A)
#define REG_SC_BK0B_7B_L      _PK_L_(0x0B, 0x7B)
#define REG_SC_BK0B_7B_H      _PK_H_(0x0B, 0x7B)
#define REG_SC_BK0B_7C_L      _PK_L_(0x0B, 0x7C)
#define REG_SC_BK0B_7C_H      _PK_H_(0x0B, 0x7C)
#define REG_SC_BK0B_7D_L      _PK_L_(0x0B, 0x7D)
#define REG_SC_BK0B_7D_H      _PK_H_(0x0B, 0x7D)
#define REG_SC_BK0B_7E_L      _PK_L_(0x0B, 0x7E)
#define REG_SC_BK0B_7E_H      _PK_H_(0x0B, 0x7E)
#define REG_SC_BK0B_7F_L      _PK_L_(0x0B, 0x7F)
#define REG_SC_BK0B_7F_H      _PK_H_(0x0B, 0x7F)

//----------------------------------------------
//  BK0C: SNR
//----------------------------------------------
#define REG_SC_BK0C_00_L      _PK_L_(0x0C, 0x00)
#define REG_SC_BK0C_00_H      _PK_H_(0x0C, 0x00)
#define REG_SC_BK0C_01_L      _PK_L_(0x0C, 0x01)
#define REG_SC_BK0C_01_H      _PK_H_(0x0C, 0x01)
#define REG_SC_BK0C_02_L      _PK_L_(0x0C, 0x02)
#define REG_SC_BK0C_02_H      _PK_H_(0x0C, 0x02)
#define REG_SC_BK0C_03_L      _PK_L_(0x0C, 0x03)
#define REG_SC_BK0C_03_H      _PK_H_(0x0C, 0x03)
#define REG_SC_BK0C_04_L      _PK_L_(0x0C, 0x04)
#define REG_SC_BK0C_04_H      _PK_H_(0x0C, 0x04)
#define REG_SC_BK0C_05_L      _PK_L_(0x0C, 0x05)
#define REG_SC_BK0C_05_H      _PK_H_(0x0C, 0x05)
#define REG_SC_BK0C_06_L      _PK_L_(0x0C, 0x06)
#define REG_SC_BK0C_06_H      _PK_H_(0x0C, 0x06)
#define REG_SC_BK0C_07_L      _PK_L_(0x0C, 0x07)
#define REG_SC_BK0C_07_H      _PK_H_(0x0C, 0x07)
#define REG_SC_BK0C_08_L      _PK_L_(0x0C, 0x08)
#define REG_SC_BK0C_08_H      _PK_H_(0x0C, 0x08)
#define REG_SC_BK0C_09_L      _PK_L_(0x0C, 0x09)
#define REG_SC_BK0C_09_H      _PK_H_(0x0C, 0x09)
#define REG_SC_BK0C_0A_L      _PK_L_(0x0C, 0x0A)
#define REG_SC_BK0C_0A_H      _PK_H_(0x0C, 0x0A)
#define REG_SC_BK0C_0B_L      _PK_L_(0x0C, 0x0B)
#define REG_SC_BK0C_0B_H      _PK_H_(0x0C, 0x0B)
#define REG_SC_BK0C_0C_L      _PK_L_(0x0C, 0x0C)
#define REG_SC_BK0C_0C_H      _PK_H_(0x0C, 0x0C)
#define REG_SC_BK0C_0D_L      _PK_L_(0x0C, 0x0D)
#define REG_SC_BK0C_0D_H      _PK_H_(0x0C, 0x0D)
#define REG_SC_BK0C_0E_L      _PK_L_(0x0C, 0x0E)
#define REG_SC_BK0C_0E_H      _PK_H_(0x0C, 0x0E)
#define REG_SC_BK0C_0F_L      _PK_L_(0x0C, 0x0F)
#define REG_SC_BK0C_0F_H      _PK_H_(0x0C, 0x0F)
#define REG_SC_BK0C_10_L      _PK_L_(0x0C, 0x10)
#define REG_SC_BK0C_10_H      _PK_H_(0x0C, 0x10)
#define REG_SC_BK0C_11_L      _PK_L_(0x0C, 0x11)
#define REG_SC_BK0C_11_H      _PK_H_(0x0C, 0x11)
#define REG_SC_BK0C_12_L      _PK_L_(0x0C, 0x12)
#define REG_SC_BK0C_12_H      _PK_H_(0x0C, 0x12)
#define REG_SC_BK0C_13_L      _PK_L_(0x0C, 0x13)
#define REG_SC_BK0C_13_H      _PK_H_(0x0C, 0x13)
#define REG_SC_BK0C_14_L      _PK_L_(0x0C, 0x14)
#define REG_SC_BK0C_14_H      _PK_H_(0x0C, 0x14)
#define REG_SC_BK0C_15_L      _PK_L_(0x0C, 0x15)
#define REG_SC_BK0C_15_H      _PK_H_(0x0C, 0x15)
#define REG_SC_BK0C_16_L      _PK_L_(0x0C, 0x16)
#define REG_SC_BK0C_16_H      _PK_H_(0x0C, 0x16)
#define REG_SC_BK0C_17_L      _PK_L_(0x0C, 0x17)
#define REG_SC_BK0C_17_H      _PK_H_(0x0C, 0x17)
#define REG_SC_BK0C_18_L      _PK_L_(0x0C, 0x18)
#define REG_SC_BK0C_18_H      _PK_H_(0x0C, 0x18)
#define REG_SC_BK0C_19_L      _PK_L_(0x0C, 0x19)
#define REG_SC_BK0C_19_H      _PK_H_(0x0C, 0x19)
#define REG_SC_BK0C_1A_L      _PK_L_(0x0C, 0x1A)
#define REG_SC_BK0C_1A_H      _PK_H_(0x0C, 0x1A)
#define REG_SC_BK0C_1B_L      _PK_L_(0x0C, 0x1B)
#define REG_SC_BK0C_1B_H      _PK_H_(0x0C, 0x1B)
#define REG_SC_BK0C_1C_L      _PK_L_(0x0C, 0x1C)
#define REG_SC_BK0C_1C_H      _PK_H_(0x0C, 0x1C)
#define REG_SC_BK0C_1D_L      _PK_L_(0x0C, 0x1D)
#define REG_SC_BK0C_1D_H      _PK_H_(0x0C, 0x1D)
#define REG_SC_BK0C_1E_L      _PK_L_(0x0C, 0x1E)
#define REG_SC_BK0C_1E_H      _PK_H_(0x0C, 0x1E)
#define REG_SC_BK0C_1F_L      _PK_L_(0x0C, 0x1F)
#define REG_SC_BK0C_1F_H      _PK_H_(0x0C, 0x1F)
#define REG_SC_BK0C_20_L      _PK_L_(0x0C, 0x20)
#define REG_SC_BK0C_20_H      _PK_H_(0x0C, 0x20)
#define REG_SC_BK0C_21_L      _PK_L_(0x0C, 0x21)
#define REG_SC_BK0C_21_H      _PK_H_(0x0C, 0x21)
#define REG_SC_BK0C_22_L      _PK_L_(0x0C, 0x22)
#define REG_SC_BK0C_22_H      _PK_H_(0x0C, 0x22)
#define REG_SC_BK0C_23_L      _PK_L_(0x0C, 0x23)
#define REG_SC_BK0C_23_H      _PK_H_(0x0C, 0x23)
#define REG_SC_BK0C_24_L      _PK_L_(0x0C, 0x24)
#define REG_SC_BK0C_24_H      _PK_H_(0x0C, 0x24)
#define REG_SC_BK0C_25_L      _PK_L_(0x0C, 0x25)
#define REG_SC_BK0C_25_H      _PK_H_(0x0C, 0x25)
#define REG_SC_BK0C_26_L      _PK_L_(0x0C, 0x26)
#define REG_SC_BK0C_26_H      _PK_H_(0x0C, 0x26)
#define REG_SC_BK0C_27_L      _PK_L_(0x0C, 0x27)
#define REG_SC_BK0C_27_H      _PK_H_(0x0C, 0x27)
#define REG_SC_BK0C_28_L      _PK_L_(0x0C, 0x28)
#define REG_SC_BK0C_28_H      _PK_H_(0x0C, 0x28)
#define REG_SC_BK0C_29_L      _PK_L_(0x0C, 0x29)
#define REG_SC_BK0C_29_H      _PK_H_(0x0C, 0x29)
#define REG_SC_BK0C_2A_L      _PK_L_(0x0C, 0x2A)
#define REG_SC_BK0C_2A_H      _PK_H_(0x0C, 0x2A)
#define REG_SC_BK0C_2B_L      _PK_L_(0x0C, 0x2B)
#define REG_SC_BK0C_2B_H      _PK_H_(0x0C, 0x2B)
#define REG_SC_BK0C_2C_L      _PK_L_(0x0C, 0x2C)
#define REG_SC_BK0C_2C_H      _PK_H_(0x0C, 0x2C)
#define REG_SC_BK0C_2D_L      _PK_L_(0x0C, 0x2D)
#define REG_SC_BK0C_2D_H      _PK_H_(0x0C, 0x2D)
#define REG_SC_BK0C_2E_L      _PK_L_(0x0C, 0x2E)
#define REG_SC_BK0C_2E_H      _PK_H_(0x0C, 0x2E)
#define REG_SC_BK0C_2F_L      _PK_L_(0x0C, 0x2F)
#define REG_SC_BK0C_2F_H      _PK_H_(0x0C, 0x2F)
#define REG_SC_BK0C_30_L      _PK_L_(0x0C, 0x30)
#define REG_SC_BK0C_30_H      _PK_H_(0x0C, 0x30)
#define REG_SC_BK0C_31_L      _PK_L_(0x0C, 0x31)
#define REG_SC_BK0C_31_H      _PK_H_(0x0C, 0x31)
#define REG_SC_BK0C_32_L      _PK_L_(0x0C, 0x32)
#define REG_SC_BK0C_32_H      _PK_H_(0x0C, 0x32)
#define REG_SC_BK0C_33_L      _PK_L_(0x0C, 0x33)
#define REG_SC_BK0C_33_H      _PK_H_(0x0C, 0x33)
#define REG_SC_BK0C_34_L      _PK_L_(0x0C, 0x34)
#define REG_SC_BK0C_34_H      _PK_H_(0x0C, 0x34)
#define REG_SC_BK0C_35_L      _PK_L_(0x0C, 0x35)
#define REG_SC_BK0C_35_H      _PK_H_(0x0C, 0x35)
#define REG_SC_BK0C_36_L      _PK_L_(0x0C, 0x36)
#define REG_SC_BK0C_36_H      _PK_H_(0x0C, 0x36)
#define REG_SC_BK0C_37_L      _PK_L_(0x0C, 0x37)
#define REG_SC_BK0C_37_H      _PK_H_(0x0C, 0x37)
#define REG_SC_BK0C_38_L      _PK_L_(0x0C, 0x38)
#define REG_SC_BK0C_38_H      _PK_H_(0x0C, 0x38)
#define REG_SC_BK0C_39_L      _PK_L_(0x0C, 0x39)
#define REG_SC_BK0C_39_H      _PK_H_(0x0C, 0x39)
#define REG_SC_BK0C_3A_L      _PK_L_(0x0C, 0x3A)
#define REG_SC_BK0C_3A_H      _PK_H_(0x0C, 0x3A)
#define REG_SC_BK0C_3B_L      _PK_L_(0x0C, 0x3B)
#define REG_SC_BK0C_3B_H      _PK_H_(0x0C, 0x3B)
#define REG_SC_BK0C_3C_L      _PK_L_(0x0C, 0x3C)
#define REG_SC_BK0C_3C_H      _PK_H_(0x0C, 0x3C)
#define REG_SC_BK0C_3D_L      _PK_L_(0x0C, 0x3D)
#define REG_SC_BK0C_3D_H      _PK_H_(0x0C, 0x3D)
#define REG_SC_BK0C_3E_L      _PK_L_(0x0C, 0x3E)
#define REG_SC_BK0C_3E_H      _PK_H_(0x0C, 0x3E)
#define REG_SC_BK0C_3F_L      _PK_L_(0x0C, 0x3F)
#define REG_SC_BK0C_3F_H      _PK_H_(0x0C, 0x3F)
#define REG_SC_BK0C_40_L      _PK_L_(0x0C, 0x40)
#define REG_SC_BK0C_40_H      _PK_H_(0x0C, 0x40)
#define REG_SC_BK0C_41_L      _PK_L_(0x0C, 0x41)
#define REG_SC_BK0C_41_H      _PK_H_(0x0C, 0x41)
#define REG_SC_BK0C_42_L      _PK_L_(0x0C, 0x42)
#define REG_SC_BK0C_42_H      _PK_H_(0x0C, 0x42)
#define REG_SC_BK0C_43_L      _PK_L_(0x0C, 0x43)
#define REG_SC_BK0C_43_H      _PK_H_(0x0C, 0x43)
#define REG_SC_BK0C_44_L      _PK_L_(0x0C, 0x44)
#define REG_SC_BK0C_44_H      _PK_H_(0x0C, 0x44)
#define REG_SC_BK0C_45_L      _PK_L_(0x0C, 0x45)
#define REG_SC_BK0C_45_H      _PK_H_(0x0C, 0x45)
#define REG_SC_BK0C_46_L      _PK_L_(0x0C, 0x46)
#define REG_SC_BK0C_46_H      _PK_H_(0x0C, 0x46)
#define REG_SC_BK0C_47_L      _PK_L_(0x0C, 0x47)
#define REG_SC_BK0C_47_H      _PK_H_(0x0C, 0x47)
#define REG_SC_BK0C_48_L      _PK_L_(0x0C, 0x48)
#define REG_SC_BK0C_48_H      _PK_H_(0x0C, 0x48)
#define REG_SC_BK0C_49_L      _PK_L_(0x0C, 0x49)
#define REG_SC_BK0C_49_H      _PK_H_(0x0C, 0x49)
#define REG_SC_BK0C_4A_L      _PK_L_(0x0C, 0x4A)
#define REG_SC_BK0C_4A_H      _PK_H_(0x0C, 0x4A)
#define REG_SC_BK0C_4B_L      _PK_L_(0x0C, 0x4B)
#define REG_SC_BK0C_4B_H      _PK_H_(0x0C, 0x4B)
#define REG_SC_BK0C_4C_L      _PK_L_(0x0C, 0x4C)
#define REG_SC_BK0C_4C_H      _PK_H_(0x0C, 0x4C)
#define REG_SC_BK0C_4D_L      _PK_L_(0x0C, 0x4D)
#define REG_SC_BK0C_4D_H      _PK_H_(0x0C, 0x4D)
#define REG_SC_BK0C_4E_L      _PK_L_(0x0C, 0x4E)
#define REG_SC_BK0C_4E_H      _PK_H_(0x0C, 0x4E)
#define REG_SC_BK0C_4F_L      _PK_L_(0x0C, 0x4F)
#define REG_SC_BK0C_4F_H      _PK_H_(0x0C, 0x4F)
#define REG_SC_BK0C_50_L      _PK_L_(0x0C, 0x50)
#define REG_SC_BK0C_50_H      _PK_H_(0x0C, 0x50)
#define REG_SC_BK0C_51_L      _PK_L_(0x0C, 0x51)
#define REG_SC_BK0C_51_H      _PK_H_(0x0C, 0x51)
#define REG_SC_BK0C_52_L      _PK_L_(0x0C, 0x52)
#define REG_SC_BK0C_52_H      _PK_H_(0x0C, 0x52)
#define REG_SC_BK0C_53_L      _PK_L_(0x0C, 0x53)
#define REG_SC_BK0C_53_H      _PK_H_(0x0C, 0x53)
#define REG_SC_BK0C_54_L      _PK_L_(0x0C, 0x54)
#define REG_SC_BK0C_54_H      _PK_H_(0x0C, 0x54)
#define REG_SC_BK0C_55_L      _PK_L_(0x0C, 0x55)
#define REG_SC_BK0C_55_H      _PK_H_(0x0C, 0x55)
#define REG_SC_BK0C_56_L      _PK_L_(0x0C, 0x56)
#define REG_SC_BK0C_56_H      _PK_H_(0x0C, 0x56)
#define REG_SC_BK0C_57_L      _PK_L_(0x0C, 0x57)
#define REG_SC_BK0C_57_H      _PK_H_(0x0C, 0x57)
#define REG_SC_BK0C_58_L      _PK_L_(0x0C, 0x58)
#define REG_SC_BK0C_58_H      _PK_H_(0x0C, 0x58)
#define REG_SC_BK0C_59_L      _PK_L_(0x0C, 0x59)
#define REG_SC_BK0C_59_H      _PK_H_(0x0C, 0x59)
#define REG_SC_BK0C_5A_L      _PK_L_(0x0C, 0x5A)
#define REG_SC_BK0C_5A_H      _PK_H_(0x0C, 0x5A)
#define REG_SC_BK0C_5B_L      _PK_L_(0x0C, 0x5B)
#define REG_SC_BK0C_5B_H      _PK_H_(0x0C, 0x5B)
#define REG_SC_BK0C_5C_L      _PK_L_(0x0C, 0x5C)
#define REG_SC_BK0C_5C_H      _PK_H_(0x0C, 0x5C)
#define REG_SC_BK0C_5D_L      _PK_L_(0x0C, 0x5D)
#define REG_SC_BK0C_5D_H      _PK_H_(0x0C, 0x5D)
#define REG_SC_BK0C_5E_L      _PK_L_(0x0C, 0x5E)
#define REG_SC_BK0C_5E_H      _PK_H_(0x0C, 0x5E)
#define REG_SC_BK0C_5F_L      _PK_L_(0x0C, 0x5F)
#define REG_SC_BK0C_5F_H      _PK_H_(0x0C, 0x5F)
#define REG_SC_BK0C_60_L      _PK_L_(0x0C, 0x60)
#define REG_SC_BK0C_60_H      _PK_H_(0x0C, 0x60)
#define REG_SC_BK0C_61_L      _PK_L_(0x0C, 0x61)
#define REG_SC_BK0C_61_H      _PK_H_(0x0C, 0x61)
#define REG_SC_BK0C_62_L      _PK_L_(0x0C, 0x62)
#define REG_SC_BK0C_62_H      _PK_H_(0x0C, 0x62)
#define REG_SC_BK0C_63_L      _PK_L_(0x0C, 0x63)
#define REG_SC_BK0C_63_H      _PK_H_(0x0C, 0x63)
#define REG_SC_BK0C_64_L      _PK_L_(0x0C, 0x64)
#define REG_SC_BK0C_64_H      _PK_H_(0x0C, 0x64)
#define REG_SC_BK0C_65_L      _PK_L_(0x0C, 0x65)
#define REG_SC_BK0C_65_H      _PK_H_(0x0C, 0x65)
#define REG_SC_BK0C_66_L      _PK_L_(0x0C, 0x66)
#define REG_SC_BK0C_66_H      _PK_H_(0x0C, 0x66)
#define REG_SC_BK0C_67_L      _PK_L_(0x0C, 0x67)
#define REG_SC_BK0C_67_H      _PK_H_(0x0C, 0x67)
#define REG_SC_BK0C_68_L      _PK_L_(0x0C, 0x68)
#define REG_SC_BK0C_68_H      _PK_H_(0x0C, 0x68)
#define REG_SC_BK0C_69_L      _PK_L_(0x0C, 0x69)
#define REG_SC_BK0C_69_H      _PK_H_(0x0C, 0x69)
#define REG_SC_BK0C_6A_L      _PK_L_(0x0C, 0x6A)
#define REG_SC_BK0C_6A_H      _PK_H_(0x0C, 0x6A)
#define REG_SC_BK0C_6B_L      _PK_L_(0x0C, 0x6B)
#define REG_SC_BK0C_6B_H      _PK_H_(0x0C, 0x6B)
#define REG_SC_BK0C_6C_L      _PK_L_(0x0C, 0x6C)
#define REG_SC_BK0C_6C_H      _PK_H_(0x0C, 0x6C)
#define REG_SC_BK0C_6D_L      _PK_L_(0x0C, 0x6D)
#define REG_SC_BK0C_6D_H      _PK_H_(0x0C, 0x6D)
#define REG_SC_BK0C_6E_L      _PK_L_(0x0C, 0x6E)
#define REG_SC_BK0C_6E_H      _PK_H_(0x0C, 0x6E)
#define REG_SC_BK0C_6F_L      _PK_L_(0x0C, 0x6F)
#define REG_SC_BK0C_6F_H      _PK_H_(0x0C, 0x6F)
#define REG_SC_BK0C_70_L      _PK_L_(0x0C, 0x70)
#define REG_SC_BK0C_70_H      _PK_H_(0x0C, 0x70)
#define REG_SC_BK0C_71_L      _PK_L_(0x0C, 0x71)
#define REG_SC_BK0C_71_H      _PK_H_(0x0C, 0x71)
#define REG_SC_BK0C_72_L      _PK_L_(0x0C, 0x72)
#define REG_SC_BK0C_72_H      _PK_H_(0x0C, 0x72)
#define REG_SC_BK0C_73_L      _PK_L_(0x0C, 0x73)
#define REG_SC_BK0C_73_H      _PK_H_(0x0C, 0x73)
#define REG_SC_BK0C_74_L      _PK_L_(0x0C, 0x74)
#define REG_SC_BK0C_74_H      _PK_H_(0x0C, 0x74)
#define REG_SC_BK0C_75_L      _PK_L_(0x0C, 0x75)
#define REG_SC_BK0C_75_H      _PK_H_(0x0C, 0x75)
#define REG_SC_BK0C_76_L      _PK_L_(0x0C, 0x76)
#define REG_SC_BK0C_76_H      _PK_H_(0x0C, 0x76)
#define REG_SC_BK0C_77_L      _PK_L_(0x0C, 0x77)
#define REG_SC_BK0C_77_H      _PK_H_(0x0C, 0x77)
#define REG_SC_BK0C_78_L      _PK_L_(0x0C, 0x78)
#define REG_SC_BK0C_78_H      _PK_H_(0x0C, 0x78)
#define REG_SC_BK0C_79_L      _PK_L_(0x0C, 0x79)
#define REG_SC_BK0C_79_H      _PK_H_(0x0C, 0x79)
#define REG_SC_BK0C_7A_L      _PK_L_(0x0C, 0x7A)
#define REG_SC_BK0C_7A_H      _PK_H_(0x0C, 0x7A)
#define REG_SC_BK0C_7B_L      _PK_L_(0x0C, 0x7B)
#define REG_SC_BK0C_7B_H      _PK_H_(0x0C, 0x7B)
#define REG_SC_BK0C_7C_L      _PK_L_(0x0C, 0x7C)
#define REG_SC_BK0C_7C_H      _PK_H_(0x0C, 0x7C)
#define REG_SC_BK0C_7D_L      _PK_L_(0x0C, 0x7D)
#define REG_SC_BK0C_7D_H      _PK_H_(0x0C, 0x7D)
#define REG_SC_BK0C_7E_L      _PK_L_(0x0C, 0x7E)
#define REG_SC_BK0C_7E_H      _PK_H_(0x0C, 0x7E)
#define REG_SC_BK0C_7F_L      _PK_L_(0x0C, 0x7F)
#define REG_SC_BK0C_7F_H      _PK_H_(0x0C, 0x7F)

//----------------------------------------------
//  BK0F: SVOP
//----------------------------------------------
#define REG_SC_BK0F_00_L      _PK_L_(0x0F, 0x00)
#define REG_SC_BK0F_00_H      _PK_H_(0x0F, 0x00)
#define REG_SC_BK0F_01_L      _PK_L_(0x0F, 0x01)
#define REG_SC_BK0F_01_H      _PK_H_(0x0F, 0x01)
#define REG_SC_BK0F_02_L      _PK_L_(0x0F, 0x02)
#define REG_SC_BK0F_02_H      _PK_H_(0x0F, 0x02)
#define REG_SC_BK0F_03_L      _PK_L_(0x0F, 0x03)
#define REG_SC_BK0F_03_H      _PK_H_(0x0F, 0x03)
#define REG_SC_BK0F_04_L      _PK_L_(0x0F, 0x04)
#define REG_SC_BK0F_04_H      _PK_H_(0x0F, 0x04)
#define REG_SC_BK0F_05_L      _PK_L_(0x0F, 0x05)
#define REG_SC_BK0F_05_H      _PK_H_(0x0F, 0x05)
#define REG_SC_BK0F_06_L      _PK_L_(0x0F, 0x06)
#define REG_SC_BK0F_06_H      _PK_H_(0x0F, 0x06)
#define REG_SC_BK0F_07_L      _PK_L_(0x0F, 0x07)
#define REG_SC_BK0F_07_H      _PK_H_(0x0F, 0x07)
#define REG_SC_BK0F_08_L      _PK_L_(0x0F, 0x08)
#define REG_SC_BK0F_08_H      _PK_H_(0x0F, 0x08)
#define REG_SC_BK0F_09_L      _PK_L_(0x0F, 0x09)
#define REG_SC_BK0F_09_H      _PK_H_(0x0F, 0x09)
#define REG_SC_BK0F_0A_L      _PK_L_(0x0F, 0x0A)
#define REG_SC_BK0F_0A_H      _PK_H_(0x0F, 0x0A)
#define REG_SC_BK0F_0B_L      _PK_L_(0x0F, 0x0B)
#define REG_SC_BK0F_0B_H      _PK_H_(0x0F, 0x0B)
#define REG_SC_BK0F_0C_L      _PK_L_(0x0F, 0x0C)
#define REG_SC_BK0F_0C_H      _PK_H_(0x0F, 0x0C)
#define REG_SC_BK0F_0D_L      _PK_L_(0x0F, 0x0D)
#define REG_SC_BK0F_0D_H      _PK_H_(0x0F, 0x0D)
#define REG_SC_BK0F_0E_L      _PK_L_(0x0F, 0x0E)
#define REG_SC_BK0F_0E_H      _PK_H_(0x0F, 0x0E)
#define REG_SC_BK0F_0F_L      _PK_L_(0x0F, 0x0F)
#define REG_SC_BK0F_0F_H      _PK_H_(0x0F, 0x0F)
#define REG_SC_BK0F_10_L      _PK_L_(0x0F, 0x10)
#define REG_SC_BK0F_10_H      _PK_H_(0x0F, 0x10)
#define REG_SC_BK0F_11_L      _PK_L_(0x0F, 0x11)
#define REG_SC_BK0F_11_H      _PK_H_(0x0F, 0x11)
#define REG_SC_BK0F_12_L      _PK_L_(0x0F, 0x12)
#define REG_SC_BK0F_12_H      _PK_H_(0x0F, 0x12)
#define REG_SC_BK0F_13_L      _PK_L_(0x0F, 0x13)
#define REG_SC_BK0F_13_H      _PK_H_(0x0F, 0x13)
#define REG_SC_BK0F_14_L      _PK_L_(0x0F, 0x14)
#define REG_SC_BK0F_14_H      _PK_H_(0x0F, 0x14)
#define REG_SC_BK0F_15_L      _PK_L_(0x0F, 0x15)
#define REG_SC_BK0F_15_H      _PK_H_(0x0F, 0x15)
#define REG_SC_BK0F_16_L      _PK_L_(0x0F, 0x16)
#define REG_SC_BK0F_16_H      _PK_H_(0x0F, 0x16)
#define REG_SC_BK0F_17_L      _PK_L_(0x0F, 0x17)
#define REG_SC_BK0F_17_H      _PK_H_(0x0F, 0x17)
#define REG_SC_BK0F_18_L      _PK_L_(0x0F, 0x18)
#define REG_SC_BK0F_18_H      _PK_H_(0x0F, 0x18)
#define REG_SC_BK0F_19_L      _PK_L_(0x0F, 0x19)
#define REG_SC_BK0F_19_H      _PK_H_(0x0F, 0x19)
#define REG_SC_BK0F_1A_L      _PK_L_(0x0F, 0x1A)
#define REG_SC_BK0F_1A_H      _PK_H_(0x0F, 0x1A)
#define REG_SC_BK0F_1B_L      _PK_L_(0x0F, 0x1B)
#define REG_SC_BK0F_1B_H      _PK_H_(0x0F, 0x1B)
#define REG_SC_BK0F_1C_L      _PK_L_(0x0F, 0x1C)
#define REG_SC_BK0F_1C_H      _PK_H_(0x0F, 0x1C)
#define REG_SC_BK0F_1D_L      _PK_L_(0x0F, 0x1D)
#define REG_SC_BK0F_1D_H      _PK_H_(0x0F, 0x1D)
#define REG_SC_BK0F_1E_L      _PK_L_(0x0F, 0x1E)
#define REG_SC_BK0F_1E_H      _PK_H_(0x0F, 0x1E)
#define REG_SC_BK0F_1F_L      _PK_L_(0x0F, 0x1F)
#define REG_SC_BK0F_1F_H      _PK_H_(0x0F, 0x1F)
#define REG_SC_BK0F_20_L      _PK_L_(0x0F, 0x20)
#define REG_SC_BK0F_20_H      _PK_H_(0x0F, 0x20)
#define REG_SC_BK0F_21_L      _PK_L_(0x0F, 0x21)
#define REG_SC_BK0F_21_H      _PK_H_(0x0F, 0x21)
#define REG_SC_BK0F_22_L      _PK_L_(0x0F, 0x22)
#define REG_SC_BK0F_22_H      _PK_H_(0x0F, 0x22)
#define REG_SC_BK0F_23_L      _PK_L_(0x0F, 0x23)
#define REG_SC_BK0F_23_H      _PK_H_(0x0F, 0x23)
#define REG_SC_BK0F_24_L      _PK_L_(0x0F, 0x24)
#define REG_SC_BK0F_24_H      _PK_H_(0x0F, 0x24)
#define REG_SC_BK0F_25_L      _PK_L_(0x0F, 0x25)
#define REG_SC_BK0F_25_H      _PK_H_(0x0F, 0x25)
#define REG_SC_BK0F_26_L      _PK_L_(0x0F, 0x26)
#define REG_SC_BK0F_26_H      _PK_H_(0x0F, 0x26)
#define REG_SC_BK0F_27_L      _PK_L_(0x0F, 0x27)
#define REG_SC_BK0F_27_H      _PK_H_(0x0F, 0x27)
#define REG_SC_BK0F_28_L      _PK_L_(0x0F, 0x28)
#define REG_SC_BK0F_28_H      _PK_H_(0x0F, 0x28)
#define REG_SC_BK0F_29_L      _PK_L_(0x0F, 0x29)
#define REG_SC_BK0F_29_H      _PK_H_(0x0F, 0x29)
#define REG_SC_BK0F_2A_L      _PK_L_(0x0F, 0x2A)
#define REG_SC_BK0F_2A_H      _PK_H_(0x0F, 0x2A)
#define REG_SC_BK0F_2B_L      _PK_L_(0x0F, 0x2B)
#define REG_SC_BK0F_2B_H      _PK_H_(0x0F, 0x2B)
#define REG_SC_BK0F_2C_L      _PK_L_(0x0F, 0x2C)
#define REG_SC_BK0F_2C_H      _PK_H_(0x0F, 0x2C)
#define REG_SC_BK0F_2D_L      _PK_L_(0x0F, 0x2D)
#define REG_SC_BK0F_2D_H      _PK_H_(0x0F, 0x2D)
#define REG_SC_BK0F_2E_L      _PK_L_(0x0F, 0x2E)
#define REG_SC_BK0F_2E_H      _PK_H_(0x0F, 0x2E)
#define REG_SC_BK0F_2F_L      _PK_L_(0x0F, 0x2F)
#define REG_SC_BK0F_2F_H      _PK_H_(0x0F, 0x2F)
#define REG_SC_BK0F_30_L      _PK_L_(0x0F, 0x30)
#define REG_SC_BK0F_30_H      _PK_H_(0x0F, 0x30)
#define REG_SC_BK0F_31_L      _PK_L_(0x0F, 0x31)
#define REG_SC_BK0F_31_H      _PK_H_(0x0F, 0x31)
#define REG_SC_BK0F_32_L      _PK_L_(0x0F, 0x32)
#define REG_SC_BK0F_32_H      _PK_H_(0x0F, 0x32)
#define REG_SC_BK0F_33_L      _PK_L_(0x0F, 0x33)
#define REG_SC_BK0F_33_H      _PK_H_(0x0F, 0x33)
#define REG_SC_BK0F_34_L      _PK_L_(0x0F, 0x34)
#define REG_SC_BK0F_34_H      _PK_H_(0x0F, 0x34)
#define REG_SC_BK0F_35_L      _PK_L_(0x0F, 0x35)
#define REG_SC_BK0F_35_H      _PK_H_(0x0F, 0x35)
#define REG_SC_BK0F_36_L      _PK_L_(0x0F, 0x36)
#define REG_SC_BK0F_36_H      _PK_H_(0x0F, 0x36)
#define REG_SC_BK0F_37_L      _PK_L_(0x0F, 0x37)
#define REG_SC_BK0F_37_H      _PK_H_(0x0F, 0x37)
#define REG_SC_BK0F_38_L      _PK_L_(0x0F, 0x38)
#define REG_SC_BK0F_38_H      _PK_H_(0x0F, 0x38)
#define REG_SC_BK0F_39_L      _PK_L_(0x0F, 0x39)
#define REG_SC_BK0F_39_H      _PK_H_(0x0F, 0x39)
#define REG_SC_BK0F_3A_L      _PK_L_(0x0F, 0x3A)
#define REG_SC_BK0F_3A_H      _PK_H_(0x0F, 0x3A)
#define REG_SC_BK0F_3B_L      _PK_L_(0x0F, 0x3B)
#define REG_SC_BK0F_3B_H      _PK_H_(0x0F, 0x3B)
#define REG_SC_BK0F_3C_L      _PK_L_(0x0F, 0x3C)
#define REG_SC_BK0F_3C_H      _PK_H_(0x0F, 0x3C)
#define REG_SC_BK0F_3D_L      _PK_L_(0x0F, 0x3D)
#define REG_SC_BK0F_3D_H      _PK_H_(0x0F, 0x3D)
#define REG_SC_BK0F_3E_L      _PK_L_(0x0F, 0x3E)
#define REG_SC_BK0F_3E_H      _PK_H_(0x0F, 0x3E)
#define REG_SC_BK0F_3F_L      _PK_L_(0x0F, 0x3F)
#define REG_SC_BK0F_3F_H      _PK_H_(0x0F, 0x3F)
#define REG_SC_BK0F_40_L      _PK_L_(0x0F, 0x40)
#define REG_SC_BK0F_40_H      _PK_H_(0x0F, 0x40)
#define REG_SC_BK0F_41_L      _PK_L_(0x0F, 0x41)
#define REG_SC_BK0F_41_H      _PK_H_(0x0F, 0x41)
#define REG_SC_BK0F_42_L      _PK_L_(0x0F, 0x42)
#define REG_SC_BK0F_42_H      _PK_H_(0x0F, 0x42)
#define REG_SC_BK0F_43_L      _PK_L_(0x0F, 0x43)
#define REG_SC_BK0F_43_H      _PK_H_(0x0F, 0x43)
#define REG_SC_BK0F_44_L      _PK_L_(0x0F, 0x44)
#define REG_SC_BK0F_44_H      _PK_H_(0x0F, 0x44)
#define REG_SC_BK0F_45_L      _PK_L_(0x0F, 0x45)
#define REG_SC_BK0F_45_H      _PK_H_(0x0F, 0x45)
#define REG_SC_BK0F_46_L      _PK_L_(0x0F, 0x46)
#define REG_SC_BK0F_46_H      _PK_H_(0x0F, 0x46)
#define REG_SC_BK0F_47_L      _PK_L_(0x0F, 0x47)
#define REG_SC_BK0F_47_H      _PK_H_(0x0F, 0x47)
#define REG_SC_BK0F_48_L      _PK_L_(0x0F, 0x48)
#define REG_SC_BK0F_48_H      _PK_H_(0x0F, 0x48)
#define REG_SC_BK0F_49_L      _PK_L_(0x0F, 0x49)
#define REG_SC_BK0F_49_H      _PK_H_(0x0F, 0x49)
#define REG_SC_BK0F_4A_L      _PK_L_(0x0F, 0x4A)
#define REG_SC_BK0F_4A_H      _PK_H_(0x0F, 0x4A)
#define REG_SC_BK0F_4B_L      _PK_L_(0x0F, 0x4B)
#define REG_SC_BK0F_4B_H      _PK_H_(0x0F, 0x4B)
#define REG_SC_BK0F_4C_L      _PK_L_(0x0F, 0x4C)
#define REG_SC_BK0F_4C_H      _PK_H_(0x0F, 0x4C)
#define REG_SC_BK0F_4D_L      _PK_L_(0x0F, 0x4D)
#define REG_SC_BK0F_4D_H      _PK_H_(0x0F, 0x4D)
#define REG_SC_BK0F_4E_L      _PK_L_(0x0F, 0x4E)
#define REG_SC_BK0F_4E_H      _PK_H_(0x0F, 0x4E)
#define REG_SC_BK0F_4F_L      _PK_L_(0x0F, 0x4F)
#define REG_SC_BK0F_4F_H      _PK_H_(0x0F, 0x4F)
#define REG_SC_BK0F_50_L      _PK_L_(0x0F, 0x50)
#define REG_SC_BK0F_50_H      _PK_H_(0x0F, 0x50)
#define REG_SC_BK0F_51_L      _PK_L_(0x0F, 0x51)
#define REG_SC_BK0F_51_H      _PK_H_(0x0F, 0x51)
#define REG_SC_BK0F_52_L      _PK_L_(0x0F, 0x52)
#define REG_SC_BK0F_52_H      _PK_H_(0x0F, 0x52)
#define REG_SC_BK0F_53_L      _PK_L_(0x0F, 0x53)
#define REG_SC_BK0F_53_H      _PK_H_(0x0F, 0x53)
#define REG_SC_BK0F_54_L      _PK_L_(0x0F, 0x54)
#define REG_SC_BK0F_54_H      _PK_H_(0x0F, 0x54)
#define REG_SC_BK0F_55_L      _PK_L_(0x0F, 0x55)
#define REG_SC_BK0F_55_H      _PK_H_(0x0F, 0x55)
#define REG_SC_BK0F_56_L      _PK_L_(0x0F, 0x56)
#define REG_SC_BK0F_56_H      _PK_H_(0x0F, 0x56)
#define REG_SC_BK0F_57_L      _PK_L_(0x0F, 0x57)
#define REG_SC_BK0F_57_H      _PK_H_(0x0F, 0x57)
#define REG_SC_BK0F_58_L      _PK_L_(0x0F, 0x58)
#define REG_SC_BK0F_58_H      _PK_H_(0x0F, 0x58)
#define REG_SC_BK0F_59_L      _PK_L_(0x0F, 0x59)
#define REG_SC_BK0F_59_H      _PK_H_(0x0F, 0x59)
#define REG_SC_BK0F_5A_L      _PK_L_(0x0F, 0x5A)
#define REG_SC_BK0F_5A_H      _PK_H_(0x0F, 0x5A)
#define REG_SC_BK0F_5B_L      _PK_L_(0x0F, 0x5B)
#define REG_SC_BK0F_5B_H      _PK_H_(0x0F, 0x5B)
#define REG_SC_BK0F_5C_L      _PK_L_(0x0F, 0x5C)
#define REG_SC_BK0F_5C_H      _PK_H_(0x0F, 0x5C)
#define REG_SC_BK0F_5D_L      _PK_L_(0x0F, 0x5D)
#define REG_SC_BK0F_5D_H      _PK_H_(0x0F, 0x5D)
#define REG_SC_BK0F_5E_L      _PK_L_(0x0F, 0x5E)
#define REG_SC_BK0F_5E_H      _PK_H_(0x0F, 0x5E)
#define REG_SC_BK0F_5F_L      _PK_L_(0x0F, 0x5F)
#define REG_SC_BK0F_5F_H      _PK_H_(0x0F, 0x5F)
#define REG_SC_BK0F_60_L      _PK_L_(0x0F, 0x60)
#define REG_SC_BK0F_60_H      _PK_H_(0x0F, 0x60)
#define REG_SC_BK0F_61_L      _PK_L_(0x0F, 0x61)
#define REG_SC_BK0F_61_H      _PK_H_(0x0F, 0x61)
#define REG_SC_BK0F_62_L      _PK_L_(0x0F, 0x62)
#define REG_SC_BK0F_62_H      _PK_H_(0x0F, 0x62)
#define REG_SC_BK0F_63_L      _PK_L_(0x0F, 0x63)
#define REG_SC_BK0F_63_H      _PK_H_(0x0F, 0x63)
#define REG_SC_BK0F_64_L      _PK_L_(0x0F, 0x64)
#define REG_SC_BK0F_64_H      _PK_H_(0x0F, 0x64)
#define REG_SC_BK0F_65_L      _PK_L_(0x0F, 0x65)
#define REG_SC_BK0F_65_H      _PK_H_(0x0F, 0x65)
#define REG_SC_BK0F_66_L      _PK_L_(0x0F, 0x66)
#define REG_SC_BK0F_66_H      _PK_H_(0x0F, 0x66)
#define REG_SC_BK0F_67_L      _PK_L_(0x0F, 0x67)
#define REG_SC_BK0F_67_H      _PK_H_(0x0F, 0x67)
#define REG_SC_BK0F_68_L      _PK_L_(0x0F, 0x68)
#define REG_SC_BK0F_68_H      _PK_H_(0x0F, 0x68)
#define REG_SC_BK0F_69_L      _PK_L_(0x0F, 0x69)
#define REG_SC_BK0F_69_H      _PK_H_(0x0F, 0x69)
#define REG_SC_BK0F_6A_L      _PK_L_(0x0F, 0x6A)
#define REG_SC_BK0F_6A_H      _PK_H_(0x0F, 0x6A)
#define REG_SC_BK0F_6B_L      _PK_L_(0x0F, 0x6B)
#define REG_SC_BK0F_6B_H      _PK_H_(0x0F, 0x6B)
#define REG_SC_BK0F_6C_L      _PK_L_(0x0F, 0x6C)
#define REG_SC_BK0F_6C_H      _PK_H_(0x0F, 0x6C)
#define REG_SC_BK0F_6D_L      _PK_L_(0x0F, 0x6D)
#define REG_SC_BK0F_6D_H      _PK_H_(0x0F, 0x6D)
#define REG_SC_BK0F_6E_L      _PK_L_(0x0F, 0x6E)
#define REG_SC_BK0F_6E_H      _PK_H_(0x0F, 0x6E)
#define REG_SC_BK0F_6F_L      _PK_L_(0x0F, 0x6F)
#define REG_SC_BK0F_6F_H      _PK_H_(0x0F, 0x6F)
#define REG_SC_BK0F_70_L      _PK_L_(0x0F, 0x70)
#define REG_SC_BK0F_70_H      _PK_H_(0x0F, 0x70)
#define REG_SC_BK0F_71_L      _PK_L_(0x0F, 0x71)
#define REG_SC_BK0F_71_H      _PK_H_(0x0F, 0x71)
#define REG_SC_BK0F_72_L      _PK_L_(0x0F, 0x72)
#define REG_SC_BK0F_72_H      _PK_H_(0x0F, 0x72)
#define REG_SC_BK0F_73_L      _PK_L_(0x0F, 0x73)
#define REG_SC_BK0F_73_H      _PK_H_(0x0F, 0x73)
#define REG_SC_BK0F_74_L      _PK_L_(0x0F, 0x74)
#define REG_SC_BK0F_74_H      _PK_H_(0x0F, 0x74)
#define REG_SC_BK0F_75_L      _PK_L_(0x0F, 0x75)
#define REG_SC_BK0F_75_H      _PK_H_(0x0F, 0x75)
#define REG_SC_BK0F_76_L      _PK_L_(0x0F, 0x76)
#define REG_SC_BK0F_76_H      _PK_H_(0x0F, 0x76)
#define REG_SC_BK0F_77_L      _PK_L_(0x0F, 0x77)
#define REG_SC_BK0F_77_H      _PK_H_(0x0F, 0x77)
#define REG_SC_BK0F_78_L      _PK_L_(0x0F, 0x78)
#define REG_SC_BK0F_78_H      _PK_H_(0x0F, 0x78)
#define REG_SC_BK0F_79_L      _PK_L_(0x0F, 0x79)
#define REG_SC_BK0F_79_H      _PK_H_(0x0F, 0x79)
#define REG_SC_BK0F_7A_L      _PK_L_(0x0F, 0x7A)
#define REG_SC_BK0F_7A_H      _PK_H_(0x0F, 0x7A)
#define REG_SC_BK0F_7B_L      _PK_L_(0x0F, 0x7B)
#define REG_SC_BK0F_7B_H      _PK_H_(0x0F, 0x7B)
#define REG_SC_BK0F_7C_L      _PK_L_(0x0F, 0x7C)
#define REG_SC_BK0F_7C_H      _PK_H_(0x0F, 0x7C)
#define REG_SC_BK0F_7D_L      _PK_L_(0x0F, 0x7D)
#define REG_SC_BK0F_7D_H      _PK_H_(0x0F, 0x7D)
#define REG_SC_BK0F_7E_L      _PK_L_(0x0F, 0x7E)
#define REG_SC_BK0F_7E_H      _PK_H_(0x0F, 0x7E)
#define REG_SC_BK0F_7F_L      _PK_L_(0x0F, 0x7F)
#define REG_SC_BK0F_7F_H      _PK_H_(0x0F, 0x7F)

//----------------------------------------------
//  BK10: VOP
//----------------------------------------------
#define REG_SC_BK10_00_L      _PK_L_(0x10, 0x00)
#define REG_SC_BK10_00_H      _PK_H_(0x10, 0x00)
#define REG_SC_BK10_01_L      _PK_L_(0x10, 0x01)
#define REG_SC_BK10_01_H      _PK_H_(0x10, 0x01)
#define REG_SC_BK10_02_L      _PK_L_(0x10, 0x02)
#define REG_SC_BK10_02_H      _PK_H_(0x10, 0x02)
#define REG_SC_BK10_03_L      _PK_L_(0x10, 0x03)
#define REG_SC_BK10_03_H      _PK_H_(0x10, 0x03)
#define REG_SC_BK10_04_L      _PK_L_(0x10, 0x04)
#define REG_SC_BK10_04_H      _PK_H_(0x10, 0x04)
#define REG_SC_BK10_05_L      _PK_L_(0x10, 0x05)
#define REG_SC_BK10_05_H      _PK_H_(0x10, 0x05)
#define REG_SC_BK10_06_L      _PK_L_(0x10, 0x06)
#define REG_SC_BK10_06_H      _PK_H_(0x10, 0x06)
#define REG_SC_BK10_07_L      _PK_L_(0x10, 0x07)
#define REG_SC_BK10_07_H      _PK_H_(0x10, 0x07)
#define REG_SC_BK10_08_L      _PK_L_(0x10, 0x08)
#define REG_SC_BK10_08_H      _PK_H_(0x10, 0x08)
#define REG_SC_BK10_09_L      _PK_L_(0x10, 0x09)
#define REG_SC_BK10_09_H      _PK_H_(0x10, 0x09)
#define REG_SC_BK10_0A_L      _PK_L_(0x10, 0x0A)
#define REG_SC_BK10_0A_H      _PK_H_(0x10, 0x0A)
#define REG_SC_BK10_0B_L      _PK_L_(0x10, 0x0B)
#define REG_SC_BK10_0B_H      _PK_H_(0x10, 0x0B)
#define REG_SC_BK10_0C_L      _PK_L_(0x10, 0x0C)
#define REG_SC_BK10_0C_H      _PK_H_(0x10, 0x0C)
#define REG_SC_BK10_0D_L      _PK_L_(0x10, 0x0D)
#define REG_SC_BK10_0D_H      _PK_H_(0x10, 0x0D)
#define REG_SC_BK10_0E_L      _PK_L_(0x10, 0x0E)
#define REG_SC_BK10_0E_H      _PK_H_(0x10, 0x0E)
#define REG_SC_BK10_0F_L      _PK_L_(0x10, 0x0F)
#define REG_SC_BK10_0F_H      _PK_H_(0x10, 0x0F)
#define REG_SC_BK10_10_L      _PK_L_(0x10, 0x10)
#define REG_SC_BK10_10_H      _PK_H_(0x10, 0x10)
#define REG_SC_BK10_11_L      _PK_L_(0x10, 0x11)
#define REG_SC_BK10_11_H      _PK_H_(0x10, 0x11)
#define REG_SC_BK10_12_L      _PK_L_(0x10, 0x12)
#define REG_SC_BK10_12_H      _PK_H_(0x10, 0x12)
#define REG_SC_BK10_13_L      _PK_L_(0x10, 0x13)
#define REG_SC_BK10_13_H      _PK_H_(0x10, 0x13)
#define REG_SC_BK10_14_L      _PK_L_(0x10, 0x14)
#define REG_SC_BK10_14_H      _PK_H_(0x10, 0x14)
#define REG_SC_BK10_15_L      _PK_L_(0x10, 0x15)
#define REG_SC_BK10_15_H      _PK_H_(0x10, 0x15)
#define REG_SC_BK10_16_L      _PK_L_(0x10, 0x16)
#define REG_SC_BK10_16_H      _PK_H_(0x10, 0x16)
#define REG_SC_BK10_17_L      _PK_L_(0x10, 0x17)
#define REG_SC_BK10_17_H      _PK_H_(0x10, 0x17)
#define REG_SC_BK10_18_L      _PK_L_(0x10, 0x18)
#define REG_SC_BK10_18_H      _PK_H_(0x10, 0x18)
#define REG_SC_BK10_19_L      _PK_L_(0x10, 0x19)
#define REG_SC_BK10_19_H      _PK_H_(0x10, 0x19)
#define REG_SC_BK10_1A_L      _PK_L_(0x10, 0x1A)
#define REG_SC_BK10_1A_H      _PK_H_(0x10, 0x1A)
#define REG_SC_BK10_1B_L      _PK_L_(0x10, 0x1B)
#define REG_SC_BK10_1B_H      _PK_H_(0x10, 0x1B)
#define REG_SC_BK10_1C_L      _PK_L_(0x10, 0x1C)
#define REG_SC_BK10_1C_H      _PK_H_(0x10, 0x1C)
#define REG_SC_BK10_1D_L      _PK_L_(0x10, 0x1D)
#define REG_SC_BK10_1D_H      _PK_H_(0x10, 0x1D)
#define REG_SC_BK10_1E_L      _PK_L_(0x10, 0x1E)
#define REG_SC_BK10_1E_H      _PK_H_(0x10, 0x1E)
#define REG_SC_BK10_1F_L      _PK_L_(0x10, 0x1F)
#define REG_SC_BK10_1F_H      _PK_H_(0x10, 0x1F)
#define REG_SC_BK10_20_L      _PK_L_(0x10, 0x20)
#define REG_SC_BK10_20_H      _PK_H_(0x10, 0x20)
#define REG_SC_BK10_21_L      _PK_L_(0x10, 0x21)
#define REG_SC_BK10_21_H      _PK_H_(0x10, 0x21)
#define REG_SC_BK10_22_L      _PK_L_(0x10, 0x22)
#define REG_SC_BK10_22_H      _PK_H_(0x10, 0x22)
#define REG_SC_BK10_23_L      _PK_L_(0x10, 0x23)
#define REG_SC_BK10_23_H      _PK_H_(0x10, 0x23)
#define REG_SC_BK10_24_L      _PK_L_(0x10, 0x24)
#define REG_SC_BK10_24_H      _PK_H_(0x10, 0x24)
#define REG_SC_BK10_25_L      _PK_L_(0x10, 0x25)
#define REG_SC_BK10_25_H      _PK_H_(0x10, 0x25)
#define REG_SC_BK10_26_L      _PK_L_(0x10, 0x26)
#define REG_SC_BK10_26_H      _PK_H_(0x10, 0x26)
#define REG_SC_BK10_27_L      _PK_L_(0x10, 0x27)
#define REG_SC_BK10_27_H      _PK_H_(0x10, 0x27)
#define REG_SC_BK10_28_L      _PK_L_(0x10, 0x28)
#define REG_SC_BK10_28_H      _PK_H_(0x10, 0x28)
#define REG_SC_BK10_29_L      _PK_L_(0x10, 0x29)
#define REG_SC_BK10_29_H      _PK_H_(0x10, 0x29)
#define REG_SC_BK10_2A_L      _PK_L_(0x10, 0x2A)
#define REG_SC_BK10_2A_H      _PK_H_(0x10, 0x2A)
#define REG_SC_BK10_2B_L      _PK_L_(0x10, 0x2B)
#define REG_SC_BK10_2B_H      _PK_H_(0x10, 0x2B)
#define REG_SC_BK10_2C_L      _PK_L_(0x10, 0x2C)
#define REG_SC_BK10_2C_H      _PK_H_(0x10, 0x2C)
#define REG_SC_BK10_2D_L      _PK_L_(0x10, 0x2D)
#define REG_SC_BK10_2D_H      _PK_H_(0x10, 0x2D)
#define REG_SC_BK10_2E_L      _PK_L_(0x10, 0x2E)
#define REG_SC_BK10_2E_H      _PK_H_(0x10, 0x2E)
#define REG_SC_BK10_2F_L      _PK_L_(0x10, 0x2F)
#define REG_SC_BK10_2F_H      _PK_H_(0x10, 0x2F)
#define REG_SC_BK10_30_L      _PK_L_(0x10, 0x30)
#define REG_SC_BK10_30_H      _PK_H_(0x10, 0x30)
#define REG_SC_BK10_31_L      _PK_L_(0x10, 0x31)
#define REG_SC_BK10_31_H      _PK_H_(0x10, 0x31)
#define REG_SC_BK10_32_L      _PK_L_(0x10, 0x32)
#define REG_SC_BK10_32_H      _PK_H_(0x10, 0x32)
#define REG_SC_BK10_33_L      _PK_L_(0x10, 0x33)
#define REG_SC_BK10_33_H      _PK_H_(0x10, 0x33)
#define REG_SC_BK10_34_L      _PK_L_(0x10, 0x34)
#define REG_SC_BK10_34_H      _PK_H_(0x10, 0x34)
#define REG_SC_BK10_35_L      _PK_L_(0x10, 0x35)
#define REG_SC_BK10_35_H      _PK_H_(0x10, 0x35)
#define REG_SC_BK10_36_L      _PK_L_(0x10, 0x36)
#define REG_SC_BK10_36_H      _PK_H_(0x10, 0x36)
#define REG_SC_BK10_37_L      _PK_L_(0x10, 0x37)
#define REG_SC_BK10_37_H      _PK_H_(0x10, 0x37)
#define REG_SC_BK10_38_L      _PK_L_(0x10, 0x38)
#define REG_SC_BK10_38_H      _PK_H_(0x10, 0x38)
#define REG_SC_BK10_39_L      _PK_L_(0x10, 0x39)
#define REG_SC_BK10_39_H      _PK_H_(0x10, 0x39)
#define REG_SC_BK10_3A_L      _PK_L_(0x10, 0x3A)
#define REG_SC_BK10_3A_H      _PK_H_(0x10, 0x3A)
#define REG_SC_BK10_3B_L      _PK_L_(0x10, 0x3B)
#define REG_SC_BK10_3B_H      _PK_H_(0x10, 0x3B)
#define REG_SC_BK10_3C_L      _PK_L_(0x10, 0x3C)
#define REG_SC_BK10_3C_H      _PK_H_(0x10, 0x3C)
#define REG_SC_BK10_3D_L      _PK_L_(0x10, 0x3D)
#define REG_SC_BK10_3D_H      _PK_H_(0x10, 0x3D)
#define REG_SC_BK10_3E_L      _PK_L_(0x10, 0x3E)
#define REG_SC_BK10_3E_H      _PK_H_(0x10, 0x3E)
#define REG_SC_BK10_3F_L      _PK_L_(0x10, 0x3F)
#define REG_SC_BK10_3F_H      _PK_H_(0x10, 0x3F)
#define REG_SC_BK10_40_L      _PK_L_(0x10, 0x40)
#define REG_SC_BK10_40_H      _PK_H_(0x10, 0x40)
#define REG_SC_BK10_41_L      _PK_L_(0x10, 0x41)
#define REG_SC_BK10_41_H      _PK_H_(0x10, 0x41)
#define REG_SC_BK10_42_L      _PK_L_(0x10, 0x42)
#define REG_SC_BK10_42_H      _PK_H_(0x10, 0x42)
#define REG_SC_BK10_43_L      _PK_L_(0x10, 0x43)
#define REG_SC_BK10_43_H      _PK_H_(0x10, 0x43)
#define REG_SC_BK10_44_L      _PK_L_(0x10, 0x44)
#define REG_SC_BK10_44_H      _PK_H_(0x10, 0x44)
#define REG_SC_BK10_45_L      _PK_L_(0x10, 0x45)
#define REG_SC_BK10_45_H      _PK_H_(0x10, 0x45)
#define REG_SC_BK10_46_L      _PK_L_(0x10, 0x46)
#define REG_SC_BK10_46_H      _PK_H_(0x10, 0x46)
#define REG_SC_BK10_47_L      _PK_L_(0x10, 0x47)
#define REG_SC_BK10_47_H      _PK_H_(0x10, 0x47)
#define REG_SC_BK10_48_L      _PK_L_(0x10, 0x48)
#define REG_SC_BK10_48_H      _PK_H_(0x10, 0x48)
#define REG_SC_BK10_49_L      _PK_L_(0x10, 0x49)
#define REG_SC_BK10_49_H      _PK_H_(0x10, 0x49)
#define REG_SC_BK10_4A_L      _PK_L_(0x10, 0x4A)
#define REG_SC_BK10_4A_H      _PK_H_(0x10, 0x4A)
#define REG_SC_BK10_4B_L      _PK_L_(0x10, 0x4B)
#define REG_SC_BK10_4B_H      _PK_H_(0x10, 0x4B)
#define REG_SC_BK10_4C_L      _PK_L_(0x10, 0x4C)
#define REG_SC_BK10_4C_H      _PK_H_(0x10, 0x4C)
#define REG_SC_BK10_4D_L      _PK_L_(0x10, 0x4D)
#define REG_SC_BK10_4D_H      _PK_H_(0x10, 0x4D)
#define REG_SC_BK10_4E_L      _PK_L_(0x10, 0x4E)
#define REG_SC_BK10_4E_H      _PK_H_(0x10, 0x4E)
#define REG_SC_BK10_4F_L      _PK_L_(0x10, 0x4F)
#define REG_SC_BK10_4F_H      _PK_H_(0x10, 0x4F)
#define REG_SC_BK10_50_L      _PK_L_(0x10, 0x50)
#define REG_SC_BK10_50_H      _PK_H_(0x10, 0x50)
#define REG_SC_BK10_51_L      _PK_L_(0x10, 0x51)
#define REG_SC_BK10_51_H      _PK_H_(0x10, 0x51)
#define REG_SC_BK10_52_L      _PK_L_(0x10, 0x52)
#define REG_SC_BK10_52_H      _PK_H_(0x10, 0x52)
#define REG_SC_BK10_53_L      _PK_L_(0x10, 0x53)
#define REG_SC_BK10_53_H      _PK_H_(0x10, 0x53)
#define REG_SC_BK10_54_L      _PK_L_(0x10, 0x54)
#define REG_SC_BK10_54_H      _PK_H_(0x10, 0x54)
#define REG_SC_BK10_55_L      _PK_L_(0x10, 0x55)
#define REG_SC_BK10_55_H      _PK_H_(0x10, 0x55)
#define REG_SC_BK10_56_L      _PK_L_(0x10, 0x56)
#define REG_SC_BK10_56_H      _PK_H_(0x10, 0x56)
#define REG_SC_BK10_57_L      _PK_L_(0x10, 0x57)
#define REG_SC_BK10_57_H      _PK_H_(0x10, 0x57)
#define REG_SC_BK10_58_L      _PK_L_(0x10, 0x58)
#define REG_SC_BK10_58_H      _PK_H_(0x10, 0x58)
#define REG_SC_BK10_59_L      _PK_L_(0x10, 0x59)
#define REG_SC_BK10_59_H      _PK_H_(0x10, 0x59)
#define REG_SC_BK10_5A_L      _PK_L_(0x10, 0x5A)
#define REG_SC_BK10_5A_H      _PK_H_(0x10, 0x5A)
#define REG_SC_BK10_5B_L      _PK_L_(0x10, 0x5B)
#define REG_SC_BK10_5B_H      _PK_H_(0x10, 0x5B)
#define REG_SC_BK10_5C_L      _PK_L_(0x10, 0x5C)
#define REG_SC_BK10_5C_H      _PK_H_(0x10, 0x5C)
#define REG_SC_BK10_5D_L      _PK_L_(0x10, 0x5D)
#define REG_SC_BK10_5D_H      _PK_H_(0x10, 0x5D)
#define REG_SC_BK10_5E_L      _PK_L_(0x10, 0x5E)
#define REG_SC_BK10_5E_H      _PK_H_(0x10, 0x5E)
#define REG_SC_BK10_5F_L      _PK_L_(0x10, 0x5F)
#define REG_SC_BK10_5F_H      _PK_H_(0x10, 0x5F)
#define REG_SC_BK10_60_L      _PK_L_(0x10, 0x60)
#define REG_SC_BK10_60_H      _PK_H_(0x10, 0x60)
#define REG_SC_BK10_61_L      _PK_L_(0x10, 0x61)
#define REG_SC_BK10_61_H      _PK_H_(0x10, 0x61)
#define REG_SC_BK10_62_L      _PK_L_(0x10, 0x62)
#define REG_SC_BK10_62_H      _PK_H_(0x10, 0x62)
#define REG_SC_BK10_63_L      _PK_L_(0x10, 0x63)
#define REG_SC_BK10_63_H      _PK_H_(0x10, 0x63)
#define REG_SC_BK10_64_L      _PK_L_(0x10, 0x64)
#define REG_SC_BK10_64_H      _PK_H_(0x10, 0x64)
#define REG_SC_BK10_65_L      _PK_L_(0x10, 0x65)
#define REG_SC_BK10_65_H      _PK_H_(0x10, 0x65)
#define REG_SC_BK10_66_L      _PK_L_(0x10, 0x66)
#define REG_SC_BK10_66_H      _PK_H_(0x10, 0x66)
#define REG_SC_BK10_67_L      _PK_L_(0x10, 0x67)
#define REG_SC_BK10_67_H      _PK_H_(0x10, 0x67)
#define REG_SC_BK10_68_L      _PK_L_(0x10, 0x68)
#define REG_SC_BK10_68_H      _PK_H_(0x10, 0x68)
#define REG_SC_BK10_69_L      _PK_L_(0x10, 0x69)
#define REG_SC_BK10_69_H      _PK_H_(0x10, 0x69)
#define REG_SC_BK10_6A_L      _PK_L_(0x10, 0x6A)
#define REG_SC_BK10_6A_H      _PK_H_(0x10, 0x6A)
#define REG_SC_BK10_6B_L      _PK_L_(0x10, 0x6B)
#define REG_SC_BK10_6B_H      _PK_H_(0x10, 0x6B)
#define REG_SC_BK10_6C_L      _PK_L_(0x10, 0x6C)
#define REG_SC_BK10_6C_H      _PK_H_(0x10, 0x6C)
#define REG_SC_BK10_6D_L      _PK_L_(0x10, 0x6D)
#define REG_SC_BK10_6D_H      _PK_H_(0x10, 0x6D)
#define REG_SC_BK10_6E_L      _PK_L_(0x10, 0x6E)
#define REG_SC_BK10_6E_H      _PK_H_(0x10, 0x6E)
#define REG_SC_BK10_6F_L      _PK_L_(0x10, 0x6F)
#define REG_SC_BK10_6F_H      _PK_H_(0x10, 0x6F)
#define REG_SC_BK10_70_L      _PK_L_(0x10, 0x70)
#define REG_SC_BK10_70_H      _PK_H_(0x10, 0x70)
#define REG_SC_BK10_71_L      _PK_L_(0x10, 0x71)
#define REG_SC_BK10_71_H      _PK_H_(0x10, 0x71)
#define REG_SC_BK10_72_L      _PK_L_(0x10, 0x72)
#define REG_SC_BK10_72_H      _PK_H_(0x10, 0x72)
#define REG_SC_BK10_73_L      _PK_L_(0x10, 0x73)
#define REG_SC_BK10_73_H      _PK_H_(0x10, 0x73)
#define REG_SC_BK10_74_L      _PK_L_(0x10, 0x74)
#define REG_SC_BK10_74_H      _PK_H_(0x10, 0x74)
#define REG_SC_BK10_75_L      _PK_L_(0x10, 0x75)
#define REG_SC_BK10_75_H      _PK_H_(0x10, 0x75)
#define REG_SC_BK10_76_L      _PK_L_(0x10, 0x76)
#define REG_SC_BK10_76_H      _PK_H_(0x10, 0x76)
#define REG_SC_BK10_77_L      _PK_L_(0x10, 0x77)
#define REG_SC_BK10_77_H      _PK_H_(0x10, 0x77)
#define REG_SC_BK10_78_L      _PK_L_(0x10, 0x78)
#define REG_SC_BK10_78_H      _PK_H_(0x10, 0x78)
#define REG_SC_BK10_79_L      _PK_L_(0x10, 0x79)
#define REG_SC_BK10_79_H      _PK_H_(0x10, 0x79)
#define REG_SC_BK10_7A_L      _PK_L_(0x10, 0x7A)
#define REG_SC_BK10_7A_H      _PK_H_(0x10, 0x7A)
#define REG_SC_BK10_7B_L      _PK_L_(0x10, 0x7B)
#define REG_SC_BK10_7B_H      _PK_H_(0x10, 0x7B)
#define REG_SC_BK10_7C_L      _PK_L_(0x10, 0x7C)
#define REG_SC_BK10_7C_H      _PK_H_(0x10, 0x7C)
#define REG_SC_BK10_7D_L      _PK_L_(0x10, 0x7D)
#define REG_SC_BK10_7D_H      _PK_H_(0x10, 0x7D)
#define REG_SC_BK10_7E_L      _PK_L_(0x10, 0x7E)
#define REG_SC_BK10_7E_H      _PK_H_(0x10, 0x7E)
#define REG_SC_BK10_7F_L      _PK_L_(0x10, 0x7F)
#define REG_SC_BK10_7F_H      _PK_H_(0x10, 0x7F)

//----------------------------------------------
//  BK11: TCON
//----------------------------------------------
#define REG_SC_BK11_00_L      _PK_L_(0x11, 0x00)
#define REG_SC_BK11_00_H      _PK_H_(0x11, 0x00)
#define REG_SC_BK11_01_L      _PK_L_(0x11, 0x01)
#define REG_SC_BK11_01_H      _PK_H_(0x11, 0x01)
#define REG_SC_BK11_02_L      _PK_L_(0x11, 0x02)
#define REG_SC_BK11_02_H      _PK_H_(0x11, 0x02)
#define REG_SC_BK11_03_L      _PK_L_(0x11, 0x03)
#define REG_SC_BK11_03_H      _PK_H_(0x11, 0x03)
#define REG_SC_BK11_04_L      _PK_L_(0x11, 0x04)
#define REG_SC_BK11_04_H      _PK_H_(0x11, 0x04)
#define REG_SC_BK11_05_L      _PK_L_(0x11, 0x05)
#define REG_SC_BK11_05_H      _PK_H_(0x11, 0x05)
#define REG_SC_BK11_06_L      _PK_L_(0x11, 0x06)
#define REG_SC_BK11_06_H      _PK_H_(0x11, 0x06)
#define REG_SC_BK11_07_L      _PK_L_(0x11, 0x07)
#define REG_SC_BK11_07_H      _PK_H_(0x11, 0x07)
#define REG_SC_BK11_08_L      _PK_L_(0x11, 0x08)
#define REG_SC_BK11_08_H      _PK_H_(0x11, 0x08)
#define REG_SC_BK11_09_L      _PK_L_(0x11, 0x09)
#define REG_SC_BK11_09_H      _PK_H_(0x11, 0x09)
#define REG_SC_BK11_0A_L      _PK_L_(0x11, 0x0A)
#define REG_SC_BK11_0A_H      _PK_H_(0x11, 0x0A)
#define REG_SC_BK11_0B_L      _PK_L_(0x11, 0x0B)
#define REG_SC_BK11_0B_H      _PK_H_(0x11, 0x0B)
#define REG_SC_BK11_0C_L      _PK_L_(0x11, 0x0C)
#define REG_SC_BK11_0C_H      _PK_H_(0x11, 0x0C)
#define REG_SC_BK11_0D_L      _PK_L_(0x11, 0x0D)
#define REG_SC_BK11_0D_H      _PK_H_(0x11, 0x0D)
#define REG_SC_BK11_0E_L      _PK_L_(0x11, 0x0E)
#define REG_SC_BK11_0E_H      _PK_H_(0x11, 0x0E)
#define REG_SC_BK11_0F_L      _PK_L_(0x11, 0x0F)
#define REG_SC_BK11_0F_H      _PK_H_(0x11, 0x0F)
#define REG_SC_BK11_10_L      _PK_L_(0x11, 0x10)
#define REG_SC_BK11_10_H      _PK_H_(0x11, 0x10)
#define REG_SC_BK11_11_L      _PK_L_(0x11, 0x11)
#define REG_SC_BK11_11_H      _PK_H_(0x11, 0x11)
#define REG_SC_BK11_12_L      _PK_L_(0x11, 0x12)
#define REG_SC_BK11_12_H      _PK_H_(0x11, 0x12)
#define REG_SC_BK11_13_L      _PK_L_(0x11, 0x13)
#define REG_SC_BK11_13_H      _PK_H_(0x11, 0x13)
#define REG_SC_BK11_14_L      _PK_L_(0x11, 0x14)
#define REG_SC_BK11_14_H      _PK_H_(0x11, 0x14)
#define REG_SC_BK11_15_L      _PK_L_(0x11, 0x15)
#define REG_SC_BK11_15_H      _PK_H_(0x11, 0x15)
#define REG_SC_BK11_16_L      _PK_L_(0x11, 0x16)
#define REG_SC_BK11_16_H      _PK_H_(0x11, 0x16)
#define REG_SC_BK11_17_L      _PK_L_(0x11, 0x17)
#define REG_SC_BK11_17_H      _PK_H_(0x11, 0x17)
#define REG_SC_BK11_18_L      _PK_L_(0x11, 0x18)
#define REG_SC_BK11_18_H      _PK_H_(0x11, 0x18)
#define REG_SC_BK11_19_L      _PK_L_(0x11, 0x19)
#define REG_SC_BK11_19_H      _PK_H_(0x11, 0x19)
#define REG_SC_BK11_1A_L      _PK_L_(0x11, 0x1A)
#define REG_SC_BK11_1A_H      _PK_H_(0x11, 0x1A)
#define REG_SC_BK11_1B_L      _PK_L_(0x11, 0x1B)
#define REG_SC_BK11_1B_H      _PK_H_(0x11, 0x1B)
#define REG_SC_BK11_1C_L      _PK_L_(0x11, 0x1C)
#define REG_SC_BK11_1C_H      _PK_H_(0x11, 0x1C)
#define REG_SC_BK11_1D_L      _PK_L_(0x11, 0x1D)
#define REG_SC_BK11_1D_H      _PK_H_(0x11, 0x1D)
#define REG_SC_BK11_1E_L      _PK_L_(0x11, 0x1E)
#define REG_SC_BK11_1E_H      _PK_H_(0x11, 0x1E)
#define REG_SC_BK11_1F_L      _PK_L_(0x11, 0x1F)
#define REG_SC_BK11_1F_H      _PK_H_(0x11, 0x1F)
#define REG_SC_BK11_20_L      _PK_L_(0x11, 0x20)
#define REG_SC_BK11_20_H      _PK_H_(0x11, 0x20)
#define REG_SC_BK11_21_L      _PK_L_(0x11, 0x21)
#define REG_SC_BK11_21_H      _PK_H_(0x11, 0x21)
#define REG_SC_BK11_22_L      _PK_L_(0x11, 0x22)
#define REG_SC_BK11_22_H      _PK_H_(0x11, 0x22)
#define REG_SC_BK11_23_L      _PK_L_(0x11, 0x23)
#define REG_SC_BK11_23_H      _PK_H_(0x11, 0x23)
#define REG_SC_BK11_24_L      _PK_L_(0x11, 0x24)
#define REG_SC_BK11_24_H      _PK_H_(0x11, 0x24)
#define REG_SC_BK11_25_L      _PK_L_(0x11, 0x25)
#define REG_SC_BK11_25_H      _PK_H_(0x11, 0x25)
#define REG_SC_BK11_26_L      _PK_L_(0x11, 0x26)
#define REG_SC_BK11_26_H      _PK_H_(0x11, 0x26)
#define REG_SC_BK11_27_L      _PK_L_(0x11, 0x27)
#define REG_SC_BK11_27_H      _PK_H_(0x11, 0x27)
#define REG_SC_BK11_28_L      _PK_L_(0x11, 0x28)
#define REG_SC_BK11_28_H      _PK_H_(0x11, 0x28)
#define REG_SC_BK11_29_L      _PK_L_(0x11, 0x29)
#define REG_SC_BK11_29_H      _PK_H_(0x11, 0x29)
#define REG_SC_BK11_2A_L      _PK_L_(0x11, 0x2A)
#define REG_SC_BK11_2A_H      _PK_H_(0x11, 0x2A)
#define REG_SC_BK11_2B_L      _PK_L_(0x11, 0x2B)
#define REG_SC_BK11_2B_H      _PK_H_(0x11, 0x2B)
#define REG_SC_BK11_2C_L      _PK_L_(0x11, 0x2C)
#define REG_SC_BK11_2C_H      _PK_H_(0x11, 0x2C)
#define REG_SC_BK11_2D_L      _PK_L_(0x11, 0x2D)
#define REG_SC_BK11_2D_H      _PK_H_(0x11, 0x2D)
#define REG_SC_BK11_2E_L      _PK_L_(0x11, 0x2E)
#define REG_SC_BK11_2E_H      _PK_H_(0x11, 0x2E)
#define REG_SC_BK11_2F_L      _PK_L_(0x11, 0x2F)
#define REG_SC_BK11_2F_H      _PK_H_(0x11, 0x2F)
#define REG_SC_BK11_30_L      _PK_L_(0x11, 0x30)
#define REG_SC_BK11_30_H      _PK_H_(0x11, 0x30)
#define REG_SC_BK11_31_L      _PK_L_(0x11, 0x31)
#define REG_SC_BK11_31_H      _PK_H_(0x11, 0x31)
#define REG_SC_BK11_32_L      _PK_L_(0x11, 0x32)
#define REG_SC_BK11_32_H      _PK_H_(0x11, 0x32)
#define REG_SC_BK11_33_L      _PK_L_(0x11, 0x33)
#define REG_SC_BK11_33_H      _PK_H_(0x11, 0x33)
#define REG_SC_BK11_34_L      _PK_L_(0x11, 0x34)
#define REG_SC_BK11_34_H      _PK_H_(0x11, 0x34)
#define REG_SC_BK11_35_L      _PK_L_(0x11, 0x35)
#define REG_SC_BK11_35_H      _PK_H_(0x11, 0x35)
#define REG_SC_BK11_36_L      _PK_L_(0x11, 0x36)
#define REG_SC_BK11_36_H      _PK_H_(0x11, 0x36)
#define REG_SC_BK11_37_L      _PK_L_(0x11, 0x37)
#define REG_SC_BK11_37_H      _PK_H_(0x11, 0x37)
#define REG_SC_BK11_38_L      _PK_L_(0x11, 0x38)
#define REG_SC_BK11_38_H      _PK_H_(0x11, 0x38)
#define REG_SC_BK11_39_L      _PK_L_(0x11, 0x39)
#define REG_SC_BK11_39_H      _PK_H_(0x11, 0x39)
#define REG_SC_BK11_3A_L      _PK_L_(0x11, 0x3A)
#define REG_SC_BK11_3A_H      _PK_H_(0x11, 0x3A)
#define REG_SC_BK11_3B_L      _PK_L_(0x11, 0x3B)
#define REG_SC_BK11_3B_H      _PK_H_(0x11, 0x3B)
#define REG_SC_BK11_3C_L      _PK_L_(0x11, 0x3C)
#define REG_SC_BK11_3C_H      _PK_H_(0x11, 0x3C)
#define REG_SC_BK11_3D_L      _PK_L_(0x11, 0x3D)
#define REG_SC_BK11_3D_H      _PK_H_(0x11, 0x3D)
#define REG_SC_BK11_3E_L      _PK_L_(0x11, 0x3E)
#define REG_SC_BK11_3E_H      _PK_H_(0x11, 0x3E)
#define REG_SC_BK11_3F_L      _PK_L_(0x11, 0x3F)
#define REG_SC_BK11_3F_H      _PK_H_(0x11, 0x3F)
#define REG_SC_BK11_40_L      _PK_L_(0x11, 0x40)
#define REG_SC_BK11_40_H      _PK_H_(0x11, 0x40)
#define REG_SC_BK11_41_L      _PK_L_(0x11, 0x41)
#define REG_SC_BK11_41_H      _PK_H_(0x11, 0x41)
#define REG_SC_BK11_42_L      _PK_L_(0x11, 0x42)
#define REG_SC_BK11_42_H      _PK_H_(0x11, 0x42)
#define REG_SC_BK11_43_L      _PK_L_(0x11, 0x43)
#define REG_SC_BK11_43_H      _PK_H_(0x11, 0x43)
#define REG_SC_BK11_44_L      _PK_L_(0x11, 0x44)
#define REG_SC_BK11_44_H      _PK_H_(0x11, 0x44)
#define REG_SC_BK11_45_L      _PK_L_(0x11, 0x45)
#define REG_SC_BK11_45_H      _PK_H_(0x11, 0x45)
#define REG_SC_BK11_46_L      _PK_L_(0x11, 0x46)
#define REG_SC_BK11_46_H      _PK_H_(0x11, 0x46)
#define REG_SC_BK11_47_L      _PK_L_(0x11, 0x47)
#define REG_SC_BK11_47_H      _PK_H_(0x11, 0x47)
#define REG_SC_BK11_48_L      _PK_L_(0x11, 0x48)
#define REG_SC_BK11_48_H      _PK_H_(0x11, 0x48)
#define REG_SC_BK11_49_L      _PK_L_(0x11, 0x49)
#define REG_SC_BK11_49_H      _PK_H_(0x11, 0x49)
#define REG_SC_BK11_4A_L      _PK_L_(0x11, 0x4A)
#define REG_SC_BK11_4A_H      _PK_H_(0x11, 0x4A)
#define REG_SC_BK11_4B_L      _PK_L_(0x11, 0x4B)
#define REG_SC_BK11_4B_H      _PK_H_(0x11, 0x4B)
#define REG_SC_BK11_4C_L      _PK_L_(0x11, 0x4C)
#define REG_SC_BK11_4C_H      _PK_H_(0x11, 0x4C)
#define REG_SC_BK11_4D_L      _PK_L_(0x11, 0x4D)
#define REG_SC_BK11_4D_H      _PK_H_(0x11, 0x4D)
#define REG_SC_BK11_4E_L      _PK_L_(0x11, 0x4E)
#define REG_SC_BK11_4E_H      _PK_H_(0x11, 0x4E)
#define REG_SC_BK11_4F_L      _PK_L_(0x11, 0x4F)
#define REG_SC_BK11_4F_H      _PK_H_(0x11, 0x4F)
#define REG_SC_BK11_50_L      _PK_L_(0x11, 0x50)
#define REG_SC_BK11_50_H      _PK_H_(0x11, 0x50)
#define REG_SC_BK11_51_L      _PK_L_(0x11, 0x51)
#define REG_SC_BK11_51_H      _PK_H_(0x11, 0x51)
#define REG_SC_BK11_52_L      _PK_L_(0x11, 0x52)
#define REG_SC_BK11_52_H      _PK_H_(0x11, 0x52)
#define REG_SC_BK11_53_L      _PK_L_(0x11, 0x53)
#define REG_SC_BK11_53_H      _PK_H_(0x11, 0x53)
#define REG_SC_BK11_54_L      _PK_L_(0x11, 0x54)
#define REG_SC_BK11_54_H      _PK_H_(0x11, 0x54)
#define REG_SC_BK11_55_L      _PK_L_(0x11, 0x55)
#define REG_SC_BK11_55_H      _PK_H_(0x11, 0x55)
#define REG_SC_BK11_56_L      _PK_L_(0x11, 0x56)
#define REG_SC_BK11_56_H      _PK_H_(0x11, 0x56)
#define REG_SC_BK11_57_L      _PK_L_(0x11, 0x57)
#define REG_SC_BK11_57_H      _PK_H_(0x11, 0x57)
#define REG_SC_BK11_58_L      _PK_L_(0x11, 0x58)
#define REG_SC_BK11_58_H      _PK_H_(0x11, 0x58)
#define REG_SC_BK11_59_L      _PK_L_(0x11, 0x59)
#define REG_SC_BK11_59_H      _PK_H_(0x11, 0x59)
#define REG_SC_BK11_5A_L      _PK_L_(0x11, 0x5A)
#define REG_SC_BK11_5A_H      _PK_H_(0x11, 0x5A)
#define REG_SC_BK11_5B_L      _PK_L_(0x11, 0x5B)
#define REG_SC_BK11_5B_H      _PK_H_(0x11, 0x5B)
#define REG_SC_BK11_5C_L      _PK_L_(0x11, 0x5C)
#define REG_SC_BK11_5C_H      _PK_H_(0x11, 0x5C)
#define REG_SC_BK11_5D_L      _PK_L_(0x11, 0x5D)
#define REG_SC_BK11_5D_H      _PK_H_(0x11, 0x5D)
#define REG_SC_BK11_5E_L      _PK_L_(0x11, 0x5E)
#define REG_SC_BK11_5E_H      _PK_H_(0x11, 0x5E)
#define REG_SC_BK11_5F_L      _PK_L_(0x11, 0x5F)
#define REG_SC_BK11_5F_H      _PK_H_(0x11, 0x5F)
#define REG_SC_BK11_60_L      _PK_L_(0x11, 0x60)
#define REG_SC_BK11_60_H      _PK_H_(0x11, 0x60)
#define REG_SC_BK11_61_L      _PK_L_(0x11, 0x61)
#define REG_SC_BK11_61_H      _PK_H_(0x11, 0x61)
#define REG_SC_BK11_62_L      _PK_L_(0x11, 0x62)
#define REG_SC_BK11_62_H      _PK_H_(0x11, 0x62)
#define REG_SC_BK11_63_L      _PK_L_(0x11, 0x63)
#define REG_SC_BK11_63_H      _PK_H_(0x11, 0x63)
#define REG_SC_BK11_64_L      _PK_L_(0x11, 0x64)
#define REG_SC_BK11_64_H      _PK_H_(0x11, 0x64)
#define REG_SC_BK11_65_L      _PK_L_(0x11, 0x65)
#define REG_SC_BK11_65_H      _PK_H_(0x11, 0x65)
#define REG_SC_BK11_66_L      _PK_L_(0x11, 0x66)
#define REG_SC_BK11_66_H      _PK_H_(0x11, 0x66)
#define REG_SC_BK11_67_L      _PK_L_(0x11, 0x67)
#define REG_SC_BK11_67_H      _PK_H_(0x11, 0x67)
#define REG_SC_BK11_68_L      _PK_L_(0x11, 0x68)
#define REG_SC_BK11_68_H      _PK_H_(0x11, 0x68)
#define REG_SC_BK11_69_L      _PK_L_(0x11, 0x69)
#define REG_SC_BK11_69_H      _PK_H_(0x11, 0x69)
#define REG_SC_BK11_6A_L      _PK_L_(0x11, 0x6A)
#define REG_SC_BK11_6A_H      _PK_H_(0x11, 0x6A)
#define REG_SC_BK11_6B_L      _PK_L_(0x11, 0x6B)
#define REG_SC_BK11_6B_H      _PK_H_(0x11, 0x6B)
#define REG_SC_BK11_6C_L      _PK_L_(0x11, 0x6C)
#define REG_SC_BK11_6C_H      _PK_H_(0x11, 0x6C)
#define REG_SC_BK11_6D_L      _PK_L_(0x11, 0x6D)
#define REG_SC_BK11_6D_H      _PK_H_(0x11, 0x6D)
#define REG_SC_BK11_6E_L      _PK_L_(0x11, 0x6E)
#define REG_SC_BK11_6E_H      _PK_H_(0x11, 0x6E)
#define REG_SC_BK11_6F_L      _PK_L_(0x11, 0x6F)
#define REG_SC_BK11_6F_H      _PK_H_(0x11, 0x6F)
#define REG_SC_BK11_70_L      _PK_L_(0x11, 0x70)
#define REG_SC_BK11_70_H      _PK_H_(0x11, 0x70)
#define REG_SC_BK11_71_L      _PK_L_(0x11, 0x71)
#define REG_SC_BK11_71_H      _PK_H_(0x11, 0x71)
#define REG_SC_BK11_72_L      _PK_L_(0x11, 0x72)
#define REG_SC_BK11_72_H      _PK_H_(0x11, 0x72)
#define REG_SC_BK11_73_L      _PK_L_(0x11, 0x73)
#define REG_SC_BK11_73_H      _PK_H_(0x11, 0x73)
#define REG_SC_BK11_74_L      _PK_L_(0x11, 0x74)
#define REG_SC_BK11_74_H      _PK_H_(0x11, 0x74)
#define REG_SC_BK11_75_L      _PK_L_(0x11, 0x75)
#define REG_SC_BK11_75_H      _PK_H_(0x11, 0x75)
#define REG_SC_BK11_76_L      _PK_L_(0x11, 0x76)
#define REG_SC_BK11_76_H      _PK_H_(0x11, 0x76)
#define REG_SC_BK11_77_L      _PK_L_(0x11, 0x77)
#define REG_SC_BK11_77_H      _PK_H_(0x11, 0x77)
#define REG_SC_BK11_78_L      _PK_L_(0x11, 0x78)
#define REG_SC_BK11_78_H      _PK_H_(0x11, 0x78)
#define REG_SC_BK11_79_L      _PK_L_(0x11, 0x79)
#define REG_SC_BK11_79_H      _PK_H_(0x11, 0x79)
#define REG_SC_BK11_7A_L      _PK_L_(0x11, 0x7A)
#define REG_SC_BK11_7A_H      _PK_H_(0x11, 0x7A)
#define REG_SC_BK11_7B_L      _PK_L_(0x11, 0x7B)
#define REG_SC_BK11_7B_H      _PK_H_(0x11, 0x7B)
#define REG_SC_BK11_7C_L      _PK_L_(0x11, 0x7C)
#define REG_SC_BK11_7C_H      _PK_H_(0x11, 0x7C)
#define REG_SC_BK11_7D_L      _PK_L_(0x11, 0x7D)
#define REG_SC_BK11_7D_H      _PK_H_(0x11, 0x7D)
#define REG_SC_BK11_7E_L      _PK_L_(0x11, 0x7E)
#define REG_SC_BK11_7E_H      _PK_H_(0x11, 0x7E)
#define REG_SC_BK11_7F_L      _PK_L_(0x11, 0x7F)
#define REG_SC_BK11_7F_H      _PK_H_(0x11, 0x7F)



//----------------------------------------------
//  BK12
//----------------------------------------------
#define REG_SC_BK12_00_L      _PK_L_(0x12, 0x00)
#define REG_SC_BK12_00_H      _PK_H_(0x12, 0x00)
#define REG_SC_BK12_01_L      _PK_L_(0x12, 0x01)
#define REG_SC_BK12_01_H      _PK_H_(0x12, 0x01)
#define REG_SC_BK12_02_L      _PK_L_(0x12, 0x02)
#define REG_SC_BK12_02_H      _PK_H_(0x12, 0x02)
#define REG_SC_BK12_03_L      _PK_L_(0x12, 0x03)
#define REG_SC_BK12_03_H      _PK_H_(0x12, 0x03)
#define REG_SC_BK12_04_L      _PK_L_(0x12, 0x04)
#define REG_SC_BK12_04_H      _PK_H_(0x12, 0x04)
#define REG_SC_BK12_05_L      _PK_L_(0x12, 0x05)
#define REG_SC_BK12_05_H      _PK_H_(0x12, 0x05)
#define REG_SC_BK12_06_L      _PK_L_(0x12, 0x06)
#define REG_SC_BK12_06_H      _PK_H_(0x12, 0x06)
#define REG_SC_BK12_07_L      _PK_L_(0x12, 0x07)
#define REG_SC_BK12_07_H      _PK_H_(0x12, 0x07)
#define REG_SC_BK12_08_L      _PK_L_(0x12, 0x08)
#define REG_SC_BK12_08_H      _PK_H_(0x12, 0x08)
#define REG_SC_BK12_09_L      _PK_L_(0x12, 0x09)
#define REG_SC_BK12_09_H      _PK_H_(0x12, 0x09)
#define REG_SC_BK12_0A_L      _PK_L_(0x12, 0x0A)
#define REG_SC_BK12_0A_H      _PK_H_(0x12, 0x0A)
#define REG_SC_BK12_0B_L      _PK_L_(0x12, 0x0B)
#define REG_SC_BK12_0B_H      _PK_H_(0x12, 0x0B)
#define REG_SC_BK12_0C_L      _PK_L_(0x12, 0x0C)
#define REG_SC_BK12_0C_H      _PK_H_(0x12, 0x0C)
#define REG_SC_BK12_0D_L      _PK_L_(0x12, 0x0D)
#define REG_SC_BK12_0D_H      _PK_H_(0x12, 0x0D)
#define REG_SC_BK12_0E_L      _PK_L_(0x12, 0x0E)
#define REG_SC_BK12_0E_H      _PK_H_(0x12, 0x0E)
#define REG_SC_BK12_0F_L      _PK_L_(0x12, 0x0F)
#define REG_SC_BK12_0F_H      _PK_H_(0x12, 0x0F)
#define REG_SC_BK12_10_L      _PK_L_(0x12, 0x10)
#define REG_SC_BK12_10_H      _PK_H_(0x12, 0x10)
#define REG_SC_BK12_11_L      _PK_L_(0x12, 0x11)
#define REG_SC_BK12_11_H      _PK_H_(0x12, 0x11)
#define REG_SC_BK12_12_L      _PK_L_(0x12, 0x12)
#define REG_SC_BK12_12_H      _PK_H_(0x12, 0x12)
#define REG_SC_BK12_13_L      _PK_L_(0x12, 0x13)
#define REG_SC_BK12_13_H      _PK_H_(0x12, 0x13)
#define REG_SC_BK12_14_L      _PK_L_(0x12, 0x14)
#define REG_SC_BK12_14_H      _PK_H_(0x12, 0x14)
#define REG_SC_BK12_15_L      _PK_L_(0x12, 0x15)
#define REG_SC_BK12_15_H      _PK_H_(0x12, 0x15)
#define REG_SC_BK12_16_L      _PK_L_(0x12, 0x16)
#define REG_SC_BK12_16_H      _PK_H_(0x12, 0x16)
#define REG_SC_BK12_17_L      _PK_L_(0x12, 0x17)
#define REG_SC_BK12_17_H      _PK_H_(0x12, 0x17)
#define REG_SC_BK12_18_L      _PK_L_(0x12, 0x18)
#define REG_SC_BK12_18_H      _PK_H_(0x12, 0x18)
#define REG_SC_BK12_19_L      _PK_L_(0x12, 0x19)
#define REG_SC_BK12_19_H      _PK_H_(0x12, 0x19)
#define REG_SC_BK12_1A_L      _PK_L_(0x12, 0x1A)
#define REG_SC_BK12_1A_H      _PK_H_(0x12, 0x1A)
#define REG_SC_BK12_1B_L      _PK_L_(0x12, 0x1B)
#define REG_SC_BK12_1B_H      _PK_H_(0x12, 0x1B)
#define REG_SC_BK12_1C_L      _PK_L_(0x12, 0x1C)
#define REG_SC_BK12_1C_H      _PK_H_(0x12, 0x1C)
#define REG_SC_BK12_1D_L      _PK_L_(0x12, 0x1D)
#define REG_SC_BK12_1D_H      _PK_H_(0x12, 0x1D)
#define REG_SC_BK12_1E_L      _PK_L_(0x12, 0x1E)
#define REG_SC_BK12_1E_H      _PK_H_(0x12, 0x1E)
#define REG_SC_BK12_1F_L      _PK_L_(0x12, 0x1F)
#define REG_SC_BK12_1F_H      _PK_H_(0x12, 0x1F)
#define REG_SC_BK12_20_L      _PK_L_(0x12, 0x20)
#define REG_SC_BK12_20_H      _PK_H_(0x12, 0x20)
#define REG_SC_BK12_21_L      _PK_L_(0x12, 0x21)
#define REG_SC_BK12_21_H      _PK_H_(0x12, 0x21)
#define REG_SC_BK12_22_L      _PK_L_(0x12, 0x22)
#define REG_SC_BK12_22_H      _PK_H_(0x12, 0x22)
#define REG_SC_BK12_23_L      _PK_L_(0x12, 0x23)
#define REG_SC_BK12_23_H      _PK_H_(0x12, 0x23)
#define REG_SC_BK12_24_L      _PK_L_(0x12, 0x24)
#define REG_SC_BK12_24_H      _PK_H_(0x12, 0x24)
#define REG_SC_BK12_25_L      _PK_L_(0x12, 0x25)
#define REG_SC_BK12_25_H      _PK_H_(0x12, 0x25)
#define REG_SC_BK12_26_L      _PK_L_(0x12, 0x26)
#define REG_SC_BK12_26_H      _PK_H_(0x12, 0x26)
#define REG_SC_BK12_27_L      _PK_L_(0x12, 0x27)
#define REG_SC_BK12_27_H      _PK_H_(0x12, 0x27)
#define REG_SC_BK12_28_L      _PK_L_(0x12, 0x28)
#define REG_SC_BK12_28_H      _PK_H_(0x12, 0x28)
#define REG_SC_BK12_29_L      _PK_L_(0x12, 0x29)
#define REG_SC_BK12_29_H      _PK_H_(0x12, 0x29)
#define REG_SC_BK12_2A_L      _PK_L_(0x12, 0x2A)
#define REG_SC_BK12_2A_H      _PK_H_(0x12, 0x2A)
#define REG_SC_BK12_2B_L      _PK_L_(0x12, 0x2B)
#define REG_SC_BK12_2B_H      _PK_H_(0x12, 0x2B)
#define REG_SC_BK12_2C_L      _PK_L_(0x12, 0x2C)
#define REG_SC_BK12_2C_H      _PK_H_(0x12, 0x2C)
#define REG_SC_BK12_2D_L      _PK_L_(0x12, 0x2D)
#define REG_SC_BK12_2D_H      _PK_H_(0x12, 0x2D)
#define REG_SC_BK12_2E_L      _PK_L_(0x12, 0x2E)
#define REG_SC_BK12_2E_H      _PK_H_(0x12, 0x2E)
#define REG_SC_BK12_2F_L      _PK_L_(0x12, 0x2F)
#define REG_SC_BK12_2F_H      _PK_H_(0x12, 0x2F)
#define REG_SC_BK12_30_L      _PK_L_(0x12, 0x30)
#define REG_SC_BK12_30_H      _PK_H_(0x12, 0x30)
#define REG_SC_BK12_31_L      _PK_L_(0x12, 0x31)
#define REG_SC_BK12_31_H      _PK_H_(0x12, 0x31)
#define REG_SC_BK12_32_L      _PK_L_(0x12, 0x32)
#define REG_SC_BK12_32_H      _PK_H_(0x12, 0x32)
#define REG_SC_BK12_33_L      _PK_L_(0x12, 0x33)
#define REG_SC_BK12_33_H      _PK_H_(0x12, 0x33)
#define REG_SC_BK12_34_L      _PK_L_(0x12, 0x34)
#define REG_SC_BK12_34_H      _PK_H_(0x12, 0x34)
#define REG_SC_BK12_35_L      _PK_L_(0x12, 0x35)
#define REG_SC_BK12_35_H      _PK_H_(0x12, 0x35)
#define REG_SC_BK12_36_L      _PK_L_(0x12, 0x36)
#define REG_SC_BK12_36_H      _PK_H_(0x12, 0x36)
#define REG_SC_BK12_37_L      _PK_L_(0x12, 0x37)
#define REG_SC_BK12_37_H      _PK_H_(0x12, 0x37)
#define REG_SC_BK12_38_L      _PK_L_(0x12, 0x38)
#define REG_SC_BK12_38_H      _PK_H_(0x12, 0x38)
#define REG_SC_BK12_39_L      _PK_L_(0x12, 0x39)
#define REG_SC_BK12_39_H      _PK_H_(0x12, 0x39)
#define REG_SC_BK12_3A_L      _PK_L_(0x12, 0x3A)
#define REG_SC_BK12_3A_H      _PK_H_(0x12, 0x3A)
#define REG_SC_BK12_3B_L      _PK_L_(0x12, 0x3B)
#define REG_SC_BK12_3B_H      _PK_H_(0x12, 0x3B)
#define REG_SC_BK12_3C_L      _PK_L_(0x12, 0x3C)
#define REG_SC_BK12_3C_H      _PK_H_(0x12, 0x3C)
#define REG_SC_BK12_3D_L      _PK_L_(0x12, 0x3D)
#define REG_SC_BK12_3D_H      _PK_H_(0x12, 0x3D)
#define REG_SC_BK12_3E_L      _PK_L_(0x12, 0x3E)
#define REG_SC_BK12_3E_H      _PK_H_(0x12, 0x3E)
#define REG_SC_BK12_3F_L      _PK_L_(0x12, 0x3F)
#define REG_SC_BK12_3F_H      _PK_H_(0x12, 0x3F)
#define REG_SC_BK12_40_L      _PK_L_(0x12, 0x40)
#define REG_SC_BK12_40_H      _PK_H_(0x12, 0x40)
#define REG_SC_BK12_41_L      _PK_L_(0x12, 0x41)
#define REG_SC_BK12_41_H      _PK_H_(0x12, 0x41)
#define REG_SC_BK12_42_L      _PK_L_(0x12, 0x42)
#define REG_SC_BK12_42_H      _PK_H_(0x12, 0x42)
#define REG_SC_BK12_43_L      _PK_L_(0x12, 0x43)
#define REG_SC_BK12_43_H      _PK_H_(0x12, 0x43)
#define REG_SC_BK12_44_L      _PK_L_(0x12, 0x44)
#define REG_SC_BK12_44_H      _PK_H_(0x12, 0x44)
#define REG_SC_BK12_45_L      _PK_L_(0x12, 0x45)
#define REG_SC_BK12_45_H      _PK_H_(0x12, 0x45)
#define REG_SC_BK12_46_L      _PK_L_(0x12, 0x46)
#define REG_SC_BK12_46_H      _PK_H_(0x12, 0x46)
#define REG_SC_BK12_47_L      _PK_L_(0x12, 0x47)
#define REG_SC_BK12_47_H      _PK_H_(0x12, 0x47)
#define REG_SC_BK12_48_L      _PK_L_(0x12, 0x48)
#define REG_SC_BK12_48_H      _PK_H_(0x12, 0x48)
#define REG_SC_BK12_49_L      _PK_L_(0x12, 0x49)
#define REG_SC_BK12_49_H      _PK_H_(0x12, 0x49)
#define REG_SC_BK12_4A_L      _PK_L_(0x12, 0x4A)
#define REG_SC_BK12_4A_H      _PK_H_(0x12, 0x4A)
#define REG_SC_BK12_4B_L      _PK_L_(0x12, 0x4B)
#define REG_SC_BK12_4B_H      _PK_H_(0x12, 0x4B)
#define REG_SC_BK12_4C_L      _PK_L_(0x12, 0x4C)
#define REG_SC_BK12_4C_H      _PK_H_(0x12, 0x4C)
#define REG_SC_BK12_4D_L      _PK_L_(0x12, 0x4D)
#define REG_SC_BK12_4D_H      _PK_H_(0x12, 0x4D)
#define REG_SC_BK12_4E_L      _PK_L_(0x12, 0x4E)
#define REG_SC_BK12_4E_H      _PK_H_(0x12, 0x4E)
#define REG_SC_BK12_4F_L      _PK_L_(0x12, 0x4F)
#define REG_SC_BK12_4F_H      _PK_H_(0x12, 0x4F)
#define REG_SC_BK12_50_L      _PK_L_(0x12, 0x50)
#define REG_SC_BK12_50_H      _PK_H_(0x12, 0x50)
#define REG_SC_BK12_51_L      _PK_L_(0x12, 0x51)
#define REG_SC_BK12_51_H      _PK_H_(0x12, 0x51)
#define REG_SC_BK12_52_L      _PK_L_(0x12, 0x52)
#define REG_SC_BK12_52_H      _PK_H_(0x12, 0x52)
#define REG_SC_BK12_53_L      _PK_L_(0x12, 0x53)
#define REG_SC_BK12_53_H      _PK_H_(0x12, 0x53)
#define REG_SC_BK12_54_L      _PK_L_(0x12, 0x54)
#define REG_SC_BK12_54_H      _PK_H_(0x12, 0x54)
#define REG_SC_BK12_55_L      _PK_L_(0x12, 0x55)
#define REG_SC_BK12_55_H      _PK_H_(0x12, 0x55)
#define REG_SC_BK12_56_L      _PK_L_(0x12, 0x56)
#define REG_SC_BK12_56_H      _PK_H_(0x12, 0x56)
#define REG_SC_BK12_57_L      _PK_L_(0x12, 0x57)
#define REG_SC_BK12_57_H      _PK_H_(0x12, 0x57)
#define REG_SC_BK12_58_L      _PK_L_(0x12, 0x58)
#define REG_SC_BK12_58_H      _PK_H_(0x12, 0x58)
#define REG_SC_BK12_59_L      _PK_L_(0x12, 0x59)
#define REG_SC_BK12_59_H      _PK_H_(0x12, 0x59)
#define REG_SC_BK12_5A_L      _PK_L_(0x12, 0x5A)
#define REG_SC_BK12_5A_H      _PK_H_(0x12, 0x5A)
#define REG_SC_BK12_5B_L      _PK_L_(0x12, 0x5B)
#define REG_SC_BK12_5B_H      _PK_H_(0x12, 0x5B)
#define REG_SC_BK12_5C_L      _PK_L_(0x12, 0x5C)
#define REG_SC_BK12_5C_H      _PK_H_(0x12, 0x5C)
#define REG_SC_BK12_5D_L      _PK_L_(0x12, 0x5D)
#define REG_SC_BK12_5D_H      _PK_H_(0x12, 0x5D)
#define REG_SC_BK12_5E_L      _PK_L_(0x12, 0x5E)
#define REG_SC_BK12_5E_H      _PK_H_(0x12, 0x5E)
#define REG_SC_BK12_5F_L      _PK_L_(0x12, 0x5F)
#define REG_SC_BK12_5F_H      _PK_H_(0x12, 0x5F)
#define REG_SC_BK12_60_L      _PK_L_(0x12, 0x60)
#define REG_SC_BK12_60_H      _PK_H_(0x12, 0x60)
#define REG_SC_BK12_61_L      _PK_L_(0x12, 0x61)
#define REG_SC_BK12_61_H      _PK_H_(0x12, 0x61)
#define REG_SC_BK12_62_L      _PK_L_(0x12, 0x62)
#define REG_SC_BK12_62_H      _PK_H_(0x12, 0x62)
#define REG_SC_BK12_63_L      _PK_L_(0x12, 0x63)
#define REG_SC_BK12_63_H      _PK_H_(0x12, 0x63)
#define REG_SC_BK12_64_L      _PK_L_(0x12, 0x64)
#define REG_SC_BK12_64_H      _PK_H_(0x12, 0x64)
#define REG_SC_BK12_65_L      _PK_L_(0x12, 0x65)
#define REG_SC_BK12_65_H      _PK_H_(0x12, 0x65)
#define REG_SC_BK12_66_L      _PK_L_(0x12, 0x66)
#define REG_SC_BK12_66_H      _PK_H_(0x12, 0x66)
#define REG_SC_BK12_67_L      _PK_L_(0x12, 0x67)
#define REG_SC_BK12_67_H      _PK_H_(0x12, 0x67)
#define REG_SC_BK12_68_L      _PK_L_(0x12, 0x68)
#define REG_SC_BK12_68_H      _PK_H_(0x12, 0x68)
#define REG_SC_BK12_69_L      _PK_L_(0x12, 0x69)
#define REG_SC_BK12_69_H      _PK_H_(0x12, 0x69)
#define REG_SC_BK12_6A_L      _PK_L_(0x12, 0x6A)
#define REG_SC_BK12_6A_H      _PK_H_(0x12, 0x6A)
#define REG_SC_BK12_6B_L      _PK_L_(0x12, 0x6B)
#define REG_SC_BK12_6B_H      _PK_H_(0x12, 0x6B)
#define REG_SC_BK12_6C_L      _PK_L_(0x12, 0x6C)
#define REG_SC_BK12_6C_H      _PK_H_(0x12, 0x6C)
#define REG_SC_BK12_6D_L      _PK_L_(0x12, 0x6D)
#define REG_SC_BK12_6D_H      _PK_H_(0x12, 0x6D)
#define REG_SC_BK12_6E_L      _PK_L_(0x12, 0x6E)
#define REG_SC_BK12_6E_H      _PK_H_(0x12, 0x6E)
#define REG_SC_BK12_6F_L      _PK_L_(0x12, 0x6F)
#define REG_SC_BK12_6F_H      _PK_H_(0x12, 0x6F)
#define REG_SC_BK12_70_L      _PK_L_(0x12, 0x70)
#define REG_SC_BK12_70_H      _PK_H_(0x12, 0x70)
#define REG_SC_BK12_71_L      _PK_L_(0x12, 0x71)
#define REG_SC_BK12_71_H      _PK_H_(0x12, 0x71)
#define REG_SC_BK12_72_L      _PK_L_(0x12, 0x72)
#define REG_SC_BK12_72_H      _PK_H_(0x12, 0x72)
#define REG_SC_BK12_73_L      _PK_L_(0x12, 0x73)
#define REG_SC_BK12_73_H      _PK_H_(0x12, 0x73)
#define REG_SC_BK12_74_L      _PK_L_(0x12, 0x74)
#define REG_SC_BK12_74_H      _PK_H_(0x12, 0x74)
#define REG_SC_BK12_75_L      _PK_L_(0x12, 0x75)
#define REG_SC_BK12_75_H      _PK_H_(0x12, 0x75)
#define REG_SC_BK12_76_L      _PK_L_(0x12, 0x76)
#define REG_SC_BK12_76_H      _PK_H_(0x12, 0x76)
#define REG_SC_BK12_77_L      _PK_L_(0x12, 0x77)
#define REG_SC_BK12_77_H      _PK_H_(0x12, 0x77)
#define REG_SC_BK12_78_L      _PK_L_(0x12, 0x78)
#define REG_SC_BK12_78_H      _PK_H_(0x12, 0x78)
#define REG_SC_BK12_79_L      _PK_L_(0x12, 0x79)
#define REG_SC_BK12_79_H      _PK_H_(0x12, 0x79)
#define REG_SC_BK12_7A_L      _PK_L_(0x12, 0x7A)
#define REG_SC_BK12_7A_H      _PK_H_(0x12, 0x7A)
#define REG_SC_BK12_7B_L      _PK_L_(0x12, 0x7B)
#define REG_SC_BK12_7B_H      _PK_H_(0x12, 0x7B)
#define REG_SC_BK12_7C_L      _PK_L_(0x12, 0x7C)
#define REG_SC_BK12_7C_H      _PK_H_(0x12, 0x7C)
#define REG_SC_BK12_7D_L      _PK_L_(0x12, 0x7D)
#define REG_SC_BK12_7D_H      _PK_H_(0x12, 0x7D)
#define REG_SC_BK12_7E_L      _PK_L_(0x12, 0x7E)
#define REG_SC_BK12_7E_H      _PK_H_(0x12, 0x7E)
#define REG_SC_BK12_7F_L      _PK_L_(0x12, 0x7F)
#define REG_SC_BK12_7F_H      _PK_H_(0x12, 0x7F)



//----------------------------------------------
//  BK17: SRAM
//----------------------------------------------
#define REG_SC_BK17_00_L      _PK_L_(0x17, 0x00)
#define REG_SC_BK17_00_H      _PK_H_(0x17, 0x00)
#define REG_SC_BK17_01_L      _PK_L_(0x17, 0x01)
#define REG_SC_BK17_01_H      _PK_H_(0x17, 0x01)
#define REG_SC_BK17_02_L      _PK_L_(0x17, 0x02)
#define REG_SC_BK17_02_H      _PK_H_(0x17, 0x02)
#define REG_SC_BK17_03_L      _PK_L_(0x17, 0x03)
#define REG_SC_BK17_03_H      _PK_H_(0x17, 0x03)
#define REG_SC_BK17_04_L      _PK_L_(0x17, 0x04)
#define REG_SC_BK17_04_H      _PK_H_(0x17, 0x04)
#define REG_SC_BK17_05_L      _PK_L_(0x17, 0x05)
#define REG_SC_BK17_05_H      _PK_H_(0x17, 0x05)
#define REG_SC_BK17_06_L      _PK_L_(0x17, 0x06)
#define REG_SC_BK17_06_H      _PK_H_(0x17, 0x06)
#define REG_SC_BK17_07_L      _PK_L_(0x17, 0x07)
#define REG_SC_BK17_07_H      _PK_H_(0x17, 0x07)
#define REG_SC_BK17_08_L      _PK_L_(0x17, 0x08)
#define REG_SC_BK17_08_H      _PK_H_(0x17, 0x08)
#define REG_SC_BK17_09_L      _PK_L_(0x17, 0x09)
#define REG_SC_BK17_09_H      _PK_H_(0x17, 0x09)
#define REG_SC_BK17_0A_L      _PK_L_(0x17, 0x0A)
#define REG_SC_BK17_0A_H      _PK_H_(0x17, 0x0A)
#define REG_SC_BK17_0B_L      _PK_L_(0x17, 0x0B)
#define REG_SC_BK17_0B_H      _PK_H_(0x17, 0x0B)
#define REG_SC_BK17_0C_L      _PK_L_(0x17, 0x0C)
#define REG_SC_BK17_0C_H      _PK_H_(0x17, 0x0C)
#define REG_SC_BK17_0D_L      _PK_L_(0x17, 0x0D)
#define REG_SC_BK17_0D_H      _PK_H_(0x17, 0x0D)
#define REG_SC_BK17_0E_L      _PK_L_(0x17, 0x0E)
#define REG_SC_BK17_0E_H      _PK_H_(0x17, 0x0E)
#define REG_SC_BK17_0F_L      _PK_L_(0x17, 0x0F)
#define REG_SC_BK17_0F_H      _PK_H_(0x17, 0x0F)
#define REG_SC_BK17_10_L      _PK_L_(0x17, 0x10)
#define REG_SC_BK17_10_H      _PK_H_(0x17, 0x10)
#define REG_SC_BK17_11_L      _PK_L_(0x17, 0x11)
#define REG_SC_BK17_11_H      _PK_H_(0x17, 0x11)
#define REG_SC_BK17_12_L      _PK_L_(0x17, 0x12)
#define REG_SC_BK17_12_H      _PK_H_(0x17, 0x12)
#define REG_SC_BK17_13_L      _PK_L_(0x17, 0x13)
#define REG_SC_BK17_13_H      _PK_H_(0x17, 0x13)
#define REG_SC_BK17_14_L      _PK_L_(0x17, 0x14)
#define REG_SC_BK17_14_H      _PK_H_(0x17, 0x14)
#define REG_SC_BK17_15_L      _PK_L_(0x17, 0x15)
#define REG_SC_BK17_15_H      _PK_H_(0x17, 0x15)
#define REG_SC_BK17_16_L      _PK_L_(0x17, 0x16)
#define REG_SC_BK17_16_H      _PK_H_(0x17, 0x16)
#define REG_SC_BK17_17_L      _PK_L_(0x17, 0x17)
#define REG_SC_BK17_17_H      _PK_H_(0x17, 0x17)
#define REG_SC_BK17_18_L      _PK_L_(0x17, 0x18)
#define REG_SC_BK17_18_H      _PK_H_(0x17, 0x18)
#define REG_SC_BK17_19_L      _PK_L_(0x17, 0x19)
#define REG_SC_BK17_19_H      _PK_H_(0x17, 0x19)
#define REG_SC_BK17_1A_L      _PK_L_(0x17, 0x1A)
#define REG_SC_BK17_1A_H      _PK_H_(0x17, 0x1A)
#define REG_SC_BK17_1B_L      _PK_L_(0x17, 0x1B)
#define REG_SC_BK17_1B_H      _PK_H_(0x17, 0x1B)
#define REG_SC_BK17_1C_L      _PK_L_(0x17, 0x1C)
#define REG_SC_BK17_1C_H      _PK_H_(0x17, 0x1C)
#define REG_SC_BK17_1D_L      _PK_L_(0x17, 0x1D)
#define REG_SC_BK17_1D_H      _PK_H_(0x17, 0x1D)
#define REG_SC_BK17_1E_L      _PK_L_(0x17, 0x1E)
#define REG_SC_BK17_1E_H      _PK_H_(0x17, 0x1E)
#define REG_SC_BK17_1F_L      _PK_L_(0x17, 0x1F)
#define REG_SC_BK17_1F_H      _PK_H_(0x17, 0x1F)
#define REG_SC_BK17_20_L      _PK_L_(0x17, 0x20)
#define REG_SC_BK17_20_H      _PK_H_(0x17, 0x20)
#define REG_SC_BK17_21_L      _PK_L_(0x17, 0x21)
#define REG_SC_BK17_21_H      _PK_H_(0x17, 0x21)
#define REG_SC_BK17_22_L      _PK_L_(0x17, 0x22)
#define REG_SC_BK17_22_H      _PK_H_(0x17, 0x22)
#define REG_SC_BK17_23_L      _PK_L_(0x17, 0x23)
#define REG_SC_BK17_23_H      _PK_H_(0x17, 0x23)
#define REG_SC_BK17_24_L      _PK_L_(0x17, 0x24)
#define REG_SC_BK17_24_H      _PK_H_(0x17, 0x24)
#define REG_SC_BK17_25_L      _PK_L_(0x17, 0x25)
#define REG_SC_BK17_25_H      _PK_H_(0x17, 0x25)
#define REG_SC_BK17_26_L      _PK_L_(0x17, 0x26)
#define REG_SC_BK17_26_H      _PK_H_(0x17, 0x26)
#define REG_SC_BK17_27_L      _PK_L_(0x17, 0x27)
#define REG_SC_BK17_27_H      _PK_H_(0x17, 0x27)
#define REG_SC_BK17_28_L      _PK_L_(0x17, 0x28)
#define REG_SC_BK17_28_H      _PK_H_(0x17, 0x28)
#define REG_SC_BK17_29_L      _PK_L_(0x17, 0x29)
#define REG_SC_BK17_29_H      _PK_H_(0x17, 0x29)
#define REG_SC_BK17_2A_L      _PK_L_(0x17, 0x2A)
#define REG_SC_BK17_2A_H      _PK_H_(0x17, 0x2A)
#define REG_SC_BK17_2B_L      _PK_L_(0x17, 0x2B)
#define REG_SC_BK17_2B_H      _PK_H_(0x17, 0x2B)
#define REG_SC_BK17_2C_L      _PK_L_(0x17, 0x2C)
#define REG_SC_BK17_2C_H      _PK_H_(0x17, 0x2C)
#define REG_SC_BK17_2D_L      _PK_L_(0x17, 0x2D)
#define REG_SC_BK17_2D_H      _PK_H_(0x17, 0x2D)
#define REG_SC_BK17_2E_L      _PK_L_(0x17, 0x2E)
#define REG_SC_BK17_2E_H      _PK_H_(0x17, 0x2E)
#define REG_SC_BK17_2F_L      _PK_L_(0x17, 0x2F)
#define REG_SC_BK17_2F_H      _PK_H_(0x17, 0x2F)
#define REG_SC_BK17_30_L      _PK_L_(0x17, 0x30)
#define REG_SC_BK17_30_H      _PK_H_(0x17, 0x30)
#define REG_SC_BK17_31_L      _PK_L_(0x17, 0x31)
#define REG_SC_BK17_31_H      _PK_H_(0x17, 0x31)
#define REG_SC_BK17_32_L      _PK_L_(0x17, 0x32)
#define REG_SC_BK17_32_H      _PK_H_(0x17, 0x32)
#define REG_SC_BK17_33_L      _PK_L_(0x17, 0x33)
#define REG_SC_BK17_33_H      _PK_H_(0x17, 0x33)
#define REG_SC_BK17_34_L      _PK_L_(0x17, 0x34)
#define REG_SC_BK17_34_H      _PK_H_(0x17, 0x34)
#define REG_SC_BK17_35_L      _PK_L_(0x17, 0x35)
#define REG_SC_BK17_35_H      _PK_H_(0x17, 0x35)
#define REG_SC_BK17_36_L      _PK_L_(0x17, 0x36)
#define REG_SC_BK17_36_H      _PK_H_(0x17, 0x36)
#define REG_SC_BK17_37_L      _PK_L_(0x17, 0x37)
#define REG_SC_BK17_37_H      _PK_H_(0x17, 0x37)
#define REG_SC_BK17_38_L      _PK_L_(0x17, 0x38)
#define REG_SC_BK17_38_H      _PK_H_(0x17, 0x38)
#define REG_SC_BK17_39_L      _PK_L_(0x17, 0x39)
#define REG_SC_BK17_39_H      _PK_H_(0x17, 0x39)
#define REG_SC_BK17_3A_L      _PK_L_(0x17, 0x3A)
#define REG_SC_BK17_3A_H      _PK_H_(0x17, 0x3A)
#define REG_SC_BK17_3B_L      _PK_L_(0x17, 0x3B)
#define REG_SC_BK17_3B_H      _PK_H_(0x17, 0x3B)
#define REG_SC_BK17_3C_L      _PK_L_(0x17, 0x3C)
#define REG_SC_BK17_3C_H      _PK_H_(0x17, 0x3C)
#define REG_SC_BK17_3D_L      _PK_L_(0x17, 0x3D)
#define REG_SC_BK17_3D_H      _PK_H_(0x17, 0x3D)
#define REG_SC_BK17_3E_L      _PK_L_(0x17, 0x3E)
#define REG_SC_BK17_3E_H      _PK_H_(0x17, 0x3E)
#define REG_SC_BK17_3F_L      _PK_L_(0x17, 0x3F)
#define REG_SC_BK17_3F_H      _PK_H_(0x17, 0x3F)
#define REG_SC_BK17_40_L      _PK_L_(0x17, 0x40)
#define REG_SC_BK17_40_H      _PK_H_(0x17, 0x40)
#define REG_SC_BK17_41_L      _PK_L_(0x17, 0x41)
#define REG_SC_BK17_41_H      _PK_H_(0x17, 0x41)
#define REG_SC_BK17_42_L      _PK_L_(0x17, 0x42)
#define REG_SC_BK17_42_H      _PK_H_(0x17, 0x42)
#define REG_SC_BK17_43_L      _PK_L_(0x17, 0x43)
#define REG_SC_BK17_43_H      _PK_H_(0x17, 0x43)
#define REG_SC_BK17_44_L      _PK_L_(0x17, 0x44)
#define REG_SC_BK17_44_H      _PK_H_(0x17, 0x44)
#define REG_SC_BK17_45_L      _PK_L_(0x17, 0x45)
#define REG_SC_BK17_45_H      _PK_H_(0x17, 0x45)
#define REG_SC_BK17_46_L      _PK_L_(0x17, 0x46)
#define REG_SC_BK17_46_H      _PK_H_(0x17, 0x46)
#define REG_SC_BK17_47_L      _PK_L_(0x17, 0x47)
#define REG_SC_BK17_47_H      _PK_H_(0x17, 0x47)
#define REG_SC_BK17_48_L      _PK_L_(0x17, 0x48)
#define REG_SC_BK17_48_H      _PK_H_(0x17, 0x48)
#define REG_SC_BK17_49_L      _PK_L_(0x17, 0x49)
#define REG_SC_BK17_49_H      _PK_H_(0x17, 0x49)
#define REG_SC_BK17_4A_L      _PK_L_(0x17, 0x4A)
#define REG_SC_BK17_4A_H      _PK_H_(0x17, 0x4A)
#define REG_SC_BK17_4B_L      _PK_L_(0x17, 0x4B)
#define REG_SC_BK17_4B_H      _PK_H_(0x17, 0x4B)
#define REG_SC_BK17_4C_L      _PK_L_(0x17, 0x4C)
#define REG_SC_BK17_4C_H      _PK_H_(0x17, 0x4C)
#define REG_SC_BK17_4D_L      _PK_L_(0x17, 0x4D)
#define REG_SC_BK17_4D_H      _PK_H_(0x17, 0x4D)
#define REG_SC_BK17_4E_L      _PK_L_(0x17, 0x4E)
#define REG_SC_BK17_4E_H      _PK_H_(0x17, 0x4E)
#define REG_SC_BK17_4F_L      _PK_L_(0x17, 0x4F)
#define REG_SC_BK17_4F_H      _PK_H_(0x17, 0x4F)
#define REG_SC_BK17_50_L      _PK_L_(0x17, 0x50)
#define REG_SC_BK17_50_H      _PK_H_(0x17, 0x50)
#define REG_SC_BK17_51_L      _PK_L_(0x17, 0x51)
#define REG_SC_BK17_51_H      _PK_H_(0x17, 0x51)
#define REG_SC_BK17_52_L      _PK_L_(0x17, 0x52)
#define REG_SC_BK17_52_H      _PK_H_(0x17, 0x52)
#define REG_SC_BK17_53_L      _PK_L_(0x17, 0x53)
#define REG_SC_BK17_53_H      _PK_H_(0x17, 0x53)
#define REG_SC_BK17_54_L      _PK_L_(0x17, 0x54)
#define REG_SC_BK17_54_H      _PK_H_(0x17, 0x54)
#define REG_SC_BK17_55_L      _PK_L_(0x17, 0x55)
#define REG_SC_BK17_55_H      _PK_H_(0x17, 0x55)
#define REG_SC_BK17_56_L      _PK_L_(0x17, 0x56)
#define REG_SC_BK17_56_H      _PK_H_(0x17, 0x56)
#define REG_SC_BK17_57_L      _PK_L_(0x17, 0x57)
#define REG_SC_BK17_57_H      _PK_H_(0x17, 0x57)
#define REG_SC_BK17_58_L      _PK_L_(0x17, 0x58)
#define REG_SC_BK17_58_H      _PK_H_(0x17, 0x58)
#define REG_SC_BK17_59_L      _PK_L_(0x17, 0x59)
#define REG_SC_BK17_59_H      _PK_H_(0x17, 0x59)
#define REG_SC_BK17_5A_L      _PK_L_(0x17, 0x5A)
#define REG_SC_BK17_5A_H      _PK_H_(0x17, 0x5A)
#define REG_SC_BK17_5B_L      _PK_L_(0x17, 0x5B)
#define REG_SC_BK17_5B_H      _PK_H_(0x17, 0x5B)
#define REG_SC_BK17_5C_L      _PK_L_(0x17, 0x5C)
#define REG_SC_BK17_5C_H      _PK_H_(0x17, 0x5C)
#define REG_SC_BK17_5D_L      _PK_L_(0x17, 0x5D)
#define REG_SC_BK17_5D_H      _PK_H_(0x17, 0x5D)
#define REG_SC_BK17_5E_L      _PK_L_(0x17, 0x5E)
#define REG_SC_BK17_5E_H      _PK_H_(0x17, 0x5E)
#define REG_SC_BK17_5F_L      _PK_L_(0x17, 0x5F)
#define REG_SC_BK17_5F_H      _PK_H_(0x17, 0x5F)
#define REG_SC_BK17_60_L      _PK_L_(0x17, 0x60)
#define REG_SC_BK17_60_H      _PK_H_(0x17, 0x60)
#define REG_SC_BK17_61_L      _PK_L_(0x17, 0x61)
#define REG_SC_BK17_61_H      _PK_H_(0x17, 0x61)
#define REG_SC_BK17_62_L      _PK_L_(0x17, 0x62)
#define REG_SC_BK17_62_H      _PK_H_(0x17, 0x62)
#define REG_SC_BK17_63_L      _PK_L_(0x17, 0x63)
#define REG_SC_BK17_63_H      _PK_H_(0x17, 0x63)
#define REG_SC_BK17_64_L      _PK_L_(0x17, 0x64)
#define REG_SC_BK17_64_H      _PK_H_(0x17, 0x64)
#define REG_SC_BK17_65_L      _PK_L_(0x17, 0x65)
#define REG_SC_BK17_65_H      _PK_H_(0x17, 0x65)
#define REG_SC_BK17_66_L      _PK_L_(0x17, 0x66)
#define REG_SC_BK17_66_H      _PK_H_(0x17, 0x66)
#define REG_SC_BK17_67_L      _PK_L_(0x17, 0x67)
#define REG_SC_BK17_67_H      _PK_H_(0x17, 0x67)
#define REG_SC_BK17_68_L      _PK_L_(0x17, 0x68)
#define REG_SC_BK17_68_H      _PK_H_(0x17, 0x68)
#define REG_SC_BK17_69_L      _PK_L_(0x17, 0x69)
#define REG_SC_BK17_69_H      _PK_H_(0x17, 0x69)
#define REG_SC_BK17_6A_L      _PK_L_(0x17, 0x6A)
#define REG_SC_BK17_6A_H      _PK_H_(0x17, 0x6A)
#define REG_SC_BK17_6B_L      _PK_L_(0x17, 0x6B)
#define REG_SC_BK17_6B_H      _PK_H_(0x17, 0x6B)
#define REG_SC_BK17_6C_L      _PK_L_(0x17, 0x6C)
#define REG_SC_BK17_6C_H      _PK_H_(0x17, 0x6C)
#define REG_SC_BK17_6D_L      _PK_L_(0x17, 0x6D)
#define REG_SC_BK17_6D_H      _PK_H_(0x17, 0x6D)
#define REG_SC_BK17_6E_L      _PK_L_(0x17, 0x6E)
#define REG_SC_BK17_6E_H      _PK_H_(0x17, 0x6E)
#define REG_SC_BK17_6F_L      _PK_L_(0x17, 0x6F)
#define REG_SC_BK17_6F_H      _PK_H_(0x17, 0x6F)
#define REG_SC_BK17_70_L      _PK_L_(0x17, 0x70)
#define REG_SC_BK17_70_H      _PK_H_(0x17, 0x70)
#define REG_SC_BK17_71_L      _PK_L_(0x17, 0x71)
#define REG_SC_BK17_71_H      _PK_H_(0x17, 0x71)
#define REG_SC_BK17_72_L      _PK_L_(0x17, 0x72)
#define REG_SC_BK17_72_H      _PK_H_(0x17, 0x72)
#define REG_SC_BK17_73_L      _PK_L_(0x17, 0x73)
#define REG_SC_BK17_73_H      _PK_H_(0x17, 0x73)
#define REG_SC_BK17_74_L      _PK_L_(0x17, 0x74)
#define REG_SC_BK17_74_H      _PK_H_(0x17, 0x74)
#define REG_SC_BK17_75_L      _PK_L_(0x17, 0x75)
#define REG_SC_BK17_75_H      _PK_H_(0x17, 0x75)
#define REG_SC_BK17_76_L      _PK_L_(0x17, 0x76)
#define REG_SC_BK17_76_H      _PK_H_(0x17, 0x76)
#define REG_SC_BK17_77_L      _PK_L_(0x17, 0x77)
#define REG_SC_BK17_77_H      _PK_H_(0x17, 0x77)
#define REG_SC_BK17_78_L      _PK_L_(0x17, 0x78)
#define REG_SC_BK17_78_H      _PK_H_(0x17, 0x78)
#define REG_SC_BK17_79_L      _PK_L_(0x17, 0x79)
#define REG_SC_BK17_79_H      _PK_H_(0x17, 0x79)
#define REG_SC_BK17_7A_L      _PK_L_(0x17, 0x7A)
#define REG_SC_BK17_7A_H      _PK_H_(0x17, 0x7A)
#define REG_SC_BK17_7B_L      _PK_L_(0x17, 0x7B)
#define REG_SC_BK17_7B_H      _PK_H_(0x17, 0x7B)
#define REG_SC_BK17_7C_L      _PK_L_(0x17, 0x7C)
#define REG_SC_BK17_7C_H      _PK_H_(0x17, 0x7C)
#define REG_SC_BK17_7D_L      _PK_L_(0x17, 0x7D)
#define REG_SC_BK17_7D_H      _PK_H_(0x17, 0x7D)
#define REG_SC_BK17_7E_L      _PK_L_(0x17, 0x7E)
#define REG_SC_BK17_7E_H      _PK_H_(0x17, 0x7E)
#define REG_SC_BK17_7F_L      _PK_L_(0x17, 0x7F)
#define REG_SC_BK17_7F_H      _PK_H_(0x17, 0x7F)

//----------------------------------------------
//  BK18: ACE
//----------------------------------------------
#define REG_SC_BK18_00_L      _PK_L_(0x18, 0x00)
#define REG_SC_BK18_00_H      _PK_H_(0x18, 0x00)
#define REG_SC_BK18_01_L      _PK_L_(0x18, 0x01)
#define REG_SC_BK18_01_H      _PK_H_(0x18, 0x01)
#define REG_SC_BK18_02_L      _PK_L_(0x18, 0x02)
#define REG_SC_BK18_02_H      _PK_H_(0x18, 0x02)
#define REG_SC_BK18_03_L      _PK_L_(0x18, 0x03)
#define REG_SC_BK18_03_H      _PK_H_(0x18, 0x03)
#define REG_SC_BK18_04_L      _PK_L_(0x18, 0x04)
#define REG_SC_BK18_04_H      _PK_H_(0x18, 0x04)
#define REG_SC_BK18_05_L      _PK_L_(0x18, 0x05)
#define REG_SC_BK18_05_H      _PK_H_(0x18, 0x05)
#define REG_SC_BK18_06_L      _PK_L_(0x18, 0x06)
#define REG_SC_BK18_06_H      _PK_H_(0x18, 0x06)
#define REG_SC_BK18_07_L      _PK_L_(0x18, 0x07)
#define REG_SC_BK18_07_H      _PK_H_(0x18, 0x07)
#define REG_SC_BK18_08_L      _PK_L_(0x18, 0x08)
#define REG_SC_BK18_08_H      _PK_H_(0x18, 0x08)
#define REG_SC_BK18_09_L      _PK_L_(0x18, 0x09)
#define REG_SC_BK18_09_H      _PK_H_(0x18, 0x09)
#define REG_SC_BK18_0A_L      _PK_L_(0x18, 0x0A)
#define REG_SC_BK18_0A_H      _PK_H_(0x18, 0x0A)
#define REG_SC_BK18_0B_L      _PK_L_(0x18, 0x0B)
#define REG_SC_BK18_0B_H      _PK_H_(0x18, 0x0B)
#define REG_SC_BK18_0C_L      _PK_L_(0x18, 0x0C)
#define REG_SC_BK18_0C_H      _PK_H_(0x18, 0x0C)
#define REG_SC_BK18_0D_L      _PK_L_(0x18, 0x0D)
#define REG_SC_BK18_0D_H      _PK_H_(0x18, 0x0D)
#define REG_SC_BK18_0E_L      _PK_L_(0x18, 0x0E)
#define REG_SC_BK18_0E_H      _PK_H_(0x18, 0x0E)
#define REG_SC_BK18_0F_L      _PK_L_(0x18, 0x0F)
#define REG_SC_BK18_0F_H      _PK_H_(0x18, 0x0F)
#define REG_SC_BK18_10_L      _PK_L_(0x18, 0x10)
#define REG_SC_BK18_10_H      _PK_H_(0x18, 0x10)
#define REG_SC_BK18_11_L      _PK_L_(0x18, 0x11)
#define REG_SC_BK18_11_H      _PK_H_(0x18, 0x11)
#define REG_SC_BK18_12_L      _PK_L_(0x18, 0x12)
#define REG_SC_BK18_12_H      _PK_H_(0x18, 0x12)
#define REG_SC_BK18_13_L      _PK_L_(0x18, 0x13)
#define REG_SC_BK18_13_H      _PK_H_(0x18, 0x13)
#define REG_SC_BK18_14_L      _PK_L_(0x18, 0x14)
#define REG_SC_BK18_14_H      _PK_H_(0x18, 0x14)
#define REG_SC_BK18_15_L      _PK_L_(0x18, 0x15)
#define REG_SC_BK18_15_H      _PK_H_(0x18, 0x15)
#define REG_SC_BK18_16_L      _PK_L_(0x18, 0x16)
#define REG_SC_BK18_16_H      _PK_H_(0x18, 0x16)
#define REG_SC_BK18_17_L      _PK_L_(0x18, 0x17)
#define REG_SC_BK18_17_H      _PK_H_(0x18, 0x17)
#define REG_SC_BK18_18_L      _PK_L_(0x18, 0x18)
#define REG_SC_BK18_18_H      _PK_H_(0x18, 0x18)
#define REG_SC_BK18_19_L      _PK_L_(0x18, 0x19)
#define REG_SC_BK18_19_H      _PK_H_(0x18, 0x19)
#define REG_SC_BK18_1A_L      _PK_L_(0x18, 0x1A)
#define REG_SC_BK18_1A_H      _PK_H_(0x18, 0x1A)
#define REG_SC_BK18_1B_L      _PK_L_(0x18, 0x1B)
#define REG_SC_BK18_1B_H      _PK_H_(0x18, 0x1B)
#define REG_SC_BK18_1C_L      _PK_L_(0x18, 0x1C)
#define REG_SC_BK18_1C_H      _PK_H_(0x18, 0x1C)
#define REG_SC_BK18_1D_L      _PK_L_(0x18, 0x1D)
#define REG_SC_BK18_1D_H      _PK_H_(0x18, 0x1D)
#define REG_SC_BK18_1E_L      _PK_L_(0x18, 0x1E)
#define REG_SC_BK18_1E_H      _PK_H_(0x18, 0x1E)
#define REG_SC_BK18_1F_L      _PK_L_(0x18, 0x1F)
#define REG_SC_BK18_1F_H      _PK_H_(0x18, 0x1F)
#define REG_SC_BK18_20_L      _PK_L_(0x18, 0x20)
#define REG_SC_BK18_20_H      _PK_H_(0x18, 0x20)
#define REG_SC_BK18_21_L      _PK_L_(0x18, 0x21)
#define REG_SC_BK18_21_H      _PK_H_(0x18, 0x21)
#define REG_SC_BK18_22_L      _PK_L_(0x18, 0x22)
#define REG_SC_BK18_22_H      _PK_H_(0x18, 0x22)
#define REG_SC_BK18_23_L      _PK_L_(0x18, 0x23)
#define REG_SC_BK18_23_H      _PK_H_(0x18, 0x23)
#define REG_SC_BK18_24_L      _PK_L_(0x18, 0x24)
#define REG_SC_BK18_24_H      _PK_H_(0x18, 0x24)
#define REG_SC_BK18_25_L      _PK_L_(0x18, 0x25)
#define REG_SC_BK18_25_H      _PK_H_(0x18, 0x25)
#define REG_SC_BK18_26_L      _PK_L_(0x18, 0x26)
#define REG_SC_BK18_26_H      _PK_H_(0x18, 0x26)
#define REG_SC_BK18_27_L      _PK_L_(0x18, 0x27)
#define REG_SC_BK18_27_H      _PK_H_(0x18, 0x27)
#define REG_SC_BK18_28_L      _PK_L_(0x18, 0x28)
#define REG_SC_BK18_28_H      _PK_H_(0x18, 0x28)
#define REG_SC_BK18_29_L      _PK_L_(0x18, 0x29)
#define REG_SC_BK18_29_H      _PK_H_(0x18, 0x29)
#define REG_SC_BK18_2A_L      _PK_L_(0x18, 0x2A)
#define REG_SC_BK18_2A_H      _PK_H_(0x18, 0x2A)
#define REG_SC_BK18_2B_L      _PK_L_(0x18, 0x2B)
#define REG_SC_BK18_2B_H      _PK_H_(0x18, 0x2B)
#define REG_SC_BK18_2C_L      _PK_L_(0x18, 0x2C)
#define REG_SC_BK18_2C_H      _PK_H_(0x18, 0x2C)
#define REG_SC_BK18_2D_L      _PK_L_(0x18, 0x2D)
#define REG_SC_BK18_2D_H      _PK_H_(0x18, 0x2D)
#define REG_SC_BK18_2E_L      _PK_L_(0x18, 0x2E)
#define REG_SC_BK18_2E_H      _PK_H_(0x18, 0x2E)
#define REG_SC_BK18_2F_L      _PK_L_(0x18, 0x2F)
#define REG_SC_BK18_2F_H      _PK_H_(0x18, 0x2F)
#define REG_SC_BK18_30_L      _PK_L_(0x18, 0x30)
#define REG_SC_BK18_30_H      _PK_H_(0x18, 0x30)
#define REG_SC_BK18_31_L      _PK_L_(0x18, 0x31)
#define REG_SC_BK18_31_H      _PK_H_(0x18, 0x31)
#define REG_SC_BK18_32_L      _PK_L_(0x18, 0x32)
#define REG_SC_BK18_32_H      _PK_H_(0x18, 0x32)
#define REG_SC_BK18_33_L      _PK_L_(0x18, 0x33)
#define REG_SC_BK18_33_H      _PK_H_(0x18, 0x33)
#define REG_SC_BK18_34_L      _PK_L_(0x18, 0x34)
#define REG_SC_BK18_34_H      _PK_H_(0x18, 0x34)
#define REG_SC_BK18_35_L      _PK_L_(0x18, 0x35)
#define REG_SC_BK18_35_H      _PK_H_(0x18, 0x35)
#define REG_SC_BK18_36_L      _PK_L_(0x18, 0x36)
#define REG_SC_BK18_36_H      _PK_H_(0x18, 0x36)
#define REG_SC_BK18_37_L      _PK_L_(0x18, 0x37)
#define REG_SC_BK18_37_H      _PK_H_(0x18, 0x37)
#define REG_SC_BK18_38_L      _PK_L_(0x18, 0x38)
#define REG_SC_BK18_38_H      _PK_H_(0x18, 0x38)
#define REG_SC_BK18_39_L      _PK_L_(0x18, 0x39)
#define REG_SC_BK18_39_H      _PK_H_(0x18, 0x39)
#define REG_SC_BK18_3A_L      _PK_L_(0x18, 0x3A)
#define REG_SC_BK18_3A_H      _PK_H_(0x18, 0x3A)
#define REG_SC_BK18_3B_L      _PK_L_(0x18, 0x3B)
#define REG_SC_BK18_3B_H      _PK_H_(0x18, 0x3B)
#define REG_SC_BK18_3C_L      _PK_L_(0x18, 0x3C)
#define REG_SC_BK18_3C_H      _PK_H_(0x18, 0x3C)
#define REG_SC_BK18_3D_L      _PK_L_(0x18, 0x3D)
#define REG_SC_BK18_3D_H      _PK_H_(0x18, 0x3D)
#define REG_SC_BK18_3E_L      _PK_L_(0x18, 0x3E)
#define REG_SC_BK18_3E_H      _PK_H_(0x18, 0x3E)
#define REG_SC_BK18_3F_L      _PK_L_(0x18, 0x3F)
#define REG_SC_BK18_3F_H      _PK_H_(0x18, 0x3F)
#define REG_SC_BK18_40_L      _PK_L_(0x18, 0x40)
#define REG_SC_BK18_40_H      _PK_H_(0x18, 0x40)
#define REG_SC_BK18_41_L      _PK_L_(0x18, 0x41)
#define REG_SC_BK18_41_H      _PK_H_(0x18, 0x41)
#define REG_SC_BK18_42_L      _PK_L_(0x18, 0x42)
#define REG_SC_BK18_42_H      _PK_H_(0x18, 0x42)
#define REG_SC_BK18_43_L      _PK_L_(0x18, 0x43)
#define REG_SC_BK18_43_H      _PK_H_(0x18, 0x43)
#define REG_SC_BK18_44_L      _PK_L_(0x18, 0x44)
#define REG_SC_BK18_44_H      _PK_H_(0x18, 0x44)
#define REG_SC_BK18_45_L      _PK_L_(0x18, 0x45)
#define REG_SC_BK18_45_H      _PK_H_(0x18, 0x45)
#define REG_SC_BK18_46_L      _PK_L_(0x18, 0x46)
#define REG_SC_BK18_46_H      _PK_H_(0x18, 0x46)
#define REG_SC_BK18_47_L      _PK_L_(0x18, 0x47)
#define REG_SC_BK18_47_H      _PK_H_(0x18, 0x47)
#define REG_SC_BK18_48_L      _PK_L_(0x18, 0x48)
#define REG_SC_BK18_48_H      _PK_H_(0x18, 0x48)
#define REG_SC_BK18_49_L      _PK_L_(0x18, 0x49)
#define REG_SC_BK18_49_H      _PK_H_(0x18, 0x49)
#define REG_SC_BK18_4A_L      _PK_L_(0x18, 0x4A)
#define REG_SC_BK18_4A_H      _PK_H_(0x18, 0x4A)
#define REG_SC_BK18_4B_L      _PK_L_(0x18, 0x4B)
#define REG_SC_BK18_4B_H      _PK_H_(0x18, 0x4B)
#define REG_SC_BK18_4C_L      _PK_L_(0x18, 0x4C)
#define REG_SC_BK18_4C_H      _PK_H_(0x18, 0x4C)
#define REG_SC_BK18_4D_L      _PK_L_(0x18, 0x4D)
#define REG_SC_BK18_4D_H      _PK_H_(0x18, 0x4D)
#define REG_SC_BK18_4E_L      _PK_L_(0x18, 0x4E)
#define REG_SC_BK18_4E_H      _PK_H_(0x18, 0x4E)
#define REG_SC_BK18_4F_L      _PK_L_(0x18, 0x4F)
#define REG_SC_BK18_4F_H      _PK_H_(0x18, 0x4F)
#define REG_SC_BK18_50_L      _PK_L_(0x18, 0x50)
#define REG_SC_BK18_50_H      _PK_H_(0x18, 0x50)
#define REG_SC_BK18_51_L      _PK_L_(0x18, 0x51)
#define REG_SC_BK18_51_H      _PK_H_(0x18, 0x51)
#define REG_SC_BK18_52_L      _PK_L_(0x18, 0x52)
#define REG_SC_BK18_52_H      _PK_H_(0x18, 0x52)
#define REG_SC_BK18_53_L      _PK_L_(0x18, 0x53)
#define REG_SC_BK18_53_H      _PK_H_(0x18, 0x53)
#define REG_SC_BK18_54_L      _PK_L_(0x18, 0x54)
#define REG_SC_BK18_54_H      _PK_H_(0x18, 0x54)
#define REG_SC_BK18_55_L      _PK_L_(0x18, 0x55)
#define REG_SC_BK18_55_H      _PK_H_(0x18, 0x55)
#define REG_SC_BK18_56_L      _PK_L_(0x18, 0x56)
#define REG_SC_BK18_56_H      _PK_H_(0x18, 0x56)
#define REG_SC_BK18_57_L      _PK_L_(0x18, 0x57)
#define REG_SC_BK18_57_H      _PK_H_(0x18, 0x57)
#define REG_SC_BK18_58_L      _PK_L_(0x18, 0x58)
#define REG_SC_BK18_58_H      _PK_H_(0x18, 0x58)
#define REG_SC_BK18_59_L      _PK_L_(0x18, 0x59)
#define REG_SC_BK18_59_H      _PK_H_(0x18, 0x59)
#define REG_SC_BK18_5A_L      _PK_L_(0x18, 0x5A)
#define REG_SC_BK18_5A_H      _PK_H_(0x18, 0x5A)
#define REG_SC_BK18_5B_L      _PK_L_(0x18, 0x5B)
#define REG_SC_BK18_5B_H      _PK_H_(0x18, 0x5B)
#define REG_SC_BK18_5C_L      _PK_L_(0x18, 0x5C)
#define REG_SC_BK18_5C_H      _PK_H_(0x18, 0x5C)
#define REG_SC_BK18_5D_L      _PK_L_(0x18, 0x5D)
#define REG_SC_BK18_5D_H      _PK_H_(0x18, 0x5D)
#define REG_SC_BK18_5E_L      _PK_L_(0x18, 0x5E)
#define REG_SC_BK18_5E_H      _PK_H_(0x18, 0x5E)
#define REG_SC_BK18_5F_L      _PK_L_(0x18, 0x5F)
#define REG_SC_BK18_5F_H      _PK_H_(0x18, 0x5F)
#define REG_SC_BK18_60_L      _PK_L_(0x18, 0x60)
#define REG_SC_BK18_60_H      _PK_H_(0x18, 0x60)
#define REG_SC_BK18_61_L      _PK_L_(0x18, 0x61)
#define REG_SC_BK18_61_H      _PK_H_(0x18, 0x61)
#define REG_SC_BK18_62_L      _PK_L_(0x18, 0x62)
#define REG_SC_BK18_62_H      _PK_H_(0x18, 0x62)
#define REG_SC_BK18_63_L      _PK_L_(0x18, 0x63)
#define REG_SC_BK18_63_H      _PK_H_(0x18, 0x63)
#define REG_SC_BK18_64_L      _PK_L_(0x18, 0x64)
#define REG_SC_BK18_64_H      _PK_H_(0x18, 0x64)
#define REG_SC_BK18_65_L      _PK_L_(0x18, 0x65)
#define REG_SC_BK18_65_H      _PK_H_(0x18, 0x65)
#define REG_SC_BK18_66_L      _PK_L_(0x18, 0x66)
#define REG_SC_BK18_66_H      _PK_H_(0x18, 0x66)
#define REG_SC_BK18_67_L      _PK_L_(0x18, 0x67)
#define REG_SC_BK18_67_H      _PK_H_(0x18, 0x67)
#define REG_SC_BK18_68_L      _PK_L_(0x18, 0x68)
#define REG_SC_BK18_68_H      _PK_H_(0x18, 0x68)
#define REG_SC_BK18_69_L      _PK_L_(0x18, 0x69)
#define REG_SC_BK18_69_H      _PK_H_(0x18, 0x69)
#define REG_SC_BK18_6A_L      _PK_L_(0x18, 0x6A)
#define REG_SC_BK18_6A_H      _PK_H_(0x18, 0x6A)
#define REG_SC_BK18_6B_L      _PK_L_(0x18, 0x6B)
#define REG_SC_BK18_6B_H      _PK_H_(0x18, 0x6B)
#define REG_SC_BK18_6C_L      _PK_L_(0x18, 0x6C)
#define REG_SC_BK18_6C_H      _PK_H_(0x18, 0x6C)
#define REG_SC_BK18_6D_L      _PK_L_(0x18, 0x6D)
#define REG_SC_BK18_6D_H      _PK_H_(0x18, 0x6D)
#define REG_SC_BK18_6E_L      _PK_L_(0x18, 0x6E)
#define REG_SC_BK18_6E_H      _PK_H_(0x18, 0x6E)
#define REG_SC_BK18_6F_L      _PK_L_(0x18, 0x6F)
#define REG_SC_BK18_6F_H      _PK_H_(0x18, 0x6F)
#define REG_SC_BK18_70_L      _PK_L_(0x18, 0x70)
#define REG_SC_BK18_70_H      _PK_H_(0x18, 0x70)
#define REG_SC_BK18_71_L      _PK_L_(0x18, 0x71)
#define REG_SC_BK18_71_H      _PK_H_(0x18, 0x71)
#define REG_SC_BK18_72_L      _PK_L_(0x18, 0x72)
#define REG_SC_BK18_72_H      _PK_H_(0x18, 0x72)
#define REG_SC_BK18_73_L      _PK_L_(0x18, 0x73)
#define REG_SC_BK18_73_H      _PK_H_(0x18, 0x73)
#define REG_SC_BK18_74_L      _PK_L_(0x18, 0x74)
#define REG_SC_BK18_74_H      _PK_H_(0x18, 0x74)
#define REG_SC_BK18_75_L      _PK_L_(0x18, 0x75)
#define REG_SC_BK18_75_H      _PK_H_(0x18, 0x75)
#define REG_SC_BK18_76_L      _PK_L_(0x18, 0x76)
#define REG_SC_BK18_76_H      _PK_H_(0x18, 0x76)
#define REG_SC_BK18_77_L      _PK_L_(0x18, 0x77)
#define REG_SC_BK18_77_H      _PK_H_(0x18, 0x77)
#define REG_SC_BK18_78_L      _PK_L_(0x18, 0x78)
#define REG_SC_BK18_78_H      _PK_H_(0x18, 0x78)
#define REG_SC_BK18_79_L      _PK_L_(0x18, 0x79)
#define REG_SC_BK18_79_H      _PK_H_(0x18, 0x79)
#define REG_SC_BK18_7A_L      _PK_L_(0x18, 0x7A)
#define REG_SC_BK18_7A_H      _PK_H_(0x18, 0x7A)
#define REG_SC_BK18_7B_L      _PK_L_(0x18, 0x7B)
#define REG_SC_BK18_7B_H      _PK_H_(0x18, 0x7B)
#define REG_SC_BK18_7C_L      _PK_L_(0x18, 0x7C)
#define REG_SC_BK18_7C_H      _PK_H_(0x18, 0x7C)
#define REG_SC_BK18_7D_L      _PK_L_(0x18, 0x7D)
#define REG_SC_BK18_7D_H      _PK_H_(0x18, 0x7D)
#define REG_SC_BK18_7E_L      _PK_L_(0x18, 0x7E)
#define REG_SC_BK18_7E_H      _PK_H_(0x18, 0x7E)
#define REG_SC_BK18_7F_L      _PK_L_(0x18, 0x7F)
#define REG_SC_BK18_7F_H      _PK_H_(0x18, 0x7F)

//----------------------------------------------
//  BK19: PEAKING
//----------------------------------------------
#define REG_SC_BK19_00_L      _PK_L_(0x19, 0x00)
#define REG_SC_BK19_00_H      _PK_H_(0x19, 0x00)
#define REG_SC_BK19_01_L      _PK_L_(0x19, 0x01)
#define REG_SC_BK19_01_H      _PK_H_(0x19, 0x01)
#define REG_SC_BK19_02_L      _PK_L_(0x19, 0x02)
#define REG_SC_BK19_02_H      _PK_H_(0x19, 0x02)
#define REG_SC_BK19_03_L      _PK_L_(0x19, 0x03)
#define REG_SC_BK19_03_H      _PK_H_(0x19, 0x03)
#define REG_SC_BK19_04_L      _PK_L_(0x19, 0x04)
#define REG_SC_BK19_04_H      _PK_H_(0x19, 0x04)
#define REG_SC_BK19_05_L      _PK_L_(0x19, 0x05)
#define REG_SC_BK19_05_H      _PK_H_(0x19, 0x05)
#define REG_SC_BK19_06_L      _PK_L_(0x19, 0x06)
#define REG_SC_BK19_06_H      _PK_H_(0x19, 0x06)
#define REG_SC_BK19_07_L      _PK_L_(0x19, 0x07)
#define REG_SC_BK19_07_H      _PK_H_(0x19, 0x07)
#define REG_SC_BK19_08_L      _PK_L_(0x19, 0x08)
#define REG_SC_BK19_08_H      _PK_H_(0x19, 0x08)
#define REG_SC_BK19_09_L      _PK_L_(0x19, 0x09)
#define REG_SC_BK19_09_H      _PK_H_(0x19, 0x09)
#define REG_SC_BK19_0A_L      _PK_L_(0x19, 0x0A)
#define REG_SC_BK19_0A_H      _PK_H_(0x19, 0x0A)
#define REG_SC_BK19_0B_L      _PK_L_(0x19, 0x0B)
#define REG_SC_BK19_0B_H      _PK_H_(0x19, 0x0B)
#define REG_SC_BK19_0C_L      _PK_L_(0x19, 0x0C)
#define REG_SC_BK19_0C_H      _PK_H_(0x19, 0x0C)
#define REG_SC_BK19_0D_L      _PK_L_(0x19, 0x0D)
#define REG_SC_BK19_0D_H      _PK_H_(0x19, 0x0D)
#define REG_SC_BK19_0E_L      _PK_L_(0x19, 0x0E)
#define REG_SC_BK19_0E_H      _PK_H_(0x19, 0x0E)
#define REG_SC_BK19_0F_L      _PK_L_(0x19, 0x0F)
#define REG_SC_BK19_0F_H      _PK_H_(0x19, 0x0F)
#define REG_SC_BK19_10_L      _PK_L_(0x19, 0x10)
#define REG_SC_BK19_10_H      _PK_H_(0x19, 0x10)
#define REG_SC_BK19_11_L      _PK_L_(0x19, 0x11)
#define REG_SC_BK19_11_H      _PK_H_(0x19, 0x11)
#define REG_SC_BK19_12_L      _PK_L_(0x19, 0x12)
#define REG_SC_BK19_12_H      _PK_H_(0x19, 0x12)
#define REG_SC_BK19_13_L      _PK_L_(0x19, 0x13)
#define REG_SC_BK19_13_H      _PK_H_(0x19, 0x13)
#define REG_SC_BK19_14_L      _PK_L_(0x19, 0x14)
#define REG_SC_BK19_14_H      _PK_H_(0x19, 0x14)
#define REG_SC_BK19_15_L      _PK_L_(0x19, 0x15)
#define REG_SC_BK19_15_H      _PK_H_(0x19, 0x15)
#define REG_SC_BK19_16_L      _PK_L_(0x19, 0x16)
#define REG_SC_BK19_16_H      _PK_H_(0x19, 0x16)
#define REG_SC_BK19_17_L      _PK_L_(0x19, 0x17)
#define REG_SC_BK19_17_H      _PK_H_(0x19, 0x17)
#define REG_SC_BK19_18_L      _PK_L_(0x19, 0x18)
#define REG_SC_BK19_18_H      _PK_H_(0x19, 0x18)
#define REG_SC_BK19_19_L      _PK_L_(0x19, 0x19)
#define REG_SC_BK19_19_H      _PK_H_(0x19, 0x19)
#define REG_SC_BK19_1A_L      _PK_L_(0x19, 0x1A)
#define REG_SC_BK19_1A_H      _PK_H_(0x19, 0x1A)
#define REG_SC_BK19_1B_L      _PK_L_(0x19, 0x1B)
#define REG_SC_BK19_1B_H      _PK_H_(0x19, 0x1B)
#define REG_SC_BK19_1C_L      _PK_L_(0x19, 0x1C)
#define REG_SC_BK19_1C_H      _PK_H_(0x19, 0x1C)
#define REG_SC_BK19_1D_L      _PK_L_(0x19, 0x1D)
#define REG_SC_BK19_1D_H      _PK_H_(0x19, 0x1D)
#define REG_SC_BK19_1E_L      _PK_L_(0x19, 0x1E)
#define REG_SC_BK19_1E_H      _PK_H_(0x19, 0x1E)
#define REG_SC_BK19_1F_L      _PK_L_(0x19, 0x1F)
#define REG_SC_BK19_1F_H      _PK_H_(0x19, 0x1F)
#define REG_SC_BK19_20_L      _PK_L_(0x19, 0x20)
#define REG_SC_BK19_20_H      _PK_H_(0x19, 0x20)
#define REG_SC_BK19_21_L      _PK_L_(0x19, 0x21)
#define REG_SC_BK19_21_H      _PK_H_(0x19, 0x21)
#define REG_SC_BK19_22_L      _PK_L_(0x19, 0x22)
#define REG_SC_BK19_22_H      _PK_H_(0x19, 0x22)
#define REG_SC_BK19_23_L      _PK_L_(0x19, 0x23)
#define REG_SC_BK19_23_H      _PK_H_(0x19, 0x23)
#define REG_SC_BK19_24_L      _PK_L_(0x19, 0x24)
#define REG_SC_BK19_24_H      _PK_H_(0x19, 0x24)
#define REG_SC_BK19_25_L      _PK_L_(0x19, 0x25)
#define REG_SC_BK19_25_H      _PK_H_(0x19, 0x25)
#define REG_SC_BK19_26_L      _PK_L_(0x19, 0x26)
#define REG_SC_BK19_26_H      _PK_H_(0x19, 0x26)
#define REG_SC_BK19_27_L      _PK_L_(0x19, 0x27)
#define REG_SC_BK19_27_H      _PK_H_(0x19, 0x27)
#define REG_SC_BK19_28_L      _PK_L_(0x19, 0x28)
#define REG_SC_BK19_28_H      _PK_H_(0x19, 0x28)
#define REG_SC_BK19_29_L      _PK_L_(0x19, 0x29)
#define REG_SC_BK19_29_H      _PK_H_(0x19, 0x29)
#define REG_SC_BK19_2A_L      _PK_L_(0x19, 0x2A)
#define REG_SC_BK19_2A_H      _PK_H_(0x19, 0x2A)
#define REG_SC_BK19_2B_L      _PK_L_(0x19, 0x2B)
#define REG_SC_BK19_2B_H      _PK_H_(0x19, 0x2B)
#define REG_SC_BK19_2C_L      _PK_L_(0x19, 0x2C)
#define REG_SC_BK19_2C_H      _PK_H_(0x19, 0x2C)
#define REG_SC_BK19_2D_L      _PK_L_(0x19, 0x2D)
#define REG_SC_BK19_2D_H      _PK_H_(0x19, 0x2D)
#define REG_SC_BK19_2E_L      _PK_L_(0x19, 0x2E)
#define REG_SC_BK19_2E_H      _PK_H_(0x19, 0x2E)
#define REG_SC_BK19_2F_L      _PK_L_(0x19, 0x2F)
#define REG_SC_BK19_2F_H      _PK_H_(0x19, 0x2F)
#define REG_SC_BK19_30_L      _PK_L_(0x19, 0x30)
#define REG_SC_BK19_30_H      _PK_H_(0x19, 0x30)
#define REG_SC_BK19_31_L      _PK_L_(0x19, 0x31)
#define REG_SC_BK19_31_H      _PK_H_(0x19, 0x31)
#define REG_SC_BK19_32_L      _PK_L_(0x19, 0x32)
#define REG_SC_BK19_32_H      _PK_H_(0x19, 0x32)
#define REG_SC_BK19_33_L      _PK_L_(0x19, 0x33)
#define REG_SC_BK19_33_H      _PK_H_(0x19, 0x33)
#define REG_SC_BK19_34_L      _PK_L_(0x19, 0x34)
#define REG_SC_BK19_34_H      _PK_H_(0x19, 0x34)
#define REG_SC_BK19_35_L      _PK_L_(0x19, 0x35)
#define REG_SC_BK19_35_H      _PK_H_(0x19, 0x35)
#define REG_SC_BK19_36_L      _PK_L_(0x19, 0x36)
#define REG_SC_BK19_36_H      _PK_H_(0x19, 0x36)
#define REG_SC_BK19_37_L      _PK_L_(0x19, 0x37)
#define REG_SC_BK19_37_H      _PK_H_(0x19, 0x37)
#define REG_SC_BK19_38_L      _PK_L_(0x19, 0x38)
#define REG_SC_BK19_38_H      _PK_H_(0x19, 0x38)
#define REG_SC_BK19_39_L      _PK_L_(0x19, 0x39)
#define REG_SC_BK19_39_H      _PK_H_(0x19, 0x39)
#define REG_SC_BK19_3A_L      _PK_L_(0x19, 0x3A)
#define REG_SC_BK19_3A_H      _PK_H_(0x19, 0x3A)
#define REG_SC_BK19_3B_L      _PK_L_(0x19, 0x3B)
#define REG_SC_BK19_3B_H      _PK_H_(0x19, 0x3B)
#define REG_SC_BK19_3C_L      _PK_L_(0x19, 0x3C)
#define REG_SC_BK19_3C_H      _PK_H_(0x19, 0x3C)
#define REG_SC_BK19_3D_L      _PK_L_(0x19, 0x3D)
#define REG_SC_BK19_3D_H      _PK_H_(0x19, 0x3D)
#define REG_SC_BK19_3E_L      _PK_L_(0x19, 0x3E)
#define REG_SC_BK19_3E_H      _PK_H_(0x19, 0x3E)
#define REG_SC_BK19_3F_L      _PK_L_(0x19, 0x3F)
#define REG_SC_BK19_3F_H      _PK_H_(0x19, 0x3F)
#define REG_SC_BK19_40_L      _PK_L_(0x19, 0x40)
#define REG_SC_BK19_40_H      _PK_H_(0x19, 0x40)
#define REG_SC_BK19_41_L      _PK_L_(0x19, 0x41)
#define REG_SC_BK19_41_H      _PK_H_(0x19, 0x41)
#define REG_SC_BK19_42_L      _PK_L_(0x19, 0x42)
#define REG_SC_BK19_42_H      _PK_H_(0x19, 0x42)
#define REG_SC_BK19_43_L      _PK_L_(0x19, 0x43)
#define REG_SC_BK19_43_H      _PK_H_(0x19, 0x43)
#define REG_SC_BK19_44_L      _PK_L_(0x19, 0x44)
#define REG_SC_BK19_44_H      _PK_H_(0x19, 0x44)
#define REG_SC_BK19_45_L      _PK_L_(0x19, 0x45)
#define REG_SC_BK19_45_H      _PK_H_(0x19, 0x45)
#define REG_SC_BK19_46_L      _PK_L_(0x19, 0x46)
#define REG_SC_BK19_46_H      _PK_H_(0x19, 0x46)
#define REG_SC_BK19_47_L      _PK_L_(0x19, 0x47)
#define REG_SC_BK19_47_H      _PK_H_(0x19, 0x47)
#define REG_SC_BK19_48_L      _PK_L_(0x19, 0x48)
#define REG_SC_BK19_48_H      _PK_H_(0x19, 0x48)
#define REG_SC_BK19_49_L      _PK_L_(0x19, 0x49)
#define REG_SC_BK19_49_H      _PK_H_(0x19, 0x49)
#define REG_SC_BK19_4A_L      _PK_L_(0x19, 0x4A)
#define REG_SC_BK19_4A_H      _PK_H_(0x19, 0x4A)
#define REG_SC_BK19_4B_L      _PK_L_(0x19, 0x4B)
#define REG_SC_BK19_4B_H      _PK_H_(0x19, 0x4B)
#define REG_SC_BK19_4C_L      _PK_L_(0x19, 0x4C)
#define REG_SC_BK19_4C_H      _PK_H_(0x19, 0x4C)
#define REG_SC_BK19_4D_L      _PK_L_(0x19, 0x4D)
#define REG_SC_BK19_4D_H      _PK_H_(0x19, 0x4D)
#define REG_SC_BK19_4E_L      _PK_L_(0x19, 0x4E)
#define REG_SC_BK19_4E_H      _PK_H_(0x19, 0x4E)
#define REG_SC_BK19_4F_L      _PK_L_(0x19, 0x4F)
#define REG_SC_BK19_4F_H      _PK_H_(0x19, 0x4F)
#define REG_SC_BK19_50_L      _PK_L_(0x19, 0x50)
#define REG_SC_BK19_50_H      _PK_H_(0x19, 0x50)
#define REG_SC_BK19_51_L      _PK_L_(0x19, 0x51)
#define REG_SC_BK19_51_H      _PK_H_(0x19, 0x51)
#define REG_SC_BK19_52_L      _PK_L_(0x19, 0x52)
#define REG_SC_BK19_52_H      _PK_H_(0x19, 0x52)
#define REG_SC_BK19_53_L      _PK_L_(0x19, 0x53)
#define REG_SC_BK19_53_H      _PK_H_(0x19, 0x53)
#define REG_SC_BK19_54_L      _PK_L_(0x19, 0x54)
#define REG_SC_BK19_54_H      _PK_H_(0x19, 0x54)
#define REG_SC_BK19_55_L      _PK_L_(0x19, 0x55)
#define REG_SC_BK19_55_H      _PK_H_(0x19, 0x55)
#define REG_SC_BK19_56_L      _PK_L_(0x19, 0x56)
#define REG_SC_BK19_56_H      _PK_H_(0x19, 0x56)
#define REG_SC_BK19_57_L      _PK_L_(0x19, 0x57)
#define REG_SC_BK19_57_H      _PK_H_(0x19, 0x57)
#define REG_SC_BK19_58_L      _PK_L_(0x19, 0x58)
#define REG_SC_BK19_58_H      _PK_H_(0x19, 0x58)
#define REG_SC_BK19_59_L      _PK_L_(0x19, 0x59)
#define REG_SC_BK19_59_H      _PK_H_(0x19, 0x59)
#define REG_SC_BK19_5A_L      _PK_L_(0x19, 0x5A)
#define REG_SC_BK19_5A_H      _PK_H_(0x19, 0x5A)
#define REG_SC_BK19_5B_L      _PK_L_(0x19, 0x5B)
#define REG_SC_BK19_5B_H      _PK_H_(0x19, 0x5B)
#define REG_SC_BK19_5C_L      _PK_L_(0x19, 0x5C)
#define REG_SC_BK19_5C_H      _PK_H_(0x19, 0x5C)
#define REG_SC_BK19_5D_L      _PK_L_(0x19, 0x5D)
#define REG_SC_BK19_5D_H      _PK_H_(0x19, 0x5D)
#define REG_SC_BK19_5E_L      _PK_L_(0x19, 0x5E)
#define REG_SC_BK19_5E_H      _PK_H_(0x19, 0x5E)
#define REG_SC_BK19_5F_L      _PK_L_(0x19, 0x5F)
#define REG_SC_BK19_5F_H      _PK_H_(0x19, 0x5F)
#define REG_SC_BK19_60_L      _PK_L_(0x19, 0x60)
#define REG_SC_BK19_60_H      _PK_H_(0x19, 0x60)
#define REG_SC_BK19_61_L      _PK_L_(0x19, 0x61)
#define REG_SC_BK19_61_H      _PK_H_(0x19, 0x61)
#define REG_SC_BK19_62_L      _PK_L_(0x19, 0x62)
#define REG_SC_BK19_62_H      _PK_H_(0x19, 0x62)
#define REG_SC_BK19_63_L      _PK_L_(0x19, 0x63)
#define REG_SC_BK19_63_H      _PK_H_(0x19, 0x63)
#define REG_SC_BK19_64_L      _PK_L_(0x19, 0x64)
#define REG_SC_BK19_64_H      _PK_H_(0x19, 0x64)
#define REG_SC_BK19_65_L      _PK_L_(0x19, 0x65)
#define REG_SC_BK19_65_H      _PK_H_(0x19, 0x65)
#define REG_SC_BK19_66_L      _PK_L_(0x19, 0x66)
#define REG_SC_BK19_66_H      _PK_H_(0x19, 0x66)
#define REG_SC_BK19_67_L      _PK_L_(0x19, 0x67)
#define REG_SC_BK19_67_H      _PK_H_(0x19, 0x67)
#define REG_SC_BK19_68_L      _PK_L_(0x19, 0x68)
#define REG_SC_BK19_68_H      _PK_H_(0x19, 0x68)
#define REG_SC_BK19_69_L      _PK_L_(0x19, 0x69)
#define REG_SC_BK19_69_H      _PK_H_(0x19, 0x69)
#define REG_SC_BK19_6A_L      _PK_L_(0x19, 0x6A)
#define REG_SC_BK19_6A_H      _PK_H_(0x19, 0x6A)
#define REG_SC_BK19_6B_L      _PK_L_(0x19, 0x6B)
#define REG_SC_BK19_6B_H      _PK_H_(0x19, 0x6B)
#define REG_SC_BK19_6C_L      _PK_L_(0x19, 0x6C)
#define REG_SC_BK19_6C_H      _PK_H_(0x19, 0x6C)
#define REG_SC_BK19_6D_L      _PK_L_(0x19, 0x6D)
#define REG_SC_BK19_6D_H      _PK_H_(0x19, 0x6D)
#define REG_SC_BK19_6E_L      _PK_L_(0x19, 0x6E)
#define REG_SC_BK19_6E_H      _PK_H_(0x19, 0x6E)
#define REG_SC_BK19_6F_L      _PK_L_(0x19, 0x6F)
#define REG_SC_BK19_6F_H      _PK_H_(0x19, 0x6F)
#define REG_SC_BK19_70_L      _PK_L_(0x19, 0x70)
#define REG_SC_BK19_70_H      _PK_H_(0x19, 0x70)
#define REG_SC_BK19_71_L      _PK_L_(0x19, 0x71)
#define REG_SC_BK19_71_H      _PK_H_(0x19, 0x71)
#define REG_SC_BK19_72_L      _PK_L_(0x19, 0x72)
#define REG_SC_BK19_72_H      _PK_H_(0x19, 0x72)
#define REG_SC_BK19_73_L      _PK_L_(0x19, 0x73)
#define REG_SC_BK19_73_H      _PK_H_(0x19, 0x73)
#define REG_SC_BK19_74_L      _PK_L_(0x19, 0x74)
#define REG_SC_BK19_74_H      _PK_H_(0x19, 0x74)
#define REG_SC_BK19_75_L      _PK_L_(0x19, 0x75)
#define REG_SC_BK19_75_H      _PK_H_(0x19, 0x75)
#define REG_SC_BK19_76_L      _PK_L_(0x19, 0x76)
#define REG_SC_BK19_76_H      _PK_H_(0x19, 0x76)
#define REG_SC_BK19_77_L      _PK_L_(0x19, 0x77)
#define REG_SC_BK19_77_H      _PK_H_(0x19, 0x77)
#define REG_SC_BK19_78_L      _PK_L_(0x19, 0x78)
#define REG_SC_BK19_78_H      _PK_H_(0x19, 0x78)
#define REG_SC_BK19_79_L      _PK_L_(0x19, 0x79)
#define REG_SC_BK19_79_H      _PK_H_(0x19, 0x79)
#define REG_SC_BK19_7A_L      _PK_L_(0x19, 0x7A)
#define REG_SC_BK19_7A_H      _PK_H_(0x19, 0x7A)
#define REG_SC_BK19_7B_L      _PK_L_(0x19, 0x7B)
#define REG_SC_BK19_7B_H      _PK_H_(0x19, 0x7B)
#define REG_SC_BK19_7C_L      _PK_L_(0x19, 0x7C)
#define REG_SC_BK19_7C_H      _PK_H_(0x19, 0x7C)
#define REG_SC_BK19_7D_L      _PK_L_(0x19, 0x7D)
#define REG_SC_BK19_7D_H      _PK_H_(0x19, 0x7D)
#define REG_SC_BK19_7E_L      _PK_L_(0x19, 0x7E)
#define REG_SC_BK19_7E_H      _PK_H_(0x19, 0x7E)
#define REG_SC_BK19_7F_L      _PK_L_(0x19, 0x7F)
#define REG_SC_BK19_7F_H      _PK_H_(0x19, 0x7F)

//----------------------------------------------
//  BK1A: DLC
//----------------------------------------------
#define REG_SC_BK1A_00_L      _PK_L_(0x1A, 0x00)
#define REG_SC_BK1A_00_H      _PK_H_(0x1A, 0x00)
#define REG_SC_BK1A_01_L      _PK_L_(0x1A, 0x01)
#define REG_SC_BK1A_01_H      _PK_H_(0x1A, 0x01)
#define REG_SC_BK1A_02_L      _PK_L_(0x1A, 0x02)
#define REG_SC_BK1A_02_H      _PK_H_(0x1A, 0x02)
#define REG_SC_BK1A_03_L      _PK_L_(0x1A, 0x03)
#define REG_SC_BK1A_03_H      _PK_H_(0x1A, 0x03)
#define REG_SC_BK1A_04_L      _PK_L_(0x1A, 0x04)
#define REG_SC_BK1A_04_H      _PK_H_(0x1A, 0x04)
#define REG_SC_BK1A_05_L      _PK_L_(0x1A, 0x05)
#define REG_SC_BK1A_05_H      _PK_H_(0x1A, 0x05)
#define REG_SC_BK1A_06_L      _PK_L_(0x1A, 0x06)
#define REG_SC_BK1A_06_H      _PK_H_(0x1A, 0x06)
#define REG_SC_BK1A_07_L      _PK_L_(0x1A, 0x07)
#define REG_SC_BK1A_07_H      _PK_H_(0x1A, 0x07)
#define REG_SC_BK1A_08_L      _PK_L_(0x1A, 0x08)
#define REG_SC_BK1A_08_H      _PK_H_(0x1A, 0x08)
#define REG_SC_BK1A_09_L      _PK_L_(0x1A, 0x09)
#define REG_SC_BK1A_09_H      _PK_H_(0x1A, 0x09)
#define REG_SC_BK1A_0A_L      _PK_L_(0x1A, 0x0A)
#define REG_SC_BK1A_0A_H      _PK_H_(0x1A, 0x0A)
#define REG_SC_BK1A_0B_L      _PK_L_(0x1A, 0x0B)
#define REG_SC_BK1A_0B_H      _PK_H_(0x1A, 0x0B)
#define REG_SC_BK1A_0C_L      _PK_L_(0x1A, 0x0C)
#define REG_SC_BK1A_0C_H      _PK_H_(0x1A, 0x0C)
#define REG_SC_BK1A_0D_L      _PK_L_(0x1A, 0x0D)
#define REG_SC_BK1A_0D_H      _PK_H_(0x1A, 0x0D)
#define REG_SC_BK1A_0E_L      _PK_L_(0x1A, 0x0E)
#define REG_SC_BK1A_0E_H      _PK_H_(0x1A, 0x0E)
#define REG_SC_BK1A_0F_L      _PK_L_(0x1A, 0x0F)
#define REG_SC_BK1A_0F_H      _PK_H_(0x1A, 0x0F)
#define REG_SC_BK1A_10_L      _PK_L_(0x1A, 0x10)
#define REG_SC_BK1A_10_H      _PK_H_(0x1A, 0x10)
#define REG_SC_BK1A_11_L      _PK_L_(0x1A, 0x11)
#define REG_SC_BK1A_11_H      _PK_H_(0x1A, 0x11)
#define REG_SC_BK1A_12_L      _PK_L_(0x1A, 0x12)
#define REG_SC_BK1A_12_H      _PK_H_(0x1A, 0x12)
#define REG_SC_BK1A_13_L      _PK_L_(0x1A, 0x13)
#define REG_SC_BK1A_13_H      _PK_H_(0x1A, 0x13)
#define REG_SC_BK1A_14_L      _PK_L_(0x1A, 0x14)
#define REG_SC_BK1A_14_H      _PK_H_(0x1A, 0x14)
#define REG_SC_BK1A_15_L      _PK_L_(0x1A, 0x15)
#define REG_SC_BK1A_15_H      _PK_H_(0x1A, 0x15)
#define REG_SC_BK1A_16_L      _PK_L_(0x1A, 0x16)
#define REG_SC_BK1A_16_H      _PK_H_(0x1A, 0x16)
#define REG_SC_BK1A_17_L      _PK_L_(0x1A, 0x17)
#define REG_SC_BK1A_17_H      _PK_H_(0x1A, 0x17)
#define REG_SC_BK1A_18_L      _PK_L_(0x1A, 0x18)
#define REG_SC_BK1A_18_H      _PK_H_(0x1A, 0x18)
#define REG_SC_BK1A_19_L      _PK_L_(0x1A, 0x19)
#define REG_SC_BK1A_19_H      _PK_H_(0x1A, 0x19)
#define REG_SC_BK1A_1A_L      _PK_L_(0x1A, 0x1A)
#define REG_SC_BK1A_1A_H      _PK_H_(0x1A, 0x1A)
#define REG_SC_BK1A_1B_L      _PK_L_(0x1A, 0x1B)
#define REG_SC_BK1A_1B_H      _PK_H_(0x1A, 0x1B)
#define REG_SC_BK1A_1C_L      _PK_L_(0x1A, 0x1C)
#define REG_SC_BK1A_1C_H      _PK_H_(0x1A, 0x1C)
#define REG_SC_BK1A_1D_L      _PK_L_(0x1A, 0x1D)
#define REG_SC_BK1A_1D_H      _PK_H_(0x1A, 0x1D)
#define REG_SC_BK1A_1E_L      _PK_L_(0x1A, 0x1E)
#define REG_SC_BK1A_1E_H      _PK_H_(0x1A, 0x1E)
#define REG_SC_BK1A_1F_L      _PK_L_(0x1A, 0x1F)
#define REG_SC_BK1A_1F_H      _PK_H_(0x1A, 0x1F)
#define REG_SC_BK1A_20_L      _PK_L_(0x1A, 0x20)
#define REG_SC_BK1A_20_H      _PK_H_(0x1A, 0x20)
#define REG_SC_BK1A_21_L      _PK_L_(0x1A, 0x21)
#define REG_SC_BK1A_21_H      _PK_H_(0x1A, 0x21)
#define REG_SC_BK1A_22_L      _PK_L_(0x1A, 0x22)
#define REG_SC_BK1A_22_H      _PK_H_(0x1A, 0x22)
#define REG_SC_BK1A_23_L      _PK_L_(0x1A, 0x23)
#define REG_SC_BK1A_23_H      _PK_H_(0x1A, 0x23)
#define REG_SC_BK1A_24_L      _PK_L_(0x1A, 0x24)
#define REG_SC_BK1A_24_H      _PK_H_(0x1A, 0x24)
#define REG_SC_BK1A_25_L      _PK_L_(0x1A, 0x25)
#define REG_SC_BK1A_25_H      _PK_H_(0x1A, 0x25)
#define REG_SC_BK1A_26_L      _PK_L_(0x1A, 0x26)
#define REG_SC_BK1A_26_H      _PK_H_(0x1A, 0x26)
#define REG_SC_BK1A_27_L      _PK_L_(0x1A, 0x27)
#define REG_SC_BK1A_27_H      _PK_H_(0x1A, 0x27)
#define REG_SC_BK1A_28_L      _PK_L_(0x1A, 0x28)
#define REG_SC_BK1A_28_H      _PK_H_(0x1A, 0x28)
#define REG_SC_BK1A_29_L      _PK_L_(0x1A, 0x29)
#define REG_SC_BK1A_29_H      _PK_H_(0x1A, 0x29)
#define REG_SC_BK1A_2A_L      _PK_L_(0x1A, 0x2A)
#define REG_SC_BK1A_2A_H      _PK_H_(0x1A, 0x2A)
#define REG_SC_BK1A_2B_L      _PK_L_(0x1A, 0x2B)
#define REG_SC_BK1A_2B_H      _PK_H_(0x1A, 0x2B)
#define REG_SC_BK1A_2C_L      _PK_L_(0x1A, 0x2C)
#define REG_SC_BK1A_2C_H      _PK_H_(0x1A, 0x2C)
#define REG_SC_BK1A_2D_L      _PK_L_(0x1A, 0x2D)
#define REG_SC_BK1A_2D_H      _PK_H_(0x1A, 0x2D)
#define REG_SC_BK1A_2E_L      _PK_L_(0x1A, 0x2E)
#define REG_SC_BK1A_2E_H      _PK_H_(0x1A, 0x2E)
#define REG_SC_BK1A_2F_L      _PK_L_(0x1A, 0x2F)
#define REG_SC_BK1A_2F_H      _PK_H_(0x1A, 0x2F)
#define REG_SC_BK1A_30_L      _PK_L_(0x1A, 0x30)
#define REG_SC_BK1A_30_H      _PK_H_(0x1A, 0x30)
#define REG_SC_BK1A_31_L      _PK_L_(0x1A, 0x31)
#define REG_SC_BK1A_31_H      _PK_H_(0x1A, 0x31)
#define REG_SC_BK1A_32_L      _PK_L_(0x1A, 0x32)
#define REG_SC_BK1A_32_H      _PK_H_(0x1A, 0x32)
#define REG_SC_BK1A_33_L      _PK_L_(0x1A, 0x33)
#define REG_SC_BK1A_33_H      _PK_H_(0x1A, 0x33)
#define REG_SC_BK1A_34_L      _PK_L_(0x1A, 0x34)
#define REG_SC_BK1A_34_H      _PK_H_(0x1A, 0x34)
#define REG_SC_BK1A_35_L      _PK_L_(0x1A, 0x35)
#define REG_SC_BK1A_35_H      _PK_H_(0x1A, 0x35)
#define REG_SC_BK1A_36_L      _PK_L_(0x1A, 0x36)
#define REG_SC_BK1A_36_H      _PK_H_(0x1A, 0x36)
#define REG_SC_BK1A_37_L      _PK_L_(0x1A, 0x37)
#define REG_SC_BK1A_37_H      _PK_H_(0x1A, 0x37)
#define REG_SC_BK1A_38_L      _PK_L_(0x1A, 0x38)
#define REG_SC_BK1A_38_H      _PK_H_(0x1A, 0x38)
#define REG_SC_BK1A_39_L      _PK_L_(0x1A, 0x39)
#define REG_SC_BK1A_39_H      _PK_H_(0x1A, 0x39)
#define REG_SC_BK1A_3A_L      _PK_L_(0x1A, 0x3A)
#define REG_SC_BK1A_3A_H      _PK_H_(0x1A, 0x3A)
#define REG_SC_BK1A_3B_L      _PK_L_(0x1A, 0x3B)
#define REG_SC_BK1A_3B_H      _PK_H_(0x1A, 0x3B)
#define REG_SC_BK1A_3C_L      _PK_L_(0x1A, 0x3C)
#define REG_SC_BK1A_3C_H      _PK_H_(0x1A, 0x3C)
#define REG_SC_BK1A_3D_L      _PK_L_(0x1A, 0x3D)
#define REG_SC_BK1A_3D_H      _PK_H_(0x1A, 0x3D)
#define REG_SC_BK1A_3E_L      _PK_L_(0x1A, 0x3E)
#define REG_SC_BK1A_3E_H      _PK_H_(0x1A, 0x3E)
#define REG_SC_BK1A_3F_L      _PK_L_(0x1A, 0x3F)
#define REG_SC_BK1A_3F_H      _PK_H_(0x1A, 0x3F)
#define REG_SC_BK1A_40_L      _PK_L_(0x1A, 0x40)
#define REG_SC_BK1A_40_H      _PK_H_(0x1A, 0x40)
#define REG_SC_BK1A_41_L      _PK_L_(0x1A, 0x41)
#define REG_SC_BK1A_41_H      _PK_H_(0x1A, 0x41)
#define REG_SC_BK1A_42_L      _PK_L_(0x1A, 0x42)
#define REG_SC_BK1A_42_H      _PK_H_(0x1A, 0x42)
#define REG_SC_BK1A_43_L      _PK_L_(0x1A, 0x43)
#define REG_SC_BK1A_43_H      _PK_H_(0x1A, 0x43)
#define REG_SC_BK1A_44_L      _PK_L_(0x1A, 0x44)
#define REG_SC_BK1A_44_H      _PK_H_(0x1A, 0x44)
#define REG_SC_BK1A_45_L      _PK_L_(0x1A, 0x45)
#define REG_SC_BK1A_45_H      _PK_H_(0x1A, 0x45)
#define REG_SC_BK1A_46_L      _PK_L_(0x1A, 0x46)
#define REG_SC_BK1A_46_H      _PK_H_(0x1A, 0x46)
#define REG_SC_BK1A_47_L      _PK_L_(0x1A, 0x47)
#define REG_SC_BK1A_47_H      _PK_H_(0x1A, 0x47)
#define REG_SC_BK1A_48_L      _PK_L_(0x1A, 0x48)
#define REG_SC_BK1A_48_H      _PK_H_(0x1A, 0x48)
#define REG_SC_BK1A_49_L      _PK_L_(0x1A, 0x49)
#define REG_SC_BK1A_49_H      _PK_H_(0x1A, 0x49)
#define REG_SC_BK1A_4A_L      _PK_L_(0x1A, 0x4A)
#define REG_SC_BK1A_4A_H      _PK_H_(0x1A, 0x4A)
#define REG_SC_BK1A_4B_L      _PK_L_(0x1A, 0x4B)
#define REG_SC_BK1A_4B_H      _PK_H_(0x1A, 0x4B)
#define REG_SC_BK1A_4C_L      _PK_L_(0x1A, 0x4C)
#define REG_SC_BK1A_4C_H      _PK_H_(0x1A, 0x4C)
#define REG_SC_BK1A_4D_L      _PK_L_(0x1A, 0x4D)
#define REG_SC_BK1A_4D_H      _PK_H_(0x1A, 0x4D)
#define REG_SC_BK1A_4E_L      _PK_L_(0x1A, 0x4E)
#define REG_SC_BK1A_4E_H      _PK_H_(0x1A, 0x4E)
#define REG_SC_BK1A_4F_L      _PK_L_(0x1A, 0x4F)
#define REG_SC_BK1A_4F_H      _PK_H_(0x1A, 0x4F)
#define REG_SC_BK1A_50_L      _PK_L_(0x1A, 0x50)
#define REG_SC_BK1A_50_H      _PK_H_(0x1A, 0x50)
#define REG_SC_BK1A_51_L      _PK_L_(0x1A, 0x51)
#define REG_SC_BK1A_51_H      _PK_H_(0x1A, 0x51)
#define REG_SC_BK1A_52_L      _PK_L_(0x1A, 0x52)
#define REG_SC_BK1A_52_H      _PK_H_(0x1A, 0x52)
#define REG_SC_BK1A_53_L      _PK_L_(0x1A, 0x53)
#define REG_SC_BK1A_53_H      _PK_H_(0x1A, 0x53)
#define REG_SC_BK1A_54_L      _PK_L_(0x1A, 0x54)
#define REG_SC_BK1A_54_H      _PK_H_(0x1A, 0x54)
#define REG_SC_BK1A_55_L      _PK_L_(0x1A, 0x55)
#define REG_SC_BK1A_55_H      _PK_H_(0x1A, 0x55)
#define REG_SC_BK1A_56_L      _PK_L_(0x1A, 0x56)
#define REG_SC_BK1A_56_H      _PK_H_(0x1A, 0x56)
#define REG_SC_BK1A_57_L      _PK_L_(0x1A, 0x57)
#define REG_SC_BK1A_57_H      _PK_H_(0x1A, 0x57)
#define REG_SC_BK1A_58_L      _PK_L_(0x1A, 0x58)
#define REG_SC_BK1A_58_H      _PK_H_(0x1A, 0x58)
#define REG_SC_BK1A_59_L      _PK_L_(0x1A, 0x59)
#define REG_SC_BK1A_59_H      _PK_H_(0x1A, 0x59)
#define REG_SC_BK1A_5A_L      _PK_L_(0x1A, 0x5A)
#define REG_SC_BK1A_5A_H      _PK_H_(0x1A, 0x5A)
#define REG_SC_BK1A_5B_L      _PK_L_(0x1A, 0x5B)
#define REG_SC_BK1A_5B_H      _PK_H_(0x1A, 0x5B)
#define REG_SC_BK1A_5C_L      _PK_L_(0x1A, 0x5C)
#define REG_SC_BK1A_5C_H      _PK_H_(0x1A, 0x5C)
#define REG_SC_BK1A_5D_L      _PK_L_(0x1A, 0x5D)
#define REG_SC_BK1A_5D_H      _PK_H_(0x1A, 0x5D)
#define REG_SC_BK1A_5E_L      _PK_L_(0x1A, 0x5E)
#define REG_SC_BK1A_5E_H      _PK_H_(0x1A, 0x5E)
#define REG_SC_BK1A_5F_L      _PK_L_(0x1A, 0x5F)
#define REG_SC_BK1A_5F_H      _PK_H_(0x1A, 0x5F)
#define REG_SC_BK1A_60_L      _PK_L_(0x1A, 0x60)
#define REG_SC_BK1A_60_H      _PK_H_(0x1A, 0x60)
#define REG_SC_BK1A_61_L      _PK_L_(0x1A, 0x61)
#define REG_SC_BK1A_61_H      _PK_H_(0x1A, 0x61)
#define REG_SC_BK1A_62_L      _PK_L_(0x1A, 0x62)
#define REG_SC_BK1A_62_H      _PK_H_(0x1A, 0x62)
#define REG_SC_BK1A_63_L      _PK_L_(0x1A, 0x63)
#define REG_SC_BK1A_63_H      _PK_H_(0x1A, 0x63)
#define REG_SC_BK1A_64_L      _PK_L_(0x1A, 0x64)
#define REG_SC_BK1A_64_H      _PK_H_(0x1A, 0x64)
#define REG_SC_BK1A_65_L      _PK_L_(0x1A, 0x65)
#define REG_SC_BK1A_65_H      _PK_H_(0x1A, 0x65)
#define REG_SC_BK1A_66_L      _PK_L_(0x1A, 0x66)
#define REG_SC_BK1A_66_H      _PK_H_(0x1A, 0x66)
#define REG_SC_BK1A_67_L      _PK_L_(0x1A, 0x67)
#define REG_SC_BK1A_67_H      _PK_H_(0x1A, 0x67)
#define REG_SC_BK1A_68_L      _PK_L_(0x1A, 0x68)
#define REG_SC_BK1A_68_H      _PK_H_(0x1A, 0x68)
#define REG_SC_BK1A_69_L      _PK_L_(0x1A, 0x69)
#define REG_SC_BK1A_69_H      _PK_H_(0x1A, 0x69)
#define REG_SC_BK1A_6A_L      _PK_L_(0x1A, 0x6A)
#define REG_SC_BK1A_6A_H      _PK_H_(0x1A, 0x6A)
#define REG_SC_BK1A_6B_L      _PK_L_(0x1A, 0x6B)
#define REG_SC_BK1A_6B_H      _PK_H_(0x1A, 0x6B)
#define REG_SC_BK1A_6C_L      _PK_L_(0x1A, 0x6C)
#define REG_SC_BK1A_6C_H      _PK_H_(0x1A, 0x6C)
#define REG_SC_BK1A_6D_L      _PK_L_(0x1A, 0x6D)
#define REG_SC_BK1A_6D_H      _PK_H_(0x1A, 0x6D)
#define REG_SC_BK1A_6E_L      _PK_L_(0x1A, 0x6E)
#define REG_SC_BK1A_6E_H      _PK_H_(0x1A, 0x6E)
#define REG_SC_BK1A_6F_L      _PK_L_(0x1A, 0x6F)
#define REG_SC_BK1A_6F_H      _PK_H_(0x1A, 0x6F)
#define REG_SC_BK1A_70_L      _PK_L_(0x1A, 0x70)
#define REG_SC_BK1A_70_H      _PK_H_(0x1A, 0x70)
#define REG_SC_BK1A_71_L      _PK_L_(0x1A, 0x71)
#define REG_SC_BK1A_71_H      _PK_H_(0x1A, 0x71)
#define REG_SC_BK1A_72_L      _PK_L_(0x1A, 0x72)
#define REG_SC_BK1A_72_H      _PK_H_(0x1A, 0x72)
#define REG_SC_BK1A_73_L      _PK_L_(0x1A, 0x73)
#define REG_SC_BK1A_73_H      _PK_H_(0x1A, 0x73)
#define REG_SC_BK1A_74_L      _PK_L_(0x1A, 0x74)
#define REG_SC_BK1A_74_H      _PK_H_(0x1A, 0x74)
#define REG_SC_BK1A_75_L      _PK_L_(0x1A, 0x75)
#define REG_SC_BK1A_75_H      _PK_H_(0x1A, 0x75)
#define REG_SC_BK1A_76_L      _PK_L_(0x1A, 0x76)
#define REG_SC_BK1A_76_H      _PK_H_(0x1A, 0x76)
#define REG_SC_BK1A_77_L      _PK_L_(0x1A, 0x77)
#define REG_SC_BK1A_77_H      _PK_H_(0x1A, 0x77)
#define REG_SC_BK1A_78_L      _PK_L_(0x1A, 0x78)
#define REG_SC_BK1A_78_H      _PK_H_(0x1A, 0x78)
#define REG_SC_BK1A_79_L      _PK_L_(0x1A, 0x79)
#define REG_SC_BK1A_79_H      _PK_H_(0x1A, 0x79)
#define REG_SC_BK1A_7A_L      _PK_L_(0x1A, 0x7A)
#define REG_SC_BK1A_7A_H      _PK_H_(0x1A, 0x7A)
#define REG_SC_BK1A_7B_L      _PK_L_(0x1A, 0x7B)
#define REG_SC_BK1A_7B_H      _PK_H_(0x1A, 0x7B)
#define REG_SC_BK1A_7C_L      _PK_L_(0x1A, 0x7C)
#define REG_SC_BK1A_7C_H      _PK_H_(0x1A, 0x7C)
#define REG_SC_BK1A_7D_L      _PK_L_(0x1A, 0x7D)
#define REG_SC_BK1A_7D_H      _PK_H_(0x1A, 0x7D)
#define REG_SC_BK1A_7E_L      _PK_L_(0x1A, 0x7E)
#define REG_SC_BK1A_7E_H      _PK_H_(0x1A, 0x7E)
#define REG_SC_BK1A_7F_L      _PK_L_(0x1A, 0x7F)
#define REG_SC_BK1A_7F_H      _PK_H_(0x1A, 0x7F)

////
////?????????????????????????

#define REG_SC_BK1B_00_L      _PK_L_(0x1B, 0x00)
#define REG_SC_BK1B_00_H      _PK_H_(0x1B, 0x00)
#define REG_SC_BK1B_01_L      _PK_L_(0x1B, 0x01)
#define REG_SC_BK1B_01_H      _PK_H_(0x1B, 0x01)
#define REG_SC_BK1B_02_L      _PK_L_(0x1B, 0x02)
#define REG_SC_BK1B_02_H      _PK_H_(0x1B, 0x02)
#define REG_SC_BK1B_03_L      _PK_L_(0x1B, 0x03)
#define REG_SC_BK1B_03_H      _PK_H_(0x1B, 0x03)
#define REG_SC_BK1B_04_L      _PK_L_(0x1B, 0x04)
#define REG_SC_BK1B_04_H      _PK_H_(0x1B, 0x04)
#define REG_SC_BK1B_05_L      _PK_L_(0x1B, 0x05)
#define REG_SC_BK1B_05_H      _PK_H_(0x1B, 0x05)
#define REG_SC_BK1B_06_L      _PK_L_(0x1B, 0x06)
#define REG_SC_BK1B_06_H      _PK_H_(0x1B, 0x06)
#define REG_SC_BK1B_07_L      _PK_L_(0x1B, 0x07)
#define REG_SC_BK1B_07_H      _PK_H_(0x1B, 0x07)
#define REG_SC_BK1B_08_L      _PK_L_(0x1B, 0x08)
#define REG_SC_BK1B_08_H      _PK_H_(0x1B, 0x08)
#define REG_SC_BK1B_09_L      _PK_L_(0x1B, 0x09)
#define REG_SC_BK1B_09_H      _PK_H_(0x1B, 0x09)
#define REG_SC_BK1B_0A_L      _PK_L_(0x1B, 0x0A)
#define REG_SC_BK1B_0A_H      _PK_H_(0x1B, 0x0A)
#define REG_SC_BK1B_0B_L      _PK_L_(0x1B, 0x0B)
#define REG_SC_BK1B_0B_H      _PK_H_(0x1B, 0x0B)
#define REG_SC_BK1B_0C_L      _PK_L_(0x1B, 0x0C)
#define REG_SC_BK1B_0C_H      _PK_H_(0x1B, 0x0C)
#define REG_SC_BK1B_0D_L      _PK_L_(0x1B, 0x0D)
#define REG_SC_BK1B_0D_H      _PK_H_(0x1B, 0x0D)
#define REG_SC_BK1B_0E_L      _PK_L_(0x1B, 0x0E)
#define REG_SC_BK1B_0E_H      _PK_H_(0x1B, 0x0E)
#define REG_SC_BK1B_0F_L      _PK_L_(0x1B, 0x0F)
#define REG_SC_BK1B_0F_H      _PK_H_(0x1B, 0x0F)
#define REG_SC_BK1B_10_L      _PK_L_(0x1B, 0x10)
#define REG_SC_BK1B_10_H      _PK_H_(0x1B, 0x10)
#define REG_SC_BK1B_11_L      _PK_L_(0x1B, 0x11)
#define REG_SC_BK1B_11_H      _PK_H_(0x1B, 0x11)
#define REG_SC_BK1B_12_L      _PK_L_(0x1B, 0x12)
#define REG_SC_BK1B_12_H      _PK_H_(0x1B, 0x12)
#define REG_SC_BK1B_13_L      _PK_L_(0x1B, 0x13)
#define REG_SC_BK1B_13_H      _PK_H_(0x1B, 0x13)
#define REG_SC_BK1B_14_L      _PK_L_(0x1B, 0x14)
#define REG_SC_BK1B_14_H      _PK_H_(0x1B, 0x14)
#define REG_SC_BK1B_15_L      _PK_L_(0x1B, 0x15)
#define REG_SC_BK1B_15_H      _PK_H_(0x1B, 0x15)
#define REG_SC_BK1B_16_L      _PK_L_(0x1B, 0x16)
#define REG_SC_BK1B_16_H      _PK_H_(0x1B, 0x16)
#define REG_SC_BK1B_17_L      _PK_L_(0x1B, 0x17)
#define REG_SC_BK1B_17_H      _PK_H_(0x1B, 0x17)
#define REG_SC_BK1B_18_L      _PK_L_(0x1B, 0x18)
#define REG_SC_BK1B_18_H      _PK_H_(0x1B, 0x18)
#define REG_SC_BK1B_19_L      _PK_L_(0x1B, 0x19)
#define REG_SC_BK1B_19_H      _PK_H_(0x1B, 0x19)
#define REG_SC_BK1B_1A_L      _PK_L_(0x1B, 0x1A)
#define REG_SC_BK1B_1A_H      _PK_H_(0x1B, 0x1A)
#define REG_SC_BK1B_1B_L      _PK_L_(0x1B, 0x1B)
#define REG_SC_BK1B_1B_H      _PK_H_(0x1B, 0x1B)
#define REG_SC_BK1B_1C_L      _PK_L_(0x1B, 0x1C)
#define REG_SC_BK1B_1C_H      _PK_H_(0x1B, 0x1C)
#define REG_SC_BK1B_1D_L      _PK_L_(0x1B, 0x1D)
#define REG_SC_BK1B_1D_H      _PK_H_(0x1B, 0x1D)
#define REG_SC_BK1B_1E_L      _PK_L_(0x1B, 0x1E)
#define REG_SC_BK1B_1E_H      _PK_H_(0x1B, 0x1E)
#define REG_SC_BK1B_1F_L      _PK_L_(0x1B, 0x1F)
#define REG_SC_BK1B_1F_H      _PK_H_(0x1B, 0x1F)
#define REG_SC_BK1B_20_L      _PK_L_(0x1B, 0x20)
#define REG_SC_BK1B_20_H      _PK_H_(0x1B, 0x20)
#define REG_SC_BK1B_21_L      _PK_L_(0x1B, 0x21)
#define REG_SC_BK1B_21_H      _PK_H_(0x1B, 0x21)
#define REG_SC_BK1B_22_L      _PK_L_(0x1B, 0x22)
#define REG_SC_BK1B_22_H      _PK_H_(0x1B, 0x22)
#define REG_SC_BK1B_23_L      _PK_L_(0x1B, 0x23)
#define REG_SC_BK1B_23_H      _PK_H_(0x1B, 0x23)
#define REG_SC_BK1B_24_L      _PK_L_(0x1B, 0x24)
#define REG_SC_BK1B_24_H      _PK_H_(0x1B, 0x24)
#define REG_SC_BK1B_25_L      _PK_L_(0x1B, 0x25)
#define REG_SC_BK1B_25_H      _PK_H_(0x1B, 0x25)
#define REG_SC_BK1B_26_L      _PK_L_(0x1B, 0x26)
#define REG_SC_BK1B_26_H      _PK_H_(0x1B, 0x26)
#define REG_SC_BK1B_27_L      _PK_L_(0x1B, 0x27)
#define REG_SC_BK1B_27_H      _PK_H_(0x1B, 0x27)
#define REG_SC_BK1B_28_L      _PK_L_(0x1B, 0x28)
#define REG_SC_BK1B_28_H      _PK_H_(0x1B, 0x28)
#define REG_SC_BK1B_29_L      _PK_L_(0x1B, 0x29)
#define REG_SC_BK1B_29_H      _PK_H_(0x1B, 0x29)
#define REG_SC_BK1B_2A_L      _PK_L_(0x1B, 0x2A)
#define REG_SC_BK1B_2A_H      _PK_H_(0x1B, 0x2A)
#define REG_SC_BK1B_2B_L      _PK_L_(0x1B, 0x2B)
#define REG_SC_BK1B_2B_H      _PK_H_(0x1B, 0x2B)
#define REG_SC_BK1B_2C_L      _PK_L_(0x1B, 0x2C)
#define REG_SC_BK1B_2C_H      _PK_H_(0x1B, 0x2C)
#define REG_SC_BK1B_2D_L      _PK_L_(0x1B, 0x2D)
#define REG_SC_BK1B_2D_H      _PK_H_(0x1B, 0x2D)
#define REG_SC_BK1B_2E_L      _PK_L_(0x1B, 0x2E)
#define REG_SC_BK1B_2E_H      _PK_H_(0x1B, 0x2E)
#define REG_SC_BK1B_2F_L      _PK_L_(0x1B, 0x2F)
#define REG_SC_BK1B_2F_H      _PK_H_(0x1B, 0x2F)
#define REG_SC_BK1B_30_L      _PK_L_(0x1B, 0x30)
#define REG_SC_BK1B_30_H      _PK_H_(0x1B, 0x30)
#define REG_SC_BK1B_31_L      _PK_L_(0x1B, 0x31)
#define REG_SC_BK1B_31_H      _PK_H_(0x1B, 0x31)
#define REG_SC_BK1B_32_L      _PK_L_(0x1B, 0x32)
#define REG_SC_BK1B_32_H      _PK_H_(0x1B, 0x32)
#define REG_SC_BK1B_33_L      _PK_L_(0x1B, 0x33)
#define REG_SC_BK1B_33_H      _PK_H_(0x1B, 0x33)
#define REG_SC_BK1B_34_L      _PK_L_(0x1B, 0x34)
#define REG_SC_BK1B_34_H      _PK_H_(0x1B, 0x34)
#define REG_SC_BK1B_35_L      _PK_L_(0x1B, 0x35)
#define REG_SC_BK1B_35_H      _PK_H_(0x1B, 0x35)
#define REG_SC_BK1B_36_L      _PK_L_(0x1B, 0x36)
#define REG_SC_BK1B_36_H      _PK_H_(0x1B, 0x36)
#define REG_SC_BK1B_37_L      _PK_L_(0x1B, 0x37)
#define REG_SC_BK1B_37_H      _PK_H_(0x1B, 0x37)
#define REG_SC_BK1B_38_L      _PK_L_(0x1B, 0x38)
#define REG_SC_BK1B_38_H      _PK_H_(0x1B, 0x38)
#define REG_SC_BK1B_39_L      _PK_L_(0x1B, 0x39)
#define REG_SC_BK1B_39_H      _PK_H_(0x1B, 0x39)
#define REG_SC_BK1B_3A_L      _PK_L_(0x1B, 0x3A)
#define REG_SC_BK1B_3A_H      _PK_H_(0x1B, 0x3A)
#define REG_SC_BK1B_3B_L      _PK_L_(0x1B, 0x3B)
#define REG_SC_BK1B_3B_H      _PK_H_(0x1B, 0x3B)
#define REG_SC_BK1B_3C_L      _PK_L_(0x1B, 0x3C)
#define REG_SC_BK1B_3C_H      _PK_H_(0x1B, 0x3C)
#define REG_SC_BK1B_3D_L      _PK_L_(0x1B, 0x3D)
#define REG_SC_BK1B_3D_H      _PK_H_(0x1B, 0x3D)
#define REG_SC_BK1B_3E_L      _PK_L_(0x1B, 0x3E)
#define REG_SC_BK1B_3E_H      _PK_H_(0x1B, 0x3E)
#define REG_SC_BK1B_3F_L      _PK_L_(0x1B, 0x3F)
#define REG_SC_BK1B_3F_H      _PK_H_(0x1B, 0x3F)
#define REG_SC_BK1B_40_L      _PK_L_(0x1B, 0x40)
#define REG_SC_BK1B_40_H      _PK_H_(0x1B, 0x40)
#define REG_SC_BK1B_41_L      _PK_L_(0x1B, 0x41)
#define REG_SC_BK1B_41_H      _PK_H_(0x1B, 0x41)
#define REG_SC_BK1B_42_L      _PK_L_(0x1B, 0x42)
#define REG_SC_BK1B_42_H      _PK_H_(0x1B, 0x42)
#define REG_SC_BK1B_43_L      _PK_L_(0x1B, 0x43)
#define REG_SC_BK1B_43_H      _PK_H_(0x1B, 0x43)
#define REG_SC_BK1B_44_L      _PK_L_(0x1B, 0x44)
#define REG_SC_BK1B_44_H      _PK_H_(0x1B, 0x44)
#define REG_SC_BK1B_45_L      _PK_L_(0x1B, 0x45)
#define REG_SC_BK1B_45_H      _PK_H_(0x1B, 0x45)
#define REG_SC_BK1B_46_L      _PK_L_(0x1B, 0x46)
#define REG_SC_BK1B_46_H      _PK_H_(0x1B, 0x46)
#define REG_SC_BK1B_47_L      _PK_L_(0x1B, 0x47)
#define REG_SC_BK1B_47_H      _PK_H_(0x1B, 0x47)
#define REG_SC_BK1B_48_L      _PK_L_(0x1B, 0x48)
#define REG_SC_BK1B_48_H      _PK_H_(0x1B, 0x48)
#define REG_SC_BK1B_49_L      _PK_L_(0x1B, 0x49)
#define REG_SC_BK1B_49_H      _PK_H_(0x1B, 0x49)
#define REG_SC_BK1B_4A_L      _PK_L_(0x1B, 0x4A)
#define REG_SC_BK1B_4A_H      _PK_H_(0x1B, 0x4A)
#define REG_SC_BK1B_4B_L      _PK_L_(0x1B, 0x4B)
#define REG_SC_BK1B_4B_H      _PK_H_(0x1B, 0x4B)
#define REG_SC_BK1B_4C_L      _PK_L_(0x1B, 0x4C)
#define REG_SC_BK1B_4C_H      _PK_H_(0x1B, 0x4C)
#define REG_SC_BK1B_4D_L      _PK_L_(0x1B, 0x4D)
#define REG_SC_BK1B_4D_H      _PK_H_(0x1B, 0x4D)
#define REG_SC_BK1B_4E_L      _PK_L_(0x1B, 0x4E)
#define REG_SC_BK1B_4E_H      _PK_H_(0x1B, 0x4E)
#define REG_SC_BK1B_4F_L      _PK_L_(0x1B, 0x4F)
#define REG_SC_BK1B_4F_H      _PK_H_(0x1B, 0x4F)
#define REG_SC_BK1B_50_L      _PK_L_(0x1B, 0x50)
#define REG_SC_BK1B_50_H      _PK_H_(0x1B, 0x50)
#define REG_SC_BK1B_51_L      _PK_L_(0x1B, 0x51)
#define REG_SC_BK1B_51_H      _PK_H_(0x1B, 0x51)
#define REG_SC_BK1B_52_L      _PK_L_(0x1B, 0x52)
#define REG_SC_BK1B_52_H      _PK_H_(0x1B, 0x52)
#define REG_SC_BK1B_53_L      _PK_L_(0x1B, 0x53)
#define REG_SC_BK1B_53_H      _PK_H_(0x1B, 0x53)
#define REG_SC_BK1B_54_L      _PK_L_(0x1B, 0x54)
#define REG_SC_BK1B_54_H      _PK_H_(0x1B, 0x54)
#define REG_SC_BK1B_55_L      _PK_L_(0x1B, 0x55)
#define REG_SC_BK1B_55_H      _PK_H_(0x1B, 0x55)
#define REG_SC_BK1B_56_L      _PK_L_(0x1B, 0x56)
#define REG_SC_BK1B_56_H      _PK_H_(0x1B, 0x56)
#define REG_SC_BK1B_57_L      _PK_L_(0x1B, 0x57)
#define REG_SC_BK1B_57_H      _PK_H_(0x1B, 0x57)
#define REG_SC_BK1B_58_L      _PK_L_(0x1B, 0x58)
#define REG_SC_BK1B_58_H      _PK_H_(0x1B, 0x58)
#define REG_SC_BK1B_59_L      _PK_L_(0x1B, 0x59)
#define REG_SC_BK1B_59_H      _PK_H_(0x1B, 0x59)
#define REG_SC_BK1B_5A_L      _PK_L_(0x1B, 0x5A)
#define REG_SC_BK1B_5A_H      _PK_H_(0x1B, 0x5A)
#define REG_SC_BK1B_5B_L      _PK_L_(0x1B, 0x5B)
#define REG_SC_BK1B_5B_H      _PK_H_(0x1B, 0x5B)
#define REG_SC_BK1B_5C_L      _PK_L_(0x1B, 0x5C)
#define REG_SC_BK1B_5C_H      _PK_H_(0x1B, 0x5C)
#define REG_SC_BK1B_5D_L      _PK_L_(0x1B, 0x5D)
#define REG_SC_BK1B_5D_H      _PK_H_(0x1B, 0x5D)
#define REG_SC_BK1B_5E_L      _PK_L_(0x1B, 0x5E)
#define REG_SC_BK1B_5E_H      _PK_H_(0x1B, 0x5E)
#define REG_SC_BK1B_5F_L      _PK_L_(0x1B, 0x5F)
#define REG_SC_BK1B_5F_H      _PK_H_(0x1B, 0x5F)
#define REG_SC_BK1B_60_L      _PK_L_(0x1B, 0x60)
#define REG_SC_BK1B_60_H      _PK_H_(0x1B, 0x60)
#define REG_SC_BK1B_61_L      _PK_L_(0x1B, 0x61)
#define REG_SC_BK1B_61_H      _PK_H_(0x1B, 0x61)
#define REG_SC_BK1B_62_L      _PK_L_(0x1B, 0x62)
#define REG_SC_BK1B_62_H      _PK_H_(0x1B, 0x62)
#define REG_SC_BK1B_63_L      _PK_L_(0x1B, 0x63)
#define REG_SC_BK1B_63_H      _PK_H_(0x1B, 0x63)
#define REG_SC_BK1B_64_L      _PK_L_(0x1B, 0x64)
#define REG_SC_BK1B_64_H      _PK_H_(0x1B, 0x64)
#define REG_SC_BK1B_65_L      _PK_L_(0x1B, 0x65)
#define REG_SC_BK1B_65_H      _PK_H_(0x1B, 0x65)
#define REG_SC_BK1B_66_L      _PK_L_(0x1B, 0x66)
#define REG_SC_BK1B_66_H      _PK_H_(0x1B, 0x66)
#define REG_SC_BK1B_67_L      _PK_L_(0x1B, 0x67)
#define REG_SC_BK1B_67_H      _PK_H_(0x1B, 0x67)
#define REG_SC_BK1B_68_L      _PK_L_(0x1B, 0x68)
#define REG_SC_BK1B_68_H      _PK_H_(0x1B, 0x68)
#define REG_SC_BK1B_69_L      _PK_L_(0x1B, 0x69)
#define REG_SC_BK1B_69_H      _PK_H_(0x1B, 0x69)
#define REG_SC_BK1B_6A_L      _PK_L_(0x1B, 0x6A)
#define REG_SC_BK1B_6A_H      _PK_H_(0x1B, 0x6A)
#define REG_SC_BK1B_6B_L      _PK_L_(0x1B, 0x6B)
#define REG_SC_BK1B_6B_H      _PK_H_(0x1B, 0x6B)
#define REG_SC_BK1B_6C_L      _PK_L_(0x1B, 0x6C)
#define REG_SC_BK1B_6C_H      _PK_H_(0x1B, 0x6C)
#define REG_SC_BK1B_6D_L      _PK_L_(0x1B, 0x6D)
#define REG_SC_BK1B_6D_H      _PK_H_(0x1B, 0x6D)
#define REG_SC_BK1B_6E_L      _PK_L_(0x1B, 0x6E)
#define REG_SC_BK1B_6E_H      _PK_H_(0x1B, 0x6E)
#define REG_SC_BK1B_6F_L      _PK_L_(0x1B, 0x6F)
#define REG_SC_BK1B_6F_H      _PK_H_(0x1B, 0x6F)
#define REG_SC_BK1B_70_L      _PK_L_(0x1B, 0x70)
#define REG_SC_BK1B_70_H      _PK_H_(0x1B, 0x70)
#define REG_SC_BK1B_71_L      _PK_L_(0x1B, 0x71)
#define REG_SC_BK1B_71_H      _PK_H_(0x1B, 0x71)
#define REG_SC_BK1B_72_L      _PK_L_(0x1B, 0x72)
#define REG_SC_BK1B_72_H      _PK_H_(0x1B, 0x72)
#define REG_SC_BK1B_73_L      _PK_L_(0x1B, 0x73)
#define REG_SC_BK1B_73_H      _PK_H_(0x1B, 0x73)
#define REG_SC_BK1B_74_L      _PK_L_(0x1B, 0x74)
#define REG_SC_BK1B_74_H      _PK_H_(0x1B, 0x74)
#define REG_SC_BK1B_75_L      _PK_L_(0x1B, 0x75)
#define REG_SC_BK1B_75_H      _PK_H_(0x1B, 0x75)
#define REG_SC_BK1B_76_L      _PK_L_(0x1B, 0x76)
#define REG_SC_BK1B_76_H      _PK_H_(0x1B, 0x76)
#define REG_SC_BK1B_77_L      _PK_L_(0x1B, 0x77)
#define REG_SC_BK1B_77_H      _PK_H_(0x1B, 0x77)
#define REG_SC_BK1B_78_L      _PK_L_(0x1B, 0x78)
#define REG_SC_BK1B_78_H      _PK_H_(0x1B, 0x78)
#define REG_SC_BK1B_79_L      _PK_L_(0x1B, 0x79)
#define REG_SC_BK1B_79_H      _PK_H_(0x1B, 0x79)
#define REG_SC_BK1B_7A_L      _PK_L_(0x1B, 0x7A)
#define REG_SC_BK1B_7A_H      _PK_H_(0x1B, 0x7A)
#define REG_SC_BK1B_7B_L      _PK_L_(0x1B, 0x7B)
#define REG_SC_BK1B_7B_H      _PK_H_(0x1B, 0x7B)
#define REG_SC_BK1B_7C_L      _PK_L_(0x1B, 0x7C)
#define REG_SC_BK1B_7C_H      _PK_H_(0x1B, 0x7C)
#define REG_SC_BK1B_7D_L      _PK_L_(0x1B, 0x7D)
#define REG_SC_BK1B_7D_H      _PK_H_(0x1B, 0x7D)
#define REG_SC_BK1B_7E_L      _PK_L_(0x1B, 0x7E)
#define REG_SC_BK1B_7E_H      _PK_H_(0x1B, 0x7E)
#define REG_SC_BK1B_7F_L      _PK_L_(0x1B, 0x7F)
#define REG_SC_BK1B_7F_H      _PK_H_(0x1B, 0x7F)



#define REG_SC_BK1C_00_L      _PK_L_(0x1C, 0x00)
#define REG_SC_BK1C_00_H      _PK_H_(0x1C, 0x00)
#define REG_SC_BK1C_01_L      _PK_L_(0x1C, 0x01)
#define REG_SC_BK1C_01_H      _PK_H_(0x1C, 0x01)
#define REG_SC_BK1C_02_L      _PK_L_(0x1C, 0x02)
#define REG_SC_BK1C_02_H      _PK_H_(0x1C, 0x02)
#define REG_SC_BK1C_03_L      _PK_L_(0x1C, 0x03)
#define REG_SC_BK1C_03_H      _PK_H_(0x1C, 0x03)
#define REG_SC_BK1C_04_L      _PK_L_(0x1C, 0x04)
#define REG_SC_BK1C_04_H      _PK_H_(0x1C, 0x04)
#define REG_SC_BK1C_05_L      _PK_L_(0x1C, 0x05)
#define REG_SC_BK1C_05_H      _PK_H_(0x1C, 0x05)
#define REG_SC_BK1C_06_L      _PK_L_(0x1C, 0x06)
#define REG_SC_BK1C_06_H      _PK_H_(0x1C, 0x06)
#define REG_SC_BK1C_07_L      _PK_L_(0x1C, 0x07)
#define REG_SC_BK1C_07_H      _PK_H_(0x1C, 0x07)
#define REG_SC_BK1C_08_L      _PK_L_(0x1C, 0x08)
#define REG_SC_BK1C_08_H      _PK_H_(0x1C, 0x08)
#define REG_SC_BK1C_09_L      _PK_L_(0x1C, 0x09)
#define REG_SC_BK1C_09_H      _PK_H_(0x1C, 0x09)
#define REG_SC_BK1C_0A_L      _PK_L_(0x1C, 0x0A)
#define REG_SC_BK1C_0A_H      _PK_H_(0x1C, 0x0A)
#define REG_SC_BK1C_0B_L      _PK_L_(0x1C, 0x0B)
#define REG_SC_BK1C_0B_H      _PK_H_(0x1C, 0x0B)
#define REG_SC_BK1C_0C_L      _PK_L_(0x1C, 0x0C)
#define REG_SC_BK1C_0C_H      _PK_H_(0x1C, 0x0C)
#define REG_SC_BK1C_0D_L      _PK_L_(0x1C, 0x0D)
#define REG_SC_BK1C_0D_H      _PK_H_(0x1C, 0x0D)
#define REG_SC_BK1C_0E_L      _PK_L_(0x1C, 0x0E)
#define REG_SC_BK1C_0E_H      _PK_H_(0x1C, 0x0E)
#define REG_SC_BK1C_0F_L      _PK_L_(0x1C, 0x0F)
#define REG_SC_BK1C_0F_H      _PK_H_(0x1C, 0x0F)
#define REG_SC_BK1C_10_L      _PK_L_(0x1C, 0x10)
#define REG_SC_BK1C_10_H      _PK_H_(0x1C, 0x10)
#define REG_SC_BK1C_11_L      _PK_L_(0x1C, 0x11)
#define REG_SC_BK1C_11_H      _PK_H_(0x1C, 0x11)
#define REG_SC_BK1C_12_L      _PK_L_(0x1C, 0x12)
#define REG_SC_BK1C_12_H      _PK_H_(0x1C, 0x12)
#define REG_SC_BK1C_13_L      _PK_L_(0x1C, 0x13)
#define REG_SC_BK1C_13_H      _PK_H_(0x1C, 0x13)
#define REG_SC_BK1C_14_L      _PK_L_(0x1C, 0x14)
#define REG_SC_BK1C_14_H      _PK_H_(0x1C, 0x14)
#define REG_SC_BK1C_15_L      _PK_L_(0x1C, 0x15)
#define REG_SC_BK1C_15_H      _PK_H_(0x1C, 0x15)
#define REG_SC_BK1C_16_L      _PK_L_(0x1C, 0x16)
#define REG_SC_BK1C_16_H      _PK_H_(0x1C, 0x16)
#define REG_SC_BK1C_17_L      _PK_L_(0x1C, 0x17)
#define REG_SC_BK1C_17_H      _PK_H_(0x1C, 0x17)
#define REG_SC_BK1C_18_L      _PK_L_(0x1C, 0x18)
#define REG_SC_BK1C_18_H      _PK_H_(0x1C, 0x18)
#define REG_SC_BK1C_19_L      _PK_L_(0x1C, 0x19)
#define REG_SC_BK1C_19_H      _PK_H_(0x1C, 0x19)
#define REG_SC_BK1C_1A_L      _PK_L_(0x1C, 0x1A)
#define REG_SC_BK1C_1A_H      _PK_H_(0x1C, 0x1A)
#define REG_SC_BK1C_1B_L      _PK_L_(0x1C, 0x1B)
#define REG_SC_BK1C_1B_H      _PK_H_(0x1C, 0x1B)
#define REG_SC_BK1C_1C_L      _PK_L_(0x1C, 0x1C)
#define REG_SC_BK1C_1C_H      _PK_H_(0x1C, 0x1C)
#define REG_SC_BK1C_1D_L      _PK_L_(0x1C, 0x1D)
#define REG_SC_BK1C_1D_H      _PK_H_(0x1C, 0x1D)
#define REG_SC_BK1C_1E_L      _PK_L_(0x1C, 0x1E)
#define REG_SC_BK1C_1E_H      _PK_H_(0x1C, 0x1E)
#define REG_SC_BK1C_1F_L      _PK_L_(0x1C, 0x1F)
#define REG_SC_BK1C_1F_H      _PK_H_(0x1C, 0x1F)
#define REG_SC_BK1C_20_L      _PK_L_(0x1C, 0x20)
#define REG_SC_BK1C_20_H      _PK_H_(0x1C, 0x20)
#define REG_SC_BK1C_21_L      _PK_L_(0x1C, 0x21)
#define REG_SC_BK1C_21_H      _PK_H_(0x1C, 0x21)
#define REG_SC_BK1C_22_L      _PK_L_(0x1C, 0x22)
#define REG_SC_BK1C_22_H      _PK_H_(0x1C, 0x22)
#define REG_SC_BK1C_23_L      _PK_L_(0x1C, 0x23)
#define REG_SC_BK1C_23_H      _PK_H_(0x1C, 0x23)
#define REG_SC_BK1C_24_L      _PK_L_(0x1C, 0x24)
#define REG_SC_BK1C_24_H      _PK_H_(0x1C, 0x24)
#define REG_SC_BK1C_25_L      _PK_L_(0x1C, 0x25)
#define REG_SC_BK1C_25_H      _PK_H_(0x1C, 0x25)
#define REG_SC_BK1C_26_L      _PK_L_(0x1C, 0x26)
#define REG_SC_BK1C_26_H      _PK_H_(0x1C, 0x26)
#define REG_SC_BK1C_27_L      _PK_L_(0x1C, 0x27)
#define REG_SC_BK1C_27_H      _PK_H_(0x1C, 0x27)
#define REG_SC_BK1C_28_L      _PK_L_(0x1C, 0x28)
#define REG_SC_BK1C_28_H      _PK_H_(0x1C, 0x28)
#define REG_SC_BK1C_29_L      _PK_L_(0x1C, 0x29)
#define REG_SC_BK1C_29_H      _PK_H_(0x1C, 0x29)
#define REG_SC_BK1C_2A_L      _PK_L_(0x1C, 0x2A)
#define REG_SC_BK1C_2A_H      _PK_H_(0x1C, 0x2A)
#define REG_SC_BK1C_2B_L      _PK_L_(0x1C, 0x2B)
#define REG_SC_BK1C_2B_H      _PK_H_(0x1C, 0x2B)
#define REG_SC_BK1C_2C_L      _PK_L_(0x1C, 0x2C)
#define REG_SC_BK1C_2C_H      _PK_H_(0x1C, 0x2C)
#define REG_SC_BK1C_2D_L      _PK_L_(0x1C, 0x2D)
#define REG_SC_BK1C_2D_H      _PK_H_(0x1C, 0x2D)
#define REG_SC_BK1C_2E_L      _PK_L_(0x1C, 0x2E)
#define REG_SC_BK1C_2E_H      _PK_H_(0x1C, 0x2E)
#define REG_SC_BK1C_2F_L      _PK_L_(0x1C, 0x2F)
#define REG_SC_BK1C_2F_H      _PK_H_(0x1C, 0x2F)
#define REG_SC_BK1C_30_L      _PK_L_(0x1C, 0x30)
#define REG_SC_BK1C_30_H      _PK_H_(0x1C, 0x30)
#define REG_SC_BK1C_31_L      _PK_L_(0x1C, 0x31)
#define REG_SC_BK1C_31_H      _PK_H_(0x1C, 0x31)
#define REG_SC_BK1C_32_L      _PK_L_(0x1C, 0x32)
#define REG_SC_BK1C_32_H      _PK_H_(0x1C, 0x32)
#define REG_SC_BK1C_33_L      _PK_L_(0x1C, 0x33)
#define REG_SC_BK1C_33_H      _PK_H_(0x1C, 0x33)
#define REG_SC_BK1C_34_L      _PK_L_(0x1C, 0x34)
#define REG_SC_BK1C_34_H      _PK_H_(0x1C, 0x34)
#define REG_SC_BK1C_35_L      _PK_L_(0x1C, 0x35)
#define REG_SC_BK1C_35_H      _PK_H_(0x1C, 0x35)
#define REG_SC_BK1C_36_L      _PK_L_(0x1C, 0x36)
#define REG_SC_BK1C_36_H      _PK_H_(0x1C, 0x36)
#define REG_SC_BK1C_37_L      _PK_L_(0x1C, 0x37)
#define REG_SC_BK1C_37_H      _PK_H_(0x1C, 0x37)
#define REG_SC_BK1C_38_L      _PK_L_(0x1C, 0x38)
#define REG_SC_BK1C_38_H      _PK_H_(0x1C, 0x38)
#define REG_SC_BK1C_39_L      _PK_L_(0x1C, 0x39)
#define REG_SC_BK1C_39_H      _PK_H_(0x1C, 0x39)
#define REG_SC_BK1C_3A_L      _PK_L_(0x1C, 0x3A)
#define REG_SC_BK1C_3A_H      _PK_H_(0x1C, 0x3A)
#define REG_SC_BK1C_3B_L      _PK_L_(0x1C, 0x3B)
#define REG_SC_BK1C_3B_H      _PK_H_(0x1C, 0x3B)
#define REG_SC_BK1C_3C_L      _PK_L_(0x1C, 0x3C)
#define REG_SC_BK1C_3C_H      _PK_H_(0x1C, 0x3C)
#define REG_SC_BK1C_3D_L      _PK_L_(0x1C, 0x3D)
#define REG_SC_BK1C_3D_H      _PK_H_(0x1C, 0x3D)
#define REG_SC_BK1C_3E_L      _PK_L_(0x1C, 0x3E)
#define REG_SC_BK1C_3E_H      _PK_H_(0x1C, 0x3E)
#define REG_SC_BK1C_3F_L      _PK_L_(0x1C, 0x3F)
#define REG_SC_BK1C_3F_H      _PK_H_(0x1C, 0x3F)
#define REG_SC_BK1C_40_L      _PK_L_(0x1C, 0x40)
#define REG_SC_BK1C_40_H      _PK_H_(0x1C, 0x40)
#define REG_SC_BK1C_41_L      _PK_L_(0x1C, 0x41)
#define REG_SC_BK1C_41_H      _PK_H_(0x1C, 0x41)
#define REG_SC_BK1C_42_L      _PK_L_(0x1C, 0x42)
#define REG_SC_BK1C_42_H      _PK_H_(0x1C, 0x42)
#define REG_SC_BK1C_43_L      _PK_L_(0x1C, 0x43)
#define REG_SC_BK1C_43_H      _PK_H_(0x1C, 0x43)
#define REG_SC_BK1C_44_L      _PK_L_(0x1C, 0x44)
#define REG_SC_BK1C_44_H      _PK_H_(0x1C, 0x44)
#define REG_SC_BK1C_45_L      _PK_L_(0x1C, 0x45)
#define REG_SC_BK1C_45_H      _PK_H_(0x1C, 0x45)
#define REG_SC_BK1C_46_L      _PK_L_(0x1C, 0x46)
#define REG_SC_BK1C_46_H      _PK_H_(0x1C, 0x46)
#define REG_SC_BK1C_47_L      _PK_L_(0x1C, 0x47)
#define REG_SC_BK1C_47_H      _PK_H_(0x1C, 0x47)
#define REG_SC_BK1C_48_L      _PK_L_(0x1C, 0x48)
#define REG_SC_BK1C_48_H      _PK_H_(0x1C, 0x48)
#define REG_SC_BK1C_49_L      _PK_L_(0x1C, 0x49)
#define REG_SC_BK1C_49_H      _PK_H_(0x1C, 0x49)
#define REG_SC_BK1C_4A_L      _PK_L_(0x1C, 0x4A)
#define REG_SC_BK1C_4A_H      _PK_H_(0x1C, 0x4A)
#define REG_SC_BK1C_4B_L      _PK_L_(0x1C, 0x4B)
#define REG_SC_BK1C_4B_H      _PK_H_(0x1C, 0x4B)
#define REG_SC_BK1C_4C_L      _PK_L_(0x1C, 0x4C)
#define REG_SC_BK1C_4C_H      _PK_H_(0x1C, 0x4C)
#define REG_SC_BK1C_4D_L      _PK_L_(0x1C, 0x4D)
#define REG_SC_BK1C_4D_H      _PK_H_(0x1C, 0x4D)
#define REG_SC_BK1C_4E_L      _PK_L_(0x1C, 0x4E)
#define REG_SC_BK1C_4E_H      _PK_H_(0x1C, 0x4E)
#define REG_SC_BK1C_4F_L      _PK_L_(0x1C, 0x4F)
#define REG_SC_BK1C_4F_H      _PK_H_(0x1C, 0x4F)
#define REG_SC_BK1C_50_L      _PK_L_(0x1C, 0x50)
#define REG_SC_BK1C_50_H      _PK_H_(0x1C, 0x50)
#define REG_SC_BK1C_51_L      _PK_L_(0x1C, 0x51)
#define REG_SC_BK1C_51_H      _PK_H_(0x1C, 0x51)
#define REG_SC_BK1C_52_L      _PK_L_(0x1C, 0x52)
#define REG_SC_BK1C_52_H      _PK_H_(0x1C, 0x52)
#define REG_SC_BK1C_53_L      _PK_L_(0x1C, 0x53)
#define REG_SC_BK1C_53_H      _PK_H_(0x1C, 0x53)
#define REG_SC_BK1C_54_L      _PK_L_(0x1C, 0x54)
#define REG_SC_BK1C_54_H      _PK_H_(0x1C, 0x54)
#define REG_SC_BK1C_55_L      _PK_L_(0x1C, 0x55)
#define REG_SC_BK1C_55_H      _PK_H_(0x1C, 0x55)
#define REG_SC_BK1C_56_L      _PK_L_(0x1C, 0x56)
#define REG_SC_BK1C_56_H      _PK_H_(0x1C, 0x56)
#define REG_SC_BK1C_57_L      _PK_L_(0x1C, 0x57)
#define REG_SC_BK1C_57_H      _PK_H_(0x1C, 0x57)
#define REG_SC_BK1C_58_L      _PK_L_(0x1C, 0x58)
#define REG_SC_BK1C_58_H      _PK_H_(0x1C, 0x58)
#define REG_SC_BK1C_59_L      _PK_L_(0x1C, 0x59)
#define REG_SC_BK1C_59_H      _PK_H_(0x1C, 0x59)
#define REG_SC_BK1C_5A_L      _PK_L_(0x1C, 0x5A)
#define REG_SC_BK1C_5A_H      _PK_H_(0x1C, 0x5A)
#define REG_SC_BK1C_5B_L      _PK_L_(0x1C, 0x5B)
#define REG_SC_BK1C_5B_H      _PK_H_(0x1C, 0x5B)
#define REG_SC_BK1C_5C_L      _PK_L_(0x1C, 0x5C)
#define REG_SC_BK1C_5C_H      _PK_H_(0x1C, 0x5C)
#define REG_SC_BK1C_5D_L      _PK_L_(0x1C, 0x5D)
#define REG_SC_BK1C_5D_H      _PK_H_(0x1C, 0x5D)
#define REG_SC_BK1C_5E_L      _PK_L_(0x1C, 0x5E)
#define REG_SC_BK1C_5E_H      _PK_H_(0x1C, 0x5E)
#define REG_SC_BK1C_5F_L      _PK_L_(0x1C, 0x5F)
#define REG_SC_BK1C_5F_H      _PK_H_(0x1C, 0x5F)
#define REG_SC_BK1C_60_L      _PK_L_(0x1C, 0x60)
#define REG_SC_BK1C_60_H      _PK_H_(0x1C, 0x60)
#define REG_SC_BK1C_61_L      _PK_L_(0x1C, 0x61)
#define REG_SC_BK1C_61_H      _PK_H_(0x1C, 0x61)
#define REG_SC_BK1C_62_L      _PK_L_(0x1C, 0x62)
#define REG_SC_BK1C_62_H      _PK_H_(0x1C, 0x62)
#define REG_SC_BK1C_63_L      _PK_L_(0x1C, 0x63)
#define REG_SC_BK1C_63_H      _PK_H_(0x1C, 0x63)
#define REG_SC_BK1C_64_L      _PK_L_(0x1C, 0x64)
#define REG_SC_BK1C_64_H      _PK_H_(0x1C, 0x64)
#define REG_SC_BK1C_65_L      _PK_L_(0x1C, 0x65)
#define REG_SC_BK1C_65_H      _PK_H_(0x1C, 0x65)
#define REG_SC_BK1C_66_L      _PK_L_(0x1C, 0x66)
#define REG_SC_BK1C_66_H      _PK_H_(0x1C, 0x66)
#define REG_SC_BK1C_67_L      _PK_L_(0x1C, 0x67)
#define REG_SC_BK1C_67_H      _PK_H_(0x1C, 0x67)
#define REG_SC_BK1C_68_L      _PK_L_(0x1C, 0x68)
#define REG_SC_BK1C_68_H      _PK_H_(0x1C, 0x68)
#define REG_SC_BK1C_69_L      _PK_L_(0x1C, 0x69)
#define REG_SC_BK1C_69_H      _PK_H_(0x1C, 0x69)
#define REG_SC_BK1C_6A_L      _PK_L_(0x1C, 0x6A)
#define REG_SC_BK1C_6A_H      _PK_H_(0x1C, 0x6A)
#define REG_SC_BK1C_6B_L      _PK_L_(0x1C, 0x6B)
#define REG_SC_BK1C_6B_H      _PK_H_(0x1C, 0x6B)
#define REG_SC_BK1C_6C_L      _PK_L_(0x1C, 0x6C)
#define REG_SC_BK1C_6C_H      _PK_H_(0x1C, 0x6C)
#define REG_SC_BK1C_6D_L      _PK_L_(0x1C, 0x6D)
#define REG_SC_BK1C_6D_H      _PK_H_(0x1C, 0x6D)
#define REG_SC_BK1C_6E_L      _PK_L_(0x1C, 0x6E)
#define REG_SC_BK1C_6E_H      _PK_H_(0x1C, 0x6E)
#define REG_SC_BK1C_6F_L      _PK_L_(0x1C, 0x6F)
#define REG_SC_BK1C_6F_H      _PK_H_(0x1C, 0x6F)
#define REG_SC_BK1C_70_L      _PK_L_(0x1C, 0x70)
#define REG_SC_BK1C_70_H      _PK_H_(0x1C, 0x70)
#define REG_SC_BK1C_71_L      _PK_L_(0x1C, 0x71)
#define REG_SC_BK1C_71_H      _PK_H_(0x1C, 0x71)
#define REG_SC_BK1C_72_L      _PK_L_(0x1C, 0x72)
#define REG_SC_BK1C_72_H      _PK_H_(0x1C, 0x72)
#define REG_SC_BK1C_73_L      _PK_L_(0x1C, 0x73)
#define REG_SC_BK1C_73_H      _PK_H_(0x1C, 0x73)
#define REG_SC_BK1C_74_L      _PK_L_(0x1C, 0x74)
#define REG_SC_BK1C_74_H      _PK_H_(0x1C, 0x74)
#define REG_SC_BK1C_75_L      _PK_L_(0x1C, 0x75)
#define REG_SC_BK1C_75_H      _PK_H_(0x1C, 0x75)
#define REG_SC_BK1C_76_L      _PK_L_(0x1C, 0x76)
#define REG_SC_BK1C_76_H      _PK_H_(0x1C, 0x76)
#define REG_SC_BK1C_77_L      _PK_L_(0x1C, 0x77)
#define REG_SC_BK1C_77_H      _PK_H_(0x1C, 0x77)
#define REG_SC_BK1C_78_L      _PK_L_(0x1C, 0x78)
#define REG_SC_BK1C_78_H      _PK_H_(0x1C, 0x78)
#define REG_SC_BK1C_79_L      _PK_L_(0x1C, 0x79)
#define REG_SC_BK1C_79_H      _PK_H_(0x1C, 0x79)
#define REG_SC_BK1C_7A_L      _PK_L_(0x1C, 0x7A)
#define REG_SC_BK1C_7A_H      _PK_H_(0x1C, 0x7A)
#define REG_SC_BK1C_7B_L      _PK_L_(0x1C, 0x7B)
#define REG_SC_BK1C_7B_H      _PK_H_(0x1C, 0x7B)
#define REG_SC_BK1C_7C_L      _PK_L_(0x1C, 0x7C)
#define REG_SC_BK1C_7C_H      _PK_H_(0x1C, 0x7C)
#define REG_SC_BK1C_7D_L      _PK_L_(0x1C, 0x7D)
#define REG_SC_BK1C_7D_H      _PK_H_(0x1C, 0x7D)
#define REG_SC_BK1C_7E_L      _PK_L_(0x1C, 0x7E)
#define REG_SC_BK1C_7E_H      _PK_H_(0x1C, 0x7E)
#define REG_SC_BK1C_7F_L      _PK_L_(0x1C, 0x7F)
#define REG_SC_BK1C_7F_H      _PK_H_(0x1C, 0x7F)

////

//----------------------------------------------
//  BK1D: MFC
//----------------------------------------------
#define REG_SC_BK1D_00_L      _PK_L_(0x1D, 0x00)
#define REG_SC_BK1D_00_H      _PK_H_(0x1D, 0x00)
#define REG_SC_BK1D_01_L      _PK_L_(0x1D, 0x01)
#define REG_SC_BK1D_01_H      _PK_H_(0x1D, 0x01)
#define REG_SC_BK1D_02_L      _PK_L_(0x1D, 0x02)
#define REG_SC_BK1D_02_H      _PK_H_(0x1D, 0x02)
#define REG_SC_BK1D_03_L      _PK_L_(0x1D, 0x03)
#define REG_SC_BK1D_03_H      _PK_H_(0x1D, 0x03)
#define REG_SC_BK1D_04_L      _PK_L_(0x1D, 0x04)
#define REG_SC_BK1D_04_H      _PK_H_(0x1D, 0x04)
#define REG_SC_BK1D_05_L      _PK_L_(0x1D, 0x05)
#define REG_SC_BK1D_05_H      _PK_H_(0x1D, 0x05)
#define REG_SC_BK1D_06_L      _PK_L_(0x1D, 0x06)
#define REG_SC_BK1D_06_H      _PK_H_(0x1D, 0x06)
#define REG_SC_BK1D_07_L      _PK_L_(0x1D, 0x07)
#define REG_SC_BK1D_07_H      _PK_H_(0x1D, 0x07)
#define REG_SC_BK1D_08_L      _PK_L_(0x1D, 0x08)
#define REG_SC_BK1D_08_H      _PK_H_(0x1D, 0x08)
#define REG_SC_BK1D_09_L      _PK_L_(0x1D, 0x09)
#define REG_SC_BK1D_09_H      _PK_H_(0x1D, 0x09)
#define REG_SC_BK1D_0A_L      _PK_L_(0x1D, 0x0A)
#define REG_SC_BK1D_0A_H      _PK_H_(0x1D, 0x0A)
#define REG_SC_BK1D_0B_L      _PK_L_(0x1D, 0x0B)
#define REG_SC_BK1D_0B_H      _PK_H_(0x1D, 0x0B)
#define REG_SC_BK1D_0C_L      _PK_L_(0x1D, 0x0C)
#define REG_SC_BK1D_0C_H      _PK_H_(0x1D, 0x0C)
#define REG_SC_BK1D_0D_L      _PK_L_(0x1D, 0x0D)
#define REG_SC_BK1D_0D_H      _PK_H_(0x1D, 0x0D)
#define REG_SC_BK1D_0E_L      _PK_L_(0x1D, 0x0E)
#define REG_SC_BK1D_0E_H      _PK_H_(0x1D, 0x0E)
#define REG_SC_BK1D_0F_L      _PK_L_(0x1D, 0x0F)
#define REG_SC_BK1D_0F_H      _PK_H_(0x1D, 0x0F)
#define REG_SC_BK1D_10_L      _PK_L_(0x1D, 0x10)
#define REG_SC_BK1D_10_H      _PK_H_(0x1D, 0x10)
#define REG_SC_BK1D_11_L      _PK_L_(0x1D, 0x11)
#define REG_SC_BK1D_11_H      _PK_H_(0x1D, 0x11)
#define REG_SC_BK1D_12_L      _PK_L_(0x1D, 0x12)
#define REG_SC_BK1D_12_H      _PK_H_(0x1D, 0x12)
#define REG_SC_BK1D_13_L      _PK_L_(0x1D, 0x13)
#define REG_SC_BK1D_13_H      _PK_H_(0x1D, 0x13)
#define REG_SC_BK1D_14_L      _PK_L_(0x1D, 0x14)
#define REG_SC_BK1D_14_H      _PK_H_(0x1D, 0x14)
#define REG_SC_BK1D_15_L      _PK_L_(0x1D, 0x15)
#define REG_SC_BK1D_15_H      _PK_H_(0x1D, 0x15)
#define REG_SC_BK1D_16_L      _PK_L_(0x1D, 0x16)
#define REG_SC_BK1D_16_H      _PK_H_(0x1D, 0x16)
#define REG_SC_BK1D_17_L      _PK_L_(0x1D, 0x17)
#define REG_SC_BK1D_17_H      _PK_H_(0x1D, 0x17)
#define REG_SC_BK1D_18_L      _PK_L_(0x1D, 0x18)
#define REG_SC_BK1D_18_H      _PK_H_(0x1D, 0x18)
#define REG_SC_BK1D_19_L      _PK_L_(0x1D, 0x19)
#define REG_SC_BK1D_19_H      _PK_H_(0x1D, 0x19)
#define REG_SC_BK1D_1A_L      _PK_L_(0x1D, 0x1A)
#define REG_SC_BK1D_1A_H      _PK_H_(0x1D, 0x1A)
#define REG_SC_BK1D_1B_L      _PK_L_(0x1D, 0x1B)
#define REG_SC_BK1D_1B_H      _PK_H_(0x1D, 0x1B)
#define REG_SC_BK1D_1C_L      _PK_L_(0x1D, 0x1C)
#define REG_SC_BK1D_1C_H      _PK_H_(0x1D, 0x1C)
#define REG_SC_BK1D_1D_L      _PK_L_(0x1D, 0x1D)
#define REG_SC_BK1D_1D_H      _PK_H_(0x1D, 0x1D)
#define REG_SC_BK1D_1E_L      _PK_L_(0x1D, 0x1E)
#define REG_SC_BK1D_1E_H      _PK_H_(0x1D, 0x1E)
#define REG_SC_BK1D_1F_L      _PK_L_(0x1D, 0x1F)
#define REG_SC_BK1D_1F_H      _PK_H_(0x1D, 0x1F)
#define REG_SC_BK1D_20_L      _PK_L_(0x1D, 0x20)
#define REG_SC_BK1D_20_H      _PK_H_(0x1D, 0x20)
#define REG_SC_BK1D_21_L      _PK_L_(0x1D, 0x21)
#define REG_SC_BK1D_21_H      _PK_H_(0x1D, 0x21)
#define REG_SC_BK1D_22_L      _PK_L_(0x1D, 0x22)
#define REG_SC_BK1D_22_H      _PK_H_(0x1D, 0x22)
#define REG_SC_BK1D_23_L      _PK_L_(0x1D, 0x23)
#define REG_SC_BK1D_23_H      _PK_H_(0x1D, 0x23)
#define REG_SC_BK1D_24_L      _PK_L_(0x1D, 0x24)
#define REG_SC_BK1D_24_H      _PK_H_(0x1D, 0x24)
#define REG_SC_BK1D_25_L      _PK_L_(0x1D, 0x25)
#define REG_SC_BK1D_25_H      _PK_H_(0x1D, 0x25)
#define REG_SC_BK1D_26_L      _PK_L_(0x1D, 0x26)
#define REG_SC_BK1D_26_H      _PK_H_(0x1D, 0x26)
#define REG_SC_BK1D_27_L      _PK_L_(0x1D, 0x27)
#define REG_SC_BK1D_27_H      _PK_H_(0x1D, 0x27)
#define REG_SC_BK1D_28_L      _PK_L_(0x1D, 0x28)
#define REG_SC_BK1D_28_H      _PK_H_(0x1D, 0x28)
#define REG_SC_BK1D_29_L      _PK_L_(0x1D, 0x29)
#define REG_SC_BK1D_29_H      _PK_H_(0x1D, 0x29)
#define REG_SC_BK1D_2A_L      _PK_L_(0x1D, 0x2A)
#define REG_SC_BK1D_2A_H      _PK_H_(0x1D, 0x2A)
#define REG_SC_BK1D_2B_L      _PK_L_(0x1D, 0x2B)
#define REG_SC_BK1D_2B_H      _PK_H_(0x1D, 0x2B)
#define REG_SC_BK1D_2C_L      _PK_L_(0x1D, 0x2C)
#define REG_SC_BK1D_2C_H      _PK_H_(0x1D, 0x2C)
#define REG_SC_BK1D_2D_L      _PK_L_(0x1D, 0x2D)
#define REG_SC_BK1D_2D_H      _PK_H_(0x1D, 0x2D)
#define REG_SC_BK1D_2E_L      _PK_L_(0x1D, 0x2E)
#define REG_SC_BK1D_2E_H      _PK_H_(0x1D, 0x2E)
#define REG_SC_BK1D_2F_L      _PK_L_(0x1D, 0x2F)
#define REG_SC_BK1D_2F_H      _PK_H_(0x1D, 0x2F)
#define REG_SC_BK1D_30_L      _PK_L_(0x1D, 0x30)
#define REG_SC_BK1D_30_H      _PK_H_(0x1D, 0x30)
#define REG_SC_BK1D_31_L      _PK_L_(0x1D, 0x31)
#define REG_SC_BK1D_31_H      _PK_H_(0x1D, 0x31)
#define REG_SC_BK1D_32_L      _PK_L_(0x1D, 0x32)
#define REG_SC_BK1D_32_H      _PK_H_(0x1D, 0x32)
#define REG_SC_BK1D_33_L      _PK_L_(0x1D, 0x33)
#define REG_SC_BK1D_33_H      _PK_H_(0x1D, 0x33)
#define REG_SC_BK1D_34_L      _PK_L_(0x1D, 0x34)
#define REG_SC_BK1D_34_H      _PK_H_(0x1D, 0x34)
#define REG_SC_BK1D_35_L      _PK_L_(0x1D, 0x35)
#define REG_SC_BK1D_35_H      _PK_H_(0x1D, 0x35)
#define REG_SC_BK1D_36_L      _PK_L_(0x1D, 0x36)
#define REG_SC_BK1D_36_H      _PK_H_(0x1D, 0x36)
#define REG_SC_BK1D_37_L      _PK_L_(0x1D, 0x37)
#define REG_SC_BK1D_37_H      _PK_H_(0x1D, 0x37)
#define REG_SC_BK1D_38_L      _PK_L_(0x1D, 0x38)
#define REG_SC_BK1D_38_H      _PK_H_(0x1D, 0x38)
#define REG_SC_BK1D_39_L      _PK_L_(0x1D, 0x39)
#define REG_SC_BK1D_39_H      _PK_H_(0x1D, 0x39)
#define REG_SC_BK1D_3A_L      _PK_L_(0x1D, 0x3A)
#define REG_SC_BK1D_3A_H      _PK_H_(0x1D, 0x3A)
#define REG_SC_BK1D_3B_L      _PK_L_(0x1D, 0x3B)
#define REG_SC_BK1D_3B_H      _PK_H_(0x1D, 0x3B)
#define REG_SC_BK1D_3C_L      _PK_L_(0x1D, 0x3C)
#define REG_SC_BK1D_3C_H      _PK_H_(0x1D, 0x3C)
#define REG_SC_BK1D_3D_L      _PK_L_(0x1D, 0x3D)
#define REG_SC_BK1D_3D_H      _PK_H_(0x1D, 0x3D)
#define REG_SC_BK1D_3E_L      _PK_L_(0x1D, 0x3E)
#define REG_SC_BK1D_3E_H      _PK_H_(0x1D, 0x3E)
#define REG_SC_BK1D_3F_L      _PK_L_(0x1D, 0x3F)
#define REG_SC_BK1D_3F_H      _PK_H_(0x1D, 0x3F)
#define REG_SC_BK1D_40_L      _PK_L_(0x1D, 0x40)
#define REG_SC_BK1D_40_H      _PK_H_(0x1D, 0x40)
#define REG_SC_BK1D_41_L      _PK_L_(0x1D, 0x41)
#define REG_SC_BK1D_41_H      _PK_H_(0x1D, 0x41)
#define REG_SC_BK1D_42_L      _PK_L_(0x1D, 0x42)
#define REG_SC_BK1D_42_H      _PK_H_(0x1D, 0x42)
#define REG_SC_BK1D_43_L      _PK_L_(0x1D, 0x43)
#define REG_SC_BK1D_43_H      _PK_H_(0x1D, 0x43)
#define REG_SC_BK1D_44_L      _PK_L_(0x1D, 0x44)
#define REG_SC_BK1D_44_H      _PK_H_(0x1D, 0x44)
#define REG_SC_BK1D_45_L      _PK_L_(0x1D, 0x45)
#define REG_SC_BK1D_45_H      _PK_H_(0x1D, 0x45)
#define REG_SC_BK1D_46_L      _PK_L_(0x1D, 0x46)
#define REG_SC_BK1D_46_H      _PK_H_(0x1D, 0x46)
#define REG_SC_BK1D_47_L      _PK_L_(0x1D, 0x47)
#define REG_SC_BK1D_47_H      _PK_H_(0x1D, 0x47)
#define REG_SC_BK1D_48_L      _PK_L_(0x1D, 0x48)
#define REG_SC_BK1D_48_H      _PK_H_(0x1D, 0x48)
#define REG_SC_BK1D_49_L      _PK_L_(0x1D, 0x49)
#define REG_SC_BK1D_49_H      _PK_H_(0x1D, 0x49)
#define REG_SC_BK1D_4A_L      _PK_L_(0x1D, 0x4A)
#define REG_SC_BK1D_4A_H      _PK_H_(0x1D, 0x4A)
#define REG_SC_BK1D_4B_L      _PK_L_(0x1D, 0x4B)
#define REG_SC_BK1D_4B_H      _PK_H_(0x1D, 0x4B)
#define REG_SC_BK1D_4C_L      _PK_L_(0x1D, 0x4C)
#define REG_SC_BK1D_4C_H      _PK_H_(0x1D, 0x4C)
#define REG_SC_BK1D_4D_L      _PK_L_(0x1D, 0x4D)
#define REG_SC_BK1D_4D_H      _PK_H_(0x1D, 0x4D)
#define REG_SC_BK1D_4E_L      _PK_L_(0x1D, 0x4E)
#define REG_SC_BK1D_4E_H      _PK_H_(0x1D, 0x4E)
#define REG_SC_BK1D_4F_L      _PK_L_(0x1D, 0x4F)
#define REG_SC_BK1D_4F_H      _PK_H_(0x1D, 0x4F)
#define REG_SC_BK1D_50_L      _PK_L_(0x1D, 0x50)
#define REG_SC_BK1D_50_H      _PK_H_(0x1D, 0x50)
#define REG_SC_BK1D_51_L      _PK_L_(0x1D, 0x51)
#define REG_SC_BK1D_51_H      _PK_H_(0x1D, 0x51)
#define REG_SC_BK1D_52_L      _PK_L_(0x1D, 0x52)
#define REG_SC_BK1D_52_H      _PK_H_(0x1D, 0x52)
#define REG_SC_BK1D_53_L      _PK_L_(0x1D, 0x53)
#define REG_SC_BK1D_53_H      _PK_H_(0x1D, 0x53)
#define REG_SC_BK1D_54_L      _PK_L_(0x1D, 0x54)
#define REG_SC_BK1D_54_H      _PK_H_(0x1D, 0x54)
#define REG_SC_BK1D_55_L      _PK_L_(0x1D, 0x55)
#define REG_SC_BK1D_55_H      _PK_H_(0x1D, 0x55)
#define REG_SC_BK1D_56_L      _PK_L_(0x1D, 0x56)
#define REG_SC_BK1D_56_H      _PK_H_(0x1D, 0x56)
#define REG_SC_BK1D_57_L      _PK_L_(0x1D, 0x57)
#define REG_SC_BK1D_57_H      _PK_H_(0x1D, 0x57)
#define REG_SC_BK1D_58_L      _PK_L_(0x1D, 0x58)
#define REG_SC_BK1D_58_H      _PK_H_(0x1D, 0x58)
#define REG_SC_BK1D_59_L      _PK_L_(0x1D, 0x59)
#define REG_SC_BK1D_59_H      _PK_H_(0x1D, 0x59)
#define REG_SC_BK1D_5A_L      _PK_L_(0x1D, 0x5A)
#define REG_SC_BK1D_5A_H      _PK_H_(0x1D, 0x5A)
#define REG_SC_BK1D_5B_L      _PK_L_(0x1D, 0x5B)
#define REG_SC_BK1D_5B_H      _PK_H_(0x1D, 0x5B)
#define REG_SC_BK1D_5C_L      _PK_L_(0x1D, 0x5C)
#define REG_SC_BK1D_5C_H      _PK_H_(0x1D, 0x5C)
#define REG_SC_BK1D_5D_L      _PK_L_(0x1D, 0x5D)
#define REG_SC_BK1D_5D_H      _PK_H_(0x1D, 0x5D)
#define REG_SC_BK1D_5E_L      _PK_L_(0x1D, 0x5E)
#define REG_SC_BK1D_5E_H      _PK_H_(0x1D, 0x5E)
#define REG_SC_BK1D_5F_L      _PK_L_(0x1D, 0x5F)
#define REG_SC_BK1D_5F_H      _PK_H_(0x1D, 0x5F)
#define REG_SC_BK1D_60_L      _PK_L_(0x1D, 0x60)
#define REG_SC_BK1D_60_H      _PK_H_(0x1D, 0x60)
#define REG_SC_BK1D_61_L      _PK_L_(0x1D, 0x61)
#define REG_SC_BK1D_61_H      _PK_H_(0x1D, 0x61)
#define REG_SC_BK1D_62_L      _PK_L_(0x1D, 0x62)
#define REG_SC_BK1D_62_H      _PK_H_(0x1D, 0x62)
#define REG_SC_BK1D_63_L      _PK_L_(0x1D, 0x63)
#define REG_SC_BK1D_63_H      _PK_H_(0x1D, 0x63)
#define REG_SC_BK1D_64_L      _PK_L_(0x1D, 0x64)
#define REG_SC_BK1D_64_H      _PK_H_(0x1D, 0x64)
#define REG_SC_BK1D_65_L      _PK_L_(0x1D, 0x65)
#define REG_SC_BK1D_65_H      _PK_H_(0x1D, 0x65)
#define REG_SC_BK1D_66_L      _PK_L_(0x1D, 0x66)
#define REG_SC_BK1D_66_H      _PK_H_(0x1D, 0x66)
#define REG_SC_BK1D_67_L      _PK_L_(0x1D, 0x67)
#define REG_SC_BK1D_67_H      _PK_H_(0x1D, 0x67)
#define REG_SC_BK1D_68_L      _PK_L_(0x1D, 0x68)
#define REG_SC_BK1D_68_H      _PK_H_(0x1D, 0x68)
#define REG_SC_BK1D_69_L      _PK_L_(0x1D, 0x69)
#define REG_SC_BK1D_69_H      _PK_H_(0x1D, 0x69)
#define REG_SC_BK1D_6A_L      _PK_L_(0x1D, 0x6A)
#define REG_SC_BK1D_6A_H      _PK_H_(0x1D, 0x6A)
#define REG_SC_BK1D_6B_L      _PK_L_(0x1D, 0x6B)
#define REG_SC_BK1D_6B_H      _PK_H_(0x1D, 0x6B)
#define REG_SC_BK1D_6C_L      _PK_L_(0x1D, 0x6C)
#define REG_SC_BK1D_6C_H      _PK_H_(0x1D, 0x6C)
#define REG_SC_BK1D_6D_L      _PK_L_(0x1D, 0x6D)
#define REG_SC_BK1D_6D_H      _PK_H_(0x1D, 0x6D)
#define REG_SC_BK1D_6E_L      _PK_L_(0x1D, 0x6E)
#define REG_SC_BK1D_6E_H      _PK_H_(0x1D, 0x6E)
#define REG_SC_BK1D_6F_L      _PK_L_(0x1D, 0x6F)
#define REG_SC_BK1D_6F_H      _PK_H_(0x1D, 0x6F)
#define REG_SC_BK1D_70_L      _PK_L_(0x1D, 0x70)
#define REG_SC_BK1D_70_H      _PK_H_(0x1D, 0x70)
#define REG_SC_BK1D_71_L      _PK_L_(0x1D, 0x71)
#define REG_SC_BK1D_71_H      _PK_H_(0x1D, 0x71)
#define REG_SC_BK1D_72_L      _PK_L_(0x1D, 0x72)
#define REG_SC_BK1D_72_H      _PK_H_(0x1D, 0x72)
#define REG_SC_BK1D_73_L      _PK_L_(0x1D, 0x73)
#define REG_SC_BK1D_73_H      _PK_H_(0x1D, 0x73)
#define REG_SC_BK1D_74_L      _PK_L_(0x1D, 0x74)
#define REG_SC_BK1D_74_H      _PK_H_(0x1D, 0x74)
#define REG_SC_BK1D_75_L      _PK_L_(0x1D, 0x75)
#define REG_SC_BK1D_75_H      _PK_H_(0x1D, 0x75)
#define REG_SC_BK1D_76_L      _PK_L_(0x1D, 0x76)
#define REG_SC_BK1D_76_H      _PK_H_(0x1D, 0x76)
#define REG_SC_BK1D_77_L      _PK_L_(0x1D, 0x77)
#define REG_SC_BK1D_77_H      _PK_H_(0x1D, 0x77)
#define REG_SC_BK1D_78_L      _PK_L_(0x1D, 0x78)
#define REG_SC_BK1D_78_H      _PK_H_(0x1D, 0x78)
#define REG_SC_BK1D_79_L      _PK_L_(0x1D, 0x79)
#define REG_SC_BK1D_79_H      _PK_H_(0x1D, 0x79)
#define REG_SC_BK1D_7A_L      _PK_L_(0x1D, 0x7A)
#define REG_SC_BK1D_7A_H      _PK_H_(0x1D, 0x7A)
#define REG_SC_BK1D_7B_L      _PK_L_(0x1D, 0x7B)
#define REG_SC_BK1D_7B_H      _PK_H_(0x1D, 0x7B)
#define REG_SC_BK1D_7C_L      _PK_L_(0x1D, 0x7C)
#define REG_SC_BK1D_7C_H      _PK_H_(0x1D, 0x7C)
#define REG_SC_BK1D_7D_L      _PK_L_(0x1D, 0x7D)
#define REG_SC_BK1D_7D_H      _PK_H_(0x1D, 0x7D)
#define REG_SC_BK1D_7E_L      _PK_L_(0x1D, 0x7E)
#define REG_SC_BK1D_7E_H      _PK_H_(0x1D, 0x7E)
#define REG_SC_BK1D_7F_L      _PK_L_(0x1D, 0x7F)
#define REG_SC_BK1D_7F_H      _PK_H_(0x1D, 0x7F)

//----------------------------------------------
//  BK1E
//----------------------------------------------
#define REG_SC_BK1E_10_L      _PK_H_(0x1E, 0x10)

//----------------------------------------------
//  BK2B
//----------------------------------------------
#define REG_SC_BK2B_10_L      _PK_H_(0x2B, 0x10)

//----------------------------------------------
//  BK20
//----------------------------------------------
#define REG_SC_BK20_00_L      _PK_L_(0x20, 0x00)
#define REG_SC_BK20_00_H      _PK_H_(0x20, 0x00)
#define REG_SC_BK20_01_L      _PK_L_(0x20, 0x01)
#define REG_SC_BK20_01_H      _PK_H_(0x20, 0x01)
#define REG_SC_BK20_02_L      _PK_L_(0x20, 0x02)
#define REG_SC_BK20_02_H      _PK_H_(0x20, 0x02)
#define REG_SC_BK20_03_L      _PK_L_(0x20, 0x03)
#define REG_SC_BK20_03_H      _PK_H_(0x20, 0x03)
#define REG_SC_BK20_04_L      _PK_L_(0x20, 0x04)
#define REG_SC_BK20_04_H      _PK_H_(0x20, 0x04)
#define REG_SC_BK20_05_L      _PK_L_(0x20, 0x05)
#define REG_SC_BK20_05_H      _PK_H_(0x20, 0x05)
#define REG_SC_BK20_06_L      _PK_L_(0x20, 0x06)
#define REG_SC_BK20_06_H      _PK_H_(0x20, 0x06)
#define REG_SC_BK20_07_L      _PK_L_(0x20, 0x07)
#define REG_SC_BK20_07_H      _PK_H_(0x20, 0x07)
#define REG_SC_BK20_08_L      _PK_L_(0x20, 0x08)
#define REG_SC_BK20_08_H      _PK_H_(0x20, 0x08)
#define REG_SC_BK20_09_L      _PK_L_(0x20, 0x09)
#define REG_SC_BK20_09_H      _PK_H_(0x20, 0x09)
#define REG_SC_BK20_0A_L      _PK_L_(0x20, 0x0A)
#define REG_SC_BK20_0A_H      _PK_H_(0x20, 0x0A)
#define REG_SC_BK20_0B_L      _PK_L_(0x20, 0x0B)
#define REG_SC_BK20_0B_H      _PK_H_(0x20, 0x0B)
#define REG_SC_BK20_0C_L      _PK_L_(0x20, 0x0C)
#define REG_SC_BK20_0C_H      _PK_H_(0x20, 0x0C)
#define REG_SC_BK20_0D_L      _PK_L_(0x20, 0x0d)
#define REG_SC_BK20_0D_H      _PK_H_(0x20, 0x0d)
#define REG_SC_BK20_0E_L      _PK_L_(0x20, 0x0e)
#define REG_SC_BK20_0E_H      _PK_H_(0x20, 0x0e)
#define REG_SC_BK20_0F_L      _PK_L_(0x20, 0x0f)
#define REG_SC_BK20_0F_H      _PK_H_(0x20, 0x0f)

#define REG_SC_BK20_10_L      _PK_L_(0x20, 0x10)
#define REG_SC_BK20_10_H      _PK_H_(0x20, 0x10)
#define REG_SC_BK20_11_L      _PK_L_(0x20, 0x11)
#define REG_SC_BK20_11_H      _PK_H_(0x20, 0x11)
#define REG_SC_BK20_12_L      _PK_L_(0x20, 0x12)
#define REG_SC_BK20_12_H      _PK_H_(0x20, 0x12)
#define REG_SC_BK20_13_L      _PK_L_(0x20, 0x13)
#define REG_SC_BK20_13_H      _PK_H_(0x20, 0x13)
#define REG_SC_BK20_14_L      _PK_L_(0x20, 0x14)
#define REG_SC_BK20_14_H      _PK_H_(0x20, 0x14)
#define REG_SC_BK20_15_L      _PK_L_(0x20, 0x15)
#define REG_SC_BK20_15_H      _PK_H_(0x20, 0x15)
#define REG_SC_BK20_16_L      _PK_L_(0x20, 0x16)
#define REG_SC_BK20_16_H      _PK_H_(0x20, 0x16)
#define REG_SC_BK20_17_L      _PK_L_(0x20, 0x17)
#define REG_SC_BK20_17_H      _PK_H_(0x20, 0x17)
#define REG_SC_BK20_18_L      _PK_L_(0x20, 0x18)
#define REG_SC_BK20_18_H      _PK_H_(0x20, 0x18)
#define REG_SC_BK20_19_L      _PK_L_(0x20, 0x19)
#define REG_SC_BK20_19_H      _PK_H_(0x20, 0x19)
#define REG_SC_BK20_1A_L      _PK_L_(0x20, 0x1A)
#define REG_SC_BK20_1A_H      _PK_H_(0x20, 0x1A)
#define REG_SC_BK20_1B_L      _PK_L_(0x20, 0x1B)
#define REG_SC_BK20_1B_H      _PK_H_(0x20, 0x1B)
#define REG_SC_BK20_1C_L      _PK_L_(0x20, 0x1C)
#define REG_SC_BK20_1C_H      _PK_H_(0x20, 0x1C)
#define REG_SC_BK20_1D_L      _PK_L_(0x20, 0x1d)
#define REG_SC_BK20_1D_H      _PK_H_(0x20, 0x1d)
#define REG_SC_BK20_1E_L      _PK_L_(0x20, 0x1e)
#define REG_SC_BK20_1E_H      _PK_H_(0x20, 0x1e)
#define REG_SC_BK20_1F_L      _PK_L_(0x20, 0x1f)
#define REG_SC_BK20_1F_H      _PK_H_(0x20, 0x1f)

//----------------------------------------------
//  BK21
//----------------------------------------------
#define REG_SC_BK21_00_L      _PK_L_(0x21, 0x00)
#define REG_SC_BK21_00_H      _PK_H_(0x21, 0x00)
#define REG_SC_BK21_01_L      _PK_L_(0x21, 0x01)
#define REG_SC_BK21_01_H      _PK_H_(0x21, 0x01)
#define REG_SC_BK21_02_L      _PK_L_(0x21, 0x02)
#define REG_SC_BK21_02_H      _PK_H_(0x21, 0x02)
#define REG_SC_BK21_03_L      _PK_L_(0x21, 0x03)
#define REG_SC_BK21_03_H      _PK_H_(0x21, 0x03)
#define REG_SC_BK21_04_L      _PK_L_(0x21, 0x04)
#define REG_SC_BK21_04_H      _PK_H_(0x21, 0x04)
#define REG_SC_BK21_05_L      _PK_L_(0x21, 0x05)
#define REG_SC_BK21_05_H      _PK_H_(0x21, 0x05)
#define REG_SC_BK21_06_L      _PK_L_(0x21, 0x06)
#define REG_SC_BK21_06_H      _PK_H_(0x21, 0x06)
#define REG_SC_BK21_07_L      _PK_L_(0x21, 0x07)
#define REG_SC_BK21_07_H      _PK_H_(0x21, 0x07)
#define REG_SC_BK21_08_L      _PK_L_(0x21, 0x08)
#define REG_SC_BK21_08_H      _PK_H_(0x21, 0x08)
#define REG_SC_BK21_09_L      _PK_L_(0x21, 0x09)
#define REG_SC_BK21_09_H      _PK_H_(0x21, 0x09)
#define REG_SC_BK21_0A_L      _PK_L_(0x21, 0x0A)
#define REG_SC_BK21_0A_H      _PK_H_(0x21, 0x0A)
#define REG_SC_BK21_0B_L      _PK_L_(0x21, 0x0B)
#define REG_SC_BK21_0B_H      _PK_H_(0x21, 0x0B)
#define REG_SC_BK21_0C_L      _PK_L_(0x21, 0x0C)
#define REG_SC_BK21_0C_H      _PK_H_(0x21, 0x0C)
#define REG_SC_BK21_0D_L      _PK_L_(0x21, 0x0d)
#define REG_SC_BK21_0D_H      _PK_H_(0x21, 0x0d)
#define REG_SC_BK21_0E_L      _PK_L_(0x21, 0x0e)
#define REG_SC_BK21_0E_H      _PK_H_(0x21, 0x0e)
#define REG_SC_BK21_0F_L      _PK_L_(0x21, 0x0f)
#define REG_SC_BK21_0F_H      _PK_H_(0x21, 0x0f)

#define REG_SC_BK21_10_L      _PK_L_(0x21, 0x10)
#define REG_SC_BK21_10_H      _PK_H_(0x21, 0x10)
#define REG_SC_BK21_11_L      _PK_L_(0x21, 0x11)
#define REG_SC_BK21_11_H      _PK_H_(0x21, 0x11)
#define REG_SC_BK21_12_L      _PK_L_(0x21, 0x12)
#define REG_SC_BK21_12_H      _PK_H_(0x21, 0x12)
#define REG_SC_BK21_13_L      _PK_L_(0x21, 0x13)
#define REG_SC_BK21_13_H      _PK_H_(0x21, 0x13)
#define REG_SC_BK21_14_L      _PK_L_(0x21, 0x14)
#define REG_SC_BK21_14_H      _PK_H_(0x21, 0x14)
#define REG_SC_BK21_15_L      _PK_L_(0x21, 0x15)
#define REG_SC_BK21_15_H      _PK_H_(0x21, 0x15)
#define REG_SC_BK21_16_L      _PK_L_(0x21, 0x16)
#define REG_SC_BK21_16_H      _PK_H_(0x21, 0x16)
#define REG_SC_BK21_17_L      _PK_L_(0x21, 0x17)
#define REG_SC_BK21_17_H      _PK_H_(0x21, 0x17)
#define REG_SC_BK21_18_L      _PK_L_(0x21, 0x18)
#define REG_SC_BK21_18_H      _PK_H_(0x21, 0x18)
#define REG_SC_BK21_19_L      _PK_L_(0x21, 0x19)
#define REG_SC_BK21_19_H      _PK_H_(0x21, 0x19)
#define REG_SC_BK21_1A_L      _PK_L_(0x21, 0x1A)
#define REG_SC_BK21_1A_H      _PK_H_(0x21, 0x1A)
#define REG_SC_BK21_1B_L      _PK_L_(0x21, 0x1B)
#define REG_SC_BK21_1B_H      _PK_H_(0x21, 0x1B)
#define REG_SC_BK21_1C_L      _PK_L_(0x21, 0x1C)
#define REG_SC_BK21_1C_H      _PK_H_(0x21, 0x1C)
#define REG_SC_BK21_1D_L      _PK_L_(0x21, 0x1d)
#define REG_SC_BK21_1D_H      _PK_H_(0x21, 0x1d)
#define REG_SC_BK21_1E_L      _PK_L_(0x21, 0x1e)
#define REG_SC_BK21_1E_H      _PK_H_(0x21, 0x1e)
#define REG_SC_BK21_1F_L      _PK_L_(0x21, 0x1f)
#define REG_SC_BK21_1F_H      _PK_H_(0x21, 0x1f)

#define REG_SC_BK21_20_L      _PK_L_(0x21, 0x20)
#define REG_SC_BK21_20_H      _PK_H_(0x21, 0x20)
#define REG_SC_BK21_21_L      _PK_L_(0x21, 0x21)
#define REG_SC_BK21_21_H      _PK_H_(0x21, 0x21)
#define REG_SC_BK21_22_L      _PK_L_(0x21, 0x22)
#define REG_SC_BK21_22_H      _PK_H_(0x21, 0x22)
#define REG_SC_BK21_23_L      _PK_L_(0x21, 0x23)
#define REG_SC_BK21_23_H      _PK_H_(0x21, 0x23)
#define REG_SC_BK21_24_L      _PK_L_(0x21, 0x24)
#define REG_SC_BK21_24_H      _PK_H_(0x21, 0x24)
#define REG_SC_BK21_25_L      _PK_L_(0x21, 0x25)
#define REG_SC_BK21_25_H      _PK_H_(0x21, 0x25)
#define REG_SC_BK21_26_L      _PK_L_(0x21, 0x26)
#define REG_SC_BK21_26_H      _PK_H_(0x21, 0x26)
#define REG_SC_BK21_27_L      _PK_L_(0x21, 0x27)
#define REG_SC_BK21_27_H      _PK_H_(0x21, 0x27)
#define REG_SC_BK21_28_L      _PK_L_(0x21, 0x28)
#define REG_SC_BK21_28_H      _PK_H_(0x21, 0x28)
#define REG_SC_BK21_29_L      _PK_L_(0x21, 0x29)
#define REG_SC_BK21_29_H      _PK_H_(0x21, 0x29)
#define REG_SC_BK21_2A_L      _PK_L_(0x21, 0x2A)
#define REG_SC_BK21_2A_H      _PK_H_(0x21, 0x2A)
#define REG_SC_BK21_2B_L      _PK_L_(0x21, 0x2B)
#define REG_SC_BK21_2B_H      _PK_H_(0x21, 0x2B)
#define REG_SC_BK21_2C_L      _PK_L_(0x21, 0x2C)
#define REG_SC_BK21_2C_H      _PK_H_(0x21, 0x2C)
#define REG_SC_BK21_2D_L      _PK_L_(0x21, 0x2d)
#define REG_SC_BK21_2D_H      _PK_H_(0x21, 0x2d)
#define REG_SC_BK21_2E_L      _PK_L_(0x21, 0x2e)
#define REG_SC_BK21_2E_H      _PK_H_(0x21, 0x2e)
#define REG_SC_BK21_2F_L      _PK_L_(0x21, 0x2f)
#define REG_SC_BK21_2F_H      _PK_H_(0x21, 0x2f)
#define REG_SC_BK21_77_L      _PK_L_(0x21, 0x77)

//----------------------------------------------
//  BK22
//----------------------------------------------
#define REG_SC_BK22_00_L      _PK_L_(0x22, 0x00)
#define REG_SC_BK22_00_H      _PK_H_(0x22, 0x00)
#define REG_SC_BK22_01_L      _PK_L_(0x22, 0x01)
#define REG_SC_BK22_01_H      _PK_H_(0x22, 0x01)
#define REG_SC_BK22_02_L      _PK_L_(0x22, 0x02)
#define REG_SC_BK22_02_H      _PK_H_(0x22, 0x02)
#define REG_SC_BK22_03_L      _PK_L_(0x22, 0x03)
#define REG_SC_BK22_03_H      _PK_H_(0x22, 0x03)
#define REG_SC_BK22_04_L      _PK_L_(0x22, 0x04)
#define REG_SC_BK22_04_H      _PK_H_(0x22, 0x04)
#define REG_SC_BK22_05_L      _PK_L_(0x22, 0x05)
#define REG_SC_BK22_05_H      _PK_H_(0x22, 0x05)
#define REG_SC_BK22_06_L      _PK_L_(0x22, 0x06)
#define REG_SC_BK22_06_H      _PK_H_(0x22, 0x06)
#define REG_SC_BK22_07_L      _PK_L_(0x22, 0x07)
#define REG_SC_BK22_07_H      _PK_H_(0x22, 0x07)
#define REG_SC_BK22_08_L      _PK_L_(0x22, 0x08)
#define REG_SC_BK22_08_H      _PK_H_(0x22, 0x08)
#define REG_SC_BK22_09_L      _PK_L_(0x22, 0x09)
#define REG_SC_BK22_09_H      _PK_H_(0x22, 0x09)
#define REG_SC_BK22_0A_L      _PK_L_(0x22, 0x0A)
#define REG_SC_BK22_0A_H      _PK_H_(0x22, 0x0A)
#define REG_SC_BK22_0B_L      _PK_L_(0x22, 0x0B)
#define REG_SC_BK22_0B_H      _PK_H_(0x22, 0x0B)
#define REG_SC_BK22_0C_L      _PK_L_(0x22, 0x0C)
#define REG_SC_BK22_0C_H      _PK_H_(0x22, 0x0C)
#define REG_SC_BK22_0D_L      _PK_L_(0x22, 0x0d)
#define REG_SC_BK22_0D_H      _PK_H_(0x22, 0x0d)
#define REG_SC_BK22_0E_L      _PK_L_(0x22, 0x0e)
#define REG_SC_BK22_0E_H      _PK_H_(0x22, 0x0e)
#define REG_SC_BK22_0F_L      _PK_L_(0x22, 0x0f)
#define REG_SC_BK22_0F_H      _PK_H_(0x22, 0x0f)

#define REG_SC_BK22_10_L      _PK_L_(0x22, 0x10)
#define REG_SC_BK22_10_H      _PK_H_(0x22, 0x10)
#define REG_SC_BK22_11_L      _PK_L_(0x22, 0x11)
#define REG_SC_BK22_11_H      _PK_H_(0x22, 0x11)
#define REG_SC_BK22_12_L      _PK_L_(0x22, 0x12)
#define REG_SC_BK22_12_H      _PK_H_(0x22, 0x12)
#define REG_SC_BK22_13_L      _PK_L_(0x22, 0x13)
#define REG_SC_BK22_13_H      _PK_H_(0x22, 0x13)
#define REG_SC_BK22_14_L      _PK_L_(0x22, 0x14)
#define REG_SC_BK22_14_H      _PK_H_(0x22, 0x14)
#define REG_SC_BK22_15_L      _PK_L_(0x22, 0x15)
#define REG_SC_BK22_15_H      _PK_H_(0x22, 0x15)
#define REG_SC_BK22_16_L      _PK_L_(0x22, 0x16)
#define REG_SC_BK22_16_H      _PK_H_(0x22, 0x16)
#define REG_SC_BK22_17_L      _PK_L_(0x22, 0x17)
#define REG_SC_BK22_17_H      _PK_H_(0x22, 0x17)
#define REG_SC_BK22_18_L      _PK_L_(0x22, 0x18)
#define REG_SC_BK22_18_H      _PK_H_(0x22, 0x18)
#define REG_SC_BK22_19_L      _PK_L_(0x22, 0x19)
#define REG_SC_BK22_19_H      _PK_H_(0x22, 0x19)
#define REG_SC_BK22_1A_L      _PK_L_(0x22, 0x1A)
#define REG_SC_BK22_1A_H      _PK_H_(0x22, 0x1A)
#define REG_SC_BK22_1B_L      _PK_L_(0x22, 0x1B)
#define REG_SC_BK22_1B_H      _PK_H_(0x22, 0x1B)
#define REG_SC_BK22_1C_L      _PK_L_(0x22, 0x1C)
#define REG_SC_BK22_1C_H      _PK_H_(0x22, 0x1C)
#define REG_SC_BK22_1D_L      _PK_L_(0x22, 0x1d)
#define REG_SC_BK22_1D_H      _PK_H_(0x22, 0x1d)
#define REG_SC_BK22_1E_L      _PK_L_(0x22, 0x1e)
#define REG_SC_BK22_1E_H      _PK_H_(0x22, 0x1e)
#define REG_SC_BK22_1F_L      _PK_L_(0x22, 0x1f)
#define REG_SC_BK22_1F_H      _PK_H_(0x22, 0x1f)

#define REG_SC_BK22_70_L      _PK_L_(0x22, 0x70)
#define REG_SC_BK22_70_H      _PK_H_(0x22, 0x70)
#define REG_SC_BK22_71_L      _PK_L_(0x22, 0x71)
#define REG_SC_BK22_71_H      _PK_H_(0x22, 0x71)
#define REG_SC_BK22_72_L      _PK_L_(0x22, 0x72)
#define REG_SC_BK22_72_H      _PK_H_(0x22, 0x72)
#define REG_SC_BK22_73_L      _PK_L_(0x22, 0x73)
#define REG_SC_BK22_73_H      _PK_H_(0x22, 0x73)
#define REG_SC_BK22_74_L      _PK_L_(0x22, 0x74)
#define REG_SC_BK22_74_H      _PK_H_(0x22, 0x74)
#define REG_SC_BK22_75_L      _PK_L_(0x22, 0x75)
#define REG_SC_BK22_75_H      _PK_H_(0x22, 0x75)
#define REG_SC_BK22_76_L      _PK_L_(0x22, 0x76)
#define REG_SC_BK22_76_H      _PK_H_(0x22, 0x76)
#define REG_SC_BK22_77_L      _PK_L_(0x22, 0x77)
#define REG_SC_BK22_77_H      _PK_H_(0x22, 0x77)
#define REG_SC_BK22_78_L      _PK_L_(0x22, 0x78)
#define REG_SC_BK22_78_H      _PK_H_(0x22, 0x78)
#define REG_SC_BK22_79_L      _PK_L_(0x22, 0x79)
#define REG_SC_BK22_79_H      _PK_H_(0x22, 0x79)
#define REG_SC_BK22_7A_L      _PK_L_(0x22, 0x7A)
#define REG_SC_BK22_7A_H      _PK_H_(0x22, 0x7A)
#define REG_SC_BK22_7B_L      _PK_L_(0x22, 0x7B)
#define REG_SC_BK22_7B_H      _PK_H_(0x22, 0x7B)
#define REG_SC_BK22_7C_L      _PK_L_(0x22, 0x7C)
#define REG_SC_BK22_7C_H      _PK_H_(0x22, 0x7C)
#define REG_SC_BK22_7D_L      _PK_L_(0x22, 0x7d)
#define REG_SC_BK22_7D_H      _PK_H_(0x22, 0x7d)
#define REG_SC_BK22_7E_L      _PK_L_(0x22, 0x7e)
#define REG_SC_BK22_7E_H      _PK_H_(0x22, 0x7e)
#define REG_SC_BK22_7F_L      _PK_L_(0x22, 0x7f)
#define REG_SC_BK22_7F_H      _PK_H_(0x22, 0x7f)

//----------------------------------------------
//  BK23
//----------------------------------------------
#define REG_SC_BK23_00_L      _PK_L_(0x23, 0x00)
#define REG_SC_BK23_00_H      _PK_H_(0x23, 0x00)
#define REG_SC_BK23_01_L      _PK_L_(0x23, 0x01)
#define REG_SC_BK23_01_H      _PK_H_(0x23, 0x01)
#define REG_SC_BK23_02_L      _PK_L_(0x23, 0x02)
#define REG_SC_BK23_02_H      _PK_H_(0x23, 0x02)
#define REG_SC_BK23_03_L      _PK_L_(0x23, 0x03)
#define REG_SC_BK23_03_H      _PK_H_(0x23, 0x03)
#define REG_SC_BK23_04_L      _PK_L_(0x23, 0x04)
#define REG_SC_BK23_04_H      _PK_H_(0x23, 0x04)
#define REG_SC_BK23_05_L      _PK_L_(0x23, 0x05)
#define REG_SC_BK23_05_H      _PK_H_(0x23, 0x05)
#define REG_SC_BK23_06_L      _PK_L_(0x23, 0x06)
#define REG_SC_BK23_06_H      _PK_H_(0x23, 0x06)
#define REG_SC_BK23_07_L      _PK_L_(0x23, 0x07)
#define REG_SC_BK23_07_H      _PK_H_(0x23, 0x07)
#define REG_SC_BK23_08_L      _PK_L_(0x23, 0x08)
#define REG_SC_BK23_08_H      _PK_H_(0x23, 0x08)
#define REG_SC_BK23_09_L      _PK_L_(0x23, 0x09)
#define REG_SC_BK23_09_H      _PK_H_(0x23, 0x09)
#define REG_SC_BK23_0A_L      _PK_L_(0x23, 0x0A)
#define REG_SC_BK23_0A_H      _PK_H_(0x23, 0x0A)
#define REG_SC_BK23_0B_L      _PK_L_(0x23, 0x0B)
#define REG_SC_BK23_0B_H      _PK_H_(0x23, 0x0B)
#define REG_SC_BK23_0C_L      _PK_L_(0x23, 0x0C)
#define REG_SC_BK23_0C_H      _PK_H_(0x23, 0x0C)
#define REG_SC_BK23_0D_L      _PK_L_(0x23, 0x0d)
#define REG_SC_BK23_0D_H      _PK_H_(0x23, 0x0d)
#define REG_SC_BK23_0E_L      _PK_L_(0x23, 0x0e)
#define REG_SC_BK23_0E_H      _PK_H_(0x23, 0x0e)
#define REG_SC_BK23_0F_L      _PK_L_(0x23, 0x0f)
#define REG_SC_BK23_0F_H      _PK_H_(0x23, 0x0f)

#define REG_SC_BK23_10_L      _PK_L_(0x23, 0x10)
#define REG_SC_BK23_10_H      _PK_H_(0x23, 0x10)
#define REG_SC_BK23_11_L      _PK_L_(0x23, 0x11)
#define REG_SC_BK23_11_H      _PK_H_(0x23, 0x11)
#define REG_SC_BK23_12_L      _PK_L_(0x23, 0x12)
#define REG_SC_BK23_12_H      _PK_H_(0x23, 0x12)
#define REG_SC_BK23_13_L      _PK_L_(0x23, 0x13)
#define REG_SC_BK23_13_H      _PK_H_(0x23, 0x13)
#define REG_SC_BK23_14_L      _PK_L_(0x23, 0x14)
#define REG_SC_BK23_14_H      _PK_H_(0x23, 0x14)
#define REG_SC_BK23_15_L      _PK_L_(0x23, 0x15)
#define REG_SC_BK23_15_H      _PK_H_(0x23, 0x15)
#define REG_SC_BK23_16_L      _PK_L_(0x23, 0x16)
#define REG_SC_BK23_16_H      _PK_H_(0x23, 0x16)
#define REG_SC_BK23_17_L      _PK_L_(0x23, 0x17)
#define REG_SC_BK23_17_H      _PK_H_(0x23, 0x17)
#define REG_SC_BK23_18_L      _PK_L_(0x23, 0x18)
#define REG_SC_BK23_18_H      _PK_H_(0x23, 0x18)
#define REG_SC_BK23_19_L      _PK_L_(0x23, 0x19)
#define REG_SC_BK23_19_H      _PK_H_(0x23, 0x19)
#define REG_SC_BK23_1A_L      _PK_L_(0x23, 0x1A)
#define REG_SC_BK23_1A_H      _PK_H_(0x23, 0x1A)
#define REG_SC_BK23_1B_L      _PK_L_(0x23, 0x1B)
#define REG_SC_BK23_1B_H      _PK_H_(0x23, 0x1B)
#define REG_SC_BK23_1C_L      _PK_L_(0x23, 0x1C)
#define REG_SC_BK23_1C_H      _PK_H_(0x23, 0x1C)
#define REG_SC_BK23_1D_L      _PK_L_(0x23, 0x1d)
#define REG_SC_BK23_1D_H      _PK_H_(0x23, 0x1d)
#define REG_SC_BK23_1E_L      _PK_L_(0x23, 0x1e)
#define REG_SC_BK23_1E_H      _PK_H_(0x23, 0x1e)
#define REG_SC_BK23_1F_L      _PK_L_(0x23, 0x1f)
#define REG_SC_BK23_1F_H      _PK_H_(0x23, 0x1f)
#define REG_SC_BK23_20_L      _PK_L_(0x23, 0x20)
#define REG_SC_BK23_20_H      _PK_H_(0x23, 0x20)
#define REG_SC_BK23_21_L      _PK_L_(0x23, 0x21)
#define REG_SC_BK23_21_H      _PK_H_(0x23, 0x21)
#define REG_SC_BK23_22_L      _PK_L_(0x23, 0x22)
#define REG_SC_BK23_22_H      _PK_H_(0x23, 0x22)
#define REG_SC_BK23_23_L      _PK_L_(0x23, 0x23)
#define REG_SC_BK23_23_H      _PK_H_(0x23, 0x23)
#define REG_SC_BK23_24_L      _PK_L_(0x23, 0x24)
#define REG_SC_BK23_24_H      _PK_H_(0x23, 0x24)
#define REG_SC_BK23_25_L      _PK_L_(0x23, 0x25)
#define REG_SC_BK23_25_H      _PK_H_(0x23, 0x25)
#define REG_SC_BK23_26_L      _PK_L_(0x23, 0x26)
#define REG_SC_BK23_26_H      _PK_H_(0x23, 0x26)
#define REG_SC_BK23_27_L      _PK_L_(0x23, 0x27)
#define REG_SC_BK23_27_H      _PK_H_(0x23, 0x27)
#define REG_SC_BK23_28_L      _PK_L_(0x23, 0x28)
#define REG_SC_BK23_28_H      _PK_H_(0x23, 0x28)
#define REG_SC_BK23_29_L      _PK_L_(0x23, 0x29)
#define REG_SC_BK23_29_H      _PK_H_(0x23, 0x29)
#define REG_SC_BK23_2A_L      _PK_L_(0x23, 0x2A)
#define REG_SC_BK23_2A_H      _PK_H_(0x23, 0x2A)
#define REG_SC_BK23_2B_L      _PK_L_(0x23, 0x2B)
#define REG_SC_BK23_2B_H      _PK_H_(0x23, 0x2B)
#define REG_SC_BK23_2C_L      _PK_L_(0x23, 0x2C)
#define REG_SC_BK23_2C_H      _PK_H_(0x23, 0x2C)
#define REG_SC_BK23_2D_L      _PK_L_(0x23, 0x2D)
#define REG_SC_BK23_2D_H      _PK_H_(0x23, 0x2D)
#define REG_SC_BK23_2E_L      _PK_L_(0x23, 0x2E)
#define REG_SC_BK23_2E_H      _PK_H_(0x23, 0x2E)
#define REG_SC_BK23_2F_L      _PK_L_(0x23, 0x2F)
#define REG_SC_BK23_2F_H      _PK_H_(0x23, 0x2F)
#define REG_SC_BK23_30_L      _PK_L_(0x23, 0x30)
#define REG_SC_BK23_30_H      _PK_H_(0x23, 0x30)
#define REG_SC_BK23_31_L      _PK_L_(0x23, 0x31)
#define REG_SC_BK23_31_H      _PK_H_(0x23, 0x31)
#define REG_SC_BK23_32_L      _PK_L_(0x23, 0x32)
#define REG_SC_BK23_32_H      _PK_H_(0x23, 0x32)
#define REG_SC_BK23_33_L      _PK_L_(0x23, 0x33)
#define REG_SC_BK23_33_H      _PK_H_(0x23, 0x33)
#define REG_SC_BK23_34_L      _PK_L_(0x23, 0x34)
#define REG_SC_BK23_34_H      _PK_H_(0x23, 0x34)
#define REG_SC_BK23_35_L      _PK_L_(0x23, 0x35)
#define REG_SC_BK23_35_H      _PK_H_(0x23, 0x35)
#define REG_SC_BK23_36_L      _PK_L_(0x23, 0x36)
#define REG_SC_BK23_36_H      _PK_H_(0x23, 0x36)
#define REG_SC_BK23_37_L      _PK_L_(0x23, 0x37)
#define REG_SC_BK23_37_H      _PK_H_(0x23, 0x37)
#define REG_SC_BK23_38_L      _PK_L_(0x23, 0x38)
#define REG_SC_BK23_38_H      _PK_H_(0x23, 0x38)
#define REG_SC_BK23_39_L      _PK_L_(0x23, 0x39)
#define REG_SC_BK23_39_H      _PK_H_(0x23, 0x39)
#define REG_SC_BK23_3A_L      _PK_L_(0x23, 0x3A)
#define REG_SC_BK23_3A_H      _PK_H_(0x23, 0x3A)
#define REG_SC_BK23_3B_L      _PK_L_(0x23, 0x3B)
#define REG_SC_BK23_3B_H      _PK_H_(0x23, 0x3B)
#define REG_SC_BK23_3C_L      _PK_L_(0x23, 0x3C)
#define REG_SC_BK23_3C_H      _PK_H_(0x23, 0x3C)
#define REG_SC_BK23_3D_L      _PK_L_(0x23, 0x3D)
#define REG_SC_BK23_3D_H      _PK_H_(0x23, 0x3D)
#define REG_SC_BK23_3E_L      _PK_L_(0x23, 0x3E)
#define REG_SC_BK23_3E_H      _PK_H_(0x23, 0x3E)
#define REG_SC_BK23_3F_L      _PK_L_(0x23, 0x3F)
#define REG_SC_BK23_3F_H      _PK_H_(0x23, 0x3F)
#define REG_SC_BK23_40_L      _PK_L_(0x23, 0x40)
#define REG_SC_BK23_40_H      _PK_H_(0x23, 0x40)
#define REG_SC_BK23_41_L      _PK_L_(0x23, 0x41)
#define REG_SC_BK23_41_H      _PK_H_(0x23, 0x41)
#define REG_SC_BK23_42_L      _PK_L_(0x23, 0x42)
#define REG_SC_BK23_42_H      _PK_H_(0x23, 0x42)
#define REG_SC_BK23_43_L      _PK_L_(0x23, 0x43)
#define REG_SC_BK23_43_H      _PK_H_(0x23, 0x43)
#define REG_SC_BK23_44_L      _PK_L_(0x23, 0x44)
#define REG_SC_BK23_44_H      _PK_H_(0x23, 0x44)
#define REG_SC_BK23_45_L      _PK_L_(0x23, 0x45)
#define REG_SC_BK23_45_H      _PK_H_(0x23, 0x45)
#define REG_SC_BK23_46_L      _PK_L_(0x23, 0x46)
#define REG_SC_BK23_46_H      _PK_H_(0x23, 0x46)
#define REG_SC_BK23_47_L      _PK_L_(0x23, 0x47)
#define REG_SC_BK23_47_H      _PK_H_(0x23, 0x47)
#define REG_SC_BK23_48_L      _PK_L_(0x23, 0x48)
#define REG_SC_BK23_48_H      _PK_H_(0x23, 0x48)
#define REG_SC_BK23_49_L      _PK_L_(0x23, 0x49)
#define REG_SC_BK23_49_H      _PK_H_(0x23, 0x49)
#define REG_SC_BK23_4A_L      _PK_L_(0x23, 0x4A)
#define REG_SC_BK23_4A_H      _PK_H_(0x23, 0x4A)
#define REG_SC_BK23_4B_L      _PK_L_(0x23, 0x4B)
#define REG_SC_BK23_4B_H      _PK_H_(0x23, 0x4B)
#define REG_SC_BK23_4C_L      _PK_L_(0x23, 0x4C)
#define REG_SC_BK23_4C_H      _PK_H_(0x23, 0x4C)
#define REG_SC_BK23_4D_L      _PK_L_(0x23, 0x4D)
#define REG_SC_BK23_4D_H      _PK_H_(0x23, 0x4D)
#define REG_SC_BK23_4E_L      _PK_L_(0x23, 0x4E)
#define REG_SC_BK23_4E_H      _PK_H_(0x23, 0x4E)
#define REG_SC_BK23_4F_L      _PK_L_(0x23, 0x4F)
#define REG_SC_BK23_4F_H      _PK_H_(0x23, 0x4F)
#define REG_SC_BK23_50_L      _PK_L_(0x23, 0x50)
#define REG_SC_BK23_50_H      _PK_H_(0x23, 0x50)
#define REG_SC_BK23_51_L      _PK_L_(0x23, 0x51)
#define REG_SC_BK23_51_H      _PK_H_(0x23, 0x51)
#define REG_SC_BK23_52_L      _PK_L_(0x23, 0x52)
#define REG_SC_BK23_52_H      _PK_H_(0x23, 0x52)
#define REG_SC_BK23_53_L      _PK_L_(0x23, 0x53)
#define REG_SC_BK23_53_H      _PK_H_(0x23, 0x53)
#define REG_SC_BK23_54_L      _PK_L_(0x23, 0x54)
#define REG_SC_BK23_54_H      _PK_H_(0x23, 0x54)
#define REG_SC_BK23_55_L      _PK_L_(0x23, 0x55)
#define REG_SC_BK23_55_H      _PK_H_(0x23, 0x55)
#define REG_SC_BK23_56_L      _PK_L_(0x23, 0x56)
#define REG_SC_BK23_56_H      _PK_H_(0x23, 0x56)
#define REG_SC_BK23_57_L      _PK_L_(0x23, 0x57)
#define REG_SC_BK23_57_H      _PK_H_(0x23, 0x57)
#define REG_SC_BK23_58_L      _PK_L_(0x23, 0x58)
#define REG_SC_BK23_58_H      _PK_H_(0x23, 0x58)
#define REG_SC_BK23_59_L      _PK_L_(0x23, 0x59)
#define REG_SC_BK23_59_H      _PK_H_(0x23, 0x59)
#define REG_SC_BK23_5A_L      _PK_L_(0x23, 0x5A)
#define REG_SC_BK23_5A_H      _PK_H_(0x23, 0x5A)
#define REG_SC_BK23_5B_L      _PK_L_(0x23, 0x5B)
#define REG_SC_BK23_5B_H      _PK_H_(0x23, 0x5B)
#define REG_SC_BK23_5C_L      _PK_L_(0x23, 0x5C)
#define REG_SC_BK23_5C_H      _PK_H_(0x23, 0x5C)
#define REG_SC_BK23_5D_L      _PK_L_(0x23, 0x5D)
#define REG_SC_BK23_5D_H      _PK_H_(0x23, 0x5D)
#define REG_SC_BK23_5E_L      _PK_L_(0x23, 0x5E)
#define REG_SC_BK23_5E_H      _PK_H_(0x23, 0x5E)
#define REG_SC_BK23_5F_L      _PK_L_(0x23, 0x5F)
#define REG_SC_BK23_5F_H      _PK_H_(0x23, 0x5F)
#define REG_SC_BK23_60_L      _PK_L_(0x23, 0x60)
#define REG_SC_BK23_60_H      _PK_H_(0x23, 0x60)
#define REG_SC_BK23_61_L      _PK_L_(0x23, 0x61)
#define REG_SC_BK23_61_H      _PK_H_(0x23, 0x61)
#define REG_SC_BK23_62_L      _PK_L_(0x23, 0x62)
#define REG_SC_BK23_62_H      _PK_H_(0x23, 0x62)
#define REG_SC_BK23_63_L      _PK_L_(0x23, 0x63)
#define REG_SC_BK23_63_H      _PK_H_(0x23, 0x63)
#define REG_SC_BK23_64_L      _PK_L_(0x23, 0x64)
#define REG_SC_BK23_64_H      _PK_H_(0x23, 0x64)
#define REG_SC_BK23_65_L      _PK_L_(0x23, 0x65)
#define REG_SC_BK23_65_H      _PK_H_(0x23, 0x65)
#define REG_SC_BK23_66_L      _PK_L_(0x23, 0x66)
#define REG_SC_BK23_66_H      _PK_H_(0x23, 0x66)
#define REG_SC_BK23_67_L      _PK_L_(0x23, 0x67)
#define REG_SC_BK23_67_H      _PK_H_(0x23, 0x67)
#define REG_SC_BK23_68_L      _PK_L_(0x23, 0x68)
#define REG_SC_BK23_68_H      _PK_H_(0x23, 0x68)
#define REG_SC_BK23_69_L      _PK_L_(0x23, 0x69)
#define REG_SC_BK23_69_H      _PK_H_(0x23, 0x69)
#define REG_SC_BK23_6A_L      _PK_L_(0x23, 0x6A)
#define REG_SC_BK23_6A_H      _PK_H_(0x23, 0x6A)
#define REG_SC_BK23_6B_L      _PK_L_(0x23, 0x6B)
#define REG_SC_BK23_6B_H      _PK_H_(0x23, 0x6B)
#define REG_SC_BK23_6C_L      _PK_L_(0x23, 0x6C)
#define REG_SC_BK23_6C_H      _PK_H_(0x23, 0x6C)
#define REG_SC_BK23_6D_L      _PK_L_(0x23, 0x6D)
#define REG_SC_BK23_6D_H      _PK_H_(0x23, 0x6D)
#define REG_SC_BK23_6E_L      _PK_L_(0x23, 0x6E)
#define REG_SC_BK23_6E_H      _PK_H_(0x23, 0x6E)
#define REG_SC_BK23_6F_L      _PK_L_(0x23, 0x6F)
#define REG_SC_BK23_6F_H      _PK_H_(0x23, 0x6F)
#define REG_SC_BK23_70_L      _PK_L_(0x23, 0x70)
#define REG_SC_BK23_70_H      _PK_H_(0x23, 0x70)
#define REG_SC_BK23_71_L      _PK_L_(0x23, 0x71)
#define REG_SC_BK23_71_H      _PK_H_(0x23, 0x71)
#define REG_SC_BK23_72_L      _PK_L_(0x23, 0x72)
#define REG_SC_BK23_72_H      _PK_H_(0x23, 0x72)
#define REG_SC_BK23_73_L      _PK_L_(0x23, 0x73)
#define REG_SC_BK23_73_H      _PK_H_(0x23, 0x73)
#define REG_SC_BK23_74_L      _PK_L_(0x23, 0x74)
#define REG_SC_BK23_74_H      _PK_H_(0x23, 0x74)
#define REG_SC_BK23_75_L      _PK_L_(0x23, 0x75)
#define REG_SC_BK23_75_H      _PK_H_(0x23, 0x75)
#define REG_SC_BK23_76_L      _PK_L_(0x23, 0x76)
#define REG_SC_BK23_76_H      _PK_H_(0x23, 0x76)
#define REG_SC_BK23_77_L      _PK_L_(0x23, 0x77)
#define REG_SC_BK23_77_H      _PK_H_(0x23, 0x77)

//----------------------------------------------
//  BK24
//----------------------------------------------
#define REG_SC_BK24_5F_L      _PK_L_(0x24, 0x5F)
#define REG_SC_BK24_5F_H      _PK_H_(0x24, 0x5F)
#define REG_SC_BK24_60_L      _PK_L_(0x24, 0x60)
#define REG_SC_BK24_60_H      _PK_H_(0x24, 0x60)
#define REG_SC_BK24_61_L      _PK_L_(0x24, 0x61)
#define REG_SC_BK24_61_H      _PK_H_(0x24, 0x61)
#define REG_SC_BK24_62_L      _PK_L_(0x24, 0x62)
#define REG_SC_BK24_62_H      _PK_H_(0x24, 0x62)
#define REG_SC_BK24_63_L      _PK_L_(0x24, 0x63)
#define REG_SC_BK24_63_H      _PK_H_(0x24, 0x63)
#define REG_SC_BK24_64_L      _PK_L_(0x24, 0x64)
#define REG_SC_BK24_64_H      _PK_H_(0x24, 0x64)
#define REG_SC_BK24_65_L      _PK_L_(0x24, 0x65)
#define REG_SC_BK24_65_H      _PK_H_(0x24, 0x65)
#define REG_SC_BK24_66_L      _PK_L_(0x24, 0x66)
#define REG_SC_BK24_66_H      _PK_H_(0x24, 0x66)

//----------------------------------------------
//  BK25
//----------------------------------------------
#define REG_SC_BK25_01_L      _PK_L_(0x25, 0x01)
#define REG_SC_BK25_01_H      _PK_H_(0x25, 0x01)
#define REG_SC_BK25_02_L      _PK_L_(0x25, 0x02)
#define REG_SC_BK25_02_H      _PK_H_(0x25, 0x02)
#define REG_SC_BK25_03_L      _PK_L_(0x25, 0x03)
#define REG_SC_BK25_03_H      _PK_H_(0x25, 0x03)
#define REG_SC_BK25_04_L      _PK_L_(0x25, 0x04)
#define REG_SC_BK25_04_H      _PK_H_(0x25, 0x04)
#define REG_SC_BK25_05_L      _PK_L_(0x25, 0x05)
#define REG_SC_BK25_05_H      _PK_H_(0x25, 0x05)
#define REG_SC_BK25_06_L      _PK_L_(0x25, 0x06)
#define REG_SC_BK25_06_H      _PK_H_(0x25, 0x06)
#define REG_SC_BK25_07_L      _PK_L_(0x25, 0x07)
#define REG_SC_BK25_07_H      _PK_H_(0x25, 0x07)
#define REG_SC_BK25_08_L      _PK_L_(0x25, 0x08)
#define REG_SC_BK25_08_H      _PK_H_(0x25, 0x08)
#define REG_SC_BK25_09_L      _PK_L_(0x25, 0x09)
#define REG_SC_BK25_09_H      _PK_H_(0x25, 0x09)
#define REG_SC_BK25_0A_L      _PK_L_(0x25, 0x0A)
#define REG_SC_BK25_0A_H      _PK_H_(0x25, 0x0A)
#define REG_SC_BK25_0B_L      _PK_L_(0x25, 0x0B)
#define REG_SC_BK25_0B_H      _PK_H_(0x25, 0x0B)
#define REG_SC_BK25_0C_L      _PK_L_(0x25, 0x0C)
#define REG_SC_BK25_0C_H      _PK_H_(0x25, 0x0C)
#define REG_SC_BK25_0D_L      _PK_L_(0x25, 0x0d)
#define REG_SC_BK25_0D_H      _PK_H_(0x25, 0x0d)
#define REG_SC_BK25_0E_L      _PK_L_(0x25, 0x0e)
#define REG_SC_BK25_0E_H      _PK_H_(0x25, 0x0e)
#define REG_SC_BK25_0F_L      _PK_L_(0x25, 0x0f)
#define REG_SC_BK25_0F_H      _PK_H_(0x25, 0x0f)
#define REG_SC_BK25_10_L      _PK_L_(0x25, 0x10)
#define REG_SC_BK25_10_H      _PK_H_(0x25, 0x10)
#define REG_SC_BK25_11_L      _PK_L_(0x25, 0x11)
#define REG_SC_BK25_11_H      _PK_H_(0x25, 0x11)
#define REG_SC_BK25_12_L      _PK_L_(0x25, 0x12)
#define REG_SC_BK25_12_H      _PK_H_(0x25, 0x12)
#define REG_SC_BK25_13_L      _PK_L_(0x25, 0x13)
#define REG_SC_BK25_13_H      _PK_H_(0x25, 0x13)
#define REG_SC_BK25_14_L      _PK_L_(0x25, 0x14)
#define REG_SC_BK25_14_H      _PK_H_(0x25, 0x14)
#define REG_SC_BK25_15_L      _PK_L_(0x25, 0x15)
#define REG_SC_BK25_15_H      _PK_H_(0x25, 0x15)
#define REG_SC_BK25_16_L      _PK_L_(0x25, 0x16)
#define REG_SC_BK25_16_H      _PK_H_(0x25, 0x16)
#define REG_SC_BK25_17_L      _PK_L_(0x25, 0x17)
#define REG_SC_BK25_17_H      _PK_H_(0x25, 0x17)
#define REG_SC_BK25_18_L      _PK_L_(0x25, 0x18)
#define REG_SC_BK25_18_H      _PK_H_(0x25, 0x18)
#define REG_SC_BK25_19_L      _PK_L_(0x25, 0x19)
#define REG_SC_BK25_19_H      _PK_H_(0x25, 0x19)
#define REG_SC_BK25_1A_L      _PK_L_(0x25, 0x1A)
#define REG_SC_BK25_1A_H      _PK_H_(0x25, 0x1A)
#define REG_SC_BK25_1B_L      _PK_L_(0x25, 0x1B)
#define REG_SC_BK25_1B_H      _PK_H_(0x25, 0x1B)
#define REG_SC_BK25_1C_L      _PK_L_(0x25, 0x1C)
#define REG_SC_BK25_1C_H      _PK_H_(0x25, 0x1C)
#define REG_SC_BK25_1D_L      _PK_L_(0x25, 0x1d)
#define REG_SC_BK25_1D_H      _PK_H_(0x25, 0x1d)
#define REG_SC_BK25_1E_L      _PK_L_(0x25, 0x1e)
#define REG_SC_BK25_1E_H      _PK_H_(0x25, 0x1e)
#define REG_SC_BK25_1F_L      _PK_L_(0x25, 0x1f)
#define REG_SC_BK25_1F_H      _PK_H_(0x25, 0x1f)
#define REG_SC_BK25_20_L      _PK_L_(0x25, 0x20)
#define REG_SC_BK25_20_H      _PK_H_(0x25, 0x20)
#define REG_SC_BK25_21_L      _PK_L_(0x25, 0x21)
#define REG_SC_BK25_21_H      _PK_H_(0x25, 0x21)
#define REG_SC_BK25_22_L      _PK_L_(0x25, 0x22)
#define REG_SC_BK25_22_H      _PK_H_(0x25, 0x22)
#define REG_SC_BK25_23_L      _PK_L_(0x25, 0x23)
#define REG_SC_BK25_23_H      _PK_H_(0x25, 0x23)
#define REG_SC_BK25_24_L      _PK_L_(0x25, 0x24)
#define REG_SC_BK25_24_H      _PK_H_(0x25, 0x24)
#define REG_SC_BK25_25_L      _PK_L_(0x25, 0x25)
#define REG_SC_BK25_25_H      _PK_H_(0x25, 0x25)
#define REG_SC_BK25_26_L      _PK_L_(0x25, 0x26)
#define REG_SC_BK25_26_H      _PK_H_(0x25, 0x26)
#define REG_SC_BK25_27_L      _PK_L_(0x25, 0x27)
#define REG_SC_BK25_27_H      _PK_H_(0x25, 0x27)
#define REG_SC_BK25_28_L      _PK_L_(0x25, 0x28)
#define REG_SC_BK25_28_H      _PK_H_(0x25, 0x28)
#define REG_SC_BK25_29_L      _PK_L_(0x25, 0x29)
#define REG_SC_BK25_29_H      _PK_H_(0x25, 0x29)
#define REG_SC_BK25_2A_L      _PK_L_(0x25, 0x2A)
#define REG_SC_BK25_2A_H      _PK_H_(0x25, 0x2A)
#define REG_SC_BK25_2B_L      _PK_L_(0x25, 0x2B)
#define REG_SC_BK25_2B_H      _PK_H_(0x25, 0x2B)
#define REG_SC_BK25_2C_L      _PK_L_(0x25, 0x2C)
#define REG_SC_BK25_2C_H      _PK_H_(0x25, 0x2C)
#define REG_SC_BK25_2D_L      _PK_L_(0x25, 0x2d)
#define REG_SC_BK25_2D_H      _PK_H_(0x25, 0x2d)

//----------------------------------------------
//  BK26
//----------------------------------------------
#define REG_SC_BK26_10_L      _PK_L_(0x26, 0x10)
#define REG_SC_BK26_10_H      _PK_H_(0x26, 0x10)
#define REG_SC_BK26_11_L      _PK_L_(0x26, 0x11)
#define REG_SC_BK26_11_H      _PK_H_(0x26, 0x11)
#define REG_SC_BK26_12_L      _PK_L_(0x26, 0x12)
#define REG_SC_BK26_12_H      _PK_H_(0x26, 0x12)
#define REG_SC_BK26_13_L      _PK_L_(0x26, 0x13)
#define REG_SC_BK26_13_H      _PK_H_(0x26, 0x13)
#define REG_SC_BK26_14_L      _PK_L_(0x26, 0x14)
#define REG_SC_BK26_14_H      _PK_H_(0x26, 0x14)
#define REG_SC_BK26_15_L      _PK_L_(0x26, 0x15)
#define REG_SC_BK26_15_H      _PK_H_(0x26, 0x15)
#define REG_SC_BK26_16_L      _PK_L_(0x26, 0x16)
#define REG_SC_BK26_16_H      _PK_H_(0x26, 0x16)
#define REG_SC_BK26_17_L      _PK_L_(0x26, 0x17)
#define REG_SC_BK26_17_H      _PK_H_(0x26, 0x17)
#define REG_SC_BK26_18_L      _PK_L_(0x26, 0x18)
#define REG_SC_BK26_18_H      _PK_H_(0x26, 0x18)
#define REG_SC_BK26_19_L      _PK_L_(0x26, 0x19)
#define REG_SC_BK26_19_H      _PK_H_(0x26, 0x19)
#define REG_SC_BK26_1A_L      _PK_L_(0x26, 0x1a)
#define REG_SC_BK26_1A_H      _PK_H_(0x26, 0x1a)
#define REG_SC_BK26_1B_L      _PK_L_(0x26, 0x1b)
#define REG_SC_BK26_1B_H      _PK_H_(0x26, 0x1b)
#define REG_SC_BK26_1C_L      _PK_L_(0x26, 0x1c)
#define REG_SC_BK26_1C_H      _PK_H_(0x26, 0x1c)
#define REG_SC_BK26_1D_L      _PK_L_(0x26, 0x1d)
#define REG_SC_BK26_1D_H      _PK_H_(0x26, 0x1d)
#define REG_SC_BK26_1E_L      _PK_L_(0x26, 0x1e)
#define REG_SC_BK26_1E_H      _PK_H_(0x26, 0x1e)
#define REG_SC_BK26_1F_L      _PK_L_(0x26, 0x1f)
#define REG_SC_BK26_1F_H      _PK_H_(0x26, 0x1f)


#define REG_SC_BK26_50_L      _PK_L_(0x26, 0x50)
#define REG_SC_BK26_50_H      _PK_H_(0x26, 0x50)
#define REG_SC_BK26_51_L      _PK_L_(0x26, 0x51)
#define REG_SC_BK26_51_H      _PK_H_(0x26, 0x51)
#define REG_SC_BK26_52_L      _PK_L_(0x26, 0x52)
#define REG_SC_BK26_52_H      _PK_H_(0x26, 0x52)
#define REG_SC_BK26_53_L      _PK_L_(0x26, 0x53)
#define REG_SC_BK26_53_H      _PK_H_(0x26, 0x53)
#define REG_SC_BK26_54_L      _PK_L_(0x26, 0x54)
#define REG_SC_BK26_54_H      _PK_H_(0x26, 0x54)
#define REG_SC_BK26_55_L      _PK_L_(0x26, 0x55)
#define REG_SC_BK26_55_H      _PK_H_(0x26, 0x55)
#define REG_SC_BK26_56_L      _PK_L_(0x26, 0x56)
#define REG_SC_BK26_56_H      _PK_H_(0x26, 0x56)
#define REG_SC_BK26_57_L      _PK_L_(0x26, 0x57)
#define REG_SC_BK26_57_H      _PK_H_(0x26, 0x57)
#define REG_SC_BK26_58_L      _PK_L_(0x26, 0x58)
#define REG_SC_BK26_58_H      _PK_H_(0x26, 0x58)
#define REG_SC_BK26_59_L      _PK_L_(0x26, 0x59)
#define REG_SC_BK26_59_H      _PK_H_(0x26, 0x59)
#define REG_SC_BK26_5A_L      _PK_L_(0x26, 0x5a)
#define REG_SC_BK26_5A_H      _PK_H_(0x26, 0x5a)
#define REG_SC_BK26_5B_L      _PK_L_(0x26, 0x5b)
#define REG_SC_BK26_5B_H      _PK_H_(0x26, 0x5b)
#define REG_SC_BK26_5C_L      _PK_L_(0x26, 0x5c)
#define REG_SC_BK26_5C_H      _PK_H_(0x26, 0x5c)
#define REG_SC_BK26_5D_L      _PK_L_(0x26, 0x5d)
#define REG_SC_BK26_5D_H      _PK_H_(0x26, 0x5d)
#define REG_SC_BK26_5E_L      _PK_L_(0x26, 0x5e)
#define REG_SC_BK26_5E_H      _PK_H_(0x26, 0x5e)
#define REG_SC_BK26_5F_L      _PK_L_(0x26, 0x5f)
#define REG_SC_BK26_5F_H      _PK_H_(0x26, 0x5f)
//--------------------------------------------------------
#define REG_SC_BK27_20_L      _PK_L_(0x27, 0x20)
#define REG_SC_BK27_20_H      _PK_H_(0x27, 0x20)
#define REG_SC_BK27_21_L      _PK_L_(0x27, 0x21)
#define REG_SC_BK27_21_H      _PK_H_(0x27, 0x21)
#define REG_SC_BK27_22_L      _PK_L_(0x27, 0x22)
#define REG_SC_BK27_22_H      _PK_H_(0x27, 0x22)
#define REG_SC_BK27_23_L      _PK_L_(0x27, 0x23)
#define REG_SC_BK27_23_H      _PK_H_(0x27, 0x23)
#define REG_SC_BK27_24_L      _PK_L_(0x27, 0x24)
#define REG_SC_BK27_24_H      _PK_H_(0x27, 0x24)
#define REG_SC_BK27_25_L      _PK_L_(0x27, 0x25)
#define REG_SC_BK27_25_H      _PK_H_(0x27, 0x25)
#define REG_SC_BK27_26_L      _PK_L_(0x27, 0x26)
#define REG_SC_BK27_26_H      _PK_H_(0x27, 0x26)
#define REG_SC_BK27_27_L      _PK_L_(0x27, 0x27)
#define REG_SC_BK27_27_H      _PK_H_(0x27, 0x27)
#define REG_SC_BK27_28_L      _PK_L_(0x27, 0x28)
#define REG_SC_BK27_28_H      _PK_H_(0x27, 0x28)
#define REG_SC_BK27_29_L      _PK_L_(0x27, 0x29)
#define REG_SC_BK27_29_H      _PK_H_(0x27, 0x29)
#define REG_SC_BK27_2A_L      _PK_L_(0x27, 0x2a)
#define REG_SC_BK27_2A_H      _PK_H_(0x27, 0x2a)
#define REG_SC_BK27_2B_L      _PK_L_(0x27, 0x2b)
#define REG_SC_BK27_2B_H      _PK_H_(0x27, 0x2b)
#define REG_SC_BK27_2C_L      _PK_L_(0x27, 0x2c)
#define REG_SC_BK27_2C_H      _PK_H_(0x27, 0x2c)
#define REG_SC_BK27_2D_L      _PK_L_(0x27, 0x2d)
#define REG_SC_BK27_2D_H      _PK_H_(0x27, 0x2d)
#define REG_SC_BK27_2E_L      _PK_L_(0x27, 0x2e)
#define REG_SC_BK27_2E_H      _PK_H_(0x27, 0x2e)
#define REG_SC_BK27_2F_L      _PK_L_(0x27, 0x2f)
#define REG_SC_BK27_2F_H      _PK_H_(0x27, 0x2f)

#define REG_SC_BK27_30_L      _PK_L_(0x27, 0x30)
#define REG_SC_BK27_30_H      _PK_H_(0x27, 0x30)
#define REG_SC_BK27_31_L      _PK_L_(0x27, 0x31)
#define REG_SC_BK27_31_H      _PK_H_(0x27, 0x31)
#define REG_SC_BK27_32_L      _PK_L_(0x27, 0x32)
#define REG_SC_BK27_32_H      _PK_H_(0x27, 0x32)
#define REG_SC_BK27_33_L      _PK_L_(0x27, 0x33)
#define REG_SC_BK27_33_H      _PK_H_(0x27, 0x33)
#define REG_SC_BK27_34_L      _PK_L_(0x27, 0x34)
#define REG_SC_BK27_34_H      _PK_H_(0x27, 0x34)
#define REG_SC_BK27_35_L      _PK_L_(0x27, 0x35)
#define REG_SC_BK27_35_H      _PK_H_(0x27, 0x35)
#define REG_SC_BK27_36_L      _PK_L_(0x27, 0x36)
#define REG_SC_BK27_36_H      _PK_H_(0x27, 0x36)
#define REG_SC_BK27_37_L      _PK_L_(0x27, 0x37)
#define REG_SC_BK27_37_H      _PK_H_(0x27, 0x37)
#define REG_SC_BK27_38_L      _PK_L_(0x27, 0x38)
#define REG_SC_BK27_38_H      _PK_H_(0x27, 0x38)
#define REG_SC_BK27_39_L      _PK_L_(0x27, 0x39)
#define REG_SC_BK27_39_H      _PK_H_(0x27, 0x39)
#define REG_SC_BK27_3A_L      _PK_L_(0x27, 0x3a)
#define REG_SC_BK27_3A_H      _PK_H_(0x27, 0x3a)
#define REG_SC_BK27_3B_L      _PK_L_(0x27, 0x3b)
#define REG_SC_BK27_3B_H      _PK_H_(0x27, 0x3b)
#define REG_SC_BK27_3C_L      _PK_L_(0x27, 0x3c)
#define REG_SC_BK27_3C_H      _PK_H_(0x27, 0x3c)
#define REG_SC_BK27_3D_L      _PK_L_(0x27, 0x3d)
#define REG_SC_BK27_3D_H      _PK_H_(0x27, 0x3d)
#define REG_SC_BK27_3E_L      _PK_L_(0x27, 0x3e)
#define REG_SC_BK27_3E_H      _PK_H_(0x27, 0x3e)
#define REG_SC_BK27_3F_L      _PK_L_(0x27, 0x3f)
#define REG_SC_BK27_3F_H      _PK_H_(0x27, 0x3f)


#define REG_SC_BK27_60_L      _PK_L_(0x27, 0x60)
#define REG_SC_BK27_60_H      _PK_H_(0x27, 0x60)
#define REG_SC_BK27_61_L      _PK_L_(0x27, 0x61)
#define REG_SC_BK27_61_H      _PK_H_(0x27, 0x61)
#define REG_SC_BK27_62_L      _PK_L_(0x27, 0x62)
#define REG_SC_BK27_62_H      _PK_H_(0x27, 0x62)
#define REG_SC_BK27_63_L      _PK_L_(0x27, 0x63)
#define REG_SC_BK27_63_H      _PK_H_(0x27, 0x63)
#define REG_SC_BK27_64_L      _PK_L_(0x27, 0x64)
#define REG_SC_BK27_64_H      _PK_H_(0x27, 0x64)
#define REG_SC_BK27_65_L      _PK_L_(0x27, 0x65)
#define REG_SC_BK27_65_H      _PK_H_(0x27, 0x65)
#define REG_SC_BK27_66_L      _PK_L_(0x27, 0x66)
#define REG_SC_BK27_66_H      _PK_H_(0x27, 0x66)
#define REG_SC_BK27_67_L      _PK_L_(0x27, 0x67)
#define REG_SC_BK27_67_H      _PK_H_(0x27, 0x67)
#define REG_SC_BK27_68_L      _PK_L_(0x27, 0x68)
#define REG_SC_BK27_68_H      _PK_H_(0x27, 0x68)
#define REG_SC_BK27_69_L      _PK_L_(0x27, 0x69)
#define REG_SC_BK27_69_H      _PK_H_(0x27, 0x69)
#define REG_SC_BK27_6A_L      _PK_L_(0x27, 0x6a)
#define REG_SC_BK27_6A_H      _PK_H_(0x27, 0x6a)
#define REG_SC_BK27_6B_L      _PK_L_(0x27, 0x6b)
#define REG_SC_BK27_6B_H      _PK_H_(0x27, 0x6b)
#define REG_SC_BK27_6C_L      _PK_L_(0x27, 0x6c)
#define REG_SC_BK27_6C_H      _PK_H_(0x27, 0x6c)
#define REG_SC_BK27_6D_L      _PK_L_(0x27, 0x6d)
#define REG_SC_BK27_6D_H      _PK_H_(0x27, 0x6d)
#define REG_SC_BK27_6E_L      _PK_L_(0x27, 0x6e)
#define REG_SC_BK27_6E_H      _PK_H_(0x27, 0x6e)

#define REG_SC_BK27_70_L      _PK_L_(0x27, 0x70)
#define REG_SC_BK27_70_H      _PK_H_(0x27, 0x70)
#define REG_SC_BK27_71_L      _PK_L_(0x27, 0x71)
#define REG_SC_BK27_71_H      _PK_H_(0x27, 0x71)
#define REG_SC_BK27_72_L      _PK_L_(0x27, 0x72)
#define REG_SC_BK27_72_H      _PK_H_(0x27, 0x72)
#define REG_SC_BK27_73_L      _PK_L_(0x27, 0x73)
#define REG_SC_BK27_73_H      _PK_H_(0x27, 0x73)
#define REG_SC_BK27_74_L      _PK_L_(0x27, 0x74)
#define REG_SC_BK27_74_H      _PK_H_(0x27, 0x74)
#define REG_SC_BK27_75_L      _PK_L_(0x27, 0x75)
#define REG_SC_BK27_75_H      _PK_H_(0x27, 0x75)
#define REG_SC_BK27_76_L      _PK_L_(0x27, 0x76)
#define REG_SC_BK27_76_H      _PK_H_(0x27, 0x76)
#define REG_SC_BK27_77_L      _PK_L_(0x27, 0x77)
#define REG_SC_BK27_77_H      _PK_H_(0x27, 0x77)
#define REG_SC_BK27_78_L      _PK_L_(0x27, 0x78)
#define REG_SC_BK27_78_H      _PK_H_(0x27, 0x78)
#define REG_SC_BK27_79_L      _PK_L_(0x27, 0x79)
#define REG_SC_BK27_79_H      _PK_H_(0x27, 0x79)
#define REG_SC_BK27_7A_L      _PK_L_(0x27, 0x7a)
#define REG_SC_BK27_7A_H      _PK_H_(0x27, 0x7a)
#define REG_SC_BK27_7B_L      _PK_L_(0x27, 0x7b)
#define REG_SC_BK27_7B_H      _PK_H_(0x27, 0x7b)
#define REG_SC_BK27_7C_L      _PK_L_(0x27, 0x7c)
#define REG_SC_BK27_7C_H      _PK_H_(0x27, 0x7c)
#define REG_SC_BK27_7D_L      _PK_L_(0x27, 0x7d)
#define REG_SC_BK27_7D_H      _PK_H_(0x27, 0x7d)
#define REG_SC_BK27_7E_L      _PK_L_(0x27, 0x7e)
#define REG_SC_BK27_7E_H      _PK_H_(0x27, 0x7e)

#define REG_SC_BK2B_60_L      _PK_L_(0x2B, 0x60)
#define REG_SC_BK2B_60_H      _PK_H_(0x2B, 0x60)
#define REG_SC_BK2B_61_L      _PK_L_(0x2B, 0x61)
#define REG_SC_BK2B_61_H      _PK_H_(0x2B, 0x61)
#define REG_SC_BK2B_62_L      _PK_L_(0x2B, 0x62)
#define REG_SC_BK2B_62_H      _PK_H_(0x2B, 0x62)
#define REG_SC_BK2B_63_L      _PK_L_(0x2B, 0x63)
#define REG_SC_BK2B_63_H      _PK_H_(0x2B, 0x63)
#define REG_SC_BK2B_64_L      _PK_L_(0x2B, 0x64)
#define REG_SC_BK2B_64_H      _PK_H_(0x2B, 0x64)
#define REG_SC_BK2B_65_L      _PK_L_(0x2B, 0x65)
#define REG_SC_BK2B_65_H      _PK_H_(0x2B, 0x65)
#define REG_SC_BK2B_66_L      _PK_L_(0x2B, 0x66)
#define REG_SC_BK2B_66_H      _PK_H_(0x2B, 0x66)
#define REG_SC_BK2B_67_L      _PK_L_(0x2B, 0x67)
#define REG_SC_BK2B_67_H      _PK_H_(0x2B, 0x67)
#define REG_SC_BK2B_68_L      _PK_L_(0x2B, 0x68)
#define REG_SC_BK2B_68_H      _PK_H_(0x2B, 0x68)
#define REG_SC_BK2B_69_L      _PK_L_(0x2B, 0x69)
#define REG_SC_BK2B_69_H      _PK_H_(0x2B, 0x69)
#define REG_SC_BK2B_6A_L      _PK_L_(0x2B, 0x6a)
#define REG_SC_BK2B_6A_H      _PK_H_(0x2B, 0x6a)
#define REG_SC_BK2B_6B_L      _PK_L_(0x2B, 0x6b)
#define REG_SC_BK2B_6B_H      _PK_H_(0x2B, 0x6b)
#define REG_SC_BK2B_6C_L      _PK_L_(0x2B, 0x6c)
#define REG_SC_BK2B_6C_H      _PK_H_(0x2B, 0x6c)
#define REG_SC_BK2B_6D_L      _PK_L_(0x2B, 0x6d)
#define REG_SC_BK2B_6D_H      _PK_H_(0x2B, 0x6d)
#define REG_SC_BK2B_6E_L      _PK_L_(0x2B, 0x6e)
#define REG_SC_BK2B_6E_H      _PK_H_(0x2B, 0x6e)

#define REG_SC_BK30_0E_L      _PK_L_(0x30, 0x0e)
#define REG_SC_BK30_0E_H      _PK_H_(0x30, 0x0e)

//----------------------------------------------
//  BK46: BWD
//----------------------------------------------
#define REG_SC_BK46_00_L      _PK_L_(0x46, 0x00)
#define REG_SC_BK46_00_H      _PK_H_(0x46, 0x00)
#define REG_SC_BK46_01_L      _PK_L_(0x46, 0x01)
#define REG_SC_BK46_01_H      _PK_H_(0x46, 0x01)
#define REG_SC_BK46_02_L      _PK_L_(0x46, 0x02)
#define REG_SC_BK46_02_H      _PK_H_(0x46, 0x02)
#define REG_SC_BK46_03_L      _PK_L_(0x46, 0x03)
#define REG_SC_BK46_03_H      _PK_H_(0x46, 0x03)
#define REG_SC_BK46_04_L      _PK_L_(0x46, 0x04)
#define REG_SC_BK46_04_H      _PK_H_(0x46, 0x04)
#define REG_SC_BK46_05_L      _PK_L_(0x46, 0x05)
#define REG_SC_BK46_05_H      _PK_H_(0x46, 0x05)
#define REG_SC_BK46_06_L      _PK_L_(0x46, 0x06)
#define REG_SC_BK46_06_H      _PK_H_(0x46, 0x06)
#define REG_SC_BK46_07_L      _PK_L_(0x46, 0x07)
#define REG_SC_BK46_07_H      _PK_H_(0x46, 0x07)
#define REG_SC_BK46_08_L      _PK_L_(0x46, 0x08)
#define REG_SC_BK46_08_H      _PK_H_(0x46, 0x08)
#define REG_SC_BK46_09_L      _PK_L_(0x46, 0x09)
#define REG_SC_BK46_09_H      _PK_H_(0x46, 0x09)
#define REG_SC_BK46_0A_L      _PK_L_(0x46, 0x0A)
#define REG_SC_BK46_0A_H      _PK_H_(0x46, 0x0A)
#define REG_SC_BK46_0B_L      _PK_L_(0x46, 0x0B)
#define REG_SC_BK46_0B_H      _PK_H_(0x46, 0x0B)
#define REG_SC_BK46_0C_L      _PK_L_(0x46, 0x0C)
#define REG_SC_BK46_0C_H      _PK_H_(0x46, 0x0C)
#define REG_SC_BK46_0D_L      _PK_L_(0x46, 0x0D)
#define REG_SC_BK46_0D_H      _PK_H_(0x46, 0x0D)
#define REG_SC_BK46_0E_L      _PK_L_(0x46, 0x0E)
#define REG_SC_BK46_0E_H      _PK_H_(0x46, 0x0E)
#define REG_SC_BK46_0F_L      _PK_L_(0x46, 0x0F)
#define REG_SC_BK46_0F_H      _PK_H_(0x46, 0x0F)
#define REG_SC_BK46_10_L      _PK_L_(0x46, 0x10)
#define REG_SC_BK46_10_H      _PK_H_(0x46, 0x10)
#define REG_SC_BK46_11_L      _PK_L_(0x46, 0x11)
#define REG_SC_BK46_11_H      _PK_H_(0x46, 0x11)
#define REG_SC_BK46_12_L      _PK_L_(0x46, 0x12)
#define REG_SC_BK46_12_H      _PK_H_(0x46, 0x12)
#define REG_SC_BK46_13_L      _PK_L_(0x46, 0x13)
#define REG_SC_BK46_13_H      _PK_H_(0x46, 0x13)
#define REG_SC_BK46_14_L      _PK_L_(0x46, 0x14)
#define REG_SC_BK46_14_H      _PK_H_(0x46, 0x14)
#define REG_SC_BK46_15_L      _PK_L_(0x46, 0x15)
#define REG_SC_BK46_15_H      _PK_H_(0x46, 0x15)
#define REG_SC_BK46_16_L      _PK_L_(0x46, 0x16)
#define REG_SC_BK46_16_H      _PK_H_(0x46, 0x16)
#define REG_SC_BK46_17_L      _PK_L_(0x46, 0x17)
#define REG_SC_BK46_17_H      _PK_H_(0x46, 0x17)
#define REG_SC_BK46_18_L      _PK_L_(0x46, 0x18)
#define REG_SC_BK46_18_H      _PK_H_(0x46, 0x18)
#define REG_SC_BK46_19_L      _PK_L_(0x46, 0x19)
#define REG_SC_BK46_19_H      _PK_H_(0x46, 0x19)
#define REG_SC_BK46_1A_L      _PK_L_(0x46, 0x1A)
#define REG_SC_BK46_1A_H      _PK_H_(0x46, 0x1A)
#define REG_SC_BK46_1B_L      _PK_L_(0x46, 0x1B)
#define REG_SC_BK46_1B_H      _PK_H_(0x46, 0x1B)
#define REG_SC_BK46_1C_L      _PK_L_(0x46, 0x1C)
#define REG_SC_BK46_1C_H      _PK_H_(0x46, 0x1C)
#define REG_SC_BK46_1D_L      _PK_L_(0x46, 0x1D)
#define REG_SC_BK46_1D_H      _PK_H_(0x46, 0x1D)
#define REG_SC_BK46_1E_L      _PK_L_(0x46, 0x1E)
#define REG_SC_BK46_1E_H      _PK_H_(0x46, 0x1E)
#define REG_SC_BK46_1F_L      _PK_L_(0x46, 0x1F)
#define REG_SC_BK46_1F_H      _PK_H_(0x46, 0x1F)
#define REG_SC_BK46_20_L      _PK_L_(0x46, 0x20)
#define REG_SC_BK46_20_H      _PK_H_(0x46, 0x20)
#define REG_SC_BK46_21_L      _PK_L_(0x46, 0x21)
#define REG_SC_BK46_21_H      _PK_H_(0x46, 0x21)
#define REG_SC_BK46_22_L      _PK_L_(0x46, 0x22)
#define REG_SC_BK46_22_H      _PK_H_(0x46, 0x22)
#define REG_SC_BK46_23_L      _PK_L_(0x46, 0x23)
#define REG_SC_BK46_23_H      _PK_H_(0x46, 0x23)
#define REG_SC_BK46_24_L      _PK_L_(0x46, 0x24)
#define REG_SC_BK46_24_H      _PK_H_(0x46, 0x24)
#define REG_SC_BK46_25_L      _PK_L_(0x46, 0x25)
#define REG_SC_BK46_25_H      _PK_H_(0x46, 0x25)
#define REG_SC_BK46_26_L      _PK_L_(0x46, 0x26)
#define REG_SC_BK46_26_H      _PK_H_(0x46, 0x26)
#define REG_SC_BK46_27_L      _PK_L_(0x46, 0x27)
#define REG_SC_BK46_27_H      _PK_H_(0x46, 0x27)
#define REG_SC_BK46_28_L      _PK_L_(0x46, 0x28)
#define REG_SC_BK46_28_H      _PK_H_(0x46, 0x28)
#define REG_SC_BK46_29_L      _PK_L_(0x46, 0x29)
#define REG_SC_BK46_29_H      _PK_H_(0x46, 0x29)
#define REG_SC_BK46_2A_L      _PK_L_(0x46, 0x2A)
#define REG_SC_BK46_2A_H      _PK_H_(0x46, 0x2A)
#define REG_SC_BK46_2B_L      _PK_L_(0x46, 0x2B)
#define REG_SC_BK46_2B_H      _PK_H_(0x46, 0x2B)
#define REG_SC_BK46_2C_L      _PK_L_(0x46, 0x2C)
#define REG_SC_BK46_2C_H      _PK_H_(0x46, 0x2C)
#define REG_SC_BK46_2D_L      _PK_L_(0x46, 0x2D)
#define REG_SC_BK46_2D_H      _PK_H_(0x46, 0x2D)
#define REG_SC_BK46_2E_L      _PK_L_(0x46, 0x2E)
#define REG_SC_BK46_2E_H      _PK_H_(0x46, 0x2E)
#define REG_SC_BK46_2F_L      _PK_L_(0x46, 0x2F)
#define REG_SC_BK46_2F_H      _PK_H_(0x46, 0x2F)
#define REG_SC_BK46_30_L      _PK_L_(0x46, 0x30)
#define REG_SC_BK46_30_H      _PK_H_(0x46, 0x30)
#define REG_SC_BK46_31_L      _PK_L_(0x46, 0x31)
#define REG_SC_BK46_31_H      _PK_H_(0x46, 0x31)
#define REG_SC_BK46_32_L      _PK_L_(0x46, 0x32)
#define REG_SC_BK46_32_H      _PK_H_(0x46, 0x32)
#define REG_SC_BK46_33_L      _PK_L_(0x46, 0x33)
#define REG_SC_BK46_33_H      _PK_H_(0x46, 0x33)
#define REG_SC_BK46_34_L      _PK_L_(0x46, 0x34)
#define REG_SC_BK46_34_H      _PK_H_(0x46, 0x34)
#define REG_SC_BK46_35_L      _PK_L_(0x46, 0x35)
#define REG_SC_BK46_35_H      _PK_H_(0x46, 0x35)
#define REG_SC_BK46_36_L      _PK_L_(0x46, 0x36)
#define REG_SC_BK46_36_H      _PK_H_(0x46, 0x36)
#define REG_SC_BK46_37_L      _PK_L_(0x46, 0x37)
#define REG_SC_BK46_37_H      _PK_H_(0x46, 0x37)
#define REG_SC_BK46_38_L      _PK_L_(0x46, 0x38)
#define REG_SC_BK46_38_H      _PK_H_(0x46, 0x38)
#define REG_SC_BK46_39_L      _PK_L_(0x46, 0x39)
#define REG_SC_BK46_39_H      _PK_H_(0x46, 0x39)
#define REG_SC_BK46_3A_L      _PK_L_(0x46, 0x3A)
#define REG_SC_BK46_3A_H      _PK_H_(0x46, 0x3A)
#define REG_SC_BK46_3B_L      _PK_L_(0x46, 0x3B)
#define REG_SC_BK46_3B_H      _PK_H_(0x46, 0x3B)
#define REG_SC_BK46_3C_L      _PK_L_(0x46, 0x3C)
#define REG_SC_BK46_3C_H      _PK_H_(0x46, 0x3C)
#define REG_SC_BK46_3D_L      _PK_L_(0x46, 0x3D)
#define REG_SC_BK46_3D_H      _PK_H_(0x46, 0x3D)
#define REG_SC_BK46_3E_L      _PK_L_(0x46, 0x3E)
#define REG_SC_BK46_3E_H      _PK_H_(0x46, 0x3E)
#define REG_SC_BK46_3F_L      _PK_L_(0x46, 0x3F)
#define REG_SC_BK46_3F_H      _PK_H_(0x46, 0x3F)
#define REG_SC_BK46_40_L      _PK_L_(0x46, 0x40)
#define REG_SC_BK46_40_H      _PK_H_(0x46, 0x40)
#define REG_SC_BK46_41_L      _PK_L_(0x46, 0x41)
#define REG_SC_BK46_41_H      _PK_H_(0x46, 0x41)
#define REG_SC_BK46_42_L      _PK_L_(0x46, 0x42)
#define REG_SC_BK46_42_H      _PK_H_(0x46, 0x42)
#define REG_SC_BK46_43_L      _PK_L_(0x46, 0x43)
#define REG_SC_BK46_43_H      _PK_H_(0x46, 0x43)
#define REG_SC_BK46_44_L      _PK_L_(0x46, 0x44)
#define REG_SC_BK46_44_H      _PK_H_(0x46, 0x44)
#define REG_SC_BK46_45_L      _PK_L_(0x46, 0x45)
#define REG_SC_BK46_45_H      _PK_H_(0x46, 0x45)
#define REG_SC_BK46_46_L      _PK_L_(0x46, 0x46)
#define REG_SC_BK46_46_H      _PK_H_(0x46, 0x46)
#define REG_SC_BK46_47_L      _PK_L_(0x46, 0x47)
#define REG_SC_BK46_47_H      _PK_H_(0x46, 0x47)
#define REG_SC_BK46_48_L      _PK_L_(0x46, 0x48)
#define REG_SC_BK46_48_H      _PK_H_(0x46, 0x48)
#define REG_SC_BK46_49_L      _PK_L_(0x46, 0x49)
#define REG_SC_BK46_49_H      _PK_H_(0x46, 0x49)
#define REG_SC_BK46_4A_L      _PK_L_(0x46, 0x4A)
#define REG_SC_BK46_4A_H      _PK_H_(0x46, 0x4A)
#define REG_SC_BK46_4B_L      _PK_L_(0x46, 0x4B)
#define REG_SC_BK46_4B_H      _PK_H_(0x46, 0x4B)
#define REG_SC_BK46_4C_L      _PK_L_(0x46, 0x4C)
#define REG_SC_BK46_4C_H      _PK_H_(0x46, 0x4C)
#define REG_SC_BK46_4D_L      _PK_L_(0x46, 0x4D)
#define REG_SC_BK46_4D_H      _PK_H_(0x46, 0x4D)
#define REG_SC_BK46_4E_L      _PK_L_(0x46, 0x4E)
#define REG_SC_BK46_4E_H      _PK_H_(0x46, 0x4E)
#define REG_SC_BK46_4F_L      _PK_L_(0x46, 0x4F)
#define REG_SC_BK46_4F_H      _PK_H_(0x46, 0x4F)
#define REG_SC_BK46_50_L      _PK_L_(0x46, 0x50)
#define REG_SC_BK46_50_H      _PK_H_(0x46, 0x50)
#define REG_SC_BK46_51_L      _PK_L_(0x46, 0x51)
#define REG_SC_BK46_51_H      _PK_H_(0x46, 0x51)
#define REG_SC_BK46_52_L      _PK_L_(0x46, 0x52)
#define REG_SC_BK46_52_H      _PK_H_(0x46, 0x52)
#define REG_SC_BK46_53_L      _PK_L_(0x46, 0x53)
#define REG_SC_BK46_53_H      _PK_H_(0x46, 0x53)
#define REG_SC_BK46_54_L      _PK_L_(0x46, 0x54)
#define REG_SC_BK46_54_H      _PK_H_(0x46, 0x54)
#define REG_SC_BK46_55_L      _PK_L_(0x46, 0x55)
#define REG_SC_BK46_55_H      _PK_H_(0x46, 0x55)
#define REG_SC_BK46_56_L      _PK_L_(0x46, 0x56)
#define REG_SC_BK46_56_H      _PK_H_(0x46, 0x56)
#define REG_SC_BK46_57_L      _PK_L_(0x46, 0x57)
#define REG_SC_BK46_57_H      _PK_H_(0x46, 0x57)
#define REG_SC_BK46_58_L      _PK_L_(0x46, 0x58)
#define REG_SC_BK46_58_H      _PK_H_(0x46, 0x58)
#define REG_SC_BK46_59_L      _PK_L_(0x46, 0x59)
#define REG_SC_BK46_59_H      _PK_H_(0x46, 0x59)
#define REG_SC_BK46_5A_L      _PK_L_(0x46, 0x5A)
#define REG_SC_BK46_5A_H      _PK_H_(0x46, 0x5A)
#define REG_SC_BK46_5B_L      _PK_L_(0x46, 0x5B)
#define REG_SC_BK46_5B_H      _PK_H_(0x46, 0x5B)
#define REG_SC_BK46_5C_L      _PK_L_(0x46, 0x5C)
#define REG_SC_BK46_5C_H      _PK_H_(0x46, 0x5C)
#define REG_SC_BK46_5D_L      _PK_L_(0x46, 0x5D)
#define REG_SC_BK46_5D_H      _PK_H_(0x46, 0x5D)
#define REG_SC_BK46_5E_L      _PK_L_(0x46, 0x5E)
#define REG_SC_BK46_5E_H      _PK_H_(0x46, 0x5E)
#define REG_SC_BK46_5F_L      _PK_L_(0x46, 0x5F)
#define REG_SC_BK46_5F_H      _PK_H_(0x46, 0x5F)
#define REG_SC_BK46_60_L      _PK_L_(0x46, 0x60)
#define REG_SC_BK46_60_H      _PK_H_(0x46, 0x60)
#define REG_SC_BK46_61_L      _PK_L_(0x46, 0x61)
#define REG_SC_BK46_61_H      _PK_H_(0x46, 0x61)
#define REG_SC_BK46_62_L      _PK_L_(0x46, 0x62)
#define REG_SC_BK46_62_H      _PK_H_(0x46, 0x62)
#define REG_SC_BK46_63_L      _PK_L_(0x46, 0x63)
#define REG_SC_BK46_63_H      _PK_H_(0x46, 0x63)
#define REG_SC_BK46_64_L      _PK_L_(0x46, 0x64)
#define REG_SC_BK46_64_H      _PK_H_(0x46, 0x64)
#define REG_SC_BK46_65_L      _PK_L_(0x46, 0x65)
#define REG_SC_BK46_65_H      _PK_H_(0x46, 0x65)
#define REG_SC_BK46_66_L      _PK_L_(0x46, 0x66)
#define REG_SC_BK46_66_H      _PK_H_(0x46, 0x66)
#define REG_SC_BK46_67_L      _PK_L_(0x46, 0x67)
#define REG_SC_BK46_67_H      _PK_H_(0x46, 0x67)
#define REG_SC_BK46_68_L      _PK_L_(0x46, 0x68)
#define REG_SC_BK46_68_H      _PK_H_(0x46, 0x68)
#define REG_SC_BK46_69_L      _PK_L_(0x46, 0x69)
#define REG_SC_BK46_69_H      _PK_H_(0x46, 0x69)
#define REG_SC_BK46_6A_L      _PK_L_(0x46, 0x6A)
#define REG_SC_BK46_6A_H      _PK_H_(0x46, 0x6A)
#define REG_SC_BK46_6B_L      _PK_L_(0x46, 0x6B)
#define REG_SC_BK46_6B_H      _PK_H_(0x46, 0x6B)
#define REG_SC_BK46_6C_L      _PK_L_(0x46, 0x6C)
#define REG_SC_BK46_6C_H      _PK_H_(0x46, 0x6C)
#define REG_SC_BK46_6D_L      _PK_L_(0x46, 0x6D)
#define REG_SC_BK46_6D_H      _PK_H_(0x46, 0x6D)
#define REG_SC_BK46_6E_L      _PK_L_(0x46, 0x6E)
#define REG_SC_BK46_6E_H      _PK_H_(0x46, 0x6E)
#define REG_SC_BK46_6F_L      _PK_L_(0x46, 0x6F)
#define REG_SC_BK46_6F_H      _PK_H_(0x46, 0x6F)
#define REG_SC_BK46_70_L      _PK_L_(0x46, 0x70)
#define REG_SC_BK46_70_H      _PK_H_(0x46, 0x70)
#define REG_SC_BK46_71_L      _PK_L_(0x46, 0x71)
#define REG_SC_BK46_71_H      _PK_H_(0x46, 0x71)
#define REG_SC_BK46_72_L      _PK_L_(0x46, 0x72)
#define REG_SC_BK46_72_H      _PK_H_(0x46, 0x72)
#define REG_SC_BK46_73_L      _PK_L_(0x46, 0x73)
#define REG_SC_BK46_73_H      _PK_H_(0x46, 0x73)
#define REG_SC_BK46_74_L      _PK_L_(0x46, 0x74)
#define REG_SC_BK46_74_H      _PK_H_(0x46, 0x74)
#define REG_SC_BK46_75_L      _PK_L_(0x46, 0x75)
#define REG_SC_BK46_75_H      _PK_H_(0x46, 0x75)
#define REG_SC_BK46_76_L      _PK_L_(0x46, 0x76)
#define REG_SC_BK46_76_H      _PK_H_(0x46, 0x76)
#define REG_SC_BK46_77_L      _PK_L_(0x46, 0x77)
#define REG_SC_BK46_77_H      _PK_H_(0x46, 0x77)
#define REG_SC_BK46_78_L      _PK_L_(0x46, 0x78)
#define REG_SC_BK46_78_H      _PK_H_(0x46, 0x78)
#define REG_SC_BK46_79_L      _PK_L_(0x46, 0x79)
#define REG_SC_BK46_79_H      _PK_H_(0x46, 0x79)
#define REG_SC_BK46_7A_L      _PK_L_(0x46, 0x7A)
#define REG_SC_BK46_7A_H      _PK_H_(0x46, 0x7A)
#define REG_SC_BK46_7B_L      _PK_L_(0x46, 0x7B)
#define REG_SC_BK46_7B_H      _PK_H_(0x46, 0x7B)
#define REG_SC_BK46_7C_L      _PK_L_(0x46, 0x7C)
#define REG_SC_BK46_7C_H      _PK_H_(0x46, 0x7C)
#define REG_SC_BK46_7D_L      _PK_L_(0x46, 0x7D)
#define REG_SC_BK46_7D_H      _PK_H_(0x46, 0x7D)
#define REG_SC_BK46_7E_L      _PK_L_(0x46, 0x7E)
#define REG_SC_BK46_7E_H      _PK_H_(0x46, 0x7E)
#define REG_SC_BK46_7F_L      _PK_L_(0x46, 0x7F)
#define REG_SC_BK46_7F_H      _PK_H_(0x46, 0x7F)


//----------------------------------------------
//  BK58:
//----------------------------------------------
#define REG_SC_BK58_00_L      _PK_L_(0x58, 0x00)
#define REG_SC_BK58_00_H      _PK_H_(0x58, 0x00)
#define REG_SC_BK58_01_L      _PK_L_(0x58, 0x01)
#define REG_SC_BK58_01_H      _PK_H_(0x58, 0x01)
#define REG_SC_BK58_02_L      _PK_L_(0x58, 0x02)
#define REG_SC_BK58_02_H      _PK_H_(0x58, 0x02)
#define REG_SC_BK58_03_L      _PK_L_(0x58, 0x03)
#define REG_SC_BK58_03_H      _PK_H_(0x58, 0x03)
#define REG_SC_BK58_04_L      _PK_L_(0x58, 0x04)
#define REG_SC_BK58_04_H      _PK_H_(0x58, 0x04)
#define REG_SC_BK58_05_L      _PK_L_(0x58, 0x05)
#define REG_SC_BK58_05_H      _PK_H_(0x58, 0x05)
#define REG_SC_BK58_06_L      _PK_L_(0x58, 0x06)
#define REG_SC_BK58_06_H      _PK_H_(0x58, 0x06)
#define REG_SC_BK58_07_L      _PK_L_(0x58, 0x07)
#define REG_SC_BK58_07_H      _PK_H_(0x58, 0x07)
#define REG_SC_BK58_08_L      _PK_L_(0x58, 0x08)
#define REG_SC_BK58_08_H      _PK_H_(0x58, 0x08)
#define REG_SC_BK58_09_L      _PK_L_(0x58, 0x09)
#define REG_SC_BK58_09_H      _PK_H_(0x58, 0x09)
#define REG_SC_BK58_0A_L      _PK_L_(0x58, 0x0A)
#define REG_SC_BK58_0A_H      _PK_H_(0x58, 0x0A)
#define REG_SC_BK58_0B_L      _PK_L_(0x58, 0x0B)
#define REG_SC_BK58_0B_H      _PK_H_(0x58, 0x0B)
#define REG_SC_BK58_0C_L      _PK_L_(0x58, 0x0C)
#define REG_SC_BK58_0C_H      _PK_H_(0x58, 0x0C)
#define REG_SC_BK58_0D_L      _PK_L_(0x58, 0x0D)
#define REG_SC_BK58_0D_H      _PK_H_(0x58, 0x0D)
#define REG_SC_BK58_0E_L      _PK_L_(0x58, 0x0E)
#define REG_SC_BK58_0E_H      _PK_H_(0x58, 0x0E)
#define REG_SC_BK58_0F_L      _PK_L_(0x58, 0x0F)
#define REG_SC_BK58_0F_H      _PK_H_(0x58, 0x0F)
#define REG_SC_BK58_10_L      _PK_L_(0x58, 0x10)
#define REG_SC_BK58_10_H      _PK_H_(0x58, 0x10)
#define REG_SC_BK58_11_L      _PK_L_(0x58, 0x11)
#define REG_SC_BK58_11_H      _PK_H_(0x58, 0x11)
#define REG_SC_BK58_12_L      _PK_L_(0x58, 0x12)
#define REG_SC_BK58_12_H      _PK_H_(0x58, 0x12)
#define REG_SC_BK58_13_L      _PK_L_(0x58, 0x13)
#define REG_SC_BK58_13_H      _PK_H_(0x58, 0x13)
#define REG_SC_BK58_14_L      _PK_L_(0x58, 0x14)
#define REG_SC_BK58_14_H      _PK_H_(0x58, 0x14)
#define REG_SC_BK58_15_L      _PK_L_(0x58, 0x15)
#define REG_SC_BK58_15_H      _PK_H_(0x58, 0x15)
#define REG_SC_BK58_16_L      _PK_L_(0x58, 0x16)
#define REG_SC_BK58_16_H      _PK_H_(0x58, 0x16)
#define REG_SC_BK58_17_L      _PK_L_(0x58, 0x17)
#define REG_SC_BK58_17_H      _PK_H_(0x58, 0x17)
#define REG_SC_BK58_18_L      _PK_L_(0x58, 0x18)
#define REG_SC_BK58_18_H      _PK_H_(0x58, 0x18)
#define REG_SC_BK58_19_L      _PK_L_(0x58, 0x19)
#define REG_SC_BK58_19_H      _PK_H_(0x58, 0x19)
#define REG_SC_BK58_1A_L      _PK_L_(0x58, 0x1A)
#define REG_SC_BK58_1A_H      _PK_H_(0x58, 0x1A)
#define REG_SC_BK58_1B_L      _PK_L_(0x58, 0x1B)
#define REG_SC_BK58_1B_H      _PK_H_(0x58, 0x1B)
#define REG_SC_BK58_1C_L      _PK_L_(0x58, 0x1C)
#define REG_SC_BK58_1C_H      _PK_H_(0x58, 0x1C)
#define REG_SC_BK58_1D_L      _PK_L_(0x58, 0x1D)
#define REG_SC_BK58_1D_H      _PK_H_(0x58, 0x1D)
#define REG_SC_BK58_1E_L      _PK_L_(0x58, 0x1E)
#define REG_SC_BK58_1E_H      _PK_H_(0x58, 0x1E)
#define REG_SC_BK58_1F_L      _PK_L_(0x58, 0x1F)
#define REG_SC_BK58_1F_H      _PK_H_(0x58, 0x1F)
#define REG_SC_BK58_20_L      _PK_L_(0x58, 0x20)
#define REG_SC_BK58_20_H      _PK_H_(0x58, 0x20)
#define REG_SC_BK58_21_L      _PK_L_(0x58, 0x21)
#define REG_SC_BK58_21_H      _PK_H_(0x58, 0x21)
#define REG_SC_BK58_22_L      _PK_L_(0x58, 0x22)
#define REG_SC_BK58_22_H      _PK_H_(0x58, 0x22)
#define REG_SC_BK58_23_L      _PK_L_(0x58, 0x23)
#define REG_SC_BK58_23_H      _PK_H_(0x58, 0x23)
#define REG_SC_BK58_24_L      _PK_L_(0x58, 0x24)
#define REG_SC_BK58_24_H      _PK_H_(0x58, 0x24)
#define REG_SC_BK58_25_L      _PK_L_(0x58, 0x25)
#define REG_SC_BK58_25_H      _PK_H_(0x58, 0x25)
#define REG_SC_BK58_26_L      _PK_L_(0x58, 0x26)
#define REG_SC_BK58_26_H      _PK_H_(0x58, 0x26)
#define REG_SC_BK58_27_L      _PK_L_(0x58, 0x27)
#define REG_SC_BK58_27_H      _PK_H_(0x58, 0x27)
#define REG_SC_BK58_28_L      _PK_L_(0x58, 0x28)
#define REG_SC_BK58_28_H      _PK_H_(0x58, 0x28)
#define REG_SC_BK58_29_L      _PK_L_(0x58, 0x29)
#define REG_SC_BK58_29_H      _PK_H_(0x58, 0x29)
#define REG_SC_BK58_2A_L      _PK_L_(0x58, 0x2A)
#define REG_SC_BK58_2A_H      _PK_H_(0x58, 0x2A)
#define REG_SC_BK58_2B_L      _PK_L_(0x58, 0x2B)
#define REG_SC_BK58_2B_H      _PK_H_(0x58, 0x2B)
#define REG_SC_BK58_2C_L      _PK_L_(0x58, 0x2C)
#define REG_SC_BK58_2C_H      _PK_H_(0x58, 0x2C)
#define REG_SC_BK58_2D_L      _PK_L_(0x58, 0x2D)
#define REG_SC_BK58_2D_H      _PK_H_(0x58, 0x2D)
#define REG_SC_BK58_2E_L      _PK_L_(0x58, 0x2E)
#define REG_SC_BK58_2E_H      _PK_H_(0x58, 0x2E)
#define REG_SC_BK58_2F_L      _PK_L_(0x58, 0x2F)
#define REG_SC_BK58_2F_H      _PK_H_(0x58, 0x2F)
#define REG_SC_BK58_30_L      _PK_L_(0x58, 0x30)
#define REG_SC_BK58_30_H      _PK_H_(0x58, 0x30)
#define REG_SC_BK58_31_L      _PK_L_(0x58, 0x31)
#define REG_SC_BK58_31_H      _PK_H_(0x58, 0x31)
#define REG_SC_BK58_32_L      _PK_L_(0x58, 0x32)
#define REG_SC_BK58_32_H      _PK_H_(0x58, 0x32)
#define REG_SC_BK58_33_L      _PK_L_(0x58, 0x33)
#define REG_SC_BK58_33_H      _PK_H_(0x58, 0x33)
#define REG_SC_BK58_34_L      _PK_L_(0x58, 0x34)
#define REG_SC_BK58_34_H      _PK_H_(0x58, 0x34)
#define REG_SC_BK58_35_L      _PK_L_(0x58, 0x35)
#define REG_SC_BK58_35_H      _PK_H_(0x58, 0x35)
#define REG_SC_BK58_36_L      _PK_L_(0x58, 0x36)
#define REG_SC_BK58_36_H      _PK_H_(0x58, 0x36)
#define REG_SC_BK58_37_L      _PK_L_(0x58, 0x37)
#define REG_SC_BK58_37_H      _PK_H_(0x58, 0x37)
#define REG_SC_BK58_38_L      _PK_L_(0x58, 0x38)
#define REG_SC_BK58_38_H      _PK_H_(0x58, 0x38)
#define REG_SC_BK58_39_L      _PK_L_(0x58, 0x39)
#define REG_SC_BK58_39_H      _PK_H_(0x58, 0x39)
#define REG_SC_BK58_3A_L      _PK_L_(0x58, 0x3A)
#define REG_SC_BK58_3A_H      _PK_H_(0x58, 0x3A)
#define REG_SC_BK58_3B_L      _PK_L_(0x58, 0x3B)
#define REG_SC_BK58_3B_H      _PK_H_(0x58, 0x3B)
#define REG_SC_BK58_3C_L      _PK_L_(0x58, 0x3C)
#define REG_SC_BK58_3C_H      _PK_H_(0x58, 0x3C)
#define REG_SC_BK58_3D_L      _PK_L_(0x58, 0x3D)
#define REG_SC_BK58_3D_H      _PK_H_(0x58, 0x3D)
#define REG_SC_BK58_3E_L      _PK_L_(0x58, 0x3E)
#define REG_SC_BK58_3E_H      _PK_H_(0x58, 0x3E)
#define REG_SC_BK58_3F_L      _PK_L_(0x58, 0x3F)
#define REG_SC_BK58_3F_H      _PK_H_(0x58, 0x3F)
#define REG_SC_BK58_40_L      _PK_L_(0x58, 0x40)
#define REG_SC_BK58_40_H      _PK_H_(0x58, 0x40)
#define REG_SC_BK58_41_L      _PK_L_(0x58, 0x41)
#define REG_SC_BK58_41_H      _PK_H_(0x58, 0x41)
#define REG_SC_BK58_42_L      _PK_L_(0x58, 0x42)
#define REG_SC_BK58_42_H      _PK_H_(0x58, 0x42)
#define REG_SC_BK58_43_L      _PK_L_(0x58, 0x43)
#define REG_SC_BK58_43_H      _PK_H_(0x58, 0x43)
#define REG_SC_BK58_44_L      _PK_L_(0x58, 0x44)
#define REG_SC_BK58_44_H      _PK_H_(0x58, 0x44)
#define REG_SC_BK58_45_L      _PK_L_(0x58, 0x45)
#define REG_SC_BK58_45_H      _PK_H_(0x58, 0x45)
#define REG_SC_BK58_46_L      _PK_L_(0x58, 0x46)
#define REG_SC_BK58_46_H      _PK_H_(0x58, 0x46)
#define REG_SC_BK58_47_L      _PK_L_(0x58, 0x47)
#define REG_SC_BK58_47_H      _PK_H_(0x58, 0x47)
#define REG_SC_BK58_48_L      _PK_L_(0x58, 0x48)
#define REG_SC_BK58_48_H      _PK_H_(0x58, 0x48)
#define REG_SC_BK58_49_L      _PK_L_(0x58, 0x49)
#define REG_SC_BK58_49_H      _PK_H_(0x58, 0x49)
#define REG_SC_BK58_4A_L      _PK_L_(0x58, 0x4A)
#define REG_SC_BK58_4A_H      _PK_H_(0x58, 0x4A)
#define REG_SC_BK58_4B_L      _PK_L_(0x58, 0x4B)
#define REG_SC_BK58_4B_H      _PK_H_(0x58, 0x4B)
#define REG_SC_BK58_4C_L      _PK_L_(0x58, 0x4C)
#define REG_SC_BK58_4C_H      _PK_H_(0x58, 0x4C)
#define REG_SC_BK58_4D_L      _PK_L_(0x58, 0x4D)
#define REG_SC_BK58_4D_H      _PK_H_(0x58, 0x4D)
#define REG_SC_BK58_4E_L      _PK_L_(0x58, 0x4E)
#define REG_SC_BK58_4E_H      _PK_H_(0x58, 0x4E)
#define REG_SC_BK58_4F_L      _PK_L_(0x58, 0x4F)
#define REG_SC_BK58_4F_H      _PK_H_(0x58, 0x4F)
#define REG_SC_BK58_50_L      _PK_L_(0x58, 0x50)
#define REG_SC_BK58_50_H      _PK_H_(0x58, 0x50)
#define REG_SC_BK58_51_L      _PK_L_(0x58, 0x51)
#define REG_SC_BK58_51_H      _PK_H_(0x58, 0x51)
#define REG_SC_BK58_52_L      _PK_L_(0x58, 0x52)
#define REG_SC_BK58_52_H      _PK_H_(0x58, 0x52)
#define REG_SC_BK58_53_L      _PK_L_(0x58, 0x53)
#define REG_SC_BK58_53_H      _PK_H_(0x58, 0x53)
#define REG_SC_BK58_54_L      _PK_L_(0x58, 0x54)
#define REG_SC_BK58_54_H      _PK_H_(0x58, 0x54)
#define REG_SC_BK58_55_L      _PK_L_(0x58, 0x55)
#define REG_SC_BK58_55_H      _PK_H_(0x58, 0x55)
#define REG_SC_BK58_56_L      _PK_L_(0x58, 0x56)
#define REG_SC_BK58_56_H      _PK_H_(0x58, 0x56)
#define REG_SC_BK58_57_L      _PK_L_(0x58, 0x57)
#define REG_SC_BK58_57_H      _PK_H_(0x58, 0x57)
#define REG_SC_BK58_58_L      _PK_L_(0x58, 0x58)
#define REG_SC_BK58_58_H      _PK_H_(0x58, 0x58)
#define REG_SC_BK58_59_L      _PK_L_(0x58, 0x59)
#define REG_SC_BK58_59_H      _PK_H_(0x58, 0x59)
#define REG_SC_BK58_5A_L      _PK_L_(0x58, 0x5A)
#define REG_SC_BK58_5A_H      _PK_H_(0x58, 0x5A)
#define REG_SC_BK58_5B_L      _PK_L_(0x58, 0x5B)
#define REG_SC_BK58_5B_H      _PK_H_(0x58, 0x5B)
#define REG_SC_BK58_5C_L      _PK_L_(0x58, 0x5C)
#define REG_SC_BK58_5C_H      _PK_H_(0x58, 0x5C)
#define REG_SC_BK58_5D_L      _PK_L_(0x58, 0x5D)
#define REG_SC_BK58_5D_H      _PK_H_(0x58, 0x5D)
#define REG_SC_BK58_5E_L      _PK_L_(0x58, 0x5E)
#define REG_SC_BK58_5E_H      _PK_H_(0x58, 0x5E)
#define REG_SC_BK58_5F_L      _PK_L_(0x58, 0x5F)
#define REG_SC_BK58_5F_H      _PK_H_(0x58, 0x5F)
#define REG_SC_BK58_60_L      _PK_L_(0x58, 0x60)
#define REG_SC_BK58_60_H      _PK_H_(0x58, 0x60)
#define REG_SC_BK58_61_L      _PK_L_(0x58, 0x61)
#define REG_SC_BK58_61_H      _PK_H_(0x58, 0x61)
#define REG_SC_BK58_62_L      _PK_L_(0x58, 0x62)
#define REG_SC_BK58_62_H      _PK_H_(0x58, 0x62)
#define REG_SC_BK58_63_L      _PK_L_(0x58, 0x63)
#define REG_SC_BK58_63_H      _PK_H_(0x58, 0x63)
#define REG_SC_BK58_64_L      _PK_L_(0x58, 0x64)
#define REG_SC_BK58_64_H      _PK_H_(0x58, 0x64)
#define REG_SC_BK58_65_L      _PK_L_(0x58, 0x65)
#define REG_SC_BK58_65_H      _PK_H_(0x58, 0x65)
#define REG_SC_BK58_66_L      _PK_L_(0x58, 0x66)
#define REG_SC_BK58_66_H      _PK_H_(0x58, 0x66)
#define REG_SC_BK58_67_L      _PK_L_(0x58, 0x67)
#define REG_SC_BK58_67_H      _PK_H_(0x58, 0x67)
#define REG_SC_BK58_68_L      _PK_L_(0x58, 0x68)
#define REG_SC_BK58_68_H      _PK_H_(0x58, 0x68)
#define REG_SC_BK58_69_L      _PK_L_(0x58, 0x69)
#define REG_SC_BK58_69_H      _PK_H_(0x58, 0x69)
#define REG_SC_BK58_6A_L      _PK_L_(0x58, 0x6A)
#define REG_SC_BK58_6A_H      _PK_H_(0x58, 0x6A)
#define REG_SC_BK58_6B_L      _PK_L_(0x58, 0x6B)
#define REG_SC_BK58_6B_H      _PK_H_(0x58, 0x6B)
#define REG_SC_BK58_6C_L      _PK_L_(0x58, 0x6C)
#define REG_SC_BK58_6C_H      _PK_H_(0x58, 0x6C)
#define REG_SC_BK58_6D_L      _PK_L_(0x58, 0x6D)
#define REG_SC_BK58_6D_H      _PK_H_(0x58, 0x6D)
#define REG_SC_BK58_6E_L      _PK_L_(0x58, 0x6E)
#define REG_SC_BK58_6E_H      _PK_H_(0x58, 0x6E)
#define REG_SC_BK58_6F_L      _PK_L_(0x58, 0x6F)
#define REG_SC_BK58_6F_H      _PK_H_(0x58, 0x6F)
#define REG_SC_BK58_70_L      _PK_L_(0x58, 0x70)
#define REG_SC_BK58_70_H      _PK_H_(0x58, 0x70)
#define REG_SC_BK58_71_L      _PK_L_(0x58, 0x71)
#define REG_SC_BK58_71_H      _PK_H_(0x58, 0x71)
#define REG_SC_BK58_72_L      _PK_L_(0x58, 0x72)
#define REG_SC_BK58_72_H      _PK_H_(0x58, 0x72)
#define REG_SC_BK58_73_L      _PK_L_(0x58, 0x73)
#define REG_SC_BK58_73_H      _PK_H_(0x58, 0x73)
#define REG_SC_BK58_74_L      _PK_L_(0x58, 0x74)
#define REG_SC_BK58_74_H      _PK_H_(0x58, 0x74)
#define REG_SC_BK58_75_L      _PK_L_(0x58, 0x75)
#define REG_SC_BK58_75_H      _PK_H_(0x58, 0x75)
#define REG_SC_BK58_76_L      _PK_L_(0x58, 0x76)
#define REG_SC_BK58_76_H      _PK_H_(0x58, 0x76)
#define REG_SC_BK58_77_L      _PK_L_(0x58, 0x77)
#define REG_SC_BK58_77_H      _PK_H_(0x58, 0x77)
#define REG_SC_BK58_78_L      _PK_L_(0x58, 0x78)
#define REG_SC_BK58_78_H      _PK_H_(0x58, 0x78)
#define REG_SC_BK58_79_L      _PK_L_(0x58, 0x79)
#define REG_SC_BK58_79_H      _PK_H_(0x58, 0x79)
#define REG_SC_BK58_7A_L      _PK_L_(0x58, 0x7A)
#define REG_SC_BK58_7A_H      _PK_H_(0x58, 0x7A)
#define REG_SC_BK58_7B_L      _PK_L_(0x58, 0x7B)
#define REG_SC_BK58_7B_H      _PK_H_(0x58, 0x7B)
#define REG_SC_BK58_7C_L      _PK_L_(0x58, 0x7C)
#define REG_SC_BK58_7C_H      _PK_H_(0x58, 0x7C)
#define REG_SC_BK58_7D_L      _PK_L_(0x58, 0x7D)
#define REG_SC_BK58_7D_H      _PK_H_(0x58, 0x7D)
#define REG_SC_BK58_7E_L      _PK_L_(0x58, 0x7E)
#define REG_SC_BK58_7E_H      _PK_H_(0x58, 0x7E)
#define REG_SC_BK58_7F_L      _PK_L_(0x58, 0x7F)
#define REG_SC_BK58_7F_H      _PK_H_(0x58, 0x7F)


//----------------------------------------------
//  BK67: auto download
//----------------------------------------------
#define REG_SC_BK67_00_L      _PK_L_(0x67, 0x00)
#define REG_SC_BK67_00_H      _PK_H_(0x67, 0x00)
#define REG_SC_BK67_01_L      _PK_L_(0x67, 0x01)
#define REG_SC_BK67_01_H      _PK_H_(0x67, 0x01)
#define REG_SC_BK67_02_L      _PK_L_(0x67, 0x02)
#define REG_SC_BK67_02_H      _PK_H_(0x67, 0x02)
#define REG_SC_BK67_03_L      _PK_L_(0x67, 0x03)
#define REG_SC_BK67_03_H      _PK_H_(0x67, 0x03)
#define REG_SC_BK67_04_L      _PK_L_(0x67, 0x04)
#define REG_SC_BK67_04_H      _PK_H_(0x67, 0x04)
#define REG_SC_BK67_05_L      _PK_L_(0x67, 0x05)
#define REG_SC_BK67_05_H      _PK_H_(0x67, 0x05)
#define REG_SC_BK67_06_L      _PK_L_(0x67, 0x06)
#define REG_SC_BK67_06_H      _PK_H_(0x67, 0x06)
#define REG_SC_BK67_07_L      _PK_L_(0x67, 0x07)
#define REG_SC_BK67_07_H      _PK_H_(0x67, 0x07)
#define REG_SC_BK67_08_L      _PK_L_(0x67, 0x08)
#define REG_SC_BK67_08_H      _PK_H_(0x67, 0x08)
#define REG_SC_BK67_09_L      _PK_L_(0x67, 0x09)
#define REG_SC_BK67_09_H      _PK_H_(0x67, 0x09)
#define REG_SC_BK67_0A_L      _PK_L_(0x67, 0x0A)
#define REG_SC_BK67_0A_H      _PK_H_(0x67, 0x0A)
#define REG_SC_BK67_0B_L      _PK_L_(0x67, 0x0B)
#define REG_SC_BK67_0B_H      _PK_H_(0x67, 0x0B)
#define REG_SC_BK67_0C_L      _PK_L_(0x67, 0x0C)
#define REG_SC_BK67_0C_H      _PK_H_(0x67, 0x0C)
#define REG_SC_BK67_0D_L      _PK_L_(0x67, 0x0D)
#define REG_SC_BK67_0D_H      _PK_H_(0x67, 0x0D)
#define REG_SC_BK67_0E_L      _PK_L_(0x67, 0x0E)
#define REG_SC_BK67_0E_H      _PK_H_(0x67, 0x0E)
#define REG_SC_BK67_0F_L      _PK_L_(0x67, 0x0F)
#define REG_SC_BK67_0F_H      _PK_H_(0x67, 0x0F)
#define REG_SC_BK67_10_L      _PK_L_(0x67, 0x10)
#define REG_SC_BK67_10_H      _PK_H_(0x67, 0x10)
#define REG_SC_BK67_11_L      _PK_L_(0x67, 0x11)
#define REG_SC_BK67_11_H      _PK_H_(0x67, 0x11)
#define REG_SC_BK67_12_L      _PK_L_(0x67, 0x12)
#define REG_SC_BK67_12_H      _PK_H_(0x67, 0x12)
#define REG_SC_BK67_13_L      _PK_L_(0x67, 0x13)
#define REG_SC_BK67_13_H      _PK_H_(0x67, 0x13)
#define REG_SC_BK67_14_L      _PK_L_(0x67, 0x14)
#define REG_SC_BK67_14_H      _PK_H_(0x67, 0x14)
#define REG_SC_BK67_15_L      _PK_L_(0x67, 0x15)
#define REG_SC_BK67_15_H      _PK_H_(0x67, 0x15)
#define REG_SC_BK67_16_L      _PK_L_(0x67, 0x16)
#define REG_SC_BK67_16_H      _PK_H_(0x67, 0x16)
#define REG_SC_BK67_17_L      _PK_L_(0x67, 0x17)
#define REG_SC_BK67_17_H      _PK_H_(0x67, 0x17)
#define REG_SC_BK67_18_L      _PK_L_(0x67, 0x18)
#define REG_SC_BK67_18_H      _PK_H_(0x67, 0x18)
#define REG_SC_BK67_19_L      _PK_L_(0x67, 0x19)
#define REG_SC_BK67_19_H      _PK_H_(0x67, 0x19)
#define REG_SC_BK67_1A_L      _PK_L_(0x67, 0x1A)
#define REG_SC_BK67_1A_H      _PK_H_(0x67, 0x1A)
#define REG_SC_BK67_1B_L      _PK_L_(0x67, 0x1B)
#define REG_SC_BK67_1B_H      _PK_H_(0x67, 0x1B)
#define REG_SC_BK67_1C_L      _PK_L_(0x67, 0x1C)
#define REG_SC_BK67_1C_H      _PK_H_(0x67, 0x1C)
#define REG_SC_BK67_1D_L      _PK_L_(0x67, 0x1D)
#define REG_SC_BK67_1D_H      _PK_H_(0x67, 0x1D)
#define REG_SC_BK67_1E_L      _PK_L_(0x67, 0x1E)
#define REG_SC_BK67_1E_H      _PK_H_(0x67, 0x1E)
#define REG_SC_BK67_1F_L      _PK_L_(0x67, 0x1F)
#define REG_SC_BK67_1F_H      _PK_H_(0x67, 0x1F)
#define REG_SC_BK67_20_L      _PK_L_(0x67, 0x20)
#define REG_SC_BK67_20_H      _PK_H_(0x67, 0x20)
#define REG_SC_BK67_21_L      _PK_L_(0x67, 0x21)
#define REG_SC_BK67_21_H      _PK_H_(0x67, 0x21)
#define REG_SC_BK67_22_L      _PK_L_(0x67, 0x22)
#define REG_SC_BK67_22_H      _PK_H_(0x67, 0x22)
#define REG_SC_BK67_23_L      _PK_L_(0x67, 0x23)
#define REG_SC_BK67_23_H      _PK_H_(0x67, 0x23)
#define REG_SC_BK67_24_L      _PK_L_(0x67, 0x24)
#define REG_SC_BK67_24_H      _PK_H_(0x67, 0x24)
#define REG_SC_BK67_25_L      _PK_L_(0x67, 0x25)
#define REG_SC_BK67_25_H      _PK_H_(0x67, 0x25)
#define REG_SC_BK67_26_L      _PK_L_(0x67, 0x26)
#define REG_SC_BK67_26_H      _PK_H_(0x67, 0x26)
#define REG_SC_BK67_27_L      _PK_L_(0x67, 0x27)
#define REG_SC_BK67_27_H      _PK_H_(0x67, 0x27)
#define REG_SC_BK67_28_L      _PK_L_(0x67, 0x28)
#define REG_SC_BK67_28_H      _PK_H_(0x67, 0x28)
#define REG_SC_BK67_29_L      _PK_L_(0x67, 0x29)
#define REG_SC_BK67_29_H      _PK_H_(0x67, 0x29)
#define REG_SC_BK67_2A_L      _PK_L_(0x67, 0x2A)
#define REG_SC_BK67_2A_H      _PK_H_(0x67, 0x2A)
#define REG_SC_BK67_2B_L      _PK_L_(0x67, 0x2B)
#define REG_SC_BK67_2B_H      _PK_H_(0x67, 0x2B)
#define REG_SC_BK67_2C_L      _PK_L_(0x67, 0x2C)
#define REG_SC_BK67_2C_H      _PK_H_(0x67, 0x2C)
#define REG_SC_BK67_2D_L      _PK_L_(0x67, 0x2D)
#define REG_SC_BK67_2D_H      _PK_H_(0x67, 0x2D)
#define REG_SC_BK67_2E_L      _PK_L_(0x67, 0x2E)
#define REG_SC_BK67_2E_H      _PK_H_(0x67, 0x2E)
#define REG_SC_BK67_2F_L      _PK_L_(0x67, 0x2F)
#define REG_SC_BK67_2F_H      _PK_H_(0x67, 0x2F)
#define REG_SC_BK67_30_L      _PK_L_(0x67, 0x30)
#define REG_SC_BK67_30_H      _PK_H_(0x67, 0x30)
#define REG_SC_BK67_31_L      _PK_L_(0x67, 0x31)
#define REG_SC_BK67_31_H      _PK_H_(0x67, 0x31)
#define REG_SC_BK67_32_L      _PK_L_(0x67, 0x32)
#define REG_SC_BK67_32_H      _PK_H_(0x67, 0x32)
#define REG_SC_BK67_33_L      _PK_L_(0x67, 0x33)
#define REG_SC_BK67_33_H      _PK_H_(0x67, 0x33)
#define REG_SC_BK67_34_L      _PK_L_(0x67, 0x34)
#define REG_SC_BK67_34_H      _PK_H_(0x67, 0x34)
#define REG_SC_BK67_35_L      _PK_L_(0x67, 0x35)
#define REG_SC_BK67_35_H      _PK_H_(0x67, 0x35)
#define REG_SC_BK67_36_L      _PK_L_(0x67, 0x36)
#define REG_SC_BK67_36_H      _PK_H_(0x67, 0x36)
#define REG_SC_BK67_37_L      _PK_L_(0x67, 0x37)
#define REG_SC_BK67_37_H      _PK_H_(0x67, 0x37)
#define REG_SC_BK67_38_L      _PK_L_(0x67, 0x38)
#define REG_SC_BK67_38_H      _PK_H_(0x67, 0x38)
#define REG_SC_BK67_39_L      _PK_L_(0x67, 0x39)
#define REG_SC_BK67_39_H      _PK_H_(0x67, 0x39)
#define REG_SC_BK67_3A_L      _PK_L_(0x67, 0x3A)
#define REG_SC_BK67_3A_H      _PK_H_(0x67, 0x3A)
#define REG_SC_BK67_3B_L      _PK_L_(0x67, 0x3B)
#define REG_SC_BK67_3B_H      _PK_H_(0x67, 0x3B)
#define REG_SC_BK67_3C_L      _PK_L_(0x67, 0x3C)
#define REG_SC_BK67_3C_H      _PK_H_(0x67, 0x3C)
#define REG_SC_BK67_3D_L      _PK_L_(0x67, 0x3D)
#define REG_SC_BK67_3D_H      _PK_H_(0x67, 0x3D)
#define REG_SC_BK67_3E_L      _PK_L_(0x67, 0x3E)
#define REG_SC_BK67_3E_H      _PK_H_(0x67, 0x3E)
#define REG_SC_BK67_3F_L      _PK_L_(0x67, 0x3F)
#define REG_SC_BK67_3F_H      _PK_H_(0x67, 0x3F)
#define REG_SC_BK67_40_L      _PK_L_(0x67, 0x40)
#define REG_SC_BK67_40_H      _PK_H_(0x67, 0x40)
#define REG_SC_BK67_41_L      _PK_L_(0x67, 0x41)
#define REG_SC_BK67_41_H      _PK_H_(0x67, 0x41)
#define REG_SC_BK67_42_L      _PK_L_(0x67, 0x42)
#define REG_SC_BK67_42_H      _PK_H_(0x67, 0x42)
#define REG_SC_BK67_43_L      _PK_L_(0x67, 0x43)
#define REG_SC_BK67_43_H      _PK_H_(0x67, 0x43)
#define REG_SC_BK67_44_L      _PK_L_(0x67, 0x44)
#define REG_SC_BK67_44_H      _PK_H_(0x67, 0x44)
#define REG_SC_BK67_45_L      _PK_L_(0x67, 0x45)
#define REG_SC_BK67_45_H      _PK_H_(0x67, 0x45)
#define REG_SC_BK67_46_L      _PK_L_(0x67, 0x46)
#define REG_SC_BK67_46_H      _PK_H_(0x67, 0x46)
#define REG_SC_BK67_47_L      _PK_L_(0x67, 0x47)
#define REG_SC_BK67_47_H      _PK_H_(0x67, 0x47)
#define REG_SC_BK67_48_L      _PK_L_(0x67, 0x48)
#define REG_SC_BK67_48_H      _PK_H_(0x67, 0x48)
#define REG_SC_BK67_49_L      _PK_L_(0x67, 0x49)
#define REG_SC_BK67_49_H      _PK_H_(0x67, 0x49)
#define REG_SC_BK67_4A_L      _PK_L_(0x67, 0x4A)
#define REG_SC_BK67_4A_H      _PK_H_(0x67, 0x4A)
#define REG_SC_BK67_4B_L      _PK_L_(0x67, 0x4B)
#define REG_SC_BK67_4B_H      _PK_H_(0x67, 0x4B)
#define REG_SC_BK67_4C_L      _PK_L_(0x67, 0x4C)
#define REG_SC_BK67_4C_H      _PK_H_(0x67, 0x4C)
#define REG_SC_BK67_4D_L      _PK_L_(0x67, 0x4D)
#define REG_SC_BK67_4D_H      _PK_H_(0x67, 0x4D)
#define REG_SC_BK67_4E_L      _PK_L_(0x67, 0x4E)
#define REG_SC_BK67_4E_H      _PK_H_(0x67, 0x4E)
#define REG_SC_BK67_4F_L      _PK_L_(0x67, 0x4F)
#define REG_SC_BK67_4F_H      _PK_H_(0x67, 0x4F)
#define REG_SC_BK67_50_L      _PK_L_(0x67, 0x50)
#define REG_SC_BK67_50_H      _PK_H_(0x67, 0x50)
#define REG_SC_BK67_51_L      _PK_L_(0x67, 0x51)
#define REG_SC_BK67_51_H      _PK_H_(0x67, 0x51)
#define REG_SC_BK67_52_L      _PK_L_(0x67, 0x52)
#define REG_SC_BK67_52_H      _PK_H_(0x67, 0x52)
#define REG_SC_BK67_53_L      _PK_L_(0x67, 0x53)
#define REG_SC_BK67_53_H      _PK_H_(0x67, 0x53)
#define REG_SC_BK67_54_L      _PK_L_(0x67, 0x54)
#define REG_SC_BK67_54_H      _PK_H_(0x67, 0x54)
#define REG_SC_BK67_55_L      _PK_L_(0x67, 0x55)
#define REG_SC_BK67_55_H      _PK_H_(0x67, 0x55)
#define REG_SC_BK67_56_L      _PK_L_(0x67, 0x56)
#define REG_SC_BK67_56_H      _PK_H_(0x67, 0x56)
#define REG_SC_BK67_57_L      _PK_L_(0x67, 0x57)
#define REG_SC_BK67_57_H      _PK_H_(0x67, 0x57)
#define REG_SC_BK67_58_L      _PK_L_(0x67, 0x58)
#define REG_SC_BK67_58_H      _PK_H_(0x67, 0x58)
#define REG_SC_BK67_59_L      _PK_L_(0x67, 0x59)
#define REG_SC_BK67_59_H      _PK_H_(0x67, 0x59)
#define REG_SC_BK67_5A_L      _PK_L_(0x67, 0x5A)
#define REG_SC_BK67_5A_H      _PK_H_(0x67, 0x5A)
#define REG_SC_BK67_5B_L      _PK_L_(0x67, 0x5B)
#define REG_SC_BK67_5B_H      _PK_H_(0x67, 0x5B)
#define REG_SC_BK67_5C_L      _PK_L_(0x67, 0x5C)
#define REG_SC_BK67_5C_H      _PK_H_(0x67, 0x5C)
#define REG_SC_BK67_5D_L      _PK_L_(0x67, 0x5D)
#define REG_SC_BK67_5D_H      _PK_H_(0x67, 0x5D)
#define REG_SC_BK67_5E_L      _PK_L_(0x67, 0x5E)
#define REG_SC_BK67_5E_H      _PK_H_(0x67, 0x5E)
#define REG_SC_BK67_5F_L      _PK_L_(0x67, 0x5F)
#define REG_SC_BK67_5F_H      _PK_H_(0x67, 0x5F)
#define REG_SC_BK67_60_L      _PK_L_(0x67, 0x60)
#define REG_SC_BK67_60_H      _PK_H_(0x67, 0x60)
#define REG_SC_BK67_61_L      _PK_L_(0x67, 0x61)
#define REG_SC_BK67_61_H      _PK_H_(0x67, 0x61)
#define REG_SC_BK67_62_L      _PK_L_(0x67, 0x62)
#define REG_SC_BK67_62_H      _PK_H_(0x67, 0x62)
#define REG_SC_BK67_63_L      _PK_L_(0x67, 0x63)
#define REG_SC_BK67_63_H      _PK_H_(0x67, 0x63)
#define REG_SC_BK67_64_L      _PK_L_(0x67, 0x64)
#define REG_SC_BK67_64_H      _PK_H_(0x67, 0x64)
#define REG_SC_BK67_65_L      _PK_L_(0x67, 0x65)
#define REG_SC_BK67_65_H      _PK_H_(0x67, 0x65)
#define REG_SC_BK67_66_L      _PK_L_(0x67, 0x66)
#define REG_SC_BK67_66_H      _PK_H_(0x67, 0x66)
#define REG_SC_BK67_67_L      _PK_L_(0x67, 0x67)
#define REG_SC_BK67_67_H      _PK_H_(0x67, 0x67)
#define REG_SC_BK67_68_L      _PK_L_(0x67, 0x68)
#define REG_SC_BK67_68_H      _PK_H_(0x67, 0x68)
#define REG_SC_BK67_69_L      _PK_L_(0x67, 0x69)
#define REG_SC_BK67_69_H      _PK_H_(0x67, 0x69)
#define REG_SC_BK67_6A_L      _PK_L_(0x67, 0x6A)
#define REG_SC_BK67_6A_H      _PK_H_(0x67, 0x6A)
#define REG_SC_BK67_6B_L      _PK_L_(0x67, 0x6B)
#define REG_SC_BK67_6B_H      _PK_H_(0x67, 0x6B)
#define REG_SC_BK67_6C_L      _PK_L_(0x67, 0x6C)
#define REG_SC_BK67_6C_H      _PK_H_(0x67, 0x6C)
#define REG_SC_BK67_6D_L      _PK_L_(0x67, 0x6D)
#define REG_SC_BK67_6D_H      _PK_H_(0x67, 0x6D)
#define REG_SC_BK67_6E_L      _PK_L_(0x67, 0x6E)
#define REG_SC_BK67_6E_H      _PK_H_(0x67, 0x6E)
#define REG_SC_BK67_6F_L      _PK_L_(0x67, 0x6F)
#define REG_SC_BK67_6F_H      _PK_H_(0x67, 0x6F)
#define REG_SC_BK67_70_L      _PK_L_(0x67, 0x70)
#define REG_SC_BK67_70_H      _PK_H_(0x67, 0x70)
#define REG_SC_BK67_71_L      _PK_L_(0x67, 0x71)
#define REG_SC_BK67_71_H      _PK_H_(0x67, 0x71)
#define REG_SC_BK67_72_L      _PK_L_(0x67, 0x72)
#define REG_SC_BK67_72_H      _PK_H_(0x67, 0x72)
#define REG_SC_BK67_73_L      _PK_L_(0x67, 0x73)
#define REG_SC_BK67_73_H      _PK_H_(0x67, 0x73)
#define REG_SC_BK67_74_L      _PK_L_(0x67, 0x74)
#define REG_SC_BK67_74_H      _PK_H_(0x67, 0x74)
#define REG_SC_BK67_75_L      _PK_L_(0x67, 0x75)
#define REG_SC_BK67_75_H      _PK_H_(0x67, 0x75)
#define REG_SC_BK67_76_L      _PK_L_(0x67, 0x76)
#define REG_SC_BK67_76_H      _PK_H_(0x67, 0x76)
#define REG_SC_BK67_77_L      _PK_L_(0x67, 0x77)
#define REG_SC_BK67_77_H      _PK_H_(0x67, 0x77)
#define REG_SC_BK67_78_L      _PK_L_(0x67, 0x78)
#define REG_SC_BK67_78_H      _PK_H_(0x67, 0x78)
#define REG_SC_BK67_79_L      _PK_L_(0x67, 0x79)
#define REG_SC_BK67_79_H      _PK_H_(0x67, 0x79)
#define REG_SC_BK67_7A_L      _PK_L_(0x67, 0x7A)
#define REG_SC_BK67_7A_H      _PK_H_(0x67, 0x7A)
#define REG_SC_BK67_7B_L      _PK_L_(0x67, 0x7B)
#define REG_SC_BK67_7B_H      _PK_H_(0x67, 0x7B)
#define REG_SC_BK67_7C_L      _PK_L_(0x67, 0x7C)
#define REG_SC_BK67_7C_H      _PK_H_(0x67, 0x7C)
#define REG_SC_BK67_7D_L      _PK_L_(0x67, 0x7D)
#define REG_SC_BK67_7D_H      _PK_H_(0x67, 0x7D)
#define REG_SC_BK67_7E_L      _PK_L_(0x67, 0x7E)
#define REG_SC_BK67_7E_H      _PK_H_(0x67, 0x7E)
#define REG_SC_BK67_7F_L      _PK_L_(0x67, 0x7F)
#define REG_SC_BK67_7F_H      _PK_H_(0x67, 0x7F)


//----------------------------------------------
// BK77:
//----------------------------------------------
#define REG_SC_BK77_00_L      _PK_L_(0x77, 0x00)
#define REG_SC_BK77_00_H      _PK_H_(0x77, 0x00)
#define REG_SC_BK77_01_L      _PK_L_(0x77, 0x01)
#define REG_SC_BK77_01_H      _PK_H_(0x77, 0x01)
#define REG_SC_BK77_02_L      _PK_L_(0x77, 0x02)
#define REG_SC_BK77_02_H      _PK_H_(0x77, 0x02)
#define REG_SC_BK77_03_L      _PK_L_(0x77, 0x03)
#define REG_SC_BK77_03_H      _PK_H_(0x77, 0x03)
#define REG_SC_BK77_04_L      _PK_L_(0x77, 0x04)
#define REG_SC_BK77_04_H      _PK_H_(0x77, 0x04)
#define REG_SC_BK77_05_L      _PK_L_(0x77, 0x05)
#define REG_SC_BK77_05_H      _PK_H_(0x77, 0x05)
#define REG_SC_BK77_06_L      _PK_L_(0x77, 0x06)
#define REG_SC_BK77_06_H      _PK_H_(0x77, 0x06)
#define REG_SC_BK77_07_L      _PK_L_(0x77, 0x07)
#define REG_SC_BK77_07_H      _PK_H_(0x77, 0x07)
#define REG_SC_BK77_08_L      _PK_L_(0x77, 0x08)
#define REG_SC_BK77_08_H      _PK_H_(0x77, 0x08)
#define REG_SC_BK77_09_L      _PK_L_(0x77, 0x09)
#define REG_SC_BK77_09_H      _PK_H_(0x77, 0x09)
#define REG_SC_BK77_0A_L      _PK_L_(0x77, 0x0A)
#define REG_SC_BK77_0A_H      _PK_H_(0x77, 0x0A)
#define REG_SC_BK77_0B_L      _PK_L_(0x77, 0x0B)
#define REG_SC_BK77_0B_H      _PK_H_(0x77, 0x0B)
#define REG_SC_BK77_0C_L      _PK_L_(0x77, 0x0C)
#define REG_SC_BK77_0C_H      _PK_H_(0x77, 0x0C)
#define REG_SC_BK77_0D_L      _PK_L_(0x77, 0x0D)
#define REG_SC_BK77_0D_H      _PK_H_(0x77, 0x0D)
#define REG_SC_BK77_0E_L      _PK_L_(0x77, 0x0E)
#define REG_SC_BK77_0E_H      _PK_H_(0x77, 0x0E)
#define REG_SC_BK77_0F_L      _PK_L_(0x77, 0x0F)
#define REG_SC_BK77_0F_H      _PK_H_(0x77, 0x0F)
#define REG_SC_BK77_10_L      _PK_L_(0x77, 0x10)
#define REG_SC_BK77_10_H      _PK_H_(0x77, 0x10)
#define REG_SC_BK77_11_L      _PK_L_(0x77, 0x11)
#define REG_SC_BK77_11_H      _PK_H_(0x77, 0x11)
#define REG_SC_BK77_12_L      _PK_L_(0x77, 0x12)
#define REG_SC_BK77_12_H      _PK_H_(0x77, 0x12)
#define REG_SC_BK77_13_L      _PK_L_(0x77, 0x13)
#define REG_SC_BK77_13_H      _PK_H_(0x77, 0x13)
#define REG_SC_BK77_14_L      _PK_L_(0x77, 0x14)
#define REG_SC_BK77_14_H      _PK_H_(0x77, 0x14)
#define REG_SC_BK77_15_L      _PK_L_(0x77, 0x15)
#define REG_SC_BK77_15_H      _PK_H_(0x77, 0x15)
#define REG_SC_BK77_16_L      _PK_L_(0x77, 0x16)
#define REG_SC_BK77_16_H      _PK_H_(0x77, 0x16)
#define REG_SC_BK77_17_L      _PK_L_(0x77, 0x17)
#define REG_SC_BK77_17_H      _PK_H_(0x77, 0x17)
#define REG_SC_BK77_18_L      _PK_L_(0x77, 0x18)
#define REG_SC_BK77_18_H      _PK_H_(0x77, 0x18)
#define REG_SC_BK77_19_L      _PK_L_(0x77, 0x19)
#define REG_SC_BK77_19_H      _PK_H_(0x77, 0x19)
#define REG_SC_BK77_1A_L      _PK_L_(0x77, 0x1A)
#define REG_SC_BK77_1A_H      _PK_H_(0x77, 0x1A)
#define REG_SC_BK77_1B_L      _PK_L_(0x77, 0x1B)
#define REG_SC_BK77_1B_H      _PK_H_(0x77, 0x1B)
#define REG_SC_BK77_1C_L      _PK_L_(0x77, 0x1C)
#define REG_SC_BK77_1C_H      _PK_H_(0x77, 0x1C)
#define REG_SC_BK77_1D_L      _PK_L_(0x77, 0x1D)
#define REG_SC_BK77_1D_H      _PK_H_(0x77, 0x1D)
#define REG_SC_BK77_1E_L      _PK_L_(0x77, 0x1E)
#define REG_SC_BK77_1E_H      _PK_H_(0x77, 0x1E)
#define REG_SC_BK77_1F_L      _PK_L_(0x77, 0x1F)
#define REG_SC_BK77_1F_H      _PK_H_(0x77, 0x1F)
#define REG_SC_BK77_20_L      _PK_L_(0x77, 0x20)
#define REG_SC_BK77_20_H      _PK_H_(0x77, 0x20)
#define REG_SC_BK77_21_L      _PK_L_(0x77, 0x21)
#define REG_SC_BK77_21_H      _PK_H_(0x77, 0x21)
#define REG_SC_BK77_22_L      _PK_L_(0x77, 0x22)
#define REG_SC_BK77_22_H      _PK_H_(0x77, 0x22)
#define REG_SC_BK77_23_L      _PK_L_(0x77, 0x23)
#define REG_SC_BK77_23_H      _PK_H_(0x77, 0x23)
#define REG_SC_BK77_24_L      _PK_L_(0x77, 0x24)
#define REG_SC_BK77_24_H      _PK_H_(0x77, 0x24)
#define REG_SC_BK77_25_L      _PK_L_(0x77, 0x25)
#define REG_SC_BK77_25_H      _PK_H_(0x77, 0x25)
#define REG_SC_BK77_26_L      _PK_L_(0x77, 0x26)
#define REG_SC_BK77_26_H      _PK_H_(0x77, 0x26)
#define REG_SC_BK77_27_L      _PK_L_(0x77, 0x27)
#define REG_SC_BK77_27_H      _PK_H_(0x77, 0x27)
#define REG_SC_BK77_28_L      _PK_L_(0x77, 0x28)
#define REG_SC_BK77_28_H      _PK_H_(0x77, 0x28)
#define REG_SC_BK77_29_L      _PK_L_(0x77, 0x29)
#define REG_SC_BK77_29_H      _PK_H_(0x77, 0x29)
#define REG_SC_BK77_2A_L      _PK_L_(0x77, 0x2A)
#define REG_SC_BK77_2A_H      _PK_H_(0x77, 0x2A)
#define REG_SC_BK77_2B_L      _PK_L_(0x77, 0x2B)
#define REG_SC_BK77_2B_H      _PK_H_(0x77, 0x2B)
#define REG_SC_BK77_2C_L      _PK_L_(0x77, 0x2C)
#define REG_SC_BK77_2C_H      _PK_H_(0x77, 0x2C)
#define REG_SC_BK77_2D_L      _PK_L_(0x77, 0x2D)
#define REG_SC_BK77_2D_H      _PK_H_(0x77, 0x2D)
#define REG_SC_BK77_2E_L      _PK_L_(0x77, 0x2E)
#define REG_SC_BK77_2E_H      _PK_H_(0x77, 0x2E)
#define REG_SC_BK77_2F_L      _PK_L_(0x77, 0x2F)
#define REG_SC_BK77_2F_H      _PK_H_(0x77, 0x2F)
#define REG_SC_BK77_30_L      _PK_L_(0x77, 0x30)
#define REG_SC_BK77_30_H      _PK_H_(0x77, 0x30)
#define REG_SC_BK77_31_L      _PK_L_(0x77, 0x31)
#define REG_SC_BK77_31_H      _PK_H_(0x77, 0x31)
#define REG_SC_BK77_32_L      _PK_L_(0x77, 0x32)
#define REG_SC_BK77_32_H      _PK_H_(0x77, 0x32)
#define REG_SC_BK77_33_L      _PK_L_(0x77, 0x33)
#define REG_SC_BK77_33_H      _PK_H_(0x77, 0x33)
#define REG_SC_BK77_34_L      _PK_L_(0x77, 0x34)
#define REG_SC_BK77_34_H      _PK_H_(0x77, 0x34)
#define REG_SC_BK77_35_L      _PK_L_(0x77, 0x35)
#define REG_SC_BK77_35_H      _PK_H_(0x77, 0x35)
#define REG_SC_BK77_36_L      _PK_L_(0x77, 0x36)
#define REG_SC_BK77_36_H      _PK_H_(0x77, 0x36)
#define REG_SC_BK77_37_L      _PK_L_(0x77, 0x37)
#define REG_SC_BK77_37_H      _PK_H_(0x77, 0x37)
#define REG_SC_BK77_38_L      _PK_L_(0x77, 0x38)
#define REG_SC_BK77_38_H      _PK_H_(0x77, 0x38)
#define REG_SC_BK77_39_L      _PK_L_(0x77, 0x39)
#define REG_SC_BK77_39_H      _PK_H_(0x77, 0x39)
#define REG_SC_BK77_3A_L      _PK_L_(0x77, 0x3A)
#define REG_SC_BK77_3A_H      _PK_H_(0x77, 0x3A)
#define REG_SC_BK77_3B_L      _PK_L_(0x77, 0x3B)
#define REG_SC_BK77_3B_H      _PK_H_(0x77, 0x3B)
#define REG_SC_BK77_3C_L      _PK_L_(0x77, 0x3C)
#define REG_SC_BK77_3C_H      _PK_H_(0x77, 0x3C)
#define REG_SC_BK77_3D_L      _PK_L_(0x77, 0x3D)
#define REG_SC_BK77_3D_H      _PK_H_(0x77, 0x3D)
#define REG_SC_BK77_3E_L      _PK_L_(0x77, 0x3E)
#define REG_SC_BK77_3E_H      _PK_H_(0x77, 0x3E)
#define REG_SC_BK77_3F_L      _PK_L_(0x77, 0x3F)
#define REG_SC_BK77_3F_H      _PK_H_(0x77, 0x3F)
#define REG_SC_BK77_40_L      _PK_L_(0x77, 0x40)
#define REG_SC_BK77_40_H      _PK_H_(0x77, 0x40)
#define REG_SC_BK77_41_L      _PK_L_(0x77, 0x41)
#define REG_SC_BK77_41_H      _PK_H_(0x77, 0x41)
#define REG_SC_BK77_42_L      _PK_L_(0x77, 0x42)
#define REG_SC_BK77_42_H      _PK_H_(0x77, 0x42)
#define REG_SC_BK77_43_L      _PK_L_(0x77, 0x43)
#define REG_SC_BK77_43_H      _PK_H_(0x77, 0x43)
#define REG_SC_BK77_44_L      _PK_L_(0x77, 0x44)
#define REG_SC_BK77_44_H      _PK_H_(0x77, 0x44)
#define REG_SC_BK77_45_L      _PK_L_(0x77, 0x45)
#define REG_SC_BK77_45_H      _PK_H_(0x77, 0x45)
#define REG_SC_BK77_46_L      _PK_L_(0x77, 0x46)
#define REG_SC_BK77_46_H      _PK_H_(0x77, 0x46)
#define REG_SC_BK77_47_L      _PK_L_(0x77, 0x47)
#define REG_SC_BK77_47_H      _PK_H_(0x77, 0x47)
#define REG_SC_BK77_48_L      _PK_L_(0x77, 0x48)
#define REG_SC_BK77_48_H      _PK_H_(0x77, 0x48)
#define REG_SC_BK77_49_L      _PK_L_(0x77, 0x49)
#define REG_SC_BK77_49_H      _PK_H_(0x77, 0x49)
#define REG_SC_BK77_4A_L      _PK_L_(0x77, 0x4A)
#define REG_SC_BK77_4A_H      _PK_H_(0x77, 0x4A)
#define REG_SC_BK77_4B_L      _PK_L_(0x77, 0x4B)
#define REG_SC_BK77_4B_H      _PK_H_(0x77, 0x4B)
#define REG_SC_BK77_4C_L      _PK_L_(0x77, 0x4C)
#define REG_SC_BK77_4C_H      _PK_H_(0x77, 0x4C)
#define REG_SC_BK77_4D_L      _PK_L_(0x77, 0x4D)
#define REG_SC_BK77_4D_H      _PK_H_(0x77, 0x4D)
#define REG_SC_BK77_4E_L      _PK_L_(0x77, 0x4E)
#define REG_SC_BK77_4E_H      _PK_H_(0x77, 0x4E)
#define REG_SC_BK77_4F_L      _PK_L_(0x77, 0x4F)
#define REG_SC_BK77_4F_H      _PK_H_(0x77, 0x4F)
#define REG_SC_BK77_50_L      _PK_L_(0x77, 0x50)
#define REG_SC_BK77_50_H      _PK_H_(0x77, 0x50)
#define REG_SC_BK77_51_L      _PK_L_(0x77, 0x51)
#define REG_SC_BK77_51_H      _PK_H_(0x77, 0x51)
#define REG_SC_BK77_52_L      _PK_L_(0x77, 0x52)
#define REG_SC_BK77_52_H      _PK_H_(0x77, 0x52)
#define REG_SC_BK77_53_L      _PK_L_(0x77, 0x53)
#define REG_SC_BK77_53_H      _PK_H_(0x77, 0x53)
#define REG_SC_BK77_54_L      _PK_L_(0x77, 0x54)
#define REG_SC_BK77_54_H      _PK_H_(0x77, 0x54)
#define REG_SC_BK77_55_L      _PK_L_(0x77, 0x55)
#define REG_SC_BK77_55_H      _PK_H_(0x77, 0x55)
#define REG_SC_BK77_56_L      _PK_L_(0x77, 0x56)
#define REG_SC_BK77_56_H      _PK_H_(0x77, 0x56)
#define REG_SC_BK77_57_L      _PK_L_(0x77, 0x57)
#define REG_SC_BK77_57_H      _PK_H_(0x77, 0x57)
#define REG_SC_BK77_58_L      _PK_L_(0x77, 0x58)
#define REG_SC_BK77_58_H      _PK_H_(0x77, 0x58)
#define REG_SC_BK77_59_L      _PK_L_(0x77, 0x59)
#define REG_SC_BK77_59_H      _PK_H_(0x77, 0x59)
#define REG_SC_BK77_5A_L      _PK_L_(0x77, 0x5A)
#define REG_SC_BK77_5A_H      _PK_H_(0x77, 0x5A)
#define REG_SC_BK77_5B_L      _PK_L_(0x77, 0x5B)
#define REG_SC_BK77_5B_H      _PK_H_(0x77, 0x5B)
#define REG_SC_BK77_5C_L      _PK_L_(0x77, 0x5C)
#define REG_SC_BK77_5C_H      _PK_H_(0x77, 0x5C)
#define REG_SC_BK77_5D_L      _PK_L_(0x77, 0x5D)
#define REG_SC_BK77_5D_H      _PK_H_(0x77, 0x5D)
#define REG_SC_BK77_5E_L      _PK_L_(0x77, 0x5E)
#define REG_SC_BK77_5E_H      _PK_H_(0x77, 0x5E)
#define REG_SC_BK77_5F_L      _PK_L_(0x77, 0x5F)
#define REG_SC_BK77_5F_H      _PK_H_(0x77, 0x5F)
#define REG_SC_BK77_60_L      _PK_L_(0x77, 0x60)
#define REG_SC_BK77_60_H      _PK_H_(0x77, 0x60)
#define REG_SC_BK77_61_L      _PK_L_(0x77, 0x61)
#define REG_SC_BK77_61_H      _PK_H_(0x77, 0x61)
#define REG_SC_BK77_62_L      _PK_L_(0x77, 0x62)
#define REG_SC_BK77_62_H      _PK_H_(0x77, 0x62)
#define REG_SC_BK77_63_L      _PK_L_(0x77, 0x63)
#define REG_SC_BK77_63_H      _PK_H_(0x77, 0x63)
#define REG_SC_BK77_64_L      _PK_L_(0x77, 0x64)
#define REG_SC_BK77_64_H      _PK_H_(0x77, 0x64)
#define REG_SC_BK77_65_L      _PK_L_(0x77, 0x65)
#define REG_SC_BK77_65_H      _PK_H_(0x77, 0x65)
#define REG_SC_BK77_66_L      _PK_L_(0x77, 0x66)
#define REG_SC_BK77_66_H      _PK_H_(0x77, 0x66)
#define REG_SC_BK77_67_L      _PK_L_(0x77, 0x67)
#define REG_SC_BK77_67_H      _PK_H_(0x77, 0x67)
#define REG_SC_BK77_68_L      _PK_L_(0x77, 0x68)
#define REG_SC_BK77_68_H      _PK_H_(0x77, 0x68)
#define REG_SC_BK77_69_L      _PK_L_(0x77, 0x69)
#define REG_SC_BK77_69_H      _PK_H_(0x77, 0x69)
#define REG_SC_BK77_6A_L      _PK_L_(0x77, 0x6A)
#define REG_SC_BK77_6A_H      _PK_H_(0x77, 0x6A)
#define REG_SC_BK77_6B_L      _PK_L_(0x77, 0x6B)
#define REG_SC_BK77_6B_H      _PK_H_(0x77, 0x6B)
#define REG_SC_BK77_6C_L      _PK_L_(0x77, 0x6C)
#define REG_SC_BK77_6C_H      _PK_H_(0x77, 0x6C)
#define REG_SC_BK77_6D_L      _PK_L_(0x77, 0x6D)
#define REG_SC_BK77_6D_H      _PK_H_(0x77, 0x6D)
#define REG_SC_BK77_6E_L      _PK_L_(0x77, 0x6E)
#define REG_SC_BK77_6E_H      _PK_H_(0x77, 0x6E)
#define REG_SC_BK77_6F_L      _PK_L_(0x77, 0x6F)
#define REG_SC_BK77_6F_H      _PK_H_(0x77, 0x6F)
#define REG_SC_BK77_70_L      _PK_L_(0x77, 0x70)
#define REG_SC_BK77_70_H      _PK_H_(0x77, 0x70)
#define REG_SC_BK77_71_L      _PK_L_(0x77, 0x71)
#define REG_SC_BK77_71_H      _PK_H_(0x77, 0x71)
#define REG_SC_BK77_72_L      _PK_L_(0x77, 0x72)
#define REG_SC_BK77_72_H      _PK_H_(0x77, 0x72)
#define REG_SC_BK77_73_L      _PK_L_(0x77, 0x73)
#define REG_SC_BK77_73_H      _PK_H_(0x77, 0x73)
#define REG_SC_BK77_74_L      _PK_L_(0x77, 0x74)
#define REG_SC_BK77_74_H      _PK_H_(0x77, 0x74)
#define REG_SC_BK77_75_L      _PK_L_(0x77, 0x75)
#define REG_SC_BK77_75_H      _PK_H_(0x77, 0x75)
#define REG_SC_BK77_76_L      _PK_L_(0x77, 0x76)
#define REG_SC_BK77_76_H      _PK_H_(0x77, 0x76)
#define REG_SC_BK77_77_L      _PK_L_(0x77, 0x77)
#define REG_SC_BK77_77_H      _PK_H_(0x77, 0x77)
#define REG_SC_BK77_78_L      _PK_L_(0x77, 0x78)
#define REG_SC_BK77_78_H      _PK_H_(0x77, 0x78)
#define REG_SC_BK77_79_L      _PK_L_(0x77, 0x79)
#define REG_SC_BK77_79_H      _PK_H_(0x77, 0x79)
#define REG_SC_BK77_7A_L      _PK_L_(0x77, 0x7A)
#define REG_SC_BK77_7A_H      _PK_H_(0x77, 0x7A)
#define REG_SC_BK77_7B_L      _PK_L_(0x77, 0x7B)
#define REG_SC_BK77_7B_H      _PK_H_(0x77, 0x7B)
#define REG_SC_BK77_7C_L      _PK_L_(0x77, 0x7C)
#define REG_SC_BK77_7C_H      _PK_H_(0x77, 0x7C)
#define REG_SC_BK77_7D_L      _PK_L_(0x77, 0x7D)
#define REG_SC_BK77_7D_H      _PK_H_(0x77, 0x7D)
#define REG_SC_BK77_7E_L      _PK_L_(0x77, 0x7E)
#define REG_SC_BK77_7E_H      _PK_H_(0x77, 0x7E)
#define REG_SC_BK77_7F_L      _PK_L_(0x77, 0x7F)
#define REG_SC_BK77_7F_H      _PK_H_(0x77, 0x7F)


////////////////////////////////////////////////////////////////////////////
// SC HW
////////////////////////////////////////////////////////////////////////////
#define MAX_WINDOW_NUM          (2)

////////////////////////////////////////////////////////////////////////////
// color gain after ACE engine
////////////////////////////////////////////////////////////////////////////
#define POST_R_CHANNEL_GAIN_MAIN      REG_SC_BK25_24_L
#define POST_G_CHANNEL_GAIN_MAIN      REG_SC_BK25_25_L
#define POST_B_CHANNEL_GAIN_MAIN      REG_SC_BK25_26_L
#define POST_R_CHANNEL_GAIN_SUB       REG_SC_BK25_2A_L
#define POST_G_CHANNEL_GAIN_SUB       REG_SC_BK25_2B_L
#define POST_B_CHANNEL_GAIN_SUB       REG_SC_BK25_2C_L
#define POST_R_CHANNEL_GAIN_MASK      0x0FFF
#define POST_G_CHANNEL_GAIN_MASK      0x0FFF
#define POST_B_CHANNEL_GAIN_MASK      0x0FFF

//----------------------------------------------
//  FSC BK30
//----------------------------------------------
#define REG_FSC_BANK_BASE           0x140000UL  // FSC 0x102C bank, direct bank is 0x1400

#define REG_FSC_BK30_11_L        (REG_FSC_BANK_BASE+0x3022)
#define REG_FSC_BK30_11_H        (REG_FSC_BANK_BASE+0x3023)
////////////////////////////////////////////////////////////////////////////
// VR ACE engine
////////////////////////////////////////////////////////////////////////////
#define REG_VR_BK08_50_L    _PK_L_(0x08,0x50)
#define REG_VR_BK08_50_H    _PK_H_(0x08,0x50)
#define REG_VR_BK08_51_L    _PK_L_(0x08,0x51)
#define REG_VR_BK08_51_H    _PK_H_(0x08,0x51)
#define REG_VR_BK08_52_L    _PK_L_(0x08,0x52)
#define REG_VR_BK08_52_H    _PK_H_(0x08,0x52)
#define REG_VR_BK08_53_L    _PK_L_(0x08,0x53)
#define REG_VR_BK08_53_H    _PK_H_(0x08,0x53)
#define REG_VR_BK08_54_L    _PK_L_(0x08,0x54)
#define REG_VR_BK08_54_H    _PK_H_(0x08,0x54)
#define REG_VR_BK08_55_L    _PK_L_(0x08,0x55)
#define REG_VR_BK08_55_H    _PK_H_(0x08,0x55)
#define REG_VR_BK08_56_L    _PK_L_(0x08,0x56)
#define REG_VR_BK08_56_H    _PK_H_(0x08,0x56)
#define REG_VR_BK08_57_L    _PK_L_(0x08,0x57)
#define REG_VR_BK08_57_H    _PK_H_(0x08,0x57)
#define REG_VR_BK08_58_L    _PK_L_(0x08,0x58)
#define REG_VR_BK08_58_H    _PK_H_(0x08,0x58)
#define REG_VR_BK08_59_L    _PK_L_(0x08,0x59)
#define REG_VR_BK08_59_H    _PK_H_(0x08,0x59)
#define REG_VR_BK08_5A_L    _PK_L_(0x08,0x5A)
#define REG_VR_BK08_5A_H    _PK_H_(0x08,0x5A)
#define REG_VR_BK08_5B_L    _PK_L_(0x08,0x5B)
#define REG_VR_BK08_5B_H    _PK_H_(0x08,0x5B)
#define REG_VR_BK08_5C_L    _PK_L_(0x08,0x5C)
#define REG_VR_BK08_5C_H    _PK_H_(0x08,0x5C)
#define REG_VR_BK08_5D_L    _PK_L_(0x08,0x5D)
#define REG_VR_BK08_5D_H    _PK_H_(0x08,0x5D)
#define REG_VR_BK08_5E_L    _PK_L_(0x08,0x5E)
#define REG_VR_BK08_5E_H    _PK_H_(0x08,0x5E)
#define REG_VR_BK08_5F_L    _PK_L_(0x08,0x5F)
#define REG_VR_BK08_5F_H    _PK_H_(0x08,0x5F)

#define REG_VR_BK08_60_L    _PK_L_(0x08,0x60)
#define REG_VR_BK08_60_H    _PK_H_(0x08,0x60)
#define REG_VR_BK08_61_L    _PK_L_(0x08,0x61)
#define REG_VR_BK08_61_H    _PK_H_(0x08,0x61)
#define REG_VR_BK08_62_L    _PK_L_(0x08,0x62)
#define REG_VR_BK08_62_H    _PK_H_(0x08,0x62)
#define REG_VR_BK08_63_L    _PK_L_(0x08,0x63)
#define REG_VR_BK08_63_H    _PK_H_(0x08,0x63)
#define REG_VR_BK08_64_L    _PK_L_(0x08,0x64)
#define REG_VR_BK08_64_H    _PK_H_(0x08,0x64)
#define REG_VR_BK08_65_L    _PK_L_(0x08,0x65)
#define REG_VR_BK08_65_H    _PK_H_(0x08,0x65)
#define REG_VR_BK08_66_L    _PK_L_(0x08,0x66)
#define REG_VR_BK08_66_H    _PK_H_(0x08,0x66)
#define REG_VR_BK08_67_L    _PK_L_(0x08,0x67)
#define REG_VR_BK08_67_H    _PK_H_(0x08,0x67)
#define REG_VR_BK08_68_L    _PK_L_(0x08,0x68)
#define REG_VR_BK08_68_H    _PK_H_(0x08,0x68)
#define REG_VR_BK08_69_L    _PK_L_(0x08,0x69)
#define REG_VR_BK08_69_H    _PK_H_(0x08,0x69)
#define REG_VR_BK08_6A_L    _PK_L_(0x08,0x6A)
#define REG_VR_BK08_6A_H    _PK_H_(0x08,0x6A)
#define REG_VR_BK08_6B_L    _PK_L_(0x08,0x6B)
#define REG_VR_BK08_6B_H    _PK_H_(0x08,0x6B)
#define REG_VR_BK08_6C_L    _PK_L_(0x08,0x6C)
#define REG_VR_BK08_6C_H    _PK_H_(0x08,0x6C)
#define REG_VR_BK08_6D_L    _PK_L_(0x08,0x6D)
#define REG_VR_BK08_6D_H    _PK_H_(0x08,0x6D)
#define REG_VR_BK08_6E_L    _PK_L_(0x08,0x6E)
#define REG_VR_BK08_6E_H    _PK_H_(0x08,0x6E)
#define REG_VR_BK08_6F_L    _PK_L_(0x08,0x6F)
#define REG_VR_BK08_6F_H    _PK_H_(0x08,0x6F)
#endif

