//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>

#ifndef _LPLL_TBL_H_
#define _LPLL_TBL_H_

#define LPLL_REG_NUM    37

typedef enum
{
    E_PNL_SUPPORTED_LPLL_TTL_75to150MHz,          //0
    E_PNL_SUPPORTED_LPLL_TTL_75to75MHz,          //1

    E_PNL_SUPPORTED_LPLL_LVDS_1ch_450to595MHz,          //2
    E_PNL_SUPPORTED_LPLL_LVDS_1ch_297_5to450MHz,          //3
    E_PNL_SUPPORTED_LPLL_LVDS_1ch_297_5to297_5MHz,          //4

    E_PNL_SUPPORTED_LPLL_LVDS_2ch_450to600MHz,          //5
    E_PNL_SUPPORTED_LPLL_LVDS_2ch_300to450MHz,          //6
    E_PNL_SUPPORTED_LPLL_LVDS_2ch_300to300MHz,          //7

    E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_450to600MHz,          //8
    E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_300to450MHz,          //9
    E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_300to300MHz,          //10

    E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_450to600MHz,          //11
    E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_300to450MHz,          //12
    E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_300to300MHz,          //13

    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_450to595MHz,          //14
    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_297_5to450MHz,          //15
    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_297_5to297_5MHz,          //16

    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_450to595MHz,          //17
    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_297_5to450MHz,          //18
    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_297_5to297_5MHz,          //19

    E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_6bit_300to600MHz,          //20
    E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_6bit_300to300MHz,          //21

    E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_6bit_300to600MHz,          //22
    E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_6bit_300to300MHz,          //23

    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_450to595MHz,          //24
    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_297_5to450MHz,          //25
    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_297_5to297_5MHz,          //26

    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_450to595MHz,          //27
    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_297_5to450MHz,          //28
    E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_297_5to297_5MHz,          //29

    E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_8bit_300to600MHz,          //30
    E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_8bit_300to300MHz,          //31

    E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_8bit_300to600MHz,          //32
    E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_8bit_300to300MHz,          //33

    E_PNL_SUPPORTED_LPLL_MINILVDS_4bk_6pair_8bit_300to600MHz,          //34
    E_PNL_SUPPORTED_LPLL_MINILVDS_4bk_6pair_8bit_300to300MHz,          //35

    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_450to600MHz,          //36
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_300to450MHz,          //37
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_300to300MHz,          //38

    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_450to600MHz,          //39
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_300to450MHz,          //40
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_300to300MHz,          //41

    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_FHD_300to600MHz,          //42
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_FHD_300to300MHz,          //43

    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_450to600MHz,          //44
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_300to450MHz,          //45
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_300to300MHz,          //46

    E_PNL_SUPPORTED_LPLL_EPI_24_10bit_16pair_UHD_300to600MHz,          //47
    E_PNL_SUPPORTED_LPLL_EPI_24_10bit_16pair_UHD_300to300MHz,          //48

    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_450to600MHz,          //49
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_300to450MHz,          //50
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_300to300MHz,          //51

    E_PNL_SUPPORTED_LPLL_EPI_24_10bit_12pair_UHD_300to600MHz,          //52
    E_PNL_SUPPORTED_LPLL_EPI_24_10bit_12pair_UHD_300to300MHz,          //53

    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_12pair_UHD_300to600MHz,          //54
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_12pair_UHD_300to300MHz,          //55

    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_350to600MHz,          //56
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_300to350MHz,          //57
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_300to300MHz,          //58

    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_450to600MHz,          //59
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_300to450MHz,          //60
    E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_300to300MHz,          //61

    E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_450to600MHz,          //62
    E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_300to450MHz,          //63
    E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_300to300MHz,          //64

    E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_350to600MHz,          //65
    E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_300to350MHz,          //66
    E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_300to300MHz,          //67

    E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_12pair_300to600MHz,          //68
    E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_12pair_300to300MHz,          //69

    E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_12pair_300to600MHz,          //70
    E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_12pair_300to300MHz,          //71

    E_PNL_SUPPORTED_LPLL_USI_T_10bit_12pair_300to600MHz,          //72
    E_PNL_SUPPORTED_LPLL_USI_T_10bit_12pair_300to300MHz,          //73

    E_PNL_SUPPORTED_LPLL_USI_T_8bit_12pair_300to600MHz,          //74
    E_PNL_SUPPORTED_LPLL_USI_T_8bit_12pair_300to300MHz,          //75

    E_PNL_SUPPORTED_LPLL_ISP_10bit_6pair_dual_300to600MHz,          //76
    E_PNL_SUPPORTED_LPLL_ISP_10bit_6pair_dual_300to300MHz,          //77

    E_PNL_SUPPORTED_LPLL_ISP_8bit_6pair_dual_300to600MHz,          //78
    E_PNL_SUPPORTED_LPLL_ISP_8bit_6pair_dual_300to300MHz,          //79

    E_PNL_SUPPORTED_LPLL_ISP_10bit_12pair_300to600MHz,          //80
    E_PNL_SUPPORTED_LPLL_ISP_10bit_12pair_300to300MHz,          //81

    E_PNL_SUPPORTED_LPLL_ISP_8bit_12pair_300to600MHz,          //82
    E_PNL_SUPPORTED_LPLL_ISP_8bit_12pair_300to300MHz,          //83

    E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_400to600MHz,          //84
    E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_300to400MHz,          //85
    E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_300to300MHz,          //86

    E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_450to600MHz,          //87
    E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_300to450MHz,          //88
    E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_300to300MHz,          //89

    E_PNL_SUPPORTED_LPLL_USII_8bit_12x1_4k_300to600MHz,          //90
    E_PNL_SUPPORTED_LPLL_USII_8bit_12x1_4k_300to300MHz,          //91

    E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_dual_4k_300to600MHz,          //92
    E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_dual_4k_300to300MHz,          //93

    E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_450to600MHz,          //94
    E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_300to450MHz,          //95
    E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_300to300MHz,          //96

    E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_4k_300to600MHz,          //97
    E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_4k_300to300MHz,          //98

    E_PNL_SUPPORTED_LPLL_USII_8bit_6x2_4k_300to600MHz,          //99
    E_PNL_SUPPORTED_LPLL_USII_8bit_6x2_4k_300to300MHz,          //100

    E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_500to600MHz,          //101
    E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_300to500MHz,          //102
    E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_300to300MHz,          //103

    E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_350to600MHz,          //104
    E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_300to350MHz,          //105
    E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_300to300MHz,          //106

    E_PNL_SUPPORTED_LPLL_Vx1_10bit_8_lane_300to600MHz,          //107
    E_PNL_SUPPORTED_LPLL_Vx1_10bit_8_lane_300to300MHz,          //108

    E_PNL_SUPPORTED_LPLL_Vx1_10bit_4_lane_300to600MHz,          //109
    E_PNL_SUPPORTED_LPLL_Vx1_10bit_4_lane_300to300MHz,          //110

    E_PNL_SUPPORTED_LPLL_Vx1_10bit_2_lane_300to600MHz,          //111
    E_PNL_SUPPORTED_LPLL_Vx1_10bit_2_lane_300to300MHz,          //112

    E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_450to600MHz,          //113
    E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_300to450MHz,          //114
    E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_300to300MHz,          //115

    E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_450to600MHz,          //116
    E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_300to450MHz,          //117
    E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_300to300MHz,          //118

    E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_450to600MHz,          //119
    E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_300to450MHz,          //120
    E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_300to300MHz,          //121

    E_PNL_SUPPORTED_LPLL_MAX,          //122
} E_PNL_SUPPORTED_LPLL_TYPE;

typedef struct
{
    MS_U8  address;
    MS_U16 value;
    MS_U16 mask;
}TBLStruct,*pTBLStruct;

TBLStruct LPLLSettingTBL[E_PNL_SUPPORTED_LPLL_MAX][LPLL_REG_NUM]=
{
    { //E_PNL_SUPPORTED_LPLL_TTL_75to150MHz    NO.0
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x3000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0004,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_TTL_75to75MHz    NO.1
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x3000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0004,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_LVDS_1ch_450to595MHz    NO.2
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x1000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_LVDS_1ch_297_5to450MHz    NO.3
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x2000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_LVDS_1ch_297_5to297_5MHz    NO.4
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x2000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_LVDS_2ch_450to600MHz    NO.5
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0200,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x2000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_LVDS_2ch_300to450MHz    NO.6
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x2000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_LVDS_2ch_300to300MHz    NO.7
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x2000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_450to600MHz    NO.8
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0200,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x2000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_300to450MHz    NO.9
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x2000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_300to300MHz    NO.10
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x2000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_450to600MHz    NO.11
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x2000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_300to450MHz    NO.12
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x2000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_300to300MHz    NO.13
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x2000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_450to595MHz    NO.14
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_297_5to450MHz    NO.15
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0200,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0001,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_297_5to297_5MHz    NO.16
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0200,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0001,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_450to595MHz    NO.17
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0001,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_297_5to450MHz    NO.18
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0200,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x3000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0002,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_297_5to297_5MHz    NO.19
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0200,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x3000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0002,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_6bit_300to600MHz    NO.20
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0300,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0001,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_6bit_300to300MHz    NO.21
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0300,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0001,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_6bit_300to600MHz    NO.22
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0300,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x3000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0002,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_6bit_300to300MHz    NO.23
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0300,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x3000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0002,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_450to595MHz    NO.24
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0200,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_297_5to450MHz    NO.25
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0001,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_297_5to297_5MHz    NO.26
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0001,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_450to595MHz    NO.27
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0200,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0001,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_297_5to450MHz    NO.28
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0001,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0001,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_297_5to297_5MHz    NO.29
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0001,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0001,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0080,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_8bit_300to600MHz    NO.30
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x1000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_8bit_300to300MHz    NO.31
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x1000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_8bit_300to600MHz    NO.32
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x1000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0001,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_8bit_300to300MHz    NO.33
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x1000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x2000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0001,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_4bk_6pair_8bit_300to600MHz    NO.34
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x1000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_MINILVDS_4bk_6pair_8bit_300to300MHz    NO.35
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0000,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x1000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x0000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0000,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x4000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x0000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0020,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0000,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0000,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_450to600MHz    NO.36
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_300to450MHz    NO.37
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_300to300MHz    NO.38
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_450to600MHz    NO.39
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_300to450MHz    NO.40
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_300to300MHz    NO.41
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_FHD_300to600MHz    NO.42
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_FHD_300to300MHz    NO.43
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_450to600MHz    NO.44
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_300to450MHz    NO.45
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_300to300MHz    NO.46
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_16pair_UHD_300to600MHz    NO.47
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_16pair_UHD_300to300MHz    NO.48
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_450to600MHz    NO.49
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_300to450MHz    NO.50
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_300to300MHz    NO.51
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x1000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_12pair_UHD_300to600MHz    NO.52
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_12pair_UHD_300to300MHz    NO.53
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_12pair_UHD_300to600MHz    NO.54
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_12pair_UHD_300to300MHz    NO.55
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_350to600MHz    NO.56
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_300to350MHz    NO.57
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0018,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_300to300MHz    NO.58
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0018,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_450to600MHz    NO.59
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_300to450MHz    NO.60
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_300to300MHz    NO.61
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0700,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_450to600MHz    NO.62
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_300to450MHz    NO.63
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_300to300MHz    NO.64
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_350to600MHz    NO.65
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_300to350MHz    NO.66
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_300to300MHz    NO.67
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_12pair_300to600MHz    NO.68
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_12pair_300to300MHz    NO.69
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_12pair_300to600MHz    NO.70
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_12pair_300to300MHz    NO.71
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x0000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USI_T_10bit_12pair_300to600MHz    NO.72
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0010,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USI_T_10bit_12pair_300to300MHz    NO.73
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0010,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USI_T_8bit_12pair_300to600MHz    NO.74
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0010,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USI_T_8bit_12pair_300to300MHz    NO.75
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0010,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0100,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_10bit_6pair_dual_300to600MHz    NO.76
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_10bit_6pair_dual_300to300MHz    NO.77
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_8bit_6pair_dual_300to600MHz    NO.78
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_8bit_6pair_dual_300to300MHz    NO.79
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_10bit_12pair_300to600MHz    NO.80
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_10bit_12pair_300to300MHz    NO.81
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_8bit_12pair_300to600MHz    NO.82
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_8bit_12pair_300to300MHz    NO.83
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_400to600MHz    NO.84
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0000,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0010,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_300to400MHz    NO.85
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0018,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0000,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0010,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_300to300MHz    NO.86
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0018,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0000,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0010,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_450to600MHz    NO.87
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_300to450MHz    NO.88
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_300to300MHz    NO.89
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0900,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0004,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0008,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_8bit_12x1_4k_300to600MHz    NO.90
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_8bit_12x1_4k_300to300MHz    NO.91
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_dual_4k_300to600MHz    NO.92
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_dual_4k_300to300MHz    NO.93
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_450to600MHz    NO.94
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_300to450MHz    NO.95
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0014,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_300to300MHz    NO.96
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0014,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_4k_300to600MHz    NO.97
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_4k_300to300MHz    NO.98
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_8bit_6x2_4k_300to600MHz    NO.99
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_8bit_6x2_4k_300to300MHz    NO.100
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_500to600MHz    NO.101
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_300to500MHz    NO.102
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0010,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_300to300MHz    NO.103
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0010,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_350to600MHz    NO.104
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x000C,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0F00,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_300to350MHz    NO.105
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0018,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0F00,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_300to300MHz    NO.106
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0018,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0001,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0F00,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0800,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0040,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_10bit_8_lane_300to600MHz    NO.107
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_10bit_8_lane_300to300MHz    NO.108
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_10bit_4_lane_300to600MHz    NO.109
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_10bit_4_lane_300to300MHz    NO.110
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_10bit_2_lane_300to600MHz    NO.111
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_10bit_2_lane_300to300MHz    NO.112
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0004,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0002,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0500,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0040,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0000,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0800,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_450to600MHz    NO.113
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_300to450MHz    NO.114
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0014,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_300to300MHz    NO.115
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0014,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_450to600MHz    NO.116
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_300to450MHz    NO.117
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0014,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_300to300MHz    NO.118
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0014,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_450to600MHz    NO.119
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0008,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0000,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0004,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0002,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_300to450MHz    NO.120
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0014,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

    { //E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_300to300MHz    NO.121
      //Address,Value,Mask
        {0x6D,0x0040,0x00C0},//reg_mpll_loop_div_first
        {0x6E,0x0020,0x0020},//reg_mpll_test[5]
        {0x03,0x0014,0x001C},//reg_lpll1_ibias_ictrl
        {0x15,0x0000,0x0003},//reg_lpll1_input_div_first
        {0x01,0x0003,0x0003},//reg_lpll1_loop_div_first
        {0x01,0x0300,0x1F00},//reg_lpll1_loop_div_second
        {0x02,0x0000,0x3000},//reg_lpll1_output_div_second[13:12]
        {0x02,0x0000,0x0F00},//reg_lpll1_output_div_second[11:8]
        {0x35,0x0000,0x7000},//reg_lpll1_skew_div
        {0x2E,0x0000,0x0007},//reg_lpll1_fifo_div
        {0x03,0x0000,0x0800},//reg_lpll1_fifo_div5_en
        {0x2E,0x1000,0x1000},//reg_lpll1_en_fix_clk
        {0x35,0x0020,0x0020},//reg_lpll_2ndpll_clk_sel
        {0x37,0x0008,0x0008},//reg_lpll1_test[19]
        {0x37,0x0000,0x0010},//reg_lpll1_test[20]
        {0x2E,0x8000,0x8000},//reg_lpll1_dual_lp_en
        {0x04,0x0000,0x2000},//reg_lpll1_sdiv3p5_en
        {0x03,0x0000,0x0400},//reg_lpll1_sdiv2p5_en
        {0x2E,0x0000,0x4000},//reg_lpll1_en_mini
        {0x2E,0x0000,0x0040},//reg_lpll1_en_fifo
        {0x2E,0x0010,0x0010},//reg_lpll_en_scalar
        {0x37,0x0000,0x0004},//reg_lpll1_test[18]
        {0x36,0x8000,0x8000},//reg_lpll1_test[15]
        {0x37,0x0000,0x0001},//reg_lpll1_test[16]
        {0x37,0x0000,0x0040},//reg_lpll1_test[22]
        {0x33,0x0000,0x0020},//reg_lpll2_pd
        {0x33,0x0000,0x0004},//reg_lpll2_ibias_ictrl
        {0x30,0x0000,0x001F},//reg_lpll2_input_div_first
        {0x31,0x0001,0x0003},//reg_lpll2_loop_div_first
        {0x31,0x0300,0x1F00},//reg_lpll2_loop_div_second
        {0x32,0x0004,0x000F},//reg_lpll2_output_div_first
        {0x39,0x0000,0x0800},//reg_lpll2_test[11]
        {0x39,0x1000,0x1000},//reg_lpll2_test[12]
        {0x39,0x0000,0x0100},//reg_lpll2_test[8]
        {0x33,0x0000,0x0080},//reg_lpll2_div14_en
        {0x38,0x0000,0x0200},//reg_lpll1_scalar2fifo_en
        {0x38,0x0000,0x0100},//reg_lpll1_scalar2fifo_div2
    },

};
MS_U16 u16LoopGain[E_PNL_SUPPORTED_LPLL_MAX]=
{
    8,           //E_PNL_SUPPORTED_LPLL_TTL_75to150MHz    NO.0
    8,           //E_PNL_SUPPORTED_LPLL_TTL_75to75MHz    NO.1
    8,           //E_PNL_SUPPORTED_LPLL_LVDS_1ch_450to595MHz    NO.2
    8,           //E_PNL_SUPPORTED_LPLL_LVDS_1ch_297_5to450MHz    NO.3
    8,           //E_PNL_SUPPORTED_LPLL_LVDS_1ch_297_5to297_5MHz    NO.4
    32,           //E_PNL_SUPPORTED_LPLL_LVDS_2ch_450to600MHz    NO.5
    16,           //E_PNL_SUPPORTED_LPLL_LVDS_2ch_300to450MHz    NO.6
    16,           //E_PNL_SUPPORTED_LPLL_LVDS_2ch_300to300MHz    NO.7
    32,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_450to600MHz    NO.8
    16,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_300to450MHz    NO.9
    16,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_300to300MHz    NO.10
    28,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_450to600MHz    NO.11
    28,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_300to450MHz    NO.12
    28,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_300to300MHz    NO.13
    12,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_450to595MHz    NO.14
    6,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_297_5to450MHz    NO.15
    6,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_297_5to297_5MHz    NO.16
    12,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_450to595MHz    NO.17
    6,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_297_5to450MHz    NO.18
    6,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_297_5to297_5MHz    NO.19
    8,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_6bit_300to600MHz    NO.20
    8,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_6bit_300to300MHz    NO.21
    8,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_6bit_300to600MHz    NO.22
    8,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_6bit_300to300MHz    NO.23
    6,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_450to595MHz    NO.24
    12,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_297_5to450MHz    NO.25
    12,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_297_5to297_5MHz    NO.26
    6,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_450to595MHz    NO.27
    12,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_297_5to450MHz    NO.28
    12,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_297_5to297_5MHz    NO.29
    8,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_8bit_300to600MHz    NO.30
    8,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_8bit_300to300MHz    NO.31
    8,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_8bit_300to600MHz    NO.32
    8,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_8bit_300to300MHz    NO.33
    8,           //E_PNL_SUPPORTED_LPLL_MINILVDS_4bk_6pair_8bit_300to600MHz    NO.34
    8,           //E_PNL_SUPPORTED_LPLL_MINILVDS_4bk_6pair_8bit_300to300MHz    NO.35
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_450to600MHz    NO.36
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_300to450MHz    NO.37
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_300to300MHz    NO.38
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_450to600MHz    NO.39
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_300to450MHz    NO.40
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_300to300MHz    NO.41
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_FHD_300to600MHz    NO.42
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_FHD_300to300MHz    NO.43
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_450to600MHz    NO.44
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_300to450MHz    NO.45
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_300to300MHz    NO.46
    6,           //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_16pair_UHD_300to600MHz    NO.47
    6,           //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_16pair_UHD_300to300MHz    NO.48
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_450to600MHz    NO.49
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_300to450MHz    NO.50
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_300to300MHz    NO.51
    6,           //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_12pair_UHD_300to600MHz    NO.52
    6,           //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_12pair_UHD_300to300MHz    NO.53
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_12pair_UHD_300to600MHz    NO.54
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_12pair_UHD_300to300MHz    NO.55
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_350to600MHz    NO.56
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_300to350MHz    NO.57
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_300to300MHz    NO.58
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_450to600MHz    NO.59
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_300to450MHz    NO.60
    6,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_300to300MHz    NO.61
    12,           //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_450to600MHz    NO.62
    6,           //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_300to450MHz    NO.63
    6,           //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_300to300MHz    NO.64
    6,           //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_350to600MHz    NO.65
    6,           //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_300to350MHz    NO.66
    6,           //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_300to300MHz    NO.67
    6,           //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_12pair_300to600MHz    NO.68
    6,           //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_12pair_300to300MHz    NO.69
    6,           //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_12pair_300to600MHz    NO.70
    6,           //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_12pair_300to300MHz    NO.71
    24,           //E_PNL_SUPPORTED_LPLL_USI_T_10bit_12pair_300to600MHz    NO.72
    24,           //E_PNL_SUPPORTED_LPLL_USI_T_10bit_12pair_300to300MHz    NO.73
    6,           //E_PNL_SUPPORTED_LPLL_USI_T_8bit_12pair_300to600MHz    NO.74
    6,           //E_PNL_SUPPORTED_LPLL_USI_T_8bit_12pair_300to300MHz    NO.75
    24,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_6pair_dual_300to600MHz    NO.76
    24,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_6pair_dual_300to300MHz    NO.77
    6,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_6pair_dual_300to600MHz    NO.78
    6,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_6pair_dual_300to300MHz    NO.79
    24,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_12pair_300to600MHz    NO.80
    24,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_12pair_300to300MHz    NO.81
    6,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_12pair_300to600MHz    NO.82
    6,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_12pair_300to300MHz    NO.83
    24,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_400to600MHz    NO.84
    12,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_300to400MHz    NO.85
    12,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_300to300MHz    NO.86
    12,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_450to600MHz    NO.87
    6,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_300to450MHz    NO.88
    6,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_300to300MHz    NO.89
    6,           //E_PNL_SUPPORTED_LPLL_USII_8bit_12x1_4k_300to600MHz    NO.90
    6,           //E_PNL_SUPPORTED_LPLL_USII_8bit_12x1_4k_300to300MHz    NO.91
    6,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_dual_4k_300to600MHz    NO.92
    6,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_dual_4k_300to300MHz    NO.93
    24,           //E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_450to600MHz    NO.94
    12,           //E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_300to450MHz    NO.95
    12,           //E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_300to300MHz    NO.96
    6,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_4k_300to600MHz    NO.97
    6,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_4k_300to300MHz    NO.98
    6,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x2_4k_300to600MHz    NO.99
    6,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x2_4k_300to300MHz    NO.100
    24,           //E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_500to600MHz    NO.101
    12,           //E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_300to500MHz    NO.102
    12,           //E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_300to300MHz    NO.103
    24,           //E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_350to600MHz    NO.104
    12,           //E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_300to350MHz    NO.105
    12,           //E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_300to300MHz    NO.106
    6,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_8_lane_300to600MHz    NO.107
    6,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_8_lane_300to300MHz    NO.108
    6,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_4_lane_300to600MHz    NO.109
    6,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_4_lane_300to300MHz    NO.110
    6,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_2_lane_300to600MHz    NO.111
    6,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_2_lane_300to300MHz    NO.112
    24,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_450to600MHz    NO.113
    12,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_300to450MHz    NO.114
    12,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_300to300MHz    NO.115
    24,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_450to600MHz    NO.116
    12,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_300to450MHz    NO.117
    12,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_300to300MHz    NO.118
    24,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_450to600MHz    NO.119
    12,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_300to450MHz    NO.120
    12,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_300to300MHz    NO.121
};
MS_U16 u16LoopDiv[E_PNL_SUPPORTED_LPLL_MAX]=
{
    8,           //E_PNL_SUPPORTED_LPLL_TTL_75to150MHz    NO.0
    8,           //E_PNL_SUPPORTED_LPLL_TTL_75to75MHz    NO.1
    2,           //E_PNL_SUPPORTED_LPLL_LVDS_1ch_450to595MHz    NO.2
    4,           //E_PNL_SUPPORTED_LPLL_LVDS_1ch_297_5to450MHz    NO.3
    4,           //E_PNL_SUPPORTED_LPLL_LVDS_1ch_297_5to297_5MHz    NO.4
    7,           //E_PNL_SUPPORTED_LPLL_LVDS_2ch_450to600MHz    NO.5
    7,           //E_PNL_SUPPORTED_LPLL_LVDS_2ch_300to450MHz    NO.6
    7,           //E_PNL_SUPPORTED_LPLL_LVDS_2ch_300to300MHz    NO.7
    7,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_450to600MHz    NO.8
    7,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_300to450MHz    NO.9
    7,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_1ch_300to300MHz    NO.10
    7,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_450to600MHz    NO.11
    7,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_300to450MHz    NO.12
    7,           //E_PNL_SUPPORTED_LPLL_HS_LVDS_2ch_300to300MHz    NO.13
    3,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_450to595MHz    NO.14
    3,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_297_5to450MHz    NO.15
    3,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_6bit_297_5to297_5MHz    NO.16
    3,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_450to595MHz    NO.17
    3,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_297_5to450MHz    NO.18
    3,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_6bit_297_5to297_5MHz    NO.19
    3,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_6bit_300to600MHz    NO.20
    3,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_6bit_300to300MHz    NO.21
    3,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_6bit_300to600MHz    NO.22
    3,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_6bit_300to300MHz    NO.23
    2,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_450to595MHz    NO.24
    4,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_297_5to450MHz    NO.25
    4,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_3pair_8bit_297_5to297_5MHz    NO.26
    2,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_450to595MHz    NO.27
    4,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_297_5to450MHz    NO.28
    4,           //E_PNL_SUPPORTED_LPLL_MINILVDS_1bk_6pair_8bit_297_5to297_5MHz    NO.29
    2,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_8bit_300to600MHz    NO.30
    2,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_3pair_8bit_300to300MHz    NO.31
    2,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_8bit_300to600MHz    NO.32
    2,           //E_PNL_SUPPORTED_LPLL_MINILVDS_2bk_6pair_8bit_300to300MHz    NO.33
    2,           //E_PNL_SUPPORTED_LPLL_MINILVDS_4bk_6pair_8bit_300to600MHz    NO.34
    2,           //E_PNL_SUPPORTED_LPLL_MINILVDS_4bk_6pair_8bit_300to300MHz    NO.35
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_450to600MHz    NO.36
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_300to450MHz    NO.37
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_2pair_FHD_300to300MHz    NO.38
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_450to600MHz    NO.39
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_300to450MHz    NO.40
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_4pair_FHD_300to300MHz    NO.41
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_FHD_300to600MHz    NO.42
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_FHD_300to300MHz    NO.43
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_450to600MHz    NO.44
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_300to450MHz    NO.45
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_FHD_300to300MHz    NO.46
    2,           //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_16pair_UHD_300to600MHz    NO.47
    2,           //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_16pair_UHD_300to300MHz    NO.48
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_450to600MHz    NO.49
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_300to450MHz    NO.50
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_16pair_UHD_300to300MHz    NO.51
    2,           //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_12pair_UHD_300to600MHz    NO.52
    2,           //E_PNL_SUPPORTED_LPLL_EPI_24_10bit_12pair_UHD_300to300MHz    NO.53
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_12pair_UHD_300to600MHz    NO.54
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_12pair_UHD_300to300MHz    NO.55
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_350to600MHz    NO.56
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_300to350MHz    NO.57
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_6pair_EPI3G_UHD_300to300MHz    NO.58
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_450to600MHz    NO.59
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_300to450MHz    NO.60
    2,           //E_PNL_SUPPORTED_LPLL_EPI_28_8bit_8pair_EPI3G_UHD_300to300MHz    NO.61
    3,           //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_450to600MHz    NO.62
    3,           //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_300to450MHz    NO.63
    3,           //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_8pair_300to300MHz    NO.64
    2,           //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_350to600MHz    NO.65
    2,           //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_300to350MHz    NO.66
    2,           //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_8pair_300to300MHz    NO.67
    2,           //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_12pair_300to600MHz    NO.68
    2,           //E_PNL_SUPPORTED_LPLL_CMPI_27_8bit_12pair_300to300MHz    NO.69
    2,           //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_12pair_300to600MHz    NO.70
    2,           //E_PNL_SUPPORTED_LPLL_CMPI_24_10bit_12pair_300to300MHz    NO.71
    5,           //E_PNL_SUPPORTED_LPLL_USI_T_10bit_12pair_300to600MHz    NO.72
    5,           //E_PNL_SUPPORTED_LPLL_USI_T_10bit_12pair_300to300MHz    NO.73
    2,           //E_PNL_SUPPORTED_LPLL_USI_T_8bit_12pair_300to600MHz    NO.74
    2,           //E_PNL_SUPPORTED_LPLL_USI_T_8bit_12pair_300to300MHz    NO.75
    5,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_6pair_dual_300to600MHz    NO.76
    5,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_6pair_dual_300to300MHz    NO.77
    2,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_6pair_dual_300to600MHz    NO.78
    2,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_6pair_dual_300to300MHz    NO.79
    5,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_12pair_300to600MHz    NO.80
    5,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_12pair_300to300MHz    NO.81
    2,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_12pair_300to600MHz    NO.82
    2,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_12pair_300to300MHz    NO.83
    5,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_400to600MHz    NO.84
    5,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_300to400MHz    NO.85
    5,           //E_PNL_SUPPORTED_LPLL_ISP_10bit_8pair_300to300MHz    NO.86
    3,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_450to600MHz    NO.87
    3,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_300to450MHz    NO.88
    3,           //E_PNL_SUPPORTED_LPLL_ISP_8bit_8pair_300to300MHz    NO.89
    2,           //E_PNL_SUPPORTED_LPLL_USII_8bit_12x1_4k_300to600MHz    NO.90
    2,           //E_PNL_SUPPORTED_LPLL_USII_8bit_12x1_4k_300to300MHz    NO.91
    2,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_dual_4k_300to600MHz    NO.92
    2,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_dual_4k_300to300MHz    NO.93
    5,           //E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_450to600MHz    NO.94
    5,           //E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_300to450MHz    NO.95
    5,           //E_PNL_SUPPORTED_LPLL_USII_8bit_8x1_4k_300to300MHz    NO.96
    2,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_4k_300to600MHz    NO.97
    2,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x1_4k_300to300MHz    NO.98
    2,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x2_4k_300to600MHz    NO.99
    2,           //E_PNL_SUPPORTED_LPLL_USII_8bit_6x2_4k_300to300MHz    NO.100
    5,           //E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_500to600MHz    NO.101
    5,           //E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_300to500MHz    NO.102
    5,           //E_PNL_SUPPORTED_LPLL_USII_10bit_12x1_4k_300to300MHz    NO.103
    5,           //E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_350to600MHz    NO.104
    5,           //E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_300to350MHz    NO.105
    5,           //E_PNL_SUPPORTED_LPLL_USII_10bit_8x1_4k_300to300MHz    NO.106
    2,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_8_lane_300to600MHz    NO.107
    2,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_8_lane_300to300MHz    NO.108
    2,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_4_lane_300to600MHz    NO.109
    2,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_4_lane_300to300MHz    NO.110
    2,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_2_lane_300to600MHz    NO.111
    2,           //E_PNL_SUPPORTED_LPLL_Vx1_10bit_2_lane_300to300MHz    NO.112
    5,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_450to600MHz    NO.113
    5,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_300to450MHz    NO.114
    5,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_8_lane_300to300MHz    NO.115
    5,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_450to600MHz    NO.116
    5,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_300to450MHz    NO.117
    5,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_4_lane_300to300MHz    NO.118
    5,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_450to600MHz    NO.119
    5,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_300to450MHz    NO.120
    5,           //E_PNL_SUPPORTED_LPLL_Vx1_8bit_2_lane_300to300MHz    NO.121
};

#endif //_LPLL_TBL_H_
