//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////


#ifndef _HWREG_FRC_MAP_H_
#define _HWREG_FRC_MAP_H_

#define FRC_PK_L_(bank, addr)            (REG_FRC_BANK_BASE + (((MS_U16)bank << 8) | (MS_U16)(addr*2)))
#define FRC_PK_H_( bank, addr)            (REG_FRC_BANK_BASE + (((MS_U16)bank << 8) | (MS_U16)(addr*2+1)))
#define U8 MS_U8
#define code
//=============================================================

//----------------------------------------------
//  BK2C -> BK22C
//----------------------------------------------
#define REG_FRC_BK22C_00_L      FRC_PK_L_(0x22C, 0x00)
#define REG_FRC_BK22C_00_H      FRC_PK_H_(0x22C, 0x00)
#define REG_FRC_BK22C_01_L      FRC_PK_L_(0x22C, 0x01)
#define REG_FRC_BK22C_01_H      FRC_PK_H_(0x22C, 0x01)
#define REG_FRC_BK22C_02_L      FRC_PK_L_(0x22C, 0x02)
#define REG_FRC_BK22C_02_H      FRC_PK_H_(0x22C, 0x02)
#define REG_FRC_BK22C_03_L      FRC_PK_L_(0x22C, 0x03)
#define REG_FRC_BK22C_03_H      FRC_PK_H_(0x22C, 0x03)
#define REG_FRC_BK22C_04_L      FRC_PK_L_(0x22C, 0x04)
#define REG_FRC_BK22C_04_H      FRC_PK_H_(0x22C, 0x04)
#define REG_FRC_BK22C_05_L      FRC_PK_L_(0x22C, 0x05)
#define REG_FRC_BK22C_05_H      FRC_PK_H_(0x22C, 0x05)
#define REG_FRC_BK22C_06_L      FRC_PK_L_(0x22C, 0x06)
#define REG_FRC_BK22C_06_H      FRC_PK_H_(0x22C, 0x06)
#define REG_FRC_BK22C_07_L      FRC_PK_L_(0x22C, 0x07)
#define REG_FRC_BK22C_07_H      FRC_PK_H_(0x22C, 0x07)
#define REG_FRC_BK22C_08_L      FRC_PK_L_(0x22C, 0x08)
#define REG_FRC_BK22C_08_H      FRC_PK_H_(0x22C, 0x08)
#define REG_FRC_BK22C_09_L      FRC_PK_L_(0x22C, 0x09)
#define REG_FRC_BK22C_09_H      FRC_PK_H_(0x22C, 0x09)
#define REG_FRC_BK22C_0A_L      FRC_PK_L_(0x22C, 0x0A)
#define REG_FRC_BK22C_0A_H      FRC_PK_H_(0x22C, 0x0A)
#define REG_FRC_BK22C_0B_L      FRC_PK_L_(0x22C, 0x0B)
#define REG_FRC_BK22C_0B_H      FRC_PK_H_(0x22C, 0x0B)
#define REG_FRC_BK22C_0C_L      FRC_PK_L_(0x22C, 0x0C)
#define REG_FRC_BK22C_0C_H      FRC_PK_H_(0x22C, 0x0C)
#define REG_FRC_BK22C_0D_L      FRC_PK_L_(0x22C, 0x0D)
#define REG_FRC_BK22C_0D_H      FRC_PK_H_(0x22C, 0x0D)
#define REG_FRC_BK22C_0E_L      FRC_PK_L_(0x22C, 0x0E)
#define REG_FRC_BK22C_0E_H      FRC_PK_H_(0x22C, 0x0E)
#define REG_FRC_BK22C_0F_L      FRC_PK_L_(0x22C, 0x0F)
#define REG_FRC_BK22C_0F_H      FRC_PK_H_(0x22C, 0x0F)
#define REG_FRC_BK22C_10_L      FRC_PK_L_(0x22C, 0x10)
#define REG_FRC_BK22C_10_H      FRC_PK_H_(0x22C, 0x10)
#define REG_FRC_BK22C_11_L      FRC_PK_L_(0x22C, 0x11)
#define REG_FRC_BK22C_11_H      FRC_PK_H_(0x22C, 0x11)
#define REG_FRC_BK22C_12_L      FRC_PK_L_(0x22C, 0x12)
#define REG_FRC_BK22C_12_H      FRC_PK_H_(0x22C, 0x12)
#define REG_FRC_BK22C_13_L      FRC_PK_L_(0x22C, 0x13)
#define REG_FRC_BK22C_13_H      FRC_PK_H_(0x22C, 0x13)
#define REG_FRC_BK22C_14_L      FRC_PK_L_(0x22C, 0x14)
#define REG_FRC_BK22C_14_H      FRC_PK_H_(0x22C, 0x14)
#define REG_FRC_BK22C_15_L      FRC_PK_L_(0x22C, 0x15)
#define REG_FRC_BK22C_15_H      FRC_PK_H_(0x22C, 0x15)
#define REG_FRC_BK22C_16_L      FRC_PK_L_(0x22C, 0x16)
#define REG_FRC_BK22C_16_H      FRC_PK_H_(0x22C, 0x16)
#define REG_FRC_BK22C_17_L      FRC_PK_L_(0x22C, 0x17)
#define REG_FRC_BK22C_17_H      FRC_PK_H_(0x22C, 0x17)
#define REG_FRC_BK22C_18_L      FRC_PK_L_(0x22C, 0x18)
#define REG_FRC_BK22C_18_H      FRC_PK_H_(0x22C, 0x18)
#define REG_FRC_BK22C_19_L      FRC_PK_L_(0x22C, 0x19)
#define REG_FRC_BK22C_19_H      FRC_PK_H_(0x22C, 0x19)
#define REG_FRC_BK22C_1A_L      FRC_PK_L_(0x22C, 0x1A)
#define REG_FRC_BK22C_1A_H      FRC_PK_H_(0x22C, 0x1A)
#define REG_FRC_BK22C_1B_L      FRC_PK_L_(0x22C, 0x1B)
#define REG_FRC_BK22C_1B_H      FRC_PK_H_(0x22C, 0x1B)
#define REG_FRC_BK22C_1C_L      FRC_PK_L_(0x22C, 0x1C)
#define REG_FRC_BK22C_1C_H      FRC_PK_H_(0x22C, 0x1C)
#define REG_FRC_BK22C_1D_L      FRC_PK_L_(0x22C, 0x1D)
#define REG_FRC_BK22C_1D_H      FRC_PK_H_(0x22C, 0x1D)
#define REG_FRC_BK22C_1E_L      FRC_PK_L_(0x22C, 0x1E)
#define REG_FRC_BK22C_1E_H      FRC_PK_H_(0x22C, 0x1E)
#define REG_FRC_BK22C_1F_L      FRC_PK_L_(0x22C, 0x1F)
#define REG_FRC_BK22C_1F_H      FRC_PK_H_(0x22C, 0x1F)
#define REG_FRC_BK22C_20_L      FRC_PK_L_(0x22C, 0x20)
#define REG_FRC_BK22C_20_H      FRC_PK_H_(0x22C, 0x20)
#define REG_FRC_BK22C_21_L      FRC_PK_L_(0x22C, 0x21)
#define REG_FRC_BK22C_21_H      FRC_PK_H_(0x22C, 0x21)
#define REG_FRC_BK22C_22_L      FRC_PK_L_(0x22C, 0x22)
#define REG_FRC_BK22C_22_H      FRC_PK_H_(0x22C, 0x22)
#define REG_FRC_BK22C_23_L      FRC_PK_L_(0x22C, 0x23)
#define REG_FRC_BK22C_23_H      FRC_PK_H_(0x22C, 0x23)
#define REG_FRC_BK22C_24_L      FRC_PK_L_(0x22C, 0x24)
#define REG_FRC_BK22C_24_H      FRC_PK_H_(0x22C, 0x24)
#define REG_FRC_BK22C_25_L      FRC_PK_L_(0x22C, 0x25)
#define REG_FRC_BK22C_25_H      FRC_PK_H_(0x22C, 0x25)
#define REG_FRC_BK22C_26_L      FRC_PK_L_(0x22C, 0x26)
#define REG_FRC_BK22C_26_H      FRC_PK_H_(0x22C, 0x26)
#define REG_FRC_BK22C_27_L      FRC_PK_L_(0x22C, 0x27)
#define REG_FRC_BK22C_27_H      FRC_PK_H_(0x22C, 0x27)
#define REG_FRC_BK22C_28_L      FRC_PK_L_(0x22C, 0x28)
#define REG_FRC_BK22C_28_H      FRC_PK_H_(0x22C, 0x28)
#define REG_FRC_BK22C_29_L      FRC_PK_L_(0x22C, 0x29)
#define REG_FRC_BK22C_29_H      FRC_PK_H_(0x22C, 0x29)
#define REG_FRC_BK22C_2A_L      FRC_PK_L_(0x22C, 0x2A)
#define REG_FRC_BK22C_2A_H      FRC_PK_H_(0x22C, 0x2A)
#define REG_FRC_BK22C_2B_L      FRC_PK_L_(0x22C, 0x2B)
#define REG_FRC_BK22C_2B_H      FRC_PK_H_(0x22C, 0x2B)
#define REG_FRC_BK22C_2C_L      FRC_PK_L_(0x22C, 0x2C)
#define REG_FRC_BK22C_2C_H      FRC_PK_H_(0x22C, 0x2C)
#define REG_FRC_BK22C_2D_L      FRC_PK_L_(0x22C, 0x2D)
#define REG_FRC_BK22C_2D_H      FRC_PK_H_(0x22C, 0x2D)
#define REG_FRC_BK22C_2E_L      FRC_PK_L_(0x22C, 0x2E)
#define REG_FRC_BK22C_2E_H      FRC_PK_H_(0x22C, 0x2E)
#define REG_FRC_BK22C_2F_L      FRC_PK_L_(0x22C, 0x2F)
#define REG_FRC_BK22C_2F_H      FRC_PK_H_(0x22C, 0x2F)
#define REG_FRC_BK22C_30_L      FRC_PK_L_(0x22C, 0x30)
#define REG_FRC_BK22C_30_H      FRC_PK_H_(0x22C, 0x30)
#define REG_FRC_BK22C_31_L      FRC_PK_L_(0x22C, 0x31)
#define REG_FRC_BK22C_31_H      FRC_PK_H_(0x22C, 0x31)
#define REG_FRC_BK22C_32_L      FRC_PK_L_(0x22C, 0x32)
#define REG_FRC_BK22C_32_H      FRC_PK_H_(0x22C, 0x32)
#define REG_FRC_BK22C_33_L      FRC_PK_L_(0x22C, 0x33)
#define REG_FRC_BK22C_33_H      FRC_PK_H_(0x22C, 0x33)
#define REG_FRC_BK22C_34_L      FRC_PK_L_(0x22C, 0x34)
#define REG_FRC_BK22C_34_H      FRC_PK_H_(0x22C, 0x34)
#define REG_FRC_BK22C_35_L      FRC_PK_L_(0x22C, 0x35)
#define REG_FRC_BK22C_35_H      FRC_PK_H_(0x22C, 0x35)
#define REG_FRC_BK22C_36_L      FRC_PK_L_(0x22C, 0x36)
#define REG_FRC_BK22C_36_H      FRC_PK_H_(0x22C, 0x36)
#define REG_FRC_BK22C_37_L      FRC_PK_L_(0x22C, 0x37)
#define REG_FRC_BK22C_37_H      FRC_PK_H_(0x22C, 0x37)
#define REG_FRC_BK22C_38_L      FRC_PK_L_(0x22C, 0x38)
#define REG_FRC_BK22C_38_H      FRC_PK_H_(0x22C, 0x38)
#define REG_FRC_BK22C_39_L      FRC_PK_L_(0x22C, 0x39)
#define REG_FRC_BK22C_39_H      FRC_PK_H_(0x22C, 0x39)
#define REG_FRC_BK22C_3A_L      FRC_PK_L_(0x22C, 0x3A)
#define REG_FRC_BK22C_3A_H      FRC_PK_H_(0x22C, 0x3A)
#define REG_FRC_BK22C_3B_L      FRC_PK_L_(0x22C, 0x3B)
#define REG_FRC_BK22C_3B_H      FRC_PK_H_(0x22C, 0x3B)
#define REG_FRC_BK22C_3C_L      FRC_PK_L_(0x22C, 0x3C)
#define REG_FRC_BK22C_3C_H      FRC_PK_H_(0x22C, 0x3C)
#define REG_FRC_BK22C_3D_L      FRC_PK_L_(0x22C, 0x3D)
#define REG_FRC_BK22C_3D_H      FRC_PK_H_(0x22C, 0x3D)
#define REG_FRC_BK22C_3E_L      FRC_PK_L_(0x22C, 0x3E)
#define REG_FRC_BK22C_3E_H      FRC_PK_H_(0x22C, 0x3E)
#define REG_FRC_BK22C_3F_L      FRC_PK_L_(0x22C, 0x3F)
#define REG_FRC_BK22C_3F_H      FRC_PK_H_(0x22C, 0x3F)
#define REG_FRC_BK22C_40_L      FRC_PK_L_(0x22C, 0x40)
#define REG_FRC_BK22C_40_H      FRC_PK_H_(0x22C, 0x40)
#define REG_FRC_BK22C_41_L      FRC_PK_L_(0x22C, 0x41)
#define REG_FRC_BK22C_41_H      FRC_PK_H_(0x22C, 0x41)
#define REG_FRC_BK22C_42_L      FRC_PK_L_(0x22C, 0x42)
#define REG_FRC_BK22C_42_H      FRC_PK_H_(0x22C, 0x42)
#define REG_FRC_BK22C_43_L      FRC_PK_L_(0x22C, 0x43)
#define REG_FRC_BK22C_43_H      FRC_PK_H_(0x22C, 0x43)
#define REG_FRC_BK22C_44_L      FRC_PK_L_(0x22C, 0x44)
#define REG_FRC_BK22C_44_H      FRC_PK_H_(0x22C, 0x44)
#define REG_FRC_BK22C_45_L      FRC_PK_L_(0x22C, 0x45)
#define REG_FRC_BK22C_45_H      FRC_PK_H_(0x22C, 0x45)
#define REG_FRC_BK22C_46_L      FRC_PK_L_(0x22C, 0x46)
#define REG_FRC_BK22C_46_H      FRC_PK_H_(0x22C, 0x46)
#define REG_FRC_BK22C_47_L      FRC_PK_L_(0x22C, 0x47)
#define REG_FRC_BK22C_47_H      FRC_PK_H_(0x22C, 0x47)
#define REG_FRC_BK22C_48_L      FRC_PK_L_(0x22C, 0x48)
#define REG_FRC_BK22C_48_H      FRC_PK_H_(0x22C, 0x48)
#define REG_FRC_BK22C_49_L      FRC_PK_L_(0x22C, 0x49)
#define REG_FRC_BK22C_49_H      FRC_PK_H_(0x22C, 0x49)
#define REG_FRC_BK22C_4A_L      FRC_PK_L_(0x22C, 0x4A)
#define REG_FRC_BK22C_4A_H      FRC_PK_H_(0x22C, 0x4A)
#define REG_FRC_BK22C_4B_L      FRC_PK_L_(0x22C, 0x4B)
#define REG_FRC_BK22C_4B_H      FRC_PK_H_(0x22C, 0x4B)
#define REG_FRC_BK22C_4C_L      FRC_PK_L_(0x22C, 0x4C)
#define REG_FRC_BK22C_4C_H      FRC_PK_H_(0x22C, 0x4C)
#define REG_FRC_BK22C_4D_L      FRC_PK_L_(0x22C, 0x4D)
#define REG_FRC_BK22C_4D_H      FRC_PK_H_(0x22C, 0x4D)
#define REG_FRC_BK22C_4E_L      FRC_PK_L_(0x22C, 0x4E)
#define REG_FRC_BK22C_4E_H      FRC_PK_H_(0x22C, 0x4E)
#define REG_FRC_BK22C_4F_L      FRC_PK_L_(0x22C, 0x4F)
#define REG_FRC_BK22C_4F_H      FRC_PK_H_(0x22C, 0x4F)
#define REG_FRC_BK22C_50_L      FRC_PK_L_(0x22C, 0x50)
#define REG_FRC_BK22C_50_H      FRC_PK_H_(0x22C, 0x50)
#define REG_FRC_BK22C_51_L      FRC_PK_L_(0x22C, 0x51)
#define REG_FRC_BK22C_51_H      FRC_PK_H_(0x22C, 0x51)
#define REG_FRC_BK22C_52_L      FRC_PK_L_(0x22C, 0x52)
#define REG_FRC_BK22C_52_H      FRC_PK_H_(0x22C, 0x52)
#define REG_FRC_BK22C_53_L      FRC_PK_L_(0x22C, 0x53)
#define REG_FRC_BK22C_53_H      FRC_PK_H_(0x22C, 0x53)
#define REG_FRC_BK22C_54_L      FRC_PK_L_(0x22C, 0x54)
#define REG_FRC_BK22C_54_H      FRC_PK_H_(0x22C, 0x54)
#define REG_FRC_BK22C_55_L      FRC_PK_L_(0x22C, 0x55)
#define REG_FRC_BK22C_55_H      FRC_PK_H_(0x22C, 0x55)
#define REG_FRC_BK22C_56_L      FRC_PK_L_(0x22C, 0x56)
#define REG_FRC_BK22C_56_H      FRC_PK_H_(0x22C, 0x56)
#define REG_FRC_BK22C_57_L      FRC_PK_L_(0x22C, 0x57)
#define REG_FRC_BK22C_57_H      FRC_PK_H_(0x22C, 0x57)
#define REG_FRC_BK22C_58_L      FRC_PK_L_(0x22C, 0x58)
#define REG_FRC_BK22C_58_H      FRC_PK_H_(0x22C, 0x58)
#define REG_FRC_BK22C_59_L      FRC_PK_L_(0x22C, 0x59)
#define REG_FRC_BK22C_59_H      FRC_PK_H_(0x22C, 0x59)
#define REG_FRC_BK22C_5A_L      FRC_PK_L_(0x22C, 0x5A)
#define REG_FRC_BK22C_5A_H      FRC_PK_H_(0x22C, 0x5A)
#define REG_FRC_BK22C_5B_L      FRC_PK_L_(0x22C, 0x5B)
#define REG_FRC_BK22C_5B_H      FRC_PK_H_(0x22C, 0x5B)
#define REG_FRC_BK22C_5C_L      FRC_PK_L_(0x22C, 0x5C)
#define REG_FRC_BK22C_5C_H      FRC_PK_H_(0x22C, 0x5C)
#define REG_FRC_BK22C_5D_L      FRC_PK_L_(0x22C, 0x5D)
#define REG_FRC_BK22C_5D_H      FRC_PK_H_(0x22C, 0x5D)
#define REG_FRC_BK22C_5E_L      FRC_PK_L_(0x22C, 0x5E)
#define REG_FRC_BK22C_5E_H      FRC_PK_H_(0x22C, 0x5E)
#define REG_FRC_BK22C_5F_L      FRC_PK_L_(0x22C, 0x5F)
#define REG_FRC_BK22C_5F_H      FRC_PK_H_(0x22C, 0x5F)
#define REG_FRC_BK22C_60_L      FRC_PK_L_(0x22C, 0x60)
#define REG_FRC_BK22C_60_H      FRC_PK_H_(0x22C, 0x60)
#define REG_FRC_BK22C_61_L      FRC_PK_L_(0x22C, 0x61)
#define REG_FRC_BK22C_61_H      FRC_PK_H_(0x22C, 0x61)
#define REG_FRC_BK22C_62_L      FRC_PK_L_(0x22C, 0x62)
#define REG_FRC_BK22C_62_H      FRC_PK_H_(0x22C, 0x62)
#define REG_FRC_BK22C_63_L      FRC_PK_L_(0x22C, 0x63)
#define REG_FRC_BK22C_63_H      FRC_PK_H_(0x22C, 0x63)
#define REG_FRC_BK22C_64_L      FRC_PK_L_(0x22C, 0x64)
#define REG_FRC_BK22C_64_H      FRC_PK_H_(0x22C, 0x64)
#define REG_FRC_BK22C_65_L      FRC_PK_L_(0x22C, 0x65)
#define REG_FRC_BK22C_65_H      FRC_PK_H_(0x22C, 0x65)
#define REG_FRC_BK22C_66_L      FRC_PK_L_(0x22C, 0x66)
#define REG_FRC_BK22C_66_H      FRC_PK_H_(0x22C, 0x66)
#define REG_FRC_BK22C_67_L      FRC_PK_L_(0x22C, 0x67)
#define REG_FRC_BK22C_67_H      FRC_PK_H_(0x22C, 0x67)
#define REG_FRC_BK22C_68_L      FRC_PK_L_(0x22C, 0x68)
#define REG_FRC_BK22C_68_H      FRC_PK_H_(0x22C, 0x68)
#define REG_FRC_BK22C_69_L      FRC_PK_L_(0x22C, 0x69)
#define REG_FRC_BK22C_69_H      FRC_PK_H_(0x22C, 0x69)
#define REG_FRC_BK22C_6A_L      FRC_PK_L_(0x22C, 0x6A)
#define REG_FRC_BK22C_6A_H      FRC_PK_H_(0x22C, 0x6A)
#define REG_FRC_BK22C_6B_L      FRC_PK_L_(0x22C, 0x6B)
#define REG_FRC_BK22C_6B_H      FRC_PK_H_(0x22C, 0x6B)
#define REG_FRC_BK22C_6C_L      FRC_PK_L_(0x22C, 0x6C)
#define REG_FRC_BK22C_6C_H      FRC_PK_H_(0x22C, 0x6C)
#define REG_FRC_BK22C_6D_L      FRC_PK_L_(0x22C, 0x6D)
#define REG_FRC_BK22C_6D_H      FRC_PK_H_(0x22C, 0x6D)
#define REG_FRC_BK22C_6E_L      FRC_PK_L_(0x22C, 0x6E)
#define REG_FRC_BK22C_6E_H      FRC_PK_H_(0x22C, 0x6E)
#define REG_FRC_BK22C_6F_L      FRC_PK_L_(0x22C, 0x6F)
#define REG_FRC_BK22C_6F_H      FRC_PK_H_(0x22C, 0x6F)
#define REG_FRC_BK22C_70_L      FRC_PK_L_(0x22C, 0x70)
#define REG_FRC_BK22C_70_H      FRC_PK_H_(0x22C, 0x70)
#define REG_FRC_BK22C_71_L      FRC_PK_L_(0x22C, 0x71)
#define REG_FRC_BK22C_71_H      FRC_PK_H_(0x22C, 0x71)
#define REG_FRC_BK22C_72_L      FRC_PK_L_(0x22C, 0x72)
#define REG_FRC_BK22C_72_H      FRC_PK_H_(0x22C, 0x72)
#define REG_FRC_BK22C_73_L      FRC_PK_L_(0x22C, 0x73)
#define REG_FRC_BK22C_73_H      FRC_PK_H_(0x22C, 0x73)
#define REG_FRC_BK22C_74_L      FRC_PK_L_(0x22C, 0x74)
#define REG_FRC_BK22C_74_H      FRC_PK_H_(0x22C, 0x74)
#define REG_FRC_BK22C_75_L      FRC_PK_L_(0x22C, 0x75)
#define REG_FRC_BK22C_75_H      FRC_PK_H_(0x22C, 0x75)
#define REG_FRC_BK22C_76_L      FRC_PK_L_(0x22C, 0x76)
#define REG_FRC_BK22C_76_H      FRC_PK_H_(0x22C, 0x76)
#define REG_FRC_BK22C_77_L      FRC_PK_L_(0x22C, 0x77)
#define REG_FRC_BK22C_77_H      FRC_PK_H_(0x22C, 0x77)
#define REG_FRC_BK22C_78_L      FRC_PK_L_(0x22C, 0x78)
#define REG_FRC_BK22C_78_H      FRC_PK_H_(0x22C, 0x78)
#define REG_FRC_BK22C_79_L      FRC_PK_L_(0x22C, 0x79)
#define REG_FRC_BK22C_79_H      FRC_PK_H_(0x22C, 0x79)
#define REG_FRC_BK22C_7A_L      FRC_PK_L_(0x22C, 0x7A)
#define REG_FRC_BK22C_7A_H      FRC_PK_H_(0x22C, 0x7A)
#define REG_FRC_BK22C_7B_L      FRC_PK_L_(0x22C, 0x7B)
#define REG_FRC_BK22C_7B_H      FRC_PK_H_(0x22C, 0x7B)
#define REG_FRC_BK22C_7C_L      FRC_PK_L_(0x22C, 0x7C)
#define REG_FRC_BK22C_7C_H      FRC_PK_H_(0x22C, 0x7C)
#define REG_FRC_BK22C_7D_L      FRC_PK_L_(0x22C, 0x7D)
#define REG_FRC_BK22C_7D_H      FRC_PK_H_(0x22C, 0x7D)
#define REG_FRC_BK22C_7E_L      FRC_PK_L_(0x22C, 0x7E)
#define REG_FRC_BK22C_7E_H      FRC_PK_H_(0x22C, 0x7E)
#define REG_FRC_BK22C_7F_L      FRC_PK_L_(0x22C, 0x7F)
#define REG_FRC_BK22C_7F_H      FRC_PK_H_(0x22C, 0x7F)

//----------------------------------------------
//  BK34
//----------------------------------------------
#define REG_FRC_BK34_00_L      FRC_PK_L_(0x34, 0x00)
#define REG_FRC_BK34_00_H      FRC_PK_H_(0x34, 0x00)
#define REG_FRC_BK34_01_L      FRC_PK_L_(0x34, 0x01)
#define REG_FRC_BK34_01_H      FRC_PK_H_(0x34, 0x01)
#define REG_FRC_BK34_02_L      FRC_PK_L_(0x34, 0x02)
#define REG_FRC_BK34_02_H      FRC_PK_H_(0x34, 0x02)
#define REG_FRC_BK34_03_L      FRC_PK_L_(0x34, 0x03)
#define REG_FRC_BK34_03_H      FRC_PK_H_(0x34, 0x03)
#define REG_FRC_BK34_04_L      FRC_PK_L_(0x34, 0x04)
#define REG_FRC_BK34_04_H      FRC_PK_H_(0x34, 0x04)
#define REG_FRC_BK34_05_L      FRC_PK_L_(0x34, 0x05)
#define REG_FRC_BK34_05_H      FRC_PK_H_(0x34, 0x05)
#define REG_FRC_BK34_06_L      FRC_PK_L_(0x34, 0x06)
#define REG_FRC_BK34_06_H      FRC_PK_H_(0x34, 0x06)
#define REG_FRC_BK34_07_L      FRC_PK_L_(0x34, 0x07)
#define REG_FRC_BK34_07_H      FRC_PK_H_(0x34, 0x07)
#define REG_FRC_BK34_08_L      FRC_PK_L_(0x34, 0x08)
#define REG_FRC_BK34_08_H      FRC_PK_H_(0x34, 0x08)
#define REG_FRC_BK34_09_L      FRC_PK_L_(0x34, 0x09)
#define REG_FRC_BK34_09_H      FRC_PK_H_(0x34, 0x09)
#define REG_FRC_BK34_0A_L      FRC_PK_L_(0x34, 0x0A)
#define REG_FRC_BK34_0A_H      FRC_PK_H_(0x34, 0x0A)
#define REG_FRC_BK34_0B_L      FRC_PK_L_(0x34, 0x0B)
#define REG_FRC_BK34_0B_H      FRC_PK_H_(0x34, 0x0B)
#define REG_FRC_BK34_0C_L      FRC_PK_L_(0x34, 0x0C)
#define REG_FRC_BK34_0C_H      FRC_PK_H_(0x34, 0x0C)
#define REG_FRC_BK34_0D_L      FRC_PK_L_(0x34, 0x0D)
#define REG_FRC_BK34_0D_H      FRC_PK_H_(0x34, 0x0D)
#define REG_FRC_BK34_0E_L      FRC_PK_L_(0x34, 0x0E)
#define REG_FRC_BK34_0E_H      FRC_PK_H_(0x34, 0x0E)
#define REG_FRC_BK34_0F_L      FRC_PK_L_(0x34, 0x0F)
#define REG_FRC_BK34_0F_H      FRC_PK_H_(0x34, 0x0F)
#define REG_FRC_BK34_10_L      FRC_PK_L_(0x34, 0x10)
#define REG_FRC_BK34_10_H      FRC_PK_H_(0x34, 0x10)
#define REG_FRC_BK34_11_L      FRC_PK_L_(0x34, 0x11)
#define REG_FRC_BK34_11_H      FRC_PK_H_(0x34, 0x11)
#define REG_FRC_BK34_12_L      FRC_PK_L_(0x34, 0x12)
#define REG_FRC_BK34_12_H      FRC_PK_H_(0x34, 0x12)
#define REG_FRC_BK34_13_L      FRC_PK_L_(0x34, 0x13)
#define REG_FRC_BK34_13_H      FRC_PK_H_(0x34, 0x13)
#define REG_FRC_BK34_14_L      FRC_PK_L_(0x34, 0x14)
#define REG_FRC_BK34_14_H      FRC_PK_H_(0x34, 0x14)
#define REG_FRC_BK34_15_L      FRC_PK_L_(0x34, 0x15)
#define REG_FRC_BK34_15_H      FRC_PK_H_(0x34, 0x15)
#define REG_FRC_BK34_16_L      FRC_PK_L_(0x34, 0x16)
#define REG_FRC_BK34_16_H      FRC_PK_H_(0x34, 0x16)
#define REG_FRC_BK34_17_L      FRC_PK_L_(0x34, 0x17)
#define REG_FRC_BK34_17_H      FRC_PK_H_(0x34, 0x17)
#define REG_FRC_BK34_18_L      FRC_PK_L_(0x34, 0x18)
#define REG_FRC_BK34_18_H      FRC_PK_H_(0x34, 0x18)
#define REG_FRC_BK34_19_L      FRC_PK_L_(0x34, 0x19)
#define REG_FRC_BK34_19_H      FRC_PK_H_(0x34, 0x19)
#define REG_FRC_BK34_1A_L      FRC_PK_L_(0x34, 0x1A)
#define REG_FRC_BK34_1A_H      FRC_PK_H_(0x34, 0x1A)
#define REG_FRC_BK34_1B_L      FRC_PK_L_(0x34, 0x1B)
#define REG_FRC_BK34_1B_H      FRC_PK_H_(0x34, 0x1B)
#define REG_FRC_BK34_1C_L      FRC_PK_L_(0x34, 0x1C)
#define REG_FRC_BK34_1C_H      FRC_PK_H_(0x34, 0x1C)
#define REG_FRC_BK34_1D_L      FRC_PK_L_(0x34, 0x1D)
#define REG_FRC_BK34_1D_H      FRC_PK_H_(0x34, 0x1D)
#define REG_FRC_BK34_1E_L      FRC_PK_L_(0x34, 0x1E)
#define REG_FRC_BK34_1E_H      FRC_PK_H_(0x34, 0x1E)
#define REG_FRC_BK34_1F_L      FRC_PK_L_(0x34, 0x1F)
#define REG_FRC_BK34_1F_H      FRC_PK_H_(0x34, 0x1F)
#define REG_FRC_BK34_20_L      FRC_PK_L_(0x34, 0x20)
#define REG_FRC_BK34_20_H      FRC_PK_H_(0x34, 0x20)
#define REG_FRC_BK34_21_L      FRC_PK_L_(0x34, 0x21)
#define REG_FRC_BK34_21_H      FRC_PK_H_(0x34, 0x21)
#define REG_FRC_BK34_22_L      FRC_PK_L_(0x34, 0x22)
#define REG_FRC_BK34_22_H      FRC_PK_H_(0x34, 0x22)
#define REG_FRC_BK34_23_L      FRC_PK_L_(0x34, 0x23)
#define REG_FRC_BK34_23_H      FRC_PK_H_(0x34, 0x23)
#define REG_FRC_BK34_24_L      FRC_PK_L_(0x34, 0x24)
#define REG_FRC_BK34_24_H      FRC_PK_H_(0x34, 0x24)
#define REG_FRC_BK34_25_L      FRC_PK_L_(0x34, 0x25)
#define REG_FRC_BK34_25_H      FRC_PK_H_(0x34, 0x25)
#define REG_FRC_BK34_26_L      FRC_PK_L_(0x34, 0x26)
#define REG_FRC_BK34_26_H      FRC_PK_H_(0x34, 0x26)
#define REG_FRC_BK34_27_L      FRC_PK_L_(0x34, 0x27)
#define REG_FRC_BK34_27_H      FRC_PK_H_(0x34, 0x27)
#define REG_FRC_BK34_28_L      FRC_PK_L_(0x34, 0x28)
#define REG_FRC_BK34_28_H      FRC_PK_H_(0x34, 0x28)
#define REG_FRC_BK34_29_L      FRC_PK_L_(0x34, 0x29)
#define REG_FRC_BK34_29_H      FRC_PK_H_(0x34, 0x29)
#define REG_FRC_BK34_2A_L      FRC_PK_L_(0x34, 0x2A)
#define REG_FRC_BK34_2A_H      FRC_PK_H_(0x34, 0x2A)
#define REG_FRC_BK34_2B_L      FRC_PK_L_(0x34, 0x2B)
#define REG_FRC_BK34_2B_H      FRC_PK_H_(0x34, 0x2B)
#define REG_FRC_BK34_2C_L      FRC_PK_L_(0x34, 0x2C)
#define REG_FRC_BK34_2C_H      FRC_PK_H_(0x34, 0x2C)
#define REG_FRC_BK34_2D_L      FRC_PK_L_(0x34, 0x2D)
#define REG_FRC_BK34_2D_H      FRC_PK_H_(0x34, 0x2D)
#define REG_FRC_BK34_2E_L      FRC_PK_L_(0x34, 0x2E)
#define REG_FRC_BK34_2E_H      FRC_PK_H_(0x34, 0x2E)
#define REG_FRC_BK34_2F_L      FRC_PK_L_(0x34, 0x2F)
#define REG_FRC_BK34_2F_H      FRC_PK_H_(0x34, 0x2F)
#define REG_FRC_BK34_30_L      FRC_PK_L_(0x34, 0x30)
#define REG_FRC_BK34_30_H      FRC_PK_H_(0x34, 0x30)
#define REG_FRC_BK34_31_L      FRC_PK_L_(0x34, 0x31)
#define REG_FRC_BK34_31_H      FRC_PK_H_(0x34, 0x31)
#define REG_FRC_BK34_32_L      FRC_PK_L_(0x34, 0x32)
#define REG_FRC_BK34_32_H      FRC_PK_H_(0x34, 0x32)
#define REG_FRC_BK34_33_L      FRC_PK_L_(0x34, 0x33)
#define REG_FRC_BK34_33_H      FRC_PK_H_(0x34, 0x33)
#define REG_FRC_BK34_34_L      FRC_PK_L_(0x34, 0x34)
#define REG_FRC_BK34_34_H      FRC_PK_H_(0x34, 0x34)
#define REG_FRC_BK34_35_L      FRC_PK_L_(0x34, 0x35)
#define REG_FRC_BK34_35_H      FRC_PK_H_(0x34, 0x35)
#define REG_FRC_BK34_36_L      FRC_PK_L_(0x34, 0x36)
#define REG_FRC_BK34_36_H      FRC_PK_H_(0x34, 0x36)
#define REG_FRC_BK34_37_L      FRC_PK_L_(0x34, 0x37)
#define REG_FRC_BK34_37_H      FRC_PK_H_(0x34, 0x37)
#define REG_FRC_BK34_38_L      FRC_PK_L_(0x34, 0x38)
#define REG_FRC_BK34_38_H      FRC_PK_H_(0x34, 0x38)
#define REG_FRC_BK34_39_L      FRC_PK_L_(0x34, 0x39)
#define REG_FRC_BK34_39_H      FRC_PK_H_(0x34, 0x39)
#define REG_FRC_BK34_3A_L      FRC_PK_L_(0x34, 0x3A)
#define REG_FRC_BK34_3A_H      FRC_PK_H_(0x34, 0x3A)
#define REG_FRC_BK34_3B_L      FRC_PK_L_(0x34, 0x3B)
#define REG_FRC_BK34_3B_H      FRC_PK_H_(0x34, 0x3B)
#define REG_FRC_BK34_3C_L      FRC_PK_L_(0x34, 0x3C)
#define REG_FRC_BK34_3C_H      FRC_PK_H_(0x34, 0x3C)
#define REG_FRC_BK34_3D_L      FRC_PK_L_(0x34, 0x3D)
#define REG_FRC_BK34_3D_H      FRC_PK_H_(0x34, 0x3D)
#define REG_FRC_BK34_3E_L      FRC_PK_L_(0x34, 0x3E)
#define REG_FRC_BK34_3E_H      FRC_PK_H_(0x34, 0x3E)
#define REG_FRC_BK34_3F_L      FRC_PK_L_(0x34, 0x3F)
#define REG_FRC_BK34_3F_H      FRC_PK_H_(0x34, 0x3F)
#define REG_FRC_BK34_40_L      FRC_PK_L_(0x34, 0x40)
#define REG_FRC_BK34_40_H      FRC_PK_H_(0x34, 0x40)
#define REG_FRC_BK34_41_L      FRC_PK_L_(0x34, 0x41)
#define REG_FRC_BK34_41_H      FRC_PK_H_(0x34, 0x41)
#define REG_FRC_BK34_42_L      FRC_PK_L_(0x34, 0x42)
#define REG_FRC_BK34_42_H      FRC_PK_H_(0x34, 0x42)
#define REG_FRC_BK34_43_L      FRC_PK_L_(0x34, 0x43)
#define REG_FRC_BK34_43_H      FRC_PK_H_(0x34, 0x43)
#define REG_FRC_BK34_44_L      FRC_PK_L_(0x34, 0x44)
#define REG_FRC_BK34_44_H      FRC_PK_H_(0x34, 0x44)
#define REG_FRC_BK34_45_L      FRC_PK_L_(0x34, 0x45)
#define REG_FRC_BK34_45_H      FRC_PK_H_(0x34, 0x45)
#define REG_FRC_BK34_46_L      FRC_PK_L_(0x34, 0x46)
#define REG_FRC_BK34_46_H      FRC_PK_H_(0x34, 0x46)
#define REG_FRC_BK34_47_L      FRC_PK_L_(0x34, 0x47)
#define REG_FRC_BK34_47_H      FRC_PK_H_(0x34, 0x47)
#define REG_FRC_BK34_48_L      FRC_PK_L_(0x34, 0x48)
#define REG_FRC_BK34_48_H      FRC_PK_H_(0x34, 0x48)
#define REG_FRC_BK34_49_L      FRC_PK_L_(0x34, 0x49)
#define REG_FRC_BK34_49_H      FRC_PK_H_(0x34, 0x49)
#define REG_FRC_BK34_4A_L      FRC_PK_L_(0x34, 0x4A)
#define REG_FRC_BK34_4A_H      FRC_PK_H_(0x34, 0x4A)
#define REG_FRC_BK34_4B_L      FRC_PK_L_(0x34, 0x4B)
#define REG_FRC_BK34_4B_H      FRC_PK_H_(0x34, 0x4B)
#define REG_FRC_BK34_4C_L      FRC_PK_L_(0x34, 0x4C)
#define REG_FRC_BK34_4C_H      FRC_PK_H_(0x34, 0x4C)
#define REG_FRC_BK34_4D_L      FRC_PK_L_(0x34, 0x4D)
#define REG_FRC_BK34_4D_H      FRC_PK_H_(0x34, 0x4D)
#define REG_FRC_BK34_4E_L      FRC_PK_L_(0x34, 0x4E)
#define REG_FRC_BK34_4E_H      FRC_PK_H_(0x34, 0x4E)
#define REG_FRC_BK34_4F_L      FRC_PK_L_(0x34, 0x4F)
#define REG_FRC_BK34_4F_H      FRC_PK_H_(0x34, 0x4F)
#define REG_FRC_BK34_50_L      FRC_PK_L_(0x34, 0x50)
#define REG_FRC_BK34_50_H      FRC_PK_H_(0x34, 0x50)
#define REG_FRC_BK34_51_L      FRC_PK_L_(0x34, 0x51)
#define REG_FRC_BK34_51_H      FRC_PK_H_(0x34, 0x51)
#define REG_FRC_BK34_52_L      FRC_PK_L_(0x34, 0x52)
#define REG_FRC_BK34_52_H      FRC_PK_H_(0x34, 0x52)
#define REG_FRC_BK34_53_L      FRC_PK_L_(0x34, 0x53)
#define REG_FRC_BK34_53_H      FRC_PK_H_(0x34, 0x53)
#define REG_FRC_BK34_54_L      FRC_PK_L_(0x34, 0x54)
#define REG_FRC_BK34_54_H      FRC_PK_H_(0x34, 0x54)
#define REG_FRC_BK34_55_L      FRC_PK_L_(0x34, 0x55)
#define REG_FRC_BK34_55_H      FRC_PK_H_(0x34, 0x55)
#define REG_FRC_BK34_56_L      FRC_PK_L_(0x34, 0x56)
#define REG_FRC_BK34_56_H      FRC_PK_H_(0x34, 0x56)
#define REG_FRC_BK34_57_L      FRC_PK_L_(0x34, 0x57)
#define REG_FRC_BK34_57_H      FRC_PK_H_(0x34, 0x57)
#define REG_FRC_BK34_58_L      FRC_PK_L_(0x34, 0x58)
#define REG_FRC_BK34_58_H      FRC_PK_H_(0x34, 0x58)
#define REG_FRC_BK34_59_L      FRC_PK_L_(0x34, 0x59)
#define REG_FRC_BK34_59_H      FRC_PK_H_(0x34, 0x59)
#define REG_FRC_BK34_5A_L      FRC_PK_L_(0x34, 0x5A)
#define REG_FRC_BK34_5A_H      FRC_PK_H_(0x34, 0x5A)
#define REG_FRC_BK34_5B_L      FRC_PK_L_(0x34, 0x5B)
#define REG_FRC_BK34_5B_H      FRC_PK_H_(0x34, 0x5B)
#define REG_FRC_BK34_5C_L      FRC_PK_L_(0x34, 0x5C)
#define REG_FRC_BK34_5C_H      FRC_PK_H_(0x34, 0x5C)
#define REG_FRC_BK34_5D_L      FRC_PK_L_(0x34, 0x5D)
#define REG_FRC_BK34_5D_H      FRC_PK_H_(0x34, 0x5D)
#define REG_FRC_BK34_5E_L      FRC_PK_L_(0x34, 0x5E)
#define REG_FRC_BK34_5E_H      FRC_PK_H_(0x34, 0x5E)
#define REG_FRC_BK34_5F_L      FRC_PK_L_(0x34, 0x5F)
#define REG_FRC_BK34_5F_H      FRC_PK_H_(0x34, 0x5F)
#define REG_FRC_BK34_60_L      FRC_PK_L_(0x34, 0x60)
#define REG_FRC_BK34_60_H      FRC_PK_H_(0x34, 0x60)
#define REG_FRC_BK34_61_L      FRC_PK_L_(0x34, 0x61)
#define REG_FRC_BK34_61_H      FRC_PK_H_(0x34, 0x61)
#define REG_FRC_BK34_62_L      FRC_PK_L_(0x34, 0x62)
#define REG_FRC_BK34_62_H      FRC_PK_H_(0x34, 0x62)
#define REG_FRC_BK34_63_L      FRC_PK_L_(0x34, 0x63)
#define REG_FRC_BK34_63_H      FRC_PK_H_(0x34, 0x63)
#define REG_FRC_BK34_64_L      FRC_PK_L_(0x34, 0x64)
#define REG_FRC_BK34_64_H      FRC_PK_H_(0x34, 0x64)
#define REG_FRC_BK34_65_L      FRC_PK_L_(0x34, 0x65)
#define REG_FRC_BK34_65_H      FRC_PK_H_(0x34, 0x65)
#define REG_FRC_BK34_66_L      FRC_PK_L_(0x34, 0x66)
#define REG_FRC_BK34_66_H      FRC_PK_H_(0x34, 0x66)
#define REG_FRC_BK34_67_L      FRC_PK_L_(0x34, 0x67)
#define REG_FRC_BK34_67_H      FRC_PK_H_(0x34, 0x67)
#define REG_FRC_BK34_68_L      FRC_PK_L_(0x34, 0x68)
#define REG_FRC_BK34_68_H      FRC_PK_H_(0x34, 0x68)
#define REG_FRC_BK34_69_L      FRC_PK_L_(0x34, 0x69)
#define REG_FRC_BK34_69_H      FRC_PK_H_(0x34, 0x69)
#define REG_FRC_BK34_6A_L      FRC_PK_L_(0x34, 0x6A)
#define REG_FRC_BK34_6A_H      FRC_PK_H_(0x34, 0x6A)
#define REG_FRC_BK34_6B_L      FRC_PK_L_(0x34, 0x6B)
#define REG_FRC_BK34_6B_H      FRC_PK_H_(0x34, 0x6B)
#define REG_FRC_BK34_6C_L      FRC_PK_L_(0x34, 0x6C)
#define REG_FRC_BK34_6C_H      FRC_PK_H_(0x34, 0x6C)
#define REG_FRC_BK34_6D_L      FRC_PK_L_(0x34, 0x6D)
#define REG_FRC_BK34_6D_H      FRC_PK_H_(0x34, 0x6D)
#define REG_FRC_BK34_6E_L      FRC_PK_L_(0x34, 0x6E)
#define REG_FRC_BK34_6E_H      FRC_PK_H_(0x34, 0x6E)
#define REG_FRC_BK34_6F_L      FRC_PK_L_(0x34, 0x6F)
#define REG_FRC_BK34_6F_H      FRC_PK_H_(0x34, 0x6F)
#define REG_FRC_BK34_70_L      FRC_PK_L_(0x34, 0x70)
#define REG_FRC_BK34_70_H      FRC_PK_H_(0x34, 0x70)
#define REG_FRC_BK34_71_L      FRC_PK_L_(0x34, 0x71)
#define REG_FRC_BK34_71_H      FRC_PK_H_(0x34, 0x71)
#define REG_FRC_BK34_72_L      FRC_PK_L_(0x34, 0x72)
#define REG_FRC_BK34_72_H      FRC_PK_H_(0x34, 0x72)
#define REG_FRC_BK34_73_L      FRC_PK_L_(0x34, 0x73)
#define REG_FRC_BK34_73_H      FRC_PK_H_(0x34, 0x73)
#define REG_FRC_BK34_74_L      FRC_PK_L_(0x34, 0x74)
#define REG_FRC_BK34_74_H      FRC_PK_H_(0x34, 0x74)
#define REG_FRC_BK34_75_L      FRC_PK_L_(0x34, 0x75)
#define REG_FRC_BK34_75_H      FRC_PK_H_(0x34, 0x75)
#define REG_FRC_BK34_76_L      FRC_PK_L_(0x34, 0x76)
#define REG_FRC_BK34_76_H      FRC_PK_H_(0x34, 0x76)
#define REG_FRC_BK34_77_L      FRC_PK_L_(0x34, 0x77)
#define REG_FRC_BK34_77_H      FRC_PK_H_(0x34, 0x77)
#define REG_FRC_BK34_78_L      FRC_PK_L_(0x34, 0x78)
#define REG_FRC_BK34_78_H      FRC_PK_H_(0x34, 0x78)
#define REG_FRC_BK34_79_L      FRC_PK_L_(0x34, 0x79)
#define REG_FRC_BK34_79_H      FRC_PK_H_(0x34, 0x79)
#define REG_FRC_BK34_7A_L      FRC_PK_L_(0x34, 0x7A)
#define REG_FRC_BK34_7A_H      FRC_PK_H_(0x34, 0x7A)
#define REG_FRC_BK34_7B_L      FRC_PK_L_(0x34, 0x7B)
#define REG_FRC_BK34_7B_H      FRC_PK_H_(0x34, 0x7B)
#define REG_FRC_BK34_7C_L      FRC_PK_L_(0x34, 0x7C)
#define REG_FRC_BK34_7C_H      FRC_PK_H_(0x34, 0x7C)
#define REG_FRC_BK34_7D_L      FRC_PK_L_(0x34, 0x7D)
#define REG_FRC_BK34_7D_H      FRC_PK_H_(0x34, 0x7D)
#define REG_FRC_BK34_7E_L      FRC_PK_L_(0x34, 0x7E)
#define REG_FRC_BK34_7E_H      FRC_PK_H_(0x34, 0x7E)
#define REG_FRC_BK34_7F_L      FRC_PK_L_(0x34, 0x7F)
#define REG_FRC_BK34_7F_H      FRC_PK_H_(0x34, 0x7F)

//----------------------------------------------
//  BK36
//----------------------------------------------
#define REG_FRC_BK36_00_L      FRC_PK_L_(0x36, 0x00)
#define REG_FRC_BK36_00_H      FRC_PK_H_(0x36, 0x00)
#define REG_FRC_BK36_01_L      FRC_PK_L_(0x36, 0x01)
#define REG_FRC_BK36_01_H      FRC_PK_H_(0x36, 0x01)
#define REG_FRC_BK36_02_L      FRC_PK_L_(0x36, 0x02)
#define REG_FRC_BK36_02_H      FRC_PK_H_(0x36, 0x02)
#define REG_FRC_BK36_03_L      FRC_PK_L_(0x36, 0x03)
#define REG_FRC_BK36_03_H      FRC_PK_H_(0x36, 0x03)
#define REG_FRC_BK36_04_L      FRC_PK_L_(0x36, 0x04)
#define REG_FRC_BK36_04_H      FRC_PK_H_(0x36, 0x04)
#define REG_FRC_BK36_05_L      FRC_PK_L_(0x36, 0x05)
#define REG_FRC_BK36_05_H      FRC_PK_H_(0x36, 0x05)
#define REG_FRC_BK36_06_L      FRC_PK_L_(0x36, 0x06)
#define REG_FRC_BK36_06_H      FRC_PK_H_(0x36, 0x06)
#define REG_FRC_BK36_07_L      FRC_PK_L_(0x36, 0x07)
#define REG_FRC_BK36_07_H      FRC_PK_H_(0x36, 0x07)
#define REG_FRC_BK36_08_L      FRC_PK_L_(0x36, 0x08)
#define REG_FRC_BK36_08_H      FRC_PK_H_(0x36, 0x08)
#define REG_FRC_BK36_09_L      FRC_PK_L_(0x36, 0x09)
#define REG_FRC_BK36_09_H      FRC_PK_H_(0x36, 0x09)
#define REG_FRC_BK36_0A_L      FRC_PK_L_(0x36, 0x0A)
#define REG_FRC_BK36_0A_H      FRC_PK_H_(0x36, 0x0A)
#define REG_FRC_BK36_0B_L      FRC_PK_L_(0x36, 0x0B)
#define REG_FRC_BK36_0B_H      FRC_PK_H_(0x36, 0x0B)
#define REG_FRC_BK36_0C_L      FRC_PK_L_(0x36, 0x0C)
#define REG_FRC_BK36_0C_H      FRC_PK_H_(0x36, 0x0C)
#define REG_FRC_BK36_0D_L      FRC_PK_L_(0x36, 0x0D)
#define REG_FRC_BK36_0D_H      FRC_PK_H_(0x36, 0x0D)
#define REG_FRC_BK36_0E_L      FRC_PK_L_(0x36, 0x0E)
#define REG_FRC_BK36_0E_H      FRC_PK_H_(0x36, 0x0E)
#define REG_FRC_BK36_0F_L      FRC_PK_L_(0x36, 0x0F)
#define REG_FRC_BK36_0F_H      FRC_PK_H_(0x36, 0x0F)
#define REG_FRC_BK36_10_L      FRC_PK_L_(0x36, 0x10)
#define REG_FRC_BK36_10_H      FRC_PK_H_(0x36, 0x10)
#define REG_FRC_BK36_11_L      FRC_PK_L_(0x36, 0x11)
#define REG_FRC_BK36_11_H      FRC_PK_H_(0x36, 0x11)
#define REG_FRC_BK36_12_L      FRC_PK_L_(0x36, 0x12)
#define REG_FRC_BK36_12_H      FRC_PK_H_(0x36, 0x12)
#define REG_FRC_BK36_13_L      FRC_PK_L_(0x36, 0x13)
#define REG_FRC_BK36_13_H      FRC_PK_H_(0x36, 0x13)
#define REG_FRC_BK36_14_L      FRC_PK_L_(0x36, 0x14)
#define REG_FRC_BK36_14_H      FRC_PK_H_(0x36, 0x14)
#define REG_FRC_BK36_15_L      FRC_PK_L_(0x36, 0x15)
#define REG_FRC_BK36_15_H      FRC_PK_H_(0x36, 0x15)
#define REG_FRC_BK36_16_L      FRC_PK_L_(0x36, 0x16)
#define REG_FRC_BK36_16_H      FRC_PK_H_(0x36, 0x16)
#define REG_FRC_BK36_17_L      FRC_PK_L_(0x36, 0x17)
#define REG_FRC_BK36_17_H      FRC_PK_H_(0x36, 0x17)
#define REG_FRC_BK36_18_L      FRC_PK_L_(0x36, 0x18)
#define REG_FRC_BK36_18_H      FRC_PK_H_(0x36, 0x18)
#define REG_FRC_BK36_19_L      FRC_PK_L_(0x36, 0x19)
#define REG_FRC_BK36_19_H      FRC_PK_H_(0x36, 0x19)
#define REG_FRC_BK36_1A_L      FRC_PK_L_(0x36, 0x1A)
#define REG_FRC_BK36_1A_H      FRC_PK_H_(0x36, 0x1A)
#define REG_FRC_BK36_1B_L      FRC_PK_L_(0x36, 0x1B)
#define REG_FRC_BK36_1B_H      FRC_PK_H_(0x36, 0x1B)
#define REG_FRC_BK36_1C_L      FRC_PK_L_(0x36, 0x1C)
#define REG_FRC_BK36_1C_H      FRC_PK_H_(0x36, 0x1C)
#define REG_FRC_BK36_1D_L      FRC_PK_L_(0x36, 0x1D)
#define REG_FRC_BK36_1D_H      FRC_PK_H_(0x36, 0x1D)
#define REG_FRC_BK36_1E_L      FRC_PK_L_(0x36, 0x1E)
#define REG_FRC_BK36_1E_H      FRC_PK_H_(0x36, 0x1E)
#define REG_FRC_BK36_1F_L      FRC_PK_L_(0x36, 0x1F)
#define REG_FRC_BK36_1F_H      FRC_PK_H_(0x36, 0x1F)
#define REG_FRC_BK36_20_L      FRC_PK_L_(0x36, 0x20)
#define REG_FRC_BK36_20_H      FRC_PK_H_(0x36, 0x20)
#define REG_FRC_BK36_21_L      FRC_PK_L_(0x36, 0x21)
#define REG_FRC_BK36_21_H      FRC_PK_H_(0x36, 0x21)
#define REG_FRC_BK36_22_L      FRC_PK_L_(0x36, 0x22)
#define REG_FRC_BK36_22_H      FRC_PK_H_(0x36, 0x22)
#define REG_FRC_BK36_23_L      FRC_PK_L_(0x36, 0x23)
#define REG_FRC_BK36_23_H      FRC_PK_H_(0x36, 0x23)
#define REG_FRC_BK36_24_L      FRC_PK_L_(0x36, 0x24)
#define REG_FRC_BK36_24_H      FRC_PK_H_(0x36, 0x24)
#define REG_FRC_BK36_25_L      FRC_PK_L_(0x36, 0x25)
#define REG_FRC_BK36_25_H      FRC_PK_H_(0x36, 0x25)
#define REG_FRC_BK36_26_L      FRC_PK_L_(0x36, 0x26)
#define REG_FRC_BK36_26_H      FRC_PK_H_(0x36, 0x26)
#define REG_FRC_BK36_27_L      FRC_PK_L_(0x36, 0x27)
#define REG_FRC_BK36_27_H      FRC_PK_H_(0x36, 0x27)
#define REG_FRC_BK36_28_L      FRC_PK_L_(0x36, 0x28)
#define REG_FRC_BK36_28_H      FRC_PK_H_(0x36, 0x28)
#define REG_FRC_BK36_29_L      FRC_PK_L_(0x36, 0x29)
#define REG_FRC_BK36_29_H      FRC_PK_H_(0x36, 0x29)
#define REG_FRC_BK36_2A_L      FRC_PK_L_(0x36, 0x2A)
#define REG_FRC_BK36_2A_H      FRC_PK_H_(0x36, 0x2A)
#define REG_FRC_BK36_2B_L      FRC_PK_L_(0x36, 0x2B)
#define REG_FRC_BK36_2B_H      FRC_PK_H_(0x36, 0x2B)
#define REG_FRC_BK36_2C_L      FRC_PK_L_(0x36, 0x2C)
#define REG_FRC_BK36_2C_H      FRC_PK_H_(0x36, 0x2C)
#define REG_FRC_BK36_2D_L      FRC_PK_L_(0x36, 0x2D)
#define REG_FRC_BK36_2D_H      FRC_PK_H_(0x36, 0x2D)
#define REG_FRC_BK36_2E_L      FRC_PK_L_(0x36, 0x2E)
#define REG_FRC_BK36_2E_H      FRC_PK_H_(0x36, 0x2E)
#define REG_FRC_BK36_2F_L      FRC_PK_L_(0x36, 0x2F)
#define REG_FRC_BK36_2F_H      FRC_PK_H_(0x36, 0x2F)
#define REG_FRC_BK36_30_L      FRC_PK_L_(0x36, 0x30)
#define REG_FRC_BK36_30_H      FRC_PK_H_(0x36, 0x30)
#define REG_FRC_BK36_31_L      FRC_PK_L_(0x36, 0x31)
#define REG_FRC_BK36_31_H      FRC_PK_H_(0x36, 0x31)
#define REG_FRC_BK36_32_L      FRC_PK_L_(0x36, 0x32)
#define REG_FRC_BK36_32_H      FRC_PK_H_(0x36, 0x32)
#define REG_FRC_BK36_33_L      FRC_PK_L_(0x36, 0x33)
#define REG_FRC_BK36_33_H      FRC_PK_H_(0x36, 0x33)
#define REG_FRC_BK36_34_L      FRC_PK_L_(0x36, 0x34)
#define REG_FRC_BK36_34_H      FRC_PK_H_(0x36, 0x34)
#define REG_FRC_BK36_35_L      FRC_PK_L_(0x36, 0x35)
#define REG_FRC_BK36_35_H      FRC_PK_H_(0x36, 0x35)
#define REG_FRC_BK36_36_L      FRC_PK_L_(0x36, 0x36)
#define REG_FRC_BK36_36_H      FRC_PK_H_(0x36, 0x36)
#define REG_FRC_BK36_37_L      FRC_PK_L_(0x36, 0x37)
#define REG_FRC_BK36_37_H      FRC_PK_H_(0x36, 0x37)
#define REG_FRC_BK36_38_L      FRC_PK_L_(0x36, 0x38)
#define REG_FRC_BK36_38_H      FRC_PK_H_(0x36, 0x38)
#define REG_FRC_BK36_39_L      FRC_PK_L_(0x36, 0x39)
#define REG_FRC_BK36_39_H      FRC_PK_H_(0x36, 0x39)
#define REG_FRC_BK36_3A_L      FRC_PK_L_(0x36, 0x3A)
#define REG_FRC_BK36_3A_H      FRC_PK_H_(0x36, 0x3A)
#define REG_FRC_BK36_3B_L      FRC_PK_L_(0x36, 0x3B)
#define REG_FRC_BK36_3B_H      FRC_PK_H_(0x36, 0x3B)
#define REG_FRC_BK36_3C_L      FRC_PK_L_(0x36, 0x3C)
#define REG_FRC_BK36_3C_H      FRC_PK_H_(0x36, 0x3C)
#define REG_FRC_BK36_3D_L      FRC_PK_L_(0x36, 0x3D)
#define REG_FRC_BK36_3D_H      FRC_PK_H_(0x36, 0x3D)
#define REG_FRC_BK36_3E_L      FRC_PK_L_(0x36, 0x3E)
#define REG_FRC_BK36_3E_H      FRC_PK_H_(0x36, 0x3E)
#define REG_FRC_BK36_3F_L      FRC_PK_L_(0x36, 0x3F)
#define REG_FRC_BK36_3F_H      FRC_PK_H_(0x36, 0x3F)
#define REG_FRC_BK36_40_L      FRC_PK_L_(0x36, 0x40)
#define REG_FRC_BK36_40_H      FRC_PK_H_(0x36, 0x40)
#define REG_FRC_BK36_41_L      FRC_PK_L_(0x36, 0x41)
#define REG_FRC_BK36_41_H      FRC_PK_H_(0x36, 0x41)
#define REG_FRC_BK36_42_L      FRC_PK_L_(0x36, 0x42)
#define REG_FRC_BK36_42_H      FRC_PK_H_(0x36, 0x42)
#define REG_FRC_BK36_43_L      FRC_PK_L_(0x36, 0x43)
#define REG_FRC_BK36_43_H      FRC_PK_H_(0x36, 0x43)
#define REG_FRC_BK36_44_L      FRC_PK_L_(0x36, 0x44)
#define REG_FRC_BK36_44_H      FRC_PK_H_(0x36, 0x44)
#define REG_FRC_BK36_45_L      FRC_PK_L_(0x36, 0x45)
#define REG_FRC_BK36_45_H      FRC_PK_H_(0x36, 0x45)
#define REG_FRC_BK36_46_L      FRC_PK_L_(0x36, 0x46)
#define REG_FRC_BK36_46_H      FRC_PK_H_(0x36, 0x46)
#define REG_FRC_BK36_47_L      FRC_PK_L_(0x36, 0x47)
#define REG_FRC_BK36_47_H      FRC_PK_H_(0x36, 0x47)
#define REG_FRC_BK36_48_L      FRC_PK_L_(0x36, 0x48)
#define REG_FRC_BK36_48_H      FRC_PK_H_(0x36, 0x48)
#define REG_FRC_BK36_49_L      FRC_PK_L_(0x36, 0x49)
#define REG_FRC_BK36_49_H      FRC_PK_H_(0x36, 0x49)
#define REG_FRC_BK36_4A_L      FRC_PK_L_(0x36, 0x4A)
#define REG_FRC_BK36_4A_H      FRC_PK_H_(0x36, 0x4A)
#define REG_FRC_BK36_4B_L      FRC_PK_L_(0x36, 0x4B)
#define REG_FRC_BK36_4B_H      FRC_PK_H_(0x36, 0x4B)
#define REG_FRC_BK36_4C_L      FRC_PK_L_(0x36, 0x4C)
#define REG_FRC_BK36_4C_H      FRC_PK_H_(0x36, 0x4C)
#define REG_FRC_BK36_4D_L      FRC_PK_L_(0x36, 0x4D)
#define REG_FRC_BK36_4D_H      FRC_PK_H_(0x36, 0x4D)
#define REG_FRC_BK36_4E_L      FRC_PK_L_(0x36, 0x4E)
#define REG_FRC_BK36_4E_H      FRC_PK_H_(0x36, 0x4E)
#define REG_FRC_BK36_4F_L      FRC_PK_L_(0x36, 0x4F)
#define REG_FRC_BK36_4F_H      FRC_PK_H_(0x36, 0x4F)
#define REG_FRC_BK36_50_L      FRC_PK_L_(0x36, 0x50)
#define REG_FRC_BK36_50_H      FRC_PK_H_(0x36, 0x50)
#define REG_FRC_BK36_51_L      FRC_PK_L_(0x36, 0x51)
#define REG_FRC_BK36_51_H      FRC_PK_H_(0x36, 0x51)
#define REG_FRC_BK36_52_L      FRC_PK_L_(0x36, 0x52)
#define REG_FRC_BK36_52_H      FRC_PK_H_(0x36, 0x52)
#define REG_FRC_BK36_53_L      FRC_PK_L_(0x36, 0x53)
#define REG_FRC_BK36_53_H      FRC_PK_H_(0x36, 0x53)
#define REG_FRC_BK36_54_L      FRC_PK_L_(0x36, 0x54)
#define REG_FRC_BK36_54_H      FRC_PK_H_(0x36, 0x54)
#define REG_FRC_BK36_55_L      FRC_PK_L_(0x36, 0x55)
#define REG_FRC_BK36_55_H      FRC_PK_H_(0x36, 0x55)
#define REG_FRC_BK36_56_L      FRC_PK_L_(0x36, 0x56)
#define REG_FRC_BK36_56_H      FRC_PK_H_(0x36, 0x56)
#define REG_FRC_BK36_57_L      FRC_PK_L_(0x36, 0x57)
#define REG_FRC_BK36_57_H      FRC_PK_H_(0x36, 0x57)
#define REG_FRC_BK36_58_L      FRC_PK_L_(0x36, 0x58)
#define REG_FRC_BK36_58_H      FRC_PK_H_(0x36, 0x58)
#define REG_FRC_BK36_59_L      FRC_PK_L_(0x36, 0x59)
#define REG_FRC_BK36_59_H      FRC_PK_H_(0x36, 0x59)
#define REG_FRC_BK36_5A_L      FRC_PK_L_(0x36, 0x5A)
#define REG_FRC_BK36_5A_H      FRC_PK_H_(0x36, 0x5A)
#define REG_FRC_BK36_5B_L      FRC_PK_L_(0x36, 0x5B)
#define REG_FRC_BK36_5B_H      FRC_PK_H_(0x36, 0x5B)
#define REG_FRC_BK36_5C_L      FRC_PK_L_(0x36, 0x5C)
#define REG_FRC_BK36_5C_H      FRC_PK_H_(0x36, 0x5C)
#define REG_FRC_BK36_5D_L      FRC_PK_L_(0x36, 0x5D)
#define REG_FRC_BK36_5D_H      FRC_PK_H_(0x36, 0x5D)
#define REG_FRC_BK36_5E_L      FRC_PK_L_(0x36, 0x5E)
#define REG_FRC_BK36_5E_H      FRC_PK_H_(0x36, 0x5E)
#define REG_FRC_BK36_5F_L      FRC_PK_L_(0x36, 0x5F)
#define REG_FRC_BK36_5F_H      FRC_PK_H_(0x36, 0x5F)
#define REG_FRC_BK36_60_L      FRC_PK_L_(0x36, 0x60)
#define REG_FRC_BK36_60_H      FRC_PK_H_(0x36, 0x60)
#define REG_FRC_BK36_61_L      FRC_PK_L_(0x36, 0x61)
#define REG_FRC_BK36_61_H      FRC_PK_H_(0x36, 0x61)
#define REG_FRC_BK36_62_L      FRC_PK_L_(0x36, 0x62)
#define REG_FRC_BK36_62_H      FRC_PK_H_(0x36, 0x62)
#define REG_FRC_BK36_63_L      FRC_PK_L_(0x36, 0x63)
#define REG_FRC_BK36_63_H      FRC_PK_H_(0x36, 0x63)
#define REG_FRC_BK36_64_L      FRC_PK_L_(0x36, 0x64)
#define REG_FRC_BK36_64_H      FRC_PK_H_(0x36, 0x64)
#define REG_FRC_BK36_65_L      FRC_PK_L_(0x36, 0x65)
#define REG_FRC_BK36_65_H      FRC_PK_H_(0x36, 0x65)
#define REG_FRC_BK36_66_L      FRC_PK_L_(0x36, 0x66)
#define REG_FRC_BK36_66_H      FRC_PK_H_(0x36, 0x66)
#define REG_FRC_BK36_67_L      FRC_PK_L_(0x36, 0x67)
#define REG_FRC_BK36_67_H      FRC_PK_H_(0x36, 0x67)
#define REG_FRC_BK36_68_L      FRC_PK_L_(0x36, 0x68)
#define REG_FRC_BK36_68_H      FRC_PK_H_(0x36, 0x68)
#define REG_FRC_BK36_69_L      FRC_PK_L_(0x36, 0x69)
#define REG_FRC_BK36_69_H      FRC_PK_H_(0x36, 0x69)
#define REG_FRC_BK36_6A_L      FRC_PK_L_(0x36, 0x6A)
#define REG_FRC_BK36_6A_H      FRC_PK_H_(0x36, 0x6A)
#define REG_FRC_BK36_6B_L      FRC_PK_L_(0x36, 0x6B)
#define REG_FRC_BK36_6B_H      FRC_PK_H_(0x36, 0x6B)
#define REG_FRC_BK36_6C_L      FRC_PK_L_(0x36, 0x6C)
#define REG_FRC_BK36_6C_H      FRC_PK_H_(0x36, 0x6C)
#define REG_FRC_BK36_6D_L      FRC_PK_L_(0x36, 0x6D)
#define REG_FRC_BK36_6D_H      FRC_PK_H_(0x36, 0x6D)
#define REG_FRC_BK36_6E_L      FRC_PK_L_(0x36, 0x6E)
#define REG_FRC_BK36_6E_H      FRC_PK_H_(0x36, 0x6E)
#define REG_FRC_BK36_6F_L      FRC_PK_L_(0x36, 0x6F)
#define REG_FRC_BK36_6F_H      FRC_PK_H_(0x36, 0x6F)
#define REG_FRC_BK36_70_L      FRC_PK_L_(0x36, 0x70)
#define REG_FRC_BK36_70_H      FRC_PK_H_(0x36, 0x70)
#define REG_FRC_BK36_71_L      FRC_PK_L_(0x36, 0x71)
#define REG_FRC_BK36_71_H      FRC_PK_H_(0x36, 0x71)
#define REG_FRC_BK36_72_L      FRC_PK_L_(0x36, 0x72)
#define REG_FRC_BK36_72_H      FRC_PK_H_(0x36, 0x72)
#define REG_FRC_BK36_73_L      FRC_PK_L_(0x36, 0x73)
#define REG_FRC_BK36_73_H      FRC_PK_H_(0x36, 0x73)
#define REG_FRC_BK36_74_L      FRC_PK_L_(0x36, 0x74)
#define REG_FRC_BK36_74_H      FRC_PK_H_(0x36, 0x74)
#define REG_FRC_BK36_75_L      FRC_PK_L_(0x36, 0x75)
#define REG_FRC_BK36_75_H      FRC_PK_H_(0x36, 0x75)
#define REG_FRC_BK36_76_L      FRC_PK_L_(0x36, 0x76)
#define REG_FRC_BK36_76_H      FRC_PK_H_(0x36, 0x76)
#define REG_FRC_BK36_77_L      FRC_PK_L_(0x36, 0x77)
#define REG_FRC_BK36_77_H      FRC_PK_H_(0x36, 0x77)
#define REG_FRC_BK36_78_L      FRC_PK_L_(0x36, 0x78)
#define REG_FRC_BK36_78_H      FRC_PK_H_(0x36, 0x78)
#define REG_FRC_BK36_79_L      FRC_PK_L_(0x36, 0x79)
#define REG_FRC_BK36_79_H      FRC_PK_H_(0x36, 0x79)
#define REG_FRC_BK36_7A_L      FRC_PK_L_(0x36, 0x7A)
#define REG_FRC_BK36_7A_H      FRC_PK_H_(0x36, 0x7A)
#define REG_FRC_BK36_7B_L      FRC_PK_L_(0x36, 0x7B)
#define REG_FRC_BK36_7B_H      FRC_PK_H_(0x36, 0x7B)
#define REG_FRC_BK36_7C_L      FRC_PK_L_(0x36, 0x7C)
#define REG_FRC_BK36_7C_H      FRC_PK_H_(0x36, 0x7C)
#define REG_FRC_BK36_7D_L      FRC_PK_L_(0x36, 0x7D)
#define REG_FRC_BK36_7D_H      FRC_PK_H_(0x36, 0x7D)
#define REG_FRC_BK36_7E_L      FRC_PK_L_(0x36, 0x7E)
#define REG_FRC_BK36_7E_H      FRC_PK_H_(0x36, 0x7E)
#define REG_FRC_BK36_7F_L      FRC_PK_L_(0x36, 0x7F)
#define REG_FRC_BK36_7F_H      FRC_PK_H_(0x36, 0x7F)

//----------------------------------------------
//  BK3A -> BK23A
//----------------------------------------------
#define REG_FRC_BK23A_00_L      FRC_PK_L_(0x23A, 0x00)
#define REG_FRC_BK23A_00_H      FRC_PK_H_(0x23A, 0x00)
#define REG_FRC_BK23A_01_L      FRC_PK_L_(0x23A, 0x01)
#define REG_FRC_BK23A_01_H      FRC_PK_H_(0x23A, 0x01)
#define REG_FRC_BK23A_02_L      FRC_PK_L_(0x23A, 0x02)
#define REG_FRC_BK23A_02_H      FRC_PK_H_(0x23A, 0x02)
#define REG_FRC_BK23A_03_L      FRC_PK_L_(0x23A, 0x03)
#define REG_FRC_BK23A_03_H      FRC_PK_H_(0x23A, 0x03)
#define REG_FRC_BK23A_04_L      FRC_PK_L_(0x23A, 0x04)
#define REG_FRC_BK23A_04_H      FRC_PK_H_(0x23A, 0x04)
#define REG_FRC_BK23A_05_L      FRC_PK_L_(0x23A, 0x05)
#define REG_FRC_BK23A_05_H      FRC_PK_H_(0x23A, 0x05)
#define REG_FRC_BK23A_06_L      FRC_PK_L_(0x23A, 0x06)
#define REG_FRC_BK23A_06_H      FRC_PK_H_(0x23A, 0x06)
#define REG_FRC_BK23A_07_L      FRC_PK_L_(0x23A, 0x07)
#define REG_FRC_BK23A_07_H      FRC_PK_H_(0x23A, 0x07)
#define REG_FRC_BK23A_08_L      FRC_PK_L_(0x23A, 0x08)
#define REG_FRC_BK23A_08_H      FRC_PK_H_(0x23A, 0x08)
#define REG_FRC_BK23A_09_L      FRC_PK_L_(0x23A, 0x09)
#define REG_FRC_BK23A_09_H      FRC_PK_H_(0x23A, 0x09)
#define REG_FRC_BK23A_0A_L      FRC_PK_L_(0x23A, 0x0A)
#define REG_FRC_BK23A_0A_H      FRC_PK_H_(0x23A, 0x0A)
#define REG_FRC_BK23A_0B_L      FRC_PK_L_(0x23A, 0x0B)
#define REG_FRC_BK23A_0B_H      FRC_PK_H_(0x23A, 0x0B)
#define REG_FRC_BK23A_0C_L      FRC_PK_L_(0x23A, 0x0C)
#define REG_FRC_BK23A_0C_H      FRC_PK_H_(0x23A, 0x0C)
#define REG_FRC_BK23A_0D_L      FRC_PK_L_(0x23A, 0x0D)
#define REG_FRC_BK23A_0D_H      FRC_PK_H_(0x23A, 0x0D)
#define REG_FRC_BK23A_0E_L      FRC_PK_L_(0x23A, 0x0E)
#define REG_FRC_BK23A_0E_H      FRC_PK_H_(0x23A, 0x0E)
#define REG_FRC_BK23A_0F_L      FRC_PK_L_(0x23A, 0x0F)
#define REG_FRC_BK23A_0F_H      FRC_PK_H_(0x23A, 0x0F)
#define REG_FRC_BK23A_10_L      FRC_PK_L_(0x23A, 0x10)
#define REG_FRC_BK23A_10_H      FRC_PK_H_(0x23A, 0x10)
#define REG_FRC_BK23A_11_L      FRC_PK_L_(0x23A, 0x11)
#define REG_FRC_BK23A_11_H      FRC_PK_H_(0x23A, 0x11)
#define REG_FRC_BK23A_12_L      FRC_PK_L_(0x23A, 0x12)
#define REG_FRC_BK23A_12_H      FRC_PK_H_(0x23A, 0x12)
#define REG_FRC_BK23A_13_L      FRC_PK_L_(0x23A, 0x13)
#define REG_FRC_BK23A_13_H      FRC_PK_H_(0x23A, 0x13)
#define REG_FRC_BK23A_14_L      FRC_PK_L_(0x23A, 0x14)
#define REG_FRC_BK23A_14_H      FRC_PK_H_(0x23A, 0x14)
#define REG_FRC_BK23A_15_L      FRC_PK_L_(0x23A, 0x15)
#define REG_FRC_BK23A_15_H      FRC_PK_H_(0x23A, 0x15)
#define REG_FRC_BK23A_16_L      FRC_PK_L_(0x23A, 0x16)
#define REG_FRC_BK23A_16_H      FRC_PK_H_(0x23A, 0x16)
#define REG_FRC_BK23A_17_L      FRC_PK_L_(0x23A, 0x17)
#define REG_FRC_BK23A_17_H      FRC_PK_H_(0x23A, 0x17)
#define REG_FRC_BK23A_18_L      FRC_PK_L_(0x23A, 0x18)
#define REG_FRC_BK23A_18_H      FRC_PK_H_(0x23A, 0x18)
#define REG_FRC_BK23A_19_L      FRC_PK_L_(0x23A, 0x19)
#define REG_FRC_BK23A_19_H      FRC_PK_H_(0x23A, 0x19)
#define REG_FRC_BK23A_1A_L      FRC_PK_L_(0x23A, 0x1A)
#define REG_FRC_BK23A_1A_H      FRC_PK_H_(0x23A, 0x1A)
#define REG_FRC_BK23A_1B_L      FRC_PK_L_(0x23A, 0x1B)
#define REG_FRC_BK23A_1B_H      FRC_PK_H_(0x23A, 0x1B)
#define REG_FRC_BK23A_1C_L      FRC_PK_L_(0x23A, 0x1C)
#define REG_FRC_BK23A_1C_H      FRC_PK_H_(0x23A, 0x1C)
#define REG_FRC_BK23A_1D_L      FRC_PK_L_(0x23A, 0x1D)
#define REG_FRC_BK23A_1D_H      FRC_PK_H_(0x23A, 0x1D)
#define REG_FRC_BK23A_1E_L      FRC_PK_L_(0x23A, 0x1E)
#define REG_FRC_BK23A_1E_H      FRC_PK_H_(0x23A, 0x1E)
#define REG_FRC_BK23A_1F_L      FRC_PK_L_(0x23A, 0x1F)
#define REG_FRC_BK23A_1F_H      FRC_PK_H_(0x23A, 0x1F)
#define REG_FRC_BK23A_20_L      FRC_PK_L_(0x23A, 0x20)
#define REG_FRC_BK23A_20_H      FRC_PK_H_(0x23A, 0x20)
#define REG_FRC_BK23A_21_L      FRC_PK_L_(0x23A, 0x21)
#define REG_FRC_BK23A_21_H      FRC_PK_H_(0x23A, 0x21)
#define REG_FRC_BK23A_22_L      FRC_PK_L_(0x23A, 0x22)
#define REG_FRC_BK23A_22_H      FRC_PK_H_(0x23A, 0x22)
#define REG_FRC_BK23A_23_L      FRC_PK_L_(0x23A, 0x23)
#define REG_FRC_BK23A_23_H      FRC_PK_H_(0x23A, 0x23)
#define REG_FRC_BK23A_24_L      FRC_PK_L_(0x23A, 0x24)
#define REG_FRC_BK23A_24_H      FRC_PK_H_(0x23A, 0x24)
#define REG_FRC_BK23A_25_L      FRC_PK_L_(0x23A, 0x25)
#define REG_FRC_BK23A_25_H      FRC_PK_H_(0x23A, 0x25)
#define REG_FRC_BK23A_26_L      FRC_PK_L_(0x23A, 0x26)
#define REG_FRC_BK23A_26_H      FRC_PK_H_(0x23A, 0x26)
#define REG_FRC_BK23A_27_L      FRC_PK_L_(0x23A, 0x27)
#define REG_FRC_BK23A_27_H      FRC_PK_H_(0x23A, 0x27)
#define REG_FRC_BK23A_28_L      FRC_PK_L_(0x23A, 0x28)
#define REG_FRC_BK23A_28_H      FRC_PK_H_(0x23A, 0x28)
#define REG_FRC_BK23A_29_L      FRC_PK_L_(0x23A, 0x29)
#define REG_FRC_BK23A_29_H      FRC_PK_H_(0x23A, 0x29)
#define REG_FRC_BK23A_2A_L      FRC_PK_L_(0x23A, 0x2A)
#define REG_FRC_BK23A_2A_H      FRC_PK_H_(0x23A, 0x2A)
#define REG_FRC_BK23A_2B_L      FRC_PK_L_(0x23A, 0x2B)
#define REG_FRC_BK23A_2B_H      FRC_PK_H_(0x23A, 0x2B)
#define REG_FRC_BK23A_2C_L      FRC_PK_L_(0x23A, 0x2C)
#define REG_FRC_BK23A_2C_H      FRC_PK_H_(0x23A, 0x2C)
#define REG_FRC_BK23A_2D_L      FRC_PK_L_(0x23A, 0x2D)
#define REG_FRC_BK23A_2D_H      FRC_PK_H_(0x23A, 0x2D)
#define REG_FRC_BK23A_2E_L      FRC_PK_L_(0x23A, 0x2E)
#define REG_FRC_BK23A_2E_H      FRC_PK_H_(0x23A, 0x2E)
#define REG_FRC_BK23A_2F_L      FRC_PK_L_(0x23A, 0x2F)
#define REG_FRC_BK23A_2F_H      FRC_PK_H_(0x23A, 0x2F)
#define REG_FRC_BK23A_30_L      FRC_PK_L_(0x23A, 0x30)
#define REG_FRC_BK23A_30_H      FRC_PK_H_(0x23A, 0x30)
#define REG_FRC_BK23A_31_L      FRC_PK_L_(0x23A, 0x31)
#define REG_FRC_BK23A_31_H      FRC_PK_H_(0x23A, 0x31)
#define REG_FRC_BK23A_32_L      FRC_PK_L_(0x23A, 0x32)
#define REG_FRC_BK23A_32_H      FRC_PK_H_(0x23A, 0x32)
#define REG_FRC_BK23A_33_L      FRC_PK_L_(0x23A, 0x33)
#define REG_FRC_BK23A_33_H      FRC_PK_H_(0x23A, 0x33)
#define REG_FRC_BK23A_34_L      FRC_PK_L_(0x23A, 0x34)
#define REG_FRC_BK23A_34_H      FRC_PK_H_(0x23A, 0x34)
#define REG_FRC_BK23A_35_L      FRC_PK_L_(0x23A, 0x35)
#define REG_FRC_BK23A_35_H      FRC_PK_H_(0x23A, 0x35)
#define REG_FRC_BK23A_36_L      FRC_PK_L_(0x23A, 0x36)
#define REG_FRC_BK23A_36_H      FRC_PK_H_(0x23A, 0x36)
#define REG_FRC_BK23A_37_L      FRC_PK_L_(0x23A, 0x37)
#define REG_FRC_BK23A_37_H      FRC_PK_H_(0x23A, 0x37)
#define REG_FRC_BK23A_38_L      FRC_PK_L_(0x23A, 0x38)
#define REG_FRC_BK23A_38_H      FRC_PK_H_(0x23A, 0x38)
#define REG_FRC_BK23A_39_L      FRC_PK_L_(0x23A, 0x39)
#define REG_FRC_BK23A_39_H      FRC_PK_H_(0x23A, 0x39)
#define REG_FRC_BK23A_3A_L      FRC_PK_L_(0x23A, 0x3A)
#define REG_FRC_BK23A_3A_H      FRC_PK_H_(0x23A, 0x3A)
#define REG_FRC_BK23A_3B_L      FRC_PK_L_(0x23A, 0x3B)
#define REG_FRC_BK23A_3B_H      FRC_PK_H_(0x23A, 0x3B)
#define REG_FRC_BK23A_3C_L      FRC_PK_L_(0x23A, 0x3C)
#define REG_FRC_BK23A_3C_H      FRC_PK_H_(0x23A, 0x3C)
#define REG_FRC_BK23A_3D_L      FRC_PK_L_(0x23A, 0x3D)
#define REG_FRC_BK23A_3D_H      FRC_PK_H_(0x23A, 0x3D)
#define REG_FRC_BK23A_3E_L      FRC_PK_L_(0x23A, 0x3E)
#define REG_FRC_BK23A_3E_H      FRC_PK_H_(0x23A, 0x3E)
#define REG_FRC_BK23A_3F_L      FRC_PK_L_(0x23A, 0x3F)
#define REG_FRC_BK23A_3F_H      FRC_PK_H_(0x23A, 0x3F)
#define REG_FRC_BK23A_40_L      FRC_PK_L_(0x23A, 0x40)
#define REG_FRC_BK23A_40_H      FRC_PK_H_(0x23A, 0x40)
#define REG_FRC_BK23A_41_L      FRC_PK_L_(0x23A, 0x41)
#define REG_FRC_BK23A_41_H      FRC_PK_H_(0x23A, 0x41)
#define REG_FRC_BK23A_42_L      FRC_PK_L_(0x23A, 0x42)
#define REG_FRC_BK23A_42_H      FRC_PK_H_(0x23A, 0x42)
#define REG_FRC_BK23A_43_L      FRC_PK_L_(0x23A, 0x43)
#define REG_FRC_BK23A_43_H      FRC_PK_H_(0x23A, 0x43)
#define REG_FRC_BK23A_44_L      FRC_PK_L_(0x23A, 0x44)
#define REG_FRC_BK23A_44_H      FRC_PK_H_(0x23A, 0x44)
#define REG_FRC_BK23A_45_L      FRC_PK_L_(0x23A, 0x45)
#define REG_FRC_BK23A_45_H      FRC_PK_H_(0x23A, 0x45)
#define REG_FRC_BK23A_46_L      FRC_PK_L_(0x23A, 0x46)
#define REG_FRC_BK23A_46_H      FRC_PK_H_(0x23A, 0x46)
#define REG_FRC_BK23A_47_L      FRC_PK_L_(0x23A, 0x47)
#define REG_FRC_BK23A_47_H      FRC_PK_H_(0x23A, 0x47)
#define REG_FRC_BK23A_48_L      FRC_PK_L_(0x23A, 0x48)
#define REG_FRC_BK23A_48_H      FRC_PK_H_(0x23A, 0x48)
#define REG_FRC_BK23A_49_L      FRC_PK_L_(0x23A, 0x49)
#define REG_FRC_BK23A_49_H      FRC_PK_H_(0x23A, 0x49)
#define REG_FRC_BK23A_4A_L      FRC_PK_L_(0x23A, 0x4A)
#define REG_FRC_BK23A_4A_H      FRC_PK_H_(0x23A, 0x4A)
#define REG_FRC_BK23A_4B_L      FRC_PK_L_(0x23A, 0x4B)
#define REG_FRC_BK23A_4B_H      FRC_PK_H_(0x23A, 0x4B)
#define REG_FRC_BK23A_4C_L      FRC_PK_L_(0x23A, 0x4C)
#define REG_FRC_BK23A_4C_H      FRC_PK_H_(0x23A, 0x4C)
#define REG_FRC_BK23A_4D_L      FRC_PK_L_(0x23A, 0x4D)
#define REG_FRC_BK23A_4D_H      FRC_PK_H_(0x23A, 0x4D)
#define REG_FRC_BK23A_4E_L      FRC_PK_L_(0x23A, 0x4E)
#define REG_FRC_BK23A_4E_H      FRC_PK_H_(0x23A, 0x4E)
#define REG_FRC_BK23A_4F_L      FRC_PK_L_(0x23A, 0x4F)
#define REG_FRC_BK23A_4F_H      FRC_PK_H_(0x23A, 0x4F)
#define REG_FRC_BK23A_50_L      FRC_PK_L_(0x23A, 0x50)
#define REG_FRC_BK23A_50_H      FRC_PK_H_(0x23A, 0x50)
#define REG_FRC_BK23A_51_L      FRC_PK_L_(0x23A, 0x51)
#define REG_FRC_BK23A_51_H      FRC_PK_H_(0x23A, 0x51)
#define REG_FRC_BK23A_52_L      FRC_PK_L_(0x23A, 0x52)
#define REG_FRC_BK23A_52_H      FRC_PK_H_(0x23A, 0x52)
#define REG_FRC_BK23A_53_L      FRC_PK_L_(0x23A, 0x53)
#define REG_FRC_BK23A_53_H      FRC_PK_H_(0x23A, 0x53)
#define REG_FRC_BK23A_54_L      FRC_PK_L_(0x23A, 0x54)
#define REG_FRC_BK23A_54_H      FRC_PK_H_(0x23A, 0x54)
#define REG_FRC_BK23A_55_L      FRC_PK_L_(0x23A, 0x55)
#define REG_FRC_BK23A_55_H      FRC_PK_H_(0x23A, 0x55)
#define REG_FRC_BK23A_56_L      FRC_PK_L_(0x23A, 0x56)
#define REG_FRC_BK23A_56_H      FRC_PK_H_(0x23A, 0x56)
#define REG_FRC_BK23A_57_L      FRC_PK_L_(0x23A, 0x57)
#define REG_FRC_BK23A_57_H      FRC_PK_H_(0x23A, 0x57)
#define REG_FRC_BK23A_58_L      FRC_PK_L_(0x23A, 0x58)
#define REG_FRC_BK23A_58_H      FRC_PK_H_(0x23A, 0x58)
#define REG_FRC_BK23A_59_L      FRC_PK_L_(0x23A, 0x59)
#define REG_FRC_BK23A_59_H      FRC_PK_H_(0x23A, 0x59)
#define REG_FRC_BK23A_5A_L      FRC_PK_L_(0x23A, 0x5A)
#define REG_FRC_BK23A_5A_H      FRC_PK_H_(0x23A, 0x5A)
#define REG_FRC_BK23A_5B_L      FRC_PK_L_(0x23A, 0x5B)
#define REG_FRC_BK23A_5B_H      FRC_PK_H_(0x23A, 0x5B)
#define REG_FRC_BK23A_5C_L      FRC_PK_L_(0x23A, 0x5C)
#define REG_FRC_BK23A_5C_H      FRC_PK_H_(0x23A, 0x5C)
#define REG_FRC_BK23A_5D_L      FRC_PK_L_(0x23A, 0x5D)
#define REG_FRC_BK23A_5D_H      FRC_PK_H_(0x23A, 0x5D)
#define REG_FRC_BK23A_5E_L      FRC_PK_L_(0x23A, 0x5E)
#define REG_FRC_BK23A_5E_H      FRC_PK_H_(0x23A, 0x5E)
#define REG_FRC_BK23A_5F_L      FRC_PK_L_(0x23A, 0x5F)
#define REG_FRC_BK23A_5F_H      FRC_PK_H_(0x23A, 0x5F)
#define REG_FRC_BK23A_60_L      FRC_PK_L_(0x23A, 0x60)
#define REG_FRC_BK23A_60_H      FRC_PK_H_(0x23A, 0x60)
#define REG_FRC_BK23A_61_L      FRC_PK_L_(0x23A, 0x61)
#define REG_FRC_BK23A_61_H      FRC_PK_H_(0x23A, 0x61)
#define REG_FRC_BK23A_62_L      FRC_PK_L_(0x23A, 0x62)
#define REG_FRC_BK23A_62_H      FRC_PK_H_(0x23A, 0x62)
#define REG_FRC_BK23A_63_L      FRC_PK_L_(0x23A, 0x63)
#define REG_FRC_BK23A_63_H      FRC_PK_H_(0x23A, 0x63)
#define REG_FRC_BK23A_64_L      FRC_PK_L_(0x23A, 0x64)
#define REG_FRC_BK23A_64_H      FRC_PK_H_(0x23A, 0x64)
#define REG_FRC_BK23A_65_L      FRC_PK_L_(0x23A, 0x65)
#define REG_FRC_BK23A_65_H      FRC_PK_H_(0x23A, 0x65)
#define REG_FRC_BK23A_66_L      FRC_PK_L_(0x23A, 0x66)
#define REG_FRC_BK23A_66_H      FRC_PK_H_(0x23A, 0x66)
#define REG_FRC_BK23A_67_L      FRC_PK_L_(0x23A, 0x67)
#define REG_FRC_BK23A_67_H      FRC_PK_H_(0x23A, 0x67)
#define REG_FRC_BK23A_68_L      FRC_PK_L_(0x23A, 0x68)
#define REG_FRC_BK23A_68_H      FRC_PK_H_(0x23A, 0x68)
#define REG_FRC_BK23A_69_L      FRC_PK_L_(0x23A, 0x69)
#define REG_FRC_BK23A_69_H      FRC_PK_H_(0x23A, 0x69)
#define REG_FRC_BK23A_6A_L      FRC_PK_L_(0x23A, 0x6A)
#define REG_FRC_BK23A_6A_H      FRC_PK_H_(0x23A, 0x6A)
#define REG_FRC_BK23A_6B_L      FRC_PK_L_(0x23A, 0x6B)
#define REG_FRC_BK23A_6B_H      FRC_PK_H_(0x23A, 0x6B)
#define REG_FRC_BK23A_6C_L      FRC_PK_L_(0x23A, 0x6C)
#define REG_FRC_BK23A_6C_H      FRC_PK_H_(0x23A, 0x6C)
#define REG_FRC_BK23A_6D_L      FRC_PK_L_(0x23A, 0x6D)
#define REG_FRC_BK23A_6D_H      FRC_PK_H_(0x23A, 0x6D)
#define REG_FRC_BK23A_6E_L      FRC_PK_L_(0x23A, 0x6E)
#define REG_FRC_BK23A_6E_H      FRC_PK_H_(0x23A, 0x6E)
#define REG_FRC_BK23A_6F_L      FRC_PK_L_(0x23A, 0x6F)
#define REG_FRC_BK23A_6F_H      FRC_PK_H_(0x23A, 0x6F)
#define REG_FRC_BK23A_70_L      FRC_PK_L_(0x23A, 0x70)
#define REG_FRC_BK23A_70_H      FRC_PK_H_(0x23A, 0x70)
#define REG_FRC_BK23A_71_L      FRC_PK_L_(0x23A, 0x71)
#define REG_FRC_BK23A_71_H      FRC_PK_H_(0x23A, 0x71)
#define REG_FRC_BK23A_72_L      FRC_PK_L_(0x23A, 0x72)
#define REG_FRC_BK23A_72_H      FRC_PK_H_(0x23A, 0x72)
#define REG_FRC_BK23A_73_L      FRC_PK_L_(0x23A, 0x73)
#define REG_FRC_BK23A_73_H      FRC_PK_H_(0x23A, 0x73)
#define REG_FRC_BK23A_74_L      FRC_PK_L_(0x23A, 0x74)
#define REG_FRC_BK23A_74_H      FRC_PK_H_(0x23A, 0x74)
#define REG_FRC_BK23A_75_L      FRC_PK_L_(0x23A, 0x75)
#define REG_FRC_BK23A_75_H      FRC_PK_H_(0x23A, 0x75)
#define REG_FRC_BK23A_76_L      FRC_PK_L_(0x23A, 0x76)
#define REG_FRC_BK23A_76_H      FRC_PK_H_(0x23A, 0x76)
#define REG_FRC_BK23A_77_L      FRC_PK_L_(0x23A, 0x77)
#define REG_FRC_BK23A_77_H      FRC_PK_H_(0x23A, 0x77)
#define REG_FRC_BK23A_78_L      FRC_PK_L_(0x23A, 0x78)
#define REG_FRC_BK23A_78_H      FRC_PK_H_(0x23A, 0x78)
#define REG_FRC_BK23A_79_L      FRC_PK_L_(0x23A, 0x79)
#define REG_FRC_BK23A_79_H      FRC_PK_H_(0x23A, 0x79)
#define REG_FRC_BK23A_7A_L      FRC_PK_L_(0x23A, 0x7A)
#define REG_FRC_BK23A_7A_H      FRC_PK_H_(0x23A, 0x7A)
#define REG_FRC_BK23A_7B_L      FRC_PK_L_(0x23A, 0x7B)
#define REG_FRC_BK23A_7B_H      FRC_PK_H_(0x23A, 0x7B)
#define REG_FRC_BK23A_7C_L      FRC_PK_L_(0x23A, 0x7C)
#define REG_FRC_BK23A_7C_H      FRC_PK_H_(0x23A, 0x7C)
#define REG_FRC_BK23A_7D_L      FRC_PK_L_(0x23A, 0x7D)
#define REG_FRC_BK23A_7D_H      FRC_PK_H_(0x23A, 0x7D)
#define REG_FRC_BK23A_7E_L      FRC_PK_L_(0x23A, 0x7E)
#define REG_FRC_BK23A_7E_H      FRC_PK_H_(0x23A, 0x7E)
#define REG_FRC_BK23A_7F_L      FRC_PK_L_(0x23A, 0x7F)
#define REG_FRC_BK23A_7F_H      FRC_PK_H_(0x23A, 0x7F)

//----------------------------------------------
//  BK3B
//----------------------------------------------
#define REG_FRC_BK3B_00_L      FRC_PK_L_(0x3B, 0x00)
#define REG_FRC_BK3B_00_H      FRC_PK_H_(0x3B, 0x00)
#define REG_FRC_BK3B_01_L      FRC_PK_L_(0x3B, 0x01)
#define REG_FRC_BK3B_01_H      FRC_PK_H_(0x3B, 0x01)
#define REG_FRC_BK3B_02_L      FRC_PK_L_(0x3B, 0x02)
#define REG_FRC_BK3B_02_H      FRC_PK_H_(0x3B, 0x02)
#define REG_FRC_BK3B_03_L      FRC_PK_L_(0x3B, 0x03)
#define REG_FRC_BK3B_03_H      FRC_PK_H_(0x3B, 0x03)
#define REG_FRC_BK3B_04_L      FRC_PK_L_(0x3B, 0x04)
#define REG_FRC_BK3B_04_H      FRC_PK_H_(0x3B, 0x04)
#define REG_FRC_BK3B_05_L      FRC_PK_L_(0x3B, 0x05)
#define REG_FRC_BK3B_05_H      FRC_PK_H_(0x3B, 0x05)
#define REG_FRC_BK3B_06_L      FRC_PK_L_(0x3B, 0x06)
#define REG_FRC_BK3B_06_H      FRC_PK_H_(0x3B, 0x06)
#define REG_FRC_BK3B_07_L      FRC_PK_L_(0x3B, 0x07)
#define REG_FRC_BK3B_07_H      FRC_PK_H_(0x3B, 0x07)
#define REG_FRC_BK3B_08_L      FRC_PK_L_(0x3B, 0x08)
#define REG_FRC_BK3B_08_H      FRC_PK_H_(0x3B, 0x08)
#define REG_FRC_BK3B_09_L      FRC_PK_L_(0x3B, 0x09)
#define REG_FRC_BK3B_09_H      FRC_PK_H_(0x3B, 0x09)
#define REG_FRC_BK3B_0A_L      FRC_PK_L_(0x3B, 0x0A)
#define REG_FRC_BK3B_0A_H      FRC_PK_H_(0x3B, 0x0A)
#define REG_FRC_BK3B_0B_L      FRC_PK_L_(0x3B, 0x0B)
#define REG_FRC_BK3B_0B_H      FRC_PK_H_(0x3B, 0x0B)
#define REG_FRC_BK3B_0C_L      FRC_PK_L_(0x3B, 0x0C)
#define REG_FRC_BK3B_0C_H      FRC_PK_H_(0x3B, 0x0C)
#define REG_FRC_BK3B_0D_L      FRC_PK_L_(0x3B, 0x0D)
#define REG_FRC_BK3B_0D_H      FRC_PK_H_(0x3B, 0x0D)
#define REG_FRC_BK3B_0E_L      FRC_PK_L_(0x3B, 0x0E)
#define REG_FRC_BK3B_0E_H      FRC_PK_H_(0x3B, 0x0E)
#define REG_FRC_BK3B_0F_L      FRC_PK_L_(0x3B, 0x0F)
#define REG_FRC_BK3B_0F_H      FRC_PK_H_(0x3B, 0x0F)
#define REG_FRC_BK3B_10_L      FRC_PK_L_(0x3B, 0x10)
#define REG_FRC_BK3B_10_H      FRC_PK_H_(0x3B, 0x10)
#define REG_FRC_BK3B_11_L      FRC_PK_L_(0x3B, 0x11)
#define REG_FRC_BK3B_11_H      FRC_PK_H_(0x3B, 0x11)
#define REG_FRC_BK3B_12_L      FRC_PK_L_(0x3B, 0x12)
#define REG_FRC_BK3B_12_H      FRC_PK_H_(0x3B, 0x12)
#define REG_FRC_BK3B_13_L      FRC_PK_L_(0x3B, 0x13)
#define REG_FRC_BK3B_13_H      FRC_PK_H_(0x3B, 0x13)
#define REG_FRC_BK3B_14_L      FRC_PK_L_(0x3B, 0x14)
#define REG_FRC_BK3B_14_H      FRC_PK_H_(0x3B, 0x14)
#define REG_FRC_BK3B_15_L      FRC_PK_L_(0x3B, 0x15)
#define REG_FRC_BK3B_15_H      FRC_PK_H_(0x3B, 0x15)
#define REG_FRC_BK3B_16_L      FRC_PK_L_(0x3B, 0x16)
#define REG_FRC_BK3B_16_H      FRC_PK_H_(0x3B, 0x16)
#define REG_FRC_BK3B_17_L      FRC_PK_L_(0x3B, 0x17)
#define REG_FRC_BK3B_17_H      FRC_PK_H_(0x3B, 0x17)
#define REG_FRC_BK3B_18_L      FRC_PK_L_(0x3B, 0x18)
#define REG_FRC_BK3B_18_H      FRC_PK_H_(0x3B, 0x18)
#define REG_FRC_BK3B_19_L      FRC_PK_L_(0x3B, 0x19)
#define REG_FRC_BK3B_19_H      FRC_PK_H_(0x3B, 0x19)
#define REG_FRC_BK3B_1A_L      FRC_PK_L_(0x3B, 0x1A)
#define REG_FRC_BK3B_1A_H      FRC_PK_H_(0x3B, 0x1A)
#define REG_FRC_BK3B_1B_L      FRC_PK_L_(0x3B, 0x1B)
#define REG_FRC_BK3B_1B_H      FRC_PK_H_(0x3B, 0x1B)
#define REG_FRC_BK3B_1C_L      FRC_PK_L_(0x3B, 0x1C)
#define REG_FRC_BK3B_1C_H      FRC_PK_H_(0x3B, 0x1C)
#define REG_FRC_BK3B_1D_L      FRC_PK_L_(0x3B, 0x1D)
#define REG_FRC_BK3B_1D_H      FRC_PK_H_(0x3B, 0x1D)
#define REG_FRC_BK3B_1E_L      FRC_PK_L_(0x3B, 0x1E)
#define REG_FRC_BK3B_1E_H      FRC_PK_H_(0x3B, 0x1E)
#define REG_FRC_BK3B_1F_L      FRC_PK_L_(0x3B, 0x1F)
#define REG_FRC_BK3B_1F_H      FRC_PK_H_(0x3B, 0x1F)
#define REG_FRC_BK3B_20_L      FRC_PK_L_(0x3B, 0x20)
#define REG_FRC_BK3B_20_H      FRC_PK_H_(0x3B, 0x20)
#define REG_FRC_BK3B_21_L      FRC_PK_L_(0x3B, 0x21)
#define REG_FRC_BK3B_21_H      FRC_PK_H_(0x3B, 0x21)
#define REG_FRC_BK3B_22_L      FRC_PK_L_(0x3B, 0x22)
#define REG_FRC_BK3B_22_H      FRC_PK_H_(0x3B, 0x22)
#define REG_FRC_BK3B_23_L      FRC_PK_L_(0x3B, 0x23)
#define REG_FRC_BK3B_23_H      FRC_PK_H_(0x3B, 0x23)
#define REG_FRC_BK3B_24_L      FRC_PK_L_(0x3B, 0x24)
#define REG_FRC_BK3B_24_H      FRC_PK_H_(0x3B, 0x24)
#define REG_FRC_BK3B_25_L      FRC_PK_L_(0x3B, 0x25)
#define REG_FRC_BK3B_25_H      FRC_PK_H_(0x3B, 0x25)
#define REG_FRC_BK3B_26_L      FRC_PK_L_(0x3B, 0x26)
#define REG_FRC_BK3B_26_H      FRC_PK_H_(0x3B, 0x26)
#define REG_FRC_BK3B_27_L      FRC_PK_L_(0x3B, 0x27)
#define REG_FRC_BK3B_27_H      FRC_PK_H_(0x3B, 0x27)
#define REG_FRC_BK3B_28_L      FRC_PK_L_(0x3B, 0x28)
#define REG_FRC_BK3B_28_H      FRC_PK_H_(0x3B, 0x28)
#define REG_FRC_BK3B_29_L      FRC_PK_L_(0x3B, 0x29)
#define REG_FRC_BK3B_29_H      FRC_PK_H_(0x3B, 0x29)
#define REG_FRC_BK3B_2A_L      FRC_PK_L_(0x3B, 0x2A)
#define REG_FRC_BK3B_2A_H      FRC_PK_H_(0x3B, 0x2A)
#define REG_FRC_BK3B_2B_L      FRC_PK_L_(0x3B, 0x2B)
#define REG_FRC_BK3B_2B_H      FRC_PK_H_(0x3B, 0x2B)
#define REG_FRC_BK3B_2C_L      FRC_PK_L_(0x3B, 0x2C)
#define REG_FRC_BK3B_2C_H      FRC_PK_H_(0x3B, 0x2C)
#define REG_FRC_BK3B_2D_L      FRC_PK_L_(0x3B, 0x2D)
#define REG_FRC_BK3B_2D_H      FRC_PK_H_(0x3B, 0x2D)
#define REG_FRC_BK3B_2E_L      FRC_PK_L_(0x3B, 0x2E)
#define REG_FRC_BK3B_2E_H      FRC_PK_H_(0x3B, 0x2E)
#define REG_FRC_BK3B_2F_L      FRC_PK_L_(0x3B, 0x2F)
#define REG_FRC_BK3B_2F_H      FRC_PK_H_(0x3B, 0x2F)
#define REG_FRC_BK3B_30_L      FRC_PK_L_(0x3B, 0x30)
#define REG_FRC_BK3B_30_H      FRC_PK_H_(0x3B, 0x30)
#define REG_FRC_BK3B_31_L      FRC_PK_L_(0x3B, 0x31)
#define REG_FRC_BK3B_31_H      FRC_PK_H_(0x3B, 0x31)
#define REG_FRC_BK3B_32_L      FRC_PK_L_(0x3B, 0x32)
#define REG_FRC_BK3B_32_H      FRC_PK_H_(0x3B, 0x32)
#define REG_FRC_BK3B_33_L      FRC_PK_L_(0x3B, 0x33)
#define REG_FRC_BK3B_33_H      FRC_PK_H_(0x3B, 0x33)
#define REG_FRC_BK3B_34_L      FRC_PK_L_(0x3B, 0x34)
#define REG_FRC_BK3B_34_H      FRC_PK_H_(0x3B, 0x34)
#define REG_FRC_BK3B_35_L      FRC_PK_L_(0x3B, 0x35)
#define REG_FRC_BK3B_35_H      FRC_PK_H_(0x3B, 0x35)
#define REG_FRC_BK3B_36_L      FRC_PK_L_(0x3B, 0x36)
#define REG_FRC_BK3B_36_H      FRC_PK_H_(0x3B, 0x36)
#define REG_FRC_BK3B_37_L      FRC_PK_L_(0x3B, 0x37)
#define REG_FRC_BK3B_37_H      FRC_PK_H_(0x3B, 0x37)
#define REG_FRC_BK3B_38_L      FRC_PK_L_(0x3B, 0x38)
#define REG_FRC_BK3B_38_H      FRC_PK_H_(0x3B, 0x38)
#define REG_FRC_BK3B_39_L      FRC_PK_L_(0x3B, 0x39)
#define REG_FRC_BK3B_39_H      FRC_PK_H_(0x3B, 0x39)
#define REG_FRC_BK3B_3A_L      FRC_PK_L_(0x3B, 0x3A)
#define REG_FRC_BK3B_3A_H      FRC_PK_H_(0x3B, 0x3A)
#define REG_FRC_BK3B_3B_L      FRC_PK_L_(0x3B, 0x3B)
#define REG_FRC_BK3B_3B_H      FRC_PK_H_(0x3B, 0x3B)
#define REG_FRC_BK3B_3C_L      FRC_PK_L_(0x3B, 0x3C)
#define REG_FRC_BK3B_3C_H      FRC_PK_H_(0x3B, 0x3C)
#define REG_FRC_BK3B_3D_L      FRC_PK_L_(0x3B, 0x3D)
#define REG_FRC_BK3B_3D_H      FRC_PK_H_(0x3B, 0x3D)
#define REG_FRC_BK3B_3E_L      FRC_PK_L_(0x3B, 0x3E)
#define REG_FRC_BK3B_3E_H      FRC_PK_H_(0x3B, 0x3E)
#define REG_FRC_BK3B_3F_L      FRC_PK_L_(0x3B, 0x3F)
#define REG_FRC_BK3B_3F_H      FRC_PK_H_(0x3B, 0x3F)
#define REG_FRC_BK3B_40_L      FRC_PK_L_(0x3B, 0x40)
#define REG_FRC_BK3B_40_H      FRC_PK_H_(0x3B, 0x40)
#define REG_FRC_BK3B_41_L      FRC_PK_L_(0x3B, 0x41)
#define REG_FRC_BK3B_41_H      FRC_PK_H_(0x3B, 0x41)
#define REG_FRC_BK3B_42_L      FRC_PK_L_(0x3B, 0x42)
#define REG_FRC_BK3B_42_H      FRC_PK_H_(0x3B, 0x42)
#define REG_FRC_BK3B_43_L      FRC_PK_L_(0x3B, 0x43)
#define REG_FRC_BK3B_43_H      FRC_PK_H_(0x3B, 0x43)
#define REG_FRC_BK3B_44_L      FRC_PK_L_(0x3B, 0x44)
#define REG_FRC_BK3B_44_H      FRC_PK_H_(0x3B, 0x44)
#define REG_FRC_BK3B_45_L      FRC_PK_L_(0x3B, 0x45)
#define REG_FRC_BK3B_45_H      FRC_PK_H_(0x3B, 0x45)
#define REG_FRC_BK3B_46_L      FRC_PK_L_(0x3B, 0x46)
#define REG_FRC_BK3B_46_H      FRC_PK_H_(0x3B, 0x46)
#define REG_FRC_BK3B_47_L      FRC_PK_L_(0x3B, 0x47)
#define REG_FRC_BK3B_47_H      FRC_PK_H_(0x3B, 0x47)
#define REG_FRC_BK3B_48_L      FRC_PK_L_(0x3B, 0x48)
#define REG_FRC_BK3B_48_H      FRC_PK_H_(0x3B, 0x48)
#define REG_FRC_BK3B_49_L      FRC_PK_L_(0x3B, 0x49)
#define REG_FRC_BK3B_49_H      FRC_PK_H_(0x3B, 0x49)
#define REG_FRC_BK3B_4A_L      FRC_PK_L_(0x3B, 0x4A)
#define REG_FRC_BK3B_4A_H      FRC_PK_H_(0x3B, 0x4A)
#define REG_FRC_BK3B_4B_L      FRC_PK_L_(0x3B, 0x4B)
#define REG_FRC_BK3B_4B_H      FRC_PK_H_(0x3B, 0x4B)
#define REG_FRC_BK3B_4C_L      FRC_PK_L_(0x3B, 0x4C)
#define REG_FRC_BK3B_4C_H      FRC_PK_H_(0x3B, 0x4C)
#define REG_FRC_BK3B_4D_L      FRC_PK_L_(0x3B, 0x4D)
#define REG_FRC_BK3B_4D_H      FRC_PK_H_(0x3B, 0x4D)
#define REG_FRC_BK3B_4E_L      FRC_PK_L_(0x3B, 0x4E)
#define REG_FRC_BK3B_4E_H      FRC_PK_H_(0x3B, 0x4E)
#define REG_FRC_BK3B_4F_L      FRC_PK_L_(0x3B, 0x4F)
#define REG_FRC_BK3B_4F_H      FRC_PK_H_(0x3B, 0x4F)
#define REG_FRC_BK3B_50_L      FRC_PK_L_(0x3B, 0x50)
#define REG_FRC_BK3B_50_H      FRC_PK_H_(0x3B, 0x50)
#define REG_FRC_BK3B_51_L      FRC_PK_L_(0x3B, 0x51)
#define REG_FRC_BK3B_51_H      FRC_PK_H_(0x3B, 0x51)
#define REG_FRC_BK3B_52_L      FRC_PK_L_(0x3B, 0x52)
#define REG_FRC_BK3B_52_H      FRC_PK_H_(0x3B, 0x52)
#define REG_FRC_BK3B_53_L      FRC_PK_L_(0x3B, 0x53)
#define REG_FRC_BK3B_53_H      FRC_PK_H_(0x3B, 0x53)
#define REG_FRC_BK3B_54_L      FRC_PK_L_(0x3B, 0x54)
#define REG_FRC_BK3B_54_H      FRC_PK_H_(0x3B, 0x54)
#define REG_FRC_BK3B_55_L      FRC_PK_L_(0x3B, 0x55)
#define REG_FRC_BK3B_55_H      FRC_PK_H_(0x3B, 0x55)
#define REG_FRC_BK3B_56_L      FRC_PK_L_(0x3B, 0x56)
#define REG_FRC_BK3B_56_H      FRC_PK_H_(0x3B, 0x56)
#define REG_FRC_BK3B_57_L      FRC_PK_L_(0x3B, 0x57)
#define REG_FRC_BK3B_57_H      FRC_PK_H_(0x3B, 0x57)
#define REG_FRC_BK3B_58_L      FRC_PK_L_(0x3B, 0x58)
#define REG_FRC_BK3B_58_H      FRC_PK_H_(0x3B, 0x58)
#define REG_FRC_BK3B_59_L      FRC_PK_L_(0x3B, 0x59)
#define REG_FRC_BK3B_59_H      FRC_PK_H_(0x3B, 0x59)
#define REG_FRC_BK3B_5A_L      FRC_PK_L_(0x3B, 0x5A)
#define REG_FRC_BK3B_5A_H      FRC_PK_H_(0x3B, 0x5A)
#define REG_FRC_BK3B_5B_L      FRC_PK_L_(0x3B, 0x5B)
#define REG_FRC_BK3B_5B_H      FRC_PK_H_(0x3B, 0x5B)
#define REG_FRC_BK3B_5C_L      FRC_PK_L_(0x3B, 0x5C)
#define REG_FRC_BK3B_5C_H      FRC_PK_H_(0x3B, 0x5C)
#define REG_FRC_BK3B_5D_L      FRC_PK_L_(0x3B, 0x5D)
#define REG_FRC_BK3B_5D_H      FRC_PK_H_(0x3B, 0x5D)
#define REG_FRC_BK3B_5E_L      FRC_PK_L_(0x3B, 0x5E)
#define REG_FRC_BK3B_5E_H      FRC_PK_H_(0x3B, 0x5E)
#define REG_FRC_BK3B_5F_L      FRC_PK_L_(0x3B, 0x5F)
#define REG_FRC_BK3B_5F_H      FRC_PK_H_(0x3B, 0x5F)
#define REG_FRC_BK3B_60_L      FRC_PK_L_(0x3B, 0x60)
#define REG_FRC_BK3B_60_H      FRC_PK_H_(0x3B, 0x60)
#define REG_FRC_BK3B_61_L      FRC_PK_L_(0x3B, 0x61)
#define REG_FRC_BK3B_61_H      FRC_PK_H_(0x3B, 0x61)
#define REG_FRC_BK3B_62_L      FRC_PK_L_(0x3B, 0x62)
#define REG_FRC_BK3B_62_H      FRC_PK_H_(0x3B, 0x62)
#define REG_FRC_BK3B_63_L      FRC_PK_L_(0x3B, 0x63)
#define REG_FRC_BK3B_63_H      FRC_PK_H_(0x3B, 0x63)
#define REG_FRC_BK3B_64_L      FRC_PK_L_(0x3B, 0x64)
#define REG_FRC_BK3B_64_H      FRC_PK_H_(0x3B, 0x64)
#define REG_FRC_BK3B_65_L      FRC_PK_L_(0x3B, 0x65)
#define REG_FRC_BK3B_65_H      FRC_PK_H_(0x3B, 0x65)
#define REG_FRC_BK3B_66_L      FRC_PK_L_(0x3B, 0x66)
#define REG_FRC_BK3B_66_H      FRC_PK_H_(0x3B, 0x66)
#define REG_FRC_BK3B_67_L      FRC_PK_L_(0x3B, 0x67)
#define REG_FRC_BK3B_67_H      FRC_PK_H_(0x3B, 0x67)
#define REG_FRC_BK3B_68_L      FRC_PK_L_(0x3B, 0x68)
#define REG_FRC_BK3B_68_H      FRC_PK_H_(0x3B, 0x68)
#define REG_FRC_BK3B_69_L      FRC_PK_L_(0x3B, 0x69)
#define REG_FRC_BK3B_69_H      FRC_PK_H_(0x3B, 0x69)
#define REG_FRC_BK3B_6A_L      FRC_PK_L_(0x3B, 0x6A)
#define REG_FRC_BK3B_6A_H      FRC_PK_H_(0x3B, 0x6A)
#define REG_FRC_BK3B_6B_L      FRC_PK_L_(0x3B, 0x6B)
#define REG_FRC_BK3B_6B_H      FRC_PK_H_(0x3B, 0x6B)
#define REG_FRC_BK3B_6C_L      FRC_PK_L_(0x3B, 0x6C)
#define REG_FRC_BK3B_6C_H      FRC_PK_H_(0x3B, 0x6C)
#define REG_FRC_BK3B_6D_L      FRC_PK_L_(0x3B, 0x6D)
#define REG_FRC_BK3B_6D_H      FRC_PK_H_(0x3B, 0x6D)
#define REG_FRC_BK3B_6E_L      FRC_PK_L_(0x3B, 0x6E)
#define REG_FRC_BK3B_6E_H      FRC_PK_H_(0x3B, 0x6E)
#define REG_FRC_BK3B_6F_L      FRC_PK_L_(0x3B, 0x6F)
#define REG_FRC_BK3B_6F_H      FRC_PK_H_(0x3B, 0x6F)
#define REG_FRC_BK3B_70_L      FRC_PK_L_(0x3B, 0x70)
#define REG_FRC_BK3B_70_H      FRC_PK_H_(0x3B, 0x70)
#define REG_FRC_BK3B_71_L      FRC_PK_L_(0x3B, 0x71)
#define REG_FRC_BK3B_71_H      FRC_PK_H_(0x3B, 0x71)
#define REG_FRC_BK3B_72_L      FRC_PK_L_(0x3B, 0x72)
#define REG_FRC_BK3B_72_H      FRC_PK_H_(0x3B, 0x72)
#define REG_FRC_BK3B_73_L      FRC_PK_L_(0x3B, 0x73)
#define REG_FRC_BK3B_73_H      FRC_PK_H_(0x3B, 0x73)
#define REG_FRC_BK3B_74_L      FRC_PK_L_(0x3B, 0x74)
#define REG_FRC_BK3B_74_H      FRC_PK_H_(0x3B, 0x74)
#define REG_FRC_BK3B_75_L      FRC_PK_L_(0x3B, 0x75)
#define REG_FRC_BK3B_75_H      FRC_PK_H_(0x3B, 0x75)
#define REG_FRC_BK3B_76_L      FRC_PK_L_(0x3B, 0x76)
#define REG_FRC_BK3B_76_H      FRC_PK_H_(0x3B, 0x76)
#define REG_FRC_BK3B_77_L      FRC_PK_L_(0x3B, 0x77)
#define REG_FRC_BK3B_77_H      FRC_PK_H_(0x3B, 0x77)
#define REG_FRC_BK3B_78_L      FRC_PK_L_(0x3B, 0x78)
#define REG_FRC_BK3B_78_H      FRC_PK_H_(0x3B, 0x78)
#define REG_FRC_BK3B_79_L      FRC_PK_L_(0x3B, 0x79)
#define REG_FRC_BK3B_79_H      FRC_PK_H_(0x3B, 0x79)
#define REG_FRC_BK3B_7A_L      FRC_PK_L_(0x3B, 0x7A)
#define REG_FRC_BK3B_7A_H      FRC_PK_H_(0x3B, 0x7A)
#define REG_FRC_BK3B_7B_L      FRC_PK_L_(0x3B, 0x7B)
#define REG_FRC_BK3B_7B_H      FRC_PK_H_(0x3B, 0x7B)
#define REG_FRC_BK3B_7C_L      FRC_PK_L_(0x3B, 0x7C)
#define REG_FRC_BK3B_7C_H      FRC_PK_H_(0x3B, 0x7C)
#define REG_FRC_BK3B_7D_L      FRC_PK_L_(0x3B, 0x7D)
#define REG_FRC_BK3B_7D_H      FRC_PK_H_(0x3B, 0x7D)
#define REG_FRC_BK3B_7E_L      FRC_PK_L_(0x3B, 0x7E)
#define REG_FRC_BK3B_7E_H      FRC_PK_H_(0x3B, 0x7E)
#define REG_FRC_BK3B_7F_L      FRC_PK_L_(0x3B, 0x7F)
#define REG_FRC_BK3B_7F_H      FRC_PK_H_(0x3B, 0x7F)

//----------------------------------------------
//  BK3C
//----------------------------------------------
#define REG_FRC_BK3C_00_L      FRC_PK_L_(0x3C, 0x00)
#define REG_FRC_BK3C_00_H      FRC_PK_H_(0x3C, 0x00)
#define REG_FRC_BK3C_01_L      FRC_PK_L_(0x3C, 0x01)
#define REG_FRC_BK3C_01_H      FRC_PK_H_(0x3C, 0x01)
#define REG_FRC_BK3C_02_L      FRC_PK_L_(0x3C, 0x02)
#define REG_FRC_BK3C_02_H      FRC_PK_H_(0x3C, 0x02)
#define REG_FRC_BK3C_03_L      FRC_PK_L_(0x3C, 0x03)
#define REG_FRC_BK3C_03_H      FRC_PK_H_(0x3C, 0x03)
#define REG_FRC_BK3C_04_L      FRC_PK_L_(0x3C, 0x04)
#define REG_FRC_BK3C_04_H      FRC_PK_H_(0x3C, 0x04)
#define REG_FRC_BK3C_05_L      FRC_PK_L_(0x3C, 0x05)
#define REG_FRC_BK3C_05_H      FRC_PK_H_(0x3C, 0x05)
#define REG_FRC_BK3C_06_L      FRC_PK_L_(0x3C, 0x06)
#define REG_FRC_BK3C_06_H      FRC_PK_H_(0x3C, 0x06)
#define REG_FRC_BK3C_07_L      FRC_PK_L_(0x3C, 0x07)
#define REG_FRC_BK3C_07_H      FRC_PK_H_(0x3C, 0x07)
#define REG_FRC_BK3C_08_L      FRC_PK_L_(0x3C, 0x08)
#define REG_FRC_BK3C_08_H      FRC_PK_H_(0x3C, 0x08)
#define REG_FRC_BK3C_09_L      FRC_PK_L_(0x3C, 0x09)
#define REG_FRC_BK3C_09_H      FRC_PK_H_(0x3C, 0x09)
#define REG_FRC_BK3C_0A_L      FRC_PK_L_(0x3C, 0x0A)
#define REG_FRC_BK3C_0A_H      FRC_PK_H_(0x3C, 0x0A)
#define REG_FRC_BK3C_0B_L      FRC_PK_L_(0x3C, 0x0B)
#define REG_FRC_BK3C_0B_H      FRC_PK_H_(0x3C, 0x0B)
#define REG_FRC_BK3C_0C_L      FRC_PK_L_(0x3C, 0x0C)
#define REG_FRC_BK3C_0C_H      FRC_PK_H_(0x3C, 0x0C)
#define REG_FRC_BK3C_0D_L      FRC_PK_L_(0x3C, 0x0D)
#define REG_FRC_BK3C_0D_H      FRC_PK_H_(0x3C, 0x0D)
#define REG_FRC_BK3C_0E_L      FRC_PK_L_(0x3C, 0x0E)
#define REG_FRC_BK3C_0E_H      FRC_PK_H_(0x3C, 0x0E)
#define REG_FRC_BK3C_0F_L      FRC_PK_L_(0x3C, 0x0F)
#define REG_FRC_BK3C_0F_H      FRC_PK_H_(0x3C, 0x0F)
#define REG_FRC_BK3C_10_L      FRC_PK_L_(0x3C, 0x10)
#define REG_FRC_BK3C_10_H      FRC_PK_H_(0x3C, 0x10)
#define REG_FRC_BK3C_11_L      FRC_PK_L_(0x3C, 0x11)
#define REG_FRC_BK3C_11_H      FRC_PK_H_(0x3C, 0x11)
#define REG_FRC_BK3C_12_L      FRC_PK_L_(0x3C, 0x12)
#define REG_FRC_BK3C_12_H      FRC_PK_H_(0x3C, 0x12)
#define REG_FRC_BK3C_13_L      FRC_PK_L_(0x3C, 0x13)
#define REG_FRC_BK3C_13_H      FRC_PK_H_(0x3C, 0x13)
#define REG_FRC_BK3C_14_L      FRC_PK_L_(0x3C, 0x14)
#define REG_FRC_BK3C_14_H      FRC_PK_H_(0x3C, 0x14)
#define REG_FRC_BK3C_15_L      FRC_PK_L_(0x3C, 0x15)
#define REG_FRC_BK3C_15_H      FRC_PK_H_(0x3C, 0x15)
#define REG_FRC_BK3C_16_L      FRC_PK_L_(0x3C, 0x16)
#define REG_FRC_BK3C_16_H      FRC_PK_H_(0x3C, 0x16)
#define REG_FRC_BK3C_17_L      FRC_PK_L_(0x3C, 0x17)
#define REG_FRC_BK3C_17_H      FRC_PK_H_(0x3C, 0x17)
#define REG_FRC_BK3C_18_L      FRC_PK_L_(0x3C, 0x18)
#define REG_FRC_BK3C_18_H      FRC_PK_H_(0x3C, 0x18)
#define REG_FRC_BK3C_19_L      FRC_PK_L_(0x3C, 0x19)
#define REG_FRC_BK3C_19_H      FRC_PK_H_(0x3C, 0x19)
#define REG_FRC_BK3C_1A_L      FRC_PK_L_(0x3C, 0x1A)
#define REG_FRC_BK3C_1A_H      FRC_PK_H_(0x3C, 0x1A)
#define REG_FRC_BK3C_1B_L      FRC_PK_L_(0x3C, 0x1B)
#define REG_FRC_BK3C_1B_H      FRC_PK_H_(0x3C, 0x1B)
#define REG_FRC_BK3C_1C_L      FRC_PK_L_(0x3C, 0x1C)
#define REG_FRC_BK3C_1C_H      FRC_PK_H_(0x3C, 0x1C)
#define REG_FRC_BK3C_1D_L      FRC_PK_L_(0x3C, 0x1D)
#define REG_FRC_BK3C_1D_H      FRC_PK_H_(0x3C, 0x1D)
#define REG_FRC_BK3C_1E_L      FRC_PK_L_(0x3C, 0x1E)
#define REG_FRC_BK3C_1E_H      FRC_PK_H_(0x3C, 0x1E)
#define REG_FRC_BK3C_1F_L      FRC_PK_L_(0x3C, 0x1F)
#define REG_FRC_BK3C_1F_H      FRC_PK_H_(0x3C, 0x1F)
#define REG_FRC_BK3C_20_L      FRC_PK_L_(0x3C, 0x20)
#define REG_FRC_BK3C_20_H      FRC_PK_H_(0x3C, 0x20)
#define REG_FRC_BK3C_21_L      FRC_PK_L_(0x3C, 0x21)
#define REG_FRC_BK3C_21_H      FRC_PK_H_(0x3C, 0x21)
#define REG_FRC_BK3C_22_L      FRC_PK_L_(0x3C, 0x22)
#define REG_FRC_BK3C_22_H      FRC_PK_H_(0x3C, 0x22)
#define REG_FRC_BK3C_23_L      FRC_PK_L_(0x3C, 0x23)
#define REG_FRC_BK3C_23_H      FRC_PK_H_(0x3C, 0x23)
#define REG_FRC_BK3C_24_L      FRC_PK_L_(0x3C, 0x24)
#define REG_FRC_BK3C_24_H      FRC_PK_H_(0x3C, 0x24)
#define REG_FRC_BK3C_25_L      FRC_PK_L_(0x3C, 0x25)
#define REG_FRC_BK3C_25_H      FRC_PK_H_(0x3C, 0x25)
#define REG_FRC_BK3C_26_L      FRC_PK_L_(0x3C, 0x26)
#define REG_FRC_BK3C_26_H      FRC_PK_H_(0x3C, 0x26)
#define REG_FRC_BK3C_27_L      FRC_PK_L_(0x3C, 0x27)
#define REG_FRC_BK3C_27_H      FRC_PK_H_(0x3C, 0x27)
#define REG_FRC_BK3C_28_L      FRC_PK_L_(0x3C, 0x28)
#define REG_FRC_BK3C_28_H      FRC_PK_H_(0x3C, 0x28)
#define REG_FRC_BK3C_29_L      FRC_PK_L_(0x3C, 0x29)
#define REG_FRC_BK3C_29_H      FRC_PK_H_(0x3C, 0x29)
#define REG_FRC_BK3C_2A_L      FRC_PK_L_(0x3C, 0x2A)
#define REG_FRC_BK3C_2A_H      FRC_PK_H_(0x3C, 0x2A)
#define REG_FRC_BK3C_2B_L      FRC_PK_L_(0x3C, 0x2B)
#define REG_FRC_BK3C_2B_H      FRC_PK_H_(0x3C, 0x2B)
#define REG_FRC_BK3C_2C_L      FRC_PK_L_(0x3C, 0x2C)
#define REG_FRC_BK3C_2C_H      FRC_PK_H_(0x3C, 0x2C)
#define REG_FRC_BK3C_2D_L      FRC_PK_L_(0x3C, 0x2D)
#define REG_FRC_BK3C_2D_H      FRC_PK_H_(0x3C, 0x2D)
#define REG_FRC_BK3C_2E_L      FRC_PK_L_(0x3C, 0x2E)
#define REG_FRC_BK3C_2E_H      FRC_PK_H_(0x3C, 0x2E)
#define REG_FRC_BK3C_2F_L      FRC_PK_L_(0x3C, 0x2F)
#define REG_FRC_BK3C_2F_H      FRC_PK_H_(0x3C, 0x2F)
#define REG_FRC_BK3C_30_L      FRC_PK_L_(0x3C, 0x30)
#define REG_FRC_BK3C_30_H      FRC_PK_H_(0x3C, 0x30)
#define REG_FRC_BK3C_31_L      FRC_PK_L_(0x3C, 0x31)
#define REG_FRC_BK3C_31_H      FRC_PK_H_(0x3C, 0x31)
#define REG_FRC_BK3C_32_L      FRC_PK_L_(0x3C, 0x32)
#define REG_FRC_BK3C_32_H      FRC_PK_H_(0x3C, 0x32)
#define REG_FRC_BK3C_33_L      FRC_PK_L_(0x3C, 0x33)
#define REG_FRC_BK3C_33_H      FRC_PK_H_(0x3C, 0x33)
#define REG_FRC_BK3C_34_L      FRC_PK_L_(0x3C, 0x34)
#define REG_FRC_BK3C_34_H      FRC_PK_H_(0x3C, 0x34)
#define REG_FRC_BK3C_35_L      FRC_PK_L_(0x3C, 0x35)
#define REG_FRC_BK3C_35_H      FRC_PK_H_(0x3C, 0x35)
#define REG_FRC_BK3C_36_L      FRC_PK_L_(0x3C, 0x36)
#define REG_FRC_BK3C_36_H      FRC_PK_H_(0x3C, 0x36)
#define REG_FRC_BK3C_37_L      FRC_PK_L_(0x3C, 0x37)
#define REG_FRC_BK3C_37_H      FRC_PK_H_(0x3C, 0x37)
#define REG_FRC_BK3C_38_L      FRC_PK_L_(0x3C, 0x38)
#define REG_FRC_BK3C_38_H      FRC_PK_H_(0x3C, 0x38)
#define REG_FRC_BK3C_39_L      FRC_PK_L_(0x3C, 0x39)
#define REG_FRC_BK3C_39_H      FRC_PK_H_(0x3C, 0x39)
#define REG_FRC_BK3C_3A_L      FRC_PK_L_(0x3C, 0x3A)
#define REG_FRC_BK3C_3A_H      FRC_PK_H_(0x3C, 0x3A)
#define REG_FRC_BK3C_3B_L      FRC_PK_L_(0x3C, 0x3B)
#define REG_FRC_BK3C_3B_H      FRC_PK_H_(0x3C, 0x3B)
#define REG_FRC_BK3C_3C_L      FRC_PK_L_(0x3C, 0x3C)
#define REG_FRC_BK3C_3C_H      FRC_PK_H_(0x3C, 0x3C)
#define REG_FRC_BK3C_3D_L      FRC_PK_L_(0x3C, 0x3D)
#define REG_FRC_BK3C_3D_H      FRC_PK_H_(0x3C, 0x3D)
#define REG_FRC_BK3C_3E_L      FRC_PK_L_(0x3C, 0x3E)
#define REG_FRC_BK3C_3E_H      FRC_PK_H_(0x3C, 0x3E)
#define REG_FRC_BK3C_3F_L      FRC_PK_L_(0x3C, 0x3F)
#define REG_FRC_BK3C_3F_H      FRC_PK_H_(0x3C, 0x3F)
#define REG_FRC_BK3C_40_L      FRC_PK_L_(0x3C, 0x40)
#define REG_FRC_BK3C_40_H      FRC_PK_H_(0x3C, 0x40)
#define REG_FRC_BK3C_41_L      FRC_PK_L_(0x3C, 0x41)
#define REG_FRC_BK3C_41_H      FRC_PK_H_(0x3C, 0x41)
#define REG_FRC_BK3C_42_L      FRC_PK_L_(0x3C, 0x42)
#define REG_FRC_BK3C_42_H      FRC_PK_H_(0x3C, 0x42)
#define REG_FRC_BK3C_43_L      FRC_PK_L_(0x3C, 0x43)
#define REG_FRC_BK3C_43_H      FRC_PK_H_(0x3C, 0x43)
#define REG_FRC_BK3C_44_L      FRC_PK_L_(0x3C, 0x44)
#define REG_FRC_BK3C_44_H      FRC_PK_H_(0x3C, 0x44)
#define REG_FRC_BK3C_45_L      FRC_PK_L_(0x3C, 0x45)
#define REG_FRC_BK3C_45_H      FRC_PK_H_(0x3C, 0x45)
#define REG_FRC_BK3C_46_L      FRC_PK_L_(0x3C, 0x46)
#define REG_FRC_BK3C_46_H      FRC_PK_H_(0x3C, 0x46)
#define REG_FRC_BK3C_47_L      FRC_PK_L_(0x3C, 0x47)
#define REG_FRC_BK3C_47_H      FRC_PK_H_(0x3C, 0x47)
#define REG_FRC_BK3C_48_L      FRC_PK_L_(0x3C, 0x48)
#define REG_FRC_BK3C_48_H      FRC_PK_H_(0x3C, 0x48)
#define REG_FRC_BK3C_49_L      FRC_PK_L_(0x3C, 0x49)
#define REG_FRC_BK3C_49_H      FRC_PK_H_(0x3C, 0x49)
#define REG_FRC_BK3C_4A_L      FRC_PK_L_(0x3C, 0x4A)
#define REG_FRC_BK3C_4A_H      FRC_PK_H_(0x3C, 0x4A)
#define REG_FRC_BK3C_4B_L      FRC_PK_L_(0x3C, 0x4B)
#define REG_FRC_BK3C_4B_H      FRC_PK_H_(0x3C, 0x4B)
#define REG_FRC_BK3C_4C_L      FRC_PK_L_(0x3C, 0x4C)
#define REG_FRC_BK3C_4C_H      FRC_PK_H_(0x3C, 0x4C)
#define REG_FRC_BK3C_4D_L      FRC_PK_L_(0x3C, 0x4D)
#define REG_FRC_BK3C_4D_H      FRC_PK_H_(0x3C, 0x4D)
#define REG_FRC_BK3C_4E_L      FRC_PK_L_(0x3C, 0x4E)
#define REG_FRC_BK3C_4E_H      FRC_PK_H_(0x3C, 0x4E)
#define REG_FRC_BK3C_4F_L      FRC_PK_L_(0x3C, 0x4F)
#define REG_FRC_BK3C_4F_H      FRC_PK_H_(0x3C, 0x4F)
#define REG_FRC_BK3C_50_L      FRC_PK_L_(0x3C, 0x50)
#define REG_FRC_BK3C_50_H      FRC_PK_H_(0x3C, 0x50)
#define REG_FRC_BK3C_51_L      FRC_PK_L_(0x3C, 0x51)
#define REG_FRC_BK3C_51_H      FRC_PK_H_(0x3C, 0x51)
#define REG_FRC_BK3C_52_L      FRC_PK_L_(0x3C, 0x52)
#define REG_FRC_BK3C_52_H      FRC_PK_H_(0x3C, 0x52)
#define REG_FRC_BK3C_53_L      FRC_PK_L_(0x3C, 0x53)
#define REG_FRC_BK3C_53_H      FRC_PK_H_(0x3C, 0x53)
#define REG_FRC_BK3C_54_L      FRC_PK_L_(0x3C, 0x54)
#define REG_FRC_BK3C_54_H      FRC_PK_H_(0x3C, 0x54)
#define REG_FRC_BK3C_55_L      FRC_PK_L_(0x3C, 0x55)
#define REG_FRC_BK3C_55_H      FRC_PK_H_(0x3C, 0x55)
#define REG_FRC_BK3C_56_L      FRC_PK_L_(0x3C, 0x56)
#define REG_FRC_BK3C_56_H      FRC_PK_H_(0x3C, 0x56)
#define REG_FRC_BK3C_57_L      FRC_PK_L_(0x3C, 0x57)
#define REG_FRC_BK3C_57_H      FRC_PK_H_(0x3C, 0x57)
#define REG_FRC_BK3C_58_L      FRC_PK_L_(0x3C, 0x58)
#define REG_FRC_BK3C_58_H      FRC_PK_H_(0x3C, 0x58)
#define REG_FRC_BK3C_59_L      FRC_PK_L_(0x3C, 0x59)
#define REG_FRC_BK3C_59_H      FRC_PK_H_(0x3C, 0x59)
#define REG_FRC_BK3C_5A_L      FRC_PK_L_(0x3C, 0x5A)
#define REG_FRC_BK3C_5A_H      FRC_PK_H_(0x3C, 0x5A)
#define REG_FRC_BK3C_5B_L      FRC_PK_L_(0x3C, 0x5B)
#define REG_FRC_BK3C_5B_H      FRC_PK_H_(0x3C, 0x5B)
#define REG_FRC_BK3C_5C_L      FRC_PK_L_(0x3C, 0x5C)
#define REG_FRC_BK3C_5C_H      FRC_PK_H_(0x3C, 0x5C)
#define REG_FRC_BK3C_5D_L      FRC_PK_L_(0x3C, 0x5D)
#define REG_FRC_BK3C_5D_H      FRC_PK_H_(0x3C, 0x5D)
#define REG_FRC_BK3C_5E_L      FRC_PK_L_(0x3C, 0x5E)
#define REG_FRC_BK3C_5E_H      FRC_PK_H_(0x3C, 0x5E)
#define REG_FRC_BK3C_5F_L      FRC_PK_L_(0x3C, 0x5F)
#define REG_FRC_BK3C_5F_H      FRC_PK_H_(0x3C, 0x5F)
#define REG_FRC_BK3C_60_L      FRC_PK_L_(0x3C, 0x60)
#define REG_FRC_BK3C_60_H      FRC_PK_H_(0x3C, 0x60)
#define REG_FRC_BK3C_61_L      FRC_PK_L_(0x3C, 0x61)
#define REG_FRC_BK3C_61_H      FRC_PK_H_(0x3C, 0x61)
#define REG_FRC_BK3C_62_L      FRC_PK_L_(0x3C, 0x62)
#define REG_FRC_BK3C_62_H      FRC_PK_H_(0x3C, 0x62)
#define REG_FRC_BK3C_63_L      FRC_PK_L_(0x3C, 0x63)
#define REG_FRC_BK3C_63_H      FRC_PK_H_(0x3C, 0x63)
#define REG_FRC_BK3C_64_L      FRC_PK_L_(0x3C, 0x64)
#define REG_FRC_BK3C_64_H      FRC_PK_H_(0x3C, 0x64)
#define REG_FRC_BK3C_65_L      FRC_PK_L_(0x3C, 0x65)
#define REG_FRC_BK3C_65_H      FRC_PK_H_(0x3C, 0x65)
#define REG_FRC_BK3C_66_L      FRC_PK_L_(0x3C, 0x66)
#define REG_FRC_BK3C_66_H      FRC_PK_H_(0x3C, 0x66)
#define REG_FRC_BK3C_67_L      FRC_PK_L_(0x3C, 0x67)
#define REG_FRC_BK3C_67_H      FRC_PK_H_(0x3C, 0x67)
#define REG_FRC_BK3C_68_L      FRC_PK_L_(0x3C, 0x68)
#define REG_FRC_BK3C_68_H      FRC_PK_H_(0x3C, 0x68)
#define REG_FRC_BK3C_69_L      FRC_PK_L_(0x3C, 0x69)
#define REG_FRC_BK3C_69_H      FRC_PK_H_(0x3C, 0x69)
#define REG_FRC_BK3C_6A_L      FRC_PK_L_(0x3C, 0x6A)
#define REG_FRC_BK3C_6A_H      FRC_PK_H_(0x3C, 0x6A)
#define REG_FRC_BK3C_6B_L      FRC_PK_L_(0x3C, 0x6B)
#define REG_FRC_BK3C_6B_H      FRC_PK_H_(0x3C, 0x6B)
#define REG_FRC_BK3C_6C_L      FRC_PK_L_(0x3C, 0x6C)
#define REG_FRC_BK3C_6C_H      FRC_PK_H_(0x3C, 0x6C)
#define REG_FRC_BK3C_6D_L      FRC_PK_L_(0x3C, 0x6D)
#define REG_FRC_BK3C_6D_H      FRC_PK_H_(0x3C, 0x6D)
#define REG_FRC_BK3C_6E_L      FRC_PK_L_(0x3C, 0x6E)
#define REG_FRC_BK3C_6E_H      FRC_PK_H_(0x3C, 0x6E)
#define REG_FRC_BK3C_6F_L      FRC_PK_L_(0x3C, 0x6F)
#define REG_FRC_BK3C_6F_H      FRC_PK_H_(0x3C, 0x6F)
#define REG_FRC_BK3C_70_L      FRC_PK_L_(0x3C, 0x70)
#define REG_FRC_BK3C_70_H      FRC_PK_H_(0x3C, 0x70)
#define REG_FRC_BK3C_71_L      FRC_PK_L_(0x3C, 0x71)
#define REG_FRC_BK3C_71_H      FRC_PK_H_(0x3C, 0x71)
#define REG_FRC_BK3C_72_L      FRC_PK_L_(0x3C, 0x72)
#define REG_FRC_BK3C_72_H      FRC_PK_H_(0x3C, 0x72)
#define REG_FRC_BK3C_73_L      FRC_PK_L_(0x3C, 0x73)
#define REG_FRC_BK3C_73_H      FRC_PK_H_(0x3C, 0x73)
#define REG_FRC_BK3C_74_L      FRC_PK_L_(0x3C, 0x74)
#define REG_FRC_BK3C_74_H      FRC_PK_H_(0x3C, 0x74)
#define REG_FRC_BK3C_75_L      FRC_PK_L_(0x3C, 0x75)
#define REG_FRC_BK3C_75_H      FRC_PK_H_(0x3C, 0x75)
#define REG_FRC_BK3C_76_L      FRC_PK_L_(0x3C, 0x76)
#define REG_FRC_BK3C_76_H      FRC_PK_H_(0x3C, 0x76)
#define REG_FRC_BK3C_77_L      FRC_PK_L_(0x3C, 0x77)
#define REG_FRC_BK3C_77_H      FRC_PK_H_(0x3C, 0x77)
#define REG_FRC_BK3C_78_L      FRC_PK_L_(0x3C, 0x78)
#define REG_FRC_BK3C_78_H      FRC_PK_H_(0x3C, 0x78)
#define REG_FRC_BK3C_79_L      FRC_PK_L_(0x3C, 0x79)
#define REG_FRC_BK3C_79_H      FRC_PK_H_(0x3C, 0x79)
#define REG_FRC_BK3C_7A_L      FRC_PK_L_(0x3C, 0x7A)
#define REG_FRC_BK3C_7A_H      FRC_PK_H_(0x3C, 0x7A)
#define REG_FRC_BK3C_7B_L      FRC_PK_L_(0x3C, 0x7B)
#define REG_FRC_BK3C_7B_H      FRC_PK_H_(0x3C, 0x7B)
#define REG_FRC_BK3C_7C_L      FRC_PK_L_(0x3C, 0x7C)
#define REG_FRC_BK3C_7C_H      FRC_PK_H_(0x3C, 0x7C)
#define REG_FRC_BK3C_7D_L      FRC_PK_L_(0x3C, 0x7D)
#define REG_FRC_BK3C_7D_H      FRC_PK_H_(0x3C, 0x7D)
#define REG_FRC_BK3C_7E_L      FRC_PK_L_(0x3C, 0x7E)
#define REG_FRC_BK3C_7E_H      FRC_PK_H_(0x3C, 0x7E)
#define REG_FRC_BK3C_7F_L      FRC_PK_L_(0x3C, 0x7F)
#define REG_FRC_BK3C_7F_H      FRC_PK_H_(0x3C, 0x7F)

//----------------------------------------------
//  BK3D
//----------------------------------------------
#define REG_FRC_BK3D_00_L      FRC_PK_L_(0x3D, 0x00)
#define REG_FRC_BK3D_00_H      FRC_PK_H_(0x3D, 0x00)
#define REG_FRC_BK3D_01_L      FRC_PK_L_(0x3D, 0x01)
#define REG_FRC_BK3D_01_H      FRC_PK_H_(0x3D, 0x01)
#define REG_FRC_BK3D_02_L      FRC_PK_L_(0x3D, 0x02)
#define REG_FRC_BK3D_02_H      FRC_PK_H_(0x3D, 0x02)
#define REG_FRC_BK3D_03_L      FRC_PK_L_(0x3D, 0x03)
#define REG_FRC_BK3D_03_H      FRC_PK_H_(0x3D, 0x03)
#define REG_FRC_BK3D_04_L      FRC_PK_L_(0x3D, 0x04)
#define REG_FRC_BK3D_04_H      FRC_PK_H_(0x3D, 0x04)
#define REG_FRC_BK3D_05_L      FRC_PK_L_(0x3D, 0x05)
#define REG_FRC_BK3D_05_H      FRC_PK_H_(0x3D, 0x05)
#define REG_FRC_BK3D_06_L      FRC_PK_L_(0x3D, 0x06)
#define REG_FRC_BK3D_06_H      FRC_PK_H_(0x3D, 0x06)
#define REG_FRC_BK3D_07_L      FRC_PK_L_(0x3D, 0x07)
#define REG_FRC_BK3D_07_H      FRC_PK_H_(0x3D, 0x07)
#define REG_FRC_BK3D_08_L      FRC_PK_L_(0x3D, 0x08)
#define REG_FRC_BK3D_08_H      FRC_PK_H_(0x3D, 0x08)
#define REG_FRC_BK3D_09_L      FRC_PK_L_(0x3D, 0x09)
#define REG_FRC_BK3D_09_H      FRC_PK_H_(0x3D, 0x09)
#define REG_FRC_BK3D_0A_L      FRC_PK_L_(0x3D, 0x0A)
#define REG_FRC_BK3D_0A_H      FRC_PK_H_(0x3D, 0x0A)
#define REG_FRC_BK3D_0B_L      FRC_PK_L_(0x3D, 0x0B)
#define REG_FRC_BK3D_0B_H      FRC_PK_H_(0x3D, 0x0B)
#define REG_FRC_BK3D_0C_L      FRC_PK_L_(0x3D, 0x0C)
#define REG_FRC_BK3D_0C_H      FRC_PK_H_(0x3D, 0x0C)
#define REG_FRC_BK3D_0D_L      FRC_PK_L_(0x3D, 0x0D)
#define REG_FRC_BK3D_0D_H      FRC_PK_H_(0x3D, 0x0D)
#define REG_FRC_BK3D_0E_L      FRC_PK_L_(0x3D, 0x0E)
#define REG_FRC_BK3D_0E_H      FRC_PK_H_(0x3D, 0x0E)
#define REG_FRC_BK3D_0F_L      FRC_PK_L_(0x3D, 0x0F)
#define REG_FRC_BK3D_0F_H      FRC_PK_H_(0x3D, 0x0F)
#define REG_FRC_BK3D_10_L      FRC_PK_L_(0x3D, 0x10)
#define REG_FRC_BK3D_10_H      FRC_PK_H_(0x3D, 0x10)
#define REG_FRC_BK3D_11_L      FRC_PK_L_(0x3D, 0x11)
#define REG_FRC_BK3D_11_H      FRC_PK_H_(0x3D, 0x11)
#define REG_FRC_BK3D_12_L      FRC_PK_L_(0x3D, 0x12)
#define REG_FRC_BK3D_12_H      FRC_PK_H_(0x3D, 0x12)
#define REG_FRC_BK3D_13_L      FRC_PK_L_(0x3D, 0x13)
#define REG_FRC_BK3D_13_H      FRC_PK_H_(0x3D, 0x13)
#define REG_FRC_BK3D_14_L      FRC_PK_L_(0x3D, 0x14)
#define REG_FRC_BK3D_14_H      FRC_PK_H_(0x3D, 0x14)
#define REG_FRC_BK3D_15_L      FRC_PK_L_(0x3D, 0x15)
#define REG_FRC_BK3D_15_H      FRC_PK_H_(0x3D, 0x15)
#define REG_FRC_BK3D_16_L      FRC_PK_L_(0x3D, 0x16)
#define REG_FRC_BK3D_16_H      FRC_PK_H_(0x3D, 0x16)
#define REG_FRC_BK3D_17_L      FRC_PK_L_(0x3D, 0x17)
#define REG_FRC_BK3D_17_H      FRC_PK_H_(0x3D, 0x17)
#define REG_FRC_BK3D_18_L      FRC_PK_L_(0x3D, 0x18)
#define REG_FRC_BK3D_18_H      FRC_PK_H_(0x3D, 0x18)
#define REG_FRC_BK3D_19_L      FRC_PK_L_(0x3D, 0x19)
#define REG_FRC_BK3D_19_H      FRC_PK_H_(0x3D, 0x19)
#define REG_FRC_BK3D_1A_L      FRC_PK_L_(0x3D, 0x1A)
#define REG_FRC_BK3D_1A_H      FRC_PK_H_(0x3D, 0x1A)
#define REG_FRC_BK3D_1B_L      FRC_PK_L_(0x3D, 0x1B)
#define REG_FRC_BK3D_1B_H      FRC_PK_H_(0x3D, 0x1B)
#define REG_FRC_BK3D_1C_L      FRC_PK_L_(0x3D, 0x1C)
#define REG_FRC_BK3D_1C_H      FRC_PK_H_(0x3D, 0x1C)
#define REG_FRC_BK3D_1D_L      FRC_PK_L_(0x3D, 0x1D)
#define REG_FRC_BK3D_1D_H      FRC_PK_H_(0x3D, 0x1D)
#define REG_FRC_BK3D_1E_L      FRC_PK_L_(0x3D, 0x1E)
#define REG_FRC_BK3D_1E_H      FRC_PK_H_(0x3D, 0x1E)
#define REG_FRC_BK3D_1F_L      FRC_PK_L_(0x3D, 0x1F)
#define REG_FRC_BK3D_1F_H      FRC_PK_H_(0x3D, 0x1F)
#define REG_FRC_BK3D_20_L      FRC_PK_L_(0x3D, 0x20)
#define REG_FRC_BK3D_20_H      FRC_PK_H_(0x3D, 0x20)
#define REG_FRC_BK3D_21_L      FRC_PK_L_(0x3D, 0x21)
#define REG_FRC_BK3D_21_H      FRC_PK_H_(0x3D, 0x21)
#define REG_FRC_BK3D_22_L      FRC_PK_L_(0x3D, 0x22)
#define REG_FRC_BK3D_22_H      FRC_PK_H_(0x3D, 0x22)
#define REG_FRC_BK3D_23_L      FRC_PK_L_(0x3D, 0x23)
#define REG_FRC_BK3D_23_H      FRC_PK_H_(0x3D, 0x23)
#define REG_FRC_BK3D_24_L      FRC_PK_L_(0x3D, 0x24)
#define REG_FRC_BK3D_24_H      FRC_PK_H_(0x3D, 0x24)
#define REG_FRC_BK3D_25_L      FRC_PK_L_(0x3D, 0x25)
#define REG_FRC_BK3D_25_H      FRC_PK_H_(0x3D, 0x25)
#define REG_FRC_BK3D_26_L      FRC_PK_L_(0x3D, 0x26)
#define REG_FRC_BK3D_26_H      FRC_PK_H_(0x3D, 0x26)
#define REG_FRC_BK3D_27_L      FRC_PK_L_(0x3D, 0x27)
#define REG_FRC_BK3D_27_H      FRC_PK_H_(0x3D, 0x27)
#define REG_FRC_BK3D_28_L      FRC_PK_L_(0x3D, 0x28)
#define REG_FRC_BK3D_28_H      FRC_PK_H_(0x3D, 0x28)
#define REG_FRC_BK3D_29_L      FRC_PK_L_(0x3D, 0x29)
#define REG_FRC_BK3D_29_H      FRC_PK_H_(0x3D, 0x29)
#define REG_FRC_BK3D_2A_L      FRC_PK_L_(0x3D, 0x2A)
#define REG_FRC_BK3D_2A_H      FRC_PK_H_(0x3D, 0x2A)
#define REG_FRC_BK3D_2B_L      FRC_PK_L_(0x3D, 0x2B)
#define REG_FRC_BK3D_2B_H      FRC_PK_H_(0x3D, 0x2B)
#define REG_FRC_BK3D_2C_L      FRC_PK_L_(0x3D, 0x2C)
#define REG_FRC_BK3D_2C_H      FRC_PK_H_(0x3D, 0x2C)
#define REG_FRC_BK3D_2D_L      FRC_PK_L_(0x3D, 0x2D)
#define REG_FRC_BK3D_2D_H      FRC_PK_H_(0x3D, 0x2D)
#define REG_FRC_BK3D_2E_L      FRC_PK_L_(0x3D, 0x2E)
#define REG_FRC_BK3D_2E_H      FRC_PK_H_(0x3D, 0x2E)
#define REG_FRC_BK3D_2F_L      FRC_PK_L_(0x3D, 0x2F)
#define REG_FRC_BK3D_2F_H      FRC_PK_H_(0x3D, 0x2F)
#define REG_FRC_BK3D_30_L      FRC_PK_L_(0x3D, 0x30)
#define REG_FRC_BK3D_30_H      FRC_PK_H_(0x3D, 0x30)
#define REG_FRC_BK3D_31_L      FRC_PK_L_(0x3D, 0x31)
#define REG_FRC_BK3D_31_H      FRC_PK_H_(0x3D, 0x31)
#define REG_FRC_BK3D_32_L      FRC_PK_L_(0x3D, 0x32)
#define REG_FRC_BK3D_32_H      FRC_PK_H_(0x3D, 0x32)
#define REG_FRC_BK3D_33_L      FRC_PK_L_(0x3D, 0x33)
#define REG_FRC_BK3D_33_H      FRC_PK_H_(0x3D, 0x33)
#define REG_FRC_BK3D_34_L      FRC_PK_L_(0x3D, 0x34)
#define REG_FRC_BK3D_34_H      FRC_PK_H_(0x3D, 0x34)
#define REG_FRC_BK3D_35_L      FRC_PK_L_(0x3D, 0x35)
#define REG_FRC_BK3D_35_H      FRC_PK_H_(0x3D, 0x35)
#define REG_FRC_BK3D_36_L      FRC_PK_L_(0x3D, 0x36)
#define REG_FRC_BK3D_36_H      FRC_PK_H_(0x3D, 0x36)
#define REG_FRC_BK3D_37_L      FRC_PK_L_(0x3D, 0x37)
#define REG_FRC_BK3D_37_H      FRC_PK_H_(0x3D, 0x37)
#define REG_FRC_BK3D_38_L      FRC_PK_L_(0x3D, 0x38)
#define REG_FRC_BK3D_38_H      FRC_PK_H_(0x3D, 0x38)
#define REG_FRC_BK3D_39_L      FRC_PK_L_(0x3D, 0x39)
#define REG_FRC_BK3D_39_H      FRC_PK_H_(0x3D, 0x39)
#define REG_FRC_BK3D_3A_L      FRC_PK_L_(0x3D, 0x3A)
#define REG_FRC_BK3D_3A_H      FRC_PK_H_(0x3D, 0x3A)
#define REG_FRC_BK3D_3B_L      FRC_PK_L_(0x3D, 0x3B)
#define REG_FRC_BK3D_3B_H      FRC_PK_H_(0x3D, 0x3B)
#define REG_FRC_BK3D_3C_L      FRC_PK_L_(0x3D, 0x3C)
#define REG_FRC_BK3D_3C_H      FRC_PK_H_(0x3D, 0x3C)
#define REG_FRC_BK3D_3D_L      FRC_PK_L_(0x3D, 0x3D)
#define REG_FRC_BK3D_3D_H      FRC_PK_H_(0x3D, 0x3D)
#define REG_FRC_BK3D_3E_L      FRC_PK_L_(0x3D, 0x3E)
#define REG_FRC_BK3D_3E_H      FRC_PK_H_(0x3D, 0x3E)
#define REG_FRC_BK3D_3F_L      FRC_PK_L_(0x3D, 0x3F)
#define REG_FRC_BK3D_3F_H      FRC_PK_H_(0x3D, 0x3F)
#define REG_FRC_BK3D_40_L      FRC_PK_L_(0x3D, 0x40)
#define REG_FRC_BK3D_40_H      FRC_PK_H_(0x3D, 0x40)
#define REG_FRC_BK3D_41_L      FRC_PK_L_(0x3D, 0x41)
#define REG_FRC_BK3D_41_H      FRC_PK_H_(0x3D, 0x41)
#define REG_FRC_BK3D_42_L      FRC_PK_L_(0x3D, 0x42)
#define REG_FRC_BK3D_42_H      FRC_PK_H_(0x3D, 0x42)
#define REG_FRC_BK3D_43_L      FRC_PK_L_(0x3D, 0x43)
#define REG_FRC_BK3D_43_H      FRC_PK_H_(0x3D, 0x43)
#define REG_FRC_BK3D_44_L      FRC_PK_L_(0x3D, 0x44)
#define REG_FRC_BK3D_44_H      FRC_PK_H_(0x3D, 0x44)
#define REG_FRC_BK3D_45_L      FRC_PK_L_(0x3D, 0x45)
#define REG_FRC_BK3D_45_H      FRC_PK_H_(0x3D, 0x45)
#define REG_FRC_BK3D_46_L      FRC_PK_L_(0x3D, 0x46)
#define REG_FRC_BK3D_46_H      FRC_PK_H_(0x3D, 0x46)
#define REG_FRC_BK3D_47_L      FRC_PK_L_(0x3D, 0x47)
#define REG_FRC_BK3D_47_H      FRC_PK_H_(0x3D, 0x47)
#define REG_FRC_BK3D_48_L      FRC_PK_L_(0x3D, 0x48)
#define REG_FRC_BK3D_48_H      FRC_PK_H_(0x3D, 0x48)
#define REG_FRC_BK3D_49_L      FRC_PK_L_(0x3D, 0x49)
#define REG_FRC_BK3D_49_H      FRC_PK_H_(0x3D, 0x49)
#define REG_FRC_BK3D_4A_L      FRC_PK_L_(0x3D, 0x4A)
#define REG_FRC_BK3D_4A_H      FRC_PK_H_(0x3D, 0x4A)
#define REG_FRC_BK3D_4B_L      FRC_PK_L_(0x3D, 0x4B)
#define REG_FRC_BK3D_4B_H      FRC_PK_H_(0x3D, 0x4B)
#define REG_FRC_BK3D_4C_L      FRC_PK_L_(0x3D, 0x4C)
#define REG_FRC_BK3D_4C_H      FRC_PK_H_(0x3D, 0x4C)
#define REG_FRC_BK3D_4D_L      FRC_PK_L_(0x3D, 0x4D)
#define REG_FRC_BK3D_4D_H      FRC_PK_H_(0x3D, 0x4D)
#define REG_FRC_BK3D_4E_L      FRC_PK_L_(0x3D, 0x4E)
#define REG_FRC_BK3D_4E_H      FRC_PK_H_(0x3D, 0x4E)
#define REG_FRC_BK3D_4F_L      FRC_PK_L_(0x3D, 0x4F)
#define REG_FRC_BK3D_4F_H      FRC_PK_H_(0x3D, 0x4F)
#define REG_FRC_BK3D_50_L      FRC_PK_L_(0x3D, 0x50)
#define REG_FRC_BK3D_50_H      FRC_PK_H_(0x3D, 0x50)
#define REG_FRC_BK3D_51_L      FRC_PK_L_(0x3D, 0x51)
#define REG_FRC_BK3D_51_H      FRC_PK_H_(0x3D, 0x51)
#define REG_FRC_BK3D_52_L      FRC_PK_L_(0x3D, 0x52)
#define REG_FRC_BK3D_52_H      FRC_PK_H_(0x3D, 0x52)
#define REG_FRC_BK3D_53_L      FRC_PK_L_(0x3D, 0x53)
#define REG_FRC_BK3D_53_H      FRC_PK_H_(0x3D, 0x53)
#define REG_FRC_BK3D_54_L      FRC_PK_L_(0x3D, 0x54)
#define REG_FRC_BK3D_54_H      FRC_PK_H_(0x3D, 0x54)
#define REG_FRC_BK3D_55_L      FRC_PK_L_(0x3D, 0x55)
#define REG_FRC_BK3D_55_H      FRC_PK_H_(0x3D, 0x55)
#define REG_FRC_BK3D_56_L      FRC_PK_L_(0x3D, 0x56)
#define REG_FRC_BK3D_56_H      FRC_PK_H_(0x3D, 0x56)
#define REG_FRC_BK3D_57_L      FRC_PK_L_(0x3D, 0x57)
#define REG_FRC_BK3D_57_H      FRC_PK_H_(0x3D, 0x57)
#define REG_FRC_BK3D_58_L      FRC_PK_L_(0x3D, 0x58)
#define REG_FRC_BK3D_58_H      FRC_PK_H_(0x3D, 0x58)
#define REG_FRC_BK3D_59_L      FRC_PK_L_(0x3D, 0x59)
#define REG_FRC_BK3D_59_H      FRC_PK_H_(0x3D, 0x59)
#define REG_FRC_BK3D_5A_L      FRC_PK_L_(0x3D, 0x5A)
#define REG_FRC_BK3D_5A_H      FRC_PK_H_(0x3D, 0x5A)
#define REG_FRC_BK3D_5B_L      FRC_PK_L_(0x3D, 0x5B)
#define REG_FRC_BK3D_5B_H      FRC_PK_H_(0x3D, 0x5B)
#define REG_FRC_BK3D_5C_L      FRC_PK_L_(0x3D, 0x5C)
#define REG_FRC_BK3D_5C_H      FRC_PK_H_(0x3D, 0x5C)
#define REG_FRC_BK3D_5D_L      FRC_PK_L_(0x3D, 0x5D)
#define REG_FRC_BK3D_5D_H      FRC_PK_H_(0x3D, 0x5D)
#define REG_FRC_BK3D_5E_L      FRC_PK_L_(0x3D, 0x5E)
#define REG_FRC_BK3D_5E_H      FRC_PK_H_(0x3D, 0x5E)
#define REG_FRC_BK3D_5F_L      FRC_PK_L_(0x3D, 0x5F)
#define REG_FRC_BK3D_5F_H      FRC_PK_H_(0x3D, 0x5F)
#define REG_FRC_BK3D_60_L      FRC_PK_L_(0x3D, 0x60)
#define REG_FRC_BK3D_60_H      FRC_PK_H_(0x3D, 0x60)
#define REG_FRC_BK3D_61_L      FRC_PK_L_(0x3D, 0x61)
#define REG_FRC_BK3D_61_H      FRC_PK_H_(0x3D, 0x61)
#define REG_FRC_BK3D_62_L      FRC_PK_L_(0x3D, 0x62)
#define REG_FRC_BK3D_62_H      FRC_PK_H_(0x3D, 0x62)
#define REG_FRC_BK3D_63_L      FRC_PK_L_(0x3D, 0x63)
#define REG_FRC_BK3D_63_H      FRC_PK_H_(0x3D, 0x63)
#define REG_FRC_BK3D_64_L      FRC_PK_L_(0x3D, 0x64)
#define REG_FRC_BK3D_64_H      FRC_PK_H_(0x3D, 0x64)
#define REG_FRC_BK3D_65_L      FRC_PK_L_(0x3D, 0x65)
#define REG_FRC_BK3D_65_H      FRC_PK_H_(0x3D, 0x65)
#define REG_FRC_BK3D_66_L      FRC_PK_L_(0x3D, 0x66)
#define REG_FRC_BK3D_66_H      FRC_PK_H_(0x3D, 0x66)
#define REG_FRC_BK3D_67_L      FRC_PK_L_(0x3D, 0x67)
#define REG_FRC_BK3D_67_H      FRC_PK_H_(0x3D, 0x67)
#define REG_FRC_BK3D_68_L      FRC_PK_L_(0x3D, 0x68)
#define REG_FRC_BK3D_68_H      FRC_PK_H_(0x3D, 0x68)
#define REG_FRC_BK3D_69_L      FRC_PK_L_(0x3D, 0x69)
#define REG_FRC_BK3D_69_H      FRC_PK_H_(0x3D, 0x69)
#define REG_FRC_BK3D_6A_L      FRC_PK_L_(0x3D, 0x6A)
#define REG_FRC_BK3D_6A_H      FRC_PK_H_(0x3D, 0x6A)
#define REG_FRC_BK3D_6B_L      FRC_PK_L_(0x3D, 0x6B)
#define REG_FRC_BK3D_6B_H      FRC_PK_H_(0x3D, 0x6B)
#define REG_FRC_BK3D_6C_L      FRC_PK_L_(0x3D, 0x6C)
#define REG_FRC_BK3D_6C_H      FRC_PK_H_(0x3D, 0x6C)
#define REG_FRC_BK3D_6D_L      FRC_PK_L_(0x3D, 0x6D)
#define REG_FRC_BK3D_6D_H      FRC_PK_H_(0x3D, 0x6D)
#define REG_FRC_BK3D_6E_L      FRC_PK_L_(0x3D, 0x6E)
#define REG_FRC_BK3D_6E_H      FRC_PK_H_(0x3D, 0x6E)
#define REG_FRC_BK3D_6F_L      FRC_PK_L_(0x3D, 0x6F)
#define REG_FRC_BK3D_6F_H      FRC_PK_H_(0x3D, 0x6F)
#define REG_FRC_BK3D_70_L      FRC_PK_L_(0x3D, 0x70)
#define REG_FRC_BK3D_70_H      FRC_PK_H_(0x3D, 0x70)
#define REG_FRC_BK3D_71_L      FRC_PK_L_(0x3D, 0x71)
#define REG_FRC_BK3D_71_H      FRC_PK_H_(0x3D, 0x71)
#define REG_FRC_BK3D_72_L      FRC_PK_L_(0x3D, 0x72)
#define REG_FRC_BK3D_72_H      FRC_PK_H_(0x3D, 0x72)
#define REG_FRC_BK3D_73_L      FRC_PK_L_(0x3D, 0x73)
#define REG_FRC_BK3D_73_H      FRC_PK_H_(0x3D, 0x73)
#define REG_FRC_BK3D_74_L      FRC_PK_L_(0x3D, 0x74)
#define REG_FRC_BK3D_74_H      FRC_PK_H_(0x3D, 0x74)
#define REG_FRC_BK3D_75_L      FRC_PK_L_(0x3D, 0x75)
#define REG_FRC_BK3D_75_H      FRC_PK_H_(0x3D, 0x75)
#define REG_FRC_BK3D_76_L      FRC_PK_L_(0x3D, 0x76)
#define REG_FRC_BK3D_76_H      FRC_PK_H_(0x3D, 0x76)
#define REG_FRC_BK3D_77_L      FRC_PK_L_(0x3D, 0x77)
#define REG_FRC_BK3D_77_H      FRC_PK_H_(0x3D, 0x77)
#define REG_FRC_BK3D_78_L      FRC_PK_L_(0x3D, 0x78)
#define REG_FRC_BK3D_78_H      FRC_PK_H_(0x3D, 0x78)
#define REG_FRC_BK3D_79_L      FRC_PK_L_(0x3D, 0x79)
#define REG_FRC_BK3D_79_H      FRC_PK_H_(0x3D, 0x79)
#define REG_FRC_BK3D_7A_L      FRC_PK_L_(0x3D, 0x7A)
#define REG_FRC_BK3D_7A_H      FRC_PK_H_(0x3D, 0x7A)
#define REG_FRC_BK3D_7B_L      FRC_PK_L_(0x3D, 0x7B)
#define REG_FRC_BK3D_7B_H      FRC_PK_H_(0x3D, 0x7B)
#define REG_FRC_BK3D_7C_L      FRC_PK_L_(0x3D, 0x7C)
#define REG_FRC_BK3D_7C_H      FRC_PK_H_(0x3D, 0x7C)
#define REG_FRC_BK3D_7D_L      FRC_PK_L_(0x3D, 0x7D)
#define REG_FRC_BK3D_7D_H      FRC_PK_H_(0x3D, 0x7D)
#define REG_FRC_BK3D_7E_L      FRC_PK_L_(0x3D, 0x7E)
#define REG_FRC_BK3D_7E_H      FRC_PK_H_(0x3D, 0x7E)
#define REG_FRC_BK3D_7F_L      FRC_PK_L_(0x3D, 0x7F)
#define REG_FRC_BK3D_7F_H      FRC_PK_H_(0x3D, 0x7F)

//----------------------------------------------
//  BK3F
//----------------------------------------------
#define REG_FRC_BK3F_00_L      FRC_PK_L_(0x3F, 0x00)
#define REG_FRC_BK3F_00_H      FRC_PK_H_(0x3F, 0x00)
#define REG_FRC_BK3F_01_L      FRC_PK_L_(0x3F, 0x01)
#define REG_FRC_BK3F_01_H      FRC_PK_H_(0x3F, 0x01)
#define REG_FRC_BK3F_02_L      FRC_PK_L_(0x3F, 0x02)
#define REG_FRC_BK3F_02_H      FRC_PK_H_(0x3F, 0x02)
#define REG_FRC_BK3F_03_L      FRC_PK_L_(0x3F, 0x03)
#define REG_FRC_BK3F_03_H      FRC_PK_H_(0x3F, 0x03)
#define REG_FRC_BK3F_04_L      FRC_PK_L_(0x3F, 0x04)
#define REG_FRC_BK3F_04_H      FRC_PK_H_(0x3F, 0x04)
#define REG_FRC_BK3F_05_L      FRC_PK_L_(0x3F, 0x05)
#define REG_FRC_BK3F_05_H      FRC_PK_H_(0x3F, 0x05)
#define REG_FRC_BK3F_06_L      FRC_PK_L_(0x3F, 0x06)
#define REG_FRC_BK3F_06_H      FRC_PK_H_(0x3F, 0x06)
#define REG_FRC_BK3F_07_L      FRC_PK_L_(0x3F, 0x07)
#define REG_FRC_BK3F_07_H      FRC_PK_H_(0x3F, 0x07)
#define REG_FRC_BK3F_08_L      FRC_PK_L_(0x3F, 0x08)
#define REG_FRC_BK3F_08_H      FRC_PK_H_(0x3F, 0x08)
#define REG_FRC_BK3F_09_L      FRC_PK_L_(0x3F, 0x09)
#define REG_FRC_BK3F_09_H      FRC_PK_H_(0x3F, 0x09)
#define REG_FRC_BK3F_0A_L      FRC_PK_L_(0x3F, 0x0A)
#define REG_FRC_BK3F_0A_H      FRC_PK_H_(0x3F, 0x0A)
#define REG_FRC_BK3F_0B_L      FRC_PK_L_(0x3F, 0x0B)
#define REG_FRC_BK3F_0B_H      FRC_PK_H_(0x3F, 0x0B)
#define REG_FRC_BK3F_0C_L      FRC_PK_L_(0x3F, 0x0C)
#define REG_FRC_BK3F_0C_H      FRC_PK_H_(0x3F, 0x0C)
#define REG_FRC_BK3F_0D_L      FRC_PK_L_(0x3F, 0x0D)
#define REG_FRC_BK3F_0D_H      FRC_PK_H_(0x3F, 0x0D)
#define REG_FRC_BK3F_0E_L      FRC_PK_L_(0x3F, 0x0E)
#define REG_FRC_BK3F_0E_H      FRC_PK_H_(0x3F, 0x0E)
#define REG_FRC_BK3F_0F_L      FRC_PK_L_(0x3F, 0x0F)
#define REG_FRC_BK3F_0F_H      FRC_PK_H_(0x3F, 0x0F)
#define REG_FRC_BK3F_10_L      FRC_PK_L_(0x3F, 0x10)
#define REG_FRC_BK3F_10_H      FRC_PK_H_(0x3F, 0x10)
#define REG_FRC_BK3F_11_L      FRC_PK_L_(0x3F, 0x11)
#define REG_FRC_BK3F_11_H      FRC_PK_H_(0x3F, 0x11)
#define REG_FRC_BK3F_12_L      FRC_PK_L_(0x3F, 0x12)
#define REG_FRC_BK3F_12_H      FRC_PK_H_(0x3F, 0x12)
#define REG_FRC_BK3F_13_L      FRC_PK_L_(0x3F, 0x13)
#define REG_FRC_BK3F_13_H      FRC_PK_H_(0x3F, 0x13)
#define REG_FRC_BK3F_14_L      FRC_PK_L_(0x3F, 0x14)
#define REG_FRC_BK3F_14_H      FRC_PK_H_(0x3F, 0x14)
#define REG_FRC_BK3F_15_L      FRC_PK_L_(0x3F, 0x15)
#define REG_FRC_BK3F_15_H      FRC_PK_H_(0x3F, 0x15)
#define REG_FRC_BK3F_16_L      FRC_PK_L_(0x3F, 0x16)
#define REG_FRC_BK3F_16_H      FRC_PK_H_(0x3F, 0x16)
#define REG_FRC_BK3F_17_L      FRC_PK_L_(0x3F, 0x17)
#define REG_FRC_BK3F_17_H      FRC_PK_H_(0x3F, 0x17)
#define REG_FRC_BK3F_18_L      FRC_PK_L_(0x3F, 0x18)
#define REG_FRC_BK3F_18_H      FRC_PK_H_(0x3F, 0x18)
#define REG_FRC_BK3F_19_L      FRC_PK_L_(0x3F, 0x19)
#define REG_FRC_BK3F_19_H      FRC_PK_H_(0x3F, 0x19)
#define REG_FRC_BK3F_1A_L      FRC_PK_L_(0x3F, 0x1A)
#define REG_FRC_BK3F_1A_H      FRC_PK_H_(0x3F, 0x1A)
#define REG_FRC_BK3F_1B_L      FRC_PK_L_(0x3F, 0x1B)
#define REG_FRC_BK3F_1B_H      FRC_PK_H_(0x3F, 0x1B)
#define REG_FRC_BK3F_1C_L      FRC_PK_L_(0x3F, 0x1C)
#define REG_FRC_BK3F_1C_H      FRC_PK_H_(0x3F, 0x1C)
#define REG_FRC_BK3F_1D_L      FRC_PK_L_(0x3F, 0x1D)
#define REG_FRC_BK3F_1D_H      FRC_PK_H_(0x3F, 0x1D)
#define REG_FRC_BK3F_1E_L      FRC_PK_L_(0x3F, 0x1E)
#define REG_FRC_BK3F_1E_H      FRC_PK_H_(0x3F, 0x1E)
#define REG_FRC_BK3F_1F_L      FRC_PK_L_(0x3F, 0x1F)
#define REG_FRC_BK3F_1F_H      FRC_PK_H_(0x3F, 0x1F)
#define REG_FRC_BK3F_20_L      FRC_PK_L_(0x3F, 0x20)
#define REG_FRC_BK3F_20_H      FRC_PK_H_(0x3F, 0x20)
#define REG_FRC_BK3F_21_L      FRC_PK_L_(0x3F, 0x21)
#define REG_FRC_BK3F_21_H      FRC_PK_H_(0x3F, 0x21)
#define REG_FRC_BK3F_22_L      FRC_PK_L_(0x3F, 0x22)
#define REG_FRC_BK3F_22_H      FRC_PK_H_(0x3F, 0x22)
#define REG_FRC_BK3F_23_L      FRC_PK_L_(0x3F, 0x23)
#define REG_FRC_BK3F_23_H      FRC_PK_H_(0x3F, 0x23)
#define REG_FRC_BK3F_24_L      FRC_PK_L_(0x3F, 0x24)
#define REG_FRC_BK3F_24_H      FRC_PK_H_(0x3F, 0x24)
#define REG_FRC_BK3F_25_L      FRC_PK_L_(0x3F, 0x25)
#define REG_FRC_BK3F_25_H      FRC_PK_H_(0x3F, 0x25)
#define REG_FRC_BK3F_26_L      FRC_PK_L_(0x3F, 0x26)
#define REG_FRC_BK3F_26_H      FRC_PK_H_(0x3F, 0x26)
#define REG_FRC_BK3F_27_L      FRC_PK_L_(0x3F, 0x27)
#define REG_FRC_BK3F_27_H      FRC_PK_H_(0x3F, 0x27)
#define REG_FRC_BK3F_28_L      FRC_PK_L_(0x3F, 0x28)
#define REG_FRC_BK3F_28_H      FRC_PK_H_(0x3F, 0x28)
#define REG_FRC_BK3F_29_L      FRC_PK_L_(0x3F, 0x29)
#define REG_FRC_BK3F_29_H      FRC_PK_H_(0x3F, 0x29)
#define REG_FRC_BK3F_2A_L      FRC_PK_L_(0x3F, 0x2A)
#define REG_FRC_BK3F_2A_H      FRC_PK_H_(0x3F, 0x2A)
#define REG_FRC_BK3F_2B_L      FRC_PK_L_(0x3F, 0x2B)
#define REG_FRC_BK3F_2B_H      FRC_PK_H_(0x3F, 0x2B)
#define REG_FRC_BK3F_2C_L      FRC_PK_L_(0x3F, 0x2C)
#define REG_FRC_BK3F_2C_H      FRC_PK_H_(0x3F, 0x2C)
#define REG_FRC_BK3F_2D_L      FRC_PK_L_(0x3F, 0x2D)
#define REG_FRC_BK3F_2D_H      FRC_PK_H_(0x3F, 0x2D)
#define REG_FRC_BK3F_2E_L      FRC_PK_L_(0x3F, 0x2E)
#define REG_FRC_BK3F_2E_H      FRC_PK_H_(0x3F, 0x2E)
#define REG_FRC_BK3F_2F_L      FRC_PK_L_(0x3F, 0x2F)
#define REG_FRC_BK3F_2F_H      FRC_PK_H_(0x3F, 0x2F)
#define REG_FRC_BK3F_30_L      FRC_PK_L_(0x3F, 0x30)
#define REG_FRC_BK3F_30_H      FRC_PK_H_(0x3F, 0x30)
#define REG_FRC_BK3F_31_L      FRC_PK_L_(0x3F, 0x31)
#define REG_FRC_BK3F_31_H      FRC_PK_H_(0x3F, 0x31)
#define REG_FRC_BK3F_32_L      FRC_PK_L_(0x3F, 0x32)
#define REG_FRC_BK3F_32_H      FRC_PK_H_(0x3F, 0x32)
#define REG_FRC_BK3F_33_L      FRC_PK_L_(0x3F, 0x33)
#define REG_FRC_BK3F_33_H      FRC_PK_H_(0x3F, 0x33)
#define REG_FRC_BK3F_34_L      FRC_PK_L_(0x3F, 0x34)
#define REG_FRC_BK3F_34_H      FRC_PK_H_(0x3F, 0x34)
#define REG_FRC_BK3F_35_L      FRC_PK_L_(0x3F, 0x35)
#define REG_FRC_BK3F_35_H      FRC_PK_H_(0x3F, 0x35)
#define REG_FRC_BK3F_36_L      FRC_PK_L_(0x3F, 0x36)
#define REG_FRC_BK3F_36_H      FRC_PK_H_(0x3F, 0x36)
#define REG_FRC_BK3F_37_L      FRC_PK_L_(0x3F, 0x37)
#define REG_FRC_BK3F_37_H      FRC_PK_H_(0x3F, 0x37)
#define REG_FRC_BK3F_38_L      FRC_PK_L_(0x3F, 0x38)
#define REG_FRC_BK3F_38_H      FRC_PK_H_(0x3F, 0x38)
#define REG_FRC_BK3F_39_L      FRC_PK_L_(0x3F, 0x39)
#define REG_FRC_BK3F_39_H      FRC_PK_H_(0x3F, 0x39)
#define REG_FRC_BK3F_3A_L      FRC_PK_L_(0x3F, 0x3A)
#define REG_FRC_BK3F_3A_H      FRC_PK_H_(0x3F, 0x3A)
#define REG_FRC_BK3F_3B_L      FRC_PK_L_(0x3F, 0x3B)
#define REG_FRC_BK3F_3B_H      FRC_PK_H_(0x3F, 0x3B)
#define REG_FRC_BK3F_3C_L      FRC_PK_L_(0x3F, 0x3C)
#define REG_FRC_BK3F_3C_H      FRC_PK_H_(0x3F, 0x3C)
#define REG_FRC_BK3F_3D_L      FRC_PK_L_(0x3F, 0x3D)
#define REG_FRC_BK3F_3D_H      FRC_PK_H_(0x3F, 0x3D)
#define REG_FRC_BK3F_3E_L      FRC_PK_L_(0x3F, 0x3E)
#define REG_FRC_BK3F_3E_H      FRC_PK_H_(0x3F, 0x3E)
#define REG_FRC_BK3F_3F_L      FRC_PK_L_(0x3F, 0x3F)
#define REG_FRC_BK3F_3F_H      FRC_PK_H_(0x3F, 0x3F)
#define REG_FRC_BK3F_40_L      FRC_PK_L_(0x3F, 0x40)
#define REG_FRC_BK3F_40_H      FRC_PK_H_(0x3F, 0x40)
#define REG_FRC_BK3F_41_L      FRC_PK_L_(0x3F, 0x41)
#define REG_FRC_BK3F_41_H      FRC_PK_H_(0x3F, 0x41)
#define REG_FRC_BK3F_42_L      FRC_PK_L_(0x3F, 0x42)
#define REG_FRC_BK3F_42_H      FRC_PK_H_(0x3F, 0x42)
#define REG_FRC_BK3F_43_L      FRC_PK_L_(0x3F, 0x43)
#define REG_FRC_BK3F_43_H      FRC_PK_H_(0x3F, 0x43)
#define REG_FRC_BK3F_44_L      FRC_PK_L_(0x3F, 0x44)
#define REG_FRC_BK3F_44_H      FRC_PK_H_(0x3F, 0x44)
#define REG_FRC_BK3F_45_L      FRC_PK_L_(0x3F, 0x45)
#define REG_FRC_BK3F_45_H      FRC_PK_H_(0x3F, 0x45)
#define REG_FRC_BK3F_46_L      FRC_PK_L_(0x3F, 0x46)
#define REG_FRC_BK3F_46_H      FRC_PK_H_(0x3F, 0x46)
#define REG_FRC_BK3F_47_L      FRC_PK_L_(0x3F, 0x47)
#define REG_FRC_BK3F_47_H      FRC_PK_H_(0x3F, 0x47)
#define REG_FRC_BK3F_48_L      FRC_PK_L_(0x3F, 0x48)
#define REG_FRC_BK3F_48_H      FRC_PK_H_(0x3F, 0x48)
#define REG_FRC_BK3F_49_L      FRC_PK_L_(0x3F, 0x49)
#define REG_FRC_BK3F_49_H      FRC_PK_H_(0x3F, 0x49)
#define REG_FRC_BK3F_4A_L      FRC_PK_L_(0x3F, 0x4A)
#define REG_FRC_BK3F_4A_H      FRC_PK_H_(0x3F, 0x4A)
#define REG_FRC_BK3F_4B_L      FRC_PK_L_(0x3F, 0x4B)
#define REG_FRC_BK3F_4B_H      FRC_PK_H_(0x3F, 0x4B)
#define REG_FRC_BK3F_4C_L      FRC_PK_L_(0x3F, 0x4C)
#define REG_FRC_BK3F_4C_H      FRC_PK_H_(0x3F, 0x4C)
#define REG_FRC_BK3F_4D_L      FRC_PK_L_(0x3F, 0x4D)
#define REG_FRC_BK3F_4D_H      FRC_PK_H_(0x3F, 0x4D)
#define REG_FRC_BK3F_4E_L      FRC_PK_L_(0x3F, 0x4E)
#define REG_FRC_BK3F_4E_H      FRC_PK_H_(0x3F, 0x4E)
#define REG_FRC_BK3F_4F_L      FRC_PK_L_(0x3F, 0x4F)
#define REG_FRC_BK3F_4F_H      FRC_PK_H_(0x3F, 0x4F)
#define REG_FRC_BK3F_50_L      FRC_PK_L_(0x3F, 0x50)
#define REG_FRC_BK3F_50_H      FRC_PK_H_(0x3F, 0x50)
#define REG_FRC_BK3F_51_L      FRC_PK_L_(0x3F, 0x51)
#define REG_FRC_BK3F_51_H      FRC_PK_H_(0x3F, 0x51)
#define REG_FRC_BK3F_52_L      FRC_PK_L_(0x3F, 0x52)
#define REG_FRC_BK3F_52_H      FRC_PK_H_(0x3F, 0x52)
#define REG_FRC_BK3F_53_L      FRC_PK_L_(0x3F, 0x53)
#define REG_FRC_BK3F_53_H      FRC_PK_H_(0x3F, 0x53)
#define REG_FRC_BK3F_54_L      FRC_PK_L_(0x3F, 0x54)
#define REG_FRC_BK3F_54_H      FRC_PK_H_(0x3F, 0x54)
#define REG_FRC_BK3F_55_L      FRC_PK_L_(0x3F, 0x55)
#define REG_FRC_BK3F_55_H      FRC_PK_H_(0x3F, 0x55)
#define REG_FRC_BK3F_56_L      FRC_PK_L_(0x3F, 0x56)
#define REG_FRC_BK3F_56_H      FRC_PK_H_(0x3F, 0x56)
#define REG_FRC_BK3F_57_L      FRC_PK_L_(0x3F, 0x57)
#define REG_FRC_BK3F_57_H      FRC_PK_H_(0x3F, 0x57)
#define REG_FRC_BK3F_58_L      FRC_PK_L_(0x3F, 0x58)
#define REG_FRC_BK3F_58_H      FRC_PK_H_(0x3F, 0x58)
#define REG_FRC_BK3F_59_L      FRC_PK_L_(0x3F, 0x59)
#define REG_FRC_BK3F_59_H      FRC_PK_H_(0x3F, 0x59)
#define REG_FRC_BK3F_5A_L      FRC_PK_L_(0x3F, 0x5A)
#define REG_FRC_BK3F_5A_H      FRC_PK_H_(0x3F, 0x5A)
#define REG_FRC_BK3F_5B_L      FRC_PK_L_(0x3F, 0x5B)
#define REG_FRC_BK3F_5B_H      FRC_PK_H_(0x3F, 0x5B)
#define REG_FRC_BK3F_5C_L      FRC_PK_L_(0x3F, 0x5C)
#define REG_FRC_BK3F_5C_H      FRC_PK_H_(0x3F, 0x5C)
#define REG_FRC_BK3F_5D_L      FRC_PK_L_(0x3F, 0x5D)
#define REG_FRC_BK3F_5D_H      FRC_PK_H_(0x3F, 0x5D)
#define REG_FRC_BK3F_5E_L      FRC_PK_L_(0x3F, 0x5E)
#define REG_FRC_BK3F_5E_H      FRC_PK_H_(0x3F, 0x5E)
#define REG_FRC_BK3F_5F_L      FRC_PK_L_(0x3F, 0x5F)
#define REG_FRC_BK3F_5F_H      FRC_PK_H_(0x3F, 0x5F)
#define REG_FRC_BK3F_60_L      FRC_PK_L_(0x3F, 0x60)
#define REG_FRC_BK3F_60_H      FRC_PK_H_(0x3F, 0x60)
#define REG_FRC_BK3F_61_L      FRC_PK_L_(0x3F, 0x61)
#define REG_FRC_BK3F_61_H      FRC_PK_H_(0x3F, 0x61)
#define REG_FRC_BK3F_62_L      FRC_PK_L_(0x3F, 0x62)
#define REG_FRC_BK3F_62_H      FRC_PK_H_(0x3F, 0x62)
#define REG_FRC_BK3F_63_L      FRC_PK_L_(0x3F, 0x63)
#define REG_FRC_BK3F_63_H      FRC_PK_H_(0x3F, 0x63)
#define REG_FRC_BK3F_64_L      FRC_PK_L_(0x3F, 0x64)
#define REG_FRC_BK3F_64_H      FRC_PK_H_(0x3F, 0x64)
#define REG_FRC_BK3F_65_L      FRC_PK_L_(0x3F, 0x65)
#define REG_FRC_BK3F_65_H      FRC_PK_H_(0x3F, 0x65)
#define REG_FRC_BK3F_66_L      FRC_PK_L_(0x3F, 0x66)
#define REG_FRC_BK3F_66_H      FRC_PK_H_(0x3F, 0x66)
#define REG_FRC_BK3F_67_L      FRC_PK_L_(0x3F, 0x67)
#define REG_FRC_BK3F_67_H      FRC_PK_H_(0x3F, 0x67)
#define REG_FRC_BK3F_68_L      FRC_PK_L_(0x3F, 0x68)
#define REG_FRC_BK3F_68_H      FRC_PK_H_(0x3F, 0x68)
#define REG_FRC_BK3F_69_L      FRC_PK_L_(0x3F, 0x69)
#define REG_FRC_BK3F_69_H      FRC_PK_H_(0x3F, 0x69)
#define REG_FRC_BK3F_6A_L      FRC_PK_L_(0x3F, 0x6A)
#define REG_FRC_BK3F_6A_H      FRC_PK_H_(0x3F, 0x6A)
#define REG_FRC_BK3F_6B_L      FRC_PK_L_(0x3F, 0x6B)
#define REG_FRC_BK3F_6B_H      FRC_PK_H_(0x3F, 0x6B)
#define REG_FRC_BK3F_6C_L      FRC_PK_L_(0x3F, 0x6C)
#define REG_FRC_BK3F_6C_H      FRC_PK_H_(0x3F, 0x6C)
#define REG_FRC_BK3F_6D_L      FRC_PK_L_(0x3F, 0x6D)
#define REG_FRC_BK3F_6D_H      FRC_PK_H_(0x3F, 0x6D)
#define REG_FRC_BK3F_6E_L      FRC_PK_L_(0x3F, 0x6E)
#define REG_FRC_BK3F_6E_H      FRC_PK_H_(0x3F, 0x6E)
#define REG_FRC_BK3F_6F_L      FRC_PK_L_(0x3F, 0x6F)
#define REG_FRC_BK3F_6F_H      FRC_PK_H_(0x3F, 0x6F)
#define REG_FRC_BK3F_70_L      FRC_PK_L_(0x3F, 0x70)
#define REG_FRC_BK3F_70_H      FRC_PK_H_(0x3F, 0x70)
#define REG_FRC_BK3F_71_L      FRC_PK_L_(0x3F, 0x71)
#define REG_FRC_BK3F_71_H      FRC_PK_H_(0x3F, 0x71)
#define REG_FRC_BK3F_72_L      FRC_PK_L_(0x3F, 0x72)
#define REG_FRC_BK3F_72_H      FRC_PK_H_(0x3F, 0x72)
#define REG_FRC_BK3F_73_L      FRC_PK_L_(0x3F, 0x73)
#define REG_FRC_BK3F_73_H      FRC_PK_H_(0x3F, 0x73)
#define REG_FRC_BK3F_74_L      FRC_PK_L_(0x3F, 0x74)
#define REG_FRC_BK3F_74_H      FRC_PK_H_(0x3F, 0x74)
#define REG_FRC_BK3F_75_L      FRC_PK_L_(0x3F, 0x75)
#define REG_FRC_BK3F_75_H      FRC_PK_H_(0x3F, 0x75)
#define REG_FRC_BK3F_76_L      FRC_PK_L_(0x3F, 0x76)
#define REG_FRC_BK3F_76_H      FRC_PK_H_(0x3F, 0x76)
#define REG_FRC_BK3F_77_L      FRC_PK_L_(0x3F, 0x77)
#define REG_FRC_BK3F_77_H      FRC_PK_H_(0x3F, 0x77)
#define REG_FRC_BK3F_78_L      FRC_PK_L_(0x3F, 0x78)
#define REG_FRC_BK3F_78_H      FRC_PK_H_(0x3F, 0x78)
#define REG_FRC_BK3F_79_L      FRC_PK_L_(0x3F, 0x79)
#define REG_FRC_BK3F_79_H      FRC_PK_H_(0x3F, 0x79)
#define REG_FRC_BK3F_7A_L      FRC_PK_L_(0x3F, 0x7A)
#define REG_FRC_BK3F_7A_H      FRC_PK_H_(0x3F, 0x7A)
#define REG_FRC_BK3F_7B_L      FRC_PK_L_(0x3F, 0x7B)
#define REG_FRC_BK3F_7B_H      FRC_PK_H_(0x3F, 0x7B)
#define REG_FRC_BK3F_7C_L      FRC_PK_L_(0x3F, 0x7C)
#define REG_FRC_BK3F_7C_H      FRC_PK_H_(0x3F, 0x7C)
#define REG_FRC_BK3F_7D_L      FRC_PK_L_(0x3F, 0x7D)
#define REG_FRC_BK3F_7D_H      FRC_PK_H_(0x3F, 0x7D)
#define REG_FRC_BK3F_7E_L      FRC_PK_L_(0x3F, 0x7E)
#define REG_FRC_BK3F_7E_H      FRC_PK_H_(0x3F, 0x7E)
#define REG_FRC_BK3F_7F_L      FRC_PK_L_(0x3F, 0x7F)
#define REG_FRC_BK3F_7F_H      FRC_PK_H_(0x3F, 0x7F)

//----------------------------------------------
//  BK40
//----------------------------------------------
#define REG_FRC_BK40_00_L      FRC_PK_L_(0x40, 0x00)
#define REG_FRC_BK40_00_H      FRC_PK_H_(0x40, 0x00)
#define REG_FRC_BK40_01_L      FRC_PK_L_(0x40, 0x01)
#define REG_FRC_BK40_01_H      FRC_PK_H_(0x40, 0x01)
#define REG_FRC_BK40_02_L      FRC_PK_L_(0x40, 0x02)
#define REG_FRC_BK40_02_H      FRC_PK_H_(0x40, 0x02)
#define REG_FRC_BK40_03_L      FRC_PK_L_(0x40, 0x03)
#define REG_FRC_BK40_03_H      FRC_PK_H_(0x40, 0x03)
#define REG_FRC_BK40_04_L      FRC_PK_L_(0x40, 0x04)
#define REG_FRC_BK40_04_H      FRC_PK_H_(0x40, 0x04)
#define REG_FRC_BK40_05_L      FRC_PK_L_(0x40, 0x05)
#define REG_FRC_BK40_05_H      FRC_PK_H_(0x40, 0x05)
#define REG_FRC_BK40_06_L      FRC_PK_L_(0x40, 0x06)
#define REG_FRC_BK40_06_H      FRC_PK_H_(0x40, 0x06)
#define REG_FRC_BK40_07_L      FRC_PK_L_(0x40, 0x07)
#define REG_FRC_BK40_07_H      FRC_PK_H_(0x40, 0x07)
#define REG_FRC_BK40_08_L      FRC_PK_L_(0x40, 0x08)
#define REG_FRC_BK40_08_H      FRC_PK_H_(0x40, 0x08)
#define REG_FRC_BK40_09_L      FRC_PK_L_(0x40, 0x09)
#define REG_FRC_BK40_09_H      FRC_PK_H_(0x40, 0x09)
#define REG_FRC_BK40_0A_L      FRC_PK_L_(0x40, 0x0A)
#define REG_FRC_BK40_0A_H      FRC_PK_H_(0x40, 0x0A)
#define REG_FRC_BK40_0B_L      FRC_PK_L_(0x40, 0x0B)
#define REG_FRC_BK40_0B_H      FRC_PK_H_(0x40, 0x0B)
#define REG_FRC_BK40_0C_L      FRC_PK_L_(0x40, 0x0C)
#define REG_FRC_BK40_0C_H      FRC_PK_H_(0x40, 0x0C)
#define REG_FRC_BK40_0D_L      FRC_PK_L_(0x40, 0x0D)
#define REG_FRC_BK40_0D_H      FRC_PK_H_(0x40, 0x0D)
#define REG_FRC_BK40_0E_L      FRC_PK_L_(0x40, 0x0E)
#define REG_FRC_BK40_0E_H      FRC_PK_H_(0x40, 0x0E)
#define REG_FRC_BK40_0F_L      FRC_PK_L_(0x40, 0x0F)
#define REG_FRC_BK40_0F_H      FRC_PK_H_(0x40, 0x0F)
#define REG_FRC_BK40_10_L      FRC_PK_L_(0x40, 0x10)
#define REG_FRC_BK40_10_H      FRC_PK_H_(0x40, 0x10)
#define REG_FRC_BK40_11_L      FRC_PK_L_(0x40, 0x11)
#define REG_FRC_BK40_11_H      FRC_PK_H_(0x40, 0x11)
#define REG_FRC_BK40_12_L      FRC_PK_L_(0x40, 0x12)
#define REG_FRC_BK40_12_H      FRC_PK_H_(0x40, 0x12)
#define REG_FRC_BK40_13_L      FRC_PK_L_(0x40, 0x13)
#define REG_FRC_BK40_13_H      FRC_PK_H_(0x40, 0x13)
#define REG_FRC_BK40_14_L      FRC_PK_L_(0x40, 0x14)
#define REG_FRC_BK40_14_H      FRC_PK_H_(0x40, 0x14)
#define REG_FRC_BK40_15_L      FRC_PK_L_(0x40, 0x15)
#define REG_FRC_BK40_15_H      FRC_PK_H_(0x40, 0x15)
#define REG_FRC_BK40_16_L      FRC_PK_L_(0x40, 0x16)
#define REG_FRC_BK40_16_H      FRC_PK_H_(0x40, 0x16)
#define REG_FRC_BK40_17_L      FRC_PK_L_(0x40, 0x17)
#define REG_FRC_BK40_17_H      FRC_PK_H_(0x40, 0x17)
#define REG_FRC_BK40_18_L      FRC_PK_L_(0x40, 0x18)
#define REG_FRC_BK40_18_H      FRC_PK_H_(0x40, 0x18)
#define REG_FRC_BK40_19_L      FRC_PK_L_(0x40, 0x19)
#define REG_FRC_BK40_19_H      FRC_PK_H_(0x40, 0x19)
#define REG_FRC_BK40_1A_L      FRC_PK_L_(0x40, 0x1A)
#define REG_FRC_BK40_1A_H      FRC_PK_H_(0x40, 0x1A)
#define REG_FRC_BK40_1B_L      FRC_PK_L_(0x40, 0x1B)
#define REG_FRC_BK40_1B_H      FRC_PK_H_(0x40, 0x1B)
#define REG_FRC_BK40_1C_L      FRC_PK_L_(0x40, 0x1C)
#define REG_FRC_BK40_1C_H      FRC_PK_H_(0x40, 0x1C)
#define REG_FRC_BK40_1D_L      FRC_PK_L_(0x40, 0x1D)
#define REG_FRC_BK40_1D_H      FRC_PK_H_(0x40, 0x1D)
#define REG_FRC_BK40_1E_L      FRC_PK_L_(0x40, 0x1E)
#define REG_FRC_BK40_1E_H      FRC_PK_H_(0x40, 0x1E)
#define REG_FRC_BK40_1F_L      FRC_PK_L_(0x40, 0x1F)
#define REG_FRC_BK40_1F_H      FRC_PK_H_(0x40, 0x1F)
#define REG_FRC_BK40_20_L      FRC_PK_L_(0x40, 0x20)
#define REG_FRC_BK40_20_H      FRC_PK_H_(0x40, 0x20)
#define REG_FRC_BK40_21_L      FRC_PK_L_(0x40, 0x21)
#define REG_FRC_BK40_21_H      FRC_PK_H_(0x40, 0x21)
#define REG_FRC_BK40_22_L      FRC_PK_L_(0x40, 0x22)
#define REG_FRC_BK40_22_H      FRC_PK_H_(0x40, 0x22)
#define REG_FRC_BK40_23_L      FRC_PK_L_(0x40, 0x23)
#define REG_FRC_BK40_23_H      FRC_PK_H_(0x40, 0x23)
#define REG_FRC_BK40_24_L      FRC_PK_L_(0x40, 0x24)
#define REG_FRC_BK40_24_H      FRC_PK_H_(0x40, 0x24)
#define REG_FRC_BK40_25_L      FRC_PK_L_(0x40, 0x25)
#define REG_FRC_BK40_25_H      FRC_PK_H_(0x40, 0x25)
#define REG_FRC_BK40_26_L      FRC_PK_L_(0x40, 0x26)
#define REG_FRC_BK40_26_H      FRC_PK_H_(0x40, 0x26)
#define REG_FRC_BK40_27_L      FRC_PK_L_(0x40, 0x27)
#define REG_FRC_BK40_27_H      FRC_PK_H_(0x40, 0x27)
#define REG_FRC_BK40_28_L      FRC_PK_L_(0x40, 0x28)
#define REG_FRC_BK40_28_H      FRC_PK_H_(0x40, 0x28)
#define REG_FRC_BK40_29_L      FRC_PK_L_(0x40, 0x29)
#define REG_FRC_BK40_29_H      FRC_PK_H_(0x40, 0x29)
#define REG_FRC_BK40_2A_L      FRC_PK_L_(0x40, 0x2A)
#define REG_FRC_BK40_2A_H      FRC_PK_H_(0x40, 0x2A)
#define REG_FRC_BK40_2B_L      FRC_PK_L_(0x40, 0x2B)
#define REG_FRC_BK40_2B_H      FRC_PK_H_(0x40, 0x2B)
#define REG_FRC_BK40_2C_L      FRC_PK_L_(0x40, 0x2C)
#define REG_FRC_BK40_2C_H      FRC_PK_H_(0x40, 0x2C)
#define REG_FRC_BK40_2D_L      FRC_PK_L_(0x40, 0x2D)
#define REG_FRC_BK40_2D_H      FRC_PK_H_(0x40, 0x2D)
#define REG_FRC_BK40_2E_L      FRC_PK_L_(0x40, 0x2E)
#define REG_FRC_BK40_2E_H      FRC_PK_H_(0x40, 0x2E)
#define REG_FRC_BK40_2F_L      FRC_PK_L_(0x40, 0x2F)
#define REG_FRC_BK40_2F_H      FRC_PK_H_(0x40, 0x2F)
#define REG_FRC_BK40_30_L      FRC_PK_L_(0x40, 0x30)
#define REG_FRC_BK40_30_H      FRC_PK_H_(0x40, 0x30)
#define REG_FRC_BK40_31_L      FRC_PK_L_(0x40, 0x31)
#define REG_FRC_BK40_31_H      FRC_PK_H_(0x40, 0x31)
#define REG_FRC_BK40_32_L      FRC_PK_L_(0x40, 0x32)
#define REG_FRC_BK40_32_H      FRC_PK_H_(0x40, 0x32)
#define REG_FRC_BK40_33_L      FRC_PK_L_(0x40, 0x33)
#define REG_FRC_BK40_33_H      FRC_PK_H_(0x40, 0x33)
#define REG_FRC_BK40_34_L      FRC_PK_L_(0x40, 0x34)
#define REG_FRC_BK40_34_H      FRC_PK_H_(0x40, 0x34)
#define REG_FRC_BK40_35_L      FRC_PK_L_(0x40, 0x35)
#define REG_FRC_BK40_35_H      FRC_PK_H_(0x40, 0x35)
#define REG_FRC_BK40_36_L      FRC_PK_L_(0x40, 0x36)
#define REG_FRC_BK40_36_H      FRC_PK_H_(0x40, 0x36)
#define REG_FRC_BK40_37_L      FRC_PK_L_(0x40, 0x37)
#define REG_FRC_BK40_37_H      FRC_PK_H_(0x40, 0x37)
#define REG_FRC_BK40_38_L      FRC_PK_L_(0x40, 0x38)
#define REG_FRC_BK40_38_H      FRC_PK_H_(0x40, 0x38)
#define REG_FRC_BK40_39_L      FRC_PK_L_(0x40, 0x39)
#define REG_FRC_BK40_39_H      FRC_PK_H_(0x40, 0x39)
#define REG_FRC_BK40_3A_L      FRC_PK_L_(0x40, 0x3A)
#define REG_FRC_BK40_3A_H      FRC_PK_H_(0x40, 0x3A)
#define REG_FRC_BK40_3B_L      FRC_PK_L_(0x40, 0x3B)
#define REG_FRC_BK40_3B_H      FRC_PK_H_(0x40, 0x3B)
#define REG_FRC_BK40_3C_L      FRC_PK_L_(0x40, 0x3C)
#define REG_FRC_BK40_3C_H      FRC_PK_H_(0x40, 0x3C)
#define REG_FRC_BK40_3D_L      FRC_PK_L_(0x40, 0x3D)
#define REG_FRC_BK40_3D_H      FRC_PK_H_(0x40, 0x3D)
#define REG_FRC_BK40_3E_L      FRC_PK_L_(0x40, 0x3E)
#define REG_FRC_BK40_3E_H      FRC_PK_H_(0x40, 0x3E)
#define REG_FRC_BK40_3F_L      FRC_PK_L_(0x40, 0x3F)
#define REG_FRC_BK40_3F_H      FRC_PK_H_(0x40, 0x3F)
#define REG_FRC_BK40_40_L      FRC_PK_L_(0x40, 0x40)
#define REG_FRC_BK40_40_H      FRC_PK_H_(0x40, 0x40)
#define REG_FRC_BK40_41_L      FRC_PK_L_(0x40, 0x41)
#define REG_FRC_BK40_41_H      FRC_PK_H_(0x40, 0x41)
#define REG_FRC_BK40_42_L      FRC_PK_L_(0x40, 0x42)
#define REG_FRC_BK40_42_H      FRC_PK_H_(0x40, 0x42)
#define REG_FRC_BK40_43_L      FRC_PK_L_(0x40, 0x43)
#define REG_FRC_BK40_43_H      FRC_PK_H_(0x40, 0x43)
#define REG_FRC_BK40_44_L      FRC_PK_L_(0x40, 0x44)
#define REG_FRC_BK40_44_H      FRC_PK_H_(0x40, 0x44)
#define REG_FRC_BK40_45_L      FRC_PK_L_(0x40, 0x45)
#define REG_FRC_BK40_45_H      FRC_PK_H_(0x40, 0x45)
#define REG_FRC_BK40_46_L      FRC_PK_L_(0x40, 0x46)
#define REG_FRC_BK40_46_H      FRC_PK_H_(0x40, 0x46)
#define REG_FRC_BK40_47_L      FRC_PK_L_(0x40, 0x47)
#define REG_FRC_BK40_47_H      FRC_PK_H_(0x40, 0x47)
#define REG_FRC_BK40_48_L      FRC_PK_L_(0x40, 0x48)
#define REG_FRC_BK40_48_H      FRC_PK_H_(0x40, 0x48)
#define REG_FRC_BK40_49_L      FRC_PK_L_(0x40, 0x49)
#define REG_FRC_BK40_49_H      FRC_PK_H_(0x40, 0x49)
#define REG_FRC_BK40_4A_L      FRC_PK_L_(0x40, 0x4A)
#define REG_FRC_BK40_4A_H      FRC_PK_H_(0x40, 0x4A)
#define REG_FRC_BK40_4B_L      FRC_PK_L_(0x40, 0x4B)
#define REG_FRC_BK40_4B_H      FRC_PK_H_(0x40, 0x4B)
#define REG_FRC_BK40_4C_L      FRC_PK_L_(0x40, 0x4C)
#define REG_FRC_BK40_4C_H      FRC_PK_H_(0x40, 0x4C)
#define REG_FRC_BK40_4D_L      FRC_PK_L_(0x40, 0x4D)
#define REG_FRC_BK40_4D_H      FRC_PK_H_(0x40, 0x4D)
#define REG_FRC_BK40_4E_L      FRC_PK_L_(0x40, 0x4E)
#define REG_FRC_BK40_4E_H      FRC_PK_H_(0x40, 0x4E)
#define REG_FRC_BK40_4F_L      FRC_PK_L_(0x40, 0x4F)
#define REG_FRC_BK40_4F_H      FRC_PK_H_(0x40, 0x4F)
#define REG_FRC_BK40_50_L      FRC_PK_L_(0x40, 0x50)
#define REG_FRC_BK40_50_H      FRC_PK_H_(0x40, 0x50)
#define REG_FRC_BK40_51_L      FRC_PK_L_(0x40, 0x51)
#define REG_FRC_BK40_51_H      FRC_PK_H_(0x40, 0x51)
#define REG_FRC_BK40_52_L      FRC_PK_L_(0x40, 0x52)
#define REG_FRC_BK40_52_H      FRC_PK_H_(0x40, 0x52)
#define REG_FRC_BK40_53_L      FRC_PK_L_(0x40, 0x53)
#define REG_FRC_BK40_53_H      FRC_PK_H_(0x40, 0x53)
#define REG_FRC_BK40_54_L      FRC_PK_L_(0x40, 0x54)
#define REG_FRC_BK40_54_H      FRC_PK_H_(0x40, 0x54)
#define REG_FRC_BK40_55_L      FRC_PK_L_(0x40, 0x55)
#define REG_FRC_BK40_55_H      FRC_PK_H_(0x40, 0x55)
#define REG_FRC_BK40_56_L      FRC_PK_L_(0x40, 0x56)
#define REG_FRC_BK40_56_H      FRC_PK_H_(0x40, 0x56)
#define REG_FRC_BK40_57_L      FRC_PK_L_(0x40, 0x57)
#define REG_FRC_BK40_57_H      FRC_PK_H_(0x40, 0x57)
#define REG_FRC_BK40_58_L      FRC_PK_L_(0x40, 0x58)
#define REG_FRC_BK40_58_H      FRC_PK_H_(0x40, 0x58)
#define REG_FRC_BK40_59_L      FRC_PK_L_(0x40, 0x59)
#define REG_FRC_BK40_59_H      FRC_PK_H_(0x40, 0x59)
#define REG_FRC_BK40_5A_L      FRC_PK_L_(0x40, 0x5A)
#define REG_FRC_BK40_5A_H      FRC_PK_H_(0x40, 0x5A)
#define REG_FRC_BK40_5B_L      FRC_PK_L_(0x40, 0x5B)
#define REG_FRC_BK40_5B_H      FRC_PK_H_(0x40, 0x5B)
#define REG_FRC_BK40_5C_L      FRC_PK_L_(0x40, 0x5C)
#define REG_FRC_BK40_5C_H      FRC_PK_H_(0x40, 0x5C)
#define REG_FRC_BK40_5D_L      FRC_PK_L_(0x40, 0x5D)
#define REG_FRC_BK40_5D_H      FRC_PK_H_(0x40, 0x5D)
#define REG_FRC_BK40_5E_L      FRC_PK_L_(0x40, 0x5E)
#define REG_FRC_BK40_5E_H      FRC_PK_H_(0x40, 0x5E)
#define REG_FRC_BK40_5F_L      FRC_PK_L_(0x40, 0x5F)
#define REG_FRC_BK40_5F_H      FRC_PK_H_(0x40, 0x5F)
#define REG_FRC_BK40_60_L      FRC_PK_L_(0x40, 0x60)
#define REG_FRC_BK40_60_H      FRC_PK_H_(0x40, 0x60)
#define REG_FRC_BK40_61_L      FRC_PK_L_(0x40, 0x61)
#define REG_FRC_BK40_61_H      FRC_PK_H_(0x40, 0x61)
#define REG_FRC_BK40_62_L      FRC_PK_L_(0x40, 0x62)
#define REG_FRC_BK40_62_H      FRC_PK_H_(0x40, 0x62)
#define REG_FRC_BK40_63_L      FRC_PK_L_(0x40, 0x63)
#define REG_FRC_BK40_63_H      FRC_PK_H_(0x40, 0x63)
#define REG_FRC_BK40_64_L      FRC_PK_L_(0x40, 0x64)
#define REG_FRC_BK40_64_H      FRC_PK_H_(0x40, 0x64)
#define REG_FRC_BK40_65_L      FRC_PK_L_(0x40, 0x65)
#define REG_FRC_BK40_65_H      FRC_PK_H_(0x40, 0x65)
#define REG_FRC_BK40_66_L      FRC_PK_L_(0x40, 0x66)
#define REG_FRC_BK40_66_H      FRC_PK_H_(0x40, 0x66)
#define REG_FRC_BK40_67_L      FRC_PK_L_(0x40, 0x67)
#define REG_FRC_BK40_67_H      FRC_PK_H_(0x40, 0x67)
#define REG_FRC_BK40_68_L      FRC_PK_L_(0x40, 0x68)
#define REG_FRC_BK40_68_H      FRC_PK_H_(0x40, 0x68)
#define REG_FRC_BK40_69_L      FRC_PK_L_(0x40, 0x69)
#define REG_FRC_BK40_69_H      FRC_PK_H_(0x40, 0x69)
#define REG_FRC_BK40_6A_L      FRC_PK_L_(0x40, 0x6A)
#define REG_FRC_BK40_6A_H      FRC_PK_H_(0x40, 0x6A)
#define REG_FRC_BK40_6B_L      FRC_PK_L_(0x40, 0x6B)
#define REG_FRC_BK40_6B_H      FRC_PK_H_(0x40, 0x6B)
#define REG_FRC_BK40_6C_L      FRC_PK_L_(0x40, 0x6C)
#define REG_FRC_BK40_6C_H      FRC_PK_H_(0x40, 0x6C)
#define REG_FRC_BK40_6D_L      FRC_PK_L_(0x40, 0x6D)
#define REG_FRC_BK40_6D_H      FRC_PK_H_(0x40, 0x6D)
#define REG_FRC_BK40_6E_L      FRC_PK_L_(0x40, 0x6E)
#define REG_FRC_BK40_6E_H      FRC_PK_H_(0x40, 0x6E)
#define REG_FRC_BK40_6F_L      FRC_PK_L_(0x40, 0x6F)
#define REG_FRC_BK40_6F_H      FRC_PK_H_(0x40, 0x6F)
#define REG_FRC_BK40_70_L      FRC_PK_L_(0x40, 0x70)
#define REG_FRC_BK40_70_H      FRC_PK_H_(0x40, 0x70)
#define REG_FRC_BK40_71_L      FRC_PK_L_(0x40, 0x71)
#define REG_FRC_BK40_71_H      FRC_PK_H_(0x40, 0x71)
#define REG_FRC_BK40_72_L      FRC_PK_L_(0x40, 0x72)
#define REG_FRC_BK40_72_H      FRC_PK_H_(0x40, 0x72)
#define REG_FRC_BK40_73_L      FRC_PK_L_(0x40, 0x73)
#define REG_FRC_BK40_73_H      FRC_PK_H_(0x40, 0x73)
#define REG_FRC_BK40_74_L      FRC_PK_L_(0x40, 0x74)
#define REG_FRC_BK40_74_H      FRC_PK_H_(0x40, 0x74)
#define REG_FRC_BK40_75_L      FRC_PK_L_(0x40, 0x75)
#define REG_FRC_BK40_75_H      FRC_PK_H_(0x40, 0x75)
#define REG_FRC_BK40_76_L      FRC_PK_L_(0x40, 0x76)
#define REG_FRC_BK40_76_H      FRC_PK_H_(0x40, 0x76)
#define REG_FRC_BK40_77_L      FRC_PK_L_(0x40, 0x77)
#define REG_FRC_BK40_77_H      FRC_PK_H_(0x40, 0x77)
#define REG_FRC_BK40_78_L      FRC_PK_L_(0x40, 0x78)
#define REG_FRC_BK40_78_H      FRC_PK_H_(0x40, 0x78)
#define REG_FRC_BK40_79_L      FRC_PK_L_(0x40, 0x79)
#define REG_FRC_BK40_79_H      FRC_PK_H_(0x40, 0x79)
#define REG_FRC_BK40_7A_L      FRC_PK_L_(0x40, 0x7A)
#define REG_FRC_BK40_7A_H      FRC_PK_H_(0x40, 0x7A)
#define REG_FRC_BK40_7B_L      FRC_PK_L_(0x40, 0x7B)
#define REG_FRC_BK40_7B_H      FRC_PK_H_(0x40, 0x7B)
#define REG_FRC_BK40_7C_L      FRC_PK_L_(0x40, 0x7C)
#define REG_FRC_BK40_7C_H      FRC_PK_H_(0x40, 0x7C)
#define REG_FRC_BK40_7D_L      FRC_PK_L_(0x40, 0x7D)
#define REG_FRC_BK40_7D_H      FRC_PK_H_(0x40, 0x7D)
#define REG_FRC_BK40_7E_L      FRC_PK_L_(0x40, 0x7E)
#define REG_FRC_BK40_7E_H      FRC_PK_H_(0x40, 0x7E)
#define REG_FRC_BK40_7F_L      FRC_PK_L_(0x40, 0x7F)
#define REG_FRC_BK40_7F_H      FRC_PK_H_(0x40, 0x7F)

//----------------------------------------------
//  BK41
//----------------------------------------------
#define REG_FRC_BK41_00_L      FRC_PK_L_(0x41, 0x00)
#define REG_FRC_BK41_00_H      FRC_PK_H_(0x41, 0x00)
#define REG_FRC_BK41_01_L      FRC_PK_L_(0x41, 0x01)
#define REG_FRC_BK41_01_H      FRC_PK_H_(0x41, 0x01)
#define REG_FRC_BK41_02_L      FRC_PK_L_(0x41, 0x02)
#define REG_FRC_BK41_02_H      FRC_PK_H_(0x41, 0x02)
#define REG_FRC_BK41_03_L      FRC_PK_L_(0x41, 0x03)
#define REG_FRC_BK41_03_H      FRC_PK_H_(0x41, 0x03)
#define REG_FRC_BK41_04_L      FRC_PK_L_(0x41, 0x04)
#define REG_FRC_BK41_04_H      FRC_PK_H_(0x41, 0x04)
#define REG_FRC_BK41_05_L      FRC_PK_L_(0x41, 0x05)
#define REG_FRC_BK41_05_H      FRC_PK_H_(0x41, 0x05)
#define REG_FRC_BK41_06_L      FRC_PK_L_(0x41, 0x06)
#define REG_FRC_BK41_06_H      FRC_PK_H_(0x41, 0x06)
#define REG_FRC_BK41_07_L      FRC_PK_L_(0x41, 0x07)
#define REG_FRC_BK41_07_H      FRC_PK_H_(0x41, 0x07)
#define REG_FRC_BK41_08_L      FRC_PK_L_(0x41, 0x08)
#define REG_FRC_BK41_08_H      FRC_PK_H_(0x41, 0x08)
#define REG_FRC_BK41_09_L      FRC_PK_L_(0x41, 0x09)
#define REG_FRC_BK41_09_H      FRC_PK_H_(0x41, 0x09)
#define REG_FRC_BK41_0A_L      FRC_PK_L_(0x41, 0x0A)
#define REG_FRC_BK41_0A_H      FRC_PK_H_(0x41, 0x0A)
#define REG_FRC_BK41_0B_L      FRC_PK_L_(0x41, 0x0B)
#define REG_FRC_BK41_0B_H      FRC_PK_H_(0x41, 0x0B)
#define REG_FRC_BK41_0C_L      FRC_PK_L_(0x41, 0x0C)
#define REG_FRC_BK41_0C_H      FRC_PK_H_(0x41, 0x0C)
#define REG_FRC_BK41_0D_L      FRC_PK_L_(0x41, 0x0D)
#define REG_FRC_BK41_0D_H      FRC_PK_H_(0x41, 0x0D)
#define REG_FRC_BK41_0E_L      FRC_PK_L_(0x41, 0x0E)
#define REG_FRC_BK41_0E_H      FRC_PK_H_(0x41, 0x0E)
#define REG_FRC_BK41_0F_L      FRC_PK_L_(0x41, 0x0F)
#define REG_FRC_BK41_0F_H      FRC_PK_H_(0x41, 0x0F)
#define REG_FRC_BK41_10_L      FRC_PK_L_(0x41, 0x10)
#define REG_FRC_BK41_10_H      FRC_PK_H_(0x41, 0x10)
#define REG_FRC_BK41_11_L      FRC_PK_L_(0x41, 0x11)
#define REG_FRC_BK41_11_H      FRC_PK_H_(0x41, 0x11)
#define REG_FRC_BK41_12_L      FRC_PK_L_(0x41, 0x12)
#define REG_FRC_BK41_12_H      FRC_PK_H_(0x41, 0x12)
#define REG_FRC_BK41_13_L      FRC_PK_L_(0x41, 0x13)
#define REG_FRC_BK41_13_H      FRC_PK_H_(0x41, 0x13)
#define REG_FRC_BK41_14_L      FRC_PK_L_(0x41, 0x14)
#define REG_FRC_BK41_14_H      FRC_PK_H_(0x41, 0x14)
#define REG_FRC_BK41_15_L      FRC_PK_L_(0x41, 0x15)
#define REG_FRC_BK41_15_H      FRC_PK_H_(0x41, 0x15)
#define REG_FRC_BK41_16_L      FRC_PK_L_(0x41, 0x16)
#define REG_FRC_BK41_16_H      FRC_PK_H_(0x41, 0x16)
#define REG_FRC_BK41_17_L      FRC_PK_L_(0x41, 0x17)
#define REG_FRC_BK41_17_H      FRC_PK_H_(0x41, 0x17)
#define REG_FRC_BK41_18_L      FRC_PK_L_(0x41, 0x18)
#define REG_FRC_BK41_18_H      FRC_PK_H_(0x41, 0x18)
#define REG_FRC_BK41_19_L      FRC_PK_L_(0x41, 0x19)
#define REG_FRC_BK41_19_H      FRC_PK_H_(0x41, 0x19)
#define REG_FRC_BK41_1A_L      FRC_PK_L_(0x41, 0x1A)
#define REG_FRC_BK41_1A_H      FRC_PK_H_(0x41, 0x1A)
#define REG_FRC_BK41_1B_L      FRC_PK_L_(0x41, 0x1B)
#define REG_FRC_BK41_1B_H      FRC_PK_H_(0x41, 0x1B)
#define REG_FRC_BK41_1C_L      FRC_PK_L_(0x41, 0x1C)
#define REG_FRC_BK41_1C_H      FRC_PK_H_(0x41, 0x1C)
#define REG_FRC_BK41_1D_L      FRC_PK_L_(0x41, 0x1D)
#define REG_FRC_BK41_1D_H      FRC_PK_H_(0x41, 0x1D)
#define REG_FRC_BK41_1E_L      FRC_PK_L_(0x41, 0x1E)
#define REG_FRC_BK41_1E_H      FRC_PK_H_(0x41, 0x1E)
#define REG_FRC_BK41_1F_L      FRC_PK_L_(0x41, 0x1F)
#define REG_FRC_BK41_1F_H      FRC_PK_H_(0x41, 0x1F)
#define REG_FRC_BK41_20_L      FRC_PK_L_(0x41, 0x20)
#define REG_FRC_BK41_20_H      FRC_PK_H_(0x41, 0x20)
#define REG_FRC_BK41_21_L      FRC_PK_L_(0x41, 0x21)
#define REG_FRC_BK41_21_H      FRC_PK_H_(0x41, 0x21)
#define REG_FRC_BK41_22_L      FRC_PK_L_(0x41, 0x22)
#define REG_FRC_BK41_22_H      FRC_PK_H_(0x41, 0x22)
#define REG_FRC_BK41_23_L      FRC_PK_L_(0x41, 0x23)
#define REG_FRC_BK41_23_H      FRC_PK_H_(0x41, 0x23)
#define REG_FRC_BK41_24_L      FRC_PK_L_(0x41, 0x24)
#define REG_FRC_BK41_24_H      FRC_PK_H_(0x41, 0x24)
#define REG_FRC_BK41_25_L      FRC_PK_L_(0x41, 0x25)
#define REG_FRC_BK41_25_H      FRC_PK_H_(0x41, 0x25)
#define REG_FRC_BK41_26_L      FRC_PK_L_(0x41, 0x26)
#define REG_FRC_BK41_26_H      FRC_PK_H_(0x41, 0x26)
#define REG_FRC_BK41_27_L      FRC_PK_L_(0x41, 0x27)
#define REG_FRC_BK41_27_H      FRC_PK_H_(0x41, 0x27)
#define REG_FRC_BK41_28_L      FRC_PK_L_(0x41, 0x28)
#define REG_FRC_BK41_28_H      FRC_PK_H_(0x41, 0x28)
#define REG_FRC_BK41_29_L      FRC_PK_L_(0x41, 0x29)
#define REG_FRC_BK41_29_H      FRC_PK_H_(0x41, 0x29)
#define REG_FRC_BK41_2A_L      FRC_PK_L_(0x41, 0x2A)
#define REG_FRC_BK41_2A_H      FRC_PK_H_(0x41, 0x2A)
#define REG_FRC_BK41_2B_L      FRC_PK_L_(0x41, 0x2B)
#define REG_FRC_BK41_2B_H      FRC_PK_H_(0x41, 0x2B)
#define REG_FRC_BK41_2C_L      FRC_PK_L_(0x41, 0x2C)
#define REG_FRC_BK41_2C_H      FRC_PK_H_(0x41, 0x2C)
#define REG_FRC_BK41_2D_L      FRC_PK_L_(0x41, 0x2D)
#define REG_FRC_BK41_2D_H      FRC_PK_H_(0x41, 0x2D)
#define REG_FRC_BK41_2E_L      FRC_PK_L_(0x41, 0x2E)
#define REG_FRC_BK41_2E_H      FRC_PK_H_(0x41, 0x2E)
#define REG_FRC_BK41_2F_L      FRC_PK_L_(0x41, 0x2F)
#define REG_FRC_BK41_2F_H      FRC_PK_H_(0x41, 0x2F)
#define REG_FRC_BK41_30_L      FRC_PK_L_(0x41, 0x30)
#define REG_FRC_BK41_30_H      FRC_PK_H_(0x41, 0x30)
#define REG_FRC_BK41_31_L      FRC_PK_L_(0x41, 0x31)
#define REG_FRC_BK41_31_H      FRC_PK_H_(0x41, 0x31)
#define REG_FRC_BK41_32_L      FRC_PK_L_(0x41, 0x32)
#define REG_FRC_BK41_32_H      FRC_PK_H_(0x41, 0x32)
#define REG_FRC_BK41_33_L      FRC_PK_L_(0x41, 0x33)
#define REG_FRC_BK41_33_H      FRC_PK_H_(0x41, 0x33)
#define REG_FRC_BK41_34_L      FRC_PK_L_(0x41, 0x34)
#define REG_FRC_BK41_34_H      FRC_PK_H_(0x41, 0x34)
#define REG_FRC_BK41_35_L      FRC_PK_L_(0x41, 0x35)
#define REG_FRC_BK41_35_H      FRC_PK_H_(0x41, 0x35)
#define REG_FRC_BK41_36_L      FRC_PK_L_(0x41, 0x36)
#define REG_FRC_BK41_36_H      FRC_PK_H_(0x41, 0x36)
#define REG_FRC_BK41_37_L      FRC_PK_L_(0x41, 0x37)
#define REG_FRC_BK41_37_H      FRC_PK_H_(0x41, 0x37)
#define REG_FRC_BK41_38_L      FRC_PK_L_(0x41, 0x38)
#define REG_FRC_BK41_38_H      FRC_PK_H_(0x41, 0x38)
#define REG_FRC_BK41_39_L      FRC_PK_L_(0x41, 0x39)
#define REG_FRC_BK41_39_H      FRC_PK_H_(0x41, 0x39)
#define REG_FRC_BK41_3A_L      FRC_PK_L_(0x41, 0x3A)
#define REG_FRC_BK41_3A_H      FRC_PK_H_(0x41, 0x3A)
#define REG_FRC_BK41_3B_L      FRC_PK_L_(0x41, 0x3B)
#define REG_FRC_BK41_3B_H      FRC_PK_H_(0x41, 0x3B)
#define REG_FRC_BK41_3C_L      FRC_PK_L_(0x41, 0x3C)
#define REG_FRC_BK41_3C_H      FRC_PK_H_(0x41, 0x3C)
#define REG_FRC_BK41_3D_L      FRC_PK_L_(0x41, 0x3D)
#define REG_FRC_BK41_3D_H      FRC_PK_H_(0x41, 0x3D)
#define REG_FRC_BK41_3E_L      FRC_PK_L_(0x41, 0x3E)
#define REG_FRC_BK41_3E_H      FRC_PK_H_(0x41, 0x3E)
#define REG_FRC_BK41_3F_L      FRC_PK_L_(0x41, 0x3F)
#define REG_FRC_BK41_3F_H      FRC_PK_H_(0x41, 0x3F)
#define REG_FRC_BK41_40_L      FRC_PK_L_(0x41, 0x40)
#define REG_FRC_BK41_40_H      FRC_PK_H_(0x41, 0x40)
#define REG_FRC_BK41_41_L      FRC_PK_L_(0x41, 0x41)
#define REG_FRC_BK41_41_H      FRC_PK_H_(0x41, 0x41)
#define REG_FRC_BK41_42_L      FRC_PK_L_(0x41, 0x42)
#define REG_FRC_BK41_42_H      FRC_PK_H_(0x41, 0x42)
#define REG_FRC_BK41_43_L      FRC_PK_L_(0x41, 0x43)
#define REG_FRC_BK41_43_H      FRC_PK_H_(0x41, 0x43)
#define REG_FRC_BK41_44_L      FRC_PK_L_(0x41, 0x44)
#define REG_FRC_BK41_44_H      FRC_PK_H_(0x41, 0x44)
#define REG_FRC_BK41_45_L      FRC_PK_L_(0x41, 0x45)
#define REG_FRC_BK41_45_H      FRC_PK_H_(0x41, 0x45)
#define REG_FRC_BK41_46_L      FRC_PK_L_(0x41, 0x46)
#define REG_FRC_BK41_46_H      FRC_PK_H_(0x41, 0x46)
#define REG_FRC_BK41_47_L      FRC_PK_L_(0x41, 0x47)
#define REG_FRC_BK41_47_H      FRC_PK_H_(0x41, 0x47)
#define REG_FRC_BK41_48_L      FRC_PK_L_(0x41, 0x48)
#define REG_FRC_BK41_48_H      FRC_PK_H_(0x41, 0x48)
#define REG_FRC_BK41_49_L      FRC_PK_L_(0x41, 0x49)
#define REG_FRC_BK41_49_H      FRC_PK_H_(0x41, 0x49)
#define REG_FRC_BK41_4A_L      FRC_PK_L_(0x41, 0x4A)
#define REG_FRC_BK41_4A_H      FRC_PK_H_(0x41, 0x4A)
#define REG_FRC_BK41_4B_L      FRC_PK_L_(0x41, 0x4B)
#define REG_FRC_BK41_4B_H      FRC_PK_H_(0x41, 0x4B)
#define REG_FRC_BK41_4C_L      FRC_PK_L_(0x41, 0x4C)
#define REG_FRC_BK41_4C_H      FRC_PK_H_(0x41, 0x4C)
#define REG_FRC_BK41_4D_L      FRC_PK_L_(0x41, 0x4D)
#define REG_FRC_BK41_4D_H      FRC_PK_H_(0x41, 0x4D)
#define REG_FRC_BK41_4E_L      FRC_PK_L_(0x41, 0x4E)
#define REG_FRC_BK41_4E_H      FRC_PK_H_(0x41, 0x4E)
#define REG_FRC_BK41_4F_L      FRC_PK_L_(0x41, 0x4F)
#define REG_FRC_BK41_4F_H      FRC_PK_H_(0x41, 0x4F)
#define REG_FRC_BK41_50_L      FRC_PK_L_(0x41, 0x50)
#define REG_FRC_BK41_50_H      FRC_PK_H_(0x41, 0x50)
#define REG_FRC_BK41_51_L      FRC_PK_L_(0x41, 0x51)
#define REG_FRC_BK41_51_H      FRC_PK_H_(0x41, 0x51)
#define REG_FRC_BK41_52_L      FRC_PK_L_(0x41, 0x52)
#define REG_FRC_BK41_52_H      FRC_PK_H_(0x41, 0x52)
#define REG_FRC_BK41_53_L      FRC_PK_L_(0x41, 0x53)
#define REG_FRC_BK41_53_H      FRC_PK_H_(0x41, 0x53)
#define REG_FRC_BK41_54_L      FRC_PK_L_(0x41, 0x54)
#define REG_FRC_BK41_54_H      FRC_PK_H_(0x41, 0x54)
#define REG_FRC_BK41_55_L      FRC_PK_L_(0x41, 0x55)
#define REG_FRC_BK41_55_H      FRC_PK_H_(0x41, 0x55)
#define REG_FRC_BK41_56_L      FRC_PK_L_(0x41, 0x56)
#define REG_FRC_BK41_56_H      FRC_PK_H_(0x41, 0x56)
#define REG_FRC_BK41_57_L      FRC_PK_L_(0x41, 0x57)
#define REG_FRC_BK41_57_H      FRC_PK_H_(0x41, 0x57)
#define REG_FRC_BK41_58_L      FRC_PK_L_(0x41, 0x58)
#define REG_FRC_BK41_58_H      FRC_PK_H_(0x41, 0x58)
#define REG_FRC_BK41_59_L      FRC_PK_L_(0x41, 0x59)
#define REG_FRC_BK41_59_H      FRC_PK_H_(0x41, 0x59)
#define REG_FRC_BK41_5A_L      FRC_PK_L_(0x41, 0x5A)
#define REG_FRC_BK41_5A_H      FRC_PK_H_(0x41, 0x5A)
#define REG_FRC_BK41_5B_L      FRC_PK_L_(0x41, 0x5B)
#define REG_FRC_BK41_5B_H      FRC_PK_H_(0x41, 0x5B)
#define REG_FRC_BK41_5C_L      FRC_PK_L_(0x41, 0x5C)
#define REG_FRC_BK41_5C_H      FRC_PK_H_(0x41, 0x5C)
#define REG_FRC_BK41_5D_L      FRC_PK_L_(0x41, 0x5D)
#define REG_FRC_BK41_5D_H      FRC_PK_H_(0x41, 0x5D)
#define REG_FRC_BK41_5E_L      FRC_PK_L_(0x41, 0x5E)
#define REG_FRC_BK41_5E_H      FRC_PK_H_(0x41, 0x5E)
#define REG_FRC_BK41_5F_L      FRC_PK_L_(0x41, 0x5F)
#define REG_FRC_BK41_5F_H      FRC_PK_H_(0x41, 0x5F)
#define REG_FRC_BK41_60_L      FRC_PK_L_(0x41, 0x60)
#define REG_FRC_BK41_60_H      FRC_PK_H_(0x41, 0x60)
#define REG_FRC_BK41_61_L      FRC_PK_L_(0x41, 0x61)
#define REG_FRC_BK41_61_H      FRC_PK_H_(0x41, 0x61)
#define REG_FRC_BK41_62_L      FRC_PK_L_(0x41, 0x62)
#define REG_FRC_BK41_62_H      FRC_PK_H_(0x41, 0x62)
#define REG_FRC_BK41_63_L      FRC_PK_L_(0x41, 0x63)
#define REG_FRC_BK41_63_H      FRC_PK_H_(0x41, 0x63)
#define REG_FRC_BK41_64_L      FRC_PK_L_(0x41, 0x64)
#define REG_FRC_BK41_64_H      FRC_PK_H_(0x41, 0x64)
#define REG_FRC_BK41_65_L      FRC_PK_L_(0x41, 0x65)
#define REG_FRC_BK41_65_H      FRC_PK_H_(0x41, 0x65)
#define REG_FRC_BK41_66_L      FRC_PK_L_(0x41, 0x66)
#define REG_FRC_BK41_66_H      FRC_PK_H_(0x41, 0x66)
#define REG_FRC_BK41_67_L      FRC_PK_L_(0x41, 0x67)
#define REG_FRC_BK41_67_H      FRC_PK_H_(0x41, 0x67)
#define REG_FRC_BK41_68_L      FRC_PK_L_(0x41, 0x68)
#define REG_FRC_BK41_68_H      FRC_PK_H_(0x41, 0x68)
#define REG_FRC_BK41_69_L      FRC_PK_L_(0x41, 0x69)
#define REG_FRC_BK41_69_H      FRC_PK_H_(0x41, 0x69)
#define REG_FRC_BK41_6A_L      FRC_PK_L_(0x41, 0x6A)
#define REG_FRC_BK41_6A_H      FRC_PK_H_(0x41, 0x6A)
#define REG_FRC_BK41_6B_L      FRC_PK_L_(0x41, 0x6B)
#define REG_FRC_BK41_6B_H      FRC_PK_H_(0x41, 0x6B)
#define REG_FRC_BK41_6C_L      FRC_PK_L_(0x41, 0x6C)
#define REG_FRC_BK41_6C_H      FRC_PK_H_(0x41, 0x6C)
#define REG_FRC_BK41_6D_L      FRC_PK_L_(0x41, 0x6D)
#define REG_FRC_BK41_6D_H      FRC_PK_H_(0x41, 0x6D)
#define REG_FRC_BK41_6E_L      FRC_PK_L_(0x41, 0x6E)
#define REG_FRC_BK41_6E_H      FRC_PK_H_(0x41, 0x6E)
#define REG_FRC_BK41_6F_L      FRC_PK_L_(0x41, 0x6F)
#define REG_FRC_BK41_6F_H      FRC_PK_H_(0x41, 0x6F)
#define REG_FRC_BK41_70_L      FRC_PK_L_(0x41, 0x70)
#define REG_FRC_BK41_70_H      FRC_PK_H_(0x41, 0x70)
#define REG_FRC_BK41_71_L      FRC_PK_L_(0x41, 0x71)
#define REG_FRC_BK41_71_H      FRC_PK_H_(0x41, 0x71)
#define REG_FRC_BK41_72_L      FRC_PK_L_(0x41, 0x72)
#define REG_FRC_BK41_72_H      FRC_PK_H_(0x41, 0x72)
#define REG_FRC_BK41_73_L      FRC_PK_L_(0x41, 0x73)
#define REG_FRC_BK41_73_H      FRC_PK_H_(0x41, 0x73)
#define REG_FRC_BK41_74_L      FRC_PK_L_(0x41, 0x74)
#define REG_FRC_BK41_74_H      FRC_PK_H_(0x41, 0x74)
#define REG_FRC_BK41_75_L      FRC_PK_L_(0x41, 0x75)
#define REG_FRC_BK41_75_H      FRC_PK_H_(0x41, 0x75)
#define REG_FRC_BK41_76_L      FRC_PK_L_(0x41, 0x76)
#define REG_FRC_BK41_76_H      FRC_PK_H_(0x41, 0x76)
#define REG_FRC_BK41_77_L      FRC_PK_L_(0x41, 0x77)
#define REG_FRC_BK41_77_H      FRC_PK_H_(0x41, 0x77)
#define REG_FRC_BK41_78_L      FRC_PK_L_(0x41, 0x78)
#define REG_FRC_BK41_78_H      FRC_PK_H_(0x41, 0x78)
#define REG_FRC_BK41_79_L      FRC_PK_L_(0x41, 0x79)
#define REG_FRC_BK41_79_H      FRC_PK_H_(0x41, 0x79)
#define REG_FRC_BK41_7A_L      FRC_PK_L_(0x41, 0x7A)
#define REG_FRC_BK41_7A_H      FRC_PK_H_(0x41, 0x7A)
#define REG_FRC_BK41_7B_L      FRC_PK_L_(0x41, 0x7B)
#define REG_FRC_BK41_7B_H      FRC_PK_H_(0x41, 0x7B)
#define REG_FRC_BK41_7C_L      FRC_PK_L_(0x41, 0x7C)
#define REG_FRC_BK41_7C_H      FRC_PK_H_(0x41, 0x7C)
#define REG_FRC_BK41_7D_L      FRC_PK_L_(0x41, 0x7D)
#define REG_FRC_BK41_7D_H      FRC_PK_H_(0x41, 0x7D)
#define REG_FRC_BK41_7E_L      FRC_PK_L_(0x41, 0x7E)
#define REG_FRC_BK41_7E_H      FRC_PK_H_(0x41, 0x7E)
#define REG_FRC_BK41_7F_L      FRC_PK_L_(0x41, 0x7F)
#define REG_FRC_BK41_7F_H      FRC_PK_H_(0x41, 0x7F)
//----------------------------------------------
//  BK42
//----------------------------------------------
#define REG_FRC_BK42_00_L      FRC_PK_L_(0x42, 0x00)
#define REG_FRC_BK42_00_H      FRC_PK_H_(0x42, 0x00)
#define REG_FRC_BK42_01_L      FRC_PK_L_(0x42, 0x01)
#define REG_FRC_BK42_01_H      FRC_PK_H_(0x42, 0x01)
#define REG_FRC_BK42_02_L      FRC_PK_L_(0x42, 0x02)
#define REG_FRC_BK42_02_H      FRC_PK_H_(0x42, 0x02)
#define REG_FRC_BK42_03_L      FRC_PK_L_(0x42, 0x03)
#define REG_FRC_BK42_03_H      FRC_PK_H_(0x42, 0x03)
#define REG_FRC_BK42_04_L      FRC_PK_L_(0x42, 0x04)
#define REG_FRC_BK42_04_H      FRC_PK_H_(0x42, 0x04)
#define REG_FRC_BK42_05_L      FRC_PK_L_(0x42, 0x05)
#define REG_FRC_BK42_05_H      FRC_PK_H_(0x42, 0x05)
#define REG_FRC_BK42_06_L      FRC_PK_L_(0x42, 0x06)
#define REG_FRC_BK42_06_H      FRC_PK_H_(0x42, 0x06)
#define REG_FRC_BK42_07_L      FRC_PK_L_(0x42, 0x07)
#define REG_FRC_BK42_07_H      FRC_PK_H_(0x42, 0x07)
#define REG_FRC_BK42_08_L      FRC_PK_L_(0x42, 0x08)
#define REG_FRC_BK42_08_H      FRC_PK_H_(0x42, 0x08)
#define REG_FRC_BK42_09_L      FRC_PK_L_(0x42, 0x09)
#define REG_FRC_BK42_09_H      FRC_PK_H_(0x42, 0x09)
#define REG_FRC_BK42_0A_L      FRC_PK_L_(0x42, 0x0A)
#define REG_FRC_BK42_0A_H      FRC_PK_H_(0x42, 0x0A)
#define REG_FRC_BK42_0B_L      FRC_PK_L_(0x42, 0x0B)
#define REG_FRC_BK42_0B_H      FRC_PK_H_(0x42, 0x0B)
#define REG_FRC_BK42_0C_L      FRC_PK_L_(0x42, 0x0C)
#define REG_FRC_BK42_0C_H      FRC_PK_H_(0x42, 0x0C)
#define REG_FRC_BK42_0D_L      FRC_PK_L_(0x42, 0x0D)
#define REG_FRC_BK42_0D_H      FRC_PK_H_(0x42, 0x0D)
#define REG_FRC_BK42_0E_L      FRC_PK_L_(0x42, 0x0E)
#define REG_FRC_BK42_0E_H      FRC_PK_H_(0x42, 0x0E)
#define REG_FRC_BK42_0F_L      FRC_PK_L_(0x42, 0x0F)
#define REG_FRC_BK42_0F_H      FRC_PK_H_(0x42, 0x0F)
#define REG_FRC_BK42_10_L      FRC_PK_L_(0x42, 0x10)
#define REG_FRC_BK42_10_H      FRC_PK_H_(0x42, 0x10)
#define REG_FRC_BK42_11_L      FRC_PK_L_(0x42, 0x11)
#define REG_FRC_BK42_11_H      FRC_PK_H_(0x42, 0x11)
#define REG_FRC_BK42_12_L      FRC_PK_L_(0x42, 0x12)
#define REG_FRC_BK42_12_H      FRC_PK_H_(0x42, 0x12)
#define REG_FRC_BK42_13_L      FRC_PK_L_(0x42, 0x13)
#define REG_FRC_BK42_13_H      FRC_PK_H_(0x42, 0x13)
#define REG_FRC_BK42_14_L      FRC_PK_L_(0x42, 0x14)
#define REG_FRC_BK42_14_H      FRC_PK_H_(0x42, 0x14)
#define REG_FRC_BK42_15_L      FRC_PK_L_(0x42, 0x15)
#define REG_FRC_BK42_15_H      FRC_PK_H_(0x42, 0x15)
#define REG_FRC_BK42_16_L      FRC_PK_L_(0x42, 0x16)
#define REG_FRC_BK42_16_H      FRC_PK_H_(0x42, 0x16)
#define REG_FRC_BK42_17_L      FRC_PK_L_(0x42, 0x17)
#define REG_FRC_BK42_17_H      FRC_PK_H_(0x42, 0x17)
#define REG_FRC_BK42_18_L      FRC_PK_L_(0x42, 0x18)
#define REG_FRC_BK42_18_H      FRC_PK_H_(0x42, 0x18)
#define REG_FRC_BK42_19_L      FRC_PK_L_(0x42, 0x19)
#define REG_FRC_BK42_19_H      FRC_PK_H_(0x42, 0x19)
#define REG_FRC_BK42_1A_L      FRC_PK_L_(0x42, 0x1A)
#define REG_FRC_BK42_1A_H      FRC_PK_H_(0x42, 0x1A)
#define REG_FRC_BK42_1B_L      FRC_PK_L_(0x42, 0x1B)
#define REG_FRC_BK42_1B_H      FRC_PK_H_(0x42, 0x1B)
#define REG_FRC_BK42_1C_L      FRC_PK_L_(0x42, 0x1C)
#define REG_FRC_BK42_1C_H      FRC_PK_H_(0x42, 0x1C)
#define REG_FRC_BK42_1D_L      FRC_PK_L_(0x42, 0x1D)
#define REG_FRC_BK42_1D_H      FRC_PK_H_(0x42, 0x1D)
#define REG_FRC_BK42_1E_L      FRC_PK_L_(0x42, 0x1E)
#define REG_FRC_BK42_1E_H      FRC_PK_H_(0x42, 0x1E)
#define REG_FRC_BK42_1F_L      FRC_PK_L_(0x42, 0x1F)
#define REG_FRC_BK42_1F_H      FRC_PK_H_(0x42, 0x1F)
#define REG_FRC_BK42_20_L      FRC_PK_L_(0x42, 0x20)
#define REG_FRC_BK42_20_H      FRC_PK_H_(0x42, 0x20)
#define REG_FRC_BK42_21_L      FRC_PK_L_(0x42, 0x21)
#define REG_FRC_BK42_21_H      FRC_PK_H_(0x42, 0x21)
#define REG_FRC_BK42_22_L      FRC_PK_L_(0x42, 0x22)
#define REG_FRC_BK42_22_H      FRC_PK_H_(0x42, 0x22)
#define REG_FRC_BK42_23_L      FRC_PK_L_(0x42, 0x23)
#define REG_FRC_BK42_23_H      FRC_PK_H_(0x42, 0x23)
#define REG_FRC_BK42_24_L      FRC_PK_L_(0x42, 0x24)
#define REG_FRC_BK42_24_H      FRC_PK_H_(0x42, 0x24)
#define REG_FRC_BK42_25_L      FRC_PK_L_(0x42, 0x25)
#define REG_FRC_BK42_25_H      FRC_PK_H_(0x42, 0x25)
#define REG_FRC_BK42_26_L      FRC_PK_L_(0x42, 0x26)
#define REG_FRC_BK42_26_H      FRC_PK_H_(0x42, 0x26)
#define REG_FRC_BK42_27_L      FRC_PK_L_(0x42, 0x27)
#define REG_FRC_BK42_27_H      FRC_PK_H_(0x42, 0x27)
#define REG_FRC_BK42_28_L      FRC_PK_L_(0x42, 0x28)
#define REG_FRC_BK42_28_H      FRC_PK_H_(0x42, 0x28)
#define REG_FRC_BK42_29_L      FRC_PK_L_(0x42, 0x29)
#define REG_FRC_BK42_29_H      FRC_PK_H_(0x42, 0x29)
#define REG_FRC_BK42_2A_L      FRC_PK_L_(0x42, 0x2A)
#define REG_FRC_BK42_2A_H      FRC_PK_H_(0x42, 0x2A)
#define REG_FRC_BK42_2B_L      FRC_PK_L_(0x42, 0x2B)
#define REG_FRC_BK42_2B_H      FRC_PK_H_(0x42, 0x2B)
#define REG_FRC_BK42_2C_L      FRC_PK_L_(0x42, 0x2C)
#define REG_FRC_BK42_2C_H      FRC_PK_H_(0x42, 0x2C)
#define REG_FRC_BK42_2D_L      FRC_PK_L_(0x42, 0x2D)
#define REG_FRC_BK42_2D_H      FRC_PK_H_(0x42, 0x2D)
#define REG_FRC_BK42_2E_L      FRC_PK_L_(0x42, 0x2E)
#define REG_FRC_BK42_2E_H      FRC_PK_H_(0x42, 0x2E)
#define REG_FRC_BK42_2F_L      FRC_PK_L_(0x42, 0x2F)
#define REG_FRC_BK42_2F_H      FRC_PK_H_(0x42, 0x2F)
#define REG_FRC_BK42_30_L      FRC_PK_L_(0x42, 0x30)
#define REG_FRC_BK42_30_H      FRC_PK_H_(0x42, 0x30)
#define REG_FRC_BK42_31_L      FRC_PK_L_(0x42, 0x31)
#define REG_FRC_BK42_31_H      FRC_PK_H_(0x42, 0x31)
#define REG_FRC_BK42_32_L      FRC_PK_L_(0x42, 0x32)
#define REG_FRC_BK42_32_H      FRC_PK_H_(0x42, 0x32)
#define REG_FRC_BK42_33_L      FRC_PK_L_(0x42, 0x33)
#define REG_FRC_BK42_33_H      FRC_PK_H_(0x42, 0x33)
#define REG_FRC_BK42_34_L      FRC_PK_L_(0x42, 0x34)
#define REG_FRC_BK42_34_H      FRC_PK_H_(0x42, 0x34)
#define REG_FRC_BK42_35_L      FRC_PK_L_(0x42, 0x35)
#define REG_FRC_BK42_35_H      FRC_PK_H_(0x42, 0x35)
#define REG_FRC_BK42_36_L      FRC_PK_L_(0x42, 0x36)
#define REG_FRC_BK42_36_H      FRC_PK_H_(0x42, 0x36)
#define REG_FRC_BK42_37_L      FRC_PK_L_(0x42, 0x37)
#define REG_FRC_BK42_37_H      FRC_PK_H_(0x42, 0x37)
#define REG_FRC_BK42_38_L      FRC_PK_L_(0x42, 0x38)
#define REG_FRC_BK42_38_H      FRC_PK_H_(0x42, 0x38)
#define REG_FRC_BK42_39_L      FRC_PK_L_(0x42, 0x39)
#define REG_FRC_BK42_39_H      FRC_PK_H_(0x42, 0x39)
#define REG_FRC_BK42_3A_L      FRC_PK_L_(0x42, 0x3A)
#define REG_FRC_BK42_3A_H      FRC_PK_H_(0x42, 0x3A)
#define REG_FRC_BK42_3B_L      FRC_PK_L_(0x42, 0x3B)
#define REG_FRC_BK42_3B_H      FRC_PK_H_(0x42, 0x3B)
#define REG_FRC_BK42_3C_L      FRC_PK_L_(0x42, 0x3C)
#define REG_FRC_BK42_3C_H      FRC_PK_H_(0x42, 0x3C)
#define REG_FRC_BK42_3D_L      FRC_PK_L_(0x42, 0x3D)
#define REG_FRC_BK42_3D_H      FRC_PK_H_(0x42, 0x3D)
#define REG_FRC_BK42_3E_L      FRC_PK_L_(0x42, 0x3E)
#define REG_FRC_BK42_3E_H      FRC_PK_H_(0x42, 0x3E)
#define REG_FRC_BK42_3F_L      FRC_PK_L_(0x42, 0x3F)
#define REG_FRC_BK42_3F_H      FRC_PK_H_(0x42, 0x3F)
#define REG_FRC_BK42_40_L      FRC_PK_L_(0x42, 0x40)
#define REG_FRC_BK42_40_H      FRC_PK_H_(0x42, 0x40)
#define REG_FRC_BK42_41_L      FRC_PK_L_(0x42, 0x41)
#define REG_FRC_BK42_41_H      FRC_PK_H_(0x42, 0x41)
#define REG_FRC_BK42_42_L      FRC_PK_L_(0x42, 0x42)
#define REG_FRC_BK42_42_H      FRC_PK_H_(0x42, 0x42)
#define REG_FRC_BK42_43_L      FRC_PK_L_(0x42, 0x43)
#define REG_FRC_BK42_43_H      FRC_PK_H_(0x42, 0x43)
#define REG_FRC_BK42_44_L      FRC_PK_L_(0x42, 0x44)
#define REG_FRC_BK42_44_H      FRC_PK_H_(0x42, 0x44)
#define REG_FRC_BK42_45_L      FRC_PK_L_(0x42, 0x45)
#define REG_FRC_BK42_45_H      FRC_PK_H_(0x42, 0x45)
#define REG_FRC_BK42_46_L      FRC_PK_L_(0x42, 0x46)
#define REG_FRC_BK42_46_H      FRC_PK_H_(0x42, 0x46)
#define REG_FRC_BK42_47_L      FRC_PK_L_(0x42, 0x47)
#define REG_FRC_BK42_47_H      FRC_PK_H_(0x42, 0x47)
#define REG_FRC_BK42_48_L      FRC_PK_L_(0x42, 0x48)
#define REG_FRC_BK42_48_H      FRC_PK_H_(0x42, 0x48)
#define REG_FRC_BK42_49_L      FRC_PK_L_(0x42, 0x49)
#define REG_FRC_BK42_49_H      FRC_PK_H_(0x42, 0x49)
#define REG_FRC_BK42_4A_L      FRC_PK_L_(0x42, 0x4A)
#define REG_FRC_BK42_4A_H      FRC_PK_H_(0x42, 0x4A)
#define REG_FRC_BK42_4B_L      FRC_PK_L_(0x42, 0x4B)
#define REG_FRC_BK42_4B_H      FRC_PK_H_(0x42, 0x4B)
#define REG_FRC_BK42_4C_L      FRC_PK_L_(0x42, 0x4C)
#define REG_FRC_BK42_4C_H      FRC_PK_H_(0x42, 0x4C)
#define REG_FRC_BK42_4D_L      FRC_PK_L_(0x42, 0x4D)
#define REG_FRC_BK42_4D_H      FRC_PK_H_(0x42, 0x4D)
#define REG_FRC_BK42_4E_L      FRC_PK_L_(0x42, 0x4E)
#define REG_FRC_BK42_4E_H      FRC_PK_H_(0x42, 0x4E)
#define REG_FRC_BK42_4F_L      FRC_PK_L_(0x42, 0x4F)
#define REG_FRC_BK42_4F_H      FRC_PK_H_(0x42, 0x4F)
#define REG_FRC_BK42_50_L      FRC_PK_L_(0x42, 0x50)
#define REG_FRC_BK42_50_H      FRC_PK_H_(0x42, 0x50)
#define REG_FRC_BK42_51_L      FRC_PK_L_(0x42, 0x51)
#define REG_FRC_BK42_51_H      FRC_PK_H_(0x42, 0x51)
#define REG_FRC_BK42_52_L      FRC_PK_L_(0x42, 0x52)
#define REG_FRC_BK42_52_H      FRC_PK_H_(0x42, 0x52)
#define REG_FRC_BK42_53_L      FRC_PK_L_(0x42, 0x53)
#define REG_FRC_BK42_53_H      FRC_PK_H_(0x42, 0x53)
#define REG_FRC_BK42_54_L      FRC_PK_L_(0x42, 0x54)
#define REG_FRC_BK42_54_H      FRC_PK_H_(0x42, 0x54)
#define REG_FRC_BK42_55_L      FRC_PK_L_(0x42, 0x55)
#define REG_FRC_BK42_55_H      FRC_PK_H_(0x42, 0x55)
#define REG_FRC_BK42_56_L      FRC_PK_L_(0x42, 0x56)
#define REG_FRC_BK42_56_H      FRC_PK_H_(0x42, 0x56)
#define REG_FRC_BK42_57_L      FRC_PK_L_(0x42, 0x57)
#define REG_FRC_BK42_57_H      FRC_PK_H_(0x42, 0x57)
#define REG_FRC_BK42_58_L      FRC_PK_L_(0x42, 0x58)
#define REG_FRC_BK42_58_H      FRC_PK_H_(0x42, 0x58)
#define REG_FRC_BK42_59_L      FRC_PK_L_(0x42, 0x59)
#define REG_FRC_BK42_59_H      FRC_PK_H_(0x42, 0x59)
#define REG_FRC_BK42_5A_L      FRC_PK_L_(0x42, 0x5A)
#define REG_FRC_BK42_5A_H      FRC_PK_H_(0x42, 0x5A)
#define REG_FRC_BK42_5B_L      FRC_PK_L_(0x42, 0x5B)
#define REG_FRC_BK42_5B_H      FRC_PK_H_(0x42, 0x5B)
#define REG_FRC_BK42_5C_L      FRC_PK_L_(0x42, 0x5C)
#define REG_FRC_BK42_5C_H      FRC_PK_H_(0x42, 0x5C)
#define REG_FRC_BK42_5D_L      FRC_PK_L_(0x42, 0x5D)
#define REG_FRC_BK42_5D_H      FRC_PK_H_(0x42, 0x5D)
#define REG_FRC_BK42_5E_L      FRC_PK_L_(0x42, 0x5E)
#define REG_FRC_BK42_5E_H      FRC_PK_H_(0x42, 0x5E)
#define REG_FRC_BK42_5F_L      FRC_PK_L_(0x42, 0x5F)
#define REG_FRC_BK42_5F_H      FRC_PK_H_(0x42, 0x5F)
#define REG_FRC_BK42_60_L      FRC_PK_L_(0x42, 0x60)
#define REG_FRC_BK42_60_H      FRC_PK_H_(0x42, 0x60)
#define REG_FRC_BK42_61_L      FRC_PK_L_(0x42, 0x61)
#define REG_FRC_BK42_61_H      FRC_PK_H_(0x42, 0x61)
#define REG_FRC_BK42_62_L      FRC_PK_L_(0x42, 0x62)
#define REG_FRC_BK42_62_H      FRC_PK_H_(0x42, 0x62)
#define REG_FRC_BK42_63_L      FRC_PK_L_(0x42, 0x63)
#define REG_FRC_BK42_63_H      FRC_PK_H_(0x42, 0x63)
#define REG_FRC_BK42_64_L      FRC_PK_L_(0x42, 0x64)
#define REG_FRC_BK42_64_H      FRC_PK_H_(0x42, 0x64)
#define REG_FRC_BK42_65_L      FRC_PK_L_(0x42, 0x65)
#define REG_FRC_BK42_65_H      FRC_PK_H_(0x42, 0x65)
#define REG_FRC_BK42_66_L      FRC_PK_L_(0x42, 0x66)
#define REG_FRC_BK42_66_H      FRC_PK_H_(0x42, 0x66)
#define REG_FRC_BK42_67_L      FRC_PK_L_(0x42, 0x67)
#define REG_FRC_BK42_67_H      FRC_PK_H_(0x42, 0x67)
#define REG_FRC_BK42_68_L      FRC_PK_L_(0x42, 0x68)
#define REG_FRC_BK42_68_H      FRC_PK_H_(0x42, 0x68)
#define REG_FRC_BK42_69_L      FRC_PK_L_(0x42, 0x69)
#define REG_FRC_BK42_69_H      FRC_PK_H_(0x42, 0x69)
#define REG_FRC_BK42_6A_L      FRC_PK_L_(0x42, 0x6A)
#define REG_FRC_BK42_6A_H      FRC_PK_H_(0x42, 0x6A)
#define REG_FRC_BK42_6B_L      FRC_PK_L_(0x42, 0x6B)
#define REG_FRC_BK42_6B_H      FRC_PK_H_(0x42, 0x6B)
#define REG_FRC_BK42_6C_L      FRC_PK_L_(0x42, 0x6C)
#define REG_FRC_BK42_6C_H      FRC_PK_H_(0x42, 0x6C)
#define REG_FRC_BK42_6D_L      FRC_PK_L_(0x42, 0x6D)
#define REG_FRC_BK42_6D_H      FRC_PK_H_(0x42, 0x6D)
#define REG_FRC_BK42_6E_L      FRC_PK_L_(0x42, 0x6E)
#define REG_FRC_BK42_6E_H      FRC_PK_H_(0x42, 0x6E)
#define REG_FRC_BK42_6F_L      FRC_PK_L_(0x42, 0x6F)
#define REG_FRC_BK42_6F_H      FRC_PK_H_(0x42, 0x6F)
#define REG_FRC_BK42_70_L      FRC_PK_L_(0x42, 0x70)
#define REG_FRC_BK42_70_H      FRC_PK_H_(0x42, 0x70)
#define REG_FRC_BK42_71_L      FRC_PK_L_(0x42, 0x71)
#define REG_FRC_BK42_71_H      FRC_PK_H_(0x42, 0x71)
#define REG_FRC_BK42_72_L      FRC_PK_L_(0x42, 0x72)
#define REG_FRC_BK42_72_H      FRC_PK_H_(0x42, 0x72)
#define REG_FRC_BK42_73_L      FRC_PK_L_(0x42, 0x73)
#define REG_FRC_BK42_73_H      FRC_PK_H_(0x42, 0x73)
#define REG_FRC_BK42_74_L      FRC_PK_L_(0x42, 0x74)
#define REG_FRC_BK42_74_H      FRC_PK_H_(0x42, 0x74)
#define REG_FRC_BK42_75_L      FRC_PK_L_(0x42, 0x75)
#define REG_FRC_BK42_75_H      FRC_PK_H_(0x42, 0x75)
#define REG_FRC_BK42_76_L      FRC_PK_L_(0x42, 0x76)
#define REG_FRC_BK42_76_H      FRC_PK_H_(0x42, 0x76)
#define REG_FRC_BK42_77_L      FRC_PK_L_(0x42, 0x77)
#define REG_FRC_BK42_77_H      FRC_PK_H_(0x42, 0x77)
#define REG_FRC_BK42_78_L      FRC_PK_L_(0x42, 0x78)
#define REG_FRC_BK42_78_H      FRC_PK_H_(0x42, 0x78)
#define REG_FRC_BK42_79_L      FRC_PK_L_(0x42, 0x79)
#define REG_FRC_BK42_79_H      FRC_PK_H_(0x42, 0x79)
#define REG_FRC_BK42_7A_L      FRC_PK_L_(0x42, 0x7A)
#define REG_FRC_BK42_7A_H      FRC_PK_H_(0x42, 0x7A)
#define REG_FRC_BK42_7B_L      FRC_PK_L_(0x42, 0x7B)
#define REG_FRC_BK42_7B_H      FRC_PK_H_(0x42, 0x7B)
#define REG_FRC_BK42_7C_L      FRC_PK_L_(0x42, 0x7C)
#define REG_FRC_BK42_7C_H      FRC_PK_H_(0x42, 0x7C)
#define REG_FRC_BK42_7D_L      FRC_PK_L_(0x42, 0x7D)
#define REG_FRC_BK42_7D_H      FRC_PK_H_(0x42, 0x7D)
#define REG_FRC_BK42_7E_L      FRC_PK_L_(0x42, 0x7E)
#define REG_FRC_BK42_7E_H      FRC_PK_H_(0x42, 0x7E)
#define REG_FRC_BK42_7F_L      FRC_PK_L_(0x42, 0x7F)
#define REG_FRC_BK42_7F_H      FRC_PK_H_(0x42, 0x7F)
//----------------------------------------------
//  BK43
//----------------------------------------------
#define REG_FRC_BK43_00_L      FRC_PK_L_(0x43, 0x00)
#define REG_FRC_BK43_00_H      FRC_PK_H_(0x43, 0x00)
#define REG_FRC_BK43_01_L      FRC_PK_L_(0x43, 0x01)
#define REG_FRC_BK43_01_H      FRC_PK_H_(0x43, 0x01)
#define REG_FRC_BK43_02_L      FRC_PK_L_(0x43, 0x02)
#define REG_FRC_BK43_02_H      FRC_PK_H_(0x43, 0x02)
#define REG_FRC_BK43_03_L      FRC_PK_L_(0x43, 0x03)
#define REG_FRC_BK43_03_H      FRC_PK_H_(0x43, 0x03)
#define REG_FRC_BK43_04_L      FRC_PK_L_(0x43, 0x04)
#define REG_FRC_BK43_04_H      FRC_PK_H_(0x43, 0x04)
#define REG_FRC_BK43_05_L      FRC_PK_L_(0x43, 0x05)
#define REG_FRC_BK43_05_H      FRC_PK_H_(0x43, 0x05)
#define REG_FRC_BK43_06_L      FRC_PK_L_(0x43, 0x06)
#define REG_FRC_BK43_06_H      FRC_PK_H_(0x43, 0x06)
#define REG_FRC_BK43_07_L      FRC_PK_L_(0x43, 0x07)
#define REG_FRC_BK43_07_H      FRC_PK_H_(0x43, 0x07)
#define REG_FRC_BK43_08_L      FRC_PK_L_(0x43, 0x08)
#define REG_FRC_BK43_08_H      FRC_PK_H_(0x43, 0x08)
#define REG_FRC_BK43_09_L      FRC_PK_L_(0x43, 0x09)
#define REG_FRC_BK43_09_H      FRC_PK_H_(0x43, 0x09)
#define REG_FRC_BK43_0A_L      FRC_PK_L_(0x43, 0x0A)
#define REG_FRC_BK43_0A_H      FRC_PK_H_(0x43, 0x0A)
#define REG_FRC_BK43_0B_L      FRC_PK_L_(0x43, 0x0B)
#define REG_FRC_BK43_0B_H      FRC_PK_H_(0x43, 0x0B)
#define REG_FRC_BK43_0C_L      FRC_PK_L_(0x43, 0x0C)
#define REG_FRC_BK43_0C_H      FRC_PK_H_(0x43, 0x0C)
#define REG_FRC_BK43_0D_L      FRC_PK_L_(0x43, 0x0D)
#define REG_FRC_BK43_0D_H      FRC_PK_H_(0x43, 0x0D)
#define REG_FRC_BK43_0E_L      FRC_PK_L_(0x43, 0x0E)
#define REG_FRC_BK43_0E_H      FRC_PK_H_(0x43, 0x0E)
#define REG_FRC_BK43_0F_L      FRC_PK_L_(0x43, 0x0F)
#define REG_FRC_BK43_0F_H      FRC_PK_H_(0x43, 0x0F)
#define REG_FRC_BK43_10_L      FRC_PK_L_(0x43, 0x10)
#define REG_FRC_BK43_10_H      FRC_PK_H_(0x43, 0x10)
#define REG_FRC_BK43_11_L      FRC_PK_L_(0x43, 0x11)
#define REG_FRC_BK43_11_H      FRC_PK_H_(0x43, 0x11)
#define REG_FRC_BK43_12_L      FRC_PK_L_(0x43, 0x12)
#define REG_FRC_BK43_12_H      FRC_PK_H_(0x43, 0x12)
#define REG_FRC_BK43_13_L      FRC_PK_L_(0x43, 0x13)
#define REG_FRC_BK43_13_H      FRC_PK_H_(0x43, 0x13)
#define REG_FRC_BK43_14_L      FRC_PK_L_(0x43, 0x14)
#define REG_FRC_BK43_14_H      FRC_PK_H_(0x43, 0x14)
#define REG_FRC_BK43_15_L      FRC_PK_L_(0x43, 0x15)
#define REG_FRC_BK43_15_H      FRC_PK_H_(0x43, 0x15)
#define REG_FRC_BK43_16_L      FRC_PK_L_(0x43, 0x16)
#define REG_FRC_BK43_16_H      FRC_PK_H_(0x43, 0x16)
#define REG_FRC_BK43_17_L      FRC_PK_L_(0x43, 0x17)
#define REG_FRC_BK43_17_H      FRC_PK_H_(0x43, 0x17)
#define REG_FRC_BK43_18_L      FRC_PK_L_(0x43, 0x18)
#define REG_FRC_BK43_18_H      FRC_PK_H_(0x43, 0x18)
#define REG_FRC_BK43_19_L      FRC_PK_L_(0x43, 0x19)
#define REG_FRC_BK43_19_H      FRC_PK_H_(0x43, 0x19)
#define REG_FRC_BK43_1A_L      FRC_PK_L_(0x43, 0x1A)
#define REG_FRC_BK43_1A_H      FRC_PK_H_(0x43, 0x1A)
#define REG_FRC_BK43_1B_L      FRC_PK_L_(0x43, 0x1B)
#define REG_FRC_BK43_1B_H      FRC_PK_H_(0x43, 0x1B)
#define REG_FRC_BK43_1C_L      FRC_PK_L_(0x43, 0x1C)
#define REG_FRC_BK43_1C_H      FRC_PK_H_(0x43, 0x1C)
#define REG_FRC_BK43_1D_L      FRC_PK_L_(0x43, 0x1D)
#define REG_FRC_BK43_1D_H      FRC_PK_H_(0x43, 0x1D)
#define REG_FRC_BK43_1E_L      FRC_PK_L_(0x43, 0x1E)
#define REG_FRC_BK43_1E_H      FRC_PK_H_(0x43, 0x1E)
#define REG_FRC_BK43_1F_L      FRC_PK_L_(0x43, 0x1F)
#define REG_FRC_BK43_1F_H      FRC_PK_H_(0x43, 0x1F)
#define REG_FRC_BK43_20_L      FRC_PK_L_(0x43, 0x20)
#define REG_FRC_BK43_20_H      FRC_PK_H_(0x43, 0x20)
#define REG_FRC_BK43_21_L      FRC_PK_L_(0x43, 0x21)
#define REG_FRC_BK43_21_H      FRC_PK_H_(0x43, 0x21)
#define REG_FRC_BK43_22_L      FRC_PK_L_(0x43, 0x22)
#define REG_FRC_BK43_22_H      FRC_PK_H_(0x43, 0x22)
#define REG_FRC_BK43_23_L      FRC_PK_L_(0x43, 0x23)
#define REG_FRC_BK43_23_H      FRC_PK_H_(0x43, 0x23)
#define REG_FRC_BK43_24_L      FRC_PK_L_(0x43, 0x24)
#define REG_FRC_BK43_24_H      FRC_PK_H_(0x43, 0x24)
#define REG_FRC_BK43_25_L      FRC_PK_L_(0x43, 0x25)
#define REG_FRC_BK43_25_H      FRC_PK_H_(0x43, 0x25)
#define REG_FRC_BK43_26_L      FRC_PK_L_(0x43, 0x26)
#define REG_FRC_BK43_26_H      FRC_PK_H_(0x43, 0x26)
#define REG_FRC_BK43_27_L      FRC_PK_L_(0x43, 0x27)
#define REG_FRC_BK43_27_H      FRC_PK_H_(0x43, 0x27)
#define REG_FRC_BK43_28_L      FRC_PK_L_(0x43, 0x28)
#define REG_FRC_BK43_28_H      FRC_PK_H_(0x43, 0x28)
#define REG_FRC_BK43_29_L      FRC_PK_L_(0x43, 0x29)
#define REG_FRC_BK43_29_H      FRC_PK_H_(0x43, 0x29)
#define REG_FRC_BK43_2A_L      FRC_PK_L_(0x43, 0x2A)
#define REG_FRC_BK43_2A_H      FRC_PK_H_(0x43, 0x2A)
#define REG_FRC_BK43_2B_L      FRC_PK_L_(0x43, 0x2B)
#define REG_FRC_BK43_2B_H      FRC_PK_H_(0x43, 0x2B)
#define REG_FRC_BK43_2C_L      FRC_PK_L_(0x43, 0x2C)
#define REG_FRC_BK43_2C_H      FRC_PK_H_(0x43, 0x2C)
#define REG_FRC_BK43_2D_L      FRC_PK_L_(0x43, 0x2D)
#define REG_FRC_BK43_2D_H      FRC_PK_H_(0x43, 0x2D)
#define REG_FRC_BK43_2E_L      FRC_PK_L_(0x43, 0x2E)
#define REG_FRC_BK43_2E_H      FRC_PK_H_(0x43, 0x2E)
#define REG_FRC_BK43_2F_L      FRC_PK_L_(0x43, 0x2F)
#define REG_FRC_BK43_2F_H      FRC_PK_H_(0x43, 0x2F)
#define REG_FRC_BK43_30_L      FRC_PK_L_(0x43, 0x30)
#define REG_FRC_BK43_30_H      FRC_PK_H_(0x43, 0x30)
#define REG_FRC_BK43_31_L      FRC_PK_L_(0x43, 0x31)
#define REG_FRC_BK43_31_H      FRC_PK_H_(0x43, 0x31)
#define REG_FRC_BK43_32_L      FRC_PK_L_(0x43, 0x32)
#define REG_FRC_BK43_32_H      FRC_PK_H_(0x43, 0x32)
#define REG_FRC_BK43_33_L      FRC_PK_L_(0x43, 0x33)
#define REG_FRC_BK43_33_H      FRC_PK_H_(0x43, 0x33)
#define REG_FRC_BK43_34_L      FRC_PK_L_(0x43, 0x34)
#define REG_FRC_BK43_34_H      FRC_PK_H_(0x43, 0x34)
#define REG_FRC_BK43_35_L      FRC_PK_L_(0x43, 0x35)
#define REG_FRC_BK43_35_H      FRC_PK_H_(0x43, 0x35)
#define REG_FRC_BK43_36_L      FRC_PK_L_(0x43, 0x36)
#define REG_FRC_BK43_36_H      FRC_PK_H_(0x43, 0x36)
#define REG_FRC_BK43_37_L      FRC_PK_L_(0x43, 0x37)
#define REG_FRC_BK43_37_H      FRC_PK_H_(0x43, 0x37)
#define REG_FRC_BK43_38_L      FRC_PK_L_(0x43, 0x38)
#define REG_FRC_BK43_38_H      FRC_PK_H_(0x43, 0x38)
#define REG_FRC_BK43_39_L      FRC_PK_L_(0x43, 0x39)
#define REG_FRC_BK43_39_H      FRC_PK_H_(0x43, 0x39)
#define REG_FRC_BK43_3A_L      FRC_PK_L_(0x43, 0x3A)
#define REG_FRC_BK43_3A_H      FRC_PK_H_(0x43, 0x3A)
#define REG_FRC_BK43_3B_L      FRC_PK_L_(0x43, 0x3B)
#define REG_FRC_BK43_3B_H      FRC_PK_H_(0x43, 0x3B)
#define REG_FRC_BK43_3C_L      FRC_PK_L_(0x43, 0x3C)
#define REG_FRC_BK43_3C_H      FRC_PK_H_(0x43, 0x3C)
#define REG_FRC_BK43_3D_L      FRC_PK_L_(0x43, 0x3D)
#define REG_FRC_BK43_3D_H      FRC_PK_H_(0x43, 0x3D)
#define REG_FRC_BK43_3E_L      FRC_PK_L_(0x43, 0x3E)
#define REG_FRC_BK43_3E_H      FRC_PK_H_(0x43, 0x3E)
#define REG_FRC_BK43_3F_L      FRC_PK_L_(0x43, 0x3F)
#define REG_FRC_BK43_3F_H      FRC_PK_H_(0x43, 0x3F)
#define REG_FRC_BK43_40_L      FRC_PK_L_(0x43, 0x40)
#define REG_FRC_BK43_40_H      FRC_PK_H_(0x43, 0x40)
#define REG_FRC_BK43_41_L      FRC_PK_L_(0x43, 0x41)
#define REG_FRC_BK43_41_H      FRC_PK_H_(0x43, 0x41)
#define REG_FRC_BK43_42_L      FRC_PK_L_(0x43, 0x42)
#define REG_FRC_BK43_42_H      FRC_PK_H_(0x43, 0x42)
#define REG_FRC_BK43_43_L      FRC_PK_L_(0x43, 0x43)
#define REG_FRC_BK43_43_H      FRC_PK_H_(0x43, 0x43)
#define REG_FRC_BK43_44_L      FRC_PK_L_(0x43, 0x44)
#define REG_FRC_BK43_44_H      FRC_PK_H_(0x43, 0x44)
#define REG_FRC_BK43_45_L      FRC_PK_L_(0x43, 0x45)
#define REG_FRC_BK43_45_H      FRC_PK_H_(0x43, 0x45)
#define REG_FRC_BK43_46_L      FRC_PK_L_(0x43, 0x46)
#define REG_FRC_BK43_46_H      FRC_PK_H_(0x43, 0x46)
#define REG_FRC_BK43_47_L      FRC_PK_L_(0x43, 0x47)
#define REG_FRC_BK43_47_H      FRC_PK_H_(0x43, 0x47)
#define REG_FRC_BK43_48_L      FRC_PK_L_(0x43, 0x48)
#define REG_FRC_BK43_48_H      FRC_PK_H_(0x43, 0x48)
#define REG_FRC_BK43_49_L      FRC_PK_L_(0x43, 0x49)
#define REG_FRC_BK43_49_H      FRC_PK_H_(0x43, 0x49)
#define REG_FRC_BK43_4A_L      FRC_PK_L_(0x43, 0x4A)
#define REG_FRC_BK43_4A_H      FRC_PK_H_(0x43, 0x4A)
#define REG_FRC_BK43_4B_L      FRC_PK_L_(0x43, 0x4B)
#define REG_FRC_BK43_4B_H      FRC_PK_H_(0x43, 0x4B)
#define REG_FRC_BK43_4C_L      FRC_PK_L_(0x43, 0x4C)
#define REG_FRC_BK43_4C_H      FRC_PK_H_(0x43, 0x4C)
#define REG_FRC_BK43_4D_L      FRC_PK_L_(0x43, 0x4D)
#define REG_FRC_BK43_4D_H      FRC_PK_H_(0x43, 0x4D)
#define REG_FRC_BK43_4E_L      FRC_PK_L_(0x43, 0x4E)
#define REG_FRC_BK43_4E_H      FRC_PK_H_(0x43, 0x4E)
#define REG_FRC_BK43_4F_L      FRC_PK_L_(0x43, 0x4F)
#define REG_FRC_BK43_4F_H      FRC_PK_H_(0x43, 0x4F)
#define REG_FRC_BK43_50_L      FRC_PK_L_(0x43, 0x50)
#define REG_FRC_BK43_50_H      FRC_PK_H_(0x43, 0x50)
#define REG_FRC_BK43_51_L      FRC_PK_L_(0x43, 0x51)
#define REG_FRC_BK43_51_H      FRC_PK_H_(0x43, 0x51)
#define REG_FRC_BK43_52_L      FRC_PK_L_(0x43, 0x52)
#define REG_FRC_BK43_52_H      FRC_PK_H_(0x43, 0x52)
#define REG_FRC_BK43_53_L      FRC_PK_L_(0x43, 0x53)
#define REG_FRC_BK43_53_H      FRC_PK_H_(0x43, 0x53)
#define REG_FRC_BK43_54_L      FRC_PK_L_(0x43, 0x54)
#define REG_FRC_BK43_54_H      FRC_PK_H_(0x43, 0x54)
#define REG_FRC_BK43_55_L      FRC_PK_L_(0x43, 0x55)
#define REG_FRC_BK43_55_H      FRC_PK_H_(0x43, 0x55)
#define REG_FRC_BK43_56_L      FRC_PK_L_(0x43, 0x56)
#define REG_FRC_BK43_56_H      FRC_PK_H_(0x43, 0x56)
#define REG_FRC_BK43_57_L      FRC_PK_L_(0x43, 0x57)
#define REG_FRC_BK43_57_H      FRC_PK_H_(0x43, 0x57)
#define REG_FRC_BK43_58_L      FRC_PK_L_(0x43, 0x58)
#define REG_FRC_BK43_58_H      FRC_PK_H_(0x43, 0x58)
#define REG_FRC_BK43_59_L      FRC_PK_L_(0x43, 0x59)
#define REG_FRC_BK43_59_H      FRC_PK_H_(0x43, 0x59)
#define REG_FRC_BK43_5A_L      FRC_PK_L_(0x43, 0x5A)
#define REG_FRC_BK43_5A_H      FRC_PK_H_(0x43, 0x5A)
#define REG_FRC_BK43_5B_L      FRC_PK_L_(0x43, 0x5B)
#define REG_FRC_BK43_5B_H      FRC_PK_H_(0x43, 0x5B)
#define REG_FRC_BK43_5C_L      FRC_PK_L_(0x43, 0x5C)
#define REG_FRC_BK43_5C_H      FRC_PK_H_(0x43, 0x5C)
#define REG_FRC_BK43_5D_L      FRC_PK_L_(0x43, 0x5D)
#define REG_FRC_BK43_5D_H      FRC_PK_H_(0x43, 0x5D)
#define REG_FRC_BK43_5E_L      FRC_PK_L_(0x43, 0x5E)
#define REG_FRC_BK43_5E_H      FRC_PK_H_(0x43, 0x5E)
#define REG_FRC_BK43_5F_L      FRC_PK_L_(0x43, 0x5F)
#define REG_FRC_BK43_5F_H      FRC_PK_H_(0x43, 0x5F)
#define REG_FRC_BK43_60_L      FRC_PK_L_(0x43, 0x60)
#define REG_FRC_BK43_60_H      FRC_PK_H_(0x43, 0x60)
#define REG_FRC_BK43_61_L      FRC_PK_L_(0x43, 0x61)
#define REG_FRC_BK43_61_H      FRC_PK_H_(0x43, 0x61)
#define REG_FRC_BK43_62_L      FRC_PK_L_(0x43, 0x62)
#define REG_FRC_BK43_62_H      FRC_PK_H_(0x43, 0x62)
#define REG_FRC_BK43_63_L      FRC_PK_L_(0x43, 0x63)
#define REG_FRC_BK43_63_H      FRC_PK_H_(0x43, 0x63)
#define REG_FRC_BK43_64_L      FRC_PK_L_(0x43, 0x64)
#define REG_FRC_BK43_64_H      FRC_PK_H_(0x43, 0x64)
#define REG_FRC_BK43_65_L      FRC_PK_L_(0x43, 0x65)
#define REG_FRC_BK43_65_H      FRC_PK_H_(0x43, 0x65)
#define REG_FRC_BK43_66_L      FRC_PK_L_(0x43, 0x66)
#define REG_FRC_BK43_66_H      FRC_PK_H_(0x43, 0x66)
#define REG_FRC_BK43_67_L      FRC_PK_L_(0x43, 0x67)
#define REG_FRC_BK43_67_H      FRC_PK_H_(0x43, 0x67)
#define REG_FRC_BK43_68_L      FRC_PK_L_(0x43, 0x68)
#define REG_FRC_BK43_68_H      FRC_PK_H_(0x43, 0x68)
#define REG_FRC_BK43_69_L      FRC_PK_L_(0x43, 0x69)
#define REG_FRC_BK43_69_H      FRC_PK_H_(0x43, 0x69)
#define REG_FRC_BK43_6A_L      FRC_PK_L_(0x43, 0x6A)
#define REG_FRC_BK43_6A_H      FRC_PK_H_(0x43, 0x6A)
#define REG_FRC_BK43_6B_L      FRC_PK_L_(0x43, 0x6B)
#define REG_FRC_BK43_6B_H      FRC_PK_H_(0x43, 0x6B)
#define REG_FRC_BK43_6C_L      FRC_PK_L_(0x43, 0x6C)
#define REG_FRC_BK43_6C_H      FRC_PK_H_(0x43, 0x6C)
#define REG_FRC_BK43_6D_L      FRC_PK_L_(0x43, 0x6D)
#define REG_FRC_BK43_6D_H      FRC_PK_H_(0x43, 0x6D)
#define REG_FRC_BK43_6E_L      FRC_PK_L_(0x43, 0x6E)
#define REG_FRC_BK43_6E_H      FRC_PK_H_(0x43, 0x6E)
#define REG_FRC_BK43_6F_L      FRC_PK_L_(0x43, 0x6F)
#define REG_FRC_BK43_6F_H      FRC_PK_H_(0x43, 0x6F)
#define REG_FRC_BK43_70_L      FRC_PK_L_(0x43, 0x70)
#define REG_FRC_BK43_70_H      FRC_PK_H_(0x43, 0x70)
#define REG_FRC_BK43_71_L      FRC_PK_L_(0x43, 0x71)
#define REG_FRC_BK43_71_H      FRC_PK_H_(0x43, 0x71)
#define REG_FRC_BK43_72_L      FRC_PK_L_(0x43, 0x72)
#define REG_FRC_BK43_72_H      FRC_PK_H_(0x43, 0x72)
#define REG_FRC_BK43_73_L      FRC_PK_L_(0x43, 0x73)
#define REG_FRC_BK43_73_H      FRC_PK_H_(0x43, 0x73)
#define REG_FRC_BK43_74_L      FRC_PK_L_(0x43, 0x74)
#define REG_FRC_BK43_74_H      FRC_PK_H_(0x43, 0x74)
#define REG_FRC_BK43_75_L      FRC_PK_L_(0x43, 0x75)
#define REG_FRC_BK43_75_H      FRC_PK_H_(0x43, 0x75)
#define REG_FRC_BK43_76_L      FRC_PK_L_(0x43, 0x76)
#define REG_FRC_BK43_76_H      FRC_PK_H_(0x43, 0x76)
#define REG_FRC_BK43_77_L      FRC_PK_L_(0x43, 0x77)
#define REG_FRC_BK43_77_H      FRC_PK_H_(0x43, 0x77)
#define REG_FRC_BK43_78_L      FRC_PK_L_(0x43, 0x78)
#define REG_FRC_BK43_78_H      FRC_PK_H_(0x43, 0x78)
#define REG_FRC_BK43_79_L      FRC_PK_L_(0x43, 0x79)
#define REG_FRC_BK43_79_H      FRC_PK_H_(0x43, 0x79)
#define REG_FRC_BK43_7A_L      FRC_PK_L_(0x43, 0x7A)
#define REG_FRC_BK43_7A_H      FRC_PK_H_(0x43, 0x7A)
#define REG_FRC_BK43_7B_L      FRC_PK_L_(0x43, 0x7B)
#define REG_FRC_BK43_7B_H      FRC_PK_H_(0x43, 0x7B)
#define REG_FRC_BK43_7C_L      FRC_PK_L_(0x43, 0x7C)
#define REG_FRC_BK43_7C_H      FRC_PK_H_(0x43, 0x7C)
#define REG_FRC_BK43_7D_L      FRC_PK_L_(0x43, 0x7D)
#define REG_FRC_BK43_7D_H      FRC_PK_H_(0x43, 0x7D)
#define REG_FRC_BK43_7E_L      FRC_PK_L_(0x43, 0x7E)
#define REG_FRC_BK43_7E_H      FRC_PK_H_(0x43, 0x7E)
#define REG_FRC_BK43_7F_L      FRC_PK_L_(0x43, 0x7F)
#define REG_FRC_BK43_7F_H      FRC_PK_H_(0x43, 0x7F)
//----------------------------------------------
//  BK44
//----------------------------------------------
#define REG_FRC_BK44_00_L      FRC_PK_L_(0x44, 0x00)
#define REG_FRC_BK44_00_H      FRC_PK_H_(0x44, 0x00)
#define REG_FRC_BK44_01_L      FRC_PK_L_(0x44, 0x01)
#define REG_FRC_BK44_01_H      FRC_PK_H_(0x44, 0x01)
#define REG_FRC_BK44_02_L      FRC_PK_L_(0x44, 0x02)
#define REG_FRC_BK44_02_H      FRC_PK_H_(0x44, 0x02)
#define REG_FRC_BK44_03_L      FRC_PK_L_(0x44, 0x03)
#define REG_FRC_BK44_03_H      FRC_PK_H_(0x44, 0x03)
#define REG_FRC_BK44_04_L      FRC_PK_L_(0x44, 0x04)
#define REG_FRC_BK44_04_H      FRC_PK_H_(0x44, 0x04)
#define REG_FRC_BK44_05_L      FRC_PK_L_(0x44, 0x05)
#define REG_FRC_BK44_05_H      FRC_PK_H_(0x44, 0x05)
#define REG_FRC_BK44_06_L      FRC_PK_L_(0x44, 0x06)
#define REG_FRC_BK44_06_H      FRC_PK_H_(0x44, 0x06)
#define REG_FRC_BK44_07_L      FRC_PK_L_(0x44, 0x07)
#define REG_FRC_BK44_07_H      FRC_PK_H_(0x44, 0x07)
#define REG_FRC_BK44_08_L      FRC_PK_L_(0x44, 0x08)
#define REG_FRC_BK44_08_H      FRC_PK_H_(0x44, 0x08)
#define REG_FRC_BK44_09_L      FRC_PK_L_(0x44, 0x09)
#define REG_FRC_BK44_09_H      FRC_PK_H_(0x44, 0x09)
#define REG_FRC_BK44_0A_L      FRC_PK_L_(0x44, 0x0A)
#define REG_FRC_BK44_0A_H      FRC_PK_H_(0x44, 0x0A)
#define REG_FRC_BK44_0B_L      FRC_PK_L_(0x44, 0x0B)
#define REG_FRC_BK44_0B_H      FRC_PK_H_(0x44, 0x0B)
#define REG_FRC_BK44_0C_L      FRC_PK_L_(0x44, 0x0C)
#define REG_FRC_BK44_0C_H      FRC_PK_H_(0x44, 0x0C)
#define REG_FRC_BK44_0D_L      FRC_PK_L_(0x44, 0x0D)
#define REG_FRC_BK44_0D_H      FRC_PK_H_(0x44, 0x0D)
#define REG_FRC_BK44_0E_L      FRC_PK_L_(0x44, 0x0E)
#define REG_FRC_BK44_0E_H      FRC_PK_H_(0x44, 0x0E)
#define REG_FRC_BK44_0F_L      FRC_PK_L_(0x44, 0x0F)
#define REG_FRC_BK44_0F_H      FRC_PK_H_(0x44, 0x0F)
#define REG_FRC_BK44_10_L      FRC_PK_L_(0x44, 0x10)
#define REG_FRC_BK44_10_H      FRC_PK_H_(0x44, 0x10)
#define REG_FRC_BK44_11_L      FRC_PK_L_(0x44, 0x11)
#define REG_FRC_BK44_11_H      FRC_PK_H_(0x44, 0x11)
#define REG_FRC_BK44_12_L      FRC_PK_L_(0x44, 0x12)
#define REG_FRC_BK44_12_H      FRC_PK_H_(0x44, 0x12)
#define REG_FRC_BK44_13_L      FRC_PK_L_(0x44, 0x13)
#define REG_FRC_BK44_13_H      FRC_PK_H_(0x44, 0x13)
#define REG_FRC_BK44_14_L      FRC_PK_L_(0x44, 0x14)
#define REG_FRC_BK44_14_H      FRC_PK_H_(0x44, 0x14)
#define REG_FRC_BK44_15_L      FRC_PK_L_(0x44, 0x15)
#define REG_FRC_BK44_15_H      FRC_PK_H_(0x44, 0x15)
#define REG_FRC_BK44_16_L      FRC_PK_L_(0x44, 0x16)
#define REG_FRC_BK44_16_H      FRC_PK_H_(0x44, 0x16)
#define REG_FRC_BK44_17_L      FRC_PK_L_(0x44, 0x17)
#define REG_FRC_BK44_17_H      FRC_PK_H_(0x44, 0x17)
#define REG_FRC_BK44_18_L      FRC_PK_L_(0x44, 0x18)
#define REG_FRC_BK44_18_H      FRC_PK_H_(0x44, 0x18)
#define REG_FRC_BK44_19_L      FRC_PK_L_(0x44, 0x19)
#define REG_FRC_BK44_19_H      FRC_PK_H_(0x44, 0x19)
#define REG_FRC_BK44_1A_L      FRC_PK_L_(0x44, 0x1A)
#define REG_FRC_BK44_1A_H      FRC_PK_H_(0x44, 0x1A)
#define REG_FRC_BK44_1B_L      FRC_PK_L_(0x44, 0x1B)
#define REG_FRC_BK44_1B_H      FRC_PK_H_(0x44, 0x1B)
#define REG_FRC_BK44_1C_L      FRC_PK_L_(0x44, 0x1C)
#define REG_FRC_BK44_1C_H      FRC_PK_H_(0x44, 0x1C)
#define REG_FRC_BK44_1D_L      FRC_PK_L_(0x44, 0x1D)
#define REG_FRC_BK44_1D_H      FRC_PK_H_(0x44, 0x1D)
#define REG_FRC_BK44_1E_L      FRC_PK_L_(0x44, 0x1E)
#define REG_FRC_BK44_1E_H      FRC_PK_H_(0x44, 0x1E)
#define REG_FRC_BK44_1F_L      FRC_PK_L_(0x44, 0x1F)
#define REG_FRC_BK44_1F_H      FRC_PK_H_(0x44, 0x1F)
#define REG_FRC_BK44_20_L      FRC_PK_L_(0x44, 0x20)
#define REG_FRC_BK44_20_H      FRC_PK_H_(0x44, 0x20)
#define REG_FRC_BK44_21_L      FRC_PK_L_(0x44, 0x21)
#define REG_FRC_BK44_21_H      FRC_PK_H_(0x44, 0x21)
#define REG_FRC_BK44_22_L      FRC_PK_L_(0x44, 0x22)
#define REG_FRC_BK44_22_H      FRC_PK_H_(0x44, 0x22)
#define REG_FRC_BK44_23_L      FRC_PK_L_(0x44, 0x23)
#define REG_FRC_BK44_23_H      FRC_PK_H_(0x44, 0x23)
#define REG_FRC_BK44_24_L      FRC_PK_L_(0x44, 0x24)
#define REG_FRC_BK44_24_H      FRC_PK_H_(0x44, 0x24)
#define REG_FRC_BK44_25_L      FRC_PK_L_(0x44, 0x25)
#define REG_FRC_BK44_25_H      FRC_PK_H_(0x44, 0x25)
#define REG_FRC_BK44_26_L      FRC_PK_L_(0x44, 0x26)
#define REG_FRC_BK44_26_H      FRC_PK_H_(0x44, 0x26)
#define REG_FRC_BK44_27_L      FRC_PK_L_(0x44, 0x27)
#define REG_FRC_BK44_27_H      FRC_PK_H_(0x44, 0x27)
#define REG_FRC_BK44_28_L      FRC_PK_L_(0x44, 0x28)
#define REG_FRC_BK44_28_H      FRC_PK_H_(0x44, 0x28)
#define REG_FRC_BK44_29_L      FRC_PK_L_(0x44, 0x29)
#define REG_FRC_BK44_29_H      FRC_PK_H_(0x44, 0x29)
#define REG_FRC_BK44_2A_L      FRC_PK_L_(0x44, 0x2A)
#define REG_FRC_BK44_2A_H      FRC_PK_H_(0x44, 0x2A)
#define REG_FRC_BK44_2B_L      FRC_PK_L_(0x44, 0x2B)
#define REG_FRC_BK44_2B_H      FRC_PK_H_(0x44, 0x2B)
#define REG_FRC_BK44_2C_L      FRC_PK_L_(0x44, 0x2C)
#define REG_FRC_BK44_2C_H      FRC_PK_H_(0x44, 0x2C)
#define REG_FRC_BK44_2D_L      FRC_PK_L_(0x44, 0x2D)
#define REG_FRC_BK44_2D_H      FRC_PK_H_(0x44, 0x2D)
#define REG_FRC_BK44_2E_L      FRC_PK_L_(0x44, 0x2E)
#define REG_FRC_BK44_2E_H      FRC_PK_H_(0x44, 0x2E)
#define REG_FRC_BK44_2F_L      FRC_PK_L_(0x44, 0x2F)
#define REG_FRC_BK44_2F_H      FRC_PK_H_(0x44, 0x2F)
#define REG_FRC_BK44_30_L      FRC_PK_L_(0x44, 0x30)
#define REG_FRC_BK44_30_H      FRC_PK_H_(0x44, 0x30)
#define REG_FRC_BK44_31_L      FRC_PK_L_(0x44, 0x31)
#define REG_FRC_BK44_31_H      FRC_PK_H_(0x44, 0x31)
#define REG_FRC_BK44_32_L      FRC_PK_L_(0x44, 0x32)
#define REG_FRC_BK44_32_H      FRC_PK_H_(0x44, 0x32)
#define REG_FRC_BK44_33_L      FRC_PK_L_(0x44, 0x33)
#define REG_FRC_BK44_33_H      FRC_PK_H_(0x44, 0x33)
#define REG_FRC_BK44_34_L      FRC_PK_L_(0x44, 0x34)
#define REG_FRC_BK44_34_H      FRC_PK_H_(0x44, 0x34)
#define REG_FRC_BK44_35_L      FRC_PK_L_(0x44, 0x35)
#define REG_FRC_BK44_35_H      FRC_PK_H_(0x44, 0x35)
#define REG_FRC_BK44_36_L      FRC_PK_L_(0x44, 0x36)
#define REG_FRC_BK44_36_H      FRC_PK_H_(0x44, 0x36)
#define REG_FRC_BK44_37_L      FRC_PK_L_(0x44, 0x37)
#define REG_FRC_BK44_37_H      FRC_PK_H_(0x44, 0x37)
#define REG_FRC_BK44_38_L      FRC_PK_L_(0x44, 0x38)
#define REG_FRC_BK44_38_H      FRC_PK_H_(0x44, 0x38)
#define REG_FRC_BK44_39_L      FRC_PK_L_(0x44, 0x39)
#define REG_FRC_BK44_39_H      FRC_PK_H_(0x44, 0x39)
#define REG_FRC_BK44_3A_L      FRC_PK_L_(0x44, 0x3A)
#define REG_FRC_BK44_3A_H      FRC_PK_H_(0x44, 0x3A)
#define REG_FRC_BK44_3B_L      FRC_PK_L_(0x44, 0x3B)
#define REG_FRC_BK44_3B_H      FRC_PK_H_(0x44, 0x3B)
#define REG_FRC_BK44_3C_L      FRC_PK_L_(0x44, 0x3C)
#define REG_FRC_BK44_3C_H      FRC_PK_H_(0x44, 0x3C)
#define REG_FRC_BK44_3D_L      FRC_PK_L_(0x44, 0x3D)
#define REG_FRC_BK44_3D_H      FRC_PK_H_(0x44, 0x3D)
#define REG_FRC_BK44_3E_L      FRC_PK_L_(0x44, 0x3E)
#define REG_FRC_BK44_3E_H      FRC_PK_H_(0x44, 0x3E)
#define REG_FRC_BK44_3F_L      FRC_PK_L_(0x44, 0x3F)
#define REG_FRC_BK44_3F_H      FRC_PK_H_(0x44, 0x3F)
#define REG_FRC_BK44_40_L      FRC_PK_L_(0x44, 0x40)
#define REG_FRC_BK44_40_H      FRC_PK_H_(0x44, 0x40)
#define REG_FRC_BK44_41_L      FRC_PK_L_(0x44, 0x41)
#define REG_FRC_BK44_41_H      FRC_PK_H_(0x44, 0x41)
#define REG_FRC_BK44_42_L      FRC_PK_L_(0x44, 0x42)
#define REG_FRC_BK44_42_H      FRC_PK_H_(0x44, 0x42)
#define REG_FRC_BK44_43_L      FRC_PK_L_(0x44, 0x43)
#define REG_FRC_BK44_43_H      FRC_PK_H_(0x44, 0x43)
#define REG_FRC_BK44_44_L      FRC_PK_L_(0x44, 0x44)
#define REG_FRC_BK44_44_H      FRC_PK_H_(0x44, 0x44)
#define REG_FRC_BK44_45_L      FRC_PK_L_(0x44, 0x45)
#define REG_FRC_BK44_45_H      FRC_PK_H_(0x44, 0x45)
#define REG_FRC_BK44_46_L      FRC_PK_L_(0x44, 0x46)
#define REG_FRC_BK44_46_H      FRC_PK_H_(0x44, 0x46)
#define REG_FRC_BK44_47_L      FRC_PK_L_(0x44, 0x47)
#define REG_FRC_BK44_47_H      FRC_PK_H_(0x44, 0x47)
#define REG_FRC_BK44_48_L      FRC_PK_L_(0x44, 0x48)
#define REG_FRC_BK44_48_H      FRC_PK_H_(0x44, 0x48)
#define REG_FRC_BK44_49_L      FRC_PK_L_(0x44, 0x49)
#define REG_FRC_BK44_49_H      FRC_PK_H_(0x44, 0x49)
#define REG_FRC_BK44_4A_L      FRC_PK_L_(0x44, 0x4A)
#define REG_FRC_BK44_4A_H      FRC_PK_H_(0x44, 0x4A)
#define REG_FRC_BK44_4B_L      FRC_PK_L_(0x44, 0x4B)
#define REG_FRC_BK44_4B_H      FRC_PK_H_(0x44, 0x4B)
#define REG_FRC_BK44_4C_L      FRC_PK_L_(0x44, 0x4C)
#define REG_FRC_BK44_4C_H      FRC_PK_H_(0x44, 0x4C)
#define REG_FRC_BK44_4D_L      FRC_PK_L_(0x44, 0x4D)
#define REG_FRC_BK44_4D_H      FRC_PK_H_(0x44, 0x4D)
#define REG_FRC_BK44_4E_L      FRC_PK_L_(0x44, 0x4E)
#define REG_FRC_BK44_4E_H      FRC_PK_H_(0x44, 0x4E)
#define REG_FRC_BK44_4F_L      FRC_PK_L_(0x44, 0x4F)
#define REG_FRC_BK44_4F_H      FRC_PK_H_(0x44, 0x4F)
#define REG_FRC_BK44_50_L      FRC_PK_L_(0x44, 0x50)
#define REG_FRC_BK44_50_H      FRC_PK_H_(0x44, 0x50)
#define REG_FRC_BK44_51_L      FRC_PK_L_(0x44, 0x51)
#define REG_FRC_BK44_51_H      FRC_PK_H_(0x44, 0x51)
#define REG_FRC_BK44_52_L      FRC_PK_L_(0x44, 0x52)
#define REG_FRC_BK44_52_H      FRC_PK_H_(0x44, 0x52)
#define REG_FRC_BK44_53_L      FRC_PK_L_(0x44, 0x53)
#define REG_FRC_BK44_53_H      FRC_PK_H_(0x44, 0x53)
#define REG_FRC_BK44_54_L      FRC_PK_L_(0x44, 0x54)
#define REG_FRC_BK44_54_H      FRC_PK_H_(0x44, 0x54)
#define REG_FRC_BK44_55_L      FRC_PK_L_(0x44, 0x55)
#define REG_FRC_BK44_55_H      FRC_PK_H_(0x44, 0x55)
#define REG_FRC_BK44_56_L      FRC_PK_L_(0x44, 0x56)
#define REG_FRC_BK44_56_H      FRC_PK_H_(0x44, 0x56)
#define REG_FRC_BK44_57_L      FRC_PK_L_(0x44, 0x57)
#define REG_FRC_BK44_57_H      FRC_PK_H_(0x44, 0x57)
#define REG_FRC_BK44_58_L      FRC_PK_L_(0x44, 0x58)
#define REG_FRC_BK44_58_H      FRC_PK_H_(0x44, 0x58)
#define REG_FRC_BK44_59_L      FRC_PK_L_(0x44, 0x59)
#define REG_FRC_BK44_59_H      FRC_PK_H_(0x44, 0x59)
#define REG_FRC_BK44_5A_L      FRC_PK_L_(0x44, 0x5A)
#define REG_FRC_BK44_5A_H      FRC_PK_H_(0x44, 0x5A)
#define REG_FRC_BK44_5B_L      FRC_PK_L_(0x44, 0x5B)
#define REG_FRC_BK44_5B_H      FRC_PK_H_(0x44, 0x5B)
#define REG_FRC_BK44_5C_L      FRC_PK_L_(0x44, 0x5C)
#define REG_FRC_BK44_5C_H      FRC_PK_H_(0x44, 0x5C)
#define REG_FRC_BK44_5D_L      FRC_PK_L_(0x44, 0x5D)
#define REG_FRC_BK44_5D_H      FRC_PK_H_(0x44, 0x5D)
#define REG_FRC_BK44_5E_L      FRC_PK_L_(0x44, 0x5E)
#define REG_FRC_BK44_5E_H      FRC_PK_H_(0x44, 0x5E)
#define REG_FRC_BK44_5F_L      FRC_PK_L_(0x44, 0x5F)
#define REG_FRC_BK44_5F_H      FRC_PK_H_(0x44, 0x5F)
#define REG_FRC_BK44_60_L      FRC_PK_L_(0x44, 0x60)
#define REG_FRC_BK44_60_H      FRC_PK_H_(0x44, 0x60)
#define REG_FRC_BK44_61_L      FRC_PK_L_(0x44, 0x61)
#define REG_FRC_BK44_61_H      FRC_PK_H_(0x44, 0x61)
#define REG_FRC_BK44_62_L      FRC_PK_L_(0x44, 0x62)
#define REG_FRC_BK44_62_H      FRC_PK_H_(0x44, 0x62)
#define REG_FRC_BK44_63_L      FRC_PK_L_(0x44, 0x63)
#define REG_FRC_BK44_63_H      FRC_PK_H_(0x44, 0x63)
#define REG_FRC_BK44_64_L      FRC_PK_L_(0x44, 0x64)
#define REG_FRC_BK44_64_H      FRC_PK_H_(0x44, 0x64)
#define REG_FRC_BK44_65_L      FRC_PK_L_(0x44, 0x65)
#define REG_FRC_BK44_65_H      FRC_PK_H_(0x44, 0x65)
#define REG_FRC_BK44_66_L      FRC_PK_L_(0x44, 0x66)
#define REG_FRC_BK44_66_H      FRC_PK_H_(0x44, 0x66)
#define REG_FRC_BK44_67_L      FRC_PK_L_(0x44, 0x67)
#define REG_FRC_BK44_67_H      FRC_PK_H_(0x44, 0x67)
#define REG_FRC_BK44_68_L      FRC_PK_L_(0x44, 0x68)
#define REG_FRC_BK44_68_H      FRC_PK_H_(0x44, 0x68)
#define REG_FRC_BK44_69_L      FRC_PK_L_(0x44, 0x69)
#define REG_FRC_BK44_69_H      FRC_PK_H_(0x44, 0x69)
#define REG_FRC_BK44_6A_L      FRC_PK_L_(0x44, 0x6A)
#define REG_FRC_BK44_6A_H      FRC_PK_H_(0x44, 0x6A)
#define REG_FRC_BK44_6B_L      FRC_PK_L_(0x44, 0x6B)
#define REG_FRC_BK44_6B_H      FRC_PK_H_(0x44, 0x6B)
#define REG_FRC_BK44_6C_L      FRC_PK_L_(0x44, 0x6C)
#define REG_FRC_BK44_6C_H      FRC_PK_H_(0x44, 0x6C)
#define REG_FRC_BK44_6D_L      FRC_PK_L_(0x44, 0x6D)
#define REG_FRC_BK44_6D_H      FRC_PK_H_(0x44, 0x6D)
#define REG_FRC_BK44_6E_L      FRC_PK_L_(0x44, 0x6E)
#define REG_FRC_BK44_6E_H      FRC_PK_H_(0x44, 0x6E)
#define REG_FRC_BK44_6F_L      FRC_PK_L_(0x44, 0x6F)
#define REG_FRC_BK44_6F_H      FRC_PK_H_(0x44, 0x6F)
#define REG_FRC_BK44_70_L      FRC_PK_L_(0x44, 0x70)
#define REG_FRC_BK44_70_H      FRC_PK_H_(0x44, 0x70)
#define REG_FRC_BK44_71_L      FRC_PK_L_(0x44, 0x71)
#define REG_FRC_BK44_71_H      FRC_PK_H_(0x44, 0x71)
#define REG_FRC_BK44_72_L      FRC_PK_L_(0x44, 0x72)
#define REG_FRC_BK44_72_H      FRC_PK_H_(0x44, 0x72)
#define REG_FRC_BK44_73_L      FRC_PK_L_(0x44, 0x73)
#define REG_FRC_BK44_73_H      FRC_PK_H_(0x44, 0x73)
#define REG_FRC_BK44_74_L      FRC_PK_L_(0x44, 0x74)
#define REG_FRC_BK44_74_H      FRC_PK_H_(0x44, 0x74)
#define REG_FRC_BK44_75_L      FRC_PK_L_(0x44, 0x75)
#define REG_FRC_BK44_75_H      FRC_PK_H_(0x44, 0x75)
#define REG_FRC_BK44_76_L      FRC_PK_L_(0x44, 0x76)
#define REG_FRC_BK44_76_H      FRC_PK_H_(0x44, 0x76)
#define REG_FRC_BK44_77_L      FRC_PK_L_(0x44, 0x77)
#define REG_FRC_BK44_77_H      FRC_PK_H_(0x44, 0x77)
#define REG_FRC_BK44_78_L      FRC_PK_L_(0x44, 0x78)
#define REG_FRC_BK44_78_H      FRC_PK_H_(0x44, 0x78)
#define REG_FRC_BK44_79_L      FRC_PK_L_(0x44, 0x79)
#define REG_FRC_BK44_79_H      FRC_PK_H_(0x44, 0x79)
#define REG_FRC_BK44_7A_L      FRC_PK_L_(0x44, 0x7A)
#define REG_FRC_BK44_7A_H      FRC_PK_H_(0x44, 0x7A)
#define REG_FRC_BK44_7B_L      FRC_PK_L_(0x44, 0x7B)
#define REG_FRC_BK44_7B_H      FRC_PK_H_(0x44, 0x7B)
#define REG_FRC_BK44_7C_L      FRC_PK_L_(0x44, 0x7C)
#define REG_FRC_BK44_7C_H      FRC_PK_H_(0x44, 0x7C)
#define REG_FRC_BK44_7D_L      FRC_PK_L_(0x44, 0x7D)
#define REG_FRC_BK44_7D_H      FRC_PK_H_(0x44, 0x7D)
#define REG_FRC_BK44_7E_L      FRC_PK_L_(0x44, 0x7E)
#define REG_FRC_BK44_7E_H      FRC_PK_H_(0x44, 0x7E)
#define REG_FRC_BK44_7F_L      FRC_PK_L_(0x44, 0x7F)
#define REG_FRC_BK44_7F_H      FRC_PK_H_(0x44, 0x7F)
//----------------------------------------------
//  BK45
//----------------------------------------------
#define REG_FRC_BK45_00_L      FRC_PK_L_(0x45, 0x00)
#define REG_FRC_BK45_00_H      FRC_PK_H_(0x45, 0x00)
#define REG_FRC_BK45_01_L      FRC_PK_L_(0x45, 0x01)
#define REG_FRC_BK45_01_H      FRC_PK_H_(0x45, 0x01)
#define REG_FRC_BK45_02_L      FRC_PK_L_(0x45, 0x02)
#define REG_FRC_BK45_02_H      FRC_PK_H_(0x45, 0x02)
#define REG_FRC_BK45_03_L      FRC_PK_L_(0x45, 0x03)
#define REG_FRC_BK45_03_H      FRC_PK_H_(0x45, 0x03)
#define REG_FRC_BK45_04_L      FRC_PK_L_(0x45, 0x04)
#define REG_FRC_BK45_04_H      FRC_PK_H_(0x45, 0x04)
#define REG_FRC_BK45_05_L      FRC_PK_L_(0x45, 0x05)
#define REG_FRC_BK45_05_H      FRC_PK_H_(0x45, 0x05)
#define REG_FRC_BK45_06_L      FRC_PK_L_(0x45, 0x06)
#define REG_FRC_BK45_06_H      FRC_PK_H_(0x45, 0x06)
#define REG_FRC_BK45_07_L      FRC_PK_L_(0x45, 0x07)
#define REG_FRC_BK45_07_H      FRC_PK_H_(0x45, 0x07)
#define REG_FRC_BK45_08_L      FRC_PK_L_(0x45, 0x08)
#define REG_FRC_BK45_08_H      FRC_PK_H_(0x45, 0x08)
#define REG_FRC_BK45_09_L      FRC_PK_L_(0x45, 0x09)
#define REG_FRC_BK45_09_H      FRC_PK_H_(0x45, 0x09)
#define REG_FRC_BK45_0A_L      FRC_PK_L_(0x45, 0x0A)
#define REG_FRC_BK45_0A_H      FRC_PK_H_(0x45, 0x0A)
#define REG_FRC_BK45_0B_L      FRC_PK_L_(0x45, 0x0B)
#define REG_FRC_BK45_0B_H      FRC_PK_H_(0x45, 0x0B)
#define REG_FRC_BK45_0C_L      FRC_PK_L_(0x45, 0x0C)
#define REG_FRC_BK45_0C_H      FRC_PK_H_(0x45, 0x0C)
#define REG_FRC_BK45_0D_L      FRC_PK_L_(0x45, 0x0D)
#define REG_FRC_BK45_0D_H      FRC_PK_H_(0x45, 0x0D)
#define REG_FRC_BK45_0E_L      FRC_PK_L_(0x45, 0x0E)
#define REG_FRC_BK45_0E_H      FRC_PK_H_(0x45, 0x0E)
#define REG_FRC_BK45_0F_L      FRC_PK_L_(0x45, 0x0F)
#define REG_FRC_BK45_0F_H      FRC_PK_H_(0x45, 0x0F)
#define REG_FRC_BK45_10_L      FRC_PK_L_(0x45, 0x10)
#define REG_FRC_BK45_10_H      FRC_PK_H_(0x45, 0x10)
#define REG_FRC_BK45_11_L      FRC_PK_L_(0x45, 0x11)
#define REG_FRC_BK45_11_H      FRC_PK_H_(0x45, 0x11)
#define REG_FRC_BK45_12_L      FRC_PK_L_(0x45, 0x12)
#define REG_FRC_BK45_12_H      FRC_PK_H_(0x45, 0x12)
#define REG_FRC_BK45_13_L      FRC_PK_L_(0x45, 0x13)
#define REG_FRC_BK45_13_H      FRC_PK_H_(0x45, 0x13)
#define REG_FRC_BK45_14_L      FRC_PK_L_(0x45, 0x14)
#define REG_FRC_BK45_14_H      FRC_PK_H_(0x45, 0x14)
#define REG_FRC_BK45_15_L      FRC_PK_L_(0x45, 0x15)
#define REG_FRC_BK45_15_H      FRC_PK_H_(0x45, 0x15)
#define REG_FRC_BK45_16_L      FRC_PK_L_(0x45, 0x16)
#define REG_FRC_BK45_16_H      FRC_PK_H_(0x45, 0x16)
#define REG_FRC_BK45_17_L      FRC_PK_L_(0x45, 0x17)
#define REG_FRC_BK45_17_H      FRC_PK_H_(0x45, 0x17)
#define REG_FRC_BK45_18_L      FRC_PK_L_(0x45, 0x18)
#define REG_FRC_BK45_18_H      FRC_PK_H_(0x45, 0x18)
#define REG_FRC_BK45_19_L      FRC_PK_L_(0x45, 0x19)
#define REG_FRC_BK45_19_H      FRC_PK_H_(0x45, 0x19)
#define REG_FRC_BK45_1A_L      FRC_PK_L_(0x45, 0x1A)
#define REG_FRC_BK45_1A_H      FRC_PK_H_(0x45, 0x1A)
#define REG_FRC_BK45_1B_L      FRC_PK_L_(0x45, 0x1B)
#define REG_FRC_BK45_1B_H      FRC_PK_H_(0x45, 0x1B)
#define REG_FRC_BK45_1C_L      FRC_PK_L_(0x45, 0x1C)
#define REG_FRC_BK45_1C_H      FRC_PK_H_(0x45, 0x1C)
#define REG_FRC_BK45_1D_L      FRC_PK_L_(0x45, 0x1D)
#define REG_FRC_BK45_1D_H      FRC_PK_H_(0x45, 0x1D)
#define REG_FRC_BK45_1E_L      FRC_PK_L_(0x45, 0x1E)
#define REG_FRC_BK45_1E_H      FRC_PK_H_(0x45, 0x1E)
#define REG_FRC_BK45_1F_L      FRC_PK_L_(0x45, 0x1F)
#define REG_FRC_BK45_1F_H      FRC_PK_H_(0x45, 0x1F)
#define REG_FRC_BK45_20_L      FRC_PK_L_(0x45, 0x20)
#define REG_FRC_BK45_20_H      FRC_PK_H_(0x45, 0x20)
#define REG_FRC_BK45_21_L      FRC_PK_L_(0x45, 0x21)
#define REG_FRC_BK45_21_H      FRC_PK_H_(0x45, 0x21)
#define REG_FRC_BK45_22_L      FRC_PK_L_(0x45, 0x22)
#define REG_FRC_BK45_22_H      FRC_PK_H_(0x45, 0x22)
#define REG_FRC_BK45_23_L      FRC_PK_L_(0x45, 0x23)
#define REG_FRC_BK45_23_H      FRC_PK_H_(0x45, 0x23)
#define REG_FRC_BK45_24_L      FRC_PK_L_(0x45, 0x24)
#define REG_FRC_BK45_24_H      FRC_PK_H_(0x45, 0x24)
#define REG_FRC_BK45_25_L      FRC_PK_L_(0x45, 0x25)
#define REG_FRC_BK45_25_H      FRC_PK_H_(0x45, 0x25)
#define REG_FRC_BK45_26_L      FRC_PK_L_(0x45, 0x26)
#define REG_FRC_BK45_26_H      FRC_PK_H_(0x45, 0x26)
#define REG_FRC_BK45_27_L      FRC_PK_L_(0x45, 0x27)
#define REG_FRC_BK45_27_H      FRC_PK_H_(0x45, 0x27)
#define REG_FRC_BK45_28_L      FRC_PK_L_(0x45, 0x28)
#define REG_FRC_BK45_28_H      FRC_PK_H_(0x45, 0x28)
#define REG_FRC_BK45_29_L      FRC_PK_L_(0x45, 0x29)
#define REG_FRC_BK45_29_H      FRC_PK_H_(0x45, 0x29)
#define REG_FRC_BK45_2A_L      FRC_PK_L_(0x45, 0x2A)
#define REG_FRC_BK45_2A_H      FRC_PK_H_(0x45, 0x2A)
#define REG_FRC_BK45_2B_L      FRC_PK_L_(0x45, 0x2B)
#define REG_FRC_BK45_2B_H      FRC_PK_H_(0x45, 0x2B)
#define REG_FRC_BK45_2C_L      FRC_PK_L_(0x45, 0x2C)
#define REG_FRC_BK45_2C_H      FRC_PK_H_(0x45, 0x2C)
#define REG_FRC_BK45_2D_L      FRC_PK_L_(0x45, 0x2D)
#define REG_FRC_BK45_2D_H      FRC_PK_H_(0x45, 0x2D)
#define REG_FRC_BK45_2E_L      FRC_PK_L_(0x45, 0x2E)
#define REG_FRC_BK45_2E_H      FRC_PK_H_(0x45, 0x2E)
#define REG_FRC_BK45_2F_L      FRC_PK_L_(0x45, 0x2F)
#define REG_FRC_BK45_2F_H      FRC_PK_H_(0x45, 0x2F)
#define REG_FRC_BK45_30_L      FRC_PK_L_(0x45, 0x30)
#define REG_FRC_BK45_30_H      FRC_PK_H_(0x45, 0x30)
#define REG_FRC_BK45_31_L      FRC_PK_L_(0x45, 0x31)
#define REG_FRC_BK45_31_H      FRC_PK_H_(0x45, 0x31)
#define REG_FRC_BK45_32_L      FRC_PK_L_(0x45, 0x32)
#define REG_FRC_BK45_32_H      FRC_PK_H_(0x45, 0x32)
#define REG_FRC_BK45_33_L      FRC_PK_L_(0x45, 0x33)
#define REG_FRC_BK45_33_H      FRC_PK_H_(0x45, 0x33)
#define REG_FRC_BK45_34_L      FRC_PK_L_(0x45, 0x34)
#define REG_FRC_BK45_34_H      FRC_PK_H_(0x45, 0x34)
#define REG_FRC_BK45_35_L      FRC_PK_L_(0x45, 0x35)
#define REG_FRC_BK45_35_H      FRC_PK_H_(0x45, 0x35)
#define REG_FRC_BK45_36_L      FRC_PK_L_(0x45, 0x36)
#define REG_FRC_BK45_36_H      FRC_PK_H_(0x45, 0x36)
#define REG_FRC_BK45_37_L      FRC_PK_L_(0x45, 0x37)
#define REG_FRC_BK45_37_H      FRC_PK_H_(0x45, 0x37)
#define REG_FRC_BK45_38_L      FRC_PK_L_(0x45, 0x38)
#define REG_FRC_BK45_38_H      FRC_PK_H_(0x45, 0x38)
#define REG_FRC_BK45_39_L      FRC_PK_L_(0x45, 0x39)
#define REG_FRC_BK45_39_H      FRC_PK_H_(0x45, 0x39)
#define REG_FRC_BK45_3A_L      FRC_PK_L_(0x45, 0x3A)
#define REG_FRC_BK45_3A_H      FRC_PK_H_(0x45, 0x3A)
#define REG_FRC_BK45_3B_L      FRC_PK_L_(0x45, 0x3B)
#define REG_FRC_BK45_3B_H      FRC_PK_H_(0x45, 0x3B)
#define REG_FRC_BK45_3C_L      FRC_PK_L_(0x45, 0x3C)
#define REG_FRC_BK45_3C_H      FRC_PK_H_(0x45, 0x3C)
#define REG_FRC_BK45_3D_L      FRC_PK_L_(0x45, 0x3D)
#define REG_FRC_BK45_3D_H      FRC_PK_H_(0x45, 0x3D)
#define REG_FRC_BK45_3E_L      FRC_PK_L_(0x45, 0x3E)
#define REG_FRC_BK45_3E_H      FRC_PK_H_(0x45, 0x3E)
#define REG_FRC_BK45_3F_L      FRC_PK_L_(0x45, 0x3F)
#define REG_FRC_BK45_3F_H      FRC_PK_H_(0x45, 0x3F)
#define REG_FRC_BK45_40_L      FRC_PK_L_(0x45, 0x40)
#define REG_FRC_BK45_40_H      FRC_PK_H_(0x45, 0x40)
#define REG_FRC_BK45_41_L      FRC_PK_L_(0x45, 0x41)
#define REG_FRC_BK45_41_H      FRC_PK_H_(0x45, 0x41)
#define REG_FRC_BK45_42_L      FRC_PK_L_(0x45, 0x42)
#define REG_FRC_BK45_42_H      FRC_PK_H_(0x45, 0x42)
#define REG_FRC_BK45_43_L      FRC_PK_L_(0x45, 0x43)
#define REG_FRC_BK45_43_H      FRC_PK_H_(0x45, 0x43)
#define REG_FRC_BK45_44_L      FRC_PK_L_(0x45, 0x44)
#define REG_FRC_BK45_44_H      FRC_PK_H_(0x45, 0x44)
#define REG_FRC_BK45_45_L      FRC_PK_L_(0x45, 0x45)
#define REG_FRC_BK45_45_H      FRC_PK_H_(0x45, 0x45)
#define REG_FRC_BK45_46_L      FRC_PK_L_(0x45, 0x46)
#define REG_FRC_BK45_46_H      FRC_PK_H_(0x45, 0x46)
#define REG_FRC_BK45_47_L      FRC_PK_L_(0x45, 0x47)
#define REG_FRC_BK45_47_H      FRC_PK_H_(0x45, 0x47)
#define REG_FRC_BK45_48_L      FRC_PK_L_(0x45, 0x48)
#define REG_FRC_BK45_48_H      FRC_PK_H_(0x45, 0x48)
#define REG_FRC_BK45_49_L      FRC_PK_L_(0x45, 0x49)
#define REG_FRC_BK45_49_H      FRC_PK_H_(0x45, 0x49)
#define REG_FRC_BK45_4A_L      FRC_PK_L_(0x45, 0x4A)
#define REG_FRC_BK45_4A_H      FRC_PK_H_(0x45, 0x4A)
#define REG_FRC_BK45_4B_L      FRC_PK_L_(0x45, 0x4B)
#define REG_FRC_BK45_4B_H      FRC_PK_H_(0x45, 0x4B)
#define REG_FRC_BK45_4C_L      FRC_PK_L_(0x45, 0x4C)
#define REG_FRC_BK45_4C_H      FRC_PK_H_(0x45, 0x4C)
#define REG_FRC_BK45_4D_L      FRC_PK_L_(0x45, 0x4D)
#define REG_FRC_BK45_4D_H      FRC_PK_H_(0x45, 0x4D)
#define REG_FRC_BK45_4E_L      FRC_PK_L_(0x45, 0x4E)
#define REG_FRC_BK45_4E_H      FRC_PK_H_(0x45, 0x4E)
#define REG_FRC_BK45_4F_L      FRC_PK_L_(0x45, 0x4F)
#define REG_FRC_BK45_4F_H      FRC_PK_H_(0x45, 0x4F)
#define REG_FRC_BK45_50_L      FRC_PK_L_(0x45, 0x50)
#define REG_FRC_BK45_50_H      FRC_PK_H_(0x45, 0x50)
#define REG_FRC_BK45_51_L      FRC_PK_L_(0x45, 0x51)
#define REG_FRC_BK45_51_H      FRC_PK_H_(0x45, 0x51)
#define REG_FRC_BK45_52_L      FRC_PK_L_(0x45, 0x52)
#define REG_FRC_BK45_52_H      FRC_PK_H_(0x45, 0x52)
#define REG_FRC_BK45_53_L      FRC_PK_L_(0x45, 0x53)
#define REG_FRC_BK45_53_H      FRC_PK_H_(0x45, 0x53)
#define REG_FRC_BK45_54_L      FRC_PK_L_(0x45, 0x54)
#define REG_FRC_BK45_54_H      FRC_PK_H_(0x45, 0x54)
#define REG_FRC_BK45_55_L      FRC_PK_L_(0x45, 0x55)
#define REG_FRC_BK45_55_H      FRC_PK_H_(0x45, 0x55)
#define REG_FRC_BK45_56_L      FRC_PK_L_(0x45, 0x56)
#define REG_FRC_BK45_56_H      FRC_PK_H_(0x45, 0x56)
#define REG_FRC_BK45_57_L      FRC_PK_L_(0x45, 0x57)
#define REG_FRC_BK45_57_H      FRC_PK_H_(0x45, 0x57)
#define REG_FRC_BK45_58_L      FRC_PK_L_(0x45, 0x58)
#define REG_FRC_BK45_58_H      FRC_PK_H_(0x45, 0x58)
#define REG_FRC_BK45_59_L      FRC_PK_L_(0x45, 0x59)
#define REG_FRC_BK45_59_H      FRC_PK_H_(0x45, 0x59)
#define REG_FRC_BK45_5A_L      FRC_PK_L_(0x45, 0x5A)
#define REG_FRC_BK45_5A_H      FRC_PK_H_(0x45, 0x5A)
#define REG_FRC_BK45_5B_L      FRC_PK_L_(0x45, 0x5B)
#define REG_FRC_BK45_5B_H      FRC_PK_H_(0x45, 0x5B)
#define REG_FRC_BK45_5C_L      FRC_PK_L_(0x45, 0x5C)
#define REG_FRC_BK45_5C_H      FRC_PK_H_(0x45, 0x5C)
#define REG_FRC_BK45_5D_L      FRC_PK_L_(0x45, 0x5D)
#define REG_FRC_BK45_5D_H      FRC_PK_H_(0x45, 0x5D)
#define REG_FRC_BK45_5E_L      FRC_PK_L_(0x45, 0x5E)
#define REG_FRC_BK45_5E_H      FRC_PK_H_(0x45, 0x5E)
#define REG_FRC_BK45_5F_L      FRC_PK_L_(0x45, 0x5F)
#define REG_FRC_BK45_5F_H      FRC_PK_H_(0x45, 0x5F)
#define REG_FRC_BK45_60_L      FRC_PK_L_(0x45, 0x60)
#define REG_FRC_BK45_60_H      FRC_PK_H_(0x45, 0x60)
#define REG_FRC_BK45_61_L      FRC_PK_L_(0x45, 0x61)
#define REG_FRC_BK45_61_H      FRC_PK_H_(0x45, 0x61)
#define REG_FRC_BK45_62_L      FRC_PK_L_(0x45, 0x62)
#define REG_FRC_BK45_62_H      FRC_PK_H_(0x45, 0x62)
#define REG_FRC_BK45_63_L      FRC_PK_L_(0x45, 0x63)
#define REG_FRC_BK45_63_H      FRC_PK_H_(0x45, 0x63)
#define REG_FRC_BK45_64_L      FRC_PK_L_(0x45, 0x64)
#define REG_FRC_BK45_64_H      FRC_PK_H_(0x45, 0x64)
#define REG_FRC_BK45_65_L      FRC_PK_L_(0x45, 0x65)
#define REG_FRC_BK45_65_H      FRC_PK_H_(0x45, 0x65)
#define REG_FRC_BK45_66_L      FRC_PK_L_(0x45, 0x66)
#define REG_FRC_BK45_66_H      FRC_PK_H_(0x45, 0x66)
#define REG_FRC_BK45_67_L      FRC_PK_L_(0x45, 0x67)
#define REG_FRC_BK45_67_H      FRC_PK_H_(0x45, 0x67)
#define REG_FRC_BK45_68_L      FRC_PK_L_(0x45, 0x68)
#define REG_FRC_BK45_68_H      FRC_PK_H_(0x45, 0x68)
#define REG_FRC_BK45_69_L      FRC_PK_L_(0x45, 0x69)
#define REG_FRC_BK45_69_H      FRC_PK_H_(0x45, 0x69)
#define REG_FRC_BK45_6A_L      FRC_PK_L_(0x45, 0x6A)
#define REG_FRC_BK45_6A_H      FRC_PK_H_(0x45, 0x6A)
#define REG_FRC_BK45_6B_L      FRC_PK_L_(0x45, 0x6B)
#define REG_FRC_BK45_6B_H      FRC_PK_H_(0x45, 0x6B)
#define REG_FRC_BK45_6C_L      FRC_PK_L_(0x45, 0x6C)
#define REG_FRC_BK45_6C_H      FRC_PK_H_(0x45, 0x6C)
#define REG_FRC_BK45_6D_L      FRC_PK_L_(0x45, 0x6D)
#define REG_FRC_BK45_6D_H      FRC_PK_H_(0x45, 0x6D)
#define REG_FRC_BK45_6E_L      FRC_PK_L_(0x45, 0x6E)
#define REG_FRC_BK45_6E_H      FRC_PK_H_(0x45, 0x6E)
#define REG_FRC_BK45_6F_L      FRC_PK_L_(0x45, 0x6F)
#define REG_FRC_BK45_6F_H      FRC_PK_H_(0x45, 0x6F)
#define REG_FRC_BK45_70_L      FRC_PK_L_(0x45, 0x70)
#define REG_FRC_BK45_70_H      FRC_PK_H_(0x45, 0x70)
#define REG_FRC_BK45_71_L      FRC_PK_L_(0x45, 0x71)
#define REG_FRC_BK45_71_H      FRC_PK_H_(0x45, 0x71)
#define REG_FRC_BK45_72_L      FRC_PK_L_(0x45, 0x72)
#define REG_FRC_BK45_72_H      FRC_PK_H_(0x45, 0x72)
#define REG_FRC_BK45_73_L      FRC_PK_L_(0x45, 0x73)
#define REG_FRC_BK45_73_H      FRC_PK_H_(0x45, 0x73)
#define REG_FRC_BK45_74_L      FRC_PK_L_(0x45, 0x74)
#define REG_FRC_BK45_74_H      FRC_PK_H_(0x45, 0x74)
#define REG_FRC_BK45_75_L      FRC_PK_L_(0x45, 0x75)
#define REG_FRC_BK45_75_H      FRC_PK_H_(0x45, 0x75)
#define REG_FRC_BK45_76_L      FRC_PK_L_(0x45, 0x76)
#define REG_FRC_BK45_76_H      FRC_PK_H_(0x45, 0x76)
#define REG_FRC_BK45_77_L      FRC_PK_L_(0x45, 0x77)
#define REG_FRC_BK45_77_H      FRC_PK_H_(0x45, 0x77)
#define REG_FRC_BK45_78_L      FRC_PK_L_(0x45, 0x78)
#define REG_FRC_BK45_78_H      FRC_PK_H_(0x45, 0x78)
#define REG_FRC_BK45_79_L      FRC_PK_L_(0x45, 0x79)
#define REG_FRC_BK45_79_H      FRC_PK_H_(0x45, 0x79)
#define REG_FRC_BK45_7A_L      FRC_PK_L_(0x45, 0x7A)
#define REG_FRC_BK45_7A_H      FRC_PK_H_(0x45, 0x7A)
#define REG_FRC_BK45_7B_L      FRC_PK_L_(0x45, 0x7B)
#define REG_FRC_BK45_7B_H      FRC_PK_H_(0x45, 0x7B)
#define REG_FRC_BK45_7C_L      FRC_PK_L_(0x45, 0x7C)
#define REG_FRC_BK45_7C_H      FRC_PK_H_(0x45, 0x7C)
#define REG_FRC_BK45_7D_L      FRC_PK_L_(0x45, 0x7D)
#define REG_FRC_BK45_7D_H      FRC_PK_H_(0x45, 0x7D)
#define REG_FRC_BK45_7E_L      FRC_PK_L_(0x45, 0x7E)
#define REG_FRC_BK45_7E_H      FRC_PK_H_(0x45, 0x7E)
#define REG_FRC_BK45_7F_L      FRC_PK_L_(0x45, 0x7F)
#define REG_FRC_BK45_7F_H      FRC_PK_H_(0x45, 0x7F)
//----------------------------------------------
//  BK46
//----------------------------------------------
#define REG_FRC_BK46_00_L      FRC_PK_L_(0x46, 0x00)
#define REG_FRC_BK46_00_H      FRC_PK_H_(0x46, 0x00)
#define REG_FRC_BK46_01_L      FRC_PK_L_(0x46, 0x01)
#define REG_FRC_BK46_01_H      FRC_PK_H_(0x46, 0x01)
#define REG_FRC_BK46_02_L      FRC_PK_L_(0x46, 0x02)
#define REG_FRC_BK46_02_H      FRC_PK_H_(0x46, 0x02)
#define REG_FRC_BK46_03_L      FRC_PK_L_(0x46, 0x03)
#define REG_FRC_BK46_03_H      FRC_PK_H_(0x46, 0x03)
#define REG_FRC_BK46_04_L      FRC_PK_L_(0x46, 0x04)
#define REG_FRC_BK46_04_H      FRC_PK_H_(0x46, 0x04)
#define REG_FRC_BK46_05_L      FRC_PK_L_(0x46, 0x05)
#define REG_FRC_BK46_05_H      FRC_PK_H_(0x46, 0x05)
#define REG_FRC_BK46_06_L      FRC_PK_L_(0x46, 0x06)
#define REG_FRC_BK46_06_H      FRC_PK_H_(0x46, 0x06)
#define REG_FRC_BK46_07_L      FRC_PK_L_(0x46, 0x07)
#define REG_FRC_BK46_07_H      FRC_PK_H_(0x46, 0x07)
#define REG_FRC_BK46_08_L      FRC_PK_L_(0x46, 0x08)
#define REG_FRC_BK46_08_H      FRC_PK_H_(0x46, 0x08)
#define REG_FRC_BK46_09_L      FRC_PK_L_(0x46, 0x09)
#define REG_FRC_BK46_09_H      FRC_PK_H_(0x46, 0x09)
#define REG_FRC_BK46_0A_L      FRC_PK_L_(0x46, 0x0A)
#define REG_FRC_BK46_0A_H      FRC_PK_H_(0x46, 0x0A)
#define REG_FRC_BK46_0B_L      FRC_PK_L_(0x46, 0x0B)
#define REG_FRC_BK46_0B_H      FRC_PK_H_(0x46, 0x0B)
#define REG_FRC_BK46_0C_L      FRC_PK_L_(0x46, 0x0C)
#define REG_FRC_BK46_0C_H      FRC_PK_H_(0x46, 0x0C)
#define REG_FRC_BK46_0D_L      FRC_PK_L_(0x46, 0x0D)
#define REG_FRC_BK46_0D_H      FRC_PK_H_(0x46, 0x0D)
#define REG_FRC_BK46_0E_L      FRC_PK_L_(0x46, 0x0E)
#define REG_FRC_BK46_0E_H      FRC_PK_H_(0x46, 0x0E)
#define REG_FRC_BK46_0F_L      FRC_PK_L_(0x46, 0x0F)
#define REG_FRC_BK46_0F_H      FRC_PK_H_(0x46, 0x0F)
#define REG_FRC_BK46_10_L      FRC_PK_L_(0x46, 0x10)
#define REG_FRC_BK46_10_H      FRC_PK_H_(0x46, 0x10)
#define REG_FRC_BK46_11_L      FRC_PK_L_(0x46, 0x11)
#define REG_FRC_BK46_11_H      FRC_PK_H_(0x46, 0x11)
#define REG_FRC_BK46_12_L      FRC_PK_L_(0x46, 0x12)
#define REG_FRC_BK46_12_H      FRC_PK_H_(0x46, 0x12)
#define REG_FRC_BK46_13_L      FRC_PK_L_(0x46, 0x13)
#define REG_FRC_BK46_13_H      FRC_PK_H_(0x46, 0x13)
#define REG_FRC_BK46_14_L      FRC_PK_L_(0x46, 0x14)
#define REG_FRC_BK46_14_H      FRC_PK_H_(0x46, 0x14)
#define REG_FRC_BK46_15_L      FRC_PK_L_(0x46, 0x15)
#define REG_FRC_BK46_15_H      FRC_PK_H_(0x46, 0x15)
#define REG_FRC_BK46_16_L      FRC_PK_L_(0x46, 0x16)
#define REG_FRC_BK46_16_H      FRC_PK_H_(0x46, 0x16)
#define REG_FRC_BK46_17_L      FRC_PK_L_(0x46, 0x17)
#define REG_FRC_BK46_17_H      FRC_PK_H_(0x46, 0x17)
#define REG_FRC_BK46_18_L      FRC_PK_L_(0x46, 0x18)
#define REG_FRC_BK46_18_H      FRC_PK_H_(0x46, 0x18)
#define REG_FRC_BK46_19_L      FRC_PK_L_(0x46, 0x19)
#define REG_FRC_BK46_19_H      FRC_PK_H_(0x46, 0x19)
#define REG_FRC_BK46_1A_L      FRC_PK_L_(0x46, 0x1A)
#define REG_FRC_BK46_1A_H      FRC_PK_H_(0x46, 0x1A)
#define REG_FRC_BK46_1B_L      FRC_PK_L_(0x46, 0x1B)
#define REG_FRC_BK46_1B_H      FRC_PK_H_(0x46, 0x1B)
#define REG_FRC_BK46_1C_L      FRC_PK_L_(0x46, 0x1C)
#define REG_FRC_BK46_1C_H      FRC_PK_H_(0x46, 0x1C)
#define REG_FRC_BK46_1D_L      FRC_PK_L_(0x46, 0x1D)
#define REG_FRC_BK46_1D_H      FRC_PK_H_(0x46, 0x1D)
#define REG_FRC_BK46_1E_L      FRC_PK_L_(0x46, 0x1E)
#define REG_FRC_BK46_1E_H      FRC_PK_H_(0x46, 0x1E)
#define REG_FRC_BK46_1F_L      FRC_PK_L_(0x46, 0x1F)
#define REG_FRC_BK46_1F_H      FRC_PK_H_(0x46, 0x1F)
#define REG_FRC_BK46_20_L      FRC_PK_L_(0x46, 0x20)
#define REG_FRC_BK46_20_H      FRC_PK_H_(0x46, 0x20)
#define REG_FRC_BK46_21_L      FRC_PK_L_(0x46, 0x21)
#define REG_FRC_BK46_21_H      FRC_PK_H_(0x46, 0x21)
#define REG_FRC_BK46_22_L      FRC_PK_L_(0x46, 0x22)
#define REG_FRC_BK46_22_H      FRC_PK_H_(0x46, 0x22)
#define REG_FRC_BK46_23_L      FRC_PK_L_(0x46, 0x23)
#define REG_FRC_BK46_23_H      FRC_PK_H_(0x46, 0x23)
#define REG_FRC_BK46_24_L      FRC_PK_L_(0x46, 0x24)
#define REG_FRC_BK46_24_H      FRC_PK_H_(0x46, 0x24)
#define REG_FRC_BK46_25_L      FRC_PK_L_(0x46, 0x25)
#define REG_FRC_BK46_25_H      FRC_PK_H_(0x46, 0x25)
#define REG_FRC_BK46_26_L      FRC_PK_L_(0x46, 0x26)
#define REG_FRC_BK46_26_H      FRC_PK_H_(0x46, 0x26)
#define REG_FRC_BK46_27_L      FRC_PK_L_(0x46, 0x27)
#define REG_FRC_BK46_27_H      FRC_PK_H_(0x46, 0x27)
#define REG_FRC_BK46_28_L      FRC_PK_L_(0x46, 0x28)
#define REG_FRC_BK46_28_H      FRC_PK_H_(0x46, 0x28)
#define REG_FRC_BK46_29_L      FRC_PK_L_(0x46, 0x29)
#define REG_FRC_BK46_29_H      FRC_PK_H_(0x46, 0x29)
#define REG_FRC_BK46_2A_L      FRC_PK_L_(0x46, 0x2A)
#define REG_FRC_BK46_2A_H      FRC_PK_H_(0x46, 0x2A)
#define REG_FRC_BK46_2B_L      FRC_PK_L_(0x46, 0x2B)
#define REG_FRC_BK46_2B_H      FRC_PK_H_(0x46, 0x2B)
#define REG_FRC_BK46_2C_L      FRC_PK_L_(0x46, 0x2C)
#define REG_FRC_BK46_2C_H      FRC_PK_H_(0x46, 0x2C)
#define REG_FRC_BK46_2D_L      FRC_PK_L_(0x46, 0x2D)
#define REG_FRC_BK46_2D_H      FRC_PK_H_(0x46, 0x2D)
#define REG_FRC_BK46_2E_L      FRC_PK_L_(0x46, 0x2E)
#define REG_FRC_BK46_2E_H      FRC_PK_H_(0x46, 0x2E)
#define REG_FRC_BK46_2F_L      FRC_PK_L_(0x46, 0x2F)
#define REG_FRC_BK46_2F_H      FRC_PK_H_(0x46, 0x2F)
#define REG_FRC_BK46_30_L      FRC_PK_L_(0x46, 0x30)
#define REG_FRC_BK46_30_H      FRC_PK_H_(0x46, 0x30)
#define REG_FRC_BK46_31_L      FRC_PK_L_(0x46, 0x31)
#define REG_FRC_BK46_31_H      FRC_PK_H_(0x46, 0x31)
#define REG_FRC_BK46_32_L      FRC_PK_L_(0x46, 0x32)
#define REG_FRC_BK46_32_H      FRC_PK_H_(0x46, 0x32)
#define REG_FRC_BK46_33_L      FRC_PK_L_(0x46, 0x33)
#define REG_FRC_BK46_33_H      FRC_PK_H_(0x46, 0x33)
#define REG_FRC_BK46_34_L      FRC_PK_L_(0x46, 0x34)
#define REG_FRC_BK46_34_H      FRC_PK_H_(0x46, 0x34)
#define REG_FRC_BK46_35_L      FRC_PK_L_(0x46, 0x35)
#define REG_FRC_BK46_35_H      FRC_PK_H_(0x46, 0x35)
#define REG_FRC_BK46_36_L      FRC_PK_L_(0x46, 0x36)
#define REG_FRC_BK46_36_H      FRC_PK_H_(0x46, 0x36)
#define REG_FRC_BK46_37_L      FRC_PK_L_(0x46, 0x37)
#define REG_FRC_BK46_37_H      FRC_PK_H_(0x46, 0x37)
#define REG_FRC_BK46_38_L      FRC_PK_L_(0x46, 0x38)
#define REG_FRC_BK46_38_H      FRC_PK_H_(0x46, 0x38)
#define REG_FRC_BK46_39_L      FRC_PK_L_(0x46, 0x39)
#define REG_FRC_BK46_39_H      FRC_PK_H_(0x46, 0x39)
#define REG_FRC_BK46_3A_L      FRC_PK_L_(0x46, 0x3A)
#define REG_FRC_BK46_3A_H      FRC_PK_H_(0x46, 0x3A)
#define REG_FRC_BK46_3B_L      FRC_PK_L_(0x46, 0x3B)
#define REG_FRC_BK46_3B_H      FRC_PK_H_(0x46, 0x3B)
#define REG_FRC_BK46_3C_L      FRC_PK_L_(0x46, 0x3C)
#define REG_FRC_BK46_3C_H      FRC_PK_H_(0x46, 0x3C)
#define REG_FRC_BK46_3D_L      FRC_PK_L_(0x46, 0x3D)
#define REG_FRC_BK46_3D_H      FRC_PK_H_(0x46, 0x3D)
#define REG_FRC_BK46_3E_L      FRC_PK_L_(0x46, 0x3E)
#define REG_FRC_BK46_3E_H      FRC_PK_H_(0x46, 0x3E)
#define REG_FRC_BK46_3F_L      FRC_PK_L_(0x46, 0x3F)
#define REG_FRC_BK46_3F_H      FRC_PK_H_(0x46, 0x3F)
#define REG_FRC_BK46_40_L      FRC_PK_L_(0x46, 0x40)
#define REG_FRC_BK46_40_H      FRC_PK_H_(0x46, 0x40)
#define REG_FRC_BK46_41_L      FRC_PK_L_(0x46, 0x41)
#define REG_FRC_BK46_41_H      FRC_PK_H_(0x46, 0x41)
#define REG_FRC_BK46_42_L      FRC_PK_L_(0x46, 0x42)
#define REG_FRC_BK46_42_H      FRC_PK_H_(0x46, 0x42)
#define REG_FRC_BK46_43_L      FRC_PK_L_(0x46, 0x43)
#define REG_FRC_BK46_43_H      FRC_PK_H_(0x46, 0x43)
#define REG_FRC_BK46_44_L      FRC_PK_L_(0x46, 0x44)
#define REG_FRC_BK46_44_H      FRC_PK_H_(0x46, 0x44)
#define REG_FRC_BK46_45_L      FRC_PK_L_(0x46, 0x45)
#define REG_FRC_BK46_45_H      FRC_PK_H_(0x46, 0x45)
#define REG_FRC_BK46_46_L      FRC_PK_L_(0x46, 0x46)
#define REG_FRC_BK46_46_H      FRC_PK_H_(0x46, 0x46)
#define REG_FRC_BK46_47_L      FRC_PK_L_(0x46, 0x47)
#define REG_FRC_BK46_47_H      FRC_PK_H_(0x46, 0x47)
#define REG_FRC_BK46_48_L      FRC_PK_L_(0x46, 0x48)
#define REG_FRC_BK46_48_H      FRC_PK_H_(0x46, 0x48)
#define REG_FRC_BK46_49_L      FRC_PK_L_(0x46, 0x49)
#define REG_FRC_BK46_49_H      FRC_PK_H_(0x46, 0x49)
#define REG_FRC_BK46_4A_L      FRC_PK_L_(0x46, 0x4A)
#define REG_FRC_BK46_4A_H      FRC_PK_H_(0x46, 0x4A)
#define REG_FRC_BK46_4B_L      FRC_PK_L_(0x46, 0x4B)
#define REG_FRC_BK46_4B_H      FRC_PK_H_(0x46, 0x4B)
#define REG_FRC_BK46_4C_L      FRC_PK_L_(0x46, 0x4C)
#define REG_FRC_BK46_4C_H      FRC_PK_H_(0x46, 0x4C)
#define REG_FRC_BK46_4D_L      FRC_PK_L_(0x46, 0x4D)
#define REG_FRC_BK46_4D_H      FRC_PK_H_(0x46, 0x4D)
#define REG_FRC_BK46_4E_L      FRC_PK_L_(0x46, 0x4E)
#define REG_FRC_BK46_4E_H      FRC_PK_H_(0x46, 0x4E)
#define REG_FRC_BK46_4F_L      FRC_PK_L_(0x46, 0x4F)
#define REG_FRC_BK46_4F_H      FRC_PK_H_(0x46, 0x4F)
#define REG_FRC_BK46_50_L      FRC_PK_L_(0x46, 0x50)
#define REG_FRC_BK46_50_H      FRC_PK_H_(0x46, 0x50)
#define REG_FRC_BK46_51_L      FRC_PK_L_(0x46, 0x51)
#define REG_FRC_BK46_51_H      FRC_PK_H_(0x46, 0x51)
#define REG_FRC_BK46_52_L      FRC_PK_L_(0x46, 0x52)
#define REG_FRC_BK46_52_H      FRC_PK_H_(0x46, 0x52)
#define REG_FRC_BK46_53_L      FRC_PK_L_(0x46, 0x53)
#define REG_FRC_BK46_53_H      FRC_PK_H_(0x46, 0x53)
#define REG_FRC_BK46_54_L      FRC_PK_L_(0x46, 0x54)
#define REG_FRC_BK46_54_H      FRC_PK_H_(0x46, 0x54)
#define REG_FRC_BK46_55_L      FRC_PK_L_(0x46, 0x55)
#define REG_FRC_BK46_55_H      FRC_PK_H_(0x46, 0x55)
#define REG_FRC_BK46_56_L      FRC_PK_L_(0x46, 0x56)
#define REG_FRC_BK46_56_H      FRC_PK_H_(0x46, 0x56)
#define REG_FRC_BK46_57_L      FRC_PK_L_(0x46, 0x57)
#define REG_FRC_BK46_57_H      FRC_PK_H_(0x46, 0x57)
#define REG_FRC_BK46_58_L      FRC_PK_L_(0x46, 0x58)
#define REG_FRC_BK46_58_H      FRC_PK_H_(0x46, 0x58)
#define REG_FRC_BK46_59_L      FRC_PK_L_(0x46, 0x59)
#define REG_FRC_BK46_59_H      FRC_PK_H_(0x46, 0x59)
#define REG_FRC_BK46_5A_L      FRC_PK_L_(0x46, 0x5A)
#define REG_FRC_BK46_5A_H      FRC_PK_H_(0x46, 0x5A)
#define REG_FRC_BK46_5B_L      FRC_PK_L_(0x46, 0x5B)
#define REG_FRC_BK46_5B_H      FRC_PK_H_(0x46, 0x5B)
#define REG_FRC_BK46_5C_L      FRC_PK_L_(0x46, 0x5C)
#define REG_FRC_BK46_5C_H      FRC_PK_H_(0x46, 0x5C)
#define REG_FRC_BK46_5D_L      FRC_PK_L_(0x46, 0x5D)
#define REG_FRC_BK46_5D_H      FRC_PK_H_(0x46, 0x5D)
#define REG_FRC_BK46_5E_L      FRC_PK_L_(0x46, 0x5E)
#define REG_FRC_BK46_5E_H      FRC_PK_H_(0x46, 0x5E)
#define REG_FRC_BK46_5F_L      FRC_PK_L_(0x46, 0x5F)
#define REG_FRC_BK46_5F_H      FRC_PK_H_(0x46, 0x5F)
#define REG_FRC_BK46_60_L      FRC_PK_L_(0x46, 0x60)
#define REG_FRC_BK46_60_H      FRC_PK_H_(0x46, 0x60)
#define REG_FRC_BK46_61_L      FRC_PK_L_(0x46, 0x61)
#define REG_FRC_BK46_61_H      FRC_PK_H_(0x46, 0x61)
#define REG_FRC_BK46_62_L      FRC_PK_L_(0x46, 0x62)
#define REG_FRC_BK46_62_H      FRC_PK_H_(0x46, 0x62)
#define REG_FRC_BK46_63_L      FRC_PK_L_(0x46, 0x63)
#define REG_FRC_BK46_63_H      FRC_PK_H_(0x46, 0x63)
#define REG_FRC_BK46_64_L      FRC_PK_L_(0x46, 0x64)
#define REG_FRC_BK46_64_H      FRC_PK_H_(0x46, 0x64)
#define REG_FRC_BK46_65_L      FRC_PK_L_(0x46, 0x65)
#define REG_FRC_BK46_65_H      FRC_PK_H_(0x46, 0x65)
#define REG_FRC_BK46_66_L      FRC_PK_L_(0x46, 0x66)
#define REG_FRC_BK46_66_H      FRC_PK_H_(0x46, 0x66)
#define REG_FRC_BK46_67_L      FRC_PK_L_(0x46, 0x67)
#define REG_FRC_BK46_67_H      FRC_PK_H_(0x46, 0x67)
#define REG_FRC_BK46_68_L      FRC_PK_L_(0x46, 0x68)
#define REG_FRC_BK46_68_H      FRC_PK_H_(0x46, 0x68)
#define REG_FRC_BK46_69_L      FRC_PK_L_(0x46, 0x69)
#define REG_FRC_BK46_69_H      FRC_PK_H_(0x46, 0x69)
#define REG_FRC_BK46_6A_L      FRC_PK_L_(0x46, 0x6A)
#define REG_FRC_BK46_6A_H      FRC_PK_H_(0x46, 0x6A)
#define REG_FRC_BK46_6B_L      FRC_PK_L_(0x46, 0x6B)
#define REG_FRC_BK46_6B_H      FRC_PK_H_(0x46, 0x6B)
#define REG_FRC_BK46_6C_L      FRC_PK_L_(0x46, 0x6C)
#define REG_FRC_BK46_6C_H      FRC_PK_H_(0x46, 0x6C)
#define REG_FRC_BK46_6D_L      FRC_PK_L_(0x46, 0x6D)
#define REG_FRC_BK46_6D_H      FRC_PK_H_(0x46, 0x6D)
#define REG_FRC_BK46_6E_L      FRC_PK_L_(0x46, 0x6E)
#define REG_FRC_BK46_6E_H      FRC_PK_H_(0x46, 0x6E)
#define REG_FRC_BK46_6F_L      FRC_PK_L_(0x46, 0x6F)
#define REG_FRC_BK46_6F_H      FRC_PK_H_(0x46, 0x6F)
#define REG_FRC_BK46_70_L      FRC_PK_L_(0x46, 0x70)
#define REG_FRC_BK46_70_H      FRC_PK_H_(0x46, 0x70)
#define REG_FRC_BK46_71_L      FRC_PK_L_(0x46, 0x71)
#define REG_FRC_BK46_71_H      FRC_PK_H_(0x46, 0x71)
#define REG_FRC_BK46_72_L      FRC_PK_L_(0x46, 0x72)
#define REG_FRC_BK46_72_H      FRC_PK_H_(0x46, 0x72)
#define REG_FRC_BK46_73_L      FRC_PK_L_(0x46, 0x73)
#define REG_FRC_BK46_73_H      FRC_PK_H_(0x46, 0x73)
#define REG_FRC_BK46_74_L      FRC_PK_L_(0x46, 0x74)
#define REG_FRC_BK46_74_H      FRC_PK_H_(0x46, 0x74)
#define REG_FRC_BK46_75_L      FRC_PK_L_(0x46, 0x75)
#define REG_FRC_BK46_75_H      FRC_PK_H_(0x46, 0x75)
#define REG_FRC_BK46_76_L      FRC_PK_L_(0x46, 0x76)
#define REG_FRC_BK46_76_H      FRC_PK_H_(0x46, 0x76)
#define REG_FRC_BK46_77_L      FRC_PK_L_(0x46, 0x77)
#define REG_FRC_BK46_77_H      FRC_PK_H_(0x46, 0x77)
#define REG_FRC_BK46_78_L      FRC_PK_L_(0x46, 0x78)
#define REG_FRC_BK46_78_H      FRC_PK_H_(0x46, 0x78)
#define REG_FRC_BK46_79_L      FRC_PK_L_(0x46, 0x79)
#define REG_FRC_BK46_79_H      FRC_PK_H_(0x46, 0x79)
#define REG_FRC_BK46_7A_L      FRC_PK_L_(0x46, 0x7A)
#define REG_FRC_BK46_7A_H      FRC_PK_H_(0x46, 0x7A)
#define REG_FRC_BK46_7B_L      FRC_PK_L_(0x46, 0x7B)
#define REG_FRC_BK46_7B_H      FRC_PK_H_(0x46, 0x7B)
#define REG_FRC_BK46_7C_L      FRC_PK_L_(0x46, 0x7C)
#define REG_FRC_BK46_7C_H      FRC_PK_H_(0x46, 0x7C)
#define REG_FRC_BK46_7D_L      FRC_PK_L_(0x46, 0x7D)
#define REG_FRC_BK46_7D_H      FRC_PK_H_(0x46, 0x7D)
#define REG_FRC_BK46_7E_L      FRC_PK_L_(0x46, 0x7E)
#define REG_FRC_BK46_7E_H      FRC_PK_H_(0x46, 0x7E)
#define REG_FRC_BK46_7F_L      FRC_PK_L_(0x46, 0x7F)
#define REG_FRC_BK46_7F_H      FRC_PK_H_(0x46, 0x7F)

//----------------------------------------------
//  BK47
//----------------------------------------------
#define REG_FRC_BK47_00_L      FRC_PK_L_(0x47, 0x00)
#define REG_FRC_BK47_00_H      FRC_PK_H_(0x47, 0x00)
#define REG_FRC_BK47_01_L      FRC_PK_L_(0x47, 0x01)
#define REG_FRC_BK47_01_H      FRC_PK_H_(0x47, 0x01)
#define REG_FRC_BK47_02_L      FRC_PK_L_(0x47, 0x02)
#define REG_FRC_BK47_02_H      FRC_PK_H_(0x47, 0x02)
#define REG_FRC_BK47_03_L      FRC_PK_L_(0x47, 0x03)
#define REG_FRC_BK47_03_H      FRC_PK_H_(0x47, 0x03)
#define REG_FRC_BK47_04_L      FRC_PK_L_(0x47, 0x04)
#define REG_FRC_BK47_04_H      FRC_PK_H_(0x47, 0x04)
#define REG_FRC_BK47_05_L      FRC_PK_L_(0x47, 0x05)
#define REG_FRC_BK47_05_H      FRC_PK_H_(0x47, 0x05)
#define REG_FRC_BK47_06_L      FRC_PK_L_(0x47, 0x06)
#define REG_FRC_BK47_06_H      FRC_PK_H_(0x47, 0x06)
#define REG_FRC_BK47_07_L      FRC_PK_L_(0x47, 0x07)
#define REG_FRC_BK47_07_H      FRC_PK_H_(0x47, 0x07)
#define REG_FRC_BK47_08_L      FRC_PK_L_(0x47, 0x08)
#define REG_FRC_BK47_08_H      FRC_PK_H_(0x47, 0x08)
#define REG_FRC_BK47_09_L      FRC_PK_L_(0x47, 0x09)
#define REG_FRC_BK47_09_H      FRC_PK_H_(0x47, 0x09)
#define REG_FRC_BK47_0A_L      FRC_PK_L_(0x47, 0x0A)
#define REG_FRC_BK47_0A_H      FRC_PK_H_(0x47, 0x0A)
#define REG_FRC_BK47_0B_L      FRC_PK_L_(0x47, 0x0B)
#define REG_FRC_BK47_0B_H      FRC_PK_H_(0x47, 0x0B)
#define REG_FRC_BK47_0C_L      FRC_PK_L_(0x47, 0x0C)
#define REG_FRC_BK47_0C_H      FRC_PK_H_(0x47, 0x0C)
#define REG_FRC_BK47_0D_L      FRC_PK_L_(0x47, 0x0D)
#define REG_FRC_BK47_0D_H      FRC_PK_H_(0x47, 0x0D)
#define REG_FRC_BK47_0E_L      FRC_PK_L_(0x47, 0x0E)
#define REG_FRC_BK47_0E_H      FRC_PK_H_(0x47, 0x0E)
#define REG_FRC_BK47_0F_L      FRC_PK_L_(0x47, 0x0F)
#define REG_FRC_BK47_0F_H      FRC_PK_H_(0x47, 0x0F)
#define REG_FRC_BK47_10_L      FRC_PK_L_(0x47, 0x10)
#define REG_FRC_BK47_10_H      FRC_PK_H_(0x47, 0x10)
#define REG_FRC_BK47_11_L      FRC_PK_L_(0x47, 0x11)
#define REG_FRC_BK47_11_H      FRC_PK_H_(0x47, 0x11)
#define REG_FRC_BK47_12_L      FRC_PK_L_(0x47, 0x12)
#define REG_FRC_BK47_12_H      FRC_PK_H_(0x47, 0x12)
#define REG_FRC_BK47_13_L      FRC_PK_L_(0x47, 0x13)
#define REG_FRC_BK47_13_H      FRC_PK_H_(0x47, 0x13)
#define REG_FRC_BK47_14_L      FRC_PK_L_(0x47, 0x14)
#define REG_FRC_BK47_14_H      FRC_PK_H_(0x47, 0x14)
#define REG_FRC_BK47_15_L      FRC_PK_L_(0x47, 0x15)
#define REG_FRC_BK47_15_H      FRC_PK_H_(0x47, 0x15)
#define REG_FRC_BK47_16_L      FRC_PK_L_(0x47, 0x16)
#define REG_FRC_BK47_16_H      FRC_PK_H_(0x47, 0x16)
#define REG_FRC_BK47_17_L      FRC_PK_L_(0x47, 0x17)
#define REG_FRC_BK47_17_H      FRC_PK_H_(0x47, 0x17)
#define REG_FRC_BK47_18_L      FRC_PK_L_(0x47, 0x18)
#define REG_FRC_BK47_18_H      FRC_PK_H_(0x47, 0x18)
#define REG_FRC_BK47_19_L      FRC_PK_L_(0x47, 0x19)
#define REG_FRC_BK47_19_H      FRC_PK_H_(0x47, 0x19)
#define REG_FRC_BK47_1A_L      FRC_PK_L_(0x47, 0x1A)
#define REG_FRC_BK47_1A_H      FRC_PK_H_(0x47, 0x1A)
#define REG_FRC_BK47_1B_L      FRC_PK_L_(0x47, 0x1B)
#define REG_FRC_BK47_1B_H      FRC_PK_H_(0x47, 0x1B)
#define REG_FRC_BK47_1C_L      FRC_PK_L_(0x47, 0x1C)
#define REG_FRC_BK47_1C_H      FRC_PK_H_(0x47, 0x1C)
#define REG_FRC_BK47_1D_L      FRC_PK_L_(0x47, 0x1D)
#define REG_FRC_BK47_1D_H      FRC_PK_H_(0x47, 0x1D)
#define REG_FRC_BK47_1E_L      FRC_PK_L_(0x47, 0x1E)
#define REG_FRC_BK47_1E_H      FRC_PK_H_(0x47, 0x1E)
#define REG_FRC_BK47_1F_L      FRC_PK_L_(0x47, 0x1F)
#define REG_FRC_BK47_1F_H      FRC_PK_H_(0x47, 0x1F)
#define REG_FRC_BK47_20_L      FRC_PK_L_(0x47, 0x20)
#define REG_FRC_BK47_20_H      FRC_PK_H_(0x47, 0x20)
#define REG_FRC_BK47_21_L      FRC_PK_L_(0x47, 0x21)
#define REG_FRC_BK47_21_H      FRC_PK_H_(0x47, 0x21)
#define REG_FRC_BK47_22_L      FRC_PK_L_(0x47, 0x22)
#define REG_FRC_BK47_22_H      FRC_PK_H_(0x47, 0x22)
#define REG_FRC_BK47_23_L      FRC_PK_L_(0x47, 0x23)
#define REG_FRC_BK47_23_H      FRC_PK_H_(0x47, 0x23)
#define REG_FRC_BK47_24_L      FRC_PK_L_(0x47, 0x24)
#define REG_FRC_BK47_24_H      FRC_PK_H_(0x47, 0x24)
#define REG_FRC_BK47_25_L      FRC_PK_L_(0x47, 0x25)
#define REG_FRC_BK47_25_H      FRC_PK_H_(0x47, 0x25)
#define REG_FRC_BK47_26_L      FRC_PK_L_(0x47, 0x26)
#define REG_FRC_BK47_26_H      FRC_PK_H_(0x47, 0x26)
#define REG_FRC_BK47_27_L      FRC_PK_L_(0x47, 0x27)
#define REG_FRC_BK47_27_H      FRC_PK_H_(0x47, 0x27)
#define REG_FRC_BK47_28_L      FRC_PK_L_(0x47, 0x28)
#define REG_FRC_BK47_28_H      FRC_PK_H_(0x47, 0x28)
#define REG_FRC_BK47_29_L      FRC_PK_L_(0x47, 0x29)
#define REG_FRC_BK47_29_H      FRC_PK_H_(0x47, 0x29)
#define REG_FRC_BK47_2A_L      FRC_PK_L_(0x47, 0x2A)
#define REG_FRC_BK47_2A_H      FRC_PK_H_(0x47, 0x2A)
#define REG_FRC_BK47_2B_L      FRC_PK_L_(0x47, 0x2B)
#define REG_FRC_BK47_2B_H      FRC_PK_H_(0x47, 0x2B)
#define REG_FRC_BK47_2C_L      FRC_PK_L_(0x47, 0x2C)
#define REG_FRC_BK47_2C_H      FRC_PK_H_(0x47, 0x2C)
#define REG_FRC_BK47_2D_L      FRC_PK_L_(0x47, 0x2D)
#define REG_FRC_BK47_2D_H      FRC_PK_H_(0x47, 0x2D)
#define REG_FRC_BK47_2E_L      FRC_PK_L_(0x47, 0x2E)
#define REG_FRC_BK47_2E_H      FRC_PK_H_(0x47, 0x2E)
#define REG_FRC_BK47_2F_L      FRC_PK_L_(0x47, 0x2F)
#define REG_FRC_BK47_2F_H      FRC_PK_H_(0x47, 0x2F)
#define REG_FRC_BK47_30_L      FRC_PK_L_(0x47, 0x30)
#define REG_FRC_BK47_30_H      FRC_PK_H_(0x47, 0x30)
#define REG_FRC_BK47_31_L      FRC_PK_L_(0x47, 0x31)
#define REG_FRC_BK47_31_H      FRC_PK_H_(0x47, 0x31)
#define REG_FRC_BK47_32_L      FRC_PK_L_(0x47, 0x32)
#define REG_FRC_BK47_32_H      FRC_PK_H_(0x47, 0x32)
#define REG_FRC_BK47_33_L      FRC_PK_L_(0x47, 0x33)
#define REG_FRC_BK47_33_H      FRC_PK_H_(0x47, 0x33)
#define REG_FRC_BK47_34_L      FRC_PK_L_(0x47, 0x34)
#define REG_FRC_BK47_34_H      FRC_PK_H_(0x47, 0x34)
#define REG_FRC_BK47_35_L      FRC_PK_L_(0x47, 0x35)
#define REG_FRC_BK47_35_H      FRC_PK_H_(0x47, 0x35)
#define REG_FRC_BK47_36_L      FRC_PK_L_(0x47, 0x36)
#define REG_FRC_BK47_36_H      FRC_PK_H_(0x47, 0x36)
#define REG_FRC_BK47_37_L      FRC_PK_L_(0x47, 0x37)
#define REG_FRC_BK47_37_H      FRC_PK_H_(0x47, 0x37)
#define REG_FRC_BK47_38_L      FRC_PK_L_(0x47, 0x38)
#define REG_FRC_BK47_38_H      FRC_PK_H_(0x47, 0x38)
#define REG_FRC_BK47_39_L      FRC_PK_L_(0x47, 0x39)
#define REG_FRC_BK47_39_H      FRC_PK_H_(0x47, 0x39)
#define REG_FRC_BK47_3A_L      FRC_PK_L_(0x47, 0x3A)
#define REG_FRC_BK47_3A_H      FRC_PK_H_(0x47, 0x3A)
#define REG_FRC_BK47_3B_L      FRC_PK_L_(0x47, 0x3B)
#define REG_FRC_BK47_3B_H      FRC_PK_H_(0x47, 0x3B)
#define REG_FRC_BK47_3C_L      FRC_PK_L_(0x47, 0x3C)
#define REG_FRC_BK47_3C_H      FRC_PK_H_(0x47, 0x3C)
#define REG_FRC_BK47_3D_L      FRC_PK_L_(0x47, 0x3D)
#define REG_FRC_BK47_3D_H      FRC_PK_H_(0x47, 0x3D)
#define REG_FRC_BK47_3E_L      FRC_PK_L_(0x47, 0x3E)
#define REG_FRC_BK47_3E_H      FRC_PK_H_(0x47, 0x3E)
#define REG_FRC_BK47_3F_L      FRC_PK_L_(0x47, 0x3F)
#define REG_FRC_BK47_3F_H      FRC_PK_H_(0x47, 0x3F)
#define REG_FRC_BK47_40_L      FRC_PK_L_(0x47, 0x40)
#define REG_FRC_BK47_40_H      FRC_PK_H_(0x47, 0x40)
#define REG_FRC_BK47_41_L      FRC_PK_L_(0x47, 0x41)
#define REG_FRC_BK47_41_H      FRC_PK_H_(0x47, 0x41)
#define REG_FRC_BK47_42_L      FRC_PK_L_(0x47, 0x42)
#define REG_FRC_BK47_42_H      FRC_PK_H_(0x47, 0x42)
#define REG_FRC_BK47_43_L      FRC_PK_L_(0x47, 0x43)
#define REG_FRC_BK47_43_H      FRC_PK_H_(0x47, 0x43)
#define REG_FRC_BK47_44_L      FRC_PK_L_(0x47, 0x44)
#define REG_FRC_BK47_44_H      FRC_PK_H_(0x47, 0x44)
#define REG_FRC_BK47_45_L      FRC_PK_L_(0x47, 0x45)
#define REG_FRC_BK47_45_H      FRC_PK_H_(0x47, 0x45)
#define REG_FRC_BK47_46_L      FRC_PK_L_(0x47, 0x46)
#define REG_FRC_BK47_46_H      FRC_PK_H_(0x47, 0x46)
#define REG_FRC_BK47_47_L      FRC_PK_L_(0x47, 0x47)
#define REG_FRC_BK47_47_H      FRC_PK_H_(0x47, 0x47)
#define REG_FRC_BK47_48_L      FRC_PK_L_(0x47, 0x48)
#define REG_FRC_BK47_48_H      FRC_PK_H_(0x47, 0x48)
#define REG_FRC_BK47_49_L      FRC_PK_L_(0x47, 0x49)
#define REG_FRC_BK47_49_H      FRC_PK_H_(0x47, 0x49)
#define REG_FRC_BK47_4A_L      FRC_PK_L_(0x47, 0x4A)
#define REG_FRC_BK47_4A_H      FRC_PK_H_(0x47, 0x4A)
#define REG_FRC_BK47_4B_L      FRC_PK_L_(0x47, 0x4B)
#define REG_FRC_BK47_4B_H      FRC_PK_H_(0x47, 0x4B)
#define REG_FRC_BK47_4C_L      FRC_PK_L_(0x47, 0x4C)
#define REG_FRC_BK47_4C_H      FRC_PK_H_(0x47, 0x4C)
#define REG_FRC_BK47_4D_L      FRC_PK_L_(0x47, 0x4D)
#define REG_FRC_BK47_4D_H      FRC_PK_H_(0x47, 0x4D)
#define REG_FRC_BK47_4E_L      FRC_PK_L_(0x47, 0x4E)
#define REG_FRC_BK47_4E_H      FRC_PK_H_(0x47, 0x4E)
#define REG_FRC_BK47_4F_L      FRC_PK_L_(0x47, 0x4F)
#define REG_FRC_BK47_4F_H      FRC_PK_H_(0x47, 0x4F)
#define REG_FRC_BK47_50_L      FRC_PK_L_(0x47, 0x50)
#define REG_FRC_BK47_50_H      FRC_PK_H_(0x47, 0x50)
#define REG_FRC_BK47_51_L      FRC_PK_L_(0x47, 0x51)
#define REG_FRC_BK47_51_H      FRC_PK_H_(0x47, 0x51)
#define REG_FRC_BK47_52_L      FRC_PK_L_(0x47, 0x52)
#define REG_FRC_BK47_52_H      FRC_PK_H_(0x47, 0x52)
#define REG_FRC_BK47_53_L      FRC_PK_L_(0x47, 0x53)
#define REG_FRC_BK47_53_H      FRC_PK_H_(0x47, 0x53)
#define REG_FRC_BK47_54_L      FRC_PK_L_(0x47, 0x54)
#define REG_FRC_BK47_54_H      FRC_PK_H_(0x47, 0x54)
#define REG_FRC_BK47_55_L      FRC_PK_L_(0x47, 0x55)
#define REG_FRC_BK47_55_H      FRC_PK_H_(0x47, 0x55)
#define REG_FRC_BK47_56_L      FRC_PK_L_(0x47, 0x56)
#define REG_FRC_BK47_56_H      FRC_PK_H_(0x47, 0x56)
#define REG_FRC_BK47_57_L      FRC_PK_L_(0x47, 0x57)
#define REG_FRC_BK47_57_H      FRC_PK_H_(0x47, 0x57)
#define REG_FRC_BK47_58_L      FRC_PK_L_(0x47, 0x58)
#define REG_FRC_BK47_58_H      FRC_PK_H_(0x47, 0x58)
#define REG_FRC_BK47_59_L      FRC_PK_L_(0x47, 0x59)
#define REG_FRC_BK47_59_H      FRC_PK_H_(0x47, 0x59)
#define REG_FRC_BK47_5A_L      FRC_PK_L_(0x47, 0x5A)
#define REG_FRC_BK47_5A_H      FRC_PK_H_(0x47, 0x5A)
#define REG_FRC_BK47_5B_L      FRC_PK_L_(0x47, 0x5B)
#define REG_FRC_BK47_5B_H      FRC_PK_H_(0x47, 0x5B)
#define REG_FRC_BK47_5C_L      FRC_PK_L_(0x47, 0x5C)
#define REG_FRC_BK47_5C_H      FRC_PK_H_(0x47, 0x5C)
#define REG_FRC_BK47_5D_L      FRC_PK_L_(0x47, 0x5D)
#define REG_FRC_BK47_5D_H      FRC_PK_H_(0x47, 0x5D)
#define REG_FRC_BK47_5E_L      FRC_PK_L_(0x47, 0x5E)
#define REG_FRC_BK47_5E_H      FRC_PK_H_(0x47, 0x5E)
#define REG_FRC_BK47_5F_L      FRC_PK_L_(0x47, 0x5F)
#define REG_FRC_BK47_5F_H      FRC_PK_H_(0x47, 0x5F)
#define REG_FRC_BK47_60_L      FRC_PK_L_(0x47, 0x60)
#define REG_FRC_BK47_60_H      FRC_PK_H_(0x47, 0x60)
#define REG_FRC_BK47_61_L      FRC_PK_L_(0x47, 0x61)
#define REG_FRC_BK47_61_H      FRC_PK_H_(0x47, 0x61)
#define REG_FRC_BK47_62_L      FRC_PK_L_(0x47, 0x62)
#define REG_FRC_BK47_62_H      FRC_PK_H_(0x47, 0x62)
#define REG_FRC_BK47_63_L      FRC_PK_L_(0x47, 0x63)
#define REG_FRC_BK47_63_H      FRC_PK_H_(0x47, 0x63)
#define REG_FRC_BK47_64_L      FRC_PK_L_(0x47, 0x64)
#define REG_FRC_BK47_64_H      FRC_PK_H_(0x47, 0x64)
#define REG_FRC_BK47_65_L      FRC_PK_L_(0x47, 0x65)
#define REG_FRC_BK47_65_H      FRC_PK_H_(0x47, 0x65)
#define REG_FRC_BK47_66_L      FRC_PK_L_(0x47, 0x66)
#define REG_FRC_BK47_66_H      FRC_PK_H_(0x47, 0x66)
#define REG_FRC_BK47_67_L      FRC_PK_L_(0x47, 0x67)
#define REG_FRC_BK47_67_H      FRC_PK_H_(0x47, 0x67)
#define REG_FRC_BK47_68_L      FRC_PK_L_(0x47, 0x68)
#define REG_FRC_BK47_68_H      FRC_PK_H_(0x47, 0x68)
#define REG_FRC_BK47_69_L      FRC_PK_L_(0x47, 0x69)
#define REG_FRC_BK47_69_H      FRC_PK_H_(0x47, 0x69)
#define REG_FRC_BK47_6A_L      FRC_PK_L_(0x47, 0x6A)
#define REG_FRC_BK47_6A_H      FRC_PK_H_(0x47, 0x6A)
#define REG_FRC_BK47_6B_L      FRC_PK_L_(0x47, 0x6B)
#define REG_FRC_BK47_6B_H      FRC_PK_H_(0x47, 0x6B)
#define REG_FRC_BK47_6C_L      FRC_PK_L_(0x47, 0x6C)
#define REG_FRC_BK47_6C_H      FRC_PK_H_(0x47, 0x6C)
#define REG_FRC_BK47_6D_L      FRC_PK_L_(0x47, 0x6D)
#define REG_FRC_BK47_6D_H      FRC_PK_H_(0x47, 0x6D)
#define REG_FRC_BK47_6E_L      FRC_PK_L_(0x47, 0x6E)
#define REG_FRC_BK47_6E_H      FRC_PK_H_(0x47, 0x6E)
#define REG_FRC_BK47_6F_L      FRC_PK_L_(0x47, 0x6F)
#define REG_FRC_BK47_6F_H      FRC_PK_H_(0x47, 0x6F)
#define REG_FRC_BK47_70_L      FRC_PK_L_(0x47, 0x70)
#define REG_FRC_BK47_70_H      FRC_PK_H_(0x47, 0x70)
#define REG_FRC_BK47_71_L      FRC_PK_L_(0x47, 0x71)
#define REG_FRC_BK47_71_H      FRC_PK_H_(0x47, 0x71)
#define REG_FRC_BK47_72_L      FRC_PK_L_(0x47, 0x72)
#define REG_FRC_BK47_72_H      FRC_PK_H_(0x47, 0x72)
#define REG_FRC_BK47_73_L      FRC_PK_L_(0x47, 0x73)
#define REG_FRC_BK47_73_H      FRC_PK_H_(0x47, 0x73)
#define REG_FRC_BK47_74_L      FRC_PK_L_(0x47, 0x74)
#define REG_FRC_BK47_74_H      FRC_PK_H_(0x47, 0x74)
#define REG_FRC_BK47_75_L      FRC_PK_L_(0x47, 0x75)
#define REG_FRC_BK47_75_H      FRC_PK_H_(0x47, 0x75)
#define REG_FRC_BK47_76_L      FRC_PK_L_(0x47, 0x76)
#define REG_FRC_BK47_76_H      FRC_PK_H_(0x47, 0x76)
#define REG_FRC_BK47_77_L      FRC_PK_L_(0x47, 0x77)
#define REG_FRC_BK47_77_H      FRC_PK_H_(0x47, 0x77)
#define REG_FRC_BK47_78_L      FRC_PK_L_(0x47, 0x78)
#define REG_FRC_BK47_78_H      FRC_PK_H_(0x47, 0x78)
#define REG_FRC_BK47_79_L      FRC_PK_L_(0x47, 0x79)
#define REG_FRC_BK47_79_H      FRC_PK_H_(0x47, 0x79)
#define REG_FRC_BK47_7A_L      FRC_PK_L_(0x47, 0x7A)
#define REG_FRC_BK47_7A_H      FRC_PK_H_(0x47, 0x7A)
#define REG_FRC_BK47_7B_L      FRC_PK_L_(0x47, 0x7B)
#define REG_FRC_BK47_7B_H      FRC_PK_H_(0x47, 0x7B)
#define REG_FRC_BK47_7C_L      FRC_PK_L_(0x47, 0x7C)
#define REG_FRC_BK47_7C_H      FRC_PK_H_(0x47, 0x7C)
#define REG_FRC_BK47_7D_L      FRC_PK_L_(0x47, 0x7D)
#define REG_FRC_BK47_7D_H      FRC_PK_H_(0x47, 0x7D)
#define REG_FRC_BK47_7E_L      FRC_PK_L_(0x47, 0x7E)
#define REG_FRC_BK47_7E_H      FRC_PK_H_(0x47, 0x7E)
#define REG_FRC_BK47_7F_L      FRC_PK_L_(0x47, 0x7F)
#define REG_FRC_BK47_7F_H      FRC_PK_H_(0x47, 0x7F)

//----------------------------------------------
//  BK10A -> BK20A
//----------------------------------------------
#define REG_FRC_BK20A_00_L      FRC_PK_L_(0x20A, 0x00)
#define REG_FRC_BK20A_00_H      FRC_PK_H_(0x20A, 0x00)
#define REG_FRC_BK20A_01_L      FRC_PK_L_(0x20A, 0x01)
#define REG_FRC_BK20A_01_H      FRC_PK_H_(0x20A, 0x01)
#define REG_FRC_BK20A_02_L      FRC_PK_L_(0x20A, 0x02)
#define REG_FRC_BK20A_02_H      FRC_PK_H_(0x20A, 0x02)
#define REG_FRC_BK20A_03_L      FRC_PK_L_(0x20A, 0x03)
#define REG_FRC_BK20A_03_H      FRC_PK_H_(0x20A, 0x03)
#define REG_FRC_BK20A_04_L      FRC_PK_L_(0x20A, 0x04)
#define REG_FRC_BK20A_04_H      FRC_PK_H_(0x20A, 0x04)
#define REG_FRC_BK20A_05_L      FRC_PK_L_(0x20A, 0x05)
#define REG_FRC_BK20A_05_H      FRC_PK_H_(0x20A, 0x05)
#define REG_FRC_BK20A_06_L      FRC_PK_L_(0x20A, 0x06)
#define REG_FRC_BK20A_06_H      FRC_PK_H_(0x20A, 0x06)
#define REG_FRC_BK20A_07_L      FRC_PK_L_(0x20A, 0x07)
#define REG_FRC_BK20A_07_H      FRC_PK_H_(0x20A, 0x07)
#define REG_FRC_BK20A_08_L      FRC_PK_L_(0x20A, 0x08)
#define REG_FRC_BK20A_08_H      FRC_PK_H_(0x20A, 0x08)
#define REG_FRC_BK20A_09_L      FRC_PK_L_(0x20A, 0x09)
#define REG_FRC_BK20A_09_H      FRC_PK_H_(0x20A, 0x09)
#define REG_FRC_BK20A_0A_L      FRC_PK_L_(0x20A, 0x0A)
#define REG_FRC_BK20A_0A_H      FRC_PK_H_(0x20A, 0x0A)
#define REG_FRC_BK20A_0B_L      FRC_PK_L_(0x20A, 0x0B)
#define REG_FRC_BK20A_0B_H      FRC_PK_H_(0x20A, 0x0B)
#define REG_FRC_BK20A_0C_L      FRC_PK_L_(0x20A, 0x0C)
#define REG_FRC_BK20A_0C_H      FRC_PK_H_(0x20A, 0x0C)
#define REG_FRC_BK20A_0D_L      FRC_PK_L_(0x20A, 0x0D)
#define REG_FRC_BK20A_0D_H      FRC_PK_H_(0x20A, 0x0D)
#define REG_FRC_BK20A_0E_L      FRC_PK_L_(0x20A, 0x0E)
#define REG_FRC_BK20A_0E_H      FRC_PK_H_(0x20A, 0x0E)
#define REG_FRC_BK20A_0F_L      FRC_PK_L_(0x20A, 0x0F)
#define REG_FRC_BK20A_0F_H      FRC_PK_H_(0x20A, 0x0F)
#define REG_FRC_BK20A_10_L      FRC_PK_L_(0x20A, 0x10)
#define REG_FRC_BK20A_10_H      FRC_PK_H_(0x20A, 0x10)
#define REG_FRC_BK20A_11_L      FRC_PK_L_(0x20A, 0x11)
#define REG_FRC_BK20A_11_H      FRC_PK_H_(0x20A, 0x11)
#define REG_FRC_BK20A_12_L      FRC_PK_L_(0x20A, 0x12)
#define REG_FRC_BK20A_12_H      FRC_PK_H_(0x20A, 0x12)
#define REG_FRC_BK20A_13_L      FRC_PK_L_(0x20A, 0x13)
#define REG_FRC_BK20A_13_H      FRC_PK_H_(0x20A, 0x13)
#define REG_FRC_BK20A_14_L      FRC_PK_L_(0x20A, 0x14)
#define REG_FRC_BK20A_14_H      FRC_PK_H_(0x20A, 0x14)
#define REG_FRC_BK20A_15_L      FRC_PK_L_(0x20A, 0x15)
#define REG_FRC_BK20A_15_H      FRC_PK_H_(0x20A, 0x15)
#define REG_FRC_BK20A_16_L      FRC_PK_L_(0x20A, 0x16)
#define REG_FRC_BK20A_16_H      FRC_PK_H_(0x20A, 0x16)
#define REG_FRC_BK20A_17_L      FRC_PK_L_(0x20A, 0x17)
#define REG_FRC_BK20A_17_H      FRC_PK_H_(0x20A, 0x17)
#define REG_FRC_BK20A_18_L      FRC_PK_L_(0x20A, 0x18)
#define REG_FRC_BK20A_18_H      FRC_PK_H_(0x20A, 0x18)
#define REG_FRC_BK20A_19_L      FRC_PK_L_(0x20A, 0x19)
#define REG_FRC_BK20A_19_H      FRC_PK_H_(0x20A, 0x19)
#define REG_FRC_BK20A_1A_L      FRC_PK_L_(0x20A, 0x1A)
#define REG_FRC_BK20A_1A_H      FRC_PK_H_(0x20A, 0x1A)
#define REG_FRC_BK20A_1B_L      FRC_PK_L_(0x20A, 0x1B)
#define REG_FRC_BK20A_1B_H      FRC_PK_H_(0x20A, 0x1B)
#define REG_FRC_BK20A_1C_L      FRC_PK_L_(0x20A, 0x1C)
#define REG_FRC_BK20A_1C_H      FRC_PK_H_(0x20A, 0x1C)
#define REG_FRC_BK20A_1D_L      FRC_PK_L_(0x20A, 0x1D)
#define REG_FRC_BK20A_1D_H      FRC_PK_H_(0x20A, 0x1D)
#define REG_FRC_BK20A_1E_L      FRC_PK_L_(0x20A, 0x1E)
#define REG_FRC_BK20A_1E_H      FRC_PK_H_(0x20A, 0x1E)
#define REG_FRC_BK20A_1F_L      FRC_PK_L_(0x20A, 0x1F)
#define REG_FRC_BK20A_1F_H      FRC_PK_H_(0x20A, 0x1F)
#define REG_FRC_BK20A_20_L      FRC_PK_L_(0x20A, 0x20)
#define REG_FRC_BK20A_20_H      FRC_PK_H_(0x20A, 0x20)
#define REG_FRC_BK20A_21_L      FRC_PK_L_(0x20A, 0x21)
#define REG_FRC_BK20A_21_H      FRC_PK_H_(0x20A, 0x21)
#define REG_FRC_BK20A_22_L      FRC_PK_L_(0x20A, 0x22)
#define REG_FRC_BK20A_22_H      FRC_PK_H_(0x20A, 0x22)
#define REG_FRC_BK20A_23_L      FRC_PK_L_(0x20A, 0x23)
#define REG_FRC_BK20A_23_H      FRC_PK_H_(0x20A, 0x23)
#define REG_FRC_BK20A_24_L      FRC_PK_L_(0x20A, 0x24)
#define REG_FRC_BK20A_24_H      FRC_PK_H_(0x20A, 0x24)
#define REG_FRC_BK20A_25_L      FRC_PK_L_(0x20A, 0x25)
#define REG_FRC_BK20A_25_H      FRC_PK_H_(0x20A, 0x25)
#define REG_FRC_BK20A_26_L      FRC_PK_L_(0x20A, 0x26)
#define REG_FRC_BK20A_26_H      FRC_PK_H_(0x20A, 0x26)
#define REG_FRC_BK20A_27_L      FRC_PK_L_(0x20A, 0x27)
#define REG_FRC_BK20A_27_H      FRC_PK_H_(0x20A, 0x27)
#define REG_FRC_BK20A_28_L      FRC_PK_L_(0x20A, 0x28)
#define REG_FRC_BK20A_28_H      FRC_PK_H_(0x20A, 0x28)
#define REG_FRC_BK20A_29_L      FRC_PK_L_(0x20A, 0x29)
#define REG_FRC_BK20A_29_H      FRC_PK_H_(0x20A, 0x29)
#define REG_FRC_BK20A_2A_L      FRC_PK_L_(0x20A, 0x2A)
#define REG_FRC_BK20A_2A_H      FRC_PK_H_(0x20A, 0x2A)
#define REG_FRC_BK20A_2B_L      FRC_PK_L_(0x20A, 0x2B)
#define REG_FRC_BK20A_2B_H      FRC_PK_H_(0x20A, 0x2B)
#define REG_FRC_BK20A_2C_L      FRC_PK_L_(0x20A, 0x2C)
#define REG_FRC_BK20A_2C_H      FRC_PK_H_(0x20A, 0x2C)
#define REG_FRC_BK20A_2D_L      FRC_PK_L_(0x20A, 0x2D)
#define REG_FRC_BK20A_2D_H      FRC_PK_H_(0x20A, 0x2D)
#define REG_FRC_BK20A_2E_L      FRC_PK_L_(0x20A, 0x2E)
#define REG_FRC_BK20A_2E_H      FRC_PK_H_(0x20A, 0x2E)
#define REG_FRC_BK20A_2F_L      FRC_PK_L_(0x20A, 0x2F)
#define REG_FRC_BK20A_2F_H      FRC_PK_H_(0x20A, 0x2F)
#define REG_FRC_BK20A_30_L      FRC_PK_L_(0x20A, 0x30)
#define REG_FRC_BK20A_30_H      FRC_PK_H_(0x20A, 0x30)
#define REG_FRC_BK20A_31_L      FRC_PK_L_(0x20A, 0x31)
#define REG_FRC_BK20A_31_H      FRC_PK_H_(0x20A, 0x31)
#define REG_FRC_BK20A_32_L      FRC_PK_L_(0x20A, 0x32)
#define REG_FRC_BK20A_32_H      FRC_PK_H_(0x20A, 0x32)
#define REG_FRC_BK20A_33_L      FRC_PK_L_(0x20A, 0x33)
#define REG_FRC_BK20A_33_H      FRC_PK_H_(0x20A, 0x33)
#define REG_FRC_BK20A_34_L      FRC_PK_L_(0x20A, 0x34)
#define REG_FRC_BK20A_34_H      FRC_PK_H_(0x20A, 0x34)
#define REG_FRC_BK20A_35_L      FRC_PK_L_(0x20A, 0x35)
#define REG_FRC_BK20A_35_H      FRC_PK_H_(0x20A, 0x35)
#define REG_FRC_BK20A_36_L      FRC_PK_L_(0x20A, 0x36)
#define REG_FRC_BK20A_36_H      FRC_PK_H_(0x20A, 0x36)
#define REG_FRC_BK20A_37_L      FRC_PK_L_(0x20A, 0x37)
#define REG_FRC_BK20A_37_H      FRC_PK_H_(0x20A, 0x37)
#define REG_FRC_BK20A_38_L      FRC_PK_L_(0x20A, 0x38)
#define REG_FRC_BK20A_38_H      FRC_PK_H_(0x20A, 0x38)
#define REG_FRC_BK20A_39_L      FRC_PK_L_(0x20A, 0x39)
#define REG_FRC_BK20A_39_H      FRC_PK_H_(0x20A, 0x39)
#define REG_FRC_BK20A_3A_L      FRC_PK_L_(0x20A, 0x3A)
#define REG_FRC_BK20A_3A_H      FRC_PK_H_(0x20A, 0x3A)
#define REG_FRC_BK20A_3B_L      FRC_PK_L_(0x20A, 0x3B)
#define REG_FRC_BK20A_3B_H      FRC_PK_H_(0x20A, 0x3B)
#define REG_FRC_BK20A_3C_L      FRC_PK_L_(0x20A, 0x3C)
#define REG_FRC_BK20A_3C_H      FRC_PK_H_(0x20A, 0x3C)
#define REG_FRC_BK20A_3D_L      FRC_PK_L_(0x20A, 0x3D)
#define REG_FRC_BK20A_3D_H      FRC_PK_H_(0x20A, 0x3D)
#define REG_FRC_BK20A_3E_L      FRC_PK_L_(0x20A, 0x3E)
#define REG_FRC_BK20A_3E_H      FRC_PK_H_(0x20A, 0x3E)
#define REG_FRC_BK20A_3F_L      FRC_PK_L_(0x20A, 0x3F)
#define REG_FRC_BK20A_3F_H      FRC_PK_H_(0x20A, 0x3F)
#define REG_FRC_BK20A_40_L      FRC_PK_L_(0x20A, 0x40)
#define REG_FRC_BK20A_40_H      FRC_PK_H_(0x20A, 0x40)
#define REG_FRC_BK20A_41_L      FRC_PK_L_(0x20A, 0x41)
#define REG_FRC_BK20A_41_H      FRC_PK_H_(0x20A, 0x41)
#define REG_FRC_BK20A_42_L      FRC_PK_L_(0x20A, 0x42)
#define REG_FRC_BK20A_42_H      FRC_PK_H_(0x20A, 0x42)
#define REG_FRC_BK20A_43_L      FRC_PK_L_(0x20A, 0x43)
#define REG_FRC_BK20A_43_H      FRC_PK_H_(0x20A, 0x43)
#define REG_FRC_BK20A_44_L      FRC_PK_L_(0x20A, 0x44)
#define REG_FRC_BK20A_44_H      FRC_PK_H_(0x20A, 0x44)
#define REG_FRC_BK20A_45_L      FRC_PK_L_(0x20A, 0x45)
#define REG_FRC_BK20A_45_H      FRC_PK_H_(0x20A, 0x45)
#define REG_FRC_BK20A_46_L      FRC_PK_L_(0x20A, 0x46)
#define REG_FRC_BK20A_46_H      FRC_PK_H_(0x20A, 0x46)
#define REG_FRC_BK20A_47_L      FRC_PK_L_(0x20A, 0x47)
#define REG_FRC_BK20A_47_H      FRC_PK_H_(0x20A, 0x47)
#define REG_FRC_BK20A_48_L      FRC_PK_L_(0x20A, 0x48)
#define REG_FRC_BK20A_48_H      FRC_PK_H_(0x20A, 0x48)
#define REG_FRC_BK20A_49_L      FRC_PK_L_(0x20A, 0x49)
#define REG_FRC_BK20A_49_H      FRC_PK_H_(0x20A, 0x49)
#define REG_FRC_BK20A_4A_L      FRC_PK_L_(0x20A, 0x4A)
#define REG_FRC_BK20A_4A_H      FRC_PK_H_(0x20A, 0x4A)
#define REG_FRC_BK20A_4B_L      FRC_PK_L_(0x20A, 0x4B)
#define REG_FRC_BK20A_4B_H      FRC_PK_H_(0x20A, 0x4B)
#define REG_FRC_BK20A_4C_L      FRC_PK_L_(0x20A, 0x4C)
#define REG_FRC_BK20A_4C_H      FRC_PK_H_(0x20A, 0x4C)
#define REG_FRC_BK20A_4D_L      FRC_PK_L_(0x20A, 0x4D)
#define REG_FRC_BK20A_4D_H      FRC_PK_H_(0x20A, 0x4D)
#define REG_FRC_BK20A_4E_L      FRC_PK_L_(0x20A, 0x4E)
#define REG_FRC_BK20A_4E_H      FRC_PK_H_(0x20A, 0x4E)
#define REG_FRC_BK20A_4F_L      FRC_PK_L_(0x20A, 0x4F)
#define REG_FRC_BK20A_4F_H      FRC_PK_H_(0x20A, 0x4F)
#define REG_FRC_BK20A_50_L      FRC_PK_L_(0x20A, 0x50)
#define REG_FRC_BK20A_50_H      FRC_PK_H_(0x20A, 0x50)
#define REG_FRC_BK20A_51_L      FRC_PK_L_(0x20A, 0x51)
#define REG_FRC_BK20A_51_H      FRC_PK_H_(0x20A, 0x51)
#define REG_FRC_BK20A_52_L      FRC_PK_L_(0x20A, 0x52)
#define REG_FRC_BK20A_52_H      FRC_PK_H_(0x20A, 0x52)
#define REG_FRC_BK20A_53_L      FRC_PK_L_(0x20A, 0x53)
#define REG_FRC_BK20A_53_H      FRC_PK_H_(0x20A, 0x53)
#define REG_FRC_BK20A_54_L      FRC_PK_L_(0x20A, 0x54)
#define REG_FRC_BK20A_54_H      FRC_PK_H_(0x20A, 0x54)
#define REG_FRC_BK20A_55_L      FRC_PK_L_(0x20A, 0x55)
#define REG_FRC_BK20A_55_H      FRC_PK_H_(0x20A, 0x55)
#define REG_FRC_BK20A_56_L      FRC_PK_L_(0x20A, 0x56)
#define REG_FRC_BK20A_56_H      FRC_PK_H_(0x20A, 0x56)
#define REG_FRC_BK20A_57_L      FRC_PK_L_(0x20A, 0x57)
#define REG_FRC_BK20A_57_H      FRC_PK_H_(0x20A, 0x57)
#define REG_FRC_BK20A_58_L      FRC_PK_L_(0x20A, 0x58)
#define REG_FRC_BK20A_58_H      FRC_PK_H_(0x20A, 0x58)
#define REG_FRC_BK20A_59_L      FRC_PK_L_(0x20A, 0x59)
#define REG_FRC_BK20A_59_H      FRC_PK_H_(0x20A, 0x59)
#define REG_FRC_BK20A_5A_L      FRC_PK_L_(0x20A, 0x5A)
#define REG_FRC_BK20A_5A_H      FRC_PK_H_(0x20A, 0x5A)
#define REG_FRC_BK20A_5B_L      FRC_PK_L_(0x20A, 0x5B)
#define REG_FRC_BK20A_5B_H      FRC_PK_H_(0x20A, 0x5B)
#define REG_FRC_BK20A_5C_L      FRC_PK_L_(0x20A, 0x5C)
#define REG_FRC_BK20A_5C_H      FRC_PK_H_(0x20A, 0x5C)
#define REG_FRC_BK20A_5D_L      FRC_PK_L_(0x20A, 0x5D)
#define REG_FRC_BK20A_5D_H      FRC_PK_H_(0x20A, 0x5D)
#define REG_FRC_BK20A_5E_L      FRC_PK_L_(0x20A, 0x5E)
#define REG_FRC_BK20A_5E_H      FRC_PK_H_(0x20A, 0x5E)
#define REG_FRC_BK20A_5F_L      FRC_PK_L_(0x20A, 0x5F)
#define REG_FRC_BK20A_5F_H      FRC_PK_H_(0x20A, 0x5F)
#define REG_FRC_BK20A_60_L      FRC_PK_L_(0x20A, 0x60)
#define REG_FRC_BK20A_60_H      FRC_PK_H_(0x20A, 0x60)
#define REG_FRC_BK20A_61_L      FRC_PK_L_(0x20A, 0x61)
#define REG_FRC_BK20A_61_H      FRC_PK_H_(0x20A, 0x61)
#define REG_FRC_BK20A_62_L      FRC_PK_L_(0x20A, 0x62)
#define REG_FRC_BK20A_62_H      FRC_PK_H_(0x20A, 0x62)
#define REG_FRC_BK20A_63_L      FRC_PK_L_(0x20A, 0x63)
#define REG_FRC_BK20A_63_H      FRC_PK_H_(0x20A, 0x63)
#define REG_FRC_BK20A_64_L      FRC_PK_L_(0x20A, 0x64)
#define REG_FRC_BK20A_64_H      FRC_PK_H_(0x20A, 0x64)
#define REG_FRC_BK20A_65_L      FRC_PK_L_(0x20A, 0x65)
#define REG_FRC_BK20A_65_H      FRC_PK_H_(0x20A, 0x65)
#define REG_FRC_BK20A_66_L      FRC_PK_L_(0x20A, 0x66)
#define REG_FRC_BK20A_66_H      FRC_PK_H_(0x20A, 0x66)
#define REG_FRC_BK20A_67_L      FRC_PK_L_(0x20A, 0x67)
#define REG_FRC_BK20A_67_H      FRC_PK_H_(0x20A, 0x67)
#define REG_FRC_BK20A_68_L      FRC_PK_L_(0x20A, 0x68)
#define REG_FRC_BK20A_68_H      FRC_PK_H_(0x20A, 0x68)
#define REG_FRC_BK20A_69_L      FRC_PK_L_(0x20A, 0x69)
#define REG_FRC_BK20A_69_H      FRC_PK_H_(0x20A, 0x69)
#define REG_FRC_BK20A_6A_L      FRC_PK_L_(0x20A, 0x6A)
#define REG_FRC_BK20A_6A_H      FRC_PK_H_(0x20A, 0x6A)
#define REG_FRC_BK20A_6B_L      FRC_PK_L_(0x20A, 0x6B)
#define REG_FRC_BK20A_6B_H      FRC_PK_H_(0x20A, 0x6B)
#define REG_FRC_BK20A_6C_L      FRC_PK_L_(0x20A, 0x6C)
#define REG_FRC_BK20A_6C_H      FRC_PK_H_(0x20A, 0x6C)
#define REG_FRC_BK20A_6D_L      FRC_PK_L_(0x20A, 0x6D)
#define REG_FRC_BK20A_6D_H      FRC_PK_H_(0x20A, 0x6D)
#define REG_FRC_BK20A_6E_L      FRC_PK_L_(0x20A, 0x6E)
#define REG_FRC_BK20A_6E_H      FRC_PK_H_(0x20A, 0x6E)
#define REG_FRC_BK20A_6F_L      FRC_PK_L_(0x20A, 0x6F)
#define REG_FRC_BK20A_6F_H      FRC_PK_H_(0x20A, 0x6F)
#define REG_FRC_BK20A_70_L      FRC_PK_L_(0x20A, 0x70)
#define REG_FRC_BK20A_70_H      FRC_PK_H_(0x20A, 0x70)
#define REG_FRC_BK20A_71_L      FRC_PK_L_(0x20A, 0x71)
#define REG_FRC_BK20A_71_H      FRC_PK_H_(0x20A, 0x71)
#define REG_FRC_BK20A_72_L      FRC_PK_L_(0x20A, 0x72)
#define REG_FRC_BK20A_72_H      FRC_PK_H_(0x20A, 0x72)
#define REG_FRC_BK20A_73_L      FRC_PK_L_(0x20A, 0x73)
#define REG_FRC_BK20A_73_H      FRC_PK_H_(0x20A, 0x73)
#define REG_FRC_BK20A_74_L      FRC_PK_L_(0x20A, 0x74)
#define REG_FRC_BK20A_74_H      FRC_PK_H_(0x20A, 0x74)
#define REG_FRC_BK20A_75_L      FRC_PK_L_(0x20A, 0x75)
#define REG_FRC_BK20A_75_H      FRC_PK_H_(0x20A, 0x75)
#define REG_FRC_BK20A_76_L      FRC_PK_L_(0x20A, 0x76)
#define REG_FRC_BK20A_76_H      FRC_PK_H_(0x20A, 0x76)
#define REG_FRC_BK20A_77_L      FRC_PK_L_(0x20A, 0x77)
#define REG_FRC_BK20A_77_H      FRC_PK_H_(0x20A, 0x77)
#define REG_FRC_BK20A_78_L      FRC_PK_L_(0x20A, 0x78)
#define REG_FRC_BK20A_78_H      FRC_PK_H_(0x20A, 0x78)
#define REG_FRC_BK20A_79_L      FRC_PK_L_(0x20A, 0x79)
#define REG_FRC_BK20A_79_H      FRC_PK_H_(0x20A, 0x79)
#define REG_FRC_BK20A_7A_L      FRC_PK_L_(0x20A, 0x7A)
#define REG_FRC_BK20A_7A_H      FRC_PK_H_(0x20A, 0x7A)
#define REG_FRC_BK20A_7B_L      FRC_PK_L_(0x20A, 0x7B)
#define REG_FRC_BK20A_7B_H      FRC_PK_H_(0x20A, 0x7B)
#define REG_FRC_BK20A_7C_L      FRC_PK_L_(0x20A, 0x7C)
#define REG_FRC_BK20A_7C_H      FRC_PK_H_(0x20A, 0x7C)
#define REG_FRC_BK20A_7D_L      FRC_PK_L_(0x20A, 0x7D)
#define REG_FRC_BK20A_7D_H      FRC_PK_H_(0x20A, 0x7D)
#define REG_FRC_BK20A_7E_L      FRC_PK_L_(0x20A, 0x7E)
#define REG_FRC_BK20A_7E_H      FRC_PK_H_(0x20A, 0x7E)
#define REG_FRC_BK20A_7F_L      FRC_PK_L_(0x20A, 0x7F)
#define REG_FRC_BK20A_7F_H      FRC_PK_H_(0x20A, 0x7F)

//----------------------------------------------
//  BK118 -> BK218
//----------------------------------------------
#define REG_FRC_BK218_00_L      FRC_PK_L_(0x218, 0x00)
#define REG_FRC_BK218_00_H      FRC_PK_H_(0x218, 0x00)
#define REG_FRC_BK218_01_L      FRC_PK_L_(0x218, 0x01)
#define REG_FRC_BK218_01_H      FRC_PK_H_(0x218, 0x01)
#define REG_FRC_BK218_02_L      FRC_PK_L_(0x218, 0x02)
#define REG_FRC_BK218_02_H      FRC_PK_H_(0x218, 0x02)
#define REG_FRC_BK218_03_L      FRC_PK_L_(0x218, 0x03)
#define REG_FRC_BK218_03_H      FRC_PK_H_(0x218, 0x03)
#define REG_FRC_BK218_04_L      FRC_PK_L_(0x218, 0x04)
#define REG_FRC_BK218_04_H      FRC_PK_H_(0x218, 0x04)
#define REG_FRC_BK218_05_L      FRC_PK_L_(0x218, 0x05)
#define REG_FRC_BK218_05_H      FRC_PK_H_(0x218, 0x05)
#define REG_FRC_BK218_06_L      FRC_PK_L_(0x218, 0x06)
#define REG_FRC_BK218_06_H      FRC_PK_H_(0x218, 0x06)
#define REG_FRC_BK218_07_L      FRC_PK_L_(0x218, 0x07)
#define REG_FRC_BK218_07_H      FRC_PK_H_(0x218, 0x07)
#define REG_FRC_BK218_08_L      FRC_PK_L_(0x218, 0x08)
#define REG_FRC_BK218_08_H      FRC_PK_H_(0x218, 0x08)
#define REG_FRC_BK218_09_L      FRC_PK_L_(0x218, 0x09)
#define REG_FRC_BK218_09_H      FRC_PK_H_(0x218, 0x09)
#define REG_FRC_BK218_0A_L      FRC_PK_L_(0x218, 0x0A)
#define REG_FRC_BK218_0A_H      FRC_PK_H_(0x218, 0x0A)
#define REG_FRC_BK218_0B_L      FRC_PK_L_(0x218, 0x0B)
#define REG_FRC_BK218_0B_H      FRC_PK_H_(0x218, 0x0B)
#define REG_FRC_BK218_0C_L      FRC_PK_L_(0x218, 0x0C)
#define REG_FRC_BK218_0C_H      FRC_PK_H_(0x218, 0x0C)
#define REG_FRC_BK218_0D_L      FRC_PK_L_(0x218, 0x0D)
#define REG_FRC_BK218_0D_H      FRC_PK_H_(0x218, 0x0D)
#define REG_FRC_BK218_0E_L      FRC_PK_L_(0x218, 0x0E)
#define REG_FRC_BK218_0E_H      FRC_PK_H_(0x218, 0x0E)
#define REG_FRC_BK218_0F_L      FRC_PK_L_(0x218, 0x0F)
#define REG_FRC_BK218_0F_H      FRC_PK_H_(0x218, 0x0F)
#define REG_FRC_BK218_10_L      FRC_PK_L_(0x218, 0x10)
#define REG_FRC_BK218_10_H      FRC_PK_H_(0x218, 0x10)
#define REG_FRC_BK218_11_L      FRC_PK_L_(0x218, 0x11)
#define REG_FRC_BK218_11_H      FRC_PK_H_(0x218, 0x11)
#define REG_FRC_BK218_12_L      FRC_PK_L_(0x218, 0x12)
#define REG_FRC_BK218_12_H      FRC_PK_H_(0x218, 0x12)
#define REG_FRC_BK218_13_L      FRC_PK_L_(0x218, 0x13)
#define REG_FRC_BK218_13_H      FRC_PK_H_(0x218, 0x13)
#define REG_FRC_BK218_14_L      FRC_PK_L_(0x218, 0x14)
#define REG_FRC_BK218_14_H      FRC_PK_H_(0x218, 0x14)
#define REG_FRC_BK218_15_L      FRC_PK_L_(0x218, 0x15)
#define REG_FRC_BK218_15_H      FRC_PK_H_(0x218, 0x15)
#define REG_FRC_BK218_16_L      FRC_PK_L_(0x218, 0x16)
#define REG_FRC_BK218_16_H      FRC_PK_H_(0x218, 0x16)
#define REG_FRC_BK218_17_L      FRC_PK_L_(0x218, 0x17)
#define REG_FRC_BK218_17_H      FRC_PK_H_(0x218, 0x17)
#define REG_FRC_BK218_18_L      FRC_PK_L_(0x218, 0x18)
#define REG_FRC_BK218_18_H      FRC_PK_H_(0x218, 0x18)
#define REG_FRC_BK218_19_L      FRC_PK_L_(0x218, 0x19)
#define REG_FRC_BK218_19_H      FRC_PK_H_(0x218, 0x19)
#define REG_FRC_BK218_1A_L      FRC_PK_L_(0x218, 0x1A)
#define REG_FRC_BK218_1A_H      FRC_PK_H_(0x218, 0x1A)
#define REG_FRC_BK218_1B_L      FRC_PK_L_(0x218, 0x1B)
#define REG_FRC_BK218_1B_H      FRC_PK_H_(0x218, 0x1B)
#define REG_FRC_BK218_1C_L      FRC_PK_L_(0x218, 0x1C)
#define REG_FRC_BK218_1C_H      FRC_PK_H_(0x218, 0x1C)
#define REG_FRC_BK218_1D_L      FRC_PK_L_(0x218, 0x1D)
#define REG_FRC_BK218_1D_H      FRC_PK_H_(0x218, 0x1D)
#define REG_FRC_BK218_1E_L      FRC_PK_L_(0x218, 0x1E)
#define REG_FRC_BK218_1E_H      FRC_PK_H_(0x218, 0x1E)
#define REG_FRC_BK218_1F_L      FRC_PK_L_(0x218, 0x1F)
#define REG_FRC_BK218_1F_H      FRC_PK_H_(0x218, 0x1F)
#define REG_FRC_BK218_20_L      FRC_PK_L_(0x218, 0x20)
#define REG_FRC_BK218_20_H      FRC_PK_H_(0x218, 0x20)
#define REG_FRC_BK218_21_L      FRC_PK_L_(0x218, 0x21)
#define REG_FRC_BK218_21_H      FRC_PK_H_(0x218, 0x21)
#define REG_FRC_BK218_22_L      FRC_PK_L_(0x218, 0x22)
#define REG_FRC_BK218_22_H      FRC_PK_H_(0x218, 0x22)
#define REG_FRC_BK218_23_L      FRC_PK_L_(0x218, 0x23)
#define REG_FRC_BK218_23_H      FRC_PK_H_(0x218, 0x23)
#define REG_FRC_BK218_24_L      FRC_PK_L_(0x218, 0x24)
#define REG_FRC_BK218_24_H      FRC_PK_H_(0x218, 0x24)
#define REG_FRC_BK218_25_L      FRC_PK_L_(0x218, 0x25)
#define REG_FRC_BK218_25_H      FRC_PK_H_(0x218, 0x25)
#define REG_FRC_BK218_26_L      FRC_PK_L_(0x218, 0x26)
#define REG_FRC_BK218_26_H      FRC_PK_H_(0x218, 0x26)
#define REG_FRC_BK218_27_L      FRC_PK_L_(0x218, 0x27)
#define REG_FRC_BK218_27_H      FRC_PK_H_(0x218, 0x27)
#define REG_FRC_BK218_28_L      FRC_PK_L_(0x218, 0x28)
#define REG_FRC_BK218_28_H      FRC_PK_H_(0x218, 0x28)
#define REG_FRC_BK218_29_L      FRC_PK_L_(0x218, 0x29)
#define REG_FRC_BK218_29_H      FRC_PK_H_(0x218, 0x29)
#define REG_FRC_BK218_2A_L      FRC_PK_L_(0x218, 0x2A)
#define REG_FRC_BK218_2A_H      FRC_PK_H_(0x218, 0x2A)
#define REG_FRC_BK218_2B_L      FRC_PK_L_(0x218, 0x2B)
#define REG_FRC_BK218_2B_H      FRC_PK_H_(0x218, 0x2B)
#define REG_FRC_BK218_2C_L      FRC_PK_L_(0x218, 0x2C)
#define REG_FRC_BK218_2C_H      FRC_PK_H_(0x218, 0x2C)
#define REG_FRC_BK218_2D_L      FRC_PK_L_(0x218, 0x2D)
#define REG_FRC_BK218_2D_H      FRC_PK_H_(0x218, 0x2D)
#define REG_FRC_BK218_2E_L      FRC_PK_L_(0x218, 0x2E)
#define REG_FRC_BK218_2E_H      FRC_PK_H_(0x218, 0x2E)
#define REG_FRC_BK218_2F_L      FRC_PK_L_(0x218, 0x2F)
#define REG_FRC_BK218_2F_H      FRC_PK_H_(0x218, 0x2F)
#define REG_FRC_BK218_30_L      FRC_PK_L_(0x218, 0x30)
#define REG_FRC_BK218_30_H      FRC_PK_H_(0x218, 0x30)
#define REG_FRC_BK218_31_L      FRC_PK_L_(0x218, 0x31)
#define REG_FRC_BK218_31_H      FRC_PK_H_(0x218, 0x31)
#define REG_FRC_BK218_32_L      FRC_PK_L_(0x218, 0x32)
#define REG_FRC_BK218_32_H      FRC_PK_H_(0x218, 0x32)
#define REG_FRC_BK218_33_L      FRC_PK_L_(0x218, 0x33)
#define REG_FRC_BK218_33_H      FRC_PK_H_(0x218, 0x33)
#define REG_FRC_BK218_34_L      FRC_PK_L_(0x218, 0x34)
#define REG_FRC_BK218_34_H      FRC_PK_H_(0x218, 0x34)
#define REG_FRC_BK218_35_L      FRC_PK_L_(0x218, 0x35)
#define REG_FRC_BK218_35_H      FRC_PK_H_(0x218, 0x35)
#define REG_FRC_BK218_36_L      FRC_PK_L_(0x218, 0x36)
#define REG_FRC_BK218_36_H      FRC_PK_H_(0x218, 0x36)
#define REG_FRC_BK218_37_L      FRC_PK_L_(0x218, 0x37)
#define REG_FRC_BK218_37_H      FRC_PK_H_(0x218, 0x37)
#define REG_FRC_BK218_38_L      FRC_PK_L_(0x218, 0x38)
#define REG_FRC_BK218_38_H      FRC_PK_H_(0x218, 0x38)
#define REG_FRC_BK218_39_L      FRC_PK_L_(0x218, 0x39)
#define REG_FRC_BK218_39_H      FRC_PK_H_(0x218, 0x39)
#define REG_FRC_BK218_3A_L      FRC_PK_L_(0x218, 0x3A)
#define REG_FRC_BK218_3A_H      FRC_PK_H_(0x218, 0x3A)
#define REG_FRC_BK218_3B_L      FRC_PK_L_(0x218, 0x3B)
#define REG_FRC_BK218_3B_H      FRC_PK_H_(0x218, 0x3B)
#define REG_FRC_BK218_3C_L      FRC_PK_L_(0x218, 0x3C)
#define REG_FRC_BK218_3C_H      FRC_PK_H_(0x218, 0x3C)
#define REG_FRC_BK218_3D_L      FRC_PK_L_(0x218, 0x3D)
#define REG_FRC_BK218_3D_H      FRC_PK_H_(0x218, 0x3D)
#define REG_FRC_BK218_3E_L      FRC_PK_L_(0x218, 0x3E)
#define REG_FRC_BK218_3E_H      FRC_PK_H_(0x218, 0x3E)
#define REG_FRC_BK218_3F_L      FRC_PK_L_(0x218, 0x3F)
#define REG_FRC_BK218_3F_H      FRC_PK_H_(0x218, 0x3F)
#define REG_FRC_BK218_40_L      FRC_PK_L_(0x218, 0x40)
#define REG_FRC_BK218_40_H      FRC_PK_H_(0x218, 0x40)
#define REG_FRC_BK218_41_L      FRC_PK_L_(0x218, 0x41)
#define REG_FRC_BK218_41_H      FRC_PK_H_(0x218, 0x41)
#define REG_FRC_BK218_42_L      FRC_PK_L_(0x218, 0x42)
#define REG_FRC_BK218_42_H      FRC_PK_H_(0x218, 0x42)
#define REG_FRC_BK218_43_L      FRC_PK_L_(0x218, 0x43)
#define REG_FRC_BK218_43_H      FRC_PK_H_(0x218, 0x43)
#define REG_FRC_BK218_44_L      FRC_PK_L_(0x218, 0x44)
#define REG_FRC_BK218_44_H      FRC_PK_H_(0x218, 0x44)
#define REG_FRC_BK218_45_L      FRC_PK_L_(0x218, 0x45)
#define REG_FRC_BK218_45_H      FRC_PK_H_(0x218, 0x45)
#define REG_FRC_BK218_46_L      FRC_PK_L_(0x218, 0x46)
#define REG_FRC_BK218_46_H      FRC_PK_H_(0x218, 0x46)
#define REG_FRC_BK218_47_L      FRC_PK_L_(0x218, 0x47)
#define REG_FRC_BK218_47_H      FRC_PK_H_(0x218, 0x47)
#define REG_FRC_BK218_48_L      FRC_PK_L_(0x218, 0x48)
#define REG_FRC_BK218_48_H      FRC_PK_H_(0x218, 0x48)
#define REG_FRC_BK218_49_L      FRC_PK_L_(0x218, 0x49)
#define REG_FRC_BK218_49_H      FRC_PK_H_(0x218, 0x49)
#define REG_FRC_BK218_4A_L      FRC_PK_L_(0x218, 0x4A)
#define REG_FRC_BK218_4A_H      FRC_PK_H_(0x218, 0x4A)
#define REG_FRC_BK218_4B_L      FRC_PK_L_(0x218, 0x4B)
#define REG_FRC_BK218_4B_H      FRC_PK_H_(0x218, 0x4B)
#define REG_FRC_BK218_4C_L      FRC_PK_L_(0x218, 0x4C)
#define REG_FRC_BK218_4C_H      FRC_PK_H_(0x218, 0x4C)
#define REG_FRC_BK218_4D_L      FRC_PK_L_(0x218, 0x4D)
#define REG_FRC_BK218_4D_H      FRC_PK_H_(0x218, 0x4D)
#define REG_FRC_BK218_4E_L      FRC_PK_L_(0x218, 0x4E)
#define REG_FRC_BK218_4E_H      FRC_PK_H_(0x218, 0x4E)
#define REG_FRC_BK218_4F_L      FRC_PK_L_(0x218, 0x4F)
#define REG_FRC_BK218_4F_H      FRC_PK_H_(0x218, 0x4F)
#define REG_FRC_BK218_50_L      FRC_PK_L_(0x218, 0x50)
#define REG_FRC_BK218_50_H      FRC_PK_H_(0x218, 0x50)
#define REG_FRC_BK218_51_L      FRC_PK_L_(0x218, 0x51)
#define REG_FRC_BK218_51_H      FRC_PK_H_(0x218, 0x51)
#define REG_FRC_BK218_52_L      FRC_PK_L_(0x218, 0x52)
#define REG_FRC_BK218_52_H      FRC_PK_H_(0x218, 0x52)
#define REG_FRC_BK218_53_L      FRC_PK_L_(0x218, 0x53)
#define REG_FRC_BK218_53_H      FRC_PK_H_(0x218, 0x53)
#define REG_FRC_BK218_54_L      FRC_PK_L_(0x218, 0x54)
#define REG_FRC_BK218_54_H      FRC_PK_H_(0x218, 0x54)
#define REG_FRC_BK218_55_L      FRC_PK_L_(0x218, 0x55)
#define REG_FRC_BK218_55_H      FRC_PK_H_(0x218, 0x55)
#define REG_FRC_BK218_56_L      FRC_PK_L_(0x218, 0x56)
#define REG_FRC_BK218_56_H      FRC_PK_H_(0x218, 0x56)
#define REG_FRC_BK218_57_L      FRC_PK_L_(0x218, 0x57)
#define REG_FRC_BK218_57_H      FRC_PK_H_(0x218, 0x57)
#define REG_FRC_BK218_58_L      FRC_PK_L_(0x218, 0x58)
#define REG_FRC_BK218_58_H      FRC_PK_H_(0x218, 0x58)
#define REG_FRC_BK218_59_L      FRC_PK_L_(0x218, 0x59)
#define REG_FRC_BK218_59_H      FRC_PK_H_(0x218, 0x59)
#define REG_FRC_BK218_5A_L      FRC_PK_L_(0x218, 0x5A)
#define REG_FRC_BK218_5A_H      FRC_PK_H_(0x218, 0x5A)
#define REG_FRC_BK218_5B_L      FRC_PK_L_(0x218, 0x5B)
#define REG_FRC_BK218_5B_H      FRC_PK_H_(0x218, 0x5B)
#define REG_FRC_BK218_5C_L      FRC_PK_L_(0x218, 0x5C)
#define REG_FRC_BK218_5C_H      FRC_PK_H_(0x218, 0x5C)
#define REG_FRC_BK218_5D_L      FRC_PK_L_(0x218, 0x5D)
#define REG_FRC_BK218_5D_H      FRC_PK_H_(0x218, 0x5D)
#define REG_FRC_BK218_5E_L      FRC_PK_L_(0x218, 0x5E)
#define REG_FRC_BK218_5E_H      FRC_PK_H_(0x218, 0x5E)
#define REG_FRC_BK218_5F_L      FRC_PK_L_(0x218, 0x5F)
#define REG_FRC_BK218_5F_H      FRC_PK_H_(0x218, 0x5F)
#define REG_FRC_BK218_60_L      FRC_PK_L_(0x218, 0x60)
#define REG_FRC_BK218_60_H      FRC_PK_H_(0x218, 0x60)
#define REG_FRC_BK218_61_L      FRC_PK_L_(0x218, 0x61)
#define REG_FRC_BK218_61_H      FRC_PK_H_(0x218, 0x61)
#define REG_FRC_BK218_62_L      FRC_PK_L_(0x218, 0x62)
#define REG_FRC_BK218_62_H      FRC_PK_H_(0x218, 0x62)
#define REG_FRC_BK218_63_L      FRC_PK_L_(0x218, 0x63)
#define REG_FRC_BK218_63_H      FRC_PK_H_(0x218, 0x63)
#define REG_FRC_BK218_64_L      FRC_PK_L_(0x218, 0x64)
#define REG_FRC_BK218_64_H      FRC_PK_H_(0x218, 0x64)
#define REG_FRC_BK218_65_L      FRC_PK_L_(0x218, 0x65)
#define REG_FRC_BK218_65_H      FRC_PK_H_(0x218, 0x65)
#define REG_FRC_BK218_66_L      FRC_PK_L_(0x218, 0x66)
#define REG_FRC_BK218_66_H      FRC_PK_H_(0x218, 0x66)
#define REG_FRC_BK218_67_L      FRC_PK_L_(0x218, 0x67)
#define REG_FRC_BK218_67_H      FRC_PK_H_(0x218, 0x67)
#define REG_FRC_BK218_68_L      FRC_PK_L_(0x218, 0x68)
#define REG_FRC_BK218_68_H      FRC_PK_H_(0x218, 0x68)
#define REG_FRC_BK218_69_L      FRC_PK_L_(0x218, 0x69)
#define REG_FRC_BK218_69_H      FRC_PK_H_(0x218, 0x69)
#define REG_FRC_BK218_6A_L      FRC_PK_L_(0x218, 0x6A)
#define REG_FRC_BK218_6A_H      FRC_PK_H_(0x218, 0x6A)
#define REG_FRC_BK218_6B_L      FRC_PK_L_(0x218, 0x6B)
#define REG_FRC_BK218_6B_H      FRC_PK_H_(0x218, 0x6B)
#define REG_FRC_BK218_6C_L      FRC_PK_L_(0x218, 0x6C)
#define REG_FRC_BK218_6C_H      FRC_PK_H_(0x218, 0x6C)
#define REG_FRC_BK218_6D_L      FRC_PK_L_(0x218, 0x6D)
#define REG_FRC_BK218_6D_H      FRC_PK_H_(0x218, 0x6D)
#define REG_FRC_BK218_6E_L      FRC_PK_L_(0x218, 0x6E)
#define REG_FRC_BK218_6E_H      FRC_PK_H_(0x218, 0x6E)
#define REG_FRC_BK218_6F_L      FRC_PK_L_(0x218, 0x6F)
#define REG_FRC_BK218_6F_H      FRC_PK_H_(0x218, 0x6F)
#define REG_FRC_BK218_70_L      FRC_PK_L_(0x218, 0x70)
#define REG_FRC_BK218_70_H      FRC_PK_H_(0x218, 0x70)
#define REG_FRC_BK218_71_L      FRC_PK_L_(0x218, 0x71)
#define REG_FRC_BK218_71_H      FRC_PK_H_(0x218, 0x71)
#define REG_FRC_BK218_72_L      FRC_PK_L_(0x218, 0x72)
#define REG_FRC_BK218_72_H      FRC_PK_H_(0x218, 0x72)
#define REG_FRC_BK218_73_L      FRC_PK_L_(0x218, 0x73)
#define REG_FRC_BK218_73_H      FRC_PK_H_(0x218, 0x73)
#define REG_FRC_BK218_74_L      FRC_PK_L_(0x218, 0x74)
#define REG_FRC_BK218_74_H      FRC_PK_H_(0x218, 0x74)
#define REG_FRC_BK218_75_L      FRC_PK_L_(0x218, 0x75)
#define REG_FRC_BK218_75_H      FRC_PK_H_(0x218, 0x75)
#define REG_FRC_BK218_76_L      FRC_PK_L_(0x218, 0x76)
#define REG_FRC_BK218_76_H      FRC_PK_H_(0x218, 0x76)
#define REG_FRC_BK218_77_L      FRC_PK_L_(0x218, 0x77)
#define REG_FRC_BK218_77_H      FRC_PK_H_(0x218, 0x77)
#define REG_FRC_BK218_78_L      FRC_PK_L_(0x218, 0x78)
#define REG_FRC_BK218_78_H      FRC_PK_H_(0x218, 0x78)
#define REG_FRC_BK218_79_L      FRC_PK_L_(0x218, 0x79)
#define REG_FRC_BK218_79_H      FRC_PK_H_(0x218, 0x79)
#define REG_FRC_BK218_7A_L      FRC_PK_L_(0x218, 0x7A)
#define REG_FRC_BK218_7A_H      FRC_PK_H_(0x218, 0x7A)
#define REG_FRC_BK218_7B_L      FRC_PK_L_(0x218, 0x7B)
#define REG_FRC_BK218_7B_H      FRC_PK_H_(0x218, 0x7B)
#define REG_FRC_BK218_7C_L      FRC_PK_L_(0x218, 0x7C)
#define REG_FRC_BK218_7C_H      FRC_PK_H_(0x218, 0x7C)
#define REG_FRC_BK218_7D_L      FRC_PK_L_(0x218, 0x7D)
#define REG_FRC_BK218_7D_H      FRC_PK_H_(0x218, 0x7D)
#define REG_FRC_BK218_7E_L      FRC_PK_L_(0x218, 0x7E)
#define REG_FRC_BK218_7E_H      FRC_PK_H_(0x218, 0x7E)
#define REG_FRC_BK218_7F_L      FRC_PK_L_(0x218, 0x7F)
#define REG_FRC_BK218_7F_H      FRC_PK_H_(0x218, 0x7F)

#define REG_FRC_BK229_01_L      FRC_PK_L_(0x229, 0x01)
#define REG_FRC_BK229_01_H      FRC_PK_H_(0x229, 0x01)

//----------------------------------------------
//  BK133 -> BK233
//----------------------------------------------
#define REG_FRC_BK233_00_L      FRC_PK_L_(0x233, 0x00)
#define REG_FRC_BK233_00_H      FRC_PK_H_(0x233, 0x00)
#define REG_FRC_BK233_01_L      FRC_PK_L_(0x233, 0x01)
#define REG_FRC_BK233_01_H      FRC_PK_H_(0x233, 0x01)
#define REG_FRC_BK233_02_L      FRC_PK_L_(0x233, 0x02)
#define REG_FRC_BK233_02_H      FRC_PK_H_(0x233, 0x02)
#define REG_FRC_BK233_03_L      FRC_PK_L_(0x233, 0x03)
#define REG_FRC_BK233_03_H      FRC_PK_H_(0x233, 0x03)
#define REG_FRC_BK233_04_L      FRC_PK_L_(0x233, 0x04)
#define REG_FRC_BK233_04_H      FRC_PK_H_(0x233, 0x04)
#define REG_FRC_BK233_05_L      FRC_PK_L_(0x233, 0x05)
#define REG_FRC_BK233_05_H      FRC_PK_H_(0x233, 0x05)
#define REG_FRC_BK233_06_L      FRC_PK_L_(0x233, 0x06)
#define REG_FRC_BK233_06_H      FRC_PK_H_(0x233, 0x06)
#define REG_FRC_BK233_07_L      FRC_PK_L_(0x233, 0x07)
#define REG_FRC_BK233_07_H      FRC_PK_H_(0x233, 0x07)
#define REG_FRC_BK233_08_L      FRC_PK_L_(0x233, 0x08)
#define REG_FRC_BK233_08_H      FRC_PK_H_(0x233, 0x08)
#define REG_FRC_BK233_09_L      FRC_PK_L_(0x233, 0x09)
#define REG_FRC_BK233_09_H      FRC_PK_H_(0x233, 0x09)
#define REG_FRC_BK233_0A_L      FRC_PK_L_(0x233, 0x0A)
#define REG_FRC_BK233_0A_H      FRC_PK_H_(0x233, 0x0A)
#define REG_FRC_BK233_0B_L      FRC_PK_L_(0x233, 0x0B)
#define REG_FRC_BK233_0B_H      FRC_PK_H_(0x233, 0x0B)
#define REG_FRC_BK233_0C_L      FRC_PK_L_(0x233, 0x0C)
#define REG_FRC_BK233_0C_H      FRC_PK_H_(0x233, 0x0C)
#define REG_FRC_BK233_0D_L      FRC_PK_L_(0x233, 0x0D)
#define REG_FRC_BK233_0D_H      FRC_PK_H_(0x233, 0x0D)
#define REG_FRC_BK233_0E_L      FRC_PK_L_(0x233, 0x0E)
#define REG_FRC_BK233_0E_H      FRC_PK_H_(0x233, 0x0E)
#define REG_FRC_BK233_0F_L      FRC_PK_L_(0x233, 0x0F)
#define REG_FRC_BK233_0F_H      FRC_PK_H_(0x233, 0x0F)
#define REG_FRC_BK233_10_L      FRC_PK_L_(0x233, 0x10)
#define REG_FRC_BK233_10_H      FRC_PK_H_(0x233, 0x10)
#define REG_FRC_BK233_11_L      FRC_PK_L_(0x233, 0x11)
#define REG_FRC_BK233_11_H      FRC_PK_H_(0x233, 0x11)
#define REG_FRC_BK233_12_L      FRC_PK_L_(0x233, 0x12)
#define REG_FRC_BK233_12_H      FRC_PK_H_(0x233, 0x12)
#define REG_FRC_BK233_13_L      FRC_PK_L_(0x233, 0x13)
#define REG_FRC_BK233_13_H      FRC_PK_H_(0x233, 0x13)
#define REG_FRC_BK233_14_L      FRC_PK_L_(0x233, 0x14)
#define REG_FRC_BK233_14_H      FRC_PK_H_(0x233, 0x14)
#define REG_FRC_BK233_15_L      FRC_PK_L_(0x233, 0x15)
#define REG_FRC_BK233_15_H      FRC_PK_H_(0x233, 0x15)
#define REG_FRC_BK233_16_L      FRC_PK_L_(0x233, 0x16)
#define REG_FRC_BK233_16_H      FRC_PK_H_(0x233, 0x16)
#define REG_FRC_BK233_17_L      FRC_PK_L_(0x233, 0x17)
#define REG_FRC_BK233_17_H      FRC_PK_H_(0x233, 0x17)
#define REG_FRC_BK233_18_L      FRC_PK_L_(0x233, 0x18)
#define REG_FRC_BK233_18_H      FRC_PK_H_(0x233, 0x18)
#define REG_FRC_BK233_19_L      FRC_PK_L_(0x233, 0x19)
#define REG_FRC_BK233_19_H      FRC_PK_H_(0x233, 0x19)
#define REG_FRC_BK233_1A_L      FRC_PK_L_(0x233, 0x1A)
#define REG_FRC_BK233_1A_H      FRC_PK_H_(0x233, 0x1A)
#define REG_FRC_BK233_1B_L      FRC_PK_L_(0x233, 0x1B)
#define REG_FRC_BK233_1B_H      FRC_PK_H_(0x233, 0x1B)
#define REG_FRC_BK233_1C_L      FRC_PK_L_(0x233, 0x1C)
#define REG_FRC_BK233_1C_H      FRC_PK_H_(0x233, 0x1C)
#define REG_FRC_BK233_1D_L      FRC_PK_L_(0x233, 0x1D)
#define REG_FRC_BK233_1D_H      FRC_PK_H_(0x233, 0x1D)
#define REG_FRC_BK233_1E_L      FRC_PK_L_(0x233, 0x1E)
#define REG_FRC_BK233_1E_H      FRC_PK_H_(0x233, 0x1E)
#define REG_FRC_BK233_1F_L      FRC_PK_L_(0x233, 0x1F)
#define REG_FRC_BK233_1F_H      FRC_PK_H_(0x233, 0x1F)
#define REG_FRC_BK233_20_L      FRC_PK_L_(0x233, 0x20)
#define REG_FRC_BK233_20_H      FRC_PK_H_(0x233, 0x20)
#define REG_FRC_BK233_21_L      FRC_PK_L_(0x233, 0x21)
#define REG_FRC_BK233_21_H      FRC_PK_H_(0x233, 0x21)
#define REG_FRC_BK233_22_L      FRC_PK_L_(0x233, 0x22)
#define REG_FRC_BK233_22_H      FRC_PK_H_(0x233, 0x22)
#define REG_FRC_BK233_23_L      FRC_PK_L_(0x233, 0x23)
#define REG_FRC_BK233_23_H      FRC_PK_H_(0x233, 0x23)
#define REG_FRC_BK233_24_L      FRC_PK_L_(0x233, 0x24)
#define REG_FRC_BK233_24_H      FRC_PK_H_(0x233, 0x24)
#define REG_FRC_BK233_25_L      FRC_PK_L_(0x233, 0x25)
#define REG_FRC_BK233_25_H      FRC_PK_H_(0x233, 0x25)
#define REG_FRC_BK233_26_L      FRC_PK_L_(0x233, 0x26)
#define REG_FRC_BK233_26_H      FRC_PK_H_(0x233, 0x26)
#define REG_FRC_BK233_27_L      FRC_PK_L_(0x233, 0x27)
#define REG_FRC_BK233_27_H      FRC_PK_H_(0x233, 0x27)
#define REG_FRC_BK233_28_L      FRC_PK_L_(0x233, 0x28)
#define REG_FRC_BK233_28_H      FRC_PK_H_(0x233, 0x28)
#define REG_FRC_BK233_29_L      FRC_PK_L_(0x233, 0x29)
#define REG_FRC_BK233_29_H      FRC_PK_H_(0x233, 0x29)
#define REG_FRC_BK233_2A_L      FRC_PK_L_(0x233, 0x2A)
#define REG_FRC_BK233_2A_H      FRC_PK_H_(0x233, 0x2A)
#define REG_FRC_BK233_2B_L      FRC_PK_L_(0x233, 0x2B)
#define REG_FRC_BK233_2B_H      FRC_PK_H_(0x233, 0x2B)
#define REG_FRC_BK233_2C_L      FRC_PK_L_(0x233, 0x2C)
#define REG_FRC_BK233_2C_H      FRC_PK_H_(0x233, 0x2C)
#define REG_FRC_BK233_2D_L      FRC_PK_L_(0x233, 0x2D)
#define REG_FRC_BK233_2D_H      FRC_PK_H_(0x233, 0x2D)
#define REG_FRC_BK233_2E_L      FRC_PK_L_(0x233, 0x2E)
#define REG_FRC_BK233_2E_H      FRC_PK_H_(0x233, 0x2E)
#define REG_FRC_BK233_2F_L      FRC_PK_L_(0x233, 0x2F)
#define REG_FRC_BK233_2F_H      FRC_PK_H_(0x233, 0x2F)
#define REG_FRC_BK233_30_L      FRC_PK_L_(0x233, 0x30)
#define REG_FRC_BK233_30_H      FRC_PK_H_(0x233, 0x30)
#define REG_FRC_BK233_31_L      FRC_PK_L_(0x233, 0x31)
#define REG_FRC_BK233_31_H      FRC_PK_H_(0x233, 0x31)
#define REG_FRC_BK233_32_L      FRC_PK_L_(0x233, 0x32)
#define REG_FRC_BK233_32_H      FRC_PK_H_(0x233, 0x32)
#define REG_FRC_BK233_33_L      FRC_PK_L_(0x233, 0x33)
#define REG_FRC_BK233_33_H      FRC_PK_H_(0x233, 0x33)
#define REG_FRC_BK233_34_L      FRC_PK_L_(0x233, 0x34)
#define REG_FRC_BK233_34_H      FRC_PK_H_(0x233, 0x34)
#define REG_FRC_BK233_35_L      FRC_PK_L_(0x233, 0x35)
#define REG_FRC_BK233_35_H      FRC_PK_H_(0x233, 0x35)
#define REG_FRC_BK233_36_L      FRC_PK_L_(0x233, 0x36)
#define REG_FRC_BK233_36_H      FRC_PK_H_(0x233, 0x36)
#define REG_FRC_BK233_37_L      FRC_PK_L_(0x233, 0x37)
#define REG_FRC_BK233_37_H      FRC_PK_H_(0x233, 0x37)
#define REG_FRC_BK233_38_L      FRC_PK_L_(0x233, 0x38)
#define REG_FRC_BK233_38_H      FRC_PK_H_(0x233, 0x38)
#define REG_FRC_BK233_39_L      FRC_PK_L_(0x233, 0x39)
#define REG_FRC_BK233_39_H      FRC_PK_H_(0x233, 0x39)
#define REG_FRC_BK233_3A_L      FRC_PK_L_(0x233, 0x3A)
#define REG_FRC_BK233_3A_H      FRC_PK_H_(0x233, 0x3A)
#define REG_FRC_BK233_3B_L      FRC_PK_L_(0x233, 0x3B)
#define REG_FRC_BK233_3B_H      FRC_PK_H_(0x233, 0x3B)
#define REG_FRC_BK233_3C_L      FRC_PK_L_(0x233, 0x3C)
#define REG_FRC_BK233_3C_H      FRC_PK_H_(0x233, 0x3C)
#define REG_FRC_BK233_3D_L      FRC_PK_L_(0x233, 0x3D)
#define REG_FRC_BK233_3D_H      FRC_PK_H_(0x233, 0x3D)
#define REG_FRC_BK233_3E_L      FRC_PK_L_(0x233, 0x3E)
#define REG_FRC_BK233_3E_H      FRC_PK_H_(0x233, 0x3E)
#define REG_FRC_BK233_3F_L      FRC_PK_L_(0x233, 0x3F)
#define REG_FRC_BK233_3F_H      FRC_PK_H_(0x233, 0x3F)
#define REG_FRC_BK233_40_L      FRC_PK_L_(0x233, 0x40)
#define REG_FRC_BK233_40_H      FRC_PK_H_(0x233, 0x40)
#define REG_FRC_BK233_41_L      FRC_PK_L_(0x233, 0x41)
#define REG_FRC_BK233_41_H      FRC_PK_H_(0x233, 0x41)
#define REG_FRC_BK233_42_L      FRC_PK_L_(0x233, 0x42)
#define REG_FRC_BK233_42_H      FRC_PK_H_(0x233, 0x42)
#define REG_FRC_BK233_43_L      FRC_PK_L_(0x233, 0x43)
#define REG_FRC_BK233_43_H      FRC_PK_H_(0x233, 0x43)
#define REG_FRC_BK233_44_L      FRC_PK_L_(0x233, 0x44)
#define REG_FRC_BK233_44_H      FRC_PK_H_(0x233, 0x44)
#define REG_FRC_BK233_45_L      FRC_PK_L_(0x233, 0x45)
#define REG_FRC_BK233_45_H      FRC_PK_H_(0x233, 0x45)
#define REG_FRC_BK233_46_L      FRC_PK_L_(0x233, 0x46)
#define REG_FRC_BK233_46_H      FRC_PK_H_(0x233, 0x46)
#define REG_FRC_BK233_47_L      FRC_PK_L_(0x233, 0x47)
#define REG_FRC_BK233_47_H      FRC_PK_H_(0x233, 0x47)
#define REG_FRC_BK233_48_L      FRC_PK_L_(0x233, 0x48)
#define REG_FRC_BK233_48_H      FRC_PK_H_(0x233, 0x48)
#define REG_FRC_BK233_49_L      FRC_PK_L_(0x233, 0x49)
#define REG_FRC_BK233_49_H      FRC_PK_H_(0x233, 0x49)
#define REG_FRC_BK233_4A_L      FRC_PK_L_(0x233, 0x4A)
#define REG_FRC_BK233_4A_H      FRC_PK_H_(0x233, 0x4A)
#define REG_FRC_BK233_4B_L      FRC_PK_L_(0x233, 0x4B)
#define REG_FRC_BK233_4B_H      FRC_PK_H_(0x233, 0x4B)
#define REG_FRC_BK233_4C_L      FRC_PK_L_(0x233, 0x4C)
#define REG_FRC_BK233_4C_H      FRC_PK_H_(0x233, 0x4C)
#define REG_FRC_BK233_4D_L      FRC_PK_L_(0x233, 0x4D)
#define REG_FRC_BK233_4D_H      FRC_PK_H_(0x233, 0x4D)
#define REG_FRC_BK233_4E_L      FRC_PK_L_(0x233, 0x4E)
#define REG_FRC_BK233_4E_H      FRC_PK_H_(0x233, 0x4E)
#define REG_FRC_BK233_4F_L      FRC_PK_L_(0x233, 0x4F)
#define REG_FRC_BK233_4F_H      FRC_PK_H_(0x233, 0x4F)
#define REG_FRC_BK233_50_L      FRC_PK_L_(0x233, 0x50)
#define REG_FRC_BK233_50_H      FRC_PK_H_(0x233, 0x50)
#define REG_FRC_BK233_51_L      FRC_PK_L_(0x233, 0x51)
#define REG_FRC_BK233_51_H      FRC_PK_H_(0x233, 0x51)
#define REG_FRC_BK233_52_L      FRC_PK_L_(0x233, 0x52)
#define REG_FRC_BK233_52_H      FRC_PK_H_(0x233, 0x52)
#define REG_FRC_BK233_53_L      FRC_PK_L_(0x233, 0x53)
#define REG_FRC_BK233_53_H      FRC_PK_H_(0x233, 0x53)
#define REG_FRC_BK233_54_L      FRC_PK_L_(0x233, 0x54)
#define REG_FRC_BK233_54_H      FRC_PK_H_(0x233, 0x54)
#define REG_FRC_BK233_55_L      FRC_PK_L_(0x233, 0x55)
#define REG_FRC_BK233_55_H      FRC_PK_H_(0x233, 0x55)
#define REG_FRC_BK233_56_L      FRC_PK_L_(0x233, 0x56)
#define REG_FRC_BK233_56_H      FRC_PK_H_(0x233, 0x56)
#define REG_FRC_BK233_57_L      FRC_PK_L_(0x233, 0x57)
#define REG_FRC_BK233_57_H      FRC_PK_H_(0x233, 0x57)
#define REG_FRC_BK233_58_L      FRC_PK_L_(0x233, 0x58)
#define REG_FRC_BK233_58_H      FRC_PK_H_(0x233, 0x58)
#define REG_FRC_BK233_59_L      FRC_PK_L_(0x233, 0x59)
#define REG_FRC_BK233_59_H      FRC_PK_H_(0x233, 0x59)
#define REG_FRC_BK233_5A_L      FRC_PK_L_(0x233, 0x5A)
#define REG_FRC_BK233_5A_H      FRC_PK_H_(0x233, 0x5A)
#define REG_FRC_BK233_5B_L      FRC_PK_L_(0x233, 0x5B)
#define REG_FRC_BK233_5B_H      FRC_PK_H_(0x233, 0x5B)
#define REG_FRC_BK233_5C_L      FRC_PK_L_(0x233, 0x5C)
#define REG_FRC_BK233_5C_H      FRC_PK_H_(0x233, 0x5C)
#define REG_FRC_BK233_5D_L      FRC_PK_L_(0x233, 0x5D)
#define REG_FRC_BK233_5D_H      FRC_PK_H_(0x233, 0x5D)
#define REG_FRC_BK233_5E_L      FRC_PK_L_(0x233, 0x5E)
#define REG_FRC_BK233_5E_H      FRC_PK_H_(0x233, 0x5E)
#define REG_FRC_BK233_5F_L      FRC_PK_L_(0x233, 0x5F)
#define REG_FRC_BK233_5F_H      FRC_PK_H_(0x233, 0x5F)
#define REG_FRC_BK233_60_L      FRC_PK_L_(0x233, 0x60)
#define REG_FRC_BK233_60_H      FRC_PK_H_(0x233, 0x60)
#define REG_FRC_BK233_61_L      FRC_PK_L_(0x233, 0x61)
#define REG_FRC_BK233_61_H      FRC_PK_H_(0x233, 0x61)
#define REG_FRC_BK233_62_L      FRC_PK_L_(0x233, 0x62)
#define REG_FRC_BK233_62_H      FRC_PK_H_(0x233, 0x62)
#define REG_FRC_BK233_63_L      FRC_PK_L_(0x233, 0x63)
#define REG_FRC_BK233_63_H      FRC_PK_H_(0x233, 0x63)
#define REG_FRC_BK233_64_L      FRC_PK_L_(0x233, 0x64)
#define REG_FRC_BK233_64_H      FRC_PK_H_(0x233, 0x64)
#define REG_FRC_BK233_65_L      FRC_PK_L_(0x233, 0x65)
#define REG_FRC_BK233_65_H      FRC_PK_H_(0x233, 0x65)
#define REG_FRC_BK233_66_L      FRC_PK_L_(0x233, 0x66)
#define REG_FRC_BK233_66_H      FRC_PK_H_(0x233, 0x66)
#define REG_FRC_BK233_67_L      FRC_PK_L_(0x233, 0x67)
#define REG_FRC_BK233_67_H      FRC_PK_H_(0x233, 0x67)
#define REG_FRC_BK233_68_L      FRC_PK_L_(0x233, 0x68)
#define REG_FRC_BK233_68_H      FRC_PK_H_(0x233, 0x68)
#define REG_FRC_BK233_69_L      FRC_PK_L_(0x233, 0x69)
#define REG_FRC_BK233_69_H      FRC_PK_H_(0x233, 0x69)
#define REG_FRC_BK233_6A_L      FRC_PK_L_(0x233, 0x6A)
#define REG_FRC_BK233_6A_H      FRC_PK_H_(0x233, 0x6A)
#define REG_FRC_BK233_6B_L      FRC_PK_L_(0x233, 0x6B)
#define REG_FRC_BK233_6B_H      FRC_PK_H_(0x233, 0x6B)
#define REG_FRC_BK233_6C_L      FRC_PK_L_(0x233, 0x6C)
#define REG_FRC_BK233_6C_H      FRC_PK_H_(0x233, 0x6C)
#define REG_FRC_BK233_6D_L      FRC_PK_L_(0x233, 0x6D)
#define REG_FRC_BK233_6D_H      FRC_PK_H_(0x233, 0x6D)
#define REG_FRC_BK233_6E_L      FRC_PK_L_(0x233, 0x6E)
#define REG_FRC_BK233_6E_H      FRC_PK_H_(0x233, 0x6E)
#define REG_FRC_BK233_6F_L      FRC_PK_L_(0x233, 0x6F)
#define REG_FRC_BK233_6F_H      FRC_PK_H_(0x233, 0x6F)
#define REG_FRC_BK233_70_L      FRC_PK_L_(0x233, 0x70)
#define REG_FRC_BK233_70_H      FRC_PK_H_(0x233, 0x70)
#define REG_FRC_BK233_71_L      FRC_PK_L_(0x233, 0x71)
#define REG_FRC_BK233_71_H      FRC_PK_H_(0x233, 0x71)
#define REG_FRC_BK233_72_L      FRC_PK_L_(0x233, 0x72)
#define REG_FRC_BK233_72_H      FRC_PK_H_(0x233, 0x72)
#define REG_FRC_BK233_73_L      FRC_PK_L_(0x233, 0x73)
#define REG_FRC_BK233_73_H      FRC_PK_H_(0x233, 0x73)
#define REG_FRC_BK233_74_L      FRC_PK_L_(0x233, 0x74)
#define REG_FRC_BK233_74_H      FRC_PK_H_(0x233, 0x74)
#define REG_FRC_BK233_75_L      FRC_PK_L_(0x233, 0x75)
#define REG_FRC_BK233_75_H      FRC_PK_H_(0x233, 0x75)
#define REG_FRC_BK233_76_L      FRC_PK_L_(0x233, 0x76)
#define REG_FRC_BK233_76_H      FRC_PK_H_(0x233, 0x76)
#define REG_FRC_BK233_77_L      FRC_PK_L_(0x233, 0x77)
#define REG_FRC_BK233_77_H      FRC_PK_H_(0x233, 0x77)
#define REG_FRC_BK233_78_L      FRC_PK_L_(0x233, 0x78)
#define REG_FRC_BK233_78_H      FRC_PK_H_(0x233, 0x78)
#define REG_FRC_BK233_79_L      FRC_PK_L_(0x233, 0x79)
#define REG_FRC_BK233_79_H      FRC_PK_H_(0x233, 0x79)
#define REG_FRC_BK233_7A_L      FRC_PK_L_(0x233, 0x7A)
#define REG_FRC_BK233_7A_H      FRC_PK_H_(0x233, 0x7A)
#define REG_FRC_BK233_7B_L      FRC_PK_L_(0x233, 0x7B)
#define REG_FRC_BK233_7B_H      FRC_PK_H_(0x233, 0x7B)
#define REG_FRC_BK233_7C_L      FRC_PK_L_(0x233, 0x7C)
#define REG_FRC_BK233_7C_H      FRC_PK_H_(0x233, 0x7C)
#define REG_FRC_BK233_7D_L      FRC_PK_L_(0x233, 0x7D)
#define REG_FRC_BK233_7D_H      FRC_PK_H_(0x233, 0x7D)
#define REG_FRC_BK233_7E_L      FRC_PK_L_(0x233, 0x7E)
#define REG_FRC_BK233_7E_H      FRC_PK_H_(0x233, 0x7E)
#define REG_FRC_BK233_7F_L      FRC_PK_L_(0x233, 0x7F)
#define REG_FRC_BK233_7F_H      FRC_PK_H_(0x233, 0x7F)

#define REG_FRC_BK119_02_L      FRC_PK_L_(0x119, 0x02)
#define REG_FRC_BK119_02_H      FRC_PK_H_(0x119, 0x02)
#define REG_FRC_BK119_03_L      FRC_PK_L_(0x119, 0x03)
#define REG_FRC_BK119_03_H      FRC_PK_H_(0x119, 0x03)
#define REG_FRC_BK119_04_L      FRC_PK_L_(0x119, 0x04)
#define REG_FRC_BK119_04_H      FRC_PK_H_(0x119, 0x04)
#define REG_FRC_BK119_10_L      FRC_PK_L_(0x119, 0x10)
#define REG_FRC_BK119_10_H      FRC_PK_H_(0x119, 0x10)
#define REG_FRC_BK119_1A_L      FRC_PK_L_(0x119, 0x1A)
#define REG_FRC_BK119_1A_H      FRC_PK_H_(0x119, 0x1A)
#define REG_FRC_BK119_1C_L      FRC_PK_L_(0x119, 0x1C)
#define REG_FRC_BK119_1C_H      FRC_PK_H_(0x119, 0x1C)
#define REG_FRC_BK119_2E_L      FRC_PK_L_(0x119, 0x2E)
#define REG_FRC_BK119_2E_H      FRC_PK_H_(0x119, 0x2E)
#define REG_FRC_BK119_30_L      FRC_PK_L_(0x119, 0x30)
#define REG_FRC_BK119_30_H      FRC_PK_H_(0x119, 0x30)
#define REG_FRC_BK119_32_L      FRC_PK_L_(0x119, 0x32)
#define REG_FRC_BK119_32_H      FRC_PK_H_(0x119, 0x32)
#define REG_FRC_BK119_34_L      FRC_PK_L_(0x119, 0x34)
#define REG_FRC_BK119_34_H      FRC_PK_H_(0x119, 0x34)
#define REG_FRC_BK119_36_L      FRC_PK_L_(0x119, 0x36)
#define REG_FRC_BK119_36_H      FRC_PK_H_(0x119, 0x36)
#define REG_FRC_BK119_38_L      FRC_PK_L_(0x119, 0x38)
#define REG_FRC_BK119_38_H      FRC_PK_H_(0x119, 0x38)
#define REG_FRC_BK119_3A_L      FRC_PK_L_(0x119, 0x3A)
#define REG_FRC_BK119_3A_H      FRC_PK_H_(0x119, 0x3A)
#define REG_FRC_BK119_3C_L      FRC_PK_L_(0x119, 0x3C)
#define REG_FRC_BK119_3C_H      FRC_PK_H_(0x119, 0x3C)
#define REG_FRC_BK119_3E_L      FRC_PK_L_(0x119, 0x3E)
#define REG_FRC_BK119_3E_H      FRC_PK_H_(0x119, 0x3E)
#define REG_FRC_BK119_40_L      FRC_PK_L_(0x119, 0x40)
#define REG_FRC_BK119_40_H      FRC_PK_H_(0x119, 0x40)
#define REG_FRC_BK119_42_L      FRC_PK_L_(0x119, 0x42)
#define REG_FRC_BK119_42_H      FRC_PK_H_(0x119, 0x42)
#define REG_FRC_BK119_44_L      FRC_PK_L_(0x119, 0x44)
#define REG_FRC_BK119_44_H      FRC_PK_H_(0x119, 0x44)
#define REG_FRC_BK119_47_L      FRC_PK_L_(0x119, 0x47)
#define REG_FRC_BK119_47_H      FRC_PK_H_(0x119, 0x47)

#define REG_FRC_BK121_03_L      FRC_PK_L_(0x121, 0x03)
#define REG_FRC_BK121_03_H      FRC_PK_H_(0x121, 0x03)

#define REG_FRC_BK134_01_L      FRC_PK_L_(0x134, 0x01)
#define REG_FRC_BK134_01_H      FRC_PK_H_(0x134, 0x01)
#define REG_FRC_BK134_02_L      FRC_PK_L_(0x134, 0x02)
#define REG_FRC_BK134_02_H      FRC_PK_H_(0x134, 0x02)
#define REG_FRC_BK134_07_L      FRC_PK_L_(0x134, 0x07)
#define REG_FRC_BK134_07_H      FRC_PK_H_(0x134, 0x07)
#define REG_FRC_BK134_08_L      FRC_PK_L_(0x134, 0x08)
#define REG_FRC_BK134_08_H      FRC_PK_H_(0x134, 0x08)
#define REG_FRC_BK134_09_L      FRC_PK_L_(0x134, 0x09)
#define REG_FRC_BK134_09_H      FRC_PK_H_(0x134, 0x09)
#define REG_FRC_BK134_10_L      FRC_PK_L_(0x134, 0x10)
#define REG_FRC_BK134_10_H      FRC_PK_H_(0x134, 0x10)
#define REG_FRC_BK134_11_L      FRC_PK_L_(0x134, 0x11)
#define REG_FRC_BK134_11_H      FRC_PK_H_(0x134, 0x11)
#define REG_FRC_BK134_13_L      FRC_PK_L_(0x134, 0x13)
#define REG_FRC_BK134_13_H      FRC_PK_H_(0x134, 0x13)
#define REG_FRC_BK134_47_L      FRC_PK_L_(0x134, 0x47)
#define REG_FRC_BK134_47_H      FRC_PK_H_(0x134, 0x47)
#define REG_FRC_BK134_48_L      FRC_PK_L_(0x134, 0x48)
#define REG_FRC_BK134_48_H      FRC_PK_H_(0x134, 0x48)
#define REG_FRC_BK134_49_L      FRC_PK_L_(0x134, 0x49)
#define REG_FRC_BK134_49_H      FRC_PK_H_(0x134, 0x49)
#define REG_FRC_BK134_4A_L      FRC_PK_L_(0x134, 0x4A)
#define REG_FRC_BK134_4A_H      FRC_PK_H_(0x134, 0x4A)
#define REG_FRC_BK134_4B_L      FRC_PK_L_(0x134, 0x4B)
#define REG_FRC_BK134_4B_H      FRC_PK_H_(0x134, 0x4B)
#define REG_FRC_BK134_4C_L      FRC_PK_L_(0x134, 0x4C)
#define REG_FRC_BK134_4C_H      FRC_PK_H_(0x134, 0x4C)
#define REG_FRC_BK134_4D_L      FRC_PK_L_(0x134, 0x4D)
#define REG_FRC_BK134_4D_H      FRC_PK_H_(0x134, 0x4D)

#define REG_FRC_BK136_10_L      FRC_PK_L_(0x136, 0x10)
#define REG_FRC_BK136_10_H      FRC_PK_H_(0x136, 0x10)
#define REG_FRC_BK136_11_L      FRC_PK_L_(0x136, 0x11)
#define REG_FRC_BK136_11_H      FRC_PK_H_(0x136, 0x11)

#define REG_FRC_BK13A_07_L      FRC_PK_L_(0x13A, 0x07)
#define REG_FRC_BK13A_07_H      FRC_PK_H_(0x13A, 0x07)
#define REG_FRC_BK13A_08_L      FRC_PK_L_(0x13A, 0x08)
#define REG_FRC_BK13A_08_H      FRC_PK_H_(0x13A, 0x08)
#define REG_FRC_BK13A_09_L      FRC_PK_L_(0x13A, 0x09)
#define REG_FRC_BK13A_09_H      FRC_PK_H_(0x13A, 0x09)
#define REG_FRC_BK13A_10_L      FRC_PK_L_(0x13A, 0x10)
#define REG_FRC_BK13A_10_H      FRC_PK_H_(0x13A, 0x10)
#define REG_FRC_BK13A_11_L      FRC_PK_L_(0x13A, 0x11)
#define REG_FRC_BK13A_11_H      FRC_PK_H_(0x13A, 0x11)
#define REG_FRC_BK13A_48_L      FRC_PK_L_(0x13A, 0x48)
#define REG_FRC_BK13A_48_H      FRC_PK_H_(0x13A, 0x48)
#define REG_FRC_BK13A_49_L      FRC_PK_L_(0x13A, 0x49)
#define REG_FRC_BK13A_49_H      FRC_PK_H_(0x13A, 0x49)

#define REG_FRC_BK13B_10_L      FRC_PK_L_(0x13B, 0x10)
#define REG_FRC_BK13B_10_H      FRC_PK_H_(0x13B, 0x10)
#define REG_FRC_BK13B_11_L      FRC_PK_L_(0x13B, 0x11)
#define REG_FRC_BK13B_11_H      FRC_PK_H_(0x13B, 0x11)

#define REG_FRC_BK13C_10_L      FRC_PK_L_(0x13C, 0x10)
#define REG_FRC_BK13C_10_H      FRC_PK_H_(0x13C, 0x10)
#define REG_FRC_BK13C_11_L      FRC_PK_L_(0x13C, 0x11)
#define REG_FRC_BK13C_11_H      FRC_PK_H_(0x13C, 0x11)

#define REG_FRC_BK13D_10_L      FRC_PK_L_(0x13D, 0x10)
#define REG_FRC_BK13D_10_H      FRC_PK_H_(0x13D, 0x10)
#define REG_FRC_BK13D_11_L      FRC_PK_L_(0x13D, 0x11)
#define REG_FRC_BK13D_11_H      FRC_PK_H_(0x13D, 0x11)

#define REG_FRC_BK242_08_L      FRC_PK_L_(0x242, 0x08)
#define REG_FRC_BK242_08_H      FRC_PK_H_(0x242, 0x08)
#define REG_FRC_BK242_09_L      FRC_PK_L_(0x242, 0x09)
#define REG_FRC_BK242_09_H      FRC_PK_H_(0x242, 0x09)
#define REG_FRC_BK242_0C_L      FRC_PK_L_(0x242, 0x0C)
#define REG_FRC_BK242_0C_H      FRC_PK_H_(0x242, 0x0C)
#define REG_FRC_BK242_0D_L      FRC_PK_L_(0x242, 0x0D)
#define REG_FRC_BK242_0D_H      FRC_PK_H_(0x242, 0x0D)
#define REG_FRC_BK242_10_L      FRC_PK_L_(0x242, 0x10)
#define REG_FRC_BK242_10_H      FRC_PK_H_(0x242, 0x10)
#define REG_FRC_BK242_11_L      FRC_PK_L_(0x242, 0x11)
#define REG_FRC_BK242_11_H      FRC_PK_H_(0x242, 0x11)
#define REG_FRC_BK242_14_L      FRC_PK_L_(0x242, 0x14)
#define REG_FRC_BK242_14_H      FRC_PK_H_(0x242, 0x14)
#define REG_FRC_BK242_15_L      FRC_PK_L_(0x242, 0x15)
#define REG_FRC_BK242_15_H      FRC_PK_H_(0x242, 0x15)
#define REG_FRC_BK242_18_L      FRC_PK_L_(0x242, 0x18)
#define REG_FRC_BK242_18_H      FRC_PK_H_(0x242, 0x18)
#define REG_FRC_BK242_19_L      FRC_PK_L_(0x242, 0x19)
#define REG_FRC_BK242_19_H      FRC_PK_H_(0x242, 0x19)

#define REG_FRC_BK252_08_L      FRC_PK_L_(0x252, 0x08)
#define REG_FRC_BK252_08_H      FRC_PK_H_(0x252, 0x08)
#define REG_FRC_BK252_09_L      FRC_PK_L_(0x252, 0x09)
#define REG_FRC_BK252_09_H      FRC_PK_H_(0x252, 0x09)
#define REG_FRC_BK252_10_L      FRC_PK_L_(0x252, 0x10)
#define REG_FRC_BK252_10_H      FRC_PK_H_(0x252, 0x10)
#define REG_FRC_BK252_11_L      FRC_PK_L_(0x252, 0x11)
#define REG_FRC_BK252_11_H      FRC_PK_H_(0x252, 0x11)
#define REG_FRC_BK252_18_L      FRC_PK_L_(0x252, 0x18)
#define REG_FRC_BK252_18_H      FRC_PK_H_(0x252, 0x18)
#define REG_FRC_BK252_19_L      FRC_PK_L_(0x252, 0x19)
#define REG_FRC_BK252_19_H      FRC_PK_H_(0x252, 0x19)

#define REG_FRC_BK253_5A_L      FRC_PK_L_(0x253, 0x5A)
#define REG_FRC_BK253_5A_H      FRC_PK_H_(0x253, 0x5A)

#define REG_FRC_BK300_02_L      FRC_PK_L_(0x300, 0x02)
#define REG_FRC_BK300_02_H      FRC_PK_H_(0x300, 0x02)

#define REG_FRC_BK30D_10_L      FRC_PK_L_(0x30D, 0x10)
#define REG_FRC_BK30D_10_H      FRC_PK_H_(0x30D, 0x10)
#define REG_FRC_BK30D_11_L      FRC_PK_L_(0x30D, 0x11)
#define REG_FRC_BK30D_11_H      FRC_PK_H_(0x30D, 0x11)
#define REG_FRC_BK30D_20_L      FRC_PK_L_(0x30D, 0x20)
#define REG_FRC_BK30D_20_H      FRC_PK_H_(0x30D, 0x20)
#define REG_FRC_BK30D_22_L      FRC_PK_L_(0x30D, 0x22)
#define REG_FRC_BK30D_22_H      FRC_PK_H_(0x30D, 0x22)
#define REG_FRC_BK30D_24_L      FRC_PK_L_(0x30D, 0x24)
#define REG_FRC_BK30D_24_H      FRC_PK_H_(0x30D, 0x24)
#define REG_FRC_BK30D_26_L      FRC_PK_L_(0x30D, 0x26)
#define REG_FRC_BK30D_26_H      FRC_PK_H_(0x30D, 0x26)
#define REG_FRC_BK30D_28_L      FRC_PK_L_(0x30D, 0x28)
#define REG_FRC_BK30D_28_H      FRC_PK_H_(0x30D, 0x28)
#define REG_FRC_BK30D_2A_L      FRC_PK_L_(0x30D, 0x2A)
#define REG_FRC_BK30D_2A_H      FRC_PK_H_(0x30D, 0x2A)
#define REG_FRC_BK30D_2C_L      FRC_PK_L_(0x30D, 0x2C)
#define REG_FRC_BK30D_2C_H      FRC_PK_H_(0x30D, 0x2C)
#define REG_FRC_BK30D_2E_L      FRC_PK_L_(0x30D, 0x2E)
#define REG_FRC_BK30D_2E_H      FRC_PK_H_(0x30D, 0x2E)

#if 0
// === FRC bk16 -> bk4216
#define REG_FRC_BK216_00        (REG_FRC_BANK_BASE+0x21600)
#define REG_FRC_BK216_01        (REG_FRC_BANK_BASE+0x21601)
#define REG_FRC_BK216_02        (REG_FRC_BANK_BASE+0x21602)
#define REG_FRC_BK216_03        (REG_FRC_BANK_BASE+0x21603)
#define REG_FRC_BK216_04        (REG_FRC_BANK_BASE+0x21604)
#define REG_FRC_BK216_05        (REG_FRC_BANK_BASE+0x21605)
#define REG_FRC_BK216_06        (REG_FRC_BANK_BASE+0x21606)
#define REG_FRC_BK216_07        (REG_FRC_BANK_BASE+0x21607)
#define REG_FRC_BK216_08        (REG_FRC_BANK_BASE+0x21608)
#define REG_FRC_BK216_09        (REG_FRC_BANK_BASE+0x21609)
#define REG_FRC_BK216_0A        (REG_FRC_BANK_BASE+0x2160A)
#define REG_FRC_BK216_0B        (REG_FRC_BANK_BASE+0x2160B)
#define REG_FRC_BK216_0C        (REG_FRC_BANK_BASE+0x2160C)
#define REG_FRC_BK216_0D        (REG_FRC_BANK_BASE+0x2160D)
#define REG_FRC_BK216_0E        (REG_FRC_BANK_BASE+0x2160E)
#define REG_FRC_BK216_0F        (REG_FRC_BANK_BASE+0x2160F)
#define REG_FRC_BK216_10        (REG_FRC_BANK_BASE+0x21610)
#define REG_FRC_BK216_11        (REG_FRC_BANK_BASE+0x21611)
#define REG_FRC_BK216_12        (REG_FRC_BANK_BASE+0x21612)
#define REG_FRC_BK216_13        (REG_FRC_BANK_BASE+0x21613)
#define REG_FRC_BK216_14        (REG_FRC_BANK_BASE+0x21614)
#define REG_FRC_BK216_15        (REG_FRC_BANK_BASE+0x21615)
#define REG_FRC_BK216_16        (REG_FRC_BANK_BASE+0x21616)
#define REG_FRC_BK216_17        (REG_FRC_BANK_BASE+0x21617)
#define REG_FRC_BK216_18        (REG_FRC_BANK_BASE+0x21618)
#define REG_FRC_BK216_19        (REG_FRC_BANK_BASE+0x21619)
#define REG_FRC_BK216_1A        (REG_FRC_BANK_BASE+0x2161A)
#define REG_FRC_BK216_1B        (REG_FRC_BANK_BASE+0x2161B)
#define REG_FRC_BK216_1C        (REG_FRC_BANK_BASE+0x2161C)
#define REG_FRC_BK216_1D        (REG_FRC_BANK_BASE+0x2161D)
#define REG_FRC_BK216_1E        (REG_FRC_BANK_BASE+0x2161E)
#define REG_FRC_BK216_1F        (REG_FRC_BANK_BASE+0x2161F)
#define REG_FRC_BK216_20        (REG_FRC_BANK_BASE+0x21620)
#define REG_FRC_BK216_21        (REG_FRC_BANK_BASE+0x21621)
#define REG_FRC_BK216_22        (REG_FRC_BANK_BASE+0x21622)
#define REG_FRC_BK216_23        (REG_FRC_BANK_BASE+0x21623)
#define REG_FRC_BK216_24        (REG_FRC_BANK_BASE+0x21624)
#define REG_FRC_BK216_25        (REG_FRC_BANK_BASE+0x21625)
#define REG_FRC_BK216_26        (REG_FRC_BANK_BASE+0x21626)
#define REG_FRC_BK216_27        (REG_FRC_BANK_BASE+0x21627)
#define REG_FRC_BK216_28        (REG_FRC_BANK_BASE+0x21628)
#define REG_FRC_BK216_29        (REG_FRC_BANK_BASE+0x21629)
#define REG_FRC_BK216_2A        (REG_FRC_BANK_BASE+0x2162A)
#define REG_FRC_BK216_2B        (REG_FRC_BANK_BASE+0x2162B)
#define REG_FRC_BK216_2C        (REG_FRC_BANK_BASE+0x2162C)
#define REG_FRC_BK216_2D        (REG_FRC_BANK_BASE+0x2162D)
#define REG_FRC_BK216_2E        (REG_FRC_BANK_BASE+0x2162E)
#define REG_FRC_BK216_2F        (REG_FRC_BANK_BASE+0x2162F)
#define REG_FRC_BK216_30        (REG_FRC_BANK_BASE+0x21630)
#define REG_FRC_BK216_31        (REG_FRC_BANK_BASE+0x21631)
#define REG_FRC_BK216_32        (REG_FRC_BANK_BASE+0x21632)
#define REG_FRC_BK216_33        (REG_FRC_BANK_BASE+0x21633)
#define REG_FRC_BK216_34        (REG_FRC_BANK_BASE+0x21634)
#define REG_FRC_BK216_35        (REG_FRC_BANK_BASE+0x21635)
#define REG_FRC_BK216_36        (REG_FRC_BANK_BASE+0x21636)
#define REG_FRC_BK216_37        (REG_FRC_BANK_BASE+0x21637)
#define REG_FRC_BK216_38        (REG_FRC_BANK_BASE+0x21638)
#define REG_FRC_BK216_39        (REG_FRC_BANK_BASE+0x21639)
#define REG_FRC_BK216_3A        (REG_FRC_BANK_BASE+0x2163A)
#define REG_FRC_BK216_3B        (REG_FRC_BANK_BASE+0x2163B)
#define REG_FRC_BK216_3C        (REG_FRC_BANK_BASE+0x2163C)
#define REG_FRC_BK216_3D        (REG_FRC_BANK_BASE+0x2163D)
#define REG_FRC_BK216_3E        (REG_FRC_BANK_BASE+0x2163E)
#define REG_FRC_BK216_3F        (REG_FRC_BANK_BASE+0x2163F)
#define REG_FRC_BK216_40        (REG_FRC_BANK_BASE+0x21640)
#define REG_FRC_BK216_41        (REG_FRC_BANK_BASE+0x21641)
#define REG_FRC_BK216_42        (REG_FRC_BANK_BASE+0x21642)
#define REG_FRC_BK216_43        (REG_FRC_BANK_BASE+0x21643)
#define REG_FRC_BK216_44        (REG_FRC_BANK_BASE+0x21644)
#define REG_FRC_BK216_45        (REG_FRC_BANK_BASE+0x21645)
#define REG_FRC_BK216_46        (REG_FRC_BANK_BASE+0x21646)
#define REG_FRC_BK216_47        (REG_FRC_BANK_BASE+0x21647)
#define REG_FRC_BK216_48        (REG_FRC_BANK_BASE+0x21648)
#define REG_FRC_BK216_49        (REG_FRC_BANK_BASE+0x21649)
#define REG_FRC_BK216_4A        (REG_FRC_BANK_BASE+0x2164A)
#define REG_FRC_BK216_4B        (REG_FRC_BANK_BASE+0x2164B)
#define REG_FRC_BK216_4C        (REG_FRC_BANK_BASE+0x2164C)
#define REG_FRC_BK216_4D        (REG_FRC_BANK_BASE+0x2164D)
#define REG_FRC_BK216_4E        (REG_FRC_BANK_BASE+0x2164E)
#define REG_FRC_BK216_4F        (REG_FRC_BANK_BASE+0x2164F)
#define REG_FRC_BK216_50        (REG_FRC_BANK_BASE+0x21650)
#define REG_FRC_BK216_51        (REG_FRC_BANK_BASE+0x21651)
#define REG_FRC_BK216_52        (REG_FRC_BANK_BASE+0x21652)
#define REG_FRC_BK216_53        (REG_FRC_BANK_BASE+0x21653)
#define REG_FRC_BK216_54        (REG_FRC_BANK_BASE+0x21654)
#define REG_FRC_BK216_55        (REG_FRC_BANK_BASE+0x21655)
#define REG_FRC_BK216_56        (REG_FRC_BANK_BASE+0x21656)
#define REG_FRC_BK216_57        (REG_FRC_BANK_BASE+0x21657)
#define REG_FRC_BK216_58        (REG_FRC_BANK_BASE+0x21658)
#define REG_FRC_BK216_59        (REG_FRC_BANK_BASE+0x21659)
#define REG_FRC_BK216_5A        (REG_FRC_BANK_BASE+0x2165A)
#define REG_FRC_BK216_5B        (REG_FRC_BANK_BASE+0x2165B)
#define REG_FRC_BK216_5C        (REG_FRC_BANK_BASE+0x2165C)
#define REG_FRC_BK216_5D        (REG_FRC_BANK_BASE+0x2165D)
#define REG_FRC_BK216_5E        (REG_FRC_BANK_BASE+0x2165E)
#define REG_FRC_BK216_5F        (REG_FRC_BANK_BASE+0x2165F)
#define REG_FRC_BK216_60        (REG_FRC_BANK_BASE+0x21660)
#define REG_FRC_BK216_61        (REG_FRC_BANK_BASE+0x21661)
#define REG_FRC_BK216_62        (REG_FRC_BANK_BASE+0x21662)
#define REG_FRC_BK216_63        (REG_FRC_BANK_BASE+0x21663)
#define REG_FRC_BK216_64        (REG_FRC_BANK_BASE+0x21664)
#define REG_FRC_BK216_65        (REG_FRC_BANK_BASE+0x21665)
#define REG_FRC_BK216_66        (REG_FRC_BANK_BASE+0x21666)
#define REG_FRC_BK216_67        (REG_FRC_BANK_BASE+0x21667)
#define REG_FRC_BK216_68        (REG_FRC_BANK_BASE+0x21668)
#define REG_FRC_BK216_69        (REG_FRC_BANK_BASE+0x21669)
#define REG_FRC_BK216_6A        (REG_FRC_BANK_BASE+0x2166A)
#define REG_FRC_BK216_6B        (REG_FRC_BANK_BASE+0x2166B)
#define REG_FRC_BK216_6C        (REG_FRC_BANK_BASE+0x2166C)
#define REG_FRC_BK216_6D        (REG_FRC_BANK_BASE+0x2166D)
#define REG_FRC_BK216_6E        (REG_FRC_BANK_BASE+0x2166E)
#define REG_FRC_BK216_6F        (REG_FRC_BANK_BASE+0x2166F)
#define REG_FRC_BK216_70        (REG_FRC_BANK_BASE+0x21670)
#define REG_FRC_BK216_71        (REG_FRC_BANK_BASE+0x21671)
#define REG_FRC_BK216_72        (REG_FRC_BANK_BASE+0x21672)
#define REG_FRC_BK216_73        (REG_FRC_BANK_BASE+0x21673)
#define REG_FRC_BK216_74        (REG_FRC_BANK_BASE+0x21674)
#define REG_FRC_BK216_75        (REG_FRC_BANK_BASE+0x21675)
#define REG_FRC_BK216_76        (REG_FRC_BANK_BASE+0x21676)
#define REG_FRC_BK216_77        (REG_FRC_BANK_BASE+0x21677)
#define REG_FRC_BK216_78        (REG_FRC_BANK_BASE+0x21678)
#define REG_FRC_BK216_79        (REG_FRC_BANK_BASE+0x21679)
#define REG_FRC_BK216_7A        (REG_FRC_BANK_BASE+0x2167A)
#define REG_FRC_BK216_7B        (REG_FRC_BANK_BASE+0x2167B)
#define REG_FRC_BK216_7C        (REG_FRC_BANK_BASE+0x2167C)
#define REG_FRC_BK216_7D        (REG_FRC_BANK_BASE+0x2167D)
#define REG_FRC_BK216_7E        (REG_FRC_BANK_BASE+0x2167E)
#define REG_FRC_BK216_7F        (REG_FRC_BANK_BASE+0x2167F)
#define REG_FRC_BK216_80        (REG_FRC_BANK_BASE+0x21680)
#define REG_FRC_BK216_81        (REG_FRC_BANK_BASE+0x21681)
#define REG_FRC_BK216_82        (REG_FRC_BANK_BASE+0x21682)
#define REG_FRC_BK216_83        (REG_FRC_BANK_BASE+0x21683)
#define REG_FRC_BK216_84        (REG_FRC_BANK_BASE+0x21684)
#define REG_FRC_BK216_85        (REG_FRC_BANK_BASE+0x21685)
#define REG_FRC_BK216_86        (REG_FRC_BANK_BASE+0x21686)
#define REG_FRC_BK216_87        (REG_FRC_BANK_BASE+0x21687)
#define REG_FRC_BK216_88        (REG_FRC_BANK_BASE+0x21688)
#define REG_FRC_BK216_89        (REG_FRC_BANK_BASE+0x21689)
#define REG_FRC_BK216_8A        (REG_FRC_BANK_BASE+0x2168A)
#define REG_FRC_BK216_8B        (REG_FRC_BANK_BASE+0x2168B)
#define REG_FRC_BK216_8C        (REG_FRC_BANK_BASE+0x2168C)
#define REG_FRC_BK216_8D        (REG_FRC_BANK_BASE+0x2168D)
#define REG_FRC_BK216_8E        (REG_FRC_BANK_BASE+0x2168E)
#define REG_FRC_BK216_8F        (REG_FRC_BANK_BASE+0x2168F)
#define REG_FRC_BK216_90        (REG_FRC_BANK_BASE+0x21690)
#define REG_FRC_BK216_91        (REG_FRC_BANK_BASE+0x21691)
#define REG_FRC_BK216_92        (REG_FRC_BANK_BASE+0x21692)
#define REG_FRC_BK216_93        (REG_FRC_BANK_BASE+0x21693)
#define REG_FRC_BK216_94        (REG_FRC_BANK_BASE+0x21694)
#define REG_FRC_BK216_95        (REG_FRC_BANK_BASE+0x21695)
#define REG_FRC_BK216_96        (REG_FRC_BANK_BASE+0x21696)
#define REG_FRC_BK216_97        (REG_FRC_BANK_BASE+0x21697)
#define REG_FRC_BK216_98        (REG_FRC_BANK_BASE+0x21698)
#define REG_FRC_BK216_99        (REG_FRC_BANK_BASE+0x21699)
#define REG_FRC_BK216_9A        (REG_FRC_BANK_BASE+0x2169A)
#define REG_FRC_BK216_9B        (REG_FRC_BANK_BASE+0x2169B)
#define REG_FRC_BK216_9C        (REG_FRC_BANK_BASE+0x2169C)
#define REG_FRC_BK216_9D        (REG_FRC_BANK_BASE+0x2169D)
#define REG_FRC_BK216_9E        (REG_FRC_BANK_BASE+0x2169E)
#define REG_FRC_BK216_9F        (REG_FRC_BANK_BASE+0x2169F)
#define REG_FRC_BK216_A0        (REG_FRC_BANK_BASE+0x216A0)
#define REG_FRC_BK216_A1        (REG_FRC_BANK_BASE+0x216A1)
#define REG_FRC_BK216_A2        (REG_FRC_BANK_BASE+0x216A2)
#define REG_FRC_BK216_A3        (REG_FRC_BANK_BASE+0x216A3)
#define REG_FRC_BK216_A4        (REG_FRC_BANK_BASE+0x216A4)
#define REG_FRC_BK216_A5        (REG_FRC_BANK_BASE+0x216A5)
#define REG_FRC_BK216_A6        (REG_FRC_BANK_BASE+0x216A6)
#define REG_FRC_BK216_A7        (REG_FRC_BANK_BASE+0x216A7)
#define REG_FRC_BK216_A8        (REG_FRC_BANK_BASE+0x216A8)
#define REG_FRC_BK216_A9        (REG_FRC_BANK_BASE+0x216A9)
#define REG_FRC_BK216_AA        (REG_FRC_BANK_BASE+0x216AA)
#define REG_FRC_BK216_AB        (REG_FRC_BANK_BASE+0x216AB)
#define REG_FRC_BK216_AC        (REG_FRC_BANK_BASE+0x216AC)
#define REG_FRC_BK216_AD        (REG_FRC_BANK_BASE+0x216AD)
#define REG_FRC_BK216_AE        (REG_FRC_BANK_BASE+0x216AE)
#define REG_FRC_BK216_AF        (REG_FRC_BANK_BASE+0x216AF)
#define REG_FRC_BK216_B0        (REG_FRC_BANK_BASE+0x216B0)
#define REG_FRC_BK216_B1        (REG_FRC_BANK_BASE+0x216B1)
#define REG_FRC_BK216_B2        (REG_FRC_BANK_BASE+0x216B2)
#define REG_FRC_BK216_B3        (REG_FRC_BANK_BASE+0x216B3)
#define REG_FRC_BK216_B4        (REG_FRC_BANK_BASE+0x216B4)
#define REG_FRC_BK216_B5        (REG_FRC_BANK_BASE+0x216B5)
#define REG_FRC_BK216_B6        (REG_FRC_BANK_BASE+0x216B6)
#define REG_FRC_BK216_B7        (REG_FRC_BANK_BASE+0x216B7)
#define REG_FRC_BK216_B8        (REG_FRC_BANK_BASE+0x216B8)
#define REG_FRC_BK216_B9        (REG_FRC_BANK_BASE+0x216B9)
#define REG_FRC_BK216_BA        (REG_FRC_BANK_BASE+0x216BA)
#define REG_FRC_BK216_BB        (REG_FRC_BANK_BASE+0x216BB)
#define REG_FRC_BK216_BC        (REG_FRC_BANK_BASE+0x216BC)
#define REG_FRC_BK216_BD        (REG_FRC_BANK_BASE+0x216BD)
#define REG_FRC_BK216_BE        (REG_FRC_BANK_BASE+0x216BE)
#define REG_FRC_BK216_BF        (REG_FRC_BANK_BASE+0x216BF)
#define REG_FRC_BK216_C0        (REG_FRC_BANK_BASE+0x216C0)
#define REG_FRC_BK216_C1        (REG_FRC_BANK_BASE+0x216C1)
#define REG_FRC_BK216_C2        (REG_FRC_BANK_BASE+0x216C2)
#define REG_FRC_BK216_C3        (REG_FRC_BANK_BASE+0x216C3)
#define REG_FRC_BK216_C4        (REG_FRC_BANK_BASE+0x216C4)
#define REG_FRC_BK216_C5        (REG_FRC_BANK_BASE+0x216C5)
#define REG_FRC_BK216_C6        (REG_FRC_BANK_BASE+0x216C6)
#define REG_FRC_BK216_C7        (REG_FRC_BANK_BASE+0x216C7)
#define REG_FRC_BK216_C8        (REG_FRC_BANK_BASE+0x216C8)
#define REG_FRC_BK216_C9        (REG_FRC_BANK_BASE+0x216C9)
#define REG_FRC_BK216_CA        (REG_FRC_BANK_BASE+0x216CA)
#define REG_FRC_BK216_CB        (REG_FRC_BANK_BASE+0x216CB)
#define REG_FRC_BK216_CC        (REG_FRC_BANK_BASE+0x216CC)
#define REG_FRC_BK216_CD        (REG_FRC_BANK_BASE+0x216CD)
#define REG_FRC_BK216_CE        (REG_FRC_BANK_BASE+0x216CE)
#define REG_FRC_BK216_CF        (REG_FRC_BANK_BASE+0x216CF)
#define REG_FRC_BK216_D0        (REG_FRC_BANK_BASE+0x216D0)
#define REG_FRC_BK216_D1        (REG_FRC_BANK_BASE+0x216D1)
#define REG_FRC_BK216_D2        (REG_FRC_BANK_BASE+0x216D2)
#define REG_FRC_BK216_D3        (REG_FRC_BANK_BASE+0x216D3)
#define REG_FRC_BK216_D4        (REG_FRC_BANK_BASE+0x216D4)
#define REG_FRC_BK216_D5        (REG_FRC_BANK_BASE+0x216D5)
#define REG_FRC_BK216_D6        (REG_FRC_BANK_BASE+0x216D6)
#define REG_FRC_BK216_D7        (REG_FRC_BANK_BASE+0x216D7)
#define REG_FRC_BK216_D8        (REG_FRC_BANK_BASE+0x216D8)
#define REG_FRC_BK216_D9        (REG_FRC_BANK_BASE+0x216D9)
#define REG_FRC_BK216_DA        (REG_FRC_BANK_BASE+0x216DA)
#define REG_FRC_BK216_DB        (REG_FRC_BANK_BASE+0x216DB)
#define REG_FRC_BK216_DC        (REG_FRC_BANK_BASE+0x216DC)
#define REG_FRC_BK216_DD        (REG_FRC_BANK_BASE+0x216DD)
#define REG_FRC_BK216_DE        (REG_FRC_BANK_BASE+0x216DE)
#define REG_FRC_BK216_DF        (REG_FRC_BANK_BASE+0x216DF)
#define REG_FRC_BK216_E0        (REG_FRC_BANK_BASE+0x216E0)
#define REG_FRC_BK216_E1        (REG_FRC_BANK_BASE+0x216E1)
#define REG_FRC_BK216_E2        (REG_FRC_BANK_BASE+0x216E2)
#define REG_FRC_BK216_E3        (REG_FRC_BANK_BASE+0x216E3)
#define REG_FRC_BK216_E4        (REG_FRC_BANK_BASE+0x216E4)
#define REG_FRC_BK216_E5        (REG_FRC_BANK_BASE+0x216E5)
#define REG_FRC_BK216_E6        (REG_FRC_BANK_BASE+0x216E6)
#define REG_FRC_BK216_E7        (REG_FRC_BANK_BASE+0x216E7)
#define REG_FRC_BK216_E8        (REG_FRC_BANK_BASE+0x216E8)
#define REG_FRC_BK216_E9        (REG_FRC_BANK_BASE+0x216E9)
#define REG_FRC_BK216_EA        (REG_FRC_BANK_BASE+0x216EA)
#define REG_FRC_BK216_EB        (REG_FRC_BANK_BASE+0x216EB)
#define REG_FRC_BK216_EC        (REG_FRC_BANK_BASE+0x216EC)
#define REG_FRC_BK216_ED        (REG_FRC_BANK_BASE+0x216ED)
#define REG_FRC_BK216_EE        (REG_FRC_BANK_BASE+0x216EE)
#define REG_FRC_BK216_EF        (REG_FRC_BANK_BASE+0x216EF)
#define REG_FRC_BK216_F0        (REG_FRC_BANK_BASE+0x216F0)
#define REG_FRC_BK216_F1        (REG_FRC_BANK_BASE+0x216F1)
#define REG_FRC_BK216_F2        (REG_FRC_BANK_BASE+0x216F2)
#define REG_FRC_BK216_F3        (REG_FRC_BANK_BASE+0x216F3)
#define REG_FRC_BK216_F4        (REG_FRC_BANK_BASE+0x216F4)
#define REG_FRC_BK216_F5        (REG_FRC_BANK_BASE+0x216F5)
#define REG_FRC_BK216_F6        (REG_FRC_BANK_BASE+0x216F6)
#define REG_FRC_BK216_F7        (REG_FRC_BANK_BASE+0x216F7)
#define REG_FRC_BK216_F8        (REG_FRC_BANK_BASE+0x216F8)
#define REG_FRC_BK216_F9        (REG_FRC_BANK_BASE+0x216F9)
#define REG_FRC_BK216_FA        (REG_FRC_BANK_BASE+0x216FA)
#define REG_FRC_BK216_FB        (REG_FRC_BANK_BASE+0x216FB)
#define REG_FRC_BK216_FC        (REG_FRC_BANK_BASE+0x216FC)
#define REG_FRC_BK216_FD        (REG_FRC_BANK_BASE+0x216FD)
#define REG_FRC_BK216_FE        (REG_FRC_BANK_BASE+0x216FE)
#define REG_FRC_BK216_FF        (REG_FRC_BANK_BASE+0x216FF)
#endif

// === FRC bk26 -> 0x4226
#define REG_FRC_BK226_00        (REG_FRC_BANK_BASE+0x22600)
#define REG_FRC_BK226_01        (REG_FRC_BANK_BASE+0x22601)
#define REG_FRC_BK226_02        (REG_FRC_BANK_BASE+0x22602)
#define REG_FRC_BK226_03        (REG_FRC_BANK_BASE+0x22603)
#define REG_FRC_BK226_04        (REG_FRC_BANK_BASE+0x22604)
#define REG_FRC_BK226_05        (REG_FRC_BANK_BASE+0x22605)
#define REG_FRC_BK226_06        (REG_FRC_BANK_BASE+0x22606)
#define REG_FRC_BK226_07        (REG_FRC_BANK_BASE+0x22607)
#define REG_FRC_BK226_08        (REG_FRC_BANK_BASE+0x22608)
#define REG_FRC_BK226_09        (REG_FRC_BANK_BASE+0x22609)
#define REG_FRC_BK226_0A        (REG_FRC_BANK_BASE+0x2260A)
#define REG_FRC_BK226_0B        (REG_FRC_BANK_BASE+0x2260B)
#define REG_FRC_BK226_0C        (REG_FRC_BANK_BASE+0x2260C)
#define REG_FRC_BK226_0D        (REG_FRC_BANK_BASE+0x2260D)
#define REG_FRC_BK226_0E        (REG_FRC_BANK_BASE+0x2260E)
#define REG_FRC_BK226_0F        (REG_FRC_BANK_BASE+0x2260F)
#define REG_FRC_BK226_10        (REG_FRC_BANK_BASE+0x22610)
#define REG_FRC_BK226_11        (REG_FRC_BANK_BASE+0x22611)
#define REG_FRC_BK226_12        (REG_FRC_BANK_BASE+0x22612)
#define REG_FRC_BK226_13        (REG_FRC_BANK_BASE+0x22613)
#define REG_FRC_BK226_14        (REG_FRC_BANK_BASE+0x22614)
#define REG_FRC_BK226_15        (REG_FRC_BANK_BASE+0x22615)
#define REG_FRC_BK226_16        (REG_FRC_BANK_BASE+0x22616)
#define REG_FRC_BK226_17        (REG_FRC_BANK_BASE+0x22617)
#define REG_FRC_BK226_18        (REG_FRC_BANK_BASE+0x22618)
#define REG_FRC_BK226_19        (REG_FRC_BANK_BASE+0x22619)
#define REG_FRC_BK226_1A        (REG_FRC_BANK_BASE+0x2261A)
#define REG_FRC_BK226_1B        (REG_FRC_BANK_BASE+0x2261B)
#define REG_FRC_BK226_1C        (REG_FRC_BANK_BASE+0x2261C)
#define REG_FRC_BK226_1D        (REG_FRC_BANK_BASE+0x2261D)
#define REG_FRC_BK226_1E        (REG_FRC_BANK_BASE+0x2261E)
#define REG_FRC_BK226_1F        (REG_FRC_BANK_BASE+0x2261F)
#define REG_FRC_BK226_20        (REG_FRC_BANK_BASE+0x22620)
#define REG_FRC_BK226_21        (REG_FRC_BANK_BASE+0x22621)
#define REG_FRC_BK226_22        (REG_FRC_BANK_BASE+0x22622)
#define REG_FRC_BK226_23        (REG_FRC_BANK_BASE+0x22623)
#define REG_FRC_BK226_24        (REG_FRC_BANK_BASE+0x22624)
#define REG_FRC_BK226_25        (REG_FRC_BANK_BASE+0x22625)
#define REG_FRC_BK226_26        (REG_FRC_BANK_BASE+0x22626)
#define REG_FRC_BK226_27        (REG_FRC_BANK_BASE+0x22627)
#define REG_FRC_BK226_28        (REG_FRC_BANK_BASE+0x22628)
#define REG_FRC_BK226_29        (REG_FRC_BANK_BASE+0x22629)
#define REG_FRC_BK226_2A        (REG_FRC_BANK_BASE+0x2262A)
#define REG_FRC_BK226_2B        (REG_FRC_BANK_BASE+0x2262B)
#define REG_FRC_BK226_2C        (REG_FRC_BANK_BASE+0x2262C)
#define REG_FRC_BK226_2D        (REG_FRC_BANK_BASE+0x2262D)
#define REG_FRC_BK226_2E        (REG_FRC_BANK_BASE+0x2262E)
#define REG_FRC_BK226_2F        (REG_FRC_BANK_BASE+0x2262F)
#define REG_FRC_BK226_30        (REG_FRC_BANK_BASE+0x22630)
#define REG_FRC_BK226_31        (REG_FRC_BANK_BASE+0x22631)
#define REG_FRC_BK226_32        (REG_FRC_BANK_BASE+0x22632)
#define REG_FRC_BK226_33        (REG_FRC_BANK_BASE+0x22633)
#define REG_FRC_BK226_34        (REG_FRC_BANK_BASE+0x22634)
#define REG_FRC_BK226_35        (REG_FRC_BANK_BASE+0x22635)
#define REG_FRC_BK226_36        (REG_FRC_BANK_BASE+0x22636)
#define REG_FRC_BK226_37        (REG_FRC_BANK_BASE+0x22637)
#define REG_FRC_BK226_38        (REG_FRC_BANK_BASE+0x22638)
#define REG_FRC_BK226_39        (REG_FRC_BANK_BASE+0x22639)
#define REG_FRC_BK226_3A        (REG_FRC_BANK_BASE+0x2263A)
#define REG_FRC_BK226_3B        (REG_FRC_BANK_BASE+0x2263B)
#define REG_FRC_BK226_3C        (REG_FRC_BANK_BASE+0x2263C)
#define REG_FRC_BK226_3D        (REG_FRC_BANK_BASE+0x2263D)
#define REG_FRC_BK226_3E        (REG_FRC_BANK_BASE+0x2263E)
#define REG_FRC_BK226_3F        (REG_FRC_BANK_BASE+0x2263F)
#define REG_FRC_BK226_40        (REG_FRC_BANK_BASE+0x22640)
#define REG_FRC_BK226_41        (REG_FRC_BANK_BASE+0x22641)
#define REG_FRC_BK226_42        (REG_FRC_BANK_BASE+0x22642)
#define REG_FRC_BK226_43        (REG_FRC_BANK_BASE+0x22643)
#define REG_FRC_BK226_44        (REG_FRC_BANK_BASE+0x22644)
#define REG_FRC_BK226_45        (REG_FRC_BANK_BASE+0x22645)
#define REG_FRC_BK226_46        (REG_FRC_BANK_BASE+0x22646)
#define REG_FRC_BK226_47        (REG_FRC_BANK_BASE+0x22647)
#define REG_FRC_BK226_48        (REG_FRC_BANK_BASE+0x22648)
#define REG_FRC_BK226_49        (REG_FRC_BANK_BASE+0x22649)
#define REG_FRC_BK226_4A        (REG_FRC_BANK_BASE+0x2264A)
#define REG_FRC_BK226_4B        (REG_FRC_BANK_BASE+0x2264B)
#define REG_FRC_BK226_4C        (REG_FRC_BANK_BASE+0x2264C)
#define REG_FRC_BK226_4D        (REG_FRC_BANK_BASE+0x2264D)
#define REG_FRC_BK226_4E        (REG_FRC_BANK_BASE+0x2264E)
#define REG_FRC_BK226_4F        (REG_FRC_BANK_BASE+0x2264F)
#define REG_FRC_BK226_50        (REG_FRC_BANK_BASE+0x22650)
#define REG_FRC_BK226_51        (REG_FRC_BANK_BASE+0x22651)
#define REG_FRC_BK226_52        (REG_FRC_BANK_BASE+0x22652)
#define REG_FRC_BK226_53        (REG_FRC_BANK_BASE+0x22653)
#define REG_FRC_BK226_54        (REG_FRC_BANK_BASE+0x22654)
#define REG_FRC_BK226_55        (REG_FRC_BANK_BASE+0x22655)
#define REG_FRC_BK226_56        (REG_FRC_BANK_BASE+0x22656)
#define REG_FRC_BK226_57        (REG_FRC_BANK_BASE+0x22657)
#define REG_FRC_BK226_58        (REG_FRC_BANK_BASE+0x22658)
#define REG_FRC_BK226_59        (REG_FRC_BANK_BASE+0x22659)
#define REG_FRC_BK226_5A        (REG_FRC_BANK_BASE+0x2265A)
#define REG_FRC_BK226_5B        (REG_FRC_BANK_BASE+0x2265B)
#define REG_FRC_BK226_5C        (REG_FRC_BANK_BASE+0x2265C)
#define REG_FRC_BK226_5D        (REG_FRC_BANK_BASE+0x2265D)
#define REG_FRC_BK226_5E        (REG_FRC_BANK_BASE+0x2265E)
#define REG_FRC_BK226_5F        (REG_FRC_BANK_BASE+0x2265F)
#define REG_FRC_BK226_60        (REG_FRC_BANK_BASE+0x22660)
#define REG_FRC_BK226_61        (REG_FRC_BANK_BASE+0x22661)
#define REG_FRC_BK226_62        (REG_FRC_BANK_BASE+0x22662)
#define REG_FRC_BK226_63        (REG_FRC_BANK_BASE+0x22663)
#define REG_FRC_BK226_64        (REG_FRC_BANK_BASE+0x22664)
#define REG_FRC_BK226_65        (REG_FRC_BANK_BASE+0x22665)
#define REG_FRC_BK226_66        (REG_FRC_BANK_BASE+0x22666)
#define REG_FRC_BK226_67        (REG_FRC_BANK_BASE+0x22667)
#define REG_FRC_BK226_68        (REG_FRC_BANK_BASE+0x22668)
#define REG_FRC_BK226_69        (REG_FRC_BANK_BASE+0x22669)
#define REG_FRC_BK226_6A        (REG_FRC_BANK_BASE+0x2266A)
#define REG_FRC_BK226_6B        (REG_FRC_BANK_BASE+0x2266B)
#define REG_FRC_BK226_6C        (REG_FRC_BANK_BASE+0x2266C)
#define REG_FRC_BK226_6D        (REG_FRC_BANK_BASE+0x2266D)
#define REG_FRC_BK226_6E        (REG_FRC_BANK_BASE+0x2266E)
#define REG_FRC_BK226_6F        (REG_FRC_BANK_BASE+0x2266F)
#define REG_FRC_BK226_70        (REG_FRC_BANK_BASE+0x22670)
#define REG_FRC_BK226_71        (REG_FRC_BANK_BASE+0x22671)
#define REG_FRC_BK226_72        (REG_FRC_BANK_BASE+0x22672)
#define REG_FRC_BK226_73        (REG_FRC_BANK_BASE+0x22673)
#define REG_FRC_BK226_74        (REG_FRC_BANK_BASE+0x22674)
#define REG_FRC_BK226_75        (REG_FRC_BANK_BASE+0x22675)
#define REG_FRC_BK226_76        (REG_FRC_BANK_BASE+0x22676)
#define REG_FRC_BK226_77        (REG_FRC_BANK_BASE+0x22677)
#define REG_FRC_BK226_78        (REG_FRC_BANK_BASE+0x22678)
#define REG_FRC_BK226_79        (REG_FRC_BANK_BASE+0x22679)
#define REG_FRC_BK226_7A        (REG_FRC_BANK_BASE+0x2267A)
#define REG_FRC_BK226_7B        (REG_FRC_BANK_BASE+0x2267B)
#define REG_FRC_BK226_7C        (REG_FRC_BANK_BASE+0x2267C)
#define REG_FRC_BK226_7D        (REG_FRC_BANK_BASE+0x2267D)
#define REG_FRC_BK226_7E        (REG_FRC_BANK_BASE+0x2267E)
#define REG_FRC_BK226_7F        (REG_FRC_BANK_BASE+0x2267F)
#define REG_FRC_BK226_80        (REG_FRC_BANK_BASE+0x22680)
#define REG_FRC_BK226_81        (REG_FRC_BANK_BASE+0x22681)
#define REG_FRC_BK226_82        (REG_FRC_BANK_BASE+0x22682)
#define REG_FRC_BK226_83        (REG_FRC_BANK_BASE+0x22683)
#define REG_FRC_BK226_84        (REG_FRC_BANK_BASE+0x22684)
#define REG_FRC_BK226_85        (REG_FRC_BANK_BASE+0x22685)
#define REG_FRC_BK226_86        (REG_FRC_BANK_BASE+0x22686)
#define REG_FRC_BK226_87        (REG_FRC_BANK_BASE+0x22687)
#define REG_FRC_BK226_88        (REG_FRC_BANK_BASE+0x22688)
#define REG_FRC_BK226_89        (REG_FRC_BANK_BASE+0x22689)
#define REG_FRC_BK226_8A        (REG_FRC_BANK_BASE+0x2268A)
#define REG_FRC_BK226_8B        (REG_FRC_BANK_BASE+0x2268B)
#define REG_FRC_BK226_8C        (REG_FRC_BANK_BASE+0x2268C)
#define REG_FRC_BK226_8D        (REG_FRC_BANK_BASE+0x2268D)
#define REG_FRC_BK226_8E        (REG_FRC_BANK_BASE+0x2268E)
#define REG_FRC_BK226_8F        (REG_FRC_BANK_BASE+0x2268F)
#define REG_FRC_BK226_90        (REG_FRC_BANK_BASE+0x22690)
#define REG_FRC_BK226_91        (REG_FRC_BANK_BASE+0x22691)
#define REG_FRC_BK226_92        (REG_FRC_BANK_BASE+0x22692)
#define REG_FRC_BK226_93        (REG_FRC_BANK_BASE+0x22693)
#define REG_FRC_BK226_94        (REG_FRC_BANK_BASE+0x22694)
#define REG_FRC_BK226_95        (REG_FRC_BANK_BASE+0x22695)
#define REG_FRC_BK226_96        (REG_FRC_BANK_BASE+0x22696)
#define REG_FRC_BK226_97        (REG_FRC_BANK_BASE+0x22697)
#define REG_FRC_BK226_98        (REG_FRC_BANK_BASE+0x22698)
#define REG_FRC_BK226_99        (REG_FRC_BANK_BASE+0x22699)
#define REG_FRC_BK226_9A        (REG_FRC_BANK_BASE+0x2269A)
#define REG_FRC_BK226_9B        (REG_FRC_BANK_BASE+0x2269B)
#define REG_FRC_BK226_9C        (REG_FRC_BANK_BASE+0x2269C)
#define REG_FRC_BK226_9D        (REG_FRC_BANK_BASE+0x2269D)
#define REG_FRC_BK226_9E        (REG_FRC_BANK_BASE+0x2269E)
#define REG_FRC_BK226_9F        (REG_FRC_BANK_BASE+0x2269F)
#define REG_FRC_BK226_A0        (REG_FRC_BANK_BASE+0x226A0)
#define REG_FRC_BK226_A1        (REG_FRC_BANK_BASE+0x226A1)
#define REG_FRC_BK226_A2        (REG_FRC_BANK_BASE+0x226A2)
#define REG_FRC_BK226_A3        (REG_FRC_BANK_BASE+0x226A3)
#define REG_FRC_BK226_A4        (REG_FRC_BANK_BASE+0x226A4)
#define REG_FRC_BK226_A5        (REG_FRC_BANK_BASE+0x226A5)
#define REG_FRC_BK226_A6        (REG_FRC_BANK_BASE+0x226A6)
#define REG_FRC_BK226_A7        (REG_FRC_BANK_BASE+0x226A7)
#define REG_FRC_BK226_A8        (REG_FRC_BANK_BASE+0x226A8)
#define REG_FRC_BK226_A9        (REG_FRC_BANK_BASE+0x226A9)
#define REG_FRC_BK226_AA        (REG_FRC_BANK_BASE+0x226AA)
#define REG_FRC_BK226_AB        (REG_FRC_BANK_BASE+0x226AB)
#define REG_FRC_BK226_AC        (REG_FRC_BANK_BASE+0x226AC)
#define REG_FRC_BK226_AD        (REG_FRC_BANK_BASE+0x226AD)
#define REG_FRC_BK226_AE        (REG_FRC_BANK_BASE+0x226AE)
#define REG_FRC_BK226_AF        (REG_FRC_BANK_BASE+0x226AF)
#define REG_FRC_BK226_B0        (REG_FRC_BANK_BASE+0x226B0)
#define REG_FRC_BK226_B1        (REG_FRC_BANK_BASE+0x226B1)
#define REG_FRC_BK226_B2        (REG_FRC_BANK_BASE+0x226B2)
#define REG_FRC_BK226_B3        (REG_FRC_BANK_BASE+0x226B3)
#define REG_FRC_BK226_B4        (REG_FRC_BANK_BASE+0x226B4)
#define REG_FRC_BK226_B5        (REG_FRC_BANK_BASE+0x226B5)
#define REG_FRC_BK226_B6        (REG_FRC_BANK_BASE+0x226B6)
#define REG_FRC_BK226_B7        (REG_FRC_BANK_BASE+0x226B7)
#define REG_FRC_BK226_B8        (REG_FRC_BANK_BASE+0x226B8)
#define REG_FRC_BK226_B9        (REG_FRC_BANK_BASE+0x226B9)
#define REG_FRC_BK226_BA        (REG_FRC_BANK_BASE+0x226BA)
#define REG_FRC_BK226_BB        (REG_FRC_BANK_BASE+0x226BB)
#define REG_FRC_BK226_BC        (REG_FRC_BANK_BASE+0x226BC)
#define REG_FRC_BK226_BD        (REG_FRC_BANK_BASE+0x226BD)
#define REG_FRC_BK226_BE        (REG_FRC_BANK_BASE+0x226BE)
#define REG_FRC_BK226_BF        (REG_FRC_BANK_BASE+0x226BF)
#define REG_FRC_BK226_C0        (REG_FRC_BANK_BASE+0x226C0)
#define REG_FRC_BK226_C1        (REG_FRC_BANK_BASE+0x226C1)
#define REG_FRC_BK226_C2        (REG_FRC_BANK_BASE+0x226C2)
#define REG_FRC_BK226_C3        (REG_FRC_BANK_BASE+0x226C3)
#define REG_FRC_BK226_C4        (REG_FRC_BANK_BASE+0x226C4)
#define REG_FRC_BK226_C5        (REG_FRC_BANK_BASE+0x226C5)
#define REG_FRC_BK226_C6        (REG_FRC_BANK_BASE+0x226C6)
#define REG_FRC_BK226_C7        (REG_FRC_BANK_BASE+0x226C7)
#define REG_FRC_BK226_C8        (REG_FRC_BANK_BASE+0x226C8)
#define REG_FRC_BK226_C9        (REG_FRC_BANK_BASE+0x226C9)
#define REG_FRC_BK226_CA        (REG_FRC_BANK_BASE+0x226CA)
#define REG_FRC_BK226_CB        (REG_FRC_BANK_BASE+0x226CB)
#define REG_FRC_BK226_CC        (REG_FRC_BANK_BASE+0x226CC)
#define REG_FRC_BK226_CD        (REG_FRC_BANK_BASE+0x226CD)
#define REG_FRC_BK226_CE        (REG_FRC_BANK_BASE+0x226CE)
#define REG_FRC_BK226_CF        (REG_FRC_BANK_BASE+0x226CF)
#define REG_FRC_BK226_D0        (REG_FRC_BANK_BASE+0x226D0)
#define REG_FRC_BK226_D1        (REG_FRC_BANK_BASE+0x226D1)
#define REG_FRC_BK226_D2        (REG_FRC_BANK_BASE+0x226D2)
#define REG_FRC_BK226_D3        (REG_FRC_BANK_BASE+0x226D3)
#define REG_FRC_BK226_D4        (REG_FRC_BANK_BASE+0x226D4)
#define REG_FRC_BK226_D5        (REG_FRC_BANK_BASE+0x226D5)
#define REG_FRC_BK226_D6        (REG_FRC_BANK_BASE+0x226D6)
#define REG_FRC_BK226_D7        (REG_FRC_BANK_BASE+0x226D7)
#define REG_FRC_BK226_D8        (REG_FRC_BANK_BASE+0x226D8)
#define REG_FRC_BK226_D9        (REG_FRC_BANK_BASE+0x226D9)
#define REG_FRC_BK226_DA        (REG_FRC_BANK_BASE+0x226DA)
#define REG_FRC_BK226_DB        (REG_FRC_BANK_BASE+0x226DB)
#define REG_FRC_BK226_DC        (REG_FRC_BANK_BASE+0x226DC)
#define REG_FRC_BK226_DD        (REG_FRC_BANK_BASE+0x226DD)
#define REG_FRC_BK226_DE        (REG_FRC_BANK_BASE+0x226DE)
#define REG_FRC_BK226_DF        (REG_FRC_BANK_BASE+0x226DF)
#define REG_FRC_BK226_E0        (REG_FRC_BANK_BASE+0x226E0)
#define REG_FRC_BK226_E1        (REG_FRC_BANK_BASE+0x226E1)
#define REG_FRC_BK226_E2        (REG_FRC_BANK_BASE+0x226E2)
#define REG_FRC_BK226_E3        (REG_FRC_BANK_BASE+0x226E3)
#define REG_FRC_BK226_E4        (REG_FRC_BANK_BASE+0x226E4)
#define REG_FRC_BK226_E5        (REG_FRC_BANK_BASE+0x226E5)
#define REG_FRC_BK226_E6        (REG_FRC_BANK_BASE+0x226E6)
#define REG_FRC_BK226_E7        (REG_FRC_BANK_BASE+0x226E7)
#define REG_FRC_BK226_E8        (REG_FRC_BANK_BASE+0x226E8)
#define REG_FRC_BK226_E9        (REG_FRC_BANK_BASE+0x226E9)
#define REG_FRC_BK226_EA        (REG_FRC_BANK_BASE+0x226EA)
#define REG_FRC_BK226_EB        (REG_FRC_BANK_BASE+0x226EB)
#define REG_FRC_BK226_EC        (REG_FRC_BANK_BASE+0x226EC)
#define REG_FRC_BK226_ED        (REG_FRC_BANK_BASE+0x226ED)
#define REG_FRC_BK226_EE        (REG_FRC_BANK_BASE+0x226EE)
#define REG_FRC_BK226_EF        (REG_FRC_BANK_BASE+0x226EF)
#define REG_FRC_BK226_F0        (REG_FRC_BANK_BASE+0x226F0)
#define REG_FRC_BK226_F1        (REG_FRC_BANK_BASE+0x226F1)
#define REG_FRC_BK226_F2        (REG_FRC_BANK_BASE+0x226F2)
#define REG_FRC_BK226_F3        (REG_FRC_BANK_BASE+0x226F3)
#define REG_FRC_BK226_F4        (REG_FRC_BANK_BASE+0x226F4)
#define REG_FRC_BK226_F5        (REG_FRC_BANK_BASE+0x226F5)
#define REG_FRC_BK226_F6        (REG_FRC_BANK_BASE+0x226F6)
#define REG_FRC_BK226_F7        (REG_FRC_BANK_BASE+0x226F7)
#define REG_FRC_BK226_F8        (REG_FRC_BANK_BASE+0x226F8)
#define REG_FRC_BK226_F9        (REG_FRC_BANK_BASE+0x226F9)
#define REG_FRC_BK226_FA        (REG_FRC_BANK_BASE+0x226FA)
#define REG_FRC_BK226_FB        (REG_FRC_BANK_BASE+0x226FB)
#define REG_FRC_BK226_FC        (REG_FRC_BANK_BASE+0x226FC)
#define REG_FRC_BK226_FD        (REG_FRC_BANK_BASE+0x226FD)
#define REG_FRC_BK226_FE        (REG_FRC_BANK_BASE+0x226FE)
#define REG_FRC_BK226_FF        (REG_FRC_BANK_BASE+0x226FF)

// === FRC bk29 -> 0x4229
#define REG_FRC_BK229_00        (REG_FRC_BANK_BASE+0x22900)
#define REG_FRC_BK229_01        (REG_FRC_BANK_BASE+0x22901)
#define REG_FRC_BK229_02        (REG_FRC_BANK_BASE+0x22902)
#define REG_FRC_BK229_03        (REG_FRC_BANK_BASE+0x22903)
#define REG_FRC_BK229_04        (REG_FRC_BANK_BASE+0x22904)
#define REG_FRC_BK229_05        (REG_FRC_BANK_BASE+0x22905)
#define REG_FRC_BK229_06        (REG_FRC_BANK_BASE+0x22906)
#define REG_FRC_BK229_07        (REG_FRC_BANK_BASE+0x22907)
#define REG_FRC_BK229_08        (REG_FRC_BANK_BASE+0x22908)
#define REG_FRC_BK229_09        (REG_FRC_BANK_BASE+0x22909)
#define REG_FRC_BK229_0A        (REG_FRC_BANK_BASE+0x2290A)
#define REG_FRC_BK229_0B        (REG_FRC_BANK_BASE+0x2290B)
#define REG_FRC_BK229_0C        (REG_FRC_BANK_BASE+0x2290C)
#define REG_FRC_BK229_0D        (REG_FRC_BANK_BASE+0x2290D)
#define REG_FRC_BK229_0E        (REG_FRC_BANK_BASE+0x2290E)
#define REG_FRC_BK229_0F        (REG_FRC_BANK_BASE+0x2290F)
#define REG_FRC_BK229_10        (REG_FRC_BANK_BASE+0x22910)
#define REG_FRC_BK229_11        (REG_FRC_BANK_BASE+0x22911)
#define REG_FRC_BK229_12        (REG_FRC_BANK_BASE+0x22912)
#define REG_FRC_BK229_13        (REG_FRC_BANK_BASE+0x22913)
#define REG_FRC_BK229_14        (REG_FRC_BANK_BASE+0x22914)
#define REG_FRC_BK229_15        (REG_FRC_BANK_BASE+0x22915)
#define REG_FRC_BK229_16        (REG_FRC_BANK_BASE+0x22916)
#define REG_FRC_BK229_17        (REG_FRC_BANK_BASE+0x22917)
#define REG_FRC_BK229_18        (REG_FRC_BANK_BASE+0x22918)
#define REG_FRC_BK229_19        (REG_FRC_BANK_BASE+0x22919)
#define REG_FRC_BK229_1A        (REG_FRC_BANK_BASE+0x2291A)
#define REG_FRC_BK229_1B        (REG_FRC_BANK_BASE+0x2291B)
#define REG_FRC_BK229_1C        (REG_FRC_BANK_BASE+0x2291C)
#define REG_FRC_BK229_1D        (REG_FRC_BANK_BASE+0x2291D)
#define REG_FRC_BK229_1E        (REG_FRC_BANK_BASE+0x2291E)
#define REG_FRC_BK229_1F        (REG_FRC_BANK_BASE+0x2291F)
#define REG_FRC_BK229_20        (REG_FRC_BANK_BASE+0x22920)
#define REG_FRC_BK229_21        (REG_FRC_BANK_BASE+0x22921)
#define REG_FRC_BK229_22        (REG_FRC_BANK_BASE+0x22922)
#define REG_FRC_BK229_23        (REG_FRC_BANK_BASE+0x22923)
#define REG_FRC_BK229_24        (REG_FRC_BANK_BASE+0x22924)
#define REG_FRC_BK229_25        (REG_FRC_BANK_BASE+0x22925)
#define REG_FRC_BK229_26        (REG_FRC_BANK_BASE+0x22926)
#define REG_FRC_BK229_27        (REG_FRC_BANK_BASE+0x22927)
#define REG_FRC_BK229_28        (REG_FRC_BANK_BASE+0x22928)
#define REG_FRC_BK229_29        (REG_FRC_BANK_BASE+0x22929)
#define REG_FRC_BK229_2A        (REG_FRC_BANK_BASE+0x2292A)
#define REG_FRC_BK229_2B        (REG_FRC_BANK_BASE+0x2292B)
#define REG_FRC_BK229_2C        (REG_FRC_BANK_BASE+0x2292C)
#define REG_FRC_BK229_2D        (REG_FRC_BANK_BASE+0x2292D)
#define REG_FRC_BK229_2E        (REG_FRC_BANK_BASE+0x2292E)
#define REG_FRC_BK229_2F        (REG_FRC_BANK_BASE+0x2292F)
#define REG_FRC_BK229_30        (REG_FRC_BANK_BASE+0x22930)
#define REG_FRC_BK229_31        (REG_FRC_BANK_BASE+0x22931)
#define REG_FRC_BK229_32        (REG_FRC_BANK_BASE+0x22932)
#define REG_FRC_BK229_33        (REG_FRC_BANK_BASE+0x22933)
#define REG_FRC_BK229_34        (REG_FRC_BANK_BASE+0x22934)
#define REG_FRC_BK229_35        (REG_FRC_BANK_BASE+0x22935)
#define REG_FRC_BK229_36        (REG_FRC_BANK_BASE+0x22936)
#define REG_FRC_BK229_37        (REG_FRC_BANK_BASE+0x22937)
#define REG_FRC_BK229_38        (REG_FRC_BANK_BASE+0x22938)
#define REG_FRC_BK229_39        (REG_FRC_BANK_BASE+0x22939)
#define REG_FRC_BK229_3A        (REG_FRC_BANK_BASE+0x2293A)
#define REG_FRC_BK229_3B        (REG_FRC_BANK_BASE+0x2293B)
#define REG_FRC_BK229_3C        (REG_FRC_BANK_BASE+0x2293C)
#define REG_FRC_BK229_3D        (REG_FRC_BANK_BASE+0x2293D)
#define REG_FRC_BK229_3E        (REG_FRC_BANK_BASE+0x2293E)
#define REG_FRC_BK229_3F        (REG_FRC_BANK_BASE+0x2293F)
#define REG_FRC_BK229_40        (REG_FRC_BANK_BASE+0x22940)
#define REG_FRC_BK229_41        (REG_FRC_BANK_BASE+0x22941)
#define REG_FRC_BK229_42        (REG_FRC_BANK_BASE+0x22942)
#define REG_FRC_BK229_43        (REG_FRC_BANK_BASE+0x22943)
#define REG_FRC_BK229_44        (REG_FRC_BANK_BASE+0x22944)
#define REG_FRC_BK229_45        (REG_FRC_BANK_BASE+0x22945)
#define REG_FRC_BK229_46        (REG_FRC_BANK_BASE+0x22946)
#define REG_FRC_BK229_47        (REG_FRC_BANK_BASE+0x22947)
#define REG_FRC_BK229_48        (REG_FRC_BANK_BASE+0x22948)
#define REG_FRC_BK229_49        (REG_FRC_BANK_BASE+0x22949)
#define REG_FRC_BK229_4A        (REG_FRC_BANK_BASE+0x2294A)
#define REG_FRC_BK229_4B        (REG_FRC_BANK_BASE+0x2294B)
#define REG_FRC_BK229_4C        (REG_FRC_BANK_BASE+0x2294C)
#define REG_FRC_BK229_4D        (REG_FRC_BANK_BASE+0x2294D)
#define REG_FRC_BK229_4E        (REG_FRC_BANK_BASE+0x2294E)
#define REG_FRC_BK229_4F        (REG_FRC_BANK_BASE+0x2294F)
#define REG_FRC_BK229_50        (REG_FRC_BANK_BASE+0x22950)
#define REG_FRC_BK229_51        (REG_FRC_BANK_BASE+0x22951)
#define REG_FRC_BK229_52        (REG_FRC_BANK_BASE+0x22952)
#define REG_FRC_BK229_53        (REG_FRC_BANK_BASE+0x22953)
#define REG_FRC_BK229_54        (REG_FRC_BANK_BASE+0x22954)
#define REG_FRC_BK229_55        (REG_FRC_BANK_BASE+0x22955)
#define REG_FRC_BK229_56        (REG_FRC_BANK_BASE+0x22956)
#define REG_FRC_BK229_57        (REG_FRC_BANK_BASE+0x22957)
#define REG_FRC_BK229_58        (REG_FRC_BANK_BASE+0x22958)
#define REG_FRC_BK229_59        (REG_FRC_BANK_BASE+0x22959)
#define REG_FRC_BK229_5A        (REG_FRC_BANK_BASE+0x2295A)
#define REG_FRC_BK229_5B        (REG_FRC_BANK_BASE+0x2295B)
#define REG_FRC_BK229_5C        (REG_FRC_BANK_BASE+0x2295C)
#define REG_FRC_BK229_5D        (REG_FRC_BANK_BASE+0x2295D)
#define REG_FRC_BK229_5E        (REG_FRC_BANK_BASE+0x2295E)
#define REG_FRC_BK229_5F        (REG_FRC_BANK_BASE+0x2295F)
#define REG_FRC_BK229_60        (REG_FRC_BANK_BASE+0x22960)
#define REG_FRC_BK229_61        (REG_FRC_BANK_BASE+0x22961)
#define REG_FRC_BK229_62        (REG_FRC_BANK_BASE+0x22962)
#define REG_FRC_BK229_63        (REG_FRC_BANK_BASE+0x22963)
#define REG_FRC_BK229_64        (REG_FRC_BANK_BASE+0x22964)
#define REG_FRC_BK229_65        (REG_FRC_BANK_BASE+0x22965)
#define REG_FRC_BK229_66        (REG_FRC_BANK_BASE+0x22966)
#define REG_FRC_BK229_67        (REG_FRC_BANK_BASE+0x22967)
#define REG_FRC_BK229_68        (REG_FRC_BANK_BASE+0x22968)
#define REG_FRC_BK229_69        (REG_FRC_BANK_BASE+0x22969)
#define REG_FRC_BK229_6A        (REG_FRC_BANK_BASE+0x2296A)
#define REG_FRC_BK229_6B        (REG_FRC_BANK_BASE+0x2296B)
#define REG_FRC_BK229_6C        (REG_FRC_BANK_BASE+0x2296C)
#define REG_FRC_BK229_6D        (REG_FRC_BANK_BASE+0x2296D)
#define REG_FRC_BK229_6E        (REG_FRC_BANK_BASE+0x2296E)
#define REG_FRC_BK229_6F        (REG_FRC_BANK_BASE+0x2296F)
#define REG_FRC_BK229_70        (REG_FRC_BANK_BASE+0x22970)
#define REG_FRC_BK229_71        (REG_FRC_BANK_BASE+0x22971)
#define REG_FRC_BK229_72        (REG_FRC_BANK_BASE+0x22972)
#define REG_FRC_BK229_73        (REG_FRC_BANK_BASE+0x22973)
#define REG_FRC_BK229_74        (REG_FRC_BANK_BASE+0x22974)
#define REG_FRC_BK229_75        (REG_FRC_BANK_BASE+0x22975)
#define REG_FRC_BK229_76        (REG_FRC_BANK_BASE+0x22976)
#define REG_FRC_BK229_77        (REG_FRC_BANK_BASE+0x22977)
#define REG_FRC_BK229_78        (REG_FRC_BANK_BASE+0x22978)
#define REG_FRC_BK229_79        (REG_FRC_BANK_BASE+0x22979)
#define REG_FRC_BK229_7A        (REG_FRC_BANK_BASE+0x2297A)
#define REG_FRC_BK229_7B        (REG_FRC_BANK_BASE+0x2297B)
#define REG_FRC_BK229_7C        (REG_FRC_BANK_BASE+0x2297C)
#define REG_FRC_BK229_7D        (REG_FRC_BANK_BASE+0x2297D)
#define REG_FRC_BK229_7E        (REG_FRC_BANK_BASE+0x2297E)
#define REG_FRC_BK229_7F        (REG_FRC_BANK_BASE+0x2297F)
#define REG_FRC_BK229_80        (REG_FRC_BANK_BASE+0x22980)
#define REG_FRC_BK229_81        (REG_FRC_BANK_BASE+0x22981)
#define REG_FRC_BK229_82        (REG_FRC_BANK_BASE+0x22982)
#define REG_FRC_BK229_83        (REG_FRC_BANK_BASE+0x22983)
#define REG_FRC_BK229_84        (REG_FRC_BANK_BASE+0x22984)
#define REG_FRC_BK229_85        (REG_FRC_BANK_BASE+0x22985)
#define REG_FRC_BK229_86        (REG_FRC_BANK_BASE+0x22986)
#define REG_FRC_BK229_87        (REG_FRC_BANK_BASE+0x22987)
#define REG_FRC_BK229_88        (REG_FRC_BANK_BASE+0x22988)
#define REG_FRC_BK229_89        (REG_FRC_BANK_BASE+0x22989)
#define REG_FRC_BK229_8A        (REG_FRC_BANK_BASE+0x2298A)
#define REG_FRC_BK229_8B        (REG_FRC_BANK_BASE+0x2298B)
#define REG_FRC_BK229_8C        (REG_FRC_BANK_BASE+0x2298C)
#define REG_FRC_BK229_8D        (REG_FRC_BANK_BASE+0x2298D)
#define REG_FRC_BK229_8E        (REG_FRC_BANK_BASE+0x2298E)
#define REG_FRC_BK229_8F        (REG_FRC_BANK_BASE+0x2298F)
#define REG_FRC_BK229_90        (REG_FRC_BANK_BASE+0x22990)
#define REG_FRC_BK229_91        (REG_FRC_BANK_BASE+0x22991)
#define REG_FRC_BK229_92        (REG_FRC_BANK_BASE+0x22992)
#define REG_FRC_BK229_93        (REG_FRC_BANK_BASE+0x22993)
#define REG_FRC_BK229_94        (REG_FRC_BANK_BASE+0x22994)
#define REG_FRC_BK229_95        (REG_FRC_BANK_BASE+0x22995)
#define REG_FRC_BK229_96        (REG_FRC_BANK_BASE+0x22996)
#define REG_FRC_BK229_97        (REG_FRC_BANK_BASE+0x22997)
#define REG_FRC_BK229_98        (REG_FRC_BANK_BASE+0x22998)
#define REG_FRC_BK229_99        (REG_FRC_BANK_BASE+0x22999)
#define REG_FRC_BK229_9A        (REG_FRC_BANK_BASE+0x2299A)
#define REG_FRC_BK229_9B        (REG_FRC_BANK_BASE+0x2299B)
#define REG_FRC_BK229_9C        (REG_FRC_BANK_BASE+0x2299C)
#define REG_FRC_BK229_9D        (REG_FRC_BANK_BASE+0x2299D)
#define REG_FRC_BK229_9E        (REG_FRC_BANK_BASE+0x2299E)
#define REG_FRC_BK229_9F        (REG_FRC_BANK_BASE+0x2299F)
#define REG_FRC_BK229_A0        (REG_FRC_BANK_BASE+0x229A0)
#define REG_FRC_BK229_A1        (REG_FRC_BANK_BASE+0x229A1)
#define REG_FRC_BK229_A2        (REG_FRC_BANK_BASE+0x229A2)
#define REG_FRC_BK229_A3        (REG_FRC_BANK_BASE+0x229A3)
#define REG_FRC_BK229_A4        (REG_FRC_BANK_BASE+0x229A4)
#define REG_FRC_BK229_A5        (REG_FRC_BANK_BASE+0x229A5)
#define REG_FRC_BK229_A6        (REG_FRC_BANK_BASE+0x229A6)
#define REG_FRC_BK229_A7        (REG_FRC_BANK_BASE+0x229A7)
#define REG_FRC_BK229_A8        (REG_FRC_BANK_BASE+0x229A8)
#define REG_FRC_BK229_A9        (REG_FRC_BANK_BASE+0x229A9)
#define REG_FRC_BK229_AA        (REG_FRC_BANK_BASE+0x229AA)
#define REG_FRC_BK229_AB        (REG_FRC_BANK_BASE+0x229AB)
#define REG_FRC_BK229_AC        (REG_FRC_BANK_BASE+0x229AC)
#define REG_FRC_BK229_AD        (REG_FRC_BANK_BASE+0x229AD)
#define REG_FRC_BK229_AE        (REG_FRC_BANK_BASE+0x229AE)
#define REG_FRC_BK229_AF        (REG_FRC_BANK_BASE+0x229AF)
#define REG_FRC_BK229_B0        (REG_FRC_BANK_BASE+0x229B0)
#define REG_FRC_BK229_B1        (REG_FRC_BANK_BASE+0x229B1)
#define REG_FRC_BK229_B2        (REG_FRC_BANK_BASE+0x229B2)
#define REG_FRC_BK229_B3        (REG_FRC_BANK_BASE+0x229B3)
#define REG_FRC_BK229_B4        (REG_FRC_BANK_BASE+0x229B4)
#define REG_FRC_BK229_B5        (REG_FRC_BANK_BASE+0x229B5)
#define REG_FRC_BK229_B6        (REG_FRC_BANK_BASE+0x229B6)
#define REG_FRC_BK229_B7        (REG_FRC_BANK_BASE+0x229B7)
#define REG_FRC_BK229_B8        (REG_FRC_BANK_BASE+0x229B8)
#define REG_FRC_BK229_B9        (REG_FRC_BANK_BASE+0x229B9)
#define REG_FRC_BK229_BA        (REG_FRC_BANK_BASE+0x229BA)
#define REG_FRC_BK229_BB        (REG_FRC_BANK_BASE+0x229BB)
#define REG_FRC_BK229_BC        (REG_FRC_BANK_BASE+0x229BC)
#define REG_FRC_BK229_BD        (REG_FRC_BANK_BASE+0x229BD)
#define REG_FRC_BK229_BE        (REG_FRC_BANK_BASE+0x229BE)
#define REG_FRC_BK229_BF        (REG_FRC_BANK_BASE+0x229BF)
#define REG_FRC_BK229_C0        (REG_FRC_BANK_BASE+0x229C0)
#define REG_FRC_BK229_C1        (REG_FRC_BANK_BASE+0x229C1)
#define REG_FRC_BK229_C2        (REG_FRC_BANK_BASE+0x229C2)
#define REG_FRC_BK229_C3        (REG_FRC_BANK_BASE+0x229C3)
#define REG_FRC_BK229_C4        (REG_FRC_BANK_BASE+0x229C4)
#define REG_FRC_BK229_C5        (REG_FRC_BANK_BASE+0x229C5)
#define REG_FRC_BK229_C6        (REG_FRC_BANK_BASE+0x229C6)
#define REG_FRC_BK229_C7        (REG_FRC_BANK_BASE+0x229C7)
#define REG_FRC_BK229_C8        (REG_FRC_BANK_BASE+0x229C8)
#define REG_FRC_BK229_C9        (REG_FRC_BANK_BASE+0x229C9)
#define REG_FRC_BK229_CA        (REG_FRC_BANK_BASE+0x229CA)
#define REG_FRC_BK229_CB        (REG_FRC_BANK_BASE+0x229CB)
#define REG_FRC_BK229_CC        (REG_FRC_BANK_BASE+0x229CC)
#define REG_FRC_BK229_CD        (REG_FRC_BANK_BASE+0x229CD)
#define REG_FRC_BK229_CE        (REG_FRC_BANK_BASE+0x229CE)
#define REG_FRC_BK229_CF        (REG_FRC_BANK_BASE+0x229CF)
#define REG_FRC_BK229_D0        (REG_FRC_BANK_BASE+0x229D0)
#define REG_FRC_BK229_D1        (REG_FRC_BANK_BASE+0x229D1)
#define REG_FRC_BK229_D2        (REG_FRC_BANK_BASE+0x229D2)
#define REG_FRC_BK229_D3        (REG_FRC_BANK_BASE+0x229D3)
#define REG_FRC_BK229_D4        (REG_FRC_BANK_BASE+0x229D4)
#define REG_FRC_BK229_D5        (REG_FRC_BANK_BASE+0x229D5)
#define REG_FRC_BK229_D6        (REG_FRC_BANK_BASE+0x229D6)
#define REG_FRC_BK229_D7        (REG_FRC_BANK_BASE+0x229D7)
#define REG_FRC_BK229_D8        (REG_FRC_BANK_BASE+0x229D8)
#define REG_FRC_BK229_D9        (REG_FRC_BANK_BASE+0x229D9)
#define REG_FRC_BK229_DA        (REG_FRC_BANK_BASE+0x229DA)
#define REG_FRC_BK229_DB        (REG_FRC_BANK_BASE+0x229DB)
#define REG_FRC_BK229_DC        (REG_FRC_BANK_BASE+0x229DC)
#define REG_FRC_BK229_DD        (REG_FRC_BANK_BASE+0x229DD)
#define REG_FRC_BK229_DE        (REG_FRC_BANK_BASE+0x229DE)
#define REG_FRC_BK229_DF        (REG_FRC_BANK_BASE+0x229DF)
#define REG_FRC_BK229_E0        (REG_FRC_BANK_BASE+0x229E0)
#define REG_FRC_BK229_E1        (REG_FRC_BANK_BASE+0x229E1)
#define REG_FRC_BK229_E2        (REG_FRC_BANK_BASE+0x229E2)
#define REG_FRC_BK229_E3        (REG_FRC_BANK_BASE+0x229E3)
#define REG_FRC_BK229_E4        (REG_FRC_BANK_BASE+0x229E4)
#define REG_FRC_BK229_E5        (REG_FRC_BANK_BASE+0x229E5)
#define REG_FRC_BK229_E6        (REG_FRC_BANK_BASE+0x229E6)
#define REG_FRC_BK229_E7        (REG_FRC_BANK_BASE+0x229E7)
#define REG_FRC_BK229_E8        (REG_FRC_BANK_BASE+0x229E8)
#define REG_FRC_BK229_E9        (REG_FRC_BANK_BASE+0x229E9)
#define REG_FRC_BK229_EA        (REG_FRC_BANK_BASE+0x229EA)
#define REG_FRC_BK229_EB        (REG_FRC_BANK_BASE+0x229EB)
#define REG_FRC_BK229_EC        (REG_FRC_BANK_BASE+0x229EC)
#define REG_FRC_BK229_ED        (REG_FRC_BANK_BASE+0x229ED)
#define REG_FRC_BK229_EE        (REG_FRC_BANK_BASE+0x229EE)
#define REG_FRC_BK229_EF        (REG_FRC_BANK_BASE+0x229EF)
#define REG_FRC_BK229_F0        (REG_FRC_BANK_BASE+0x229F0)
#define REG_FRC_BK229_F1        (REG_FRC_BANK_BASE+0x229F1)
#define REG_FRC_BK229_F2        (REG_FRC_BANK_BASE+0x229F2)
#define REG_FRC_BK229_F3        (REG_FRC_BANK_BASE+0x229F3)
#define REG_FRC_BK229_F4        (REG_FRC_BANK_BASE+0x229F4)
#define REG_FRC_BK229_F5        (REG_FRC_BANK_BASE+0x229F5)
#define REG_FRC_BK229_F6        (REG_FRC_BANK_BASE+0x229F6)
#define REG_FRC_BK229_F7        (REG_FRC_BANK_BASE+0x229F7)
#define REG_FRC_BK229_F8        (REG_FRC_BANK_BASE+0x229F8)
#define REG_FRC_BK229_F9        (REG_FRC_BANK_BASE+0x229F9)
#define REG_FRC_BK229_FA        (REG_FRC_BANK_BASE+0x229FA)
#define REG_FRC_BK229_FB        (REG_FRC_BANK_BASE+0x229FB)
#define REG_FRC_BK229_FC        (REG_FRC_BANK_BASE+0x229FC)
#define REG_FRC_BK229_FD        (REG_FRC_BANK_BASE+0x229FD)
#define REG_FRC_BK229_FE        (REG_FRC_BANK_BASE+0x229FE)
#define REG_FRC_BK229_FF        (REG_FRC_BANK_BASE+0x229FF)

// === FRC bk2C -> 0x422C
#define REG_FRC_BK22C_00        (REG_FRC_BANK_BASE+0x22C00)
#define REG_FRC_BK22C_01        (REG_FRC_BANK_BASE+0x22C01)
#define REG_FRC_BK22C_02        (REG_FRC_BANK_BASE+0x22C02)
#define REG_FRC_BK22C_03        (REG_FRC_BANK_BASE+0x22C03)
#define REG_FRC_BK22C_04        (REG_FRC_BANK_BASE+0x22C04)
#define REG_FRC_BK22C_05        (REG_FRC_BANK_BASE+0x22C05)
#define REG_FRC_BK22C_06        (REG_FRC_BANK_BASE+0x22C06)
#define REG_FRC_BK22C_07        (REG_FRC_BANK_BASE+0x22C07)
#define REG_FRC_BK22C_08        (REG_FRC_BANK_BASE+0x22C08)
#define REG_FRC_BK22C_09        (REG_FRC_BANK_BASE+0x22C09)
#define REG_FRC_BK22C_0A        (REG_FRC_BANK_BASE+0x22C0A)
#define REG_FRC_BK22C_0B        (REG_FRC_BANK_BASE+0x22C0B)
#define REG_FRC_BK22C_0C        (REG_FRC_BANK_BASE+0x22C0C)
#define REG_FRC_BK22C_0D        (REG_FRC_BANK_BASE+0x22C0D)
#define REG_FRC_BK22C_0E        (REG_FRC_BANK_BASE+0x22C0E)
#define REG_FRC_BK22C_0F        (REG_FRC_BANK_BASE+0x22C0F)
#define REG_FRC_BK22C_10        (REG_FRC_BANK_BASE+0x22C10)
#define REG_FRC_BK22C_11        (REG_FRC_BANK_BASE+0x22C11)
#define REG_FRC_BK22C_12        (REG_FRC_BANK_BASE+0x22C12)
#define REG_FRC_BK22C_13        (REG_FRC_BANK_BASE+0x22C13)
#define REG_FRC_BK22C_14        (REG_FRC_BANK_BASE+0x22C14)
#define REG_FRC_BK22C_15        (REG_FRC_BANK_BASE+0x22C15)
#define REG_FRC_BK22C_16        (REG_FRC_BANK_BASE+0x22C16)
#define REG_FRC_BK22C_17        (REG_FRC_BANK_BASE+0x22C17)
#define REG_FRC_BK22C_18        (REG_FRC_BANK_BASE+0x22C18)
#define REG_FRC_BK22C_19        (REG_FRC_BANK_BASE+0x22C19)
#define REG_FRC_BK22C_1A        (REG_FRC_BANK_BASE+0x22C1A)
#define REG_FRC_BK22C_1B        (REG_FRC_BANK_BASE+0x22C1B)
#define REG_FRC_BK22C_1C        (REG_FRC_BANK_BASE+0x22C1C)
#define REG_FRC_BK22C_1D        (REG_FRC_BANK_BASE+0x22C1D)
#define REG_FRC_BK22C_1E        (REG_FRC_BANK_BASE+0x22C1E)
#define REG_FRC_BK22C_1F        (REG_FRC_BANK_BASE+0x22C1F)
#define REG_FRC_BK22C_20        (REG_FRC_BANK_BASE+0x22C20)
#define REG_FRC_BK22C_21        (REG_FRC_BANK_BASE+0x22C21)
#define REG_FRC_BK22C_22        (REG_FRC_BANK_BASE+0x22C22)
#define REG_FRC_BK22C_23        (REG_FRC_BANK_BASE+0x22C23)
#define REG_FRC_BK22C_24        (REG_FRC_BANK_BASE+0x22C24)
#define REG_FRC_BK22C_25        (REG_FRC_BANK_BASE+0x22C25)
#define REG_FRC_BK22C_26        (REG_FRC_BANK_BASE+0x22C26)
#define REG_FRC_BK22C_27        (REG_FRC_BANK_BASE+0x22C27)
#define REG_FRC_BK22C_28        (REG_FRC_BANK_BASE+0x22C28)
#define REG_FRC_BK22C_29        (REG_FRC_BANK_BASE+0x22C29)
#define REG_FRC_BK22C_2A        (REG_FRC_BANK_BASE+0x22C2A)
#define REG_FRC_BK22C_2B        (REG_FRC_BANK_BASE+0x22C2B)
#define REG_FRC_BK22C_2C        (REG_FRC_BANK_BASE+0x22C2C)
#define REG_FRC_BK22C_2D        (REG_FRC_BANK_BASE+0x22C2D)
#define REG_FRC_BK22C_2E        (REG_FRC_BANK_BASE+0x22C2E)
#define REG_FRC_BK22C_2F        (REG_FRC_BANK_BASE+0x22C2F)
#define REG_FRC_BK22C_30        (REG_FRC_BANK_BASE+0x22C30)
#define REG_FRC_BK22C_31        (REG_FRC_BANK_BASE+0x22C31)
#define REG_FRC_BK22C_32        (REG_FRC_BANK_BASE+0x22C32)
#define REG_FRC_BK22C_33        (REG_FRC_BANK_BASE+0x22C33)
#define REG_FRC_BK22C_34        (REG_FRC_BANK_BASE+0x22C34)
#define REG_FRC_BK22C_35        (REG_FRC_BANK_BASE+0x22C35)
#define REG_FRC_BK22C_36        (REG_FRC_BANK_BASE+0x22C36)
#define REG_FRC_BK22C_37        (REG_FRC_BANK_BASE+0x22C37)
#define REG_FRC_BK22C_38        (REG_FRC_BANK_BASE+0x22C38)
#define REG_FRC_BK22C_39        (REG_FRC_BANK_BASE+0x22C39)
#define REG_FRC_BK22C_3A        (REG_FRC_BANK_BASE+0x22C3A)
#define REG_FRC_BK22C_3B        (REG_FRC_BANK_BASE+0x22C3B)
#define REG_FRC_BK22C_3C        (REG_FRC_BANK_BASE+0x22C3C)
#define REG_FRC_BK22C_3D        (REG_FRC_BANK_BASE+0x22C3D)
#define REG_FRC_BK22C_3E        (REG_FRC_BANK_BASE+0x22C3E)
#define REG_FRC_BK22C_3F        (REG_FRC_BANK_BASE+0x22C3F)
#define REG_FRC_BK22C_40        (REG_FRC_BANK_BASE+0x22C40)
#define REG_FRC_BK22C_41        (REG_FRC_BANK_BASE+0x22C41)
#define REG_FRC_BK22C_42        (REG_FRC_BANK_BASE+0x22C42)
#define REG_FRC_BK22C_43        (REG_FRC_BANK_BASE+0x22C43)
#define REG_FRC_BK22C_44        (REG_FRC_BANK_BASE+0x22C44)
#define REG_FRC_BK22C_45        (REG_FRC_BANK_BASE+0x22C45)
#define REG_FRC_BK22C_46        (REG_FRC_BANK_BASE+0x22C46)
#define REG_FRC_BK22C_47        (REG_FRC_BANK_BASE+0x22C47)
#define REG_FRC_BK22C_48        (REG_FRC_BANK_BASE+0x22C48)
#define REG_FRC_BK22C_49        (REG_FRC_BANK_BASE+0x22C49)
#define REG_FRC_BK22C_4A        (REG_FRC_BANK_BASE+0x22C4A)
#define REG_FRC_BK22C_4B        (REG_FRC_BANK_BASE+0x22C4B)
#define REG_FRC_BK22C_4C        (REG_FRC_BANK_BASE+0x22C4C)
#define REG_FRC_BK22C_4D        (REG_FRC_BANK_BASE+0x22C4D)
#define REG_FRC_BK22C_4E        (REG_FRC_BANK_BASE+0x22C4E)
#define REG_FRC_BK22C_4F        (REG_FRC_BANK_BASE+0x22C4F)
#define REG_FRC_BK22C_50        (REG_FRC_BANK_BASE+0x22C50)
#define REG_FRC_BK22C_51        (REG_FRC_BANK_BASE+0x22C51)
#define REG_FRC_BK22C_52        (REG_FRC_BANK_BASE+0x22C52)
#define REG_FRC_BK22C_53        (REG_FRC_BANK_BASE+0x22C53)
#define REG_FRC_BK22C_54        (REG_FRC_BANK_BASE+0x22C54)
#define REG_FRC_BK22C_55        (REG_FRC_BANK_BASE+0x22C55)
#define REG_FRC_BK22C_56        (REG_FRC_BANK_BASE+0x22C56)
#define REG_FRC_BK22C_57        (REG_FRC_BANK_BASE+0x22C57)
#define REG_FRC_BK22C_58        (REG_FRC_BANK_BASE+0x22C58)
#define REG_FRC_BK22C_59        (REG_FRC_BANK_BASE+0x22C59)
#define REG_FRC_BK22C_5A        (REG_FRC_BANK_BASE+0x22C5A)
#define REG_FRC_BK22C_5B        (REG_FRC_BANK_BASE+0x22C5B)
#define REG_FRC_BK22C_5C        (REG_FRC_BANK_BASE+0x22C5C)
#define REG_FRC_BK22C_5D        (REG_FRC_BANK_BASE+0x22C5D)
#define REG_FRC_BK22C_5E        (REG_FRC_BANK_BASE+0x22C5E)
#define REG_FRC_BK22C_5F        (REG_FRC_BANK_BASE+0x22C5F)
#define REG_FRC_BK22C_60        (REG_FRC_BANK_BASE+0x22C60)
#define REG_FRC_BK22C_61        (REG_FRC_BANK_BASE+0x22C61)
#define REG_FRC_BK22C_62        (REG_FRC_BANK_BASE+0x22C62)
#define REG_FRC_BK22C_63        (REG_FRC_BANK_BASE+0x22C63)
#define REG_FRC_BK22C_64        (REG_FRC_BANK_BASE+0x22C64)
#define REG_FRC_BK22C_65        (REG_FRC_BANK_BASE+0x22C65)
#define REG_FRC_BK22C_66        (REG_FRC_BANK_BASE+0x22C66)
#define REG_FRC_BK22C_67        (REG_FRC_BANK_BASE+0x22C67)
#define REG_FRC_BK22C_68        (REG_FRC_BANK_BASE+0x22C68)
#define REG_FRC_BK22C_69        (REG_FRC_BANK_BASE+0x22C69)
#define REG_FRC_BK22C_6A        (REG_FRC_BANK_BASE+0x22C6A)
#define REG_FRC_BK22C_6B        (REG_FRC_BANK_BASE+0x22C6B)
#define REG_FRC_BK22C_6C        (REG_FRC_BANK_BASE+0x22C6C)
#define REG_FRC_BK22C_6D        (REG_FRC_BANK_BASE+0x22C6D)
#define REG_FRC_BK22C_6E        (REG_FRC_BANK_BASE+0x22C6E)
#define REG_FRC_BK22C_6F        (REG_FRC_BANK_BASE+0x22C6F)
#define REG_FRC_BK22C_70        (REG_FRC_BANK_BASE+0x22C70)
#define REG_FRC_BK22C_71        (REG_FRC_BANK_BASE+0x22C71)
#define REG_FRC_BK22C_72        (REG_FRC_BANK_BASE+0x22C72)
#define REG_FRC_BK22C_73        (REG_FRC_BANK_BASE+0x22C73)
#define REG_FRC_BK22C_74        (REG_FRC_BANK_BASE+0x22C74)
#define REG_FRC_BK22C_75        (REG_FRC_BANK_BASE+0x22C75)
#define REG_FRC_BK22C_76        (REG_FRC_BANK_BASE+0x22C76)
#define REG_FRC_BK22C_77        (REG_FRC_BANK_BASE+0x22C77)
#define REG_FRC_BK22C_78        (REG_FRC_BANK_BASE+0x22C78)
#define REG_FRC_BK22C_79        (REG_FRC_BANK_BASE+0x22C79)
#define REG_FRC_BK22C_7A        (REG_FRC_BANK_BASE+0x22C7A)
#define REG_FRC_BK22C_7B        (REG_FRC_BANK_BASE+0x22C7B)
#define REG_FRC_BK22C_7C        (REG_FRC_BANK_BASE+0x22C7C)
#define REG_FRC_BK22C_7D        (REG_FRC_BANK_BASE+0x22C7D)
#define REG_FRC_BK22C_7E        (REG_FRC_BANK_BASE+0x22C7E)
#define REG_FRC_BK22C_7F        (REG_FRC_BANK_BASE+0x22C7F)
#define REG_FRC_BK22C_80        (REG_FRC_BANK_BASE+0x22C80)
#define REG_FRC_BK22C_81        (REG_FRC_BANK_BASE+0x22C81)
#define REG_FRC_BK22C_82        (REG_FRC_BANK_BASE+0x22C82)
#define REG_FRC_BK22C_83        (REG_FRC_BANK_BASE+0x22C83)
#define REG_FRC_BK22C_84        (REG_FRC_BANK_BASE+0x22C84)
#define REG_FRC_BK22C_85        (REG_FRC_BANK_BASE+0x22C85)
#define REG_FRC_BK22C_86        (REG_FRC_BANK_BASE+0x22C86)
#define REG_FRC_BK22C_87        (REG_FRC_BANK_BASE+0x22C87)
#define REG_FRC_BK22C_88        (REG_FRC_BANK_BASE+0x22C88)
#define REG_FRC_BK22C_89        (REG_FRC_BANK_BASE+0x22C89)
#define REG_FRC_BK22C_8A        (REG_FRC_BANK_BASE+0x22C8A)
#define REG_FRC_BK22C_8B        (REG_FRC_BANK_BASE+0x22C8B)
#define REG_FRC_BK22C_8C        (REG_FRC_BANK_BASE+0x22C8C)
#define REG_FRC_BK22C_8D        (REG_FRC_BANK_BASE+0x22C8D)
#define REG_FRC_BK22C_8E        (REG_FRC_BANK_BASE+0x22C8E)
#define REG_FRC_BK22C_8F        (REG_FRC_BANK_BASE+0x22C8F)
#define REG_FRC_BK22C_90        (REG_FRC_BANK_BASE+0x22C90)
#define REG_FRC_BK22C_91        (REG_FRC_BANK_BASE+0x22C91)
#define REG_FRC_BK22C_92        (REG_FRC_BANK_BASE+0x22C92)
#define REG_FRC_BK22C_93        (REG_FRC_BANK_BASE+0x22C93)
#define REG_FRC_BK22C_94        (REG_FRC_BANK_BASE+0x22C94)
#define REG_FRC_BK22C_95        (REG_FRC_BANK_BASE+0x22C95)
#define REG_FRC_BK22C_96        (REG_FRC_BANK_BASE+0x22C96)
#define REG_FRC_BK22C_97        (REG_FRC_BANK_BASE+0x22C97)
#define REG_FRC_BK22C_98        (REG_FRC_BANK_BASE+0x22C98)
#define REG_FRC_BK22C_99        (REG_FRC_BANK_BASE+0x22C99)
#define REG_FRC_BK22C_9A        (REG_FRC_BANK_BASE+0x22C9A)
#define REG_FRC_BK22C_9B        (REG_FRC_BANK_BASE+0x22C9B)
#define REG_FRC_BK22C_9C        (REG_FRC_BANK_BASE+0x22C9C)
#define REG_FRC_BK22C_9D        (REG_FRC_BANK_BASE+0x22C9D)
#define REG_FRC_BK22C_9E        (REG_FRC_BANK_BASE+0x22C9E)
#define REG_FRC_BK22C_9F        (REG_FRC_BANK_BASE+0x22C9F)
#define REG_FRC_BK22C_A0        (REG_FRC_BANK_BASE+0x22CA0)
#define REG_FRC_BK22C_A1        (REG_FRC_BANK_BASE+0x22CA1)
#define REG_FRC_BK22C_A2        (REG_FRC_BANK_BASE+0x22CA2)
#define REG_FRC_BK22C_A3        (REG_FRC_BANK_BASE+0x22CA3)
#define REG_FRC_BK22C_A4        (REG_FRC_BANK_BASE+0x22CA4)
#define REG_FRC_BK22C_A5        (REG_FRC_BANK_BASE+0x22CA5)
#define REG_FRC_BK22C_A6        (REG_FRC_BANK_BASE+0x22CA6)
#define REG_FRC_BK22C_A7        (REG_FRC_BANK_BASE+0x22CA7)
#define REG_FRC_BK22C_A8        (REG_FRC_BANK_BASE+0x22CA8)
#define REG_FRC_BK22C_A9        (REG_FRC_BANK_BASE+0x22CA9)
#define REG_FRC_BK22C_AA        (REG_FRC_BANK_BASE+0x22CAA)
#define REG_FRC_BK22C_AB        (REG_FRC_BANK_BASE+0x22CAB)
#define REG_FRC_BK22C_AC        (REG_FRC_BANK_BASE+0x22CAC)
#define REG_FRC_BK22C_AD        (REG_FRC_BANK_BASE+0x22CAD)
#define REG_FRC_BK22C_AE        (REG_FRC_BANK_BASE+0x22CAE)
#define REG_FRC_BK22C_AF        (REG_FRC_BANK_BASE+0x22CAF)
#define REG_FRC_BK22C_B0        (REG_FRC_BANK_BASE+0x22CB0)
#define REG_FRC_BK22C_B1        (REG_FRC_BANK_BASE+0x22CB1)
#define REG_FRC_BK22C_B2        (REG_FRC_BANK_BASE+0x22CB2)
#define REG_FRC_BK22C_B3        (REG_FRC_BANK_BASE+0x22CB3)
#define REG_FRC_BK22C_B4        (REG_FRC_BANK_BASE+0x22CB4)
#define REG_FRC_BK22C_B5        (REG_FRC_BANK_BASE+0x22CB5)
#define REG_FRC_BK22C_B6        (REG_FRC_BANK_BASE+0x22CB6)
#define REG_FRC_BK22C_B7        (REG_FRC_BANK_BASE+0x22CB7)
#define REG_FRC_BK22C_B8        (REG_FRC_BANK_BASE+0x22CB8)
#define REG_FRC_BK22C_B9        (REG_FRC_BANK_BASE+0x22CB9)
#define REG_FRC_BK22C_BA        (REG_FRC_BANK_BASE+0x22CBA)
#define REG_FRC_BK22C_BB        (REG_FRC_BANK_BASE+0x22CBB)
#define REG_FRC_BK22C_BC        (REG_FRC_BANK_BASE+0x22CBC)
#define REG_FRC_BK22C_BD        (REG_FRC_BANK_BASE+0x22CBD)
#define REG_FRC_BK22C_BE        (REG_FRC_BANK_BASE+0x22CBE)
#define REG_FRC_BK22C_BF        (REG_FRC_BANK_BASE+0x22CBF)
#define REG_FRC_BK22C_C0        (REG_FRC_BANK_BASE+0x22CC0)
#define REG_FRC_BK22C_C1        (REG_FRC_BANK_BASE+0x22CC1)
#define REG_FRC_BK22C_C2        (REG_FRC_BANK_BASE+0x22CC2)
#define REG_FRC_BK22C_C3        (REG_FRC_BANK_BASE+0x22CC3)
#define REG_FRC_BK22C_C4        (REG_FRC_BANK_BASE+0x22CC4)
#define REG_FRC_BK22C_C5        (REG_FRC_BANK_BASE+0x22CC5)
#define REG_FRC_BK22C_C6        (REG_FRC_BANK_BASE+0x22CC6)
#define REG_FRC_BK22C_C7        (REG_FRC_BANK_BASE+0x22CC7)
#define REG_FRC_BK22C_C8        (REG_FRC_BANK_BASE+0x22CC8)
#define REG_FRC_BK22C_C9        (REG_FRC_BANK_BASE+0x22CC9)
#define REG_FRC_BK22C_CA        (REG_FRC_BANK_BASE+0x22CCA)
#define REG_FRC_BK22C_CB        (REG_FRC_BANK_BASE+0x22CCB)
#define REG_FRC_BK22C_CC        (REG_FRC_BANK_BASE+0x22CCC)
#define REG_FRC_BK22C_CD        (REG_FRC_BANK_BASE+0x22CCD)
#define REG_FRC_BK22C_CE        (REG_FRC_BANK_BASE+0x22CCE)
#define REG_FRC_BK22C_CF        (REG_FRC_BANK_BASE+0x22CCF)
#define REG_FRC_BK22C_D0        (REG_FRC_BANK_BASE+0x22CD0)
#define REG_FRC_BK22C_D1        (REG_FRC_BANK_BASE+0x22CD1)
#define REG_FRC_BK22C_D2        (REG_FRC_BANK_BASE+0x22CD2)
#define REG_FRC_BK22C_D3        (REG_FRC_BANK_BASE+0x22CD3)
#define REG_FRC_BK22C_D4        (REG_FRC_BANK_BASE+0x22CD4)
#define REG_FRC_BK22C_D5        (REG_FRC_BANK_BASE+0x22CD5)
#define REG_FRC_BK22C_D6        (REG_FRC_BANK_BASE+0x22CD6)
#define REG_FRC_BK22C_D7        (REG_FRC_BANK_BASE+0x22CD7)
#define REG_FRC_BK22C_D8        (REG_FRC_BANK_BASE+0x22CD8)
#define REG_FRC_BK22C_D9        (REG_FRC_BANK_BASE+0x22CD9)
#define REG_FRC_BK22C_DA        (REG_FRC_BANK_BASE+0x22CDA)
#define REG_FRC_BK22C_DB        (REG_FRC_BANK_BASE+0x22CDB)
#define REG_FRC_BK22C_DC        (REG_FRC_BANK_BASE+0x22CDC)
#define REG_FRC_BK22C_DD        (REG_FRC_BANK_BASE+0x22CDD)
#define REG_FRC_BK22C_DE        (REG_FRC_BANK_BASE+0x22CDE)
#define REG_FRC_BK22C_DF        (REG_FRC_BANK_BASE+0x22CDF)
#define REG_FRC_BK22C_E0        (REG_FRC_BANK_BASE+0x22CE0)
#define REG_FRC_BK22C_E1        (REG_FRC_BANK_BASE+0x22CE1)
#define REG_FRC_BK22C_E2        (REG_FRC_BANK_BASE+0x22CE2)
#define REG_FRC_BK22C_E3        (REG_FRC_BANK_BASE+0x22CE3)
#define REG_FRC_BK22C_E4        (REG_FRC_BANK_BASE+0x22CE4)
#define REG_FRC_BK22C_E5        (REG_FRC_BANK_BASE+0x22CE5)
#define REG_FRC_BK22C_E6        (REG_FRC_BANK_BASE+0x22CE6)
#define REG_FRC_BK22C_E7        (REG_FRC_BANK_BASE+0x22CE7)
#define REG_FRC_BK22C_E8        (REG_FRC_BANK_BASE+0x22CE8)
#define REG_FRC_BK22C_E9        (REG_FRC_BANK_BASE+0x22CE9)
#define REG_FRC_BK22C_EA        (REG_FRC_BANK_BASE+0x22CEA)
#define REG_FRC_BK22C_EB        (REG_FRC_BANK_BASE+0x22CEB)
#define REG_FRC_BK22C_EC        (REG_FRC_BANK_BASE+0x22CEC)
#define REG_FRC_BK22C_ED        (REG_FRC_BANK_BASE+0x22CED)
#define REG_FRC_BK22C_EE        (REG_FRC_BANK_BASE+0x22CEE)
#define REG_FRC_BK22C_EF        (REG_FRC_BANK_BASE+0x22CEF)
#define REG_FRC_BK22C_F0        (REG_FRC_BANK_BASE+0x22CF0)
#define REG_FRC_BK22C_F1        (REG_FRC_BANK_BASE+0x22CF1)
#define REG_FRC_BK22C_F2        (REG_FRC_BANK_BASE+0x22CF2)
#define REG_FRC_BK22C_F3        (REG_FRC_BANK_BASE+0x22CF3)
#define REG_FRC_BK22C_F4        (REG_FRC_BANK_BASE+0x22CF4)
#define REG_FRC_BK22C_F5        (REG_FRC_BANK_BASE+0x22CF5)
#define REG_FRC_BK22C_F6        (REG_FRC_BANK_BASE+0x22CF6)
#define REG_FRC_BK22C_F7        (REG_FRC_BANK_BASE+0x22CF7)
#define REG_FRC_BK22C_F8        (REG_FRC_BANK_BASE+0x22CF8)
#define REG_FRC_BK22C_F9        (REG_FRC_BANK_BASE+0x22CF9)
#define REG_FRC_BK22C_FA        (REG_FRC_BANK_BASE+0x22CFA)
#define REG_FRC_BK22C_FB        (REG_FRC_BANK_BASE+0x22CFB)
#define REG_FRC_BK22C_FC        (REG_FRC_BANK_BASE+0x22CFC)
#define REG_FRC_BK22C_FD        (REG_FRC_BANK_BASE+0x22CFD)
#define REG_FRC_BK22C_FE        (REG_FRC_BANK_BASE+0x22CFE)
#define REG_FRC_BK22C_FF        (REG_FRC_BANK_BASE+0x22CFF)

// === FRC bk2E
#define REG_FRC_BK2E_00        (REG_FRC_BANK_BASE+0x2E00)
#define REG_FRC_BK2E_01        (REG_FRC_BANK_BASE+0x2E01)
#define REG_FRC_BK2E_02        (REG_FRC_BANK_BASE+0x2E02)
#define REG_FRC_BK2E_03        (REG_FRC_BANK_BASE+0x2E03)
#define REG_FRC_BK2E_04        (REG_FRC_BANK_BASE+0x2E04)
#define REG_FRC_BK2E_05        (REG_FRC_BANK_BASE+0x2E05)
#define REG_FRC_BK2E_06        (REG_FRC_BANK_BASE+0x2E06)
#define REG_FRC_BK2E_07        (REG_FRC_BANK_BASE+0x2E07)
#define REG_FRC_BK2E_08        (REG_FRC_BANK_BASE+0x2E08)
#define REG_FRC_BK2E_09        (REG_FRC_BANK_BASE+0x2E09)
#define REG_FRC_BK2E_0A        (REG_FRC_BANK_BASE+0x2E0A)
#define REG_FRC_BK2E_0B        (REG_FRC_BANK_BASE+0x2E0B)
#define REG_FRC_BK2E_0C        (REG_FRC_BANK_BASE+0x2E0C)
#define REG_FRC_BK2E_0D        (REG_FRC_BANK_BASE+0x2E0D)
#define REG_FRC_BK2E_0E        (REG_FRC_BANK_BASE+0x2E0E)
#define REG_FRC_BK2E_0F        (REG_FRC_BANK_BASE+0x2E0F)
#define REG_FRC_BK2E_10        (REG_FRC_BANK_BASE+0x2E10)
#define REG_FRC_BK2E_11        (REG_FRC_BANK_BASE+0x2E11)
#define REG_FRC_BK2E_12        (REG_FRC_BANK_BASE+0x2E12)
#define REG_FRC_BK2E_13        (REG_FRC_BANK_BASE+0x2E13)
#define REG_FRC_BK2E_14        (REG_FRC_BANK_BASE+0x2E14)
#define REG_FRC_BK2E_15        (REG_FRC_BANK_BASE+0x2E15)
#define REG_FRC_BK2E_16        (REG_FRC_BANK_BASE+0x2E16)
#define REG_FRC_BK2E_17        (REG_FRC_BANK_BASE+0x2E17)
#define REG_FRC_BK2E_18        (REG_FRC_BANK_BASE+0x2E18)
#define REG_FRC_BK2E_19        (REG_FRC_BANK_BASE+0x2E19)
#define REG_FRC_BK2E_1A        (REG_FRC_BANK_BASE+0x2E1A)
#define REG_FRC_BK2E_1B        (REG_FRC_BANK_BASE+0x2E1B)
#define REG_FRC_BK2E_1C        (REG_FRC_BANK_BASE+0x2E1C)
#define REG_FRC_BK2E_1D        (REG_FRC_BANK_BASE+0x2E1D)
#define REG_FRC_BK2E_1E        (REG_FRC_BANK_BASE+0x2E1E)
#define REG_FRC_BK2E_1F        (REG_FRC_BANK_BASE+0x2E1F)
#define REG_FRC_BK2E_20        (REG_FRC_BANK_BASE+0x2E20)
#define REG_FRC_BK2E_21        (REG_FRC_BANK_BASE+0x2E21)
#define REG_FRC_BK2E_22        (REG_FRC_BANK_BASE+0x2E22)
#define REG_FRC_BK2E_23        (REG_FRC_BANK_BASE+0x2E23)
#define REG_FRC_BK2E_24        (REG_FRC_BANK_BASE+0x2E24)
#define REG_FRC_BK2E_25        (REG_FRC_BANK_BASE+0x2E25)
#define REG_FRC_BK2E_26        (REG_FRC_BANK_BASE+0x2E26)
#define REG_FRC_BK2E_27        (REG_FRC_BANK_BASE+0x2E27)
#define REG_FRC_BK2E_28        (REG_FRC_BANK_BASE+0x2E28)
#define REG_FRC_BK2E_29        (REG_FRC_BANK_BASE+0x2E29)
#define REG_FRC_BK2E_2A        (REG_FRC_BANK_BASE+0x2E2A)
#define REG_FRC_BK2E_2B        (REG_FRC_BANK_BASE+0x2E2B)
#define REG_FRC_BK2E_2C        (REG_FRC_BANK_BASE+0x2E2C)
#define REG_FRC_BK2E_2D        (REG_FRC_BANK_BASE+0x2E2D)
#define REG_FRC_BK2E_2E        (REG_FRC_BANK_BASE+0x2E2E)
#define REG_FRC_BK2E_2F        (REG_FRC_BANK_BASE+0x2E2F)
#define REG_FRC_BK2E_30        (REG_FRC_BANK_BASE+0x2E30)
#define REG_FRC_BK2E_31        (REG_FRC_BANK_BASE+0x2E31)
#define REG_FRC_BK2E_32        (REG_FRC_BANK_BASE+0x2E32)
#define REG_FRC_BK2E_33        (REG_FRC_BANK_BASE+0x2E33)
#define REG_FRC_BK2E_34        (REG_FRC_BANK_BASE+0x2E34)
#define REG_FRC_BK2E_35        (REG_FRC_BANK_BASE+0x2E35)
#define REG_FRC_BK2E_36        (REG_FRC_BANK_BASE+0x2E36)
#define REG_FRC_BK2E_37        (REG_FRC_BANK_BASE+0x2E37)
#define REG_FRC_BK2E_38        (REG_FRC_BANK_BASE+0x2E38)
#define REG_FRC_BK2E_39        (REG_FRC_BANK_BASE+0x2E39)
#define REG_FRC_BK2E_3A        (REG_FRC_BANK_BASE+0x2E3A)
#define REG_FRC_BK2E_3B        (REG_FRC_BANK_BASE+0x2E3B)
#define REG_FRC_BK2E_3C        (REG_FRC_BANK_BASE+0x2E3C)
#define REG_FRC_BK2E_3D        (REG_FRC_BANK_BASE+0x2E3D)
#define REG_FRC_BK2E_3E        (REG_FRC_BANK_BASE+0x2E3E)
#define REG_FRC_BK2E_3F        (REG_FRC_BANK_BASE+0x2E3F)
#define REG_FRC_BK2E_40        (REG_FRC_BANK_BASE+0x2E40)
#define REG_FRC_BK2E_41        (REG_FRC_BANK_BASE+0x2E41)
#define REG_FRC_BK2E_42        (REG_FRC_BANK_BASE+0x2E42)
#define REG_FRC_BK2E_43        (REG_FRC_BANK_BASE+0x2E43)
#define REG_FRC_BK2E_44        (REG_FRC_BANK_BASE+0x2E44)
#define REG_FRC_BK2E_45        (REG_FRC_BANK_BASE+0x2E45)
#define REG_FRC_BK2E_46        (REG_FRC_BANK_BASE+0x2E46)
#define REG_FRC_BK2E_47        (REG_FRC_BANK_BASE+0x2E47)
#define REG_FRC_BK2E_48        (REG_FRC_BANK_BASE+0x2E48)
#define REG_FRC_BK2E_49        (REG_FRC_BANK_BASE+0x2E49)
#define REG_FRC_BK2E_4A        (REG_FRC_BANK_BASE+0x2E4A)
#define REG_FRC_BK2E_4B        (REG_FRC_BANK_BASE+0x2E4B)
#define REG_FRC_BK2E_4C        (REG_FRC_BANK_BASE+0x2E4C)
#define REG_FRC_BK2E_4D        (REG_FRC_BANK_BASE+0x2E4D)
#define REG_FRC_BK2E_4E        (REG_FRC_BANK_BASE+0x2E4E)
#define REG_FRC_BK2E_4F        (REG_FRC_BANK_BASE+0x2E4F)
#define REG_FRC_BK2E_50        (REG_FRC_BANK_BASE+0x2E50)
#define REG_FRC_BK2E_51        (REG_FRC_BANK_BASE+0x2E51)
#define REG_FRC_BK2E_52        (REG_FRC_BANK_BASE+0x2E52)
#define REG_FRC_BK2E_53        (REG_FRC_BANK_BASE+0x2E53)
#define REG_FRC_BK2E_54        (REG_FRC_BANK_BASE+0x2E54)
#define REG_FRC_BK2E_55        (REG_FRC_BANK_BASE+0x2E55)
#define REG_FRC_BK2E_56        (REG_FRC_BANK_BASE+0x2E56)
#define REG_FRC_BK2E_57        (REG_FRC_BANK_BASE+0x2E57)
#define REG_FRC_BK2E_58        (REG_FRC_BANK_BASE+0x2E58)
#define REG_FRC_BK2E_59        (REG_FRC_BANK_BASE+0x2E59)
#define REG_FRC_BK2E_5A        (REG_FRC_BANK_BASE+0x2E5A)
#define REG_FRC_BK2E_5B        (REG_FRC_BANK_BASE+0x2E5B)
#define REG_FRC_BK2E_5C        (REG_FRC_BANK_BASE+0x2E5C)
#define REG_FRC_BK2E_5D        (REG_FRC_BANK_BASE+0x2E5D)
#define REG_FRC_BK2E_5E        (REG_FRC_BANK_BASE+0x2E5E)
#define REG_FRC_BK2E_5F        (REG_FRC_BANK_BASE+0x2E5F)
#define REG_FRC_BK2E_60        (REG_FRC_BANK_BASE+0x2E60)
#define REG_FRC_BK2E_61        (REG_FRC_BANK_BASE+0x2E61)
#define REG_FRC_BK2E_62        (REG_FRC_BANK_BASE+0x2E62)
#define REG_FRC_BK2E_63        (REG_FRC_BANK_BASE+0x2E63)
#define REG_FRC_BK2E_64        (REG_FRC_BANK_BASE+0x2E64)
#define REG_FRC_BK2E_65        (REG_FRC_BANK_BASE+0x2E65)
#define REG_FRC_BK2E_66        (REG_FRC_BANK_BASE+0x2E66)
#define REG_FRC_BK2E_67        (REG_FRC_BANK_BASE+0x2E67)
#define REG_FRC_BK2E_68        (REG_FRC_BANK_BASE+0x2E68)
#define REG_FRC_BK2E_69        (REG_FRC_BANK_BASE+0x2E69)
#define REG_FRC_BK2E_6A        (REG_FRC_BANK_BASE+0x2E6A)
#define REG_FRC_BK2E_6B        (REG_FRC_BANK_BASE+0x2E6B)
#define REG_FRC_BK2E_6C        (REG_FRC_BANK_BASE+0x2E6C)
#define REG_FRC_BK2E_6D        (REG_FRC_BANK_BASE+0x2E6D)
#define REG_FRC_BK2E_6E        (REG_FRC_BANK_BASE+0x2E6E)
#define REG_FRC_BK2E_6F        (REG_FRC_BANK_BASE+0x2E6F)
#define REG_FRC_BK2E_70        (REG_FRC_BANK_BASE+0x2E70)
#define REG_FRC_BK2E_71        (REG_FRC_BANK_BASE+0x2E71)
#define REG_FRC_BK2E_72        (REG_FRC_BANK_BASE+0x2E72)
#define REG_FRC_BK2E_73        (REG_FRC_BANK_BASE+0x2E73)
#define REG_FRC_BK2E_74        (REG_FRC_BANK_BASE+0x2E74)
#define REG_FRC_BK2E_75        (REG_FRC_BANK_BASE+0x2E75)
#define REG_FRC_BK2E_76        (REG_FRC_BANK_BASE+0x2E76)
#define REG_FRC_BK2E_77        (REG_FRC_BANK_BASE+0x2E77)
#define REG_FRC_BK2E_78        (REG_FRC_BANK_BASE+0x2E78)
#define REG_FRC_BK2E_79        (REG_FRC_BANK_BASE+0x2E79)
#define REG_FRC_BK2E_7A        (REG_FRC_BANK_BASE+0x2E7A)
#define REG_FRC_BK2E_7B        (REG_FRC_BANK_BASE+0x2E7B)
#define REG_FRC_BK2E_7C        (REG_FRC_BANK_BASE+0x2E7C)
#define REG_FRC_BK2E_7D        (REG_FRC_BANK_BASE+0x2E7D)
#define REG_FRC_BK2E_7E        (REG_FRC_BANK_BASE+0x2E7E)
#define REG_FRC_BK2E_7F        (REG_FRC_BANK_BASE+0x2E7F)
#define REG_FRC_BK2E_80        (REG_FRC_BANK_BASE+0x2E80)
#define REG_FRC_BK2E_81        (REG_FRC_BANK_BASE+0x2E81)
#define REG_FRC_BK2E_82        (REG_FRC_BANK_BASE+0x2E82)
#define REG_FRC_BK2E_83        (REG_FRC_BANK_BASE+0x2E83)
#define REG_FRC_BK2E_84        (REG_FRC_BANK_BASE+0x2E84)
#define REG_FRC_BK2E_85        (REG_FRC_BANK_BASE+0x2E85)
#define REG_FRC_BK2E_86        (REG_FRC_BANK_BASE+0x2E86)
#define REG_FRC_BK2E_87        (REG_FRC_BANK_BASE+0x2E87)
#define REG_FRC_BK2E_88        (REG_FRC_BANK_BASE+0x2E88)
#define REG_FRC_BK2E_89        (REG_FRC_BANK_BASE+0x2E89)
#define REG_FRC_BK2E_8A        (REG_FRC_BANK_BASE+0x2E8A)
#define REG_FRC_BK2E_8B        (REG_FRC_BANK_BASE+0x2E8B)
#define REG_FRC_BK2E_8C        (REG_FRC_BANK_BASE+0x2E8C)
#define REG_FRC_BK2E_8D        (REG_FRC_BANK_BASE+0x2E8D)
#define REG_FRC_BK2E_8E        (REG_FRC_BANK_BASE+0x2E8E)
#define REG_FRC_BK2E_8F        (REG_FRC_BANK_BASE+0x2E8F)
#define REG_FRC_BK2E_90        (REG_FRC_BANK_BASE+0x2E90)
#define REG_FRC_BK2E_91        (REG_FRC_BANK_BASE+0x2E91)
#define REG_FRC_BK2E_92        (REG_FRC_BANK_BASE+0x2E92)
#define REG_FRC_BK2E_93        (REG_FRC_BANK_BASE+0x2E93)
#define REG_FRC_BK2E_94        (REG_FRC_BANK_BASE+0x2E94)
#define REG_FRC_BK2E_95        (REG_FRC_BANK_BASE+0x2E95)
#define REG_FRC_BK2E_96        (REG_FRC_BANK_BASE+0x2E96)
#define REG_FRC_BK2E_97        (REG_FRC_BANK_BASE+0x2E97)
#define REG_FRC_BK2E_98        (REG_FRC_BANK_BASE+0x2E98)
#define REG_FRC_BK2E_99        (REG_FRC_BANK_BASE+0x2E99)
#define REG_FRC_BK2E_9A        (REG_FRC_BANK_BASE+0x2E9A)
#define REG_FRC_BK2E_9B        (REG_FRC_BANK_BASE+0x2E9B)
#define REG_FRC_BK2E_9C        (REG_FRC_BANK_BASE+0x2E9C)
#define REG_FRC_BK2E_9D        (REG_FRC_BANK_BASE+0x2E9D)
#define REG_FRC_BK2E_9E        (REG_FRC_BANK_BASE+0x2E9E)
#define REG_FRC_BK2E_9F        (REG_FRC_BANK_BASE+0x2E9F)
#define REG_FRC_BK2E_A0        (REG_FRC_BANK_BASE+0x2EA0)
#define REG_FRC_BK2E_A1        (REG_FRC_BANK_BASE+0x2EA1)
#define REG_FRC_BK2E_A2        (REG_FRC_BANK_BASE+0x2EA2)
#define REG_FRC_BK2E_A3        (REG_FRC_BANK_BASE+0x2EA3)
#define REG_FRC_BK2E_A4        (REG_FRC_BANK_BASE+0x2EA4)
#define REG_FRC_BK2E_A5        (REG_FRC_BANK_BASE+0x2EA5)
#define REG_FRC_BK2E_A6        (REG_FRC_BANK_BASE+0x2EA6)
#define REG_FRC_BK2E_A7        (REG_FRC_BANK_BASE+0x2EA7)
#define REG_FRC_BK2E_A8        (REG_FRC_BANK_BASE+0x2EA8)
#define REG_FRC_BK2E_A9        (REG_FRC_BANK_BASE+0x2EA9)
#define REG_FRC_BK2E_AA        (REG_FRC_BANK_BASE+0x2EAA)
#define REG_FRC_BK2E_AB        (REG_FRC_BANK_BASE+0x2EAB)
#define REG_FRC_BK2E_AC        (REG_FRC_BANK_BASE+0x2EAC)
#define REG_FRC_BK2E_AD        (REG_FRC_BANK_BASE+0x2EAD)
#define REG_FRC_BK2E_AE        (REG_FRC_BANK_BASE+0x2EAE)
#define REG_FRC_BK2E_AF        (REG_FRC_BANK_BASE+0x2EAF)
#define REG_FRC_BK2E_B0        (REG_FRC_BANK_BASE+0x2EB0)
#define REG_FRC_BK2E_B1        (REG_FRC_BANK_BASE+0x2EB1)
#define REG_FRC_BK2E_B2        (REG_FRC_BANK_BASE+0x2EB2)
#define REG_FRC_BK2E_B3        (REG_FRC_BANK_BASE+0x2EB3)
#define REG_FRC_BK2E_B4        (REG_FRC_BANK_BASE+0x2EB4)
#define REG_FRC_BK2E_B5        (REG_FRC_BANK_BASE+0x2EB5)
#define REG_FRC_BK2E_B6        (REG_FRC_BANK_BASE+0x2EB6)
#define REG_FRC_BK2E_B7        (REG_FRC_BANK_BASE+0x2EB7)
#define REG_FRC_BK2E_B8        (REG_FRC_BANK_BASE+0x2EB8)
#define REG_FRC_BK2E_B9        (REG_FRC_BANK_BASE+0x2EB9)
#define REG_FRC_BK2E_BA        (REG_FRC_BANK_BASE+0x2EBA)
#define REG_FRC_BK2E_BB        (REG_FRC_BANK_BASE+0x2EBB)
#define REG_FRC_BK2E_BC        (REG_FRC_BANK_BASE+0x2EBC)
#define REG_FRC_BK2E_BD        (REG_FRC_BANK_BASE+0x2EBD)
#define REG_FRC_BK2E_BE        (REG_FRC_BANK_BASE+0x2EBE)
#define REG_FRC_BK2E_BF        (REG_FRC_BANK_BASE+0x2EBF)
#define REG_FRC_BK2E_C0        (REG_FRC_BANK_BASE+0x2EC0)
#define REG_FRC_BK2E_C1        (REG_FRC_BANK_BASE+0x2EC1)
#define REG_FRC_BK2E_C2        (REG_FRC_BANK_BASE+0x2EC2)
#define REG_FRC_BK2E_C3        (REG_FRC_BANK_BASE+0x2EC3)
#define REG_FRC_BK2E_C4        (REG_FRC_BANK_BASE+0x2EC4)
#define REG_FRC_BK2E_C5        (REG_FRC_BANK_BASE+0x2EC5)
#define REG_FRC_BK2E_C6        (REG_FRC_BANK_BASE+0x2EC6)
#define REG_FRC_BK2E_C7        (REG_FRC_BANK_BASE+0x2EC7)
#define REG_FRC_BK2E_C8        (REG_FRC_BANK_BASE+0x2EC8)
#define REG_FRC_BK2E_C9        (REG_FRC_BANK_BASE+0x2EC9)
#define REG_FRC_BK2E_CA        (REG_FRC_BANK_BASE+0x2ECA)
#define REG_FRC_BK2E_CB        (REG_FRC_BANK_BASE+0x2ECB)
#define REG_FRC_BK2E_CC        (REG_FRC_BANK_BASE+0x2ECC)
#define REG_FRC_BK2E_CD        (REG_FRC_BANK_BASE+0x2ECD)
#define REG_FRC_BK2E_CE        (REG_FRC_BANK_BASE+0x2ECE)
#define REG_FRC_BK2E_CF        (REG_FRC_BANK_BASE+0x2ECF)
#define REG_FRC_BK2E_D0        (REG_FRC_BANK_BASE+0x2ED0)
#define REG_FRC_BK2E_D1        (REG_FRC_BANK_BASE+0x2ED1)
#define REG_FRC_BK2E_D2        (REG_FRC_BANK_BASE+0x2ED2)
#define REG_FRC_BK2E_D3        (REG_FRC_BANK_BASE+0x2ED3)
#define REG_FRC_BK2E_D4        (REG_FRC_BANK_BASE+0x2ED4)
#define REG_FRC_BK2E_D5        (REG_FRC_BANK_BASE+0x2ED5)
#define REG_FRC_BK2E_D6        (REG_FRC_BANK_BASE+0x2ED6)
#define REG_FRC_BK2E_D7        (REG_FRC_BANK_BASE+0x2ED7)
#define REG_FRC_BK2E_D8        (REG_FRC_BANK_BASE+0x2ED8)
#define REG_FRC_BK2E_D9        (REG_FRC_BANK_BASE+0x2ED9)
#define REG_FRC_BK2E_DA        (REG_FRC_BANK_BASE+0x2EDA)
#define REG_FRC_BK2E_DB        (REG_FRC_BANK_BASE+0x2EDB)
#define REG_FRC_BK2E_DC        (REG_FRC_BANK_BASE+0x2EDC)
#define REG_FRC_BK2E_DD        (REG_FRC_BANK_BASE+0x2EDD)
#define REG_FRC_BK2E_DE        (REG_FRC_BANK_BASE+0x2EDE)
#define REG_FRC_BK2E_DF        (REG_FRC_BANK_BASE+0x2EDF)
#define REG_FRC_BK2E_E0        (REG_FRC_BANK_BASE+0x2EE0)
#define REG_FRC_BK2E_E1        (REG_FRC_BANK_BASE+0x2EE1)
#define REG_FRC_BK2E_E2        (REG_FRC_BANK_BASE+0x2EE2)
#define REG_FRC_BK2E_E3        (REG_FRC_BANK_BASE+0x2EE3)
#define REG_FRC_BK2E_E4        (REG_FRC_BANK_BASE+0x2EE4)
#define REG_FRC_BK2E_E5        (REG_FRC_BANK_BASE+0x2EE5)
#define REG_FRC_BK2E_E6        (REG_FRC_BANK_BASE+0x2EE6)
#define REG_FRC_BK2E_E7        (REG_FRC_BANK_BASE+0x2EE7)
#define REG_FRC_BK2E_E8        (REG_FRC_BANK_BASE+0x2EE8)
#define REG_FRC_BK2E_E9        (REG_FRC_BANK_BASE+0x2EE9)
#define REG_FRC_BK2E_EA        (REG_FRC_BANK_BASE+0x2EEA)
#define REG_FRC_BK2E_EB        (REG_FRC_BANK_BASE+0x2EEB)
#define REG_FRC_BK2E_EC        (REG_FRC_BANK_BASE+0x2EEC)
#define REG_FRC_BK2E_ED        (REG_FRC_BANK_BASE+0x2EED)
#define REG_FRC_BK2E_EE        (REG_FRC_BANK_BASE+0x2EEE)
#define REG_FRC_BK2E_EF        (REG_FRC_BANK_BASE+0x2EEF)
#define REG_FRC_BK2E_F0        (REG_FRC_BANK_BASE+0x2EF0)
#define REG_FRC_BK2E_F1        (REG_FRC_BANK_BASE+0x2EF1)
#define REG_FRC_BK2E_F2        (REG_FRC_BANK_BASE+0x2EF2)
#define REG_FRC_BK2E_F3        (REG_FRC_BANK_BASE+0x2EF3)
#define REG_FRC_BK2E_F4        (REG_FRC_BANK_BASE+0x2EF4)
#define REG_FRC_BK2E_F5        (REG_FRC_BANK_BASE+0x2EF5)
#define REG_FRC_BK2E_F6        (REG_FRC_BANK_BASE+0x2EF6)
#define REG_FRC_BK2E_F7        (REG_FRC_BANK_BASE+0x2EF7)
#define REG_FRC_BK2E_F8        (REG_FRC_BANK_BASE+0x2EF8)
#define REG_FRC_BK2E_F9        (REG_FRC_BANK_BASE+0x2EF9)
#define REG_FRC_BK2E_FA        (REG_FRC_BANK_BASE+0x2EFA)
#define REG_FRC_BK2E_FB        (REG_FRC_BANK_BASE+0x2EFB)
#define REG_FRC_BK2E_FC        (REG_FRC_BANK_BASE+0x2EFC)
#define REG_FRC_BK2E_FD        (REG_FRC_BANK_BASE+0x2EFD)
#define REG_FRC_BK2E_FE        (REG_FRC_BANK_BASE+0x2EFE)
#define REG_FRC_BK2E_FF        (REG_FRC_BANK_BASE+0x2EFF)

// === FRC bk3E
#define REG_FRC_BK3E_00        (REG_FRC_BANK_BASE+0x3E00)
#define REG_FRC_BK3E_01        (REG_FRC_BANK_BASE+0x3E01)
#define REG_FRC_BK3E_02        (REG_FRC_BANK_BASE+0x3E02)
#define REG_FRC_BK3E_03        (REG_FRC_BANK_BASE+0x3E03)
#define REG_FRC_BK3E_04        (REG_FRC_BANK_BASE+0x3E04)
#define REG_FRC_BK3E_05        (REG_FRC_BANK_BASE+0x3E05)
#define REG_FRC_BK3E_06        (REG_FRC_BANK_BASE+0x3E06)
#define REG_FRC_BK3E_07        (REG_FRC_BANK_BASE+0x3E07)
#define REG_FRC_BK3E_08        (REG_FRC_BANK_BASE+0x3E08)
#define REG_FRC_BK3E_09        (REG_FRC_BANK_BASE+0x3E09)
#define REG_FRC_BK3E_0A        (REG_FRC_BANK_BASE+0x3E0A)
#define REG_FRC_BK3E_0B        (REG_FRC_BANK_BASE+0x3E0B)
#define REG_FRC_BK3E_0C        (REG_FRC_BANK_BASE+0x3E0C)
#define REG_FRC_BK3E_0D        (REG_FRC_BANK_BASE+0x3E0D)
#define REG_FRC_BK3E_0E        (REG_FRC_BANK_BASE+0x3E0E)
#define REG_FRC_BK3E_0F        (REG_FRC_BANK_BASE+0x3E0F)
#define REG_FRC_BK3E_10        (REG_FRC_BANK_BASE+0x3E10)
#define REG_FRC_BK3E_11        (REG_FRC_BANK_BASE+0x3E11)
#define REG_FRC_BK3E_12        (REG_FRC_BANK_BASE+0x3E12)
#define REG_FRC_BK3E_13        (REG_FRC_BANK_BASE+0x3E13)
#define REG_FRC_BK3E_14        (REG_FRC_BANK_BASE+0x3E14)
#define REG_FRC_BK3E_15        (REG_FRC_BANK_BASE+0x3E15)
#define REG_FRC_BK3E_16        (REG_FRC_BANK_BASE+0x3E16)
#define REG_FRC_BK3E_17        (REG_FRC_BANK_BASE+0x3E17)
#define REG_FRC_BK3E_18        (REG_FRC_BANK_BASE+0x3E18)
#define REG_FRC_BK3E_19        (REG_FRC_BANK_BASE+0x3E19)
#define REG_FRC_BK3E_1A        (REG_FRC_BANK_BASE+0x3E1A)
#define REG_FRC_BK3E_1B        (REG_FRC_BANK_BASE+0x3E1B)
#define REG_FRC_BK3E_1C        (REG_FRC_BANK_BASE+0x3E1C)
#define REG_FRC_BK3E_1D        (REG_FRC_BANK_BASE+0x3E1D)
#define REG_FRC_BK3E_1E        (REG_FRC_BANK_BASE+0x3E1E)
#define REG_FRC_BK3E_1F        (REG_FRC_BANK_BASE+0x3E1F)
#define REG_FRC_BK3E_20        (REG_FRC_BANK_BASE+0x3E20)
#define REG_FRC_BK3E_21        (REG_FRC_BANK_BASE+0x3E21)
#define REG_FRC_BK3E_22        (REG_FRC_BANK_BASE+0x3E22)
#define REG_FRC_BK3E_23        (REG_FRC_BANK_BASE+0x3E23)
#define REG_FRC_BK3E_24        (REG_FRC_BANK_BASE+0x3E24)
#define REG_FRC_BK3E_25        (REG_FRC_BANK_BASE+0x3E25)
#define REG_FRC_BK3E_26        (REG_FRC_BANK_BASE+0x3E26)
#define REG_FRC_BK3E_27        (REG_FRC_BANK_BASE+0x3E27)
#define REG_FRC_BK3E_28        (REG_FRC_BANK_BASE+0x3E28)
#define REG_FRC_BK3E_29        (REG_FRC_BANK_BASE+0x3E29)
#define REG_FRC_BK3E_2A        (REG_FRC_BANK_BASE+0x3E2A)
#define REG_FRC_BK3E_2B        (REG_FRC_BANK_BASE+0x3E2B)
#define REG_FRC_BK3E_2C        (REG_FRC_BANK_BASE+0x3E2C)
#define REG_FRC_BK3E_2D        (REG_FRC_BANK_BASE+0x3E2D)
#define REG_FRC_BK3E_2E        (REG_FRC_BANK_BASE+0x3E2E)
#define REG_FRC_BK3E_2F        (REG_FRC_BANK_BASE+0x3E2F)
#define REG_FRC_BK3E_30        (REG_FRC_BANK_BASE+0x3E30)
#define REG_FRC_BK3E_31        (REG_FRC_BANK_BASE+0x3E31)
#define REG_FRC_BK3E_32        (REG_FRC_BANK_BASE+0x3E32)
#define REG_FRC_BK3E_33        (REG_FRC_BANK_BASE+0x3E33)
#define REG_FRC_BK3E_34        (REG_FRC_BANK_BASE+0x3E34)
#define REG_FRC_BK3E_35        (REG_FRC_BANK_BASE+0x3E35)
#define REG_FRC_BK3E_36        (REG_FRC_BANK_BASE+0x3E36)
#define REG_FRC_BK3E_37        (REG_FRC_BANK_BASE+0x3E37)
#define REG_FRC_BK3E_38        (REG_FRC_BANK_BASE+0x3E38)
#define REG_FRC_BK3E_39        (REG_FRC_BANK_BASE+0x3E39)
#define REG_FRC_BK3E_3A        (REG_FRC_BANK_BASE+0x3E3A)
#define REG_FRC_BK3E_3B        (REG_FRC_BANK_BASE+0x3E3B)
#define REG_FRC_BK3E_3C        (REG_FRC_BANK_BASE+0x3E3C)
#define REG_FRC_BK3E_3D        (REG_FRC_BANK_BASE+0x3E3D)
#define REG_FRC_BK3E_3E        (REG_FRC_BANK_BASE+0x3E3E)
#define REG_FRC_BK3E_3F        (REG_FRC_BANK_BASE+0x3E3F)
#define REG_FRC_BK3E_40        (REG_FRC_BANK_BASE+0x3E40)
#define REG_FRC_BK3E_41        (REG_FRC_BANK_BASE+0x3E41)
#define REG_FRC_BK3E_42        (REG_FRC_BANK_BASE+0x3E42)
#define REG_FRC_BK3E_43        (REG_FRC_BANK_BASE+0x3E43)
#define REG_FRC_BK3E_44        (REG_FRC_BANK_BASE+0x3E44)
#define REG_FRC_BK3E_45        (REG_FRC_BANK_BASE+0x3E45)
#define REG_FRC_BK3E_46        (REG_FRC_BANK_BASE+0x3E46)
#define REG_FRC_BK3E_47        (REG_FRC_BANK_BASE+0x3E47)
#define REG_FRC_BK3E_48        (REG_FRC_BANK_BASE+0x3E48)
#define REG_FRC_BK3E_49        (REG_FRC_BANK_BASE+0x3E49)
#define REG_FRC_BK3E_4A        (REG_FRC_BANK_BASE+0x3E4A)
#define REG_FRC_BK3E_4B        (REG_FRC_BANK_BASE+0x3E4B)
#define REG_FRC_BK3E_4C        (REG_FRC_BANK_BASE+0x3E4C)
#define REG_FRC_BK3E_4D        (REG_FRC_BANK_BASE+0x3E4D)
#define REG_FRC_BK3E_4E        (REG_FRC_BANK_BASE+0x3E4E)
#define REG_FRC_BK3E_4F        (REG_FRC_BANK_BASE+0x3E4F)
#define REG_FRC_BK3E_50        (REG_FRC_BANK_BASE+0x3E50)
#define REG_FRC_BK3E_51        (REG_FRC_BANK_BASE+0x3E51)
#define REG_FRC_BK3E_52        (REG_FRC_BANK_BASE+0x3E52)
#define REG_FRC_BK3E_53        (REG_FRC_BANK_BASE+0x3E53)
#define REG_FRC_BK3E_54        (REG_FRC_BANK_BASE+0x3E54)
#define REG_FRC_BK3E_55        (REG_FRC_BANK_BASE+0x3E55)
#define REG_FRC_BK3E_56        (REG_FRC_BANK_BASE+0x3E56)
#define REG_FRC_BK3E_57        (REG_FRC_BANK_BASE+0x3E57)
#define REG_FRC_BK3E_58        (REG_FRC_BANK_BASE+0x3E58)
#define REG_FRC_BK3E_59        (REG_FRC_BANK_BASE+0x3E59)
#define REG_FRC_BK3E_5A        (REG_FRC_BANK_BASE+0x3E5A)
#define REG_FRC_BK3E_5B        (REG_FRC_BANK_BASE+0x3E5B)
#define REG_FRC_BK3E_5C        (REG_FRC_BANK_BASE+0x3E5C)
#define REG_FRC_BK3E_5D        (REG_FRC_BANK_BASE+0x3E5D)
#define REG_FRC_BK3E_5E        (REG_FRC_BANK_BASE+0x3E5E)
#define REG_FRC_BK3E_5F        (REG_FRC_BANK_BASE+0x3E5F)
#define REG_FRC_BK3E_60        (REG_FRC_BANK_BASE+0x3E60)
#define REG_FRC_BK3E_61        (REG_FRC_BANK_BASE+0x3E61)
#define REG_FRC_BK3E_62        (REG_FRC_BANK_BASE+0x3E62)
#define REG_FRC_BK3E_63        (REG_FRC_BANK_BASE+0x3E63)
#define REG_FRC_BK3E_64        (REG_FRC_BANK_BASE+0x3E64)
#define REG_FRC_BK3E_65        (REG_FRC_BANK_BASE+0x3E65)
#define REG_FRC_BK3E_66        (REG_FRC_BANK_BASE+0x3E66)
#define REG_FRC_BK3E_67        (REG_FRC_BANK_BASE+0x3E67)
#define REG_FRC_BK3E_68        (REG_FRC_BANK_BASE+0x3E68)
#define REG_FRC_BK3E_69        (REG_FRC_BANK_BASE+0x3E69)
#define REG_FRC_BK3E_6A        (REG_FRC_BANK_BASE+0x3E6A)
#define REG_FRC_BK3E_6B        (REG_FRC_BANK_BASE+0x3E6B)
#define REG_FRC_BK3E_6C        (REG_FRC_BANK_BASE+0x3E6C)
#define REG_FRC_BK3E_6D        (REG_FRC_BANK_BASE+0x3E6D)
#define REG_FRC_BK3E_6E        (REG_FRC_BANK_BASE+0x3E6E)
#define REG_FRC_BK3E_6F        (REG_FRC_BANK_BASE+0x3E6F)
#define REG_FRC_BK3E_70        (REG_FRC_BANK_BASE+0x3E70)
#define REG_FRC_BK3E_71        (REG_FRC_BANK_BASE+0x3E71)
#define REG_FRC_BK3E_72        (REG_FRC_BANK_BASE+0x3E72)
#define REG_FRC_BK3E_73        (REG_FRC_BANK_BASE+0x3E73)
#define REG_FRC_BK3E_74        (REG_FRC_BANK_BASE+0x3E74)
#define REG_FRC_BK3E_75        (REG_FRC_BANK_BASE+0x3E75)
#define REG_FRC_BK3E_76        (REG_FRC_BANK_BASE+0x3E76)
#define REG_FRC_BK3E_77        (REG_FRC_BANK_BASE+0x3E77)
#define REG_FRC_BK3E_78        (REG_FRC_BANK_BASE+0x3E78)
#define REG_FRC_BK3E_79        (REG_FRC_BANK_BASE+0x3E79)
#define REG_FRC_BK3E_7A        (REG_FRC_BANK_BASE+0x3E7A)
#define REG_FRC_BK3E_7B        (REG_FRC_BANK_BASE+0x3E7B)
#define REG_FRC_BK3E_7C        (REG_FRC_BANK_BASE+0x3E7C)
#define REG_FRC_BK3E_7D        (REG_FRC_BANK_BASE+0x3E7D)
#define REG_FRC_BK3E_7E        (REG_FRC_BANK_BASE+0x3E7E)
#define REG_FRC_BK3E_7F        (REG_FRC_BANK_BASE+0x3E7F)
#define REG_FRC_BK3E_80        (REG_FRC_BANK_BASE+0x3E80)
#define REG_FRC_BK3E_81        (REG_FRC_BANK_BASE+0x3E81)
#define REG_FRC_BK3E_82        (REG_FRC_BANK_BASE+0x3E82)
#define REG_FRC_BK3E_83        (REG_FRC_BANK_BASE+0x3E83)
#define REG_FRC_BK3E_84        (REG_FRC_BANK_BASE+0x3E84)
#define REG_FRC_BK3E_85        (REG_FRC_BANK_BASE+0x3E85)
#define REG_FRC_BK3E_86        (REG_FRC_BANK_BASE+0x3E86)
#define REG_FRC_BK3E_87        (REG_FRC_BANK_BASE+0x3E87)
#define REG_FRC_BK3E_88        (REG_FRC_BANK_BASE+0x3E88)
#define REG_FRC_BK3E_89        (REG_FRC_BANK_BASE+0x3E89)
#define REG_FRC_BK3E_8A        (REG_FRC_BANK_BASE+0x3E8A)
#define REG_FRC_BK3E_8B        (REG_FRC_BANK_BASE+0x3E8B)
#define REG_FRC_BK3E_8C        (REG_FRC_BANK_BASE+0x3E8C)
#define REG_FRC_BK3E_8D        (REG_FRC_BANK_BASE+0x3E8D)
#define REG_FRC_BK3E_8E        (REG_FRC_BANK_BASE+0x3E8E)
#define REG_FRC_BK3E_8F        (REG_FRC_BANK_BASE+0x3E8F)
#define REG_FRC_BK3E_90        (REG_FRC_BANK_BASE+0x3E90)
#define REG_FRC_BK3E_91        (REG_FRC_BANK_BASE+0x3E91)
#define REG_FRC_BK3E_92        (REG_FRC_BANK_BASE+0x3E92)
#define REG_FRC_BK3E_93        (REG_FRC_BANK_BASE+0x3E93)
#define REG_FRC_BK3E_94        (REG_FRC_BANK_BASE+0x3E94)
#define REG_FRC_BK3E_95        (REG_FRC_BANK_BASE+0x3E95)
#define REG_FRC_BK3E_96        (REG_FRC_BANK_BASE+0x3E96)
#define REG_FRC_BK3E_97        (REG_FRC_BANK_BASE+0x3E97)
#define REG_FRC_BK3E_98        (REG_FRC_BANK_BASE+0x3E98)
#define REG_FRC_BK3E_99        (REG_FRC_BANK_BASE+0x3E99)
#define REG_FRC_BK3E_9A        (REG_FRC_BANK_BASE+0x3E9A)
#define REG_FRC_BK3E_9B        (REG_FRC_BANK_BASE+0x3E9B)
#define REG_FRC_BK3E_9C        (REG_FRC_BANK_BASE+0x3E9C)
#define REG_FRC_BK3E_9D        (REG_FRC_BANK_BASE+0x3E9D)
#define REG_FRC_BK3E_9E        (REG_FRC_BANK_BASE+0x3E9E)
#define REG_FRC_BK3E_9F        (REG_FRC_BANK_BASE+0x3E9F)
#define REG_FRC_BK3E_A0        (REG_FRC_BANK_BASE+0x3EA0)
#define REG_FRC_BK3E_A1        (REG_FRC_BANK_BASE+0x3EA1)
#define REG_FRC_BK3E_A2        (REG_FRC_BANK_BASE+0x3EA2)
#define REG_FRC_BK3E_A3        (REG_FRC_BANK_BASE+0x3EA3)
#define REG_FRC_BK3E_A4        (REG_FRC_BANK_BASE+0x3EA4)
#define REG_FRC_BK3E_A5        (REG_FRC_BANK_BASE+0x3EA5)
#define REG_FRC_BK3E_A6        (REG_FRC_BANK_BASE+0x3EA6)
#define REG_FRC_BK3E_A7        (REG_FRC_BANK_BASE+0x3EA7)
#define REG_FRC_BK3E_A8        (REG_FRC_BANK_BASE+0x3EA8)
#define REG_FRC_BK3E_A9        (REG_FRC_BANK_BASE+0x3EA9)
#define REG_FRC_BK3E_AA        (REG_FRC_BANK_BASE+0x3EAA)
#define REG_FRC_BK3E_AB        (REG_FRC_BANK_BASE+0x3EAB)
#define REG_FRC_BK3E_AC        (REG_FRC_BANK_BASE+0x3EAC)
#define REG_FRC_BK3E_AD        (REG_FRC_BANK_BASE+0x3EAD)
#define REG_FRC_BK3E_AE        (REG_FRC_BANK_BASE+0x3EAE)
#define REG_FRC_BK3E_AF        (REG_FRC_BANK_BASE+0x3EAF)
#define REG_FRC_BK3E_B0        (REG_FRC_BANK_BASE+0x3EB0)
#define REG_FRC_BK3E_B1        (REG_FRC_BANK_BASE+0x3EB1)
#define REG_FRC_BK3E_B2        (REG_FRC_BANK_BASE+0x3EB2)
#define REG_FRC_BK3E_B3        (REG_FRC_BANK_BASE+0x3EB3)
#define REG_FRC_BK3E_B4        (REG_FRC_BANK_BASE+0x3EB4)
#define REG_FRC_BK3E_B5        (REG_FRC_BANK_BASE+0x3EB5)
#define REG_FRC_BK3E_B6        (REG_FRC_BANK_BASE+0x3EB6)
#define REG_FRC_BK3E_B7        (REG_FRC_BANK_BASE+0x3EB7)
#define REG_FRC_BK3E_B8        (REG_FRC_BANK_BASE+0x3EB8)
#define REG_FRC_BK3E_B9        (REG_FRC_BANK_BASE+0x3EB9)
#define REG_FRC_BK3E_BA        (REG_FRC_BANK_BASE+0x3EBA)
#define REG_FRC_BK3E_BB        (REG_FRC_BANK_BASE+0x3EBB)
#define REG_FRC_BK3E_BC        (REG_FRC_BANK_BASE+0x3EBC)
#define REG_FRC_BK3E_BD        (REG_FRC_BANK_BASE+0x3EBD)
#define REG_FRC_BK3E_BE        (REG_FRC_BANK_BASE+0x3EBE)
#define REG_FRC_BK3E_BF        (REG_FRC_BANK_BASE+0x3EBF)
#define REG_FRC_BK3E_C0        (REG_FRC_BANK_BASE+0x3EC0)
#define REG_FRC_BK3E_C1        (REG_FRC_BANK_BASE+0x3EC1)
#define REG_FRC_BK3E_C2        (REG_FRC_BANK_BASE+0x3EC2)
#define REG_FRC_BK3E_C3        (REG_FRC_BANK_BASE+0x3EC3)
#define REG_FRC_BK3E_C4        (REG_FRC_BANK_BASE+0x3EC4)
#define REG_FRC_BK3E_C5        (REG_FRC_BANK_BASE+0x3EC5)
#define REG_FRC_BK3E_C6        (REG_FRC_BANK_BASE+0x3EC6)
#define REG_FRC_BK3E_C7        (REG_FRC_BANK_BASE+0x3EC7)
#define REG_FRC_BK3E_C8        (REG_FRC_BANK_BASE+0x3EC8)
#define REG_FRC_BK3E_C9        (REG_FRC_BANK_BASE+0x3EC9)
#define REG_FRC_BK3E_CA        (REG_FRC_BANK_BASE+0x3ECA)
#define REG_FRC_BK3E_CB        (REG_FRC_BANK_BASE+0x3ECB)
#define REG_FRC_BK3E_CC        (REG_FRC_BANK_BASE+0x3ECC)
#define REG_FRC_BK3E_CD        (REG_FRC_BANK_BASE+0x3ECD)
#define REG_FRC_BK3E_CE        (REG_FRC_BANK_BASE+0x3ECE)
#define REG_FRC_BK3E_CF        (REG_FRC_BANK_BASE+0x3ECF)
#define REG_FRC_BK3E_D0        (REG_FRC_BANK_BASE+0x3ED0)
#define REG_FRC_BK3E_D1        (REG_FRC_BANK_BASE+0x3ED1)
#define REG_FRC_BK3E_D2        (REG_FRC_BANK_BASE+0x3ED2)
#define REG_FRC_BK3E_D3        (REG_FRC_BANK_BASE+0x3ED3)
#define REG_FRC_BK3E_D4        (REG_FRC_BANK_BASE+0x3ED4)
#define REG_FRC_BK3E_D5        (REG_FRC_BANK_BASE+0x3ED5)
#define REG_FRC_BK3E_D6        (REG_FRC_BANK_BASE+0x3ED6)
#define REG_FRC_BK3E_D7        (REG_FRC_BANK_BASE+0x3ED7)
#define REG_FRC_BK3E_D8        (REG_FRC_BANK_BASE+0x3ED8)
#define REG_FRC_BK3E_D9        (REG_FRC_BANK_BASE+0x3ED9)
#define REG_FRC_BK3E_DA        (REG_FRC_BANK_BASE+0x3EDA)
#define REG_FRC_BK3E_DB        (REG_FRC_BANK_BASE+0x3EDB)
#define REG_FRC_BK3E_DC        (REG_FRC_BANK_BASE+0x3EDC)
#define REG_FRC_BK3E_DD        (REG_FRC_BANK_BASE+0x3EDD)
#define REG_FRC_BK3E_DE        (REG_FRC_BANK_BASE+0x3EDE)
#define REG_FRC_BK3E_DF        (REG_FRC_BANK_BASE+0x3EDF)
#define REG_FRC_BK3E_E0        (REG_FRC_BANK_BASE+0x3EE0)
#define REG_FRC_BK3E_E1        (REG_FRC_BANK_BASE+0x3EE1)
#define REG_FRC_BK3E_E2        (REG_FRC_BANK_BASE+0x3EE2)
#define REG_FRC_BK3E_E3        (REG_FRC_BANK_BASE+0x3EE3)
#define REG_FRC_BK3E_E4        (REG_FRC_BANK_BASE+0x3EE4)
#define REG_FRC_BK3E_E5        (REG_FRC_BANK_BASE+0x3EE5)
#define REG_FRC_BK3E_E6        (REG_FRC_BANK_BASE+0x3EE6)
#define REG_FRC_BK3E_E7        (REG_FRC_BANK_BASE+0x3EE7)
#define REG_FRC_BK3E_E8        (REG_FRC_BANK_BASE+0x3EE8)
#define REG_FRC_BK3E_E9        (REG_FRC_BANK_BASE+0x3EE9)
#define REG_FRC_BK3E_EA        (REG_FRC_BANK_BASE+0x3EEA)
#define REG_FRC_BK3E_EB        (REG_FRC_BANK_BASE+0x3EEB)
#define REG_FRC_BK3E_EC        (REG_FRC_BANK_BASE+0x3EEC)
#define REG_FRC_BK3E_ED        (REG_FRC_BANK_BASE+0x3EED)
#define REG_FRC_BK3E_EE        (REG_FRC_BANK_BASE+0x3EEE)
#define REG_FRC_BK3E_EF        (REG_FRC_BANK_BASE+0x3EEF)
#define REG_FRC_BK3E_F0        (REG_FRC_BANK_BASE+0x3EF0)
#define REG_FRC_BK3E_F1        (REG_FRC_BANK_BASE+0x3EF1)
#define REG_FRC_BK3E_F2        (REG_FRC_BANK_BASE+0x3EF2)
#define REG_FRC_BK3E_F3        (REG_FRC_BANK_BASE+0x3EF3)
#define REG_FRC_BK3E_F4        (REG_FRC_BANK_BASE+0x3EF4)
#define REG_FRC_BK3E_F5        (REG_FRC_BANK_BASE+0x3EF5)
#define REG_FRC_BK3E_F6        (REG_FRC_BANK_BASE+0x3EF6)
#define REG_FRC_BK3E_F7        (REG_FRC_BANK_BASE+0x3EF7)
#define REG_FRC_BK3E_F8        (REG_FRC_BANK_BASE+0x3EF8)
#define REG_FRC_BK3E_F9        (REG_FRC_BANK_BASE+0x3EF9)
#define REG_FRC_BK3E_FA        (REG_FRC_BANK_BASE+0x3EFA)
#define REG_FRC_BK3E_FB        (REG_FRC_BANK_BASE+0x3EFB)
#define REG_FRC_BK3E_FC        (REG_FRC_BANK_BASE+0x3EFC)
#define REG_FRC_BK3E_FD        (REG_FRC_BANK_BASE+0x3EFD)
#define REG_FRC_BK3E_FE        (REG_FRC_BANK_BASE+0x3EFE)
#define REG_FRC_BK3E_FF        (REG_FRC_BANK_BASE+0x3EFF)

#define REG_FRC_BK110_AE        (REG_FRC_BANK_BASE+0x110AE)

// === FRC bk111
#define REG_FRC_BK111_00        (REG_FRC_BANK_BASE+0x11100)
#define REG_FRC_BK111_01        (REG_FRC_BANK_BASE+0x11101)
#define REG_FRC_BK111_02        (REG_FRC_BANK_BASE+0x11102)
#define REG_FRC_BK111_03        (REG_FRC_BANK_BASE+0x11103)
#define REG_FRC_BK111_04        (REG_FRC_BANK_BASE+0x11104)
#define REG_FRC_BK111_05        (REG_FRC_BANK_BASE+0x11105)
#define REG_FRC_BK111_06        (REG_FRC_BANK_BASE+0x11106)
#define REG_FRC_BK111_07        (REG_FRC_BANK_BASE+0x11107)
#define REG_FRC_BK111_08        (REG_FRC_BANK_BASE+0x11108)
#define REG_FRC_BK111_09        (REG_FRC_BANK_BASE+0x11109)
#define REG_FRC_BK111_0A        (REG_FRC_BANK_BASE+0x1110A)
#define REG_FRC_BK111_0B        (REG_FRC_BANK_BASE+0x1110B)
#define REG_FRC_BK111_0C        (REG_FRC_BANK_BASE+0x1110C)
#define REG_FRC_BK111_0D        (REG_FRC_BANK_BASE+0x1110D)
#define REG_FRC_BK111_0E        (REG_FRC_BANK_BASE+0x1110E)
#define REG_FRC_BK111_0F        (REG_FRC_BANK_BASE+0x1110F)
#define REG_FRC_BK111_10        (REG_FRC_BANK_BASE+0x11110)
#define REG_FRC_BK111_11        (REG_FRC_BANK_BASE+0x11111)
#define REG_FRC_BK111_12        (REG_FRC_BANK_BASE+0x11112)
#define REG_FRC_BK111_13        (REG_FRC_BANK_BASE+0x11113)
#define REG_FRC_BK111_14        (REG_FRC_BANK_BASE+0x11114)
#define REG_FRC_BK111_15        (REG_FRC_BANK_BASE+0x11115)
#define REG_FRC_BK111_16        (REG_FRC_BANK_BASE+0x11116)
#define REG_FRC_BK111_17        (REG_FRC_BANK_BASE+0x11117)
#define REG_FRC_BK111_18        (REG_FRC_BANK_BASE+0x11118)
#define REG_FRC_BK111_19        (REG_FRC_BANK_BASE+0x11119)
#define REG_FRC_BK111_1A        (REG_FRC_BANK_BASE+0x1111A)
#define REG_FRC_BK111_1B        (REG_FRC_BANK_BASE+0x1111B)
#define REG_FRC_BK111_1C        (REG_FRC_BANK_BASE+0x1111C)
#define REG_FRC_BK111_1D        (REG_FRC_BANK_BASE+0x1111D)
#define REG_FRC_BK111_1E        (REG_FRC_BANK_BASE+0x1111E)
#define REG_FRC_BK111_1F        (REG_FRC_BANK_BASE+0x1111F)
#define REG_FRC_BK111_20        (REG_FRC_BANK_BASE+0x11120)
#define REG_FRC_BK111_21        (REG_FRC_BANK_BASE+0x11121)
#define REG_FRC_BK111_22        (REG_FRC_BANK_BASE+0x11122)
#define REG_FRC_BK111_23        (REG_FRC_BANK_BASE+0x11123)
#define REG_FRC_BK111_24        (REG_FRC_BANK_BASE+0x11124)
#define REG_FRC_BK111_25        (REG_FRC_BANK_BASE+0x11125)
#define REG_FRC_BK111_26        (REG_FRC_BANK_BASE+0x11126)
#define REG_FRC_BK111_27        (REG_FRC_BANK_BASE+0x11127)
#define REG_FRC_BK111_28        (REG_FRC_BANK_BASE+0x11128)
#define REG_FRC_BK111_29        (REG_FRC_BANK_BASE+0x11129)
#define REG_FRC_BK111_2A        (REG_FRC_BANK_BASE+0x1112A)
#define REG_FRC_BK111_2B        (REG_FRC_BANK_BASE+0x1112B)
#define REG_FRC_BK111_2C        (REG_FRC_BANK_BASE+0x1112C)
#define REG_FRC_BK111_2D        (REG_FRC_BANK_BASE+0x1112D)
#define REG_FRC_BK111_2E        (REG_FRC_BANK_BASE+0x1112E)
#define REG_FRC_BK111_2F        (REG_FRC_BANK_BASE+0x1112F)
#define REG_FRC_BK111_30        (REG_FRC_BANK_BASE+0x11130)
#define REG_FRC_BK111_31        (REG_FRC_BANK_BASE+0x11131)
#define REG_FRC_BK111_32        (REG_FRC_BANK_BASE+0x11132)
#define REG_FRC_BK111_33        (REG_FRC_BANK_BASE+0x11133)
#define REG_FRC_BK111_34        (REG_FRC_BANK_BASE+0x11134)
#define REG_FRC_BK111_35        (REG_FRC_BANK_BASE+0x11135)
#define REG_FRC_BK111_36        (REG_FRC_BANK_BASE+0x11136)
#define REG_FRC_BK111_37        (REG_FRC_BANK_BASE+0x11137)
#define REG_FRC_BK111_38        (REG_FRC_BANK_BASE+0x11138)
#define REG_FRC_BK111_39        (REG_FRC_BANK_BASE+0x11139)
#define REG_FRC_BK111_3A        (REG_FRC_BANK_BASE+0x1113A)
#define REG_FRC_BK111_3B        (REG_FRC_BANK_BASE+0x1113B)
#define REG_FRC_BK111_3C        (REG_FRC_BANK_BASE+0x1113C)
#define REG_FRC_BK111_3D        (REG_FRC_BANK_BASE+0x1113D)
#define REG_FRC_BK111_3E        (REG_FRC_BANK_BASE+0x1113E)
#define REG_FRC_BK111_3F        (REG_FRC_BANK_BASE+0x1113F)
#define REG_FRC_BK111_40        (REG_FRC_BANK_BASE+0x11140)
#define REG_FRC_BK111_41        (REG_FRC_BANK_BASE+0x11141)
#define REG_FRC_BK111_42        (REG_FRC_BANK_BASE+0x11142)
#define REG_FRC_BK111_43        (REG_FRC_BANK_BASE+0x11143)
#define REG_FRC_BK111_44        (REG_FRC_BANK_BASE+0x11144)
#define REG_FRC_BK111_45        (REG_FRC_BANK_BASE+0x11145)
#define REG_FRC_BK111_46        (REG_FRC_BANK_BASE+0x11146)
#define REG_FRC_BK111_47        (REG_FRC_BANK_BASE+0x11147)
#define REG_FRC_BK111_48        (REG_FRC_BANK_BASE+0x11148)
#define REG_FRC_BK111_49        (REG_FRC_BANK_BASE+0x11149)
#define REG_FRC_BK111_4A        (REG_FRC_BANK_BASE+0x1114A)
#define REG_FRC_BK111_4B        (REG_FRC_BANK_BASE+0x1114B)
#define REG_FRC_BK111_4C        (REG_FRC_BANK_BASE+0x1114C)
#define REG_FRC_BK111_4D        (REG_FRC_BANK_BASE+0x1114D)
#define REG_FRC_BK111_4E        (REG_FRC_BANK_BASE+0x1114E)
#define REG_FRC_BK111_4F        (REG_FRC_BANK_BASE+0x1114F)
#define REG_FRC_BK111_50        (REG_FRC_BANK_BASE+0x11150)
#define REG_FRC_BK111_51        (REG_FRC_BANK_BASE+0x11151)
#define REG_FRC_BK111_52        (REG_FRC_BANK_BASE+0x11152)
#define REG_FRC_BK111_53        (REG_FRC_BANK_BASE+0x11153)
#define REG_FRC_BK111_54        (REG_FRC_BANK_BASE+0x11154)
#define REG_FRC_BK111_55        (REG_FRC_BANK_BASE+0x11155)
#define REG_FRC_BK111_56        (REG_FRC_BANK_BASE+0x11156)
#define REG_FRC_BK111_57        (REG_FRC_BANK_BASE+0x11157)
#define REG_FRC_BK111_58        (REG_FRC_BANK_BASE+0x11158)
#define REG_FRC_BK111_59        (REG_FRC_BANK_BASE+0x11159)
#define REG_FRC_BK111_5A        (REG_FRC_BANK_BASE+0x1115A)
#define REG_FRC_BK111_5B        (REG_FRC_BANK_BASE+0x1115B)
#define REG_FRC_BK111_5C        (REG_FRC_BANK_BASE+0x1115C)
#define REG_FRC_BK111_5D        (REG_FRC_BANK_BASE+0x1115D)
#define REG_FRC_BK111_5E        (REG_FRC_BANK_BASE+0x1115E)
#define REG_FRC_BK111_5F        (REG_FRC_BANK_BASE+0x1115F)
#define REG_FRC_BK111_60        (REG_FRC_BANK_BASE+0x11160)
#define REG_FRC_BK111_61        (REG_FRC_BANK_BASE+0x11161)
#define REG_FRC_BK111_62        (REG_FRC_BANK_BASE+0x11162)
#define REG_FRC_BK111_63        (REG_FRC_BANK_BASE+0x11163)
#define REG_FRC_BK111_64        (REG_FRC_BANK_BASE+0x11164)
#define REG_FRC_BK111_65        (REG_FRC_BANK_BASE+0x11165)
#define REG_FRC_BK111_66        (REG_FRC_BANK_BASE+0x11166)
#define REG_FRC_BK111_67        (REG_FRC_BANK_BASE+0x11167)
#define REG_FRC_BK111_68        (REG_FRC_BANK_BASE+0x11168)
#define REG_FRC_BK111_69        (REG_FRC_BANK_BASE+0x11169)
#define REG_FRC_BK111_6A        (REG_FRC_BANK_BASE+0x1116A)
#define REG_FRC_BK111_6B        (REG_FRC_BANK_BASE+0x1116B)
#define REG_FRC_BK111_6C        (REG_FRC_BANK_BASE+0x1116C)
#define REG_FRC_BK111_6D        (REG_FRC_BANK_BASE+0x1116D)
#define REG_FRC_BK111_6E        (REG_FRC_BANK_BASE+0x1116E)
#define REG_FRC_BK111_6F        (REG_FRC_BANK_BASE+0x1116F)
#define REG_FRC_BK111_70        (REG_FRC_BANK_BASE+0x11170)
#define REG_FRC_BK111_71        (REG_FRC_BANK_BASE+0x11171)
#define REG_FRC_BK111_72        (REG_FRC_BANK_BASE+0x11172)
#define REG_FRC_BK111_73        (REG_FRC_BANK_BASE+0x11173)
#define REG_FRC_BK111_74        (REG_FRC_BANK_BASE+0x11174)
#define REG_FRC_BK111_75        (REG_FRC_BANK_BASE+0x11175)
#define REG_FRC_BK111_76        (REG_FRC_BANK_BASE+0x11176)
#define REG_FRC_BK111_77        (REG_FRC_BANK_BASE+0x11177)
#define REG_FRC_BK111_78        (REG_FRC_BANK_BASE+0x11178)
#define REG_FRC_BK111_79        (REG_FRC_BANK_BASE+0x11179)
#define REG_FRC_BK111_7A        (REG_FRC_BANK_BASE+0x1117A)
#define REG_FRC_BK111_7B        (REG_FRC_BANK_BASE+0x1117B)
#define REG_FRC_BK111_7C        (REG_FRC_BANK_BASE+0x1117C)
#define REG_FRC_BK111_7D        (REG_FRC_BANK_BASE+0x1117D)
#define REG_FRC_BK111_7E        (REG_FRC_BANK_BASE+0x1117E)
#define REG_FRC_BK111_7F        (REG_FRC_BANK_BASE+0x1117F)
#define REG_FRC_BK111_80        (REG_FRC_BANK_BASE+0x11180)
#define REG_FRC_BK111_81        (REG_FRC_BANK_BASE+0x11181)
#define REG_FRC_BK111_82        (REG_FRC_BANK_BASE+0x11182)
#define REG_FRC_BK111_83        (REG_FRC_BANK_BASE+0x11183)
#define REG_FRC_BK111_84        (REG_FRC_BANK_BASE+0x11184)
#define REG_FRC_BK111_85        (REG_FRC_BANK_BASE+0x11185)
#define REG_FRC_BK111_86        (REG_FRC_BANK_BASE+0x11186)
#define REG_FRC_BK111_87        (REG_FRC_BANK_BASE+0x11187)
#define REG_FRC_BK111_88        (REG_FRC_BANK_BASE+0x11188)
#define REG_FRC_BK111_89        (REG_FRC_BANK_BASE+0x11189)
#define REG_FRC_BK111_8A        (REG_FRC_BANK_BASE+0x1118A)
#define REG_FRC_BK111_8B        (REG_FRC_BANK_BASE+0x1118B)
#define REG_FRC_BK111_8C        (REG_FRC_BANK_BASE+0x1118C)
#define REG_FRC_BK111_8D        (REG_FRC_BANK_BASE+0x1118D)
#define REG_FRC_BK111_8E        (REG_FRC_BANK_BASE+0x1118E)
#define REG_FRC_BK111_8F        (REG_FRC_BANK_BASE+0x1118F)
#define REG_FRC_BK111_90        (REG_FRC_BANK_BASE+0x11190)
#define REG_FRC_BK111_91        (REG_FRC_BANK_BASE+0x11191)
#define REG_FRC_BK111_92        (REG_FRC_BANK_BASE+0x11192)
#define REG_FRC_BK111_93        (REG_FRC_BANK_BASE+0x11193)
#define REG_FRC_BK111_94        (REG_FRC_BANK_BASE+0x11194)
#define REG_FRC_BK111_95        (REG_FRC_BANK_BASE+0x11195)
#define REG_FRC_BK111_96        (REG_FRC_BANK_BASE+0x11196)
#define REG_FRC_BK111_97        (REG_FRC_BANK_BASE+0x11197)
#define REG_FRC_BK111_98        (REG_FRC_BANK_BASE+0x11198)
#define REG_FRC_BK111_99        (REG_FRC_BANK_BASE+0x11199)
#define REG_FRC_BK111_9A        (REG_FRC_BANK_BASE+0x1119A)
#define REG_FRC_BK111_9B        (REG_FRC_BANK_BASE+0x1119B)
#define REG_FRC_BK111_9C        (REG_FRC_BANK_BASE+0x1119C)
#define REG_FRC_BK111_9D        (REG_FRC_BANK_BASE+0x1119D)
#define REG_FRC_BK111_9E        (REG_FRC_BANK_BASE+0x1119E)
#define REG_FRC_BK111_9F        (REG_FRC_BANK_BASE+0x1119F)
#define REG_FRC_BK111_A0        (REG_FRC_BANK_BASE+0x111A0)
#define REG_FRC_BK111_A1        (REG_FRC_BANK_BASE+0x111A1)
#define REG_FRC_BK111_A2        (REG_FRC_BANK_BASE+0x111A2)
#define REG_FRC_BK111_A3        (REG_FRC_BANK_BASE+0x111A3)
#define REG_FRC_BK111_A4        (REG_FRC_BANK_BASE+0x111A4)
#define REG_FRC_BK111_A5        (REG_FRC_BANK_BASE+0x111A5)
#define REG_FRC_BK111_A6        (REG_FRC_BANK_BASE+0x111A6)
#define REG_FRC_BK111_A7        (REG_FRC_BANK_BASE+0x111A7)
#define REG_FRC_BK111_A8        (REG_FRC_BANK_BASE+0x111A8)
#define REG_FRC_BK111_A9        (REG_FRC_BANK_BASE+0x111A9)
#define REG_FRC_BK111_AA        (REG_FRC_BANK_BASE+0x111AA)
#define REG_FRC_BK111_AB        (REG_FRC_BANK_BASE+0x111AB)
#define REG_FRC_BK111_AC        (REG_FRC_BANK_BASE+0x111AC)
#define REG_FRC_BK111_AD        (REG_FRC_BANK_BASE+0x111AD)
#define REG_FRC_BK111_AE        (REG_FRC_BANK_BASE+0x111AE)
#define REG_FRC_BK111_AF        (REG_FRC_BANK_BASE+0x111AF)
#define REG_FRC_BK111_B0        (REG_FRC_BANK_BASE+0x111B0)
#define REG_FRC_BK111_B1        (REG_FRC_BANK_BASE+0x111B1)
#define REG_FRC_BK111_B2        (REG_FRC_BANK_BASE+0x111B2)
#define REG_FRC_BK111_B3        (REG_FRC_BANK_BASE+0x111B3)
#define REG_FRC_BK111_B4        (REG_FRC_BANK_BASE+0x111B4)
#define REG_FRC_BK111_B5        (REG_FRC_BANK_BASE+0x111B5)
#define REG_FRC_BK111_B6        (REG_FRC_BANK_BASE+0x111B6)
#define REG_FRC_BK111_B7        (REG_FRC_BANK_BASE+0x111B7)
#define REG_FRC_BK111_B8        (REG_FRC_BANK_BASE+0x111B8)
#define REG_FRC_BK111_B9        (REG_FRC_BANK_BASE+0x111B9)
#define REG_FRC_BK111_BA        (REG_FRC_BANK_BASE+0x111BA)
#define REG_FRC_BK111_BB        (REG_FRC_BANK_BASE+0x111BB)
#define REG_FRC_BK111_BC        (REG_FRC_BANK_BASE+0x111BC)
#define REG_FRC_BK111_BD        (REG_FRC_BANK_BASE+0x111BD)
#define REG_FRC_BK111_BE        (REG_FRC_BANK_BASE+0x111BE)
#define REG_FRC_BK111_BF        (REG_FRC_BANK_BASE+0x111BF)
#define REG_FRC_BK111_C0        (REG_FRC_BANK_BASE+0x111C0)
#define REG_FRC_BK111_C1        (REG_FRC_BANK_BASE+0x111C1)
#define REG_FRC_BK111_C2        (REG_FRC_BANK_BASE+0x111C2)
#define REG_FRC_BK111_C3        (REG_FRC_BANK_BASE+0x111C3)
#define REG_FRC_BK111_C4        (REG_FRC_BANK_BASE+0x111C4)
#define REG_FRC_BK111_C5        (REG_FRC_BANK_BASE+0x111C5)
#define REG_FRC_BK111_C6        (REG_FRC_BANK_BASE+0x111C6)
#define REG_FRC_BK111_C7        (REG_FRC_BANK_BASE+0x111C7)
#define REG_FRC_BK111_C8        (REG_FRC_BANK_BASE+0x111C8)
#define REG_FRC_BK111_C9        (REG_FRC_BANK_BASE+0x111C9)
#define REG_FRC_BK111_CA        (REG_FRC_BANK_BASE+0x111CA)
#define REG_FRC_BK111_CB        (REG_FRC_BANK_BASE+0x111CB)
#define REG_FRC_BK111_CC        (REG_FRC_BANK_BASE+0x111CC)
#define REG_FRC_BK111_CD        (REG_FRC_BANK_BASE+0x111CD)
#define REG_FRC_BK111_CE        (REG_FRC_BANK_BASE+0x111CE)
#define REG_FRC_BK111_CF        (REG_FRC_BANK_BASE+0x111CF)
#define REG_FRC_BK111_D0        (REG_FRC_BANK_BASE+0x111D0)
#define REG_FRC_BK111_D1        (REG_FRC_BANK_BASE+0x111D1)
#define REG_FRC_BK111_D2        (REG_FRC_BANK_BASE+0x111D2)
#define REG_FRC_BK111_D3        (REG_FRC_BANK_BASE+0x111D3)
#define REG_FRC_BK111_D4        (REG_FRC_BANK_BASE+0x111D4)
#define REG_FRC_BK111_D5        (REG_FRC_BANK_BASE+0x111D5)
#define REG_FRC_BK111_D6        (REG_FRC_BANK_BASE+0x111D6)
#define REG_FRC_BK111_D7        (REG_FRC_BANK_BASE+0x111D7)
#define REG_FRC_BK111_D8        (REG_FRC_BANK_BASE+0x111D8)
#define REG_FRC_BK111_D9        (REG_FRC_BANK_BASE+0x111D9)
#define REG_FRC_BK111_DA        (REG_FRC_BANK_BASE+0x111DA)
#define REG_FRC_BK111_DB        (REG_FRC_BANK_BASE+0x111DB)
#define REG_FRC_BK111_DC        (REG_FRC_BANK_BASE+0x111DC)
#define REG_FRC_BK111_DD        (REG_FRC_BANK_BASE+0x111DD)
#define REG_FRC_BK111_DE        (REG_FRC_BANK_BASE+0x111DE)
#define REG_FRC_BK111_DF        (REG_FRC_BANK_BASE+0x111DF)
#define REG_FRC_BK111_E0        (REG_FRC_BANK_BASE+0x111E0)
#define REG_FRC_BK111_E1        (REG_FRC_BANK_BASE+0x111E1)
#define REG_FRC_BK111_E2        (REG_FRC_BANK_BASE+0x111E2)
#define REG_FRC_BK111_E3        (REG_FRC_BANK_BASE+0x111E3)
#define REG_FRC_BK111_E4        (REG_FRC_BANK_BASE+0x111E4)
#define REG_FRC_BK111_E5        (REG_FRC_BANK_BASE+0x111E5)
#define REG_FRC_BK111_E6        (REG_FRC_BANK_BASE+0x111E6)
#define REG_FRC_BK111_E7        (REG_FRC_BANK_BASE+0x111E7)
#define REG_FRC_BK111_E8        (REG_FRC_BANK_BASE+0x111E8)
#define REG_FRC_BK111_E9        (REG_FRC_BANK_BASE+0x111E9)
#define REG_FRC_BK111_EA        (REG_FRC_BANK_BASE+0x111EA)
#define REG_FRC_BK111_EB        (REG_FRC_BANK_BASE+0x111EB)
#define REG_FRC_BK111_EC        (REG_FRC_BANK_BASE+0x111EC)
#define REG_FRC_BK111_ED        (REG_FRC_BANK_BASE+0x111ED)
#define REG_FRC_BK111_EE        (REG_FRC_BANK_BASE+0x111EE)
#define REG_FRC_BK111_EF        (REG_FRC_BANK_BASE+0x111EF)
#define REG_FRC_BK111_F0        (REG_FRC_BANK_BASE+0x111F0)
#define REG_FRC_BK111_F1        (REG_FRC_BANK_BASE+0x111F1)
#define REG_FRC_BK111_F2        (REG_FRC_BANK_BASE+0x111F2)
#define REG_FRC_BK111_F3        (REG_FRC_BANK_BASE+0x111F3)
#define REG_FRC_BK111_F4        (REG_FRC_BANK_BASE+0x111F4)
#define REG_FRC_BK111_F5        (REG_FRC_BANK_BASE+0x111F5)
#define REG_FRC_BK111_F6        (REG_FRC_BANK_BASE+0x111F6)
#define REG_FRC_BK111_F7        (REG_FRC_BANK_BASE+0x111F7)
#define REG_FRC_BK111_F8        (REG_FRC_BANK_BASE+0x111F8)
#define REG_FRC_BK111_F9        (REG_FRC_BANK_BASE+0x111F9)
#define REG_FRC_BK111_FA        (REG_FRC_BANK_BASE+0x111FA)
#define REG_FRC_BK111_FB        (REG_FRC_BANK_BASE+0x111FB)
#define REG_FRC_BK111_FC        (REG_FRC_BANK_BASE+0x111FC)
#define REG_FRC_BK111_FD        (REG_FRC_BANK_BASE+0x111FD)
#define REG_FRC_BK111_FE        (REG_FRC_BANK_BASE+0x111FE)
#define REG_FRC_BK111_FF        (REG_FRC_BANK_BASE+0x111FF)

// === FRC bk115
#define REG_FRC_BK115_00        (REG_FRC_BANK_BASE+0x11500)
#define REG_FRC_BK115_01        (REG_FRC_BANK_BASE+0x11501)
#define REG_FRC_BK115_02        (REG_FRC_BANK_BASE+0x11502)
#define REG_FRC_BK115_03        (REG_FRC_BANK_BASE+0x11503)
#define REG_FRC_BK115_04        (REG_FRC_BANK_BASE+0x11504)
#define REG_FRC_BK115_05        (REG_FRC_BANK_BASE+0x11505)
#define REG_FRC_BK115_06        (REG_FRC_BANK_BASE+0x11506)
#define REG_FRC_BK115_07        (REG_FRC_BANK_BASE+0x11507)
#define REG_FRC_BK115_08        (REG_FRC_BANK_BASE+0x11508)
#define REG_FRC_BK115_09        (REG_FRC_BANK_BASE+0x11509)
#define REG_FRC_BK115_0A        (REG_FRC_BANK_BASE+0x1150A)
#define REG_FRC_BK115_0B        (REG_FRC_BANK_BASE+0x1150B)
#define REG_FRC_BK115_0C        (REG_FRC_BANK_BASE+0x1150C)
#define REG_FRC_BK115_0D        (REG_FRC_BANK_BASE+0x1150D)
#define REG_FRC_BK115_0E        (REG_FRC_BANK_BASE+0x1150E)
#define REG_FRC_BK115_0F        (REG_FRC_BANK_BASE+0x1150F)
#define REG_FRC_BK115_10        (REG_FRC_BANK_BASE+0x11510)
#define REG_FRC_BK115_11        (REG_FRC_BANK_BASE+0x11511)
#define REG_FRC_BK115_12        (REG_FRC_BANK_BASE+0x11512)
#define REG_FRC_BK115_13        (REG_FRC_BANK_BASE+0x11513)
#define REG_FRC_BK115_14        (REG_FRC_BANK_BASE+0x11514)
#define REG_FRC_BK115_15        (REG_FRC_BANK_BASE+0x11515)
#define REG_FRC_BK115_16        (REG_FRC_BANK_BASE+0x11516)
#define REG_FRC_BK115_17        (REG_FRC_BANK_BASE+0x11517)
#define REG_FRC_BK115_18        (REG_FRC_BANK_BASE+0x11518)
#define REG_FRC_BK115_19        (REG_FRC_BANK_BASE+0x11519)
#define REG_FRC_BK115_1A        (REG_FRC_BANK_BASE+0x1151A)
#define REG_FRC_BK115_1B        (REG_FRC_BANK_BASE+0x1151B)
#define REG_FRC_BK115_1C        (REG_FRC_BANK_BASE+0x1151C)
#define REG_FRC_BK115_1D        (REG_FRC_BANK_BASE+0x1151D)
#define REG_FRC_BK115_1E        (REG_FRC_BANK_BASE+0x1151E)
#define REG_FRC_BK115_1F        (REG_FRC_BANK_BASE+0x1151F)
#define REG_FRC_BK115_20        (REG_FRC_BANK_BASE+0x11520)
#define REG_FRC_BK115_21        (REG_FRC_BANK_BASE+0x11521)
#define REG_FRC_BK115_22        (REG_FRC_BANK_BASE+0x11522)
#define REG_FRC_BK115_23        (REG_FRC_BANK_BASE+0x11523)
#define REG_FRC_BK115_24        (REG_FRC_BANK_BASE+0x11524)
#define REG_FRC_BK115_25        (REG_FRC_BANK_BASE+0x11525)
#define REG_FRC_BK115_26        (REG_FRC_BANK_BASE+0x11526)
#define REG_FRC_BK115_27        (REG_FRC_BANK_BASE+0x11527)
#define REG_FRC_BK115_28        (REG_FRC_BANK_BASE+0x11528)
#define REG_FRC_BK115_29        (REG_FRC_BANK_BASE+0x11529)
#define REG_FRC_BK115_2A        (REG_FRC_BANK_BASE+0x1152A)
#define REG_FRC_BK115_2B        (REG_FRC_BANK_BASE+0x1152B)
#define REG_FRC_BK115_2C        (REG_FRC_BANK_BASE+0x1152C)
#define REG_FRC_BK115_2D        (REG_FRC_BANK_BASE+0x1152D)
#define REG_FRC_BK115_2E        (REG_FRC_BANK_BASE+0x1152E)
#define REG_FRC_BK115_2F        (REG_FRC_BANK_BASE+0x1152F)
#define REG_FRC_BK115_30        (REG_FRC_BANK_BASE+0x11530)
#define REG_FRC_BK115_31        (REG_FRC_BANK_BASE+0x11531)
#define REG_FRC_BK115_32        (REG_FRC_BANK_BASE+0x11532)
#define REG_FRC_BK115_33        (REG_FRC_BANK_BASE+0x11533)
#define REG_FRC_BK115_34        (REG_FRC_BANK_BASE+0x11534)
#define REG_FRC_BK115_35        (REG_FRC_BANK_BASE+0x11535)
#define REG_FRC_BK115_36        (REG_FRC_BANK_BASE+0x11536)
#define REG_FRC_BK115_37        (REG_FRC_BANK_BASE+0x11537)
#define REG_FRC_BK115_38        (REG_FRC_BANK_BASE+0x11538)
#define REG_FRC_BK115_39        (REG_FRC_BANK_BASE+0x11539)
#define REG_FRC_BK115_3A        (REG_FRC_BANK_BASE+0x1153A)
#define REG_FRC_BK115_3B        (REG_FRC_BANK_BASE+0x1153B)
#define REG_FRC_BK115_3C        (REG_FRC_BANK_BASE+0x1153C)
#define REG_FRC_BK115_3D        (REG_FRC_BANK_BASE+0x1153D)
#define REG_FRC_BK115_3E        (REG_FRC_BANK_BASE+0x1153E)
#define REG_FRC_BK115_3F        (REG_FRC_BANK_BASE+0x1153F)
#define REG_FRC_BK115_40        (REG_FRC_BANK_BASE+0x11540)
#define REG_FRC_BK115_41        (REG_FRC_BANK_BASE+0x11541)
#define REG_FRC_BK115_42        (REG_FRC_BANK_BASE+0x11542)
#define REG_FRC_BK115_43        (REG_FRC_BANK_BASE+0x11543)
#define REG_FRC_BK115_44        (REG_FRC_BANK_BASE+0x11544)
#define REG_FRC_BK115_45        (REG_FRC_BANK_BASE+0x11545)
#define REG_FRC_BK115_46        (REG_FRC_BANK_BASE+0x11546)
#define REG_FRC_BK115_47        (REG_FRC_BANK_BASE+0x11547)
#define REG_FRC_BK115_48        (REG_FRC_BANK_BASE+0x11548)
#define REG_FRC_BK115_49        (REG_FRC_BANK_BASE+0x11549)
#define REG_FRC_BK115_4A        (REG_FRC_BANK_BASE+0x1154A)
#define REG_FRC_BK115_4B        (REG_FRC_BANK_BASE+0x1154B)
#define REG_FRC_BK115_4C        (REG_FRC_BANK_BASE+0x1154C)
#define REG_FRC_BK115_4D        (REG_FRC_BANK_BASE+0x1154D)
#define REG_FRC_BK115_4E        (REG_FRC_BANK_BASE+0x1154E)
#define REG_FRC_BK115_4F        (REG_FRC_BANK_BASE+0x1154F)
#define REG_FRC_BK115_50        (REG_FRC_BANK_BASE+0x11550)
#define REG_FRC_BK115_51        (REG_FRC_BANK_BASE+0x11551)
#define REG_FRC_BK115_52        (REG_FRC_BANK_BASE+0x11552)
#define REG_FRC_BK115_53        (REG_FRC_BANK_BASE+0x11553)
#define REG_FRC_BK115_54        (REG_FRC_BANK_BASE+0x11554)
#define REG_FRC_BK115_55        (REG_FRC_BANK_BASE+0x11555)
#define REG_FRC_BK115_56        (REG_FRC_BANK_BASE+0x11556)
#define REG_FRC_BK115_57        (REG_FRC_BANK_BASE+0x11557)
#define REG_FRC_BK115_58        (REG_FRC_BANK_BASE+0x11558)
#define REG_FRC_BK115_59        (REG_FRC_BANK_BASE+0x11559)
#define REG_FRC_BK115_5A        (REG_FRC_BANK_BASE+0x1155A)
#define REG_FRC_BK115_5B        (REG_FRC_BANK_BASE+0x1155B)
#define REG_FRC_BK115_5C        (REG_FRC_BANK_BASE+0x1155C)
#define REG_FRC_BK115_5D        (REG_FRC_BANK_BASE+0x1155D)
#define REG_FRC_BK115_5E        (REG_FRC_BANK_BASE+0x1155E)
#define REG_FRC_BK115_5F        (REG_FRC_BANK_BASE+0x1155F)
#define REG_FRC_BK115_60        (REG_FRC_BANK_BASE+0x11560)
#define REG_FRC_BK115_61        (REG_FRC_BANK_BASE+0x11561)
#define REG_FRC_BK115_62        (REG_FRC_BANK_BASE+0x11562)
#define REG_FRC_BK115_63        (REG_FRC_BANK_BASE+0x11563)
#define REG_FRC_BK115_64        (REG_FRC_BANK_BASE+0x11564)
#define REG_FRC_BK115_65        (REG_FRC_BANK_BASE+0x11565)
#define REG_FRC_BK115_66        (REG_FRC_BANK_BASE+0x11566)
#define REG_FRC_BK115_67        (REG_FRC_BANK_BASE+0x11567)
#define REG_FRC_BK115_68        (REG_FRC_BANK_BASE+0x11568)
#define REG_FRC_BK115_69        (REG_FRC_BANK_BASE+0x11569)
#define REG_FRC_BK115_6A        (REG_FRC_BANK_BASE+0x1156A)
#define REG_FRC_BK115_6B        (REG_FRC_BANK_BASE+0x1156B)
#define REG_FRC_BK115_6C        (REG_FRC_BANK_BASE+0x1156C)
#define REG_FRC_BK115_6D        (REG_FRC_BANK_BASE+0x1156D)
#define REG_FRC_BK115_6E        (REG_FRC_BANK_BASE+0x1156E)
#define REG_FRC_BK115_6F        (REG_FRC_BANK_BASE+0x1156F)
#define REG_FRC_BK115_70        (REG_FRC_BANK_BASE+0x11570)
#define REG_FRC_BK115_71        (REG_FRC_BANK_BASE+0x11571)
#define REG_FRC_BK115_72        (REG_FRC_BANK_BASE+0x11572)
#define REG_FRC_BK115_73        (REG_FRC_BANK_BASE+0x11573)
#define REG_FRC_BK115_74        (REG_FRC_BANK_BASE+0x11574)
#define REG_FRC_BK115_75        (REG_FRC_BANK_BASE+0x11575)
#define REG_FRC_BK115_76        (REG_FRC_BANK_BASE+0x11576)
#define REG_FRC_BK115_77        (REG_FRC_BANK_BASE+0x11577)
#define REG_FRC_BK115_78        (REG_FRC_BANK_BASE+0x11578)
#define REG_FRC_BK115_79        (REG_FRC_BANK_BASE+0x11579)
#define REG_FRC_BK115_7A        (REG_FRC_BANK_BASE+0x1157A)
#define REG_FRC_BK115_7B        (REG_FRC_BANK_BASE+0x1157B)
#define REG_FRC_BK115_7C        (REG_FRC_BANK_BASE+0x1157C)
#define REG_FRC_BK115_7D        (REG_FRC_BANK_BASE+0x1157D)
#define REG_FRC_BK115_7E        (REG_FRC_BANK_BASE+0x1157E)
#define REG_FRC_BK115_7F        (REG_FRC_BANK_BASE+0x1157F)
#define REG_FRC_BK115_80        (REG_FRC_BANK_BASE+0x11580)
#define REG_FRC_BK115_81        (REG_FRC_BANK_BASE+0x11581)
#define REG_FRC_BK115_82        (REG_FRC_BANK_BASE+0x11582)
#define REG_FRC_BK115_83        (REG_FRC_BANK_BASE+0x11583)
#define REG_FRC_BK115_84        (REG_FRC_BANK_BASE+0x11584)
#define REG_FRC_BK115_85        (REG_FRC_BANK_BASE+0x11585)
#define REG_FRC_BK115_86        (REG_FRC_BANK_BASE+0x11586)
#define REG_FRC_BK115_87        (REG_FRC_BANK_BASE+0x11587)
#define REG_FRC_BK115_88        (REG_FRC_BANK_BASE+0x11588)
#define REG_FRC_BK115_89        (REG_FRC_BANK_BASE+0x11589)
#define REG_FRC_BK115_8A        (REG_FRC_BANK_BASE+0x1158A)
#define REG_FRC_BK115_8B        (REG_FRC_BANK_BASE+0x1158B)
#define REG_FRC_BK115_8C        (REG_FRC_BANK_BASE+0x1158C)
#define REG_FRC_BK115_8D        (REG_FRC_BANK_BASE+0x1158D)
#define REG_FRC_BK115_8E        (REG_FRC_BANK_BASE+0x1158E)
#define REG_FRC_BK115_8F        (REG_FRC_BANK_BASE+0x1158F)
#define REG_FRC_BK115_90        (REG_FRC_BANK_BASE+0x11590)
#define REG_FRC_BK115_91        (REG_FRC_BANK_BASE+0x11591)
#define REG_FRC_BK115_92        (REG_FRC_BANK_BASE+0x11592)
#define REG_FRC_BK115_93        (REG_FRC_BANK_BASE+0x11593)
#define REG_FRC_BK115_94        (REG_FRC_BANK_BASE+0x11594)
#define REG_FRC_BK115_95        (REG_FRC_BANK_BASE+0x11595)
#define REG_FRC_BK115_96        (REG_FRC_BANK_BASE+0x11596)
#define REG_FRC_BK115_97        (REG_FRC_BANK_BASE+0x11597)
#define REG_FRC_BK115_98        (REG_FRC_BANK_BASE+0x11598)
#define REG_FRC_BK115_99        (REG_FRC_BANK_BASE+0x11599)
#define REG_FRC_BK115_9A        (REG_FRC_BANK_BASE+0x1159A)
#define REG_FRC_BK115_9B        (REG_FRC_BANK_BASE+0x1159B)
#define REG_FRC_BK115_9C        (REG_FRC_BANK_BASE+0x1159C)
#define REG_FRC_BK115_9D        (REG_FRC_BANK_BASE+0x1159D)
#define REG_FRC_BK115_9E        (REG_FRC_BANK_BASE+0x1159E)
#define REG_FRC_BK115_9F        (REG_FRC_BANK_BASE+0x1159F)
#define REG_FRC_BK115_A0        (REG_FRC_BANK_BASE+0x115A0)
#define REG_FRC_BK115_A1        (REG_FRC_BANK_BASE+0x115A1)
#define REG_FRC_BK115_A2        (REG_FRC_BANK_BASE+0x115A2)
#define REG_FRC_BK115_A3        (REG_FRC_BANK_BASE+0x115A3)
#define REG_FRC_BK115_A4        (REG_FRC_BANK_BASE+0x115A4)
#define REG_FRC_BK115_A5        (REG_FRC_BANK_BASE+0x115A5)
#define REG_FRC_BK115_A6        (REG_FRC_BANK_BASE+0x115A6)
#define REG_FRC_BK115_A7        (REG_FRC_BANK_BASE+0x115A7)
#define REG_FRC_BK115_A8        (REG_FRC_BANK_BASE+0x115A8)
#define REG_FRC_BK115_A9        (REG_FRC_BANK_BASE+0x115A9)
#define REG_FRC_BK115_AA        (REG_FRC_BANK_BASE+0x115AA)
#define REG_FRC_BK115_AB        (REG_FRC_BANK_BASE+0x115AB)
#define REG_FRC_BK115_AC        (REG_FRC_BANK_BASE+0x115AC)
#define REG_FRC_BK115_AD        (REG_FRC_BANK_BASE+0x115AD)
#define REG_FRC_BK115_AE        (REG_FRC_BANK_BASE+0x115AE)
#define REG_FRC_BK115_AF        (REG_FRC_BANK_BASE+0x115AF)
#define REG_FRC_BK115_B0        (REG_FRC_BANK_BASE+0x115B0)
#define REG_FRC_BK115_B1        (REG_FRC_BANK_BASE+0x115B1)
#define REG_FRC_BK115_B2        (REG_FRC_BANK_BASE+0x115B2)
#define REG_FRC_BK115_B3        (REG_FRC_BANK_BASE+0x115B3)
#define REG_FRC_BK115_B4        (REG_FRC_BANK_BASE+0x115B4)
#define REG_FRC_BK115_B5        (REG_FRC_BANK_BASE+0x115B5)
#define REG_FRC_BK115_B6        (REG_FRC_BANK_BASE+0x115B6)
#define REG_FRC_BK115_B7        (REG_FRC_BANK_BASE+0x115B7)
#define REG_FRC_BK115_B8        (REG_FRC_BANK_BASE+0x115B8)
#define REG_FRC_BK115_B9        (REG_FRC_BANK_BASE+0x115B9)
#define REG_FRC_BK115_BA        (REG_FRC_BANK_BASE+0x115BA)
#define REG_FRC_BK115_BB        (REG_FRC_BANK_BASE+0x115BB)
#define REG_FRC_BK115_BC        (REG_FRC_BANK_BASE+0x115BC)
#define REG_FRC_BK115_BD        (REG_FRC_BANK_BASE+0x115BD)
#define REG_FRC_BK115_BE        (REG_FRC_BANK_BASE+0x115BE)
#define REG_FRC_BK115_BF        (REG_FRC_BANK_BASE+0x115BF)
#define REG_FRC_BK115_C0        (REG_FRC_BANK_BASE+0x115C0)
#define REG_FRC_BK115_C1        (REG_FRC_BANK_BASE+0x115C1)
#define REG_FRC_BK115_C2        (REG_FRC_BANK_BASE+0x115C2)
#define REG_FRC_BK115_C3        (REG_FRC_BANK_BASE+0x115C3)
#define REG_FRC_BK115_C4        (REG_FRC_BANK_BASE+0x115C4)
#define REG_FRC_BK115_C5        (REG_FRC_BANK_BASE+0x115C5)
#define REG_FRC_BK115_C6        (REG_FRC_BANK_BASE+0x115C6)
#define REG_FRC_BK115_C7        (REG_FRC_BANK_BASE+0x115C7)
#define REG_FRC_BK115_C8        (REG_FRC_BANK_BASE+0x115C8)
#define REG_FRC_BK115_C9        (REG_FRC_BANK_BASE+0x115C9)
#define REG_FRC_BK115_CA        (REG_FRC_BANK_BASE+0x115CA)
#define REG_FRC_BK115_CB        (REG_FRC_BANK_BASE+0x115CB)
#define REG_FRC_BK115_CC        (REG_FRC_BANK_BASE+0x115CC)
#define REG_FRC_BK115_CD        (REG_FRC_BANK_BASE+0x115CD)
#define REG_FRC_BK115_CE        (REG_FRC_BANK_BASE+0x115CE)
#define REG_FRC_BK115_CF        (REG_FRC_BANK_BASE+0x115CF)
#define REG_FRC_BK115_D0        (REG_FRC_BANK_BASE+0x115D0)
#define REG_FRC_BK115_D1        (REG_FRC_BANK_BASE+0x115D1)
#define REG_FRC_BK115_D2        (REG_FRC_BANK_BASE+0x115D2)
#define REG_FRC_BK115_D3        (REG_FRC_BANK_BASE+0x115D3)
#define REG_FRC_BK115_D4        (REG_FRC_BANK_BASE+0x115D4)
#define REG_FRC_BK115_D5        (REG_FRC_BANK_BASE+0x115D5)
#define REG_FRC_BK115_D6        (REG_FRC_BANK_BASE+0x115D6)
#define REG_FRC_BK115_D7        (REG_FRC_BANK_BASE+0x115D7)
#define REG_FRC_BK115_D8        (REG_FRC_BANK_BASE+0x115D8)
#define REG_FRC_BK115_D9        (REG_FRC_BANK_BASE+0x115D9)
#define REG_FRC_BK115_DA        (REG_FRC_BANK_BASE+0x115DA)
#define REG_FRC_BK115_DB        (REG_FRC_BANK_BASE+0x115DB)
#define REG_FRC_BK115_DC        (REG_FRC_BANK_BASE+0x115DC)
#define REG_FRC_BK115_DD        (REG_FRC_BANK_BASE+0x115DD)
#define REG_FRC_BK115_DE        (REG_FRC_BANK_BASE+0x115DE)
#define REG_FRC_BK115_DF        (REG_FRC_BANK_BASE+0x115DF)
#define REG_FRC_BK115_E0        (REG_FRC_BANK_BASE+0x115E0)
#define REG_FRC_BK115_E1        (REG_FRC_BANK_BASE+0x115E1)
#define REG_FRC_BK115_E2        (REG_FRC_BANK_BASE+0x115E2)
#define REG_FRC_BK115_E3        (REG_FRC_BANK_BASE+0x115E3)
#define REG_FRC_BK115_E4        (REG_FRC_BANK_BASE+0x115E4)
#define REG_FRC_BK115_E5        (REG_FRC_BANK_BASE+0x115E5)
#define REG_FRC_BK115_E6        (REG_FRC_BANK_BASE+0x115E6)
#define REG_FRC_BK115_E7        (REG_FRC_BANK_BASE+0x115E7)
#define REG_FRC_BK115_E8        (REG_FRC_BANK_BASE+0x115E8)
#define REG_FRC_BK115_E9        (REG_FRC_BANK_BASE+0x115E9)
#define REG_FRC_BK115_EA        (REG_FRC_BANK_BASE+0x115EA)
#define REG_FRC_BK115_EB        (REG_FRC_BANK_BASE+0x115EB)
#define REG_FRC_BK115_EC        (REG_FRC_BANK_BASE+0x115EC)
#define REG_FRC_BK115_ED        (REG_FRC_BANK_BASE+0x115ED)
#define REG_FRC_BK115_EE        (REG_FRC_BANK_BASE+0x115EE)
#define REG_FRC_BK115_EF        (REG_FRC_BANK_BASE+0x115EF)
#define REG_FRC_BK115_F0        (REG_FRC_BANK_BASE+0x115F0)
#define REG_FRC_BK115_F1        (REG_FRC_BANK_BASE+0x115F1)
#define REG_FRC_BK115_F2        (REG_FRC_BANK_BASE+0x115F2)
#define REG_FRC_BK115_F3        (REG_FRC_BANK_BASE+0x115F3)
#define REG_FRC_BK115_F4        (REG_FRC_BANK_BASE+0x115F4)
#define REG_FRC_BK115_F5        (REG_FRC_BANK_BASE+0x115F5)
#define REG_FRC_BK115_F6        (REG_FRC_BANK_BASE+0x115F6)
#define REG_FRC_BK115_F7        (REG_FRC_BANK_BASE+0x115F7)
#define REG_FRC_BK115_F8        (REG_FRC_BANK_BASE+0x115F8)
#define REG_FRC_BK115_F9        (REG_FRC_BANK_BASE+0x115F9)
#define REG_FRC_BK115_FA        (REG_FRC_BANK_BASE+0x115FA)
#define REG_FRC_BK115_FB        (REG_FRC_BANK_BASE+0x115FB)
#define REG_FRC_BK115_FC        (REG_FRC_BANK_BASE+0x115FC)
#define REG_FRC_BK115_FD        (REG_FRC_BANK_BASE+0x115FD)
#define REG_FRC_BK115_FE        (REG_FRC_BANK_BASE+0x115FE)
#define REG_FRC_BK115_FF        (REG_FRC_BANK_BASE+0x115FF)

// === FRC bk132 -> 0x4232
#define REG_FRC_BK232_00        (REG_FRC_BANK_BASE+0x23200)
#define REG_FRC_BK232_01        (REG_FRC_BANK_BASE+0x23201)
#define REG_FRC_BK232_02        (REG_FRC_BANK_BASE+0x23202)
#define REG_FRC_BK232_03        (REG_FRC_BANK_BASE+0x23203)
#define REG_FRC_BK232_04        (REG_FRC_BANK_BASE+0x23204)
#define REG_FRC_BK232_05        (REG_FRC_BANK_BASE+0x23205)
#define REG_FRC_BK232_06        (REG_FRC_BANK_BASE+0x23206)
#define REG_FRC_BK232_07        (REG_FRC_BANK_BASE+0x23207)
#define REG_FRC_BK232_08        (REG_FRC_BANK_BASE+0x23208)
#define REG_FRC_BK232_09        (REG_FRC_BANK_BASE+0x23209)
#define REG_FRC_BK232_0A        (REG_FRC_BANK_BASE+0x2320A)
#define REG_FRC_BK232_0B        (REG_FRC_BANK_BASE+0x2320B)
#define REG_FRC_BK232_0C        (REG_FRC_BANK_BASE+0x2320C)
#define REG_FRC_BK232_0D        (REG_FRC_BANK_BASE+0x2320D)
#define REG_FRC_BK232_0E        (REG_FRC_BANK_BASE+0x2320E)
#define REG_FRC_BK232_0F        (REG_FRC_BANK_BASE+0x2320F)
#define REG_FRC_BK232_10        (REG_FRC_BANK_BASE+0x23210)
#define REG_FRC_BK232_11        (REG_FRC_BANK_BASE+0x23211)
#define REG_FRC_BK232_12        (REG_FRC_BANK_BASE+0x23212)
#define REG_FRC_BK232_13        (REG_FRC_BANK_BASE+0x23213)
#define REG_FRC_BK232_14        (REG_FRC_BANK_BASE+0x23214)
#define REG_FRC_BK232_15        (REG_FRC_BANK_BASE+0x23215)
#define REG_FRC_BK232_16        (REG_FRC_BANK_BASE+0x23216)
#define REG_FRC_BK232_17        (REG_FRC_BANK_BASE+0x23217)
#define REG_FRC_BK232_18        (REG_FRC_BANK_BASE+0x23218)
#define REG_FRC_BK232_19        (REG_FRC_BANK_BASE+0x23219)
#define REG_FRC_BK232_1A        (REG_FRC_BANK_BASE+0x2321A)
#define REG_FRC_BK232_1B        (REG_FRC_BANK_BASE+0x2321B)
#define REG_FRC_BK232_1C        (REG_FRC_BANK_BASE+0x2321C)
#define REG_FRC_BK232_1D        (REG_FRC_BANK_BASE+0x2321D)
#define REG_FRC_BK232_1E        (REG_FRC_BANK_BASE+0x2321E)
#define REG_FRC_BK232_1F        (REG_FRC_BANK_BASE+0x2321F)
#define REG_FRC_BK232_20        (REG_FRC_BANK_BASE+0x23220)
#define REG_FRC_BK232_21        (REG_FRC_BANK_BASE+0x23221)
#define REG_FRC_BK232_22        (REG_FRC_BANK_BASE+0x23222)
#define REG_FRC_BK232_23        (REG_FRC_BANK_BASE+0x23223)
#define REG_FRC_BK232_24        (REG_FRC_BANK_BASE+0x23224)
#define REG_FRC_BK232_25        (REG_FRC_BANK_BASE+0x23225)
#define REG_FRC_BK232_26        (REG_FRC_BANK_BASE+0x23226)
#define REG_FRC_BK232_27        (REG_FRC_BANK_BASE+0x23227)
#define REG_FRC_BK232_28        (REG_FRC_BANK_BASE+0x23228)
#define REG_FRC_BK232_29        (REG_FRC_BANK_BASE+0x23229)
#define REG_FRC_BK232_2A        (REG_FRC_BANK_BASE+0x2322A)
#define REG_FRC_BK232_2B        (REG_FRC_BANK_BASE+0x2322B)
#define REG_FRC_BK232_2C        (REG_FRC_BANK_BASE+0x2322C)
#define REG_FRC_BK232_2D        (REG_FRC_BANK_BASE+0x2322D)
#define REG_FRC_BK232_2E        (REG_FRC_BANK_BASE+0x2322E)
#define REG_FRC_BK232_2F        (REG_FRC_BANK_BASE+0x2322F)
#define REG_FRC_BK232_30        (REG_FRC_BANK_BASE+0x23230)
#define REG_FRC_BK232_31        (REG_FRC_BANK_BASE+0x23231)
#define REG_FRC_BK232_32        (REG_FRC_BANK_BASE+0x23232)
#define REG_FRC_BK232_33        (REG_FRC_BANK_BASE+0x23233)
#define REG_FRC_BK232_34        (REG_FRC_BANK_BASE+0x23234)
#define REG_FRC_BK232_35        (REG_FRC_BANK_BASE+0x23235)
#define REG_FRC_BK232_36        (REG_FRC_BANK_BASE+0x23236)
#define REG_FRC_BK232_37        (REG_FRC_BANK_BASE+0x23237)
#define REG_FRC_BK232_38        (REG_FRC_BANK_BASE+0x23238)
#define REG_FRC_BK232_39        (REG_FRC_BANK_BASE+0x23239)
#define REG_FRC_BK232_3A        (REG_FRC_BANK_BASE+0x2323A)
#define REG_FRC_BK232_3B        (REG_FRC_BANK_BASE+0x2323B)
#define REG_FRC_BK232_3C        (REG_FRC_BANK_BASE+0x2323C)
#define REG_FRC_BK232_3D        (REG_FRC_BANK_BASE+0x2323D)
#define REG_FRC_BK232_3E        (REG_FRC_BANK_BASE+0x2323E)
#define REG_FRC_BK232_3F        (REG_FRC_BANK_BASE+0x2323F)
#define REG_FRC_BK232_40        (REG_FRC_BANK_BASE+0x23240)
#define REG_FRC_BK232_41        (REG_FRC_BANK_BASE+0x23241)
#define REG_FRC_BK232_42        (REG_FRC_BANK_BASE+0x23242)
#define REG_FRC_BK232_43        (REG_FRC_BANK_BASE+0x23243)
#define REG_FRC_BK232_44        (REG_FRC_BANK_BASE+0x23244)
#define REG_FRC_BK232_45        (REG_FRC_BANK_BASE+0x23245)
#define REG_FRC_BK232_46        (REG_FRC_BANK_BASE+0x23246)
#define REG_FRC_BK232_47        (REG_FRC_BANK_BASE+0x23247)
#define REG_FRC_BK232_48        (REG_FRC_BANK_BASE+0x23248)
#define REG_FRC_BK232_49        (REG_FRC_BANK_BASE+0x23249)
#define REG_FRC_BK232_4A        (REG_FRC_BANK_BASE+0x2324A)
#define REG_FRC_BK232_4B        (REG_FRC_BANK_BASE+0x2324B)
#define REG_FRC_BK232_4C        (REG_FRC_BANK_BASE+0x2324C)
#define REG_FRC_BK232_4D        (REG_FRC_BANK_BASE+0x2324D)
#define REG_FRC_BK232_4E        (REG_FRC_BANK_BASE+0x2324E)
#define REG_FRC_BK232_4F        (REG_FRC_BANK_BASE+0x2324F)
#define REG_FRC_BK232_50        (REG_FRC_BANK_BASE+0x23250)
#define REG_FRC_BK232_51        (REG_FRC_BANK_BASE+0x23251)
#define REG_FRC_BK232_52        (REG_FRC_BANK_BASE+0x23252)
#define REG_FRC_BK232_53        (REG_FRC_BANK_BASE+0x23253)
#define REG_FRC_BK232_54        (REG_FRC_BANK_BASE+0x23254)
#define REG_FRC_BK232_55        (REG_FRC_BANK_BASE+0x23255)
#define REG_FRC_BK232_56        (REG_FRC_BANK_BASE+0x23256)
#define REG_FRC_BK232_57        (REG_FRC_BANK_BASE+0x23257)
#define REG_FRC_BK232_58        (REG_FRC_BANK_BASE+0x23258)
#define REG_FRC_BK232_59        (REG_FRC_BANK_BASE+0x23259)
#define REG_FRC_BK232_5A        (REG_FRC_BANK_BASE+0x2325A)
#define REG_FRC_BK232_5B        (REG_FRC_BANK_BASE+0x2325B)
#define REG_FRC_BK232_5C        (REG_FRC_BANK_BASE+0x2325C)
#define REG_FRC_BK232_5D        (REG_FRC_BANK_BASE+0x2325D)
#define REG_FRC_BK232_5E        (REG_FRC_BANK_BASE+0x2325E)
#define REG_FRC_BK232_5F        (REG_FRC_BANK_BASE+0x2325F)
#define REG_FRC_BK232_60        (REG_FRC_BANK_BASE+0x23260)
#define REG_FRC_BK232_61        (REG_FRC_BANK_BASE+0x23261)
#define REG_FRC_BK232_62        (REG_FRC_BANK_BASE+0x23262)
#define REG_FRC_BK232_63        (REG_FRC_BANK_BASE+0x23263)
#define REG_FRC_BK232_64        (REG_FRC_BANK_BASE+0x23264)
#define REG_FRC_BK232_65        (REG_FRC_BANK_BASE+0x23265)
#define REG_FRC_BK232_66        (REG_FRC_BANK_BASE+0x23266)
#define REG_FRC_BK232_67        (REG_FRC_BANK_BASE+0x23267)
#define REG_FRC_BK232_68        (REG_FRC_BANK_BASE+0x23268)
#define REG_FRC_BK232_69        (REG_FRC_BANK_BASE+0x23269)
#define REG_FRC_BK232_6A        (REG_FRC_BANK_BASE+0x2326A)
#define REG_FRC_BK232_6B        (REG_FRC_BANK_BASE+0x2326B)
#define REG_FRC_BK232_6C        (REG_FRC_BANK_BASE+0x2326C)
#define REG_FRC_BK232_6D        (REG_FRC_BANK_BASE+0x2326D)
#define REG_FRC_BK232_6E        (REG_FRC_BANK_BASE+0x2326E)
#define REG_FRC_BK232_6F        (REG_FRC_BANK_BASE+0x2326F)
#define REG_FRC_BK232_70        (REG_FRC_BANK_BASE+0x23270)
#define REG_FRC_BK232_71        (REG_FRC_BANK_BASE+0x23271)
#define REG_FRC_BK232_72        (REG_FRC_BANK_BASE+0x23272)
#define REG_FRC_BK232_73        (REG_FRC_BANK_BASE+0x23273)
#define REG_FRC_BK232_74        (REG_FRC_BANK_BASE+0x23274)
#define REG_FRC_BK232_75        (REG_FRC_BANK_BASE+0x23275)
#define REG_FRC_BK232_76        (REG_FRC_BANK_BASE+0x23276)
#define REG_FRC_BK232_77        (REG_FRC_BANK_BASE+0x23277)
#define REG_FRC_BK232_78        (REG_FRC_BANK_BASE+0x23278)
#define REG_FRC_BK232_79        (REG_FRC_BANK_BASE+0x23279)
#define REG_FRC_BK232_7A        (REG_FRC_BANK_BASE+0x2327A)
#define REG_FRC_BK232_7B        (REG_FRC_BANK_BASE+0x2327B)
#define REG_FRC_BK232_7C        (REG_FRC_BANK_BASE+0x2327C)
#define REG_FRC_BK232_7D        (REG_FRC_BANK_BASE+0x2327D)
#define REG_FRC_BK232_7E        (REG_FRC_BANK_BASE+0x2327E)
#define REG_FRC_BK232_7F        (REG_FRC_BANK_BASE+0x2327F)
#define REG_FRC_BK232_80        (REG_FRC_BANK_BASE+0x23280)
#define REG_FRC_BK232_81        (REG_FRC_BANK_BASE+0x23281)
#define REG_FRC_BK232_82        (REG_FRC_BANK_BASE+0x23282)
#define REG_FRC_BK232_83        (REG_FRC_BANK_BASE+0x23283)
#define REG_FRC_BK232_84        (REG_FRC_BANK_BASE+0x23284)
#define REG_FRC_BK232_85        (REG_FRC_BANK_BASE+0x23285)
#define REG_FRC_BK232_86        (REG_FRC_BANK_BASE+0x23286)
#define REG_FRC_BK232_87        (REG_FRC_BANK_BASE+0x23287)
#define REG_FRC_BK232_88        (REG_FRC_BANK_BASE+0x23288)
#define REG_FRC_BK232_89        (REG_FRC_BANK_BASE+0x23289)
#define REG_FRC_BK232_8A        (REG_FRC_BANK_BASE+0x2328A)
#define REG_FRC_BK232_8B        (REG_FRC_BANK_BASE+0x2328B)
#define REG_FRC_BK232_8C        (REG_FRC_BANK_BASE+0x2328C)
#define REG_FRC_BK232_8D        (REG_FRC_BANK_BASE+0x2328D)
#define REG_FRC_BK232_8E        (REG_FRC_BANK_BASE+0x2328E)
#define REG_FRC_BK232_8F        (REG_FRC_BANK_BASE+0x2328F)
#define REG_FRC_BK232_90        (REG_FRC_BANK_BASE+0x23290)
#define REG_FRC_BK232_91        (REG_FRC_BANK_BASE+0x23291)
#define REG_FRC_BK232_92        (REG_FRC_BANK_BASE+0x23292)
#define REG_FRC_BK232_93        (REG_FRC_BANK_BASE+0x23293)
#define REG_FRC_BK232_94        (REG_FRC_BANK_BASE+0x23294)
#define REG_FRC_BK232_95        (REG_FRC_BANK_BASE+0x23295)
#define REG_FRC_BK232_96        (REG_FRC_BANK_BASE+0x23296)
#define REG_FRC_BK232_97        (REG_FRC_BANK_BASE+0x23297)
#define REG_FRC_BK232_98        (REG_FRC_BANK_BASE+0x23298)
#define REG_FRC_BK232_99        (REG_FRC_BANK_BASE+0x23299)
#define REG_FRC_BK232_9A        (REG_FRC_BANK_BASE+0x2329A)
#define REG_FRC_BK232_9B        (REG_FRC_BANK_BASE+0x2329B)
#define REG_FRC_BK232_9C        (REG_FRC_BANK_BASE+0x2329C)
#define REG_FRC_BK232_9D        (REG_FRC_BANK_BASE+0x2329D)
#define REG_FRC_BK232_9E        (REG_FRC_BANK_BASE+0x2329E)
#define REG_FRC_BK232_9F        (REG_FRC_BANK_BASE+0x2329F)
#define REG_FRC_BK232_A0        (REG_FRC_BANK_BASE+0x232A0)
#define REG_FRC_BK232_A1        (REG_FRC_BANK_BASE+0x232A1)
#define REG_FRC_BK232_A2        (REG_FRC_BANK_BASE+0x232A2)
#define REG_FRC_BK232_A3        (REG_FRC_BANK_BASE+0x232A3)
#define REG_FRC_BK232_A4        (REG_FRC_BANK_BASE+0x232A4)
#define REG_FRC_BK232_A5        (REG_FRC_BANK_BASE+0x232A5)
#define REG_FRC_BK232_A6        (REG_FRC_BANK_BASE+0x232A6)
#define REG_FRC_BK232_A7        (REG_FRC_BANK_BASE+0x232A7)
#define REG_FRC_BK232_A8        (REG_FRC_BANK_BASE+0x232A8)
#define REG_FRC_BK232_A9        (REG_FRC_BANK_BASE+0x232A9)
#define REG_FRC_BK232_AA        (REG_FRC_BANK_BASE+0x232AA)
#define REG_FRC_BK232_AB        (REG_FRC_BANK_BASE+0x232AB)
#define REG_FRC_BK232_AC        (REG_FRC_BANK_BASE+0x232AC)
#define REG_FRC_BK232_AD        (REG_FRC_BANK_BASE+0x232AD)
#define REG_FRC_BK232_AE        (REG_FRC_BANK_BASE+0x232AE)
#define REG_FRC_BK232_AF        (REG_FRC_BANK_BASE+0x232AF)
#define REG_FRC_BK232_B0        (REG_FRC_BANK_BASE+0x232B0)
#define REG_FRC_BK232_B1        (REG_FRC_BANK_BASE+0x232B1)
#define REG_FRC_BK232_B2        (REG_FRC_BANK_BASE+0x232B2)
#define REG_FRC_BK232_B3        (REG_FRC_BANK_BASE+0x232B3)
#define REG_FRC_BK232_B4        (REG_FRC_BANK_BASE+0x232B4)
#define REG_FRC_BK232_B5        (REG_FRC_BANK_BASE+0x232B5)
#define REG_FRC_BK232_B6        (REG_FRC_BANK_BASE+0x232B6)
#define REG_FRC_BK232_B7        (REG_FRC_BANK_BASE+0x232B7)
#define REG_FRC_BK232_B8        (REG_FRC_BANK_BASE+0x232B8)
#define REG_FRC_BK232_B9        (REG_FRC_BANK_BASE+0x232B9)
#define REG_FRC_BK232_BA        (REG_FRC_BANK_BASE+0x232BA)
#define REG_FRC_BK232_BB        (REG_FRC_BANK_BASE+0x232BB)
#define REG_FRC_BK232_BC        (REG_FRC_BANK_BASE+0x232BC)
#define REG_FRC_BK232_BD        (REG_FRC_BANK_BASE+0x232BD)
#define REG_FRC_BK232_BE        (REG_FRC_BANK_BASE+0x232BE)
#define REG_FRC_BK232_BF        (REG_FRC_BANK_BASE+0x232BF)
#define REG_FRC_BK232_C0        (REG_FRC_BANK_BASE+0x232C0)
#define REG_FRC_BK232_C1        (REG_FRC_BANK_BASE+0x232C1)
#define REG_FRC_BK232_C2        (REG_FRC_BANK_BASE+0x232C2)
#define REG_FRC_BK232_C3        (REG_FRC_BANK_BASE+0x232C3)
#define REG_FRC_BK232_C4        (REG_FRC_BANK_BASE+0x232C4)
#define REG_FRC_BK232_C5        (REG_FRC_BANK_BASE+0x232C5)
#define REG_FRC_BK232_C6        (REG_FRC_BANK_BASE+0x232C6)
#define REG_FRC_BK232_C7        (REG_FRC_BANK_BASE+0x232C7)
#define REG_FRC_BK232_C8        (REG_FRC_BANK_BASE+0x232C8)
#define REG_FRC_BK232_C9        (REG_FRC_BANK_BASE+0x232C9)
#define REG_FRC_BK232_CA        (REG_FRC_BANK_BASE+0x232CA)
#define REG_FRC_BK232_CB        (REG_FRC_BANK_BASE+0x232CB)
#define REG_FRC_BK232_CC        (REG_FRC_BANK_BASE+0x232CC)
#define REG_FRC_BK232_CD        (REG_FRC_BANK_BASE+0x232CD)
#define REG_FRC_BK232_CE        (REG_FRC_BANK_BASE+0x232CE)
#define REG_FRC_BK232_CF        (REG_FRC_BANK_BASE+0x232CF)
#define REG_FRC_BK232_D0        (REG_FRC_BANK_BASE+0x232D0)
#define REG_FRC_BK232_D1        (REG_FRC_BANK_BASE+0x232D1)
#define REG_FRC_BK232_D2        (REG_FRC_BANK_BASE+0x232D2)
#define REG_FRC_BK232_D3        (REG_FRC_BANK_BASE+0x232D3)
#define REG_FRC_BK232_D4        (REG_FRC_BANK_BASE+0x232D4)
#define REG_FRC_BK232_D5        (REG_FRC_BANK_BASE+0x232D5)
#define REG_FRC_BK232_D6        (REG_FRC_BANK_BASE+0x232D6)
#define REG_FRC_BK232_D7        (REG_FRC_BANK_BASE+0x232D7)
#define REG_FRC_BK232_D8        (REG_FRC_BANK_BASE+0x232D8)
#define REG_FRC_BK232_D9        (REG_FRC_BANK_BASE+0x232D9)
#define REG_FRC_BK232_DA        (REG_FRC_BANK_BASE+0x232DA)
#define REG_FRC_BK232_DB        (REG_FRC_BANK_BASE+0x232DB)
#define REG_FRC_BK232_DC        (REG_FRC_BANK_BASE+0x232DC)
#define REG_FRC_BK232_DD        (REG_FRC_BANK_BASE+0x232DD)
#define REG_FRC_BK232_DE        (REG_FRC_BANK_BASE+0x232DE)
#define REG_FRC_BK232_DF        (REG_FRC_BANK_BASE+0x232DF)
#define REG_FRC_BK232_E0        (REG_FRC_BANK_BASE+0x232E0)
#define REG_FRC_BK232_E1        (REG_FRC_BANK_BASE+0x232E1)
#define REG_FRC_BK232_E2        (REG_FRC_BANK_BASE+0x232E2)
#define REG_FRC_BK232_E3        (REG_FRC_BANK_BASE+0x232E3)
#define REG_FRC_BK232_E4        (REG_FRC_BANK_BASE+0x232E4)
#define REG_FRC_BK232_E5        (REG_FRC_BANK_BASE+0x232E5)
#define REG_FRC_BK232_E6        (REG_FRC_BANK_BASE+0x232E6)
#define REG_FRC_BK232_E7        (REG_FRC_BANK_BASE+0x232E7)
#define REG_FRC_BK232_E8        (REG_FRC_BANK_BASE+0x232E8)
#define REG_FRC_BK232_E9        (REG_FRC_BANK_BASE+0x232E9)
#define REG_FRC_BK232_EA        (REG_FRC_BANK_BASE+0x232EA)
#define REG_FRC_BK232_EB        (REG_FRC_BANK_BASE+0x232EB)
#define REG_FRC_BK232_EC        (REG_FRC_BANK_BASE+0x232EC)
#define REG_FRC_BK232_ED        (REG_FRC_BANK_BASE+0x232ED)
#define REG_FRC_BK232_EE        (REG_FRC_BANK_BASE+0x232EE)
#define REG_FRC_BK232_EF        (REG_FRC_BANK_BASE+0x232EF)
#define REG_FRC_BK232_F0        (REG_FRC_BANK_BASE+0x232F0)
#define REG_FRC_BK232_F1        (REG_FRC_BANK_BASE+0x232F1)
#define REG_FRC_BK232_F2        (REG_FRC_BANK_BASE+0x232F2)
#define REG_FRC_BK232_F3        (REG_FRC_BANK_BASE+0x232F3)
#define REG_FRC_BK232_F4        (REG_FRC_BANK_BASE+0x232F4)
#define REG_FRC_BK232_F5        (REG_FRC_BANK_BASE+0x232F5)
#define REG_FRC_BK232_F6        (REG_FRC_BANK_BASE+0x232F6)
#define REG_FRC_BK232_F7        (REG_FRC_BANK_BASE+0x232F7)
#define REG_FRC_BK232_F8        (REG_FRC_BANK_BASE+0x232F8)
#define REG_FRC_BK232_F9        (REG_FRC_BANK_BASE+0x232F9)
#define REG_FRC_BK232_FA        (REG_FRC_BANK_BASE+0x232FA)
#define REG_FRC_BK232_FB        (REG_FRC_BANK_BASE+0x232FB)
#define REG_FRC_BK232_FC        (REG_FRC_BANK_BASE+0x232FC)
#define REG_FRC_BK232_FD        (REG_FRC_BANK_BASE+0x232FD)
#define REG_FRC_BK232_FE        (REG_FRC_BANK_BASE+0x232FE)
#define REG_FRC_BK232_FF        (REG_FRC_BANK_BASE+0x232FF)

// === FRC bk133 -> 0x4233
#define REG_FRC_BK233_00        (REG_FRC_BANK_BASE+0x23300)
#define REG_FRC_BK233_01        (REG_FRC_BANK_BASE+0x23301)
#define REG_FRC_BK233_02        (REG_FRC_BANK_BASE+0x23302)
#define REG_FRC_BK233_03        (REG_FRC_BANK_BASE+0x23303)
#define REG_FRC_BK233_04        (REG_FRC_BANK_BASE+0x23304)
#define REG_FRC_BK233_05        (REG_FRC_BANK_BASE+0x23305)
#define REG_FRC_BK233_06        (REG_FRC_BANK_BASE+0x23306)
#define REG_FRC_BK233_07        (REG_FRC_BANK_BASE+0x23307)
#define REG_FRC_BK233_08        (REG_FRC_BANK_BASE+0x23308)
#define REG_FRC_BK233_09        (REG_FRC_BANK_BASE+0x23309)
#define REG_FRC_BK233_0A        (REG_FRC_BANK_BASE+0x2330A)
#define REG_FRC_BK233_0B        (REG_FRC_BANK_BASE+0x2330B)
#define REG_FRC_BK233_0C        (REG_FRC_BANK_BASE+0x2330C)
#define REG_FRC_BK233_0D        (REG_FRC_BANK_BASE+0x2330D)
#define REG_FRC_BK233_0E        (REG_FRC_BANK_BASE+0x2330E)
#define REG_FRC_BK233_0F        (REG_FRC_BANK_BASE+0x2330F)
#define REG_FRC_BK233_10        (REG_FRC_BANK_BASE+0x23310)
#define REG_FRC_BK233_11        (REG_FRC_BANK_BASE+0x23311)
#define REG_FRC_BK233_12        (REG_FRC_BANK_BASE+0x23312)
#define REG_FRC_BK233_13        (REG_FRC_BANK_BASE+0x23313)
#define REG_FRC_BK233_14        (REG_FRC_BANK_BASE+0x23314)
#define REG_FRC_BK233_15        (REG_FRC_BANK_BASE+0x23315)
#define REG_FRC_BK233_16        (REG_FRC_BANK_BASE+0x23316)
#define REG_FRC_BK233_17        (REG_FRC_BANK_BASE+0x23317)
#define REG_FRC_BK233_18        (REG_FRC_BANK_BASE+0x23318)
#define REG_FRC_BK233_19        (REG_FRC_BANK_BASE+0x23319)
#define REG_FRC_BK233_1A        (REG_FRC_BANK_BASE+0x2331A)
#define REG_FRC_BK233_1B        (REG_FRC_BANK_BASE+0x2331B)
#define REG_FRC_BK233_1C        (REG_FRC_BANK_BASE+0x2331C)
#define REG_FRC_BK233_1D        (REG_FRC_BANK_BASE+0x2331D)
#define REG_FRC_BK233_1E        (REG_FRC_BANK_BASE+0x2331E)
#define REG_FRC_BK233_1F        (REG_FRC_BANK_BASE+0x2331F)
#define REG_FRC_BK233_20        (REG_FRC_BANK_BASE+0x23320)
#define REG_FRC_BK233_21        (REG_FRC_BANK_BASE+0x23321)
#define REG_FRC_BK233_22        (REG_FRC_BANK_BASE+0x23322)
#define REG_FRC_BK233_23        (REG_FRC_BANK_BASE+0x23323)
#define REG_FRC_BK233_24        (REG_FRC_BANK_BASE+0x23324)
#define REG_FRC_BK233_25        (REG_FRC_BANK_BASE+0x23325)
#define REG_FRC_BK233_26        (REG_FRC_BANK_BASE+0x23326)
#define REG_FRC_BK233_27        (REG_FRC_BANK_BASE+0x23327)
#define REG_FRC_BK233_28        (REG_FRC_BANK_BASE+0x23328)
#define REG_FRC_BK233_29        (REG_FRC_BANK_BASE+0x23329)
#define REG_FRC_BK233_2A        (REG_FRC_BANK_BASE+0x2332A)
#define REG_FRC_BK233_2B        (REG_FRC_BANK_BASE+0x2332B)
#define REG_FRC_BK233_2C        (REG_FRC_BANK_BASE+0x2332C)
#define REG_FRC_BK233_2D        (REG_FRC_BANK_BASE+0x2332D)
#define REG_FRC_BK233_2E        (REG_FRC_BANK_BASE+0x2332E)
#define REG_FRC_BK233_2F        (REG_FRC_BANK_BASE+0x2332F)
#define REG_FRC_BK233_30        (REG_FRC_BANK_BASE+0x23330)
#define REG_FRC_BK233_31        (REG_FRC_BANK_BASE+0x23331)
#define REG_FRC_BK233_32        (REG_FRC_BANK_BASE+0x23332)
#define REG_FRC_BK233_33        (REG_FRC_BANK_BASE+0x23333)
#define REG_FRC_BK233_34        (REG_FRC_BANK_BASE+0x23334)
#define REG_FRC_BK233_35        (REG_FRC_BANK_BASE+0x23335)
#define REG_FRC_BK233_36        (REG_FRC_BANK_BASE+0x23336)
#define REG_FRC_BK233_37        (REG_FRC_BANK_BASE+0x23337)
#define REG_FRC_BK233_38        (REG_FRC_BANK_BASE+0x23338)
#define REG_FRC_BK233_39        (REG_FRC_BANK_BASE+0x23339)
#define REG_FRC_BK233_3A        (REG_FRC_BANK_BASE+0x2333A)
#define REG_FRC_BK233_3B        (REG_FRC_BANK_BASE+0x2333B)
#define REG_FRC_BK233_3C        (REG_FRC_BANK_BASE+0x2333C)
#define REG_FRC_BK233_3D        (REG_FRC_BANK_BASE+0x2333D)
#define REG_FRC_BK233_3E        (REG_FRC_BANK_BASE+0x2333E)
#define REG_FRC_BK233_3F        (REG_FRC_BANK_BASE+0x2333F)
#define REG_FRC_BK233_40        (REG_FRC_BANK_BASE+0x23340)
#define REG_FRC_BK233_41        (REG_FRC_BANK_BASE+0x23341)
#define REG_FRC_BK233_42        (REG_FRC_BANK_BASE+0x23342)
#define REG_FRC_BK233_43        (REG_FRC_BANK_BASE+0x23343)
#define REG_FRC_BK233_44        (REG_FRC_BANK_BASE+0x23344)
#define REG_FRC_BK233_45        (REG_FRC_BANK_BASE+0x23345)
#define REG_FRC_BK233_46        (REG_FRC_BANK_BASE+0x23346)
#define REG_FRC_BK233_47        (REG_FRC_BANK_BASE+0x23347)
#define REG_FRC_BK233_48        (REG_FRC_BANK_BASE+0x23348)
#define REG_FRC_BK233_49        (REG_FRC_BANK_BASE+0x23349)
#define REG_FRC_BK233_4A        (REG_FRC_BANK_BASE+0x2334A)
#define REG_FRC_BK233_4B        (REG_FRC_BANK_BASE+0x2334B)
#define REG_FRC_BK233_4C        (REG_FRC_BANK_BASE+0x2334C)
#define REG_FRC_BK233_4D        (REG_FRC_BANK_BASE+0x2334D)
#define REG_FRC_BK233_4E        (REG_FRC_BANK_BASE+0x2334E)
#define REG_FRC_BK233_4F        (REG_FRC_BANK_BASE+0x2334F)
#define REG_FRC_BK233_50        (REG_FRC_BANK_BASE+0x23350)
#define REG_FRC_BK233_51        (REG_FRC_BANK_BASE+0x23351)
#define REG_FRC_BK233_52        (REG_FRC_BANK_BASE+0x23352)
#define REG_FRC_BK233_53        (REG_FRC_BANK_BASE+0x23353)
#define REG_FRC_BK233_54        (REG_FRC_BANK_BASE+0x23354)
#define REG_FRC_BK233_55        (REG_FRC_BANK_BASE+0x23355)
#define REG_FRC_BK233_56        (REG_FRC_BANK_BASE+0x23356)
#define REG_FRC_BK233_57        (REG_FRC_BANK_BASE+0x23357)
#define REG_FRC_BK233_58        (REG_FRC_BANK_BASE+0x23358)
#define REG_FRC_BK233_59        (REG_FRC_BANK_BASE+0x23359)
#define REG_FRC_BK233_5A        (REG_FRC_BANK_BASE+0x2335A)
#define REG_FRC_BK233_5B        (REG_FRC_BANK_BASE+0x2335B)
#define REG_FRC_BK233_5C        (REG_FRC_BANK_BASE+0x2335C)
#define REG_FRC_BK233_5D        (REG_FRC_BANK_BASE+0x2335D)
#define REG_FRC_BK233_5E        (REG_FRC_BANK_BASE+0x2335E)
#define REG_FRC_BK233_5F        (REG_FRC_BANK_BASE+0x2335F)
#define REG_FRC_BK233_60        (REG_FRC_BANK_BASE+0x23360)
#define REG_FRC_BK233_61        (REG_FRC_BANK_BASE+0x23361)
#define REG_FRC_BK233_62        (REG_FRC_BANK_BASE+0x23362)
#define REG_FRC_BK233_63        (REG_FRC_BANK_BASE+0x23363)
#define REG_FRC_BK233_64        (REG_FRC_BANK_BASE+0x23364)
#define REG_FRC_BK233_65        (REG_FRC_BANK_BASE+0x23365)
#define REG_FRC_BK233_66        (REG_FRC_BANK_BASE+0x23366)
#define REG_FRC_BK233_67        (REG_FRC_BANK_BASE+0x23367)
#define REG_FRC_BK233_68        (REG_FRC_BANK_BASE+0x23368)
#define REG_FRC_BK233_69        (REG_FRC_BANK_BASE+0x23369)
#define REG_FRC_BK233_6A        (REG_FRC_BANK_BASE+0x2336A)
#define REG_FRC_BK233_6B        (REG_FRC_BANK_BASE+0x2336B)
#define REG_FRC_BK233_6C        (REG_FRC_BANK_BASE+0x2336C)
#define REG_FRC_BK233_6D        (REG_FRC_BANK_BASE+0x2336D)
#define REG_FRC_BK233_6E        (REG_FRC_BANK_BASE+0x2336E)
#define REG_FRC_BK233_6F        (REG_FRC_BANK_BASE+0x2336F)
#define REG_FRC_BK233_70        (REG_FRC_BANK_BASE+0x23370)
#define REG_FRC_BK233_71        (REG_FRC_BANK_BASE+0x23371)
#define REG_FRC_BK233_72        (REG_FRC_BANK_BASE+0x23372)
#define REG_FRC_BK233_73        (REG_FRC_BANK_BASE+0x23373)
#define REG_FRC_BK233_74        (REG_FRC_BANK_BASE+0x23374)
#define REG_FRC_BK233_75        (REG_FRC_BANK_BASE+0x23375)
#define REG_FRC_BK233_76        (REG_FRC_BANK_BASE+0x23376)
#define REG_FRC_BK233_77        (REG_FRC_BANK_BASE+0x23377)
#define REG_FRC_BK233_78        (REG_FRC_BANK_BASE+0x23378)
#define REG_FRC_BK233_79        (REG_FRC_BANK_BASE+0x23379)
#define REG_FRC_BK233_7A        (REG_FRC_BANK_BASE+0x2337A)
#define REG_FRC_BK233_7B        (REG_FRC_BANK_BASE+0x2337B)
#define REG_FRC_BK233_7C        (REG_FRC_BANK_BASE+0x2337C)
#define REG_FRC_BK233_7D        (REG_FRC_BANK_BASE+0x2337D)
#define REG_FRC_BK233_7E        (REG_FRC_BANK_BASE+0x2337E)
#define REG_FRC_BK233_7F        (REG_FRC_BANK_BASE+0x2337F)
#define REG_FRC_BK233_80        (REG_FRC_BANK_BASE+0x23380)
#define REG_FRC_BK233_81        (REG_FRC_BANK_BASE+0x23381)
#define REG_FRC_BK233_82        (REG_FRC_BANK_BASE+0x23382)
#define REG_FRC_BK233_83        (REG_FRC_BANK_BASE+0x23383)
#define REG_FRC_BK233_84        (REG_FRC_BANK_BASE+0x23384)
#define REG_FRC_BK233_85        (REG_FRC_BANK_BASE+0x23385)
#define REG_FRC_BK233_86        (REG_FRC_BANK_BASE+0x23386)
#define REG_FRC_BK233_87        (REG_FRC_BANK_BASE+0x23387)
#define REG_FRC_BK233_88        (REG_FRC_BANK_BASE+0x23388)
#define REG_FRC_BK233_89        (REG_FRC_BANK_BASE+0x23389)
#define REG_FRC_BK233_8A        (REG_FRC_BANK_BASE+0x2338A)
#define REG_FRC_BK233_8B        (REG_FRC_BANK_BASE+0x2338B)
#define REG_FRC_BK233_8C        (REG_FRC_BANK_BASE+0x2338C)
#define REG_FRC_BK233_8D        (REG_FRC_BANK_BASE+0x2338D)
#define REG_FRC_BK233_8E        (REG_FRC_BANK_BASE+0x2338E)
#define REG_FRC_BK233_8F        (REG_FRC_BANK_BASE+0x2338F)
#define REG_FRC_BK233_90        (REG_FRC_BANK_BASE+0x23390)
#define REG_FRC_BK233_91        (REG_FRC_BANK_BASE+0x23391)
#define REG_FRC_BK233_92        (REG_FRC_BANK_BASE+0x23392)
#define REG_FRC_BK233_93        (REG_FRC_BANK_BASE+0x23393)
#define REG_FRC_BK233_94        (REG_FRC_BANK_BASE+0x23394)
#define REG_FRC_BK233_95        (REG_FRC_BANK_BASE+0x23395)
#define REG_FRC_BK233_96        (REG_FRC_BANK_BASE+0x23396)
#define REG_FRC_BK233_97        (REG_FRC_BANK_BASE+0x23397)
#define REG_FRC_BK233_98        (REG_FRC_BANK_BASE+0x23398)
#define REG_FRC_BK233_99        (REG_FRC_BANK_BASE+0x23399)
#define REG_FRC_BK233_9A        (REG_FRC_BANK_BASE+0x2339A)
#define REG_FRC_BK233_9B        (REG_FRC_BANK_BASE+0x2339B)
#define REG_FRC_BK233_9C        (REG_FRC_BANK_BASE+0x2339C)
#define REG_FRC_BK233_9D        (REG_FRC_BANK_BASE+0x2339D)
#define REG_FRC_BK233_9E        (REG_FRC_BANK_BASE+0x2339E)
#define REG_FRC_BK233_9F        (REG_FRC_BANK_BASE+0x2339F)
#define REG_FRC_BK233_A0        (REG_FRC_BANK_BASE+0x233A0)
#define REG_FRC_BK233_A1        (REG_FRC_BANK_BASE+0x233A1)
#define REG_FRC_BK233_A2        (REG_FRC_BANK_BASE+0x233A2)
#define REG_FRC_BK233_A3        (REG_FRC_BANK_BASE+0x233A3)
#define REG_FRC_BK233_A4        (REG_FRC_BANK_BASE+0x233A4)
#define REG_FRC_BK233_A5        (REG_FRC_BANK_BASE+0x233A5)
#define REG_FRC_BK233_A6        (REG_FRC_BANK_BASE+0x233A6)
#define REG_FRC_BK233_A7        (REG_FRC_BANK_BASE+0x233A7)
#define REG_FRC_BK233_A8        (REG_FRC_BANK_BASE+0x233A8)
#define REG_FRC_BK233_A9        (REG_FRC_BANK_BASE+0x233A9)
#define REG_FRC_BK233_AA        (REG_FRC_BANK_BASE+0x233AA)
#define REG_FRC_BK233_AB        (REG_FRC_BANK_BASE+0x233AB)
#define REG_FRC_BK233_AC        (REG_FRC_BANK_BASE+0x233AC)
#define REG_FRC_BK233_AD        (REG_FRC_BANK_BASE+0x233AD)
#define REG_FRC_BK233_AE        (REG_FRC_BANK_BASE+0x233AE)
#define REG_FRC_BK233_AF        (REG_FRC_BANK_BASE+0x233AF)
#define REG_FRC_BK233_B0        (REG_FRC_BANK_BASE+0x233B0)
#define REG_FRC_BK233_B1        (REG_FRC_BANK_BASE+0x233B1)
#define REG_FRC_BK233_B2        (REG_FRC_BANK_BASE+0x233B2)
#define REG_FRC_BK233_B3        (REG_FRC_BANK_BASE+0x233B3)
#define REG_FRC_BK233_B4        (REG_FRC_BANK_BASE+0x233B4)
#define REG_FRC_BK233_B5        (REG_FRC_BANK_BASE+0x233B5)
#define REG_FRC_BK233_B6        (REG_FRC_BANK_BASE+0x233B6)
#define REG_FRC_BK233_B7        (REG_FRC_BANK_BASE+0x233B7)
#define REG_FRC_BK233_B8        (REG_FRC_BANK_BASE+0x233B8)
#define REG_FRC_BK233_B9        (REG_FRC_BANK_BASE+0x233B9)
#define REG_FRC_BK233_BA        (REG_FRC_BANK_BASE+0x233BA)
#define REG_FRC_BK233_BB        (REG_FRC_BANK_BASE+0x233BB)
#define REG_FRC_BK233_BC        (REG_FRC_BANK_BASE+0x233BC)
#define REG_FRC_BK233_BD        (REG_FRC_BANK_BASE+0x233BD)
#define REG_FRC_BK233_BE        (REG_FRC_BANK_BASE+0x233BE)
#define REG_FRC_BK233_BF        (REG_FRC_BANK_BASE+0x233BF)
#define REG_FRC_BK233_C0        (REG_FRC_BANK_BASE+0x233C0)
#define REG_FRC_BK233_C1        (REG_FRC_BANK_BASE+0x233C1)
#define REG_FRC_BK233_C2        (REG_FRC_BANK_BASE+0x233C2)
#define REG_FRC_BK233_C3        (REG_FRC_BANK_BASE+0x233C3)
#define REG_FRC_BK233_C4        (REG_FRC_BANK_BASE+0x233C4)
#define REG_FRC_BK233_C5        (REG_FRC_BANK_BASE+0x233C5)
#define REG_FRC_BK233_C6        (REG_FRC_BANK_BASE+0x233C6)
#define REG_FRC_BK233_C7        (REG_FRC_BANK_BASE+0x233C7)
#define REG_FRC_BK233_C8        (REG_FRC_BANK_BASE+0x233C8)
#define REG_FRC_BK233_C9        (REG_FRC_BANK_BASE+0x233C9)
#define REG_FRC_BK233_CA        (REG_FRC_BANK_BASE+0x233CA)
#define REG_FRC_BK233_CB        (REG_FRC_BANK_BASE+0x233CB)
#define REG_FRC_BK233_CC        (REG_FRC_BANK_BASE+0x233CC)
#define REG_FRC_BK233_CD        (REG_FRC_BANK_BASE+0x233CD)
#define REG_FRC_BK233_CE        (REG_FRC_BANK_BASE+0x233CE)
#define REG_FRC_BK233_CF        (REG_FRC_BANK_BASE+0x233CF)
#define REG_FRC_BK233_D0        (REG_FRC_BANK_BASE+0x233D0)
#define REG_FRC_BK233_D1        (REG_FRC_BANK_BASE+0x233D1)
#define REG_FRC_BK233_D2        (REG_FRC_BANK_BASE+0x233D2)
#define REG_FRC_BK233_D3        (REG_FRC_BANK_BASE+0x233D3)
#define REG_FRC_BK233_D4        (REG_FRC_BANK_BASE+0x233D4)
#define REG_FRC_BK233_D5        (REG_FRC_BANK_BASE+0x233D5)
#define REG_FRC_BK233_D6        (REG_FRC_BANK_BASE+0x233D6)
#define REG_FRC_BK233_D7        (REG_FRC_BANK_BASE+0x233D7)
#define REG_FRC_BK233_D8        (REG_FRC_BANK_BASE+0x233D8)
#define REG_FRC_BK233_D9        (REG_FRC_BANK_BASE+0x233D9)
#define REG_FRC_BK233_DA        (REG_FRC_BANK_BASE+0x233DA)
#define REG_FRC_BK233_DB        (REG_FRC_BANK_BASE+0x233DB)
#define REG_FRC_BK233_DC        (REG_FRC_BANK_BASE+0x233DC)
#define REG_FRC_BK233_DD        (REG_FRC_BANK_BASE+0x233DD)
#define REG_FRC_BK233_DE        (REG_FRC_BANK_BASE+0x233DE)
#define REG_FRC_BK233_DF        (REG_FRC_BANK_BASE+0x233DF)
#define REG_FRC_BK233_E0        (REG_FRC_BANK_BASE+0x233E0)
#define REG_FRC_BK233_E1        (REG_FRC_BANK_BASE+0x233E1)
#define REG_FRC_BK233_E2        (REG_FRC_BANK_BASE+0x233E2)
#define REG_FRC_BK233_E3        (REG_FRC_BANK_BASE+0x233E3)
#define REG_FRC_BK233_E4        (REG_FRC_BANK_BASE+0x233E4)
#define REG_FRC_BK233_E5        (REG_FRC_BANK_BASE+0x233E5)
#define REG_FRC_BK233_E6        (REG_FRC_BANK_BASE+0x233E6)
#define REG_FRC_BK233_E7        (REG_FRC_BANK_BASE+0x233E7)
#define REG_FRC_BK233_E8        (REG_FRC_BANK_BASE+0x233E8)
#define REG_FRC_BK233_E9        (REG_FRC_BANK_BASE+0x233E9)
#define REG_FRC_BK233_EA        (REG_FRC_BANK_BASE+0x233EA)
#define REG_FRC_BK233_EB        (REG_FRC_BANK_BASE+0x233EB)
#define REG_FRC_BK233_EC        (REG_FRC_BANK_BASE+0x233EC)
#define REG_FRC_BK233_ED        (REG_FRC_BANK_BASE+0x233ED)
#define REG_FRC_BK233_EE        (REG_FRC_BANK_BASE+0x233EE)
#define REG_FRC_BK233_EF        (REG_FRC_BANK_BASE+0x233EF)
#define REG_FRC_BK233_F0        (REG_FRC_BANK_BASE+0x233F0)
#define REG_FRC_BK233_F1        (REG_FRC_BANK_BASE+0x233F1)
#define REG_FRC_BK233_F2        (REG_FRC_BANK_BASE+0x233F2)
#define REG_FRC_BK233_F3        (REG_FRC_BANK_BASE+0x233F3)
#define REG_FRC_BK233_F4        (REG_FRC_BANK_BASE+0x233F4)
#define REG_FRC_BK233_F5        (REG_FRC_BANK_BASE+0x233F5)
#define REG_FRC_BK233_F6        (REG_FRC_BANK_BASE+0x233F6)
#define REG_FRC_BK233_F7        (REG_FRC_BANK_BASE+0x233F7)
#define REG_FRC_BK233_F8        (REG_FRC_BANK_BASE+0x233F8)
#define REG_FRC_BK233_F9        (REG_FRC_BANK_BASE+0x233F9)
#define REG_FRC_BK233_FA        (REG_FRC_BANK_BASE+0x233FA)
#define REG_FRC_BK233_FB        (REG_FRC_BANK_BASE+0x233FB)
#define REG_FRC_BK233_FC        (REG_FRC_BANK_BASE+0x233FC)
#define REG_FRC_BK233_FD        (REG_FRC_BANK_BASE+0x233FD)
#define REG_FRC_BK233_FE        (REG_FRC_BANK_BASE+0x233FE)
#define REG_FRC_BK233_FF        (REG_FRC_BANK_BASE+0x233FF)

// === FRC bk134
#define REG_FRC_BK134_00        (REG_FRC_BANK_BASE+0x13400)
#define REG_FRC_BK134_01        (REG_FRC_BANK_BASE+0x13401)
#define REG_FRC_BK134_02        (REG_FRC_BANK_BASE+0x13402)
#define REG_FRC_BK134_03        (REG_FRC_BANK_BASE+0x13403)
#define REG_FRC_BK134_04        (REG_FRC_BANK_BASE+0x13404)
#define REG_FRC_BK134_05        (REG_FRC_BANK_BASE+0x13405)
#define REG_FRC_BK134_06        (REG_FRC_BANK_BASE+0x13406)
#define REG_FRC_BK134_07        (REG_FRC_BANK_BASE+0x13407)
#define REG_FRC_BK134_08        (REG_FRC_BANK_BASE+0x13408)
#define REG_FRC_BK134_09        (REG_FRC_BANK_BASE+0x13409)
#define REG_FRC_BK134_0A        (REG_FRC_BANK_BASE+0x1340A)
#define REG_FRC_BK134_0B        (REG_FRC_BANK_BASE+0x1340B)
#define REG_FRC_BK134_0C        (REG_FRC_BANK_BASE+0x1340C)
#define REG_FRC_BK134_0D        (REG_FRC_BANK_BASE+0x1340D)
#define REG_FRC_BK134_0E        (REG_FRC_BANK_BASE+0x1340E)
#define REG_FRC_BK134_0F        (REG_FRC_BANK_BASE+0x1340F)
#define REG_FRC_BK134_10        (REG_FRC_BANK_BASE+0x13410)
#define REG_FRC_BK134_11        (REG_FRC_BANK_BASE+0x13411)
#define REG_FRC_BK134_12        (REG_FRC_BANK_BASE+0x13412)
#define REG_FRC_BK134_13        (REG_FRC_BANK_BASE+0x13413)
#define REG_FRC_BK134_14        (REG_FRC_BANK_BASE+0x13414)
#define REG_FRC_BK134_15        (REG_FRC_BANK_BASE+0x13415)
#define REG_FRC_BK134_16        (REG_FRC_BANK_BASE+0x13416)
#define REG_FRC_BK134_17        (REG_FRC_BANK_BASE+0x13417)
#define REG_FRC_BK134_18        (REG_FRC_BANK_BASE+0x13418)
#define REG_FRC_BK134_19        (REG_FRC_BANK_BASE+0x13419)
#define REG_FRC_BK134_1A        (REG_FRC_BANK_BASE+0x1341A)
#define REG_FRC_BK134_1B        (REG_FRC_BANK_BASE+0x1341B)
#define REG_FRC_BK134_1C        (REG_FRC_BANK_BASE+0x1341C)
#define REG_FRC_BK134_1D        (REG_FRC_BANK_BASE+0x1341D)
#define REG_FRC_BK134_1E        (REG_FRC_BANK_BASE+0x1341E)
#define REG_FRC_BK134_1F        (REG_FRC_BANK_BASE+0x1341F)
#define REG_FRC_BK134_20        (REG_FRC_BANK_BASE+0x13420)
#define REG_FRC_BK134_21        (REG_FRC_BANK_BASE+0x13421)
#define REG_FRC_BK134_22        (REG_FRC_BANK_BASE+0x13422)
#define REG_FRC_BK134_23        (REG_FRC_BANK_BASE+0x13423)
#define REG_FRC_BK134_24        (REG_FRC_BANK_BASE+0x13424)
#define REG_FRC_BK134_25        (REG_FRC_BANK_BASE+0x13425)
#define REG_FRC_BK134_26        (REG_FRC_BANK_BASE+0x13426)
#define REG_FRC_BK134_27        (REG_FRC_BANK_BASE+0x13427)
#define REG_FRC_BK134_28        (REG_FRC_BANK_BASE+0x13428)
#define REG_FRC_BK134_29        (REG_FRC_BANK_BASE+0x13429)
#define REG_FRC_BK134_2A        (REG_FRC_BANK_BASE+0x1342A)
#define REG_FRC_BK134_2B        (REG_FRC_BANK_BASE+0x1342B)
#define REG_FRC_BK134_2C        (REG_FRC_BANK_BASE+0x1342C)
#define REG_FRC_BK134_2D        (REG_FRC_BANK_BASE+0x1342D)
#define REG_FRC_BK134_2E        (REG_FRC_BANK_BASE+0x1342E)
#define REG_FRC_BK134_2F        (REG_FRC_BANK_BASE+0x1342F)
#define REG_FRC_BK134_30        (REG_FRC_BANK_BASE+0x13430)
#define REG_FRC_BK134_31        (REG_FRC_BANK_BASE+0x13431)
#define REG_FRC_BK134_32        (REG_FRC_BANK_BASE+0x13432)
#define REG_FRC_BK134_33        (REG_FRC_BANK_BASE+0x13433)
#define REG_FRC_BK134_34        (REG_FRC_BANK_BASE+0x13434)
#define REG_FRC_BK134_35        (REG_FRC_BANK_BASE+0x13435)
#define REG_FRC_BK134_36        (REG_FRC_BANK_BASE+0x13436)
#define REG_FRC_BK134_37        (REG_FRC_BANK_BASE+0x13437)
#define REG_FRC_BK134_38        (REG_FRC_BANK_BASE+0x13438)
#define REG_FRC_BK134_39        (REG_FRC_BANK_BASE+0x13439)
#define REG_FRC_BK134_3A        (REG_FRC_BANK_BASE+0x1343A)
#define REG_FRC_BK134_3B        (REG_FRC_BANK_BASE+0x1343B)
#define REG_FRC_BK134_3C        (REG_FRC_BANK_BASE+0x1343C)
#define REG_FRC_BK134_3D        (REG_FRC_BANK_BASE+0x1343D)
#define REG_FRC_BK134_3E        (REG_FRC_BANK_BASE+0x1343E)
#define REG_FRC_BK134_3F        (REG_FRC_BANK_BASE+0x1343F)
#define REG_FRC_BK134_40        (REG_FRC_BANK_BASE+0x13440)
#define REG_FRC_BK134_41        (REG_FRC_BANK_BASE+0x13441)
#define REG_FRC_BK134_42        (REG_FRC_BANK_BASE+0x13442)
#define REG_FRC_BK134_43        (REG_FRC_BANK_BASE+0x13443)
#define REG_FRC_BK134_44        (REG_FRC_BANK_BASE+0x13444)
#define REG_FRC_BK134_45        (REG_FRC_BANK_BASE+0x13445)
#define REG_FRC_BK134_46        (REG_FRC_BANK_BASE+0x13446)
#define REG_FRC_BK134_47        (REG_FRC_BANK_BASE+0x13447)
#define REG_FRC_BK134_48        (REG_FRC_BANK_BASE+0x13448)
#define REG_FRC_BK134_49        (REG_FRC_BANK_BASE+0x13449)
#define REG_FRC_BK134_4A        (REG_FRC_BANK_BASE+0x1344A)
#define REG_FRC_BK134_4B        (REG_FRC_BANK_BASE+0x1344B)
#define REG_FRC_BK134_4C        (REG_FRC_BANK_BASE+0x1344C)
#define REG_FRC_BK134_4D        (REG_FRC_BANK_BASE+0x1344D)
#define REG_FRC_BK134_4E        (REG_FRC_BANK_BASE+0x1344E)
#define REG_FRC_BK134_4F        (REG_FRC_BANK_BASE+0x1344F)
#define REG_FRC_BK134_50        (REG_FRC_BANK_BASE+0x13450)
#define REG_FRC_BK134_51        (REG_FRC_BANK_BASE+0x13451)
#define REG_FRC_BK134_52        (REG_FRC_BANK_BASE+0x13452)
#define REG_FRC_BK134_53        (REG_FRC_BANK_BASE+0x13453)
#define REG_FRC_BK134_54        (REG_FRC_BANK_BASE+0x13454)
#define REG_FRC_BK134_55        (REG_FRC_BANK_BASE+0x13455)
#define REG_FRC_BK134_56        (REG_FRC_BANK_BASE+0x13456)
#define REG_FRC_BK134_57        (REG_FRC_BANK_BASE+0x13457)
#define REG_FRC_BK134_58        (REG_FRC_BANK_BASE+0x13458)
#define REG_FRC_BK134_59        (REG_FRC_BANK_BASE+0x13459)
#define REG_FRC_BK134_5A        (REG_FRC_BANK_BASE+0x1345A)
#define REG_FRC_BK134_5B        (REG_FRC_BANK_BASE+0x1345B)
#define REG_FRC_BK134_5C        (REG_FRC_BANK_BASE+0x1345C)
#define REG_FRC_BK134_5D        (REG_FRC_BANK_BASE+0x1345D)
#define REG_FRC_BK134_5E        (REG_FRC_BANK_BASE+0x1345E)
#define REG_FRC_BK134_5F        (REG_FRC_BANK_BASE+0x1345F)
#define REG_FRC_BK134_60        (REG_FRC_BANK_BASE+0x13460)
#define REG_FRC_BK134_61        (REG_FRC_BANK_BASE+0x13461)
#define REG_FRC_BK134_62        (REG_FRC_BANK_BASE+0x13462)
#define REG_FRC_BK134_63        (REG_FRC_BANK_BASE+0x13463)
#define REG_FRC_BK134_64        (REG_FRC_BANK_BASE+0x13464)
#define REG_FRC_BK134_65        (REG_FRC_BANK_BASE+0x13465)
#define REG_FRC_BK134_66        (REG_FRC_BANK_BASE+0x13466)
#define REG_FRC_BK134_67        (REG_FRC_BANK_BASE+0x13467)
#define REG_FRC_BK134_68        (REG_FRC_BANK_BASE+0x13468)
#define REG_FRC_BK134_69        (REG_FRC_BANK_BASE+0x13469)
#define REG_FRC_BK134_6A        (REG_FRC_BANK_BASE+0x1346A)
#define REG_FRC_BK134_6B        (REG_FRC_BANK_BASE+0x1346B)
#define REG_FRC_BK134_6C        (REG_FRC_BANK_BASE+0x1346C)
#define REG_FRC_BK134_6D        (REG_FRC_BANK_BASE+0x1346D)
#define REG_FRC_BK134_6E        (REG_FRC_BANK_BASE+0x1346E)
#define REG_FRC_BK134_6F        (REG_FRC_BANK_BASE+0x1346F)
#define REG_FRC_BK134_70        (REG_FRC_BANK_BASE+0x13470)
#define REG_FRC_BK134_71        (REG_FRC_BANK_BASE+0x13471)
#define REG_FRC_BK134_72        (REG_FRC_BANK_BASE+0x13472)
#define REG_FRC_BK134_73        (REG_FRC_BANK_BASE+0x13473)
#define REG_FRC_BK134_74        (REG_FRC_BANK_BASE+0x13474)
#define REG_FRC_BK134_75        (REG_FRC_BANK_BASE+0x13475)
#define REG_FRC_BK134_76        (REG_FRC_BANK_BASE+0x13476)
#define REG_FRC_BK134_77        (REG_FRC_BANK_BASE+0x13477)
#define REG_FRC_BK134_78        (REG_FRC_BANK_BASE+0x13478)
#define REG_FRC_BK134_79        (REG_FRC_BANK_BASE+0x13479)
#define REG_FRC_BK134_7A        (REG_FRC_BANK_BASE+0x1347A)
#define REG_FRC_BK134_7B        (REG_FRC_BANK_BASE+0x1347B)
#define REG_FRC_BK134_7C        (REG_FRC_BANK_BASE+0x1347C)
#define REG_FRC_BK134_7D        (REG_FRC_BANK_BASE+0x1347D)
#define REG_FRC_BK134_7E        (REG_FRC_BANK_BASE+0x1347E)
#define REG_FRC_BK134_7F        (REG_FRC_BANK_BASE+0x1347F)
#define REG_FRC_BK134_80        (REG_FRC_BANK_BASE+0x13480)
#define REG_FRC_BK134_81        (REG_FRC_BANK_BASE+0x13481)
#define REG_FRC_BK134_82        (REG_FRC_BANK_BASE+0x13482)
#define REG_FRC_BK134_83        (REG_FRC_BANK_BASE+0x13483)
#define REG_FRC_BK134_84        (REG_FRC_BANK_BASE+0x13484)
#define REG_FRC_BK134_85        (REG_FRC_BANK_BASE+0x13485)
#define REG_FRC_BK134_86        (REG_FRC_BANK_BASE+0x13486)
#define REG_FRC_BK134_87        (REG_FRC_BANK_BASE+0x13487)
#define REG_FRC_BK134_88        (REG_FRC_BANK_BASE+0x13488)
#define REG_FRC_BK134_89        (REG_FRC_BANK_BASE+0x13489)
#define REG_FRC_BK134_8A        (REG_FRC_BANK_BASE+0x1348A)
#define REG_FRC_BK134_8B        (REG_FRC_BANK_BASE+0x1348B)
#define REG_FRC_BK134_8C        (REG_FRC_BANK_BASE+0x1348C)
#define REG_FRC_BK134_8D        (REG_FRC_BANK_BASE+0x1348D)
#define REG_FRC_BK134_8E        (REG_FRC_BANK_BASE+0x1348E)
#define REG_FRC_BK134_8F        (REG_FRC_BANK_BASE+0x1348F)
#define REG_FRC_BK134_90        (REG_FRC_BANK_BASE+0x13490)
#define REG_FRC_BK134_91        (REG_FRC_BANK_BASE+0x13491)
#define REG_FRC_BK134_92        (REG_FRC_BANK_BASE+0x13492)
#define REG_FRC_BK134_93        (REG_FRC_BANK_BASE+0x13493)
#define REG_FRC_BK134_94        (REG_FRC_BANK_BASE+0x13494)
#define REG_FRC_BK134_95        (REG_FRC_BANK_BASE+0x13495)
#define REG_FRC_BK134_96        (REG_FRC_BANK_BASE+0x13496)
#define REG_FRC_BK134_97        (REG_FRC_BANK_BASE+0x13497)
#define REG_FRC_BK134_98        (REG_FRC_BANK_BASE+0x13498)
#define REG_FRC_BK134_99        (REG_FRC_BANK_BASE+0x13499)
#define REG_FRC_BK134_9A        (REG_FRC_BANK_BASE+0x1349A)
#define REG_FRC_BK134_9B        (REG_FRC_BANK_BASE+0x1349B)
#define REG_FRC_BK134_9C        (REG_FRC_BANK_BASE+0x1349C)
#define REG_FRC_BK134_9D        (REG_FRC_BANK_BASE+0x1349D)
#define REG_FRC_BK134_9E        (REG_FRC_BANK_BASE+0x1349E)
#define REG_FRC_BK134_9F        (REG_FRC_BANK_BASE+0x1349F)
#define REG_FRC_BK134_A0        (REG_FRC_BANK_BASE+0x134A0)
#define REG_FRC_BK134_A1        (REG_FRC_BANK_BASE+0x134A1)
#define REG_FRC_BK134_A2        (REG_FRC_BANK_BASE+0x134A2)
#define REG_FRC_BK134_A3        (REG_FRC_BANK_BASE+0x134A3)
#define REG_FRC_BK134_A4        (REG_FRC_BANK_BASE+0x134A4)
#define REG_FRC_BK134_A5        (REG_FRC_BANK_BASE+0x134A5)
#define REG_FRC_BK134_A6        (REG_FRC_BANK_BASE+0x134A6)
#define REG_FRC_BK134_A7        (REG_FRC_BANK_BASE+0x134A7)
#define REG_FRC_BK134_A8        (REG_FRC_BANK_BASE+0x134A8)
#define REG_FRC_BK134_A9        (REG_FRC_BANK_BASE+0x134A9)
#define REG_FRC_BK134_AA        (REG_FRC_BANK_BASE+0x134AA)
#define REG_FRC_BK134_AB        (REG_FRC_BANK_BASE+0x134AB)
#define REG_FRC_BK134_AC        (REG_FRC_BANK_BASE+0x134AC)
#define REG_FRC_BK134_AD        (REG_FRC_BANK_BASE+0x134AD)
#define REG_FRC_BK134_AE        (REG_FRC_BANK_BASE+0x134AE)
#define REG_FRC_BK134_AF        (REG_FRC_BANK_BASE+0x134AF)
#define REG_FRC_BK134_B0        (REG_FRC_BANK_BASE+0x134B0)
#define REG_FRC_BK134_B1        (REG_FRC_BANK_BASE+0x134B1)
#define REG_FRC_BK134_B2        (REG_FRC_BANK_BASE+0x134B2)
#define REG_FRC_BK134_B3        (REG_FRC_BANK_BASE+0x134B3)
#define REG_FRC_BK134_B4        (REG_FRC_BANK_BASE+0x134B4)
#define REG_FRC_BK134_B5        (REG_FRC_BANK_BASE+0x134B5)
#define REG_FRC_BK134_B6        (REG_FRC_BANK_BASE+0x134B6)
#define REG_FRC_BK134_B7        (REG_FRC_BANK_BASE+0x134B7)
#define REG_FRC_BK134_B8        (REG_FRC_BANK_BASE+0x134B8)
#define REG_FRC_BK134_B9        (REG_FRC_BANK_BASE+0x134B9)
#define REG_FRC_BK134_BA        (REG_FRC_BANK_BASE+0x134BA)
#define REG_FRC_BK134_BB        (REG_FRC_BANK_BASE+0x134BB)
#define REG_FRC_BK134_BC        (REG_FRC_BANK_BASE+0x134BC)
#define REG_FRC_BK134_BD        (REG_FRC_BANK_BASE+0x134BD)
#define REG_FRC_BK134_BE        (REG_FRC_BANK_BASE+0x134BE)
#define REG_FRC_BK134_BF        (REG_FRC_BANK_BASE+0x134BF)
#define REG_FRC_BK134_C0        (REG_FRC_BANK_BASE+0x134C0)
#define REG_FRC_BK134_C1        (REG_FRC_BANK_BASE+0x134C1)
#define REG_FRC_BK134_C2        (REG_FRC_BANK_BASE+0x134C2)
#define REG_FRC_BK134_C3        (REG_FRC_BANK_BASE+0x134C3)
#define REG_FRC_BK134_C4        (REG_FRC_BANK_BASE+0x134C4)
#define REG_FRC_BK134_C5        (REG_FRC_BANK_BASE+0x134C5)
#define REG_FRC_BK134_C6        (REG_FRC_BANK_BASE+0x134C6)
#define REG_FRC_BK134_C7        (REG_FRC_BANK_BASE+0x134C7)
#define REG_FRC_BK134_C8        (REG_FRC_BANK_BASE+0x134C8)
#define REG_FRC_BK134_C9        (REG_FRC_BANK_BASE+0x134C9)
#define REG_FRC_BK134_CA        (REG_FRC_BANK_BASE+0x134CA)
#define REG_FRC_BK134_CB        (REG_FRC_BANK_BASE+0x134CB)
#define REG_FRC_BK134_CC        (REG_FRC_BANK_BASE+0x134CC)
#define REG_FRC_BK134_CD        (REG_FRC_BANK_BASE+0x134CD)
#define REG_FRC_BK134_CE        (REG_FRC_BANK_BASE+0x134CE)
#define REG_FRC_BK134_CF        (REG_FRC_BANK_BASE+0x134CF)
#define REG_FRC_BK134_D0        (REG_FRC_BANK_BASE+0x134D0)
#define REG_FRC_BK134_D1        (REG_FRC_BANK_BASE+0x134D1)
#define REG_FRC_BK134_D2        (REG_FRC_BANK_BASE+0x134D2)
#define REG_FRC_BK134_D3        (REG_FRC_BANK_BASE+0x134D3)
#define REG_FRC_BK134_D4        (REG_FRC_BANK_BASE+0x134D4)
#define REG_FRC_BK134_D5        (REG_FRC_BANK_BASE+0x134D5)
#define REG_FRC_BK134_D6        (REG_FRC_BANK_BASE+0x134D6)
#define REG_FRC_BK134_D7        (REG_FRC_BANK_BASE+0x134D7)
#define REG_FRC_BK134_D8        (REG_FRC_BANK_BASE+0x134D8)
#define REG_FRC_BK134_D9        (REG_FRC_BANK_BASE+0x134D9)
#define REG_FRC_BK134_DA        (REG_FRC_BANK_BASE+0x134DA)
#define REG_FRC_BK134_DB        (REG_FRC_BANK_BASE+0x134DB)
#define REG_FRC_BK134_DC        (REG_FRC_BANK_BASE+0x134DC)
#define REG_FRC_BK134_DD        (REG_FRC_BANK_BASE+0x134DD)
#define REG_FRC_BK134_DE        (REG_FRC_BANK_BASE+0x134DE)
#define REG_FRC_BK134_DF        (REG_FRC_BANK_BASE+0x134DF)
#define REG_FRC_BK134_E0        (REG_FRC_BANK_BASE+0x134E0)
#define REG_FRC_BK134_E1        (REG_FRC_BANK_BASE+0x134E1)
#define REG_FRC_BK134_E2        (REG_FRC_BANK_BASE+0x134E2)
#define REG_FRC_BK134_E3        (REG_FRC_BANK_BASE+0x134E3)
#define REG_FRC_BK134_E4        (REG_FRC_BANK_BASE+0x134E4)
#define REG_FRC_BK134_E5        (REG_FRC_BANK_BASE+0x134E5)
#define REG_FRC_BK134_E6        (REG_FRC_BANK_BASE+0x134E6)
#define REG_FRC_BK134_E7        (REG_FRC_BANK_BASE+0x134E7)
#define REG_FRC_BK134_E8        (REG_FRC_BANK_BASE+0x134E8)
#define REG_FRC_BK134_E9        (REG_FRC_BANK_BASE+0x134E9)
#define REG_FRC_BK134_EA        (REG_FRC_BANK_BASE+0x134EA)
#define REG_FRC_BK134_EB        (REG_FRC_BANK_BASE+0x134EB)
#define REG_FRC_BK134_EC        (REG_FRC_BANK_BASE+0x134EC)
#define REG_FRC_BK134_ED        (REG_FRC_BANK_BASE+0x134ED)
#define REG_FRC_BK134_EE        (REG_FRC_BANK_BASE+0x134EE)
#define REG_FRC_BK134_EF        (REG_FRC_BANK_BASE+0x134EF)
#define REG_FRC_BK134_F0        (REG_FRC_BANK_BASE+0x134F0)
#define REG_FRC_BK134_F1        (REG_FRC_BANK_BASE+0x134F1)
#define REG_FRC_BK134_F2        (REG_FRC_BANK_BASE+0x134F2)
#define REG_FRC_BK134_F3        (REG_FRC_BANK_BASE+0x134F3)
#define REG_FRC_BK134_F4        (REG_FRC_BANK_BASE+0x134F4)
#define REG_FRC_BK134_F5        (REG_FRC_BANK_BASE+0x134F5)
#define REG_FRC_BK134_F6        (REG_FRC_BANK_BASE+0x134F6)
#define REG_FRC_BK134_F7        (REG_FRC_BANK_BASE+0x134F7)
#define REG_FRC_BK134_F8        (REG_FRC_BANK_BASE+0x134F8)
#define REG_FRC_BK134_F9        (REG_FRC_BANK_BASE+0x134F9)
#define REG_FRC_BK134_FA        (REG_FRC_BANK_BASE+0x134FA)
#define REG_FRC_BK134_FB        (REG_FRC_BANK_BASE+0x134FB)
#define REG_FRC_BK134_FC        (REG_FRC_BANK_BASE+0x134FC)
#define REG_FRC_BK134_FD        (REG_FRC_BANK_BASE+0x134FD)
#define REG_FRC_BK134_FE        (REG_FRC_BANK_BASE+0x134FE)
#define REG_FRC_BK134_FF        (REG_FRC_BANK_BASE+0x134FF)

// === FRC bk135
#define REG_FRC_BK135_00        (REG_FRC_BANK_BASE+0x13500)
#define REG_FRC_BK135_01        (REG_FRC_BANK_BASE+0x13501)
#define REG_FRC_BK135_02        (REG_FRC_BANK_BASE+0x13502)
#define REG_FRC_BK135_03        (REG_FRC_BANK_BASE+0x13503)
#define REG_FRC_BK135_04        (REG_FRC_BANK_BASE+0x13504)
#define REG_FRC_BK135_05        (REG_FRC_BANK_BASE+0x13505)
#define REG_FRC_BK135_06        (REG_FRC_BANK_BASE+0x13506)
#define REG_FRC_BK135_07        (REG_FRC_BANK_BASE+0x13507)
#define REG_FRC_BK135_08        (REG_FRC_BANK_BASE+0x13508)
#define REG_FRC_BK135_09        (REG_FRC_BANK_BASE+0x13509)
#define REG_FRC_BK135_0A        (REG_FRC_BANK_BASE+0x1350A)
#define REG_FRC_BK135_0B        (REG_FRC_BANK_BASE+0x1350B)
#define REG_FRC_BK135_0C        (REG_FRC_BANK_BASE+0x1350C)
#define REG_FRC_BK135_0D        (REG_FRC_BANK_BASE+0x1350D)
#define REG_FRC_BK135_0E        (REG_FRC_BANK_BASE+0x1350E)
#define REG_FRC_BK135_0F        (REG_FRC_BANK_BASE+0x1350F)
#define REG_FRC_BK135_10        (REG_FRC_BANK_BASE+0x13510)
#define REG_FRC_BK135_11        (REG_FRC_BANK_BASE+0x13511)
#define REG_FRC_BK135_12        (REG_FRC_BANK_BASE+0x13512)
#define REG_FRC_BK135_13        (REG_FRC_BANK_BASE+0x13513)
#define REG_FRC_BK135_14        (REG_FRC_BANK_BASE+0x13514)
#define REG_FRC_BK135_15        (REG_FRC_BANK_BASE+0x13515)
#define REG_FRC_BK135_16        (REG_FRC_BANK_BASE+0x13516)
#define REG_FRC_BK135_17        (REG_FRC_BANK_BASE+0x13517)
#define REG_FRC_BK135_18        (REG_FRC_BANK_BASE+0x13518)
#define REG_FRC_BK135_19        (REG_FRC_BANK_BASE+0x13519)
#define REG_FRC_BK135_1A        (REG_FRC_BANK_BASE+0x1351A)
#define REG_FRC_BK135_1B        (REG_FRC_BANK_BASE+0x1351B)
#define REG_FRC_BK135_1C        (REG_FRC_BANK_BASE+0x1351C)
#define REG_FRC_BK135_1D        (REG_FRC_BANK_BASE+0x1351D)
#define REG_FRC_BK135_1E        (REG_FRC_BANK_BASE+0x1351E)
#define REG_FRC_BK135_1F        (REG_FRC_BANK_BASE+0x1351F)
#define REG_FRC_BK135_20        (REG_FRC_BANK_BASE+0x13520)
#define REG_FRC_BK135_21        (REG_FRC_BANK_BASE+0x13521)
#define REG_FRC_BK135_22        (REG_FRC_BANK_BASE+0x13522)
#define REG_FRC_BK135_23        (REG_FRC_BANK_BASE+0x13523)
#define REG_FRC_BK135_24        (REG_FRC_BANK_BASE+0x13524)
#define REG_FRC_BK135_25        (REG_FRC_BANK_BASE+0x13525)
#define REG_FRC_BK135_26        (REG_FRC_BANK_BASE+0x13526)
#define REG_FRC_BK135_27        (REG_FRC_BANK_BASE+0x13527)
#define REG_FRC_BK135_28        (REG_FRC_BANK_BASE+0x13528)
#define REG_FRC_BK135_29        (REG_FRC_BANK_BASE+0x13529)
#define REG_FRC_BK135_2A        (REG_FRC_BANK_BASE+0x1352A)
#define REG_FRC_BK135_2B        (REG_FRC_BANK_BASE+0x1352B)
#define REG_FRC_BK135_2C        (REG_FRC_BANK_BASE+0x1352C)
#define REG_FRC_BK135_2D        (REG_FRC_BANK_BASE+0x1352D)
#define REG_FRC_BK135_2E        (REG_FRC_BANK_BASE+0x1352E)
#define REG_FRC_BK135_2F        (REG_FRC_BANK_BASE+0x1352F)
#define REG_FRC_BK135_30        (REG_FRC_BANK_BASE+0x13530)
#define REG_FRC_BK135_31        (REG_FRC_BANK_BASE+0x13531)
#define REG_FRC_BK135_32        (REG_FRC_BANK_BASE+0x13532)
#define REG_FRC_BK135_33        (REG_FRC_BANK_BASE+0x13533)
#define REG_FRC_BK135_34        (REG_FRC_BANK_BASE+0x13534)
#define REG_FRC_BK135_35        (REG_FRC_BANK_BASE+0x13535)
#define REG_FRC_BK135_36        (REG_FRC_BANK_BASE+0x13536)
#define REG_FRC_BK135_37        (REG_FRC_BANK_BASE+0x13537)
#define REG_FRC_BK135_38        (REG_FRC_BANK_BASE+0x13538)
#define REG_FRC_BK135_39        (REG_FRC_BANK_BASE+0x13539)
#define REG_FRC_BK135_3A        (REG_FRC_BANK_BASE+0x1353A)
#define REG_FRC_BK135_3B        (REG_FRC_BANK_BASE+0x1353B)
#define REG_FRC_BK135_3C        (REG_FRC_BANK_BASE+0x1353C)
#define REG_FRC_BK135_3D        (REG_FRC_BANK_BASE+0x1353D)
#define REG_FRC_BK135_3E        (REG_FRC_BANK_BASE+0x1353E)
#define REG_FRC_BK135_3F        (REG_FRC_BANK_BASE+0x1353F)
#define REG_FRC_BK135_40        (REG_FRC_BANK_BASE+0x13540)
#define REG_FRC_BK135_41        (REG_FRC_BANK_BASE+0x13541)
#define REG_FRC_BK135_42        (REG_FRC_BANK_BASE+0x13542)
#define REG_FRC_BK135_43        (REG_FRC_BANK_BASE+0x13543)
#define REG_FRC_BK135_44        (REG_FRC_BANK_BASE+0x13544)
#define REG_FRC_BK135_45        (REG_FRC_BANK_BASE+0x13545)
#define REG_FRC_BK135_46        (REG_FRC_BANK_BASE+0x13546)
#define REG_FRC_BK135_47        (REG_FRC_BANK_BASE+0x13547)
#define REG_FRC_BK135_48        (REG_FRC_BANK_BASE+0x13548)
#define REG_FRC_BK135_49        (REG_FRC_BANK_BASE+0x13549)
#define REG_FRC_BK135_4A        (REG_FRC_BANK_BASE+0x1354A)
#define REG_FRC_BK135_4B        (REG_FRC_BANK_BASE+0x1354B)
#define REG_FRC_BK135_4C        (REG_FRC_BANK_BASE+0x1354C)
#define REG_FRC_BK135_4D        (REG_FRC_BANK_BASE+0x1354D)
#define REG_FRC_BK135_4E        (REG_FRC_BANK_BASE+0x1354E)
#define REG_FRC_BK135_4F        (REG_FRC_BANK_BASE+0x1354F)
#define REG_FRC_BK135_50        (REG_FRC_BANK_BASE+0x13550)
#define REG_FRC_BK135_51        (REG_FRC_BANK_BASE+0x13551)
#define REG_FRC_BK135_52        (REG_FRC_BANK_BASE+0x13552)
#define REG_FRC_BK135_53        (REG_FRC_BANK_BASE+0x13553)
#define REG_FRC_BK135_54        (REG_FRC_BANK_BASE+0x13554)
#define REG_FRC_BK135_55        (REG_FRC_BANK_BASE+0x13555)
#define REG_FRC_BK135_56        (REG_FRC_BANK_BASE+0x13556)
#define REG_FRC_BK135_57        (REG_FRC_BANK_BASE+0x13557)
#define REG_FRC_BK135_58        (REG_FRC_BANK_BASE+0x13558)
#define REG_FRC_BK135_59        (REG_FRC_BANK_BASE+0x13559)
#define REG_FRC_BK135_5A        (REG_FRC_BANK_BASE+0x1355A)
#define REG_FRC_BK135_5B        (REG_FRC_BANK_BASE+0x1355B)
#define REG_FRC_BK135_5C        (REG_FRC_BANK_BASE+0x1355C)
#define REG_FRC_BK135_5D        (REG_FRC_BANK_BASE+0x1355D)
#define REG_FRC_BK135_5E        (REG_FRC_BANK_BASE+0x1355E)
#define REG_FRC_BK135_5F        (REG_FRC_BANK_BASE+0x1355F)
#define REG_FRC_BK135_60        (REG_FRC_BANK_BASE+0x13560)
#define REG_FRC_BK135_61        (REG_FRC_BANK_BASE+0x13561)
#define REG_FRC_BK135_62        (REG_FRC_BANK_BASE+0x13562)
#define REG_FRC_BK135_63        (REG_FRC_BANK_BASE+0x13563)
#define REG_FRC_BK135_64        (REG_FRC_BANK_BASE+0x13564)
#define REG_FRC_BK135_65        (REG_FRC_BANK_BASE+0x13565)
#define REG_FRC_BK135_66        (REG_FRC_BANK_BASE+0x13566)
#define REG_FRC_BK135_67        (REG_FRC_BANK_BASE+0x13567)
#define REG_FRC_BK135_68        (REG_FRC_BANK_BASE+0x13568)
#define REG_FRC_BK135_69        (REG_FRC_BANK_BASE+0x13569)
#define REG_FRC_BK135_6A        (REG_FRC_BANK_BASE+0x1356A)
#define REG_FRC_BK135_6B        (REG_FRC_BANK_BASE+0x1356B)
#define REG_FRC_BK135_6C        (REG_FRC_BANK_BASE+0x1356C)
#define REG_FRC_BK135_6D        (REG_FRC_BANK_BASE+0x1356D)
#define REG_FRC_BK135_6E        (REG_FRC_BANK_BASE+0x1356E)
#define REG_FRC_BK135_6F        (REG_FRC_BANK_BASE+0x1356F)
#define REG_FRC_BK135_70        (REG_FRC_BANK_BASE+0x13570)
#define REG_FRC_BK135_71        (REG_FRC_BANK_BASE+0x13571)
#define REG_FRC_BK135_72        (REG_FRC_BANK_BASE+0x13572)
#define REG_FRC_BK135_73        (REG_FRC_BANK_BASE+0x13573)
#define REG_FRC_BK135_74        (REG_FRC_BANK_BASE+0x13574)
#define REG_FRC_BK135_75        (REG_FRC_BANK_BASE+0x13575)
#define REG_FRC_BK135_76        (REG_FRC_BANK_BASE+0x13576)
#define REG_FRC_BK135_77        (REG_FRC_BANK_BASE+0x13577)
#define REG_FRC_BK135_78        (REG_FRC_BANK_BASE+0x13578)
#define REG_FRC_BK135_79        (REG_FRC_BANK_BASE+0x13579)
#define REG_FRC_BK135_7A        (REG_FRC_BANK_BASE+0x1357A)
#define REG_FRC_BK135_7B        (REG_FRC_BANK_BASE+0x1357B)
#define REG_FRC_BK135_7C        (REG_FRC_BANK_BASE+0x1357C)
#define REG_FRC_BK135_7D        (REG_FRC_BANK_BASE+0x1357D)
#define REG_FRC_BK135_7E        (REG_FRC_BANK_BASE+0x1357E)
#define REG_FRC_BK135_7F        (REG_FRC_BANK_BASE+0x1357F)
#define REG_FRC_BK135_80        (REG_FRC_BANK_BASE+0x13580)
#define REG_FRC_BK135_81        (REG_FRC_BANK_BASE+0x13581)
#define REG_FRC_BK135_82        (REG_FRC_BANK_BASE+0x13582)
#define REG_FRC_BK135_83        (REG_FRC_BANK_BASE+0x13583)
#define REG_FRC_BK135_84        (REG_FRC_BANK_BASE+0x13584)
#define REG_FRC_BK135_85        (REG_FRC_BANK_BASE+0x13585)
#define REG_FRC_BK135_86        (REG_FRC_BANK_BASE+0x13586)
#define REG_FRC_BK135_87        (REG_FRC_BANK_BASE+0x13587)
#define REG_FRC_BK135_88        (REG_FRC_BANK_BASE+0x13588)
#define REG_FRC_BK135_89        (REG_FRC_BANK_BASE+0x13589)
#define REG_FRC_BK135_8A        (REG_FRC_BANK_BASE+0x1358A)
#define REG_FRC_BK135_8B        (REG_FRC_BANK_BASE+0x1358B)
#define REG_FRC_BK135_8C        (REG_FRC_BANK_BASE+0x1358C)
#define REG_FRC_BK135_8D        (REG_FRC_BANK_BASE+0x1358D)
#define REG_FRC_BK135_8E        (REG_FRC_BANK_BASE+0x1358E)
#define REG_FRC_BK135_8F        (REG_FRC_BANK_BASE+0x1358F)
#define REG_FRC_BK135_90        (REG_FRC_BANK_BASE+0x13590)
#define REG_FRC_BK135_91        (REG_FRC_BANK_BASE+0x13591)
#define REG_FRC_BK135_92        (REG_FRC_BANK_BASE+0x13592)
#define REG_FRC_BK135_93        (REG_FRC_BANK_BASE+0x13593)
#define REG_FRC_BK135_94        (REG_FRC_BANK_BASE+0x13594)
#define REG_FRC_BK135_95        (REG_FRC_BANK_BASE+0x13595)
#define REG_FRC_BK135_96        (REG_FRC_BANK_BASE+0x13596)
#define REG_FRC_BK135_97        (REG_FRC_BANK_BASE+0x13597)
#define REG_FRC_BK135_98        (REG_FRC_BANK_BASE+0x13598)
#define REG_FRC_BK135_99        (REG_FRC_BANK_BASE+0x13599)
#define REG_FRC_BK135_9A        (REG_FRC_BANK_BASE+0x1359A)
#define REG_FRC_BK135_9B        (REG_FRC_BANK_BASE+0x1359B)
#define REG_FRC_BK135_9C        (REG_FRC_BANK_BASE+0x1359C)
#define REG_FRC_BK135_9D        (REG_FRC_BANK_BASE+0x1359D)
#define REG_FRC_BK135_9E        (REG_FRC_BANK_BASE+0x1359E)
#define REG_FRC_BK135_9F        (REG_FRC_BANK_BASE+0x1359F)
#define REG_FRC_BK135_A0        (REG_FRC_BANK_BASE+0x135A0)
#define REG_FRC_BK135_A1        (REG_FRC_BANK_BASE+0x135A1)
#define REG_FRC_BK135_A2        (REG_FRC_BANK_BASE+0x135A2)
#define REG_FRC_BK135_A3        (REG_FRC_BANK_BASE+0x135A3)
#define REG_FRC_BK135_A4        (REG_FRC_BANK_BASE+0x135A4)
#define REG_FRC_BK135_A5        (REG_FRC_BANK_BASE+0x135A5)
#define REG_FRC_BK135_A6        (REG_FRC_BANK_BASE+0x135A6)
#define REG_FRC_BK135_A7        (REG_FRC_BANK_BASE+0x135A7)
#define REG_FRC_BK135_A8        (REG_FRC_BANK_BASE+0x135A8)
#define REG_FRC_BK135_A9        (REG_FRC_BANK_BASE+0x135A9)
#define REG_FRC_BK135_AA        (REG_FRC_BANK_BASE+0x135AA)
#define REG_FRC_BK135_AB        (REG_FRC_BANK_BASE+0x135AB)
#define REG_FRC_BK135_AC        (REG_FRC_BANK_BASE+0x135AC)
#define REG_FRC_BK135_AD        (REG_FRC_BANK_BASE+0x135AD)
#define REG_FRC_BK135_AE        (REG_FRC_BANK_BASE+0x135AE)
#define REG_FRC_BK135_AF        (REG_FRC_BANK_BASE+0x135AF)
#define REG_FRC_BK135_B0        (REG_FRC_BANK_BASE+0x135B0)
#define REG_FRC_BK135_B1        (REG_FRC_BANK_BASE+0x135B1)
#define REG_FRC_BK135_B2        (REG_FRC_BANK_BASE+0x135B2)
#define REG_FRC_BK135_B3        (REG_FRC_BANK_BASE+0x135B3)
#define REG_FRC_BK135_B4        (REG_FRC_BANK_BASE+0x135B4)
#define REG_FRC_BK135_B5        (REG_FRC_BANK_BASE+0x135B5)
#define REG_FRC_BK135_B6        (REG_FRC_BANK_BASE+0x135B6)
#define REG_FRC_BK135_B7        (REG_FRC_BANK_BASE+0x135B7)
#define REG_FRC_BK135_B8        (REG_FRC_BANK_BASE+0x135B8)
#define REG_FRC_BK135_B9        (REG_FRC_BANK_BASE+0x135B9)
#define REG_FRC_BK135_BA        (REG_FRC_BANK_BASE+0x135BA)
#define REG_FRC_BK135_BB        (REG_FRC_BANK_BASE+0x135BB)
#define REG_FRC_BK135_BC        (REG_FRC_BANK_BASE+0x135BC)
#define REG_FRC_BK135_BD        (REG_FRC_BANK_BASE+0x135BD)
#define REG_FRC_BK135_BE        (REG_FRC_BANK_BASE+0x135BE)
#define REG_FRC_BK135_BF        (REG_FRC_BANK_BASE+0x135BF)
#define REG_FRC_BK135_C0        (REG_FRC_BANK_BASE+0x135C0)
#define REG_FRC_BK135_C1        (REG_FRC_BANK_BASE+0x135C1)
#define REG_FRC_BK135_C2        (REG_FRC_BANK_BASE+0x135C2)
#define REG_FRC_BK135_C3        (REG_FRC_BANK_BASE+0x135C3)
#define REG_FRC_BK135_C4        (REG_FRC_BANK_BASE+0x135C4)
#define REG_FRC_BK135_C5        (REG_FRC_BANK_BASE+0x135C5)
#define REG_FRC_BK135_C6        (REG_FRC_BANK_BASE+0x135C6)
#define REG_FRC_BK135_C7        (REG_FRC_BANK_BASE+0x135C7)
#define REG_FRC_BK135_C8        (REG_FRC_BANK_BASE+0x135C8)
#define REG_FRC_BK135_C9        (REG_FRC_BANK_BASE+0x135C9)
#define REG_FRC_BK135_CA        (REG_FRC_BANK_BASE+0x135CA)
#define REG_FRC_BK135_CB        (REG_FRC_BANK_BASE+0x135CB)
#define REG_FRC_BK135_CC        (REG_FRC_BANK_BASE+0x135CC)
#define REG_FRC_BK135_CD        (REG_FRC_BANK_BASE+0x135CD)
#define REG_FRC_BK135_CE        (REG_FRC_BANK_BASE+0x135CE)
#define REG_FRC_BK135_CF        (REG_FRC_BANK_BASE+0x135CF)
#define REG_FRC_BK135_D0        (REG_FRC_BANK_BASE+0x135D0)
#define REG_FRC_BK135_D1        (REG_FRC_BANK_BASE+0x135D1)
#define REG_FRC_BK135_D2        (REG_FRC_BANK_BASE+0x135D2)
#define REG_FRC_BK135_D3        (REG_FRC_BANK_BASE+0x135D3)
#define REG_FRC_BK135_D4        (REG_FRC_BANK_BASE+0x135D4)
#define REG_FRC_BK135_D5        (REG_FRC_BANK_BASE+0x135D5)
#define REG_FRC_BK135_D6        (REG_FRC_BANK_BASE+0x135D6)
#define REG_FRC_BK135_D7        (REG_FRC_BANK_BASE+0x135D7)
#define REG_FRC_BK135_D8        (REG_FRC_BANK_BASE+0x135D8)
#define REG_FRC_BK135_D9        (REG_FRC_BANK_BASE+0x135D9)
#define REG_FRC_BK135_DA        (REG_FRC_BANK_BASE+0x135DA)
#define REG_FRC_BK135_DB        (REG_FRC_BANK_BASE+0x135DB)
#define REG_FRC_BK135_DC        (REG_FRC_BANK_BASE+0x135DC)
#define REG_FRC_BK135_DD        (REG_FRC_BANK_BASE+0x135DD)
#define REG_FRC_BK135_DE        (REG_FRC_BANK_BASE+0x135DE)
#define REG_FRC_BK135_DF        (REG_FRC_BANK_BASE+0x135DF)
#define REG_FRC_BK135_E0        (REG_FRC_BANK_BASE+0x135E0)
#define REG_FRC_BK135_E1        (REG_FRC_BANK_BASE+0x135E1)
#define REG_FRC_BK135_E2        (REG_FRC_BANK_BASE+0x135E2)
#define REG_FRC_BK135_E3        (REG_FRC_BANK_BASE+0x135E3)
#define REG_FRC_BK135_E4        (REG_FRC_BANK_BASE+0x135E4)
#define REG_FRC_BK135_E5        (REG_FRC_BANK_BASE+0x135E5)
#define REG_FRC_BK135_E6        (REG_FRC_BANK_BASE+0x135E6)
#define REG_FRC_BK135_E7        (REG_FRC_BANK_BASE+0x135E7)
#define REG_FRC_BK135_E8        (REG_FRC_BANK_BASE+0x135E8)
#define REG_FRC_BK135_E9        (REG_FRC_BANK_BASE+0x135E9)
#define REG_FRC_BK135_EA        (REG_FRC_BANK_BASE+0x135EA)
#define REG_FRC_BK135_EB        (REG_FRC_BANK_BASE+0x135EB)
#define REG_FRC_BK135_EC        (REG_FRC_BANK_BASE+0x135EC)
#define REG_FRC_BK135_ED        (REG_FRC_BANK_BASE+0x135ED)
#define REG_FRC_BK135_EE        (REG_FRC_BANK_BASE+0x135EE)
#define REG_FRC_BK135_EF        (REG_FRC_BANK_BASE+0x135EF)
#define REG_FRC_BK135_F0        (REG_FRC_BANK_BASE+0x135F0)
#define REG_FRC_BK135_F1        (REG_FRC_BANK_BASE+0x135F1)
#define REG_FRC_BK135_F2        (REG_FRC_BANK_BASE+0x135F2)
#define REG_FRC_BK135_F3        (REG_FRC_BANK_BASE+0x135F3)
#define REG_FRC_BK135_F4        (REG_FRC_BANK_BASE+0x135F4)
#define REG_FRC_BK135_F5        (REG_FRC_BANK_BASE+0x135F5)
#define REG_FRC_BK135_F6        (REG_FRC_BANK_BASE+0x135F6)
#define REG_FRC_BK135_F7        (REG_FRC_BANK_BASE+0x135F7)
#define REG_FRC_BK135_F8        (REG_FRC_BANK_BASE+0x135F8)
#define REG_FRC_BK135_F9        (REG_FRC_BANK_BASE+0x135F9)
#define REG_FRC_BK135_FA        (REG_FRC_BANK_BASE+0x135FA)
#define REG_FRC_BK135_FB        (REG_FRC_BANK_BASE+0x135FB)
#define REG_FRC_BK135_FC        (REG_FRC_BANK_BASE+0x135FC)
#define REG_FRC_BK135_FD        (REG_FRC_BANK_BASE+0x135FD)
#define REG_FRC_BK135_FE        (REG_FRC_BANK_BASE+0x135FE)
#define REG_FRC_BK135_FF        (REG_FRC_BANK_BASE+0x135FF)

// === FRC bk136
#define REG_FRC_BK136_00        (REG_FRC_BANK_BASE+0x13600)
#define REG_FRC_BK136_01        (REG_FRC_BANK_BASE+0x13601)
#define REG_FRC_BK136_02        (REG_FRC_BANK_BASE+0x13602)
#define REG_FRC_BK136_03        (REG_FRC_BANK_BASE+0x13603)
#define REG_FRC_BK136_04        (REG_FRC_BANK_BASE+0x13604)
#define REG_FRC_BK136_05        (REG_FRC_BANK_BASE+0x13605)
#define REG_FRC_BK136_06        (REG_FRC_BANK_BASE+0x13606)
#define REG_FRC_BK136_07        (REG_FRC_BANK_BASE+0x13607)
#define REG_FRC_BK136_08        (REG_FRC_BANK_BASE+0x13608)
#define REG_FRC_BK136_09        (REG_FRC_BANK_BASE+0x13609)
#define REG_FRC_BK136_0A        (REG_FRC_BANK_BASE+0x1360A)
#define REG_FRC_BK136_0B        (REG_FRC_BANK_BASE+0x1360B)
#define REG_FRC_BK136_0C        (REG_FRC_BANK_BASE+0x1360C)
#define REG_FRC_BK136_0D        (REG_FRC_BANK_BASE+0x1360D)
#define REG_FRC_BK136_0E        (REG_FRC_BANK_BASE+0x1360E)
#define REG_FRC_BK136_0F        (REG_FRC_BANK_BASE+0x1360F)
#define REG_FRC_BK136_10        (REG_FRC_BANK_BASE+0x13610)
#define REG_FRC_BK136_11        (REG_FRC_BANK_BASE+0x13611)
#define REG_FRC_BK136_12        (REG_FRC_BANK_BASE+0x13612)
#define REG_FRC_BK136_13        (REG_FRC_BANK_BASE+0x13613)
#define REG_FRC_BK136_14        (REG_FRC_BANK_BASE+0x13614)
#define REG_FRC_BK136_15        (REG_FRC_BANK_BASE+0x13615)
#define REG_FRC_BK136_16        (REG_FRC_BANK_BASE+0x13616)
#define REG_FRC_BK136_17        (REG_FRC_BANK_BASE+0x13617)
#define REG_FRC_BK136_18        (REG_FRC_BANK_BASE+0x13618)
#define REG_FRC_BK136_19        (REG_FRC_BANK_BASE+0x13619)
#define REG_FRC_BK136_1A        (REG_FRC_BANK_BASE+0x1361A)
#define REG_FRC_BK136_1B        (REG_FRC_BANK_BASE+0x1361B)
#define REG_FRC_BK136_1C        (REG_FRC_BANK_BASE+0x1361C)
#define REG_FRC_BK136_1D        (REG_FRC_BANK_BASE+0x1361D)
#define REG_FRC_BK136_1E        (REG_FRC_BANK_BASE+0x1361E)
#define REG_FRC_BK136_1F        (REG_FRC_BANK_BASE+0x1361F)
#define REG_FRC_BK136_20        (REG_FRC_BANK_BASE+0x13620)
#define REG_FRC_BK136_21        (REG_FRC_BANK_BASE+0x13621)
#define REG_FRC_BK136_22        (REG_FRC_BANK_BASE+0x13622)
#define REG_FRC_BK136_23        (REG_FRC_BANK_BASE+0x13623)
#define REG_FRC_BK136_24        (REG_FRC_BANK_BASE+0x13624)
#define REG_FRC_BK136_25        (REG_FRC_BANK_BASE+0x13625)
#define REG_FRC_BK136_26        (REG_FRC_BANK_BASE+0x13626)
#define REG_FRC_BK136_27        (REG_FRC_BANK_BASE+0x13627)
#define REG_FRC_BK136_28        (REG_FRC_BANK_BASE+0x13628)
#define REG_FRC_BK136_29        (REG_FRC_BANK_BASE+0x13629)
#define REG_FRC_BK136_2A        (REG_FRC_BANK_BASE+0x1362A)
#define REG_FRC_BK136_2B        (REG_FRC_BANK_BASE+0x1362B)
#define REG_FRC_BK136_2C        (REG_FRC_BANK_BASE+0x1362C)
#define REG_FRC_BK136_2D        (REG_FRC_BANK_BASE+0x1362D)
#define REG_FRC_BK136_2E        (REG_FRC_BANK_BASE+0x1362E)
#define REG_FRC_BK136_2F        (REG_FRC_BANK_BASE+0x1362F)
#define REG_FRC_BK136_30        (REG_FRC_BANK_BASE+0x13630)
#define REG_FRC_BK136_31        (REG_FRC_BANK_BASE+0x13631)
#define REG_FRC_BK136_32        (REG_FRC_BANK_BASE+0x13632)
#define REG_FRC_BK136_33        (REG_FRC_BANK_BASE+0x13633)
#define REG_FRC_BK136_34        (REG_FRC_BANK_BASE+0x13634)
#define REG_FRC_BK136_35        (REG_FRC_BANK_BASE+0x13635)
#define REG_FRC_BK136_36        (REG_FRC_BANK_BASE+0x13636)
#define REG_FRC_BK136_37        (REG_FRC_BANK_BASE+0x13637)
#define REG_FRC_BK136_38        (REG_FRC_BANK_BASE+0x13638)
#define REG_FRC_BK136_39        (REG_FRC_BANK_BASE+0x13639)
#define REG_FRC_BK136_3A        (REG_FRC_BANK_BASE+0x1363A)
#define REG_FRC_BK136_3B        (REG_FRC_BANK_BASE+0x1363B)
#define REG_FRC_BK136_3C        (REG_FRC_BANK_BASE+0x1363C)
#define REG_FRC_BK136_3D        (REG_FRC_BANK_BASE+0x1363D)
#define REG_FRC_BK136_3E        (REG_FRC_BANK_BASE+0x1363E)
#define REG_FRC_BK136_3F        (REG_FRC_BANK_BASE+0x1363F)
#define REG_FRC_BK136_40        (REG_FRC_BANK_BASE+0x13640)
#define REG_FRC_BK136_41        (REG_FRC_BANK_BASE+0x13641)
#define REG_FRC_BK136_42        (REG_FRC_BANK_BASE+0x13642)
#define REG_FRC_BK136_43        (REG_FRC_BANK_BASE+0x13643)
#define REG_FRC_BK136_44        (REG_FRC_BANK_BASE+0x13644)
#define REG_FRC_BK136_45        (REG_FRC_BANK_BASE+0x13645)
#define REG_FRC_BK136_46        (REG_FRC_BANK_BASE+0x13646)
#define REG_FRC_BK136_47        (REG_FRC_BANK_BASE+0x13647)
#define REG_FRC_BK136_48        (REG_FRC_BANK_BASE+0x13648)
#define REG_FRC_BK136_49        (REG_FRC_BANK_BASE+0x13649)
#define REG_FRC_BK136_4A        (REG_FRC_BANK_BASE+0x1364A)
#define REG_FRC_BK136_4B        (REG_FRC_BANK_BASE+0x1364B)
#define REG_FRC_BK136_4C        (REG_FRC_BANK_BASE+0x1364C)
#define REG_FRC_BK136_4D        (REG_FRC_BANK_BASE+0x1364D)
#define REG_FRC_BK136_4E        (REG_FRC_BANK_BASE+0x1364E)
#define REG_FRC_BK136_4F        (REG_FRC_BANK_BASE+0x1364F)
#define REG_FRC_BK136_50        (REG_FRC_BANK_BASE+0x13650)
#define REG_FRC_BK136_51        (REG_FRC_BANK_BASE+0x13651)
#define REG_FRC_BK136_52        (REG_FRC_BANK_BASE+0x13652)
#define REG_FRC_BK136_53        (REG_FRC_BANK_BASE+0x13653)
#define REG_FRC_BK136_54        (REG_FRC_BANK_BASE+0x13654)
#define REG_FRC_BK136_55        (REG_FRC_BANK_BASE+0x13655)
#define REG_FRC_BK136_56        (REG_FRC_BANK_BASE+0x13656)
#define REG_FRC_BK136_57        (REG_FRC_BANK_BASE+0x13657)
#define REG_FRC_BK136_58        (REG_FRC_BANK_BASE+0x13658)
#define REG_FRC_BK136_59        (REG_FRC_BANK_BASE+0x13659)
#define REG_FRC_BK136_5A        (REG_FRC_BANK_BASE+0x1365A)
#define REG_FRC_BK136_5B        (REG_FRC_BANK_BASE+0x1365B)
#define REG_FRC_BK136_5C        (REG_FRC_BANK_BASE+0x1365C)
#define REG_FRC_BK136_5D        (REG_FRC_BANK_BASE+0x1365D)
#define REG_FRC_BK136_5E        (REG_FRC_BANK_BASE+0x1365E)
#define REG_FRC_BK136_5F        (REG_FRC_BANK_BASE+0x1365F)
#define REG_FRC_BK136_60        (REG_FRC_BANK_BASE+0x13660)
#define REG_FRC_BK136_61        (REG_FRC_BANK_BASE+0x13661)
#define REG_FRC_BK136_62        (REG_FRC_BANK_BASE+0x13662)
#define REG_FRC_BK136_63        (REG_FRC_BANK_BASE+0x13663)
#define REG_FRC_BK136_64        (REG_FRC_BANK_BASE+0x13664)
#define REG_FRC_BK136_65        (REG_FRC_BANK_BASE+0x13665)
#define REG_FRC_BK136_66        (REG_FRC_BANK_BASE+0x13666)
#define REG_FRC_BK136_67        (REG_FRC_BANK_BASE+0x13667)
#define REG_FRC_BK136_68        (REG_FRC_BANK_BASE+0x13668)
#define REG_FRC_BK136_69        (REG_FRC_BANK_BASE+0x13669)
#define REG_FRC_BK136_6A        (REG_FRC_BANK_BASE+0x1366A)
#define REG_FRC_BK136_6B        (REG_FRC_BANK_BASE+0x1366B)
#define REG_FRC_BK136_6C        (REG_FRC_BANK_BASE+0x1366C)
#define REG_FRC_BK136_6D        (REG_FRC_BANK_BASE+0x1366D)
#define REG_FRC_BK136_6E        (REG_FRC_BANK_BASE+0x1366E)
#define REG_FRC_BK136_6F        (REG_FRC_BANK_BASE+0x1366F)
#define REG_FRC_BK136_70        (REG_FRC_BANK_BASE+0x13670)
#define REG_FRC_BK136_71        (REG_FRC_BANK_BASE+0x13671)
#define REG_FRC_BK136_72        (REG_FRC_BANK_BASE+0x13672)
#define REG_FRC_BK136_73        (REG_FRC_BANK_BASE+0x13673)
#define REG_FRC_BK136_74        (REG_FRC_BANK_BASE+0x13674)
#define REG_FRC_BK136_75        (REG_FRC_BANK_BASE+0x13675)
#define REG_FRC_BK136_76        (REG_FRC_BANK_BASE+0x13676)
#define REG_FRC_BK136_77        (REG_FRC_BANK_BASE+0x13677)
#define REG_FRC_BK136_78        (REG_FRC_BANK_BASE+0x13678)
#define REG_FRC_BK136_79        (REG_FRC_BANK_BASE+0x13679)
#define REG_FRC_BK136_7A        (REG_FRC_BANK_BASE+0x1367A)
#define REG_FRC_BK136_7B        (REG_FRC_BANK_BASE+0x1367B)
#define REG_FRC_BK136_7C        (REG_FRC_BANK_BASE+0x1367C)
#define REG_FRC_BK136_7D        (REG_FRC_BANK_BASE+0x1367D)
#define REG_FRC_BK136_7E        (REG_FRC_BANK_BASE+0x1367E)
#define REG_FRC_BK136_7F        (REG_FRC_BANK_BASE+0x1367F)
#define REG_FRC_BK136_80        (REG_FRC_BANK_BASE+0x13680)
#define REG_FRC_BK136_81        (REG_FRC_BANK_BASE+0x13681)
#define REG_FRC_BK136_82        (REG_FRC_BANK_BASE+0x13682)
#define REG_FRC_BK136_83        (REG_FRC_BANK_BASE+0x13683)
#define REG_FRC_BK136_84        (REG_FRC_BANK_BASE+0x13684)
#define REG_FRC_BK136_85        (REG_FRC_BANK_BASE+0x13685)
#define REG_FRC_BK136_86        (REG_FRC_BANK_BASE+0x13686)
#define REG_FRC_BK136_87        (REG_FRC_BANK_BASE+0x13687)
#define REG_FRC_BK136_88        (REG_FRC_BANK_BASE+0x13688)
#define REG_FRC_BK136_89        (REG_FRC_BANK_BASE+0x13689)
#define REG_FRC_BK136_8A        (REG_FRC_BANK_BASE+0x1368A)
#define REG_FRC_BK136_8B        (REG_FRC_BANK_BASE+0x1368B)
#define REG_FRC_BK136_8C        (REG_FRC_BANK_BASE+0x1368C)
#define REG_FRC_BK136_8D        (REG_FRC_BANK_BASE+0x1368D)
#define REG_FRC_BK136_8E        (REG_FRC_BANK_BASE+0x1368E)
#define REG_FRC_BK136_8F        (REG_FRC_BANK_BASE+0x1368F)
#define REG_FRC_BK136_90        (REG_FRC_BANK_BASE+0x13690)
#define REG_FRC_BK136_91        (REG_FRC_BANK_BASE+0x13691)
#define REG_FRC_BK136_92        (REG_FRC_BANK_BASE+0x13692)
#define REG_FRC_BK136_93        (REG_FRC_BANK_BASE+0x13693)
#define REG_FRC_BK136_94        (REG_FRC_BANK_BASE+0x13694)
#define REG_FRC_BK136_95        (REG_FRC_BANK_BASE+0x13695)
#define REG_FRC_BK136_96        (REG_FRC_BANK_BASE+0x13696)
#define REG_FRC_BK136_97        (REG_FRC_BANK_BASE+0x13697)
#define REG_FRC_BK136_98        (REG_FRC_BANK_BASE+0x13698)
#define REG_FRC_BK136_99        (REG_FRC_BANK_BASE+0x13699)
#define REG_FRC_BK136_9A        (REG_FRC_BANK_BASE+0x1369A)
#define REG_FRC_BK136_9B        (REG_FRC_BANK_BASE+0x1369B)
#define REG_FRC_BK136_9C        (REG_FRC_BANK_BASE+0x1369C)
#define REG_FRC_BK136_9D        (REG_FRC_BANK_BASE+0x1369D)
#define REG_FRC_BK136_9E        (REG_FRC_BANK_BASE+0x1369E)
#define REG_FRC_BK136_9F        (REG_FRC_BANK_BASE+0x1369F)
#define REG_FRC_BK136_A0        (REG_FRC_BANK_BASE+0x136A0)
#define REG_FRC_BK136_A1        (REG_FRC_BANK_BASE+0x136A1)
#define REG_FRC_BK136_A2        (REG_FRC_BANK_BASE+0x136A2)
#define REG_FRC_BK136_A3        (REG_FRC_BANK_BASE+0x136A3)
#define REG_FRC_BK136_A4        (REG_FRC_BANK_BASE+0x136A4)
#define REG_FRC_BK136_A5        (REG_FRC_BANK_BASE+0x136A5)
#define REG_FRC_BK136_A6        (REG_FRC_BANK_BASE+0x136A6)
#define REG_FRC_BK136_A7        (REG_FRC_BANK_BASE+0x136A7)
#define REG_FRC_BK136_A8        (REG_FRC_BANK_BASE+0x136A8)
#define REG_FRC_BK136_A9        (REG_FRC_BANK_BASE+0x136A9)
#define REG_FRC_BK136_AA        (REG_FRC_BANK_BASE+0x136AA)
#define REG_FRC_BK136_AB        (REG_FRC_BANK_BASE+0x136AB)
#define REG_FRC_BK136_AC        (REG_FRC_BANK_BASE+0x136AC)
#define REG_FRC_BK136_AD        (REG_FRC_BANK_BASE+0x136AD)
#define REG_FRC_BK136_AE        (REG_FRC_BANK_BASE+0x136AE)
#define REG_FRC_BK136_AF        (REG_FRC_BANK_BASE+0x136AF)
#define REG_FRC_BK136_B0        (REG_FRC_BANK_BASE+0x136B0)
#define REG_FRC_BK136_B1        (REG_FRC_BANK_BASE+0x136B1)
#define REG_FRC_BK136_B2        (REG_FRC_BANK_BASE+0x136B2)
#define REG_FRC_BK136_B3        (REG_FRC_BANK_BASE+0x136B3)
#define REG_FRC_BK136_B4        (REG_FRC_BANK_BASE+0x136B4)
#define REG_FRC_BK136_B5        (REG_FRC_BANK_BASE+0x136B5)
#define REG_FRC_BK136_B6        (REG_FRC_BANK_BASE+0x136B6)
#define REG_FRC_BK136_B7        (REG_FRC_BANK_BASE+0x136B7)
#define REG_FRC_BK136_B8        (REG_FRC_BANK_BASE+0x136B8)
#define REG_FRC_BK136_B9        (REG_FRC_BANK_BASE+0x136B9)
#define REG_FRC_BK136_BA        (REG_FRC_BANK_BASE+0x136BA)
#define REG_FRC_BK136_BB        (REG_FRC_BANK_BASE+0x136BB)
#define REG_FRC_BK136_BC        (REG_FRC_BANK_BASE+0x136BC)
#define REG_FRC_BK136_BD        (REG_FRC_BANK_BASE+0x136BD)
#define REG_FRC_BK136_BE        (REG_FRC_BANK_BASE+0x136BE)
#define REG_FRC_BK136_BF        (REG_FRC_BANK_BASE+0x136BF)
#define REG_FRC_BK136_C0        (REG_FRC_BANK_BASE+0x136C0)
#define REG_FRC_BK136_C1        (REG_FRC_BANK_BASE+0x136C1)
#define REG_FRC_BK136_C2        (REG_FRC_BANK_BASE+0x136C2)
#define REG_FRC_BK136_C3        (REG_FRC_BANK_BASE+0x136C3)
#define REG_FRC_BK136_C4        (REG_FRC_BANK_BASE+0x136C4)
#define REG_FRC_BK136_C5        (REG_FRC_BANK_BASE+0x136C5)
#define REG_FRC_BK136_C6        (REG_FRC_BANK_BASE+0x136C6)
#define REG_FRC_BK136_C7        (REG_FRC_BANK_BASE+0x136C7)
#define REG_FRC_BK136_C8        (REG_FRC_BANK_BASE+0x136C8)
#define REG_FRC_BK136_C9        (REG_FRC_BANK_BASE+0x136C9)
#define REG_FRC_BK136_CA        (REG_FRC_BANK_BASE+0x136CA)
#define REG_FRC_BK136_CB        (REG_FRC_BANK_BASE+0x136CB)
#define REG_FRC_BK136_CC        (REG_FRC_BANK_BASE+0x136CC)
#define REG_FRC_BK136_CD        (REG_FRC_BANK_BASE+0x136CD)
#define REG_FRC_BK136_CE        (REG_FRC_BANK_BASE+0x136CE)
#define REG_FRC_BK136_CF        (REG_FRC_BANK_BASE+0x136CF)
#define REG_FRC_BK136_D0        (REG_FRC_BANK_BASE+0x136D0)
#define REG_FRC_BK136_D1        (REG_FRC_BANK_BASE+0x136D1)
#define REG_FRC_BK136_D2        (REG_FRC_BANK_BASE+0x136D2)
#define REG_FRC_BK136_D3        (REG_FRC_BANK_BASE+0x136D3)
#define REG_FRC_BK136_D4        (REG_FRC_BANK_BASE+0x136D4)
#define REG_FRC_BK136_D5        (REG_FRC_BANK_BASE+0x136D5)
#define REG_FRC_BK136_D6        (REG_FRC_BANK_BASE+0x136D6)
#define REG_FRC_BK136_D7        (REG_FRC_BANK_BASE+0x136D7)
#define REG_FRC_BK136_D8        (REG_FRC_BANK_BASE+0x136D8)
#define REG_FRC_BK136_D9        (REG_FRC_BANK_BASE+0x136D9)
#define REG_FRC_BK136_DA        (REG_FRC_BANK_BASE+0x136DA)
#define REG_FRC_BK136_DB        (REG_FRC_BANK_BASE+0x136DB)
#define REG_FRC_BK136_DC        (REG_FRC_BANK_BASE+0x136DC)
#define REG_FRC_BK136_DD        (REG_FRC_BANK_BASE+0x136DD)
#define REG_FRC_BK136_DE        (REG_FRC_BANK_BASE+0x136DE)
#define REG_FRC_BK136_DF        (REG_FRC_BANK_BASE+0x136DF)
#define REG_FRC_BK136_E0        (REG_FRC_BANK_BASE+0x136E0)
#define REG_FRC_BK136_E1        (REG_FRC_BANK_BASE+0x136E1)
#define REG_FRC_BK136_E2        (REG_FRC_BANK_BASE+0x136E2)
#define REG_FRC_BK136_E3        (REG_FRC_BANK_BASE+0x136E3)
#define REG_FRC_BK136_E4        (REG_FRC_BANK_BASE+0x136E4)
#define REG_FRC_BK136_E5        (REG_FRC_BANK_BASE+0x136E5)
#define REG_FRC_BK136_E6        (REG_FRC_BANK_BASE+0x136E6)
#define REG_FRC_BK136_E7        (REG_FRC_BANK_BASE+0x136E7)
#define REG_FRC_BK136_E8        (REG_FRC_BANK_BASE+0x136E8)
#define REG_FRC_BK136_E9        (REG_FRC_BANK_BASE+0x136E9)
#define REG_FRC_BK136_EA        (REG_FRC_BANK_BASE+0x136EA)
#define REG_FRC_BK136_EB        (REG_FRC_BANK_BASE+0x136EB)
#define REG_FRC_BK136_EC        (REG_FRC_BANK_BASE+0x136EC)
#define REG_FRC_BK136_ED        (REG_FRC_BANK_BASE+0x136ED)
#define REG_FRC_BK136_EE        (REG_FRC_BANK_BASE+0x136EE)
#define REG_FRC_BK136_EF        (REG_FRC_BANK_BASE+0x136EF)
#define REG_FRC_BK136_F0        (REG_FRC_BANK_BASE+0x136F0)
#define REG_FRC_BK136_F1        (REG_FRC_BANK_BASE+0x136F1)
#define REG_FRC_BK136_F2        (REG_FRC_BANK_BASE+0x136F2)
#define REG_FRC_BK136_F3        (REG_FRC_BANK_BASE+0x136F3)
#define REG_FRC_BK136_F4        (REG_FRC_BANK_BASE+0x136F4)
#define REG_FRC_BK136_F5        (REG_FRC_BANK_BASE+0x136F5)
#define REG_FRC_BK136_F6        (REG_FRC_BANK_BASE+0x136F6)
#define REG_FRC_BK136_F7        (REG_FRC_BANK_BASE+0x136F7)
#define REG_FRC_BK136_F8        (REG_FRC_BANK_BASE+0x136F8)
#define REG_FRC_BK136_F9        (REG_FRC_BANK_BASE+0x136F9)
#define REG_FRC_BK136_FA        (REG_FRC_BANK_BASE+0x136FA)
#define REG_FRC_BK136_FB        (REG_FRC_BANK_BASE+0x136FB)
#define REG_FRC_BK136_FC        (REG_FRC_BANK_BASE+0x136FC)
#define REG_FRC_BK136_FD        (REG_FRC_BANK_BASE+0x136FD)
#define REG_FRC_BK136_FE        (REG_FRC_BANK_BASE+0x136FE)
#define REG_FRC_BK136_FF        (REG_FRC_BANK_BASE+0x136FF)

// === FRC bk13A
#define REG_FRC_BK13A_00        (REG_FRC_BANK_BASE+0x13A00)
#define REG_FRC_BK13A_01        (REG_FRC_BANK_BASE+0x13A01)
#define REG_FRC_BK13A_02        (REG_FRC_BANK_BASE+0x13A02)
#define REG_FRC_BK13A_03        (REG_FRC_BANK_BASE+0x13A03)
#define REG_FRC_BK13A_04        (REG_FRC_BANK_BASE+0x13A04)
#define REG_FRC_BK13A_05        (REG_FRC_BANK_BASE+0x13A05)
#define REG_FRC_BK13A_06        (REG_FRC_BANK_BASE+0x13A06)
#define REG_FRC_BK13A_07        (REG_FRC_BANK_BASE+0x13A07)
#define REG_FRC_BK13A_08        (REG_FRC_BANK_BASE+0x13A08)
#define REG_FRC_BK13A_09        (REG_FRC_BANK_BASE+0x13A09)
#define REG_FRC_BK13A_0A        (REG_FRC_BANK_BASE+0x13A0A)
#define REG_FRC_BK13A_0B        (REG_FRC_BANK_BASE+0x13A0B)
#define REG_FRC_BK13A_0C        (REG_FRC_BANK_BASE+0x13A0C)
#define REG_FRC_BK13A_0D        (REG_FRC_BANK_BASE+0x13A0D)
#define REG_FRC_BK13A_0E        (REG_FRC_BANK_BASE+0x13A0E)
#define REG_FRC_BK13A_0F        (REG_FRC_BANK_BASE+0x13A0F)
#define REG_FRC_BK13A_10        (REG_FRC_BANK_BASE+0x13A10)
#define REG_FRC_BK13A_11        (REG_FRC_BANK_BASE+0x13A11)
#define REG_FRC_BK13A_12        (REG_FRC_BANK_BASE+0x13A12)
#define REG_FRC_BK13A_13        (REG_FRC_BANK_BASE+0x13A13)
#define REG_FRC_BK13A_14        (REG_FRC_BANK_BASE+0x13A14)
#define REG_FRC_BK13A_15        (REG_FRC_BANK_BASE+0x13A15)
#define REG_FRC_BK13A_16        (REG_FRC_BANK_BASE+0x13A16)
#define REG_FRC_BK13A_17        (REG_FRC_BANK_BASE+0x13A17)
#define REG_FRC_BK13A_18        (REG_FRC_BANK_BASE+0x13A18)
#define REG_FRC_BK13A_19        (REG_FRC_BANK_BASE+0x13A19)
#define REG_FRC_BK13A_1A        (REG_FRC_BANK_BASE+0x13A1A)
#define REG_FRC_BK13A_1B        (REG_FRC_BANK_BASE+0x13A1B)
#define REG_FRC_BK13A_1C        (REG_FRC_BANK_BASE+0x13A1C)
#define REG_FRC_BK13A_1D        (REG_FRC_BANK_BASE+0x13A1D)
#define REG_FRC_BK13A_1E        (REG_FRC_BANK_BASE+0x13A1E)
#define REG_FRC_BK13A_1F        (REG_FRC_BANK_BASE+0x13A1F)
#define REG_FRC_BK13A_20        (REG_FRC_BANK_BASE+0x13A20)
#define REG_FRC_BK13A_21        (REG_FRC_BANK_BASE+0x13A21)
#define REG_FRC_BK13A_22        (REG_FRC_BANK_BASE+0x13A22)
#define REG_FRC_BK13A_23        (REG_FRC_BANK_BASE+0x13A23)
#define REG_FRC_BK13A_24        (REG_FRC_BANK_BASE+0x13A24)
#define REG_FRC_BK13A_25        (REG_FRC_BANK_BASE+0x13A25)
#define REG_FRC_BK13A_26        (REG_FRC_BANK_BASE+0x13A26)
#define REG_FRC_BK13A_27        (REG_FRC_BANK_BASE+0x13A27)
#define REG_FRC_BK13A_28        (REG_FRC_BANK_BASE+0x13A28)
#define REG_FRC_BK13A_29        (REG_FRC_BANK_BASE+0x13A29)
#define REG_FRC_BK13A_2A        (REG_FRC_BANK_BASE+0x13A2A)
#define REG_FRC_BK13A_2B        (REG_FRC_BANK_BASE+0x13A2B)
#define REG_FRC_BK13A_2C        (REG_FRC_BANK_BASE+0x13A2C)
#define REG_FRC_BK13A_2D        (REG_FRC_BANK_BASE+0x13A2D)
#define REG_FRC_BK13A_2E        (REG_FRC_BANK_BASE+0x13A2E)
#define REG_FRC_BK13A_2F        (REG_FRC_BANK_BASE+0x13A2F)
#define REG_FRC_BK13A_30        (REG_FRC_BANK_BASE+0x13A30)
#define REG_FRC_BK13A_31        (REG_FRC_BANK_BASE+0x13A31)
#define REG_FRC_BK13A_32        (REG_FRC_BANK_BASE+0x13A32)
#define REG_FRC_BK13A_33        (REG_FRC_BANK_BASE+0x13A33)
#define REG_FRC_BK13A_34        (REG_FRC_BANK_BASE+0x13A34)
#define REG_FRC_BK13A_35        (REG_FRC_BANK_BASE+0x13A35)
#define REG_FRC_BK13A_36        (REG_FRC_BANK_BASE+0x13A36)
#define REG_FRC_BK13A_37        (REG_FRC_BANK_BASE+0x13A37)
#define REG_FRC_BK13A_38        (REG_FRC_BANK_BASE+0x13A38)
#define REG_FRC_BK13A_39        (REG_FRC_BANK_BASE+0x13A39)
#define REG_FRC_BK13A_3A        (REG_FRC_BANK_BASE+0x13A3A)
#define REG_FRC_BK13A_3B        (REG_FRC_BANK_BASE+0x13A3B)
#define REG_FRC_BK13A_3C        (REG_FRC_BANK_BASE+0x13A3C)
#define REG_FRC_BK13A_3D        (REG_FRC_BANK_BASE+0x13A3D)
#define REG_FRC_BK13A_3E        (REG_FRC_BANK_BASE+0x13A3E)
#define REG_FRC_BK13A_3F        (REG_FRC_BANK_BASE+0x13A3F)
#define REG_FRC_BK13A_40        (REG_FRC_BANK_BASE+0x13A40)
#define REG_FRC_BK13A_41        (REG_FRC_BANK_BASE+0x13A41)
#define REG_FRC_BK13A_42        (REG_FRC_BANK_BASE+0x13A42)
#define REG_FRC_BK13A_43        (REG_FRC_BANK_BASE+0x13A43)
#define REG_FRC_BK13A_44        (REG_FRC_BANK_BASE+0x13A44)
#define REG_FRC_BK13A_45        (REG_FRC_BANK_BASE+0x13A45)
#define REG_FRC_BK13A_46        (REG_FRC_BANK_BASE+0x13A46)
#define REG_FRC_BK13A_47        (REG_FRC_BANK_BASE+0x13A47)
#define REG_FRC_BK13A_48        (REG_FRC_BANK_BASE+0x13A48)
#define REG_FRC_BK13A_49        (REG_FRC_BANK_BASE+0x13A49)
#define REG_FRC_BK13A_4A        (REG_FRC_BANK_BASE+0x13A4A)
#define REG_FRC_BK13A_4B        (REG_FRC_BANK_BASE+0x13A4B)
#define REG_FRC_BK13A_4C        (REG_FRC_BANK_BASE+0x13A4C)
#define REG_FRC_BK13A_4D        (REG_FRC_BANK_BASE+0x13A4D)
#define REG_FRC_BK13A_4E        (REG_FRC_BANK_BASE+0x13A4E)
#define REG_FRC_BK13A_4F        (REG_FRC_BANK_BASE+0x13A4F)
#define REG_FRC_BK13A_50        (REG_FRC_BANK_BASE+0x13A50)
#define REG_FRC_BK13A_51        (REG_FRC_BANK_BASE+0x13A51)
#define REG_FRC_BK13A_52        (REG_FRC_BANK_BASE+0x13A52)
#define REG_FRC_BK13A_53        (REG_FRC_BANK_BASE+0x13A53)
#define REG_FRC_BK13A_54        (REG_FRC_BANK_BASE+0x13A54)
#define REG_FRC_BK13A_55        (REG_FRC_BANK_BASE+0x13A55)
#define REG_FRC_BK13A_56        (REG_FRC_BANK_BASE+0x13A56)
#define REG_FRC_BK13A_57        (REG_FRC_BANK_BASE+0x13A57)
#define REG_FRC_BK13A_58        (REG_FRC_BANK_BASE+0x13A58)
#define REG_FRC_BK13A_59        (REG_FRC_BANK_BASE+0x13A59)
#define REG_FRC_BK13A_5A        (REG_FRC_BANK_BASE+0x13A5A)
#define REG_FRC_BK13A_5B        (REG_FRC_BANK_BASE+0x13A5B)
#define REG_FRC_BK13A_5C        (REG_FRC_BANK_BASE+0x13A5C)
#define REG_FRC_BK13A_5D        (REG_FRC_BANK_BASE+0x13A5D)
#define REG_FRC_BK13A_5E        (REG_FRC_BANK_BASE+0x13A5E)
#define REG_FRC_BK13A_5F        (REG_FRC_BANK_BASE+0x13A5F)
#define REG_FRC_BK13A_60        (REG_FRC_BANK_BASE+0x13A60)
#define REG_FRC_BK13A_61        (REG_FRC_BANK_BASE+0x13A61)
#define REG_FRC_BK13A_62        (REG_FRC_BANK_BASE+0x13A62)
#define REG_FRC_BK13A_63        (REG_FRC_BANK_BASE+0x13A63)
#define REG_FRC_BK13A_64        (REG_FRC_BANK_BASE+0x13A64)
#define REG_FRC_BK13A_65        (REG_FRC_BANK_BASE+0x13A65)
#define REG_FRC_BK13A_66        (REG_FRC_BANK_BASE+0x13A66)
#define REG_FRC_BK13A_67        (REG_FRC_BANK_BASE+0x13A67)
#define REG_FRC_BK13A_68        (REG_FRC_BANK_BASE+0x13A68)
#define REG_FRC_BK13A_69        (REG_FRC_BANK_BASE+0x13A69)
#define REG_FRC_BK13A_6A        (REG_FRC_BANK_BASE+0x13A6A)
#define REG_FRC_BK13A_6B        (REG_FRC_BANK_BASE+0x13A6B)
#define REG_FRC_BK13A_6C        (REG_FRC_BANK_BASE+0x13A6C)
#define REG_FRC_BK13A_6D        (REG_FRC_BANK_BASE+0x13A6D)
#define REG_FRC_BK13A_6E        (REG_FRC_BANK_BASE+0x13A6E)
#define REG_FRC_BK13A_6F        (REG_FRC_BANK_BASE+0x13A6F)
#define REG_FRC_BK13A_70        (REG_FRC_BANK_BASE+0x13A70)
#define REG_FRC_BK13A_71        (REG_FRC_BANK_BASE+0x13A71)
#define REG_FRC_BK13A_72        (REG_FRC_BANK_BASE+0x13A72)
#define REG_FRC_BK13A_73        (REG_FRC_BANK_BASE+0x13A73)
#define REG_FRC_BK13A_74        (REG_FRC_BANK_BASE+0x13A74)
#define REG_FRC_BK13A_75        (REG_FRC_BANK_BASE+0x13A75)
#define REG_FRC_BK13A_76        (REG_FRC_BANK_BASE+0x13A76)
#define REG_FRC_BK13A_77        (REG_FRC_BANK_BASE+0x13A77)
#define REG_FRC_BK13A_78        (REG_FRC_BANK_BASE+0x13A78)
#define REG_FRC_BK13A_79        (REG_FRC_BANK_BASE+0x13A79)
#define REG_FRC_BK13A_7A        (REG_FRC_BANK_BASE+0x13A7A)
#define REG_FRC_BK13A_7B        (REG_FRC_BANK_BASE+0x13A7B)
#define REG_FRC_BK13A_7C        (REG_FRC_BANK_BASE+0x13A7C)
#define REG_FRC_BK13A_7D        (REG_FRC_BANK_BASE+0x13A7D)
#define REG_FRC_BK13A_7E        (REG_FRC_BANK_BASE+0x13A7E)
#define REG_FRC_BK13A_7F        (REG_FRC_BANK_BASE+0x13A7F)
#define REG_FRC_BK13A_80        (REG_FRC_BANK_BASE+0x13A80)
#define REG_FRC_BK13A_81        (REG_FRC_BANK_BASE+0x13A81)
#define REG_FRC_BK13A_82        (REG_FRC_BANK_BASE+0x13A82)
#define REG_FRC_BK13A_83        (REG_FRC_BANK_BASE+0x13A83)
#define REG_FRC_BK13A_84        (REG_FRC_BANK_BASE+0x13A84)
#define REG_FRC_BK13A_85        (REG_FRC_BANK_BASE+0x13A85)
#define REG_FRC_BK13A_86        (REG_FRC_BANK_BASE+0x13A86)
#define REG_FRC_BK13A_87        (REG_FRC_BANK_BASE+0x13A87)
#define REG_FRC_BK13A_88        (REG_FRC_BANK_BASE+0x13A88)
#define REG_FRC_BK13A_89        (REG_FRC_BANK_BASE+0x13A89)
#define REG_FRC_BK13A_8A        (REG_FRC_BANK_BASE+0x13A8A)
#define REG_FRC_BK13A_8B        (REG_FRC_BANK_BASE+0x13A8B)
#define REG_FRC_BK13A_8C        (REG_FRC_BANK_BASE+0x13A8C)
#define REG_FRC_BK13A_8D        (REG_FRC_BANK_BASE+0x13A8D)
#define REG_FRC_BK13A_8E        (REG_FRC_BANK_BASE+0x13A8E)
#define REG_FRC_BK13A_8F        (REG_FRC_BANK_BASE+0x13A8F)
#define REG_FRC_BK13A_90        (REG_FRC_BANK_BASE+0x13A90)
#define REG_FRC_BK13A_91        (REG_FRC_BANK_BASE+0x13A91)
#define REG_FRC_BK13A_92        (REG_FRC_BANK_BASE+0x13A92)
#define REG_FRC_BK13A_93        (REG_FRC_BANK_BASE+0x13A93)
#define REG_FRC_BK13A_94        (REG_FRC_BANK_BASE+0x13A94)
#define REG_FRC_BK13A_95        (REG_FRC_BANK_BASE+0x13A95)
#define REG_FRC_BK13A_96        (REG_FRC_BANK_BASE+0x13A96)
#define REG_FRC_BK13A_97        (REG_FRC_BANK_BASE+0x13A97)
#define REG_FRC_BK13A_98        (REG_FRC_BANK_BASE+0x13A98)
#define REG_FRC_BK13A_99        (REG_FRC_BANK_BASE+0x13A99)
#define REG_FRC_BK13A_9A        (REG_FRC_BANK_BASE+0x13A9A)
#define REG_FRC_BK13A_9B        (REG_FRC_BANK_BASE+0x13A9B)
#define REG_FRC_BK13A_9C        (REG_FRC_BANK_BASE+0x13A9C)
#define REG_FRC_BK13A_9D        (REG_FRC_BANK_BASE+0x13A9D)
#define REG_FRC_BK13A_9E        (REG_FRC_BANK_BASE+0x13A9E)
#define REG_FRC_BK13A_9F        (REG_FRC_BANK_BASE+0x13A9F)
#define REG_FRC_BK13A_A0        (REG_FRC_BANK_BASE+0x13AA0)
#define REG_FRC_BK13A_A1        (REG_FRC_BANK_BASE+0x13AA1)
#define REG_FRC_BK13A_A2        (REG_FRC_BANK_BASE+0x13AA2)
#define REG_FRC_BK13A_A3        (REG_FRC_BANK_BASE+0x13AA3)
#define REG_FRC_BK13A_A4        (REG_FRC_BANK_BASE+0x13AA4)
#define REG_FRC_BK13A_A5        (REG_FRC_BANK_BASE+0x13AA5)
#define REG_FRC_BK13A_A6        (REG_FRC_BANK_BASE+0x13AA6)
#define REG_FRC_BK13A_A7        (REG_FRC_BANK_BASE+0x13AA7)
#define REG_FRC_BK13A_A8        (REG_FRC_BANK_BASE+0x13AA8)
#define REG_FRC_BK13A_A9        (REG_FRC_BANK_BASE+0x13AA9)
#define REG_FRC_BK13A_AA        (REG_FRC_BANK_BASE+0x13AAA)
#define REG_FRC_BK13A_AB        (REG_FRC_BANK_BASE+0x13AAB)
#define REG_FRC_BK13A_AC        (REG_FRC_BANK_BASE+0x13AAC)
#define REG_FRC_BK13A_AD        (REG_FRC_BANK_BASE+0x13AAD)
#define REG_FRC_BK13A_AE        (REG_FRC_BANK_BASE+0x13AAE)
#define REG_FRC_BK13A_AF        (REG_FRC_BANK_BASE+0x13AAF)
#define REG_FRC_BK13A_B0        (REG_FRC_BANK_BASE+0x13AB0)
#define REG_FRC_BK13A_B1        (REG_FRC_BANK_BASE+0x13AB1)
#define REG_FRC_BK13A_B2        (REG_FRC_BANK_BASE+0x13AB2)
#define REG_FRC_BK13A_B3        (REG_FRC_BANK_BASE+0x13AB3)
#define REG_FRC_BK13A_B4        (REG_FRC_BANK_BASE+0x13AB4)
#define REG_FRC_BK13A_B5        (REG_FRC_BANK_BASE+0x13AB5)
#define REG_FRC_BK13A_B6        (REG_FRC_BANK_BASE+0x13AB6)
#define REG_FRC_BK13A_B7        (REG_FRC_BANK_BASE+0x13AB7)
#define REG_FRC_BK13A_B8        (REG_FRC_BANK_BASE+0x13AB8)
#define REG_FRC_BK13A_B9        (REG_FRC_BANK_BASE+0x13AB9)
#define REG_FRC_BK13A_BA        (REG_FRC_BANK_BASE+0x13ABA)
#define REG_FRC_BK13A_BB        (REG_FRC_BANK_BASE+0x13ABB)
#define REG_FRC_BK13A_BC        (REG_FRC_BANK_BASE+0x13ABC)
#define REG_FRC_BK13A_BD        (REG_FRC_BANK_BASE+0x13ABD)
#define REG_FRC_BK13A_BE        (REG_FRC_BANK_BASE+0x13ABE)
#define REG_FRC_BK13A_BF        (REG_FRC_BANK_BASE+0x13ABF)
#define REG_FRC_BK13A_C0        (REG_FRC_BANK_BASE+0x13AC0)
#define REG_FRC_BK13A_C1        (REG_FRC_BANK_BASE+0x13AC1)
#define REG_FRC_BK13A_C2        (REG_FRC_BANK_BASE+0x13AC2)
#define REG_FRC_BK13A_C3        (REG_FRC_BANK_BASE+0x13AC3)
#define REG_FRC_BK13A_C4        (REG_FRC_BANK_BASE+0x13AC4)
#define REG_FRC_BK13A_C5        (REG_FRC_BANK_BASE+0x13AC5)
#define REG_FRC_BK13A_C6        (REG_FRC_BANK_BASE+0x13AC6)
#define REG_FRC_BK13A_C7        (REG_FRC_BANK_BASE+0x13AC7)
#define REG_FRC_BK13A_C8        (REG_FRC_BANK_BASE+0x13AC8)
#define REG_FRC_BK13A_C9        (REG_FRC_BANK_BASE+0x13AC9)
#define REG_FRC_BK13A_CA        (REG_FRC_BANK_BASE+0x13ACA)
#define REG_FRC_BK13A_CB        (REG_FRC_BANK_BASE+0x13ACB)
#define REG_FRC_BK13A_CC        (REG_FRC_BANK_BASE+0x13ACC)
#define REG_FRC_BK13A_CD        (REG_FRC_BANK_BASE+0x13ACD)
#define REG_FRC_BK13A_CE        (REG_FRC_BANK_BASE+0x13ACE)
#define REG_FRC_BK13A_CF        (REG_FRC_BANK_BASE+0x13ACF)
#define REG_FRC_BK13A_D0        (REG_FRC_BANK_BASE+0x13AD0)
#define REG_FRC_BK13A_D1        (REG_FRC_BANK_BASE+0x13AD1)
#define REG_FRC_BK13A_D2        (REG_FRC_BANK_BASE+0x13AD2)
#define REG_FRC_BK13A_D3        (REG_FRC_BANK_BASE+0x13AD3)
#define REG_FRC_BK13A_D4        (REG_FRC_BANK_BASE+0x13AD4)
#define REG_FRC_BK13A_D5        (REG_FRC_BANK_BASE+0x13AD5)
#define REG_FRC_BK13A_D6        (REG_FRC_BANK_BASE+0x13AD6)
#define REG_FRC_BK13A_D7        (REG_FRC_BANK_BASE+0x13AD7)
#define REG_FRC_BK13A_D8        (REG_FRC_BANK_BASE+0x13AD8)
#define REG_FRC_BK13A_D9        (REG_FRC_BANK_BASE+0x13AD9)
#define REG_FRC_BK13A_DA        (REG_FRC_BANK_BASE+0x13ADA)
#define REG_FRC_BK13A_DB        (REG_FRC_BANK_BASE+0x13ADB)
#define REG_FRC_BK13A_DC        (REG_FRC_BANK_BASE+0x13ADC)
#define REG_FRC_BK13A_DD        (REG_FRC_BANK_BASE+0x13ADD)
#define REG_FRC_BK13A_DE        (REG_FRC_BANK_BASE+0x13ADE)
#define REG_FRC_BK13A_DF        (REG_FRC_BANK_BASE+0x13ADF)
#define REG_FRC_BK13A_E0        (REG_FRC_BANK_BASE+0x13AE0)
#define REG_FRC_BK13A_E1        (REG_FRC_BANK_BASE+0x13AE1)
#define REG_FRC_BK13A_E2        (REG_FRC_BANK_BASE+0x13AE2)
#define REG_FRC_BK13A_E3        (REG_FRC_BANK_BASE+0x13AE3)
#define REG_FRC_BK13A_E4        (REG_FRC_BANK_BASE+0x13AE4)
#define REG_FRC_BK13A_E5        (REG_FRC_BANK_BASE+0x13AE5)
#define REG_FRC_BK13A_E6        (REG_FRC_BANK_BASE+0x13AE6)
#define REG_FRC_BK13A_E7        (REG_FRC_BANK_BASE+0x13AE7)
#define REG_FRC_BK13A_E8        (REG_FRC_BANK_BASE+0x13AE8)
#define REG_FRC_BK13A_E9        (REG_FRC_BANK_BASE+0x13AE9)
#define REG_FRC_BK13A_EA        (REG_FRC_BANK_BASE+0x13AEA)
#define REG_FRC_BK13A_EB        (REG_FRC_BANK_BASE+0x13AEB)
#define REG_FRC_BK13A_EC        (REG_FRC_BANK_BASE+0x13AEC)
#define REG_FRC_BK13A_ED        (REG_FRC_BANK_BASE+0x13AED)
#define REG_FRC_BK13A_EE        (REG_FRC_BANK_BASE+0x13AEE)
#define REG_FRC_BK13A_EF        (REG_FRC_BANK_BASE+0x13AEF)
#define REG_FRC_BK13A_F0        (REG_FRC_BANK_BASE+0x13AF0)
#define REG_FRC_BK13A_F1        (REG_FRC_BANK_BASE+0x13AF1)
#define REG_FRC_BK13A_F2        (REG_FRC_BANK_BASE+0x13AF2)
#define REG_FRC_BK13A_F3        (REG_FRC_BANK_BASE+0x13AF3)
#define REG_FRC_BK13A_F4        (REG_FRC_BANK_BASE+0x13AF4)
#define REG_FRC_BK13A_F5        (REG_FRC_BANK_BASE+0x13AF5)
#define REG_FRC_BK13A_F6        (REG_FRC_BANK_BASE+0x13AF6)
#define REG_FRC_BK13A_F7        (REG_FRC_BANK_BASE+0x13AF7)
#define REG_FRC_BK13A_F8        (REG_FRC_BANK_BASE+0x13AF8)
#define REG_FRC_BK13A_F9        (REG_FRC_BANK_BASE+0x13AF9)
#define REG_FRC_BK13A_FA        (REG_FRC_BANK_BASE+0x13AFA)
#define REG_FRC_BK13A_FB        (REG_FRC_BANK_BASE+0x13AFB)
#define REG_FRC_BK13A_FC        (REG_FRC_BANK_BASE+0x13AFC)
#define REG_FRC_BK13A_FD        (REG_FRC_BANK_BASE+0x13AFD)
#define REG_FRC_BK13A_FE        (REG_FRC_BANK_BASE+0x13AFE)
#define REG_FRC_BK13A_FF        (REG_FRC_BANK_BASE+0x13AFF)

// === FRC bk13B
#define REG_FRC_BK13B_00        (REG_FRC_BANK_BASE+0x13B00)
#define REG_FRC_BK13B_01        (REG_FRC_BANK_BASE+0x13B01)
#define REG_FRC_BK13B_02        (REG_FRC_BANK_BASE+0x13B02)
#define REG_FRC_BK13B_03        (REG_FRC_BANK_BASE+0x13B03)
#define REG_FRC_BK13B_04        (REG_FRC_BANK_BASE+0x13B04)
#define REG_FRC_BK13B_05        (REG_FRC_BANK_BASE+0x13B05)
#define REG_FRC_BK13B_06        (REG_FRC_BANK_BASE+0x13B06)
#define REG_FRC_BK13B_07        (REG_FRC_BANK_BASE+0x13B07)
#define REG_FRC_BK13B_08        (REG_FRC_BANK_BASE+0x13B08)
#define REG_FRC_BK13B_09        (REG_FRC_BANK_BASE+0x13B09)
#define REG_FRC_BK13B_0A        (REG_FRC_BANK_BASE+0x13B0A)
#define REG_FRC_BK13B_0B        (REG_FRC_BANK_BASE+0x13B0B)
#define REG_FRC_BK13B_0C        (REG_FRC_BANK_BASE+0x13B0C)
#define REG_FRC_BK13B_0D        (REG_FRC_BANK_BASE+0x13B0D)
#define REG_FRC_BK13B_0E        (REG_FRC_BANK_BASE+0x13B0E)
#define REG_FRC_BK13B_0F        (REG_FRC_BANK_BASE+0x13B0F)
#define REG_FRC_BK13B_10        (REG_FRC_BANK_BASE+0x13B10)
#define REG_FRC_BK13B_11        (REG_FRC_BANK_BASE+0x13B11)
#define REG_FRC_BK13B_12        (REG_FRC_BANK_BASE+0x13B12)
#define REG_FRC_BK13B_13        (REG_FRC_BANK_BASE+0x13B13)
#define REG_FRC_BK13B_14        (REG_FRC_BANK_BASE+0x13B14)
#define REG_FRC_BK13B_15        (REG_FRC_BANK_BASE+0x13B15)
#define REG_FRC_BK13B_16        (REG_FRC_BANK_BASE+0x13B16)
#define REG_FRC_BK13B_17        (REG_FRC_BANK_BASE+0x13B17)
#define REG_FRC_BK13B_18        (REG_FRC_BANK_BASE+0x13B18)
#define REG_FRC_BK13B_19        (REG_FRC_BANK_BASE+0x13B19)
#define REG_FRC_BK13B_1A        (REG_FRC_BANK_BASE+0x13B1A)
#define REG_FRC_BK13B_1B        (REG_FRC_BANK_BASE+0x13B1B)
#define REG_FRC_BK13B_1C        (REG_FRC_BANK_BASE+0x13B1C)
#define REG_FRC_BK13B_1D        (REG_FRC_BANK_BASE+0x13B1D)
#define REG_FRC_BK13B_1E        (REG_FRC_BANK_BASE+0x13B1E)
#define REG_FRC_BK13B_1F        (REG_FRC_BANK_BASE+0x13B1F)
#define REG_FRC_BK13B_20        (REG_FRC_BANK_BASE+0x13B20)
#define REG_FRC_BK13B_21        (REG_FRC_BANK_BASE+0x13B21)
#define REG_FRC_BK13B_22        (REG_FRC_BANK_BASE+0x13B22)
#define REG_FRC_BK13B_23        (REG_FRC_BANK_BASE+0x13B23)
#define REG_FRC_BK13B_24        (REG_FRC_BANK_BASE+0x13B24)
#define REG_FRC_BK13B_25        (REG_FRC_BANK_BASE+0x13B25)
#define REG_FRC_BK13B_26        (REG_FRC_BANK_BASE+0x13B26)
#define REG_FRC_BK13B_27        (REG_FRC_BANK_BASE+0x13B27)
#define REG_FRC_BK13B_28        (REG_FRC_BANK_BASE+0x13B28)
#define REG_FRC_BK13B_29        (REG_FRC_BANK_BASE+0x13B29)
#define REG_FRC_BK13B_2A        (REG_FRC_BANK_BASE+0x13B2A)
#define REG_FRC_BK13B_2B        (REG_FRC_BANK_BASE+0x13B2B)
#define REG_FRC_BK13B_2C        (REG_FRC_BANK_BASE+0x13B2C)
#define REG_FRC_BK13B_2D        (REG_FRC_BANK_BASE+0x13B2D)
#define REG_FRC_BK13B_2E        (REG_FRC_BANK_BASE+0x13B2E)
#define REG_FRC_BK13B_2F        (REG_FRC_BANK_BASE+0x13B2F)
#define REG_FRC_BK13B_30        (REG_FRC_BANK_BASE+0x13B30)
#define REG_FRC_BK13B_31        (REG_FRC_BANK_BASE+0x13B31)
#define REG_FRC_BK13B_32        (REG_FRC_BANK_BASE+0x13B32)
#define REG_FRC_BK13B_33        (REG_FRC_BANK_BASE+0x13B33)
#define REG_FRC_BK13B_34        (REG_FRC_BANK_BASE+0x13B34)
#define REG_FRC_BK13B_35        (REG_FRC_BANK_BASE+0x13B35)
#define REG_FRC_BK13B_36        (REG_FRC_BANK_BASE+0x13B36)
#define REG_FRC_BK13B_37        (REG_FRC_BANK_BASE+0x13B37)
#define REG_FRC_BK13B_38        (REG_FRC_BANK_BASE+0x13B38)
#define REG_FRC_BK13B_39        (REG_FRC_BANK_BASE+0x13B39)
#define REG_FRC_BK13B_3A        (REG_FRC_BANK_BASE+0x13B3A)
#define REG_FRC_BK13B_3B        (REG_FRC_BANK_BASE+0x13B3B)
#define REG_FRC_BK13B_3C        (REG_FRC_BANK_BASE+0x13B3C)
#define REG_FRC_BK13B_3D        (REG_FRC_BANK_BASE+0x13B3D)
#define REG_FRC_BK13B_3E        (REG_FRC_BANK_BASE+0x13B3E)
#define REG_FRC_BK13B_3F        (REG_FRC_BANK_BASE+0x13B3F)
#define REG_FRC_BK13B_40        (REG_FRC_BANK_BASE+0x13B40)
#define REG_FRC_BK13B_41        (REG_FRC_BANK_BASE+0x13B41)
#define REG_FRC_BK13B_42        (REG_FRC_BANK_BASE+0x13B42)
#define REG_FRC_BK13B_43        (REG_FRC_BANK_BASE+0x13B43)
#define REG_FRC_BK13B_44        (REG_FRC_BANK_BASE+0x13B44)
#define REG_FRC_BK13B_45        (REG_FRC_BANK_BASE+0x13B45)
#define REG_FRC_BK13B_46        (REG_FRC_BANK_BASE+0x13B46)
#define REG_FRC_BK13B_47        (REG_FRC_BANK_BASE+0x13B47)
#define REG_FRC_BK13B_48        (REG_FRC_BANK_BASE+0x13B48)
#define REG_FRC_BK13B_49        (REG_FRC_BANK_BASE+0x13B49)
#define REG_FRC_BK13B_4A        (REG_FRC_BANK_BASE+0x13B4A)
#define REG_FRC_BK13B_4B        (REG_FRC_BANK_BASE+0x13B4B)
#define REG_FRC_BK13B_4C        (REG_FRC_BANK_BASE+0x13B4C)
#define REG_FRC_BK13B_4D        (REG_FRC_BANK_BASE+0x13B4D)
#define REG_FRC_BK13B_4E        (REG_FRC_BANK_BASE+0x13B4E)
#define REG_FRC_BK13B_4F        (REG_FRC_BANK_BASE+0x13B4F)
#define REG_FRC_BK13B_50        (REG_FRC_BANK_BASE+0x13B50)
#define REG_FRC_BK13B_51        (REG_FRC_BANK_BASE+0x13B51)
#define REG_FRC_BK13B_52        (REG_FRC_BANK_BASE+0x13B52)
#define REG_FRC_BK13B_53        (REG_FRC_BANK_BASE+0x13B53)
#define REG_FRC_BK13B_54        (REG_FRC_BANK_BASE+0x13B54)
#define REG_FRC_BK13B_55        (REG_FRC_BANK_BASE+0x13B55)
#define REG_FRC_BK13B_56        (REG_FRC_BANK_BASE+0x13B56)
#define REG_FRC_BK13B_57        (REG_FRC_BANK_BASE+0x13B57)
#define REG_FRC_BK13B_58        (REG_FRC_BANK_BASE+0x13B58)
#define REG_FRC_BK13B_59        (REG_FRC_BANK_BASE+0x13B59)
#define REG_FRC_BK13B_5A        (REG_FRC_BANK_BASE+0x13B5A)
#define REG_FRC_BK13B_5B        (REG_FRC_BANK_BASE+0x13B5B)
#define REG_FRC_BK13B_5C        (REG_FRC_BANK_BASE+0x13B5C)
#define REG_FRC_BK13B_5D        (REG_FRC_BANK_BASE+0x13B5D)
#define REG_FRC_BK13B_5E        (REG_FRC_BANK_BASE+0x13B5E)
#define REG_FRC_BK13B_5F        (REG_FRC_BANK_BASE+0x13B5F)
#define REG_FRC_BK13B_60        (REG_FRC_BANK_BASE+0x13B60)
#define REG_FRC_BK13B_61        (REG_FRC_BANK_BASE+0x13B61)
#define REG_FRC_BK13B_62        (REG_FRC_BANK_BASE+0x13B62)
#define REG_FRC_BK13B_63        (REG_FRC_BANK_BASE+0x13B63)
#define REG_FRC_BK13B_64        (REG_FRC_BANK_BASE+0x13B64)
#define REG_FRC_BK13B_65        (REG_FRC_BANK_BASE+0x13B65)
#define REG_FRC_BK13B_66        (REG_FRC_BANK_BASE+0x13B66)
#define REG_FRC_BK13B_67        (REG_FRC_BANK_BASE+0x13B67)
#define REG_FRC_BK13B_68        (REG_FRC_BANK_BASE+0x13B68)
#define REG_FRC_BK13B_69        (REG_FRC_BANK_BASE+0x13B69)
#define REG_FRC_BK13B_6A        (REG_FRC_BANK_BASE+0x13B6A)
#define REG_FRC_BK13B_6B        (REG_FRC_BANK_BASE+0x13B6B)
#define REG_FRC_BK13B_6C        (REG_FRC_BANK_BASE+0x13B6C)
#define REG_FRC_BK13B_6D        (REG_FRC_BANK_BASE+0x13B6D)
#define REG_FRC_BK13B_6E        (REG_FRC_BANK_BASE+0x13B6E)
#define REG_FRC_BK13B_6F        (REG_FRC_BANK_BASE+0x13B6F)
#define REG_FRC_BK13B_70        (REG_FRC_BANK_BASE+0x13B70)
#define REG_FRC_BK13B_71        (REG_FRC_BANK_BASE+0x13B71)
#define REG_FRC_BK13B_72        (REG_FRC_BANK_BASE+0x13B72)
#define REG_FRC_BK13B_73        (REG_FRC_BANK_BASE+0x13B73)
#define REG_FRC_BK13B_74        (REG_FRC_BANK_BASE+0x13B74)
#define REG_FRC_BK13B_75        (REG_FRC_BANK_BASE+0x13B75)
#define REG_FRC_BK13B_76        (REG_FRC_BANK_BASE+0x13B76)
#define REG_FRC_BK13B_77        (REG_FRC_BANK_BASE+0x13B77)
#define REG_FRC_BK13B_78        (REG_FRC_BANK_BASE+0x13B78)
#define REG_FRC_BK13B_79        (REG_FRC_BANK_BASE+0x13B79)
#define REG_FRC_BK13B_7A        (REG_FRC_BANK_BASE+0x13B7A)
#define REG_FRC_BK13B_7B        (REG_FRC_BANK_BASE+0x13B7B)
#define REG_FRC_BK13B_7C        (REG_FRC_BANK_BASE+0x13B7C)
#define REG_FRC_BK13B_7D        (REG_FRC_BANK_BASE+0x13B7D)
#define REG_FRC_BK13B_7E        (REG_FRC_BANK_BASE+0x13B7E)
#define REG_FRC_BK13B_7F        (REG_FRC_BANK_BASE+0x13B7F)
#define REG_FRC_BK13B_80        (REG_FRC_BANK_BASE+0x13B80)
#define REG_FRC_BK13B_81        (REG_FRC_BANK_BASE+0x13B81)
#define REG_FRC_BK13B_82        (REG_FRC_BANK_BASE+0x13B82)
#define REG_FRC_BK13B_83        (REG_FRC_BANK_BASE+0x13B83)
#define REG_FRC_BK13B_84        (REG_FRC_BANK_BASE+0x13B84)
#define REG_FRC_BK13B_85        (REG_FRC_BANK_BASE+0x13B85)
#define REG_FRC_BK13B_86        (REG_FRC_BANK_BASE+0x13B86)
#define REG_FRC_BK13B_87        (REG_FRC_BANK_BASE+0x13B87)
#define REG_FRC_BK13B_88        (REG_FRC_BANK_BASE+0x13B88)
#define REG_FRC_BK13B_89        (REG_FRC_BANK_BASE+0x13B89)
#define REG_FRC_BK13B_8A        (REG_FRC_BANK_BASE+0x13B8A)
#define REG_FRC_BK13B_8B        (REG_FRC_BANK_BASE+0x13B8B)
#define REG_FRC_BK13B_8C        (REG_FRC_BANK_BASE+0x13B8C)
#define REG_FRC_BK13B_8D        (REG_FRC_BANK_BASE+0x13B8D)
#define REG_FRC_BK13B_8E        (REG_FRC_BANK_BASE+0x13B8E)
#define REG_FRC_BK13B_8F        (REG_FRC_BANK_BASE+0x13B8F)
#define REG_FRC_BK13B_90        (REG_FRC_BANK_BASE+0x13B90)
#define REG_FRC_BK13B_91        (REG_FRC_BANK_BASE+0x13B91)
#define REG_FRC_BK13B_92        (REG_FRC_BANK_BASE+0x13B92)
#define REG_FRC_BK13B_93        (REG_FRC_BANK_BASE+0x13B93)
#define REG_FRC_BK13B_94        (REG_FRC_BANK_BASE+0x13B94)
#define REG_FRC_BK13B_95        (REG_FRC_BANK_BASE+0x13B95)
#define REG_FRC_BK13B_96        (REG_FRC_BANK_BASE+0x13B96)
#define REG_FRC_BK13B_97        (REG_FRC_BANK_BASE+0x13B97)
#define REG_FRC_BK13B_98        (REG_FRC_BANK_BASE+0x13B98)
#define REG_FRC_BK13B_99        (REG_FRC_BANK_BASE+0x13B99)
#define REG_FRC_BK13B_9A        (REG_FRC_BANK_BASE+0x13B9A)
#define REG_FRC_BK13B_9B        (REG_FRC_BANK_BASE+0x13B9B)
#define REG_FRC_BK13B_9C        (REG_FRC_BANK_BASE+0x13B9C)
#define REG_FRC_BK13B_9D        (REG_FRC_BANK_BASE+0x13B9D)
#define REG_FRC_BK13B_9E        (REG_FRC_BANK_BASE+0x13B9E)
#define REG_FRC_BK13B_9F        (REG_FRC_BANK_BASE+0x13B9F)
#define REG_FRC_BK13B_A0        (REG_FRC_BANK_BASE+0x13BA0)
#define REG_FRC_BK13B_A1        (REG_FRC_BANK_BASE+0x13BA1)
#define REG_FRC_BK13B_A2        (REG_FRC_BANK_BASE+0x13BA2)
#define REG_FRC_BK13B_A3        (REG_FRC_BANK_BASE+0x13BA3)
#define REG_FRC_BK13B_A4        (REG_FRC_BANK_BASE+0x13BA4)
#define REG_FRC_BK13B_A5        (REG_FRC_BANK_BASE+0x13BA5)
#define REG_FRC_BK13B_A6        (REG_FRC_BANK_BASE+0x13BA6)
#define REG_FRC_BK13B_A7        (REG_FRC_BANK_BASE+0x13BA7)
#define REG_FRC_BK13B_A8        (REG_FRC_BANK_BASE+0x13BA8)
#define REG_FRC_BK13B_A9        (REG_FRC_BANK_BASE+0x13BA9)
#define REG_FRC_BK13B_AA        (REG_FRC_BANK_BASE+0x13BAA)
#define REG_FRC_BK13B_AB        (REG_FRC_BANK_BASE+0x13BAB)
#define REG_FRC_BK13B_AC        (REG_FRC_BANK_BASE+0x13BAC)
#define REG_FRC_BK13B_AD        (REG_FRC_BANK_BASE+0x13BAD)
#define REG_FRC_BK13B_AE        (REG_FRC_BANK_BASE+0x13BAE)
#define REG_FRC_BK13B_AF        (REG_FRC_BANK_BASE+0x13BAF)
#define REG_FRC_BK13B_B0        (REG_FRC_BANK_BASE+0x13BB0)
#define REG_FRC_BK13B_B1        (REG_FRC_BANK_BASE+0x13BB1)
#define REG_FRC_BK13B_B2        (REG_FRC_BANK_BASE+0x13BB2)
#define REG_FRC_BK13B_B3        (REG_FRC_BANK_BASE+0x13BB3)
#define REG_FRC_BK13B_B4        (REG_FRC_BANK_BASE+0x13BB4)
#define REG_FRC_BK13B_B5        (REG_FRC_BANK_BASE+0x13BB5)
#define REG_FRC_BK13B_B6        (REG_FRC_BANK_BASE+0x13BB6)
#define REG_FRC_BK13B_B7        (REG_FRC_BANK_BASE+0x13BB7)
#define REG_FRC_BK13B_B8        (REG_FRC_BANK_BASE+0x13BB8)
#define REG_FRC_BK13B_B9        (REG_FRC_BANK_BASE+0x13BB9)
#define REG_FRC_BK13B_BA        (REG_FRC_BANK_BASE+0x13BBA)
#define REG_FRC_BK13B_BB        (REG_FRC_BANK_BASE+0x13BBB)
#define REG_FRC_BK13B_BC        (REG_FRC_BANK_BASE+0x13BBC)
#define REG_FRC_BK13B_BD        (REG_FRC_BANK_BASE+0x13BBD)
#define REG_FRC_BK13B_BE        (REG_FRC_BANK_BASE+0x13BBE)
#define REG_FRC_BK13B_BF        (REG_FRC_BANK_BASE+0x13BBF)
#define REG_FRC_BK13B_C0        (REG_FRC_BANK_BASE+0x13BC0)
#define REG_FRC_BK13B_C1        (REG_FRC_BANK_BASE+0x13BC1)
#define REG_FRC_BK13B_C2        (REG_FRC_BANK_BASE+0x13BC2)
#define REG_FRC_BK13B_C3        (REG_FRC_BANK_BASE+0x13BC3)
#define REG_FRC_BK13B_C4        (REG_FRC_BANK_BASE+0x13BC4)
#define REG_FRC_BK13B_C5        (REG_FRC_BANK_BASE+0x13BC5)
#define REG_FRC_BK13B_C6        (REG_FRC_BANK_BASE+0x13BC6)
#define REG_FRC_BK13B_C7        (REG_FRC_BANK_BASE+0x13BC7)
#define REG_FRC_BK13B_C8        (REG_FRC_BANK_BASE+0x13BC8)
#define REG_FRC_BK13B_C9        (REG_FRC_BANK_BASE+0x13BC9)
#define REG_FRC_BK13B_CA        (REG_FRC_BANK_BASE+0x13BCA)
#define REG_FRC_BK13B_CB        (REG_FRC_BANK_BASE+0x13BCB)
#define REG_FRC_BK13B_CC        (REG_FRC_BANK_BASE+0x13BCC)
#define REG_FRC_BK13B_CD        (REG_FRC_BANK_BASE+0x13BCD)
#define REG_FRC_BK13B_CE        (REG_FRC_BANK_BASE+0x13BCE)
#define REG_FRC_BK13B_CF        (REG_FRC_BANK_BASE+0x13BCF)
#define REG_FRC_BK13B_D0        (REG_FRC_BANK_BASE+0x13BD0)
#define REG_FRC_BK13B_D1        (REG_FRC_BANK_BASE+0x13BD1)
#define REG_FRC_BK13B_D2        (REG_FRC_BANK_BASE+0x13BD2)
#define REG_FRC_BK13B_D3        (REG_FRC_BANK_BASE+0x13BD3)
#define REG_FRC_BK13B_D4        (REG_FRC_BANK_BASE+0x13BD4)
#define REG_FRC_BK13B_D5        (REG_FRC_BANK_BASE+0x13BD5)
#define REG_FRC_BK13B_D6        (REG_FRC_BANK_BASE+0x13BD6)
#define REG_FRC_BK13B_D7        (REG_FRC_BANK_BASE+0x13BD7)
#define REG_FRC_BK13B_D8        (REG_FRC_BANK_BASE+0x13BD8)
#define REG_FRC_BK13B_D9        (REG_FRC_BANK_BASE+0x13BD9)
#define REG_FRC_BK13B_DA        (REG_FRC_BANK_BASE+0x13BDA)
#define REG_FRC_BK13B_DB        (REG_FRC_BANK_BASE+0x13BDB)
#define REG_FRC_BK13B_DC        (REG_FRC_BANK_BASE+0x13BDC)
#define REG_FRC_BK13B_DD        (REG_FRC_BANK_BASE+0x13BDD)
#define REG_FRC_BK13B_DE        (REG_FRC_BANK_BASE+0x13BDE)
#define REG_FRC_BK13B_DF        (REG_FRC_BANK_BASE+0x13BDF)
#define REG_FRC_BK13B_E0        (REG_FRC_BANK_BASE+0x13BE0)
#define REG_FRC_BK13B_E1        (REG_FRC_BANK_BASE+0x13BE1)
#define REG_FRC_BK13B_E2        (REG_FRC_BANK_BASE+0x13BE2)
#define REG_FRC_BK13B_E3        (REG_FRC_BANK_BASE+0x13BE3)
#define REG_FRC_BK13B_E4        (REG_FRC_BANK_BASE+0x13BE4)
#define REG_FRC_BK13B_E5        (REG_FRC_BANK_BASE+0x13BE5)
#define REG_FRC_BK13B_E6        (REG_FRC_BANK_BASE+0x13BE6)
#define REG_FRC_BK13B_E7        (REG_FRC_BANK_BASE+0x13BE7)
#define REG_FRC_BK13B_E8        (REG_FRC_BANK_BASE+0x13BE8)
#define REG_FRC_BK13B_E9        (REG_FRC_BANK_BASE+0x13BE9)
#define REG_FRC_BK13B_EA        (REG_FRC_BANK_BASE+0x13BEA)
#define REG_FRC_BK13B_EB        (REG_FRC_BANK_BASE+0x13BEB)
#define REG_FRC_BK13B_EC        (REG_FRC_BANK_BASE+0x13BEC)
#define REG_FRC_BK13B_ED        (REG_FRC_BANK_BASE+0x13BED)
#define REG_FRC_BK13B_EE        (REG_FRC_BANK_BASE+0x13BEE)
#define REG_FRC_BK13B_EF        (REG_FRC_BANK_BASE+0x13BEF)
#define REG_FRC_BK13B_F0        (REG_FRC_BANK_BASE+0x13BF0)
#define REG_FRC_BK13B_F1        (REG_FRC_BANK_BASE+0x13BF1)
#define REG_FRC_BK13B_F2        (REG_FRC_BANK_BASE+0x13BF2)
#define REG_FRC_BK13B_F3        (REG_FRC_BANK_BASE+0x13BF3)
#define REG_FRC_BK13B_F4        (REG_FRC_BANK_BASE+0x13BF4)
#define REG_FRC_BK13B_F5        (REG_FRC_BANK_BASE+0x13BF5)
#define REG_FRC_BK13B_F6        (REG_FRC_BANK_BASE+0x13BF6)
#define REG_FRC_BK13B_F7        (REG_FRC_BANK_BASE+0x13BF7)
#define REG_FRC_BK13B_F8        (REG_FRC_BANK_BASE+0x13BF8)
#define REG_FRC_BK13B_F9        (REG_FRC_BANK_BASE+0x13BF9)
#define REG_FRC_BK13B_FA        (REG_FRC_BANK_BASE+0x13BFA)
#define REG_FRC_BK13B_FB        (REG_FRC_BANK_BASE+0x13BFB)
#define REG_FRC_BK13B_FC        (REG_FRC_BANK_BASE+0x13BFC)
#define REG_FRC_BK13B_FD        (REG_FRC_BANK_BASE+0x13BFD)
#define REG_FRC_BK13B_FE        (REG_FRC_BANK_BASE+0x13BFE)
#define REG_FRC_BK13B_FF        (REG_FRC_BANK_BASE+0x13BFF)

// === FRC bk13C
#define REG_FRC_BK13C_00        (REG_FRC_BANK_BASE+0x13C00)
#define REG_FRC_BK13C_01        (REG_FRC_BANK_BASE+0x13C01)
#define REG_FRC_BK13C_02        (REG_FRC_BANK_BASE+0x13C02)
#define REG_FRC_BK13C_03        (REG_FRC_BANK_BASE+0x13C03)
#define REG_FRC_BK13C_04        (REG_FRC_BANK_BASE+0x13C04)
#define REG_FRC_BK13C_05        (REG_FRC_BANK_BASE+0x13C05)
#define REG_FRC_BK13C_06        (REG_FRC_BANK_BASE+0x13C06)
#define REG_FRC_BK13C_07        (REG_FRC_BANK_BASE+0x13C07)
#define REG_FRC_BK13C_08        (REG_FRC_BANK_BASE+0x13C08)
#define REG_FRC_BK13C_09        (REG_FRC_BANK_BASE+0x13C09)
#define REG_FRC_BK13C_0A        (REG_FRC_BANK_BASE+0x13C0A)
#define REG_FRC_BK13C_0B        (REG_FRC_BANK_BASE+0x13C0B)
#define REG_FRC_BK13C_0C        (REG_FRC_BANK_BASE+0x13C0C)
#define REG_FRC_BK13C_0D        (REG_FRC_BANK_BASE+0x13C0D)
#define REG_FRC_BK13C_0E        (REG_FRC_BANK_BASE+0x13C0E)
#define REG_FRC_BK13C_0F        (REG_FRC_BANK_BASE+0x13C0F)
#define REG_FRC_BK13C_10        (REG_FRC_BANK_BASE+0x13C10)
#define REG_FRC_BK13C_11        (REG_FRC_BANK_BASE+0x13C11)
#define REG_FRC_BK13C_12        (REG_FRC_BANK_BASE+0x13C12)
#define REG_FRC_BK13C_13        (REG_FRC_BANK_BASE+0x13C13)
#define REG_FRC_BK13C_14        (REG_FRC_BANK_BASE+0x13C14)
#define REG_FRC_BK13C_15        (REG_FRC_BANK_BASE+0x13C15)
#define REG_FRC_BK13C_16        (REG_FRC_BANK_BASE+0x13C16)
#define REG_FRC_BK13C_17        (REG_FRC_BANK_BASE+0x13C17)
#define REG_FRC_BK13C_18        (REG_FRC_BANK_BASE+0x13C18)
#define REG_FRC_BK13C_19        (REG_FRC_BANK_BASE+0x13C19)
#define REG_FRC_BK13C_1A        (REG_FRC_BANK_BASE+0x13C1A)
#define REG_FRC_BK13C_1B        (REG_FRC_BANK_BASE+0x13C1B)
#define REG_FRC_BK13C_1C        (REG_FRC_BANK_BASE+0x13C1C)
#define REG_FRC_BK13C_1D        (REG_FRC_BANK_BASE+0x13C1D)
#define REG_FRC_BK13C_1E        (REG_FRC_BANK_BASE+0x13C1E)
#define REG_FRC_BK13C_1F        (REG_FRC_BANK_BASE+0x13C1F)
#define REG_FRC_BK13C_20        (REG_FRC_BANK_BASE+0x13C20)
#define REG_FRC_BK13C_21        (REG_FRC_BANK_BASE+0x13C21)
#define REG_FRC_BK13C_22        (REG_FRC_BANK_BASE+0x13C22)
#define REG_FRC_BK13C_23        (REG_FRC_BANK_BASE+0x13C23)
#define REG_FRC_BK13C_24        (REG_FRC_BANK_BASE+0x13C24)
#define REG_FRC_BK13C_25        (REG_FRC_BANK_BASE+0x13C25)
#define REG_FRC_BK13C_26        (REG_FRC_BANK_BASE+0x13C26)
#define REG_FRC_BK13C_27        (REG_FRC_BANK_BASE+0x13C27)
#define REG_FRC_BK13C_28        (REG_FRC_BANK_BASE+0x13C28)
#define REG_FRC_BK13C_29        (REG_FRC_BANK_BASE+0x13C29)
#define REG_FRC_BK13C_2A        (REG_FRC_BANK_BASE+0x13C2A)
#define REG_FRC_BK13C_2B        (REG_FRC_BANK_BASE+0x13C2B)
#define REG_FRC_BK13C_2C        (REG_FRC_BANK_BASE+0x13C2C)
#define REG_FRC_BK13C_2D        (REG_FRC_BANK_BASE+0x13C2D)
#define REG_FRC_BK13C_2E        (REG_FRC_BANK_BASE+0x13C2E)
#define REG_FRC_BK13C_2F        (REG_FRC_BANK_BASE+0x13C2F)
#define REG_FRC_BK13C_30        (REG_FRC_BANK_BASE+0x13C30)
#define REG_FRC_BK13C_31        (REG_FRC_BANK_BASE+0x13C31)
#define REG_FRC_BK13C_32        (REG_FRC_BANK_BASE+0x13C32)
#define REG_FRC_BK13C_33        (REG_FRC_BANK_BASE+0x13C33)
#define REG_FRC_BK13C_34        (REG_FRC_BANK_BASE+0x13C34)
#define REG_FRC_BK13C_35        (REG_FRC_BANK_BASE+0x13C35)
#define REG_FRC_BK13C_36        (REG_FRC_BANK_BASE+0x13C36)
#define REG_FRC_BK13C_37        (REG_FRC_BANK_BASE+0x13C37)
#define REG_FRC_BK13C_38        (REG_FRC_BANK_BASE+0x13C38)
#define REG_FRC_BK13C_39        (REG_FRC_BANK_BASE+0x13C39)
#define REG_FRC_BK13C_3A        (REG_FRC_BANK_BASE+0x13C3A)
#define REG_FRC_BK13C_3B        (REG_FRC_BANK_BASE+0x13C3B)
#define REG_FRC_BK13C_3C        (REG_FRC_BANK_BASE+0x13C3C)
#define REG_FRC_BK13C_3D        (REG_FRC_BANK_BASE+0x13C3D)
#define REG_FRC_BK13C_3E        (REG_FRC_BANK_BASE+0x13C3E)
#define REG_FRC_BK13C_3F        (REG_FRC_BANK_BASE+0x13C3F)
#define REG_FRC_BK13C_40        (REG_FRC_BANK_BASE+0x13C40)
#define REG_FRC_BK13C_41        (REG_FRC_BANK_BASE+0x13C41)
#define REG_FRC_BK13C_42        (REG_FRC_BANK_BASE+0x13C42)
#define REG_FRC_BK13C_43        (REG_FRC_BANK_BASE+0x13C43)
#define REG_FRC_BK13C_44        (REG_FRC_BANK_BASE+0x13C44)
#define REG_FRC_BK13C_45        (REG_FRC_BANK_BASE+0x13C45)
#define REG_FRC_BK13C_46        (REG_FRC_BANK_BASE+0x13C46)
#define REG_FRC_BK13C_47        (REG_FRC_BANK_BASE+0x13C47)
#define REG_FRC_BK13C_48        (REG_FRC_BANK_BASE+0x13C48)
#define REG_FRC_BK13C_49        (REG_FRC_BANK_BASE+0x13C49)
#define REG_FRC_BK13C_4A        (REG_FRC_BANK_BASE+0x13C4A)
#define REG_FRC_BK13C_4B        (REG_FRC_BANK_BASE+0x13C4B)
#define REG_FRC_BK13C_4C        (REG_FRC_BANK_BASE+0x13C4C)
#define REG_FRC_BK13C_4D        (REG_FRC_BANK_BASE+0x13C4D)
#define REG_FRC_BK13C_4E        (REG_FRC_BANK_BASE+0x13C4E)
#define REG_FRC_BK13C_4F        (REG_FRC_BANK_BASE+0x13C4F)
#define REG_FRC_BK13C_50        (REG_FRC_BANK_BASE+0x13C50)
#define REG_FRC_BK13C_51        (REG_FRC_BANK_BASE+0x13C51)
#define REG_FRC_BK13C_52        (REG_FRC_BANK_BASE+0x13C52)
#define REG_FRC_BK13C_53        (REG_FRC_BANK_BASE+0x13C53)
#define REG_FRC_BK13C_54        (REG_FRC_BANK_BASE+0x13C54)
#define REG_FRC_BK13C_55        (REG_FRC_BANK_BASE+0x13C55)
#define REG_FRC_BK13C_56        (REG_FRC_BANK_BASE+0x13C56)
#define REG_FRC_BK13C_57        (REG_FRC_BANK_BASE+0x13C57)
#define REG_FRC_BK13C_58        (REG_FRC_BANK_BASE+0x13C58)
#define REG_FRC_BK13C_59        (REG_FRC_BANK_BASE+0x13C59)
#define REG_FRC_BK13C_5A        (REG_FRC_BANK_BASE+0x13C5A)
#define REG_FRC_BK13C_5B        (REG_FRC_BANK_BASE+0x13C5B)
#define REG_FRC_BK13C_5C        (REG_FRC_BANK_BASE+0x13C5C)
#define REG_FRC_BK13C_5D        (REG_FRC_BANK_BASE+0x13C5D)
#define REG_FRC_BK13C_5E        (REG_FRC_BANK_BASE+0x13C5E)
#define REG_FRC_BK13C_5F        (REG_FRC_BANK_BASE+0x13C5F)
#define REG_FRC_BK13C_60        (REG_FRC_BANK_BASE+0x13C60)
#define REG_FRC_BK13C_61        (REG_FRC_BANK_BASE+0x13C61)
#define REG_FRC_BK13C_62        (REG_FRC_BANK_BASE+0x13C62)
#define REG_FRC_BK13C_63        (REG_FRC_BANK_BASE+0x13C63)
#define REG_FRC_BK13C_64        (REG_FRC_BANK_BASE+0x13C64)
#define REG_FRC_BK13C_65        (REG_FRC_BANK_BASE+0x13C65)
#define REG_FRC_BK13C_66        (REG_FRC_BANK_BASE+0x13C66)
#define REG_FRC_BK13C_67        (REG_FRC_BANK_BASE+0x13C67)
#define REG_FRC_BK13C_68        (REG_FRC_BANK_BASE+0x13C68)
#define REG_FRC_BK13C_69        (REG_FRC_BANK_BASE+0x13C69)
#define REG_FRC_BK13C_6A        (REG_FRC_BANK_BASE+0x13C6A)
#define REG_FRC_BK13C_6B        (REG_FRC_BANK_BASE+0x13C6B)
#define REG_FRC_BK13C_6C        (REG_FRC_BANK_BASE+0x13C6C)
#define REG_FRC_BK13C_6D        (REG_FRC_BANK_BASE+0x13C6D)
#define REG_FRC_BK13C_6E        (REG_FRC_BANK_BASE+0x13C6E)
#define REG_FRC_BK13C_6F        (REG_FRC_BANK_BASE+0x13C6F)
#define REG_FRC_BK13C_70        (REG_FRC_BANK_BASE+0x13C70)
#define REG_FRC_BK13C_71        (REG_FRC_BANK_BASE+0x13C71)
#define REG_FRC_BK13C_72        (REG_FRC_BANK_BASE+0x13C72)
#define REG_FRC_BK13C_73        (REG_FRC_BANK_BASE+0x13C73)
#define REG_FRC_BK13C_74        (REG_FRC_BANK_BASE+0x13C74)
#define REG_FRC_BK13C_75        (REG_FRC_BANK_BASE+0x13C75)
#define REG_FRC_BK13C_76        (REG_FRC_BANK_BASE+0x13C76)
#define REG_FRC_BK13C_77        (REG_FRC_BANK_BASE+0x13C77)
#define REG_FRC_BK13C_78        (REG_FRC_BANK_BASE+0x13C78)
#define REG_FRC_BK13C_79        (REG_FRC_BANK_BASE+0x13C79)
#define REG_FRC_BK13C_7A        (REG_FRC_BANK_BASE+0x13C7A)
#define REG_FRC_BK13C_7B        (REG_FRC_BANK_BASE+0x13C7B)
#define REG_FRC_BK13C_7C        (REG_FRC_BANK_BASE+0x13C7C)
#define REG_FRC_BK13C_7D        (REG_FRC_BANK_BASE+0x13C7D)
#define REG_FRC_BK13C_7E        (REG_FRC_BANK_BASE+0x13C7E)
#define REG_FRC_BK13C_7F        (REG_FRC_BANK_BASE+0x13C7F)
#define REG_FRC_BK13C_80        (REG_FRC_BANK_BASE+0x13C80)
#define REG_FRC_BK13C_81        (REG_FRC_BANK_BASE+0x13C81)
#define REG_FRC_BK13C_82        (REG_FRC_BANK_BASE+0x13C82)
#define REG_FRC_BK13C_83        (REG_FRC_BANK_BASE+0x13C83)
#define REG_FRC_BK13C_84        (REG_FRC_BANK_BASE+0x13C84)
#define REG_FRC_BK13C_85        (REG_FRC_BANK_BASE+0x13C85)
#define REG_FRC_BK13C_86        (REG_FRC_BANK_BASE+0x13C86)
#define REG_FRC_BK13C_87        (REG_FRC_BANK_BASE+0x13C87)
#define REG_FRC_BK13C_88        (REG_FRC_BANK_BASE+0x13C88)
#define REG_FRC_BK13C_89        (REG_FRC_BANK_BASE+0x13C89)
#define REG_FRC_BK13C_8A        (REG_FRC_BANK_BASE+0x13C8A)
#define REG_FRC_BK13C_8B        (REG_FRC_BANK_BASE+0x13C8B)
#define REG_FRC_BK13C_8C        (REG_FRC_BANK_BASE+0x13C8C)
#define REG_FRC_BK13C_8D        (REG_FRC_BANK_BASE+0x13C8D)
#define REG_FRC_BK13C_8E        (REG_FRC_BANK_BASE+0x13C8E)
#define REG_FRC_BK13C_8F        (REG_FRC_BANK_BASE+0x13C8F)
#define REG_FRC_BK13C_90        (REG_FRC_BANK_BASE+0x13C90)
#define REG_FRC_BK13C_91        (REG_FRC_BANK_BASE+0x13C91)
#define REG_FRC_BK13C_92        (REG_FRC_BANK_BASE+0x13C92)
#define REG_FRC_BK13C_93        (REG_FRC_BANK_BASE+0x13C93)
#define REG_FRC_BK13C_94        (REG_FRC_BANK_BASE+0x13C94)
#define REG_FRC_BK13C_95        (REG_FRC_BANK_BASE+0x13C95)
#define REG_FRC_BK13C_96        (REG_FRC_BANK_BASE+0x13C96)
#define REG_FRC_BK13C_97        (REG_FRC_BANK_BASE+0x13C97)
#define REG_FRC_BK13C_98        (REG_FRC_BANK_BASE+0x13C98)
#define REG_FRC_BK13C_99        (REG_FRC_BANK_BASE+0x13C99)
#define REG_FRC_BK13C_9A        (REG_FRC_BANK_BASE+0x13C9A)
#define REG_FRC_BK13C_9B        (REG_FRC_BANK_BASE+0x13C9B)
#define REG_FRC_BK13C_9C        (REG_FRC_BANK_BASE+0x13C9C)
#define REG_FRC_BK13C_9D        (REG_FRC_BANK_BASE+0x13C9D)
#define REG_FRC_BK13C_9E        (REG_FRC_BANK_BASE+0x13C9E)
#define REG_FRC_BK13C_9F        (REG_FRC_BANK_BASE+0x13C9F)
#define REG_FRC_BK13C_A0        (REG_FRC_BANK_BASE+0x13CA0)
#define REG_FRC_BK13C_A1        (REG_FRC_BANK_BASE+0x13CA1)
#define REG_FRC_BK13C_A2        (REG_FRC_BANK_BASE+0x13CA2)
#define REG_FRC_BK13C_A3        (REG_FRC_BANK_BASE+0x13CA3)
#define REG_FRC_BK13C_A4        (REG_FRC_BANK_BASE+0x13CA4)
#define REG_FRC_BK13C_A5        (REG_FRC_BANK_BASE+0x13CA5)
#define REG_FRC_BK13C_A6        (REG_FRC_BANK_BASE+0x13CA6)
#define REG_FRC_BK13C_A7        (REG_FRC_BANK_BASE+0x13CA7)
#define REG_FRC_BK13C_A8        (REG_FRC_BANK_BASE+0x13CA8)
#define REG_FRC_BK13C_A9        (REG_FRC_BANK_BASE+0x13CA9)
#define REG_FRC_BK13C_AA        (REG_FRC_BANK_BASE+0x13CAA)
#define REG_FRC_BK13C_AB        (REG_FRC_BANK_BASE+0x13CAB)
#define REG_FRC_BK13C_AC        (REG_FRC_BANK_BASE+0x13CAC)
#define REG_FRC_BK13C_AD        (REG_FRC_BANK_BASE+0x13CAD)
#define REG_FRC_BK13C_AE        (REG_FRC_BANK_BASE+0x13CAE)
#define REG_FRC_BK13C_AF        (REG_FRC_BANK_BASE+0x13CAF)
#define REG_FRC_BK13C_B0        (REG_FRC_BANK_BASE+0x13CB0)
#define REG_FRC_BK13C_B1        (REG_FRC_BANK_BASE+0x13CB1)
#define REG_FRC_BK13C_B2        (REG_FRC_BANK_BASE+0x13CB2)
#define REG_FRC_BK13C_B3        (REG_FRC_BANK_BASE+0x13CB3)
#define REG_FRC_BK13C_B4        (REG_FRC_BANK_BASE+0x13CB4)
#define REG_FRC_BK13C_B5        (REG_FRC_BANK_BASE+0x13CB5)
#define REG_FRC_BK13C_B6        (REG_FRC_BANK_BASE+0x13CB6)
#define REG_FRC_BK13C_B7        (REG_FRC_BANK_BASE+0x13CB7)
#define REG_FRC_BK13C_B8        (REG_FRC_BANK_BASE+0x13CB8)
#define REG_FRC_BK13C_B9        (REG_FRC_BANK_BASE+0x13CB9)
#define REG_FRC_BK13C_BA        (REG_FRC_BANK_BASE+0x13CBA)
#define REG_FRC_BK13C_BB        (REG_FRC_BANK_BASE+0x13CBB)
#define REG_FRC_BK13C_BC        (REG_FRC_BANK_BASE+0x13CBC)
#define REG_FRC_BK13C_BD        (REG_FRC_BANK_BASE+0x13CBD)
#define REG_FRC_BK13C_BE        (REG_FRC_BANK_BASE+0x13CBE)
#define REG_FRC_BK13C_BF        (REG_FRC_BANK_BASE+0x13CBF)
#define REG_FRC_BK13C_C0        (REG_FRC_BANK_BASE+0x13CC0)
#define REG_FRC_BK13C_C1        (REG_FRC_BANK_BASE+0x13CC1)
#define REG_FRC_BK13C_C2        (REG_FRC_BANK_BASE+0x13CC2)
#define REG_FRC_BK13C_C3        (REG_FRC_BANK_BASE+0x13CC3)
#define REG_FRC_BK13C_C4        (REG_FRC_BANK_BASE+0x13CC4)
#define REG_FRC_BK13C_C5        (REG_FRC_BANK_BASE+0x13CC5)
#define REG_FRC_BK13C_C6        (REG_FRC_BANK_BASE+0x13CC6)
#define REG_FRC_BK13C_C7        (REG_FRC_BANK_BASE+0x13CC7)
#define REG_FRC_BK13C_C8        (REG_FRC_BANK_BASE+0x13CC8)
#define REG_FRC_BK13C_C9        (REG_FRC_BANK_BASE+0x13CC9)
#define REG_FRC_BK13C_CA        (REG_FRC_BANK_BASE+0x13CCA)
#define REG_FRC_BK13C_CB        (REG_FRC_BANK_BASE+0x13CCB)
#define REG_FRC_BK13C_CC        (REG_FRC_BANK_BASE+0x13CCC)
#define REG_FRC_BK13C_CD        (REG_FRC_BANK_BASE+0x13CCD)
#define REG_FRC_BK13C_CE        (REG_FRC_BANK_BASE+0x13CCE)
#define REG_FRC_BK13C_CF        (REG_FRC_BANK_BASE+0x13CCF)
#define REG_FRC_BK13C_D0        (REG_FRC_BANK_BASE+0x13CD0)
#define REG_FRC_BK13C_D1        (REG_FRC_BANK_BASE+0x13CD1)
#define REG_FRC_BK13C_D2        (REG_FRC_BANK_BASE+0x13CD2)
#define REG_FRC_BK13C_D3        (REG_FRC_BANK_BASE+0x13CD3)
#define REG_FRC_BK13C_D4        (REG_FRC_BANK_BASE+0x13CD4)
#define REG_FRC_BK13C_D5        (REG_FRC_BANK_BASE+0x13CD5)
#define REG_FRC_BK13C_D6        (REG_FRC_BANK_BASE+0x13CD6)
#define REG_FRC_BK13C_D7        (REG_FRC_BANK_BASE+0x13CD7)
#define REG_FRC_BK13C_D8        (REG_FRC_BANK_BASE+0x13CD8)
#define REG_FRC_BK13C_D9        (REG_FRC_BANK_BASE+0x13CD9)
#define REG_FRC_BK13C_DA        (REG_FRC_BANK_BASE+0x13CDA)
#define REG_FRC_BK13C_DB        (REG_FRC_BANK_BASE+0x13CDB)
#define REG_FRC_BK13C_DC        (REG_FRC_BANK_BASE+0x13CDC)
#define REG_FRC_BK13C_DD        (REG_FRC_BANK_BASE+0x13CDD)
#define REG_FRC_BK13C_DE        (REG_FRC_BANK_BASE+0x13CDE)
#define REG_FRC_BK13C_DF        (REG_FRC_BANK_BASE+0x13CDF)
#define REG_FRC_BK13C_E0        (REG_FRC_BANK_BASE+0x13CE0)
#define REG_FRC_BK13C_E1        (REG_FRC_BANK_BASE+0x13CE1)
#define REG_FRC_BK13C_E2        (REG_FRC_BANK_BASE+0x13CE2)
#define REG_FRC_BK13C_E3        (REG_FRC_BANK_BASE+0x13CE3)
#define REG_FRC_BK13C_E4        (REG_FRC_BANK_BASE+0x13CE4)
#define REG_FRC_BK13C_E5        (REG_FRC_BANK_BASE+0x13CE5)
#define REG_FRC_BK13C_E6        (REG_FRC_BANK_BASE+0x13CE6)
#define REG_FRC_BK13C_E7        (REG_FRC_BANK_BASE+0x13CE7)
#define REG_FRC_BK13C_E8        (REG_FRC_BANK_BASE+0x13CE8)
#define REG_FRC_BK13C_E9        (REG_FRC_BANK_BASE+0x13CE9)
#define REG_FRC_BK13C_EA        (REG_FRC_BANK_BASE+0x13CEA)
#define REG_FRC_BK13C_EB        (REG_FRC_BANK_BASE+0x13CEB)
#define REG_FRC_BK13C_EC        (REG_FRC_BANK_BASE+0x13CEC)
#define REG_FRC_BK13C_ED        (REG_FRC_BANK_BASE+0x13CED)
#define REG_FRC_BK13C_EE        (REG_FRC_BANK_BASE+0x13CEE)
#define REG_FRC_BK13C_EF        (REG_FRC_BANK_BASE+0x13CEF)
#define REG_FRC_BK13C_F0        (REG_FRC_BANK_BASE+0x13CF0)
#define REG_FRC_BK13C_F1        (REG_FRC_BANK_BASE+0x13CF1)
#define REG_FRC_BK13C_F2        (REG_FRC_BANK_BASE+0x13CF2)
#define REG_FRC_BK13C_F3        (REG_FRC_BANK_BASE+0x13CF3)
#define REG_FRC_BK13C_F4        (REG_FRC_BANK_BASE+0x13CF4)
#define REG_FRC_BK13C_F5        (REG_FRC_BANK_BASE+0x13CF5)
#define REG_FRC_BK13C_F6        (REG_FRC_BANK_BASE+0x13CF6)
#define REG_FRC_BK13C_F7        (REG_FRC_BANK_BASE+0x13CF7)
#define REG_FRC_BK13C_F8        (REG_FRC_BANK_BASE+0x13CF8)
#define REG_FRC_BK13C_F9        (REG_FRC_BANK_BASE+0x13CF9)
#define REG_FRC_BK13C_FA        (REG_FRC_BANK_BASE+0x13CFA)
#define REG_FRC_BK13C_FB        (REG_FRC_BANK_BASE+0x13CFB)
#define REG_FRC_BK13C_FC        (REG_FRC_BANK_BASE+0x13CFC)
#define REG_FRC_BK13C_FD        (REG_FRC_BANK_BASE+0x13CFD)
#define REG_FRC_BK13C_FE        (REG_FRC_BANK_BASE+0x13CFE)
#define REG_FRC_BK13C_FF        (REG_FRC_BANK_BASE+0x13CFF)

// === FRC bk13D
#define REG_FRC_BK13D_00        (REG_FRC_BANK_BASE+0x13D00)
#define REG_FRC_BK13D_01        (REG_FRC_BANK_BASE+0x13D01)
#define REG_FRC_BK13D_02        (REG_FRC_BANK_BASE+0x13D02)
#define REG_FRC_BK13D_03        (REG_FRC_BANK_BASE+0x13D03)
#define REG_FRC_BK13D_04        (REG_FRC_BANK_BASE+0x13D04)
#define REG_FRC_BK13D_05        (REG_FRC_BANK_BASE+0x13D05)
#define REG_FRC_BK13D_06        (REG_FRC_BANK_BASE+0x13D06)
#define REG_FRC_BK13D_07        (REG_FRC_BANK_BASE+0x13D07)
#define REG_FRC_BK13D_08        (REG_FRC_BANK_BASE+0x13D08)
#define REG_FRC_BK13D_09        (REG_FRC_BANK_BASE+0x13D09)
#define REG_FRC_BK13D_0A        (REG_FRC_BANK_BASE+0x13D0A)
#define REG_FRC_BK13D_0B        (REG_FRC_BANK_BASE+0x13D0B)
#define REG_FRC_BK13D_0C        (REG_FRC_BANK_BASE+0x13D0C)
#define REG_FRC_BK13D_0D        (REG_FRC_BANK_BASE+0x13D0D)
#define REG_FRC_BK13D_0E        (REG_FRC_BANK_BASE+0x13D0E)
#define REG_FRC_BK13D_0F        (REG_FRC_BANK_BASE+0x13D0F)
#define REG_FRC_BK13D_10        (REG_FRC_BANK_BASE+0x13D10)
#define REG_FRC_BK13D_11        (REG_FRC_BANK_BASE+0x13D11)
#define REG_FRC_BK13D_12        (REG_FRC_BANK_BASE+0x13D12)
#define REG_FRC_BK13D_13        (REG_FRC_BANK_BASE+0x13D13)
#define REG_FRC_BK13D_14        (REG_FRC_BANK_BASE+0x13D14)
#define REG_FRC_BK13D_15        (REG_FRC_BANK_BASE+0x13D15)
#define REG_FRC_BK13D_16        (REG_FRC_BANK_BASE+0x13D16)
#define REG_FRC_BK13D_17        (REG_FRC_BANK_BASE+0x13D17)
#define REG_FRC_BK13D_18        (REG_FRC_BANK_BASE+0x13D18)
#define REG_FRC_BK13D_19        (REG_FRC_BANK_BASE+0x13D19)
#define REG_FRC_BK13D_1A        (REG_FRC_BANK_BASE+0x13D1A)
#define REG_FRC_BK13D_1B        (REG_FRC_BANK_BASE+0x13D1B)
#define REG_FRC_BK13D_1C        (REG_FRC_BANK_BASE+0x13D1C)
#define REG_FRC_BK13D_1D        (REG_FRC_BANK_BASE+0x13D1D)
#define REG_FRC_BK13D_1E        (REG_FRC_BANK_BASE+0x13D1E)
#define REG_FRC_BK13D_1F        (REG_FRC_BANK_BASE+0x13D1F)
#define REG_FRC_BK13D_20        (REG_FRC_BANK_BASE+0x13D20)
#define REG_FRC_BK13D_21        (REG_FRC_BANK_BASE+0x13D21)
#define REG_FRC_BK13D_22        (REG_FRC_BANK_BASE+0x13D22)
#define REG_FRC_BK13D_23        (REG_FRC_BANK_BASE+0x13D23)
#define REG_FRC_BK13D_24        (REG_FRC_BANK_BASE+0x13D24)
#define REG_FRC_BK13D_25        (REG_FRC_BANK_BASE+0x13D25)
#define REG_FRC_BK13D_26        (REG_FRC_BANK_BASE+0x13D26)
#define REG_FRC_BK13D_27        (REG_FRC_BANK_BASE+0x13D27)
#define REG_FRC_BK13D_28        (REG_FRC_BANK_BASE+0x13D28)
#define REG_FRC_BK13D_29        (REG_FRC_BANK_BASE+0x13D29)
#define REG_FRC_BK13D_2A        (REG_FRC_BANK_BASE+0x13D2A)
#define REG_FRC_BK13D_2B        (REG_FRC_BANK_BASE+0x13D2B)
#define REG_FRC_BK13D_2C        (REG_FRC_BANK_BASE+0x13D2C)
#define REG_FRC_BK13D_2D        (REG_FRC_BANK_BASE+0x13D2D)
#define REG_FRC_BK13D_2E        (REG_FRC_BANK_BASE+0x13D2E)
#define REG_FRC_BK13D_2F        (REG_FRC_BANK_BASE+0x13D2F)
#define REG_FRC_BK13D_30        (REG_FRC_BANK_BASE+0x13D30)
#define REG_FRC_BK13D_31        (REG_FRC_BANK_BASE+0x13D31)
#define REG_FRC_BK13D_32        (REG_FRC_BANK_BASE+0x13D32)
#define REG_FRC_BK13D_33        (REG_FRC_BANK_BASE+0x13D33)
#define REG_FRC_BK13D_34        (REG_FRC_BANK_BASE+0x13D34)
#define REG_FRC_BK13D_35        (REG_FRC_BANK_BASE+0x13D35)
#define REG_FRC_BK13D_36        (REG_FRC_BANK_BASE+0x13D36)
#define REG_FRC_BK13D_37        (REG_FRC_BANK_BASE+0x13D37)
#define REG_FRC_BK13D_38        (REG_FRC_BANK_BASE+0x13D38)
#define REG_FRC_BK13D_39        (REG_FRC_BANK_BASE+0x13D39)
#define REG_FRC_BK13D_3A        (REG_FRC_BANK_BASE+0x13D3A)
#define REG_FRC_BK13D_3B        (REG_FRC_BANK_BASE+0x13D3B)
#define REG_FRC_BK13D_3C        (REG_FRC_BANK_BASE+0x13D3C)
#define REG_FRC_BK13D_3D        (REG_FRC_BANK_BASE+0x13D3D)
#define REG_FRC_BK13D_3E        (REG_FRC_BANK_BASE+0x13D3E)
#define REG_FRC_BK13D_3F        (REG_FRC_BANK_BASE+0x13D3F)
#define REG_FRC_BK13D_40        (REG_FRC_BANK_BASE+0x13D40)
#define REG_FRC_BK13D_41        (REG_FRC_BANK_BASE+0x13D41)
#define REG_FRC_BK13D_42        (REG_FRC_BANK_BASE+0x13D42)
#define REG_FRC_BK13D_43        (REG_FRC_BANK_BASE+0x13D43)
#define REG_FRC_BK13D_44        (REG_FRC_BANK_BASE+0x13D44)
#define REG_FRC_BK13D_45        (REG_FRC_BANK_BASE+0x13D45)
#define REG_FRC_BK13D_46        (REG_FRC_BANK_BASE+0x13D46)
#define REG_FRC_BK13D_47        (REG_FRC_BANK_BASE+0x13D47)
#define REG_FRC_BK13D_48        (REG_FRC_BANK_BASE+0x13D48)
#define REG_FRC_BK13D_49        (REG_FRC_BANK_BASE+0x13D49)
#define REG_FRC_BK13D_4A        (REG_FRC_BANK_BASE+0x13D4A)
#define REG_FRC_BK13D_4B        (REG_FRC_BANK_BASE+0x13D4B)
#define REG_FRC_BK13D_4C        (REG_FRC_BANK_BASE+0x13D4C)
#define REG_FRC_BK13D_4D        (REG_FRC_BANK_BASE+0x13D4D)
#define REG_FRC_BK13D_4E        (REG_FRC_BANK_BASE+0x13D4E)
#define REG_FRC_BK13D_4F        (REG_FRC_BANK_BASE+0x13D4F)
#define REG_FRC_BK13D_50        (REG_FRC_BANK_BASE+0x13D50)
#define REG_FRC_BK13D_51        (REG_FRC_BANK_BASE+0x13D51)
#define REG_FRC_BK13D_52        (REG_FRC_BANK_BASE+0x13D52)
#define REG_FRC_BK13D_53        (REG_FRC_BANK_BASE+0x13D53)
#define REG_FRC_BK13D_54        (REG_FRC_BANK_BASE+0x13D54)
#define REG_FRC_BK13D_55        (REG_FRC_BANK_BASE+0x13D55)
#define REG_FRC_BK13D_56        (REG_FRC_BANK_BASE+0x13D56)
#define REG_FRC_BK13D_57        (REG_FRC_BANK_BASE+0x13D57)
#define REG_FRC_BK13D_58        (REG_FRC_BANK_BASE+0x13D58)
#define REG_FRC_BK13D_59        (REG_FRC_BANK_BASE+0x13D59)
#define REG_FRC_BK13D_5A        (REG_FRC_BANK_BASE+0x13D5A)
#define REG_FRC_BK13D_5B        (REG_FRC_BANK_BASE+0x13D5B)
#define REG_FRC_BK13D_5C        (REG_FRC_BANK_BASE+0x13D5C)
#define REG_FRC_BK13D_5D        (REG_FRC_BANK_BASE+0x13D5D)
#define REG_FRC_BK13D_5E        (REG_FRC_BANK_BASE+0x13D5E)
#define REG_FRC_BK13D_5F        (REG_FRC_BANK_BASE+0x13D5F)
#define REG_FRC_BK13D_60        (REG_FRC_BANK_BASE+0x13D60)
#define REG_FRC_BK13D_61        (REG_FRC_BANK_BASE+0x13D61)
#define REG_FRC_BK13D_62        (REG_FRC_BANK_BASE+0x13D62)
#define REG_FRC_BK13D_63        (REG_FRC_BANK_BASE+0x13D63)
#define REG_FRC_BK13D_64        (REG_FRC_BANK_BASE+0x13D64)
#define REG_FRC_BK13D_65        (REG_FRC_BANK_BASE+0x13D65)
#define REG_FRC_BK13D_66        (REG_FRC_BANK_BASE+0x13D66)
#define REG_FRC_BK13D_67        (REG_FRC_BANK_BASE+0x13D67)
#define REG_FRC_BK13D_68        (REG_FRC_BANK_BASE+0x13D68)
#define REG_FRC_BK13D_69        (REG_FRC_BANK_BASE+0x13D69)
#define REG_FRC_BK13D_6A        (REG_FRC_BANK_BASE+0x13D6A)
#define REG_FRC_BK13D_6B        (REG_FRC_BANK_BASE+0x13D6B)
#define REG_FRC_BK13D_6C        (REG_FRC_BANK_BASE+0x13D6C)
#define REG_FRC_BK13D_6D        (REG_FRC_BANK_BASE+0x13D6D)
#define REG_FRC_BK13D_6E        (REG_FRC_BANK_BASE+0x13D6E)
#define REG_FRC_BK13D_6F        (REG_FRC_BANK_BASE+0x13D6F)
#define REG_FRC_BK13D_70        (REG_FRC_BANK_BASE+0x13D70)
#define REG_FRC_BK13D_71        (REG_FRC_BANK_BASE+0x13D71)
#define REG_FRC_BK13D_72        (REG_FRC_BANK_BASE+0x13D72)
#define REG_FRC_BK13D_73        (REG_FRC_BANK_BASE+0x13D73)
#define REG_FRC_BK13D_74        (REG_FRC_BANK_BASE+0x13D74)
#define REG_FRC_BK13D_75        (REG_FRC_BANK_BASE+0x13D75)
#define REG_FRC_BK13D_76        (REG_FRC_BANK_BASE+0x13D76)
#define REG_FRC_BK13D_77        (REG_FRC_BANK_BASE+0x13D77)
#define REG_FRC_BK13D_78        (REG_FRC_BANK_BASE+0x13D78)
#define REG_FRC_BK13D_79        (REG_FRC_BANK_BASE+0x13D79)
#define REG_FRC_BK13D_7A        (REG_FRC_BANK_BASE+0x13D7A)
#define REG_FRC_BK13D_7B        (REG_FRC_BANK_BASE+0x13D7B)
#define REG_FRC_BK13D_7C        (REG_FRC_BANK_BASE+0x13D7C)
#define REG_FRC_BK13D_7D        (REG_FRC_BANK_BASE+0x13D7D)
#define REG_FRC_BK13D_7E        (REG_FRC_BANK_BASE+0x13D7E)
#define REG_FRC_BK13D_7F        (REG_FRC_BANK_BASE+0x13D7F)
#define REG_FRC_BK13D_80        (REG_FRC_BANK_BASE+0x13D80)
#define REG_FRC_BK13D_81        (REG_FRC_BANK_BASE+0x13D81)
#define REG_FRC_BK13D_82        (REG_FRC_BANK_BASE+0x13D82)
#define REG_FRC_BK13D_83        (REG_FRC_BANK_BASE+0x13D83)
#define REG_FRC_BK13D_84        (REG_FRC_BANK_BASE+0x13D84)
#define REG_FRC_BK13D_85        (REG_FRC_BANK_BASE+0x13D85)
#define REG_FRC_BK13D_86        (REG_FRC_BANK_BASE+0x13D86)
#define REG_FRC_BK13D_87        (REG_FRC_BANK_BASE+0x13D87)
#define REG_FRC_BK13D_88        (REG_FRC_BANK_BASE+0x13D88)
#define REG_FRC_BK13D_89        (REG_FRC_BANK_BASE+0x13D89)
#define REG_FRC_BK13D_8A        (REG_FRC_BANK_BASE+0x13D8A)
#define REG_FRC_BK13D_8B        (REG_FRC_BANK_BASE+0x13D8B)
#define REG_FRC_BK13D_8C        (REG_FRC_BANK_BASE+0x13D8C)
#define REG_FRC_BK13D_8D        (REG_FRC_BANK_BASE+0x13D8D)
#define REG_FRC_BK13D_8E        (REG_FRC_BANK_BASE+0x13D8E)
#define REG_FRC_BK13D_8F        (REG_FRC_BANK_BASE+0x13D8F)
#define REG_FRC_BK13D_90        (REG_FRC_BANK_BASE+0x13D90)
#define REG_FRC_BK13D_91        (REG_FRC_BANK_BASE+0x13D91)
#define REG_FRC_BK13D_92        (REG_FRC_BANK_BASE+0x13D92)
#define REG_FRC_BK13D_93        (REG_FRC_BANK_BASE+0x13D93)
#define REG_FRC_BK13D_94        (REG_FRC_BANK_BASE+0x13D94)
#define REG_FRC_BK13D_95        (REG_FRC_BANK_BASE+0x13D95)
#define REG_FRC_BK13D_96        (REG_FRC_BANK_BASE+0x13D96)
#define REG_FRC_BK13D_97        (REG_FRC_BANK_BASE+0x13D97)
#define REG_FRC_BK13D_98        (REG_FRC_BANK_BASE+0x13D98)
#define REG_FRC_BK13D_99        (REG_FRC_BANK_BASE+0x13D99)
#define REG_FRC_BK13D_9A        (REG_FRC_BANK_BASE+0x13D9A)
#define REG_FRC_BK13D_9B        (REG_FRC_BANK_BASE+0x13D9B)
#define REG_FRC_BK13D_9C        (REG_FRC_BANK_BASE+0x13D9C)
#define REG_FRC_BK13D_9D        (REG_FRC_BANK_BASE+0x13D9D)
#define REG_FRC_BK13D_9E        (REG_FRC_BANK_BASE+0x13D9E)
#define REG_FRC_BK13D_9F        (REG_FRC_BANK_BASE+0x13D9F)
#define REG_FRC_BK13D_A0        (REG_FRC_BANK_BASE+0x13DA0)
#define REG_FRC_BK13D_A1        (REG_FRC_BANK_BASE+0x13DA1)
#define REG_FRC_BK13D_A2        (REG_FRC_BANK_BASE+0x13DA2)
#define REG_FRC_BK13D_A3        (REG_FRC_BANK_BASE+0x13DA3)
#define REG_FRC_BK13D_A4        (REG_FRC_BANK_BASE+0x13DA4)
#define REG_FRC_BK13D_A5        (REG_FRC_BANK_BASE+0x13DA5)
#define REG_FRC_BK13D_A6        (REG_FRC_BANK_BASE+0x13DA6)
#define REG_FRC_BK13D_A7        (REG_FRC_BANK_BASE+0x13DA7)
#define REG_FRC_BK13D_A8        (REG_FRC_BANK_BASE+0x13DA8)
#define REG_FRC_BK13D_A9        (REG_FRC_BANK_BASE+0x13DA9)
#define REG_FRC_BK13D_AA        (REG_FRC_BANK_BASE+0x13DAA)
#define REG_FRC_BK13D_AB        (REG_FRC_BANK_BASE+0x13DAB)
#define REG_FRC_BK13D_AC        (REG_FRC_BANK_BASE+0x13DAC)
#define REG_FRC_BK13D_AD        (REG_FRC_BANK_BASE+0x13DAD)
#define REG_FRC_BK13D_AE        (REG_FRC_BANK_BASE+0x13DAE)
#define REG_FRC_BK13D_AF        (REG_FRC_BANK_BASE+0x13DAF)
#define REG_FRC_BK13D_B0        (REG_FRC_BANK_BASE+0x13DB0)
#define REG_FRC_BK13D_B1        (REG_FRC_BANK_BASE+0x13DB1)
#define REG_FRC_BK13D_B2        (REG_FRC_BANK_BASE+0x13DB2)
#define REG_FRC_BK13D_B3        (REG_FRC_BANK_BASE+0x13DB3)
#define REG_FRC_BK13D_B4        (REG_FRC_BANK_BASE+0x13DB4)
#define REG_FRC_BK13D_B5        (REG_FRC_BANK_BASE+0x13DB5)
#define REG_FRC_BK13D_B6        (REG_FRC_BANK_BASE+0x13DB6)
#define REG_FRC_BK13D_B7        (REG_FRC_BANK_BASE+0x13DB7)
#define REG_FRC_BK13D_B8        (REG_FRC_BANK_BASE+0x13DB8)
#define REG_FRC_BK13D_B9        (REG_FRC_BANK_BASE+0x13DB9)
#define REG_FRC_BK13D_BA        (REG_FRC_BANK_BASE+0x13DBA)
#define REG_FRC_BK13D_BB        (REG_FRC_BANK_BASE+0x13DBB)
#define REG_FRC_BK13D_BC        (REG_FRC_BANK_BASE+0x13DBC)
#define REG_FRC_BK13D_BD        (REG_FRC_BANK_BASE+0x13DBD)
#define REG_FRC_BK13D_BE        (REG_FRC_BANK_BASE+0x13DBE)
#define REG_FRC_BK13D_BF        (REG_FRC_BANK_BASE+0x13DBF)
#define REG_FRC_BK13D_C0        (REG_FRC_BANK_BASE+0x13DC0)
#define REG_FRC_BK13D_C1        (REG_FRC_BANK_BASE+0x13DC1)
#define REG_FRC_BK13D_C2        (REG_FRC_BANK_BASE+0x13DC2)
#define REG_FRC_BK13D_C3        (REG_FRC_BANK_BASE+0x13DC3)
#define REG_FRC_BK13D_C4        (REG_FRC_BANK_BASE+0x13DC4)
#define REG_FRC_BK13D_C5        (REG_FRC_BANK_BASE+0x13DC5)
#define REG_FRC_BK13D_C6        (REG_FRC_BANK_BASE+0x13DC6)
#define REG_FRC_BK13D_C7        (REG_FRC_BANK_BASE+0x13DC7)
#define REG_FRC_BK13D_C8        (REG_FRC_BANK_BASE+0x13DC8)
#define REG_FRC_BK13D_C9        (REG_FRC_BANK_BASE+0x13DC9)
#define REG_FRC_BK13D_CA        (REG_FRC_BANK_BASE+0x13DCA)
#define REG_FRC_BK13D_CB        (REG_FRC_BANK_BASE+0x13DCB)
#define REG_FRC_BK13D_CC        (REG_FRC_BANK_BASE+0x13DCC)
#define REG_FRC_BK13D_CD        (REG_FRC_BANK_BASE+0x13DCD)
#define REG_FRC_BK13D_CE        (REG_FRC_BANK_BASE+0x13DCE)
#define REG_FRC_BK13D_CF        (REG_FRC_BANK_BASE+0x13DCF)
#define REG_FRC_BK13D_D0        (REG_FRC_BANK_BASE+0x13DD0)
#define REG_FRC_BK13D_D1        (REG_FRC_BANK_BASE+0x13DD1)
#define REG_FRC_BK13D_D2        (REG_FRC_BANK_BASE+0x13DD2)
#define REG_FRC_BK13D_D3        (REG_FRC_BANK_BASE+0x13DD3)
#define REG_FRC_BK13D_D4        (REG_FRC_BANK_BASE+0x13DD4)
#define REG_FRC_BK13D_D5        (REG_FRC_BANK_BASE+0x13DD5)
#define REG_FRC_BK13D_D6        (REG_FRC_BANK_BASE+0x13DD6)
#define REG_FRC_BK13D_D7        (REG_FRC_BANK_BASE+0x13DD7)
#define REG_FRC_BK13D_D8        (REG_FRC_BANK_BASE+0x13DD8)
#define REG_FRC_BK13D_D9        (REG_FRC_BANK_BASE+0x13DD9)
#define REG_FRC_BK13D_DA        (REG_FRC_BANK_BASE+0x13DDA)
#define REG_FRC_BK13D_DB        (REG_FRC_BANK_BASE+0x13DDB)
#define REG_FRC_BK13D_DC        (REG_FRC_BANK_BASE+0x13DDC)
#define REG_FRC_BK13D_DD        (REG_FRC_BANK_BASE+0x13DDD)
#define REG_FRC_BK13D_DE        (REG_FRC_BANK_BASE+0x13DDE)
#define REG_FRC_BK13D_DF        (REG_FRC_BANK_BASE+0x13DDF)
#define REG_FRC_BK13D_E0        (REG_FRC_BANK_BASE+0x13DE0)
#define REG_FRC_BK13D_E1        (REG_FRC_BANK_BASE+0x13DE1)
#define REG_FRC_BK13D_E2        (REG_FRC_BANK_BASE+0x13DE2)
#define REG_FRC_BK13D_E3        (REG_FRC_BANK_BASE+0x13DE3)
#define REG_FRC_BK13D_E4        (REG_FRC_BANK_BASE+0x13DE4)
#define REG_FRC_BK13D_E5        (REG_FRC_BANK_BASE+0x13DE5)
#define REG_FRC_BK13D_E6        (REG_FRC_BANK_BASE+0x13DE6)
#define REG_FRC_BK13D_E7        (REG_FRC_BANK_BASE+0x13DE7)
#define REG_FRC_BK13D_E8        (REG_FRC_BANK_BASE+0x13DE8)
#define REG_FRC_BK13D_E9        (REG_FRC_BANK_BASE+0x13DE9)
#define REG_FRC_BK13D_EA        (REG_FRC_BANK_BASE+0x13DEA)
#define REG_FRC_BK13D_EB        (REG_FRC_BANK_BASE+0x13DEB)
#define REG_FRC_BK13D_EC        (REG_FRC_BANK_BASE+0x13DEC)
#define REG_FRC_BK13D_ED        (REG_FRC_BANK_BASE+0x13DED)
#define REG_FRC_BK13D_EE        (REG_FRC_BANK_BASE+0x13DEE)
#define REG_FRC_BK13D_EF        (REG_FRC_BANK_BASE+0x13DEF)
#define REG_FRC_BK13D_F0        (REG_FRC_BANK_BASE+0x13DF0)
#define REG_FRC_BK13D_F1        (REG_FRC_BANK_BASE+0x13DF1)
#define REG_FRC_BK13D_F2        (REG_FRC_BANK_BASE+0x13DF2)
#define REG_FRC_BK13D_F3        (REG_FRC_BANK_BASE+0x13DF3)
#define REG_FRC_BK13D_F4        (REG_FRC_BANK_BASE+0x13DF4)
#define REG_FRC_BK13D_F5        (REG_FRC_BANK_BASE+0x13DF5)
#define REG_FRC_BK13D_F6        (REG_FRC_BANK_BASE+0x13DF6)
#define REG_FRC_BK13D_F7        (REG_FRC_BANK_BASE+0x13DF7)
#define REG_FRC_BK13D_F8        (REG_FRC_BANK_BASE+0x13DF8)
#define REG_FRC_BK13D_F9        (REG_FRC_BANK_BASE+0x13DF9)
#define REG_FRC_BK13D_FA        (REG_FRC_BANK_BASE+0x13DFA)
#define REG_FRC_BK13D_FB        (REG_FRC_BANK_BASE+0x13DFB)
#define REG_FRC_BK13D_FC        (REG_FRC_BANK_BASE+0x13DFC)
#define REG_FRC_BK13D_FD        (REG_FRC_BANK_BASE+0x13DFD)
#define REG_FRC_BK13D_FE        (REG_FRC_BANK_BASE+0x13DFE)
#define REG_FRC_BK13D_FF        (REG_FRC_BANK_BASE+0x13DFF)

// === FRC bk13E
#define REG_FRC_BK13E_00        (REG_FRC_BANK_BASE+0x13E00)
#define REG_FRC_BK13E_01        (REG_FRC_BANK_BASE+0x13E01)
#define REG_FRC_BK13E_02        (REG_FRC_BANK_BASE+0x13E02)
#define REG_FRC_BK13E_03        (REG_FRC_BANK_BASE+0x13E03)
#define REG_FRC_BK13E_04        (REG_FRC_BANK_BASE+0x13E04)
#define REG_FRC_BK13E_05        (REG_FRC_BANK_BASE+0x13E05)
#define REG_FRC_BK13E_06        (REG_FRC_BANK_BASE+0x13E06)
#define REG_FRC_BK13E_07        (REG_FRC_BANK_BASE+0x13E07)
#define REG_FRC_BK13E_08        (REG_FRC_BANK_BASE+0x13E08)
#define REG_FRC_BK13E_09        (REG_FRC_BANK_BASE+0x13E09)
#define REG_FRC_BK13E_0A        (REG_FRC_BANK_BASE+0x13E0A)
#define REG_FRC_BK13E_0B        (REG_FRC_BANK_BASE+0x13E0B)
#define REG_FRC_BK13E_0C        (REG_FRC_BANK_BASE+0x13E0C)
#define REG_FRC_BK13E_0D        (REG_FRC_BANK_BASE+0x13E0D)
#define REG_FRC_BK13E_0E        (REG_FRC_BANK_BASE+0x13E0E)
#define REG_FRC_BK13E_0F        (REG_FRC_BANK_BASE+0x13E0F)
#define REG_FRC_BK13E_10        (REG_FRC_BANK_BASE+0x13E10)
#define REG_FRC_BK13E_11        (REG_FRC_BANK_BASE+0x13E11)
#define REG_FRC_BK13E_12        (REG_FRC_BANK_BASE+0x13E12)
#define REG_FRC_BK13E_13        (REG_FRC_BANK_BASE+0x13E13)
#define REG_FRC_BK13E_14        (REG_FRC_BANK_BASE+0x13E14)
#define REG_FRC_BK13E_15        (REG_FRC_BANK_BASE+0x13E15)
#define REG_FRC_BK13E_16        (REG_FRC_BANK_BASE+0x13E16)
#define REG_FRC_BK13E_17        (REG_FRC_BANK_BASE+0x13E17)
#define REG_FRC_BK13E_18        (REG_FRC_BANK_BASE+0x13E18)
#define REG_FRC_BK13E_19        (REG_FRC_BANK_BASE+0x13E19)
#define REG_FRC_BK13E_1A        (REG_FRC_BANK_BASE+0x13E1A)
#define REG_FRC_BK13E_1B        (REG_FRC_BANK_BASE+0x13E1B)
#define REG_FRC_BK13E_1C        (REG_FRC_BANK_BASE+0x13E1C)
#define REG_FRC_BK13E_1D        (REG_FRC_BANK_BASE+0x13E1D)
#define REG_FRC_BK13E_1E        (REG_FRC_BANK_BASE+0x13E1E)
#define REG_FRC_BK13E_1F        (REG_FRC_BANK_BASE+0x13E1F)
#define REG_FRC_BK13E_20        (REG_FRC_BANK_BASE+0x13E20)
#define REG_FRC_BK13E_21        (REG_FRC_BANK_BASE+0x13E21)
#define REG_FRC_BK13E_22        (REG_FRC_BANK_BASE+0x13E22)
#define REG_FRC_BK13E_23        (REG_FRC_BANK_BASE+0x13E23)
#define REG_FRC_BK13E_24        (REG_FRC_BANK_BASE+0x13E24)
#define REG_FRC_BK13E_25        (REG_FRC_BANK_BASE+0x13E25)
#define REG_FRC_BK13E_26        (REG_FRC_BANK_BASE+0x13E26)
#define REG_FRC_BK13E_27        (REG_FRC_BANK_BASE+0x13E27)
#define REG_FRC_BK13E_28        (REG_FRC_BANK_BASE+0x13E28)
#define REG_FRC_BK13E_29        (REG_FRC_BANK_BASE+0x13E29)
#define REG_FRC_BK13E_2A        (REG_FRC_BANK_BASE+0x13E2A)
#define REG_FRC_BK13E_2B        (REG_FRC_BANK_BASE+0x13E2B)
#define REG_FRC_BK13E_2C        (REG_FRC_BANK_BASE+0x13E2C)
#define REG_FRC_BK13E_2D        (REG_FRC_BANK_BASE+0x13E2D)
#define REG_FRC_BK13E_2E        (REG_FRC_BANK_BASE+0x13E2E)
#define REG_FRC_BK13E_2F        (REG_FRC_BANK_BASE+0x13E2F)
#define REG_FRC_BK13E_30        (REG_FRC_BANK_BASE+0x13E30)
#define REG_FRC_BK13E_31        (REG_FRC_BANK_BASE+0x13E31)
#define REG_FRC_BK13E_32        (REG_FRC_BANK_BASE+0x13E32)
#define REG_FRC_BK13E_33        (REG_FRC_BANK_BASE+0x13E33)
#define REG_FRC_BK13E_34        (REG_FRC_BANK_BASE+0x13E34)
#define REG_FRC_BK13E_35        (REG_FRC_BANK_BASE+0x13E35)
#define REG_FRC_BK13E_36        (REG_FRC_BANK_BASE+0x13E36)
#define REG_FRC_BK13E_37        (REG_FRC_BANK_BASE+0x13E37)
#define REG_FRC_BK13E_38        (REG_FRC_BANK_BASE+0x13E38)
#define REG_FRC_BK13E_39        (REG_FRC_BANK_BASE+0x13E39)
#define REG_FRC_BK13E_3A        (REG_FRC_BANK_BASE+0x13E3A)
#define REG_FRC_BK13E_3B        (REG_FRC_BANK_BASE+0x13E3B)
#define REG_FRC_BK13E_3C        (REG_FRC_BANK_BASE+0x13E3C)
#define REG_FRC_BK13E_3D        (REG_FRC_BANK_BASE+0x13E3D)
#define REG_FRC_BK13E_3E        (REG_FRC_BANK_BASE+0x13E3E)
#define REG_FRC_BK13E_3F        (REG_FRC_BANK_BASE+0x13E3F)
#define REG_FRC_BK13E_40        (REG_FRC_BANK_BASE+0x13E40)
#define REG_FRC_BK13E_41        (REG_FRC_BANK_BASE+0x13E41)
#define REG_FRC_BK13E_42        (REG_FRC_BANK_BASE+0x13E42)
#define REG_FRC_BK13E_43        (REG_FRC_BANK_BASE+0x13E43)
#define REG_FRC_BK13E_44        (REG_FRC_BANK_BASE+0x13E44)
#define REG_FRC_BK13E_45        (REG_FRC_BANK_BASE+0x13E45)
#define REG_FRC_BK13E_46        (REG_FRC_BANK_BASE+0x13E46)
#define REG_FRC_BK13E_47        (REG_FRC_BANK_BASE+0x13E47)
#define REG_FRC_BK13E_48        (REG_FRC_BANK_BASE+0x13E48)
#define REG_FRC_BK13E_49        (REG_FRC_BANK_BASE+0x13E49)
#define REG_FRC_BK13E_4A        (REG_FRC_BANK_BASE+0x13E4A)
#define REG_FRC_BK13E_4B        (REG_FRC_BANK_BASE+0x13E4B)
#define REG_FRC_BK13E_4C        (REG_FRC_BANK_BASE+0x13E4C)
#define REG_FRC_BK13E_4D        (REG_FRC_BANK_BASE+0x13E4D)
#define REG_FRC_BK13E_4E        (REG_FRC_BANK_BASE+0x13E4E)
#define REG_FRC_BK13E_4F        (REG_FRC_BANK_BASE+0x13E4F)
#define REG_FRC_BK13E_50        (REG_FRC_BANK_BASE+0x13E50)
#define REG_FRC_BK13E_51        (REG_FRC_BANK_BASE+0x13E51)
#define REG_FRC_BK13E_52        (REG_FRC_BANK_BASE+0x13E52)
#define REG_FRC_BK13E_53        (REG_FRC_BANK_BASE+0x13E53)
#define REG_FRC_BK13E_54        (REG_FRC_BANK_BASE+0x13E54)
#define REG_FRC_BK13E_55        (REG_FRC_BANK_BASE+0x13E55)
#define REG_FRC_BK13E_56        (REG_FRC_BANK_BASE+0x13E56)
#define REG_FRC_BK13E_57        (REG_FRC_BANK_BASE+0x13E57)
#define REG_FRC_BK13E_58        (REG_FRC_BANK_BASE+0x13E58)
#define REG_FRC_BK13E_59        (REG_FRC_BANK_BASE+0x13E59)
#define REG_FRC_BK13E_5A        (REG_FRC_BANK_BASE+0x13E5A)
#define REG_FRC_BK13E_5B        (REG_FRC_BANK_BASE+0x13E5B)
#define REG_FRC_BK13E_5C        (REG_FRC_BANK_BASE+0x13E5C)
#define REG_FRC_BK13E_5D        (REG_FRC_BANK_BASE+0x13E5D)
#define REG_FRC_BK13E_5E        (REG_FRC_BANK_BASE+0x13E5E)
#define REG_FRC_BK13E_5F        (REG_FRC_BANK_BASE+0x13E5F)
#define REG_FRC_BK13E_60        (REG_FRC_BANK_BASE+0x13E60)
#define REG_FRC_BK13E_61        (REG_FRC_BANK_BASE+0x13E61)
#define REG_FRC_BK13E_62        (REG_FRC_BANK_BASE+0x13E62)
#define REG_FRC_BK13E_63        (REG_FRC_BANK_BASE+0x13E63)
#define REG_FRC_BK13E_64        (REG_FRC_BANK_BASE+0x13E64)
#define REG_FRC_BK13E_65        (REG_FRC_BANK_BASE+0x13E65)
#define REG_FRC_BK13E_66        (REG_FRC_BANK_BASE+0x13E66)
#define REG_FRC_BK13E_67        (REG_FRC_BANK_BASE+0x13E67)
#define REG_FRC_BK13E_68        (REG_FRC_BANK_BASE+0x13E68)
#define REG_FRC_BK13E_69        (REG_FRC_BANK_BASE+0x13E69)
#define REG_FRC_BK13E_6A        (REG_FRC_BANK_BASE+0x13E6A)
#define REG_FRC_BK13E_6B        (REG_FRC_BANK_BASE+0x13E6B)
#define REG_FRC_BK13E_6C        (REG_FRC_BANK_BASE+0x13E6C)
#define REG_FRC_BK13E_6D        (REG_FRC_BANK_BASE+0x13E6D)
#define REG_FRC_BK13E_6E        (REG_FRC_BANK_BASE+0x13E6E)
#define REG_FRC_BK13E_6F        (REG_FRC_BANK_BASE+0x13E6F)
#define REG_FRC_BK13E_70        (REG_FRC_BANK_BASE+0x13E70)
#define REG_FRC_BK13E_71        (REG_FRC_BANK_BASE+0x13E71)
#define REG_FRC_BK13E_72        (REG_FRC_BANK_BASE+0x13E72)
#define REG_FRC_BK13E_73        (REG_FRC_BANK_BASE+0x13E73)
#define REG_FRC_BK13E_74        (REG_FRC_BANK_BASE+0x13E74)
#define REG_FRC_BK13E_75        (REG_FRC_BANK_BASE+0x13E75)
#define REG_FRC_BK13E_76        (REG_FRC_BANK_BASE+0x13E76)
#define REG_FRC_BK13E_77        (REG_FRC_BANK_BASE+0x13E77)
#define REG_FRC_BK13E_78        (REG_FRC_BANK_BASE+0x13E78)
#define REG_FRC_BK13E_79        (REG_FRC_BANK_BASE+0x13E79)
#define REG_FRC_BK13E_7A        (REG_FRC_BANK_BASE+0x13E7A)
#define REG_FRC_BK13E_7B        (REG_FRC_BANK_BASE+0x13E7B)
#define REG_FRC_BK13E_7C        (REG_FRC_BANK_BASE+0x13E7C)
#define REG_FRC_BK13E_7D        (REG_FRC_BANK_BASE+0x13E7D)
#define REG_FRC_BK13E_7E        (REG_FRC_BANK_BASE+0x13E7E)
#define REG_FRC_BK13E_7F        (REG_FRC_BANK_BASE+0x13E7F)
#define REG_FRC_BK13E_80        (REG_FRC_BANK_BASE+0x13E80)
#define REG_FRC_BK13E_81        (REG_FRC_BANK_BASE+0x13E81)
#define REG_FRC_BK13E_82        (REG_FRC_BANK_BASE+0x13E82)
#define REG_FRC_BK13E_83        (REG_FRC_BANK_BASE+0x13E83)
#define REG_FRC_BK13E_84        (REG_FRC_BANK_BASE+0x13E84)
#define REG_FRC_BK13E_85        (REG_FRC_BANK_BASE+0x13E85)
#define REG_FRC_BK13E_86        (REG_FRC_BANK_BASE+0x13E86)
#define REG_FRC_BK13E_87        (REG_FRC_BANK_BASE+0x13E87)
#define REG_FRC_BK13E_88        (REG_FRC_BANK_BASE+0x13E88)
#define REG_FRC_BK13E_89        (REG_FRC_BANK_BASE+0x13E89)
#define REG_FRC_BK13E_8A        (REG_FRC_BANK_BASE+0x13E8A)
#define REG_FRC_BK13E_8B        (REG_FRC_BANK_BASE+0x13E8B)
#define REG_FRC_BK13E_8C        (REG_FRC_BANK_BASE+0x13E8C)
#define REG_FRC_BK13E_8D        (REG_FRC_BANK_BASE+0x13E8D)
#define REG_FRC_BK13E_8E        (REG_FRC_BANK_BASE+0x13E8E)
#define REG_FRC_BK13E_8F        (REG_FRC_BANK_BASE+0x13E8F)
#define REG_FRC_BK13E_90        (REG_FRC_BANK_BASE+0x13E90)
#define REG_FRC_BK13E_91        (REG_FRC_BANK_BASE+0x13E91)
#define REG_FRC_BK13E_92        (REG_FRC_BANK_BASE+0x13E92)
#define REG_FRC_BK13E_93        (REG_FRC_BANK_BASE+0x13E93)
#define REG_FRC_BK13E_94        (REG_FRC_BANK_BASE+0x13E94)
#define REG_FRC_BK13E_95        (REG_FRC_BANK_BASE+0x13E95)
#define REG_FRC_BK13E_96        (REG_FRC_BANK_BASE+0x13E96)
#define REG_FRC_BK13E_97        (REG_FRC_BANK_BASE+0x13E97)
#define REG_FRC_BK13E_98        (REG_FRC_BANK_BASE+0x13E98)
#define REG_FRC_BK13E_99        (REG_FRC_BANK_BASE+0x13E99)
#define REG_FRC_BK13E_9A        (REG_FRC_BANK_BASE+0x13E9A)
#define REG_FRC_BK13E_9B        (REG_FRC_BANK_BASE+0x13E9B)
#define REG_FRC_BK13E_9C        (REG_FRC_BANK_BASE+0x13E9C)
#define REG_FRC_BK13E_9D        (REG_FRC_BANK_BASE+0x13E9D)
#define REG_FRC_BK13E_9E        (REG_FRC_BANK_BASE+0x13E9E)
#define REG_FRC_BK13E_9F        (REG_FRC_BANK_BASE+0x13E9F)
#define REG_FRC_BK13E_A0        (REG_FRC_BANK_BASE+0x13EA0)
#define REG_FRC_BK13E_A1        (REG_FRC_BANK_BASE+0x13EA1)
#define REG_FRC_BK13E_A2        (REG_FRC_BANK_BASE+0x13EA2)
#define REG_FRC_BK13E_A3        (REG_FRC_BANK_BASE+0x13EA3)
#define REG_FRC_BK13E_A4        (REG_FRC_BANK_BASE+0x13EA4)
#define REG_FRC_BK13E_A5        (REG_FRC_BANK_BASE+0x13EA5)
#define REG_FRC_BK13E_A6        (REG_FRC_BANK_BASE+0x13EA6)
#define REG_FRC_BK13E_A7        (REG_FRC_BANK_BASE+0x13EA7)
#define REG_FRC_BK13E_A8        (REG_FRC_BANK_BASE+0x13EA8)
#define REG_FRC_BK13E_A9        (REG_FRC_BANK_BASE+0x13EA9)
#define REG_FRC_BK13E_AA        (REG_FRC_BANK_BASE+0x13EAA)
#define REG_FRC_BK13E_AB        (REG_FRC_BANK_BASE+0x13EAB)
#define REG_FRC_BK13E_AC        (REG_FRC_BANK_BASE+0x13EAC)
#define REG_FRC_BK13E_AD        (REG_FRC_BANK_BASE+0x13EAD)
#define REG_FRC_BK13E_AE        (REG_FRC_BANK_BASE+0x13EAE)
#define REG_FRC_BK13E_AF        (REG_FRC_BANK_BASE+0x13EAF)
#define REG_FRC_BK13E_B0        (REG_FRC_BANK_BASE+0x13EB0)
#define REG_FRC_BK13E_B1        (REG_FRC_BANK_BASE+0x13EB1)
#define REG_FRC_BK13E_B2        (REG_FRC_BANK_BASE+0x13EB2)
#define REG_FRC_BK13E_B3        (REG_FRC_BANK_BASE+0x13EB3)
#define REG_FRC_BK13E_B4        (REG_FRC_BANK_BASE+0x13EB4)
#define REG_FRC_BK13E_B5        (REG_FRC_BANK_BASE+0x13EB5)
#define REG_FRC_BK13E_B6        (REG_FRC_BANK_BASE+0x13EB6)
#define REG_FRC_BK13E_B7        (REG_FRC_BANK_BASE+0x13EB7)
#define REG_FRC_BK13E_B8        (REG_FRC_BANK_BASE+0x13EB8)
#define REG_FRC_BK13E_B9        (REG_FRC_BANK_BASE+0x13EB9)
#define REG_FRC_BK13E_BA        (REG_FRC_BANK_BASE+0x13EBA)
#define REG_FRC_BK13E_BB        (REG_FRC_BANK_BASE+0x13EBB)
#define REG_FRC_BK13E_BC        (REG_FRC_BANK_BASE+0x13EBC)
#define REG_FRC_BK13E_BD        (REG_FRC_BANK_BASE+0x13EBD)
#define REG_FRC_BK13E_BE        (REG_FRC_BANK_BASE+0x13EBE)
#define REG_FRC_BK13E_BF        (REG_FRC_BANK_BASE+0x13EBF)
#define REG_FRC_BK13E_C0        (REG_FRC_BANK_BASE+0x13EC0)
#define REG_FRC_BK13E_C1        (REG_FRC_BANK_BASE+0x13EC1)
#define REG_FRC_BK13E_C2        (REG_FRC_BANK_BASE+0x13EC2)
#define REG_FRC_BK13E_C3        (REG_FRC_BANK_BASE+0x13EC3)
#define REG_FRC_BK13E_C4        (REG_FRC_BANK_BASE+0x13EC4)
#define REG_FRC_BK13E_C5        (REG_FRC_BANK_BASE+0x13EC5)
#define REG_FRC_BK13E_C6        (REG_FRC_BANK_BASE+0x13EC6)
#define REG_FRC_BK13E_C7        (REG_FRC_BANK_BASE+0x13EC7)
#define REG_FRC_BK13E_C8        (REG_FRC_BANK_BASE+0x13EC8)
#define REG_FRC_BK13E_C9        (REG_FRC_BANK_BASE+0x13EC9)
#define REG_FRC_BK13E_CA        (REG_FRC_BANK_BASE+0x13ECA)
#define REG_FRC_BK13E_CB        (REG_FRC_BANK_BASE+0x13ECB)
#define REG_FRC_BK13E_CC        (REG_FRC_BANK_BASE+0x13ECC)
#define REG_FRC_BK13E_CD        (REG_FRC_BANK_BASE+0x13ECD)
#define REG_FRC_BK13E_CE        (REG_FRC_BANK_BASE+0x13ECE)
#define REG_FRC_BK13E_CF        (REG_FRC_BANK_BASE+0x13ECF)
#define REG_FRC_BK13E_D0        (REG_FRC_BANK_BASE+0x13ED0)
#define REG_FRC_BK13E_D1        (REG_FRC_BANK_BASE+0x13ED1)
#define REG_FRC_BK13E_D2        (REG_FRC_BANK_BASE+0x13ED2)
#define REG_FRC_BK13E_D3        (REG_FRC_BANK_BASE+0x13ED3)
#define REG_FRC_BK13E_D4        (REG_FRC_BANK_BASE+0x13ED4)
#define REG_FRC_BK13E_D5        (REG_FRC_BANK_BASE+0x13ED5)
#define REG_FRC_BK13E_D6        (REG_FRC_BANK_BASE+0x13ED6)
#define REG_FRC_BK13E_D7        (REG_FRC_BANK_BASE+0x13ED7)
#define REG_FRC_BK13E_D8        (REG_FRC_BANK_BASE+0x13ED8)
#define REG_FRC_BK13E_D9        (REG_FRC_BANK_BASE+0x13ED9)
#define REG_FRC_BK13E_DA        (REG_FRC_BANK_BASE+0x13EDA)
#define REG_FRC_BK13E_DB        (REG_FRC_BANK_BASE+0x13EDB)
#define REG_FRC_BK13E_DC        (REG_FRC_BANK_BASE+0x13EDC)
#define REG_FRC_BK13E_DD        (REG_FRC_BANK_BASE+0x13EDD)
#define REG_FRC_BK13E_DE        (REG_FRC_BANK_BASE+0x13EDE)
#define REG_FRC_BK13E_DF        (REG_FRC_BANK_BASE+0x13EDF)
#define REG_FRC_BK13E_E0        (REG_FRC_BANK_BASE+0x13EE0)
#define REG_FRC_BK13E_E1        (REG_FRC_BANK_BASE+0x13EE1)
#define REG_FRC_BK13E_E2        (REG_FRC_BANK_BASE+0x13EE2)
#define REG_FRC_BK13E_E3        (REG_FRC_BANK_BASE+0x13EE3)
#define REG_FRC_BK13E_E4        (REG_FRC_BANK_BASE+0x13EE4)
#define REG_FRC_BK13E_E5        (REG_FRC_BANK_BASE+0x13EE5)
#define REG_FRC_BK13E_E6        (REG_FRC_BANK_BASE+0x13EE6)
#define REG_FRC_BK13E_E7        (REG_FRC_BANK_BASE+0x13EE7)
#define REG_FRC_BK13E_E8        (REG_FRC_BANK_BASE+0x13EE8)
#define REG_FRC_BK13E_E9        (REG_FRC_BANK_BASE+0x13EE9)
#define REG_FRC_BK13E_EA        (REG_FRC_BANK_BASE+0x13EEA)
#define REG_FRC_BK13E_EB        (REG_FRC_BANK_BASE+0x13EEB)
#define REG_FRC_BK13E_EC        (REG_FRC_BANK_BASE+0x13EEC)
#define REG_FRC_BK13E_ED        (REG_FRC_BANK_BASE+0x13EED)
#define REG_FRC_BK13E_EE        (REG_FRC_BANK_BASE+0x13EEE)
#define REG_FRC_BK13E_EF        (REG_FRC_BANK_BASE+0x13EEF)
#define REG_FRC_BK13E_F0        (REG_FRC_BANK_BASE+0x13EF0)
#define REG_FRC_BK13E_F1        (REG_FRC_BANK_BASE+0x13EF1)
#define REG_FRC_BK13E_F2        (REG_FRC_BANK_BASE+0x13EF2)
#define REG_FRC_BK13E_F3        (REG_FRC_BANK_BASE+0x13EF3)
#define REG_FRC_BK13E_F4        (REG_FRC_BANK_BASE+0x13EF4)
#define REG_FRC_BK13E_F5        (REG_FRC_BANK_BASE+0x13EF5)
#define REG_FRC_BK13E_F6        (REG_FRC_BANK_BASE+0x13EF6)
#define REG_FRC_BK13E_F7        (REG_FRC_BANK_BASE+0x13EF7)
#define REG_FRC_BK13E_F8        (REG_FRC_BANK_BASE+0x13EF8)
#define REG_FRC_BK13E_F9        (REG_FRC_BANK_BASE+0x13EF9)
#define REG_FRC_BK13E_FA        (REG_FRC_BANK_BASE+0x13EFA)
#define REG_FRC_BK13E_FB        (REG_FRC_BANK_BASE+0x13EFB)
#define REG_FRC_BK13E_FC        (REG_FRC_BANK_BASE+0x13EFC)
#define REG_FRC_BK13E_FD        (REG_FRC_BANK_BASE+0x13EFD)
#define REG_FRC_BK13E_FE        (REG_FRC_BANK_BASE+0x13EFE)
#define REG_FRC_BK13E_FF        (REG_FRC_BANK_BASE+0x13EFF)

// === FRC bk20A
#define REG_FRC_BK20A_00        (REG_FRC_BANK_BASE+0x20A00)
#define REG_FRC_BK20A_01        (REG_FRC_BANK_BASE+0x20A01)
#define REG_FRC_BK20A_02        (REG_FRC_BANK_BASE+0x20A02)
#define REG_FRC_BK20A_03        (REG_FRC_BANK_BASE+0x20A03)
#define REG_FRC_BK20A_04        (REG_FRC_BANK_BASE+0x20A04)
#define REG_FRC_BK20A_05        (REG_FRC_BANK_BASE+0x20A05)
#define REG_FRC_BK20A_06        (REG_FRC_BANK_BASE+0x20A06)
#define REG_FRC_BK20A_07        (REG_FRC_BANK_BASE+0x20A07)
#define REG_FRC_BK20A_08        (REG_FRC_BANK_BASE+0x20A08)
#define REG_FRC_BK20A_09        (REG_FRC_BANK_BASE+0x20A09)
#define REG_FRC_BK20A_0A        (REG_FRC_BANK_BASE+0x20A0A)
#define REG_FRC_BK20A_0B        (REG_FRC_BANK_BASE+0x20A0B)
#define REG_FRC_BK20A_0C        (REG_FRC_BANK_BASE+0x20A0C)
#define REG_FRC_BK20A_0D        (REG_FRC_BANK_BASE+0x20A0D)
#define REG_FRC_BK20A_0E        (REG_FRC_BANK_BASE+0x20A0E)
#define REG_FRC_BK20A_0F        (REG_FRC_BANK_BASE+0x20A0F)
#define REG_FRC_BK20A_10        (REG_FRC_BANK_BASE+0x20A10)
#define REG_FRC_BK20A_11        (REG_FRC_BANK_BASE+0x20A11)
#define REG_FRC_BK20A_12        (REG_FRC_BANK_BASE+0x20A12)
#define REG_FRC_BK20A_13        (REG_FRC_BANK_BASE+0x20A13)
#define REG_FRC_BK20A_14        (REG_FRC_BANK_BASE+0x20A14)
#define REG_FRC_BK20A_15        (REG_FRC_BANK_BASE+0x20A15)
#define REG_FRC_BK20A_16        (REG_FRC_BANK_BASE+0x20A16)
#define REG_FRC_BK20A_17        (REG_FRC_BANK_BASE+0x20A17)
#define REG_FRC_BK20A_18        (REG_FRC_BANK_BASE+0x20A18)
#define REG_FRC_BK20A_19        (REG_FRC_BANK_BASE+0x20A19)
#define REG_FRC_BK20A_1A        (REG_FRC_BANK_BASE+0x20A1A)
#define REG_FRC_BK20A_1B        (REG_FRC_BANK_BASE+0x20A1B)
#define REG_FRC_BK20A_1C        (REG_FRC_BANK_BASE+0x20A1C)
#define REG_FRC_BK20A_1D        (REG_FRC_BANK_BASE+0x20A1D)
#define REG_FRC_BK20A_1E        (REG_FRC_BANK_BASE+0x20A1E)
#define REG_FRC_BK20A_1F        (REG_FRC_BANK_BASE+0x20A1F)
#define REG_FRC_BK20A_20        (REG_FRC_BANK_BASE+0x20A20)
#define REG_FRC_BK20A_21        (REG_FRC_BANK_BASE+0x20A21)
#define REG_FRC_BK20A_22        (REG_FRC_BANK_BASE+0x20A22)
#define REG_FRC_BK20A_23        (REG_FRC_BANK_BASE+0x20A23)
#define REG_FRC_BK20A_24        (REG_FRC_BANK_BASE+0x20A24)
#define REG_FRC_BK20A_25        (REG_FRC_BANK_BASE+0x20A25)
#define REG_FRC_BK20A_26        (REG_FRC_BANK_BASE+0x20A26)
#define REG_FRC_BK20A_27        (REG_FRC_BANK_BASE+0x20A27)
#define REG_FRC_BK20A_28        (REG_FRC_BANK_BASE+0x20A28)
#define REG_FRC_BK20A_29        (REG_FRC_BANK_BASE+0x20A29)
#define REG_FRC_BK20A_2A        (REG_FRC_BANK_BASE+0x20A2A)
#define REG_FRC_BK20A_2B        (REG_FRC_BANK_BASE+0x20A2B)
#define REG_FRC_BK20A_2C        (REG_FRC_BANK_BASE+0x20A2C)
#define REG_FRC_BK20A_2D        (REG_FRC_BANK_BASE+0x20A2D)
#define REG_FRC_BK20A_2E        (REG_FRC_BANK_BASE+0x20A2E)
#define REG_FRC_BK20A_2F        (REG_FRC_BANK_BASE+0x20A2F)
#define REG_FRC_BK20A_30        (REG_FRC_BANK_BASE+0x20A30)
#define REG_FRC_BK20A_31        (REG_FRC_BANK_BASE+0x20A31)
#define REG_FRC_BK20A_32        (REG_FRC_BANK_BASE+0x20A32)
#define REG_FRC_BK20A_33        (REG_FRC_BANK_BASE+0x20A33)
#define REG_FRC_BK20A_34        (REG_FRC_BANK_BASE+0x20A34)
#define REG_FRC_BK20A_35        (REG_FRC_BANK_BASE+0x20A35)
#define REG_FRC_BK20A_36        (REG_FRC_BANK_BASE+0x20A36)
#define REG_FRC_BK20A_37        (REG_FRC_BANK_BASE+0x20A37)
#define REG_FRC_BK20A_38        (REG_FRC_BANK_BASE+0x20A38)
#define REG_FRC_BK20A_39        (REG_FRC_BANK_BASE+0x20A39)
#define REG_FRC_BK20A_3A        (REG_FRC_BANK_BASE+0x20A3A)
#define REG_FRC_BK20A_3B        (REG_FRC_BANK_BASE+0x20A3B)
#define REG_FRC_BK20A_3C        (REG_FRC_BANK_BASE+0x20A3C)
#define REG_FRC_BK20A_3D        (REG_FRC_BANK_BASE+0x20A3D)
#define REG_FRC_BK20A_3E        (REG_FRC_BANK_BASE+0x20A3E)
#define REG_FRC_BK20A_3F        (REG_FRC_BANK_BASE+0x20A3F)
#define REG_FRC_BK20A_40        (REG_FRC_BANK_BASE+0x20A40)
#define REG_FRC_BK20A_41        (REG_FRC_BANK_BASE+0x20A41)
#define REG_FRC_BK20A_42        (REG_FRC_BANK_BASE+0x20A42)
#define REG_FRC_BK20A_43        (REG_FRC_BANK_BASE+0x20A43)
#define REG_FRC_BK20A_44        (REG_FRC_BANK_BASE+0x20A44)
#define REG_FRC_BK20A_45        (REG_FRC_BANK_BASE+0x20A45)
#define REG_FRC_BK20A_46        (REG_FRC_BANK_BASE+0x20A46)
#define REG_FRC_BK20A_47        (REG_FRC_BANK_BASE+0x20A47)
#define REG_FRC_BK20A_48        (REG_FRC_BANK_BASE+0x20A48)
#define REG_FRC_BK20A_49        (REG_FRC_BANK_BASE+0x20A49)
#define REG_FRC_BK20A_4A        (REG_FRC_BANK_BASE+0x20A4A)
#define REG_FRC_BK20A_4B        (REG_FRC_BANK_BASE+0x20A4B)
#define REG_FRC_BK20A_4C        (REG_FRC_BANK_BASE+0x20A4C)
#define REG_FRC_BK20A_4D        (REG_FRC_BANK_BASE+0x20A4D)
#define REG_FRC_BK20A_4E        (REG_FRC_BANK_BASE+0x20A4E)
#define REG_FRC_BK20A_4F        (REG_FRC_BANK_BASE+0x20A4F)
#define REG_FRC_BK20A_50        (REG_FRC_BANK_BASE+0x20A50)
#define REG_FRC_BK20A_51        (REG_FRC_BANK_BASE+0x20A51)
#define REG_FRC_BK20A_52        (REG_FRC_BANK_BASE+0x20A52)
#define REG_FRC_BK20A_53        (REG_FRC_BANK_BASE+0x20A53)
#define REG_FRC_BK20A_54        (REG_FRC_BANK_BASE+0x20A54)
#define REG_FRC_BK20A_55        (REG_FRC_BANK_BASE+0x20A55)
#define REG_FRC_BK20A_56        (REG_FRC_BANK_BASE+0x20A56)
#define REG_FRC_BK20A_57        (REG_FRC_BANK_BASE+0x20A57)
#define REG_FRC_BK20A_58        (REG_FRC_BANK_BASE+0x20A58)
#define REG_FRC_BK20A_59        (REG_FRC_BANK_BASE+0x20A59)
#define REG_FRC_BK20A_5A        (REG_FRC_BANK_BASE+0x20A5A)
#define REG_FRC_BK20A_5B        (REG_FRC_BANK_BASE+0x20A5B)
#define REG_FRC_BK20A_5C        (REG_FRC_BANK_BASE+0x20A5C)
#define REG_FRC_BK20A_5D        (REG_FRC_BANK_BASE+0x20A5D)
#define REG_FRC_BK20A_5E        (REG_FRC_BANK_BASE+0x20A5E)
#define REG_FRC_BK20A_5F        (REG_FRC_BANK_BASE+0x20A5F)
#define REG_FRC_BK20A_60        (REG_FRC_BANK_BASE+0x20A60)
#define REG_FRC_BK20A_61        (REG_FRC_BANK_BASE+0x20A61)
#define REG_FRC_BK20A_62        (REG_FRC_BANK_BASE+0x20A62)
#define REG_FRC_BK20A_63        (REG_FRC_BANK_BASE+0x20A63)
#define REG_FRC_BK20A_64        (REG_FRC_BANK_BASE+0x20A64)
#define REG_FRC_BK20A_65        (REG_FRC_BANK_BASE+0x20A65)
#define REG_FRC_BK20A_66        (REG_FRC_BANK_BASE+0x20A66)
#define REG_FRC_BK20A_67        (REG_FRC_BANK_BASE+0x20A67)
#define REG_FRC_BK20A_68        (REG_FRC_BANK_BASE+0x20A68)
#define REG_FRC_BK20A_69        (REG_FRC_BANK_BASE+0x20A69)
#define REG_FRC_BK20A_6A        (REG_FRC_BANK_BASE+0x20A6A)
#define REG_FRC_BK20A_6B        (REG_FRC_BANK_BASE+0x20A6B)
#define REG_FRC_BK20A_6C        (REG_FRC_BANK_BASE+0x20A6C)
#define REG_FRC_BK20A_6D        (REG_FRC_BANK_BASE+0x20A6D)
#define REG_FRC_BK20A_6E        (REG_FRC_BANK_BASE+0x20A6E)
#define REG_FRC_BK20A_6F        (REG_FRC_BANK_BASE+0x20A6F)
#define REG_FRC_BK20A_70        (REG_FRC_BANK_BASE+0x20A70)
#define REG_FRC_BK20A_71        (REG_FRC_BANK_BASE+0x20A71)
#define REG_FRC_BK20A_72        (REG_FRC_BANK_BASE+0x20A72)
#define REG_FRC_BK20A_73        (REG_FRC_BANK_BASE+0x20A73)
#define REG_FRC_BK20A_74        (REG_FRC_BANK_BASE+0x20A74)
#define REG_FRC_BK20A_75        (REG_FRC_BANK_BASE+0x20A75)
#define REG_FRC_BK20A_76        (REG_FRC_BANK_BASE+0x20A76)
#define REG_FRC_BK20A_77        (REG_FRC_BANK_BASE+0x20A77)
#define REG_FRC_BK20A_78        (REG_FRC_BANK_BASE+0x20A78)
#define REG_FRC_BK20A_79        (REG_FRC_BANK_BASE+0x20A79)
#define REG_FRC_BK20A_7A        (REG_FRC_BANK_BASE+0x20A7A)
#define REG_FRC_BK20A_7B        (REG_FRC_BANK_BASE+0x20A7B)
#define REG_FRC_BK20A_7C        (REG_FRC_BANK_BASE+0x20A7C)
#define REG_FRC_BK20A_7D        (REG_FRC_BANK_BASE+0x20A7D)
#define REG_FRC_BK20A_7E        (REG_FRC_BANK_BASE+0x20A7E)
#define REG_FRC_BK20A_7F        (REG_FRC_BANK_BASE+0x20A7F)
#define REG_FRC_BK20A_80        (REG_FRC_BANK_BASE+0x20A80)
#define REG_FRC_BK20A_81        (REG_FRC_BANK_BASE+0x20A81)
#define REG_FRC_BK20A_82        (REG_FRC_BANK_BASE+0x20A82)
#define REG_FRC_BK20A_83        (REG_FRC_BANK_BASE+0x20A83)
#define REG_FRC_BK20A_84        (REG_FRC_BANK_BASE+0x20A84)
#define REG_FRC_BK20A_85        (REG_FRC_BANK_BASE+0x20A85)
#define REG_FRC_BK20A_86        (REG_FRC_BANK_BASE+0x20A86)
#define REG_FRC_BK20A_87        (REG_FRC_BANK_BASE+0x20A87)
#define REG_FRC_BK20A_88        (REG_FRC_BANK_BASE+0x20A88)
#define REG_FRC_BK20A_89        (REG_FRC_BANK_BASE+0x20A89)
#define REG_FRC_BK20A_8A        (REG_FRC_BANK_BASE+0x20A8A)
#define REG_FRC_BK20A_8B        (REG_FRC_BANK_BASE+0x20A8B)
#define REG_FRC_BK20A_8C        (REG_FRC_BANK_BASE+0x20A8C)
#define REG_FRC_BK20A_8D        (REG_FRC_BANK_BASE+0x20A8D)
#define REG_FRC_BK20A_8E        (REG_FRC_BANK_BASE+0x20A8E)
#define REG_FRC_BK20A_8F        (REG_FRC_BANK_BASE+0x20A8F)
#define REG_FRC_BK20A_90        (REG_FRC_BANK_BASE+0x20A90)
#define REG_FRC_BK20A_91        (REG_FRC_BANK_BASE+0x20A91)
#define REG_FRC_BK20A_92        (REG_FRC_BANK_BASE+0x20A92)
#define REG_FRC_BK20A_93        (REG_FRC_BANK_BASE+0x20A93)
#define REG_FRC_BK20A_94        (REG_FRC_BANK_BASE+0x20A94)
#define REG_FRC_BK20A_95        (REG_FRC_BANK_BASE+0x20A95)
#define REG_FRC_BK20A_96        (REG_FRC_BANK_BASE+0x20A96)
#define REG_FRC_BK20A_97        (REG_FRC_BANK_BASE+0x20A97)
#define REG_FRC_BK20A_98        (REG_FRC_BANK_BASE+0x20A98)
#define REG_FRC_BK20A_99        (REG_FRC_BANK_BASE+0x20A99)
#define REG_FRC_BK20A_9A        (REG_FRC_BANK_BASE+0x20A9A)
#define REG_FRC_BK20A_9B        (REG_FRC_BANK_BASE+0x20A9B)
#define REG_FRC_BK20A_9C        (REG_FRC_BANK_BASE+0x20A9C)
#define REG_FRC_BK20A_9D        (REG_FRC_BANK_BASE+0x20A9D)
#define REG_FRC_BK20A_9E        (REG_FRC_BANK_BASE+0x20A9E)
#define REG_FRC_BK20A_9F        (REG_FRC_BANK_BASE+0x20A9F)
#define REG_FRC_BK20A_A0        (REG_FRC_BANK_BASE+0x20AA0)
#define REG_FRC_BK20A_A1        (REG_FRC_BANK_BASE+0x20AA1)
#define REG_FRC_BK20A_A2        (REG_FRC_BANK_BASE+0x20AA2)
#define REG_FRC_BK20A_A3        (REG_FRC_BANK_BASE+0x20AA3)
#define REG_FRC_BK20A_A4        (REG_FRC_BANK_BASE+0x20AA4)
#define REG_FRC_BK20A_A5        (REG_FRC_BANK_BASE+0x20AA5)
#define REG_FRC_BK20A_A6        (REG_FRC_BANK_BASE+0x20AA6)
#define REG_FRC_BK20A_A7        (REG_FRC_BANK_BASE+0x20AA7)
#define REG_FRC_BK20A_A8        (REG_FRC_BANK_BASE+0x20AA8)
#define REG_FRC_BK20A_A9        (REG_FRC_BANK_BASE+0x20AA9)
#define REG_FRC_BK20A_AA        (REG_FRC_BANK_BASE+0x20AAA)
#define REG_FRC_BK20A_AB        (REG_FRC_BANK_BASE+0x20AAB)
#define REG_FRC_BK20A_AC        (REG_FRC_BANK_BASE+0x20AAC)
#define REG_FRC_BK20A_AD        (REG_FRC_BANK_BASE+0x20AAD)
#define REG_FRC_BK20A_AE        (REG_FRC_BANK_BASE+0x20AAE)
#define REG_FRC_BK20A_AF        (REG_FRC_BANK_BASE+0x20AAF)
#define REG_FRC_BK20A_B0        (REG_FRC_BANK_BASE+0x20AB0)
#define REG_FRC_BK20A_B1        (REG_FRC_BANK_BASE+0x20AB1)
#define REG_FRC_BK20A_B2        (REG_FRC_BANK_BASE+0x20AB2)
#define REG_FRC_BK20A_B3        (REG_FRC_BANK_BASE+0x20AB3)
#define REG_FRC_BK20A_B4        (REG_FRC_BANK_BASE+0x20AB4)
#define REG_FRC_BK20A_B5        (REG_FRC_BANK_BASE+0x20AB5)
#define REG_FRC_BK20A_B6        (REG_FRC_BANK_BASE+0x20AB6)
#define REG_FRC_BK20A_B7        (REG_FRC_BANK_BASE+0x20AB7)
#define REG_FRC_BK20A_B8        (REG_FRC_BANK_BASE+0x20AB8)
#define REG_FRC_BK20A_B9        (REG_FRC_BANK_BASE+0x20AB9)
#define REG_FRC_BK20A_BA        (REG_FRC_BANK_BASE+0x20ABA)
#define REG_FRC_BK20A_BB        (REG_FRC_BANK_BASE+0x20ABB)
#define REG_FRC_BK20A_BC        (REG_FRC_BANK_BASE+0x20ABC)
#define REG_FRC_BK20A_BD        (REG_FRC_BANK_BASE+0x20ABD)
#define REG_FRC_BK20A_BE        (REG_FRC_BANK_BASE+0x20ABE)
#define REG_FRC_BK20A_BF        (REG_FRC_BANK_BASE+0x20ABF)
#define REG_FRC_BK20A_C0        (REG_FRC_BANK_BASE+0x20AC0)
#define REG_FRC_BK20A_C1        (REG_FRC_BANK_BASE+0x20AC1)
#define REG_FRC_BK20A_C2        (REG_FRC_BANK_BASE+0x20AC2)
#define REG_FRC_BK20A_C3        (REG_FRC_BANK_BASE+0x20AC3)
#define REG_FRC_BK20A_C4        (REG_FRC_BANK_BASE+0x20AC4)
#define REG_FRC_BK20A_C5        (REG_FRC_BANK_BASE+0x20AC5)
#define REG_FRC_BK20A_C6        (REG_FRC_BANK_BASE+0x20AC6)
#define REG_FRC_BK20A_C7        (REG_FRC_BANK_BASE+0x20AC7)
#define REG_FRC_BK20A_C8        (REG_FRC_BANK_BASE+0x20AC8)
#define REG_FRC_BK20A_C9        (REG_FRC_BANK_BASE+0x20AC9)
#define REG_FRC_BK20A_CA        (REG_FRC_BANK_BASE+0x20ACA)
#define REG_FRC_BK20A_CB        (REG_FRC_BANK_BASE+0x20ACB)
#define REG_FRC_BK20A_CC        (REG_FRC_BANK_BASE+0x20ACC)
#define REG_FRC_BK20A_CD        (REG_FRC_BANK_BASE+0x20ACD)
#define REG_FRC_BK20A_CE        (REG_FRC_BANK_BASE+0x20ACE)
#define REG_FRC_BK20A_CF        (REG_FRC_BANK_BASE+0x20ACF)
#define REG_FRC_BK20A_D0        (REG_FRC_BANK_BASE+0x20AD0)
#define REG_FRC_BK20A_D1        (REG_FRC_BANK_BASE+0x20AD1)
#define REG_FRC_BK20A_D2        (REG_FRC_BANK_BASE+0x20AD2)
#define REG_FRC_BK20A_D3        (REG_FRC_BANK_BASE+0x20AD3)
#define REG_FRC_BK20A_D4        (REG_FRC_BANK_BASE+0x20AD4)
#define REG_FRC_BK20A_D5        (REG_FRC_BANK_BASE+0x20AD5)
#define REG_FRC_BK20A_D6        (REG_FRC_BANK_BASE+0x20AD6)
#define REG_FRC_BK20A_D7        (REG_FRC_BANK_BASE+0x20AD7)
#define REG_FRC_BK20A_D8        (REG_FRC_BANK_BASE+0x20AD8)
#define REG_FRC_BK20A_D9        (REG_FRC_BANK_BASE+0x20AD9)
#define REG_FRC_BK20A_DA        (REG_FRC_BANK_BASE+0x20ADA)
#define REG_FRC_BK20A_DB        (REG_FRC_BANK_BASE+0x20ADB)
#define REG_FRC_BK20A_DC        (REG_FRC_BANK_BASE+0x20ADC)
#define REG_FRC_BK20A_DD        (REG_FRC_BANK_BASE+0x20ADD)
#define REG_FRC_BK20A_DE        (REG_FRC_BANK_BASE+0x20ADE)
#define REG_FRC_BK20A_DF        (REG_FRC_BANK_BASE+0x20ADF)
#define REG_FRC_BK20A_E0        (REG_FRC_BANK_BASE+0x20AE0)
#define REG_FRC_BK20A_E1        (REG_FRC_BANK_BASE+0x20AE1)
#define REG_FRC_BK20A_E2        (REG_FRC_BANK_BASE+0x20AE2)
#define REG_FRC_BK20A_E3        (REG_FRC_BANK_BASE+0x20AE3)
#define REG_FRC_BK20A_E4        (REG_FRC_BANK_BASE+0x20AE4)
#define REG_FRC_BK20A_E5        (REG_FRC_BANK_BASE+0x20AE5)
#define REG_FRC_BK20A_E6        (REG_FRC_BANK_BASE+0x20AE6)
#define REG_FRC_BK20A_E7        (REG_FRC_BANK_BASE+0x20AE7)
#define REG_FRC_BK20A_E8        (REG_FRC_BANK_BASE+0x20AE8)
#define REG_FRC_BK20A_E9        (REG_FRC_BANK_BASE+0x20AE9)
#define REG_FRC_BK20A_EA        (REG_FRC_BANK_BASE+0x20AEA)
#define REG_FRC_BK20A_EB        (REG_FRC_BANK_BASE+0x20AEB)
#define REG_FRC_BK20A_EC        (REG_FRC_BANK_BASE+0x20AEC)
#define REG_FRC_BK20A_ED        (REG_FRC_BANK_BASE+0x20AED)
#define REG_FRC_BK20A_EE        (REG_FRC_BANK_BASE+0x20AEE)
#define REG_FRC_BK20A_EF        (REG_FRC_BANK_BASE+0x20AEF)
#define REG_FRC_BK20A_F0        (REG_FRC_BANK_BASE+0x20AF0)
#define REG_FRC_BK20A_F1        (REG_FRC_BANK_BASE+0x20AF1)
#define REG_FRC_BK20A_F2        (REG_FRC_BANK_BASE+0x20AF2)
#define REG_FRC_BK20A_F3        (REG_FRC_BANK_BASE+0x20AF3)
#define REG_FRC_BK20A_F4        (REG_FRC_BANK_BASE+0x20AF4)
#define REG_FRC_BK20A_F5        (REG_FRC_BANK_BASE+0x20AF5)
#define REG_FRC_BK20A_F6        (REG_FRC_BANK_BASE+0x20AF6)
#define REG_FRC_BK20A_F7        (REG_FRC_BANK_BASE+0x20AF7)
#define REG_FRC_BK20A_F8        (REG_FRC_BANK_BASE+0x20AF8)
#define REG_FRC_BK20A_F9        (REG_FRC_BANK_BASE+0x20AF9)
#define REG_FRC_BK20A_FA        (REG_FRC_BANK_BASE+0x20AFA)
#define REG_FRC_BK20A_FB        (REG_FRC_BANK_BASE+0x20AFB)
#define REG_FRC_BK20A_FC        (REG_FRC_BANK_BASE+0x20AFC)
#define REG_FRC_BK20A_FD        (REG_FRC_BANK_BASE+0x20AFD)
#define REG_FRC_BK20A_FE        (REG_FRC_BANK_BASE+0x20AFE)
#define REG_FRC_BK20A_FF        (REG_FRC_BANK_BASE+0x20AFF)

#define REG_FRC_BK246_60        (REG_FRC_BANK_BASE+0x24660)
#define REG_FRC_BK253_06        (REG_FRC_BANK_BASE+0x25306)

#define REG_FRC_BK31B_10        (REG_FRC_BANK_BASE+0x31B10)

// === FRC bk4320
#define REG_FRC_BK320_00        (REG_FRC_BANK_BASE+0x32000)
#define REG_FRC_BK320_01        (REG_FRC_BANK_BASE+0x32001)
#define REG_FRC_BK320_02        (REG_FRC_BANK_BASE+0x32002)
#define REG_FRC_BK320_03        (REG_FRC_BANK_BASE+0x32003)
#define REG_FRC_BK320_04        (REG_FRC_BANK_BASE+0x32004)
#define REG_FRC_BK320_05        (REG_FRC_BANK_BASE+0x32005)
#define REG_FRC_BK320_06        (REG_FRC_BANK_BASE+0x32006)
#define REG_FRC_BK320_07        (REG_FRC_BANK_BASE+0x32007)
#define REG_FRC_BK320_08        (REG_FRC_BANK_BASE+0x32008)
#define REG_FRC_BK320_09        (REG_FRC_BANK_BASE+0x32009)
#define REG_FRC_BK320_0A        (REG_FRC_BANK_BASE+0x3200A)
#define REG_FRC_BK320_0B        (REG_FRC_BANK_BASE+0x3200B)
#define REG_FRC_BK320_0C        (REG_FRC_BANK_BASE+0x3200C)
#define REG_FRC_BK320_0D        (REG_FRC_BANK_BASE+0x3200D)
#define REG_FRC_BK320_0E        (REG_FRC_BANK_BASE+0x3200E)
#define REG_FRC_BK320_0F        (REG_FRC_BANK_BASE+0x3200F)
#define REG_FRC_BK320_10        (REG_FRC_BANK_BASE+0x32010)
#define REG_FRC_BK320_11        (REG_FRC_BANK_BASE+0x32011)
#define REG_FRC_BK320_12        (REG_FRC_BANK_BASE+0x32012)
#define REG_FRC_BK320_13        (REG_FRC_BANK_BASE+0x32013)
#define REG_FRC_BK320_14        (REG_FRC_BANK_BASE+0x32014)
#define REG_FRC_BK320_15        (REG_FRC_BANK_BASE+0x32015)
#define REG_FRC_BK320_16        (REG_FRC_BANK_BASE+0x32016)
#define REG_FRC_BK320_17        (REG_FRC_BANK_BASE+0x32017)
#define REG_FRC_BK320_18        (REG_FRC_BANK_BASE+0x32018)
#define REG_FRC_BK320_19        (REG_FRC_BANK_BASE+0x32019)
#define REG_FRC_BK320_1A        (REG_FRC_BANK_BASE+0x3201A)
#define REG_FRC_BK320_1B        (REG_FRC_BANK_BASE+0x3201B)
#define REG_FRC_BK320_1C        (REG_FRC_BANK_BASE+0x3201C)
#define REG_FRC_BK320_1D        (REG_FRC_BANK_BASE+0x3201D)
#define REG_FRC_BK320_1E        (REG_FRC_BANK_BASE+0x3201E)
#define REG_FRC_BK320_1F        (REG_FRC_BANK_BASE+0x3201F)
#define REG_FRC_BK320_20        (REG_FRC_BANK_BASE+0x32020)
#define REG_FRC_BK320_21        (REG_FRC_BANK_BASE+0x32021)
#define REG_FRC_BK320_22        (REG_FRC_BANK_BASE+0x32022)
#define REG_FRC_BK320_23        (REG_FRC_BANK_BASE+0x32023)
#define REG_FRC_BK320_24        (REG_FRC_BANK_BASE+0x32024)
#define REG_FRC_BK320_25        (REG_FRC_BANK_BASE+0x32025)
#define REG_FRC_BK320_26        (REG_FRC_BANK_BASE+0x32026)
#define REG_FRC_BK320_27        (REG_FRC_BANK_BASE+0x32027)
#define REG_FRC_BK320_28        (REG_FRC_BANK_BASE+0x32028)
#define REG_FRC_BK320_29        (REG_FRC_BANK_BASE+0x32029)
#define REG_FRC_BK320_2A        (REG_FRC_BANK_BASE+0x3202A)
#define REG_FRC_BK320_2B        (REG_FRC_BANK_BASE+0x3202B)
#define REG_FRC_BK320_2C        (REG_FRC_BANK_BASE+0x3202C)
#define REG_FRC_BK320_2D        (REG_FRC_BANK_BASE+0x3202D)
#define REG_FRC_BK320_2E        (REG_FRC_BANK_BASE+0x3202E)
#define REG_FRC_BK320_2F        (REG_FRC_BANK_BASE+0x3202F)
#define REG_FRC_BK320_30        (REG_FRC_BANK_BASE+0x32030)
#define REG_FRC_BK320_31        (REG_FRC_BANK_BASE+0x32031)
#define REG_FRC_BK320_32        (REG_FRC_BANK_BASE+0x32032)
#define REG_FRC_BK320_33        (REG_FRC_BANK_BASE+0x32033)
#define REG_FRC_BK320_34        (REG_FRC_BANK_BASE+0x32034)
#define REG_FRC_BK320_35        (REG_FRC_BANK_BASE+0x32035)
#define REG_FRC_BK320_36        (REG_FRC_BANK_BASE+0x32036)
#define REG_FRC_BK320_37        (REG_FRC_BANK_BASE+0x32037)
#define REG_FRC_BK320_38        (REG_FRC_BANK_BASE+0x32038)
#define REG_FRC_BK320_39        (REG_FRC_BANK_BASE+0x32039)
#define REG_FRC_BK320_3A        (REG_FRC_BANK_BASE+0x3203A)
#define REG_FRC_BK320_3B        (REG_FRC_BANK_BASE+0x3203B)
#define REG_FRC_BK320_3C        (REG_FRC_BANK_BASE+0x3203C)
#define REG_FRC_BK320_3D        (REG_FRC_BANK_BASE+0x3203D)
#define REG_FRC_BK320_3E        (REG_FRC_BANK_BASE+0x3203E)
#define REG_FRC_BK320_3F        (REG_FRC_BANK_BASE+0x3203F)
#define REG_FRC_BK320_40        (REG_FRC_BANK_BASE+0x32040)
#define REG_FRC_BK320_41        (REG_FRC_BANK_BASE+0x32041)
#define REG_FRC_BK320_42        (REG_FRC_BANK_BASE+0x32042)
#define REG_FRC_BK320_43        (REG_FRC_BANK_BASE+0x32043)
#define REG_FRC_BK320_44        (REG_FRC_BANK_BASE+0x32044)
#define REG_FRC_BK320_45        (REG_FRC_BANK_BASE+0x32045)
#define REG_FRC_BK320_46        (REG_FRC_BANK_BASE+0x32046)
#define REG_FRC_BK320_47        (REG_FRC_BANK_BASE+0x32047)
#define REG_FRC_BK320_48        (REG_FRC_BANK_BASE+0x32048)
#define REG_FRC_BK320_49        (REG_FRC_BANK_BASE+0x32049)
#define REG_FRC_BK320_4A        (REG_FRC_BANK_BASE+0x3204A)
#define REG_FRC_BK320_4B        (REG_FRC_BANK_BASE+0x3204B)
#define REG_FRC_BK320_4C        (REG_FRC_BANK_BASE+0x3204C)
#define REG_FRC_BK320_4D        (REG_FRC_BANK_BASE+0x3204D)
#define REG_FRC_BK320_4E        (REG_FRC_BANK_BASE+0x3204E)
#define REG_FRC_BK320_4F        (REG_FRC_BANK_BASE+0x3204F)
#define REG_FRC_BK320_50        (REG_FRC_BANK_BASE+0x32050)
#define REG_FRC_BK320_51        (REG_FRC_BANK_BASE+0x32051)
#define REG_FRC_BK320_52        (REG_FRC_BANK_BASE+0x32052)
#define REG_FRC_BK320_53        (REG_FRC_BANK_BASE+0x32053)
#define REG_FRC_BK320_54        (REG_FRC_BANK_BASE+0x32054)
#define REG_FRC_BK320_55        (REG_FRC_BANK_BASE+0x32055)
#define REG_FRC_BK320_56        (REG_FRC_BANK_BASE+0x32056)
#define REG_FRC_BK320_57        (REG_FRC_BANK_BASE+0x32057)
#define REG_FRC_BK320_58        (REG_FRC_BANK_BASE+0x32058)
#define REG_FRC_BK320_59        (REG_FRC_BANK_BASE+0x32059)
#define REG_FRC_BK320_5A        (REG_FRC_BANK_BASE+0x3205A)
#define REG_FRC_BK320_5B        (REG_FRC_BANK_BASE+0x3205B)
#define REG_FRC_BK320_5C        (REG_FRC_BANK_BASE+0x3205C)
#define REG_FRC_BK320_5D        (REG_FRC_BANK_BASE+0x3205D)
#define REG_FRC_BK320_5E        (REG_FRC_BANK_BASE+0x3205E)
#define REG_FRC_BK320_5F        (REG_FRC_BANK_BASE+0x3205F)
#define REG_FRC_BK320_60        (REG_FRC_BANK_BASE+0x32060)
#define REG_FRC_BK320_61        (REG_FRC_BANK_BASE+0x32061)
#define REG_FRC_BK320_62        (REG_FRC_BANK_BASE+0x32062)
#define REG_FRC_BK320_63        (REG_FRC_BANK_BASE+0x32063)
#define REG_FRC_BK320_64        (REG_FRC_BANK_BASE+0x32064)
#define REG_FRC_BK320_65        (REG_FRC_BANK_BASE+0x32065)
#define REG_FRC_BK320_66        (REG_FRC_BANK_BASE+0x32066)
#define REG_FRC_BK320_67        (REG_FRC_BANK_BASE+0x32067)
#define REG_FRC_BK320_68        (REG_FRC_BANK_BASE+0x32068)
#define REG_FRC_BK320_69        (REG_FRC_BANK_BASE+0x32069)
#define REG_FRC_BK320_6A        (REG_FRC_BANK_BASE+0x3206A)
#define REG_FRC_BK320_6B        (REG_FRC_BANK_BASE+0x3206B)
#define REG_FRC_BK320_6C        (REG_FRC_BANK_BASE+0x3206C)
#define REG_FRC_BK320_6D        (REG_FRC_BANK_BASE+0x3206D)
#define REG_FRC_BK320_6E        (REG_FRC_BANK_BASE+0x3206E)
#define REG_FRC_BK320_6F        (REG_FRC_BANK_BASE+0x3206F)
#define REG_FRC_BK320_70        (REG_FRC_BANK_BASE+0x32070)
#define REG_FRC_BK320_71        (REG_FRC_BANK_BASE+0x32071)
#define REG_FRC_BK320_72        (REG_FRC_BANK_BASE+0x32072)
#define REG_FRC_BK320_73        (REG_FRC_BANK_BASE+0x32073)
#define REG_FRC_BK320_74        (REG_FRC_BANK_BASE+0x32074)
#define REG_FRC_BK320_75        (REG_FRC_BANK_BASE+0x32075)
#define REG_FRC_BK320_76        (REG_FRC_BANK_BASE+0x32076)
#define REG_FRC_BK320_77        (REG_FRC_BANK_BASE+0x32077)
#define REG_FRC_BK320_78        (REG_FRC_BANK_BASE+0x32078)
#define REG_FRC_BK320_79        (REG_FRC_BANK_BASE+0x32079)
#define REG_FRC_BK320_7A        (REG_FRC_BANK_BASE+0x3207A)
#define REG_FRC_BK320_7B        (REG_FRC_BANK_BASE+0x3207B)
#define REG_FRC_BK320_7C        (REG_FRC_BANK_BASE+0x3207C)
#define REG_FRC_BK320_7D        (REG_FRC_BANK_BASE+0x3207D)
#define REG_FRC_BK320_7E        (REG_FRC_BANK_BASE+0x3207E)
#define REG_FRC_BK320_7F        (REG_FRC_BANK_BASE+0x3207F)
#define REG_FRC_BK320_80        (REG_FRC_BANK_BASE+0x32080)
#define REG_FRC_BK320_81        (REG_FRC_BANK_BASE+0x32081)
#define REG_FRC_BK320_82        (REG_FRC_BANK_BASE+0x32082)
#define REG_FRC_BK320_83        (REG_FRC_BANK_BASE+0x32083)
#define REG_FRC_BK320_84        (REG_FRC_BANK_BASE+0x32084)
#define REG_FRC_BK320_85        (REG_FRC_BANK_BASE+0x32085)
#define REG_FRC_BK320_86        (REG_FRC_BANK_BASE+0x32086)
#define REG_FRC_BK320_87        (REG_FRC_BANK_BASE+0x32087)
#define REG_FRC_BK320_88        (REG_FRC_BANK_BASE+0x32088)
#define REG_FRC_BK320_89        (REG_FRC_BANK_BASE+0x32089)
#define REG_FRC_BK320_8A        (REG_FRC_BANK_BASE+0x3208A)
#define REG_FRC_BK320_8B        (REG_FRC_BANK_BASE+0x3208B)
#define REG_FRC_BK320_8C        (REG_FRC_BANK_BASE+0x3208C)
#define REG_FRC_BK320_8D        (REG_FRC_BANK_BASE+0x3208D)
#define REG_FRC_BK320_8E        (REG_FRC_BANK_BASE+0x3208E)
#define REG_FRC_BK320_8F        (REG_FRC_BANK_BASE+0x3208F)
#define REG_FRC_BK320_90        (REG_FRC_BANK_BASE+0x32090)
#define REG_FRC_BK320_91        (REG_FRC_BANK_BASE+0x32091)
#define REG_FRC_BK320_92        (REG_FRC_BANK_BASE+0x32092)
#define REG_FRC_BK320_93        (REG_FRC_BANK_BASE+0x32093)
#define REG_FRC_BK320_94        (REG_FRC_BANK_BASE+0x32094)
#define REG_FRC_BK320_95        (REG_FRC_BANK_BASE+0x32095)
#define REG_FRC_BK320_96        (REG_FRC_BANK_BASE+0x32096)
#define REG_FRC_BK320_97        (REG_FRC_BANK_BASE+0x32097)
#define REG_FRC_BK320_98        (REG_FRC_BANK_BASE+0x32098)
#define REG_FRC_BK320_99        (REG_FRC_BANK_BASE+0x32099)
#define REG_FRC_BK320_9A        (REG_FRC_BANK_BASE+0x3209A)
#define REG_FRC_BK320_9B        (REG_FRC_BANK_BASE+0x3209B)
#define REG_FRC_BK320_9C        (REG_FRC_BANK_BASE+0x3209C)
#define REG_FRC_BK320_9D        (REG_FRC_BANK_BASE+0x3209D)
#define REG_FRC_BK320_9E        (REG_FRC_BANK_BASE+0x3209E)
#define REG_FRC_BK320_9F        (REG_FRC_BANK_BASE+0x3209F)
#define REG_FRC_BK320_A0        (REG_FRC_BANK_BASE+0x320A0)
#define REG_FRC_BK320_A1        (REG_FRC_BANK_BASE+0x320A1)
#define REG_FRC_BK320_A2        (REG_FRC_BANK_BASE+0x320A2)
#define REG_FRC_BK320_A3        (REG_FRC_BANK_BASE+0x320A3)
#define REG_FRC_BK320_A4        (REG_FRC_BANK_BASE+0x320A4)
#define REG_FRC_BK320_A5        (REG_FRC_BANK_BASE+0x320A5)
#define REG_FRC_BK320_A6        (REG_FRC_BANK_BASE+0x320A6)
#define REG_FRC_BK320_A7        (REG_FRC_BANK_BASE+0x320A7)
#define REG_FRC_BK320_A8        (REG_FRC_BANK_BASE+0x320A8)
#define REG_FRC_BK320_A9        (REG_FRC_BANK_BASE+0x320A9)
#define REG_FRC_BK320_AA        (REG_FRC_BANK_BASE+0x320AA)
#define REG_FRC_BK320_AB        (REG_FRC_BANK_BASE+0x320AB)
#define REG_FRC_BK320_AC        (REG_FRC_BANK_BASE+0x320AC)
#define REG_FRC_BK320_AD        (REG_FRC_BANK_BASE+0x320AD)
#define REG_FRC_BK320_AE        (REG_FRC_BANK_BASE+0x320AE)
#define REG_FRC_BK320_AF        (REG_FRC_BANK_BASE+0x320AF)
#define REG_FRC_BK320_B0        (REG_FRC_BANK_BASE+0x320B0)
#define REG_FRC_BK320_B1        (REG_FRC_BANK_BASE+0x320B1)
#define REG_FRC_BK320_B2        (REG_FRC_BANK_BASE+0x320B2)
#define REG_FRC_BK320_B3        (REG_FRC_BANK_BASE+0x320B3)
#define REG_FRC_BK320_B4        (REG_FRC_BANK_BASE+0x320B4)
#define REG_FRC_BK320_B5        (REG_FRC_BANK_BASE+0x320B5)
#define REG_FRC_BK320_B6        (REG_FRC_BANK_BASE+0x320B6)
#define REG_FRC_BK320_B7        (REG_FRC_BANK_BASE+0x320B7)
#define REG_FRC_BK320_B8        (REG_FRC_BANK_BASE+0x320B8)
#define REG_FRC_BK320_B9        (REG_FRC_BANK_BASE+0x320B9)
#define REG_FRC_BK320_BA        (REG_FRC_BANK_BASE+0x320BA)
#define REG_FRC_BK320_BB        (REG_FRC_BANK_BASE+0x320BB)
#define REG_FRC_BK320_BC        (REG_FRC_BANK_BASE+0x320BC)
#define REG_FRC_BK320_BD        (REG_FRC_BANK_BASE+0x320BD)
#define REG_FRC_BK320_BE        (REG_FRC_BANK_BASE+0x320BE)
#define REG_FRC_BK320_BF        (REG_FRC_BANK_BASE+0x320BF)
#define REG_FRC_BK320_C0        (REG_FRC_BANK_BASE+0x320C0)
#define REG_FRC_BK320_C1        (REG_FRC_BANK_BASE+0x320C1)
#define REG_FRC_BK320_C2        (REG_FRC_BANK_BASE+0x320C2)
#define REG_FRC_BK320_C3        (REG_FRC_BANK_BASE+0x320C3)
#define REG_FRC_BK320_C4        (REG_FRC_BANK_BASE+0x320C4)
#define REG_FRC_BK320_C5        (REG_FRC_BANK_BASE+0x320C5)
#define REG_FRC_BK320_C6        (REG_FRC_BANK_BASE+0x320C6)
#define REG_FRC_BK320_C7        (REG_FRC_BANK_BASE+0x320C7)
#define REG_FRC_BK320_C8        (REG_FRC_BANK_BASE+0x320C8)
#define REG_FRC_BK320_C9        (REG_FRC_BANK_BASE+0x320C9)
#define REG_FRC_BK320_CA        (REG_FRC_BANK_BASE+0x320CA)
#define REG_FRC_BK320_CB        (REG_FRC_BANK_BASE+0x320CB)
#define REG_FRC_BK320_CC        (REG_FRC_BANK_BASE+0x320CC)
#define REG_FRC_BK320_CD        (REG_FRC_BANK_BASE+0x320CD)
#define REG_FRC_BK320_CE        (REG_FRC_BANK_BASE+0x320CE)
#define REG_FRC_BK320_CF        (REG_FRC_BANK_BASE+0x320CF)
#define REG_FRC_BK320_D0        (REG_FRC_BANK_BASE+0x320D0)
#define REG_FRC_BK320_D1        (REG_FRC_BANK_BASE+0x320D1)
#define REG_FRC_BK320_D2        (REG_FRC_BANK_BASE+0x320D2)
#define REG_FRC_BK320_D3        (REG_FRC_BANK_BASE+0x320D3)
#define REG_FRC_BK320_D4        (REG_FRC_BANK_BASE+0x320D4)
#define REG_FRC_BK320_D5        (REG_FRC_BANK_BASE+0x320D5)
#define REG_FRC_BK320_D6        (REG_FRC_BANK_BASE+0x320D6)
#define REG_FRC_BK320_D7        (REG_FRC_BANK_BASE+0x320D7)
#define REG_FRC_BK320_D8        (REG_FRC_BANK_BASE+0x320D8)
#define REG_FRC_BK320_D9        (REG_FRC_BANK_BASE+0x320D9)
#define REG_FRC_BK320_DA        (REG_FRC_BANK_BASE+0x320DA)
#define REG_FRC_BK320_DB        (REG_FRC_BANK_BASE+0x320DB)
#define REG_FRC_BK320_DC        (REG_FRC_BANK_BASE+0x320DC)
#define REG_FRC_BK320_DD        (REG_FRC_BANK_BASE+0x320DD)
#define REG_FRC_BK320_DE        (REG_FRC_BANK_BASE+0x320DE)
#define REG_FRC_BK320_DF        (REG_FRC_BANK_BASE+0x320DF)
#define REG_FRC_BK320_E0        (REG_FRC_BANK_BASE+0x320E0)
#define REG_FRC_BK320_E1        (REG_FRC_BANK_BASE+0x320E1)
#define REG_FRC_BK320_E2        (REG_FRC_BANK_BASE+0x320E2)
#define REG_FRC_BK320_E3        (REG_FRC_BANK_BASE+0x320E3)
#define REG_FRC_BK320_E4        (REG_FRC_BANK_BASE+0x320E4)
#define REG_FRC_BK320_E5        (REG_FRC_BANK_BASE+0x320E5)
#define REG_FRC_BK320_E6        (REG_FRC_BANK_BASE+0x320E6)
#define REG_FRC_BK320_E7        (REG_FRC_BANK_BASE+0x320E7)
#define REG_FRC_BK320_E8        (REG_FRC_BANK_BASE+0x320E8)
#define REG_FRC_BK320_E9        (REG_FRC_BANK_BASE+0x320E9)
#define REG_FRC_BK320_EA        (REG_FRC_BANK_BASE+0x320EA)
#define REG_FRC_BK320_EB        (REG_FRC_BANK_BASE+0x320EB)
#define REG_FRC_BK320_EC        (REG_FRC_BANK_BASE+0x320EC)
#define REG_FRC_BK320_ED        (REG_FRC_BANK_BASE+0x320ED)
#define REG_FRC_BK320_EE        (REG_FRC_BANK_BASE+0x320EE)
#define REG_FRC_BK320_EF        (REG_FRC_BANK_BASE+0x320EF)
#define REG_FRC_BK320_F0        (REG_FRC_BANK_BASE+0x320F0)
#define REG_FRC_BK320_F1        (REG_FRC_BANK_BASE+0x320F1)
#define REG_FRC_BK320_F2        (REG_FRC_BANK_BASE+0x320F2)
#define REG_FRC_BK320_F3        (REG_FRC_BANK_BASE+0x320F3)
#define REG_FRC_BK320_F4        (REG_FRC_BANK_BASE+0x320F4)
#define REG_FRC_BK320_F5        (REG_FRC_BANK_BASE+0x320F5)
#define REG_FRC_BK320_F6        (REG_FRC_BANK_BASE+0x320F6)
#define REG_FRC_BK320_F7        (REG_FRC_BANK_BASE+0x320F7)
#define REG_FRC_BK320_F8        (REG_FRC_BANK_BASE+0x320F8)
#define REG_FRC_BK320_F9        (REG_FRC_BANK_BASE+0x320F9)
#define REG_FRC_BK320_FA        (REG_FRC_BANK_BASE+0x320FA)
#define REG_FRC_BK320_FB        (REG_FRC_BANK_BASE+0x320FB)
#define REG_FRC_BK320_FC        (REG_FRC_BANK_BASE+0x320FC)
#define REG_FRC_BK320_FD        (REG_FRC_BANK_BASE+0x320FD)
#define REG_FRC_BK320_FE        (REG_FRC_BANK_BASE+0x320FE)
#define REG_FRC_BK320_FF        (REG_FRC_BANK_BASE+0x320FF)

// === FRC bk4339
#define REG_FRC_BK339_00        (REG_FRC_BANK_BASE+0x33900)
#define REG_FRC_BK339_01        (REG_FRC_BANK_BASE+0x33901)
#define REG_FRC_BK339_02        (REG_FRC_BANK_BASE+0x33902)
#define REG_FRC_BK339_03        (REG_FRC_BANK_BASE+0x33903)
#define REG_FRC_BK339_04        (REG_FRC_BANK_BASE+0x33904)
#define REG_FRC_BK339_05        (REG_FRC_BANK_BASE+0x33905)
#define REG_FRC_BK339_06        (REG_FRC_BANK_BASE+0x33906)
#define REG_FRC_BK339_07        (REG_FRC_BANK_BASE+0x33907)
#define REG_FRC_BK339_08        (REG_FRC_BANK_BASE+0x33908)
#define REG_FRC_BK339_09        (REG_FRC_BANK_BASE+0x33909)
#define REG_FRC_BK339_0A        (REG_FRC_BANK_BASE+0x3390A)
#define REG_FRC_BK339_0B        (REG_FRC_BANK_BASE+0x3390B)
#define REG_FRC_BK339_0C        (REG_FRC_BANK_BASE+0x3390C)
#define REG_FRC_BK339_0D        (REG_FRC_BANK_BASE+0x3390D)
#define REG_FRC_BK339_0E        (REG_FRC_BANK_BASE+0x3390E)
#define REG_FRC_BK339_0F        (REG_FRC_BANK_BASE+0x3390F)
#define REG_FRC_BK339_10        (REG_FRC_BANK_BASE+0x33910)
#define REG_FRC_BK339_11        (REG_FRC_BANK_BASE+0x33911)
#define REG_FRC_BK339_12        (REG_FRC_BANK_BASE+0x33912)
#define REG_FRC_BK339_13        (REG_FRC_BANK_BASE+0x33913)
#define REG_FRC_BK339_14        (REG_FRC_BANK_BASE+0x33914)
#define REG_FRC_BK339_15        (REG_FRC_BANK_BASE+0x33915)
#define REG_FRC_BK339_16        (REG_FRC_BANK_BASE+0x33916)
#define REG_FRC_BK339_17        (REG_FRC_BANK_BASE+0x33917)
#define REG_FRC_BK339_18        (REG_FRC_BANK_BASE+0x33918)
#define REG_FRC_BK339_19        (REG_FRC_BANK_BASE+0x33919)
#define REG_FRC_BK339_1A        (REG_FRC_BANK_BASE+0x3391A)
#define REG_FRC_BK339_1B        (REG_FRC_BANK_BASE+0x3391B)
#define REG_FRC_BK339_1C        (REG_FRC_BANK_BASE+0x3391C)
#define REG_FRC_BK339_1D        (REG_FRC_BANK_BASE+0x3391D)
#define REG_FRC_BK339_1E        (REG_FRC_BANK_BASE+0x3391E)
#define REG_FRC_BK339_1F        (REG_FRC_BANK_BASE+0x3391F)
#define REG_FRC_BK339_20        (REG_FRC_BANK_BASE+0x33920)
#define REG_FRC_BK339_21        (REG_FRC_BANK_BASE+0x33921)
#define REG_FRC_BK339_22        (REG_FRC_BANK_BASE+0x33922)
#define REG_FRC_BK339_23        (REG_FRC_BANK_BASE+0x33923)
#define REG_FRC_BK339_24        (REG_FRC_BANK_BASE+0x33924)
#define REG_FRC_BK339_25        (REG_FRC_BANK_BASE+0x33925)
#define REG_FRC_BK339_26        (REG_FRC_BANK_BASE+0x33926)
#define REG_FRC_BK339_27        (REG_FRC_BANK_BASE+0x33927)
#define REG_FRC_BK339_28        (REG_FRC_BANK_BASE+0x33928)
#define REG_FRC_BK339_29        (REG_FRC_BANK_BASE+0x33929)
#define REG_FRC_BK339_2A        (REG_FRC_BANK_BASE+0x3392A)
#define REG_FRC_BK339_2B        (REG_FRC_BANK_BASE+0x3392B)
#define REG_FRC_BK339_2C        (REG_FRC_BANK_BASE+0x3392C)
#define REG_FRC_BK339_2D        (REG_FRC_BANK_BASE+0x3392D)
#define REG_FRC_BK339_2E        (REG_FRC_BANK_BASE+0x3392E)
#define REG_FRC_BK339_2F        (REG_FRC_BANK_BASE+0x3392F)
#define REG_FRC_BK339_30        (REG_FRC_BANK_BASE+0x33930)
#define REG_FRC_BK339_31        (REG_FRC_BANK_BASE+0x33931)
#define REG_FRC_BK339_32        (REG_FRC_BANK_BASE+0x33932)
#define REG_FRC_BK339_33        (REG_FRC_BANK_BASE+0x33933)
#define REG_FRC_BK339_34        (REG_FRC_BANK_BASE+0x33934)
#define REG_FRC_BK339_35        (REG_FRC_BANK_BASE+0x33935)
#define REG_FRC_BK339_36        (REG_FRC_BANK_BASE+0x33936)
#define REG_FRC_BK339_37        (REG_FRC_BANK_BASE+0x33937)
#define REG_FRC_BK339_38        (REG_FRC_BANK_BASE+0x33938)
#define REG_FRC_BK339_39        (REG_FRC_BANK_BASE+0x33939)
#define REG_FRC_BK339_3A        (REG_FRC_BANK_BASE+0x3393A)
#define REG_FRC_BK339_3B        (REG_FRC_BANK_BASE+0x3393B)
#define REG_FRC_BK339_3C        (REG_FRC_BANK_BASE+0x3393C)
#define REG_FRC_BK339_3D        (REG_FRC_BANK_BASE+0x3393D)
#define REG_FRC_BK339_3E        (REG_FRC_BANK_BASE+0x3393E)
#define REG_FRC_BK339_3F        (REG_FRC_BANK_BASE+0x3393F)
#define REG_FRC_BK339_40        (REG_FRC_BANK_BASE+0x33940)
#define REG_FRC_BK339_41        (REG_FRC_BANK_BASE+0x33941)
#define REG_FRC_BK339_42        (REG_FRC_BANK_BASE+0x33942)
#define REG_FRC_BK339_43        (REG_FRC_BANK_BASE+0x33943)
#define REG_FRC_BK339_44        (REG_FRC_BANK_BASE+0x33944)
#define REG_FRC_BK339_45        (REG_FRC_BANK_BASE+0x33945)
#define REG_FRC_BK339_46        (REG_FRC_BANK_BASE+0x33946)
#define REG_FRC_BK339_47        (REG_FRC_BANK_BASE+0x33947)
#define REG_FRC_BK339_48        (REG_FRC_BANK_BASE+0x33948)
#define REG_FRC_BK339_49        (REG_FRC_BANK_BASE+0x33949)
#define REG_FRC_BK339_4A        (REG_FRC_BANK_BASE+0x3394A)
#define REG_FRC_BK339_4B        (REG_FRC_BANK_BASE+0x3394B)
#define REG_FRC_BK339_4C        (REG_FRC_BANK_BASE+0x3394C)
#define REG_FRC_BK339_4D        (REG_FRC_BANK_BASE+0x3394D)
#define REG_FRC_BK339_4E        (REG_FRC_BANK_BASE+0x3394E)
#define REG_FRC_BK339_4F        (REG_FRC_BANK_BASE+0x3394F)
#define REG_FRC_BK339_50        (REG_FRC_BANK_BASE+0x33950)
#define REG_FRC_BK339_51        (REG_FRC_BANK_BASE+0x33951)
#define REG_FRC_BK339_52        (REG_FRC_BANK_BASE+0x33952)
#define REG_FRC_BK339_53        (REG_FRC_BANK_BASE+0x33953)
#define REG_FRC_BK339_54        (REG_FRC_BANK_BASE+0x33954)
#define REG_FRC_BK339_55        (REG_FRC_BANK_BASE+0x33955)
#define REG_FRC_BK339_56        (REG_FRC_BANK_BASE+0x33956)
#define REG_FRC_BK339_57        (REG_FRC_BANK_BASE+0x33957)
#define REG_FRC_BK339_58        (REG_FRC_BANK_BASE+0x33958)
#define REG_FRC_BK339_59        (REG_FRC_BANK_BASE+0x33959)
#define REG_FRC_BK339_5A        (REG_FRC_BANK_BASE+0x3395A)
#define REG_FRC_BK339_5B        (REG_FRC_BANK_BASE+0x3395B)
#define REG_FRC_BK339_5C        (REG_FRC_BANK_BASE+0x3395C)
#define REG_FRC_BK339_5D        (REG_FRC_BANK_BASE+0x3395D)
#define REG_FRC_BK339_5E        (REG_FRC_BANK_BASE+0x3395E)
#define REG_FRC_BK339_5F        (REG_FRC_BANK_BASE+0x3395F)
#define REG_FRC_BK339_60        (REG_FRC_BANK_BASE+0x33960)
#define REG_FRC_BK339_61        (REG_FRC_BANK_BASE+0x33961)
#define REG_FRC_BK339_62        (REG_FRC_BANK_BASE+0x33962)
#define REG_FRC_BK339_63        (REG_FRC_BANK_BASE+0x33963)
#define REG_FRC_BK339_64        (REG_FRC_BANK_BASE+0x33964)
#define REG_FRC_BK339_65        (REG_FRC_BANK_BASE+0x33965)
#define REG_FRC_BK339_66        (REG_FRC_BANK_BASE+0x33966)
#define REG_FRC_BK339_67        (REG_FRC_BANK_BASE+0x33967)
#define REG_FRC_BK339_68        (REG_FRC_BANK_BASE+0x33968)
#define REG_FRC_BK339_69        (REG_FRC_BANK_BASE+0x33969)
#define REG_FRC_BK339_6A        (REG_FRC_BANK_BASE+0x3396A)
#define REG_FRC_BK339_6B        (REG_FRC_BANK_BASE+0x3396B)
#define REG_FRC_BK339_6C        (REG_FRC_BANK_BASE+0x3396C)
#define REG_FRC_BK339_6D        (REG_FRC_BANK_BASE+0x3396D)
#define REG_FRC_BK339_6E        (REG_FRC_BANK_BASE+0x3396E)
#define REG_FRC_BK339_6F        (REG_FRC_BANK_BASE+0x3396F)
#define REG_FRC_BK339_70        (REG_FRC_BANK_BASE+0x33970)
#define REG_FRC_BK339_71        (REG_FRC_BANK_BASE+0x33971)
#define REG_FRC_BK339_72        (REG_FRC_BANK_BASE+0x33972)
#define REG_FRC_BK339_73        (REG_FRC_BANK_BASE+0x33973)
#define REG_FRC_BK339_74        (REG_FRC_BANK_BASE+0x33974)
#define REG_FRC_BK339_75        (REG_FRC_BANK_BASE+0x33975)
#define REG_FRC_BK339_76        (REG_FRC_BANK_BASE+0x33976)
#define REG_FRC_BK339_77        (REG_FRC_BANK_BASE+0x33977)
#define REG_FRC_BK339_78        (REG_FRC_BANK_BASE+0x33978)
#define REG_FRC_BK339_79        (REG_FRC_BANK_BASE+0x33979)
#define REG_FRC_BK339_7A        (REG_FRC_BANK_BASE+0x3397A)
#define REG_FRC_BK339_7B        (REG_FRC_BANK_BASE+0x3397B)
#define REG_FRC_BK339_7C        (REG_FRC_BANK_BASE+0x3397C)
#define REG_FRC_BK339_7D        (REG_FRC_BANK_BASE+0x3397D)
#define REG_FRC_BK339_7E        (REG_FRC_BANK_BASE+0x3397E)
#define REG_FRC_BK339_7F        (REG_FRC_BANK_BASE+0x3397F)
#define REG_FRC_BK339_80        (REG_FRC_BANK_BASE+0x33980)
#define REG_FRC_BK339_81        (REG_FRC_BANK_BASE+0x33981)
#define REG_FRC_BK339_82        (REG_FRC_BANK_BASE+0x33982)
#define REG_FRC_BK339_83        (REG_FRC_BANK_BASE+0x33983)
#define REG_FRC_BK339_84        (REG_FRC_BANK_BASE+0x33984)
#define REG_FRC_BK339_85        (REG_FRC_BANK_BASE+0x33985)
#define REG_FRC_BK339_86        (REG_FRC_BANK_BASE+0x33986)
#define REG_FRC_BK339_87        (REG_FRC_BANK_BASE+0x33987)
#define REG_FRC_BK339_88        (REG_FRC_BANK_BASE+0x33988)
#define REG_FRC_BK339_89        (REG_FRC_BANK_BASE+0x33989)
#define REG_FRC_BK339_8A        (REG_FRC_BANK_BASE+0x3398A)
#define REG_FRC_BK339_8B        (REG_FRC_BANK_BASE+0x3398B)
#define REG_FRC_BK339_8C        (REG_FRC_BANK_BASE+0x3398C)
#define REG_FRC_BK339_8D        (REG_FRC_BANK_BASE+0x3398D)
#define REG_FRC_BK339_8E        (REG_FRC_BANK_BASE+0x3398E)
#define REG_FRC_BK339_8F        (REG_FRC_BANK_BASE+0x3398F)
#define REG_FRC_BK339_90        (REG_FRC_BANK_BASE+0x33990)
#define REG_FRC_BK339_91        (REG_FRC_BANK_BASE+0x33991)
#define REG_FRC_BK339_92        (REG_FRC_BANK_BASE+0x33992)
#define REG_FRC_BK339_93        (REG_FRC_BANK_BASE+0x33993)
#define REG_FRC_BK339_94        (REG_FRC_BANK_BASE+0x33994)
#define REG_FRC_BK339_95        (REG_FRC_BANK_BASE+0x33995)
#define REG_FRC_BK339_96        (REG_FRC_BANK_BASE+0x33996)
#define REG_FRC_BK339_97        (REG_FRC_BANK_BASE+0x33997)
#define REG_FRC_BK339_98        (REG_FRC_BANK_BASE+0x33998)
#define REG_FRC_BK339_99        (REG_FRC_BANK_BASE+0x33999)
#define REG_FRC_BK339_9A        (REG_FRC_BANK_BASE+0x3399A)
#define REG_FRC_BK339_9B        (REG_FRC_BANK_BASE+0x3399B)
#define REG_FRC_BK339_9C        (REG_FRC_BANK_BASE+0x3399C)
#define REG_FRC_BK339_9D        (REG_FRC_BANK_BASE+0x3399D)
#define REG_FRC_BK339_9E        (REG_FRC_BANK_BASE+0x3399E)
#define REG_FRC_BK339_9F        (REG_FRC_BANK_BASE+0x3399F)
#define REG_FRC_BK339_A0        (REG_FRC_BANK_BASE+0x339A0)
#define REG_FRC_BK339_A1        (REG_FRC_BANK_BASE+0x339A1)
#define REG_FRC_BK339_A2        (REG_FRC_BANK_BASE+0x339A2)
#define REG_FRC_BK339_A3        (REG_FRC_BANK_BASE+0x339A3)
#define REG_FRC_BK339_A4        (REG_FRC_BANK_BASE+0x339A4)
#define REG_FRC_BK339_A5        (REG_FRC_BANK_BASE+0x339A5)
#define REG_FRC_BK339_A6        (REG_FRC_BANK_BASE+0x339A6)
#define REG_FRC_BK339_A7        (REG_FRC_BANK_BASE+0x339A7)
#define REG_FRC_BK339_A8        (REG_FRC_BANK_BASE+0x339A8)
#define REG_FRC_BK339_A9        (REG_FRC_BANK_BASE+0x339A9)
#define REG_FRC_BK339_AA        (REG_FRC_BANK_BASE+0x339AA)
#define REG_FRC_BK339_AB        (REG_FRC_BANK_BASE+0x339AB)
#define REG_FRC_BK339_AC        (REG_FRC_BANK_BASE+0x339AC)
#define REG_FRC_BK339_AD        (REG_FRC_BANK_BASE+0x339AD)
#define REG_FRC_BK339_AE        (REG_FRC_BANK_BASE+0x339AE)
#define REG_FRC_BK339_AF        (REG_FRC_BANK_BASE+0x339AF)
#define REG_FRC_BK339_B0        (REG_FRC_BANK_BASE+0x339B0)
#define REG_FRC_BK339_B1        (REG_FRC_BANK_BASE+0x339B1)
#define REG_FRC_BK339_B2        (REG_FRC_BANK_BASE+0x339B2)
#define REG_FRC_BK339_B3        (REG_FRC_BANK_BASE+0x339B3)
#define REG_FRC_BK339_B4        (REG_FRC_BANK_BASE+0x339B4)
#define REG_FRC_BK339_B5        (REG_FRC_BANK_BASE+0x339B5)
#define REG_FRC_BK339_B6        (REG_FRC_BANK_BASE+0x339B6)
#define REG_FRC_BK339_B7        (REG_FRC_BANK_BASE+0x339B7)
#define REG_FRC_BK339_B8        (REG_FRC_BANK_BASE+0x339B8)
#define REG_FRC_BK339_B9        (REG_FRC_BANK_BASE+0x339B9)
#define REG_FRC_BK339_BA        (REG_FRC_BANK_BASE+0x339BA)
#define REG_FRC_BK339_BB        (REG_FRC_BANK_BASE+0x339BB)
#define REG_FRC_BK339_BC        (REG_FRC_BANK_BASE+0x339BC)
#define REG_FRC_BK339_BD        (REG_FRC_BANK_BASE+0x339BD)
#define REG_FRC_BK339_BE        (REG_FRC_BANK_BASE+0x339BE)
#define REG_FRC_BK339_BF        (REG_FRC_BANK_BASE+0x339BF)
#define REG_FRC_BK339_C0        (REG_FRC_BANK_BASE+0x339C0)
#define REG_FRC_BK339_C1        (REG_FRC_BANK_BASE+0x339C1)
#define REG_FRC_BK339_C2        (REG_FRC_BANK_BASE+0x339C2)
#define REG_FRC_BK339_C3        (REG_FRC_BANK_BASE+0x339C3)
#define REG_FRC_BK339_C4        (REG_FRC_BANK_BASE+0x339C4)
#define REG_FRC_BK339_C5        (REG_FRC_BANK_BASE+0x339C5)
#define REG_FRC_BK339_C6        (REG_FRC_BANK_BASE+0x339C6)
#define REG_FRC_BK339_C7        (REG_FRC_BANK_BASE+0x339C7)
#define REG_FRC_BK339_C8        (REG_FRC_BANK_BASE+0x339C8)
#define REG_FRC_BK339_C9        (REG_FRC_BANK_BASE+0x339C9)
#define REG_FRC_BK339_CA        (REG_FRC_BANK_BASE+0x339CA)
#define REG_FRC_BK339_CB        (REG_FRC_BANK_BASE+0x339CB)
#define REG_FRC_BK339_CC        (REG_FRC_BANK_BASE+0x339CC)
#define REG_FRC_BK339_CD        (REG_FRC_BANK_BASE+0x339CD)
#define REG_FRC_BK339_CE        (REG_FRC_BANK_BASE+0x339CE)
#define REG_FRC_BK339_CF        (REG_FRC_BANK_BASE+0x339CF)
#define REG_FRC_BK339_D0        (REG_FRC_BANK_BASE+0x339D0)
#define REG_FRC_BK339_D1        (REG_FRC_BANK_BASE+0x339D1)
#define REG_FRC_BK339_D2        (REG_FRC_BANK_BASE+0x339D2)
#define REG_FRC_BK339_D3        (REG_FRC_BANK_BASE+0x339D3)
#define REG_FRC_BK339_D4        (REG_FRC_BANK_BASE+0x339D4)
#define REG_FRC_BK339_D5        (REG_FRC_BANK_BASE+0x339D5)
#define REG_FRC_BK339_D6        (REG_FRC_BANK_BASE+0x339D6)
#define REG_FRC_BK339_D7        (REG_FRC_BANK_BASE+0x339D7)
#define REG_FRC_BK339_D8        (REG_FRC_BANK_BASE+0x339D8)
#define REG_FRC_BK339_D9        (REG_FRC_BANK_BASE+0x339D9)
#define REG_FRC_BK339_DA        (REG_FRC_BANK_BASE+0x339DA)
#define REG_FRC_BK339_DB        (REG_FRC_BANK_BASE+0x339DB)
#define REG_FRC_BK339_DC        (REG_FRC_BANK_BASE+0x339DC)
#define REG_FRC_BK339_DD        (REG_FRC_BANK_BASE+0x339DD)
#define REG_FRC_BK339_DE        (REG_FRC_BANK_BASE+0x339DE)
#define REG_FRC_BK339_DF        (REG_FRC_BANK_BASE+0x339DF)
#define REG_FRC_BK339_E0        (REG_FRC_BANK_BASE+0x339E0)
#define REG_FRC_BK339_E1        (REG_FRC_BANK_BASE+0x339E1)
#define REG_FRC_BK339_E2        (REG_FRC_BANK_BASE+0x339E2)
#define REG_FRC_BK339_E3        (REG_FRC_BANK_BASE+0x339E3)
#define REG_FRC_BK339_E4        (REG_FRC_BANK_BASE+0x339E4)
#define REG_FRC_BK339_E5        (REG_FRC_BANK_BASE+0x339E5)
#define REG_FRC_BK339_E6        (REG_FRC_BANK_BASE+0x339E6)
#define REG_FRC_BK339_E7        (REG_FRC_BANK_BASE+0x339E7)
#define REG_FRC_BK339_E8        (REG_FRC_BANK_BASE+0x339E8)
#define REG_FRC_BK339_E9        (REG_FRC_BANK_BASE+0x339E9)
#define REG_FRC_BK339_EA        (REG_FRC_BANK_BASE+0x339EA)
#define REG_FRC_BK339_EB        (REG_FRC_BANK_BASE+0x339EB)
#define REG_FRC_BK339_EC        (REG_FRC_BANK_BASE+0x339EC)
#define REG_FRC_BK339_ED        (REG_FRC_BANK_BASE+0x339ED)
#define REG_FRC_BK339_EE        (REG_FRC_BANK_BASE+0x339EE)
#define REG_FRC_BK339_EF        (REG_FRC_BANK_BASE+0x339EF)
#define REG_FRC_BK339_F0        (REG_FRC_BANK_BASE+0x339F0)
#define REG_FRC_BK339_F1        (REG_FRC_BANK_BASE+0x339F1)
#define REG_FRC_BK339_F2        (REG_FRC_BANK_BASE+0x339F2)
#define REG_FRC_BK339_F3        (REG_FRC_BANK_BASE+0x339F3)
#define REG_FRC_BK339_F4        (REG_FRC_BANK_BASE+0x339F4)
#define REG_FRC_BK339_F5        (REG_FRC_BANK_BASE+0x339F5)
#define REG_FRC_BK339_F6        (REG_FRC_BANK_BASE+0x339F6)
#define REG_FRC_BK339_F7        (REG_FRC_BANK_BASE+0x339F7)
#define REG_FRC_BK339_F8        (REG_FRC_BANK_BASE+0x339F8)
#define REG_FRC_BK339_F9        (REG_FRC_BANK_BASE+0x339F9)
#define REG_FRC_BK339_FA        (REG_FRC_BANK_BASE+0x339FA)
#define REG_FRC_BK339_FB        (REG_FRC_BANK_BASE+0x339FB)
#define REG_FRC_BK339_FC        (REG_FRC_BANK_BASE+0x339FC)
#define REG_FRC_BK339_FD        (REG_FRC_BANK_BASE+0x339FD)
#define REG_FRC_BK339_FE        (REG_FRC_BANK_BASE+0x339FE)
#define REG_FRC_BK339_FF        (REG_FRC_BANK_BASE+0x339FF)

// === FRC bk433A
#define REG_FRC_BK33A_00        (REG_FRC_BANK_BASE+0x33A00)
#define REG_FRC_BK33A_01        (REG_FRC_BANK_BASE+0x33A01)
#define REG_FRC_BK33A_02        (REG_FRC_BANK_BASE+0x33A02)
#define REG_FRC_BK33A_03        (REG_FRC_BANK_BASE+0x33A03)
#define REG_FRC_BK33A_04        (REG_FRC_BANK_BASE+0x33A04)
#define REG_FRC_BK33A_05        (REG_FRC_BANK_BASE+0x33A05)
#define REG_FRC_BK33A_06        (REG_FRC_BANK_BASE+0x33A06)
#define REG_FRC_BK33A_07        (REG_FRC_BANK_BASE+0x33A07)
#define REG_FRC_BK33A_08        (REG_FRC_BANK_BASE+0x33A08)
#define REG_FRC_BK33A_09        (REG_FRC_BANK_BASE+0x33A09)
#define REG_FRC_BK33A_0A        (REG_FRC_BANK_BASE+0x33A0A)
#define REG_FRC_BK33A_0B        (REG_FRC_BANK_BASE+0x33A0B)
#define REG_FRC_BK33A_0C        (REG_FRC_BANK_BASE+0x33A0C)
#define REG_FRC_BK33A_0D        (REG_FRC_BANK_BASE+0x33A0D)
#define REG_FRC_BK33A_0E        (REG_FRC_BANK_BASE+0x33A0E)
#define REG_FRC_BK33A_0F        (REG_FRC_BANK_BASE+0x33A0F)
#define REG_FRC_BK33A_10        (REG_FRC_BANK_BASE+0x33A10)
#define REG_FRC_BK33A_11        (REG_FRC_BANK_BASE+0x33A11)
#define REG_FRC_BK33A_12        (REG_FRC_BANK_BASE+0x33A12)
#define REG_FRC_BK33A_13        (REG_FRC_BANK_BASE+0x33A13)
#define REG_FRC_BK33A_14        (REG_FRC_BANK_BASE+0x33A14)
#define REG_FRC_BK33A_15        (REG_FRC_BANK_BASE+0x33A15)
#define REG_FRC_BK33A_16        (REG_FRC_BANK_BASE+0x33A16)
#define REG_FRC_BK33A_17        (REG_FRC_BANK_BASE+0x33A17)
#define REG_FRC_BK33A_18        (REG_FRC_BANK_BASE+0x33A18)
#define REG_FRC_BK33A_19        (REG_FRC_BANK_BASE+0x33A19)
#define REG_FRC_BK33A_1A        (REG_FRC_BANK_BASE+0x33A1A)
#define REG_FRC_BK33A_1B        (REG_FRC_BANK_BASE+0x33A1B)
#define REG_FRC_BK33A_1C        (REG_FRC_BANK_BASE+0x33A1C)
#define REG_FRC_BK33A_1D        (REG_FRC_BANK_BASE+0x33A1D)
#define REG_FRC_BK33A_1E        (REG_FRC_BANK_BASE+0x33A1E)
#define REG_FRC_BK33A_1F        (REG_FRC_BANK_BASE+0x33A1F)
#define REG_FRC_BK33A_20        (REG_FRC_BANK_BASE+0x33A20)
#define REG_FRC_BK33A_21        (REG_FRC_BANK_BASE+0x33A21)
#define REG_FRC_BK33A_22        (REG_FRC_BANK_BASE+0x33A22)
#define REG_FRC_BK33A_23        (REG_FRC_BANK_BASE+0x33A23)
#define REG_FRC_BK33A_24        (REG_FRC_BANK_BASE+0x33A24)
#define REG_FRC_BK33A_25        (REG_FRC_BANK_BASE+0x33A25)
#define REG_FRC_BK33A_26        (REG_FRC_BANK_BASE+0x33A26)
#define REG_FRC_BK33A_27        (REG_FRC_BANK_BASE+0x33A27)
#define REG_FRC_BK33A_28        (REG_FRC_BANK_BASE+0x33A28)
#define REG_FRC_BK33A_29        (REG_FRC_BANK_BASE+0x33A29)
#define REG_FRC_BK33A_2A        (REG_FRC_BANK_BASE+0x33A2A)
#define REG_FRC_BK33A_2B        (REG_FRC_BANK_BASE+0x33A2B)
#define REG_FRC_BK33A_2C        (REG_FRC_BANK_BASE+0x33A2C)
#define REG_FRC_BK33A_2D        (REG_FRC_BANK_BASE+0x33A2D)
#define REG_FRC_BK33A_2E        (REG_FRC_BANK_BASE+0x33A2E)
#define REG_FRC_BK33A_2F        (REG_FRC_BANK_BASE+0x33A2F)
#define REG_FRC_BK33A_30        (REG_FRC_BANK_BASE+0x33A30)
#define REG_FRC_BK33A_31        (REG_FRC_BANK_BASE+0x33A31)
#define REG_FRC_BK33A_32        (REG_FRC_BANK_BASE+0x33A32)
#define REG_FRC_BK33A_33        (REG_FRC_BANK_BASE+0x33A33)
#define REG_FRC_BK33A_34        (REG_FRC_BANK_BASE+0x33A34)
#define REG_FRC_BK33A_35        (REG_FRC_BANK_BASE+0x33A35)
#define REG_FRC_BK33A_36        (REG_FRC_BANK_BASE+0x33A36)
#define REG_FRC_BK33A_37        (REG_FRC_BANK_BASE+0x33A37)
#define REG_FRC_BK33A_38        (REG_FRC_BANK_BASE+0x33A38)
#define REG_FRC_BK33A_39        (REG_FRC_BANK_BASE+0x33A39)
#define REG_FRC_BK33A_3A        (REG_FRC_BANK_BASE+0x33A3A)
#define REG_FRC_BK33A_3B        (REG_FRC_BANK_BASE+0x33A3B)
#define REG_FRC_BK33A_3C        (REG_FRC_BANK_BASE+0x33A3C)
#define REG_FRC_BK33A_3D        (REG_FRC_BANK_BASE+0x33A3D)
#define REG_FRC_BK33A_3E        (REG_FRC_BANK_BASE+0x33A3E)
#define REG_FRC_BK33A_3F        (REG_FRC_BANK_BASE+0x33A3F)
#define REG_FRC_BK33A_40        (REG_FRC_BANK_BASE+0x33A40)
#define REG_FRC_BK33A_41        (REG_FRC_BANK_BASE+0x33A41)
#define REG_FRC_BK33A_42        (REG_FRC_BANK_BASE+0x33A42)
#define REG_FRC_BK33A_43        (REG_FRC_BANK_BASE+0x33A43)
#define REG_FRC_BK33A_44        (REG_FRC_BANK_BASE+0x33A44)
#define REG_FRC_BK33A_45        (REG_FRC_BANK_BASE+0x33A45)
#define REG_FRC_BK33A_46        (REG_FRC_BANK_BASE+0x33A46)
#define REG_FRC_BK33A_47        (REG_FRC_BANK_BASE+0x33A47)
#define REG_FRC_BK33A_48        (REG_FRC_BANK_BASE+0x33A48)
#define REG_FRC_BK33A_49        (REG_FRC_BANK_BASE+0x33A49)
#define REG_FRC_BK33A_4A        (REG_FRC_BANK_BASE+0x33A4A)
#define REG_FRC_BK33A_4B        (REG_FRC_BANK_BASE+0x33A4B)
#define REG_FRC_BK33A_4C        (REG_FRC_BANK_BASE+0x33A4C)
#define REG_FRC_BK33A_4D        (REG_FRC_BANK_BASE+0x33A4D)
#define REG_FRC_BK33A_4E        (REG_FRC_BANK_BASE+0x33A4E)
#define REG_FRC_BK33A_4F        (REG_FRC_BANK_BASE+0x33A4F)
#define REG_FRC_BK33A_50        (REG_FRC_BANK_BASE+0x33A50)
#define REG_FRC_BK33A_51        (REG_FRC_BANK_BASE+0x33A51)
#define REG_FRC_BK33A_52        (REG_FRC_BANK_BASE+0x33A52)
#define REG_FRC_BK33A_53        (REG_FRC_BANK_BASE+0x33A53)
#define REG_FRC_BK33A_54        (REG_FRC_BANK_BASE+0x33A54)
#define REG_FRC_BK33A_55        (REG_FRC_BANK_BASE+0x33A55)
#define REG_FRC_BK33A_56        (REG_FRC_BANK_BASE+0x33A56)
#define REG_FRC_BK33A_57        (REG_FRC_BANK_BASE+0x33A57)
#define REG_FRC_BK33A_58        (REG_FRC_BANK_BASE+0x33A58)
#define REG_FRC_BK33A_59        (REG_FRC_BANK_BASE+0x33A59)
#define REG_FRC_BK33A_5A        (REG_FRC_BANK_BASE+0x33A5A)
#define REG_FRC_BK33A_5B        (REG_FRC_BANK_BASE+0x33A5B)
#define REG_FRC_BK33A_5C        (REG_FRC_BANK_BASE+0x33A5C)
#define REG_FRC_BK33A_5D        (REG_FRC_BANK_BASE+0x33A5D)
#define REG_FRC_BK33A_5E        (REG_FRC_BANK_BASE+0x33A5E)
#define REG_FRC_BK33A_5F        (REG_FRC_BANK_BASE+0x33A5F)
#define REG_FRC_BK33A_60        (REG_FRC_BANK_BASE+0x33A60)
#define REG_FRC_BK33A_61        (REG_FRC_BANK_BASE+0x33A61)
#define REG_FRC_BK33A_62        (REG_FRC_BANK_BASE+0x33A62)
#define REG_FRC_BK33A_63        (REG_FRC_BANK_BASE+0x33A63)
#define REG_FRC_BK33A_64        (REG_FRC_BANK_BASE+0x33A64)
#define REG_FRC_BK33A_65        (REG_FRC_BANK_BASE+0x33A65)
#define REG_FRC_BK33A_66        (REG_FRC_BANK_BASE+0x33A66)
#define REG_FRC_BK33A_67        (REG_FRC_BANK_BASE+0x33A67)
#define REG_FRC_BK33A_68        (REG_FRC_BANK_BASE+0x33A68)
#define REG_FRC_BK33A_69        (REG_FRC_BANK_BASE+0x33A69)
#define REG_FRC_BK33A_6A        (REG_FRC_BANK_BASE+0x33A6A)
#define REG_FRC_BK33A_6B        (REG_FRC_BANK_BASE+0x33A6B)
#define REG_FRC_BK33A_6C        (REG_FRC_BANK_BASE+0x33A6C)
#define REG_FRC_BK33A_6D        (REG_FRC_BANK_BASE+0x33A6D)
#define REG_FRC_BK33A_6E        (REG_FRC_BANK_BASE+0x33A6E)
#define REG_FRC_BK33A_6F        (REG_FRC_BANK_BASE+0x33A6F)
#define REG_FRC_BK33A_70        (REG_FRC_BANK_BASE+0x33A70)
#define REG_FRC_BK33A_71        (REG_FRC_BANK_BASE+0x33A71)
#define REG_FRC_BK33A_72        (REG_FRC_BANK_BASE+0x33A72)
#define REG_FRC_BK33A_73        (REG_FRC_BANK_BASE+0x33A73)
#define REG_FRC_BK33A_74        (REG_FRC_BANK_BASE+0x33A74)
#define REG_FRC_BK33A_75        (REG_FRC_BANK_BASE+0x33A75)
#define REG_FRC_BK33A_76        (REG_FRC_BANK_BASE+0x33A76)
#define REG_FRC_BK33A_77        (REG_FRC_BANK_BASE+0x33A77)
#define REG_FRC_BK33A_78        (REG_FRC_BANK_BASE+0x33A78)
#define REG_FRC_BK33A_79        (REG_FRC_BANK_BASE+0x33A79)
#define REG_FRC_BK33A_7A        (REG_FRC_BANK_BASE+0x33A7A)
#define REG_FRC_BK33A_7B        (REG_FRC_BANK_BASE+0x33A7B)
#define REG_FRC_BK33A_7C        (REG_FRC_BANK_BASE+0x33A7C)
#define REG_FRC_BK33A_7D        (REG_FRC_BANK_BASE+0x33A7D)
#define REG_FRC_BK33A_7E        (REG_FRC_BANK_BASE+0x33A7E)
#define REG_FRC_BK33A_7F        (REG_FRC_BANK_BASE+0x33A7F)
#define REG_FRC_BK33A_80        (REG_FRC_BANK_BASE+0x33A80)
#define REG_FRC_BK33A_81        (REG_FRC_BANK_BASE+0x33A81)
#define REG_FRC_BK33A_82        (REG_FRC_BANK_BASE+0x33A82)
#define REG_FRC_BK33A_83        (REG_FRC_BANK_BASE+0x33A83)
#define REG_FRC_BK33A_84        (REG_FRC_BANK_BASE+0x33A84)
#define REG_FRC_BK33A_85        (REG_FRC_BANK_BASE+0x33A85)
#define REG_FRC_BK33A_86        (REG_FRC_BANK_BASE+0x33A86)
#define REG_FRC_BK33A_87        (REG_FRC_BANK_BASE+0x33A87)
#define REG_FRC_BK33A_88        (REG_FRC_BANK_BASE+0x33A88)
#define REG_FRC_BK33A_89        (REG_FRC_BANK_BASE+0x33A89)
#define REG_FRC_BK33A_8A        (REG_FRC_BANK_BASE+0x33A8A)
#define REG_FRC_BK33A_8B        (REG_FRC_BANK_BASE+0x33A8B)
#define REG_FRC_BK33A_8C        (REG_FRC_BANK_BASE+0x33A8C)
#define REG_FRC_BK33A_8D        (REG_FRC_BANK_BASE+0x33A8D)
#define REG_FRC_BK33A_8E        (REG_FRC_BANK_BASE+0x33A8E)
#define REG_FRC_BK33A_8F        (REG_FRC_BANK_BASE+0x33A8F)
#define REG_FRC_BK33A_90        (REG_FRC_BANK_BASE+0x33A90)
#define REG_FRC_BK33A_91        (REG_FRC_BANK_BASE+0x33A91)
#define REG_FRC_BK33A_92        (REG_FRC_BANK_BASE+0x33A92)
#define REG_FRC_BK33A_93        (REG_FRC_BANK_BASE+0x33A93)
#define REG_FRC_BK33A_94        (REG_FRC_BANK_BASE+0x33A94)
#define REG_FRC_BK33A_95        (REG_FRC_BANK_BASE+0x33A95)
#define REG_FRC_BK33A_96        (REG_FRC_BANK_BASE+0x33A96)
#define REG_FRC_BK33A_97        (REG_FRC_BANK_BASE+0x33A97)
#define REG_FRC_BK33A_98        (REG_FRC_BANK_BASE+0x33A98)
#define REG_FRC_BK33A_99        (REG_FRC_BANK_BASE+0x33A99)
#define REG_FRC_BK33A_9A        (REG_FRC_BANK_BASE+0x33A9A)
#define REG_FRC_BK33A_9B        (REG_FRC_BANK_BASE+0x33A9B)
#define REG_FRC_BK33A_9C        (REG_FRC_BANK_BASE+0x33A9C)
#define REG_FRC_BK33A_9D        (REG_FRC_BANK_BASE+0x33A9D)
#define REG_FRC_BK33A_9E        (REG_FRC_BANK_BASE+0x33A9E)
#define REG_FRC_BK33A_9F        (REG_FRC_BANK_BASE+0x33A9F)
#define REG_FRC_BK33A_A0        (REG_FRC_BANK_BASE+0x33AA0)
#define REG_FRC_BK33A_A1        (REG_FRC_BANK_BASE+0x33AA1)
#define REG_FRC_BK33A_A2        (REG_FRC_BANK_BASE+0x33AA2)
#define REG_FRC_BK33A_A3        (REG_FRC_BANK_BASE+0x33AA3)
#define REG_FRC_BK33A_A4        (REG_FRC_BANK_BASE+0x33AA4)
#define REG_FRC_BK33A_A5        (REG_FRC_BANK_BASE+0x33AA5)
#define REG_FRC_BK33A_A6        (REG_FRC_BANK_BASE+0x33AA6)
#define REG_FRC_BK33A_A7        (REG_FRC_BANK_BASE+0x33AA7)
#define REG_FRC_BK33A_A8        (REG_FRC_BANK_BASE+0x33AA8)
#define REG_FRC_BK33A_A9        (REG_FRC_BANK_BASE+0x33AA9)
#define REG_FRC_BK33A_AA        (REG_FRC_BANK_BASE+0x33AAA)
#define REG_FRC_BK33A_AB        (REG_FRC_BANK_BASE+0x33AAB)
#define REG_FRC_BK33A_AC        (REG_FRC_BANK_BASE+0x33AAC)
#define REG_FRC_BK33A_AD        (REG_FRC_BANK_BASE+0x33AAD)
#define REG_FRC_BK33A_AE        (REG_FRC_BANK_BASE+0x33AAE)
#define REG_FRC_BK33A_AF        (REG_FRC_BANK_BASE+0x33AAF)
#define REG_FRC_BK33A_B0        (REG_FRC_BANK_BASE+0x33AB0)
#define REG_FRC_BK33A_B1        (REG_FRC_BANK_BASE+0x33AB1)
#define REG_FRC_BK33A_B2        (REG_FRC_BANK_BASE+0x33AB2)
#define REG_FRC_BK33A_B3        (REG_FRC_BANK_BASE+0x33AB3)
#define REG_FRC_BK33A_B4        (REG_FRC_BANK_BASE+0x33AB4)
#define REG_FRC_BK33A_B5        (REG_FRC_BANK_BASE+0x33AB5)
#define REG_FRC_BK33A_B6        (REG_FRC_BANK_BASE+0x33AB6)
#define REG_FRC_BK33A_B7        (REG_FRC_BANK_BASE+0x33AB7)
#define REG_FRC_BK33A_B8        (REG_FRC_BANK_BASE+0x33AB8)
#define REG_FRC_BK33A_B9        (REG_FRC_BANK_BASE+0x33AB9)
#define REG_FRC_BK33A_BA        (REG_FRC_BANK_BASE+0x33ABA)
#define REG_FRC_BK33A_BB        (REG_FRC_BANK_BASE+0x33ABB)
#define REG_FRC_BK33A_BC        (REG_FRC_BANK_BASE+0x33ABC)
#define REG_FRC_BK33A_BD        (REG_FRC_BANK_BASE+0x33ABD)
#define REG_FRC_BK33A_BE        (REG_FRC_BANK_BASE+0x33ABE)
#define REG_FRC_BK33A_BF        (REG_FRC_BANK_BASE+0x33ABF)
#define REG_FRC_BK33A_C0        (REG_FRC_BANK_BASE+0x33AC0)
#define REG_FRC_BK33A_C1        (REG_FRC_BANK_BASE+0x33AC1)
#define REG_FRC_BK33A_C2        (REG_FRC_BANK_BASE+0x33AC2)
#define REG_FRC_BK33A_C3        (REG_FRC_BANK_BASE+0x33AC3)
#define REG_FRC_BK33A_C4        (REG_FRC_BANK_BASE+0x33AC4)
#define REG_FRC_BK33A_C5        (REG_FRC_BANK_BASE+0x33AC5)
#define REG_FRC_BK33A_C6        (REG_FRC_BANK_BASE+0x33AC6)
#define REG_FRC_BK33A_C7        (REG_FRC_BANK_BASE+0x33AC7)
#define REG_FRC_BK33A_C8        (REG_FRC_BANK_BASE+0x33AC8)
#define REG_FRC_BK33A_C9        (REG_FRC_BANK_BASE+0x33AC9)
#define REG_FRC_BK33A_CA        (REG_FRC_BANK_BASE+0x33ACA)
#define REG_FRC_BK33A_CB        (REG_FRC_BANK_BASE+0x33ACB)
#define REG_FRC_BK33A_CC        (REG_FRC_BANK_BASE+0x33ACC)
#define REG_FRC_BK33A_CD        (REG_FRC_BANK_BASE+0x33ACD)
#define REG_FRC_BK33A_CE        (REG_FRC_BANK_BASE+0x33ACE)
#define REG_FRC_BK33A_CF        (REG_FRC_BANK_BASE+0x33ACF)
#define REG_FRC_BK33A_D0        (REG_FRC_BANK_BASE+0x33AD0)
#define REG_FRC_BK33A_D1        (REG_FRC_BANK_BASE+0x33AD1)
#define REG_FRC_BK33A_D2        (REG_FRC_BANK_BASE+0x33AD2)
#define REG_FRC_BK33A_D3        (REG_FRC_BANK_BASE+0x33AD3)
#define REG_FRC_BK33A_D4        (REG_FRC_BANK_BASE+0x33AD4)
#define REG_FRC_BK33A_D5        (REG_FRC_BANK_BASE+0x33AD5)
#define REG_FRC_BK33A_D6        (REG_FRC_BANK_BASE+0x33AD6)
#define REG_FRC_BK33A_D7        (REG_FRC_BANK_BASE+0x33AD7)
#define REG_FRC_BK33A_D8        (REG_FRC_BANK_BASE+0x33AD8)
#define REG_FRC_BK33A_D9        (REG_FRC_BANK_BASE+0x33AD9)
#define REG_FRC_BK33A_DA        (REG_FRC_BANK_BASE+0x33ADA)
#define REG_FRC_BK33A_DB        (REG_FRC_BANK_BASE+0x33ADB)
#define REG_FRC_BK33A_DC        (REG_FRC_BANK_BASE+0x33ADC)
#define REG_FRC_BK33A_DD        (REG_FRC_BANK_BASE+0x33ADD)
#define REG_FRC_BK33A_DE        (REG_FRC_BANK_BASE+0x33ADE)
#define REG_FRC_BK33A_DF        (REG_FRC_BANK_BASE+0x33ADF)
#define REG_FRC_BK33A_E0        (REG_FRC_BANK_BASE+0x33AE0)
#define REG_FRC_BK33A_E1        (REG_FRC_BANK_BASE+0x33AE1)
#define REG_FRC_BK33A_E2        (REG_FRC_BANK_BASE+0x33AE2)
#define REG_FRC_BK33A_E3        (REG_FRC_BANK_BASE+0x33AE3)
#define REG_FRC_BK33A_E4        (REG_FRC_BANK_BASE+0x33AE4)
#define REG_FRC_BK33A_E5        (REG_FRC_BANK_BASE+0x33AE5)
#define REG_FRC_BK33A_E6        (REG_FRC_BANK_BASE+0x33AE6)
#define REG_FRC_BK33A_E7        (REG_FRC_BANK_BASE+0x33AE7)
#define REG_FRC_BK33A_E8        (REG_FRC_BANK_BASE+0x33AE8)
#define REG_FRC_BK33A_E9        (REG_FRC_BANK_BASE+0x33AE9)
#define REG_FRC_BK33A_EA        (REG_FRC_BANK_BASE+0x33AEA)
#define REG_FRC_BK33A_EB        (REG_FRC_BANK_BASE+0x33AEB)
#define REG_FRC_BK33A_EC        (REG_FRC_BANK_BASE+0x33AEC)
#define REG_FRC_BK33A_ED        (REG_FRC_BANK_BASE+0x33AED)
#define REG_FRC_BK33A_EE        (REG_FRC_BANK_BASE+0x33AEE)
#define REG_FRC_BK33A_EF        (REG_FRC_BANK_BASE+0x33AEF)
#define REG_FRC_BK33A_F0        (REG_FRC_BANK_BASE+0x33AF0)
#define REG_FRC_BK33A_F1        (REG_FRC_BANK_BASE+0x33AF1)
#define REG_FRC_BK33A_F2        (REG_FRC_BANK_BASE+0x33AF2)
#define REG_FRC_BK33A_F3        (REG_FRC_BANK_BASE+0x33AF3)
#define REG_FRC_BK33A_F4        (REG_FRC_BANK_BASE+0x33AF4)
#define REG_FRC_BK33A_F5        (REG_FRC_BANK_BASE+0x33AF5)
#define REG_FRC_BK33A_F6        (REG_FRC_BANK_BASE+0x33AF6)
#define REG_FRC_BK33A_F7        (REG_FRC_BANK_BASE+0x33AF7)
#define REG_FRC_BK33A_F8        (REG_FRC_BANK_BASE+0x33AF8)
#define REG_FRC_BK33A_F9        (REG_FRC_BANK_BASE+0x33AF9)
#define REG_FRC_BK33A_FA        (REG_FRC_BANK_BASE+0x33AFA)
#define REG_FRC_BK33A_FB        (REG_FRC_BANK_BASE+0x33AFB)
#define REG_FRC_BK33A_FC        (REG_FRC_BANK_BASE+0x33AFC)
#define REG_FRC_BK33A_FD        (REG_FRC_BANK_BASE+0x33AFD)
#define REG_FRC_BK33A_FE        (REG_FRC_BANK_BASE+0x33AFE)
#define REG_FRC_BK33A_FF        (REG_FRC_BANK_BASE+0x33AFF)

#define REG_FRC_BK261_60        (REG_FRC_BANK_BASE+0x26160)
#define REG_FRC_BK271_60        (REG_FRC_BANK_BASE+0x27160)

#define REG_FRC_BK23_40         (REG_FRC_BANK_BASE+0x2340)
#define REG_FRC_BK23_60         (REG_FRC_BANK_BASE+0x2360)
#define REG_FRC_BK23_80         (REG_FRC_BANK_BASE+0x2380)

// === SC BK4F
#define REG_SC_BK4F_00        (REG_SCALER_BASE+0x4F00)
#define REG_SC_BK4F_01        (REG_SCALER_BASE+0x4F01)
#define REG_SC_BK4F_02        (REG_SCALER_BASE+0x4F02)
#define REG_SC_BK4F_03        (REG_SCALER_BASE+0x4F03)
#define REG_SC_BK4F_04        (REG_SCALER_BASE+0x4F04)
#define REG_SC_BK4F_05        (REG_SCALER_BASE+0x4F05)
#define REG_SC_BK4F_06        (REG_SCALER_BASE+0x4F06)
#define REG_SC_BK4F_07        (REG_SCALER_BASE+0x4F07)
#define REG_SC_BK4F_08        (REG_SCALER_BASE+0x4F08)
#define REG_SC_BK4F_09        (REG_SCALER_BASE+0x4F09)
#define REG_SC_BK4F_0A        (REG_SCALER_BASE+0x4F0A)
#define REG_SC_BK4F_0B        (REG_SCALER_BASE+0x4F0B)
#define REG_SC_BK4F_0C        (REG_SCALER_BASE+0x4F0C)
#define REG_SC_BK4F_0D        (REG_SCALER_BASE+0x4F0D)
#define REG_SC_BK4F_0E        (REG_SCALER_BASE+0x4F0E)
#define REG_SC_BK4F_0F        (REG_SCALER_BASE+0x4F0F)
#define REG_SC_BK4F_10        (REG_SCALER_BASE+0x4F10)
#define REG_SC_BK4F_11        (REG_SCALER_BASE+0x4F11)
#define REG_SC_BK4F_12        (REG_SCALER_BASE+0x4F12)
#define REG_SC_BK4F_13        (REG_SCALER_BASE+0x4F13)
#define REG_SC_BK4F_14        (REG_SCALER_BASE+0x4F14)
#define REG_SC_BK4F_15        (REG_SCALER_BASE+0x4F15)
#define REG_SC_BK4F_16        (REG_SCALER_BASE+0x4F16)
#define REG_SC_BK4F_17        (REG_SCALER_BASE+0x4F17)
#define REG_SC_BK4F_18        (REG_SCALER_BASE+0x4F18)
#define REG_SC_BK4F_19        (REG_SCALER_BASE+0x4F19)
#define REG_SC_BK4F_1A        (REG_SCALER_BASE+0x4F1A)
#define REG_SC_BK4F_1B        (REG_SCALER_BASE+0x4F1B)
#define REG_SC_BK4F_1C        (REG_SCALER_BASE+0x4F1C)
#define REG_SC_BK4F_1D        (REG_SCALER_BASE+0x4F1D)
#define REG_SC_BK4F_1E        (REG_SCALER_BASE+0x4F1E)
#define REG_SC_BK4F_1F        (REG_SCALER_BASE+0x4F1F)
#define REG_SC_BK4F_20        (REG_SCALER_BASE+0x4F20)
#define REG_SC_BK4F_21        (REG_SCALER_BASE+0x4F21)
#define REG_SC_BK4F_22        (REG_SCALER_BASE+0x4F22)
#define REG_SC_BK4F_23        (REG_SCALER_BASE+0x4F23)
#define REG_SC_BK4F_24        (REG_SCALER_BASE+0x4F24)
#define REG_SC_BK4F_25        (REG_SCALER_BASE+0x4F25)
#define REG_SC_BK4F_26        (REG_SCALER_BASE+0x4F26)
#define REG_SC_BK4F_27        (REG_SCALER_BASE+0x4F27)
#define REG_SC_BK4F_28        (REG_SCALER_BASE+0x4F28)
#define REG_SC_BK4F_29        (REG_SCALER_BASE+0x4F29)
#define REG_SC_BK4F_2A        (REG_SCALER_BASE+0x4F2A)
#define REG_SC_BK4F_2B        (REG_SCALER_BASE+0x4F2B)
#define REG_SC_BK4F_2C        (REG_SCALER_BASE+0x4F2C)
#define REG_SC_BK4F_2D        (REG_SCALER_BASE+0x4F2D)
#define REG_SC_BK4F_2E        (REG_SCALER_BASE+0x4F2E)
#define REG_SC_BK4F_2F        (REG_SCALER_BASE+0x4F2F)
#define REG_SC_BK4F_30        (REG_SCALER_BASE+0x4F30)
#define REG_SC_BK4F_31        (REG_SCALER_BASE+0x4F31)
#define REG_SC_BK4F_32        (REG_SCALER_BASE+0x4F32)
#define REG_SC_BK4F_33        (REG_SCALER_BASE+0x4F33)
#define REG_SC_BK4F_34        (REG_SCALER_BASE+0x4F34)
#define REG_SC_BK4F_35        (REG_SCALER_BASE+0x4F35)
#define REG_SC_BK4F_36        (REG_SCALER_BASE+0x4F36)
#define REG_SC_BK4F_37        (REG_SCALER_BASE+0x4F37)
#define REG_SC_BK4F_38        (REG_SCALER_BASE+0x4F38)
#define REG_SC_BK4F_39        (REG_SCALER_BASE+0x4F39)
#define REG_SC_BK4F_3A        (REG_SCALER_BASE+0x4F3A)
#define REG_SC_BK4F_3B        (REG_SCALER_BASE+0x4F3B)
#define REG_SC_BK4F_3C        (REG_SCALER_BASE+0x4F3C)
#define REG_SC_BK4F_3D        (REG_SCALER_BASE+0x4F3D)
#define REG_SC_BK4F_3E        (REG_SCALER_BASE+0x4F3E)
#define REG_SC_BK4F_3F        (REG_SCALER_BASE+0x4F3F)
#define REG_SC_BK4F_40        (REG_SCALER_BASE+0x4F40)
#define REG_SC_BK4F_41        (REG_SCALER_BASE+0x4F41)
#define REG_SC_BK4F_42        (REG_SCALER_BASE+0x4F42)
#define REG_SC_BK4F_43        (REG_SCALER_BASE+0x4F43)
#define REG_SC_BK4F_44        (REG_SCALER_BASE+0x4F44)
#define REG_SC_BK4F_45        (REG_SCALER_BASE+0x4F45)
#define REG_SC_BK4F_46        (REG_SCALER_BASE+0x4F46)
#define REG_SC_BK4F_47        (REG_SCALER_BASE+0x4F47)
#define REG_SC_BK4F_48        (REG_SCALER_BASE+0x4F48)
#define REG_SC_BK4F_49        (REG_SCALER_BASE+0x4F49)
#define REG_SC_BK4F_4A        (REG_SCALER_BASE+0x4F4A)
#define REG_SC_BK4F_4B        (REG_SCALER_BASE+0x4F4B)
#define REG_SC_BK4F_4C        (REG_SCALER_BASE+0x4F4C)
#define REG_SC_BK4F_4D        (REG_SCALER_BASE+0x4F4D)
#define REG_SC_BK4F_4E        (REG_SCALER_BASE+0x4F4E)
#define REG_SC_BK4F_4F        (REG_SCALER_BASE+0x4F4F)
#define REG_SC_BK4F_50        (REG_SCALER_BASE+0x4F50)
#define REG_SC_BK4F_51        (REG_SCALER_BASE+0x4F51)
#define REG_SC_BK4F_52        (REG_SCALER_BASE+0x4F52)
#define REG_SC_BK4F_53        (REG_SCALER_BASE+0x4F53)
#define REG_SC_BK4F_54        (REG_SCALER_BASE+0x4F54)
#define REG_SC_BK4F_55        (REG_SCALER_BASE+0x4F55)
#define REG_SC_BK4F_56        (REG_SCALER_BASE+0x4F56)
#define REG_SC_BK4F_57        (REG_SCALER_BASE+0x4F57)
#define REG_SC_BK4F_58        (REG_SCALER_BASE+0x4F58)
#define REG_SC_BK4F_59        (REG_SCALER_BASE+0x4F59)
#define REG_SC_BK4F_5A        (REG_SCALER_BASE+0x4F5A)
#define REG_SC_BK4F_5B        (REG_SCALER_BASE+0x4F5B)
#define REG_SC_BK4F_5C        (REG_SCALER_BASE+0x4F5C)
#define REG_SC_BK4F_5D        (REG_SCALER_BASE+0x4F5D)
#define REG_SC_BK4F_5E        (REG_SCALER_BASE+0x4F5E)
#define REG_SC_BK4F_5F        (REG_SCALER_BASE+0x4F5F)
#define REG_SC_BK4F_60        (REG_SCALER_BASE+0x4F60)
#define REG_SC_BK4F_61        (REG_SCALER_BASE+0x4F61)
#define REG_SC_BK4F_62        (REG_SCALER_BASE+0x4F62)
#define REG_SC_BK4F_63        (REG_SCALER_BASE+0x4F63)
#define REG_SC_BK4F_64        (REG_SCALER_BASE+0x4F64)
#define REG_SC_BK4F_65        (REG_SCALER_BASE+0x4F65)
#define REG_SC_BK4F_66        (REG_SCALER_BASE+0x4F66)
#define REG_SC_BK4F_67        (REG_SCALER_BASE+0x4F67)
#define REG_SC_BK4F_68        (REG_SCALER_BASE+0x4F68)
#define REG_SC_BK4F_69        (REG_SCALER_BASE+0x4F69)
#define REG_SC_BK4F_6A        (REG_SCALER_BASE+0x4F6A)
#define REG_SC_BK4F_6B        (REG_SCALER_BASE+0x4F6B)
#define REG_SC_BK4F_6C        (REG_SCALER_BASE+0x4F6C)
#define REG_SC_BK4F_6D        (REG_SCALER_BASE+0x4F6D)
#define REG_SC_BK4F_6E        (REG_SCALER_BASE+0x4F6E)
#define REG_SC_BK4F_6F        (REG_SCALER_BASE+0x4F6F)
#define REG_SC_BK4F_70        (REG_SCALER_BASE+0x4F70)
#define REG_SC_BK4F_71        (REG_SCALER_BASE+0x4F71)
#define REG_SC_BK4F_72        (REG_SCALER_BASE+0x4F72)
#define REG_SC_BK4F_73        (REG_SCALER_BASE+0x4F73)
#define REG_SC_BK4F_74        (REG_SCALER_BASE+0x4F74)
#define REG_SC_BK4F_75        (REG_SCALER_BASE+0x4F75)
#define REG_SC_BK4F_76        (REG_SCALER_BASE+0x4F76)
#define REG_SC_BK4F_77        (REG_SCALER_BASE+0x4F77)
#define REG_SC_BK4F_78        (REG_SCALER_BASE+0x4F78)
#define REG_SC_BK4F_79        (REG_SCALER_BASE+0x4F79)
#define REG_SC_BK4F_7A        (REG_SCALER_BASE+0x4F7A)
#define REG_SC_BK4F_7B        (REG_SCALER_BASE+0x4F7B)
#define REG_SC_BK4F_7C        (REG_SCALER_BASE+0x4F7C)
#define REG_SC_BK4F_7D        (REG_SCALER_BASE+0x4F7D)
#define REG_SC_BK4F_7E        (REG_SCALER_BASE+0x4F7E)
#define REG_SC_BK4F_7F        (REG_SCALER_BASE+0x4F7F)
#define REG_SC_BK4F_80        (REG_SCALER_BASE+0x4F80)
#define REG_SC_BK4F_81        (REG_SCALER_BASE+0x4F81)
#define REG_SC_BK4F_82        (REG_SCALER_BASE+0x4F82)
#define REG_SC_BK4F_83        (REG_SCALER_BASE+0x4F83)
#define REG_SC_BK4F_84        (REG_SCALER_BASE+0x4F84)
#define REG_SC_BK4F_85        (REG_SCALER_BASE+0x4F85)
#define REG_SC_BK4F_86        (REG_SCALER_BASE+0x4F86)
#define REG_SC_BK4F_87        (REG_SCALER_BASE+0x4F87)
#define REG_SC_BK4F_88        (REG_SCALER_BASE+0x4F88)
#define REG_SC_BK4F_89        (REG_SCALER_BASE+0x4F89)
#define REG_SC_BK4F_8A        (REG_SCALER_BASE+0x4F8A)
#define REG_SC_BK4F_8B        (REG_SCALER_BASE+0x4F8B)
#define REG_SC_BK4F_8C        (REG_SCALER_BASE+0x4F8C)
#define REG_SC_BK4F_8D        (REG_SCALER_BASE+0x4F8D)
#define REG_SC_BK4F_8E        (REG_SCALER_BASE+0x4F8E)
#define REG_SC_BK4F_8F        (REG_SCALER_BASE+0x4F8F)
#define REG_SC_BK4F_90        (REG_SCALER_BASE+0x4F90)
#define REG_SC_BK4F_91        (REG_SCALER_BASE+0x4F91)
#define REG_SC_BK4F_92        (REG_SCALER_BASE+0x4F92)
#define REG_SC_BK4F_93        (REG_SCALER_BASE+0x4F93)
#define REG_SC_BK4F_94        (REG_SCALER_BASE+0x4F94)
#define REG_SC_BK4F_95        (REG_SCALER_BASE+0x4F95)
#define REG_SC_BK4F_96        (REG_SCALER_BASE+0x4F96)
#define REG_SC_BK4F_97        (REG_SCALER_BASE+0x4F97)
#define REG_SC_BK4F_98        (REG_SCALER_BASE+0x4F98)
#define REG_SC_BK4F_99        (REG_SCALER_BASE+0x4F99)
#define REG_SC_BK4F_9A        (REG_SCALER_BASE+0x4F9A)
#define REG_SC_BK4F_9B        (REG_SCALER_BASE+0x4F9B)
#define REG_SC_BK4F_9C        (REG_SCALER_BASE+0x4F9C)
#define REG_SC_BK4F_9D        (REG_SCALER_BASE+0x4F9D)
#define REG_SC_BK4F_9E        (REG_SCALER_BASE+0x4F9E)
#define REG_SC_BK4F_9F        (REG_SCALER_BASE+0x4F9F)
#define REG_SC_BK4F_A0        (REG_SCALER_BASE+0x4FA0)
#define REG_SC_BK4F_A1        (REG_SCALER_BASE+0x4FA1)
#define REG_SC_BK4F_A2        (REG_SCALER_BASE+0x4FA2)
#define REG_SC_BK4F_A3        (REG_SCALER_BASE+0x4FA3)
#define REG_SC_BK4F_A4        (REG_SCALER_BASE+0x4FA4)
#define REG_SC_BK4F_A5        (REG_SCALER_BASE+0x4FA5)
#define REG_SC_BK4F_A6        (REG_SCALER_BASE+0x4FA6)
#define REG_SC_BK4F_A7        (REG_SCALER_BASE+0x4FA7)
#define REG_SC_BK4F_A8        (REG_SCALER_BASE+0x4FA8)
#define REG_SC_BK4F_A9        (REG_SCALER_BASE+0x4FA9)
#define REG_SC_BK4F_AA        (REG_SCALER_BASE+0x4FAA)
#define REG_SC_BK4F_AB        (REG_SCALER_BASE+0x4FAB)
#define REG_SC_BK4F_AC        (REG_SCALER_BASE+0x4FAC)
#define REG_SC_BK4F_AD        (REG_SCALER_BASE+0x4FAD)
#define REG_SC_BK4F_AE        (REG_SCALER_BASE+0x4FAE)
#define REG_SC_BK4F_AF        (REG_SCALER_BASE+0x4FAF)
#define REG_SC_BK4F_B0        (REG_SCALER_BASE+0x4FB0)
#define REG_SC_BK4F_B1        (REG_SCALER_BASE+0x4FB1)
#define REG_SC_BK4F_B2        (REG_SCALER_BASE+0x4FB2)
#define REG_SC_BK4F_B3        (REG_SCALER_BASE+0x4FB3)
#define REG_SC_BK4F_B4        (REG_SCALER_BASE+0x4FB4)
#define REG_SC_BK4F_B5        (REG_SCALER_BASE+0x4FB5)
#define REG_SC_BK4F_B6        (REG_SCALER_BASE+0x4FB6)
#define REG_SC_BK4F_B7        (REG_SCALER_BASE+0x4FB7)
#define REG_SC_BK4F_B8        (REG_SCALER_BASE+0x4FB8)
#define REG_SC_BK4F_B9        (REG_SCALER_BASE+0x4FB9)
#define REG_SC_BK4F_BA        (REG_SCALER_BASE+0x4FBA)
#define REG_SC_BK4F_BB        (REG_SCALER_BASE+0x4FBB)
#define REG_SC_BK4F_BC        (REG_SCALER_BASE+0x4FBC)
#define REG_SC_BK4F_BD        (REG_SCALER_BASE+0x4FBD)
#define REG_SC_BK4F_BE        (REG_SCALER_BASE+0x4FBE)
#define REG_SC_BK4F_BF        (REG_SCALER_BASE+0x4FBF)
#define REG_SC_BK4F_C0        (REG_SCALER_BASE+0x4FC0)
#define REG_SC_BK4F_C1        (REG_SCALER_BASE+0x4FC1)
#define REG_SC_BK4F_C2        (REG_SCALER_BASE+0x4FC2)
#define REG_SC_BK4F_C3        (REG_SCALER_BASE+0x4FC3)
#define REG_SC_BK4F_C4        (REG_SCALER_BASE+0x4FC4)
#define REG_SC_BK4F_C5        (REG_SCALER_BASE+0x4FC5)
#define REG_SC_BK4F_C6        (REG_SCALER_BASE+0x4FC6)
#define REG_SC_BK4F_C7        (REG_SCALER_BASE+0x4FC7)
#define REG_SC_BK4F_C8        (REG_SCALER_BASE+0x4FC8)
#define REG_SC_BK4F_C9        (REG_SCALER_BASE+0x4FC9)
#define REG_SC_BK4F_CA        (REG_SCALER_BASE+0x4FCA)
#define REG_SC_BK4F_CB        (REG_SCALER_BASE+0x4FCB)
#define REG_SC_BK4F_CC        (REG_SCALER_BASE+0x4FCC)
#define REG_SC_BK4F_CD        (REG_SCALER_BASE+0x4FCD)
#define REG_SC_BK4F_CE        (REG_SCALER_BASE+0x4FCE)
#define REG_SC_BK4F_CF        (REG_SCALER_BASE+0x4FCF)
#define REG_SC_BK4F_D0        (REG_SCALER_BASE+0x4FD0)
#define REG_SC_BK4F_D1        (REG_SCALER_BASE+0x4FD1)
#define REG_SC_BK4F_D2        (REG_SCALER_BASE+0x4FD2)
#define REG_SC_BK4F_D3        (REG_SCALER_BASE+0x4FD3)
#define REG_SC_BK4F_D4        (REG_SCALER_BASE+0x4FD4)
#define REG_SC_BK4F_D5        (REG_SCALER_BASE+0x4FD5)
#define REG_SC_BK4F_D6        (REG_SCALER_BASE+0x4FD6)
#define REG_SC_BK4F_D7        (REG_SCALER_BASE+0x4FD7)
#define REG_SC_BK4F_D8        (REG_SCALER_BASE+0x4FD8)
#define REG_SC_BK4F_D9        (REG_SCALER_BASE+0x4FD9)
#define REG_SC_BK4F_DA        (REG_SCALER_BASE+0x4FDA)
#define REG_SC_BK4F_DB        (REG_SCALER_BASE+0x4FDB)
#define REG_SC_BK4F_DC        (REG_SCALER_BASE+0x4FDC)
#define REG_SC_BK4F_DD        (REG_SCALER_BASE+0x4FDD)
#define REG_SC_BK4F_DE        (REG_SCALER_BASE+0x4FDE)
#define REG_SC_BK4F_DF        (REG_SCALER_BASE+0x4FDF)
#define REG_SC_BK4F_E0        (REG_SCALER_BASE+0x4FE0)
#define REG_SC_BK4F_E1        (REG_SCALER_BASE+0x4FE1)
#define REG_SC_BK4F_E2        (REG_SCALER_BASE+0x4FE2)
#define REG_SC_BK4F_E3        (REG_SCALER_BASE+0x4FE3)
#define REG_SC_BK4F_E4        (REG_SCALER_BASE+0x4FE4)
#define REG_SC_BK4F_E5        (REG_SCALER_BASE+0x4FE5)
#define REG_SC_BK4F_E6        (REG_SCALER_BASE+0x4FE6)
#define REG_SC_BK4F_E7        (REG_SCALER_BASE+0x4FE7)
#define REG_SC_BK4F_E8        (REG_SCALER_BASE+0x4FE8)
#define REG_SC_BK4F_E9        (REG_SCALER_BASE+0x4FE9)
#define REG_SC_BK4F_EA        (REG_SCALER_BASE+0x4FEA)
#define REG_SC_BK4F_EB        (REG_SCALER_BASE+0x4FEB)
#define REG_SC_BK4F_EC        (REG_SCALER_BASE+0x4FEC)
#define REG_SC_BK4F_ED        (REG_SCALER_BASE+0x4FED)
#define REG_SC_BK4F_EE        (REG_SCALER_BASE+0x4FEE)
#define REG_SC_BK4F_EF        (REG_SCALER_BASE+0x4FEF)
#define REG_SC_BK4F_F0        (REG_SCALER_BASE+0x4FF0)
#define REG_SC_BK4F_F1        (REG_SCALER_BASE+0x4FF1)
#define REG_SC_BK4F_F2        (REG_SCALER_BASE+0x4FF2)
#define REG_SC_BK4F_F3        (REG_SCALER_BASE+0x4FF3)
#define REG_SC_BK4F_F4        (REG_SCALER_BASE+0x4FF4)
#define REG_SC_BK4F_F5        (REG_SCALER_BASE+0x4FF5)
#define REG_SC_BK4F_F6        (REG_SCALER_BASE+0x4FF6)
#define REG_SC_BK4F_F7        (REG_SCALER_BASE+0x4FF7)
#define REG_SC_BK4F_F8        (REG_SCALER_BASE+0x4FF8)
#define REG_SC_BK4F_F9        (REG_SCALER_BASE+0x4FF9)
#define REG_SC_BK4F_FA        (REG_SCALER_BASE+0x4FFA)
#define REG_SC_BK4F_FB        (REG_SCALER_BASE+0x4FFB)
#define REG_SC_BK4F_FC        (REG_SCALER_BASE+0x4FFC)
#define REG_SC_BK4F_FD        (REG_SCALER_BASE+0x4FFD)
#define REG_SC_BK4F_FE        (REG_SCALER_BASE+0x4FFE)
#define REG_SC_BK4F_FF        (REG_SCALER_BASE+0x4FFF)

// === SC BKC6
#define REG_SC_BKC6_00        (REG_SCALER_BASE+0xC600)
#define REG_SC_BKC6_01        (REG_SCALER_BASE+0xC601)
#define REG_SC_BKC6_02        (REG_SCALER_BASE+0xC602)
#define REG_SC_BKC6_03        (REG_SCALER_BASE+0xC603)
#define REG_SC_BKC6_04        (REG_SCALER_BASE+0xC604)
#define REG_SC_BKC6_05        (REG_SCALER_BASE+0xC605)
#define REG_SC_BKC6_06        (REG_SCALER_BASE+0xC606)
#define REG_SC_BKC6_07        (REG_SCALER_BASE+0xC607)
#define REG_SC_BKC6_08        (REG_SCALER_BASE+0xC608)
#define REG_SC_BKC6_09        (REG_SCALER_BASE+0xC609)
#define REG_SC_BKC6_0A        (REG_SCALER_BASE+0xC60A)
#define REG_SC_BKC6_0B        (REG_SCALER_BASE+0xC60B)
#define REG_SC_BKC6_0C        (REG_SCALER_BASE+0xC60C)
#define REG_SC_BKC6_0D        (REG_SCALER_BASE+0xC60D)
#define REG_SC_BKC6_0E        (REG_SCALER_BASE+0xC60E)
#define REG_SC_BKC6_0F        (REG_SCALER_BASE+0xC60F)
#define REG_SC_BKC6_10        (REG_SCALER_BASE+0xC610)
#define REG_SC_BKC6_11        (REG_SCALER_BASE+0xC611)
#define REG_SC_BKC6_12        (REG_SCALER_BASE+0xC612)
#define REG_SC_BKC6_13        (REG_SCALER_BASE+0xC613)
#define REG_SC_BKC6_14        (REG_SCALER_BASE+0xC614)
#define REG_SC_BKC6_15        (REG_SCALER_BASE+0xC615)
#define REG_SC_BKC6_16        (REG_SCALER_BASE+0xC616)
#define REG_SC_BKC6_17        (REG_SCALER_BASE+0xC617)
#define REG_SC_BKC6_18        (REG_SCALER_BASE+0xC618)
#define REG_SC_BKC6_19        (REG_SCALER_BASE+0xC619)
#define REG_SC_BKC6_1A        (REG_SCALER_BASE+0xC61A)
#define REG_SC_BKC6_1B        (REG_SCALER_BASE+0xC61B)
#define REG_SC_BKC6_1C        (REG_SCALER_BASE+0xC61C)
#define REG_SC_BKC6_1D        (REG_SCALER_BASE+0xC61D)
#define REG_SC_BKC6_1E        (REG_SCALER_BASE+0xC61E)
#define REG_SC_BKC6_1F        (REG_SCALER_BASE+0xC61F)
#define REG_SC_BKC6_20        (REG_SCALER_BASE+0xC620)
#define REG_SC_BKC6_21        (REG_SCALER_BASE+0xC621)
#define REG_SC_BKC6_22        (REG_SCALER_BASE+0xC622)
#define REG_SC_BKC6_23        (REG_SCALER_BASE+0xC623)
#define REG_SC_BKC6_24        (REG_SCALER_BASE+0xC624)
#define REG_SC_BKC6_25        (REG_SCALER_BASE+0xC625)
#define REG_SC_BKC6_26        (REG_SCALER_BASE+0xC626)
#define REG_SC_BKC6_27        (REG_SCALER_BASE+0xC627)
#define REG_SC_BKC6_28        (REG_SCALER_BASE+0xC628)
#define REG_SC_BKC6_29        (REG_SCALER_BASE+0xC629)
#define REG_SC_BKC6_2A        (REG_SCALER_BASE+0xC62A)
#define REG_SC_BKC6_2B        (REG_SCALER_BASE+0xC62B)
#define REG_SC_BKC6_2C        (REG_SCALER_BASE+0xC62C)
#define REG_SC_BKC6_2D        (REG_SCALER_BASE+0xC62D)
#define REG_SC_BKC6_2E        (REG_SCALER_BASE+0xC62E)
#define REG_SC_BKC6_2F        (REG_SCALER_BASE+0xC62F)
#define REG_SC_BKC6_30        (REG_SCALER_BASE+0xC630)
#define REG_SC_BKC6_31        (REG_SCALER_BASE+0xC631)
#define REG_SC_BKC6_32        (REG_SCALER_BASE+0xC632)
#define REG_SC_BKC6_33        (REG_SCALER_BASE+0xC633)
#define REG_SC_BKC6_34        (REG_SCALER_BASE+0xC634)
#define REG_SC_BKC6_35        (REG_SCALER_BASE+0xC635)
#define REG_SC_BKC6_36        (REG_SCALER_BASE+0xC636)
#define REG_SC_BKC6_37        (REG_SCALER_BASE+0xC637)
#define REG_SC_BKC6_38        (REG_SCALER_BASE+0xC638)
#define REG_SC_BKC6_39        (REG_SCALER_BASE+0xC639)
#define REG_SC_BKC6_3A        (REG_SCALER_BASE+0xC63A)
#define REG_SC_BKC6_3B        (REG_SCALER_BASE+0xC63B)
#define REG_SC_BKC6_3C        (REG_SCALER_BASE+0xC63C)
#define REG_SC_BKC6_3D        (REG_SCALER_BASE+0xC63D)
#define REG_SC_BKC6_3E        (REG_SCALER_BASE+0xC63E)
#define REG_SC_BKC6_3F        (REG_SCALER_BASE+0xC63F)
#define REG_SC_BKC6_40        (REG_SCALER_BASE+0xC640)
#define REG_SC_BKC6_41        (REG_SCALER_BASE+0xC641)
#define REG_SC_BKC6_42        (REG_SCALER_BASE+0xC642)
#define REG_SC_BKC6_43        (REG_SCALER_BASE+0xC643)
#define REG_SC_BKC6_44        (REG_SCALER_BASE+0xC644)
#define REG_SC_BKC6_45        (REG_SCALER_BASE+0xC645)
#define REG_SC_BKC6_46        (REG_SCALER_BASE+0xC646)
#define REG_SC_BKC6_47        (REG_SCALER_BASE+0xC647)
#define REG_SC_BKC6_48        (REG_SCALER_BASE+0xC648)
#define REG_SC_BKC6_49        (REG_SCALER_BASE+0xC649)
#define REG_SC_BKC6_4A        (REG_SCALER_BASE+0xC64A)
#define REG_SC_BKC6_4B        (REG_SCALER_BASE+0xC64B)
#define REG_SC_BKC6_4C        (REG_SCALER_BASE+0xC64C)
#define REG_SC_BKC6_4D        (REG_SCALER_BASE+0xC64D)
#define REG_SC_BKC6_4E        (REG_SCALER_BASE+0xC64E)
#define REG_SC_BKC6_4F        (REG_SCALER_BASE+0xC64F)
#define REG_SC_BKC6_50        (REG_SCALER_BASE+0xC650)
#define REG_SC_BKC6_51        (REG_SCALER_BASE+0xC651)
#define REG_SC_BKC6_52        (REG_SCALER_BASE+0xC652)
#define REG_SC_BKC6_53        (REG_SCALER_BASE+0xC653)
#define REG_SC_BKC6_54        (REG_SCALER_BASE+0xC654)
#define REG_SC_BKC6_55        (REG_SCALER_BASE+0xC655)
#define REG_SC_BKC6_56        (REG_SCALER_BASE+0xC656)
#define REG_SC_BKC6_57        (REG_SCALER_BASE+0xC657)
#define REG_SC_BKC6_58        (REG_SCALER_BASE+0xC658)
#define REG_SC_BKC6_59        (REG_SCALER_BASE+0xC659)
#define REG_SC_BKC6_5A        (REG_SCALER_BASE+0xC65A)
#define REG_SC_BKC6_5B        (REG_SCALER_BASE+0xC65B)
#define REG_SC_BKC6_5C        (REG_SCALER_BASE+0xC65C)
#define REG_SC_BKC6_5D        (REG_SCALER_BASE+0xC65D)
#define REG_SC_BKC6_5E        (REG_SCALER_BASE+0xC65E)
#define REG_SC_BKC6_5F        (REG_SCALER_BASE+0xC65F)
#define REG_SC_BKC6_60        (REG_SCALER_BASE+0xC660)
#define REG_SC_BKC6_61        (REG_SCALER_BASE+0xC661)
#define REG_SC_BKC6_62        (REG_SCALER_BASE+0xC662)
#define REG_SC_BKC6_63        (REG_SCALER_BASE+0xC663)
#define REG_SC_BKC6_64        (REG_SCALER_BASE+0xC664)
#define REG_SC_BKC6_65        (REG_SCALER_BASE+0xC665)
#define REG_SC_BKC6_66        (REG_SCALER_BASE+0xC666)
#define REG_SC_BKC6_67        (REG_SCALER_BASE+0xC667)
#define REG_SC_BKC6_68        (REG_SCALER_BASE+0xC668)
#define REG_SC_BKC6_69        (REG_SCALER_BASE+0xC669)
#define REG_SC_BKC6_6A        (REG_SCALER_BASE+0xC66A)
#define REG_SC_BKC6_6B        (REG_SCALER_BASE+0xC66B)
#define REG_SC_BKC6_6C        (REG_SCALER_BASE+0xC66C)
#define REG_SC_BKC6_6D        (REG_SCALER_BASE+0xC66D)
#define REG_SC_BKC6_6E        (REG_SCALER_BASE+0xC66E)
#define REG_SC_BKC6_6F        (REG_SCALER_BASE+0xC66F)
#define REG_SC_BKC6_70        (REG_SCALER_BASE+0xC670)
#define REG_SC_BKC6_71        (REG_SCALER_BASE+0xC671)
#define REG_SC_BKC6_72        (REG_SCALER_BASE+0xC672)
#define REG_SC_BKC6_73        (REG_SCALER_BASE+0xC673)
#define REG_SC_BKC6_74        (REG_SCALER_BASE+0xC674)
#define REG_SC_BKC6_75        (REG_SCALER_BASE+0xC675)
#define REG_SC_BKC6_76        (REG_SCALER_BASE+0xC676)
#define REG_SC_BKC6_77        (REG_SCALER_BASE+0xC677)
#define REG_SC_BKC6_78        (REG_SCALER_BASE+0xC678)
#define REG_SC_BKC6_79        (REG_SCALER_BASE+0xC679)
#define REG_SC_BKC6_7A        (REG_SCALER_BASE+0xC67A)
#define REG_SC_BKC6_7B        (REG_SCALER_BASE+0xC67B)
#define REG_SC_BKC6_7C        (REG_SCALER_BASE+0xC67C)
#define REG_SC_BKC6_7D        (REG_SCALER_BASE+0xC67D)
#define REG_SC_BKC6_7E        (REG_SCALER_BASE+0xC67E)
#define REG_SC_BKC6_7F        (REG_SCALER_BASE+0xC67F)
#define REG_SC_BKC6_80        (REG_SCALER_BASE+0xC680)
#define REG_SC_BKC6_81        (REG_SCALER_BASE+0xC681)
#define REG_SC_BKC6_82        (REG_SCALER_BASE+0xC682)
#define REG_SC_BKC6_83        (REG_SCALER_BASE+0xC683)
#define REG_SC_BKC6_84        (REG_SCALER_BASE+0xC684)
#define REG_SC_BKC6_85        (REG_SCALER_BASE+0xC685)
#define REG_SC_BKC6_86        (REG_SCALER_BASE+0xC686)
#define REG_SC_BKC6_87        (REG_SCALER_BASE+0xC687)
#define REG_SC_BKC6_88        (REG_SCALER_BASE+0xC688)
#define REG_SC_BKC6_89        (REG_SCALER_BASE+0xC689)
#define REG_SC_BKC6_8A        (REG_SCALER_BASE+0xC68A)
#define REG_SC_BKC6_8B        (REG_SCALER_BASE+0xC68B)
#define REG_SC_BKC6_8C        (REG_SCALER_BASE+0xC68C)
#define REG_SC_BKC6_8D        (REG_SCALER_BASE+0xC68D)
#define REG_SC_BKC6_8E        (REG_SCALER_BASE+0xC68E)
#define REG_SC_BKC6_8F        (REG_SCALER_BASE+0xC68F)
#define REG_SC_BKC6_90        (REG_SCALER_BASE+0xC690)
#define REG_SC_BKC6_91        (REG_SCALER_BASE+0xC691)
#define REG_SC_BKC6_92        (REG_SCALER_BASE+0xC692)
#define REG_SC_BKC6_93        (REG_SCALER_BASE+0xC693)
#define REG_SC_BKC6_94        (REG_SCALER_BASE+0xC694)
#define REG_SC_BKC6_95        (REG_SCALER_BASE+0xC695)
#define REG_SC_BKC6_96        (REG_SCALER_BASE+0xC696)
#define REG_SC_BKC6_97        (REG_SCALER_BASE+0xC697)
#define REG_SC_BKC6_98        (REG_SCALER_BASE+0xC698)
#define REG_SC_BKC6_99        (REG_SCALER_BASE+0xC699)
#define REG_SC_BKC6_9A        (REG_SCALER_BASE+0xC69A)
#define REG_SC_BKC6_9B        (REG_SCALER_BASE+0xC69B)
#define REG_SC_BKC6_9C        (REG_SCALER_BASE+0xC69C)
#define REG_SC_BKC6_9D        (REG_SCALER_BASE+0xC69D)
#define REG_SC_BKC6_9E        (REG_SCALER_BASE+0xC69E)
#define REG_SC_BKC6_9F        (REG_SCALER_BASE+0xC69F)
#define REG_SC_BKC6_A0        (REG_SCALER_BASE+0xC6A0)
#define REG_SC_BKC6_A1        (REG_SCALER_BASE+0xC6A1)
#define REG_SC_BKC6_A2        (REG_SCALER_BASE+0xC6A2)
#define REG_SC_BKC6_A3        (REG_SCALER_BASE+0xC6A3)
#define REG_SC_BKC6_A4        (REG_SCALER_BASE+0xC6A4)
#define REG_SC_BKC6_A5        (REG_SCALER_BASE+0xC6A5)
#define REG_SC_BKC6_A6        (REG_SCALER_BASE+0xC6A6)
#define REG_SC_BKC6_A7        (REG_SCALER_BASE+0xC6A7)
#define REG_SC_BKC6_A8        (REG_SCALER_BASE+0xC6A8)
#define REG_SC_BKC6_A9        (REG_SCALER_BASE+0xC6A9)
#define REG_SC_BKC6_AA        (REG_SCALER_BASE+0xC6AA)
#define REG_SC_BKC6_AB        (REG_SCALER_BASE+0xC6AB)
#define REG_SC_BKC6_AC        (REG_SCALER_BASE+0xC6AC)
#define REG_SC_BKC6_AD        (REG_SCALER_BASE+0xC6AD)
#define REG_SC_BKC6_AE        (REG_SCALER_BASE+0xC6AE)
#define REG_SC_BKC6_AF        (REG_SCALER_BASE+0xC6AF)
#define REG_SC_BKC6_B0        (REG_SCALER_BASE+0xC6B0)
#define REG_SC_BKC6_B1        (REG_SCALER_BASE+0xC6B1)
#define REG_SC_BKC6_B2        (REG_SCALER_BASE+0xC6B2)
#define REG_SC_BKC6_B3        (REG_SCALER_BASE+0xC6B3)
#define REG_SC_BKC6_B4        (REG_SCALER_BASE+0xC6B4)
#define REG_SC_BKC6_B5        (REG_SCALER_BASE+0xC6B5)
#define REG_SC_BKC6_B6        (REG_SCALER_BASE+0xC6B6)
#define REG_SC_BKC6_B7        (REG_SCALER_BASE+0xC6B7)
#define REG_SC_BKC6_B8        (REG_SCALER_BASE+0xC6B8)
#define REG_SC_BKC6_B9        (REG_SCALER_BASE+0xC6B9)
#define REG_SC_BKC6_BA        (REG_SCALER_BASE+0xC6BA)
#define REG_SC_BKC6_BB        (REG_SCALER_BASE+0xC6BB)
#define REG_SC_BKC6_BC        (REG_SCALER_BASE+0xC6BC)
#define REG_SC_BKC6_BD        (REG_SCALER_BASE+0xC6BD)
#define REG_SC_BKC6_BE        (REG_SCALER_BASE+0xC6BE)
#define REG_SC_BKC6_BF        (REG_SCALER_BASE+0xC6BF)
#define REG_SC_BKC6_C0        (REG_SCALER_BASE+0xC6C0)
#define REG_SC_BKC6_C1        (REG_SCALER_BASE+0xC6C1)
#define REG_SC_BKC6_C2        (REG_SCALER_BASE+0xC6C2)
#define REG_SC_BKC6_C3        (REG_SCALER_BASE+0xC6C3)
#define REG_SC_BKC6_C4        (REG_SCALER_BASE+0xC6C4)
#define REG_SC_BKC6_C5        (REG_SCALER_BASE+0xC6C5)
#define REG_SC_BKC6_C6        (REG_SCALER_BASE+0xC6C6)
#define REG_SC_BKC6_C7        (REG_SCALER_BASE+0xC6C7)
#define REG_SC_BKC6_C8        (REG_SCALER_BASE+0xC6C8)
#define REG_SC_BKC6_C9        (REG_SCALER_BASE+0xC6C9)
#define REG_SC_BKC6_CA        (REG_SCALER_BASE+0xC6CA)
#define REG_SC_BKC6_CB        (REG_SCALER_BASE+0xC6CB)
#define REG_SC_BKC6_CC        (REG_SCALER_BASE+0xC6CC)
#define REG_SC_BKC6_CD        (REG_SCALER_BASE+0xC6CD)
#define REG_SC_BKC6_CE        (REG_SCALER_BASE+0xC6CE)
#define REG_SC_BKC6_CF        (REG_SCALER_BASE+0xC6CF)
#define REG_SC_BKC6_D0        (REG_SCALER_BASE+0xC6D0)
#define REG_SC_BKC6_D1        (REG_SCALER_BASE+0xC6D1)
#define REG_SC_BKC6_D2        (REG_SCALER_BASE+0xC6D2)
#define REG_SC_BKC6_D3        (REG_SCALER_BASE+0xC6D3)
#define REG_SC_BKC6_D4        (REG_SCALER_BASE+0xC6D4)
#define REG_SC_BKC6_D5        (REG_SCALER_BASE+0xC6D5)
#define REG_SC_BKC6_D6        (REG_SCALER_BASE+0xC6D6)
#define REG_SC_BKC6_D7        (REG_SCALER_BASE+0xC6D7)
#define REG_SC_BKC6_D8        (REG_SCALER_BASE+0xC6D8)
#define REG_SC_BKC6_D9        (REG_SCALER_BASE+0xC6D9)
#define REG_SC_BKC6_DA        (REG_SCALER_BASE+0xC6DA)
#define REG_SC_BKC6_DB        (REG_SCALER_BASE+0xC6DB)
#define REG_SC_BKC6_DC        (REG_SCALER_BASE+0xC6DC)
#define REG_SC_BKC6_DD        (REG_SCALER_BASE+0xC6DD)
#define REG_SC_BKC6_DE        (REG_SCALER_BASE+0xC6DE)
#define REG_SC_BKC6_DF        (REG_SCALER_BASE+0xC6DF)
#define REG_SC_BKC6_E0        (REG_SCALER_BASE+0xC6E0)
#define REG_SC_BKC6_E1        (REG_SCALER_BASE+0xC6E1)
#define REG_SC_BKC6_E2        (REG_SCALER_BASE+0xC6E2)
#define REG_SC_BKC6_E3        (REG_SCALER_BASE+0xC6E3)
#define REG_SC_BKC6_E4        (REG_SCALER_BASE+0xC6E4)
#define REG_SC_BKC6_E5        (REG_SCALER_BASE+0xC6E5)
#define REG_SC_BKC6_E6        (REG_SCALER_BASE+0xC6E6)
#define REG_SC_BKC6_E7        (REG_SCALER_BASE+0xC6E7)
#define REG_SC_BKC6_E8        (REG_SCALER_BASE+0xC6E8)
#define REG_SC_BKC6_E9        (REG_SCALER_BASE+0xC6E9)
#define REG_SC_BKC6_EA        (REG_SCALER_BASE+0xC6EA)
#define REG_SC_BKC6_EB        (REG_SCALER_BASE+0xC6EB)
#define REG_SC_BKC6_EC        (REG_SCALER_BASE+0xC6EC)
#define REG_SC_BKC6_ED        (REG_SCALER_BASE+0xC6ED)
#define REG_SC_BKC6_EE        (REG_SCALER_BASE+0xC6EE)
#define REG_SC_BKC6_EF        (REG_SCALER_BASE+0xC6EF)
#define REG_SC_BKC6_F0        (REG_SCALER_BASE+0xC6F0)
#define REG_SC_BKC6_F1        (REG_SCALER_BASE+0xC6F1)
#define REG_SC_BKC6_F2        (REG_SCALER_BASE+0xC6F2)
#define REG_SC_BKC6_F3        (REG_SCALER_BASE+0xC6F3)
#define REG_SC_BKC6_F4        (REG_SCALER_BASE+0xC6F4)
#define REG_SC_BKC6_F5        (REG_SCALER_BASE+0xC6F5)
#define REG_SC_BKC6_F6        (REG_SCALER_BASE+0xC6F6)
#define REG_SC_BKC6_F7        (REG_SCALER_BASE+0xC6F7)
#define REG_SC_BKC6_F8        (REG_SCALER_BASE+0xC6F8)
#define REG_SC_BKC6_F9        (REG_SCALER_BASE+0xC6F9)
#define REG_SC_BKC6_FA        (REG_SCALER_BASE+0xC6FA)
#define REG_SC_BKC6_FB        (REG_SCALER_BASE+0xC6FB)
#define REG_SC_BKC6_FC        (REG_SCALER_BASE+0xC6FC)
#define REG_SC_BKC6_FD        (REG_SCALER_BASE+0xC6FD)
#define REG_SC_BKC6_FE        (REG_SCALER_BASE+0xC6FE)
#define REG_SC_BKC6_FF        (REG_SCALER_BASE+0xC6FF)

#define REG_FSC_BK03_62        (REG_FSC_BANK_BASE+0x0362)
#define REG_FSC_BK03_64        (REG_FSC_BANK_BASE+0x0364)

// === FSC BK00
#define REG_FSC_BK00_00        (REG_FSC_BANK_BASE+0x0000)
#define REG_FSC_BK00_01        (REG_FSC_BANK_BASE+0x0001)
#define REG_FSC_BK00_02        (REG_FSC_BANK_BASE+0x0002)
#define REG_FSC_BK00_03        (REG_FSC_BANK_BASE+0x0003)
#define REG_FSC_BK00_04        (REG_FSC_BANK_BASE+0x0004)
#define REG_FSC_BK00_05        (REG_FSC_BANK_BASE+0x0005)
#define REG_FSC_BK00_06        (REG_FSC_BANK_BASE+0x0006)
#define REG_FSC_BK00_07        (REG_FSC_BANK_BASE+0x0007)
#define REG_FSC_BK00_08        (REG_FSC_BANK_BASE+0x0008)
#define REG_FSC_BK00_09        (REG_FSC_BANK_BASE+0x0009)
#define REG_FSC_BK00_0A        (REG_FSC_BANK_BASE+0x000A)
#define REG_FSC_BK00_0B        (REG_FSC_BANK_BASE+0x000B)
#define REG_FSC_BK00_0C        (REG_FSC_BANK_BASE+0x000C)
#define REG_FSC_BK00_0D        (REG_FSC_BANK_BASE+0x000D)
#define REG_FSC_BK00_0E        (REG_FSC_BANK_BASE+0x000E)
#define REG_FSC_BK00_0F        (REG_FSC_BANK_BASE+0x000F)
#define REG_FSC_BK00_10        (REG_FSC_BANK_BASE+0x0010)
#define REG_FSC_BK00_11        (REG_FSC_BANK_BASE+0x0011)
#define REG_FSC_BK00_12        (REG_FSC_BANK_BASE+0x0012)
#define REG_FSC_BK00_13        (REG_FSC_BANK_BASE+0x0013)
#define REG_FSC_BK00_14        (REG_FSC_BANK_BASE+0x0014)
#define REG_FSC_BK00_15        (REG_FSC_BANK_BASE+0x0015)
#define REG_FSC_BK00_16        (REG_FSC_BANK_BASE+0x0016)
#define REG_FSC_BK00_17        (REG_FSC_BANK_BASE+0x0017)
#define REG_FSC_BK00_18        (REG_FSC_BANK_BASE+0x0018)
#define REG_FSC_BK00_19        (REG_FSC_BANK_BASE+0x0019)
#define REG_FSC_BK00_1A        (REG_FSC_BANK_BASE+0x001A)
#define REG_FSC_BK00_1B        (REG_FSC_BANK_BASE+0x001B)
#define REG_FSC_BK00_1C        (REG_FSC_BANK_BASE+0x001C)
#define REG_FSC_BK00_1D        (REG_FSC_BANK_BASE+0x001D)
#define REG_FSC_BK00_1E        (REG_FSC_BANK_BASE+0x001E)
#define REG_FSC_BK00_1F        (REG_FSC_BANK_BASE+0x001F)
#define REG_FSC_BK00_20        (REG_FSC_BANK_BASE+0x0020)
#define REG_FSC_BK00_21        (REG_FSC_BANK_BASE+0x0021)
#define REG_FSC_BK00_22        (REG_FSC_BANK_BASE+0x0022)
#define REG_FSC_BK00_23        (REG_FSC_BANK_BASE+0x0023)
#define REG_FSC_BK00_24        (REG_FSC_BANK_BASE+0x0024)
#define REG_FSC_BK00_25        (REG_FSC_BANK_BASE+0x0025)
#define REG_FSC_BK00_26        (REG_FSC_BANK_BASE+0x0026)
#define REG_FSC_BK00_27        (REG_FSC_BANK_BASE+0x0027)
#define REG_FSC_BK00_28        (REG_FSC_BANK_BASE+0x0028)
#define REG_FSC_BK00_29        (REG_FSC_BANK_BASE+0x0029)
#define REG_FSC_BK00_2A        (REG_FSC_BANK_BASE+0x002A)
#define REG_FSC_BK00_2B        (REG_FSC_BANK_BASE+0x002B)
#define REG_FSC_BK00_2C        (REG_FSC_BANK_BASE+0x002C)
#define REG_FSC_BK00_2D        (REG_FSC_BANK_BASE+0x002D)
#define REG_FSC_BK00_2E        (REG_FSC_BANK_BASE+0x002E)
#define REG_FSC_BK00_2F        (REG_FSC_BANK_BASE+0x002F)
#define REG_FSC_BK00_30        (REG_FSC_BANK_BASE+0x0030)
#define REG_FSC_BK00_31        (REG_FSC_BANK_BASE+0x0031)
#define REG_FSC_BK00_32        (REG_FSC_BANK_BASE+0x0032)
#define REG_FSC_BK00_33        (REG_FSC_BANK_BASE+0x0033)
#define REG_FSC_BK00_34        (REG_FSC_BANK_BASE+0x0034)
#define REG_FSC_BK00_35        (REG_FSC_BANK_BASE+0x0035)
#define REG_FSC_BK00_36        (REG_FSC_BANK_BASE+0x0036)
#define REG_FSC_BK00_37        (REG_FSC_BANK_BASE+0x0037)
#define REG_FSC_BK00_38        (REG_FSC_BANK_BASE+0x0038)
#define REG_FSC_BK00_39        (REG_FSC_BANK_BASE+0x0039)
#define REG_FSC_BK00_3A        (REG_FSC_BANK_BASE+0x003A)
#define REG_FSC_BK00_3B        (REG_FSC_BANK_BASE+0x003B)
#define REG_FSC_BK00_3C        (REG_FSC_BANK_BASE+0x003C)
#define REG_FSC_BK00_3D        (REG_FSC_BANK_BASE+0x003D)
#define REG_FSC_BK00_3E        (REG_FSC_BANK_BASE+0x003E)
#define REG_FSC_BK00_3F        (REG_FSC_BANK_BASE+0x003F)
#define REG_FSC_BK00_40        (REG_FSC_BANK_BASE+0x0040)
#define REG_FSC_BK00_41        (REG_FSC_BANK_BASE+0x0041)
#define REG_FSC_BK00_42        (REG_FSC_BANK_BASE+0x0042)
#define REG_FSC_BK00_43        (REG_FSC_BANK_BASE+0x0043)
#define REG_FSC_BK00_44        (REG_FSC_BANK_BASE+0x0044)
#define REG_FSC_BK00_45        (REG_FSC_BANK_BASE+0x0045)
#define REG_FSC_BK00_46        (REG_FSC_BANK_BASE+0x0046)
#define REG_FSC_BK00_47        (REG_FSC_BANK_BASE+0x0047)
#define REG_FSC_BK00_48        (REG_FSC_BANK_BASE+0x0048)
#define REG_FSC_BK00_49        (REG_FSC_BANK_BASE+0x0049)
#define REG_FSC_BK00_4A        (REG_FSC_BANK_BASE+0x004A)
#define REG_FSC_BK00_4B        (REG_FSC_BANK_BASE+0x004B)
#define REG_FSC_BK00_4C        (REG_FSC_BANK_BASE+0x004C)
#define REG_FSC_BK00_4D        (REG_FSC_BANK_BASE+0x004D)
#define REG_FSC_BK00_4E        (REG_FSC_BANK_BASE+0x004E)
#define REG_FSC_BK00_4F        (REG_FSC_BANK_BASE+0x004F)
#define REG_FSC_BK00_50        (REG_FSC_BANK_BASE+0x0050)
#define REG_FSC_BK00_51        (REG_FSC_BANK_BASE+0x0051)
#define REG_FSC_BK00_52        (REG_FSC_BANK_BASE+0x0052)
#define REG_FSC_BK00_53        (REG_FSC_BANK_BASE+0x0053)
#define REG_FSC_BK00_54        (REG_FSC_BANK_BASE+0x0054)
#define REG_FSC_BK00_55        (REG_FSC_BANK_BASE+0x0055)
#define REG_FSC_BK00_56        (REG_FSC_BANK_BASE+0x0056)
#define REG_FSC_BK00_57        (REG_FSC_BANK_BASE+0x0057)
#define REG_FSC_BK00_58        (REG_FSC_BANK_BASE+0x0058)
#define REG_FSC_BK00_59        (REG_FSC_BANK_BASE+0x0059)
#define REG_FSC_BK00_5A        (REG_FSC_BANK_BASE+0x005A)
#define REG_FSC_BK00_5B        (REG_FSC_BANK_BASE+0x005B)
#define REG_FSC_BK00_5C        (REG_FSC_BANK_BASE+0x005C)
#define REG_FSC_BK00_5D        (REG_FSC_BANK_BASE+0x005D)
#define REG_FSC_BK00_5E        (REG_FSC_BANK_BASE+0x005E)
#define REG_FSC_BK00_5F        (REG_FSC_BANK_BASE+0x005F)
#define REG_FSC_BK00_60        (REG_FSC_BANK_BASE+0x0060)
#define REG_FSC_BK00_61        (REG_FSC_BANK_BASE+0x0061)
#define REG_FSC_BK00_62        (REG_FSC_BANK_BASE+0x0062)
#define REG_FSC_BK00_63        (REG_FSC_BANK_BASE+0x0063)
#define REG_FSC_BK00_64        (REG_FSC_BANK_BASE+0x0064)
#define REG_FSC_BK00_65        (REG_FSC_BANK_BASE+0x0065)
#define REG_FSC_BK00_66        (REG_FSC_BANK_BASE+0x0066)
#define REG_FSC_BK00_67        (REG_FSC_BANK_BASE+0x0067)
#define REG_FSC_BK00_68        (REG_FSC_BANK_BASE+0x0068)
#define REG_FSC_BK00_69        (REG_FSC_BANK_BASE+0x0069)
#define REG_FSC_BK00_6A        (REG_FSC_BANK_BASE+0x006A)
#define REG_FSC_BK00_6B        (REG_FSC_BANK_BASE+0x006B)
#define REG_FSC_BK00_6C        (REG_FSC_BANK_BASE+0x006C)
#define REG_FSC_BK00_6D        (REG_FSC_BANK_BASE+0x006D)
#define REG_FSC_BK00_6E        (REG_FSC_BANK_BASE+0x006E)
#define REG_FSC_BK00_6F        (REG_FSC_BANK_BASE+0x006F)
#define REG_FSC_BK00_70        (REG_FSC_BANK_BASE+0x0070)
#define REG_FSC_BK00_71        (REG_FSC_BANK_BASE+0x0071)
#define REG_FSC_BK00_72        (REG_FSC_BANK_BASE+0x0072)
#define REG_FSC_BK00_73        (REG_FSC_BANK_BASE+0x0073)
#define REG_FSC_BK00_74        (REG_FSC_BANK_BASE+0x0074)
#define REG_FSC_BK00_75        (REG_FSC_BANK_BASE+0x0075)
#define REG_FSC_BK00_76        (REG_FSC_BANK_BASE+0x0076)
#define REG_FSC_BK00_77        (REG_FSC_BANK_BASE+0x0077)
#define REG_FSC_BK00_78        (REG_FSC_BANK_BASE+0x0078)
#define REG_FSC_BK00_79        (REG_FSC_BANK_BASE+0x0079)
#define REG_FSC_BK00_7A        (REG_FSC_BANK_BASE+0x007A)
#define REG_FSC_BK00_7B        (REG_FSC_BANK_BASE+0x007B)
#define REG_FSC_BK00_7C        (REG_FSC_BANK_BASE+0x007C)
#define REG_FSC_BK00_7D        (REG_FSC_BANK_BASE+0x007D)
#define REG_FSC_BK00_7E        (REG_FSC_BANK_BASE+0x007E)
#define REG_FSC_BK00_7F        (REG_FSC_BANK_BASE+0x007F)
#define REG_FSC_BK00_80        (REG_FSC_BANK_BASE+0x0080)
#define REG_FSC_BK00_81        (REG_FSC_BANK_BASE+0x0081)
#define REG_FSC_BK00_82        (REG_FSC_BANK_BASE+0x0082)
#define REG_FSC_BK00_83        (REG_FSC_BANK_BASE+0x0083)
#define REG_FSC_BK00_84        (REG_FSC_BANK_BASE+0x0084)
#define REG_FSC_BK00_85        (REG_FSC_BANK_BASE+0x0085)
#define REG_FSC_BK00_86        (REG_FSC_BANK_BASE+0x0086)
#define REG_FSC_BK00_87        (REG_FSC_BANK_BASE+0x0087)
#define REG_FSC_BK00_88        (REG_FSC_BANK_BASE+0x0088)
#define REG_FSC_BK00_89        (REG_FSC_BANK_BASE+0x0089)
#define REG_FSC_BK00_8A        (REG_FSC_BANK_BASE+0x008A)
#define REG_FSC_BK00_8B        (REG_FSC_BANK_BASE+0x008B)
#define REG_FSC_BK00_8C        (REG_FSC_BANK_BASE+0x008C)
#define REG_FSC_BK00_8D        (REG_FSC_BANK_BASE+0x008D)
#define REG_FSC_BK00_8E        (REG_FSC_BANK_BASE+0x008E)
#define REG_FSC_BK00_8F        (REG_FSC_BANK_BASE+0x008F)
#define REG_FSC_BK00_90        (REG_FSC_BANK_BASE+0x0090)
#define REG_FSC_BK00_91        (REG_FSC_BANK_BASE+0x0091)
#define REG_FSC_BK00_92        (REG_FSC_BANK_BASE+0x0092)
#define REG_FSC_BK00_93        (REG_FSC_BANK_BASE+0x0093)
#define REG_FSC_BK00_94        (REG_FSC_BANK_BASE+0x0094)
#define REG_FSC_BK00_95        (REG_FSC_BANK_BASE+0x0095)
#define REG_FSC_BK00_96        (REG_FSC_BANK_BASE+0x0096)
#define REG_FSC_BK00_97        (REG_FSC_BANK_BASE+0x0097)
#define REG_FSC_BK00_98        (REG_FSC_BANK_BASE+0x0098)
#define REG_FSC_BK00_99        (REG_FSC_BANK_BASE+0x0099)
#define REG_FSC_BK00_9A        (REG_FSC_BANK_BASE+0x009A)
#define REG_FSC_BK00_9B        (REG_FSC_BANK_BASE+0x009B)
#define REG_FSC_BK00_9C        (REG_FSC_BANK_BASE+0x009C)
#define REG_FSC_BK00_9D        (REG_FSC_BANK_BASE+0x009D)
#define REG_FSC_BK00_9E        (REG_FSC_BANK_BASE+0x009E)
#define REG_FSC_BK00_9F        (REG_FSC_BANK_BASE+0x009F)
#define REG_FSC_BK00_A0        (REG_FSC_BANK_BASE+0x00A0)
#define REG_FSC_BK00_A1        (REG_FSC_BANK_BASE+0x00A1)
#define REG_FSC_BK00_A2        (REG_FSC_BANK_BASE+0x00A2)
#define REG_FSC_BK00_A3        (REG_FSC_BANK_BASE+0x00A3)
#define REG_FSC_BK00_A4        (REG_FSC_BANK_BASE+0x00A4)
#define REG_FSC_BK00_A5        (REG_FSC_BANK_BASE+0x00A5)
#define REG_FSC_BK00_A6        (REG_FSC_BANK_BASE+0x00A6)
#define REG_FSC_BK00_A7        (REG_FSC_BANK_BASE+0x00A7)
#define REG_FSC_BK00_A8        (REG_FSC_BANK_BASE+0x00A8)
#define REG_FSC_BK00_A9        (REG_FSC_BANK_BASE+0x00A9)
#define REG_FSC_BK00_AA        (REG_FSC_BANK_BASE+0x00AA)
#define REG_FSC_BK00_AB        (REG_FSC_BANK_BASE+0x00AB)
#define REG_FSC_BK00_AC        (REG_FSC_BANK_BASE+0x00AC)
#define REG_FSC_BK00_AD        (REG_FSC_BANK_BASE+0x00AD)
#define REG_FSC_BK00_AE        (REG_FSC_BANK_BASE+0x00AE)
#define REG_FSC_BK00_AF        (REG_FSC_BANK_BASE+0x00AF)
#define REG_FSC_BK00_B0        (REG_FSC_BANK_BASE+0x00B0)
#define REG_FSC_BK00_B1        (REG_FSC_BANK_BASE+0x00B1)
#define REG_FSC_BK00_B2        (REG_FSC_BANK_BASE+0x00B2)
#define REG_FSC_BK00_B3        (REG_FSC_BANK_BASE+0x00B3)
#define REG_FSC_BK00_B4        (REG_FSC_BANK_BASE+0x00B4)
#define REG_FSC_BK00_B5        (REG_FSC_BANK_BASE+0x00B5)
#define REG_FSC_BK00_B6        (REG_FSC_BANK_BASE+0x00B6)
#define REG_FSC_BK00_B7        (REG_FSC_BANK_BASE+0x00B7)
#define REG_FSC_BK00_B8        (REG_FSC_BANK_BASE+0x00B8)
#define REG_FSC_BK00_B9        (REG_FSC_BANK_BASE+0x00B9)
#define REG_FSC_BK00_BA        (REG_FSC_BANK_BASE+0x00BA)
#define REG_FSC_BK00_BB        (REG_FSC_BANK_BASE+0x00BB)
#define REG_FSC_BK00_BC        (REG_FSC_BANK_BASE+0x00BC)
#define REG_FSC_BK00_BD        (REG_FSC_BANK_BASE+0x00BD)
#define REG_FSC_BK00_BE        (REG_FSC_BANK_BASE+0x00BE)
#define REG_FSC_BK00_BF        (REG_FSC_BANK_BASE+0x00BF)
#define REG_FSC_BK00_C0        (REG_FSC_BANK_BASE+0x00C0)
#define REG_FSC_BK00_C1        (REG_FSC_BANK_BASE+0x00C1)
#define REG_FSC_BK00_C2        (REG_FSC_BANK_BASE+0x00C2)
#define REG_FSC_BK00_C3        (REG_FSC_BANK_BASE+0x00C3)
#define REG_FSC_BK00_C4        (REG_FSC_BANK_BASE+0x00C4)
#define REG_FSC_BK00_C5        (REG_FSC_BANK_BASE+0x00C5)
#define REG_FSC_BK00_C6        (REG_FSC_BANK_BASE+0x00C6)
#define REG_FSC_BK00_C7        (REG_FSC_BANK_BASE+0x00C7)
#define REG_FSC_BK00_C8        (REG_FSC_BANK_BASE+0x00C8)
#define REG_FSC_BK00_C9        (REG_FSC_BANK_BASE+0x00C9)
#define REG_FSC_BK00_CA        (REG_FSC_BANK_BASE+0x00CA)
#define REG_FSC_BK00_CB        (REG_FSC_BANK_BASE+0x00CB)
#define REG_FSC_BK00_CC        (REG_FSC_BANK_BASE+0x00CC)
#define REG_FSC_BK00_CD        (REG_FSC_BANK_BASE+0x00CD)
#define REG_FSC_BK00_CE        (REG_FSC_BANK_BASE+0x00CE)
#define REG_FSC_BK00_CF        (REG_FSC_BANK_BASE+0x00CF)
#define REG_FSC_BK00_D0        (REG_FSC_BANK_BASE+0x00D0)
#define REG_FSC_BK00_D1        (REG_FSC_BANK_BASE+0x00D1)
#define REG_FSC_BK00_D2        (REG_FSC_BANK_BASE+0x00D2)
#define REG_FSC_BK00_D3        (REG_FSC_BANK_BASE+0x00D3)
#define REG_FSC_BK00_D4        (REG_FSC_BANK_BASE+0x00D4)
#define REG_FSC_BK00_D5        (REG_FSC_BANK_BASE+0x00D5)
#define REG_FSC_BK00_D6        (REG_FSC_BANK_BASE+0x00D6)
#define REG_FSC_BK00_D7        (REG_FSC_BANK_BASE+0x00D7)
#define REG_FSC_BK00_D8        (REG_FSC_BANK_BASE+0x00D8)
#define REG_FSC_BK00_D9        (REG_FSC_BANK_BASE+0x00D9)
#define REG_FSC_BK00_DA        (REG_FSC_BANK_BASE+0x00DA)
#define REG_FSC_BK00_DB        (REG_FSC_BANK_BASE+0x00DB)
#define REG_FSC_BK00_DC        (REG_FSC_BANK_BASE+0x00DC)
#define REG_FSC_BK00_DD        (REG_FSC_BANK_BASE+0x00DD)
#define REG_FSC_BK00_DE        (REG_FSC_BANK_BASE+0x00DE)
#define REG_FSC_BK00_DF        (REG_FSC_BANK_BASE+0x00DF)
#define REG_FSC_BK00_E0        (REG_FSC_BANK_BASE+0x00E0)
#define REG_FSC_BK00_E1        (REG_FSC_BANK_BASE+0x00E1)
#define REG_FSC_BK00_E2        (REG_FSC_BANK_BASE+0x00E2)
#define REG_FSC_BK00_E3        (REG_FSC_BANK_BASE+0x00E3)
#define REG_FSC_BK00_E4        (REG_FSC_BANK_BASE+0x00E4)
#define REG_FSC_BK00_E5        (REG_FSC_BANK_BASE+0x00E5)
#define REG_FSC_BK00_E6        (REG_FSC_BANK_BASE+0x00E6)
#define REG_FSC_BK00_E7        (REG_FSC_BANK_BASE+0x00E7)
#define REG_FSC_BK00_E8        (REG_FSC_BANK_BASE+0x00E8)
#define REG_FSC_BK00_E9        (REG_FSC_BANK_BASE+0x00E9)
#define REG_FSC_BK00_EA        (REG_FSC_BANK_BASE+0x00EA)
#define REG_FSC_BK00_EB        (REG_FSC_BANK_BASE+0x00EB)
#define REG_FSC_BK00_EC        (REG_FSC_BANK_BASE+0x00EC)
#define REG_FSC_BK00_ED        (REG_FSC_BANK_BASE+0x00ED)
#define REG_FSC_BK00_EE        (REG_FSC_BANK_BASE+0x00EE)
#define REG_FSC_BK00_EF        (REG_FSC_BANK_BASE+0x00EF)
#define REG_FSC_BK00_F0        (REG_FSC_BANK_BASE+0x00F0)
#define REG_FSC_BK00_F1        (REG_FSC_BANK_BASE+0x00F1)
#define REG_FSC_BK00_F2        (REG_FSC_BANK_BASE+0x00F2)
#define REG_FSC_BK00_F3        (REG_FSC_BANK_BASE+0x00F3)
#define REG_FSC_BK00_F4        (REG_FSC_BANK_BASE+0x00F4)
#define REG_FSC_BK00_F5        (REG_FSC_BANK_BASE+0x00F5)
#define REG_FSC_BK00_F6        (REG_FSC_BANK_BASE+0x00F6)
#define REG_FSC_BK00_F7        (REG_FSC_BANK_BASE+0x00F7)
#define REG_FSC_BK00_F8        (REG_FSC_BANK_BASE+0x00F8)
#define REG_FSC_BK00_F9        (REG_FSC_BANK_BASE+0x00F9)
#define REG_FSC_BK00_FA        (REG_FSC_BANK_BASE+0x00FA)
#define REG_FSC_BK00_FB        (REG_FSC_BANK_BASE+0x00FB)
#define REG_FSC_BK00_FC        (REG_FSC_BANK_BASE+0x00FC)
#define REG_FSC_BK00_FD        (REG_FSC_BANK_BASE+0x00FD)
#define REG_FSC_BK00_FE        (REG_FSC_BANK_BASE+0x00FE)
#define REG_FSC_BK00_FF        (REG_FSC_BANK_BASE+0x00FF)

// === FSC bk12
#define REG_FSC_BK12_00        (REG_FSC_BANK_BASE+0x1200)
#define REG_FSC_BK12_01        (REG_FSC_BANK_BASE+0x1201)
#define REG_FSC_BK12_02        (REG_FSC_BANK_BASE+0x1202)
#define REG_FSC_BK12_03        (REG_FSC_BANK_BASE+0x1203)
#define REG_FSC_BK12_04        (REG_FSC_BANK_BASE+0x1204)
#define REG_FSC_BK12_05        (REG_FSC_BANK_BASE+0x1205)
#define REG_FSC_BK12_06        (REG_FSC_BANK_BASE+0x1206)
#define REG_FSC_BK12_07        (REG_FSC_BANK_BASE+0x1207)
#define REG_FSC_BK12_08        (REG_FSC_BANK_BASE+0x1208)
#define REG_FSC_BK12_09        (REG_FSC_BANK_BASE+0x1209)
#define REG_FSC_BK12_0A        (REG_FSC_BANK_BASE+0x120A)
#define REG_FSC_BK12_0B        (REG_FSC_BANK_BASE+0x120B)
#define REG_FSC_BK12_0C        (REG_FSC_BANK_BASE+0x120C)
#define REG_FSC_BK12_0D        (REG_FSC_BANK_BASE+0x120D)
#define REG_FSC_BK12_0E        (REG_FSC_BANK_BASE+0x120E)
#define REG_FSC_BK12_0F        (REG_FSC_BANK_BASE+0x120F)
#define REG_FSC_BK12_10        (REG_FSC_BANK_BASE+0x1210)
#define REG_FSC_BK12_11        (REG_FSC_BANK_BASE+0x1211)
#define REG_FSC_BK12_12        (REG_FSC_BANK_BASE+0x1212)
#define REG_FSC_BK12_13        (REG_FSC_BANK_BASE+0x1213)
#define REG_FSC_BK12_14        (REG_FSC_BANK_BASE+0x1214)
#define REG_FSC_BK12_15        (REG_FSC_BANK_BASE+0x1215)
#define REG_FSC_BK12_16        (REG_FSC_BANK_BASE+0x1216)
#define REG_FSC_BK12_17        (REG_FSC_BANK_BASE+0x1217)
#define REG_FSC_BK12_18        (REG_FSC_BANK_BASE+0x1218)
#define REG_FSC_BK12_19        (REG_FSC_BANK_BASE+0x1219)
#define REG_FSC_BK12_1A        (REG_FSC_BANK_BASE+0x121A)
#define REG_FSC_BK12_1B        (REG_FSC_BANK_BASE+0x121B)
#define REG_FSC_BK12_1C        (REG_FSC_BANK_BASE+0x121C)
#define REG_FSC_BK12_1D        (REG_FSC_BANK_BASE+0x121D)
#define REG_FSC_BK12_1E        (REG_FSC_BANK_BASE+0x121E)
#define REG_FSC_BK12_1F        (REG_FSC_BANK_BASE+0x121F)
#define REG_FSC_BK12_20        (REG_FSC_BANK_BASE+0x1220)
#define REG_FSC_BK12_21        (REG_FSC_BANK_BASE+0x1221)
#define REG_FSC_BK12_22        (REG_FSC_BANK_BASE+0x1222)
#define REG_FSC_BK12_23        (REG_FSC_BANK_BASE+0x1223)
#define REG_FSC_BK12_24        (REG_FSC_BANK_BASE+0x1224)
#define REG_FSC_BK12_25        (REG_FSC_BANK_BASE+0x1225)
#define REG_FSC_BK12_26        (REG_FSC_BANK_BASE+0x1226)
#define REG_FSC_BK12_27        (REG_FSC_BANK_BASE+0x1227)
#define REG_FSC_BK12_28        (REG_FSC_BANK_BASE+0x1228)
#define REG_FSC_BK12_29        (REG_FSC_BANK_BASE+0x1229)
#define REG_FSC_BK12_2A        (REG_FSC_BANK_BASE+0x122A)
#define REG_FSC_BK12_2B        (REG_FSC_BANK_BASE+0x122B)
#define REG_FSC_BK12_2C        (REG_FSC_BANK_BASE+0x122C)
#define REG_FSC_BK12_2D        (REG_FSC_BANK_BASE+0x122D)
#define REG_FSC_BK12_2E        (REG_FSC_BANK_BASE+0x122E)
#define REG_FSC_BK12_2F        (REG_FSC_BANK_BASE+0x122F)
#define REG_FSC_BK12_30        (REG_FSC_BANK_BASE+0x1230)
#define REG_FSC_BK12_31        (REG_FSC_BANK_BASE+0x1231)
#define REG_FSC_BK12_32        (REG_FSC_BANK_BASE+0x1232)
#define REG_FSC_BK12_33        (REG_FSC_BANK_BASE+0x1233)
#define REG_FSC_BK12_34        (REG_FSC_BANK_BASE+0x1234)
#define REG_FSC_BK12_35        (REG_FSC_BANK_BASE+0x1235)
#define REG_FSC_BK12_36        (REG_FSC_BANK_BASE+0x1236)
#define REG_FSC_BK12_37        (REG_FSC_BANK_BASE+0x1237)
#define REG_FSC_BK12_38        (REG_FSC_BANK_BASE+0x1238)
#define REG_FSC_BK12_39        (REG_FSC_BANK_BASE+0x1239)
#define REG_FSC_BK12_3A        (REG_FSC_BANK_BASE+0x123A)
#define REG_FSC_BK12_3B        (REG_FSC_BANK_BASE+0x123B)
#define REG_FSC_BK12_3C        (REG_FSC_BANK_BASE+0x123C)
#define REG_FSC_BK12_3D        (REG_FSC_BANK_BASE+0x123D)
#define REG_FSC_BK12_3E        (REG_FSC_BANK_BASE+0x123E)
#define REG_FSC_BK12_3F        (REG_FSC_BANK_BASE+0x123F)
#define REG_FSC_BK12_40        (REG_FSC_BANK_BASE+0x1240)
#define REG_FSC_BK12_41        (REG_FSC_BANK_BASE+0x1241)
#define REG_FSC_BK12_42        (REG_FSC_BANK_BASE+0x1242)
#define REG_FSC_BK12_43        (REG_FSC_BANK_BASE+0x1243)
#define REG_FSC_BK12_44        (REG_FSC_BANK_BASE+0x1244)
#define REG_FSC_BK12_45        (REG_FSC_BANK_BASE+0x1245)
#define REG_FSC_BK12_46        (REG_FSC_BANK_BASE+0x1246)
#define REG_FSC_BK12_47        (REG_FSC_BANK_BASE+0x1247)
#define REG_FSC_BK12_48        (REG_FSC_BANK_BASE+0x1248)
#define REG_FSC_BK12_49        (REG_FSC_BANK_BASE+0x1249)
#define REG_FSC_BK12_4A        (REG_FSC_BANK_BASE+0x124A)
#define REG_FSC_BK12_4B        (REG_FSC_BANK_BASE+0x124B)
#define REG_FSC_BK12_4C        (REG_FSC_BANK_BASE+0x124C)
#define REG_FSC_BK12_4D        (REG_FSC_BANK_BASE+0x124D)
#define REG_FSC_BK12_4E        (REG_FSC_BANK_BASE+0x124E)
#define REG_FSC_BK12_4F        (REG_FSC_BANK_BASE+0x124F)
#define REG_FSC_BK12_50        (REG_FSC_BANK_BASE+0x1250)
#define REG_FSC_BK12_51        (REG_FSC_BANK_BASE+0x1251)
#define REG_FSC_BK12_52        (REG_FSC_BANK_BASE+0x1252)
#define REG_FSC_BK12_53        (REG_FSC_BANK_BASE+0x1253)
#define REG_FSC_BK12_54        (REG_FSC_BANK_BASE+0x1254)
#define REG_FSC_BK12_55        (REG_FSC_BANK_BASE+0x1255)
#define REG_FSC_BK12_56        (REG_FSC_BANK_BASE+0x1256)
#define REG_FSC_BK12_57        (REG_FSC_BANK_BASE+0x1257)
#define REG_FSC_BK12_58        (REG_FSC_BANK_BASE+0x1258)
#define REG_FSC_BK12_59        (REG_FSC_BANK_BASE+0x1259)
#define REG_FSC_BK12_5A        (REG_FSC_BANK_BASE+0x125A)
#define REG_FSC_BK12_5B        (REG_FSC_BANK_BASE+0x125B)
#define REG_FSC_BK12_5C        (REG_FSC_BANK_BASE+0x125C)
#define REG_FSC_BK12_5D        (REG_FSC_BANK_BASE+0x125D)
#define REG_FSC_BK12_5E        (REG_FSC_BANK_BASE+0x125E)
#define REG_FSC_BK12_5F        (REG_FSC_BANK_BASE+0x125F)
#define REG_FSC_BK12_60        (REG_FSC_BANK_BASE+0x1260)
#define REG_FSC_BK12_61        (REG_FSC_BANK_BASE+0x1261)
#define REG_FSC_BK12_62        (REG_FSC_BANK_BASE+0x1262)
#define REG_FSC_BK12_63        (REG_FSC_BANK_BASE+0x1263)
#define REG_FSC_BK12_64        (REG_FSC_BANK_BASE+0x1264)
#define REG_FSC_BK12_65        (REG_FSC_BANK_BASE+0x1265)
#define REG_FSC_BK12_66        (REG_FSC_BANK_BASE+0x1266)
#define REG_FSC_BK12_67        (REG_FSC_BANK_BASE+0x1267)
#define REG_FSC_BK12_68        (REG_FSC_BANK_BASE+0x1268)
#define REG_FSC_BK12_69        (REG_FSC_BANK_BASE+0x1269)
#define REG_FSC_BK12_6A        (REG_FSC_BANK_BASE+0x126A)
#define REG_FSC_BK12_6B        (REG_FSC_BANK_BASE+0x126B)
#define REG_FSC_BK12_6C        (REG_FSC_BANK_BASE+0x126C)
#define REG_FSC_BK12_6D        (REG_FSC_BANK_BASE+0x126D)
#define REG_FSC_BK12_6E        (REG_FSC_BANK_BASE+0x126E)
#define REG_FSC_BK12_6F        (REG_FSC_BANK_BASE+0x126F)
#define REG_FSC_BK12_70        (REG_FSC_BANK_BASE+0x1270)
#define REG_FSC_BK12_71        (REG_FSC_BANK_BASE+0x1271)
#define REG_FSC_BK12_72        (REG_FSC_BANK_BASE+0x1272)
#define REG_FSC_BK12_73        (REG_FSC_BANK_BASE+0x1273)
#define REG_FSC_BK12_74        (REG_FSC_BANK_BASE+0x1274)
#define REG_FSC_BK12_75        (REG_FSC_BANK_BASE+0x1275)
#define REG_FSC_BK12_76        (REG_FSC_BANK_BASE+0x1276)
#define REG_FSC_BK12_77        (REG_FSC_BANK_BASE+0x1277)
#define REG_FSC_BK12_78        (REG_FSC_BANK_BASE+0x1278)
#define REG_FSC_BK12_79        (REG_FSC_BANK_BASE+0x1279)
#define REG_FSC_BK12_7A        (REG_FSC_BANK_BASE+0x127A)
#define REG_FSC_BK12_7B        (REG_FSC_BANK_BASE+0x127B)
#define REG_FSC_BK12_7C        (REG_FSC_BANK_BASE+0x127C)
#define REG_FSC_BK12_7D        (REG_FSC_BANK_BASE+0x127D)
#define REG_FSC_BK12_7E        (REG_FSC_BANK_BASE+0x127E)
#define REG_FSC_BK12_7F        (REG_FSC_BANK_BASE+0x127F)
#define REG_FSC_BK12_80        (REG_FSC_BANK_BASE+0x1280)
#define REG_FSC_BK12_81        (REG_FSC_BANK_BASE+0x1281)
#define REG_FSC_BK12_82        (REG_FSC_BANK_BASE+0x1282)
#define REG_FSC_BK12_83        (REG_FSC_BANK_BASE+0x1283)
#define REG_FSC_BK12_84        (REG_FSC_BANK_BASE+0x1284)
#define REG_FSC_BK12_85        (REG_FSC_BANK_BASE+0x1285)
#define REG_FSC_BK12_86        (REG_FSC_BANK_BASE+0x1286)
#define REG_FSC_BK12_87        (REG_FSC_BANK_BASE+0x1287)
#define REG_FSC_BK12_88        (REG_FSC_BANK_BASE+0x1288)
#define REG_FSC_BK12_89        (REG_FSC_BANK_BASE+0x1289)
#define REG_FSC_BK12_8A        (REG_FSC_BANK_BASE+0x128A)
#define REG_FSC_BK12_8B        (REG_FSC_BANK_BASE+0x128B)
#define REG_FSC_BK12_8C        (REG_FSC_BANK_BASE+0x128C)
#define REG_FSC_BK12_8D        (REG_FSC_BANK_BASE+0x128D)
#define REG_FSC_BK12_8E        (REG_FSC_BANK_BASE+0x128E)
#define REG_FSC_BK12_8F        (REG_FSC_BANK_BASE+0x128F)
#define REG_FSC_BK12_90        (REG_FSC_BANK_BASE+0x1290)
#define REG_FSC_BK12_91        (REG_FSC_BANK_BASE+0x1291)
#define REG_FSC_BK12_92        (REG_FSC_BANK_BASE+0x1292)
#define REG_FSC_BK12_93        (REG_FSC_BANK_BASE+0x1293)
#define REG_FSC_BK12_94        (REG_FSC_BANK_BASE+0x1294)
#define REG_FSC_BK12_95        (REG_FSC_BANK_BASE+0x1295)
#define REG_FSC_BK12_96        (REG_FSC_BANK_BASE+0x1296)
#define REG_FSC_BK12_97        (REG_FSC_BANK_BASE+0x1297)
#define REG_FSC_BK12_98        (REG_FSC_BANK_BASE+0x1298)
#define REG_FSC_BK12_99        (REG_FSC_BANK_BASE+0x1299)
#define REG_FSC_BK12_9A        (REG_FSC_BANK_BASE+0x129A)
#define REG_FSC_BK12_9B        (REG_FSC_BANK_BASE+0x129B)
#define REG_FSC_BK12_9C        (REG_FSC_BANK_BASE+0x129C)
#define REG_FSC_BK12_9D        (REG_FSC_BANK_BASE+0x129D)
#define REG_FSC_BK12_9E        (REG_FSC_BANK_BASE+0x129E)
#define REG_FSC_BK12_9F        (REG_FSC_BANK_BASE+0x129F)
#define REG_FSC_BK12_A0        (REG_FSC_BANK_BASE+0x12A0)
#define REG_FSC_BK12_A1        (REG_FSC_BANK_BASE+0x12A1)
#define REG_FSC_BK12_A2        (REG_FSC_BANK_BASE+0x12A2)
#define REG_FSC_BK12_A3        (REG_FSC_BANK_BASE+0x12A3)
#define REG_FSC_BK12_A4        (REG_FSC_BANK_BASE+0x12A4)
#define REG_FSC_BK12_A5        (REG_FSC_BANK_BASE+0x12A5)
#define REG_FSC_BK12_A6        (REG_FSC_BANK_BASE+0x12A6)
#define REG_FSC_BK12_A7        (REG_FSC_BANK_BASE+0x12A7)
#define REG_FSC_BK12_A8        (REG_FSC_BANK_BASE+0x12A8)
#define REG_FSC_BK12_A9        (REG_FSC_BANK_BASE+0x12A9)
#define REG_FSC_BK12_AA        (REG_FSC_BANK_BASE+0x12AA)
#define REG_FSC_BK12_AB        (REG_FSC_BANK_BASE+0x12AB)
#define REG_FSC_BK12_AC        (REG_FSC_BANK_BASE+0x12AC)
#define REG_FSC_BK12_AD        (REG_FSC_BANK_BASE+0x12AD)
#define REG_FSC_BK12_AE        (REG_FSC_BANK_BASE+0x12AE)
#define REG_FSC_BK12_AF        (REG_FSC_BANK_BASE+0x12AF)
#define REG_FSC_BK12_B0        (REG_FSC_BANK_BASE+0x12B0)
#define REG_FSC_BK12_B1        (REG_FSC_BANK_BASE+0x12B1)
#define REG_FSC_BK12_B2        (REG_FSC_BANK_BASE+0x12B2)
#define REG_FSC_BK12_B3        (REG_FSC_BANK_BASE+0x12B3)
#define REG_FSC_BK12_B4        (REG_FSC_BANK_BASE+0x12B4)
#define REG_FSC_BK12_B5        (REG_FSC_BANK_BASE+0x12B5)
#define REG_FSC_BK12_B6        (REG_FSC_BANK_BASE+0x12B6)
#define REG_FSC_BK12_B7        (REG_FSC_BANK_BASE+0x12B7)
#define REG_FSC_BK12_B8        (REG_FSC_BANK_BASE+0x12B8)
#define REG_FSC_BK12_B9        (REG_FSC_BANK_BASE+0x12B9)
#define REG_FSC_BK12_BA        (REG_FSC_BANK_BASE+0x12BA)
#define REG_FSC_BK12_BB        (REG_FSC_BANK_BASE+0x12BB)
#define REG_FSC_BK12_BC        (REG_FSC_BANK_BASE+0x12BC)
#define REG_FSC_BK12_BD        (REG_FSC_BANK_BASE+0x12BD)
#define REG_FSC_BK12_BE        (REG_FSC_BANK_BASE+0x12BE)
#define REG_FSC_BK12_BF        (REG_FSC_BANK_BASE+0x12BF)
#define REG_FSC_BK12_C0        (REG_FSC_BANK_BASE+0x12C0)
#define REG_FSC_BK12_C1        (REG_FSC_BANK_BASE+0x12C1)
#define REG_FSC_BK12_C2        (REG_FSC_BANK_BASE+0x12C2)
#define REG_FSC_BK12_C3        (REG_FSC_BANK_BASE+0x12C3)
#define REG_FSC_BK12_C4        (REG_FSC_BANK_BASE+0x12C4)
#define REG_FSC_BK12_C5        (REG_FSC_BANK_BASE+0x12C5)
#define REG_FSC_BK12_C6        (REG_FSC_BANK_BASE+0x12C6)
#define REG_FSC_BK12_C7        (REG_FSC_BANK_BASE+0x12C7)
#define REG_FSC_BK12_C8        (REG_FSC_BANK_BASE+0x12C8)
#define REG_FSC_BK12_C9        (REG_FSC_BANK_BASE+0x12C9)
#define REG_FSC_BK12_CA        (REG_FSC_BANK_BASE+0x12CA)
#define REG_FSC_BK12_CB        (REG_FSC_BANK_BASE+0x12CB)
#define REG_FSC_BK12_CC        (REG_FSC_BANK_BASE+0x12CC)
#define REG_FSC_BK12_CD        (REG_FSC_BANK_BASE+0x12CD)
#define REG_FSC_BK12_CE        (REG_FSC_BANK_BASE+0x12CE)
#define REG_FSC_BK12_CF        (REG_FSC_BANK_BASE+0x12CF)
#define REG_FSC_BK12_D0        (REG_FSC_BANK_BASE+0x12D0)
#define REG_FSC_BK12_D1        (REG_FSC_BANK_BASE+0x12D1)
#define REG_FSC_BK12_D2        (REG_FSC_BANK_BASE+0x12D2)
#define REG_FSC_BK12_D3        (REG_FSC_BANK_BASE+0x12D3)
#define REG_FSC_BK12_D4        (REG_FSC_BANK_BASE+0x12D4)
#define REG_FSC_BK12_D5        (REG_FSC_BANK_BASE+0x12D5)
#define REG_FSC_BK12_D6        (REG_FSC_BANK_BASE+0x12D6)
#define REG_FSC_BK12_D7        (REG_FSC_BANK_BASE+0x12D7)
#define REG_FSC_BK12_D8        (REG_FSC_BANK_BASE+0x12D8)
#define REG_FSC_BK12_D9        (REG_FSC_BANK_BASE+0x12D9)
#define REG_FSC_BK12_DA        (REG_FSC_BANK_BASE+0x12DA)
#define REG_FSC_BK12_DB        (REG_FSC_BANK_BASE+0x12DB)
#define REG_FSC_BK12_DC        (REG_FSC_BANK_BASE+0x12DC)
#define REG_FSC_BK12_DD        (REG_FSC_BANK_BASE+0x12DD)
#define REG_FSC_BK12_DE        (REG_FSC_BANK_BASE+0x12DE)
#define REG_FSC_BK12_DF        (REG_FSC_BANK_BASE+0x12DF)
#define REG_FSC_BK12_E0        (REG_FSC_BANK_BASE+0x12E0)
#define REG_FSC_BK12_E1        (REG_FSC_BANK_BASE+0x12E1)
#define REG_FSC_BK12_E2        (REG_FSC_BANK_BASE+0x12E2)
#define REG_FSC_BK12_E3        (REG_FSC_BANK_BASE+0x12E3)
#define REG_FSC_BK12_E4        (REG_FSC_BANK_BASE+0x12E4)
#define REG_FSC_BK12_E5        (REG_FSC_BANK_BASE+0x12E5)
#define REG_FSC_BK12_E6        (REG_FSC_BANK_BASE+0x12E6)
#define REG_FSC_BK12_E7        (REG_FSC_BANK_BASE+0x12E7)
#define REG_FSC_BK12_E8        (REG_FSC_BANK_BASE+0x12E8)
#define REG_FSC_BK12_E9        (REG_FSC_BANK_BASE+0x12E9)
#define REG_FSC_BK12_EA        (REG_FSC_BANK_BASE+0x12EA)
#define REG_FSC_BK12_EB        (REG_FSC_BANK_BASE+0x12EB)
#define REG_FSC_BK12_EC        (REG_FSC_BANK_BASE+0x12EC)
#define REG_FSC_BK12_ED        (REG_FSC_BANK_BASE+0x12ED)
#define REG_FSC_BK12_EE        (REG_FSC_BANK_BASE+0x12EE)
#define REG_FSC_BK12_EF        (REG_FSC_BANK_BASE+0x12EF)
#define REG_FSC_BK12_F0        (REG_FSC_BANK_BASE+0x12F0)
#define REG_FSC_BK12_F1        (REG_FSC_BANK_BASE+0x12F1)
#define REG_FSC_BK12_F2        (REG_FSC_BANK_BASE+0x12F2)
#define REG_FSC_BK12_F3        (REG_FSC_BANK_BASE+0x12F3)
#define REG_FSC_BK12_F4        (REG_FSC_BANK_BASE+0x12F4)
#define REG_FSC_BK12_F5        (REG_FSC_BANK_BASE+0x12F5)
#define REG_FSC_BK12_F6        (REG_FSC_BANK_BASE+0x12F6)
#define REG_FSC_BK12_F7        (REG_FSC_BANK_BASE+0x12F7)
#define REG_FSC_BK12_F8        (REG_FSC_BANK_BASE+0x12F8)
#define REG_FSC_BK12_F9        (REG_FSC_BANK_BASE+0x12F9)
#define REG_FSC_BK12_FA        (REG_FSC_BANK_BASE+0x12FA)
#define REG_FSC_BK12_FB        (REG_FSC_BANK_BASE+0x12FB)
#define REG_FSC_BK12_FC        (REG_FSC_BANK_BASE+0x12FC)
#define REG_FSC_BK12_FD        (REG_FSC_BANK_BASE+0x12FD)
#define REG_FSC_BK12_FE        (REG_FSC_BANK_BASE+0x12FE)
#define REG_FSC_BK12_FF        (REG_FSC_BANK_BASE+0x12FF)

// === FSC bk1B
#define REG_FSC_BK1B_00        (REG_FSC_BANK_BASE+0x1B00)
#define REG_FSC_BK1B_01        (REG_FSC_BANK_BASE+0x1B01)
#define REG_FSC_BK1B_02        (REG_FSC_BANK_BASE+0x1B02)
#define REG_FSC_BK1B_03        (REG_FSC_BANK_BASE+0x1B03)
#define REG_FSC_BK1B_04        (REG_FSC_BANK_BASE+0x1B04)
#define REG_FSC_BK1B_05        (REG_FSC_BANK_BASE+0x1B05)
#define REG_FSC_BK1B_06        (REG_FSC_BANK_BASE+0x1B06)
#define REG_FSC_BK1B_07        (REG_FSC_BANK_BASE+0x1B07)
#define REG_FSC_BK1B_08        (REG_FSC_BANK_BASE+0x1B08)
#define REG_FSC_BK1B_09        (REG_FSC_BANK_BASE+0x1B09)
#define REG_FSC_BK1B_0A        (REG_FSC_BANK_BASE+0x1B0A)
#define REG_FSC_BK1B_0B        (REG_FSC_BANK_BASE+0x1B0B)
#define REG_FSC_BK1B_0C        (REG_FSC_BANK_BASE+0x1B0C)
#define REG_FSC_BK1B_0D        (REG_FSC_BANK_BASE+0x1B0D)
#define REG_FSC_BK1B_0E        (REG_FSC_BANK_BASE+0x1B0E)
#define REG_FSC_BK1B_0F        (REG_FSC_BANK_BASE+0x1B0F)
#define REG_FSC_BK1B_10        (REG_FSC_BANK_BASE+0x1B10)
#define REG_FSC_BK1B_11        (REG_FSC_BANK_BASE+0x1B11)
#define REG_FSC_BK1B_12        (REG_FSC_BANK_BASE+0x1B12)
#define REG_FSC_BK1B_13        (REG_FSC_BANK_BASE+0x1B13)
#define REG_FSC_BK1B_14        (REG_FSC_BANK_BASE+0x1B14)
#define REG_FSC_BK1B_15        (REG_FSC_BANK_BASE+0x1B15)
#define REG_FSC_BK1B_16        (REG_FSC_BANK_BASE+0x1B16)
#define REG_FSC_BK1B_17        (REG_FSC_BANK_BASE+0x1B17)
#define REG_FSC_BK1B_18        (REG_FSC_BANK_BASE+0x1B18)
#define REG_FSC_BK1B_19        (REG_FSC_BANK_BASE+0x1B19)
#define REG_FSC_BK1B_1A        (REG_FSC_BANK_BASE+0x1B1A)
#define REG_FSC_BK1B_1B        (REG_FSC_BANK_BASE+0x1B1B)
#define REG_FSC_BK1B_1C        (REG_FSC_BANK_BASE+0x1B1C)
#define REG_FSC_BK1B_1D        (REG_FSC_BANK_BASE+0x1B1D)
#define REG_FSC_BK1B_1E        (REG_FSC_BANK_BASE+0x1B1E)
#define REG_FSC_BK1B_1F        (REG_FSC_BANK_BASE+0x1B1F)
#define REG_FSC_BK1B_20        (REG_FSC_BANK_BASE+0x1B20)
#define REG_FSC_BK1B_21        (REG_FSC_BANK_BASE+0x1B21)
#define REG_FSC_BK1B_22        (REG_FSC_BANK_BASE+0x1B22)
#define REG_FSC_BK1B_23        (REG_FSC_BANK_BASE+0x1B23)
#define REG_FSC_BK1B_24        (REG_FSC_BANK_BASE+0x1B24)
#define REG_FSC_BK1B_25        (REG_FSC_BANK_BASE+0x1B25)
#define REG_FSC_BK1B_26        (REG_FSC_BANK_BASE+0x1B26)
#define REG_FSC_BK1B_27        (REG_FSC_BANK_BASE+0x1B27)
#define REG_FSC_BK1B_28        (REG_FSC_BANK_BASE+0x1B28)
#define REG_FSC_BK1B_29        (REG_FSC_BANK_BASE+0x1B29)
#define REG_FSC_BK1B_2A        (REG_FSC_BANK_BASE+0x1B2A)
#define REG_FSC_BK1B_2B        (REG_FSC_BANK_BASE+0x1B2B)
#define REG_FSC_BK1B_2C        (REG_FSC_BANK_BASE+0x1B2C)
#define REG_FSC_BK1B_2D        (REG_FSC_BANK_BASE+0x1B2D)
#define REG_FSC_BK1B_2E        (REG_FSC_BANK_BASE+0x1B2E)
#define REG_FSC_BK1B_2F        (REG_FSC_BANK_BASE+0x1B2F)
#define REG_FSC_BK1B_30        (REG_FSC_BANK_BASE+0x1B30)
#define REG_FSC_BK1B_31        (REG_FSC_BANK_BASE+0x1B31)
#define REG_FSC_BK1B_32        (REG_FSC_BANK_BASE+0x1B32)
#define REG_FSC_BK1B_33        (REG_FSC_BANK_BASE+0x1B33)
#define REG_FSC_BK1B_34        (REG_FSC_BANK_BASE+0x1B34)
#define REG_FSC_BK1B_35        (REG_FSC_BANK_BASE+0x1B35)
#define REG_FSC_BK1B_36        (REG_FSC_BANK_BASE+0x1B36)
#define REG_FSC_BK1B_37        (REG_FSC_BANK_BASE+0x1B37)
#define REG_FSC_BK1B_38        (REG_FSC_BANK_BASE+0x1B38)
#define REG_FSC_BK1B_39        (REG_FSC_BANK_BASE+0x1B39)
#define REG_FSC_BK1B_3A        (REG_FSC_BANK_BASE+0x1B3A)
#define REG_FSC_BK1B_3B        (REG_FSC_BANK_BASE+0x1B3B)
#define REG_FSC_BK1B_3C        (REG_FSC_BANK_BASE+0x1B3C)
#define REG_FSC_BK1B_3D        (REG_FSC_BANK_BASE+0x1B3D)
#define REG_FSC_BK1B_3E        (REG_FSC_BANK_BASE+0x1B3E)
#define REG_FSC_BK1B_3F        (REG_FSC_BANK_BASE+0x1B3F)
#define REG_FSC_BK1B_40        (REG_FSC_BANK_BASE+0x1B40)
#define REG_FSC_BK1B_41        (REG_FSC_BANK_BASE+0x1B41)
#define REG_FSC_BK1B_42        (REG_FSC_BANK_BASE+0x1B42)
#define REG_FSC_BK1B_43        (REG_FSC_BANK_BASE+0x1B43)
#define REG_FSC_BK1B_44        (REG_FSC_BANK_BASE+0x1B44)
#define REG_FSC_BK1B_45        (REG_FSC_BANK_BASE+0x1B45)
#define REG_FSC_BK1B_46        (REG_FSC_BANK_BASE+0x1B46)
#define REG_FSC_BK1B_47        (REG_FSC_BANK_BASE+0x1B47)
#define REG_FSC_BK1B_48        (REG_FSC_BANK_BASE+0x1B48)
#define REG_FSC_BK1B_49        (REG_FSC_BANK_BASE+0x1B49)
#define REG_FSC_BK1B_4A        (REG_FSC_BANK_BASE+0x1B4A)
#define REG_FSC_BK1B_4B        (REG_FSC_BANK_BASE+0x1B4B)
#define REG_FSC_BK1B_4C        (REG_FSC_BANK_BASE+0x1B4C)
#define REG_FSC_BK1B_4D        (REG_FSC_BANK_BASE+0x1B4D)
#define REG_FSC_BK1B_4E        (REG_FSC_BANK_BASE+0x1B4E)
#define REG_FSC_BK1B_4F        (REG_FSC_BANK_BASE+0x1B4F)
#define REG_FSC_BK1B_50        (REG_FSC_BANK_BASE+0x1B50)
#define REG_FSC_BK1B_51        (REG_FSC_BANK_BASE+0x1B51)
#define REG_FSC_BK1B_52        (REG_FSC_BANK_BASE+0x1B52)
#define REG_FSC_BK1B_53        (REG_FSC_BANK_BASE+0x1B53)
#define REG_FSC_BK1B_54        (REG_FSC_BANK_BASE+0x1B54)
#define REG_FSC_BK1B_55        (REG_FSC_BANK_BASE+0x1B55)
#define REG_FSC_BK1B_56        (REG_FSC_BANK_BASE+0x1B56)
#define REG_FSC_BK1B_57        (REG_FSC_BANK_BASE+0x1B57)
#define REG_FSC_BK1B_58        (REG_FSC_BANK_BASE+0x1B58)
#define REG_FSC_BK1B_59        (REG_FSC_BANK_BASE+0x1B59)
#define REG_FSC_BK1B_5A        (REG_FSC_BANK_BASE+0x1B5A)
#define REG_FSC_BK1B_5B        (REG_FSC_BANK_BASE+0x1B5B)
#define REG_FSC_BK1B_5C        (REG_FSC_BANK_BASE+0x1B5C)
#define REG_FSC_BK1B_5D        (REG_FSC_BANK_BASE+0x1B5D)
#define REG_FSC_BK1B_5E        (REG_FSC_BANK_BASE+0x1B5E)
#define REG_FSC_BK1B_5F        (REG_FSC_BANK_BASE+0x1B5F)
#define REG_FSC_BK1B_60        (REG_FSC_BANK_BASE+0x1B60)
#define REG_FSC_BK1B_61        (REG_FSC_BANK_BASE+0x1B61)
#define REG_FSC_BK1B_62        (REG_FSC_BANK_BASE+0x1B62)
#define REG_FSC_BK1B_63        (REG_FSC_BANK_BASE+0x1B63)
#define REG_FSC_BK1B_64        (REG_FSC_BANK_BASE+0x1B64)
#define REG_FSC_BK1B_65        (REG_FSC_BANK_BASE+0x1B65)
#define REG_FSC_BK1B_66        (REG_FSC_BANK_BASE+0x1B66)
#define REG_FSC_BK1B_67        (REG_FSC_BANK_BASE+0x1B67)
#define REG_FSC_BK1B_68        (REG_FSC_BANK_BASE+0x1B68)
#define REG_FSC_BK1B_69        (REG_FSC_BANK_BASE+0x1B69)
#define REG_FSC_BK1B_6A        (REG_FSC_BANK_BASE+0x1B6A)
#define REG_FSC_BK1B_6B        (REG_FSC_BANK_BASE+0x1B6B)
#define REG_FSC_BK1B_6C        (REG_FSC_BANK_BASE+0x1B6C)
#define REG_FSC_BK1B_6D        (REG_FSC_BANK_BASE+0x1B6D)
#define REG_FSC_BK1B_6E        (REG_FSC_BANK_BASE+0x1B6E)
#define REG_FSC_BK1B_6F        (REG_FSC_BANK_BASE+0x1B6F)
#define REG_FSC_BK1B_70        (REG_FSC_BANK_BASE+0x1B70)
#define REG_FSC_BK1B_71        (REG_FSC_BANK_BASE+0x1B71)
#define REG_FSC_BK1B_72        (REG_FSC_BANK_BASE+0x1B72)
#define REG_FSC_BK1B_73        (REG_FSC_BANK_BASE+0x1B73)
#define REG_FSC_BK1B_74        (REG_FSC_BANK_BASE+0x1B74)
#define REG_FSC_BK1B_75        (REG_FSC_BANK_BASE+0x1B75)
#define REG_FSC_BK1B_76        (REG_FSC_BANK_BASE+0x1B76)
#define REG_FSC_BK1B_77        (REG_FSC_BANK_BASE+0x1B77)
#define REG_FSC_BK1B_78        (REG_FSC_BANK_BASE+0x1B78)
#define REG_FSC_BK1B_79        (REG_FSC_BANK_BASE+0x1B79)
#define REG_FSC_BK1B_7A        (REG_FSC_BANK_BASE+0x1B7A)
#define REG_FSC_BK1B_7B        (REG_FSC_BANK_BASE+0x1B7B)
#define REG_FSC_BK1B_7C        (REG_FSC_BANK_BASE+0x1B7C)
#define REG_FSC_BK1B_7D        (REG_FSC_BANK_BASE+0x1B7D)
#define REG_FSC_BK1B_7E        (REG_FSC_BANK_BASE+0x1B7E)
#define REG_FSC_BK1B_7F        (REG_FSC_BANK_BASE+0x1B7F)
#define REG_FSC_BK1B_80        (REG_FSC_BANK_BASE+0x1B80)
#define REG_FSC_BK1B_81        (REG_FSC_BANK_BASE+0x1B81)
#define REG_FSC_BK1B_82        (REG_FSC_BANK_BASE+0x1B82)
#define REG_FSC_BK1B_83        (REG_FSC_BANK_BASE+0x1B83)
#define REG_FSC_BK1B_84        (REG_FSC_BANK_BASE+0x1B84)
#define REG_FSC_BK1B_85        (REG_FSC_BANK_BASE+0x1B85)
#define REG_FSC_BK1B_86        (REG_FSC_BANK_BASE+0x1B86)
#define REG_FSC_BK1B_87        (REG_FSC_BANK_BASE+0x1B87)
#define REG_FSC_BK1B_88        (REG_FSC_BANK_BASE+0x1B88)
#define REG_FSC_BK1B_89        (REG_FSC_BANK_BASE+0x1B89)
#define REG_FSC_BK1B_8A        (REG_FSC_BANK_BASE+0x1B8A)
#define REG_FSC_BK1B_8B        (REG_FSC_BANK_BASE+0x1B8B)
#define REG_FSC_BK1B_8C        (REG_FSC_BANK_BASE+0x1B8C)
#define REG_FSC_BK1B_8D        (REG_FSC_BANK_BASE+0x1B8D)
#define REG_FSC_BK1B_8E        (REG_FSC_BANK_BASE+0x1B8E)
#define REG_FSC_BK1B_8F        (REG_FSC_BANK_BASE+0x1B8F)
#define REG_FSC_BK1B_90        (REG_FSC_BANK_BASE+0x1B90)
#define REG_FSC_BK1B_91        (REG_FSC_BANK_BASE+0x1B91)
#define REG_FSC_BK1B_92        (REG_FSC_BANK_BASE+0x1B92)
#define REG_FSC_BK1B_93        (REG_FSC_BANK_BASE+0x1B93)
#define REG_FSC_BK1B_94        (REG_FSC_BANK_BASE+0x1B94)
#define REG_FSC_BK1B_95        (REG_FSC_BANK_BASE+0x1B95)
#define REG_FSC_BK1B_96        (REG_FSC_BANK_BASE+0x1B96)
#define REG_FSC_BK1B_97        (REG_FSC_BANK_BASE+0x1B97)
#define REG_FSC_BK1B_98        (REG_FSC_BANK_BASE+0x1B98)
#define REG_FSC_BK1B_99        (REG_FSC_BANK_BASE+0x1B99)
#define REG_FSC_BK1B_9A        (REG_FSC_BANK_BASE+0x1B9A)
#define REG_FSC_BK1B_9B        (REG_FSC_BANK_BASE+0x1B9B)
#define REG_FSC_BK1B_9C        (REG_FSC_BANK_BASE+0x1B9C)
#define REG_FSC_BK1B_9D        (REG_FSC_BANK_BASE+0x1B9D)
#define REG_FSC_BK1B_9E        (REG_FSC_BANK_BASE+0x1B9E)
#define REG_FSC_BK1B_9F        (REG_FSC_BANK_BASE+0x1B9F)
#define REG_FSC_BK1B_A0        (REG_FSC_BANK_BASE+0x1BA0)
#define REG_FSC_BK1B_A1        (REG_FSC_BANK_BASE+0x1BA1)
#define REG_FSC_BK1B_A2        (REG_FSC_BANK_BASE+0x1BA2)
#define REG_FSC_BK1B_A3        (REG_FSC_BANK_BASE+0x1BA3)
#define REG_FSC_BK1B_A4        (REG_FSC_BANK_BASE+0x1BA4)
#define REG_FSC_BK1B_A5        (REG_FSC_BANK_BASE+0x1BA5)
#define REG_FSC_BK1B_A6        (REG_FSC_BANK_BASE+0x1BA6)
#define REG_FSC_BK1B_A7        (REG_FSC_BANK_BASE+0x1BA7)
#define REG_FSC_BK1B_A8        (REG_FSC_BANK_BASE+0x1BA8)
#define REG_FSC_BK1B_A9        (REG_FSC_BANK_BASE+0x1BA9)
#define REG_FSC_BK1B_AA        (REG_FSC_BANK_BASE+0x1BAA)
#define REG_FSC_BK1B_AB        (REG_FSC_BANK_BASE+0x1BAB)
#define REG_FSC_BK1B_AC        (REG_FSC_BANK_BASE+0x1BAC)
#define REG_FSC_BK1B_AD        (REG_FSC_BANK_BASE+0x1BAD)
#define REG_FSC_BK1B_AE        (REG_FSC_BANK_BASE+0x1BAE)
#define REG_FSC_BK1B_AF        (REG_FSC_BANK_BASE+0x1BAF)
#define REG_FSC_BK1B_B0        (REG_FSC_BANK_BASE+0x1BB0)
#define REG_FSC_BK1B_B1        (REG_FSC_BANK_BASE+0x1BB1)
#define REG_FSC_BK1B_B2        (REG_FSC_BANK_BASE+0x1BB2)
#define REG_FSC_BK1B_B3        (REG_FSC_BANK_BASE+0x1BB3)
#define REG_FSC_BK1B_B4        (REG_FSC_BANK_BASE+0x1BB4)
#define REG_FSC_BK1B_B5        (REG_FSC_BANK_BASE+0x1BB5)
#define REG_FSC_BK1B_B6        (REG_FSC_BANK_BASE+0x1BB6)
#define REG_FSC_BK1B_B7        (REG_FSC_BANK_BASE+0x1BB7)
#define REG_FSC_BK1B_B8        (REG_FSC_BANK_BASE+0x1BB8)
#define REG_FSC_BK1B_B9        (REG_FSC_BANK_BASE+0x1BB9)
#define REG_FSC_BK1B_BA        (REG_FSC_BANK_BASE+0x1BBA)
#define REG_FSC_BK1B_BB        (REG_FSC_BANK_BASE+0x1BBB)
#define REG_FSC_BK1B_BC        (REG_FSC_BANK_BASE+0x1BBC)
#define REG_FSC_BK1B_BD        (REG_FSC_BANK_BASE+0x1BBD)
#define REG_FSC_BK1B_BE        (REG_FSC_BANK_BASE+0x1BBE)
#define REG_FSC_BK1B_BF        (REG_FSC_BANK_BASE+0x1BBF)
#define REG_FSC_BK1B_C0        (REG_FSC_BANK_BASE+0x1BC0)
#define REG_FSC_BK1B_C1        (REG_FSC_BANK_BASE+0x1BC1)
#define REG_FSC_BK1B_C2        (REG_FSC_BANK_BASE+0x1BC2)
#define REG_FSC_BK1B_C3        (REG_FSC_BANK_BASE+0x1BC3)
#define REG_FSC_BK1B_C4        (REG_FSC_BANK_BASE+0x1BC4)
#define REG_FSC_BK1B_C5        (REG_FSC_BANK_BASE+0x1BC5)
#define REG_FSC_BK1B_C6        (REG_FSC_BANK_BASE+0x1BC6)
#define REG_FSC_BK1B_C7        (REG_FSC_BANK_BASE+0x1BC7)
#define REG_FSC_BK1B_C8        (REG_FSC_BANK_BASE+0x1BC8)
#define REG_FSC_BK1B_C9        (REG_FSC_BANK_BASE+0x1BC9)
#define REG_FSC_BK1B_CA        (REG_FSC_BANK_BASE+0x1BCA)
#define REG_FSC_BK1B_CB        (REG_FSC_BANK_BASE+0x1BCB)
#define REG_FSC_BK1B_CC        (REG_FSC_BANK_BASE+0x1BCC)
#define REG_FSC_BK1B_CD        (REG_FSC_BANK_BASE+0x1BCD)
#define REG_FSC_BK1B_CE        (REG_FSC_BANK_BASE+0x1BCE)
#define REG_FSC_BK1B_CF        (REG_FSC_BANK_BASE+0x1BCF)
#define REG_FSC_BK1B_D0        (REG_FSC_BANK_BASE+0x1BD0)
#define REG_FSC_BK1B_D1        (REG_FSC_BANK_BASE+0x1BD1)
#define REG_FSC_BK1B_D2        (REG_FSC_BANK_BASE+0x1BD2)
#define REG_FSC_BK1B_D3        (REG_FSC_BANK_BASE+0x1BD3)
#define REG_FSC_BK1B_D4        (REG_FSC_BANK_BASE+0x1BD4)
#define REG_FSC_BK1B_D5        (REG_FSC_BANK_BASE+0x1BD5)
#define REG_FSC_BK1B_D6        (REG_FSC_BANK_BASE+0x1BD6)
#define REG_FSC_BK1B_D7        (REG_FSC_BANK_BASE+0x1BD7)
#define REG_FSC_BK1B_D8        (REG_FSC_BANK_BASE+0x1BD8)
#define REG_FSC_BK1B_D9        (REG_FSC_BANK_BASE+0x1BD9)
#define REG_FSC_BK1B_DA        (REG_FSC_BANK_BASE+0x1BDA)
#define REG_FSC_BK1B_DB        (REG_FSC_BANK_BASE+0x1BDB)
#define REG_FSC_BK1B_DC        (REG_FSC_BANK_BASE+0x1BDC)
#define REG_FSC_BK1B_DD        (REG_FSC_BANK_BASE+0x1BDD)
#define REG_FSC_BK1B_DE        (REG_FSC_BANK_BASE+0x1BDE)
#define REG_FSC_BK1B_DF        (REG_FSC_BANK_BASE+0x1BDF)
#define REG_FSC_BK1B_E0        (REG_FSC_BANK_BASE+0x1BE0)
#define REG_FSC_BK1B_E1        (REG_FSC_BANK_BASE+0x1BE1)
#define REG_FSC_BK1B_E2        (REG_FSC_BANK_BASE+0x1BE2)
#define REG_FSC_BK1B_E3        (REG_FSC_BANK_BASE+0x1BE3)
#define REG_FSC_BK1B_E4        (REG_FSC_BANK_BASE+0x1BE4)
#define REG_FSC_BK1B_E5        (REG_FSC_BANK_BASE+0x1BE5)
#define REG_FSC_BK1B_E6        (REG_FSC_BANK_BASE+0x1BE6)
#define REG_FSC_BK1B_E7        (REG_FSC_BANK_BASE+0x1BE7)
#define REG_FSC_BK1B_E8        (REG_FSC_BANK_BASE+0x1BE8)
#define REG_FSC_BK1B_E9        (REG_FSC_BANK_BASE+0x1BE9)
#define REG_FSC_BK1B_EA        (REG_FSC_BANK_BASE+0x1BEA)
#define REG_FSC_BK1B_EB        (REG_FSC_BANK_BASE+0x1BEB)
#define REG_FSC_BK1B_EC        (REG_FSC_BANK_BASE+0x1BEC)
#define REG_FSC_BK1B_ED        (REG_FSC_BANK_BASE+0x1BED)
#define REG_FSC_BK1B_EE        (REG_FSC_BANK_BASE+0x1BEE)
#define REG_FSC_BK1B_EF        (REG_FSC_BANK_BASE+0x1BEF)
#define REG_FSC_BK1B_F0        (REG_FSC_BANK_BASE+0x1BF0)
#define REG_FSC_BK1B_F1        (REG_FSC_BANK_BASE+0x1BF1)
#define REG_FSC_BK1B_F2        (REG_FSC_BANK_BASE+0x1BF2)
#define REG_FSC_BK1B_F3        (REG_FSC_BANK_BASE+0x1BF3)
#define REG_FSC_BK1B_F4        (REG_FSC_BANK_BASE+0x1BF4)
#define REG_FSC_BK1B_F5        (REG_FSC_BANK_BASE+0x1BF5)
#define REG_FSC_BK1B_F6        (REG_FSC_BANK_BASE+0x1BF6)
#define REG_FSC_BK1B_F7        (REG_FSC_BANK_BASE+0x1BF7)
#define REG_FSC_BK1B_F8        (REG_FSC_BANK_BASE+0x1BF8)
#define REG_FSC_BK1B_F9        (REG_FSC_BANK_BASE+0x1BF9)
#define REG_FSC_BK1B_FA        (REG_FSC_BANK_BASE+0x1BFA)
#define REG_FSC_BK1B_FB        (REG_FSC_BANK_BASE+0x1BFB)
#define REG_FSC_BK1B_FC        (REG_FSC_BANK_BASE+0x1BFC)
#define REG_FSC_BK1B_FD        (REG_FSC_BANK_BASE+0x1BFD)
#define REG_FSC_BK1B_FE        (REG_FSC_BANK_BASE+0x1BFE)
#define REG_FSC_BK1B_FF        (REG_FSC_BANK_BASE+0x1BFF)


// === FSC bk1D
#define REG_FSC_BK1D_00        (REG_FSC_BANK_BASE+0x1D00)
#define REG_FSC_BK1D_01        (REG_FSC_BANK_BASE+0x1D01)
#define REG_FSC_BK1D_02        (REG_FSC_BANK_BASE+0x1D02)
#define REG_FSC_BK1D_03        (REG_FSC_BANK_BASE+0x1D03)
#define REG_FSC_BK1D_04        (REG_FSC_BANK_BASE+0x1D04)
#define REG_FSC_BK1D_05        (REG_FSC_BANK_BASE+0x1D05)
#define REG_FSC_BK1D_06        (REG_FSC_BANK_BASE+0x1D06)
#define REG_FSC_BK1D_07        (REG_FSC_BANK_BASE+0x1D07)
#define REG_FSC_BK1D_08        (REG_FSC_BANK_BASE+0x1D08)
#define REG_FSC_BK1D_09        (REG_FSC_BANK_BASE+0x1D09)
#define REG_FSC_BK1D_0A        (REG_FSC_BANK_BASE+0x1D0A)
#define REG_FSC_BK1D_0B        (REG_FSC_BANK_BASE+0x1D0B)
#define REG_FSC_BK1D_0C        (REG_FSC_BANK_BASE+0x1D0C)
#define REG_FSC_BK1D_0D        (REG_FSC_BANK_BASE+0x1D0D)
#define REG_FSC_BK1D_0E        (REG_FSC_BANK_BASE+0x1D0E)
#define REG_FSC_BK1D_0F        (REG_FSC_BANK_BASE+0x1D0F)
#define REG_FSC_BK1D_10        (REG_FSC_BANK_BASE+0x1D10)
#define REG_FSC_BK1D_11        (REG_FSC_BANK_BASE+0x1D11)
#define REG_FSC_BK1D_12        (REG_FSC_BANK_BASE+0x1D12)
#define REG_FSC_BK1D_13        (REG_FSC_BANK_BASE+0x1D13)
#define REG_FSC_BK1D_14        (REG_FSC_BANK_BASE+0x1D14)
#define REG_FSC_BK1D_15        (REG_FSC_BANK_BASE+0x1D15)
#define REG_FSC_BK1D_16        (REG_FSC_BANK_BASE+0x1D16)
#define REG_FSC_BK1D_17        (REG_FSC_BANK_BASE+0x1D17)
#define REG_FSC_BK1D_18        (REG_FSC_BANK_BASE+0x1D18)
#define REG_FSC_BK1D_19        (REG_FSC_BANK_BASE+0x1D19)
#define REG_FSC_BK1D_1A        (REG_FSC_BANK_BASE+0x1D1A)
#define REG_FSC_BK1D_1B        (REG_FSC_BANK_BASE+0x1D1B)
#define REG_FSC_BK1D_1C        (REG_FSC_BANK_BASE+0x1D1C)
#define REG_FSC_BK1D_1D        (REG_FSC_BANK_BASE+0x1D1D)
#define REG_FSC_BK1D_1E        (REG_FSC_BANK_BASE+0x1D1E)
#define REG_FSC_BK1D_1F        (REG_FSC_BANK_BASE+0x1D1F)
#define REG_FSC_BK1D_20        (REG_FSC_BANK_BASE+0x1D20)
#define REG_FSC_BK1D_21        (REG_FSC_BANK_BASE+0x1D21)
#define REG_FSC_BK1D_22        (REG_FSC_BANK_BASE+0x1D22)
#define REG_FSC_BK1D_23        (REG_FSC_BANK_BASE+0x1D23)
#define REG_FSC_BK1D_24        (REG_FSC_BANK_BASE+0x1D24)
#define REG_FSC_BK1D_25        (REG_FSC_BANK_BASE+0x1D25)
#define REG_FSC_BK1D_26        (REG_FSC_BANK_BASE+0x1D26)
#define REG_FSC_BK1D_27        (REG_FSC_BANK_BASE+0x1D27)
#define REG_FSC_BK1D_28        (REG_FSC_BANK_BASE+0x1D28)
#define REG_FSC_BK1D_29        (REG_FSC_BANK_BASE+0x1D29)
#define REG_FSC_BK1D_2A        (REG_FSC_BANK_BASE+0x1D2A)
#define REG_FSC_BK1D_2B        (REG_FSC_BANK_BASE+0x1D2B)
#define REG_FSC_BK1D_2C        (REG_FSC_BANK_BASE+0x1D2C)
#define REG_FSC_BK1D_2D        (REG_FSC_BANK_BASE+0x1D2D)
#define REG_FSC_BK1D_2E        (REG_FSC_BANK_BASE+0x1D2E)
#define REG_FSC_BK1D_2F        (REG_FSC_BANK_BASE+0x1D2F)
#define REG_FSC_BK1D_30        (REG_FSC_BANK_BASE+0x1D30)
#define REG_FSC_BK1D_31        (REG_FSC_BANK_BASE+0x1D31)
#define REG_FSC_BK1D_32        (REG_FSC_BANK_BASE+0x1D32)
#define REG_FSC_BK1D_33        (REG_FSC_BANK_BASE+0x1D33)
#define REG_FSC_BK1D_34        (REG_FSC_BANK_BASE+0x1D34)
#define REG_FSC_BK1D_35        (REG_FSC_BANK_BASE+0x1D35)
#define REG_FSC_BK1D_36        (REG_FSC_BANK_BASE+0x1D36)
#define REG_FSC_BK1D_37        (REG_FSC_BANK_BASE+0x1D37)
#define REG_FSC_BK1D_38        (REG_FSC_BANK_BASE+0x1D38)
#define REG_FSC_BK1D_39        (REG_FSC_BANK_BASE+0x1D39)
#define REG_FSC_BK1D_3A        (REG_FSC_BANK_BASE+0x1D3A)
#define REG_FSC_BK1D_3B        (REG_FSC_BANK_BASE+0x1D3B)
#define REG_FSC_BK1D_3C        (REG_FSC_BANK_BASE+0x1D3C)
#define REG_FSC_BK1D_3D        (REG_FSC_BANK_BASE+0x1D3D)
#define REG_FSC_BK1D_3E        (REG_FSC_BANK_BASE+0x1D3E)
#define REG_FSC_BK1D_3F        (REG_FSC_BANK_BASE+0x1D3F)
#define REG_FSC_BK1D_40        (REG_FSC_BANK_BASE+0x1D40)
#define REG_FSC_BK1D_41        (REG_FSC_BANK_BASE+0x1D41)
#define REG_FSC_BK1D_42        (REG_FSC_BANK_BASE+0x1D42)
#define REG_FSC_BK1D_43        (REG_FSC_BANK_BASE+0x1D43)
#define REG_FSC_BK1D_44        (REG_FSC_BANK_BASE+0x1D44)
#define REG_FSC_BK1D_45        (REG_FSC_BANK_BASE+0x1D45)
#define REG_FSC_BK1D_46        (REG_FSC_BANK_BASE+0x1D46)
#define REG_FSC_BK1D_47        (REG_FSC_BANK_BASE+0x1D47)
#define REG_FSC_BK1D_48        (REG_FSC_BANK_BASE+0x1D48)
#define REG_FSC_BK1D_49        (REG_FSC_BANK_BASE+0x1D49)
#define REG_FSC_BK1D_4A        (REG_FSC_BANK_BASE+0x1D4A)
#define REG_FSC_BK1D_4B        (REG_FSC_BANK_BASE+0x1D4B)
#define REG_FSC_BK1D_4C        (REG_FSC_BANK_BASE+0x1D4C)
#define REG_FSC_BK1D_4D        (REG_FSC_BANK_BASE+0x1D4D)
#define REG_FSC_BK1D_4E        (REG_FSC_BANK_BASE+0x1D4E)
#define REG_FSC_BK1D_4F        (REG_FSC_BANK_BASE+0x1D4F)
#define REG_FSC_BK1D_50        (REG_FSC_BANK_BASE+0x1D50)
#define REG_FSC_BK1D_51        (REG_FSC_BANK_BASE+0x1D51)
#define REG_FSC_BK1D_52        (REG_FSC_BANK_BASE+0x1D52)
#define REG_FSC_BK1D_53        (REG_FSC_BANK_BASE+0x1D53)
#define REG_FSC_BK1D_54        (REG_FSC_BANK_BASE+0x1D54)
#define REG_FSC_BK1D_55        (REG_FSC_BANK_BASE+0x1D55)
#define REG_FSC_BK1D_56        (REG_FSC_BANK_BASE+0x1D56)
#define REG_FSC_BK1D_57        (REG_FSC_BANK_BASE+0x1D57)
#define REG_FSC_BK1D_58        (REG_FSC_BANK_BASE+0x1D58)
#define REG_FSC_BK1D_59        (REG_FSC_BANK_BASE+0x1D59)
#define REG_FSC_BK1D_5A        (REG_FSC_BANK_BASE+0x1D5A)
#define REG_FSC_BK1D_5B        (REG_FSC_BANK_BASE+0x1D5B)
#define REG_FSC_BK1D_5C        (REG_FSC_BANK_BASE+0x1D5C)
#define REG_FSC_BK1D_5D        (REG_FSC_BANK_BASE+0x1D5D)
#define REG_FSC_BK1D_5E        (REG_FSC_BANK_BASE+0x1D5E)
#define REG_FSC_BK1D_5F        (REG_FSC_BANK_BASE+0x1D5F)
#define REG_FSC_BK1D_60        (REG_FSC_BANK_BASE+0x1D60)
#define REG_FSC_BK1D_61        (REG_FSC_BANK_BASE+0x1D61)
#define REG_FSC_BK1D_62        (REG_FSC_BANK_BASE+0x1D62)
#define REG_FSC_BK1D_63        (REG_FSC_BANK_BASE+0x1D63)
#define REG_FSC_BK1D_64        (REG_FSC_BANK_BASE+0x1D64)
#define REG_FSC_BK1D_65        (REG_FSC_BANK_BASE+0x1D65)
#define REG_FSC_BK1D_66        (REG_FSC_BANK_BASE+0x1D66)
#define REG_FSC_BK1D_67        (REG_FSC_BANK_BASE+0x1D67)
#define REG_FSC_BK1D_68        (REG_FSC_BANK_BASE+0x1D68)
#define REG_FSC_BK1D_69        (REG_FSC_BANK_BASE+0x1D69)
#define REG_FSC_BK1D_6A        (REG_FSC_BANK_BASE+0x1D6A)
#define REG_FSC_BK1D_6B        (REG_FSC_BANK_BASE+0x1D6B)
#define REG_FSC_BK1D_6C        (REG_FSC_BANK_BASE+0x1D6C)
#define REG_FSC_BK1D_6D        (REG_FSC_BANK_BASE+0x1D6D)
#define REG_FSC_BK1D_6E        (REG_FSC_BANK_BASE+0x1D6E)
#define REG_FSC_BK1D_6F        (REG_FSC_BANK_BASE+0x1D6F)
#define REG_FSC_BK1D_70        (REG_FSC_BANK_BASE+0x1D70)
#define REG_FSC_BK1D_71        (REG_FSC_BANK_BASE+0x1D71)
#define REG_FSC_BK1D_72        (REG_FSC_BANK_BASE+0x1D72)
#define REG_FSC_BK1D_73        (REG_FSC_BANK_BASE+0x1D73)
#define REG_FSC_BK1D_74        (REG_FSC_BANK_BASE+0x1D74)
#define REG_FSC_BK1D_75        (REG_FSC_BANK_BASE+0x1D75)
#define REG_FSC_BK1D_76        (REG_FSC_BANK_BASE+0x1D76)
#define REG_FSC_BK1D_77        (REG_FSC_BANK_BASE+0x1D77)
#define REG_FSC_BK1D_78        (REG_FSC_BANK_BASE+0x1D78)
#define REG_FSC_BK1D_79        (REG_FSC_BANK_BASE+0x1D79)
#define REG_FSC_BK1D_7A        (REG_FSC_BANK_BASE+0x1D7A)
#define REG_FSC_BK1D_7B        (REG_FSC_BANK_BASE+0x1D7B)
#define REG_FSC_BK1D_7C        (REG_FSC_BANK_BASE+0x1D7C)
#define REG_FSC_BK1D_7D        (REG_FSC_BANK_BASE+0x1D7D)
#define REG_FSC_BK1D_7E        (REG_FSC_BANK_BASE+0x1D7E)
#define REG_FSC_BK1D_7F        (REG_FSC_BANK_BASE+0x1D7F)
#define REG_FSC_BK1D_80        (REG_FSC_BANK_BASE+0x1D80)
#define REG_FSC_BK1D_81        (REG_FSC_BANK_BASE+0x1D81)
#define REG_FSC_BK1D_82        (REG_FSC_BANK_BASE+0x1D82)
#define REG_FSC_BK1D_83        (REG_FSC_BANK_BASE+0x1D83)
#define REG_FSC_BK1D_84        (REG_FSC_BANK_BASE+0x1D84)
#define REG_FSC_BK1D_85        (REG_FSC_BANK_BASE+0x1D85)
#define REG_FSC_BK1D_86        (REG_FSC_BANK_BASE+0x1D86)
#define REG_FSC_BK1D_87        (REG_FSC_BANK_BASE+0x1D87)
#define REG_FSC_BK1D_88        (REG_FSC_BANK_BASE+0x1D88)
#define REG_FSC_BK1D_89        (REG_FSC_BANK_BASE+0x1D89)
#define REG_FSC_BK1D_8A        (REG_FSC_BANK_BASE+0x1D8A)
#define REG_FSC_BK1D_8B        (REG_FSC_BANK_BASE+0x1D8B)
#define REG_FSC_BK1D_8C        (REG_FSC_BANK_BASE+0x1D8C)
#define REG_FSC_BK1D_8D        (REG_FSC_BANK_BASE+0x1D8D)
#define REG_FSC_BK1D_8E        (REG_FSC_BANK_BASE+0x1D8E)
#define REG_FSC_BK1D_8F        (REG_FSC_BANK_BASE+0x1D8F)
#define REG_FSC_BK1D_90        (REG_FSC_BANK_BASE+0x1D90)
#define REG_FSC_BK1D_91        (REG_FSC_BANK_BASE+0x1D91)
#define REG_FSC_BK1D_92        (REG_FSC_BANK_BASE+0x1D92)
#define REG_FSC_BK1D_93        (REG_FSC_BANK_BASE+0x1D93)
#define REG_FSC_BK1D_94        (REG_FSC_BANK_BASE+0x1D94)
#define REG_FSC_BK1D_95        (REG_FSC_BANK_BASE+0x1D95)
#define REG_FSC_BK1D_96        (REG_FSC_BANK_BASE+0x1D96)
#define REG_FSC_BK1D_97        (REG_FSC_BANK_BASE+0x1D97)
#define REG_FSC_BK1D_98        (REG_FSC_BANK_BASE+0x1D98)
#define REG_FSC_BK1D_99        (REG_FSC_BANK_BASE+0x1D99)
#define REG_FSC_BK1D_9A        (REG_FSC_BANK_BASE+0x1D9A)
#define REG_FSC_BK1D_9B        (REG_FSC_BANK_BASE+0x1D9B)
#define REG_FSC_BK1D_9C        (REG_FSC_BANK_BASE+0x1D9C)
#define REG_FSC_BK1D_9D        (REG_FSC_BANK_BASE+0x1D9D)
#define REG_FSC_BK1D_9E        (REG_FSC_BANK_BASE+0x1D9E)
#define REG_FSC_BK1D_9F        (REG_FSC_BANK_BASE+0x1D9F)
#define REG_FSC_BK1D_A0        (REG_FSC_BANK_BASE+0x1DA0)
#define REG_FSC_BK1D_A1        (REG_FSC_BANK_BASE+0x1DA1)
#define REG_FSC_BK1D_A2        (REG_FSC_BANK_BASE+0x1DA2)
#define REG_FSC_BK1D_A3        (REG_FSC_BANK_BASE+0x1DA3)
#define REG_FSC_BK1D_A4        (REG_FSC_BANK_BASE+0x1DA4)
#define REG_FSC_BK1D_A5        (REG_FSC_BANK_BASE+0x1DA5)
#define REG_FSC_BK1D_A6        (REG_FSC_BANK_BASE+0x1DA6)
#define REG_FSC_BK1D_A7        (REG_FSC_BANK_BASE+0x1DA7)
#define REG_FSC_BK1D_A8        (REG_FSC_BANK_BASE+0x1DA8)
#define REG_FSC_BK1D_A9        (REG_FSC_BANK_BASE+0x1DA9)
#define REG_FSC_BK1D_AA        (REG_FSC_BANK_BASE+0x1DAA)
#define REG_FSC_BK1D_AB        (REG_FSC_BANK_BASE+0x1DAB)
#define REG_FSC_BK1D_AC        (REG_FSC_BANK_BASE+0x1DAC)
#define REG_FSC_BK1D_AD        (REG_FSC_BANK_BASE+0x1DAD)
#define REG_FSC_BK1D_AE        (REG_FSC_BANK_BASE+0x1DAE)
#define REG_FSC_BK1D_AF        (REG_FSC_BANK_BASE+0x1DAF)
#define REG_FSC_BK1D_B0        (REG_FSC_BANK_BASE+0x1DB0)
#define REG_FSC_BK1D_B1        (REG_FSC_BANK_BASE+0x1DB1)
#define REG_FSC_BK1D_B2        (REG_FSC_BANK_BASE+0x1DB2)
#define REG_FSC_BK1D_B3        (REG_FSC_BANK_BASE+0x1DB3)
#define REG_FSC_BK1D_B4        (REG_FSC_BANK_BASE+0x1DB4)
#define REG_FSC_BK1D_B5        (REG_FSC_BANK_BASE+0x1DB5)
#define REG_FSC_BK1D_B6        (REG_FSC_BANK_BASE+0x1DB6)
#define REG_FSC_BK1D_B7        (REG_FSC_BANK_BASE+0x1DB7)
#define REG_FSC_BK1D_B8        (REG_FSC_BANK_BASE+0x1DB8)
#define REG_FSC_BK1D_B9        (REG_FSC_BANK_BASE+0x1DB9)
#define REG_FSC_BK1D_BA        (REG_FSC_BANK_BASE+0x1DBA)
#define REG_FSC_BK1D_BB        (REG_FSC_BANK_BASE+0x1DBB)
#define REG_FSC_BK1D_BC        (REG_FSC_BANK_BASE+0x1DBC)
#define REG_FSC_BK1D_BD        (REG_FSC_BANK_BASE+0x1DBD)
#define REG_FSC_BK1D_BE        (REG_FSC_BANK_BASE+0x1DBE)
#define REG_FSC_BK1D_BF        (REG_FSC_BANK_BASE+0x1DBF)
#define REG_FSC_BK1D_C0        (REG_FSC_BANK_BASE+0x1DC0)
#define REG_FSC_BK1D_C1        (REG_FSC_BANK_BASE+0x1DC1)
#define REG_FSC_BK1D_C2        (REG_FSC_BANK_BASE+0x1DC2)
#define REG_FSC_BK1D_C3        (REG_FSC_BANK_BASE+0x1DC3)
#define REG_FSC_BK1D_C4        (REG_FSC_BANK_BASE+0x1DC4)
#define REG_FSC_BK1D_C5        (REG_FSC_BANK_BASE+0x1DC5)
#define REG_FSC_BK1D_C6        (REG_FSC_BANK_BASE+0x1DC6)
#define REG_FSC_BK1D_C7        (REG_FSC_BANK_BASE+0x1DC7)
#define REG_FSC_BK1D_C8        (REG_FSC_BANK_BASE+0x1DC8)
#define REG_FSC_BK1D_C9        (REG_FSC_BANK_BASE+0x1DC9)
#define REG_FSC_BK1D_CA        (REG_FSC_BANK_BASE+0x1DCA)
#define REG_FSC_BK1D_CB        (REG_FSC_BANK_BASE+0x1DCB)
#define REG_FSC_BK1D_CC        (REG_FSC_BANK_BASE+0x1DCC)
#define REG_FSC_BK1D_CD        (REG_FSC_BANK_BASE+0x1DCD)
#define REG_FSC_BK1D_CE        (REG_FSC_BANK_BASE+0x1DCE)
#define REG_FSC_BK1D_CF        (REG_FSC_BANK_BASE+0x1DCF)
#define REG_FSC_BK1D_D0        (REG_FSC_BANK_BASE+0x1DD0)
#define REG_FSC_BK1D_D1        (REG_FSC_BANK_BASE+0x1DD1)
#define REG_FSC_BK1D_D2        (REG_FSC_BANK_BASE+0x1DD2)
#define REG_FSC_BK1D_D3        (REG_FSC_BANK_BASE+0x1DD3)
#define REG_FSC_BK1D_D4        (REG_FSC_BANK_BASE+0x1DD4)
#define REG_FSC_BK1D_D5        (REG_FSC_BANK_BASE+0x1DD5)
#define REG_FSC_BK1D_D6        (REG_FSC_BANK_BASE+0x1DD6)
#define REG_FSC_BK1D_D7        (REG_FSC_BANK_BASE+0x1DD7)
#define REG_FSC_BK1D_D8        (REG_FSC_BANK_BASE+0x1DD8)
#define REG_FSC_BK1D_D9        (REG_FSC_BANK_BASE+0x1DD9)
#define REG_FSC_BK1D_DA        (REG_FSC_BANK_BASE+0x1DDA)
#define REG_FSC_BK1D_DB        (REG_FSC_BANK_BASE+0x1DDB)
#define REG_FSC_BK1D_DC        (REG_FSC_BANK_BASE+0x1DDC)
#define REG_FSC_BK1D_DD        (REG_FSC_BANK_BASE+0x1DDD)
#define REG_FSC_BK1D_DE        (REG_FSC_BANK_BASE+0x1DDE)
#define REG_FSC_BK1D_DF        (REG_FSC_BANK_BASE+0x1DDF)
#define REG_FSC_BK1D_E0        (REG_FSC_BANK_BASE+0x1DE0)
#define REG_FSC_BK1D_E1        (REG_FSC_BANK_BASE+0x1DE1)
#define REG_FSC_BK1D_E2        (REG_FSC_BANK_BASE+0x1DE2)
#define REG_FSC_BK1D_E3        (REG_FSC_BANK_BASE+0x1DE3)
#define REG_FSC_BK1D_E4        (REG_FSC_BANK_BASE+0x1DE4)
#define REG_FSC_BK1D_E5        (REG_FSC_BANK_BASE+0x1DE5)
#define REG_FSC_BK1D_E6        (REG_FSC_BANK_BASE+0x1DE6)
#define REG_FSC_BK1D_E7        (REG_FSC_BANK_BASE+0x1DE7)
#define REG_FSC_BK1D_E8        (REG_FSC_BANK_BASE+0x1DE8)
#define REG_FSC_BK1D_E9        (REG_FSC_BANK_BASE+0x1DE9)
#define REG_FSC_BK1D_EA        (REG_FSC_BANK_BASE+0x1DEA)
#define REG_FSC_BK1D_EB        (REG_FSC_BANK_BASE+0x1DEB)
#define REG_FSC_BK1D_EC        (REG_FSC_BANK_BASE+0x1DEC)
#define REG_FSC_BK1D_ED        (REG_FSC_BANK_BASE+0x1DED)
#define REG_FSC_BK1D_EE        (REG_FSC_BANK_BASE+0x1DEE)
#define REG_FSC_BK1D_EF        (REG_FSC_BANK_BASE+0x1DEF)
#define REG_FSC_BK1D_F0        (REG_FSC_BANK_BASE+0x1DF0)
#define REG_FSC_BK1D_F1        (REG_FSC_BANK_BASE+0x1DF1)
#define REG_FSC_BK1D_F2        (REG_FSC_BANK_BASE+0x1DF2)
#define REG_FSC_BK1D_F3        (REG_FSC_BANK_BASE+0x1DF3)
#define REG_FSC_BK1D_F4        (REG_FSC_BANK_BASE+0x1DF4)
#define REG_FSC_BK1D_F5        (REG_FSC_BANK_BASE+0x1DF5)
#define REG_FSC_BK1D_F6        (REG_FSC_BANK_BASE+0x1DF6)
#define REG_FSC_BK1D_F7        (REG_FSC_BANK_BASE+0x1DF7)
#define REG_FSC_BK1D_F8        (REG_FSC_BANK_BASE+0x1DF8)
#define REG_FSC_BK1D_F9        (REG_FSC_BANK_BASE+0x1DF9)
#define REG_FSC_BK1D_FA        (REG_FSC_BANK_BASE+0x1DFA)
#define REG_FSC_BK1D_FB        (REG_FSC_BANK_BASE+0x1DFB)
#define REG_FSC_BK1D_FC        (REG_FSC_BANK_BASE+0x1DFC)
#define REG_FSC_BK1D_FD        (REG_FSC_BANK_BASE+0x1DFD)
#define REG_FSC_BK1D_FE        (REG_FSC_BANK_BASE+0x1DFE)
#define REG_FSC_BK1D_FF        (REG_FSC_BANK_BASE+0x1DFF)

// === FSC bk20
#define REG_FSC_BK20           ((REG_FSC_BANK_BASE >> 8)+0x20)
#define REG_FSC_BK20_00        (REG_FSC_BANK_BASE+0x2000)
#define REG_FSC_BK20_01        (REG_FSC_BANK_BASE+0x2001)
#define REG_FSC_BK20_02        (REG_FSC_BANK_BASE+0x2002)
#define REG_FSC_BK20_03        (REG_FSC_BANK_BASE+0x2003)
#define REG_FSC_BK20_04        (REG_FSC_BANK_BASE+0x2004)
#define REG_FSC_BK20_05        (REG_FSC_BANK_BASE+0x2005)
#define REG_FSC_BK20_06        (REG_FSC_BANK_BASE+0x2006)
#define REG_FSC_BK20_07        (REG_FSC_BANK_BASE+0x2007)
#define REG_FSC_BK20_08        (REG_FSC_BANK_BASE+0x2008)
#define REG_FSC_BK20_09        (REG_FSC_BANK_BASE+0x2009)
#define REG_FSC_BK20_0A        (REG_FSC_BANK_BASE+0x200A)
#define REG_FSC_BK20_0B        (REG_FSC_BANK_BASE+0x200B)
#define REG_FSC_BK20_0C        (REG_FSC_BANK_BASE+0x200C)
#define REG_FSC_BK20_0D        (REG_FSC_BANK_BASE+0x200D)
#define REG_FSC_BK20_0E        (REG_FSC_BANK_BASE+0x200E)
#define REG_FSC_BK20_0F        (REG_FSC_BANK_BASE+0x200F)
#define REG_FSC_BK20_10        (REG_FSC_BANK_BASE+0x2010)
#define REG_FSC_BK20_11        (REG_FSC_BANK_BASE+0x2011)
#define REG_FSC_BK20_12        (REG_FSC_BANK_BASE+0x2012)
#define REG_FSC_BK20_13        (REG_FSC_BANK_BASE+0x2013)
#define REG_FSC_BK20_14        (REG_FSC_BANK_BASE+0x2014)
#define REG_FSC_BK20_15        (REG_FSC_BANK_BASE+0x2015)
#define REG_FSC_BK20_16        (REG_FSC_BANK_BASE+0x2016)
#define REG_FSC_BK20_17        (REG_FSC_BANK_BASE+0x2017)
#define REG_FSC_BK20_18        (REG_FSC_BANK_BASE+0x2018)
#define REG_FSC_BK20_19        (REG_FSC_BANK_BASE+0x2019)
#define REG_FSC_BK20_1A        (REG_FSC_BANK_BASE+0x201A)
#define REG_FSC_BK20_1B        (REG_FSC_BANK_BASE+0x201B)
#define REG_FSC_BK20_1C        (REG_FSC_BANK_BASE+0x201C)
#define REG_FSC_BK20_1D        (REG_FSC_BANK_BASE+0x201D)
#define REG_FSC_BK20_1E        (REG_FSC_BANK_BASE+0x201E)
#define REG_FSC_BK20_1F        (REG_FSC_BANK_BASE+0x201F)
#define REG_FSC_BK20_20        (REG_FSC_BANK_BASE+0x2020)
#define REG_FSC_BK20_21        (REG_FSC_BANK_BASE+0x2021)
#define REG_FSC_BK20_22        (REG_FSC_BANK_BASE+0x2022)
#define REG_FSC_BK20_23        (REG_FSC_BANK_BASE+0x2023)
#define REG_FSC_BK20_24        (REG_FSC_BANK_BASE+0x2024)
#define REG_FSC_BK20_25        (REG_FSC_BANK_BASE+0x2025)
#define REG_FSC_BK20_26        (REG_FSC_BANK_BASE+0x2026)
#define REG_FSC_BK20_27        (REG_FSC_BANK_BASE+0x2027)
#define REG_FSC_BK20_28        (REG_FSC_BANK_BASE+0x2028)
#define REG_FSC_BK20_29        (REG_FSC_BANK_BASE+0x2029)
#define REG_FSC_BK20_2A        (REG_FSC_BANK_BASE+0x202A)
#define REG_FSC_BK20_2B        (REG_FSC_BANK_BASE+0x202B)
#define REG_FSC_BK20_2C        (REG_FSC_BANK_BASE+0x202C)
#define REG_FSC_BK20_2D        (REG_FSC_BANK_BASE+0x202D)
#define REG_FSC_BK20_2E        (REG_FSC_BANK_BASE+0x202E)
#define REG_FSC_BK20_2F        (REG_FSC_BANK_BASE+0x202F)
#define REG_FSC_BK20_30        (REG_FSC_BANK_BASE+0x2030)
#define REG_FSC_BK20_31        (REG_FSC_BANK_BASE+0x2031)
#define REG_FSC_BK20_32        (REG_FSC_BANK_BASE+0x2032)
#define REG_FSC_BK20_33        (REG_FSC_BANK_BASE+0x2033)
#define REG_FSC_BK20_34        (REG_FSC_BANK_BASE+0x2034)
#define REG_FSC_BK20_35        (REG_FSC_BANK_BASE+0x2035)
#define REG_FSC_BK20_36        (REG_FSC_BANK_BASE+0x2036)
#define REG_FSC_BK20_37        (REG_FSC_BANK_BASE+0x2037)
#define REG_FSC_BK20_38        (REG_FSC_BANK_BASE+0x2038)
#define REG_FSC_BK20_39        (REG_FSC_BANK_BASE+0x2039)
#define REG_FSC_BK20_3A        (REG_FSC_BANK_BASE+0x203A)
#define REG_FSC_BK20_3B        (REG_FSC_BANK_BASE+0x203B)
#define REG_FSC_BK20_3C        (REG_FSC_BANK_BASE+0x203C)
#define REG_FSC_BK20_3D        (REG_FSC_BANK_BASE+0x203D)
#define REG_FSC_BK20_3E        (REG_FSC_BANK_BASE+0x203E)
#define REG_FSC_BK20_3F        (REG_FSC_BANK_BASE+0x203F)
#define REG_FSC_BK20_40        (REG_FSC_BANK_BASE+0x2040)
#define REG_FSC_BK20_41        (REG_FSC_BANK_BASE+0x2041)
#define REG_FSC_BK20_42        (REG_FSC_BANK_BASE+0x2042)
#define REG_FSC_BK20_43        (REG_FSC_BANK_BASE+0x2043)
#define REG_FSC_BK20_44        (REG_FSC_BANK_BASE+0x2044)
#define REG_FSC_BK20_45        (REG_FSC_BANK_BASE+0x2045)
#define REG_FSC_BK20_46        (REG_FSC_BANK_BASE+0x2046)
#define REG_FSC_BK20_47        (REG_FSC_BANK_BASE+0x2047)
#define REG_FSC_BK20_48        (REG_FSC_BANK_BASE+0x2048)
#define REG_FSC_BK20_49        (REG_FSC_BANK_BASE+0x2049)
#define REG_FSC_BK20_4A        (REG_FSC_BANK_BASE+0x204A)
#define REG_FSC_BK20_4B        (REG_FSC_BANK_BASE+0x204B)
#define REG_FSC_BK20_4C        (REG_FSC_BANK_BASE+0x204C)
#define REG_FSC_BK20_4D        (REG_FSC_BANK_BASE+0x204D)
#define REG_FSC_BK20_4E        (REG_FSC_BANK_BASE+0x204E)
#define REG_FSC_BK20_4F        (REG_FSC_BANK_BASE+0x204F)
#define REG_FSC_BK20_50        (REG_FSC_BANK_BASE+0x2050)
#define REG_FSC_BK20_51        (REG_FSC_BANK_BASE+0x2051)
#define REG_FSC_BK20_52        (REG_FSC_BANK_BASE+0x2052)
#define REG_FSC_BK20_53        (REG_FSC_BANK_BASE+0x2053)
#define REG_FSC_BK20_54        (REG_FSC_BANK_BASE+0x2054)
#define REG_FSC_BK20_55        (REG_FSC_BANK_BASE+0x2055)
#define REG_FSC_BK20_56        (REG_FSC_BANK_BASE+0x2056)
#define REG_FSC_BK20_57        (REG_FSC_BANK_BASE+0x2057)
#define REG_FSC_BK20_58        (REG_FSC_BANK_BASE+0x2058)
#define REG_FSC_BK20_59        (REG_FSC_BANK_BASE+0x2059)
#define REG_FSC_BK20_5A        (REG_FSC_BANK_BASE+0x205A)
#define REG_FSC_BK20_5B        (REG_FSC_BANK_BASE+0x205B)
#define REG_FSC_BK20_5C        (REG_FSC_BANK_BASE+0x205C)
#define REG_FSC_BK20_5D        (REG_FSC_BANK_BASE+0x205D)
#define REG_FSC_BK20_5E        (REG_FSC_BANK_BASE+0x205E)
#define REG_FSC_BK20_5F        (REG_FSC_BANK_BASE+0x205F)
#define REG_FSC_BK20_60        (REG_FSC_BANK_BASE+0x2060)
#define REG_FSC_BK20_61        (REG_FSC_BANK_BASE+0x2061)
#define REG_FSC_BK20_62        (REG_FSC_BANK_BASE+0x2062)
#define REG_FSC_BK20_63        (REG_FSC_BANK_BASE+0x2063)
#define REG_FSC_BK20_64        (REG_FSC_BANK_BASE+0x2064)
#define REG_FSC_BK20_65        (REG_FSC_BANK_BASE+0x2065)
#define REG_FSC_BK20_66        (REG_FSC_BANK_BASE+0x2066)
#define REG_FSC_BK20_67        (REG_FSC_BANK_BASE+0x2067)
#define REG_FSC_BK20_68        (REG_FSC_BANK_BASE+0x2068)
#define REG_FSC_BK20_69        (REG_FSC_BANK_BASE+0x2069)
#define REG_FSC_BK20_6A        (REG_FSC_BANK_BASE+0x206A)
#define REG_FSC_BK20_6B        (REG_FSC_BANK_BASE+0x206B)
#define REG_FSC_BK20_6C        (REG_FSC_BANK_BASE+0x206C)
#define REG_FSC_BK20_6D        (REG_FSC_BANK_BASE+0x206D)
#define REG_FSC_BK20_6E        (REG_FSC_BANK_BASE+0x206E)
#define REG_FSC_BK20_6F        (REG_FSC_BANK_BASE+0x206F)
#define REG_FSC_BK20_70        (REG_FSC_BANK_BASE+0x2070)
#define REG_FSC_BK20_71        (REG_FSC_BANK_BASE+0x2071)
#define REG_FSC_BK20_72        (REG_FSC_BANK_BASE+0x2072)
#define REG_FSC_BK20_73        (REG_FSC_BANK_BASE+0x2073)
#define REG_FSC_BK20_74        (REG_FSC_BANK_BASE+0x2074)
#define REG_FSC_BK20_75        (REG_FSC_BANK_BASE+0x2075)
#define REG_FSC_BK20_76        (REG_FSC_BANK_BASE+0x2076)
#define REG_FSC_BK20_77        (REG_FSC_BANK_BASE+0x2077)
#define REG_FSC_BK20_78        (REG_FSC_BANK_BASE+0x2078)
#define REG_FSC_BK20_79        (REG_FSC_BANK_BASE+0x2079)
#define REG_FSC_BK20_7A        (REG_FSC_BANK_BASE+0x207A)
#define REG_FSC_BK20_7B        (REG_FSC_BANK_BASE+0x207B)
#define REG_FSC_BK20_7C        (REG_FSC_BANK_BASE+0x207C)
#define REG_FSC_BK20_7D        (REG_FSC_BANK_BASE+0x207D)
#define REG_FSC_BK20_7E        (REG_FSC_BANK_BASE+0x207E)
#define REG_FSC_BK20_7F        (REG_FSC_BANK_BASE+0x207F)
#define REG_FSC_BK20_80        (REG_FSC_BANK_BASE+0x2080)
#define REG_FSC_BK20_81        (REG_FSC_BANK_BASE+0x2081)
#define REG_FSC_BK20_82        (REG_FSC_BANK_BASE+0x2082)
#define REG_FSC_BK20_83        (REG_FSC_BANK_BASE+0x2083)
#define REG_FSC_BK20_84        (REG_FSC_BANK_BASE+0x2084)
#define REG_FSC_BK20_85        (REG_FSC_BANK_BASE+0x2085)
#define REG_FSC_BK20_86        (REG_FSC_BANK_BASE+0x2086)
#define REG_FSC_BK20_87        (REG_FSC_BANK_BASE+0x2087)
#define REG_FSC_BK20_88        (REG_FSC_BANK_BASE+0x2088)
#define REG_FSC_BK20_89        (REG_FSC_BANK_BASE+0x2089)
#define REG_FSC_BK20_8A        (REG_FSC_BANK_BASE+0x208A)
#define REG_FSC_BK20_8B        (REG_FSC_BANK_BASE+0x208B)
#define REG_FSC_BK20_8C        (REG_FSC_BANK_BASE+0x208C)
#define REG_FSC_BK20_8D        (REG_FSC_BANK_BASE+0x208D)
#define REG_FSC_BK20_8E        (REG_FSC_BANK_BASE+0x208E)
#define REG_FSC_BK20_8F        (REG_FSC_BANK_BASE+0x208F)
#define REG_FSC_BK20_90        (REG_FSC_BANK_BASE+0x2090)
#define REG_FSC_BK20_91        (REG_FSC_BANK_BASE+0x2091)
#define REG_FSC_BK20_92        (REG_FSC_BANK_BASE+0x2092)
#define REG_FSC_BK20_93        (REG_FSC_BANK_BASE+0x2093)
#define REG_FSC_BK20_94        (REG_FSC_BANK_BASE+0x2094)
#define REG_FSC_BK20_95        (REG_FSC_BANK_BASE+0x2095)
#define REG_FSC_BK20_96        (REG_FSC_BANK_BASE+0x2096)
#define REG_FSC_BK20_97        (REG_FSC_BANK_BASE+0x2097)
#define REG_FSC_BK20_98        (REG_FSC_BANK_BASE+0x2098)
#define REG_FSC_BK20_99        (REG_FSC_BANK_BASE+0x2099)
#define REG_FSC_BK20_9A        (REG_FSC_BANK_BASE+0x209A)
#define REG_FSC_BK20_9B        (REG_FSC_BANK_BASE+0x209B)
#define REG_FSC_BK20_9C        (REG_FSC_BANK_BASE+0x209C)
#define REG_FSC_BK20_9D        (REG_FSC_BANK_BASE+0x209D)
#define REG_FSC_BK20_9E        (REG_FSC_BANK_BASE+0x209E)
#define REG_FSC_BK20_9F        (REG_FSC_BANK_BASE+0x209F)
#define REG_FSC_BK20_A0        (REG_FSC_BANK_BASE+0x20A0)
#define REG_FSC_BK20_A1        (REG_FSC_BANK_BASE+0x20A1)
#define REG_FSC_BK20_A2        (REG_FSC_BANK_BASE+0x20A2)
#define REG_FSC_BK20_A3        (REG_FSC_BANK_BASE+0x20A3)
#define REG_FSC_BK20_A4        (REG_FSC_BANK_BASE+0x20A4)
#define REG_FSC_BK20_A5        (REG_FSC_BANK_BASE+0x20A5)
#define REG_FSC_BK20_A6        (REG_FSC_BANK_BASE+0x20A6)
#define REG_FSC_BK20_A7        (REG_FSC_BANK_BASE+0x20A7)
#define REG_FSC_BK20_A8        (REG_FSC_BANK_BASE+0x20A8)
#define REG_FSC_BK20_A9        (REG_FSC_BANK_BASE+0x20A9)
#define REG_FSC_BK20_AA        (REG_FSC_BANK_BASE+0x20AA)
#define REG_FSC_BK20_AB        (REG_FSC_BANK_BASE+0x20AB)
#define REG_FSC_BK20_AC        (REG_FSC_BANK_BASE+0x20AC)
#define REG_FSC_BK20_AD        (REG_FSC_BANK_BASE+0x20AD)
#define REG_FSC_BK20_AE        (REG_FSC_BANK_BASE+0x20AE)
#define REG_FSC_BK20_AF        (REG_FSC_BANK_BASE+0x20AF)
#define REG_FSC_BK20_B0        (REG_FSC_BANK_BASE+0x20B0)
#define REG_FSC_BK20_B1        (REG_FSC_BANK_BASE+0x20B1)
#define REG_FSC_BK20_B2        (REG_FSC_BANK_BASE+0x20B2)
#define REG_FSC_BK20_B3        (REG_FSC_BANK_BASE+0x20B3)
#define REG_FSC_BK20_B4        (REG_FSC_BANK_BASE+0x20B4)
#define REG_FSC_BK20_B5        (REG_FSC_BANK_BASE+0x20B5)
#define REG_FSC_BK20_B6        (REG_FSC_BANK_BASE+0x20B6)
#define REG_FSC_BK20_B7        (REG_FSC_BANK_BASE+0x20B7)
#define REG_FSC_BK20_B8        (REG_FSC_BANK_BASE+0x20B8)
#define REG_FSC_BK20_B9        (REG_FSC_BANK_BASE+0x20B9)
#define REG_FSC_BK20_BA        (REG_FSC_BANK_BASE+0x20BA)
#define REG_FSC_BK20_BB        (REG_FSC_BANK_BASE+0x20BB)
#define REG_FSC_BK20_BC        (REG_FSC_BANK_BASE+0x20BC)
#define REG_FSC_BK20_BD        (REG_FSC_BANK_BASE+0x20BD)
#define REG_FSC_BK20_BE        (REG_FSC_BANK_BASE+0x20BE)
#define REG_FSC_BK20_BF        (REG_FSC_BANK_BASE+0x20BF)
#define REG_FSC_BK20_C0        (REG_FSC_BANK_BASE+0x20C0)
#define REG_FSC_BK20_C1        (REG_FSC_BANK_BASE+0x20C1)
#define REG_FSC_BK20_C2        (REG_FSC_BANK_BASE+0x20C2)
#define REG_FSC_BK20_C3        (REG_FSC_BANK_BASE+0x20C3)
#define REG_FSC_BK20_C4        (REG_FSC_BANK_BASE+0x20C4)
#define REG_FSC_BK20_C5        (REG_FSC_BANK_BASE+0x20C5)
#define REG_FSC_BK20_C6        (REG_FSC_BANK_BASE+0x20C6)
#define REG_FSC_BK20_C7        (REG_FSC_BANK_BASE+0x20C7)
#define REG_FSC_BK20_C8        (REG_FSC_BANK_BASE+0x20C8)
#define REG_FSC_BK20_C9        (REG_FSC_BANK_BASE+0x20C9)
#define REG_FSC_BK20_CA        (REG_FSC_BANK_BASE+0x20CA)
#define REG_FSC_BK20_CB        (REG_FSC_BANK_BASE+0x20CB)
#define REG_FSC_BK20_CC        (REG_FSC_BANK_BASE+0x20CC)
#define REG_FSC_BK20_CD        (REG_FSC_BANK_BASE+0x20CD)
#define REG_FSC_BK20_CE        (REG_FSC_BANK_BASE+0x20CE)
#define REG_FSC_BK20_CF        (REG_FSC_BANK_BASE+0x20CF)
#define REG_FSC_BK20_D0        (REG_FSC_BANK_BASE+0x20D0)
#define REG_FSC_BK20_D1        (REG_FSC_BANK_BASE+0x20D1)
#define REG_FSC_BK20_D2        (REG_FSC_BANK_BASE+0x20D2)
#define REG_FSC_BK20_D3        (REG_FSC_BANK_BASE+0x20D3)
#define REG_FSC_BK20_D4        (REG_FSC_BANK_BASE+0x20D4)
#define REG_FSC_BK20_D5        (REG_FSC_BANK_BASE+0x20D5)
#define REG_FSC_BK20_D6        (REG_FSC_BANK_BASE+0x20D6)
#define REG_FSC_BK20_D7        (REG_FSC_BANK_BASE+0x20D7)
#define REG_FSC_BK20_D8        (REG_FSC_BANK_BASE+0x20D8)
#define REG_FSC_BK20_D9        (REG_FSC_BANK_BASE+0x20D9)
#define REG_FSC_BK20_DA        (REG_FSC_BANK_BASE+0x20DA)
#define REG_FSC_BK20_DB        (REG_FSC_BANK_BASE+0x20DB)
#define REG_FSC_BK20_DC        (REG_FSC_BANK_BASE+0x20DC)
#define REG_FSC_BK20_DD        (REG_FSC_BANK_BASE+0x20DD)
#define REG_FSC_BK20_DE        (REG_FSC_BANK_BASE+0x20DE)
#define REG_FSC_BK20_DF        (REG_FSC_BANK_BASE+0x20DF)
#define REG_FSC_BK20_E0        (REG_FSC_BANK_BASE+0x20E0)
#define REG_FSC_BK20_E1        (REG_FSC_BANK_BASE+0x20E1)
#define REG_FSC_BK20_E2        (REG_FSC_BANK_BASE+0x20E2)
#define REG_FSC_BK20_E3        (REG_FSC_BANK_BASE+0x20E3)
#define REG_FSC_BK20_E4        (REG_FSC_BANK_BASE+0x20E4)
#define REG_FSC_BK20_E5        (REG_FSC_BANK_BASE+0x20E5)
#define REG_FSC_BK20_E6        (REG_FSC_BANK_BASE+0x20E6)
#define REG_FSC_BK20_E7        (REG_FSC_BANK_BASE+0x20E7)
#define REG_FSC_BK20_E8        (REG_FSC_BANK_BASE+0x20E8)
#define REG_FSC_BK20_E9        (REG_FSC_BANK_BASE+0x20E9)
#define REG_FSC_BK20_EA        (REG_FSC_BANK_BASE+0x20EA)
#define REG_FSC_BK20_EB        (REG_FSC_BANK_BASE+0x20EB)
#define REG_FSC_BK20_EC        (REG_FSC_BANK_BASE+0x20EC)
#define REG_FSC_BK20_ED        (REG_FSC_BANK_BASE+0x20ED)
#define REG_FSC_BK20_EE        (REG_FSC_BANK_BASE+0x20EE)
#define REG_FSC_BK20_EF        (REG_FSC_BANK_BASE+0x20EF)
#define REG_FSC_BK20_F0        (REG_FSC_BANK_BASE+0x20F0)
#define REG_FSC_BK20_F1        (REG_FSC_BANK_BASE+0x20F1)
#define REG_FSC_BK20_F2        (REG_FSC_BANK_BASE+0x20F2)
#define REG_FSC_BK20_F3        (REG_FSC_BANK_BASE+0x20F3)
#define REG_FSC_BK20_F4        (REG_FSC_BANK_BASE+0x20F4)
#define REG_FSC_BK20_F5        (REG_FSC_BANK_BASE+0x20F5)
#define REG_FSC_BK20_F6        (REG_FSC_BANK_BASE+0x20F6)
#define REG_FSC_BK20_F7        (REG_FSC_BANK_BASE+0x20F7)
#define REG_FSC_BK20_F8        (REG_FSC_BANK_BASE+0x20F8)
#define REG_FSC_BK20_F9        (REG_FSC_BANK_BASE+0x20F9)
#define REG_FSC_BK20_FA        (REG_FSC_BANK_BASE+0x20FA)
#define REG_FSC_BK20_FB        (REG_FSC_BANK_BASE+0x20FB)
#define REG_FSC_BK20_FC        (REG_FSC_BANK_BASE+0x20FC)
#define REG_FSC_BK20_FD        (REG_FSC_BANK_BASE+0x20FD)
#define REG_FSC_BK20_FE        (REG_FSC_BANK_BASE+0x20FE)
#define REG_FSC_BK20_FF        (REG_FSC_BANK_BASE+0x20FF)

// === FSC bk23
#define REG_FSC_BK23           ((REG_FSC_BANK_BASE >> 8)+0x23)
#define REG_FSC_BK23_00        (REG_FSC_BANK_BASE+0x2300)
#define REG_FSC_BK23_01        (REG_FSC_BANK_BASE+0x2301)
#define REG_FSC_BK23_02        (REG_FSC_BANK_BASE+0x2302)
#define REG_FSC_BK23_03        (REG_FSC_BANK_BASE+0x2303)
#define REG_FSC_BK23_04        (REG_FSC_BANK_BASE+0x2304)
#define REG_FSC_BK23_05        (REG_FSC_BANK_BASE+0x2305)
#define REG_FSC_BK23_06        (REG_FSC_BANK_BASE+0x2306)
#define REG_FSC_BK23_07        (REG_FSC_BANK_BASE+0x2307)
#define REG_FSC_BK23_08        (REG_FSC_BANK_BASE+0x2308)
#define REG_FSC_BK23_09        (REG_FSC_BANK_BASE+0x2309)
#define REG_FSC_BK23_0A        (REG_FSC_BANK_BASE+0x230A)
#define REG_FSC_BK23_0B        (REG_FSC_BANK_BASE+0x230B)
#define REG_FSC_BK23_0C        (REG_FSC_BANK_BASE+0x230C)
#define REG_FSC_BK23_0D        (REG_FSC_BANK_BASE+0x230D)
#define REG_FSC_BK23_0E        (REG_FSC_BANK_BASE+0x230E)
#define REG_FSC_BK23_0F        (REG_FSC_BANK_BASE+0x230F)
#define REG_FSC_BK23_10        (REG_FSC_BANK_BASE+0x2310)
#define REG_FSC_BK23_11        (REG_FSC_BANK_BASE+0x2311)
#define REG_FSC_BK23_12        (REG_FSC_BANK_BASE+0x2312)
#define REG_FSC_BK23_13        (REG_FSC_BANK_BASE+0x2313)
#define REG_FSC_BK23_14        (REG_FSC_BANK_BASE+0x2314)
#define REG_FSC_BK23_15        (REG_FSC_BANK_BASE+0x2315)
#define REG_FSC_BK23_16        (REG_FSC_BANK_BASE+0x2316)
#define REG_FSC_BK23_17        (REG_FSC_BANK_BASE+0x2317)
#define REG_FSC_BK23_18        (REG_FSC_BANK_BASE+0x2318)
#define REG_FSC_BK23_19        (REG_FSC_BANK_BASE+0x2319)
#define REG_FSC_BK23_1A        (REG_FSC_BANK_BASE+0x231A)
#define REG_FSC_BK23_1B        (REG_FSC_BANK_BASE+0x231B)
#define REG_FSC_BK23_1C        (REG_FSC_BANK_BASE+0x231C)
#define REG_FSC_BK23_1D        (REG_FSC_BANK_BASE+0x231D)
#define REG_FSC_BK23_1E        (REG_FSC_BANK_BASE+0x231E)
#define REG_FSC_BK23_1F        (REG_FSC_BANK_BASE+0x231F)
#define REG_FSC_BK23_20        (REG_FSC_BANK_BASE+0x2320)
#define REG_FSC_BK23_21        (REG_FSC_BANK_BASE+0x2321)
#define REG_FSC_BK23_22        (REG_FSC_BANK_BASE+0x2322)
#define REG_FSC_BK23_23        (REG_FSC_BANK_BASE+0x2323)
#define REG_FSC_BK23_24        (REG_FSC_BANK_BASE+0x2324)
#define REG_FSC_BK23_25        (REG_FSC_BANK_BASE+0x2325)
#define REG_FSC_BK23_26        (REG_FSC_BANK_BASE+0x2326)
#define REG_FSC_BK23_27        (REG_FSC_BANK_BASE+0x2327)
#define REG_FSC_BK23_28        (REG_FSC_BANK_BASE+0x2328)
#define REG_FSC_BK23_29        (REG_FSC_BANK_BASE+0x2329)
#define REG_FSC_BK23_2A        (REG_FSC_BANK_BASE+0x232A)
#define REG_FSC_BK23_2B        (REG_FSC_BANK_BASE+0x232B)
#define REG_FSC_BK23_2C        (REG_FSC_BANK_BASE+0x232C)
#define REG_FSC_BK23_2D        (REG_FSC_BANK_BASE+0x232D)
#define REG_FSC_BK23_2E        (REG_FSC_BANK_BASE+0x232E)
#define REG_FSC_BK23_2F        (REG_FSC_BANK_BASE+0x232F)
#define REG_FSC_BK23_30        (REG_FSC_BANK_BASE+0x2330)
#define REG_FSC_BK23_31        (REG_FSC_BANK_BASE+0x2331)
#define REG_FSC_BK23_32        (REG_FSC_BANK_BASE+0x2332)
#define REG_FSC_BK23_33        (REG_FSC_BANK_BASE+0x2333)
#define REG_FSC_BK23_34        (REG_FSC_BANK_BASE+0x2334)
#define REG_FSC_BK23_35        (REG_FSC_BANK_BASE+0x2335)
#define REG_FSC_BK23_36        (REG_FSC_BANK_BASE+0x2336)
#define REG_FSC_BK23_37        (REG_FSC_BANK_BASE+0x2337)
#define REG_FSC_BK23_38        (REG_FSC_BANK_BASE+0x2338)
#define REG_FSC_BK23_39        (REG_FSC_BANK_BASE+0x2339)
#define REG_FSC_BK23_3A        (REG_FSC_BANK_BASE+0x233A)
#define REG_FSC_BK23_3B        (REG_FSC_BANK_BASE+0x233B)
#define REG_FSC_BK23_3C        (REG_FSC_BANK_BASE+0x233C)
#define REG_FSC_BK23_3D        (REG_FSC_BANK_BASE+0x233D)
#define REG_FSC_BK23_3E        (REG_FSC_BANK_BASE+0x233E)
#define REG_FSC_BK23_3F        (REG_FSC_BANK_BASE+0x233F)
#define REG_FSC_BK23_40        (REG_FSC_BANK_BASE+0x2340)
#define REG_FSC_BK23_41        (REG_FSC_BANK_BASE+0x2341)
#define REG_FSC_BK23_42        (REG_FSC_BANK_BASE+0x2342)
#define REG_FSC_BK23_43        (REG_FSC_BANK_BASE+0x2343)
#define REG_FSC_BK23_44        (REG_FSC_BANK_BASE+0x2344)
#define REG_FSC_BK23_45        (REG_FSC_BANK_BASE+0x2345)
#define REG_FSC_BK23_46        (REG_FSC_BANK_BASE+0x2346)
#define REG_FSC_BK23_47        (REG_FSC_BANK_BASE+0x2347)
#define REG_FSC_BK23_48        (REG_FSC_BANK_BASE+0x2348)
#define REG_FSC_BK23_49        (REG_FSC_BANK_BASE+0x2349)
#define REG_FSC_BK23_4A        (REG_FSC_BANK_BASE+0x234A)
#define REG_FSC_BK23_4B        (REG_FSC_BANK_BASE+0x234B)
#define REG_FSC_BK23_4C        (REG_FSC_BANK_BASE+0x234C)
#define REG_FSC_BK23_4D        (REG_FSC_BANK_BASE+0x234D)
#define REG_FSC_BK23_4E        (REG_FSC_BANK_BASE+0x234E)
#define REG_FSC_BK23_4F        (REG_FSC_BANK_BASE+0x234F)
#define REG_FSC_BK23_50        (REG_FSC_BANK_BASE+0x2350)
#define REG_FSC_BK23_51        (REG_FSC_BANK_BASE+0x2351)
#define REG_FSC_BK23_52        (REG_FSC_BANK_BASE+0x2352)
#define REG_FSC_BK23_53        (REG_FSC_BANK_BASE+0x2353)
#define REG_FSC_BK23_54        (REG_FSC_BANK_BASE+0x2354)
#define REG_FSC_BK23_55        (REG_FSC_BANK_BASE+0x2355)
#define REG_FSC_BK23_56        (REG_FSC_BANK_BASE+0x2356)
#define REG_FSC_BK23_57        (REG_FSC_BANK_BASE+0x2357)
#define REG_FSC_BK23_58        (REG_FSC_BANK_BASE+0x2358)
#define REG_FSC_BK23_59        (REG_FSC_BANK_BASE+0x2359)
#define REG_FSC_BK23_5A        (REG_FSC_BANK_BASE+0x235A)
#define REG_FSC_BK23_5B        (REG_FSC_BANK_BASE+0x235B)
#define REG_FSC_BK23_5C        (REG_FSC_BANK_BASE+0x235C)
#define REG_FSC_BK23_5D        (REG_FSC_BANK_BASE+0x235D)
#define REG_FSC_BK23_5E        (REG_FSC_BANK_BASE+0x235E)
#define REG_FSC_BK23_5F        (REG_FSC_BANK_BASE+0x235F)
#define REG_FSC_BK23_60        (REG_FSC_BANK_BASE+0x2360)
#define REG_FSC_BK23_61        (REG_FSC_BANK_BASE+0x2361)
#define REG_FSC_BK23_62        (REG_FSC_BANK_BASE+0x2362)
#define REG_FSC_BK23_63        (REG_FSC_BANK_BASE+0x2363)
#define REG_FSC_BK23_64        (REG_FSC_BANK_BASE+0x2364)
#define REG_FSC_BK23_65        (REG_FSC_BANK_BASE+0x2365)
#define REG_FSC_BK23_66        (REG_FSC_BANK_BASE+0x2366)
#define REG_FSC_BK23_67        (REG_FSC_BANK_BASE+0x2367)
#define REG_FSC_BK23_68        (REG_FSC_BANK_BASE+0x2368)
#define REG_FSC_BK23_69        (REG_FSC_BANK_BASE+0x2369)
#define REG_FSC_BK23_6A        (REG_FSC_BANK_BASE+0x236A)
#define REG_FSC_BK23_6B        (REG_FSC_BANK_BASE+0x236B)
#define REG_FSC_BK23_6C        (REG_FSC_BANK_BASE+0x236C)
#define REG_FSC_BK23_6D        (REG_FSC_BANK_BASE+0x236D)
#define REG_FSC_BK23_6E        (REG_FSC_BANK_BASE+0x236E)
#define REG_FSC_BK23_6F        (REG_FSC_BANK_BASE+0x236F)
#define REG_FSC_BK23_70        (REG_FSC_BANK_BASE+0x2370)
#define REG_FSC_BK23_71        (REG_FSC_BANK_BASE+0x2371)
#define REG_FSC_BK23_72        (REG_FSC_BANK_BASE+0x2372)
#define REG_FSC_BK23_73        (REG_FSC_BANK_BASE+0x2373)
#define REG_FSC_BK23_74        (REG_FSC_BANK_BASE+0x2374)
#define REG_FSC_BK23_75        (REG_FSC_BANK_BASE+0x2375)
#define REG_FSC_BK23_76        (REG_FSC_BANK_BASE+0x2376)
#define REG_FSC_BK23_77        (REG_FSC_BANK_BASE+0x2377)
#define REG_FSC_BK23_78        (REG_FSC_BANK_BASE+0x2378)
#define REG_FSC_BK23_79        (REG_FSC_BANK_BASE+0x2379)
#define REG_FSC_BK23_7A        (REG_FSC_BANK_BASE+0x237A)
#define REG_FSC_BK23_7B        (REG_FSC_BANK_BASE+0x237B)
#define REG_FSC_BK23_7C        (REG_FSC_BANK_BASE+0x237C)
#define REG_FSC_BK23_7D        (REG_FSC_BANK_BASE+0x237D)
#define REG_FSC_BK23_7E        (REG_FSC_BANK_BASE+0x237E)
#define REG_FSC_BK23_7F        (REG_FSC_BANK_BASE+0x237F)
#define REG_FSC_BK23_80        (REG_FSC_BANK_BASE+0x2380)
#define REG_FSC_BK23_81        (REG_FSC_BANK_BASE+0x2381)
#define REG_FSC_BK23_82        (REG_FSC_BANK_BASE+0x2382)
#define REG_FSC_BK23_83        (REG_FSC_BANK_BASE+0x2383)
#define REG_FSC_BK23_84        (REG_FSC_BANK_BASE+0x2384)
#define REG_FSC_BK23_85        (REG_FSC_BANK_BASE+0x2385)
#define REG_FSC_BK23_86        (REG_FSC_BANK_BASE+0x2386)
#define REG_FSC_BK23_87        (REG_FSC_BANK_BASE+0x2387)
#define REG_FSC_BK23_88        (REG_FSC_BANK_BASE+0x2388)
#define REG_FSC_BK23_89        (REG_FSC_BANK_BASE+0x2389)
#define REG_FSC_BK23_8A        (REG_FSC_BANK_BASE+0x238A)
#define REG_FSC_BK23_8B        (REG_FSC_BANK_BASE+0x238B)
#define REG_FSC_BK23_8C        (REG_FSC_BANK_BASE+0x238C)
#define REG_FSC_BK23_8D        (REG_FSC_BANK_BASE+0x238D)
#define REG_FSC_BK23_8E        (REG_FSC_BANK_BASE+0x238E)
#define REG_FSC_BK23_8F        (REG_FSC_BANK_BASE+0x238F)
#define REG_FSC_BK23_90        (REG_FSC_BANK_BASE+0x2390)
#define REG_FSC_BK23_91        (REG_FSC_BANK_BASE+0x2391)
#define REG_FSC_BK23_92        (REG_FSC_BANK_BASE+0x2392)
#define REG_FSC_BK23_93        (REG_FSC_BANK_BASE+0x2393)
#define REG_FSC_BK23_94        (REG_FSC_BANK_BASE+0x2394)
#define REG_FSC_BK23_95        (REG_FSC_BANK_BASE+0x2395)
#define REG_FSC_BK23_96        (REG_FSC_BANK_BASE+0x2396)
#define REG_FSC_BK23_97        (REG_FSC_BANK_BASE+0x2397)
#define REG_FSC_BK23_98        (REG_FSC_BANK_BASE+0x2398)
#define REG_FSC_BK23_99        (REG_FSC_BANK_BASE+0x2399)
#define REG_FSC_BK23_9A        (REG_FSC_BANK_BASE+0x239A)
#define REG_FSC_BK23_9B        (REG_FSC_BANK_BASE+0x239B)
#define REG_FSC_BK23_9C        (REG_FSC_BANK_BASE+0x239C)
#define REG_FSC_BK23_9D        (REG_FSC_BANK_BASE+0x239D)
#define REG_FSC_BK23_9E        (REG_FSC_BANK_BASE+0x239E)
#define REG_FSC_BK23_9F        (REG_FSC_BANK_BASE+0x239F)
#define REG_FSC_BK23_A0        (REG_FSC_BANK_BASE+0x23A0)
#define REG_FSC_BK23_A1        (REG_FSC_BANK_BASE+0x23A1)
#define REG_FSC_BK23_A2        (REG_FSC_BANK_BASE+0x23A2)
#define REG_FSC_BK23_A3        (REG_FSC_BANK_BASE+0x23A3)
#define REG_FSC_BK23_A4        (REG_FSC_BANK_BASE+0x23A4)
#define REG_FSC_BK23_A5        (REG_FSC_BANK_BASE+0x23A5)
#define REG_FSC_BK23_A6        (REG_FSC_BANK_BASE+0x23A6)
#define REG_FSC_BK23_A7        (REG_FSC_BANK_BASE+0x23A7)
#define REG_FSC_BK23_A8        (REG_FSC_BANK_BASE+0x23A8)
#define REG_FSC_BK23_A9        (REG_FSC_BANK_BASE+0x23A9)
#define REG_FSC_BK23_AA        (REG_FSC_BANK_BASE+0x23AA)
#define REG_FSC_BK23_AB        (REG_FSC_BANK_BASE+0x23AB)
#define REG_FSC_BK23_AC        (REG_FSC_BANK_BASE+0x23AC)
#define REG_FSC_BK23_AD        (REG_FSC_BANK_BASE+0x23AD)
#define REG_FSC_BK23_AE        (REG_FSC_BANK_BASE+0x23AE)
#define REG_FSC_BK23_AF        (REG_FSC_BANK_BASE+0x23AF)
#define REG_FSC_BK23_B0        (REG_FSC_BANK_BASE+0x23B0)
#define REG_FSC_BK23_B1        (REG_FSC_BANK_BASE+0x23B1)
#define REG_FSC_BK23_B2        (REG_FSC_BANK_BASE+0x23B2)
#define REG_FSC_BK23_B3        (REG_FSC_BANK_BASE+0x23B3)
#define REG_FSC_BK23_B4        (REG_FSC_BANK_BASE+0x23B4)
#define REG_FSC_BK23_B5        (REG_FSC_BANK_BASE+0x23B5)
#define REG_FSC_BK23_B6        (REG_FSC_BANK_BASE+0x23B6)
#define REG_FSC_BK23_B7        (REG_FSC_BANK_BASE+0x23B7)
#define REG_FSC_BK23_B8        (REG_FSC_BANK_BASE+0x23B8)
#define REG_FSC_BK23_B9        (REG_FSC_BANK_BASE+0x23B9)
#define REG_FSC_BK23_BA        (REG_FSC_BANK_BASE+0x23BA)
#define REG_FSC_BK23_BB        (REG_FSC_BANK_BASE+0x23BB)
#define REG_FSC_BK23_BC        (REG_FSC_BANK_BASE+0x23BC)
#define REG_FSC_BK23_BD        (REG_FSC_BANK_BASE+0x23BD)
#define REG_FSC_BK23_BE        (REG_FSC_BANK_BASE+0x23BE)
#define REG_FSC_BK23_BF        (REG_FSC_BANK_BASE+0x23BF)
#define REG_FSC_BK23_C0        (REG_FSC_BANK_BASE+0x23C0)
#define REG_FSC_BK23_C1        (REG_FSC_BANK_BASE+0x23C1)
#define REG_FSC_BK23_C2        (REG_FSC_BANK_BASE+0x23C2)
#define REG_FSC_BK23_C3        (REG_FSC_BANK_BASE+0x23C3)
#define REG_FSC_BK23_C4        (REG_FSC_BANK_BASE+0x23C4)
#define REG_FSC_BK23_C5        (REG_FSC_BANK_BASE+0x23C5)
#define REG_FSC_BK23_C6        (REG_FSC_BANK_BASE+0x23C6)
#define REG_FSC_BK23_C7        (REG_FSC_BANK_BASE+0x23C7)
#define REG_FSC_BK23_C8        (REG_FSC_BANK_BASE+0x23C8)
#define REG_FSC_BK23_C9        (REG_FSC_BANK_BASE+0x23C9)
#define REG_FSC_BK23_CA        (REG_FSC_BANK_BASE+0x23CA)
#define REG_FSC_BK23_CB        (REG_FSC_BANK_BASE+0x23CB)
#define REG_FSC_BK23_CC        (REG_FSC_BANK_BASE+0x23CC)
#define REG_FSC_BK23_CD        (REG_FSC_BANK_BASE+0x23CD)
#define REG_FSC_BK23_CE        (REG_FSC_BANK_BASE+0x23CE)
#define REG_FSC_BK23_CF        (REG_FSC_BANK_BASE+0x23CF)
#define REG_FSC_BK23_D0        (REG_FSC_BANK_BASE+0x23D0)
#define REG_FSC_BK23_D1        (REG_FSC_BANK_BASE+0x23D1)
#define REG_FSC_BK23_D2        (REG_FSC_BANK_BASE+0x23D2)
#define REG_FSC_BK23_D3        (REG_FSC_BANK_BASE+0x23D3)
#define REG_FSC_BK23_D4        (REG_FSC_BANK_BASE+0x23D4)
#define REG_FSC_BK23_D5        (REG_FSC_BANK_BASE+0x23D5)
#define REG_FSC_BK23_D6        (REG_FSC_BANK_BASE+0x23D6)
#define REG_FSC_BK23_D7        (REG_FSC_BANK_BASE+0x23D7)
#define REG_FSC_BK23_D8        (REG_FSC_BANK_BASE+0x23D8)
#define REG_FSC_BK23_D9        (REG_FSC_BANK_BASE+0x23D9)
#define REG_FSC_BK23_DA        (REG_FSC_BANK_BASE+0x23DA)
#define REG_FSC_BK23_DB        (REG_FSC_BANK_BASE+0x23DB)
#define REG_FSC_BK23_DC        (REG_FSC_BANK_BASE+0x23DC)
#define REG_FSC_BK23_DD        (REG_FSC_BANK_BASE+0x23DD)
#define REG_FSC_BK23_DE        (REG_FSC_BANK_BASE+0x23DE)
#define REG_FSC_BK23_DF        (REG_FSC_BANK_BASE+0x23DF)
#define REG_FSC_BK23_E0        (REG_FSC_BANK_BASE+0x23E0)
#define REG_FSC_BK23_E1        (REG_FSC_BANK_BASE+0x23E1)
#define REG_FSC_BK23_E2        (REG_FSC_BANK_BASE+0x23E2)
#define REG_FSC_BK23_E3        (REG_FSC_BANK_BASE+0x23E3)
#define REG_FSC_BK23_E4        (REG_FSC_BANK_BASE+0x23E4)
#define REG_FSC_BK23_E5        (REG_FSC_BANK_BASE+0x23E5)
#define REG_FSC_BK23_E6        (REG_FSC_BANK_BASE+0x23E6)
#define REG_FSC_BK23_E7        (REG_FSC_BANK_BASE+0x23E7)
#define REG_FSC_BK23_E8        (REG_FSC_BANK_BASE+0x23E8)
#define REG_FSC_BK23_E9        (REG_FSC_BANK_BASE+0x23E9)
#define REG_FSC_BK23_EA        (REG_FSC_BANK_BASE+0x23EA)
#define REG_FSC_BK23_EB        (REG_FSC_BANK_BASE+0x23EB)
#define REG_FSC_BK23_EC        (REG_FSC_BANK_BASE+0x23EC)
#define REG_FSC_BK23_ED        (REG_FSC_BANK_BASE+0x23ED)
#define REG_FSC_BK23_EE        (REG_FSC_BANK_BASE+0x23EE)
#define REG_FSC_BK23_EF        (REG_FSC_BANK_BASE+0x23EF)
#define REG_FSC_BK23_F0        (REG_FSC_BANK_BASE+0x23F0)
#define REG_FSC_BK23_F1        (REG_FSC_BANK_BASE+0x23F1)
#define REG_FSC_BK23_F2        (REG_FSC_BANK_BASE+0x23F2)
#define REG_FSC_BK23_F3        (REG_FSC_BANK_BASE+0x23F3)
#define REG_FSC_BK23_F4        (REG_FSC_BANK_BASE+0x23F4)
#define REG_FSC_BK23_F5        (REG_FSC_BANK_BASE+0x23F5)
#define REG_FSC_BK23_F6        (REG_FSC_BANK_BASE+0x23F6)
#define REG_FSC_BK23_F7        (REG_FSC_BANK_BASE+0x23F7)
#define REG_FSC_BK23_F8        (REG_FSC_BANK_BASE+0x23F8)
#define REG_FSC_BK23_F9        (REG_FSC_BANK_BASE+0x23F9)
#define REG_FSC_BK23_FA        (REG_FSC_BANK_BASE+0x23FA)
#define REG_FSC_BK23_FB        (REG_FSC_BANK_BASE+0x23FB)
#define REG_FSC_BK23_FC        (REG_FSC_BANK_BASE+0x23FC)
#define REG_FSC_BK23_FD        (REG_FSC_BANK_BASE+0x23FD)
#define REG_FSC_BK23_FE        (REG_FSC_BANK_BASE+0x23FE)
#define REG_FSC_BK23_FF        (REG_FSC_BANK_BASE+0x23FF)

// === FSC bk39
#define REG_FSC_BK39_00        (REG_FSC_BANK_BASE+0x3900)
#define REG_FSC_BK39_01        (REG_FSC_BANK_BASE+0x3901)
#define REG_FSC_BK39_02        (REG_FSC_BANK_BASE+0x3902)
#define REG_FSC_BK39_03        (REG_FSC_BANK_BASE+0x3903)
#define REG_FSC_BK39_04        (REG_FSC_BANK_BASE+0x3904)
#define REG_FSC_BK39_05        (REG_FSC_BANK_BASE+0x3905)
#define REG_FSC_BK39_06        (REG_FSC_BANK_BASE+0x3906)
#define REG_FSC_BK39_07        (REG_FSC_BANK_BASE+0x3907)
#define REG_FSC_BK39_08        (REG_FSC_BANK_BASE+0x3908)
#define REG_FSC_BK39_09        (REG_FSC_BANK_BASE+0x3909)
#define REG_FSC_BK39_0A        (REG_FSC_BANK_BASE+0x390A)
#define REG_FSC_BK39_0B        (REG_FSC_BANK_BASE+0x390B)
#define REG_FSC_BK39_0C        (REG_FSC_BANK_BASE+0x390C)
#define REG_FSC_BK39_0D        (REG_FSC_BANK_BASE+0x390D)
#define REG_FSC_BK39_0E        (REG_FSC_BANK_BASE+0x390E)
#define REG_FSC_BK39_0F        (REG_FSC_BANK_BASE+0x390F)
#define REG_FSC_BK39_10        (REG_FSC_BANK_BASE+0x3910)
#define REG_FSC_BK39_11        (REG_FSC_BANK_BASE+0x3911)
#define REG_FSC_BK39_12        (REG_FSC_BANK_BASE+0x3912)
#define REG_FSC_BK39_13        (REG_FSC_BANK_BASE+0x3913)
#define REG_FSC_BK39_14        (REG_FSC_BANK_BASE+0x3914)
#define REG_FSC_BK39_15        (REG_FSC_BANK_BASE+0x3915)
#define REG_FSC_BK39_16        (REG_FSC_BANK_BASE+0x3916)
#define REG_FSC_BK39_17        (REG_FSC_BANK_BASE+0x3917)
#define REG_FSC_BK39_18        (REG_FSC_BANK_BASE+0x3918)
#define REG_FSC_BK39_19        (REG_FSC_BANK_BASE+0x3919)
#define REG_FSC_BK39_1A        (REG_FSC_BANK_BASE+0x391A)
#define REG_FSC_BK39_1B        (REG_FSC_BANK_BASE+0x391B)
#define REG_FSC_BK39_1C        (REG_FSC_BANK_BASE+0x391C)
#define REG_FSC_BK39_1D        (REG_FSC_BANK_BASE+0x391D)
#define REG_FSC_BK39_1E        (REG_FSC_BANK_BASE+0x391E)
#define REG_FSC_BK39_1F        (REG_FSC_BANK_BASE+0x391F)
#define REG_FSC_BK39_20        (REG_FSC_BANK_BASE+0x3920)
#define REG_FSC_BK39_21        (REG_FSC_BANK_BASE+0x3921)
#define REG_FSC_BK39_22        (REG_FSC_BANK_BASE+0x3922)
#define REG_FSC_BK39_23        (REG_FSC_BANK_BASE+0x3923)
#define REG_FSC_BK39_24        (REG_FSC_BANK_BASE+0x3924)
#define REG_FSC_BK39_25        (REG_FSC_BANK_BASE+0x3925)
#define REG_FSC_BK39_26        (REG_FSC_BANK_BASE+0x3926)
#define REG_FSC_BK39_27        (REG_FSC_BANK_BASE+0x3927)
#define REG_FSC_BK39_28        (REG_FSC_BANK_BASE+0x3928)
#define REG_FSC_BK39_29        (REG_FSC_BANK_BASE+0x3929)
#define REG_FSC_BK39_2A        (REG_FSC_BANK_BASE+0x392A)
#define REG_FSC_BK39_2B        (REG_FSC_BANK_BASE+0x392B)
#define REG_FSC_BK39_2C        (REG_FSC_BANK_BASE+0x392C)
#define REG_FSC_BK39_2D        (REG_FSC_BANK_BASE+0x392D)
#define REG_FSC_BK39_2E        (REG_FSC_BANK_BASE+0x392E)
#define REG_FSC_BK39_2F        (REG_FSC_BANK_BASE+0x392F)
#define REG_FSC_BK39_30        (REG_FSC_BANK_BASE+0x3930)
#define REG_FSC_BK39_31        (REG_FSC_BANK_BASE+0x3931)
#define REG_FSC_BK39_32        (REG_FSC_BANK_BASE+0x3932)
#define REG_FSC_BK39_33        (REG_FSC_BANK_BASE+0x3933)
#define REG_FSC_BK39_34        (REG_FSC_BANK_BASE+0x3934)
#define REG_FSC_BK39_35        (REG_FSC_BANK_BASE+0x3935)
#define REG_FSC_BK39_36        (REG_FSC_BANK_BASE+0x3936)
#define REG_FSC_BK39_37        (REG_FSC_BANK_BASE+0x3937)
#define REG_FSC_BK39_38        (REG_FSC_BANK_BASE+0x3938)
#define REG_FSC_BK39_39        (REG_FSC_BANK_BASE+0x3939)
#define REG_FSC_BK39_3A        (REG_FSC_BANK_BASE+0x393A)
#define REG_FSC_BK39_3B        (REG_FSC_BANK_BASE+0x393B)
#define REG_FSC_BK39_3C        (REG_FSC_BANK_BASE+0x393C)
#define REG_FSC_BK39_3D        (REG_FSC_BANK_BASE+0x393D)
#define REG_FSC_BK39_3E        (REG_FSC_BANK_BASE+0x393E)
#define REG_FSC_BK39_3F        (REG_FSC_BANK_BASE+0x393F)
#define REG_FSC_BK39_40        (REG_FSC_BANK_BASE+0x3940)
#define REG_FSC_BK39_41        (REG_FSC_BANK_BASE+0x3941)
#define REG_FSC_BK39_42        (REG_FSC_BANK_BASE+0x3942)
#define REG_FSC_BK39_43        (REG_FSC_BANK_BASE+0x3943)
#define REG_FSC_BK39_44        (REG_FSC_BANK_BASE+0x3944)
#define REG_FSC_BK39_45        (REG_FSC_BANK_BASE+0x3945)
#define REG_FSC_BK39_46        (REG_FSC_BANK_BASE+0x3946)
#define REG_FSC_BK39_47        (REG_FSC_BANK_BASE+0x3947)
#define REG_FSC_BK39_48        (REG_FSC_BANK_BASE+0x3948)
#define REG_FSC_BK39_49        (REG_FSC_BANK_BASE+0x3949)
#define REG_FSC_BK39_4A        (REG_FSC_BANK_BASE+0x394A)
#define REG_FSC_BK39_4B        (REG_FSC_BANK_BASE+0x394B)
#define REG_FSC_BK39_4C        (REG_FSC_BANK_BASE+0x394C)
#define REG_FSC_BK39_4D        (REG_FSC_BANK_BASE+0x394D)
#define REG_FSC_BK39_4E        (REG_FSC_BANK_BASE+0x394E)
#define REG_FSC_BK39_4F        (REG_FSC_BANK_BASE+0x394F)
#define REG_FSC_BK39_50        (REG_FSC_BANK_BASE+0x3950)
#define REG_FSC_BK39_51        (REG_FSC_BANK_BASE+0x3951)
#define REG_FSC_BK39_52        (REG_FSC_BANK_BASE+0x3952)
#define REG_FSC_BK39_53        (REG_FSC_BANK_BASE+0x3953)
#define REG_FSC_BK39_54        (REG_FSC_BANK_BASE+0x3954)
#define REG_FSC_BK39_55        (REG_FSC_BANK_BASE+0x3955)
#define REG_FSC_BK39_56        (REG_FSC_BANK_BASE+0x3956)
#define REG_FSC_BK39_57        (REG_FSC_BANK_BASE+0x3957)
#define REG_FSC_BK39_58        (REG_FSC_BANK_BASE+0x3958)
#define REG_FSC_BK39_59        (REG_FSC_BANK_BASE+0x3959)
#define REG_FSC_BK39_5A        (REG_FSC_BANK_BASE+0x395A)
#define REG_FSC_BK39_5B        (REG_FSC_BANK_BASE+0x395B)
#define REG_FSC_BK39_5C        (REG_FSC_BANK_BASE+0x395C)
#define REG_FSC_BK39_5D        (REG_FSC_BANK_BASE+0x395D)
#define REG_FSC_BK39_5E        (REG_FSC_BANK_BASE+0x395E)
#define REG_FSC_BK39_5F        (REG_FSC_BANK_BASE+0x395F)
#define REG_FSC_BK39_60        (REG_FSC_BANK_BASE+0x3960)
#define REG_FSC_BK39_61        (REG_FSC_BANK_BASE+0x3961)
#define REG_FSC_BK39_62        (REG_FSC_BANK_BASE+0x3962)
#define REG_FSC_BK39_63        (REG_FSC_BANK_BASE+0x3963)
#define REG_FSC_BK39_64        (REG_FSC_BANK_BASE+0x3964)
#define REG_FSC_BK39_65        (REG_FSC_BANK_BASE+0x3965)
#define REG_FSC_BK39_66        (REG_FSC_BANK_BASE+0x3966)
#define REG_FSC_BK39_67        (REG_FSC_BANK_BASE+0x3967)
#define REG_FSC_BK39_68        (REG_FSC_BANK_BASE+0x3968)
#define REG_FSC_BK39_69        (REG_FSC_BANK_BASE+0x3969)
#define REG_FSC_BK39_6A        (REG_FSC_BANK_BASE+0x396A)
#define REG_FSC_BK39_6B        (REG_FSC_BANK_BASE+0x396B)
#define REG_FSC_BK39_6C        (REG_FSC_BANK_BASE+0x396C)
#define REG_FSC_BK39_6D        (REG_FSC_BANK_BASE+0x396D)
#define REG_FSC_BK39_6E        (REG_FSC_BANK_BASE+0x396E)
#define REG_FSC_BK39_6F        (REG_FSC_BANK_BASE+0x396F)
#define REG_FSC_BK39_70        (REG_FSC_BANK_BASE+0x3970)
#define REG_FSC_BK39_71        (REG_FSC_BANK_BASE+0x3971)
#define REG_FSC_BK39_72        (REG_FSC_BANK_BASE+0x3972)
#define REG_FSC_BK39_73        (REG_FSC_BANK_BASE+0x3973)
#define REG_FSC_BK39_74        (REG_FSC_BANK_BASE+0x3974)
#define REG_FSC_BK39_75        (REG_FSC_BANK_BASE+0x3975)
#define REG_FSC_BK39_76        (REG_FSC_BANK_BASE+0x3976)
#define REG_FSC_BK39_77        (REG_FSC_BANK_BASE+0x3977)
#define REG_FSC_BK39_78        (REG_FSC_BANK_BASE+0x3978)
#define REG_FSC_BK39_79        (REG_FSC_BANK_BASE+0x3979)
#define REG_FSC_BK39_7A        (REG_FSC_BANK_BASE+0x397A)
#define REG_FSC_BK39_7B        (REG_FSC_BANK_BASE+0x397B)
#define REG_FSC_BK39_7C        (REG_FSC_BANK_BASE+0x397C)
#define REG_FSC_BK39_7D        (REG_FSC_BANK_BASE+0x397D)
#define REG_FSC_BK39_7E        (REG_FSC_BANK_BASE+0x397E)
#define REG_FSC_BK39_7F        (REG_FSC_BANK_BASE+0x397F)
#define REG_FSC_BK39_80        (REG_FSC_BANK_BASE+0x3980)
#define REG_FSC_BK39_81        (REG_FSC_BANK_BASE+0x3981)
#define REG_FSC_BK39_82        (REG_FSC_BANK_BASE+0x3982)
#define REG_FSC_BK39_83        (REG_FSC_BANK_BASE+0x3983)
#define REG_FSC_BK39_84        (REG_FSC_BANK_BASE+0x3984)
#define REG_FSC_BK39_85        (REG_FSC_BANK_BASE+0x3985)
#define REG_FSC_BK39_86        (REG_FSC_BANK_BASE+0x3986)
#define REG_FSC_BK39_87        (REG_FSC_BANK_BASE+0x3987)
#define REG_FSC_BK39_88        (REG_FSC_BANK_BASE+0x3988)
#define REG_FSC_BK39_89        (REG_FSC_BANK_BASE+0x3989)
#define REG_FSC_BK39_8A        (REG_FSC_BANK_BASE+0x398A)
#define REG_FSC_BK39_8B        (REG_FSC_BANK_BASE+0x398B)
#define REG_FSC_BK39_8C        (REG_FSC_BANK_BASE+0x398C)
#define REG_FSC_BK39_8D        (REG_FSC_BANK_BASE+0x398D)
#define REG_FSC_BK39_8E        (REG_FSC_BANK_BASE+0x398E)
#define REG_FSC_BK39_8F        (REG_FSC_BANK_BASE+0x398F)
#define REG_FSC_BK39_90        (REG_FSC_BANK_BASE+0x3990)
#define REG_FSC_BK39_91        (REG_FSC_BANK_BASE+0x3991)
#define REG_FSC_BK39_92        (REG_FSC_BANK_BASE+0x3992)
#define REG_FSC_BK39_93        (REG_FSC_BANK_BASE+0x3993)
#define REG_FSC_BK39_94        (REG_FSC_BANK_BASE+0x3994)
#define REG_FSC_BK39_95        (REG_FSC_BANK_BASE+0x3995)
#define REG_FSC_BK39_96        (REG_FSC_BANK_BASE+0x3996)
#define REG_FSC_BK39_97        (REG_FSC_BANK_BASE+0x3997)
#define REG_FSC_BK39_98        (REG_FSC_BANK_BASE+0x3998)
#define REG_FSC_BK39_99        (REG_FSC_BANK_BASE+0x3999)
#define REG_FSC_BK39_9A        (REG_FSC_BANK_BASE+0x399A)
#define REG_FSC_BK39_9B        (REG_FSC_BANK_BASE+0x399B)
#define REG_FSC_BK39_9C        (REG_FSC_BANK_BASE+0x399C)
#define REG_FSC_BK39_9D        (REG_FSC_BANK_BASE+0x399D)
#define REG_FSC_BK39_9E        (REG_FSC_BANK_BASE+0x399E)
#define REG_FSC_BK39_9F        (REG_FSC_BANK_BASE+0x399F)
#define REG_FSC_BK39_A0        (REG_FSC_BANK_BASE+0x39A0)
#define REG_FSC_BK39_A1        (REG_FSC_BANK_BASE+0x39A1)
#define REG_FSC_BK39_A2        (REG_FSC_BANK_BASE+0x39A2)
#define REG_FSC_BK39_A3        (REG_FSC_BANK_BASE+0x39A3)
#define REG_FSC_BK39_A4        (REG_FSC_BANK_BASE+0x39A4)
#define REG_FSC_BK39_A5        (REG_FSC_BANK_BASE+0x39A5)
#define REG_FSC_BK39_A6        (REG_FSC_BANK_BASE+0x39A6)
#define REG_FSC_BK39_A7        (REG_FSC_BANK_BASE+0x39A7)
#define REG_FSC_BK39_A8        (REG_FSC_BANK_BASE+0x39A8)
#define REG_FSC_BK39_A9        (REG_FSC_BANK_BASE+0x39A9)
#define REG_FSC_BK39_AA        (REG_FSC_BANK_BASE+0x39AA)
#define REG_FSC_BK39_AB        (REG_FSC_BANK_BASE+0x39AB)
#define REG_FSC_BK39_AC        (REG_FSC_BANK_BASE+0x39AC)
#define REG_FSC_BK39_AD        (REG_FSC_BANK_BASE+0x39AD)
#define REG_FSC_BK39_AE        (REG_FSC_BANK_BASE+0x39AE)
#define REG_FSC_BK39_AF        (REG_FSC_BANK_BASE+0x39AF)
#define REG_FSC_BK39_B0        (REG_FSC_BANK_BASE+0x39B0)
#define REG_FSC_BK39_B1        (REG_FSC_BANK_BASE+0x39B1)
#define REG_FSC_BK39_B2        (REG_FSC_BANK_BASE+0x39B2)
#define REG_FSC_BK39_B3        (REG_FSC_BANK_BASE+0x39B3)
#define REG_FSC_BK39_B4        (REG_FSC_BANK_BASE+0x39B4)
#define REG_FSC_BK39_B5        (REG_FSC_BANK_BASE+0x39B5)
#define REG_FSC_BK39_B6        (REG_FSC_BANK_BASE+0x39B6)
#define REG_FSC_BK39_B7        (REG_FSC_BANK_BASE+0x39B7)
#define REG_FSC_BK39_B8        (REG_FSC_BANK_BASE+0x39B8)
#define REG_FSC_BK39_B9        (REG_FSC_BANK_BASE+0x39B9)
#define REG_FSC_BK39_BA        (REG_FSC_BANK_BASE+0x39BA)
#define REG_FSC_BK39_BB        (REG_FSC_BANK_BASE+0x39BB)
#define REG_FSC_BK39_BC        (REG_FSC_BANK_BASE+0x39BC)
#define REG_FSC_BK39_BD        (REG_FSC_BANK_BASE+0x39BD)
#define REG_FSC_BK39_BE        (REG_FSC_BANK_BASE+0x39BE)
#define REG_FSC_BK39_BF        (REG_FSC_BANK_BASE+0x39BF)
#define REG_FSC_BK39_C0        (REG_FSC_BANK_BASE+0x39C0)
#define REG_FSC_BK39_C1        (REG_FSC_BANK_BASE+0x39C1)
#define REG_FSC_BK39_C2        (REG_FSC_BANK_BASE+0x39C2)
#define REG_FSC_BK39_C3        (REG_FSC_BANK_BASE+0x39C3)
#define REG_FSC_BK39_C4        (REG_FSC_BANK_BASE+0x39C4)
#define REG_FSC_BK39_C5        (REG_FSC_BANK_BASE+0x39C5)
#define REG_FSC_BK39_C6        (REG_FSC_BANK_BASE+0x39C6)
#define REG_FSC_BK39_C7        (REG_FSC_BANK_BASE+0x39C7)
#define REG_FSC_BK39_C8        (REG_FSC_BANK_BASE+0x39C8)
#define REG_FSC_BK39_C9        (REG_FSC_BANK_BASE+0x39C9)
#define REG_FSC_BK39_CA        (REG_FSC_BANK_BASE+0x39CA)
#define REG_FSC_BK39_CB        (REG_FSC_BANK_BASE+0x39CB)
#define REG_FSC_BK39_CC        (REG_FSC_BANK_BASE+0x39CC)
#define REG_FSC_BK39_CD        (REG_FSC_BANK_BASE+0x39CD)
#define REG_FSC_BK39_CE        (REG_FSC_BANK_BASE+0x39CE)
#define REG_FSC_BK39_CF        (REG_FSC_BANK_BASE+0x39CF)
#define REG_FSC_BK39_D0        (REG_FSC_BANK_BASE+0x39D0)
#define REG_FSC_BK39_D1        (REG_FSC_BANK_BASE+0x39D1)
#define REG_FSC_BK39_D2        (REG_FSC_BANK_BASE+0x39D2)
#define REG_FSC_BK39_D3        (REG_FSC_BANK_BASE+0x39D3)
#define REG_FSC_BK39_D4        (REG_FSC_BANK_BASE+0x39D4)
#define REG_FSC_BK39_D5        (REG_FSC_BANK_BASE+0x39D5)
#define REG_FSC_BK39_D6        (REG_FSC_BANK_BASE+0x39D6)
#define REG_FSC_BK39_D7        (REG_FSC_BANK_BASE+0x39D7)
#define REG_FSC_BK39_D8        (REG_FSC_BANK_BASE+0x39D8)
#define REG_FSC_BK39_D9        (REG_FSC_BANK_BASE+0x39D9)
#define REG_FSC_BK39_DA        (REG_FSC_BANK_BASE+0x39DA)
#define REG_FSC_BK39_DB        (REG_FSC_BANK_BASE+0x39DB)
#define REG_FSC_BK39_DC        (REG_FSC_BANK_BASE+0x39DC)
#define REG_FSC_BK39_DD        (REG_FSC_BANK_BASE+0x39DD)
#define REG_FSC_BK39_DE        (REG_FSC_BANK_BASE+0x39DE)
#define REG_FSC_BK39_DF        (REG_FSC_BANK_BASE+0x39DF)
#define REG_FSC_BK39_E0        (REG_FSC_BANK_BASE+0x39E0)
#define REG_FSC_BK39_E1        (REG_FSC_BANK_BASE+0x39E1)
#define REG_FSC_BK39_E2        (REG_FSC_BANK_BASE+0x39E2)
#define REG_FSC_BK39_E3        (REG_FSC_BANK_BASE+0x39E3)
#define REG_FSC_BK39_E4        (REG_FSC_BANK_BASE+0x39E4)
#define REG_FSC_BK39_E5        (REG_FSC_BANK_BASE+0x39E5)
#define REG_FSC_BK39_E6        (REG_FSC_BANK_BASE+0x39E6)
#define REG_FSC_BK39_E7        (REG_FSC_BANK_BASE+0x39E7)
#define REG_FSC_BK39_E8        (REG_FSC_BANK_BASE+0x39E8)
#define REG_FSC_BK39_E9        (REG_FSC_BANK_BASE+0x39E9)
#define REG_FSC_BK39_EA        (REG_FSC_BANK_BASE+0x39EA)
#define REG_FSC_BK39_EB        (REG_FSC_BANK_BASE+0x39EB)
#define REG_FSC_BK39_EC        (REG_FSC_BANK_BASE+0x39EC)
#define REG_FSC_BK39_ED        (REG_FSC_BANK_BASE+0x39ED)
#define REG_FSC_BK39_EE        (REG_FSC_BANK_BASE+0x39EE)
#define REG_FSC_BK39_EF        (REG_FSC_BANK_BASE+0x39EF)
#define REG_FSC_BK39_F0        (REG_FSC_BANK_BASE+0x39F0)
#define REG_FSC_BK39_F1        (REG_FSC_BANK_BASE+0x39F1)
#define REG_FSC_BK39_F2        (REG_FSC_BANK_BASE+0x39F2)
#define REG_FSC_BK39_F3        (REG_FSC_BANK_BASE+0x39F3)
#define REG_FSC_BK39_F4        (REG_FSC_BANK_BASE+0x39F4)
#define REG_FSC_BK39_F5        (REG_FSC_BANK_BASE+0x39F5)
#define REG_FSC_BK39_F6        (REG_FSC_BANK_BASE+0x39F6)
#define REG_FSC_BK39_F7        (REG_FSC_BANK_BASE+0x39F7)
#define REG_FSC_BK39_F8        (REG_FSC_BANK_BASE+0x39F8)
#define REG_FSC_BK39_F9        (REG_FSC_BANK_BASE+0x39F9)
#define REG_FSC_BK39_FA        (REG_FSC_BANK_BASE+0x39FA)
#define REG_FSC_BK39_FB        (REG_FSC_BANK_BASE+0x39FB)
#define REG_FSC_BK39_FC        (REG_FSC_BANK_BASE+0x39FC)
#define REG_FSC_BK39_FD        (REG_FSC_BANK_BASE+0x39FD)
#define REG_FSC_BK39_FE        (REG_FSC_BANK_BASE+0x39FE)
#define REG_FSC_BK39_FF        (REG_FSC_BANK_BASE+0x39FF)

// === FSC bk3A
#define REG_FSC_BK3A_00        (REG_FSC_BANK_BASE+0x3A00)
#define REG_FSC_BK3A_01        (REG_FSC_BANK_BASE+0x3A01)
#define REG_FSC_BK3A_02        (REG_FSC_BANK_BASE+0x3A02)
#define REG_FSC_BK3A_03        (REG_FSC_BANK_BASE+0x3A03)
#define REG_FSC_BK3A_04        (REG_FSC_BANK_BASE+0x3A04)
#define REG_FSC_BK3A_05        (REG_FSC_BANK_BASE+0x3A05)
#define REG_FSC_BK3A_06        (REG_FSC_BANK_BASE+0x3A06)
#define REG_FSC_BK3A_07        (REG_FSC_BANK_BASE+0x3A07)
#define REG_FSC_BK3A_08        (REG_FSC_BANK_BASE+0x3A08)
#define REG_FSC_BK3A_09        (REG_FSC_BANK_BASE+0x3A09)
#define REG_FSC_BK3A_0A        (REG_FSC_BANK_BASE+0x3A0A)
#define REG_FSC_BK3A_0B        (REG_FSC_BANK_BASE+0x3A0B)
#define REG_FSC_BK3A_0C        (REG_FSC_BANK_BASE+0x3A0C)
#define REG_FSC_BK3A_0D        (REG_FSC_BANK_BASE+0x3A0D)
#define REG_FSC_BK3A_0E        (REG_FSC_BANK_BASE+0x3A0E)
#define REG_FSC_BK3A_0F        (REG_FSC_BANK_BASE+0x3A0F)
#define REG_FSC_BK3A_10        (REG_FSC_BANK_BASE+0x3A10)
#define REG_FSC_BK3A_11        (REG_FSC_BANK_BASE+0x3A11)
#define REG_FSC_BK3A_12        (REG_FSC_BANK_BASE+0x3A12)
#define REG_FSC_BK3A_13        (REG_FSC_BANK_BASE+0x3A13)
#define REG_FSC_BK3A_14        (REG_FSC_BANK_BASE+0x3A14)
#define REG_FSC_BK3A_15        (REG_FSC_BANK_BASE+0x3A15)
#define REG_FSC_BK3A_16        (REG_FSC_BANK_BASE+0x3A16)
#define REG_FSC_BK3A_17        (REG_FSC_BANK_BASE+0x3A17)
#define REG_FSC_BK3A_18        (REG_FSC_BANK_BASE+0x3A18)
#define REG_FSC_BK3A_19        (REG_FSC_BANK_BASE+0x3A19)
#define REG_FSC_BK3A_1A        (REG_FSC_BANK_BASE+0x3A1A)
#define REG_FSC_BK3A_1B        (REG_FSC_BANK_BASE+0x3A1B)
#define REG_FSC_BK3A_1C        (REG_FSC_BANK_BASE+0x3A1C)
#define REG_FSC_BK3A_1D        (REG_FSC_BANK_BASE+0x3A1D)
#define REG_FSC_BK3A_1E        (REG_FSC_BANK_BASE+0x3A1E)
#define REG_FSC_BK3A_1F        (REG_FSC_BANK_BASE+0x3A1F)
#define REG_FSC_BK3A_20        (REG_FSC_BANK_BASE+0x3A20)
#define REG_FSC_BK3A_21        (REG_FSC_BANK_BASE+0x3A21)
#define REG_FSC_BK3A_22        (REG_FSC_BANK_BASE+0x3A22)
#define REG_FSC_BK3A_23        (REG_FSC_BANK_BASE+0x3A23)
#define REG_FSC_BK3A_24        (REG_FSC_BANK_BASE+0x3A24)
#define REG_FSC_BK3A_25        (REG_FSC_BANK_BASE+0x3A25)
#define REG_FSC_BK3A_26        (REG_FSC_BANK_BASE+0x3A26)
#define REG_FSC_BK3A_27        (REG_FSC_BANK_BASE+0x3A27)
#define REG_FSC_BK3A_28        (REG_FSC_BANK_BASE+0x3A28)
#define REG_FSC_BK3A_29        (REG_FSC_BANK_BASE+0x3A29)
#define REG_FSC_BK3A_2A        (REG_FSC_BANK_BASE+0x3A2A)
#define REG_FSC_BK3A_2B        (REG_FSC_BANK_BASE+0x3A2B)
#define REG_FSC_BK3A_2C        (REG_FSC_BANK_BASE+0x3A2C)
#define REG_FSC_BK3A_2D        (REG_FSC_BANK_BASE+0x3A2D)
#define REG_FSC_BK3A_2E        (REG_FSC_BANK_BASE+0x3A2E)
#define REG_FSC_BK3A_2F        (REG_FSC_BANK_BASE+0x3A2F)
#define REG_FSC_BK3A_30        (REG_FSC_BANK_BASE+0x3A30)
#define REG_FSC_BK3A_31        (REG_FSC_BANK_BASE+0x3A31)
#define REG_FSC_BK3A_32        (REG_FSC_BANK_BASE+0x3A32)
#define REG_FSC_BK3A_33        (REG_FSC_BANK_BASE+0x3A33)
#define REG_FSC_BK3A_34        (REG_FSC_BANK_BASE+0x3A34)
#define REG_FSC_BK3A_35        (REG_FSC_BANK_BASE+0x3A35)
#define REG_FSC_BK3A_36        (REG_FSC_BANK_BASE+0x3A36)
#define REG_FSC_BK3A_37        (REG_FSC_BANK_BASE+0x3A37)
#define REG_FSC_BK3A_38        (REG_FSC_BANK_BASE+0x3A38)
#define REG_FSC_BK3A_39        (REG_FSC_BANK_BASE+0x3A39)
#define REG_FSC_BK3A_3A        (REG_FSC_BANK_BASE+0x3A3A)
#define REG_FSC_BK3A_3B        (REG_FSC_BANK_BASE+0x3A3B)
#define REG_FSC_BK3A_3C        (REG_FSC_BANK_BASE+0x3A3C)
#define REG_FSC_BK3A_3D        (REG_FSC_BANK_BASE+0x3A3D)
#define REG_FSC_BK3A_3E        (REG_FSC_BANK_BASE+0x3A3E)
#define REG_FSC_BK3A_3F        (REG_FSC_BANK_BASE+0x3A3F)
#define REG_FSC_BK3A_40        (REG_FSC_BANK_BASE+0x3A40)
#define REG_FSC_BK3A_41        (REG_FSC_BANK_BASE+0x3A41)
#define REG_FSC_BK3A_42        (REG_FSC_BANK_BASE+0x3A42)
#define REG_FSC_BK3A_43        (REG_FSC_BANK_BASE+0x3A43)
#define REG_FSC_BK3A_44        (REG_FSC_BANK_BASE+0x3A44)
#define REG_FSC_BK3A_45        (REG_FSC_BANK_BASE+0x3A45)
#define REG_FSC_BK3A_46        (REG_FSC_BANK_BASE+0x3A46)
#define REG_FSC_BK3A_47        (REG_FSC_BANK_BASE+0x3A47)
#define REG_FSC_BK3A_48        (REG_FSC_BANK_BASE+0x3A48)
#define REG_FSC_BK3A_49        (REG_FSC_BANK_BASE+0x3A49)
#define REG_FSC_BK3A_4A        (REG_FSC_BANK_BASE+0x3A4A)
#define REG_FSC_BK3A_4B        (REG_FSC_BANK_BASE+0x3A4B)
#define REG_FSC_BK3A_4C        (REG_FSC_BANK_BASE+0x3A4C)
#define REG_FSC_BK3A_4D        (REG_FSC_BANK_BASE+0x3A4D)
#define REG_FSC_BK3A_4E        (REG_FSC_BANK_BASE+0x3A4E)
#define REG_FSC_BK3A_4F        (REG_FSC_BANK_BASE+0x3A4F)
#define REG_FSC_BK3A_50        (REG_FSC_BANK_BASE+0x3A50)
#define REG_FSC_BK3A_51        (REG_FSC_BANK_BASE+0x3A51)
#define REG_FSC_BK3A_52        (REG_FSC_BANK_BASE+0x3A52)
#define REG_FSC_BK3A_53        (REG_FSC_BANK_BASE+0x3A53)
#define REG_FSC_BK3A_54        (REG_FSC_BANK_BASE+0x3A54)
#define REG_FSC_BK3A_55        (REG_FSC_BANK_BASE+0x3A55)
#define REG_FSC_BK3A_56        (REG_FSC_BANK_BASE+0x3A56)
#define REG_FSC_BK3A_57        (REG_FSC_BANK_BASE+0x3A57)
#define REG_FSC_BK3A_58        (REG_FSC_BANK_BASE+0x3A58)
#define REG_FSC_BK3A_59        (REG_FSC_BANK_BASE+0x3A59)
#define REG_FSC_BK3A_5A        (REG_FSC_BANK_BASE+0x3A5A)
#define REG_FSC_BK3A_5B        (REG_FSC_BANK_BASE+0x3A5B)
#define REG_FSC_BK3A_5C        (REG_FSC_BANK_BASE+0x3A5C)
#define REG_FSC_BK3A_5D        (REG_FSC_BANK_BASE+0x3A5D)
#define REG_FSC_BK3A_5E        (REG_FSC_BANK_BASE+0x3A5E)
#define REG_FSC_BK3A_5F        (REG_FSC_BANK_BASE+0x3A5F)
#define REG_FSC_BK3A_60        (REG_FSC_BANK_BASE+0x3A60)
#define REG_FSC_BK3A_61        (REG_FSC_BANK_BASE+0x3A61)
#define REG_FSC_BK3A_62        (REG_FSC_BANK_BASE+0x3A62)
#define REG_FSC_BK3A_63        (REG_FSC_BANK_BASE+0x3A63)
#define REG_FSC_BK3A_64        (REG_FSC_BANK_BASE+0x3A64)
#define REG_FSC_BK3A_65        (REG_FSC_BANK_BASE+0x3A65)
#define REG_FSC_BK3A_66        (REG_FSC_BANK_BASE+0x3A66)
#define REG_FSC_BK3A_67        (REG_FSC_BANK_BASE+0x3A67)
#define REG_FSC_BK3A_68        (REG_FSC_BANK_BASE+0x3A68)
#define REG_FSC_BK3A_69        (REG_FSC_BANK_BASE+0x3A69)
#define REG_FSC_BK3A_6A        (REG_FSC_BANK_BASE+0x3A6A)
#define REG_FSC_BK3A_6B        (REG_FSC_BANK_BASE+0x3A6B)
#define REG_FSC_BK3A_6C        (REG_FSC_BANK_BASE+0x3A6C)
#define REG_FSC_BK3A_6D        (REG_FSC_BANK_BASE+0x3A6D)
#define REG_FSC_BK3A_6E        (REG_FSC_BANK_BASE+0x3A6E)
#define REG_FSC_BK3A_6F        (REG_FSC_BANK_BASE+0x3A6F)
#define REG_FSC_BK3A_70        (REG_FSC_BANK_BASE+0x3A70)
#define REG_FSC_BK3A_71        (REG_FSC_BANK_BASE+0x3A71)
#define REG_FSC_BK3A_72        (REG_FSC_BANK_BASE+0x3A72)
#define REG_FSC_BK3A_73        (REG_FSC_BANK_BASE+0x3A73)
#define REG_FSC_BK3A_74        (REG_FSC_BANK_BASE+0x3A74)
#define REG_FSC_BK3A_75        (REG_FSC_BANK_BASE+0x3A75)
#define REG_FSC_BK3A_76        (REG_FSC_BANK_BASE+0x3A76)
#define REG_FSC_BK3A_77        (REG_FSC_BANK_BASE+0x3A77)
#define REG_FSC_BK3A_78        (REG_FSC_BANK_BASE+0x3A78)
#define REG_FSC_BK3A_79        (REG_FSC_BANK_BASE+0x3A79)
#define REG_FSC_BK3A_7A        (REG_FSC_BANK_BASE+0x3A7A)
#define REG_FSC_BK3A_7B        (REG_FSC_BANK_BASE+0x3A7B)
#define REG_FSC_BK3A_7C        (REG_FSC_BANK_BASE+0x3A7C)
#define REG_FSC_BK3A_7D        (REG_FSC_BANK_BASE+0x3A7D)
#define REG_FSC_BK3A_7E        (REG_FSC_BANK_BASE+0x3A7E)
#define REG_FSC_BK3A_7F        (REG_FSC_BANK_BASE+0x3A7F)
#define REG_FSC_BK3A_80        (REG_FSC_BANK_BASE+0x3A80)
#define REG_FSC_BK3A_81        (REG_FSC_BANK_BASE+0x3A81)
#define REG_FSC_BK3A_82        (REG_FSC_BANK_BASE+0x3A82)
#define REG_FSC_BK3A_83        (REG_FSC_BANK_BASE+0x3A83)
#define REG_FSC_BK3A_84        (REG_FSC_BANK_BASE+0x3A84)
#define REG_FSC_BK3A_85        (REG_FSC_BANK_BASE+0x3A85)
#define REG_FSC_BK3A_86        (REG_FSC_BANK_BASE+0x3A86)
#define REG_FSC_BK3A_87        (REG_FSC_BANK_BASE+0x3A87)
#define REG_FSC_BK3A_88        (REG_FSC_BANK_BASE+0x3A88)
#define REG_FSC_BK3A_89        (REG_FSC_BANK_BASE+0x3A89)
#define REG_FSC_BK3A_8A        (REG_FSC_BANK_BASE+0x3A8A)
#define REG_FSC_BK3A_8B        (REG_FSC_BANK_BASE+0x3A8B)
#define REG_FSC_BK3A_8C        (REG_FSC_BANK_BASE+0x3A8C)
#define REG_FSC_BK3A_8D        (REG_FSC_BANK_BASE+0x3A8D)
#define REG_FSC_BK3A_8E        (REG_FSC_BANK_BASE+0x3A8E)
#define REG_FSC_BK3A_8F        (REG_FSC_BANK_BASE+0x3A8F)
#define REG_FSC_BK3A_90        (REG_FSC_BANK_BASE+0x3A90)
#define REG_FSC_BK3A_91        (REG_FSC_BANK_BASE+0x3A91)
#define REG_FSC_BK3A_92        (REG_FSC_BANK_BASE+0x3A92)
#define REG_FSC_BK3A_93        (REG_FSC_BANK_BASE+0x3A93)
#define REG_FSC_BK3A_94        (REG_FSC_BANK_BASE+0x3A94)
#define REG_FSC_BK3A_95        (REG_FSC_BANK_BASE+0x3A95)
#define REG_FSC_BK3A_96        (REG_FSC_BANK_BASE+0x3A96)
#define REG_FSC_BK3A_97        (REG_FSC_BANK_BASE+0x3A97)
#define REG_FSC_BK3A_98        (REG_FSC_BANK_BASE+0x3A98)
#define REG_FSC_BK3A_99        (REG_FSC_BANK_BASE+0x3A99)
#define REG_FSC_BK3A_9A        (REG_FSC_BANK_BASE+0x3A9A)
#define REG_FSC_BK3A_9B        (REG_FSC_BANK_BASE+0x3A9B)
#define REG_FSC_BK3A_9C        (REG_FSC_BANK_BASE+0x3A9C)
#define REG_FSC_BK3A_9D        (REG_FSC_BANK_BASE+0x3A9D)
#define REG_FSC_BK3A_9E        (REG_FSC_BANK_BASE+0x3A9E)
#define REG_FSC_BK3A_9F        (REG_FSC_BANK_BASE+0x3A9F)
#define REG_FSC_BK3A_A0        (REG_FSC_BANK_BASE+0x3AA0)
#define REG_FSC_BK3A_A1        (REG_FSC_BANK_BASE+0x3AA1)
#define REG_FSC_BK3A_A2        (REG_FSC_BANK_BASE+0x3AA2)
#define REG_FSC_BK3A_A3        (REG_FSC_BANK_BASE+0x3AA3)
#define REG_FSC_BK3A_A4        (REG_FSC_BANK_BASE+0x3AA4)
#define REG_FSC_BK3A_A5        (REG_FSC_BANK_BASE+0x3AA5)
#define REG_FSC_BK3A_A6        (REG_FSC_BANK_BASE+0x3AA6)
#define REG_FSC_BK3A_A7        (REG_FSC_BANK_BASE+0x3AA7)
#define REG_FSC_BK3A_A8        (REG_FSC_BANK_BASE+0x3AA8)
#define REG_FSC_BK3A_A9        (REG_FSC_BANK_BASE+0x3AA9)
#define REG_FSC_BK3A_AA        (REG_FSC_BANK_BASE+0x3AAA)
#define REG_FSC_BK3A_AB        (REG_FSC_BANK_BASE+0x3AAB)
#define REG_FSC_BK3A_AC        (REG_FSC_BANK_BASE+0x3AAC)
#define REG_FSC_BK3A_AD        (REG_FSC_BANK_BASE+0x3AAD)
#define REG_FSC_BK3A_AE        (REG_FSC_BANK_BASE+0x3AAE)
#define REG_FSC_BK3A_AF        (REG_FSC_BANK_BASE+0x3AAF)
#define REG_FSC_BK3A_B0        (REG_FSC_BANK_BASE+0x3AB0)
#define REG_FSC_BK3A_B1        (REG_FSC_BANK_BASE+0x3AB1)
#define REG_FSC_BK3A_B2        (REG_FSC_BANK_BASE+0x3AB2)
#define REG_FSC_BK3A_B3        (REG_FSC_BANK_BASE+0x3AB3)
#define REG_FSC_BK3A_B4        (REG_FSC_BANK_BASE+0x3AB4)
#define REG_FSC_BK3A_B5        (REG_FSC_BANK_BASE+0x3AB5)
#define REG_FSC_BK3A_B6        (REG_FSC_BANK_BASE+0x3AB6)
#define REG_FSC_BK3A_B7        (REG_FSC_BANK_BASE+0x3AB7)
#define REG_FSC_BK3A_B8        (REG_FSC_BANK_BASE+0x3AB8)
#define REG_FSC_BK3A_B9        (REG_FSC_BANK_BASE+0x3AB9)
#define REG_FSC_BK3A_BA        (REG_FSC_BANK_BASE+0x3ABA)
#define REG_FSC_BK3A_BB        (REG_FSC_BANK_BASE+0x3ABB)
#define REG_FSC_BK3A_BC        (REG_FSC_BANK_BASE+0x3ABC)
#define REG_FSC_BK3A_BD        (REG_FSC_BANK_BASE+0x3ABD)
#define REG_FSC_BK3A_BE        (REG_FSC_BANK_BASE+0x3ABE)
#define REG_FSC_BK3A_BF        (REG_FSC_BANK_BASE+0x3ABF)
#define REG_FSC_BK3A_C0        (REG_FSC_BANK_BASE+0x3AC0)
#define REG_FSC_BK3A_C1        (REG_FSC_BANK_BASE+0x3AC1)
#define REG_FSC_BK3A_C2        (REG_FSC_BANK_BASE+0x3AC2)
#define REG_FSC_BK3A_C3        (REG_FSC_BANK_BASE+0x3AC3)
#define REG_FSC_BK3A_C4        (REG_FSC_BANK_BASE+0x3AC4)
#define REG_FSC_BK3A_C5        (REG_FSC_BANK_BASE+0x3AC5)
#define REG_FSC_BK3A_C6        (REG_FSC_BANK_BASE+0x3AC6)
#define REG_FSC_BK3A_C7        (REG_FSC_BANK_BASE+0x3AC7)
#define REG_FSC_BK3A_C8        (REG_FSC_BANK_BASE+0x3AC8)
#define REG_FSC_BK3A_C9        (REG_FSC_BANK_BASE+0x3AC9)
#define REG_FSC_BK3A_CA        (REG_FSC_BANK_BASE+0x3ACA)
#define REG_FSC_BK3A_CB        (REG_FSC_BANK_BASE+0x3ACB)
#define REG_FSC_BK3A_CC        (REG_FSC_BANK_BASE+0x3ACC)
#define REG_FSC_BK3A_CD        (REG_FSC_BANK_BASE+0x3ACD)
#define REG_FSC_BK3A_CE        (REG_FSC_BANK_BASE+0x3ACE)
#define REG_FSC_BK3A_CF        (REG_FSC_BANK_BASE+0x3ACF)
#define REG_FSC_BK3A_D0        (REG_FSC_BANK_BASE+0x3AD0)
#define REG_FSC_BK3A_D1        (REG_FSC_BANK_BASE+0x3AD1)
#define REG_FSC_BK3A_D2        (REG_FSC_BANK_BASE+0x3AD2)
#define REG_FSC_BK3A_D3        (REG_FSC_BANK_BASE+0x3AD3)
#define REG_FSC_BK3A_D4        (REG_FSC_BANK_BASE+0x3AD4)
#define REG_FSC_BK3A_D5        (REG_FSC_BANK_BASE+0x3AD5)
#define REG_FSC_BK3A_D6        (REG_FSC_BANK_BASE+0x3AD6)
#define REG_FSC_BK3A_D7        (REG_FSC_BANK_BASE+0x3AD7)
#define REG_FSC_BK3A_D8        (REG_FSC_BANK_BASE+0x3AD8)
#define REG_FSC_BK3A_D9        (REG_FSC_BANK_BASE+0x3AD9)
#define REG_FSC_BK3A_DA        (REG_FSC_BANK_BASE+0x3ADA)
#define REG_FSC_BK3A_DB        (REG_FSC_BANK_BASE+0x3ADB)
#define REG_FSC_BK3A_DC        (REG_FSC_BANK_BASE+0x3ADC)
#define REG_FSC_BK3A_DD        (REG_FSC_BANK_BASE+0x3ADD)
#define REG_FSC_BK3A_DE        (REG_FSC_BANK_BASE+0x3ADE)
#define REG_FSC_BK3A_DF        (REG_FSC_BANK_BASE+0x3ADF)
#define REG_FSC_BK3A_E0        (REG_FSC_BANK_BASE+0x3AE0)
#define REG_FSC_BK3A_E1        (REG_FSC_BANK_BASE+0x3AE1)
#define REG_FSC_BK3A_E2        (REG_FSC_BANK_BASE+0x3AE2)
#define REG_FSC_BK3A_E3        (REG_FSC_BANK_BASE+0x3AE3)
#define REG_FSC_BK3A_E4        (REG_FSC_BANK_BASE+0x3AE4)
#define REG_FSC_BK3A_E5        (REG_FSC_BANK_BASE+0x3AE5)
#define REG_FSC_BK3A_E6        (REG_FSC_BANK_BASE+0x3AE6)
#define REG_FSC_BK3A_E7        (REG_FSC_BANK_BASE+0x3AE7)
#define REG_FSC_BK3A_E8        (REG_FSC_BANK_BASE+0x3AE8)
#define REG_FSC_BK3A_E9        (REG_FSC_BANK_BASE+0x3AE9)
#define REG_FSC_BK3A_EA        (REG_FSC_BANK_BASE+0x3AEA)
#define REG_FSC_BK3A_EB        (REG_FSC_BANK_BASE+0x3AEB)
#define REG_FSC_BK3A_EC        (REG_FSC_BANK_BASE+0x3AEC)
#define REG_FSC_BK3A_ED        (REG_FSC_BANK_BASE+0x3AED)
#define REG_FSC_BK3A_EE        (REG_FSC_BANK_BASE+0x3AEE)
#define REG_FSC_BK3A_EF        (REG_FSC_BANK_BASE+0x3AEF)
#define REG_FSC_BK3A_F0        (REG_FSC_BANK_BASE+0x3AF0)
#define REG_FSC_BK3A_F1        (REG_FSC_BANK_BASE+0x3AF1)
#define REG_FSC_BK3A_F2        (REG_FSC_BANK_BASE+0x3AF2)
#define REG_FSC_BK3A_F3        (REG_FSC_BANK_BASE+0x3AF3)
#define REG_FSC_BK3A_F4        (REG_FSC_BANK_BASE+0x3AF4)
#define REG_FSC_BK3A_F5        (REG_FSC_BANK_BASE+0x3AF5)
#define REG_FSC_BK3A_F6        (REG_FSC_BANK_BASE+0x3AF6)
#define REG_FSC_BK3A_F7        (REG_FSC_BANK_BASE+0x3AF7)
#define REG_FSC_BK3A_F8        (REG_FSC_BANK_BASE+0x3AF8)
#define REG_FSC_BK3A_F9        (REG_FSC_BANK_BASE+0x3AF9)
#define REG_FSC_BK3A_FA        (REG_FSC_BANK_BASE+0x3AFA)
#define REG_FSC_BK3A_FB        (REG_FSC_BANK_BASE+0x3AFB)
#define REG_FSC_BK3A_FC        (REG_FSC_BANK_BASE+0x3AFC)
#define REG_FSC_BK3A_FD        (REG_FSC_BANK_BASE+0x3AFD)
#define REG_FSC_BK3A_FE        (REG_FSC_BANK_BASE+0x3AFE)
#define REG_FSC_BK3A_FF        (REG_FSC_BANK_BASE+0x3AFF)

// === FSC BKC6
#define REG_FSC_BKC6_00        (REG_FSC_BANK_BASE+0x2000)
#define REG_FSC_BKC6_01        (REG_FSC_BANK_BASE+0x2001)
#define REG_FSC_BKC6_02        (REG_FSC_BANK_BASE+0x2002)
#define REG_FSC_BKC6_03        (REG_FSC_BANK_BASE+0x2003)
#define REG_FSC_BKC6_04        (REG_FSC_BANK_BASE+0x2004)
#define REG_FSC_BKC6_05        (REG_FSC_BANK_BASE+0x2005)
#define REG_FSC_BKC6_06        (REG_FSC_BANK_BASE+0x2006)
#define REG_FSC_BKC6_07        (REG_FSC_BANK_BASE+0x2007)
#define REG_FSC_BKC6_08        (REG_FSC_BANK_BASE+0x2008)
#define REG_FSC_BKC6_09        (REG_FSC_BANK_BASE+0x2009)
#define REG_FSC_BKC6_0A        (REG_FSC_BANK_BASE+0x200A)
#define REG_FSC_BKC6_0B        (REG_FSC_BANK_BASE+0x200B)
#define REG_FSC_BKC6_0C        (REG_FSC_BANK_BASE+0x200C)
#define REG_FSC_BKC6_0D        (REG_FSC_BANK_BASE+0x200D)
#define REG_FSC_BKC6_0E        (REG_FSC_BANK_BASE+0x200E)
#define REG_FSC_BKC6_0F        (REG_FSC_BANK_BASE+0x200F)
#define REG_FSC_BKC6_10        (REG_FSC_BANK_BASE+0x2010)
#define REG_FSC_BKC6_11        (REG_FSC_BANK_BASE+0x2011)
#define REG_FSC_BKC6_12        (REG_FSC_BANK_BASE+0x2012)
#define REG_FSC_BKC6_13        (REG_FSC_BANK_BASE+0x2013)
#define REG_FSC_BKC6_14        (REG_FSC_BANK_BASE+0x2014)
#define REG_FSC_BKC6_15        (REG_FSC_BANK_BASE+0x2015)
#define REG_FSC_BKC6_16        (REG_FSC_BANK_BASE+0x2016)
#define REG_FSC_BKC6_17        (REG_FSC_BANK_BASE+0x2017)
#define REG_FSC_BKC6_18        (REG_FSC_BANK_BASE+0x2018)
#define REG_FSC_BKC6_19        (REG_FSC_BANK_BASE+0x2019)
#define REG_FSC_BKC6_1A        (REG_FSC_BANK_BASE+0x201A)
#define REG_FSC_BKC6_1B        (REG_FSC_BANK_BASE+0x201B)
#define REG_FSC_BKC6_1C        (REG_FSC_BANK_BASE+0x201C)
#define REG_FSC_BKC6_1D        (REG_FSC_BANK_BASE+0x201D)
#define REG_FSC_BKC6_1E        (REG_FSC_BANK_BASE+0x201E)
#define REG_FSC_BKC6_1F        (REG_FSC_BANK_BASE+0x201F)
#define REG_FSC_BKC6_20        (REG_FSC_BANK_BASE+0x2020)
#define REG_FSC_BKC6_21        (REG_FSC_BANK_BASE+0x2021)
#define REG_FSC_BKC6_22        (REG_FSC_BANK_BASE+0x2022)
#define REG_FSC_BKC6_23        (REG_FSC_BANK_BASE+0x2023)
#define REG_FSC_BKC6_24        (REG_FSC_BANK_BASE+0x2024)
#define REG_FSC_BKC6_25        (REG_FSC_BANK_BASE+0x2025)
#define REG_FSC_BKC6_26        (REG_FSC_BANK_BASE+0x2026)
#define REG_FSC_BKC6_27        (REG_FSC_BANK_BASE+0x2027)
#define REG_FSC_BKC6_28        (REG_FSC_BANK_BASE+0x2028)
#define REG_FSC_BKC6_29        (REG_FSC_BANK_BASE+0x2029)
#define REG_FSC_BKC6_2A        (REG_FSC_BANK_BASE+0x202A)
#define REG_FSC_BKC6_2B        (REG_FSC_BANK_BASE+0x202B)
#define REG_FSC_BKC6_2C        (REG_FSC_BANK_BASE+0x202C)
#define REG_FSC_BKC6_2D        (REG_FSC_BANK_BASE+0x202D)
#define REG_FSC_BKC6_2E        (REG_FSC_BANK_BASE+0x202E)
#define REG_FSC_BKC6_2F        (REG_FSC_BANK_BASE+0x202F)
#define REG_FSC_BKC6_30        (REG_FSC_BANK_BASE+0x2030)
#define REG_FSC_BKC6_31        (REG_FSC_BANK_BASE+0x2031)
#define REG_FSC_BKC6_32        (REG_FSC_BANK_BASE+0x2032)
#define REG_FSC_BKC6_33        (REG_FSC_BANK_BASE+0x2033)
#define REG_FSC_BKC6_34        (REG_FSC_BANK_BASE+0x2034)
#define REG_FSC_BKC6_35        (REG_FSC_BANK_BASE+0x2035)
#define REG_FSC_BKC6_36        (REG_FSC_BANK_BASE+0x2036)
#define REG_FSC_BKC6_37        (REG_FSC_BANK_BASE+0x2037)
#define REG_FSC_BKC6_38        (REG_FSC_BANK_BASE+0x2038)
#define REG_FSC_BKC6_39        (REG_FSC_BANK_BASE+0x2039)
#define REG_FSC_BKC6_3A        (REG_FSC_BANK_BASE+0x203A)
#define REG_FSC_BKC6_3B        (REG_FSC_BANK_BASE+0x203B)
#define REG_FSC_BKC6_3C        (REG_FSC_BANK_BASE+0x203C)
#define REG_FSC_BKC6_3D        (REG_FSC_BANK_BASE+0x203D)
#define REG_FSC_BKC6_3E        (REG_FSC_BANK_BASE+0x203E)
#define REG_FSC_BKC6_3F        (REG_FSC_BANK_BASE+0x203F)
#define REG_FSC_BKC6_40        (REG_FSC_BANK_BASE+0x2040)
#define REG_FSC_BKC6_41        (REG_FSC_BANK_BASE+0x2041)
#define REG_FSC_BKC6_42        (REG_FSC_BANK_BASE+0x2042)
#define REG_FSC_BKC6_43        (REG_FSC_BANK_BASE+0x2043)
#define REG_FSC_BKC6_44        (REG_FSC_BANK_BASE+0x2044)
#define REG_FSC_BKC6_45        (REG_FSC_BANK_BASE+0x2045)
#define REG_FSC_BKC6_46        (REG_FSC_BANK_BASE+0x2046)
#define REG_FSC_BKC6_47        (REG_FSC_BANK_BASE+0x2047)
#define REG_FSC_BKC6_48        (REG_FSC_BANK_BASE+0x2048)
#define REG_FSC_BKC6_49        (REG_FSC_BANK_BASE+0x2049)
#define REG_FSC_BKC6_4A        (REG_FSC_BANK_BASE+0x204A)
#define REG_FSC_BKC6_4B        (REG_FSC_BANK_BASE+0x204B)
#define REG_FSC_BKC6_4C        (REG_FSC_BANK_BASE+0x204C)
#define REG_FSC_BKC6_4D        (REG_FSC_BANK_BASE+0x204D)
#define REG_FSC_BKC6_4E        (REG_FSC_BANK_BASE+0x204E)
#define REG_FSC_BKC6_4F        (REG_FSC_BANK_BASE+0x204F)
#define REG_FSC_BKC6_50        (REG_FSC_BANK_BASE+0x2050)
#define REG_FSC_BKC6_51        (REG_FSC_BANK_BASE+0x2051)
#define REG_FSC_BKC6_52        (REG_FSC_BANK_BASE+0x2052)
#define REG_FSC_BKC6_53        (REG_FSC_BANK_BASE+0x2053)
#define REG_FSC_BKC6_54        (REG_FSC_BANK_BASE+0x2054)
#define REG_FSC_BKC6_55        (REG_FSC_BANK_BASE+0x2055)
#define REG_FSC_BKC6_56        (REG_FSC_BANK_BASE+0x2056)
#define REG_FSC_BKC6_57        (REG_FSC_BANK_BASE+0x2057)
#define REG_FSC_BKC6_58        (REG_FSC_BANK_BASE+0x2058)
#define REG_FSC_BKC6_59        (REG_FSC_BANK_BASE+0x2059)
#define REG_FSC_BKC6_5A        (REG_FSC_BANK_BASE+0x205A)
#define REG_FSC_BKC6_5B        (REG_FSC_BANK_BASE+0x205B)
#define REG_FSC_BKC6_5C        (REG_FSC_BANK_BASE+0x205C)
#define REG_FSC_BKC6_5D        (REG_FSC_BANK_BASE+0x205D)
#define REG_FSC_BKC6_5E        (REG_FSC_BANK_BASE+0x205E)
#define REG_FSC_BKC6_5F        (REG_FSC_BANK_BASE+0x205F)
#define REG_FSC_BKC6_60        (REG_FSC_BANK_BASE+0x2060)
#define REG_FSC_BKC6_61        (REG_FSC_BANK_BASE+0x2061)
#define REG_FSC_BKC6_62        (REG_FSC_BANK_BASE+0x2062)
#define REG_FSC_BKC6_63        (REG_FSC_BANK_BASE+0x2063)
#define REG_FSC_BKC6_64        (REG_FSC_BANK_BASE+0x2064)
#define REG_FSC_BKC6_65        (REG_FSC_BANK_BASE+0x2065)
#define REG_FSC_BKC6_66        (REG_FSC_BANK_BASE+0x2066)
#define REG_FSC_BKC6_67        (REG_FSC_BANK_BASE+0x2067)
#define REG_FSC_BKC6_68        (REG_FSC_BANK_BASE+0x2068)
#define REG_FSC_BKC6_69        (REG_FSC_BANK_BASE+0x2069)
#define REG_FSC_BKC6_6A        (REG_FSC_BANK_BASE+0x206A)
#define REG_FSC_BKC6_6B        (REG_FSC_BANK_BASE+0x206B)
#define REG_FSC_BKC6_6C        (REG_FSC_BANK_BASE+0x206C)
#define REG_FSC_BKC6_6D        (REG_FSC_BANK_BASE+0x206D)
#define REG_FSC_BKC6_6E        (REG_FSC_BANK_BASE+0x206E)
#define REG_FSC_BKC6_6F        (REG_FSC_BANK_BASE+0x206F)
#define REG_FSC_BKC6_70        (REG_FSC_BANK_BASE+0x2070)
#define REG_FSC_BKC6_71        (REG_FSC_BANK_BASE+0x2071)
#define REG_FSC_BKC6_72        (REG_FSC_BANK_BASE+0x2072)
#define REG_FSC_BKC6_73        (REG_FSC_BANK_BASE+0x2073)
#define REG_FSC_BKC6_74        (REG_FSC_BANK_BASE+0x2074)
#define REG_FSC_BKC6_75        (REG_FSC_BANK_BASE+0x2075)
#define REG_FSC_BKC6_76        (REG_FSC_BANK_BASE+0x2076)
#define REG_FSC_BKC6_77        (REG_FSC_BANK_BASE+0x2077)
#define REG_FSC_BKC6_78        (REG_FSC_BANK_BASE+0x2078)
#define REG_FSC_BKC6_79        (REG_FSC_BANK_BASE+0x2079)
#define REG_FSC_BKC6_7A        (REG_FSC_BANK_BASE+0x207A)
#define REG_FSC_BKC6_7B        (REG_FSC_BANK_BASE+0x207B)
#define REG_FSC_BKC6_7C        (REG_FSC_BANK_BASE+0x207C)
#define REG_FSC_BKC6_7D        (REG_FSC_BANK_BASE+0x207D)
#define REG_FSC_BKC6_7E        (REG_FSC_BANK_BASE+0x207E)
#define REG_FSC_BKC6_7F        (REG_FSC_BANK_BASE+0x207F)
#define REG_FSC_BKC6_80        (REG_FSC_BANK_BASE+0x2080)
#define REG_FSC_BKC6_81        (REG_FSC_BANK_BASE+0x2081)
#define REG_FSC_BKC6_82        (REG_FSC_BANK_BASE+0x2082)
#define REG_FSC_BKC6_83        (REG_FSC_BANK_BASE+0x2083)
#define REG_FSC_BKC6_84        (REG_FSC_BANK_BASE+0x2084)
#define REG_FSC_BKC6_85        (REG_FSC_BANK_BASE+0x2085)
#define REG_FSC_BKC6_86        (REG_FSC_BANK_BASE+0x2086)
#define REG_FSC_BKC6_87        (REG_FSC_BANK_BASE+0x2087)
#define REG_FSC_BKC6_88        (REG_FSC_BANK_BASE+0x2088)
#define REG_FSC_BKC6_89        (REG_FSC_BANK_BASE+0x2089)
#define REG_FSC_BKC6_8A        (REG_FSC_BANK_BASE+0x208A)
#define REG_FSC_BKC6_8B        (REG_FSC_BANK_BASE+0x208B)
#define REG_FSC_BKC6_8C        (REG_FSC_BANK_BASE+0x208C)
#define REG_FSC_BKC6_8D        (REG_FSC_BANK_BASE+0x208D)
#define REG_FSC_BKC6_8E        (REG_FSC_BANK_BASE+0x208E)
#define REG_FSC_BKC6_8F        (REG_FSC_BANK_BASE+0x208F)
#define REG_FSC_BKC6_90        (REG_FSC_BANK_BASE+0x2090)
#define REG_FSC_BKC6_91        (REG_FSC_BANK_BASE+0x2091)
#define REG_FSC_BKC6_92        (REG_FSC_BANK_BASE+0x2092)
#define REG_FSC_BKC6_93        (REG_FSC_BANK_BASE+0x2093)
#define REG_FSC_BKC6_94        (REG_FSC_BANK_BASE+0x2094)
#define REG_FSC_BKC6_95        (REG_FSC_BANK_BASE+0x2095)
#define REG_FSC_BKC6_96        (REG_FSC_BANK_BASE+0x2096)
#define REG_FSC_BKC6_97        (REG_FSC_BANK_BASE+0x2097)
#define REG_FSC_BKC6_98        (REG_FSC_BANK_BASE+0x2098)
#define REG_FSC_BKC6_99        (REG_FSC_BANK_BASE+0x2099)
#define REG_FSC_BKC6_9A        (REG_FSC_BANK_BASE+0x209A)
#define REG_FSC_BKC6_9B        (REG_FSC_BANK_BASE+0x209B)
#define REG_FSC_BKC6_9C        (REG_FSC_BANK_BASE+0x209C)
#define REG_FSC_BKC6_9D        (REG_FSC_BANK_BASE+0x209D)
#define REG_FSC_BKC6_9E        (REG_FSC_BANK_BASE+0x209E)
#define REG_FSC_BKC6_9F        (REG_FSC_BANK_BASE+0x209F)
#define REG_FSC_BKC6_A0        (REG_FSC_BANK_BASE+0x20A0)
#define REG_FSC_BKC6_A1        (REG_FSC_BANK_BASE+0x20A1)
#define REG_FSC_BKC6_A2        (REG_FSC_BANK_BASE+0x20A2)
#define REG_FSC_BKC6_A3        (REG_FSC_BANK_BASE+0x20A3)
#define REG_FSC_BKC6_A4        (REG_FSC_BANK_BASE+0x20A4)
#define REG_FSC_BKC6_A5        (REG_FSC_BANK_BASE+0x20A5)
#define REG_FSC_BKC6_A6        (REG_FSC_BANK_BASE+0x20A6)
#define REG_FSC_BKC6_A7        (REG_FSC_BANK_BASE+0x20A7)
#define REG_FSC_BKC6_A8        (REG_FSC_BANK_BASE+0x20A8)
#define REG_FSC_BKC6_A9        (REG_FSC_BANK_BASE+0x20A9)
#define REG_FSC_BKC6_AA        (REG_FSC_BANK_BASE+0x20AA)
#define REG_FSC_BKC6_AB        (REG_FSC_BANK_BASE+0x20AB)
#define REG_FSC_BKC6_AC        (REG_FSC_BANK_BASE+0x20AC)
#define REG_FSC_BKC6_AD        (REG_FSC_BANK_BASE+0x20AD)
#define REG_FSC_BKC6_AE        (REG_FSC_BANK_BASE+0x20AE)
#define REG_FSC_BKC6_AF        (REG_FSC_BANK_BASE+0x20AF)
#define REG_FSC_BKC6_B0        (REG_FSC_BANK_BASE+0x20B0)
#define REG_FSC_BKC6_B1        (REG_FSC_BANK_BASE+0x20B1)
#define REG_FSC_BKC6_B2        (REG_FSC_BANK_BASE+0x20B2)
#define REG_FSC_BKC6_B3        (REG_FSC_BANK_BASE+0x20B3)
#define REG_FSC_BKC6_B4        (REG_FSC_BANK_BASE+0x20B4)
#define REG_FSC_BKC6_B5        (REG_FSC_BANK_BASE+0x20B5)
#define REG_FSC_BKC6_B6        (REG_FSC_BANK_BASE+0x20B6)
#define REG_FSC_BKC6_B7        (REG_FSC_BANK_BASE+0x20B7)
#define REG_FSC_BKC6_B8        (REG_FSC_BANK_BASE+0x20B8)
#define REG_FSC_BKC6_B9        (REG_FSC_BANK_BASE+0x20B9)
#define REG_FSC_BKC6_BA        (REG_FSC_BANK_BASE+0x20BA)
#define REG_FSC_BKC6_BB        (REG_FSC_BANK_BASE+0x20BB)
#define REG_FSC_BKC6_BC        (REG_FSC_BANK_BASE+0x20BC)
#define REG_FSC_BKC6_BD        (REG_FSC_BANK_BASE+0x20BD)
#define REG_FSC_BKC6_BE        (REG_FSC_BANK_BASE+0x20BE)
#define REG_FSC_BKC6_BF        (REG_FSC_BANK_BASE+0x20BF)
#define REG_FSC_BKC6_C0        (REG_FSC_BANK_BASE+0x20C0)
#define REG_FSC_BKC6_C1        (REG_FSC_BANK_BASE+0x20C1)
#define REG_FSC_BKC6_C2        (REG_FSC_BANK_BASE+0x20C2)
#define REG_FSC_BKC6_C3        (REG_FSC_BANK_BASE+0x20C3)
#define REG_FSC_BKC6_C4        (REG_FSC_BANK_BASE+0x20C4)
#define REG_FSC_BKC6_C5        (REG_FSC_BANK_BASE+0x20C5)
#define REG_FSC_BKC6_C6        (REG_FSC_BANK_BASE+0x20C6)
#define REG_FSC_BKC6_C7        (REG_FSC_BANK_BASE+0x20C7)
#define REG_FSC_BKC6_C8        (REG_FSC_BANK_BASE+0x20C8)
#define REG_FSC_BKC6_C9        (REG_FSC_BANK_BASE+0x20C9)
#define REG_FSC_BKC6_CA        (REG_FSC_BANK_BASE+0x20CA)
#define REG_FSC_BKC6_CB        (REG_FSC_BANK_BASE+0x20CB)
#define REG_FSC_BKC6_CC        (REG_FSC_BANK_BASE+0x20CC)
#define REG_FSC_BKC6_CD        (REG_FSC_BANK_BASE+0x20CD)
#define REG_FSC_BKC6_CE        (REG_FSC_BANK_BASE+0x20CE)
#define REG_FSC_BKC6_CF        (REG_FSC_BANK_BASE+0x20CF)
#define REG_FSC_BKC6_D0        (REG_FSC_BANK_BASE+0x20D0)
#define REG_FSC_BKC6_D1        (REG_FSC_BANK_BASE+0x20D1)
#define REG_FSC_BKC6_D2        (REG_FSC_BANK_BASE+0x20D2)
#define REG_FSC_BKC6_D3        (REG_FSC_BANK_BASE+0x20D3)
#define REG_FSC_BKC6_D4        (REG_FSC_BANK_BASE+0x20D4)
#define REG_FSC_BKC6_D5        (REG_FSC_BANK_BASE+0x20D5)
#define REG_FSC_BKC6_D6        (REG_FSC_BANK_BASE+0x20D6)
#define REG_FSC_BKC6_D7        (REG_FSC_BANK_BASE+0x20D7)
#define REG_FSC_BKC6_D8        (REG_FSC_BANK_BASE+0x20D8)
#define REG_FSC_BKC6_D9        (REG_FSC_BANK_BASE+0x20D9)
#define REG_FSC_BKC6_DA        (REG_FSC_BANK_BASE+0x20DA)
#define REG_FSC_BKC6_DB        (REG_FSC_BANK_BASE+0x20DB)
#define REG_FSC_BKC6_DC        (REG_FSC_BANK_BASE+0x20DC)
#define REG_FSC_BKC6_DD        (REG_FSC_BANK_BASE+0x20DD)
#define REG_FSC_BKC6_DE        (REG_FSC_BANK_BASE+0x20DE)
#define REG_FSC_BKC6_DF        (REG_FSC_BANK_BASE+0x20DF)
#define REG_FSC_BKC6_E0        (REG_FSC_BANK_BASE+0x20E0)
#define REG_FSC_BKC6_E1        (REG_FSC_BANK_BASE+0x20E1)
#define REG_FSC_BKC6_E2        (REG_FSC_BANK_BASE+0x20E2)
#define REG_FSC_BKC6_E3        (REG_FSC_BANK_BASE+0x20E3)
#define REG_FSC_BKC6_E4        (REG_FSC_BANK_BASE+0x20E4)
#define REG_FSC_BKC6_E5        (REG_FSC_BANK_BASE+0x20E5)
#define REG_FSC_BKC6_E6        (REG_FSC_BANK_BASE+0x20E6)
#define REG_FSC_BKC6_E7        (REG_FSC_BANK_BASE+0x20E7)
#define REG_FSC_BKC6_E8        (REG_FSC_BANK_BASE+0x20E8)
#define REG_FSC_BKC6_E9        (REG_FSC_BANK_BASE+0x20E9)
#define REG_FSC_BKC6_EA        (REG_FSC_BANK_BASE+0x20EA)
#define REG_FSC_BKC6_EB        (REG_FSC_BANK_BASE+0x20EB)
#define REG_FSC_BKC6_EC        (REG_FSC_BANK_BASE+0x20EC)
#define REG_FSC_BKC6_ED        (REG_FSC_BANK_BASE+0x20ED)
#define REG_FSC_BKC6_EE        (REG_FSC_BANK_BASE+0x20EE)
#define REG_FSC_BKC6_EF        (REG_FSC_BANK_BASE+0x20EF)
#define REG_FSC_BKC6_F0        (REG_FSC_BANK_BASE+0x20F0)
#define REG_FSC_BKC6_F1        (REG_FSC_BANK_BASE+0x20F1)
#define REG_FSC_BKC6_F2        (REG_FSC_BANK_BASE+0x20F2)
#define REG_FSC_BKC6_F3        (REG_FSC_BANK_BASE+0x20F3)
#define REG_FSC_BKC6_F4        (REG_FSC_BANK_BASE+0x20F4)
#define REG_FSC_BKC6_F5        (REG_FSC_BANK_BASE+0x20F5)
#define REG_FSC_BKC6_F6        (REG_FSC_BANK_BASE+0x20F6)
#define REG_FSC_BKC6_F7        (REG_FSC_BANK_BASE+0x20F7)
#define REG_FSC_BKC6_F8        (REG_FSC_BANK_BASE+0x20F8)
#define REG_FSC_BKC6_F9        (REG_FSC_BANK_BASE+0x20F9)
#define REG_FSC_BKC6_FA        (REG_FSC_BANK_BASE+0x20FA)
#define REG_FSC_BKC6_FB        (REG_FSC_BANK_BASE+0x20FB)
#define REG_FSC_BKC6_FC        (REG_FSC_BANK_BASE+0x20FC)
#define REG_FSC_BKC6_FD        (REG_FSC_BANK_BASE+0x20FD)
#define REG_FSC_BKC6_FE        (REG_FSC_BANK_BASE+0x20FE)
#define REG_FSC_BKC6_FF        (REG_FSC_BANK_BASE+0x20FF)

#endif

