//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

#ifndef _HWREG_HDMI_H_
#define _HWREG_HDMI_H_

// PM_SCDC
#define REG_PM_SCDC_P0_OFFSET           0x0UL
#define REG_PM_SCDC_P1_OFFSET           0x100UL
#define REG_PM_SCDC_P2_OFFSET           0x200UL
#define REG_PM_SCDC_P3_OFFSET           0x300UL

// DVI_PHY_PM
#define REG_DVI_PHY2P1_PM_P0_OFFSET     0x0UL
#define REG_DVI_PHY2P1_PM_P1_OFFSET     0x100UL
#define REG_DVI_PHY2P1_PM_P2_OFFSET     0x200UL
#define REG_DVI_PHY2P1_PM_P3_OFFSET     0x300UL

// DVI_PHY2P1
#define REG_DVI_PHY2P1_P0_OFFSET        0x0UL
#define REG_DVI_PHY2P1_P1_OFFSET        0x1000UL
#define REG_DVI_PHY2P1_P2_OFFSET        0x2000UL
#define REG_DVI_PHY2P1_P3_OFFSET        0x10000UL

// DVI_DTOP_DUAL
#define REG_DVI_DTOP_P0_OFFSET          0x0UL
#define REG_DVI_DTOP_P1_OFFSET          0x400UL
#define REG_DVI_DTOP_P2_OFFSET          0x800UL
#define REG_DVI_DTOP_P3_OFFSET          0xC00UL

// HDMI_DUAL
#define REG_HDMI_DUAL_P0_OFFSET         0x0UL

// HDMIRX_VE
#define REG_HDMIRX_VE_P0_OFFSET         0x0UL
#define REG_HDMIRX_VE_P1_OFFSET         0x100UL
#define REG_HDMIRX_VE_P2_OFFSET         0x200UL
#define REG_HDMIRX_VE_P3_OFFSET         0x300UL

//=============================================================
// DVI DTOP
#define REG_DVI_DTOP_29_L               (REG_DVI_DTOP_BASE + 0x52)
#define REG_DVI_DTOP_29_H               (REG_DVI_DTOP_BASE + 0x53)
#define REG_DVI_DTOP_2A_L               (REG_DVI_DTOP_BASE + 0x54)
#define REG_DVI_DTOP_2A_H               (REG_DVI_DTOP_BASE + 0x55)

//=============================================================
// DVI ATOP
#define REG_DVI_ATOP_61_L               (REG_DVI_ATOP_BASE + 0xC2)
#define REG_DVI_ATOP_61_H               (REG_DVI_ATOP_BASE + 0xC3)
#define REG_DVI_ATOP_6A_L               (REG_DVI_ATOP_BASE + 0xD4)
#define REG_DVI_ATOP_6A_H               (REG_DVI_ATOP_BASE + 0xD5)

//=============================================================

// CHIP
#define REG_CHIP_05_L                (REG_CHIP_BASE + 0x0A)
#define REG_CHIP_19_L                (REG_CHIP_BASE + 0x38)

//CHIP_GPIO1
#define REG_CHIP_GPIO1_10_L          (REG_CHIP_GPIO1_BASE + 0x20)


//CHIPTOP GPIO_FUNC_MUX
#define REG_CHIPTOP_GPIO_FUNC_MUX_3E_L  (REG_CHIPTOP_GPIO_FUNC_MUX_BASE + 0x7C)

//CHIPTOP GPIO_AUDIO
#define REG_CHIPTOP_GPIO_AUDIO_78_L  (REG_CHIPTOP_GPIO_AUDIO_BASE + 0xF0)


//=============================================================
// DVI_DTOP_DUAL_P0
#define REG_DVI_DTOP_DUAL_P0_00_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x00)
#define REG_DVI_DTOP_DUAL_P0_00_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x01)
#define REG_DVI_DTOP_DUAL_P0_01_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x02)
#define REG_DVI_DTOP_DUAL_P0_01_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x03)
#define REG_DVI_DTOP_DUAL_P0_02_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x04)
#define REG_DVI_DTOP_DUAL_P0_02_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x05)
#define REG_DVI_DTOP_DUAL_P0_03_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x06)
#define REG_DVI_DTOP_DUAL_P0_03_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x07)
#define REG_DVI_DTOP_DUAL_P0_04_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x08)
#define REG_DVI_DTOP_DUAL_P0_04_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x09)
#define REG_DVI_DTOP_DUAL_P0_05_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x0A)
#define REG_DVI_DTOP_DUAL_P0_05_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x0B)
#define REG_DVI_DTOP_DUAL_P0_06_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x0C)
#define REG_DVI_DTOP_DUAL_P0_06_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x0D)
#define REG_DVI_DTOP_DUAL_P0_07_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x0E)
#define REG_DVI_DTOP_DUAL_P0_07_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x0F)
#define REG_DVI_DTOP_DUAL_P0_08_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x10)
#define REG_DVI_DTOP_DUAL_P0_08_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x11)
#define REG_DVI_DTOP_DUAL_P0_09_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x12)
#define REG_DVI_DTOP_DUAL_P0_09_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x13)
#define REG_DVI_DTOP_DUAL_P0_0A_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x14)
#define REG_DVI_DTOP_DUAL_P0_0A_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x15)
#define REG_DVI_DTOP_DUAL_P0_0B_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x16)
#define REG_DVI_DTOP_DUAL_P0_0B_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x17)
#define REG_DVI_DTOP_DUAL_P0_0C_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x18)
#define REG_DVI_DTOP_DUAL_P0_0C_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x19)
#define REG_DVI_DTOP_DUAL_P0_0D_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x1A)
#define REG_DVI_DTOP_DUAL_P0_0D_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x1B)
#define REG_DVI_DTOP_DUAL_P0_0E_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x1C)
#define REG_DVI_DTOP_DUAL_P0_0E_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x1D)
#define REG_DVI_DTOP_DUAL_P0_0F_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x1E)
#define REG_DVI_DTOP_DUAL_P0_0F_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x1F)
#define REG_DVI_DTOP_DUAL_P0_10_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x20)
#define REG_DVI_DTOP_DUAL_P0_10_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x21)
#define REG_DVI_DTOP_DUAL_P0_11_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x22)
#define REG_DVI_DTOP_DUAL_P0_11_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x23)
#define REG_DVI_DTOP_DUAL_P0_12_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x24)
#define REG_DVI_DTOP_DUAL_P0_12_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x25)
#define REG_DVI_DTOP_DUAL_P0_13_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x26)
#define REG_DVI_DTOP_DUAL_P0_13_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x27)
#define REG_DVI_DTOP_DUAL_P0_14_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x28)
#define REG_DVI_DTOP_DUAL_P0_14_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x29)
#define REG_DVI_DTOP_DUAL_P0_15_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x2A)
#define REG_DVI_DTOP_DUAL_P0_15_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x2B)
#define REG_DVI_DTOP_DUAL_P0_16_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x2C)
#define REG_DVI_DTOP_DUAL_P0_16_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x2D)
#define REG_DVI_DTOP_DUAL_P0_17_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x2E)
#define REG_DVI_DTOP_DUAL_P0_17_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x2F)
#define REG_DVI_DTOP_DUAL_P0_18_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x30)
#define REG_DVI_DTOP_DUAL_P0_18_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x31)
#define REG_DVI_DTOP_DUAL_P0_19_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x32)
#define REG_DVI_DTOP_DUAL_P0_19_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x33)
#define REG_DVI_DTOP_DUAL_P0_1A_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x34)
#define REG_DVI_DTOP_DUAL_P0_1A_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x35)
#define REG_DVI_DTOP_DUAL_P0_1B_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x36)
#define REG_DVI_DTOP_DUAL_P0_1B_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x37)
#define REG_DVI_DTOP_DUAL_P0_1C_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x38)
#define REG_DVI_DTOP_DUAL_P0_1C_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x39)
#define REG_DVI_DTOP_DUAL_P0_1D_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x3A)
#define REG_DVI_DTOP_DUAL_P0_1D_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x3B)
#define REG_DVI_DTOP_DUAL_P0_1E_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x3C)
#define REG_DVI_DTOP_DUAL_P0_1E_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x3D)
#define REG_DVI_DTOP_DUAL_P0_1F_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x3E)
#define REG_DVI_DTOP_DUAL_P0_1F_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x3F)
#define REG_DVI_DTOP_DUAL_P0_20_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x40)
#define REG_DVI_DTOP_DUAL_P0_20_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x41)
#define REG_DVI_DTOP_DUAL_P0_21_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x42)
#define REG_DVI_DTOP_DUAL_P0_21_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x43)
#define REG_DVI_DTOP_DUAL_P0_22_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x44)
#define REG_DVI_DTOP_DUAL_P0_22_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x45)
#define REG_DVI_DTOP_DUAL_P0_23_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x46)
#define REG_DVI_DTOP_DUAL_P0_23_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x47)
#define REG_DVI_DTOP_DUAL_P0_24_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x48)
#define REG_DVI_DTOP_DUAL_P0_24_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x49)
#define REG_DVI_DTOP_DUAL_P0_25_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x4A)
#define REG_DVI_DTOP_DUAL_P0_25_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x4B)
#define REG_DVI_DTOP_DUAL_P0_26_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x4C)
#define REG_DVI_DTOP_DUAL_P0_26_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x4D)
#define REG_DVI_DTOP_DUAL_P0_27_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x4E)
#define REG_DVI_DTOP_DUAL_P0_27_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x4F)
#define REG_DVI_DTOP_DUAL_P0_28_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x50)
#define REG_DVI_DTOP_DUAL_P0_28_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x51)
#define REG_DVI_DTOP_DUAL_P0_29_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x52)
#define REG_DVI_DTOP_DUAL_P0_29_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x53)
#define REG_DVI_DTOP_DUAL_P0_2A_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x54)
#define REG_DVI_DTOP_DUAL_P0_2A_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x55)
#define REG_DVI_DTOP_DUAL_P0_2B_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x56)
#define REG_DVI_DTOP_DUAL_P0_2B_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x57)
#define REG_DVI_DTOP_DUAL_P0_2C_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x58)
#define REG_DVI_DTOP_DUAL_P0_2C_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x59)
#define REG_DVI_DTOP_DUAL_P0_2D_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x5A)
#define REG_DVI_DTOP_DUAL_P0_2D_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x5B)
#define REG_DVI_DTOP_DUAL_P0_2E_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x5C)
#define REG_DVI_DTOP_DUAL_P0_2E_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x5D)
#define REG_DVI_DTOP_DUAL_P0_2F_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x5E)
#define REG_DVI_DTOP_DUAL_P0_2F_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x5F)
#define REG_DVI_DTOP_DUAL_P0_30_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x60)
#define REG_DVI_DTOP_DUAL_P0_30_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x61)
#define REG_DVI_DTOP_DUAL_P0_31_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x62)
#define REG_DVI_DTOP_DUAL_P0_31_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x63)
#define REG_DVI_DTOP_DUAL_P0_32_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x64)
#define REG_DVI_DTOP_DUAL_P0_32_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x65)
#define REG_DVI_DTOP_DUAL_P0_33_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x66)
#define REG_DVI_DTOP_DUAL_P0_33_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x67)
#define REG_DVI_DTOP_DUAL_P0_34_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x68)
#define REG_DVI_DTOP_DUAL_P0_34_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x69)
#define REG_DVI_DTOP_DUAL_P0_35_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x6A)
#define REG_DVI_DTOP_DUAL_P0_35_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x6B)
#define REG_DVI_DTOP_DUAL_P0_36_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x6C)
#define REG_DVI_DTOP_DUAL_P0_36_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x6D)
#define REG_DVI_DTOP_DUAL_P0_37_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x6E)
#define REG_DVI_DTOP_DUAL_P0_37_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x6F)
#define REG_DVI_DTOP_DUAL_P0_38_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x70)
#define REG_DVI_DTOP_DUAL_P0_38_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x71)
#define REG_DVI_DTOP_DUAL_P0_39_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x72)
#define REG_DVI_DTOP_DUAL_P0_39_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x73)
#define REG_DVI_DTOP_DUAL_P0_3A_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x74)
#define REG_DVI_DTOP_DUAL_P0_3A_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x75)
#define REG_DVI_DTOP_DUAL_P0_3B_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x76)
#define REG_DVI_DTOP_DUAL_P0_3B_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x77)
#define REG_DVI_DTOP_DUAL_P0_3C_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x78)
#define REG_DVI_DTOP_DUAL_P0_3C_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x79)
#define REG_DVI_DTOP_DUAL_P0_3D_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x7A)
#define REG_DVI_DTOP_DUAL_P0_3D_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x7B)
#define REG_DVI_DTOP_DUAL_P0_3E_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x7C)
#define REG_DVI_DTOP_DUAL_P0_3E_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x7D)
#define REG_DVI_DTOP_DUAL_P0_3F_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x7E)
#define REG_DVI_DTOP_DUAL_P0_3F_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x7F)
#define REG_DVI_DTOP_DUAL_P0_40_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x80)
#define REG_DVI_DTOP_DUAL_P0_40_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x81)
#define REG_DVI_DTOP_DUAL_P0_41_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x82)
#define REG_DVI_DTOP_DUAL_P0_41_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x83)
#define REG_DVI_DTOP_DUAL_P0_42_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x84)
#define REG_DVI_DTOP_DUAL_P0_42_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x85)
#define REG_DVI_DTOP_DUAL_P0_43_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x86)
#define REG_DVI_DTOP_DUAL_P0_43_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x87)
#define REG_DVI_DTOP_DUAL_P0_44_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x88)
#define REG_DVI_DTOP_DUAL_P0_44_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x89)
#define REG_DVI_DTOP_DUAL_P0_45_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x8A)
#define REG_DVI_DTOP_DUAL_P0_45_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x8B)
#define REG_DVI_DTOP_DUAL_P0_46_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x8C)
#define REG_DVI_DTOP_DUAL_P0_46_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x8D)
#define REG_DVI_DTOP_DUAL_P0_47_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x8E)
#define REG_DVI_DTOP_DUAL_P0_47_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x8F)
#define REG_DVI_DTOP_DUAL_P0_48_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x90)
#define REG_DVI_DTOP_DUAL_P0_48_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x91)
#define REG_DVI_DTOP_DUAL_P0_49_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x92)
#define REG_DVI_DTOP_DUAL_P0_49_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x93)
#define REG_DVI_DTOP_DUAL_P0_4A_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x94)
#define REG_DVI_DTOP_DUAL_P0_4A_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x95)
#define REG_DVI_DTOP_DUAL_P0_4B_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x96)
#define REG_DVI_DTOP_DUAL_P0_4B_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x97)
#define REG_DVI_DTOP_DUAL_P0_4C_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x98)
#define REG_DVI_DTOP_DUAL_P0_4C_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x99)
#define REG_DVI_DTOP_DUAL_P0_4D_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x9A)
#define REG_DVI_DTOP_DUAL_P0_4D_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x9B)
#define REG_DVI_DTOP_DUAL_P0_4E_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x9C)
#define REG_DVI_DTOP_DUAL_P0_4E_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x9D)
#define REG_DVI_DTOP_DUAL_P0_4F_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0x9E)
#define REG_DVI_DTOP_DUAL_P0_4F_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0x9F)
#define REG_DVI_DTOP_DUAL_P0_50_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xA0)
#define REG_DVI_DTOP_DUAL_P0_50_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xA1)
#define REG_DVI_DTOP_DUAL_P0_51_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xA2)
#define REG_DVI_DTOP_DUAL_P0_51_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xA3)
#define REG_DVI_DTOP_DUAL_P0_52_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xA4)
#define REG_DVI_DTOP_DUAL_P0_52_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xA5)
#define REG_DVI_DTOP_DUAL_P0_53_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xA6)
#define REG_DVI_DTOP_DUAL_P0_53_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xA7)
#define REG_DVI_DTOP_DUAL_P0_54_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xA8)
#define REG_DVI_DTOP_DUAL_P0_54_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xA9)
#define REG_DVI_DTOP_DUAL_P0_55_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xAA)
#define REG_DVI_DTOP_DUAL_P0_55_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xAB)
#define REG_DVI_DTOP_DUAL_P0_56_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xAC)
#define REG_DVI_DTOP_DUAL_P0_56_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xAD)
#define REG_DVI_DTOP_DUAL_P0_57_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xAE)
#define REG_DVI_DTOP_DUAL_P0_57_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xAF)
#define REG_DVI_DTOP_DUAL_P0_58_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xB0)
#define REG_DVI_DTOP_DUAL_P0_58_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xB1)
#define REG_DVI_DTOP_DUAL_P0_59_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xB2)
#define REG_DVI_DTOP_DUAL_P0_59_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xB3)
#define REG_DVI_DTOP_DUAL_P0_5A_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xB4)
#define REG_DVI_DTOP_DUAL_P0_5A_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xB5)
#define REG_DVI_DTOP_DUAL_P0_5B_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xB6)
#define REG_DVI_DTOP_DUAL_P0_5B_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xB7)
#define REG_DVI_DTOP_DUAL_P0_5C_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xB8)
#define REG_DVI_DTOP_DUAL_P0_5C_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xB9)
#define REG_DVI_DTOP_DUAL_P0_5D_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xBA)
#define REG_DVI_DTOP_DUAL_P0_5D_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xBB)
#define REG_DVI_DTOP_DUAL_P0_5E_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xBC)
#define REG_DVI_DTOP_DUAL_P0_5E_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xBD)
#define REG_DVI_DTOP_DUAL_P0_5F_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xBE)
#define REG_DVI_DTOP_DUAL_P0_5F_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xBF)
#define REG_DVI_DTOP_DUAL_P0_60_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xC0)
#define REG_DVI_DTOP_DUAL_P0_60_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xC1)
#define REG_DVI_DTOP_DUAL_P0_61_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xC2)
#define REG_DVI_DTOP_DUAL_P0_61_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xC3)
#define REG_DVI_DTOP_DUAL_P0_62_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xC4)
#define REG_DVI_DTOP_DUAL_P0_62_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xC5)
#define REG_DVI_DTOP_DUAL_P0_63_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xC6)
#define REG_DVI_DTOP_DUAL_P0_63_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xC7)
#define REG_DVI_DTOP_DUAL_P0_64_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xC8)
#define REG_DVI_DTOP_DUAL_P0_64_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xC9)
#define REG_DVI_DTOP_DUAL_P0_65_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xCA)
#define REG_DVI_DTOP_DUAL_P0_65_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xCB)
#define REG_DVI_DTOP_DUAL_P0_66_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xCC)
#define REG_DVI_DTOP_DUAL_P0_66_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xCD)
#define REG_DVI_DTOP_DUAL_P0_67_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xCE)
#define REG_DVI_DTOP_DUAL_P0_67_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xCF)
#define REG_DVI_DTOP_DUAL_P0_68_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xD0)
#define REG_DVI_DTOP_DUAL_P0_68_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xD1)
#define REG_DVI_DTOP_DUAL_P0_69_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xD2)
#define REG_DVI_DTOP_DUAL_P0_69_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xD3)
#define REG_DVI_DTOP_DUAL_P0_6A_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xD4)
#define REG_DVI_DTOP_DUAL_P0_6A_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xD5)
#define REG_DVI_DTOP_DUAL_P0_6B_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xD6)
#define REG_DVI_DTOP_DUAL_P0_6B_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xD7)
#define REG_DVI_DTOP_DUAL_P0_6C_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xD8)
#define REG_DVI_DTOP_DUAL_P0_6C_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xD9)
#define REG_DVI_DTOP_DUAL_P0_6D_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xDA)
#define REG_DVI_DTOP_DUAL_P0_6D_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xDB)
#define REG_DVI_DTOP_DUAL_P0_6E_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xDC)
#define REG_DVI_DTOP_DUAL_P0_6E_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xDD)
#define REG_DVI_DTOP_DUAL_P0_6F_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xDE)
#define REG_DVI_DTOP_DUAL_P0_6F_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xDF)
#define REG_DVI_DTOP_DUAL_P0_70_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xE0)
#define REG_DVI_DTOP_DUAL_P0_70_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xE1)
#define REG_DVI_DTOP_DUAL_P0_71_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xE2)
#define REG_DVI_DTOP_DUAL_P0_71_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xE3)
#define REG_DVI_DTOP_DUAL_P0_72_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xE4)
#define REG_DVI_DTOP_DUAL_P0_72_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xE5)
#define REG_DVI_DTOP_DUAL_P0_73_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xE6)
#define REG_DVI_DTOP_DUAL_P0_73_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xE7)
#define REG_DVI_DTOP_DUAL_P0_74_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xE8)
#define REG_DVI_DTOP_DUAL_P0_74_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xE9)
#define REG_DVI_DTOP_DUAL_P0_75_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xEA)
#define REG_DVI_DTOP_DUAL_P0_75_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xEB)
#define REG_DVI_DTOP_DUAL_P0_76_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xEC)
#define REG_DVI_DTOP_DUAL_P0_76_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xED)
#define REG_DVI_DTOP_DUAL_P0_77_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xEE)
#define REG_DVI_DTOP_DUAL_P0_77_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xEF)
#define REG_DVI_DTOP_DUAL_P0_78_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xF0)
#define REG_DVI_DTOP_DUAL_P0_78_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xF1)
#define REG_DVI_DTOP_DUAL_P0_79_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xF2)
#define REG_DVI_DTOP_DUAL_P0_79_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xF3)
#define REG_DVI_DTOP_DUAL_P0_7A_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xF4)
#define REG_DVI_DTOP_DUAL_P0_7A_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xF5)
#define REG_DVI_DTOP_DUAL_P0_7B_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xF6)
#define REG_DVI_DTOP_DUAL_P0_7B_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xF7)
#define REG_DVI_DTOP_DUAL_P0_7C_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xF8)
#define REG_DVI_DTOP_DUAL_P0_7C_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xF9)
#define REG_DVI_DTOP_DUAL_P0_7D_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xFA)
#define REG_DVI_DTOP_DUAL_P0_7D_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xFB)
#define REG_DVI_DTOP_DUAL_P0_7E_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xFC)
#define REG_DVI_DTOP_DUAL_P0_7E_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xFD)
#define REG_DVI_DTOP_DUAL_P0_7F_L       (REG_DVI_DTOP_DUAL_P0_BASE + 0xFE)
#define REG_DVI_DTOP_DUAL_P0_7F_H       (REG_DVI_DTOP_DUAL_P0_BASE + 0xFF)

//=============================================================
// DVI_RSV_DUAL_P0
#define REG_DVI_RSV_DUAL_P0_00_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x00)
#define REG_DVI_RSV_DUAL_P0_00_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x01)
#define REG_DVI_RSV_DUAL_P0_01_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x02)
#define REG_DVI_RSV_DUAL_P0_01_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x03)
#define REG_DVI_RSV_DUAL_P0_02_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x04)
#define REG_DVI_RSV_DUAL_P0_02_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x05)
#define REG_DVI_RSV_DUAL_P0_03_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x06)
#define REG_DVI_RSV_DUAL_P0_03_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x07)
#define REG_DVI_RSV_DUAL_P0_04_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x08)
#define REG_DVI_RSV_DUAL_P0_04_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x09)
#define REG_DVI_RSV_DUAL_P0_05_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x0A)
#define REG_DVI_RSV_DUAL_P0_05_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x0B)
#define REG_DVI_RSV_DUAL_P0_06_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x0C)
#define REG_DVI_RSV_DUAL_P0_06_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x0D)
#define REG_DVI_RSV_DUAL_P0_07_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x0E)
#define REG_DVI_RSV_DUAL_P0_07_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x0F)
#define REG_DVI_RSV_DUAL_P0_08_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x10)
#define REG_DVI_RSV_DUAL_P0_08_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x11)
#define REG_DVI_RSV_DUAL_P0_09_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x12)
#define REG_DVI_RSV_DUAL_P0_09_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x13)
#define REG_DVI_RSV_DUAL_P0_0A_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x14)
#define REG_DVI_RSV_DUAL_P0_0A_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x15)
#define REG_DVI_RSV_DUAL_P0_0B_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x16)
#define REG_DVI_RSV_DUAL_P0_0B_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x17)
#define REG_DVI_RSV_DUAL_P0_0C_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x18)
#define REG_DVI_RSV_DUAL_P0_0C_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x19)
#define REG_DVI_RSV_DUAL_P0_0D_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x1A)
#define REG_DVI_RSV_DUAL_P0_0D_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x1B)
#define REG_DVI_RSV_DUAL_P0_0E_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x1C)
#define REG_DVI_RSV_DUAL_P0_0E_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x1D)
#define REG_DVI_RSV_DUAL_P0_0F_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x1E)
#define REG_DVI_RSV_DUAL_P0_0F_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x1F)
#define REG_DVI_RSV_DUAL_P0_10_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x20)
#define REG_DVI_RSV_DUAL_P0_10_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x21)
#define REG_DVI_RSV_DUAL_P0_11_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x22)
#define REG_DVI_RSV_DUAL_P0_11_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x23)
#define REG_DVI_RSV_DUAL_P0_12_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x24)
#define REG_DVI_RSV_DUAL_P0_12_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x25)
#define REG_DVI_RSV_DUAL_P0_13_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x26)
#define REG_DVI_RSV_DUAL_P0_13_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x27)
#define REG_DVI_RSV_DUAL_P0_14_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x28)
#define REG_DVI_RSV_DUAL_P0_14_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x29)
#define REG_DVI_RSV_DUAL_P0_15_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x2A)
#define REG_DVI_RSV_DUAL_P0_15_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x2B)
#define REG_DVI_RSV_DUAL_P0_16_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x2C)
#define REG_DVI_RSV_DUAL_P0_16_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x2D)
#define REG_DVI_RSV_DUAL_P0_17_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x2E)
#define REG_DVI_RSV_DUAL_P0_17_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x2F)
#define REG_DVI_RSV_DUAL_P0_18_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x30)
#define REG_DVI_RSV_DUAL_P0_18_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x31)
#define REG_DVI_RSV_DUAL_P0_19_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x32)
#define REG_DVI_RSV_DUAL_P0_19_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x33)
#define REG_DVI_RSV_DUAL_P0_1A_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x34)
#define REG_DVI_RSV_DUAL_P0_1A_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x35)
#define REG_DVI_RSV_DUAL_P0_1B_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x36)
#define REG_DVI_RSV_DUAL_P0_1B_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x37)
#define REG_DVI_RSV_DUAL_P0_1C_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x38)
#define REG_DVI_RSV_DUAL_P0_1C_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x39)
#define REG_DVI_RSV_DUAL_P0_1D_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x3A)
#define REG_DVI_RSV_DUAL_P0_1D_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x3B)
#define REG_DVI_RSV_DUAL_P0_1E_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x3C)
#define REG_DVI_RSV_DUAL_P0_1E_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x3D)
#define REG_DVI_RSV_DUAL_P0_1F_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x3E)
#define REG_DVI_RSV_DUAL_P0_1F_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x3F)
#define REG_DVI_RSV_DUAL_P0_20_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x40)
#define REG_DVI_RSV_DUAL_P0_20_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x41)
#define REG_DVI_RSV_DUAL_P0_21_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x42)
#define REG_DVI_RSV_DUAL_P0_21_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x43)
#define REG_DVI_RSV_DUAL_P0_22_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x44)
#define REG_DVI_RSV_DUAL_P0_22_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x45)
#define REG_DVI_RSV_DUAL_P0_23_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x46)
#define REG_DVI_RSV_DUAL_P0_23_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x47)
#define REG_DVI_RSV_DUAL_P0_24_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x48)
#define REG_DVI_RSV_DUAL_P0_24_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x49)
#define REG_DVI_RSV_DUAL_P0_25_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x4A)
#define REG_DVI_RSV_DUAL_P0_25_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x4B)
#define REG_DVI_RSV_DUAL_P0_26_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x4C)
#define REG_DVI_RSV_DUAL_P0_26_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x4D)
#define REG_DVI_RSV_DUAL_P0_27_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x4E)
#define REG_DVI_RSV_DUAL_P0_27_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x4F)
#define REG_DVI_RSV_DUAL_P0_28_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x50)
#define REG_DVI_RSV_DUAL_P0_28_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x51)
#define REG_DVI_RSV_DUAL_P0_29_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x52)
#define REG_DVI_RSV_DUAL_P0_29_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x53)
#define REG_DVI_RSV_DUAL_P0_2A_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x54)
#define REG_DVI_RSV_DUAL_P0_2A_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x55)
#define REG_DVI_RSV_DUAL_P0_2B_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x56)
#define REG_DVI_RSV_DUAL_P0_2B_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x57)
#define REG_DVI_RSV_DUAL_P0_2C_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x58)
#define REG_DVI_RSV_DUAL_P0_2C_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x59)
#define REG_DVI_RSV_DUAL_P0_2D_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x5A)
#define REG_DVI_RSV_DUAL_P0_2D_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x5B)
#define REG_DVI_RSV_DUAL_P0_2E_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x5C)
#define REG_DVI_RSV_DUAL_P0_2E_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x5D)
#define REG_DVI_RSV_DUAL_P0_2F_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x5E)
#define REG_DVI_RSV_DUAL_P0_2F_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x5F)
#define REG_DVI_RSV_DUAL_P0_30_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x60)
#define REG_DVI_RSV_DUAL_P0_30_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x61)
#define REG_DVI_RSV_DUAL_P0_31_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x62)
#define REG_DVI_RSV_DUAL_P0_31_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x63)
#define REG_DVI_RSV_DUAL_P0_32_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x64)
#define REG_DVI_RSV_DUAL_P0_32_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x65)
#define REG_DVI_RSV_DUAL_P0_33_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x66)
#define REG_DVI_RSV_DUAL_P0_33_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x67)
#define REG_DVI_RSV_DUAL_P0_34_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x68)
#define REG_DVI_RSV_DUAL_P0_34_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x69)
#define REG_DVI_RSV_DUAL_P0_35_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x6A)
#define REG_DVI_RSV_DUAL_P0_35_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x6B)
#define REG_DVI_RSV_DUAL_P0_36_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x6C)
#define REG_DVI_RSV_DUAL_P0_36_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x6D)
#define REG_DVI_RSV_DUAL_P0_37_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x6E)
#define REG_DVI_RSV_DUAL_P0_37_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x6F)
#define REG_DVI_RSV_DUAL_P0_38_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x70)
#define REG_DVI_RSV_DUAL_P0_38_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x71)
#define REG_DVI_RSV_DUAL_P0_39_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x72)
#define REG_DVI_RSV_DUAL_P0_39_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x73)
#define REG_DVI_RSV_DUAL_P0_3A_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x74)
#define REG_DVI_RSV_DUAL_P0_3A_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x75)
#define REG_DVI_RSV_DUAL_P0_3B_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x76)
#define REG_DVI_RSV_DUAL_P0_3B_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x77)
#define REG_DVI_RSV_DUAL_P0_3C_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x78)
#define REG_DVI_RSV_DUAL_P0_3C_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x79)
#define REG_DVI_RSV_DUAL_P0_3D_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x7A)
#define REG_DVI_RSV_DUAL_P0_3D_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x7B)
#define REG_DVI_RSV_DUAL_P0_3E_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x7C)
#define REG_DVI_RSV_DUAL_P0_3E_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x7D)
#define REG_DVI_RSV_DUAL_P0_3F_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x7E)
#define REG_DVI_RSV_DUAL_P0_3F_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x7F)
#define REG_DVI_RSV_DUAL_P0_40_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x80)
#define REG_DVI_RSV_DUAL_P0_40_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x81)
#define REG_DVI_RSV_DUAL_P0_41_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x82)
#define REG_DVI_RSV_DUAL_P0_41_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x83)
#define REG_DVI_RSV_DUAL_P0_42_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x84)
#define REG_DVI_RSV_DUAL_P0_42_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x85)
#define REG_DVI_RSV_DUAL_P0_43_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x86)
#define REG_DVI_RSV_DUAL_P0_43_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x87)
#define REG_DVI_RSV_DUAL_P0_44_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x88)
#define REG_DVI_RSV_DUAL_P0_44_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x89)
#define REG_DVI_RSV_DUAL_P0_45_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x8A)
#define REG_DVI_RSV_DUAL_P0_45_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x8B)
#define REG_DVI_RSV_DUAL_P0_46_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x8C)
#define REG_DVI_RSV_DUAL_P0_46_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x8D)
#define REG_DVI_RSV_DUAL_P0_47_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x8E)
#define REG_DVI_RSV_DUAL_P0_47_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x8F)
#define REG_DVI_RSV_DUAL_P0_48_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x90)
#define REG_DVI_RSV_DUAL_P0_48_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x91)
#define REG_DVI_RSV_DUAL_P0_49_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x92)
#define REG_DVI_RSV_DUAL_P0_49_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x93)
#define REG_DVI_RSV_DUAL_P0_4A_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x94)
#define REG_DVI_RSV_DUAL_P0_4A_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x95)
#define REG_DVI_RSV_DUAL_P0_4B_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x96)
#define REG_DVI_RSV_DUAL_P0_4B_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x97)
#define REG_DVI_RSV_DUAL_P0_4C_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x98)
#define REG_DVI_RSV_DUAL_P0_4C_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x99)
#define REG_DVI_RSV_DUAL_P0_4D_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x9A)
#define REG_DVI_RSV_DUAL_P0_4D_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x9B)
#define REG_DVI_RSV_DUAL_P0_4E_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x9C)
#define REG_DVI_RSV_DUAL_P0_4E_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x9D)
#define REG_DVI_RSV_DUAL_P0_4F_L        (REG_DVI_RSV_DUAL_P0_BASE + 0x9E)
#define REG_DVI_RSV_DUAL_P0_4F_H        (REG_DVI_RSV_DUAL_P0_BASE + 0x9F)
#define REG_DVI_RSV_DUAL_P0_50_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xA0)
#define REG_DVI_RSV_DUAL_P0_50_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xA1)
#define REG_DVI_RSV_DUAL_P0_51_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xA2)
#define REG_DVI_RSV_DUAL_P0_51_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xA3)
#define REG_DVI_RSV_DUAL_P0_52_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xA4)
#define REG_DVI_RSV_DUAL_P0_52_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xA5)
#define REG_DVI_RSV_DUAL_P0_53_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xA6)
#define REG_DVI_RSV_DUAL_P0_53_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xA7)
#define REG_DVI_RSV_DUAL_P0_54_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xA8)
#define REG_DVI_RSV_DUAL_P0_54_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xA9)
#define REG_DVI_RSV_DUAL_P0_55_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xAA)
#define REG_DVI_RSV_DUAL_P0_55_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xAB)
#define REG_DVI_RSV_DUAL_P0_56_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xAC)
#define REG_DVI_RSV_DUAL_P0_56_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xAD)
#define REG_DVI_RSV_DUAL_P0_57_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xAE)
#define REG_DVI_RSV_DUAL_P0_57_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xAF)
#define REG_DVI_RSV_DUAL_P0_58_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xB0)
#define REG_DVI_RSV_DUAL_P0_58_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xB1)
#define REG_DVI_RSV_DUAL_P0_59_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xB2)
#define REG_DVI_RSV_DUAL_P0_59_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xB3)
#define REG_DVI_RSV_DUAL_P0_5A_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xB4)
#define REG_DVI_RSV_DUAL_P0_5A_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xB5)
#define REG_DVI_RSV_DUAL_P0_5B_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xB6)
#define REG_DVI_RSV_DUAL_P0_5B_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xB7)
#define REG_DVI_RSV_DUAL_P0_5C_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xB8)
#define REG_DVI_RSV_DUAL_P0_5C_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xB9)
#define REG_DVI_RSV_DUAL_P0_5D_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xBA)
#define REG_DVI_RSV_DUAL_P0_5D_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xBB)
#define REG_DVI_RSV_DUAL_P0_5E_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xBC)
#define REG_DVI_RSV_DUAL_P0_5E_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xBD)
#define REG_DVI_RSV_DUAL_P0_5F_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xBE)
#define REG_DVI_RSV_DUAL_P0_5F_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xBF)
#define REG_DVI_RSV_DUAL_P0_60_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xC0)
#define REG_DVI_RSV_DUAL_P0_60_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xC1)
#define REG_DVI_RSV_DUAL_P0_61_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xC2)
#define REG_DVI_RSV_DUAL_P0_61_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xC3)
#define REG_DVI_RSV_DUAL_P0_62_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xC4)
#define REG_DVI_RSV_DUAL_P0_62_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xC5)
#define REG_DVI_RSV_DUAL_P0_63_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xC6)
#define REG_DVI_RSV_DUAL_P0_63_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xC7)
#define REG_DVI_RSV_DUAL_P0_64_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xC8)
#define REG_DVI_RSV_DUAL_P0_64_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xC9)
#define REG_DVI_RSV_DUAL_P0_65_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xCA)
#define REG_DVI_RSV_DUAL_P0_65_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xCB)
#define REG_DVI_RSV_DUAL_P0_66_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xCC)
#define REG_DVI_RSV_DUAL_P0_66_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xCD)
#define REG_DVI_RSV_DUAL_P0_67_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xCE)
#define REG_DVI_RSV_DUAL_P0_67_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xCF)
#define REG_DVI_RSV_DUAL_P0_68_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xD0)
#define REG_DVI_RSV_DUAL_P0_68_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xD1)
#define REG_DVI_RSV_DUAL_P0_69_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xD2)
#define REG_DVI_RSV_DUAL_P0_69_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xD3)
#define REG_DVI_RSV_DUAL_P0_6A_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xD4)
#define REG_DVI_RSV_DUAL_P0_6A_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xD5)
#define REG_DVI_RSV_DUAL_P0_6B_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xD6)
#define REG_DVI_RSV_DUAL_P0_6B_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xD7)
#define REG_DVI_RSV_DUAL_P0_6C_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xD8)
#define REG_DVI_RSV_DUAL_P0_6C_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xD9)
#define REG_DVI_RSV_DUAL_P0_6D_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xDA)
#define REG_DVI_RSV_DUAL_P0_6D_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xDB)
#define REG_DVI_RSV_DUAL_P0_6E_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xDC)
#define REG_DVI_RSV_DUAL_P0_6E_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xDD)
#define REG_DVI_RSV_DUAL_P0_6F_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xDE)
#define REG_DVI_RSV_DUAL_P0_6F_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xDF)
#define REG_DVI_RSV_DUAL_P0_70_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xE0)
#define REG_DVI_RSV_DUAL_P0_70_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xE1)
#define REG_DVI_RSV_DUAL_P0_71_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xE2)
#define REG_DVI_RSV_DUAL_P0_71_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xE3)
#define REG_DVI_RSV_DUAL_P0_72_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xE4)
#define REG_DVI_RSV_DUAL_P0_72_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xE5)
#define REG_DVI_RSV_DUAL_P0_73_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xE6)
#define REG_DVI_RSV_DUAL_P0_73_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xE7)
#define REG_DVI_RSV_DUAL_P0_74_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xE8)
#define REG_DVI_RSV_DUAL_P0_74_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xE9)
#define REG_DVI_RSV_DUAL_P0_75_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xEA)
#define REG_DVI_RSV_DUAL_P0_75_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xEB)
#define REG_DVI_RSV_DUAL_P0_76_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xEC)
#define REG_DVI_RSV_DUAL_P0_76_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xED)
#define REG_DVI_RSV_DUAL_P0_77_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xEE)
#define REG_DVI_RSV_DUAL_P0_77_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xEF)
#define REG_DVI_RSV_DUAL_P0_78_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xF0)
#define REG_DVI_RSV_DUAL_P0_78_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xF1)
#define REG_DVI_RSV_DUAL_P0_79_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xF2)
#define REG_DVI_RSV_DUAL_P0_79_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xF3)
#define REG_DVI_RSV_DUAL_P0_7A_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xF4)
#define REG_DVI_RSV_DUAL_P0_7A_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xF5)
#define REG_DVI_RSV_DUAL_P0_7B_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xF6)
#define REG_DVI_RSV_DUAL_P0_7B_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xF7)
#define REG_DVI_RSV_DUAL_P0_7C_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xF8)
#define REG_DVI_RSV_DUAL_P0_7C_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xF9)
#define REG_DVI_RSV_DUAL_P0_7D_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xFA)
#define REG_DVI_RSV_DUAL_P0_7D_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xFB)
#define REG_DVI_RSV_DUAL_P0_7E_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xFC)
#define REG_DVI_RSV_DUAL_P0_7E_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xFD)
#define REG_DVI_RSV_DUAL_P0_7F_L        (REG_DVI_RSV_DUAL_P0_BASE + 0xFE)
#define REG_DVI_RSV_DUAL_P0_7F_H        (REG_DVI_RSV_DUAL_P0_BASE + 0xFF)

//=============================================================
// HDCP_DUAL_P0
#define REG_HDCP_DUAL_P0_00_L           (REG_HDCP_DUAL_P0_BASE + 0x00)
#define REG_HDCP_DUAL_P0_00_H           (REG_HDCP_DUAL_P0_BASE + 0x01)
#define REG_HDCP_DUAL_P0_01_L           (REG_HDCP_DUAL_P0_BASE + 0x02)
#define REG_HDCP_DUAL_P0_01_H           (REG_HDCP_DUAL_P0_BASE + 0x03)
#define REG_HDCP_DUAL_P0_02_L           (REG_HDCP_DUAL_P0_BASE + 0x04)
#define REG_HDCP_DUAL_P0_02_H           (REG_HDCP_DUAL_P0_BASE + 0x05)
#define REG_HDCP_DUAL_P0_03_L           (REG_HDCP_DUAL_P0_BASE + 0x06)
#define REG_HDCP_DUAL_P0_03_H           (REG_HDCP_DUAL_P0_BASE + 0x07)
#define REG_HDCP_DUAL_P0_04_L           (REG_HDCP_DUAL_P0_BASE + 0x08)
#define REG_HDCP_DUAL_P0_04_H           (REG_HDCP_DUAL_P0_BASE + 0x09)
#define REG_HDCP_DUAL_P0_05_L           (REG_HDCP_DUAL_P0_BASE + 0x0A)
#define REG_HDCP_DUAL_P0_05_H           (REG_HDCP_DUAL_P0_BASE + 0x0B)
#define REG_HDCP_DUAL_P0_06_L           (REG_HDCP_DUAL_P0_BASE + 0x0C)
#define REG_HDCP_DUAL_P0_06_H           (REG_HDCP_DUAL_P0_BASE + 0x0D)
#define REG_HDCP_DUAL_P0_07_L           (REG_HDCP_DUAL_P0_BASE + 0x0E)
#define REG_HDCP_DUAL_P0_07_H           (REG_HDCP_DUAL_P0_BASE + 0x0F)
#define REG_HDCP_DUAL_P0_08_L           (REG_HDCP_DUAL_P0_BASE + 0x10)
#define REG_HDCP_DUAL_P0_08_H           (REG_HDCP_DUAL_P0_BASE + 0x11)
#define REG_HDCP_DUAL_P0_09_L           (REG_HDCP_DUAL_P0_BASE + 0x12)
#define REG_HDCP_DUAL_P0_09_H           (REG_HDCP_DUAL_P0_BASE + 0x13)
#define REG_HDCP_DUAL_P0_0A_L           (REG_HDCP_DUAL_P0_BASE + 0x14)
#define REG_HDCP_DUAL_P0_0A_H           (REG_HDCP_DUAL_P0_BASE + 0x15)
#define REG_HDCP_DUAL_P0_0B_L           (REG_HDCP_DUAL_P0_BASE + 0x16)
#define REG_HDCP_DUAL_P0_0B_H           (REG_HDCP_DUAL_P0_BASE + 0x17)
#define REG_HDCP_DUAL_P0_0C_L           (REG_HDCP_DUAL_P0_BASE + 0x18)
#define REG_HDCP_DUAL_P0_0C_H           (REG_HDCP_DUAL_P0_BASE + 0x19)
#define REG_HDCP_DUAL_P0_0D_L           (REG_HDCP_DUAL_P0_BASE + 0x1A)
#define REG_HDCP_DUAL_P0_0D_H           (REG_HDCP_DUAL_P0_BASE + 0x1B)
#define REG_HDCP_DUAL_P0_0E_L           (REG_HDCP_DUAL_P0_BASE + 0x1C)
#define REG_HDCP_DUAL_P0_0E_H           (REG_HDCP_DUAL_P0_BASE + 0x1D)
#define REG_HDCP_DUAL_P0_0F_L           (REG_HDCP_DUAL_P0_BASE + 0x1E)
#define REG_HDCP_DUAL_P0_0F_H           (REG_HDCP_DUAL_P0_BASE + 0x1F)
#define REG_HDCP_DUAL_P0_10_L           (REG_HDCP_DUAL_P0_BASE + 0x20)
#define REG_HDCP_DUAL_P0_10_H           (REG_HDCP_DUAL_P0_BASE + 0x21)
#define REG_HDCP_DUAL_P0_11_L           (REG_HDCP_DUAL_P0_BASE + 0x22)
#define REG_HDCP_DUAL_P0_11_H           (REG_HDCP_DUAL_P0_BASE + 0x23)
#define REG_HDCP_DUAL_P0_12_L           (REG_HDCP_DUAL_P0_BASE + 0x24)
#define REG_HDCP_DUAL_P0_12_H           (REG_HDCP_DUAL_P0_BASE + 0x25)
#define REG_HDCP_DUAL_P0_13_L           (REG_HDCP_DUAL_P0_BASE + 0x26)
#define REG_HDCP_DUAL_P0_13_H           (REG_HDCP_DUAL_P0_BASE + 0x27)
#define REG_HDCP_DUAL_P0_14_L           (REG_HDCP_DUAL_P0_BASE + 0x28)
#define REG_HDCP_DUAL_P0_14_H           (REG_HDCP_DUAL_P0_BASE + 0x29)
#define REG_HDCP_DUAL_P0_15_L           (REG_HDCP_DUAL_P0_BASE + 0x2A)
#define REG_HDCP_DUAL_P0_15_H           (REG_HDCP_DUAL_P0_BASE + 0x2B)
#define REG_HDCP_DUAL_P0_16_L           (REG_HDCP_DUAL_P0_BASE + 0x2C)
#define REG_HDCP_DUAL_P0_16_H           (REG_HDCP_DUAL_P0_BASE + 0x2D)
#define REG_HDCP_DUAL_P0_17_L           (REG_HDCP_DUAL_P0_BASE + 0x2E)
#define REG_HDCP_DUAL_P0_17_H           (REG_HDCP_DUAL_P0_BASE + 0x2F)
#define REG_HDCP_DUAL_P0_18_L           (REG_HDCP_DUAL_P0_BASE + 0x30)
#define REG_HDCP_DUAL_P0_18_H           (REG_HDCP_DUAL_P0_BASE + 0x31)
#define REG_HDCP_DUAL_P0_19_L           (REG_HDCP_DUAL_P0_BASE + 0x32)
#define REG_HDCP_DUAL_P0_19_H           (REG_HDCP_DUAL_P0_BASE + 0x33)
#define REG_HDCP_DUAL_P0_1A_L           (REG_HDCP_DUAL_P0_BASE + 0x34)
#define REG_HDCP_DUAL_P0_1A_H           (REG_HDCP_DUAL_P0_BASE + 0x35)
#define REG_HDCP_DUAL_P0_1B_L           (REG_HDCP_DUAL_P0_BASE + 0x36)
#define REG_HDCP_DUAL_P0_1B_H           (REG_HDCP_DUAL_P0_BASE + 0x37)
#define REG_HDCP_DUAL_P0_1C_L           (REG_HDCP_DUAL_P0_BASE + 0x38)
#define REG_HDCP_DUAL_P0_1C_H           (REG_HDCP_DUAL_P0_BASE + 0x39)
#define REG_HDCP_DUAL_P0_1D_L           (REG_HDCP_DUAL_P0_BASE + 0x3A)
#define REG_HDCP_DUAL_P0_1D_H           (REG_HDCP_DUAL_P0_BASE + 0x3B)
#define REG_HDCP_DUAL_P0_1E_L           (REG_HDCP_DUAL_P0_BASE + 0x3C)
#define REG_HDCP_DUAL_P0_1E_H           (REG_HDCP_DUAL_P0_BASE + 0x3D)
#define REG_HDCP_DUAL_P0_1F_L           (REG_HDCP_DUAL_P0_BASE + 0x3E)
#define REG_HDCP_DUAL_P0_1F_H           (REG_HDCP_DUAL_P0_BASE + 0x3F)
#define REG_HDCP_DUAL_P0_20_L           (REG_HDCP_DUAL_P0_BASE + 0x40)
#define REG_HDCP_DUAL_P0_20_H           (REG_HDCP_DUAL_P0_BASE + 0x41)
#define REG_HDCP_DUAL_P0_21_L           (REG_HDCP_DUAL_P0_BASE + 0x42)
#define REG_HDCP_DUAL_P0_21_H           (REG_HDCP_DUAL_P0_BASE + 0x43)
#define REG_HDCP_DUAL_P0_22_L           (REG_HDCP_DUAL_P0_BASE + 0x44)
#define REG_HDCP_DUAL_P0_22_H           (REG_HDCP_DUAL_P0_BASE + 0x45)
#define REG_HDCP_DUAL_P0_23_L           (REG_HDCP_DUAL_P0_BASE + 0x46)
#define REG_HDCP_DUAL_P0_23_H           (REG_HDCP_DUAL_P0_BASE + 0x47)
#define REG_HDCP_DUAL_P0_24_L           (REG_HDCP_DUAL_P0_BASE + 0x48)
#define REG_HDCP_DUAL_P0_24_H           (REG_HDCP_DUAL_P0_BASE + 0x49)
#define REG_HDCP_DUAL_P0_25_L           (REG_HDCP_DUAL_P0_BASE + 0x4A)
#define REG_HDCP_DUAL_P0_25_H           (REG_HDCP_DUAL_P0_BASE + 0x4B)
#define REG_HDCP_DUAL_P0_26_L           (REG_HDCP_DUAL_P0_BASE + 0x4C)
#define REG_HDCP_DUAL_P0_26_H           (REG_HDCP_DUAL_P0_BASE + 0x4D)
#define REG_HDCP_DUAL_P0_27_L           (REG_HDCP_DUAL_P0_BASE + 0x4E)
#define REG_HDCP_DUAL_P0_27_H           (REG_HDCP_DUAL_P0_BASE + 0x4F)
#define REG_HDCP_DUAL_P0_28_L           (REG_HDCP_DUAL_P0_BASE + 0x50)
#define REG_HDCP_DUAL_P0_28_H           (REG_HDCP_DUAL_P0_BASE + 0x51)
#define REG_HDCP_DUAL_P0_29_L           (REG_HDCP_DUAL_P0_BASE + 0x52)
#define REG_HDCP_DUAL_P0_29_H           (REG_HDCP_DUAL_P0_BASE + 0x53)
#define REG_HDCP_DUAL_P0_2A_L           (REG_HDCP_DUAL_P0_BASE + 0x54)
#define REG_HDCP_DUAL_P0_2A_H           (REG_HDCP_DUAL_P0_BASE + 0x55)
#define REG_HDCP_DUAL_P0_2B_L           (REG_HDCP_DUAL_P0_BASE + 0x56)
#define REG_HDCP_DUAL_P0_2B_H           (REG_HDCP_DUAL_P0_BASE + 0x57)
#define REG_HDCP_DUAL_P0_2C_L           (REG_HDCP_DUAL_P0_BASE + 0x58)
#define REG_HDCP_DUAL_P0_2C_H           (REG_HDCP_DUAL_P0_BASE + 0x59)
#define REG_HDCP_DUAL_P0_2D_L           (REG_HDCP_DUAL_P0_BASE + 0x5A)
#define REG_HDCP_DUAL_P0_2D_H           (REG_HDCP_DUAL_P0_BASE + 0x5B)
#define REG_HDCP_DUAL_P0_2E_L           (REG_HDCP_DUAL_P0_BASE + 0x5C)
#define REG_HDCP_DUAL_P0_2E_H           (REG_HDCP_DUAL_P0_BASE + 0x5D)
#define REG_HDCP_DUAL_P0_2F_L           (REG_HDCP_DUAL_P0_BASE + 0x5E)
#define REG_HDCP_DUAL_P0_2F_H           (REG_HDCP_DUAL_P0_BASE + 0x5F)
#define REG_HDCP_DUAL_P0_30_L           (REG_HDCP_DUAL_P0_BASE + 0x60)
#define REG_HDCP_DUAL_P0_30_H           (REG_HDCP_DUAL_P0_BASE + 0x61)
#define REG_HDCP_DUAL_P0_31_L           (REG_HDCP_DUAL_P0_BASE + 0x62)
#define REG_HDCP_DUAL_P0_31_H           (REG_HDCP_DUAL_P0_BASE + 0x63)
#define REG_HDCP_DUAL_P0_32_L           (REG_HDCP_DUAL_P0_BASE + 0x64)
#define REG_HDCP_DUAL_P0_32_H           (REG_HDCP_DUAL_P0_BASE + 0x65)
#define REG_HDCP_DUAL_P0_33_L           (REG_HDCP_DUAL_P0_BASE + 0x66)
#define REG_HDCP_DUAL_P0_33_H           (REG_HDCP_DUAL_P0_BASE + 0x67)
#define REG_HDCP_DUAL_P0_34_L           (REG_HDCP_DUAL_P0_BASE + 0x68)
#define REG_HDCP_DUAL_P0_34_H           (REG_HDCP_DUAL_P0_BASE + 0x69)
#define REG_HDCP_DUAL_P0_35_L           (REG_HDCP_DUAL_P0_BASE + 0x6A)
#define REG_HDCP_DUAL_P0_35_H           (REG_HDCP_DUAL_P0_BASE + 0x6B)
#define REG_HDCP_DUAL_P0_36_L           (REG_HDCP_DUAL_P0_BASE + 0x6C)
#define REG_HDCP_DUAL_P0_36_H           (REG_HDCP_DUAL_P0_BASE + 0x6D)
#define REG_HDCP_DUAL_P0_37_L           (REG_HDCP_DUAL_P0_BASE + 0x6E)
#define REG_HDCP_DUAL_P0_37_H           (REG_HDCP_DUAL_P0_BASE + 0x6F)
#define REG_HDCP_DUAL_P0_38_L           (REG_HDCP_DUAL_P0_BASE + 0x70)
#define REG_HDCP_DUAL_P0_38_H           (REG_HDCP_DUAL_P0_BASE + 0x71)
#define REG_HDCP_DUAL_P0_39_L           (REG_HDCP_DUAL_P0_BASE + 0x72)
#define REG_HDCP_DUAL_P0_39_H           (REG_HDCP_DUAL_P0_BASE + 0x73)
#define REG_HDCP_DUAL_P0_3A_L           (REG_HDCP_DUAL_P0_BASE + 0x74)
#define REG_HDCP_DUAL_P0_3A_H           (REG_HDCP_DUAL_P0_BASE + 0x75)
#define REG_HDCP_DUAL_P0_3B_L           (REG_HDCP_DUAL_P0_BASE + 0x76)
#define REG_HDCP_DUAL_P0_3B_H           (REG_HDCP_DUAL_P0_BASE + 0x77)
#define REG_HDCP_DUAL_P0_3C_L           (REG_HDCP_DUAL_P0_BASE + 0x78)
#define REG_HDCP_DUAL_P0_3C_H           (REG_HDCP_DUAL_P0_BASE + 0x79)
#define REG_HDCP_DUAL_P0_3D_L           (REG_HDCP_DUAL_P0_BASE + 0x7A)
#define REG_HDCP_DUAL_P0_3D_H           (REG_HDCP_DUAL_P0_BASE + 0x7B)
#define REG_HDCP_DUAL_P0_3E_L           (REG_HDCP_DUAL_P0_BASE + 0x7C)
#define REG_HDCP_DUAL_P0_3E_H           (REG_HDCP_DUAL_P0_BASE + 0x7D)
#define REG_HDCP_DUAL_P0_3F_L           (REG_HDCP_DUAL_P0_BASE + 0x7E)
#define REG_HDCP_DUAL_P0_3F_H           (REG_HDCP_DUAL_P0_BASE + 0x7F)
#define REG_HDCP_DUAL_P0_40_L           (REG_HDCP_DUAL_P0_BASE + 0x80)
#define REG_HDCP_DUAL_P0_40_H           (REG_HDCP_DUAL_P0_BASE + 0x81)
#define REG_HDCP_DUAL_P0_41_L           (REG_HDCP_DUAL_P0_BASE + 0x82)
#define REG_HDCP_DUAL_P0_41_H           (REG_HDCP_DUAL_P0_BASE + 0x83)
#define REG_HDCP_DUAL_P0_42_L           (REG_HDCP_DUAL_P0_BASE + 0x84)
#define REG_HDCP_DUAL_P0_42_H           (REG_HDCP_DUAL_P0_BASE + 0x85)
#define REG_HDCP_DUAL_P0_43_L           (REG_HDCP_DUAL_P0_BASE + 0x86)
#define REG_HDCP_DUAL_P0_43_H           (REG_HDCP_DUAL_P0_BASE + 0x87)
#define REG_HDCP_DUAL_P0_44_L           (REG_HDCP_DUAL_P0_BASE + 0x88)
#define REG_HDCP_DUAL_P0_44_H           (REG_HDCP_DUAL_P0_BASE + 0x89)
#define REG_HDCP_DUAL_P0_45_L           (REG_HDCP_DUAL_P0_BASE + 0x8A)
#define REG_HDCP_DUAL_P0_45_H           (REG_HDCP_DUAL_P0_BASE + 0x8B)
#define REG_HDCP_DUAL_P0_46_L           (REG_HDCP_DUAL_P0_BASE + 0x8C)
#define REG_HDCP_DUAL_P0_46_H           (REG_HDCP_DUAL_P0_BASE + 0x8D)
#define REG_HDCP_DUAL_P0_47_L           (REG_HDCP_DUAL_P0_BASE + 0x8E)
#define REG_HDCP_DUAL_P0_47_H           (REG_HDCP_DUAL_P0_BASE + 0x8F)
#define REG_HDCP_DUAL_P0_48_L           (REG_HDCP_DUAL_P0_BASE + 0x90)
#define REG_HDCP_DUAL_P0_48_H           (REG_HDCP_DUAL_P0_BASE + 0x91)
#define REG_HDCP_DUAL_P0_49_L           (REG_HDCP_DUAL_P0_BASE + 0x92)
#define REG_HDCP_DUAL_P0_49_H           (REG_HDCP_DUAL_P0_BASE + 0x93)
#define REG_HDCP_DUAL_P0_4A_L           (REG_HDCP_DUAL_P0_BASE + 0x94)
#define REG_HDCP_DUAL_P0_4A_H           (REG_HDCP_DUAL_P0_BASE + 0x95)
#define REG_HDCP_DUAL_P0_4B_L           (REG_HDCP_DUAL_P0_BASE + 0x96)
#define REG_HDCP_DUAL_P0_4B_H           (REG_HDCP_DUAL_P0_BASE + 0x97)
#define REG_HDCP_DUAL_P0_4C_L           (REG_HDCP_DUAL_P0_BASE + 0x98)
#define REG_HDCP_DUAL_P0_4C_H           (REG_HDCP_DUAL_P0_BASE + 0x99)
#define REG_HDCP_DUAL_P0_4D_L           (REG_HDCP_DUAL_P0_BASE + 0x9A)
#define REG_HDCP_DUAL_P0_4D_H           (REG_HDCP_DUAL_P0_BASE + 0x9B)
#define REG_HDCP_DUAL_P0_4E_L           (REG_HDCP_DUAL_P0_BASE + 0x9C)
#define REG_HDCP_DUAL_P0_4E_H           (REG_HDCP_DUAL_P0_BASE + 0x9D)
#define REG_HDCP_DUAL_P0_4F_L           (REG_HDCP_DUAL_P0_BASE + 0x9E)
#define REG_HDCP_DUAL_P0_4F_H           (REG_HDCP_DUAL_P0_BASE + 0x9F)
#define REG_HDCP_DUAL_P0_50_L           (REG_HDCP_DUAL_P0_BASE + 0xA0)
#define REG_HDCP_DUAL_P0_50_H           (REG_HDCP_DUAL_P0_BASE + 0xA1)
#define REG_HDCP_DUAL_P0_51_L           (REG_HDCP_DUAL_P0_BASE + 0xA2)
#define REG_HDCP_DUAL_P0_51_H           (REG_HDCP_DUAL_P0_BASE + 0xA3)
#define REG_HDCP_DUAL_P0_52_L           (REG_HDCP_DUAL_P0_BASE + 0xA4)
#define REG_HDCP_DUAL_P0_52_H           (REG_HDCP_DUAL_P0_BASE + 0xA5)
#define REG_HDCP_DUAL_P0_53_L           (REG_HDCP_DUAL_P0_BASE + 0xA6)
#define REG_HDCP_DUAL_P0_53_H           (REG_HDCP_DUAL_P0_BASE + 0xA7)
#define REG_HDCP_DUAL_P0_54_L           (REG_HDCP_DUAL_P0_BASE + 0xA8)
#define REG_HDCP_DUAL_P0_54_H           (REG_HDCP_DUAL_P0_BASE + 0xA9)
#define REG_HDCP_DUAL_P0_55_L           (REG_HDCP_DUAL_P0_BASE + 0xAA)
#define REG_HDCP_DUAL_P0_55_H           (REG_HDCP_DUAL_P0_BASE + 0xAB)
#define REG_HDCP_DUAL_P0_56_L           (REG_HDCP_DUAL_P0_BASE + 0xAC)
#define REG_HDCP_DUAL_P0_56_H           (REG_HDCP_DUAL_P0_BASE + 0xAD)
#define REG_HDCP_DUAL_P0_57_L           (REG_HDCP_DUAL_P0_BASE + 0xAE)
#define REG_HDCP_DUAL_P0_57_H           (REG_HDCP_DUAL_P0_BASE + 0xAF)
#define REG_HDCP_DUAL_P0_58_L           (REG_HDCP_DUAL_P0_BASE + 0xB0)
#define REG_HDCP_DUAL_P0_58_H           (REG_HDCP_DUAL_P0_BASE + 0xB1)
#define REG_HDCP_DUAL_P0_59_L           (REG_HDCP_DUAL_P0_BASE + 0xB2)
#define REG_HDCP_DUAL_P0_59_H           (REG_HDCP_DUAL_P0_BASE + 0xB3)
#define REG_HDCP_DUAL_P0_5A_L           (REG_HDCP_DUAL_P0_BASE + 0xB4)
#define REG_HDCP_DUAL_P0_5A_H           (REG_HDCP_DUAL_P0_BASE + 0xB5)
#define REG_HDCP_DUAL_P0_5B_L           (REG_HDCP_DUAL_P0_BASE + 0xB6)
#define REG_HDCP_DUAL_P0_5B_H           (REG_HDCP_DUAL_P0_BASE + 0xB7)
#define REG_HDCP_DUAL_P0_5C_L           (REG_HDCP_DUAL_P0_BASE + 0xB8)
#define REG_HDCP_DUAL_P0_5C_H           (REG_HDCP_DUAL_P0_BASE + 0xB9)
#define REG_HDCP_DUAL_P0_5D_L           (REG_HDCP_DUAL_P0_BASE + 0xBA)
#define REG_HDCP_DUAL_P0_5D_H           (REG_HDCP_DUAL_P0_BASE + 0xBB)
#define REG_HDCP_DUAL_P0_5E_L           (REG_HDCP_DUAL_P0_BASE + 0xBC)
#define REG_HDCP_DUAL_P0_5E_H           (REG_HDCP_DUAL_P0_BASE + 0xBD)
#define REG_HDCP_DUAL_P0_5F_L           (REG_HDCP_DUAL_P0_BASE + 0xBE)
#define REG_HDCP_DUAL_P0_5F_H           (REG_HDCP_DUAL_P0_BASE + 0xBF)
#define REG_HDCP_DUAL_P0_60_L           (REG_HDCP_DUAL_P0_BASE + 0xC0)
#define REG_HDCP_DUAL_P0_60_H           (REG_HDCP_DUAL_P0_BASE + 0xC1)
#define REG_HDCP_DUAL_P0_61_L           (REG_HDCP_DUAL_P0_BASE + 0xC2)
#define REG_HDCP_DUAL_P0_61_H           (REG_HDCP_DUAL_P0_BASE + 0xC3)
#define REG_HDCP_DUAL_P0_62_L           (REG_HDCP_DUAL_P0_BASE + 0xC4)
#define REG_HDCP_DUAL_P0_62_H           (REG_HDCP_DUAL_P0_BASE + 0xC5)
#define REG_HDCP_DUAL_P0_63_L           (REG_HDCP_DUAL_P0_BASE + 0xC6)
#define REG_HDCP_DUAL_P0_63_H           (REG_HDCP_DUAL_P0_BASE + 0xC7)
#define REG_HDCP_DUAL_P0_64_L           (REG_HDCP_DUAL_P0_BASE + 0xC8)
#define REG_HDCP_DUAL_P0_64_H           (REG_HDCP_DUAL_P0_BASE + 0xC9)
#define REG_HDCP_DUAL_P0_65_L           (REG_HDCP_DUAL_P0_BASE + 0xCA)
#define REG_HDCP_DUAL_P0_65_H           (REG_HDCP_DUAL_P0_BASE + 0xCB)
#define REG_HDCP_DUAL_P0_66_L           (REG_HDCP_DUAL_P0_BASE + 0xCC)
#define REG_HDCP_DUAL_P0_66_H           (REG_HDCP_DUAL_P0_BASE + 0xCD)
#define REG_HDCP_DUAL_P0_67_L           (REG_HDCP_DUAL_P0_BASE + 0xCE)
#define REG_HDCP_DUAL_P0_67_H           (REG_HDCP_DUAL_P0_BASE + 0xCF)
#define REG_HDCP_DUAL_P0_68_L           (REG_HDCP_DUAL_P0_BASE + 0xD0)
#define REG_HDCP_DUAL_P0_68_H           (REG_HDCP_DUAL_P0_BASE + 0xD1)
#define REG_HDCP_DUAL_P0_69_L           (REG_HDCP_DUAL_P0_BASE + 0xD2)
#define REG_HDCP_DUAL_P0_69_H           (REG_HDCP_DUAL_P0_BASE + 0xD3)
#define REG_HDCP_DUAL_P0_6A_L           (REG_HDCP_DUAL_P0_BASE + 0xD4)
#define REG_HDCP_DUAL_P0_6A_H           (REG_HDCP_DUAL_P0_BASE + 0xD5)
#define REG_HDCP_DUAL_P0_6B_L           (REG_HDCP_DUAL_P0_BASE + 0xD6)
#define REG_HDCP_DUAL_P0_6B_H           (REG_HDCP_DUAL_P0_BASE + 0xD7)
#define REG_HDCP_DUAL_P0_6C_L           (REG_HDCP_DUAL_P0_BASE + 0xD8)
#define REG_HDCP_DUAL_P0_6C_H           (REG_HDCP_DUAL_P0_BASE + 0xD9)
#define REG_HDCP_DUAL_P0_6D_L           (REG_HDCP_DUAL_P0_BASE + 0xDA)
#define REG_HDCP_DUAL_P0_6D_H           (REG_HDCP_DUAL_P0_BASE + 0xDB)
#define REG_HDCP_DUAL_P0_6E_L           (REG_HDCP_DUAL_P0_BASE + 0xDC)
#define REG_HDCP_DUAL_P0_6E_H           (REG_HDCP_DUAL_P0_BASE + 0xDD)
#define REG_HDCP_DUAL_P0_6F_L           (REG_HDCP_DUAL_P0_BASE + 0xDE)
#define REG_HDCP_DUAL_P0_6F_H           (REG_HDCP_DUAL_P0_BASE + 0xDF)
#define REG_HDCP_DUAL_P0_70_L           (REG_HDCP_DUAL_P0_BASE + 0xE0)
#define REG_HDCP_DUAL_P0_70_H           (REG_HDCP_DUAL_P0_BASE + 0xE1)
#define REG_HDCP_DUAL_P0_71_L           (REG_HDCP_DUAL_P0_BASE + 0xE2)
#define REG_HDCP_DUAL_P0_71_H           (REG_HDCP_DUAL_P0_BASE + 0xE3)
#define REG_HDCP_DUAL_P0_72_L           (REG_HDCP_DUAL_P0_BASE + 0xE4)
#define REG_HDCP_DUAL_P0_72_H           (REG_HDCP_DUAL_P0_BASE + 0xE5)
#define REG_HDCP_DUAL_P0_73_L           (REG_HDCP_DUAL_P0_BASE + 0xE6)
#define REG_HDCP_DUAL_P0_73_H           (REG_HDCP_DUAL_P0_BASE + 0xE7)
#define REG_HDCP_DUAL_P0_74_L           (REG_HDCP_DUAL_P0_BASE + 0xE8)
#define REG_HDCP_DUAL_P0_74_H           (REG_HDCP_DUAL_P0_BASE + 0xE9)
#define REG_HDCP_DUAL_P0_75_L           (REG_HDCP_DUAL_P0_BASE + 0xEA)
#define REG_HDCP_DUAL_P0_75_H           (REG_HDCP_DUAL_P0_BASE + 0xEB)
#define REG_HDCP_DUAL_P0_76_L           (REG_HDCP_DUAL_P0_BASE + 0xEC)
#define REG_HDCP_DUAL_P0_76_H           (REG_HDCP_DUAL_P0_BASE + 0xED)
#define REG_HDCP_DUAL_P0_77_L           (REG_HDCP_DUAL_P0_BASE + 0xEE)
#define REG_HDCP_DUAL_P0_77_H           (REG_HDCP_DUAL_P0_BASE + 0xEF)
#define REG_HDCP_DUAL_P0_78_L           (REG_HDCP_DUAL_P0_BASE + 0xF0)
#define REG_HDCP_DUAL_P0_78_H           (REG_HDCP_DUAL_P0_BASE + 0xF1)
#define REG_HDCP_DUAL_P0_79_L           (REG_HDCP_DUAL_P0_BASE + 0xF2)
#define REG_HDCP_DUAL_P0_79_H           (REG_HDCP_DUAL_P0_BASE + 0xF3)
#define REG_HDCP_DUAL_P0_7A_L           (REG_HDCP_DUAL_P0_BASE + 0xF4)
#define REG_HDCP_DUAL_P0_7A_H           (REG_HDCP_DUAL_P0_BASE + 0xF5)
#define REG_HDCP_DUAL_P0_7B_L           (REG_HDCP_DUAL_P0_BASE + 0xF6)
#define REG_HDCP_DUAL_P0_7B_H           (REG_HDCP_DUAL_P0_BASE + 0xF7)
#define REG_HDCP_DUAL_P0_7C_L           (REG_HDCP_DUAL_P0_BASE + 0xF8)
#define REG_HDCP_DUAL_P0_7C_H           (REG_HDCP_DUAL_P0_BASE + 0xF9)
#define REG_HDCP_DUAL_P0_7D_L           (REG_HDCP_DUAL_P0_BASE + 0xFA)
#define REG_HDCP_DUAL_P0_7D_H           (REG_HDCP_DUAL_P0_BASE + 0xFB)
#define REG_HDCP_DUAL_P0_7E_L           (REG_HDCP_DUAL_P0_BASE + 0xFC)
#define REG_HDCP_DUAL_P0_7E_H           (REG_HDCP_DUAL_P0_BASE + 0xFD)
#define REG_HDCP_DUAL_P0_7F_L           (REG_HDCP_DUAL_P0_BASE + 0xFE)
#define REG_HDCP_DUAL_P0_7F_H           (REG_HDCP_DUAL_P0_BASE + 0xFF)

//=============================================================
// HDMIRX_DTOP_PKT_P0
#define REG_HDMIRX_DTOP_PKT_P0_00_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x00)
#define REG_HDMIRX_DTOP_PKT_P0_00_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x01)
#define REG_HDMIRX_DTOP_PKT_P0_01_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x02)
#define REG_HDMIRX_DTOP_PKT_P0_01_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x03)
#define REG_HDMIRX_DTOP_PKT_P0_02_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x04)
#define REG_HDMIRX_DTOP_PKT_P0_02_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x05)
#define REG_HDMIRX_DTOP_PKT_P0_03_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x06)
#define REG_HDMIRX_DTOP_PKT_P0_03_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x07)
#define REG_HDMIRX_DTOP_PKT_P0_04_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x08)
#define REG_HDMIRX_DTOP_PKT_P0_04_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x09)
#define REG_HDMIRX_DTOP_PKT_P0_05_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x0A)
#define REG_HDMIRX_DTOP_PKT_P0_05_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x0B)
#define REG_HDMIRX_DTOP_PKT_P0_06_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x0C)
#define REG_HDMIRX_DTOP_PKT_P0_06_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x0D)
#define REG_HDMIRX_DTOP_PKT_P0_07_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x0E)
#define REG_HDMIRX_DTOP_PKT_P0_07_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x0F)
#define REG_HDMIRX_DTOP_PKT_P0_08_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x10)
#define REG_HDMIRX_DTOP_PKT_P0_08_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x11)
#define REG_HDMIRX_DTOP_PKT_P0_09_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x12)
#define REG_HDMIRX_DTOP_PKT_P0_09_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x13)
#define REG_HDMIRX_DTOP_PKT_P0_0A_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x14)
#define REG_HDMIRX_DTOP_PKT_P0_0A_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x15)
#define REG_HDMIRX_DTOP_PKT_P0_0B_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x16)
#define REG_HDMIRX_DTOP_PKT_P0_0B_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x17)
#define REG_HDMIRX_DTOP_PKT_P0_0C_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x18)
#define REG_HDMIRX_DTOP_PKT_P0_0C_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x19)
#define REG_HDMIRX_DTOP_PKT_P0_0D_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x1A)
#define REG_HDMIRX_DTOP_PKT_P0_0D_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x1B)
#define REG_HDMIRX_DTOP_PKT_P0_0E_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x1C)
#define REG_HDMIRX_DTOP_PKT_P0_0E_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x1D)
#define REG_HDMIRX_DTOP_PKT_P0_0F_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x1E)
#define REG_HDMIRX_DTOP_PKT_P0_0F_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x1F)
#define REG_HDMIRX_DTOP_PKT_P0_10_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x20)
#define REG_HDMIRX_DTOP_PKT_P0_10_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x21)
#define REG_HDMIRX_DTOP_PKT_P0_11_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x22)
#define REG_HDMIRX_DTOP_PKT_P0_11_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x23)
#define REG_HDMIRX_DTOP_PKT_P0_12_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x24)
#define REG_HDMIRX_DTOP_PKT_P0_12_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x25)
#define REG_HDMIRX_DTOP_PKT_P0_13_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x26)
#define REG_HDMIRX_DTOP_PKT_P0_13_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x27)
#define REG_HDMIRX_DTOP_PKT_P0_14_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x28)
#define REG_HDMIRX_DTOP_PKT_P0_14_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x29)
#define REG_HDMIRX_DTOP_PKT_P0_15_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x2A)
#define REG_HDMIRX_DTOP_PKT_P0_15_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x2B)
#define REG_HDMIRX_DTOP_PKT_P0_16_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x2C)
#define REG_HDMIRX_DTOP_PKT_P0_16_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x2D)
#define REG_HDMIRX_DTOP_PKT_P0_17_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x2E)
#define REG_HDMIRX_DTOP_PKT_P0_17_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x2F)
#define REG_HDMIRX_DTOP_PKT_P0_18_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x30)
#define REG_HDMIRX_DTOP_PKT_P0_18_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x31)
#define REG_HDMIRX_DTOP_PKT_P0_19_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x32)
#define REG_HDMIRX_DTOP_PKT_P0_19_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x33)
#define REG_HDMIRX_DTOP_PKT_P0_1A_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x34)
#define REG_HDMIRX_DTOP_PKT_P0_1A_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x35)
#define REG_HDMIRX_DTOP_PKT_P0_1B_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x36)
#define REG_HDMIRX_DTOP_PKT_P0_1B_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x37)
#define REG_HDMIRX_DTOP_PKT_P0_1C_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x38)
#define REG_HDMIRX_DTOP_PKT_P0_1C_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x39)
#define REG_HDMIRX_DTOP_PKT_P0_1D_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x3A)
#define REG_HDMIRX_DTOP_PKT_P0_1D_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x3B)
#define REG_HDMIRX_DTOP_PKT_P0_1E_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x3C)
#define REG_HDMIRX_DTOP_PKT_P0_1E_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x3D)
#define REG_HDMIRX_DTOP_PKT_P0_1F_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x3E)
#define REG_HDMIRX_DTOP_PKT_P0_1F_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x3F)
#define REG_HDMIRX_DTOP_PKT_P0_20_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x40)
#define REG_HDMIRX_DTOP_PKT_P0_20_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x41)
#define REG_HDMIRX_DTOP_PKT_P0_21_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x42)
#define REG_HDMIRX_DTOP_PKT_P0_21_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x43)
#define REG_HDMIRX_DTOP_PKT_P0_22_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x44)
#define REG_HDMIRX_DTOP_PKT_P0_22_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x45)
#define REG_HDMIRX_DTOP_PKT_P0_23_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x46)
#define REG_HDMIRX_DTOP_PKT_P0_23_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x47)
#define REG_HDMIRX_DTOP_PKT_P0_24_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x48)
#define REG_HDMIRX_DTOP_PKT_P0_24_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x49)
#define REG_HDMIRX_DTOP_PKT_P0_25_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x4A)
#define REG_HDMIRX_DTOP_PKT_P0_25_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x4B)
#define REG_HDMIRX_DTOP_PKT_P0_26_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x4C)
#define REG_HDMIRX_DTOP_PKT_P0_26_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x4D)
#define REG_HDMIRX_DTOP_PKT_P0_27_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x4E)
#define REG_HDMIRX_DTOP_PKT_P0_27_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x4F)
#define REG_HDMIRX_DTOP_PKT_P0_28_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x50)
#define REG_HDMIRX_DTOP_PKT_P0_28_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x51)
#define REG_HDMIRX_DTOP_PKT_P0_29_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x52)
#define REG_HDMIRX_DTOP_PKT_P0_29_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x53)
#define REG_HDMIRX_DTOP_PKT_P0_2A_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x54)
#define REG_HDMIRX_DTOP_PKT_P0_2A_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x55)
#define REG_HDMIRX_DTOP_PKT_P0_2B_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x56)
#define REG_HDMIRX_DTOP_PKT_P0_2B_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x57)
#define REG_HDMIRX_DTOP_PKT_P0_2C_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x58)
#define REG_HDMIRX_DTOP_PKT_P0_2C_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x59)
#define REG_HDMIRX_DTOP_PKT_P0_2D_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x5A)
#define REG_HDMIRX_DTOP_PKT_P0_2D_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x5B)
#define REG_HDMIRX_DTOP_PKT_P0_2E_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x5C)
#define REG_HDMIRX_DTOP_PKT_P0_2E_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x5D)
#define REG_HDMIRX_DTOP_PKT_P0_2F_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x5E)
#define REG_HDMIRX_DTOP_PKT_P0_2F_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x5F)
#define REG_HDMIRX_DTOP_PKT_P0_30_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x60)
#define REG_HDMIRX_DTOP_PKT_P0_30_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x61)
#define REG_HDMIRX_DTOP_PKT_P0_31_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x62)
#define REG_HDMIRX_DTOP_PKT_P0_31_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x63)
#define REG_HDMIRX_DTOP_PKT_P0_32_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x64)
#define REG_HDMIRX_DTOP_PKT_P0_32_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x65)
#define REG_HDMIRX_DTOP_PKT_P0_33_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x66)
#define REG_HDMIRX_DTOP_PKT_P0_33_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x67)
#define REG_HDMIRX_DTOP_PKT_P0_34_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x68)
#define REG_HDMIRX_DTOP_PKT_P0_34_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x69)
#define REG_HDMIRX_DTOP_PKT_P0_35_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x6A)
#define REG_HDMIRX_DTOP_PKT_P0_35_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x6B)
#define REG_HDMIRX_DTOP_PKT_P0_36_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x6C)
#define REG_HDMIRX_DTOP_PKT_P0_36_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x6D)
#define REG_HDMIRX_DTOP_PKT_P0_37_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x6E)
#define REG_HDMIRX_DTOP_PKT_P0_37_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x6F)
#define REG_HDMIRX_DTOP_PKT_P0_38_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x70)
#define REG_HDMIRX_DTOP_PKT_P0_38_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x71)
#define REG_HDMIRX_DTOP_PKT_P0_39_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x72)
#define REG_HDMIRX_DTOP_PKT_P0_39_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x73)
#define REG_HDMIRX_DTOP_PKT_P0_3A_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x74)
#define REG_HDMIRX_DTOP_PKT_P0_3A_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x75)
#define REG_HDMIRX_DTOP_PKT_P0_3B_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x76)
#define REG_HDMIRX_DTOP_PKT_P0_3B_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x77)
#define REG_HDMIRX_DTOP_PKT_P0_3C_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x78)
#define REG_HDMIRX_DTOP_PKT_P0_3C_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x79)
#define REG_HDMIRX_DTOP_PKT_P0_3D_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x7A)
#define REG_HDMIRX_DTOP_PKT_P0_3D_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x7B)
#define REG_HDMIRX_DTOP_PKT_P0_3E_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x7C)
#define REG_HDMIRX_DTOP_PKT_P0_3E_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x7D)
#define REG_HDMIRX_DTOP_PKT_P0_3F_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x7E)
#define REG_HDMIRX_DTOP_PKT_P0_3F_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x7F)
#define REG_HDMIRX_DTOP_PKT_P0_40_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x80)
#define REG_HDMIRX_DTOP_PKT_P0_40_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x81)
#define REG_HDMIRX_DTOP_PKT_P0_41_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x82)
#define REG_HDMIRX_DTOP_PKT_P0_41_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x83)
#define REG_HDMIRX_DTOP_PKT_P0_42_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x84)
#define REG_HDMIRX_DTOP_PKT_P0_42_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x85)
#define REG_HDMIRX_DTOP_PKT_P0_43_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x86)
#define REG_HDMIRX_DTOP_PKT_P0_43_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x87)
#define REG_HDMIRX_DTOP_PKT_P0_44_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x88)
#define REG_HDMIRX_DTOP_PKT_P0_44_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x89)
#define REG_HDMIRX_DTOP_PKT_P0_45_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x8A)
#define REG_HDMIRX_DTOP_PKT_P0_45_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x8B)
#define REG_HDMIRX_DTOP_PKT_P0_46_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x8C)
#define REG_HDMIRX_DTOP_PKT_P0_46_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x8D)
#define REG_HDMIRX_DTOP_PKT_P0_47_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x8E)
#define REG_HDMIRX_DTOP_PKT_P0_47_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x8F)
#define REG_HDMIRX_DTOP_PKT_P0_48_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x90)
#define REG_HDMIRX_DTOP_PKT_P0_48_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x91)
#define REG_HDMIRX_DTOP_PKT_P0_49_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x92)
#define REG_HDMIRX_DTOP_PKT_P0_49_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x93)
#define REG_HDMIRX_DTOP_PKT_P0_4A_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x94)
#define REG_HDMIRX_DTOP_PKT_P0_4A_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x95)
#define REG_HDMIRX_DTOP_PKT_P0_4B_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x96)
#define REG_HDMIRX_DTOP_PKT_P0_4B_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x97)
#define REG_HDMIRX_DTOP_PKT_P0_4C_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x98)
#define REG_HDMIRX_DTOP_PKT_P0_4C_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x99)
#define REG_HDMIRX_DTOP_PKT_P0_4D_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x9A)
#define REG_HDMIRX_DTOP_PKT_P0_4D_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x9B)
#define REG_HDMIRX_DTOP_PKT_P0_4E_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x9C)
#define REG_HDMIRX_DTOP_PKT_P0_4E_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x9D)
#define REG_HDMIRX_DTOP_PKT_P0_4F_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x9E)
#define REG_HDMIRX_DTOP_PKT_P0_4F_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0x9F)
#define REG_HDMIRX_DTOP_PKT_P0_50_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xA0)
#define REG_HDMIRX_DTOP_PKT_P0_50_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xA1)
#define REG_HDMIRX_DTOP_PKT_P0_51_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xA2)
#define REG_HDMIRX_DTOP_PKT_P0_51_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xA3)
#define REG_HDMIRX_DTOP_PKT_P0_52_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xA4)
#define REG_HDMIRX_DTOP_PKT_P0_52_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xA5)
#define REG_HDMIRX_DTOP_PKT_P0_53_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xA6)
#define REG_HDMIRX_DTOP_PKT_P0_53_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xA7)
#define REG_HDMIRX_DTOP_PKT_P0_54_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xA8)
#define REG_HDMIRX_DTOP_PKT_P0_54_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xA9)
#define REG_HDMIRX_DTOP_PKT_P0_55_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xAA)
#define REG_HDMIRX_DTOP_PKT_P0_55_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xAB)
#define REG_HDMIRX_DTOP_PKT_P0_56_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xAC)
#define REG_HDMIRX_DTOP_PKT_P0_56_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xAD)
#define REG_HDMIRX_DTOP_PKT_P0_57_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xAE)
#define REG_HDMIRX_DTOP_PKT_P0_57_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xAF)
#define REG_HDMIRX_DTOP_PKT_P0_58_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xB0)
#define REG_HDMIRX_DTOP_PKT_P0_58_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xB1)
#define REG_HDMIRX_DTOP_PKT_P0_59_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xB2)
#define REG_HDMIRX_DTOP_PKT_P0_59_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xB3)
#define REG_HDMIRX_DTOP_PKT_P0_5A_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xB4)
#define REG_HDMIRX_DTOP_PKT_P0_5A_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xB5)
#define REG_HDMIRX_DTOP_PKT_P0_5B_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xB6)
#define REG_HDMIRX_DTOP_PKT_P0_5B_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xB7)
#define REG_HDMIRX_DTOP_PKT_P0_5C_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xB8)
#define REG_HDMIRX_DTOP_PKT_P0_5C_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xB9)
#define REG_HDMIRX_DTOP_PKT_P0_5D_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xBA)
#define REG_HDMIRX_DTOP_PKT_P0_5D_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xBB)
#define REG_HDMIRX_DTOP_PKT_P0_5E_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xBC)
#define REG_HDMIRX_DTOP_PKT_P0_5E_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xBD)
#define REG_HDMIRX_DTOP_PKT_P0_5F_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xBE)
#define REG_HDMIRX_DTOP_PKT_P0_5F_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xBF)
#define REG_HDMIRX_DTOP_PKT_P0_60_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xC0)
#define REG_HDMIRX_DTOP_PKT_P0_60_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xC1)
#define REG_HDMIRX_DTOP_PKT_P0_61_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xC2)
#define REG_HDMIRX_DTOP_PKT_P0_61_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xC3)
#define REG_HDMIRX_DTOP_PKT_P0_62_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xC4)
#define REG_HDMIRX_DTOP_PKT_P0_62_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xC5)
#define REG_HDMIRX_DTOP_PKT_P0_63_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xC6)
#define REG_HDMIRX_DTOP_PKT_P0_63_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xC7)
#define REG_HDMIRX_DTOP_PKT_P0_64_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xC8)
#define REG_HDMIRX_DTOP_PKT_P0_64_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xC9)
#define REG_HDMIRX_DTOP_PKT_P0_65_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xCA)
#define REG_HDMIRX_DTOP_PKT_P0_65_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xCB)
#define REG_HDMIRX_DTOP_PKT_P0_66_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xCC)
#define REG_HDMIRX_DTOP_PKT_P0_66_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xCD)
#define REG_HDMIRX_DTOP_PKT_P0_67_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xCE)
#define REG_HDMIRX_DTOP_PKT_P0_67_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xCF)
#define REG_HDMIRX_DTOP_PKT_P0_68_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xD0)
#define REG_HDMIRX_DTOP_PKT_P0_68_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xD1)
#define REG_HDMIRX_DTOP_PKT_P0_69_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xD2)
#define REG_HDMIRX_DTOP_PKT_P0_69_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xD3)
#define REG_HDMIRX_DTOP_PKT_P0_6A_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xD4)
#define REG_HDMIRX_DTOP_PKT_P0_6A_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xD5)
#define REG_HDMIRX_DTOP_PKT_P0_6B_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xD6)
#define REG_HDMIRX_DTOP_PKT_P0_6B_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xD7)
#define REG_HDMIRX_DTOP_PKT_P0_6C_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xD8)
#define REG_HDMIRX_DTOP_PKT_P0_6C_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xD9)
#define REG_HDMIRX_DTOP_PKT_P0_6D_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xDA)
#define REG_HDMIRX_DTOP_PKT_P0_6D_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xDB)
#define REG_HDMIRX_DTOP_PKT_P0_6E_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xDC)
#define REG_HDMIRX_DTOP_PKT_P0_6E_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xDD)
#define REG_HDMIRX_DTOP_PKT_P0_6F_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xDE)
#define REG_HDMIRX_DTOP_PKT_P0_6F_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xDF)
#define REG_HDMIRX_DTOP_PKT_P0_70_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xE0)
#define REG_HDMIRX_DTOP_PKT_P0_70_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xE1)
#define REG_HDMIRX_DTOP_PKT_P0_71_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xE2)
#define REG_HDMIRX_DTOP_PKT_P0_71_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xE3)
#define REG_HDMIRX_DTOP_PKT_P0_72_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xE4)
#define REG_HDMIRX_DTOP_PKT_P0_72_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xE5)
#define REG_HDMIRX_DTOP_PKT_P0_73_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xE6)
#define REG_HDMIRX_DTOP_PKT_P0_73_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xE7)
#define REG_HDMIRX_DTOP_PKT_P0_74_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xE8)
#define REG_HDMIRX_DTOP_PKT_P0_74_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xE9)
#define REG_HDMIRX_DTOP_PKT_P0_75_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xEA)
#define REG_HDMIRX_DTOP_PKT_P0_75_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xEB)
#define REG_HDMIRX_DTOP_PKT_P0_76_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xEC)
#define REG_HDMIRX_DTOP_PKT_P0_76_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xED)
#define REG_HDMIRX_DTOP_PKT_P0_77_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xEE)
#define REG_HDMIRX_DTOP_PKT_P0_77_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xEF)
#define REG_HDMIRX_DTOP_PKT_P0_78_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xF0)
#define REG_HDMIRX_DTOP_PKT_P0_78_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xF1)
#define REG_HDMIRX_DTOP_PKT_P0_79_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xF2)
#define REG_HDMIRX_DTOP_PKT_P0_79_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xF3)
#define REG_HDMIRX_DTOP_PKT_P0_7A_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xF4)
#define REG_HDMIRX_DTOP_PKT_P0_7A_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xF5)
#define REG_HDMIRX_DTOP_PKT_P0_7B_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xF6)
#define REG_HDMIRX_DTOP_PKT_P0_7B_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xF7)
#define REG_HDMIRX_DTOP_PKT_P0_7C_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xF8)
#define REG_HDMIRX_DTOP_PKT_P0_7C_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xF9)
#define REG_HDMIRX_DTOP_PKT_P0_7D_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xFA)
#define REG_HDMIRX_DTOP_PKT_P0_7D_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xFB)
#define REG_HDMIRX_DTOP_PKT_P0_7E_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xFC)
#define REG_HDMIRX_DTOP_PKT_P0_7E_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xFD)
#define REG_HDMIRX_DTOP_PKT_P0_7F_L           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xFE)
#define REG_HDMIRX_DTOP_PKT_P0_7F_H           (REG_HDMIRX_DTOP_PKT_P0_BASE + 0xFF)

//=============================================================
// DVI_DTOP_DUAL_P1
#define REG_DVI_DTOP_DUAL_P1_00_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x00)
#define REG_DVI_DTOP_DUAL_P1_00_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x01)
#define REG_DVI_DTOP_DUAL_P1_01_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x02)
#define REG_DVI_DTOP_DUAL_P1_01_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x03)
#define REG_DVI_DTOP_DUAL_P1_02_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x04)
#define REG_DVI_DTOP_DUAL_P1_02_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x05)
#define REG_DVI_DTOP_DUAL_P1_03_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x06)
#define REG_DVI_DTOP_DUAL_P1_03_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x07)
#define REG_DVI_DTOP_DUAL_P1_04_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x08)
#define REG_DVI_DTOP_DUAL_P1_04_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x09)
#define REG_DVI_DTOP_DUAL_P1_05_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x0A)
#define REG_DVI_DTOP_DUAL_P1_05_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x0B)
#define REG_DVI_DTOP_DUAL_P1_06_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x0C)
#define REG_DVI_DTOP_DUAL_P1_06_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x0D)
#define REG_DVI_DTOP_DUAL_P1_07_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x0E)
#define REG_DVI_DTOP_DUAL_P1_07_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x0F)
#define REG_DVI_DTOP_DUAL_P1_08_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x10)
#define REG_DVI_DTOP_DUAL_P1_08_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x11)
#define REG_DVI_DTOP_DUAL_P1_09_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x12)
#define REG_DVI_DTOP_DUAL_P1_09_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x13)
#define REG_DVI_DTOP_DUAL_P1_0A_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x14)
#define REG_DVI_DTOP_DUAL_P1_0A_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x15)
#define REG_DVI_DTOP_DUAL_P1_0B_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x16)
#define REG_DVI_DTOP_DUAL_P1_0B_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x17)
#define REG_DVI_DTOP_DUAL_P1_0C_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x18)
#define REG_DVI_DTOP_DUAL_P1_0C_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x19)
#define REG_DVI_DTOP_DUAL_P1_0D_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x1A)
#define REG_DVI_DTOP_DUAL_P1_0D_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x1B)
#define REG_DVI_DTOP_DUAL_P1_0E_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x1C)
#define REG_DVI_DTOP_DUAL_P1_0E_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x1D)
#define REG_DVI_DTOP_DUAL_P1_0F_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x1E)
#define REG_DVI_DTOP_DUAL_P1_0F_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x1F)
#define REG_DVI_DTOP_DUAL_P1_10_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x20)
#define REG_DVI_DTOP_DUAL_P1_10_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x21)
#define REG_DVI_DTOP_DUAL_P1_11_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x22)
#define REG_DVI_DTOP_DUAL_P1_11_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x23)
#define REG_DVI_DTOP_DUAL_P1_12_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x24)
#define REG_DVI_DTOP_DUAL_P1_12_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x25)
#define REG_DVI_DTOP_DUAL_P1_13_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x26)
#define REG_DVI_DTOP_DUAL_P1_13_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x27)
#define REG_DVI_DTOP_DUAL_P1_14_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x28)
#define REG_DVI_DTOP_DUAL_P1_14_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x29)
#define REG_DVI_DTOP_DUAL_P1_15_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x2A)
#define REG_DVI_DTOP_DUAL_P1_15_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x2B)
#define REG_DVI_DTOP_DUAL_P1_16_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x2C)
#define REG_DVI_DTOP_DUAL_P1_16_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x2D)
#define REG_DVI_DTOP_DUAL_P1_17_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x2E)
#define REG_DVI_DTOP_DUAL_P1_17_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x2F)
#define REG_DVI_DTOP_DUAL_P1_18_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x30)
#define REG_DVI_DTOP_DUAL_P1_18_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x31)
#define REG_DVI_DTOP_DUAL_P1_19_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x32)
#define REG_DVI_DTOP_DUAL_P1_19_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x33)
#define REG_DVI_DTOP_DUAL_P1_1A_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x34)
#define REG_DVI_DTOP_DUAL_P1_1A_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x35)
#define REG_DVI_DTOP_DUAL_P1_1B_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x36)
#define REG_DVI_DTOP_DUAL_P1_1B_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x37)
#define REG_DVI_DTOP_DUAL_P1_1C_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x38)
#define REG_DVI_DTOP_DUAL_P1_1C_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x39)
#define REG_DVI_DTOP_DUAL_P1_1D_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x3A)
#define REG_DVI_DTOP_DUAL_P1_1D_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x3B)
#define REG_DVI_DTOP_DUAL_P1_1E_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x3C)
#define REG_DVI_DTOP_DUAL_P1_1E_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x3D)
#define REG_DVI_DTOP_DUAL_P1_1F_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x3E)
#define REG_DVI_DTOP_DUAL_P1_1F_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x3F)
#define REG_DVI_DTOP_DUAL_P1_20_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x40)
#define REG_DVI_DTOP_DUAL_P1_20_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x41)
#define REG_DVI_DTOP_DUAL_P1_21_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x42)
#define REG_DVI_DTOP_DUAL_P1_21_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x43)
#define REG_DVI_DTOP_DUAL_P1_22_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x44)
#define REG_DVI_DTOP_DUAL_P1_22_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x45)
#define REG_DVI_DTOP_DUAL_P1_23_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x46)
#define REG_DVI_DTOP_DUAL_P1_23_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x47)
#define REG_DVI_DTOP_DUAL_P1_24_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x48)
#define REG_DVI_DTOP_DUAL_P1_24_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x49)
#define REG_DVI_DTOP_DUAL_P1_25_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x4A)
#define REG_DVI_DTOP_DUAL_P1_25_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x4B)
#define REG_DVI_DTOP_DUAL_P1_26_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x4C)
#define REG_DVI_DTOP_DUAL_P1_26_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x4D)
#define REG_DVI_DTOP_DUAL_P1_27_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x4E)
#define REG_DVI_DTOP_DUAL_P1_27_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x4F)
#define REG_DVI_DTOP_DUAL_P1_28_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x50)
#define REG_DVI_DTOP_DUAL_P1_28_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x51)
#define REG_DVI_DTOP_DUAL_P1_29_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x52)
#define REG_DVI_DTOP_DUAL_P1_29_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x53)
#define REG_DVI_DTOP_DUAL_P1_2A_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x54)
#define REG_DVI_DTOP_DUAL_P1_2A_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x55)
#define REG_DVI_DTOP_DUAL_P1_2B_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x56)
#define REG_DVI_DTOP_DUAL_P1_2B_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x57)
#define REG_DVI_DTOP_DUAL_P1_2C_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x58)
#define REG_DVI_DTOP_DUAL_P1_2C_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x59)
#define REG_DVI_DTOP_DUAL_P1_2D_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x5A)
#define REG_DVI_DTOP_DUAL_P1_2D_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x5B)
#define REG_DVI_DTOP_DUAL_P1_2E_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x5C)
#define REG_DVI_DTOP_DUAL_P1_2E_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x5D)
#define REG_DVI_DTOP_DUAL_P1_2F_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x5E)
#define REG_DVI_DTOP_DUAL_P1_2F_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x5F)
#define REG_DVI_DTOP_DUAL_P1_30_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x60)
#define REG_DVI_DTOP_DUAL_P1_30_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x61)
#define REG_DVI_DTOP_DUAL_P1_31_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x62)
#define REG_DVI_DTOP_DUAL_P1_31_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x63)
#define REG_DVI_DTOP_DUAL_P1_32_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x64)
#define REG_DVI_DTOP_DUAL_P1_32_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x65)
#define REG_DVI_DTOP_DUAL_P1_33_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x66)
#define REG_DVI_DTOP_DUAL_P1_33_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x67)
#define REG_DVI_DTOP_DUAL_P1_34_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x68)
#define REG_DVI_DTOP_DUAL_P1_34_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x69)
#define REG_DVI_DTOP_DUAL_P1_35_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x6A)
#define REG_DVI_DTOP_DUAL_P1_35_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x6B)
#define REG_DVI_DTOP_DUAL_P1_36_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x6C)
#define REG_DVI_DTOP_DUAL_P1_36_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x6D)
#define REG_DVI_DTOP_DUAL_P1_37_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x6E)
#define REG_DVI_DTOP_DUAL_P1_37_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x6F)
#define REG_DVI_DTOP_DUAL_P1_38_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x70)
#define REG_DVI_DTOP_DUAL_P1_38_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x71)
#define REG_DVI_DTOP_DUAL_P1_39_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x72)
#define REG_DVI_DTOP_DUAL_P1_39_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x73)
#define REG_DVI_DTOP_DUAL_P1_3A_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x74)
#define REG_DVI_DTOP_DUAL_P1_3A_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x75)
#define REG_DVI_DTOP_DUAL_P1_3B_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x76)
#define REG_DVI_DTOP_DUAL_P1_3B_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x77)
#define REG_DVI_DTOP_DUAL_P1_3C_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x78)
#define REG_DVI_DTOP_DUAL_P1_3C_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x79)
#define REG_DVI_DTOP_DUAL_P1_3D_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x7A)
#define REG_DVI_DTOP_DUAL_P1_3D_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x7B)
#define REG_DVI_DTOP_DUAL_P1_3E_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x7C)
#define REG_DVI_DTOP_DUAL_P1_3E_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x7D)
#define REG_DVI_DTOP_DUAL_P1_3F_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x7E)
#define REG_DVI_DTOP_DUAL_P1_3F_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x7F)
#define REG_DVI_DTOP_DUAL_P1_40_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x80)
#define REG_DVI_DTOP_DUAL_P1_40_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x81)
#define REG_DVI_DTOP_DUAL_P1_41_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x82)
#define REG_DVI_DTOP_DUAL_P1_41_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x83)
#define REG_DVI_DTOP_DUAL_P1_42_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x84)
#define REG_DVI_DTOP_DUAL_P1_42_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x85)
#define REG_DVI_DTOP_DUAL_P1_43_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x86)
#define REG_DVI_DTOP_DUAL_P1_43_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x87)
#define REG_DVI_DTOP_DUAL_P1_44_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x88)
#define REG_DVI_DTOP_DUAL_P1_44_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x89)
#define REG_DVI_DTOP_DUAL_P1_45_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x8A)
#define REG_DVI_DTOP_DUAL_P1_45_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x8B)
#define REG_DVI_DTOP_DUAL_P1_46_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x8C)
#define REG_DVI_DTOP_DUAL_P1_46_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x8D)
#define REG_DVI_DTOP_DUAL_P1_47_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x8E)
#define REG_DVI_DTOP_DUAL_P1_47_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x8F)
#define REG_DVI_DTOP_DUAL_P1_48_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x90)
#define REG_DVI_DTOP_DUAL_P1_48_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x91)
#define REG_DVI_DTOP_DUAL_P1_49_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x92)
#define REG_DVI_DTOP_DUAL_P1_49_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x93)
#define REG_DVI_DTOP_DUAL_P1_4A_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x94)
#define REG_DVI_DTOP_DUAL_P1_4A_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x95)
#define REG_DVI_DTOP_DUAL_P1_4B_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x96)
#define REG_DVI_DTOP_DUAL_P1_4B_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x97)
#define REG_DVI_DTOP_DUAL_P1_4C_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x98)
#define REG_DVI_DTOP_DUAL_P1_4C_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x99)
#define REG_DVI_DTOP_DUAL_P1_4D_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x9A)
#define REG_DVI_DTOP_DUAL_P1_4D_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x9B)
#define REG_DVI_DTOP_DUAL_P1_4E_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x9C)
#define REG_DVI_DTOP_DUAL_P1_4E_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x9D)
#define REG_DVI_DTOP_DUAL_P1_4F_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0x9E)
#define REG_DVI_DTOP_DUAL_P1_4F_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0x9F)
#define REG_DVI_DTOP_DUAL_P1_50_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xA0)
#define REG_DVI_DTOP_DUAL_P1_50_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xA1)
#define REG_DVI_DTOP_DUAL_P1_51_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xA2)
#define REG_DVI_DTOP_DUAL_P1_51_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xA3)
#define REG_DVI_DTOP_DUAL_P1_52_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xA4)
#define REG_DVI_DTOP_DUAL_P1_52_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xA5)
#define REG_DVI_DTOP_DUAL_P1_53_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xA6)
#define REG_DVI_DTOP_DUAL_P1_53_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xA7)
#define REG_DVI_DTOP_DUAL_P1_54_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xA8)
#define REG_DVI_DTOP_DUAL_P1_54_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xA9)
#define REG_DVI_DTOP_DUAL_P1_55_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xAA)
#define REG_DVI_DTOP_DUAL_P1_55_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xAB)
#define REG_DVI_DTOP_DUAL_P1_56_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xAC)
#define REG_DVI_DTOP_DUAL_P1_56_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xAD)
#define REG_DVI_DTOP_DUAL_P1_57_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xAE)
#define REG_DVI_DTOP_DUAL_P1_57_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xAF)
#define REG_DVI_DTOP_DUAL_P1_58_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xB0)
#define REG_DVI_DTOP_DUAL_P1_58_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xB1)
#define REG_DVI_DTOP_DUAL_P1_59_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xB2)
#define REG_DVI_DTOP_DUAL_P1_59_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xB3)
#define REG_DVI_DTOP_DUAL_P1_5A_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xB4)
#define REG_DVI_DTOP_DUAL_P1_5A_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xB5)
#define REG_DVI_DTOP_DUAL_P1_5B_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xB6)
#define REG_DVI_DTOP_DUAL_P1_5B_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xB7)
#define REG_DVI_DTOP_DUAL_P1_5C_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xB8)
#define REG_DVI_DTOP_DUAL_P1_5C_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xB9)
#define REG_DVI_DTOP_DUAL_P1_5D_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xBA)
#define REG_DVI_DTOP_DUAL_P1_5D_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xBB)
#define REG_DVI_DTOP_DUAL_P1_5E_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xBC)
#define REG_DVI_DTOP_DUAL_P1_5E_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xBD)
#define REG_DVI_DTOP_DUAL_P1_5F_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xBE)
#define REG_DVI_DTOP_DUAL_P1_5F_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xBF)
#define REG_DVI_DTOP_DUAL_P1_60_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xC0)
#define REG_DVI_DTOP_DUAL_P1_60_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xC1)
#define REG_DVI_DTOP_DUAL_P1_61_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xC2)
#define REG_DVI_DTOP_DUAL_P1_61_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xC3)
#define REG_DVI_DTOP_DUAL_P1_62_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xC4)
#define REG_DVI_DTOP_DUAL_P1_62_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xC5)
#define REG_DVI_DTOP_DUAL_P1_63_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xC6)
#define REG_DVI_DTOP_DUAL_P1_63_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xC7)
#define REG_DVI_DTOP_DUAL_P1_64_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xC8)
#define REG_DVI_DTOP_DUAL_P1_64_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xC9)
#define REG_DVI_DTOP_DUAL_P1_65_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xCA)
#define REG_DVI_DTOP_DUAL_P1_65_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xCB)
#define REG_DVI_DTOP_DUAL_P1_66_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xCC)
#define REG_DVI_DTOP_DUAL_P1_66_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xCD)
#define REG_DVI_DTOP_DUAL_P1_67_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xCE)
#define REG_DVI_DTOP_DUAL_P1_67_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xCF)
#define REG_DVI_DTOP_DUAL_P1_68_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xD0)
#define REG_DVI_DTOP_DUAL_P1_68_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xD1)
#define REG_DVI_DTOP_DUAL_P1_69_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xD2)
#define REG_DVI_DTOP_DUAL_P1_69_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xD3)
#define REG_DVI_DTOP_DUAL_P1_6A_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xD4)
#define REG_DVI_DTOP_DUAL_P1_6A_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xD5)
#define REG_DVI_DTOP_DUAL_P1_6B_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xD6)
#define REG_DVI_DTOP_DUAL_P1_6B_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xD7)
#define REG_DVI_DTOP_DUAL_P1_6C_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xD8)
#define REG_DVI_DTOP_DUAL_P1_6C_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xD9)
#define REG_DVI_DTOP_DUAL_P1_6D_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xDA)
#define REG_DVI_DTOP_DUAL_P1_6D_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xDB)
#define REG_DVI_DTOP_DUAL_P1_6E_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xDC)
#define REG_DVI_DTOP_DUAL_P1_6E_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xDD)
#define REG_DVI_DTOP_DUAL_P1_6F_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xDE)
#define REG_DVI_DTOP_DUAL_P1_6F_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xDF)
#define REG_DVI_DTOP_DUAL_P1_70_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xE0)
#define REG_DVI_DTOP_DUAL_P1_70_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xE1)
#define REG_DVI_DTOP_DUAL_P1_71_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xE2)
#define REG_DVI_DTOP_DUAL_P1_71_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xE3)
#define REG_DVI_DTOP_DUAL_P1_72_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xE4)
#define REG_DVI_DTOP_DUAL_P1_72_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xE5)
#define REG_DVI_DTOP_DUAL_P1_73_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xE6)
#define REG_DVI_DTOP_DUAL_P1_73_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xE7)
#define REG_DVI_DTOP_DUAL_P1_74_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xE8)
#define REG_DVI_DTOP_DUAL_P1_74_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xE9)
#define REG_DVI_DTOP_DUAL_P1_75_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xEA)
#define REG_DVI_DTOP_DUAL_P1_75_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xEB)
#define REG_DVI_DTOP_DUAL_P1_76_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xEC)
#define REG_DVI_DTOP_DUAL_P1_76_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xED)
#define REG_DVI_DTOP_DUAL_P1_77_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xEE)
#define REG_DVI_DTOP_DUAL_P1_77_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xEF)
#define REG_DVI_DTOP_DUAL_P1_78_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xF0)
#define REG_DVI_DTOP_DUAL_P1_78_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xF1)
#define REG_DVI_DTOP_DUAL_P1_79_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xF2)
#define REG_DVI_DTOP_DUAL_P1_79_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xF3)
#define REG_DVI_DTOP_DUAL_P1_7A_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xF4)
#define REG_DVI_DTOP_DUAL_P1_7A_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xF5)
#define REG_DVI_DTOP_DUAL_P1_7B_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xF6)
#define REG_DVI_DTOP_DUAL_P1_7B_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xF7)
#define REG_DVI_DTOP_DUAL_P1_7C_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xF8)
#define REG_DVI_DTOP_DUAL_P1_7C_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xF9)
#define REG_DVI_DTOP_DUAL_P1_7D_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xFA)
#define REG_DVI_DTOP_DUAL_P1_7D_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xFB)
#define REG_DVI_DTOP_DUAL_P1_7E_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xFC)
#define REG_DVI_DTOP_DUAL_P1_7E_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xFD)
#define REG_DVI_DTOP_DUAL_P1_7F_L       (REG_DVI_DTOP_DUAL_P1_BASE + 0xFE)
#define REG_DVI_DTOP_DUAL_P1_7F_H       (REG_DVI_DTOP_DUAL_P1_BASE + 0xFF)

//=============================================================
// DVI_RSV_DUAL_P1
#define REG_DVI_RSV_DUAL_P1_00_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x00)
#define REG_DVI_RSV_DUAL_P1_00_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x01)
#define REG_DVI_RSV_DUAL_P1_01_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x02)
#define REG_DVI_RSV_DUAL_P1_01_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x03)
#define REG_DVI_RSV_DUAL_P1_02_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x04)
#define REG_DVI_RSV_DUAL_P1_02_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x05)
#define REG_DVI_RSV_DUAL_P1_03_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x06)
#define REG_DVI_RSV_DUAL_P1_03_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x07)
#define REG_DVI_RSV_DUAL_P1_04_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x08)
#define REG_DVI_RSV_DUAL_P1_04_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x09)
#define REG_DVI_RSV_DUAL_P1_05_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x0A)
#define REG_DVI_RSV_DUAL_P1_05_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x0B)
#define REG_DVI_RSV_DUAL_P1_06_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x0C)
#define REG_DVI_RSV_DUAL_P1_06_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x0D)
#define REG_DVI_RSV_DUAL_P1_07_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x0E)
#define REG_DVI_RSV_DUAL_P1_07_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x0F)
#define REG_DVI_RSV_DUAL_P1_08_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x10)
#define REG_DVI_RSV_DUAL_P1_08_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x11)
#define REG_DVI_RSV_DUAL_P1_09_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x12)
#define REG_DVI_RSV_DUAL_P1_09_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x13)
#define REG_DVI_RSV_DUAL_P1_0A_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x14)
#define REG_DVI_RSV_DUAL_P1_0A_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x15)
#define REG_DVI_RSV_DUAL_P1_0B_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x16)
#define REG_DVI_RSV_DUAL_P1_0B_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x17)
#define REG_DVI_RSV_DUAL_P1_0C_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x18)
#define REG_DVI_RSV_DUAL_P1_0C_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x19)
#define REG_DVI_RSV_DUAL_P1_0D_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x1A)
#define REG_DVI_RSV_DUAL_P1_0D_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x1B)
#define REG_DVI_RSV_DUAL_P1_0E_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x1C)
#define REG_DVI_RSV_DUAL_P1_0E_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x1D)
#define REG_DVI_RSV_DUAL_P1_0F_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x1E)
#define REG_DVI_RSV_DUAL_P1_0F_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x1F)
#define REG_DVI_RSV_DUAL_P1_10_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x20)
#define REG_DVI_RSV_DUAL_P1_10_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x21)
#define REG_DVI_RSV_DUAL_P1_11_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x22)
#define REG_DVI_RSV_DUAL_P1_11_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x23)
#define REG_DVI_RSV_DUAL_P1_12_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x24)
#define REG_DVI_RSV_DUAL_P1_12_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x25)
#define REG_DVI_RSV_DUAL_P1_13_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x26)
#define REG_DVI_RSV_DUAL_P1_13_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x27)
#define REG_DVI_RSV_DUAL_P1_14_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x28)
#define REG_DVI_RSV_DUAL_P1_14_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x29)
#define REG_DVI_RSV_DUAL_P1_15_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x2A)
#define REG_DVI_RSV_DUAL_P1_15_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x2B)
#define REG_DVI_RSV_DUAL_P1_16_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x2C)
#define REG_DVI_RSV_DUAL_P1_16_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x2D)
#define REG_DVI_RSV_DUAL_P1_17_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x2E)
#define REG_DVI_RSV_DUAL_P1_17_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x2F)
#define REG_DVI_RSV_DUAL_P1_18_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x30)
#define REG_DVI_RSV_DUAL_P1_18_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x31)
#define REG_DVI_RSV_DUAL_P1_19_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x32)
#define REG_DVI_RSV_DUAL_P1_19_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x33)
#define REG_DVI_RSV_DUAL_P1_1A_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x34)
#define REG_DVI_RSV_DUAL_P1_1A_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x35)
#define REG_DVI_RSV_DUAL_P1_1B_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x36)
#define REG_DVI_RSV_DUAL_P1_1B_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x37)
#define REG_DVI_RSV_DUAL_P1_1C_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x38)
#define REG_DVI_RSV_DUAL_P1_1C_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x39)
#define REG_DVI_RSV_DUAL_P1_1D_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x3A)
#define REG_DVI_RSV_DUAL_P1_1D_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x3B)
#define REG_DVI_RSV_DUAL_P1_1E_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x3C)
#define REG_DVI_RSV_DUAL_P1_1E_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x3D)
#define REG_DVI_RSV_DUAL_P1_1F_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x3E)
#define REG_DVI_RSV_DUAL_P1_1F_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x3F)
#define REG_DVI_RSV_DUAL_P1_20_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x40)
#define REG_DVI_RSV_DUAL_P1_20_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x41)
#define REG_DVI_RSV_DUAL_P1_21_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x42)
#define REG_DVI_RSV_DUAL_P1_21_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x43)
#define REG_DVI_RSV_DUAL_P1_22_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x44)
#define REG_DVI_RSV_DUAL_P1_22_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x45)
#define REG_DVI_RSV_DUAL_P1_23_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x46)
#define REG_DVI_RSV_DUAL_P1_23_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x47)
#define REG_DVI_RSV_DUAL_P1_24_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x48)
#define REG_DVI_RSV_DUAL_P1_24_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x49)
#define REG_DVI_RSV_DUAL_P1_25_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x4A)
#define REG_DVI_RSV_DUAL_P1_25_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x4B)
#define REG_DVI_RSV_DUAL_P1_26_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x4C)
#define REG_DVI_RSV_DUAL_P1_26_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x4D)
#define REG_DVI_RSV_DUAL_P1_27_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x4E)
#define REG_DVI_RSV_DUAL_P1_27_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x4F)
#define REG_DVI_RSV_DUAL_P1_28_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x50)
#define REG_DVI_RSV_DUAL_P1_28_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x51)
#define REG_DVI_RSV_DUAL_P1_29_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x52)
#define REG_DVI_RSV_DUAL_P1_29_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x53)
#define REG_DVI_RSV_DUAL_P1_2A_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x54)
#define REG_DVI_RSV_DUAL_P1_2A_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x55)
#define REG_DVI_RSV_DUAL_P1_2B_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x56)
#define REG_DVI_RSV_DUAL_P1_2B_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x57)
#define REG_DVI_RSV_DUAL_P1_2C_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x58)
#define REG_DVI_RSV_DUAL_P1_2C_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x59)
#define REG_DVI_RSV_DUAL_P1_2D_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x5A)
#define REG_DVI_RSV_DUAL_P1_2D_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x5B)
#define REG_DVI_RSV_DUAL_P1_2E_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x5C)
#define REG_DVI_RSV_DUAL_P1_2E_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x5D)
#define REG_DVI_RSV_DUAL_P1_2F_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x5E)
#define REG_DVI_RSV_DUAL_P1_2F_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x5F)
#define REG_DVI_RSV_DUAL_P1_30_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x60)
#define REG_DVI_RSV_DUAL_P1_30_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x61)
#define REG_DVI_RSV_DUAL_P1_31_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x62)
#define REG_DVI_RSV_DUAL_P1_31_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x63)
#define REG_DVI_RSV_DUAL_P1_32_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x64)
#define REG_DVI_RSV_DUAL_P1_32_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x65)
#define REG_DVI_RSV_DUAL_P1_33_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x66)
#define REG_DVI_RSV_DUAL_P1_33_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x67)
#define REG_DVI_RSV_DUAL_P1_34_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x68)
#define REG_DVI_RSV_DUAL_P1_34_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x69)
#define REG_DVI_RSV_DUAL_P1_35_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x6A)
#define REG_DVI_RSV_DUAL_P1_35_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x6B)
#define REG_DVI_RSV_DUAL_P1_36_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x6C)
#define REG_DVI_RSV_DUAL_P1_36_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x6D)
#define REG_DVI_RSV_DUAL_P1_37_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x6E)
#define REG_DVI_RSV_DUAL_P1_37_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x6F)
#define REG_DVI_RSV_DUAL_P1_38_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x70)
#define REG_DVI_RSV_DUAL_P1_38_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x71)
#define REG_DVI_RSV_DUAL_P1_39_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x72)
#define REG_DVI_RSV_DUAL_P1_39_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x73)
#define REG_DVI_RSV_DUAL_P1_3A_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x74)
#define REG_DVI_RSV_DUAL_P1_3A_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x75)
#define REG_DVI_RSV_DUAL_P1_3B_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x76)
#define REG_DVI_RSV_DUAL_P1_3B_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x77)
#define REG_DVI_RSV_DUAL_P1_3C_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x78)
#define REG_DVI_RSV_DUAL_P1_3C_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x79)
#define REG_DVI_RSV_DUAL_P1_3D_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x7A)
#define REG_DVI_RSV_DUAL_P1_3D_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x7B)
#define REG_DVI_RSV_DUAL_P1_3E_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x7C)
#define REG_DVI_RSV_DUAL_P1_3E_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x7D)
#define REG_DVI_RSV_DUAL_P1_3F_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x7E)
#define REG_DVI_RSV_DUAL_P1_3F_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x7F)
#define REG_DVI_RSV_DUAL_P1_40_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x80)
#define REG_DVI_RSV_DUAL_P1_40_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x81)
#define REG_DVI_RSV_DUAL_P1_41_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x82)
#define REG_DVI_RSV_DUAL_P1_41_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x83)
#define REG_DVI_RSV_DUAL_P1_42_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x84)
#define REG_DVI_RSV_DUAL_P1_42_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x85)
#define REG_DVI_RSV_DUAL_P1_43_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x86)
#define REG_DVI_RSV_DUAL_P1_43_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x87)
#define REG_DVI_RSV_DUAL_P1_44_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x88)
#define REG_DVI_RSV_DUAL_P1_44_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x89)
#define REG_DVI_RSV_DUAL_P1_45_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x8A)
#define REG_DVI_RSV_DUAL_P1_45_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x8B)
#define REG_DVI_RSV_DUAL_P1_46_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x8C)
#define REG_DVI_RSV_DUAL_P1_46_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x8D)
#define REG_DVI_RSV_DUAL_P1_47_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x8E)
#define REG_DVI_RSV_DUAL_P1_47_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x8F)
#define REG_DVI_RSV_DUAL_P1_48_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x90)
#define REG_DVI_RSV_DUAL_P1_48_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x91)
#define REG_DVI_RSV_DUAL_P1_49_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x92)
#define REG_DVI_RSV_DUAL_P1_49_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x93)
#define REG_DVI_RSV_DUAL_P1_4A_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x94)
#define REG_DVI_RSV_DUAL_P1_4A_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x95)
#define REG_DVI_RSV_DUAL_P1_4B_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x96)
#define REG_DVI_RSV_DUAL_P1_4B_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x97)
#define REG_DVI_RSV_DUAL_P1_4C_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x98)
#define REG_DVI_RSV_DUAL_P1_4C_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x99)
#define REG_DVI_RSV_DUAL_P1_4D_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x9A)
#define REG_DVI_RSV_DUAL_P1_4D_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x9B)
#define REG_DVI_RSV_DUAL_P1_4E_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x9C)
#define REG_DVI_RSV_DUAL_P1_4E_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x9D)
#define REG_DVI_RSV_DUAL_P1_4F_L        (REG_DVI_RSV_DUAL_P1_BASE + 0x9E)
#define REG_DVI_RSV_DUAL_P1_4F_H        (REG_DVI_RSV_DUAL_P1_BASE + 0x9F)
#define REG_DVI_RSV_DUAL_P1_50_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xA0)
#define REG_DVI_RSV_DUAL_P1_50_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xA1)
#define REG_DVI_RSV_DUAL_P1_51_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xA2)
#define REG_DVI_RSV_DUAL_P1_51_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xA3)
#define REG_DVI_RSV_DUAL_P1_52_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xA4)
#define REG_DVI_RSV_DUAL_P1_52_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xA5)
#define REG_DVI_RSV_DUAL_P1_53_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xA6)
#define REG_DVI_RSV_DUAL_P1_53_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xA7)
#define REG_DVI_RSV_DUAL_P1_54_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xA8)
#define REG_DVI_RSV_DUAL_P1_54_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xA9)
#define REG_DVI_RSV_DUAL_P1_55_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xAA)
#define REG_DVI_RSV_DUAL_P1_55_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xAB)
#define REG_DVI_RSV_DUAL_P1_56_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xAC)
#define REG_DVI_RSV_DUAL_P1_56_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xAD)
#define REG_DVI_RSV_DUAL_P1_57_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xAE)
#define REG_DVI_RSV_DUAL_P1_57_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xAF)
#define REG_DVI_RSV_DUAL_P1_58_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xB0)
#define REG_DVI_RSV_DUAL_P1_58_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xB1)
#define REG_DVI_RSV_DUAL_P1_59_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xB2)
#define REG_DVI_RSV_DUAL_P1_59_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xB3)
#define REG_DVI_RSV_DUAL_P1_5A_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xB4)
#define REG_DVI_RSV_DUAL_P1_5A_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xB5)
#define REG_DVI_RSV_DUAL_P1_5B_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xB6)
#define REG_DVI_RSV_DUAL_P1_5B_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xB7)
#define REG_DVI_RSV_DUAL_P1_5C_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xB8)
#define REG_DVI_RSV_DUAL_P1_5C_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xB9)
#define REG_DVI_RSV_DUAL_P1_5D_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xBA)
#define REG_DVI_RSV_DUAL_P1_5D_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xBB)
#define REG_DVI_RSV_DUAL_P1_5E_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xBC)
#define REG_DVI_RSV_DUAL_P1_5E_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xBD)
#define REG_DVI_RSV_DUAL_P1_5F_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xBE)
#define REG_DVI_RSV_DUAL_P1_5F_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xBF)
#define REG_DVI_RSV_DUAL_P1_60_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xC0)
#define REG_DVI_RSV_DUAL_P1_60_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xC1)
#define REG_DVI_RSV_DUAL_P1_61_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xC2)
#define REG_DVI_RSV_DUAL_P1_61_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xC3)
#define REG_DVI_RSV_DUAL_P1_62_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xC4)
#define REG_DVI_RSV_DUAL_P1_62_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xC5)
#define REG_DVI_RSV_DUAL_P1_63_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xC6)
#define REG_DVI_RSV_DUAL_P1_63_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xC7)
#define REG_DVI_RSV_DUAL_P1_64_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xC8)
#define REG_DVI_RSV_DUAL_P1_64_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xC9)
#define REG_DVI_RSV_DUAL_P1_65_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xCA)
#define REG_DVI_RSV_DUAL_P1_65_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xCB)
#define REG_DVI_RSV_DUAL_P1_66_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xCC)
#define REG_DVI_RSV_DUAL_P1_66_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xCD)
#define REG_DVI_RSV_DUAL_P1_67_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xCE)
#define REG_DVI_RSV_DUAL_P1_67_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xCF)
#define REG_DVI_RSV_DUAL_P1_68_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xD0)
#define REG_DVI_RSV_DUAL_P1_68_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xD1)
#define REG_DVI_RSV_DUAL_P1_69_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xD2)
#define REG_DVI_RSV_DUAL_P1_69_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xD3)
#define REG_DVI_RSV_DUAL_P1_6A_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xD4)
#define REG_DVI_RSV_DUAL_P1_6A_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xD5)
#define REG_DVI_RSV_DUAL_P1_6B_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xD6)
#define REG_DVI_RSV_DUAL_P1_6B_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xD7)
#define REG_DVI_RSV_DUAL_P1_6C_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xD8)
#define REG_DVI_RSV_DUAL_P1_6C_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xD9)
#define REG_DVI_RSV_DUAL_P1_6D_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xDA)
#define REG_DVI_RSV_DUAL_P1_6D_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xDB)
#define REG_DVI_RSV_DUAL_P1_6E_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xDC)
#define REG_DVI_RSV_DUAL_P1_6E_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xDD)
#define REG_DVI_RSV_DUAL_P1_6F_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xDE)
#define REG_DVI_RSV_DUAL_P1_6F_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xDF)
#define REG_DVI_RSV_DUAL_P1_70_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xE0)
#define REG_DVI_RSV_DUAL_P1_70_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xE1)
#define REG_DVI_RSV_DUAL_P1_71_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xE2)
#define REG_DVI_RSV_DUAL_P1_71_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xE3)
#define REG_DVI_RSV_DUAL_P1_72_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xE4)
#define REG_DVI_RSV_DUAL_P1_72_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xE5)
#define REG_DVI_RSV_DUAL_P1_73_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xE6)
#define REG_DVI_RSV_DUAL_P1_73_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xE7)
#define REG_DVI_RSV_DUAL_P1_74_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xE8)
#define REG_DVI_RSV_DUAL_P1_74_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xE9)
#define REG_DVI_RSV_DUAL_P1_75_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xEA)
#define REG_DVI_RSV_DUAL_P1_75_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xEB)
#define REG_DVI_RSV_DUAL_P1_76_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xEC)
#define REG_DVI_RSV_DUAL_P1_76_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xED)
#define REG_DVI_RSV_DUAL_P1_77_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xEE)
#define REG_DVI_RSV_DUAL_P1_77_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xEF)
#define REG_DVI_RSV_DUAL_P1_78_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xF0)
#define REG_DVI_RSV_DUAL_P1_78_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xF1)
#define REG_DVI_RSV_DUAL_P1_79_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xF2)
#define REG_DVI_RSV_DUAL_P1_79_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xF3)
#define REG_DVI_RSV_DUAL_P1_7A_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xF4)
#define REG_DVI_RSV_DUAL_P1_7A_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xF5)
#define REG_DVI_RSV_DUAL_P1_7B_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xF6)
#define REG_DVI_RSV_DUAL_P1_7B_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xF7)
#define REG_DVI_RSV_DUAL_P1_7C_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xF8)
#define REG_DVI_RSV_DUAL_P1_7C_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xF9)
#define REG_DVI_RSV_DUAL_P1_7D_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xFA)
#define REG_DVI_RSV_DUAL_P1_7D_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xFB)
#define REG_DVI_RSV_DUAL_P1_7E_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xFC)
#define REG_DVI_RSV_DUAL_P1_7E_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xFD)
#define REG_DVI_RSV_DUAL_P1_7F_L        (REG_DVI_RSV_DUAL_P1_BASE + 0xFE)
#define REG_DVI_RSV_DUAL_P1_7F_H        (REG_DVI_RSV_DUAL_P1_BASE + 0xFF)

//=============================================================
// HDCP_DUAL_P1
#define REG_HDCP_DUAL_P1_00_L           (REG_HDCP_DUAL_P1_BASE + 0x00)
#define REG_HDCP_DUAL_P1_00_H           (REG_HDCP_DUAL_P1_BASE + 0x01)
#define REG_HDCP_DUAL_P1_01_L           (REG_HDCP_DUAL_P1_BASE + 0x02)
#define REG_HDCP_DUAL_P1_01_H           (REG_HDCP_DUAL_P1_BASE + 0x03)
#define REG_HDCP_DUAL_P1_02_L           (REG_HDCP_DUAL_P1_BASE + 0x04)
#define REG_HDCP_DUAL_P1_02_H           (REG_HDCP_DUAL_P1_BASE + 0x05)
#define REG_HDCP_DUAL_P1_03_L           (REG_HDCP_DUAL_P1_BASE + 0x06)
#define REG_HDCP_DUAL_P1_03_H           (REG_HDCP_DUAL_P1_BASE + 0x07)
#define REG_HDCP_DUAL_P1_04_L           (REG_HDCP_DUAL_P1_BASE + 0x08)
#define REG_HDCP_DUAL_P1_04_H           (REG_HDCP_DUAL_P1_BASE + 0x09)
#define REG_HDCP_DUAL_P1_05_L           (REG_HDCP_DUAL_P1_BASE + 0x0A)
#define REG_HDCP_DUAL_P1_05_H           (REG_HDCP_DUAL_P1_BASE + 0x0B)
#define REG_HDCP_DUAL_P1_06_L           (REG_HDCP_DUAL_P1_BASE + 0x0C)
#define REG_HDCP_DUAL_P1_06_H           (REG_HDCP_DUAL_P1_BASE + 0x0D)
#define REG_HDCP_DUAL_P1_07_L           (REG_HDCP_DUAL_P1_BASE + 0x0E)
#define REG_HDCP_DUAL_P1_07_H           (REG_HDCP_DUAL_P1_BASE + 0x0F)
#define REG_HDCP_DUAL_P1_08_L           (REG_HDCP_DUAL_P1_BASE + 0x10)
#define REG_HDCP_DUAL_P1_08_H           (REG_HDCP_DUAL_P1_BASE + 0x11)
#define REG_HDCP_DUAL_P1_09_L           (REG_HDCP_DUAL_P1_BASE + 0x12)
#define REG_HDCP_DUAL_P1_09_H           (REG_HDCP_DUAL_P1_BASE + 0x13)
#define REG_HDCP_DUAL_P1_0A_L           (REG_HDCP_DUAL_P1_BASE + 0x14)
#define REG_HDCP_DUAL_P1_0A_H           (REG_HDCP_DUAL_P1_BASE + 0x15)
#define REG_HDCP_DUAL_P1_0B_L           (REG_HDCP_DUAL_P1_BASE + 0x16)
#define REG_HDCP_DUAL_P1_0B_H           (REG_HDCP_DUAL_P1_BASE + 0x17)
#define REG_HDCP_DUAL_P1_0C_L           (REG_HDCP_DUAL_P1_BASE + 0x18)
#define REG_HDCP_DUAL_P1_0C_H           (REG_HDCP_DUAL_P1_BASE + 0x19)
#define REG_HDCP_DUAL_P1_0D_L           (REG_HDCP_DUAL_P1_BASE + 0x1A)
#define REG_HDCP_DUAL_P1_0D_H           (REG_HDCP_DUAL_P1_BASE + 0x1B)
#define REG_HDCP_DUAL_P1_0E_L           (REG_HDCP_DUAL_P1_BASE + 0x1C)
#define REG_HDCP_DUAL_P1_0E_H           (REG_HDCP_DUAL_P1_BASE + 0x1D)
#define REG_HDCP_DUAL_P1_0F_L           (REG_HDCP_DUAL_P1_BASE + 0x1E)
#define REG_HDCP_DUAL_P1_0F_H           (REG_HDCP_DUAL_P1_BASE + 0x1F)
#define REG_HDCP_DUAL_P1_10_L           (REG_HDCP_DUAL_P1_BASE + 0x20)
#define REG_HDCP_DUAL_P1_10_H           (REG_HDCP_DUAL_P1_BASE + 0x21)
#define REG_HDCP_DUAL_P1_11_L           (REG_HDCP_DUAL_P1_BASE + 0x22)
#define REG_HDCP_DUAL_P1_11_H           (REG_HDCP_DUAL_P1_BASE + 0x23)
#define REG_HDCP_DUAL_P1_12_L           (REG_HDCP_DUAL_P1_BASE + 0x24)
#define REG_HDCP_DUAL_P1_12_H           (REG_HDCP_DUAL_P1_BASE + 0x25)
#define REG_HDCP_DUAL_P1_13_L           (REG_HDCP_DUAL_P1_BASE + 0x26)
#define REG_HDCP_DUAL_P1_13_H           (REG_HDCP_DUAL_P1_BASE + 0x27)
#define REG_HDCP_DUAL_P1_14_L           (REG_HDCP_DUAL_P1_BASE + 0x28)
#define REG_HDCP_DUAL_P1_14_H           (REG_HDCP_DUAL_P1_BASE + 0x29)
#define REG_HDCP_DUAL_P1_15_L           (REG_HDCP_DUAL_P1_BASE + 0x2A)
#define REG_HDCP_DUAL_P1_15_H           (REG_HDCP_DUAL_P1_BASE + 0x2B)
#define REG_HDCP_DUAL_P1_16_L           (REG_HDCP_DUAL_P1_BASE + 0x2C)
#define REG_HDCP_DUAL_P1_16_H           (REG_HDCP_DUAL_P1_BASE + 0x2D)
#define REG_HDCP_DUAL_P1_17_L           (REG_HDCP_DUAL_P1_BASE + 0x2E)
#define REG_HDCP_DUAL_P1_17_H           (REG_HDCP_DUAL_P1_BASE + 0x2F)
#define REG_HDCP_DUAL_P1_18_L           (REG_HDCP_DUAL_P1_BASE + 0x30)
#define REG_HDCP_DUAL_P1_18_H           (REG_HDCP_DUAL_P1_BASE + 0x31)
#define REG_HDCP_DUAL_P1_19_L           (REG_HDCP_DUAL_P1_BASE + 0x32)
#define REG_HDCP_DUAL_P1_19_H           (REG_HDCP_DUAL_P1_BASE + 0x33)
#define REG_HDCP_DUAL_P1_1A_L           (REG_HDCP_DUAL_P1_BASE + 0x34)
#define REG_HDCP_DUAL_P1_1A_H           (REG_HDCP_DUAL_P1_BASE + 0x35)
#define REG_HDCP_DUAL_P1_1B_L           (REG_HDCP_DUAL_P1_BASE + 0x36)
#define REG_HDCP_DUAL_P1_1B_H           (REG_HDCP_DUAL_P1_BASE + 0x37)
#define REG_HDCP_DUAL_P1_1C_L           (REG_HDCP_DUAL_P1_BASE + 0x38)
#define REG_HDCP_DUAL_P1_1C_H           (REG_HDCP_DUAL_P1_BASE + 0x39)
#define REG_HDCP_DUAL_P1_1D_L           (REG_HDCP_DUAL_P1_BASE + 0x3A)
#define REG_HDCP_DUAL_P1_1D_H           (REG_HDCP_DUAL_P1_BASE + 0x3B)
#define REG_HDCP_DUAL_P1_1E_L           (REG_HDCP_DUAL_P1_BASE + 0x3C)
#define REG_HDCP_DUAL_P1_1E_H           (REG_HDCP_DUAL_P1_BASE + 0x3D)
#define REG_HDCP_DUAL_P1_1F_L           (REG_HDCP_DUAL_P1_BASE + 0x3E)
#define REG_HDCP_DUAL_P1_1F_H           (REG_HDCP_DUAL_P1_BASE + 0x3F)
#define REG_HDCP_DUAL_P1_20_L           (REG_HDCP_DUAL_P1_BASE + 0x40)
#define REG_HDCP_DUAL_P1_20_H           (REG_HDCP_DUAL_P1_BASE + 0x41)
#define REG_HDCP_DUAL_P1_21_L           (REG_HDCP_DUAL_P1_BASE + 0x42)
#define REG_HDCP_DUAL_P1_21_H           (REG_HDCP_DUAL_P1_BASE + 0x43)
#define REG_HDCP_DUAL_P1_22_L           (REG_HDCP_DUAL_P1_BASE + 0x44)
#define REG_HDCP_DUAL_P1_22_H           (REG_HDCP_DUAL_P1_BASE + 0x45)
#define REG_HDCP_DUAL_P1_23_L           (REG_HDCP_DUAL_P1_BASE + 0x46)
#define REG_HDCP_DUAL_P1_23_H           (REG_HDCP_DUAL_P1_BASE + 0x47)
#define REG_HDCP_DUAL_P1_24_L           (REG_HDCP_DUAL_P1_BASE + 0x48)
#define REG_HDCP_DUAL_P1_24_H           (REG_HDCP_DUAL_P1_BASE + 0x49)
#define REG_HDCP_DUAL_P1_25_L           (REG_HDCP_DUAL_P1_BASE + 0x4A)
#define REG_HDCP_DUAL_P1_25_H           (REG_HDCP_DUAL_P1_BASE + 0x4B)
#define REG_HDCP_DUAL_P1_26_L           (REG_HDCP_DUAL_P1_BASE + 0x4C)
#define REG_HDCP_DUAL_P1_26_H           (REG_HDCP_DUAL_P1_BASE + 0x4D)
#define REG_HDCP_DUAL_P1_27_L           (REG_HDCP_DUAL_P1_BASE + 0x4E)
#define REG_HDCP_DUAL_P1_27_H           (REG_HDCP_DUAL_P1_BASE + 0x4F)
#define REG_HDCP_DUAL_P1_28_L           (REG_HDCP_DUAL_P1_BASE + 0x50)
#define REG_HDCP_DUAL_P1_28_H           (REG_HDCP_DUAL_P1_BASE + 0x51)
#define REG_HDCP_DUAL_P1_29_L           (REG_HDCP_DUAL_P1_BASE + 0x52)
#define REG_HDCP_DUAL_P1_29_H           (REG_HDCP_DUAL_P1_BASE + 0x53)
#define REG_HDCP_DUAL_P1_2A_L           (REG_HDCP_DUAL_P1_BASE + 0x54)
#define REG_HDCP_DUAL_P1_2A_H           (REG_HDCP_DUAL_P1_BASE + 0x55)
#define REG_HDCP_DUAL_P1_2B_L           (REG_HDCP_DUAL_P1_BASE + 0x56)
#define REG_HDCP_DUAL_P1_2B_H           (REG_HDCP_DUAL_P1_BASE + 0x57)
#define REG_HDCP_DUAL_P1_2C_L           (REG_HDCP_DUAL_P1_BASE + 0x58)
#define REG_HDCP_DUAL_P1_2C_H           (REG_HDCP_DUAL_P1_BASE + 0x59)
#define REG_HDCP_DUAL_P1_2D_L           (REG_HDCP_DUAL_P1_BASE + 0x5A)
#define REG_HDCP_DUAL_P1_2D_H           (REG_HDCP_DUAL_P1_BASE + 0x5B)
#define REG_HDCP_DUAL_P1_2E_L           (REG_HDCP_DUAL_P1_BASE + 0x5C)
#define REG_HDCP_DUAL_P1_2E_H           (REG_HDCP_DUAL_P1_BASE + 0x5D)
#define REG_HDCP_DUAL_P1_2F_L           (REG_HDCP_DUAL_P1_BASE + 0x5E)
#define REG_HDCP_DUAL_P1_2F_H           (REG_HDCP_DUAL_P1_BASE + 0x5F)
#define REG_HDCP_DUAL_P1_30_L           (REG_HDCP_DUAL_P1_BASE + 0x60)
#define REG_HDCP_DUAL_P1_30_H           (REG_HDCP_DUAL_P1_BASE + 0x61)
#define REG_HDCP_DUAL_P1_31_L           (REG_HDCP_DUAL_P1_BASE + 0x62)
#define REG_HDCP_DUAL_P1_31_H           (REG_HDCP_DUAL_P1_BASE + 0x63)
#define REG_HDCP_DUAL_P1_32_L           (REG_HDCP_DUAL_P1_BASE + 0x64)
#define REG_HDCP_DUAL_P1_32_H           (REG_HDCP_DUAL_P1_BASE + 0x65)
#define REG_HDCP_DUAL_P1_33_L           (REG_HDCP_DUAL_P1_BASE + 0x66)
#define REG_HDCP_DUAL_P1_33_H           (REG_HDCP_DUAL_P1_BASE + 0x67)
#define REG_HDCP_DUAL_P1_34_L           (REG_HDCP_DUAL_P1_BASE + 0x68)
#define REG_HDCP_DUAL_P1_34_H           (REG_HDCP_DUAL_P1_BASE + 0x69)
#define REG_HDCP_DUAL_P1_35_L           (REG_HDCP_DUAL_P1_BASE + 0x6A)
#define REG_HDCP_DUAL_P1_35_H           (REG_HDCP_DUAL_P1_BASE + 0x6B)
#define REG_HDCP_DUAL_P1_36_L           (REG_HDCP_DUAL_P1_BASE + 0x6C)
#define REG_HDCP_DUAL_P1_36_H           (REG_HDCP_DUAL_P1_BASE + 0x6D)
#define REG_HDCP_DUAL_P1_37_L           (REG_HDCP_DUAL_P1_BASE + 0x6E)
#define REG_HDCP_DUAL_P1_37_H           (REG_HDCP_DUAL_P1_BASE + 0x6F)
#define REG_HDCP_DUAL_P1_38_L           (REG_HDCP_DUAL_P1_BASE + 0x70)
#define REG_HDCP_DUAL_P1_38_H           (REG_HDCP_DUAL_P1_BASE + 0x71)
#define REG_HDCP_DUAL_P1_39_L           (REG_HDCP_DUAL_P1_BASE + 0x72)
#define REG_HDCP_DUAL_P1_39_H           (REG_HDCP_DUAL_P1_BASE + 0x73)
#define REG_HDCP_DUAL_P1_3A_L           (REG_HDCP_DUAL_P1_BASE + 0x74)
#define REG_HDCP_DUAL_P1_3A_H           (REG_HDCP_DUAL_P1_BASE + 0x75)
#define REG_HDCP_DUAL_P1_3B_L           (REG_HDCP_DUAL_P1_BASE + 0x76)
#define REG_HDCP_DUAL_P1_3B_H           (REG_HDCP_DUAL_P1_BASE + 0x77)
#define REG_HDCP_DUAL_P1_3C_L           (REG_HDCP_DUAL_P1_BASE + 0x78)
#define REG_HDCP_DUAL_P1_3C_H           (REG_HDCP_DUAL_P1_BASE + 0x79)
#define REG_HDCP_DUAL_P1_3D_L           (REG_HDCP_DUAL_P1_BASE + 0x7A)
#define REG_HDCP_DUAL_P1_3D_H           (REG_HDCP_DUAL_P1_BASE + 0x7B)
#define REG_HDCP_DUAL_P1_3E_L           (REG_HDCP_DUAL_P1_BASE + 0x7C)
#define REG_HDCP_DUAL_P1_3E_H           (REG_HDCP_DUAL_P1_BASE + 0x7D)
#define REG_HDCP_DUAL_P1_3F_L           (REG_HDCP_DUAL_P1_BASE + 0x7E)
#define REG_HDCP_DUAL_P1_3F_H           (REG_HDCP_DUAL_P1_BASE + 0x7F)
#define REG_HDCP_DUAL_P1_40_L           (REG_HDCP_DUAL_P1_BASE + 0x80)
#define REG_HDCP_DUAL_P1_40_H           (REG_HDCP_DUAL_P1_BASE + 0x81)
#define REG_HDCP_DUAL_P1_41_L           (REG_HDCP_DUAL_P1_BASE + 0x82)
#define REG_HDCP_DUAL_P1_41_H           (REG_HDCP_DUAL_P1_BASE + 0x83)
#define REG_HDCP_DUAL_P1_42_L           (REG_HDCP_DUAL_P1_BASE + 0x84)
#define REG_HDCP_DUAL_P1_42_H           (REG_HDCP_DUAL_P1_BASE + 0x85)
#define REG_HDCP_DUAL_P1_43_L           (REG_HDCP_DUAL_P1_BASE + 0x86)
#define REG_HDCP_DUAL_P1_43_H           (REG_HDCP_DUAL_P1_BASE + 0x87)
#define REG_HDCP_DUAL_P1_44_L           (REG_HDCP_DUAL_P1_BASE + 0x88)
#define REG_HDCP_DUAL_P1_44_H           (REG_HDCP_DUAL_P1_BASE + 0x89)
#define REG_HDCP_DUAL_P1_45_L           (REG_HDCP_DUAL_P1_BASE + 0x8A)
#define REG_HDCP_DUAL_P1_45_H           (REG_HDCP_DUAL_P1_BASE + 0x8B)
#define REG_HDCP_DUAL_P1_46_L           (REG_HDCP_DUAL_P1_BASE + 0x8C)
#define REG_HDCP_DUAL_P1_46_H           (REG_HDCP_DUAL_P1_BASE + 0x8D)
#define REG_HDCP_DUAL_P1_47_L           (REG_HDCP_DUAL_P1_BASE + 0x8E)
#define REG_HDCP_DUAL_P1_47_H           (REG_HDCP_DUAL_P1_BASE + 0x8F)
#define REG_HDCP_DUAL_P1_48_L           (REG_HDCP_DUAL_P1_BASE + 0x90)
#define REG_HDCP_DUAL_P1_48_H           (REG_HDCP_DUAL_P1_BASE + 0x91)
#define REG_HDCP_DUAL_P1_49_L           (REG_HDCP_DUAL_P1_BASE + 0x92)
#define REG_HDCP_DUAL_P1_49_H           (REG_HDCP_DUAL_P1_BASE + 0x93)
#define REG_HDCP_DUAL_P1_4A_L           (REG_HDCP_DUAL_P1_BASE + 0x94)
#define REG_HDCP_DUAL_P1_4A_H           (REG_HDCP_DUAL_P1_BASE + 0x95)
#define REG_HDCP_DUAL_P1_4B_L           (REG_HDCP_DUAL_P1_BASE + 0x96)
#define REG_HDCP_DUAL_P1_4B_H           (REG_HDCP_DUAL_P1_BASE + 0x97)
#define REG_HDCP_DUAL_P1_4C_L           (REG_HDCP_DUAL_P1_BASE + 0x98)
#define REG_HDCP_DUAL_P1_4C_H           (REG_HDCP_DUAL_P1_BASE + 0x99)
#define REG_HDCP_DUAL_P1_4D_L           (REG_HDCP_DUAL_P1_BASE + 0x9A)
#define REG_HDCP_DUAL_P1_4D_H           (REG_HDCP_DUAL_P1_BASE + 0x9B)
#define REG_HDCP_DUAL_P1_4E_L           (REG_HDCP_DUAL_P1_BASE + 0x9C)
#define REG_HDCP_DUAL_P1_4E_H           (REG_HDCP_DUAL_P1_BASE + 0x9D)
#define REG_HDCP_DUAL_P1_4F_L           (REG_HDCP_DUAL_P1_BASE + 0x9E)
#define REG_HDCP_DUAL_P1_4F_H           (REG_HDCP_DUAL_P1_BASE + 0x9F)
#define REG_HDCP_DUAL_P1_50_L           (REG_HDCP_DUAL_P1_BASE + 0xA0)
#define REG_HDCP_DUAL_P1_50_H           (REG_HDCP_DUAL_P1_BASE + 0xA1)
#define REG_HDCP_DUAL_P1_51_L           (REG_HDCP_DUAL_P1_BASE + 0xA2)
#define REG_HDCP_DUAL_P1_51_H           (REG_HDCP_DUAL_P1_BASE + 0xA3)
#define REG_HDCP_DUAL_P1_52_L           (REG_HDCP_DUAL_P1_BASE + 0xA4)
#define REG_HDCP_DUAL_P1_52_H           (REG_HDCP_DUAL_P1_BASE + 0xA5)
#define REG_HDCP_DUAL_P1_53_L           (REG_HDCP_DUAL_P1_BASE + 0xA6)
#define REG_HDCP_DUAL_P1_53_H           (REG_HDCP_DUAL_P1_BASE + 0xA7)
#define REG_HDCP_DUAL_P1_54_L           (REG_HDCP_DUAL_P1_BASE + 0xA8)
#define REG_HDCP_DUAL_P1_54_H           (REG_HDCP_DUAL_P1_BASE + 0xA9)
#define REG_HDCP_DUAL_P1_55_L           (REG_HDCP_DUAL_P1_BASE + 0xAA)
#define REG_HDCP_DUAL_P1_55_H           (REG_HDCP_DUAL_P1_BASE + 0xAB)
#define REG_HDCP_DUAL_P1_56_L           (REG_HDCP_DUAL_P1_BASE + 0xAC)
#define REG_HDCP_DUAL_P1_56_H           (REG_HDCP_DUAL_P1_BASE + 0xAD)
#define REG_HDCP_DUAL_P1_57_L           (REG_HDCP_DUAL_P1_BASE + 0xAE)
#define REG_HDCP_DUAL_P1_57_H           (REG_HDCP_DUAL_P1_BASE + 0xAF)
#define REG_HDCP_DUAL_P1_58_L           (REG_HDCP_DUAL_P1_BASE + 0xB0)
#define REG_HDCP_DUAL_P1_58_H           (REG_HDCP_DUAL_P1_BASE + 0xB1)
#define REG_HDCP_DUAL_P1_59_L           (REG_HDCP_DUAL_P1_BASE + 0xB2)
#define REG_HDCP_DUAL_P1_59_H           (REG_HDCP_DUAL_P1_BASE + 0xB3)
#define REG_HDCP_DUAL_P1_5A_L           (REG_HDCP_DUAL_P1_BASE + 0xB4)
#define REG_HDCP_DUAL_P1_5A_H           (REG_HDCP_DUAL_P1_BASE + 0xB5)
#define REG_HDCP_DUAL_P1_5B_L           (REG_HDCP_DUAL_P1_BASE + 0xB6)
#define REG_HDCP_DUAL_P1_5B_H           (REG_HDCP_DUAL_P1_BASE + 0xB7)
#define REG_HDCP_DUAL_P1_5C_L           (REG_HDCP_DUAL_P1_BASE + 0xB8)
#define REG_HDCP_DUAL_P1_5C_H           (REG_HDCP_DUAL_P1_BASE + 0xB9)
#define REG_HDCP_DUAL_P1_5D_L           (REG_HDCP_DUAL_P1_BASE + 0xBA)
#define REG_HDCP_DUAL_P1_5D_H           (REG_HDCP_DUAL_P1_BASE + 0xBB)
#define REG_HDCP_DUAL_P1_5E_L           (REG_HDCP_DUAL_P1_BASE + 0xBC)
#define REG_HDCP_DUAL_P1_5E_H           (REG_HDCP_DUAL_P1_BASE + 0xBD)
#define REG_HDCP_DUAL_P1_5F_L           (REG_HDCP_DUAL_P1_BASE + 0xBE)
#define REG_HDCP_DUAL_P1_5F_H           (REG_HDCP_DUAL_P1_BASE + 0xBF)
#define REG_HDCP_DUAL_P1_60_L           (REG_HDCP_DUAL_P1_BASE + 0xC0)
#define REG_HDCP_DUAL_P1_60_H           (REG_HDCP_DUAL_P1_BASE + 0xC1)
#define REG_HDCP_DUAL_P1_61_L           (REG_HDCP_DUAL_P1_BASE + 0xC2)
#define REG_HDCP_DUAL_P1_61_H           (REG_HDCP_DUAL_P1_BASE + 0xC3)
#define REG_HDCP_DUAL_P1_62_L           (REG_HDCP_DUAL_P1_BASE + 0xC4)
#define REG_HDCP_DUAL_P1_62_H           (REG_HDCP_DUAL_P1_BASE + 0xC5)
#define REG_HDCP_DUAL_P1_63_L           (REG_HDCP_DUAL_P1_BASE + 0xC6)
#define REG_HDCP_DUAL_P1_63_H           (REG_HDCP_DUAL_P1_BASE + 0xC7)
#define REG_HDCP_DUAL_P1_64_L           (REG_HDCP_DUAL_P1_BASE + 0xC8)
#define REG_HDCP_DUAL_P1_64_H           (REG_HDCP_DUAL_P1_BASE + 0xC9)
#define REG_HDCP_DUAL_P1_65_L           (REG_HDCP_DUAL_P1_BASE + 0xCA)
#define REG_HDCP_DUAL_P1_65_H           (REG_HDCP_DUAL_P1_BASE + 0xCB)
#define REG_HDCP_DUAL_P1_66_L           (REG_HDCP_DUAL_P1_BASE + 0xCC)
#define REG_HDCP_DUAL_P1_66_H           (REG_HDCP_DUAL_P1_BASE + 0xCD)
#define REG_HDCP_DUAL_P1_67_L           (REG_HDCP_DUAL_P1_BASE + 0xCE)
#define REG_HDCP_DUAL_P1_67_H           (REG_HDCP_DUAL_P1_BASE + 0xCF)
#define REG_HDCP_DUAL_P1_68_L           (REG_HDCP_DUAL_P1_BASE + 0xD0)
#define REG_HDCP_DUAL_P1_68_H           (REG_HDCP_DUAL_P1_BASE + 0xD1)
#define REG_HDCP_DUAL_P1_69_L           (REG_HDCP_DUAL_P1_BASE + 0xD2)
#define REG_HDCP_DUAL_P1_69_H           (REG_HDCP_DUAL_P1_BASE + 0xD3)
#define REG_HDCP_DUAL_P1_6A_L           (REG_HDCP_DUAL_P1_BASE + 0xD4)
#define REG_HDCP_DUAL_P1_6A_H           (REG_HDCP_DUAL_P1_BASE + 0xD5)
#define REG_HDCP_DUAL_P1_6B_L           (REG_HDCP_DUAL_P1_BASE + 0xD6)
#define REG_HDCP_DUAL_P1_6B_H           (REG_HDCP_DUAL_P1_BASE + 0xD7)
#define REG_HDCP_DUAL_P1_6C_L           (REG_HDCP_DUAL_P1_BASE + 0xD8)
#define REG_HDCP_DUAL_P1_6C_H           (REG_HDCP_DUAL_P1_BASE + 0xD9)
#define REG_HDCP_DUAL_P1_6D_L           (REG_HDCP_DUAL_P1_BASE + 0xDA)
#define REG_HDCP_DUAL_P1_6D_H           (REG_HDCP_DUAL_P1_BASE + 0xDB)
#define REG_HDCP_DUAL_P1_6E_L           (REG_HDCP_DUAL_P1_BASE + 0xDC)
#define REG_HDCP_DUAL_P1_6E_H           (REG_HDCP_DUAL_P1_BASE + 0xDD)
#define REG_HDCP_DUAL_P1_6F_L           (REG_HDCP_DUAL_P1_BASE + 0xDE)
#define REG_HDCP_DUAL_P1_6F_H           (REG_HDCP_DUAL_P1_BASE + 0xDF)
#define REG_HDCP_DUAL_P1_70_L           (REG_HDCP_DUAL_P1_BASE + 0xE0)
#define REG_HDCP_DUAL_P1_70_H           (REG_HDCP_DUAL_P1_BASE + 0xE1)
#define REG_HDCP_DUAL_P1_71_L           (REG_HDCP_DUAL_P1_BASE + 0xE2)
#define REG_HDCP_DUAL_P1_71_H           (REG_HDCP_DUAL_P1_BASE + 0xE3)
#define REG_HDCP_DUAL_P1_72_L           (REG_HDCP_DUAL_P1_BASE + 0xE4)
#define REG_HDCP_DUAL_P1_72_H           (REG_HDCP_DUAL_P1_BASE + 0xE5)
#define REG_HDCP_DUAL_P1_73_L           (REG_HDCP_DUAL_P1_BASE + 0xE6)
#define REG_HDCP_DUAL_P1_73_H           (REG_HDCP_DUAL_P1_BASE + 0xE7)
#define REG_HDCP_DUAL_P1_74_L           (REG_HDCP_DUAL_P1_BASE + 0xE8)
#define REG_HDCP_DUAL_P1_74_H           (REG_HDCP_DUAL_P1_BASE + 0xE9)
#define REG_HDCP_DUAL_P1_75_L           (REG_HDCP_DUAL_P1_BASE + 0xEA)
#define REG_HDCP_DUAL_P1_75_H           (REG_HDCP_DUAL_P1_BASE + 0xEB)
#define REG_HDCP_DUAL_P1_76_L           (REG_HDCP_DUAL_P1_BASE + 0xEC)
#define REG_HDCP_DUAL_P1_76_H           (REG_HDCP_DUAL_P1_BASE + 0xED)
#define REG_HDCP_DUAL_P1_77_L           (REG_HDCP_DUAL_P1_BASE + 0xEE)
#define REG_HDCP_DUAL_P1_77_H           (REG_HDCP_DUAL_P1_BASE + 0xEF)
#define REG_HDCP_DUAL_P1_78_L           (REG_HDCP_DUAL_P1_BASE + 0xF0)
#define REG_HDCP_DUAL_P1_78_H           (REG_HDCP_DUAL_P1_BASE + 0xF1)
#define REG_HDCP_DUAL_P1_79_L           (REG_HDCP_DUAL_P1_BASE + 0xF2)
#define REG_HDCP_DUAL_P1_79_H           (REG_HDCP_DUAL_P1_BASE + 0xF3)
#define REG_HDCP_DUAL_P1_7A_L           (REG_HDCP_DUAL_P1_BASE + 0xF4)
#define REG_HDCP_DUAL_P1_7A_H           (REG_HDCP_DUAL_P1_BASE + 0xF5)
#define REG_HDCP_DUAL_P1_7B_L           (REG_HDCP_DUAL_P1_BASE + 0xF6)
#define REG_HDCP_DUAL_P1_7B_H           (REG_HDCP_DUAL_P1_BASE + 0xF7)
#define REG_HDCP_DUAL_P1_7C_L           (REG_HDCP_DUAL_P1_BASE + 0xF8)
#define REG_HDCP_DUAL_P1_7C_H           (REG_HDCP_DUAL_P1_BASE + 0xF9)
#define REG_HDCP_DUAL_P1_7D_L           (REG_HDCP_DUAL_P1_BASE + 0xFA)
#define REG_HDCP_DUAL_P1_7D_H           (REG_HDCP_DUAL_P1_BASE + 0xFB)
#define REG_HDCP_DUAL_P1_7E_L           (REG_HDCP_DUAL_P1_BASE + 0xFC)
#define REG_HDCP_DUAL_P1_7E_H           (REG_HDCP_DUAL_P1_BASE + 0xFD)
#define REG_HDCP_DUAL_P1_7F_L           (REG_HDCP_DUAL_P1_BASE + 0xFE)
#define REG_HDCP_DUAL_P1_7F_H           (REG_HDCP_DUAL_P1_BASE + 0xFF)

//=============================================================
// HDMIRX_DTOP_PKT_P1
#define REG_HDMIRX_DTOP_PKT_P1_00_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x00)
#define REG_HDMIRX_DTOP_PKT_P1_00_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x01)
#define REG_HDMIRX_DTOP_PKT_P1_01_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x02)
#define REG_HDMIRX_DTOP_PKT_P1_01_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x03)
#define REG_HDMIRX_DTOP_PKT_P1_02_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x04)
#define REG_HDMIRX_DTOP_PKT_P1_02_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x05)
#define REG_HDMIRX_DTOP_PKT_P1_03_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x06)
#define REG_HDMIRX_DTOP_PKT_P1_03_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x07)
#define REG_HDMIRX_DTOP_PKT_P1_04_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x08)
#define REG_HDMIRX_DTOP_PKT_P1_04_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x09)
#define REG_HDMIRX_DTOP_PKT_P1_05_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x0A)
#define REG_HDMIRX_DTOP_PKT_P1_05_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x0B)
#define REG_HDMIRX_DTOP_PKT_P1_06_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x0C)
#define REG_HDMIRX_DTOP_PKT_P1_06_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x0D)
#define REG_HDMIRX_DTOP_PKT_P1_07_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x0E)
#define REG_HDMIRX_DTOP_PKT_P1_07_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x0F)
#define REG_HDMIRX_DTOP_PKT_P1_08_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x10)
#define REG_HDMIRX_DTOP_PKT_P1_08_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x11)
#define REG_HDMIRX_DTOP_PKT_P1_09_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x12)
#define REG_HDMIRX_DTOP_PKT_P1_09_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x13)
#define REG_HDMIRX_DTOP_PKT_P1_0A_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x14)
#define REG_HDMIRX_DTOP_PKT_P1_0A_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x15)
#define REG_HDMIRX_DTOP_PKT_P1_0B_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x16)
#define REG_HDMIRX_DTOP_PKT_P1_0B_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x17)
#define REG_HDMIRX_DTOP_PKT_P1_0C_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x18)
#define REG_HDMIRX_DTOP_PKT_P1_0C_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x19)
#define REG_HDMIRX_DTOP_PKT_P1_0D_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x1A)
#define REG_HDMIRX_DTOP_PKT_P1_0D_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x1B)
#define REG_HDMIRX_DTOP_PKT_P1_0E_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x1C)
#define REG_HDMIRX_DTOP_PKT_P1_0E_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x1D)
#define REG_HDMIRX_DTOP_PKT_P1_0F_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x1E)
#define REG_HDMIRX_DTOP_PKT_P1_0F_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x1F)
#define REG_HDMIRX_DTOP_PKT_P1_10_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x20)
#define REG_HDMIRX_DTOP_PKT_P1_10_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x21)
#define REG_HDMIRX_DTOP_PKT_P1_11_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x22)
#define REG_HDMIRX_DTOP_PKT_P1_11_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x23)
#define REG_HDMIRX_DTOP_PKT_P1_12_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x24)
#define REG_HDMIRX_DTOP_PKT_P1_12_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x25)
#define REG_HDMIRX_DTOP_PKT_P1_13_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x26)
#define REG_HDMIRX_DTOP_PKT_P1_13_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x27)
#define REG_HDMIRX_DTOP_PKT_P1_14_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x28)
#define REG_HDMIRX_DTOP_PKT_P1_14_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x29)
#define REG_HDMIRX_DTOP_PKT_P1_15_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x2A)
#define REG_HDMIRX_DTOP_PKT_P1_15_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x2B)
#define REG_HDMIRX_DTOP_PKT_P1_16_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x2C)
#define REG_HDMIRX_DTOP_PKT_P1_16_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x2D)
#define REG_HDMIRX_DTOP_PKT_P1_17_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x2E)
#define REG_HDMIRX_DTOP_PKT_P1_17_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x2F)
#define REG_HDMIRX_DTOP_PKT_P1_18_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x30)
#define REG_HDMIRX_DTOP_PKT_P1_18_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x31)
#define REG_HDMIRX_DTOP_PKT_P1_19_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x32)
#define REG_HDMIRX_DTOP_PKT_P1_19_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x33)
#define REG_HDMIRX_DTOP_PKT_P1_1A_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x34)
#define REG_HDMIRX_DTOP_PKT_P1_1A_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x35)
#define REG_HDMIRX_DTOP_PKT_P1_1B_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x36)
#define REG_HDMIRX_DTOP_PKT_P1_1B_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x37)
#define REG_HDMIRX_DTOP_PKT_P1_1C_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x38)
#define REG_HDMIRX_DTOP_PKT_P1_1C_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x39)
#define REG_HDMIRX_DTOP_PKT_P1_1D_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x3A)
#define REG_HDMIRX_DTOP_PKT_P1_1D_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x3B)
#define REG_HDMIRX_DTOP_PKT_P1_1E_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x3C)
#define REG_HDMIRX_DTOP_PKT_P1_1E_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x3D)
#define REG_HDMIRX_DTOP_PKT_P1_1F_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x3E)
#define REG_HDMIRX_DTOP_PKT_P1_1F_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x3F)
#define REG_HDMIRX_DTOP_PKT_P1_20_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x40)
#define REG_HDMIRX_DTOP_PKT_P1_20_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x41)
#define REG_HDMIRX_DTOP_PKT_P1_21_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x42)
#define REG_HDMIRX_DTOP_PKT_P1_21_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x43)
#define REG_HDMIRX_DTOP_PKT_P1_22_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x44)
#define REG_HDMIRX_DTOP_PKT_P1_22_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x45)
#define REG_HDMIRX_DTOP_PKT_P1_23_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x46)
#define REG_HDMIRX_DTOP_PKT_P1_23_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x47)
#define REG_HDMIRX_DTOP_PKT_P1_24_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x48)
#define REG_HDMIRX_DTOP_PKT_P1_24_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x49)
#define REG_HDMIRX_DTOP_PKT_P1_25_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x4A)
#define REG_HDMIRX_DTOP_PKT_P1_25_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x4B)
#define REG_HDMIRX_DTOP_PKT_P1_26_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x4C)
#define REG_HDMIRX_DTOP_PKT_P1_26_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x4D)
#define REG_HDMIRX_DTOP_PKT_P1_27_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x4E)
#define REG_HDMIRX_DTOP_PKT_P1_27_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x4F)
#define REG_HDMIRX_DTOP_PKT_P1_28_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x50)
#define REG_HDMIRX_DTOP_PKT_P1_28_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x51)
#define REG_HDMIRX_DTOP_PKT_P1_29_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x52)
#define REG_HDMIRX_DTOP_PKT_P1_29_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x53)
#define REG_HDMIRX_DTOP_PKT_P1_2A_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x54)
#define REG_HDMIRX_DTOP_PKT_P1_2A_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x55)
#define REG_HDMIRX_DTOP_PKT_P1_2B_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x56)
#define REG_HDMIRX_DTOP_PKT_P1_2B_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x57)
#define REG_HDMIRX_DTOP_PKT_P1_2C_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x58)
#define REG_HDMIRX_DTOP_PKT_P1_2C_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x59)
#define REG_HDMIRX_DTOP_PKT_P1_2D_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x5A)
#define REG_HDMIRX_DTOP_PKT_P1_2D_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x5B)
#define REG_HDMIRX_DTOP_PKT_P1_2E_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x5C)
#define REG_HDMIRX_DTOP_PKT_P1_2E_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x5D)
#define REG_HDMIRX_DTOP_PKT_P1_2F_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x5E)
#define REG_HDMIRX_DTOP_PKT_P1_2F_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x5F)
#define REG_HDMIRX_DTOP_PKT_P1_30_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x60)
#define REG_HDMIRX_DTOP_PKT_P1_30_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x61)
#define REG_HDMIRX_DTOP_PKT_P1_31_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x62)
#define REG_HDMIRX_DTOP_PKT_P1_31_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x63)
#define REG_HDMIRX_DTOP_PKT_P1_32_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x64)
#define REG_HDMIRX_DTOP_PKT_P1_32_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x65)
#define REG_HDMIRX_DTOP_PKT_P1_33_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x66)
#define REG_HDMIRX_DTOP_PKT_P1_33_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x67)
#define REG_HDMIRX_DTOP_PKT_P1_34_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x68)
#define REG_HDMIRX_DTOP_PKT_P1_34_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x69)
#define REG_HDMIRX_DTOP_PKT_P1_35_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x6A)
#define REG_HDMIRX_DTOP_PKT_P1_35_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x6B)
#define REG_HDMIRX_DTOP_PKT_P1_36_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x6C)
#define REG_HDMIRX_DTOP_PKT_P1_36_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x6D)
#define REG_HDMIRX_DTOP_PKT_P1_37_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x6E)
#define REG_HDMIRX_DTOP_PKT_P1_37_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x6F)
#define REG_HDMIRX_DTOP_PKT_P1_38_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x70)
#define REG_HDMIRX_DTOP_PKT_P1_38_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x71)
#define REG_HDMIRX_DTOP_PKT_P1_39_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x72)
#define REG_HDMIRX_DTOP_PKT_P1_39_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x73)
#define REG_HDMIRX_DTOP_PKT_P1_3A_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x74)
#define REG_HDMIRX_DTOP_PKT_P1_3A_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x75)
#define REG_HDMIRX_DTOP_PKT_P1_3B_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x76)
#define REG_HDMIRX_DTOP_PKT_P1_3B_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x77)
#define REG_HDMIRX_DTOP_PKT_P1_3C_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x78)
#define REG_HDMIRX_DTOP_PKT_P1_3C_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x79)
#define REG_HDMIRX_DTOP_PKT_P1_3D_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x7A)
#define REG_HDMIRX_DTOP_PKT_P1_3D_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x7B)
#define REG_HDMIRX_DTOP_PKT_P1_3E_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x7C)
#define REG_HDMIRX_DTOP_PKT_P1_3E_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x7D)
#define REG_HDMIRX_DTOP_PKT_P1_3F_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x7E)
#define REG_HDMIRX_DTOP_PKT_P1_3F_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x7F)
#define REG_HDMIRX_DTOP_PKT_P1_40_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x80)
#define REG_HDMIRX_DTOP_PKT_P1_40_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x81)
#define REG_HDMIRX_DTOP_PKT_P1_41_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x82)
#define REG_HDMIRX_DTOP_PKT_P1_41_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x83)
#define REG_HDMIRX_DTOP_PKT_P1_42_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x84)
#define REG_HDMIRX_DTOP_PKT_P1_42_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x85)
#define REG_HDMIRX_DTOP_PKT_P1_43_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x86)
#define REG_HDMIRX_DTOP_PKT_P1_43_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x87)
#define REG_HDMIRX_DTOP_PKT_P1_44_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x88)
#define REG_HDMIRX_DTOP_PKT_P1_44_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x89)
#define REG_HDMIRX_DTOP_PKT_P1_45_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x8A)
#define REG_HDMIRX_DTOP_PKT_P1_45_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x8B)
#define REG_HDMIRX_DTOP_PKT_P1_46_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x8C)
#define REG_HDMIRX_DTOP_PKT_P1_46_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x8D)
#define REG_HDMIRX_DTOP_PKT_P1_47_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x8E)
#define REG_HDMIRX_DTOP_PKT_P1_47_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x8F)
#define REG_HDMIRX_DTOP_PKT_P1_48_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x90)
#define REG_HDMIRX_DTOP_PKT_P1_48_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x91)
#define REG_HDMIRX_DTOP_PKT_P1_49_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x92)
#define REG_HDMIRX_DTOP_PKT_P1_49_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x93)
#define REG_HDMIRX_DTOP_PKT_P1_4A_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x94)
#define REG_HDMIRX_DTOP_PKT_P1_4A_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x95)
#define REG_HDMIRX_DTOP_PKT_P1_4B_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x96)
#define REG_HDMIRX_DTOP_PKT_P1_4B_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x97)
#define REG_HDMIRX_DTOP_PKT_P1_4C_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x98)
#define REG_HDMIRX_DTOP_PKT_P1_4C_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x99)
#define REG_HDMIRX_DTOP_PKT_P1_4D_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x9A)
#define REG_HDMIRX_DTOP_PKT_P1_4D_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x9B)
#define REG_HDMIRX_DTOP_PKT_P1_4E_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x9C)
#define REG_HDMIRX_DTOP_PKT_P1_4E_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x9D)
#define REG_HDMIRX_DTOP_PKT_P1_4F_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x9E)
#define REG_HDMIRX_DTOP_PKT_P1_4F_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0x9F)
#define REG_HDMIRX_DTOP_PKT_P1_50_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xA0)
#define REG_HDMIRX_DTOP_PKT_P1_50_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xA1)
#define REG_HDMIRX_DTOP_PKT_P1_51_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xA2)
#define REG_HDMIRX_DTOP_PKT_P1_51_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xA3)
#define REG_HDMIRX_DTOP_PKT_P1_52_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xA4)
#define REG_HDMIRX_DTOP_PKT_P1_52_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xA5)
#define REG_HDMIRX_DTOP_PKT_P1_53_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xA6)
#define REG_HDMIRX_DTOP_PKT_P1_53_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xA7)
#define REG_HDMIRX_DTOP_PKT_P1_54_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xA8)
#define REG_HDMIRX_DTOP_PKT_P1_54_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xA9)
#define REG_HDMIRX_DTOP_PKT_P1_55_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xAA)
#define REG_HDMIRX_DTOP_PKT_P1_55_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xAB)
#define REG_HDMIRX_DTOP_PKT_P1_56_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xAC)
#define REG_HDMIRX_DTOP_PKT_P1_56_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xAD)
#define REG_HDMIRX_DTOP_PKT_P1_57_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xAE)
#define REG_HDMIRX_DTOP_PKT_P1_57_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xAF)
#define REG_HDMIRX_DTOP_PKT_P1_58_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xB0)
#define REG_HDMIRX_DTOP_PKT_P1_58_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xB1)
#define REG_HDMIRX_DTOP_PKT_P1_59_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xB2)
#define REG_HDMIRX_DTOP_PKT_P1_59_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xB3)
#define REG_HDMIRX_DTOP_PKT_P1_5A_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xB4)
#define REG_HDMIRX_DTOP_PKT_P1_5A_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xB5)
#define REG_HDMIRX_DTOP_PKT_P1_5B_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xB6)
#define REG_HDMIRX_DTOP_PKT_P1_5B_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xB7)
#define REG_HDMIRX_DTOP_PKT_P1_5C_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xB8)
#define REG_HDMIRX_DTOP_PKT_P1_5C_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xB9)
#define REG_HDMIRX_DTOP_PKT_P1_5D_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xBA)
#define REG_HDMIRX_DTOP_PKT_P1_5D_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xBB)
#define REG_HDMIRX_DTOP_PKT_P1_5E_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xBC)
#define REG_HDMIRX_DTOP_PKT_P1_5E_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xBD)
#define REG_HDMIRX_DTOP_PKT_P1_5F_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xBE)
#define REG_HDMIRX_DTOP_PKT_P1_5F_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xBF)
#define REG_HDMIRX_DTOP_PKT_P1_60_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xC0)
#define REG_HDMIRX_DTOP_PKT_P1_60_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xC1)
#define REG_HDMIRX_DTOP_PKT_P1_61_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xC2)
#define REG_HDMIRX_DTOP_PKT_P1_61_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xC3)
#define REG_HDMIRX_DTOP_PKT_P1_62_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xC4)
#define REG_HDMIRX_DTOP_PKT_P1_62_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xC5)
#define REG_HDMIRX_DTOP_PKT_P1_63_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xC6)
#define REG_HDMIRX_DTOP_PKT_P1_63_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xC7)
#define REG_HDMIRX_DTOP_PKT_P1_64_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xC8)
#define REG_HDMIRX_DTOP_PKT_P1_64_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xC9)
#define REG_HDMIRX_DTOP_PKT_P1_65_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xCA)
#define REG_HDMIRX_DTOP_PKT_P1_65_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xCB)
#define REG_HDMIRX_DTOP_PKT_P1_66_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xCC)
#define REG_HDMIRX_DTOP_PKT_P1_66_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xCD)
#define REG_HDMIRX_DTOP_PKT_P1_67_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xCE)
#define REG_HDMIRX_DTOP_PKT_P1_67_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xCF)
#define REG_HDMIRX_DTOP_PKT_P1_68_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xD0)
#define REG_HDMIRX_DTOP_PKT_P1_68_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xD1)
#define REG_HDMIRX_DTOP_PKT_P1_69_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xD2)
#define REG_HDMIRX_DTOP_PKT_P1_69_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xD3)
#define REG_HDMIRX_DTOP_PKT_P1_6A_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xD4)
#define REG_HDMIRX_DTOP_PKT_P1_6A_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xD5)
#define REG_HDMIRX_DTOP_PKT_P1_6B_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xD6)
#define REG_HDMIRX_DTOP_PKT_P1_6B_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xD7)
#define REG_HDMIRX_DTOP_PKT_P1_6C_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xD8)
#define REG_HDMIRX_DTOP_PKT_P1_6C_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xD9)
#define REG_HDMIRX_DTOP_PKT_P1_6D_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xDA)
#define REG_HDMIRX_DTOP_PKT_P1_6D_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xDB)
#define REG_HDMIRX_DTOP_PKT_P1_6E_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xDC)
#define REG_HDMIRX_DTOP_PKT_P1_6E_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xDD)
#define REG_HDMIRX_DTOP_PKT_P1_6F_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xDE)
#define REG_HDMIRX_DTOP_PKT_P1_6F_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xDF)
#define REG_HDMIRX_DTOP_PKT_P1_70_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xE0)
#define REG_HDMIRX_DTOP_PKT_P1_70_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xE1)
#define REG_HDMIRX_DTOP_PKT_P1_71_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xE2)
#define REG_HDMIRX_DTOP_PKT_P1_71_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xE3)
#define REG_HDMIRX_DTOP_PKT_P1_72_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xE4)
#define REG_HDMIRX_DTOP_PKT_P1_72_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xE5)
#define REG_HDMIRX_DTOP_PKT_P1_73_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xE6)
#define REG_HDMIRX_DTOP_PKT_P1_73_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xE7)
#define REG_HDMIRX_DTOP_PKT_P1_74_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xE8)
#define REG_HDMIRX_DTOP_PKT_P1_74_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xE9)
#define REG_HDMIRX_DTOP_PKT_P1_75_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xEA)
#define REG_HDMIRX_DTOP_PKT_P1_75_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xEB)
#define REG_HDMIRX_DTOP_PKT_P1_76_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xEC)
#define REG_HDMIRX_DTOP_PKT_P1_76_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xED)
#define REG_HDMIRX_DTOP_PKT_P1_77_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xEE)
#define REG_HDMIRX_DTOP_PKT_P1_77_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xEF)
#define REG_HDMIRX_DTOP_PKT_P1_78_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xF0)
#define REG_HDMIRX_DTOP_PKT_P1_78_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xF1)
#define REG_HDMIRX_DTOP_PKT_P1_79_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xF2)
#define REG_HDMIRX_DTOP_PKT_P1_79_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xF3)
#define REG_HDMIRX_DTOP_PKT_P1_7A_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xF4)
#define REG_HDMIRX_DTOP_PKT_P1_7A_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xF5)
#define REG_HDMIRX_DTOP_PKT_P1_7B_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xF6)
#define REG_HDMIRX_DTOP_PKT_P1_7B_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xF7)
#define REG_HDMIRX_DTOP_PKT_P1_7C_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xF8)
#define REG_HDMIRX_DTOP_PKT_P1_7C_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xF9)
#define REG_HDMIRX_DTOP_PKT_P1_7D_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xFA)
#define REG_HDMIRX_DTOP_PKT_P1_7D_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xFB)
#define REG_HDMIRX_DTOP_PKT_P1_7E_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xFC)
#define REG_HDMIRX_DTOP_PKT_P1_7E_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xFD)
#define REG_HDMIRX_DTOP_PKT_P1_7F_L           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xFE)
#define REG_HDMIRX_DTOP_PKT_P1_7F_H           (REG_HDMIRX_DTOP_PKT_P1_BASE + 0xFF)

//=============================================================
// DVI_DTOP_DUAL_P2
#define REG_DVI_DTOP_DUAL_P2_00_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x00)
#define REG_DVI_DTOP_DUAL_P2_00_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x01)
#define REG_DVI_DTOP_DUAL_P2_01_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x02)
#define REG_DVI_DTOP_DUAL_P2_01_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x03)
#define REG_DVI_DTOP_DUAL_P2_02_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x04)
#define REG_DVI_DTOP_DUAL_P2_02_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x05)
#define REG_DVI_DTOP_DUAL_P2_03_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x06)
#define REG_DVI_DTOP_DUAL_P2_03_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x07)
#define REG_DVI_DTOP_DUAL_P2_04_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x08)
#define REG_DVI_DTOP_DUAL_P2_04_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x09)
#define REG_DVI_DTOP_DUAL_P2_05_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x0A)
#define REG_DVI_DTOP_DUAL_P2_05_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x0B)
#define REG_DVI_DTOP_DUAL_P2_06_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x0C)
#define REG_DVI_DTOP_DUAL_P2_06_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x0D)
#define REG_DVI_DTOP_DUAL_P2_07_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x0E)
#define REG_DVI_DTOP_DUAL_P2_07_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x0F)
#define REG_DVI_DTOP_DUAL_P2_08_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x10)
#define REG_DVI_DTOP_DUAL_P2_08_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x11)
#define REG_DVI_DTOP_DUAL_P2_09_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x12)
#define REG_DVI_DTOP_DUAL_P2_09_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x13)
#define REG_DVI_DTOP_DUAL_P2_0A_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x14)
#define REG_DVI_DTOP_DUAL_P2_0A_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x15)
#define REG_DVI_DTOP_DUAL_P2_0B_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x16)
#define REG_DVI_DTOP_DUAL_P2_0B_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x17)
#define REG_DVI_DTOP_DUAL_P2_0C_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x18)
#define REG_DVI_DTOP_DUAL_P2_0C_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x19)
#define REG_DVI_DTOP_DUAL_P2_0D_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x1A)
#define REG_DVI_DTOP_DUAL_P2_0D_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x1B)
#define REG_DVI_DTOP_DUAL_P2_0E_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x1C)
#define REG_DVI_DTOP_DUAL_P2_0E_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x1D)
#define REG_DVI_DTOP_DUAL_P2_0F_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x1E)
#define REG_DVI_DTOP_DUAL_P2_0F_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x1F)
#define REG_DVI_DTOP_DUAL_P2_10_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x20)
#define REG_DVI_DTOP_DUAL_P2_10_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x21)
#define REG_DVI_DTOP_DUAL_P2_11_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x22)
#define REG_DVI_DTOP_DUAL_P2_11_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x23)
#define REG_DVI_DTOP_DUAL_P2_12_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x24)
#define REG_DVI_DTOP_DUAL_P2_12_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x25)
#define REG_DVI_DTOP_DUAL_P2_13_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x26)
#define REG_DVI_DTOP_DUAL_P2_13_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x27)
#define REG_DVI_DTOP_DUAL_P2_14_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x28)
#define REG_DVI_DTOP_DUAL_P2_14_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x29)
#define REG_DVI_DTOP_DUAL_P2_15_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x2A)
#define REG_DVI_DTOP_DUAL_P2_15_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x2B)
#define REG_DVI_DTOP_DUAL_P2_16_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x2C)
#define REG_DVI_DTOP_DUAL_P2_16_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x2D)
#define REG_DVI_DTOP_DUAL_P2_17_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x2E)
#define REG_DVI_DTOP_DUAL_P2_17_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x2F)
#define REG_DVI_DTOP_DUAL_P2_18_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x30)
#define REG_DVI_DTOP_DUAL_P2_18_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x31)
#define REG_DVI_DTOP_DUAL_P2_19_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x32)
#define REG_DVI_DTOP_DUAL_P2_19_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x33)
#define REG_DVI_DTOP_DUAL_P2_1A_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x34)
#define REG_DVI_DTOP_DUAL_P2_1A_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x35)
#define REG_DVI_DTOP_DUAL_P2_1B_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x36)
#define REG_DVI_DTOP_DUAL_P2_1B_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x37)
#define REG_DVI_DTOP_DUAL_P2_1C_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x38)
#define REG_DVI_DTOP_DUAL_P2_1C_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x39)
#define REG_DVI_DTOP_DUAL_P2_1D_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x3A)
#define REG_DVI_DTOP_DUAL_P2_1D_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x3B)
#define REG_DVI_DTOP_DUAL_P2_1E_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x3C)
#define REG_DVI_DTOP_DUAL_P2_1E_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x3D)
#define REG_DVI_DTOP_DUAL_P2_1F_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x3E)
#define REG_DVI_DTOP_DUAL_P2_1F_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x3F)
#define REG_DVI_DTOP_DUAL_P2_20_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x40)
#define REG_DVI_DTOP_DUAL_P2_20_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x41)
#define REG_DVI_DTOP_DUAL_P2_21_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x42)
#define REG_DVI_DTOP_DUAL_P2_21_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x43)
#define REG_DVI_DTOP_DUAL_P2_22_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x44)
#define REG_DVI_DTOP_DUAL_P2_22_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x45)
#define REG_DVI_DTOP_DUAL_P2_23_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x46)
#define REG_DVI_DTOP_DUAL_P2_23_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x47)
#define REG_DVI_DTOP_DUAL_P2_24_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x48)
#define REG_DVI_DTOP_DUAL_P2_24_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x49)
#define REG_DVI_DTOP_DUAL_P2_25_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x4A)
#define REG_DVI_DTOP_DUAL_P2_25_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x4B)
#define REG_DVI_DTOP_DUAL_P2_26_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x4C)
#define REG_DVI_DTOP_DUAL_P2_26_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x4D)
#define REG_DVI_DTOP_DUAL_P2_27_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x4E)
#define REG_DVI_DTOP_DUAL_P2_27_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x4F)
#define REG_DVI_DTOP_DUAL_P2_28_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x50)
#define REG_DVI_DTOP_DUAL_P2_28_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x51)
#define REG_DVI_DTOP_DUAL_P2_29_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x52)
#define REG_DVI_DTOP_DUAL_P2_29_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x53)
#define REG_DVI_DTOP_DUAL_P2_2A_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x54)
#define REG_DVI_DTOP_DUAL_P2_2A_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x55)
#define REG_DVI_DTOP_DUAL_P2_2B_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x56)
#define REG_DVI_DTOP_DUAL_P2_2B_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x57)
#define REG_DVI_DTOP_DUAL_P2_2C_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x58)
#define REG_DVI_DTOP_DUAL_P2_2C_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x59)
#define REG_DVI_DTOP_DUAL_P2_2D_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x5A)
#define REG_DVI_DTOP_DUAL_P2_2D_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x5B)
#define REG_DVI_DTOP_DUAL_P2_2E_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x5C)
#define REG_DVI_DTOP_DUAL_P2_2E_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x5D)
#define REG_DVI_DTOP_DUAL_P2_2F_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x5E)
#define REG_DVI_DTOP_DUAL_P2_2F_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x5F)
#define REG_DVI_DTOP_DUAL_P2_30_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x60)
#define REG_DVI_DTOP_DUAL_P2_30_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x61)
#define REG_DVI_DTOP_DUAL_P2_31_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x62)
#define REG_DVI_DTOP_DUAL_P2_31_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x63)
#define REG_DVI_DTOP_DUAL_P2_32_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x64)
#define REG_DVI_DTOP_DUAL_P2_32_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x65)
#define REG_DVI_DTOP_DUAL_P2_33_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x66)
#define REG_DVI_DTOP_DUAL_P2_33_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x67)
#define REG_DVI_DTOP_DUAL_P2_34_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x68)
#define REG_DVI_DTOP_DUAL_P2_34_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x69)
#define REG_DVI_DTOP_DUAL_P2_35_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x6A)
#define REG_DVI_DTOP_DUAL_P2_35_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x6B)
#define REG_DVI_DTOP_DUAL_P2_36_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x6C)
#define REG_DVI_DTOP_DUAL_P2_36_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x6D)
#define REG_DVI_DTOP_DUAL_P2_37_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x6E)
#define REG_DVI_DTOP_DUAL_P2_37_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x6F)
#define REG_DVI_DTOP_DUAL_P2_38_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x70)
#define REG_DVI_DTOP_DUAL_P2_38_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x71)
#define REG_DVI_DTOP_DUAL_P2_39_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x72)
#define REG_DVI_DTOP_DUAL_P2_39_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x73)
#define REG_DVI_DTOP_DUAL_P2_3A_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x74)
#define REG_DVI_DTOP_DUAL_P2_3A_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x75)
#define REG_DVI_DTOP_DUAL_P2_3B_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x76)
#define REG_DVI_DTOP_DUAL_P2_3B_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x77)
#define REG_DVI_DTOP_DUAL_P2_3C_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x78)
#define REG_DVI_DTOP_DUAL_P2_3C_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x79)
#define REG_DVI_DTOP_DUAL_P2_3D_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x7A)
#define REG_DVI_DTOP_DUAL_P2_3D_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x7B)
#define REG_DVI_DTOP_DUAL_P2_3E_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x7C)
#define REG_DVI_DTOP_DUAL_P2_3E_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x7D)
#define REG_DVI_DTOP_DUAL_P2_3F_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x7E)
#define REG_DVI_DTOP_DUAL_P2_3F_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x7F)
#define REG_DVI_DTOP_DUAL_P2_40_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x80)
#define REG_DVI_DTOP_DUAL_P2_40_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x81)
#define REG_DVI_DTOP_DUAL_P2_41_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x82)
#define REG_DVI_DTOP_DUAL_P2_41_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x83)
#define REG_DVI_DTOP_DUAL_P2_42_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x84)
#define REG_DVI_DTOP_DUAL_P2_42_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x85)
#define REG_DVI_DTOP_DUAL_P2_43_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x86)
#define REG_DVI_DTOP_DUAL_P2_43_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x87)
#define REG_DVI_DTOP_DUAL_P2_44_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x88)
#define REG_DVI_DTOP_DUAL_P2_44_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x89)
#define REG_DVI_DTOP_DUAL_P2_45_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x8A)
#define REG_DVI_DTOP_DUAL_P2_45_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x8B)
#define REG_DVI_DTOP_DUAL_P2_46_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x8C)
#define REG_DVI_DTOP_DUAL_P2_46_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x8D)
#define REG_DVI_DTOP_DUAL_P2_47_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x8E)
#define REG_DVI_DTOP_DUAL_P2_47_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x8F)
#define REG_DVI_DTOP_DUAL_P2_48_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x90)
#define REG_DVI_DTOP_DUAL_P2_48_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x91)
#define REG_DVI_DTOP_DUAL_P2_49_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x92)
#define REG_DVI_DTOP_DUAL_P2_49_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x93)
#define REG_DVI_DTOP_DUAL_P2_4A_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x94)
#define REG_DVI_DTOP_DUAL_P2_4A_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x95)
#define REG_DVI_DTOP_DUAL_P2_4B_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x96)
#define REG_DVI_DTOP_DUAL_P2_4B_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x97)
#define REG_DVI_DTOP_DUAL_P2_4C_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x98)
#define REG_DVI_DTOP_DUAL_P2_4C_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x99)
#define REG_DVI_DTOP_DUAL_P2_4D_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x9A)
#define REG_DVI_DTOP_DUAL_P2_4D_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x9B)
#define REG_DVI_DTOP_DUAL_P2_4E_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x9C)
#define REG_DVI_DTOP_DUAL_P2_4E_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x9D)
#define REG_DVI_DTOP_DUAL_P2_4F_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0x9E)
#define REG_DVI_DTOP_DUAL_P2_4F_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0x9F)
#define REG_DVI_DTOP_DUAL_P2_50_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xA0)
#define REG_DVI_DTOP_DUAL_P2_50_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xA1)
#define REG_DVI_DTOP_DUAL_P2_51_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xA2)
#define REG_DVI_DTOP_DUAL_P2_51_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xA3)
#define REG_DVI_DTOP_DUAL_P2_52_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xA4)
#define REG_DVI_DTOP_DUAL_P2_52_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xA5)
#define REG_DVI_DTOP_DUAL_P2_53_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xA6)
#define REG_DVI_DTOP_DUAL_P2_53_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xA7)
#define REG_DVI_DTOP_DUAL_P2_54_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xA8)
#define REG_DVI_DTOP_DUAL_P2_54_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xA9)
#define REG_DVI_DTOP_DUAL_P2_55_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xAA)
#define REG_DVI_DTOP_DUAL_P2_55_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xAB)
#define REG_DVI_DTOP_DUAL_P2_56_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xAC)
#define REG_DVI_DTOP_DUAL_P2_56_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xAD)
#define REG_DVI_DTOP_DUAL_P2_57_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xAE)
#define REG_DVI_DTOP_DUAL_P2_57_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xAF)
#define REG_DVI_DTOP_DUAL_P2_58_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xB0)
#define REG_DVI_DTOP_DUAL_P2_58_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xB1)
#define REG_DVI_DTOP_DUAL_P2_59_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xB2)
#define REG_DVI_DTOP_DUAL_P2_59_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xB3)
#define REG_DVI_DTOP_DUAL_P2_5A_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xB4)
#define REG_DVI_DTOP_DUAL_P2_5A_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xB5)
#define REG_DVI_DTOP_DUAL_P2_5B_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xB6)
#define REG_DVI_DTOP_DUAL_P2_5B_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xB7)
#define REG_DVI_DTOP_DUAL_P2_5C_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xB8)
#define REG_DVI_DTOP_DUAL_P2_5C_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xB9)
#define REG_DVI_DTOP_DUAL_P2_5D_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xBA)
#define REG_DVI_DTOP_DUAL_P2_5D_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xBB)
#define REG_DVI_DTOP_DUAL_P2_5E_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xBC)
#define REG_DVI_DTOP_DUAL_P2_5E_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xBD)
#define REG_DVI_DTOP_DUAL_P2_5F_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xBE)
#define REG_DVI_DTOP_DUAL_P2_5F_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xBF)
#define REG_DVI_DTOP_DUAL_P2_60_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xC0)
#define REG_DVI_DTOP_DUAL_P2_60_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xC1)
#define REG_DVI_DTOP_DUAL_P2_61_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xC2)
#define REG_DVI_DTOP_DUAL_P2_61_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xC3)
#define REG_DVI_DTOP_DUAL_P2_62_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xC4)
#define REG_DVI_DTOP_DUAL_P2_62_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xC5)
#define REG_DVI_DTOP_DUAL_P2_63_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xC6)
#define REG_DVI_DTOP_DUAL_P2_63_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xC7)
#define REG_DVI_DTOP_DUAL_P2_64_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xC8)
#define REG_DVI_DTOP_DUAL_P2_64_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xC9)
#define REG_DVI_DTOP_DUAL_P2_65_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xCA)
#define REG_DVI_DTOP_DUAL_P2_65_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xCB)
#define REG_DVI_DTOP_DUAL_P2_66_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xCC)
#define REG_DVI_DTOP_DUAL_P2_66_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xCD)
#define REG_DVI_DTOP_DUAL_P2_67_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xCE)
#define REG_DVI_DTOP_DUAL_P2_67_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xCF)
#define REG_DVI_DTOP_DUAL_P2_68_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xD0)
#define REG_DVI_DTOP_DUAL_P2_68_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xD1)
#define REG_DVI_DTOP_DUAL_P2_69_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xD2)
#define REG_DVI_DTOP_DUAL_P2_69_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xD3)
#define REG_DVI_DTOP_DUAL_P2_6A_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xD4)
#define REG_DVI_DTOP_DUAL_P2_6A_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xD5)
#define REG_DVI_DTOP_DUAL_P2_6B_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xD6)
#define REG_DVI_DTOP_DUAL_P2_6B_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xD7)
#define REG_DVI_DTOP_DUAL_P2_6C_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xD8)
#define REG_DVI_DTOP_DUAL_P2_6C_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xD9)
#define REG_DVI_DTOP_DUAL_P2_6D_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xDA)
#define REG_DVI_DTOP_DUAL_P2_6D_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xDB)
#define REG_DVI_DTOP_DUAL_P2_6E_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xDC)
#define REG_DVI_DTOP_DUAL_P2_6E_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xDD)
#define REG_DVI_DTOP_DUAL_P2_6F_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xDE)
#define REG_DVI_DTOP_DUAL_P2_6F_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xDF)
#define REG_DVI_DTOP_DUAL_P2_70_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xE0)
#define REG_DVI_DTOP_DUAL_P2_70_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xE1)
#define REG_DVI_DTOP_DUAL_P2_71_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xE2)
#define REG_DVI_DTOP_DUAL_P2_71_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xE3)
#define REG_DVI_DTOP_DUAL_P2_72_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xE4)
#define REG_DVI_DTOP_DUAL_P2_72_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xE5)
#define REG_DVI_DTOP_DUAL_P2_73_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xE6)
#define REG_DVI_DTOP_DUAL_P2_73_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xE7)
#define REG_DVI_DTOP_DUAL_P2_74_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xE8)
#define REG_DVI_DTOP_DUAL_P2_74_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xE9)
#define REG_DVI_DTOP_DUAL_P2_75_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xEA)
#define REG_DVI_DTOP_DUAL_P2_75_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xEB)
#define REG_DVI_DTOP_DUAL_P2_76_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xEC)
#define REG_DVI_DTOP_DUAL_P2_76_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xED)
#define REG_DVI_DTOP_DUAL_P2_77_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xEE)
#define REG_DVI_DTOP_DUAL_P2_77_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xEF)
#define REG_DVI_DTOP_DUAL_P2_78_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xF0)
#define REG_DVI_DTOP_DUAL_P2_78_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xF1)
#define REG_DVI_DTOP_DUAL_P2_79_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xF2)
#define REG_DVI_DTOP_DUAL_P2_79_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xF3)
#define REG_DVI_DTOP_DUAL_P2_7A_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xF4)
#define REG_DVI_DTOP_DUAL_P2_7A_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xF5)
#define REG_DVI_DTOP_DUAL_P2_7B_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xF6)
#define REG_DVI_DTOP_DUAL_P2_7B_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xF7)
#define REG_DVI_DTOP_DUAL_P2_7C_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xF8)
#define REG_DVI_DTOP_DUAL_P2_7C_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xF9)
#define REG_DVI_DTOP_DUAL_P2_7D_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xFA)
#define REG_DVI_DTOP_DUAL_P2_7D_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xFB)
#define REG_DVI_DTOP_DUAL_P2_7E_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xFC)
#define REG_DVI_DTOP_DUAL_P2_7E_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xFD)
#define REG_DVI_DTOP_DUAL_P2_7F_L       (REG_DVI_DTOP_DUAL_P2_BASE + 0xFE)
#define REG_DVI_DTOP_DUAL_P2_7F_H       (REG_DVI_DTOP_DUAL_P2_BASE + 0xFF)

//=============================================================
// DVI_RSV_DUAL_P2
#define REG_DVI_RSV_DUAL_P2_00_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x00)
#define REG_DVI_RSV_DUAL_P2_00_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x01)
#define REG_DVI_RSV_DUAL_P2_01_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x02)
#define REG_DVI_RSV_DUAL_P2_01_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x03)
#define REG_DVI_RSV_DUAL_P2_02_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x04)
#define REG_DVI_RSV_DUAL_P2_02_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x05)
#define REG_DVI_RSV_DUAL_P2_03_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x06)
#define REG_DVI_RSV_DUAL_P2_03_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x07)
#define REG_DVI_RSV_DUAL_P2_04_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x08)
#define REG_DVI_RSV_DUAL_P2_04_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x09)
#define REG_DVI_RSV_DUAL_P2_05_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x0A)
#define REG_DVI_RSV_DUAL_P2_05_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x0B)
#define REG_DVI_RSV_DUAL_P2_06_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x0C)
#define REG_DVI_RSV_DUAL_P2_06_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x0D)
#define REG_DVI_RSV_DUAL_P2_07_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x0E)
#define REG_DVI_RSV_DUAL_P2_07_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x0F)
#define REG_DVI_RSV_DUAL_P2_08_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x10)
#define REG_DVI_RSV_DUAL_P2_08_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x11)
#define REG_DVI_RSV_DUAL_P2_09_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x12)
#define REG_DVI_RSV_DUAL_P2_09_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x13)
#define REG_DVI_RSV_DUAL_P2_0A_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x14)
#define REG_DVI_RSV_DUAL_P2_0A_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x15)
#define REG_DVI_RSV_DUAL_P2_0B_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x16)
#define REG_DVI_RSV_DUAL_P2_0B_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x17)
#define REG_DVI_RSV_DUAL_P2_0C_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x18)
#define REG_DVI_RSV_DUAL_P2_0C_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x19)
#define REG_DVI_RSV_DUAL_P2_0D_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x1A)
#define REG_DVI_RSV_DUAL_P2_0D_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x1B)
#define REG_DVI_RSV_DUAL_P2_0E_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x1C)
#define REG_DVI_RSV_DUAL_P2_0E_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x1D)
#define REG_DVI_RSV_DUAL_P2_0F_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x1E)
#define REG_DVI_RSV_DUAL_P2_0F_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x1F)
#define REG_DVI_RSV_DUAL_P2_10_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x20)
#define REG_DVI_RSV_DUAL_P2_10_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x21)
#define REG_DVI_RSV_DUAL_P2_11_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x22)
#define REG_DVI_RSV_DUAL_P2_11_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x23)
#define REG_DVI_RSV_DUAL_P2_12_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x24)
#define REG_DVI_RSV_DUAL_P2_12_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x25)
#define REG_DVI_RSV_DUAL_P2_13_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x26)
#define REG_DVI_RSV_DUAL_P2_13_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x27)
#define REG_DVI_RSV_DUAL_P2_14_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x28)
#define REG_DVI_RSV_DUAL_P2_14_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x29)
#define REG_DVI_RSV_DUAL_P2_15_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x2A)
#define REG_DVI_RSV_DUAL_P2_15_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x2B)
#define REG_DVI_RSV_DUAL_P2_16_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x2C)
#define REG_DVI_RSV_DUAL_P2_16_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x2D)
#define REG_DVI_RSV_DUAL_P2_17_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x2E)
#define REG_DVI_RSV_DUAL_P2_17_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x2F)
#define REG_DVI_RSV_DUAL_P2_18_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x30)
#define REG_DVI_RSV_DUAL_P2_18_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x31)
#define REG_DVI_RSV_DUAL_P2_19_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x32)
#define REG_DVI_RSV_DUAL_P2_19_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x33)
#define REG_DVI_RSV_DUAL_P2_1A_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x34)
#define REG_DVI_RSV_DUAL_P2_1A_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x35)
#define REG_DVI_RSV_DUAL_P2_1B_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x36)
#define REG_DVI_RSV_DUAL_P2_1B_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x37)
#define REG_DVI_RSV_DUAL_P2_1C_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x38)
#define REG_DVI_RSV_DUAL_P2_1C_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x39)
#define REG_DVI_RSV_DUAL_P2_1D_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x3A)
#define REG_DVI_RSV_DUAL_P2_1D_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x3B)
#define REG_DVI_RSV_DUAL_P2_1E_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x3C)
#define REG_DVI_RSV_DUAL_P2_1E_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x3D)
#define REG_DVI_RSV_DUAL_P2_1F_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x3E)
#define REG_DVI_RSV_DUAL_P2_1F_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x3F)
#define REG_DVI_RSV_DUAL_P2_20_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x40)
#define REG_DVI_RSV_DUAL_P2_20_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x41)
#define REG_DVI_RSV_DUAL_P2_21_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x42)
#define REG_DVI_RSV_DUAL_P2_21_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x43)
#define REG_DVI_RSV_DUAL_P2_22_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x44)
#define REG_DVI_RSV_DUAL_P2_22_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x45)
#define REG_DVI_RSV_DUAL_P2_23_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x46)
#define REG_DVI_RSV_DUAL_P2_23_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x47)
#define REG_DVI_RSV_DUAL_P2_24_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x48)
#define REG_DVI_RSV_DUAL_P2_24_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x49)
#define REG_DVI_RSV_DUAL_P2_25_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x4A)
#define REG_DVI_RSV_DUAL_P2_25_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x4B)
#define REG_DVI_RSV_DUAL_P2_26_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x4C)
#define REG_DVI_RSV_DUAL_P2_26_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x4D)
#define REG_DVI_RSV_DUAL_P2_27_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x4E)
#define REG_DVI_RSV_DUAL_P2_27_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x4F)
#define REG_DVI_RSV_DUAL_P2_28_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x50)
#define REG_DVI_RSV_DUAL_P2_28_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x51)
#define REG_DVI_RSV_DUAL_P2_29_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x52)
#define REG_DVI_RSV_DUAL_P2_29_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x53)
#define REG_DVI_RSV_DUAL_P2_2A_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x54)
#define REG_DVI_RSV_DUAL_P2_2A_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x55)
#define REG_DVI_RSV_DUAL_P2_2B_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x56)
#define REG_DVI_RSV_DUAL_P2_2B_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x57)
#define REG_DVI_RSV_DUAL_P2_2C_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x58)
#define REG_DVI_RSV_DUAL_P2_2C_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x59)
#define REG_DVI_RSV_DUAL_P2_2D_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x5A)
#define REG_DVI_RSV_DUAL_P2_2D_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x5B)
#define REG_DVI_RSV_DUAL_P2_2E_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x5C)
#define REG_DVI_RSV_DUAL_P2_2E_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x5D)
#define REG_DVI_RSV_DUAL_P2_2F_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x5E)
#define REG_DVI_RSV_DUAL_P2_2F_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x5F)
#define REG_DVI_RSV_DUAL_P2_30_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x60)
#define REG_DVI_RSV_DUAL_P2_30_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x61)
#define REG_DVI_RSV_DUAL_P2_31_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x62)
#define REG_DVI_RSV_DUAL_P2_31_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x63)
#define REG_DVI_RSV_DUAL_P2_32_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x64)
#define REG_DVI_RSV_DUAL_P2_32_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x65)
#define REG_DVI_RSV_DUAL_P2_33_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x66)
#define REG_DVI_RSV_DUAL_P2_33_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x67)
#define REG_DVI_RSV_DUAL_P2_34_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x68)
#define REG_DVI_RSV_DUAL_P2_34_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x69)
#define REG_DVI_RSV_DUAL_P2_35_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x6A)
#define REG_DVI_RSV_DUAL_P2_35_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x6B)
#define REG_DVI_RSV_DUAL_P2_36_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x6C)
#define REG_DVI_RSV_DUAL_P2_36_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x6D)
#define REG_DVI_RSV_DUAL_P2_37_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x6E)
#define REG_DVI_RSV_DUAL_P2_37_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x6F)
#define REG_DVI_RSV_DUAL_P2_38_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x70)
#define REG_DVI_RSV_DUAL_P2_38_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x71)
#define REG_DVI_RSV_DUAL_P2_39_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x72)
#define REG_DVI_RSV_DUAL_P2_39_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x73)
#define REG_DVI_RSV_DUAL_P2_3A_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x74)
#define REG_DVI_RSV_DUAL_P2_3A_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x75)
#define REG_DVI_RSV_DUAL_P2_3B_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x76)
#define REG_DVI_RSV_DUAL_P2_3B_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x77)
#define REG_DVI_RSV_DUAL_P2_3C_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x78)
#define REG_DVI_RSV_DUAL_P2_3C_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x79)
#define REG_DVI_RSV_DUAL_P2_3D_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x7A)
#define REG_DVI_RSV_DUAL_P2_3D_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x7B)
#define REG_DVI_RSV_DUAL_P2_3E_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x7C)
#define REG_DVI_RSV_DUAL_P2_3E_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x7D)
#define REG_DVI_RSV_DUAL_P2_3F_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x7E)
#define REG_DVI_RSV_DUAL_P2_3F_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x7F)
#define REG_DVI_RSV_DUAL_P2_40_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x80)
#define REG_DVI_RSV_DUAL_P2_40_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x81)
#define REG_DVI_RSV_DUAL_P2_41_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x82)
#define REG_DVI_RSV_DUAL_P2_41_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x83)
#define REG_DVI_RSV_DUAL_P2_42_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x84)
#define REG_DVI_RSV_DUAL_P2_42_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x85)
#define REG_DVI_RSV_DUAL_P2_43_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x86)
#define REG_DVI_RSV_DUAL_P2_43_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x87)
#define REG_DVI_RSV_DUAL_P2_44_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x88)
#define REG_DVI_RSV_DUAL_P2_44_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x89)
#define REG_DVI_RSV_DUAL_P2_45_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x8A)
#define REG_DVI_RSV_DUAL_P2_45_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x8B)
#define REG_DVI_RSV_DUAL_P2_46_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x8C)
#define REG_DVI_RSV_DUAL_P2_46_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x8D)
#define REG_DVI_RSV_DUAL_P2_47_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x8E)
#define REG_DVI_RSV_DUAL_P2_47_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x8F)
#define REG_DVI_RSV_DUAL_P2_48_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x90)
#define REG_DVI_RSV_DUAL_P2_48_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x91)
#define REG_DVI_RSV_DUAL_P2_49_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x92)
#define REG_DVI_RSV_DUAL_P2_49_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x93)
#define REG_DVI_RSV_DUAL_P2_4A_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x94)
#define REG_DVI_RSV_DUAL_P2_4A_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x95)
#define REG_DVI_RSV_DUAL_P2_4B_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x96)
#define REG_DVI_RSV_DUAL_P2_4B_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x97)
#define REG_DVI_RSV_DUAL_P2_4C_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x98)
#define REG_DVI_RSV_DUAL_P2_4C_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x99)
#define REG_DVI_RSV_DUAL_P2_4D_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x9A)
#define REG_DVI_RSV_DUAL_P2_4D_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x9B)
#define REG_DVI_RSV_DUAL_P2_4E_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x9C)
#define REG_DVI_RSV_DUAL_P2_4E_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x9D)
#define REG_DVI_RSV_DUAL_P2_4F_L        (REG_DVI_RSV_DUAL_P2_BASE + 0x9E)
#define REG_DVI_RSV_DUAL_P2_4F_H        (REG_DVI_RSV_DUAL_P2_BASE + 0x9F)
#define REG_DVI_RSV_DUAL_P2_50_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xA0)
#define REG_DVI_RSV_DUAL_P2_50_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xA1)
#define REG_DVI_RSV_DUAL_P2_51_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xA2)
#define REG_DVI_RSV_DUAL_P2_51_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xA3)
#define REG_DVI_RSV_DUAL_P2_52_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xA4)
#define REG_DVI_RSV_DUAL_P2_52_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xA5)
#define REG_DVI_RSV_DUAL_P2_53_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xA6)
#define REG_DVI_RSV_DUAL_P2_53_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xA7)
#define REG_DVI_RSV_DUAL_P2_54_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xA8)
#define REG_DVI_RSV_DUAL_P2_54_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xA9)
#define REG_DVI_RSV_DUAL_P2_55_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xAA)
#define REG_DVI_RSV_DUAL_P2_55_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xAB)
#define REG_DVI_RSV_DUAL_P2_56_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xAC)
#define REG_DVI_RSV_DUAL_P2_56_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xAD)
#define REG_DVI_RSV_DUAL_P2_57_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xAE)
#define REG_DVI_RSV_DUAL_P2_57_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xAF)
#define REG_DVI_RSV_DUAL_P2_58_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xB0)
#define REG_DVI_RSV_DUAL_P2_58_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xB1)
#define REG_DVI_RSV_DUAL_P2_59_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xB2)
#define REG_DVI_RSV_DUAL_P2_59_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xB3)
#define REG_DVI_RSV_DUAL_P2_5A_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xB4)
#define REG_DVI_RSV_DUAL_P2_5A_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xB5)
#define REG_DVI_RSV_DUAL_P2_5B_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xB6)
#define REG_DVI_RSV_DUAL_P2_5B_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xB7)
#define REG_DVI_RSV_DUAL_P2_5C_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xB8)
#define REG_DVI_RSV_DUAL_P2_5C_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xB9)
#define REG_DVI_RSV_DUAL_P2_5D_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xBA)
#define REG_DVI_RSV_DUAL_P2_5D_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xBB)
#define REG_DVI_RSV_DUAL_P2_5E_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xBC)
#define REG_DVI_RSV_DUAL_P2_5E_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xBD)
#define REG_DVI_RSV_DUAL_P2_5F_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xBE)
#define REG_DVI_RSV_DUAL_P2_5F_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xBF)
#define REG_DVI_RSV_DUAL_P2_60_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xC0)
#define REG_DVI_RSV_DUAL_P2_60_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xC1)
#define REG_DVI_RSV_DUAL_P2_61_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xC2)
#define REG_DVI_RSV_DUAL_P2_61_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xC3)
#define REG_DVI_RSV_DUAL_P2_62_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xC4)
#define REG_DVI_RSV_DUAL_P2_62_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xC5)
#define REG_DVI_RSV_DUAL_P2_63_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xC6)
#define REG_DVI_RSV_DUAL_P2_63_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xC7)
#define REG_DVI_RSV_DUAL_P2_64_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xC8)
#define REG_DVI_RSV_DUAL_P2_64_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xC9)
#define REG_DVI_RSV_DUAL_P2_65_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xCA)
#define REG_DVI_RSV_DUAL_P2_65_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xCB)
#define REG_DVI_RSV_DUAL_P2_66_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xCC)
#define REG_DVI_RSV_DUAL_P2_66_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xCD)
#define REG_DVI_RSV_DUAL_P2_67_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xCE)
#define REG_DVI_RSV_DUAL_P2_67_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xCF)
#define REG_DVI_RSV_DUAL_P2_68_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xD0)
#define REG_DVI_RSV_DUAL_P2_68_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xD1)
#define REG_DVI_RSV_DUAL_P2_69_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xD2)
#define REG_DVI_RSV_DUAL_P2_69_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xD3)
#define REG_DVI_RSV_DUAL_P2_6A_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xD4)
#define REG_DVI_RSV_DUAL_P2_6A_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xD5)
#define REG_DVI_RSV_DUAL_P2_6B_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xD6)
#define REG_DVI_RSV_DUAL_P2_6B_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xD7)
#define REG_DVI_RSV_DUAL_P2_6C_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xD8)
#define REG_DVI_RSV_DUAL_P2_6C_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xD9)
#define REG_DVI_RSV_DUAL_P2_6D_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xDA)
#define REG_DVI_RSV_DUAL_P2_6D_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xDB)
#define REG_DVI_RSV_DUAL_P2_6E_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xDC)
#define REG_DVI_RSV_DUAL_P2_6E_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xDD)
#define REG_DVI_RSV_DUAL_P2_6F_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xDE)
#define REG_DVI_RSV_DUAL_P2_6F_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xDF)
#define REG_DVI_RSV_DUAL_P2_70_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xE0)
#define REG_DVI_RSV_DUAL_P2_70_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xE1)
#define REG_DVI_RSV_DUAL_P2_71_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xE2)
#define REG_DVI_RSV_DUAL_P2_71_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xE3)
#define REG_DVI_RSV_DUAL_P2_72_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xE4)
#define REG_DVI_RSV_DUAL_P2_72_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xE5)
#define REG_DVI_RSV_DUAL_P2_73_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xE6)
#define REG_DVI_RSV_DUAL_P2_73_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xE7)
#define REG_DVI_RSV_DUAL_P2_74_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xE8)
#define REG_DVI_RSV_DUAL_P2_74_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xE9)
#define REG_DVI_RSV_DUAL_P2_75_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xEA)
#define REG_DVI_RSV_DUAL_P2_75_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xEB)
#define REG_DVI_RSV_DUAL_P2_76_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xEC)
#define REG_DVI_RSV_DUAL_P2_76_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xED)
#define REG_DVI_RSV_DUAL_P2_77_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xEE)
#define REG_DVI_RSV_DUAL_P2_77_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xEF)
#define REG_DVI_RSV_DUAL_P2_78_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xF0)
#define REG_DVI_RSV_DUAL_P2_78_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xF1)
#define REG_DVI_RSV_DUAL_P2_79_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xF2)
#define REG_DVI_RSV_DUAL_P2_79_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xF3)
#define REG_DVI_RSV_DUAL_P2_7A_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xF4)
#define REG_DVI_RSV_DUAL_P2_7A_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xF5)
#define REG_DVI_RSV_DUAL_P2_7B_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xF6)
#define REG_DVI_RSV_DUAL_P2_7B_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xF7)
#define REG_DVI_RSV_DUAL_P2_7C_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xF8)
#define REG_DVI_RSV_DUAL_P2_7C_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xF9)
#define REG_DVI_RSV_DUAL_P2_7D_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xFA)
#define REG_DVI_RSV_DUAL_P2_7D_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xFB)
#define REG_DVI_RSV_DUAL_P2_7E_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xFC)
#define REG_DVI_RSV_DUAL_P2_7E_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xFD)
#define REG_DVI_RSV_DUAL_P2_7F_L        (REG_DVI_RSV_DUAL_P2_BASE + 0xFE)
#define REG_DVI_RSV_DUAL_P2_7F_H        (REG_DVI_RSV_DUAL_P2_BASE + 0xFF)

//=============================================================
// HDCP_DUAL_P2
#define REG_HDCP_DUAL_P2_00_L           (REG_HDCP_DUAL_P2_BASE + 0x00)
#define REG_HDCP_DUAL_P2_00_H           (REG_HDCP_DUAL_P2_BASE + 0x01)
#define REG_HDCP_DUAL_P2_01_L           (REG_HDCP_DUAL_P2_BASE + 0x02)
#define REG_HDCP_DUAL_P2_01_H           (REG_HDCP_DUAL_P2_BASE + 0x03)
#define REG_HDCP_DUAL_P2_02_L           (REG_HDCP_DUAL_P2_BASE + 0x04)
#define REG_HDCP_DUAL_P2_02_H           (REG_HDCP_DUAL_P2_BASE + 0x05)
#define REG_HDCP_DUAL_P2_03_L           (REG_HDCP_DUAL_P2_BASE + 0x06)
#define REG_HDCP_DUAL_P2_03_H           (REG_HDCP_DUAL_P2_BASE + 0x07)
#define REG_HDCP_DUAL_P2_04_L           (REG_HDCP_DUAL_P2_BASE + 0x08)
#define REG_HDCP_DUAL_P2_04_H           (REG_HDCP_DUAL_P2_BASE + 0x09)
#define REG_HDCP_DUAL_P2_05_L           (REG_HDCP_DUAL_P2_BASE + 0x0A)
#define REG_HDCP_DUAL_P2_05_H           (REG_HDCP_DUAL_P2_BASE + 0x0B)
#define REG_HDCP_DUAL_P2_06_L           (REG_HDCP_DUAL_P2_BASE + 0x0C)
#define REG_HDCP_DUAL_P2_06_H           (REG_HDCP_DUAL_P2_BASE + 0x0D)
#define REG_HDCP_DUAL_P2_07_L           (REG_HDCP_DUAL_P2_BASE + 0x0E)
#define REG_HDCP_DUAL_P2_07_H           (REG_HDCP_DUAL_P2_BASE + 0x0F)
#define REG_HDCP_DUAL_P2_08_L           (REG_HDCP_DUAL_P2_BASE + 0x10)
#define REG_HDCP_DUAL_P2_08_H           (REG_HDCP_DUAL_P2_BASE + 0x11)
#define REG_HDCP_DUAL_P2_09_L           (REG_HDCP_DUAL_P2_BASE + 0x12)
#define REG_HDCP_DUAL_P2_09_H           (REG_HDCP_DUAL_P2_BASE + 0x13)
#define REG_HDCP_DUAL_P2_0A_L           (REG_HDCP_DUAL_P2_BASE + 0x14)
#define REG_HDCP_DUAL_P2_0A_H           (REG_HDCP_DUAL_P2_BASE + 0x15)
#define REG_HDCP_DUAL_P2_0B_L           (REG_HDCP_DUAL_P2_BASE + 0x16)
#define REG_HDCP_DUAL_P2_0B_H           (REG_HDCP_DUAL_P2_BASE + 0x17)
#define REG_HDCP_DUAL_P2_0C_L           (REG_HDCP_DUAL_P2_BASE + 0x18)
#define REG_HDCP_DUAL_P2_0C_H           (REG_HDCP_DUAL_P2_BASE + 0x19)
#define REG_HDCP_DUAL_P2_0D_L           (REG_HDCP_DUAL_P2_BASE + 0x1A)
#define REG_HDCP_DUAL_P2_0D_H           (REG_HDCP_DUAL_P2_BASE + 0x1B)
#define REG_HDCP_DUAL_P2_0E_L           (REG_HDCP_DUAL_P2_BASE + 0x1C)
#define REG_HDCP_DUAL_P2_0E_H           (REG_HDCP_DUAL_P2_BASE + 0x1D)
#define REG_HDCP_DUAL_P2_0F_L           (REG_HDCP_DUAL_P2_BASE + 0x1E)
#define REG_HDCP_DUAL_P2_0F_H           (REG_HDCP_DUAL_P2_BASE + 0x1F)
#define REG_HDCP_DUAL_P2_10_L           (REG_HDCP_DUAL_P2_BASE + 0x20)
#define REG_HDCP_DUAL_P2_10_H           (REG_HDCP_DUAL_P2_BASE + 0x21)
#define REG_HDCP_DUAL_P2_11_L           (REG_HDCP_DUAL_P2_BASE + 0x22)
#define REG_HDCP_DUAL_P2_11_H           (REG_HDCP_DUAL_P2_BASE + 0x23)
#define REG_HDCP_DUAL_P2_12_L           (REG_HDCP_DUAL_P2_BASE + 0x24)
#define REG_HDCP_DUAL_P2_12_H           (REG_HDCP_DUAL_P2_BASE + 0x25)
#define REG_HDCP_DUAL_P2_13_L           (REG_HDCP_DUAL_P2_BASE + 0x26)
#define REG_HDCP_DUAL_P2_13_H           (REG_HDCP_DUAL_P2_BASE + 0x27)
#define REG_HDCP_DUAL_P2_14_L           (REG_HDCP_DUAL_P2_BASE + 0x28)
#define REG_HDCP_DUAL_P2_14_H           (REG_HDCP_DUAL_P2_BASE + 0x29)
#define REG_HDCP_DUAL_P2_15_L           (REG_HDCP_DUAL_P2_BASE + 0x2A)
#define REG_HDCP_DUAL_P2_15_H           (REG_HDCP_DUAL_P2_BASE + 0x2B)
#define REG_HDCP_DUAL_P2_16_L           (REG_HDCP_DUAL_P2_BASE + 0x2C)
#define REG_HDCP_DUAL_P2_16_H           (REG_HDCP_DUAL_P2_BASE + 0x2D)
#define REG_HDCP_DUAL_P2_17_L           (REG_HDCP_DUAL_P2_BASE + 0x2E)
#define REG_HDCP_DUAL_P2_17_H           (REG_HDCP_DUAL_P2_BASE + 0x2F)
#define REG_HDCP_DUAL_P2_18_L           (REG_HDCP_DUAL_P2_BASE + 0x30)
#define REG_HDCP_DUAL_P2_18_H           (REG_HDCP_DUAL_P2_BASE + 0x31)
#define REG_HDCP_DUAL_P2_19_L           (REG_HDCP_DUAL_P2_BASE + 0x32)
#define REG_HDCP_DUAL_P2_19_H           (REG_HDCP_DUAL_P2_BASE + 0x33)
#define REG_HDCP_DUAL_P2_1A_L           (REG_HDCP_DUAL_P2_BASE + 0x34)
#define REG_HDCP_DUAL_P2_1A_H           (REG_HDCP_DUAL_P2_BASE + 0x35)
#define REG_HDCP_DUAL_P2_1B_L           (REG_HDCP_DUAL_P2_BASE + 0x36)
#define REG_HDCP_DUAL_P2_1B_H           (REG_HDCP_DUAL_P2_BASE + 0x37)
#define REG_HDCP_DUAL_P2_1C_L           (REG_HDCP_DUAL_P2_BASE + 0x38)
#define REG_HDCP_DUAL_P2_1C_H           (REG_HDCP_DUAL_P2_BASE + 0x39)
#define REG_HDCP_DUAL_P2_1D_L           (REG_HDCP_DUAL_P2_BASE + 0x3A)
#define REG_HDCP_DUAL_P2_1D_H           (REG_HDCP_DUAL_P2_BASE + 0x3B)
#define REG_HDCP_DUAL_P2_1E_L           (REG_HDCP_DUAL_P2_BASE + 0x3C)
#define REG_HDCP_DUAL_P2_1E_H           (REG_HDCP_DUAL_P2_BASE + 0x3D)
#define REG_HDCP_DUAL_P2_1F_L           (REG_HDCP_DUAL_P2_BASE + 0x3E)
#define REG_HDCP_DUAL_P2_1F_H           (REG_HDCP_DUAL_P2_BASE + 0x3F)
#define REG_HDCP_DUAL_P2_20_L           (REG_HDCP_DUAL_P2_BASE + 0x40)
#define REG_HDCP_DUAL_P2_20_H           (REG_HDCP_DUAL_P2_BASE + 0x41)
#define REG_HDCP_DUAL_P2_21_L           (REG_HDCP_DUAL_P2_BASE + 0x42)
#define REG_HDCP_DUAL_P2_21_H           (REG_HDCP_DUAL_P2_BASE + 0x43)
#define REG_HDCP_DUAL_P2_22_L           (REG_HDCP_DUAL_P2_BASE + 0x44)
#define REG_HDCP_DUAL_P2_22_H           (REG_HDCP_DUAL_P2_BASE + 0x45)
#define REG_HDCP_DUAL_P2_23_L           (REG_HDCP_DUAL_P2_BASE + 0x46)
#define REG_HDCP_DUAL_P2_23_H           (REG_HDCP_DUAL_P2_BASE + 0x47)
#define REG_HDCP_DUAL_P2_24_L           (REG_HDCP_DUAL_P2_BASE + 0x48)
#define REG_HDCP_DUAL_P2_24_H           (REG_HDCP_DUAL_P2_BASE + 0x49)
#define REG_HDCP_DUAL_P2_25_L           (REG_HDCP_DUAL_P2_BASE + 0x4A)
#define REG_HDCP_DUAL_P2_25_H           (REG_HDCP_DUAL_P2_BASE + 0x4B)
#define REG_HDCP_DUAL_P2_26_L           (REG_HDCP_DUAL_P2_BASE + 0x4C)
#define REG_HDCP_DUAL_P2_26_H           (REG_HDCP_DUAL_P2_BASE + 0x4D)
#define REG_HDCP_DUAL_P2_27_L           (REG_HDCP_DUAL_P2_BASE + 0x4E)
#define REG_HDCP_DUAL_P2_27_H           (REG_HDCP_DUAL_P2_BASE + 0x4F)
#define REG_HDCP_DUAL_P2_28_L           (REG_HDCP_DUAL_P2_BASE + 0x50)
#define REG_HDCP_DUAL_P2_28_H           (REG_HDCP_DUAL_P2_BASE + 0x51)
#define REG_HDCP_DUAL_P2_29_L           (REG_HDCP_DUAL_P2_BASE + 0x52)
#define REG_HDCP_DUAL_P2_29_H           (REG_HDCP_DUAL_P2_BASE + 0x53)
#define REG_HDCP_DUAL_P2_2A_L           (REG_HDCP_DUAL_P2_BASE + 0x54)
#define REG_HDCP_DUAL_P2_2A_H           (REG_HDCP_DUAL_P2_BASE + 0x55)
#define REG_HDCP_DUAL_P2_2B_L           (REG_HDCP_DUAL_P2_BASE + 0x56)
#define REG_HDCP_DUAL_P2_2B_H           (REG_HDCP_DUAL_P2_BASE + 0x57)
#define REG_HDCP_DUAL_P2_2C_L           (REG_HDCP_DUAL_P2_BASE + 0x58)
#define REG_HDCP_DUAL_P2_2C_H           (REG_HDCP_DUAL_P2_BASE + 0x59)
#define REG_HDCP_DUAL_P2_2D_L           (REG_HDCP_DUAL_P2_BASE + 0x5A)
#define REG_HDCP_DUAL_P2_2D_H           (REG_HDCP_DUAL_P2_BASE + 0x5B)
#define REG_HDCP_DUAL_P2_2E_L           (REG_HDCP_DUAL_P2_BASE + 0x5C)
#define REG_HDCP_DUAL_P2_2E_H           (REG_HDCP_DUAL_P2_BASE + 0x5D)
#define REG_HDCP_DUAL_P2_2F_L           (REG_HDCP_DUAL_P2_BASE + 0x5E)
#define REG_HDCP_DUAL_P2_2F_H           (REG_HDCP_DUAL_P2_BASE + 0x5F)
#define REG_HDCP_DUAL_P2_30_L           (REG_HDCP_DUAL_P2_BASE + 0x60)
#define REG_HDCP_DUAL_P2_30_H           (REG_HDCP_DUAL_P2_BASE + 0x61)
#define REG_HDCP_DUAL_P2_31_L           (REG_HDCP_DUAL_P2_BASE + 0x62)
#define REG_HDCP_DUAL_P2_31_H           (REG_HDCP_DUAL_P2_BASE + 0x63)
#define REG_HDCP_DUAL_P2_32_L           (REG_HDCP_DUAL_P2_BASE + 0x64)
#define REG_HDCP_DUAL_P2_32_H           (REG_HDCP_DUAL_P2_BASE + 0x65)
#define REG_HDCP_DUAL_P2_33_L           (REG_HDCP_DUAL_P2_BASE + 0x66)
#define REG_HDCP_DUAL_P2_33_H           (REG_HDCP_DUAL_P2_BASE + 0x67)
#define REG_HDCP_DUAL_P2_34_L           (REG_HDCP_DUAL_P2_BASE + 0x68)
#define REG_HDCP_DUAL_P2_34_H           (REG_HDCP_DUAL_P2_BASE + 0x69)
#define REG_HDCP_DUAL_P2_35_L           (REG_HDCP_DUAL_P2_BASE + 0x6A)
#define REG_HDCP_DUAL_P2_35_H           (REG_HDCP_DUAL_P2_BASE + 0x6B)
#define REG_HDCP_DUAL_P2_36_L           (REG_HDCP_DUAL_P2_BASE + 0x6C)
#define REG_HDCP_DUAL_P2_36_H           (REG_HDCP_DUAL_P2_BASE + 0x6D)
#define REG_HDCP_DUAL_P2_37_L           (REG_HDCP_DUAL_P2_BASE + 0x6E)
#define REG_HDCP_DUAL_P2_37_H           (REG_HDCP_DUAL_P2_BASE + 0x6F)
#define REG_HDCP_DUAL_P2_38_L           (REG_HDCP_DUAL_P2_BASE + 0x70)
#define REG_HDCP_DUAL_P2_38_H           (REG_HDCP_DUAL_P2_BASE + 0x71)
#define REG_HDCP_DUAL_P2_39_L           (REG_HDCP_DUAL_P2_BASE + 0x72)
#define REG_HDCP_DUAL_P2_39_H           (REG_HDCP_DUAL_P2_BASE + 0x73)
#define REG_HDCP_DUAL_P2_3A_L           (REG_HDCP_DUAL_P2_BASE + 0x74)
#define REG_HDCP_DUAL_P2_3A_H           (REG_HDCP_DUAL_P2_BASE + 0x75)
#define REG_HDCP_DUAL_P2_3B_L           (REG_HDCP_DUAL_P2_BASE + 0x76)
#define REG_HDCP_DUAL_P2_3B_H           (REG_HDCP_DUAL_P2_BASE + 0x77)
#define REG_HDCP_DUAL_P2_3C_L           (REG_HDCP_DUAL_P2_BASE + 0x78)
#define REG_HDCP_DUAL_P2_3C_H           (REG_HDCP_DUAL_P2_BASE + 0x79)
#define REG_HDCP_DUAL_P2_3D_L           (REG_HDCP_DUAL_P2_BASE + 0x7A)
#define REG_HDCP_DUAL_P2_3D_H           (REG_HDCP_DUAL_P2_BASE + 0x7B)
#define REG_HDCP_DUAL_P2_3E_L           (REG_HDCP_DUAL_P2_BASE + 0x7C)
#define REG_HDCP_DUAL_P2_3E_H           (REG_HDCP_DUAL_P2_BASE + 0x7D)
#define REG_HDCP_DUAL_P2_3F_L           (REG_HDCP_DUAL_P2_BASE + 0x7E)
#define REG_HDCP_DUAL_P2_3F_H           (REG_HDCP_DUAL_P2_BASE + 0x7F)
#define REG_HDCP_DUAL_P2_40_L           (REG_HDCP_DUAL_P2_BASE + 0x80)
#define REG_HDCP_DUAL_P2_40_H           (REG_HDCP_DUAL_P2_BASE + 0x81)
#define REG_HDCP_DUAL_P2_41_L           (REG_HDCP_DUAL_P2_BASE + 0x82)
#define REG_HDCP_DUAL_P2_41_H           (REG_HDCP_DUAL_P2_BASE + 0x83)
#define REG_HDCP_DUAL_P2_42_L           (REG_HDCP_DUAL_P2_BASE + 0x84)
#define REG_HDCP_DUAL_P2_42_H           (REG_HDCP_DUAL_P2_BASE + 0x85)
#define REG_HDCP_DUAL_P2_43_L           (REG_HDCP_DUAL_P2_BASE + 0x86)
#define REG_HDCP_DUAL_P2_43_H           (REG_HDCP_DUAL_P2_BASE + 0x87)
#define REG_HDCP_DUAL_P2_44_L           (REG_HDCP_DUAL_P2_BASE + 0x88)
#define REG_HDCP_DUAL_P2_44_H           (REG_HDCP_DUAL_P2_BASE + 0x89)
#define REG_HDCP_DUAL_P2_45_L           (REG_HDCP_DUAL_P2_BASE + 0x8A)
#define REG_HDCP_DUAL_P2_45_H           (REG_HDCP_DUAL_P2_BASE + 0x8B)
#define REG_HDCP_DUAL_P2_46_L           (REG_HDCP_DUAL_P2_BASE + 0x8C)
#define REG_HDCP_DUAL_P2_46_H           (REG_HDCP_DUAL_P2_BASE + 0x8D)
#define REG_HDCP_DUAL_P2_47_L           (REG_HDCP_DUAL_P2_BASE + 0x8E)
#define REG_HDCP_DUAL_P2_47_H           (REG_HDCP_DUAL_P2_BASE + 0x8F)
#define REG_HDCP_DUAL_P2_48_L           (REG_HDCP_DUAL_P2_BASE + 0x90)
#define REG_HDCP_DUAL_P2_48_H           (REG_HDCP_DUAL_P2_BASE + 0x91)
#define REG_HDCP_DUAL_P2_49_L           (REG_HDCP_DUAL_P2_BASE + 0x92)
#define REG_HDCP_DUAL_P2_49_H           (REG_HDCP_DUAL_P2_BASE + 0x93)
#define REG_HDCP_DUAL_P2_4A_L           (REG_HDCP_DUAL_P2_BASE + 0x94)
#define REG_HDCP_DUAL_P2_4A_H           (REG_HDCP_DUAL_P2_BASE + 0x95)
#define REG_HDCP_DUAL_P2_4B_L           (REG_HDCP_DUAL_P2_BASE + 0x96)
#define REG_HDCP_DUAL_P2_4B_H           (REG_HDCP_DUAL_P2_BASE + 0x97)
#define REG_HDCP_DUAL_P2_4C_L           (REG_HDCP_DUAL_P2_BASE + 0x98)
#define REG_HDCP_DUAL_P2_4C_H           (REG_HDCP_DUAL_P2_BASE + 0x99)
#define REG_HDCP_DUAL_P2_4D_L           (REG_HDCP_DUAL_P2_BASE + 0x9A)
#define REG_HDCP_DUAL_P2_4D_H           (REG_HDCP_DUAL_P2_BASE + 0x9B)
#define REG_HDCP_DUAL_P2_4E_L           (REG_HDCP_DUAL_P2_BASE + 0x9C)
#define REG_HDCP_DUAL_P2_4E_H           (REG_HDCP_DUAL_P2_BASE + 0x9D)
#define REG_HDCP_DUAL_P2_4F_L           (REG_HDCP_DUAL_P2_BASE + 0x9E)
#define REG_HDCP_DUAL_P2_4F_H           (REG_HDCP_DUAL_P2_BASE + 0x9F)
#define REG_HDCP_DUAL_P2_50_L           (REG_HDCP_DUAL_P2_BASE + 0xA0)
#define REG_HDCP_DUAL_P2_50_H           (REG_HDCP_DUAL_P2_BASE + 0xA1)
#define REG_HDCP_DUAL_P2_51_L           (REG_HDCP_DUAL_P2_BASE + 0xA2)
#define REG_HDCP_DUAL_P2_51_H           (REG_HDCP_DUAL_P2_BASE + 0xA3)
#define REG_HDCP_DUAL_P2_52_L           (REG_HDCP_DUAL_P2_BASE + 0xA4)
#define REG_HDCP_DUAL_P2_52_H           (REG_HDCP_DUAL_P2_BASE + 0xA5)
#define REG_HDCP_DUAL_P2_53_L           (REG_HDCP_DUAL_P2_BASE + 0xA6)
#define REG_HDCP_DUAL_P2_53_H           (REG_HDCP_DUAL_P2_BASE + 0xA7)
#define REG_HDCP_DUAL_P2_54_L           (REG_HDCP_DUAL_P2_BASE + 0xA8)
#define REG_HDCP_DUAL_P2_54_H           (REG_HDCP_DUAL_P2_BASE + 0xA9)
#define REG_HDCP_DUAL_P2_55_L           (REG_HDCP_DUAL_P2_BASE + 0xAA)
#define REG_HDCP_DUAL_P2_55_H           (REG_HDCP_DUAL_P2_BASE + 0xAB)
#define REG_HDCP_DUAL_P2_56_L           (REG_HDCP_DUAL_P2_BASE + 0xAC)
#define REG_HDCP_DUAL_P2_56_H           (REG_HDCP_DUAL_P2_BASE + 0xAD)
#define REG_HDCP_DUAL_P2_57_L           (REG_HDCP_DUAL_P2_BASE + 0xAE)
#define REG_HDCP_DUAL_P2_57_H           (REG_HDCP_DUAL_P2_BASE + 0xAF)
#define REG_HDCP_DUAL_P2_58_L           (REG_HDCP_DUAL_P2_BASE + 0xB0)
#define REG_HDCP_DUAL_P2_58_H           (REG_HDCP_DUAL_P2_BASE + 0xB1)
#define REG_HDCP_DUAL_P2_59_L           (REG_HDCP_DUAL_P2_BASE + 0xB2)
#define REG_HDCP_DUAL_P2_59_H           (REG_HDCP_DUAL_P2_BASE + 0xB3)
#define REG_HDCP_DUAL_P2_5A_L           (REG_HDCP_DUAL_P2_BASE + 0xB4)
#define REG_HDCP_DUAL_P2_5A_H           (REG_HDCP_DUAL_P2_BASE + 0xB5)
#define REG_HDCP_DUAL_P2_5B_L           (REG_HDCP_DUAL_P2_BASE + 0xB6)
#define REG_HDCP_DUAL_P2_5B_H           (REG_HDCP_DUAL_P2_BASE + 0xB7)
#define REG_HDCP_DUAL_P2_5C_L           (REG_HDCP_DUAL_P2_BASE + 0xB8)
#define REG_HDCP_DUAL_P2_5C_H           (REG_HDCP_DUAL_P2_BASE + 0xB9)
#define REG_HDCP_DUAL_P2_5D_L           (REG_HDCP_DUAL_P2_BASE + 0xBA)
#define REG_HDCP_DUAL_P2_5D_H           (REG_HDCP_DUAL_P2_BASE + 0xBB)
#define REG_HDCP_DUAL_P2_5E_L           (REG_HDCP_DUAL_P2_BASE + 0xBC)
#define REG_HDCP_DUAL_P2_5E_H           (REG_HDCP_DUAL_P2_BASE + 0xBD)
#define REG_HDCP_DUAL_P2_5F_L           (REG_HDCP_DUAL_P2_BASE + 0xBE)
#define REG_HDCP_DUAL_P2_5F_H           (REG_HDCP_DUAL_P2_BASE + 0xBF)
#define REG_HDCP_DUAL_P2_60_L           (REG_HDCP_DUAL_P2_BASE + 0xC0)
#define REG_HDCP_DUAL_P2_60_H           (REG_HDCP_DUAL_P2_BASE + 0xC1)
#define REG_HDCP_DUAL_P2_61_L           (REG_HDCP_DUAL_P2_BASE + 0xC2)
#define REG_HDCP_DUAL_P2_61_H           (REG_HDCP_DUAL_P2_BASE + 0xC3)
#define REG_HDCP_DUAL_P2_62_L           (REG_HDCP_DUAL_P2_BASE + 0xC4)
#define REG_HDCP_DUAL_P2_62_H           (REG_HDCP_DUAL_P2_BASE + 0xC5)
#define REG_HDCP_DUAL_P2_63_L           (REG_HDCP_DUAL_P2_BASE + 0xC6)
#define REG_HDCP_DUAL_P2_63_H           (REG_HDCP_DUAL_P2_BASE + 0xC7)
#define REG_HDCP_DUAL_P2_64_L           (REG_HDCP_DUAL_P2_BASE + 0xC8)
#define REG_HDCP_DUAL_P2_64_H           (REG_HDCP_DUAL_P2_BASE + 0xC9)
#define REG_HDCP_DUAL_P2_65_L           (REG_HDCP_DUAL_P2_BASE + 0xCA)
#define REG_HDCP_DUAL_P2_65_H           (REG_HDCP_DUAL_P2_BASE + 0xCB)
#define REG_HDCP_DUAL_P2_66_L           (REG_HDCP_DUAL_P2_BASE + 0xCC)
#define REG_HDCP_DUAL_P2_66_H           (REG_HDCP_DUAL_P2_BASE + 0xCD)
#define REG_HDCP_DUAL_P2_67_L           (REG_HDCP_DUAL_P2_BASE + 0xCE)
#define REG_HDCP_DUAL_P2_67_H           (REG_HDCP_DUAL_P2_BASE + 0xCF)
#define REG_HDCP_DUAL_P2_68_L           (REG_HDCP_DUAL_P2_BASE + 0xD0)
#define REG_HDCP_DUAL_P2_68_H           (REG_HDCP_DUAL_P2_BASE + 0xD1)
#define REG_HDCP_DUAL_P2_69_L           (REG_HDCP_DUAL_P2_BASE + 0xD2)
#define REG_HDCP_DUAL_P2_69_H           (REG_HDCP_DUAL_P2_BASE + 0xD3)
#define REG_HDCP_DUAL_P2_6A_L           (REG_HDCP_DUAL_P2_BASE + 0xD4)
#define REG_HDCP_DUAL_P2_6A_H           (REG_HDCP_DUAL_P2_BASE + 0xD5)
#define REG_HDCP_DUAL_P2_6B_L           (REG_HDCP_DUAL_P2_BASE + 0xD6)
#define REG_HDCP_DUAL_P2_6B_H           (REG_HDCP_DUAL_P2_BASE + 0xD7)
#define REG_HDCP_DUAL_P2_6C_L           (REG_HDCP_DUAL_P2_BASE + 0xD8)
#define REG_HDCP_DUAL_P2_6C_H           (REG_HDCP_DUAL_P2_BASE + 0xD9)
#define REG_HDCP_DUAL_P2_6D_L           (REG_HDCP_DUAL_P2_BASE + 0xDA)
#define REG_HDCP_DUAL_P2_6D_H           (REG_HDCP_DUAL_P2_BASE + 0xDB)
#define REG_HDCP_DUAL_P2_6E_L           (REG_HDCP_DUAL_P2_BASE + 0xDC)
#define REG_HDCP_DUAL_P2_6E_H           (REG_HDCP_DUAL_P2_BASE + 0xDD)
#define REG_HDCP_DUAL_P2_6F_L           (REG_HDCP_DUAL_P2_BASE + 0xDE)
#define REG_HDCP_DUAL_P2_6F_H           (REG_HDCP_DUAL_P2_BASE + 0xDF)
#define REG_HDCP_DUAL_P2_70_L           (REG_HDCP_DUAL_P2_BASE + 0xE0)
#define REG_HDCP_DUAL_P2_70_H           (REG_HDCP_DUAL_P2_BASE + 0xE1)
#define REG_HDCP_DUAL_P2_71_L           (REG_HDCP_DUAL_P2_BASE + 0xE2)
#define REG_HDCP_DUAL_P2_71_H           (REG_HDCP_DUAL_P2_BASE + 0xE3)
#define REG_HDCP_DUAL_P2_72_L           (REG_HDCP_DUAL_P2_BASE + 0xE4)
#define REG_HDCP_DUAL_P2_72_H           (REG_HDCP_DUAL_P2_BASE + 0xE5)
#define REG_HDCP_DUAL_P2_73_L           (REG_HDCP_DUAL_P2_BASE + 0xE6)
#define REG_HDCP_DUAL_P2_73_H           (REG_HDCP_DUAL_P2_BASE + 0xE7)
#define REG_HDCP_DUAL_P2_74_L           (REG_HDCP_DUAL_P2_BASE + 0xE8)
#define REG_HDCP_DUAL_P2_74_H           (REG_HDCP_DUAL_P2_BASE + 0xE9)
#define REG_HDCP_DUAL_P2_75_L           (REG_HDCP_DUAL_P2_BASE + 0xEA)
#define REG_HDCP_DUAL_P2_75_H           (REG_HDCP_DUAL_P2_BASE + 0xEB)
#define REG_HDCP_DUAL_P2_76_L           (REG_HDCP_DUAL_P2_BASE + 0xEC)
#define REG_HDCP_DUAL_P2_76_H           (REG_HDCP_DUAL_P2_BASE + 0xED)
#define REG_HDCP_DUAL_P2_77_L           (REG_HDCP_DUAL_P2_BASE + 0xEE)
#define REG_HDCP_DUAL_P2_77_H           (REG_HDCP_DUAL_P2_BASE + 0xEF)
#define REG_HDCP_DUAL_P2_78_L           (REG_HDCP_DUAL_P2_BASE + 0xF0)
#define REG_HDCP_DUAL_P2_78_H           (REG_HDCP_DUAL_P2_BASE + 0xF1)
#define REG_HDCP_DUAL_P2_79_L           (REG_HDCP_DUAL_P2_BASE + 0xF2)
#define REG_HDCP_DUAL_P2_79_H           (REG_HDCP_DUAL_P2_BASE + 0xF3)
#define REG_HDCP_DUAL_P2_7A_L           (REG_HDCP_DUAL_P2_BASE + 0xF4)
#define REG_HDCP_DUAL_P2_7A_H           (REG_HDCP_DUAL_P2_BASE + 0xF5)
#define REG_HDCP_DUAL_P2_7B_L           (REG_HDCP_DUAL_P2_BASE + 0xF6)
#define REG_HDCP_DUAL_P2_7B_H           (REG_HDCP_DUAL_P2_BASE + 0xF7)
#define REG_HDCP_DUAL_P2_7C_L           (REG_HDCP_DUAL_P2_BASE + 0xF8)
#define REG_HDCP_DUAL_P2_7C_H           (REG_HDCP_DUAL_P2_BASE + 0xF9)
#define REG_HDCP_DUAL_P2_7D_L           (REG_HDCP_DUAL_P2_BASE + 0xFA)
#define REG_HDCP_DUAL_P2_7D_H           (REG_HDCP_DUAL_P2_BASE + 0xFB)
#define REG_HDCP_DUAL_P2_7E_L           (REG_HDCP_DUAL_P2_BASE + 0xFC)
#define REG_HDCP_DUAL_P2_7E_H           (REG_HDCP_DUAL_P2_BASE + 0xFD)
#define REG_HDCP_DUAL_P2_7F_L           (REG_HDCP_DUAL_P2_BASE + 0xFE)
#define REG_HDCP_DUAL_P2_7F_H           (REG_HDCP_DUAL_P2_BASE + 0xFF)

//=============================================================
// HDMIRX_DTOP_PKT_P2
#define REG_HDMIRX_DTOP_PKT_P2_00_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x00)
#define REG_HDMIRX_DTOP_PKT_P2_00_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x01)
#define REG_HDMIRX_DTOP_PKT_P2_01_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x02)
#define REG_HDMIRX_DTOP_PKT_P2_01_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x03)
#define REG_HDMIRX_DTOP_PKT_P2_02_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x04)
#define REG_HDMIRX_DTOP_PKT_P2_02_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x05)
#define REG_HDMIRX_DTOP_PKT_P2_03_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x06)
#define REG_HDMIRX_DTOP_PKT_P2_03_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x07)
#define REG_HDMIRX_DTOP_PKT_P2_04_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x08)
#define REG_HDMIRX_DTOP_PKT_P2_04_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x09)
#define REG_HDMIRX_DTOP_PKT_P2_05_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x0A)
#define REG_HDMIRX_DTOP_PKT_P2_05_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x0B)
#define REG_HDMIRX_DTOP_PKT_P2_06_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x0C)
#define REG_HDMIRX_DTOP_PKT_P2_06_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x0D)
#define REG_HDMIRX_DTOP_PKT_P2_07_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x0E)
#define REG_HDMIRX_DTOP_PKT_P2_07_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x0F)
#define REG_HDMIRX_DTOP_PKT_P2_08_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x10)
#define REG_HDMIRX_DTOP_PKT_P2_08_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x11)
#define REG_HDMIRX_DTOP_PKT_P2_09_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x12)
#define REG_HDMIRX_DTOP_PKT_P2_09_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x13)
#define REG_HDMIRX_DTOP_PKT_P2_0A_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x14)
#define REG_HDMIRX_DTOP_PKT_P2_0A_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x15)
#define REG_HDMIRX_DTOP_PKT_P2_0B_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x16)
#define REG_HDMIRX_DTOP_PKT_P2_0B_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x17)
#define REG_HDMIRX_DTOP_PKT_P2_0C_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x18)
#define REG_HDMIRX_DTOP_PKT_P2_0C_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x19)
#define REG_HDMIRX_DTOP_PKT_P2_0D_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x1A)
#define REG_HDMIRX_DTOP_PKT_P2_0D_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x1B)
#define REG_HDMIRX_DTOP_PKT_P2_0E_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x1C)
#define REG_HDMIRX_DTOP_PKT_P2_0E_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x1D)
#define REG_HDMIRX_DTOP_PKT_P2_0F_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x1E)
#define REG_HDMIRX_DTOP_PKT_P2_0F_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x1F)
#define REG_HDMIRX_DTOP_PKT_P2_10_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x20)
#define REG_HDMIRX_DTOP_PKT_P2_10_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x21)
#define REG_HDMIRX_DTOP_PKT_P2_11_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x22)
#define REG_HDMIRX_DTOP_PKT_P2_11_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x23)
#define REG_HDMIRX_DTOP_PKT_P2_12_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x24)
#define REG_HDMIRX_DTOP_PKT_P2_12_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x25)
#define REG_HDMIRX_DTOP_PKT_P2_13_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x26)
#define REG_HDMIRX_DTOP_PKT_P2_13_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x27)
#define REG_HDMIRX_DTOP_PKT_P2_14_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x28)
#define REG_HDMIRX_DTOP_PKT_P2_14_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x29)
#define REG_HDMIRX_DTOP_PKT_P2_15_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x2A)
#define REG_HDMIRX_DTOP_PKT_P2_15_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x2B)
#define REG_HDMIRX_DTOP_PKT_P2_16_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x2C)
#define REG_HDMIRX_DTOP_PKT_P2_16_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x2D)
#define REG_HDMIRX_DTOP_PKT_P2_17_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x2E)
#define REG_HDMIRX_DTOP_PKT_P2_17_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x2F)
#define REG_HDMIRX_DTOP_PKT_P2_18_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x30)
#define REG_HDMIRX_DTOP_PKT_P2_18_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x31)
#define REG_HDMIRX_DTOP_PKT_P2_19_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x32)
#define REG_HDMIRX_DTOP_PKT_P2_19_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x33)
#define REG_HDMIRX_DTOP_PKT_P2_1A_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x34)
#define REG_HDMIRX_DTOP_PKT_P2_1A_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x35)
#define REG_HDMIRX_DTOP_PKT_P2_1B_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x36)
#define REG_HDMIRX_DTOP_PKT_P2_1B_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x37)
#define REG_HDMIRX_DTOP_PKT_P2_1C_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x38)
#define REG_HDMIRX_DTOP_PKT_P2_1C_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x39)
#define REG_HDMIRX_DTOP_PKT_P2_1D_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x3A)
#define REG_HDMIRX_DTOP_PKT_P2_1D_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x3B)
#define REG_HDMIRX_DTOP_PKT_P2_1E_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x3C)
#define REG_HDMIRX_DTOP_PKT_P2_1E_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x3D)
#define REG_HDMIRX_DTOP_PKT_P2_1F_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x3E)
#define REG_HDMIRX_DTOP_PKT_P2_1F_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x3F)
#define REG_HDMIRX_DTOP_PKT_P2_20_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x40)
#define REG_HDMIRX_DTOP_PKT_P2_20_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x41)
#define REG_HDMIRX_DTOP_PKT_P2_21_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x42)
#define REG_HDMIRX_DTOP_PKT_P2_21_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x43)
#define REG_HDMIRX_DTOP_PKT_P2_22_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x44)
#define REG_HDMIRX_DTOP_PKT_P2_22_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x45)
#define REG_HDMIRX_DTOP_PKT_P2_23_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x46)
#define REG_HDMIRX_DTOP_PKT_P2_23_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x47)
#define REG_HDMIRX_DTOP_PKT_P2_24_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x48)
#define REG_HDMIRX_DTOP_PKT_P2_24_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x49)
#define REG_HDMIRX_DTOP_PKT_P2_25_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x4A)
#define REG_HDMIRX_DTOP_PKT_P2_25_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x4B)
#define REG_HDMIRX_DTOP_PKT_P2_26_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x4C)
#define REG_HDMIRX_DTOP_PKT_P2_26_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x4D)
#define REG_HDMIRX_DTOP_PKT_P2_27_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x4E)
#define REG_HDMIRX_DTOP_PKT_P2_27_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x4F)
#define REG_HDMIRX_DTOP_PKT_P2_28_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x50)
#define REG_HDMIRX_DTOP_PKT_P2_28_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x51)
#define REG_HDMIRX_DTOP_PKT_P2_29_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x52)
#define REG_HDMIRX_DTOP_PKT_P2_29_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x53)
#define REG_HDMIRX_DTOP_PKT_P2_2A_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x54)
#define REG_HDMIRX_DTOP_PKT_P2_2A_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x55)
#define REG_HDMIRX_DTOP_PKT_P2_2B_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x56)
#define REG_HDMIRX_DTOP_PKT_P2_2B_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x57)
#define REG_HDMIRX_DTOP_PKT_P2_2C_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x58)
#define REG_HDMIRX_DTOP_PKT_P2_2C_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x59)
#define REG_HDMIRX_DTOP_PKT_P2_2D_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x5A)
#define REG_HDMIRX_DTOP_PKT_P2_2D_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x5B)
#define REG_HDMIRX_DTOP_PKT_P2_2E_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x5C)
#define REG_HDMIRX_DTOP_PKT_P2_2E_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x5D)
#define REG_HDMIRX_DTOP_PKT_P2_2F_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x5E)
#define REG_HDMIRX_DTOP_PKT_P2_2F_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x5F)
#define REG_HDMIRX_DTOP_PKT_P2_30_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x60)
#define REG_HDMIRX_DTOP_PKT_P2_30_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x61)
#define REG_HDMIRX_DTOP_PKT_P2_31_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x62)
#define REG_HDMIRX_DTOP_PKT_P2_31_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x63)
#define REG_HDMIRX_DTOP_PKT_P2_32_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x64)
#define REG_HDMIRX_DTOP_PKT_P2_32_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x65)
#define REG_HDMIRX_DTOP_PKT_P2_33_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x66)
#define REG_HDMIRX_DTOP_PKT_P2_33_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x67)
#define REG_HDMIRX_DTOP_PKT_P2_34_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x68)
#define REG_HDMIRX_DTOP_PKT_P2_34_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x69)
#define REG_HDMIRX_DTOP_PKT_P2_35_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x6A)
#define REG_HDMIRX_DTOP_PKT_P2_35_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x6B)
#define REG_HDMIRX_DTOP_PKT_P2_36_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x6C)
#define REG_HDMIRX_DTOP_PKT_P2_36_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x6D)
#define REG_HDMIRX_DTOP_PKT_P2_37_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x6E)
#define REG_HDMIRX_DTOP_PKT_P2_37_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x6F)
#define REG_HDMIRX_DTOP_PKT_P2_38_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x70)
#define REG_HDMIRX_DTOP_PKT_P2_38_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x71)
#define REG_HDMIRX_DTOP_PKT_P2_39_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x72)
#define REG_HDMIRX_DTOP_PKT_P2_39_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x73)
#define REG_HDMIRX_DTOP_PKT_P2_3A_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x74)
#define REG_HDMIRX_DTOP_PKT_P2_3A_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x75)
#define REG_HDMIRX_DTOP_PKT_P2_3B_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x76)
#define REG_HDMIRX_DTOP_PKT_P2_3B_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x77)
#define REG_HDMIRX_DTOP_PKT_P2_3C_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x78)
#define REG_HDMIRX_DTOP_PKT_P2_3C_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x79)
#define REG_HDMIRX_DTOP_PKT_P2_3D_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x7A)
#define REG_HDMIRX_DTOP_PKT_P2_3D_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x7B)
#define REG_HDMIRX_DTOP_PKT_P2_3E_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x7C)
#define REG_HDMIRX_DTOP_PKT_P2_3E_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x7D)
#define REG_HDMIRX_DTOP_PKT_P2_3F_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x7E)
#define REG_HDMIRX_DTOP_PKT_P2_3F_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x7F)
#define REG_HDMIRX_DTOP_PKT_P2_40_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x80)
#define REG_HDMIRX_DTOP_PKT_P2_40_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x81)
#define REG_HDMIRX_DTOP_PKT_P2_41_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x82)
#define REG_HDMIRX_DTOP_PKT_P2_41_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x83)
#define REG_HDMIRX_DTOP_PKT_P2_42_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x84)
#define REG_HDMIRX_DTOP_PKT_P2_42_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x85)
#define REG_HDMIRX_DTOP_PKT_P2_43_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x86)
#define REG_HDMIRX_DTOP_PKT_P2_43_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x87)
#define REG_HDMIRX_DTOP_PKT_P2_44_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x88)
#define REG_HDMIRX_DTOP_PKT_P2_44_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x89)
#define REG_HDMIRX_DTOP_PKT_P2_45_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x8A)
#define REG_HDMIRX_DTOP_PKT_P2_45_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x8B)
#define REG_HDMIRX_DTOP_PKT_P2_46_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x8C)
#define REG_HDMIRX_DTOP_PKT_P2_46_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x8D)
#define REG_HDMIRX_DTOP_PKT_P2_47_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x8E)
#define REG_HDMIRX_DTOP_PKT_P2_47_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x8F)
#define REG_HDMIRX_DTOP_PKT_P2_48_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x90)
#define REG_HDMIRX_DTOP_PKT_P2_48_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x91)
#define REG_HDMIRX_DTOP_PKT_P2_49_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x92)
#define REG_HDMIRX_DTOP_PKT_P2_49_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x93)
#define REG_HDMIRX_DTOP_PKT_P2_4A_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x94)
#define REG_HDMIRX_DTOP_PKT_P2_4A_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x95)
#define REG_HDMIRX_DTOP_PKT_P2_4B_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x96)
#define REG_HDMIRX_DTOP_PKT_P2_4B_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x97)
#define REG_HDMIRX_DTOP_PKT_P2_4C_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x98)
#define REG_HDMIRX_DTOP_PKT_P2_4C_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x99)
#define REG_HDMIRX_DTOP_PKT_P2_4D_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x9A)
#define REG_HDMIRX_DTOP_PKT_P2_4D_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x9B)
#define REG_HDMIRX_DTOP_PKT_P2_4E_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x9C)
#define REG_HDMIRX_DTOP_PKT_P2_4E_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x9D)
#define REG_HDMIRX_DTOP_PKT_P2_4F_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x9E)
#define REG_HDMIRX_DTOP_PKT_P2_4F_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0x9F)
#define REG_HDMIRX_DTOP_PKT_P2_50_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xA0)
#define REG_HDMIRX_DTOP_PKT_P2_50_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xA1)
#define REG_HDMIRX_DTOP_PKT_P2_51_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xA2)
#define REG_HDMIRX_DTOP_PKT_P2_51_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xA3)
#define REG_HDMIRX_DTOP_PKT_P2_52_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xA4)
#define REG_HDMIRX_DTOP_PKT_P2_52_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xA5)
#define REG_HDMIRX_DTOP_PKT_P2_53_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xA6)
#define REG_HDMIRX_DTOP_PKT_P2_53_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xA7)
#define REG_HDMIRX_DTOP_PKT_P2_54_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xA8)
#define REG_HDMIRX_DTOP_PKT_P2_54_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xA9)
#define REG_HDMIRX_DTOP_PKT_P2_55_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xAA)
#define REG_HDMIRX_DTOP_PKT_P2_55_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xAB)
#define REG_HDMIRX_DTOP_PKT_P2_56_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xAC)
#define REG_HDMIRX_DTOP_PKT_P2_56_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xAD)
#define REG_HDMIRX_DTOP_PKT_P2_57_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xAE)
#define REG_HDMIRX_DTOP_PKT_P2_57_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xAF)
#define REG_HDMIRX_DTOP_PKT_P2_58_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xB0)
#define REG_HDMIRX_DTOP_PKT_P2_58_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xB1)
#define REG_HDMIRX_DTOP_PKT_P2_59_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xB2)
#define REG_HDMIRX_DTOP_PKT_P2_59_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xB3)
#define REG_HDMIRX_DTOP_PKT_P2_5A_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xB4)
#define REG_HDMIRX_DTOP_PKT_P2_5A_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xB5)
#define REG_HDMIRX_DTOP_PKT_P2_5B_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xB6)
#define REG_HDMIRX_DTOP_PKT_P2_5B_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xB7)
#define REG_HDMIRX_DTOP_PKT_P2_5C_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xB8)
#define REG_HDMIRX_DTOP_PKT_P2_5C_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xB9)
#define REG_HDMIRX_DTOP_PKT_P2_5D_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xBA)
#define REG_HDMIRX_DTOP_PKT_P2_5D_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xBB)
#define REG_HDMIRX_DTOP_PKT_P2_5E_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xBC)
#define REG_HDMIRX_DTOP_PKT_P2_5E_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xBD)
#define REG_HDMIRX_DTOP_PKT_P2_5F_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xBE)
#define REG_HDMIRX_DTOP_PKT_P2_5F_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xBF)
#define REG_HDMIRX_DTOP_PKT_P2_60_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xC0)
#define REG_HDMIRX_DTOP_PKT_P2_60_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xC1)
#define REG_HDMIRX_DTOP_PKT_P2_61_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xC2)
#define REG_HDMIRX_DTOP_PKT_P2_61_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xC3)
#define REG_HDMIRX_DTOP_PKT_P2_62_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xC4)
#define REG_HDMIRX_DTOP_PKT_P2_62_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xC5)
#define REG_HDMIRX_DTOP_PKT_P2_63_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xC6)
#define REG_HDMIRX_DTOP_PKT_P2_63_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xC7)
#define REG_HDMIRX_DTOP_PKT_P2_64_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xC8)
#define REG_HDMIRX_DTOP_PKT_P2_64_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xC9)
#define REG_HDMIRX_DTOP_PKT_P2_65_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xCA)
#define REG_HDMIRX_DTOP_PKT_P2_65_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xCB)
#define REG_HDMIRX_DTOP_PKT_P2_66_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xCC)
#define REG_HDMIRX_DTOP_PKT_P2_66_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xCD)
#define REG_HDMIRX_DTOP_PKT_P2_67_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xCE)
#define REG_HDMIRX_DTOP_PKT_P2_67_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xCF)
#define REG_HDMIRX_DTOP_PKT_P2_68_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xD0)
#define REG_HDMIRX_DTOP_PKT_P2_68_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xD1)
#define REG_HDMIRX_DTOP_PKT_P2_69_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xD2)
#define REG_HDMIRX_DTOP_PKT_P2_69_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xD3)
#define REG_HDMIRX_DTOP_PKT_P2_6A_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xD4)
#define REG_HDMIRX_DTOP_PKT_P2_6A_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xD5)
#define REG_HDMIRX_DTOP_PKT_P2_6B_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xD6)
#define REG_HDMIRX_DTOP_PKT_P2_6B_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xD7)
#define REG_HDMIRX_DTOP_PKT_P2_6C_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xD8)
#define REG_HDMIRX_DTOP_PKT_P2_6C_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xD9)
#define REG_HDMIRX_DTOP_PKT_P2_6D_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xDA)
#define REG_HDMIRX_DTOP_PKT_P2_6D_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xDB)
#define REG_HDMIRX_DTOP_PKT_P2_6E_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xDC)
#define REG_HDMIRX_DTOP_PKT_P2_6E_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xDD)
#define REG_HDMIRX_DTOP_PKT_P2_6F_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xDE)
#define REG_HDMIRX_DTOP_PKT_P2_6F_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xDF)
#define REG_HDMIRX_DTOP_PKT_P2_70_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xE0)
#define REG_HDMIRX_DTOP_PKT_P2_70_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xE1)
#define REG_HDMIRX_DTOP_PKT_P2_71_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xE2)
#define REG_HDMIRX_DTOP_PKT_P2_71_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xE3)
#define REG_HDMIRX_DTOP_PKT_P2_72_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xE4)
#define REG_HDMIRX_DTOP_PKT_P2_72_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xE5)
#define REG_HDMIRX_DTOP_PKT_P2_73_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xE6)
#define REG_HDMIRX_DTOP_PKT_P2_73_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xE7)
#define REG_HDMIRX_DTOP_PKT_P2_74_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xE8)
#define REG_HDMIRX_DTOP_PKT_P2_74_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xE9)
#define REG_HDMIRX_DTOP_PKT_P2_75_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xEA)
#define REG_HDMIRX_DTOP_PKT_P2_75_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xEB)
#define REG_HDMIRX_DTOP_PKT_P2_76_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xEC)
#define REG_HDMIRX_DTOP_PKT_P2_76_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xED)
#define REG_HDMIRX_DTOP_PKT_P2_77_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xEE)
#define REG_HDMIRX_DTOP_PKT_P2_77_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xEF)
#define REG_HDMIRX_DTOP_PKT_P2_78_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xF0)
#define REG_HDMIRX_DTOP_PKT_P2_78_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xF1)
#define REG_HDMIRX_DTOP_PKT_P2_79_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xF2)
#define REG_HDMIRX_DTOP_PKT_P2_79_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xF3)
#define REG_HDMIRX_DTOP_PKT_P2_7A_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xF4)
#define REG_HDMIRX_DTOP_PKT_P2_7A_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xF5)
#define REG_HDMIRX_DTOP_PKT_P2_7B_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xF6)
#define REG_HDMIRX_DTOP_PKT_P2_7B_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xF7)
#define REG_HDMIRX_DTOP_PKT_P2_7C_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xF8)
#define REG_HDMIRX_DTOP_PKT_P2_7C_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xF9)
#define REG_HDMIRX_DTOP_PKT_P2_7D_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xFA)
#define REG_HDMIRX_DTOP_PKT_P2_7D_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xFB)
#define REG_HDMIRX_DTOP_PKT_P2_7E_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xFC)
#define REG_HDMIRX_DTOP_PKT_P2_7E_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xFD)
#define REG_HDMIRX_DTOP_PKT_P2_7F_L           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xFE)
#define REG_HDMIRX_DTOP_PKT_P2_7F_H           (REG_HDMIRX_DTOP_PKT_P2_BASE + 0xFF)

//=============================================================
// DVI_DTOP_DUAL_P3
#define REG_DVI_DTOP_DUAL_P3_00_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x00)
#define REG_DVI_DTOP_DUAL_P3_00_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x01)
#define REG_DVI_DTOP_DUAL_P3_01_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x02)
#define REG_DVI_DTOP_DUAL_P3_01_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x03)
#define REG_DVI_DTOP_DUAL_P3_02_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x04)
#define REG_DVI_DTOP_DUAL_P3_02_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x05)
#define REG_DVI_DTOP_DUAL_P3_03_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x06)
#define REG_DVI_DTOP_DUAL_P3_03_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x07)
#define REG_DVI_DTOP_DUAL_P3_04_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x08)
#define REG_DVI_DTOP_DUAL_P3_04_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x09)
#define REG_DVI_DTOP_DUAL_P3_05_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x0A)
#define REG_DVI_DTOP_DUAL_P3_05_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x0B)
#define REG_DVI_DTOP_DUAL_P3_06_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x0C)
#define REG_DVI_DTOP_DUAL_P3_06_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x0D)
#define REG_DVI_DTOP_DUAL_P3_07_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x0E)
#define REG_DVI_DTOP_DUAL_P3_07_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x0F)
#define REG_DVI_DTOP_DUAL_P3_08_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x10)
#define REG_DVI_DTOP_DUAL_P3_08_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x11)
#define REG_DVI_DTOP_DUAL_P3_09_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x12)
#define REG_DVI_DTOP_DUAL_P3_09_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x13)
#define REG_DVI_DTOP_DUAL_P3_0A_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x14)
#define REG_DVI_DTOP_DUAL_P3_0A_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x15)
#define REG_DVI_DTOP_DUAL_P3_0B_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x16)
#define REG_DVI_DTOP_DUAL_P3_0B_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x17)
#define REG_DVI_DTOP_DUAL_P3_0C_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x18)
#define REG_DVI_DTOP_DUAL_P3_0C_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x19)
#define REG_DVI_DTOP_DUAL_P3_0D_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x1A)
#define REG_DVI_DTOP_DUAL_P3_0D_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x1B)
#define REG_DVI_DTOP_DUAL_P3_0E_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x1C)
#define REG_DVI_DTOP_DUAL_P3_0E_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x1D)
#define REG_DVI_DTOP_DUAL_P3_0F_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x1E)
#define REG_DVI_DTOP_DUAL_P3_0F_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x1F)
#define REG_DVI_DTOP_DUAL_P3_10_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x20)
#define REG_DVI_DTOP_DUAL_P3_10_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x21)
#define REG_DVI_DTOP_DUAL_P3_11_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x22)
#define REG_DVI_DTOP_DUAL_P3_11_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x23)
#define REG_DVI_DTOP_DUAL_P3_12_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x24)
#define REG_DVI_DTOP_DUAL_P3_12_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x25)
#define REG_DVI_DTOP_DUAL_P3_13_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x26)
#define REG_DVI_DTOP_DUAL_P3_13_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x27)
#define REG_DVI_DTOP_DUAL_P3_14_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x28)
#define REG_DVI_DTOP_DUAL_P3_14_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x29)
#define REG_DVI_DTOP_DUAL_P3_15_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x2A)
#define REG_DVI_DTOP_DUAL_P3_15_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x2B)
#define REG_DVI_DTOP_DUAL_P3_16_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x2C)
#define REG_DVI_DTOP_DUAL_P3_16_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x2D)
#define REG_DVI_DTOP_DUAL_P3_17_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x2E)
#define REG_DVI_DTOP_DUAL_P3_17_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x2F)
#define REG_DVI_DTOP_DUAL_P3_18_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x30)
#define REG_DVI_DTOP_DUAL_P3_18_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x31)
#define REG_DVI_DTOP_DUAL_P3_19_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x32)
#define REG_DVI_DTOP_DUAL_P3_19_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x33)
#define REG_DVI_DTOP_DUAL_P3_1A_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x34)
#define REG_DVI_DTOP_DUAL_P3_1A_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x35)
#define REG_DVI_DTOP_DUAL_P3_1B_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x36)
#define REG_DVI_DTOP_DUAL_P3_1B_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x37)
#define REG_DVI_DTOP_DUAL_P3_1C_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x38)
#define REG_DVI_DTOP_DUAL_P3_1C_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x39)
#define REG_DVI_DTOP_DUAL_P3_1D_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x3A)
#define REG_DVI_DTOP_DUAL_P3_1D_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x3B)
#define REG_DVI_DTOP_DUAL_P3_1E_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x3C)
#define REG_DVI_DTOP_DUAL_P3_1E_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x3D)
#define REG_DVI_DTOP_DUAL_P3_1F_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x3E)
#define REG_DVI_DTOP_DUAL_P3_1F_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x3F)
#define REG_DVI_DTOP_DUAL_P3_20_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x40)
#define REG_DVI_DTOP_DUAL_P3_20_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x41)
#define REG_DVI_DTOP_DUAL_P3_21_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x42)
#define REG_DVI_DTOP_DUAL_P3_21_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x43)
#define REG_DVI_DTOP_DUAL_P3_22_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x44)
#define REG_DVI_DTOP_DUAL_P3_22_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x45)
#define REG_DVI_DTOP_DUAL_P3_23_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x46)
#define REG_DVI_DTOP_DUAL_P3_23_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x47)
#define REG_DVI_DTOP_DUAL_P3_24_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x48)
#define REG_DVI_DTOP_DUAL_P3_24_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x49)
#define REG_DVI_DTOP_DUAL_P3_25_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x4A)
#define REG_DVI_DTOP_DUAL_P3_25_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x4B)
#define REG_DVI_DTOP_DUAL_P3_26_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x4C)
#define REG_DVI_DTOP_DUAL_P3_26_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x4D)
#define REG_DVI_DTOP_DUAL_P3_27_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x4E)
#define REG_DVI_DTOP_DUAL_P3_27_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x4F)
#define REG_DVI_DTOP_DUAL_P3_28_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x50)
#define REG_DVI_DTOP_DUAL_P3_28_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x51)
#define REG_DVI_DTOP_DUAL_P3_29_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x52)
#define REG_DVI_DTOP_DUAL_P3_29_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x53)
#define REG_DVI_DTOP_DUAL_P3_2A_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x54)
#define REG_DVI_DTOP_DUAL_P3_2A_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x55)
#define REG_DVI_DTOP_DUAL_P3_2B_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x56)
#define REG_DVI_DTOP_DUAL_P3_2B_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x57)
#define REG_DVI_DTOP_DUAL_P3_2C_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x58)
#define REG_DVI_DTOP_DUAL_P3_2C_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x59)
#define REG_DVI_DTOP_DUAL_P3_2D_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x5A)
#define REG_DVI_DTOP_DUAL_P3_2D_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x5B)
#define REG_DVI_DTOP_DUAL_P3_2E_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x5C)
#define REG_DVI_DTOP_DUAL_P3_2E_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x5D)
#define REG_DVI_DTOP_DUAL_P3_2F_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x5E)
#define REG_DVI_DTOP_DUAL_P3_2F_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x5F)
#define REG_DVI_DTOP_DUAL_P3_30_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x60)
#define REG_DVI_DTOP_DUAL_P3_30_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x61)
#define REG_DVI_DTOP_DUAL_P3_31_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x62)
#define REG_DVI_DTOP_DUAL_P3_31_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x63)
#define REG_DVI_DTOP_DUAL_P3_32_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x64)
#define REG_DVI_DTOP_DUAL_P3_32_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x65)
#define REG_DVI_DTOP_DUAL_P3_33_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x66)
#define REG_DVI_DTOP_DUAL_P3_33_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x67)
#define REG_DVI_DTOP_DUAL_P3_34_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x68)
#define REG_DVI_DTOP_DUAL_P3_34_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x69)
#define REG_DVI_DTOP_DUAL_P3_35_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x6A)
#define REG_DVI_DTOP_DUAL_P3_35_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x6B)
#define REG_DVI_DTOP_DUAL_P3_36_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x6C)
#define REG_DVI_DTOP_DUAL_P3_36_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x6D)
#define REG_DVI_DTOP_DUAL_P3_37_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x6E)
#define REG_DVI_DTOP_DUAL_P3_37_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x6F)
#define REG_DVI_DTOP_DUAL_P3_38_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x70)
#define REG_DVI_DTOP_DUAL_P3_38_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x71)
#define REG_DVI_DTOP_DUAL_P3_39_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x72)
#define REG_DVI_DTOP_DUAL_P3_39_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x73)
#define REG_DVI_DTOP_DUAL_P3_3A_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x74)
#define REG_DVI_DTOP_DUAL_P3_3A_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x75)
#define REG_DVI_DTOP_DUAL_P3_3B_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x76)
#define REG_DVI_DTOP_DUAL_P3_3B_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x77)
#define REG_DVI_DTOP_DUAL_P3_3C_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x78)
#define REG_DVI_DTOP_DUAL_P3_3C_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x79)
#define REG_DVI_DTOP_DUAL_P3_3D_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x7A)
#define REG_DVI_DTOP_DUAL_P3_3D_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x7B)
#define REG_DVI_DTOP_DUAL_P3_3E_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x7C)
#define REG_DVI_DTOP_DUAL_P3_3E_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x7D)
#define REG_DVI_DTOP_DUAL_P3_3F_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x7E)
#define REG_DVI_DTOP_DUAL_P3_3F_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x7F)
#define REG_DVI_DTOP_DUAL_P3_40_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x80)
#define REG_DVI_DTOP_DUAL_P3_40_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x81)
#define REG_DVI_DTOP_DUAL_P3_41_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x82)
#define REG_DVI_DTOP_DUAL_P3_41_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x83)
#define REG_DVI_DTOP_DUAL_P3_42_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x84)
#define REG_DVI_DTOP_DUAL_P3_42_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x85)
#define REG_DVI_DTOP_DUAL_P3_43_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x86)
#define REG_DVI_DTOP_DUAL_P3_43_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x87)
#define REG_DVI_DTOP_DUAL_P3_44_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x88)
#define REG_DVI_DTOP_DUAL_P3_44_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x89)
#define REG_DVI_DTOP_DUAL_P3_45_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x8A)
#define REG_DVI_DTOP_DUAL_P3_45_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x8B)
#define REG_DVI_DTOP_DUAL_P3_46_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x8C)
#define REG_DVI_DTOP_DUAL_P3_46_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x8D)
#define REG_DVI_DTOP_DUAL_P3_47_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x8E)
#define REG_DVI_DTOP_DUAL_P3_47_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x8F)
#define REG_DVI_DTOP_DUAL_P3_48_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x90)
#define REG_DVI_DTOP_DUAL_P3_48_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x91)
#define REG_DVI_DTOP_DUAL_P3_49_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x92)
#define REG_DVI_DTOP_DUAL_P3_49_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x93)
#define REG_DVI_DTOP_DUAL_P3_4A_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x94)
#define REG_DVI_DTOP_DUAL_P3_4A_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x95)
#define REG_DVI_DTOP_DUAL_P3_4B_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x96)
#define REG_DVI_DTOP_DUAL_P3_4B_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x97)
#define REG_DVI_DTOP_DUAL_P3_4C_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x98)
#define REG_DVI_DTOP_DUAL_P3_4C_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x99)
#define REG_DVI_DTOP_DUAL_P3_4D_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x9A)
#define REG_DVI_DTOP_DUAL_P3_4D_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x9B)
#define REG_DVI_DTOP_DUAL_P3_4E_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x9C)
#define REG_DVI_DTOP_DUAL_P3_4E_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x9D)
#define REG_DVI_DTOP_DUAL_P3_4F_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0x9E)
#define REG_DVI_DTOP_DUAL_P3_4F_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0x9F)
#define REG_DVI_DTOP_DUAL_P3_50_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xA0)
#define REG_DVI_DTOP_DUAL_P3_50_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xA1)
#define REG_DVI_DTOP_DUAL_P3_51_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xA2)
#define REG_DVI_DTOP_DUAL_P3_51_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xA3)
#define REG_DVI_DTOP_DUAL_P3_52_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xA4)
#define REG_DVI_DTOP_DUAL_P3_52_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xA5)
#define REG_DVI_DTOP_DUAL_P3_53_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xA6)
#define REG_DVI_DTOP_DUAL_P3_53_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xA7)
#define REG_DVI_DTOP_DUAL_P3_54_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xA8)
#define REG_DVI_DTOP_DUAL_P3_54_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xA9)
#define REG_DVI_DTOP_DUAL_P3_55_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xAA)
#define REG_DVI_DTOP_DUAL_P3_55_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xAB)
#define REG_DVI_DTOP_DUAL_P3_56_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xAC)
#define REG_DVI_DTOP_DUAL_P3_56_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xAD)
#define REG_DVI_DTOP_DUAL_P3_57_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xAE)
#define REG_DVI_DTOP_DUAL_P3_57_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xAF)
#define REG_DVI_DTOP_DUAL_P3_58_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xB0)
#define REG_DVI_DTOP_DUAL_P3_58_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xB1)
#define REG_DVI_DTOP_DUAL_P3_59_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xB2)
#define REG_DVI_DTOP_DUAL_P3_59_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xB3)
#define REG_DVI_DTOP_DUAL_P3_5A_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xB4)
#define REG_DVI_DTOP_DUAL_P3_5A_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xB5)
#define REG_DVI_DTOP_DUAL_P3_5B_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xB6)
#define REG_DVI_DTOP_DUAL_P3_5B_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xB7)
#define REG_DVI_DTOP_DUAL_P3_5C_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xB8)
#define REG_DVI_DTOP_DUAL_P3_5C_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xB9)
#define REG_DVI_DTOP_DUAL_P3_5D_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xBA)
#define REG_DVI_DTOP_DUAL_P3_5D_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xBB)
#define REG_DVI_DTOP_DUAL_P3_5E_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xBC)
#define REG_DVI_DTOP_DUAL_P3_5E_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xBD)
#define REG_DVI_DTOP_DUAL_P3_5F_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xBE)
#define REG_DVI_DTOP_DUAL_P3_5F_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xBF)
#define REG_DVI_DTOP_DUAL_P3_60_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xC0)
#define REG_DVI_DTOP_DUAL_P3_60_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xC1)
#define REG_DVI_DTOP_DUAL_P3_61_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xC2)
#define REG_DVI_DTOP_DUAL_P3_61_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xC3)
#define REG_DVI_DTOP_DUAL_P3_62_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xC4)
#define REG_DVI_DTOP_DUAL_P3_62_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xC5)
#define REG_DVI_DTOP_DUAL_P3_63_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xC6)
#define REG_DVI_DTOP_DUAL_P3_63_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xC7)
#define REG_DVI_DTOP_DUAL_P3_64_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xC8)
#define REG_DVI_DTOP_DUAL_P3_64_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xC9)
#define REG_DVI_DTOP_DUAL_P3_65_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xCA)
#define REG_DVI_DTOP_DUAL_P3_65_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xCB)
#define REG_DVI_DTOP_DUAL_P3_66_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xCC)
#define REG_DVI_DTOP_DUAL_P3_66_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xCD)
#define REG_DVI_DTOP_DUAL_P3_67_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xCE)
#define REG_DVI_DTOP_DUAL_P3_67_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xCF)
#define REG_DVI_DTOP_DUAL_P3_68_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xD0)
#define REG_DVI_DTOP_DUAL_P3_68_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xD1)
#define REG_DVI_DTOP_DUAL_P3_69_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xD2)
#define REG_DVI_DTOP_DUAL_P3_69_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xD3)
#define REG_DVI_DTOP_DUAL_P3_6A_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xD4)
#define REG_DVI_DTOP_DUAL_P3_6A_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xD5)
#define REG_DVI_DTOP_DUAL_P3_6B_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xD6)
#define REG_DVI_DTOP_DUAL_P3_6B_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xD7)
#define REG_DVI_DTOP_DUAL_P3_6C_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xD8)
#define REG_DVI_DTOP_DUAL_P3_6C_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xD9)
#define REG_DVI_DTOP_DUAL_P3_6D_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xDA)
#define REG_DVI_DTOP_DUAL_P3_6D_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xDB)
#define REG_DVI_DTOP_DUAL_P3_6E_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xDC)
#define REG_DVI_DTOP_DUAL_P3_6E_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xDD)
#define REG_DVI_DTOP_DUAL_P3_6F_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xDE)
#define REG_DVI_DTOP_DUAL_P3_6F_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xDF)
#define REG_DVI_DTOP_DUAL_P3_70_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xE0)
#define REG_DVI_DTOP_DUAL_P3_70_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xE1)
#define REG_DVI_DTOP_DUAL_P3_71_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xE2)
#define REG_DVI_DTOP_DUAL_P3_71_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xE3)
#define REG_DVI_DTOP_DUAL_P3_72_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xE4)
#define REG_DVI_DTOP_DUAL_P3_72_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xE5)
#define REG_DVI_DTOP_DUAL_P3_73_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xE6)
#define REG_DVI_DTOP_DUAL_P3_73_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xE7)
#define REG_DVI_DTOP_DUAL_P3_74_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xE8)
#define REG_DVI_DTOP_DUAL_P3_74_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xE9)
#define REG_DVI_DTOP_DUAL_P3_75_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xEA)
#define REG_DVI_DTOP_DUAL_P3_75_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xEB)
#define REG_DVI_DTOP_DUAL_P3_76_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xEC)
#define REG_DVI_DTOP_DUAL_P3_76_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xED)
#define REG_DVI_DTOP_DUAL_P3_77_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xEE)
#define REG_DVI_DTOP_DUAL_P3_77_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xEF)
#define REG_DVI_DTOP_DUAL_P3_78_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xF0)
#define REG_DVI_DTOP_DUAL_P3_78_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xF1)
#define REG_DVI_DTOP_DUAL_P3_79_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xF2)
#define REG_DVI_DTOP_DUAL_P3_79_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xF3)
#define REG_DVI_DTOP_DUAL_P3_7A_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xF4)
#define REG_DVI_DTOP_DUAL_P3_7A_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xF5)
#define REG_DVI_DTOP_DUAL_P3_7B_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xF6)
#define REG_DVI_DTOP_DUAL_P3_7B_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xF7)
#define REG_DVI_DTOP_DUAL_P3_7C_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xF8)
#define REG_DVI_DTOP_DUAL_P3_7C_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xF9)
#define REG_DVI_DTOP_DUAL_P3_7D_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xFA)
#define REG_DVI_DTOP_DUAL_P3_7D_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xFB)
#define REG_DVI_DTOP_DUAL_P3_7E_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xFC)
#define REG_DVI_DTOP_DUAL_P3_7E_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xFD)
#define REG_DVI_DTOP_DUAL_P3_7F_L       (REG_DVI_DTOP_DUAL_P3_BASE + 0xFE)
#define REG_DVI_DTOP_DUAL_P3_7F_H       (REG_DVI_DTOP_DUAL_P3_BASE + 0xFF)

//=============================================================
// DVI_RSV_DUAL_P3
#define REG_DVI_RSV_DUAL_P3_00_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x00)
#define REG_DVI_RSV_DUAL_P3_00_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x01)
#define REG_DVI_RSV_DUAL_P3_01_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x02)
#define REG_DVI_RSV_DUAL_P3_01_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x03)
#define REG_DVI_RSV_DUAL_P3_02_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x04)
#define REG_DVI_RSV_DUAL_P3_02_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x05)
#define REG_DVI_RSV_DUAL_P3_03_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x06)
#define REG_DVI_RSV_DUAL_P3_03_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x07)
#define REG_DVI_RSV_DUAL_P3_04_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x08)
#define REG_DVI_RSV_DUAL_P3_04_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x09)
#define REG_DVI_RSV_DUAL_P3_05_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x0A)
#define REG_DVI_RSV_DUAL_P3_05_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x0B)
#define REG_DVI_RSV_DUAL_P3_06_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x0C)
#define REG_DVI_RSV_DUAL_P3_06_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x0D)
#define REG_DVI_RSV_DUAL_P3_07_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x0E)
#define REG_DVI_RSV_DUAL_P3_07_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x0F)
#define REG_DVI_RSV_DUAL_P3_08_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x10)
#define REG_DVI_RSV_DUAL_P3_08_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x11)
#define REG_DVI_RSV_DUAL_P3_09_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x12)
#define REG_DVI_RSV_DUAL_P3_09_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x13)
#define REG_DVI_RSV_DUAL_P3_0A_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x14)
#define REG_DVI_RSV_DUAL_P3_0A_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x15)
#define REG_DVI_RSV_DUAL_P3_0B_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x16)
#define REG_DVI_RSV_DUAL_P3_0B_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x17)
#define REG_DVI_RSV_DUAL_P3_0C_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x18)
#define REG_DVI_RSV_DUAL_P3_0C_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x19)
#define REG_DVI_RSV_DUAL_P3_0D_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x1A)
#define REG_DVI_RSV_DUAL_P3_0D_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x1B)
#define REG_DVI_RSV_DUAL_P3_0E_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x1C)
#define REG_DVI_RSV_DUAL_P3_0E_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x1D)
#define REG_DVI_RSV_DUAL_P3_0F_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x1E)
#define REG_DVI_RSV_DUAL_P3_0F_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x1F)
#define REG_DVI_RSV_DUAL_P3_10_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x20)
#define REG_DVI_RSV_DUAL_P3_10_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x21)
#define REG_DVI_RSV_DUAL_P3_11_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x22)
#define REG_DVI_RSV_DUAL_P3_11_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x23)
#define REG_DVI_RSV_DUAL_P3_12_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x24)
#define REG_DVI_RSV_DUAL_P3_12_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x25)
#define REG_DVI_RSV_DUAL_P3_13_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x26)
#define REG_DVI_RSV_DUAL_P3_13_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x27)
#define REG_DVI_RSV_DUAL_P3_14_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x28)
#define REG_DVI_RSV_DUAL_P3_14_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x29)
#define REG_DVI_RSV_DUAL_P3_15_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x2A)
#define REG_DVI_RSV_DUAL_P3_15_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x2B)
#define REG_DVI_RSV_DUAL_P3_16_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x2C)
#define REG_DVI_RSV_DUAL_P3_16_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x2D)
#define REG_DVI_RSV_DUAL_P3_17_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x2E)
#define REG_DVI_RSV_DUAL_P3_17_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x2F)
#define REG_DVI_RSV_DUAL_P3_18_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x30)
#define REG_DVI_RSV_DUAL_P3_18_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x31)
#define REG_DVI_RSV_DUAL_P3_19_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x32)
#define REG_DVI_RSV_DUAL_P3_19_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x33)
#define REG_DVI_RSV_DUAL_P3_1A_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x34)
#define REG_DVI_RSV_DUAL_P3_1A_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x35)
#define REG_DVI_RSV_DUAL_P3_1B_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x36)
#define REG_DVI_RSV_DUAL_P3_1B_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x37)
#define REG_DVI_RSV_DUAL_P3_1C_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x38)
#define REG_DVI_RSV_DUAL_P3_1C_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x39)
#define REG_DVI_RSV_DUAL_P3_1D_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x3A)
#define REG_DVI_RSV_DUAL_P3_1D_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x3B)
#define REG_DVI_RSV_DUAL_P3_1E_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x3C)
#define REG_DVI_RSV_DUAL_P3_1E_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x3D)
#define REG_DVI_RSV_DUAL_P3_1F_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x3E)
#define REG_DVI_RSV_DUAL_P3_1F_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x3F)
#define REG_DVI_RSV_DUAL_P3_20_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x40)
#define REG_DVI_RSV_DUAL_P3_20_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x41)
#define REG_DVI_RSV_DUAL_P3_21_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x42)
#define REG_DVI_RSV_DUAL_P3_21_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x43)
#define REG_DVI_RSV_DUAL_P3_22_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x44)
#define REG_DVI_RSV_DUAL_P3_22_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x45)
#define REG_DVI_RSV_DUAL_P3_23_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x46)
#define REG_DVI_RSV_DUAL_P3_23_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x47)
#define REG_DVI_RSV_DUAL_P3_24_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x48)
#define REG_DVI_RSV_DUAL_P3_24_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x49)
#define REG_DVI_RSV_DUAL_P3_25_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x4A)
#define REG_DVI_RSV_DUAL_P3_25_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x4B)
#define REG_DVI_RSV_DUAL_P3_26_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x4C)
#define REG_DVI_RSV_DUAL_P3_26_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x4D)
#define REG_DVI_RSV_DUAL_P3_27_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x4E)
#define REG_DVI_RSV_DUAL_P3_27_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x4F)
#define REG_DVI_RSV_DUAL_P3_28_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x50)
#define REG_DVI_RSV_DUAL_P3_28_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x51)
#define REG_DVI_RSV_DUAL_P3_29_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x52)
#define REG_DVI_RSV_DUAL_P3_29_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x53)
#define REG_DVI_RSV_DUAL_P3_2A_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x54)
#define REG_DVI_RSV_DUAL_P3_2A_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x55)
#define REG_DVI_RSV_DUAL_P3_2B_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x56)
#define REG_DVI_RSV_DUAL_P3_2B_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x57)
#define REG_DVI_RSV_DUAL_P3_2C_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x58)
#define REG_DVI_RSV_DUAL_P3_2C_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x59)
#define REG_DVI_RSV_DUAL_P3_2D_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x5A)
#define REG_DVI_RSV_DUAL_P3_2D_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x5B)
#define REG_DVI_RSV_DUAL_P3_2E_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x5C)
#define REG_DVI_RSV_DUAL_P3_2E_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x5D)
#define REG_DVI_RSV_DUAL_P3_2F_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x5E)
#define REG_DVI_RSV_DUAL_P3_2F_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x5F)
#define REG_DVI_RSV_DUAL_P3_30_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x60)
#define REG_DVI_RSV_DUAL_P3_30_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x61)
#define REG_DVI_RSV_DUAL_P3_31_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x62)
#define REG_DVI_RSV_DUAL_P3_31_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x63)
#define REG_DVI_RSV_DUAL_P3_32_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x64)
#define REG_DVI_RSV_DUAL_P3_32_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x65)
#define REG_DVI_RSV_DUAL_P3_33_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x66)
#define REG_DVI_RSV_DUAL_P3_33_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x67)
#define REG_DVI_RSV_DUAL_P3_34_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x68)
#define REG_DVI_RSV_DUAL_P3_34_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x69)
#define REG_DVI_RSV_DUAL_P3_35_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x6A)
#define REG_DVI_RSV_DUAL_P3_35_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x6B)
#define REG_DVI_RSV_DUAL_P3_36_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x6C)
#define REG_DVI_RSV_DUAL_P3_36_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x6D)
#define REG_DVI_RSV_DUAL_P3_37_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x6E)
#define REG_DVI_RSV_DUAL_P3_37_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x6F)
#define REG_DVI_RSV_DUAL_P3_38_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x70)
#define REG_DVI_RSV_DUAL_P3_38_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x71)
#define REG_DVI_RSV_DUAL_P3_39_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x72)
#define REG_DVI_RSV_DUAL_P3_39_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x73)
#define REG_DVI_RSV_DUAL_P3_3A_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x74)
#define REG_DVI_RSV_DUAL_P3_3A_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x75)
#define REG_DVI_RSV_DUAL_P3_3B_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x76)
#define REG_DVI_RSV_DUAL_P3_3B_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x77)
#define REG_DVI_RSV_DUAL_P3_3C_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x78)
#define REG_DVI_RSV_DUAL_P3_3C_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x79)
#define REG_DVI_RSV_DUAL_P3_3D_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x7A)
#define REG_DVI_RSV_DUAL_P3_3D_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x7B)
#define REG_DVI_RSV_DUAL_P3_3E_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x7C)
#define REG_DVI_RSV_DUAL_P3_3E_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x7D)
#define REG_DVI_RSV_DUAL_P3_3F_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x7E)
#define REG_DVI_RSV_DUAL_P3_3F_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x7F)
#define REG_DVI_RSV_DUAL_P3_40_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x80)
#define REG_DVI_RSV_DUAL_P3_40_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x81)
#define REG_DVI_RSV_DUAL_P3_41_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x82)
#define REG_DVI_RSV_DUAL_P3_41_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x83)
#define REG_DVI_RSV_DUAL_P3_42_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x84)
#define REG_DVI_RSV_DUAL_P3_42_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x85)
#define REG_DVI_RSV_DUAL_P3_43_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x86)
#define REG_DVI_RSV_DUAL_P3_43_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x87)
#define REG_DVI_RSV_DUAL_P3_44_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x88)
#define REG_DVI_RSV_DUAL_P3_44_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x89)
#define REG_DVI_RSV_DUAL_P3_45_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x8A)
#define REG_DVI_RSV_DUAL_P3_45_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x8B)
#define REG_DVI_RSV_DUAL_P3_46_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x8C)
#define REG_DVI_RSV_DUAL_P3_46_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x8D)
#define REG_DVI_RSV_DUAL_P3_47_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x8E)
#define REG_DVI_RSV_DUAL_P3_47_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x8F)
#define REG_DVI_RSV_DUAL_P3_48_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x90)
#define REG_DVI_RSV_DUAL_P3_48_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x91)
#define REG_DVI_RSV_DUAL_P3_49_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x92)
#define REG_DVI_RSV_DUAL_P3_49_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x93)
#define REG_DVI_RSV_DUAL_P3_4A_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x94)
#define REG_DVI_RSV_DUAL_P3_4A_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x95)
#define REG_DVI_RSV_DUAL_P3_4B_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x96)
#define REG_DVI_RSV_DUAL_P3_4B_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x97)
#define REG_DVI_RSV_DUAL_P3_4C_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x98)
#define REG_DVI_RSV_DUAL_P3_4C_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x99)
#define REG_DVI_RSV_DUAL_P3_4D_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x9A)
#define REG_DVI_RSV_DUAL_P3_4D_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x9B)
#define REG_DVI_RSV_DUAL_P3_4E_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x9C)
#define REG_DVI_RSV_DUAL_P3_4E_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x9D)
#define REG_DVI_RSV_DUAL_P3_4F_L        (REG_DVI_RSV_DUAL_P3_BASE + 0x9E)
#define REG_DVI_RSV_DUAL_P3_4F_H        (REG_DVI_RSV_DUAL_P3_BASE + 0x9F)
#define REG_DVI_RSV_DUAL_P3_50_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xA0)
#define REG_DVI_RSV_DUAL_P3_50_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xA1)
#define REG_DVI_RSV_DUAL_P3_51_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xA2)
#define REG_DVI_RSV_DUAL_P3_51_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xA3)
#define REG_DVI_RSV_DUAL_P3_52_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xA4)
#define REG_DVI_RSV_DUAL_P3_52_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xA5)
#define REG_DVI_RSV_DUAL_P3_53_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xA6)
#define REG_DVI_RSV_DUAL_P3_53_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xA7)
#define REG_DVI_RSV_DUAL_P3_54_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xA8)
#define REG_DVI_RSV_DUAL_P3_54_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xA9)
#define REG_DVI_RSV_DUAL_P3_55_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xAA)
#define REG_DVI_RSV_DUAL_P3_55_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xAB)
#define REG_DVI_RSV_DUAL_P3_56_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xAC)
#define REG_DVI_RSV_DUAL_P3_56_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xAD)
#define REG_DVI_RSV_DUAL_P3_57_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xAE)
#define REG_DVI_RSV_DUAL_P3_57_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xAF)
#define REG_DVI_RSV_DUAL_P3_58_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xB0)
#define REG_DVI_RSV_DUAL_P3_58_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xB1)
#define REG_DVI_RSV_DUAL_P3_59_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xB2)
#define REG_DVI_RSV_DUAL_P3_59_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xB3)
#define REG_DVI_RSV_DUAL_P3_5A_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xB4)
#define REG_DVI_RSV_DUAL_P3_5A_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xB5)
#define REG_DVI_RSV_DUAL_P3_5B_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xB6)
#define REG_DVI_RSV_DUAL_P3_5B_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xB7)
#define REG_DVI_RSV_DUAL_P3_5C_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xB8)
#define REG_DVI_RSV_DUAL_P3_5C_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xB9)
#define REG_DVI_RSV_DUAL_P3_5D_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xBA)
#define REG_DVI_RSV_DUAL_P3_5D_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xBB)
#define REG_DVI_RSV_DUAL_P3_5E_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xBC)
#define REG_DVI_RSV_DUAL_P3_5E_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xBD)
#define REG_DVI_RSV_DUAL_P3_5F_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xBE)
#define REG_DVI_RSV_DUAL_P3_5F_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xBF)
#define REG_DVI_RSV_DUAL_P3_60_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xC0)
#define REG_DVI_RSV_DUAL_P3_60_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xC1)
#define REG_DVI_RSV_DUAL_P3_61_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xC2)
#define REG_DVI_RSV_DUAL_P3_61_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xC3)
#define REG_DVI_RSV_DUAL_P3_62_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xC4)
#define REG_DVI_RSV_DUAL_P3_62_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xC5)
#define REG_DVI_RSV_DUAL_P3_63_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xC6)
#define REG_DVI_RSV_DUAL_P3_63_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xC7)
#define REG_DVI_RSV_DUAL_P3_64_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xC8)
#define REG_DVI_RSV_DUAL_P3_64_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xC9)
#define REG_DVI_RSV_DUAL_P3_65_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xCA)
#define REG_DVI_RSV_DUAL_P3_65_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xCB)
#define REG_DVI_RSV_DUAL_P3_66_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xCC)
#define REG_DVI_RSV_DUAL_P3_66_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xCD)
#define REG_DVI_RSV_DUAL_P3_67_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xCE)
#define REG_DVI_RSV_DUAL_P3_67_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xCF)
#define REG_DVI_RSV_DUAL_P3_68_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xD0)
#define REG_DVI_RSV_DUAL_P3_68_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xD1)
#define REG_DVI_RSV_DUAL_P3_69_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xD2)
#define REG_DVI_RSV_DUAL_P3_69_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xD3)
#define REG_DVI_RSV_DUAL_P3_6A_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xD4)
#define REG_DVI_RSV_DUAL_P3_6A_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xD5)
#define REG_DVI_RSV_DUAL_P3_6B_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xD6)
#define REG_DVI_RSV_DUAL_P3_6B_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xD7)
#define REG_DVI_RSV_DUAL_P3_6C_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xD8)
#define REG_DVI_RSV_DUAL_P3_6C_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xD9)
#define REG_DVI_RSV_DUAL_P3_6D_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xDA)
#define REG_DVI_RSV_DUAL_P3_6D_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xDB)
#define REG_DVI_RSV_DUAL_P3_6E_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xDC)
#define REG_DVI_RSV_DUAL_P3_6E_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xDD)
#define REG_DVI_RSV_DUAL_P3_6F_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xDE)
#define REG_DVI_RSV_DUAL_P3_6F_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xDF)
#define REG_DVI_RSV_DUAL_P3_70_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xE0)
#define REG_DVI_RSV_DUAL_P3_70_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xE1)
#define REG_DVI_RSV_DUAL_P3_71_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xE2)
#define REG_DVI_RSV_DUAL_P3_71_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xE3)
#define REG_DVI_RSV_DUAL_P3_72_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xE4)
#define REG_DVI_RSV_DUAL_P3_72_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xE5)
#define REG_DVI_RSV_DUAL_P3_73_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xE6)
#define REG_DVI_RSV_DUAL_P3_73_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xE7)
#define REG_DVI_RSV_DUAL_P3_74_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xE8)
#define REG_DVI_RSV_DUAL_P3_74_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xE9)
#define REG_DVI_RSV_DUAL_P3_75_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xEA)
#define REG_DVI_RSV_DUAL_P3_75_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xEB)
#define REG_DVI_RSV_DUAL_P3_76_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xEC)
#define REG_DVI_RSV_DUAL_P3_76_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xED)
#define REG_DVI_RSV_DUAL_P3_77_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xEE)
#define REG_DVI_RSV_DUAL_P3_77_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xEF)
#define REG_DVI_RSV_DUAL_P3_78_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xF0)
#define REG_DVI_RSV_DUAL_P3_78_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xF1)
#define REG_DVI_RSV_DUAL_P3_79_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xF2)
#define REG_DVI_RSV_DUAL_P3_79_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xF3)
#define REG_DVI_RSV_DUAL_P3_7A_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xF4)
#define REG_DVI_RSV_DUAL_P3_7A_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xF5)
#define REG_DVI_RSV_DUAL_P3_7B_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xF6)
#define REG_DVI_RSV_DUAL_P3_7B_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xF7)
#define REG_DVI_RSV_DUAL_P3_7C_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xF8)
#define REG_DVI_RSV_DUAL_P3_7C_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xF9)
#define REG_DVI_RSV_DUAL_P3_7D_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xFA)
#define REG_DVI_RSV_DUAL_P3_7D_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xFB)
#define REG_DVI_RSV_DUAL_P3_7E_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xFC)
#define REG_DVI_RSV_DUAL_P3_7E_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xFD)
#define REG_DVI_RSV_DUAL_P3_7F_L        (REG_DVI_RSV_DUAL_P3_BASE + 0xFE)
#define REG_DVI_RSV_DUAL_P3_7F_H        (REG_DVI_RSV_DUAL_P3_BASE + 0xFF)

//=============================================================
// HDCP_DUAL_P3
#define REG_HDCP_DUAL_P3_00_L           (REG_HDCP_DUAL_P3_BASE + 0x00)
#define REG_HDCP_DUAL_P3_00_H           (REG_HDCP_DUAL_P3_BASE + 0x01)
#define REG_HDCP_DUAL_P3_01_L           (REG_HDCP_DUAL_P3_BASE + 0x02)
#define REG_HDCP_DUAL_P3_01_H           (REG_HDCP_DUAL_P3_BASE + 0x03)
#define REG_HDCP_DUAL_P3_02_L           (REG_HDCP_DUAL_P3_BASE + 0x04)
#define REG_HDCP_DUAL_P3_02_H           (REG_HDCP_DUAL_P3_BASE + 0x05)
#define REG_HDCP_DUAL_P3_03_L           (REG_HDCP_DUAL_P3_BASE + 0x06)
#define REG_HDCP_DUAL_P3_03_H           (REG_HDCP_DUAL_P3_BASE + 0x07)
#define REG_HDCP_DUAL_P3_04_L           (REG_HDCP_DUAL_P3_BASE + 0x08)
#define REG_HDCP_DUAL_P3_04_H           (REG_HDCP_DUAL_P3_BASE + 0x09)
#define REG_HDCP_DUAL_P3_05_L           (REG_HDCP_DUAL_P3_BASE + 0x0A)
#define REG_HDCP_DUAL_P3_05_H           (REG_HDCP_DUAL_P3_BASE + 0x0B)
#define REG_HDCP_DUAL_P3_06_L           (REG_HDCP_DUAL_P3_BASE + 0x0C)
#define REG_HDCP_DUAL_P3_06_H           (REG_HDCP_DUAL_P3_BASE + 0x0D)
#define REG_HDCP_DUAL_P3_07_L           (REG_HDCP_DUAL_P3_BASE + 0x0E)
#define REG_HDCP_DUAL_P3_07_H           (REG_HDCP_DUAL_P3_BASE + 0x0F)
#define REG_HDCP_DUAL_P3_08_L           (REG_HDCP_DUAL_P3_BASE + 0x10)
#define REG_HDCP_DUAL_P3_08_H           (REG_HDCP_DUAL_P3_BASE + 0x11)
#define REG_HDCP_DUAL_P3_09_L           (REG_HDCP_DUAL_P3_BASE + 0x12)
#define REG_HDCP_DUAL_P3_09_H           (REG_HDCP_DUAL_P3_BASE + 0x13)
#define REG_HDCP_DUAL_P3_0A_L           (REG_HDCP_DUAL_P3_BASE + 0x14)
#define REG_HDCP_DUAL_P3_0A_H           (REG_HDCP_DUAL_P3_BASE + 0x15)
#define REG_HDCP_DUAL_P3_0B_L           (REG_HDCP_DUAL_P3_BASE + 0x16)
#define REG_HDCP_DUAL_P3_0B_H           (REG_HDCP_DUAL_P3_BASE + 0x17)
#define REG_HDCP_DUAL_P3_0C_L           (REG_HDCP_DUAL_P3_BASE + 0x18)
#define REG_HDCP_DUAL_P3_0C_H           (REG_HDCP_DUAL_P3_BASE + 0x19)
#define REG_HDCP_DUAL_P3_0D_L           (REG_HDCP_DUAL_P3_BASE + 0x1A)
#define REG_HDCP_DUAL_P3_0D_H           (REG_HDCP_DUAL_P3_BASE + 0x1B)
#define REG_HDCP_DUAL_P3_0E_L           (REG_HDCP_DUAL_P3_BASE + 0x1C)
#define REG_HDCP_DUAL_P3_0E_H           (REG_HDCP_DUAL_P3_BASE + 0x1D)
#define REG_HDCP_DUAL_P3_0F_L           (REG_HDCP_DUAL_P3_BASE + 0x1E)
#define REG_HDCP_DUAL_P3_0F_H           (REG_HDCP_DUAL_P3_BASE + 0x1F)
#define REG_HDCP_DUAL_P3_10_L           (REG_HDCP_DUAL_P3_BASE + 0x20)
#define REG_HDCP_DUAL_P3_10_H           (REG_HDCP_DUAL_P3_BASE + 0x21)
#define REG_HDCP_DUAL_P3_11_L           (REG_HDCP_DUAL_P3_BASE + 0x22)
#define REG_HDCP_DUAL_P3_11_H           (REG_HDCP_DUAL_P3_BASE + 0x23)
#define REG_HDCP_DUAL_P3_12_L           (REG_HDCP_DUAL_P3_BASE + 0x24)
#define REG_HDCP_DUAL_P3_12_H           (REG_HDCP_DUAL_P3_BASE + 0x25)
#define REG_HDCP_DUAL_P3_13_L           (REG_HDCP_DUAL_P3_BASE + 0x26)
#define REG_HDCP_DUAL_P3_13_H           (REG_HDCP_DUAL_P3_BASE + 0x27)
#define REG_HDCP_DUAL_P3_14_L           (REG_HDCP_DUAL_P3_BASE + 0x28)
#define REG_HDCP_DUAL_P3_14_H           (REG_HDCP_DUAL_P3_BASE + 0x29)
#define REG_HDCP_DUAL_P3_15_L           (REG_HDCP_DUAL_P3_BASE + 0x2A)
#define REG_HDCP_DUAL_P3_15_H           (REG_HDCP_DUAL_P3_BASE + 0x2B)
#define REG_HDCP_DUAL_P3_16_L           (REG_HDCP_DUAL_P3_BASE + 0x2C)
#define REG_HDCP_DUAL_P3_16_H           (REG_HDCP_DUAL_P3_BASE + 0x2D)
#define REG_HDCP_DUAL_P3_17_L           (REG_HDCP_DUAL_P3_BASE + 0x2E)
#define REG_HDCP_DUAL_P3_17_H           (REG_HDCP_DUAL_P3_BASE + 0x2F)
#define REG_HDCP_DUAL_P3_18_L           (REG_HDCP_DUAL_P3_BASE + 0x30)
#define REG_HDCP_DUAL_P3_18_H           (REG_HDCP_DUAL_P3_BASE + 0x31)
#define REG_HDCP_DUAL_P3_19_L           (REG_HDCP_DUAL_P3_BASE + 0x32)
#define REG_HDCP_DUAL_P3_19_H           (REG_HDCP_DUAL_P3_BASE + 0x33)
#define REG_HDCP_DUAL_P3_1A_L           (REG_HDCP_DUAL_P3_BASE + 0x34)
#define REG_HDCP_DUAL_P3_1A_H           (REG_HDCP_DUAL_P3_BASE + 0x35)
#define REG_HDCP_DUAL_P3_1B_L           (REG_HDCP_DUAL_P3_BASE + 0x36)
#define REG_HDCP_DUAL_P3_1B_H           (REG_HDCP_DUAL_P3_BASE + 0x37)
#define REG_HDCP_DUAL_P3_1C_L           (REG_HDCP_DUAL_P3_BASE + 0x38)
#define REG_HDCP_DUAL_P3_1C_H           (REG_HDCP_DUAL_P3_BASE + 0x39)
#define REG_HDCP_DUAL_P3_1D_L           (REG_HDCP_DUAL_P3_BASE + 0x3A)
#define REG_HDCP_DUAL_P3_1D_H           (REG_HDCP_DUAL_P3_BASE + 0x3B)
#define REG_HDCP_DUAL_P3_1E_L           (REG_HDCP_DUAL_P3_BASE + 0x3C)
#define REG_HDCP_DUAL_P3_1E_H           (REG_HDCP_DUAL_P3_BASE + 0x3D)
#define REG_HDCP_DUAL_P3_1F_L           (REG_HDCP_DUAL_P3_BASE + 0x3E)
#define REG_HDCP_DUAL_P3_1F_H           (REG_HDCP_DUAL_P3_BASE + 0x3F)
#define REG_HDCP_DUAL_P3_20_L           (REG_HDCP_DUAL_P3_BASE + 0x40)
#define REG_HDCP_DUAL_P3_20_H           (REG_HDCP_DUAL_P3_BASE + 0x41)
#define REG_HDCP_DUAL_P3_21_L           (REG_HDCP_DUAL_P3_BASE + 0x42)
#define REG_HDCP_DUAL_P3_21_H           (REG_HDCP_DUAL_P3_BASE + 0x43)
#define REG_HDCP_DUAL_P3_22_L           (REG_HDCP_DUAL_P3_BASE + 0x44)
#define REG_HDCP_DUAL_P3_22_H           (REG_HDCP_DUAL_P3_BASE + 0x45)
#define REG_HDCP_DUAL_P3_23_L           (REG_HDCP_DUAL_P3_BASE + 0x46)
#define REG_HDCP_DUAL_P3_23_H           (REG_HDCP_DUAL_P3_BASE + 0x47)
#define REG_HDCP_DUAL_P3_24_L           (REG_HDCP_DUAL_P3_BASE + 0x48)
#define REG_HDCP_DUAL_P3_24_H           (REG_HDCP_DUAL_P3_BASE + 0x49)
#define REG_HDCP_DUAL_P3_25_L           (REG_HDCP_DUAL_P3_BASE + 0x4A)
#define REG_HDCP_DUAL_P3_25_H           (REG_HDCP_DUAL_P3_BASE + 0x4B)
#define REG_HDCP_DUAL_P3_26_L           (REG_HDCP_DUAL_P3_BASE + 0x4C)
#define REG_HDCP_DUAL_P3_26_H           (REG_HDCP_DUAL_P3_BASE + 0x4D)
#define REG_HDCP_DUAL_P3_27_L           (REG_HDCP_DUAL_P3_BASE + 0x4E)
#define REG_HDCP_DUAL_P3_27_H           (REG_HDCP_DUAL_P3_BASE + 0x4F)
#define REG_HDCP_DUAL_P3_28_L           (REG_HDCP_DUAL_P3_BASE + 0x50)
#define REG_HDCP_DUAL_P3_28_H           (REG_HDCP_DUAL_P3_BASE + 0x51)
#define REG_HDCP_DUAL_P3_29_L           (REG_HDCP_DUAL_P3_BASE + 0x52)
#define REG_HDCP_DUAL_P3_29_H           (REG_HDCP_DUAL_P3_BASE + 0x53)
#define REG_HDCP_DUAL_P3_2A_L           (REG_HDCP_DUAL_P3_BASE + 0x54)
#define REG_HDCP_DUAL_P3_2A_H           (REG_HDCP_DUAL_P3_BASE + 0x55)
#define REG_HDCP_DUAL_P3_2B_L           (REG_HDCP_DUAL_P3_BASE + 0x56)
#define REG_HDCP_DUAL_P3_2B_H           (REG_HDCP_DUAL_P3_BASE + 0x57)
#define REG_HDCP_DUAL_P3_2C_L           (REG_HDCP_DUAL_P3_BASE + 0x58)
#define REG_HDCP_DUAL_P3_2C_H           (REG_HDCP_DUAL_P3_BASE + 0x59)
#define REG_HDCP_DUAL_P3_2D_L           (REG_HDCP_DUAL_P3_BASE + 0x5A)
#define REG_HDCP_DUAL_P3_2D_H           (REG_HDCP_DUAL_P3_BASE + 0x5B)
#define REG_HDCP_DUAL_P3_2E_L           (REG_HDCP_DUAL_P3_BASE + 0x5C)
#define REG_HDCP_DUAL_P3_2E_H           (REG_HDCP_DUAL_P3_BASE + 0x5D)
#define REG_HDCP_DUAL_P3_2F_L           (REG_HDCP_DUAL_P3_BASE + 0x5E)
#define REG_HDCP_DUAL_P3_2F_H           (REG_HDCP_DUAL_P3_BASE + 0x5F)
#define REG_HDCP_DUAL_P3_30_L           (REG_HDCP_DUAL_P3_BASE + 0x60)
#define REG_HDCP_DUAL_P3_30_H           (REG_HDCP_DUAL_P3_BASE + 0x61)
#define REG_HDCP_DUAL_P3_31_L           (REG_HDCP_DUAL_P3_BASE + 0x62)
#define REG_HDCP_DUAL_P3_31_H           (REG_HDCP_DUAL_P3_BASE + 0x63)
#define REG_HDCP_DUAL_P3_32_L           (REG_HDCP_DUAL_P3_BASE + 0x64)
#define REG_HDCP_DUAL_P3_32_H           (REG_HDCP_DUAL_P3_BASE + 0x65)
#define REG_HDCP_DUAL_P3_33_L           (REG_HDCP_DUAL_P3_BASE + 0x66)
#define REG_HDCP_DUAL_P3_33_H           (REG_HDCP_DUAL_P3_BASE + 0x67)
#define REG_HDCP_DUAL_P3_34_L           (REG_HDCP_DUAL_P3_BASE + 0x68)
#define REG_HDCP_DUAL_P3_34_H           (REG_HDCP_DUAL_P3_BASE + 0x69)
#define REG_HDCP_DUAL_P3_35_L           (REG_HDCP_DUAL_P3_BASE + 0x6A)
#define REG_HDCP_DUAL_P3_35_H           (REG_HDCP_DUAL_P3_BASE + 0x6B)
#define REG_HDCP_DUAL_P3_36_L           (REG_HDCP_DUAL_P3_BASE + 0x6C)
#define REG_HDCP_DUAL_P3_36_H           (REG_HDCP_DUAL_P3_BASE + 0x6D)
#define REG_HDCP_DUAL_P3_37_L           (REG_HDCP_DUAL_P3_BASE + 0x6E)
#define REG_HDCP_DUAL_P3_37_H           (REG_HDCP_DUAL_P3_BASE + 0x6F)
#define REG_HDCP_DUAL_P3_38_L           (REG_HDCP_DUAL_P3_BASE + 0x70)
#define REG_HDCP_DUAL_P3_38_H           (REG_HDCP_DUAL_P3_BASE + 0x71)
#define REG_HDCP_DUAL_P3_39_L           (REG_HDCP_DUAL_P3_BASE + 0x72)
#define REG_HDCP_DUAL_P3_39_H           (REG_HDCP_DUAL_P3_BASE + 0x73)
#define REG_HDCP_DUAL_P3_3A_L           (REG_HDCP_DUAL_P3_BASE + 0x74)
#define REG_HDCP_DUAL_P3_3A_H           (REG_HDCP_DUAL_P3_BASE + 0x75)
#define REG_HDCP_DUAL_P3_3B_L           (REG_HDCP_DUAL_P3_BASE + 0x76)
#define REG_HDCP_DUAL_P3_3B_H           (REG_HDCP_DUAL_P3_BASE + 0x77)
#define REG_HDCP_DUAL_P3_3C_L           (REG_HDCP_DUAL_P3_BASE + 0x78)
#define REG_HDCP_DUAL_P3_3C_H           (REG_HDCP_DUAL_P3_BASE + 0x79)
#define REG_HDCP_DUAL_P3_3D_L           (REG_HDCP_DUAL_P3_BASE + 0x7A)
#define REG_HDCP_DUAL_P3_3D_H           (REG_HDCP_DUAL_P3_BASE + 0x7B)
#define REG_HDCP_DUAL_P3_3E_L           (REG_HDCP_DUAL_P3_BASE + 0x7C)
#define REG_HDCP_DUAL_P3_3E_H           (REG_HDCP_DUAL_P3_BASE + 0x7D)
#define REG_HDCP_DUAL_P3_3F_L           (REG_HDCP_DUAL_P3_BASE + 0x7E)
#define REG_HDCP_DUAL_P3_3F_H           (REG_HDCP_DUAL_P3_BASE + 0x7F)
#define REG_HDCP_DUAL_P3_40_L           (REG_HDCP_DUAL_P3_BASE + 0x80)
#define REG_HDCP_DUAL_P3_40_H           (REG_HDCP_DUAL_P3_BASE + 0x81)
#define REG_HDCP_DUAL_P3_41_L           (REG_HDCP_DUAL_P3_BASE + 0x82)
#define REG_HDCP_DUAL_P3_41_H           (REG_HDCP_DUAL_P3_BASE + 0x83)
#define REG_HDCP_DUAL_P3_42_L           (REG_HDCP_DUAL_P3_BASE + 0x84)
#define REG_HDCP_DUAL_P3_42_H           (REG_HDCP_DUAL_P3_BASE + 0x85)
#define REG_HDCP_DUAL_P3_43_L           (REG_HDCP_DUAL_P3_BASE + 0x86)
#define REG_HDCP_DUAL_P3_43_H           (REG_HDCP_DUAL_P3_BASE + 0x87)
#define REG_HDCP_DUAL_P3_44_L           (REG_HDCP_DUAL_P3_BASE + 0x88)
#define REG_HDCP_DUAL_P3_44_H           (REG_HDCP_DUAL_P3_BASE + 0x89)
#define REG_HDCP_DUAL_P3_45_L           (REG_HDCP_DUAL_P3_BASE + 0x8A)
#define REG_HDCP_DUAL_P3_45_H           (REG_HDCP_DUAL_P3_BASE + 0x8B)
#define REG_HDCP_DUAL_P3_46_L           (REG_HDCP_DUAL_P3_BASE + 0x8C)
#define REG_HDCP_DUAL_P3_46_H           (REG_HDCP_DUAL_P3_BASE + 0x8D)
#define REG_HDCP_DUAL_P3_47_L           (REG_HDCP_DUAL_P3_BASE + 0x8E)
#define REG_HDCP_DUAL_P3_47_H           (REG_HDCP_DUAL_P3_BASE + 0x8F)
#define REG_HDCP_DUAL_P3_48_L           (REG_HDCP_DUAL_P3_BASE + 0x90)
#define REG_HDCP_DUAL_P3_48_H           (REG_HDCP_DUAL_P3_BASE + 0x91)
#define REG_HDCP_DUAL_P3_49_L           (REG_HDCP_DUAL_P3_BASE + 0x92)
#define REG_HDCP_DUAL_P3_49_H           (REG_HDCP_DUAL_P3_BASE + 0x93)
#define REG_HDCP_DUAL_P3_4A_L           (REG_HDCP_DUAL_P3_BASE + 0x94)
#define REG_HDCP_DUAL_P3_4A_H           (REG_HDCP_DUAL_P3_BASE + 0x95)
#define REG_HDCP_DUAL_P3_4B_L           (REG_HDCP_DUAL_P3_BASE + 0x96)
#define REG_HDCP_DUAL_P3_4B_H           (REG_HDCP_DUAL_P3_BASE + 0x97)
#define REG_HDCP_DUAL_P3_4C_L           (REG_HDCP_DUAL_P3_BASE + 0x98)
#define REG_HDCP_DUAL_P3_4C_H           (REG_HDCP_DUAL_P3_BASE + 0x99)
#define REG_HDCP_DUAL_P3_4D_L           (REG_HDCP_DUAL_P3_BASE + 0x9A)
#define REG_HDCP_DUAL_P3_4D_H           (REG_HDCP_DUAL_P3_BASE + 0x9B)
#define REG_HDCP_DUAL_P3_4E_L           (REG_HDCP_DUAL_P3_BASE + 0x9C)
#define REG_HDCP_DUAL_P3_4E_H           (REG_HDCP_DUAL_P3_BASE + 0x9D)
#define REG_HDCP_DUAL_P3_4F_L           (REG_HDCP_DUAL_P3_BASE + 0x9E)
#define REG_HDCP_DUAL_P3_4F_H           (REG_HDCP_DUAL_P3_BASE + 0x9F)
#define REG_HDCP_DUAL_P3_50_L           (REG_HDCP_DUAL_P3_BASE + 0xA0)
#define REG_HDCP_DUAL_P3_50_H           (REG_HDCP_DUAL_P3_BASE + 0xA1)
#define REG_HDCP_DUAL_P3_51_L           (REG_HDCP_DUAL_P3_BASE + 0xA2)
#define REG_HDCP_DUAL_P3_51_H           (REG_HDCP_DUAL_P3_BASE + 0xA3)
#define REG_HDCP_DUAL_P3_52_L           (REG_HDCP_DUAL_P3_BASE + 0xA4)
#define REG_HDCP_DUAL_P3_52_H           (REG_HDCP_DUAL_P3_BASE + 0xA5)
#define REG_HDCP_DUAL_P3_53_L           (REG_HDCP_DUAL_P3_BASE + 0xA6)
#define REG_HDCP_DUAL_P3_53_H           (REG_HDCP_DUAL_P3_BASE + 0xA7)
#define REG_HDCP_DUAL_P3_54_L           (REG_HDCP_DUAL_P3_BASE + 0xA8)
#define REG_HDCP_DUAL_P3_54_H           (REG_HDCP_DUAL_P3_BASE + 0xA9)
#define REG_HDCP_DUAL_P3_55_L           (REG_HDCP_DUAL_P3_BASE + 0xAA)
#define REG_HDCP_DUAL_P3_55_H           (REG_HDCP_DUAL_P3_BASE + 0xAB)
#define REG_HDCP_DUAL_P3_56_L           (REG_HDCP_DUAL_P3_BASE + 0xAC)
#define REG_HDCP_DUAL_P3_56_H           (REG_HDCP_DUAL_P3_BASE + 0xAD)
#define REG_HDCP_DUAL_P3_57_L           (REG_HDCP_DUAL_P3_BASE + 0xAE)
#define REG_HDCP_DUAL_P3_57_H           (REG_HDCP_DUAL_P3_BASE + 0xAF)
#define REG_HDCP_DUAL_P3_58_L           (REG_HDCP_DUAL_P3_BASE + 0xB0)
#define REG_HDCP_DUAL_P3_58_H           (REG_HDCP_DUAL_P3_BASE + 0xB1)
#define REG_HDCP_DUAL_P3_59_L           (REG_HDCP_DUAL_P3_BASE + 0xB2)
#define REG_HDCP_DUAL_P3_59_H           (REG_HDCP_DUAL_P3_BASE + 0xB3)
#define REG_HDCP_DUAL_P3_5A_L           (REG_HDCP_DUAL_P3_BASE + 0xB4)
#define REG_HDCP_DUAL_P3_5A_H           (REG_HDCP_DUAL_P3_BASE + 0xB5)
#define REG_HDCP_DUAL_P3_5B_L           (REG_HDCP_DUAL_P3_BASE + 0xB6)
#define REG_HDCP_DUAL_P3_5B_H           (REG_HDCP_DUAL_P3_BASE + 0xB7)
#define REG_HDCP_DUAL_P3_5C_L           (REG_HDCP_DUAL_P3_BASE + 0xB8)
#define REG_HDCP_DUAL_P3_5C_H           (REG_HDCP_DUAL_P3_BASE + 0xB9)
#define REG_HDCP_DUAL_P3_5D_L           (REG_HDCP_DUAL_P3_BASE + 0xBA)
#define REG_HDCP_DUAL_P3_5D_H           (REG_HDCP_DUAL_P3_BASE + 0xBB)
#define REG_HDCP_DUAL_P3_5E_L           (REG_HDCP_DUAL_P3_BASE + 0xBC)
#define REG_HDCP_DUAL_P3_5E_H           (REG_HDCP_DUAL_P3_BASE + 0xBD)
#define REG_HDCP_DUAL_P3_5F_L           (REG_HDCP_DUAL_P3_BASE + 0xBE)
#define REG_HDCP_DUAL_P3_5F_H           (REG_HDCP_DUAL_P3_BASE + 0xBF)
#define REG_HDCP_DUAL_P3_60_L           (REG_HDCP_DUAL_P3_BASE + 0xC0)
#define REG_HDCP_DUAL_P3_60_H           (REG_HDCP_DUAL_P3_BASE + 0xC1)
#define REG_HDCP_DUAL_P3_61_L           (REG_HDCP_DUAL_P3_BASE + 0xC2)
#define REG_HDCP_DUAL_P3_61_H           (REG_HDCP_DUAL_P3_BASE + 0xC3)
#define REG_HDCP_DUAL_P3_62_L           (REG_HDCP_DUAL_P3_BASE + 0xC4)
#define REG_HDCP_DUAL_P3_62_H           (REG_HDCP_DUAL_P3_BASE + 0xC5)
#define REG_HDCP_DUAL_P3_63_L           (REG_HDCP_DUAL_P3_BASE + 0xC6)
#define REG_HDCP_DUAL_P3_63_H           (REG_HDCP_DUAL_P3_BASE + 0xC7)
#define REG_HDCP_DUAL_P3_64_L           (REG_HDCP_DUAL_P3_BASE + 0xC8)
#define REG_HDCP_DUAL_P3_64_H           (REG_HDCP_DUAL_P3_BASE + 0xC9)
#define REG_HDCP_DUAL_P3_65_L           (REG_HDCP_DUAL_P3_BASE + 0xCA)
#define REG_HDCP_DUAL_P3_65_H           (REG_HDCP_DUAL_P3_BASE + 0xCB)
#define REG_HDCP_DUAL_P3_66_L           (REG_HDCP_DUAL_P3_BASE + 0xCC)
#define REG_HDCP_DUAL_P3_66_H           (REG_HDCP_DUAL_P3_BASE + 0xCD)
#define REG_HDCP_DUAL_P3_67_L           (REG_HDCP_DUAL_P3_BASE + 0xCE)
#define REG_HDCP_DUAL_P3_67_H           (REG_HDCP_DUAL_P3_BASE + 0xCF)
#define REG_HDCP_DUAL_P3_68_L           (REG_HDCP_DUAL_P3_BASE + 0xD0)
#define REG_HDCP_DUAL_P3_68_H           (REG_HDCP_DUAL_P3_BASE + 0xD1)
#define REG_HDCP_DUAL_P3_69_L           (REG_HDCP_DUAL_P3_BASE + 0xD2)
#define REG_HDCP_DUAL_P3_69_H           (REG_HDCP_DUAL_P3_BASE + 0xD3)
#define REG_HDCP_DUAL_P3_6A_L           (REG_HDCP_DUAL_P3_BASE + 0xD4)
#define REG_HDCP_DUAL_P3_6A_H           (REG_HDCP_DUAL_P3_BASE + 0xD5)
#define REG_HDCP_DUAL_P3_6B_L           (REG_HDCP_DUAL_P3_BASE + 0xD6)
#define REG_HDCP_DUAL_P3_6B_H           (REG_HDCP_DUAL_P3_BASE + 0xD7)
#define REG_HDCP_DUAL_P3_6C_L           (REG_HDCP_DUAL_P3_BASE + 0xD8)
#define REG_HDCP_DUAL_P3_6C_H           (REG_HDCP_DUAL_P3_BASE + 0xD9)
#define REG_HDCP_DUAL_P3_6D_L           (REG_HDCP_DUAL_P3_BASE + 0xDA)
#define REG_HDCP_DUAL_P3_6D_H           (REG_HDCP_DUAL_P3_BASE + 0xDB)
#define REG_HDCP_DUAL_P3_6E_L           (REG_HDCP_DUAL_P3_BASE + 0xDC)
#define REG_HDCP_DUAL_P3_6E_H           (REG_HDCP_DUAL_P3_BASE + 0xDD)
#define REG_HDCP_DUAL_P3_6F_L           (REG_HDCP_DUAL_P3_BASE + 0xDE)
#define REG_HDCP_DUAL_P3_6F_H           (REG_HDCP_DUAL_P3_BASE + 0xDF)
#define REG_HDCP_DUAL_P3_70_L           (REG_HDCP_DUAL_P3_BASE + 0xE0)
#define REG_HDCP_DUAL_P3_70_H           (REG_HDCP_DUAL_P3_BASE + 0xE1)
#define REG_HDCP_DUAL_P3_71_L           (REG_HDCP_DUAL_P3_BASE + 0xE2)
#define REG_HDCP_DUAL_P3_71_H           (REG_HDCP_DUAL_P3_BASE + 0xE3)
#define REG_HDCP_DUAL_P3_72_L           (REG_HDCP_DUAL_P3_BASE + 0xE4)
#define REG_HDCP_DUAL_P3_72_H           (REG_HDCP_DUAL_P3_BASE + 0xE5)
#define REG_HDCP_DUAL_P3_73_L           (REG_HDCP_DUAL_P3_BASE + 0xE6)
#define REG_HDCP_DUAL_P3_73_H           (REG_HDCP_DUAL_P3_BASE + 0xE7)
#define REG_HDCP_DUAL_P3_74_L           (REG_HDCP_DUAL_P3_BASE + 0xE8)
#define REG_HDCP_DUAL_P3_74_H           (REG_HDCP_DUAL_P3_BASE + 0xE9)
#define REG_HDCP_DUAL_P3_75_L           (REG_HDCP_DUAL_P3_BASE + 0xEA)
#define REG_HDCP_DUAL_P3_75_H           (REG_HDCP_DUAL_P3_BASE + 0xEB)
#define REG_HDCP_DUAL_P3_76_L           (REG_HDCP_DUAL_P3_BASE + 0xEC)
#define REG_HDCP_DUAL_P3_76_H           (REG_HDCP_DUAL_P3_BASE + 0xED)
#define REG_HDCP_DUAL_P3_77_L           (REG_HDCP_DUAL_P3_BASE + 0xEE)
#define REG_HDCP_DUAL_P3_77_H           (REG_HDCP_DUAL_P3_BASE + 0xEF)
#define REG_HDCP_DUAL_P3_78_L           (REG_HDCP_DUAL_P3_BASE + 0xF0)
#define REG_HDCP_DUAL_P3_78_H           (REG_HDCP_DUAL_P3_BASE + 0xF1)
#define REG_HDCP_DUAL_P3_79_L           (REG_HDCP_DUAL_P3_BASE + 0xF2)
#define REG_HDCP_DUAL_P3_79_H           (REG_HDCP_DUAL_P3_BASE + 0xF3)
#define REG_HDCP_DUAL_P3_7A_L           (REG_HDCP_DUAL_P3_BASE + 0xF4)
#define REG_HDCP_DUAL_P3_7A_H           (REG_HDCP_DUAL_P3_BASE + 0xF5)
#define REG_HDCP_DUAL_P3_7B_L           (REG_HDCP_DUAL_P3_BASE + 0xF6)
#define REG_HDCP_DUAL_P3_7B_H           (REG_HDCP_DUAL_P3_BASE + 0xF7)
#define REG_HDCP_DUAL_P3_7C_L           (REG_HDCP_DUAL_P3_BASE + 0xF8)
#define REG_HDCP_DUAL_P3_7C_H           (REG_HDCP_DUAL_P3_BASE + 0xF9)
#define REG_HDCP_DUAL_P3_7D_L           (REG_HDCP_DUAL_P3_BASE + 0xFA)
#define REG_HDCP_DUAL_P3_7D_H           (REG_HDCP_DUAL_P3_BASE + 0xFB)
#define REG_HDCP_DUAL_P3_7E_L           (REG_HDCP_DUAL_P3_BASE + 0xFC)
#define REG_HDCP_DUAL_P3_7E_H           (REG_HDCP_DUAL_P3_BASE + 0xFD)
#define REG_HDCP_DUAL_P3_7F_L           (REG_HDCP_DUAL_P3_BASE + 0xFE)
#define REG_HDCP_DUAL_P3_7F_H           (REG_HDCP_DUAL_P3_BASE + 0xFF)

//=============================================================
// HDMIRX_DTOP_PKT_P3
#define REG_HDMIRX_DTOP_PKT_P3_00_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x00)
#define REG_HDMIRX_DTOP_PKT_P3_00_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x01)
#define REG_HDMIRX_DTOP_PKT_P3_01_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x02)
#define REG_HDMIRX_DTOP_PKT_P3_01_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x03)
#define REG_HDMIRX_DTOP_PKT_P3_02_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x04)
#define REG_HDMIRX_DTOP_PKT_P3_02_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x05)
#define REG_HDMIRX_DTOP_PKT_P3_03_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x06)
#define REG_HDMIRX_DTOP_PKT_P3_03_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x07)
#define REG_HDMIRX_DTOP_PKT_P3_04_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x08)
#define REG_HDMIRX_DTOP_PKT_P3_04_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x09)
#define REG_HDMIRX_DTOP_PKT_P3_05_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x0A)
#define REG_HDMIRX_DTOP_PKT_P3_05_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x0B)
#define REG_HDMIRX_DTOP_PKT_P3_06_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x0C)
#define REG_HDMIRX_DTOP_PKT_P3_06_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x0D)
#define REG_HDMIRX_DTOP_PKT_P3_07_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x0E)
#define REG_HDMIRX_DTOP_PKT_P3_07_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x0F)
#define REG_HDMIRX_DTOP_PKT_P3_08_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x10)
#define REG_HDMIRX_DTOP_PKT_P3_08_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x11)
#define REG_HDMIRX_DTOP_PKT_P3_09_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x12)
#define REG_HDMIRX_DTOP_PKT_P3_09_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x13)
#define REG_HDMIRX_DTOP_PKT_P3_0A_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x14)
#define REG_HDMIRX_DTOP_PKT_P3_0A_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x15)
#define REG_HDMIRX_DTOP_PKT_P3_0B_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x16)
#define REG_HDMIRX_DTOP_PKT_P3_0B_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x17)
#define REG_HDMIRX_DTOP_PKT_P3_0C_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x18)
#define REG_HDMIRX_DTOP_PKT_P3_0C_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x19)
#define REG_HDMIRX_DTOP_PKT_P3_0D_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x1A)
#define REG_HDMIRX_DTOP_PKT_P3_0D_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x1B)
#define REG_HDMIRX_DTOP_PKT_P3_0E_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x1C)
#define REG_HDMIRX_DTOP_PKT_P3_0E_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x1D)
#define REG_HDMIRX_DTOP_PKT_P3_0F_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x1E)
#define REG_HDMIRX_DTOP_PKT_P3_0F_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x1F)
#define REG_HDMIRX_DTOP_PKT_P3_10_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x20)
#define REG_HDMIRX_DTOP_PKT_P3_10_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x21)
#define REG_HDMIRX_DTOP_PKT_P3_11_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x22)
#define REG_HDMIRX_DTOP_PKT_P3_11_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x23)
#define REG_HDMIRX_DTOP_PKT_P3_12_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x24)
#define REG_HDMIRX_DTOP_PKT_P3_12_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x25)
#define REG_HDMIRX_DTOP_PKT_P3_13_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x26)
#define REG_HDMIRX_DTOP_PKT_P3_13_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x27)
#define REG_HDMIRX_DTOP_PKT_P3_14_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x28)
#define REG_HDMIRX_DTOP_PKT_P3_14_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x29)
#define REG_HDMIRX_DTOP_PKT_P3_15_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x2A)
#define REG_HDMIRX_DTOP_PKT_P3_15_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x2B)
#define REG_HDMIRX_DTOP_PKT_P3_16_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x2C)
#define REG_HDMIRX_DTOP_PKT_P3_16_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x2D)
#define REG_HDMIRX_DTOP_PKT_P3_17_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x2E)
#define REG_HDMIRX_DTOP_PKT_P3_17_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x2F)
#define REG_HDMIRX_DTOP_PKT_P3_18_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x30)
#define REG_HDMIRX_DTOP_PKT_P3_18_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x31)
#define REG_HDMIRX_DTOP_PKT_P3_19_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x32)
#define REG_HDMIRX_DTOP_PKT_P3_19_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x33)
#define REG_HDMIRX_DTOP_PKT_P3_1A_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x34)
#define REG_HDMIRX_DTOP_PKT_P3_1A_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x35)
#define REG_HDMIRX_DTOP_PKT_P3_1B_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x36)
#define REG_HDMIRX_DTOP_PKT_P3_1B_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x37)
#define REG_HDMIRX_DTOP_PKT_P3_1C_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x38)
#define REG_HDMIRX_DTOP_PKT_P3_1C_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x39)
#define REG_HDMIRX_DTOP_PKT_P3_1D_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x3A)
#define REG_HDMIRX_DTOP_PKT_P3_1D_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x3B)
#define REG_HDMIRX_DTOP_PKT_P3_1E_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x3C)
#define REG_HDMIRX_DTOP_PKT_P3_1E_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x3D)
#define REG_HDMIRX_DTOP_PKT_P3_1F_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x3E)
#define REG_HDMIRX_DTOP_PKT_P3_1F_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x3F)
#define REG_HDMIRX_DTOP_PKT_P3_20_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x40)
#define REG_HDMIRX_DTOP_PKT_P3_20_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x41)
#define REG_HDMIRX_DTOP_PKT_P3_21_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x42)
#define REG_HDMIRX_DTOP_PKT_P3_21_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x43)
#define REG_HDMIRX_DTOP_PKT_P3_22_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x44)
#define REG_HDMIRX_DTOP_PKT_P3_22_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x45)
#define REG_HDMIRX_DTOP_PKT_P3_23_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x46)
#define REG_HDMIRX_DTOP_PKT_P3_23_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x47)
#define REG_HDMIRX_DTOP_PKT_P3_24_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x48)
#define REG_HDMIRX_DTOP_PKT_P3_24_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x49)
#define REG_HDMIRX_DTOP_PKT_P3_25_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x4A)
#define REG_HDMIRX_DTOP_PKT_P3_25_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x4B)
#define REG_HDMIRX_DTOP_PKT_P3_26_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x4C)
#define REG_HDMIRX_DTOP_PKT_P3_26_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x4D)
#define REG_HDMIRX_DTOP_PKT_P3_27_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x4E)
#define REG_HDMIRX_DTOP_PKT_P3_27_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x4F)
#define REG_HDMIRX_DTOP_PKT_P3_28_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x50)
#define REG_HDMIRX_DTOP_PKT_P3_28_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x51)
#define REG_HDMIRX_DTOP_PKT_P3_29_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x52)
#define REG_HDMIRX_DTOP_PKT_P3_29_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x53)
#define REG_HDMIRX_DTOP_PKT_P3_2A_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x54)
#define REG_HDMIRX_DTOP_PKT_P3_2A_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x55)
#define REG_HDMIRX_DTOP_PKT_P3_2B_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x56)
#define REG_HDMIRX_DTOP_PKT_P3_2B_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x57)
#define REG_HDMIRX_DTOP_PKT_P3_2C_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x58)
#define REG_HDMIRX_DTOP_PKT_P3_2C_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x59)
#define REG_HDMIRX_DTOP_PKT_P3_2D_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x5A)
#define REG_HDMIRX_DTOP_PKT_P3_2D_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x5B)
#define REG_HDMIRX_DTOP_PKT_P3_2E_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x5C)
#define REG_HDMIRX_DTOP_PKT_P3_2E_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x5D)
#define REG_HDMIRX_DTOP_PKT_P3_2F_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x5E)
#define REG_HDMIRX_DTOP_PKT_P3_2F_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x5F)
#define REG_HDMIRX_DTOP_PKT_P3_30_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x60)
#define REG_HDMIRX_DTOP_PKT_P3_30_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x61)
#define REG_HDMIRX_DTOP_PKT_P3_31_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x62)
#define REG_HDMIRX_DTOP_PKT_P3_31_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x63)
#define REG_HDMIRX_DTOP_PKT_P3_32_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x64)
#define REG_HDMIRX_DTOP_PKT_P3_32_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x65)
#define REG_HDMIRX_DTOP_PKT_P3_33_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x66)
#define REG_HDMIRX_DTOP_PKT_P3_33_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x67)
#define REG_HDMIRX_DTOP_PKT_P3_34_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x68)
#define REG_HDMIRX_DTOP_PKT_P3_34_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x69)
#define REG_HDMIRX_DTOP_PKT_P3_35_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x6A)
#define REG_HDMIRX_DTOP_PKT_P3_35_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x6B)
#define REG_HDMIRX_DTOP_PKT_P3_36_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x6C)
#define REG_HDMIRX_DTOP_PKT_P3_36_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x6D)
#define REG_HDMIRX_DTOP_PKT_P3_37_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x6E)
#define REG_HDMIRX_DTOP_PKT_P3_37_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x6F)
#define REG_HDMIRX_DTOP_PKT_P3_38_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x70)
#define REG_HDMIRX_DTOP_PKT_P3_38_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x71)
#define REG_HDMIRX_DTOP_PKT_P3_39_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x72)
#define REG_HDMIRX_DTOP_PKT_P3_39_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x73)
#define REG_HDMIRX_DTOP_PKT_P3_3A_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x74)
#define REG_HDMIRX_DTOP_PKT_P3_3A_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x75)
#define REG_HDMIRX_DTOP_PKT_P3_3B_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x76)
#define REG_HDMIRX_DTOP_PKT_P3_3B_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x77)
#define REG_HDMIRX_DTOP_PKT_P3_3C_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x78)
#define REG_HDMIRX_DTOP_PKT_P3_3C_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x79)
#define REG_HDMIRX_DTOP_PKT_P3_3D_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x7A)
#define REG_HDMIRX_DTOP_PKT_P3_3D_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x7B)
#define REG_HDMIRX_DTOP_PKT_P3_3E_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x7C)
#define REG_HDMIRX_DTOP_PKT_P3_3E_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x7D)
#define REG_HDMIRX_DTOP_PKT_P3_3F_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x7E)
#define REG_HDMIRX_DTOP_PKT_P3_3F_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x7F)
#define REG_HDMIRX_DTOP_PKT_P3_40_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x80)
#define REG_HDMIRX_DTOP_PKT_P3_40_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x81)
#define REG_HDMIRX_DTOP_PKT_P3_41_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x82)
#define REG_HDMIRX_DTOP_PKT_P3_41_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x83)
#define REG_HDMIRX_DTOP_PKT_P3_42_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x84)
#define REG_HDMIRX_DTOP_PKT_P3_42_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x85)
#define REG_HDMIRX_DTOP_PKT_P3_43_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x86)
#define REG_HDMIRX_DTOP_PKT_P3_43_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x87)
#define REG_HDMIRX_DTOP_PKT_P3_44_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x88)
#define REG_HDMIRX_DTOP_PKT_P3_44_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x89)
#define REG_HDMIRX_DTOP_PKT_P3_45_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x8A)
#define REG_HDMIRX_DTOP_PKT_P3_45_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x8B)
#define REG_HDMIRX_DTOP_PKT_P3_46_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x8C)
#define REG_HDMIRX_DTOP_PKT_P3_46_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x8D)
#define REG_HDMIRX_DTOP_PKT_P3_47_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x8E)
#define REG_HDMIRX_DTOP_PKT_P3_47_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x8F)
#define REG_HDMIRX_DTOP_PKT_P3_48_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x90)
#define REG_HDMIRX_DTOP_PKT_P3_48_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x91)
#define REG_HDMIRX_DTOP_PKT_P3_49_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x92)
#define REG_HDMIRX_DTOP_PKT_P3_49_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x93)
#define REG_HDMIRX_DTOP_PKT_P3_4A_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x94)
#define REG_HDMIRX_DTOP_PKT_P3_4A_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x95)
#define REG_HDMIRX_DTOP_PKT_P3_4B_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x96)
#define REG_HDMIRX_DTOP_PKT_P3_4B_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x97)
#define REG_HDMIRX_DTOP_PKT_P3_4C_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x98)
#define REG_HDMIRX_DTOP_PKT_P3_4C_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x99)
#define REG_HDMIRX_DTOP_PKT_P3_4D_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x9A)
#define REG_HDMIRX_DTOP_PKT_P3_4D_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x9B)
#define REG_HDMIRX_DTOP_PKT_P3_4E_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x9C)
#define REG_HDMIRX_DTOP_PKT_P3_4E_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x9D)
#define REG_HDMIRX_DTOP_PKT_P3_4F_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x9E)
#define REG_HDMIRX_DTOP_PKT_P3_4F_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0x9F)
#define REG_HDMIRX_DTOP_PKT_P3_50_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xA0)
#define REG_HDMIRX_DTOP_PKT_P3_50_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xA1)
#define REG_HDMIRX_DTOP_PKT_P3_51_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xA2)
#define REG_HDMIRX_DTOP_PKT_P3_51_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xA3)
#define REG_HDMIRX_DTOP_PKT_P3_52_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xA4)
#define REG_HDMIRX_DTOP_PKT_P3_52_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xA5)
#define REG_HDMIRX_DTOP_PKT_P3_53_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xA6)
#define REG_HDMIRX_DTOP_PKT_P3_53_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xA7)
#define REG_HDMIRX_DTOP_PKT_P3_54_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xA8)
#define REG_HDMIRX_DTOP_PKT_P3_54_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xA9)
#define REG_HDMIRX_DTOP_PKT_P3_55_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xAA)
#define REG_HDMIRX_DTOP_PKT_P3_55_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xAB)
#define REG_HDMIRX_DTOP_PKT_P3_56_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xAC)
#define REG_HDMIRX_DTOP_PKT_P3_56_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xAD)
#define REG_HDMIRX_DTOP_PKT_P3_57_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xAE)
#define REG_HDMIRX_DTOP_PKT_P3_57_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xAF)
#define REG_HDMIRX_DTOP_PKT_P3_58_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xB0)
#define REG_HDMIRX_DTOP_PKT_P3_58_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xB1)
#define REG_HDMIRX_DTOP_PKT_P3_59_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xB2)
#define REG_HDMIRX_DTOP_PKT_P3_59_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xB3)
#define REG_HDMIRX_DTOP_PKT_P3_5A_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xB4)
#define REG_HDMIRX_DTOP_PKT_P3_5A_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xB5)
#define REG_HDMIRX_DTOP_PKT_P3_5B_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xB6)
#define REG_HDMIRX_DTOP_PKT_P3_5B_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xB7)
#define REG_HDMIRX_DTOP_PKT_P3_5C_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xB8)
#define REG_HDMIRX_DTOP_PKT_P3_5C_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xB9)
#define REG_HDMIRX_DTOP_PKT_P3_5D_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xBA)
#define REG_HDMIRX_DTOP_PKT_P3_5D_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xBB)
#define REG_HDMIRX_DTOP_PKT_P3_5E_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xBC)
#define REG_HDMIRX_DTOP_PKT_P3_5E_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xBD)
#define REG_HDMIRX_DTOP_PKT_P3_5F_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xBE)
#define REG_HDMIRX_DTOP_PKT_P3_5F_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xBF)
#define REG_HDMIRX_DTOP_PKT_P3_60_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xC0)
#define REG_HDMIRX_DTOP_PKT_P3_60_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xC1)
#define REG_HDMIRX_DTOP_PKT_P3_61_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xC2)
#define REG_HDMIRX_DTOP_PKT_P3_61_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xC3)
#define REG_HDMIRX_DTOP_PKT_P3_62_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xC4)
#define REG_HDMIRX_DTOP_PKT_P3_62_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xC5)
#define REG_HDMIRX_DTOP_PKT_P3_63_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xC6)
#define REG_HDMIRX_DTOP_PKT_P3_63_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xC7)
#define REG_HDMIRX_DTOP_PKT_P3_64_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xC8)
#define REG_HDMIRX_DTOP_PKT_P3_64_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xC9)
#define REG_HDMIRX_DTOP_PKT_P3_65_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xCA)
#define REG_HDMIRX_DTOP_PKT_P3_65_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xCB)
#define REG_HDMIRX_DTOP_PKT_P3_66_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xCC)
#define REG_HDMIRX_DTOP_PKT_P3_66_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xCD)
#define REG_HDMIRX_DTOP_PKT_P3_67_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xCE)
#define REG_HDMIRX_DTOP_PKT_P3_67_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xCF)
#define REG_HDMIRX_DTOP_PKT_P3_68_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xD0)
#define REG_HDMIRX_DTOP_PKT_P3_68_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xD1)
#define REG_HDMIRX_DTOP_PKT_P3_69_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xD2)
#define REG_HDMIRX_DTOP_PKT_P3_69_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xD3)
#define REG_HDMIRX_DTOP_PKT_P3_6A_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xD4)
#define REG_HDMIRX_DTOP_PKT_P3_6A_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xD5)
#define REG_HDMIRX_DTOP_PKT_P3_6B_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xD6)
#define REG_HDMIRX_DTOP_PKT_P3_6B_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xD7)
#define REG_HDMIRX_DTOP_PKT_P3_6C_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xD8)
#define REG_HDMIRX_DTOP_PKT_P3_6C_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xD9)
#define REG_HDMIRX_DTOP_PKT_P3_6D_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xDA)
#define REG_HDMIRX_DTOP_PKT_P3_6D_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xDB)
#define REG_HDMIRX_DTOP_PKT_P3_6E_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xDC)
#define REG_HDMIRX_DTOP_PKT_P3_6E_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xDD)
#define REG_HDMIRX_DTOP_PKT_P3_6F_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xDE)
#define REG_HDMIRX_DTOP_PKT_P3_6F_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xDF)
#define REG_HDMIRX_DTOP_PKT_P3_70_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xE0)
#define REG_HDMIRX_DTOP_PKT_P3_70_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xE1)
#define REG_HDMIRX_DTOP_PKT_P3_71_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xE2)
#define REG_HDMIRX_DTOP_PKT_P3_71_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xE3)
#define REG_HDMIRX_DTOP_PKT_P3_72_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xE4)
#define REG_HDMIRX_DTOP_PKT_P3_72_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xE5)
#define REG_HDMIRX_DTOP_PKT_P3_73_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xE6)
#define REG_HDMIRX_DTOP_PKT_P3_73_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xE7)
#define REG_HDMIRX_DTOP_PKT_P3_74_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xE8)
#define REG_HDMIRX_DTOP_PKT_P3_74_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xE9)
#define REG_HDMIRX_DTOP_PKT_P3_75_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xEA)
#define REG_HDMIRX_DTOP_PKT_P3_75_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xEB)
#define REG_HDMIRX_DTOP_PKT_P3_76_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xEC)
#define REG_HDMIRX_DTOP_PKT_P3_76_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xED)
#define REG_HDMIRX_DTOP_PKT_P3_77_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xEE)
#define REG_HDMIRX_DTOP_PKT_P3_77_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xEF)
#define REG_HDMIRX_DTOP_PKT_P3_78_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xF0)
#define REG_HDMIRX_DTOP_PKT_P3_78_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xF1)
#define REG_HDMIRX_DTOP_PKT_P3_79_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xF2)
#define REG_HDMIRX_DTOP_PKT_P3_79_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xF3)
#define REG_HDMIRX_DTOP_PKT_P3_7A_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xF4)
#define REG_HDMIRX_DTOP_PKT_P3_7A_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xF5)
#define REG_HDMIRX_DTOP_PKT_P3_7B_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xF6)
#define REG_HDMIRX_DTOP_PKT_P3_7B_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xF7)
#define REG_HDMIRX_DTOP_PKT_P3_7C_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xF8)
#define REG_HDMIRX_DTOP_PKT_P3_7C_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xF9)
#define REG_HDMIRX_DTOP_PKT_P3_7D_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xFA)
#define REG_HDMIRX_DTOP_PKT_P3_7D_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xFB)
#define REG_HDMIRX_DTOP_PKT_P3_7E_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xFC)
#define REG_HDMIRX_DTOP_PKT_P3_7E_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xFD)
#define REG_HDMIRX_DTOP_PKT_P3_7F_L           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xFE)
#define REG_HDMIRX_DTOP_PKT_P3_7F_H           (REG_HDMIRX_DTOP_PKT_P3_BASE + 0xFF)

//=============================================================
// HDMIRX_VE_U0
#define REG_HDMIRX_VE_U0_00_L           (REG_HDMIRX_VE_U0_BASE + 0x00)
#define REG_HDMIRX_VE_U0_00_H           (REG_HDMIRX_VE_U0_BASE + 0x01)
#define REG_HDMIRX_VE_U0_01_L           (REG_HDMIRX_VE_U0_BASE + 0x02)
#define REG_HDMIRX_VE_U0_01_H           (REG_HDMIRX_VE_U0_BASE + 0x03)
#define REG_HDMIRX_VE_U0_02_L           (REG_HDMIRX_VE_U0_BASE + 0x04)
#define REG_HDMIRX_VE_U0_02_H           (REG_HDMIRX_VE_U0_BASE + 0x05)
#define REG_HDMIRX_VE_U0_03_L           (REG_HDMIRX_VE_U0_BASE + 0x06)
#define REG_HDMIRX_VE_U0_03_H           (REG_HDMIRX_VE_U0_BASE + 0x07)
#define REG_HDMIRX_VE_U0_04_L           (REG_HDMIRX_VE_U0_BASE + 0x08)
#define REG_HDMIRX_VE_U0_04_H           (REG_HDMIRX_VE_U0_BASE + 0x09)
#define REG_HDMIRX_VE_U0_05_L           (REG_HDMIRX_VE_U0_BASE + 0x0A)
#define REG_HDMIRX_VE_U0_05_H           (REG_HDMIRX_VE_U0_BASE + 0x0B)
#define REG_HDMIRX_VE_U0_06_L           (REG_HDMIRX_VE_U0_BASE + 0x0C)
#define REG_HDMIRX_VE_U0_06_H           (REG_HDMIRX_VE_U0_BASE + 0x0D)
#define REG_HDMIRX_VE_U0_07_L           (REG_HDMIRX_VE_U0_BASE + 0x0E)
#define REG_HDMIRX_VE_U0_07_H           (REG_HDMIRX_VE_U0_BASE + 0x0F)
#define REG_HDMIRX_VE_U0_08_L           (REG_HDMIRX_VE_U0_BASE + 0x10)
#define REG_HDMIRX_VE_U0_08_H           (REG_HDMIRX_VE_U0_BASE + 0x11)
#define REG_HDMIRX_VE_U0_09_L           (REG_HDMIRX_VE_U0_BASE + 0x12)
#define REG_HDMIRX_VE_U0_09_H           (REG_HDMIRX_VE_U0_BASE + 0x13)
#define REG_HDMIRX_VE_U0_0A_L           (REG_HDMIRX_VE_U0_BASE + 0x14)
#define REG_HDMIRX_VE_U0_0A_H           (REG_HDMIRX_VE_U0_BASE + 0x15)
#define REG_HDMIRX_VE_U0_0B_L           (REG_HDMIRX_VE_U0_BASE + 0x16)
#define REG_HDMIRX_VE_U0_0B_H           (REG_HDMIRX_VE_U0_BASE + 0x17)
#define REG_HDMIRX_VE_U0_0C_L           (REG_HDMIRX_VE_U0_BASE + 0x18)
#define REG_HDMIRX_VE_U0_0C_H           (REG_HDMIRX_VE_U0_BASE + 0x19)
#define REG_HDMIRX_VE_U0_0D_L           (REG_HDMIRX_VE_U0_BASE + 0x1A)
#define REG_HDMIRX_VE_U0_0D_H           (REG_HDMIRX_VE_U0_BASE + 0x1B)
#define REG_HDMIRX_VE_U0_0E_L           (REG_HDMIRX_VE_U0_BASE + 0x1C)
#define REG_HDMIRX_VE_U0_0E_H           (REG_HDMIRX_VE_U0_BASE + 0x1D)
#define REG_HDMIRX_VE_U0_0F_L           (REG_HDMIRX_VE_U0_BASE + 0x1E)
#define REG_HDMIRX_VE_U0_0F_H           (REG_HDMIRX_VE_U0_BASE + 0x1F)
#define REG_HDMIRX_VE_U0_10_L           (REG_HDMIRX_VE_U0_BASE + 0x20)
#define REG_HDMIRX_VE_U0_10_H           (REG_HDMIRX_VE_U0_BASE + 0x21)
#define REG_HDMIRX_VE_U0_11_L           (REG_HDMIRX_VE_U0_BASE + 0x22)
#define REG_HDMIRX_VE_U0_11_H           (REG_HDMIRX_VE_U0_BASE + 0x23)
#define REG_HDMIRX_VE_U0_12_L           (REG_HDMIRX_VE_U0_BASE + 0x24)
#define REG_HDMIRX_VE_U0_12_H           (REG_HDMIRX_VE_U0_BASE + 0x25)
#define REG_HDMIRX_VE_U0_13_L           (REG_HDMIRX_VE_U0_BASE + 0x26)
#define REG_HDMIRX_VE_U0_13_H           (REG_HDMIRX_VE_U0_BASE + 0x27)
#define REG_HDMIRX_VE_U0_14_L           (REG_HDMIRX_VE_U0_BASE + 0x28)
#define REG_HDMIRX_VE_U0_14_H           (REG_HDMIRX_VE_U0_BASE + 0x29)
#define REG_HDMIRX_VE_U0_15_L           (REG_HDMIRX_VE_U0_BASE + 0x2A)
#define REG_HDMIRX_VE_U0_15_H           (REG_HDMIRX_VE_U0_BASE + 0x2B)
#define REG_HDMIRX_VE_U0_16_L           (REG_HDMIRX_VE_U0_BASE + 0x2C)
#define REG_HDMIRX_VE_U0_16_H           (REG_HDMIRX_VE_U0_BASE + 0x2D)
#define REG_HDMIRX_VE_U0_17_L           (REG_HDMIRX_VE_U0_BASE + 0x2E)
#define REG_HDMIRX_VE_U0_17_H           (REG_HDMIRX_VE_U0_BASE + 0x2F)
#define REG_HDMIRX_VE_U0_18_L           (REG_HDMIRX_VE_U0_BASE + 0x30)
#define REG_HDMIRX_VE_U0_18_H           (REG_HDMIRX_VE_U0_BASE + 0x31)
#define REG_HDMIRX_VE_U0_19_L           (REG_HDMIRX_VE_U0_BASE + 0x32)
#define REG_HDMIRX_VE_U0_19_H           (REG_HDMIRX_VE_U0_BASE + 0x33)
#define REG_HDMIRX_VE_U0_1A_L           (REG_HDMIRX_VE_U0_BASE + 0x34)
#define REG_HDMIRX_VE_U0_1A_H           (REG_HDMIRX_VE_U0_BASE + 0x35)
#define REG_HDMIRX_VE_U0_1B_L           (REG_HDMIRX_VE_U0_BASE + 0x36)
#define REG_HDMIRX_VE_U0_1B_H           (REG_HDMIRX_VE_U0_BASE + 0x37)
#define REG_HDMIRX_VE_U0_1C_L           (REG_HDMIRX_VE_U0_BASE + 0x38)
#define REG_HDMIRX_VE_U0_1C_H           (REG_HDMIRX_VE_U0_BASE + 0x39)
#define REG_HDMIRX_VE_U0_1D_L           (REG_HDMIRX_VE_U0_BASE + 0x3A)
#define REG_HDMIRX_VE_U0_1D_H           (REG_HDMIRX_VE_U0_BASE + 0x3B)
#define REG_HDMIRX_VE_U0_1E_L           (REG_HDMIRX_VE_U0_BASE + 0x3C)
#define REG_HDMIRX_VE_U0_1E_H           (REG_HDMIRX_VE_U0_BASE + 0x3D)
#define REG_HDMIRX_VE_U0_1F_L           (REG_HDMIRX_VE_U0_BASE + 0x3E)
#define REG_HDMIRX_VE_U0_1F_H           (REG_HDMIRX_VE_U0_BASE + 0x3F)
#define REG_HDMIRX_VE_U0_20_L           (REG_HDMIRX_VE_U0_BASE + 0x40)
#define REG_HDMIRX_VE_U0_20_H           (REG_HDMIRX_VE_U0_BASE + 0x41)
#define REG_HDMIRX_VE_U0_21_L           (REG_HDMIRX_VE_U0_BASE + 0x42)
#define REG_HDMIRX_VE_U0_21_H           (REG_HDMIRX_VE_U0_BASE + 0x43)
#define REG_HDMIRX_VE_U0_22_L           (REG_HDMIRX_VE_U0_BASE + 0x44)
#define REG_HDMIRX_VE_U0_22_H           (REG_HDMIRX_VE_U0_BASE + 0x45)
#define REG_HDMIRX_VE_U0_23_L           (REG_HDMIRX_VE_U0_BASE + 0x46)
#define REG_HDMIRX_VE_U0_23_H           (REG_HDMIRX_VE_U0_BASE + 0x47)
#define REG_HDMIRX_VE_U0_24_L           (REG_HDMIRX_VE_U0_BASE + 0x48)
#define REG_HDMIRX_VE_U0_24_H           (REG_HDMIRX_VE_U0_BASE + 0x49)
#define REG_HDMIRX_VE_U0_25_L           (REG_HDMIRX_VE_U0_BASE + 0x4A)
#define REG_HDMIRX_VE_U0_25_H           (REG_HDMIRX_VE_U0_BASE + 0x4B)
#define REG_HDMIRX_VE_U0_26_L           (REG_HDMIRX_VE_U0_BASE + 0x4C)
#define REG_HDMIRX_VE_U0_26_H           (REG_HDMIRX_VE_U0_BASE + 0x4D)
#define REG_HDMIRX_VE_U0_27_L           (REG_HDMIRX_VE_U0_BASE + 0x4E)
#define REG_HDMIRX_VE_U0_27_H           (REG_HDMIRX_VE_U0_BASE + 0x4F)
#define REG_HDMIRX_VE_U0_28_L           (REG_HDMIRX_VE_U0_BASE + 0x50)
#define REG_HDMIRX_VE_U0_28_H           (REG_HDMIRX_VE_U0_BASE + 0x51)
#define REG_HDMIRX_VE_U0_29_L           (REG_HDMIRX_VE_U0_BASE + 0x52)
#define REG_HDMIRX_VE_U0_29_H           (REG_HDMIRX_VE_U0_BASE + 0x53)
#define REG_HDMIRX_VE_U0_2A_L           (REG_HDMIRX_VE_U0_BASE + 0x54)
#define REG_HDMIRX_VE_U0_2A_H           (REG_HDMIRX_VE_U0_BASE + 0x55)
#define REG_HDMIRX_VE_U0_2B_L           (REG_HDMIRX_VE_U0_BASE + 0x56)
#define REG_HDMIRX_VE_U0_2B_H           (REG_HDMIRX_VE_U0_BASE + 0x57)
#define REG_HDMIRX_VE_U0_2C_L           (REG_HDMIRX_VE_U0_BASE + 0x58)
#define REG_HDMIRX_VE_U0_2C_H           (REG_HDMIRX_VE_U0_BASE + 0x59)
#define REG_HDMIRX_VE_U0_2D_L           (REG_HDMIRX_VE_U0_BASE + 0x5A)
#define REG_HDMIRX_VE_U0_2D_H           (REG_HDMIRX_VE_U0_BASE + 0x5B)
#define REG_HDMIRX_VE_U0_2E_L           (REG_HDMIRX_VE_U0_BASE + 0x5C)
#define REG_HDMIRX_VE_U0_2E_H           (REG_HDMIRX_VE_U0_BASE + 0x5D)
#define REG_HDMIRX_VE_U0_2F_L           (REG_HDMIRX_VE_U0_BASE + 0x5E)
#define REG_HDMIRX_VE_U0_2F_H           (REG_HDMIRX_VE_U0_BASE + 0x5F)
#define REG_HDMIRX_VE_U0_30_L           (REG_HDMIRX_VE_U0_BASE + 0x60)
#define REG_HDMIRX_VE_U0_30_H           (REG_HDMIRX_VE_U0_BASE + 0x61)
#define REG_HDMIRX_VE_U0_31_L           (REG_HDMIRX_VE_U0_BASE + 0x62)
#define REG_HDMIRX_VE_U0_31_H           (REG_HDMIRX_VE_U0_BASE + 0x63)
#define REG_HDMIRX_VE_U0_32_L           (REG_HDMIRX_VE_U0_BASE + 0x64)
#define REG_HDMIRX_VE_U0_32_H           (REG_HDMIRX_VE_U0_BASE + 0x65)
#define REG_HDMIRX_VE_U0_33_L           (REG_HDMIRX_VE_U0_BASE + 0x66)
#define REG_HDMIRX_VE_U0_33_H           (REG_HDMIRX_VE_U0_BASE + 0x67)
#define REG_HDMIRX_VE_U0_34_L           (REG_HDMIRX_VE_U0_BASE + 0x68)
#define REG_HDMIRX_VE_U0_34_H           (REG_HDMIRX_VE_U0_BASE + 0x69)
#define REG_HDMIRX_VE_U0_35_L           (REG_HDMIRX_VE_U0_BASE + 0x6A)
#define REG_HDMIRX_VE_U0_35_H           (REG_HDMIRX_VE_U0_BASE + 0x6B)
#define REG_HDMIRX_VE_U0_36_L           (REG_HDMIRX_VE_U0_BASE + 0x6C)
#define REG_HDMIRX_VE_U0_36_H           (REG_HDMIRX_VE_U0_BASE + 0x6D)
#define REG_HDMIRX_VE_U0_37_L           (REG_HDMIRX_VE_U0_BASE + 0x6E)
#define REG_HDMIRX_VE_U0_37_H           (REG_HDMIRX_VE_U0_BASE + 0x6F)
#define REG_HDMIRX_VE_U0_38_L           (REG_HDMIRX_VE_U0_BASE + 0x70)
#define REG_HDMIRX_VE_U0_38_H           (REG_HDMIRX_VE_U0_BASE + 0x71)
#define REG_HDMIRX_VE_U0_39_L           (REG_HDMIRX_VE_U0_BASE + 0x72)
#define REG_HDMIRX_VE_U0_39_H           (REG_HDMIRX_VE_U0_BASE + 0x73)
#define REG_HDMIRX_VE_U0_3A_L           (REG_HDMIRX_VE_U0_BASE + 0x74)
#define REG_HDMIRX_VE_U0_3A_H           (REG_HDMIRX_VE_U0_BASE + 0x75)
#define REG_HDMIRX_VE_U0_3B_L           (REG_HDMIRX_VE_U0_BASE + 0x76)
#define REG_HDMIRX_VE_U0_3B_H           (REG_HDMIRX_VE_U0_BASE + 0x77)
#define REG_HDMIRX_VE_U0_3C_L           (REG_HDMIRX_VE_U0_BASE + 0x78)
#define REG_HDMIRX_VE_U0_3C_H           (REG_HDMIRX_VE_U0_BASE + 0x79)
#define REG_HDMIRX_VE_U0_3D_L           (REG_HDMIRX_VE_U0_BASE + 0x7A)
#define REG_HDMIRX_VE_U0_3D_H           (REG_HDMIRX_VE_U0_BASE + 0x7B)
#define REG_HDMIRX_VE_U0_3E_L           (REG_HDMIRX_VE_U0_BASE + 0x7C)
#define REG_HDMIRX_VE_U0_3E_H           (REG_HDMIRX_VE_U0_BASE + 0x7D)
#define REG_HDMIRX_VE_U0_3F_L           (REG_HDMIRX_VE_U0_BASE + 0x7E)
#define REG_HDMIRX_VE_U0_3F_H           (REG_HDMIRX_VE_U0_BASE + 0x7F)
#define REG_HDMIRX_VE_U0_40_L           (REG_HDMIRX_VE_U0_BASE + 0x80)
#define REG_HDMIRX_VE_U0_40_H           (REG_HDMIRX_VE_U0_BASE + 0x81)
#define REG_HDMIRX_VE_U0_41_L           (REG_HDMIRX_VE_U0_BASE + 0x82)
#define REG_HDMIRX_VE_U0_41_H           (REG_HDMIRX_VE_U0_BASE + 0x83)
#define REG_HDMIRX_VE_U0_42_L           (REG_HDMIRX_VE_U0_BASE + 0x84)
#define REG_HDMIRX_VE_U0_42_H           (REG_HDMIRX_VE_U0_BASE + 0x85)
#define REG_HDMIRX_VE_U0_43_L           (REG_HDMIRX_VE_U0_BASE + 0x86)
#define REG_HDMIRX_VE_U0_43_H           (REG_HDMIRX_VE_U0_BASE + 0x87)
#define REG_HDMIRX_VE_U0_44_L           (REG_HDMIRX_VE_U0_BASE + 0x88)
#define REG_HDMIRX_VE_U0_44_H           (REG_HDMIRX_VE_U0_BASE + 0x89)
#define REG_HDMIRX_VE_U0_45_L           (REG_HDMIRX_VE_U0_BASE + 0x8A)
#define REG_HDMIRX_VE_U0_45_H           (REG_HDMIRX_VE_U0_BASE + 0x8B)
#define REG_HDMIRX_VE_U0_46_L           (REG_HDMIRX_VE_U0_BASE + 0x8C)
#define REG_HDMIRX_VE_U0_46_H           (REG_HDMIRX_VE_U0_BASE + 0x8D)
#define REG_HDMIRX_VE_U0_47_L           (REG_HDMIRX_VE_U0_BASE + 0x8E)
#define REG_HDMIRX_VE_U0_47_H           (REG_HDMIRX_VE_U0_BASE + 0x8F)
#define REG_HDMIRX_VE_U0_48_L           (REG_HDMIRX_VE_U0_BASE + 0x90)
#define REG_HDMIRX_VE_U0_48_H           (REG_HDMIRX_VE_U0_BASE + 0x91)
#define REG_HDMIRX_VE_U0_49_L           (REG_HDMIRX_VE_U0_BASE + 0x92)
#define REG_HDMIRX_VE_U0_49_H           (REG_HDMIRX_VE_U0_BASE + 0x93)
#define REG_HDMIRX_VE_U0_4A_L           (REG_HDMIRX_VE_U0_BASE + 0x94)
#define REG_HDMIRX_VE_U0_4A_H           (REG_HDMIRX_VE_U0_BASE + 0x95)
#define REG_HDMIRX_VE_U0_4B_L           (REG_HDMIRX_VE_U0_BASE + 0x96)
#define REG_HDMIRX_VE_U0_4B_H           (REG_HDMIRX_VE_U0_BASE + 0x97)
#define REG_HDMIRX_VE_U0_4C_L           (REG_HDMIRX_VE_U0_BASE + 0x98)
#define REG_HDMIRX_VE_U0_4C_H           (REG_HDMIRX_VE_U0_BASE + 0x99)
#define REG_HDMIRX_VE_U0_4D_L           (REG_HDMIRX_VE_U0_BASE + 0x9A)
#define REG_HDMIRX_VE_U0_4D_H           (REG_HDMIRX_VE_U0_BASE + 0x9B)
#define REG_HDMIRX_VE_U0_4E_L           (REG_HDMIRX_VE_U0_BASE + 0x9C)
#define REG_HDMIRX_VE_U0_4E_H           (REG_HDMIRX_VE_U0_BASE + 0x9D)
#define REG_HDMIRX_VE_U0_4F_L           (REG_HDMIRX_VE_U0_BASE + 0x9E)
#define REG_HDMIRX_VE_U0_4F_H           (REG_HDMIRX_VE_U0_BASE + 0x9F)
#define REG_HDMIRX_VE_U0_50_L           (REG_HDMIRX_VE_U0_BASE + 0xA0)
#define REG_HDMIRX_VE_U0_50_H           (REG_HDMIRX_VE_U0_BASE + 0xA1)
#define REG_HDMIRX_VE_U0_51_L           (REG_HDMIRX_VE_U0_BASE + 0xA2)
#define REG_HDMIRX_VE_U0_51_H           (REG_HDMIRX_VE_U0_BASE + 0xA3)
#define REG_HDMIRX_VE_U0_52_L           (REG_HDMIRX_VE_U0_BASE + 0xA4)
#define REG_HDMIRX_VE_U0_52_H           (REG_HDMIRX_VE_U0_BASE + 0xA5)
#define REG_HDMIRX_VE_U0_53_L           (REG_HDMIRX_VE_U0_BASE + 0xA6)
#define REG_HDMIRX_VE_U0_53_H           (REG_HDMIRX_VE_U0_BASE + 0xA7)
#define REG_HDMIRX_VE_U0_54_L           (REG_HDMIRX_VE_U0_BASE + 0xA8)
#define REG_HDMIRX_VE_U0_54_H           (REG_HDMIRX_VE_U0_BASE + 0xA9)
#define REG_HDMIRX_VE_U0_55_L           (REG_HDMIRX_VE_U0_BASE + 0xAA)
#define REG_HDMIRX_VE_U0_55_H           (REG_HDMIRX_VE_U0_BASE + 0xAB)
#define REG_HDMIRX_VE_U0_56_L           (REG_HDMIRX_VE_U0_BASE + 0xAC)
#define REG_HDMIRX_VE_U0_56_H           (REG_HDMIRX_VE_U0_BASE + 0xAD)
#define REG_HDMIRX_VE_U0_57_L           (REG_HDMIRX_VE_U0_BASE + 0xAE)
#define REG_HDMIRX_VE_U0_57_H           (REG_HDMIRX_VE_U0_BASE + 0xAF)
#define REG_HDMIRX_VE_U0_58_L           (REG_HDMIRX_VE_U0_BASE + 0xB0)
#define REG_HDMIRX_VE_U0_58_H           (REG_HDMIRX_VE_U0_BASE + 0xB1)
#define REG_HDMIRX_VE_U0_59_L           (REG_HDMIRX_VE_U0_BASE + 0xB2)
#define REG_HDMIRX_VE_U0_59_H           (REG_HDMIRX_VE_U0_BASE + 0xB3)
#define REG_HDMIRX_VE_U0_5A_L           (REG_HDMIRX_VE_U0_BASE + 0xB4)
#define REG_HDMIRX_VE_U0_5A_H           (REG_HDMIRX_VE_U0_BASE + 0xB5)
#define REG_HDMIRX_VE_U0_5B_L           (REG_HDMIRX_VE_U0_BASE + 0xB6)
#define REG_HDMIRX_VE_U0_5B_H           (REG_HDMIRX_VE_U0_BASE + 0xB7)
#define REG_HDMIRX_VE_U0_5C_L           (REG_HDMIRX_VE_U0_BASE + 0xB8)
#define REG_HDMIRX_VE_U0_5C_H           (REG_HDMIRX_VE_U0_BASE + 0xB9)
#define REG_HDMIRX_VE_U0_5D_L           (REG_HDMIRX_VE_U0_BASE + 0xBA)
#define REG_HDMIRX_VE_U0_5D_H           (REG_HDMIRX_VE_U0_BASE + 0xBB)
#define REG_HDMIRX_VE_U0_5E_L           (REG_HDMIRX_VE_U0_BASE + 0xBC)
#define REG_HDMIRX_VE_U0_5E_H           (REG_HDMIRX_VE_U0_BASE + 0xBD)
#define REG_HDMIRX_VE_U0_5F_L           (REG_HDMIRX_VE_U0_BASE + 0xBE)
#define REG_HDMIRX_VE_U0_5F_H           (REG_HDMIRX_VE_U0_BASE + 0xBF)
#define REG_HDMIRX_VE_U0_60_L           (REG_HDMIRX_VE_U0_BASE + 0xC0)
#define REG_HDMIRX_VE_U0_60_H           (REG_HDMIRX_VE_U0_BASE + 0xC1)
#define REG_HDMIRX_VE_U0_61_L           (REG_HDMIRX_VE_U0_BASE + 0xC2)
#define REG_HDMIRX_VE_U0_61_H           (REG_HDMIRX_VE_U0_BASE + 0xC3)
#define REG_HDMIRX_VE_U0_62_L           (REG_HDMIRX_VE_U0_BASE + 0xC4)
#define REG_HDMIRX_VE_U0_62_H           (REG_HDMIRX_VE_U0_BASE + 0xC5)
#define REG_HDMIRX_VE_U0_63_L           (REG_HDMIRX_VE_U0_BASE + 0xC6)
#define REG_HDMIRX_VE_U0_63_H           (REG_HDMIRX_VE_U0_BASE + 0xC7)
#define REG_HDMIRX_VE_U0_64_L           (REG_HDMIRX_VE_U0_BASE + 0xC8)
#define REG_HDMIRX_VE_U0_64_H           (REG_HDMIRX_VE_U0_BASE + 0xC9)
#define REG_HDMIRX_VE_U0_65_L           (REG_HDMIRX_VE_U0_BASE + 0xCA)
#define REG_HDMIRX_VE_U0_65_H           (REG_HDMIRX_VE_U0_BASE + 0xCB)
#define REG_HDMIRX_VE_U0_66_L           (REG_HDMIRX_VE_U0_BASE + 0xCC)
#define REG_HDMIRX_VE_U0_66_H           (REG_HDMIRX_VE_U0_BASE + 0xCD)
#define REG_HDMIRX_VE_U0_67_L           (REG_HDMIRX_VE_U0_BASE + 0xCE)
#define REG_HDMIRX_VE_U0_67_H           (REG_HDMIRX_VE_U0_BASE + 0xCF)
#define REG_HDMIRX_VE_U0_68_L           (REG_HDMIRX_VE_U0_BASE + 0xD0)
#define REG_HDMIRX_VE_U0_68_H           (REG_HDMIRX_VE_U0_BASE + 0xD1)
#define REG_HDMIRX_VE_U0_69_L           (REG_HDMIRX_VE_U0_BASE + 0xD2)
#define REG_HDMIRX_VE_U0_69_H           (REG_HDMIRX_VE_U0_BASE + 0xD3)
#define REG_HDMIRX_VE_U0_6A_L           (REG_HDMIRX_VE_U0_BASE + 0xD4)
#define REG_HDMIRX_VE_U0_6A_H           (REG_HDMIRX_VE_U0_BASE + 0xD5)
#define REG_HDMIRX_VE_U0_6B_L           (REG_HDMIRX_VE_U0_BASE + 0xD6)
#define REG_HDMIRX_VE_U0_6B_H           (REG_HDMIRX_VE_U0_BASE + 0xD7)
#define REG_HDMIRX_VE_U0_6C_L           (REG_HDMIRX_VE_U0_BASE + 0xD8)
#define REG_HDMIRX_VE_U0_6C_H           (REG_HDMIRX_VE_U0_BASE + 0xD9)
#define REG_HDMIRX_VE_U0_6D_L           (REG_HDMIRX_VE_U0_BASE + 0xDA)
#define REG_HDMIRX_VE_U0_6D_H           (REG_HDMIRX_VE_U0_BASE + 0xDB)
#define REG_HDMIRX_VE_U0_6E_L           (REG_HDMIRX_VE_U0_BASE + 0xDC)
#define REG_HDMIRX_VE_U0_6E_H           (REG_HDMIRX_VE_U0_BASE + 0xDD)
#define REG_HDMIRX_VE_U0_6F_L           (REG_HDMIRX_VE_U0_BASE + 0xDE)
#define REG_HDMIRX_VE_U0_6F_H           (REG_HDMIRX_VE_U0_BASE + 0xDF)
#define REG_HDMIRX_VE_U0_70_L           (REG_HDMIRX_VE_U0_BASE + 0xE0)
#define REG_HDMIRX_VE_U0_70_H           (REG_HDMIRX_VE_U0_BASE + 0xE1)
#define REG_HDMIRX_VE_U0_71_L           (REG_HDMIRX_VE_U0_BASE + 0xE2)
#define REG_HDMIRX_VE_U0_71_H           (REG_HDMIRX_VE_U0_BASE + 0xE3)
#define REG_HDMIRX_VE_U0_72_L           (REG_HDMIRX_VE_U0_BASE + 0xE4)
#define REG_HDMIRX_VE_U0_72_H           (REG_HDMIRX_VE_U0_BASE + 0xE5)
#define REG_HDMIRX_VE_U0_73_L           (REG_HDMIRX_VE_U0_BASE + 0xE6)
#define REG_HDMIRX_VE_U0_73_H           (REG_HDMIRX_VE_U0_BASE + 0xE7)
#define REG_HDMIRX_VE_U0_74_L           (REG_HDMIRX_VE_U0_BASE + 0xE8)
#define REG_HDMIRX_VE_U0_74_H           (REG_HDMIRX_VE_U0_BASE + 0xE9)
#define REG_HDMIRX_VE_U0_75_L           (REG_HDMIRX_VE_U0_BASE + 0xEA)
#define REG_HDMIRX_VE_U0_75_H           (REG_HDMIRX_VE_U0_BASE + 0xEB)
#define REG_HDMIRX_VE_U0_76_L           (REG_HDMIRX_VE_U0_BASE + 0xEC)
#define REG_HDMIRX_VE_U0_76_H           (REG_HDMIRX_VE_U0_BASE + 0xED)
#define REG_HDMIRX_VE_U0_77_L           (REG_HDMIRX_VE_U0_BASE + 0xEE)
#define REG_HDMIRX_VE_U0_77_H           (REG_HDMIRX_VE_U0_BASE + 0xEF)
#define REG_HDMIRX_VE_U0_78_L           (REG_HDMIRX_VE_U0_BASE + 0xF0)
#define REG_HDMIRX_VE_U0_78_H           (REG_HDMIRX_VE_U0_BASE + 0xF1)
#define REG_HDMIRX_VE_U0_79_L           (REG_HDMIRX_VE_U0_BASE + 0xF2)
#define REG_HDMIRX_VE_U0_79_H           (REG_HDMIRX_VE_U0_BASE + 0xF3)
#define REG_HDMIRX_VE_U0_7A_L           (REG_HDMIRX_VE_U0_BASE + 0xF4)
#define REG_HDMIRX_VE_U0_7A_H           (REG_HDMIRX_VE_U0_BASE + 0xF5)
#define REG_HDMIRX_VE_U0_7B_L           (REG_HDMIRX_VE_U0_BASE + 0xF6)
#define REG_HDMIRX_VE_U0_7B_H           (REG_HDMIRX_VE_U0_BASE + 0xF7)
#define REG_HDMIRX_VE_U0_7C_L           (REG_HDMIRX_VE_U0_BASE + 0xF8)
#define REG_HDMIRX_VE_U0_7C_H           (REG_HDMIRX_VE_U0_BASE + 0xF9)
#define REG_HDMIRX_VE_U0_7D_L           (REG_HDMIRX_VE_U0_BASE + 0xFA)
#define REG_HDMIRX_VE_U0_7D_H           (REG_HDMIRX_VE_U0_BASE + 0xFB)
#define REG_HDMIRX_VE_U0_7E_L           (REG_HDMIRX_VE_U0_BASE + 0xFC)
#define REG_HDMIRX_VE_U0_7E_H           (REG_HDMIRX_VE_U0_BASE + 0xFD)
#define REG_HDMIRX_VE_U0_7F_L           (REG_HDMIRX_VE_U0_BASE + 0xFE)
#define REG_HDMIRX_VE_U0_7F_H           (REG_HDMIRX_VE_U0_BASE + 0xFF)

//=============================================================
// HDMIRX_VE_U1
#define REG_HDMIRX_VE_U1_00_L           (REG_HDMIRX_VE_U1_BASE + 0x00)
#define REG_HDMIRX_VE_U1_00_H           (REG_HDMIRX_VE_U1_BASE + 0x01)
#define REG_HDMIRX_VE_U1_01_L           (REG_HDMIRX_VE_U1_BASE + 0x02)
#define REG_HDMIRX_VE_U1_01_H           (REG_HDMIRX_VE_U1_BASE + 0x03)
#define REG_HDMIRX_VE_U1_02_L           (REG_HDMIRX_VE_U1_BASE + 0x04)
#define REG_HDMIRX_VE_U1_02_H           (REG_HDMIRX_VE_U1_BASE + 0x05)
#define REG_HDMIRX_VE_U1_03_L           (REG_HDMIRX_VE_U1_BASE + 0x06)
#define REG_HDMIRX_VE_U1_03_H           (REG_HDMIRX_VE_U1_BASE + 0x07)
#define REG_HDMIRX_VE_U1_04_L           (REG_HDMIRX_VE_U1_BASE + 0x08)
#define REG_HDMIRX_VE_U1_04_H           (REG_HDMIRX_VE_U1_BASE + 0x09)
#define REG_HDMIRX_VE_U1_05_L           (REG_HDMIRX_VE_U1_BASE + 0x0A)
#define REG_HDMIRX_VE_U1_05_H           (REG_HDMIRX_VE_U1_BASE + 0x0B)
#define REG_HDMIRX_VE_U1_06_L           (REG_HDMIRX_VE_U1_BASE + 0x0C)
#define REG_HDMIRX_VE_U1_06_H           (REG_HDMIRX_VE_U1_BASE + 0x0D)
#define REG_HDMIRX_VE_U1_07_L           (REG_HDMIRX_VE_U1_BASE + 0x0E)
#define REG_HDMIRX_VE_U1_07_H           (REG_HDMIRX_VE_U1_BASE + 0x0F)
#define REG_HDMIRX_VE_U1_08_L           (REG_HDMIRX_VE_U1_BASE + 0x10)
#define REG_HDMIRX_VE_U1_08_H           (REG_HDMIRX_VE_U1_BASE + 0x11)
#define REG_HDMIRX_VE_U1_09_L           (REG_HDMIRX_VE_U1_BASE + 0x12)
#define REG_HDMIRX_VE_U1_09_H           (REG_HDMIRX_VE_U1_BASE + 0x13)
#define REG_HDMIRX_VE_U1_0A_L           (REG_HDMIRX_VE_U1_BASE + 0x14)
#define REG_HDMIRX_VE_U1_0A_H           (REG_HDMIRX_VE_U1_BASE + 0x15)
#define REG_HDMIRX_VE_U1_0B_L           (REG_HDMIRX_VE_U1_BASE + 0x16)
#define REG_HDMIRX_VE_U1_0B_H           (REG_HDMIRX_VE_U1_BASE + 0x17)
#define REG_HDMIRX_VE_U1_0C_L           (REG_HDMIRX_VE_U1_BASE + 0x18)
#define REG_HDMIRX_VE_U1_0C_H           (REG_HDMIRX_VE_U1_BASE + 0x19)
#define REG_HDMIRX_VE_U1_0D_L           (REG_HDMIRX_VE_U1_BASE + 0x1A)
#define REG_HDMIRX_VE_U1_0D_H           (REG_HDMIRX_VE_U1_BASE + 0x1B)
#define REG_HDMIRX_VE_U1_0E_L           (REG_HDMIRX_VE_U1_BASE + 0x1C)
#define REG_HDMIRX_VE_U1_0E_H           (REG_HDMIRX_VE_U1_BASE + 0x1D)
#define REG_HDMIRX_VE_U1_0F_L           (REG_HDMIRX_VE_U1_BASE + 0x1E)
#define REG_HDMIRX_VE_U1_0F_H           (REG_HDMIRX_VE_U1_BASE + 0x1F)
#define REG_HDMIRX_VE_U1_10_L           (REG_HDMIRX_VE_U1_BASE + 0x20)
#define REG_HDMIRX_VE_U1_10_H           (REG_HDMIRX_VE_U1_BASE + 0x21)
#define REG_HDMIRX_VE_U1_11_L           (REG_HDMIRX_VE_U1_BASE + 0x22)
#define REG_HDMIRX_VE_U1_11_H           (REG_HDMIRX_VE_U1_BASE + 0x23)
#define REG_HDMIRX_VE_U1_12_L           (REG_HDMIRX_VE_U1_BASE + 0x24)
#define REG_HDMIRX_VE_U1_12_H           (REG_HDMIRX_VE_U1_BASE + 0x25)
#define REG_HDMIRX_VE_U1_13_L           (REG_HDMIRX_VE_U1_BASE + 0x26)
#define REG_HDMIRX_VE_U1_13_H           (REG_HDMIRX_VE_U1_BASE + 0x27)
#define REG_HDMIRX_VE_U1_14_L           (REG_HDMIRX_VE_U1_BASE + 0x28)
#define REG_HDMIRX_VE_U1_14_H           (REG_HDMIRX_VE_U1_BASE + 0x29)
#define REG_HDMIRX_VE_U1_15_L           (REG_HDMIRX_VE_U1_BASE + 0x2A)
#define REG_HDMIRX_VE_U1_15_H           (REG_HDMIRX_VE_U1_BASE + 0x2B)
#define REG_HDMIRX_VE_U1_16_L           (REG_HDMIRX_VE_U1_BASE + 0x2C)
#define REG_HDMIRX_VE_U1_16_H           (REG_HDMIRX_VE_U1_BASE + 0x2D)
#define REG_HDMIRX_VE_U1_17_L           (REG_HDMIRX_VE_U1_BASE + 0x2E)
#define REG_HDMIRX_VE_U1_17_H           (REG_HDMIRX_VE_U1_BASE + 0x2F)
#define REG_HDMIRX_VE_U1_18_L           (REG_HDMIRX_VE_U1_BASE + 0x30)
#define REG_HDMIRX_VE_U1_18_H           (REG_HDMIRX_VE_U1_BASE + 0x31)
#define REG_HDMIRX_VE_U1_19_L           (REG_HDMIRX_VE_U1_BASE + 0x32)
#define REG_HDMIRX_VE_U1_19_H           (REG_HDMIRX_VE_U1_BASE + 0x33)
#define REG_HDMIRX_VE_U1_1A_L           (REG_HDMIRX_VE_U1_BASE + 0x34)
#define REG_HDMIRX_VE_U1_1A_H           (REG_HDMIRX_VE_U1_BASE + 0x35)
#define REG_HDMIRX_VE_U1_1B_L           (REG_HDMIRX_VE_U1_BASE + 0x36)
#define REG_HDMIRX_VE_U1_1B_H           (REG_HDMIRX_VE_U1_BASE + 0x37)
#define REG_HDMIRX_VE_U1_1C_L           (REG_HDMIRX_VE_U1_BASE + 0x38)
#define REG_HDMIRX_VE_U1_1C_H           (REG_HDMIRX_VE_U1_BASE + 0x39)
#define REG_HDMIRX_VE_U1_1D_L           (REG_HDMIRX_VE_U1_BASE + 0x3A)
#define REG_HDMIRX_VE_U1_1D_H           (REG_HDMIRX_VE_U1_BASE + 0x3B)
#define REG_HDMIRX_VE_U1_1E_L           (REG_HDMIRX_VE_U1_BASE + 0x3C)
#define REG_HDMIRX_VE_U1_1E_H           (REG_HDMIRX_VE_U1_BASE + 0x3D)
#define REG_HDMIRX_VE_U1_1F_L           (REG_HDMIRX_VE_U1_BASE + 0x3E)
#define REG_HDMIRX_VE_U1_1F_H           (REG_HDMIRX_VE_U1_BASE + 0x3F)
#define REG_HDMIRX_VE_U1_20_L           (REG_HDMIRX_VE_U1_BASE + 0x40)
#define REG_HDMIRX_VE_U1_20_H           (REG_HDMIRX_VE_U1_BASE + 0x41)
#define REG_HDMIRX_VE_U1_21_L           (REG_HDMIRX_VE_U1_BASE + 0x42)
#define REG_HDMIRX_VE_U1_21_H           (REG_HDMIRX_VE_U1_BASE + 0x43)
#define REG_HDMIRX_VE_U1_22_L           (REG_HDMIRX_VE_U1_BASE + 0x44)
#define REG_HDMIRX_VE_U1_22_H           (REG_HDMIRX_VE_U1_BASE + 0x45)
#define REG_HDMIRX_VE_U1_23_L           (REG_HDMIRX_VE_U1_BASE + 0x46)
#define REG_HDMIRX_VE_U1_23_H           (REG_HDMIRX_VE_U1_BASE + 0x47)
#define REG_HDMIRX_VE_U1_24_L           (REG_HDMIRX_VE_U1_BASE + 0x48)
#define REG_HDMIRX_VE_U1_24_H           (REG_HDMIRX_VE_U1_BASE + 0x49)
#define REG_HDMIRX_VE_U1_25_L           (REG_HDMIRX_VE_U1_BASE + 0x4A)
#define REG_HDMIRX_VE_U1_25_H           (REG_HDMIRX_VE_U1_BASE + 0x4B)
#define REG_HDMIRX_VE_U1_26_L           (REG_HDMIRX_VE_U1_BASE + 0x4C)
#define REG_HDMIRX_VE_U1_26_H           (REG_HDMIRX_VE_U1_BASE + 0x4D)
#define REG_HDMIRX_VE_U1_27_L           (REG_HDMIRX_VE_U1_BASE + 0x4E)
#define REG_HDMIRX_VE_U1_27_H           (REG_HDMIRX_VE_U1_BASE + 0x4F)
#define REG_HDMIRX_VE_U1_28_L           (REG_HDMIRX_VE_U1_BASE + 0x50)
#define REG_HDMIRX_VE_U1_28_H           (REG_HDMIRX_VE_U1_BASE + 0x51)
#define REG_HDMIRX_VE_U1_29_L           (REG_HDMIRX_VE_U1_BASE + 0x52)
#define REG_HDMIRX_VE_U1_29_H           (REG_HDMIRX_VE_U1_BASE + 0x53)
#define REG_HDMIRX_VE_U1_2A_L           (REG_HDMIRX_VE_U1_BASE + 0x54)
#define REG_HDMIRX_VE_U1_2A_H           (REG_HDMIRX_VE_U1_BASE + 0x55)
#define REG_HDMIRX_VE_U1_2B_L           (REG_HDMIRX_VE_U1_BASE + 0x56)
#define REG_HDMIRX_VE_U1_2B_H           (REG_HDMIRX_VE_U1_BASE + 0x57)
#define REG_HDMIRX_VE_U1_2C_L           (REG_HDMIRX_VE_U1_BASE + 0x58)
#define REG_HDMIRX_VE_U1_2C_H           (REG_HDMIRX_VE_U1_BASE + 0x59)
#define REG_HDMIRX_VE_U1_2D_L           (REG_HDMIRX_VE_U1_BASE + 0x5A)
#define REG_HDMIRX_VE_U1_2D_H           (REG_HDMIRX_VE_U1_BASE + 0x5B)
#define REG_HDMIRX_VE_U1_2E_L           (REG_HDMIRX_VE_U1_BASE + 0x5C)
#define REG_HDMIRX_VE_U1_2E_H           (REG_HDMIRX_VE_U1_BASE + 0x5D)
#define REG_HDMIRX_VE_U1_2F_L           (REG_HDMIRX_VE_U1_BASE + 0x5E)
#define REG_HDMIRX_VE_U1_2F_H           (REG_HDMIRX_VE_U1_BASE + 0x5F)
#define REG_HDMIRX_VE_U1_30_L           (REG_HDMIRX_VE_U1_BASE + 0x60)
#define REG_HDMIRX_VE_U1_30_H           (REG_HDMIRX_VE_U1_BASE + 0x61)
#define REG_HDMIRX_VE_U1_31_L           (REG_HDMIRX_VE_U1_BASE + 0x62)
#define REG_HDMIRX_VE_U1_31_H           (REG_HDMIRX_VE_U1_BASE + 0x63)
#define REG_HDMIRX_VE_U1_32_L           (REG_HDMIRX_VE_U1_BASE + 0x64)
#define REG_HDMIRX_VE_U1_32_H           (REG_HDMIRX_VE_U1_BASE + 0x65)
#define REG_HDMIRX_VE_U1_33_L           (REG_HDMIRX_VE_U1_BASE + 0x66)
#define REG_HDMIRX_VE_U1_33_H           (REG_HDMIRX_VE_U1_BASE + 0x67)
#define REG_HDMIRX_VE_U1_34_L           (REG_HDMIRX_VE_U1_BASE + 0x68)
#define REG_HDMIRX_VE_U1_34_H           (REG_HDMIRX_VE_U1_BASE + 0x69)
#define REG_HDMIRX_VE_U1_35_L           (REG_HDMIRX_VE_U1_BASE + 0x6A)
#define REG_HDMIRX_VE_U1_35_H           (REG_HDMIRX_VE_U1_BASE + 0x6B)
#define REG_HDMIRX_VE_U1_36_L           (REG_HDMIRX_VE_U1_BASE + 0x6C)
#define REG_HDMIRX_VE_U1_36_H           (REG_HDMIRX_VE_U1_BASE + 0x6D)
#define REG_HDMIRX_VE_U1_37_L           (REG_HDMIRX_VE_U1_BASE + 0x6E)
#define REG_HDMIRX_VE_U1_37_H           (REG_HDMIRX_VE_U1_BASE + 0x6F)
#define REG_HDMIRX_VE_U1_38_L           (REG_HDMIRX_VE_U1_BASE + 0x70)
#define REG_HDMIRX_VE_U1_38_H           (REG_HDMIRX_VE_U1_BASE + 0x71)
#define REG_HDMIRX_VE_U1_39_L           (REG_HDMIRX_VE_U1_BASE + 0x72)
#define REG_HDMIRX_VE_U1_39_H           (REG_HDMIRX_VE_U1_BASE + 0x73)
#define REG_HDMIRX_VE_U1_3A_L           (REG_HDMIRX_VE_U1_BASE + 0x74)
#define REG_HDMIRX_VE_U1_3A_H           (REG_HDMIRX_VE_U1_BASE + 0x75)
#define REG_HDMIRX_VE_U1_3B_L           (REG_HDMIRX_VE_U1_BASE + 0x76)
#define REG_HDMIRX_VE_U1_3B_H           (REG_HDMIRX_VE_U1_BASE + 0x77)
#define REG_HDMIRX_VE_U1_3C_L           (REG_HDMIRX_VE_U1_BASE + 0x78)
#define REG_HDMIRX_VE_U1_3C_H           (REG_HDMIRX_VE_U1_BASE + 0x79)
#define REG_HDMIRX_VE_U1_3D_L           (REG_HDMIRX_VE_U1_BASE + 0x7A)
#define REG_HDMIRX_VE_U1_3D_H           (REG_HDMIRX_VE_U1_BASE + 0x7B)
#define REG_HDMIRX_VE_U1_3E_L           (REG_HDMIRX_VE_U1_BASE + 0x7C)
#define REG_HDMIRX_VE_U1_3E_H           (REG_HDMIRX_VE_U1_BASE + 0x7D)
#define REG_HDMIRX_VE_U1_3F_L           (REG_HDMIRX_VE_U1_BASE + 0x7E)
#define REG_HDMIRX_VE_U1_3F_H           (REG_HDMIRX_VE_U1_BASE + 0x7F)
#define REG_HDMIRX_VE_U1_40_L           (REG_HDMIRX_VE_U1_BASE + 0x80)
#define REG_HDMIRX_VE_U1_40_H           (REG_HDMIRX_VE_U1_BASE + 0x81)
#define REG_HDMIRX_VE_U1_41_L           (REG_HDMIRX_VE_U1_BASE + 0x82)
#define REG_HDMIRX_VE_U1_41_H           (REG_HDMIRX_VE_U1_BASE + 0x83)
#define REG_HDMIRX_VE_U1_42_L           (REG_HDMIRX_VE_U1_BASE + 0x84)
#define REG_HDMIRX_VE_U1_42_H           (REG_HDMIRX_VE_U1_BASE + 0x85)
#define REG_HDMIRX_VE_U1_43_L           (REG_HDMIRX_VE_U1_BASE + 0x86)
#define REG_HDMIRX_VE_U1_43_H           (REG_HDMIRX_VE_U1_BASE + 0x87)
#define REG_HDMIRX_VE_U1_44_L           (REG_HDMIRX_VE_U1_BASE + 0x88)
#define REG_HDMIRX_VE_U1_44_H           (REG_HDMIRX_VE_U1_BASE + 0x89)
#define REG_HDMIRX_VE_U1_45_L           (REG_HDMIRX_VE_U1_BASE + 0x8A)
#define REG_HDMIRX_VE_U1_45_H           (REG_HDMIRX_VE_U1_BASE + 0x8B)
#define REG_HDMIRX_VE_U1_46_L           (REG_HDMIRX_VE_U1_BASE + 0x8C)
#define REG_HDMIRX_VE_U1_46_H           (REG_HDMIRX_VE_U1_BASE + 0x8D)
#define REG_HDMIRX_VE_U1_47_L           (REG_HDMIRX_VE_U1_BASE + 0x8E)
#define REG_HDMIRX_VE_U1_47_H           (REG_HDMIRX_VE_U1_BASE + 0x8F)
#define REG_HDMIRX_VE_U1_48_L           (REG_HDMIRX_VE_U1_BASE + 0x90)
#define REG_HDMIRX_VE_U1_48_H           (REG_HDMIRX_VE_U1_BASE + 0x91)
#define REG_HDMIRX_VE_U1_49_L           (REG_HDMIRX_VE_U1_BASE + 0x92)
#define REG_HDMIRX_VE_U1_49_H           (REG_HDMIRX_VE_U1_BASE + 0x93)
#define REG_HDMIRX_VE_U1_4A_L           (REG_HDMIRX_VE_U1_BASE + 0x94)
#define REG_HDMIRX_VE_U1_4A_H           (REG_HDMIRX_VE_U1_BASE + 0x95)
#define REG_HDMIRX_VE_U1_4B_L           (REG_HDMIRX_VE_U1_BASE + 0x96)
#define REG_HDMIRX_VE_U1_4B_H           (REG_HDMIRX_VE_U1_BASE + 0x97)
#define REG_HDMIRX_VE_U1_4C_L           (REG_HDMIRX_VE_U1_BASE + 0x98)
#define REG_HDMIRX_VE_U1_4C_H           (REG_HDMIRX_VE_U1_BASE + 0x99)
#define REG_HDMIRX_VE_U1_4D_L           (REG_HDMIRX_VE_U1_BASE + 0x9A)
#define REG_HDMIRX_VE_U1_4D_H           (REG_HDMIRX_VE_U1_BASE + 0x9B)
#define REG_HDMIRX_VE_U1_4E_L           (REG_HDMIRX_VE_U1_BASE + 0x9C)
#define REG_HDMIRX_VE_U1_4E_H           (REG_HDMIRX_VE_U1_BASE + 0x9D)
#define REG_HDMIRX_VE_U1_4F_L           (REG_HDMIRX_VE_U1_BASE + 0x9E)
#define REG_HDMIRX_VE_U1_4F_H           (REG_HDMIRX_VE_U1_BASE + 0x9F)
#define REG_HDMIRX_VE_U1_50_L           (REG_HDMIRX_VE_U1_BASE + 0xA0)
#define REG_HDMIRX_VE_U1_50_H           (REG_HDMIRX_VE_U1_BASE + 0xA1)
#define REG_HDMIRX_VE_U1_51_L           (REG_HDMIRX_VE_U1_BASE + 0xA2)
#define REG_HDMIRX_VE_U1_51_H           (REG_HDMIRX_VE_U1_BASE + 0xA3)
#define REG_HDMIRX_VE_U1_52_L           (REG_HDMIRX_VE_U1_BASE + 0xA4)
#define REG_HDMIRX_VE_U1_52_H           (REG_HDMIRX_VE_U1_BASE + 0xA5)
#define REG_HDMIRX_VE_U1_53_L           (REG_HDMIRX_VE_U1_BASE + 0xA6)
#define REG_HDMIRX_VE_U1_53_H           (REG_HDMIRX_VE_U1_BASE + 0xA7)
#define REG_HDMIRX_VE_U1_54_L           (REG_HDMIRX_VE_U1_BASE + 0xA8)
#define REG_HDMIRX_VE_U1_54_H           (REG_HDMIRX_VE_U1_BASE + 0xA9)
#define REG_HDMIRX_VE_U1_55_L           (REG_HDMIRX_VE_U1_BASE + 0xAA)
#define REG_HDMIRX_VE_U1_55_H           (REG_HDMIRX_VE_U1_BASE + 0xAB)
#define REG_HDMIRX_VE_U1_56_L           (REG_HDMIRX_VE_U1_BASE + 0xAC)
#define REG_HDMIRX_VE_U1_56_H           (REG_HDMIRX_VE_U1_BASE + 0xAD)
#define REG_HDMIRX_VE_U1_57_L           (REG_HDMIRX_VE_U1_BASE + 0xAE)
#define REG_HDMIRX_VE_U1_57_H           (REG_HDMIRX_VE_U1_BASE + 0xAF)
#define REG_HDMIRX_VE_U1_58_L           (REG_HDMIRX_VE_U1_BASE + 0xB0)
#define REG_HDMIRX_VE_U1_58_H           (REG_HDMIRX_VE_U1_BASE + 0xB1)
#define REG_HDMIRX_VE_U1_59_L           (REG_HDMIRX_VE_U1_BASE + 0xB2)
#define REG_HDMIRX_VE_U1_59_H           (REG_HDMIRX_VE_U1_BASE + 0xB3)
#define REG_HDMIRX_VE_U1_5A_L           (REG_HDMIRX_VE_U1_BASE + 0xB4)
#define REG_HDMIRX_VE_U1_5A_H           (REG_HDMIRX_VE_U1_BASE + 0xB5)
#define REG_HDMIRX_VE_U1_5B_L           (REG_HDMIRX_VE_U1_BASE + 0xB6)
#define REG_HDMIRX_VE_U1_5B_H           (REG_HDMIRX_VE_U1_BASE + 0xB7)
#define REG_HDMIRX_VE_U1_5C_L           (REG_HDMIRX_VE_U1_BASE + 0xB8)
#define REG_HDMIRX_VE_U1_5C_H           (REG_HDMIRX_VE_U1_BASE + 0xB9)
#define REG_HDMIRX_VE_U1_5D_L           (REG_HDMIRX_VE_U1_BASE + 0xBA)
#define REG_HDMIRX_VE_U1_5D_H           (REG_HDMIRX_VE_U1_BASE + 0xBB)
#define REG_HDMIRX_VE_U1_5E_L           (REG_HDMIRX_VE_U1_BASE + 0xBC)
#define REG_HDMIRX_VE_U1_5E_H           (REG_HDMIRX_VE_U1_BASE + 0xBD)
#define REG_HDMIRX_VE_U1_5F_L           (REG_HDMIRX_VE_U1_BASE + 0xBE)
#define REG_HDMIRX_VE_U1_5F_H           (REG_HDMIRX_VE_U1_BASE + 0xBF)
#define REG_HDMIRX_VE_U1_60_L           (REG_HDMIRX_VE_U1_BASE + 0xC0)
#define REG_HDMIRX_VE_U1_60_H           (REG_HDMIRX_VE_U1_BASE + 0xC1)
#define REG_HDMIRX_VE_U1_61_L           (REG_HDMIRX_VE_U1_BASE + 0xC2)
#define REG_HDMIRX_VE_U1_61_H           (REG_HDMIRX_VE_U1_BASE + 0xC3)
#define REG_HDMIRX_VE_U1_62_L           (REG_HDMIRX_VE_U1_BASE + 0xC4)
#define REG_HDMIRX_VE_U1_62_H           (REG_HDMIRX_VE_U1_BASE + 0xC5)
#define REG_HDMIRX_VE_U1_63_L           (REG_HDMIRX_VE_U1_BASE + 0xC6)
#define REG_HDMIRX_VE_U1_63_H           (REG_HDMIRX_VE_U1_BASE + 0xC7)
#define REG_HDMIRX_VE_U1_64_L           (REG_HDMIRX_VE_U1_BASE + 0xC8)
#define REG_HDMIRX_VE_U1_64_H           (REG_HDMIRX_VE_U1_BASE + 0xC9)
#define REG_HDMIRX_VE_U1_65_L           (REG_HDMIRX_VE_U1_BASE + 0xCA)
#define REG_HDMIRX_VE_U1_65_H           (REG_HDMIRX_VE_U1_BASE + 0xCB)
#define REG_HDMIRX_VE_U1_66_L           (REG_HDMIRX_VE_U1_BASE + 0xCC)
#define REG_HDMIRX_VE_U1_66_H           (REG_HDMIRX_VE_U1_BASE + 0xCD)
#define REG_HDMIRX_VE_U1_67_L           (REG_HDMIRX_VE_U1_BASE + 0xCE)
#define REG_HDMIRX_VE_U1_67_H           (REG_HDMIRX_VE_U1_BASE + 0xCF)
#define REG_HDMIRX_VE_U1_68_L           (REG_HDMIRX_VE_U1_BASE + 0xD0)
#define REG_HDMIRX_VE_U1_68_H           (REG_HDMIRX_VE_U1_BASE + 0xD1)
#define REG_HDMIRX_VE_U1_69_L           (REG_HDMIRX_VE_U1_BASE + 0xD2)
#define REG_HDMIRX_VE_U1_69_H           (REG_HDMIRX_VE_U1_BASE + 0xD3)
#define REG_HDMIRX_VE_U1_6A_L           (REG_HDMIRX_VE_U1_BASE + 0xD4)
#define REG_HDMIRX_VE_U1_6A_H           (REG_HDMIRX_VE_U1_BASE + 0xD5)
#define REG_HDMIRX_VE_U1_6B_L           (REG_HDMIRX_VE_U1_BASE + 0xD6)
#define REG_HDMIRX_VE_U1_6B_H           (REG_HDMIRX_VE_U1_BASE + 0xD7)
#define REG_HDMIRX_VE_U1_6C_L           (REG_HDMIRX_VE_U1_BASE + 0xD8)
#define REG_HDMIRX_VE_U1_6C_H           (REG_HDMIRX_VE_U1_BASE + 0xD9)
#define REG_HDMIRX_VE_U1_6D_L           (REG_HDMIRX_VE_U1_BASE + 0xDA)
#define REG_HDMIRX_VE_U1_6D_H           (REG_HDMIRX_VE_U1_BASE + 0xDB)
#define REG_HDMIRX_VE_U1_6E_L           (REG_HDMIRX_VE_U1_BASE + 0xDC)
#define REG_HDMIRX_VE_U1_6E_H           (REG_HDMIRX_VE_U1_BASE + 0xDD)
#define REG_HDMIRX_VE_U1_6F_L           (REG_HDMIRX_VE_U1_BASE + 0xDE)
#define REG_HDMIRX_VE_U1_6F_H           (REG_HDMIRX_VE_U1_BASE + 0xDF)
#define REG_HDMIRX_VE_U1_70_L           (REG_HDMIRX_VE_U1_BASE + 0xE0)
#define REG_HDMIRX_VE_U1_70_H           (REG_HDMIRX_VE_U1_BASE + 0xE1)
#define REG_HDMIRX_VE_U1_71_L           (REG_HDMIRX_VE_U1_BASE + 0xE2)
#define REG_HDMIRX_VE_U1_71_H           (REG_HDMIRX_VE_U1_BASE + 0xE3)
#define REG_HDMIRX_VE_U1_72_L           (REG_HDMIRX_VE_U1_BASE + 0xE4)
#define REG_HDMIRX_VE_U1_72_H           (REG_HDMIRX_VE_U1_BASE + 0xE5)
#define REG_HDMIRX_VE_U1_73_L           (REG_HDMIRX_VE_U1_BASE + 0xE6)
#define REG_HDMIRX_VE_U1_73_H           (REG_HDMIRX_VE_U1_BASE + 0xE7)
#define REG_HDMIRX_VE_U1_74_L           (REG_HDMIRX_VE_U1_BASE + 0xE8)
#define REG_HDMIRX_VE_U1_74_H           (REG_HDMIRX_VE_U1_BASE + 0xE9)
#define REG_HDMIRX_VE_U1_75_L           (REG_HDMIRX_VE_U1_BASE + 0xEA)
#define REG_HDMIRX_VE_U1_75_H           (REG_HDMIRX_VE_U1_BASE + 0xEB)
#define REG_HDMIRX_VE_U1_76_L           (REG_HDMIRX_VE_U1_BASE + 0xEC)
#define REG_HDMIRX_VE_U1_76_H           (REG_HDMIRX_VE_U1_BASE + 0xED)
#define REG_HDMIRX_VE_U1_77_L           (REG_HDMIRX_VE_U1_BASE + 0xEE)
#define REG_HDMIRX_VE_U1_77_H           (REG_HDMIRX_VE_U1_BASE + 0xEF)
#define REG_HDMIRX_VE_U1_78_L           (REG_HDMIRX_VE_U1_BASE + 0xF0)
#define REG_HDMIRX_VE_U1_78_H           (REG_HDMIRX_VE_U1_BASE + 0xF1)
#define REG_HDMIRX_VE_U1_79_L           (REG_HDMIRX_VE_U1_BASE + 0xF2)
#define REG_HDMIRX_VE_U1_79_H           (REG_HDMIRX_VE_U1_BASE + 0xF3)
#define REG_HDMIRX_VE_U1_7A_L           (REG_HDMIRX_VE_U1_BASE + 0xF4)
#define REG_HDMIRX_VE_U1_7A_H           (REG_HDMIRX_VE_U1_BASE + 0xF5)
#define REG_HDMIRX_VE_U1_7B_L           (REG_HDMIRX_VE_U1_BASE + 0xF6)
#define REG_HDMIRX_VE_U1_7B_H           (REG_HDMIRX_VE_U1_BASE + 0xF7)
#define REG_HDMIRX_VE_U1_7C_L           (REG_HDMIRX_VE_U1_BASE + 0xF8)
#define REG_HDMIRX_VE_U1_7C_H           (REG_HDMIRX_VE_U1_BASE + 0xF9)
#define REG_HDMIRX_VE_U1_7D_L           (REG_HDMIRX_VE_U1_BASE + 0xFA)
#define REG_HDMIRX_VE_U1_7D_H           (REG_HDMIRX_VE_U1_BASE + 0xFB)
#define REG_HDMIRX_VE_U1_7E_L           (REG_HDMIRX_VE_U1_BASE + 0xFC)
#define REG_HDMIRX_VE_U1_7E_H           (REG_HDMIRX_VE_U1_BASE + 0xFD)
#define REG_HDMIRX_VE_U1_7F_L           (REG_HDMIRX_VE_U1_BASE + 0xFE)
#define REG_HDMIRX_VE_U1_7F_H           (REG_HDMIRX_VE_U1_BASE + 0xFF)

//=============================================================
// HDMIRX_VE_U2
#define REG_HDMIRX_VE_U2_00_L           (REG_HDMIRX_VE_U2_BASE + 0x00)
#define REG_HDMIRX_VE_U2_00_H           (REG_HDMIRX_VE_U2_BASE + 0x01)
#define REG_HDMIRX_VE_U2_01_L           (REG_HDMIRX_VE_U2_BASE + 0x02)
#define REG_HDMIRX_VE_U2_01_H           (REG_HDMIRX_VE_U2_BASE + 0x03)
#define REG_HDMIRX_VE_U2_02_L           (REG_HDMIRX_VE_U2_BASE + 0x04)
#define REG_HDMIRX_VE_U2_02_H           (REG_HDMIRX_VE_U2_BASE + 0x05)
#define REG_HDMIRX_VE_U2_03_L           (REG_HDMIRX_VE_U2_BASE + 0x06)
#define REG_HDMIRX_VE_U2_03_H           (REG_HDMIRX_VE_U2_BASE + 0x07)
#define REG_HDMIRX_VE_U2_04_L           (REG_HDMIRX_VE_U2_BASE + 0x08)
#define REG_HDMIRX_VE_U2_04_H           (REG_HDMIRX_VE_U2_BASE + 0x09)
#define REG_HDMIRX_VE_U2_05_L           (REG_HDMIRX_VE_U2_BASE + 0x0A)
#define REG_HDMIRX_VE_U2_05_H           (REG_HDMIRX_VE_U2_BASE + 0x0B)
#define REG_HDMIRX_VE_U2_06_L           (REG_HDMIRX_VE_U2_BASE + 0x0C)
#define REG_HDMIRX_VE_U2_06_H           (REG_HDMIRX_VE_U2_BASE + 0x0D)
#define REG_HDMIRX_VE_U2_07_L           (REG_HDMIRX_VE_U2_BASE + 0x0E)
#define REG_HDMIRX_VE_U2_07_H           (REG_HDMIRX_VE_U2_BASE + 0x0F)
#define REG_HDMIRX_VE_U2_08_L           (REG_HDMIRX_VE_U2_BASE + 0x10)
#define REG_HDMIRX_VE_U2_08_H           (REG_HDMIRX_VE_U2_BASE + 0x11)
#define REG_HDMIRX_VE_U2_09_L           (REG_HDMIRX_VE_U2_BASE + 0x12)
#define REG_HDMIRX_VE_U2_09_H           (REG_HDMIRX_VE_U2_BASE + 0x13)
#define REG_HDMIRX_VE_U2_0A_L           (REG_HDMIRX_VE_U2_BASE + 0x14)
#define REG_HDMIRX_VE_U2_0A_H           (REG_HDMIRX_VE_U2_BASE + 0x15)
#define REG_HDMIRX_VE_U2_0B_L           (REG_HDMIRX_VE_U2_BASE + 0x16)
#define REG_HDMIRX_VE_U2_0B_H           (REG_HDMIRX_VE_U2_BASE + 0x17)
#define REG_HDMIRX_VE_U2_0C_L           (REG_HDMIRX_VE_U2_BASE + 0x18)
#define REG_HDMIRX_VE_U2_0C_H           (REG_HDMIRX_VE_U2_BASE + 0x19)
#define REG_HDMIRX_VE_U2_0D_L           (REG_HDMIRX_VE_U2_BASE + 0x1A)
#define REG_HDMIRX_VE_U2_0D_H           (REG_HDMIRX_VE_U2_BASE + 0x1B)
#define REG_HDMIRX_VE_U2_0E_L           (REG_HDMIRX_VE_U2_BASE + 0x1C)
#define REG_HDMIRX_VE_U2_0E_H           (REG_HDMIRX_VE_U2_BASE + 0x1D)
#define REG_HDMIRX_VE_U2_0F_L           (REG_HDMIRX_VE_U2_BASE + 0x1E)
#define REG_HDMIRX_VE_U2_0F_H           (REG_HDMIRX_VE_U2_BASE + 0x1F)
#define REG_HDMIRX_VE_U2_10_L           (REG_HDMIRX_VE_U2_BASE + 0x20)
#define REG_HDMIRX_VE_U2_10_H           (REG_HDMIRX_VE_U2_BASE + 0x21)
#define REG_HDMIRX_VE_U2_11_L           (REG_HDMIRX_VE_U2_BASE + 0x22)
#define REG_HDMIRX_VE_U2_11_H           (REG_HDMIRX_VE_U2_BASE + 0x23)
#define REG_HDMIRX_VE_U2_12_L           (REG_HDMIRX_VE_U2_BASE + 0x24)
#define REG_HDMIRX_VE_U2_12_H           (REG_HDMIRX_VE_U2_BASE + 0x25)
#define REG_HDMIRX_VE_U2_13_L           (REG_HDMIRX_VE_U2_BASE + 0x26)
#define REG_HDMIRX_VE_U2_13_H           (REG_HDMIRX_VE_U2_BASE + 0x27)
#define REG_HDMIRX_VE_U2_14_L           (REG_HDMIRX_VE_U2_BASE + 0x28)
#define REG_HDMIRX_VE_U2_14_H           (REG_HDMIRX_VE_U2_BASE + 0x29)
#define REG_HDMIRX_VE_U2_15_L           (REG_HDMIRX_VE_U2_BASE + 0x2A)
#define REG_HDMIRX_VE_U2_15_H           (REG_HDMIRX_VE_U2_BASE + 0x2B)
#define REG_HDMIRX_VE_U2_16_L           (REG_HDMIRX_VE_U2_BASE + 0x2C)
#define REG_HDMIRX_VE_U2_16_H           (REG_HDMIRX_VE_U2_BASE + 0x2D)
#define REG_HDMIRX_VE_U2_17_L           (REG_HDMIRX_VE_U2_BASE + 0x2E)
#define REG_HDMIRX_VE_U2_17_H           (REG_HDMIRX_VE_U2_BASE + 0x2F)
#define REG_HDMIRX_VE_U2_18_L           (REG_HDMIRX_VE_U2_BASE + 0x30)
#define REG_HDMIRX_VE_U2_18_H           (REG_HDMIRX_VE_U2_BASE + 0x31)
#define REG_HDMIRX_VE_U2_19_L           (REG_HDMIRX_VE_U2_BASE + 0x32)
#define REG_HDMIRX_VE_U2_19_H           (REG_HDMIRX_VE_U2_BASE + 0x33)
#define REG_HDMIRX_VE_U2_1A_L           (REG_HDMIRX_VE_U2_BASE + 0x34)
#define REG_HDMIRX_VE_U2_1A_H           (REG_HDMIRX_VE_U2_BASE + 0x35)
#define REG_HDMIRX_VE_U2_1B_L           (REG_HDMIRX_VE_U2_BASE + 0x36)
#define REG_HDMIRX_VE_U2_1B_H           (REG_HDMIRX_VE_U2_BASE + 0x37)
#define REG_HDMIRX_VE_U2_1C_L           (REG_HDMIRX_VE_U2_BASE + 0x38)
#define REG_HDMIRX_VE_U2_1C_H           (REG_HDMIRX_VE_U2_BASE + 0x39)
#define REG_HDMIRX_VE_U2_1D_L           (REG_HDMIRX_VE_U2_BASE + 0x3A)
#define REG_HDMIRX_VE_U2_1D_H           (REG_HDMIRX_VE_U2_BASE + 0x3B)
#define REG_HDMIRX_VE_U2_1E_L           (REG_HDMIRX_VE_U2_BASE + 0x3C)
#define REG_HDMIRX_VE_U2_1E_H           (REG_HDMIRX_VE_U2_BASE + 0x3D)
#define REG_HDMIRX_VE_U2_1F_L           (REG_HDMIRX_VE_U2_BASE + 0x3E)
#define REG_HDMIRX_VE_U2_1F_H           (REG_HDMIRX_VE_U2_BASE + 0x3F)
#define REG_HDMIRX_VE_U2_20_L           (REG_HDMIRX_VE_U2_BASE + 0x40)
#define REG_HDMIRX_VE_U2_20_H           (REG_HDMIRX_VE_U2_BASE + 0x41)
#define REG_HDMIRX_VE_U2_21_L           (REG_HDMIRX_VE_U2_BASE + 0x42)
#define REG_HDMIRX_VE_U2_21_H           (REG_HDMIRX_VE_U2_BASE + 0x43)
#define REG_HDMIRX_VE_U2_22_L           (REG_HDMIRX_VE_U2_BASE + 0x44)
#define REG_HDMIRX_VE_U2_22_H           (REG_HDMIRX_VE_U2_BASE + 0x45)
#define REG_HDMIRX_VE_U2_23_L           (REG_HDMIRX_VE_U2_BASE + 0x46)
#define REG_HDMIRX_VE_U2_23_H           (REG_HDMIRX_VE_U2_BASE + 0x47)
#define REG_HDMIRX_VE_U2_24_L           (REG_HDMIRX_VE_U2_BASE + 0x48)
#define REG_HDMIRX_VE_U2_24_H           (REG_HDMIRX_VE_U2_BASE + 0x49)
#define REG_HDMIRX_VE_U2_25_L           (REG_HDMIRX_VE_U2_BASE + 0x4A)
#define REG_HDMIRX_VE_U2_25_H           (REG_HDMIRX_VE_U2_BASE + 0x4B)
#define REG_HDMIRX_VE_U2_26_L           (REG_HDMIRX_VE_U2_BASE + 0x4C)
#define REG_HDMIRX_VE_U2_26_H           (REG_HDMIRX_VE_U2_BASE + 0x4D)
#define REG_HDMIRX_VE_U2_27_L           (REG_HDMIRX_VE_U2_BASE + 0x4E)
#define REG_HDMIRX_VE_U2_27_H           (REG_HDMIRX_VE_U2_BASE + 0x4F)
#define REG_HDMIRX_VE_U2_28_L           (REG_HDMIRX_VE_U2_BASE + 0x50)
#define REG_HDMIRX_VE_U2_28_H           (REG_HDMIRX_VE_U2_BASE + 0x51)
#define REG_HDMIRX_VE_U2_29_L           (REG_HDMIRX_VE_U2_BASE + 0x52)
#define REG_HDMIRX_VE_U2_29_H           (REG_HDMIRX_VE_U2_BASE + 0x53)
#define REG_HDMIRX_VE_U2_2A_L           (REG_HDMIRX_VE_U2_BASE + 0x54)
#define REG_HDMIRX_VE_U2_2A_H           (REG_HDMIRX_VE_U2_BASE + 0x55)
#define REG_HDMIRX_VE_U2_2B_L           (REG_HDMIRX_VE_U2_BASE + 0x56)
#define REG_HDMIRX_VE_U2_2B_H           (REG_HDMIRX_VE_U2_BASE + 0x57)
#define REG_HDMIRX_VE_U2_2C_L           (REG_HDMIRX_VE_U2_BASE + 0x58)
#define REG_HDMIRX_VE_U2_2C_H           (REG_HDMIRX_VE_U2_BASE + 0x59)
#define REG_HDMIRX_VE_U2_2D_L           (REG_HDMIRX_VE_U2_BASE + 0x5A)
#define REG_HDMIRX_VE_U2_2D_H           (REG_HDMIRX_VE_U2_BASE + 0x5B)
#define REG_HDMIRX_VE_U2_2E_L           (REG_HDMIRX_VE_U2_BASE + 0x5C)
#define REG_HDMIRX_VE_U2_2E_H           (REG_HDMIRX_VE_U2_BASE + 0x5D)
#define REG_HDMIRX_VE_U2_2F_L           (REG_HDMIRX_VE_U2_BASE + 0x5E)
#define REG_HDMIRX_VE_U2_2F_H           (REG_HDMIRX_VE_U2_BASE + 0x5F)
#define REG_HDMIRX_VE_U2_30_L           (REG_HDMIRX_VE_U2_BASE + 0x60)
#define REG_HDMIRX_VE_U2_30_H           (REG_HDMIRX_VE_U2_BASE + 0x61)
#define REG_HDMIRX_VE_U2_31_L           (REG_HDMIRX_VE_U2_BASE + 0x62)
#define REG_HDMIRX_VE_U2_31_H           (REG_HDMIRX_VE_U2_BASE + 0x63)
#define REG_HDMIRX_VE_U2_32_L           (REG_HDMIRX_VE_U2_BASE + 0x64)
#define REG_HDMIRX_VE_U2_32_H           (REG_HDMIRX_VE_U2_BASE + 0x65)
#define REG_HDMIRX_VE_U2_33_L           (REG_HDMIRX_VE_U2_BASE + 0x66)
#define REG_HDMIRX_VE_U2_33_H           (REG_HDMIRX_VE_U2_BASE + 0x67)
#define REG_HDMIRX_VE_U2_34_L           (REG_HDMIRX_VE_U2_BASE + 0x68)
#define REG_HDMIRX_VE_U2_34_H           (REG_HDMIRX_VE_U2_BASE + 0x69)
#define REG_HDMIRX_VE_U2_35_L           (REG_HDMIRX_VE_U2_BASE + 0x6A)
#define REG_HDMIRX_VE_U2_35_H           (REG_HDMIRX_VE_U2_BASE + 0x6B)
#define REG_HDMIRX_VE_U2_36_L           (REG_HDMIRX_VE_U2_BASE + 0x6C)
#define REG_HDMIRX_VE_U2_36_H           (REG_HDMIRX_VE_U2_BASE + 0x6D)
#define REG_HDMIRX_VE_U2_37_L           (REG_HDMIRX_VE_U2_BASE + 0x6E)
#define REG_HDMIRX_VE_U2_37_H           (REG_HDMIRX_VE_U2_BASE + 0x6F)
#define REG_HDMIRX_VE_U2_38_L           (REG_HDMIRX_VE_U2_BASE + 0x70)
#define REG_HDMIRX_VE_U2_38_H           (REG_HDMIRX_VE_U2_BASE + 0x71)
#define REG_HDMIRX_VE_U2_39_L           (REG_HDMIRX_VE_U2_BASE + 0x72)
#define REG_HDMIRX_VE_U2_39_H           (REG_HDMIRX_VE_U2_BASE + 0x73)
#define REG_HDMIRX_VE_U2_3A_L           (REG_HDMIRX_VE_U2_BASE + 0x74)
#define REG_HDMIRX_VE_U2_3A_H           (REG_HDMIRX_VE_U2_BASE + 0x75)
#define REG_HDMIRX_VE_U2_3B_L           (REG_HDMIRX_VE_U2_BASE + 0x76)
#define REG_HDMIRX_VE_U2_3B_H           (REG_HDMIRX_VE_U2_BASE + 0x77)
#define REG_HDMIRX_VE_U2_3C_L           (REG_HDMIRX_VE_U2_BASE + 0x78)
#define REG_HDMIRX_VE_U2_3C_H           (REG_HDMIRX_VE_U2_BASE + 0x79)
#define REG_HDMIRX_VE_U2_3D_L           (REG_HDMIRX_VE_U2_BASE + 0x7A)
#define REG_HDMIRX_VE_U2_3D_H           (REG_HDMIRX_VE_U2_BASE + 0x7B)
#define REG_HDMIRX_VE_U2_3E_L           (REG_HDMIRX_VE_U2_BASE + 0x7C)
#define REG_HDMIRX_VE_U2_3E_H           (REG_HDMIRX_VE_U2_BASE + 0x7D)
#define REG_HDMIRX_VE_U2_3F_L           (REG_HDMIRX_VE_U2_BASE + 0x7E)
#define REG_HDMIRX_VE_U2_3F_H           (REG_HDMIRX_VE_U2_BASE + 0x7F)
#define REG_HDMIRX_VE_U2_40_L           (REG_HDMIRX_VE_U2_BASE + 0x80)
#define REG_HDMIRX_VE_U2_40_H           (REG_HDMIRX_VE_U2_BASE + 0x81)
#define REG_HDMIRX_VE_U2_41_L           (REG_HDMIRX_VE_U2_BASE + 0x82)
#define REG_HDMIRX_VE_U2_41_H           (REG_HDMIRX_VE_U2_BASE + 0x83)
#define REG_HDMIRX_VE_U2_42_L           (REG_HDMIRX_VE_U2_BASE + 0x84)
#define REG_HDMIRX_VE_U2_42_H           (REG_HDMIRX_VE_U2_BASE + 0x85)
#define REG_HDMIRX_VE_U2_43_L           (REG_HDMIRX_VE_U2_BASE + 0x86)
#define REG_HDMIRX_VE_U2_43_H           (REG_HDMIRX_VE_U2_BASE + 0x87)
#define REG_HDMIRX_VE_U2_44_L           (REG_HDMIRX_VE_U2_BASE + 0x88)
#define REG_HDMIRX_VE_U2_44_H           (REG_HDMIRX_VE_U2_BASE + 0x89)
#define REG_HDMIRX_VE_U2_45_L           (REG_HDMIRX_VE_U2_BASE + 0x8A)
#define REG_HDMIRX_VE_U2_45_H           (REG_HDMIRX_VE_U2_BASE + 0x8B)
#define REG_HDMIRX_VE_U2_46_L           (REG_HDMIRX_VE_U2_BASE + 0x8C)
#define REG_HDMIRX_VE_U2_46_H           (REG_HDMIRX_VE_U2_BASE + 0x8D)
#define REG_HDMIRX_VE_U2_47_L           (REG_HDMIRX_VE_U2_BASE + 0x8E)
#define REG_HDMIRX_VE_U2_47_H           (REG_HDMIRX_VE_U2_BASE + 0x8F)
#define REG_HDMIRX_VE_U2_48_L           (REG_HDMIRX_VE_U2_BASE + 0x90)
#define REG_HDMIRX_VE_U2_48_H           (REG_HDMIRX_VE_U2_BASE + 0x91)
#define REG_HDMIRX_VE_U2_49_L           (REG_HDMIRX_VE_U2_BASE + 0x92)
#define REG_HDMIRX_VE_U2_49_H           (REG_HDMIRX_VE_U2_BASE + 0x93)
#define REG_HDMIRX_VE_U2_4A_L           (REG_HDMIRX_VE_U2_BASE + 0x94)
#define REG_HDMIRX_VE_U2_4A_H           (REG_HDMIRX_VE_U2_BASE + 0x95)
#define REG_HDMIRX_VE_U2_4B_L           (REG_HDMIRX_VE_U2_BASE + 0x96)
#define REG_HDMIRX_VE_U2_4B_H           (REG_HDMIRX_VE_U2_BASE + 0x97)
#define REG_HDMIRX_VE_U2_4C_L           (REG_HDMIRX_VE_U2_BASE + 0x98)
#define REG_HDMIRX_VE_U2_4C_H           (REG_HDMIRX_VE_U2_BASE + 0x99)
#define REG_HDMIRX_VE_U2_4D_L           (REG_HDMIRX_VE_U2_BASE + 0x9A)
#define REG_HDMIRX_VE_U2_4D_H           (REG_HDMIRX_VE_U2_BASE + 0x9B)
#define REG_HDMIRX_VE_U2_4E_L           (REG_HDMIRX_VE_U2_BASE + 0x9C)
#define REG_HDMIRX_VE_U2_4E_H           (REG_HDMIRX_VE_U2_BASE + 0x9D)
#define REG_HDMIRX_VE_U2_4F_L           (REG_HDMIRX_VE_U2_BASE + 0x9E)
#define REG_HDMIRX_VE_U2_4F_H           (REG_HDMIRX_VE_U2_BASE + 0x9F)
#define REG_HDMIRX_VE_U2_50_L           (REG_HDMIRX_VE_U2_BASE + 0xA0)
#define REG_HDMIRX_VE_U2_50_H           (REG_HDMIRX_VE_U2_BASE + 0xA1)
#define REG_HDMIRX_VE_U2_51_L           (REG_HDMIRX_VE_U2_BASE + 0xA2)
#define REG_HDMIRX_VE_U2_51_H           (REG_HDMIRX_VE_U2_BASE + 0xA3)
#define REG_HDMIRX_VE_U2_52_L           (REG_HDMIRX_VE_U2_BASE + 0xA4)
#define REG_HDMIRX_VE_U2_52_H           (REG_HDMIRX_VE_U2_BASE + 0xA5)
#define REG_HDMIRX_VE_U2_53_L           (REG_HDMIRX_VE_U2_BASE + 0xA6)
#define REG_HDMIRX_VE_U2_53_H           (REG_HDMIRX_VE_U2_BASE + 0xA7)
#define REG_HDMIRX_VE_U2_54_L           (REG_HDMIRX_VE_U2_BASE + 0xA8)
#define REG_HDMIRX_VE_U2_54_H           (REG_HDMIRX_VE_U2_BASE + 0xA9)
#define REG_HDMIRX_VE_U2_55_L           (REG_HDMIRX_VE_U2_BASE + 0xAA)
#define REG_HDMIRX_VE_U2_55_H           (REG_HDMIRX_VE_U2_BASE + 0xAB)
#define REG_HDMIRX_VE_U2_56_L           (REG_HDMIRX_VE_U2_BASE + 0xAC)
#define REG_HDMIRX_VE_U2_56_H           (REG_HDMIRX_VE_U2_BASE + 0xAD)
#define REG_HDMIRX_VE_U2_57_L           (REG_HDMIRX_VE_U2_BASE + 0xAE)
#define REG_HDMIRX_VE_U2_57_H           (REG_HDMIRX_VE_U2_BASE + 0xAF)
#define REG_HDMIRX_VE_U2_58_L           (REG_HDMIRX_VE_U2_BASE + 0xB0)
#define REG_HDMIRX_VE_U2_58_H           (REG_HDMIRX_VE_U2_BASE + 0xB1)
#define REG_HDMIRX_VE_U2_59_L           (REG_HDMIRX_VE_U2_BASE + 0xB2)
#define REG_HDMIRX_VE_U2_59_H           (REG_HDMIRX_VE_U2_BASE + 0xB3)
#define REG_HDMIRX_VE_U2_5A_L           (REG_HDMIRX_VE_U2_BASE + 0xB4)
#define REG_HDMIRX_VE_U2_5A_H           (REG_HDMIRX_VE_U2_BASE + 0xB5)
#define REG_HDMIRX_VE_U2_5B_L           (REG_HDMIRX_VE_U2_BASE + 0xB6)
#define REG_HDMIRX_VE_U2_5B_H           (REG_HDMIRX_VE_U2_BASE + 0xB7)
#define REG_HDMIRX_VE_U2_5C_L           (REG_HDMIRX_VE_U2_BASE + 0xB8)
#define REG_HDMIRX_VE_U2_5C_H           (REG_HDMIRX_VE_U2_BASE + 0xB9)
#define REG_HDMIRX_VE_U2_5D_L           (REG_HDMIRX_VE_U2_BASE + 0xBA)
#define REG_HDMIRX_VE_U2_5D_H           (REG_HDMIRX_VE_U2_BASE + 0xBB)
#define REG_HDMIRX_VE_U2_5E_L           (REG_HDMIRX_VE_U2_BASE + 0xBC)
#define REG_HDMIRX_VE_U2_5E_H           (REG_HDMIRX_VE_U2_BASE + 0xBD)
#define REG_HDMIRX_VE_U2_5F_L           (REG_HDMIRX_VE_U2_BASE + 0xBE)
#define REG_HDMIRX_VE_U2_5F_H           (REG_HDMIRX_VE_U2_BASE + 0xBF)
#define REG_HDMIRX_VE_U2_60_L           (REG_HDMIRX_VE_U2_BASE + 0xC0)
#define REG_HDMIRX_VE_U2_60_H           (REG_HDMIRX_VE_U2_BASE + 0xC1)
#define REG_HDMIRX_VE_U2_61_L           (REG_HDMIRX_VE_U2_BASE + 0xC2)
#define REG_HDMIRX_VE_U2_61_H           (REG_HDMIRX_VE_U2_BASE + 0xC3)
#define REG_HDMIRX_VE_U2_62_L           (REG_HDMIRX_VE_U2_BASE + 0xC4)
#define REG_HDMIRX_VE_U2_62_H           (REG_HDMIRX_VE_U2_BASE + 0xC5)
#define REG_HDMIRX_VE_U2_63_L           (REG_HDMIRX_VE_U2_BASE + 0xC6)
#define REG_HDMIRX_VE_U2_63_H           (REG_HDMIRX_VE_U2_BASE + 0xC7)
#define REG_HDMIRX_VE_U2_64_L           (REG_HDMIRX_VE_U2_BASE + 0xC8)
#define REG_HDMIRX_VE_U2_64_H           (REG_HDMIRX_VE_U2_BASE + 0xC9)
#define REG_HDMIRX_VE_U2_65_L           (REG_HDMIRX_VE_U2_BASE + 0xCA)
#define REG_HDMIRX_VE_U2_65_H           (REG_HDMIRX_VE_U2_BASE + 0xCB)
#define REG_HDMIRX_VE_U2_66_L           (REG_HDMIRX_VE_U2_BASE + 0xCC)
#define REG_HDMIRX_VE_U2_66_H           (REG_HDMIRX_VE_U2_BASE + 0xCD)
#define REG_HDMIRX_VE_U2_67_L           (REG_HDMIRX_VE_U2_BASE + 0xCE)
#define REG_HDMIRX_VE_U2_67_H           (REG_HDMIRX_VE_U2_BASE + 0xCF)
#define REG_HDMIRX_VE_U2_68_L           (REG_HDMIRX_VE_U2_BASE + 0xD0)
#define REG_HDMIRX_VE_U2_68_H           (REG_HDMIRX_VE_U2_BASE + 0xD1)
#define REG_HDMIRX_VE_U2_69_L           (REG_HDMIRX_VE_U2_BASE + 0xD2)
#define REG_HDMIRX_VE_U2_69_H           (REG_HDMIRX_VE_U2_BASE + 0xD3)
#define REG_HDMIRX_VE_U2_6A_L           (REG_HDMIRX_VE_U2_BASE + 0xD4)
#define REG_HDMIRX_VE_U2_6A_H           (REG_HDMIRX_VE_U2_BASE + 0xD5)
#define REG_HDMIRX_VE_U2_6B_L           (REG_HDMIRX_VE_U2_BASE + 0xD6)
#define REG_HDMIRX_VE_U2_6B_H           (REG_HDMIRX_VE_U2_BASE + 0xD7)
#define REG_HDMIRX_VE_U2_6C_L           (REG_HDMIRX_VE_U2_BASE + 0xD8)
#define REG_HDMIRX_VE_U2_6C_H           (REG_HDMIRX_VE_U2_BASE + 0xD9)
#define REG_HDMIRX_VE_U2_6D_L           (REG_HDMIRX_VE_U2_BASE + 0xDA)
#define REG_HDMIRX_VE_U2_6D_H           (REG_HDMIRX_VE_U2_BASE + 0xDB)
#define REG_HDMIRX_VE_U2_6E_L           (REG_HDMIRX_VE_U2_BASE + 0xDC)
#define REG_HDMIRX_VE_U2_6E_H           (REG_HDMIRX_VE_U2_BASE + 0xDD)
#define REG_HDMIRX_VE_U2_6F_L           (REG_HDMIRX_VE_U2_BASE + 0xDE)
#define REG_HDMIRX_VE_U2_6F_H           (REG_HDMIRX_VE_U2_BASE + 0xDF)
#define REG_HDMIRX_VE_U2_70_L           (REG_HDMIRX_VE_U2_BASE + 0xE0)
#define REG_HDMIRX_VE_U2_70_H           (REG_HDMIRX_VE_U2_BASE + 0xE1)
#define REG_HDMIRX_VE_U2_71_L           (REG_HDMIRX_VE_U2_BASE + 0xE2)
#define REG_HDMIRX_VE_U2_71_H           (REG_HDMIRX_VE_U2_BASE + 0xE3)
#define REG_HDMIRX_VE_U2_72_L           (REG_HDMIRX_VE_U2_BASE + 0xE4)
#define REG_HDMIRX_VE_U2_72_H           (REG_HDMIRX_VE_U2_BASE + 0xE5)
#define REG_HDMIRX_VE_U2_73_L           (REG_HDMIRX_VE_U2_BASE + 0xE6)
#define REG_HDMIRX_VE_U2_73_H           (REG_HDMIRX_VE_U2_BASE + 0xE7)
#define REG_HDMIRX_VE_U2_74_L           (REG_HDMIRX_VE_U2_BASE + 0xE8)
#define REG_HDMIRX_VE_U2_74_H           (REG_HDMIRX_VE_U2_BASE + 0xE9)
#define REG_HDMIRX_VE_U2_75_L           (REG_HDMIRX_VE_U2_BASE + 0xEA)
#define REG_HDMIRX_VE_U2_75_H           (REG_HDMIRX_VE_U2_BASE + 0xEB)
#define REG_HDMIRX_VE_U2_76_L           (REG_HDMIRX_VE_U2_BASE + 0xEC)
#define REG_HDMIRX_VE_U2_76_H           (REG_HDMIRX_VE_U2_BASE + 0xED)
#define REG_HDMIRX_VE_U2_77_L           (REG_HDMIRX_VE_U2_BASE + 0xEE)
#define REG_HDMIRX_VE_U2_77_H           (REG_HDMIRX_VE_U2_BASE + 0xEF)
#define REG_HDMIRX_VE_U2_78_L           (REG_HDMIRX_VE_U2_BASE + 0xF0)
#define REG_HDMIRX_VE_U2_78_H           (REG_HDMIRX_VE_U2_BASE + 0xF1)
#define REG_HDMIRX_VE_U2_79_L           (REG_HDMIRX_VE_U2_BASE + 0xF2)
#define REG_HDMIRX_VE_U2_79_H           (REG_HDMIRX_VE_U2_BASE + 0xF3)
#define REG_HDMIRX_VE_U2_7A_L           (REG_HDMIRX_VE_U2_BASE + 0xF4)
#define REG_HDMIRX_VE_U2_7A_H           (REG_HDMIRX_VE_U2_BASE + 0xF5)
#define REG_HDMIRX_VE_U2_7B_L           (REG_HDMIRX_VE_U2_BASE + 0xF6)
#define REG_HDMIRX_VE_U2_7B_H           (REG_HDMIRX_VE_U2_BASE + 0xF7)
#define REG_HDMIRX_VE_U2_7C_L           (REG_HDMIRX_VE_U2_BASE + 0xF8)
#define REG_HDMIRX_VE_U2_7C_H           (REG_HDMIRX_VE_U2_BASE + 0xF9)
#define REG_HDMIRX_VE_U2_7D_L           (REG_HDMIRX_VE_U2_BASE + 0xFA)
#define REG_HDMIRX_VE_U2_7D_H           (REG_HDMIRX_VE_U2_BASE + 0xFB)
#define REG_HDMIRX_VE_U2_7E_L           (REG_HDMIRX_VE_U2_BASE + 0xFC)
#define REG_HDMIRX_VE_U2_7E_H           (REG_HDMIRX_VE_U2_BASE + 0xFD)
#define REG_HDMIRX_VE_U2_7F_L           (REG_HDMIRX_VE_U2_BASE + 0xFE)
#define REG_HDMIRX_VE_U2_7F_H           (REG_HDMIRX_VE_U2_BASE + 0xFF)

//=============================================================
// HDMIRX_VE_U3
#define REG_HDMIRX_VE_U3_00_L           (REG_HDMIRX_VE_U3_BASE + 0x00)
#define REG_HDMIRX_VE_U3_00_H           (REG_HDMIRX_VE_U3_BASE + 0x01)
#define REG_HDMIRX_VE_U3_01_L           (REG_HDMIRX_VE_U3_BASE + 0x02)
#define REG_HDMIRX_VE_U3_01_H           (REG_HDMIRX_VE_U3_BASE + 0x03)
#define REG_HDMIRX_VE_U3_02_L           (REG_HDMIRX_VE_U3_BASE + 0x04)
#define REG_HDMIRX_VE_U3_02_H           (REG_HDMIRX_VE_U3_BASE + 0x05)
#define REG_HDMIRX_VE_U3_03_L           (REG_HDMIRX_VE_U3_BASE + 0x06)
#define REG_HDMIRX_VE_U3_03_H           (REG_HDMIRX_VE_U3_BASE + 0x07)
#define REG_HDMIRX_VE_U3_04_L           (REG_HDMIRX_VE_U3_BASE + 0x08)
#define REG_HDMIRX_VE_U3_04_H           (REG_HDMIRX_VE_U3_BASE + 0x09)
#define REG_HDMIRX_VE_U3_05_L           (REG_HDMIRX_VE_U3_BASE + 0x0A)
#define REG_HDMIRX_VE_U3_05_H           (REG_HDMIRX_VE_U3_BASE + 0x0B)
#define REG_HDMIRX_VE_U3_06_L           (REG_HDMIRX_VE_U3_BASE + 0x0C)
#define REG_HDMIRX_VE_U3_06_H           (REG_HDMIRX_VE_U3_BASE + 0x0D)
#define REG_HDMIRX_VE_U3_07_L           (REG_HDMIRX_VE_U3_BASE + 0x0E)
#define REG_HDMIRX_VE_U3_07_H           (REG_HDMIRX_VE_U3_BASE + 0x0F)
#define REG_HDMIRX_VE_U3_08_L           (REG_HDMIRX_VE_U3_BASE + 0x10)
#define REG_HDMIRX_VE_U3_08_H           (REG_HDMIRX_VE_U3_BASE + 0x11)
#define REG_HDMIRX_VE_U3_09_L           (REG_HDMIRX_VE_U3_BASE + 0x12)
#define REG_HDMIRX_VE_U3_09_H           (REG_HDMIRX_VE_U3_BASE + 0x13)
#define REG_HDMIRX_VE_U3_0A_L           (REG_HDMIRX_VE_U3_BASE + 0x14)
#define REG_HDMIRX_VE_U3_0A_H           (REG_HDMIRX_VE_U3_BASE + 0x15)
#define REG_HDMIRX_VE_U3_0B_L           (REG_HDMIRX_VE_U3_BASE + 0x16)
#define REG_HDMIRX_VE_U3_0B_H           (REG_HDMIRX_VE_U3_BASE + 0x17)
#define REG_HDMIRX_VE_U3_0C_L           (REG_HDMIRX_VE_U3_BASE + 0x18)
#define REG_HDMIRX_VE_U3_0C_H           (REG_HDMIRX_VE_U3_BASE + 0x19)
#define REG_HDMIRX_VE_U3_0D_L           (REG_HDMIRX_VE_U3_BASE + 0x1A)
#define REG_HDMIRX_VE_U3_0D_H           (REG_HDMIRX_VE_U3_BASE + 0x1B)
#define REG_HDMIRX_VE_U3_0E_L           (REG_HDMIRX_VE_U3_BASE + 0x1C)
#define REG_HDMIRX_VE_U3_0E_H           (REG_HDMIRX_VE_U3_BASE + 0x1D)
#define REG_HDMIRX_VE_U3_0F_L           (REG_HDMIRX_VE_U3_BASE + 0x1E)
#define REG_HDMIRX_VE_U3_0F_H           (REG_HDMIRX_VE_U3_BASE + 0x1F)
#define REG_HDMIRX_VE_U3_10_L           (REG_HDMIRX_VE_U3_BASE + 0x20)
#define REG_HDMIRX_VE_U3_10_H           (REG_HDMIRX_VE_U3_BASE + 0x21)
#define REG_HDMIRX_VE_U3_11_L           (REG_HDMIRX_VE_U3_BASE + 0x22)
#define REG_HDMIRX_VE_U3_11_H           (REG_HDMIRX_VE_U3_BASE + 0x23)
#define REG_HDMIRX_VE_U3_12_L           (REG_HDMIRX_VE_U3_BASE + 0x24)
#define REG_HDMIRX_VE_U3_12_H           (REG_HDMIRX_VE_U3_BASE + 0x25)
#define REG_HDMIRX_VE_U3_13_L           (REG_HDMIRX_VE_U3_BASE + 0x26)
#define REG_HDMIRX_VE_U3_13_H           (REG_HDMIRX_VE_U3_BASE + 0x27)
#define REG_HDMIRX_VE_U3_14_L           (REG_HDMIRX_VE_U3_BASE + 0x28)
#define REG_HDMIRX_VE_U3_14_H           (REG_HDMIRX_VE_U3_BASE + 0x29)
#define REG_HDMIRX_VE_U3_15_L           (REG_HDMIRX_VE_U3_BASE + 0x2A)
#define REG_HDMIRX_VE_U3_15_H           (REG_HDMIRX_VE_U3_BASE + 0x2B)
#define REG_HDMIRX_VE_U3_16_L           (REG_HDMIRX_VE_U3_BASE + 0x2C)
#define REG_HDMIRX_VE_U3_16_H           (REG_HDMIRX_VE_U3_BASE + 0x2D)
#define REG_HDMIRX_VE_U3_17_L           (REG_HDMIRX_VE_U3_BASE + 0x2E)
#define REG_HDMIRX_VE_U3_17_H           (REG_HDMIRX_VE_U3_BASE + 0x2F)
#define REG_HDMIRX_VE_U3_18_L           (REG_HDMIRX_VE_U3_BASE + 0x30)
#define REG_HDMIRX_VE_U3_18_H           (REG_HDMIRX_VE_U3_BASE + 0x31)
#define REG_HDMIRX_VE_U3_19_L           (REG_HDMIRX_VE_U3_BASE + 0x32)
#define REG_HDMIRX_VE_U3_19_H           (REG_HDMIRX_VE_U3_BASE + 0x33)
#define REG_HDMIRX_VE_U3_1A_L           (REG_HDMIRX_VE_U3_BASE + 0x34)
#define REG_HDMIRX_VE_U3_1A_H           (REG_HDMIRX_VE_U3_BASE + 0x35)
#define REG_HDMIRX_VE_U3_1B_L           (REG_HDMIRX_VE_U3_BASE + 0x36)
#define REG_HDMIRX_VE_U3_1B_H           (REG_HDMIRX_VE_U3_BASE + 0x37)
#define REG_HDMIRX_VE_U3_1C_L           (REG_HDMIRX_VE_U3_BASE + 0x38)
#define REG_HDMIRX_VE_U3_1C_H           (REG_HDMIRX_VE_U3_BASE + 0x39)
#define REG_HDMIRX_VE_U3_1D_L           (REG_HDMIRX_VE_U3_BASE + 0x3A)
#define REG_HDMIRX_VE_U3_1D_H           (REG_HDMIRX_VE_U3_BASE + 0x3B)
#define REG_HDMIRX_VE_U3_1E_L           (REG_HDMIRX_VE_U3_BASE + 0x3C)
#define REG_HDMIRX_VE_U3_1E_H           (REG_HDMIRX_VE_U3_BASE + 0x3D)
#define REG_HDMIRX_VE_U3_1F_L           (REG_HDMIRX_VE_U3_BASE + 0x3E)
#define REG_HDMIRX_VE_U3_1F_H           (REG_HDMIRX_VE_U3_BASE + 0x3F)
#define REG_HDMIRX_VE_U3_20_L           (REG_HDMIRX_VE_U3_BASE + 0x40)
#define REG_HDMIRX_VE_U3_20_H           (REG_HDMIRX_VE_U3_BASE + 0x41)
#define REG_HDMIRX_VE_U3_21_L           (REG_HDMIRX_VE_U3_BASE + 0x42)
#define REG_HDMIRX_VE_U3_21_H           (REG_HDMIRX_VE_U3_BASE + 0x43)
#define REG_HDMIRX_VE_U3_22_L           (REG_HDMIRX_VE_U3_BASE + 0x44)
#define REG_HDMIRX_VE_U3_22_H           (REG_HDMIRX_VE_U3_BASE + 0x45)
#define REG_HDMIRX_VE_U3_23_L           (REG_HDMIRX_VE_U3_BASE + 0x46)
#define REG_HDMIRX_VE_U3_23_H           (REG_HDMIRX_VE_U3_BASE + 0x47)
#define REG_HDMIRX_VE_U3_24_L           (REG_HDMIRX_VE_U3_BASE + 0x48)
#define REG_HDMIRX_VE_U3_24_H           (REG_HDMIRX_VE_U3_BASE + 0x49)
#define REG_HDMIRX_VE_U3_25_L           (REG_HDMIRX_VE_U3_BASE + 0x4A)
#define REG_HDMIRX_VE_U3_25_H           (REG_HDMIRX_VE_U3_BASE + 0x4B)
#define REG_HDMIRX_VE_U3_26_L           (REG_HDMIRX_VE_U3_BASE + 0x4C)
#define REG_HDMIRX_VE_U3_26_H           (REG_HDMIRX_VE_U3_BASE + 0x4D)
#define REG_HDMIRX_VE_U3_27_L           (REG_HDMIRX_VE_U3_BASE + 0x4E)
#define REG_HDMIRX_VE_U3_27_H           (REG_HDMIRX_VE_U3_BASE + 0x4F)
#define REG_HDMIRX_VE_U3_28_L           (REG_HDMIRX_VE_U3_BASE + 0x50)
#define REG_HDMIRX_VE_U3_28_H           (REG_HDMIRX_VE_U3_BASE + 0x51)
#define REG_HDMIRX_VE_U3_29_L           (REG_HDMIRX_VE_U3_BASE + 0x52)
#define REG_HDMIRX_VE_U3_29_H           (REG_HDMIRX_VE_U3_BASE + 0x53)
#define REG_HDMIRX_VE_U3_2A_L           (REG_HDMIRX_VE_U3_BASE + 0x54)
#define REG_HDMIRX_VE_U3_2A_H           (REG_HDMIRX_VE_U3_BASE + 0x55)
#define REG_HDMIRX_VE_U3_2B_L           (REG_HDMIRX_VE_U3_BASE + 0x56)
#define REG_HDMIRX_VE_U3_2B_H           (REG_HDMIRX_VE_U3_BASE + 0x57)
#define REG_HDMIRX_VE_U3_2C_L           (REG_HDMIRX_VE_U3_BASE + 0x58)
#define REG_HDMIRX_VE_U3_2C_H           (REG_HDMIRX_VE_U3_BASE + 0x59)
#define REG_HDMIRX_VE_U3_2D_L           (REG_HDMIRX_VE_U3_BASE + 0x5A)
#define REG_HDMIRX_VE_U3_2D_H           (REG_HDMIRX_VE_U3_BASE + 0x5B)
#define REG_HDMIRX_VE_U3_2E_L           (REG_HDMIRX_VE_U3_BASE + 0x5C)
#define REG_HDMIRX_VE_U3_2E_H           (REG_HDMIRX_VE_U3_BASE + 0x5D)
#define REG_HDMIRX_VE_U3_2F_L           (REG_HDMIRX_VE_U3_BASE + 0x5E)
#define REG_HDMIRX_VE_U3_2F_H           (REG_HDMIRX_VE_U3_BASE + 0x5F)
#define REG_HDMIRX_VE_U3_30_L           (REG_HDMIRX_VE_U3_BASE + 0x60)
#define REG_HDMIRX_VE_U3_30_H           (REG_HDMIRX_VE_U3_BASE + 0x61)
#define REG_HDMIRX_VE_U3_31_L           (REG_HDMIRX_VE_U3_BASE + 0x62)
#define REG_HDMIRX_VE_U3_31_H           (REG_HDMIRX_VE_U3_BASE + 0x63)
#define REG_HDMIRX_VE_U3_32_L           (REG_HDMIRX_VE_U3_BASE + 0x64)
#define REG_HDMIRX_VE_U3_32_H           (REG_HDMIRX_VE_U3_BASE + 0x65)
#define REG_HDMIRX_VE_U3_33_L           (REG_HDMIRX_VE_U3_BASE + 0x66)
#define REG_HDMIRX_VE_U3_33_H           (REG_HDMIRX_VE_U3_BASE + 0x67)
#define REG_HDMIRX_VE_U3_34_L           (REG_HDMIRX_VE_U3_BASE + 0x68)
#define REG_HDMIRX_VE_U3_34_H           (REG_HDMIRX_VE_U3_BASE + 0x69)
#define REG_HDMIRX_VE_U3_35_L           (REG_HDMIRX_VE_U3_BASE + 0x6A)
#define REG_HDMIRX_VE_U3_35_H           (REG_HDMIRX_VE_U3_BASE + 0x6B)
#define REG_HDMIRX_VE_U3_36_L           (REG_HDMIRX_VE_U3_BASE + 0x6C)
#define REG_HDMIRX_VE_U3_36_H           (REG_HDMIRX_VE_U3_BASE + 0x6D)
#define REG_HDMIRX_VE_U3_37_L           (REG_HDMIRX_VE_U3_BASE + 0x6E)
#define REG_HDMIRX_VE_U3_37_H           (REG_HDMIRX_VE_U3_BASE + 0x6F)
#define REG_HDMIRX_VE_U3_38_L           (REG_HDMIRX_VE_U3_BASE + 0x70)
#define REG_HDMIRX_VE_U3_38_H           (REG_HDMIRX_VE_U3_BASE + 0x71)
#define REG_HDMIRX_VE_U3_39_L           (REG_HDMIRX_VE_U3_BASE + 0x72)
#define REG_HDMIRX_VE_U3_39_H           (REG_HDMIRX_VE_U3_BASE + 0x73)
#define REG_HDMIRX_VE_U3_3A_L           (REG_HDMIRX_VE_U3_BASE + 0x74)
#define REG_HDMIRX_VE_U3_3A_H           (REG_HDMIRX_VE_U3_BASE + 0x75)
#define REG_HDMIRX_VE_U3_3B_L           (REG_HDMIRX_VE_U3_BASE + 0x76)
#define REG_HDMIRX_VE_U3_3B_H           (REG_HDMIRX_VE_U3_BASE + 0x77)
#define REG_HDMIRX_VE_U3_3C_L           (REG_HDMIRX_VE_U3_BASE + 0x78)
#define REG_HDMIRX_VE_U3_3C_H           (REG_HDMIRX_VE_U3_BASE + 0x79)
#define REG_HDMIRX_VE_U3_3D_L           (REG_HDMIRX_VE_U3_BASE + 0x7A)
#define REG_HDMIRX_VE_U3_3D_H           (REG_HDMIRX_VE_U3_BASE + 0x7B)
#define REG_HDMIRX_VE_U3_3E_L           (REG_HDMIRX_VE_U3_BASE + 0x7C)
#define REG_HDMIRX_VE_U3_3E_H           (REG_HDMIRX_VE_U3_BASE + 0x7D)
#define REG_HDMIRX_VE_U3_3F_L           (REG_HDMIRX_VE_U3_BASE + 0x7E)
#define REG_HDMIRX_VE_U3_3F_H           (REG_HDMIRX_VE_U3_BASE + 0x7F)
#define REG_HDMIRX_VE_U3_40_L           (REG_HDMIRX_VE_U3_BASE + 0x80)
#define REG_HDMIRX_VE_U3_40_H           (REG_HDMIRX_VE_U3_BASE + 0x81)
#define REG_HDMIRX_VE_U3_41_L           (REG_HDMIRX_VE_U3_BASE + 0x82)
#define REG_HDMIRX_VE_U3_41_H           (REG_HDMIRX_VE_U3_BASE + 0x83)
#define REG_HDMIRX_VE_U3_42_L           (REG_HDMIRX_VE_U3_BASE + 0x84)
#define REG_HDMIRX_VE_U3_42_H           (REG_HDMIRX_VE_U3_BASE + 0x85)
#define REG_HDMIRX_VE_U3_43_L           (REG_HDMIRX_VE_U3_BASE + 0x86)
#define REG_HDMIRX_VE_U3_43_H           (REG_HDMIRX_VE_U3_BASE + 0x87)
#define REG_HDMIRX_VE_U3_44_L           (REG_HDMIRX_VE_U3_BASE + 0x88)
#define REG_HDMIRX_VE_U3_44_H           (REG_HDMIRX_VE_U3_BASE + 0x89)
#define REG_HDMIRX_VE_U3_45_L           (REG_HDMIRX_VE_U3_BASE + 0x8A)
#define REG_HDMIRX_VE_U3_45_H           (REG_HDMIRX_VE_U3_BASE + 0x8B)
#define REG_HDMIRX_VE_U3_46_L           (REG_HDMIRX_VE_U3_BASE + 0x8C)
#define REG_HDMIRX_VE_U3_46_H           (REG_HDMIRX_VE_U3_BASE + 0x8D)
#define REG_HDMIRX_VE_U3_47_L           (REG_HDMIRX_VE_U3_BASE + 0x8E)
#define REG_HDMIRX_VE_U3_47_H           (REG_HDMIRX_VE_U3_BASE + 0x8F)
#define REG_HDMIRX_VE_U3_48_L           (REG_HDMIRX_VE_U3_BASE + 0x90)
#define REG_HDMIRX_VE_U3_48_H           (REG_HDMIRX_VE_U3_BASE + 0x91)
#define REG_HDMIRX_VE_U3_49_L           (REG_HDMIRX_VE_U3_BASE + 0x92)
#define REG_HDMIRX_VE_U3_49_H           (REG_HDMIRX_VE_U3_BASE + 0x93)
#define REG_HDMIRX_VE_U3_4A_L           (REG_HDMIRX_VE_U3_BASE + 0x94)
#define REG_HDMIRX_VE_U3_4A_H           (REG_HDMIRX_VE_U3_BASE + 0x95)
#define REG_HDMIRX_VE_U3_4B_L           (REG_HDMIRX_VE_U3_BASE + 0x96)
#define REG_HDMIRX_VE_U3_4B_H           (REG_HDMIRX_VE_U3_BASE + 0x97)
#define REG_HDMIRX_VE_U3_4C_L           (REG_HDMIRX_VE_U3_BASE + 0x98)
#define REG_HDMIRX_VE_U3_4C_H           (REG_HDMIRX_VE_U3_BASE + 0x99)
#define REG_HDMIRX_VE_U3_4D_L           (REG_HDMIRX_VE_U3_BASE + 0x9A)
#define REG_HDMIRX_VE_U3_4D_H           (REG_HDMIRX_VE_U3_BASE + 0x9B)
#define REG_HDMIRX_VE_U3_4E_L           (REG_HDMIRX_VE_U3_BASE + 0x9C)
#define REG_HDMIRX_VE_U3_4E_H           (REG_HDMIRX_VE_U3_BASE + 0x9D)
#define REG_HDMIRX_VE_U3_4F_L           (REG_HDMIRX_VE_U3_BASE + 0x9E)
#define REG_HDMIRX_VE_U3_4F_H           (REG_HDMIRX_VE_U3_BASE + 0x9F)
#define REG_HDMIRX_VE_U3_50_L           (REG_HDMIRX_VE_U3_BASE + 0xA0)
#define REG_HDMIRX_VE_U3_50_H           (REG_HDMIRX_VE_U3_BASE + 0xA1)
#define REG_HDMIRX_VE_U3_51_L           (REG_HDMIRX_VE_U3_BASE + 0xA2)
#define REG_HDMIRX_VE_U3_51_H           (REG_HDMIRX_VE_U3_BASE + 0xA3)
#define REG_HDMIRX_VE_U3_52_L           (REG_HDMIRX_VE_U3_BASE + 0xA4)
#define REG_HDMIRX_VE_U3_52_H           (REG_HDMIRX_VE_U3_BASE + 0xA5)
#define REG_HDMIRX_VE_U3_53_L           (REG_HDMIRX_VE_U3_BASE + 0xA6)
#define REG_HDMIRX_VE_U3_53_H           (REG_HDMIRX_VE_U3_BASE + 0xA7)
#define REG_HDMIRX_VE_U3_54_L           (REG_HDMIRX_VE_U3_BASE + 0xA8)
#define REG_HDMIRX_VE_U3_54_H           (REG_HDMIRX_VE_U3_BASE + 0xA9)
#define REG_HDMIRX_VE_U3_55_L           (REG_HDMIRX_VE_U3_BASE + 0xAA)
#define REG_HDMIRX_VE_U3_55_H           (REG_HDMIRX_VE_U3_BASE + 0xAB)
#define REG_HDMIRX_VE_U3_56_L           (REG_HDMIRX_VE_U3_BASE + 0xAC)
#define REG_HDMIRX_VE_U3_56_H           (REG_HDMIRX_VE_U3_BASE + 0xAD)
#define REG_HDMIRX_VE_U3_57_L           (REG_HDMIRX_VE_U3_BASE + 0xAE)
#define REG_HDMIRX_VE_U3_57_H           (REG_HDMIRX_VE_U3_BASE + 0xAF)
#define REG_HDMIRX_VE_U3_58_L           (REG_HDMIRX_VE_U3_BASE + 0xB0)
#define REG_HDMIRX_VE_U3_58_H           (REG_HDMIRX_VE_U3_BASE + 0xB1)
#define REG_HDMIRX_VE_U3_59_L           (REG_HDMIRX_VE_U3_BASE + 0xB2)
#define REG_HDMIRX_VE_U3_59_H           (REG_HDMIRX_VE_U3_BASE + 0xB3)
#define REG_HDMIRX_VE_U3_5A_L           (REG_HDMIRX_VE_U3_BASE + 0xB4)
#define REG_HDMIRX_VE_U3_5A_H           (REG_HDMIRX_VE_U3_BASE + 0xB5)
#define REG_HDMIRX_VE_U3_5B_L           (REG_HDMIRX_VE_U3_BASE + 0xB6)
#define REG_HDMIRX_VE_U3_5B_H           (REG_HDMIRX_VE_U3_BASE + 0xB7)
#define REG_HDMIRX_VE_U3_5C_L           (REG_HDMIRX_VE_U3_BASE + 0xB8)
#define REG_HDMIRX_VE_U3_5C_H           (REG_HDMIRX_VE_U3_BASE + 0xB9)
#define REG_HDMIRX_VE_U3_5D_L           (REG_HDMIRX_VE_U3_BASE + 0xBA)
#define REG_HDMIRX_VE_U3_5D_H           (REG_HDMIRX_VE_U3_BASE + 0xBB)
#define REG_HDMIRX_VE_U3_5E_L           (REG_HDMIRX_VE_U3_BASE + 0xBC)
#define REG_HDMIRX_VE_U3_5E_H           (REG_HDMIRX_VE_U3_BASE + 0xBD)
#define REG_HDMIRX_VE_U3_5F_L           (REG_HDMIRX_VE_U3_BASE + 0xBE)
#define REG_HDMIRX_VE_U3_5F_H           (REG_HDMIRX_VE_U3_BASE + 0xBF)
#define REG_HDMIRX_VE_U3_60_L           (REG_HDMIRX_VE_U3_BASE + 0xC0)
#define REG_HDMIRX_VE_U3_60_H           (REG_HDMIRX_VE_U3_BASE + 0xC1)
#define REG_HDMIRX_VE_U3_61_L           (REG_HDMIRX_VE_U3_BASE + 0xC2)
#define REG_HDMIRX_VE_U3_61_H           (REG_HDMIRX_VE_U3_BASE + 0xC3)
#define REG_HDMIRX_VE_U3_62_L           (REG_HDMIRX_VE_U3_BASE + 0xC4)
#define REG_HDMIRX_VE_U3_62_H           (REG_HDMIRX_VE_U3_BASE + 0xC5)
#define REG_HDMIRX_VE_U3_63_L           (REG_HDMIRX_VE_U3_BASE + 0xC6)
#define REG_HDMIRX_VE_U3_63_H           (REG_HDMIRX_VE_U3_BASE + 0xC7)
#define REG_HDMIRX_VE_U3_64_L           (REG_HDMIRX_VE_U3_BASE + 0xC8)
#define REG_HDMIRX_VE_U3_64_H           (REG_HDMIRX_VE_U3_BASE + 0xC9)
#define REG_HDMIRX_VE_U3_65_L           (REG_HDMIRX_VE_U3_BASE + 0xCA)
#define REG_HDMIRX_VE_U3_65_H           (REG_HDMIRX_VE_U3_BASE + 0xCB)
#define REG_HDMIRX_VE_U3_66_L           (REG_HDMIRX_VE_U3_BASE + 0xCC)
#define REG_HDMIRX_VE_U3_66_H           (REG_HDMIRX_VE_U3_BASE + 0xCD)
#define REG_HDMIRX_VE_U3_67_L           (REG_HDMIRX_VE_U3_BASE + 0xCE)
#define REG_HDMIRX_VE_U3_67_H           (REG_HDMIRX_VE_U3_BASE + 0xCF)
#define REG_HDMIRX_VE_U3_68_L           (REG_HDMIRX_VE_U3_BASE + 0xD0)
#define REG_HDMIRX_VE_U3_68_H           (REG_HDMIRX_VE_U3_BASE + 0xD1)
#define REG_HDMIRX_VE_U3_69_L           (REG_HDMIRX_VE_U3_BASE + 0xD2)
#define REG_HDMIRX_VE_U3_69_H           (REG_HDMIRX_VE_U3_BASE + 0xD3)
#define REG_HDMIRX_VE_U3_6A_L           (REG_HDMIRX_VE_U3_BASE + 0xD4)
#define REG_HDMIRX_VE_U3_6A_H           (REG_HDMIRX_VE_U3_BASE + 0xD5)
#define REG_HDMIRX_VE_U3_6B_L           (REG_HDMIRX_VE_U3_BASE + 0xD6)
#define REG_HDMIRX_VE_U3_6B_H           (REG_HDMIRX_VE_U3_BASE + 0xD7)
#define REG_HDMIRX_VE_U3_6C_L           (REG_HDMIRX_VE_U3_BASE + 0xD8)
#define REG_HDMIRX_VE_U3_6C_H           (REG_HDMIRX_VE_U3_BASE + 0xD9)
#define REG_HDMIRX_VE_U3_6D_L           (REG_HDMIRX_VE_U3_BASE + 0xDA)
#define REG_HDMIRX_VE_U3_6D_H           (REG_HDMIRX_VE_U3_BASE + 0xDB)
#define REG_HDMIRX_VE_U3_6E_L           (REG_HDMIRX_VE_U3_BASE + 0xDC)
#define REG_HDMIRX_VE_U3_6E_H           (REG_HDMIRX_VE_U3_BASE + 0xDD)
#define REG_HDMIRX_VE_U3_6F_L           (REG_HDMIRX_VE_U3_BASE + 0xDE)
#define REG_HDMIRX_VE_U3_6F_H           (REG_HDMIRX_VE_U3_BASE + 0xDF)
#define REG_HDMIRX_VE_U3_70_L           (REG_HDMIRX_VE_U3_BASE + 0xE0)
#define REG_HDMIRX_VE_U3_70_H           (REG_HDMIRX_VE_U3_BASE + 0xE1)
#define REG_HDMIRX_VE_U3_71_L           (REG_HDMIRX_VE_U3_BASE + 0xE2)
#define REG_HDMIRX_VE_U3_71_H           (REG_HDMIRX_VE_U3_BASE + 0xE3)
#define REG_HDMIRX_VE_U3_72_L           (REG_HDMIRX_VE_U3_BASE + 0xE4)
#define REG_HDMIRX_VE_U3_72_H           (REG_HDMIRX_VE_U3_BASE + 0xE5)
#define REG_HDMIRX_VE_U3_73_L           (REG_HDMIRX_VE_U3_BASE + 0xE6)
#define REG_HDMIRX_VE_U3_73_H           (REG_HDMIRX_VE_U3_BASE + 0xE7)
#define REG_HDMIRX_VE_U3_74_L           (REG_HDMIRX_VE_U3_BASE + 0xE8)
#define REG_HDMIRX_VE_U3_74_H           (REG_HDMIRX_VE_U3_BASE + 0xE9)
#define REG_HDMIRX_VE_U3_75_L           (REG_HDMIRX_VE_U3_BASE + 0xEA)
#define REG_HDMIRX_VE_U3_75_H           (REG_HDMIRX_VE_U3_BASE + 0xEB)
#define REG_HDMIRX_VE_U3_76_L           (REG_HDMIRX_VE_U3_BASE + 0xEC)
#define REG_HDMIRX_VE_U3_76_H           (REG_HDMIRX_VE_U3_BASE + 0xED)
#define REG_HDMIRX_VE_U3_77_L           (REG_HDMIRX_VE_U3_BASE + 0xEE)
#define REG_HDMIRX_VE_U3_77_H           (REG_HDMIRX_VE_U3_BASE + 0xEF)
#define REG_HDMIRX_VE_U3_78_L           (REG_HDMIRX_VE_U3_BASE + 0xF0)
#define REG_HDMIRX_VE_U3_78_H           (REG_HDMIRX_VE_U3_BASE + 0xF1)
#define REG_HDMIRX_VE_U3_79_L           (REG_HDMIRX_VE_U3_BASE + 0xF2)
#define REG_HDMIRX_VE_U3_79_H           (REG_HDMIRX_VE_U3_BASE + 0xF3)
#define REG_HDMIRX_VE_U3_7A_L           (REG_HDMIRX_VE_U3_BASE + 0xF4)
#define REG_HDMIRX_VE_U3_7A_H           (REG_HDMIRX_VE_U3_BASE + 0xF5)
#define REG_HDMIRX_VE_U3_7B_L           (REG_HDMIRX_VE_U3_BASE + 0xF6)
#define REG_HDMIRX_VE_U3_7B_H           (REG_HDMIRX_VE_U3_BASE + 0xF7)
#define REG_HDMIRX_VE_U3_7C_L           (REG_HDMIRX_VE_U3_BASE + 0xF8)
#define REG_HDMIRX_VE_U3_7C_H           (REG_HDMIRX_VE_U3_BASE + 0xF9)
#define REG_HDMIRX_VE_U3_7D_L           (REG_HDMIRX_VE_U3_BASE + 0xFA)
#define REG_HDMIRX_VE_U3_7D_H           (REG_HDMIRX_VE_U3_BASE + 0xFB)
#define REG_HDMIRX_VE_U3_7E_L           (REG_HDMIRX_VE_U3_BASE + 0xFC)
#define REG_HDMIRX_VE_U3_7E_H           (REG_HDMIRX_VE_U3_BASE + 0xFD)
#define REG_HDMIRX_VE_U3_7F_L           (REG_HDMIRX_VE_U3_BASE + 0xFE)
#define REG_HDMIRX_VE_U3_7F_H           (REG_HDMIRX_VE_U3_BASE + 0xFF)


//=============================================================
// HDMI_DUAL_0
#define REG_HDMI_DUAL_0_00_L            (REG_HDMI_DUAL_0_BASE + 0x00)
#define REG_HDMI_DUAL_0_00_H            (REG_HDMI_DUAL_0_BASE + 0x01)
#define REG_HDMI_DUAL_0_01_L            (REG_HDMI_DUAL_0_BASE + 0x02)
#define REG_HDMI_DUAL_0_01_H            (REG_HDMI_DUAL_0_BASE + 0x03)
#define REG_HDMI_DUAL_0_02_L            (REG_HDMI_DUAL_0_BASE + 0x04)
#define REG_HDMI_DUAL_0_02_H            (REG_HDMI_DUAL_0_BASE + 0x05)
#define REG_HDMI_DUAL_0_03_L            (REG_HDMI_DUAL_0_BASE + 0x06)
#define REG_HDMI_DUAL_0_03_H            (REG_HDMI_DUAL_0_BASE + 0x07)
#define REG_HDMI_DUAL_0_04_L            (REG_HDMI_DUAL_0_BASE + 0x08)
#define REG_HDMI_DUAL_0_04_H            (REG_HDMI_DUAL_0_BASE + 0x09)
#define REG_HDMI_DUAL_0_05_L            (REG_HDMI_DUAL_0_BASE + 0x0A)
#define REG_HDMI_DUAL_0_05_H            (REG_HDMI_DUAL_0_BASE + 0x0B)
#define REG_HDMI_DUAL_0_06_L            (REG_HDMI_DUAL_0_BASE + 0x0C)
#define REG_HDMI_DUAL_0_06_H            (REG_HDMI_DUAL_0_BASE + 0x0D)
#define REG_HDMI_DUAL_0_07_L            (REG_HDMI_DUAL_0_BASE + 0x0E)
#define REG_HDMI_DUAL_0_07_H            (REG_HDMI_DUAL_0_BASE + 0x0F)
#define REG_HDMI_DUAL_0_08_L            (REG_HDMI_DUAL_0_BASE + 0x10)
#define REG_HDMI_DUAL_0_08_H            (REG_HDMI_DUAL_0_BASE + 0x11)
#define REG_HDMI_DUAL_0_09_L            (REG_HDMI_DUAL_0_BASE + 0x12)
#define REG_HDMI_DUAL_0_09_H            (REG_HDMI_DUAL_0_BASE + 0x13)
#define REG_HDMI_DUAL_0_0A_L            (REG_HDMI_DUAL_0_BASE + 0x14)
#define REG_HDMI_DUAL_0_0A_H            (REG_HDMI_DUAL_0_BASE + 0x15)
#define REG_HDMI_DUAL_0_0B_L            (REG_HDMI_DUAL_0_BASE + 0x16)
#define REG_HDMI_DUAL_0_0B_H            (REG_HDMI_DUAL_0_BASE + 0x17)
#define REG_HDMI_DUAL_0_0C_L            (REG_HDMI_DUAL_0_BASE + 0x18)
#define REG_HDMI_DUAL_0_0C_H            (REG_HDMI_DUAL_0_BASE + 0x19)
#define REG_HDMI_DUAL_0_0D_L            (REG_HDMI_DUAL_0_BASE + 0x1A)
#define REG_HDMI_DUAL_0_0D_H            (REG_HDMI_DUAL_0_BASE + 0x1B)
#define REG_HDMI_DUAL_0_0E_L            (REG_HDMI_DUAL_0_BASE + 0x1C)
#define REG_HDMI_DUAL_0_0E_H            (REG_HDMI_DUAL_0_BASE + 0x1D)
#define REG_HDMI_DUAL_0_0F_L            (REG_HDMI_DUAL_0_BASE + 0x1E)
#define REG_HDMI_DUAL_0_0F_H            (REG_HDMI_DUAL_0_BASE + 0x1F)
#define REG_HDMI_DUAL_0_10_L            (REG_HDMI_DUAL_0_BASE + 0x20)
#define REG_HDMI_DUAL_0_10_H            (REG_HDMI_DUAL_0_BASE + 0x21)
#define REG_HDMI_DUAL_0_11_L            (REG_HDMI_DUAL_0_BASE + 0x22)
#define REG_HDMI_DUAL_0_11_H            (REG_HDMI_DUAL_0_BASE + 0x23)
#define REG_HDMI_DUAL_0_12_L            (REG_HDMI_DUAL_0_BASE + 0x24)
#define REG_HDMI_DUAL_0_12_H            (REG_HDMI_DUAL_0_BASE + 0x25)
#define REG_HDMI_DUAL_0_13_L            (REG_HDMI_DUAL_0_BASE + 0x26)
#define REG_HDMI_DUAL_0_13_H            (REG_HDMI_DUAL_0_BASE + 0x27)
#define REG_HDMI_DUAL_0_14_L            (REG_HDMI_DUAL_0_BASE + 0x28)
#define REG_HDMI_DUAL_0_14_H            (REG_HDMI_DUAL_0_BASE + 0x29)
#define REG_HDMI_DUAL_0_15_L            (REG_HDMI_DUAL_0_BASE + 0x2A)
#define REG_HDMI_DUAL_0_15_H            (REG_HDMI_DUAL_0_BASE + 0x2B)
#define REG_HDMI_DUAL_0_16_L            (REG_HDMI_DUAL_0_BASE + 0x2C)
#define REG_HDMI_DUAL_0_16_H            (REG_HDMI_DUAL_0_BASE + 0x2D)
#define REG_HDMI_DUAL_0_17_L            (REG_HDMI_DUAL_0_BASE + 0x2E)
#define REG_HDMI_DUAL_0_17_H            (REG_HDMI_DUAL_0_BASE + 0x2F)
#define REG_HDMI_DUAL_0_18_L            (REG_HDMI_DUAL_0_BASE + 0x30)
#define REG_HDMI_DUAL_0_18_H            (REG_HDMI_DUAL_0_BASE + 0x31)
#define REG_HDMI_DUAL_0_19_L            (REG_HDMI_DUAL_0_BASE + 0x32)
#define REG_HDMI_DUAL_0_19_H            (REG_HDMI_DUAL_0_BASE + 0x33)
#define REG_HDMI_DUAL_0_1A_L            (REG_HDMI_DUAL_0_BASE + 0x34)
#define REG_HDMI_DUAL_0_1A_H            (REG_HDMI_DUAL_0_BASE + 0x35)
#define REG_HDMI_DUAL_0_1B_L            (REG_HDMI_DUAL_0_BASE + 0x36)
#define REG_HDMI_DUAL_0_1B_H            (REG_HDMI_DUAL_0_BASE + 0x37)
#define REG_HDMI_DUAL_0_1C_L            (REG_HDMI_DUAL_0_BASE + 0x38)
#define REG_HDMI_DUAL_0_1C_H            (REG_HDMI_DUAL_0_BASE + 0x39)
#define REG_HDMI_DUAL_0_1D_L            (REG_HDMI_DUAL_0_BASE + 0x3A)
#define REG_HDMI_DUAL_0_1D_H            (REG_HDMI_DUAL_0_BASE + 0x3B)
#define REG_HDMI_DUAL_0_1E_L            (REG_HDMI_DUAL_0_BASE + 0x3C)
#define REG_HDMI_DUAL_0_1E_H            (REG_HDMI_DUAL_0_BASE + 0x3D)
#define REG_HDMI_DUAL_0_1F_L            (REG_HDMI_DUAL_0_BASE + 0x3E)
#define REG_HDMI_DUAL_0_1F_H            (REG_HDMI_DUAL_0_BASE + 0x3F)
#define REG_HDMI_DUAL_0_20_L            (REG_HDMI_DUAL_0_BASE + 0x40)
#define REG_HDMI_DUAL_0_20_H            (REG_HDMI_DUAL_0_BASE + 0x41)
#define REG_HDMI_DUAL_0_21_L            (REG_HDMI_DUAL_0_BASE + 0x42)
#define REG_HDMI_DUAL_0_21_H            (REG_HDMI_DUAL_0_BASE + 0x43)
#define REG_HDMI_DUAL_0_22_L            (REG_HDMI_DUAL_0_BASE + 0x44)
#define REG_HDMI_DUAL_0_22_H            (REG_HDMI_DUAL_0_BASE + 0x45)
#define REG_HDMI_DUAL_0_23_L            (REG_HDMI_DUAL_0_BASE + 0x46)
#define REG_HDMI_DUAL_0_23_H            (REG_HDMI_DUAL_0_BASE + 0x47)
#define REG_HDMI_DUAL_0_24_L            (REG_HDMI_DUAL_0_BASE + 0x48)
#define REG_HDMI_DUAL_0_24_H            (REG_HDMI_DUAL_0_BASE + 0x49)
#define REG_HDMI_DUAL_0_25_L            (REG_HDMI_DUAL_0_BASE + 0x4A)
#define REG_HDMI_DUAL_0_25_H            (REG_HDMI_DUAL_0_BASE + 0x4B)
#define REG_HDMI_DUAL_0_26_L            (REG_HDMI_DUAL_0_BASE + 0x4C)
#define REG_HDMI_DUAL_0_26_H            (REG_HDMI_DUAL_0_BASE + 0x4D)
#define REG_HDMI_DUAL_0_27_L            (REG_HDMI_DUAL_0_BASE + 0x4E)
#define REG_HDMI_DUAL_0_27_H            (REG_HDMI_DUAL_0_BASE + 0x4F)
#define REG_HDMI_DUAL_0_28_L            (REG_HDMI_DUAL_0_BASE + 0x50)
#define REG_HDMI_DUAL_0_28_H            (REG_HDMI_DUAL_0_BASE + 0x51)
#define REG_HDMI_DUAL_0_29_L            (REG_HDMI_DUAL_0_BASE + 0x52)
#define REG_HDMI_DUAL_0_29_H            (REG_HDMI_DUAL_0_BASE + 0x53)
#define REG_HDMI_DUAL_0_2A_L            (REG_HDMI_DUAL_0_BASE + 0x54)
#define REG_HDMI_DUAL_0_2A_H            (REG_HDMI_DUAL_0_BASE + 0x55)
#define REG_HDMI_DUAL_0_2B_L            (REG_HDMI_DUAL_0_BASE + 0x56)
#define REG_HDMI_DUAL_0_2B_H            (REG_HDMI_DUAL_0_BASE + 0x57)
#define REG_HDMI_DUAL_0_2C_L            (REG_HDMI_DUAL_0_BASE + 0x58)
#define REG_HDMI_DUAL_0_2C_H            (REG_HDMI_DUAL_0_BASE + 0x59)
#define REG_HDMI_DUAL_0_2D_L            (REG_HDMI_DUAL_0_BASE + 0x5A)
#define REG_HDMI_DUAL_0_2D_H            (REG_HDMI_DUAL_0_BASE + 0x5B)
#define REG_HDMI_DUAL_0_2E_L            (REG_HDMI_DUAL_0_BASE + 0x5C)
#define REG_HDMI_DUAL_0_2E_H            (REG_HDMI_DUAL_0_BASE + 0x5D)
#define REG_HDMI_DUAL_0_2F_L            (REG_HDMI_DUAL_0_BASE + 0x5E)
#define REG_HDMI_DUAL_0_2F_H            (REG_HDMI_DUAL_0_BASE + 0x5F)
#define REG_HDMI_DUAL_0_30_L            (REG_HDMI_DUAL_0_BASE + 0x60)
#define REG_HDMI_DUAL_0_30_H            (REG_HDMI_DUAL_0_BASE + 0x61)
#define REG_HDMI_DUAL_0_31_L            (REG_HDMI_DUAL_0_BASE + 0x62)
#define REG_HDMI_DUAL_0_31_H            (REG_HDMI_DUAL_0_BASE + 0x63)
#define REG_HDMI_DUAL_0_32_L            (REG_HDMI_DUAL_0_BASE + 0x64)
#define REG_HDMI_DUAL_0_32_H            (REG_HDMI_DUAL_0_BASE + 0x65)
#define REG_HDMI_DUAL_0_33_L            (REG_HDMI_DUAL_0_BASE + 0x66)
#define REG_HDMI_DUAL_0_33_H            (REG_HDMI_DUAL_0_BASE + 0x67)
#define REG_HDMI_DUAL_0_34_L            (REG_HDMI_DUAL_0_BASE + 0x68)
#define REG_HDMI_DUAL_0_34_H            (REG_HDMI_DUAL_0_BASE + 0x69)
#define REG_HDMI_DUAL_0_35_L            (REG_HDMI_DUAL_0_BASE + 0x6A)
#define REG_HDMI_DUAL_0_35_H            (REG_HDMI_DUAL_0_BASE + 0x6B)
#define REG_HDMI_DUAL_0_36_L            (REG_HDMI_DUAL_0_BASE + 0x6C)
#define REG_HDMI_DUAL_0_36_H            (REG_HDMI_DUAL_0_BASE + 0x6D)
#define REG_HDMI_DUAL_0_37_L            (REG_HDMI_DUAL_0_BASE + 0x6E)
#define REG_HDMI_DUAL_0_37_H            (REG_HDMI_DUAL_0_BASE + 0x6F)
#define REG_HDMI_DUAL_0_38_L            (REG_HDMI_DUAL_0_BASE + 0x70)
#define REG_HDMI_DUAL_0_38_H            (REG_HDMI_DUAL_0_BASE + 0x71)
#define REG_HDMI_DUAL_0_39_L            (REG_HDMI_DUAL_0_BASE + 0x72)
#define REG_HDMI_DUAL_0_39_H            (REG_HDMI_DUAL_0_BASE + 0x73)
#define REG_HDMI_DUAL_0_3A_L            (REG_HDMI_DUAL_0_BASE + 0x74)
#define REG_HDMI_DUAL_0_3A_H            (REG_HDMI_DUAL_0_BASE + 0x75)
#define REG_HDMI_DUAL_0_3B_L            (REG_HDMI_DUAL_0_BASE + 0x76)
#define REG_HDMI_DUAL_0_3B_H            (REG_HDMI_DUAL_0_BASE + 0x77)
#define REG_HDMI_DUAL_0_3C_L            (REG_HDMI_DUAL_0_BASE + 0x78)
#define REG_HDMI_DUAL_0_3C_H            (REG_HDMI_DUAL_0_BASE + 0x79)
#define REG_HDMI_DUAL_0_3D_L            (REG_HDMI_DUAL_0_BASE + 0x7A)
#define REG_HDMI_DUAL_0_3D_H            (REG_HDMI_DUAL_0_BASE + 0x7B)
#define REG_HDMI_DUAL_0_3E_L            (REG_HDMI_DUAL_0_BASE + 0x7C)
#define REG_HDMI_DUAL_0_3E_H            (REG_HDMI_DUAL_0_BASE + 0x7D)
#define REG_HDMI_DUAL_0_3F_L            (REG_HDMI_DUAL_0_BASE + 0x7E)
#define REG_HDMI_DUAL_0_3F_H            (REG_HDMI_DUAL_0_BASE + 0x7F)
#define REG_HDMI_DUAL_0_40_L            (REG_HDMI_DUAL_0_BASE + 0x80)
#define REG_HDMI_DUAL_0_40_H            (REG_HDMI_DUAL_0_BASE + 0x81)
#define REG_HDMI_DUAL_0_41_L            (REG_HDMI_DUAL_0_BASE + 0x82)
#define REG_HDMI_DUAL_0_41_H            (REG_HDMI_DUAL_0_BASE + 0x83)
#define REG_HDMI_DUAL_0_42_L            (REG_HDMI_DUAL_0_BASE + 0x84)
#define REG_HDMI_DUAL_0_42_H            (REG_HDMI_DUAL_0_BASE + 0x85)
#define REG_HDMI_DUAL_0_43_L            (REG_HDMI_DUAL_0_BASE + 0x86)
#define REG_HDMI_DUAL_0_43_H            (REG_HDMI_DUAL_0_BASE + 0x87)
#define REG_HDMI_DUAL_0_44_L            (REG_HDMI_DUAL_0_BASE + 0x88)
#define REG_HDMI_DUAL_0_44_H            (REG_HDMI_DUAL_0_BASE + 0x89)
#define REG_HDMI_DUAL_0_45_L            (REG_HDMI_DUAL_0_BASE + 0x8A)
#define REG_HDMI_DUAL_0_45_H            (REG_HDMI_DUAL_0_BASE + 0x8B)
#define REG_HDMI_DUAL_0_46_L            (REG_HDMI_DUAL_0_BASE + 0x8C)
#define REG_HDMI_DUAL_0_46_H            (REG_HDMI_DUAL_0_BASE + 0x8D)
#define REG_HDMI_DUAL_0_47_L            (REG_HDMI_DUAL_0_BASE + 0x8E)
#define REG_HDMI_DUAL_0_47_H            (REG_HDMI_DUAL_0_BASE + 0x8F)
#define REG_HDMI_DUAL_0_48_L            (REG_HDMI_DUAL_0_BASE + 0x90)
#define REG_HDMI_DUAL_0_48_H            (REG_HDMI_DUAL_0_BASE + 0x91)
#define REG_HDMI_DUAL_0_49_L            (REG_HDMI_DUAL_0_BASE + 0x92)
#define REG_HDMI_DUAL_0_49_H            (REG_HDMI_DUAL_0_BASE + 0x93)
#define REG_HDMI_DUAL_0_4A_L            (REG_HDMI_DUAL_0_BASE + 0x94)
#define REG_HDMI_DUAL_0_4A_H            (REG_HDMI_DUAL_0_BASE + 0x95)
#define REG_HDMI_DUAL_0_4B_L            (REG_HDMI_DUAL_0_BASE + 0x96)
#define REG_HDMI_DUAL_0_4B_H            (REG_HDMI_DUAL_0_BASE + 0x97)
#define REG_HDMI_DUAL_0_4C_L            (REG_HDMI_DUAL_0_BASE + 0x98)
#define REG_HDMI_DUAL_0_4C_H            (REG_HDMI_DUAL_0_BASE + 0x99)
#define REG_HDMI_DUAL_0_4D_L            (REG_HDMI_DUAL_0_BASE + 0x9A)
#define REG_HDMI_DUAL_0_4D_H            (REG_HDMI_DUAL_0_BASE + 0x9B)
#define REG_HDMI_DUAL_0_4E_L            (REG_HDMI_DUAL_0_BASE + 0x9C)
#define REG_HDMI_DUAL_0_4E_H            (REG_HDMI_DUAL_0_BASE + 0x9D)
#define REG_HDMI_DUAL_0_4F_L            (REG_HDMI_DUAL_0_BASE + 0x9E)
#define REG_HDMI_DUAL_0_4F_H            (REG_HDMI_DUAL_0_BASE + 0x9F)
#define REG_HDMI_DUAL_0_50_L            (REG_HDMI_DUAL_0_BASE + 0xA0)
#define REG_HDMI_DUAL_0_50_H            (REG_HDMI_DUAL_0_BASE + 0xA1)
#define REG_HDMI_DUAL_0_51_L            (REG_HDMI_DUAL_0_BASE + 0xA2)
#define REG_HDMI_DUAL_0_51_H            (REG_HDMI_DUAL_0_BASE + 0xA3)
#define REG_HDMI_DUAL_0_52_L            (REG_HDMI_DUAL_0_BASE + 0xA4)
#define REG_HDMI_DUAL_0_52_H            (REG_HDMI_DUAL_0_BASE + 0xA5)
#define REG_HDMI_DUAL_0_53_L            (REG_HDMI_DUAL_0_BASE + 0xA6)
#define REG_HDMI_DUAL_0_53_H            (REG_HDMI_DUAL_0_BASE + 0xA7)
#define REG_HDMI_DUAL_0_54_L            (REG_HDMI_DUAL_0_BASE + 0xA8)
#define REG_HDMI_DUAL_0_54_H            (REG_HDMI_DUAL_0_BASE + 0xA9)
#define REG_HDMI_DUAL_0_55_L            (REG_HDMI_DUAL_0_BASE + 0xAA)
#define REG_HDMI_DUAL_0_55_H            (REG_HDMI_DUAL_0_BASE + 0xAB)
#define REG_HDMI_DUAL_0_56_L            (REG_HDMI_DUAL_0_BASE + 0xAC)
#define REG_HDMI_DUAL_0_56_H            (REG_HDMI_DUAL_0_BASE + 0xAD)
#define REG_HDMI_DUAL_0_57_L            (REG_HDMI_DUAL_0_BASE + 0xAE)
#define REG_HDMI_DUAL_0_57_H            (REG_HDMI_DUAL_0_BASE + 0xAF)
#define REG_HDMI_DUAL_0_58_L            (REG_HDMI_DUAL_0_BASE + 0xB0)
#define REG_HDMI_DUAL_0_58_H            (REG_HDMI_DUAL_0_BASE + 0xB1)
#define REG_HDMI_DUAL_0_59_L            (REG_HDMI_DUAL_0_BASE + 0xB2)
#define REG_HDMI_DUAL_0_59_H            (REG_HDMI_DUAL_0_BASE + 0xB3)
#define REG_HDMI_DUAL_0_5A_L            (REG_HDMI_DUAL_0_BASE + 0xB4)
#define REG_HDMI_DUAL_0_5A_H            (REG_HDMI_DUAL_0_BASE + 0xB5)
#define REG_HDMI_DUAL_0_5B_L            (REG_HDMI_DUAL_0_BASE + 0xB6)
#define REG_HDMI_DUAL_0_5B_H            (REG_HDMI_DUAL_0_BASE + 0xB7)
#define REG_HDMI_DUAL_0_5C_L            (REG_HDMI_DUAL_0_BASE + 0xB8)
#define REG_HDMI_DUAL_0_5C_H            (REG_HDMI_DUAL_0_BASE + 0xB9)
#define REG_HDMI_DUAL_0_5D_L            (REG_HDMI_DUAL_0_BASE + 0xBA)
#define REG_HDMI_DUAL_0_5D_H            (REG_HDMI_DUAL_0_BASE + 0xBB)
#define REG_HDMI_DUAL_0_5E_L            (REG_HDMI_DUAL_0_BASE + 0xBC)
#define REG_HDMI_DUAL_0_5E_H            (REG_HDMI_DUAL_0_BASE + 0xBD)
#define REG_HDMI_DUAL_0_5F_L            (REG_HDMI_DUAL_0_BASE + 0xBE)
#define REG_HDMI_DUAL_0_5F_H            (REG_HDMI_DUAL_0_BASE + 0xBF)
#define REG_HDMI_DUAL_0_60_L            (REG_HDMI_DUAL_0_BASE + 0xC0)
#define REG_HDMI_DUAL_0_60_H            (REG_HDMI_DUAL_0_BASE + 0xC1)
#define REG_HDMI_DUAL_0_61_L            (REG_HDMI_DUAL_0_BASE + 0xC2)
#define REG_HDMI_DUAL_0_61_H            (REG_HDMI_DUAL_0_BASE + 0xC3)
#define REG_HDMI_DUAL_0_62_L            (REG_HDMI_DUAL_0_BASE + 0xC4)
#define REG_HDMI_DUAL_0_62_H            (REG_HDMI_DUAL_0_BASE + 0xC5)
#define REG_HDMI_DUAL_0_63_L            (REG_HDMI_DUAL_0_BASE + 0xC6)
#define REG_HDMI_DUAL_0_63_H            (REG_HDMI_DUAL_0_BASE + 0xC7)
#define REG_HDMI_DUAL_0_64_L            (REG_HDMI_DUAL_0_BASE + 0xC8)
#define REG_HDMI_DUAL_0_64_H            (REG_HDMI_DUAL_0_BASE + 0xC9)
#define REG_HDMI_DUAL_0_65_L            (REG_HDMI_DUAL_0_BASE + 0xCA)
#define REG_HDMI_DUAL_0_65_H            (REG_HDMI_DUAL_0_BASE + 0xCB)
#define REG_HDMI_DUAL_0_66_L            (REG_HDMI_DUAL_0_BASE + 0xCC)
#define REG_HDMI_DUAL_0_66_H            (REG_HDMI_DUAL_0_BASE + 0xCD)
#define REG_HDMI_DUAL_0_67_L            (REG_HDMI_DUAL_0_BASE + 0xCE)
#define REG_HDMI_DUAL_0_67_H            (REG_HDMI_DUAL_0_BASE + 0xCF)
#define REG_HDMI_DUAL_0_68_L            (REG_HDMI_DUAL_0_BASE + 0xD0)
#define REG_HDMI_DUAL_0_68_H            (REG_HDMI_DUAL_0_BASE + 0xD1)
#define REG_HDMI_DUAL_0_69_L            (REG_HDMI_DUAL_0_BASE + 0xD2)
#define REG_HDMI_DUAL_0_69_H            (REG_HDMI_DUAL_0_BASE + 0xD3)
#define REG_HDMI_DUAL_0_6A_L            (REG_HDMI_DUAL_0_BASE + 0xD4)
#define REG_HDMI_DUAL_0_6A_H            (REG_HDMI_DUAL_0_BASE + 0xD5)
#define REG_HDMI_DUAL_0_6B_L            (REG_HDMI_DUAL_0_BASE + 0xD6)
#define REG_HDMI_DUAL_0_6B_H            (REG_HDMI_DUAL_0_BASE + 0xD7)
#define REG_HDMI_DUAL_0_6C_L            (REG_HDMI_DUAL_0_BASE + 0xD8)
#define REG_HDMI_DUAL_0_6C_H            (REG_HDMI_DUAL_0_BASE + 0xD9)
#define REG_HDMI_DUAL_0_6D_L            (REG_HDMI_DUAL_0_BASE + 0xDA)
#define REG_HDMI_DUAL_0_6D_H            (REG_HDMI_DUAL_0_BASE + 0xDB)
#define REG_HDMI_DUAL_0_6E_L            (REG_HDMI_DUAL_0_BASE + 0xDC)
#define REG_HDMI_DUAL_0_6E_H            (REG_HDMI_DUAL_0_BASE + 0xDD)
#define REG_HDMI_DUAL_0_6F_L            (REG_HDMI_DUAL_0_BASE + 0xDE)
#define REG_HDMI_DUAL_0_6F_H            (REG_HDMI_DUAL_0_BASE + 0xDF)
#define REG_HDMI_DUAL_0_70_L            (REG_HDMI_DUAL_0_BASE + 0xE0)
#define REG_HDMI_DUAL_0_70_H            (REG_HDMI_DUAL_0_BASE + 0xE1)
#define REG_HDMI_DUAL_0_71_L            (REG_HDMI_DUAL_0_BASE + 0xE2)
#define REG_HDMI_DUAL_0_71_H            (REG_HDMI_DUAL_0_BASE + 0xE3)
#define REG_HDMI_DUAL_0_72_L            (REG_HDMI_DUAL_0_BASE + 0xE4)
#define REG_HDMI_DUAL_0_72_H            (REG_HDMI_DUAL_0_BASE + 0xE5)
#define REG_HDMI_DUAL_0_73_L            (REG_HDMI_DUAL_0_BASE + 0xE6)
#define REG_HDMI_DUAL_0_73_H            (REG_HDMI_DUAL_0_BASE + 0xE7)
#define REG_HDMI_DUAL_0_74_L            (REG_HDMI_DUAL_0_BASE + 0xE8)
#define REG_HDMI_DUAL_0_74_H            (REG_HDMI_DUAL_0_BASE + 0xE9)
#define REG_HDMI_DUAL_0_75_L            (REG_HDMI_DUAL_0_BASE + 0xEA)
#define REG_HDMI_DUAL_0_75_H            (REG_HDMI_DUAL_0_BASE + 0xEB)
#define REG_HDMI_DUAL_0_76_L            (REG_HDMI_DUAL_0_BASE + 0xEC)
#define REG_HDMI_DUAL_0_76_H            (REG_HDMI_DUAL_0_BASE + 0xED)
#define REG_HDMI_DUAL_0_77_L            (REG_HDMI_DUAL_0_BASE + 0xEE)
#define REG_HDMI_DUAL_0_77_H            (REG_HDMI_DUAL_0_BASE + 0xEF)
#define REG_HDMI_DUAL_0_78_L            (REG_HDMI_DUAL_0_BASE + 0xF0)
#define REG_HDMI_DUAL_0_78_H            (REG_HDMI_DUAL_0_BASE + 0xF1)
#define REG_HDMI_DUAL_0_79_L            (REG_HDMI_DUAL_0_BASE + 0xF2)
#define REG_HDMI_DUAL_0_79_H            (REG_HDMI_DUAL_0_BASE + 0xF3)
#define REG_HDMI_DUAL_0_7A_L            (REG_HDMI_DUAL_0_BASE + 0xF4)
#define REG_HDMI_DUAL_0_7A_H            (REG_HDMI_DUAL_0_BASE + 0xF5)
#define REG_HDMI_DUAL_0_7B_L            (REG_HDMI_DUAL_0_BASE + 0xF6)
#define REG_HDMI_DUAL_0_7B_H            (REG_HDMI_DUAL_0_BASE + 0xF7)
#define REG_HDMI_DUAL_0_7C_L            (REG_HDMI_DUAL_0_BASE + 0xF8)
#define REG_HDMI_DUAL_0_7C_H            (REG_HDMI_DUAL_0_BASE + 0xF9)
#define REG_HDMI_DUAL_0_7D_L            (REG_HDMI_DUAL_0_BASE + 0xFA)
#define REG_HDMI_DUAL_0_7D_H            (REG_HDMI_DUAL_0_BASE + 0xFB)
#define REG_HDMI_DUAL_0_7E_L            (REG_HDMI_DUAL_0_BASE + 0xFC)
#define REG_HDMI_DUAL_0_7E_H            (REG_HDMI_DUAL_0_BASE + 0xFD)
#define REG_HDMI_DUAL_0_7F_L            (REG_HDMI_DUAL_0_BASE + 0xFE)
#define REG_HDMI_DUAL_0_7F_H            (REG_HDMI_DUAL_0_BASE + 0xFF)

//=============================================================
// HDMI2_DUAL_0
#define REG_HDMI2_DUAL_0_00_L           (REG_HDMI2_DUAL_0_BASE + 0x00)
#define REG_HDMI2_DUAL_0_00_H           (REG_HDMI2_DUAL_0_BASE + 0x01)
#define REG_HDMI2_DUAL_0_01_L           (REG_HDMI2_DUAL_0_BASE + 0x02)
#define REG_HDMI2_DUAL_0_01_H           (REG_HDMI2_DUAL_0_BASE + 0x03)
#define REG_HDMI2_DUAL_0_02_L           (REG_HDMI2_DUAL_0_BASE + 0x04)
#define REG_HDMI2_DUAL_0_02_H           (REG_HDMI2_DUAL_0_BASE + 0x05)
#define REG_HDMI2_DUAL_0_03_L           (REG_HDMI2_DUAL_0_BASE + 0x06)
#define REG_HDMI2_DUAL_0_03_H           (REG_HDMI2_DUAL_0_BASE + 0x07)
#define REG_HDMI2_DUAL_0_04_L           (REG_HDMI2_DUAL_0_BASE + 0x08)
#define REG_HDMI2_DUAL_0_04_H           (REG_HDMI2_DUAL_0_BASE + 0x09)
#define REG_HDMI2_DUAL_0_05_L           (REG_HDMI2_DUAL_0_BASE + 0x0A)
#define REG_HDMI2_DUAL_0_05_H           (REG_HDMI2_DUAL_0_BASE + 0x0B)
#define REG_HDMI2_DUAL_0_06_L           (REG_HDMI2_DUAL_0_BASE + 0x0C)
#define REG_HDMI2_DUAL_0_06_H           (REG_HDMI2_DUAL_0_BASE + 0x0D)
#define REG_HDMI2_DUAL_0_07_L           (REG_HDMI2_DUAL_0_BASE + 0x0E)
#define REG_HDMI2_DUAL_0_07_H           (REG_HDMI2_DUAL_0_BASE + 0x0F)
#define REG_HDMI2_DUAL_0_08_L           (REG_HDMI2_DUAL_0_BASE + 0x10)
#define REG_HDMI2_DUAL_0_08_H           (REG_HDMI2_DUAL_0_BASE + 0x11)
#define REG_HDMI2_DUAL_0_09_L           (REG_HDMI2_DUAL_0_BASE + 0x12)
#define REG_HDMI2_DUAL_0_09_H           (REG_HDMI2_DUAL_0_BASE + 0x13)
#define REG_HDMI2_DUAL_0_0A_L           (REG_HDMI2_DUAL_0_BASE + 0x14)
#define REG_HDMI2_DUAL_0_0A_H           (REG_HDMI2_DUAL_0_BASE + 0x15)
#define REG_HDMI2_DUAL_0_0B_L           (REG_HDMI2_DUAL_0_BASE + 0x16)
#define REG_HDMI2_DUAL_0_0B_H           (REG_HDMI2_DUAL_0_BASE + 0x17)
#define REG_HDMI2_DUAL_0_0C_L           (REG_HDMI2_DUAL_0_BASE + 0x18)
#define REG_HDMI2_DUAL_0_0C_H           (REG_HDMI2_DUAL_0_BASE + 0x19)
#define REG_HDMI2_DUAL_0_0D_L           (REG_HDMI2_DUAL_0_BASE + 0x1A)
#define REG_HDMI2_DUAL_0_0D_H           (REG_HDMI2_DUAL_0_BASE + 0x1B)
#define REG_HDMI2_DUAL_0_0E_L           (REG_HDMI2_DUAL_0_BASE + 0x1C)
#define REG_HDMI2_DUAL_0_0E_H           (REG_HDMI2_DUAL_0_BASE + 0x1D)
#define REG_HDMI2_DUAL_0_0F_L           (REG_HDMI2_DUAL_0_BASE + 0x1E)
#define REG_HDMI2_DUAL_0_0F_H           (REG_HDMI2_DUAL_0_BASE + 0x1F)
#define REG_HDMI2_DUAL_0_10_L           (REG_HDMI2_DUAL_0_BASE + 0x20)
#define REG_HDMI2_DUAL_0_10_H           (REG_HDMI2_DUAL_0_BASE + 0x21)
#define REG_HDMI2_DUAL_0_11_L           (REG_HDMI2_DUAL_0_BASE + 0x22)
#define REG_HDMI2_DUAL_0_11_H           (REG_HDMI2_DUAL_0_BASE + 0x23)
#define REG_HDMI2_DUAL_0_12_L           (REG_HDMI2_DUAL_0_BASE + 0x24)
#define REG_HDMI2_DUAL_0_12_H           (REG_HDMI2_DUAL_0_BASE + 0x25)
#define REG_HDMI2_DUAL_0_13_L           (REG_HDMI2_DUAL_0_BASE + 0x26)
#define REG_HDMI2_DUAL_0_13_H           (REG_HDMI2_DUAL_0_BASE + 0x27)
#define REG_HDMI2_DUAL_0_14_L           (REG_HDMI2_DUAL_0_BASE + 0x28)
#define REG_HDMI2_DUAL_0_14_H           (REG_HDMI2_DUAL_0_BASE + 0x29)
#define REG_HDMI2_DUAL_0_15_L           (REG_HDMI2_DUAL_0_BASE + 0x2A)
#define REG_HDMI2_DUAL_0_15_H           (REG_HDMI2_DUAL_0_BASE + 0x2B)
#define REG_HDMI2_DUAL_0_16_L           (REG_HDMI2_DUAL_0_BASE + 0x2C)
#define REG_HDMI2_DUAL_0_16_H           (REG_HDMI2_DUAL_0_BASE + 0x2D)
#define REG_HDMI2_DUAL_0_17_L           (REG_HDMI2_DUAL_0_BASE + 0x2E)
#define REG_HDMI2_DUAL_0_17_H           (REG_HDMI2_DUAL_0_BASE + 0x2F)
#define REG_HDMI2_DUAL_0_18_L           (REG_HDMI2_DUAL_0_BASE + 0x30)
#define REG_HDMI2_DUAL_0_18_H           (REG_HDMI2_DUAL_0_BASE + 0x31)
#define REG_HDMI2_DUAL_0_19_L           (REG_HDMI2_DUAL_0_BASE + 0x32)
#define REG_HDMI2_DUAL_0_19_H           (REG_HDMI2_DUAL_0_BASE + 0x33)
#define REG_HDMI2_DUAL_0_1A_L           (REG_HDMI2_DUAL_0_BASE + 0x34)
#define REG_HDMI2_DUAL_0_1A_H           (REG_HDMI2_DUAL_0_BASE + 0x35)
#define REG_HDMI2_DUAL_0_1B_L           (REG_HDMI2_DUAL_0_BASE + 0x36)
#define REG_HDMI2_DUAL_0_1B_H           (REG_HDMI2_DUAL_0_BASE + 0x37)
#define REG_HDMI2_DUAL_0_1C_L           (REG_HDMI2_DUAL_0_BASE + 0x38)
#define REG_HDMI2_DUAL_0_1C_H           (REG_HDMI2_DUAL_0_BASE + 0x39)
#define REG_HDMI2_DUAL_0_1D_L           (REG_HDMI2_DUAL_0_BASE + 0x3A)
#define REG_HDMI2_DUAL_0_1D_H           (REG_HDMI2_DUAL_0_BASE + 0x3B)
#define REG_HDMI2_DUAL_0_1E_L           (REG_HDMI2_DUAL_0_BASE + 0x3C)
#define REG_HDMI2_DUAL_0_1E_H           (REG_HDMI2_DUAL_0_BASE + 0x3D)
#define REG_HDMI2_DUAL_0_1F_L           (REG_HDMI2_DUAL_0_BASE + 0x3E)
#define REG_HDMI2_DUAL_0_1F_H           (REG_HDMI2_DUAL_0_BASE + 0x3F)
#define REG_HDMI2_DUAL_0_20_L           (REG_HDMI2_DUAL_0_BASE + 0x40)
#define REG_HDMI2_DUAL_0_20_H           (REG_HDMI2_DUAL_0_BASE + 0x41)
#define REG_HDMI2_DUAL_0_21_L           (REG_HDMI2_DUAL_0_BASE + 0x42)
#define REG_HDMI2_DUAL_0_21_H           (REG_HDMI2_DUAL_0_BASE + 0x43)
#define REG_HDMI2_DUAL_0_22_L           (REG_HDMI2_DUAL_0_BASE + 0x44)
#define REG_HDMI2_DUAL_0_22_H           (REG_HDMI2_DUAL_0_BASE + 0x45)
#define REG_HDMI2_DUAL_0_23_L           (REG_HDMI2_DUAL_0_BASE + 0x46)
#define REG_HDMI2_DUAL_0_23_H           (REG_HDMI2_DUAL_0_BASE + 0x47)
#define REG_HDMI2_DUAL_0_24_L           (REG_HDMI2_DUAL_0_BASE + 0x48)
#define REG_HDMI2_DUAL_0_24_H           (REG_HDMI2_DUAL_0_BASE + 0x49)
#define REG_HDMI2_DUAL_0_25_L           (REG_HDMI2_DUAL_0_BASE + 0x4A)
#define REG_HDMI2_DUAL_0_25_H           (REG_HDMI2_DUAL_0_BASE + 0x4B)
#define REG_HDMI2_DUAL_0_26_L           (REG_HDMI2_DUAL_0_BASE + 0x4C)
#define REG_HDMI2_DUAL_0_26_H           (REG_HDMI2_DUAL_0_BASE + 0x4D)
#define REG_HDMI2_DUAL_0_27_L           (REG_HDMI2_DUAL_0_BASE + 0x4E)
#define REG_HDMI2_DUAL_0_27_H           (REG_HDMI2_DUAL_0_BASE + 0x4F)
#define REG_HDMI2_DUAL_0_28_L           (REG_HDMI2_DUAL_0_BASE + 0x50)
#define REG_HDMI2_DUAL_0_28_H           (REG_HDMI2_DUAL_0_BASE + 0x51)
#define REG_HDMI2_DUAL_0_29_L           (REG_HDMI2_DUAL_0_BASE + 0x52)
#define REG_HDMI2_DUAL_0_29_H           (REG_HDMI2_DUAL_0_BASE + 0x53)
#define REG_HDMI2_DUAL_0_2A_L           (REG_HDMI2_DUAL_0_BASE + 0x54)
#define REG_HDMI2_DUAL_0_2A_H           (REG_HDMI2_DUAL_0_BASE + 0x55)
#define REG_HDMI2_DUAL_0_2B_L           (REG_HDMI2_DUAL_0_BASE + 0x56)
#define REG_HDMI2_DUAL_0_2B_H           (REG_HDMI2_DUAL_0_BASE + 0x57)
#define REG_HDMI2_DUAL_0_2C_L           (REG_HDMI2_DUAL_0_BASE + 0x58)
#define REG_HDMI2_DUAL_0_2C_H           (REG_HDMI2_DUAL_0_BASE + 0x59)
#define REG_HDMI2_DUAL_0_2D_L           (REG_HDMI2_DUAL_0_BASE + 0x5A)
#define REG_HDMI2_DUAL_0_2D_H           (REG_HDMI2_DUAL_0_BASE + 0x5B)
#define REG_HDMI2_DUAL_0_2E_L           (REG_HDMI2_DUAL_0_BASE + 0x5C)
#define REG_HDMI2_DUAL_0_2E_H           (REG_HDMI2_DUAL_0_BASE + 0x5D)
#define REG_HDMI2_DUAL_0_2F_L           (REG_HDMI2_DUAL_0_BASE + 0x5E)
#define REG_HDMI2_DUAL_0_2F_H           (REG_HDMI2_DUAL_0_BASE + 0x5F)
#define REG_HDMI2_DUAL_0_30_L           (REG_HDMI2_DUAL_0_BASE + 0x60)
#define REG_HDMI2_DUAL_0_30_H           (REG_HDMI2_DUAL_0_BASE + 0x61)
#define REG_HDMI2_DUAL_0_31_L           (REG_HDMI2_DUAL_0_BASE + 0x62)
#define REG_HDMI2_DUAL_0_31_H           (REG_HDMI2_DUAL_0_BASE + 0x63)
#define REG_HDMI2_DUAL_0_32_L           (REG_HDMI2_DUAL_0_BASE + 0x64)
#define REG_HDMI2_DUAL_0_32_H           (REG_HDMI2_DUAL_0_BASE + 0x65)
#define REG_HDMI2_DUAL_0_33_L           (REG_HDMI2_DUAL_0_BASE + 0x66)
#define REG_HDMI2_DUAL_0_33_H           (REG_HDMI2_DUAL_0_BASE + 0x67)
#define REG_HDMI2_DUAL_0_34_L           (REG_HDMI2_DUAL_0_BASE + 0x68)
#define REG_HDMI2_DUAL_0_34_H           (REG_HDMI2_DUAL_0_BASE + 0x69)
#define REG_HDMI2_DUAL_0_35_L           (REG_HDMI2_DUAL_0_BASE + 0x6A)
#define REG_HDMI2_DUAL_0_35_H           (REG_HDMI2_DUAL_0_BASE + 0x6B)
#define REG_HDMI2_DUAL_0_36_L           (REG_HDMI2_DUAL_0_BASE + 0x6C)
#define REG_HDMI2_DUAL_0_36_H           (REG_HDMI2_DUAL_0_BASE + 0x6D)
#define REG_HDMI2_DUAL_0_37_L           (REG_HDMI2_DUAL_0_BASE + 0x6E)
#define REG_HDMI2_DUAL_0_37_H           (REG_HDMI2_DUAL_0_BASE + 0x6F)
#define REG_HDMI2_DUAL_0_38_L           (REG_HDMI2_DUAL_0_BASE + 0x70)
#define REG_HDMI2_DUAL_0_38_H           (REG_HDMI2_DUAL_0_BASE + 0x71)
#define REG_HDMI2_DUAL_0_39_L           (REG_HDMI2_DUAL_0_BASE + 0x72)
#define REG_HDMI2_DUAL_0_39_H           (REG_HDMI2_DUAL_0_BASE + 0x73)
#define REG_HDMI2_DUAL_0_3A_L           (REG_HDMI2_DUAL_0_BASE + 0x74)
#define REG_HDMI2_DUAL_0_3A_H           (REG_HDMI2_DUAL_0_BASE + 0x75)
#define REG_HDMI2_DUAL_0_3B_L           (REG_HDMI2_DUAL_0_BASE + 0x76)
#define REG_HDMI2_DUAL_0_3B_H           (REG_HDMI2_DUAL_0_BASE + 0x77)
#define REG_HDMI2_DUAL_0_3C_L           (REG_HDMI2_DUAL_0_BASE + 0x78)
#define REG_HDMI2_DUAL_0_3C_H           (REG_HDMI2_DUAL_0_BASE + 0x79)
#define REG_HDMI2_DUAL_0_3D_L           (REG_HDMI2_DUAL_0_BASE + 0x7A)
#define REG_HDMI2_DUAL_0_3D_H           (REG_HDMI2_DUAL_0_BASE + 0x7B)
#define REG_HDMI2_DUAL_0_3E_L           (REG_HDMI2_DUAL_0_BASE + 0x7C)
#define REG_HDMI2_DUAL_0_3E_H           (REG_HDMI2_DUAL_0_BASE + 0x7D)
#define REG_HDMI2_DUAL_0_3F_L           (REG_HDMI2_DUAL_0_BASE + 0x7E)
#define REG_HDMI2_DUAL_0_3F_H           (REG_HDMI2_DUAL_0_BASE + 0x7F)
#define REG_HDMI2_DUAL_0_40_L           (REG_HDMI2_DUAL_0_BASE + 0x80)
#define REG_HDMI2_DUAL_0_40_H           (REG_HDMI2_DUAL_0_BASE + 0x81)
#define REG_HDMI2_DUAL_0_41_L           (REG_HDMI2_DUAL_0_BASE + 0x82)
#define REG_HDMI2_DUAL_0_41_H           (REG_HDMI2_DUAL_0_BASE + 0x83)
#define REG_HDMI2_DUAL_0_42_L           (REG_HDMI2_DUAL_0_BASE + 0x84)
#define REG_HDMI2_DUAL_0_42_H           (REG_HDMI2_DUAL_0_BASE + 0x85)
#define REG_HDMI2_DUAL_0_43_L           (REG_HDMI2_DUAL_0_BASE + 0x86)
#define REG_HDMI2_DUAL_0_43_H           (REG_HDMI2_DUAL_0_BASE + 0x87)
#define REG_HDMI2_DUAL_0_44_L           (REG_HDMI2_DUAL_0_BASE + 0x88)
#define REG_HDMI2_DUAL_0_44_H           (REG_HDMI2_DUAL_0_BASE + 0x89)
#define REG_HDMI2_DUAL_0_45_L           (REG_HDMI2_DUAL_0_BASE + 0x8A)
#define REG_HDMI2_DUAL_0_45_H           (REG_HDMI2_DUAL_0_BASE + 0x8B)
#define REG_HDMI2_DUAL_0_46_L           (REG_HDMI2_DUAL_0_BASE + 0x8C)
#define REG_HDMI2_DUAL_0_46_H           (REG_HDMI2_DUAL_0_BASE + 0x8D)
#define REG_HDMI2_DUAL_0_47_L           (REG_HDMI2_DUAL_0_BASE + 0x8E)
#define REG_HDMI2_DUAL_0_47_H           (REG_HDMI2_DUAL_0_BASE + 0x8F)
#define REG_HDMI2_DUAL_0_48_L           (REG_HDMI2_DUAL_0_BASE + 0x90)
#define REG_HDMI2_DUAL_0_48_H           (REG_HDMI2_DUAL_0_BASE + 0x91)
#define REG_HDMI2_DUAL_0_49_L           (REG_HDMI2_DUAL_0_BASE + 0x92)
#define REG_HDMI2_DUAL_0_49_H           (REG_HDMI2_DUAL_0_BASE + 0x93)
#define REG_HDMI2_DUAL_0_4A_L           (REG_HDMI2_DUAL_0_BASE + 0x94)
#define REG_HDMI2_DUAL_0_4A_H           (REG_HDMI2_DUAL_0_BASE + 0x95)
#define REG_HDMI2_DUAL_0_4B_L           (REG_HDMI2_DUAL_0_BASE + 0x96)
#define REG_HDMI2_DUAL_0_4B_H           (REG_HDMI2_DUAL_0_BASE + 0x97)
#define REG_HDMI2_DUAL_0_4C_L           (REG_HDMI2_DUAL_0_BASE + 0x98)
#define REG_HDMI2_DUAL_0_4C_H           (REG_HDMI2_DUAL_0_BASE + 0x99)
#define REG_HDMI2_DUAL_0_4D_L           (REG_HDMI2_DUAL_0_BASE + 0x9A)
#define REG_HDMI2_DUAL_0_4D_H           (REG_HDMI2_DUAL_0_BASE + 0x9B)
#define REG_HDMI2_DUAL_0_4E_L           (REG_HDMI2_DUAL_0_BASE + 0x9C)
#define REG_HDMI2_DUAL_0_4E_H           (REG_HDMI2_DUAL_0_BASE + 0x9D)
#define REG_HDMI2_DUAL_0_4F_L           (REG_HDMI2_DUAL_0_BASE + 0x9E)
#define REG_HDMI2_DUAL_0_4F_H           (REG_HDMI2_DUAL_0_BASE + 0x9F)
#define REG_HDMI2_DUAL_0_50_L           (REG_HDMI2_DUAL_0_BASE + 0xA0)
#define REG_HDMI2_DUAL_0_50_H           (REG_HDMI2_DUAL_0_BASE + 0xA1)
#define REG_HDMI2_DUAL_0_51_L           (REG_HDMI2_DUAL_0_BASE + 0xA2)
#define REG_HDMI2_DUAL_0_51_H           (REG_HDMI2_DUAL_0_BASE + 0xA3)
#define REG_HDMI2_DUAL_0_52_L           (REG_HDMI2_DUAL_0_BASE + 0xA4)
#define REG_HDMI2_DUAL_0_52_H           (REG_HDMI2_DUAL_0_BASE + 0xA5)
#define REG_HDMI2_DUAL_0_53_L           (REG_HDMI2_DUAL_0_BASE + 0xA6)
#define REG_HDMI2_DUAL_0_53_H           (REG_HDMI2_DUAL_0_BASE + 0xA7)
#define REG_HDMI2_DUAL_0_54_L           (REG_HDMI2_DUAL_0_BASE + 0xA8)
#define REG_HDMI2_DUAL_0_54_H           (REG_HDMI2_DUAL_0_BASE + 0xA9)
#define REG_HDMI2_DUAL_0_55_L           (REG_HDMI2_DUAL_0_BASE + 0xAA)
#define REG_HDMI2_DUAL_0_55_H           (REG_HDMI2_DUAL_0_BASE + 0xAB)
#define REG_HDMI2_DUAL_0_56_L           (REG_HDMI2_DUAL_0_BASE + 0xAC)
#define REG_HDMI2_DUAL_0_56_H           (REG_HDMI2_DUAL_0_BASE + 0xAD)
#define REG_HDMI2_DUAL_0_57_L           (REG_HDMI2_DUAL_0_BASE + 0xAE)
#define REG_HDMI2_DUAL_0_57_H           (REG_HDMI2_DUAL_0_BASE + 0xAF)
#define REG_HDMI2_DUAL_0_58_L           (REG_HDMI2_DUAL_0_BASE + 0xB0)
#define REG_HDMI2_DUAL_0_58_H           (REG_HDMI2_DUAL_0_BASE + 0xB1)
#define REG_HDMI2_DUAL_0_59_L           (REG_HDMI2_DUAL_0_BASE + 0xB2)
#define REG_HDMI2_DUAL_0_59_H           (REG_HDMI2_DUAL_0_BASE + 0xB3)
#define REG_HDMI2_DUAL_0_5A_L           (REG_HDMI2_DUAL_0_BASE + 0xB4)
#define REG_HDMI2_DUAL_0_5A_H           (REG_HDMI2_DUAL_0_BASE + 0xB5)
#define REG_HDMI2_DUAL_0_5B_L           (REG_HDMI2_DUAL_0_BASE + 0xB6)
#define REG_HDMI2_DUAL_0_5B_H           (REG_HDMI2_DUAL_0_BASE + 0xB7)
#define REG_HDMI2_DUAL_0_5C_L           (REG_HDMI2_DUAL_0_BASE + 0xB8)
#define REG_HDMI2_DUAL_0_5C_H           (REG_HDMI2_DUAL_0_BASE + 0xB9)
#define REG_HDMI2_DUAL_0_5D_L           (REG_HDMI2_DUAL_0_BASE + 0xBA)
#define REG_HDMI2_DUAL_0_5D_H           (REG_HDMI2_DUAL_0_BASE + 0xBB)
#define REG_HDMI2_DUAL_0_5E_L           (REG_HDMI2_DUAL_0_BASE + 0xBC)
#define REG_HDMI2_DUAL_0_5E_H           (REG_HDMI2_DUAL_0_BASE + 0xBD)
#define REG_HDMI2_DUAL_0_5F_L           (REG_HDMI2_DUAL_0_BASE + 0xBE)
#define REG_HDMI2_DUAL_0_5F_H           (REG_HDMI2_DUAL_0_BASE + 0xBF)
#define REG_HDMI2_DUAL_0_60_L           (REG_HDMI2_DUAL_0_BASE + 0xC0)
#define REG_HDMI2_DUAL_0_60_H           (REG_HDMI2_DUAL_0_BASE + 0xC1)
#define REG_HDMI2_DUAL_0_61_L           (REG_HDMI2_DUAL_0_BASE + 0xC2)
#define REG_HDMI2_DUAL_0_61_H           (REG_HDMI2_DUAL_0_BASE + 0xC3)
#define REG_HDMI2_DUAL_0_62_L           (REG_HDMI2_DUAL_0_BASE + 0xC4)
#define REG_HDMI2_DUAL_0_62_H           (REG_HDMI2_DUAL_0_BASE + 0xC5)
#define REG_HDMI2_DUAL_0_63_L           (REG_HDMI2_DUAL_0_BASE + 0xC6)
#define REG_HDMI2_DUAL_0_63_H           (REG_HDMI2_DUAL_0_BASE + 0xC7)
#define REG_HDMI2_DUAL_0_64_L           (REG_HDMI2_DUAL_0_BASE + 0xC8)
#define REG_HDMI2_DUAL_0_64_H           (REG_HDMI2_DUAL_0_BASE + 0xC9)
#define REG_HDMI2_DUAL_0_65_L           (REG_HDMI2_DUAL_0_BASE + 0xCA)
#define REG_HDMI2_DUAL_0_65_H           (REG_HDMI2_DUAL_0_BASE + 0xCB)
#define REG_HDMI2_DUAL_0_66_L           (REG_HDMI2_DUAL_0_BASE + 0xCC)
#define REG_HDMI2_DUAL_0_66_H           (REG_HDMI2_DUAL_0_BASE + 0xCD)
#define REG_HDMI2_DUAL_0_67_L           (REG_HDMI2_DUAL_0_BASE + 0xCE)
#define REG_HDMI2_DUAL_0_67_H           (REG_HDMI2_DUAL_0_BASE + 0xCF)
#define REG_HDMI2_DUAL_0_68_L           (REG_HDMI2_DUAL_0_BASE + 0xD0)
#define REG_HDMI2_DUAL_0_68_H           (REG_HDMI2_DUAL_0_BASE + 0xD1)
#define REG_HDMI2_DUAL_0_69_L           (REG_HDMI2_DUAL_0_BASE + 0xD2)
#define REG_HDMI2_DUAL_0_69_H           (REG_HDMI2_DUAL_0_BASE + 0xD3)
#define REG_HDMI2_DUAL_0_6A_L           (REG_HDMI2_DUAL_0_BASE + 0xD4)
#define REG_HDMI2_DUAL_0_6A_H           (REG_HDMI2_DUAL_0_BASE + 0xD5)
#define REG_HDMI2_DUAL_0_6B_L           (REG_HDMI2_DUAL_0_BASE + 0xD6)
#define REG_HDMI2_DUAL_0_6B_H           (REG_HDMI2_DUAL_0_BASE + 0xD7)
#define REG_HDMI2_DUAL_0_6C_L           (REG_HDMI2_DUAL_0_BASE + 0xD8)
#define REG_HDMI2_DUAL_0_6C_H           (REG_HDMI2_DUAL_0_BASE + 0xD9)
#define REG_HDMI2_DUAL_0_6D_L           (REG_HDMI2_DUAL_0_BASE + 0xDA)
#define REG_HDMI2_DUAL_0_6D_H           (REG_HDMI2_DUAL_0_BASE + 0xDB)
#define REG_HDMI2_DUAL_0_6E_L           (REG_HDMI2_DUAL_0_BASE + 0xDC)
#define REG_HDMI2_DUAL_0_6E_H           (REG_HDMI2_DUAL_0_BASE + 0xDD)
#define REG_HDMI2_DUAL_0_6F_L           (REG_HDMI2_DUAL_0_BASE + 0xDE)
#define REG_HDMI2_DUAL_0_6F_H           (REG_HDMI2_DUAL_0_BASE + 0xDF)
#define REG_HDMI2_DUAL_0_70_L           (REG_HDMI2_DUAL_0_BASE + 0xE0)
#define REG_HDMI2_DUAL_0_70_H           (REG_HDMI2_DUAL_0_BASE + 0xE1)
#define REG_HDMI2_DUAL_0_71_L           (REG_HDMI2_DUAL_0_BASE + 0xE2)
#define REG_HDMI2_DUAL_0_71_H           (REG_HDMI2_DUAL_0_BASE + 0xE3)
#define REG_HDMI2_DUAL_0_72_L           (REG_HDMI2_DUAL_0_BASE + 0xE4)
#define REG_HDMI2_DUAL_0_72_H           (REG_HDMI2_DUAL_0_BASE + 0xE5)
#define REG_HDMI2_DUAL_0_73_L           (REG_HDMI2_DUAL_0_BASE + 0xE6)
#define REG_HDMI2_DUAL_0_73_H           (REG_HDMI2_DUAL_0_BASE + 0xE7)
#define REG_HDMI2_DUAL_0_74_L           (REG_HDMI2_DUAL_0_BASE + 0xE8)
#define REG_HDMI2_DUAL_0_74_H           (REG_HDMI2_DUAL_0_BASE + 0xE9)
#define REG_HDMI2_DUAL_0_75_L           (REG_HDMI2_DUAL_0_BASE + 0xEA)
#define REG_HDMI2_DUAL_0_75_H           (REG_HDMI2_DUAL_0_BASE + 0xEB)
#define REG_HDMI2_DUAL_0_76_L           (REG_HDMI2_DUAL_0_BASE + 0xEC)
#define REG_HDMI2_DUAL_0_76_H           (REG_HDMI2_DUAL_0_BASE + 0xED)
#define REG_HDMI2_DUAL_0_77_L           (REG_HDMI2_DUAL_0_BASE + 0xEE)
#define REG_HDMI2_DUAL_0_77_H           (REG_HDMI2_DUAL_0_BASE + 0xEF)
#define REG_HDMI2_DUAL_0_78_L           (REG_HDMI2_DUAL_0_BASE + 0xF0)
#define REG_HDMI2_DUAL_0_78_H           (REG_HDMI2_DUAL_0_BASE + 0xF1)
#define REG_HDMI2_DUAL_0_79_L           (REG_HDMI2_DUAL_0_BASE + 0xF2)
#define REG_HDMI2_DUAL_0_79_H           (REG_HDMI2_DUAL_0_BASE + 0xF3)
#define REG_HDMI2_DUAL_0_7A_L           (REG_HDMI2_DUAL_0_BASE + 0xF4)
#define REG_HDMI2_DUAL_0_7A_H           (REG_HDMI2_DUAL_0_BASE + 0xF5)
#define REG_HDMI2_DUAL_0_7B_L           (REG_HDMI2_DUAL_0_BASE + 0xF6)
#define REG_HDMI2_DUAL_0_7B_H           (REG_HDMI2_DUAL_0_BASE + 0xF7)
#define REG_HDMI2_DUAL_0_7C_L           (REG_HDMI2_DUAL_0_BASE + 0xF8)
#define REG_HDMI2_DUAL_0_7C_H           (REG_HDMI2_DUAL_0_BASE + 0xF9)
#define REG_HDMI2_DUAL_0_7D_L           (REG_HDMI2_DUAL_0_BASE + 0xFA)
#define REG_HDMI2_DUAL_0_7D_H           (REG_HDMI2_DUAL_0_BASE + 0xFB)
#define REG_HDMI2_DUAL_0_7E_L           (REG_HDMI2_DUAL_0_BASE + 0xFC)
#define REG_HDMI2_DUAL_0_7E_H           (REG_HDMI2_DUAL_0_BASE + 0xFD)
#define REG_HDMI2_DUAL_0_7F_L           (REG_HDMI2_DUAL_0_BASE + 0xFE)
#define REG_HDMI2_DUAL_0_7F_H           (REG_HDMI2_DUAL_0_BASE + 0xFF)

//=============================================================
// HDMI3_DUAL_0
#define REG_HDMI3_DUAL_0_00_L           (REG_HDMI3_DUAL_0_BASE + 0x00)
#define REG_HDMI3_DUAL_0_00_H           (REG_HDMI3_DUAL_0_BASE + 0x01)
#define REG_HDMI3_DUAL_0_01_L           (REG_HDMI3_DUAL_0_BASE + 0x02)
#define REG_HDMI3_DUAL_0_01_H           (REG_HDMI3_DUAL_0_BASE + 0x03)
#define REG_HDMI3_DUAL_0_02_L           (REG_HDMI3_DUAL_0_BASE + 0x04)
#define REG_HDMI3_DUAL_0_02_H           (REG_HDMI3_DUAL_0_BASE + 0x05)
#define REG_HDMI3_DUAL_0_03_L           (REG_HDMI3_DUAL_0_BASE + 0x06)
#define REG_HDMI3_DUAL_0_03_H           (REG_HDMI3_DUAL_0_BASE + 0x07)
#define REG_HDMI3_DUAL_0_04_L           (REG_HDMI3_DUAL_0_BASE + 0x08)
#define REG_HDMI3_DUAL_0_04_H           (REG_HDMI3_DUAL_0_BASE + 0x09)
#define REG_HDMI3_DUAL_0_05_L           (REG_HDMI3_DUAL_0_BASE + 0x0A)
#define REG_HDMI3_DUAL_0_05_H           (REG_HDMI3_DUAL_0_BASE + 0x0B)
#define REG_HDMI3_DUAL_0_06_L           (REG_HDMI3_DUAL_0_BASE + 0x0C)
#define REG_HDMI3_DUAL_0_06_H           (REG_HDMI3_DUAL_0_BASE + 0x0D)
#define REG_HDMI3_DUAL_0_07_L           (REG_HDMI3_DUAL_0_BASE + 0x0E)
#define REG_HDMI3_DUAL_0_07_H           (REG_HDMI3_DUAL_0_BASE + 0x0F)
#define REG_HDMI3_DUAL_0_08_L           (REG_HDMI3_DUAL_0_BASE + 0x10)
#define REG_HDMI3_DUAL_0_08_H           (REG_HDMI3_DUAL_0_BASE + 0x11)
#define REG_HDMI3_DUAL_0_09_L           (REG_HDMI3_DUAL_0_BASE + 0x12)
#define REG_HDMI3_DUAL_0_09_H           (REG_HDMI3_DUAL_0_BASE + 0x13)
#define REG_HDMI3_DUAL_0_0A_L           (REG_HDMI3_DUAL_0_BASE + 0x14)
#define REG_HDMI3_DUAL_0_0A_H           (REG_HDMI3_DUAL_0_BASE + 0x15)
#define REG_HDMI3_DUAL_0_0B_L           (REG_HDMI3_DUAL_0_BASE + 0x16)
#define REG_HDMI3_DUAL_0_0B_H           (REG_HDMI3_DUAL_0_BASE + 0x17)
#define REG_HDMI3_DUAL_0_0C_L           (REG_HDMI3_DUAL_0_BASE + 0x18)
#define REG_HDMI3_DUAL_0_0C_H           (REG_HDMI3_DUAL_0_BASE + 0x19)
#define REG_HDMI3_DUAL_0_0D_L           (REG_HDMI3_DUAL_0_BASE + 0x1A)
#define REG_HDMI3_DUAL_0_0D_H           (REG_HDMI3_DUAL_0_BASE + 0x1B)
#define REG_HDMI3_DUAL_0_0E_L           (REG_HDMI3_DUAL_0_BASE + 0x1C)
#define REG_HDMI3_DUAL_0_0E_H           (REG_HDMI3_DUAL_0_BASE + 0x1D)
#define REG_HDMI3_DUAL_0_0F_L           (REG_HDMI3_DUAL_0_BASE + 0x1E)
#define REG_HDMI3_DUAL_0_0F_H           (REG_HDMI3_DUAL_0_BASE + 0x1F)
#define REG_HDMI3_DUAL_0_10_L           (REG_HDMI3_DUAL_0_BASE + 0x20)
#define REG_HDMI3_DUAL_0_10_H           (REG_HDMI3_DUAL_0_BASE + 0x21)
#define REG_HDMI3_DUAL_0_11_L           (REG_HDMI3_DUAL_0_BASE + 0x22)
#define REG_HDMI3_DUAL_0_11_H           (REG_HDMI3_DUAL_0_BASE + 0x23)
#define REG_HDMI3_DUAL_0_12_L           (REG_HDMI3_DUAL_0_BASE + 0x24)
#define REG_HDMI3_DUAL_0_12_H           (REG_HDMI3_DUAL_0_BASE + 0x25)
#define REG_HDMI3_DUAL_0_13_L           (REG_HDMI3_DUAL_0_BASE + 0x26)
#define REG_HDMI3_DUAL_0_13_H           (REG_HDMI3_DUAL_0_BASE + 0x27)
#define REG_HDMI3_DUAL_0_14_L           (REG_HDMI3_DUAL_0_BASE + 0x28)
#define REG_HDMI3_DUAL_0_14_H           (REG_HDMI3_DUAL_0_BASE + 0x29)
#define REG_HDMI3_DUAL_0_15_L           (REG_HDMI3_DUAL_0_BASE + 0x2A)
#define REG_HDMI3_DUAL_0_15_H           (REG_HDMI3_DUAL_0_BASE + 0x2B)
#define REG_HDMI3_DUAL_0_16_L           (REG_HDMI3_DUAL_0_BASE + 0x2C)
#define REG_HDMI3_DUAL_0_16_H           (REG_HDMI3_DUAL_0_BASE + 0x2D)
#define REG_HDMI3_DUAL_0_17_L           (REG_HDMI3_DUAL_0_BASE + 0x2E)
#define REG_HDMI3_DUAL_0_17_H           (REG_HDMI3_DUAL_0_BASE + 0x2F)
#define REG_HDMI3_DUAL_0_18_L           (REG_HDMI3_DUAL_0_BASE + 0x30)
#define REG_HDMI3_DUAL_0_18_H           (REG_HDMI3_DUAL_0_BASE + 0x31)
#define REG_HDMI3_DUAL_0_19_L           (REG_HDMI3_DUAL_0_BASE + 0x32)
#define REG_HDMI3_DUAL_0_19_H           (REG_HDMI3_DUAL_0_BASE + 0x33)
#define REG_HDMI3_DUAL_0_1A_L           (REG_HDMI3_DUAL_0_BASE + 0x34)
#define REG_HDMI3_DUAL_0_1A_H           (REG_HDMI3_DUAL_0_BASE + 0x35)
#define REG_HDMI3_DUAL_0_1B_L           (REG_HDMI3_DUAL_0_BASE + 0x36)
#define REG_HDMI3_DUAL_0_1B_H           (REG_HDMI3_DUAL_0_BASE + 0x37)
#define REG_HDMI3_DUAL_0_1C_L           (REG_HDMI3_DUAL_0_BASE + 0x38)
#define REG_HDMI3_DUAL_0_1C_H           (REG_HDMI3_DUAL_0_BASE + 0x39)
#define REG_HDMI3_DUAL_0_1D_L           (REG_HDMI3_DUAL_0_BASE + 0x3A)
#define REG_HDMI3_DUAL_0_1D_H           (REG_HDMI3_DUAL_0_BASE + 0x3B)
#define REG_HDMI3_DUAL_0_1E_L           (REG_HDMI3_DUAL_0_BASE + 0x3C)
#define REG_HDMI3_DUAL_0_1E_H           (REG_HDMI3_DUAL_0_BASE + 0x3D)
#define REG_HDMI3_DUAL_0_1F_L           (REG_HDMI3_DUAL_0_BASE + 0x3E)
#define REG_HDMI3_DUAL_0_1F_H           (REG_HDMI3_DUAL_0_BASE + 0x3F)
#define REG_HDMI3_DUAL_0_20_L           (REG_HDMI3_DUAL_0_BASE + 0x40)
#define REG_HDMI3_DUAL_0_20_H           (REG_HDMI3_DUAL_0_BASE + 0x41)
#define REG_HDMI3_DUAL_0_21_L           (REG_HDMI3_DUAL_0_BASE + 0x42)
#define REG_HDMI3_DUAL_0_21_H           (REG_HDMI3_DUAL_0_BASE + 0x43)
#define REG_HDMI3_DUAL_0_22_L           (REG_HDMI3_DUAL_0_BASE + 0x44)
#define REG_HDMI3_DUAL_0_22_H           (REG_HDMI3_DUAL_0_BASE + 0x45)
#define REG_HDMI3_DUAL_0_23_L           (REG_HDMI3_DUAL_0_BASE + 0x46)
#define REG_HDMI3_DUAL_0_23_H           (REG_HDMI3_DUAL_0_BASE + 0x47)
#define REG_HDMI3_DUAL_0_24_L           (REG_HDMI3_DUAL_0_BASE + 0x48)
#define REG_HDMI3_DUAL_0_24_H           (REG_HDMI3_DUAL_0_BASE + 0x49)
#define REG_HDMI3_DUAL_0_25_L           (REG_HDMI3_DUAL_0_BASE + 0x4A)
#define REG_HDMI3_DUAL_0_25_H           (REG_HDMI3_DUAL_0_BASE + 0x4B)
#define REG_HDMI3_DUAL_0_26_L           (REG_HDMI3_DUAL_0_BASE + 0x4C)
#define REG_HDMI3_DUAL_0_26_H           (REG_HDMI3_DUAL_0_BASE + 0x4D)
#define REG_HDMI3_DUAL_0_27_L           (REG_HDMI3_DUAL_0_BASE + 0x4E)
#define REG_HDMI3_DUAL_0_27_H           (REG_HDMI3_DUAL_0_BASE + 0x4F)
#define REG_HDMI3_DUAL_0_28_L           (REG_HDMI3_DUAL_0_BASE + 0x50)
#define REG_HDMI3_DUAL_0_28_H           (REG_HDMI3_DUAL_0_BASE + 0x51)
#define REG_HDMI3_DUAL_0_29_L           (REG_HDMI3_DUAL_0_BASE + 0x52)
#define REG_HDMI3_DUAL_0_29_H           (REG_HDMI3_DUAL_0_BASE + 0x53)
#define REG_HDMI3_DUAL_0_2A_L           (REG_HDMI3_DUAL_0_BASE + 0x54)
#define REG_HDMI3_DUAL_0_2A_H           (REG_HDMI3_DUAL_0_BASE + 0x55)
#define REG_HDMI3_DUAL_0_2B_L           (REG_HDMI3_DUAL_0_BASE + 0x56)
#define REG_HDMI3_DUAL_0_2B_H           (REG_HDMI3_DUAL_0_BASE + 0x57)
#define REG_HDMI3_DUAL_0_2C_L           (REG_HDMI3_DUAL_0_BASE + 0x58)
#define REG_HDMI3_DUAL_0_2C_H           (REG_HDMI3_DUAL_0_BASE + 0x59)
#define REG_HDMI3_DUAL_0_2D_L           (REG_HDMI3_DUAL_0_BASE + 0x5A)
#define REG_HDMI3_DUAL_0_2D_H           (REG_HDMI3_DUAL_0_BASE + 0x5B)
#define REG_HDMI3_DUAL_0_2E_L           (REG_HDMI3_DUAL_0_BASE + 0x5C)
#define REG_HDMI3_DUAL_0_2E_H           (REG_HDMI3_DUAL_0_BASE + 0x5D)
#define REG_HDMI3_DUAL_0_2F_L           (REG_HDMI3_DUAL_0_BASE + 0x5E)
#define REG_HDMI3_DUAL_0_2F_H           (REG_HDMI3_DUAL_0_BASE + 0x5F)
#define REG_HDMI3_DUAL_0_30_L           (REG_HDMI3_DUAL_0_BASE + 0x60)
#define REG_HDMI3_DUAL_0_30_H           (REG_HDMI3_DUAL_0_BASE + 0x61)
#define REG_HDMI3_DUAL_0_31_L           (REG_HDMI3_DUAL_0_BASE + 0x62)
#define REG_HDMI3_DUAL_0_31_H           (REG_HDMI3_DUAL_0_BASE + 0x63)
#define REG_HDMI3_DUAL_0_32_L           (REG_HDMI3_DUAL_0_BASE + 0x64)
#define REG_HDMI3_DUAL_0_32_H           (REG_HDMI3_DUAL_0_BASE + 0x65)
#define REG_HDMI3_DUAL_0_33_L           (REG_HDMI3_DUAL_0_BASE + 0x66)
#define REG_HDMI3_DUAL_0_33_H           (REG_HDMI3_DUAL_0_BASE + 0x67)
#define REG_HDMI3_DUAL_0_34_L           (REG_HDMI3_DUAL_0_BASE + 0x68)
#define REG_HDMI3_DUAL_0_34_H           (REG_HDMI3_DUAL_0_BASE + 0x69)
#define REG_HDMI3_DUAL_0_35_L           (REG_HDMI3_DUAL_0_BASE + 0x6A)
#define REG_HDMI3_DUAL_0_35_H           (REG_HDMI3_DUAL_0_BASE + 0x6B)
#define REG_HDMI3_DUAL_0_36_L           (REG_HDMI3_DUAL_0_BASE + 0x6C)
#define REG_HDMI3_DUAL_0_36_H           (REG_HDMI3_DUAL_0_BASE + 0x6D)
#define REG_HDMI3_DUAL_0_37_L           (REG_HDMI3_DUAL_0_BASE + 0x6E)
#define REG_HDMI3_DUAL_0_37_H           (REG_HDMI3_DUAL_0_BASE + 0x6F)
#define REG_HDMI3_DUAL_0_38_L           (REG_HDMI3_DUAL_0_BASE + 0x70)
#define REG_HDMI3_DUAL_0_38_H           (REG_HDMI3_DUAL_0_BASE + 0x71)
#define REG_HDMI3_DUAL_0_39_L           (REG_HDMI3_DUAL_0_BASE + 0x72)
#define REG_HDMI3_DUAL_0_39_H           (REG_HDMI3_DUAL_0_BASE + 0x73)
#define REG_HDMI3_DUAL_0_3A_L           (REG_HDMI3_DUAL_0_BASE + 0x74)
#define REG_HDMI3_DUAL_0_3A_H           (REG_HDMI3_DUAL_0_BASE + 0x75)
#define REG_HDMI3_DUAL_0_3B_L           (REG_HDMI3_DUAL_0_BASE + 0x76)
#define REG_HDMI3_DUAL_0_3B_H           (REG_HDMI3_DUAL_0_BASE + 0x77)
#define REG_HDMI3_DUAL_0_3C_L           (REG_HDMI3_DUAL_0_BASE + 0x78)
#define REG_HDMI3_DUAL_0_3C_H           (REG_HDMI3_DUAL_0_BASE + 0x79)
#define REG_HDMI3_DUAL_0_3D_L           (REG_HDMI3_DUAL_0_BASE + 0x7A)
#define REG_HDMI3_DUAL_0_3D_H           (REG_HDMI3_DUAL_0_BASE + 0x7B)
#define REG_HDMI3_DUAL_0_3E_L           (REG_HDMI3_DUAL_0_BASE + 0x7C)
#define REG_HDMI3_DUAL_0_3E_H           (REG_HDMI3_DUAL_0_BASE + 0x7D)
#define REG_HDMI3_DUAL_0_3F_L           (REG_HDMI3_DUAL_0_BASE + 0x7E)
#define REG_HDMI3_DUAL_0_3F_H           (REG_HDMI3_DUAL_0_BASE + 0x7F)
#define REG_HDMI3_DUAL_0_40_L           (REG_HDMI3_DUAL_0_BASE + 0x80)
#define REG_HDMI3_DUAL_0_40_H           (REG_HDMI3_DUAL_0_BASE + 0x81)
#define REG_HDMI3_DUAL_0_41_L           (REG_HDMI3_DUAL_0_BASE + 0x82)
#define REG_HDMI3_DUAL_0_41_H           (REG_HDMI3_DUAL_0_BASE + 0x83)
#define REG_HDMI3_DUAL_0_42_L           (REG_HDMI3_DUAL_0_BASE + 0x84)
#define REG_HDMI3_DUAL_0_42_H           (REG_HDMI3_DUAL_0_BASE + 0x85)
#define REG_HDMI3_DUAL_0_43_L           (REG_HDMI3_DUAL_0_BASE + 0x86)
#define REG_HDMI3_DUAL_0_43_H           (REG_HDMI3_DUAL_0_BASE + 0x87)
#define REG_HDMI3_DUAL_0_44_L           (REG_HDMI3_DUAL_0_BASE + 0x88)
#define REG_HDMI3_DUAL_0_44_H           (REG_HDMI3_DUAL_0_BASE + 0x89)
#define REG_HDMI3_DUAL_0_45_L           (REG_HDMI3_DUAL_0_BASE + 0x8A)
#define REG_HDMI3_DUAL_0_45_H           (REG_HDMI3_DUAL_0_BASE + 0x8B)
#define REG_HDMI3_DUAL_0_46_L           (REG_HDMI3_DUAL_0_BASE + 0x8C)
#define REG_HDMI3_DUAL_0_46_H           (REG_HDMI3_DUAL_0_BASE + 0x8D)
#define REG_HDMI3_DUAL_0_47_L           (REG_HDMI3_DUAL_0_BASE + 0x8E)
#define REG_HDMI3_DUAL_0_47_H           (REG_HDMI3_DUAL_0_BASE + 0x8F)
#define REG_HDMI3_DUAL_0_48_L           (REG_HDMI3_DUAL_0_BASE + 0x90)
#define REG_HDMI3_DUAL_0_48_H           (REG_HDMI3_DUAL_0_BASE + 0x91)
#define REG_HDMI3_DUAL_0_49_L           (REG_HDMI3_DUAL_0_BASE + 0x92)
#define REG_HDMI3_DUAL_0_49_H           (REG_HDMI3_DUAL_0_BASE + 0x93)
#define REG_HDMI3_DUAL_0_4A_L           (REG_HDMI3_DUAL_0_BASE + 0x94)
#define REG_HDMI3_DUAL_0_4A_H           (REG_HDMI3_DUAL_0_BASE + 0x95)
#define REG_HDMI3_DUAL_0_4B_L           (REG_HDMI3_DUAL_0_BASE + 0x96)
#define REG_HDMI3_DUAL_0_4B_H           (REG_HDMI3_DUAL_0_BASE + 0x97)
#define REG_HDMI3_DUAL_0_4C_L           (REG_HDMI3_DUAL_0_BASE + 0x98)
#define REG_HDMI3_DUAL_0_4C_H           (REG_HDMI3_DUAL_0_BASE + 0x99)
#define REG_HDMI3_DUAL_0_4D_L           (REG_HDMI3_DUAL_0_BASE + 0x9A)
#define REG_HDMI3_DUAL_0_4D_H           (REG_HDMI3_DUAL_0_BASE + 0x9B)
#define REG_HDMI3_DUAL_0_4E_L           (REG_HDMI3_DUAL_0_BASE + 0x9C)
#define REG_HDMI3_DUAL_0_4E_H           (REG_HDMI3_DUAL_0_BASE + 0x9D)
#define REG_HDMI3_DUAL_0_4F_L           (REG_HDMI3_DUAL_0_BASE + 0x9E)
#define REG_HDMI3_DUAL_0_4F_H           (REG_HDMI3_DUAL_0_BASE + 0x9F)
#define REG_HDMI3_DUAL_0_50_L           (REG_HDMI3_DUAL_0_BASE + 0xA0)
#define REG_HDMI3_DUAL_0_50_H           (REG_HDMI3_DUAL_0_BASE + 0xA1)
#define REG_HDMI3_DUAL_0_51_L           (REG_HDMI3_DUAL_0_BASE + 0xA2)
#define REG_HDMI3_DUAL_0_51_H           (REG_HDMI3_DUAL_0_BASE + 0xA3)
#define REG_HDMI3_DUAL_0_52_L           (REG_HDMI3_DUAL_0_BASE + 0xA4)
#define REG_HDMI3_DUAL_0_52_H           (REG_HDMI3_DUAL_0_BASE + 0xA5)
#define REG_HDMI3_DUAL_0_53_L           (REG_HDMI3_DUAL_0_BASE + 0xA6)
#define REG_HDMI3_DUAL_0_53_H           (REG_HDMI3_DUAL_0_BASE + 0xA7)
#define REG_HDMI3_DUAL_0_54_L           (REG_HDMI3_DUAL_0_BASE + 0xA8)
#define REG_HDMI3_DUAL_0_54_H           (REG_HDMI3_DUAL_0_BASE + 0xA9)
#define REG_HDMI3_DUAL_0_55_L           (REG_HDMI3_DUAL_0_BASE + 0xAA)
#define REG_HDMI3_DUAL_0_55_H           (REG_HDMI3_DUAL_0_BASE + 0xAB)
#define REG_HDMI3_DUAL_0_56_L           (REG_HDMI3_DUAL_0_BASE + 0xAC)
#define REG_HDMI3_DUAL_0_56_H           (REG_HDMI3_DUAL_0_BASE + 0xAD)
#define REG_HDMI3_DUAL_0_57_L           (REG_HDMI3_DUAL_0_BASE + 0xAE)
#define REG_HDMI3_DUAL_0_57_H           (REG_HDMI3_DUAL_0_BASE + 0xAF)
#define REG_HDMI3_DUAL_0_58_L           (REG_HDMI3_DUAL_0_BASE + 0xB0)
#define REG_HDMI3_DUAL_0_58_H           (REG_HDMI3_DUAL_0_BASE + 0xB1)
#define REG_HDMI3_DUAL_0_59_L           (REG_HDMI3_DUAL_0_BASE + 0xB2)
#define REG_HDMI3_DUAL_0_59_H           (REG_HDMI3_DUAL_0_BASE + 0xB3)
#define REG_HDMI3_DUAL_0_5A_L           (REG_HDMI3_DUAL_0_BASE + 0xB4)
#define REG_HDMI3_DUAL_0_5A_H           (REG_HDMI3_DUAL_0_BASE + 0xB5)
#define REG_HDMI3_DUAL_0_5B_L           (REG_HDMI3_DUAL_0_BASE + 0xB6)
#define REG_HDMI3_DUAL_0_5B_H           (REG_HDMI3_DUAL_0_BASE + 0xB7)
#define REG_HDMI3_DUAL_0_5C_L           (REG_HDMI3_DUAL_0_BASE + 0xB8)
#define REG_HDMI3_DUAL_0_5C_H           (REG_HDMI3_DUAL_0_BASE + 0xB9)
#define REG_HDMI3_DUAL_0_5D_L           (REG_HDMI3_DUAL_0_BASE + 0xBA)
#define REG_HDMI3_DUAL_0_5D_H           (REG_HDMI3_DUAL_0_BASE + 0xBB)
#define REG_HDMI3_DUAL_0_5E_L           (REG_HDMI3_DUAL_0_BASE + 0xBC)
#define REG_HDMI3_DUAL_0_5E_H           (REG_HDMI3_DUAL_0_BASE + 0xBD)
#define REG_HDMI3_DUAL_0_5F_L           (REG_HDMI3_DUAL_0_BASE + 0xBE)
#define REG_HDMI3_DUAL_0_5F_H           (REG_HDMI3_DUAL_0_BASE + 0xBF)
#define REG_HDMI3_DUAL_0_60_L           (REG_HDMI3_DUAL_0_BASE + 0xC0)
#define REG_HDMI3_DUAL_0_60_H           (REG_HDMI3_DUAL_0_BASE + 0xC1)
#define REG_HDMI3_DUAL_0_61_L           (REG_HDMI3_DUAL_0_BASE + 0xC2)
#define REG_HDMI3_DUAL_0_61_H           (REG_HDMI3_DUAL_0_BASE + 0xC3)
#define REG_HDMI3_DUAL_0_62_L           (REG_HDMI3_DUAL_0_BASE + 0xC4)
#define REG_HDMI3_DUAL_0_62_H           (REG_HDMI3_DUAL_0_BASE + 0xC5)
#define REG_HDMI3_DUAL_0_63_L           (REG_HDMI3_DUAL_0_BASE + 0xC6)
#define REG_HDMI3_DUAL_0_63_H           (REG_HDMI3_DUAL_0_BASE + 0xC7)
#define REG_HDMI3_DUAL_0_64_L           (REG_HDMI3_DUAL_0_BASE + 0xC8)
#define REG_HDMI3_DUAL_0_64_H           (REG_HDMI3_DUAL_0_BASE + 0xC9)
#define REG_HDMI3_DUAL_0_65_L           (REG_HDMI3_DUAL_0_BASE + 0xCA)
#define REG_HDMI3_DUAL_0_65_H           (REG_HDMI3_DUAL_0_BASE + 0xCB)
#define REG_HDMI3_DUAL_0_66_L           (REG_HDMI3_DUAL_0_BASE + 0xCC)
#define REG_HDMI3_DUAL_0_66_H           (REG_HDMI3_DUAL_0_BASE + 0xCD)
#define REG_HDMI3_DUAL_0_67_L           (REG_HDMI3_DUAL_0_BASE + 0xCE)
#define REG_HDMI3_DUAL_0_67_H           (REG_HDMI3_DUAL_0_BASE + 0xCF)
#define REG_HDMI3_DUAL_0_68_L           (REG_HDMI3_DUAL_0_BASE + 0xD0)
#define REG_HDMI3_DUAL_0_68_H           (REG_HDMI3_DUAL_0_BASE + 0xD1)
#define REG_HDMI3_DUAL_0_69_L           (REG_HDMI3_DUAL_0_BASE + 0xD2)
#define REG_HDMI3_DUAL_0_69_H           (REG_HDMI3_DUAL_0_BASE + 0xD3)
#define REG_HDMI3_DUAL_0_6A_L           (REG_HDMI3_DUAL_0_BASE + 0xD4)
#define REG_HDMI3_DUAL_0_6A_H           (REG_HDMI3_DUAL_0_BASE + 0xD5)
#define REG_HDMI3_DUAL_0_6B_L           (REG_HDMI3_DUAL_0_BASE + 0xD6)
#define REG_HDMI3_DUAL_0_6B_H           (REG_HDMI3_DUAL_0_BASE + 0xD7)
#define REG_HDMI3_DUAL_0_6C_L           (REG_HDMI3_DUAL_0_BASE + 0xD8)
#define REG_HDMI3_DUAL_0_6C_H           (REG_HDMI3_DUAL_0_BASE + 0xD9)
#define REG_HDMI3_DUAL_0_6D_L           (REG_HDMI3_DUAL_0_BASE + 0xDA)
#define REG_HDMI3_DUAL_0_6D_H           (REG_HDMI3_DUAL_0_BASE + 0xDB)
#define REG_HDMI3_DUAL_0_6E_L           (REG_HDMI3_DUAL_0_BASE + 0xDC)
#define REG_HDMI3_DUAL_0_6E_H           (REG_HDMI3_DUAL_0_BASE + 0xDD)
#define REG_HDMI3_DUAL_0_6F_L           (REG_HDMI3_DUAL_0_BASE + 0xDE)
#define REG_HDMI3_DUAL_0_6F_H           (REG_HDMI3_DUAL_0_BASE + 0xDF)
#define REG_HDMI3_DUAL_0_70_L           (REG_HDMI3_DUAL_0_BASE + 0xE0)
#define REG_HDMI3_DUAL_0_70_H           (REG_HDMI3_DUAL_0_BASE + 0xE1)
#define REG_HDMI3_DUAL_0_71_L           (REG_HDMI3_DUAL_0_BASE + 0xE2)
#define REG_HDMI3_DUAL_0_71_H           (REG_HDMI3_DUAL_0_BASE + 0xE3)
#define REG_HDMI3_DUAL_0_72_L           (REG_HDMI3_DUAL_0_BASE + 0xE4)
#define REG_HDMI3_DUAL_0_72_H           (REG_HDMI3_DUAL_0_BASE + 0xE5)
#define REG_HDMI3_DUAL_0_73_L           (REG_HDMI3_DUAL_0_BASE + 0xE6)
#define REG_HDMI3_DUAL_0_73_H           (REG_HDMI3_DUAL_0_BASE + 0xE7)
#define REG_HDMI3_DUAL_0_74_L           (REG_HDMI3_DUAL_0_BASE + 0xE8)
#define REG_HDMI3_DUAL_0_74_H           (REG_HDMI3_DUAL_0_BASE + 0xE9)
#define REG_HDMI3_DUAL_0_75_L           (REG_HDMI3_DUAL_0_BASE + 0xEA)
#define REG_HDMI3_DUAL_0_75_H           (REG_HDMI3_DUAL_0_BASE + 0xEB)
#define REG_HDMI3_DUAL_0_76_L           (REG_HDMI3_DUAL_0_BASE + 0xEC)
#define REG_HDMI3_DUAL_0_76_H           (REG_HDMI3_DUAL_0_BASE + 0xED)
#define REG_HDMI3_DUAL_0_77_L           (REG_HDMI3_DUAL_0_BASE + 0xEE)
#define REG_HDMI3_DUAL_0_77_H           (REG_HDMI3_DUAL_0_BASE + 0xEF)
#define REG_HDMI3_DUAL_0_78_L           (REG_HDMI3_DUAL_0_BASE + 0xF0)
#define REG_HDMI3_DUAL_0_78_H           (REG_HDMI3_DUAL_0_BASE + 0xF1)
#define REG_HDMI3_DUAL_0_79_L           (REG_HDMI3_DUAL_0_BASE + 0xF2)
#define REG_HDMI3_DUAL_0_79_H           (REG_HDMI3_DUAL_0_BASE + 0xF3)
#define REG_HDMI3_DUAL_0_7A_L           (REG_HDMI3_DUAL_0_BASE + 0xF4)
#define REG_HDMI3_DUAL_0_7A_H           (REG_HDMI3_DUAL_0_BASE + 0xF5)
#define REG_HDMI3_DUAL_0_7B_L           (REG_HDMI3_DUAL_0_BASE + 0xF6)
#define REG_HDMI3_DUAL_0_7B_H           (REG_HDMI3_DUAL_0_BASE + 0xF7)
#define REG_HDMI3_DUAL_0_7C_L           (REG_HDMI3_DUAL_0_BASE + 0xF8)
#define REG_HDMI3_DUAL_0_7C_H           (REG_HDMI3_DUAL_0_BASE + 0xF9)
#define REG_HDMI3_DUAL_0_7D_L           (REG_HDMI3_DUAL_0_BASE + 0xFA)
#define REG_HDMI3_DUAL_0_7D_H           (REG_HDMI3_DUAL_0_BASE + 0xFB)
#define REG_HDMI3_DUAL_0_7E_L           (REG_HDMI3_DUAL_0_BASE + 0xFC)
#define REG_HDMI3_DUAL_0_7E_H           (REG_HDMI3_DUAL_0_BASE + 0xFD)
#define REG_HDMI3_DUAL_0_7F_L           (REG_HDMI3_DUAL_0_BASE + 0xFE)
#define REG_HDMI3_DUAL_0_7F_H           (REG_HDMI3_DUAL_0_BASE + 0xFF)

//=============================================================
// HDMI_EM_U0
#define REG_HDMI_EM_U0_00_L           (REG_HDMI_EM_U0_BASE + 0x00)
#define REG_HDMI_EM_U0_00_H           (REG_HDMI_EM_U0_BASE + 0x01)
#define REG_HDMI_EM_U0_01_L           (REG_HDMI_EM_U0_BASE + 0x02)
#define REG_HDMI_EM_U0_01_H           (REG_HDMI_EM_U0_BASE + 0x03)
#define REG_HDMI_EM_U0_02_L           (REG_HDMI_EM_U0_BASE + 0x04)
#define REG_HDMI_EM_U0_02_H           (REG_HDMI_EM_U0_BASE + 0x05)
#define REG_HDMI_EM_U0_03_L           (REG_HDMI_EM_U0_BASE + 0x06)
#define REG_HDMI_EM_U0_03_H           (REG_HDMI_EM_U0_BASE + 0x07)
#define REG_HDMI_EM_U0_04_L           (REG_HDMI_EM_U0_BASE + 0x08)
#define REG_HDMI_EM_U0_04_H           (REG_HDMI_EM_U0_BASE + 0x09)
#define REG_HDMI_EM_U0_05_L           (REG_HDMI_EM_U0_BASE + 0x0A)
#define REG_HDMI_EM_U0_05_H           (REG_HDMI_EM_U0_BASE + 0x0B)
#define REG_HDMI_EM_U0_06_L           (REG_HDMI_EM_U0_BASE + 0x0C)
#define REG_HDMI_EM_U0_06_H           (REG_HDMI_EM_U0_BASE + 0x0D)
#define REG_HDMI_EM_U0_07_L           (REG_HDMI_EM_U0_BASE + 0x0E)
#define REG_HDMI_EM_U0_07_H           (REG_HDMI_EM_U0_BASE + 0x0F)
#define REG_HDMI_EM_U0_08_L           (REG_HDMI_EM_U0_BASE + 0x10)
#define REG_HDMI_EM_U0_08_H           (REG_HDMI_EM_U0_BASE + 0x11)
#define REG_HDMI_EM_U0_09_L           (REG_HDMI_EM_U0_BASE + 0x12)
#define REG_HDMI_EM_U0_09_H           (REG_HDMI_EM_U0_BASE + 0x13)
#define REG_HDMI_EM_U0_0A_L           (REG_HDMI_EM_U0_BASE + 0x14)
#define REG_HDMI_EM_U0_0A_H           (REG_HDMI_EM_U0_BASE + 0x15)
#define REG_HDMI_EM_U0_0B_L           (REG_HDMI_EM_U0_BASE + 0x16)
#define REG_HDMI_EM_U0_0B_H           (REG_HDMI_EM_U0_BASE + 0x17)
#define REG_HDMI_EM_U0_0C_L           (REG_HDMI_EM_U0_BASE + 0x18)
#define REG_HDMI_EM_U0_0C_H           (REG_HDMI_EM_U0_BASE + 0x19)
#define REG_HDMI_EM_U0_0D_L           (REG_HDMI_EM_U0_BASE + 0x1A)
#define REG_HDMI_EM_U0_0D_H           (REG_HDMI_EM_U0_BASE + 0x1B)
#define REG_HDMI_EM_U0_0E_L           (REG_HDMI_EM_U0_BASE + 0x1C)
#define REG_HDMI_EM_U0_0E_H           (REG_HDMI_EM_U0_BASE + 0x1D)
#define REG_HDMI_EM_U0_0F_L           (REG_HDMI_EM_U0_BASE + 0x1E)
#define REG_HDMI_EM_U0_0F_H           (REG_HDMI_EM_U0_BASE + 0x1F)
#define REG_HDMI_EM_U0_10_L           (REG_HDMI_EM_U0_BASE + 0x20)
#define REG_HDMI_EM_U0_10_H           (REG_HDMI_EM_U0_BASE + 0x21)
#define REG_HDMI_EM_U0_11_L           (REG_HDMI_EM_U0_BASE + 0x22)
#define REG_HDMI_EM_U0_11_H           (REG_HDMI_EM_U0_BASE + 0x23)
#define REG_HDMI_EM_U0_12_L           (REG_HDMI_EM_U0_BASE + 0x24)
#define REG_HDMI_EM_U0_12_H           (REG_HDMI_EM_U0_BASE + 0x25)
#define REG_HDMI_EM_U0_13_L           (REG_HDMI_EM_U0_BASE + 0x26)
#define REG_HDMI_EM_U0_13_H           (REG_HDMI_EM_U0_BASE + 0x27)
#define REG_HDMI_EM_U0_14_L           (REG_HDMI_EM_U0_BASE + 0x28)
#define REG_HDMI_EM_U0_14_H           (REG_HDMI_EM_U0_BASE + 0x29)
#define REG_HDMI_EM_U0_15_L           (REG_HDMI_EM_U0_BASE + 0x2A)
#define REG_HDMI_EM_U0_15_H           (REG_HDMI_EM_U0_BASE + 0x2B)
#define REG_HDMI_EM_U0_16_L           (REG_HDMI_EM_U0_BASE + 0x2C)
#define REG_HDMI_EM_U0_16_H           (REG_HDMI_EM_U0_BASE + 0x2D)
#define REG_HDMI_EM_U0_17_L           (REG_HDMI_EM_U0_BASE + 0x2E)
#define REG_HDMI_EM_U0_17_H           (REG_HDMI_EM_U0_BASE + 0x2F)
#define REG_HDMI_EM_U0_18_L           (REG_HDMI_EM_U0_BASE + 0x30)
#define REG_HDMI_EM_U0_18_H           (REG_HDMI_EM_U0_BASE + 0x31)
#define REG_HDMI_EM_U0_19_L           (REG_HDMI_EM_U0_BASE + 0x32)
#define REG_HDMI_EM_U0_19_H           (REG_HDMI_EM_U0_BASE + 0x33)
#define REG_HDMI_EM_U0_1A_L           (REG_HDMI_EM_U0_BASE + 0x34)
#define REG_HDMI_EM_U0_1A_H           (REG_HDMI_EM_U0_BASE + 0x35)
#define REG_HDMI_EM_U0_1B_L           (REG_HDMI_EM_U0_BASE + 0x36)
#define REG_HDMI_EM_U0_1B_H           (REG_HDMI_EM_U0_BASE + 0x37)
#define REG_HDMI_EM_U0_1C_L           (REG_HDMI_EM_U0_BASE + 0x38)
#define REG_HDMI_EM_U0_1C_H           (REG_HDMI_EM_U0_BASE + 0x39)
#define REG_HDMI_EM_U0_1D_L           (REG_HDMI_EM_U0_BASE + 0x3A)
#define REG_HDMI_EM_U0_1D_H           (REG_HDMI_EM_U0_BASE + 0x3B)
#define REG_HDMI_EM_U0_1E_L           (REG_HDMI_EM_U0_BASE + 0x3C)
#define REG_HDMI_EM_U0_1E_H           (REG_HDMI_EM_U0_BASE + 0x3D)
#define REG_HDMI_EM_U0_1F_L           (REG_HDMI_EM_U0_BASE + 0x3E)
#define REG_HDMI_EM_U0_1F_H           (REG_HDMI_EM_U0_BASE + 0x3F)
#define REG_HDMI_EM_U0_20_L           (REG_HDMI_EM_U0_BASE + 0x40)
#define REG_HDMI_EM_U0_20_H           (REG_HDMI_EM_U0_BASE + 0x41)
#define REG_HDMI_EM_U0_21_L           (REG_HDMI_EM_U0_BASE + 0x42)
#define REG_HDMI_EM_U0_21_H           (REG_HDMI_EM_U0_BASE + 0x43)
#define REG_HDMI_EM_U0_22_L           (REG_HDMI_EM_U0_BASE + 0x44)
#define REG_HDMI_EM_U0_22_H           (REG_HDMI_EM_U0_BASE + 0x45)
#define REG_HDMI_EM_U0_23_L           (REG_HDMI_EM_U0_BASE + 0x46)
#define REG_HDMI_EM_U0_23_H           (REG_HDMI_EM_U0_BASE + 0x47)
#define REG_HDMI_EM_U0_24_L           (REG_HDMI_EM_U0_BASE + 0x48)
#define REG_HDMI_EM_U0_24_H           (REG_HDMI_EM_U0_BASE + 0x49)
#define REG_HDMI_EM_U0_25_L           (REG_HDMI_EM_U0_BASE + 0x4A)
#define REG_HDMI_EM_U0_25_H           (REG_HDMI_EM_U0_BASE + 0x4B)
#define REG_HDMI_EM_U0_26_L           (REG_HDMI_EM_U0_BASE + 0x4C)
#define REG_HDMI_EM_U0_26_H           (REG_HDMI_EM_U0_BASE + 0x4D)
#define REG_HDMI_EM_U0_27_L           (REG_HDMI_EM_U0_BASE + 0x4E)
#define REG_HDMI_EM_U0_27_H           (REG_HDMI_EM_U0_BASE + 0x4F)
#define REG_HDMI_EM_U0_28_L           (REG_HDMI_EM_U0_BASE + 0x50)
#define REG_HDMI_EM_U0_28_H           (REG_HDMI_EM_U0_BASE + 0x51)
#define REG_HDMI_EM_U0_29_L           (REG_HDMI_EM_U0_BASE + 0x52)
#define REG_HDMI_EM_U0_29_H           (REG_HDMI_EM_U0_BASE + 0x53)
#define REG_HDMI_EM_U0_2A_L           (REG_HDMI_EM_U0_BASE + 0x54)
#define REG_HDMI_EM_U0_2A_H           (REG_HDMI_EM_U0_BASE + 0x55)
#define REG_HDMI_EM_U0_2B_L           (REG_HDMI_EM_U0_BASE + 0x56)
#define REG_HDMI_EM_U0_2B_H           (REG_HDMI_EM_U0_BASE + 0x57)
#define REG_HDMI_EM_U0_2C_L           (REG_HDMI_EM_U0_BASE + 0x58)
#define REG_HDMI_EM_U0_2C_H           (REG_HDMI_EM_U0_BASE + 0x59)
#define REG_HDMI_EM_U0_2D_L           (REG_HDMI_EM_U0_BASE + 0x5A)
#define REG_HDMI_EM_U0_2D_H           (REG_HDMI_EM_U0_BASE + 0x5B)
#define REG_HDMI_EM_U0_2E_L           (REG_HDMI_EM_U0_BASE + 0x5C)
#define REG_HDMI_EM_U0_2E_H           (REG_HDMI_EM_U0_BASE + 0x5D)
#define REG_HDMI_EM_U0_2F_L           (REG_HDMI_EM_U0_BASE + 0x5E)
#define REG_HDMI_EM_U0_2F_H           (REG_HDMI_EM_U0_BASE + 0x5F)
#define REG_HDMI_EM_U0_30_L           (REG_HDMI_EM_U0_BASE + 0x60)
#define REG_HDMI_EM_U0_30_H           (REG_HDMI_EM_U0_BASE + 0x61)
#define REG_HDMI_EM_U0_31_L           (REG_HDMI_EM_U0_BASE + 0x62)
#define REG_HDMI_EM_U0_31_H           (REG_HDMI_EM_U0_BASE + 0x63)
#define REG_HDMI_EM_U0_32_L           (REG_HDMI_EM_U0_BASE + 0x64)
#define REG_HDMI_EM_U0_32_H           (REG_HDMI_EM_U0_BASE + 0x65)
#define REG_HDMI_EM_U0_33_L           (REG_HDMI_EM_U0_BASE + 0x66)
#define REG_HDMI_EM_U0_33_H           (REG_HDMI_EM_U0_BASE + 0x67)
#define REG_HDMI_EM_U0_34_L           (REG_HDMI_EM_U0_BASE + 0x68)
#define REG_HDMI_EM_U0_34_H           (REG_HDMI_EM_U0_BASE + 0x69)
#define REG_HDMI_EM_U0_35_L           (REG_HDMI_EM_U0_BASE + 0x6A)
#define REG_HDMI_EM_U0_35_H           (REG_HDMI_EM_U0_BASE + 0x6B)
#define REG_HDMI_EM_U0_36_L           (REG_HDMI_EM_U0_BASE + 0x6C)
#define REG_HDMI_EM_U0_36_H           (REG_HDMI_EM_U0_BASE + 0x6D)
#define REG_HDMI_EM_U0_37_L           (REG_HDMI_EM_U0_BASE + 0x6E)
#define REG_HDMI_EM_U0_37_H           (REG_HDMI_EM_U0_BASE + 0x6F)
#define REG_HDMI_EM_U0_38_L           (REG_HDMI_EM_U0_BASE + 0x70)
#define REG_HDMI_EM_U0_38_H           (REG_HDMI_EM_U0_BASE + 0x71)
#define REG_HDMI_EM_U0_39_L           (REG_HDMI_EM_U0_BASE + 0x72)
#define REG_HDMI_EM_U0_39_H           (REG_HDMI_EM_U0_BASE + 0x73)
#define REG_HDMI_EM_U0_3A_L           (REG_HDMI_EM_U0_BASE + 0x74)
#define REG_HDMI_EM_U0_3A_H           (REG_HDMI_EM_U0_BASE + 0x75)
#define REG_HDMI_EM_U0_3B_L           (REG_HDMI_EM_U0_BASE + 0x76)
#define REG_HDMI_EM_U0_3B_H           (REG_HDMI_EM_U0_BASE + 0x77)
#define REG_HDMI_EM_U0_3C_L           (REG_HDMI_EM_U0_BASE + 0x78)
#define REG_HDMI_EM_U0_3C_H           (REG_HDMI_EM_U0_BASE + 0x79)
#define REG_HDMI_EM_U0_3D_L           (REG_HDMI_EM_U0_BASE + 0x7A)
#define REG_HDMI_EM_U0_3D_H           (REG_HDMI_EM_U0_BASE + 0x7B)
#define REG_HDMI_EM_U0_3E_L           (REG_HDMI_EM_U0_BASE + 0x7C)
#define REG_HDMI_EM_U0_3E_H           (REG_HDMI_EM_U0_BASE + 0x7D)
#define REG_HDMI_EM_U0_3F_L           (REG_HDMI_EM_U0_BASE + 0x7E)
#define REG_HDMI_EM_U0_3F_H           (REG_HDMI_EM_U0_BASE + 0x7F)
#define REG_HDMI_EM_U0_40_L           (REG_HDMI_EM_U0_BASE + 0x80)
#define REG_HDMI_EM_U0_40_H           (REG_HDMI_EM_U0_BASE + 0x81)
#define REG_HDMI_EM_U0_41_L           (REG_HDMI_EM_U0_BASE + 0x82)
#define REG_HDMI_EM_U0_41_H           (REG_HDMI_EM_U0_BASE + 0x83)
#define REG_HDMI_EM_U0_42_L           (REG_HDMI_EM_U0_BASE + 0x84)
#define REG_HDMI_EM_U0_42_H           (REG_HDMI_EM_U0_BASE + 0x85)
#define REG_HDMI_EM_U0_43_L           (REG_HDMI_EM_U0_BASE + 0x86)
#define REG_HDMI_EM_U0_43_H           (REG_HDMI_EM_U0_BASE + 0x87)
#define REG_HDMI_EM_U0_44_L           (REG_HDMI_EM_U0_BASE + 0x88)
#define REG_HDMI_EM_U0_44_H           (REG_HDMI_EM_U0_BASE + 0x89)
#define REG_HDMI_EM_U0_45_L           (REG_HDMI_EM_U0_BASE + 0x8A)
#define REG_HDMI_EM_U0_45_H           (REG_HDMI_EM_U0_BASE + 0x8B)
#define REG_HDMI_EM_U0_46_L           (REG_HDMI_EM_U0_BASE + 0x8C)
#define REG_HDMI_EM_U0_46_H           (REG_HDMI_EM_U0_BASE + 0x8D)
#define REG_HDMI_EM_U0_47_L           (REG_HDMI_EM_U0_BASE + 0x8E)
#define REG_HDMI_EM_U0_47_H           (REG_HDMI_EM_U0_BASE + 0x8F)
#define REG_HDMI_EM_U0_48_L           (REG_HDMI_EM_U0_BASE + 0x90)
#define REG_HDMI_EM_U0_48_H           (REG_HDMI_EM_U0_BASE + 0x91)
#define REG_HDMI_EM_U0_49_L           (REG_HDMI_EM_U0_BASE + 0x92)
#define REG_HDMI_EM_U0_49_H           (REG_HDMI_EM_U0_BASE + 0x93)
#define REG_HDMI_EM_U0_4A_L           (REG_HDMI_EM_U0_BASE + 0x94)
#define REG_HDMI_EM_U0_4A_H           (REG_HDMI_EM_U0_BASE + 0x95)
#define REG_HDMI_EM_U0_4B_L           (REG_HDMI_EM_U0_BASE + 0x96)
#define REG_HDMI_EM_U0_4B_H           (REG_HDMI_EM_U0_BASE + 0x97)
#define REG_HDMI_EM_U0_4C_L           (REG_HDMI_EM_U0_BASE + 0x98)
#define REG_HDMI_EM_U0_4C_H           (REG_HDMI_EM_U0_BASE + 0x99)
#define REG_HDMI_EM_U0_4D_L           (REG_HDMI_EM_U0_BASE + 0x9A)
#define REG_HDMI_EM_U0_4D_H           (REG_HDMI_EM_U0_BASE + 0x9B)
#define REG_HDMI_EM_U0_4E_L           (REG_HDMI_EM_U0_BASE + 0x9C)
#define REG_HDMI_EM_U0_4E_H           (REG_HDMI_EM_U0_BASE + 0x9D)
#define REG_HDMI_EM_U0_4F_L           (REG_HDMI_EM_U0_BASE + 0x9E)
#define REG_HDMI_EM_U0_4F_H           (REG_HDMI_EM_U0_BASE + 0x9F)
#define REG_HDMI_EM_U0_50_L           (REG_HDMI_EM_U0_BASE + 0xA0)
#define REG_HDMI_EM_U0_50_H           (REG_HDMI_EM_U0_BASE + 0xA1)
#define REG_HDMI_EM_U0_51_L           (REG_HDMI_EM_U0_BASE + 0xA2)
#define REG_HDMI_EM_U0_51_H           (REG_HDMI_EM_U0_BASE + 0xA3)
#define REG_HDMI_EM_U0_52_L           (REG_HDMI_EM_U0_BASE + 0xA4)
#define REG_HDMI_EM_U0_52_H           (REG_HDMI_EM_U0_BASE + 0xA5)
#define REG_HDMI_EM_U0_53_L           (REG_HDMI_EM_U0_BASE + 0xA6)
#define REG_HDMI_EM_U0_53_H           (REG_HDMI_EM_U0_BASE + 0xA7)
#define REG_HDMI_EM_U0_54_L           (REG_HDMI_EM_U0_BASE + 0xA8)
#define REG_HDMI_EM_U0_54_H           (REG_HDMI_EM_U0_BASE + 0xA9)
#define REG_HDMI_EM_U0_55_L           (REG_HDMI_EM_U0_BASE + 0xAA)
#define REG_HDMI_EM_U0_55_H           (REG_HDMI_EM_U0_BASE + 0xAB)
#define REG_HDMI_EM_U0_56_L           (REG_HDMI_EM_U0_BASE + 0xAC)
#define REG_HDMI_EM_U0_56_H           (REG_HDMI_EM_U0_BASE + 0xAD)
#define REG_HDMI_EM_U0_57_L           (REG_HDMI_EM_U0_BASE + 0xAE)
#define REG_HDMI_EM_U0_57_H           (REG_HDMI_EM_U0_BASE + 0xAF)
#define REG_HDMI_EM_U0_58_L           (REG_HDMI_EM_U0_BASE + 0xB0)
#define REG_HDMI_EM_U0_58_H           (REG_HDMI_EM_U0_BASE + 0xB1)
#define REG_HDMI_EM_U0_59_L           (REG_HDMI_EM_U0_BASE + 0xB2)
#define REG_HDMI_EM_U0_59_H           (REG_HDMI_EM_U0_BASE + 0xB3)
#define REG_HDMI_EM_U0_5A_L           (REG_HDMI_EM_U0_BASE + 0xB4)
#define REG_HDMI_EM_U0_5A_H           (REG_HDMI_EM_U0_BASE + 0xB5)
#define REG_HDMI_EM_U0_5B_L           (REG_HDMI_EM_U0_BASE + 0xB6)
#define REG_HDMI_EM_U0_5B_H           (REG_HDMI_EM_U0_BASE + 0xB7)
#define REG_HDMI_EM_U0_5C_L           (REG_HDMI_EM_U0_BASE + 0xB8)
#define REG_HDMI_EM_U0_5C_H           (REG_HDMI_EM_U0_BASE + 0xB9)
#define REG_HDMI_EM_U0_5D_L           (REG_HDMI_EM_U0_BASE + 0xBA)
#define REG_HDMI_EM_U0_5D_H           (REG_HDMI_EM_U0_BASE + 0xBB)
#define REG_HDMI_EM_U0_5E_L           (REG_HDMI_EM_U0_BASE + 0xBC)
#define REG_HDMI_EM_U0_5E_H           (REG_HDMI_EM_U0_BASE + 0xBD)
#define REG_HDMI_EM_U0_5F_L           (REG_HDMI_EM_U0_BASE + 0xBE)
#define REG_HDMI_EM_U0_5F_H           (REG_HDMI_EM_U0_BASE + 0xBF)
#define REG_HDMI_EM_U0_60_L           (REG_HDMI_EM_U0_BASE + 0xC0)
#define REG_HDMI_EM_U0_60_H           (REG_HDMI_EM_U0_BASE + 0xC1)
#define REG_HDMI_EM_U0_61_L           (REG_HDMI_EM_U0_BASE + 0xC2)
#define REG_HDMI_EM_U0_61_H           (REG_HDMI_EM_U0_BASE + 0xC3)
#define REG_HDMI_EM_U0_62_L           (REG_HDMI_EM_U0_BASE + 0xC4)
#define REG_HDMI_EM_U0_62_H           (REG_HDMI_EM_U0_BASE + 0xC5)
#define REG_HDMI_EM_U0_63_L           (REG_HDMI_EM_U0_BASE + 0xC6)
#define REG_HDMI_EM_U0_63_H           (REG_HDMI_EM_U0_BASE + 0xC7)
#define REG_HDMI_EM_U0_64_L           (REG_HDMI_EM_U0_BASE + 0xC8)
#define REG_HDMI_EM_U0_64_H           (REG_HDMI_EM_U0_BASE + 0xC9)
#define REG_HDMI_EM_U0_65_L           (REG_HDMI_EM_U0_BASE + 0xCA)
#define REG_HDMI_EM_U0_65_H           (REG_HDMI_EM_U0_BASE + 0xCB)
#define REG_HDMI_EM_U0_66_L           (REG_HDMI_EM_U0_BASE + 0xCC)
#define REG_HDMI_EM_U0_66_H           (REG_HDMI_EM_U0_BASE + 0xCD)
#define REG_HDMI_EM_U0_67_L           (REG_HDMI_EM_U0_BASE + 0xCE)
#define REG_HDMI_EM_U0_67_H           (REG_HDMI_EM_U0_BASE + 0xCF)
#define REG_HDMI_EM_U0_68_L           (REG_HDMI_EM_U0_BASE + 0xD0)
#define REG_HDMI_EM_U0_68_H           (REG_HDMI_EM_U0_BASE + 0xD1)
#define REG_HDMI_EM_U0_69_L           (REG_HDMI_EM_U0_BASE + 0xD2)
#define REG_HDMI_EM_U0_69_H           (REG_HDMI_EM_U0_BASE + 0xD3)
#define REG_HDMI_EM_U0_6A_L           (REG_HDMI_EM_U0_BASE + 0xD4)
#define REG_HDMI_EM_U0_6A_H           (REG_HDMI_EM_U0_BASE + 0xD5)
#define REG_HDMI_EM_U0_6B_L           (REG_HDMI_EM_U0_BASE + 0xD6)
#define REG_HDMI_EM_U0_6B_H           (REG_HDMI_EM_U0_BASE + 0xD7)
#define REG_HDMI_EM_U0_6C_L           (REG_HDMI_EM_U0_BASE + 0xD8)
#define REG_HDMI_EM_U0_6C_H           (REG_HDMI_EM_U0_BASE + 0xD9)
#define REG_HDMI_EM_U0_6D_L           (REG_HDMI_EM_U0_BASE + 0xDA)
#define REG_HDMI_EM_U0_6D_H           (REG_HDMI_EM_U0_BASE + 0xDB)
#define REG_HDMI_EM_U0_6E_L           (REG_HDMI_EM_U0_BASE + 0xDC)
#define REG_HDMI_EM_U0_6E_H           (REG_HDMI_EM_U0_BASE + 0xDD)
#define REG_HDMI_EM_U0_6F_L           (REG_HDMI_EM_U0_BASE + 0xDE)
#define REG_HDMI_EM_U0_6F_H           (REG_HDMI_EM_U0_BASE + 0xDF)
#define REG_HDMI_EM_U0_70_L           (REG_HDMI_EM_U0_BASE + 0xE0)
#define REG_HDMI_EM_U0_70_H           (REG_HDMI_EM_U0_BASE + 0xE1)
#define REG_HDMI_EM_U0_71_L           (REG_HDMI_EM_U0_BASE + 0xE2)
#define REG_HDMI_EM_U0_71_H           (REG_HDMI_EM_U0_BASE + 0xE3)
#define REG_HDMI_EM_U0_72_L           (REG_HDMI_EM_U0_BASE + 0xE4)
#define REG_HDMI_EM_U0_72_H           (REG_HDMI_EM_U0_BASE + 0xE5)
#define REG_HDMI_EM_U0_73_L           (REG_HDMI_EM_U0_BASE + 0xE6)
#define REG_HDMI_EM_U0_73_H           (REG_HDMI_EM_U0_BASE + 0xE7)
#define REG_HDMI_EM_U0_74_L           (REG_HDMI_EM_U0_BASE + 0xE8)
#define REG_HDMI_EM_U0_74_H           (REG_HDMI_EM_U0_BASE + 0xE9)
#define REG_HDMI_EM_U0_75_L           (REG_HDMI_EM_U0_BASE + 0xEA)
#define REG_HDMI_EM_U0_75_H           (REG_HDMI_EM_U0_BASE + 0xEB)
#define REG_HDMI_EM_U0_76_L           (REG_HDMI_EM_U0_BASE + 0xEC)
#define REG_HDMI_EM_U0_76_H           (REG_HDMI_EM_U0_BASE + 0xED)
#define REG_HDMI_EM_U0_77_L           (REG_HDMI_EM_U0_BASE + 0xEE)
#define REG_HDMI_EM_U0_77_H           (REG_HDMI_EM_U0_BASE + 0xEF)
#define REG_HDMI_EM_U0_78_L           (REG_HDMI_EM_U0_BASE + 0xF0)
#define REG_HDMI_EM_U0_78_H           (REG_HDMI_EM_U0_BASE + 0xF1)
#define REG_HDMI_EM_U0_79_L           (REG_HDMI_EM_U0_BASE + 0xF2)
#define REG_HDMI_EM_U0_79_H           (REG_HDMI_EM_U0_BASE + 0xF3)
#define REG_HDMI_EM_U0_7A_L           (REG_HDMI_EM_U0_BASE + 0xF4)
#define REG_HDMI_EM_U0_7A_H           (REG_HDMI_EM_U0_BASE + 0xF5)
#define REG_HDMI_EM_U0_7B_L           (REG_HDMI_EM_U0_BASE + 0xF6)
#define REG_HDMI_EM_U0_7B_H           (REG_HDMI_EM_U0_BASE + 0xF7)
#define REG_HDMI_EM_U0_7C_L           (REG_HDMI_EM_U0_BASE + 0xF8)
#define REG_HDMI_EM_U0_7C_H           (REG_HDMI_EM_U0_BASE + 0xF9)
#define REG_HDMI_EM_U0_7D_L           (REG_HDMI_EM_U0_BASE + 0xFA)
#define REG_HDMI_EM_U0_7D_H           (REG_HDMI_EM_U0_BASE + 0xFB)
#define REG_HDMI_EM_U0_7E_L           (REG_HDMI_EM_U0_BASE + 0xFC)
#define REG_HDMI_EM_U0_7E_H           (REG_HDMI_EM_U0_BASE + 0xFD)
#define REG_HDMI_EM_U0_7F_L           (REG_HDMI_EM_U0_BASE + 0xFE)
#define REG_HDMI_EM_U0_7F_H           (REG_HDMI_EM_U0_BASE + 0xFF)

//=============================================================
// COMBO_GP_TOP
#define REG_COMBO_GP_TOP_00_L       (REG_COMBO_GP_TOP_BASE + 0x00)
#define REG_COMBO_GP_TOP_00_H       (REG_COMBO_GP_TOP_BASE + 0x01)
#define REG_COMBO_GP_TOP_01_L       (REG_COMBO_GP_TOP_BASE + 0x02)
#define REG_COMBO_GP_TOP_01_H       (REG_COMBO_GP_TOP_BASE + 0x03)
#define REG_COMBO_GP_TOP_02_L       (REG_COMBO_GP_TOP_BASE + 0x04)
#define REG_COMBO_GP_TOP_02_H       (REG_COMBO_GP_TOP_BASE + 0x05)
#define REG_COMBO_GP_TOP_03_L       (REG_COMBO_GP_TOP_BASE + 0x06)
#define REG_COMBO_GP_TOP_03_H       (REG_COMBO_GP_TOP_BASE + 0x07)
#define REG_COMBO_GP_TOP_04_L       (REG_COMBO_GP_TOP_BASE + 0x08)
#define REG_COMBO_GP_TOP_04_H       (REG_COMBO_GP_TOP_BASE + 0x09)
#define REG_COMBO_GP_TOP_05_L       (REG_COMBO_GP_TOP_BASE + 0x0A)
#define REG_COMBO_GP_TOP_05_H       (REG_COMBO_GP_TOP_BASE + 0x0B)
#define REG_COMBO_GP_TOP_06_L       (REG_COMBO_GP_TOP_BASE + 0x0C)
#define REG_COMBO_GP_TOP_06_H       (REG_COMBO_GP_TOP_BASE + 0x0D)
#define REG_COMBO_GP_TOP_07_L       (REG_COMBO_GP_TOP_BASE + 0x0E)
#define REG_COMBO_GP_TOP_07_H       (REG_COMBO_GP_TOP_BASE + 0x0F)
#define REG_COMBO_GP_TOP_08_L       (REG_COMBO_GP_TOP_BASE + 0x10)
#define REG_COMBO_GP_TOP_08_H       (REG_COMBO_GP_TOP_BASE + 0x11)
#define REG_COMBO_GP_TOP_09_L       (REG_COMBO_GP_TOP_BASE + 0x12)
#define REG_COMBO_GP_TOP_09_H       (REG_COMBO_GP_TOP_BASE + 0x13)
#define REG_COMBO_GP_TOP_0A_L       (REG_COMBO_GP_TOP_BASE + 0x14)
#define REG_COMBO_GP_TOP_0A_H       (REG_COMBO_GP_TOP_BASE + 0x15)
#define REG_COMBO_GP_TOP_0B_L       (REG_COMBO_GP_TOP_BASE + 0x16)
#define REG_COMBO_GP_TOP_0B_H       (REG_COMBO_GP_TOP_BASE + 0x17)
#define REG_COMBO_GP_TOP_0C_L       (REG_COMBO_GP_TOP_BASE + 0x18)
#define REG_COMBO_GP_TOP_0C_H       (REG_COMBO_GP_TOP_BASE + 0x19)
#define REG_COMBO_GP_TOP_0D_L       (REG_COMBO_GP_TOP_BASE + 0x1A)
#define REG_COMBO_GP_TOP_0D_H       (REG_COMBO_GP_TOP_BASE + 0x1B)
#define REG_COMBO_GP_TOP_0E_L       (REG_COMBO_GP_TOP_BASE + 0x1C)
#define REG_COMBO_GP_TOP_0E_H       (REG_COMBO_GP_TOP_BASE + 0x1D)
#define REG_COMBO_GP_TOP_0F_L       (REG_COMBO_GP_TOP_BASE + 0x1E)
#define REG_COMBO_GP_TOP_0F_H       (REG_COMBO_GP_TOP_BASE + 0x1F)
#define REG_COMBO_GP_TOP_10_L       (REG_COMBO_GP_TOP_BASE + 0x20)
#define REG_COMBO_GP_TOP_10_H       (REG_COMBO_GP_TOP_BASE + 0x21)
#define REG_COMBO_GP_TOP_11_L       (REG_COMBO_GP_TOP_BASE + 0x22)
#define REG_COMBO_GP_TOP_11_H       (REG_COMBO_GP_TOP_BASE + 0x23)
#define REG_COMBO_GP_TOP_12_L       (REG_COMBO_GP_TOP_BASE + 0x24)
#define REG_COMBO_GP_TOP_12_H       (REG_COMBO_GP_TOP_BASE + 0x25)
#define REG_COMBO_GP_TOP_13_L       (REG_COMBO_GP_TOP_BASE + 0x26)
#define REG_COMBO_GP_TOP_13_H       (REG_COMBO_GP_TOP_BASE + 0x27)
#define REG_COMBO_GP_TOP_14_L       (REG_COMBO_GP_TOP_BASE + 0x28)
#define REG_COMBO_GP_TOP_14_H       (REG_COMBO_GP_TOP_BASE + 0x29)
#define REG_COMBO_GP_TOP_15_L       (REG_COMBO_GP_TOP_BASE + 0x2A)
#define REG_COMBO_GP_TOP_15_H       (REG_COMBO_GP_TOP_BASE + 0x2B)
#define REG_COMBO_GP_TOP_16_L       (REG_COMBO_GP_TOP_BASE + 0x2C)
#define REG_COMBO_GP_TOP_16_H       (REG_COMBO_GP_TOP_BASE + 0x2D)
#define REG_COMBO_GP_TOP_17_L       (REG_COMBO_GP_TOP_BASE + 0x2E)
#define REG_COMBO_GP_TOP_17_H       (REG_COMBO_GP_TOP_BASE + 0x2F)
#define REG_COMBO_GP_TOP_18_L       (REG_COMBO_GP_TOP_BASE + 0x30)
#define REG_COMBO_GP_TOP_18_H       (REG_COMBO_GP_TOP_BASE + 0x31)
#define REG_COMBO_GP_TOP_19_L       (REG_COMBO_GP_TOP_BASE + 0x32)
#define REG_COMBO_GP_TOP_19_H       (REG_COMBO_GP_TOP_BASE + 0x33)
#define REG_COMBO_GP_TOP_1A_L       (REG_COMBO_GP_TOP_BASE + 0x34)
#define REG_COMBO_GP_TOP_1A_H       (REG_COMBO_GP_TOP_BASE + 0x35)
#define REG_COMBO_GP_TOP_1B_L       (REG_COMBO_GP_TOP_BASE + 0x36)
#define REG_COMBO_GP_TOP_1B_H       (REG_COMBO_GP_TOP_BASE + 0x37)
#define REG_COMBO_GP_TOP_1C_L       (REG_COMBO_GP_TOP_BASE + 0x38)
#define REG_COMBO_GP_TOP_1C_H       (REG_COMBO_GP_TOP_BASE + 0x39)
#define REG_COMBO_GP_TOP_1D_L       (REG_COMBO_GP_TOP_BASE + 0x3A)
#define REG_COMBO_GP_TOP_1D_H       (REG_COMBO_GP_TOP_BASE + 0x3B)
#define REG_COMBO_GP_TOP_1E_L       (REG_COMBO_GP_TOP_BASE + 0x3C)
#define REG_COMBO_GP_TOP_1E_H       (REG_COMBO_GP_TOP_BASE + 0x3D)
#define REG_COMBO_GP_TOP_1F_L       (REG_COMBO_GP_TOP_BASE + 0x3E)
#define REG_COMBO_GP_TOP_1F_H       (REG_COMBO_GP_TOP_BASE + 0x3F)
#define REG_COMBO_GP_TOP_20_L       (REG_COMBO_GP_TOP_BASE + 0x40)
#define REG_COMBO_GP_TOP_20_H       (REG_COMBO_GP_TOP_BASE + 0x41)
#define REG_COMBO_GP_TOP_21_L       (REG_COMBO_GP_TOP_BASE + 0x42)
#define REG_COMBO_GP_TOP_21_H       (REG_COMBO_GP_TOP_BASE + 0x43)
#define REG_COMBO_GP_TOP_22_L       (REG_COMBO_GP_TOP_BASE + 0x44)
#define REG_COMBO_GP_TOP_22_H       (REG_COMBO_GP_TOP_BASE + 0x45)
#define REG_COMBO_GP_TOP_23_L       (REG_COMBO_GP_TOP_BASE + 0x46)
#define REG_COMBO_GP_TOP_23_H       (REG_COMBO_GP_TOP_BASE + 0x47)
#define REG_COMBO_GP_TOP_24_L       (REG_COMBO_GP_TOP_BASE + 0x48)
#define REG_COMBO_GP_TOP_24_H       (REG_COMBO_GP_TOP_BASE + 0x49)
#define REG_COMBO_GP_TOP_25_L       (REG_COMBO_GP_TOP_BASE + 0x4A)
#define REG_COMBO_GP_TOP_25_H       (REG_COMBO_GP_TOP_BASE + 0x4B)
#define REG_COMBO_GP_TOP_26_L       (REG_COMBO_GP_TOP_BASE + 0x4C)
#define REG_COMBO_GP_TOP_26_H       (REG_COMBO_GP_TOP_BASE + 0x4D)
#define REG_COMBO_GP_TOP_27_L       (REG_COMBO_GP_TOP_BASE + 0x4E)
#define REG_COMBO_GP_TOP_27_H       (REG_COMBO_GP_TOP_BASE + 0x4F)
#define REG_COMBO_GP_TOP_28_L       (REG_COMBO_GP_TOP_BASE + 0x50)
#define REG_COMBO_GP_TOP_28_H       (REG_COMBO_GP_TOP_BASE + 0x51)
#define REG_COMBO_GP_TOP_29_L       (REG_COMBO_GP_TOP_BASE + 0x52)
#define REG_COMBO_GP_TOP_29_H       (REG_COMBO_GP_TOP_BASE + 0x53)
#define REG_COMBO_GP_TOP_2A_L       (REG_COMBO_GP_TOP_BASE + 0x54)
#define REG_COMBO_GP_TOP_2A_H       (REG_COMBO_GP_TOP_BASE + 0x55)
#define REG_COMBO_GP_TOP_2B_L       (REG_COMBO_GP_TOP_BASE + 0x56)
#define REG_COMBO_GP_TOP_2B_H       (REG_COMBO_GP_TOP_BASE + 0x57)
#define REG_COMBO_GP_TOP_2C_L       (REG_COMBO_GP_TOP_BASE + 0x58)
#define REG_COMBO_GP_TOP_2C_H       (REG_COMBO_GP_TOP_BASE + 0x59)
#define REG_COMBO_GP_TOP_2D_L       (REG_COMBO_GP_TOP_BASE + 0x5A)
#define REG_COMBO_GP_TOP_2D_H       (REG_COMBO_GP_TOP_BASE + 0x5B)
#define REG_COMBO_GP_TOP_2E_L       (REG_COMBO_GP_TOP_BASE + 0x5C)
#define REG_COMBO_GP_TOP_2E_H       (REG_COMBO_GP_TOP_BASE + 0x5D)
#define REG_COMBO_GP_TOP_2F_L       (REG_COMBO_GP_TOP_BASE + 0x5E)
#define REG_COMBO_GP_TOP_2F_H       (REG_COMBO_GP_TOP_BASE + 0x5F)
#define REG_COMBO_GP_TOP_30_L       (REG_COMBO_GP_TOP_BASE + 0x60)
#define REG_COMBO_GP_TOP_30_H       (REG_COMBO_GP_TOP_BASE + 0x61)
#define REG_COMBO_GP_TOP_31_L       (REG_COMBO_GP_TOP_BASE + 0x62)
#define REG_COMBO_GP_TOP_31_H       (REG_COMBO_GP_TOP_BASE + 0x63)
#define REG_COMBO_GP_TOP_32_L       (REG_COMBO_GP_TOP_BASE + 0x64)
#define REG_COMBO_GP_TOP_32_H       (REG_COMBO_GP_TOP_BASE + 0x65)
#define REG_COMBO_GP_TOP_33_L       (REG_COMBO_GP_TOP_BASE + 0x66)
#define REG_COMBO_GP_TOP_33_H       (REG_COMBO_GP_TOP_BASE + 0x67)
#define REG_COMBO_GP_TOP_34_L       (REG_COMBO_GP_TOP_BASE + 0x68)
#define REG_COMBO_GP_TOP_34_H       (REG_COMBO_GP_TOP_BASE + 0x69)
#define REG_COMBO_GP_TOP_35_L       (REG_COMBO_GP_TOP_BASE + 0x6A)
#define REG_COMBO_GP_TOP_35_H       (REG_COMBO_GP_TOP_BASE + 0x6B)
#define REG_COMBO_GP_TOP_36_L       (REG_COMBO_GP_TOP_BASE + 0x6C)
#define REG_COMBO_GP_TOP_36_H       (REG_COMBO_GP_TOP_BASE + 0x6D)
#define REG_COMBO_GP_TOP_37_L       (REG_COMBO_GP_TOP_BASE + 0x6E)
#define REG_COMBO_GP_TOP_37_H       (REG_COMBO_GP_TOP_BASE + 0x6F)
#define REG_COMBO_GP_TOP_38_L       (REG_COMBO_GP_TOP_BASE + 0x70)
#define REG_COMBO_GP_TOP_38_H       (REG_COMBO_GP_TOP_BASE + 0x71)
#define REG_COMBO_GP_TOP_39_L       (REG_COMBO_GP_TOP_BASE + 0x72)
#define REG_COMBO_GP_TOP_39_H       (REG_COMBO_GP_TOP_BASE + 0x73)
#define REG_COMBO_GP_TOP_3A_L       (REG_COMBO_GP_TOP_BASE + 0x74)
#define REG_COMBO_GP_TOP_3A_H       (REG_COMBO_GP_TOP_BASE + 0x75)
#define REG_COMBO_GP_TOP_3B_L       (REG_COMBO_GP_TOP_BASE + 0x76)
#define REG_COMBO_GP_TOP_3B_H       (REG_COMBO_GP_TOP_BASE + 0x77)
#define REG_COMBO_GP_TOP_3C_L       (REG_COMBO_GP_TOP_BASE + 0x78)
#define REG_COMBO_GP_TOP_3C_H       (REG_COMBO_GP_TOP_BASE + 0x79)
#define REG_COMBO_GP_TOP_3D_L       (REG_COMBO_GP_TOP_BASE + 0x7A)
#define REG_COMBO_GP_TOP_3D_H       (REG_COMBO_GP_TOP_BASE + 0x7B)
#define REG_COMBO_GP_TOP_3E_L       (REG_COMBO_GP_TOP_BASE + 0x7C)
#define REG_COMBO_GP_TOP_3E_H       (REG_COMBO_GP_TOP_BASE + 0x7D)
#define REG_COMBO_GP_TOP_3F_L       (REG_COMBO_GP_TOP_BASE + 0x7E)
#define REG_COMBO_GP_TOP_3F_H       (REG_COMBO_GP_TOP_BASE + 0x7F)
#define REG_COMBO_GP_TOP_40_L       (REG_COMBO_GP_TOP_BASE + 0x80)
#define REG_COMBO_GP_TOP_40_H       (REG_COMBO_GP_TOP_BASE + 0x81)
#define REG_COMBO_GP_TOP_41_L       (REG_COMBO_GP_TOP_BASE + 0x82)
#define REG_COMBO_GP_TOP_41_H       (REG_COMBO_GP_TOP_BASE + 0x83)
#define REG_COMBO_GP_TOP_42_L       (REG_COMBO_GP_TOP_BASE + 0x84)
#define REG_COMBO_GP_TOP_42_H       (REG_COMBO_GP_TOP_BASE + 0x85)
#define REG_COMBO_GP_TOP_43_L       (REG_COMBO_GP_TOP_BASE + 0x86)
#define REG_COMBO_GP_TOP_43_H       (REG_COMBO_GP_TOP_BASE + 0x87)
#define REG_COMBO_GP_TOP_44_L       (REG_COMBO_GP_TOP_BASE + 0x88)
#define REG_COMBO_GP_TOP_44_H       (REG_COMBO_GP_TOP_BASE + 0x89)
#define REG_COMBO_GP_TOP_45_L       (REG_COMBO_GP_TOP_BASE + 0x8A)
#define REG_COMBO_GP_TOP_45_H       (REG_COMBO_GP_TOP_BASE + 0x8B)
#define REG_COMBO_GP_TOP_46_L       (REG_COMBO_GP_TOP_BASE + 0x8C)
#define REG_COMBO_GP_TOP_46_H       (REG_COMBO_GP_TOP_BASE + 0x8D)
#define REG_COMBO_GP_TOP_47_L       (REG_COMBO_GP_TOP_BASE + 0x8E)
#define REG_COMBO_GP_TOP_47_H       (REG_COMBO_GP_TOP_BASE + 0x8F)
#define REG_COMBO_GP_TOP_48_L       (REG_COMBO_GP_TOP_BASE + 0x90)
#define REG_COMBO_GP_TOP_48_H       (REG_COMBO_GP_TOP_BASE + 0x91)
#define REG_COMBO_GP_TOP_49_L       (REG_COMBO_GP_TOP_BASE + 0x92)
#define REG_COMBO_GP_TOP_49_H       (REG_COMBO_GP_TOP_BASE + 0x93)
#define REG_COMBO_GP_TOP_4A_L       (REG_COMBO_GP_TOP_BASE + 0x94)
#define REG_COMBO_GP_TOP_4A_H       (REG_COMBO_GP_TOP_BASE + 0x95)
#define REG_COMBO_GP_TOP_4B_L       (REG_COMBO_GP_TOP_BASE + 0x96)
#define REG_COMBO_GP_TOP_4B_H       (REG_COMBO_GP_TOP_BASE + 0x97)
#define REG_COMBO_GP_TOP_4C_L       (REG_COMBO_GP_TOP_BASE + 0x98)
#define REG_COMBO_GP_TOP_4C_H       (REG_COMBO_GP_TOP_BASE + 0x99)
#define REG_COMBO_GP_TOP_4D_L       (REG_COMBO_GP_TOP_BASE + 0x9A)
#define REG_COMBO_GP_TOP_4D_H       (REG_COMBO_GP_TOP_BASE + 0x9B)
#define REG_COMBO_GP_TOP_4E_L       (REG_COMBO_GP_TOP_BASE + 0x9C)
#define REG_COMBO_GP_TOP_4E_H       (REG_COMBO_GP_TOP_BASE + 0x9D)
#define REG_COMBO_GP_TOP_4F_L       (REG_COMBO_GP_TOP_BASE + 0x9E)
#define REG_COMBO_GP_TOP_4F_H       (REG_COMBO_GP_TOP_BASE + 0x9F)
#define REG_COMBO_GP_TOP_50_L       (REG_COMBO_GP_TOP_BASE + 0xA0)
#define REG_COMBO_GP_TOP_50_H       (REG_COMBO_GP_TOP_BASE + 0xA1)
#define REG_COMBO_GP_TOP_51_L       (REG_COMBO_GP_TOP_BASE + 0xA2)
#define REG_COMBO_GP_TOP_51_H       (REG_COMBO_GP_TOP_BASE + 0xA3)
#define REG_COMBO_GP_TOP_52_L       (REG_COMBO_GP_TOP_BASE + 0xA4)
#define REG_COMBO_GP_TOP_52_H       (REG_COMBO_GP_TOP_BASE + 0xA5)
#define REG_COMBO_GP_TOP_53_L       (REG_COMBO_GP_TOP_BASE + 0xA6)
#define REG_COMBO_GP_TOP_53_H       (REG_COMBO_GP_TOP_BASE + 0xA7)
#define REG_COMBO_GP_TOP_54_L       (REG_COMBO_GP_TOP_BASE + 0xA8)
#define REG_COMBO_GP_TOP_54_H       (REG_COMBO_GP_TOP_BASE + 0xA9)
#define REG_COMBO_GP_TOP_55_L       (REG_COMBO_GP_TOP_BASE + 0xAA)
#define REG_COMBO_GP_TOP_55_H       (REG_COMBO_GP_TOP_BASE + 0xAB)
#define REG_COMBO_GP_TOP_56_L       (REG_COMBO_GP_TOP_BASE + 0xAC)
#define REG_COMBO_GP_TOP_56_H       (REG_COMBO_GP_TOP_BASE + 0xAD)
#define REG_COMBO_GP_TOP_57_L       (REG_COMBO_GP_TOP_BASE + 0xAE)
#define REG_COMBO_GP_TOP_57_H       (REG_COMBO_GP_TOP_BASE + 0xAF)
#define REG_COMBO_GP_TOP_58_L       (REG_COMBO_GP_TOP_BASE + 0xB0)
#define REG_COMBO_GP_TOP_58_H       (REG_COMBO_GP_TOP_BASE + 0xB1)
#define REG_COMBO_GP_TOP_59_L       (REG_COMBO_GP_TOP_BASE + 0xB2)
#define REG_COMBO_GP_TOP_59_H       (REG_COMBO_GP_TOP_BASE + 0xB3)
#define REG_COMBO_GP_TOP_5A_L       (REG_COMBO_GP_TOP_BASE + 0xB4)
#define REG_COMBO_GP_TOP_5A_H       (REG_COMBO_GP_TOP_BASE + 0xB5)
#define REG_COMBO_GP_TOP_5B_L       (REG_COMBO_GP_TOP_BASE + 0xB6)
#define REG_COMBO_GP_TOP_5B_H       (REG_COMBO_GP_TOP_BASE + 0xB7)
#define REG_COMBO_GP_TOP_5C_L       (REG_COMBO_GP_TOP_BASE + 0xB8)
#define REG_COMBO_GP_TOP_5C_H       (REG_COMBO_GP_TOP_BASE + 0xB9)
#define REG_COMBO_GP_TOP_5D_L       (REG_COMBO_GP_TOP_BASE + 0xBA)
#define REG_COMBO_GP_TOP_5D_H       (REG_COMBO_GP_TOP_BASE + 0xBB)
#define REG_COMBO_GP_TOP_5E_L       (REG_COMBO_GP_TOP_BASE + 0xBC)
#define REG_COMBO_GP_TOP_5E_H       (REG_COMBO_GP_TOP_BASE + 0xBD)
#define REG_COMBO_GP_TOP_5F_L       (REG_COMBO_GP_TOP_BASE + 0xBE)
#define REG_COMBO_GP_TOP_5F_H       (REG_COMBO_GP_TOP_BASE + 0xBF)
#define REG_COMBO_GP_TOP_60_L       (REG_COMBO_GP_TOP_BASE + 0xC0)
#define REG_COMBO_GP_TOP_60_H       (REG_COMBO_GP_TOP_BASE + 0xC1)
#define REG_COMBO_GP_TOP_61_L       (REG_COMBO_GP_TOP_BASE + 0xC2)
#define REG_COMBO_GP_TOP_61_H       (REG_COMBO_GP_TOP_BASE + 0xC3)
#define REG_COMBO_GP_TOP_62_L       (REG_COMBO_GP_TOP_BASE + 0xC4)
#define REG_COMBO_GP_TOP_62_H       (REG_COMBO_GP_TOP_BASE + 0xC5)
#define REG_COMBO_GP_TOP_63_L       (REG_COMBO_GP_TOP_BASE + 0xC6)
#define REG_COMBO_GP_TOP_63_H       (REG_COMBO_GP_TOP_BASE + 0xC7)
#define REG_COMBO_GP_TOP_64_L       (REG_COMBO_GP_TOP_BASE + 0xC8)
#define REG_COMBO_GP_TOP_64_H       (REG_COMBO_GP_TOP_BASE + 0xC9)
#define REG_COMBO_GP_TOP_65_L       (REG_COMBO_GP_TOP_BASE + 0xCA)
#define REG_COMBO_GP_TOP_65_H       (REG_COMBO_GP_TOP_BASE + 0xCB)
#define REG_COMBO_GP_TOP_66_L       (REG_COMBO_GP_TOP_BASE + 0xCC)
#define REG_COMBO_GP_TOP_66_H       (REG_COMBO_GP_TOP_BASE + 0xCD)
#define REG_COMBO_GP_TOP_67_L       (REG_COMBO_GP_TOP_BASE + 0xCE)
#define REG_COMBO_GP_TOP_67_H       (REG_COMBO_GP_TOP_BASE + 0xCF)
#define REG_COMBO_GP_TOP_68_L       (REG_COMBO_GP_TOP_BASE + 0xD0)
#define REG_COMBO_GP_TOP_68_H       (REG_COMBO_GP_TOP_BASE + 0xD1)
#define REG_COMBO_GP_TOP_69_L       (REG_COMBO_GP_TOP_BASE + 0xD2)
#define REG_COMBO_GP_TOP_69_H       (REG_COMBO_GP_TOP_BASE + 0xD3)
#define REG_COMBO_GP_TOP_6A_L       (REG_COMBO_GP_TOP_BASE + 0xD4)
#define REG_COMBO_GP_TOP_6A_H       (REG_COMBO_GP_TOP_BASE + 0xD5)
#define REG_COMBO_GP_TOP_6B_L       (REG_COMBO_GP_TOP_BASE + 0xD6)
#define REG_COMBO_GP_TOP_6B_H       (REG_COMBO_GP_TOP_BASE + 0xD7)
#define REG_COMBO_GP_TOP_6C_L       (REG_COMBO_GP_TOP_BASE + 0xD8)
#define REG_COMBO_GP_TOP_6C_H       (REG_COMBO_GP_TOP_BASE + 0xD9)
#define REG_COMBO_GP_TOP_6D_L       (REG_COMBO_GP_TOP_BASE + 0xDA)
#define REG_COMBO_GP_TOP_6D_H       (REG_COMBO_GP_TOP_BASE + 0xDB)
#define REG_COMBO_GP_TOP_6E_L       (REG_COMBO_GP_TOP_BASE + 0xDC)
#define REG_COMBO_GP_TOP_6E_H       (REG_COMBO_GP_TOP_BASE + 0xDD)
#define REG_COMBO_GP_TOP_6F_L       (REG_COMBO_GP_TOP_BASE + 0xDE)
#define REG_COMBO_GP_TOP_6F_H       (REG_COMBO_GP_TOP_BASE + 0xDF)
#define REG_COMBO_GP_TOP_70_L       (REG_COMBO_GP_TOP_BASE + 0xE0)
#define REG_COMBO_GP_TOP_70_H       (REG_COMBO_GP_TOP_BASE + 0xE1)
#define REG_COMBO_GP_TOP_71_L       (REG_COMBO_GP_TOP_BASE + 0xE2)
#define REG_COMBO_GP_TOP_71_H       (REG_COMBO_GP_TOP_BASE + 0xE3)
#define REG_COMBO_GP_TOP_72_L       (REG_COMBO_GP_TOP_BASE + 0xE4)
#define REG_COMBO_GP_TOP_72_H       (REG_COMBO_GP_TOP_BASE + 0xE5)
#define REG_COMBO_GP_TOP_73_L       (REG_COMBO_GP_TOP_BASE + 0xE6)
#define REG_COMBO_GP_TOP_73_H       (REG_COMBO_GP_TOP_BASE + 0xE7)
#define REG_COMBO_GP_TOP_74_L       (REG_COMBO_GP_TOP_BASE + 0xE8)
#define REG_COMBO_GP_TOP_74_H       (REG_COMBO_GP_TOP_BASE + 0xE9)
#define REG_COMBO_GP_TOP_75_L       (REG_COMBO_GP_TOP_BASE + 0xEA)
#define REG_COMBO_GP_TOP_75_H       (REG_COMBO_GP_TOP_BASE + 0xEB)
#define REG_COMBO_GP_TOP_76_L       (REG_COMBO_GP_TOP_BASE + 0xEC)
#define REG_COMBO_GP_TOP_76_H       (REG_COMBO_GP_TOP_BASE + 0xED)
#define REG_COMBO_GP_TOP_77_L       (REG_COMBO_GP_TOP_BASE + 0xEE)
#define REG_COMBO_GP_TOP_77_H       (REG_COMBO_GP_TOP_BASE + 0xEF)
#define REG_COMBO_GP_TOP_78_L       (REG_COMBO_GP_TOP_BASE + 0xF0)
#define REG_COMBO_GP_TOP_78_H       (REG_COMBO_GP_TOP_BASE + 0xF1)
#define REG_COMBO_GP_TOP_79_L       (REG_COMBO_GP_TOP_BASE + 0xF2)
#define REG_COMBO_GP_TOP_79_H       (REG_COMBO_GP_TOP_BASE + 0xF3)
#define REG_COMBO_GP_TOP_7A_L       (REG_COMBO_GP_TOP_BASE + 0xF4)
#define REG_COMBO_GP_TOP_7A_H       (REG_COMBO_GP_TOP_BASE + 0xF5)
#define REG_COMBO_GP_TOP_7B_L       (REG_COMBO_GP_TOP_BASE + 0xF6)
#define REG_COMBO_GP_TOP_7B_H       (REG_COMBO_GP_TOP_BASE + 0xF7)
#define REG_COMBO_GP_TOP_7C_L       (REG_COMBO_GP_TOP_BASE + 0xF8)
#define REG_COMBO_GP_TOP_7C_H       (REG_COMBO_GP_TOP_BASE + 0xF9)
#define REG_COMBO_GP_TOP_7D_L       (REG_COMBO_GP_TOP_BASE + 0xFA)
#define REG_COMBO_GP_TOP_7D_H       (REG_COMBO_GP_TOP_BASE + 0xFB)
#define REG_COMBO_GP_TOP_7E_L       (REG_COMBO_GP_TOP_BASE + 0xFC)
#define REG_COMBO_GP_TOP_7E_H       (REG_COMBO_GP_TOP_BASE + 0xFD)
#define REG_COMBO_GP_TOP_7F_L       (REG_COMBO_GP_TOP_BASE + 0xFE)
#define REG_COMBO_GP_TOP_7F_H       (REG_COMBO_GP_TOP_BASE + 0xFF)

//=============================================================
// SECURE_TZPC
#define REG_SECURE_TZPC_00_L        (REG_SECURE_TZPC_BASE + 0x00)
#define REG_SECURE_TZPC_00_H        (REG_SECURE_TZPC_BASE + 0x01)
#define REG_SECURE_TZPC_01_L        (REG_SECURE_TZPC_BASE + 0x02)
#define REG_SECURE_TZPC_01_H        (REG_SECURE_TZPC_BASE + 0x03)
#define REG_SECURE_TZPC_02_L        (REG_SECURE_TZPC_BASE + 0x04)
#define REG_SECURE_TZPC_02_H        (REG_SECURE_TZPC_BASE + 0x05)
#define REG_SECURE_TZPC_03_L        (REG_SECURE_TZPC_BASE + 0x06)
#define REG_SECURE_TZPC_03_H        (REG_SECURE_TZPC_BASE + 0x07)
#define REG_SECURE_TZPC_04_L        (REG_SECURE_TZPC_BASE + 0x08)
#define REG_SECURE_TZPC_04_H        (REG_SECURE_TZPC_BASE + 0x09)
#define REG_SECURE_TZPC_05_L        (REG_SECURE_TZPC_BASE + 0x0A)
#define REG_SECURE_TZPC_05_H        (REG_SECURE_TZPC_BASE + 0x0B)
#define REG_SECURE_TZPC_06_L        (REG_SECURE_TZPC_BASE + 0x0C)
#define REG_SECURE_TZPC_06_H        (REG_SECURE_TZPC_BASE + 0x0D)
#define REG_SECURE_TZPC_07_L        (REG_SECURE_TZPC_BASE + 0x0E)
#define REG_SECURE_TZPC_07_H        (REG_SECURE_TZPC_BASE + 0x0F)
#define REG_SECURE_TZPC_08_L        (REG_SECURE_TZPC_BASE + 0x10)
#define REG_SECURE_TZPC_08_H        (REG_SECURE_TZPC_BASE + 0x11)
#define REG_SECURE_TZPC_09_L        (REG_SECURE_TZPC_BASE + 0x12)
#define REG_SECURE_TZPC_09_H        (REG_SECURE_TZPC_BASE + 0x13)
#define REG_SECURE_TZPC_0A_L        (REG_SECURE_TZPC_BASE + 0x14)
#define REG_SECURE_TZPC_0A_H        (REG_SECURE_TZPC_BASE + 0x15)
#define REG_SECURE_TZPC_0B_L        (REG_SECURE_TZPC_BASE + 0x16)
#define REG_SECURE_TZPC_0B_H        (REG_SECURE_TZPC_BASE + 0x17)
#define REG_SECURE_TZPC_0C_L        (REG_SECURE_TZPC_BASE + 0x18)
#define REG_SECURE_TZPC_0C_H        (REG_SECURE_TZPC_BASE + 0x19)
#define REG_SECURE_TZPC_0D_L        (REG_SECURE_TZPC_BASE + 0x1A)
#define REG_SECURE_TZPC_0D_H        (REG_SECURE_TZPC_BASE + 0x1B)
#define REG_SECURE_TZPC_0E_L        (REG_SECURE_TZPC_BASE + 0x1C)
#define REG_SECURE_TZPC_0E_H        (REG_SECURE_TZPC_BASE + 0x1D)
#define REG_SECURE_TZPC_0F_L        (REG_SECURE_TZPC_BASE + 0x1E)
#define REG_SECURE_TZPC_0F_H        (REG_SECURE_TZPC_BASE + 0x1F)
#define REG_SECURE_TZPC_10_L        (REG_SECURE_TZPC_BASE + 0x20)
#define REG_SECURE_TZPC_10_H        (REG_SECURE_TZPC_BASE + 0x21)
#define REG_SECURE_TZPC_11_L        (REG_SECURE_TZPC_BASE + 0x22)
#define REG_SECURE_TZPC_11_H        (REG_SECURE_TZPC_BASE + 0x23)
#define REG_SECURE_TZPC_12_L        (REG_SECURE_TZPC_BASE + 0x24)
#define REG_SECURE_TZPC_12_H        (REG_SECURE_TZPC_BASE + 0x25)
#define REG_SECURE_TZPC_13_L        (REG_SECURE_TZPC_BASE + 0x26)
#define REG_SECURE_TZPC_13_H        (REG_SECURE_TZPC_BASE + 0x27)
#define REG_SECURE_TZPC_14_L        (REG_SECURE_TZPC_BASE + 0x28)
#define REG_SECURE_TZPC_14_H        (REG_SECURE_TZPC_BASE + 0x29)
#define REG_SECURE_TZPC_15_L        (REG_SECURE_TZPC_BASE + 0x2A)
#define REG_SECURE_TZPC_15_H        (REG_SECURE_TZPC_BASE + 0x2B)
#define REG_SECURE_TZPC_16_L        (REG_SECURE_TZPC_BASE + 0x2C)
#define REG_SECURE_TZPC_16_H        (REG_SECURE_TZPC_BASE + 0x2D)
#define REG_SECURE_TZPC_17_L        (REG_SECURE_TZPC_BASE + 0x2E)
#define REG_SECURE_TZPC_17_H        (REG_SECURE_TZPC_BASE + 0x2F)
#define REG_SECURE_TZPC_18_L        (REG_SECURE_TZPC_BASE + 0x30)
#define REG_SECURE_TZPC_18_H        (REG_SECURE_TZPC_BASE + 0x31)
#define REG_SECURE_TZPC_19_L        (REG_SECURE_TZPC_BASE + 0x32)
#define REG_SECURE_TZPC_19_H        (REG_SECURE_TZPC_BASE + 0x33)
#define REG_SECURE_TZPC_1A_L        (REG_SECURE_TZPC_BASE + 0x34)
#define REG_SECURE_TZPC_1A_H        (REG_SECURE_TZPC_BASE + 0x35)
#define REG_SECURE_TZPC_1B_L        (REG_SECURE_TZPC_BASE + 0x36)
#define REG_SECURE_TZPC_1B_H        (REG_SECURE_TZPC_BASE + 0x37)
#define REG_SECURE_TZPC_1C_L        (REG_SECURE_TZPC_BASE + 0x38)
#define REG_SECURE_TZPC_1C_H        (REG_SECURE_TZPC_BASE + 0x39)
#define REG_SECURE_TZPC_1D_L        (REG_SECURE_TZPC_BASE + 0x3A)
#define REG_SECURE_TZPC_1D_H        (REG_SECURE_TZPC_BASE + 0x3B)
#define REG_SECURE_TZPC_1E_L        (REG_SECURE_TZPC_BASE + 0x3C)
#define REG_SECURE_TZPC_1E_H        (REG_SECURE_TZPC_BASE + 0x3D)
#define REG_SECURE_TZPC_1F_L        (REG_SECURE_TZPC_BASE + 0x3E)
#define REG_SECURE_TZPC_1F_H        (REG_SECURE_TZPC_BASE + 0x3F)
#define REG_SECURE_TZPC_20_L        (REG_SECURE_TZPC_BASE + 0x40)
#define REG_SECURE_TZPC_20_H        (REG_SECURE_TZPC_BASE + 0x41)
#define REG_SECURE_TZPC_21_L        (REG_SECURE_TZPC_BASE + 0x42)
#define REG_SECURE_TZPC_21_H        (REG_SECURE_TZPC_BASE + 0x43)
#define REG_SECURE_TZPC_22_L        (REG_SECURE_TZPC_BASE + 0x44)
#define REG_SECURE_TZPC_22_H        (REG_SECURE_TZPC_BASE + 0x45)
#define REG_SECURE_TZPC_23_L        (REG_SECURE_TZPC_BASE + 0x46)
#define REG_SECURE_TZPC_23_H        (REG_SECURE_TZPC_BASE + 0x47)
#define REG_SECURE_TZPC_24_L        (REG_SECURE_TZPC_BASE + 0x48)
#define REG_SECURE_TZPC_24_H        (REG_SECURE_TZPC_BASE + 0x49)
#define REG_SECURE_TZPC_25_L        (REG_SECURE_TZPC_BASE + 0x4A)
#define REG_SECURE_TZPC_25_H        (REG_SECURE_TZPC_BASE + 0x4B)
#define REG_SECURE_TZPC_26_L        (REG_SECURE_TZPC_BASE + 0x4C)
#define REG_SECURE_TZPC_26_H        (REG_SECURE_TZPC_BASE + 0x4D)
#define REG_SECURE_TZPC_27_L        (REG_SECURE_TZPC_BASE + 0x4E)
#define REG_SECURE_TZPC_27_H        (REG_SECURE_TZPC_BASE + 0x4F)
#define REG_SECURE_TZPC_28_L        (REG_SECURE_TZPC_BASE + 0x50)
#define REG_SECURE_TZPC_28_H        (REG_SECURE_TZPC_BASE + 0x51)
#define REG_SECURE_TZPC_29_L        (REG_SECURE_TZPC_BASE + 0x52)
#define REG_SECURE_TZPC_29_H        (REG_SECURE_TZPC_BASE + 0x53)
#define REG_SECURE_TZPC_2A_L        (REG_SECURE_TZPC_BASE + 0x54)
#define REG_SECURE_TZPC_2A_H        (REG_SECURE_TZPC_BASE + 0x55)
#define REG_SECURE_TZPC_2B_L        (REG_SECURE_TZPC_BASE + 0x56)
#define REG_SECURE_TZPC_2B_H        (REG_SECURE_TZPC_BASE + 0x57)
#define REG_SECURE_TZPC_2C_L        (REG_SECURE_TZPC_BASE + 0x58)
#define REG_SECURE_TZPC_2C_H        (REG_SECURE_TZPC_BASE + 0x59)
#define REG_SECURE_TZPC_2D_L        (REG_SECURE_TZPC_BASE + 0x5A)
#define REG_SECURE_TZPC_2D_H        (REG_SECURE_TZPC_BASE + 0x5B)
#define REG_SECURE_TZPC_2E_L        (REG_SECURE_TZPC_BASE + 0x5C)
#define REG_SECURE_TZPC_2E_H        (REG_SECURE_TZPC_BASE + 0x5D)
#define REG_SECURE_TZPC_2F_L        (REG_SECURE_TZPC_BASE + 0x5E)
#define REG_SECURE_TZPC_2F_H        (REG_SECURE_TZPC_BASE + 0x5F)
#define REG_SECURE_TZPC_30_L        (REG_SECURE_TZPC_BASE + 0x60)
#define REG_SECURE_TZPC_30_H        (REG_SECURE_TZPC_BASE + 0x61)
#define REG_SECURE_TZPC_31_L        (REG_SECURE_TZPC_BASE + 0x62)
#define REG_SECURE_TZPC_31_H        (REG_SECURE_TZPC_BASE + 0x63)
#define REG_SECURE_TZPC_32_L        (REG_SECURE_TZPC_BASE + 0x64)
#define REG_SECURE_TZPC_32_H        (REG_SECURE_TZPC_BASE + 0x65)
#define REG_SECURE_TZPC_33_L        (REG_SECURE_TZPC_BASE + 0x66)
#define REG_SECURE_TZPC_33_H        (REG_SECURE_TZPC_BASE + 0x67)
#define REG_SECURE_TZPC_34_L        (REG_SECURE_TZPC_BASE + 0x68)
#define REG_SECURE_TZPC_34_H        (REG_SECURE_TZPC_BASE + 0x69)
#define REG_SECURE_TZPC_35_L        (REG_SECURE_TZPC_BASE + 0x6A)
#define REG_SECURE_TZPC_35_H        (REG_SECURE_TZPC_BASE + 0x6B)
#define REG_SECURE_TZPC_36_L        (REG_SECURE_TZPC_BASE + 0x6C)
#define REG_SECURE_TZPC_36_H        (REG_SECURE_TZPC_BASE + 0x6D)
#define REG_SECURE_TZPC_37_L        (REG_SECURE_TZPC_BASE + 0x6E)
#define REG_SECURE_TZPC_37_H        (REG_SECURE_TZPC_BASE + 0x6F)
#define REG_SECURE_TZPC_38_L        (REG_SECURE_TZPC_BASE + 0x70)
#define REG_SECURE_TZPC_38_H        (REG_SECURE_TZPC_BASE + 0x71)
#define REG_SECURE_TZPC_39_L        (REG_SECURE_TZPC_BASE + 0x72)
#define REG_SECURE_TZPC_39_H        (REG_SECURE_TZPC_BASE + 0x73)
#define REG_SECURE_TZPC_3A_L        (REG_SECURE_TZPC_BASE + 0x74)
#define REG_SECURE_TZPC_3A_H        (REG_SECURE_TZPC_BASE + 0x75)
#define REG_SECURE_TZPC_3B_L        (REG_SECURE_TZPC_BASE + 0x76)
#define REG_SECURE_TZPC_3B_H        (REG_SECURE_TZPC_BASE + 0x77)
#define REG_SECURE_TZPC_3C_L        (REG_SECURE_TZPC_BASE + 0x78)
#define REG_SECURE_TZPC_3C_H        (REG_SECURE_TZPC_BASE + 0x79)
#define REG_SECURE_TZPC_3D_L        (REG_SECURE_TZPC_BASE + 0x7A)
#define REG_SECURE_TZPC_3D_H        (REG_SECURE_TZPC_BASE + 0x7B)
#define REG_SECURE_TZPC_3E_L        (REG_SECURE_TZPC_BASE + 0x7C)
#define REG_SECURE_TZPC_3E_H        (REG_SECURE_TZPC_BASE + 0x7D)
#define REG_SECURE_TZPC_3F_L        (REG_SECURE_TZPC_BASE + 0x7E)
#define REG_SECURE_TZPC_3F_H        (REG_SECURE_TZPC_BASE + 0x7F)
#define REG_SECURE_TZPC_40_L        (REG_SECURE_TZPC_BASE + 0x80)
#define REG_SECURE_TZPC_40_H        (REG_SECURE_TZPC_BASE + 0x81)
#define REG_SECURE_TZPC_41_L        (REG_SECURE_TZPC_BASE + 0x82)
#define REG_SECURE_TZPC_41_H        (REG_SECURE_TZPC_BASE + 0x83)
#define REG_SECURE_TZPC_42_L        (REG_SECURE_TZPC_BASE + 0x84)
#define REG_SECURE_TZPC_42_H        (REG_SECURE_TZPC_BASE + 0x85)
#define REG_SECURE_TZPC_43_L        (REG_SECURE_TZPC_BASE + 0x86)
#define REG_SECURE_TZPC_43_H        (REG_SECURE_TZPC_BASE + 0x87)
#define REG_SECURE_TZPC_44_L        (REG_SECURE_TZPC_BASE + 0x88)
#define REG_SECURE_TZPC_44_H        (REG_SECURE_TZPC_BASE + 0x89)
#define REG_SECURE_TZPC_45_L        (REG_SECURE_TZPC_BASE + 0x8A)
#define REG_SECURE_TZPC_45_H        (REG_SECURE_TZPC_BASE + 0x8B)
#define REG_SECURE_TZPC_46_L        (REG_SECURE_TZPC_BASE + 0x8C)
#define REG_SECURE_TZPC_46_H        (REG_SECURE_TZPC_BASE + 0x8D)
#define REG_SECURE_TZPC_47_L        (REG_SECURE_TZPC_BASE + 0x8E)
#define REG_SECURE_TZPC_47_H        (REG_SECURE_TZPC_BASE + 0x8F)
#define REG_SECURE_TZPC_48_L        (REG_SECURE_TZPC_BASE + 0x90)
#define REG_SECURE_TZPC_48_H        (REG_SECURE_TZPC_BASE + 0x91)
#define REG_SECURE_TZPC_49_L        (REG_SECURE_TZPC_BASE + 0x92)
#define REG_SECURE_TZPC_49_H        (REG_SECURE_TZPC_BASE + 0x93)
#define REG_SECURE_TZPC_4A_L        (REG_SECURE_TZPC_BASE + 0x94)
#define REG_SECURE_TZPC_4A_H        (REG_SECURE_TZPC_BASE + 0x95)
#define REG_SECURE_TZPC_4B_L        (REG_SECURE_TZPC_BASE + 0x96)
#define REG_SECURE_TZPC_4B_H        (REG_SECURE_TZPC_BASE + 0x97)
#define REG_SECURE_TZPC_4C_L        (REG_SECURE_TZPC_BASE + 0x98)
#define REG_SECURE_TZPC_4C_H        (REG_SECURE_TZPC_BASE + 0x99)
#define REG_SECURE_TZPC_4D_L        (REG_SECURE_TZPC_BASE + 0x9A)
#define REG_SECURE_TZPC_4D_H        (REG_SECURE_TZPC_BASE + 0x9B)
#define REG_SECURE_TZPC_4E_L        (REG_SECURE_TZPC_BASE + 0x9C)
#define REG_SECURE_TZPC_4E_H        (REG_SECURE_TZPC_BASE + 0x9D)
#define REG_SECURE_TZPC_4F_L        (REG_SECURE_TZPC_BASE + 0x9E)
#define REG_SECURE_TZPC_4F_H        (REG_SECURE_TZPC_BASE + 0x9F)
#define REG_SECURE_TZPC_50_L        (REG_SECURE_TZPC_BASE + 0xA0)
#define REG_SECURE_TZPC_50_H        (REG_SECURE_TZPC_BASE + 0xA1)
#define REG_SECURE_TZPC_51_L        (REG_SECURE_TZPC_BASE + 0xA2)
#define REG_SECURE_TZPC_51_H        (REG_SECURE_TZPC_BASE + 0xA3)
#define REG_SECURE_TZPC_52_L        (REG_SECURE_TZPC_BASE + 0xA4)
#define REG_SECURE_TZPC_52_H        (REG_SECURE_TZPC_BASE + 0xA5)
#define REG_SECURE_TZPC_53_L        (REG_SECURE_TZPC_BASE + 0xA6)
#define REG_SECURE_TZPC_53_H        (REG_SECURE_TZPC_BASE + 0xA7)
#define REG_SECURE_TZPC_54_L        (REG_SECURE_TZPC_BASE + 0xA8)
#define REG_SECURE_TZPC_54_H        (REG_SECURE_TZPC_BASE + 0xA9)
#define REG_SECURE_TZPC_55_L        (REG_SECURE_TZPC_BASE + 0xAA)
#define REG_SECURE_TZPC_55_H        (REG_SECURE_TZPC_BASE + 0xAB)
#define REG_SECURE_TZPC_56_L        (REG_SECURE_TZPC_BASE + 0xAC)
#define REG_SECURE_TZPC_56_H        (REG_SECURE_TZPC_BASE + 0xAD)
#define REG_SECURE_TZPC_57_L        (REG_SECURE_TZPC_BASE + 0xAE)
#define REG_SECURE_TZPC_57_H        (REG_SECURE_TZPC_BASE + 0xAF)
#define REG_SECURE_TZPC_58_L        (REG_SECURE_TZPC_BASE + 0xB0)
#define REG_SECURE_TZPC_58_H        (REG_SECURE_TZPC_BASE + 0xB1)
#define REG_SECURE_TZPC_59_L        (REG_SECURE_TZPC_BASE + 0xB2)
#define REG_SECURE_TZPC_59_H        (REG_SECURE_TZPC_BASE + 0xB3)
#define REG_SECURE_TZPC_5A_L        (REG_SECURE_TZPC_BASE + 0xB4)
#define REG_SECURE_TZPC_5A_H        (REG_SECURE_TZPC_BASE + 0xB5)
#define REG_SECURE_TZPC_5B_L        (REG_SECURE_TZPC_BASE + 0xB6)
#define REG_SECURE_TZPC_5B_H        (REG_SECURE_TZPC_BASE + 0xB7)
#define REG_SECURE_TZPC_5C_L        (REG_SECURE_TZPC_BASE + 0xB8)
#define REG_SECURE_TZPC_5C_H        (REG_SECURE_TZPC_BASE + 0xB9)
#define REG_SECURE_TZPC_5D_L        (REG_SECURE_TZPC_BASE + 0xBA)
#define REG_SECURE_TZPC_5D_H        (REG_SECURE_TZPC_BASE + 0xBB)
#define REG_SECURE_TZPC_5E_L        (REG_SECURE_TZPC_BASE + 0xBC)
#define REG_SECURE_TZPC_5E_H        (REG_SECURE_TZPC_BASE + 0xBD)
#define REG_SECURE_TZPC_5F_L        (REG_SECURE_TZPC_BASE + 0xBE)
#define REG_SECURE_TZPC_5F_H        (REG_SECURE_TZPC_BASE + 0xBF)
#define REG_SECURE_TZPC_60_L        (REG_SECURE_TZPC_BASE + 0xC0)
#define REG_SECURE_TZPC_60_H        (REG_SECURE_TZPC_BASE + 0xC1)
#define REG_SECURE_TZPC_61_L        (REG_SECURE_TZPC_BASE + 0xC2)
#define REG_SECURE_TZPC_61_H        (REG_SECURE_TZPC_BASE + 0xC3)
#define REG_SECURE_TZPC_62_L        (REG_SECURE_TZPC_BASE + 0xC4)
#define REG_SECURE_TZPC_62_H        (REG_SECURE_TZPC_BASE + 0xC5)
#define REG_SECURE_TZPC_63_L        (REG_SECURE_TZPC_BASE + 0xC6)
#define REG_SECURE_TZPC_63_H        (REG_SECURE_TZPC_BASE + 0xC7)
#define REG_SECURE_TZPC_64_L        (REG_SECURE_TZPC_BASE + 0xC8)
#define REG_SECURE_TZPC_64_H        (REG_SECURE_TZPC_BASE + 0xC9)
#define REG_SECURE_TZPC_65_L        (REG_SECURE_TZPC_BASE + 0xCA)
#define REG_SECURE_TZPC_65_H        (REG_SECURE_TZPC_BASE + 0xCB)
#define REG_SECURE_TZPC_66_L        (REG_SECURE_TZPC_BASE + 0xCC)
#define REG_SECURE_TZPC_66_H        (REG_SECURE_TZPC_BASE + 0xCD)
#define REG_SECURE_TZPC_67_L        (REG_SECURE_TZPC_BASE + 0xCE)
#define REG_SECURE_TZPC_67_H        (REG_SECURE_TZPC_BASE + 0xCF)
#define REG_SECURE_TZPC_68_L        (REG_SECURE_TZPC_BASE + 0xD0)
#define REG_SECURE_TZPC_68_H        (REG_SECURE_TZPC_BASE + 0xD1)
#define REG_SECURE_TZPC_69_L        (REG_SECURE_TZPC_BASE + 0xD2)
#define REG_SECURE_TZPC_69_H        (REG_SECURE_TZPC_BASE + 0xD3)
#define REG_SECURE_TZPC_6A_L        (REG_SECURE_TZPC_BASE + 0xD4)
#define REG_SECURE_TZPC_6A_H        (REG_SECURE_TZPC_BASE + 0xD5)
#define REG_SECURE_TZPC_6B_L        (REG_SECURE_TZPC_BASE + 0xD6)
#define REG_SECURE_TZPC_6B_H        (REG_SECURE_TZPC_BASE + 0xD7)
#define REG_SECURE_TZPC_6C_L        (REG_SECURE_TZPC_BASE + 0xD8)
#define REG_SECURE_TZPC_6C_H        (REG_SECURE_TZPC_BASE + 0xD9)
#define REG_SECURE_TZPC_6D_L        (REG_SECURE_TZPC_BASE + 0xDA)
#define REG_SECURE_TZPC_6D_H        (REG_SECURE_TZPC_BASE + 0xDB)
#define REG_SECURE_TZPC_6E_L        (REG_SECURE_TZPC_BASE + 0xDC)
#define REG_SECURE_TZPC_6E_H        (REG_SECURE_TZPC_BASE + 0xDD)

//=============================================================
// CHIP_GPIO
#define REG_CHIP_GPIO_08_L          (REG_CHIP_GPIO_BASE + 0x10)
#define REG_CHIP_GPIO_08_H          (REG_CHIP_GPIO_BASE + 0x11)
#define REG_CHIP_GPIO_09_L          (REG_CHIP_GPIO_BASE + 0x12)
#define REG_CHIP_GPIO_09_H          (REG_CHIP_GPIO_BASE + 0x13)
#define REG_CHIP_GPIO_0A_L          (REG_CHIP_GPIO_BASE + 0x14)
#define REG_CHIP_GPIO_0A_H          (REG_CHIP_GPIO_BASE + 0x15)
#define REG_CHIP_GPIO_0B_L          (REG_CHIP_GPIO_BASE + 0x16)
#define REG_CHIP_GPIO_0B_H          (REG_CHIP_GPIO_BASE + 0x17)
#define REG_CHIP_GPIO_0C_L          (REG_CHIP_GPIO_BASE + 0x18)
#define REG_CHIP_GPIO_0C_H          (REG_CHIP_GPIO_BASE + 0x19)
#define REG_CHIP_GPIO_0D_L          (REG_CHIP_GPIO_BASE + 0x1A)
#define REG_CHIP_GPIO_0D_H          (REG_CHIP_GPIO_BASE + 0x1B)
#define REG_CHIP_GPIO_0E_L          (REG_CHIP_GPIO_BASE + 0x1C)
#define REG_CHIP_GPIO_0E_H          (REG_CHIP_GPIO_BASE + 0x1D)
#define REG_CHIP_GPIO_0F_L          (REG_CHIP_GPIO_BASE + 0x1E)
#define REG_CHIP_GPIO_0F_H          (REG_CHIP_GPIO_BASE + 0x1F)

#define REG_CHIP_GPIO_50_L          (REG_CHIP_GPIO_BASE + 0xA0)
#define REG_CHIP_GPIO_50_H          (REG_CHIP_GPIO_BASE + 0xA1)
#define REG_CHIP_GPIO_51_L          (REG_CHIP_GPIO_BASE + 0xA2)
#define REG_CHIP_GPIO_51_H          (REG_CHIP_GPIO_BASE + 0xA3)
#define REG_CHIP_GPIO_52_L          (REG_CHIP_GPIO_BASE + 0xA4)
#define REG_CHIP_GPIO_52_H          (REG_CHIP_GPIO_BASE + 0xA5)
#define REG_CHIP_GPIO_53_L          (REG_CHIP_GPIO_BASE + 0xA6)
#define REG_CHIP_GPIO_53_H          (REG_CHIP_GPIO_BASE + 0xA7)
#define REG_CHIP_GPIO_54_L          (REG_CHIP_GPIO_BASE + 0xA8)
#define REG_CHIP_GPIO_54_H          (REG_CHIP_GPIO_BASE + 0xA9)
#define REG_CHIP_GPIO_55_L          (REG_CHIP_GPIO_BASE + 0xAA)
#define REG_CHIP_GPIO_55_H          (REG_CHIP_GPIO_BASE + 0xAB)
#define REG_CHIP_GPIO_56_L          (REG_CHIP_GPIO_BASE + 0xAC)
#define REG_CHIP_GPIO_56_H          (REG_CHIP_GPIO_BASE + 0xAD)
#define REG_CHIP_GPIO_57_L          (REG_CHIP_GPIO_BASE + 0xAE)
#define REG_CHIP_GPIO_57_H          (REG_CHIP_GPIO_BASE + 0xAF)

//=============================================================
// PHY2P1_0_P0
#define REG_PHY2P1_0_P0_00_L        (REG_PHY2P1_0_P0_BASE + 0x00)
#define REG_PHY2P1_0_P0_00_H        (REG_PHY2P1_0_P0_BASE + 0x01)
#define REG_PHY2P1_0_P0_01_L        (REG_PHY2P1_0_P0_BASE + 0x02)
#define REG_PHY2P1_0_P0_01_H        (REG_PHY2P1_0_P0_BASE + 0x03)
#define REG_PHY2P1_0_P0_02_L        (REG_PHY2P1_0_P0_BASE + 0x04)
#define REG_PHY2P1_0_P0_02_H        (REG_PHY2P1_0_P0_BASE + 0x05)
#define REG_PHY2P1_0_P0_03_L        (REG_PHY2P1_0_P0_BASE + 0x06)
#define REG_PHY2P1_0_P0_03_H        (REG_PHY2P1_0_P0_BASE + 0x07)
#define REG_PHY2P1_0_P0_04_L        (REG_PHY2P1_0_P0_BASE + 0x08)
#define REG_PHY2P1_0_P0_04_H        (REG_PHY2P1_0_P0_BASE + 0x09)
#define REG_PHY2P1_0_P0_05_L        (REG_PHY2P1_0_P0_BASE + 0x0A)
#define REG_PHY2P1_0_P0_05_H        (REG_PHY2P1_0_P0_BASE + 0x0B)
#define REG_PHY2P1_0_P0_06_L        (REG_PHY2P1_0_P0_BASE + 0x0C)
#define REG_PHY2P1_0_P0_06_H        (REG_PHY2P1_0_P0_BASE + 0x0D)
#define REG_PHY2P1_0_P0_07_L        (REG_PHY2P1_0_P0_BASE + 0x0E)
#define REG_PHY2P1_0_P0_07_H        (REG_PHY2P1_0_P0_BASE + 0x0F)
#define REG_PHY2P1_0_P0_08_L        (REG_PHY2P1_0_P0_BASE + 0x10)
#define REG_PHY2P1_0_P0_08_H        (REG_PHY2P1_0_P0_BASE + 0x11)
#define REG_PHY2P1_0_P0_09_L        (REG_PHY2P1_0_P0_BASE + 0x12)
#define REG_PHY2P1_0_P0_09_H        (REG_PHY2P1_0_P0_BASE + 0x13)
#define REG_PHY2P1_0_P0_0A_L        (REG_PHY2P1_0_P0_BASE + 0x14)
#define REG_PHY2P1_0_P0_0A_H        (REG_PHY2P1_0_P0_BASE + 0x15)
#define REG_PHY2P1_0_P0_0B_L        (REG_PHY2P1_0_P0_BASE + 0x16)
#define REG_PHY2P1_0_P0_0B_H        (REG_PHY2P1_0_P0_BASE + 0x17)
#define REG_PHY2P1_0_P0_0C_L        (REG_PHY2P1_0_P0_BASE + 0x18)
#define REG_PHY2P1_0_P0_0C_H        (REG_PHY2P1_0_P0_BASE + 0x19)
#define REG_PHY2P1_0_P0_0D_L        (REG_PHY2P1_0_P0_BASE + 0x1A)
#define REG_PHY2P1_0_P0_0D_H        (REG_PHY2P1_0_P0_BASE + 0x1B)
#define REG_PHY2P1_0_P0_0E_L        (REG_PHY2P1_0_P0_BASE + 0x1C)
#define REG_PHY2P1_0_P0_0E_H        (REG_PHY2P1_0_P0_BASE + 0x1D)
#define REG_PHY2P1_0_P0_0F_L        (REG_PHY2P1_0_P0_BASE + 0x1E)
#define REG_PHY2P1_0_P0_0F_H        (REG_PHY2P1_0_P0_BASE + 0x1F)
#define REG_PHY2P1_0_P0_10_L        (REG_PHY2P1_0_P0_BASE + 0x20)
#define REG_PHY2P1_0_P0_10_H        (REG_PHY2P1_0_P0_BASE + 0x21)
#define REG_PHY2P1_0_P0_11_L        (REG_PHY2P1_0_P0_BASE + 0x22)
#define REG_PHY2P1_0_P0_11_H        (REG_PHY2P1_0_P0_BASE + 0x23)
#define REG_PHY2P1_0_P0_12_L        (REG_PHY2P1_0_P0_BASE + 0x24)
#define REG_PHY2P1_0_P0_12_H        (REG_PHY2P1_0_P0_BASE + 0x25)
#define REG_PHY2P1_0_P0_13_L        (REG_PHY2P1_0_P0_BASE + 0x26)
#define REG_PHY2P1_0_P0_13_H        (REG_PHY2P1_0_P0_BASE + 0x27)
#define REG_PHY2P1_0_P0_14_L        (REG_PHY2P1_0_P0_BASE + 0x28)
#define REG_PHY2P1_0_P0_14_H        (REG_PHY2P1_0_P0_BASE + 0x29)
#define REG_PHY2P1_0_P0_15_L        (REG_PHY2P1_0_P0_BASE + 0x2A)
#define REG_PHY2P1_0_P0_15_H        (REG_PHY2P1_0_P0_BASE + 0x2B)
#define REG_PHY2P1_0_P0_16_L        (REG_PHY2P1_0_P0_BASE + 0x2C)
#define REG_PHY2P1_0_P0_16_H        (REG_PHY2P1_0_P0_BASE + 0x2D)
#define REG_PHY2P1_0_P0_17_L        (REG_PHY2P1_0_P0_BASE + 0x2E)
#define REG_PHY2P1_0_P0_17_H        (REG_PHY2P1_0_P0_BASE + 0x2F)
#define REG_PHY2P1_0_P0_18_L        (REG_PHY2P1_0_P0_BASE + 0x30)
#define REG_PHY2P1_0_P0_18_H        (REG_PHY2P1_0_P0_BASE + 0x31)
#define REG_PHY2P1_0_P0_19_L        (REG_PHY2P1_0_P0_BASE + 0x32)
#define REG_PHY2P1_0_P0_19_H        (REG_PHY2P1_0_P0_BASE + 0x33)
#define REG_PHY2P1_0_P0_1A_L        (REG_PHY2P1_0_P0_BASE + 0x34)
#define REG_PHY2P1_0_P0_1A_H        (REG_PHY2P1_0_P0_BASE + 0x35)
#define REG_PHY2P1_0_P0_1B_L        (REG_PHY2P1_0_P0_BASE + 0x36)
#define REG_PHY2P1_0_P0_1B_H        (REG_PHY2P1_0_P0_BASE + 0x37)
#define REG_PHY2P1_0_P0_1C_L        (REG_PHY2P1_0_P0_BASE + 0x38)
#define REG_PHY2P1_0_P0_1C_H        (REG_PHY2P1_0_P0_BASE + 0x39)
#define REG_PHY2P1_0_P0_1D_L        (REG_PHY2P1_0_P0_BASE + 0x3A)
#define REG_PHY2P1_0_P0_1D_H        (REG_PHY2P1_0_P0_BASE + 0x3B)
#define REG_PHY2P1_0_P0_1E_L        (REG_PHY2P1_0_P0_BASE + 0x3C)
#define REG_PHY2P1_0_P0_1E_H        (REG_PHY2P1_0_P0_BASE + 0x3D)
#define REG_PHY2P1_0_P0_1F_L        (REG_PHY2P1_0_P0_BASE + 0x3E)
#define REG_PHY2P1_0_P0_1F_H        (REG_PHY2P1_0_P0_BASE + 0x3F)
#define REG_PHY2P1_0_P0_20_L        (REG_PHY2P1_0_P0_BASE + 0x40)
#define REG_PHY2P1_0_P0_20_H        (REG_PHY2P1_0_P0_BASE + 0x41)
#define REG_PHY2P1_0_P0_21_L        (REG_PHY2P1_0_P0_BASE + 0x42)
#define REG_PHY2P1_0_P0_21_H        (REG_PHY2P1_0_P0_BASE + 0x43)
#define REG_PHY2P1_0_P0_22_L        (REG_PHY2P1_0_P0_BASE + 0x44)
#define REG_PHY2P1_0_P0_22_H        (REG_PHY2P1_0_P0_BASE + 0x45)
#define REG_PHY2P1_0_P0_23_L        (REG_PHY2P1_0_P0_BASE + 0x46)
#define REG_PHY2P1_0_P0_23_H        (REG_PHY2P1_0_P0_BASE + 0x47)
#define REG_PHY2P1_0_P0_24_L        (REG_PHY2P1_0_P0_BASE + 0x48)
#define REG_PHY2P1_0_P0_24_H        (REG_PHY2P1_0_P0_BASE + 0x49)
#define REG_PHY2P1_0_P0_25_L        (REG_PHY2P1_0_P0_BASE + 0x4A)
#define REG_PHY2P1_0_P0_25_H        (REG_PHY2P1_0_P0_BASE + 0x4B)
#define REG_PHY2P1_0_P0_26_L        (REG_PHY2P1_0_P0_BASE + 0x4C)
#define REG_PHY2P1_0_P0_26_H        (REG_PHY2P1_0_P0_BASE + 0x4D)
#define REG_PHY2P1_0_P0_27_L        (REG_PHY2P1_0_P0_BASE + 0x4E)
#define REG_PHY2P1_0_P0_27_H        (REG_PHY2P1_0_P0_BASE + 0x4F)
#define REG_PHY2P1_0_P0_28_L        (REG_PHY2P1_0_P0_BASE + 0x50)
#define REG_PHY2P1_0_P0_28_H        (REG_PHY2P1_0_P0_BASE + 0x51)
#define REG_PHY2P1_0_P0_29_L        (REG_PHY2P1_0_P0_BASE + 0x52)
#define REG_PHY2P1_0_P0_29_H        (REG_PHY2P1_0_P0_BASE + 0x53)
#define REG_PHY2P1_0_P0_2A_L        (REG_PHY2P1_0_P0_BASE + 0x54)
#define REG_PHY2P1_0_P0_2A_H        (REG_PHY2P1_0_P0_BASE + 0x55)
#define REG_PHY2P1_0_P0_2B_L        (REG_PHY2P1_0_P0_BASE + 0x56)
#define REG_PHY2P1_0_P0_2B_H        (REG_PHY2P1_0_P0_BASE + 0x57)
#define REG_PHY2P1_0_P0_2C_L        (REG_PHY2P1_0_P0_BASE + 0x58)
#define REG_PHY2P1_0_P0_2C_H        (REG_PHY2P1_0_P0_BASE + 0x59)
#define REG_PHY2P1_0_P0_2D_L        (REG_PHY2P1_0_P0_BASE + 0x5A)
#define REG_PHY2P1_0_P0_2D_H        (REG_PHY2P1_0_P0_BASE + 0x5B)
#define REG_PHY2P1_0_P0_2E_L        (REG_PHY2P1_0_P0_BASE + 0x5C)
#define REG_PHY2P1_0_P0_2E_H        (REG_PHY2P1_0_P0_BASE + 0x5D)
#define REG_PHY2P1_0_P0_2F_L        (REG_PHY2P1_0_P0_BASE + 0x5E)
#define REG_PHY2P1_0_P0_2F_H        (REG_PHY2P1_0_P0_BASE + 0x5F)
#define REG_PHY2P1_0_P0_30_L        (REG_PHY2P1_0_P0_BASE + 0x60)
#define REG_PHY2P1_0_P0_30_H        (REG_PHY2P1_0_P0_BASE + 0x61)
#define REG_PHY2P1_0_P0_31_L        (REG_PHY2P1_0_P0_BASE + 0x62)
#define REG_PHY2P1_0_P0_31_H        (REG_PHY2P1_0_P0_BASE + 0x63)
#define REG_PHY2P1_0_P0_32_L        (REG_PHY2P1_0_P0_BASE + 0x64)
#define REG_PHY2P1_0_P0_32_H        (REG_PHY2P1_0_P0_BASE + 0x65)
#define REG_PHY2P1_0_P0_33_L        (REG_PHY2P1_0_P0_BASE + 0x66)
#define REG_PHY2P1_0_P0_33_H        (REG_PHY2P1_0_P0_BASE + 0x67)
#define REG_PHY2P1_0_P0_34_L        (REG_PHY2P1_0_P0_BASE + 0x68)
#define REG_PHY2P1_0_P0_34_H        (REG_PHY2P1_0_P0_BASE + 0x69)
#define REG_PHY2P1_0_P0_35_L        (REG_PHY2P1_0_P0_BASE + 0x6A)
#define REG_PHY2P1_0_P0_35_H        (REG_PHY2P1_0_P0_BASE + 0x6B)
#define REG_PHY2P1_0_P0_36_L        (REG_PHY2P1_0_P0_BASE + 0x6C)
#define REG_PHY2P1_0_P0_36_H        (REG_PHY2P1_0_P0_BASE + 0x6D)
#define REG_PHY2P1_0_P0_37_L        (REG_PHY2P1_0_P0_BASE + 0x6E)
#define REG_PHY2P1_0_P0_37_H        (REG_PHY2P1_0_P0_BASE + 0x6F)
#define REG_PHY2P1_0_P0_38_L        (REG_PHY2P1_0_P0_BASE + 0x70)
#define REG_PHY2P1_0_P0_38_H        (REG_PHY2P1_0_P0_BASE + 0x71)
#define REG_PHY2P1_0_P0_39_L        (REG_PHY2P1_0_P0_BASE + 0x72)
#define REG_PHY2P1_0_P0_39_H        (REG_PHY2P1_0_P0_BASE + 0x73)
#define REG_PHY2P1_0_P0_3A_L        (REG_PHY2P1_0_P0_BASE + 0x74)
#define REG_PHY2P1_0_P0_3A_H        (REG_PHY2P1_0_P0_BASE + 0x75)
#define REG_PHY2P1_0_P0_3B_L        (REG_PHY2P1_0_P0_BASE + 0x76)
#define REG_PHY2P1_0_P0_3B_H        (REG_PHY2P1_0_P0_BASE + 0x77)
#define REG_PHY2P1_0_P0_3C_L        (REG_PHY2P1_0_P0_BASE + 0x78)
#define REG_PHY2P1_0_P0_3C_H        (REG_PHY2P1_0_P0_BASE + 0x79)
#define REG_PHY2P1_0_P0_3D_L        (REG_PHY2P1_0_P0_BASE + 0x7A)
#define REG_PHY2P1_0_P0_3D_H        (REG_PHY2P1_0_P0_BASE + 0x7B)
#define REG_PHY2P1_0_P0_3E_L        (REG_PHY2P1_0_P0_BASE + 0x7C)
#define REG_PHY2P1_0_P0_3E_H        (REG_PHY2P1_0_P0_BASE + 0x7D)
#define REG_PHY2P1_0_P0_3F_L        (REG_PHY2P1_0_P0_BASE + 0x7E)
#define REG_PHY2P1_0_P0_3F_H        (REG_PHY2P1_0_P0_BASE + 0x7F)
#define REG_PHY2P1_0_P0_40_L        (REG_PHY2P1_0_P0_BASE + 0x80)
#define REG_PHY2P1_0_P0_40_H        (REG_PHY2P1_0_P0_BASE + 0x81)
#define REG_PHY2P1_0_P0_41_L        (REG_PHY2P1_0_P0_BASE + 0x82)
#define REG_PHY2P1_0_P0_41_H        (REG_PHY2P1_0_P0_BASE + 0x83)
#define REG_PHY2P1_0_P0_42_L        (REG_PHY2P1_0_P0_BASE + 0x84)
#define REG_PHY2P1_0_P0_42_H        (REG_PHY2P1_0_P0_BASE + 0x85)
#define REG_PHY2P1_0_P0_43_L        (REG_PHY2P1_0_P0_BASE + 0x86)
#define REG_PHY2P1_0_P0_43_H        (REG_PHY2P1_0_P0_BASE + 0x87)
#define REG_PHY2P1_0_P0_44_L        (REG_PHY2P1_0_P0_BASE + 0x88)
#define REG_PHY2P1_0_P0_44_H        (REG_PHY2P1_0_P0_BASE + 0x89)
#define REG_PHY2P1_0_P0_45_L        (REG_PHY2P1_0_P0_BASE + 0x8A)
#define REG_PHY2P1_0_P0_45_H        (REG_PHY2P1_0_P0_BASE + 0x8B)
#define REG_PHY2P1_0_P0_46_L        (REG_PHY2P1_0_P0_BASE + 0x8C)
#define REG_PHY2P1_0_P0_46_H        (REG_PHY2P1_0_P0_BASE + 0x8D)
#define REG_PHY2P1_0_P0_47_L        (REG_PHY2P1_0_P0_BASE + 0x8E)
#define REG_PHY2P1_0_P0_47_H        (REG_PHY2P1_0_P0_BASE + 0x8F)
#define REG_PHY2P1_0_P0_48_L        (REG_PHY2P1_0_P0_BASE + 0x90)
#define REG_PHY2P1_0_P0_48_H        (REG_PHY2P1_0_P0_BASE + 0x91)
#define REG_PHY2P1_0_P0_49_L        (REG_PHY2P1_0_P0_BASE + 0x92)
#define REG_PHY2P1_0_P0_49_H        (REG_PHY2P1_0_P0_BASE + 0x93)
#define REG_PHY2P1_0_P0_4A_L        (REG_PHY2P1_0_P0_BASE + 0x94)
#define REG_PHY2P1_0_P0_4A_H        (REG_PHY2P1_0_P0_BASE + 0x95)
#define REG_PHY2P1_0_P0_4B_L        (REG_PHY2P1_0_P0_BASE + 0x96)
#define REG_PHY2P1_0_P0_4B_H        (REG_PHY2P1_0_P0_BASE + 0x97)
#define REG_PHY2P1_0_P0_4C_L        (REG_PHY2P1_0_P0_BASE + 0x98)
#define REG_PHY2P1_0_P0_4C_H        (REG_PHY2P1_0_P0_BASE + 0x99)
#define REG_PHY2P1_0_P0_4D_L        (REG_PHY2P1_0_P0_BASE + 0x9A)
#define REG_PHY2P1_0_P0_4D_H        (REG_PHY2P1_0_P0_BASE + 0x9B)
#define REG_PHY2P1_0_P0_4E_L        (REG_PHY2P1_0_P0_BASE + 0x9C)
#define REG_PHY2P1_0_P0_4E_H        (REG_PHY2P1_0_P0_BASE + 0x9D)
#define REG_PHY2P1_0_P0_4F_L        (REG_PHY2P1_0_P0_BASE + 0x9E)
#define REG_PHY2P1_0_P0_4F_H        (REG_PHY2P1_0_P0_BASE + 0x9F)
#define REG_PHY2P1_0_P0_50_L        (REG_PHY2P1_0_P0_BASE + 0xA0)
#define REG_PHY2P1_0_P0_50_H        (REG_PHY2P1_0_P0_BASE + 0xA1)
#define REG_PHY2P1_0_P0_51_L        (REG_PHY2P1_0_P0_BASE + 0xA2)
#define REG_PHY2P1_0_P0_51_H        (REG_PHY2P1_0_P0_BASE + 0xA3)
#define REG_PHY2P1_0_P0_52_L        (REG_PHY2P1_0_P0_BASE + 0xA4)
#define REG_PHY2P1_0_P0_52_H        (REG_PHY2P1_0_P0_BASE + 0xA5)
#define REG_PHY2P1_0_P0_53_L        (REG_PHY2P1_0_P0_BASE + 0xA6)
#define REG_PHY2P1_0_P0_53_H        (REG_PHY2P1_0_P0_BASE + 0xA7)
#define REG_PHY2P1_0_P0_54_L        (REG_PHY2P1_0_P0_BASE + 0xA8)
#define REG_PHY2P1_0_P0_54_H        (REG_PHY2P1_0_P0_BASE + 0xA9)
#define REG_PHY2P1_0_P0_55_L        (REG_PHY2P1_0_P0_BASE + 0xAA)
#define REG_PHY2P1_0_P0_55_H        (REG_PHY2P1_0_P0_BASE + 0xAB)
#define REG_PHY2P1_0_P0_56_L        (REG_PHY2P1_0_P0_BASE + 0xAC)
#define REG_PHY2P1_0_P0_56_H        (REG_PHY2P1_0_P0_BASE + 0xAD)
#define REG_PHY2P1_0_P0_57_L        (REG_PHY2P1_0_P0_BASE + 0xAE)
#define REG_PHY2P1_0_P0_57_H        (REG_PHY2P1_0_P0_BASE + 0xAF)
#define REG_PHY2P1_0_P0_58_L        (REG_PHY2P1_0_P0_BASE + 0xB0)
#define REG_PHY2P1_0_P0_58_H        (REG_PHY2P1_0_P0_BASE + 0xB1)
#define REG_PHY2P1_0_P0_59_L        (REG_PHY2P1_0_P0_BASE + 0xB2)
#define REG_PHY2P1_0_P0_59_H        (REG_PHY2P1_0_P0_BASE + 0xB3)
#define REG_PHY2P1_0_P0_5A_L        (REG_PHY2P1_0_P0_BASE + 0xB4)
#define REG_PHY2P1_0_P0_5A_H        (REG_PHY2P1_0_P0_BASE + 0xB5)
#define REG_PHY2P1_0_P0_5B_L        (REG_PHY2P1_0_P0_BASE + 0xB6)
#define REG_PHY2P1_0_P0_5B_H        (REG_PHY2P1_0_P0_BASE + 0xB7)
#define REG_PHY2P1_0_P0_5C_L        (REG_PHY2P1_0_P0_BASE + 0xB8)
#define REG_PHY2P1_0_P0_5C_H        (REG_PHY2P1_0_P0_BASE + 0xB9)
#define REG_PHY2P1_0_P0_5D_L        (REG_PHY2P1_0_P0_BASE + 0xBA)
#define REG_PHY2P1_0_P0_5D_H        (REG_PHY2P1_0_P0_BASE + 0xBB)
#define REG_PHY2P1_0_P0_5E_L        (REG_PHY2P1_0_P0_BASE + 0xBC)
#define REG_PHY2P1_0_P0_5E_H        (REG_PHY2P1_0_P0_BASE + 0xBD)
#define REG_PHY2P1_0_P0_5F_L        (REG_PHY2P1_0_P0_BASE + 0xBE)
#define REG_PHY2P1_0_P0_5F_H        (REG_PHY2P1_0_P0_BASE + 0xBF)
#define REG_PHY2P1_0_P0_60_L        (REG_PHY2P1_0_P0_BASE + 0xC0)
#define REG_PHY2P1_0_P0_60_H        (REG_PHY2P1_0_P0_BASE + 0xC1)
#define REG_PHY2P1_0_P0_61_L        (REG_PHY2P1_0_P0_BASE + 0xC2)
#define REG_PHY2P1_0_P0_61_H        (REG_PHY2P1_0_P0_BASE + 0xC3)
#define REG_PHY2P1_0_P0_62_L        (REG_PHY2P1_0_P0_BASE + 0xC4)
#define REG_PHY2P1_0_P0_62_H        (REG_PHY2P1_0_P0_BASE + 0xC5)
#define REG_PHY2P1_0_P0_63_L        (REG_PHY2P1_0_P0_BASE + 0xC6)
#define REG_PHY2P1_0_P0_63_H        (REG_PHY2P1_0_P0_BASE + 0xC7)
#define REG_PHY2P1_0_P0_64_L        (REG_PHY2P1_0_P0_BASE + 0xC8)
#define REG_PHY2P1_0_P0_64_H        (REG_PHY2P1_0_P0_BASE + 0xC9)
#define REG_PHY2P1_0_P0_65_L        (REG_PHY2P1_0_P0_BASE + 0xCA)
#define REG_PHY2P1_0_P0_65_H        (REG_PHY2P1_0_P0_BASE + 0xCB)
#define REG_PHY2P1_0_P0_66_L        (REG_PHY2P1_0_P0_BASE + 0xCC)
#define REG_PHY2P1_0_P0_66_H        (REG_PHY2P1_0_P0_BASE + 0xCD)
#define REG_PHY2P1_0_P0_67_L        (REG_PHY2P1_0_P0_BASE + 0xCE)
#define REG_PHY2P1_0_P0_67_H        (REG_PHY2P1_0_P0_BASE + 0xCF)
#define REG_PHY2P1_0_P0_68_L        (REG_PHY2P1_0_P0_BASE + 0xD0)
#define REG_PHY2P1_0_P0_68_H        (REG_PHY2P1_0_P0_BASE + 0xD1)
#define REG_PHY2P1_0_P0_69_L        (REG_PHY2P1_0_P0_BASE + 0xD2)
#define REG_PHY2P1_0_P0_69_H        (REG_PHY2P1_0_P0_BASE + 0xD3)
#define REG_PHY2P1_0_P0_6A_L        (REG_PHY2P1_0_P0_BASE + 0xD4)
#define REG_PHY2P1_0_P0_6A_H        (REG_PHY2P1_0_P0_BASE + 0xD5)
#define REG_PHY2P1_0_P0_6B_L        (REG_PHY2P1_0_P0_BASE + 0xD6)
#define REG_PHY2P1_0_P0_6B_H        (REG_PHY2P1_0_P0_BASE + 0xD7)
#define REG_PHY2P1_0_P0_6C_L        (REG_PHY2P1_0_P0_BASE + 0xD8)
#define REG_PHY2P1_0_P0_6C_H        (REG_PHY2P1_0_P0_BASE + 0xD9)
#define REG_PHY2P1_0_P0_6D_L        (REG_PHY2P1_0_P0_BASE + 0xDA)
#define REG_PHY2P1_0_P0_6D_H        (REG_PHY2P1_0_P0_BASE + 0xDB)
#define REG_PHY2P1_0_P0_6E_L        (REG_PHY2P1_0_P0_BASE + 0xDC)
#define REG_PHY2P1_0_P0_6E_H        (REG_PHY2P1_0_P0_BASE + 0xDD)
#define REG_PHY2P1_0_P0_6F_L        (REG_PHY2P1_0_P0_BASE + 0xDE)
#define REG_PHY2P1_0_P0_6F_H        (REG_PHY2P1_0_P0_BASE + 0xDF)
#define REG_PHY2P1_0_P0_70_L        (REG_PHY2P1_0_P0_BASE + 0xE0)
#define REG_PHY2P1_0_P0_70_H        (REG_PHY2P1_0_P0_BASE + 0xE1)
#define REG_PHY2P1_0_P0_71_L        (REG_PHY2P1_0_P0_BASE + 0xE2)
#define REG_PHY2P1_0_P0_71_H        (REG_PHY2P1_0_P0_BASE + 0xE3)
#define REG_PHY2P1_0_P0_72_L        (REG_PHY2P1_0_P0_BASE + 0xE4)
#define REG_PHY2P1_0_P0_72_H        (REG_PHY2P1_0_P0_BASE + 0xE5)
#define REG_PHY2P1_0_P0_73_L        (REG_PHY2P1_0_P0_BASE + 0xE6)
#define REG_PHY2P1_0_P0_73_H        (REG_PHY2P1_0_P0_BASE + 0xE7)
#define REG_PHY2P1_0_P0_74_L        (REG_PHY2P1_0_P0_BASE + 0xE8)
#define REG_PHY2P1_0_P0_74_H        (REG_PHY2P1_0_P0_BASE + 0xE9)
#define REG_PHY2P1_0_P0_75_L        (REG_PHY2P1_0_P0_BASE + 0xEA)
#define REG_PHY2P1_0_P0_75_H        (REG_PHY2P1_0_P0_BASE + 0xEB)
#define REG_PHY2P1_0_P0_76_L        (REG_PHY2P1_0_P0_BASE + 0xEC)
#define REG_PHY2P1_0_P0_76_H        (REG_PHY2P1_0_P0_BASE + 0xED)
#define REG_PHY2P1_0_P0_77_L        (REG_PHY2P1_0_P0_BASE + 0xEE)
#define REG_PHY2P1_0_P0_77_H        (REG_PHY2P1_0_P0_BASE + 0xEF)
#define REG_PHY2P1_0_P0_78_L        (REG_PHY2P1_0_P0_BASE + 0xF0)
#define REG_PHY2P1_0_P0_78_H        (REG_PHY2P1_0_P0_BASE + 0xF1)
#define REG_PHY2P1_0_P0_79_L        (REG_PHY2P1_0_P0_BASE + 0xF2)
#define REG_PHY2P1_0_P0_79_H        (REG_PHY2P1_0_P0_BASE + 0xF3)
#define REG_PHY2P1_0_P0_7A_L        (REG_PHY2P1_0_P0_BASE + 0xF4)
#define REG_PHY2P1_0_P0_7A_H        (REG_PHY2P1_0_P0_BASE + 0xF5)
#define REG_PHY2P1_0_P0_7B_L        (REG_PHY2P1_0_P0_BASE + 0xF6)
#define REG_PHY2P1_0_P0_7B_H        (REG_PHY2P1_0_P0_BASE + 0xF7)
#define REG_PHY2P1_0_P0_7C_L        (REG_PHY2P1_0_P0_BASE + 0xF8)
#define REG_PHY2P1_0_P0_7C_H        (REG_PHY2P1_0_P0_BASE + 0xF9)
#define REG_PHY2P1_0_P0_7D_L        (REG_PHY2P1_0_P0_BASE + 0xFA)
#define REG_PHY2P1_0_P0_7D_H        (REG_PHY2P1_0_P0_BASE + 0xFB)
#define REG_PHY2P1_0_P0_7E_L        (REG_PHY2P1_0_P0_BASE + 0xFC)
#define REG_PHY2P1_0_P0_7E_H        (REG_PHY2P1_0_P0_BASE + 0xFD)
#define REG_PHY2P1_0_P0_7F_L        (REG_PHY2P1_0_P0_BASE + 0xFE)
#define REG_PHY2P1_0_P0_7F_H        (REG_PHY2P1_0_P0_BASE + 0xFF)

//=============================================================
// PHY2P1_1_P0
#define REG_PHY2P1_1_P0_00_L        (REG_PHY2P1_1_P0_BASE + 0x00)
#define REG_PHY2P1_1_P0_00_H        (REG_PHY2P1_1_P0_BASE + 0x01)
#define REG_PHY2P1_1_P0_01_L        (REG_PHY2P1_1_P0_BASE + 0x02)
#define REG_PHY2P1_1_P0_01_H        (REG_PHY2P1_1_P0_BASE + 0x03)
#define REG_PHY2P1_1_P0_02_L        (REG_PHY2P1_1_P0_BASE + 0x04)
#define REG_PHY2P1_1_P0_02_H        (REG_PHY2P1_1_P0_BASE + 0x05)
#define REG_PHY2P1_1_P0_03_L        (REG_PHY2P1_1_P0_BASE + 0x06)
#define REG_PHY2P1_1_P0_03_H        (REG_PHY2P1_1_P0_BASE + 0x07)
#define REG_PHY2P1_1_P0_04_L        (REG_PHY2P1_1_P0_BASE + 0x08)
#define REG_PHY2P1_1_P0_04_H        (REG_PHY2P1_1_P0_BASE + 0x09)
#define REG_PHY2P1_1_P0_05_L        (REG_PHY2P1_1_P0_BASE + 0x0A)
#define REG_PHY2P1_1_P0_05_H        (REG_PHY2P1_1_P0_BASE + 0x0B)
#define REG_PHY2P1_1_P0_06_L        (REG_PHY2P1_1_P0_BASE + 0x0C)
#define REG_PHY2P1_1_P0_06_H        (REG_PHY2P1_1_P0_BASE + 0x0D)
#define REG_PHY2P1_1_P0_07_L        (REG_PHY2P1_1_P0_BASE + 0x0E)
#define REG_PHY2P1_1_P0_07_H        (REG_PHY2P1_1_P0_BASE + 0x0F)
#define REG_PHY2P1_1_P0_08_L        (REG_PHY2P1_1_P0_BASE + 0x10)
#define REG_PHY2P1_1_P0_08_H        (REG_PHY2P1_1_P0_BASE + 0x11)
#define REG_PHY2P1_1_P0_09_L        (REG_PHY2P1_1_P0_BASE + 0x12)
#define REG_PHY2P1_1_P0_09_H        (REG_PHY2P1_1_P0_BASE + 0x13)
#define REG_PHY2P1_1_P0_0A_L        (REG_PHY2P1_1_P0_BASE + 0x14)
#define REG_PHY2P1_1_P0_0A_H        (REG_PHY2P1_1_P0_BASE + 0x15)
#define REG_PHY2P1_1_P0_0B_L        (REG_PHY2P1_1_P0_BASE + 0x16)
#define REG_PHY2P1_1_P0_0B_H        (REG_PHY2P1_1_P0_BASE + 0x17)
#define REG_PHY2P1_1_P0_0C_L        (REG_PHY2P1_1_P0_BASE + 0x18)
#define REG_PHY2P1_1_P0_0C_H        (REG_PHY2P1_1_P0_BASE + 0x19)
#define REG_PHY2P1_1_P0_0D_L        (REG_PHY2P1_1_P0_BASE + 0x1A)
#define REG_PHY2P1_1_P0_0D_H        (REG_PHY2P1_1_P0_BASE + 0x1B)
#define REG_PHY2P1_1_P0_0E_L        (REG_PHY2P1_1_P0_BASE + 0x1C)
#define REG_PHY2P1_1_P0_0E_H        (REG_PHY2P1_1_P0_BASE + 0x1D)
#define REG_PHY2P1_1_P0_0F_L        (REG_PHY2P1_1_P0_BASE + 0x1E)
#define REG_PHY2P1_1_P0_0F_H        (REG_PHY2P1_1_P0_BASE + 0x1F)
#define REG_PHY2P1_1_P0_10_L        (REG_PHY2P1_1_P0_BASE + 0x20)
#define REG_PHY2P1_1_P0_10_H        (REG_PHY2P1_1_P0_BASE + 0x21)
#define REG_PHY2P1_1_P0_11_L        (REG_PHY2P1_1_P0_BASE + 0x22)
#define REG_PHY2P1_1_P0_11_H        (REG_PHY2P1_1_P0_BASE + 0x23)
#define REG_PHY2P1_1_P0_12_L        (REG_PHY2P1_1_P0_BASE + 0x24)
#define REG_PHY2P1_1_P0_12_H        (REG_PHY2P1_1_P0_BASE + 0x25)
#define REG_PHY2P1_1_P0_13_L        (REG_PHY2P1_1_P0_BASE + 0x26)
#define REG_PHY2P1_1_P0_13_H        (REG_PHY2P1_1_P0_BASE + 0x27)
#define REG_PHY2P1_1_P0_14_L        (REG_PHY2P1_1_P0_BASE + 0x28)
#define REG_PHY2P1_1_P0_14_H        (REG_PHY2P1_1_P0_BASE + 0x29)
#define REG_PHY2P1_1_P0_15_L        (REG_PHY2P1_1_P0_BASE + 0x2A)
#define REG_PHY2P1_1_P0_15_H        (REG_PHY2P1_1_P0_BASE + 0x2B)
#define REG_PHY2P1_1_P0_16_L        (REG_PHY2P1_1_P0_BASE + 0x2C)
#define REG_PHY2P1_1_P0_16_H        (REG_PHY2P1_1_P0_BASE + 0x2D)
#define REG_PHY2P1_1_P0_17_L        (REG_PHY2P1_1_P0_BASE + 0x2E)
#define REG_PHY2P1_1_P0_17_H        (REG_PHY2P1_1_P0_BASE + 0x2F)
#define REG_PHY2P1_1_P0_18_L        (REG_PHY2P1_1_P0_BASE + 0x30)
#define REG_PHY2P1_1_P0_18_H        (REG_PHY2P1_1_P0_BASE + 0x31)
#define REG_PHY2P1_1_P0_19_L        (REG_PHY2P1_1_P0_BASE + 0x32)
#define REG_PHY2P1_1_P0_19_H        (REG_PHY2P1_1_P0_BASE + 0x33)
#define REG_PHY2P1_1_P0_1A_L        (REG_PHY2P1_1_P0_BASE + 0x34)
#define REG_PHY2P1_1_P0_1A_H        (REG_PHY2P1_1_P0_BASE + 0x35)
#define REG_PHY2P1_1_P0_1B_L        (REG_PHY2P1_1_P0_BASE + 0x36)
#define REG_PHY2P1_1_P0_1B_H        (REG_PHY2P1_1_P0_BASE + 0x37)
#define REG_PHY2P1_1_P0_1C_L        (REG_PHY2P1_1_P0_BASE + 0x38)
#define REG_PHY2P1_1_P0_1C_H        (REG_PHY2P1_1_P0_BASE + 0x39)
#define REG_PHY2P1_1_P0_1D_L        (REG_PHY2P1_1_P0_BASE + 0x3A)
#define REG_PHY2P1_1_P0_1D_H        (REG_PHY2P1_1_P0_BASE + 0x3B)
#define REG_PHY2P1_1_P0_1E_L        (REG_PHY2P1_1_P0_BASE + 0x3C)
#define REG_PHY2P1_1_P0_1E_H        (REG_PHY2P1_1_P0_BASE + 0x3D)
#define REG_PHY2P1_1_P0_1F_L        (REG_PHY2P1_1_P0_BASE + 0x3E)
#define REG_PHY2P1_1_P0_1F_H        (REG_PHY2P1_1_P0_BASE + 0x3F)
#define REG_PHY2P1_1_P0_20_L        (REG_PHY2P1_1_P0_BASE + 0x40)
#define REG_PHY2P1_1_P0_20_H        (REG_PHY2P1_1_P0_BASE + 0x41)
#define REG_PHY2P1_1_P0_21_L        (REG_PHY2P1_1_P0_BASE + 0x42)
#define REG_PHY2P1_1_P0_21_H        (REG_PHY2P1_1_P0_BASE + 0x43)
#define REG_PHY2P1_1_P0_22_L        (REG_PHY2P1_1_P0_BASE + 0x44)
#define REG_PHY2P1_1_P0_22_H        (REG_PHY2P1_1_P0_BASE + 0x45)
#define REG_PHY2P1_1_P0_23_L        (REG_PHY2P1_1_P0_BASE + 0x46)
#define REG_PHY2P1_1_P0_23_H        (REG_PHY2P1_1_P0_BASE + 0x47)
#define REG_PHY2P1_1_P0_24_L        (REG_PHY2P1_1_P0_BASE + 0x48)
#define REG_PHY2P1_1_P0_24_H        (REG_PHY2P1_1_P0_BASE + 0x49)
#define REG_PHY2P1_1_P0_25_L        (REG_PHY2P1_1_P0_BASE + 0x4A)
#define REG_PHY2P1_1_P0_25_H        (REG_PHY2P1_1_P0_BASE + 0x4B)
#define REG_PHY2P1_1_P0_26_L        (REG_PHY2P1_1_P0_BASE + 0x4C)
#define REG_PHY2P1_1_P0_26_H        (REG_PHY2P1_1_P0_BASE + 0x4D)
#define REG_PHY2P1_1_P0_27_L        (REG_PHY2P1_1_P0_BASE + 0x4E)
#define REG_PHY2P1_1_P0_27_H        (REG_PHY2P1_1_P0_BASE + 0x4F)
#define REG_PHY2P1_1_P0_28_L        (REG_PHY2P1_1_P0_BASE + 0x50)
#define REG_PHY2P1_1_P0_28_H        (REG_PHY2P1_1_P0_BASE + 0x51)
#define REG_PHY2P1_1_P0_29_L        (REG_PHY2P1_1_P0_BASE + 0x52)
#define REG_PHY2P1_1_P0_29_H        (REG_PHY2P1_1_P0_BASE + 0x53)
#define REG_PHY2P1_1_P0_2A_L        (REG_PHY2P1_1_P0_BASE + 0x54)
#define REG_PHY2P1_1_P0_2A_H        (REG_PHY2P1_1_P0_BASE + 0x55)
#define REG_PHY2P1_1_P0_2B_L        (REG_PHY2P1_1_P0_BASE + 0x56)
#define REG_PHY2P1_1_P0_2B_H        (REG_PHY2P1_1_P0_BASE + 0x57)
#define REG_PHY2P1_1_P0_2C_L        (REG_PHY2P1_1_P0_BASE + 0x58)
#define REG_PHY2P1_1_P0_2C_H        (REG_PHY2P1_1_P0_BASE + 0x59)
#define REG_PHY2P1_1_P0_2D_L        (REG_PHY2P1_1_P0_BASE + 0x5A)
#define REG_PHY2P1_1_P0_2D_H        (REG_PHY2P1_1_P0_BASE + 0x5B)
#define REG_PHY2P1_1_P0_2E_L        (REG_PHY2P1_1_P0_BASE + 0x5C)
#define REG_PHY2P1_1_P0_2E_H        (REG_PHY2P1_1_P0_BASE + 0x5D)
#define REG_PHY2P1_1_P0_2F_L        (REG_PHY2P1_1_P0_BASE + 0x5E)
#define REG_PHY2P1_1_P0_2F_H        (REG_PHY2P1_1_P0_BASE + 0x5F)
#define REG_PHY2P1_1_P0_30_L        (REG_PHY2P1_1_P0_BASE + 0x60)
#define REG_PHY2P1_1_P0_30_H        (REG_PHY2P1_1_P0_BASE + 0x61)
#define REG_PHY2P1_1_P0_31_L        (REG_PHY2P1_1_P0_BASE + 0x62)
#define REG_PHY2P1_1_P0_31_H        (REG_PHY2P1_1_P0_BASE + 0x63)
#define REG_PHY2P1_1_P0_32_L        (REG_PHY2P1_1_P0_BASE + 0x64)
#define REG_PHY2P1_1_P0_32_H        (REG_PHY2P1_1_P0_BASE + 0x65)
#define REG_PHY2P1_1_P0_33_L        (REG_PHY2P1_1_P0_BASE + 0x66)
#define REG_PHY2P1_1_P0_33_H        (REG_PHY2P1_1_P0_BASE + 0x67)
#define REG_PHY2P1_1_P0_34_L        (REG_PHY2P1_1_P0_BASE + 0x68)
#define REG_PHY2P1_1_P0_34_H        (REG_PHY2P1_1_P0_BASE + 0x69)
#define REG_PHY2P1_1_P0_35_L        (REG_PHY2P1_1_P0_BASE + 0x6A)
#define REG_PHY2P1_1_P0_35_H        (REG_PHY2P1_1_P0_BASE + 0x6B)
#define REG_PHY2P1_1_P0_36_L        (REG_PHY2P1_1_P0_BASE + 0x6C)
#define REG_PHY2P1_1_P0_36_H        (REG_PHY2P1_1_P0_BASE + 0x6D)
#define REG_PHY2P1_1_P0_37_L        (REG_PHY2P1_1_P0_BASE + 0x6E)
#define REG_PHY2P1_1_P0_37_H        (REG_PHY2P1_1_P0_BASE + 0x6F)
#define REG_PHY2P1_1_P0_38_L        (REG_PHY2P1_1_P0_BASE + 0x70)
#define REG_PHY2P1_1_P0_38_H        (REG_PHY2P1_1_P0_BASE + 0x71)
#define REG_PHY2P1_1_P0_39_L        (REG_PHY2P1_1_P0_BASE + 0x72)
#define REG_PHY2P1_1_P0_39_H        (REG_PHY2P1_1_P0_BASE + 0x73)
#define REG_PHY2P1_1_P0_3A_L        (REG_PHY2P1_1_P0_BASE + 0x74)
#define REG_PHY2P1_1_P0_3A_H        (REG_PHY2P1_1_P0_BASE + 0x75)
#define REG_PHY2P1_1_P0_3B_L        (REG_PHY2P1_1_P0_BASE + 0x76)
#define REG_PHY2P1_1_P0_3B_H        (REG_PHY2P1_1_P0_BASE + 0x77)
#define REG_PHY2P1_1_P0_3C_L        (REG_PHY2P1_1_P0_BASE + 0x78)
#define REG_PHY2P1_1_P0_3C_H        (REG_PHY2P1_1_P0_BASE + 0x79)
#define REG_PHY2P1_1_P0_3D_L        (REG_PHY2P1_1_P0_BASE + 0x7A)
#define REG_PHY2P1_1_P0_3D_H        (REG_PHY2P1_1_P0_BASE + 0x7B)
#define REG_PHY2P1_1_P0_3E_L        (REG_PHY2P1_1_P0_BASE + 0x7C)
#define REG_PHY2P1_1_P0_3E_H        (REG_PHY2P1_1_P0_BASE + 0x7D)
#define REG_PHY2P1_1_P0_3F_L        (REG_PHY2P1_1_P0_BASE + 0x7E)
#define REG_PHY2P1_1_P0_3F_H        (REG_PHY2P1_1_P0_BASE + 0x7F)
#define REG_PHY2P1_1_P0_40_L        (REG_PHY2P1_1_P0_BASE + 0x80)
#define REG_PHY2P1_1_P0_40_H        (REG_PHY2P1_1_P0_BASE + 0x81)
#define REG_PHY2P1_1_P0_41_L        (REG_PHY2P1_1_P0_BASE + 0x82)
#define REG_PHY2P1_1_P0_41_H        (REG_PHY2P1_1_P0_BASE + 0x83)
#define REG_PHY2P1_1_P0_42_L        (REG_PHY2P1_1_P0_BASE + 0x84)
#define REG_PHY2P1_1_P0_42_H        (REG_PHY2P1_1_P0_BASE + 0x85)
#define REG_PHY2P1_1_P0_43_L        (REG_PHY2P1_1_P0_BASE + 0x86)
#define REG_PHY2P1_1_P0_43_H        (REG_PHY2P1_1_P0_BASE + 0x87)
#define REG_PHY2P1_1_P0_44_L        (REG_PHY2P1_1_P0_BASE + 0x88)
#define REG_PHY2P1_1_P0_44_H        (REG_PHY2P1_1_P0_BASE + 0x89)
#define REG_PHY2P1_1_P0_45_L        (REG_PHY2P1_1_P0_BASE + 0x8A)
#define REG_PHY2P1_1_P0_45_H        (REG_PHY2P1_1_P0_BASE + 0x8B)
#define REG_PHY2P1_1_P0_46_L        (REG_PHY2P1_1_P0_BASE + 0x8C)
#define REG_PHY2P1_1_P0_46_H        (REG_PHY2P1_1_P0_BASE + 0x8D)
#define REG_PHY2P1_1_P0_47_L        (REG_PHY2P1_1_P0_BASE + 0x8E)
#define REG_PHY2P1_1_P0_47_H        (REG_PHY2P1_1_P0_BASE + 0x8F)
#define REG_PHY2P1_1_P0_48_L        (REG_PHY2P1_1_P0_BASE + 0x90)
#define REG_PHY2P1_1_P0_48_H        (REG_PHY2P1_1_P0_BASE + 0x91)
#define REG_PHY2P1_1_P0_49_L        (REG_PHY2P1_1_P0_BASE + 0x92)
#define REG_PHY2P1_1_P0_49_H        (REG_PHY2P1_1_P0_BASE + 0x93)
#define REG_PHY2P1_1_P0_4A_L        (REG_PHY2P1_1_P0_BASE + 0x94)
#define REG_PHY2P1_1_P0_4A_H        (REG_PHY2P1_1_P0_BASE + 0x95)
#define REG_PHY2P1_1_P0_4B_L        (REG_PHY2P1_1_P0_BASE + 0x96)
#define REG_PHY2P1_1_P0_4B_H        (REG_PHY2P1_1_P0_BASE + 0x97)
#define REG_PHY2P1_1_P0_4C_L        (REG_PHY2P1_1_P0_BASE + 0x98)
#define REG_PHY2P1_1_P0_4C_H        (REG_PHY2P1_1_P0_BASE + 0x99)
#define REG_PHY2P1_1_P0_4D_L        (REG_PHY2P1_1_P0_BASE + 0x9A)
#define REG_PHY2P1_1_P0_4D_H        (REG_PHY2P1_1_P0_BASE + 0x9B)
#define REG_PHY2P1_1_P0_4E_L        (REG_PHY2P1_1_P0_BASE + 0x9C)
#define REG_PHY2P1_1_P0_4E_H        (REG_PHY2P1_1_P0_BASE + 0x9D)
#define REG_PHY2P1_1_P0_4F_L        (REG_PHY2P1_1_P0_BASE + 0x9E)
#define REG_PHY2P1_1_P0_4F_H        (REG_PHY2P1_1_P0_BASE + 0x9F)
#define REG_PHY2P1_1_P0_50_L        (REG_PHY2P1_1_P0_BASE + 0xA0)
#define REG_PHY2P1_1_P0_50_H        (REG_PHY2P1_1_P0_BASE + 0xA1)
#define REG_PHY2P1_1_P0_51_L        (REG_PHY2P1_1_P0_BASE + 0xA2)
#define REG_PHY2P1_1_P0_51_H        (REG_PHY2P1_1_P0_BASE + 0xA3)
#define REG_PHY2P1_1_P0_52_L        (REG_PHY2P1_1_P0_BASE + 0xA4)
#define REG_PHY2P1_1_P0_52_H        (REG_PHY2P1_1_P0_BASE + 0xA5)
#define REG_PHY2P1_1_P0_53_L        (REG_PHY2P1_1_P0_BASE + 0xA6)
#define REG_PHY2P1_1_P0_53_H        (REG_PHY2P1_1_P0_BASE + 0xA7)
#define REG_PHY2P1_1_P0_54_L        (REG_PHY2P1_1_P0_BASE + 0xA8)
#define REG_PHY2P1_1_P0_54_H        (REG_PHY2P1_1_P0_BASE + 0xA9)
#define REG_PHY2P1_1_P0_55_L        (REG_PHY2P1_1_P0_BASE + 0xAA)
#define REG_PHY2P1_1_P0_55_H        (REG_PHY2P1_1_P0_BASE + 0xAB)
#define REG_PHY2P1_1_P0_56_L        (REG_PHY2P1_1_P0_BASE + 0xAC)
#define REG_PHY2P1_1_P0_56_H        (REG_PHY2P1_1_P0_BASE + 0xAD)
#define REG_PHY2P1_1_P0_57_L        (REG_PHY2P1_1_P0_BASE + 0xAE)
#define REG_PHY2P1_1_P0_57_H        (REG_PHY2P1_1_P0_BASE + 0xAF)
#define REG_PHY2P1_1_P0_58_L        (REG_PHY2P1_1_P0_BASE + 0xB0)
#define REG_PHY2P1_1_P0_58_H        (REG_PHY2P1_1_P0_BASE + 0xB1)
#define REG_PHY2P1_1_P0_59_L        (REG_PHY2P1_1_P0_BASE + 0xB2)
#define REG_PHY2P1_1_P0_59_H        (REG_PHY2P1_1_P0_BASE + 0xB3)
#define REG_PHY2P1_1_P0_5A_L        (REG_PHY2P1_1_P0_BASE + 0xB4)
#define REG_PHY2P1_1_P0_5A_H        (REG_PHY2P1_1_P0_BASE + 0xB5)
#define REG_PHY2P1_1_P0_5B_L        (REG_PHY2P1_1_P0_BASE + 0xB6)
#define REG_PHY2P1_1_P0_5B_H        (REG_PHY2P1_1_P0_BASE + 0xB7)
#define REG_PHY2P1_1_P0_5C_L        (REG_PHY2P1_1_P0_BASE + 0xB8)
#define REG_PHY2P1_1_P0_5C_H        (REG_PHY2P1_1_P0_BASE + 0xB9)
#define REG_PHY2P1_1_P0_5D_L        (REG_PHY2P1_1_P0_BASE + 0xBA)
#define REG_PHY2P1_1_P0_5D_H        (REG_PHY2P1_1_P0_BASE + 0xBB)
#define REG_PHY2P1_1_P0_5E_L        (REG_PHY2P1_1_P0_BASE + 0xBC)
#define REG_PHY2P1_1_P0_5E_H        (REG_PHY2P1_1_P0_BASE + 0xBD)
#define REG_PHY2P1_1_P0_5F_L        (REG_PHY2P1_1_P0_BASE + 0xBE)
#define REG_PHY2P1_1_P0_5F_H        (REG_PHY2P1_1_P0_BASE + 0xBF)
#define REG_PHY2P1_1_P0_60_L        (REG_PHY2P1_1_P0_BASE + 0xC0)
#define REG_PHY2P1_1_P0_60_H        (REG_PHY2P1_1_P0_BASE + 0xC1)
#define REG_PHY2P1_1_P0_61_L        (REG_PHY2P1_1_P0_BASE + 0xC2)
#define REG_PHY2P1_1_P0_61_H        (REG_PHY2P1_1_P0_BASE + 0xC3)
#define REG_PHY2P1_1_P0_62_L        (REG_PHY2P1_1_P0_BASE + 0xC4)
#define REG_PHY2P1_1_P0_62_H        (REG_PHY2P1_1_P0_BASE + 0xC5)
#define REG_PHY2P1_1_P0_63_L        (REG_PHY2P1_1_P0_BASE + 0xC6)
#define REG_PHY2P1_1_P0_63_H        (REG_PHY2P1_1_P0_BASE + 0xC7)
#define REG_PHY2P1_1_P0_64_L        (REG_PHY2P1_1_P0_BASE + 0xC8)
#define REG_PHY2P1_1_P0_64_H        (REG_PHY2P1_1_P0_BASE + 0xC9)
#define REG_PHY2P1_1_P0_65_L        (REG_PHY2P1_1_P0_BASE + 0xCA)
#define REG_PHY2P1_1_P0_65_H        (REG_PHY2P1_1_P0_BASE + 0xCB)
#define REG_PHY2P1_1_P0_66_L        (REG_PHY2P1_1_P0_BASE + 0xCC)
#define REG_PHY2P1_1_P0_66_H        (REG_PHY2P1_1_P0_BASE + 0xCD)
#define REG_PHY2P1_1_P0_67_L        (REG_PHY2P1_1_P0_BASE + 0xCE)
#define REG_PHY2P1_1_P0_67_H        (REG_PHY2P1_1_P0_BASE + 0xCF)
#define REG_PHY2P1_1_P0_68_L        (REG_PHY2P1_1_P0_BASE + 0xD0)
#define REG_PHY2P1_1_P0_68_H        (REG_PHY2P1_1_P0_BASE + 0xD1)
#define REG_PHY2P1_1_P0_69_L        (REG_PHY2P1_1_P0_BASE + 0xD2)
#define REG_PHY2P1_1_P0_69_H        (REG_PHY2P1_1_P0_BASE + 0xD3)
#define REG_PHY2P1_1_P0_6A_L        (REG_PHY2P1_1_P0_BASE + 0xD4)
#define REG_PHY2P1_1_P0_6A_H        (REG_PHY2P1_1_P0_BASE + 0xD5)
#define REG_PHY2P1_1_P0_6B_L        (REG_PHY2P1_1_P0_BASE + 0xD6)
#define REG_PHY2P1_1_P0_6B_H        (REG_PHY2P1_1_P0_BASE + 0xD7)
#define REG_PHY2P1_1_P0_6C_L        (REG_PHY2P1_1_P0_BASE + 0xD8)
#define REG_PHY2P1_1_P0_6C_H        (REG_PHY2P1_1_P0_BASE + 0xD9)
#define REG_PHY2P1_1_P0_6D_L        (REG_PHY2P1_1_P0_BASE + 0xDA)
#define REG_PHY2P1_1_P0_6D_H        (REG_PHY2P1_1_P0_BASE + 0xDB)
#define REG_PHY2P1_1_P0_6E_L        (REG_PHY2P1_1_P0_BASE + 0xDC)
#define REG_PHY2P1_1_P0_6E_H        (REG_PHY2P1_1_P0_BASE + 0xDD)
#define REG_PHY2P1_1_P0_6F_L        (REG_PHY2P1_1_P0_BASE + 0xDE)
#define REG_PHY2P1_1_P0_6F_H        (REG_PHY2P1_1_P0_BASE + 0xDF)
#define REG_PHY2P1_1_P0_70_L        (REG_PHY2P1_1_P0_BASE + 0xE0)
#define REG_PHY2P1_1_P0_70_H        (REG_PHY2P1_1_P0_BASE + 0xE1)
#define REG_PHY2P1_1_P0_71_L        (REG_PHY2P1_1_P0_BASE + 0xE2)
#define REG_PHY2P1_1_P0_71_H        (REG_PHY2P1_1_P0_BASE + 0xE3)
#define REG_PHY2P1_1_P0_72_L        (REG_PHY2P1_1_P0_BASE + 0xE4)
#define REG_PHY2P1_1_P0_72_H        (REG_PHY2P1_1_P0_BASE + 0xE5)
#define REG_PHY2P1_1_P0_73_L        (REG_PHY2P1_1_P0_BASE + 0xE6)
#define REG_PHY2P1_1_P0_73_H        (REG_PHY2P1_1_P0_BASE + 0xE7)
#define REG_PHY2P1_1_P0_74_L        (REG_PHY2P1_1_P0_BASE + 0xE8)
#define REG_PHY2P1_1_P0_74_H        (REG_PHY2P1_1_P0_BASE + 0xE9)
#define REG_PHY2P1_1_P0_75_L        (REG_PHY2P1_1_P0_BASE + 0xEA)
#define REG_PHY2P1_1_P0_75_H        (REG_PHY2P1_1_P0_BASE + 0xEB)
#define REG_PHY2P1_1_P0_76_L        (REG_PHY2P1_1_P0_BASE + 0xEC)
#define REG_PHY2P1_1_P0_76_H        (REG_PHY2P1_1_P0_BASE + 0xED)
#define REG_PHY2P1_1_P0_77_L        (REG_PHY2P1_1_P0_BASE + 0xEE)
#define REG_PHY2P1_1_P0_77_H        (REG_PHY2P1_1_P0_BASE + 0xEF)
#define REG_PHY2P1_1_P0_78_L        (REG_PHY2P1_1_P0_BASE + 0xF0)
#define REG_PHY2P1_1_P0_78_H        (REG_PHY2P1_1_P0_BASE + 0xF1)
#define REG_PHY2P1_1_P0_79_L        (REG_PHY2P1_1_P0_BASE + 0xF2)
#define REG_PHY2P1_1_P0_79_H        (REG_PHY2P1_1_P0_BASE + 0xF3)
#define REG_PHY2P1_1_P0_7A_L        (REG_PHY2P1_1_P0_BASE + 0xF4)
#define REG_PHY2P1_1_P0_7A_H        (REG_PHY2P1_1_P0_BASE + 0xF5)
#define REG_PHY2P1_1_P0_7B_L        (REG_PHY2P1_1_P0_BASE + 0xF6)
#define REG_PHY2P1_1_P0_7B_H        (REG_PHY2P1_1_P0_BASE + 0xF7)
#define REG_PHY2P1_1_P0_7C_L        (REG_PHY2P1_1_P0_BASE + 0xF8)
#define REG_PHY2P1_1_P0_7C_H        (REG_PHY2P1_1_P0_BASE + 0xF9)
#define REG_PHY2P1_1_P0_7D_L        (REG_PHY2P1_1_P0_BASE + 0xFA)
#define REG_PHY2P1_1_P0_7D_H        (REG_PHY2P1_1_P0_BASE + 0xFB)
#define REG_PHY2P1_1_P0_7E_L        (REG_PHY2P1_1_P0_BASE + 0xFC)
#define REG_PHY2P1_1_P0_7E_H        (REG_PHY2P1_1_P0_BASE + 0xFD)
#define REG_PHY2P1_1_P0_7F_L        (REG_PHY2P1_1_P0_BASE + 0xFE)
#define REG_PHY2P1_1_P0_7F_H        (REG_PHY2P1_1_P0_BASE + 0xFF)

//=============================================================
// PHY2P1_2_P0
#define REG_PHY2P1_2_P0_00_L        (REG_PHY2P1_2_P0_BASE + 0x00)
#define REG_PHY2P1_2_P0_00_H        (REG_PHY2P1_2_P0_BASE + 0x01)
#define REG_PHY2P1_2_P0_01_L        (REG_PHY2P1_2_P0_BASE + 0x02)
#define REG_PHY2P1_2_P0_01_H        (REG_PHY2P1_2_P0_BASE + 0x03)
#define REG_PHY2P1_2_P0_02_L        (REG_PHY2P1_2_P0_BASE + 0x04)
#define REG_PHY2P1_2_P0_02_H        (REG_PHY2P1_2_P0_BASE + 0x05)
#define REG_PHY2P1_2_P0_03_L        (REG_PHY2P1_2_P0_BASE + 0x06)
#define REG_PHY2P1_2_P0_03_H        (REG_PHY2P1_2_P0_BASE + 0x07)
#define REG_PHY2P1_2_P0_04_L        (REG_PHY2P1_2_P0_BASE + 0x08)
#define REG_PHY2P1_2_P0_04_H        (REG_PHY2P1_2_P0_BASE + 0x09)
#define REG_PHY2P1_2_P0_05_L        (REG_PHY2P1_2_P0_BASE + 0x0A)
#define REG_PHY2P1_2_P0_05_H        (REG_PHY2P1_2_P0_BASE + 0x0B)
#define REG_PHY2P1_2_P0_06_L        (REG_PHY2P1_2_P0_BASE + 0x0C)
#define REG_PHY2P1_2_P0_06_H        (REG_PHY2P1_2_P0_BASE + 0x0D)
#define REG_PHY2P1_2_P0_07_L        (REG_PHY2P1_2_P0_BASE + 0x0E)
#define REG_PHY2P1_2_P0_07_H        (REG_PHY2P1_2_P0_BASE + 0x0F)
#define REG_PHY2P1_2_P0_08_L        (REG_PHY2P1_2_P0_BASE + 0x10)
#define REG_PHY2P1_2_P0_08_H        (REG_PHY2P1_2_P0_BASE + 0x11)
#define REG_PHY2P1_2_P0_09_L        (REG_PHY2P1_2_P0_BASE + 0x12)
#define REG_PHY2P1_2_P0_09_H        (REG_PHY2P1_2_P0_BASE + 0x13)
#define REG_PHY2P1_2_P0_0A_L        (REG_PHY2P1_2_P0_BASE + 0x14)
#define REG_PHY2P1_2_P0_0A_H        (REG_PHY2P1_2_P0_BASE + 0x15)
#define REG_PHY2P1_2_P0_0B_L        (REG_PHY2P1_2_P0_BASE + 0x16)
#define REG_PHY2P1_2_P0_0B_H        (REG_PHY2P1_2_P0_BASE + 0x17)
#define REG_PHY2P1_2_P0_0C_L        (REG_PHY2P1_2_P0_BASE + 0x18)
#define REG_PHY2P1_2_P0_0C_H        (REG_PHY2P1_2_P0_BASE + 0x19)
#define REG_PHY2P1_2_P0_0D_L        (REG_PHY2P1_2_P0_BASE + 0x1A)
#define REG_PHY2P1_2_P0_0D_H        (REG_PHY2P1_2_P0_BASE + 0x1B)
#define REG_PHY2P1_2_P0_0E_L        (REG_PHY2P1_2_P0_BASE + 0x1C)
#define REG_PHY2P1_2_P0_0E_H        (REG_PHY2P1_2_P0_BASE + 0x1D)
#define REG_PHY2P1_2_P0_0F_L        (REG_PHY2P1_2_P0_BASE + 0x1E)
#define REG_PHY2P1_2_P0_0F_H        (REG_PHY2P1_2_P0_BASE + 0x1F)
#define REG_PHY2P1_2_P0_10_L        (REG_PHY2P1_2_P0_BASE + 0x20)
#define REG_PHY2P1_2_P0_10_H        (REG_PHY2P1_2_P0_BASE + 0x21)
#define REG_PHY2P1_2_P0_11_L        (REG_PHY2P1_2_P0_BASE + 0x22)
#define REG_PHY2P1_2_P0_11_H        (REG_PHY2P1_2_P0_BASE + 0x23)
#define REG_PHY2P1_2_P0_12_L        (REG_PHY2P1_2_P0_BASE + 0x24)
#define REG_PHY2P1_2_P0_12_H        (REG_PHY2P1_2_P0_BASE + 0x25)
#define REG_PHY2P1_2_P0_13_L        (REG_PHY2P1_2_P0_BASE + 0x26)
#define REG_PHY2P1_2_P0_13_H        (REG_PHY2P1_2_P0_BASE + 0x27)
#define REG_PHY2P1_2_P0_14_L        (REG_PHY2P1_2_P0_BASE + 0x28)
#define REG_PHY2P1_2_P0_14_H        (REG_PHY2P1_2_P0_BASE + 0x29)
#define REG_PHY2P1_2_P0_15_L        (REG_PHY2P1_2_P0_BASE + 0x2A)
#define REG_PHY2P1_2_P0_15_H        (REG_PHY2P1_2_P0_BASE + 0x2B)
#define REG_PHY2P1_2_P0_16_L        (REG_PHY2P1_2_P0_BASE + 0x2C)
#define REG_PHY2P1_2_P0_16_H        (REG_PHY2P1_2_P0_BASE + 0x2D)
#define REG_PHY2P1_2_P0_17_L        (REG_PHY2P1_2_P0_BASE + 0x2E)
#define REG_PHY2P1_2_P0_17_H        (REG_PHY2P1_2_P0_BASE + 0x2F)
#define REG_PHY2P1_2_P0_18_L        (REG_PHY2P1_2_P0_BASE + 0x30)
#define REG_PHY2P1_2_P0_18_H        (REG_PHY2P1_2_P0_BASE + 0x31)
#define REG_PHY2P1_2_P0_19_L        (REG_PHY2P1_2_P0_BASE + 0x32)
#define REG_PHY2P1_2_P0_19_H        (REG_PHY2P1_2_P0_BASE + 0x33)
#define REG_PHY2P1_2_P0_1A_L        (REG_PHY2P1_2_P0_BASE + 0x34)
#define REG_PHY2P1_2_P0_1A_H        (REG_PHY2P1_2_P0_BASE + 0x35)
#define REG_PHY2P1_2_P0_1B_L        (REG_PHY2P1_2_P0_BASE + 0x36)
#define REG_PHY2P1_2_P0_1B_H        (REG_PHY2P1_2_P0_BASE + 0x37)
#define REG_PHY2P1_2_P0_1C_L        (REG_PHY2P1_2_P0_BASE + 0x38)
#define REG_PHY2P1_2_P0_1C_H        (REG_PHY2P1_2_P0_BASE + 0x39)
#define REG_PHY2P1_2_P0_1D_L        (REG_PHY2P1_2_P0_BASE + 0x3A)
#define REG_PHY2P1_2_P0_1D_H        (REG_PHY2P1_2_P0_BASE + 0x3B)
#define REG_PHY2P1_2_P0_1E_L        (REG_PHY2P1_2_P0_BASE + 0x3C)
#define REG_PHY2P1_2_P0_1E_H        (REG_PHY2P1_2_P0_BASE + 0x3D)
#define REG_PHY2P1_2_P0_1F_L        (REG_PHY2P1_2_P0_BASE + 0x3E)
#define REG_PHY2P1_2_P0_1F_H        (REG_PHY2P1_2_P0_BASE + 0x3F)
#define REG_PHY2P1_2_P0_20_L        (REG_PHY2P1_2_P0_BASE + 0x40)
#define REG_PHY2P1_2_P0_20_H        (REG_PHY2P1_2_P0_BASE + 0x41)
#define REG_PHY2P1_2_P0_21_L        (REG_PHY2P1_2_P0_BASE + 0x42)
#define REG_PHY2P1_2_P0_21_H        (REG_PHY2P1_2_P0_BASE + 0x43)
#define REG_PHY2P1_2_P0_22_L        (REG_PHY2P1_2_P0_BASE + 0x44)
#define REG_PHY2P1_2_P0_22_H        (REG_PHY2P1_2_P0_BASE + 0x45)
#define REG_PHY2P1_2_P0_23_L        (REG_PHY2P1_2_P0_BASE + 0x46)
#define REG_PHY2P1_2_P0_23_H        (REG_PHY2P1_2_P0_BASE + 0x47)
#define REG_PHY2P1_2_P0_24_L        (REG_PHY2P1_2_P0_BASE + 0x48)
#define REG_PHY2P1_2_P0_24_H        (REG_PHY2P1_2_P0_BASE + 0x49)
#define REG_PHY2P1_2_P0_25_L        (REG_PHY2P1_2_P0_BASE + 0x4A)
#define REG_PHY2P1_2_P0_25_H        (REG_PHY2P1_2_P0_BASE + 0x4B)
#define REG_PHY2P1_2_P0_26_L        (REG_PHY2P1_2_P0_BASE + 0x4C)
#define REG_PHY2P1_2_P0_26_H        (REG_PHY2P1_2_P0_BASE + 0x4D)
#define REG_PHY2P1_2_P0_27_L        (REG_PHY2P1_2_P0_BASE + 0x4E)
#define REG_PHY2P1_2_P0_27_H        (REG_PHY2P1_2_P0_BASE + 0x4F)
#define REG_PHY2P1_2_P0_28_L        (REG_PHY2P1_2_P0_BASE + 0x50)
#define REG_PHY2P1_2_P0_28_H        (REG_PHY2P1_2_P0_BASE + 0x51)
#define REG_PHY2P1_2_P0_29_L        (REG_PHY2P1_2_P0_BASE + 0x52)
#define REG_PHY2P1_2_P0_29_H        (REG_PHY2P1_2_P0_BASE + 0x53)
#define REG_PHY2P1_2_P0_2A_L        (REG_PHY2P1_2_P0_BASE + 0x54)
#define REG_PHY2P1_2_P0_2A_H        (REG_PHY2P1_2_P0_BASE + 0x55)
#define REG_PHY2P1_2_P0_2B_L        (REG_PHY2P1_2_P0_BASE + 0x56)
#define REG_PHY2P1_2_P0_2B_H        (REG_PHY2P1_2_P0_BASE + 0x57)
#define REG_PHY2P1_2_P0_2C_L        (REG_PHY2P1_2_P0_BASE + 0x58)
#define REG_PHY2P1_2_P0_2C_H        (REG_PHY2P1_2_P0_BASE + 0x59)
#define REG_PHY2P1_2_P0_2D_L        (REG_PHY2P1_2_P0_BASE + 0x5A)
#define REG_PHY2P1_2_P0_2D_H        (REG_PHY2P1_2_P0_BASE + 0x5B)
#define REG_PHY2P1_2_P0_2E_L        (REG_PHY2P1_2_P0_BASE + 0x5C)
#define REG_PHY2P1_2_P0_2E_H        (REG_PHY2P1_2_P0_BASE + 0x5D)
#define REG_PHY2P1_2_P0_2F_L        (REG_PHY2P1_2_P0_BASE + 0x5E)
#define REG_PHY2P1_2_P0_2F_H        (REG_PHY2P1_2_P0_BASE + 0x5F)
#define REG_PHY2P1_2_P0_30_L        (REG_PHY2P1_2_P0_BASE + 0x60)
#define REG_PHY2P1_2_P0_30_H        (REG_PHY2P1_2_P0_BASE + 0x61)
#define REG_PHY2P1_2_P0_31_L        (REG_PHY2P1_2_P0_BASE + 0x62)
#define REG_PHY2P1_2_P0_31_H        (REG_PHY2P1_2_P0_BASE + 0x63)
#define REG_PHY2P1_2_P0_32_L        (REG_PHY2P1_2_P0_BASE + 0x64)
#define REG_PHY2P1_2_P0_32_H        (REG_PHY2P1_2_P0_BASE + 0x65)
#define REG_PHY2P1_2_P0_33_L        (REG_PHY2P1_2_P0_BASE + 0x66)
#define REG_PHY2P1_2_P0_33_H        (REG_PHY2P1_2_P0_BASE + 0x67)
#define REG_PHY2P1_2_P0_34_L        (REG_PHY2P1_2_P0_BASE + 0x68)
#define REG_PHY2P1_2_P0_34_H        (REG_PHY2P1_2_P0_BASE + 0x69)
#define REG_PHY2P1_2_P0_35_L        (REG_PHY2P1_2_P0_BASE + 0x6A)
#define REG_PHY2P1_2_P0_35_H        (REG_PHY2P1_2_P0_BASE + 0x6B)
#define REG_PHY2P1_2_P0_36_L        (REG_PHY2P1_2_P0_BASE + 0x6C)
#define REG_PHY2P1_2_P0_36_H        (REG_PHY2P1_2_P0_BASE + 0x6D)
#define REG_PHY2P1_2_P0_37_L        (REG_PHY2P1_2_P0_BASE + 0x6E)
#define REG_PHY2P1_2_P0_37_H        (REG_PHY2P1_2_P0_BASE + 0x6F)
#define REG_PHY2P1_2_P0_38_L        (REG_PHY2P1_2_P0_BASE + 0x70)
#define REG_PHY2P1_2_P0_38_H        (REG_PHY2P1_2_P0_BASE + 0x71)
#define REG_PHY2P1_2_P0_39_L        (REG_PHY2P1_2_P0_BASE + 0x72)
#define REG_PHY2P1_2_P0_39_H        (REG_PHY2P1_2_P0_BASE + 0x73)
#define REG_PHY2P1_2_P0_3A_L        (REG_PHY2P1_2_P0_BASE + 0x74)
#define REG_PHY2P1_2_P0_3A_H        (REG_PHY2P1_2_P0_BASE + 0x75)
#define REG_PHY2P1_2_P0_3B_L        (REG_PHY2P1_2_P0_BASE + 0x76)
#define REG_PHY2P1_2_P0_3B_H        (REG_PHY2P1_2_P0_BASE + 0x77)
#define REG_PHY2P1_2_P0_3C_L        (REG_PHY2P1_2_P0_BASE + 0x78)
#define REG_PHY2P1_2_P0_3C_H        (REG_PHY2P1_2_P0_BASE + 0x79)
#define REG_PHY2P1_2_P0_3D_L        (REG_PHY2P1_2_P0_BASE + 0x7A)
#define REG_PHY2P1_2_P0_3D_H        (REG_PHY2P1_2_P0_BASE + 0x7B)
#define REG_PHY2P1_2_P0_3E_L        (REG_PHY2P1_2_P0_BASE + 0x7C)
#define REG_PHY2P1_2_P0_3E_H        (REG_PHY2P1_2_P0_BASE + 0x7D)
#define REG_PHY2P1_2_P0_3F_L        (REG_PHY2P1_2_P0_BASE + 0x7E)
#define REG_PHY2P1_2_P0_3F_H        (REG_PHY2P1_2_P0_BASE + 0x7F)
#define REG_PHY2P1_2_P0_40_L        (REG_PHY2P1_2_P0_BASE + 0x80)
#define REG_PHY2P1_2_P0_40_H        (REG_PHY2P1_2_P0_BASE + 0x81)
#define REG_PHY2P1_2_P0_41_L        (REG_PHY2P1_2_P0_BASE + 0x82)
#define REG_PHY2P1_2_P0_41_H        (REG_PHY2P1_2_P0_BASE + 0x83)
#define REG_PHY2P1_2_P0_42_L        (REG_PHY2P1_2_P0_BASE + 0x84)
#define REG_PHY2P1_2_P0_42_H        (REG_PHY2P1_2_P0_BASE + 0x85)
#define REG_PHY2P1_2_P0_43_L        (REG_PHY2P1_2_P0_BASE + 0x86)
#define REG_PHY2P1_2_P0_43_H        (REG_PHY2P1_2_P0_BASE + 0x87)
#define REG_PHY2P1_2_P0_44_L        (REG_PHY2P1_2_P0_BASE + 0x88)
#define REG_PHY2P1_2_P0_44_H        (REG_PHY2P1_2_P0_BASE + 0x89)
#define REG_PHY2P1_2_P0_45_L        (REG_PHY2P1_2_P0_BASE + 0x8A)
#define REG_PHY2P1_2_P0_45_H        (REG_PHY2P1_2_P0_BASE + 0x8B)
#define REG_PHY2P1_2_P0_46_L        (REG_PHY2P1_2_P0_BASE + 0x8C)
#define REG_PHY2P1_2_P0_46_H        (REG_PHY2P1_2_P0_BASE + 0x8D)
#define REG_PHY2P1_2_P0_47_L        (REG_PHY2P1_2_P0_BASE + 0x8E)
#define REG_PHY2P1_2_P0_47_H        (REG_PHY2P1_2_P0_BASE + 0x8F)
#define REG_PHY2P1_2_P0_48_L        (REG_PHY2P1_2_P0_BASE + 0x90)
#define REG_PHY2P1_2_P0_48_H        (REG_PHY2P1_2_P0_BASE + 0x91)
#define REG_PHY2P1_2_P0_49_L        (REG_PHY2P1_2_P0_BASE + 0x92)
#define REG_PHY2P1_2_P0_49_H        (REG_PHY2P1_2_P0_BASE + 0x93)
#define REG_PHY2P1_2_P0_4A_L        (REG_PHY2P1_2_P0_BASE + 0x94)
#define REG_PHY2P1_2_P0_4A_H        (REG_PHY2P1_2_P0_BASE + 0x95)
#define REG_PHY2P1_2_P0_4B_L        (REG_PHY2P1_2_P0_BASE + 0x96)
#define REG_PHY2P1_2_P0_4B_H        (REG_PHY2P1_2_P0_BASE + 0x97)
#define REG_PHY2P1_2_P0_4C_L        (REG_PHY2P1_2_P0_BASE + 0x98)
#define REG_PHY2P1_2_P0_4C_H        (REG_PHY2P1_2_P0_BASE + 0x99)
#define REG_PHY2P1_2_P0_4D_L        (REG_PHY2P1_2_P0_BASE + 0x9A)
#define REG_PHY2P1_2_P0_4D_H        (REG_PHY2P1_2_P0_BASE + 0x9B)
#define REG_PHY2P1_2_P0_4E_L        (REG_PHY2P1_2_P0_BASE + 0x9C)
#define REG_PHY2P1_2_P0_4E_H        (REG_PHY2P1_2_P0_BASE + 0x9D)
#define REG_PHY2P1_2_P0_4F_L        (REG_PHY2P1_2_P0_BASE + 0x9E)
#define REG_PHY2P1_2_P0_4F_H        (REG_PHY2P1_2_P0_BASE + 0x9F)
#define REG_PHY2P1_2_P0_50_L        (REG_PHY2P1_2_P0_BASE + 0xA0)
#define REG_PHY2P1_2_P0_50_H        (REG_PHY2P1_2_P0_BASE + 0xA1)
#define REG_PHY2P1_2_P0_51_L        (REG_PHY2P1_2_P0_BASE + 0xA2)
#define REG_PHY2P1_2_P0_51_H        (REG_PHY2P1_2_P0_BASE + 0xA3)
#define REG_PHY2P1_2_P0_52_L        (REG_PHY2P1_2_P0_BASE + 0xA4)
#define REG_PHY2P1_2_P0_52_H        (REG_PHY2P1_2_P0_BASE + 0xA5)
#define REG_PHY2P1_2_P0_53_L        (REG_PHY2P1_2_P0_BASE + 0xA6)
#define REG_PHY2P1_2_P0_53_H        (REG_PHY2P1_2_P0_BASE + 0xA7)
#define REG_PHY2P1_2_P0_54_L        (REG_PHY2P1_2_P0_BASE + 0xA8)
#define REG_PHY2P1_2_P0_54_H        (REG_PHY2P1_2_P0_BASE + 0xA9)
#define REG_PHY2P1_2_P0_55_L        (REG_PHY2P1_2_P0_BASE + 0xAA)
#define REG_PHY2P1_2_P0_55_H        (REG_PHY2P1_2_P0_BASE + 0xAB)
#define REG_PHY2P1_2_P0_56_L        (REG_PHY2P1_2_P0_BASE + 0xAC)
#define REG_PHY2P1_2_P0_56_H        (REG_PHY2P1_2_P0_BASE + 0xAD)
#define REG_PHY2P1_2_P0_57_L        (REG_PHY2P1_2_P0_BASE + 0xAE)
#define REG_PHY2P1_2_P0_57_H        (REG_PHY2P1_2_P0_BASE + 0xAF)
#define REG_PHY2P1_2_P0_58_L        (REG_PHY2P1_2_P0_BASE + 0xB0)
#define REG_PHY2P1_2_P0_58_H        (REG_PHY2P1_2_P0_BASE + 0xB1)
#define REG_PHY2P1_2_P0_59_L        (REG_PHY2P1_2_P0_BASE + 0xB2)
#define REG_PHY2P1_2_P0_59_H        (REG_PHY2P1_2_P0_BASE + 0xB3)
#define REG_PHY2P1_2_P0_5A_L        (REG_PHY2P1_2_P0_BASE + 0xB4)
#define REG_PHY2P1_2_P0_5A_H        (REG_PHY2P1_2_P0_BASE + 0xB5)
#define REG_PHY2P1_2_P0_5B_L        (REG_PHY2P1_2_P0_BASE + 0xB6)
#define REG_PHY2P1_2_P0_5B_H        (REG_PHY2P1_2_P0_BASE + 0xB7)
#define REG_PHY2P1_2_P0_5C_L        (REG_PHY2P1_2_P0_BASE + 0xB8)
#define REG_PHY2P1_2_P0_5C_H        (REG_PHY2P1_2_P0_BASE + 0xB9)
#define REG_PHY2P1_2_P0_5D_L        (REG_PHY2P1_2_P0_BASE + 0xBA)
#define REG_PHY2P1_2_P0_5D_H        (REG_PHY2P1_2_P0_BASE + 0xBB)
#define REG_PHY2P1_2_P0_5E_L        (REG_PHY2P1_2_P0_BASE + 0xBC)
#define REG_PHY2P1_2_P0_5E_H        (REG_PHY2P1_2_P0_BASE + 0xBD)
#define REG_PHY2P1_2_P0_5F_L        (REG_PHY2P1_2_P0_BASE + 0xBE)
#define REG_PHY2P1_2_P0_5F_H        (REG_PHY2P1_2_P0_BASE + 0xBF)
#define REG_PHY2P1_2_P0_60_L        (REG_PHY2P1_2_P0_BASE + 0xC0)
#define REG_PHY2P1_2_P0_60_H        (REG_PHY2P1_2_P0_BASE + 0xC1)
#define REG_PHY2P1_2_P0_61_L        (REG_PHY2P1_2_P0_BASE + 0xC2)
#define REG_PHY2P1_2_P0_61_H        (REG_PHY2P1_2_P0_BASE + 0xC3)
#define REG_PHY2P1_2_P0_62_L        (REG_PHY2P1_2_P0_BASE + 0xC4)
#define REG_PHY2P1_2_P0_62_H        (REG_PHY2P1_2_P0_BASE + 0xC5)
#define REG_PHY2P1_2_P0_63_L        (REG_PHY2P1_2_P0_BASE + 0xC6)
#define REG_PHY2P1_2_P0_63_H        (REG_PHY2P1_2_P0_BASE + 0xC7)
#define REG_PHY2P1_2_P0_64_L        (REG_PHY2P1_2_P0_BASE + 0xC8)
#define REG_PHY2P1_2_P0_64_H        (REG_PHY2P1_2_P0_BASE + 0xC9)
#define REG_PHY2P1_2_P0_65_L        (REG_PHY2P1_2_P0_BASE + 0xCA)
#define REG_PHY2P1_2_P0_65_H        (REG_PHY2P1_2_P0_BASE + 0xCB)
#define REG_PHY2P1_2_P0_66_L        (REG_PHY2P1_2_P0_BASE + 0xCC)
#define REG_PHY2P1_2_P0_66_H        (REG_PHY2P1_2_P0_BASE + 0xCD)
#define REG_PHY2P1_2_P0_67_L        (REG_PHY2P1_2_P0_BASE + 0xCE)
#define REG_PHY2P1_2_P0_67_H        (REG_PHY2P1_2_P0_BASE + 0xCF)
#define REG_PHY2P1_2_P0_68_L        (REG_PHY2P1_2_P0_BASE + 0xD0)
#define REG_PHY2P1_2_P0_68_H        (REG_PHY2P1_2_P0_BASE + 0xD1)
#define REG_PHY2P1_2_P0_69_L        (REG_PHY2P1_2_P0_BASE + 0xD2)
#define REG_PHY2P1_2_P0_69_H        (REG_PHY2P1_2_P0_BASE + 0xD3)
#define REG_PHY2P1_2_P0_6A_L        (REG_PHY2P1_2_P0_BASE + 0xD4)
#define REG_PHY2P1_2_P0_6A_H        (REG_PHY2P1_2_P0_BASE + 0xD5)
#define REG_PHY2P1_2_P0_6B_L        (REG_PHY2P1_2_P0_BASE + 0xD6)
#define REG_PHY2P1_2_P0_6B_H        (REG_PHY2P1_2_P0_BASE + 0xD7)
#define REG_PHY2P1_2_P0_6C_L        (REG_PHY2P1_2_P0_BASE + 0xD8)
#define REG_PHY2P1_2_P0_6C_H        (REG_PHY2P1_2_P0_BASE + 0xD9)
#define REG_PHY2P1_2_P0_6D_L        (REG_PHY2P1_2_P0_BASE + 0xDA)
#define REG_PHY2P1_2_P0_6D_H        (REG_PHY2P1_2_P0_BASE + 0xDB)
#define REG_PHY2P1_2_P0_6E_L        (REG_PHY2P1_2_P0_BASE + 0xDC)
#define REG_PHY2P1_2_P0_6E_H        (REG_PHY2P1_2_P0_BASE + 0xDD)
#define REG_PHY2P1_2_P0_6F_L        (REG_PHY2P1_2_P0_BASE + 0xDE)
#define REG_PHY2P1_2_P0_6F_H        (REG_PHY2P1_2_P0_BASE + 0xDF)
#define REG_PHY2P1_2_P0_70_L        (REG_PHY2P1_2_P0_BASE + 0xE0)
#define REG_PHY2P1_2_P0_70_H        (REG_PHY2P1_2_P0_BASE + 0xE1)
#define REG_PHY2P1_2_P0_71_L        (REG_PHY2P1_2_P0_BASE + 0xE2)
#define REG_PHY2P1_2_P0_71_H        (REG_PHY2P1_2_P0_BASE + 0xE3)
#define REG_PHY2P1_2_P0_72_L        (REG_PHY2P1_2_P0_BASE + 0xE4)
#define REG_PHY2P1_2_P0_72_H        (REG_PHY2P1_2_P0_BASE + 0xE5)
#define REG_PHY2P1_2_P0_73_L        (REG_PHY2P1_2_P0_BASE + 0xE6)
#define REG_PHY2P1_2_P0_73_H        (REG_PHY2P1_2_P0_BASE + 0xE7)
#define REG_PHY2P1_2_P0_74_L        (REG_PHY2P1_2_P0_BASE + 0xE8)
#define REG_PHY2P1_2_P0_74_H        (REG_PHY2P1_2_P0_BASE + 0xE9)
#define REG_PHY2P1_2_P0_75_L        (REG_PHY2P1_2_P0_BASE + 0xEA)
#define REG_PHY2P1_2_P0_75_H        (REG_PHY2P1_2_P0_BASE + 0xEB)
#define REG_PHY2P1_2_P0_76_L        (REG_PHY2P1_2_P0_BASE + 0xEC)
#define REG_PHY2P1_2_P0_76_H        (REG_PHY2P1_2_P0_BASE + 0xED)
#define REG_PHY2P1_2_P0_77_L        (REG_PHY2P1_2_P0_BASE + 0xEE)
#define REG_PHY2P1_2_P0_77_H        (REG_PHY2P1_2_P0_BASE + 0xEF)
#define REG_PHY2P1_2_P0_78_L        (REG_PHY2P1_2_P0_BASE + 0xF0)
#define REG_PHY2P1_2_P0_78_H        (REG_PHY2P1_2_P0_BASE + 0xF1)
#define REG_PHY2P1_2_P0_79_L        (REG_PHY2P1_2_P0_BASE + 0xF2)
#define REG_PHY2P1_2_P0_79_H        (REG_PHY2P1_2_P0_BASE + 0xF3)
#define REG_PHY2P1_2_P0_7A_L        (REG_PHY2P1_2_P0_BASE + 0xF4)
#define REG_PHY2P1_2_P0_7A_H        (REG_PHY2P1_2_P0_BASE + 0xF5)
#define REG_PHY2P1_2_P0_7B_L        (REG_PHY2P1_2_P0_BASE + 0xF6)
#define REG_PHY2P1_2_P0_7B_H        (REG_PHY2P1_2_P0_BASE + 0xF7)
#define REG_PHY2P1_2_P0_7C_L        (REG_PHY2P1_2_P0_BASE + 0xF8)
#define REG_PHY2P1_2_P0_7C_H        (REG_PHY2P1_2_P0_BASE + 0xF9)
#define REG_PHY2P1_2_P0_7D_L        (REG_PHY2P1_2_P0_BASE + 0xFA)
#define REG_PHY2P1_2_P0_7D_H        (REG_PHY2P1_2_P0_BASE + 0xFB)
#define REG_PHY2P1_2_P0_7E_L        (REG_PHY2P1_2_P0_BASE + 0xFC)
#define REG_PHY2P1_2_P0_7E_H        (REG_PHY2P1_2_P0_BASE + 0xFD)
#define REG_PHY2P1_2_P0_7F_L        (REG_PHY2P1_2_P0_BASE + 0xFE)
#define REG_PHY2P1_2_P0_7F_H        (REG_PHY2P1_2_P0_BASE + 0xFF)

//=============================================================
// PHY2P1_3_P0
#define REG_PHY2P1_3_P0_00_L        (REG_PHY2P1_3_P0_BASE + 0x00)
#define REG_PHY2P1_3_P0_00_H        (REG_PHY2P1_3_P0_BASE + 0x01)
#define REG_PHY2P1_3_P0_01_L        (REG_PHY2P1_3_P0_BASE + 0x02)
#define REG_PHY2P1_3_P0_01_H        (REG_PHY2P1_3_P0_BASE + 0x03)
#define REG_PHY2P1_3_P0_02_L        (REG_PHY2P1_3_P0_BASE + 0x04)
#define REG_PHY2P1_3_P0_02_H        (REG_PHY2P1_3_P0_BASE + 0x05)
#define REG_PHY2P1_3_P0_03_L        (REG_PHY2P1_3_P0_BASE + 0x06)
#define REG_PHY2P1_3_P0_03_H        (REG_PHY2P1_3_P0_BASE + 0x07)
#define REG_PHY2P1_3_P0_04_L        (REG_PHY2P1_3_P0_BASE + 0x08)
#define REG_PHY2P1_3_P0_04_H        (REG_PHY2P1_3_P0_BASE + 0x09)
#define REG_PHY2P1_3_P0_05_L        (REG_PHY2P1_3_P0_BASE + 0x0A)
#define REG_PHY2P1_3_P0_05_H        (REG_PHY2P1_3_P0_BASE + 0x0B)
#define REG_PHY2P1_3_P0_06_L        (REG_PHY2P1_3_P0_BASE + 0x0C)
#define REG_PHY2P1_3_P0_06_H        (REG_PHY2P1_3_P0_BASE + 0x0D)
#define REG_PHY2P1_3_P0_07_L        (REG_PHY2P1_3_P0_BASE + 0x0E)
#define REG_PHY2P1_3_P0_07_H        (REG_PHY2P1_3_P0_BASE + 0x0F)
#define REG_PHY2P1_3_P0_08_L        (REG_PHY2P1_3_P0_BASE + 0x10)
#define REG_PHY2P1_3_P0_08_H        (REG_PHY2P1_3_P0_BASE + 0x11)
#define REG_PHY2P1_3_P0_09_L        (REG_PHY2P1_3_P0_BASE + 0x12)
#define REG_PHY2P1_3_P0_09_H        (REG_PHY2P1_3_P0_BASE + 0x13)
#define REG_PHY2P1_3_P0_0A_L        (REG_PHY2P1_3_P0_BASE + 0x14)
#define REG_PHY2P1_3_P0_0A_H        (REG_PHY2P1_3_P0_BASE + 0x15)
#define REG_PHY2P1_3_P0_0B_L        (REG_PHY2P1_3_P0_BASE + 0x16)
#define REG_PHY2P1_3_P0_0B_H        (REG_PHY2P1_3_P0_BASE + 0x17)
#define REG_PHY2P1_3_P0_0C_L        (REG_PHY2P1_3_P0_BASE + 0x18)
#define REG_PHY2P1_3_P0_0C_H        (REG_PHY2P1_3_P0_BASE + 0x19)
#define REG_PHY2P1_3_P0_0D_L        (REG_PHY2P1_3_P0_BASE + 0x1A)
#define REG_PHY2P1_3_P0_0D_H        (REG_PHY2P1_3_P0_BASE + 0x1B)
#define REG_PHY2P1_3_P0_0E_L        (REG_PHY2P1_3_P0_BASE + 0x1C)
#define REG_PHY2P1_3_P0_0E_H        (REG_PHY2P1_3_P0_BASE + 0x1D)
#define REG_PHY2P1_3_P0_0F_L        (REG_PHY2P1_3_P0_BASE + 0x1E)
#define REG_PHY2P1_3_P0_0F_H        (REG_PHY2P1_3_P0_BASE + 0x1F)
#define REG_PHY2P1_3_P0_10_L        (REG_PHY2P1_3_P0_BASE + 0x20)
#define REG_PHY2P1_3_P0_10_H        (REG_PHY2P1_3_P0_BASE + 0x21)
#define REG_PHY2P1_3_P0_11_L        (REG_PHY2P1_3_P0_BASE + 0x22)
#define REG_PHY2P1_3_P0_11_H        (REG_PHY2P1_3_P0_BASE + 0x23)
#define REG_PHY2P1_3_P0_12_L        (REG_PHY2P1_3_P0_BASE + 0x24)
#define REG_PHY2P1_3_P0_12_H        (REG_PHY2P1_3_P0_BASE + 0x25)
#define REG_PHY2P1_3_P0_13_L        (REG_PHY2P1_3_P0_BASE + 0x26)
#define REG_PHY2P1_3_P0_13_H        (REG_PHY2P1_3_P0_BASE + 0x27)
#define REG_PHY2P1_3_P0_14_L        (REG_PHY2P1_3_P0_BASE + 0x28)
#define REG_PHY2P1_3_P0_14_H        (REG_PHY2P1_3_P0_BASE + 0x29)
#define REG_PHY2P1_3_P0_15_L        (REG_PHY2P1_3_P0_BASE + 0x2A)
#define REG_PHY2P1_3_P0_15_H        (REG_PHY2P1_3_P0_BASE + 0x2B)
#define REG_PHY2P1_3_P0_16_L        (REG_PHY2P1_3_P0_BASE + 0x2C)
#define REG_PHY2P1_3_P0_16_H        (REG_PHY2P1_3_P0_BASE + 0x2D)
#define REG_PHY2P1_3_P0_17_L        (REG_PHY2P1_3_P0_BASE + 0x2E)
#define REG_PHY2P1_3_P0_17_H        (REG_PHY2P1_3_P0_BASE + 0x2F)
#define REG_PHY2P1_3_P0_18_L        (REG_PHY2P1_3_P0_BASE + 0x30)
#define REG_PHY2P1_3_P0_18_H        (REG_PHY2P1_3_P0_BASE + 0x31)
#define REG_PHY2P1_3_P0_19_L        (REG_PHY2P1_3_P0_BASE + 0x32)
#define REG_PHY2P1_3_P0_19_H        (REG_PHY2P1_3_P0_BASE + 0x33)
#define REG_PHY2P1_3_P0_1A_L        (REG_PHY2P1_3_P0_BASE + 0x34)
#define REG_PHY2P1_3_P0_1A_H        (REG_PHY2P1_3_P0_BASE + 0x35)
#define REG_PHY2P1_3_P0_1B_L        (REG_PHY2P1_3_P0_BASE + 0x36)
#define REG_PHY2P1_3_P0_1B_H        (REG_PHY2P1_3_P0_BASE + 0x37)
#define REG_PHY2P1_3_P0_1C_L        (REG_PHY2P1_3_P0_BASE + 0x38)
#define REG_PHY2P1_3_P0_1C_H        (REG_PHY2P1_3_P0_BASE + 0x39)
#define REG_PHY2P1_3_P0_1D_L        (REG_PHY2P1_3_P0_BASE + 0x3A)
#define REG_PHY2P1_3_P0_1D_H        (REG_PHY2P1_3_P0_BASE + 0x3B)
#define REG_PHY2P1_3_P0_1E_L        (REG_PHY2P1_3_P0_BASE + 0x3C)
#define REG_PHY2P1_3_P0_1E_H        (REG_PHY2P1_3_P0_BASE + 0x3D)
#define REG_PHY2P1_3_P0_1F_L        (REG_PHY2P1_3_P0_BASE + 0x3E)
#define REG_PHY2P1_3_P0_1F_H        (REG_PHY2P1_3_P0_BASE + 0x3F)
#define REG_PHY2P1_3_P0_20_L        (REG_PHY2P1_3_P0_BASE + 0x40)
#define REG_PHY2P1_3_P0_20_H        (REG_PHY2P1_3_P0_BASE + 0x41)
#define REG_PHY2P1_3_P0_21_L        (REG_PHY2P1_3_P0_BASE + 0x42)
#define REG_PHY2P1_3_P0_21_H        (REG_PHY2P1_3_P0_BASE + 0x43)
#define REG_PHY2P1_3_P0_22_L        (REG_PHY2P1_3_P0_BASE + 0x44)
#define REG_PHY2P1_3_P0_22_H        (REG_PHY2P1_3_P0_BASE + 0x45)
#define REG_PHY2P1_3_P0_23_L        (REG_PHY2P1_3_P0_BASE + 0x46)
#define REG_PHY2P1_3_P0_23_H        (REG_PHY2P1_3_P0_BASE + 0x47)
#define REG_PHY2P1_3_P0_24_L        (REG_PHY2P1_3_P0_BASE + 0x48)
#define REG_PHY2P1_3_P0_24_H        (REG_PHY2P1_3_P0_BASE + 0x49)
#define REG_PHY2P1_3_P0_25_L        (REG_PHY2P1_3_P0_BASE + 0x4A)
#define REG_PHY2P1_3_P0_25_H        (REG_PHY2P1_3_P0_BASE + 0x4B)
#define REG_PHY2P1_3_P0_26_L        (REG_PHY2P1_3_P0_BASE + 0x4C)
#define REG_PHY2P1_3_P0_26_H        (REG_PHY2P1_3_P0_BASE + 0x4D)
#define REG_PHY2P1_3_P0_27_L        (REG_PHY2P1_3_P0_BASE + 0x4E)
#define REG_PHY2P1_3_P0_27_H        (REG_PHY2P1_3_P0_BASE + 0x4F)
#define REG_PHY2P1_3_P0_28_L        (REG_PHY2P1_3_P0_BASE + 0x50)
#define REG_PHY2P1_3_P0_28_H        (REG_PHY2P1_3_P0_BASE + 0x51)
#define REG_PHY2P1_3_P0_29_L        (REG_PHY2P1_3_P0_BASE + 0x52)
#define REG_PHY2P1_3_P0_29_H        (REG_PHY2P1_3_P0_BASE + 0x53)
#define REG_PHY2P1_3_P0_2A_L        (REG_PHY2P1_3_P0_BASE + 0x54)
#define REG_PHY2P1_3_P0_2A_H        (REG_PHY2P1_3_P0_BASE + 0x55)
#define REG_PHY2P1_3_P0_2B_L        (REG_PHY2P1_3_P0_BASE + 0x56)
#define REG_PHY2P1_3_P0_2B_H        (REG_PHY2P1_3_P0_BASE + 0x57)
#define REG_PHY2P1_3_P0_2C_L        (REG_PHY2P1_3_P0_BASE + 0x58)
#define REG_PHY2P1_3_P0_2C_H        (REG_PHY2P1_3_P0_BASE + 0x59)
#define REG_PHY2P1_3_P0_2D_L        (REG_PHY2P1_3_P0_BASE + 0x5A)
#define REG_PHY2P1_3_P0_2D_H        (REG_PHY2P1_3_P0_BASE + 0x5B)
#define REG_PHY2P1_3_P0_2E_L        (REG_PHY2P1_3_P0_BASE + 0x5C)
#define REG_PHY2P1_3_P0_2E_H        (REG_PHY2P1_3_P0_BASE + 0x5D)
#define REG_PHY2P1_3_P0_2F_L        (REG_PHY2P1_3_P0_BASE + 0x5E)
#define REG_PHY2P1_3_P0_2F_H        (REG_PHY2P1_3_P0_BASE + 0x5F)
#define REG_PHY2P1_3_P0_30_L        (REG_PHY2P1_3_P0_BASE + 0x60)
#define REG_PHY2P1_3_P0_30_H        (REG_PHY2P1_3_P0_BASE + 0x61)
#define REG_PHY2P1_3_P0_31_L        (REG_PHY2P1_3_P0_BASE + 0x62)
#define REG_PHY2P1_3_P0_31_H        (REG_PHY2P1_3_P0_BASE + 0x63)
#define REG_PHY2P1_3_P0_32_L        (REG_PHY2P1_3_P0_BASE + 0x64)
#define REG_PHY2P1_3_P0_32_H        (REG_PHY2P1_3_P0_BASE + 0x65)
#define REG_PHY2P1_3_P0_33_L        (REG_PHY2P1_3_P0_BASE + 0x66)
#define REG_PHY2P1_3_P0_33_H        (REG_PHY2P1_3_P0_BASE + 0x67)
#define REG_PHY2P1_3_P0_34_L        (REG_PHY2P1_3_P0_BASE + 0x68)
#define REG_PHY2P1_3_P0_34_H        (REG_PHY2P1_3_P0_BASE + 0x69)
#define REG_PHY2P1_3_P0_35_L        (REG_PHY2P1_3_P0_BASE + 0x6A)
#define REG_PHY2P1_3_P0_35_H        (REG_PHY2P1_3_P0_BASE + 0x6B)
#define REG_PHY2P1_3_P0_36_L        (REG_PHY2P1_3_P0_BASE + 0x6C)
#define REG_PHY2P1_3_P0_36_H        (REG_PHY2P1_3_P0_BASE + 0x6D)
#define REG_PHY2P1_3_P0_37_L        (REG_PHY2P1_3_P0_BASE + 0x6E)
#define REG_PHY2P1_3_P0_37_H        (REG_PHY2P1_3_P0_BASE + 0x6F)
#define REG_PHY2P1_3_P0_38_L        (REG_PHY2P1_3_P0_BASE + 0x70)
#define REG_PHY2P1_3_P0_38_H        (REG_PHY2P1_3_P0_BASE + 0x71)
#define REG_PHY2P1_3_P0_39_L        (REG_PHY2P1_3_P0_BASE + 0x72)
#define REG_PHY2P1_3_P0_39_H        (REG_PHY2P1_3_P0_BASE + 0x73)
#define REG_PHY2P1_3_P0_3A_L        (REG_PHY2P1_3_P0_BASE + 0x74)
#define REG_PHY2P1_3_P0_3A_H        (REG_PHY2P1_3_P0_BASE + 0x75)
#define REG_PHY2P1_3_P0_3B_L        (REG_PHY2P1_3_P0_BASE + 0x76)
#define REG_PHY2P1_3_P0_3B_H        (REG_PHY2P1_3_P0_BASE + 0x77)
#define REG_PHY2P1_3_P0_3C_L        (REG_PHY2P1_3_P0_BASE + 0x78)
#define REG_PHY2P1_3_P0_3C_H        (REG_PHY2P1_3_P0_BASE + 0x79)
#define REG_PHY2P1_3_P0_3D_L        (REG_PHY2P1_3_P0_BASE + 0x7A)
#define REG_PHY2P1_3_P0_3D_H        (REG_PHY2P1_3_P0_BASE + 0x7B)
#define REG_PHY2P1_3_P0_3E_L        (REG_PHY2P1_3_P0_BASE + 0x7C)
#define REG_PHY2P1_3_P0_3E_H        (REG_PHY2P1_3_P0_BASE + 0x7D)
#define REG_PHY2P1_3_P0_3F_L        (REG_PHY2P1_3_P0_BASE + 0x7E)
#define REG_PHY2P1_3_P0_3F_H        (REG_PHY2P1_3_P0_BASE + 0x7F)
#define REG_PHY2P1_3_P0_40_L        (REG_PHY2P1_3_P0_BASE + 0x80)
#define REG_PHY2P1_3_P0_40_H        (REG_PHY2P1_3_P0_BASE + 0x81)
#define REG_PHY2P1_3_P0_41_L        (REG_PHY2P1_3_P0_BASE + 0x82)
#define REG_PHY2P1_3_P0_41_H        (REG_PHY2P1_3_P0_BASE + 0x83)
#define REG_PHY2P1_3_P0_42_L        (REG_PHY2P1_3_P0_BASE + 0x84)
#define REG_PHY2P1_3_P0_42_H        (REG_PHY2P1_3_P0_BASE + 0x85)
#define REG_PHY2P1_3_P0_43_L        (REG_PHY2P1_3_P0_BASE + 0x86)
#define REG_PHY2P1_3_P0_43_H        (REG_PHY2P1_3_P0_BASE + 0x87)
#define REG_PHY2P1_3_P0_44_L        (REG_PHY2P1_3_P0_BASE + 0x88)
#define REG_PHY2P1_3_P0_44_H        (REG_PHY2P1_3_P0_BASE + 0x89)
#define REG_PHY2P1_3_P0_45_L        (REG_PHY2P1_3_P0_BASE + 0x8A)
#define REG_PHY2P1_3_P0_45_H        (REG_PHY2P1_3_P0_BASE + 0x8B)
#define REG_PHY2P1_3_P0_46_L        (REG_PHY2P1_3_P0_BASE + 0x8C)
#define REG_PHY2P1_3_P0_46_H        (REG_PHY2P1_3_P0_BASE + 0x8D)
#define REG_PHY2P1_3_P0_47_L        (REG_PHY2P1_3_P0_BASE + 0x8E)
#define REG_PHY2P1_3_P0_47_H        (REG_PHY2P1_3_P0_BASE + 0x8F)
#define REG_PHY2P1_3_P0_48_L        (REG_PHY2P1_3_P0_BASE + 0x90)
#define REG_PHY2P1_3_P0_48_H        (REG_PHY2P1_3_P0_BASE + 0x91)
#define REG_PHY2P1_3_P0_49_L        (REG_PHY2P1_3_P0_BASE + 0x92)
#define REG_PHY2P1_3_P0_49_H        (REG_PHY2P1_3_P0_BASE + 0x93)
#define REG_PHY2P1_3_P0_4A_L        (REG_PHY2P1_3_P0_BASE + 0x94)
#define REG_PHY2P1_3_P0_4A_H        (REG_PHY2P1_3_P0_BASE + 0x95)
#define REG_PHY2P1_3_P0_4B_L        (REG_PHY2P1_3_P0_BASE + 0x96)
#define REG_PHY2P1_3_P0_4B_H        (REG_PHY2P1_3_P0_BASE + 0x97)
#define REG_PHY2P1_3_P0_4C_L        (REG_PHY2P1_3_P0_BASE + 0x98)
#define REG_PHY2P1_3_P0_4C_H        (REG_PHY2P1_3_P0_BASE + 0x99)
#define REG_PHY2P1_3_P0_4D_L        (REG_PHY2P1_3_P0_BASE + 0x9A)
#define REG_PHY2P1_3_P0_4D_H        (REG_PHY2P1_3_P0_BASE + 0x9B)
#define REG_PHY2P1_3_P0_4E_L        (REG_PHY2P1_3_P0_BASE + 0x9C)
#define REG_PHY2P1_3_P0_4E_H        (REG_PHY2P1_3_P0_BASE + 0x9D)
#define REG_PHY2P1_3_P0_4F_L        (REG_PHY2P1_3_P0_BASE + 0x9E)
#define REG_PHY2P1_3_P0_4F_H        (REG_PHY2P1_3_P0_BASE + 0x9F)
#define REG_PHY2P1_3_P0_50_L        (REG_PHY2P1_3_P0_BASE + 0xA0)
#define REG_PHY2P1_3_P0_50_H        (REG_PHY2P1_3_P0_BASE + 0xA1)
#define REG_PHY2P1_3_P0_51_L        (REG_PHY2P1_3_P0_BASE + 0xA2)
#define REG_PHY2P1_3_P0_51_H        (REG_PHY2P1_3_P0_BASE + 0xA3)
#define REG_PHY2P1_3_P0_52_L        (REG_PHY2P1_3_P0_BASE + 0xA4)
#define REG_PHY2P1_3_P0_52_H        (REG_PHY2P1_3_P0_BASE + 0xA5)
#define REG_PHY2P1_3_P0_53_L        (REG_PHY2P1_3_P0_BASE + 0xA6)
#define REG_PHY2P1_3_P0_53_H        (REG_PHY2P1_3_P0_BASE + 0xA7)
#define REG_PHY2P1_3_P0_54_L        (REG_PHY2P1_3_P0_BASE + 0xA8)
#define REG_PHY2P1_3_P0_54_H        (REG_PHY2P1_3_P0_BASE + 0xA9)
#define REG_PHY2P1_3_P0_55_L        (REG_PHY2P1_3_P0_BASE + 0xAA)
#define REG_PHY2P1_3_P0_55_H        (REG_PHY2P1_3_P0_BASE + 0xAB)
#define REG_PHY2P1_3_P0_56_L        (REG_PHY2P1_3_P0_BASE + 0xAC)
#define REG_PHY2P1_3_P0_56_H        (REG_PHY2P1_3_P0_BASE + 0xAD)
#define REG_PHY2P1_3_P0_57_L        (REG_PHY2P1_3_P0_BASE + 0xAE)
#define REG_PHY2P1_3_P0_57_H        (REG_PHY2P1_3_P0_BASE + 0xAF)
#define REG_PHY2P1_3_P0_58_L        (REG_PHY2P1_3_P0_BASE + 0xB0)
#define REG_PHY2P1_3_P0_58_H        (REG_PHY2P1_3_P0_BASE + 0xB1)
#define REG_PHY2P1_3_P0_59_L        (REG_PHY2P1_3_P0_BASE + 0xB2)
#define REG_PHY2P1_3_P0_59_H        (REG_PHY2P1_3_P0_BASE + 0xB3)
#define REG_PHY2P1_3_P0_5A_L        (REG_PHY2P1_3_P0_BASE + 0xB4)
#define REG_PHY2P1_3_P0_5A_H        (REG_PHY2P1_3_P0_BASE + 0xB5)
#define REG_PHY2P1_3_P0_5B_L        (REG_PHY2P1_3_P0_BASE + 0xB6)
#define REG_PHY2P1_3_P0_5B_H        (REG_PHY2P1_3_P0_BASE + 0xB7)
#define REG_PHY2P1_3_P0_5C_L        (REG_PHY2P1_3_P0_BASE + 0xB8)
#define REG_PHY2P1_3_P0_5C_H        (REG_PHY2P1_3_P0_BASE + 0xB9)
#define REG_PHY2P1_3_P0_5D_L        (REG_PHY2P1_3_P0_BASE + 0xBA)
#define REG_PHY2P1_3_P0_5D_H        (REG_PHY2P1_3_P0_BASE + 0xBB)
#define REG_PHY2P1_3_P0_5E_L        (REG_PHY2P1_3_P0_BASE + 0xBC)
#define REG_PHY2P1_3_P0_5E_H        (REG_PHY2P1_3_P0_BASE + 0xBD)
#define REG_PHY2P1_3_P0_5F_L        (REG_PHY2P1_3_P0_BASE + 0xBE)
#define REG_PHY2P1_3_P0_5F_H        (REG_PHY2P1_3_P0_BASE + 0xBF)
#define REG_PHY2P1_3_P0_60_L        (REG_PHY2P1_3_P0_BASE + 0xC0)
#define REG_PHY2P1_3_P0_60_H        (REG_PHY2P1_3_P0_BASE + 0xC1)
#define REG_PHY2P1_3_P0_61_L        (REG_PHY2P1_3_P0_BASE + 0xC2)
#define REG_PHY2P1_3_P0_61_H        (REG_PHY2P1_3_P0_BASE + 0xC3)
#define REG_PHY2P1_3_P0_62_L        (REG_PHY2P1_3_P0_BASE + 0xC4)
#define REG_PHY2P1_3_P0_62_H        (REG_PHY2P1_3_P0_BASE + 0xC5)
#define REG_PHY2P1_3_P0_63_L        (REG_PHY2P1_3_P0_BASE + 0xC6)
#define REG_PHY2P1_3_P0_63_H        (REG_PHY2P1_3_P0_BASE + 0xC7)
#define REG_PHY2P1_3_P0_64_L        (REG_PHY2P1_3_P0_BASE + 0xC8)
#define REG_PHY2P1_3_P0_64_H        (REG_PHY2P1_3_P0_BASE + 0xC9)
#define REG_PHY2P1_3_P0_65_L        (REG_PHY2P1_3_P0_BASE + 0xCA)
#define REG_PHY2P1_3_P0_65_H        (REG_PHY2P1_3_P0_BASE + 0xCB)
#define REG_PHY2P1_3_P0_66_L        (REG_PHY2P1_3_P0_BASE + 0xCC)
#define REG_PHY2P1_3_P0_66_H        (REG_PHY2P1_3_P0_BASE + 0xCD)
#define REG_PHY2P1_3_P0_67_L        (REG_PHY2P1_3_P0_BASE + 0xCE)
#define REG_PHY2P1_3_P0_67_H        (REG_PHY2P1_3_P0_BASE + 0xCF)
#define REG_PHY2P1_3_P0_68_L        (REG_PHY2P1_3_P0_BASE + 0xD0)
#define REG_PHY2P1_3_P0_68_H        (REG_PHY2P1_3_P0_BASE + 0xD1)
#define REG_PHY2P1_3_P0_69_L        (REG_PHY2P1_3_P0_BASE + 0xD2)
#define REG_PHY2P1_3_P0_69_H        (REG_PHY2P1_3_P0_BASE + 0xD3)
#define REG_PHY2P1_3_P0_6A_L        (REG_PHY2P1_3_P0_BASE + 0xD4)
#define REG_PHY2P1_3_P0_6A_H        (REG_PHY2P1_3_P0_BASE + 0xD5)
#define REG_PHY2P1_3_P0_6B_L        (REG_PHY2P1_3_P0_BASE + 0xD6)
#define REG_PHY2P1_3_P0_6B_H        (REG_PHY2P1_3_P0_BASE + 0xD7)
#define REG_PHY2P1_3_P0_6C_L        (REG_PHY2P1_3_P0_BASE + 0xD8)
#define REG_PHY2P1_3_P0_6C_H        (REG_PHY2P1_3_P0_BASE + 0xD9)
#define REG_PHY2P1_3_P0_6D_L        (REG_PHY2P1_3_P0_BASE + 0xDA)
#define REG_PHY2P1_3_P0_6D_H        (REG_PHY2P1_3_P0_BASE + 0xDB)
#define REG_PHY2P1_3_P0_6E_L        (REG_PHY2P1_3_P0_BASE + 0xDC)
#define REG_PHY2P1_3_P0_6E_H        (REG_PHY2P1_3_P0_BASE + 0xDD)
#define REG_PHY2P1_3_P0_6F_L        (REG_PHY2P1_3_P0_BASE + 0xDE)
#define REG_PHY2P1_3_P0_6F_H        (REG_PHY2P1_3_P0_BASE + 0xDF)
#define REG_PHY2P1_3_P0_70_L        (REG_PHY2P1_3_P0_BASE + 0xE0)
#define REG_PHY2P1_3_P0_70_H        (REG_PHY2P1_3_P0_BASE + 0xE1)
#define REG_PHY2P1_3_P0_71_L        (REG_PHY2P1_3_P0_BASE + 0xE2)
#define REG_PHY2P1_3_P0_71_H        (REG_PHY2P1_3_P0_BASE + 0xE3)
#define REG_PHY2P1_3_P0_72_L        (REG_PHY2P1_3_P0_BASE + 0xE4)
#define REG_PHY2P1_3_P0_72_H        (REG_PHY2P1_3_P0_BASE + 0xE5)
#define REG_PHY2P1_3_P0_73_L        (REG_PHY2P1_3_P0_BASE + 0xE6)
#define REG_PHY2P1_3_P0_73_H        (REG_PHY2P1_3_P0_BASE + 0xE7)
#define REG_PHY2P1_3_P0_74_L        (REG_PHY2P1_3_P0_BASE + 0xE8)
#define REG_PHY2P1_3_P0_74_H        (REG_PHY2P1_3_P0_BASE + 0xE9)
#define REG_PHY2P1_3_P0_75_L        (REG_PHY2P1_3_P0_BASE + 0xEA)
#define REG_PHY2P1_3_P0_75_H        (REG_PHY2P1_3_P0_BASE + 0xEB)
#define REG_PHY2P1_3_P0_76_L        (REG_PHY2P1_3_P0_BASE + 0xEC)
#define REG_PHY2P1_3_P0_76_H        (REG_PHY2P1_3_P0_BASE + 0xED)
#define REG_PHY2P1_3_P0_77_L        (REG_PHY2P1_3_P0_BASE + 0xEE)
#define REG_PHY2P1_3_P0_77_H        (REG_PHY2P1_3_P0_BASE + 0xEF)
#define REG_PHY2P1_3_P0_78_L        (REG_PHY2P1_3_P0_BASE + 0xF0)
#define REG_PHY2P1_3_P0_78_H        (REG_PHY2P1_3_P0_BASE + 0xF1)
#define REG_PHY2P1_3_P0_79_L        (REG_PHY2P1_3_P0_BASE + 0xF2)
#define REG_PHY2P1_3_P0_79_H        (REG_PHY2P1_3_P0_BASE + 0xF3)
#define REG_PHY2P1_3_P0_7A_L        (REG_PHY2P1_3_P0_BASE + 0xF4)
#define REG_PHY2P1_3_P0_7A_H        (REG_PHY2P1_3_P0_BASE + 0xF5)
#define REG_PHY2P1_3_P0_7B_L        (REG_PHY2P1_3_P0_BASE + 0xF6)
#define REG_PHY2P1_3_P0_7B_H        (REG_PHY2P1_3_P0_BASE + 0xF7)
#define REG_PHY2P1_3_P0_7C_L        (REG_PHY2P1_3_P0_BASE + 0xF8)
#define REG_PHY2P1_3_P0_7C_H        (REG_PHY2P1_3_P0_BASE + 0xF9)
#define REG_PHY2P1_3_P0_7D_L        (REG_PHY2P1_3_P0_BASE + 0xFA)
#define REG_PHY2P1_3_P0_7D_H        (REG_PHY2P1_3_P0_BASE + 0xFB)
#define REG_PHY2P1_3_P0_7E_L        (REG_PHY2P1_3_P0_BASE + 0xFC)
#define REG_PHY2P1_3_P0_7E_H        (REG_PHY2P1_3_P0_BASE + 0xFD)
#define REG_PHY2P1_3_P0_7F_L        (REG_PHY2P1_3_P0_BASE + 0xFE)
#define REG_PHY2P1_3_P0_7F_H        (REG_PHY2P1_3_P0_BASE + 0xFF)

//=============================================================
// PHY2P1_4_P0
#define REG_PHY2P1_4_P0_00_L        (REG_PHY2P1_4_P0_BASE + 0x00)
#define REG_PHY2P1_4_P0_00_H        (REG_PHY2P1_4_P0_BASE + 0x01)
#define REG_PHY2P1_4_P0_01_L        (REG_PHY2P1_4_P0_BASE + 0x02)
#define REG_PHY2P1_4_P0_01_H        (REG_PHY2P1_4_P0_BASE + 0x03)
#define REG_PHY2P1_4_P0_02_L        (REG_PHY2P1_4_P0_BASE + 0x04)
#define REG_PHY2P1_4_P0_02_H        (REG_PHY2P1_4_P0_BASE + 0x05)
#define REG_PHY2P1_4_P0_03_L        (REG_PHY2P1_4_P0_BASE + 0x06)
#define REG_PHY2P1_4_P0_03_H        (REG_PHY2P1_4_P0_BASE + 0x07)
#define REG_PHY2P1_4_P0_04_L        (REG_PHY2P1_4_P0_BASE + 0x08)
#define REG_PHY2P1_4_P0_04_H        (REG_PHY2P1_4_P0_BASE + 0x09)
#define REG_PHY2P1_4_P0_05_L        (REG_PHY2P1_4_P0_BASE + 0x0A)
#define REG_PHY2P1_4_P0_05_H        (REG_PHY2P1_4_P0_BASE + 0x0B)
#define REG_PHY2P1_4_P0_06_L        (REG_PHY2P1_4_P0_BASE + 0x0C)
#define REG_PHY2P1_4_P0_06_H        (REG_PHY2P1_4_P0_BASE + 0x0D)
#define REG_PHY2P1_4_P0_07_L        (REG_PHY2P1_4_P0_BASE + 0x0E)
#define REG_PHY2P1_4_P0_07_H        (REG_PHY2P1_4_P0_BASE + 0x0F)
#define REG_PHY2P1_4_P0_08_L        (REG_PHY2P1_4_P0_BASE + 0x10)
#define REG_PHY2P1_4_P0_08_H        (REG_PHY2P1_4_P0_BASE + 0x11)
#define REG_PHY2P1_4_P0_09_L        (REG_PHY2P1_4_P0_BASE + 0x12)
#define REG_PHY2P1_4_P0_09_H        (REG_PHY2P1_4_P0_BASE + 0x13)
#define REG_PHY2P1_4_P0_0A_L        (REG_PHY2P1_4_P0_BASE + 0x14)
#define REG_PHY2P1_4_P0_0A_H        (REG_PHY2P1_4_P0_BASE + 0x15)
#define REG_PHY2P1_4_P0_0B_L        (REG_PHY2P1_4_P0_BASE + 0x16)
#define REG_PHY2P1_4_P0_0B_H        (REG_PHY2P1_4_P0_BASE + 0x17)
#define REG_PHY2P1_4_P0_0C_L        (REG_PHY2P1_4_P0_BASE + 0x18)
#define REG_PHY2P1_4_P0_0C_H        (REG_PHY2P1_4_P0_BASE + 0x19)
#define REG_PHY2P1_4_P0_0D_L        (REG_PHY2P1_4_P0_BASE + 0x1A)
#define REG_PHY2P1_4_P0_0D_H        (REG_PHY2P1_4_P0_BASE + 0x1B)
#define REG_PHY2P1_4_P0_0E_L        (REG_PHY2P1_4_P0_BASE + 0x1C)
#define REG_PHY2P1_4_P0_0E_H        (REG_PHY2P1_4_P0_BASE + 0x1D)
#define REG_PHY2P1_4_P0_0F_L        (REG_PHY2P1_4_P0_BASE + 0x1E)
#define REG_PHY2P1_4_P0_0F_H        (REG_PHY2P1_4_P0_BASE + 0x1F)
#define REG_PHY2P1_4_P0_10_L        (REG_PHY2P1_4_P0_BASE + 0x20)
#define REG_PHY2P1_4_P0_10_H        (REG_PHY2P1_4_P0_BASE + 0x21)
#define REG_PHY2P1_4_P0_11_L        (REG_PHY2P1_4_P0_BASE + 0x22)
#define REG_PHY2P1_4_P0_11_H        (REG_PHY2P1_4_P0_BASE + 0x23)
#define REG_PHY2P1_4_P0_12_L        (REG_PHY2P1_4_P0_BASE + 0x24)
#define REG_PHY2P1_4_P0_12_H        (REG_PHY2P1_4_P0_BASE + 0x25)
#define REG_PHY2P1_4_P0_13_L        (REG_PHY2P1_4_P0_BASE + 0x26)
#define REG_PHY2P1_4_P0_13_H        (REG_PHY2P1_4_P0_BASE + 0x27)
#define REG_PHY2P1_4_P0_14_L        (REG_PHY2P1_4_P0_BASE + 0x28)
#define REG_PHY2P1_4_P0_14_H        (REG_PHY2P1_4_P0_BASE + 0x29)
#define REG_PHY2P1_4_P0_15_L        (REG_PHY2P1_4_P0_BASE + 0x2A)
#define REG_PHY2P1_4_P0_15_H        (REG_PHY2P1_4_P0_BASE + 0x2B)
#define REG_PHY2P1_4_P0_16_L        (REG_PHY2P1_4_P0_BASE + 0x2C)
#define REG_PHY2P1_4_P0_16_H        (REG_PHY2P1_4_P0_BASE + 0x2D)
#define REG_PHY2P1_4_P0_17_L        (REG_PHY2P1_4_P0_BASE + 0x2E)
#define REG_PHY2P1_4_P0_17_H        (REG_PHY2P1_4_P0_BASE + 0x2F)
#define REG_PHY2P1_4_P0_18_L        (REG_PHY2P1_4_P0_BASE + 0x30)
#define REG_PHY2P1_4_P0_18_H        (REG_PHY2P1_4_P0_BASE + 0x31)
#define REG_PHY2P1_4_P0_19_L        (REG_PHY2P1_4_P0_BASE + 0x32)
#define REG_PHY2P1_4_P0_19_H        (REG_PHY2P1_4_P0_BASE + 0x33)
#define REG_PHY2P1_4_P0_1A_L        (REG_PHY2P1_4_P0_BASE + 0x34)
#define REG_PHY2P1_4_P0_1A_H        (REG_PHY2P1_4_P0_BASE + 0x35)
#define REG_PHY2P1_4_P0_1B_L        (REG_PHY2P1_4_P0_BASE + 0x36)
#define REG_PHY2P1_4_P0_1B_H        (REG_PHY2P1_4_P0_BASE + 0x37)
#define REG_PHY2P1_4_P0_1C_L        (REG_PHY2P1_4_P0_BASE + 0x38)
#define REG_PHY2P1_4_P0_1C_H        (REG_PHY2P1_4_P0_BASE + 0x39)
#define REG_PHY2P1_4_P0_1D_L        (REG_PHY2P1_4_P0_BASE + 0x3A)
#define REG_PHY2P1_4_P0_1D_H        (REG_PHY2P1_4_P0_BASE + 0x3B)
#define REG_PHY2P1_4_P0_1E_L        (REG_PHY2P1_4_P0_BASE + 0x3C)
#define REG_PHY2P1_4_P0_1E_H        (REG_PHY2P1_4_P0_BASE + 0x3D)
#define REG_PHY2P1_4_P0_1F_L        (REG_PHY2P1_4_P0_BASE + 0x3E)
#define REG_PHY2P1_4_P0_1F_H        (REG_PHY2P1_4_P0_BASE + 0x3F)
#define REG_PHY2P1_4_P0_20_L        (REG_PHY2P1_4_P0_BASE + 0x40)
#define REG_PHY2P1_4_P0_20_H        (REG_PHY2P1_4_P0_BASE + 0x41)
#define REG_PHY2P1_4_P0_21_L        (REG_PHY2P1_4_P0_BASE + 0x42)
#define REG_PHY2P1_4_P0_21_H        (REG_PHY2P1_4_P0_BASE + 0x43)
#define REG_PHY2P1_4_P0_22_L        (REG_PHY2P1_4_P0_BASE + 0x44)
#define REG_PHY2P1_4_P0_22_H        (REG_PHY2P1_4_P0_BASE + 0x45)
#define REG_PHY2P1_4_P0_23_L        (REG_PHY2P1_4_P0_BASE + 0x46)
#define REG_PHY2P1_4_P0_23_H        (REG_PHY2P1_4_P0_BASE + 0x47)
#define REG_PHY2P1_4_P0_24_L        (REG_PHY2P1_4_P0_BASE + 0x48)
#define REG_PHY2P1_4_P0_24_H        (REG_PHY2P1_4_P0_BASE + 0x49)
#define REG_PHY2P1_4_P0_25_L        (REG_PHY2P1_4_P0_BASE + 0x4A)
#define REG_PHY2P1_4_P0_25_H        (REG_PHY2P1_4_P0_BASE + 0x4B)
#define REG_PHY2P1_4_P0_26_L        (REG_PHY2P1_4_P0_BASE + 0x4C)
#define REG_PHY2P1_4_P0_26_H        (REG_PHY2P1_4_P0_BASE + 0x4D)
#define REG_PHY2P1_4_P0_27_L        (REG_PHY2P1_4_P0_BASE + 0x4E)
#define REG_PHY2P1_4_P0_27_H        (REG_PHY2P1_4_P0_BASE + 0x4F)
#define REG_PHY2P1_4_P0_28_L        (REG_PHY2P1_4_P0_BASE + 0x50)
#define REG_PHY2P1_4_P0_28_H        (REG_PHY2P1_4_P0_BASE + 0x51)
#define REG_PHY2P1_4_P0_29_L        (REG_PHY2P1_4_P0_BASE + 0x52)
#define REG_PHY2P1_4_P0_29_H        (REG_PHY2P1_4_P0_BASE + 0x53)
#define REG_PHY2P1_4_P0_2A_L        (REG_PHY2P1_4_P0_BASE + 0x54)
#define REG_PHY2P1_4_P0_2A_H        (REG_PHY2P1_4_P0_BASE + 0x55)
#define REG_PHY2P1_4_P0_2B_L        (REG_PHY2P1_4_P0_BASE + 0x56)
#define REG_PHY2P1_4_P0_2B_H        (REG_PHY2P1_4_P0_BASE + 0x57)
#define REG_PHY2P1_4_P0_2C_L        (REG_PHY2P1_4_P0_BASE + 0x58)
#define REG_PHY2P1_4_P0_2C_H        (REG_PHY2P1_4_P0_BASE + 0x59)
#define REG_PHY2P1_4_P0_2D_L        (REG_PHY2P1_4_P0_BASE + 0x5A)
#define REG_PHY2P1_4_P0_2D_H        (REG_PHY2P1_4_P0_BASE + 0x5B)
#define REG_PHY2P1_4_P0_2E_L        (REG_PHY2P1_4_P0_BASE + 0x5C)
#define REG_PHY2P1_4_P0_2E_H        (REG_PHY2P1_4_P0_BASE + 0x5D)
#define REG_PHY2P1_4_P0_2F_L        (REG_PHY2P1_4_P0_BASE + 0x5E)
#define REG_PHY2P1_4_P0_2F_H        (REG_PHY2P1_4_P0_BASE + 0x5F)
#define REG_PHY2P1_4_P0_30_L        (REG_PHY2P1_4_P0_BASE + 0x60)
#define REG_PHY2P1_4_P0_30_H        (REG_PHY2P1_4_P0_BASE + 0x61)
#define REG_PHY2P1_4_P0_31_L        (REG_PHY2P1_4_P0_BASE + 0x62)
#define REG_PHY2P1_4_P0_31_H        (REG_PHY2P1_4_P0_BASE + 0x63)
#define REG_PHY2P1_4_P0_32_L        (REG_PHY2P1_4_P0_BASE + 0x64)
#define REG_PHY2P1_4_P0_32_H        (REG_PHY2P1_4_P0_BASE + 0x65)
#define REG_PHY2P1_4_P0_33_L        (REG_PHY2P1_4_P0_BASE + 0x66)
#define REG_PHY2P1_4_P0_33_H        (REG_PHY2P1_4_P0_BASE + 0x67)
#define REG_PHY2P1_4_P0_34_L        (REG_PHY2P1_4_P0_BASE + 0x68)
#define REG_PHY2P1_4_P0_34_H        (REG_PHY2P1_4_P0_BASE + 0x69)
#define REG_PHY2P1_4_P0_35_L        (REG_PHY2P1_4_P0_BASE + 0x6A)
#define REG_PHY2P1_4_P0_35_H        (REG_PHY2P1_4_P0_BASE + 0x6B)
#define REG_PHY2P1_4_P0_36_L        (REG_PHY2P1_4_P0_BASE + 0x6C)
#define REG_PHY2P1_4_P0_36_H        (REG_PHY2P1_4_P0_BASE + 0x6D)
#define REG_PHY2P1_4_P0_37_L        (REG_PHY2P1_4_P0_BASE + 0x6E)
#define REG_PHY2P1_4_P0_37_H        (REG_PHY2P1_4_P0_BASE + 0x6F)
#define REG_PHY2P1_4_P0_38_L        (REG_PHY2P1_4_P0_BASE + 0x70)
#define REG_PHY2P1_4_P0_38_H        (REG_PHY2P1_4_P0_BASE + 0x71)
#define REG_PHY2P1_4_P0_39_L        (REG_PHY2P1_4_P0_BASE + 0x72)
#define REG_PHY2P1_4_P0_39_H        (REG_PHY2P1_4_P0_BASE + 0x73)
#define REG_PHY2P1_4_P0_3A_L        (REG_PHY2P1_4_P0_BASE + 0x74)
#define REG_PHY2P1_4_P0_3A_H        (REG_PHY2P1_4_P0_BASE + 0x75)
#define REG_PHY2P1_4_P0_3B_L        (REG_PHY2P1_4_P0_BASE + 0x76)
#define REG_PHY2P1_4_P0_3B_H        (REG_PHY2P1_4_P0_BASE + 0x77)
#define REG_PHY2P1_4_P0_3C_L        (REG_PHY2P1_4_P0_BASE + 0x78)
#define REG_PHY2P1_4_P0_3C_H        (REG_PHY2P1_4_P0_BASE + 0x79)
#define REG_PHY2P1_4_P0_3D_L        (REG_PHY2P1_4_P0_BASE + 0x7A)
#define REG_PHY2P1_4_P0_3D_H        (REG_PHY2P1_4_P0_BASE + 0x7B)
#define REG_PHY2P1_4_P0_3E_L        (REG_PHY2P1_4_P0_BASE + 0x7C)
#define REG_PHY2P1_4_P0_3E_H        (REG_PHY2P1_4_P0_BASE + 0x7D)
#define REG_PHY2P1_4_P0_3F_L        (REG_PHY2P1_4_P0_BASE + 0x7E)
#define REG_PHY2P1_4_P0_3F_H        (REG_PHY2P1_4_P0_BASE + 0x7F)
#define REG_PHY2P1_4_P0_40_L        (REG_PHY2P1_4_P0_BASE + 0x80)
#define REG_PHY2P1_4_P0_40_H        (REG_PHY2P1_4_P0_BASE + 0x81)
#define REG_PHY2P1_4_P0_41_L        (REG_PHY2P1_4_P0_BASE + 0x82)
#define REG_PHY2P1_4_P0_41_H        (REG_PHY2P1_4_P0_BASE + 0x83)
#define REG_PHY2P1_4_P0_42_L        (REG_PHY2P1_4_P0_BASE + 0x84)
#define REG_PHY2P1_4_P0_42_H        (REG_PHY2P1_4_P0_BASE + 0x85)
#define REG_PHY2P1_4_P0_43_L        (REG_PHY2P1_4_P0_BASE + 0x86)
#define REG_PHY2P1_4_P0_43_H        (REG_PHY2P1_4_P0_BASE + 0x87)
#define REG_PHY2P1_4_P0_44_L        (REG_PHY2P1_4_P0_BASE + 0x88)
#define REG_PHY2P1_4_P0_44_H        (REG_PHY2P1_4_P0_BASE + 0x89)
#define REG_PHY2P1_4_P0_45_L        (REG_PHY2P1_4_P0_BASE + 0x8A)
#define REG_PHY2P1_4_P0_45_H        (REG_PHY2P1_4_P0_BASE + 0x8B)
#define REG_PHY2P1_4_P0_46_L        (REG_PHY2P1_4_P0_BASE + 0x8C)
#define REG_PHY2P1_4_P0_46_H        (REG_PHY2P1_4_P0_BASE + 0x8D)
#define REG_PHY2P1_4_P0_47_L        (REG_PHY2P1_4_P0_BASE + 0x8E)
#define REG_PHY2P1_4_P0_47_H        (REG_PHY2P1_4_P0_BASE + 0x8F)
#define REG_PHY2P1_4_P0_48_L        (REG_PHY2P1_4_P0_BASE + 0x90)
#define REG_PHY2P1_4_P0_48_H        (REG_PHY2P1_4_P0_BASE + 0x91)
#define REG_PHY2P1_4_P0_49_L        (REG_PHY2P1_4_P0_BASE + 0x92)
#define REG_PHY2P1_4_P0_49_H        (REG_PHY2P1_4_P0_BASE + 0x93)
#define REG_PHY2P1_4_P0_4A_L        (REG_PHY2P1_4_P0_BASE + 0x94)
#define REG_PHY2P1_4_P0_4A_H        (REG_PHY2P1_4_P0_BASE + 0x95)
#define REG_PHY2P1_4_P0_4B_L        (REG_PHY2P1_4_P0_BASE + 0x96)
#define REG_PHY2P1_4_P0_4B_H        (REG_PHY2P1_4_P0_BASE + 0x97)
#define REG_PHY2P1_4_P0_4C_L        (REG_PHY2P1_4_P0_BASE + 0x98)
#define REG_PHY2P1_4_P0_4C_H        (REG_PHY2P1_4_P0_BASE + 0x99)
#define REG_PHY2P1_4_P0_4D_L        (REG_PHY2P1_4_P0_BASE + 0x9A)
#define REG_PHY2P1_4_P0_4D_H        (REG_PHY2P1_4_P0_BASE + 0x9B)
#define REG_PHY2P1_4_P0_4E_L        (REG_PHY2P1_4_P0_BASE + 0x9C)
#define REG_PHY2P1_4_P0_4E_H        (REG_PHY2P1_4_P0_BASE + 0x9D)
#define REG_PHY2P1_4_P0_4F_L        (REG_PHY2P1_4_P0_BASE + 0x9E)
#define REG_PHY2P1_4_P0_4F_H        (REG_PHY2P1_4_P0_BASE + 0x9F)
#define REG_PHY2P1_4_P0_50_L        (REG_PHY2P1_4_P0_BASE + 0xA0)
#define REG_PHY2P1_4_P0_50_H        (REG_PHY2P1_4_P0_BASE + 0xA1)
#define REG_PHY2P1_4_P0_51_L        (REG_PHY2P1_4_P0_BASE + 0xA2)
#define REG_PHY2P1_4_P0_51_H        (REG_PHY2P1_4_P0_BASE + 0xA3)
#define REG_PHY2P1_4_P0_52_L        (REG_PHY2P1_4_P0_BASE + 0xA4)
#define REG_PHY2P1_4_P0_52_H        (REG_PHY2P1_4_P0_BASE + 0xA5)
#define REG_PHY2P1_4_P0_53_L        (REG_PHY2P1_4_P0_BASE + 0xA6)
#define REG_PHY2P1_4_P0_53_H        (REG_PHY2P1_4_P0_BASE + 0xA7)
#define REG_PHY2P1_4_P0_54_L        (REG_PHY2P1_4_P0_BASE + 0xA8)
#define REG_PHY2P1_4_P0_54_H        (REG_PHY2P1_4_P0_BASE + 0xA9)
#define REG_PHY2P1_4_P0_55_L        (REG_PHY2P1_4_P0_BASE + 0xAA)
#define REG_PHY2P1_4_P0_55_H        (REG_PHY2P1_4_P0_BASE + 0xAB)
#define REG_PHY2P1_4_P0_56_L        (REG_PHY2P1_4_P0_BASE + 0xAC)
#define REG_PHY2P1_4_P0_56_H        (REG_PHY2P1_4_P0_BASE + 0xAD)
#define REG_PHY2P1_4_P0_57_L        (REG_PHY2P1_4_P0_BASE + 0xAE)
#define REG_PHY2P1_4_P0_57_H        (REG_PHY2P1_4_P0_BASE + 0xAF)
#define REG_PHY2P1_4_P0_58_L        (REG_PHY2P1_4_P0_BASE + 0xB0)
#define REG_PHY2P1_4_P0_58_H        (REG_PHY2P1_4_P0_BASE + 0xB1)
#define REG_PHY2P1_4_P0_59_L        (REG_PHY2P1_4_P0_BASE + 0xB2)
#define REG_PHY2P1_4_P0_59_H        (REG_PHY2P1_4_P0_BASE + 0xB3)
#define REG_PHY2P1_4_P0_5A_L        (REG_PHY2P1_4_P0_BASE + 0xB4)
#define REG_PHY2P1_4_P0_5A_H        (REG_PHY2P1_4_P0_BASE + 0xB5)
#define REG_PHY2P1_4_P0_5B_L        (REG_PHY2P1_4_P0_BASE + 0xB6)
#define REG_PHY2P1_4_P0_5B_H        (REG_PHY2P1_4_P0_BASE + 0xB7)
#define REG_PHY2P1_4_P0_5C_L        (REG_PHY2P1_4_P0_BASE + 0xB8)
#define REG_PHY2P1_4_P0_5C_H        (REG_PHY2P1_4_P0_BASE + 0xB9)
#define REG_PHY2P1_4_P0_5D_L        (REG_PHY2P1_4_P0_BASE + 0xBA)
#define REG_PHY2P1_4_P0_5D_H        (REG_PHY2P1_4_P0_BASE + 0xBB)
#define REG_PHY2P1_4_P0_5E_L        (REG_PHY2P1_4_P0_BASE + 0xBC)
#define REG_PHY2P1_4_P0_5E_H        (REG_PHY2P1_4_P0_BASE + 0xBD)
#define REG_PHY2P1_4_P0_5F_L        (REG_PHY2P1_4_P0_BASE + 0xBE)
#define REG_PHY2P1_4_P0_5F_H        (REG_PHY2P1_4_P0_BASE + 0xBF)
#define REG_PHY2P1_4_P0_60_L        (REG_PHY2P1_4_P0_BASE + 0xC0)
#define REG_PHY2P1_4_P0_60_H        (REG_PHY2P1_4_P0_BASE + 0xC1)
#define REG_PHY2P1_4_P0_61_L        (REG_PHY2P1_4_P0_BASE + 0xC2)
#define REG_PHY2P1_4_P0_61_H        (REG_PHY2P1_4_P0_BASE + 0xC3)
#define REG_PHY2P1_4_P0_62_L        (REG_PHY2P1_4_P0_BASE + 0xC4)
#define REG_PHY2P1_4_P0_62_H        (REG_PHY2P1_4_P0_BASE + 0xC5)
#define REG_PHY2P1_4_P0_63_L        (REG_PHY2P1_4_P0_BASE + 0xC6)
#define REG_PHY2P1_4_P0_63_H        (REG_PHY2P1_4_P0_BASE + 0xC7)
#define REG_PHY2P1_4_P0_64_L        (REG_PHY2P1_4_P0_BASE + 0xC8)
#define REG_PHY2P1_4_P0_64_H        (REG_PHY2P1_4_P0_BASE + 0xC9)
#define REG_PHY2P1_4_P0_65_L        (REG_PHY2P1_4_P0_BASE + 0xCA)
#define REG_PHY2P1_4_P0_65_H        (REG_PHY2P1_4_P0_BASE + 0xCB)
#define REG_PHY2P1_4_P0_66_L        (REG_PHY2P1_4_P0_BASE + 0xCC)
#define REG_PHY2P1_4_P0_66_H        (REG_PHY2P1_4_P0_BASE + 0xCD)
#define REG_PHY2P1_4_P0_67_L        (REG_PHY2P1_4_P0_BASE + 0xCE)
#define REG_PHY2P1_4_P0_67_H        (REG_PHY2P1_4_P0_BASE + 0xCF)
#define REG_PHY2P1_4_P0_68_L        (REG_PHY2P1_4_P0_BASE + 0xD0)
#define REG_PHY2P1_4_P0_68_H        (REG_PHY2P1_4_P0_BASE + 0xD1)
#define REG_PHY2P1_4_P0_69_L        (REG_PHY2P1_4_P0_BASE + 0xD2)
#define REG_PHY2P1_4_P0_69_H        (REG_PHY2P1_4_P0_BASE + 0xD3)
#define REG_PHY2P1_4_P0_6A_L        (REG_PHY2P1_4_P0_BASE + 0xD4)
#define REG_PHY2P1_4_P0_6A_H        (REG_PHY2P1_4_P0_BASE + 0xD5)
#define REG_PHY2P1_4_P0_6B_L        (REG_PHY2P1_4_P0_BASE + 0xD6)
#define REG_PHY2P1_4_P0_6B_H        (REG_PHY2P1_4_P0_BASE + 0xD7)
#define REG_PHY2P1_4_P0_6C_L        (REG_PHY2P1_4_P0_BASE + 0xD8)
#define REG_PHY2P1_4_P0_6C_H        (REG_PHY2P1_4_P0_BASE + 0xD9)
#define REG_PHY2P1_4_P0_6D_L        (REG_PHY2P1_4_P0_BASE + 0xDA)
#define REG_PHY2P1_4_P0_6D_H        (REG_PHY2P1_4_P0_BASE + 0xDB)
#define REG_PHY2P1_4_P0_6E_L        (REG_PHY2P1_4_P0_BASE + 0xDC)
#define REG_PHY2P1_4_P0_6E_H        (REG_PHY2P1_4_P0_BASE + 0xDD)
#define REG_PHY2P1_4_P0_6F_L        (REG_PHY2P1_4_P0_BASE + 0xDE)
#define REG_PHY2P1_4_P0_6F_H        (REG_PHY2P1_4_P0_BASE + 0xDF)
#define REG_PHY2P1_4_P0_70_L        (REG_PHY2P1_4_P0_BASE + 0xE0)
#define REG_PHY2P1_4_P0_70_H        (REG_PHY2P1_4_P0_BASE + 0xE1)
#define REG_PHY2P1_4_P0_71_L        (REG_PHY2P1_4_P0_BASE + 0xE2)
#define REG_PHY2P1_4_P0_71_H        (REG_PHY2P1_4_P0_BASE + 0xE3)
#define REG_PHY2P1_4_P0_72_L        (REG_PHY2P1_4_P0_BASE + 0xE4)
#define REG_PHY2P1_4_P0_72_H        (REG_PHY2P1_4_P0_BASE + 0xE5)
#define REG_PHY2P1_4_P0_73_L        (REG_PHY2P1_4_P0_BASE + 0xE6)
#define REG_PHY2P1_4_P0_73_H        (REG_PHY2P1_4_P0_BASE + 0xE7)
#define REG_PHY2P1_4_P0_74_L        (REG_PHY2P1_4_P0_BASE + 0xE8)
#define REG_PHY2P1_4_P0_74_H        (REG_PHY2P1_4_P0_BASE + 0xE9)
#define REG_PHY2P1_4_P0_75_L        (REG_PHY2P1_4_P0_BASE + 0xEA)
#define REG_PHY2P1_4_P0_75_H        (REG_PHY2P1_4_P0_BASE + 0xEB)
#define REG_PHY2P1_4_P0_76_L        (REG_PHY2P1_4_P0_BASE + 0xEC)
#define REG_PHY2P1_4_P0_76_H        (REG_PHY2P1_4_P0_BASE + 0xED)
#define REG_PHY2P1_4_P0_77_L        (REG_PHY2P1_4_P0_BASE + 0xEE)
#define REG_PHY2P1_4_P0_77_H        (REG_PHY2P1_4_P0_BASE + 0xEF)
#define REG_PHY2P1_4_P0_78_L        (REG_PHY2P1_4_P0_BASE + 0xF0)
#define REG_PHY2P1_4_P0_78_H        (REG_PHY2P1_4_P0_BASE + 0xF1)
#define REG_PHY2P1_4_P0_79_L        (REG_PHY2P1_4_P0_BASE + 0xF2)
#define REG_PHY2P1_4_P0_79_H        (REG_PHY2P1_4_P0_BASE + 0xF3)
#define REG_PHY2P1_4_P0_7A_L        (REG_PHY2P1_4_P0_BASE + 0xF4)
#define REG_PHY2P1_4_P0_7A_H        (REG_PHY2P1_4_P0_BASE + 0xF5)
#define REG_PHY2P1_4_P0_7B_L        (REG_PHY2P1_4_P0_BASE + 0xF6)
#define REG_PHY2P1_4_P0_7B_H        (REG_PHY2P1_4_P0_BASE + 0xF7)
#define REG_PHY2P1_4_P0_7C_L        (REG_PHY2P1_4_P0_BASE + 0xF8)
#define REG_PHY2P1_4_P0_7C_H        (REG_PHY2P1_4_P0_BASE + 0xF9)
#define REG_PHY2P1_4_P0_7D_L        (REG_PHY2P1_4_P0_BASE + 0xFA)
#define REG_PHY2P1_4_P0_7D_H        (REG_PHY2P1_4_P0_BASE + 0xFB)
#define REG_PHY2P1_4_P0_7E_L        (REG_PHY2P1_4_P0_BASE + 0xFC)
#define REG_PHY2P1_4_P0_7E_H        (REG_PHY2P1_4_P0_BASE + 0xFD)
#define REG_PHY2P1_4_P0_7F_L        (REG_PHY2P1_4_P0_BASE + 0xFE)
#define REG_PHY2P1_4_P0_7F_H        (REG_PHY2P1_4_P0_BASE + 0xFF)

//=============================================================
// PHY_TRAIN_P0
#define REG_PHY_TRAIN_P0_00_L       (REG_PHY_TRAIN_P0_BASE + 0x00)
#define REG_PHY_TRAIN_P0_00_H       (REG_PHY_TRAIN_P0_BASE + 0x01)
#define REG_PHY_TRAIN_P0_01_L       (REG_PHY_TRAIN_P0_BASE + 0x02)
#define REG_PHY_TRAIN_P0_01_H       (REG_PHY_TRAIN_P0_BASE + 0x03)
#define REG_PHY_TRAIN_P0_02_L       (REG_PHY_TRAIN_P0_BASE + 0x04)
#define REG_PHY_TRAIN_P0_02_H       (REG_PHY_TRAIN_P0_BASE + 0x05)
#define REG_PHY_TRAIN_P0_03_L       (REG_PHY_TRAIN_P0_BASE + 0x06)
#define REG_PHY_TRAIN_P0_03_H       (REG_PHY_TRAIN_P0_BASE + 0x07)
#define REG_PHY_TRAIN_P0_04_L       (REG_PHY_TRAIN_P0_BASE + 0x08)
#define REG_PHY_TRAIN_P0_04_H       (REG_PHY_TRAIN_P0_BASE + 0x09)
#define REG_PHY_TRAIN_P0_05_L       (REG_PHY_TRAIN_P0_BASE + 0x0A)
#define REG_PHY_TRAIN_P0_05_H       (REG_PHY_TRAIN_P0_BASE + 0x0B)
#define REG_PHY_TRAIN_P0_06_L       (REG_PHY_TRAIN_P0_BASE + 0x0C)
#define REG_PHY_TRAIN_P0_06_H       (REG_PHY_TRAIN_P0_BASE + 0x0D)
#define REG_PHY_TRAIN_P0_07_L       (REG_PHY_TRAIN_P0_BASE + 0x0E)
#define REG_PHY_TRAIN_P0_07_H       (REG_PHY_TRAIN_P0_BASE + 0x0F)
#define REG_PHY_TRAIN_P0_08_L       (REG_PHY_TRAIN_P0_BASE + 0x10)
#define REG_PHY_TRAIN_P0_08_H       (REG_PHY_TRAIN_P0_BASE + 0x11)
#define REG_PHY_TRAIN_P0_09_L       (REG_PHY_TRAIN_P0_BASE + 0x12)
#define REG_PHY_TRAIN_P0_09_H       (REG_PHY_TRAIN_P0_BASE + 0x13)
#define REG_PHY_TRAIN_P0_0A_L       (REG_PHY_TRAIN_P0_BASE + 0x14)
#define REG_PHY_TRAIN_P0_0A_H       (REG_PHY_TRAIN_P0_BASE + 0x15)
#define REG_PHY_TRAIN_P0_0B_L       (REG_PHY_TRAIN_P0_BASE + 0x16)
#define REG_PHY_TRAIN_P0_0B_H       (REG_PHY_TRAIN_P0_BASE + 0x17)
#define REG_PHY_TRAIN_P0_0C_L       (REG_PHY_TRAIN_P0_BASE + 0x18)
#define REG_PHY_TRAIN_P0_0C_H       (REG_PHY_TRAIN_P0_BASE + 0x19)
#define REG_PHY_TRAIN_P0_0D_L       (REG_PHY_TRAIN_P0_BASE + 0x1A)
#define REG_PHY_TRAIN_P0_0D_H       (REG_PHY_TRAIN_P0_BASE + 0x1B)
#define REG_PHY_TRAIN_P0_0E_L       (REG_PHY_TRAIN_P0_BASE + 0x1C)
#define REG_PHY_TRAIN_P0_0E_H       (REG_PHY_TRAIN_P0_BASE + 0x1D)
#define REG_PHY_TRAIN_P0_0F_L       (REG_PHY_TRAIN_P0_BASE + 0x1E)
#define REG_PHY_TRAIN_P0_0F_H       (REG_PHY_TRAIN_P0_BASE + 0x1F)
#define REG_PHY_TRAIN_P0_10_L       (REG_PHY_TRAIN_P0_BASE + 0x20)
#define REG_PHY_TRAIN_P0_10_H       (REG_PHY_TRAIN_P0_BASE + 0x21)
#define REG_PHY_TRAIN_P0_11_L       (REG_PHY_TRAIN_P0_BASE + 0x22)
#define REG_PHY_TRAIN_P0_11_H       (REG_PHY_TRAIN_P0_BASE + 0x23)
#define REG_PHY_TRAIN_P0_12_L       (REG_PHY_TRAIN_P0_BASE + 0x24)
#define REG_PHY_TRAIN_P0_12_H       (REG_PHY_TRAIN_P0_BASE + 0x25)
#define REG_PHY_TRAIN_P0_13_L       (REG_PHY_TRAIN_P0_BASE + 0x26)
#define REG_PHY_TRAIN_P0_13_H       (REG_PHY_TRAIN_P0_BASE + 0x27)
#define REG_PHY_TRAIN_P0_14_L       (REG_PHY_TRAIN_P0_BASE + 0x28)
#define REG_PHY_TRAIN_P0_14_H       (REG_PHY_TRAIN_P0_BASE + 0x29)
#define REG_PHY_TRAIN_P0_15_L       (REG_PHY_TRAIN_P0_BASE + 0x2A)
#define REG_PHY_TRAIN_P0_15_H       (REG_PHY_TRAIN_P0_BASE + 0x2B)
#define REG_PHY_TRAIN_P0_16_L       (REG_PHY_TRAIN_P0_BASE + 0x2C)
#define REG_PHY_TRAIN_P0_16_H       (REG_PHY_TRAIN_P0_BASE + 0x2D)
#define REG_PHY_TRAIN_P0_17_L       (REG_PHY_TRAIN_P0_BASE + 0x2E)
#define REG_PHY_TRAIN_P0_17_H       (REG_PHY_TRAIN_P0_BASE + 0x2F)
#define REG_PHY_TRAIN_P0_18_L       (REG_PHY_TRAIN_P0_BASE + 0x30)
#define REG_PHY_TRAIN_P0_18_H       (REG_PHY_TRAIN_P0_BASE + 0x31)
#define REG_PHY_TRAIN_P0_19_L       (REG_PHY_TRAIN_P0_BASE + 0x32)
#define REG_PHY_TRAIN_P0_19_H       (REG_PHY_TRAIN_P0_BASE + 0x33)
#define REG_PHY_TRAIN_P0_1A_L       (REG_PHY_TRAIN_P0_BASE + 0x34)
#define REG_PHY_TRAIN_P0_1A_H       (REG_PHY_TRAIN_P0_BASE + 0x35)
#define REG_PHY_TRAIN_P0_1B_L       (REG_PHY_TRAIN_P0_BASE + 0x36)
#define REG_PHY_TRAIN_P0_1B_H       (REG_PHY_TRAIN_P0_BASE + 0x37)
#define REG_PHY_TRAIN_P0_1C_L       (REG_PHY_TRAIN_P0_BASE + 0x38)
#define REG_PHY_TRAIN_P0_1C_H       (REG_PHY_TRAIN_P0_BASE + 0x39)
#define REG_PHY_TRAIN_P0_1D_L       (REG_PHY_TRAIN_P0_BASE + 0x3A)
#define REG_PHY_TRAIN_P0_1D_H       (REG_PHY_TRAIN_P0_BASE + 0x3B)
#define REG_PHY_TRAIN_P0_1E_L       (REG_PHY_TRAIN_P0_BASE + 0x3C)
#define REG_PHY_TRAIN_P0_1E_H       (REG_PHY_TRAIN_P0_BASE + 0x3D)
#define REG_PHY_TRAIN_P0_1F_L       (REG_PHY_TRAIN_P0_BASE + 0x3E)
#define REG_PHY_TRAIN_P0_1F_H       (REG_PHY_TRAIN_P0_BASE + 0x3F)
#define REG_PHY_TRAIN_P0_20_L       (REG_PHY_TRAIN_P0_BASE + 0x40)
#define REG_PHY_TRAIN_P0_20_H       (REG_PHY_TRAIN_P0_BASE + 0x41)
#define REG_PHY_TRAIN_P0_21_L       (REG_PHY_TRAIN_P0_BASE + 0x42)
#define REG_PHY_TRAIN_P0_21_H       (REG_PHY_TRAIN_P0_BASE + 0x43)
#define REG_PHY_TRAIN_P0_22_L       (REG_PHY_TRAIN_P0_BASE + 0x44)
#define REG_PHY_TRAIN_P0_22_H       (REG_PHY_TRAIN_P0_BASE + 0x45)
#define REG_PHY_TRAIN_P0_23_L       (REG_PHY_TRAIN_P0_BASE + 0x46)
#define REG_PHY_TRAIN_P0_23_H       (REG_PHY_TRAIN_P0_BASE + 0x47)
#define REG_PHY_TRAIN_P0_24_L       (REG_PHY_TRAIN_P0_BASE + 0x48)
#define REG_PHY_TRAIN_P0_24_H       (REG_PHY_TRAIN_P0_BASE + 0x49)
#define REG_PHY_TRAIN_P0_25_L       (REG_PHY_TRAIN_P0_BASE + 0x4A)
#define REG_PHY_TRAIN_P0_25_H       (REG_PHY_TRAIN_P0_BASE + 0x4B)
#define REG_PHY_TRAIN_P0_26_L       (REG_PHY_TRAIN_P0_BASE + 0x4C)
#define REG_PHY_TRAIN_P0_26_H       (REG_PHY_TRAIN_P0_BASE + 0x4D)
#define REG_PHY_TRAIN_P0_27_L       (REG_PHY_TRAIN_P0_BASE + 0x4E)
#define REG_PHY_TRAIN_P0_27_H       (REG_PHY_TRAIN_P0_BASE + 0x4F)
#define REG_PHY_TRAIN_P0_28_L       (REG_PHY_TRAIN_P0_BASE + 0x50)
#define REG_PHY_TRAIN_P0_28_H       (REG_PHY_TRAIN_P0_BASE + 0x51)
#define REG_PHY_TRAIN_P0_29_L       (REG_PHY_TRAIN_P0_BASE + 0x52)
#define REG_PHY_TRAIN_P0_29_H       (REG_PHY_TRAIN_P0_BASE + 0x53)
#define REG_PHY_TRAIN_P0_2A_L       (REG_PHY_TRAIN_P0_BASE + 0x54)
#define REG_PHY_TRAIN_P0_2A_H       (REG_PHY_TRAIN_P0_BASE + 0x55)
#define REG_PHY_TRAIN_P0_2B_L       (REG_PHY_TRAIN_P0_BASE + 0x56)
#define REG_PHY_TRAIN_P0_2B_H       (REG_PHY_TRAIN_P0_BASE + 0x57)
#define REG_PHY_TRAIN_P0_2C_L       (REG_PHY_TRAIN_P0_BASE + 0x58)
#define REG_PHY_TRAIN_P0_2C_H       (REG_PHY_TRAIN_P0_BASE + 0x59)
#define REG_PHY_TRAIN_P0_2D_L       (REG_PHY_TRAIN_P0_BASE + 0x5A)
#define REG_PHY_TRAIN_P0_2D_H       (REG_PHY_TRAIN_P0_BASE + 0x5B)
#define REG_PHY_TRAIN_P0_2E_L       (REG_PHY_TRAIN_P0_BASE + 0x5C)
#define REG_PHY_TRAIN_P0_2E_H       (REG_PHY_TRAIN_P0_BASE + 0x5D)
#define REG_PHY_TRAIN_P0_2F_L       (REG_PHY_TRAIN_P0_BASE + 0x5E)
#define REG_PHY_TRAIN_P0_2F_H       (REG_PHY_TRAIN_P0_BASE + 0x5F)
#define REG_PHY_TRAIN_P0_30_L       (REG_PHY_TRAIN_P0_BASE + 0x60)
#define REG_PHY_TRAIN_P0_30_H       (REG_PHY_TRAIN_P0_BASE + 0x61)
#define REG_PHY_TRAIN_P0_31_L       (REG_PHY_TRAIN_P0_BASE + 0x62)
#define REG_PHY_TRAIN_P0_31_H       (REG_PHY_TRAIN_P0_BASE + 0x63)
#define REG_PHY_TRAIN_P0_32_L       (REG_PHY_TRAIN_P0_BASE + 0x64)
#define REG_PHY_TRAIN_P0_32_H       (REG_PHY_TRAIN_P0_BASE + 0x65)
#define REG_PHY_TRAIN_P0_33_L       (REG_PHY_TRAIN_P0_BASE + 0x66)
#define REG_PHY_TRAIN_P0_33_H       (REG_PHY_TRAIN_P0_BASE + 0x67)
#define REG_PHY_TRAIN_P0_34_L       (REG_PHY_TRAIN_P0_BASE + 0x68)
#define REG_PHY_TRAIN_P0_34_H       (REG_PHY_TRAIN_P0_BASE + 0x69)
#define REG_PHY_TRAIN_P0_35_L       (REG_PHY_TRAIN_P0_BASE + 0x6A)
#define REG_PHY_TRAIN_P0_35_H       (REG_PHY_TRAIN_P0_BASE + 0x6B)
#define REG_PHY_TRAIN_P0_36_L       (REG_PHY_TRAIN_P0_BASE + 0x6C)
#define REG_PHY_TRAIN_P0_36_H       (REG_PHY_TRAIN_P0_BASE + 0x6D)
#define REG_PHY_TRAIN_P0_37_L       (REG_PHY_TRAIN_P0_BASE + 0x6E)
#define REG_PHY_TRAIN_P0_37_H       (REG_PHY_TRAIN_P0_BASE + 0x6F)
#define REG_PHY_TRAIN_P0_38_L       (REG_PHY_TRAIN_P0_BASE + 0x70)
#define REG_PHY_TRAIN_P0_38_H       (REG_PHY_TRAIN_P0_BASE + 0x71)
#define REG_PHY_TRAIN_P0_39_L       (REG_PHY_TRAIN_P0_BASE + 0x72)
#define REG_PHY_TRAIN_P0_39_H       (REG_PHY_TRAIN_P0_BASE + 0x73)
#define REG_PHY_TRAIN_P0_3A_L       (REG_PHY_TRAIN_P0_BASE + 0x74)
#define REG_PHY_TRAIN_P0_3A_H       (REG_PHY_TRAIN_P0_BASE + 0x75)
#define REG_PHY_TRAIN_P0_3B_L       (REG_PHY_TRAIN_P0_BASE + 0x76)
#define REG_PHY_TRAIN_P0_3B_H       (REG_PHY_TRAIN_P0_BASE + 0x77)
#define REG_PHY_TRAIN_P0_3C_L       (REG_PHY_TRAIN_P0_BASE + 0x78)
#define REG_PHY_TRAIN_P0_3C_H       (REG_PHY_TRAIN_P0_BASE + 0x79)
#define REG_PHY_TRAIN_P0_3D_L       (REG_PHY_TRAIN_P0_BASE + 0x7A)
#define REG_PHY_TRAIN_P0_3D_H       (REG_PHY_TRAIN_P0_BASE + 0x7B)
#define REG_PHY_TRAIN_P0_3E_L       (REG_PHY_TRAIN_P0_BASE + 0x7C)
#define REG_PHY_TRAIN_P0_3E_H       (REG_PHY_TRAIN_P0_BASE + 0x7D)
#define REG_PHY_TRAIN_P0_3F_L       (REG_PHY_TRAIN_P0_BASE + 0x7E)
#define REG_PHY_TRAIN_P0_3F_H       (REG_PHY_TRAIN_P0_BASE + 0x7F)
#define REG_PHY2P1_5_P0_40_L       (REG_PHY_TRAIN_P0_BASE + 0x80)
#define REG_PHY2P1_5_P0_40_H       (REG_PHY_TRAIN_P0_BASE + 0x81)
#define REG_PHY2P1_5_P0_41_L       (REG_PHY_TRAIN_P0_BASE + 0x82)
#define REG_PHY2P1_5_P0_41_H       (REG_PHY_TRAIN_P0_BASE + 0x83)
#define REG_PHY2P1_5_P0_42_L       (REG_PHY_TRAIN_P0_BASE + 0x84)
#define REG_PHY2P1_5_P0_42_H       (REG_PHY_TRAIN_P0_BASE + 0x85)
#define REG_PHY2P1_5_P0_43_L       (REG_PHY_TRAIN_P0_BASE + 0x86)
#define REG_PHY2P1_5_P0_43_H       (REG_PHY_TRAIN_P0_BASE + 0x87)
#define REG_PHY2P1_5_P0_44_L       (REG_PHY_TRAIN_P0_BASE + 0x88)
#define REG_PHY2P1_5_P0_44_H       (REG_PHY_TRAIN_P0_BASE + 0x89)
#define REG_PHY2P1_5_P0_45_L       (REG_PHY_TRAIN_P0_BASE + 0x8A)
#define REG_PHY2P1_5_P0_45_H       (REG_PHY_TRAIN_P0_BASE + 0x8B)
#define REG_PHY2P1_5_P0_46_L       (REG_PHY_TRAIN_P0_BASE + 0x8C)
#define REG_PHY2P1_5_P0_46_H       (REG_PHY_TRAIN_P0_BASE + 0x8D)
#define REG_PHY2P1_5_P0_47_L       (REG_PHY_TRAIN_P0_BASE + 0x8E)
#define REG_PHY2P1_5_P0_47_H       (REG_PHY_TRAIN_P0_BASE + 0x8F)
#define REG_PHY2P1_5_P0_48_L       (REG_PHY_TRAIN_P0_BASE + 0x90)
#define REG_PHY2P1_5_P0_48_H       (REG_PHY_TRAIN_P0_BASE + 0x91)
#define REG_PHY2P1_5_P0_49_L       (REG_PHY_TRAIN_P0_BASE + 0x92)
#define REG_PHY2P1_5_P0_49_H       (REG_PHY_TRAIN_P0_BASE + 0x93)
#define REG_PHY2P1_5_P0_4A_L       (REG_PHY_TRAIN_P0_BASE + 0x94)
#define REG_PHY2P1_5_P0_4A_H       (REG_PHY_TRAIN_P0_BASE + 0x95)
#define REG_PHY2P1_5_P0_4B_L       (REG_PHY_TRAIN_P0_BASE + 0x96)
#define REG_PHY2P1_5_P0_4B_H       (REG_PHY_TRAIN_P0_BASE + 0x97)
#define REG_PHY2P1_5_P0_4C_L       (REG_PHY_TRAIN_P0_BASE + 0x98)
#define REG_PHY2P1_5_P0_4C_H       (REG_PHY_TRAIN_P0_BASE + 0x99)
#define REG_PHY2P1_5_P0_4D_L       (REG_PHY_TRAIN_P0_BASE + 0x9A)
#define REG_PHY2P1_5_P0_4D_H       (REG_PHY_TRAIN_P0_BASE + 0x9B)
#define REG_PHY2P1_5_P0_4E_L       (REG_PHY_TRAIN_P0_BASE + 0x9C)
#define REG_PHY2P1_5_P0_4E_H       (REG_PHY_TRAIN_P0_BASE + 0x9D)
#define REG_PHY2P1_5_P0_4F_L       (REG_PHY_TRAIN_P0_BASE + 0x9E)
#define REG_PHY2P1_5_P0_4F_H       (REG_PHY_TRAIN_P0_BASE + 0x9F)
#define REG_PHY2P1_5_P0_50_L       (REG_PHY_TRAIN_P0_BASE + 0xA0)
#define REG_PHY2P1_5_P0_50_H       (REG_PHY_TRAIN_P0_BASE + 0xA1)
#define REG_PHY2P1_5_P0_51_L       (REG_PHY_TRAIN_P0_BASE + 0xA2)
#define REG_PHY2P1_5_P0_51_H       (REG_PHY_TRAIN_P0_BASE + 0xA3)
#define REG_PHY2P1_5_P0_52_L       (REG_PHY_TRAIN_P0_BASE + 0xA4)
#define REG_PHY2P1_5_P0_52_H       (REG_PHY_TRAIN_P0_BASE + 0xA5)
#define REG_PHY2P1_5_P0_53_L       (REG_PHY_TRAIN_P0_BASE + 0xA6)
#define REG_PHY2P1_5_P0_53_H       (REG_PHY_TRAIN_P0_BASE + 0xA7)
#define REG_PHY2P1_5_P0_54_L       (REG_PHY_TRAIN_P0_BASE + 0xA8)
#define REG_PHY2P1_5_P0_54_H       (REG_PHY_TRAIN_P0_BASE + 0xA9)
#define REG_PHY2P1_5_P0_55_L       (REG_PHY_TRAIN_P0_BASE + 0xAA)
#define REG_PHY2P1_5_P0_55_H       (REG_PHY_TRAIN_P0_BASE + 0xAB)
#define REG_PHY2P1_5_P0_56_L       (REG_PHY_TRAIN_P0_BASE + 0xAC)
#define REG_PHY2P1_5_P0_56_H       (REG_PHY_TRAIN_P0_BASE + 0xAD)
#define REG_PHY2P1_5_P0_57_L       (REG_PHY_TRAIN_P0_BASE + 0xAE)
#define REG_PHY2P1_5_P0_57_H       (REG_PHY_TRAIN_P0_BASE + 0xAF)
#define REG_PHY2P1_5_P0_58_L       (REG_PHY_TRAIN_P0_BASE + 0xB0)
#define REG_PHY2P1_5_P0_58_H       (REG_PHY_TRAIN_P0_BASE + 0xB1)
#define REG_PHY2P1_5_P0_59_L       (REG_PHY_TRAIN_P0_BASE + 0xB2)
#define REG_PHY2P1_5_P0_59_H       (REG_PHY_TRAIN_P0_BASE + 0xB3)
#define REG_PHY2P1_5_P0_5A_L       (REG_PHY_TRAIN_P0_BASE + 0xB4)
#define REG_PHY2P1_5_P0_5A_H       (REG_PHY_TRAIN_P0_BASE + 0xB5)
#define REG_PHY2P1_5_P0_5B_L       (REG_PHY_TRAIN_P0_BASE + 0xB6)
#define REG_PHY2P1_5_P0_5B_H       (REG_PHY_TRAIN_P0_BASE + 0xB7)
#define REG_PHY2P1_5_P0_5C_L       (REG_PHY_TRAIN_P0_BASE + 0xB8)
#define REG_PHY2P1_5_P0_5C_H       (REG_PHY_TRAIN_P0_BASE + 0xB9)
#define REG_PHY2P1_5_P0_5D_L       (REG_PHY_TRAIN_P0_BASE + 0xBA)
#define REG_PHY2P1_5_P0_5D_H       (REG_PHY_TRAIN_P0_BASE + 0xBB)
#define REG_PHY2P1_5_P0_5E_L       (REG_PHY_TRAIN_P0_BASE + 0xBC)
#define REG_PHY2P1_5_P0_5E_H       (REG_PHY_TRAIN_P0_BASE + 0xBD)
#define REG_PHY2P1_5_P0_5F_L       (REG_PHY_TRAIN_P0_BASE + 0xBE)
#define REG_PHY2P1_5_P0_5F_H       (REG_PHY_TRAIN_P0_BASE + 0xBF)
#define REG_PHY_TRAIN_P0_60_L       (REG_PHY_TRAIN_P0_BASE + 0xC0)
#define REG_PHY_TRAIN_P0_60_H       (REG_PHY_TRAIN_P0_BASE + 0xC1)
#define REG_PHY_TRAIN_P0_61_L       (REG_PHY_TRAIN_P0_BASE + 0xC2)
#define REG_PHY_TRAIN_P0_61_H       (REG_PHY_TRAIN_P0_BASE + 0xC3)
#define REG_PHY_TRAIN_P0_62_L       (REG_PHY_TRAIN_P0_BASE + 0xC4)
#define REG_PHY_TRAIN_P0_62_H       (REG_PHY_TRAIN_P0_BASE + 0xC5)
#define REG_PHY_TRAIN_P0_63_L       (REG_PHY_TRAIN_P0_BASE + 0xC6)
#define REG_PHY_TRAIN_P0_63_H       (REG_PHY_TRAIN_P0_BASE + 0xC7)
#define REG_PHY_TRAIN_P0_64_L       (REG_PHY_TRAIN_P0_BASE + 0xC8)
#define REG_PHY_TRAIN_P0_64_H       (REG_PHY_TRAIN_P0_BASE + 0xC9)
#define REG_PHY_TRAIN_P0_65_L       (REG_PHY_TRAIN_P0_BASE + 0xCA)
#define REG_PHY_TRAIN_P0_65_H       (REG_PHY_TRAIN_P0_BASE + 0xCB)
#define REG_PHY_TRAIN_P0_66_L       (REG_PHY_TRAIN_P0_BASE + 0xCC)
#define REG_PHY_TRAIN_P0_66_H       (REG_PHY_TRAIN_P0_BASE + 0xCD)
#define REG_PHY_TRAIN_P0_67_L       (REG_PHY_TRAIN_P0_BASE + 0xCE)
#define REG_PHY_TRAIN_P0_67_H       (REG_PHY_TRAIN_P0_BASE + 0xCF)
#define REG_PHY_TRAIN_P0_68_L       (REG_PHY_TRAIN_P0_BASE + 0xD0)
#define REG_PHY_TRAIN_P0_68_H       (REG_PHY_TRAIN_P0_BASE + 0xD1)
#define REG_PHY_TRAIN_P0_69_L       (REG_PHY_TRAIN_P0_BASE + 0xD2)
#define REG_PHY_TRAIN_P0_69_H       (REG_PHY_TRAIN_P0_BASE + 0xD3)
#define REG_PHY_TRAIN_P0_6A_L       (REG_PHY_TRAIN_P0_BASE + 0xD4)
#define REG_PHY_TRAIN_P0_6A_H       (REG_PHY_TRAIN_P0_BASE + 0xD5)
#define REG_PHY_TRAIN_P0_6B_L       (REG_PHY_TRAIN_P0_BASE + 0xD6)
#define REG_PHY_TRAIN_P0_6B_H       (REG_PHY_TRAIN_P0_BASE + 0xD7)
#define REG_PHY_TRAIN_P0_6C_L       (REG_PHY_TRAIN_P0_BASE + 0xD8)
#define REG_PHY_TRAIN_P0_6C_H       (REG_PHY_TRAIN_P0_BASE + 0xD9)
#define REG_PHY_TRAIN_P0_6D_L       (REG_PHY_TRAIN_P0_BASE + 0xDA)
#define REG_PHY_TRAIN_P0_6D_H       (REG_PHY_TRAIN_P0_BASE + 0xDB)
#define REG_PHY_TRAIN_P0_6E_L       (REG_PHY_TRAIN_P0_BASE + 0xDC)
#define REG_PHY_TRAIN_P0_6E_H       (REG_PHY_TRAIN_P0_BASE + 0xDD)
#define REG_PHY_TRAIN_P0_6F_L       (REG_PHY_TRAIN_P0_BASE + 0xDE)
#define REG_PHY_TRAIN_P0_6F_H       (REG_PHY_TRAIN_P0_BASE + 0xDF)
#define REG_PHY_TRAIN_P0_70_L       (REG_PHY_TRAIN_P0_BASE + 0xE0)
#define REG_PHY_TRAIN_P0_70_H       (REG_PHY_TRAIN_P0_BASE + 0xE1)
#define REG_PHY_TRAIN_P0_71_L       (REG_PHY_TRAIN_P0_BASE + 0xE2)
#define REG_PHY_TRAIN_P0_71_H       (REG_PHY_TRAIN_P0_BASE + 0xE3)
#define REG_PHY_TRAIN_P0_72_L       (REG_PHY_TRAIN_P0_BASE + 0xE4)
#define REG_PHY_TRAIN_P0_72_H       (REG_PHY_TRAIN_P0_BASE + 0xE5)
#define REG_PHY_TRAIN_P0_73_L       (REG_PHY_TRAIN_P0_BASE + 0xE6)
#define REG_PHY_TRAIN_P0_73_H       (REG_PHY_TRAIN_P0_BASE + 0xE7)
#define REG_PHY_TRAIN_P0_74_L       (REG_PHY_TRAIN_P0_BASE + 0xE8)
#define REG_PHY_TRAIN_P0_74_H       (REG_PHY_TRAIN_P0_BASE + 0xE9)
#define REG_PHY_TRAIN_P0_75_L       (REG_PHY_TRAIN_P0_BASE + 0xEA)
#define REG_PHY_TRAIN_P0_75_H       (REG_PHY_TRAIN_P0_BASE + 0xEB)
#define REG_PHY_TRAIN_P0_76_L       (REG_PHY_TRAIN_P0_BASE + 0xEC)
#define REG_PHY_TRAIN_P0_76_H       (REG_PHY_TRAIN_P0_BASE + 0xED)
#define REG_PHY_TRAIN_P0_77_L       (REG_PHY_TRAIN_P0_BASE + 0xEE)
#define REG_PHY_TRAIN_P0_77_H       (REG_PHY_TRAIN_P0_BASE + 0xEF)
#define REG_PHY_TRAIN_P0_78_L       (REG_PHY_TRAIN_P0_BASE + 0xF0)
#define REG_PHY_TRAIN_P0_78_H       (REG_PHY_TRAIN_P0_BASE + 0xF1)
#define REG_PHY_TRAIN_P0_79_L       (REG_PHY_TRAIN_P0_BASE + 0xF2)
#define REG_PHY_TRAIN_P0_79_H       (REG_PHY_TRAIN_P0_BASE + 0xF3)
#define REG_PHY_TRAIN_P0_7A_L       (REG_PHY_TRAIN_P0_BASE + 0xF4)
#define REG_PHY_TRAIN_P0_7A_H       (REG_PHY_TRAIN_P0_BASE + 0xF5)
#define REG_PHY_TRAIN_P0_7B_L       (REG_PHY_TRAIN_P0_BASE + 0xF6)
#define REG_PHY_TRAIN_P0_7B_H       (REG_PHY_TRAIN_P0_BASE + 0xF7)
#define REG_PHY_TRAIN_P0_7C_L       (REG_PHY_TRAIN_P0_BASE + 0xF8)
#define REG_PHY_TRAIN_P0_7C_H       (REG_PHY_TRAIN_P0_BASE + 0xF9)
#define REG_PHY_TRAIN_P0_7D_L       (REG_PHY_TRAIN_P0_BASE + 0xFA)
#define REG_PHY_TRAIN_P0_7D_H       (REG_PHY_TRAIN_P0_BASE + 0xFB)
#define REG_PHY_TRAIN_P0_7E_L       (REG_PHY_TRAIN_P0_BASE + 0xFC)
#define REG_PHY_TRAIN_P0_7E_H       (REG_PHY_TRAIN_P0_BASE + 0xFD)
#define REG_PHY_TRAIN_P0_7F_L       (REG_PHY_TRAIN_P0_BASE + 0xFE)
#define REG_PHY_TRAIN_P0_7F_H       (REG_PHY_TRAIN_P0_BASE + 0xFF)

//=============================================================
// PHY2P1_0_P1
#define REG_PHY2P1_0_P1_00_L        (REG_PHY2P1_0_P1_BASE + 0x00)
#define REG_PHY2P1_0_P1_00_H        (REG_PHY2P1_0_P1_BASE + 0x01)
#define REG_PHY2P1_0_P1_01_L        (REG_PHY2P1_0_P1_BASE + 0x02)
#define REG_PHY2P1_0_P1_01_H        (REG_PHY2P1_0_P1_BASE + 0x03)
#define REG_PHY2P1_0_P1_02_L        (REG_PHY2P1_0_P1_BASE + 0x04)
#define REG_PHY2P1_0_P1_02_H        (REG_PHY2P1_0_P1_BASE + 0x05)
#define REG_PHY2P1_0_P1_03_L        (REG_PHY2P1_0_P1_BASE + 0x06)
#define REG_PHY2P1_0_P1_03_H        (REG_PHY2P1_0_P1_BASE + 0x07)
#define REG_PHY2P1_0_P1_04_L        (REG_PHY2P1_0_P1_BASE + 0x08)
#define REG_PHY2P1_0_P1_04_H        (REG_PHY2P1_0_P1_BASE + 0x09)
#define REG_PHY2P1_0_P1_05_L        (REG_PHY2P1_0_P1_BASE + 0x0A)
#define REG_PHY2P1_0_P1_05_H        (REG_PHY2P1_0_P1_BASE + 0x0B)
#define REG_PHY2P1_0_P1_06_L        (REG_PHY2P1_0_P1_BASE + 0x0C)
#define REG_PHY2P1_0_P1_06_H        (REG_PHY2P1_0_P1_BASE + 0x0D)
#define REG_PHY2P1_0_P1_07_L        (REG_PHY2P1_0_P1_BASE + 0x0E)
#define REG_PHY2P1_0_P1_07_H        (REG_PHY2P1_0_P1_BASE + 0x0F)
#define REG_PHY2P1_0_P1_08_L        (REG_PHY2P1_0_P1_BASE + 0x10)
#define REG_PHY2P1_0_P1_08_H        (REG_PHY2P1_0_P1_BASE + 0x11)
#define REG_PHY2P1_0_P1_09_L        (REG_PHY2P1_0_P1_BASE + 0x12)
#define REG_PHY2P1_0_P1_09_H        (REG_PHY2P1_0_P1_BASE + 0x13)
#define REG_PHY2P1_0_P1_0A_L        (REG_PHY2P1_0_P1_BASE + 0x14)
#define REG_PHY2P1_0_P1_0A_H        (REG_PHY2P1_0_P1_BASE + 0x15)
#define REG_PHY2P1_0_P1_0B_L        (REG_PHY2P1_0_P1_BASE + 0x16)
#define REG_PHY2P1_0_P1_0B_H        (REG_PHY2P1_0_P1_BASE + 0x17)
#define REG_PHY2P1_0_P1_0C_L        (REG_PHY2P1_0_P1_BASE + 0x18)
#define REG_PHY2P1_0_P1_0C_H        (REG_PHY2P1_0_P1_BASE + 0x19)
#define REG_PHY2P1_0_P1_0D_L        (REG_PHY2P1_0_P1_BASE + 0x1A)
#define REG_PHY2P1_0_P1_0D_H        (REG_PHY2P1_0_P1_BASE + 0x1B)
#define REG_PHY2P1_0_P1_0E_L        (REG_PHY2P1_0_P1_BASE + 0x1C)
#define REG_PHY2P1_0_P1_0E_H        (REG_PHY2P1_0_P1_BASE + 0x1D)
#define REG_PHY2P1_0_P1_0F_L        (REG_PHY2P1_0_P1_BASE + 0x1E)
#define REG_PHY2P1_0_P1_0F_H        (REG_PHY2P1_0_P1_BASE + 0x1F)
#define REG_PHY2P1_0_P1_10_L        (REG_PHY2P1_0_P1_BASE + 0x20)
#define REG_PHY2P1_0_P1_10_H        (REG_PHY2P1_0_P1_BASE + 0x21)
#define REG_PHY2P1_0_P1_11_L        (REG_PHY2P1_0_P1_BASE + 0x22)
#define REG_PHY2P1_0_P1_11_H        (REG_PHY2P1_0_P1_BASE + 0x23)
#define REG_PHY2P1_0_P1_12_L        (REG_PHY2P1_0_P1_BASE + 0x24)
#define REG_PHY2P1_0_P1_12_H        (REG_PHY2P1_0_P1_BASE + 0x25)
#define REG_PHY2P1_0_P1_13_L        (REG_PHY2P1_0_P1_BASE + 0x26)
#define REG_PHY2P1_0_P1_13_H        (REG_PHY2P1_0_P1_BASE + 0x27)
#define REG_PHY2P1_0_P1_14_L        (REG_PHY2P1_0_P1_BASE + 0x28)
#define REG_PHY2P1_0_P1_14_H        (REG_PHY2P1_0_P1_BASE + 0x29)
#define REG_PHY2P1_0_P1_15_L        (REG_PHY2P1_0_P1_BASE + 0x2A)
#define REG_PHY2P1_0_P1_15_H        (REG_PHY2P1_0_P1_BASE + 0x2B)
#define REG_PHY2P1_0_P1_16_L        (REG_PHY2P1_0_P1_BASE + 0x2C)
#define REG_PHY2P1_0_P1_16_H        (REG_PHY2P1_0_P1_BASE + 0x2D)
#define REG_PHY2P1_0_P1_17_L        (REG_PHY2P1_0_P1_BASE + 0x2E)
#define REG_PHY2P1_0_P1_17_H        (REG_PHY2P1_0_P1_BASE + 0x2F)
#define REG_PHY2P1_0_P1_18_L        (REG_PHY2P1_0_P1_BASE + 0x30)
#define REG_PHY2P1_0_P1_18_H        (REG_PHY2P1_0_P1_BASE + 0x31)
#define REG_PHY2P1_0_P1_19_L        (REG_PHY2P1_0_P1_BASE + 0x32)
#define REG_PHY2P1_0_P1_19_H        (REG_PHY2P1_0_P1_BASE + 0x33)
#define REG_PHY2P1_0_P1_1A_L        (REG_PHY2P1_0_P1_BASE + 0x34)
#define REG_PHY2P1_0_P1_1A_H        (REG_PHY2P1_0_P1_BASE + 0x35)
#define REG_PHY2P1_0_P1_1B_L        (REG_PHY2P1_0_P1_BASE + 0x36)
#define REG_PHY2P1_0_P1_1B_H        (REG_PHY2P1_0_P1_BASE + 0x37)
#define REG_PHY2P1_0_P1_1C_L        (REG_PHY2P1_0_P1_BASE + 0x38)
#define REG_PHY2P1_0_P1_1C_H        (REG_PHY2P1_0_P1_BASE + 0x39)
#define REG_PHY2P1_0_P1_1D_L        (REG_PHY2P1_0_P1_BASE + 0x3A)
#define REG_PHY2P1_0_P1_1D_H        (REG_PHY2P1_0_P1_BASE + 0x3B)
#define REG_PHY2P1_0_P1_1E_L        (REG_PHY2P1_0_P1_BASE + 0x3C)
#define REG_PHY2P1_0_P1_1E_H        (REG_PHY2P1_0_P1_BASE + 0x3D)
#define REG_PHY2P1_0_P1_1F_L        (REG_PHY2P1_0_P1_BASE + 0x3E)
#define REG_PHY2P1_0_P1_1F_H        (REG_PHY2P1_0_P1_BASE + 0x3F)
#define REG_PHY2P1_0_P1_20_L        (REG_PHY2P1_0_P1_BASE + 0x40)
#define REG_PHY2P1_0_P1_20_H        (REG_PHY2P1_0_P1_BASE + 0x41)
#define REG_PHY2P1_0_P1_21_L        (REG_PHY2P1_0_P1_BASE + 0x42)
#define REG_PHY2P1_0_P1_21_H        (REG_PHY2P1_0_P1_BASE + 0x43)
#define REG_PHY2P1_0_P1_22_L        (REG_PHY2P1_0_P1_BASE + 0x44)
#define REG_PHY2P1_0_P1_22_H        (REG_PHY2P1_0_P1_BASE + 0x45)
#define REG_PHY2P1_0_P1_23_L        (REG_PHY2P1_0_P1_BASE + 0x46)
#define REG_PHY2P1_0_P1_23_H        (REG_PHY2P1_0_P1_BASE + 0x47)
#define REG_PHY2P1_0_P1_24_L        (REG_PHY2P1_0_P1_BASE + 0x48)
#define REG_PHY2P1_0_P1_24_H        (REG_PHY2P1_0_P1_BASE + 0x49)
#define REG_PHY2P1_0_P1_25_L        (REG_PHY2P1_0_P1_BASE + 0x4A)
#define REG_PHY2P1_0_P1_25_H        (REG_PHY2P1_0_P1_BASE + 0x4B)
#define REG_PHY2P1_0_P1_26_L        (REG_PHY2P1_0_P1_BASE + 0x4C)
#define REG_PHY2P1_0_P1_26_H        (REG_PHY2P1_0_P1_BASE + 0x4D)
#define REG_PHY2P1_0_P1_27_L        (REG_PHY2P1_0_P1_BASE + 0x4E)
#define REG_PHY2P1_0_P1_27_H        (REG_PHY2P1_0_P1_BASE + 0x4F)
#define REG_PHY2P1_0_P1_28_L        (REG_PHY2P1_0_P1_BASE + 0x50)
#define REG_PHY2P1_0_P1_28_H        (REG_PHY2P1_0_P1_BASE + 0x51)
#define REG_PHY2P1_0_P1_29_L        (REG_PHY2P1_0_P1_BASE + 0x52)
#define REG_PHY2P1_0_P1_29_H        (REG_PHY2P1_0_P1_BASE + 0x53)
#define REG_PHY2P1_0_P1_2A_L        (REG_PHY2P1_0_P1_BASE + 0x54)
#define REG_PHY2P1_0_P1_2A_H        (REG_PHY2P1_0_P1_BASE + 0x55)
#define REG_PHY2P1_0_P1_2B_L        (REG_PHY2P1_0_P1_BASE + 0x56)
#define REG_PHY2P1_0_P1_2B_H        (REG_PHY2P1_0_P1_BASE + 0x57)
#define REG_PHY2P1_0_P1_2C_L        (REG_PHY2P1_0_P1_BASE + 0x58)
#define REG_PHY2P1_0_P1_2C_H        (REG_PHY2P1_0_P1_BASE + 0x59)
#define REG_PHY2P1_0_P1_2D_L        (REG_PHY2P1_0_P1_BASE + 0x5A)
#define REG_PHY2P1_0_P1_2D_H        (REG_PHY2P1_0_P1_BASE + 0x5B)
#define REG_PHY2P1_0_P1_2E_L        (REG_PHY2P1_0_P1_BASE + 0x5C)
#define REG_PHY2P1_0_P1_2E_H        (REG_PHY2P1_0_P1_BASE + 0x5D)
#define REG_PHY2P1_0_P1_2F_L        (REG_PHY2P1_0_P1_BASE + 0x5E)
#define REG_PHY2P1_0_P1_2F_H        (REG_PHY2P1_0_P1_BASE + 0x5F)
#define REG_PHY2P1_0_P1_30_L        (REG_PHY2P1_0_P1_BASE + 0x60)
#define REG_PHY2P1_0_P1_30_H        (REG_PHY2P1_0_P1_BASE + 0x61)
#define REG_PHY2P1_0_P1_31_L        (REG_PHY2P1_0_P1_BASE + 0x62)
#define REG_PHY2P1_0_P1_31_H        (REG_PHY2P1_0_P1_BASE + 0x63)
#define REG_PHY2P1_0_P1_32_L        (REG_PHY2P1_0_P1_BASE + 0x64)
#define REG_PHY2P1_0_P1_32_H        (REG_PHY2P1_0_P1_BASE + 0x65)
#define REG_PHY2P1_0_P1_33_L        (REG_PHY2P1_0_P1_BASE + 0x66)
#define REG_PHY2P1_0_P1_33_H        (REG_PHY2P1_0_P1_BASE + 0x67)
#define REG_PHY2P1_0_P1_34_L        (REG_PHY2P1_0_P1_BASE + 0x68)
#define REG_PHY2P1_0_P1_34_H        (REG_PHY2P1_0_P1_BASE + 0x69)
#define REG_PHY2P1_0_P1_35_L        (REG_PHY2P1_0_P1_BASE + 0x6A)
#define REG_PHY2P1_0_P1_35_H        (REG_PHY2P1_0_P1_BASE + 0x6B)
#define REG_PHY2P1_0_P1_36_L        (REG_PHY2P1_0_P1_BASE + 0x6C)
#define REG_PHY2P1_0_P1_36_H        (REG_PHY2P1_0_P1_BASE + 0x6D)
#define REG_PHY2P1_0_P1_37_L        (REG_PHY2P1_0_P1_BASE + 0x6E)
#define REG_PHY2P1_0_P1_37_H        (REG_PHY2P1_0_P1_BASE + 0x6F)
#define REG_PHY2P1_0_P1_38_L        (REG_PHY2P1_0_P1_BASE + 0x70)
#define REG_PHY2P1_0_P1_38_H        (REG_PHY2P1_0_P1_BASE + 0x71)
#define REG_PHY2P1_0_P1_39_L        (REG_PHY2P1_0_P1_BASE + 0x72)
#define REG_PHY2P1_0_P1_39_H        (REG_PHY2P1_0_P1_BASE + 0x73)
#define REG_PHY2P1_0_P1_3A_L        (REG_PHY2P1_0_P1_BASE + 0x74)
#define REG_PHY2P1_0_P1_3A_H        (REG_PHY2P1_0_P1_BASE + 0x75)
#define REG_PHY2P1_0_P1_3B_L        (REG_PHY2P1_0_P1_BASE + 0x76)
#define REG_PHY2P1_0_P1_3B_H        (REG_PHY2P1_0_P1_BASE + 0x77)
#define REG_PHY2P1_0_P1_3C_L        (REG_PHY2P1_0_P1_BASE + 0x78)
#define REG_PHY2P1_0_P1_3C_H        (REG_PHY2P1_0_P1_BASE + 0x79)
#define REG_PHY2P1_0_P1_3D_L        (REG_PHY2P1_0_P1_BASE + 0x7A)
#define REG_PHY2P1_0_P1_3D_H        (REG_PHY2P1_0_P1_BASE + 0x7B)
#define REG_PHY2P1_0_P1_3E_L        (REG_PHY2P1_0_P1_BASE + 0x7C)
#define REG_PHY2P1_0_P1_3E_H        (REG_PHY2P1_0_P1_BASE + 0x7D)
#define REG_PHY2P1_0_P1_3F_L        (REG_PHY2P1_0_P1_BASE + 0x7E)
#define REG_PHY2P1_0_P1_3F_H        (REG_PHY2P1_0_P1_BASE + 0x7F)
#define REG_PHY2P1_0_P1_40_L        (REG_PHY2P1_0_P1_BASE + 0x80)
#define REG_PHY2P1_0_P1_40_H        (REG_PHY2P1_0_P1_BASE + 0x81)
#define REG_PHY2P1_0_P1_41_L        (REG_PHY2P1_0_P1_BASE + 0x82)
#define REG_PHY2P1_0_P1_41_H        (REG_PHY2P1_0_P1_BASE + 0x83)
#define REG_PHY2P1_0_P1_42_L        (REG_PHY2P1_0_P1_BASE + 0x84)
#define REG_PHY2P1_0_P1_42_H        (REG_PHY2P1_0_P1_BASE + 0x85)
#define REG_PHY2P1_0_P1_43_L        (REG_PHY2P1_0_P1_BASE + 0x86)
#define REG_PHY2P1_0_P1_43_H        (REG_PHY2P1_0_P1_BASE + 0x87)
#define REG_PHY2P1_0_P1_44_L        (REG_PHY2P1_0_P1_BASE + 0x88)
#define REG_PHY2P1_0_P1_44_H        (REG_PHY2P1_0_P1_BASE + 0x89)
#define REG_PHY2P1_0_P1_45_L        (REG_PHY2P1_0_P1_BASE + 0x8A)
#define REG_PHY2P1_0_P1_45_H        (REG_PHY2P1_0_P1_BASE + 0x8B)
#define REG_PHY2P1_0_P1_46_L        (REG_PHY2P1_0_P1_BASE + 0x8C)
#define REG_PHY2P1_0_P1_46_H        (REG_PHY2P1_0_P1_BASE + 0x8D)
#define REG_PHY2P1_0_P1_47_L        (REG_PHY2P1_0_P1_BASE + 0x8E)
#define REG_PHY2P1_0_P1_47_H        (REG_PHY2P1_0_P1_BASE + 0x8F)
#define REG_PHY2P1_0_P1_48_L        (REG_PHY2P1_0_P1_BASE + 0x90)
#define REG_PHY2P1_0_P1_48_H        (REG_PHY2P1_0_P1_BASE + 0x91)
#define REG_PHY2P1_0_P1_49_L        (REG_PHY2P1_0_P1_BASE + 0x92)
#define REG_PHY2P1_0_P1_49_H        (REG_PHY2P1_0_P1_BASE + 0x93)
#define REG_PHY2P1_0_P1_4A_L        (REG_PHY2P1_0_P1_BASE + 0x94)
#define REG_PHY2P1_0_P1_4A_H        (REG_PHY2P1_0_P1_BASE + 0x95)
#define REG_PHY2P1_0_P1_4B_L        (REG_PHY2P1_0_P1_BASE + 0x96)
#define REG_PHY2P1_0_P1_4B_H        (REG_PHY2P1_0_P1_BASE + 0x97)
#define REG_PHY2P1_0_P1_4C_L        (REG_PHY2P1_0_P1_BASE + 0x98)
#define REG_PHY2P1_0_P1_4C_H        (REG_PHY2P1_0_P1_BASE + 0x99)
#define REG_PHY2P1_0_P1_4D_L        (REG_PHY2P1_0_P1_BASE + 0x9A)
#define REG_PHY2P1_0_P1_4D_H        (REG_PHY2P1_0_P1_BASE + 0x9B)
#define REG_PHY2P1_0_P1_4E_L        (REG_PHY2P1_0_P1_BASE + 0x9C)
#define REG_PHY2P1_0_P1_4E_H        (REG_PHY2P1_0_P1_BASE + 0x9D)
#define REG_PHY2P1_0_P1_4F_L        (REG_PHY2P1_0_P1_BASE + 0x9E)
#define REG_PHY2P1_0_P1_4F_H        (REG_PHY2P1_0_P1_BASE + 0x9F)
#define REG_PHY2P1_0_P1_50_L        (REG_PHY2P1_0_P1_BASE + 0xA0)
#define REG_PHY2P1_0_P1_50_H        (REG_PHY2P1_0_P1_BASE + 0xA1)
#define REG_PHY2P1_0_P1_51_L        (REG_PHY2P1_0_P1_BASE + 0xA2)
#define REG_PHY2P1_0_P1_51_H        (REG_PHY2P1_0_P1_BASE + 0xA3)
#define REG_PHY2P1_0_P1_52_L        (REG_PHY2P1_0_P1_BASE + 0xA4)
#define REG_PHY2P1_0_P1_52_H        (REG_PHY2P1_0_P1_BASE + 0xA5)
#define REG_PHY2P1_0_P1_53_L        (REG_PHY2P1_0_P1_BASE + 0xA6)
#define REG_PHY2P1_0_P1_53_H        (REG_PHY2P1_0_P1_BASE + 0xA7)
#define REG_PHY2P1_0_P1_54_L        (REG_PHY2P1_0_P1_BASE + 0xA8)
#define REG_PHY2P1_0_P1_54_H        (REG_PHY2P1_0_P1_BASE + 0xA9)
#define REG_PHY2P1_0_P1_55_L        (REG_PHY2P1_0_P1_BASE + 0xAA)
#define REG_PHY2P1_0_P1_55_H        (REG_PHY2P1_0_P1_BASE + 0xAB)
#define REG_PHY2P1_0_P1_56_L        (REG_PHY2P1_0_P1_BASE + 0xAC)
#define REG_PHY2P1_0_P1_56_H        (REG_PHY2P1_0_P1_BASE + 0xAD)
#define REG_PHY2P1_0_P1_57_L        (REG_PHY2P1_0_P1_BASE + 0xAE)
#define REG_PHY2P1_0_P1_57_H        (REG_PHY2P1_0_P1_BASE + 0xAF)
#define REG_PHY2P1_0_P1_58_L        (REG_PHY2P1_0_P1_BASE + 0xB0)
#define REG_PHY2P1_0_P1_58_H        (REG_PHY2P1_0_P1_BASE + 0xB1)
#define REG_PHY2P1_0_P1_59_L        (REG_PHY2P1_0_P1_BASE + 0xB2)
#define REG_PHY2P1_0_P1_59_H        (REG_PHY2P1_0_P1_BASE + 0xB3)
#define REG_PHY2P1_0_P1_5A_L        (REG_PHY2P1_0_P1_BASE + 0xB4)
#define REG_PHY2P1_0_P1_5A_H        (REG_PHY2P1_0_P1_BASE + 0xB5)
#define REG_PHY2P1_0_P1_5B_L        (REG_PHY2P1_0_P1_BASE + 0xB6)
#define REG_PHY2P1_0_P1_5B_H        (REG_PHY2P1_0_P1_BASE + 0xB7)
#define REG_PHY2P1_0_P1_5C_L        (REG_PHY2P1_0_P1_BASE + 0xB8)
#define REG_PHY2P1_0_P1_5C_H        (REG_PHY2P1_0_P1_BASE + 0xB9)
#define REG_PHY2P1_0_P1_5D_L        (REG_PHY2P1_0_P1_BASE + 0xBA)
#define REG_PHY2P1_0_P1_5D_H        (REG_PHY2P1_0_P1_BASE + 0xBB)
#define REG_PHY2P1_0_P1_5E_L        (REG_PHY2P1_0_P1_BASE + 0xBC)
#define REG_PHY2P1_0_P1_5E_H        (REG_PHY2P1_0_P1_BASE + 0xBD)
#define REG_PHY2P1_0_P1_5F_L        (REG_PHY2P1_0_P1_BASE + 0xBE)
#define REG_PHY2P1_0_P1_5F_H        (REG_PHY2P1_0_P1_BASE + 0xBF)
#define REG_PHY2P1_0_P1_60_L        (REG_PHY2P1_0_P1_BASE + 0xC0)
#define REG_PHY2P1_0_P1_60_H        (REG_PHY2P1_0_P1_BASE + 0xC1)
#define REG_PHY2P1_0_P1_61_L        (REG_PHY2P1_0_P1_BASE + 0xC2)
#define REG_PHY2P1_0_P1_61_H        (REG_PHY2P1_0_P1_BASE + 0xC3)
#define REG_PHY2P1_0_P1_62_L        (REG_PHY2P1_0_P1_BASE + 0xC4)
#define REG_PHY2P1_0_P1_62_H        (REG_PHY2P1_0_P1_BASE + 0xC5)
#define REG_PHY2P1_0_P1_63_L        (REG_PHY2P1_0_P1_BASE + 0xC6)
#define REG_PHY2P1_0_P1_63_H        (REG_PHY2P1_0_P1_BASE + 0xC7)
#define REG_PHY2P1_0_P1_64_L        (REG_PHY2P1_0_P1_BASE + 0xC8)
#define REG_PHY2P1_0_P1_64_H        (REG_PHY2P1_0_P1_BASE + 0xC9)
#define REG_PHY2P1_0_P1_65_L        (REG_PHY2P1_0_P1_BASE + 0xCA)
#define REG_PHY2P1_0_P1_65_H        (REG_PHY2P1_0_P1_BASE + 0xCB)
#define REG_PHY2P1_0_P1_66_L        (REG_PHY2P1_0_P1_BASE + 0xCC)
#define REG_PHY2P1_0_P1_66_H        (REG_PHY2P1_0_P1_BASE + 0xCD)
#define REG_PHY2P1_0_P1_67_L        (REG_PHY2P1_0_P1_BASE + 0xCE)
#define REG_PHY2P1_0_P1_67_H        (REG_PHY2P1_0_P1_BASE + 0xCF)
#define REG_PHY2P1_0_P1_68_L        (REG_PHY2P1_0_P1_BASE + 0xD0)
#define REG_PHY2P1_0_P1_68_H        (REG_PHY2P1_0_P1_BASE + 0xD1)
#define REG_PHY2P1_0_P1_69_L        (REG_PHY2P1_0_P1_BASE + 0xD2)
#define REG_PHY2P1_0_P1_69_H        (REG_PHY2P1_0_P1_BASE + 0xD3)
#define REG_PHY2P1_0_P1_6A_L        (REG_PHY2P1_0_P1_BASE + 0xD4)
#define REG_PHY2P1_0_P1_6A_H        (REG_PHY2P1_0_P1_BASE + 0xD5)
#define REG_PHY2P1_0_P1_6B_L        (REG_PHY2P1_0_P1_BASE + 0xD6)
#define REG_PHY2P1_0_P1_6B_H        (REG_PHY2P1_0_P1_BASE + 0xD7)
#define REG_PHY2P1_0_P1_6C_L        (REG_PHY2P1_0_P1_BASE + 0xD8)
#define REG_PHY2P1_0_P1_6C_H        (REG_PHY2P1_0_P1_BASE + 0xD9)
#define REG_PHY2P1_0_P1_6D_L        (REG_PHY2P1_0_P1_BASE + 0xDA)
#define REG_PHY2P1_0_P1_6D_H        (REG_PHY2P1_0_P1_BASE + 0xDB)
#define REG_PHY2P1_0_P1_6E_L        (REG_PHY2P1_0_P1_BASE + 0xDC)
#define REG_PHY2P1_0_P1_6E_H        (REG_PHY2P1_0_P1_BASE + 0xDD)
#define REG_PHY2P1_0_P1_6F_L        (REG_PHY2P1_0_P1_BASE + 0xDE)
#define REG_PHY2P1_0_P1_6F_H        (REG_PHY2P1_0_P1_BASE + 0xDF)
#define REG_PHY2P1_0_P1_70_L        (REG_PHY2P1_0_P1_BASE + 0xE0)
#define REG_PHY2P1_0_P1_70_H        (REG_PHY2P1_0_P1_BASE + 0xE1)
#define REG_PHY2P1_0_P1_71_L        (REG_PHY2P1_0_P1_BASE + 0xE2)
#define REG_PHY2P1_0_P1_71_H        (REG_PHY2P1_0_P1_BASE + 0xE3)
#define REG_PHY2P1_0_P1_72_L        (REG_PHY2P1_0_P1_BASE + 0xE4)
#define REG_PHY2P1_0_P1_72_H        (REG_PHY2P1_0_P1_BASE + 0xE5)
#define REG_PHY2P1_0_P1_73_L        (REG_PHY2P1_0_P1_BASE + 0xE6)
#define REG_PHY2P1_0_P1_73_H        (REG_PHY2P1_0_P1_BASE + 0xE7)
#define REG_PHY2P1_0_P1_74_L        (REG_PHY2P1_0_P1_BASE + 0xE8)
#define REG_PHY2P1_0_P1_74_H        (REG_PHY2P1_0_P1_BASE + 0xE9)
#define REG_PHY2P1_0_P1_75_L        (REG_PHY2P1_0_P1_BASE + 0xEA)
#define REG_PHY2P1_0_P1_75_H        (REG_PHY2P1_0_P1_BASE + 0xEB)
#define REG_PHY2P1_0_P1_76_L        (REG_PHY2P1_0_P1_BASE + 0xEC)
#define REG_PHY2P1_0_P1_76_H        (REG_PHY2P1_0_P1_BASE + 0xED)
#define REG_PHY2P1_0_P1_77_L        (REG_PHY2P1_0_P1_BASE + 0xEE)
#define REG_PHY2P1_0_P1_77_H        (REG_PHY2P1_0_P1_BASE + 0xEF)
#define REG_PHY2P1_0_P1_78_L        (REG_PHY2P1_0_P1_BASE + 0xF0)
#define REG_PHY2P1_0_P1_78_H        (REG_PHY2P1_0_P1_BASE + 0xF1)
#define REG_PHY2P1_0_P1_79_L        (REG_PHY2P1_0_P1_BASE + 0xF2)
#define REG_PHY2P1_0_P1_79_H        (REG_PHY2P1_0_P1_BASE + 0xF3)
#define REG_PHY2P1_0_P1_7A_L        (REG_PHY2P1_0_P1_BASE + 0xF4)
#define REG_PHY2P1_0_P1_7A_H        (REG_PHY2P1_0_P1_BASE + 0xF5)
#define REG_PHY2P1_0_P1_7B_L        (REG_PHY2P1_0_P1_BASE + 0xF6)
#define REG_PHY2P1_0_P1_7B_H        (REG_PHY2P1_0_P1_BASE + 0xF7)
#define REG_PHY2P1_0_P1_7C_L        (REG_PHY2P1_0_P1_BASE + 0xF8)
#define REG_PHY2P1_0_P1_7C_H        (REG_PHY2P1_0_P1_BASE + 0xF9)
#define REG_PHY2P1_0_P1_7D_L        (REG_PHY2P1_0_P1_BASE + 0xFA)
#define REG_PHY2P1_0_P1_7D_H        (REG_PHY2P1_0_P1_BASE + 0xFB)
#define REG_PHY2P1_0_P1_7E_L        (REG_PHY2P1_0_P1_BASE + 0xFC)
#define REG_PHY2P1_0_P1_7E_H        (REG_PHY2P1_0_P1_BASE + 0xFD)
#define REG_PHY2P1_0_P1_7F_L        (REG_PHY2P1_0_P1_BASE + 0xFE)
#define REG_PHY2P1_0_P1_7F_H        (REG_PHY2P1_0_P1_BASE + 0xFF)

//=============================================================
// PHY2P1_1_P1
#define REG_PHY2P1_1_P1_00_L        (REG_PHY2P1_1_P1_BASE + 0x00)
#define REG_PHY2P1_1_P1_00_H        (REG_PHY2P1_1_P1_BASE + 0x01)
#define REG_PHY2P1_1_P1_01_L        (REG_PHY2P1_1_P1_BASE + 0x02)
#define REG_PHY2P1_1_P1_01_H        (REG_PHY2P1_1_P1_BASE + 0x03)
#define REG_PHY2P1_1_P1_02_L        (REG_PHY2P1_1_P1_BASE + 0x04)
#define REG_PHY2P1_1_P1_02_H        (REG_PHY2P1_1_P1_BASE + 0x05)
#define REG_PHY2P1_1_P1_03_L        (REG_PHY2P1_1_P1_BASE + 0x06)
#define REG_PHY2P1_1_P1_03_H        (REG_PHY2P1_1_P1_BASE + 0x07)
#define REG_PHY2P1_1_P1_04_L        (REG_PHY2P1_1_P1_BASE + 0x08)
#define REG_PHY2P1_1_P1_04_H        (REG_PHY2P1_1_P1_BASE + 0x09)
#define REG_PHY2P1_1_P1_05_L        (REG_PHY2P1_1_P1_BASE + 0x0A)
#define REG_PHY2P1_1_P1_05_H        (REG_PHY2P1_1_P1_BASE + 0x0B)
#define REG_PHY2P1_1_P1_06_L        (REG_PHY2P1_1_P1_BASE + 0x0C)
#define REG_PHY2P1_1_P1_06_H        (REG_PHY2P1_1_P1_BASE + 0x0D)
#define REG_PHY2P1_1_P1_07_L        (REG_PHY2P1_1_P1_BASE + 0x0E)
#define REG_PHY2P1_1_P1_07_H        (REG_PHY2P1_1_P1_BASE + 0x0F)
#define REG_PHY2P1_1_P1_08_L        (REG_PHY2P1_1_P1_BASE + 0x10)
#define REG_PHY2P1_1_P1_08_H        (REG_PHY2P1_1_P1_BASE + 0x11)
#define REG_PHY2P1_1_P1_09_L        (REG_PHY2P1_1_P1_BASE + 0x12)
#define REG_PHY2P1_1_P1_09_H        (REG_PHY2P1_1_P1_BASE + 0x13)
#define REG_PHY2P1_1_P1_0A_L        (REG_PHY2P1_1_P1_BASE + 0x14)
#define REG_PHY2P1_1_P1_0A_H        (REG_PHY2P1_1_P1_BASE + 0x15)
#define REG_PHY2P1_1_P1_0B_L        (REG_PHY2P1_1_P1_BASE + 0x16)
#define REG_PHY2P1_1_P1_0B_H        (REG_PHY2P1_1_P1_BASE + 0x17)
#define REG_PHY2P1_1_P1_0C_L        (REG_PHY2P1_1_P1_BASE + 0x18)
#define REG_PHY2P1_1_P1_0C_H        (REG_PHY2P1_1_P1_BASE + 0x19)
#define REG_PHY2P1_1_P1_0D_L        (REG_PHY2P1_1_P1_BASE + 0x1A)
#define REG_PHY2P1_1_P1_0D_H        (REG_PHY2P1_1_P1_BASE + 0x1B)
#define REG_PHY2P1_1_P1_0E_L        (REG_PHY2P1_1_P1_BASE + 0x1C)
#define REG_PHY2P1_1_P1_0E_H        (REG_PHY2P1_1_P1_BASE + 0x1D)
#define REG_PHY2P1_1_P1_0F_L        (REG_PHY2P1_1_P1_BASE + 0x1E)
#define REG_PHY2P1_1_P1_0F_H        (REG_PHY2P1_1_P1_BASE + 0x1F)
#define REG_PHY2P1_1_P1_10_L        (REG_PHY2P1_1_P1_BASE + 0x20)
#define REG_PHY2P1_1_P1_10_H        (REG_PHY2P1_1_P1_BASE + 0x21)
#define REG_PHY2P1_1_P1_11_L        (REG_PHY2P1_1_P1_BASE + 0x22)
#define REG_PHY2P1_1_P1_11_H        (REG_PHY2P1_1_P1_BASE + 0x23)
#define REG_PHY2P1_1_P1_12_L        (REG_PHY2P1_1_P1_BASE + 0x24)
#define REG_PHY2P1_1_P1_12_H        (REG_PHY2P1_1_P1_BASE + 0x25)
#define REG_PHY2P1_1_P1_13_L        (REG_PHY2P1_1_P1_BASE + 0x26)
#define REG_PHY2P1_1_P1_13_H        (REG_PHY2P1_1_P1_BASE + 0x27)
#define REG_PHY2P1_1_P1_14_L        (REG_PHY2P1_1_P1_BASE + 0x28)
#define REG_PHY2P1_1_P1_14_H        (REG_PHY2P1_1_P1_BASE + 0x29)
#define REG_PHY2P1_1_P1_15_L        (REG_PHY2P1_1_P1_BASE + 0x2A)
#define REG_PHY2P1_1_P1_15_H        (REG_PHY2P1_1_P1_BASE + 0x2B)
#define REG_PHY2P1_1_P1_16_L        (REG_PHY2P1_1_P1_BASE + 0x2C)
#define REG_PHY2P1_1_P1_16_H        (REG_PHY2P1_1_P1_BASE + 0x2D)
#define REG_PHY2P1_1_P1_17_L        (REG_PHY2P1_1_P1_BASE + 0x2E)
#define REG_PHY2P1_1_P1_17_H        (REG_PHY2P1_1_P1_BASE + 0x2F)
#define REG_PHY2P1_1_P1_18_L        (REG_PHY2P1_1_P1_BASE + 0x30)
#define REG_PHY2P1_1_P1_18_H        (REG_PHY2P1_1_P1_BASE + 0x31)
#define REG_PHY2P1_1_P1_19_L        (REG_PHY2P1_1_P1_BASE + 0x32)
#define REG_PHY2P1_1_P1_19_H        (REG_PHY2P1_1_P1_BASE + 0x33)
#define REG_PHY2P1_1_P1_1A_L        (REG_PHY2P1_1_P1_BASE + 0x34)
#define REG_PHY2P1_1_P1_1A_H        (REG_PHY2P1_1_P1_BASE + 0x35)
#define REG_PHY2P1_1_P1_1B_L        (REG_PHY2P1_1_P1_BASE + 0x36)
#define REG_PHY2P1_1_P1_1B_H        (REG_PHY2P1_1_P1_BASE + 0x37)
#define REG_PHY2P1_1_P1_1C_L        (REG_PHY2P1_1_P1_BASE + 0x38)
#define REG_PHY2P1_1_P1_1C_H        (REG_PHY2P1_1_P1_BASE + 0x39)
#define REG_PHY2P1_1_P1_1D_L        (REG_PHY2P1_1_P1_BASE + 0x3A)
#define REG_PHY2P1_1_P1_1D_H        (REG_PHY2P1_1_P1_BASE + 0x3B)
#define REG_PHY2P1_1_P1_1E_L        (REG_PHY2P1_1_P1_BASE + 0x3C)
#define REG_PHY2P1_1_P1_1E_H        (REG_PHY2P1_1_P1_BASE + 0x3D)
#define REG_PHY2P1_1_P1_1F_L        (REG_PHY2P1_1_P1_BASE + 0x3E)
#define REG_PHY2P1_1_P1_1F_H        (REG_PHY2P1_1_P1_BASE + 0x3F)
#define REG_PHY2P1_1_P1_20_L        (REG_PHY2P1_1_P1_BASE + 0x40)
#define REG_PHY2P1_1_P1_20_H        (REG_PHY2P1_1_P1_BASE + 0x41)
#define REG_PHY2P1_1_P1_21_L        (REG_PHY2P1_1_P1_BASE + 0x42)
#define REG_PHY2P1_1_P1_21_H        (REG_PHY2P1_1_P1_BASE + 0x43)
#define REG_PHY2P1_1_P1_22_L        (REG_PHY2P1_1_P1_BASE + 0x44)
#define REG_PHY2P1_1_P1_22_H        (REG_PHY2P1_1_P1_BASE + 0x45)
#define REG_PHY2P1_1_P1_23_L        (REG_PHY2P1_1_P1_BASE + 0x46)
#define REG_PHY2P1_1_P1_23_H        (REG_PHY2P1_1_P1_BASE + 0x47)
#define REG_PHY2P1_1_P1_24_L        (REG_PHY2P1_1_P1_BASE + 0x48)
#define REG_PHY2P1_1_P1_24_H        (REG_PHY2P1_1_P1_BASE + 0x49)
#define REG_PHY2P1_1_P1_25_L        (REG_PHY2P1_1_P1_BASE + 0x4A)
#define REG_PHY2P1_1_P1_25_H        (REG_PHY2P1_1_P1_BASE + 0x4B)
#define REG_PHY2P1_1_P1_26_L        (REG_PHY2P1_1_P1_BASE + 0x4C)
#define REG_PHY2P1_1_P1_26_H        (REG_PHY2P1_1_P1_BASE + 0x4D)
#define REG_PHY2P1_1_P1_27_L        (REG_PHY2P1_1_P1_BASE + 0x4E)
#define REG_PHY2P1_1_P1_27_H        (REG_PHY2P1_1_P1_BASE + 0x4F)
#define REG_PHY2P1_1_P1_28_L        (REG_PHY2P1_1_P1_BASE + 0x50)
#define REG_PHY2P1_1_P1_28_H        (REG_PHY2P1_1_P1_BASE + 0x51)
#define REG_PHY2P1_1_P1_29_L        (REG_PHY2P1_1_P1_BASE + 0x52)
#define REG_PHY2P1_1_P1_29_H        (REG_PHY2P1_1_P1_BASE + 0x53)
#define REG_PHY2P1_1_P1_2A_L        (REG_PHY2P1_1_P1_BASE + 0x54)
#define REG_PHY2P1_1_P1_2A_H        (REG_PHY2P1_1_P1_BASE + 0x55)
#define REG_PHY2P1_1_P1_2B_L        (REG_PHY2P1_1_P1_BASE + 0x56)
#define REG_PHY2P1_1_P1_2B_H        (REG_PHY2P1_1_P1_BASE + 0x57)
#define REG_PHY2P1_1_P1_2C_L        (REG_PHY2P1_1_P1_BASE + 0x58)
#define REG_PHY2P1_1_P1_2C_H        (REG_PHY2P1_1_P1_BASE + 0x59)
#define REG_PHY2P1_1_P1_2D_L        (REG_PHY2P1_1_P1_BASE + 0x5A)
#define REG_PHY2P1_1_P1_2D_H        (REG_PHY2P1_1_P1_BASE + 0x5B)
#define REG_PHY2P1_1_P1_2E_L        (REG_PHY2P1_1_P1_BASE + 0x5C)
#define REG_PHY2P1_1_P1_2E_H        (REG_PHY2P1_1_P1_BASE + 0x5D)
#define REG_PHY2P1_1_P1_2F_L        (REG_PHY2P1_1_P1_BASE + 0x5E)
#define REG_PHY2P1_1_P1_2F_H        (REG_PHY2P1_1_P1_BASE + 0x5F)
#define REG_PHY2P1_1_P1_30_L        (REG_PHY2P1_1_P1_BASE + 0x60)
#define REG_PHY2P1_1_P1_30_H        (REG_PHY2P1_1_P1_BASE + 0x61)
#define REG_PHY2P1_1_P1_31_L        (REG_PHY2P1_1_P1_BASE + 0x62)
#define REG_PHY2P1_1_P1_31_H        (REG_PHY2P1_1_P1_BASE + 0x63)
#define REG_PHY2P1_1_P1_32_L        (REG_PHY2P1_1_P1_BASE + 0x64)
#define REG_PHY2P1_1_P1_32_H        (REG_PHY2P1_1_P1_BASE + 0x65)
#define REG_PHY2P1_1_P1_33_L        (REG_PHY2P1_1_P1_BASE + 0x66)
#define REG_PHY2P1_1_P1_33_H        (REG_PHY2P1_1_P1_BASE + 0x67)
#define REG_PHY2P1_1_P1_34_L        (REG_PHY2P1_1_P1_BASE + 0x68)
#define REG_PHY2P1_1_P1_34_H        (REG_PHY2P1_1_P1_BASE + 0x69)
#define REG_PHY2P1_1_P1_35_L        (REG_PHY2P1_1_P1_BASE + 0x6A)
#define REG_PHY2P1_1_P1_35_H        (REG_PHY2P1_1_P1_BASE + 0x6B)
#define REG_PHY2P1_1_P1_36_L        (REG_PHY2P1_1_P1_BASE + 0x6C)
#define REG_PHY2P1_1_P1_36_H        (REG_PHY2P1_1_P1_BASE + 0x6D)
#define REG_PHY2P1_1_P1_37_L        (REG_PHY2P1_1_P1_BASE + 0x6E)
#define REG_PHY2P1_1_P1_37_H        (REG_PHY2P1_1_P1_BASE + 0x6F)
#define REG_PHY2P1_1_P1_38_L        (REG_PHY2P1_1_P1_BASE + 0x70)
#define REG_PHY2P1_1_P1_38_H        (REG_PHY2P1_1_P1_BASE + 0x71)
#define REG_PHY2P1_1_P1_39_L        (REG_PHY2P1_1_P1_BASE + 0x72)
#define REG_PHY2P1_1_P1_39_H        (REG_PHY2P1_1_P1_BASE + 0x73)
#define REG_PHY2P1_1_P1_3A_L        (REG_PHY2P1_1_P1_BASE + 0x74)
#define REG_PHY2P1_1_P1_3A_H        (REG_PHY2P1_1_P1_BASE + 0x75)
#define REG_PHY2P1_1_P1_3B_L        (REG_PHY2P1_1_P1_BASE + 0x76)
#define REG_PHY2P1_1_P1_3B_H        (REG_PHY2P1_1_P1_BASE + 0x77)
#define REG_PHY2P1_1_P1_3C_L        (REG_PHY2P1_1_P1_BASE + 0x78)
#define REG_PHY2P1_1_P1_3C_H        (REG_PHY2P1_1_P1_BASE + 0x79)
#define REG_PHY2P1_1_P1_3D_L        (REG_PHY2P1_1_P1_BASE + 0x7A)
#define REG_PHY2P1_1_P1_3D_H        (REG_PHY2P1_1_P1_BASE + 0x7B)
#define REG_PHY2P1_1_P1_3E_L        (REG_PHY2P1_1_P1_BASE + 0x7C)
#define REG_PHY2P1_1_P1_3E_H        (REG_PHY2P1_1_P1_BASE + 0x7D)
#define REG_PHY2P1_1_P1_3F_L        (REG_PHY2P1_1_P1_BASE + 0x7E)
#define REG_PHY2P1_1_P1_3F_H        (REG_PHY2P1_1_P1_BASE + 0x7F)
#define REG_PHY2P1_1_P1_40_L        (REG_PHY2P1_1_P1_BASE + 0x80)
#define REG_PHY2P1_1_P1_40_H        (REG_PHY2P1_1_P1_BASE + 0x81)
#define REG_PHY2P1_1_P1_41_L        (REG_PHY2P1_1_P1_BASE + 0x82)
#define REG_PHY2P1_1_P1_41_H        (REG_PHY2P1_1_P1_BASE + 0x83)
#define REG_PHY2P1_1_P1_42_L        (REG_PHY2P1_1_P1_BASE + 0x84)
#define REG_PHY2P1_1_P1_42_H        (REG_PHY2P1_1_P1_BASE + 0x85)
#define REG_PHY2P1_1_P1_43_L        (REG_PHY2P1_1_P1_BASE + 0x86)
#define REG_PHY2P1_1_P1_43_H        (REG_PHY2P1_1_P1_BASE + 0x87)
#define REG_PHY2P1_1_P1_44_L        (REG_PHY2P1_1_P1_BASE + 0x88)
#define REG_PHY2P1_1_P1_44_H        (REG_PHY2P1_1_P1_BASE + 0x89)
#define REG_PHY2P1_1_P1_45_L        (REG_PHY2P1_1_P1_BASE + 0x8A)
#define REG_PHY2P1_1_P1_45_H        (REG_PHY2P1_1_P1_BASE + 0x8B)
#define REG_PHY2P1_1_P1_46_L        (REG_PHY2P1_1_P1_BASE + 0x8C)
#define REG_PHY2P1_1_P1_46_H        (REG_PHY2P1_1_P1_BASE + 0x8D)
#define REG_PHY2P1_1_P1_47_L        (REG_PHY2P1_1_P1_BASE + 0x8E)
#define REG_PHY2P1_1_P1_47_H        (REG_PHY2P1_1_P1_BASE + 0x8F)
#define REG_PHY2P1_1_P1_48_L        (REG_PHY2P1_1_P1_BASE + 0x90)
#define REG_PHY2P1_1_P1_48_H        (REG_PHY2P1_1_P1_BASE + 0x91)
#define REG_PHY2P1_1_P1_49_L        (REG_PHY2P1_1_P1_BASE + 0x92)
#define REG_PHY2P1_1_P1_49_H        (REG_PHY2P1_1_P1_BASE + 0x93)
#define REG_PHY2P1_1_P1_4A_L        (REG_PHY2P1_1_P1_BASE + 0x94)
#define REG_PHY2P1_1_P1_4A_H        (REG_PHY2P1_1_P1_BASE + 0x95)
#define REG_PHY2P1_1_P1_4B_L        (REG_PHY2P1_1_P1_BASE + 0x96)
#define REG_PHY2P1_1_P1_4B_H        (REG_PHY2P1_1_P1_BASE + 0x97)
#define REG_PHY2P1_1_P1_4C_L        (REG_PHY2P1_1_P1_BASE + 0x98)
#define REG_PHY2P1_1_P1_4C_H        (REG_PHY2P1_1_P1_BASE + 0x99)
#define REG_PHY2P1_1_P1_4D_L        (REG_PHY2P1_1_P1_BASE + 0x9A)
#define REG_PHY2P1_1_P1_4D_H        (REG_PHY2P1_1_P1_BASE + 0x9B)
#define REG_PHY2P1_1_P1_4E_L        (REG_PHY2P1_1_P1_BASE + 0x9C)
#define REG_PHY2P1_1_P1_4E_H        (REG_PHY2P1_1_P1_BASE + 0x9D)
#define REG_PHY2P1_1_P1_4F_L        (REG_PHY2P1_1_P1_BASE + 0x9E)
#define REG_PHY2P1_1_P1_4F_H        (REG_PHY2P1_1_P1_BASE + 0x9F)
#define REG_PHY2P1_1_P1_50_L        (REG_PHY2P1_1_P1_BASE + 0xA0)
#define REG_PHY2P1_1_P1_50_H        (REG_PHY2P1_1_P1_BASE + 0xA1)
#define REG_PHY2P1_1_P1_51_L        (REG_PHY2P1_1_P1_BASE + 0xA2)
#define REG_PHY2P1_1_P1_51_H        (REG_PHY2P1_1_P1_BASE + 0xA3)
#define REG_PHY2P1_1_P1_52_L        (REG_PHY2P1_1_P1_BASE + 0xA4)
#define REG_PHY2P1_1_P1_52_H        (REG_PHY2P1_1_P1_BASE + 0xA5)
#define REG_PHY2P1_1_P1_53_L        (REG_PHY2P1_1_P1_BASE + 0xA6)
#define REG_PHY2P1_1_P1_53_H        (REG_PHY2P1_1_P1_BASE + 0xA7)
#define REG_PHY2P1_1_P1_54_L        (REG_PHY2P1_1_P1_BASE + 0xA8)
#define REG_PHY2P1_1_P1_54_H        (REG_PHY2P1_1_P1_BASE + 0xA9)
#define REG_PHY2P1_1_P1_55_L        (REG_PHY2P1_1_P1_BASE + 0xAA)
#define REG_PHY2P1_1_P1_55_H        (REG_PHY2P1_1_P1_BASE + 0xAB)
#define REG_PHY2P1_1_P1_56_L        (REG_PHY2P1_1_P1_BASE + 0xAC)
#define REG_PHY2P1_1_P1_56_H        (REG_PHY2P1_1_P1_BASE + 0xAD)
#define REG_PHY2P1_1_P1_57_L        (REG_PHY2P1_1_P1_BASE + 0xAE)
#define REG_PHY2P1_1_P1_57_H        (REG_PHY2P1_1_P1_BASE + 0xAF)
#define REG_PHY2P1_1_P1_58_L        (REG_PHY2P1_1_P1_BASE + 0xB0)
#define REG_PHY2P1_1_P1_58_H        (REG_PHY2P1_1_P1_BASE + 0xB1)
#define REG_PHY2P1_1_P1_59_L        (REG_PHY2P1_1_P1_BASE + 0xB2)
#define REG_PHY2P1_1_P1_59_H        (REG_PHY2P1_1_P1_BASE + 0xB3)
#define REG_PHY2P1_1_P1_5A_L        (REG_PHY2P1_1_P1_BASE + 0xB4)
#define REG_PHY2P1_1_P1_5A_H        (REG_PHY2P1_1_P1_BASE + 0xB5)
#define REG_PHY2P1_1_P1_5B_L        (REG_PHY2P1_1_P1_BASE + 0xB6)
#define REG_PHY2P1_1_P1_5B_H        (REG_PHY2P1_1_P1_BASE + 0xB7)
#define REG_PHY2P1_1_P1_5C_L        (REG_PHY2P1_1_P1_BASE + 0xB8)
#define REG_PHY2P1_1_P1_5C_H        (REG_PHY2P1_1_P1_BASE + 0xB9)
#define REG_PHY2P1_1_P1_5D_L        (REG_PHY2P1_1_P1_BASE + 0xBA)
#define REG_PHY2P1_1_P1_5D_H        (REG_PHY2P1_1_P1_BASE + 0xBB)
#define REG_PHY2P1_1_P1_5E_L        (REG_PHY2P1_1_P1_BASE + 0xBC)
#define REG_PHY2P1_1_P1_5E_H        (REG_PHY2P1_1_P1_BASE + 0xBD)
#define REG_PHY2P1_1_P1_5F_L        (REG_PHY2P1_1_P1_BASE + 0xBE)
#define REG_PHY2P1_1_P1_5F_H        (REG_PHY2P1_1_P1_BASE + 0xBF)
#define REG_PHY2P1_1_P1_60_L        (REG_PHY2P1_1_P1_BASE + 0xC0)
#define REG_PHY2P1_1_P1_60_H        (REG_PHY2P1_1_P1_BASE + 0xC1)
#define REG_PHY2P1_1_P1_61_L        (REG_PHY2P1_1_P1_BASE + 0xC2)
#define REG_PHY2P1_1_P1_61_H        (REG_PHY2P1_1_P1_BASE + 0xC3)
#define REG_PHY2P1_1_P1_62_L        (REG_PHY2P1_1_P1_BASE + 0xC4)
#define REG_PHY2P1_1_P1_62_H        (REG_PHY2P1_1_P1_BASE + 0xC5)
#define REG_PHY2P1_1_P1_63_L        (REG_PHY2P1_1_P1_BASE + 0xC6)
#define REG_PHY2P1_1_P1_63_H        (REG_PHY2P1_1_P1_BASE + 0xC7)
#define REG_PHY2P1_1_P1_64_L        (REG_PHY2P1_1_P1_BASE + 0xC8)
#define REG_PHY2P1_1_P1_64_H        (REG_PHY2P1_1_P1_BASE + 0xC9)
#define REG_PHY2P1_1_P1_65_L        (REG_PHY2P1_1_P1_BASE + 0xCA)
#define REG_PHY2P1_1_P1_65_H        (REG_PHY2P1_1_P1_BASE + 0xCB)
#define REG_PHY2P1_1_P1_66_L        (REG_PHY2P1_1_P1_BASE + 0xCC)
#define REG_PHY2P1_1_P1_66_H        (REG_PHY2P1_1_P1_BASE + 0xCD)
#define REG_PHY2P1_1_P1_67_L        (REG_PHY2P1_1_P1_BASE + 0xCE)
#define REG_PHY2P1_1_P1_67_H        (REG_PHY2P1_1_P1_BASE + 0xCF)
#define REG_PHY2P1_1_P1_68_L        (REG_PHY2P1_1_P1_BASE + 0xD0)
#define REG_PHY2P1_1_P1_68_H        (REG_PHY2P1_1_P1_BASE + 0xD1)
#define REG_PHY2P1_1_P1_69_L        (REG_PHY2P1_1_P1_BASE + 0xD2)
#define REG_PHY2P1_1_P1_69_H        (REG_PHY2P1_1_P1_BASE + 0xD3)
#define REG_PHY2P1_1_P1_6A_L        (REG_PHY2P1_1_P1_BASE + 0xD4)
#define REG_PHY2P1_1_P1_6A_H        (REG_PHY2P1_1_P1_BASE + 0xD5)
#define REG_PHY2P1_1_P1_6B_L        (REG_PHY2P1_1_P1_BASE + 0xD6)
#define REG_PHY2P1_1_P1_6B_H        (REG_PHY2P1_1_P1_BASE + 0xD7)
#define REG_PHY2P1_1_P1_6C_L        (REG_PHY2P1_1_P1_BASE + 0xD8)
#define REG_PHY2P1_1_P1_6C_H        (REG_PHY2P1_1_P1_BASE + 0xD9)
#define REG_PHY2P1_1_P1_6D_L        (REG_PHY2P1_1_P1_BASE + 0xDA)
#define REG_PHY2P1_1_P1_6D_H        (REG_PHY2P1_1_P1_BASE + 0xDB)
#define REG_PHY2P1_1_P1_6E_L        (REG_PHY2P1_1_P1_BASE + 0xDC)
#define REG_PHY2P1_1_P1_6E_H        (REG_PHY2P1_1_P1_BASE + 0xDD)
#define REG_PHY2P1_1_P1_6F_L        (REG_PHY2P1_1_P1_BASE + 0xDE)
#define REG_PHY2P1_1_P1_6F_H        (REG_PHY2P1_1_P1_BASE + 0xDF)
#define REG_PHY2P1_1_P1_70_L        (REG_PHY2P1_1_P1_BASE + 0xE0)
#define REG_PHY2P1_1_P1_70_H        (REG_PHY2P1_1_P1_BASE + 0xE1)
#define REG_PHY2P1_1_P1_71_L        (REG_PHY2P1_1_P1_BASE + 0xE2)
#define REG_PHY2P1_1_P1_71_H        (REG_PHY2P1_1_P1_BASE + 0xE3)
#define REG_PHY2P1_1_P1_72_L        (REG_PHY2P1_1_P1_BASE + 0xE4)
#define REG_PHY2P1_1_P1_72_H        (REG_PHY2P1_1_P1_BASE + 0xE5)
#define REG_PHY2P1_1_P1_73_L        (REG_PHY2P1_1_P1_BASE + 0xE6)
#define REG_PHY2P1_1_P1_73_H        (REG_PHY2P1_1_P1_BASE + 0xE7)
#define REG_PHY2P1_1_P1_74_L        (REG_PHY2P1_1_P1_BASE + 0xE8)
#define REG_PHY2P1_1_P1_74_H        (REG_PHY2P1_1_P1_BASE + 0xE9)
#define REG_PHY2P1_1_P1_75_L        (REG_PHY2P1_1_P1_BASE + 0xEA)
#define REG_PHY2P1_1_P1_75_H        (REG_PHY2P1_1_P1_BASE + 0xEB)
#define REG_PHY2P1_1_P1_76_L        (REG_PHY2P1_1_P1_BASE + 0xEC)
#define REG_PHY2P1_1_P1_76_H        (REG_PHY2P1_1_P1_BASE + 0xED)
#define REG_PHY2P1_1_P1_77_L        (REG_PHY2P1_1_P1_BASE + 0xEE)
#define REG_PHY2P1_1_P1_77_H        (REG_PHY2P1_1_P1_BASE + 0xEF)
#define REG_PHY2P1_1_P1_78_L        (REG_PHY2P1_1_P1_BASE + 0xF0)
#define REG_PHY2P1_1_P1_78_H        (REG_PHY2P1_1_P1_BASE + 0xF1)
#define REG_PHY2P1_1_P1_79_L        (REG_PHY2P1_1_P1_BASE + 0xF2)
#define REG_PHY2P1_1_P1_79_H        (REG_PHY2P1_1_P1_BASE + 0xF3)
#define REG_PHY2P1_1_P1_7A_L        (REG_PHY2P1_1_P1_BASE + 0xF4)
#define REG_PHY2P1_1_P1_7A_H        (REG_PHY2P1_1_P1_BASE + 0xF5)
#define REG_PHY2P1_1_P1_7B_L        (REG_PHY2P1_1_P1_BASE + 0xF6)
#define REG_PHY2P1_1_P1_7B_H        (REG_PHY2P1_1_P1_BASE + 0xF7)
#define REG_PHY2P1_1_P1_7C_L        (REG_PHY2P1_1_P1_BASE + 0xF8)
#define REG_PHY2P1_1_P1_7C_H        (REG_PHY2P1_1_P1_BASE + 0xF9)
#define REG_PHY2P1_1_P1_7D_L        (REG_PHY2P1_1_P1_BASE + 0xFA)
#define REG_PHY2P1_1_P1_7D_H        (REG_PHY2P1_1_P1_BASE + 0xFB)
#define REG_PHY2P1_1_P1_7E_L        (REG_PHY2P1_1_P1_BASE + 0xFC)
#define REG_PHY2P1_1_P1_7E_H        (REG_PHY2P1_1_P1_BASE + 0xFD)
#define REG_PHY2P1_1_P1_7F_L        (REG_PHY2P1_1_P1_BASE + 0xFE)
#define REG_PHY2P1_1_P1_7F_H        (REG_PHY2P1_1_P1_BASE + 0xFF)

//=============================================================
// PHY2P1_2_P1
#define REG_PHY2P1_2_P1_00_L        (REG_PHY2P1_2_P1_BASE + 0x00)
#define REG_PHY2P1_2_P1_00_H        (REG_PHY2P1_2_P1_BASE + 0x01)
#define REG_PHY2P1_2_P1_01_L        (REG_PHY2P1_2_P1_BASE + 0x02)
#define REG_PHY2P1_2_P1_01_H        (REG_PHY2P1_2_P1_BASE + 0x03)
#define REG_PHY2P1_2_P1_02_L        (REG_PHY2P1_2_P1_BASE + 0x04)
#define REG_PHY2P1_2_P1_02_H        (REG_PHY2P1_2_P1_BASE + 0x05)
#define REG_PHY2P1_2_P1_03_L        (REG_PHY2P1_2_P1_BASE + 0x06)
#define REG_PHY2P1_2_P1_03_H        (REG_PHY2P1_2_P1_BASE + 0x07)
#define REG_PHY2P1_2_P1_04_L        (REG_PHY2P1_2_P1_BASE + 0x08)
#define REG_PHY2P1_2_P1_04_H        (REG_PHY2P1_2_P1_BASE + 0x09)
#define REG_PHY2P1_2_P1_05_L        (REG_PHY2P1_2_P1_BASE + 0x0A)
#define REG_PHY2P1_2_P1_05_H        (REG_PHY2P1_2_P1_BASE + 0x0B)
#define REG_PHY2P1_2_P1_06_L        (REG_PHY2P1_2_P1_BASE + 0x0C)
#define REG_PHY2P1_2_P1_06_H        (REG_PHY2P1_2_P1_BASE + 0x0D)
#define REG_PHY2P1_2_P1_07_L        (REG_PHY2P1_2_P1_BASE + 0x0E)
#define REG_PHY2P1_2_P1_07_H        (REG_PHY2P1_2_P1_BASE + 0x0F)
#define REG_PHY2P1_2_P1_08_L        (REG_PHY2P1_2_P1_BASE + 0x10)
#define REG_PHY2P1_2_P1_08_H        (REG_PHY2P1_2_P1_BASE + 0x11)
#define REG_PHY2P1_2_P1_09_L        (REG_PHY2P1_2_P1_BASE + 0x12)
#define REG_PHY2P1_2_P1_09_H        (REG_PHY2P1_2_P1_BASE + 0x13)
#define REG_PHY2P1_2_P1_0A_L        (REG_PHY2P1_2_P1_BASE + 0x14)
#define REG_PHY2P1_2_P1_0A_H        (REG_PHY2P1_2_P1_BASE + 0x15)
#define REG_PHY2P1_2_P1_0B_L        (REG_PHY2P1_2_P1_BASE + 0x16)
#define REG_PHY2P1_2_P1_0B_H        (REG_PHY2P1_2_P1_BASE + 0x17)
#define REG_PHY2P1_2_P1_0C_L        (REG_PHY2P1_2_P1_BASE + 0x18)
#define REG_PHY2P1_2_P1_0C_H        (REG_PHY2P1_2_P1_BASE + 0x19)
#define REG_PHY2P1_2_P1_0D_L        (REG_PHY2P1_2_P1_BASE + 0x1A)
#define REG_PHY2P1_2_P1_0D_H        (REG_PHY2P1_2_P1_BASE + 0x1B)
#define REG_PHY2P1_2_P1_0E_L        (REG_PHY2P1_2_P1_BASE + 0x1C)
#define REG_PHY2P1_2_P1_0E_H        (REG_PHY2P1_2_P1_BASE + 0x1D)
#define REG_PHY2P1_2_P1_0F_L        (REG_PHY2P1_2_P1_BASE + 0x1E)
#define REG_PHY2P1_2_P1_0F_H        (REG_PHY2P1_2_P1_BASE + 0x1F)
#define REG_PHY2P1_2_P1_10_L        (REG_PHY2P1_2_P1_BASE + 0x20)
#define REG_PHY2P1_2_P1_10_H        (REG_PHY2P1_2_P1_BASE + 0x21)
#define REG_PHY2P1_2_P1_11_L        (REG_PHY2P1_2_P1_BASE + 0x22)
#define REG_PHY2P1_2_P1_11_H        (REG_PHY2P1_2_P1_BASE + 0x23)
#define REG_PHY2P1_2_P1_12_L        (REG_PHY2P1_2_P1_BASE + 0x24)
#define REG_PHY2P1_2_P1_12_H        (REG_PHY2P1_2_P1_BASE + 0x25)
#define REG_PHY2P1_2_P1_13_L        (REG_PHY2P1_2_P1_BASE + 0x26)
#define REG_PHY2P1_2_P1_13_H        (REG_PHY2P1_2_P1_BASE + 0x27)
#define REG_PHY2P1_2_P1_14_L        (REG_PHY2P1_2_P1_BASE + 0x28)
#define REG_PHY2P1_2_P1_14_H        (REG_PHY2P1_2_P1_BASE + 0x29)
#define REG_PHY2P1_2_P1_15_L        (REG_PHY2P1_2_P1_BASE + 0x2A)
#define REG_PHY2P1_2_P1_15_H        (REG_PHY2P1_2_P1_BASE + 0x2B)
#define REG_PHY2P1_2_P1_16_L        (REG_PHY2P1_2_P1_BASE + 0x2C)
#define REG_PHY2P1_2_P1_16_H        (REG_PHY2P1_2_P1_BASE + 0x2D)
#define REG_PHY2P1_2_P1_17_L        (REG_PHY2P1_2_P1_BASE + 0x2E)
#define REG_PHY2P1_2_P1_17_H        (REG_PHY2P1_2_P1_BASE + 0x2F)
#define REG_PHY2P1_2_P1_18_L        (REG_PHY2P1_2_P1_BASE + 0x30)
#define REG_PHY2P1_2_P1_18_H        (REG_PHY2P1_2_P1_BASE + 0x31)
#define REG_PHY2P1_2_P1_19_L        (REG_PHY2P1_2_P1_BASE + 0x32)
#define REG_PHY2P1_2_P1_19_H        (REG_PHY2P1_2_P1_BASE + 0x33)
#define REG_PHY2P1_2_P1_1A_L        (REG_PHY2P1_2_P1_BASE + 0x34)
#define REG_PHY2P1_2_P1_1A_H        (REG_PHY2P1_2_P1_BASE + 0x35)
#define REG_PHY2P1_2_P1_1B_L        (REG_PHY2P1_2_P1_BASE + 0x36)
#define REG_PHY2P1_2_P1_1B_H        (REG_PHY2P1_2_P1_BASE + 0x37)
#define REG_PHY2P1_2_P1_1C_L        (REG_PHY2P1_2_P1_BASE + 0x38)
#define REG_PHY2P1_2_P1_1C_H        (REG_PHY2P1_2_P1_BASE + 0x39)
#define REG_PHY2P1_2_P1_1D_L        (REG_PHY2P1_2_P1_BASE + 0x3A)
#define REG_PHY2P1_2_P1_1D_H        (REG_PHY2P1_2_P1_BASE + 0x3B)
#define REG_PHY2P1_2_P1_1E_L        (REG_PHY2P1_2_P1_BASE + 0x3C)
#define REG_PHY2P1_2_P1_1E_H        (REG_PHY2P1_2_P1_BASE + 0x3D)
#define REG_PHY2P1_2_P1_1F_L        (REG_PHY2P1_2_P1_BASE + 0x3E)
#define REG_PHY2P1_2_P1_1F_H        (REG_PHY2P1_2_P1_BASE + 0x3F)
#define REG_PHY2P1_2_P1_20_L        (REG_PHY2P1_2_P1_BASE + 0x40)
#define REG_PHY2P1_2_P1_20_H        (REG_PHY2P1_2_P1_BASE + 0x41)
#define REG_PHY2P1_2_P1_21_L        (REG_PHY2P1_2_P1_BASE + 0x42)
#define REG_PHY2P1_2_P1_21_H        (REG_PHY2P1_2_P1_BASE + 0x43)
#define REG_PHY2P1_2_P1_22_L        (REG_PHY2P1_2_P1_BASE + 0x44)
#define REG_PHY2P1_2_P1_22_H        (REG_PHY2P1_2_P1_BASE + 0x45)
#define REG_PHY2P1_2_P1_23_L        (REG_PHY2P1_2_P1_BASE + 0x46)
#define REG_PHY2P1_2_P1_23_H        (REG_PHY2P1_2_P1_BASE + 0x47)
#define REG_PHY2P1_2_P1_24_L        (REG_PHY2P1_2_P1_BASE + 0x48)
#define REG_PHY2P1_2_P1_24_H        (REG_PHY2P1_2_P1_BASE + 0x49)
#define REG_PHY2P1_2_P1_25_L        (REG_PHY2P1_2_P1_BASE + 0x4A)
#define REG_PHY2P1_2_P1_25_H        (REG_PHY2P1_2_P1_BASE + 0x4B)
#define REG_PHY2P1_2_P1_26_L        (REG_PHY2P1_2_P1_BASE + 0x4C)
#define REG_PHY2P1_2_P1_26_H        (REG_PHY2P1_2_P1_BASE + 0x4D)
#define REG_PHY2P1_2_P1_27_L        (REG_PHY2P1_2_P1_BASE + 0x4E)
#define REG_PHY2P1_2_P1_27_H        (REG_PHY2P1_2_P1_BASE + 0x4F)
#define REG_PHY2P1_2_P1_28_L        (REG_PHY2P1_2_P1_BASE + 0x50)
#define REG_PHY2P1_2_P1_28_H        (REG_PHY2P1_2_P1_BASE + 0x51)
#define REG_PHY2P1_2_P1_29_L        (REG_PHY2P1_2_P1_BASE + 0x52)
#define REG_PHY2P1_2_P1_29_H        (REG_PHY2P1_2_P1_BASE + 0x53)
#define REG_PHY2P1_2_P1_2A_L        (REG_PHY2P1_2_P1_BASE + 0x54)
#define REG_PHY2P1_2_P1_2A_H        (REG_PHY2P1_2_P1_BASE + 0x55)
#define REG_PHY2P1_2_P1_2B_L        (REG_PHY2P1_2_P1_BASE + 0x56)
#define REG_PHY2P1_2_P1_2B_H        (REG_PHY2P1_2_P1_BASE + 0x57)
#define REG_PHY2P1_2_P1_2C_L        (REG_PHY2P1_2_P1_BASE + 0x58)
#define REG_PHY2P1_2_P1_2C_H        (REG_PHY2P1_2_P1_BASE + 0x59)
#define REG_PHY2P1_2_P1_2D_L        (REG_PHY2P1_2_P1_BASE + 0x5A)
#define REG_PHY2P1_2_P1_2D_H        (REG_PHY2P1_2_P1_BASE + 0x5B)
#define REG_PHY2P1_2_P1_2E_L        (REG_PHY2P1_2_P1_BASE + 0x5C)
#define REG_PHY2P1_2_P1_2E_H        (REG_PHY2P1_2_P1_BASE + 0x5D)
#define REG_PHY2P1_2_P1_2F_L        (REG_PHY2P1_2_P1_BASE + 0x5E)
#define REG_PHY2P1_2_P1_2F_H        (REG_PHY2P1_2_P1_BASE + 0x5F)
#define REG_PHY2P1_2_P1_30_L        (REG_PHY2P1_2_P1_BASE + 0x60)
#define REG_PHY2P1_2_P1_30_H        (REG_PHY2P1_2_P1_BASE + 0x61)
#define REG_PHY2P1_2_P1_31_L        (REG_PHY2P1_2_P1_BASE + 0x62)
#define REG_PHY2P1_2_P1_31_H        (REG_PHY2P1_2_P1_BASE + 0x63)
#define REG_PHY2P1_2_P1_32_L        (REG_PHY2P1_2_P1_BASE + 0x64)
#define REG_PHY2P1_2_P1_32_H        (REG_PHY2P1_2_P1_BASE + 0x65)
#define REG_PHY2P1_2_P1_33_L        (REG_PHY2P1_2_P1_BASE + 0x66)
#define REG_PHY2P1_2_P1_33_H        (REG_PHY2P1_2_P1_BASE + 0x67)
#define REG_PHY2P1_2_P1_34_L        (REG_PHY2P1_2_P1_BASE + 0x68)
#define REG_PHY2P1_2_P1_34_H        (REG_PHY2P1_2_P1_BASE + 0x69)
#define REG_PHY2P1_2_P1_35_L        (REG_PHY2P1_2_P1_BASE + 0x6A)
#define REG_PHY2P1_2_P1_35_H        (REG_PHY2P1_2_P1_BASE + 0x6B)
#define REG_PHY2P1_2_P1_36_L        (REG_PHY2P1_2_P1_BASE + 0x6C)
#define REG_PHY2P1_2_P1_36_H        (REG_PHY2P1_2_P1_BASE + 0x6D)
#define REG_PHY2P1_2_P1_37_L        (REG_PHY2P1_2_P1_BASE + 0x6E)
#define REG_PHY2P1_2_P1_37_H        (REG_PHY2P1_2_P1_BASE + 0x6F)
#define REG_PHY2P1_2_P1_38_L        (REG_PHY2P1_2_P1_BASE + 0x70)
#define REG_PHY2P1_2_P1_38_H        (REG_PHY2P1_2_P1_BASE + 0x71)
#define REG_PHY2P1_2_P1_39_L        (REG_PHY2P1_2_P1_BASE + 0x72)
#define REG_PHY2P1_2_P1_39_H        (REG_PHY2P1_2_P1_BASE + 0x73)
#define REG_PHY2P1_2_P1_3A_L        (REG_PHY2P1_2_P1_BASE + 0x74)
#define REG_PHY2P1_2_P1_3A_H        (REG_PHY2P1_2_P1_BASE + 0x75)
#define REG_PHY2P1_2_P1_3B_L        (REG_PHY2P1_2_P1_BASE + 0x76)
#define REG_PHY2P1_2_P1_3B_H        (REG_PHY2P1_2_P1_BASE + 0x77)
#define REG_PHY2P1_2_P1_3C_L        (REG_PHY2P1_2_P1_BASE + 0x78)
#define REG_PHY2P1_2_P1_3C_H        (REG_PHY2P1_2_P1_BASE + 0x79)
#define REG_PHY2P1_2_P1_3D_L        (REG_PHY2P1_2_P1_BASE + 0x7A)
#define REG_PHY2P1_2_P1_3D_H        (REG_PHY2P1_2_P1_BASE + 0x7B)
#define REG_PHY2P1_2_P1_3E_L        (REG_PHY2P1_2_P1_BASE + 0x7C)
#define REG_PHY2P1_2_P1_3E_H        (REG_PHY2P1_2_P1_BASE + 0x7D)
#define REG_PHY2P1_2_P1_3F_L        (REG_PHY2P1_2_P1_BASE + 0x7E)
#define REG_PHY2P1_2_P1_3F_H        (REG_PHY2P1_2_P1_BASE + 0x7F)
#define REG_PHY2P1_2_P1_40_L        (REG_PHY2P1_2_P1_BASE + 0x80)
#define REG_PHY2P1_2_P1_40_H        (REG_PHY2P1_2_P1_BASE + 0x81)
#define REG_PHY2P1_2_P1_41_L        (REG_PHY2P1_2_P1_BASE + 0x82)
#define REG_PHY2P1_2_P1_41_H        (REG_PHY2P1_2_P1_BASE + 0x83)
#define REG_PHY2P1_2_P1_42_L        (REG_PHY2P1_2_P1_BASE + 0x84)
#define REG_PHY2P1_2_P1_42_H        (REG_PHY2P1_2_P1_BASE + 0x85)
#define REG_PHY2P1_2_P1_43_L        (REG_PHY2P1_2_P1_BASE + 0x86)
#define REG_PHY2P1_2_P1_43_H        (REG_PHY2P1_2_P1_BASE + 0x87)
#define REG_PHY2P1_2_P1_44_L        (REG_PHY2P1_2_P1_BASE + 0x88)
#define REG_PHY2P1_2_P1_44_H        (REG_PHY2P1_2_P1_BASE + 0x89)
#define REG_PHY2P1_2_P1_45_L        (REG_PHY2P1_2_P1_BASE + 0x8A)
#define REG_PHY2P1_2_P1_45_H        (REG_PHY2P1_2_P1_BASE + 0x8B)
#define REG_PHY2P1_2_P1_46_L        (REG_PHY2P1_2_P1_BASE + 0x8C)
#define REG_PHY2P1_2_P1_46_H        (REG_PHY2P1_2_P1_BASE + 0x8D)
#define REG_PHY2P1_2_P1_47_L        (REG_PHY2P1_2_P1_BASE + 0x8E)
#define REG_PHY2P1_2_P1_47_H        (REG_PHY2P1_2_P1_BASE + 0x8F)
#define REG_PHY2P1_2_P1_48_L        (REG_PHY2P1_2_P1_BASE + 0x90)
#define REG_PHY2P1_2_P1_48_H        (REG_PHY2P1_2_P1_BASE + 0x91)
#define REG_PHY2P1_2_P1_49_L        (REG_PHY2P1_2_P1_BASE + 0x92)
#define REG_PHY2P1_2_P1_49_H        (REG_PHY2P1_2_P1_BASE + 0x93)
#define REG_PHY2P1_2_P1_4A_L        (REG_PHY2P1_2_P1_BASE + 0x94)
#define REG_PHY2P1_2_P1_4A_H        (REG_PHY2P1_2_P1_BASE + 0x95)
#define REG_PHY2P1_2_P1_4B_L        (REG_PHY2P1_2_P1_BASE + 0x96)
#define REG_PHY2P1_2_P1_4B_H        (REG_PHY2P1_2_P1_BASE + 0x97)
#define REG_PHY2P1_2_P1_4C_L        (REG_PHY2P1_2_P1_BASE + 0x98)
#define REG_PHY2P1_2_P1_4C_H        (REG_PHY2P1_2_P1_BASE + 0x99)
#define REG_PHY2P1_2_P1_4D_L        (REG_PHY2P1_2_P1_BASE + 0x9A)
#define REG_PHY2P1_2_P1_4D_H        (REG_PHY2P1_2_P1_BASE + 0x9B)
#define REG_PHY2P1_2_P1_4E_L        (REG_PHY2P1_2_P1_BASE + 0x9C)
#define REG_PHY2P1_2_P1_4E_H        (REG_PHY2P1_2_P1_BASE + 0x9D)
#define REG_PHY2P1_2_P1_4F_L        (REG_PHY2P1_2_P1_BASE + 0x9E)
#define REG_PHY2P1_2_P1_4F_H        (REG_PHY2P1_2_P1_BASE + 0x9F)
#define REG_PHY2P1_2_P1_50_L        (REG_PHY2P1_2_P1_BASE + 0xA0)
#define REG_PHY2P1_2_P1_50_H        (REG_PHY2P1_2_P1_BASE + 0xA1)
#define REG_PHY2P1_2_P1_51_L        (REG_PHY2P1_2_P1_BASE + 0xA2)
#define REG_PHY2P1_2_P1_51_H        (REG_PHY2P1_2_P1_BASE + 0xA3)
#define REG_PHY2P1_2_P1_52_L        (REG_PHY2P1_2_P1_BASE + 0xA4)
#define REG_PHY2P1_2_P1_52_H        (REG_PHY2P1_2_P1_BASE + 0xA5)
#define REG_PHY2P1_2_P1_53_L        (REG_PHY2P1_2_P1_BASE + 0xA6)
#define REG_PHY2P1_2_P1_53_H        (REG_PHY2P1_2_P1_BASE + 0xA7)
#define REG_PHY2P1_2_P1_54_L        (REG_PHY2P1_2_P1_BASE + 0xA8)
#define REG_PHY2P1_2_P1_54_H        (REG_PHY2P1_2_P1_BASE + 0xA9)
#define REG_PHY2P1_2_P1_55_L        (REG_PHY2P1_2_P1_BASE + 0xAA)
#define REG_PHY2P1_2_P1_55_H        (REG_PHY2P1_2_P1_BASE + 0xAB)
#define REG_PHY2P1_2_P1_56_L        (REG_PHY2P1_2_P1_BASE + 0xAC)
#define REG_PHY2P1_2_P1_56_H        (REG_PHY2P1_2_P1_BASE + 0xAD)
#define REG_PHY2P1_2_P1_57_L        (REG_PHY2P1_2_P1_BASE + 0xAE)
#define REG_PHY2P1_2_P1_57_H        (REG_PHY2P1_2_P1_BASE + 0xAF)
#define REG_PHY2P1_2_P1_58_L        (REG_PHY2P1_2_P1_BASE + 0xB0)
#define REG_PHY2P1_2_P1_58_H        (REG_PHY2P1_2_P1_BASE + 0xB1)
#define REG_PHY2P1_2_P1_59_L        (REG_PHY2P1_2_P1_BASE + 0xB2)
#define REG_PHY2P1_2_P1_59_H        (REG_PHY2P1_2_P1_BASE + 0xB3)
#define REG_PHY2P1_2_P1_5A_L        (REG_PHY2P1_2_P1_BASE + 0xB4)
#define REG_PHY2P1_2_P1_5A_H        (REG_PHY2P1_2_P1_BASE + 0xB5)
#define REG_PHY2P1_2_P1_5B_L        (REG_PHY2P1_2_P1_BASE + 0xB6)
#define REG_PHY2P1_2_P1_5B_H        (REG_PHY2P1_2_P1_BASE + 0xB7)
#define REG_PHY2P1_2_P1_5C_L        (REG_PHY2P1_2_P1_BASE + 0xB8)
#define REG_PHY2P1_2_P1_5C_H        (REG_PHY2P1_2_P1_BASE + 0xB9)
#define REG_PHY2P1_2_P1_5D_L        (REG_PHY2P1_2_P1_BASE + 0xBA)
#define REG_PHY2P1_2_P1_5D_H        (REG_PHY2P1_2_P1_BASE + 0xBB)
#define REG_PHY2P1_2_P1_5E_L        (REG_PHY2P1_2_P1_BASE + 0xBC)
#define REG_PHY2P1_2_P1_5E_H        (REG_PHY2P1_2_P1_BASE + 0xBD)
#define REG_PHY2P1_2_P1_5F_L        (REG_PHY2P1_2_P1_BASE + 0xBE)
#define REG_PHY2P1_2_P1_5F_H        (REG_PHY2P1_2_P1_BASE + 0xBF)
#define REG_PHY2P1_2_P1_60_L        (REG_PHY2P1_2_P1_BASE + 0xC0)
#define REG_PHY2P1_2_P1_60_H        (REG_PHY2P1_2_P1_BASE + 0xC1)
#define REG_PHY2P1_2_P1_61_L        (REG_PHY2P1_2_P1_BASE + 0xC2)
#define REG_PHY2P1_2_P1_61_H        (REG_PHY2P1_2_P1_BASE + 0xC3)
#define REG_PHY2P1_2_P1_62_L        (REG_PHY2P1_2_P1_BASE + 0xC4)
#define REG_PHY2P1_2_P1_62_H        (REG_PHY2P1_2_P1_BASE + 0xC5)
#define REG_PHY2P1_2_P1_63_L        (REG_PHY2P1_2_P1_BASE + 0xC6)
#define REG_PHY2P1_2_P1_63_H        (REG_PHY2P1_2_P1_BASE + 0xC7)
#define REG_PHY2P1_2_P1_64_L        (REG_PHY2P1_2_P1_BASE + 0xC8)
#define REG_PHY2P1_2_P1_64_H        (REG_PHY2P1_2_P1_BASE + 0xC9)
#define REG_PHY2P1_2_P1_65_L        (REG_PHY2P1_2_P1_BASE + 0xCA)
#define REG_PHY2P1_2_P1_65_H        (REG_PHY2P1_2_P1_BASE + 0xCB)
#define REG_PHY2P1_2_P1_66_L        (REG_PHY2P1_2_P1_BASE + 0xCC)
#define REG_PHY2P1_2_P1_66_H        (REG_PHY2P1_2_P1_BASE + 0xCD)
#define REG_PHY2P1_2_P1_67_L        (REG_PHY2P1_2_P1_BASE + 0xCE)
#define REG_PHY2P1_2_P1_67_H        (REG_PHY2P1_2_P1_BASE + 0xCF)
#define REG_PHY2P1_2_P1_68_L        (REG_PHY2P1_2_P1_BASE + 0xD0)
#define REG_PHY2P1_2_P1_68_H        (REG_PHY2P1_2_P1_BASE + 0xD1)
#define REG_PHY2P1_2_P1_69_L        (REG_PHY2P1_2_P1_BASE + 0xD2)
#define REG_PHY2P1_2_P1_69_H        (REG_PHY2P1_2_P1_BASE + 0xD3)
#define REG_PHY2P1_2_P1_6A_L        (REG_PHY2P1_2_P1_BASE + 0xD4)
#define REG_PHY2P1_2_P1_6A_H        (REG_PHY2P1_2_P1_BASE + 0xD5)
#define REG_PHY2P1_2_P1_6B_L        (REG_PHY2P1_2_P1_BASE + 0xD6)
#define REG_PHY2P1_2_P1_6B_H        (REG_PHY2P1_2_P1_BASE + 0xD7)
#define REG_PHY2P1_2_P1_6C_L        (REG_PHY2P1_2_P1_BASE + 0xD8)
#define REG_PHY2P1_2_P1_6C_H        (REG_PHY2P1_2_P1_BASE + 0xD9)
#define REG_PHY2P1_2_P1_6D_L        (REG_PHY2P1_2_P1_BASE + 0xDA)
#define REG_PHY2P1_2_P1_6D_H        (REG_PHY2P1_2_P1_BASE + 0xDB)
#define REG_PHY2P1_2_P1_6E_L        (REG_PHY2P1_2_P1_BASE + 0xDC)
#define REG_PHY2P1_2_P1_6E_H        (REG_PHY2P1_2_P1_BASE + 0xDD)
#define REG_PHY2P1_2_P1_6F_L        (REG_PHY2P1_2_P1_BASE + 0xDE)
#define REG_PHY2P1_2_P1_6F_H        (REG_PHY2P1_2_P1_BASE + 0xDF)
#define REG_PHY2P1_2_P1_70_L        (REG_PHY2P1_2_P1_BASE + 0xE0)
#define REG_PHY2P1_2_P1_70_H        (REG_PHY2P1_2_P1_BASE + 0xE1)
#define REG_PHY2P1_2_P1_71_L        (REG_PHY2P1_2_P1_BASE + 0xE2)
#define REG_PHY2P1_2_P1_71_H        (REG_PHY2P1_2_P1_BASE + 0xE3)
#define REG_PHY2P1_2_P1_72_L        (REG_PHY2P1_2_P1_BASE + 0xE4)
#define REG_PHY2P1_2_P1_72_H        (REG_PHY2P1_2_P1_BASE + 0xE5)
#define REG_PHY2P1_2_P1_73_L        (REG_PHY2P1_2_P1_BASE + 0xE6)
#define REG_PHY2P1_2_P1_73_H        (REG_PHY2P1_2_P1_BASE + 0xE7)
#define REG_PHY2P1_2_P1_74_L        (REG_PHY2P1_2_P1_BASE + 0xE8)
#define REG_PHY2P1_2_P1_74_H        (REG_PHY2P1_2_P1_BASE + 0xE9)
#define REG_PHY2P1_2_P1_75_L        (REG_PHY2P1_2_P1_BASE + 0xEA)
#define REG_PHY2P1_2_P1_75_H        (REG_PHY2P1_2_P1_BASE + 0xEB)
#define REG_PHY2P1_2_P1_76_L        (REG_PHY2P1_2_P1_BASE + 0xEC)
#define REG_PHY2P1_2_P1_76_H        (REG_PHY2P1_2_P1_BASE + 0xED)
#define REG_PHY2P1_2_P1_77_L        (REG_PHY2P1_2_P1_BASE + 0xEE)
#define REG_PHY2P1_2_P1_77_H        (REG_PHY2P1_2_P1_BASE + 0xEF)
#define REG_PHY2P1_2_P1_78_L        (REG_PHY2P1_2_P1_BASE + 0xF0)
#define REG_PHY2P1_2_P1_78_H        (REG_PHY2P1_2_P1_BASE + 0xF1)
#define REG_PHY2P1_2_P1_79_L        (REG_PHY2P1_2_P1_BASE + 0xF2)
#define REG_PHY2P1_2_P1_79_H        (REG_PHY2P1_2_P1_BASE + 0xF3)
#define REG_PHY2P1_2_P1_7A_L        (REG_PHY2P1_2_P1_BASE + 0xF4)
#define REG_PHY2P1_2_P1_7A_H        (REG_PHY2P1_2_P1_BASE + 0xF5)
#define REG_PHY2P1_2_P1_7B_L        (REG_PHY2P1_2_P1_BASE + 0xF6)
#define REG_PHY2P1_2_P1_7B_H        (REG_PHY2P1_2_P1_BASE + 0xF7)
#define REG_PHY2P1_2_P1_7C_L        (REG_PHY2P1_2_P1_BASE + 0xF8)
#define REG_PHY2P1_2_P1_7C_H        (REG_PHY2P1_2_P1_BASE + 0xF9)
#define REG_PHY2P1_2_P1_7D_L        (REG_PHY2P1_2_P1_BASE + 0xFA)
#define REG_PHY2P1_2_P1_7D_H        (REG_PHY2P1_2_P1_BASE + 0xFB)
#define REG_PHY2P1_2_P1_7E_L        (REG_PHY2P1_2_P1_BASE + 0xFC)
#define REG_PHY2P1_2_P1_7E_H        (REG_PHY2P1_2_P1_BASE + 0xFD)
#define REG_PHY2P1_2_P1_7F_L        (REG_PHY2P1_2_P1_BASE + 0xFE)
#define REG_PHY2P1_2_P1_7F_H        (REG_PHY2P1_2_P1_BASE + 0xFF)

//=============================================================
// PHY2P1_3_P1
#define REG_PHY2P1_3_P1_00_L        (REG_PHY2P1_3_P1_BASE + 0x00)
#define REG_PHY2P1_3_P1_00_H        (REG_PHY2P1_3_P1_BASE + 0x01)
#define REG_PHY2P1_3_P1_01_L        (REG_PHY2P1_3_P1_BASE + 0x02)
#define REG_PHY2P1_3_P1_01_H        (REG_PHY2P1_3_P1_BASE + 0x03)
#define REG_PHY2P1_3_P1_02_L        (REG_PHY2P1_3_P1_BASE + 0x04)
#define REG_PHY2P1_3_P1_02_H        (REG_PHY2P1_3_P1_BASE + 0x05)
#define REG_PHY2P1_3_P1_03_L        (REG_PHY2P1_3_P1_BASE + 0x06)
#define REG_PHY2P1_3_P1_03_H        (REG_PHY2P1_3_P1_BASE + 0x07)
#define REG_PHY2P1_3_P1_04_L        (REG_PHY2P1_3_P1_BASE + 0x08)
#define REG_PHY2P1_3_P1_04_H        (REG_PHY2P1_3_P1_BASE + 0x09)
#define REG_PHY2P1_3_P1_05_L        (REG_PHY2P1_3_P1_BASE + 0x0A)
#define REG_PHY2P1_3_P1_05_H        (REG_PHY2P1_3_P1_BASE + 0x0B)
#define REG_PHY2P1_3_P1_06_L        (REG_PHY2P1_3_P1_BASE + 0x0C)
#define REG_PHY2P1_3_P1_06_H        (REG_PHY2P1_3_P1_BASE + 0x0D)
#define REG_PHY2P1_3_P1_07_L        (REG_PHY2P1_3_P1_BASE + 0x0E)
#define REG_PHY2P1_3_P1_07_H        (REG_PHY2P1_3_P1_BASE + 0x0F)
#define REG_PHY2P1_3_P1_08_L        (REG_PHY2P1_3_P1_BASE + 0x10)
#define REG_PHY2P1_3_P1_08_H        (REG_PHY2P1_3_P1_BASE + 0x11)
#define REG_PHY2P1_3_P1_09_L        (REG_PHY2P1_3_P1_BASE + 0x12)
#define REG_PHY2P1_3_P1_09_H        (REG_PHY2P1_3_P1_BASE + 0x13)
#define REG_PHY2P1_3_P1_0A_L        (REG_PHY2P1_3_P1_BASE + 0x14)
#define REG_PHY2P1_3_P1_0A_H        (REG_PHY2P1_3_P1_BASE + 0x15)
#define REG_PHY2P1_3_P1_0B_L        (REG_PHY2P1_3_P1_BASE + 0x16)
#define REG_PHY2P1_3_P1_0B_H        (REG_PHY2P1_3_P1_BASE + 0x17)
#define REG_PHY2P1_3_P1_0C_L        (REG_PHY2P1_3_P1_BASE + 0x18)
#define REG_PHY2P1_3_P1_0C_H        (REG_PHY2P1_3_P1_BASE + 0x19)
#define REG_PHY2P1_3_P1_0D_L        (REG_PHY2P1_3_P1_BASE + 0x1A)
#define REG_PHY2P1_3_P1_0D_H        (REG_PHY2P1_3_P1_BASE + 0x1B)
#define REG_PHY2P1_3_P1_0E_L        (REG_PHY2P1_3_P1_BASE + 0x1C)
#define REG_PHY2P1_3_P1_0E_H        (REG_PHY2P1_3_P1_BASE + 0x1D)
#define REG_PHY2P1_3_P1_0F_L        (REG_PHY2P1_3_P1_BASE + 0x1E)
#define REG_PHY2P1_3_P1_0F_H        (REG_PHY2P1_3_P1_BASE + 0x1F)
#define REG_PHY2P1_3_P1_10_L        (REG_PHY2P1_3_P1_BASE + 0x20)
#define REG_PHY2P1_3_P1_10_H        (REG_PHY2P1_3_P1_BASE + 0x21)
#define REG_PHY2P1_3_P1_11_L        (REG_PHY2P1_3_P1_BASE + 0x22)
#define REG_PHY2P1_3_P1_11_H        (REG_PHY2P1_3_P1_BASE + 0x23)
#define REG_PHY2P1_3_P1_12_L        (REG_PHY2P1_3_P1_BASE + 0x24)
#define REG_PHY2P1_3_P1_12_H        (REG_PHY2P1_3_P1_BASE + 0x25)
#define REG_PHY2P1_3_P1_13_L        (REG_PHY2P1_3_P1_BASE + 0x26)
#define REG_PHY2P1_3_P1_13_H        (REG_PHY2P1_3_P1_BASE + 0x27)
#define REG_PHY2P1_3_P1_14_L        (REG_PHY2P1_3_P1_BASE + 0x28)
#define REG_PHY2P1_3_P1_14_H        (REG_PHY2P1_3_P1_BASE + 0x29)
#define REG_PHY2P1_3_P1_15_L        (REG_PHY2P1_3_P1_BASE + 0x2A)
#define REG_PHY2P1_3_P1_15_H        (REG_PHY2P1_3_P1_BASE + 0x2B)
#define REG_PHY2P1_3_P1_16_L        (REG_PHY2P1_3_P1_BASE + 0x2C)
#define REG_PHY2P1_3_P1_16_H        (REG_PHY2P1_3_P1_BASE + 0x2D)
#define REG_PHY2P1_3_P1_17_L        (REG_PHY2P1_3_P1_BASE + 0x2E)
#define REG_PHY2P1_3_P1_17_H        (REG_PHY2P1_3_P1_BASE + 0x2F)
#define REG_PHY2P1_3_P1_18_L        (REG_PHY2P1_3_P1_BASE + 0x30)
#define REG_PHY2P1_3_P1_18_H        (REG_PHY2P1_3_P1_BASE + 0x31)
#define REG_PHY2P1_3_P1_19_L        (REG_PHY2P1_3_P1_BASE + 0x32)
#define REG_PHY2P1_3_P1_19_H        (REG_PHY2P1_3_P1_BASE + 0x33)
#define REG_PHY2P1_3_P1_1A_L        (REG_PHY2P1_3_P1_BASE + 0x34)
#define REG_PHY2P1_3_P1_1A_H        (REG_PHY2P1_3_P1_BASE + 0x35)
#define REG_PHY2P1_3_P1_1B_L        (REG_PHY2P1_3_P1_BASE + 0x36)
#define REG_PHY2P1_3_P1_1B_H        (REG_PHY2P1_3_P1_BASE + 0x37)
#define REG_PHY2P1_3_P1_1C_L        (REG_PHY2P1_3_P1_BASE + 0x38)
#define REG_PHY2P1_3_P1_1C_H        (REG_PHY2P1_3_P1_BASE + 0x39)
#define REG_PHY2P1_3_P1_1D_L        (REG_PHY2P1_3_P1_BASE + 0x3A)
#define REG_PHY2P1_3_P1_1D_H        (REG_PHY2P1_3_P1_BASE + 0x3B)
#define REG_PHY2P1_3_P1_1E_L        (REG_PHY2P1_3_P1_BASE + 0x3C)
#define REG_PHY2P1_3_P1_1E_H        (REG_PHY2P1_3_P1_BASE + 0x3D)
#define REG_PHY2P1_3_P1_1F_L        (REG_PHY2P1_3_P1_BASE + 0x3E)
#define REG_PHY2P1_3_P1_1F_H        (REG_PHY2P1_3_P1_BASE + 0x3F)
#define REG_PHY2P1_3_P1_20_L        (REG_PHY2P1_3_P1_BASE + 0x40)
#define REG_PHY2P1_3_P1_20_H        (REG_PHY2P1_3_P1_BASE + 0x41)
#define REG_PHY2P1_3_P1_21_L        (REG_PHY2P1_3_P1_BASE + 0x42)
#define REG_PHY2P1_3_P1_21_H        (REG_PHY2P1_3_P1_BASE + 0x43)
#define REG_PHY2P1_3_P1_22_L        (REG_PHY2P1_3_P1_BASE + 0x44)
#define REG_PHY2P1_3_P1_22_H        (REG_PHY2P1_3_P1_BASE + 0x45)
#define REG_PHY2P1_3_P1_23_L        (REG_PHY2P1_3_P1_BASE + 0x46)
#define REG_PHY2P1_3_P1_23_H        (REG_PHY2P1_3_P1_BASE + 0x47)
#define REG_PHY2P1_3_P1_24_L        (REG_PHY2P1_3_P1_BASE + 0x48)
#define REG_PHY2P1_3_P1_24_H        (REG_PHY2P1_3_P1_BASE + 0x49)
#define REG_PHY2P1_3_P1_25_L        (REG_PHY2P1_3_P1_BASE + 0x4A)
#define REG_PHY2P1_3_P1_25_H        (REG_PHY2P1_3_P1_BASE + 0x4B)
#define REG_PHY2P1_3_P1_26_L        (REG_PHY2P1_3_P1_BASE + 0x4C)
#define REG_PHY2P1_3_P1_26_H        (REG_PHY2P1_3_P1_BASE + 0x4D)
#define REG_PHY2P1_3_P1_27_L        (REG_PHY2P1_3_P1_BASE + 0x4E)
#define REG_PHY2P1_3_P1_27_H        (REG_PHY2P1_3_P1_BASE + 0x4F)
#define REG_PHY2P1_3_P1_28_L        (REG_PHY2P1_3_P1_BASE + 0x50)
#define REG_PHY2P1_3_P1_28_H        (REG_PHY2P1_3_P1_BASE + 0x51)
#define REG_PHY2P1_3_P1_29_L        (REG_PHY2P1_3_P1_BASE + 0x52)
#define REG_PHY2P1_3_P1_29_H        (REG_PHY2P1_3_P1_BASE + 0x53)
#define REG_PHY2P1_3_P1_2A_L        (REG_PHY2P1_3_P1_BASE + 0x54)
#define REG_PHY2P1_3_P1_2A_H        (REG_PHY2P1_3_P1_BASE + 0x55)
#define REG_PHY2P1_3_P1_2B_L        (REG_PHY2P1_3_P1_BASE + 0x56)
#define REG_PHY2P1_3_P1_2B_H        (REG_PHY2P1_3_P1_BASE + 0x57)
#define REG_PHY2P1_3_P1_2C_L        (REG_PHY2P1_3_P1_BASE + 0x58)
#define REG_PHY2P1_3_P1_2C_H        (REG_PHY2P1_3_P1_BASE + 0x59)
#define REG_PHY2P1_3_P1_2D_L        (REG_PHY2P1_3_P1_BASE + 0x5A)
#define REG_PHY2P1_3_P1_2D_H        (REG_PHY2P1_3_P1_BASE + 0x5B)
#define REG_PHY2P1_3_P1_2E_L        (REG_PHY2P1_3_P1_BASE + 0x5C)
#define REG_PHY2P1_3_P1_2E_H        (REG_PHY2P1_3_P1_BASE + 0x5D)
#define REG_PHY2P1_3_P1_2F_L        (REG_PHY2P1_3_P1_BASE + 0x5E)
#define REG_PHY2P1_3_P1_2F_H        (REG_PHY2P1_3_P1_BASE + 0x5F)
#define REG_PHY2P1_3_P1_30_L        (REG_PHY2P1_3_P1_BASE + 0x60)
#define REG_PHY2P1_3_P1_30_H        (REG_PHY2P1_3_P1_BASE + 0x61)
#define REG_PHY2P1_3_P1_31_L        (REG_PHY2P1_3_P1_BASE + 0x62)
#define REG_PHY2P1_3_P1_31_H        (REG_PHY2P1_3_P1_BASE + 0x63)
#define REG_PHY2P1_3_P1_32_L        (REG_PHY2P1_3_P1_BASE + 0x64)
#define REG_PHY2P1_3_P1_32_H        (REG_PHY2P1_3_P1_BASE + 0x65)
#define REG_PHY2P1_3_P1_33_L        (REG_PHY2P1_3_P1_BASE + 0x66)
#define REG_PHY2P1_3_P1_33_H        (REG_PHY2P1_3_P1_BASE + 0x67)
#define REG_PHY2P1_3_P1_34_L        (REG_PHY2P1_3_P1_BASE + 0x68)
#define REG_PHY2P1_3_P1_34_H        (REG_PHY2P1_3_P1_BASE + 0x69)
#define REG_PHY2P1_3_P1_35_L        (REG_PHY2P1_3_P1_BASE + 0x6A)
#define REG_PHY2P1_3_P1_35_H        (REG_PHY2P1_3_P1_BASE + 0x6B)
#define REG_PHY2P1_3_P1_36_L        (REG_PHY2P1_3_P1_BASE + 0x6C)
#define REG_PHY2P1_3_P1_36_H        (REG_PHY2P1_3_P1_BASE + 0x6D)
#define REG_PHY2P1_3_P1_37_L        (REG_PHY2P1_3_P1_BASE + 0x6E)
#define REG_PHY2P1_3_P1_37_H        (REG_PHY2P1_3_P1_BASE + 0x6F)
#define REG_PHY2P1_3_P1_38_L        (REG_PHY2P1_3_P1_BASE + 0x70)
#define REG_PHY2P1_3_P1_38_H        (REG_PHY2P1_3_P1_BASE + 0x71)
#define REG_PHY2P1_3_P1_39_L        (REG_PHY2P1_3_P1_BASE + 0x72)
#define REG_PHY2P1_3_P1_39_H        (REG_PHY2P1_3_P1_BASE + 0x73)
#define REG_PHY2P1_3_P1_3A_L        (REG_PHY2P1_3_P1_BASE + 0x74)
#define REG_PHY2P1_3_P1_3A_H        (REG_PHY2P1_3_P1_BASE + 0x75)
#define REG_PHY2P1_3_P1_3B_L        (REG_PHY2P1_3_P1_BASE + 0x76)
#define REG_PHY2P1_3_P1_3B_H        (REG_PHY2P1_3_P1_BASE + 0x77)
#define REG_PHY2P1_3_P1_3C_L        (REG_PHY2P1_3_P1_BASE + 0x78)
#define REG_PHY2P1_3_P1_3C_H        (REG_PHY2P1_3_P1_BASE + 0x79)
#define REG_PHY2P1_3_P1_3D_L        (REG_PHY2P1_3_P1_BASE + 0x7A)
#define REG_PHY2P1_3_P1_3D_H        (REG_PHY2P1_3_P1_BASE + 0x7B)
#define REG_PHY2P1_3_P1_3E_L        (REG_PHY2P1_3_P1_BASE + 0x7C)
#define REG_PHY2P1_3_P1_3E_H        (REG_PHY2P1_3_P1_BASE + 0x7D)
#define REG_PHY2P1_3_P1_3F_L        (REG_PHY2P1_3_P1_BASE + 0x7E)
#define REG_PHY2P1_3_P1_3F_H        (REG_PHY2P1_3_P1_BASE + 0x7F)
#define REG_PHY2P1_3_P1_40_L        (REG_PHY2P1_3_P1_BASE + 0x80)
#define REG_PHY2P1_3_P1_40_H        (REG_PHY2P1_3_P1_BASE + 0x81)
#define REG_PHY2P1_3_P1_41_L        (REG_PHY2P1_3_P1_BASE + 0x82)
#define REG_PHY2P1_3_P1_41_H        (REG_PHY2P1_3_P1_BASE + 0x83)
#define REG_PHY2P1_3_P1_42_L        (REG_PHY2P1_3_P1_BASE + 0x84)
#define REG_PHY2P1_3_P1_42_H        (REG_PHY2P1_3_P1_BASE + 0x85)
#define REG_PHY2P1_3_P1_43_L        (REG_PHY2P1_3_P1_BASE + 0x86)
#define REG_PHY2P1_3_P1_43_H        (REG_PHY2P1_3_P1_BASE + 0x87)
#define REG_PHY2P1_3_P1_44_L        (REG_PHY2P1_3_P1_BASE + 0x88)
#define REG_PHY2P1_3_P1_44_H        (REG_PHY2P1_3_P1_BASE + 0x89)
#define REG_PHY2P1_3_P1_45_L        (REG_PHY2P1_3_P1_BASE + 0x8A)
#define REG_PHY2P1_3_P1_45_H        (REG_PHY2P1_3_P1_BASE + 0x8B)
#define REG_PHY2P1_3_P1_46_L        (REG_PHY2P1_3_P1_BASE + 0x8C)
#define REG_PHY2P1_3_P1_46_H        (REG_PHY2P1_3_P1_BASE + 0x8D)
#define REG_PHY2P1_3_P1_47_L        (REG_PHY2P1_3_P1_BASE + 0x8E)
#define REG_PHY2P1_3_P1_47_H        (REG_PHY2P1_3_P1_BASE + 0x8F)
#define REG_PHY2P1_3_P1_48_L        (REG_PHY2P1_3_P1_BASE + 0x90)
#define REG_PHY2P1_3_P1_48_H        (REG_PHY2P1_3_P1_BASE + 0x91)
#define REG_PHY2P1_3_P1_49_L        (REG_PHY2P1_3_P1_BASE + 0x92)
#define REG_PHY2P1_3_P1_49_H        (REG_PHY2P1_3_P1_BASE + 0x93)
#define REG_PHY2P1_3_P1_4A_L        (REG_PHY2P1_3_P1_BASE + 0x94)
#define REG_PHY2P1_3_P1_4A_H        (REG_PHY2P1_3_P1_BASE + 0x95)
#define REG_PHY2P1_3_P1_4B_L        (REG_PHY2P1_3_P1_BASE + 0x96)
#define REG_PHY2P1_3_P1_4B_H        (REG_PHY2P1_3_P1_BASE + 0x97)
#define REG_PHY2P1_3_P1_4C_L        (REG_PHY2P1_3_P1_BASE + 0x98)
#define REG_PHY2P1_3_P1_4C_H        (REG_PHY2P1_3_P1_BASE + 0x99)
#define REG_PHY2P1_3_P1_4D_L        (REG_PHY2P1_3_P1_BASE + 0x9A)
#define REG_PHY2P1_3_P1_4D_H        (REG_PHY2P1_3_P1_BASE + 0x9B)
#define REG_PHY2P1_3_P1_4E_L        (REG_PHY2P1_3_P1_BASE + 0x9C)
#define REG_PHY2P1_3_P1_4E_H        (REG_PHY2P1_3_P1_BASE + 0x9D)
#define REG_PHY2P1_3_P1_4F_L        (REG_PHY2P1_3_P1_BASE + 0x9E)
#define REG_PHY2P1_3_P1_4F_H        (REG_PHY2P1_3_P1_BASE + 0x9F)
#define REG_PHY2P1_3_P1_50_L        (REG_PHY2P1_3_P1_BASE + 0xA0)
#define REG_PHY2P1_3_P1_50_H        (REG_PHY2P1_3_P1_BASE + 0xA1)
#define REG_PHY2P1_3_P1_51_L        (REG_PHY2P1_3_P1_BASE + 0xA2)
#define REG_PHY2P1_3_P1_51_H        (REG_PHY2P1_3_P1_BASE + 0xA3)
#define REG_PHY2P1_3_P1_52_L        (REG_PHY2P1_3_P1_BASE + 0xA4)
#define REG_PHY2P1_3_P1_52_H        (REG_PHY2P1_3_P1_BASE + 0xA5)
#define REG_PHY2P1_3_P1_53_L        (REG_PHY2P1_3_P1_BASE + 0xA6)
#define REG_PHY2P1_3_P1_53_H        (REG_PHY2P1_3_P1_BASE + 0xA7)
#define REG_PHY2P1_3_P1_54_L        (REG_PHY2P1_3_P1_BASE + 0xA8)
#define REG_PHY2P1_3_P1_54_H        (REG_PHY2P1_3_P1_BASE + 0xA9)
#define REG_PHY2P1_3_P1_55_L        (REG_PHY2P1_3_P1_BASE + 0xAA)
#define REG_PHY2P1_3_P1_55_H        (REG_PHY2P1_3_P1_BASE + 0xAB)
#define REG_PHY2P1_3_P1_56_L        (REG_PHY2P1_3_P1_BASE + 0xAC)
#define REG_PHY2P1_3_P1_56_H        (REG_PHY2P1_3_P1_BASE + 0xAD)
#define REG_PHY2P1_3_P1_57_L        (REG_PHY2P1_3_P1_BASE + 0xAE)
#define REG_PHY2P1_3_P1_57_H        (REG_PHY2P1_3_P1_BASE + 0xAF)
#define REG_PHY2P1_3_P1_58_L        (REG_PHY2P1_3_P1_BASE + 0xB0)
#define REG_PHY2P1_3_P1_58_H        (REG_PHY2P1_3_P1_BASE + 0xB1)
#define REG_PHY2P1_3_P1_59_L        (REG_PHY2P1_3_P1_BASE + 0xB2)
#define REG_PHY2P1_3_P1_59_H        (REG_PHY2P1_3_P1_BASE + 0xB3)
#define REG_PHY2P1_3_P1_5A_L        (REG_PHY2P1_3_P1_BASE + 0xB4)
#define REG_PHY2P1_3_P1_5A_H        (REG_PHY2P1_3_P1_BASE + 0xB5)
#define REG_PHY2P1_3_P1_5B_L        (REG_PHY2P1_3_P1_BASE + 0xB6)
#define REG_PHY2P1_3_P1_5B_H        (REG_PHY2P1_3_P1_BASE + 0xB7)
#define REG_PHY2P1_3_P1_5C_L        (REG_PHY2P1_3_P1_BASE + 0xB8)
#define REG_PHY2P1_3_P1_5C_H        (REG_PHY2P1_3_P1_BASE + 0xB9)
#define REG_PHY2P1_3_P1_5D_L        (REG_PHY2P1_3_P1_BASE + 0xBA)
#define REG_PHY2P1_3_P1_5D_H        (REG_PHY2P1_3_P1_BASE + 0xBB)
#define REG_PHY2P1_3_P1_5E_L        (REG_PHY2P1_3_P1_BASE + 0xBC)
#define REG_PHY2P1_3_P1_5E_H        (REG_PHY2P1_3_P1_BASE + 0xBD)
#define REG_PHY2P1_3_P1_5F_L        (REG_PHY2P1_3_P1_BASE + 0xBE)
#define REG_PHY2P1_3_P1_5F_H        (REG_PHY2P1_3_P1_BASE + 0xBF)
#define REG_PHY2P1_3_P1_60_L        (REG_PHY2P1_3_P1_BASE + 0xC0)
#define REG_PHY2P1_3_P1_60_H        (REG_PHY2P1_3_P1_BASE + 0xC1)
#define REG_PHY2P1_3_P1_61_L        (REG_PHY2P1_3_P1_BASE + 0xC2)
#define REG_PHY2P1_3_P1_61_H        (REG_PHY2P1_3_P1_BASE + 0xC3)
#define REG_PHY2P1_3_P1_62_L        (REG_PHY2P1_3_P1_BASE + 0xC4)
#define REG_PHY2P1_3_P1_62_H        (REG_PHY2P1_3_P1_BASE + 0xC5)
#define REG_PHY2P1_3_P1_63_L        (REG_PHY2P1_3_P1_BASE + 0xC6)
#define REG_PHY2P1_3_P1_63_H        (REG_PHY2P1_3_P1_BASE + 0xC7)
#define REG_PHY2P1_3_P1_64_L        (REG_PHY2P1_3_P1_BASE + 0xC8)
#define REG_PHY2P1_3_P1_64_H        (REG_PHY2P1_3_P1_BASE + 0xC9)
#define REG_PHY2P1_3_P1_65_L        (REG_PHY2P1_3_P1_BASE + 0xCA)
#define REG_PHY2P1_3_P1_65_H        (REG_PHY2P1_3_P1_BASE + 0xCB)
#define REG_PHY2P1_3_P1_66_L        (REG_PHY2P1_3_P1_BASE + 0xCC)
#define REG_PHY2P1_3_P1_66_H        (REG_PHY2P1_3_P1_BASE + 0xCD)
#define REG_PHY2P1_3_P1_67_L        (REG_PHY2P1_3_P1_BASE + 0xCE)
#define REG_PHY2P1_3_P1_67_H        (REG_PHY2P1_3_P1_BASE + 0xCF)
#define REG_PHY2P1_3_P1_68_L        (REG_PHY2P1_3_P1_BASE + 0xD0)
#define REG_PHY2P1_3_P1_68_H        (REG_PHY2P1_3_P1_BASE + 0xD1)
#define REG_PHY2P1_3_P1_69_L        (REG_PHY2P1_3_P1_BASE + 0xD2)
#define REG_PHY2P1_3_P1_69_H        (REG_PHY2P1_3_P1_BASE + 0xD3)
#define REG_PHY2P1_3_P1_6A_L        (REG_PHY2P1_3_P1_BASE + 0xD4)
#define REG_PHY2P1_3_P1_6A_H        (REG_PHY2P1_3_P1_BASE + 0xD5)
#define REG_PHY2P1_3_P1_6B_L        (REG_PHY2P1_3_P1_BASE + 0xD6)
#define REG_PHY2P1_3_P1_6B_H        (REG_PHY2P1_3_P1_BASE + 0xD7)
#define REG_PHY2P1_3_P1_6C_L        (REG_PHY2P1_3_P1_BASE + 0xD8)
#define REG_PHY2P1_3_P1_6C_H        (REG_PHY2P1_3_P1_BASE + 0xD9)
#define REG_PHY2P1_3_P1_6D_L        (REG_PHY2P1_3_P1_BASE + 0xDA)
#define REG_PHY2P1_3_P1_6D_H        (REG_PHY2P1_3_P1_BASE + 0xDB)
#define REG_PHY2P1_3_P1_6E_L        (REG_PHY2P1_3_P1_BASE + 0xDC)
#define REG_PHY2P1_3_P1_6E_H        (REG_PHY2P1_3_P1_BASE + 0xDD)
#define REG_PHY2P1_3_P1_6F_L        (REG_PHY2P1_3_P1_BASE + 0xDE)
#define REG_PHY2P1_3_P1_6F_H        (REG_PHY2P1_3_P1_BASE + 0xDF)
#define REG_PHY2P1_3_P1_70_L        (REG_PHY2P1_3_P1_BASE + 0xE0)
#define REG_PHY2P1_3_P1_70_H        (REG_PHY2P1_3_P1_BASE + 0xE1)
#define REG_PHY2P1_3_P1_71_L        (REG_PHY2P1_3_P1_BASE + 0xE2)
#define REG_PHY2P1_3_P1_71_H        (REG_PHY2P1_3_P1_BASE + 0xE3)
#define REG_PHY2P1_3_P1_72_L        (REG_PHY2P1_3_P1_BASE + 0xE4)
#define REG_PHY2P1_3_P1_72_H        (REG_PHY2P1_3_P1_BASE + 0xE5)
#define REG_PHY2P1_3_P1_73_L        (REG_PHY2P1_3_P1_BASE + 0xE6)
#define REG_PHY2P1_3_P1_73_H        (REG_PHY2P1_3_P1_BASE + 0xE7)
#define REG_PHY2P1_3_P1_74_L        (REG_PHY2P1_3_P1_BASE + 0xE8)
#define REG_PHY2P1_3_P1_74_H        (REG_PHY2P1_3_P1_BASE + 0xE9)
#define REG_PHY2P1_3_P1_75_L        (REG_PHY2P1_3_P1_BASE + 0xEA)
#define REG_PHY2P1_3_P1_75_H        (REG_PHY2P1_3_P1_BASE + 0xEB)
#define REG_PHY2P1_3_P1_76_L        (REG_PHY2P1_3_P1_BASE + 0xEC)
#define REG_PHY2P1_3_P1_76_H        (REG_PHY2P1_3_P1_BASE + 0xED)
#define REG_PHY2P1_3_P1_77_L        (REG_PHY2P1_3_P1_BASE + 0xEE)
#define REG_PHY2P1_3_P1_77_H        (REG_PHY2P1_3_P1_BASE + 0xEF)
#define REG_PHY2P1_3_P1_78_L        (REG_PHY2P1_3_P1_BASE + 0xF0)
#define REG_PHY2P1_3_P1_78_H        (REG_PHY2P1_3_P1_BASE + 0xF1)
#define REG_PHY2P1_3_P1_79_L        (REG_PHY2P1_3_P1_BASE + 0xF2)
#define REG_PHY2P1_3_P1_79_H        (REG_PHY2P1_3_P1_BASE + 0xF3)
#define REG_PHY2P1_3_P1_7A_L        (REG_PHY2P1_3_P1_BASE + 0xF4)
#define REG_PHY2P1_3_P1_7A_H        (REG_PHY2P1_3_P1_BASE + 0xF5)
#define REG_PHY2P1_3_P1_7B_L        (REG_PHY2P1_3_P1_BASE + 0xF6)
#define REG_PHY2P1_3_P1_7B_H        (REG_PHY2P1_3_P1_BASE + 0xF7)
#define REG_PHY2P1_3_P1_7C_L        (REG_PHY2P1_3_P1_BASE + 0xF8)
#define REG_PHY2P1_3_P1_7C_H        (REG_PHY2P1_3_P1_BASE + 0xF9)
#define REG_PHY2P1_3_P1_7D_L        (REG_PHY2P1_3_P1_BASE + 0xFA)
#define REG_PHY2P1_3_P1_7D_H        (REG_PHY2P1_3_P1_BASE + 0xFB)
#define REG_PHY2P1_3_P1_7E_L        (REG_PHY2P1_3_P1_BASE + 0xFC)
#define REG_PHY2P1_3_P1_7E_H        (REG_PHY2P1_3_P1_BASE + 0xFD)
#define REG_PHY2P1_3_P1_7F_L        (REG_PHY2P1_3_P1_BASE + 0xFE)
#define REG_PHY2P1_3_P1_7F_H        (REG_PHY2P1_3_P1_BASE + 0xFF)

//=============================================================
// PHY2P1_4_P1
#define REG_PHY2P1_4_P1_00_L        (REG_PHY2P1_4_P1_BASE + 0x00)
#define REG_PHY2P1_4_P1_00_H        (REG_PHY2P1_4_P1_BASE + 0x01)
#define REG_PHY2P1_4_P1_01_L        (REG_PHY2P1_4_P1_BASE + 0x02)
#define REG_PHY2P1_4_P1_01_H        (REG_PHY2P1_4_P1_BASE + 0x03)
#define REG_PHY2P1_4_P1_02_L        (REG_PHY2P1_4_P1_BASE + 0x04)
#define REG_PHY2P1_4_P1_02_H        (REG_PHY2P1_4_P1_BASE + 0x05)
#define REG_PHY2P1_4_P1_03_L        (REG_PHY2P1_4_P1_BASE + 0x06)
#define REG_PHY2P1_4_P1_03_H        (REG_PHY2P1_4_P1_BASE + 0x07)
#define REG_PHY2P1_4_P1_04_L        (REG_PHY2P1_4_P1_BASE + 0x08)
#define REG_PHY2P1_4_P1_04_H        (REG_PHY2P1_4_P1_BASE + 0x09)
#define REG_PHY2P1_4_P1_05_L        (REG_PHY2P1_4_P1_BASE + 0x0A)
#define REG_PHY2P1_4_P1_05_H        (REG_PHY2P1_4_P1_BASE + 0x0B)
#define REG_PHY2P1_4_P1_06_L        (REG_PHY2P1_4_P1_BASE + 0x0C)
#define REG_PHY2P1_4_P1_06_H        (REG_PHY2P1_4_P1_BASE + 0x0D)
#define REG_PHY2P1_4_P1_07_L        (REG_PHY2P1_4_P1_BASE + 0x0E)
#define REG_PHY2P1_4_P1_07_H        (REG_PHY2P1_4_P1_BASE + 0x0F)
#define REG_PHY2P1_4_P1_08_L        (REG_PHY2P1_4_P1_BASE + 0x10)
#define REG_PHY2P1_4_P1_08_H        (REG_PHY2P1_4_P1_BASE + 0x11)
#define REG_PHY2P1_4_P1_09_L        (REG_PHY2P1_4_P1_BASE + 0x12)
#define REG_PHY2P1_4_P1_09_H        (REG_PHY2P1_4_P1_BASE + 0x13)
#define REG_PHY2P1_4_P1_0A_L        (REG_PHY2P1_4_P1_BASE + 0x14)
#define REG_PHY2P1_4_P1_0A_H        (REG_PHY2P1_4_P1_BASE + 0x15)
#define REG_PHY2P1_4_P1_0B_L        (REG_PHY2P1_4_P1_BASE + 0x16)
#define REG_PHY2P1_4_P1_0B_H        (REG_PHY2P1_4_P1_BASE + 0x17)
#define REG_PHY2P1_4_P1_0C_L        (REG_PHY2P1_4_P1_BASE + 0x18)
#define REG_PHY2P1_4_P1_0C_H        (REG_PHY2P1_4_P1_BASE + 0x19)
#define REG_PHY2P1_4_P1_0D_L        (REG_PHY2P1_4_P1_BASE + 0x1A)
#define REG_PHY2P1_4_P1_0D_H        (REG_PHY2P1_4_P1_BASE + 0x1B)
#define REG_PHY2P1_4_P1_0E_L        (REG_PHY2P1_4_P1_BASE + 0x1C)
#define REG_PHY2P1_4_P1_0E_H        (REG_PHY2P1_4_P1_BASE + 0x1D)
#define REG_PHY2P1_4_P1_0F_L        (REG_PHY2P1_4_P1_BASE + 0x1E)
#define REG_PHY2P1_4_P1_0F_H        (REG_PHY2P1_4_P1_BASE + 0x1F)
#define REG_PHY2P1_4_P1_10_L        (REG_PHY2P1_4_P1_BASE + 0x20)
#define REG_PHY2P1_4_P1_10_H        (REG_PHY2P1_4_P1_BASE + 0x21)
#define REG_PHY2P1_4_P1_11_L        (REG_PHY2P1_4_P1_BASE + 0x22)
#define REG_PHY2P1_4_P1_11_H        (REG_PHY2P1_4_P1_BASE + 0x23)
#define REG_PHY2P1_4_P1_12_L        (REG_PHY2P1_4_P1_BASE + 0x24)
#define REG_PHY2P1_4_P1_12_H        (REG_PHY2P1_4_P1_BASE + 0x25)
#define REG_PHY2P1_4_P1_13_L        (REG_PHY2P1_4_P1_BASE + 0x26)
#define REG_PHY2P1_4_P1_13_H        (REG_PHY2P1_4_P1_BASE + 0x27)
#define REG_PHY2P1_4_P1_14_L        (REG_PHY2P1_4_P1_BASE + 0x28)
#define REG_PHY2P1_4_P1_14_H        (REG_PHY2P1_4_P1_BASE + 0x29)
#define REG_PHY2P1_4_P1_15_L        (REG_PHY2P1_4_P1_BASE + 0x2A)
#define REG_PHY2P1_4_P1_15_H        (REG_PHY2P1_4_P1_BASE + 0x2B)
#define REG_PHY2P1_4_P1_16_L        (REG_PHY2P1_4_P1_BASE + 0x2C)
#define REG_PHY2P1_4_P1_16_H        (REG_PHY2P1_4_P1_BASE + 0x2D)
#define REG_PHY2P1_4_P1_17_L        (REG_PHY2P1_4_P1_BASE + 0x2E)
#define REG_PHY2P1_4_P1_17_H        (REG_PHY2P1_4_P1_BASE + 0x2F)
#define REG_PHY2P1_4_P1_18_L        (REG_PHY2P1_4_P1_BASE + 0x30)
#define REG_PHY2P1_4_P1_18_H        (REG_PHY2P1_4_P1_BASE + 0x31)
#define REG_PHY2P1_4_P1_19_L        (REG_PHY2P1_4_P1_BASE + 0x32)
#define REG_PHY2P1_4_P1_19_H        (REG_PHY2P1_4_P1_BASE + 0x33)
#define REG_PHY2P1_4_P1_1A_L        (REG_PHY2P1_4_P1_BASE + 0x34)
#define REG_PHY2P1_4_P1_1A_H        (REG_PHY2P1_4_P1_BASE + 0x35)
#define REG_PHY2P1_4_P1_1B_L        (REG_PHY2P1_4_P1_BASE + 0x36)
#define REG_PHY2P1_4_P1_1B_H        (REG_PHY2P1_4_P1_BASE + 0x37)
#define REG_PHY2P1_4_P1_1C_L        (REG_PHY2P1_4_P1_BASE + 0x38)
#define REG_PHY2P1_4_P1_1C_H        (REG_PHY2P1_4_P1_BASE + 0x39)
#define REG_PHY2P1_4_P1_1D_L        (REG_PHY2P1_4_P1_BASE + 0x3A)
#define REG_PHY2P1_4_P1_1D_H        (REG_PHY2P1_4_P1_BASE + 0x3B)
#define REG_PHY2P1_4_P1_1E_L        (REG_PHY2P1_4_P1_BASE + 0x3C)
#define REG_PHY2P1_4_P1_1E_H        (REG_PHY2P1_4_P1_BASE + 0x3D)
#define REG_PHY2P1_4_P1_1F_L        (REG_PHY2P1_4_P1_BASE + 0x3E)
#define REG_PHY2P1_4_P1_1F_H        (REG_PHY2P1_4_P1_BASE + 0x3F)
#define REG_PHY2P1_4_P1_20_L        (REG_PHY2P1_4_P1_BASE + 0x40)
#define REG_PHY2P1_4_P1_20_H        (REG_PHY2P1_4_P1_BASE + 0x41)
#define REG_PHY2P1_4_P1_21_L        (REG_PHY2P1_4_P1_BASE + 0x42)
#define REG_PHY2P1_4_P1_21_H        (REG_PHY2P1_4_P1_BASE + 0x43)
#define REG_PHY2P1_4_P1_22_L        (REG_PHY2P1_4_P1_BASE + 0x44)
#define REG_PHY2P1_4_P1_22_H        (REG_PHY2P1_4_P1_BASE + 0x45)
#define REG_PHY2P1_4_P1_23_L        (REG_PHY2P1_4_P1_BASE + 0x46)
#define REG_PHY2P1_4_P1_23_H        (REG_PHY2P1_4_P1_BASE + 0x47)
#define REG_PHY2P1_4_P1_24_L        (REG_PHY2P1_4_P1_BASE + 0x48)
#define REG_PHY2P1_4_P1_24_H        (REG_PHY2P1_4_P1_BASE + 0x49)
#define REG_PHY2P1_4_P1_25_L        (REG_PHY2P1_4_P1_BASE + 0x4A)
#define REG_PHY2P1_4_P1_25_H        (REG_PHY2P1_4_P1_BASE + 0x4B)
#define REG_PHY2P1_4_P1_26_L        (REG_PHY2P1_4_P1_BASE + 0x4C)
#define REG_PHY2P1_4_P1_26_H        (REG_PHY2P1_4_P1_BASE + 0x4D)
#define REG_PHY2P1_4_P1_27_L        (REG_PHY2P1_4_P1_BASE + 0x4E)
#define REG_PHY2P1_4_P1_27_H        (REG_PHY2P1_4_P1_BASE + 0x4F)
#define REG_PHY2P1_4_P1_28_L        (REG_PHY2P1_4_P1_BASE + 0x50)
#define REG_PHY2P1_4_P1_28_H        (REG_PHY2P1_4_P1_BASE + 0x51)
#define REG_PHY2P1_4_P1_29_L        (REG_PHY2P1_4_P1_BASE + 0x52)
#define REG_PHY2P1_4_P1_29_H        (REG_PHY2P1_4_P1_BASE + 0x53)
#define REG_PHY2P1_4_P1_2A_L        (REG_PHY2P1_4_P1_BASE + 0x54)
#define REG_PHY2P1_4_P1_2A_H        (REG_PHY2P1_4_P1_BASE + 0x55)
#define REG_PHY2P1_4_P1_2B_L        (REG_PHY2P1_4_P1_BASE + 0x56)
#define REG_PHY2P1_4_P1_2B_H        (REG_PHY2P1_4_P1_BASE + 0x57)
#define REG_PHY2P1_4_P1_2C_L        (REG_PHY2P1_4_P1_BASE + 0x58)
#define REG_PHY2P1_4_P1_2C_H        (REG_PHY2P1_4_P1_BASE + 0x59)
#define REG_PHY2P1_4_P1_2D_L        (REG_PHY2P1_4_P1_BASE + 0x5A)
#define REG_PHY2P1_4_P1_2D_H        (REG_PHY2P1_4_P1_BASE + 0x5B)
#define REG_PHY2P1_4_P1_2E_L        (REG_PHY2P1_4_P1_BASE + 0x5C)
#define REG_PHY2P1_4_P1_2E_H        (REG_PHY2P1_4_P1_BASE + 0x5D)
#define REG_PHY2P1_4_P1_2F_L        (REG_PHY2P1_4_P1_BASE + 0x5E)
#define REG_PHY2P1_4_P1_2F_H        (REG_PHY2P1_4_P1_BASE + 0x5F)
#define REG_PHY2P1_4_P1_30_L        (REG_PHY2P1_4_P1_BASE + 0x60)
#define REG_PHY2P1_4_P1_30_H        (REG_PHY2P1_4_P1_BASE + 0x61)
#define REG_PHY2P1_4_P1_31_L        (REG_PHY2P1_4_P1_BASE + 0x62)
#define REG_PHY2P1_4_P1_31_H        (REG_PHY2P1_4_P1_BASE + 0x63)
#define REG_PHY2P1_4_P1_32_L        (REG_PHY2P1_4_P1_BASE + 0x64)
#define REG_PHY2P1_4_P1_32_H        (REG_PHY2P1_4_P1_BASE + 0x65)
#define REG_PHY2P1_4_P1_33_L        (REG_PHY2P1_4_P1_BASE + 0x66)
#define REG_PHY2P1_4_P1_33_H        (REG_PHY2P1_4_P1_BASE + 0x67)
#define REG_PHY2P1_4_P1_34_L        (REG_PHY2P1_4_P1_BASE + 0x68)
#define REG_PHY2P1_4_P1_34_H        (REG_PHY2P1_4_P1_BASE + 0x69)
#define REG_PHY2P1_4_P1_35_L        (REG_PHY2P1_4_P1_BASE + 0x6A)
#define REG_PHY2P1_4_P1_35_H        (REG_PHY2P1_4_P1_BASE + 0x6B)
#define REG_PHY2P1_4_P1_36_L        (REG_PHY2P1_4_P1_BASE + 0x6C)
#define REG_PHY2P1_4_P1_36_H        (REG_PHY2P1_4_P1_BASE + 0x6D)
#define REG_PHY2P1_4_P1_37_L        (REG_PHY2P1_4_P1_BASE + 0x6E)
#define REG_PHY2P1_4_P1_37_H        (REG_PHY2P1_4_P1_BASE + 0x6F)
#define REG_PHY2P1_4_P1_38_L        (REG_PHY2P1_4_P1_BASE + 0x70)
#define REG_PHY2P1_4_P1_38_H        (REG_PHY2P1_4_P1_BASE + 0x71)
#define REG_PHY2P1_4_P1_39_L        (REG_PHY2P1_4_P1_BASE + 0x72)
#define REG_PHY2P1_4_P1_39_H        (REG_PHY2P1_4_P1_BASE + 0x73)
#define REG_PHY2P1_4_P1_3A_L        (REG_PHY2P1_4_P1_BASE + 0x74)
#define REG_PHY2P1_4_P1_3A_H        (REG_PHY2P1_4_P1_BASE + 0x75)
#define REG_PHY2P1_4_P1_3B_L        (REG_PHY2P1_4_P1_BASE + 0x76)
#define REG_PHY2P1_4_P1_3B_H        (REG_PHY2P1_4_P1_BASE + 0x77)
#define REG_PHY2P1_4_P1_3C_L        (REG_PHY2P1_4_P1_BASE + 0x78)
#define REG_PHY2P1_4_P1_3C_H        (REG_PHY2P1_4_P1_BASE + 0x79)
#define REG_PHY2P1_4_P1_3D_L        (REG_PHY2P1_4_P1_BASE + 0x7A)
#define REG_PHY2P1_4_P1_3D_H        (REG_PHY2P1_4_P1_BASE + 0x7B)
#define REG_PHY2P1_4_P1_3E_L        (REG_PHY2P1_4_P1_BASE + 0x7C)
#define REG_PHY2P1_4_P1_3E_H        (REG_PHY2P1_4_P1_BASE + 0x7D)
#define REG_PHY2P1_4_P1_3F_L        (REG_PHY2P1_4_P1_BASE + 0x7E)
#define REG_PHY2P1_4_P1_3F_H        (REG_PHY2P1_4_P1_BASE + 0x7F)
#define REG_PHY2P1_4_P1_40_L        (REG_PHY2P1_4_P1_BASE + 0x80)
#define REG_PHY2P1_4_P1_40_H        (REG_PHY2P1_4_P1_BASE + 0x81)
#define REG_PHY2P1_4_P1_41_L        (REG_PHY2P1_4_P1_BASE + 0x82)
#define REG_PHY2P1_4_P1_41_H        (REG_PHY2P1_4_P1_BASE + 0x83)
#define REG_PHY2P1_4_P1_42_L        (REG_PHY2P1_4_P1_BASE + 0x84)
#define REG_PHY2P1_4_P1_42_H        (REG_PHY2P1_4_P1_BASE + 0x85)
#define REG_PHY2P1_4_P1_43_L        (REG_PHY2P1_4_P1_BASE + 0x86)
#define REG_PHY2P1_4_P1_43_H        (REG_PHY2P1_4_P1_BASE + 0x87)
#define REG_PHY2P1_4_P1_44_L        (REG_PHY2P1_4_P1_BASE + 0x88)
#define REG_PHY2P1_4_P1_44_H        (REG_PHY2P1_4_P1_BASE + 0x89)
#define REG_PHY2P1_4_P1_45_L        (REG_PHY2P1_4_P1_BASE + 0x8A)
#define REG_PHY2P1_4_P1_45_H        (REG_PHY2P1_4_P1_BASE + 0x8B)
#define REG_PHY2P1_4_P1_46_L        (REG_PHY2P1_4_P1_BASE + 0x8C)
#define REG_PHY2P1_4_P1_46_H        (REG_PHY2P1_4_P1_BASE + 0x8D)
#define REG_PHY2P1_4_P1_47_L        (REG_PHY2P1_4_P1_BASE + 0x8E)
#define REG_PHY2P1_4_P1_47_H        (REG_PHY2P1_4_P1_BASE + 0x8F)
#define REG_PHY2P1_4_P1_48_L        (REG_PHY2P1_4_P1_BASE + 0x90)
#define REG_PHY2P1_4_P1_48_H        (REG_PHY2P1_4_P1_BASE + 0x91)
#define REG_PHY2P1_4_P1_49_L        (REG_PHY2P1_4_P1_BASE + 0x92)
#define REG_PHY2P1_4_P1_49_H        (REG_PHY2P1_4_P1_BASE + 0x93)
#define REG_PHY2P1_4_P1_4A_L        (REG_PHY2P1_4_P1_BASE + 0x94)
#define REG_PHY2P1_4_P1_4A_H        (REG_PHY2P1_4_P1_BASE + 0x95)
#define REG_PHY2P1_4_P1_4B_L        (REG_PHY2P1_4_P1_BASE + 0x96)
#define REG_PHY2P1_4_P1_4B_H        (REG_PHY2P1_4_P1_BASE + 0x97)
#define REG_PHY2P1_4_P1_4C_L        (REG_PHY2P1_4_P1_BASE + 0x98)
#define REG_PHY2P1_4_P1_4C_H        (REG_PHY2P1_4_P1_BASE + 0x99)
#define REG_PHY2P1_4_P1_4D_L        (REG_PHY2P1_4_P1_BASE + 0x9A)
#define REG_PHY2P1_4_P1_4D_H        (REG_PHY2P1_4_P1_BASE + 0x9B)
#define REG_PHY2P1_4_P1_4E_L        (REG_PHY2P1_4_P1_BASE + 0x9C)
#define REG_PHY2P1_4_P1_4E_H        (REG_PHY2P1_4_P1_BASE + 0x9D)
#define REG_PHY2P1_4_P1_4F_L        (REG_PHY2P1_4_P1_BASE + 0x9E)
#define REG_PHY2P1_4_P1_4F_H        (REG_PHY2P1_4_P1_BASE + 0x9F)
#define REG_PHY2P1_4_P1_50_L        (REG_PHY2P1_4_P1_BASE + 0xA0)
#define REG_PHY2P1_4_P1_50_H        (REG_PHY2P1_4_P1_BASE + 0xA1)
#define REG_PHY2P1_4_P1_51_L        (REG_PHY2P1_4_P1_BASE + 0xA2)
#define REG_PHY2P1_4_P1_51_H        (REG_PHY2P1_4_P1_BASE + 0xA3)
#define REG_PHY2P1_4_P1_52_L        (REG_PHY2P1_4_P1_BASE + 0xA4)
#define REG_PHY2P1_4_P1_52_H        (REG_PHY2P1_4_P1_BASE + 0xA5)
#define REG_PHY2P1_4_P1_53_L        (REG_PHY2P1_4_P1_BASE + 0xA6)
#define REG_PHY2P1_4_P1_53_H        (REG_PHY2P1_4_P1_BASE + 0xA7)
#define REG_PHY2P1_4_P1_54_L        (REG_PHY2P1_4_P1_BASE + 0xA8)
#define REG_PHY2P1_4_P1_54_H        (REG_PHY2P1_4_P1_BASE + 0xA9)
#define REG_PHY2P1_4_P1_55_L        (REG_PHY2P1_4_P1_BASE + 0xAA)
#define REG_PHY2P1_4_P1_55_H        (REG_PHY2P1_4_P1_BASE + 0xAB)
#define REG_PHY2P1_4_P1_56_L        (REG_PHY2P1_4_P1_BASE + 0xAC)
#define REG_PHY2P1_4_P1_56_H        (REG_PHY2P1_4_P1_BASE + 0xAD)
#define REG_PHY2P1_4_P1_57_L        (REG_PHY2P1_4_P1_BASE + 0xAE)
#define REG_PHY2P1_4_P1_57_H        (REG_PHY2P1_4_P1_BASE + 0xAF)
#define REG_PHY2P1_4_P1_58_L        (REG_PHY2P1_4_P1_BASE + 0xB0)
#define REG_PHY2P1_4_P1_58_H        (REG_PHY2P1_4_P1_BASE + 0xB1)
#define REG_PHY2P1_4_P1_59_L        (REG_PHY2P1_4_P1_BASE + 0xB2)
#define REG_PHY2P1_4_P1_59_H        (REG_PHY2P1_4_P1_BASE + 0xB3)
#define REG_PHY2P1_4_P1_5A_L        (REG_PHY2P1_4_P1_BASE + 0xB4)
#define REG_PHY2P1_4_P1_5A_H        (REG_PHY2P1_4_P1_BASE + 0xB5)
#define REG_PHY2P1_4_P1_5B_L        (REG_PHY2P1_4_P1_BASE + 0xB6)
#define REG_PHY2P1_4_P1_5B_H        (REG_PHY2P1_4_P1_BASE + 0xB7)
#define REG_PHY2P1_4_P1_5C_L        (REG_PHY2P1_4_P1_BASE + 0xB8)
#define REG_PHY2P1_4_P1_5C_H        (REG_PHY2P1_4_P1_BASE + 0xB9)
#define REG_PHY2P1_4_P1_5D_L        (REG_PHY2P1_4_P1_BASE + 0xBA)
#define REG_PHY2P1_4_P1_5D_H        (REG_PHY2P1_4_P1_BASE + 0xBB)
#define REG_PHY2P1_4_P1_5E_L        (REG_PHY2P1_4_P1_BASE + 0xBC)
#define REG_PHY2P1_4_P1_5E_H        (REG_PHY2P1_4_P1_BASE + 0xBD)
#define REG_PHY2P1_4_P1_5F_L        (REG_PHY2P1_4_P1_BASE + 0xBE)
#define REG_PHY2P1_4_P1_5F_H        (REG_PHY2P1_4_P1_BASE + 0xBF)
#define REG_PHY2P1_4_P1_60_L        (REG_PHY2P1_4_P1_BASE + 0xC0)
#define REG_PHY2P1_4_P1_60_H        (REG_PHY2P1_4_P1_BASE + 0xC1)
#define REG_PHY2P1_4_P1_61_L        (REG_PHY2P1_4_P1_BASE + 0xC2)
#define REG_PHY2P1_4_P1_61_H        (REG_PHY2P1_4_P1_BASE + 0xC3)
#define REG_PHY2P1_4_P1_62_L        (REG_PHY2P1_4_P1_BASE + 0xC4)
#define REG_PHY2P1_4_P1_62_H        (REG_PHY2P1_4_P1_BASE + 0xC5)
#define REG_PHY2P1_4_P1_63_L        (REG_PHY2P1_4_P1_BASE + 0xC6)
#define REG_PHY2P1_4_P1_63_H        (REG_PHY2P1_4_P1_BASE + 0xC7)
#define REG_PHY2P1_4_P1_64_L        (REG_PHY2P1_4_P1_BASE + 0xC8)
#define REG_PHY2P1_4_P1_64_H        (REG_PHY2P1_4_P1_BASE + 0xC9)
#define REG_PHY2P1_4_P1_65_L        (REG_PHY2P1_4_P1_BASE + 0xCA)
#define REG_PHY2P1_4_P1_65_H        (REG_PHY2P1_4_P1_BASE + 0xCB)
#define REG_PHY2P1_4_P1_66_L        (REG_PHY2P1_4_P1_BASE + 0xCC)
#define REG_PHY2P1_4_P1_66_H        (REG_PHY2P1_4_P1_BASE + 0xCD)
#define REG_PHY2P1_4_P1_67_L        (REG_PHY2P1_4_P1_BASE + 0xCE)
#define REG_PHY2P1_4_P1_67_H        (REG_PHY2P1_4_P1_BASE + 0xCF)
#define REG_PHY2P1_4_P1_68_L        (REG_PHY2P1_4_P1_BASE + 0xD0)
#define REG_PHY2P1_4_P1_68_H        (REG_PHY2P1_4_P1_BASE + 0xD1)
#define REG_PHY2P1_4_P1_69_L        (REG_PHY2P1_4_P1_BASE + 0xD2)
#define REG_PHY2P1_4_P1_69_H        (REG_PHY2P1_4_P1_BASE + 0xD3)
#define REG_PHY2P1_4_P1_6A_L        (REG_PHY2P1_4_P1_BASE + 0xD4)
#define REG_PHY2P1_4_P1_6A_H        (REG_PHY2P1_4_P1_BASE + 0xD5)
#define REG_PHY2P1_4_P1_6B_L        (REG_PHY2P1_4_P1_BASE + 0xD6)
#define REG_PHY2P1_4_P1_6B_H        (REG_PHY2P1_4_P1_BASE + 0xD7)
#define REG_PHY2P1_4_P1_6C_L        (REG_PHY2P1_4_P1_BASE + 0xD8)
#define REG_PHY2P1_4_P1_6C_H        (REG_PHY2P1_4_P1_BASE + 0xD9)
#define REG_PHY2P1_4_P1_6D_L        (REG_PHY2P1_4_P1_BASE + 0xDA)
#define REG_PHY2P1_4_P1_6D_H        (REG_PHY2P1_4_P1_BASE + 0xDB)
#define REG_PHY2P1_4_P1_6E_L        (REG_PHY2P1_4_P1_BASE + 0xDC)
#define REG_PHY2P1_4_P1_6E_H        (REG_PHY2P1_4_P1_BASE + 0xDD)
#define REG_PHY2P1_4_P1_6F_L        (REG_PHY2P1_4_P1_BASE + 0xDE)
#define REG_PHY2P1_4_P1_6F_H        (REG_PHY2P1_4_P1_BASE + 0xDF)
#define REG_PHY2P1_4_P1_70_L        (REG_PHY2P1_4_P1_BASE + 0xE0)
#define REG_PHY2P1_4_P1_70_H        (REG_PHY2P1_4_P1_BASE + 0xE1)
#define REG_PHY2P1_4_P1_71_L        (REG_PHY2P1_4_P1_BASE + 0xE2)
#define REG_PHY2P1_4_P1_71_H        (REG_PHY2P1_4_P1_BASE + 0xE3)
#define REG_PHY2P1_4_P1_72_L        (REG_PHY2P1_4_P1_BASE + 0xE4)
#define REG_PHY2P1_4_P1_72_H        (REG_PHY2P1_4_P1_BASE + 0xE5)
#define REG_PHY2P1_4_P1_73_L        (REG_PHY2P1_4_P1_BASE + 0xE6)
#define REG_PHY2P1_4_P1_73_H        (REG_PHY2P1_4_P1_BASE + 0xE7)
#define REG_PHY2P1_4_P1_74_L        (REG_PHY2P1_4_P1_BASE + 0xE8)
#define REG_PHY2P1_4_P1_74_H        (REG_PHY2P1_4_P1_BASE + 0xE9)
#define REG_PHY2P1_4_P1_75_L        (REG_PHY2P1_4_P1_BASE + 0xEA)
#define REG_PHY2P1_4_P1_75_H        (REG_PHY2P1_4_P1_BASE + 0xEB)
#define REG_PHY2P1_4_P1_76_L        (REG_PHY2P1_4_P1_BASE + 0xEC)
#define REG_PHY2P1_4_P1_76_H        (REG_PHY2P1_4_P1_BASE + 0xED)
#define REG_PHY2P1_4_P1_77_L        (REG_PHY2P1_4_P1_BASE + 0xEE)
#define REG_PHY2P1_4_P1_77_H        (REG_PHY2P1_4_P1_BASE + 0xEF)
#define REG_PHY2P1_4_P1_78_L        (REG_PHY2P1_4_P1_BASE + 0xF0)
#define REG_PHY2P1_4_P1_78_H        (REG_PHY2P1_4_P1_BASE + 0xF1)
#define REG_PHY2P1_4_P1_79_L        (REG_PHY2P1_4_P1_BASE + 0xF2)
#define REG_PHY2P1_4_P1_79_H        (REG_PHY2P1_4_P1_BASE + 0xF3)
#define REG_PHY2P1_4_P1_7A_L        (REG_PHY2P1_4_P1_BASE + 0xF4)
#define REG_PHY2P1_4_P1_7A_H        (REG_PHY2P1_4_P1_BASE + 0xF5)
#define REG_PHY2P1_4_P1_7B_L        (REG_PHY2P1_4_P1_BASE + 0xF6)
#define REG_PHY2P1_4_P1_7B_H        (REG_PHY2P1_4_P1_BASE + 0xF7)
#define REG_PHY2P1_4_P1_7C_L        (REG_PHY2P1_4_P1_BASE + 0xF8)
#define REG_PHY2P1_4_P1_7C_H        (REG_PHY2P1_4_P1_BASE + 0xF9)
#define REG_PHY2P1_4_P1_7D_L        (REG_PHY2P1_4_P1_BASE + 0xFA)
#define REG_PHY2P1_4_P1_7D_H        (REG_PHY2P1_4_P1_BASE + 0xFB)
#define REG_PHY2P1_4_P1_7E_L        (REG_PHY2P1_4_P1_BASE + 0xFC)
#define REG_PHY2P1_4_P1_7E_H        (REG_PHY2P1_4_P1_BASE + 0xFD)
#define REG_PHY2P1_4_P1_7F_L        (REG_PHY2P1_4_P1_BASE + 0xFE)
#define REG_PHY2P1_4_P1_7F_H        (REG_PHY2P1_4_P1_BASE + 0xFF)

//=============================================================
// PHY_TRAIN_P1
#define REG_PHY_TRAIN_P1_00_L       (REG_PHY_TRAIN_P1_BASE + 0x00)
#define REG_PHY_TRAIN_P1_00_H       (REG_PHY_TRAIN_P1_BASE + 0x01)
#define REG_PHY_TRAIN_P1_01_L       (REG_PHY_TRAIN_P1_BASE + 0x02)
#define REG_PHY_TRAIN_P1_01_H       (REG_PHY_TRAIN_P1_BASE + 0x03)
#define REG_PHY_TRAIN_P1_02_L       (REG_PHY_TRAIN_P1_BASE + 0x04)
#define REG_PHY_TRAIN_P1_02_H       (REG_PHY_TRAIN_P1_BASE + 0x05)
#define REG_PHY_TRAIN_P1_03_L       (REG_PHY_TRAIN_P1_BASE + 0x06)
#define REG_PHY_TRAIN_P1_03_H       (REG_PHY_TRAIN_P1_BASE + 0x07)
#define REG_PHY_TRAIN_P1_04_L       (REG_PHY_TRAIN_P1_BASE + 0x08)
#define REG_PHY_TRAIN_P1_04_H       (REG_PHY_TRAIN_P1_BASE + 0x09)
#define REG_PHY_TRAIN_P1_05_L       (REG_PHY_TRAIN_P1_BASE + 0x0A)
#define REG_PHY_TRAIN_P1_05_H       (REG_PHY_TRAIN_P1_BASE + 0x0B)
#define REG_PHY_TRAIN_P1_06_L       (REG_PHY_TRAIN_P1_BASE + 0x0C)
#define REG_PHY_TRAIN_P1_06_H       (REG_PHY_TRAIN_P1_BASE + 0x0D)
#define REG_PHY_TRAIN_P1_07_L       (REG_PHY_TRAIN_P1_BASE + 0x0E)
#define REG_PHY_TRAIN_P1_07_H       (REG_PHY_TRAIN_P1_BASE + 0x0F)
#define REG_PHY_TRAIN_P1_08_L       (REG_PHY_TRAIN_P1_BASE + 0x10)
#define REG_PHY_TRAIN_P1_08_H       (REG_PHY_TRAIN_P1_BASE + 0x11)
#define REG_PHY_TRAIN_P1_09_L       (REG_PHY_TRAIN_P1_BASE + 0x12)
#define REG_PHY_TRAIN_P1_09_H       (REG_PHY_TRAIN_P1_BASE + 0x13)
#define REG_PHY_TRAIN_P1_0A_L       (REG_PHY_TRAIN_P1_BASE + 0x14)
#define REG_PHY_TRAIN_P1_0A_H       (REG_PHY_TRAIN_P1_BASE + 0x15)
#define REG_PHY_TRAIN_P1_0B_L       (REG_PHY_TRAIN_P1_BASE + 0x16)
#define REG_PHY_TRAIN_P1_0B_H       (REG_PHY_TRAIN_P1_BASE + 0x17)
#define REG_PHY_TRAIN_P1_0C_L       (REG_PHY_TRAIN_P1_BASE + 0x18)
#define REG_PHY_TRAIN_P1_0C_H       (REG_PHY_TRAIN_P1_BASE + 0x19)
#define REG_PHY_TRAIN_P1_0D_L       (REG_PHY_TRAIN_P1_BASE + 0x1A)
#define REG_PHY_TRAIN_P1_0D_H       (REG_PHY_TRAIN_P1_BASE + 0x1B)
#define REG_PHY_TRAIN_P1_0E_L       (REG_PHY_TRAIN_P1_BASE + 0x1C)
#define REG_PHY_TRAIN_P1_0E_H       (REG_PHY_TRAIN_P1_BASE + 0x1D)
#define REG_PHY_TRAIN_P1_0F_L       (REG_PHY_TRAIN_P1_BASE + 0x1E)
#define REG_PHY_TRAIN_P1_0F_H       (REG_PHY_TRAIN_P1_BASE + 0x1F)
#define REG_PHY_TRAIN_P1_10_L       (REG_PHY_TRAIN_P1_BASE + 0x20)
#define REG_PHY_TRAIN_P1_10_H       (REG_PHY_TRAIN_P1_BASE + 0x21)
#define REG_PHY_TRAIN_P1_11_L       (REG_PHY_TRAIN_P1_BASE + 0x22)
#define REG_PHY_TRAIN_P1_11_H       (REG_PHY_TRAIN_P1_BASE + 0x23)
#define REG_PHY_TRAIN_P1_12_L       (REG_PHY_TRAIN_P1_BASE + 0x24)
#define REG_PHY_TRAIN_P1_12_H       (REG_PHY_TRAIN_P1_BASE + 0x25)
#define REG_PHY_TRAIN_P1_13_L       (REG_PHY_TRAIN_P1_BASE + 0x26)
#define REG_PHY_TRAIN_P1_13_H       (REG_PHY_TRAIN_P1_BASE + 0x27)
#define REG_PHY_TRAIN_P1_14_L       (REG_PHY_TRAIN_P1_BASE + 0x28)
#define REG_PHY_TRAIN_P1_14_H       (REG_PHY_TRAIN_P1_BASE + 0x29)
#define REG_PHY_TRAIN_P1_15_L       (REG_PHY_TRAIN_P1_BASE + 0x2A)
#define REG_PHY_TRAIN_P1_15_H       (REG_PHY_TRAIN_P1_BASE + 0x2B)
#define REG_PHY_TRAIN_P1_16_L       (REG_PHY_TRAIN_P1_BASE + 0x2C)
#define REG_PHY_TRAIN_P1_16_H       (REG_PHY_TRAIN_P1_BASE + 0x2D)
#define REG_PHY_TRAIN_P1_17_L       (REG_PHY_TRAIN_P1_BASE + 0x2E)
#define REG_PHY_TRAIN_P1_17_H       (REG_PHY_TRAIN_P1_BASE + 0x2F)
#define REG_PHY_TRAIN_P1_18_L       (REG_PHY_TRAIN_P1_BASE + 0x30)
#define REG_PHY_TRAIN_P1_18_H       (REG_PHY_TRAIN_P1_BASE + 0x31)
#define REG_PHY_TRAIN_P1_19_L       (REG_PHY_TRAIN_P1_BASE + 0x32)
#define REG_PHY_TRAIN_P1_19_H       (REG_PHY_TRAIN_P1_BASE + 0x33)
#define REG_PHY_TRAIN_P1_1A_L       (REG_PHY_TRAIN_P1_BASE + 0x34)
#define REG_PHY_TRAIN_P1_1A_H       (REG_PHY_TRAIN_P1_BASE + 0x35)
#define REG_PHY_TRAIN_P1_1B_L       (REG_PHY_TRAIN_P1_BASE + 0x36)
#define REG_PHY_TRAIN_P1_1B_H       (REG_PHY_TRAIN_P1_BASE + 0x37)
#define REG_PHY_TRAIN_P1_1C_L       (REG_PHY_TRAIN_P1_BASE + 0x38)
#define REG_PHY_TRAIN_P1_1C_H       (REG_PHY_TRAIN_P1_BASE + 0x39)
#define REG_PHY_TRAIN_P1_1D_L       (REG_PHY_TRAIN_P1_BASE + 0x3A)
#define REG_PHY_TRAIN_P1_1D_H       (REG_PHY_TRAIN_P1_BASE + 0x3B)
#define REG_PHY_TRAIN_P1_1E_L       (REG_PHY_TRAIN_P1_BASE + 0x3C)
#define REG_PHY_TRAIN_P1_1E_H       (REG_PHY_TRAIN_P1_BASE + 0x3D)
#define REG_PHY_TRAIN_P1_1F_L       (REG_PHY_TRAIN_P1_BASE + 0x3E)
#define REG_PHY_TRAIN_P1_1F_H       (REG_PHY_TRAIN_P1_BASE + 0x3F)
#define REG_PHY_TRAIN_P1_20_L       (REG_PHY_TRAIN_P1_BASE + 0x40)
#define REG_PHY_TRAIN_P1_20_H       (REG_PHY_TRAIN_P1_BASE + 0x41)
#define REG_PHY_TRAIN_P1_21_L       (REG_PHY_TRAIN_P1_BASE + 0x42)
#define REG_PHY_TRAIN_P1_21_H       (REG_PHY_TRAIN_P1_BASE + 0x43)
#define REG_PHY_TRAIN_P1_22_L       (REG_PHY_TRAIN_P1_BASE + 0x44)
#define REG_PHY_TRAIN_P1_22_H       (REG_PHY_TRAIN_P1_BASE + 0x45)
#define REG_PHY_TRAIN_P1_23_L       (REG_PHY_TRAIN_P1_BASE + 0x46)
#define REG_PHY_TRAIN_P1_23_H       (REG_PHY_TRAIN_P1_BASE + 0x47)
#define REG_PHY_TRAIN_P1_24_L       (REG_PHY_TRAIN_P1_BASE + 0x48)
#define REG_PHY_TRAIN_P1_24_H       (REG_PHY_TRAIN_P1_BASE + 0x49)
#define REG_PHY_TRAIN_P1_25_L       (REG_PHY_TRAIN_P1_BASE + 0x4A)
#define REG_PHY_TRAIN_P1_25_H       (REG_PHY_TRAIN_P1_BASE + 0x4B)
#define REG_PHY_TRAIN_P1_26_L       (REG_PHY_TRAIN_P1_BASE + 0x4C)
#define REG_PHY_TRAIN_P1_26_H       (REG_PHY_TRAIN_P1_BASE + 0x4D)
#define REG_PHY_TRAIN_P1_27_L       (REG_PHY_TRAIN_P1_BASE + 0x4E)
#define REG_PHY_TRAIN_P1_27_H       (REG_PHY_TRAIN_P1_BASE + 0x4F)
#define REG_PHY_TRAIN_P1_28_L       (REG_PHY_TRAIN_P1_BASE + 0x50)
#define REG_PHY_TRAIN_P1_28_H       (REG_PHY_TRAIN_P1_BASE + 0x51)
#define REG_PHY_TRAIN_P1_29_L       (REG_PHY_TRAIN_P1_BASE + 0x52)
#define REG_PHY_TRAIN_P1_29_H       (REG_PHY_TRAIN_P1_BASE + 0x53)
#define REG_PHY_TRAIN_P1_2A_L       (REG_PHY_TRAIN_P1_BASE + 0x54)
#define REG_PHY_TRAIN_P1_2A_H       (REG_PHY_TRAIN_P1_BASE + 0x55)
#define REG_PHY_TRAIN_P1_2B_L       (REG_PHY_TRAIN_P1_BASE + 0x56)
#define REG_PHY_TRAIN_P1_2B_H       (REG_PHY_TRAIN_P1_BASE + 0x57)
#define REG_PHY_TRAIN_P1_2C_L       (REG_PHY_TRAIN_P1_BASE + 0x58)
#define REG_PHY_TRAIN_P1_2C_H       (REG_PHY_TRAIN_P1_BASE + 0x59)
#define REG_PHY_TRAIN_P1_2D_L       (REG_PHY_TRAIN_P1_BASE + 0x5A)
#define REG_PHY_TRAIN_P1_2D_H       (REG_PHY_TRAIN_P1_BASE + 0x5B)
#define REG_PHY_TRAIN_P1_2E_L       (REG_PHY_TRAIN_P1_BASE + 0x5C)
#define REG_PHY_TRAIN_P1_2E_H       (REG_PHY_TRAIN_P1_BASE + 0x5D)
#define REG_PHY_TRAIN_P1_2F_L       (REG_PHY_TRAIN_P1_BASE + 0x5E)
#define REG_PHY_TRAIN_P1_2F_H       (REG_PHY_TRAIN_P1_BASE + 0x5F)
#define REG_PHY_TRAIN_P1_30_L       (REG_PHY_TRAIN_P1_BASE + 0x60)
#define REG_PHY_TRAIN_P1_30_H       (REG_PHY_TRAIN_P1_BASE + 0x61)
#define REG_PHY_TRAIN_P1_31_L       (REG_PHY_TRAIN_P1_BASE + 0x62)
#define REG_PHY_TRAIN_P1_31_H       (REG_PHY_TRAIN_P1_BASE + 0x63)
#define REG_PHY_TRAIN_P1_32_L       (REG_PHY_TRAIN_P1_BASE + 0x64)
#define REG_PHY_TRAIN_P1_32_H       (REG_PHY_TRAIN_P1_BASE + 0x65)
#define REG_PHY_TRAIN_P1_33_L       (REG_PHY_TRAIN_P1_BASE + 0x66)
#define REG_PHY_TRAIN_P1_33_H       (REG_PHY_TRAIN_P1_BASE + 0x67)
#define REG_PHY_TRAIN_P1_34_L       (REG_PHY_TRAIN_P1_BASE + 0x68)
#define REG_PHY_TRAIN_P1_34_H       (REG_PHY_TRAIN_P1_BASE + 0x69)
#define REG_PHY_TRAIN_P1_35_L       (REG_PHY_TRAIN_P1_BASE + 0x6A)
#define REG_PHY_TRAIN_P1_35_H       (REG_PHY_TRAIN_P1_BASE + 0x6B)
#define REG_PHY_TRAIN_P1_36_L       (REG_PHY_TRAIN_P1_BASE + 0x6C)
#define REG_PHY_TRAIN_P1_36_H       (REG_PHY_TRAIN_P1_BASE + 0x6D)
#define REG_PHY_TRAIN_P1_37_L       (REG_PHY_TRAIN_P1_BASE + 0x6E)
#define REG_PHY_TRAIN_P1_37_H       (REG_PHY_TRAIN_P1_BASE + 0x6F)
#define REG_PHY_TRAIN_P1_38_L       (REG_PHY_TRAIN_P1_BASE + 0x70)
#define REG_PHY_TRAIN_P1_38_H       (REG_PHY_TRAIN_P1_BASE + 0x71)
#define REG_PHY_TRAIN_P1_39_L       (REG_PHY_TRAIN_P1_BASE + 0x72)
#define REG_PHY_TRAIN_P1_39_H       (REG_PHY_TRAIN_P1_BASE + 0x73)
#define REG_PHY_TRAIN_P1_3A_L       (REG_PHY_TRAIN_P1_BASE + 0x74)
#define REG_PHY_TRAIN_P1_3A_H       (REG_PHY_TRAIN_P1_BASE + 0x75)
#define REG_PHY_TRAIN_P1_3B_L       (REG_PHY_TRAIN_P1_BASE + 0x76)
#define REG_PHY_TRAIN_P1_3B_H       (REG_PHY_TRAIN_P1_BASE + 0x77)
#define REG_PHY_TRAIN_P1_3C_L       (REG_PHY_TRAIN_P1_BASE + 0x78)
#define REG_PHY_TRAIN_P1_3C_H       (REG_PHY_TRAIN_P1_BASE + 0x79)
#define REG_PHY_TRAIN_P1_3D_L       (REG_PHY_TRAIN_P1_BASE + 0x7A)
#define REG_PHY_TRAIN_P1_3D_H       (REG_PHY_TRAIN_P1_BASE + 0x7B)
#define REG_PHY_TRAIN_P1_3E_L       (REG_PHY_TRAIN_P1_BASE + 0x7C)
#define REG_PHY_TRAIN_P1_3E_H       (REG_PHY_TRAIN_P1_BASE + 0x7D)
#define REG_PHY_TRAIN_P1_3F_L       (REG_PHY_TRAIN_P1_BASE + 0x7E)
#define REG_PHY_TRAIN_P1_3F_H       (REG_PHY_TRAIN_P1_BASE + 0x7F)
#define REG_PHY2P1_5_P1_40_L       (REG_PHY_TRAIN_P1_BASE + 0x80)
#define REG_PHY2P1_5_P1_40_H       (REG_PHY_TRAIN_P1_BASE + 0x81)
#define REG_PHY2P1_5_P1_41_L       (REG_PHY_TRAIN_P1_BASE + 0x82)
#define REG_PHY2P1_5_P1_41_H       (REG_PHY_TRAIN_P1_BASE + 0x83)
#define REG_PHY2P1_5_P1_42_L       (REG_PHY_TRAIN_P1_BASE + 0x84)
#define REG_PHY2P1_5_P1_42_H       (REG_PHY_TRAIN_P1_BASE + 0x85)
#define REG_PHY2P1_5_P1_43_L       (REG_PHY_TRAIN_P1_BASE + 0x86)
#define REG_PHY2P1_5_P1_43_H       (REG_PHY_TRAIN_P1_BASE + 0x87)
#define REG_PHY2P1_5_P1_44_L       (REG_PHY_TRAIN_P1_BASE + 0x88)
#define REG_PHY2P1_5_P1_44_H       (REG_PHY_TRAIN_P1_BASE + 0x89)
#define REG_PHY2P1_5_P1_45_L       (REG_PHY_TRAIN_P1_BASE + 0x8A)
#define REG_PHY2P1_5_P1_45_H       (REG_PHY_TRAIN_P1_BASE + 0x8B)
#define REG_PHY2P1_5_P1_46_L       (REG_PHY_TRAIN_P1_BASE + 0x8C)
#define REG_PHY2P1_5_P1_46_H       (REG_PHY_TRAIN_P1_BASE + 0x8D)
#define REG_PHY2P1_5_P1_47_L       (REG_PHY_TRAIN_P1_BASE + 0x8E)
#define REG_PHY2P1_5_P1_47_H       (REG_PHY_TRAIN_P1_BASE + 0x8F)
#define REG_PHY2P1_5_P1_48_L       (REG_PHY_TRAIN_P1_BASE + 0x90)
#define REG_PHY2P1_5_P1_48_H       (REG_PHY_TRAIN_P1_BASE + 0x91)
#define REG_PHY2P1_5_P1_49_L       (REG_PHY_TRAIN_P1_BASE + 0x92)
#define REG_PHY2P1_5_P1_49_H       (REG_PHY_TRAIN_P1_BASE + 0x93)
#define REG_PHY2P1_5_P1_4A_L       (REG_PHY_TRAIN_P1_BASE + 0x94)
#define REG_PHY2P1_5_P1_4A_H       (REG_PHY_TRAIN_P1_BASE + 0x95)
#define REG_PHY2P1_5_P1_4B_L       (REG_PHY_TRAIN_P1_BASE + 0x96)
#define REG_PHY2P1_5_P1_4B_H       (REG_PHY_TRAIN_P1_BASE + 0x97)
#define REG_PHY2P1_5_P1_4C_L       (REG_PHY_TRAIN_P1_BASE + 0x98)
#define REG_PHY2P1_5_P1_4C_H       (REG_PHY_TRAIN_P1_BASE + 0x99)
#define REG_PHY2P1_5_P1_4D_L       (REG_PHY_TRAIN_P1_BASE + 0x9A)
#define REG_PHY2P1_5_P1_4D_H       (REG_PHY_TRAIN_P1_BASE + 0x9B)
#define REG_PHY2P1_5_P1_4E_L       (REG_PHY_TRAIN_P1_BASE + 0x9C)
#define REG_PHY2P1_5_P1_4E_H       (REG_PHY_TRAIN_P1_BASE + 0x9D)
#define REG_PHY2P1_5_P1_4F_L       (REG_PHY_TRAIN_P1_BASE + 0x9E)
#define REG_PHY2P1_5_P1_4F_H       (REG_PHY_TRAIN_P1_BASE + 0x9F)
#define REG_PHY2P1_5_P1_50_L       (REG_PHY_TRAIN_P1_BASE + 0xA0)
#define REG_PHY2P1_5_P1_50_H       (REG_PHY_TRAIN_P1_BASE + 0xA1)
#define REG_PHY2P1_5_P1_51_L       (REG_PHY_TRAIN_P1_BASE + 0xA2)
#define REG_PHY2P1_5_P1_51_H       (REG_PHY_TRAIN_P1_BASE + 0xA3)
#define REG_PHY2P1_5_P1_52_L       (REG_PHY_TRAIN_P1_BASE + 0xA4)
#define REG_PHY2P1_5_P1_52_H       (REG_PHY_TRAIN_P1_BASE + 0xA5)
#define REG_PHY2P1_5_P1_53_L       (REG_PHY_TRAIN_P1_BASE + 0xA6)
#define REG_PHY2P1_5_P1_53_H       (REG_PHY_TRAIN_P1_BASE + 0xA7)
#define REG_PHY2P1_5_P1_54_L       (REG_PHY_TRAIN_P1_BASE + 0xA8)
#define REG_PHY2P1_5_P1_54_H       (REG_PHY_TRAIN_P1_BASE + 0xA9)
#define REG_PHY2P1_5_P1_55_L       (REG_PHY_TRAIN_P1_BASE + 0xAA)
#define REG_PHY2P1_5_P1_55_H       (REG_PHY_TRAIN_P1_BASE + 0xAB)
#define REG_PHY2P1_5_P1_56_L       (REG_PHY_TRAIN_P1_BASE + 0xAC)
#define REG_PHY2P1_5_P1_56_H       (REG_PHY_TRAIN_P1_BASE + 0xAD)
#define REG_PHY2P1_5_P1_57_L       (REG_PHY_TRAIN_P1_BASE + 0xAE)
#define REG_PHY2P1_5_P1_57_H       (REG_PHY_TRAIN_P1_BASE + 0xAF)
#define REG_PHY2P1_5_P1_58_L       (REG_PHY_TRAIN_P1_BASE + 0xB0)
#define REG_PHY2P1_5_P1_58_H       (REG_PHY_TRAIN_P1_BASE + 0xB1)
#define REG_PHY2P1_5_P1_59_L       (REG_PHY_TRAIN_P1_BASE + 0xB2)
#define REG_PHY2P1_5_P1_59_H       (REG_PHY_TRAIN_P1_BASE + 0xB3)
#define REG_PHY2P1_5_P1_5A_L       (REG_PHY_TRAIN_P1_BASE + 0xB4)
#define REG_PHY2P1_5_P1_5A_H       (REG_PHY_TRAIN_P1_BASE + 0xB5)
#define REG_PHY2P1_5_P1_5B_L       (REG_PHY_TRAIN_P1_BASE + 0xB6)
#define REG_PHY2P1_5_P1_5B_H       (REG_PHY_TRAIN_P1_BASE + 0xB7)
#define REG_PHY2P1_5_P1_5C_L       (REG_PHY_TRAIN_P1_BASE + 0xB8)
#define REG_PHY2P1_5_P1_5C_H       (REG_PHY_TRAIN_P1_BASE + 0xB9)
#define REG_PHY2P1_5_P1_5D_L       (REG_PHY_TRAIN_P1_BASE + 0xBA)
#define REG_PHY2P1_5_P1_5D_H       (REG_PHY_TRAIN_P1_BASE + 0xBB)
#define REG_PHY2P1_5_P1_5E_L       (REG_PHY_TRAIN_P1_BASE + 0xBC)
#define REG_PHY2P1_5_P1_5E_H       (REG_PHY_TRAIN_P1_BASE + 0xBD)
#define REG_PHY2P1_5_P1_5F_L       (REG_PHY_TRAIN_P1_BASE + 0xBE)
#define REG_PHY2P1_5_P1_5F_H       (REG_PHY_TRAIN_P1_BASE + 0xBF)
#define REG_PHY_TRAIN_P1_60_L       (REG_PHY_TRAIN_P1_BASE + 0xC0)
#define REG_PHY_TRAIN_P1_60_H       (REG_PHY_TRAIN_P1_BASE + 0xC1)
#define REG_PHY_TRAIN_P1_61_L       (REG_PHY_TRAIN_P1_BASE + 0xC2)
#define REG_PHY_TRAIN_P1_61_H       (REG_PHY_TRAIN_P1_BASE + 0xC3)
#define REG_PHY_TRAIN_P1_62_L       (REG_PHY_TRAIN_P1_BASE + 0xC4)
#define REG_PHY_TRAIN_P1_62_H       (REG_PHY_TRAIN_P1_BASE + 0xC5)
#define REG_PHY_TRAIN_P1_63_L       (REG_PHY_TRAIN_P1_BASE + 0xC6)
#define REG_PHY_TRAIN_P1_63_H       (REG_PHY_TRAIN_P1_BASE + 0xC7)
#define REG_PHY_TRAIN_P1_64_L       (REG_PHY_TRAIN_P1_BASE + 0xC8)
#define REG_PHY_TRAIN_P1_64_H       (REG_PHY_TRAIN_P1_BASE + 0xC9)
#define REG_PHY_TRAIN_P1_65_L       (REG_PHY_TRAIN_P1_BASE + 0xCA)
#define REG_PHY_TRAIN_P1_65_H       (REG_PHY_TRAIN_P1_BASE + 0xCB)
#define REG_PHY_TRAIN_P1_66_L       (REG_PHY_TRAIN_P1_BASE + 0xCC)
#define REG_PHY_TRAIN_P1_66_H       (REG_PHY_TRAIN_P1_BASE + 0xCD)
#define REG_PHY_TRAIN_P1_67_L       (REG_PHY_TRAIN_P1_BASE + 0xCE)
#define REG_PHY_TRAIN_P1_67_H       (REG_PHY_TRAIN_P1_BASE + 0xCF)
#define REG_PHY_TRAIN_P1_68_L       (REG_PHY_TRAIN_P1_BASE + 0xD0)
#define REG_PHY_TRAIN_P1_68_H       (REG_PHY_TRAIN_P1_BASE + 0xD1)
#define REG_PHY_TRAIN_P1_69_L       (REG_PHY_TRAIN_P1_BASE + 0xD2)
#define REG_PHY_TRAIN_P1_69_H       (REG_PHY_TRAIN_P1_BASE + 0xD3)
#define REG_PHY_TRAIN_P1_6A_L       (REG_PHY_TRAIN_P1_BASE + 0xD4)
#define REG_PHY_TRAIN_P1_6A_H       (REG_PHY_TRAIN_P1_BASE + 0xD5)
#define REG_PHY_TRAIN_P1_6B_L       (REG_PHY_TRAIN_P1_BASE + 0xD6)
#define REG_PHY_TRAIN_P1_6B_H       (REG_PHY_TRAIN_P1_BASE + 0xD7)
#define REG_PHY_TRAIN_P1_6C_L       (REG_PHY_TRAIN_P1_BASE + 0xD8)
#define REG_PHY_TRAIN_P1_6C_H       (REG_PHY_TRAIN_P1_BASE + 0xD9)
#define REG_PHY_TRAIN_P1_6D_L       (REG_PHY_TRAIN_P1_BASE + 0xDA)
#define REG_PHY_TRAIN_P1_6D_H       (REG_PHY_TRAIN_P1_BASE + 0xDB)
#define REG_PHY_TRAIN_P1_6E_L       (REG_PHY_TRAIN_P1_BASE + 0xDC)
#define REG_PHY_TRAIN_P1_6E_H       (REG_PHY_TRAIN_P1_BASE + 0xDD)
#define REG_PHY_TRAIN_P1_6F_L       (REG_PHY_TRAIN_P1_BASE + 0xDE)
#define REG_PHY_TRAIN_P1_6F_H       (REG_PHY_TRAIN_P1_BASE + 0xDF)
#define REG_PHY_TRAIN_P1_70_L       (REG_PHY_TRAIN_P1_BASE + 0xE0)
#define REG_PHY_TRAIN_P1_70_H       (REG_PHY_TRAIN_P1_BASE + 0xE1)
#define REG_PHY_TRAIN_P1_71_L       (REG_PHY_TRAIN_P1_BASE + 0xE2)
#define REG_PHY_TRAIN_P1_71_H       (REG_PHY_TRAIN_P1_BASE + 0xE3)
#define REG_PHY_TRAIN_P1_72_L       (REG_PHY_TRAIN_P1_BASE + 0xE4)
#define REG_PHY_TRAIN_P1_72_H       (REG_PHY_TRAIN_P1_BASE + 0xE5)
#define REG_PHY_TRAIN_P1_73_L       (REG_PHY_TRAIN_P1_BASE + 0xE6)
#define REG_PHY_TRAIN_P1_73_H       (REG_PHY_TRAIN_P1_BASE + 0xE7)
#define REG_PHY_TRAIN_P1_74_L       (REG_PHY_TRAIN_P1_BASE + 0xE8)
#define REG_PHY_TRAIN_P1_74_H       (REG_PHY_TRAIN_P1_BASE + 0xE9)
#define REG_PHY_TRAIN_P1_75_L       (REG_PHY_TRAIN_P1_BASE + 0xEA)
#define REG_PHY_TRAIN_P1_75_H       (REG_PHY_TRAIN_P1_BASE + 0xEB)
#define REG_PHY_TRAIN_P1_76_L       (REG_PHY_TRAIN_P1_BASE + 0xEC)
#define REG_PHY_TRAIN_P1_76_H       (REG_PHY_TRAIN_P1_BASE + 0xED)
#define REG_PHY_TRAIN_P1_77_L       (REG_PHY_TRAIN_P1_BASE + 0xEE)
#define REG_PHY_TRAIN_P1_77_H       (REG_PHY_TRAIN_P1_BASE + 0xEF)
#define REG_PHY_TRAIN_P1_78_L       (REG_PHY_TRAIN_P1_BASE + 0xF0)
#define REG_PHY_TRAIN_P1_78_H       (REG_PHY_TRAIN_P1_BASE + 0xF1)
#define REG_PHY_TRAIN_P1_79_L       (REG_PHY_TRAIN_P1_BASE + 0xF2)
#define REG_PHY_TRAIN_P1_79_H       (REG_PHY_TRAIN_P1_BASE + 0xF3)
#define REG_PHY_TRAIN_P1_7A_L       (REG_PHY_TRAIN_P1_BASE + 0xF4)
#define REG_PHY_TRAIN_P1_7A_H       (REG_PHY_TRAIN_P1_BASE + 0xF5)
#define REG_PHY_TRAIN_P1_7B_L       (REG_PHY_TRAIN_P1_BASE + 0xF6)
#define REG_PHY_TRAIN_P1_7B_H       (REG_PHY_TRAIN_P1_BASE + 0xF7)
#define REG_PHY_TRAIN_P1_7C_L       (REG_PHY_TRAIN_P1_BASE + 0xF8)
#define REG_PHY_TRAIN_P1_7C_H       (REG_PHY_TRAIN_P1_BASE + 0xF9)
#define REG_PHY_TRAIN_P1_7D_L       (REG_PHY_TRAIN_P1_BASE + 0xFA)
#define REG_PHY_TRAIN_P1_7D_H       (REG_PHY_TRAIN_P1_BASE + 0xFB)
#define REG_PHY_TRAIN_P1_7E_L       (REG_PHY_TRAIN_P1_BASE + 0xFC)
#define REG_PHY_TRAIN_P1_7E_H       (REG_PHY_TRAIN_P1_BASE + 0xFD)
#define REG_PHY_TRAIN_P1_7F_L       (REG_PHY_TRAIN_P1_BASE + 0xFE)
#define REG_PHY_TRAIN_P1_7F_H       (REG_PHY_TRAIN_P1_BASE + 0xFF)

//=============================================================
// PHY2P1_0_P2
#define REG_PHY2P1_0_P2_00_L        (REG_PHY2P1_0_P2_BASE + 0x00)
#define REG_PHY2P1_0_P2_00_H        (REG_PHY2P1_0_P2_BASE + 0x01)
#define REG_PHY2P1_0_P2_01_L        (REG_PHY2P1_0_P2_BASE + 0x02)
#define REG_PHY2P1_0_P2_01_H        (REG_PHY2P1_0_P2_BASE + 0x03)
#define REG_PHY2P1_0_P2_02_L        (REG_PHY2P1_0_P2_BASE + 0x04)
#define REG_PHY2P1_0_P2_02_H        (REG_PHY2P1_0_P2_BASE + 0x05)
#define REG_PHY2P1_0_P2_03_L        (REG_PHY2P1_0_P2_BASE + 0x06)
#define REG_PHY2P1_0_P2_03_H        (REG_PHY2P1_0_P2_BASE + 0x07)
#define REG_PHY2P1_0_P2_04_L        (REG_PHY2P1_0_P2_BASE + 0x08)
#define REG_PHY2P1_0_P2_04_H        (REG_PHY2P1_0_P2_BASE + 0x09)
#define REG_PHY2P1_0_P2_05_L        (REG_PHY2P1_0_P2_BASE + 0x0A)
#define REG_PHY2P1_0_P2_05_H        (REG_PHY2P1_0_P2_BASE + 0x0B)
#define REG_PHY2P1_0_P2_06_L        (REG_PHY2P1_0_P2_BASE + 0x0C)
#define REG_PHY2P1_0_P2_06_H        (REG_PHY2P1_0_P2_BASE + 0x0D)
#define REG_PHY2P1_0_P2_07_L        (REG_PHY2P1_0_P2_BASE + 0x0E)
#define REG_PHY2P1_0_P2_07_H        (REG_PHY2P1_0_P2_BASE + 0x0F)
#define REG_PHY2P1_0_P2_08_L        (REG_PHY2P1_0_P2_BASE + 0x10)
#define REG_PHY2P1_0_P2_08_H        (REG_PHY2P1_0_P2_BASE + 0x11)
#define REG_PHY2P1_0_P2_09_L        (REG_PHY2P1_0_P2_BASE + 0x12)
#define REG_PHY2P1_0_P2_09_H        (REG_PHY2P1_0_P2_BASE + 0x13)
#define REG_PHY2P1_0_P2_0A_L        (REG_PHY2P1_0_P2_BASE + 0x14)
#define REG_PHY2P1_0_P2_0A_H        (REG_PHY2P1_0_P2_BASE + 0x15)
#define REG_PHY2P1_0_P2_0B_L        (REG_PHY2P1_0_P2_BASE + 0x16)
#define REG_PHY2P1_0_P2_0B_H        (REG_PHY2P1_0_P2_BASE + 0x17)
#define REG_PHY2P1_0_P2_0C_L        (REG_PHY2P1_0_P2_BASE + 0x18)
#define REG_PHY2P1_0_P2_0C_H        (REG_PHY2P1_0_P2_BASE + 0x19)
#define REG_PHY2P1_0_P2_0D_L        (REG_PHY2P1_0_P2_BASE + 0x1A)
#define REG_PHY2P1_0_P2_0D_H        (REG_PHY2P1_0_P2_BASE + 0x1B)
#define REG_PHY2P1_0_P2_0E_L        (REG_PHY2P1_0_P2_BASE + 0x1C)
#define REG_PHY2P1_0_P2_0E_H        (REG_PHY2P1_0_P2_BASE + 0x1D)
#define REG_PHY2P1_0_P2_0F_L        (REG_PHY2P1_0_P2_BASE + 0x1E)
#define REG_PHY2P1_0_P2_0F_H        (REG_PHY2P1_0_P2_BASE + 0x1F)
#define REG_PHY2P1_0_P2_10_L        (REG_PHY2P1_0_P2_BASE + 0x20)
#define REG_PHY2P1_0_P2_10_H        (REG_PHY2P1_0_P2_BASE + 0x21)
#define REG_PHY2P1_0_P2_11_L        (REG_PHY2P1_0_P2_BASE + 0x22)
#define REG_PHY2P1_0_P2_11_H        (REG_PHY2P1_0_P2_BASE + 0x23)
#define REG_PHY2P1_0_P2_12_L        (REG_PHY2P1_0_P2_BASE + 0x24)
#define REG_PHY2P1_0_P2_12_H        (REG_PHY2P1_0_P2_BASE + 0x25)
#define REG_PHY2P1_0_P2_13_L        (REG_PHY2P1_0_P2_BASE + 0x26)
#define REG_PHY2P1_0_P2_13_H        (REG_PHY2P1_0_P2_BASE + 0x27)
#define REG_PHY2P1_0_P2_14_L        (REG_PHY2P1_0_P2_BASE + 0x28)
#define REG_PHY2P1_0_P2_14_H        (REG_PHY2P1_0_P2_BASE + 0x29)
#define REG_PHY2P1_0_P2_15_L        (REG_PHY2P1_0_P2_BASE + 0x2A)
#define REG_PHY2P1_0_P2_15_H        (REG_PHY2P1_0_P2_BASE + 0x2B)
#define REG_PHY2P1_0_P2_16_L        (REG_PHY2P1_0_P2_BASE + 0x2C)
#define REG_PHY2P1_0_P2_16_H        (REG_PHY2P1_0_P2_BASE + 0x2D)
#define REG_PHY2P1_0_P2_17_L        (REG_PHY2P1_0_P2_BASE + 0x2E)
#define REG_PHY2P1_0_P2_17_H        (REG_PHY2P1_0_P2_BASE + 0x2F)
#define REG_PHY2P1_0_P2_18_L        (REG_PHY2P1_0_P2_BASE + 0x30)
#define REG_PHY2P1_0_P2_18_H        (REG_PHY2P1_0_P2_BASE + 0x31)
#define REG_PHY2P1_0_P2_19_L        (REG_PHY2P1_0_P2_BASE + 0x32)
#define REG_PHY2P1_0_P2_19_H        (REG_PHY2P1_0_P2_BASE + 0x33)
#define REG_PHY2P1_0_P2_1A_L        (REG_PHY2P1_0_P2_BASE + 0x34)
#define REG_PHY2P1_0_P2_1A_H        (REG_PHY2P1_0_P2_BASE + 0x35)
#define REG_PHY2P1_0_P2_1B_L        (REG_PHY2P1_0_P2_BASE + 0x36)
#define REG_PHY2P1_0_P2_1B_H        (REG_PHY2P1_0_P2_BASE + 0x37)
#define REG_PHY2P1_0_P2_1C_L        (REG_PHY2P1_0_P2_BASE + 0x38)
#define REG_PHY2P1_0_P2_1C_H        (REG_PHY2P1_0_P2_BASE + 0x39)
#define REG_PHY2P1_0_P2_1D_L        (REG_PHY2P1_0_P2_BASE + 0x3A)
#define REG_PHY2P1_0_P2_1D_H        (REG_PHY2P1_0_P2_BASE + 0x3B)
#define REG_PHY2P1_0_P2_1E_L        (REG_PHY2P1_0_P2_BASE + 0x3C)
#define REG_PHY2P1_0_P2_1E_H        (REG_PHY2P1_0_P2_BASE + 0x3D)
#define REG_PHY2P1_0_P2_1F_L        (REG_PHY2P1_0_P2_BASE + 0x3E)
#define REG_PHY2P1_0_P2_1F_H        (REG_PHY2P1_0_P2_BASE + 0x3F)
#define REG_PHY2P1_0_P2_20_L        (REG_PHY2P1_0_P2_BASE + 0x40)
#define REG_PHY2P1_0_P2_20_H        (REG_PHY2P1_0_P2_BASE + 0x41)
#define REG_PHY2P1_0_P2_21_L        (REG_PHY2P1_0_P2_BASE + 0x42)
#define REG_PHY2P1_0_P2_21_H        (REG_PHY2P1_0_P2_BASE + 0x43)
#define REG_PHY2P1_0_P2_22_L        (REG_PHY2P1_0_P2_BASE + 0x44)
#define REG_PHY2P1_0_P2_22_H        (REG_PHY2P1_0_P2_BASE + 0x45)
#define REG_PHY2P1_0_P2_23_L        (REG_PHY2P1_0_P2_BASE + 0x46)
#define REG_PHY2P1_0_P2_23_H        (REG_PHY2P1_0_P2_BASE + 0x47)
#define REG_PHY2P1_0_P2_24_L        (REG_PHY2P1_0_P2_BASE + 0x48)
#define REG_PHY2P1_0_P2_24_H        (REG_PHY2P1_0_P2_BASE + 0x49)
#define REG_PHY2P1_0_P2_25_L        (REG_PHY2P1_0_P2_BASE + 0x4A)
#define REG_PHY2P1_0_P2_25_H        (REG_PHY2P1_0_P2_BASE + 0x4B)
#define REG_PHY2P1_0_P2_26_L        (REG_PHY2P1_0_P2_BASE + 0x4C)
#define REG_PHY2P1_0_P2_26_H        (REG_PHY2P1_0_P2_BASE + 0x4D)
#define REG_PHY2P1_0_P2_27_L        (REG_PHY2P1_0_P2_BASE + 0x4E)
#define REG_PHY2P1_0_P2_27_H        (REG_PHY2P1_0_P2_BASE + 0x4F)
#define REG_PHY2P1_0_P2_28_L        (REG_PHY2P1_0_P2_BASE + 0x50)
#define REG_PHY2P1_0_P2_28_H        (REG_PHY2P1_0_P2_BASE + 0x51)
#define REG_PHY2P1_0_P2_29_L        (REG_PHY2P1_0_P2_BASE + 0x52)
#define REG_PHY2P1_0_P2_29_H        (REG_PHY2P1_0_P2_BASE + 0x53)
#define REG_PHY2P1_0_P2_2A_L        (REG_PHY2P1_0_P2_BASE + 0x54)
#define REG_PHY2P1_0_P2_2A_H        (REG_PHY2P1_0_P2_BASE + 0x55)
#define REG_PHY2P1_0_P2_2B_L        (REG_PHY2P1_0_P2_BASE + 0x56)
#define REG_PHY2P1_0_P2_2B_H        (REG_PHY2P1_0_P2_BASE + 0x57)
#define REG_PHY2P1_0_P2_2C_L        (REG_PHY2P1_0_P2_BASE + 0x58)
#define REG_PHY2P1_0_P2_2C_H        (REG_PHY2P1_0_P2_BASE + 0x59)
#define REG_PHY2P1_0_P2_2D_L        (REG_PHY2P1_0_P2_BASE + 0x5A)
#define REG_PHY2P1_0_P2_2D_H        (REG_PHY2P1_0_P2_BASE + 0x5B)
#define REG_PHY2P1_0_P2_2E_L        (REG_PHY2P1_0_P2_BASE + 0x5C)
#define REG_PHY2P1_0_P2_2E_H        (REG_PHY2P1_0_P2_BASE + 0x5D)
#define REG_PHY2P1_0_P2_2F_L        (REG_PHY2P1_0_P2_BASE + 0x5E)
#define REG_PHY2P1_0_P2_2F_H        (REG_PHY2P1_0_P2_BASE + 0x5F)
#define REG_PHY2P1_0_P2_30_L        (REG_PHY2P1_0_P2_BASE + 0x60)
#define REG_PHY2P1_0_P2_30_H        (REG_PHY2P1_0_P2_BASE + 0x61)
#define REG_PHY2P1_0_P2_31_L        (REG_PHY2P1_0_P2_BASE + 0x62)
#define REG_PHY2P1_0_P2_31_H        (REG_PHY2P1_0_P2_BASE + 0x63)
#define REG_PHY2P1_0_P2_32_L        (REG_PHY2P1_0_P2_BASE + 0x64)
#define REG_PHY2P1_0_P2_32_H        (REG_PHY2P1_0_P2_BASE + 0x65)
#define REG_PHY2P1_0_P2_33_L        (REG_PHY2P1_0_P2_BASE + 0x66)
#define REG_PHY2P1_0_P2_33_H        (REG_PHY2P1_0_P2_BASE + 0x67)
#define REG_PHY2P1_0_P2_34_L        (REG_PHY2P1_0_P2_BASE + 0x68)
#define REG_PHY2P1_0_P2_34_H        (REG_PHY2P1_0_P2_BASE + 0x69)
#define REG_PHY2P1_0_P2_35_L        (REG_PHY2P1_0_P2_BASE + 0x6A)
#define REG_PHY2P1_0_P2_35_H        (REG_PHY2P1_0_P2_BASE + 0x6B)
#define REG_PHY2P1_0_P2_36_L        (REG_PHY2P1_0_P2_BASE + 0x6C)
#define REG_PHY2P1_0_P2_36_H        (REG_PHY2P1_0_P2_BASE + 0x6D)
#define REG_PHY2P1_0_P2_37_L        (REG_PHY2P1_0_P2_BASE + 0x6E)
#define REG_PHY2P1_0_P2_37_H        (REG_PHY2P1_0_P2_BASE + 0x6F)
#define REG_PHY2P1_0_P2_38_L        (REG_PHY2P1_0_P2_BASE + 0x70)
#define REG_PHY2P1_0_P2_38_H        (REG_PHY2P1_0_P2_BASE + 0x71)
#define REG_PHY2P1_0_P2_39_L        (REG_PHY2P1_0_P2_BASE + 0x72)
#define REG_PHY2P1_0_P2_39_H        (REG_PHY2P1_0_P2_BASE + 0x73)
#define REG_PHY2P1_0_P2_3A_L        (REG_PHY2P1_0_P2_BASE + 0x74)
#define REG_PHY2P1_0_P2_3A_H        (REG_PHY2P1_0_P2_BASE + 0x75)
#define REG_PHY2P1_0_P2_3B_L        (REG_PHY2P1_0_P2_BASE + 0x76)
#define REG_PHY2P1_0_P2_3B_H        (REG_PHY2P1_0_P2_BASE + 0x77)
#define REG_PHY2P1_0_P2_3C_L        (REG_PHY2P1_0_P2_BASE + 0x78)
#define REG_PHY2P1_0_P2_3C_H        (REG_PHY2P1_0_P2_BASE + 0x79)
#define REG_PHY2P1_0_P2_3D_L        (REG_PHY2P1_0_P2_BASE + 0x7A)
#define REG_PHY2P1_0_P2_3D_H        (REG_PHY2P1_0_P2_BASE + 0x7B)
#define REG_PHY2P1_0_P2_3E_L        (REG_PHY2P1_0_P2_BASE + 0x7C)
#define REG_PHY2P1_0_P2_3E_H        (REG_PHY2P1_0_P2_BASE + 0x7D)
#define REG_PHY2P1_0_P2_3F_L        (REG_PHY2P1_0_P2_BASE + 0x7E)
#define REG_PHY2P1_0_P2_3F_H        (REG_PHY2P1_0_P2_BASE + 0x7F)
#define REG_PHY2P1_0_P2_40_L        (REG_PHY2P1_0_P2_BASE + 0x80)
#define REG_PHY2P1_0_P2_40_H        (REG_PHY2P1_0_P2_BASE + 0x81)
#define REG_PHY2P1_0_P2_41_L        (REG_PHY2P1_0_P2_BASE + 0x82)
#define REG_PHY2P1_0_P2_41_H        (REG_PHY2P1_0_P2_BASE + 0x83)
#define REG_PHY2P1_0_P2_42_L        (REG_PHY2P1_0_P2_BASE + 0x84)
#define REG_PHY2P1_0_P2_42_H        (REG_PHY2P1_0_P2_BASE + 0x85)
#define REG_PHY2P1_0_P2_43_L        (REG_PHY2P1_0_P2_BASE + 0x86)
#define REG_PHY2P1_0_P2_43_H        (REG_PHY2P1_0_P2_BASE + 0x87)
#define REG_PHY2P1_0_P2_44_L        (REG_PHY2P1_0_P2_BASE + 0x88)
#define REG_PHY2P1_0_P2_44_H        (REG_PHY2P1_0_P2_BASE + 0x89)
#define REG_PHY2P1_0_P2_45_L        (REG_PHY2P1_0_P2_BASE + 0x8A)
#define REG_PHY2P1_0_P2_45_H        (REG_PHY2P1_0_P2_BASE + 0x8B)
#define REG_PHY2P1_0_P2_46_L        (REG_PHY2P1_0_P2_BASE + 0x8C)
#define REG_PHY2P1_0_P2_46_H        (REG_PHY2P1_0_P2_BASE + 0x8D)
#define REG_PHY2P1_0_P2_47_L        (REG_PHY2P1_0_P2_BASE + 0x8E)
#define REG_PHY2P1_0_P2_47_H        (REG_PHY2P1_0_P2_BASE + 0x8F)
#define REG_PHY2P1_0_P2_48_L        (REG_PHY2P1_0_P2_BASE + 0x90)
#define REG_PHY2P1_0_P2_48_H        (REG_PHY2P1_0_P2_BASE + 0x91)
#define REG_PHY2P1_0_P2_49_L        (REG_PHY2P1_0_P2_BASE + 0x92)
#define REG_PHY2P1_0_P2_49_H        (REG_PHY2P1_0_P2_BASE + 0x93)
#define REG_PHY2P1_0_P2_4A_L        (REG_PHY2P1_0_P2_BASE + 0x94)
#define REG_PHY2P1_0_P2_4A_H        (REG_PHY2P1_0_P2_BASE + 0x95)
#define REG_PHY2P1_0_P2_4B_L        (REG_PHY2P1_0_P2_BASE + 0x96)
#define REG_PHY2P1_0_P2_4B_H        (REG_PHY2P1_0_P2_BASE + 0x97)
#define REG_PHY2P1_0_P2_4C_L        (REG_PHY2P1_0_P2_BASE + 0x98)
#define REG_PHY2P1_0_P2_4C_H        (REG_PHY2P1_0_P2_BASE + 0x99)
#define REG_PHY2P1_0_P2_4D_L        (REG_PHY2P1_0_P2_BASE + 0x9A)
#define REG_PHY2P1_0_P2_4D_H        (REG_PHY2P1_0_P2_BASE + 0x9B)
#define REG_PHY2P1_0_P2_4E_L        (REG_PHY2P1_0_P2_BASE + 0x9C)
#define REG_PHY2P1_0_P2_4E_H        (REG_PHY2P1_0_P2_BASE + 0x9D)
#define REG_PHY2P1_0_P2_4F_L        (REG_PHY2P1_0_P2_BASE + 0x9E)
#define REG_PHY2P1_0_P2_4F_H        (REG_PHY2P1_0_P2_BASE + 0x9F)
#define REG_PHY2P1_0_P2_50_L        (REG_PHY2P1_0_P2_BASE + 0xA0)
#define REG_PHY2P1_0_P2_50_H        (REG_PHY2P1_0_P2_BASE + 0xA1)
#define REG_PHY2P1_0_P2_51_L        (REG_PHY2P1_0_P2_BASE + 0xA2)
#define REG_PHY2P1_0_P2_51_H        (REG_PHY2P1_0_P2_BASE + 0xA3)
#define REG_PHY2P1_0_P2_52_L        (REG_PHY2P1_0_P2_BASE + 0xA4)
#define REG_PHY2P1_0_P2_52_H        (REG_PHY2P1_0_P2_BASE + 0xA5)
#define REG_PHY2P1_0_P2_53_L        (REG_PHY2P1_0_P2_BASE + 0xA6)
#define REG_PHY2P1_0_P2_53_H        (REG_PHY2P1_0_P2_BASE + 0xA7)
#define REG_PHY2P1_0_P2_54_L        (REG_PHY2P1_0_P2_BASE + 0xA8)
#define REG_PHY2P1_0_P2_54_H        (REG_PHY2P1_0_P2_BASE + 0xA9)
#define REG_PHY2P1_0_P2_55_L        (REG_PHY2P1_0_P2_BASE + 0xAA)
#define REG_PHY2P1_0_P2_55_H        (REG_PHY2P1_0_P2_BASE + 0xAB)
#define REG_PHY2P1_0_P2_56_L        (REG_PHY2P1_0_P2_BASE + 0xAC)
#define REG_PHY2P1_0_P2_56_H        (REG_PHY2P1_0_P2_BASE + 0xAD)
#define REG_PHY2P1_0_P2_57_L        (REG_PHY2P1_0_P2_BASE + 0xAE)
#define REG_PHY2P1_0_P2_57_H        (REG_PHY2P1_0_P2_BASE + 0xAF)
#define REG_PHY2P1_0_P2_58_L        (REG_PHY2P1_0_P2_BASE + 0xB0)
#define REG_PHY2P1_0_P2_58_H        (REG_PHY2P1_0_P2_BASE + 0xB1)
#define REG_PHY2P1_0_P2_59_L        (REG_PHY2P1_0_P2_BASE + 0xB2)
#define REG_PHY2P1_0_P2_59_H        (REG_PHY2P1_0_P2_BASE + 0xB3)
#define REG_PHY2P1_0_P2_5A_L        (REG_PHY2P1_0_P2_BASE + 0xB4)
#define REG_PHY2P1_0_P2_5A_H        (REG_PHY2P1_0_P2_BASE + 0xB5)
#define REG_PHY2P1_0_P2_5B_L        (REG_PHY2P1_0_P2_BASE + 0xB6)
#define REG_PHY2P1_0_P2_5B_H        (REG_PHY2P1_0_P2_BASE + 0xB7)
#define REG_PHY2P1_0_P2_5C_L        (REG_PHY2P1_0_P2_BASE + 0xB8)
#define REG_PHY2P1_0_P2_5C_H        (REG_PHY2P1_0_P2_BASE + 0xB9)
#define REG_PHY2P1_0_P2_5D_L        (REG_PHY2P1_0_P2_BASE + 0xBA)
#define REG_PHY2P1_0_P2_5D_H        (REG_PHY2P1_0_P2_BASE + 0xBB)
#define REG_PHY2P1_0_P2_5E_L        (REG_PHY2P1_0_P2_BASE + 0xBC)
#define REG_PHY2P1_0_P2_5E_H        (REG_PHY2P1_0_P2_BASE + 0xBD)
#define REG_PHY2P1_0_P2_5F_L        (REG_PHY2P1_0_P2_BASE + 0xBE)
#define REG_PHY2P1_0_P2_5F_H        (REG_PHY2P1_0_P2_BASE + 0xBF)
#define REG_PHY2P1_0_P2_60_L        (REG_PHY2P1_0_P2_BASE + 0xC0)
#define REG_PHY2P1_0_P2_60_H        (REG_PHY2P1_0_P2_BASE + 0xC1)
#define REG_PHY2P1_0_P2_61_L        (REG_PHY2P1_0_P2_BASE + 0xC2)
#define REG_PHY2P1_0_P2_61_H        (REG_PHY2P1_0_P2_BASE + 0xC3)
#define REG_PHY2P1_0_P2_62_L        (REG_PHY2P1_0_P2_BASE + 0xC4)
#define REG_PHY2P1_0_P2_62_H        (REG_PHY2P1_0_P2_BASE + 0xC5)
#define REG_PHY2P1_0_P2_63_L        (REG_PHY2P1_0_P2_BASE + 0xC6)
#define REG_PHY2P1_0_P2_63_H        (REG_PHY2P1_0_P2_BASE + 0xC7)
#define REG_PHY2P1_0_P2_64_L        (REG_PHY2P1_0_P2_BASE + 0xC8)
#define REG_PHY2P1_0_P2_64_H        (REG_PHY2P1_0_P2_BASE + 0xC9)
#define REG_PHY2P1_0_P2_65_L        (REG_PHY2P1_0_P2_BASE + 0xCA)
#define REG_PHY2P1_0_P2_65_H        (REG_PHY2P1_0_P2_BASE + 0xCB)
#define REG_PHY2P1_0_P2_66_L        (REG_PHY2P1_0_P2_BASE + 0xCC)
#define REG_PHY2P1_0_P2_66_H        (REG_PHY2P1_0_P2_BASE + 0xCD)
#define REG_PHY2P1_0_P2_67_L        (REG_PHY2P1_0_P2_BASE + 0xCE)
#define REG_PHY2P1_0_P2_67_H        (REG_PHY2P1_0_P2_BASE + 0xCF)
#define REG_PHY2P1_0_P2_68_L        (REG_PHY2P1_0_P2_BASE + 0xD0)
#define REG_PHY2P1_0_P2_68_H        (REG_PHY2P1_0_P2_BASE + 0xD1)
#define REG_PHY2P1_0_P2_69_L        (REG_PHY2P1_0_P2_BASE + 0xD2)
#define REG_PHY2P1_0_P2_69_H        (REG_PHY2P1_0_P2_BASE + 0xD3)
#define REG_PHY2P1_0_P2_6A_L        (REG_PHY2P1_0_P2_BASE + 0xD4)
#define REG_PHY2P1_0_P2_6A_H        (REG_PHY2P1_0_P2_BASE + 0xD5)
#define REG_PHY2P1_0_P2_6B_L        (REG_PHY2P1_0_P2_BASE + 0xD6)
#define REG_PHY2P1_0_P2_6B_H        (REG_PHY2P1_0_P2_BASE + 0xD7)
#define REG_PHY2P1_0_P2_6C_L        (REG_PHY2P1_0_P2_BASE + 0xD8)
#define REG_PHY2P1_0_P2_6C_H        (REG_PHY2P1_0_P2_BASE + 0xD9)
#define REG_PHY2P1_0_P2_6D_L        (REG_PHY2P1_0_P2_BASE + 0xDA)
#define REG_PHY2P1_0_P2_6D_H        (REG_PHY2P1_0_P2_BASE + 0xDB)
#define REG_PHY2P1_0_P2_6E_L        (REG_PHY2P1_0_P2_BASE + 0xDC)
#define REG_PHY2P1_0_P2_6E_H        (REG_PHY2P1_0_P2_BASE + 0xDD)
#define REG_PHY2P1_0_P2_6F_L        (REG_PHY2P1_0_P2_BASE + 0xDE)
#define REG_PHY2P1_0_P2_6F_H        (REG_PHY2P1_0_P2_BASE + 0xDF)
#define REG_PHY2P1_0_P2_70_L        (REG_PHY2P1_0_P2_BASE + 0xE0)
#define REG_PHY2P1_0_P2_70_H        (REG_PHY2P1_0_P2_BASE + 0xE1)
#define REG_PHY2P1_0_P2_71_L        (REG_PHY2P1_0_P2_BASE + 0xE2)
#define REG_PHY2P1_0_P2_71_H        (REG_PHY2P1_0_P2_BASE + 0xE3)
#define REG_PHY2P1_0_P2_72_L        (REG_PHY2P1_0_P2_BASE + 0xE4)
#define REG_PHY2P1_0_P2_72_H        (REG_PHY2P1_0_P2_BASE + 0xE5)
#define REG_PHY2P1_0_P2_73_L        (REG_PHY2P1_0_P2_BASE + 0xE6)
#define REG_PHY2P1_0_P2_73_H        (REG_PHY2P1_0_P2_BASE + 0xE7)
#define REG_PHY2P1_0_P2_74_L        (REG_PHY2P1_0_P2_BASE + 0xE8)
#define REG_PHY2P1_0_P2_74_H        (REG_PHY2P1_0_P2_BASE + 0xE9)
#define REG_PHY2P1_0_P2_75_L        (REG_PHY2P1_0_P2_BASE + 0xEA)
#define REG_PHY2P1_0_P2_75_H        (REG_PHY2P1_0_P2_BASE + 0xEB)
#define REG_PHY2P1_0_P2_76_L        (REG_PHY2P1_0_P2_BASE + 0xEC)
#define REG_PHY2P1_0_P2_76_H        (REG_PHY2P1_0_P2_BASE + 0xED)
#define REG_PHY2P1_0_P2_77_L        (REG_PHY2P1_0_P2_BASE + 0xEE)
#define REG_PHY2P1_0_P2_77_H        (REG_PHY2P1_0_P2_BASE + 0xEF)
#define REG_PHY2P1_0_P2_78_L        (REG_PHY2P1_0_P2_BASE + 0xF0)
#define REG_PHY2P1_0_P2_78_H        (REG_PHY2P1_0_P2_BASE + 0xF1)
#define REG_PHY2P1_0_P2_79_L        (REG_PHY2P1_0_P2_BASE + 0xF2)
#define REG_PHY2P1_0_P2_79_H        (REG_PHY2P1_0_P2_BASE + 0xF3)
#define REG_PHY2P1_0_P2_7A_L        (REG_PHY2P1_0_P2_BASE + 0xF4)
#define REG_PHY2P1_0_P2_7A_H        (REG_PHY2P1_0_P2_BASE + 0xF5)
#define REG_PHY2P1_0_P2_7B_L        (REG_PHY2P1_0_P2_BASE + 0xF6)
#define REG_PHY2P1_0_P2_7B_H        (REG_PHY2P1_0_P2_BASE + 0xF7)
#define REG_PHY2P1_0_P2_7C_L        (REG_PHY2P1_0_P2_BASE + 0xF8)
#define REG_PHY2P1_0_P2_7C_H        (REG_PHY2P1_0_P2_BASE + 0xF9)
#define REG_PHY2P1_0_P2_7D_L        (REG_PHY2P1_0_P2_BASE + 0xFA)
#define REG_PHY2P1_0_P2_7D_H        (REG_PHY2P1_0_P2_BASE + 0xFB)
#define REG_PHY2P1_0_P2_7E_L        (REG_PHY2P1_0_P2_BASE + 0xFC)
#define REG_PHY2P1_0_P2_7E_H        (REG_PHY2P1_0_P2_BASE + 0xFD)
#define REG_PHY2P1_0_P2_7F_L        (REG_PHY2P1_0_P2_BASE + 0xFE)
#define REG_PHY2P1_0_P2_7F_H        (REG_PHY2P1_0_P2_BASE + 0xFF)

//=============================================================
// PHY2P1_1_P2
#define REG_PHY2P1_1_P2_00_L        (REG_PHY2P1_1_P2_BASE + 0x00)
#define REG_PHY2P1_1_P2_00_H        (REG_PHY2P1_1_P2_BASE + 0x01)
#define REG_PHY2P1_1_P2_01_L        (REG_PHY2P1_1_P2_BASE + 0x02)
#define REG_PHY2P1_1_P2_01_H        (REG_PHY2P1_1_P2_BASE + 0x03)
#define REG_PHY2P1_1_P2_02_L        (REG_PHY2P1_1_P2_BASE + 0x04)
#define REG_PHY2P1_1_P2_02_H        (REG_PHY2P1_1_P2_BASE + 0x05)
#define REG_PHY2P1_1_P2_03_L        (REG_PHY2P1_1_P2_BASE + 0x06)
#define REG_PHY2P1_1_P2_03_H        (REG_PHY2P1_1_P2_BASE + 0x07)
#define REG_PHY2P1_1_P2_04_L        (REG_PHY2P1_1_P2_BASE + 0x08)
#define REG_PHY2P1_1_P2_04_H        (REG_PHY2P1_1_P2_BASE + 0x09)
#define REG_PHY2P1_1_P2_05_L        (REG_PHY2P1_1_P2_BASE + 0x0A)
#define REG_PHY2P1_1_P2_05_H        (REG_PHY2P1_1_P2_BASE + 0x0B)
#define REG_PHY2P1_1_P2_06_L        (REG_PHY2P1_1_P2_BASE + 0x0C)
#define REG_PHY2P1_1_P2_06_H        (REG_PHY2P1_1_P2_BASE + 0x0D)
#define REG_PHY2P1_1_P2_07_L        (REG_PHY2P1_1_P2_BASE + 0x0E)
#define REG_PHY2P1_1_P2_07_H        (REG_PHY2P1_1_P2_BASE + 0x0F)
#define REG_PHY2P1_1_P2_08_L        (REG_PHY2P1_1_P2_BASE + 0x10)
#define REG_PHY2P1_1_P2_08_H        (REG_PHY2P1_1_P2_BASE + 0x11)
#define REG_PHY2P1_1_P2_09_L        (REG_PHY2P1_1_P2_BASE + 0x12)
#define REG_PHY2P1_1_P2_09_H        (REG_PHY2P1_1_P2_BASE + 0x13)
#define REG_PHY2P1_1_P2_0A_L        (REG_PHY2P1_1_P2_BASE + 0x14)
#define REG_PHY2P1_1_P2_0A_H        (REG_PHY2P1_1_P2_BASE + 0x15)
#define REG_PHY2P1_1_P2_0B_L        (REG_PHY2P1_1_P2_BASE + 0x16)
#define REG_PHY2P1_1_P2_0B_H        (REG_PHY2P1_1_P2_BASE + 0x17)
#define REG_PHY2P1_1_P2_0C_L        (REG_PHY2P1_1_P2_BASE + 0x18)
#define REG_PHY2P1_1_P2_0C_H        (REG_PHY2P1_1_P2_BASE + 0x19)
#define REG_PHY2P1_1_P2_0D_L        (REG_PHY2P1_1_P2_BASE + 0x1A)
#define REG_PHY2P1_1_P2_0D_H        (REG_PHY2P1_1_P2_BASE + 0x1B)
#define REG_PHY2P1_1_P2_0E_L        (REG_PHY2P1_1_P2_BASE + 0x1C)
#define REG_PHY2P1_1_P2_0E_H        (REG_PHY2P1_1_P2_BASE + 0x1D)
#define REG_PHY2P1_1_P2_0F_L        (REG_PHY2P1_1_P2_BASE + 0x1E)
#define REG_PHY2P1_1_P2_0F_H        (REG_PHY2P1_1_P2_BASE + 0x1F)
#define REG_PHY2P1_1_P2_10_L        (REG_PHY2P1_1_P2_BASE + 0x20)
#define REG_PHY2P1_1_P2_10_H        (REG_PHY2P1_1_P2_BASE + 0x21)
#define REG_PHY2P1_1_P2_11_L        (REG_PHY2P1_1_P2_BASE + 0x22)
#define REG_PHY2P1_1_P2_11_H        (REG_PHY2P1_1_P2_BASE + 0x23)
#define REG_PHY2P1_1_P2_12_L        (REG_PHY2P1_1_P2_BASE + 0x24)
#define REG_PHY2P1_1_P2_12_H        (REG_PHY2P1_1_P2_BASE + 0x25)
#define REG_PHY2P1_1_P2_13_L        (REG_PHY2P1_1_P2_BASE + 0x26)
#define REG_PHY2P1_1_P2_13_H        (REG_PHY2P1_1_P2_BASE + 0x27)
#define REG_PHY2P1_1_P2_14_L        (REG_PHY2P1_1_P2_BASE + 0x28)
#define REG_PHY2P1_1_P2_14_H        (REG_PHY2P1_1_P2_BASE + 0x29)
#define REG_PHY2P1_1_P2_15_L        (REG_PHY2P1_1_P2_BASE + 0x2A)
#define REG_PHY2P1_1_P2_15_H        (REG_PHY2P1_1_P2_BASE + 0x2B)
#define REG_PHY2P1_1_P2_16_L        (REG_PHY2P1_1_P2_BASE + 0x2C)
#define REG_PHY2P1_1_P2_16_H        (REG_PHY2P1_1_P2_BASE + 0x2D)
#define REG_PHY2P1_1_P2_17_L        (REG_PHY2P1_1_P2_BASE + 0x2E)
#define REG_PHY2P1_1_P2_17_H        (REG_PHY2P1_1_P2_BASE + 0x2F)
#define REG_PHY2P1_1_P2_18_L        (REG_PHY2P1_1_P2_BASE + 0x30)
#define REG_PHY2P1_1_P2_18_H        (REG_PHY2P1_1_P2_BASE + 0x31)
#define REG_PHY2P1_1_P2_19_L        (REG_PHY2P1_1_P2_BASE + 0x32)
#define REG_PHY2P1_1_P2_19_H        (REG_PHY2P1_1_P2_BASE + 0x33)
#define REG_PHY2P1_1_P2_1A_L        (REG_PHY2P1_1_P2_BASE + 0x34)
#define REG_PHY2P1_1_P2_1A_H        (REG_PHY2P1_1_P2_BASE + 0x35)
#define REG_PHY2P1_1_P2_1B_L        (REG_PHY2P1_1_P2_BASE + 0x36)
#define REG_PHY2P1_1_P2_1B_H        (REG_PHY2P1_1_P2_BASE + 0x37)
#define REG_PHY2P1_1_P2_1C_L        (REG_PHY2P1_1_P2_BASE + 0x38)
#define REG_PHY2P1_1_P2_1C_H        (REG_PHY2P1_1_P2_BASE + 0x39)
#define REG_PHY2P1_1_P2_1D_L        (REG_PHY2P1_1_P2_BASE + 0x3A)
#define REG_PHY2P1_1_P2_1D_H        (REG_PHY2P1_1_P2_BASE + 0x3B)
#define REG_PHY2P1_1_P2_1E_L        (REG_PHY2P1_1_P2_BASE + 0x3C)
#define REG_PHY2P1_1_P2_1E_H        (REG_PHY2P1_1_P2_BASE + 0x3D)
#define REG_PHY2P1_1_P2_1F_L        (REG_PHY2P1_1_P2_BASE + 0x3E)
#define REG_PHY2P1_1_P2_1F_H        (REG_PHY2P1_1_P2_BASE + 0x3F)
#define REG_PHY2P1_1_P2_20_L        (REG_PHY2P1_1_P2_BASE + 0x40)
#define REG_PHY2P1_1_P2_20_H        (REG_PHY2P1_1_P2_BASE + 0x41)
#define REG_PHY2P1_1_P2_21_L        (REG_PHY2P1_1_P2_BASE + 0x42)
#define REG_PHY2P1_1_P2_21_H        (REG_PHY2P1_1_P2_BASE + 0x43)
#define REG_PHY2P1_1_P2_22_L        (REG_PHY2P1_1_P2_BASE + 0x44)
#define REG_PHY2P1_1_P2_22_H        (REG_PHY2P1_1_P2_BASE + 0x45)
#define REG_PHY2P1_1_P2_23_L        (REG_PHY2P1_1_P2_BASE + 0x46)
#define REG_PHY2P1_1_P2_23_H        (REG_PHY2P1_1_P2_BASE + 0x47)
#define REG_PHY2P1_1_P2_24_L        (REG_PHY2P1_1_P2_BASE + 0x48)
#define REG_PHY2P1_1_P2_24_H        (REG_PHY2P1_1_P2_BASE + 0x49)
#define REG_PHY2P1_1_P2_25_L        (REG_PHY2P1_1_P2_BASE + 0x4A)
#define REG_PHY2P1_1_P2_25_H        (REG_PHY2P1_1_P2_BASE + 0x4B)
#define REG_PHY2P1_1_P2_26_L        (REG_PHY2P1_1_P2_BASE + 0x4C)
#define REG_PHY2P1_1_P2_26_H        (REG_PHY2P1_1_P2_BASE + 0x4D)
#define REG_PHY2P1_1_P2_27_L        (REG_PHY2P1_1_P2_BASE + 0x4E)
#define REG_PHY2P1_1_P2_27_H        (REG_PHY2P1_1_P2_BASE + 0x4F)
#define REG_PHY2P1_1_P2_28_L        (REG_PHY2P1_1_P2_BASE + 0x50)
#define REG_PHY2P1_1_P2_28_H        (REG_PHY2P1_1_P2_BASE + 0x51)
#define REG_PHY2P1_1_P2_29_L        (REG_PHY2P1_1_P2_BASE + 0x52)
#define REG_PHY2P1_1_P2_29_H        (REG_PHY2P1_1_P2_BASE + 0x53)
#define REG_PHY2P1_1_P2_2A_L        (REG_PHY2P1_1_P2_BASE + 0x54)
#define REG_PHY2P1_1_P2_2A_H        (REG_PHY2P1_1_P2_BASE + 0x55)
#define REG_PHY2P1_1_P2_2B_L        (REG_PHY2P1_1_P2_BASE + 0x56)
#define REG_PHY2P1_1_P2_2B_H        (REG_PHY2P1_1_P2_BASE + 0x57)
#define REG_PHY2P1_1_P2_2C_L        (REG_PHY2P1_1_P2_BASE + 0x58)
#define REG_PHY2P1_1_P2_2C_H        (REG_PHY2P1_1_P2_BASE + 0x59)
#define REG_PHY2P1_1_P2_2D_L        (REG_PHY2P1_1_P2_BASE + 0x5A)
#define REG_PHY2P1_1_P2_2D_H        (REG_PHY2P1_1_P2_BASE + 0x5B)
#define REG_PHY2P1_1_P2_2E_L        (REG_PHY2P1_1_P2_BASE + 0x5C)
#define REG_PHY2P1_1_P2_2E_H        (REG_PHY2P1_1_P2_BASE + 0x5D)
#define REG_PHY2P1_1_P2_2F_L        (REG_PHY2P1_1_P2_BASE + 0x5E)
#define REG_PHY2P1_1_P2_2F_H        (REG_PHY2P1_1_P2_BASE + 0x5F)
#define REG_PHY2P1_1_P2_30_L        (REG_PHY2P1_1_P2_BASE + 0x60)
#define REG_PHY2P1_1_P2_30_H        (REG_PHY2P1_1_P2_BASE + 0x61)
#define REG_PHY2P1_1_P2_31_L        (REG_PHY2P1_1_P2_BASE + 0x62)
#define REG_PHY2P1_1_P2_31_H        (REG_PHY2P1_1_P2_BASE + 0x63)
#define REG_PHY2P1_1_P2_32_L        (REG_PHY2P1_1_P2_BASE + 0x64)
#define REG_PHY2P1_1_P2_32_H        (REG_PHY2P1_1_P2_BASE + 0x65)
#define REG_PHY2P1_1_P2_33_L        (REG_PHY2P1_1_P2_BASE + 0x66)
#define REG_PHY2P1_1_P2_33_H        (REG_PHY2P1_1_P2_BASE + 0x67)
#define REG_PHY2P1_1_P2_34_L        (REG_PHY2P1_1_P2_BASE + 0x68)
#define REG_PHY2P1_1_P2_34_H        (REG_PHY2P1_1_P2_BASE + 0x69)
#define REG_PHY2P1_1_P2_35_L        (REG_PHY2P1_1_P2_BASE + 0x6A)
#define REG_PHY2P1_1_P2_35_H        (REG_PHY2P1_1_P2_BASE + 0x6B)
#define REG_PHY2P1_1_P2_36_L        (REG_PHY2P1_1_P2_BASE + 0x6C)
#define REG_PHY2P1_1_P2_36_H        (REG_PHY2P1_1_P2_BASE + 0x6D)
#define REG_PHY2P1_1_P2_37_L        (REG_PHY2P1_1_P2_BASE + 0x6E)
#define REG_PHY2P1_1_P2_37_H        (REG_PHY2P1_1_P2_BASE + 0x6F)
#define REG_PHY2P1_1_P2_38_L        (REG_PHY2P1_1_P2_BASE + 0x70)
#define REG_PHY2P1_1_P2_38_H        (REG_PHY2P1_1_P2_BASE + 0x71)
#define REG_PHY2P1_1_P2_39_L        (REG_PHY2P1_1_P2_BASE + 0x72)
#define REG_PHY2P1_1_P2_39_H        (REG_PHY2P1_1_P2_BASE + 0x73)
#define REG_PHY2P1_1_P2_3A_L        (REG_PHY2P1_1_P2_BASE + 0x74)
#define REG_PHY2P1_1_P2_3A_H        (REG_PHY2P1_1_P2_BASE + 0x75)
#define REG_PHY2P1_1_P2_3B_L        (REG_PHY2P1_1_P2_BASE + 0x76)
#define REG_PHY2P1_1_P2_3B_H        (REG_PHY2P1_1_P2_BASE + 0x77)
#define REG_PHY2P1_1_P2_3C_L        (REG_PHY2P1_1_P2_BASE + 0x78)
#define REG_PHY2P1_1_P2_3C_H        (REG_PHY2P1_1_P2_BASE + 0x79)
#define REG_PHY2P1_1_P2_3D_L        (REG_PHY2P1_1_P2_BASE + 0x7A)
#define REG_PHY2P1_1_P2_3D_H        (REG_PHY2P1_1_P2_BASE + 0x7B)
#define REG_PHY2P1_1_P2_3E_L        (REG_PHY2P1_1_P2_BASE + 0x7C)
#define REG_PHY2P1_1_P2_3E_H        (REG_PHY2P1_1_P2_BASE + 0x7D)
#define REG_PHY2P1_1_P2_3F_L        (REG_PHY2P1_1_P2_BASE + 0x7E)
#define REG_PHY2P1_1_P2_3F_H        (REG_PHY2P1_1_P2_BASE + 0x7F)
#define REG_PHY2P1_1_P2_40_L        (REG_PHY2P1_1_P2_BASE + 0x80)
#define REG_PHY2P1_1_P2_40_H        (REG_PHY2P1_1_P2_BASE + 0x81)
#define REG_PHY2P1_1_P2_41_L        (REG_PHY2P1_1_P2_BASE + 0x82)
#define REG_PHY2P1_1_P2_41_H        (REG_PHY2P1_1_P2_BASE + 0x83)
#define REG_PHY2P1_1_P2_42_L        (REG_PHY2P1_1_P2_BASE + 0x84)
#define REG_PHY2P1_1_P2_42_H        (REG_PHY2P1_1_P2_BASE + 0x85)
#define REG_PHY2P1_1_P2_43_L        (REG_PHY2P1_1_P2_BASE + 0x86)
#define REG_PHY2P1_1_P2_43_H        (REG_PHY2P1_1_P2_BASE + 0x87)
#define REG_PHY2P1_1_P2_44_L        (REG_PHY2P1_1_P2_BASE + 0x88)
#define REG_PHY2P1_1_P2_44_H        (REG_PHY2P1_1_P2_BASE + 0x89)
#define REG_PHY2P1_1_P2_45_L        (REG_PHY2P1_1_P2_BASE + 0x8A)
#define REG_PHY2P1_1_P2_45_H        (REG_PHY2P1_1_P2_BASE + 0x8B)
#define REG_PHY2P1_1_P2_46_L        (REG_PHY2P1_1_P2_BASE + 0x8C)
#define REG_PHY2P1_1_P2_46_H        (REG_PHY2P1_1_P2_BASE + 0x8D)
#define REG_PHY2P1_1_P2_47_L        (REG_PHY2P1_1_P2_BASE + 0x8E)
#define REG_PHY2P1_1_P2_47_H        (REG_PHY2P1_1_P2_BASE + 0x8F)
#define REG_PHY2P1_1_P2_48_L        (REG_PHY2P1_1_P2_BASE + 0x90)
#define REG_PHY2P1_1_P2_48_H        (REG_PHY2P1_1_P2_BASE + 0x91)
#define REG_PHY2P1_1_P2_49_L        (REG_PHY2P1_1_P2_BASE + 0x92)
#define REG_PHY2P1_1_P2_49_H        (REG_PHY2P1_1_P2_BASE + 0x93)
#define REG_PHY2P1_1_P2_4A_L        (REG_PHY2P1_1_P2_BASE + 0x94)
#define REG_PHY2P1_1_P2_4A_H        (REG_PHY2P1_1_P2_BASE + 0x95)
#define REG_PHY2P1_1_P2_4B_L        (REG_PHY2P1_1_P2_BASE + 0x96)
#define REG_PHY2P1_1_P2_4B_H        (REG_PHY2P1_1_P2_BASE + 0x97)
#define REG_PHY2P1_1_P2_4C_L        (REG_PHY2P1_1_P2_BASE + 0x98)
#define REG_PHY2P1_1_P2_4C_H        (REG_PHY2P1_1_P2_BASE + 0x99)
#define REG_PHY2P1_1_P2_4D_L        (REG_PHY2P1_1_P2_BASE + 0x9A)
#define REG_PHY2P1_1_P2_4D_H        (REG_PHY2P1_1_P2_BASE + 0x9B)
#define REG_PHY2P1_1_P2_4E_L        (REG_PHY2P1_1_P2_BASE + 0x9C)
#define REG_PHY2P1_1_P2_4E_H        (REG_PHY2P1_1_P2_BASE + 0x9D)
#define REG_PHY2P1_1_P2_4F_L        (REG_PHY2P1_1_P2_BASE + 0x9E)
#define REG_PHY2P1_1_P2_4F_H        (REG_PHY2P1_1_P2_BASE + 0x9F)
#define REG_PHY2P1_1_P2_50_L        (REG_PHY2P1_1_P2_BASE + 0xA0)
#define REG_PHY2P1_1_P2_50_H        (REG_PHY2P1_1_P2_BASE + 0xA1)
#define REG_PHY2P1_1_P2_51_L        (REG_PHY2P1_1_P2_BASE + 0xA2)
#define REG_PHY2P1_1_P2_51_H        (REG_PHY2P1_1_P2_BASE + 0xA3)
#define REG_PHY2P1_1_P2_52_L        (REG_PHY2P1_1_P2_BASE + 0xA4)
#define REG_PHY2P1_1_P2_52_H        (REG_PHY2P1_1_P2_BASE + 0xA5)
#define REG_PHY2P1_1_P2_53_L        (REG_PHY2P1_1_P2_BASE + 0xA6)
#define REG_PHY2P1_1_P2_53_H        (REG_PHY2P1_1_P2_BASE + 0xA7)
#define REG_PHY2P1_1_P2_54_L        (REG_PHY2P1_1_P2_BASE + 0xA8)
#define REG_PHY2P1_1_P2_54_H        (REG_PHY2P1_1_P2_BASE + 0xA9)
#define REG_PHY2P1_1_P2_55_L        (REG_PHY2P1_1_P2_BASE + 0xAA)
#define REG_PHY2P1_1_P2_55_H        (REG_PHY2P1_1_P2_BASE + 0xAB)
#define REG_PHY2P1_1_P2_56_L        (REG_PHY2P1_1_P2_BASE + 0xAC)
#define REG_PHY2P1_1_P2_56_H        (REG_PHY2P1_1_P2_BASE + 0xAD)
#define REG_PHY2P1_1_P2_57_L        (REG_PHY2P1_1_P2_BASE + 0xAE)
#define REG_PHY2P1_1_P2_57_H        (REG_PHY2P1_1_P2_BASE + 0xAF)
#define REG_PHY2P1_1_P2_58_L        (REG_PHY2P1_1_P2_BASE + 0xB0)
#define REG_PHY2P1_1_P2_58_H        (REG_PHY2P1_1_P2_BASE + 0xB1)
#define REG_PHY2P1_1_P2_59_L        (REG_PHY2P1_1_P2_BASE + 0xB2)
#define REG_PHY2P1_1_P2_59_H        (REG_PHY2P1_1_P2_BASE + 0xB3)
#define REG_PHY2P1_1_P2_5A_L        (REG_PHY2P1_1_P2_BASE + 0xB4)
#define REG_PHY2P1_1_P2_5A_H        (REG_PHY2P1_1_P2_BASE + 0xB5)
#define REG_PHY2P1_1_P2_5B_L        (REG_PHY2P1_1_P2_BASE + 0xB6)
#define REG_PHY2P1_1_P2_5B_H        (REG_PHY2P1_1_P2_BASE + 0xB7)
#define REG_PHY2P1_1_P2_5C_L        (REG_PHY2P1_1_P2_BASE + 0xB8)
#define REG_PHY2P1_1_P2_5C_H        (REG_PHY2P1_1_P2_BASE + 0xB9)
#define REG_PHY2P1_1_P2_5D_L        (REG_PHY2P1_1_P2_BASE + 0xBA)
#define REG_PHY2P1_1_P2_5D_H        (REG_PHY2P1_1_P2_BASE + 0xBB)
#define REG_PHY2P1_1_P2_5E_L        (REG_PHY2P1_1_P2_BASE + 0xBC)
#define REG_PHY2P1_1_P2_5E_H        (REG_PHY2P1_1_P2_BASE + 0xBD)
#define REG_PHY2P1_1_P2_5F_L        (REG_PHY2P1_1_P2_BASE + 0xBE)
#define REG_PHY2P1_1_P2_5F_H        (REG_PHY2P1_1_P2_BASE + 0xBF)
#define REG_PHY2P1_1_P2_60_L        (REG_PHY2P1_1_P2_BASE + 0xC0)
#define REG_PHY2P1_1_P2_60_H        (REG_PHY2P1_1_P2_BASE + 0xC1)
#define REG_PHY2P1_1_P2_61_L        (REG_PHY2P1_1_P2_BASE + 0xC2)
#define REG_PHY2P1_1_P2_61_H        (REG_PHY2P1_1_P2_BASE + 0xC3)
#define REG_PHY2P1_1_P2_62_L        (REG_PHY2P1_1_P2_BASE + 0xC4)
#define REG_PHY2P1_1_P2_62_H        (REG_PHY2P1_1_P2_BASE + 0xC5)
#define REG_PHY2P1_1_P2_63_L        (REG_PHY2P1_1_P2_BASE + 0xC6)
#define REG_PHY2P1_1_P2_63_H        (REG_PHY2P1_1_P2_BASE + 0xC7)
#define REG_PHY2P1_1_P2_64_L        (REG_PHY2P1_1_P2_BASE + 0xC8)
#define REG_PHY2P1_1_P2_64_H        (REG_PHY2P1_1_P2_BASE + 0xC9)
#define REG_PHY2P1_1_P2_65_L        (REG_PHY2P1_1_P2_BASE + 0xCA)
#define REG_PHY2P1_1_P2_65_H        (REG_PHY2P1_1_P2_BASE + 0xCB)
#define REG_PHY2P1_1_P2_66_L        (REG_PHY2P1_1_P2_BASE + 0xCC)
#define REG_PHY2P1_1_P2_66_H        (REG_PHY2P1_1_P2_BASE + 0xCD)
#define REG_PHY2P1_1_P2_67_L        (REG_PHY2P1_1_P2_BASE + 0xCE)
#define REG_PHY2P1_1_P2_67_H        (REG_PHY2P1_1_P2_BASE + 0xCF)
#define REG_PHY2P1_1_P2_68_L        (REG_PHY2P1_1_P2_BASE + 0xD0)
#define REG_PHY2P1_1_P2_68_H        (REG_PHY2P1_1_P2_BASE + 0xD1)
#define REG_PHY2P1_1_P2_69_L        (REG_PHY2P1_1_P2_BASE + 0xD2)
#define REG_PHY2P1_1_P2_69_H        (REG_PHY2P1_1_P2_BASE + 0xD3)
#define REG_PHY2P1_1_P2_6A_L        (REG_PHY2P1_1_P2_BASE + 0xD4)
#define REG_PHY2P1_1_P2_6A_H        (REG_PHY2P1_1_P2_BASE + 0xD5)
#define REG_PHY2P1_1_P2_6B_L        (REG_PHY2P1_1_P2_BASE + 0xD6)
#define REG_PHY2P1_1_P2_6B_H        (REG_PHY2P1_1_P2_BASE + 0xD7)
#define REG_PHY2P1_1_P2_6C_L        (REG_PHY2P1_1_P2_BASE + 0xD8)
#define REG_PHY2P1_1_P2_6C_H        (REG_PHY2P1_1_P2_BASE + 0xD9)
#define REG_PHY2P1_1_P2_6D_L        (REG_PHY2P1_1_P2_BASE + 0xDA)
#define REG_PHY2P1_1_P2_6D_H        (REG_PHY2P1_1_P2_BASE + 0xDB)
#define REG_PHY2P1_1_P2_6E_L        (REG_PHY2P1_1_P2_BASE + 0xDC)
#define REG_PHY2P1_1_P2_6E_H        (REG_PHY2P1_1_P2_BASE + 0xDD)
#define REG_PHY2P1_1_P2_6F_L        (REG_PHY2P1_1_P2_BASE + 0xDE)
#define REG_PHY2P1_1_P2_6F_H        (REG_PHY2P1_1_P2_BASE + 0xDF)
#define REG_PHY2P1_1_P2_70_L        (REG_PHY2P1_1_P2_BASE + 0xE0)
#define REG_PHY2P1_1_P2_70_H        (REG_PHY2P1_1_P2_BASE + 0xE1)
#define REG_PHY2P1_1_P2_71_L        (REG_PHY2P1_1_P2_BASE + 0xE2)
#define REG_PHY2P1_1_P2_71_H        (REG_PHY2P1_1_P2_BASE + 0xE3)
#define REG_PHY2P1_1_P2_72_L        (REG_PHY2P1_1_P2_BASE + 0xE4)
#define REG_PHY2P1_1_P2_72_H        (REG_PHY2P1_1_P2_BASE + 0xE5)
#define REG_PHY2P1_1_P2_73_L        (REG_PHY2P1_1_P2_BASE + 0xE6)
#define REG_PHY2P1_1_P2_73_H        (REG_PHY2P1_1_P2_BASE + 0xE7)
#define REG_PHY2P1_1_P2_74_L        (REG_PHY2P1_1_P2_BASE + 0xE8)
#define REG_PHY2P1_1_P2_74_H        (REG_PHY2P1_1_P2_BASE + 0xE9)
#define REG_PHY2P1_1_P2_75_L        (REG_PHY2P1_1_P2_BASE + 0xEA)
#define REG_PHY2P1_1_P2_75_H        (REG_PHY2P1_1_P2_BASE + 0xEB)
#define REG_PHY2P1_1_P2_76_L        (REG_PHY2P1_1_P2_BASE + 0xEC)
#define REG_PHY2P1_1_P2_76_H        (REG_PHY2P1_1_P2_BASE + 0xED)
#define REG_PHY2P1_1_P2_77_L        (REG_PHY2P1_1_P2_BASE + 0xEE)
#define REG_PHY2P1_1_P2_77_H        (REG_PHY2P1_1_P2_BASE + 0xEF)
#define REG_PHY2P1_1_P2_78_L        (REG_PHY2P1_1_P2_BASE + 0xF0)
#define REG_PHY2P1_1_P2_78_H        (REG_PHY2P1_1_P2_BASE + 0xF1)
#define REG_PHY2P1_1_P2_79_L        (REG_PHY2P1_1_P2_BASE + 0xF2)
#define REG_PHY2P1_1_P2_79_H        (REG_PHY2P1_1_P2_BASE + 0xF3)
#define REG_PHY2P1_1_P2_7A_L        (REG_PHY2P1_1_P2_BASE + 0xF4)
#define REG_PHY2P1_1_P2_7A_H        (REG_PHY2P1_1_P2_BASE + 0xF5)
#define REG_PHY2P1_1_P2_7B_L        (REG_PHY2P1_1_P2_BASE + 0xF6)
#define REG_PHY2P1_1_P2_7B_H        (REG_PHY2P1_1_P2_BASE + 0xF7)
#define REG_PHY2P1_1_P2_7C_L        (REG_PHY2P1_1_P2_BASE + 0xF8)
#define REG_PHY2P1_1_P2_7C_H        (REG_PHY2P1_1_P2_BASE + 0xF9)
#define REG_PHY2P1_1_P2_7D_L        (REG_PHY2P1_1_P2_BASE + 0xFA)
#define REG_PHY2P1_1_P2_7D_H        (REG_PHY2P1_1_P2_BASE + 0xFB)
#define REG_PHY2P1_1_P2_7E_L        (REG_PHY2P1_1_P2_BASE + 0xFC)
#define REG_PHY2P1_1_P2_7E_H        (REG_PHY2P1_1_P2_BASE + 0xFD)
#define REG_PHY2P1_1_P2_7F_L        (REG_PHY2P1_1_P2_BASE + 0xFE)
#define REG_PHY2P1_1_P2_7F_H        (REG_PHY2P1_1_P2_BASE + 0xFF)

//=============================================================
// PHY2P1_2_P2
#define REG_PHY2P1_2_P2_00_L        (REG_PHY2P1_2_P2_BASE + 0x00)
#define REG_PHY2P1_2_P2_00_H        (REG_PHY2P1_2_P2_BASE + 0x01)
#define REG_PHY2P1_2_P2_01_L        (REG_PHY2P1_2_P2_BASE + 0x02)
#define REG_PHY2P1_2_P2_01_H        (REG_PHY2P1_2_P2_BASE + 0x03)
#define REG_PHY2P1_2_P2_02_L        (REG_PHY2P1_2_P2_BASE + 0x04)
#define REG_PHY2P1_2_P2_02_H        (REG_PHY2P1_2_P2_BASE + 0x05)
#define REG_PHY2P1_2_P2_03_L        (REG_PHY2P1_2_P2_BASE + 0x06)
#define REG_PHY2P1_2_P2_03_H        (REG_PHY2P1_2_P2_BASE + 0x07)
#define REG_PHY2P1_2_P2_04_L        (REG_PHY2P1_2_P2_BASE + 0x08)
#define REG_PHY2P1_2_P2_04_H        (REG_PHY2P1_2_P2_BASE + 0x09)
#define REG_PHY2P1_2_P2_05_L        (REG_PHY2P1_2_P2_BASE + 0x0A)
#define REG_PHY2P1_2_P2_05_H        (REG_PHY2P1_2_P2_BASE + 0x0B)
#define REG_PHY2P1_2_P2_06_L        (REG_PHY2P1_2_P2_BASE + 0x0C)
#define REG_PHY2P1_2_P2_06_H        (REG_PHY2P1_2_P2_BASE + 0x0D)
#define REG_PHY2P1_2_P2_07_L        (REG_PHY2P1_2_P2_BASE + 0x0E)
#define REG_PHY2P1_2_P2_07_H        (REG_PHY2P1_2_P2_BASE + 0x0F)
#define REG_PHY2P1_2_P2_08_L        (REG_PHY2P1_2_P2_BASE + 0x10)
#define REG_PHY2P1_2_P2_08_H        (REG_PHY2P1_2_P2_BASE + 0x11)
#define REG_PHY2P1_2_P2_09_L        (REG_PHY2P1_2_P2_BASE + 0x12)
#define REG_PHY2P1_2_P2_09_H        (REG_PHY2P1_2_P2_BASE + 0x13)
#define REG_PHY2P1_2_P2_0A_L        (REG_PHY2P1_2_P2_BASE + 0x14)
#define REG_PHY2P1_2_P2_0A_H        (REG_PHY2P1_2_P2_BASE + 0x15)
#define REG_PHY2P1_2_P2_0B_L        (REG_PHY2P1_2_P2_BASE + 0x16)
#define REG_PHY2P1_2_P2_0B_H        (REG_PHY2P1_2_P2_BASE + 0x17)
#define REG_PHY2P1_2_P2_0C_L        (REG_PHY2P1_2_P2_BASE + 0x18)
#define REG_PHY2P1_2_P2_0C_H        (REG_PHY2P1_2_P2_BASE + 0x19)
#define REG_PHY2P1_2_P2_0D_L        (REG_PHY2P1_2_P2_BASE + 0x1A)
#define REG_PHY2P1_2_P2_0D_H        (REG_PHY2P1_2_P2_BASE + 0x1B)
#define REG_PHY2P1_2_P2_0E_L        (REG_PHY2P1_2_P2_BASE + 0x1C)
#define REG_PHY2P1_2_P2_0E_H        (REG_PHY2P1_2_P2_BASE + 0x1D)
#define REG_PHY2P1_2_P2_0F_L        (REG_PHY2P1_2_P2_BASE + 0x1E)
#define REG_PHY2P1_2_P2_0F_H        (REG_PHY2P1_2_P2_BASE + 0x1F)
#define REG_PHY2P1_2_P2_10_L        (REG_PHY2P1_2_P2_BASE + 0x20)
#define REG_PHY2P1_2_P2_10_H        (REG_PHY2P1_2_P2_BASE + 0x21)
#define REG_PHY2P1_2_P2_11_L        (REG_PHY2P1_2_P2_BASE + 0x22)
#define REG_PHY2P1_2_P2_11_H        (REG_PHY2P1_2_P2_BASE + 0x23)
#define REG_PHY2P1_2_P2_12_L        (REG_PHY2P1_2_P2_BASE + 0x24)
#define REG_PHY2P1_2_P2_12_H        (REG_PHY2P1_2_P2_BASE + 0x25)
#define REG_PHY2P1_2_P2_13_L        (REG_PHY2P1_2_P2_BASE + 0x26)
#define REG_PHY2P1_2_P2_13_H        (REG_PHY2P1_2_P2_BASE + 0x27)
#define REG_PHY2P1_2_P2_14_L        (REG_PHY2P1_2_P2_BASE + 0x28)
#define REG_PHY2P1_2_P2_14_H        (REG_PHY2P1_2_P2_BASE + 0x29)
#define REG_PHY2P1_2_P2_15_L        (REG_PHY2P1_2_P2_BASE + 0x2A)
#define REG_PHY2P1_2_P2_15_H        (REG_PHY2P1_2_P2_BASE + 0x2B)
#define REG_PHY2P1_2_P2_16_L        (REG_PHY2P1_2_P2_BASE + 0x2C)
#define REG_PHY2P1_2_P2_16_H        (REG_PHY2P1_2_P2_BASE + 0x2D)
#define REG_PHY2P1_2_P2_17_L        (REG_PHY2P1_2_P2_BASE + 0x2E)
#define REG_PHY2P1_2_P2_17_H        (REG_PHY2P1_2_P2_BASE + 0x2F)
#define REG_PHY2P1_2_P2_18_L        (REG_PHY2P1_2_P2_BASE + 0x30)
#define REG_PHY2P1_2_P2_18_H        (REG_PHY2P1_2_P2_BASE + 0x31)
#define REG_PHY2P1_2_P2_19_L        (REG_PHY2P1_2_P2_BASE + 0x32)
#define REG_PHY2P1_2_P2_19_H        (REG_PHY2P1_2_P2_BASE + 0x33)
#define REG_PHY2P1_2_P2_1A_L        (REG_PHY2P1_2_P2_BASE + 0x34)
#define REG_PHY2P1_2_P2_1A_H        (REG_PHY2P1_2_P2_BASE + 0x35)
#define REG_PHY2P1_2_P2_1B_L        (REG_PHY2P1_2_P2_BASE + 0x36)
#define REG_PHY2P1_2_P2_1B_H        (REG_PHY2P1_2_P2_BASE + 0x37)
#define REG_PHY2P1_2_P2_1C_L        (REG_PHY2P1_2_P2_BASE + 0x38)
#define REG_PHY2P1_2_P2_1C_H        (REG_PHY2P1_2_P2_BASE + 0x39)
#define REG_PHY2P1_2_P2_1D_L        (REG_PHY2P1_2_P2_BASE + 0x3A)
#define REG_PHY2P1_2_P2_1D_H        (REG_PHY2P1_2_P2_BASE + 0x3B)
#define REG_PHY2P1_2_P2_1E_L        (REG_PHY2P1_2_P2_BASE + 0x3C)
#define REG_PHY2P1_2_P2_1E_H        (REG_PHY2P1_2_P2_BASE + 0x3D)
#define REG_PHY2P1_2_P2_1F_L        (REG_PHY2P1_2_P2_BASE + 0x3E)
#define REG_PHY2P1_2_P2_1F_H        (REG_PHY2P1_2_P2_BASE + 0x3F)
#define REG_PHY2P1_2_P2_20_L        (REG_PHY2P1_2_P2_BASE + 0x40)
#define REG_PHY2P1_2_P2_20_H        (REG_PHY2P1_2_P2_BASE + 0x41)
#define REG_PHY2P1_2_P2_21_L        (REG_PHY2P1_2_P2_BASE + 0x42)
#define REG_PHY2P1_2_P2_21_H        (REG_PHY2P1_2_P2_BASE + 0x43)
#define REG_PHY2P1_2_P2_22_L        (REG_PHY2P1_2_P2_BASE + 0x44)
#define REG_PHY2P1_2_P2_22_H        (REG_PHY2P1_2_P2_BASE + 0x45)
#define REG_PHY2P1_2_P2_23_L        (REG_PHY2P1_2_P2_BASE + 0x46)
#define REG_PHY2P1_2_P2_23_H        (REG_PHY2P1_2_P2_BASE + 0x47)
#define REG_PHY2P1_2_P2_24_L        (REG_PHY2P1_2_P2_BASE + 0x48)
#define REG_PHY2P1_2_P2_24_H        (REG_PHY2P1_2_P2_BASE + 0x49)
#define REG_PHY2P1_2_P2_25_L        (REG_PHY2P1_2_P2_BASE + 0x4A)
#define REG_PHY2P1_2_P2_25_H        (REG_PHY2P1_2_P2_BASE + 0x4B)
#define REG_PHY2P1_2_P2_26_L        (REG_PHY2P1_2_P2_BASE + 0x4C)
#define REG_PHY2P1_2_P2_26_H        (REG_PHY2P1_2_P2_BASE + 0x4D)
#define REG_PHY2P1_2_P2_27_L        (REG_PHY2P1_2_P2_BASE + 0x4E)
#define REG_PHY2P1_2_P2_27_H        (REG_PHY2P1_2_P2_BASE + 0x4F)
#define REG_PHY2P1_2_P2_28_L        (REG_PHY2P1_2_P2_BASE + 0x50)
#define REG_PHY2P1_2_P2_28_H        (REG_PHY2P1_2_P2_BASE + 0x51)
#define REG_PHY2P1_2_P2_29_L        (REG_PHY2P1_2_P2_BASE + 0x52)
#define REG_PHY2P1_2_P2_29_H        (REG_PHY2P1_2_P2_BASE + 0x53)
#define REG_PHY2P1_2_P2_2A_L        (REG_PHY2P1_2_P2_BASE + 0x54)
#define REG_PHY2P1_2_P2_2A_H        (REG_PHY2P1_2_P2_BASE + 0x55)
#define REG_PHY2P1_2_P2_2B_L        (REG_PHY2P1_2_P2_BASE + 0x56)
#define REG_PHY2P1_2_P2_2B_H        (REG_PHY2P1_2_P2_BASE + 0x57)
#define REG_PHY2P1_2_P2_2C_L        (REG_PHY2P1_2_P2_BASE + 0x58)
#define REG_PHY2P1_2_P2_2C_H        (REG_PHY2P1_2_P2_BASE + 0x59)
#define REG_PHY2P1_2_P2_2D_L        (REG_PHY2P1_2_P2_BASE + 0x5A)
#define REG_PHY2P1_2_P2_2D_H        (REG_PHY2P1_2_P2_BASE + 0x5B)
#define REG_PHY2P1_2_P2_2E_L        (REG_PHY2P1_2_P2_BASE + 0x5C)
#define REG_PHY2P1_2_P2_2E_H        (REG_PHY2P1_2_P2_BASE + 0x5D)
#define REG_PHY2P1_2_P2_2F_L        (REG_PHY2P1_2_P2_BASE + 0x5E)
#define REG_PHY2P1_2_P2_2F_H        (REG_PHY2P1_2_P2_BASE + 0x5F)
#define REG_PHY2P1_2_P2_30_L        (REG_PHY2P1_2_P2_BASE + 0x60)
#define REG_PHY2P1_2_P2_30_H        (REG_PHY2P1_2_P2_BASE + 0x61)
#define REG_PHY2P1_2_P2_31_L        (REG_PHY2P1_2_P2_BASE + 0x62)
#define REG_PHY2P1_2_P2_31_H        (REG_PHY2P1_2_P2_BASE + 0x63)
#define REG_PHY2P1_2_P2_32_L        (REG_PHY2P1_2_P2_BASE + 0x64)
#define REG_PHY2P1_2_P2_32_H        (REG_PHY2P1_2_P2_BASE + 0x65)
#define REG_PHY2P1_2_P2_33_L        (REG_PHY2P1_2_P2_BASE + 0x66)
#define REG_PHY2P1_2_P2_33_H        (REG_PHY2P1_2_P2_BASE + 0x67)
#define REG_PHY2P1_2_P2_34_L        (REG_PHY2P1_2_P2_BASE + 0x68)
#define REG_PHY2P1_2_P2_34_H        (REG_PHY2P1_2_P2_BASE + 0x69)
#define REG_PHY2P1_2_P2_35_L        (REG_PHY2P1_2_P2_BASE + 0x6A)
#define REG_PHY2P1_2_P2_35_H        (REG_PHY2P1_2_P2_BASE + 0x6B)
#define REG_PHY2P1_2_P2_36_L        (REG_PHY2P1_2_P2_BASE + 0x6C)
#define REG_PHY2P1_2_P2_36_H        (REG_PHY2P1_2_P2_BASE + 0x6D)
#define REG_PHY2P1_2_P2_37_L        (REG_PHY2P1_2_P2_BASE + 0x6E)
#define REG_PHY2P1_2_P2_37_H        (REG_PHY2P1_2_P2_BASE + 0x6F)
#define REG_PHY2P1_2_P2_38_L        (REG_PHY2P1_2_P2_BASE + 0x70)
#define REG_PHY2P1_2_P2_38_H        (REG_PHY2P1_2_P2_BASE + 0x71)
#define REG_PHY2P1_2_P2_39_L        (REG_PHY2P1_2_P2_BASE + 0x72)
#define REG_PHY2P1_2_P2_39_H        (REG_PHY2P1_2_P2_BASE + 0x73)
#define REG_PHY2P1_2_P2_3A_L        (REG_PHY2P1_2_P2_BASE + 0x74)
#define REG_PHY2P1_2_P2_3A_H        (REG_PHY2P1_2_P2_BASE + 0x75)
#define REG_PHY2P1_2_P2_3B_L        (REG_PHY2P1_2_P2_BASE + 0x76)
#define REG_PHY2P1_2_P2_3B_H        (REG_PHY2P1_2_P2_BASE + 0x77)
#define REG_PHY2P1_2_P2_3C_L        (REG_PHY2P1_2_P2_BASE + 0x78)
#define REG_PHY2P1_2_P2_3C_H        (REG_PHY2P1_2_P2_BASE + 0x79)
#define REG_PHY2P1_2_P2_3D_L        (REG_PHY2P1_2_P2_BASE + 0x7A)
#define REG_PHY2P1_2_P2_3D_H        (REG_PHY2P1_2_P2_BASE + 0x7B)
#define REG_PHY2P1_2_P2_3E_L        (REG_PHY2P1_2_P2_BASE + 0x7C)
#define REG_PHY2P1_2_P2_3E_H        (REG_PHY2P1_2_P2_BASE + 0x7D)
#define REG_PHY2P1_2_P2_3F_L        (REG_PHY2P1_2_P2_BASE + 0x7E)
#define REG_PHY2P1_2_P2_3F_H        (REG_PHY2P1_2_P2_BASE + 0x7F)
#define REG_PHY2P1_2_P2_40_L        (REG_PHY2P1_2_P2_BASE + 0x80)
#define REG_PHY2P1_2_P2_40_H        (REG_PHY2P1_2_P2_BASE + 0x81)
#define REG_PHY2P1_2_P2_41_L        (REG_PHY2P1_2_P2_BASE + 0x82)
#define REG_PHY2P1_2_P2_41_H        (REG_PHY2P1_2_P2_BASE + 0x83)
#define REG_PHY2P1_2_P2_42_L        (REG_PHY2P1_2_P2_BASE + 0x84)
#define REG_PHY2P1_2_P2_42_H        (REG_PHY2P1_2_P2_BASE + 0x85)
#define REG_PHY2P1_2_P2_43_L        (REG_PHY2P1_2_P2_BASE + 0x86)
#define REG_PHY2P1_2_P2_43_H        (REG_PHY2P1_2_P2_BASE + 0x87)
#define REG_PHY2P1_2_P2_44_L        (REG_PHY2P1_2_P2_BASE + 0x88)
#define REG_PHY2P1_2_P2_44_H        (REG_PHY2P1_2_P2_BASE + 0x89)
#define REG_PHY2P1_2_P2_45_L        (REG_PHY2P1_2_P2_BASE + 0x8A)
#define REG_PHY2P1_2_P2_45_H        (REG_PHY2P1_2_P2_BASE + 0x8B)
#define REG_PHY2P1_2_P2_46_L        (REG_PHY2P1_2_P2_BASE + 0x8C)
#define REG_PHY2P1_2_P2_46_H        (REG_PHY2P1_2_P2_BASE + 0x8D)
#define REG_PHY2P1_2_P2_47_L        (REG_PHY2P1_2_P2_BASE + 0x8E)
#define REG_PHY2P1_2_P2_47_H        (REG_PHY2P1_2_P2_BASE + 0x8F)
#define REG_PHY2P1_2_P2_48_L        (REG_PHY2P1_2_P2_BASE + 0x90)
#define REG_PHY2P1_2_P2_48_H        (REG_PHY2P1_2_P2_BASE + 0x91)
#define REG_PHY2P1_2_P2_49_L        (REG_PHY2P1_2_P2_BASE + 0x92)
#define REG_PHY2P1_2_P2_49_H        (REG_PHY2P1_2_P2_BASE + 0x93)
#define REG_PHY2P1_2_P2_4A_L        (REG_PHY2P1_2_P2_BASE + 0x94)
#define REG_PHY2P1_2_P2_4A_H        (REG_PHY2P1_2_P2_BASE + 0x95)
#define REG_PHY2P1_2_P2_4B_L        (REG_PHY2P1_2_P2_BASE + 0x96)
#define REG_PHY2P1_2_P2_4B_H        (REG_PHY2P1_2_P2_BASE + 0x97)
#define REG_PHY2P1_2_P2_4C_L        (REG_PHY2P1_2_P2_BASE + 0x98)
#define REG_PHY2P1_2_P2_4C_H        (REG_PHY2P1_2_P2_BASE + 0x99)
#define REG_PHY2P1_2_P2_4D_L        (REG_PHY2P1_2_P2_BASE + 0x9A)
#define REG_PHY2P1_2_P2_4D_H        (REG_PHY2P1_2_P2_BASE + 0x9B)
#define REG_PHY2P1_2_P2_4E_L        (REG_PHY2P1_2_P2_BASE + 0x9C)
#define REG_PHY2P1_2_P2_4E_H        (REG_PHY2P1_2_P2_BASE + 0x9D)
#define REG_PHY2P1_2_P2_4F_L        (REG_PHY2P1_2_P2_BASE + 0x9E)
#define REG_PHY2P1_2_P2_4F_H        (REG_PHY2P1_2_P2_BASE + 0x9F)
#define REG_PHY2P1_2_P2_50_L        (REG_PHY2P1_2_P2_BASE + 0xA0)
#define REG_PHY2P1_2_P2_50_H        (REG_PHY2P1_2_P2_BASE + 0xA1)
#define REG_PHY2P1_2_P2_51_L        (REG_PHY2P1_2_P2_BASE + 0xA2)
#define REG_PHY2P1_2_P2_51_H        (REG_PHY2P1_2_P2_BASE + 0xA3)
#define REG_PHY2P1_2_P2_52_L        (REG_PHY2P1_2_P2_BASE + 0xA4)
#define REG_PHY2P1_2_P2_52_H        (REG_PHY2P1_2_P2_BASE + 0xA5)
#define REG_PHY2P1_2_P2_53_L        (REG_PHY2P1_2_P2_BASE + 0xA6)
#define REG_PHY2P1_2_P2_53_H        (REG_PHY2P1_2_P2_BASE + 0xA7)
#define REG_PHY2P1_2_P2_54_L        (REG_PHY2P1_2_P2_BASE + 0xA8)
#define REG_PHY2P1_2_P2_54_H        (REG_PHY2P1_2_P2_BASE + 0xA9)
#define REG_PHY2P1_2_P2_55_L        (REG_PHY2P1_2_P2_BASE + 0xAA)
#define REG_PHY2P1_2_P2_55_H        (REG_PHY2P1_2_P2_BASE + 0xAB)
#define REG_PHY2P1_2_P2_56_L        (REG_PHY2P1_2_P2_BASE + 0xAC)
#define REG_PHY2P1_2_P2_56_H        (REG_PHY2P1_2_P2_BASE + 0xAD)
#define REG_PHY2P1_2_P2_57_L        (REG_PHY2P1_2_P2_BASE + 0xAE)
#define REG_PHY2P1_2_P2_57_H        (REG_PHY2P1_2_P2_BASE + 0xAF)
#define REG_PHY2P1_2_P2_58_L        (REG_PHY2P1_2_P2_BASE + 0xB0)
#define REG_PHY2P1_2_P2_58_H        (REG_PHY2P1_2_P2_BASE + 0xB1)
#define REG_PHY2P1_2_P2_59_L        (REG_PHY2P1_2_P2_BASE + 0xB2)
#define REG_PHY2P1_2_P2_59_H        (REG_PHY2P1_2_P2_BASE + 0xB3)
#define REG_PHY2P1_2_P2_5A_L        (REG_PHY2P1_2_P2_BASE + 0xB4)
#define REG_PHY2P1_2_P2_5A_H        (REG_PHY2P1_2_P2_BASE + 0xB5)
#define REG_PHY2P1_2_P2_5B_L        (REG_PHY2P1_2_P2_BASE + 0xB6)
#define REG_PHY2P1_2_P2_5B_H        (REG_PHY2P1_2_P2_BASE + 0xB7)
#define REG_PHY2P1_2_P2_5C_L        (REG_PHY2P1_2_P2_BASE + 0xB8)
#define REG_PHY2P1_2_P2_5C_H        (REG_PHY2P1_2_P2_BASE + 0xB9)
#define REG_PHY2P1_2_P2_5D_L        (REG_PHY2P1_2_P2_BASE + 0xBA)
#define REG_PHY2P1_2_P2_5D_H        (REG_PHY2P1_2_P2_BASE + 0xBB)
#define REG_PHY2P1_2_P2_5E_L        (REG_PHY2P1_2_P2_BASE + 0xBC)
#define REG_PHY2P1_2_P2_5E_H        (REG_PHY2P1_2_P2_BASE + 0xBD)
#define REG_PHY2P1_2_P2_5F_L        (REG_PHY2P1_2_P2_BASE + 0xBE)
#define REG_PHY2P1_2_P2_5F_H        (REG_PHY2P1_2_P2_BASE + 0xBF)
#define REG_PHY2P1_2_P2_60_L        (REG_PHY2P1_2_P2_BASE + 0xC0)
#define REG_PHY2P1_2_P2_60_H        (REG_PHY2P1_2_P2_BASE + 0xC1)
#define REG_PHY2P1_2_P2_61_L        (REG_PHY2P1_2_P2_BASE + 0xC2)
#define REG_PHY2P1_2_P2_61_H        (REG_PHY2P1_2_P2_BASE + 0xC3)
#define REG_PHY2P1_2_P2_62_L        (REG_PHY2P1_2_P2_BASE + 0xC4)
#define REG_PHY2P1_2_P2_62_H        (REG_PHY2P1_2_P2_BASE + 0xC5)
#define REG_PHY2P1_2_P2_63_L        (REG_PHY2P1_2_P2_BASE + 0xC6)
#define REG_PHY2P1_2_P2_63_H        (REG_PHY2P1_2_P2_BASE + 0xC7)
#define REG_PHY2P1_2_P2_64_L        (REG_PHY2P1_2_P2_BASE + 0xC8)
#define REG_PHY2P1_2_P2_64_H        (REG_PHY2P1_2_P2_BASE + 0xC9)
#define REG_PHY2P1_2_P2_65_L        (REG_PHY2P1_2_P2_BASE + 0xCA)
#define REG_PHY2P1_2_P2_65_H        (REG_PHY2P1_2_P2_BASE + 0xCB)
#define REG_PHY2P1_2_P2_66_L        (REG_PHY2P1_2_P2_BASE + 0xCC)
#define REG_PHY2P1_2_P2_66_H        (REG_PHY2P1_2_P2_BASE + 0xCD)
#define REG_PHY2P1_2_P2_67_L        (REG_PHY2P1_2_P2_BASE + 0xCE)
#define REG_PHY2P1_2_P2_67_H        (REG_PHY2P1_2_P2_BASE + 0xCF)
#define REG_PHY2P1_2_P2_68_L        (REG_PHY2P1_2_P2_BASE + 0xD0)
#define REG_PHY2P1_2_P2_68_H        (REG_PHY2P1_2_P2_BASE + 0xD1)
#define REG_PHY2P1_2_P2_69_L        (REG_PHY2P1_2_P2_BASE + 0xD2)
#define REG_PHY2P1_2_P2_69_H        (REG_PHY2P1_2_P2_BASE + 0xD3)
#define REG_PHY2P1_2_P2_6A_L        (REG_PHY2P1_2_P2_BASE + 0xD4)
#define REG_PHY2P1_2_P2_6A_H        (REG_PHY2P1_2_P2_BASE + 0xD5)
#define REG_PHY2P1_2_P2_6B_L        (REG_PHY2P1_2_P2_BASE + 0xD6)
#define REG_PHY2P1_2_P2_6B_H        (REG_PHY2P1_2_P2_BASE + 0xD7)
#define REG_PHY2P1_2_P2_6C_L        (REG_PHY2P1_2_P2_BASE + 0xD8)
#define REG_PHY2P1_2_P2_6C_H        (REG_PHY2P1_2_P2_BASE + 0xD9)
#define REG_PHY2P1_2_P2_6D_L        (REG_PHY2P1_2_P2_BASE + 0xDA)
#define REG_PHY2P1_2_P2_6D_H        (REG_PHY2P1_2_P2_BASE + 0xDB)
#define REG_PHY2P1_2_P2_6E_L        (REG_PHY2P1_2_P2_BASE + 0xDC)
#define REG_PHY2P1_2_P2_6E_H        (REG_PHY2P1_2_P2_BASE + 0xDD)
#define REG_PHY2P1_2_P2_6F_L        (REG_PHY2P1_2_P2_BASE + 0xDE)
#define REG_PHY2P1_2_P2_6F_H        (REG_PHY2P1_2_P2_BASE + 0xDF)
#define REG_PHY2P1_2_P2_70_L        (REG_PHY2P1_2_P2_BASE + 0xE0)
#define REG_PHY2P1_2_P2_70_H        (REG_PHY2P1_2_P2_BASE + 0xE1)
#define REG_PHY2P1_2_P2_71_L        (REG_PHY2P1_2_P2_BASE + 0xE2)
#define REG_PHY2P1_2_P2_71_H        (REG_PHY2P1_2_P2_BASE + 0xE3)
#define REG_PHY2P1_2_P2_72_L        (REG_PHY2P1_2_P2_BASE + 0xE4)
#define REG_PHY2P1_2_P2_72_H        (REG_PHY2P1_2_P2_BASE + 0xE5)
#define REG_PHY2P1_2_P2_73_L        (REG_PHY2P1_2_P2_BASE + 0xE6)
#define REG_PHY2P1_2_P2_73_H        (REG_PHY2P1_2_P2_BASE + 0xE7)
#define REG_PHY2P1_2_P2_74_L        (REG_PHY2P1_2_P2_BASE + 0xE8)
#define REG_PHY2P1_2_P2_74_H        (REG_PHY2P1_2_P2_BASE + 0xE9)
#define REG_PHY2P1_2_P2_75_L        (REG_PHY2P1_2_P2_BASE + 0xEA)
#define REG_PHY2P1_2_P2_75_H        (REG_PHY2P1_2_P2_BASE + 0xEB)
#define REG_PHY2P1_2_P2_76_L        (REG_PHY2P1_2_P2_BASE + 0xEC)
#define REG_PHY2P1_2_P2_76_H        (REG_PHY2P1_2_P2_BASE + 0xED)
#define REG_PHY2P1_2_P2_77_L        (REG_PHY2P1_2_P2_BASE + 0xEE)
#define REG_PHY2P1_2_P2_77_H        (REG_PHY2P1_2_P2_BASE + 0xEF)
#define REG_PHY2P1_2_P2_78_L        (REG_PHY2P1_2_P2_BASE + 0xF0)
#define REG_PHY2P1_2_P2_78_H        (REG_PHY2P1_2_P2_BASE + 0xF1)
#define REG_PHY2P1_2_P2_79_L        (REG_PHY2P1_2_P2_BASE + 0xF2)
#define REG_PHY2P1_2_P2_79_H        (REG_PHY2P1_2_P2_BASE + 0xF3)
#define REG_PHY2P1_2_P2_7A_L        (REG_PHY2P1_2_P2_BASE + 0xF4)
#define REG_PHY2P1_2_P2_7A_H        (REG_PHY2P1_2_P2_BASE + 0xF5)
#define REG_PHY2P1_2_P2_7B_L        (REG_PHY2P1_2_P2_BASE + 0xF6)
#define REG_PHY2P1_2_P2_7B_H        (REG_PHY2P1_2_P2_BASE + 0xF7)
#define REG_PHY2P1_2_P2_7C_L        (REG_PHY2P1_2_P2_BASE + 0xF8)
#define REG_PHY2P1_2_P2_7C_H        (REG_PHY2P1_2_P2_BASE + 0xF9)
#define REG_PHY2P1_2_P2_7D_L        (REG_PHY2P1_2_P2_BASE + 0xFA)
#define REG_PHY2P1_2_P2_7D_H        (REG_PHY2P1_2_P2_BASE + 0xFB)
#define REG_PHY2P1_2_P2_7E_L        (REG_PHY2P1_2_P2_BASE + 0xFC)
#define REG_PHY2P1_2_P2_7E_H        (REG_PHY2P1_2_P2_BASE + 0xFD)
#define REG_PHY2P1_2_P2_7F_L        (REG_PHY2P1_2_P2_BASE + 0xFE)
#define REG_PHY2P1_2_P2_7F_H        (REG_PHY2P1_2_P2_BASE + 0xFF)

//=============================================================
// PHY2P1_3_P2
#define REG_PHY2P1_3_P2_00_L        (REG_PHY2P1_3_P2_BASE + 0x00)
#define REG_PHY2P1_3_P2_00_H        (REG_PHY2P1_3_P2_BASE + 0x01)
#define REG_PHY2P1_3_P2_01_L        (REG_PHY2P1_3_P2_BASE + 0x02)
#define REG_PHY2P1_3_P2_01_H        (REG_PHY2P1_3_P2_BASE + 0x03)
#define REG_PHY2P1_3_P2_02_L        (REG_PHY2P1_3_P2_BASE + 0x04)
#define REG_PHY2P1_3_P2_02_H        (REG_PHY2P1_3_P2_BASE + 0x05)
#define REG_PHY2P1_3_P2_03_L        (REG_PHY2P1_3_P2_BASE + 0x06)
#define REG_PHY2P1_3_P2_03_H        (REG_PHY2P1_3_P2_BASE + 0x07)
#define REG_PHY2P1_3_P2_04_L        (REG_PHY2P1_3_P2_BASE + 0x08)
#define REG_PHY2P1_3_P2_04_H        (REG_PHY2P1_3_P2_BASE + 0x09)
#define REG_PHY2P1_3_P2_05_L        (REG_PHY2P1_3_P2_BASE + 0x0A)
#define REG_PHY2P1_3_P2_05_H        (REG_PHY2P1_3_P2_BASE + 0x0B)
#define REG_PHY2P1_3_P2_06_L        (REG_PHY2P1_3_P2_BASE + 0x0C)
#define REG_PHY2P1_3_P2_06_H        (REG_PHY2P1_3_P2_BASE + 0x0D)
#define REG_PHY2P1_3_P2_07_L        (REG_PHY2P1_3_P2_BASE + 0x0E)
#define REG_PHY2P1_3_P2_07_H        (REG_PHY2P1_3_P2_BASE + 0x0F)
#define REG_PHY2P1_3_P2_08_L        (REG_PHY2P1_3_P2_BASE + 0x10)
#define REG_PHY2P1_3_P2_08_H        (REG_PHY2P1_3_P2_BASE + 0x11)
#define REG_PHY2P1_3_P2_09_L        (REG_PHY2P1_3_P2_BASE + 0x12)
#define REG_PHY2P1_3_P2_09_H        (REG_PHY2P1_3_P2_BASE + 0x13)
#define REG_PHY2P1_3_P2_0A_L        (REG_PHY2P1_3_P2_BASE + 0x14)
#define REG_PHY2P1_3_P2_0A_H        (REG_PHY2P1_3_P2_BASE + 0x15)
#define REG_PHY2P1_3_P2_0B_L        (REG_PHY2P1_3_P2_BASE + 0x16)
#define REG_PHY2P1_3_P2_0B_H        (REG_PHY2P1_3_P2_BASE + 0x17)
#define REG_PHY2P1_3_P2_0C_L        (REG_PHY2P1_3_P2_BASE + 0x18)
#define REG_PHY2P1_3_P2_0C_H        (REG_PHY2P1_3_P2_BASE + 0x19)
#define REG_PHY2P1_3_P2_0D_L        (REG_PHY2P1_3_P2_BASE + 0x1A)
#define REG_PHY2P1_3_P2_0D_H        (REG_PHY2P1_3_P2_BASE + 0x1B)
#define REG_PHY2P1_3_P2_0E_L        (REG_PHY2P1_3_P2_BASE + 0x1C)
#define REG_PHY2P1_3_P2_0E_H        (REG_PHY2P1_3_P2_BASE + 0x1D)
#define REG_PHY2P1_3_P2_0F_L        (REG_PHY2P1_3_P2_BASE + 0x1E)
#define REG_PHY2P1_3_P2_0F_H        (REG_PHY2P1_3_P2_BASE + 0x1F)
#define REG_PHY2P1_3_P2_10_L        (REG_PHY2P1_3_P2_BASE + 0x20)
#define REG_PHY2P1_3_P2_10_H        (REG_PHY2P1_3_P2_BASE + 0x21)
#define REG_PHY2P1_3_P2_11_L        (REG_PHY2P1_3_P2_BASE + 0x22)
#define REG_PHY2P1_3_P2_11_H        (REG_PHY2P1_3_P2_BASE + 0x23)
#define REG_PHY2P1_3_P2_12_L        (REG_PHY2P1_3_P2_BASE + 0x24)
#define REG_PHY2P1_3_P2_12_H        (REG_PHY2P1_3_P2_BASE + 0x25)
#define REG_PHY2P1_3_P2_13_L        (REG_PHY2P1_3_P2_BASE + 0x26)
#define REG_PHY2P1_3_P2_13_H        (REG_PHY2P1_3_P2_BASE + 0x27)
#define REG_PHY2P1_3_P2_14_L        (REG_PHY2P1_3_P2_BASE + 0x28)
#define REG_PHY2P1_3_P2_14_H        (REG_PHY2P1_3_P2_BASE + 0x29)
#define REG_PHY2P1_3_P2_15_L        (REG_PHY2P1_3_P2_BASE + 0x2A)
#define REG_PHY2P1_3_P2_15_H        (REG_PHY2P1_3_P2_BASE + 0x2B)
#define REG_PHY2P1_3_P2_16_L        (REG_PHY2P1_3_P2_BASE + 0x2C)
#define REG_PHY2P1_3_P2_16_H        (REG_PHY2P1_3_P2_BASE + 0x2D)
#define REG_PHY2P1_3_P2_17_L        (REG_PHY2P1_3_P2_BASE + 0x2E)
#define REG_PHY2P1_3_P2_17_H        (REG_PHY2P1_3_P2_BASE + 0x2F)
#define REG_PHY2P1_3_P2_18_L        (REG_PHY2P1_3_P2_BASE + 0x30)
#define REG_PHY2P1_3_P2_18_H        (REG_PHY2P1_3_P2_BASE + 0x31)
#define REG_PHY2P1_3_P2_19_L        (REG_PHY2P1_3_P2_BASE + 0x32)
#define REG_PHY2P1_3_P2_19_H        (REG_PHY2P1_3_P2_BASE + 0x33)
#define REG_PHY2P1_3_P2_1A_L        (REG_PHY2P1_3_P2_BASE + 0x34)
#define REG_PHY2P1_3_P2_1A_H        (REG_PHY2P1_3_P2_BASE + 0x35)
#define REG_PHY2P1_3_P2_1B_L        (REG_PHY2P1_3_P2_BASE + 0x36)
#define REG_PHY2P1_3_P2_1B_H        (REG_PHY2P1_3_P2_BASE + 0x37)
#define REG_PHY2P1_3_P2_1C_L        (REG_PHY2P1_3_P2_BASE + 0x38)
#define REG_PHY2P1_3_P2_1C_H        (REG_PHY2P1_3_P2_BASE + 0x39)
#define REG_PHY2P1_3_P2_1D_L        (REG_PHY2P1_3_P2_BASE + 0x3A)
#define REG_PHY2P1_3_P2_1D_H        (REG_PHY2P1_3_P2_BASE + 0x3B)
#define REG_PHY2P1_3_P2_1E_L        (REG_PHY2P1_3_P2_BASE + 0x3C)
#define REG_PHY2P1_3_P2_1E_H        (REG_PHY2P1_3_P2_BASE + 0x3D)
#define REG_PHY2P1_3_P2_1F_L        (REG_PHY2P1_3_P2_BASE + 0x3E)
#define REG_PHY2P1_3_P2_1F_H        (REG_PHY2P1_3_P2_BASE + 0x3F)
#define REG_PHY2P1_3_P2_20_L        (REG_PHY2P1_3_P2_BASE + 0x40)
#define REG_PHY2P1_3_P2_20_H        (REG_PHY2P1_3_P2_BASE + 0x41)
#define REG_PHY2P1_3_P2_21_L        (REG_PHY2P1_3_P2_BASE + 0x42)
#define REG_PHY2P1_3_P2_21_H        (REG_PHY2P1_3_P2_BASE + 0x43)
#define REG_PHY2P1_3_P2_22_L        (REG_PHY2P1_3_P2_BASE + 0x44)
#define REG_PHY2P1_3_P2_22_H        (REG_PHY2P1_3_P2_BASE + 0x45)
#define REG_PHY2P1_3_P2_23_L        (REG_PHY2P1_3_P2_BASE + 0x46)
#define REG_PHY2P1_3_P2_23_H        (REG_PHY2P1_3_P2_BASE + 0x47)
#define REG_PHY2P1_3_P2_24_L        (REG_PHY2P1_3_P2_BASE + 0x48)
#define REG_PHY2P1_3_P2_24_H        (REG_PHY2P1_3_P2_BASE + 0x49)
#define REG_PHY2P1_3_P2_25_L        (REG_PHY2P1_3_P2_BASE + 0x4A)
#define REG_PHY2P1_3_P2_25_H        (REG_PHY2P1_3_P2_BASE + 0x4B)
#define REG_PHY2P1_3_P2_26_L        (REG_PHY2P1_3_P2_BASE + 0x4C)
#define REG_PHY2P1_3_P2_26_H        (REG_PHY2P1_3_P2_BASE + 0x4D)
#define REG_PHY2P1_3_P2_27_L        (REG_PHY2P1_3_P2_BASE + 0x4E)
#define REG_PHY2P1_3_P2_27_H        (REG_PHY2P1_3_P2_BASE + 0x4F)
#define REG_PHY2P1_3_P2_28_L        (REG_PHY2P1_3_P2_BASE + 0x50)
#define REG_PHY2P1_3_P2_28_H        (REG_PHY2P1_3_P2_BASE + 0x51)
#define REG_PHY2P1_3_P2_29_L        (REG_PHY2P1_3_P2_BASE + 0x52)
#define REG_PHY2P1_3_P2_29_H        (REG_PHY2P1_3_P2_BASE + 0x53)
#define REG_PHY2P1_3_P2_2A_L        (REG_PHY2P1_3_P2_BASE + 0x54)
#define REG_PHY2P1_3_P2_2A_H        (REG_PHY2P1_3_P2_BASE + 0x55)
#define REG_PHY2P1_3_P2_2B_L        (REG_PHY2P1_3_P2_BASE + 0x56)
#define REG_PHY2P1_3_P2_2B_H        (REG_PHY2P1_3_P2_BASE + 0x57)
#define REG_PHY2P1_3_P2_2C_L        (REG_PHY2P1_3_P2_BASE + 0x58)
#define REG_PHY2P1_3_P2_2C_H        (REG_PHY2P1_3_P2_BASE + 0x59)
#define REG_PHY2P1_3_P2_2D_L        (REG_PHY2P1_3_P2_BASE + 0x5A)
#define REG_PHY2P1_3_P2_2D_H        (REG_PHY2P1_3_P2_BASE + 0x5B)
#define REG_PHY2P1_3_P2_2E_L        (REG_PHY2P1_3_P2_BASE + 0x5C)
#define REG_PHY2P1_3_P2_2E_H        (REG_PHY2P1_3_P2_BASE + 0x5D)
#define REG_PHY2P1_3_P2_2F_L        (REG_PHY2P1_3_P2_BASE + 0x5E)
#define REG_PHY2P1_3_P2_2F_H        (REG_PHY2P1_3_P2_BASE + 0x5F)
#define REG_PHY2P1_3_P2_30_L        (REG_PHY2P1_3_P2_BASE + 0x60)
#define REG_PHY2P1_3_P2_30_H        (REG_PHY2P1_3_P2_BASE + 0x61)
#define REG_PHY2P1_3_P2_31_L        (REG_PHY2P1_3_P2_BASE + 0x62)
#define REG_PHY2P1_3_P2_31_H        (REG_PHY2P1_3_P2_BASE + 0x63)
#define REG_PHY2P1_3_P2_32_L        (REG_PHY2P1_3_P2_BASE + 0x64)
#define REG_PHY2P1_3_P2_32_H        (REG_PHY2P1_3_P2_BASE + 0x65)
#define REG_PHY2P1_3_P2_33_L        (REG_PHY2P1_3_P2_BASE + 0x66)
#define REG_PHY2P1_3_P2_33_H        (REG_PHY2P1_3_P2_BASE + 0x67)
#define REG_PHY2P1_3_P2_34_L        (REG_PHY2P1_3_P2_BASE + 0x68)
#define REG_PHY2P1_3_P2_34_H        (REG_PHY2P1_3_P2_BASE + 0x69)
#define REG_PHY2P1_3_P2_35_L        (REG_PHY2P1_3_P2_BASE + 0x6A)
#define REG_PHY2P1_3_P2_35_H        (REG_PHY2P1_3_P2_BASE + 0x6B)
#define REG_PHY2P1_3_P2_36_L        (REG_PHY2P1_3_P2_BASE + 0x6C)
#define REG_PHY2P1_3_P2_36_H        (REG_PHY2P1_3_P2_BASE + 0x6D)
#define REG_PHY2P1_3_P2_37_L        (REG_PHY2P1_3_P2_BASE + 0x6E)
#define REG_PHY2P1_3_P2_37_H        (REG_PHY2P1_3_P2_BASE + 0x6F)
#define REG_PHY2P1_3_P2_38_L        (REG_PHY2P1_3_P2_BASE + 0x70)
#define REG_PHY2P1_3_P2_38_H        (REG_PHY2P1_3_P2_BASE + 0x71)
#define REG_PHY2P1_3_P2_39_L        (REG_PHY2P1_3_P2_BASE + 0x72)
#define REG_PHY2P1_3_P2_39_H        (REG_PHY2P1_3_P2_BASE + 0x73)
#define REG_PHY2P1_3_P2_3A_L        (REG_PHY2P1_3_P2_BASE + 0x74)
#define REG_PHY2P1_3_P2_3A_H        (REG_PHY2P1_3_P2_BASE + 0x75)
#define REG_PHY2P1_3_P2_3B_L        (REG_PHY2P1_3_P2_BASE + 0x76)
#define REG_PHY2P1_3_P2_3B_H        (REG_PHY2P1_3_P2_BASE + 0x77)
#define REG_PHY2P1_3_P2_3C_L        (REG_PHY2P1_3_P2_BASE + 0x78)
#define REG_PHY2P1_3_P2_3C_H        (REG_PHY2P1_3_P2_BASE + 0x79)
#define REG_PHY2P1_3_P2_3D_L        (REG_PHY2P1_3_P2_BASE + 0x7A)
#define REG_PHY2P1_3_P2_3D_H        (REG_PHY2P1_3_P2_BASE + 0x7B)
#define REG_PHY2P1_3_P2_3E_L        (REG_PHY2P1_3_P2_BASE + 0x7C)
#define REG_PHY2P1_3_P2_3E_H        (REG_PHY2P1_3_P2_BASE + 0x7D)
#define REG_PHY2P1_3_P2_3F_L        (REG_PHY2P1_3_P2_BASE + 0x7E)
#define REG_PHY2P1_3_P2_3F_H        (REG_PHY2P1_3_P2_BASE + 0x7F)
#define REG_PHY2P1_3_P2_40_L        (REG_PHY2P1_3_P2_BASE + 0x80)
#define REG_PHY2P1_3_P2_40_H        (REG_PHY2P1_3_P2_BASE + 0x81)
#define REG_PHY2P1_3_P2_41_L        (REG_PHY2P1_3_P2_BASE + 0x82)
#define REG_PHY2P1_3_P2_41_H        (REG_PHY2P1_3_P2_BASE + 0x83)
#define REG_PHY2P1_3_P2_42_L        (REG_PHY2P1_3_P2_BASE + 0x84)
#define REG_PHY2P1_3_P2_42_H        (REG_PHY2P1_3_P2_BASE + 0x85)
#define REG_PHY2P1_3_P2_43_L        (REG_PHY2P1_3_P2_BASE + 0x86)
#define REG_PHY2P1_3_P2_43_H        (REG_PHY2P1_3_P2_BASE + 0x87)
#define REG_PHY2P1_3_P2_44_L        (REG_PHY2P1_3_P2_BASE + 0x88)
#define REG_PHY2P1_3_P2_44_H        (REG_PHY2P1_3_P2_BASE + 0x89)
#define REG_PHY2P1_3_P2_45_L        (REG_PHY2P1_3_P2_BASE + 0x8A)
#define REG_PHY2P1_3_P2_45_H        (REG_PHY2P1_3_P2_BASE + 0x8B)
#define REG_PHY2P1_3_P2_46_L        (REG_PHY2P1_3_P2_BASE + 0x8C)
#define REG_PHY2P1_3_P2_46_H        (REG_PHY2P1_3_P2_BASE + 0x8D)
#define REG_PHY2P1_3_P2_47_L        (REG_PHY2P1_3_P2_BASE + 0x8E)
#define REG_PHY2P1_3_P2_47_H        (REG_PHY2P1_3_P2_BASE + 0x8F)
#define REG_PHY2P1_3_P2_48_L        (REG_PHY2P1_3_P2_BASE + 0x90)
#define REG_PHY2P1_3_P2_48_H        (REG_PHY2P1_3_P2_BASE + 0x91)
#define REG_PHY2P1_3_P2_49_L        (REG_PHY2P1_3_P2_BASE + 0x92)
#define REG_PHY2P1_3_P2_49_H        (REG_PHY2P1_3_P2_BASE + 0x93)
#define REG_PHY2P1_3_P2_4A_L        (REG_PHY2P1_3_P2_BASE + 0x94)
#define REG_PHY2P1_3_P2_4A_H        (REG_PHY2P1_3_P2_BASE + 0x95)
#define REG_PHY2P1_3_P2_4B_L        (REG_PHY2P1_3_P2_BASE + 0x96)
#define REG_PHY2P1_3_P2_4B_H        (REG_PHY2P1_3_P2_BASE + 0x97)
#define REG_PHY2P1_3_P2_4C_L        (REG_PHY2P1_3_P2_BASE + 0x98)
#define REG_PHY2P1_3_P2_4C_H        (REG_PHY2P1_3_P2_BASE + 0x99)
#define REG_PHY2P1_3_P2_4D_L        (REG_PHY2P1_3_P2_BASE + 0x9A)
#define REG_PHY2P1_3_P2_4D_H        (REG_PHY2P1_3_P2_BASE + 0x9B)
#define REG_PHY2P1_3_P2_4E_L        (REG_PHY2P1_3_P2_BASE + 0x9C)
#define REG_PHY2P1_3_P2_4E_H        (REG_PHY2P1_3_P2_BASE + 0x9D)
#define REG_PHY2P1_3_P2_4F_L        (REG_PHY2P1_3_P2_BASE + 0x9E)
#define REG_PHY2P1_3_P2_4F_H        (REG_PHY2P1_3_P2_BASE + 0x9F)
#define REG_PHY2P1_3_P2_50_L        (REG_PHY2P1_3_P2_BASE + 0xA0)
#define REG_PHY2P1_3_P2_50_H        (REG_PHY2P1_3_P2_BASE + 0xA1)
#define REG_PHY2P1_3_P2_51_L        (REG_PHY2P1_3_P2_BASE + 0xA2)
#define REG_PHY2P1_3_P2_51_H        (REG_PHY2P1_3_P2_BASE + 0xA3)
#define REG_PHY2P1_3_P2_52_L        (REG_PHY2P1_3_P2_BASE + 0xA4)
#define REG_PHY2P1_3_P2_52_H        (REG_PHY2P1_3_P2_BASE + 0xA5)
#define REG_PHY2P1_3_P2_53_L        (REG_PHY2P1_3_P2_BASE + 0xA6)
#define REG_PHY2P1_3_P2_53_H        (REG_PHY2P1_3_P2_BASE + 0xA7)
#define REG_PHY2P1_3_P2_54_L        (REG_PHY2P1_3_P2_BASE + 0xA8)
#define REG_PHY2P1_3_P2_54_H        (REG_PHY2P1_3_P2_BASE + 0xA9)
#define REG_PHY2P1_3_P2_55_L        (REG_PHY2P1_3_P2_BASE + 0xAA)
#define REG_PHY2P1_3_P2_55_H        (REG_PHY2P1_3_P2_BASE + 0xAB)
#define REG_PHY2P1_3_P2_56_L        (REG_PHY2P1_3_P2_BASE + 0xAC)
#define REG_PHY2P1_3_P2_56_H        (REG_PHY2P1_3_P2_BASE + 0xAD)
#define REG_PHY2P1_3_P2_57_L        (REG_PHY2P1_3_P2_BASE + 0xAE)
#define REG_PHY2P1_3_P2_57_H        (REG_PHY2P1_3_P2_BASE + 0xAF)
#define REG_PHY2P1_3_P2_58_L        (REG_PHY2P1_3_P2_BASE + 0xB0)
#define REG_PHY2P1_3_P2_58_H        (REG_PHY2P1_3_P2_BASE + 0xB1)
#define REG_PHY2P1_3_P2_59_L        (REG_PHY2P1_3_P2_BASE + 0xB2)
#define REG_PHY2P1_3_P2_59_H        (REG_PHY2P1_3_P2_BASE + 0xB3)
#define REG_PHY2P1_3_P2_5A_L        (REG_PHY2P1_3_P2_BASE + 0xB4)
#define REG_PHY2P1_3_P2_5A_H        (REG_PHY2P1_3_P2_BASE + 0xB5)
#define REG_PHY2P1_3_P2_5B_L        (REG_PHY2P1_3_P2_BASE + 0xB6)
#define REG_PHY2P1_3_P2_5B_H        (REG_PHY2P1_3_P2_BASE + 0xB7)
#define REG_PHY2P1_3_P2_5C_L        (REG_PHY2P1_3_P2_BASE + 0xB8)
#define REG_PHY2P1_3_P2_5C_H        (REG_PHY2P1_3_P2_BASE + 0xB9)
#define REG_PHY2P1_3_P2_5D_L        (REG_PHY2P1_3_P2_BASE + 0xBA)
#define REG_PHY2P1_3_P2_5D_H        (REG_PHY2P1_3_P2_BASE + 0xBB)
#define REG_PHY2P1_3_P2_5E_L        (REG_PHY2P1_3_P2_BASE + 0xBC)
#define REG_PHY2P1_3_P2_5E_H        (REG_PHY2P1_3_P2_BASE + 0xBD)
#define REG_PHY2P1_3_P2_5F_L        (REG_PHY2P1_3_P2_BASE + 0xBE)
#define REG_PHY2P1_3_P2_5F_H        (REG_PHY2P1_3_P2_BASE + 0xBF)
#define REG_PHY2P1_3_P2_60_L        (REG_PHY2P1_3_P2_BASE + 0xC0)
#define REG_PHY2P1_3_P2_60_H        (REG_PHY2P1_3_P2_BASE + 0xC1)
#define REG_PHY2P1_3_P2_61_L        (REG_PHY2P1_3_P2_BASE + 0xC2)
#define REG_PHY2P1_3_P2_61_H        (REG_PHY2P1_3_P2_BASE + 0xC3)
#define REG_PHY2P1_3_P2_62_L        (REG_PHY2P1_3_P2_BASE + 0xC4)
#define REG_PHY2P1_3_P2_62_H        (REG_PHY2P1_3_P2_BASE + 0xC5)
#define REG_PHY2P1_3_P2_63_L        (REG_PHY2P1_3_P2_BASE + 0xC6)
#define REG_PHY2P1_3_P2_63_H        (REG_PHY2P1_3_P2_BASE + 0xC7)
#define REG_PHY2P1_3_P2_64_L        (REG_PHY2P1_3_P2_BASE + 0xC8)
#define REG_PHY2P1_3_P2_64_H        (REG_PHY2P1_3_P2_BASE + 0xC9)
#define REG_PHY2P1_3_P2_65_L        (REG_PHY2P1_3_P2_BASE + 0xCA)
#define REG_PHY2P1_3_P2_65_H        (REG_PHY2P1_3_P2_BASE + 0xCB)
#define REG_PHY2P1_3_P2_66_L        (REG_PHY2P1_3_P2_BASE + 0xCC)
#define REG_PHY2P1_3_P2_66_H        (REG_PHY2P1_3_P2_BASE + 0xCD)
#define REG_PHY2P1_3_P2_67_L        (REG_PHY2P1_3_P2_BASE + 0xCE)
#define REG_PHY2P1_3_P2_67_H        (REG_PHY2P1_3_P2_BASE + 0xCF)
#define REG_PHY2P1_3_P2_68_L        (REG_PHY2P1_3_P2_BASE + 0xD0)
#define REG_PHY2P1_3_P2_68_H        (REG_PHY2P1_3_P2_BASE + 0xD1)
#define REG_PHY2P1_3_P2_69_L        (REG_PHY2P1_3_P2_BASE + 0xD2)
#define REG_PHY2P1_3_P2_69_H        (REG_PHY2P1_3_P2_BASE + 0xD3)
#define REG_PHY2P1_3_P2_6A_L        (REG_PHY2P1_3_P2_BASE + 0xD4)
#define REG_PHY2P1_3_P2_6A_H        (REG_PHY2P1_3_P2_BASE + 0xD5)
#define REG_PHY2P1_3_P2_6B_L        (REG_PHY2P1_3_P2_BASE + 0xD6)
#define REG_PHY2P1_3_P2_6B_H        (REG_PHY2P1_3_P2_BASE + 0xD7)
#define REG_PHY2P1_3_P2_6C_L        (REG_PHY2P1_3_P2_BASE + 0xD8)
#define REG_PHY2P1_3_P2_6C_H        (REG_PHY2P1_3_P2_BASE + 0xD9)
#define REG_PHY2P1_3_P2_6D_L        (REG_PHY2P1_3_P2_BASE + 0xDA)
#define REG_PHY2P1_3_P2_6D_H        (REG_PHY2P1_3_P2_BASE + 0xDB)
#define REG_PHY2P1_3_P2_6E_L        (REG_PHY2P1_3_P2_BASE + 0xDC)
#define REG_PHY2P1_3_P2_6E_H        (REG_PHY2P1_3_P2_BASE + 0xDD)
#define REG_PHY2P1_3_P2_6F_L        (REG_PHY2P1_3_P2_BASE + 0xDE)
#define REG_PHY2P1_3_P2_6F_H        (REG_PHY2P1_3_P2_BASE + 0xDF)
#define REG_PHY2P1_3_P2_70_L        (REG_PHY2P1_3_P2_BASE + 0xE0)
#define REG_PHY2P1_3_P2_70_H        (REG_PHY2P1_3_P2_BASE + 0xE1)
#define REG_PHY2P1_3_P2_71_L        (REG_PHY2P1_3_P2_BASE + 0xE2)
#define REG_PHY2P1_3_P2_71_H        (REG_PHY2P1_3_P2_BASE + 0xE3)
#define REG_PHY2P1_3_P2_72_L        (REG_PHY2P1_3_P2_BASE + 0xE4)
#define REG_PHY2P1_3_P2_72_H        (REG_PHY2P1_3_P2_BASE + 0xE5)
#define REG_PHY2P1_3_P2_73_L        (REG_PHY2P1_3_P2_BASE + 0xE6)
#define REG_PHY2P1_3_P2_73_H        (REG_PHY2P1_3_P2_BASE + 0xE7)
#define REG_PHY2P1_3_P2_74_L        (REG_PHY2P1_3_P2_BASE + 0xE8)
#define REG_PHY2P1_3_P2_74_H        (REG_PHY2P1_3_P2_BASE + 0xE9)
#define REG_PHY2P1_3_P2_75_L        (REG_PHY2P1_3_P2_BASE + 0xEA)
#define REG_PHY2P1_3_P2_75_H        (REG_PHY2P1_3_P2_BASE + 0xEB)
#define REG_PHY2P1_3_P2_76_L        (REG_PHY2P1_3_P2_BASE + 0xEC)
#define REG_PHY2P1_3_P2_76_H        (REG_PHY2P1_3_P2_BASE + 0xED)
#define REG_PHY2P1_3_P2_77_L        (REG_PHY2P1_3_P2_BASE + 0xEE)
#define REG_PHY2P1_3_P2_77_H        (REG_PHY2P1_3_P2_BASE + 0xEF)
#define REG_PHY2P1_3_P2_78_L        (REG_PHY2P1_3_P2_BASE + 0xF0)
#define REG_PHY2P1_3_P2_78_H        (REG_PHY2P1_3_P2_BASE + 0xF1)
#define REG_PHY2P1_3_P2_79_L        (REG_PHY2P1_3_P2_BASE + 0xF2)
#define REG_PHY2P1_3_P2_79_H        (REG_PHY2P1_3_P2_BASE + 0xF3)
#define REG_PHY2P1_3_P2_7A_L        (REG_PHY2P1_3_P2_BASE + 0xF4)
#define REG_PHY2P1_3_P2_7A_H        (REG_PHY2P1_3_P2_BASE + 0xF5)
#define REG_PHY2P1_3_P2_7B_L        (REG_PHY2P1_3_P2_BASE + 0xF6)
#define REG_PHY2P1_3_P2_7B_H        (REG_PHY2P1_3_P2_BASE + 0xF7)
#define REG_PHY2P1_3_P2_7C_L        (REG_PHY2P1_3_P2_BASE + 0xF8)
#define REG_PHY2P1_3_P2_7C_H        (REG_PHY2P1_3_P2_BASE + 0xF9)
#define REG_PHY2P1_3_P2_7D_L        (REG_PHY2P1_3_P2_BASE + 0xFA)
#define REG_PHY2P1_3_P2_7D_H        (REG_PHY2P1_3_P2_BASE + 0xFB)
#define REG_PHY2P1_3_P2_7E_L        (REG_PHY2P1_3_P2_BASE + 0xFC)
#define REG_PHY2P1_3_P2_7E_H        (REG_PHY2P1_3_P2_BASE + 0xFD)
#define REG_PHY2P1_3_P2_7F_L        (REG_PHY2P1_3_P2_BASE + 0xFE)
#define REG_PHY2P1_3_P2_7F_H        (REG_PHY2P1_3_P2_BASE + 0xFF)

//=============================================================
// PHY2P1_4_P2
#define REG_PHY2P1_4_P2_00_L        (REG_PHY2P1_4_P2_BASE + 0x00)
#define REG_PHY2P1_4_P2_00_H        (REG_PHY2P1_4_P2_BASE + 0x01)
#define REG_PHY2P1_4_P2_01_L        (REG_PHY2P1_4_P2_BASE + 0x02)
#define REG_PHY2P1_4_P2_01_H        (REG_PHY2P1_4_P2_BASE + 0x03)
#define REG_PHY2P1_4_P2_02_L        (REG_PHY2P1_4_P2_BASE + 0x04)
#define REG_PHY2P1_4_P2_02_H        (REG_PHY2P1_4_P2_BASE + 0x05)
#define REG_PHY2P1_4_P2_03_L        (REG_PHY2P1_4_P2_BASE + 0x06)
#define REG_PHY2P1_4_P2_03_H        (REG_PHY2P1_4_P2_BASE + 0x07)
#define REG_PHY2P1_4_P2_04_L        (REG_PHY2P1_4_P2_BASE + 0x08)
#define REG_PHY2P1_4_P2_04_H        (REG_PHY2P1_4_P2_BASE + 0x09)
#define REG_PHY2P1_4_P2_05_L        (REG_PHY2P1_4_P2_BASE + 0x0A)
#define REG_PHY2P1_4_P2_05_H        (REG_PHY2P1_4_P2_BASE + 0x0B)
#define REG_PHY2P1_4_P2_06_L        (REG_PHY2P1_4_P2_BASE + 0x0C)
#define REG_PHY2P1_4_P2_06_H        (REG_PHY2P1_4_P2_BASE + 0x0D)
#define REG_PHY2P1_4_P2_07_L        (REG_PHY2P1_4_P2_BASE + 0x0E)
#define REG_PHY2P1_4_P2_07_H        (REG_PHY2P1_4_P2_BASE + 0x0F)
#define REG_PHY2P1_4_P2_08_L        (REG_PHY2P1_4_P2_BASE + 0x10)
#define REG_PHY2P1_4_P2_08_H        (REG_PHY2P1_4_P2_BASE + 0x11)
#define REG_PHY2P1_4_P2_09_L        (REG_PHY2P1_4_P2_BASE + 0x12)
#define REG_PHY2P1_4_P2_09_H        (REG_PHY2P1_4_P2_BASE + 0x13)
#define REG_PHY2P1_4_P2_0A_L        (REG_PHY2P1_4_P2_BASE + 0x14)
#define REG_PHY2P1_4_P2_0A_H        (REG_PHY2P1_4_P2_BASE + 0x15)
#define REG_PHY2P1_4_P2_0B_L        (REG_PHY2P1_4_P2_BASE + 0x16)
#define REG_PHY2P1_4_P2_0B_H        (REG_PHY2P1_4_P2_BASE + 0x17)
#define REG_PHY2P1_4_P2_0C_L        (REG_PHY2P1_4_P2_BASE + 0x18)
#define REG_PHY2P1_4_P2_0C_H        (REG_PHY2P1_4_P2_BASE + 0x19)
#define REG_PHY2P1_4_P2_0D_L        (REG_PHY2P1_4_P2_BASE + 0x1A)
#define REG_PHY2P1_4_P2_0D_H        (REG_PHY2P1_4_P2_BASE + 0x1B)
#define REG_PHY2P1_4_P2_0E_L        (REG_PHY2P1_4_P2_BASE + 0x1C)
#define REG_PHY2P1_4_P2_0E_H        (REG_PHY2P1_4_P2_BASE + 0x1D)
#define REG_PHY2P1_4_P2_0F_L        (REG_PHY2P1_4_P2_BASE + 0x1E)
#define REG_PHY2P1_4_P2_0F_H        (REG_PHY2P1_4_P2_BASE + 0x1F)
#define REG_PHY2P1_4_P2_10_L        (REG_PHY2P1_4_P2_BASE + 0x20)
#define REG_PHY2P1_4_P2_10_H        (REG_PHY2P1_4_P2_BASE + 0x21)
#define REG_PHY2P1_4_P2_11_L        (REG_PHY2P1_4_P2_BASE + 0x22)
#define REG_PHY2P1_4_P2_11_H        (REG_PHY2P1_4_P2_BASE + 0x23)
#define REG_PHY2P1_4_P2_12_L        (REG_PHY2P1_4_P2_BASE + 0x24)
#define REG_PHY2P1_4_P2_12_H        (REG_PHY2P1_4_P2_BASE + 0x25)
#define REG_PHY2P1_4_P2_13_L        (REG_PHY2P1_4_P2_BASE + 0x26)
#define REG_PHY2P1_4_P2_13_H        (REG_PHY2P1_4_P2_BASE + 0x27)
#define REG_PHY2P1_4_P2_14_L        (REG_PHY2P1_4_P2_BASE + 0x28)
#define REG_PHY2P1_4_P2_14_H        (REG_PHY2P1_4_P2_BASE + 0x29)
#define REG_PHY2P1_4_P2_15_L        (REG_PHY2P1_4_P2_BASE + 0x2A)
#define REG_PHY2P1_4_P2_15_H        (REG_PHY2P1_4_P2_BASE + 0x2B)
#define REG_PHY2P1_4_P2_16_L        (REG_PHY2P1_4_P2_BASE + 0x2C)
#define REG_PHY2P1_4_P2_16_H        (REG_PHY2P1_4_P2_BASE + 0x2D)
#define REG_PHY2P1_4_P2_17_L        (REG_PHY2P1_4_P2_BASE + 0x2E)
#define REG_PHY2P1_4_P2_17_H        (REG_PHY2P1_4_P2_BASE + 0x2F)
#define REG_PHY2P1_4_P2_18_L        (REG_PHY2P1_4_P2_BASE + 0x30)
#define REG_PHY2P1_4_P2_18_H        (REG_PHY2P1_4_P2_BASE + 0x31)
#define REG_PHY2P1_4_P2_19_L        (REG_PHY2P1_4_P2_BASE + 0x32)
#define REG_PHY2P1_4_P2_19_H        (REG_PHY2P1_4_P2_BASE + 0x33)
#define REG_PHY2P1_4_P2_1A_L        (REG_PHY2P1_4_P2_BASE + 0x34)
#define REG_PHY2P1_4_P2_1A_H        (REG_PHY2P1_4_P2_BASE + 0x35)
#define REG_PHY2P1_4_P2_1B_L        (REG_PHY2P1_4_P2_BASE + 0x36)
#define REG_PHY2P1_4_P2_1B_H        (REG_PHY2P1_4_P2_BASE + 0x37)
#define REG_PHY2P1_4_P2_1C_L        (REG_PHY2P1_4_P2_BASE + 0x38)
#define REG_PHY2P1_4_P2_1C_H        (REG_PHY2P1_4_P2_BASE + 0x39)
#define REG_PHY2P1_4_P2_1D_L        (REG_PHY2P1_4_P2_BASE + 0x3A)
#define REG_PHY2P1_4_P2_1D_H        (REG_PHY2P1_4_P2_BASE + 0x3B)
#define REG_PHY2P1_4_P2_1E_L        (REG_PHY2P1_4_P2_BASE + 0x3C)
#define REG_PHY2P1_4_P2_1E_H        (REG_PHY2P1_4_P2_BASE + 0x3D)
#define REG_PHY2P1_4_P2_1F_L        (REG_PHY2P1_4_P2_BASE + 0x3E)
#define REG_PHY2P1_4_P2_1F_H        (REG_PHY2P1_4_P2_BASE + 0x3F)
#define REG_PHY2P1_4_P2_20_L        (REG_PHY2P1_4_P2_BASE + 0x40)
#define REG_PHY2P1_4_P2_20_H        (REG_PHY2P1_4_P2_BASE + 0x41)
#define REG_PHY2P1_4_P2_21_L        (REG_PHY2P1_4_P2_BASE + 0x42)
#define REG_PHY2P1_4_P2_21_H        (REG_PHY2P1_4_P2_BASE + 0x43)
#define REG_PHY2P1_4_P2_22_L        (REG_PHY2P1_4_P2_BASE + 0x44)
#define REG_PHY2P1_4_P2_22_H        (REG_PHY2P1_4_P2_BASE + 0x45)
#define REG_PHY2P1_4_P2_23_L        (REG_PHY2P1_4_P2_BASE + 0x46)
#define REG_PHY2P1_4_P2_23_H        (REG_PHY2P1_4_P2_BASE + 0x47)
#define REG_PHY2P1_4_P2_24_L        (REG_PHY2P1_4_P2_BASE + 0x48)
#define REG_PHY2P1_4_P2_24_H        (REG_PHY2P1_4_P2_BASE + 0x49)
#define REG_PHY2P1_4_P2_25_L        (REG_PHY2P1_4_P2_BASE + 0x4A)
#define REG_PHY2P1_4_P2_25_H        (REG_PHY2P1_4_P2_BASE + 0x4B)
#define REG_PHY2P1_4_P2_26_L        (REG_PHY2P1_4_P2_BASE + 0x4C)
#define REG_PHY2P1_4_P2_26_H        (REG_PHY2P1_4_P2_BASE + 0x4D)
#define REG_PHY2P1_4_P2_27_L        (REG_PHY2P1_4_P2_BASE + 0x4E)
#define REG_PHY2P1_4_P2_27_H        (REG_PHY2P1_4_P2_BASE + 0x4F)
#define REG_PHY2P1_4_P2_28_L        (REG_PHY2P1_4_P2_BASE + 0x50)
#define REG_PHY2P1_4_P2_28_H        (REG_PHY2P1_4_P2_BASE + 0x51)
#define REG_PHY2P1_4_P2_29_L        (REG_PHY2P1_4_P2_BASE + 0x52)
#define REG_PHY2P1_4_P2_29_H        (REG_PHY2P1_4_P2_BASE + 0x53)
#define REG_PHY2P1_4_P2_2A_L        (REG_PHY2P1_4_P2_BASE + 0x54)
#define REG_PHY2P1_4_P2_2A_H        (REG_PHY2P1_4_P2_BASE + 0x55)
#define REG_PHY2P1_4_P2_2B_L        (REG_PHY2P1_4_P2_BASE + 0x56)
#define REG_PHY2P1_4_P2_2B_H        (REG_PHY2P1_4_P2_BASE + 0x57)
#define REG_PHY2P1_4_P2_2C_L        (REG_PHY2P1_4_P2_BASE + 0x58)
#define REG_PHY2P1_4_P2_2C_H        (REG_PHY2P1_4_P2_BASE + 0x59)
#define REG_PHY2P1_4_P2_2D_L        (REG_PHY2P1_4_P2_BASE + 0x5A)
#define REG_PHY2P1_4_P2_2D_H        (REG_PHY2P1_4_P2_BASE + 0x5B)
#define REG_PHY2P1_4_P2_2E_L        (REG_PHY2P1_4_P2_BASE + 0x5C)
#define REG_PHY2P1_4_P2_2E_H        (REG_PHY2P1_4_P2_BASE + 0x5D)
#define REG_PHY2P1_4_P2_2F_L        (REG_PHY2P1_4_P2_BASE + 0x5E)
#define REG_PHY2P1_4_P2_2F_H        (REG_PHY2P1_4_P2_BASE + 0x5F)
#define REG_PHY2P1_4_P2_30_L        (REG_PHY2P1_4_P2_BASE + 0x60)
#define REG_PHY2P1_4_P2_30_H        (REG_PHY2P1_4_P2_BASE + 0x61)
#define REG_PHY2P1_4_P2_31_L        (REG_PHY2P1_4_P2_BASE + 0x62)
#define REG_PHY2P1_4_P2_31_H        (REG_PHY2P1_4_P2_BASE + 0x63)
#define REG_PHY2P1_4_P2_32_L        (REG_PHY2P1_4_P2_BASE + 0x64)
#define REG_PHY2P1_4_P2_32_H        (REG_PHY2P1_4_P2_BASE + 0x65)
#define REG_PHY2P1_4_P2_33_L        (REG_PHY2P1_4_P2_BASE + 0x66)
#define REG_PHY2P1_4_P2_33_H        (REG_PHY2P1_4_P2_BASE + 0x67)
#define REG_PHY2P1_4_P2_34_L        (REG_PHY2P1_4_P2_BASE + 0x68)
#define REG_PHY2P1_4_P2_34_H        (REG_PHY2P1_4_P2_BASE + 0x69)
#define REG_PHY2P1_4_P2_35_L        (REG_PHY2P1_4_P2_BASE + 0x6A)
#define REG_PHY2P1_4_P2_35_H        (REG_PHY2P1_4_P2_BASE + 0x6B)
#define REG_PHY2P1_4_P2_36_L        (REG_PHY2P1_4_P2_BASE + 0x6C)
#define REG_PHY2P1_4_P2_36_H        (REG_PHY2P1_4_P2_BASE + 0x6D)
#define REG_PHY2P1_4_P2_37_L        (REG_PHY2P1_4_P2_BASE + 0x6E)
#define REG_PHY2P1_4_P2_37_H        (REG_PHY2P1_4_P2_BASE + 0x6F)
#define REG_PHY2P1_4_P2_38_L        (REG_PHY2P1_4_P2_BASE + 0x70)
#define REG_PHY2P1_4_P2_38_H        (REG_PHY2P1_4_P2_BASE + 0x71)
#define REG_PHY2P1_4_P2_39_L        (REG_PHY2P1_4_P2_BASE + 0x72)
#define REG_PHY2P1_4_P2_39_H        (REG_PHY2P1_4_P2_BASE + 0x73)
#define REG_PHY2P1_4_P2_3A_L        (REG_PHY2P1_4_P2_BASE + 0x74)
#define REG_PHY2P1_4_P2_3A_H        (REG_PHY2P1_4_P2_BASE + 0x75)
#define REG_PHY2P1_4_P2_3B_L        (REG_PHY2P1_4_P2_BASE + 0x76)
#define REG_PHY2P1_4_P2_3B_H        (REG_PHY2P1_4_P2_BASE + 0x77)
#define REG_PHY2P1_4_P2_3C_L        (REG_PHY2P1_4_P2_BASE + 0x78)
#define REG_PHY2P1_4_P2_3C_H        (REG_PHY2P1_4_P2_BASE + 0x79)
#define REG_PHY2P1_4_P2_3D_L        (REG_PHY2P1_4_P2_BASE + 0x7A)
#define REG_PHY2P1_4_P2_3D_H        (REG_PHY2P1_4_P2_BASE + 0x7B)
#define REG_PHY2P1_4_P2_3E_L        (REG_PHY2P1_4_P2_BASE + 0x7C)
#define REG_PHY2P1_4_P2_3E_H        (REG_PHY2P1_4_P2_BASE + 0x7D)
#define REG_PHY2P1_4_P2_3F_L        (REG_PHY2P1_4_P2_BASE + 0x7E)
#define REG_PHY2P1_4_P2_3F_H        (REG_PHY2P1_4_P2_BASE + 0x7F)
#define REG_PHY2P1_4_P2_40_L        (REG_PHY2P1_4_P2_BASE + 0x80)
#define REG_PHY2P1_4_P2_40_H        (REG_PHY2P1_4_P2_BASE + 0x81)
#define REG_PHY2P1_4_P2_41_L        (REG_PHY2P1_4_P2_BASE + 0x82)
#define REG_PHY2P1_4_P2_41_H        (REG_PHY2P1_4_P2_BASE + 0x83)
#define REG_PHY2P1_4_P2_42_L        (REG_PHY2P1_4_P2_BASE + 0x84)
#define REG_PHY2P1_4_P2_42_H        (REG_PHY2P1_4_P2_BASE + 0x85)
#define REG_PHY2P1_4_P2_43_L        (REG_PHY2P1_4_P2_BASE + 0x86)
#define REG_PHY2P1_4_P2_43_H        (REG_PHY2P1_4_P2_BASE + 0x87)
#define REG_PHY2P1_4_P2_44_L        (REG_PHY2P1_4_P2_BASE + 0x88)
#define REG_PHY2P1_4_P2_44_H        (REG_PHY2P1_4_P2_BASE + 0x89)
#define REG_PHY2P1_4_P2_45_L        (REG_PHY2P1_4_P2_BASE + 0x8A)
#define REG_PHY2P1_4_P2_45_H        (REG_PHY2P1_4_P2_BASE + 0x8B)
#define REG_PHY2P1_4_P2_46_L        (REG_PHY2P1_4_P2_BASE + 0x8C)
#define REG_PHY2P1_4_P2_46_H        (REG_PHY2P1_4_P2_BASE + 0x8D)
#define REG_PHY2P1_4_P2_47_L        (REG_PHY2P1_4_P2_BASE + 0x8E)
#define REG_PHY2P1_4_P2_47_H        (REG_PHY2P1_4_P2_BASE + 0x8F)
#define REG_PHY2P1_4_P2_48_L        (REG_PHY2P1_4_P2_BASE + 0x90)
#define REG_PHY2P1_4_P2_48_H        (REG_PHY2P1_4_P2_BASE + 0x91)
#define REG_PHY2P1_4_P2_49_L        (REG_PHY2P1_4_P2_BASE + 0x92)
#define REG_PHY2P1_4_P2_49_H        (REG_PHY2P1_4_P2_BASE + 0x93)
#define REG_PHY2P1_4_P2_4A_L        (REG_PHY2P1_4_P2_BASE + 0x94)
#define REG_PHY2P1_4_P2_4A_H        (REG_PHY2P1_4_P2_BASE + 0x95)
#define REG_PHY2P1_4_P2_4B_L        (REG_PHY2P1_4_P2_BASE + 0x96)
#define REG_PHY2P1_4_P2_4B_H        (REG_PHY2P1_4_P2_BASE + 0x97)
#define REG_PHY2P1_4_P2_4C_L        (REG_PHY2P1_4_P2_BASE + 0x98)
#define REG_PHY2P1_4_P2_4C_H        (REG_PHY2P1_4_P2_BASE + 0x99)
#define REG_PHY2P1_4_P2_4D_L        (REG_PHY2P1_4_P2_BASE + 0x9A)
#define REG_PHY2P1_4_P2_4D_H        (REG_PHY2P1_4_P2_BASE + 0x9B)
#define REG_PHY2P1_4_P2_4E_L        (REG_PHY2P1_4_P2_BASE + 0x9C)
#define REG_PHY2P1_4_P2_4E_H        (REG_PHY2P1_4_P2_BASE + 0x9D)
#define REG_PHY2P1_4_P2_4F_L        (REG_PHY2P1_4_P2_BASE + 0x9E)
#define REG_PHY2P1_4_P2_4F_H        (REG_PHY2P1_4_P2_BASE + 0x9F)
#define REG_PHY2P1_4_P2_50_L        (REG_PHY2P1_4_P2_BASE + 0xA0)
#define REG_PHY2P1_4_P2_50_H        (REG_PHY2P1_4_P2_BASE + 0xA1)
#define REG_PHY2P1_4_P2_51_L        (REG_PHY2P1_4_P2_BASE + 0xA2)
#define REG_PHY2P1_4_P2_51_H        (REG_PHY2P1_4_P2_BASE + 0xA3)
#define REG_PHY2P1_4_P2_52_L        (REG_PHY2P1_4_P2_BASE + 0xA4)
#define REG_PHY2P1_4_P2_52_H        (REG_PHY2P1_4_P2_BASE + 0xA5)
#define REG_PHY2P1_4_P2_53_L        (REG_PHY2P1_4_P2_BASE + 0xA6)
#define REG_PHY2P1_4_P2_53_H        (REG_PHY2P1_4_P2_BASE + 0xA7)
#define REG_PHY2P1_4_P2_54_L        (REG_PHY2P1_4_P2_BASE + 0xA8)
#define REG_PHY2P1_4_P2_54_H        (REG_PHY2P1_4_P2_BASE + 0xA9)
#define REG_PHY2P1_4_P2_55_L        (REG_PHY2P1_4_P2_BASE + 0xAA)
#define REG_PHY2P1_4_P2_55_H        (REG_PHY2P1_4_P2_BASE + 0xAB)
#define REG_PHY2P1_4_P2_56_L        (REG_PHY2P1_4_P2_BASE + 0xAC)
#define REG_PHY2P1_4_P2_56_H        (REG_PHY2P1_4_P2_BASE + 0xAD)
#define REG_PHY2P1_4_P2_57_L        (REG_PHY2P1_4_P2_BASE + 0xAE)
#define REG_PHY2P1_4_P2_57_H        (REG_PHY2P1_4_P2_BASE + 0xAF)
#define REG_PHY2P1_4_P2_58_L        (REG_PHY2P1_4_P2_BASE + 0xB0)
#define REG_PHY2P1_4_P2_58_H        (REG_PHY2P1_4_P2_BASE + 0xB1)
#define REG_PHY2P1_4_P2_59_L        (REG_PHY2P1_4_P2_BASE + 0xB2)
#define REG_PHY2P1_4_P2_59_H        (REG_PHY2P1_4_P2_BASE + 0xB3)
#define REG_PHY2P1_4_P2_5A_L        (REG_PHY2P1_4_P2_BASE + 0xB4)
#define REG_PHY2P1_4_P2_5A_H        (REG_PHY2P1_4_P2_BASE + 0xB5)
#define REG_PHY2P1_4_P2_5B_L        (REG_PHY2P1_4_P2_BASE + 0xB6)
#define REG_PHY2P1_4_P2_5B_H        (REG_PHY2P1_4_P2_BASE + 0xB7)
#define REG_PHY2P1_4_P2_5C_L        (REG_PHY2P1_4_P2_BASE + 0xB8)
#define REG_PHY2P1_4_P2_5C_H        (REG_PHY2P1_4_P2_BASE + 0xB9)
#define REG_PHY2P1_4_P2_5D_L        (REG_PHY2P1_4_P2_BASE + 0xBA)
#define REG_PHY2P1_4_P2_5D_H        (REG_PHY2P1_4_P2_BASE + 0xBB)
#define REG_PHY2P1_4_P2_5E_L        (REG_PHY2P1_4_P2_BASE + 0xBC)
#define REG_PHY2P1_4_P2_5E_H        (REG_PHY2P1_4_P2_BASE + 0xBD)
#define REG_PHY2P1_4_P2_5F_L        (REG_PHY2P1_4_P2_BASE + 0xBE)
#define REG_PHY2P1_4_P2_5F_H        (REG_PHY2P1_4_P2_BASE + 0xBF)
#define REG_PHY2P1_4_P2_60_L        (REG_PHY2P1_4_P2_BASE + 0xC0)
#define REG_PHY2P1_4_P2_60_H        (REG_PHY2P1_4_P2_BASE + 0xC1)
#define REG_PHY2P1_4_P2_61_L        (REG_PHY2P1_4_P2_BASE + 0xC2)
#define REG_PHY2P1_4_P2_61_H        (REG_PHY2P1_4_P2_BASE + 0xC3)
#define REG_PHY2P1_4_P2_62_L        (REG_PHY2P1_4_P2_BASE + 0xC4)
#define REG_PHY2P1_4_P2_62_H        (REG_PHY2P1_4_P2_BASE + 0xC5)
#define REG_PHY2P1_4_P2_63_L        (REG_PHY2P1_4_P2_BASE + 0xC6)
#define REG_PHY2P1_4_P2_63_H        (REG_PHY2P1_4_P2_BASE + 0xC7)
#define REG_PHY2P1_4_P2_64_L        (REG_PHY2P1_4_P2_BASE + 0xC8)
#define REG_PHY2P1_4_P2_64_H        (REG_PHY2P1_4_P2_BASE + 0xC9)
#define REG_PHY2P1_4_P2_65_L        (REG_PHY2P1_4_P2_BASE + 0xCA)
#define REG_PHY2P1_4_P2_65_H        (REG_PHY2P1_4_P2_BASE + 0xCB)
#define REG_PHY2P1_4_P2_66_L        (REG_PHY2P1_4_P2_BASE + 0xCC)
#define REG_PHY2P1_4_P2_66_H        (REG_PHY2P1_4_P2_BASE + 0xCD)
#define REG_PHY2P1_4_P2_67_L        (REG_PHY2P1_4_P2_BASE + 0xCE)
#define REG_PHY2P1_4_P2_67_H        (REG_PHY2P1_4_P2_BASE + 0xCF)
#define REG_PHY2P1_4_P2_68_L        (REG_PHY2P1_4_P2_BASE + 0xD0)
#define REG_PHY2P1_4_P2_68_H        (REG_PHY2P1_4_P2_BASE + 0xD1)
#define REG_PHY2P1_4_P2_69_L        (REG_PHY2P1_4_P2_BASE + 0xD2)
#define REG_PHY2P1_4_P2_69_H        (REG_PHY2P1_4_P2_BASE + 0xD3)
#define REG_PHY2P1_4_P2_6A_L        (REG_PHY2P1_4_P2_BASE + 0xD4)
#define REG_PHY2P1_4_P2_6A_H        (REG_PHY2P1_4_P2_BASE + 0xD5)
#define REG_PHY2P1_4_P2_6B_L        (REG_PHY2P1_4_P2_BASE + 0xD6)
#define REG_PHY2P1_4_P2_6B_H        (REG_PHY2P1_4_P2_BASE + 0xD7)
#define REG_PHY2P1_4_P2_6C_L        (REG_PHY2P1_4_P2_BASE + 0xD8)
#define REG_PHY2P1_4_P2_6C_H        (REG_PHY2P1_4_P2_BASE + 0xD9)
#define REG_PHY2P1_4_P2_6D_L        (REG_PHY2P1_4_P2_BASE + 0xDA)
#define REG_PHY2P1_4_P2_6D_H        (REG_PHY2P1_4_P2_BASE + 0xDB)
#define REG_PHY2P1_4_P2_6E_L        (REG_PHY2P1_4_P2_BASE + 0xDC)
#define REG_PHY2P1_4_P2_6E_H        (REG_PHY2P1_4_P2_BASE + 0xDD)
#define REG_PHY2P1_4_P2_6F_L        (REG_PHY2P1_4_P2_BASE + 0xDE)
#define REG_PHY2P1_4_P2_6F_H        (REG_PHY2P1_4_P2_BASE + 0xDF)
#define REG_PHY2P1_4_P2_70_L        (REG_PHY2P1_4_P2_BASE + 0xE0)
#define REG_PHY2P1_4_P2_70_H        (REG_PHY2P1_4_P2_BASE + 0xE1)
#define REG_PHY2P1_4_P2_71_L        (REG_PHY2P1_4_P2_BASE + 0xE2)
#define REG_PHY2P1_4_P2_71_H        (REG_PHY2P1_4_P2_BASE + 0xE3)
#define REG_PHY2P1_4_P2_72_L        (REG_PHY2P1_4_P2_BASE + 0xE4)
#define REG_PHY2P1_4_P2_72_H        (REG_PHY2P1_4_P2_BASE + 0xE5)
#define REG_PHY2P1_4_P2_73_L        (REG_PHY2P1_4_P2_BASE + 0xE6)
#define REG_PHY2P1_4_P2_73_H        (REG_PHY2P1_4_P2_BASE + 0xE7)
#define REG_PHY2P1_4_P2_74_L        (REG_PHY2P1_4_P2_BASE + 0xE8)
#define REG_PHY2P1_4_P2_74_H        (REG_PHY2P1_4_P2_BASE + 0xE9)
#define REG_PHY2P1_4_P2_75_L        (REG_PHY2P1_4_P2_BASE + 0xEA)
#define REG_PHY2P1_4_P2_75_H        (REG_PHY2P1_4_P2_BASE + 0xEB)
#define REG_PHY2P1_4_P2_76_L        (REG_PHY2P1_4_P2_BASE + 0xEC)
#define REG_PHY2P1_4_P2_76_H        (REG_PHY2P1_4_P2_BASE + 0xED)
#define REG_PHY2P1_4_P2_77_L        (REG_PHY2P1_4_P2_BASE + 0xEE)
#define REG_PHY2P1_4_P2_77_H        (REG_PHY2P1_4_P2_BASE + 0xEF)
#define REG_PHY2P1_4_P2_78_L        (REG_PHY2P1_4_P2_BASE + 0xF0)
#define REG_PHY2P1_4_P2_78_H        (REG_PHY2P1_4_P2_BASE + 0xF1)
#define REG_PHY2P1_4_P2_79_L        (REG_PHY2P1_4_P2_BASE + 0xF2)
#define REG_PHY2P1_4_P2_79_H        (REG_PHY2P1_4_P2_BASE + 0xF3)
#define REG_PHY2P1_4_P2_7A_L        (REG_PHY2P1_4_P2_BASE + 0xF4)
#define REG_PHY2P1_4_P2_7A_H        (REG_PHY2P1_4_P2_BASE + 0xF5)
#define REG_PHY2P1_4_P2_7B_L        (REG_PHY2P1_4_P2_BASE + 0xF6)
#define REG_PHY2P1_4_P2_7B_H        (REG_PHY2P1_4_P2_BASE + 0xF7)
#define REG_PHY2P1_4_P2_7C_L        (REG_PHY2P1_4_P2_BASE + 0xF8)
#define REG_PHY2P1_4_P2_7C_H        (REG_PHY2P1_4_P2_BASE + 0xF9)
#define REG_PHY2P1_4_P2_7D_L        (REG_PHY2P1_4_P2_BASE + 0xFA)
#define REG_PHY2P1_4_P2_7D_H        (REG_PHY2P1_4_P2_BASE + 0xFB)
#define REG_PHY2P1_4_P2_7E_L        (REG_PHY2P1_4_P2_BASE + 0xFC)
#define REG_PHY2P1_4_P2_7E_H        (REG_PHY2P1_4_P2_BASE + 0xFD)
#define REG_PHY2P1_4_P2_7F_L        (REG_PHY2P1_4_P2_BASE + 0xFE)
#define REG_PHY2P1_4_P2_7F_H        (REG_PHY2P1_4_P2_BASE + 0xFF)

//=============================================================
// PHY_TRAIN_P2
#define REG_PHY_TRAIN_P2_00_L       (REG_PHY_TRAIN_P2_BASE + 0x00)
#define REG_PHY_TRAIN_P2_00_H       (REG_PHY_TRAIN_P2_BASE + 0x01)
#define REG_PHY_TRAIN_P2_01_L       (REG_PHY_TRAIN_P2_BASE + 0x02)
#define REG_PHY_TRAIN_P2_01_H       (REG_PHY_TRAIN_P2_BASE + 0x03)
#define REG_PHY_TRAIN_P2_02_L       (REG_PHY_TRAIN_P2_BASE + 0x04)
#define REG_PHY_TRAIN_P2_02_H       (REG_PHY_TRAIN_P2_BASE + 0x05)
#define REG_PHY_TRAIN_P2_03_L       (REG_PHY_TRAIN_P2_BASE + 0x06)
#define REG_PHY_TRAIN_P2_03_H       (REG_PHY_TRAIN_P2_BASE + 0x07)
#define REG_PHY_TRAIN_P2_04_L       (REG_PHY_TRAIN_P2_BASE + 0x08)
#define REG_PHY_TRAIN_P2_04_H       (REG_PHY_TRAIN_P2_BASE + 0x09)
#define REG_PHY_TRAIN_P2_05_L       (REG_PHY_TRAIN_P2_BASE + 0x0A)
#define REG_PHY_TRAIN_P2_05_H       (REG_PHY_TRAIN_P2_BASE + 0x0B)
#define REG_PHY_TRAIN_P2_06_L       (REG_PHY_TRAIN_P2_BASE + 0x0C)
#define REG_PHY_TRAIN_P2_06_H       (REG_PHY_TRAIN_P2_BASE + 0x0D)
#define REG_PHY_TRAIN_P2_07_L       (REG_PHY_TRAIN_P2_BASE + 0x0E)
#define REG_PHY_TRAIN_P2_07_H       (REG_PHY_TRAIN_P2_BASE + 0x0F)
#define REG_PHY_TRAIN_P2_08_L       (REG_PHY_TRAIN_P2_BASE + 0x10)
#define REG_PHY_TRAIN_P2_08_H       (REG_PHY_TRAIN_P2_BASE + 0x11)
#define REG_PHY_TRAIN_P2_09_L       (REG_PHY_TRAIN_P2_BASE + 0x12)
#define REG_PHY_TRAIN_P2_09_H       (REG_PHY_TRAIN_P2_BASE + 0x13)
#define REG_PHY_TRAIN_P2_0A_L       (REG_PHY_TRAIN_P2_BASE + 0x14)
#define REG_PHY_TRAIN_P2_0A_H       (REG_PHY_TRAIN_P2_BASE + 0x15)
#define REG_PHY_TRAIN_P2_0B_L       (REG_PHY_TRAIN_P2_BASE + 0x16)
#define REG_PHY_TRAIN_P2_0B_H       (REG_PHY_TRAIN_P2_BASE + 0x17)
#define REG_PHY_TRAIN_P2_0C_L       (REG_PHY_TRAIN_P2_BASE + 0x18)
#define REG_PHY_TRAIN_P2_0C_H       (REG_PHY_TRAIN_P2_BASE + 0x19)
#define REG_PHY_TRAIN_P2_0D_L       (REG_PHY_TRAIN_P2_BASE + 0x1A)
#define REG_PHY_TRAIN_P2_0D_H       (REG_PHY_TRAIN_P2_BASE + 0x1B)
#define REG_PHY_TRAIN_P2_0E_L       (REG_PHY_TRAIN_P2_BASE + 0x1C)
#define REG_PHY_TRAIN_P2_0E_H       (REG_PHY_TRAIN_P2_BASE + 0x1D)
#define REG_PHY_TRAIN_P2_0F_L       (REG_PHY_TRAIN_P2_BASE + 0x1E)
#define REG_PHY_TRAIN_P2_0F_H       (REG_PHY_TRAIN_P2_BASE + 0x1F)
#define REG_PHY_TRAIN_P2_10_L       (REG_PHY_TRAIN_P2_BASE + 0x20)
#define REG_PHY_TRAIN_P2_10_H       (REG_PHY_TRAIN_P2_BASE + 0x21)
#define REG_PHY_TRAIN_P2_11_L       (REG_PHY_TRAIN_P2_BASE + 0x22)
#define REG_PHY_TRAIN_P2_11_H       (REG_PHY_TRAIN_P2_BASE + 0x23)
#define REG_PHY_TRAIN_P2_12_L       (REG_PHY_TRAIN_P2_BASE + 0x24)
#define REG_PHY_TRAIN_P2_12_H       (REG_PHY_TRAIN_P2_BASE + 0x25)
#define REG_PHY_TRAIN_P2_13_L       (REG_PHY_TRAIN_P2_BASE + 0x26)
#define REG_PHY_TRAIN_P2_13_H       (REG_PHY_TRAIN_P2_BASE + 0x27)
#define REG_PHY_TRAIN_P2_14_L       (REG_PHY_TRAIN_P2_BASE + 0x28)
#define REG_PHY_TRAIN_P2_14_H       (REG_PHY_TRAIN_P2_BASE + 0x29)
#define REG_PHY_TRAIN_P2_15_L       (REG_PHY_TRAIN_P2_BASE + 0x2A)
#define REG_PHY_TRAIN_P2_15_H       (REG_PHY_TRAIN_P2_BASE + 0x2B)
#define REG_PHY_TRAIN_P2_16_L       (REG_PHY_TRAIN_P2_BASE + 0x2C)
#define REG_PHY_TRAIN_P2_16_H       (REG_PHY_TRAIN_P2_BASE + 0x2D)
#define REG_PHY_TRAIN_P2_17_L       (REG_PHY_TRAIN_P2_BASE + 0x2E)
#define REG_PHY_TRAIN_P2_17_H       (REG_PHY_TRAIN_P2_BASE + 0x2F)
#define REG_PHY_TRAIN_P2_18_L       (REG_PHY_TRAIN_P2_BASE + 0x30)
#define REG_PHY_TRAIN_P2_18_H       (REG_PHY_TRAIN_P2_BASE + 0x31)
#define REG_PHY_TRAIN_P2_19_L       (REG_PHY_TRAIN_P2_BASE + 0x32)
#define REG_PHY_TRAIN_P2_19_H       (REG_PHY_TRAIN_P2_BASE + 0x33)
#define REG_PHY_TRAIN_P2_1A_L       (REG_PHY_TRAIN_P2_BASE + 0x34)
#define REG_PHY_TRAIN_P2_1A_H       (REG_PHY_TRAIN_P2_BASE + 0x35)
#define REG_PHY_TRAIN_P2_1B_L       (REG_PHY_TRAIN_P2_BASE + 0x36)
#define REG_PHY_TRAIN_P2_1B_H       (REG_PHY_TRAIN_P2_BASE + 0x37)
#define REG_PHY_TRAIN_P2_1C_L       (REG_PHY_TRAIN_P2_BASE + 0x38)
#define REG_PHY_TRAIN_P2_1C_H       (REG_PHY_TRAIN_P2_BASE + 0x39)
#define REG_PHY_TRAIN_P2_1D_L       (REG_PHY_TRAIN_P2_BASE + 0x3A)
#define REG_PHY_TRAIN_P2_1D_H       (REG_PHY_TRAIN_P2_BASE + 0x3B)
#define REG_PHY_TRAIN_P2_1E_L       (REG_PHY_TRAIN_P2_BASE + 0x3C)
#define REG_PHY_TRAIN_P2_1E_H       (REG_PHY_TRAIN_P2_BASE + 0x3D)
#define REG_PHY_TRAIN_P2_1F_L       (REG_PHY_TRAIN_P2_BASE + 0x3E)
#define REG_PHY_TRAIN_P2_1F_H       (REG_PHY_TRAIN_P2_BASE + 0x3F)
#define REG_PHY_TRAIN_P2_20_L       (REG_PHY_TRAIN_P2_BASE + 0x40)
#define REG_PHY_TRAIN_P2_20_H       (REG_PHY_TRAIN_P2_BASE + 0x41)
#define REG_PHY_TRAIN_P2_21_L       (REG_PHY_TRAIN_P2_BASE + 0x42)
#define REG_PHY_TRAIN_P2_21_H       (REG_PHY_TRAIN_P2_BASE + 0x43)
#define REG_PHY_TRAIN_P2_22_L       (REG_PHY_TRAIN_P2_BASE + 0x44)
#define REG_PHY_TRAIN_P2_22_H       (REG_PHY_TRAIN_P2_BASE + 0x45)
#define REG_PHY_TRAIN_P2_23_L       (REG_PHY_TRAIN_P2_BASE + 0x46)
#define REG_PHY_TRAIN_P2_23_H       (REG_PHY_TRAIN_P2_BASE + 0x47)
#define REG_PHY_TRAIN_P2_24_L       (REG_PHY_TRAIN_P2_BASE + 0x48)
#define REG_PHY_TRAIN_P2_24_H       (REG_PHY_TRAIN_P2_BASE + 0x49)
#define REG_PHY_TRAIN_P2_25_L       (REG_PHY_TRAIN_P2_BASE + 0x4A)
#define REG_PHY_TRAIN_P2_25_H       (REG_PHY_TRAIN_P2_BASE + 0x4B)
#define REG_PHY_TRAIN_P2_26_L       (REG_PHY_TRAIN_P2_BASE + 0x4C)
#define REG_PHY_TRAIN_P2_26_H       (REG_PHY_TRAIN_P2_BASE + 0x4D)
#define REG_PHY_TRAIN_P2_27_L       (REG_PHY_TRAIN_P2_BASE + 0x4E)
#define REG_PHY_TRAIN_P2_27_H       (REG_PHY_TRAIN_P2_BASE + 0x4F)
#define REG_PHY_TRAIN_P2_28_L       (REG_PHY_TRAIN_P2_BASE + 0x50)
#define REG_PHY_TRAIN_P2_28_H       (REG_PHY_TRAIN_P2_BASE + 0x51)
#define REG_PHY_TRAIN_P2_29_L       (REG_PHY_TRAIN_P2_BASE + 0x52)
#define REG_PHY_TRAIN_P2_29_H       (REG_PHY_TRAIN_P2_BASE + 0x53)
#define REG_PHY_TRAIN_P2_2A_L       (REG_PHY_TRAIN_P2_BASE + 0x54)
#define REG_PHY_TRAIN_P2_2A_H       (REG_PHY_TRAIN_P2_BASE + 0x55)
#define REG_PHY_TRAIN_P2_2B_L       (REG_PHY_TRAIN_P2_BASE + 0x56)
#define REG_PHY_TRAIN_P2_2B_H       (REG_PHY_TRAIN_P2_BASE + 0x57)
#define REG_PHY_TRAIN_P2_2C_L       (REG_PHY_TRAIN_P2_BASE + 0x58)
#define REG_PHY_TRAIN_P2_2C_H       (REG_PHY_TRAIN_P2_BASE + 0x59)
#define REG_PHY_TRAIN_P2_2D_L       (REG_PHY_TRAIN_P2_BASE + 0x5A)
#define REG_PHY_TRAIN_P2_2D_H       (REG_PHY_TRAIN_P2_BASE + 0x5B)
#define REG_PHY_TRAIN_P2_2E_L       (REG_PHY_TRAIN_P2_BASE + 0x5C)
#define REG_PHY_TRAIN_P2_2E_H       (REG_PHY_TRAIN_P2_BASE + 0x5D)
#define REG_PHY_TRAIN_P2_2F_L       (REG_PHY_TRAIN_P2_BASE + 0x5E)
#define REG_PHY_TRAIN_P2_2F_H       (REG_PHY_TRAIN_P2_BASE + 0x5F)
#define REG_PHY_TRAIN_P2_30_L       (REG_PHY_TRAIN_P2_BASE + 0x60)
#define REG_PHY_TRAIN_P2_30_H       (REG_PHY_TRAIN_P2_BASE + 0x61)
#define REG_PHY_TRAIN_P2_31_L       (REG_PHY_TRAIN_P2_BASE + 0x62)
#define REG_PHY_TRAIN_P2_31_H       (REG_PHY_TRAIN_P2_BASE + 0x63)
#define REG_PHY_TRAIN_P2_32_L       (REG_PHY_TRAIN_P2_BASE + 0x64)
#define REG_PHY_TRAIN_P2_32_H       (REG_PHY_TRAIN_P2_BASE + 0x65)
#define REG_PHY_TRAIN_P2_33_L       (REG_PHY_TRAIN_P2_BASE + 0x66)
#define REG_PHY_TRAIN_P2_33_H       (REG_PHY_TRAIN_P2_BASE + 0x67)
#define REG_PHY_TRAIN_P2_34_L       (REG_PHY_TRAIN_P2_BASE + 0x68)
#define REG_PHY_TRAIN_P2_34_H       (REG_PHY_TRAIN_P2_BASE + 0x69)
#define REG_PHY_TRAIN_P2_35_L       (REG_PHY_TRAIN_P2_BASE + 0x6A)
#define REG_PHY_TRAIN_P2_35_H       (REG_PHY_TRAIN_P2_BASE + 0x6B)
#define REG_PHY_TRAIN_P2_36_L       (REG_PHY_TRAIN_P2_BASE + 0x6C)
#define REG_PHY_TRAIN_P2_36_H       (REG_PHY_TRAIN_P2_BASE + 0x6D)
#define REG_PHY_TRAIN_P2_37_L       (REG_PHY_TRAIN_P2_BASE + 0x6E)
#define REG_PHY_TRAIN_P2_37_H       (REG_PHY_TRAIN_P2_BASE + 0x6F)
#define REG_PHY_TRAIN_P2_38_L       (REG_PHY_TRAIN_P2_BASE + 0x70)
#define REG_PHY_TRAIN_P2_38_H       (REG_PHY_TRAIN_P2_BASE + 0x71)
#define REG_PHY_TRAIN_P2_39_L       (REG_PHY_TRAIN_P2_BASE + 0x72)
#define REG_PHY_TRAIN_P2_39_H       (REG_PHY_TRAIN_P2_BASE + 0x73)
#define REG_PHY_TRAIN_P2_3A_L       (REG_PHY_TRAIN_P2_BASE + 0x74)
#define REG_PHY_TRAIN_P2_3A_H       (REG_PHY_TRAIN_P2_BASE + 0x75)
#define REG_PHY_TRAIN_P2_3B_L       (REG_PHY_TRAIN_P2_BASE + 0x76)
#define REG_PHY_TRAIN_P2_3B_H       (REG_PHY_TRAIN_P2_BASE + 0x77)
#define REG_PHY_TRAIN_P2_3C_L       (REG_PHY_TRAIN_P2_BASE + 0x78)
#define REG_PHY_TRAIN_P2_3C_H       (REG_PHY_TRAIN_P2_BASE + 0x79)
#define REG_PHY_TRAIN_P2_3D_L       (REG_PHY_TRAIN_P2_BASE + 0x7A)
#define REG_PHY_TRAIN_P2_3D_H       (REG_PHY_TRAIN_P2_BASE + 0x7B)
#define REG_PHY_TRAIN_P2_3E_L       (REG_PHY_TRAIN_P2_BASE + 0x7C)
#define REG_PHY_TRAIN_P2_3E_H       (REG_PHY_TRAIN_P2_BASE + 0x7D)
#define REG_PHY_TRAIN_P2_3F_L       (REG_PHY_TRAIN_P2_BASE + 0x7E)
#define REG_PHY_TRAIN_P2_3F_H       (REG_PHY_TRAIN_P2_BASE + 0x7F)
#define REG_PHY2P1_5_P2_40_L       (REG_PHY_TRAIN_P2_BASE + 0x80)
#define REG_PHY2P1_5_P2_40_H       (REG_PHY_TRAIN_P2_BASE + 0x81)
#define REG_PHY2P1_5_P2_41_L       (REG_PHY_TRAIN_P2_BASE + 0x82)
#define REG_PHY2P1_5_P2_41_H       (REG_PHY_TRAIN_P2_BASE + 0x83)
#define REG_PHY2P1_5_P2_42_L       (REG_PHY_TRAIN_P2_BASE + 0x84)
#define REG_PHY2P1_5_P2_42_H       (REG_PHY_TRAIN_P2_BASE + 0x85)
#define REG_PHY2P1_5_P2_43_L       (REG_PHY_TRAIN_P2_BASE + 0x86)
#define REG_PHY2P1_5_P2_43_H       (REG_PHY_TRAIN_P2_BASE + 0x87)
#define REG_PHY2P1_5_P2_44_L       (REG_PHY_TRAIN_P2_BASE + 0x88)
#define REG_PHY2P1_5_P2_44_H       (REG_PHY_TRAIN_P2_BASE + 0x89)
#define REG_PHY2P1_5_P2_45_L       (REG_PHY_TRAIN_P2_BASE + 0x8A)
#define REG_PHY2P1_5_P2_45_H       (REG_PHY_TRAIN_P2_BASE + 0x8B)
#define REG_PHY2P1_5_P2_46_L       (REG_PHY_TRAIN_P2_BASE + 0x8C)
#define REG_PHY2P1_5_P2_46_H       (REG_PHY_TRAIN_P2_BASE + 0x8D)
#define REG_PHY2P1_5_P2_47_L       (REG_PHY_TRAIN_P2_BASE + 0x8E)
#define REG_PHY2P1_5_P2_47_H       (REG_PHY_TRAIN_P2_BASE + 0x8F)
#define REG_PHY2P1_5_P2_48_L       (REG_PHY_TRAIN_P2_BASE + 0x90)
#define REG_PHY2P1_5_P2_48_H       (REG_PHY_TRAIN_P2_BASE + 0x91)
#define REG_PHY2P1_5_P2_49_L       (REG_PHY_TRAIN_P2_BASE + 0x92)
#define REG_PHY2P1_5_P2_49_H       (REG_PHY_TRAIN_P2_BASE + 0x93)
#define REG_PHY2P1_5_P2_4A_L       (REG_PHY_TRAIN_P2_BASE + 0x94)
#define REG_PHY2P1_5_P2_4A_H       (REG_PHY_TRAIN_P2_BASE + 0x95)
#define REG_PHY2P1_5_P2_4B_L       (REG_PHY_TRAIN_P2_BASE + 0x96)
#define REG_PHY2P1_5_P2_4B_H       (REG_PHY_TRAIN_P2_BASE + 0x97)
#define REG_PHY2P1_5_P2_4C_L       (REG_PHY_TRAIN_P2_BASE + 0x98)
#define REG_PHY2P1_5_P2_4C_H       (REG_PHY_TRAIN_P2_BASE + 0x99)
#define REG_PHY2P1_5_P2_4D_L       (REG_PHY_TRAIN_P2_BASE + 0x9A)
#define REG_PHY2P1_5_P2_4D_H       (REG_PHY_TRAIN_P2_BASE + 0x9B)
#define REG_PHY2P1_5_P2_4E_L       (REG_PHY_TRAIN_P2_BASE + 0x9C)
#define REG_PHY2P1_5_P2_4E_H       (REG_PHY_TRAIN_P2_BASE + 0x9D)
#define REG_PHY2P1_5_P2_4F_L       (REG_PHY_TRAIN_P2_BASE + 0x9E)
#define REG_PHY2P1_5_P2_4F_H       (REG_PHY_TRAIN_P2_BASE + 0x9F)
#define REG_PHY2P1_5_P2_50_L       (REG_PHY_TRAIN_P2_BASE + 0xA0)
#define REG_PHY2P1_5_P2_50_H       (REG_PHY_TRAIN_P2_BASE + 0xA1)
#define REG_PHY2P1_5_P2_51_L       (REG_PHY_TRAIN_P2_BASE + 0xA2)
#define REG_PHY2P1_5_P2_51_H       (REG_PHY_TRAIN_P2_BASE + 0xA3)
#define REG_PHY2P1_5_P2_52_L       (REG_PHY_TRAIN_P2_BASE + 0xA4)
#define REG_PHY2P1_5_P2_52_H       (REG_PHY_TRAIN_P2_BASE + 0xA5)
#define REG_PHY2P1_5_P2_53_L       (REG_PHY_TRAIN_P2_BASE + 0xA6)
#define REG_PHY2P1_5_P2_53_H       (REG_PHY_TRAIN_P2_BASE + 0xA7)
#define REG_PHY2P1_5_P2_54_L       (REG_PHY_TRAIN_P2_BASE + 0xA8)
#define REG_PHY2P1_5_P2_54_H       (REG_PHY_TRAIN_P2_BASE + 0xA9)
#define REG_PHY2P1_5_P2_55_L       (REG_PHY_TRAIN_P2_BASE + 0xAA)
#define REG_PHY2P1_5_P2_55_H       (REG_PHY_TRAIN_P2_BASE + 0xAB)
#define REG_PHY2P1_5_P2_56_L       (REG_PHY_TRAIN_P2_BASE + 0xAC)
#define REG_PHY2P1_5_P2_56_H       (REG_PHY_TRAIN_P2_BASE + 0xAD)
#define REG_PHY2P1_5_P2_57_L       (REG_PHY_TRAIN_P2_BASE + 0xAE)
#define REG_PHY2P1_5_P2_57_H       (REG_PHY_TRAIN_P2_BASE + 0xAF)
#define REG_PHY2P1_5_P2_58_L       (REG_PHY_TRAIN_P2_BASE + 0xB0)
#define REG_PHY2P1_5_P2_58_H       (REG_PHY_TRAIN_P2_BASE + 0xB1)
#define REG_PHY2P1_5_P2_59_L       (REG_PHY_TRAIN_P2_BASE + 0xB2)
#define REG_PHY2P1_5_P2_59_H       (REG_PHY_TRAIN_P2_BASE + 0xB3)
#define REG_PHY2P1_5_P2_5A_L       (REG_PHY_TRAIN_P2_BASE + 0xB4)
#define REG_PHY2P1_5_P2_5A_H       (REG_PHY_TRAIN_P2_BASE + 0xB5)
#define REG_PHY2P1_5_P2_5B_L       (REG_PHY_TRAIN_P2_BASE + 0xB6)
#define REG_PHY2P1_5_P2_5B_H       (REG_PHY_TRAIN_P2_BASE + 0xB7)
#define REG_PHY2P1_5_P2_5C_L       (REG_PHY_TRAIN_P2_BASE + 0xB8)
#define REG_PHY2P1_5_P2_5C_H       (REG_PHY_TRAIN_P2_BASE + 0xB9)
#define REG_PHY2P1_5_P2_5D_L       (REG_PHY_TRAIN_P2_BASE + 0xBA)
#define REG_PHY2P1_5_P2_5D_H       (REG_PHY_TRAIN_P2_BASE + 0xBB)
#define REG_PHY2P1_5_P2_5E_L       (REG_PHY_TRAIN_P2_BASE + 0xBC)
#define REG_PHY2P1_5_P2_5E_H       (REG_PHY_TRAIN_P2_BASE + 0xBD)
#define REG_PHY2P1_5_P2_5F_L       (REG_PHY_TRAIN_P2_BASE + 0xBE)
#define REG_PHY2P1_5_P2_5F_H       (REG_PHY_TRAIN_P2_BASE + 0xBF)
#define REG_PHY_TRAIN_P2_60_L       (REG_PHY_TRAIN_P2_BASE + 0xC0)
#define REG_PHY_TRAIN_P2_60_H       (REG_PHY_TRAIN_P2_BASE + 0xC1)
#define REG_PHY_TRAIN_P2_61_L       (REG_PHY_TRAIN_P2_BASE + 0xC2)
#define REG_PHY_TRAIN_P2_61_H       (REG_PHY_TRAIN_P2_BASE + 0xC3)
#define REG_PHY_TRAIN_P2_62_L       (REG_PHY_TRAIN_P2_BASE + 0xC4)
#define REG_PHY_TRAIN_P2_62_H       (REG_PHY_TRAIN_P2_BASE + 0xC5)
#define REG_PHY_TRAIN_P2_63_L       (REG_PHY_TRAIN_P2_BASE + 0xC6)
#define REG_PHY_TRAIN_P2_63_H       (REG_PHY_TRAIN_P2_BASE + 0xC7)
#define REG_PHY_TRAIN_P2_64_L       (REG_PHY_TRAIN_P2_BASE + 0xC8)
#define REG_PHY_TRAIN_P2_64_H       (REG_PHY_TRAIN_P2_BASE + 0xC9)
#define REG_PHY_TRAIN_P2_65_L       (REG_PHY_TRAIN_P2_BASE + 0xCA)
#define REG_PHY_TRAIN_P2_65_H       (REG_PHY_TRAIN_P2_BASE + 0xCB)
#define REG_PHY_TRAIN_P2_66_L       (REG_PHY_TRAIN_P2_BASE + 0xCC)
#define REG_PHY_TRAIN_P2_66_H       (REG_PHY_TRAIN_P2_BASE + 0xCD)
#define REG_PHY_TRAIN_P2_67_L       (REG_PHY_TRAIN_P2_BASE + 0xCE)
#define REG_PHY_TRAIN_P2_67_H       (REG_PHY_TRAIN_P2_BASE + 0xCF)
#define REG_PHY_TRAIN_P2_68_L       (REG_PHY_TRAIN_P2_BASE + 0xD0)
#define REG_PHY_TRAIN_P2_68_H       (REG_PHY_TRAIN_P2_BASE + 0xD1)
#define REG_PHY_TRAIN_P2_69_L       (REG_PHY_TRAIN_P2_BASE + 0xD2)
#define REG_PHY_TRAIN_P2_69_H       (REG_PHY_TRAIN_P2_BASE + 0xD3)
#define REG_PHY_TRAIN_P2_6A_L       (REG_PHY_TRAIN_P2_BASE + 0xD4)
#define REG_PHY_TRAIN_P2_6A_H       (REG_PHY_TRAIN_P2_BASE + 0xD5)
#define REG_PHY_TRAIN_P2_6B_L       (REG_PHY_TRAIN_P2_BASE + 0xD6)
#define REG_PHY_TRAIN_P2_6B_H       (REG_PHY_TRAIN_P2_BASE + 0xD7)
#define REG_PHY_TRAIN_P2_6C_L       (REG_PHY_TRAIN_P2_BASE + 0xD8)
#define REG_PHY_TRAIN_P2_6C_H       (REG_PHY_TRAIN_P2_BASE + 0xD9)
#define REG_PHY_TRAIN_P2_6D_L       (REG_PHY_TRAIN_P2_BASE + 0xDA)
#define REG_PHY_TRAIN_P2_6D_H       (REG_PHY_TRAIN_P2_BASE + 0xDB)
#define REG_PHY_TRAIN_P2_6E_L       (REG_PHY_TRAIN_P2_BASE + 0xDC)
#define REG_PHY_TRAIN_P2_6E_H       (REG_PHY_TRAIN_P2_BASE + 0xDD)
#define REG_PHY_TRAIN_P2_6F_L       (REG_PHY_TRAIN_P2_BASE + 0xDE)
#define REG_PHY_TRAIN_P2_6F_H       (REG_PHY_TRAIN_P2_BASE + 0xDF)
#define REG_PHY_TRAIN_P2_70_L       (REG_PHY_TRAIN_P2_BASE + 0xE0)
#define REG_PHY_TRAIN_P2_70_H       (REG_PHY_TRAIN_P2_BASE + 0xE1)
#define REG_PHY_TRAIN_P2_71_L       (REG_PHY_TRAIN_P2_BASE + 0xE2)
#define REG_PHY_TRAIN_P2_71_H       (REG_PHY_TRAIN_P2_BASE + 0xE3)
#define REG_PHY_TRAIN_P2_72_L       (REG_PHY_TRAIN_P2_BASE + 0xE4)
#define REG_PHY_TRAIN_P2_72_H       (REG_PHY_TRAIN_P2_BASE + 0xE5)
#define REG_PHY_TRAIN_P2_73_L       (REG_PHY_TRAIN_P2_BASE + 0xE6)
#define REG_PHY_TRAIN_P2_73_H       (REG_PHY_TRAIN_P2_BASE + 0xE7)
#define REG_PHY_TRAIN_P2_74_L       (REG_PHY_TRAIN_P2_BASE + 0xE8)
#define REG_PHY_TRAIN_P2_74_H       (REG_PHY_TRAIN_P2_BASE + 0xE9)
#define REG_PHY_TRAIN_P2_75_L       (REG_PHY_TRAIN_P2_BASE + 0xEA)
#define REG_PHY_TRAIN_P2_75_H       (REG_PHY_TRAIN_P2_BASE + 0xEB)
#define REG_PHY_TRAIN_P2_76_L       (REG_PHY_TRAIN_P2_BASE + 0xEC)
#define REG_PHY_TRAIN_P2_76_H       (REG_PHY_TRAIN_P2_BASE + 0xED)
#define REG_PHY_TRAIN_P2_77_L       (REG_PHY_TRAIN_P2_BASE + 0xEE)
#define REG_PHY_TRAIN_P2_77_H       (REG_PHY_TRAIN_P2_BASE + 0xEF)
#define REG_PHY_TRAIN_P2_78_L       (REG_PHY_TRAIN_P2_BASE + 0xF0)
#define REG_PHY_TRAIN_P2_78_H       (REG_PHY_TRAIN_P2_BASE + 0xF1)
#define REG_PHY_TRAIN_P2_79_L       (REG_PHY_TRAIN_P2_BASE + 0xF2)
#define REG_PHY_TRAIN_P2_79_H       (REG_PHY_TRAIN_P2_BASE + 0xF3)
#define REG_PHY_TRAIN_P2_7A_L       (REG_PHY_TRAIN_P2_BASE + 0xF4)
#define REG_PHY_TRAIN_P2_7A_H       (REG_PHY_TRAIN_P2_BASE + 0xF5)
#define REG_PHY_TRAIN_P2_7B_L       (REG_PHY_TRAIN_P2_BASE + 0xF6)
#define REG_PHY_TRAIN_P2_7B_H       (REG_PHY_TRAIN_P2_BASE + 0xF7)
#define REG_PHY_TRAIN_P2_7C_L       (REG_PHY_TRAIN_P2_BASE + 0xF8)
#define REG_PHY_TRAIN_P2_7C_H       (REG_PHY_TRAIN_P2_BASE + 0xF9)
#define REG_PHY_TRAIN_P2_7D_L       (REG_PHY_TRAIN_P2_BASE + 0xFA)
#define REG_PHY_TRAIN_P2_7D_H       (REG_PHY_TRAIN_P2_BASE + 0xFB)
#define REG_PHY_TRAIN_P2_7E_L       (REG_PHY_TRAIN_P2_BASE + 0xFC)
#define REG_PHY_TRAIN_P2_7E_H       (REG_PHY_TRAIN_P2_BASE + 0xFD)
#define REG_PHY_TRAIN_P2_7F_L       (REG_PHY_TRAIN_P2_BASE + 0xFE)
#define REG_PHY_TRAIN_P2_7F_H       (REG_PHY_TRAIN_P2_BASE + 0xFF)

//=============================================================
// PHY2P1_0_P3
#define REG_PHY2P1_0_P3_00_L        (REG_PHY2P1_0_P3_BASE + 0x00)
#define REG_PHY2P1_0_P3_00_H        (REG_PHY2P1_0_P3_BASE + 0x01)
#define REG_PHY2P1_0_P3_01_L        (REG_PHY2P1_0_P3_BASE + 0x02)
#define REG_PHY2P1_0_P3_01_H        (REG_PHY2P1_0_P3_BASE + 0x03)
#define REG_PHY2P1_0_P3_02_L        (REG_PHY2P1_0_P3_BASE + 0x04)
#define REG_PHY2P1_0_P3_02_H        (REG_PHY2P1_0_P3_BASE + 0x05)
#define REG_PHY2P1_0_P3_03_L        (REG_PHY2P1_0_P3_BASE + 0x06)
#define REG_PHY2P1_0_P3_03_H        (REG_PHY2P1_0_P3_BASE + 0x07)
#define REG_PHY2P1_0_P3_04_L        (REG_PHY2P1_0_P3_BASE + 0x08)
#define REG_PHY2P1_0_P3_04_H        (REG_PHY2P1_0_P3_BASE + 0x09)
#define REG_PHY2P1_0_P3_05_L        (REG_PHY2P1_0_P3_BASE + 0x0A)
#define REG_PHY2P1_0_P3_05_H        (REG_PHY2P1_0_P3_BASE + 0x0B)
#define REG_PHY2P1_0_P3_06_L        (REG_PHY2P1_0_P3_BASE + 0x0C)
#define REG_PHY2P1_0_P3_06_H        (REG_PHY2P1_0_P3_BASE + 0x0D)
#define REG_PHY2P1_0_P3_07_L        (REG_PHY2P1_0_P3_BASE + 0x0E)
#define REG_PHY2P1_0_P3_07_H        (REG_PHY2P1_0_P3_BASE + 0x0F)
#define REG_PHY2P1_0_P3_08_L        (REG_PHY2P1_0_P3_BASE + 0x10)
#define REG_PHY2P1_0_P3_08_H        (REG_PHY2P1_0_P3_BASE + 0x11)
#define REG_PHY2P1_0_P3_09_L        (REG_PHY2P1_0_P3_BASE + 0x12)
#define REG_PHY2P1_0_P3_09_H        (REG_PHY2P1_0_P3_BASE + 0x13)
#define REG_PHY2P1_0_P3_0A_L        (REG_PHY2P1_0_P3_BASE + 0x14)
#define REG_PHY2P1_0_P3_0A_H        (REG_PHY2P1_0_P3_BASE + 0x15)
#define REG_PHY2P1_0_P3_0B_L        (REG_PHY2P1_0_P3_BASE + 0x16)
#define REG_PHY2P1_0_P3_0B_H        (REG_PHY2P1_0_P3_BASE + 0x17)
#define REG_PHY2P1_0_P3_0C_L        (REG_PHY2P1_0_P3_BASE + 0x18)
#define REG_PHY2P1_0_P3_0C_H        (REG_PHY2P1_0_P3_BASE + 0x19)
#define REG_PHY2P1_0_P3_0D_L        (REG_PHY2P1_0_P3_BASE + 0x1A)
#define REG_PHY2P1_0_P3_0D_H        (REG_PHY2P1_0_P3_BASE + 0x1B)
#define REG_PHY2P1_0_P3_0E_L        (REG_PHY2P1_0_P3_BASE + 0x1C)
#define REG_PHY2P1_0_P3_0E_H        (REG_PHY2P1_0_P3_BASE + 0x1D)
#define REG_PHY2P1_0_P3_0F_L        (REG_PHY2P1_0_P3_BASE + 0x1E)
#define REG_PHY2P1_0_P3_0F_H        (REG_PHY2P1_0_P3_BASE + 0x1F)
#define REG_PHY2P1_0_P3_10_L        (REG_PHY2P1_0_P3_BASE + 0x20)
#define REG_PHY2P1_0_P3_10_H        (REG_PHY2P1_0_P3_BASE + 0x21)
#define REG_PHY2P1_0_P3_11_L        (REG_PHY2P1_0_P3_BASE + 0x22)
#define REG_PHY2P1_0_P3_11_H        (REG_PHY2P1_0_P3_BASE + 0x23)
#define REG_PHY2P1_0_P3_12_L        (REG_PHY2P1_0_P3_BASE + 0x24)
#define REG_PHY2P1_0_P3_12_H        (REG_PHY2P1_0_P3_BASE + 0x25)
#define REG_PHY2P1_0_P3_13_L        (REG_PHY2P1_0_P3_BASE + 0x26)
#define REG_PHY2P1_0_P3_13_H        (REG_PHY2P1_0_P3_BASE + 0x27)
#define REG_PHY2P1_0_P3_14_L        (REG_PHY2P1_0_P3_BASE + 0x28)
#define REG_PHY2P1_0_P3_14_H        (REG_PHY2P1_0_P3_BASE + 0x29)
#define REG_PHY2P1_0_P3_15_L        (REG_PHY2P1_0_P3_BASE + 0x2A)
#define REG_PHY2P1_0_P3_15_H        (REG_PHY2P1_0_P3_BASE + 0x2B)
#define REG_PHY2P1_0_P3_16_L        (REG_PHY2P1_0_P3_BASE + 0x2C)
#define REG_PHY2P1_0_P3_16_H        (REG_PHY2P1_0_P3_BASE + 0x2D)
#define REG_PHY2P1_0_P3_17_L        (REG_PHY2P1_0_P3_BASE + 0x2E)
#define REG_PHY2P1_0_P3_17_H        (REG_PHY2P1_0_P3_BASE + 0x2F)
#define REG_PHY2P1_0_P3_18_L        (REG_PHY2P1_0_P3_BASE + 0x30)
#define REG_PHY2P1_0_P3_18_H        (REG_PHY2P1_0_P3_BASE + 0x31)
#define REG_PHY2P1_0_P3_19_L        (REG_PHY2P1_0_P3_BASE + 0x32)
#define REG_PHY2P1_0_P3_19_H        (REG_PHY2P1_0_P3_BASE + 0x33)
#define REG_PHY2P1_0_P3_1A_L        (REG_PHY2P1_0_P3_BASE + 0x34)
#define REG_PHY2P1_0_P3_1A_H        (REG_PHY2P1_0_P3_BASE + 0x35)
#define REG_PHY2P1_0_P3_1B_L        (REG_PHY2P1_0_P3_BASE + 0x36)
#define REG_PHY2P1_0_P3_1B_H        (REG_PHY2P1_0_P3_BASE + 0x37)
#define REG_PHY2P1_0_P3_1C_L        (REG_PHY2P1_0_P3_BASE + 0x38)
#define REG_PHY2P1_0_P3_1C_H        (REG_PHY2P1_0_P3_BASE + 0x39)
#define REG_PHY2P1_0_P3_1D_L        (REG_PHY2P1_0_P3_BASE + 0x3A)
#define REG_PHY2P1_0_P3_1D_H        (REG_PHY2P1_0_P3_BASE + 0x3B)
#define REG_PHY2P1_0_P3_1E_L        (REG_PHY2P1_0_P3_BASE + 0x3C)
#define REG_PHY2P1_0_P3_1E_H        (REG_PHY2P1_0_P3_BASE + 0x3D)
#define REG_PHY2P1_0_P3_1F_L        (REG_PHY2P1_0_P3_BASE + 0x3E)
#define REG_PHY2P1_0_P3_1F_H        (REG_PHY2P1_0_P3_BASE + 0x3F)
#define REG_PHY2P1_0_P3_20_L        (REG_PHY2P1_0_P3_BASE + 0x40)
#define REG_PHY2P1_0_P3_20_H        (REG_PHY2P1_0_P3_BASE + 0x41)
#define REG_PHY2P1_0_P3_21_L        (REG_PHY2P1_0_P3_BASE + 0x42)
#define REG_PHY2P1_0_P3_21_H        (REG_PHY2P1_0_P3_BASE + 0x43)
#define REG_PHY2P1_0_P3_22_L        (REG_PHY2P1_0_P3_BASE + 0x44)
#define REG_PHY2P1_0_P3_22_H        (REG_PHY2P1_0_P3_BASE + 0x45)
#define REG_PHY2P1_0_P3_23_L        (REG_PHY2P1_0_P3_BASE + 0x46)
#define REG_PHY2P1_0_P3_23_H        (REG_PHY2P1_0_P3_BASE + 0x47)
#define REG_PHY2P1_0_P3_24_L        (REG_PHY2P1_0_P3_BASE + 0x48)
#define REG_PHY2P1_0_P3_24_H        (REG_PHY2P1_0_P3_BASE + 0x49)
#define REG_PHY2P1_0_P3_25_L        (REG_PHY2P1_0_P3_BASE + 0x4A)
#define REG_PHY2P1_0_P3_25_H        (REG_PHY2P1_0_P3_BASE + 0x4B)
#define REG_PHY2P1_0_P3_26_L        (REG_PHY2P1_0_P3_BASE + 0x4C)
#define REG_PHY2P1_0_P3_26_H        (REG_PHY2P1_0_P3_BASE + 0x4D)
#define REG_PHY2P1_0_P3_27_L        (REG_PHY2P1_0_P3_BASE + 0x4E)
#define REG_PHY2P1_0_P3_27_H        (REG_PHY2P1_0_P3_BASE + 0x4F)
#define REG_PHY2P1_0_P3_28_L        (REG_PHY2P1_0_P3_BASE + 0x50)
#define REG_PHY2P1_0_P3_28_H        (REG_PHY2P1_0_P3_BASE + 0x51)
#define REG_PHY2P1_0_P3_29_L        (REG_PHY2P1_0_P3_BASE + 0x52)
#define REG_PHY2P1_0_P3_29_H        (REG_PHY2P1_0_P3_BASE + 0x53)
#define REG_PHY2P1_0_P3_2A_L        (REG_PHY2P1_0_P3_BASE + 0x54)
#define REG_PHY2P1_0_P3_2A_H        (REG_PHY2P1_0_P3_BASE + 0x55)
#define REG_PHY2P1_0_P3_2B_L        (REG_PHY2P1_0_P3_BASE + 0x56)
#define REG_PHY2P1_0_P3_2B_H        (REG_PHY2P1_0_P3_BASE + 0x57)
#define REG_PHY2P1_0_P3_2C_L        (REG_PHY2P1_0_P3_BASE + 0x58)
#define REG_PHY2P1_0_P3_2C_H        (REG_PHY2P1_0_P3_BASE + 0x59)
#define REG_PHY2P1_0_P3_2D_L        (REG_PHY2P1_0_P3_BASE + 0x5A)
#define REG_PHY2P1_0_P3_2D_H        (REG_PHY2P1_0_P3_BASE + 0x5B)
#define REG_PHY2P1_0_P3_2E_L        (REG_PHY2P1_0_P3_BASE + 0x5C)
#define REG_PHY2P1_0_P3_2E_H        (REG_PHY2P1_0_P3_BASE + 0x5D)
#define REG_PHY2P1_0_P3_2F_L        (REG_PHY2P1_0_P3_BASE + 0x5E)
#define REG_PHY2P1_0_P3_2F_H        (REG_PHY2P1_0_P3_BASE + 0x5F)
#define REG_PHY2P1_0_P3_30_L        (REG_PHY2P1_0_P3_BASE + 0x60)
#define REG_PHY2P1_0_P3_30_H        (REG_PHY2P1_0_P3_BASE + 0x61)
#define REG_PHY2P1_0_P3_31_L        (REG_PHY2P1_0_P3_BASE + 0x62)
#define REG_PHY2P1_0_P3_31_H        (REG_PHY2P1_0_P3_BASE + 0x63)
#define REG_PHY2P1_0_P3_32_L        (REG_PHY2P1_0_P3_BASE + 0x64)
#define REG_PHY2P1_0_P3_32_H        (REG_PHY2P1_0_P3_BASE + 0x65)
#define REG_PHY2P1_0_P3_33_L        (REG_PHY2P1_0_P3_BASE + 0x66)
#define REG_PHY2P1_0_P3_33_H        (REG_PHY2P1_0_P3_BASE + 0x67)
#define REG_PHY2P1_0_P3_34_L        (REG_PHY2P1_0_P3_BASE + 0x68)
#define REG_PHY2P1_0_P3_34_H        (REG_PHY2P1_0_P3_BASE + 0x69)
#define REG_PHY2P1_0_P3_35_L        (REG_PHY2P1_0_P3_BASE + 0x6A)
#define REG_PHY2P1_0_P3_35_H        (REG_PHY2P1_0_P3_BASE + 0x6B)
#define REG_PHY2P1_0_P3_36_L        (REG_PHY2P1_0_P3_BASE + 0x6C)
#define REG_PHY2P1_0_P3_36_H        (REG_PHY2P1_0_P3_BASE + 0x6D)
#define REG_PHY2P1_0_P3_37_L        (REG_PHY2P1_0_P3_BASE + 0x6E)
#define REG_PHY2P1_0_P3_37_H        (REG_PHY2P1_0_P3_BASE + 0x6F)
#define REG_PHY2P1_0_P3_38_L        (REG_PHY2P1_0_P3_BASE + 0x70)
#define REG_PHY2P1_0_P3_38_H        (REG_PHY2P1_0_P3_BASE + 0x71)
#define REG_PHY2P1_0_P3_39_L        (REG_PHY2P1_0_P3_BASE + 0x72)
#define REG_PHY2P1_0_P3_39_H        (REG_PHY2P1_0_P3_BASE + 0x73)
#define REG_PHY2P1_0_P3_3A_L        (REG_PHY2P1_0_P3_BASE + 0x74)
#define REG_PHY2P1_0_P3_3A_H        (REG_PHY2P1_0_P3_BASE + 0x75)
#define REG_PHY2P1_0_P3_3B_L        (REG_PHY2P1_0_P3_BASE + 0x76)
#define REG_PHY2P1_0_P3_3B_H        (REG_PHY2P1_0_P3_BASE + 0x77)
#define REG_PHY2P1_0_P3_3C_L        (REG_PHY2P1_0_P3_BASE + 0x78)
#define REG_PHY2P1_0_P3_3C_H        (REG_PHY2P1_0_P3_BASE + 0x79)
#define REG_PHY2P1_0_P3_3D_L        (REG_PHY2P1_0_P3_BASE + 0x7A)
#define REG_PHY2P1_0_P3_3D_H        (REG_PHY2P1_0_P3_BASE + 0x7B)
#define REG_PHY2P1_0_P3_3E_L        (REG_PHY2P1_0_P3_BASE + 0x7C)
#define REG_PHY2P1_0_P3_3E_H        (REG_PHY2P1_0_P3_BASE + 0x7D)
#define REG_PHY2P1_0_P3_3F_L        (REG_PHY2P1_0_P3_BASE + 0x7E)
#define REG_PHY2P1_0_P3_3F_H        (REG_PHY2P1_0_P3_BASE + 0x7F)
#define REG_PHY2P1_0_P3_40_L        (REG_PHY2P1_0_P3_BASE + 0x80)
#define REG_PHY2P1_0_P3_40_H        (REG_PHY2P1_0_P3_BASE + 0x81)
#define REG_PHY2P1_0_P3_41_L        (REG_PHY2P1_0_P3_BASE + 0x82)
#define REG_PHY2P1_0_P3_41_H        (REG_PHY2P1_0_P3_BASE + 0x83)
#define REG_PHY2P1_0_P3_42_L        (REG_PHY2P1_0_P3_BASE + 0x84)
#define REG_PHY2P1_0_P3_42_H        (REG_PHY2P1_0_P3_BASE + 0x85)
#define REG_PHY2P1_0_P3_43_L        (REG_PHY2P1_0_P3_BASE + 0x86)
#define REG_PHY2P1_0_P3_43_H        (REG_PHY2P1_0_P3_BASE + 0x87)
#define REG_PHY2P1_0_P3_44_L        (REG_PHY2P1_0_P3_BASE + 0x88)
#define REG_PHY2P1_0_P3_44_H        (REG_PHY2P1_0_P3_BASE + 0x89)
#define REG_PHY2P1_0_P3_45_L        (REG_PHY2P1_0_P3_BASE + 0x8A)
#define REG_PHY2P1_0_P3_45_H        (REG_PHY2P1_0_P3_BASE + 0x8B)
#define REG_PHY2P1_0_P3_46_L        (REG_PHY2P1_0_P3_BASE + 0x8C)
#define REG_PHY2P1_0_P3_46_H        (REG_PHY2P1_0_P3_BASE + 0x8D)
#define REG_PHY2P1_0_P3_47_L        (REG_PHY2P1_0_P3_BASE + 0x8E)
#define REG_PHY2P1_0_P3_47_H        (REG_PHY2P1_0_P3_BASE + 0x8F)
#define REG_PHY2P1_0_P3_48_L        (REG_PHY2P1_0_P3_BASE + 0x90)
#define REG_PHY2P1_0_P3_48_H        (REG_PHY2P1_0_P3_BASE + 0x91)
#define REG_PHY2P1_0_P3_49_L        (REG_PHY2P1_0_P3_BASE + 0x92)
#define REG_PHY2P1_0_P3_49_H        (REG_PHY2P1_0_P3_BASE + 0x93)
#define REG_PHY2P1_0_P3_4A_L        (REG_PHY2P1_0_P3_BASE + 0x94)
#define REG_PHY2P1_0_P3_4A_H        (REG_PHY2P1_0_P3_BASE + 0x95)
#define REG_PHY2P1_0_P3_4B_L        (REG_PHY2P1_0_P3_BASE + 0x96)
#define REG_PHY2P1_0_P3_4B_H        (REG_PHY2P1_0_P3_BASE + 0x97)
#define REG_PHY2P1_0_P3_4C_L        (REG_PHY2P1_0_P3_BASE + 0x98)
#define REG_PHY2P1_0_P3_4C_H        (REG_PHY2P1_0_P3_BASE + 0x99)
#define REG_PHY2P1_0_P3_4D_L        (REG_PHY2P1_0_P3_BASE + 0x9A)
#define REG_PHY2P1_0_P3_4D_H        (REG_PHY2P1_0_P3_BASE + 0x9B)
#define REG_PHY2P1_0_P3_4E_L        (REG_PHY2P1_0_P3_BASE + 0x9C)
#define REG_PHY2P1_0_P3_4E_H        (REG_PHY2P1_0_P3_BASE + 0x9D)
#define REG_PHY2P1_0_P3_4F_L        (REG_PHY2P1_0_P3_BASE + 0x9E)
#define REG_PHY2P1_0_P3_4F_H        (REG_PHY2P1_0_P3_BASE + 0x9F)
#define REG_PHY2P1_0_P3_50_L        (REG_PHY2P1_0_P3_BASE + 0xA0)
#define REG_PHY2P1_0_P3_50_H        (REG_PHY2P1_0_P3_BASE + 0xA1)
#define REG_PHY2P1_0_P3_51_L        (REG_PHY2P1_0_P3_BASE + 0xA2)
#define REG_PHY2P1_0_P3_51_H        (REG_PHY2P1_0_P3_BASE + 0xA3)
#define REG_PHY2P1_0_P3_52_L        (REG_PHY2P1_0_P3_BASE + 0xA4)
#define REG_PHY2P1_0_P3_52_H        (REG_PHY2P1_0_P3_BASE + 0xA5)
#define REG_PHY2P1_0_P3_53_L        (REG_PHY2P1_0_P3_BASE + 0xA6)
#define REG_PHY2P1_0_P3_53_H        (REG_PHY2P1_0_P3_BASE + 0xA7)
#define REG_PHY2P1_0_P3_54_L        (REG_PHY2P1_0_P3_BASE + 0xA8)
#define REG_PHY2P1_0_P3_54_H        (REG_PHY2P1_0_P3_BASE + 0xA9)
#define REG_PHY2P1_0_P3_55_L        (REG_PHY2P1_0_P3_BASE + 0xAA)
#define REG_PHY2P1_0_P3_55_H        (REG_PHY2P1_0_P3_BASE + 0xAB)
#define REG_PHY2P1_0_P3_56_L        (REG_PHY2P1_0_P3_BASE + 0xAC)
#define REG_PHY2P1_0_P3_56_H        (REG_PHY2P1_0_P3_BASE + 0xAD)
#define REG_PHY2P1_0_P3_57_L        (REG_PHY2P1_0_P3_BASE + 0xAE)
#define REG_PHY2P1_0_P3_57_H        (REG_PHY2P1_0_P3_BASE + 0xAF)
#define REG_PHY2P1_0_P3_58_L        (REG_PHY2P1_0_P3_BASE + 0xB0)
#define REG_PHY2P1_0_P3_58_H        (REG_PHY2P1_0_P3_BASE + 0xB1)
#define REG_PHY2P1_0_P3_59_L        (REG_PHY2P1_0_P3_BASE + 0xB2)
#define REG_PHY2P1_0_P3_59_H        (REG_PHY2P1_0_P3_BASE + 0xB3)
#define REG_PHY2P1_0_P3_5A_L        (REG_PHY2P1_0_P3_BASE + 0xB4)
#define REG_PHY2P1_0_P3_5A_H        (REG_PHY2P1_0_P3_BASE + 0xB5)
#define REG_PHY2P1_0_P3_5B_L        (REG_PHY2P1_0_P3_BASE + 0xB6)
#define REG_PHY2P1_0_P3_5B_H        (REG_PHY2P1_0_P3_BASE + 0xB7)
#define REG_PHY2P1_0_P3_5C_L        (REG_PHY2P1_0_P3_BASE + 0xB8)
#define REG_PHY2P1_0_P3_5C_H        (REG_PHY2P1_0_P3_BASE + 0xB9)
#define REG_PHY2P1_0_P3_5D_L        (REG_PHY2P1_0_P3_BASE + 0xBA)
#define REG_PHY2P1_0_P3_5D_H        (REG_PHY2P1_0_P3_BASE + 0xBB)
#define REG_PHY2P1_0_P3_5E_L        (REG_PHY2P1_0_P3_BASE + 0xBC)
#define REG_PHY2P1_0_P3_5E_H        (REG_PHY2P1_0_P3_BASE + 0xBD)
#define REG_PHY2P1_0_P3_5F_L        (REG_PHY2P1_0_P3_BASE + 0xBE)
#define REG_PHY2P1_0_P3_5F_H        (REG_PHY2P1_0_P3_BASE + 0xBF)
#define REG_PHY2P1_0_P3_60_L        (REG_PHY2P1_0_P3_BASE + 0xC0)
#define REG_PHY2P1_0_P3_60_H        (REG_PHY2P1_0_P3_BASE + 0xC1)
#define REG_PHY2P1_0_P3_61_L        (REG_PHY2P1_0_P3_BASE + 0xC2)
#define REG_PHY2P1_0_P3_61_H        (REG_PHY2P1_0_P3_BASE + 0xC3)
#define REG_PHY2P1_0_P3_62_L        (REG_PHY2P1_0_P3_BASE + 0xC4)
#define REG_PHY2P1_0_P3_62_H        (REG_PHY2P1_0_P3_BASE + 0xC5)
#define REG_PHY2P1_0_P3_63_L        (REG_PHY2P1_0_P3_BASE + 0xC6)
#define REG_PHY2P1_0_P3_63_H        (REG_PHY2P1_0_P3_BASE + 0xC7)
#define REG_PHY2P1_0_P3_64_L        (REG_PHY2P1_0_P3_BASE + 0xC8)
#define REG_PHY2P1_0_P3_64_H        (REG_PHY2P1_0_P3_BASE + 0xC9)
#define REG_PHY2P1_0_P3_65_L        (REG_PHY2P1_0_P3_BASE + 0xCA)
#define REG_PHY2P1_0_P3_65_H        (REG_PHY2P1_0_P3_BASE + 0xCB)
#define REG_PHY2P1_0_P3_66_L        (REG_PHY2P1_0_P3_BASE + 0xCC)
#define REG_PHY2P1_0_P3_66_H        (REG_PHY2P1_0_P3_BASE + 0xCD)
#define REG_PHY2P1_0_P3_67_L        (REG_PHY2P1_0_P3_BASE + 0xCE)
#define REG_PHY2P1_0_P3_67_H        (REG_PHY2P1_0_P3_BASE + 0xCF)
#define REG_PHY2P1_0_P3_68_L        (REG_PHY2P1_0_P3_BASE + 0xD0)
#define REG_PHY2P1_0_P3_68_H        (REG_PHY2P1_0_P3_BASE + 0xD1)
#define REG_PHY2P1_0_P3_69_L        (REG_PHY2P1_0_P3_BASE + 0xD2)
#define REG_PHY2P1_0_P3_69_H        (REG_PHY2P1_0_P3_BASE + 0xD3)
#define REG_PHY2P1_0_P3_6A_L        (REG_PHY2P1_0_P3_BASE + 0xD4)
#define REG_PHY2P1_0_P3_6A_H        (REG_PHY2P1_0_P3_BASE + 0xD5)
#define REG_PHY2P1_0_P3_6B_L        (REG_PHY2P1_0_P3_BASE + 0xD6)
#define REG_PHY2P1_0_P3_6B_H        (REG_PHY2P1_0_P3_BASE + 0xD7)
#define REG_PHY2P1_0_P3_6C_L        (REG_PHY2P1_0_P3_BASE + 0xD8)
#define REG_PHY2P1_0_P3_6C_H        (REG_PHY2P1_0_P3_BASE + 0xD9)
#define REG_PHY2P1_0_P3_6D_L        (REG_PHY2P1_0_P3_BASE + 0xDA)
#define REG_PHY2P1_0_P3_6D_H        (REG_PHY2P1_0_P3_BASE + 0xDB)
#define REG_PHY2P1_0_P3_6E_L        (REG_PHY2P1_0_P3_BASE + 0xDC)
#define REG_PHY2P1_0_P3_6E_H        (REG_PHY2P1_0_P3_BASE + 0xDD)
#define REG_PHY2P1_0_P3_6F_L        (REG_PHY2P1_0_P3_BASE + 0xDE)
#define REG_PHY2P1_0_P3_6F_H        (REG_PHY2P1_0_P3_BASE + 0xDF)
#define REG_PHY2P1_0_P3_70_L        (REG_PHY2P1_0_P3_BASE + 0xE0)
#define REG_PHY2P1_0_P3_70_H        (REG_PHY2P1_0_P3_BASE + 0xE1)
#define REG_PHY2P1_0_P3_71_L        (REG_PHY2P1_0_P3_BASE + 0xE2)
#define REG_PHY2P1_0_P3_71_H        (REG_PHY2P1_0_P3_BASE + 0xE3)
#define REG_PHY2P1_0_P3_72_L        (REG_PHY2P1_0_P3_BASE + 0xE4)
#define REG_PHY2P1_0_P3_72_H        (REG_PHY2P1_0_P3_BASE + 0xE5)
#define REG_PHY2P1_0_P3_73_L        (REG_PHY2P1_0_P3_BASE + 0xE6)
#define REG_PHY2P1_0_P3_73_H        (REG_PHY2P1_0_P3_BASE + 0xE7)
#define REG_PHY2P1_0_P3_74_L        (REG_PHY2P1_0_P3_BASE + 0xE8)
#define REG_PHY2P1_0_P3_74_H        (REG_PHY2P1_0_P3_BASE + 0xE9)
#define REG_PHY2P1_0_P3_75_L        (REG_PHY2P1_0_P3_BASE + 0xEA)
#define REG_PHY2P1_0_P3_75_H        (REG_PHY2P1_0_P3_BASE + 0xEB)
#define REG_PHY2P1_0_P3_76_L        (REG_PHY2P1_0_P3_BASE + 0xEC)
#define REG_PHY2P1_0_P3_76_H        (REG_PHY2P1_0_P3_BASE + 0xED)
#define REG_PHY2P1_0_P3_77_L        (REG_PHY2P1_0_P3_BASE + 0xEE)
#define REG_PHY2P1_0_P3_77_H        (REG_PHY2P1_0_P3_BASE + 0xEF)
#define REG_PHY2P1_0_P3_78_L        (REG_PHY2P1_0_P3_BASE + 0xF0)
#define REG_PHY2P1_0_P3_78_H        (REG_PHY2P1_0_P3_BASE + 0xF1)
#define REG_PHY2P1_0_P3_79_L        (REG_PHY2P1_0_P3_BASE + 0xF2)
#define REG_PHY2P1_0_P3_79_H        (REG_PHY2P1_0_P3_BASE + 0xF3)
#define REG_PHY2P1_0_P3_7A_L        (REG_PHY2P1_0_P3_BASE + 0xF4)
#define REG_PHY2P1_0_P3_7A_H        (REG_PHY2P1_0_P3_BASE + 0xF5)
#define REG_PHY2P1_0_P3_7B_L        (REG_PHY2P1_0_P3_BASE + 0xF6)
#define REG_PHY2P1_0_P3_7B_H        (REG_PHY2P1_0_P3_BASE + 0xF7)
#define REG_PHY2P1_0_P3_7C_L        (REG_PHY2P1_0_P3_BASE + 0xF8)
#define REG_PHY2P1_0_P3_7C_H        (REG_PHY2P1_0_P3_BASE + 0xF9)
#define REG_PHY2P1_0_P3_7D_L        (REG_PHY2P1_0_P3_BASE + 0xFA)
#define REG_PHY2P1_0_P3_7D_H        (REG_PHY2P1_0_P3_BASE + 0xFB)
#define REG_PHY2P1_0_P3_7E_L        (REG_PHY2P1_0_P3_BASE + 0xFC)
#define REG_PHY2P1_0_P3_7E_H        (REG_PHY2P1_0_P3_BASE + 0xFD)
#define REG_PHY2P1_0_P3_7F_L        (REG_PHY2P1_0_P3_BASE + 0xFE)
#define REG_PHY2P1_0_P3_7F_H        (REG_PHY2P1_0_P3_BASE + 0xFF)

//=============================================================
// PHY2P1_1_P3
#define REG_PHY2P1_1_P3_00_L        (REG_PHY2P1_1_P3_BASE + 0x00)
#define REG_PHY2P1_1_P3_00_H        (REG_PHY2P1_1_P3_BASE + 0x01)
#define REG_PHY2P1_1_P3_01_L        (REG_PHY2P1_1_P3_BASE + 0x02)
#define REG_PHY2P1_1_P3_01_H        (REG_PHY2P1_1_P3_BASE + 0x03)
#define REG_PHY2P1_1_P3_02_L        (REG_PHY2P1_1_P3_BASE + 0x04)
#define REG_PHY2P1_1_P3_02_H        (REG_PHY2P1_1_P3_BASE + 0x05)
#define REG_PHY2P1_1_P3_03_L        (REG_PHY2P1_1_P3_BASE + 0x06)
#define REG_PHY2P1_1_P3_03_H        (REG_PHY2P1_1_P3_BASE + 0x07)
#define REG_PHY2P1_1_P3_04_L        (REG_PHY2P1_1_P3_BASE + 0x08)
#define REG_PHY2P1_1_P3_04_H        (REG_PHY2P1_1_P3_BASE + 0x09)
#define REG_PHY2P1_1_P3_05_L        (REG_PHY2P1_1_P3_BASE + 0x0A)
#define REG_PHY2P1_1_P3_05_H        (REG_PHY2P1_1_P3_BASE + 0x0B)
#define REG_PHY2P1_1_P3_06_L        (REG_PHY2P1_1_P3_BASE + 0x0C)
#define REG_PHY2P1_1_P3_06_H        (REG_PHY2P1_1_P3_BASE + 0x0D)
#define REG_PHY2P1_1_P3_07_L        (REG_PHY2P1_1_P3_BASE + 0x0E)
#define REG_PHY2P1_1_P3_07_H        (REG_PHY2P1_1_P3_BASE + 0x0F)
#define REG_PHY2P1_1_P3_08_L        (REG_PHY2P1_1_P3_BASE + 0x10)
#define REG_PHY2P1_1_P3_08_H        (REG_PHY2P1_1_P3_BASE + 0x11)
#define REG_PHY2P1_1_P3_09_L        (REG_PHY2P1_1_P3_BASE + 0x12)
#define REG_PHY2P1_1_P3_09_H        (REG_PHY2P1_1_P3_BASE + 0x13)
#define REG_PHY2P1_1_P3_0A_L        (REG_PHY2P1_1_P3_BASE + 0x14)
#define REG_PHY2P1_1_P3_0A_H        (REG_PHY2P1_1_P3_BASE + 0x15)
#define REG_PHY2P1_1_P3_0B_L        (REG_PHY2P1_1_P3_BASE + 0x16)
#define REG_PHY2P1_1_P3_0B_H        (REG_PHY2P1_1_P3_BASE + 0x17)
#define REG_PHY2P1_1_P3_0C_L        (REG_PHY2P1_1_P3_BASE + 0x18)
#define REG_PHY2P1_1_P3_0C_H        (REG_PHY2P1_1_P3_BASE + 0x19)
#define REG_PHY2P1_1_P3_0D_L        (REG_PHY2P1_1_P3_BASE + 0x1A)
#define REG_PHY2P1_1_P3_0D_H        (REG_PHY2P1_1_P3_BASE + 0x1B)
#define REG_PHY2P1_1_P3_0E_L        (REG_PHY2P1_1_P3_BASE + 0x1C)
#define REG_PHY2P1_1_P3_0E_H        (REG_PHY2P1_1_P3_BASE + 0x1D)
#define REG_PHY2P1_1_P3_0F_L        (REG_PHY2P1_1_P3_BASE + 0x1E)
#define REG_PHY2P1_1_P3_0F_H        (REG_PHY2P1_1_P3_BASE + 0x1F)
#define REG_PHY2P1_1_P3_10_L        (REG_PHY2P1_1_P3_BASE + 0x20)
#define REG_PHY2P1_1_P3_10_H        (REG_PHY2P1_1_P3_BASE + 0x21)
#define REG_PHY2P1_1_P3_11_L        (REG_PHY2P1_1_P3_BASE + 0x22)
#define REG_PHY2P1_1_P3_11_H        (REG_PHY2P1_1_P3_BASE + 0x23)
#define REG_PHY2P1_1_P3_12_L        (REG_PHY2P1_1_P3_BASE + 0x24)
#define REG_PHY2P1_1_P3_12_H        (REG_PHY2P1_1_P3_BASE + 0x25)
#define REG_PHY2P1_1_P3_13_L        (REG_PHY2P1_1_P3_BASE + 0x26)
#define REG_PHY2P1_1_P3_13_H        (REG_PHY2P1_1_P3_BASE + 0x27)
#define REG_PHY2P1_1_P3_14_L        (REG_PHY2P1_1_P3_BASE + 0x28)
#define REG_PHY2P1_1_P3_14_H        (REG_PHY2P1_1_P3_BASE + 0x29)
#define REG_PHY2P1_1_P3_15_L        (REG_PHY2P1_1_P3_BASE + 0x2A)
#define REG_PHY2P1_1_P3_15_H        (REG_PHY2P1_1_P3_BASE + 0x2B)
#define REG_PHY2P1_1_P3_16_L        (REG_PHY2P1_1_P3_BASE + 0x2C)
#define REG_PHY2P1_1_P3_16_H        (REG_PHY2P1_1_P3_BASE + 0x2D)
#define REG_PHY2P1_1_P3_17_L        (REG_PHY2P1_1_P3_BASE + 0x2E)
#define REG_PHY2P1_1_P3_17_H        (REG_PHY2P1_1_P3_BASE + 0x2F)
#define REG_PHY2P1_1_P3_18_L        (REG_PHY2P1_1_P3_BASE + 0x30)
#define REG_PHY2P1_1_P3_18_H        (REG_PHY2P1_1_P3_BASE + 0x31)
#define REG_PHY2P1_1_P3_19_L        (REG_PHY2P1_1_P3_BASE + 0x32)
#define REG_PHY2P1_1_P3_19_H        (REG_PHY2P1_1_P3_BASE + 0x33)
#define REG_PHY2P1_1_P3_1A_L        (REG_PHY2P1_1_P3_BASE + 0x34)
#define REG_PHY2P1_1_P3_1A_H        (REG_PHY2P1_1_P3_BASE + 0x35)
#define REG_PHY2P1_1_P3_1B_L        (REG_PHY2P1_1_P3_BASE + 0x36)
#define REG_PHY2P1_1_P3_1B_H        (REG_PHY2P1_1_P3_BASE + 0x37)
#define REG_PHY2P1_1_P3_1C_L        (REG_PHY2P1_1_P3_BASE + 0x38)
#define REG_PHY2P1_1_P3_1C_H        (REG_PHY2P1_1_P3_BASE + 0x39)
#define REG_PHY2P1_1_P3_1D_L        (REG_PHY2P1_1_P3_BASE + 0x3A)
#define REG_PHY2P1_1_P3_1D_H        (REG_PHY2P1_1_P3_BASE + 0x3B)
#define REG_PHY2P1_1_P3_1E_L        (REG_PHY2P1_1_P3_BASE + 0x3C)
#define REG_PHY2P1_1_P3_1E_H        (REG_PHY2P1_1_P3_BASE + 0x3D)
#define REG_PHY2P1_1_P3_1F_L        (REG_PHY2P1_1_P3_BASE + 0x3E)
#define REG_PHY2P1_1_P3_1F_H        (REG_PHY2P1_1_P3_BASE + 0x3F)
#define REG_PHY2P1_1_P3_20_L        (REG_PHY2P1_1_P3_BASE + 0x40)
#define REG_PHY2P1_1_P3_20_H        (REG_PHY2P1_1_P3_BASE + 0x41)
#define REG_PHY2P1_1_P3_21_L        (REG_PHY2P1_1_P3_BASE + 0x42)
#define REG_PHY2P1_1_P3_21_H        (REG_PHY2P1_1_P3_BASE + 0x43)
#define REG_PHY2P1_1_P3_22_L        (REG_PHY2P1_1_P3_BASE + 0x44)
#define REG_PHY2P1_1_P3_22_H        (REG_PHY2P1_1_P3_BASE + 0x45)
#define REG_PHY2P1_1_P3_23_L        (REG_PHY2P1_1_P3_BASE + 0x46)
#define REG_PHY2P1_1_P3_23_H        (REG_PHY2P1_1_P3_BASE + 0x47)
#define REG_PHY2P1_1_P3_24_L        (REG_PHY2P1_1_P3_BASE + 0x48)
#define REG_PHY2P1_1_P3_24_H        (REG_PHY2P1_1_P3_BASE + 0x49)
#define REG_PHY2P1_1_P3_25_L        (REG_PHY2P1_1_P3_BASE + 0x4A)
#define REG_PHY2P1_1_P3_25_H        (REG_PHY2P1_1_P3_BASE + 0x4B)
#define REG_PHY2P1_1_P3_26_L        (REG_PHY2P1_1_P3_BASE + 0x4C)
#define REG_PHY2P1_1_P3_26_H        (REG_PHY2P1_1_P3_BASE + 0x4D)
#define REG_PHY2P1_1_P3_27_L        (REG_PHY2P1_1_P3_BASE + 0x4E)
#define REG_PHY2P1_1_P3_27_H        (REG_PHY2P1_1_P3_BASE + 0x4F)
#define REG_PHY2P1_1_P3_28_L        (REG_PHY2P1_1_P3_BASE + 0x50)
#define REG_PHY2P1_1_P3_28_H        (REG_PHY2P1_1_P3_BASE + 0x51)
#define REG_PHY2P1_1_P3_29_L        (REG_PHY2P1_1_P3_BASE + 0x52)
#define REG_PHY2P1_1_P3_29_H        (REG_PHY2P1_1_P3_BASE + 0x53)
#define REG_PHY2P1_1_P3_2A_L        (REG_PHY2P1_1_P3_BASE + 0x54)
#define REG_PHY2P1_1_P3_2A_H        (REG_PHY2P1_1_P3_BASE + 0x55)
#define REG_PHY2P1_1_P3_2B_L        (REG_PHY2P1_1_P3_BASE + 0x56)
#define REG_PHY2P1_1_P3_2B_H        (REG_PHY2P1_1_P3_BASE + 0x57)
#define REG_PHY2P1_1_P3_2C_L        (REG_PHY2P1_1_P3_BASE + 0x58)
#define REG_PHY2P1_1_P3_2C_H        (REG_PHY2P1_1_P3_BASE + 0x59)
#define REG_PHY2P1_1_P3_2D_L        (REG_PHY2P1_1_P3_BASE + 0x5A)
#define REG_PHY2P1_1_P3_2D_H        (REG_PHY2P1_1_P3_BASE + 0x5B)
#define REG_PHY2P1_1_P3_2E_L        (REG_PHY2P1_1_P3_BASE + 0x5C)
#define REG_PHY2P1_1_P3_2E_H        (REG_PHY2P1_1_P3_BASE + 0x5D)
#define REG_PHY2P1_1_P3_2F_L        (REG_PHY2P1_1_P3_BASE + 0x5E)
#define REG_PHY2P1_1_P3_2F_H        (REG_PHY2P1_1_P3_BASE + 0x5F)
#define REG_PHY2P1_1_P3_30_L        (REG_PHY2P1_1_P3_BASE + 0x60)
#define REG_PHY2P1_1_P3_30_H        (REG_PHY2P1_1_P3_BASE + 0x61)
#define REG_PHY2P1_1_P3_31_L        (REG_PHY2P1_1_P3_BASE + 0x62)
#define REG_PHY2P1_1_P3_31_H        (REG_PHY2P1_1_P3_BASE + 0x63)
#define REG_PHY2P1_1_P3_32_L        (REG_PHY2P1_1_P3_BASE + 0x64)
#define REG_PHY2P1_1_P3_32_H        (REG_PHY2P1_1_P3_BASE + 0x65)
#define REG_PHY2P1_1_P3_33_L        (REG_PHY2P1_1_P3_BASE + 0x66)
#define REG_PHY2P1_1_P3_33_H        (REG_PHY2P1_1_P3_BASE + 0x67)
#define REG_PHY2P1_1_P3_34_L        (REG_PHY2P1_1_P3_BASE + 0x68)
#define REG_PHY2P1_1_P3_34_H        (REG_PHY2P1_1_P3_BASE + 0x69)
#define REG_PHY2P1_1_P3_35_L        (REG_PHY2P1_1_P3_BASE + 0x6A)
#define REG_PHY2P1_1_P3_35_H        (REG_PHY2P1_1_P3_BASE + 0x6B)
#define REG_PHY2P1_1_P3_36_L        (REG_PHY2P1_1_P3_BASE + 0x6C)
#define REG_PHY2P1_1_P3_36_H        (REG_PHY2P1_1_P3_BASE + 0x6D)
#define REG_PHY2P1_1_P3_37_L        (REG_PHY2P1_1_P3_BASE + 0x6E)
#define REG_PHY2P1_1_P3_37_H        (REG_PHY2P1_1_P3_BASE + 0x6F)
#define REG_PHY2P1_1_P3_38_L        (REG_PHY2P1_1_P3_BASE + 0x70)
#define REG_PHY2P1_1_P3_38_H        (REG_PHY2P1_1_P3_BASE + 0x71)
#define REG_PHY2P1_1_P3_39_L        (REG_PHY2P1_1_P3_BASE + 0x72)
#define REG_PHY2P1_1_P3_39_H        (REG_PHY2P1_1_P3_BASE + 0x73)
#define REG_PHY2P1_1_P3_3A_L        (REG_PHY2P1_1_P3_BASE + 0x74)
#define REG_PHY2P1_1_P3_3A_H        (REG_PHY2P1_1_P3_BASE + 0x75)
#define REG_PHY2P1_1_P3_3B_L        (REG_PHY2P1_1_P3_BASE + 0x76)
#define REG_PHY2P1_1_P3_3B_H        (REG_PHY2P1_1_P3_BASE + 0x77)
#define REG_PHY2P1_1_P3_3C_L        (REG_PHY2P1_1_P3_BASE + 0x78)
#define REG_PHY2P1_1_P3_3C_H        (REG_PHY2P1_1_P3_BASE + 0x79)
#define REG_PHY2P1_1_P3_3D_L        (REG_PHY2P1_1_P3_BASE + 0x7A)
#define REG_PHY2P1_1_P3_3D_H        (REG_PHY2P1_1_P3_BASE + 0x7B)
#define REG_PHY2P1_1_P3_3E_L        (REG_PHY2P1_1_P3_BASE + 0x7C)
#define REG_PHY2P1_1_P3_3E_H        (REG_PHY2P1_1_P3_BASE + 0x7D)
#define REG_PHY2P1_1_P3_3F_L        (REG_PHY2P1_1_P3_BASE + 0x7E)
#define REG_PHY2P1_1_P3_3F_H        (REG_PHY2P1_1_P3_BASE + 0x7F)
#define REG_PHY2P1_1_P3_40_L        (REG_PHY2P1_1_P3_BASE + 0x80)
#define REG_PHY2P1_1_P3_40_H        (REG_PHY2P1_1_P3_BASE + 0x81)
#define REG_PHY2P1_1_P3_41_L        (REG_PHY2P1_1_P3_BASE + 0x82)
#define REG_PHY2P1_1_P3_41_H        (REG_PHY2P1_1_P3_BASE + 0x83)
#define REG_PHY2P1_1_P3_42_L        (REG_PHY2P1_1_P3_BASE + 0x84)
#define REG_PHY2P1_1_P3_42_H        (REG_PHY2P1_1_P3_BASE + 0x85)
#define REG_PHY2P1_1_P3_43_L        (REG_PHY2P1_1_P3_BASE + 0x86)
#define REG_PHY2P1_1_P3_43_H        (REG_PHY2P1_1_P3_BASE + 0x87)
#define REG_PHY2P1_1_P3_44_L        (REG_PHY2P1_1_P3_BASE + 0x88)
#define REG_PHY2P1_1_P3_44_H        (REG_PHY2P1_1_P3_BASE + 0x89)
#define REG_PHY2P1_1_P3_45_L        (REG_PHY2P1_1_P3_BASE + 0x8A)
#define REG_PHY2P1_1_P3_45_H        (REG_PHY2P1_1_P3_BASE + 0x8B)
#define REG_PHY2P1_1_P3_46_L        (REG_PHY2P1_1_P3_BASE + 0x8C)
#define REG_PHY2P1_1_P3_46_H        (REG_PHY2P1_1_P3_BASE + 0x8D)
#define REG_PHY2P1_1_P3_47_L        (REG_PHY2P1_1_P3_BASE + 0x8E)
#define REG_PHY2P1_1_P3_47_H        (REG_PHY2P1_1_P3_BASE + 0x8F)
#define REG_PHY2P1_1_P3_48_L        (REG_PHY2P1_1_P3_BASE + 0x90)
#define REG_PHY2P1_1_P3_48_H        (REG_PHY2P1_1_P3_BASE + 0x91)
#define REG_PHY2P1_1_P3_49_L        (REG_PHY2P1_1_P3_BASE + 0x92)
#define REG_PHY2P1_1_P3_49_H        (REG_PHY2P1_1_P3_BASE + 0x93)
#define REG_PHY2P1_1_P3_4A_L        (REG_PHY2P1_1_P3_BASE + 0x94)
#define REG_PHY2P1_1_P3_4A_H        (REG_PHY2P1_1_P3_BASE + 0x95)
#define REG_PHY2P1_1_P3_4B_L        (REG_PHY2P1_1_P3_BASE + 0x96)
#define REG_PHY2P1_1_P3_4B_H        (REG_PHY2P1_1_P3_BASE + 0x97)
#define REG_PHY2P1_1_P3_4C_L        (REG_PHY2P1_1_P3_BASE + 0x98)
#define REG_PHY2P1_1_P3_4C_H        (REG_PHY2P1_1_P3_BASE + 0x99)
#define REG_PHY2P1_1_P3_4D_L        (REG_PHY2P1_1_P3_BASE + 0x9A)
#define REG_PHY2P1_1_P3_4D_H        (REG_PHY2P1_1_P3_BASE + 0x9B)
#define REG_PHY2P1_1_P3_4E_L        (REG_PHY2P1_1_P3_BASE + 0x9C)
#define REG_PHY2P1_1_P3_4E_H        (REG_PHY2P1_1_P3_BASE + 0x9D)
#define REG_PHY2P1_1_P3_4F_L        (REG_PHY2P1_1_P3_BASE + 0x9E)
#define REG_PHY2P1_1_P3_4F_H        (REG_PHY2P1_1_P3_BASE + 0x9F)
#define REG_PHY2P1_1_P3_50_L        (REG_PHY2P1_1_P3_BASE + 0xA0)
#define REG_PHY2P1_1_P3_50_H        (REG_PHY2P1_1_P3_BASE + 0xA1)
#define REG_PHY2P1_1_P3_51_L        (REG_PHY2P1_1_P3_BASE + 0xA2)
#define REG_PHY2P1_1_P3_51_H        (REG_PHY2P1_1_P3_BASE + 0xA3)
#define REG_PHY2P1_1_P3_52_L        (REG_PHY2P1_1_P3_BASE + 0xA4)
#define REG_PHY2P1_1_P3_52_H        (REG_PHY2P1_1_P3_BASE + 0xA5)
#define REG_PHY2P1_1_P3_53_L        (REG_PHY2P1_1_P3_BASE + 0xA6)
#define REG_PHY2P1_1_P3_53_H        (REG_PHY2P1_1_P3_BASE + 0xA7)
#define REG_PHY2P1_1_P3_54_L        (REG_PHY2P1_1_P3_BASE + 0xA8)
#define REG_PHY2P1_1_P3_54_H        (REG_PHY2P1_1_P3_BASE + 0xA9)
#define REG_PHY2P1_1_P3_55_L        (REG_PHY2P1_1_P3_BASE + 0xAA)
#define REG_PHY2P1_1_P3_55_H        (REG_PHY2P1_1_P3_BASE + 0xAB)
#define REG_PHY2P1_1_P3_56_L        (REG_PHY2P1_1_P3_BASE + 0xAC)
#define REG_PHY2P1_1_P3_56_H        (REG_PHY2P1_1_P3_BASE + 0xAD)
#define REG_PHY2P1_1_P3_57_L        (REG_PHY2P1_1_P3_BASE + 0xAE)
#define REG_PHY2P1_1_P3_57_H        (REG_PHY2P1_1_P3_BASE + 0xAF)
#define REG_PHY2P1_1_P3_58_L        (REG_PHY2P1_1_P3_BASE + 0xB0)
#define REG_PHY2P1_1_P3_58_H        (REG_PHY2P1_1_P3_BASE + 0xB1)
#define REG_PHY2P1_1_P3_59_L        (REG_PHY2P1_1_P3_BASE + 0xB2)
#define REG_PHY2P1_1_P3_59_H        (REG_PHY2P1_1_P3_BASE + 0xB3)
#define REG_PHY2P1_1_P3_5A_L        (REG_PHY2P1_1_P3_BASE + 0xB4)
#define REG_PHY2P1_1_P3_5A_H        (REG_PHY2P1_1_P3_BASE + 0xB5)
#define REG_PHY2P1_1_P3_5B_L        (REG_PHY2P1_1_P3_BASE + 0xB6)
#define REG_PHY2P1_1_P3_5B_H        (REG_PHY2P1_1_P3_BASE + 0xB7)
#define REG_PHY2P1_1_P3_5C_L        (REG_PHY2P1_1_P3_BASE + 0xB8)
#define REG_PHY2P1_1_P3_5C_H        (REG_PHY2P1_1_P3_BASE + 0xB9)
#define REG_PHY2P1_1_P3_5D_L        (REG_PHY2P1_1_P3_BASE + 0xBA)
#define REG_PHY2P1_1_P3_5D_H        (REG_PHY2P1_1_P3_BASE + 0xBB)
#define REG_PHY2P1_1_P3_5E_L        (REG_PHY2P1_1_P3_BASE + 0xBC)
#define REG_PHY2P1_1_P3_5E_H        (REG_PHY2P1_1_P3_BASE + 0xBD)
#define REG_PHY2P1_1_P3_5F_L        (REG_PHY2P1_1_P3_BASE + 0xBE)
#define REG_PHY2P1_1_P3_5F_H        (REG_PHY2P1_1_P3_BASE + 0xBF)
#define REG_PHY2P1_1_P3_60_L        (REG_PHY2P1_1_P3_BASE + 0xC0)
#define REG_PHY2P1_1_P3_60_H        (REG_PHY2P1_1_P3_BASE + 0xC1)
#define REG_PHY2P1_1_P3_61_L        (REG_PHY2P1_1_P3_BASE + 0xC2)
#define REG_PHY2P1_1_P3_61_H        (REG_PHY2P1_1_P3_BASE + 0xC3)
#define REG_PHY2P1_1_P3_62_L        (REG_PHY2P1_1_P3_BASE + 0xC4)
#define REG_PHY2P1_1_P3_62_H        (REG_PHY2P1_1_P3_BASE + 0xC5)
#define REG_PHY2P1_1_P3_63_L        (REG_PHY2P1_1_P3_BASE + 0xC6)
#define REG_PHY2P1_1_P3_63_H        (REG_PHY2P1_1_P3_BASE + 0xC7)
#define REG_PHY2P1_1_P3_64_L        (REG_PHY2P1_1_P3_BASE + 0xC8)
#define REG_PHY2P1_1_P3_64_H        (REG_PHY2P1_1_P3_BASE + 0xC9)
#define REG_PHY2P1_1_P3_65_L        (REG_PHY2P1_1_P3_BASE + 0xCA)
#define REG_PHY2P1_1_P3_65_H        (REG_PHY2P1_1_P3_BASE + 0xCB)
#define REG_PHY2P1_1_P3_66_L        (REG_PHY2P1_1_P3_BASE + 0xCC)
#define REG_PHY2P1_1_P3_66_H        (REG_PHY2P1_1_P3_BASE + 0xCD)
#define REG_PHY2P1_1_P3_67_L        (REG_PHY2P1_1_P3_BASE + 0xCE)
#define REG_PHY2P1_1_P3_67_H        (REG_PHY2P1_1_P3_BASE + 0xCF)
#define REG_PHY2P1_1_P3_68_L        (REG_PHY2P1_1_P3_BASE + 0xD0)
#define REG_PHY2P1_1_P3_68_H        (REG_PHY2P1_1_P3_BASE + 0xD1)
#define REG_PHY2P1_1_P3_69_L        (REG_PHY2P1_1_P3_BASE + 0xD2)
#define REG_PHY2P1_1_P3_69_H        (REG_PHY2P1_1_P3_BASE + 0xD3)
#define REG_PHY2P1_1_P3_6A_L        (REG_PHY2P1_1_P3_BASE + 0xD4)
#define REG_PHY2P1_1_P3_6A_H        (REG_PHY2P1_1_P3_BASE + 0xD5)
#define REG_PHY2P1_1_P3_6B_L        (REG_PHY2P1_1_P3_BASE + 0xD6)
#define REG_PHY2P1_1_P3_6B_H        (REG_PHY2P1_1_P3_BASE + 0xD7)
#define REG_PHY2P1_1_P3_6C_L        (REG_PHY2P1_1_P3_BASE + 0xD8)
#define REG_PHY2P1_1_P3_6C_H        (REG_PHY2P1_1_P3_BASE + 0xD9)
#define REG_PHY2P1_1_P3_6D_L        (REG_PHY2P1_1_P3_BASE + 0xDA)
#define REG_PHY2P1_1_P3_6D_H        (REG_PHY2P1_1_P3_BASE + 0xDB)
#define REG_PHY2P1_1_P3_6E_L        (REG_PHY2P1_1_P3_BASE + 0xDC)
#define REG_PHY2P1_1_P3_6E_H        (REG_PHY2P1_1_P3_BASE + 0xDD)
#define REG_PHY2P1_1_P3_6F_L        (REG_PHY2P1_1_P3_BASE + 0xDE)
#define REG_PHY2P1_1_P3_6F_H        (REG_PHY2P1_1_P3_BASE + 0xDF)
#define REG_PHY2P1_1_P3_70_L        (REG_PHY2P1_1_P3_BASE + 0xE0)
#define REG_PHY2P1_1_P3_70_H        (REG_PHY2P1_1_P3_BASE + 0xE1)
#define REG_PHY2P1_1_P3_71_L        (REG_PHY2P1_1_P3_BASE + 0xE2)
#define REG_PHY2P1_1_P3_71_H        (REG_PHY2P1_1_P3_BASE + 0xE3)
#define REG_PHY2P1_1_P3_72_L        (REG_PHY2P1_1_P3_BASE + 0xE4)
#define REG_PHY2P1_1_P3_72_H        (REG_PHY2P1_1_P3_BASE + 0xE5)
#define REG_PHY2P1_1_P3_73_L        (REG_PHY2P1_1_P3_BASE + 0xE6)
#define REG_PHY2P1_1_P3_73_H        (REG_PHY2P1_1_P3_BASE + 0xE7)
#define REG_PHY2P1_1_P3_74_L        (REG_PHY2P1_1_P3_BASE + 0xE8)
#define REG_PHY2P1_1_P3_74_H        (REG_PHY2P1_1_P3_BASE + 0xE9)
#define REG_PHY2P1_1_P3_75_L        (REG_PHY2P1_1_P3_BASE + 0xEA)
#define REG_PHY2P1_1_P3_75_H        (REG_PHY2P1_1_P3_BASE + 0xEB)
#define REG_PHY2P1_1_P3_76_L        (REG_PHY2P1_1_P3_BASE + 0xEC)
#define REG_PHY2P1_1_P3_76_H        (REG_PHY2P1_1_P3_BASE + 0xED)
#define REG_PHY2P1_1_P3_77_L        (REG_PHY2P1_1_P3_BASE + 0xEE)
#define REG_PHY2P1_1_P3_77_H        (REG_PHY2P1_1_P3_BASE + 0xEF)
#define REG_PHY2P1_1_P3_78_L        (REG_PHY2P1_1_P3_BASE + 0xF0)
#define REG_PHY2P1_1_P3_78_H        (REG_PHY2P1_1_P3_BASE + 0xF1)
#define REG_PHY2P1_1_P3_79_L        (REG_PHY2P1_1_P3_BASE + 0xF2)
#define REG_PHY2P1_1_P3_79_H        (REG_PHY2P1_1_P3_BASE + 0xF3)
#define REG_PHY2P1_1_P3_7A_L        (REG_PHY2P1_1_P3_BASE + 0xF4)
#define REG_PHY2P1_1_P3_7A_H        (REG_PHY2P1_1_P3_BASE + 0xF5)
#define REG_PHY2P1_1_P3_7B_L        (REG_PHY2P1_1_P3_BASE + 0xF6)
#define REG_PHY2P1_1_P3_7B_H        (REG_PHY2P1_1_P3_BASE + 0xF7)
#define REG_PHY2P1_1_P3_7C_L        (REG_PHY2P1_1_P3_BASE + 0xF8)
#define REG_PHY2P1_1_P3_7C_H        (REG_PHY2P1_1_P3_BASE + 0xF9)
#define REG_PHY2P1_1_P3_7D_L        (REG_PHY2P1_1_P3_BASE + 0xFA)
#define REG_PHY2P1_1_P3_7D_H        (REG_PHY2P1_1_P3_BASE + 0xFB)
#define REG_PHY2P1_1_P3_7E_L        (REG_PHY2P1_1_P3_BASE + 0xFC)
#define REG_PHY2P1_1_P3_7E_H        (REG_PHY2P1_1_P3_BASE + 0xFD)
#define REG_PHY2P1_1_P3_7F_L        (REG_PHY2P1_1_P3_BASE + 0xFE)
#define REG_PHY2P1_1_P3_7F_H        (REG_PHY2P1_1_P3_BASE + 0xFF)

//=============================================================
// PHY2P1_2_P3
#define REG_PHY2P1_2_P3_00_L        (REG_PHY2P1_2_P3_BASE + 0x00)
#define REG_PHY2P1_2_P3_00_H        (REG_PHY2P1_2_P3_BASE + 0x01)
#define REG_PHY2P1_2_P3_01_L        (REG_PHY2P1_2_P3_BASE + 0x02)
#define REG_PHY2P1_2_P3_01_H        (REG_PHY2P1_2_P3_BASE + 0x03)
#define REG_PHY2P1_2_P3_02_L        (REG_PHY2P1_2_P3_BASE + 0x04)
#define REG_PHY2P1_2_P3_02_H        (REG_PHY2P1_2_P3_BASE + 0x05)
#define REG_PHY2P1_2_P3_03_L        (REG_PHY2P1_2_P3_BASE + 0x06)
#define REG_PHY2P1_2_P3_03_H        (REG_PHY2P1_2_P3_BASE + 0x07)
#define REG_PHY2P1_2_P3_04_L        (REG_PHY2P1_2_P3_BASE + 0x08)
#define REG_PHY2P1_2_P3_04_H        (REG_PHY2P1_2_P3_BASE + 0x09)
#define REG_PHY2P1_2_P3_05_L        (REG_PHY2P1_2_P3_BASE + 0x0A)
#define REG_PHY2P1_2_P3_05_H        (REG_PHY2P1_2_P3_BASE + 0x0B)
#define REG_PHY2P1_2_P3_06_L        (REG_PHY2P1_2_P3_BASE + 0x0C)
#define REG_PHY2P1_2_P3_06_H        (REG_PHY2P1_2_P3_BASE + 0x0D)
#define REG_PHY2P1_2_P3_07_L        (REG_PHY2P1_2_P3_BASE + 0x0E)
#define REG_PHY2P1_2_P3_07_H        (REG_PHY2P1_2_P3_BASE + 0x0F)
#define REG_PHY2P1_2_P3_08_L        (REG_PHY2P1_2_P3_BASE + 0x10)
#define REG_PHY2P1_2_P3_08_H        (REG_PHY2P1_2_P3_BASE + 0x11)
#define REG_PHY2P1_2_P3_09_L        (REG_PHY2P1_2_P3_BASE + 0x12)
#define REG_PHY2P1_2_P3_09_H        (REG_PHY2P1_2_P3_BASE + 0x13)
#define REG_PHY2P1_2_P3_0A_L        (REG_PHY2P1_2_P3_BASE + 0x14)
#define REG_PHY2P1_2_P3_0A_H        (REG_PHY2P1_2_P3_BASE + 0x15)
#define REG_PHY2P1_2_P3_0B_L        (REG_PHY2P1_2_P3_BASE + 0x16)
#define REG_PHY2P1_2_P3_0B_H        (REG_PHY2P1_2_P3_BASE + 0x17)
#define REG_PHY2P1_2_P3_0C_L        (REG_PHY2P1_2_P3_BASE + 0x18)
#define REG_PHY2P1_2_P3_0C_H        (REG_PHY2P1_2_P3_BASE + 0x19)
#define REG_PHY2P1_2_P3_0D_L        (REG_PHY2P1_2_P3_BASE + 0x1A)
#define REG_PHY2P1_2_P3_0D_H        (REG_PHY2P1_2_P3_BASE + 0x1B)
#define REG_PHY2P1_2_P3_0E_L        (REG_PHY2P1_2_P3_BASE + 0x1C)
#define REG_PHY2P1_2_P3_0E_H        (REG_PHY2P1_2_P3_BASE + 0x1D)
#define REG_PHY2P1_2_P3_0F_L        (REG_PHY2P1_2_P3_BASE + 0x1E)
#define REG_PHY2P1_2_P3_0F_H        (REG_PHY2P1_2_P3_BASE + 0x1F)
#define REG_PHY2P1_2_P3_10_L        (REG_PHY2P1_2_P3_BASE + 0x20)
#define REG_PHY2P1_2_P3_10_H        (REG_PHY2P1_2_P3_BASE + 0x21)
#define REG_PHY2P1_2_P3_11_L        (REG_PHY2P1_2_P3_BASE + 0x22)
#define REG_PHY2P1_2_P3_11_H        (REG_PHY2P1_2_P3_BASE + 0x23)
#define REG_PHY2P1_2_P3_12_L        (REG_PHY2P1_2_P3_BASE + 0x24)
#define REG_PHY2P1_2_P3_12_H        (REG_PHY2P1_2_P3_BASE + 0x25)
#define REG_PHY2P1_2_P3_13_L        (REG_PHY2P1_2_P3_BASE + 0x26)
#define REG_PHY2P1_2_P3_13_H        (REG_PHY2P1_2_P3_BASE + 0x27)
#define REG_PHY2P1_2_P3_14_L        (REG_PHY2P1_2_P3_BASE + 0x28)
#define REG_PHY2P1_2_P3_14_H        (REG_PHY2P1_2_P3_BASE + 0x29)
#define REG_PHY2P1_2_P3_15_L        (REG_PHY2P1_2_P3_BASE + 0x2A)
#define REG_PHY2P1_2_P3_15_H        (REG_PHY2P1_2_P3_BASE + 0x2B)
#define REG_PHY2P1_2_P3_16_L        (REG_PHY2P1_2_P3_BASE + 0x2C)
#define REG_PHY2P1_2_P3_16_H        (REG_PHY2P1_2_P3_BASE + 0x2D)
#define REG_PHY2P1_2_P3_17_L        (REG_PHY2P1_2_P3_BASE + 0x2E)
#define REG_PHY2P1_2_P3_17_H        (REG_PHY2P1_2_P3_BASE + 0x2F)
#define REG_PHY2P1_2_P3_18_L        (REG_PHY2P1_2_P3_BASE + 0x30)
#define REG_PHY2P1_2_P3_18_H        (REG_PHY2P1_2_P3_BASE + 0x31)
#define REG_PHY2P1_2_P3_19_L        (REG_PHY2P1_2_P3_BASE + 0x32)
#define REG_PHY2P1_2_P3_19_H        (REG_PHY2P1_2_P3_BASE + 0x33)
#define REG_PHY2P1_2_P3_1A_L        (REG_PHY2P1_2_P3_BASE + 0x34)
#define REG_PHY2P1_2_P3_1A_H        (REG_PHY2P1_2_P3_BASE + 0x35)
#define REG_PHY2P1_2_P3_1B_L        (REG_PHY2P1_2_P3_BASE + 0x36)
#define REG_PHY2P1_2_P3_1B_H        (REG_PHY2P1_2_P3_BASE + 0x37)
#define REG_PHY2P1_2_P3_1C_L        (REG_PHY2P1_2_P3_BASE + 0x38)
#define REG_PHY2P1_2_P3_1C_H        (REG_PHY2P1_2_P3_BASE + 0x39)
#define REG_PHY2P1_2_P3_1D_L        (REG_PHY2P1_2_P3_BASE + 0x3A)
#define REG_PHY2P1_2_P3_1D_H        (REG_PHY2P1_2_P3_BASE + 0x3B)
#define REG_PHY2P1_2_P3_1E_L        (REG_PHY2P1_2_P3_BASE + 0x3C)
#define REG_PHY2P1_2_P3_1E_H        (REG_PHY2P1_2_P3_BASE + 0x3D)
#define REG_PHY2P1_2_P3_1F_L        (REG_PHY2P1_2_P3_BASE + 0x3E)
#define REG_PHY2P1_2_P3_1F_H        (REG_PHY2P1_2_P3_BASE + 0x3F)
#define REG_PHY2P1_2_P3_20_L        (REG_PHY2P1_2_P3_BASE + 0x40)
#define REG_PHY2P1_2_P3_20_H        (REG_PHY2P1_2_P3_BASE + 0x41)
#define REG_PHY2P1_2_P3_21_L        (REG_PHY2P1_2_P3_BASE + 0x42)
#define REG_PHY2P1_2_P3_21_H        (REG_PHY2P1_2_P3_BASE + 0x43)
#define REG_PHY2P1_2_P3_22_L        (REG_PHY2P1_2_P3_BASE + 0x44)
#define REG_PHY2P1_2_P3_22_H        (REG_PHY2P1_2_P3_BASE + 0x45)
#define REG_PHY2P1_2_P3_23_L        (REG_PHY2P1_2_P3_BASE + 0x46)
#define REG_PHY2P1_2_P3_23_H        (REG_PHY2P1_2_P3_BASE + 0x47)
#define REG_PHY2P1_2_P3_24_L        (REG_PHY2P1_2_P3_BASE + 0x48)
#define REG_PHY2P1_2_P3_24_H        (REG_PHY2P1_2_P3_BASE + 0x49)
#define REG_PHY2P1_2_P3_25_L        (REG_PHY2P1_2_P3_BASE + 0x4A)
#define REG_PHY2P1_2_P3_25_H        (REG_PHY2P1_2_P3_BASE + 0x4B)
#define REG_PHY2P1_2_P3_26_L        (REG_PHY2P1_2_P3_BASE + 0x4C)
#define REG_PHY2P1_2_P3_26_H        (REG_PHY2P1_2_P3_BASE + 0x4D)
#define REG_PHY2P1_2_P3_27_L        (REG_PHY2P1_2_P3_BASE + 0x4E)
#define REG_PHY2P1_2_P3_27_H        (REG_PHY2P1_2_P3_BASE + 0x4F)
#define REG_PHY2P1_2_P3_28_L        (REG_PHY2P1_2_P3_BASE + 0x50)
#define REG_PHY2P1_2_P3_28_H        (REG_PHY2P1_2_P3_BASE + 0x51)
#define REG_PHY2P1_2_P3_29_L        (REG_PHY2P1_2_P3_BASE + 0x52)
#define REG_PHY2P1_2_P3_29_H        (REG_PHY2P1_2_P3_BASE + 0x53)
#define REG_PHY2P1_2_P3_2A_L        (REG_PHY2P1_2_P3_BASE + 0x54)
#define REG_PHY2P1_2_P3_2A_H        (REG_PHY2P1_2_P3_BASE + 0x55)
#define REG_PHY2P1_2_P3_2B_L        (REG_PHY2P1_2_P3_BASE + 0x56)
#define REG_PHY2P1_2_P3_2B_H        (REG_PHY2P1_2_P3_BASE + 0x57)
#define REG_PHY2P1_2_P3_2C_L        (REG_PHY2P1_2_P3_BASE + 0x58)
#define REG_PHY2P1_2_P3_2C_H        (REG_PHY2P1_2_P3_BASE + 0x59)
#define REG_PHY2P1_2_P3_2D_L        (REG_PHY2P1_2_P3_BASE + 0x5A)
#define REG_PHY2P1_2_P3_2D_H        (REG_PHY2P1_2_P3_BASE + 0x5B)
#define REG_PHY2P1_2_P3_2E_L        (REG_PHY2P1_2_P3_BASE + 0x5C)
#define REG_PHY2P1_2_P3_2E_H        (REG_PHY2P1_2_P3_BASE + 0x5D)
#define REG_PHY2P1_2_P3_2F_L        (REG_PHY2P1_2_P3_BASE + 0x5E)
#define REG_PHY2P1_2_P3_2F_H        (REG_PHY2P1_2_P3_BASE + 0x5F)
#define REG_PHY2P1_2_P3_30_L        (REG_PHY2P1_2_P3_BASE + 0x60)
#define REG_PHY2P1_2_P3_30_H        (REG_PHY2P1_2_P3_BASE + 0x61)
#define REG_PHY2P1_2_P3_31_L        (REG_PHY2P1_2_P3_BASE + 0x62)
#define REG_PHY2P1_2_P3_31_H        (REG_PHY2P1_2_P3_BASE + 0x63)
#define REG_PHY2P1_2_P3_32_L        (REG_PHY2P1_2_P3_BASE + 0x64)
#define REG_PHY2P1_2_P3_32_H        (REG_PHY2P1_2_P3_BASE + 0x65)
#define REG_PHY2P1_2_P3_33_L        (REG_PHY2P1_2_P3_BASE + 0x66)
#define REG_PHY2P1_2_P3_33_H        (REG_PHY2P1_2_P3_BASE + 0x67)
#define REG_PHY2P1_2_P3_34_L        (REG_PHY2P1_2_P3_BASE + 0x68)
#define REG_PHY2P1_2_P3_34_H        (REG_PHY2P1_2_P3_BASE + 0x69)
#define REG_PHY2P1_2_P3_35_L        (REG_PHY2P1_2_P3_BASE + 0x6A)
#define REG_PHY2P1_2_P3_35_H        (REG_PHY2P1_2_P3_BASE + 0x6B)
#define REG_PHY2P1_2_P3_36_L        (REG_PHY2P1_2_P3_BASE + 0x6C)
#define REG_PHY2P1_2_P3_36_H        (REG_PHY2P1_2_P3_BASE + 0x6D)
#define REG_PHY2P1_2_P3_37_L        (REG_PHY2P1_2_P3_BASE + 0x6E)
#define REG_PHY2P1_2_P3_37_H        (REG_PHY2P1_2_P3_BASE + 0x6F)
#define REG_PHY2P1_2_P3_38_L        (REG_PHY2P1_2_P3_BASE + 0x70)
#define REG_PHY2P1_2_P3_38_H        (REG_PHY2P1_2_P3_BASE + 0x71)
#define REG_PHY2P1_2_P3_39_L        (REG_PHY2P1_2_P3_BASE + 0x72)
#define REG_PHY2P1_2_P3_39_H        (REG_PHY2P1_2_P3_BASE + 0x73)
#define REG_PHY2P1_2_P3_3A_L        (REG_PHY2P1_2_P3_BASE + 0x74)
#define REG_PHY2P1_2_P3_3A_H        (REG_PHY2P1_2_P3_BASE + 0x75)
#define REG_PHY2P1_2_P3_3B_L        (REG_PHY2P1_2_P3_BASE + 0x76)
#define REG_PHY2P1_2_P3_3B_H        (REG_PHY2P1_2_P3_BASE + 0x77)
#define REG_PHY2P1_2_P3_3C_L        (REG_PHY2P1_2_P3_BASE + 0x78)
#define REG_PHY2P1_2_P3_3C_H        (REG_PHY2P1_2_P3_BASE + 0x79)
#define REG_PHY2P1_2_P3_3D_L        (REG_PHY2P1_2_P3_BASE + 0x7A)
#define REG_PHY2P1_2_P3_3D_H        (REG_PHY2P1_2_P3_BASE + 0x7B)
#define REG_PHY2P1_2_P3_3E_L        (REG_PHY2P1_2_P3_BASE + 0x7C)
#define REG_PHY2P1_2_P3_3E_H        (REG_PHY2P1_2_P3_BASE + 0x7D)
#define REG_PHY2P1_2_P3_3F_L        (REG_PHY2P1_2_P3_BASE + 0x7E)
#define REG_PHY2P1_2_P3_3F_H        (REG_PHY2P1_2_P3_BASE + 0x7F)
#define REG_PHY2P1_2_P3_40_L        (REG_PHY2P1_2_P3_BASE + 0x80)
#define REG_PHY2P1_2_P3_40_H        (REG_PHY2P1_2_P3_BASE + 0x81)
#define REG_PHY2P1_2_P3_41_L        (REG_PHY2P1_2_P3_BASE + 0x82)
#define REG_PHY2P1_2_P3_41_H        (REG_PHY2P1_2_P3_BASE + 0x83)
#define REG_PHY2P1_2_P3_42_L        (REG_PHY2P1_2_P3_BASE + 0x84)
#define REG_PHY2P1_2_P3_42_H        (REG_PHY2P1_2_P3_BASE + 0x85)
#define REG_PHY2P1_2_P3_43_L        (REG_PHY2P1_2_P3_BASE + 0x86)
#define REG_PHY2P1_2_P3_43_H        (REG_PHY2P1_2_P3_BASE + 0x87)
#define REG_PHY2P1_2_P3_44_L        (REG_PHY2P1_2_P3_BASE + 0x88)
#define REG_PHY2P1_2_P3_44_H        (REG_PHY2P1_2_P3_BASE + 0x89)
#define REG_PHY2P1_2_P3_45_L        (REG_PHY2P1_2_P3_BASE + 0x8A)
#define REG_PHY2P1_2_P3_45_H        (REG_PHY2P1_2_P3_BASE + 0x8B)
#define REG_PHY2P1_2_P3_46_L        (REG_PHY2P1_2_P3_BASE + 0x8C)
#define REG_PHY2P1_2_P3_46_H        (REG_PHY2P1_2_P3_BASE + 0x8D)
#define REG_PHY2P1_2_P3_47_L        (REG_PHY2P1_2_P3_BASE + 0x8E)
#define REG_PHY2P1_2_P3_47_H        (REG_PHY2P1_2_P3_BASE + 0x8F)
#define REG_PHY2P1_2_P3_48_L        (REG_PHY2P1_2_P3_BASE + 0x90)
#define REG_PHY2P1_2_P3_48_H        (REG_PHY2P1_2_P3_BASE + 0x91)
#define REG_PHY2P1_2_P3_49_L        (REG_PHY2P1_2_P3_BASE + 0x92)
#define REG_PHY2P1_2_P3_49_H        (REG_PHY2P1_2_P3_BASE + 0x93)
#define REG_PHY2P1_2_P3_4A_L        (REG_PHY2P1_2_P3_BASE + 0x94)
#define REG_PHY2P1_2_P3_4A_H        (REG_PHY2P1_2_P3_BASE + 0x95)
#define REG_PHY2P1_2_P3_4B_L        (REG_PHY2P1_2_P3_BASE + 0x96)
#define REG_PHY2P1_2_P3_4B_H        (REG_PHY2P1_2_P3_BASE + 0x97)
#define REG_PHY2P1_2_P3_4C_L        (REG_PHY2P1_2_P3_BASE + 0x98)
#define REG_PHY2P1_2_P3_4C_H        (REG_PHY2P1_2_P3_BASE + 0x99)
#define REG_PHY2P1_2_P3_4D_L        (REG_PHY2P1_2_P3_BASE + 0x9A)
#define REG_PHY2P1_2_P3_4D_H        (REG_PHY2P1_2_P3_BASE + 0x9B)
#define REG_PHY2P1_2_P3_4E_L        (REG_PHY2P1_2_P3_BASE + 0x9C)
#define REG_PHY2P1_2_P3_4E_H        (REG_PHY2P1_2_P3_BASE + 0x9D)
#define REG_PHY2P1_2_P3_4F_L        (REG_PHY2P1_2_P3_BASE + 0x9E)
#define REG_PHY2P1_2_P3_4F_H        (REG_PHY2P1_2_P3_BASE + 0x9F)
#define REG_PHY2P1_2_P3_50_L        (REG_PHY2P1_2_P3_BASE + 0xA0)
#define REG_PHY2P1_2_P3_50_H        (REG_PHY2P1_2_P3_BASE + 0xA1)
#define REG_PHY2P1_2_P3_51_L        (REG_PHY2P1_2_P3_BASE + 0xA2)
#define REG_PHY2P1_2_P3_51_H        (REG_PHY2P1_2_P3_BASE + 0xA3)
#define REG_PHY2P1_2_P3_52_L        (REG_PHY2P1_2_P3_BASE + 0xA4)
#define REG_PHY2P1_2_P3_52_H        (REG_PHY2P1_2_P3_BASE + 0xA5)
#define REG_PHY2P1_2_P3_53_L        (REG_PHY2P1_2_P3_BASE + 0xA6)
#define REG_PHY2P1_2_P3_53_H        (REG_PHY2P1_2_P3_BASE + 0xA7)
#define REG_PHY2P1_2_P3_54_L        (REG_PHY2P1_2_P3_BASE + 0xA8)
#define REG_PHY2P1_2_P3_54_H        (REG_PHY2P1_2_P3_BASE + 0xA9)
#define REG_PHY2P1_2_P3_55_L        (REG_PHY2P1_2_P3_BASE + 0xAA)
#define REG_PHY2P1_2_P3_55_H        (REG_PHY2P1_2_P3_BASE + 0xAB)
#define REG_PHY2P1_2_P3_56_L        (REG_PHY2P1_2_P3_BASE + 0xAC)
#define REG_PHY2P1_2_P3_56_H        (REG_PHY2P1_2_P3_BASE + 0xAD)
#define REG_PHY2P1_2_P3_57_L        (REG_PHY2P1_2_P3_BASE + 0xAE)
#define REG_PHY2P1_2_P3_57_H        (REG_PHY2P1_2_P3_BASE + 0xAF)
#define REG_PHY2P1_2_P3_58_L        (REG_PHY2P1_2_P3_BASE + 0xB0)
#define REG_PHY2P1_2_P3_58_H        (REG_PHY2P1_2_P3_BASE + 0xB1)
#define REG_PHY2P1_2_P3_59_L        (REG_PHY2P1_2_P3_BASE + 0xB2)
#define REG_PHY2P1_2_P3_59_H        (REG_PHY2P1_2_P3_BASE + 0xB3)
#define REG_PHY2P1_2_P3_5A_L        (REG_PHY2P1_2_P3_BASE + 0xB4)
#define REG_PHY2P1_2_P3_5A_H        (REG_PHY2P1_2_P3_BASE + 0xB5)
#define REG_PHY2P1_2_P3_5B_L        (REG_PHY2P1_2_P3_BASE + 0xB6)
#define REG_PHY2P1_2_P3_5B_H        (REG_PHY2P1_2_P3_BASE + 0xB7)
#define REG_PHY2P1_2_P3_5C_L        (REG_PHY2P1_2_P3_BASE + 0xB8)
#define REG_PHY2P1_2_P3_5C_H        (REG_PHY2P1_2_P3_BASE + 0xB9)
#define REG_PHY2P1_2_P3_5D_L        (REG_PHY2P1_2_P3_BASE + 0xBA)
#define REG_PHY2P1_2_P3_5D_H        (REG_PHY2P1_2_P3_BASE + 0xBB)
#define REG_PHY2P1_2_P3_5E_L        (REG_PHY2P1_2_P3_BASE + 0xBC)
#define REG_PHY2P1_2_P3_5E_H        (REG_PHY2P1_2_P3_BASE + 0xBD)
#define REG_PHY2P1_2_P3_5F_L        (REG_PHY2P1_2_P3_BASE + 0xBE)
#define REG_PHY2P1_2_P3_5F_H        (REG_PHY2P1_2_P3_BASE + 0xBF)
#define REG_PHY2P1_2_P3_60_L        (REG_PHY2P1_2_P3_BASE + 0xC0)
#define REG_PHY2P1_2_P3_60_H        (REG_PHY2P1_2_P3_BASE + 0xC1)
#define REG_PHY2P1_2_P3_61_L        (REG_PHY2P1_2_P3_BASE + 0xC2)
#define REG_PHY2P1_2_P3_61_H        (REG_PHY2P1_2_P3_BASE + 0xC3)
#define REG_PHY2P1_2_P3_62_L        (REG_PHY2P1_2_P3_BASE + 0xC4)
#define REG_PHY2P1_2_P3_62_H        (REG_PHY2P1_2_P3_BASE + 0xC5)
#define REG_PHY2P1_2_P3_63_L        (REG_PHY2P1_2_P3_BASE + 0xC6)
#define REG_PHY2P1_2_P3_63_H        (REG_PHY2P1_2_P3_BASE + 0xC7)
#define REG_PHY2P1_2_P3_64_L        (REG_PHY2P1_2_P3_BASE + 0xC8)
#define REG_PHY2P1_2_P3_64_H        (REG_PHY2P1_2_P3_BASE + 0xC9)
#define REG_PHY2P1_2_P3_65_L        (REG_PHY2P1_2_P3_BASE + 0xCA)
#define REG_PHY2P1_2_P3_65_H        (REG_PHY2P1_2_P3_BASE + 0xCB)
#define REG_PHY2P1_2_P3_66_L        (REG_PHY2P1_2_P3_BASE + 0xCC)
#define REG_PHY2P1_2_P3_66_H        (REG_PHY2P1_2_P3_BASE + 0xCD)
#define REG_PHY2P1_2_P3_67_L        (REG_PHY2P1_2_P3_BASE + 0xCE)
#define REG_PHY2P1_2_P3_67_H        (REG_PHY2P1_2_P3_BASE + 0xCF)
#define REG_PHY2P1_2_P3_68_L        (REG_PHY2P1_2_P3_BASE + 0xD0)
#define REG_PHY2P1_2_P3_68_H        (REG_PHY2P1_2_P3_BASE + 0xD1)
#define REG_PHY2P1_2_P3_69_L        (REG_PHY2P1_2_P3_BASE + 0xD2)
#define REG_PHY2P1_2_P3_69_H        (REG_PHY2P1_2_P3_BASE + 0xD3)
#define REG_PHY2P1_2_P3_6A_L        (REG_PHY2P1_2_P3_BASE + 0xD4)
#define REG_PHY2P1_2_P3_6A_H        (REG_PHY2P1_2_P3_BASE + 0xD5)
#define REG_PHY2P1_2_P3_6B_L        (REG_PHY2P1_2_P3_BASE + 0xD6)
#define REG_PHY2P1_2_P3_6B_H        (REG_PHY2P1_2_P3_BASE + 0xD7)
#define REG_PHY2P1_2_P3_6C_L        (REG_PHY2P1_2_P3_BASE + 0xD8)
#define REG_PHY2P1_2_P3_6C_H        (REG_PHY2P1_2_P3_BASE + 0xD9)
#define REG_PHY2P1_2_P3_6D_L        (REG_PHY2P1_2_P3_BASE + 0xDA)
#define REG_PHY2P1_2_P3_6D_H        (REG_PHY2P1_2_P3_BASE + 0xDB)
#define REG_PHY2P1_2_P3_6E_L        (REG_PHY2P1_2_P3_BASE + 0xDC)
#define REG_PHY2P1_2_P3_6E_H        (REG_PHY2P1_2_P3_BASE + 0xDD)
#define REG_PHY2P1_2_P3_6F_L        (REG_PHY2P1_2_P3_BASE + 0xDE)
#define REG_PHY2P1_2_P3_6F_H        (REG_PHY2P1_2_P3_BASE + 0xDF)
#define REG_PHY2P1_2_P3_70_L        (REG_PHY2P1_2_P3_BASE + 0xE0)
#define REG_PHY2P1_2_P3_70_H        (REG_PHY2P1_2_P3_BASE + 0xE1)
#define REG_PHY2P1_2_P3_71_L        (REG_PHY2P1_2_P3_BASE + 0xE2)
#define REG_PHY2P1_2_P3_71_H        (REG_PHY2P1_2_P3_BASE + 0xE3)
#define REG_PHY2P1_2_P3_72_L        (REG_PHY2P1_2_P3_BASE + 0xE4)
#define REG_PHY2P1_2_P3_72_H        (REG_PHY2P1_2_P3_BASE + 0xE5)
#define REG_PHY2P1_2_P3_73_L        (REG_PHY2P1_2_P3_BASE + 0xE6)
#define REG_PHY2P1_2_P3_73_H        (REG_PHY2P1_2_P3_BASE + 0xE7)
#define REG_PHY2P1_2_P3_74_L        (REG_PHY2P1_2_P3_BASE + 0xE8)
#define REG_PHY2P1_2_P3_74_H        (REG_PHY2P1_2_P3_BASE + 0xE9)
#define REG_PHY2P1_2_P3_75_L        (REG_PHY2P1_2_P3_BASE + 0xEA)
#define REG_PHY2P1_2_P3_75_H        (REG_PHY2P1_2_P3_BASE + 0xEB)
#define REG_PHY2P1_2_P3_76_L        (REG_PHY2P1_2_P3_BASE + 0xEC)
#define REG_PHY2P1_2_P3_76_H        (REG_PHY2P1_2_P3_BASE + 0xED)
#define REG_PHY2P1_2_P3_77_L        (REG_PHY2P1_2_P3_BASE + 0xEE)
#define REG_PHY2P1_2_P3_77_H        (REG_PHY2P1_2_P3_BASE + 0xEF)
#define REG_PHY2P1_2_P3_78_L        (REG_PHY2P1_2_P3_BASE + 0xF0)
#define REG_PHY2P1_2_P3_78_H        (REG_PHY2P1_2_P3_BASE + 0xF1)
#define REG_PHY2P1_2_P3_79_L        (REG_PHY2P1_2_P3_BASE + 0xF2)
#define REG_PHY2P1_2_P3_79_H        (REG_PHY2P1_2_P3_BASE + 0xF3)
#define REG_PHY2P1_2_P3_7A_L        (REG_PHY2P1_2_P3_BASE + 0xF4)
#define REG_PHY2P1_2_P3_7A_H        (REG_PHY2P1_2_P3_BASE + 0xF5)
#define REG_PHY2P1_2_P3_7B_L        (REG_PHY2P1_2_P3_BASE + 0xF6)
#define REG_PHY2P1_2_P3_7B_H        (REG_PHY2P1_2_P3_BASE + 0xF7)
#define REG_PHY2P1_2_P3_7C_L        (REG_PHY2P1_2_P3_BASE + 0xF8)
#define REG_PHY2P1_2_P3_7C_H        (REG_PHY2P1_2_P3_BASE + 0xF9)
#define REG_PHY2P1_2_P3_7D_L        (REG_PHY2P1_2_P3_BASE + 0xFA)
#define REG_PHY2P1_2_P3_7D_H        (REG_PHY2P1_2_P3_BASE + 0xFB)
#define REG_PHY2P1_2_P3_7E_L        (REG_PHY2P1_2_P3_BASE + 0xFC)
#define REG_PHY2P1_2_P3_7E_H        (REG_PHY2P1_2_P3_BASE + 0xFD)
#define REG_PHY2P1_2_P3_7F_L        (REG_PHY2P1_2_P3_BASE + 0xFE)
#define REG_PHY2P1_2_P3_7F_H        (REG_PHY2P1_2_P3_BASE + 0xFF)

//=============================================================
// PHY2P1_3_P3
#define REG_PHY2P1_3_P3_00_L        (REG_PHY2P1_3_P3_BASE + 0x00)
#define REG_PHY2P1_3_P3_00_H        (REG_PHY2P1_3_P3_BASE + 0x01)
#define REG_PHY2P1_3_P3_01_L        (REG_PHY2P1_3_P3_BASE + 0x02)
#define REG_PHY2P1_3_P3_01_H        (REG_PHY2P1_3_P3_BASE + 0x03)
#define REG_PHY2P1_3_P3_02_L        (REG_PHY2P1_3_P3_BASE + 0x04)
#define REG_PHY2P1_3_P3_02_H        (REG_PHY2P1_3_P3_BASE + 0x05)
#define REG_PHY2P1_3_P3_03_L        (REG_PHY2P1_3_P3_BASE + 0x06)
#define REG_PHY2P1_3_P3_03_H        (REG_PHY2P1_3_P3_BASE + 0x07)
#define REG_PHY2P1_3_P3_04_L        (REG_PHY2P1_3_P3_BASE + 0x08)
#define REG_PHY2P1_3_P3_04_H        (REG_PHY2P1_3_P3_BASE + 0x09)
#define REG_PHY2P1_3_P3_05_L        (REG_PHY2P1_3_P3_BASE + 0x0A)
#define REG_PHY2P1_3_P3_05_H        (REG_PHY2P1_3_P3_BASE + 0x0B)
#define REG_PHY2P1_3_P3_06_L        (REG_PHY2P1_3_P3_BASE + 0x0C)
#define REG_PHY2P1_3_P3_06_H        (REG_PHY2P1_3_P3_BASE + 0x0D)
#define REG_PHY2P1_3_P3_07_L        (REG_PHY2P1_3_P3_BASE + 0x0E)
#define REG_PHY2P1_3_P3_07_H        (REG_PHY2P1_3_P3_BASE + 0x0F)
#define REG_PHY2P1_3_P3_08_L        (REG_PHY2P1_3_P3_BASE + 0x10)
#define REG_PHY2P1_3_P3_08_H        (REG_PHY2P1_3_P3_BASE + 0x11)
#define REG_PHY2P1_3_P3_09_L        (REG_PHY2P1_3_P3_BASE + 0x12)
#define REG_PHY2P1_3_P3_09_H        (REG_PHY2P1_3_P3_BASE + 0x13)
#define REG_PHY2P1_3_P3_0A_L        (REG_PHY2P1_3_P3_BASE + 0x14)
#define REG_PHY2P1_3_P3_0A_H        (REG_PHY2P1_3_P3_BASE + 0x15)
#define REG_PHY2P1_3_P3_0B_L        (REG_PHY2P1_3_P3_BASE + 0x16)
#define REG_PHY2P1_3_P3_0B_H        (REG_PHY2P1_3_P3_BASE + 0x17)
#define REG_PHY2P1_3_P3_0C_L        (REG_PHY2P1_3_P3_BASE + 0x18)
#define REG_PHY2P1_3_P3_0C_H        (REG_PHY2P1_3_P3_BASE + 0x19)
#define REG_PHY2P1_3_P3_0D_L        (REG_PHY2P1_3_P3_BASE + 0x1A)
#define REG_PHY2P1_3_P3_0D_H        (REG_PHY2P1_3_P3_BASE + 0x1B)
#define REG_PHY2P1_3_P3_0E_L        (REG_PHY2P1_3_P3_BASE + 0x1C)
#define REG_PHY2P1_3_P3_0E_H        (REG_PHY2P1_3_P3_BASE + 0x1D)
#define REG_PHY2P1_3_P3_0F_L        (REG_PHY2P1_3_P3_BASE + 0x1E)
#define REG_PHY2P1_3_P3_0F_H        (REG_PHY2P1_3_P3_BASE + 0x1F)
#define REG_PHY2P1_3_P3_10_L        (REG_PHY2P1_3_P3_BASE + 0x20)
#define REG_PHY2P1_3_P3_10_H        (REG_PHY2P1_3_P3_BASE + 0x21)
#define REG_PHY2P1_3_P3_11_L        (REG_PHY2P1_3_P3_BASE + 0x22)
#define REG_PHY2P1_3_P3_11_H        (REG_PHY2P1_3_P3_BASE + 0x23)
#define REG_PHY2P1_3_P3_12_L        (REG_PHY2P1_3_P3_BASE + 0x24)
#define REG_PHY2P1_3_P3_12_H        (REG_PHY2P1_3_P3_BASE + 0x25)
#define REG_PHY2P1_3_P3_13_L        (REG_PHY2P1_3_P3_BASE + 0x26)
#define REG_PHY2P1_3_P3_13_H        (REG_PHY2P1_3_P3_BASE + 0x27)
#define REG_PHY2P1_3_P3_14_L        (REG_PHY2P1_3_P3_BASE + 0x28)
#define REG_PHY2P1_3_P3_14_H        (REG_PHY2P1_3_P3_BASE + 0x29)
#define REG_PHY2P1_3_P3_15_L        (REG_PHY2P1_3_P3_BASE + 0x2A)
#define REG_PHY2P1_3_P3_15_H        (REG_PHY2P1_3_P3_BASE + 0x2B)
#define REG_PHY2P1_3_P3_16_L        (REG_PHY2P1_3_P3_BASE + 0x2C)
#define REG_PHY2P1_3_P3_16_H        (REG_PHY2P1_3_P3_BASE + 0x2D)
#define REG_PHY2P1_3_P3_17_L        (REG_PHY2P1_3_P3_BASE + 0x2E)
#define REG_PHY2P1_3_P3_17_H        (REG_PHY2P1_3_P3_BASE + 0x2F)
#define REG_PHY2P1_3_P3_18_L        (REG_PHY2P1_3_P3_BASE + 0x30)
#define REG_PHY2P1_3_P3_18_H        (REG_PHY2P1_3_P3_BASE + 0x31)
#define REG_PHY2P1_3_P3_19_L        (REG_PHY2P1_3_P3_BASE + 0x32)
#define REG_PHY2P1_3_P3_19_H        (REG_PHY2P1_3_P3_BASE + 0x33)
#define REG_PHY2P1_3_P3_1A_L        (REG_PHY2P1_3_P3_BASE + 0x34)
#define REG_PHY2P1_3_P3_1A_H        (REG_PHY2P1_3_P3_BASE + 0x35)
#define REG_PHY2P1_3_P3_1B_L        (REG_PHY2P1_3_P3_BASE + 0x36)
#define REG_PHY2P1_3_P3_1B_H        (REG_PHY2P1_3_P3_BASE + 0x37)
#define REG_PHY2P1_3_P3_1C_L        (REG_PHY2P1_3_P3_BASE + 0x38)
#define REG_PHY2P1_3_P3_1C_H        (REG_PHY2P1_3_P3_BASE + 0x39)
#define REG_PHY2P1_3_P3_1D_L        (REG_PHY2P1_3_P3_BASE + 0x3A)
#define REG_PHY2P1_3_P3_1D_H        (REG_PHY2P1_3_P3_BASE + 0x3B)
#define REG_PHY2P1_3_P3_1E_L        (REG_PHY2P1_3_P3_BASE + 0x3C)
#define REG_PHY2P1_3_P3_1E_H        (REG_PHY2P1_3_P3_BASE + 0x3D)
#define REG_PHY2P1_3_P3_1F_L        (REG_PHY2P1_3_P3_BASE + 0x3E)
#define REG_PHY2P1_3_P3_1F_H        (REG_PHY2P1_3_P3_BASE + 0x3F)
#define REG_PHY2P1_3_P3_20_L        (REG_PHY2P1_3_P3_BASE + 0x40)
#define REG_PHY2P1_3_P3_20_H        (REG_PHY2P1_3_P3_BASE + 0x41)
#define REG_PHY2P1_3_P3_21_L        (REG_PHY2P1_3_P3_BASE + 0x42)
#define REG_PHY2P1_3_P3_21_H        (REG_PHY2P1_3_P3_BASE + 0x43)
#define REG_PHY2P1_3_P3_22_L        (REG_PHY2P1_3_P3_BASE + 0x44)
#define REG_PHY2P1_3_P3_22_H        (REG_PHY2P1_3_P3_BASE + 0x45)
#define REG_PHY2P1_3_P3_23_L        (REG_PHY2P1_3_P3_BASE + 0x46)
#define REG_PHY2P1_3_P3_23_H        (REG_PHY2P1_3_P3_BASE + 0x47)
#define REG_PHY2P1_3_P3_24_L        (REG_PHY2P1_3_P3_BASE + 0x48)
#define REG_PHY2P1_3_P3_24_H        (REG_PHY2P1_3_P3_BASE + 0x49)
#define REG_PHY2P1_3_P3_25_L        (REG_PHY2P1_3_P3_BASE + 0x4A)
#define REG_PHY2P1_3_P3_25_H        (REG_PHY2P1_3_P3_BASE + 0x4B)
#define REG_PHY2P1_3_P3_26_L        (REG_PHY2P1_3_P3_BASE + 0x4C)
#define REG_PHY2P1_3_P3_26_H        (REG_PHY2P1_3_P3_BASE + 0x4D)
#define REG_PHY2P1_3_P3_27_L        (REG_PHY2P1_3_P3_BASE + 0x4E)
#define REG_PHY2P1_3_P3_27_H        (REG_PHY2P1_3_P3_BASE + 0x4F)
#define REG_PHY2P1_3_P3_28_L        (REG_PHY2P1_3_P3_BASE + 0x50)
#define REG_PHY2P1_3_P3_28_H        (REG_PHY2P1_3_P3_BASE + 0x51)
#define REG_PHY2P1_3_P3_29_L        (REG_PHY2P1_3_P3_BASE + 0x52)
#define REG_PHY2P1_3_P3_29_H        (REG_PHY2P1_3_P3_BASE + 0x53)
#define REG_PHY2P1_3_P3_2A_L        (REG_PHY2P1_3_P3_BASE + 0x54)
#define REG_PHY2P1_3_P3_2A_H        (REG_PHY2P1_3_P3_BASE + 0x55)
#define REG_PHY2P1_3_P3_2B_L        (REG_PHY2P1_3_P3_BASE + 0x56)
#define REG_PHY2P1_3_P3_2B_H        (REG_PHY2P1_3_P3_BASE + 0x57)
#define REG_PHY2P1_3_P3_2C_L        (REG_PHY2P1_3_P3_BASE + 0x58)
#define REG_PHY2P1_3_P3_2C_H        (REG_PHY2P1_3_P3_BASE + 0x59)
#define REG_PHY2P1_3_P3_2D_L        (REG_PHY2P1_3_P3_BASE + 0x5A)
#define REG_PHY2P1_3_P3_2D_H        (REG_PHY2P1_3_P3_BASE + 0x5B)
#define REG_PHY2P1_3_P3_2E_L        (REG_PHY2P1_3_P3_BASE + 0x5C)
#define REG_PHY2P1_3_P3_2E_H        (REG_PHY2P1_3_P3_BASE + 0x5D)
#define REG_PHY2P1_3_P3_2F_L        (REG_PHY2P1_3_P3_BASE + 0x5E)
#define REG_PHY2P1_3_P3_2F_H        (REG_PHY2P1_3_P3_BASE + 0x5F)
#define REG_PHY2P1_3_P3_30_L        (REG_PHY2P1_3_P3_BASE + 0x60)
#define REG_PHY2P1_3_P3_30_H        (REG_PHY2P1_3_P3_BASE + 0x61)
#define REG_PHY2P1_3_P3_31_L        (REG_PHY2P1_3_P3_BASE + 0x62)
#define REG_PHY2P1_3_P3_31_H        (REG_PHY2P1_3_P3_BASE + 0x63)
#define REG_PHY2P1_3_P3_32_L        (REG_PHY2P1_3_P3_BASE + 0x64)
#define REG_PHY2P1_3_P3_32_H        (REG_PHY2P1_3_P3_BASE + 0x65)
#define REG_PHY2P1_3_P3_33_L        (REG_PHY2P1_3_P3_BASE + 0x66)
#define REG_PHY2P1_3_P3_33_H        (REG_PHY2P1_3_P3_BASE + 0x67)
#define REG_PHY2P1_3_P3_34_L        (REG_PHY2P1_3_P3_BASE + 0x68)
#define REG_PHY2P1_3_P3_34_H        (REG_PHY2P1_3_P3_BASE + 0x69)
#define REG_PHY2P1_3_P3_35_L        (REG_PHY2P1_3_P3_BASE + 0x6A)
#define REG_PHY2P1_3_P3_35_H        (REG_PHY2P1_3_P3_BASE + 0x6B)
#define REG_PHY2P1_3_P3_36_L        (REG_PHY2P1_3_P3_BASE + 0x6C)
#define REG_PHY2P1_3_P3_36_H        (REG_PHY2P1_3_P3_BASE + 0x6D)
#define REG_PHY2P1_3_P3_37_L        (REG_PHY2P1_3_P3_BASE + 0x6E)
#define REG_PHY2P1_3_P3_37_H        (REG_PHY2P1_3_P3_BASE + 0x6F)
#define REG_PHY2P1_3_P3_38_L        (REG_PHY2P1_3_P3_BASE + 0x70)
#define REG_PHY2P1_3_P3_38_H        (REG_PHY2P1_3_P3_BASE + 0x71)
#define REG_PHY2P1_3_P3_39_L        (REG_PHY2P1_3_P3_BASE + 0x72)
#define REG_PHY2P1_3_P3_39_H        (REG_PHY2P1_3_P3_BASE + 0x73)
#define REG_PHY2P1_3_P3_3A_L        (REG_PHY2P1_3_P3_BASE + 0x74)
#define REG_PHY2P1_3_P3_3A_H        (REG_PHY2P1_3_P3_BASE + 0x75)
#define REG_PHY2P1_3_P3_3B_L        (REG_PHY2P1_3_P3_BASE + 0x76)
#define REG_PHY2P1_3_P3_3B_H        (REG_PHY2P1_3_P3_BASE + 0x77)
#define REG_PHY2P1_3_P3_3C_L        (REG_PHY2P1_3_P3_BASE + 0x78)
#define REG_PHY2P1_3_P3_3C_H        (REG_PHY2P1_3_P3_BASE + 0x79)
#define REG_PHY2P1_3_P3_3D_L        (REG_PHY2P1_3_P3_BASE + 0x7A)
#define REG_PHY2P1_3_P3_3D_H        (REG_PHY2P1_3_P3_BASE + 0x7B)
#define REG_PHY2P1_3_P3_3E_L        (REG_PHY2P1_3_P3_BASE + 0x7C)
#define REG_PHY2P1_3_P3_3E_H        (REG_PHY2P1_3_P3_BASE + 0x7D)
#define REG_PHY2P1_3_P3_3F_L        (REG_PHY2P1_3_P3_BASE + 0x7E)
#define REG_PHY2P1_3_P3_3F_H        (REG_PHY2P1_3_P3_BASE + 0x7F)
#define REG_PHY2P1_3_P3_40_L        (REG_PHY2P1_3_P3_BASE + 0x80)
#define REG_PHY2P1_3_P3_40_H        (REG_PHY2P1_3_P3_BASE + 0x81)
#define REG_PHY2P1_3_P3_41_L        (REG_PHY2P1_3_P3_BASE + 0x82)
#define REG_PHY2P1_3_P3_41_H        (REG_PHY2P1_3_P3_BASE + 0x83)
#define REG_PHY2P1_3_P3_42_L        (REG_PHY2P1_3_P3_BASE + 0x84)
#define REG_PHY2P1_3_P3_42_H        (REG_PHY2P1_3_P3_BASE + 0x85)
#define REG_PHY2P1_3_P3_43_L        (REG_PHY2P1_3_P3_BASE + 0x86)
#define REG_PHY2P1_3_P3_43_H        (REG_PHY2P1_3_P3_BASE + 0x87)
#define REG_PHY2P1_3_P3_44_L        (REG_PHY2P1_3_P3_BASE + 0x88)
#define REG_PHY2P1_3_P3_44_H        (REG_PHY2P1_3_P3_BASE + 0x89)
#define REG_PHY2P1_3_P3_45_L        (REG_PHY2P1_3_P3_BASE + 0x8A)
#define REG_PHY2P1_3_P3_45_H        (REG_PHY2P1_3_P3_BASE + 0x8B)
#define REG_PHY2P1_3_P3_46_L        (REG_PHY2P1_3_P3_BASE + 0x8C)
#define REG_PHY2P1_3_P3_46_H        (REG_PHY2P1_3_P3_BASE + 0x8D)
#define REG_PHY2P1_3_P3_47_L        (REG_PHY2P1_3_P3_BASE + 0x8E)
#define REG_PHY2P1_3_P3_47_H        (REG_PHY2P1_3_P3_BASE + 0x8F)
#define REG_PHY2P1_3_P3_48_L        (REG_PHY2P1_3_P3_BASE + 0x90)
#define REG_PHY2P1_3_P3_48_H        (REG_PHY2P1_3_P3_BASE + 0x91)
#define REG_PHY2P1_3_P3_49_L        (REG_PHY2P1_3_P3_BASE + 0x92)
#define REG_PHY2P1_3_P3_49_H        (REG_PHY2P1_3_P3_BASE + 0x93)
#define REG_PHY2P1_3_P3_4A_L        (REG_PHY2P1_3_P3_BASE + 0x94)
#define REG_PHY2P1_3_P3_4A_H        (REG_PHY2P1_3_P3_BASE + 0x95)
#define REG_PHY2P1_3_P3_4B_L        (REG_PHY2P1_3_P3_BASE + 0x96)
#define REG_PHY2P1_3_P3_4B_H        (REG_PHY2P1_3_P3_BASE + 0x97)
#define REG_PHY2P1_3_P3_4C_L        (REG_PHY2P1_3_P3_BASE + 0x98)
#define REG_PHY2P1_3_P3_4C_H        (REG_PHY2P1_3_P3_BASE + 0x99)
#define REG_PHY2P1_3_P3_4D_L        (REG_PHY2P1_3_P3_BASE + 0x9A)
#define REG_PHY2P1_3_P3_4D_H        (REG_PHY2P1_3_P3_BASE + 0x9B)
#define REG_PHY2P1_3_P3_4E_L        (REG_PHY2P1_3_P3_BASE + 0x9C)
#define REG_PHY2P1_3_P3_4E_H        (REG_PHY2P1_3_P3_BASE + 0x9D)
#define REG_PHY2P1_3_P3_4F_L        (REG_PHY2P1_3_P3_BASE + 0x9E)
#define REG_PHY2P1_3_P3_4F_H        (REG_PHY2P1_3_P3_BASE + 0x9F)
#define REG_PHY2P1_3_P3_50_L        (REG_PHY2P1_3_P3_BASE + 0xA0)
#define REG_PHY2P1_3_P3_50_H        (REG_PHY2P1_3_P3_BASE + 0xA1)
#define REG_PHY2P1_3_P3_51_L        (REG_PHY2P1_3_P3_BASE + 0xA2)
#define REG_PHY2P1_3_P3_51_H        (REG_PHY2P1_3_P3_BASE + 0xA3)
#define REG_PHY2P1_3_P3_52_L        (REG_PHY2P1_3_P3_BASE + 0xA4)
#define REG_PHY2P1_3_P3_52_H        (REG_PHY2P1_3_P3_BASE + 0xA5)
#define REG_PHY2P1_3_P3_53_L        (REG_PHY2P1_3_P3_BASE + 0xA6)
#define REG_PHY2P1_3_P3_53_H        (REG_PHY2P1_3_P3_BASE + 0xA7)
#define REG_PHY2P1_3_P3_54_L        (REG_PHY2P1_3_P3_BASE + 0xA8)
#define REG_PHY2P1_3_P3_54_H        (REG_PHY2P1_3_P3_BASE + 0xA9)
#define REG_PHY2P1_3_P3_55_L        (REG_PHY2P1_3_P3_BASE + 0xAA)
#define REG_PHY2P1_3_P3_55_H        (REG_PHY2P1_3_P3_BASE + 0xAB)
#define REG_PHY2P1_3_P3_56_L        (REG_PHY2P1_3_P3_BASE + 0xAC)
#define REG_PHY2P1_3_P3_56_H        (REG_PHY2P1_3_P3_BASE + 0xAD)
#define REG_PHY2P1_3_P3_57_L        (REG_PHY2P1_3_P3_BASE + 0xAE)
#define REG_PHY2P1_3_P3_57_H        (REG_PHY2P1_3_P3_BASE + 0xAF)
#define REG_PHY2P1_3_P3_58_L        (REG_PHY2P1_3_P3_BASE + 0xB0)
#define REG_PHY2P1_3_P3_58_H        (REG_PHY2P1_3_P3_BASE + 0xB1)
#define REG_PHY2P1_3_P3_59_L        (REG_PHY2P1_3_P3_BASE + 0xB2)
#define REG_PHY2P1_3_P3_59_H        (REG_PHY2P1_3_P3_BASE + 0xB3)
#define REG_PHY2P1_3_P3_5A_L        (REG_PHY2P1_3_P3_BASE + 0xB4)
#define REG_PHY2P1_3_P3_5A_H        (REG_PHY2P1_3_P3_BASE + 0xB5)
#define REG_PHY2P1_3_P3_5B_L        (REG_PHY2P1_3_P3_BASE + 0xB6)
#define REG_PHY2P1_3_P3_5B_H        (REG_PHY2P1_3_P3_BASE + 0xB7)
#define REG_PHY2P1_3_P3_5C_L        (REG_PHY2P1_3_P3_BASE + 0xB8)
#define REG_PHY2P1_3_P3_5C_H        (REG_PHY2P1_3_P3_BASE + 0xB9)
#define REG_PHY2P1_3_P3_5D_L        (REG_PHY2P1_3_P3_BASE + 0xBA)
#define REG_PHY2P1_3_P3_5D_H        (REG_PHY2P1_3_P3_BASE + 0xBB)
#define REG_PHY2P1_3_P3_5E_L        (REG_PHY2P1_3_P3_BASE + 0xBC)
#define REG_PHY2P1_3_P3_5E_H        (REG_PHY2P1_3_P3_BASE + 0xBD)
#define REG_PHY2P1_3_P3_5F_L        (REG_PHY2P1_3_P3_BASE + 0xBE)
#define REG_PHY2P1_3_P3_5F_H        (REG_PHY2P1_3_P3_BASE + 0xBF)
#define REG_PHY2P1_3_P3_60_L        (REG_PHY2P1_3_P3_BASE + 0xC0)
#define REG_PHY2P1_3_P3_60_H        (REG_PHY2P1_3_P3_BASE + 0xC1)
#define REG_PHY2P1_3_P3_61_L        (REG_PHY2P1_3_P3_BASE + 0xC2)
#define REG_PHY2P1_3_P3_61_H        (REG_PHY2P1_3_P3_BASE + 0xC3)
#define REG_PHY2P1_3_P3_62_L        (REG_PHY2P1_3_P3_BASE + 0xC4)
#define REG_PHY2P1_3_P3_62_H        (REG_PHY2P1_3_P3_BASE + 0xC5)
#define REG_PHY2P1_3_P3_63_L        (REG_PHY2P1_3_P3_BASE + 0xC6)
#define REG_PHY2P1_3_P3_63_H        (REG_PHY2P1_3_P3_BASE + 0xC7)
#define REG_PHY2P1_3_P3_64_L        (REG_PHY2P1_3_P3_BASE + 0xC8)
#define REG_PHY2P1_3_P3_64_H        (REG_PHY2P1_3_P3_BASE + 0xC9)
#define REG_PHY2P1_3_P3_65_L        (REG_PHY2P1_3_P3_BASE + 0xCA)
#define REG_PHY2P1_3_P3_65_H        (REG_PHY2P1_3_P3_BASE + 0xCB)
#define REG_PHY2P1_3_P3_66_L        (REG_PHY2P1_3_P3_BASE + 0xCC)
#define REG_PHY2P1_3_P3_66_H        (REG_PHY2P1_3_P3_BASE + 0xCD)
#define REG_PHY2P1_3_P3_67_L        (REG_PHY2P1_3_P3_BASE + 0xCE)
#define REG_PHY2P1_3_P3_67_H        (REG_PHY2P1_3_P3_BASE + 0xCF)
#define REG_PHY2P1_3_P3_68_L        (REG_PHY2P1_3_P3_BASE + 0xD0)
#define REG_PHY2P1_3_P3_68_H        (REG_PHY2P1_3_P3_BASE + 0xD1)
#define REG_PHY2P1_3_P3_69_L        (REG_PHY2P1_3_P3_BASE + 0xD2)
#define REG_PHY2P1_3_P3_69_H        (REG_PHY2P1_3_P3_BASE + 0xD3)
#define REG_PHY2P1_3_P3_6A_L        (REG_PHY2P1_3_P3_BASE + 0xD4)
#define REG_PHY2P1_3_P3_6A_H        (REG_PHY2P1_3_P3_BASE + 0xD5)
#define REG_PHY2P1_3_P3_6B_L        (REG_PHY2P1_3_P3_BASE + 0xD6)
#define REG_PHY2P1_3_P3_6B_H        (REG_PHY2P1_3_P3_BASE + 0xD7)
#define REG_PHY2P1_3_P3_6C_L        (REG_PHY2P1_3_P3_BASE + 0xD8)
#define REG_PHY2P1_3_P3_6C_H        (REG_PHY2P1_3_P3_BASE + 0xD9)
#define REG_PHY2P1_3_P3_6D_L        (REG_PHY2P1_3_P3_BASE + 0xDA)
#define REG_PHY2P1_3_P3_6D_H        (REG_PHY2P1_3_P3_BASE + 0xDB)
#define REG_PHY2P1_3_P3_6E_L        (REG_PHY2P1_3_P3_BASE + 0xDC)
#define REG_PHY2P1_3_P3_6E_H        (REG_PHY2P1_3_P3_BASE + 0xDD)
#define REG_PHY2P1_3_P3_6F_L        (REG_PHY2P1_3_P3_BASE + 0xDE)
#define REG_PHY2P1_3_P3_6F_H        (REG_PHY2P1_3_P3_BASE + 0xDF)
#define REG_PHY2P1_3_P3_70_L        (REG_PHY2P1_3_P3_BASE + 0xE0)
#define REG_PHY2P1_3_P3_70_H        (REG_PHY2P1_3_P3_BASE + 0xE1)
#define REG_PHY2P1_3_P3_71_L        (REG_PHY2P1_3_P3_BASE + 0xE2)
#define REG_PHY2P1_3_P3_71_H        (REG_PHY2P1_3_P3_BASE + 0xE3)
#define REG_PHY2P1_3_P3_72_L        (REG_PHY2P1_3_P3_BASE + 0xE4)
#define REG_PHY2P1_3_P3_72_H        (REG_PHY2P1_3_P3_BASE + 0xE5)
#define REG_PHY2P1_3_P3_73_L        (REG_PHY2P1_3_P3_BASE + 0xE6)
#define REG_PHY2P1_3_P3_73_H        (REG_PHY2P1_3_P3_BASE + 0xE7)
#define REG_PHY2P1_3_P3_74_L        (REG_PHY2P1_3_P3_BASE + 0xE8)
#define REG_PHY2P1_3_P3_74_H        (REG_PHY2P1_3_P3_BASE + 0xE9)
#define REG_PHY2P1_3_P3_75_L        (REG_PHY2P1_3_P3_BASE + 0xEA)
#define REG_PHY2P1_3_P3_75_H        (REG_PHY2P1_3_P3_BASE + 0xEB)
#define REG_PHY2P1_3_P3_76_L        (REG_PHY2P1_3_P3_BASE + 0xEC)
#define REG_PHY2P1_3_P3_76_H        (REG_PHY2P1_3_P3_BASE + 0xED)
#define REG_PHY2P1_3_P3_77_L        (REG_PHY2P1_3_P3_BASE + 0xEE)
#define REG_PHY2P1_3_P3_77_H        (REG_PHY2P1_3_P3_BASE + 0xEF)
#define REG_PHY2P1_3_P3_78_L        (REG_PHY2P1_3_P3_BASE + 0xF0)
#define REG_PHY2P1_3_P3_78_H        (REG_PHY2P1_3_P3_BASE + 0xF1)
#define REG_PHY2P1_3_P3_79_L        (REG_PHY2P1_3_P3_BASE + 0xF2)
#define REG_PHY2P1_3_P3_79_H        (REG_PHY2P1_3_P3_BASE + 0xF3)
#define REG_PHY2P1_3_P3_7A_L        (REG_PHY2P1_3_P3_BASE + 0xF4)
#define REG_PHY2P1_3_P3_7A_H        (REG_PHY2P1_3_P3_BASE + 0xF5)
#define REG_PHY2P1_3_P3_7B_L        (REG_PHY2P1_3_P3_BASE + 0xF6)
#define REG_PHY2P1_3_P3_7B_H        (REG_PHY2P1_3_P3_BASE + 0xF7)
#define REG_PHY2P1_3_P3_7C_L        (REG_PHY2P1_3_P3_BASE + 0xF8)
#define REG_PHY2P1_3_P3_7C_H        (REG_PHY2P1_3_P3_BASE + 0xF9)
#define REG_PHY2P1_3_P3_7D_L        (REG_PHY2P1_3_P3_BASE + 0xFA)
#define REG_PHY2P1_3_P3_7D_H        (REG_PHY2P1_3_P3_BASE + 0xFB)
#define REG_PHY2P1_3_P3_7E_L        (REG_PHY2P1_3_P3_BASE + 0xFC)
#define REG_PHY2P1_3_P3_7E_H        (REG_PHY2P1_3_P3_BASE + 0xFD)
#define REG_PHY2P1_3_P3_7F_L        (REG_PHY2P1_3_P3_BASE + 0xFE)
#define REG_PHY2P1_3_P3_7F_H        (REG_PHY2P1_3_P3_BASE + 0xFF)

//=============================================================
// PHY2P1_4_P3
#define REG_PHY2P1_4_P3_00_L        (REG_PHY2P1_4_P3_BASE + 0x00)
#define REG_PHY2P1_4_P3_00_H        (REG_PHY2P1_4_P3_BASE + 0x01)
#define REG_PHY2P1_4_P3_01_L        (REG_PHY2P1_4_P3_BASE + 0x02)
#define REG_PHY2P1_4_P3_01_H        (REG_PHY2P1_4_P3_BASE + 0x03)
#define REG_PHY2P1_4_P3_02_L        (REG_PHY2P1_4_P3_BASE + 0x04)
#define REG_PHY2P1_4_P3_02_H        (REG_PHY2P1_4_P3_BASE + 0x05)
#define REG_PHY2P1_4_P3_03_L        (REG_PHY2P1_4_P3_BASE + 0x06)
#define REG_PHY2P1_4_P3_03_H        (REG_PHY2P1_4_P3_BASE + 0x07)
#define REG_PHY2P1_4_P3_04_L        (REG_PHY2P1_4_P3_BASE + 0x08)
#define REG_PHY2P1_4_P3_04_H        (REG_PHY2P1_4_P3_BASE + 0x09)
#define REG_PHY2P1_4_P3_05_L        (REG_PHY2P1_4_P3_BASE + 0x0A)
#define REG_PHY2P1_4_P3_05_H        (REG_PHY2P1_4_P3_BASE + 0x0B)
#define REG_PHY2P1_4_P3_06_L        (REG_PHY2P1_4_P3_BASE + 0x0C)
#define REG_PHY2P1_4_P3_06_H        (REG_PHY2P1_4_P3_BASE + 0x0D)
#define REG_PHY2P1_4_P3_07_L        (REG_PHY2P1_4_P3_BASE + 0x0E)
#define REG_PHY2P1_4_P3_07_H        (REG_PHY2P1_4_P3_BASE + 0x0F)
#define REG_PHY2P1_4_P3_08_L        (REG_PHY2P1_4_P3_BASE + 0x10)
#define REG_PHY2P1_4_P3_08_H        (REG_PHY2P1_4_P3_BASE + 0x11)
#define REG_PHY2P1_4_P3_09_L        (REG_PHY2P1_4_P3_BASE + 0x12)
#define REG_PHY2P1_4_P3_09_H        (REG_PHY2P1_4_P3_BASE + 0x13)
#define REG_PHY2P1_4_P3_0A_L        (REG_PHY2P1_4_P3_BASE + 0x14)
#define REG_PHY2P1_4_P3_0A_H        (REG_PHY2P1_4_P3_BASE + 0x15)
#define REG_PHY2P1_4_P3_0B_L        (REG_PHY2P1_4_P3_BASE + 0x16)
#define REG_PHY2P1_4_P3_0B_H        (REG_PHY2P1_4_P3_BASE + 0x17)
#define REG_PHY2P1_4_P3_0C_L        (REG_PHY2P1_4_P3_BASE + 0x18)
#define REG_PHY2P1_4_P3_0C_H        (REG_PHY2P1_4_P3_BASE + 0x19)
#define REG_PHY2P1_4_P3_0D_L        (REG_PHY2P1_4_P3_BASE + 0x1A)
#define REG_PHY2P1_4_P3_0D_H        (REG_PHY2P1_4_P3_BASE + 0x1B)
#define REG_PHY2P1_4_P3_0E_L        (REG_PHY2P1_4_P3_BASE + 0x1C)
#define REG_PHY2P1_4_P3_0E_H        (REG_PHY2P1_4_P3_BASE + 0x1D)
#define REG_PHY2P1_4_P3_0F_L        (REG_PHY2P1_4_P3_BASE + 0x1E)
#define REG_PHY2P1_4_P3_0F_H        (REG_PHY2P1_4_P3_BASE + 0x1F)
#define REG_PHY2P1_4_P3_10_L        (REG_PHY2P1_4_P3_BASE + 0x20)
#define REG_PHY2P1_4_P3_10_H        (REG_PHY2P1_4_P3_BASE + 0x21)
#define REG_PHY2P1_4_P3_11_L        (REG_PHY2P1_4_P3_BASE + 0x22)
#define REG_PHY2P1_4_P3_11_H        (REG_PHY2P1_4_P3_BASE + 0x23)
#define REG_PHY2P1_4_P3_12_L        (REG_PHY2P1_4_P3_BASE + 0x24)
#define REG_PHY2P1_4_P3_12_H        (REG_PHY2P1_4_P3_BASE + 0x25)
#define REG_PHY2P1_4_P3_13_L        (REG_PHY2P1_4_P3_BASE + 0x26)
#define REG_PHY2P1_4_P3_13_H        (REG_PHY2P1_4_P3_BASE + 0x27)
#define REG_PHY2P1_4_P3_14_L        (REG_PHY2P1_4_P3_BASE + 0x28)
#define REG_PHY2P1_4_P3_14_H        (REG_PHY2P1_4_P3_BASE + 0x29)
#define REG_PHY2P1_4_P3_15_L        (REG_PHY2P1_4_P3_BASE + 0x2A)
#define REG_PHY2P1_4_P3_15_H        (REG_PHY2P1_4_P3_BASE + 0x2B)
#define REG_PHY2P1_4_P3_16_L        (REG_PHY2P1_4_P3_BASE + 0x2C)
#define REG_PHY2P1_4_P3_16_H        (REG_PHY2P1_4_P3_BASE + 0x2D)
#define REG_PHY2P1_4_P3_17_L        (REG_PHY2P1_4_P3_BASE + 0x2E)
#define REG_PHY2P1_4_P3_17_H        (REG_PHY2P1_4_P3_BASE + 0x2F)
#define REG_PHY2P1_4_P3_18_L        (REG_PHY2P1_4_P3_BASE + 0x30)
#define REG_PHY2P1_4_P3_18_H        (REG_PHY2P1_4_P3_BASE + 0x31)
#define REG_PHY2P1_4_P3_19_L        (REG_PHY2P1_4_P3_BASE + 0x32)
#define REG_PHY2P1_4_P3_19_H        (REG_PHY2P1_4_P3_BASE + 0x33)
#define REG_PHY2P1_4_P3_1A_L        (REG_PHY2P1_4_P3_BASE + 0x34)
#define REG_PHY2P1_4_P3_1A_H        (REG_PHY2P1_4_P3_BASE + 0x35)
#define REG_PHY2P1_4_P3_1B_L        (REG_PHY2P1_4_P3_BASE + 0x36)
#define REG_PHY2P1_4_P3_1B_H        (REG_PHY2P1_4_P3_BASE + 0x37)
#define REG_PHY2P1_4_P3_1C_L        (REG_PHY2P1_4_P3_BASE + 0x38)
#define REG_PHY2P1_4_P3_1C_H        (REG_PHY2P1_4_P3_BASE + 0x39)
#define REG_PHY2P1_4_P3_1D_L        (REG_PHY2P1_4_P3_BASE + 0x3A)
#define REG_PHY2P1_4_P3_1D_H        (REG_PHY2P1_4_P3_BASE + 0x3B)
#define REG_PHY2P1_4_P3_1E_L        (REG_PHY2P1_4_P3_BASE + 0x3C)
#define REG_PHY2P1_4_P3_1E_H        (REG_PHY2P1_4_P3_BASE + 0x3D)
#define REG_PHY2P1_4_P3_1F_L        (REG_PHY2P1_4_P3_BASE + 0x3E)
#define REG_PHY2P1_4_P3_1F_H        (REG_PHY2P1_4_P3_BASE + 0x3F)
#define REG_PHY2P1_4_P3_20_L        (REG_PHY2P1_4_P3_BASE + 0x40)
#define REG_PHY2P1_4_P3_20_H        (REG_PHY2P1_4_P3_BASE + 0x41)
#define REG_PHY2P1_4_P3_21_L        (REG_PHY2P1_4_P3_BASE + 0x42)
#define REG_PHY2P1_4_P3_21_H        (REG_PHY2P1_4_P3_BASE + 0x43)
#define REG_PHY2P1_4_P3_22_L        (REG_PHY2P1_4_P3_BASE + 0x44)
#define REG_PHY2P1_4_P3_22_H        (REG_PHY2P1_4_P3_BASE + 0x45)
#define REG_PHY2P1_4_P3_23_L        (REG_PHY2P1_4_P3_BASE + 0x46)
#define REG_PHY2P1_4_P3_23_H        (REG_PHY2P1_4_P3_BASE + 0x47)
#define REG_PHY2P1_4_P3_24_L        (REG_PHY2P1_4_P3_BASE + 0x48)
#define REG_PHY2P1_4_P3_24_H        (REG_PHY2P1_4_P3_BASE + 0x49)
#define REG_PHY2P1_4_P3_25_L        (REG_PHY2P1_4_P3_BASE + 0x4A)
#define REG_PHY2P1_4_P3_25_H        (REG_PHY2P1_4_P3_BASE + 0x4B)
#define REG_PHY2P1_4_P3_26_L        (REG_PHY2P1_4_P3_BASE + 0x4C)
#define REG_PHY2P1_4_P3_26_H        (REG_PHY2P1_4_P3_BASE + 0x4D)
#define REG_PHY2P1_4_P3_27_L        (REG_PHY2P1_4_P3_BASE + 0x4E)
#define REG_PHY2P1_4_P3_27_H        (REG_PHY2P1_4_P3_BASE + 0x4F)
#define REG_PHY2P1_4_P3_28_L        (REG_PHY2P1_4_P3_BASE + 0x50)
#define REG_PHY2P1_4_P3_28_H        (REG_PHY2P1_4_P3_BASE + 0x51)
#define REG_PHY2P1_4_P3_29_L        (REG_PHY2P1_4_P3_BASE + 0x52)
#define REG_PHY2P1_4_P3_29_H        (REG_PHY2P1_4_P3_BASE + 0x53)
#define REG_PHY2P1_4_P3_2A_L        (REG_PHY2P1_4_P3_BASE + 0x54)
#define REG_PHY2P1_4_P3_2A_H        (REG_PHY2P1_4_P3_BASE + 0x55)
#define REG_PHY2P1_4_P3_2B_L        (REG_PHY2P1_4_P3_BASE + 0x56)
#define REG_PHY2P1_4_P3_2B_H        (REG_PHY2P1_4_P3_BASE + 0x57)
#define REG_PHY2P1_4_P3_2C_L        (REG_PHY2P1_4_P3_BASE + 0x58)
#define REG_PHY2P1_4_P3_2C_H        (REG_PHY2P1_4_P3_BASE + 0x59)
#define REG_PHY2P1_4_P3_2D_L        (REG_PHY2P1_4_P3_BASE + 0x5A)
#define REG_PHY2P1_4_P3_2D_H        (REG_PHY2P1_4_P3_BASE + 0x5B)
#define REG_PHY2P1_4_P3_2E_L        (REG_PHY2P1_4_P3_BASE + 0x5C)
#define REG_PHY2P1_4_P3_2E_H        (REG_PHY2P1_4_P3_BASE + 0x5D)
#define REG_PHY2P1_4_P3_2F_L        (REG_PHY2P1_4_P3_BASE + 0x5E)
#define REG_PHY2P1_4_P3_2F_H        (REG_PHY2P1_4_P3_BASE + 0x5F)
#define REG_PHY2P1_4_P3_30_L        (REG_PHY2P1_4_P3_BASE + 0x60)
#define REG_PHY2P1_4_P3_30_H        (REG_PHY2P1_4_P3_BASE + 0x61)
#define REG_PHY2P1_4_P3_31_L        (REG_PHY2P1_4_P3_BASE + 0x62)
#define REG_PHY2P1_4_P3_31_H        (REG_PHY2P1_4_P3_BASE + 0x63)
#define REG_PHY2P1_4_P3_32_L        (REG_PHY2P1_4_P3_BASE + 0x64)
#define REG_PHY2P1_4_P3_32_H        (REG_PHY2P1_4_P3_BASE + 0x65)
#define REG_PHY2P1_4_P3_33_L        (REG_PHY2P1_4_P3_BASE + 0x66)
#define REG_PHY2P1_4_P3_33_H        (REG_PHY2P1_4_P3_BASE + 0x67)
#define REG_PHY2P1_4_P3_34_L        (REG_PHY2P1_4_P3_BASE + 0x68)
#define REG_PHY2P1_4_P3_34_H        (REG_PHY2P1_4_P3_BASE + 0x69)
#define REG_PHY2P1_4_P3_35_L        (REG_PHY2P1_4_P3_BASE + 0x6A)
#define REG_PHY2P1_4_P3_35_H        (REG_PHY2P1_4_P3_BASE + 0x6B)
#define REG_PHY2P1_4_P3_36_L        (REG_PHY2P1_4_P3_BASE + 0x6C)
#define REG_PHY2P1_4_P3_36_H        (REG_PHY2P1_4_P3_BASE + 0x6D)
#define REG_PHY2P1_4_P3_37_L        (REG_PHY2P1_4_P3_BASE + 0x6E)
#define REG_PHY2P1_4_P3_37_H        (REG_PHY2P1_4_P3_BASE + 0x6F)
#define REG_PHY2P1_4_P3_38_L        (REG_PHY2P1_4_P3_BASE + 0x70)
#define REG_PHY2P1_4_P3_38_H        (REG_PHY2P1_4_P3_BASE + 0x71)
#define REG_PHY2P1_4_P3_39_L        (REG_PHY2P1_4_P3_BASE + 0x72)
#define REG_PHY2P1_4_P3_39_H        (REG_PHY2P1_4_P3_BASE + 0x73)
#define REG_PHY2P1_4_P3_3A_L        (REG_PHY2P1_4_P3_BASE + 0x74)
#define REG_PHY2P1_4_P3_3A_H        (REG_PHY2P1_4_P3_BASE + 0x75)
#define REG_PHY2P1_4_P3_3B_L        (REG_PHY2P1_4_P3_BASE + 0x76)
#define REG_PHY2P1_4_P3_3B_H        (REG_PHY2P1_4_P3_BASE + 0x77)
#define REG_PHY2P1_4_P3_3C_L        (REG_PHY2P1_4_P3_BASE + 0x78)
#define REG_PHY2P1_4_P3_3C_H        (REG_PHY2P1_4_P3_BASE + 0x79)
#define REG_PHY2P1_4_P3_3D_L        (REG_PHY2P1_4_P3_BASE + 0x7A)
#define REG_PHY2P1_4_P3_3D_H        (REG_PHY2P1_4_P3_BASE + 0x7B)
#define REG_PHY2P1_4_P3_3E_L        (REG_PHY2P1_4_P3_BASE + 0x7C)
#define REG_PHY2P1_4_P3_3E_H        (REG_PHY2P1_4_P3_BASE + 0x7D)
#define REG_PHY2P1_4_P3_3F_L        (REG_PHY2P1_4_P3_BASE + 0x7E)
#define REG_PHY2P1_4_P3_3F_H        (REG_PHY2P1_4_P3_BASE + 0x7F)
#define REG_PHY2P1_4_P3_40_L        (REG_PHY2P1_4_P3_BASE + 0x80)
#define REG_PHY2P1_4_P3_40_H        (REG_PHY2P1_4_P3_BASE + 0x81)
#define REG_PHY2P1_4_P3_41_L        (REG_PHY2P1_4_P3_BASE + 0x82)
#define REG_PHY2P1_4_P3_41_H        (REG_PHY2P1_4_P3_BASE + 0x83)
#define REG_PHY2P1_4_P3_42_L        (REG_PHY2P1_4_P3_BASE + 0x84)
#define REG_PHY2P1_4_P3_42_H        (REG_PHY2P1_4_P3_BASE + 0x85)
#define REG_PHY2P1_4_P3_43_L        (REG_PHY2P1_4_P3_BASE + 0x86)
#define REG_PHY2P1_4_P3_43_H        (REG_PHY2P1_4_P3_BASE + 0x87)
#define REG_PHY2P1_4_P3_44_L        (REG_PHY2P1_4_P3_BASE + 0x88)
#define REG_PHY2P1_4_P3_44_H        (REG_PHY2P1_4_P3_BASE + 0x89)
#define REG_PHY2P1_4_P3_45_L        (REG_PHY2P1_4_P3_BASE + 0x8A)
#define REG_PHY2P1_4_P3_45_H        (REG_PHY2P1_4_P3_BASE + 0x8B)
#define REG_PHY2P1_4_P3_46_L        (REG_PHY2P1_4_P3_BASE + 0x8C)
#define REG_PHY2P1_4_P3_46_H        (REG_PHY2P1_4_P3_BASE + 0x8D)
#define REG_PHY2P1_4_P3_47_L        (REG_PHY2P1_4_P3_BASE + 0x8E)
#define REG_PHY2P1_4_P3_47_H        (REG_PHY2P1_4_P3_BASE + 0x8F)
#define REG_PHY2P1_4_P3_48_L        (REG_PHY2P1_4_P3_BASE + 0x90)
#define REG_PHY2P1_4_P3_48_H        (REG_PHY2P1_4_P3_BASE + 0x91)
#define REG_PHY2P1_4_P3_49_L        (REG_PHY2P1_4_P3_BASE + 0x92)
#define REG_PHY2P1_4_P3_49_H        (REG_PHY2P1_4_P3_BASE + 0x93)
#define REG_PHY2P1_4_P3_4A_L        (REG_PHY2P1_4_P3_BASE + 0x94)
#define REG_PHY2P1_4_P3_4A_H        (REG_PHY2P1_4_P3_BASE + 0x95)
#define REG_PHY2P1_4_P3_4B_L        (REG_PHY2P1_4_P3_BASE + 0x96)
#define REG_PHY2P1_4_P3_4B_H        (REG_PHY2P1_4_P3_BASE + 0x97)
#define REG_PHY2P1_4_P3_4C_L        (REG_PHY2P1_4_P3_BASE + 0x98)
#define REG_PHY2P1_4_P3_4C_H        (REG_PHY2P1_4_P3_BASE + 0x99)
#define REG_PHY2P1_4_P3_4D_L        (REG_PHY2P1_4_P3_BASE + 0x9A)
#define REG_PHY2P1_4_P3_4D_H        (REG_PHY2P1_4_P3_BASE + 0x9B)
#define REG_PHY2P1_4_P3_4E_L        (REG_PHY2P1_4_P3_BASE + 0x9C)
#define REG_PHY2P1_4_P3_4E_H        (REG_PHY2P1_4_P3_BASE + 0x9D)
#define REG_PHY2P1_4_P3_4F_L        (REG_PHY2P1_4_P3_BASE + 0x9E)
#define REG_PHY2P1_4_P3_4F_H        (REG_PHY2P1_4_P3_BASE + 0x9F)
#define REG_PHY2P1_4_P3_50_L        (REG_PHY2P1_4_P3_BASE + 0xA0)
#define REG_PHY2P1_4_P3_50_H        (REG_PHY2P1_4_P3_BASE + 0xA1)
#define REG_PHY2P1_4_P3_51_L        (REG_PHY2P1_4_P3_BASE + 0xA2)
#define REG_PHY2P1_4_P3_51_H        (REG_PHY2P1_4_P3_BASE + 0xA3)
#define REG_PHY2P1_4_P3_52_L        (REG_PHY2P1_4_P3_BASE + 0xA4)
#define REG_PHY2P1_4_P3_52_H        (REG_PHY2P1_4_P3_BASE + 0xA5)
#define REG_PHY2P1_4_P3_53_L        (REG_PHY2P1_4_P3_BASE + 0xA6)
#define REG_PHY2P1_4_P3_53_H        (REG_PHY2P1_4_P3_BASE + 0xA7)
#define REG_PHY2P1_4_P3_54_L        (REG_PHY2P1_4_P3_BASE + 0xA8)
#define REG_PHY2P1_4_P3_54_H        (REG_PHY2P1_4_P3_BASE + 0xA9)
#define REG_PHY2P1_4_P3_55_L        (REG_PHY2P1_4_P3_BASE + 0xAA)
#define REG_PHY2P1_4_P3_55_H        (REG_PHY2P1_4_P3_BASE + 0xAB)
#define REG_PHY2P1_4_P3_56_L        (REG_PHY2P1_4_P3_BASE + 0xAC)
#define REG_PHY2P1_4_P3_56_H        (REG_PHY2P1_4_P3_BASE + 0xAD)
#define REG_PHY2P1_4_P3_57_L        (REG_PHY2P1_4_P3_BASE + 0xAE)
#define REG_PHY2P1_4_P3_57_H        (REG_PHY2P1_4_P3_BASE + 0xAF)
#define REG_PHY2P1_4_P3_58_L        (REG_PHY2P1_4_P3_BASE + 0xB0)
#define REG_PHY2P1_4_P3_58_H        (REG_PHY2P1_4_P3_BASE + 0xB1)
#define REG_PHY2P1_4_P3_59_L        (REG_PHY2P1_4_P3_BASE + 0xB2)
#define REG_PHY2P1_4_P3_59_H        (REG_PHY2P1_4_P3_BASE + 0xB3)
#define REG_PHY2P1_4_P3_5A_L        (REG_PHY2P1_4_P3_BASE + 0xB4)
#define REG_PHY2P1_4_P3_5A_H        (REG_PHY2P1_4_P3_BASE + 0xB5)
#define REG_PHY2P1_4_P3_5B_L        (REG_PHY2P1_4_P3_BASE + 0xB6)
#define REG_PHY2P1_4_P3_5B_H        (REG_PHY2P1_4_P3_BASE + 0xB7)
#define REG_PHY2P1_4_P3_5C_L        (REG_PHY2P1_4_P3_BASE + 0xB8)
#define REG_PHY2P1_4_P3_5C_H        (REG_PHY2P1_4_P3_BASE + 0xB9)
#define REG_PHY2P1_4_P3_5D_L        (REG_PHY2P1_4_P3_BASE + 0xBA)
#define REG_PHY2P1_4_P3_5D_H        (REG_PHY2P1_4_P3_BASE + 0xBB)
#define REG_PHY2P1_4_P3_5E_L        (REG_PHY2P1_4_P3_BASE + 0xBC)
#define REG_PHY2P1_4_P3_5E_H        (REG_PHY2P1_4_P3_BASE + 0xBD)
#define REG_PHY2P1_4_P3_5F_L        (REG_PHY2P1_4_P3_BASE + 0xBE)
#define REG_PHY2P1_4_P3_5F_H        (REG_PHY2P1_4_P3_BASE + 0xBF)
#define REG_PHY2P1_4_P3_60_L        (REG_PHY2P1_4_P3_BASE + 0xC0)
#define REG_PHY2P1_4_P3_60_H        (REG_PHY2P1_4_P3_BASE + 0xC1)
#define REG_PHY2P1_4_P3_61_L        (REG_PHY2P1_4_P3_BASE + 0xC2)
#define REG_PHY2P1_4_P3_61_H        (REG_PHY2P1_4_P3_BASE + 0xC3)
#define REG_PHY2P1_4_P3_62_L        (REG_PHY2P1_4_P3_BASE + 0xC4)
#define REG_PHY2P1_4_P3_62_H        (REG_PHY2P1_4_P3_BASE + 0xC5)
#define REG_PHY2P1_4_P3_63_L        (REG_PHY2P1_4_P3_BASE + 0xC6)
#define REG_PHY2P1_4_P3_63_H        (REG_PHY2P1_4_P3_BASE + 0xC7)
#define REG_PHY2P1_4_P3_64_L        (REG_PHY2P1_4_P3_BASE + 0xC8)
#define REG_PHY2P1_4_P3_64_H        (REG_PHY2P1_4_P3_BASE + 0xC9)
#define REG_PHY2P1_4_P3_65_L        (REG_PHY2P1_4_P3_BASE + 0xCA)
#define REG_PHY2P1_4_P3_65_H        (REG_PHY2P1_4_P3_BASE + 0xCB)
#define REG_PHY2P1_4_P3_66_L        (REG_PHY2P1_4_P3_BASE + 0xCC)
#define REG_PHY2P1_4_P3_66_H        (REG_PHY2P1_4_P3_BASE + 0xCD)
#define REG_PHY2P1_4_P3_67_L        (REG_PHY2P1_4_P3_BASE + 0xCE)
#define REG_PHY2P1_4_P3_67_H        (REG_PHY2P1_4_P3_BASE + 0xCF)
#define REG_PHY2P1_4_P3_68_L        (REG_PHY2P1_4_P3_BASE + 0xD0)
#define REG_PHY2P1_4_P3_68_H        (REG_PHY2P1_4_P3_BASE + 0xD1)
#define REG_PHY2P1_4_P3_69_L        (REG_PHY2P1_4_P3_BASE + 0xD2)
#define REG_PHY2P1_4_P3_69_H        (REG_PHY2P1_4_P3_BASE + 0xD3)
#define REG_PHY2P1_4_P3_6A_L        (REG_PHY2P1_4_P3_BASE + 0xD4)
#define REG_PHY2P1_4_P3_6A_H        (REG_PHY2P1_4_P3_BASE + 0xD5)
#define REG_PHY2P1_4_P3_6B_L        (REG_PHY2P1_4_P3_BASE + 0xD6)
#define REG_PHY2P1_4_P3_6B_H        (REG_PHY2P1_4_P3_BASE + 0xD7)
#define REG_PHY2P1_4_P3_6C_L        (REG_PHY2P1_4_P3_BASE + 0xD8)
#define REG_PHY2P1_4_P3_6C_H        (REG_PHY2P1_4_P3_BASE + 0xD9)
#define REG_PHY2P1_4_P3_6D_L        (REG_PHY2P1_4_P3_BASE + 0xDA)
#define REG_PHY2P1_4_P3_6D_H        (REG_PHY2P1_4_P3_BASE + 0xDB)
#define REG_PHY2P1_4_P3_6E_L        (REG_PHY2P1_4_P3_BASE + 0xDC)
#define REG_PHY2P1_4_P3_6E_H        (REG_PHY2P1_4_P3_BASE + 0xDD)
#define REG_PHY2P1_4_P3_6F_L        (REG_PHY2P1_4_P3_BASE + 0xDE)
#define REG_PHY2P1_4_P3_6F_H        (REG_PHY2P1_4_P3_BASE + 0xDF)
#define REG_PHY2P1_4_P3_70_L        (REG_PHY2P1_4_P3_BASE + 0xE0)
#define REG_PHY2P1_4_P3_70_H        (REG_PHY2P1_4_P3_BASE + 0xE1)
#define REG_PHY2P1_4_P3_71_L        (REG_PHY2P1_4_P3_BASE + 0xE2)
#define REG_PHY2P1_4_P3_71_H        (REG_PHY2P1_4_P3_BASE + 0xE3)
#define REG_PHY2P1_4_P3_72_L        (REG_PHY2P1_4_P3_BASE + 0xE4)
#define REG_PHY2P1_4_P3_72_H        (REG_PHY2P1_4_P3_BASE + 0xE5)
#define REG_PHY2P1_4_P3_73_L        (REG_PHY2P1_4_P3_BASE + 0xE6)
#define REG_PHY2P1_4_P3_73_H        (REG_PHY2P1_4_P3_BASE + 0xE7)
#define REG_PHY2P1_4_P3_74_L        (REG_PHY2P1_4_P3_BASE + 0xE8)
#define REG_PHY2P1_4_P3_74_H        (REG_PHY2P1_4_P3_BASE + 0xE9)
#define REG_PHY2P1_4_P3_75_L        (REG_PHY2P1_4_P3_BASE + 0xEA)
#define REG_PHY2P1_4_P3_75_H        (REG_PHY2P1_4_P3_BASE + 0xEB)
#define REG_PHY2P1_4_P3_76_L        (REG_PHY2P1_4_P3_BASE + 0xEC)
#define REG_PHY2P1_4_P3_76_H        (REG_PHY2P1_4_P3_BASE + 0xED)
#define REG_PHY2P1_4_P3_77_L        (REG_PHY2P1_4_P3_BASE + 0xEE)
#define REG_PHY2P1_4_P3_77_H        (REG_PHY2P1_4_P3_BASE + 0xEF)
#define REG_PHY2P1_4_P3_78_L        (REG_PHY2P1_4_P3_BASE + 0xF0)
#define REG_PHY2P1_4_P3_78_H        (REG_PHY2P1_4_P3_BASE + 0xF1)
#define REG_PHY2P1_4_P3_79_L        (REG_PHY2P1_4_P3_BASE + 0xF2)
#define REG_PHY2P1_4_P3_79_H        (REG_PHY2P1_4_P3_BASE + 0xF3)
#define REG_PHY2P1_4_P3_7A_L        (REG_PHY2P1_4_P3_BASE + 0xF4)
#define REG_PHY2P1_4_P3_7A_H        (REG_PHY2P1_4_P3_BASE + 0xF5)
#define REG_PHY2P1_4_P3_7B_L        (REG_PHY2P1_4_P3_BASE + 0xF6)
#define REG_PHY2P1_4_P3_7B_H        (REG_PHY2P1_4_P3_BASE + 0xF7)
#define REG_PHY2P1_4_P3_7C_L        (REG_PHY2P1_4_P3_BASE + 0xF8)
#define REG_PHY2P1_4_P3_7C_H        (REG_PHY2P1_4_P3_BASE + 0xF9)
#define REG_PHY2P1_4_P3_7D_L        (REG_PHY2P1_4_P3_BASE + 0xFA)
#define REG_PHY2P1_4_P3_7D_H        (REG_PHY2P1_4_P3_BASE + 0xFB)
#define REG_PHY2P1_4_P3_7E_L        (REG_PHY2P1_4_P3_BASE + 0xFC)
#define REG_PHY2P1_4_P3_7E_H        (REG_PHY2P1_4_P3_BASE + 0xFD)
#define REG_PHY2P1_4_P3_7F_L        (REG_PHY2P1_4_P3_BASE + 0xFE)
#define REG_PHY2P1_4_P3_7F_H        (REG_PHY2P1_4_P3_BASE + 0xFF)

//=============================================================
// PHY_TRAIN_P3
#define REG_PHY_TRAIN_P3_00_L       (REG_PHY_TRAIN_P3_BASE + 0x00)
#define REG_PHY_TRAIN_P3_00_H       (REG_PHY_TRAIN_P3_BASE + 0x01)
#define REG_PHY_TRAIN_P3_01_L       (REG_PHY_TRAIN_P3_BASE + 0x02)
#define REG_PHY_TRAIN_P3_01_H       (REG_PHY_TRAIN_P3_BASE + 0x03)
#define REG_PHY_TRAIN_P3_02_L       (REG_PHY_TRAIN_P3_BASE + 0x04)
#define REG_PHY_TRAIN_P3_02_H       (REG_PHY_TRAIN_P3_BASE + 0x05)
#define REG_PHY_TRAIN_P3_03_L       (REG_PHY_TRAIN_P3_BASE + 0x06)
#define REG_PHY_TRAIN_P3_03_H       (REG_PHY_TRAIN_P3_BASE + 0x07)
#define REG_PHY_TRAIN_P3_04_L       (REG_PHY_TRAIN_P3_BASE + 0x08)
#define REG_PHY_TRAIN_P3_04_H       (REG_PHY_TRAIN_P3_BASE + 0x09)
#define REG_PHY_TRAIN_P3_05_L       (REG_PHY_TRAIN_P3_BASE + 0x0A)
#define REG_PHY_TRAIN_P3_05_H       (REG_PHY_TRAIN_P3_BASE + 0x0B)
#define REG_PHY_TRAIN_P3_06_L       (REG_PHY_TRAIN_P3_BASE + 0x0C)
#define REG_PHY_TRAIN_P3_06_H       (REG_PHY_TRAIN_P3_BASE + 0x0D)
#define REG_PHY_TRAIN_P3_07_L       (REG_PHY_TRAIN_P3_BASE + 0x0E)
#define REG_PHY_TRAIN_P3_07_H       (REG_PHY_TRAIN_P3_BASE + 0x0F)
#define REG_PHY_TRAIN_P3_08_L       (REG_PHY_TRAIN_P3_BASE + 0x10)
#define REG_PHY_TRAIN_P3_08_H       (REG_PHY_TRAIN_P3_BASE + 0x11)
#define REG_PHY_TRAIN_P3_09_L       (REG_PHY_TRAIN_P3_BASE + 0x12)
#define REG_PHY_TRAIN_P3_09_H       (REG_PHY_TRAIN_P3_BASE + 0x13)
#define REG_PHY_TRAIN_P3_0A_L       (REG_PHY_TRAIN_P3_BASE + 0x14)
#define REG_PHY_TRAIN_P3_0A_H       (REG_PHY_TRAIN_P3_BASE + 0x15)
#define REG_PHY_TRAIN_P3_0B_L       (REG_PHY_TRAIN_P3_BASE + 0x16)
#define REG_PHY_TRAIN_P3_0B_H       (REG_PHY_TRAIN_P3_BASE + 0x17)
#define REG_PHY_TRAIN_P3_0C_L       (REG_PHY_TRAIN_P3_BASE + 0x18)
#define REG_PHY_TRAIN_P3_0C_H       (REG_PHY_TRAIN_P3_BASE + 0x19)
#define REG_PHY_TRAIN_P3_0D_L       (REG_PHY_TRAIN_P3_BASE + 0x1A)
#define REG_PHY_TRAIN_P3_0D_H       (REG_PHY_TRAIN_P3_BASE + 0x1B)
#define REG_PHY_TRAIN_P3_0E_L       (REG_PHY_TRAIN_P3_BASE + 0x1C)
#define REG_PHY_TRAIN_P3_0E_H       (REG_PHY_TRAIN_P3_BASE + 0x1D)
#define REG_PHY_TRAIN_P3_0F_L       (REG_PHY_TRAIN_P3_BASE + 0x1E)
#define REG_PHY_TRAIN_P3_0F_H       (REG_PHY_TRAIN_P3_BASE + 0x1F)
#define REG_PHY_TRAIN_P3_10_L       (REG_PHY_TRAIN_P3_BASE + 0x20)
#define REG_PHY_TRAIN_P3_10_H       (REG_PHY_TRAIN_P3_BASE + 0x21)
#define REG_PHY_TRAIN_P3_11_L       (REG_PHY_TRAIN_P3_BASE + 0x22)
#define REG_PHY_TRAIN_P3_11_H       (REG_PHY_TRAIN_P3_BASE + 0x23)
#define REG_PHY_TRAIN_P3_12_L       (REG_PHY_TRAIN_P3_BASE + 0x24)
#define REG_PHY_TRAIN_P3_12_H       (REG_PHY_TRAIN_P3_BASE + 0x25)
#define REG_PHY_TRAIN_P3_13_L       (REG_PHY_TRAIN_P3_BASE + 0x26)
#define REG_PHY_TRAIN_P3_13_H       (REG_PHY_TRAIN_P3_BASE + 0x27)
#define REG_PHY_TRAIN_P3_14_L       (REG_PHY_TRAIN_P3_BASE + 0x28)
#define REG_PHY_TRAIN_P3_14_H       (REG_PHY_TRAIN_P3_BASE + 0x29)
#define REG_PHY_TRAIN_P3_15_L       (REG_PHY_TRAIN_P3_BASE + 0x2A)
#define REG_PHY_TRAIN_P3_15_H       (REG_PHY_TRAIN_P3_BASE + 0x2B)
#define REG_PHY_TRAIN_P3_16_L       (REG_PHY_TRAIN_P3_BASE + 0x2C)
#define REG_PHY_TRAIN_P3_16_H       (REG_PHY_TRAIN_P3_BASE + 0x2D)
#define REG_PHY_TRAIN_P3_17_L       (REG_PHY_TRAIN_P3_BASE + 0x2E)
#define REG_PHY_TRAIN_P3_17_H       (REG_PHY_TRAIN_P3_BASE + 0x2F)
#define REG_PHY_TRAIN_P3_18_L       (REG_PHY_TRAIN_P3_BASE + 0x30)
#define REG_PHY_TRAIN_P3_18_H       (REG_PHY_TRAIN_P3_BASE + 0x31)
#define REG_PHY_TRAIN_P3_19_L       (REG_PHY_TRAIN_P3_BASE + 0x32)
#define REG_PHY_TRAIN_P3_19_H       (REG_PHY_TRAIN_P3_BASE + 0x33)
#define REG_PHY_TRAIN_P3_1A_L       (REG_PHY_TRAIN_P3_BASE + 0x34)
#define REG_PHY_TRAIN_P3_1A_H       (REG_PHY_TRAIN_P3_BASE + 0x35)
#define REG_PHY_TRAIN_P3_1B_L       (REG_PHY_TRAIN_P3_BASE + 0x36)
#define REG_PHY_TRAIN_P3_1B_H       (REG_PHY_TRAIN_P3_BASE + 0x37)
#define REG_PHY_TRAIN_P3_1C_L       (REG_PHY_TRAIN_P3_BASE + 0x38)
#define REG_PHY_TRAIN_P3_1C_H       (REG_PHY_TRAIN_P3_BASE + 0x39)
#define REG_PHY_TRAIN_P3_1D_L       (REG_PHY_TRAIN_P3_BASE + 0x3A)
#define REG_PHY_TRAIN_P3_1D_H       (REG_PHY_TRAIN_P3_BASE + 0x3B)
#define REG_PHY_TRAIN_P3_1E_L       (REG_PHY_TRAIN_P3_BASE + 0x3C)
#define REG_PHY_TRAIN_P3_1E_H       (REG_PHY_TRAIN_P3_BASE + 0x3D)
#define REG_PHY_TRAIN_P3_1F_L       (REG_PHY_TRAIN_P3_BASE + 0x3E)
#define REG_PHY_TRAIN_P3_1F_H       (REG_PHY_TRAIN_P3_BASE + 0x3F)
#define REG_PHY_TRAIN_P3_20_L       (REG_PHY_TRAIN_P3_BASE + 0x40)
#define REG_PHY_TRAIN_P3_20_H       (REG_PHY_TRAIN_P3_BASE + 0x41)
#define REG_PHY_TRAIN_P3_21_L       (REG_PHY_TRAIN_P3_BASE + 0x42)
#define REG_PHY_TRAIN_P3_21_H       (REG_PHY_TRAIN_P3_BASE + 0x43)
#define REG_PHY_TRAIN_P3_22_L       (REG_PHY_TRAIN_P3_BASE + 0x44)
#define REG_PHY_TRAIN_P3_22_H       (REG_PHY_TRAIN_P3_BASE + 0x45)
#define REG_PHY_TRAIN_P3_23_L       (REG_PHY_TRAIN_P3_BASE + 0x46)
#define REG_PHY_TRAIN_P3_23_H       (REG_PHY_TRAIN_P3_BASE + 0x47)
#define REG_PHY_TRAIN_P3_24_L       (REG_PHY_TRAIN_P3_BASE + 0x48)
#define REG_PHY_TRAIN_P3_24_H       (REG_PHY_TRAIN_P3_BASE + 0x49)
#define REG_PHY_TRAIN_P3_25_L       (REG_PHY_TRAIN_P3_BASE + 0x4A)
#define REG_PHY_TRAIN_P3_25_H       (REG_PHY_TRAIN_P3_BASE + 0x4B)
#define REG_PHY_TRAIN_P3_26_L       (REG_PHY_TRAIN_P3_BASE + 0x4C)
#define REG_PHY_TRAIN_P3_26_H       (REG_PHY_TRAIN_P3_BASE + 0x4D)
#define REG_PHY_TRAIN_P3_27_L       (REG_PHY_TRAIN_P3_BASE + 0x4E)
#define REG_PHY_TRAIN_P3_27_H       (REG_PHY_TRAIN_P3_BASE + 0x4F)
#define REG_PHY_TRAIN_P3_28_L       (REG_PHY_TRAIN_P3_BASE + 0x50)
#define REG_PHY_TRAIN_P3_28_H       (REG_PHY_TRAIN_P3_BASE + 0x51)
#define REG_PHY_TRAIN_P3_29_L       (REG_PHY_TRAIN_P3_BASE + 0x52)
#define REG_PHY_TRAIN_P3_29_H       (REG_PHY_TRAIN_P3_BASE + 0x53)
#define REG_PHY_TRAIN_P3_2A_L       (REG_PHY_TRAIN_P3_BASE + 0x54)
#define REG_PHY_TRAIN_P3_2A_H       (REG_PHY_TRAIN_P3_BASE + 0x55)
#define REG_PHY_TRAIN_P3_2B_L       (REG_PHY_TRAIN_P3_BASE + 0x56)
#define REG_PHY_TRAIN_P3_2B_H       (REG_PHY_TRAIN_P3_BASE + 0x57)
#define REG_PHY_TRAIN_P3_2C_L       (REG_PHY_TRAIN_P3_BASE + 0x58)
#define REG_PHY_TRAIN_P3_2C_H       (REG_PHY_TRAIN_P3_BASE + 0x59)
#define REG_PHY_TRAIN_P3_2D_L       (REG_PHY_TRAIN_P3_BASE + 0x5A)
#define REG_PHY_TRAIN_P3_2D_H       (REG_PHY_TRAIN_P3_BASE + 0x5B)
#define REG_PHY_TRAIN_P3_2E_L       (REG_PHY_TRAIN_P3_BASE + 0x5C)
#define REG_PHY_TRAIN_P3_2E_H       (REG_PHY_TRAIN_P3_BASE + 0x5D)
#define REG_PHY_TRAIN_P3_2F_L       (REG_PHY_TRAIN_P3_BASE + 0x5E)
#define REG_PHY_TRAIN_P3_2F_H       (REG_PHY_TRAIN_P3_BASE + 0x5F)
#define REG_PHY_TRAIN_P3_30_L       (REG_PHY_TRAIN_P3_BASE + 0x60)
#define REG_PHY_TRAIN_P3_30_H       (REG_PHY_TRAIN_P3_BASE + 0x61)
#define REG_PHY_TRAIN_P3_31_L       (REG_PHY_TRAIN_P3_BASE + 0x62)
#define REG_PHY_TRAIN_P3_31_H       (REG_PHY_TRAIN_P3_BASE + 0x63)
#define REG_PHY_TRAIN_P3_32_L       (REG_PHY_TRAIN_P3_BASE + 0x64)
#define REG_PHY_TRAIN_P3_32_H       (REG_PHY_TRAIN_P3_BASE + 0x65)
#define REG_PHY_TRAIN_P3_33_L       (REG_PHY_TRAIN_P3_BASE + 0x66)
#define REG_PHY_TRAIN_P3_33_H       (REG_PHY_TRAIN_P3_BASE + 0x67)
#define REG_PHY_TRAIN_P3_34_L       (REG_PHY_TRAIN_P3_BASE + 0x68)
#define REG_PHY_TRAIN_P3_34_H       (REG_PHY_TRAIN_P3_BASE + 0x69)
#define REG_PHY_TRAIN_P3_35_L       (REG_PHY_TRAIN_P3_BASE + 0x6A)
#define REG_PHY_TRAIN_P3_35_H       (REG_PHY_TRAIN_P3_BASE + 0x6B)
#define REG_PHY_TRAIN_P3_36_L       (REG_PHY_TRAIN_P3_BASE + 0x6C)
#define REG_PHY_TRAIN_P3_36_H       (REG_PHY_TRAIN_P3_BASE + 0x6D)
#define REG_PHY_TRAIN_P3_37_L       (REG_PHY_TRAIN_P3_BASE + 0x6E)
#define REG_PHY_TRAIN_P3_37_H       (REG_PHY_TRAIN_P3_BASE + 0x6F)
#define REG_PHY_TRAIN_P3_38_L       (REG_PHY_TRAIN_P3_BASE + 0x70)
#define REG_PHY_TRAIN_P3_38_H       (REG_PHY_TRAIN_P3_BASE + 0x71)
#define REG_PHY_TRAIN_P3_39_L       (REG_PHY_TRAIN_P3_BASE + 0x72)
#define REG_PHY_TRAIN_P3_39_H       (REG_PHY_TRAIN_P3_BASE + 0x73)
#define REG_PHY_TRAIN_P3_3A_L       (REG_PHY_TRAIN_P3_BASE + 0x74)
#define REG_PHY_TRAIN_P3_3A_H       (REG_PHY_TRAIN_P3_BASE + 0x75)
#define REG_PHY_TRAIN_P3_3B_L       (REG_PHY_TRAIN_P3_BASE + 0x76)
#define REG_PHY_TRAIN_P3_3B_H       (REG_PHY_TRAIN_P3_BASE + 0x77)
#define REG_PHY_TRAIN_P3_3C_L       (REG_PHY_TRAIN_P3_BASE + 0x78)
#define REG_PHY_TRAIN_P3_3C_H       (REG_PHY_TRAIN_P3_BASE + 0x79)
#define REG_PHY_TRAIN_P3_3D_L       (REG_PHY_TRAIN_P3_BASE + 0x7A)
#define REG_PHY_TRAIN_P3_3D_H       (REG_PHY_TRAIN_P3_BASE + 0x7B)
#define REG_PHY_TRAIN_P3_3E_L       (REG_PHY_TRAIN_P3_BASE + 0x7C)
#define REG_PHY_TRAIN_P3_3E_H       (REG_PHY_TRAIN_P3_BASE + 0x7D)
#define REG_PHY_TRAIN_P3_3F_L       (REG_PHY_TRAIN_P3_BASE + 0x7E)
#define REG_PHY_TRAIN_P3_3F_H       (REG_PHY_TRAIN_P3_BASE + 0x7F)
#define REG_PHY2P1_5_P3_40_L       (REG_PHY_TRAIN_P3_BASE + 0x80)
#define REG_PHY2P1_5_P3_40_H       (REG_PHY_TRAIN_P3_BASE + 0x81)
#define REG_PHY2P1_5_P3_41_L       (REG_PHY_TRAIN_P3_BASE + 0x82)
#define REG_PHY2P1_5_P3_41_H       (REG_PHY_TRAIN_P3_BASE + 0x83)
#define REG_PHY2P1_5_P3_42_L       (REG_PHY_TRAIN_P3_BASE + 0x84)
#define REG_PHY2P1_5_P3_42_H       (REG_PHY_TRAIN_P3_BASE + 0x85)
#define REG_PHY2P1_5_P3_43_L       (REG_PHY_TRAIN_P3_BASE + 0x86)
#define REG_PHY2P1_5_P3_43_H       (REG_PHY_TRAIN_P3_BASE + 0x87)
#define REG_PHY2P1_5_P3_44_L       (REG_PHY_TRAIN_P3_BASE + 0x88)
#define REG_PHY2P1_5_P3_44_H       (REG_PHY_TRAIN_P3_BASE + 0x89)
#define REG_PHY2P1_5_P3_45_L       (REG_PHY_TRAIN_P3_BASE + 0x8A)
#define REG_PHY2P1_5_P3_45_H       (REG_PHY_TRAIN_P3_BASE + 0x8B)
#define REG_PHY2P1_5_P3_46_L       (REG_PHY_TRAIN_P3_BASE + 0x8C)
#define REG_PHY2P1_5_P3_46_H       (REG_PHY_TRAIN_P3_BASE + 0x8D)
#define REG_PHY2P1_5_P3_47_L       (REG_PHY_TRAIN_P3_BASE + 0x8E)
#define REG_PHY2P1_5_P3_47_H       (REG_PHY_TRAIN_P3_BASE + 0x8F)
#define REG_PHY2P1_5_P3_48_L       (REG_PHY_TRAIN_P3_BASE + 0x90)
#define REG_PHY2P1_5_P3_48_H       (REG_PHY_TRAIN_P3_BASE + 0x91)
#define REG_PHY2P1_5_P3_49_L       (REG_PHY_TRAIN_P3_BASE + 0x92)
#define REG_PHY2P1_5_P3_49_H       (REG_PHY_TRAIN_P3_BASE + 0x93)
#define REG_PHY2P1_5_P3_4A_L       (REG_PHY_TRAIN_P3_BASE + 0x94)
#define REG_PHY2P1_5_P3_4A_H       (REG_PHY_TRAIN_P3_BASE + 0x95)
#define REG_PHY2P1_5_P3_4B_L       (REG_PHY_TRAIN_P3_BASE + 0x96)
#define REG_PHY2P1_5_P3_4B_H       (REG_PHY_TRAIN_P3_BASE + 0x97)
#define REG_PHY2P1_5_P3_4C_L       (REG_PHY_TRAIN_P3_BASE + 0x98)
#define REG_PHY2P1_5_P3_4C_H       (REG_PHY_TRAIN_P3_BASE + 0x99)
#define REG_PHY2P1_5_P3_4D_L       (REG_PHY_TRAIN_P3_BASE + 0x9A)
#define REG_PHY2P1_5_P3_4D_H       (REG_PHY_TRAIN_P3_BASE + 0x9B)
#define REG_PHY2P1_5_P3_4E_L       (REG_PHY_TRAIN_P3_BASE + 0x9C)
#define REG_PHY2P1_5_P3_4E_H       (REG_PHY_TRAIN_P3_BASE + 0x9D)
#define REG_PHY2P1_5_P3_4F_L       (REG_PHY_TRAIN_P3_BASE + 0x9E)
#define REG_PHY2P1_5_P3_4F_H       (REG_PHY_TRAIN_P3_BASE + 0x9F)
#define REG_PHY2P1_5_P3_50_L       (REG_PHY_TRAIN_P3_BASE + 0xA0)
#define REG_PHY2P1_5_P3_50_H       (REG_PHY_TRAIN_P3_BASE + 0xA1)
#define REG_PHY2P1_5_P3_51_L       (REG_PHY_TRAIN_P3_BASE + 0xA2)
#define REG_PHY2P1_5_P3_51_H       (REG_PHY_TRAIN_P3_BASE + 0xA3)
#define REG_PHY2P1_5_P3_52_L       (REG_PHY_TRAIN_P3_BASE + 0xA4)
#define REG_PHY2P1_5_P3_52_H       (REG_PHY_TRAIN_P3_BASE + 0xA5)
#define REG_PHY2P1_5_P3_53_L       (REG_PHY_TRAIN_P3_BASE + 0xA6)
#define REG_PHY2P1_5_P3_53_H       (REG_PHY_TRAIN_P3_BASE + 0xA7)
#define REG_PHY2P1_5_P3_54_L       (REG_PHY_TRAIN_P3_BASE + 0xA8)
#define REG_PHY2P1_5_P3_54_H       (REG_PHY_TRAIN_P3_BASE + 0xA9)
#define REG_PHY2P1_5_P3_55_L       (REG_PHY_TRAIN_P3_BASE + 0xAA)
#define REG_PHY2P1_5_P3_55_H       (REG_PHY_TRAIN_P3_BASE + 0xAB)
#define REG_PHY2P1_5_P3_56_L       (REG_PHY_TRAIN_P3_BASE + 0xAC)
#define REG_PHY2P1_5_P3_56_H       (REG_PHY_TRAIN_P3_BASE + 0xAD)
#define REG_PHY2P1_5_P3_57_L       (REG_PHY_TRAIN_P3_BASE + 0xAE)
#define REG_PHY2P1_5_P3_57_H       (REG_PHY_TRAIN_P3_BASE + 0xAF)
#define REG_PHY2P1_5_P3_58_L       (REG_PHY_TRAIN_P3_BASE + 0xB0)
#define REG_PHY2P1_5_P3_58_H       (REG_PHY_TRAIN_P3_BASE + 0xB1)
#define REG_PHY2P1_5_P3_59_L       (REG_PHY_TRAIN_P3_BASE + 0xB2)
#define REG_PHY2P1_5_P3_59_H       (REG_PHY_TRAIN_P3_BASE + 0xB3)
#define REG_PHY2P1_5_P3_5A_L       (REG_PHY_TRAIN_P3_BASE + 0xB4)
#define REG_PHY2P1_5_P3_5A_H       (REG_PHY_TRAIN_P3_BASE + 0xB5)
#define REG_PHY2P1_5_P3_5B_L       (REG_PHY_TRAIN_P3_BASE + 0xB6)
#define REG_PHY2P1_5_P3_5B_H       (REG_PHY_TRAIN_P3_BASE + 0xB7)
#define REG_PHY2P1_5_P3_5C_L       (REG_PHY_TRAIN_P3_BASE + 0xB8)
#define REG_PHY2P1_5_P3_5C_H       (REG_PHY_TRAIN_P3_BASE + 0xB9)
#define REG_PHY2P1_5_P3_5D_L       (REG_PHY_TRAIN_P3_BASE + 0xBA)
#define REG_PHY2P1_5_P3_5D_H       (REG_PHY_TRAIN_P3_BASE + 0xBB)
#define REG_PHY2P1_5_P3_5E_L       (REG_PHY_TRAIN_P3_BASE + 0xBC)
#define REG_PHY2P1_5_P3_5E_H       (REG_PHY_TRAIN_P3_BASE + 0xBD)
#define REG_PHY2P1_5_P3_5F_L       (REG_PHY_TRAIN_P3_BASE + 0xBE)
#define REG_PHY2P1_5_P3_5F_H       (REG_PHY_TRAIN_P3_BASE + 0xBF)
#define REG_PHY_TRAIN_P3_60_L       (REG_PHY_TRAIN_P3_BASE + 0xC0)
#define REG_PHY_TRAIN_P3_60_H       (REG_PHY_TRAIN_P3_BASE + 0xC1)
#define REG_PHY_TRAIN_P3_61_L       (REG_PHY_TRAIN_P3_BASE + 0xC2)
#define REG_PHY_TRAIN_P3_61_H       (REG_PHY_TRAIN_P3_BASE + 0xC3)
#define REG_PHY_TRAIN_P3_62_L       (REG_PHY_TRAIN_P3_BASE + 0xC4)
#define REG_PHY_TRAIN_P3_62_H       (REG_PHY_TRAIN_P3_BASE + 0xC5)
#define REG_PHY_TRAIN_P3_63_L       (REG_PHY_TRAIN_P3_BASE + 0xC6)
#define REG_PHY_TRAIN_P3_63_H       (REG_PHY_TRAIN_P3_BASE + 0xC7)
#define REG_PHY_TRAIN_P3_64_L       (REG_PHY_TRAIN_P3_BASE + 0xC8)
#define REG_PHY_TRAIN_P3_64_H       (REG_PHY_TRAIN_P3_BASE + 0xC9)
#define REG_PHY_TRAIN_P3_65_L       (REG_PHY_TRAIN_P3_BASE + 0xCA)
#define REG_PHY_TRAIN_P3_65_H       (REG_PHY_TRAIN_P3_BASE + 0xCB)
#define REG_PHY_TRAIN_P3_66_L       (REG_PHY_TRAIN_P3_BASE + 0xCC)
#define REG_PHY_TRAIN_P3_66_H       (REG_PHY_TRAIN_P3_BASE + 0xCD)
#define REG_PHY_TRAIN_P3_67_L       (REG_PHY_TRAIN_P3_BASE + 0xCE)
#define REG_PHY_TRAIN_P3_67_H       (REG_PHY_TRAIN_P3_BASE + 0xCF)
#define REG_PHY_TRAIN_P3_68_L       (REG_PHY_TRAIN_P3_BASE + 0xD0)
#define REG_PHY_TRAIN_P3_68_H       (REG_PHY_TRAIN_P3_BASE + 0xD1)
#define REG_PHY_TRAIN_P3_69_L       (REG_PHY_TRAIN_P3_BASE + 0xD2)
#define REG_PHY_TRAIN_P3_69_H       (REG_PHY_TRAIN_P3_BASE + 0xD3)
#define REG_PHY_TRAIN_P3_6A_L       (REG_PHY_TRAIN_P3_BASE + 0xD4)
#define REG_PHY_TRAIN_P3_6A_H       (REG_PHY_TRAIN_P3_BASE + 0xD5)
#define REG_PHY_TRAIN_P3_6B_L       (REG_PHY_TRAIN_P3_BASE + 0xD6)
#define REG_PHY_TRAIN_P3_6B_H       (REG_PHY_TRAIN_P3_BASE + 0xD7)
#define REG_PHY_TRAIN_P3_6C_L       (REG_PHY_TRAIN_P3_BASE + 0xD8)
#define REG_PHY_TRAIN_P3_6C_H       (REG_PHY_TRAIN_P3_BASE + 0xD9)
#define REG_PHY_TRAIN_P3_6D_L       (REG_PHY_TRAIN_P3_BASE + 0xDA)
#define REG_PHY_TRAIN_P3_6D_H       (REG_PHY_TRAIN_P3_BASE + 0xDB)
#define REG_PHY_TRAIN_P3_6E_L       (REG_PHY_TRAIN_P3_BASE + 0xDC)
#define REG_PHY_TRAIN_P3_6E_H       (REG_PHY_TRAIN_P3_BASE + 0xDD)
#define REG_PHY_TRAIN_P3_6F_L       (REG_PHY_TRAIN_P3_BASE + 0xDE)
#define REG_PHY_TRAIN_P3_6F_H       (REG_PHY_TRAIN_P3_BASE + 0xDF)
#define REG_PHY_TRAIN_P3_70_L       (REG_PHY_TRAIN_P3_BASE + 0xE0)
#define REG_PHY_TRAIN_P3_70_H       (REG_PHY_TRAIN_P3_BASE + 0xE1)
#define REG_PHY_TRAIN_P3_71_L       (REG_PHY_TRAIN_P3_BASE + 0xE2)
#define REG_PHY_TRAIN_P3_71_H       (REG_PHY_TRAIN_P3_BASE + 0xE3)
#define REG_PHY_TRAIN_P3_72_L       (REG_PHY_TRAIN_P3_BASE + 0xE4)
#define REG_PHY_TRAIN_P3_72_H       (REG_PHY_TRAIN_P3_BASE + 0xE5)
#define REG_PHY_TRAIN_P3_73_L       (REG_PHY_TRAIN_P3_BASE + 0xE6)
#define REG_PHY_TRAIN_P3_73_H       (REG_PHY_TRAIN_P3_BASE + 0xE7)
#define REG_PHY_TRAIN_P3_74_L       (REG_PHY_TRAIN_P3_BASE + 0xE8)
#define REG_PHY_TRAIN_P3_74_H       (REG_PHY_TRAIN_P3_BASE + 0xE9)
#define REG_PHY_TRAIN_P3_75_L       (REG_PHY_TRAIN_P3_BASE + 0xEA)
#define REG_PHY_TRAIN_P3_75_H       (REG_PHY_TRAIN_P3_BASE + 0xEB)
#define REG_PHY_TRAIN_P3_76_L       (REG_PHY_TRAIN_P3_BASE + 0xEC)
#define REG_PHY_TRAIN_P3_76_H       (REG_PHY_TRAIN_P3_BASE + 0xED)
#define REG_PHY_TRAIN_P3_77_L       (REG_PHY_TRAIN_P3_BASE + 0xEE)
#define REG_PHY_TRAIN_P3_77_H       (REG_PHY_TRAIN_P3_BASE + 0xEF)
#define REG_PHY_TRAIN_P3_78_L       (REG_PHY_TRAIN_P3_BASE + 0xF0)
#define REG_PHY_TRAIN_P3_78_H       (REG_PHY_TRAIN_P3_BASE + 0xF1)
#define REG_PHY_TRAIN_P3_79_L       (REG_PHY_TRAIN_P3_BASE + 0xF2)
#define REG_PHY_TRAIN_P3_79_H       (REG_PHY_TRAIN_P3_BASE + 0xF3)
#define REG_PHY_TRAIN_P3_7A_L       (REG_PHY_TRAIN_P3_BASE + 0xF4)
#define REG_PHY_TRAIN_P3_7A_H       (REG_PHY_TRAIN_P3_BASE + 0xF5)
#define REG_PHY_TRAIN_P3_7B_L       (REG_PHY_TRAIN_P3_BASE + 0xF6)
#define REG_PHY_TRAIN_P3_7B_H       (REG_PHY_TRAIN_P3_BASE + 0xF7)
#define REG_PHY_TRAIN_P3_7C_L       (REG_PHY_TRAIN_P3_BASE + 0xF8)
#define REG_PHY_TRAIN_P3_7C_H       (REG_PHY_TRAIN_P3_BASE + 0xF9)
#define REG_PHY_TRAIN_P3_7D_L       (REG_PHY_TRAIN_P3_BASE + 0xFA)
#define REG_PHY_TRAIN_P3_7D_H       (REG_PHY_TRAIN_P3_BASE + 0xFB)
#define REG_PHY_TRAIN_P3_7E_L       (REG_PHY_TRAIN_P3_BASE + 0xFC)
#define REG_PHY_TRAIN_P3_7E_H       (REG_PHY_TRAIN_P3_BASE + 0xFD)
#define REG_PHY_TRAIN_P3_7F_L       (REG_PHY_TRAIN_P3_BASE + 0xFE)
#define REG_PHY_TRAIN_P3_7F_H       (REG_PHY_TRAIN_P3_BASE + 0xFF)

//=============================================================
// EARC_TX
#define REG_EARC_TX_00_L            (REG_EARC_TX_BASE + 0x00)
#define REG_EARC_TX_00_H            (REG_EARC_TX_BASE + 0x01)
#define REG_EARC_TX_01_L            (REG_EARC_TX_BASE + 0x02)
#define REG_EARC_TX_01_H            (REG_EARC_TX_BASE + 0x03)
#define REG_EARC_TX_02_L            (REG_EARC_TX_BASE + 0x04)
#define REG_EARC_TX_02_H            (REG_EARC_TX_BASE + 0x05)
#define REG_EARC_TX_03_L            (REG_EARC_TX_BASE + 0x06)
#define REG_EARC_TX_03_H            (REG_EARC_TX_BASE + 0x07)
#define REG_EARC_TX_04_L            (REG_EARC_TX_BASE + 0x08)
#define REG_EARC_TX_04_H            (REG_EARC_TX_BASE + 0x09)
#define REG_EARC_TX_05_L            (REG_EARC_TX_BASE + 0x0A)
#define REG_EARC_TX_05_H            (REG_EARC_TX_BASE + 0x0B)
#define REG_EARC_TX_06_L            (REG_EARC_TX_BASE + 0x0C)
#define REG_EARC_TX_06_H            (REG_EARC_TX_BASE + 0x0D)
#define REG_EARC_TX_07_L            (REG_EARC_TX_BASE + 0x0E)
#define REG_EARC_TX_07_H            (REG_EARC_TX_BASE + 0x0F)
#define REG_EARC_TX_08_L            (REG_EARC_TX_BASE + 0x10)
#define REG_EARC_TX_08_H            (REG_EARC_TX_BASE + 0x11)
#define REG_EARC_TX_09_L            (REG_EARC_TX_BASE + 0x12)
#define REG_EARC_TX_09_H            (REG_EARC_TX_BASE + 0x13)
#define REG_EARC_TX_0A_L            (REG_EARC_TX_BASE + 0x14)
#define REG_EARC_TX_0A_H            (REG_EARC_TX_BASE + 0x15)
#define REG_EARC_TX_0B_L            (REG_EARC_TX_BASE + 0x16)
#define REG_EARC_TX_0B_H            (REG_EARC_TX_BASE + 0x17)
#define REG_EARC_TX_0C_L            (REG_EARC_TX_BASE + 0x18)
#define REG_EARC_TX_0C_H            (REG_EARC_TX_BASE + 0x19)
#define REG_EARC_TX_0D_L            (REG_EARC_TX_BASE + 0x1A)
#define REG_EARC_TX_0D_H            (REG_EARC_TX_BASE + 0x1B)
#define REG_EARC_TX_0E_L            (REG_EARC_TX_BASE + 0x1C)
#define REG_EARC_TX_0E_H            (REG_EARC_TX_BASE + 0x1D)
#define REG_EARC_TX_0F_L            (REG_EARC_TX_BASE + 0x1E)
#define REG_EARC_TX_0F_H            (REG_EARC_TX_BASE + 0x1F)
#define REG_EARC_TX_10_L            (REG_EARC_TX_BASE + 0x20)
#define REG_EARC_TX_10_H            (REG_EARC_TX_BASE + 0x21)
#define REG_EARC_TX_11_L            (REG_EARC_TX_BASE + 0x22)
#define REG_EARC_TX_11_H            (REG_EARC_TX_BASE + 0x23)
#define REG_EARC_TX_12_L            (REG_EARC_TX_BASE + 0x24)
#define REG_EARC_TX_12_H            (REG_EARC_TX_BASE + 0x25)
#define REG_EARC_TX_13_L            (REG_EARC_TX_BASE + 0x26)
#define REG_EARC_TX_13_H            (REG_EARC_TX_BASE + 0x27)
#define REG_EARC_TX_14_L            (REG_EARC_TX_BASE + 0x28)
#define REG_EARC_TX_14_H            (REG_EARC_TX_BASE + 0x29)
#define REG_EARC_TX_15_L            (REG_EARC_TX_BASE + 0x2A)
#define REG_EARC_TX_15_H            (REG_EARC_TX_BASE + 0x2B)
#define REG_EARC_TX_16_L            (REG_EARC_TX_BASE + 0x2C)
#define REG_EARC_TX_16_H            (REG_EARC_TX_BASE + 0x2D)
#define REG_EARC_TX_17_L            (REG_EARC_TX_BASE + 0x2E)
#define REG_EARC_TX_17_H            (REG_EARC_TX_BASE + 0x2F)
#define REG_EARC_TX_18_L            (REG_EARC_TX_BASE + 0x30)
#define REG_EARC_TX_18_H            (REG_EARC_TX_BASE + 0x31)
#define REG_EARC_TX_19_L            (REG_EARC_TX_BASE + 0x32)
#define REG_EARC_TX_19_H            (REG_EARC_TX_BASE + 0x33)
#define REG_EARC_TX_1A_L            (REG_EARC_TX_BASE + 0x34)
#define REG_EARC_TX_1A_H            (REG_EARC_TX_BASE + 0x35)
#define REG_EARC_TX_1B_L            (REG_EARC_TX_BASE + 0x36)
#define REG_EARC_TX_1B_H            (REG_EARC_TX_BASE + 0x37)
#define REG_EARC_TX_1C_L            (REG_EARC_TX_BASE + 0x38)
#define REG_EARC_TX_1C_H            (REG_EARC_TX_BASE + 0x39)
#define REG_EARC_TX_1D_L            (REG_EARC_TX_BASE + 0x3A)
#define REG_EARC_TX_1D_H            (REG_EARC_TX_BASE + 0x3B)
#define REG_EARC_TX_1E_L            (REG_EARC_TX_BASE + 0x3C)
#define REG_EARC_TX_1E_H            (REG_EARC_TX_BASE + 0x3D)
#define REG_EARC_TX_1F_L            (REG_EARC_TX_BASE + 0x3E)
#define REG_EARC_TX_1F_H            (REG_EARC_TX_BASE + 0x3F)
#define REG_EARC_TX_20_L            (REG_EARC_TX_BASE + 0x40)
#define REG_EARC_TX_20_H            (REG_EARC_TX_BASE + 0x41)
#define REG_EARC_TX_21_L            (REG_EARC_TX_BASE + 0x42)
#define REG_EARC_TX_21_H            (REG_EARC_TX_BASE + 0x43)
#define REG_EARC_TX_22_L            (REG_EARC_TX_BASE + 0x44)
#define REG_EARC_TX_22_H            (REG_EARC_TX_BASE + 0x45)
#define REG_EARC_TX_23_L            (REG_EARC_TX_BASE + 0x46)
#define REG_EARC_TX_23_H            (REG_EARC_TX_BASE + 0x47)
#define REG_EARC_TX_24_L            (REG_EARC_TX_BASE + 0x48)
#define REG_EARC_TX_24_H            (REG_EARC_TX_BASE + 0x49)
#define REG_EARC_TX_25_L            (REG_EARC_TX_BASE + 0x4A)
#define REG_EARC_TX_25_H            (REG_EARC_TX_BASE + 0x4B)
#define REG_EARC_TX_26_L            (REG_EARC_TX_BASE + 0x4C)
#define REG_EARC_TX_26_H            (REG_EARC_TX_BASE + 0x4D)
#define REG_EARC_TX_27_L            (REG_EARC_TX_BASE + 0x4E)
#define REG_EARC_TX_27_H            (REG_EARC_TX_BASE + 0x4F)
#define REG_EARC_TX_28_L            (REG_EARC_TX_BASE + 0x50)
#define REG_EARC_TX_28_H            (REG_EARC_TX_BASE + 0x51)
#define REG_EARC_TX_29_L            (REG_EARC_TX_BASE + 0x52)
#define REG_EARC_TX_29_H            (REG_EARC_TX_BASE + 0x53)
#define REG_EARC_TX_2A_L            (REG_EARC_TX_BASE + 0x54)
#define REG_EARC_TX_2A_H            (REG_EARC_TX_BASE + 0x55)
#define REG_EARC_TX_2B_L            (REG_EARC_TX_BASE + 0x56)
#define REG_EARC_TX_2B_H            (REG_EARC_TX_BASE + 0x57)
#define REG_EARC_TX_2C_L            (REG_EARC_TX_BASE + 0x58)
#define REG_EARC_TX_2C_H            (REG_EARC_TX_BASE + 0x59)
#define REG_EARC_TX_2D_L            (REG_EARC_TX_BASE + 0x5A)
#define REG_EARC_TX_2D_H            (REG_EARC_TX_BASE + 0x5B)
#define REG_EARC_TX_2E_L            (REG_EARC_TX_BASE + 0x5C)
#define REG_EARC_TX_2E_H            (REG_EARC_TX_BASE + 0x5D)
#define REG_EARC_TX_2F_L            (REG_EARC_TX_BASE + 0x5E)
#define REG_EARC_TX_2F_H            (REG_EARC_TX_BASE + 0x5F)
#define REG_EARC_TX_30_L            (REG_EARC_TX_BASE + 0x60)
#define REG_EARC_TX_30_H            (REG_EARC_TX_BASE + 0x61)
#define REG_EARC_TX_31_L            (REG_EARC_TX_BASE + 0x62)
#define REG_EARC_TX_31_H            (REG_EARC_TX_BASE + 0x63)
#define REG_EARC_TX_32_L            (REG_EARC_TX_BASE + 0x64)
#define REG_EARC_TX_32_H            (REG_EARC_TX_BASE + 0x65)
#define REG_EARC_TX_33_L            (REG_EARC_TX_BASE + 0x66)
#define REG_EARC_TX_33_H            (REG_EARC_TX_BASE + 0x67)
#define REG_EARC_TX_34_L            (REG_EARC_TX_BASE + 0x68)
#define REG_EARC_TX_34_H            (REG_EARC_TX_BASE + 0x69)
#define REG_EARC_TX_35_L            (REG_EARC_TX_BASE + 0x6A)
#define REG_EARC_TX_35_H            (REG_EARC_TX_BASE + 0x6B)
#define REG_EARC_TX_36_L            (REG_EARC_TX_BASE + 0x6C)
#define REG_EARC_TX_36_H            (REG_EARC_TX_BASE + 0x6D)
#define REG_EARC_TX_37_L            (REG_EARC_TX_BASE + 0x6E)
#define REG_EARC_TX_37_H            (REG_EARC_TX_BASE + 0x6F)
#define REG_EARC_TX_38_L            (REG_EARC_TX_BASE + 0x70)
#define REG_EARC_TX_38_H            (REG_EARC_TX_BASE + 0x71)
#define REG_EARC_TX_39_L            (REG_EARC_TX_BASE + 0x72)
#define REG_EARC_TX_39_H            (REG_EARC_TX_BASE + 0x73)
#define REG_EARC_TX_3A_L            (REG_EARC_TX_BASE + 0x74)
#define REG_EARC_TX_3A_H            (REG_EARC_TX_BASE + 0x75)
#define REG_EARC_TX_3B_L            (REG_EARC_TX_BASE + 0x76)
#define REG_EARC_TX_3B_H            (REG_EARC_TX_BASE + 0x77)
#define REG_EARC_TX_3C_L            (REG_EARC_TX_BASE + 0x78)
#define REG_EARC_TX_3C_H            (REG_EARC_TX_BASE + 0x79)
#define REG_EARC_TX_3D_L            (REG_EARC_TX_BASE + 0x7A)
#define REG_EARC_TX_3D_H            (REG_EARC_TX_BASE + 0x7B)
#define REG_EARC_TX_3E_L            (REG_EARC_TX_BASE + 0x7C)
#define REG_EARC_TX_3E_H            (REG_EARC_TX_BASE + 0x7D)
#define REG_EARC_TX_3F_L            (REG_EARC_TX_BASE + 0x7E)
#define REG_EARC_TX_3F_H            (REG_EARC_TX_BASE + 0x7F)
#define REG_EARC_TX_40_L            (REG_EARC_TX_BASE + 0x80)
#define REG_EARC_TX_40_H            (REG_EARC_TX_BASE + 0x81)
#define REG_EARC_TX_41_L            (REG_EARC_TX_BASE + 0x82)
#define REG_EARC_TX_41_H            (REG_EARC_TX_BASE + 0x83)
#define REG_EARC_TX_42_L            (REG_EARC_TX_BASE + 0x84)
#define REG_EARC_TX_42_H            (REG_EARC_TX_BASE + 0x85)
#define REG_EARC_TX_43_L            (REG_EARC_TX_BASE + 0x86)
#define REG_EARC_TX_43_H            (REG_EARC_TX_BASE + 0x87)
#define REG_EARC_TX_44_L            (REG_EARC_TX_BASE + 0x88)
#define REG_EARC_TX_44_H            (REG_EARC_TX_BASE + 0x89)
#define REG_EARC_TX_45_L            (REG_EARC_TX_BASE + 0x8A)
#define REG_EARC_TX_45_H            (REG_EARC_TX_BASE + 0x8B)
#define REG_EARC_TX_46_L            (REG_EARC_TX_BASE + 0x8C)
#define REG_EARC_TX_46_H            (REG_EARC_TX_BASE + 0x8D)
#define REG_EARC_TX_47_L            (REG_EARC_TX_BASE + 0x8E)
#define REG_EARC_TX_47_H            (REG_EARC_TX_BASE + 0x8F)
#define REG_EARC_TX_48_L            (REG_EARC_TX_BASE + 0x90)
#define REG_EARC_TX_48_H            (REG_EARC_TX_BASE + 0x91)
#define REG_EARC_TX_49_L            (REG_EARC_TX_BASE + 0x92)
#define REG_EARC_TX_49_H            (REG_EARC_TX_BASE + 0x93)
#define REG_EARC_TX_4A_L            (REG_EARC_TX_BASE + 0x94)
#define REG_EARC_TX_4A_H            (REG_EARC_TX_BASE + 0x95)
#define REG_EARC_TX_4B_L            (REG_EARC_TX_BASE + 0x96)
#define REG_EARC_TX_4B_H            (REG_EARC_TX_BASE + 0x97)
#define REG_EARC_TX_4C_L            (REG_EARC_TX_BASE + 0x98)
#define REG_EARC_TX_4C_H            (REG_EARC_TX_BASE + 0x99)
#define REG_EARC_TX_4D_L            (REG_EARC_TX_BASE + 0x9A)
#define REG_EARC_TX_4D_H            (REG_EARC_TX_BASE + 0x9B)
#define REG_EARC_TX_4E_L            (REG_EARC_TX_BASE + 0x9C)
#define REG_EARC_TX_4E_H            (REG_EARC_TX_BASE + 0x9D)
#define REG_EARC_TX_4F_L            (REG_EARC_TX_BASE + 0x9E)
#define REG_EARC_TX_4F_H            (REG_EARC_TX_BASE + 0x9F)
#define REG_EARC_TX_50_L            (REG_EARC_TX_BASE + 0xA0)
#define REG_EARC_TX_50_H            (REG_EARC_TX_BASE + 0xA1)
#define REG_EARC_TX_51_L            (REG_EARC_TX_BASE + 0xA2)
#define REG_EARC_TX_51_H            (REG_EARC_TX_BASE + 0xA3)
#define REG_EARC_TX_52_L            (REG_EARC_TX_BASE + 0xA4)
#define REG_EARC_TX_52_H            (REG_EARC_TX_BASE + 0xA5)
#define REG_EARC_TX_53_L            (REG_EARC_TX_BASE + 0xA6)
#define REG_EARC_TX_53_H            (REG_EARC_TX_BASE + 0xA7)
#define REG_EARC_TX_54_L            (REG_EARC_TX_BASE + 0xA8)
#define REG_EARC_TX_54_H            (REG_EARC_TX_BASE + 0xA9)
#define REG_EARC_TX_55_L            (REG_EARC_TX_BASE + 0xAA)
#define REG_EARC_TX_55_H            (REG_EARC_TX_BASE + 0xAB)
#define REG_EARC_TX_56_L            (REG_EARC_TX_BASE + 0xAC)
#define REG_EARC_TX_56_H            (REG_EARC_TX_BASE + 0xAD)
#define REG_EARC_TX_57_L            (REG_EARC_TX_BASE + 0xAE)
#define REG_EARC_TX_57_H            (REG_EARC_TX_BASE + 0xAF)
#define REG_EARC_TX_58_L            (REG_EARC_TX_BASE + 0xB0)
#define REG_EARC_TX_58_H            (REG_EARC_TX_BASE + 0xB1)
#define REG_EARC_TX_59_L            (REG_EARC_TX_BASE + 0xB2)
#define REG_EARC_TX_59_H            (REG_EARC_TX_BASE + 0xB3)
#define REG_EARC_TX_5A_L            (REG_EARC_TX_BASE + 0xB4)
#define REG_EARC_TX_5A_H            (REG_EARC_TX_BASE + 0xB5)
#define REG_EARC_TX_5B_L            (REG_EARC_TX_BASE + 0xB6)
#define REG_EARC_TX_5B_H            (REG_EARC_TX_BASE + 0xB7)
#define REG_EARC_TX_5C_L            (REG_EARC_TX_BASE + 0xB8)
#define REG_EARC_TX_5C_H            (REG_EARC_TX_BASE + 0xB9)
#define REG_EARC_TX_5D_L            (REG_EARC_TX_BASE + 0xBA)
#define REG_EARC_TX_5D_H            (REG_EARC_TX_BASE + 0xBB)
#define REG_EARC_TX_5E_L            (REG_EARC_TX_BASE + 0xBC)
#define REG_EARC_TX_5E_H            (REG_EARC_TX_BASE + 0xBD)
#define REG_EARC_TX_5F_L            (REG_EARC_TX_BASE + 0xBE)
#define REG_EARC_TX_5F_H            (REG_EARC_TX_BASE + 0xBF)
#define REG_EARC_TX_60_L            (REG_EARC_TX_BASE + 0xC0)
#define REG_EARC_TX_60_H            (REG_EARC_TX_BASE + 0xC1)
#define REG_EARC_TX_61_L            (REG_EARC_TX_BASE + 0xC2)
#define REG_EARC_TX_61_H            (REG_EARC_TX_BASE + 0xC3)
#define REG_EARC_TX_62_L            (REG_EARC_TX_BASE + 0xC4)
#define REG_EARC_TX_62_H            (REG_EARC_TX_BASE + 0xC5)
#define REG_EARC_TX_63_L            (REG_EARC_TX_BASE + 0xC6)
#define REG_EARC_TX_63_H            (REG_EARC_TX_BASE + 0xC7)
#define REG_EARC_TX_64_L            (REG_EARC_TX_BASE + 0xC8)
#define REG_EARC_TX_64_H            (REG_EARC_TX_BASE + 0xC9)
#define REG_EARC_TX_65_L            (REG_EARC_TX_BASE + 0xCA)
#define REG_EARC_TX_65_H            (REG_EARC_TX_BASE + 0xCB)
#define REG_EARC_TX_66_L            (REG_EARC_TX_BASE + 0xCC)
#define REG_EARC_TX_66_H            (REG_EARC_TX_BASE + 0xCD)
#define REG_EARC_TX_67_L            (REG_EARC_TX_BASE + 0xCE)
#define REG_EARC_TX_67_H            (REG_EARC_TX_BASE + 0xCF)
#define REG_EARC_TX_68_L            (REG_EARC_TX_BASE + 0xD0)
#define REG_EARC_TX_68_H            (REG_EARC_TX_BASE + 0xD1)
#define REG_EARC_TX_69_L            (REG_EARC_TX_BASE + 0xD2)
#define REG_EARC_TX_69_H            (REG_EARC_TX_BASE + 0xD3)
#define REG_EARC_TX_6A_L            (REG_EARC_TX_BASE + 0xD4)
#define REG_EARC_TX_6A_H            (REG_EARC_TX_BASE + 0xD5)
#define REG_EARC_TX_6B_L            (REG_EARC_TX_BASE + 0xD6)
#define REG_EARC_TX_6B_H            (REG_EARC_TX_BASE + 0xD7)
#define REG_EARC_TX_6C_L            (REG_EARC_TX_BASE + 0xD8)
#define REG_EARC_TX_6C_H            (REG_EARC_TX_BASE + 0xD9)
#define REG_EARC_TX_6D_L            (REG_EARC_TX_BASE + 0xDA)
#define REG_EARC_TX_6D_H            (REG_EARC_TX_BASE + 0xDB)
#define REG_EARC_TX_6E_L            (REG_EARC_TX_BASE + 0xDC)
#define REG_EARC_TX_6E_H            (REG_EARC_TX_BASE + 0xDD)
#define REG_EARC_TX_6F_L            (REG_EARC_TX_BASE + 0xDE)
#define REG_EARC_TX_6F_H            (REG_EARC_TX_BASE + 0xDF)
#define REG_EARC_TX_70_L            (REG_EARC_TX_BASE + 0xE0)
#define REG_EARC_TX_70_H            (REG_EARC_TX_BASE + 0xE1)
#define REG_EARC_TX_71_L            (REG_EARC_TX_BASE + 0xE2)
#define REG_EARC_TX_71_H            (REG_EARC_TX_BASE + 0xE3)
#define REG_EARC_TX_72_L            (REG_EARC_TX_BASE + 0xE4)
#define REG_EARC_TX_72_H            (REG_EARC_TX_BASE + 0xE5)
#define REG_EARC_TX_73_L            (REG_EARC_TX_BASE + 0xE6)
#define REG_EARC_TX_73_H            (REG_EARC_TX_BASE + 0xE7)
#define REG_EARC_TX_74_L            (REG_EARC_TX_BASE + 0xE8)
#define REG_EARC_TX_74_H            (REG_EARC_TX_BASE + 0xE9)
#define REG_EARC_TX_75_L            (REG_EARC_TX_BASE + 0xEA)
#define REG_EARC_TX_75_H            (REG_EARC_TX_BASE + 0xEB)
#define REG_EARC_TX_76_L            (REG_EARC_TX_BASE + 0xEC)
#define REG_EARC_TX_76_H            (REG_EARC_TX_BASE + 0xED)
#define REG_EARC_TX_77_L            (REG_EARC_TX_BASE + 0xEE)
#define REG_EARC_TX_77_H            (REG_EARC_TX_BASE + 0xEF)
#define REG_EARC_TX_78_L            (REG_EARC_TX_BASE + 0xF0)
#define REG_EARC_TX_78_H            (REG_EARC_TX_BASE + 0xF1)
#define REG_EARC_TX_79_L            (REG_EARC_TX_BASE + 0xF2)
#define REG_EARC_TX_79_H            (REG_EARC_TX_BASE + 0xF3)
#define REG_EARC_TX_7A_L            (REG_EARC_TX_BASE + 0xF4)
#define REG_EARC_TX_7A_H            (REG_EARC_TX_BASE + 0xF5)
#define REG_EARC_TX_7B_L            (REG_EARC_TX_BASE + 0xF6)
#define REG_EARC_TX_7B_H            (REG_EARC_TX_BASE + 0xF7)
#define REG_EARC_TX_7C_L            (REG_EARC_TX_BASE + 0xF8)
#define REG_EARC_TX_7C_H            (REG_EARC_TX_BASE + 0xF9)
#define REG_EARC_TX_7D_L            (REG_EARC_TX_BASE + 0xFA)
#define REG_EARC_TX_7D_H            (REG_EARC_TX_BASE + 0xFB)
#define REG_EARC_TX_7E_L            (REG_EARC_TX_BASE + 0xFC)
#define REG_EARC_TX_7E_H            (REG_EARC_TX_BASE + 0xFD)
#define REG_EARC_TX_7F_L            (REG_EARC_TX_BASE + 0xFE)
#define REG_EARC_TX_7F_H            (REG_EARC_TX_BASE + 0xFF)

#endif

