//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////
//alex_tung
#ifndef _HWREG_PM_SLEEP_H_
#define _HWREG_PM_SLEEP_H_

//=============================================================
//PM SLEEP
//#define REG_PM_SLEEP_BASE       0x0E00UL
#define REG_PM_SLEEP_00_L       (REG_PM_SLEEP_BASE + 0x00)
#define REG_PM_SLEEP_00_H       (REG_PM_SLEEP_BASE + 0x01)
#define REG_PM_SLEEP_01_L       (REG_PM_SLEEP_BASE + 0x02)
#define REG_PM_SLEEP_01_H       (REG_PM_SLEEP_BASE + 0x03)
#define REG_PM_SLEEP_02_L       (REG_PM_SLEEP_BASE + 0x04)
#define REG_PM_SLEEP_02_H       (REG_PM_SLEEP_BASE + 0x05)
#define REG_PM_SLEEP_03_L       (REG_PM_SLEEP_BASE + 0x06)
#define REG_PM_SLEEP_03_H       (REG_PM_SLEEP_BASE + 0x07)
#define REG_PM_SLEEP_04_L       (REG_PM_SLEEP_BASE + 0x08)
#define REG_PM_SLEEP_04_H       (REG_PM_SLEEP_BASE + 0x09)
#define REG_PM_SLEEP_05_L       (REG_PM_SLEEP_BASE + 0x0A)
#define REG_PM_SLEEP_05_H       (REG_PM_SLEEP_BASE + 0x0B)
#define REG_PM_SLEEP_06_L       (REG_PM_SLEEP_BASE + 0x0C)
#define REG_PM_SLEEP_06_H       (REG_PM_SLEEP_BASE + 0x0D)
#define REG_PM_SLEEP_07_L       (REG_PM_SLEEP_BASE + 0x0E)
#define REG_PM_SLEEP_07_H       (REG_PM_SLEEP_BASE + 0x0F)
#define REG_PM_SLEEP_08_L       (REG_PM_SLEEP_BASE + 0x10)
#define REG_PM_SLEEP_08_H       (REG_PM_SLEEP_BASE + 0x11)
#define REG_PM_SLEEP_09_L       (REG_PM_SLEEP_BASE + 0x12)
#define REG_PM_SLEEP_09_H       (REG_PM_SLEEP_BASE + 0x13)
#define REG_PM_SLEEP_0A_L       (REG_PM_SLEEP_BASE + 0x14)
#define REG_PM_SLEEP_0A_H       (REG_PM_SLEEP_BASE + 0x15)
#define REG_PM_SLEEP_0B_L       (REG_PM_SLEEP_BASE + 0x16)
#define REG_PM_SLEEP_0B_H       (REG_PM_SLEEP_BASE + 0x17)
#define REG_PM_SLEEP_0C_L       (REG_PM_SLEEP_BASE + 0x18)
#define REG_PM_SLEEP_0C_H       (REG_PM_SLEEP_BASE + 0x19)
#define REG_PM_SLEEP_0D_L       (REG_PM_SLEEP_BASE + 0x1A)
#define REG_PM_SLEEP_0D_H       (REG_PM_SLEEP_BASE + 0x1B)
#define REG_PM_SLEEP_0E_L       (REG_PM_SLEEP_BASE + 0x1C)
#define REG_PM_SLEEP_0E_H       (REG_PM_SLEEP_BASE + 0x1D)
#define REG_PM_SLEEP_0F_L       (REG_PM_SLEEP_BASE + 0x1E)
#define REG_PM_SLEEP_0F_H       (REG_PM_SLEEP_BASE + 0x1F)
#define REG_PM_SLEEP_10_L       (REG_PM_SLEEP_BASE + 0x20)
#define REG_PM_SLEEP_10_H       (REG_PM_SLEEP_BASE + 0x21)
#define REG_PM_SLEEP_11_L       (REG_PM_SLEEP_BASE + 0x22)
#define REG_PM_SLEEP_11_H       (REG_PM_SLEEP_BASE + 0x23)
#define REG_PM_SLEEP_12_L       (REG_PM_SLEEP_BASE + 0x24)
#define REG_PM_SLEEP_12_H       (REG_PM_SLEEP_BASE + 0x25)
#define REG_PM_SLEEP_13_L       (REG_PM_SLEEP_BASE + 0x26)
#define REG_PM_SLEEP_13_H       (REG_PM_SLEEP_BASE + 0x27)
#define REG_PM_SLEEP_14_L       (REG_PM_SLEEP_BASE + 0x28)
#define REG_PM_SLEEP_14_H       (REG_PM_SLEEP_BASE + 0x29)
#define REG_PM_SLEEP_15_L       (REG_PM_SLEEP_BASE + 0x2A)
#define REG_PM_SLEEP_15_H       (REG_PM_SLEEP_BASE + 0x2B)
#define REG_PM_SLEEP_16_L       (REG_PM_SLEEP_BASE + 0x2C)
#define REG_PM_SLEEP_16_H       (REG_PM_SLEEP_BASE + 0x2D)
#define REG_PM_SLEEP_17_L       (REG_PM_SLEEP_BASE + 0x2E)
#define REG_PM_SLEEP_17_H       (REG_PM_SLEEP_BASE + 0x2F)
#define REG_PM_SLEEP_18_L       (REG_PM_SLEEP_BASE + 0x30)
#define REG_PM_SLEEP_18_H       (REG_PM_SLEEP_BASE + 0x31)
#define REG_PM_SLEEP_19_L       (REG_PM_SLEEP_BASE + 0x32)
#define REG_PM_SLEEP_19_H       (REG_PM_SLEEP_BASE + 0x33)
#define REG_PM_SLEEP_1A_L       (REG_PM_SLEEP_BASE + 0x34)
#define REG_PM_SLEEP_1A_H       (REG_PM_SLEEP_BASE + 0x35)
#define REG_PM_SLEEP_1B_L       (REG_PM_SLEEP_BASE + 0x36)
#define REG_PM_SLEEP_1B_H       (REG_PM_SLEEP_BASE + 0x37)
#define REG_PM_SLEEP_1C_L       (REG_PM_SLEEP_BASE + 0x38)
#define REG_PM_SLEEP_1C_H       (REG_PM_SLEEP_BASE + 0x39)
#define REG_PM_SLEEP_1D_L       (REG_PM_SLEEP_BASE + 0x3A)
#define REG_PM_SLEEP_1D_H       (REG_PM_SLEEP_BASE + 0x3B)
#define REG_PM_SLEEP_1E_L       (REG_PM_SLEEP_BASE + 0x3C)
#define REG_PM_SLEEP_1E_H       (REG_PM_SLEEP_BASE + 0x3D)
#define REG_PM_SLEEP_1F_L       (REG_PM_SLEEP_BASE + 0x3E)
#define REG_PM_SLEEP_1F_H       (REG_PM_SLEEP_BASE + 0x3F)
#define REG_PM_SLEEP_20_L       (REG_PM_SLEEP_BASE + 0x40)
#define REG_PM_SLEEP_20_H       (REG_PM_SLEEP_BASE + 0x41)
#define REG_PM_SLEEP_21_L       (REG_PM_SLEEP_BASE + 0x42)
#define REG_PM_SLEEP_21_H       (REG_PM_SLEEP_BASE + 0x43)
#define REG_PM_SLEEP_22_L       (REG_PM_SLEEP_BASE + 0x44)
#define REG_PM_SLEEP_22_H       (REG_PM_SLEEP_BASE + 0x45)
#define REG_PM_SLEEP_23_L       (REG_PM_SLEEP_BASE + 0x46)
#define REG_PM_SLEEP_23_H       (REG_PM_SLEEP_BASE + 0x47)
#define REG_PM_SLEEP_24_L       (REG_PM_SLEEP_BASE + 0x48)
#define REG_PM_SLEEP_24_H       (REG_PM_SLEEP_BASE + 0x49)
#define REG_PM_SLEEP_25_L       (REG_PM_SLEEP_BASE + 0x4A)
#define REG_PM_SLEEP_25_H       (REG_PM_SLEEP_BASE + 0x4B)
#define REG_PM_SLEEP_26_L       (REG_PM_SLEEP_BASE + 0x4C)
#define REG_PM_SLEEP_26_H       (REG_PM_SLEEP_BASE + 0x4D)
#define REG_PM_SLEEP_27_L       (REG_PM_SLEEP_BASE + 0x4E)
#define REG_PM_SLEEP_27_H       (REG_PM_SLEEP_BASE + 0x4F)
#define REG_PM_SLEEP_28_L       (REG_PM_SLEEP_BASE + 0x50)
#define REG_PM_SLEEP_28_H       (REG_PM_SLEEP_BASE + 0x51)
#define REG_PM_SLEEP_29_L       (REG_PM_SLEEP_BASE + 0x52)
#define REG_PM_SLEEP_29_H       (REG_PM_SLEEP_BASE + 0x53)
#define REG_PM_SLEEP_2A_L       (REG_PM_SLEEP_BASE + 0x54)
#define REG_PM_SLEEP_2A_H       (REG_PM_SLEEP_BASE + 0x55)
#define REG_PM_SLEEP_2B_L       (REG_PM_SLEEP_BASE + 0x56)
#define REG_PM_SLEEP_2B_H       (REG_PM_SLEEP_BASE + 0x57)
#define REG_PM_SLEEP_2C_L       (REG_PM_SLEEP_BASE + 0x58)
#define REG_PM_SLEEP_2C_H       (REG_PM_SLEEP_BASE + 0x59)
#define REG_PM_SLEEP_2D_L       (REG_PM_SLEEP_BASE + 0x5A)
#define REG_PM_SLEEP_2D_H       (REG_PM_SLEEP_BASE + 0x5B)
#define REG_PM_SLEEP_2E_L       (REG_PM_SLEEP_BASE + 0x5C)
#define REG_PM_SLEEP_2E_H       (REG_PM_SLEEP_BASE + 0x5D)
#define REG_PM_SLEEP_2F_L       (REG_PM_SLEEP_BASE + 0x5E)
#define REG_PM_SLEEP_2F_H       (REG_PM_SLEEP_BASE + 0x5F)
#define REG_PM_SLEEP_30_L       (REG_PM_SLEEP_BASE + 0x60)
#define REG_PM_SLEEP_30_H       (REG_PM_SLEEP_BASE + 0x61)
#define REG_PM_SLEEP_31_L       (REG_PM_SLEEP_BASE + 0x62)
#define REG_PM_SLEEP_31_H       (REG_PM_SLEEP_BASE + 0x63)
#define REG_PM_SLEEP_32_L       (REG_PM_SLEEP_BASE + 0x64)
#define REG_PM_SLEEP_32_H       (REG_PM_SLEEP_BASE + 0x65)
#define REG_PM_SLEEP_33_L       (REG_PM_SLEEP_BASE + 0x66)
#define REG_PM_SLEEP_33_H       (REG_PM_SLEEP_BASE + 0x67)
#define REG_PM_SLEEP_34_L       (REG_PM_SLEEP_BASE + 0x68)
#define REG_PM_SLEEP_34_H       (REG_PM_SLEEP_BASE + 0x69)
#define REG_PM_SLEEP_35_L       (REG_PM_SLEEP_BASE + 0x6A)
#define REG_PM_SLEEP_35_H       (REG_PM_SLEEP_BASE + 0x6B)
#define REG_PM_SLEEP_36_L       (REG_PM_SLEEP_BASE + 0x6C)
#define REG_PM_SLEEP_36_H       (REG_PM_SLEEP_BASE + 0x6D)
#define REG_PM_SLEEP_37_L       (REG_PM_SLEEP_BASE + 0x6E)
#define REG_PM_SLEEP_37_H       (REG_PM_SLEEP_BASE + 0x6F)
#define REG_PM_SLEEP_38_L       (REG_PM_SLEEP_BASE + 0x70)
#define REG_PM_SLEEP_38_H       (REG_PM_SLEEP_BASE + 0x71)
#define REG_PM_SLEEP_39_L       (REG_PM_SLEEP_BASE + 0x72)
#define REG_PM_SLEEP_39_H       (REG_PM_SLEEP_BASE + 0x73)
#define REG_PM_SLEEP_3A_L       (REG_PM_SLEEP_BASE + 0x74)
#define REG_PM_SLEEP_3A_H       (REG_PM_SLEEP_BASE + 0x75)
#define REG_PM_SLEEP_3B_L       (REG_PM_SLEEP_BASE + 0x76)
#define REG_PM_SLEEP_3B_H       (REG_PM_SLEEP_BASE + 0x77)
#define REG_PM_SLEEP_3C_L       (REG_PM_SLEEP_BASE + 0x78)
#define REG_PM_SLEEP_3C_H       (REG_PM_SLEEP_BASE + 0x79)
#define REG_PM_SLEEP_3D_L       (REG_PM_SLEEP_BASE + 0x7A)
#define REG_PM_SLEEP_3D_H       (REG_PM_SLEEP_BASE + 0x7B)
#define REG_PM_SLEEP_3E_L       (REG_PM_SLEEP_BASE + 0x7C)
#define REG_PM_SLEEP_3E_H       (REG_PM_SLEEP_BASE + 0x7D)
#define REG_PM_SLEEP_3F_L       (REG_PM_SLEEP_BASE + 0x7E)
#define REG_PM_SLEEP_3F_H       (REG_PM_SLEEP_BASE + 0x7F)
#define REG_PM_SLEEP_40_L       (REG_PM_SLEEP_BASE + 0x80)
#define REG_PM_SLEEP_40_H       (REG_PM_SLEEP_BASE + 0x81)
#define REG_PM_SLEEP_41_L       (REG_PM_SLEEP_BASE + 0x82)
#define REG_PM_SLEEP_41_H       (REG_PM_SLEEP_BASE + 0x83)
#define REG_PM_SLEEP_42_L       (REG_PM_SLEEP_BASE + 0x84)
#define REG_PM_SLEEP_42_H       (REG_PM_SLEEP_BASE + 0x85)
#define REG_PM_SLEEP_43_L       (REG_PM_SLEEP_BASE + 0x86)
#define REG_PM_SLEEP_43_H       (REG_PM_SLEEP_BASE + 0x87)
#define REG_PM_SLEEP_44_L       (REG_PM_SLEEP_BASE + 0x88)
#define REG_PM_SLEEP_44_H       (REG_PM_SLEEP_BASE + 0x89)
#define REG_PM_SLEEP_45_L       (REG_PM_SLEEP_BASE + 0x8A)
#define REG_PM_SLEEP_45_H       (REG_PM_SLEEP_BASE + 0x8B)
#define REG_PM_SLEEP_46_L       (REG_PM_SLEEP_BASE + 0x8C)
#define REG_PM_SLEEP_46_H       (REG_PM_SLEEP_BASE + 0x8D)
#define REG_PM_SLEEP_47_L       (REG_PM_SLEEP_BASE + 0x8E)
#define REG_PM_SLEEP_47_H       (REG_PM_SLEEP_BASE + 0x8F)
#define REG_PM_SLEEP_48_L       (REG_PM_SLEEP_BASE + 0x90)
#define REG_PM_SLEEP_48_H       (REG_PM_SLEEP_BASE + 0x91)
#define REG_PM_SLEEP_49_L       (REG_PM_SLEEP_BASE + 0x92)
#define REG_PM_SLEEP_49_H       (REG_PM_SLEEP_BASE + 0x93)
#define REG_PM_SLEEP_4A_L       (REG_PM_SLEEP_BASE + 0x94)
#define REG_PM_SLEEP_4A_H       (REG_PM_SLEEP_BASE + 0x95)
#define REG_PM_SLEEP_4B_L       (REG_PM_SLEEP_BASE + 0x96)
#define REG_PM_SLEEP_4B_H       (REG_PM_SLEEP_BASE + 0x97)
#define REG_PM_SLEEP_4C_L       (REG_PM_SLEEP_BASE + 0x98)
#define REG_PM_SLEEP_4C_H       (REG_PM_SLEEP_BASE + 0x99)
#define REG_PM_SLEEP_4D_L       (REG_PM_SLEEP_BASE + 0x9A)
#define REG_PM_SLEEP_4D_H       (REG_PM_SLEEP_BASE + 0x9B)
#define REG_PM_SLEEP_4E_L       (REG_PM_SLEEP_BASE + 0x9C)
#define REG_PM_SLEEP_4E_H       (REG_PM_SLEEP_BASE + 0x9D)
#define REG_PM_SLEEP_4F_L       (REG_PM_SLEEP_BASE + 0x9E)
#define REG_PM_SLEEP_4F_H       (REG_PM_SLEEP_BASE + 0x9F)
#define REG_PM_SLEEP_50_L       (REG_PM_SLEEP_BASE + 0xA0)
#define REG_PM_SLEEP_50_H       (REG_PM_SLEEP_BASE + 0xA1)
#define REG_PM_SLEEP_51_L       (REG_PM_SLEEP_BASE + 0xA2)
#define REG_PM_SLEEP_51_H       (REG_PM_SLEEP_BASE + 0xA3)
#define REG_PM_SLEEP_52_L       (REG_PM_SLEEP_BASE + 0xA4)
#define REG_PM_SLEEP_52_H       (REG_PM_SLEEP_BASE + 0xA5)
#define REG_PM_SLEEP_53_L       (REG_PM_SLEEP_BASE + 0xA6)
#define REG_PM_SLEEP_53_H       (REG_PM_SLEEP_BASE + 0xA7)
#define REG_PM_SLEEP_54_L       (REG_PM_SLEEP_BASE + 0xA8)
#define REG_PM_SLEEP_54_H       (REG_PM_SLEEP_BASE + 0xA9)
#define REG_PM_SLEEP_55_L       (REG_PM_SLEEP_BASE + 0xAA)
#define REG_PM_SLEEP_55_H       (REG_PM_SLEEP_BASE + 0xAB)
#define REG_PM_SLEEP_56_L       (REG_PM_SLEEP_BASE + 0xAC)
#define REG_PM_SLEEP_56_H       (REG_PM_SLEEP_BASE + 0xAD)
#define REG_PM_SLEEP_57_L       (REG_PM_SLEEP_BASE + 0xAE)
#define REG_PM_SLEEP_57_H       (REG_PM_SLEEP_BASE + 0xAF)
#define REG_PM_SLEEP_58_L       (REG_PM_SLEEP_BASE + 0xB0)
#define REG_PM_SLEEP_58_H       (REG_PM_SLEEP_BASE + 0xB1)
#define REG_PM_SLEEP_59_L       (REG_PM_SLEEP_BASE + 0xB2)
#define REG_PM_SLEEP_59_H       (REG_PM_SLEEP_BASE + 0xB3)
#define REG_PM_SLEEP_5A_L       (REG_PM_SLEEP_BASE + 0xB4)
#define REG_PM_SLEEP_5A_H       (REG_PM_SLEEP_BASE + 0xB5)
#define REG_PM_SLEEP_5B_L       (REG_PM_SLEEP_BASE + 0xB6)
#define REG_PM_SLEEP_5B_H       (REG_PM_SLEEP_BASE + 0xB7)
#define REG_PM_SLEEP_5C_L       (REG_PM_SLEEP_BASE + 0xB8)
#define REG_PM_SLEEP_5C_H       (REG_PM_SLEEP_BASE + 0xB9)
#define REG_PM_SLEEP_5D_L       (REG_PM_SLEEP_BASE + 0xBA)
#define REG_PM_SLEEP_5D_H       (REG_PM_SLEEP_BASE + 0xBB)
#define REG_PM_SLEEP_5E_L       (REG_PM_SLEEP_BASE + 0xBC)
#define REG_PM_SLEEP_5E_H       (REG_PM_SLEEP_BASE + 0xBD)
#define REG_PM_SLEEP_5F_L       (REG_PM_SLEEP_BASE + 0xBE)
#define REG_PM_SLEEP_5F_H       (REG_PM_SLEEP_BASE + 0xBF)
#define REG_PM_SLEEP_60_L       (REG_PM_SLEEP_BASE + 0xC0)
#define REG_PM_SLEEP_60_H       (REG_PM_SLEEP_BASE + 0xC1)
#define REG_PM_SLEEP_61_L       (REG_PM_SLEEP_BASE + 0xC2)
#define REG_PM_SLEEP_61_H       (REG_PM_SLEEP_BASE + 0xC3)
#define REG_PM_SLEEP_62_L       (REG_PM_SLEEP_BASE + 0xC4)
#define REG_PM_SLEEP_62_H       (REG_PM_SLEEP_BASE + 0xC5)
#define REG_PM_SLEEP_63_L       (REG_PM_SLEEP_BASE + 0xC6)
#define REG_PM_SLEEP_63_H       (REG_PM_SLEEP_BASE + 0xC7)
#define REG_PM_SLEEP_64_L       (REG_PM_SLEEP_BASE + 0xC8)
#define REG_PM_SLEEP_64_H       (REG_PM_SLEEP_BASE + 0xC9)
#define REG_PM_SLEEP_65_L       (REG_PM_SLEEP_BASE + 0xCA)
#define REG_PM_SLEEP_65_H       (REG_PM_SLEEP_BASE + 0xCB)
#define REG_PM_SLEEP_66_L       (REG_PM_SLEEP_BASE + 0xCC)
#define REG_PM_SLEEP_66_H       (REG_PM_SLEEP_BASE + 0xCD)
#define REG_PM_SLEEP_67_L       (REG_PM_SLEEP_BASE + 0xCE)
#define REG_PM_SLEEP_67_H       (REG_PM_SLEEP_BASE + 0xCF)
#define REG_PM_SLEEP_68_L       (REG_PM_SLEEP_BASE + 0xD0)
#define REG_PM_SLEEP_68_H       (REG_PM_SLEEP_BASE + 0xD1)
#define REG_PM_SLEEP_69_L       (REG_PM_SLEEP_BASE + 0xD2)
#define REG_PM_SLEEP_69_H       (REG_PM_SLEEP_BASE + 0xD3)
#define REG_PM_SLEEP_6A_L       (REG_PM_SLEEP_BASE + 0xD4)
#define REG_PM_SLEEP_6A_H       (REG_PM_SLEEP_BASE + 0xD5)
#define REG_PM_SLEEP_6B_L       (REG_PM_SLEEP_BASE + 0xD6)
#define REG_PM_SLEEP_6B_H       (REG_PM_SLEEP_BASE + 0xD7)
#define REG_PM_SLEEP_6C_L       (REG_PM_SLEEP_BASE + 0xD8)
#define REG_PM_SLEEP_6C_H       (REG_PM_SLEEP_BASE + 0xD9)
#define REG_PM_SLEEP_6D_L       (REG_PM_SLEEP_BASE + 0xDA)
#define REG_PM_SLEEP_6D_H       (REG_PM_SLEEP_BASE + 0xDB)
#define REG_PM_SLEEP_6E_L       (REG_PM_SLEEP_BASE + 0xDC)
#define REG_PM_SLEEP_6E_H       (REG_PM_SLEEP_BASE + 0xDD)
#define REG_PM_SLEEP_6F_L       (REG_PM_SLEEP_BASE + 0xDE)
#define REG_PM_SLEEP_6F_H       (REG_PM_SLEEP_BASE + 0xDF)
#define REG_PM_SLEEP_70_L       (REG_PM_SLEEP_BASE + 0xE0)
#define REG_PM_SLEEP_70_H       (REG_PM_SLEEP_BASE + 0xE1)
#define REG_PM_SLEEP_71_L       (REG_PM_SLEEP_BASE + 0xE2)
#define REG_PM_SLEEP_71_H       (REG_PM_SLEEP_BASE + 0xE3)
#define REG_PM_SLEEP_72_L       (REG_PM_SLEEP_BASE + 0xE4)
#define REG_PM_SLEEP_72_H       (REG_PM_SLEEP_BASE + 0xE5)
#define REG_PM_SLEEP_73_L       (REG_PM_SLEEP_BASE + 0xE6)
#define REG_PM_SLEEP_73_H       (REG_PM_SLEEP_BASE + 0xE7)
#define REG_PM_SLEEP_74_L       (REG_PM_SLEEP_BASE + 0xE8)
#define REG_PM_SLEEP_74_H       (REG_PM_SLEEP_BASE + 0xE9)
#define REG_PM_SLEEP_75_L       (REG_PM_SLEEP_BASE + 0xEA)
#define REG_PM_SLEEP_75_H       (REG_PM_SLEEP_BASE + 0xEB)
#define REG_PM_SLEEP_76_L       (REG_PM_SLEEP_BASE + 0xEC)
#define REG_PM_SLEEP_76_H       (REG_PM_SLEEP_BASE + 0xED)
#define REG_PM_SLEEP_77_L       (REG_PM_SLEEP_BASE + 0xEE)
#define REG_PM_SLEEP_77_H       (REG_PM_SLEEP_BASE + 0xEF)
#define REG_PM_SLEEP_78_L       (REG_PM_SLEEP_BASE + 0xF0)
#define REG_PM_SLEEP_78_H       (REG_PM_SLEEP_BASE + 0xF1)
#define REG_PM_SLEEP_79_L       (REG_PM_SLEEP_BASE + 0xF2)
#define REG_PM_SLEEP_79_H       (REG_PM_SLEEP_BASE + 0xF3)
#define REG_PM_SLEEP_7A_L       (REG_PM_SLEEP_BASE + 0xF4)
#define REG_PM_SLEEP_7A_H       (REG_PM_SLEEP_BASE + 0xF5)
#define REG_PM_SLEEP_7B_L       (REG_PM_SLEEP_BASE + 0xF6)
#define REG_PM_SLEEP_7B_H       (REG_PM_SLEEP_BASE + 0xF7)
#define REG_PM_SLEEP_7C_L       (REG_PM_SLEEP_BASE + 0xF8)
#define REG_PM_SLEEP_7C_H       (REG_PM_SLEEP_BASE + 0xF9)
#define REG_PM_SLEEP_7D_L       (REG_PM_SLEEP_BASE + 0xFA)
#define REG_PM_SLEEP_7D_H       (REG_PM_SLEEP_BASE + 0xFB)
#define REG_PM_SLEEP_7E_L       (REG_PM_SLEEP_BASE + 0xFC)
#define REG_PM_SLEEP_7E_H       (REG_PM_SLEEP_BASE + 0xFD)
#define REG_PM_SLEEP_7F_L       (REG_PM_SLEEP_BASE + 0xFE)
#define REG_PM_SLEEP_7F_H       (REG_PM_SLEEP_BASE + 0xFF)

//=============================================================

// PM_SCDC_P0
#define REG_PM_SCDC_P0_00_L           (REG_PM_SCDC_P0_BASE + 0x00)
#define REG_PM_SCDC_P0_00_H           (REG_PM_SCDC_P0_BASE + 0x01)
#define REG_PM_SCDC_P0_01_L           (REG_PM_SCDC_P0_BASE + 0x02)
#define REG_PM_SCDC_P0_01_H           (REG_PM_SCDC_P0_BASE + 0x03)
#define REG_PM_SCDC_P0_02_L           (REG_PM_SCDC_P0_BASE + 0x04)
#define REG_PM_SCDC_P0_02_H           (REG_PM_SCDC_P0_BASE + 0x05)
#define REG_PM_SCDC_P0_03_L           (REG_PM_SCDC_P0_BASE + 0x06)
#define REG_PM_SCDC_P0_03_H           (REG_PM_SCDC_P0_BASE + 0x07)
#define REG_PM_SCDC_P0_04_L           (REG_PM_SCDC_P0_BASE + 0x08)
#define REG_PM_SCDC_P0_04_H           (REG_PM_SCDC_P0_BASE + 0x09)
#define REG_PM_SCDC_P0_05_L           (REG_PM_SCDC_P0_BASE + 0x0A)
#define REG_PM_SCDC_P0_05_H           (REG_PM_SCDC_P0_BASE + 0x0B)
#define REG_PM_SCDC_P0_06_L           (REG_PM_SCDC_P0_BASE + 0x0C)
#define REG_PM_SCDC_P0_06_H           (REG_PM_SCDC_P0_BASE + 0x0D)
#define REG_PM_SCDC_P0_07_L           (REG_PM_SCDC_P0_BASE + 0x0E)
#define REG_PM_SCDC_P0_07_H           (REG_PM_SCDC_P0_BASE + 0x0F)
#define REG_PM_SCDC_P0_08_L           (REG_PM_SCDC_P0_BASE + 0x10)
#define REG_PM_SCDC_P0_08_H           (REG_PM_SCDC_P0_BASE + 0x11)
#define REG_PM_SCDC_P0_09_L           (REG_PM_SCDC_P0_BASE + 0x12)
#define REG_PM_SCDC_P0_09_H           (REG_PM_SCDC_P0_BASE + 0x13)
#define REG_PM_SCDC_P0_0A_L           (REG_PM_SCDC_P0_BASE + 0x14)
#define REG_PM_SCDC_P0_0A_H           (REG_PM_SCDC_P0_BASE + 0x15)
#define REG_PM_SCDC_P0_0B_L           (REG_PM_SCDC_P0_BASE + 0x16)
#define REG_PM_SCDC_P0_0B_H           (REG_PM_SCDC_P0_BASE + 0x17)
#define REG_PM_SCDC_P0_0C_L           (REG_PM_SCDC_P0_BASE + 0x18)
#define REG_PM_SCDC_P0_0C_H           (REG_PM_SCDC_P0_BASE + 0x19)
#define REG_PM_SCDC_P0_0D_L           (REG_PM_SCDC_P0_BASE + 0x1A)
#define REG_PM_SCDC_P0_0D_H           (REG_PM_SCDC_P0_BASE + 0x1B)
#define REG_PM_SCDC_P0_0E_L           (REG_PM_SCDC_P0_BASE + 0x1C)
#define REG_PM_SCDC_P0_0E_H           (REG_PM_SCDC_P0_BASE + 0x1D)
#define REG_PM_SCDC_P0_0F_L           (REG_PM_SCDC_P0_BASE + 0x1E)
#define REG_PM_SCDC_P0_0F_H           (REG_PM_SCDC_P0_BASE + 0x1F)
#define REG_PM_SCDC_P0_10_L           (REG_PM_SCDC_P0_BASE + 0x20)
#define REG_PM_SCDC_P0_10_H           (REG_PM_SCDC_P0_BASE + 0x21)
#define REG_PM_SCDC_P0_11_L           (REG_PM_SCDC_P0_BASE + 0x22)
#define REG_PM_SCDC_P0_11_H           (REG_PM_SCDC_P0_BASE + 0x23)
#define REG_PM_SCDC_P0_12_L           (REG_PM_SCDC_P0_BASE + 0x24)
#define REG_PM_SCDC_P0_12_H           (REG_PM_SCDC_P0_BASE + 0x25)
#define REG_PM_SCDC_P0_13_L           (REG_PM_SCDC_P0_BASE + 0x26)
#define REG_PM_SCDC_P0_13_H           (REG_PM_SCDC_P0_BASE + 0x27)
#define REG_PM_SCDC_P0_14_L           (REG_PM_SCDC_P0_BASE + 0x28)
#define REG_PM_SCDC_P0_14_H           (REG_PM_SCDC_P0_BASE + 0x29)
#define REG_PM_SCDC_P0_15_L           (REG_PM_SCDC_P0_BASE + 0x2A)
#define REG_PM_SCDC_P0_15_H           (REG_PM_SCDC_P0_BASE + 0x2B)
#define REG_PM_SCDC_P0_16_L           (REG_PM_SCDC_P0_BASE + 0x2C)
#define REG_PM_SCDC_P0_16_H           (REG_PM_SCDC_P0_BASE + 0x2D)
#define REG_PM_SCDC_P0_17_L           (REG_PM_SCDC_P0_BASE + 0x2E)
#define REG_PM_SCDC_P0_17_H           (REG_PM_SCDC_P0_BASE + 0x2F)
#define REG_PM_SCDC_P0_18_L           (REG_PM_SCDC_P0_BASE + 0x30)
#define REG_PM_SCDC_P0_18_H           (REG_PM_SCDC_P0_BASE + 0x31)
#define REG_PM_SCDC_P0_19_L           (REG_PM_SCDC_P0_BASE + 0x32)
#define REG_PM_SCDC_P0_19_H           (REG_PM_SCDC_P0_BASE + 0x33)
#define REG_PM_SCDC_P0_1A_L           (REG_PM_SCDC_P0_BASE + 0x34)
#define REG_PM_SCDC_P0_1A_H           (REG_PM_SCDC_P0_BASE + 0x35)
#define REG_PM_SCDC_P0_1B_L           (REG_PM_SCDC_P0_BASE + 0x36)
#define REG_PM_SCDC_P0_1B_H           (REG_PM_SCDC_P0_BASE + 0x37)
#define REG_PM_SCDC_P0_1C_L           (REG_PM_SCDC_P0_BASE + 0x38)
#define REG_PM_SCDC_P0_1C_H           (REG_PM_SCDC_P0_BASE + 0x39)
#define REG_PM_SCDC_P0_1D_L           (REG_PM_SCDC_P0_BASE + 0x3A)
#define REG_PM_SCDC_P0_1D_H           (REG_PM_SCDC_P0_BASE + 0x3B)
#define REG_PM_SCDC_P0_1E_L           (REG_PM_SCDC_P0_BASE + 0x3C)
#define REG_PM_SCDC_P0_1E_H           (REG_PM_SCDC_P0_BASE + 0x3D)
#define REG_PM_SCDC_P0_1F_L           (REG_PM_SCDC_P0_BASE + 0x3E)
#define REG_PM_SCDC_P0_1F_H           (REG_PM_SCDC_P0_BASE + 0x3F)
#define REG_PM_SCDC_P0_20_L           (REG_PM_SCDC_P0_BASE + 0x40)
#define REG_PM_SCDC_P0_20_H           (REG_PM_SCDC_P0_BASE + 0x41)
#define REG_PM_SCDC_P0_21_L           (REG_PM_SCDC_P0_BASE + 0x42)
#define REG_PM_SCDC_P0_21_H           (REG_PM_SCDC_P0_BASE + 0x43)
#define REG_PM_SCDC_P0_22_L           (REG_PM_SCDC_P0_BASE + 0x44)
#define REG_PM_SCDC_P0_22_H           (REG_PM_SCDC_P0_BASE + 0x45)
#define REG_PM_SCDC_P0_23_L           (REG_PM_SCDC_P0_BASE + 0x46)
#define REG_PM_SCDC_P0_23_H           (REG_PM_SCDC_P0_BASE + 0x47)
#define REG_PM_SCDC_P0_24_L           (REG_PM_SCDC_P0_BASE + 0x48)
#define REG_PM_SCDC_P0_24_H           (REG_PM_SCDC_P0_BASE + 0x49)
#define REG_PM_SCDC_P0_25_L           (REG_PM_SCDC_P0_BASE + 0x4A)
#define REG_PM_SCDC_P0_25_H           (REG_PM_SCDC_P0_BASE + 0x4B)
#define REG_PM_SCDC_P0_26_L           (REG_PM_SCDC_P0_BASE + 0x4C)
#define REG_PM_SCDC_P0_26_H           (REG_PM_SCDC_P0_BASE + 0x4D)
#define REG_PM_SCDC_P0_27_L           (REG_PM_SCDC_P0_BASE + 0x4E)
#define REG_PM_SCDC_P0_27_H           (REG_PM_SCDC_P0_BASE + 0x4F)
#define REG_PM_SCDC_P0_28_L           (REG_PM_SCDC_P0_BASE + 0x50)
#define REG_PM_SCDC_P0_28_H           (REG_PM_SCDC_P0_BASE + 0x51)
#define REG_PM_SCDC_P0_29_L           (REG_PM_SCDC_P0_BASE + 0x52)
#define REG_PM_SCDC_P0_29_H           (REG_PM_SCDC_P0_BASE + 0x53)
#define REG_PM_SCDC_P0_2A_L           (REG_PM_SCDC_P0_BASE + 0x54)
#define REG_PM_SCDC_P0_2A_H           (REG_PM_SCDC_P0_BASE + 0x55)
#define REG_PM_SCDC_P0_2B_L           (REG_PM_SCDC_P0_BASE + 0x56)
#define REG_PM_SCDC_P0_2B_H           (REG_PM_SCDC_P0_BASE + 0x57)
#define REG_PM_SCDC_P0_2C_L           (REG_PM_SCDC_P0_BASE + 0x58)
#define REG_PM_SCDC_P0_2C_H           (REG_PM_SCDC_P0_BASE + 0x59)
#define REG_PM_SCDC_P0_2D_L           (REG_PM_SCDC_P0_BASE + 0x5A)
#define REG_PM_SCDC_P0_2D_H           (REG_PM_SCDC_P0_BASE + 0x5B)
#define REG_PM_SCDC_P0_2E_L           (REG_PM_SCDC_P0_BASE + 0x5C)
#define REG_PM_SCDC_P0_2E_H           (REG_PM_SCDC_P0_BASE + 0x5D)
#define REG_PM_SCDC_P0_2F_L           (REG_PM_SCDC_P0_BASE + 0x5E)
#define REG_PM_SCDC_P0_2F_H           (REG_PM_SCDC_P0_BASE + 0x5F)
#define REG_PM_SCDC_P0_30_L           (REG_PM_SCDC_P0_BASE + 0x60)
#define REG_PM_SCDC_P0_30_H           (REG_PM_SCDC_P0_BASE + 0x61)
#define REG_PM_SCDC_P0_31_L           (REG_PM_SCDC_P0_BASE + 0x62)
#define REG_PM_SCDC_P0_31_H           (REG_PM_SCDC_P0_BASE + 0x63)
#define REG_PM_SCDC_P0_32_L           (REG_PM_SCDC_P0_BASE + 0x64)
#define REG_PM_SCDC_P0_32_H           (REG_PM_SCDC_P0_BASE + 0x65)
#define REG_PM_SCDC_P0_33_L           (REG_PM_SCDC_P0_BASE + 0x66)
#define REG_PM_SCDC_P0_33_H           (REG_PM_SCDC_P0_BASE + 0x67)
#define REG_PM_SCDC_P0_34_L           (REG_PM_SCDC_P0_BASE + 0x68)
#define REG_PM_SCDC_P0_34_H           (REG_PM_SCDC_P0_BASE + 0x69)
#define REG_PM_SCDC_P0_35_L           (REG_PM_SCDC_P0_BASE + 0x6A)
#define REG_PM_SCDC_P0_35_H           (REG_PM_SCDC_P0_BASE + 0x6B)
#define REG_PM_SCDC_P0_36_L           (REG_PM_SCDC_P0_BASE + 0x6C)
#define REG_PM_SCDC_P0_36_H           (REG_PM_SCDC_P0_BASE + 0x6D)
#define REG_PM_SCDC_P0_37_L           (REG_PM_SCDC_P0_BASE + 0x6E)
#define REG_PM_SCDC_P0_37_H           (REG_PM_SCDC_P0_BASE + 0x6F)
#define REG_PM_SCDC_P0_38_L           (REG_PM_SCDC_P0_BASE + 0x70)
#define REG_PM_SCDC_P0_38_H           (REG_PM_SCDC_P0_BASE + 0x71)
#define REG_PM_SCDC_P0_39_L           (REG_PM_SCDC_P0_BASE + 0x72)
#define REG_PM_SCDC_P0_39_H           (REG_PM_SCDC_P0_BASE + 0x73)
#define REG_PM_SCDC_P0_3A_L           (REG_PM_SCDC_P0_BASE + 0x74)
#define REG_PM_SCDC_P0_3A_H           (REG_PM_SCDC_P0_BASE + 0x75)
#define REG_PM_SCDC_P0_3B_L           (REG_PM_SCDC_P0_BASE + 0x76)
#define REG_PM_SCDC_P0_3B_H           (REG_PM_SCDC_P0_BASE + 0x77)
#define REG_PM_SCDC_P0_3C_L           (REG_PM_SCDC_P0_BASE + 0x78)
#define REG_PM_SCDC_P0_3C_H           (REG_PM_SCDC_P0_BASE + 0x79)
#define REG_PM_SCDC_P0_3D_L           (REG_PM_SCDC_P0_BASE + 0x7A)
#define REG_PM_SCDC_P0_3D_H           (REG_PM_SCDC_P0_BASE + 0x7B)
#define REG_PM_SCDC_P0_3E_L           (REG_PM_SCDC_P0_BASE + 0x7C)
#define REG_PM_SCDC_P0_3E_H           (REG_PM_SCDC_P0_BASE + 0x7D)
#define REG_PM_SCDC_P0_3F_L           (REG_PM_SCDC_P0_BASE + 0x7E)
#define REG_PM_SCDC_P0_3F_H           (REG_PM_SCDC_P0_BASE + 0x7F)
#define REG_PM_SCDC_P0_40_L           (REG_PM_SCDC_P0_BASE + 0x80)
#define REG_PM_SCDC_P0_40_H           (REG_PM_SCDC_P0_BASE + 0x81)
#define REG_PM_SCDC_P0_41_L           (REG_PM_SCDC_P0_BASE + 0x82)
#define REG_PM_SCDC_P0_41_H           (REG_PM_SCDC_P0_BASE + 0x83)
#define REG_PM_SCDC_P0_42_L           (REG_PM_SCDC_P0_BASE + 0x84)
#define REG_PM_SCDC_P0_42_H           (REG_PM_SCDC_P0_BASE + 0x85)
#define REG_PM_SCDC_P0_43_L           (REG_PM_SCDC_P0_BASE + 0x86)
#define REG_PM_SCDC_P0_43_H           (REG_PM_SCDC_P0_BASE + 0x87)
#define REG_PM_SCDC_P0_44_L           (REG_PM_SCDC_P0_BASE + 0x88)
#define REG_PM_SCDC_P0_44_H           (REG_PM_SCDC_P0_BASE + 0x89)
#define REG_PM_SCDC_P0_45_L           (REG_PM_SCDC_P0_BASE + 0x8A)
#define REG_PM_SCDC_P0_45_H           (REG_PM_SCDC_P0_BASE + 0x8B)
#define REG_PM_SCDC_P0_46_L           (REG_PM_SCDC_P0_BASE + 0x8C)
#define REG_PM_SCDC_P0_46_H           (REG_PM_SCDC_P0_BASE + 0x8D)
#define REG_PM_SCDC_P0_47_L           (REG_PM_SCDC_P0_BASE + 0x8E)
#define REG_PM_SCDC_P0_47_H           (REG_PM_SCDC_P0_BASE + 0x8F)
#define REG_PM_SCDC_P0_48_L           (REG_PM_SCDC_P0_BASE + 0x90)
#define REG_PM_SCDC_P0_48_H           (REG_PM_SCDC_P0_BASE + 0x91)
#define REG_PM_SCDC_P0_49_L           (REG_PM_SCDC_P0_BASE + 0x92)
#define REG_PM_SCDC_P0_49_H           (REG_PM_SCDC_P0_BASE + 0x93)
#define REG_PM_SCDC_P0_4A_L           (REG_PM_SCDC_P0_BASE + 0x94)
#define REG_PM_SCDC_P0_4A_H           (REG_PM_SCDC_P0_BASE + 0x95)
#define REG_PM_SCDC_P0_4B_L           (REG_PM_SCDC_P0_BASE + 0x96)
#define REG_PM_SCDC_P0_4B_H           (REG_PM_SCDC_P0_BASE + 0x97)
#define REG_PM_SCDC_P0_4C_L           (REG_PM_SCDC_P0_BASE + 0x98)
#define REG_PM_SCDC_P0_4C_H           (REG_PM_SCDC_P0_BASE + 0x99)
#define REG_PM_SCDC_P0_4D_L           (REG_PM_SCDC_P0_BASE + 0x9A)
#define REG_PM_SCDC_P0_4D_H           (REG_PM_SCDC_P0_BASE + 0x9B)
#define REG_PM_SCDC_P0_4E_L           (REG_PM_SCDC_P0_BASE + 0x9C)
#define REG_PM_SCDC_P0_4E_H           (REG_PM_SCDC_P0_BASE + 0x9D)
#define REG_PM_SCDC_P0_4F_L           (REG_PM_SCDC_P0_BASE + 0x9E)
#define REG_PM_SCDC_P0_4F_H           (REG_PM_SCDC_P0_BASE + 0x9F)
#define REG_PM_SCDC_P0_50_L           (REG_PM_SCDC_P0_BASE + 0xA0)
#define REG_PM_SCDC_P0_50_H           (REG_PM_SCDC_P0_BASE + 0xA1)
#define REG_PM_SCDC_P0_51_L           (REG_PM_SCDC_P0_BASE + 0xA2)
#define REG_PM_SCDC_P0_51_H           (REG_PM_SCDC_P0_BASE + 0xA3)
#define REG_PM_SCDC_P0_52_L           (REG_PM_SCDC_P0_BASE + 0xA4)
#define REG_PM_SCDC_P0_52_H           (REG_PM_SCDC_P0_BASE + 0xA5)
#define REG_PM_SCDC_P0_53_L           (REG_PM_SCDC_P0_BASE + 0xA6)
#define REG_PM_SCDC_P0_53_H           (REG_PM_SCDC_P0_BASE + 0xA7)
#define REG_PM_SCDC_P0_54_L           (REG_PM_SCDC_P0_BASE + 0xA8)
#define REG_PM_SCDC_P0_54_H           (REG_PM_SCDC_P0_BASE + 0xA9)
#define REG_PM_SCDC_P0_55_L           (REG_PM_SCDC_P0_BASE + 0xAA)
#define REG_PM_SCDC_P0_55_H           (REG_PM_SCDC_P0_BASE + 0xAB)
#define REG_PM_SCDC_P0_56_L           (REG_PM_SCDC_P0_BASE + 0xAC)
#define REG_PM_SCDC_P0_56_H           (REG_PM_SCDC_P0_BASE + 0xAD)
#define REG_PM_SCDC_P0_57_L           (REG_PM_SCDC_P0_BASE + 0xAE)
#define REG_PM_SCDC_P0_57_H           (REG_PM_SCDC_P0_BASE + 0xAF)
#define REG_PM_SCDC_P0_58_L           (REG_PM_SCDC_P0_BASE + 0xB0)
#define REG_PM_SCDC_P0_58_H           (REG_PM_SCDC_P0_BASE + 0xB1)
#define REG_PM_SCDC_P0_59_L           (REG_PM_SCDC_P0_BASE + 0xB2)
#define REG_PM_SCDC_P0_59_H           (REG_PM_SCDC_P0_BASE + 0xB3)
#define REG_PM_SCDC_P0_5A_L           (REG_PM_SCDC_P0_BASE + 0xB4)
#define REG_PM_SCDC_P0_5A_H           (REG_PM_SCDC_P0_BASE + 0xB5)
#define REG_PM_SCDC_P0_5B_L           (REG_PM_SCDC_P0_BASE + 0xB6)
#define REG_PM_SCDC_P0_5B_H           (REG_PM_SCDC_P0_BASE + 0xB7)
#define REG_PM_SCDC_P0_5C_L           (REG_PM_SCDC_P0_BASE + 0xB8)
#define REG_PM_SCDC_P0_5C_H           (REG_PM_SCDC_P0_BASE + 0xB9)
#define REG_PM_SCDC_P0_5D_L           (REG_PM_SCDC_P0_BASE + 0xBA)
#define REG_PM_SCDC_P0_5D_H           (REG_PM_SCDC_P0_BASE + 0xBB)
#define REG_PM_SCDC_P0_5E_L           (REG_PM_SCDC_P0_BASE + 0xBC)
#define REG_PM_SCDC_P0_5E_H           (REG_PM_SCDC_P0_BASE + 0xBD)
#define REG_PM_SCDC_P0_5F_L           (REG_PM_SCDC_P0_BASE + 0xBE)
#define REG_PM_SCDC_P0_5F_H           (REG_PM_SCDC_P0_BASE + 0xBF)
#define REG_PM_SCDC_P0_60_L           (REG_PM_SCDC_P0_BASE + 0xC0)
#define REG_PM_SCDC_P0_60_H           (REG_PM_SCDC_P0_BASE + 0xC1)
#define REG_PM_SCDC_P0_61_L           (REG_PM_SCDC_P0_BASE + 0xC2)
#define REG_PM_SCDC_P0_61_H           (REG_PM_SCDC_P0_BASE + 0xC3)
#define REG_PM_SCDC_P0_62_L           (REG_PM_SCDC_P0_BASE + 0xC4)
#define REG_PM_SCDC_P0_62_H           (REG_PM_SCDC_P0_BASE + 0xC5)
#define REG_PM_SCDC_P0_63_L           (REG_PM_SCDC_P0_BASE + 0xC6)
#define REG_PM_SCDC_P0_63_H           (REG_PM_SCDC_P0_BASE + 0xC7)
#define REG_PM_SCDC_P0_64_L           (REG_PM_SCDC_P0_BASE + 0xC8)
#define REG_PM_SCDC_P0_64_H           (REG_PM_SCDC_P0_BASE + 0xC9)
#define REG_PM_SCDC_P0_65_L           (REG_PM_SCDC_P0_BASE + 0xCA)
#define REG_PM_SCDC_P0_65_H           (REG_PM_SCDC_P0_BASE + 0xCB)
#define REG_PM_SCDC_P0_66_L           (REG_PM_SCDC_P0_BASE + 0xCC)
#define REG_PM_SCDC_P0_66_H           (REG_PM_SCDC_P0_BASE + 0xCD)
#define REG_PM_SCDC_P0_67_L           (REG_PM_SCDC_P0_BASE + 0xCE)
#define REG_PM_SCDC_P0_67_H           (REG_PM_SCDC_P0_BASE + 0xCF)
#define REG_PM_SCDC_P0_68_L           (REG_PM_SCDC_P0_BASE + 0xD0)
#define REG_PM_SCDC_P0_68_H           (REG_PM_SCDC_P0_BASE + 0xD1)
#define REG_PM_SCDC_P0_69_L           (REG_PM_SCDC_P0_BASE + 0xD2)
#define REG_PM_SCDC_P0_69_H           (REG_PM_SCDC_P0_BASE + 0xD3)
#define REG_PM_SCDC_P0_6A_L           (REG_PM_SCDC_P0_BASE + 0xD4)
#define REG_PM_SCDC_P0_6A_H           (REG_PM_SCDC_P0_BASE + 0xD5)
#define REG_PM_SCDC_P0_6B_L           (REG_PM_SCDC_P0_BASE + 0xD6)
#define REG_PM_SCDC_P0_6B_H           (REG_PM_SCDC_P0_BASE + 0xD7)
#define REG_PM_SCDC_P0_6C_L           (REG_PM_SCDC_P0_BASE + 0xD8)
#define REG_PM_SCDC_P0_6C_H           (REG_PM_SCDC_P0_BASE + 0xD9)
#define REG_PM_SCDC_P0_6D_L           (REG_PM_SCDC_P0_BASE + 0xDA)
#define REG_PM_SCDC_P0_6D_H           (REG_PM_SCDC_P0_BASE + 0xDB)
#define REG_PM_SCDC_P0_6E_L           (REG_PM_SCDC_P0_BASE + 0xDC)
#define REG_PM_SCDC_P0_6E_H           (REG_PM_SCDC_P0_BASE + 0xDD)
#define REG_PM_SCDC_P0_6F_L           (REG_PM_SCDC_P0_BASE + 0xDE)
#define REG_PM_SCDC_P0_6F_H           (REG_PM_SCDC_P0_BASE + 0xDF)
#define REG_PM_SCDC_P0_70_L           (REG_PM_SCDC_P0_BASE + 0xE0)
#define REG_PM_SCDC_P0_70_H           (REG_PM_SCDC_P0_BASE + 0xE1)
#define REG_PM_SCDC_P0_71_L           (REG_PM_SCDC_P0_BASE + 0xE2)
#define REG_PM_SCDC_P0_71_H           (REG_PM_SCDC_P0_BASE + 0xE3)
#define REG_PM_SCDC_P0_72_L           (REG_PM_SCDC_P0_BASE + 0xE4)
#define REG_PM_SCDC_P0_72_H           (REG_PM_SCDC_P0_BASE + 0xE5)
#define REG_PM_SCDC_P0_73_L           (REG_PM_SCDC_P0_BASE + 0xE6)
#define REG_PM_SCDC_P0_73_H           (REG_PM_SCDC_P0_BASE + 0xE7)
#define REG_PM_SCDC_P0_74_L           (REG_PM_SCDC_P0_BASE + 0xE8)
#define REG_PM_SCDC_P0_74_H           (REG_PM_SCDC_P0_BASE + 0xE9)
#define REG_PM_SCDC_P0_75_L           (REG_PM_SCDC_P0_BASE + 0xEA)
#define REG_PM_SCDC_P0_75_H           (REG_PM_SCDC_P0_BASE + 0xEB)
#define REG_PM_SCDC_P0_76_L           (REG_PM_SCDC_P0_BASE + 0xEC)
#define REG_PM_SCDC_P0_76_H           (REG_PM_SCDC_P0_BASE + 0xED)
#define REG_PM_SCDC_P0_77_L           (REG_PM_SCDC_P0_BASE + 0xEE)
#define REG_PM_SCDC_P0_77_H           (REG_PM_SCDC_P0_BASE + 0xEF)
#define REG_PM_SCDC_P0_78_L           (REG_PM_SCDC_P0_BASE + 0xF0)
#define REG_PM_SCDC_P0_78_H           (REG_PM_SCDC_P0_BASE + 0xF1)
#define REG_PM_SCDC_P0_79_L           (REG_PM_SCDC_P0_BASE + 0xF2)
#define REG_PM_SCDC_P0_79_H           (REG_PM_SCDC_P0_BASE + 0xF3)
#define REG_PM_SCDC_P0_7A_L           (REG_PM_SCDC_P0_BASE + 0xF4)
#define REG_PM_SCDC_P0_7A_H           (REG_PM_SCDC_P0_BASE + 0xF5)
#define REG_PM_SCDC_P0_7B_L           (REG_PM_SCDC_P0_BASE + 0xF6)
#define REG_PM_SCDC_P0_7B_H           (REG_PM_SCDC_P0_BASE + 0xF7)
#define REG_PM_SCDC_P0_7C_L           (REG_PM_SCDC_P0_BASE + 0xF8)
#define REG_PM_SCDC_P0_7C_H           (REG_PM_SCDC_P0_BASE + 0xF9)
#define REG_PM_SCDC_P0_7D_L           (REG_PM_SCDC_P0_BASE + 0xFA)
#define REG_PM_SCDC_P0_7D_H           (REG_PM_SCDC_P0_BASE + 0xFB)
#define REG_PM_SCDC_P0_7E_L           (REG_PM_SCDC_P0_BASE + 0xFC)
#define REG_PM_SCDC_P0_7E_H           (REG_PM_SCDC_P0_BASE + 0xFD)
#define REG_PM_SCDC_P0_7F_L           (REG_PM_SCDC_P0_BASE + 0xFE)
#define REG_PM_SCDC_P0_7F_H           (REG_PM_SCDC_P0_BASE + 0xFF)


//=============================================================
// PM_SCDC_P1
#define REG_PM_SCDC_P1_00_L           (REG_PM_SCDC_P1_BASE + 0x00)
#define REG_PM_SCDC_P1_00_H           (REG_PM_SCDC_P1_BASE + 0x01)
#define REG_PM_SCDC_P1_01_L           (REG_PM_SCDC_P1_BASE + 0x02)
#define REG_PM_SCDC_P1_01_H           (REG_PM_SCDC_P1_BASE + 0x03)
#define REG_PM_SCDC_P1_02_L           (REG_PM_SCDC_P1_BASE + 0x04)
#define REG_PM_SCDC_P1_02_H           (REG_PM_SCDC_P1_BASE + 0x05)
#define REG_PM_SCDC_P1_03_L           (REG_PM_SCDC_P1_BASE + 0x06)
#define REG_PM_SCDC_P1_03_H           (REG_PM_SCDC_P1_BASE + 0x07)
#define REG_PM_SCDC_P1_04_L           (REG_PM_SCDC_P1_BASE + 0x08)
#define REG_PM_SCDC_P1_04_H           (REG_PM_SCDC_P1_BASE + 0x09)
#define REG_PM_SCDC_P1_05_L           (REG_PM_SCDC_P1_BASE + 0x0A)
#define REG_PM_SCDC_P1_05_H           (REG_PM_SCDC_P1_BASE + 0x0B)
#define REG_PM_SCDC_P1_06_L           (REG_PM_SCDC_P1_BASE + 0x0C)
#define REG_PM_SCDC_P1_06_H           (REG_PM_SCDC_P1_BASE + 0x0D)
#define REG_PM_SCDC_P1_07_L           (REG_PM_SCDC_P1_BASE + 0x0E)
#define REG_PM_SCDC_P1_07_H           (REG_PM_SCDC_P1_BASE + 0x0F)
#define REG_PM_SCDC_P1_08_L           (REG_PM_SCDC_P1_BASE + 0x10)
#define REG_PM_SCDC_P1_08_H           (REG_PM_SCDC_P1_BASE + 0x11)
#define REG_PM_SCDC_P1_09_L           (REG_PM_SCDC_P1_BASE + 0x12)
#define REG_PM_SCDC_P1_09_H           (REG_PM_SCDC_P1_BASE + 0x13)
#define REG_PM_SCDC_P1_0A_L           (REG_PM_SCDC_P1_BASE + 0x14)
#define REG_PM_SCDC_P1_0A_H           (REG_PM_SCDC_P1_BASE + 0x15)
#define REG_PM_SCDC_P1_0B_L           (REG_PM_SCDC_P1_BASE + 0x16)
#define REG_PM_SCDC_P1_0B_H           (REG_PM_SCDC_P1_BASE + 0x17)
#define REG_PM_SCDC_P1_0C_L           (REG_PM_SCDC_P1_BASE + 0x18)
#define REG_PM_SCDC_P1_0C_H           (REG_PM_SCDC_P1_BASE + 0x19)
#define REG_PM_SCDC_P1_0D_L           (REG_PM_SCDC_P1_BASE + 0x1A)
#define REG_PM_SCDC_P1_0D_H           (REG_PM_SCDC_P1_BASE + 0x1B)
#define REG_PM_SCDC_P1_0E_L           (REG_PM_SCDC_P1_BASE + 0x1C)
#define REG_PM_SCDC_P1_0E_H           (REG_PM_SCDC_P1_BASE + 0x1D)
#define REG_PM_SCDC_P1_0F_L           (REG_PM_SCDC_P1_BASE + 0x1E)
#define REG_PM_SCDC_P1_0F_H           (REG_PM_SCDC_P1_BASE + 0x1F)
#define REG_PM_SCDC_P1_10_L           (REG_PM_SCDC_P1_BASE + 0x20)
#define REG_PM_SCDC_P1_10_H           (REG_PM_SCDC_P1_BASE + 0x21)
#define REG_PM_SCDC_P1_11_L           (REG_PM_SCDC_P1_BASE + 0x22)
#define REG_PM_SCDC_P1_11_H           (REG_PM_SCDC_P1_BASE + 0x23)
#define REG_PM_SCDC_P1_12_L           (REG_PM_SCDC_P1_BASE + 0x24)
#define REG_PM_SCDC_P1_12_H           (REG_PM_SCDC_P1_BASE + 0x25)
#define REG_PM_SCDC_P1_13_L           (REG_PM_SCDC_P1_BASE + 0x26)
#define REG_PM_SCDC_P1_13_H           (REG_PM_SCDC_P1_BASE + 0x27)
#define REG_PM_SCDC_P1_14_L           (REG_PM_SCDC_P1_BASE + 0x28)
#define REG_PM_SCDC_P1_14_H           (REG_PM_SCDC_P1_BASE + 0x29)
#define REG_PM_SCDC_P1_15_L           (REG_PM_SCDC_P1_BASE + 0x2A)
#define REG_PM_SCDC_P1_15_H           (REG_PM_SCDC_P1_BASE + 0x2B)
#define REG_PM_SCDC_P1_16_L           (REG_PM_SCDC_P1_BASE + 0x2C)
#define REG_PM_SCDC_P1_16_H           (REG_PM_SCDC_P1_BASE + 0x2D)
#define REG_PM_SCDC_P1_17_L           (REG_PM_SCDC_P1_BASE + 0x2E)
#define REG_PM_SCDC_P1_17_H           (REG_PM_SCDC_P1_BASE + 0x2F)
#define REG_PM_SCDC_P1_18_L           (REG_PM_SCDC_P1_BASE + 0x30)
#define REG_PM_SCDC_P1_18_H           (REG_PM_SCDC_P1_BASE + 0x31)
#define REG_PM_SCDC_P1_19_L           (REG_PM_SCDC_P1_BASE + 0x32)
#define REG_PM_SCDC_P1_19_H           (REG_PM_SCDC_P1_BASE + 0x33)
#define REG_PM_SCDC_P1_1A_L           (REG_PM_SCDC_P1_BASE + 0x34)
#define REG_PM_SCDC_P1_1A_H           (REG_PM_SCDC_P1_BASE + 0x35)
#define REG_PM_SCDC_P1_1B_L           (REG_PM_SCDC_P1_BASE + 0x36)
#define REG_PM_SCDC_P1_1B_H           (REG_PM_SCDC_P1_BASE + 0x37)
#define REG_PM_SCDC_P1_1C_L           (REG_PM_SCDC_P1_BASE + 0x38)
#define REG_PM_SCDC_P1_1C_H           (REG_PM_SCDC_P1_BASE + 0x39)
#define REG_PM_SCDC_P1_1D_L           (REG_PM_SCDC_P1_BASE + 0x3A)
#define REG_PM_SCDC_P1_1D_H           (REG_PM_SCDC_P1_BASE + 0x3B)
#define REG_PM_SCDC_P1_1E_L           (REG_PM_SCDC_P1_BASE + 0x3C)
#define REG_PM_SCDC_P1_1E_H           (REG_PM_SCDC_P1_BASE + 0x3D)
#define REG_PM_SCDC_P1_1F_L           (REG_PM_SCDC_P1_BASE + 0x3E)
#define REG_PM_SCDC_P1_1F_H           (REG_PM_SCDC_P1_BASE + 0x3F)
#define REG_PM_SCDC_P1_20_L           (REG_PM_SCDC_P1_BASE + 0x40)
#define REG_PM_SCDC_P1_20_H           (REG_PM_SCDC_P1_BASE + 0x41)
#define REG_PM_SCDC_P1_21_L           (REG_PM_SCDC_P1_BASE + 0x42)
#define REG_PM_SCDC_P1_21_H           (REG_PM_SCDC_P1_BASE + 0x43)
#define REG_PM_SCDC_P1_22_L           (REG_PM_SCDC_P1_BASE + 0x44)
#define REG_PM_SCDC_P1_22_H           (REG_PM_SCDC_P1_BASE + 0x45)
#define REG_PM_SCDC_P1_23_L           (REG_PM_SCDC_P1_BASE + 0x46)
#define REG_PM_SCDC_P1_23_H           (REG_PM_SCDC_P1_BASE + 0x47)
#define REG_PM_SCDC_P1_24_L           (REG_PM_SCDC_P1_BASE + 0x48)
#define REG_PM_SCDC_P1_24_H           (REG_PM_SCDC_P1_BASE + 0x49)
#define REG_PM_SCDC_P1_25_L           (REG_PM_SCDC_P1_BASE + 0x4A)
#define REG_PM_SCDC_P1_25_H           (REG_PM_SCDC_P1_BASE + 0x4B)
#define REG_PM_SCDC_P1_26_L           (REG_PM_SCDC_P1_BASE + 0x4C)
#define REG_PM_SCDC_P1_26_H           (REG_PM_SCDC_P1_BASE + 0x4D)
#define REG_PM_SCDC_P1_27_L           (REG_PM_SCDC_P1_BASE + 0x4E)
#define REG_PM_SCDC_P1_27_H           (REG_PM_SCDC_P1_BASE + 0x4F)
#define REG_PM_SCDC_P1_28_L           (REG_PM_SCDC_P1_BASE + 0x50)
#define REG_PM_SCDC_P1_28_H           (REG_PM_SCDC_P1_BASE + 0x51)
#define REG_PM_SCDC_P1_29_L           (REG_PM_SCDC_P1_BASE + 0x52)
#define REG_PM_SCDC_P1_29_H           (REG_PM_SCDC_P1_BASE + 0x53)
#define REG_PM_SCDC_P1_2A_L           (REG_PM_SCDC_P1_BASE + 0x54)
#define REG_PM_SCDC_P1_2A_H           (REG_PM_SCDC_P1_BASE + 0x55)
#define REG_PM_SCDC_P1_2B_L           (REG_PM_SCDC_P1_BASE + 0x56)
#define REG_PM_SCDC_P1_2B_H           (REG_PM_SCDC_P1_BASE + 0x57)
#define REG_PM_SCDC_P1_2C_L           (REG_PM_SCDC_P1_BASE + 0x58)
#define REG_PM_SCDC_P1_2C_H           (REG_PM_SCDC_P1_BASE + 0x59)
#define REG_PM_SCDC_P1_2D_L           (REG_PM_SCDC_P1_BASE + 0x5A)
#define REG_PM_SCDC_P1_2D_H           (REG_PM_SCDC_P1_BASE + 0x5B)
#define REG_PM_SCDC_P1_2E_L           (REG_PM_SCDC_P1_BASE + 0x5C)
#define REG_PM_SCDC_P1_2E_H           (REG_PM_SCDC_P1_BASE + 0x5D)
#define REG_PM_SCDC_P1_2F_L           (REG_PM_SCDC_P1_BASE + 0x5E)
#define REG_PM_SCDC_P1_2F_H           (REG_PM_SCDC_P1_BASE + 0x5F)
#define REG_PM_SCDC_P1_30_L           (REG_PM_SCDC_P1_BASE + 0x60)
#define REG_PM_SCDC_P1_30_H           (REG_PM_SCDC_P1_BASE + 0x61)
#define REG_PM_SCDC_P1_31_L           (REG_PM_SCDC_P1_BASE + 0x62)
#define REG_PM_SCDC_P1_31_H           (REG_PM_SCDC_P1_BASE + 0x63)
#define REG_PM_SCDC_P1_32_L           (REG_PM_SCDC_P1_BASE + 0x64)
#define REG_PM_SCDC_P1_32_H           (REG_PM_SCDC_P1_BASE + 0x65)
#define REG_PM_SCDC_P1_33_L           (REG_PM_SCDC_P1_BASE + 0x66)
#define REG_PM_SCDC_P1_33_H           (REG_PM_SCDC_P1_BASE + 0x67)
#define REG_PM_SCDC_P1_34_L           (REG_PM_SCDC_P1_BASE + 0x68)
#define REG_PM_SCDC_P1_34_H           (REG_PM_SCDC_P1_BASE + 0x69)
#define REG_PM_SCDC_P1_35_L           (REG_PM_SCDC_P1_BASE + 0x6A)
#define REG_PM_SCDC_P1_35_H           (REG_PM_SCDC_P1_BASE + 0x6B)
#define REG_PM_SCDC_P1_36_L           (REG_PM_SCDC_P1_BASE + 0x6C)
#define REG_PM_SCDC_P1_36_H           (REG_PM_SCDC_P1_BASE + 0x6D)
#define REG_PM_SCDC_P1_37_L           (REG_PM_SCDC_P1_BASE + 0x6E)
#define REG_PM_SCDC_P1_37_H           (REG_PM_SCDC_P1_BASE + 0x6F)
#define REG_PM_SCDC_P1_38_L           (REG_PM_SCDC_P1_BASE + 0x70)
#define REG_PM_SCDC_P1_38_H           (REG_PM_SCDC_P1_BASE + 0x71)
#define REG_PM_SCDC_P1_39_L           (REG_PM_SCDC_P1_BASE + 0x72)
#define REG_PM_SCDC_P1_39_H           (REG_PM_SCDC_P1_BASE + 0x73)
#define REG_PM_SCDC_P1_3A_L           (REG_PM_SCDC_P1_BASE + 0x74)
#define REG_PM_SCDC_P1_3A_H           (REG_PM_SCDC_P1_BASE + 0x75)
#define REG_PM_SCDC_P1_3B_L           (REG_PM_SCDC_P1_BASE + 0x76)
#define REG_PM_SCDC_P1_3B_H           (REG_PM_SCDC_P1_BASE + 0x77)
#define REG_PM_SCDC_P1_3C_L           (REG_PM_SCDC_P1_BASE + 0x78)
#define REG_PM_SCDC_P1_3C_H           (REG_PM_SCDC_P1_BASE + 0x79)
#define REG_PM_SCDC_P1_3D_L           (REG_PM_SCDC_P1_BASE + 0x7A)
#define REG_PM_SCDC_P1_3D_H           (REG_PM_SCDC_P1_BASE + 0x7B)
#define REG_PM_SCDC_P1_3E_L           (REG_PM_SCDC_P1_BASE + 0x7C)
#define REG_PM_SCDC_P1_3E_H           (REG_PM_SCDC_P1_BASE + 0x7D)
#define REG_PM_SCDC_P1_3F_L           (REG_PM_SCDC_P1_BASE + 0x7E)
#define REG_PM_SCDC_P1_3F_H           (REG_PM_SCDC_P1_BASE + 0x7F)
#define REG_PM_SCDC_P1_40_L           (REG_PM_SCDC_P1_BASE + 0x80)
#define REG_PM_SCDC_P1_40_H           (REG_PM_SCDC_P1_BASE + 0x81)
#define REG_PM_SCDC_P1_41_L           (REG_PM_SCDC_P1_BASE + 0x82)
#define REG_PM_SCDC_P1_41_H           (REG_PM_SCDC_P1_BASE + 0x83)
#define REG_PM_SCDC_P1_42_L           (REG_PM_SCDC_P1_BASE + 0x84)
#define REG_PM_SCDC_P1_42_H           (REG_PM_SCDC_P1_BASE + 0x85)
#define REG_PM_SCDC_P1_43_L           (REG_PM_SCDC_P1_BASE + 0x86)
#define REG_PM_SCDC_P1_43_H           (REG_PM_SCDC_P1_BASE + 0x87)
#define REG_PM_SCDC_P1_44_L           (REG_PM_SCDC_P1_BASE + 0x88)
#define REG_PM_SCDC_P1_44_H           (REG_PM_SCDC_P1_BASE + 0x89)
#define REG_PM_SCDC_P1_45_L           (REG_PM_SCDC_P1_BASE + 0x8A)
#define REG_PM_SCDC_P1_45_H           (REG_PM_SCDC_P1_BASE + 0x8B)
#define REG_PM_SCDC_P1_46_L           (REG_PM_SCDC_P1_BASE + 0x8C)
#define REG_PM_SCDC_P1_46_H           (REG_PM_SCDC_P1_BASE + 0x8D)
#define REG_PM_SCDC_P1_47_L           (REG_PM_SCDC_P1_BASE + 0x8E)
#define REG_PM_SCDC_P1_47_H           (REG_PM_SCDC_P1_BASE + 0x8F)
#define REG_PM_SCDC_P1_48_L           (REG_PM_SCDC_P1_BASE + 0x90)
#define REG_PM_SCDC_P1_48_H           (REG_PM_SCDC_P1_BASE + 0x91)
#define REG_PM_SCDC_P1_49_L           (REG_PM_SCDC_P1_BASE + 0x92)
#define REG_PM_SCDC_P1_49_H           (REG_PM_SCDC_P1_BASE + 0x93)
#define REG_PM_SCDC_P1_4A_L           (REG_PM_SCDC_P1_BASE + 0x94)
#define REG_PM_SCDC_P1_4A_H           (REG_PM_SCDC_P1_BASE + 0x95)
#define REG_PM_SCDC_P1_4B_L           (REG_PM_SCDC_P1_BASE + 0x96)
#define REG_PM_SCDC_P1_4B_H           (REG_PM_SCDC_P1_BASE + 0x97)
#define REG_PM_SCDC_P1_4C_L           (REG_PM_SCDC_P1_BASE + 0x98)
#define REG_PM_SCDC_P1_4C_H           (REG_PM_SCDC_P1_BASE + 0x99)
#define REG_PM_SCDC_P1_4D_L           (REG_PM_SCDC_P1_BASE + 0x9A)
#define REG_PM_SCDC_P1_4D_H           (REG_PM_SCDC_P1_BASE + 0x9B)
#define REG_PM_SCDC_P1_4E_L           (REG_PM_SCDC_P1_BASE + 0x9C)
#define REG_PM_SCDC_P1_4E_H           (REG_PM_SCDC_P1_BASE + 0x9D)
#define REG_PM_SCDC_P1_4F_L           (REG_PM_SCDC_P1_BASE + 0x9E)
#define REG_PM_SCDC_P1_4F_H           (REG_PM_SCDC_P1_BASE + 0x9F)
#define REG_PM_SCDC_P1_50_L           (REG_PM_SCDC_P1_BASE + 0xA0)
#define REG_PM_SCDC_P1_50_H           (REG_PM_SCDC_P1_BASE + 0xA1)
#define REG_PM_SCDC_P1_51_L           (REG_PM_SCDC_P1_BASE + 0xA2)
#define REG_PM_SCDC_P1_51_H           (REG_PM_SCDC_P1_BASE + 0xA3)
#define REG_PM_SCDC_P1_52_L           (REG_PM_SCDC_P1_BASE + 0xA4)
#define REG_PM_SCDC_P1_52_H           (REG_PM_SCDC_P1_BASE + 0xA5)
#define REG_PM_SCDC_P1_53_L           (REG_PM_SCDC_P1_BASE + 0xA6)
#define REG_PM_SCDC_P1_53_H           (REG_PM_SCDC_P1_BASE + 0xA7)
#define REG_PM_SCDC_P1_54_L           (REG_PM_SCDC_P1_BASE + 0xA8)
#define REG_PM_SCDC_P1_54_H           (REG_PM_SCDC_P1_BASE + 0xA9)
#define REG_PM_SCDC_P1_55_L           (REG_PM_SCDC_P1_BASE + 0xAA)
#define REG_PM_SCDC_P1_55_H           (REG_PM_SCDC_P1_BASE + 0xAB)
#define REG_PM_SCDC_P1_56_L           (REG_PM_SCDC_P1_BASE + 0xAC)
#define REG_PM_SCDC_P1_56_H           (REG_PM_SCDC_P1_BASE + 0xAD)
#define REG_PM_SCDC_P1_57_L           (REG_PM_SCDC_P1_BASE + 0xAE)
#define REG_PM_SCDC_P1_57_H           (REG_PM_SCDC_P1_BASE + 0xAF)
#define REG_PM_SCDC_P1_58_L           (REG_PM_SCDC_P1_BASE + 0xB0)
#define REG_PM_SCDC_P1_58_H           (REG_PM_SCDC_P1_BASE + 0xB1)
#define REG_PM_SCDC_P1_59_L           (REG_PM_SCDC_P1_BASE + 0xB2)
#define REG_PM_SCDC_P1_59_H           (REG_PM_SCDC_P1_BASE + 0xB3)
#define REG_PM_SCDC_P1_5A_L           (REG_PM_SCDC_P1_BASE + 0xB4)
#define REG_PM_SCDC_P1_5A_H           (REG_PM_SCDC_P1_BASE + 0xB5)
#define REG_PM_SCDC_P1_5B_L           (REG_PM_SCDC_P1_BASE + 0xB6)
#define REG_PM_SCDC_P1_5B_H           (REG_PM_SCDC_P1_BASE + 0xB7)
#define REG_PM_SCDC_P1_5C_L           (REG_PM_SCDC_P1_BASE + 0xB8)
#define REG_PM_SCDC_P1_5C_H           (REG_PM_SCDC_P1_BASE + 0xB9)
#define REG_PM_SCDC_P1_5D_L           (REG_PM_SCDC_P1_BASE + 0xBA)
#define REG_PM_SCDC_P1_5D_H           (REG_PM_SCDC_P1_BASE + 0xBB)
#define REG_PM_SCDC_P1_5E_L           (REG_PM_SCDC_P1_BASE + 0xBC)
#define REG_PM_SCDC_P1_5E_H           (REG_PM_SCDC_P1_BASE + 0xBD)
#define REG_PM_SCDC_P1_5F_L           (REG_PM_SCDC_P1_BASE + 0xBE)
#define REG_PM_SCDC_P1_5F_H           (REG_PM_SCDC_P1_BASE + 0xBF)
#define REG_PM_SCDC_P1_60_L           (REG_PM_SCDC_P1_BASE + 0xC0)
#define REG_PM_SCDC_P1_60_H           (REG_PM_SCDC_P1_BASE + 0xC1)
#define REG_PM_SCDC_P1_61_L           (REG_PM_SCDC_P1_BASE + 0xC2)
#define REG_PM_SCDC_P1_61_H           (REG_PM_SCDC_P1_BASE + 0xC3)
#define REG_PM_SCDC_P1_62_L           (REG_PM_SCDC_P1_BASE + 0xC4)
#define REG_PM_SCDC_P1_62_H           (REG_PM_SCDC_P1_BASE + 0xC5)
#define REG_PM_SCDC_P1_63_L           (REG_PM_SCDC_P1_BASE + 0xC6)
#define REG_PM_SCDC_P1_63_H           (REG_PM_SCDC_P1_BASE + 0xC7)
#define REG_PM_SCDC_P1_64_L           (REG_PM_SCDC_P1_BASE + 0xC8)
#define REG_PM_SCDC_P1_64_H           (REG_PM_SCDC_P1_BASE + 0xC9)
#define REG_PM_SCDC_P1_65_L           (REG_PM_SCDC_P1_BASE + 0xCA)
#define REG_PM_SCDC_P1_65_H           (REG_PM_SCDC_P1_BASE + 0xCB)
#define REG_PM_SCDC_P1_66_L           (REG_PM_SCDC_P1_BASE + 0xCC)
#define REG_PM_SCDC_P1_66_H           (REG_PM_SCDC_P1_BASE + 0xCD)
#define REG_PM_SCDC_P1_67_L           (REG_PM_SCDC_P1_BASE + 0xCE)
#define REG_PM_SCDC_P1_67_H           (REG_PM_SCDC_P1_BASE + 0xCF)
#define REG_PM_SCDC_P1_68_L           (REG_PM_SCDC_P1_BASE + 0xD0)
#define REG_PM_SCDC_P1_68_H           (REG_PM_SCDC_P1_BASE + 0xD1)
#define REG_PM_SCDC_P1_69_L           (REG_PM_SCDC_P1_BASE + 0xD2)
#define REG_PM_SCDC_P1_69_H           (REG_PM_SCDC_P1_BASE + 0xD3)
#define REG_PM_SCDC_P1_6A_L           (REG_PM_SCDC_P1_BASE + 0xD4)
#define REG_PM_SCDC_P1_6A_H           (REG_PM_SCDC_P1_BASE + 0xD5)
#define REG_PM_SCDC_P1_6B_L           (REG_PM_SCDC_P1_BASE + 0xD6)
#define REG_PM_SCDC_P1_6B_H           (REG_PM_SCDC_P1_BASE + 0xD7)
#define REG_PM_SCDC_P1_6C_L           (REG_PM_SCDC_P1_BASE + 0xD8)
#define REG_PM_SCDC_P1_6C_H           (REG_PM_SCDC_P1_BASE + 0xD9)
#define REG_PM_SCDC_P1_6D_L           (REG_PM_SCDC_P1_BASE + 0xDA)
#define REG_PM_SCDC_P1_6D_H           (REG_PM_SCDC_P1_BASE + 0xDB)
#define REG_PM_SCDC_P1_6E_L           (REG_PM_SCDC_P1_BASE + 0xDC)
#define REG_PM_SCDC_P1_6E_H           (REG_PM_SCDC_P1_BASE + 0xDD)
#define REG_PM_SCDC_P1_6F_L           (REG_PM_SCDC_P1_BASE + 0xDE)
#define REG_PM_SCDC_P1_6F_H           (REG_PM_SCDC_P1_BASE + 0xDF)
#define REG_PM_SCDC_P1_70_L           (REG_PM_SCDC_P1_BASE + 0xE0)
#define REG_PM_SCDC_P1_70_H           (REG_PM_SCDC_P1_BASE + 0xE1)
#define REG_PM_SCDC_P1_71_L           (REG_PM_SCDC_P1_BASE + 0xE2)
#define REG_PM_SCDC_P1_71_H           (REG_PM_SCDC_P1_BASE + 0xE3)
#define REG_PM_SCDC_P1_72_L           (REG_PM_SCDC_P1_BASE + 0xE4)
#define REG_PM_SCDC_P1_72_H           (REG_PM_SCDC_P1_BASE + 0xE5)
#define REG_PM_SCDC_P1_73_L           (REG_PM_SCDC_P1_BASE + 0xE6)
#define REG_PM_SCDC_P1_73_H           (REG_PM_SCDC_P1_BASE + 0xE7)
#define REG_PM_SCDC_P1_74_L           (REG_PM_SCDC_P1_BASE + 0xE8)
#define REG_PM_SCDC_P1_74_H           (REG_PM_SCDC_P1_BASE + 0xE9)
#define REG_PM_SCDC_P1_75_L           (REG_PM_SCDC_P1_BASE + 0xEA)
#define REG_PM_SCDC_P1_75_H           (REG_PM_SCDC_P1_BASE + 0xEB)
#define REG_PM_SCDC_P1_76_L           (REG_PM_SCDC_P1_BASE + 0xEC)
#define REG_PM_SCDC_P1_76_H           (REG_PM_SCDC_P1_BASE + 0xED)
#define REG_PM_SCDC_P1_77_L           (REG_PM_SCDC_P1_BASE + 0xEE)
#define REG_PM_SCDC_P1_77_H           (REG_PM_SCDC_P1_BASE + 0xEF)
#define REG_PM_SCDC_P1_78_L           (REG_PM_SCDC_P1_BASE + 0xF0)
#define REG_PM_SCDC_P1_78_H           (REG_PM_SCDC_P1_BASE + 0xF1)
#define REG_PM_SCDC_P1_79_L           (REG_PM_SCDC_P1_BASE + 0xF2)
#define REG_PM_SCDC_P1_79_H           (REG_PM_SCDC_P1_BASE + 0xF3)
#define REG_PM_SCDC_P1_7A_L           (REG_PM_SCDC_P1_BASE + 0xF4)
#define REG_PM_SCDC_P1_7A_H           (REG_PM_SCDC_P1_BASE + 0xF5)
#define REG_PM_SCDC_P1_7B_L           (REG_PM_SCDC_P1_BASE + 0xF6)
#define REG_PM_SCDC_P1_7B_H           (REG_PM_SCDC_P1_BASE + 0xF7)
#define REG_PM_SCDC_P1_7C_L           (REG_PM_SCDC_P1_BASE + 0xF8)
#define REG_PM_SCDC_P1_7C_H           (REG_PM_SCDC_P1_BASE + 0xF9)
#define REG_PM_SCDC_P1_7D_L           (REG_PM_SCDC_P1_BASE + 0xFA)
#define REG_PM_SCDC_P1_7D_H           (REG_PM_SCDC_P1_BASE + 0xFB)
#define REG_PM_SCDC_P1_7E_L           (REG_PM_SCDC_P1_BASE + 0xFC)
#define REG_PM_SCDC_P1_7E_H           (REG_PM_SCDC_P1_BASE + 0xFD)
#define REG_PM_SCDC_P1_7F_L           (REG_PM_SCDC_P1_BASE + 0xFE)
#define REG_PM_SCDC_P1_7F_H           (REG_PM_SCDC_P1_BASE + 0xFF)


//=============================================================
// PM_SCDC_P2
#define REG_PM_SCDC_P2_00_L           (REG_PM_SCDC_P2_BASE + 0x00)
#define REG_PM_SCDC_P2_00_H           (REG_PM_SCDC_P2_BASE + 0x01)
#define REG_PM_SCDC_P2_01_L           (REG_PM_SCDC_P2_BASE + 0x02)
#define REG_PM_SCDC_P2_01_H           (REG_PM_SCDC_P2_BASE + 0x03)
#define REG_PM_SCDC_P2_02_L           (REG_PM_SCDC_P2_BASE + 0x04)
#define REG_PM_SCDC_P2_02_H           (REG_PM_SCDC_P2_BASE + 0x05)
#define REG_PM_SCDC_P2_03_L           (REG_PM_SCDC_P2_BASE + 0x06)
#define REG_PM_SCDC_P2_03_H           (REG_PM_SCDC_P2_BASE + 0x07)
#define REG_PM_SCDC_P2_04_L           (REG_PM_SCDC_P2_BASE + 0x08)
#define REG_PM_SCDC_P2_04_H           (REG_PM_SCDC_P2_BASE + 0x09)
#define REG_PM_SCDC_P2_05_L           (REG_PM_SCDC_P2_BASE + 0x0A)
#define REG_PM_SCDC_P2_05_H           (REG_PM_SCDC_P2_BASE + 0x0B)
#define REG_PM_SCDC_P2_06_L           (REG_PM_SCDC_P2_BASE + 0x0C)
#define REG_PM_SCDC_P2_06_H           (REG_PM_SCDC_P2_BASE + 0x0D)
#define REG_PM_SCDC_P2_07_L           (REG_PM_SCDC_P2_BASE + 0x0E)
#define REG_PM_SCDC_P2_07_H           (REG_PM_SCDC_P2_BASE + 0x0F)
#define REG_PM_SCDC_P2_08_L           (REG_PM_SCDC_P2_BASE + 0x10)
#define REG_PM_SCDC_P2_08_H           (REG_PM_SCDC_P2_BASE + 0x11)
#define REG_PM_SCDC_P2_09_L           (REG_PM_SCDC_P2_BASE + 0x12)
#define REG_PM_SCDC_P2_09_H           (REG_PM_SCDC_P2_BASE + 0x13)
#define REG_PM_SCDC_P2_0A_L           (REG_PM_SCDC_P2_BASE + 0x14)
#define REG_PM_SCDC_P2_0A_H           (REG_PM_SCDC_P2_BASE + 0x15)
#define REG_PM_SCDC_P2_0B_L           (REG_PM_SCDC_P2_BASE + 0x16)
#define REG_PM_SCDC_P2_0B_H           (REG_PM_SCDC_P2_BASE + 0x17)
#define REG_PM_SCDC_P2_0C_L           (REG_PM_SCDC_P2_BASE + 0x18)
#define REG_PM_SCDC_P2_0C_H           (REG_PM_SCDC_P2_BASE + 0x19)
#define REG_PM_SCDC_P2_0D_L           (REG_PM_SCDC_P2_BASE + 0x1A)
#define REG_PM_SCDC_P2_0D_H           (REG_PM_SCDC_P2_BASE + 0x1B)
#define REG_PM_SCDC_P2_0E_L           (REG_PM_SCDC_P2_BASE + 0x1C)
#define REG_PM_SCDC_P2_0E_H           (REG_PM_SCDC_P2_BASE + 0x1D)
#define REG_PM_SCDC_P2_0F_L           (REG_PM_SCDC_P2_BASE + 0x1E)
#define REG_PM_SCDC_P2_0F_H           (REG_PM_SCDC_P2_BASE + 0x1F)
#define REG_PM_SCDC_P2_10_L           (REG_PM_SCDC_P2_BASE + 0x20)
#define REG_PM_SCDC_P2_10_H           (REG_PM_SCDC_P2_BASE + 0x21)
#define REG_PM_SCDC_P2_11_L           (REG_PM_SCDC_P2_BASE + 0x22)
#define REG_PM_SCDC_P2_11_H           (REG_PM_SCDC_P2_BASE + 0x23)
#define REG_PM_SCDC_P2_12_L           (REG_PM_SCDC_P2_BASE + 0x24)
#define REG_PM_SCDC_P2_12_H           (REG_PM_SCDC_P2_BASE + 0x25)
#define REG_PM_SCDC_P2_13_L           (REG_PM_SCDC_P2_BASE + 0x26)
#define REG_PM_SCDC_P2_13_H           (REG_PM_SCDC_P2_BASE + 0x27)
#define REG_PM_SCDC_P2_14_L           (REG_PM_SCDC_P2_BASE + 0x28)
#define REG_PM_SCDC_P2_14_H           (REG_PM_SCDC_P2_BASE + 0x29)
#define REG_PM_SCDC_P2_15_L           (REG_PM_SCDC_P2_BASE + 0x2A)
#define REG_PM_SCDC_P2_15_H           (REG_PM_SCDC_P2_BASE + 0x2B)
#define REG_PM_SCDC_P2_16_L           (REG_PM_SCDC_P2_BASE + 0x2C)
#define REG_PM_SCDC_P2_16_H           (REG_PM_SCDC_P2_BASE + 0x2D)
#define REG_PM_SCDC_P2_17_L           (REG_PM_SCDC_P2_BASE + 0x2E)
#define REG_PM_SCDC_P2_17_H           (REG_PM_SCDC_P2_BASE + 0x2F)
#define REG_PM_SCDC_P2_18_L           (REG_PM_SCDC_P2_BASE + 0x30)
#define REG_PM_SCDC_P2_18_H           (REG_PM_SCDC_P2_BASE + 0x31)
#define REG_PM_SCDC_P2_19_L           (REG_PM_SCDC_P2_BASE + 0x32)
#define REG_PM_SCDC_P2_19_H           (REG_PM_SCDC_P2_BASE + 0x33)
#define REG_PM_SCDC_P2_1A_L           (REG_PM_SCDC_P2_BASE + 0x34)
#define REG_PM_SCDC_P2_1A_H           (REG_PM_SCDC_P2_BASE + 0x35)
#define REG_PM_SCDC_P2_1B_L           (REG_PM_SCDC_P2_BASE + 0x36)
#define REG_PM_SCDC_P2_1B_H           (REG_PM_SCDC_P2_BASE + 0x37)
#define REG_PM_SCDC_P2_1C_L           (REG_PM_SCDC_P2_BASE + 0x38)
#define REG_PM_SCDC_P2_1C_H           (REG_PM_SCDC_P2_BASE + 0x39)
#define REG_PM_SCDC_P2_1D_L           (REG_PM_SCDC_P2_BASE + 0x3A)
#define REG_PM_SCDC_P2_1D_H           (REG_PM_SCDC_P2_BASE + 0x3B)
#define REG_PM_SCDC_P2_1E_L           (REG_PM_SCDC_P2_BASE + 0x3C)
#define REG_PM_SCDC_P2_1E_H           (REG_PM_SCDC_P2_BASE + 0x3D)
#define REG_PM_SCDC_P2_1F_L           (REG_PM_SCDC_P2_BASE + 0x3E)
#define REG_PM_SCDC_P2_1F_H           (REG_PM_SCDC_P2_BASE + 0x3F)
#define REG_PM_SCDC_P2_20_L           (REG_PM_SCDC_P2_BASE + 0x40)
#define REG_PM_SCDC_P2_20_H           (REG_PM_SCDC_P2_BASE + 0x41)
#define REG_PM_SCDC_P2_21_L           (REG_PM_SCDC_P2_BASE + 0x42)
#define REG_PM_SCDC_P2_21_H           (REG_PM_SCDC_P2_BASE + 0x43)
#define REG_PM_SCDC_P2_22_L           (REG_PM_SCDC_P2_BASE + 0x44)
#define REG_PM_SCDC_P2_22_H           (REG_PM_SCDC_P2_BASE + 0x45)
#define REG_PM_SCDC_P2_23_L           (REG_PM_SCDC_P2_BASE + 0x46)
#define REG_PM_SCDC_P2_23_H           (REG_PM_SCDC_P2_BASE + 0x47)
#define REG_PM_SCDC_P2_24_L           (REG_PM_SCDC_P2_BASE + 0x48)
#define REG_PM_SCDC_P2_24_H           (REG_PM_SCDC_P2_BASE + 0x49)
#define REG_PM_SCDC_P2_25_L           (REG_PM_SCDC_P2_BASE + 0x4A)
#define REG_PM_SCDC_P2_25_H           (REG_PM_SCDC_P2_BASE + 0x4B)
#define REG_PM_SCDC_P2_26_L           (REG_PM_SCDC_P2_BASE + 0x4C)
#define REG_PM_SCDC_P2_26_H           (REG_PM_SCDC_P2_BASE + 0x4D)
#define REG_PM_SCDC_P2_27_L           (REG_PM_SCDC_P2_BASE + 0x4E)
#define REG_PM_SCDC_P2_27_H           (REG_PM_SCDC_P2_BASE + 0x4F)
#define REG_PM_SCDC_P2_28_L           (REG_PM_SCDC_P2_BASE + 0x50)
#define REG_PM_SCDC_P2_28_H           (REG_PM_SCDC_P2_BASE + 0x51)
#define REG_PM_SCDC_P2_29_L           (REG_PM_SCDC_P2_BASE + 0x52)
#define REG_PM_SCDC_P2_29_H           (REG_PM_SCDC_P2_BASE + 0x53)
#define REG_PM_SCDC_P2_2A_L           (REG_PM_SCDC_P2_BASE + 0x54)
#define REG_PM_SCDC_P2_2A_H           (REG_PM_SCDC_P2_BASE + 0x55)
#define REG_PM_SCDC_P2_2B_L           (REG_PM_SCDC_P2_BASE + 0x56)
#define REG_PM_SCDC_P2_2B_H           (REG_PM_SCDC_P2_BASE + 0x57)
#define REG_PM_SCDC_P2_2C_L           (REG_PM_SCDC_P2_BASE + 0x58)
#define REG_PM_SCDC_P2_2C_H           (REG_PM_SCDC_P2_BASE + 0x59)
#define REG_PM_SCDC_P2_2D_L           (REG_PM_SCDC_P2_BASE + 0x5A)
#define REG_PM_SCDC_P2_2D_H           (REG_PM_SCDC_P2_BASE + 0x5B)
#define REG_PM_SCDC_P2_2E_L           (REG_PM_SCDC_P2_BASE + 0x5C)
#define REG_PM_SCDC_P2_2E_H           (REG_PM_SCDC_P2_BASE + 0x5D)
#define REG_PM_SCDC_P2_2F_L           (REG_PM_SCDC_P2_BASE + 0x5E)
#define REG_PM_SCDC_P2_2F_H           (REG_PM_SCDC_P2_BASE + 0x5F)
#define REG_PM_SCDC_P2_30_L           (REG_PM_SCDC_P2_BASE + 0x60)
#define REG_PM_SCDC_P2_30_H           (REG_PM_SCDC_P2_BASE + 0x61)
#define REG_PM_SCDC_P2_31_L           (REG_PM_SCDC_P2_BASE + 0x62)
#define REG_PM_SCDC_P2_31_H           (REG_PM_SCDC_P2_BASE + 0x63)
#define REG_PM_SCDC_P2_32_L           (REG_PM_SCDC_P2_BASE + 0x64)
#define REG_PM_SCDC_P2_32_H           (REG_PM_SCDC_P2_BASE + 0x65)
#define REG_PM_SCDC_P2_33_L           (REG_PM_SCDC_P2_BASE + 0x66)
#define REG_PM_SCDC_P2_33_H           (REG_PM_SCDC_P2_BASE + 0x67)
#define REG_PM_SCDC_P2_34_L           (REG_PM_SCDC_P2_BASE + 0x68)
#define REG_PM_SCDC_P2_34_H           (REG_PM_SCDC_P2_BASE + 0x69)
#define REG_PM_SCDC_P2_35_L           (REG_PM_SCDC_P2_BASE + 0x6A)
#define REG_PM_SCDC_P2_35_H           (REG_PM_SCDC_P2_BASE + 0x6B)
#define REG_PM_SCDC_P2_36_L           (REG_PM_SCDC_P2_BASE + 0x6C)
#define REG_PM_SCDC_P2_36_H           (REG_PM_SCDC_P2_BASE + 0x6D)
#define REG_PM_SCDC_P2_37_L           (REG_PM_SCDC_P2_BASE + 0x6E)
#define REG_PM_SCDC_P2_37_H           (REG_PM_SCDC_P2_BASE + 0x6F)
#define REG_PM_SCDC_P2_38_L           (REG_PM_SCDC_P2_BASE + 0x70)
#define REG_PM_SCDC_P2_38_H           (REG_PM_SCDC_P2_BASE + 0x71)
#define REG_PM_SCDC_P2_39_L           (REG_PM_SCDC_P2_BASE + 0x72)
#define REG_PM_SCDC_P2_39_H           (REG_PM_SCDC_P2_BASE + 0x73)
#define REG_PM_SCDC_P2_3A_L           (REG_PM_SCDC_P2_BASE + 0x74)
#define REG_PM_SCDC_P2_3A_H           (REG_PM_SCDC_P2_BASE + 0x75)
#define REG_PM_SCDC_P2_3B_L           (REG_PM_SCDC_P2_BASE + 0x76)
#define REG_PM_SCDC_P2_3B_H           (REG_PM_SCDC_P2_BASE + 0x77)
#define REG_PM_SCDC_P2_3C_L           (REG_PM_SCDC_P2_BASE + 0x78)
#define REG_PM_SCDC_P2_3C_H           (REG_PM_SCDC_P2_BASE + 0x79)
#define REG_PM_SCDC_P2_3D_L           (REG_PM_SCDC_P2_BASE + 0x7A)
#define REG_PM_SCDC_P2_3D_H           (REG_PM_SCDC_P2_BASE + 0x7B)
#define REG_PM_SCDC_P2_3E_L           (REG_PM_SCDC_P2_BASE + 0x7C)
#define REG_PM_SCDC_P2_3E_H           (REG_PM_SCDC_P2_BASE + 0x7D)
#define REG_PM_SCDC_P2_3F_L           (REG_PM_SCDC_P2_BASE + 0x7E)
#define REG_PM_SCDC_P2_3F_H           (REG_PM_SCDC_P2_BASE + 0x7F)
#define REG_PM_SCDC_P2_40_L           (REG_PM_SCDC_P2_BASE + 0x80)
#define REG_PM_SCDC_P2_40_H           (REG_PM_SCDC_P2_BASE + 0x81)
#define REG_PM_SCDC_P2_41_L           (REG_PM_SCDC_P2_BASE + 0x82)
#define REG_PM_SCDC_P2_41_H           (REG_PM_SCDC_P2_BASE + 0x83)
#define REG_PM_SCDC_P2_42_L           (REG_PM_SCDC_P2_BASE + 0x84)
#define REG_PM_SCDC_P2_42_H           (REG_PM_SCDC_P2_BASE + 0x85)
#define REG_PM_SCDC_P2_43_L           (REG_PM_SCDC_P2_BASE + 0x86)
#define REG_PM_SCDC_P2_43_H           (REG_PM_SCDC_P2_BASE + 0x87)
#define REG_PM_SCDC_P2_44_L           (REG_PM_SCDC_P2_BASE + 0x88)
#define REG_PM_SCDC_P2_44_H           (REG_PM_SCDC_P2_BASE + 0x89)
#define REG_PM_SCDC_P2_45_L           (REG_PM_SCDC_P2_BASE + 0x8A)
#define REG_PM_SCDC_P2_45_H           (REG_PM_SCDC_P2_BASE + 0x8B)
#define REG_PM_SCDC_P2_46_L           (REG_PM_SCDC_P2_BASE + 0x8C)
#define REG_PM_SCDC_P2_46_H           (REG_PM_SCDC_P2_BASE + 0x8D)
#define REG_PM_SCDC_P2_47_L           (REG_PM_SCDC_P2_BASE + 0x8E)
#define REG_PM_SCDC_P2_47_H           (REG_PM_SCDC_P2_BASE + 0x8F)
#define REG_PM_SCDC_P2_48_L           (REG_PM_SCDC_P2_BASE + 0x90)
#define REG_PM_SCDC_P2_48_H           (REG_PM_SCDC_P2_BASE + 0x91)
#define REG_PM_SCDC_P2_49_L           (REG_PM_SCDC_P2_BASE + 0x92)
#define REG_PM_SCDC_P2_49_H           (REG_PM_SCDC_P2_BASE + 0x93)
#define REG_PM_SCDC_P2_4A_L           (REG_PM_SCDC_P2_BASE + 0x94)
#define REG_PM_SCDC_P2_4A_H           (REG_PM_SCDC_P2_BASE + 0x95)
#define REG_PM_SCDC_P2_4B_L           (REG_PM_SCDC_P2_BASE + 0x96)
#define REG_PM_SCDC_P2_4B_H           (REG_PM_SCDC_P2_BASE + 0x97)
#define REG_PM_SCDC_P2_4C_L           (REG_PM_SCDC_P2_BASE + 0x98)
#define REG_PM_SCDC_P2_4C_H           (REG_PM_SCDC_P2_BASE + 0x99)
#define REG_PM_SCDC_P2_4D_L           (REG_PM_SCDC_P2_BASE + 0x9A)
#define REG_PM_SCDC_P2_4D_H           (REG_PM_SCDC_P2_BASE + 0x9B)
#define REG_PM_SCDC_P2_4E_L           (REG_PM_SCDC_P2_BASE + 0x9C)
#define REG_PM_SCDC_P2_4E_H           (REG_PM_SCDC_P2_BASE + 0x9D)
#define REG_PM_SCDC_P2_4F_L           (REG_PM_SCDC_P2_BASE + 0x9E)
#define REG_PM_SCDC_P2_4F_H           (REG_PM_SCDC_P2_BASE + 0x9F)
#define REG_PM_SCDC_P2_50_L           (REG_PM_SCDC_P2_BASE + 0xA0)
#define REG_PM_SCDC_P2_50_H           (REG_PM_SCDC_P2_BASE + 0xA1)
#define REG_PM_SCDC_P2_51_L           (REG_PM_SCDC_P2_BASE + 0xA2)
#define REG_PM_SCDC_P2_51_H           (REG_PM_SCDC_P2_BASE + 0xA3)
#define REG_PM_SCDC_P2_52_L           (REG_PM_SCDC_P2_BASE + 0xA4)
#define REG_PM_SCDC_P2_52_H           (REG_PM_SCDC_P2_BASE + 0xA5)
#define REG_PM_SCDC_P2_53_L           (REG_PM_SCDC_P2_BASE + 0xA6)
#define REG_PM_SCDC_P2_53_H           (REG_PM_SCDC_P2_BASE + 0xA7)
#define REG_PM_SCDC_P2_54_L           (REG_PM_SCDC_P2_BASE + 0xA8)
#define REG_PM_SCDC_P2_54_H           (REG_PM_SCDC_P2_BASE + 0xA9)
#define REG_PM_SCDC_P2_55_L           (REG_PM_SCDC_P2_BASE + 0xAA)
#define REG_PM_SCDC_P2_55_H           (REG_PM_SCDC_P2_BASE + 0xAB)
#define REG_PM_SCDC_P2_56_L           (REG_PM_SCDC_P2_BASE + 0xAC)
#define REG_PM_SCDC_P2_56_H           (REG_PM_SCDC_P2_BASE + 0xAD)
#define REG_PM_SCDC_P2_57_L           (REG_PM_SCDC_P2_BASE + 0xAE)
#define REG_PM_SCDC_P2_57_H           (REG_PM_SCDC_P2_BASE + 0xAF)
#define REG_PM_SCDC_P2_58_L           (REG_PM_SCDC_P2_BASE + 0xB0)
#define REG_PM_SCDC_P2_58_H           (REG_PM_SCDC_P2_BASE + 0xB1)
#define REG_PM_SCDC_P2_59_L           (REG_PM_SCDC_P2_BASE + 0xB2)
#define REG_PM_SCDC_P2_59_H           (REG_PM_SCDC_P2_BASE + 0xB3)
#define REG_PM_SCDC_P2_5A_L           (REG_PM_SCDC_P2_BASE + 0xB4)
#define REG_PM_SCDC_P2_5A_H           (REG_PM_SCDC_P2_BASE + 0xB5)
#define REG_PM_SCDC_P2_5B_L           (REG_PM_SCDC_P2_BASE + 0xB6)
#define REG_PM_SCDC_P2_5B_H           (REG_PM_SCDC_P2_BASE + 0xB7)
#define REG_PM_SCDC_P2_5C_L           (REG_PM_SCDC_P2_BASE + 0xB8)
#define REG_PM_SCDC_P2_5C_H           (REG_PM_SCDC_P2_BASE + 0xB9)
#define REG_PM_SCDC_P2_5D_L           (REG_PM_SCDC_P2_BASE + 0xBA)
#define REG_PM_SCDC_P2_5D_H           (REG_PM_SCDC_P2_BASE + 0xBB)
#define REG_PM_SCDC_P2_5E_L           (REG_PM_SCDC_P2_BASE + 0xBC)
#define REG_PM_SCDC_P2_5E_H           (REG_PM_SCDC_P2_BASE + 0xBD)
#define REG_PM_SCDC_P2_5F_L           (REG_PM_SCDC_P2_BASE + 0xBE)
#define REG_PM_SCDC_P2_5F_H           (REG_PM_SCDC_P2_BASE + 0xBF)
#define REG_PM_SCDC_P2_60_L           (REG_PM_SCDC_P2_BASE + 0xC0)
#define REG_PM_SCDC_P2_60_H           (REG_PM_SCDC_P2_BASE + 0xC1)
#define REG_PM_SCDC_P2_61_L           (REG_PM_SCDC_P2_BASE + 0xC2)
#define REG_PM_SCDC_P2_61_H           (REG_PM_SCDC_P2_BASE + 0xC3)
#define REG_PM_SCDC_P2_62_L           (REG_PM_SCDC_P2_BASE + 0xC4)
#define REG_PM_SCDC_P2_62_H           (REG_PM_SCDC_P2_BASE + 0xC5)
#define REG_PM_SCDC_P2_63_L           (REG_PM_SCDC_P2_BASE + 0xC6)
#define REG_PM_SCDC_P2_63_H           (REG_PM_SCDC_P2_BASE + 0xC7)
#define REG_PM_SCDC_P2_64_L           (REG_PM_SCDC_P2_BASE + 0xC8)
#define REG_PM_SCDC_P2_64_H           (REG_PM_SCDC_P2_BASE + 0xC9)
#define REG_PM_SCDC_P2_65_L           (REG_PM_SCDC_P2_BASE + 0xCA)
#define REG_PM_SCDC_P2_65_H           (REG_PM_SCDC_P2_BASE + 0xCB)
#define REG_PM_SCDC_P2_66_L           (REG_PM_SCDC_P2_BASE + 0xCC)
#define REG_PM_SCDC_P2_66_H           (REG_PM_SCDC_P2_BASE + 0xCD)
#define REG_PM_SCDC_P2_67_L           (REG_PM_SCDC_P2_BASE + 0xCE)
#define REG_PM_SCDC_P2_67_H           (REG_PM_SCDC_P2_BASE + 0xCF)
#define REG_PM_SCDC_P2_68_L           (REG_PM_SCDC_P2_BASE + 0xD0)
#define REG_PM_SCDC_P2_68_H           (REG_PM_SCDC_P2_BASE + 0xD1)
#define REG_PM_SCDC_P2_69_L           (REG_PM_SCDC_P2_BASE + 0xD2)
#define REG_PM_SCDC_P2_69_H           (REG_PM_SCDC_P2_BASE + 0xD3)
#define REG_PM_SCDC_P2_6A_L           (REG_PM_SCDC_P2_BASE + 0xD4)
#define REG_PM_SCDC_P2_6A_H           (REG_PM_SCDC_P2_BASE + 0xD5)
#define REG_PM_SCDC_P2_6B_L           (REG_PM_SCDC_P2_BASE + 0xD6)
#define REG_PM_SCDC_P2_6B_H           (REG_PM_SCDC_P2_BASE + 0xD7)
#define REG_PM_SCDC_P2_6C_L           (REG_PM_SCDC_P2_BASE + 0xD8)
#define REG_PM_SCDC_P2_6C_H           (REG_PM_SCDC_P2_BASE + 0xD9)
#define REG_PM_SCDC_P2_6D_L           (REG_PM_SCDC_P2_BASE + 0xDA)
#define REG_PM_SCDC_P2_6D_H           (REG_PM_SCDC_P2_BASE + 0xDB)
#define REG_PM_SCDC_P2_6E_L           (REG_PM_SCDC_P2_BASE + 0xDC)
#define REG_PM_SCDC_P2_6E_H           (REG_PM_SCDC_P2_BASE + 0xDD)
#define REG_PM_SCDC_P2_6F_L           (REG_PM_SCDC_P2_BASE + 0xDE)
#define REG_PM_SCDC_P2_6F_H           (REG_PM_SCDC_P2_BASE + 0xDF)
#define REG_PM_SCDC_P2_70_L           (REG_PM_SCDC_P2_BASE + 0xE0)
#define REG_PM_SCDC_P2_70_H           (REG_PM_SCDC_P2_BASE + 0xE1)
#define REG_PM_SCDC_P2_71_L           (REG_PM_SCDC_P2_BASE + 0xE2)
#define REG_PM_SCDC_P2_71_H           (REG_PM_SCDC_P2_BASE + 0xE3)
#define REG_PM_SCDC_P2_72_L           (REG_PM_SCDC_P2_BASE + 0xE4)
#define REG_PM_SCDC_P2_72_H           (REG_PM_SCDC_P2_BASE + 0xE5)
#define REG_PM_SCDC_P2_73_L           (REG_PM_SCDC_P2_BASE + 0xE6)
#define REG_PM_SCDC_P2_73_H           (REG_PM_SCDC_P2_BASE + 0xE7)
#define REG_PM_SCDC_P2_74_L           (REG_PM_SCDC_P2_BASE + 0xE8)
#define REG_PM_SCDC_P2_74_H           (REG_PM_SCDC_P2_BASE + 0xE9)
#define REG_PM_SCDC_P2_75_L           (REG_PM_SCDC_P2_BASE + 0xEA)
#define REG_PM_SCDC_P2_75_H           (REG_PM_SCDC_P2_BASE + 0xEB)
#define REG_PM_SCDC_P2_76_L           (REG_PM_SCDC_P2_BASE + 0xEC)
#define REG_PM_SCDC_P2_76_H           (REG_PM_SCDC_P2_BASE + 0xED)
#define REG_PM_SCDC_P2_77_L           (REG_PM_SCDC_P2_BASE + 0xEE)
#define REG_PM_SCDC_P2_77_H           (REG_PM_SCDC_P2_BASE + 0xEF)
#define REG_PM_SCDC_P2_78_L           (REG_PM_SCDC_P2_BASE + 0xF0)
#define REG_PM_SCDC_P2_78_H           (REG_PM_SCDC_P2_BASE + 0xF1)
#define REG_PM_SCDC_P2_79_L           (REG_PM_SCDC_P2_BASE + 0xF2)
#define REG_PM_SCDC_P2_79_H           (REG_PM_SCDC_P2_BASE + 0xF3)
#define REG_PM_SCDC_P2_7A_L           (REG_PM_SCDC_P2_BASE + 0xF4)
#define REG_PM_SCDC_P2_7A_H           (REG_PM_SCDC_P2_BASE + 0xF5)
#define REG_PM_SCDC_P2_7B_L           (REG_PM_SCDC_P2_BASE + 0xF6)
#define REG_PM_SCDC_P2_7B_H           (REG_PM_SCDC_P2_BASE + 0xF7)
#define REG_PM_SCDC_P2_7C_L           (REG_PM_SCDC_P2_BASE + 0xF8)
#define REG_PM_SCDC_P2_7C_H           (REG_PM_SCDC_P2_BASE + 0xF9)
#define REG_PM_SCDC_P2_7D_L           (REG_PM_SCDC_P2_BASE + 0xFA)
#define REG_PM_SCDC_P2_7D_H           (REG_PM_SCDC_P2_BASE + 0xFB)
#define REG_PM_SCDC_P2_7E_L           (REG_PM_SCDC_P2_BASE + 0xFC)
#define REG_PM_SCDC_P2_7E_H           (REG_PM_SCDC_P2_BASE + 0xFD)
#define REG_PM_SCDC_P2_7F_L           (REG_PM_SCDC_P2_BASE + 0xFE)
#define REG_PM_SCDC_P2_7F_H           (REG_PM_SCDC_P2_BASE + 0xFF)


//=============================================================
// PM_SCDC_P3
#define REG_PM_SCDC_P3_00_L           (REG_PM_SCDC_P3_BASE + 0x00)
#define REG_PM_SCDC_P3_00_H           (REG_PM_SCDC_P3_BASE + 0x01)
#define REG_PM_SCDC_P3_01_L           (REG_PM_SCDC_P3_BASE + 0x02)
#define REG_PM_SCDC_P3_01_H           (REG_PM_SCDC_P3_BASE + 0x03)
#define REG_PM_SCDC_P3_02_L           (REG_PM_SCDC_P3_BASE + 0x04)
#define REG_PM_SCDC_P3_02_H           (REG_PM_SCDC_P3_BASE + 0x05)
#define REG_PM_SCDC_P3_03_L           (REG_PM_SCDC_P3_BASE + 0x06)
#define REG_PM_SCDC_P3_03_H           (REG_PM_SCDC_P3_BASE + 0x07)
#define REG_PM_SCDC_P3_04_L           (REG_PM_SCDC_P3_BASE + 0x08)
#define REG_PM_SCDC_P3_04_H           (REG_PM_SCDC_P3_BASE + 0x09)
#define REG_PM_SCDC_P3_05_L           (REG_PM_SCDC_P3_BASE + 0x0A)
#define REG_PM_SCDC_P3_05_H           (REG_PM_SCDC_P3_BASE + 0x0B)
#define REG_PM_SCDC_P3_06_L           (REG_PM_SCDC_P3_BASE + 0x0C)
#define REG_PM_SCDC_P3_06_H           (REG_PM_SCDC_P3_BASE + 0x0D)
#define REG_PM_SCDC_P3_07_L           (REG_PM_SCDC_P3_BASE + 0x0E)
#define REG_PM_SCDC_P3_07_H           (REG_PM_SCDC_P3_BASE + 0x0F)
#define REG_PM_SCDC_P3_08_L           (REG_PM_SCDC_P3_BASE + 0x10)
#define REG_PM_SCDC_P3_08_H           (REG_PM_SCDC_P3_BASE + 0x11)
#define REG_PM_SCDC_P3_09_L           (REG_PM_SCDC_P3_BASE + 0x12)
#define REG_PM_SCDC_P3_09_H           (REG_PM_SCDC_P3_BASE + 0x13)
#define REG_PM_SCDC_P3_0A_L           (REG_PM_SCDC_P3_BASE + 0x14)
#define REG_PM_SCDC_P3_0A_H           (REG_PM_SCDC_P3_BASE + 0x15)
#define REG_PM_SCDC_P3_0B_L           (REG_PM_SCDC_P3_BASE + 0x16)
#define REG_PM_SCDC_P3_0B_H           (REG_PM_SCDC_P3_BASE + 0x17)
#define REG_PM_SCDC_P3_0C_L           (REG_PM_SCDC_P3_BASE + 0x18)
#define REG_PM_SCDC_P3_0C_H           (REG_PM_SCDC_P3_BASE + 0x19)
#define REG_PM_SCDC_P3_0D_L           (REG_PM_SCDC_P3_BASE + 0x1A)
#define REG_PM_SCDC_P3_0D_H           (REG_PM_SCDC_P3_BASE + 0x1B)
#define REG_PM_SCDC_P3_0E_L           (REG_PM_SCDC_P3_BASE + 0x1C)
#define REG_PM_SCDC_P3_0E_H           (REG_PM_SCDC_P3_BASE + 0x1D)
#define REG_PM_SCDC_P3_0F_L           (REG_PM_SCDC_P3_BASE + 0x1E)
#define REG_PM_SCDC_P3_0F_H           (REG_PM_SCDC_P3_BASE + 0x1F)
#define REG_PM_SCDC_P3_10_L           (REG_PM_SCDC_P3_BASE + 0x20)
#define REG_PM_SCDC_P3_10_H           (REG_PM_SCDC_P3_BASE + 0x21)
#define REG_PM_SCDC_P3_11_L           (REG_PM_SCDC_P3_BASE + 0x22)
#define REG_PM_SCDC_P3_11_H           (REG_PM_SCDC_P3_BASE + 0x23)
#define REG_PM_SCDC_P3_12_L           (REG_PM_SCDC_P3_BASE + 0x24)
#define REG_PM_SCDC_P3_12_H           (REG_PM_SCDC_P3_BASE + 0x25)
#define REG_PM_SCDC_P3_13_L           (REG_PM_SCDC_P3_BASE + 0x26)
#define REG_PM_SCDC_P3_13_H           (REG_PM_SCDC_P3_BASE + 0x27)
#define REG_PM_SCDC_P3_14_L           (REG_PM_SCDC_P3_BASE + 0x28)
#define REG_PM_SCDC_P3_14_H           (REG_PM_SCDC_P3_BASE + 0x29)
#define REG_PM_SCDC_P3_15_L           (REG_PM_SCDC_P3_BASE + 0x2A)
#define REG_PM_SCDC_P3_15_H           (REG_PM_SCDC_P3_BASE + 0x2B)
#define REG_PM_SCDC_P3_16_L           (REG_PM_SCDC_P3_BASE + 0x2C)
#define REG_PM_SCDC_P3_16_H           (REG_PM_SCDC_P3_BASE + 0x2D)
#define REG_PM_SCDC_P3_17_L           (REG_PM_SCDC_P3_BASE + 0x2E)
#define REG_PM_SCDC_P3_17_H           (REG_PM_SCDC_P3_BASE + 0x2F)
#define REG_PM_SCDC_P3_18_L           (REG_PM_SCDC_P3_BASE + 0x30)
#define REG_PM_SCDC_P3_18_H           (REG_PM_SCDC_P3_BASE + 0x31)
#define REG_PM_SCDC_P3_19_L           (REG_PM_SCDC_P3_BASE + 0x32)
#define REG_PM_SCDC_P3_19_H           (REG_PM_SCDC_P3_BASE + 0x33)
#define REG_PM_SCDC_P3_1A_L           (REG_PM_SCDC_P3_BASE + 0x34)
#define REG_PM_SCDC_P3_1A_H           (REG_PM_SCDC_P3_BASE + 0x35)
#define REG_PM_SCDC_P3_1B_L           (REG_PM_SCDC_P3_BASE + 0x36)
#define REG_PM_SCDC_P3_1B_H           (REG_PM_SCDC_P3_BASE + 0x37)
#define REG_PM_SCDC_P3_1C_L           (REG_PM_SCDC_P3_BASE + 0x38)
#define REG_PM_SCDC_P3_1C_H           (REG_PM_SCDC_P3_BASE + 0x39)
#define REG_PM_SCDC_P3_1D_L           (REG_PM_SCDC_P3_BASE + 0x3A)
#define REG_PM_SCDC_P3_1D_H           (REG_PM_SCDC_P3_BASE + 0x3B)
#define REG_PM_SCDC_P3_1E_L           (REG_PM_SCDC_P3_BASE + 0x3C)
#define REG_PM_SCDC_P3_1E_H           (REG_PM_SCDC_P3_BASE + 0x3D)
#define REG_PM_SCDC_P3_1F_L           (REG_PM_SCDC_P3_BASE + 0x3E)
#define REG_PM_SCDC_P3_1F_H           (REG_PM_SCDC_P3_BASE + 0x3F)
#define REG_PM_SCDC_P3_20_L           (REG_PM_SCDC_P3_BASE + 0x40)
#define REG_PM_SCDC_P3_20_H           (REG_PM_SCDC_P3_BASE + 0x41)
#define REG_PM_SCDC_P3_21_L           (REG_PM_SCDC_P3_BASE + 0x42)
#define REG_PM_SCDC_P3_21_H           (REG_PM_SCDC_P3_BASE + 0x43)
#define REG_PM_SCDC_P3_22_L           (REG_PM_SCDC_P3_BASE + 0x44)
#define REG_PM_SCDC_P3_22_H           (REG_PM_SCDC_P3_BASE + 0x45)
#define REG_PM_SCDC_P3_23_L           (REG_PM_SCDC_P3_BASE + 0x46)
#define REG_PM_SCDC_P3_23_H           (REG_PM_SCDC_P3_BASE + 0x47)
#define REG_PM_SCDC_P3_24_L           (REG_PM_SCDC_P3_BASE + 0x48)
#define REG_PM_SCDC_P3_24_H           (REG_PM_SCDC_P3_BASE + 0x49)
#define REG_PM_SCDC_P3_25_L           (REG_PM_SCDC_P3_BASE + 0x4A)
#define REG_PM_SCDC_P3_25_H           (REG_PM_SCDC_P3_BASE + 0x4B)
#define REG_PM_SCDC_P3_26_L           (REG_PM_SCDC_P3_BASE + 0x4C)
#define REG_PM_SCDC_P3_26_H           (REG_PM_SCDC_P3_BASE + 0x4D)
#define REG_PM_SCDC_P3_27_L           (REG_PM_SCDC_P3_BASE + 0x4E)
#define REG_PM_SCDC_P3_27_H           (REG_PM_SCDC_P3_BASE + 0x4F)
#define REG_PM_SCDC_P3_28_L           (REG_PM_SCDC_P3_BASE + 0x50)
#define REG_PM_SCDC_P3_28_H           (REG_PM_SCDC_P3_BASE + 0x51)
#define REG_PM_SCDC_P3_29_L           (REG_PM_SCDC_P3_BASE + 0x52)
#define REG_PM_SCDC_P3_29_H           (REG_PM_SCDC_P3_BASE + 0x53)
#define REG_PM_SCDC_P3_2A_L           (REG_PM_SCDC_P3_BASE + 0x54)
#define REG_PM_SCDC_P3_2A_H           (REG_PM_SCDC_P3_BASE + 0x55)
#define REG_PM_SCDC_P3_2B_L           (REG_PM_SCDC_P3_BASE + 0x56)
#define REG_PM_SCDC_P3_2B_H           (REG_PM_SCDC_P3_BASE + 0x57)
#define REG_PM_SCDC_P3_2C_L           (REG_PM_SCDC_P3_BASE + 0x58)
#define REG_PM_SCDC_P3_2C_H           (REG_PM_SCDC_P3_BASE + 0x59)
#define REG_PM_SCDC_P3_2D_L           (REG_PM_SCDC_P3_BASE + 0x5A)
#define REG_PM_SCDC_P3_2D_H           (REG_PM_SCDC_P3_BASE + 0x5B)
#define REG_PM_SCDC_P3_2E_L           (REG_PM_SCDC_P3_BASE + 0x5C)
#define REG_PM_SCDC_P3_2E_H           (REG_PM_SCDC_P3_BASE + 0x5D)
#define REG_PM_SCDC_P3_2F_L           (REG_PM_SCDC_P3_BASE + 0x5E)
#define REG_PM_SCDC_P3_2F_H           (REG_PM_SCDC_P3_BASE + 0x5F)
#define REG_PM_SCDC_P3_30_L           (REG_PM_SCDC_P3_BASE + 0x60)
#define REG_PM_SCDC_P3_30_H           (REG_PM_SCDC_P3_BASE + 0x61)
#define REG_PM_SCDC_P3_31_L           (REG_PM_SCDC_P3_BASE + 0x62)
#define REG_PM_SCDC_P3_31_H           (REG_PM_SCDC_P3_BASE + 0x63)
#define REG_PM_SCDC_P3_32_L           (REG_PM_SCDC_P3_BASE + 0x64)
#define REG_PM_SCDC_P3_32_H           (REG_PM_SCDC_P3_BASE + 0x65)
#define REG_PM_SCDC_P3_33_L           (REG_PM_SCDC_P3_BASE + 0x66)
#define REG_PM_SCDC_P3_33_H           (REG_PM_SCDC_P3_BASE + 0x67)
#define REG_PM_SCDC_P3_34_L           (REG_PM_SCDC_P3_BASE + 0x68)
#define REG_PM_SCDC_P3_34_H           (REG_PM_SCDC_P3_BASE + 0x69)
#define REG_PM_SCDC_P3_35_L           (REG_PM_SCDC_P3_BASE + 0x6A)
#define REG_PM_SCDC_P3_35_H           (REG_PM_SCDC_P3_BASE + 0x6B)
#define REG_PM_SCDC_P3_36_L           (REG_PM_SCDC_P3_BASE + 0x6C)
#define REG_PM_SCDC_P3_36_H           (REG_PM_SCDC_P3_BASE + 0x6D)
#define REG_PM_SCDC_P3_37_L           (REG_PM_SCDC_P3_BASE + 0x6E)
#define REG_PM_SCDC_P3_37_H           (REG_PM_SCDC_P3_BASE + 0x6F)
#define REG_PM_SCDC_P3_38_L           (REG_PM_SCDC_P3_BASE + 0x70)
#define REG_PM_SCDC_P3_38_H           (REG_PM_SCDC_P3_BASE + 0x71)
#define REG_PM_SCDC_P3_39_L           (REG_PM_SCDC_P3_BASE + 0x72)
#define REG_PM_SCDC_P3_39_H           (REG_PM_SCDC_P3_BASE + 0x73)
#define REG_PM_SCDC_P3_3A_L           (REG_PM_SCDC_P3_BASE + 0x74)
#define REG_PM_SCDC_P3_3A_H           (REG_PM_SCDC_P3_BASE + 0x75)
#define REG_PM_SCDC_P3_3B_L           (REG_PM_SCDC_P3_BASE + 0x76)
#define REG_PM_SCDC_P3_3B_H           (REG_PM_SCDC_P3_BASE + 0x77)
#define REG_PM_SCDC_P3_3C_L           (REG_PM_SCDC_P3_BASE + 0x78)
#define REG_PM_SCDC_P3_3C_H           (REG_PM_SCDC_P3_BASE + 0x79)
#define REG_PM_SCDC_P3_3D_L           (REG_PM_SCDC_P3_BASE + 0x7A)
#define REG_PM_SCDC_P3_3D_H           (REG_PM_SCDC_P3_BASE + 0x7B)
#define REG_PM_SCDC_P3_3E_L           (REG_PM_SCDC_P3_BASE + 0x7C)
#define REG_PM_SCDC_P3_3E_H           (REG_PM_SCDC_P3_BASE + 0x7D)
#define REG_PM_SCDC_P3_3F_L           (REG_PM_SCDC_P3_BASE + 0x7E)
#define REG_PM_SCDC_P3_3F_H           (REG_PM_SCDC_P3_BASE + 0x7F)
#define REG_PM_SCDC_P3_40_L           (REG_PM_SCDC_P3_BASE + 0x80)
#define REG_PM_SCDC_P3_40_H           (REG_PM_SCDC_P3_BASE + 0x81)
#define REG_PM_SCDC_P3_41_L           (REG_PM_SCDC_P3_BASE + 0x82)
#define REG_PM_SCDC_P3_41_H           (REG_PM_SCDC_P3_BASE + 0x83)
#define REG_PM_SCDC_P3_42_L           (REG_PM_SCDC_P3_BASE + 0x84)
#define REG_PM_SCDC_P3_42_H           (REG_PM_SCDC_P3_BASE + 0x85)
#define REG_PM_SCDC_P3_43_L           (REG_PM_SCDC_P3_BASE + 0x86)
#define REG_PM_SCDC_P3_43_H           (REG_PM_SCDC_P3_BASE + 0x87)
#define REG_PM_SCDC_P3_44_L           (REG_PM_SCDC_P3_BASE + 0x88)
#define REG_PM_SCDC_P3_44_H           (REG_PM_SCDC_P3_BASE + 0x89)
#define REG_PM_SCDC_P3_45_L           (REG_PM_SCDC_P3_BASE + 0x8A)
#define REG_PM_SCDC_P3_45_H           (REG_PM_SCDC_P3_BASE + 0x8B)
#define REG_PM_SCDC_P3_46_L           (REG_PM_SCDC_P3_BASE + 0x8C)
#define REG_PM_SCDC_P3_46_H           (REG_PM_SCDC_P3_BASE + 0x8D)
#define REG_PM_SCDC_P3_47_L           (REG_PM_SCDC_P3_BASE + 0x8E)
#define REG_PM_SCDC_P3_47_H           (REG_PM_SCDC_P3_BASE + 0x8F)
#define REG_PM_SCDC_P3_48_L           (REG_PM_SCDC_P3_BASE + 0x90)
#define REG_PM_SCDC_P3_48_H           (REG_PM_SCDC_P3_BASE + 0x91)
#define REG_PM_SCDC_P3_49_L           (REG_PM_SCDC_P3_BASE + 0x92)
#define REG_PM_SCDC_P3_49_H           (REG_PM_SCDC_P3_BASE + 0x93)
#define REG_PM_SCDC_P3_4A_L           (REG_PM_SCDC_P3_BASE + 0x94)
#define REG_PM_SCDC_P3_4A_H           (REG_PM_SCDC_P3_BASE + 0x95)
#define REG_PM_SCDC_P3_4B_L           (REG_PM_SCDC_P3_BASE + 0x96)
#define REG_PM_SCDC_P3_4B_H           (REG_PM_SCDC_P3_BASE + 0x97)
#define REG_PM_SCDC_P3_4C_L           (REG_PM_SCDC_P3_BASE + 0x98)
#define REG_PM_SCDC_P3_4C_H           (REG_PM_SCDC_P3_BASE + 0x99)
#define REG_PM_SCDC_P3_4D_L           (REG_PM_SCDC_P3_BASE + 0x9A)
#define REG_PM_SCDC_P3_4D_H           (REG_PM_SCDC_P3_BASE + 0x9B)
#define REG_PM_SCDC_P3_4E_L           (REG_PM_SCDC_P3_BASE + 0x9C)
#define REG_PM_SCDC_P3_4E_H           (REG_PM_SCDC_P3_BASE + 0x9D)
#define REG_PM_SCDC_P3_4F_L           (REG_PM_SCDC_P3_BASE + 0x9E)
#define REG_PM_SCDC_P3_4F_H           (REG_PM_SCDC_P3_BASE + 0x9F)
#define REG_PM_SCDC_P3_50_L           (REG_PM_SCDC_P3_BASE + 0xA0)
#define REG_PM_SCDC_P3_50_H           (REG_PM_SCDC_P3_BASE + 0xA1)
#define REG_PM_SCDC_P3_51_L           (REG_PM_SCDC_P3_BASE + 0xA2)
#define REG_PM_SCDC_P3_51_H           (REG_PM_SCDC_P3_BASE + 0xA3)
#define REG_PM_SCDC_P3_52_L           (REG_PM_SCDC_P3_BASE + 0xA4)
#define REG_PM_SCDC_P3_52_H           (REG_PM_SCDC_P3_BASE + 0xA5)
#define REG_PM_SCDC_P3_53_L           (REG_PM_SCDC_P3_BASE + 0xA6)
#define REG_PM_SCDC_P3_53_H           (REG_PM_SCDC_P3_BASE + 0xA7)
#define REG_PM_SCDC_P3_54_L           (REG_PM_SCDC_P3_BASE + 0xA8)
#define REG_PM_SCDC_P3_54_H           (REG_PM_SCDC_P3_BASE + 0xA9)
#define REG_PM_SCDC_P3_55_L           (REG_PM_SCDC_P3_BASE + 0xAA)
#define REG_PM_SCDC_P3_55_H           (REG_PM_SCDC_P3_BASE + 0xAB)
#define REG_PM_SCDC_P3_56_L           (REG_PM_SCDC_P3_BASE + 0xAC)
#define REG_PM_SCDC_P3_56_H           (REG_PM_SCDC_P3_BASE + 0xAD)
#define REG_PM_SCDC_P3_57_L           (REG_PM_SCDC_P3_BASE + 0xAE)
#define REG_PM_SCDC_P3_57_H           (REG_PM_SCDC_P3_BASE + 0xAF)
#define REG_PM_SCDC_P3_58_L           (REG_PM_SCDC_P3_BASE + 0xB0)
#define REG_PM_SCDC_P3_58_H           (REG_PM_SCDC_P3_BASE + 0xB1)
#define REG_PM_SCDC_P3_59_L           (REG_PM_SCDC_P3_BASE + 0xB2)
#define REG_PM_SCDC_P3_59_H           (REG_PM_SCDC_P3_BASE + 0xB3)
#define REG_PM_SCDC_P3_5A_L           (REG_PM_SCDC_P3_BASE + 0xB4)
#define REG_PM_SCDC_P3_5A_H           (REG_PM_SCDC_P3_BASE + 0xB5)
#define REG_PM_SCDC_P3_5B_L           (REG_PM_SCDC_P3_BASE + 0xB6)
#define REG_PM_SCDC_P3_5B_H           (REG_PM_SCDC_P3_BASE + 0xB7)
#define REG_PM_SCDC_P3_5C_L           (REG_PM_SCDC_P3_BASE + 0xB8)
#define REG_PM_SCDC_P3_5C_H           (REG_PM_SCDC_P3_BASE + 0xB9)
#define REG_PM_SCDC_P3_5D_L           (REG_PM_SCDC_P3_BASE + 0xBA)
#define REG_PM_SCDC_P3_5D_H           (REG_PM_SCDC_P3_BASE + 0xBB)
#define REG_PM_SCDC_P3_5E_L           (REG_PM_SCDC_P3_BASE + 0xBC)
#define REG_PM_SCDC_P3_5E_H           (REG_PM_SCDC_P3_BASE + 0xBD)
#define REG_PM_SCDC_P3_5F_L           (REG_PM_SCDC_P3_BASE + 0xBE)
#define REG_PM_SCDC_P3_5F_H           (REG_PM_SCDC_P3_BASE + 0xBF)
#define REG_PM_SCDC_P3_60_L           (REG_PM_SCDC_P3_BASE + 0xC0)
#define REG_PM_SCDC_P3_60_H           (REG_PM_SCDC_P3_BASE + 0xC1)
#define REG_PM_SCDC_P3_61_L           (REG_PM_SCDC_P3_BASE + 0xC2)
#define REG_PM_SCDC_P3_61_H           (REG_PM_SCDC_P3_BASE + 0xC3)
#define REG_PM_SCDC_P3_62_L           (REG_PM_SCDC_P3_BASE + 0xC4)
#define REG_PM_SCDC_P3_62_H           (REG_PM_SCDC_P3_BASE + 0xC5)
#define REG_PM_SCDC_P3_63_L           (REG_PM_SCDC_P3_BASE + 0xC6)
#define REG_PM_SCDC_P3_63_H           (REG_PM_SCDC_P3_BASE + 0xC7)
#define REG_PM_SCDC_P3_64_L           (REG_PM_SCDC_P3_BASE + 0xC8)
#define REG_PM_SCDC_P3_64_H           (REG_PM_SCDC_P3_BASE + 0xC9)
#define REG_PM_SCDC_P3_65_L           (REG_PM_SCDC_P3_BASE + 0xCA)
#define REG_PM_SCDC_P3_65_H           (REG_PM_SCDC_P3_BASE + 0xCB)
#define REG_PM_SCDC_P3_66_L           (REG_PM_SCDC_P3_BASE + 0xCC)
#define REG_PM_SCDC_P3_66_H           (REG_PM_SCDC_P3_BASE + 0xCD)
#define REG_PM_SCDC_P3_67_L           (REG_PM_SCDC_P3_BASE + 0xCE)
#define REG_PM_SCDC_P3_67_H           (REG_PM_SCDC_P3_BASE + 0xCF)
#define REG_PM_SCDC_P3_68_L           (REG_PM_SCDC_P3_BASE + 0xD0)
#define REG_PM_SCDC_P3_68_H           (REG_PM_SCDC_P3_BASE + 0xD1)
#define REG_PM_SCDC_P3_69_L           (REG_PM_SCDC_P3_BASE + 0xD2)
#define REG_PM_SCDC_P3_69_H           (REG_PM_SCDC_P3_BASE + 0xD3)
#define REG_PM_SCDC_P3_6A_L           (REG_PM_SCDC_P3_BASE + 0xD4)
#define REG_PM_SCDC_P3_6A_H           (REG_PM_SCDC_P3_BASE + 0xD5)
#define REG_PM_SCDC_P3_6B_L           (REG_PM_SCDC_P3_BASE + 0xD6)
#define REG_PM_SCDC_P3_6B_H           (REG_PM_SCDC_P3_BASE + 0xD7)
#define REG_PM_SCDC_P3_6C_L           (REG_PM_SCDC_P3_BASE + 0xD8)
#define REG_PM_SCDC_P3_6C_H           (REG_PM_SCDC_P3_BASE + 0xD9)
#define REG_PM_SCDC_P3_6D_L           (REG_PM_SCDC_P3_BASE + 0xDA)
#define REG_PM_SCDC_P3_6D_H           (REG_PM_SCDC_P3_BASE + 0xDB)
#define REG_PM_SCDC_P3_6E_L           (REG_PM_SCDC_P3_BASE + 0xDC)
#define REG_PM_SCDC_P3_6E_H           (REG_PM_SCDC_P3_BASE + 0xDD)
#define REG_PM_SCDC_P3_6F_L           (REG_PM_SCDC_P3_BASE + 0xDE)
#define REG_PM_SCDC_P3_6F_H           (REG_PM_SCDC_P3_BASE + 0xDF)
#define REG_PM_SCDC_P3_70_L           (REG_PM_SCDC_P3_BASE + 0xE0)
#define REG_PM_SCDC_P3_70_H           (REG_PM_SCDC_P3_BASE + 0xE1)
#define REG_PM_SCDC_P3_71_L           (REG_PM_SCDC_P3_BASE + 0xE2)
#define REG_PM_SCDC_P3_71_H           (REG_PM_SCDC_P3_BASE + 0xE3)
#define REG_PM_SCDC_P3_72_L           (REG_PM_SCDC_P3_BASE + 0xE4)
#define REG_PM_SCDC_P3_72_H           (REG_PM_SCDC_P3_BASE + 0xE5)
#define REG_PM_SCDC_P3_73_L           (REG_PM_SCDC_P3_BASE + 0xE6)
#define REG_PM_SCDC_P3_73_H           (REG_PM_SCDC_P3_BASE + 0xE7)
#define REG_PM_SCDC_P3_74_L           (REG_PM_SCDC_P3_BASE + 0xE8)
#define REG_PM_SCDC_P3_74_H           (REG_PM_SCDC_P3_BASE + 0xE9)
#define REG_PM_SCDC_P3_75_L           (REG_PM_SCDC_P3_BASE + 0xEA)
#define REG_PM_SCDC_P3_75_H           (REG_PM_SCDC_P3_BASE + 0xEB)
#define REG_PM_SCDC_P3_76_L           (REG_PM_SCDC_P3_BASE + 0xEC)
#define REG_PM_SCDC_P3_76_H           (REG_PM_SCDC_P3_BASE + 0xED)
#define REG_PM_SCDC_P3_77_L           (REG_PM_SCDC_P3_BASE + 0xEE)
#define REG_PM_SCDC_P3_77_H           (REG_PM_SCDC_P3_BASE + 0xEF)
#define REG_PM_SCDC_P3_78_L           (REG_PM_SCDC_P3_BASE + 0xF0)
#define REG_PM_SCDC_P3_78_H           (REG_PM_SCDC_P3_BASE + 0xF1)
#define REG_PM_SCDC_P3_79_L           (REG_PM_SCDC_P3_BASE + 0xF2)
#define REG_PM_SCDC_P3_79_H           (REG_PM_SCDC_P3_BASE + 0xF3)
#define REG_PM_SCDC_P3_7A_L           (REG_PM_SCDC_P3_BASE + 0xF4)
#define REG_PM_SCDC_P3_7A_H           (REG_PM_SCDC_P3_BASE + 0xF5)
#define REG_PM_SCDC_P3_7B_L           (REG_PM_SCDC_P3_BASE + 0xF6)
#define REG_PM_SCDC_P3_7B_H           (REG_PM_SCDC_P3_BASE + 0xF7)
#define REG_PM_SCDC_P3_7C_L           (REG_PM_SCDC_P3_BASE + 0xF8)
#define REG_PM_SCDC_P3_7C_H           (REG_PM_SCDC_P3_BASE + 0xF9)
#define REG_PM_SCDC_P3_7D_L           (REG_PM_SCDC_P3_BASE + 0xFA)
#define REG_PM_SCDC_P3_7D_H           (REG_PM_SCDC_P3_BASE + 0xFB)
#define REG_PM_SCDC_P3_7E_L           (REG_PM_SCDC_P3_BASE + 0xFC)
#define REG_PM_SCDC_P3_7E_H           (REG_PM_SCDC_P3_BASE + 0xFD)
#define REG_PM_SCDC_P3_7F_L           (REG_PM_SCDC_P3_BASE + 0xFE)
#define REG_PM_SCDC_P3_7F_H           (REG_PM_SCDC_P3_BASE + 0xFF)


//=============================================================
//PM TOP
//#define REG_PM_TOP_BASE             0x001E00UL
#define REG_PM_TOP_BANK_01_L    (REG_PM_TOP_BASE + 0x02)
#define REG_PM_TOP_BANK_01_H    (REG_PM_TOP_BASE + 0x03)

//=============================================================
//PM EFUSE
//#define REG_EFUSE_BASE              0x002000UL
#define REG_PM_EFUSE_08_L       (REG_EFUSE_BASE + 0x10)
#define REG_PM_EFUSE_08_H       (REG_EFUSE_BASE + 0x11)
#define REG_PM_EFUSE_28_L       (REG_EFUSE_BASE + 0x50)
#define REG_PM_EFUSE_28_H       (REG_EFUSE_BASE + 0x51)
#define REG_PM_EFUSE_2C_L       (REG_EFUSE_BASE + 0x58)
#define REG_PM_EFUSE_2C_H       (REG_EFUSE_BASE + 0x59)
#define REG_PM_EFUSE_2D_L       (REG_EFUSE_BASE + 0x5A)
#define REG_PM_EFUSE_2D_H       (REG_EFUSE_BASE + 0x5B)

//=============================================================
// PM GPIO
//#define REG_PM_GPIO_BASE            0x000F00UL
#define REG_PM_GPIO_00_L        (REG_PM_GPIO_BASE + 0x00)
#define REG_PM_GPIO_00_H        (REG_PM_GPIO_BASE + 0x01)
#define REG_PM_GPIO_01_L        (REG_PM_GPIO_BASE + 0x02)
#define REG_PM_GPIO_01_H        (REG_PM_GPIO_BASE + 0x03)
#define REG_PM_GPIO_02_L        (REG_PM_GPIO_BASE + 0x04)
#define REG_PM_GPIO_02_H        (REG_PM_GPIO_BASE + 0x05)
#define REG_PM_GPIO_03_L        (REG_PM_GPIO_BASE + 0x06)
#define REG_PM_GPIO_03_H        (REG_PM_GPIO_BASE + 0x07)
#define REG_PM_GPIO_04_L        (REG_PM_GPIO_BASE + 0x08)
#define REG_PM_GPIO_04_H        (REG_PM_GPIO_BASE + 0x09)
#define REG_PM_GPIO_05_L        (REG_PM_GPIO_BASE + 0x0A)
#define REG_PM_GPIO_05_H        (REG_PM_GPIO_BASE + 0x0B)
#define REG_PM_GPIO_06_L        (REG_PM_GPIO_BASE + 0x0C)
#define REG_PM_GPIO_06_H        (REG_PM_GPIO_BASE + 0x0D)
#define REG_PM_GPIO_07_L        (REG_PM_GPIO_BASE + 0x0E)
#define REG_PM_GPIO_07_H        (REG_PM_GPIO_BASE + 0x0F)
#define REG_PM_GPIO_08_L        (REG_PM_GPIO_BASE + 0x10)
#define REG_PM_GPIO_08_H        (REG_PM_GPIO_BASE + 0x11)
#define REG_PM_GPIO_09_L        (REG_PM_GPIO_BASE + 0x12)
#define REG_PM_GPIO_09_H        (REG_PM_GPIO_BASE + 0x13)
#define REG_PM_GPIO_0A_L        (REG_PM_GPIO_BASE + 0x14)
#define REG_PM_GPIO_0A_H        (REG_PM_GPIO_BASE + 0x15)
#define REG_PM_GPIO_0B_L        (REG_PM_GPIO_BASE + 0x16)
#define REG_PM_GPIO_0B_H        (REG_PM_GPIO_BASE + 0x17)
#define REG_PM_GPIO_0C_L        (REG_PM_GPIO_BASE + 0x18)
#define REG_PM_GPIO_0C_H        (REG_PM_GPIO_BASE + 0x19)
#define REG_PM_GPIO_0D_L        (REG_PM_GPIO_BASE + 0x1A)
#define REG_PM_GPIO_0D_H        (REG_PM_GPIO_BASE + 0x1B)
#define REG_PM_GPIO_0E_L        (REG_PM_GPIO_BASE + 0x1C)
#define REG_PM_GPIO_0E_H        (REG_PM_GPIO_BASE + 0x1D)
#define REG_PM_GPIO_0F_L        (REG_PM_GPIO_BASE + 0x1E)
#define REG_PM_GPIO_0F_H        (REG_PM_GPIO_BASE + 0x1F)
#define REG_PM_GPIO_10_L        (REG_PM_GPIO_BASE + 0x20)
#define REG_PM_GPIO_10_H        (REG_PM_GPIO_BASE + 0x21)
#define REG_PM_GPIO_11_L        (REG_PM_GPIO_BASE + 0x22)
#define REG_PM_GPIO_11_H        (REG_PM_GPIO_BASE + 0x23)
#define REG_PM_GPIO_12_L        (REG_PM_GPIO_BASE + 0x24)
#define REG_PM_GPIO_12_H        (REG_PM_GPIO_BASE + 0x25)
#define REG_PM_GPIO_13_L        (REG_PM_GPIO_BASE + 0x26)
#define REG_PM_GPIO_13_H        (REG_PM_GPIO_BASE + 0x27)
#define REG_PM_GPIO_14_L        (REG_PM_GPIO_BASE + 0x28)
#define REG_PM_GPIO_14_H        (REG_PM_GPIO_BASE + 0x29)
#define REG_PM_GPIO_15_L        (REG_PM_GPIO_BASE + 0x2A)
#define REG_PM_GPIO_15_H        (REG_PM_GPIO_BASE + 0x2B)
#define REG_PM_GPIO_16_L        (REG_PM_GPIO_BASE + 0x2C)
#define REG_PM_GPIO_16_H        (REG_PM_GPIO_BASE + 0x2D)
#define REG_PM_GPIO_17_L        (REG_PM_GPIO_BASE + 0x2E)
#define REG_PM_GPIO_17_H        (REG_PM_GPIO_BASE + 0x2F)

//=============================================================
// PM PAD SAR
//#define REG_PAD_SAR_BASE            0x001400UL
#define REG_PAD_SAR_11_L        (REG_PAD_SAR_BASE + 0x22)
#define REG_PAD_SAR_11_H        (REG_PAD_SAR_BASE + 0x23)
#define REG_PAD_SAR_12_L        (REG_PAD_SAR_BASE + 0x24)
#define REG_PAD_SAR_12_H        (REG_PAD_SAR_BASE + 0x25)

//=============================================================
// MHL CBUS
// #define REG_MHL_CBUS_BANK           0x001F00UL
#define REG_MHL_CBUS_00         (REG_MHL_CBUS_BANK + 0x00)
#define REG_MHL_CBUS_01         (REG_MHL_CBUS_BANK + 0x02)
#define REG_MHL_CBUS_02         (REG_MHL_CBUS_BANK + 0x04)
#define REG_MHL_CBUS_03         (REG_MHL_CBUS_BANK + 0x06)
#define REG_MHL_CBUS_04         (REG_MHL_CBUS_BANK + 0x08)
#define REG_MHL_CBUS_05         (REG_MHL_CBUS_BANK + 0x0A)
#define REG_MHL_CBUS_06         (REG_MHL_CBUS_BANK + 0x0C)
#define REG_MHL_CBUS_07         (REG_MHL_CBUS_BANK + 0x0E)
#define REG_MHL_CBUS_08         (REG_MHL_CBUS_BANK + 0x10)
#define REG_MHL_CBUS_09         (REG_MHL_CBUS_BANK + 0x12)
#define REG_MHL_CBUS_0A         (REG_MHL_CBUS_BANK + 0x14)
#define REG_MHL_CBUS_0B         (REG_MHL_CBUS_BANK + 0x16)
#define REG_MHL_CBUS_0C         (REG_MHL_CBUS_BANK + 0x18)
#define REG_MHL_CBUS_0D         (REG_MHL_CBUS_BANK + 0x1A)
#define REG_MHL_CBUS_0E         (REG_MHL_CBUS_BANK + 0x1C)
#define REG_MHL_CBUS_0F         (REG_MHL_CBUS_BANK + 0x1E)
#define REG_MHL_CBUS_10         (REG_MHL_CBUS_BANK + 0x20)
#define REG_MHL_CBUS_11         (REG_MHL_CBUS_BANK + 0x22)
#define REG_MHL_CBUS_12         (REG_MHL_CBUS_BANK + 0x24)
#define REG_MHL_CBUS_13         (REG_MHL_CBUS_BANK + 0x26)
#define REG_MHL_CBUS_14         (REG_MHL_CBUS_BANK + 0x28)
#define REG_MHL_CBUS_15         (REG_MHL_CBUS_BANK + 0x2A)
#define REG_MHL_CBUS_16         (REG_MHL_CBUS_BANK + 0x2C)
#define REG_MHL_CBUS_17         (REG_MHL_CBUS_BANK + 0x2E)
#define REG_MHL_CBUS_18         (REG_MHL_CBUS_BANK + 0x30)
#define REG_MHL_CBUS_19         (REG_MHL_CBUS_BANK + 0x32)
#define REG_MHL_CBUS_1A         (REG_MHL_CBUS_BANK + 0x34)
#define REG_MHL_CBUS_1B         (REG_MHL_CBUS_BANK + 0x36)
#define REG_MHL_CBUS_1C         (REG_MHL_CBUS_BANK + 0x38)
#define REG_MHL_CBUS_1D         (REG_MHL_CBUS_BANK + 0x3A)
#define REG_MHL_CBUS_1E         (REG_MHL_CBUS_BANK + 0x3C)
#define REG_MHL_CBUS_1F         (REG_MHL_CBUS_BANK + 0x3E)
#define REG_MHL_CBUS_20         (REG_MHL_CBUS_BANK + 0x40)
#define REG_MHL_CBUS_21         (REG_MHL_CBUS_BANK + 0x42)
#define REG_MHL_CBUS_22         (REG_MHL_CBUS_BANK + 0x44)
#define REG_MHL_CBUS_23         (REG_MHL_CBUS_BANK + 0x46)
#define REG_MHL_CBUS_24         (REG_MHL_CBUS_BANK + 0x48)
#define REG_MHL_CBUS_25         (REG_MHL_CBUS_BANK + 0x4A)
#define REG_MHL_CBUS_26         (REG_MHL_CBUS_BANK + 0x4C)
#define REG_MHL_CBUS_27         (REG_MHL_CBUS_BANK + 0x4E)
#define REG_MHL_CBUS_28         (REG_MHL_CBUS_BANK + 0x50)
#define REG_MHL_CBUS_29         (REG_MHL_CBUS_BANK + 0x52)
#define REG_MHL_CBUS_2A         (REG_MHL_CBUS_BANK + 0x54)
#define REG_MHL_CBUS_2B         (REG_MHL_CBUS_BANK + 0x56)
#define REG_MHL_CBUS_2C         (REG_MHL_CBUS_BANK + 0x58)
#define REG_MHL_CBUS_2D         (REG_MHL_CBUS_BANK + 0x5A)
#define REG_MHL_CBUS_2E         (REG_MHL_CBUS_BANK + 0x5C)
#define REG_MHL_CBUS_2F         (REG_MHL_CBUS_BANK + 0x5E)
#define REG_MHL_CBUS_30         (REG_MHL_CBUS_BANK + 0x60)
#define REG_MHL_CBUS_31         (REG_MHL_CBUS_BANK + 0x62)
#define REG_MHL_CBUS_32         (REG_MHL_CBUS_BANK + 0x64)
#define REG_MHL_CBUS_33         (REG_MHL_CBUS_BANK + 0x66)
#define REG_MHL_CBUS_34         (REG_MHL_CBUS_BANK + 0x68)
#define REG_MHL_CBUS_35         (REG_MHL_CBUS_BANK + 0x6A)
#define REG_MHL_CBUS_36         (REG_MHL_CBUS_BANK + 0x6C)
#define REG_MHL_CBUS_37         (REG_MHL_CBUS_BANK + 0x6E)
#define REG_MHL_CBUS_38         (REG_MHL_CBUS_BANK + 0x70)
#define REG_MHL_CBUS_39         (REG_MHL_CBUS_BANK + 0x72)
#define REG_MHL_CBUS_3A         (REG_MHL_CBUS_BANK + 0x74)
#define REG_MHL_CBUS_3B         (REG_MHL_CBUS_BANK + 0x76)
#define REG_MHL_CBUS_3C         (REG_MHL_CBUS_BANK + 0x78)
#define REG_MHL_CBUS_3D         (REG_MHL_CBUS_BANK + 0x7A)
#define REG_MHL_CBUS_3E         (REG_MHL_CBUS_BANK + 0x7C)
#define REG_MHL_CBUS_3F         (REG_MHL_CBUS_BANK + 0x7E)
#define REG_MHL_CBUS_40         (REG_MHL_CBUS_BANK + 0x80)
#define REG_MHL_CBUS_41         (REG_MHL_CBUS_BANK + 0x82)
#define REG_MHL_CBUS_42         (REG_MHL_CBUS_BANK + 0x84)
#define REG_MHL_CBUS_43         (REG_MHL_CBUS_BANK + 0x86)
#define REG_MHL_CBUS_44         (REG_MHL_CBUS_BANK + 0x88)
#define REG_MHL_CBUS_45         (REG_MHL_CBUS_BANK + 0x8A)
#define REG_MHL_CBUS_46         (REG_MHL_CBUS_BANK + 0x8C)
#define REG_MHL_CBUS_47         (REG_MHL_CBUS_BANK + 0x8E)
#define REG_MHL_CBUS_48         (REG_MHL_CBUS_BANK + 0x90)
#define REG_MHL_CBUS_49         (REG_MHL_CBUS_BANK + 0x92)
#define REG_MHL_CBUS_4A         (REG_MHL_CBUS_BANK + 0x94)
#define REG_MHL_CBUS_4B         (REG_MHL_CBUS_BANK + 0x96)
#define REG_MHL_CBUS_4C         (REG_MHL_CBUS_BANK + 0x98)
#define REG_MHL_CBUS_4D         (REG_MHL_CBUS_BANK + 0x9A)
#define REG_MHL_CBUS_4E         (REG_MHL_CBUS_BANK + 0x9C)
#define REG_MHL_CBUS_4F         (REG_MHL_CBUS_BANK + 0x9E)
#define REG_MHL_CBUS_50         (REG_MHL_CBUS_BANK + 0xA0)
#define REG_MHL_CBUS_51         (REG_MHL_CBUS_BANK + 0xA2)
#define REG_MHL_CBUS_52         (REG_MHL_CBUS_BANK + 0xA4)
#define REG_MHL_CBUS_53         (REG_MHL_CBUS_BANK + 0xA6)
#define REG_MHL_CBUS_54         (REG_MHL_CBUS_BANK + 0xA8)
#define REG_MHL_CBUS_55         (REG_MHL_CBUS_BANK + 0xAA)
#define REG_MHL_CBUS_56         (REG_MHL_CBUS_BANK + 0xAC)
#define REG_MHL_CBUS_57         (REG_MHL_CBUS_BANK + 0xAE)
#define REG_MHL_CBUS_58         (REG_MHL_CBUS_BANK + 0xB0)
#define REG_MHL_CBUS_59         (REG_MHL_CBUS_BANK + 0xB2)
#define REG_MHL_CBUS_5A         (REG_MHL_CBUS_BANK + 0xB4)
#define REG_MHL_CBUS_5B         (REG_MHL_CBUS_BANK + 0xB6)
#define REG_MHL_CBUS_5C         (REG_MHL_CBUS_BANK + 0xB8)
#define REG_MHL_CBUS_5D         (REG_MHL_CBUS_BANK + 0xBA)
#define REG_MHL_CBUS_5E         (REG_MHL_CBUS_BANK + 0xBC)
#define REG_MHL_CBUS_5F         (REG_MHL_CBUS_BANK + 0xBE)
#define REG_MHL_CBUS_60         (REG_MHL_CBUS_BANK + 0xC0)
#define REG_MHL_CBUS_61         (REG_MHL_CBUS_BANK + 0xC2)
#define REG_MHL_CBUS_62         (REG_MHL_CBUS_BANK + 0xC4)
#define REG_MHL_CBUS_63         (REG_MHL_CBUS_BANK + 0xC6)
#define REG_MHL_CBUS_64         (REG_MHL_CBUS_BANK + 0xC8)
#define REG_MHL_CBUS_65         (REG_MHL_CBUS_BANK + 0xCA)
#define REG_MHL_CBUS_66         (REG_MHL_CBUS_BANK + 0xCC)
#define REG_MHL_CBUS_67         (REG_MHL_CBUS_BANK + 0xCE)
#define REG_MHL_CBUS_68         (REG_MHL_CBUS_BANK + 0xD0)
#define REG_MHL_CBUS_69         (REG_MHL_CBUS_BANK + 0xD2)
#define REG_MHL_CBUS_6A         (REG_MHL_CBUS_BANK + 0xD4)
#define REG_MHL_CBUS_6B         (REG_MHL_CBUS_BANK + 0xD6)
#define REG_MHL_CBUS_6C         (REG_MHL_CBUS_BANK + 0xD8)
#define REG_MHL_CBUS_6D         (REG_MHL_CBUS_BANK + 0xDA)
#define REG_MHL_CBUS_6E         (REG_MHL_CBUS_BANK + 0xDC)
#define REG_MHL_CBUS_6F         (REG_MHL_CBUS_BANK + 0xDE)
#define REG_MHL_CBUS_70         (REG_MHL_CBUS_BANK + 0xE0)
#define REG_MHL_CBUS_71         (REG_MHL_CBUS_BANK + 0xE2)
#define REG_MHL_CBUS_72         (REG_MHL_CBUS_BANK + 0xE4)
#define REG_MHL_CBUS_73         (REG_MHL_CBUS_BANK + 0xE6)
#define REG_MHL_CBUS_74         (REG_MHL_CBUS_BANK + 0xE8)
#define REG_MHL_CBUS_75         (REG_MHL_CBUS_BANK + 0xEA)
#define REG_MHL_CBUS_76         (REG_MHL_CBUS_BANK + 0xEC)
#define REG_MHL_CBUS_77         (REG_MHL_CBUS_BANK + 0xEE)
#define REG_MHL_CBUS_78         (REG_MHL_CBUS_BANK + 0xF0)
#define REG_MHL_CBUS_79         (REG_MHL_CBUS_BANK + 0xF2)
#define REG_MHL_CBUS_7A         (REG_MHL_CBUS_BANK + 0xF4)
#define REG_MHL_CBUS_7B         (REG_MHL_CBUS_BANK + 0xF6)
#define REG_MHL_CBUS_7C         (REG_MHL_CBUS_BANK + 0xF8)
#define REG_MHL_CBUS_7D         (REG_MHL_CBUS_BANK + 0xFA)
#define REG_MHL_CBUS_7E         (REG_MHL_CBUS_BANK + 0xFC)
#define REG_MHL_CBUS_7F         (REG_MHL_CBUS_BANK + 0xFE)

//=============================================================
// PM MHL CBUS
// #define REG_PM_MHL_CBUS_BANK    0x002F00UL
#define REG_PM_MHL_CBUS_00      (REG_PM_MHL_CBUS_BANK + 0x00)
#define REG_PM_MHL_CBUS_01      (REG_PM_MHL_CBUS_BANK + 0x02)
#define REG_PM_MHL_CBUS_02      (REG_PM_MHL_CBUS_BANK + 0x04)
#define REG_PM_MHL_CBUS_03      (REG_PM_MHL_CBUS_BANK + 0x06)
#define REG_PM_MHL_CBUS_04      (REG_PM_MHL_CBUS_BANK + 0x08)
#define REG_PM_MHL_CBUS_05      (REG_PM_MHL_CBUS_BANK + 0x0A)
#define REG_PM_MHL_CBUS_06      (REG_PM_MHL_CBUS_BANK + 0x0C)
#define REG_PM_MHL_CBUS_07      (REG_PM_MHL_CBUS_BANK + 0x0E)
#define REG_PM_MHL_CBUS_08      (REG_PM_MHL_CBUS_BANK + 0x10)
#define REG_PM_MHL_CBUS_09      (REG_PM_MHL_CBUS_BANK + 0x12)
#define REG_PM_MHL_CBUS_0A      (REG_PM_MHL_CBUS_BANK + 0x14)
#define REG_PM_MHL_CBUS_0B      (REG_PM_MHL_CBUS_BANK + 0x16)
#define REG_PM_MHL_CBUS_0C      (REG_PM_MHL_CBUS_BANK + 0x18)
#define REG_PM_MHL_CBUS_0D      (REG_PM_MHL_CBUS_BANK + 0x1A)
#define REG_PM_MHL_CBUS_0E      (REG_PM_MHL_CBUS_BANK + 0x1C)
#define REG_PM_MHL_CBUS_0F      (REG_PM_MHL_CBUS_BANK + 0x1E)
#define REG_PM_MHL_CBUS_10      (REG_PM_MHL_CBUS_BANK + 0x20)
#define REG_PM_MHL_CBUS_11      (REG_PM_MHL_CBUS_BANK + 0x22)
#define REG_PM_MHL_CBUS_12      (REG_PM_MHL_CBUS_BANK + 0x24)
#define REG_PM_MHL_CBUS_13      (REG_PM_MHL_CBUS_BANK + 0x26)
#define REG_PM_MHL_CBUS_14      (REG_PM_MHL_CBUS_BANK + 0x28)
#define REG_PM_MHL_CBUS_15      (REG_PM_MHL_CBUS_BANK + 0x2A)
#define REG_PM_MHL_CBUS_16      (REG_PM_MHL_CBUS_BANK + 0x2C)
#define REG_PM_MHL_CBUS_17      (REG_PM_MHL_CBUS_BANK + 0x2E)
#define REG_PM_MHL_CBUS_18      (REG_PM_MHL_CBUS_BANK + 0x30)
#define REG_PM_MHL_CBUS_19      (REG_PM_MHL_CBUS_BANK + 0x32)
#define REG_PM_MHL_CBUS_1A      (REG_PM_MHL_CBUS_BANK + 0x34)
#define REG_PM_MHL_CBUS_1B      (REG_PM_MHL_CBUS_BANK + 0x36)
#define REG_PM_MHL_CBUS_1C      (REG_PM_MHL_CBUS_BANK + 0x38)
#define REG_PM_MHL_CBUS_1D      (REG_PM_MHL_CBUS_BANK + 0x3A)
#define REG_PM_MHL_CBUS_1E      (REG_PM_MHL_CBUS_BANK + 0x3C)
#define REG_PM_MHL_CBUS_1F      (REG_PM_MHL_CBUS_BANK + 0x3E)
#define REG_PM_MHL_CBUS_20      (REG_PM_MHL_CBUS_BANK + 0x40)
#define REG_PM_MHL_CBUS_21      (REG_PM_MHL_CBUS_BANK + 0x42)
#define REG_PM_MHL_CBUS_22      (REG_PM_MHL_CBUS_BANK + 0x44)
#define REG_PM_MHL_CBUS_23      (REG_PM_MHL_CBUS_BANK + 0x46)
#define REG_PM_MHL_CBUS_24      (REG_PM_MHL_CBUS_BANK + 0x48)
#define REG_PM_MHL_CBUS_25      (REG_PM_MHL_CBUS_BANK + 0x4A)
#define REG_PM_MHL_CBUS_26      (REG_PM_MHL_CBUS_BANK + 0x4C)
#define REG_PM_MHL_CBUS_27      (REG_PM_MHL_CBUS_BANK + 0x4E)
#define REG_PM_MHL_CBUS_28      (REG_PM_MHL_CBUS_BANK + 0x50)
#define REG_PM_MHL_CBUS_29      (REG_PM_MHL_CBUS_BANK + 0x52)
#define REG_PM_MHL_CBUS_2A      (REG_PM_MHL_CBUS_BANK + 0x54)
#define REG_PM_MHL_CBUS_2B      (REG_PM_MHL_CBUS_BANK + 0x56)
#define REG_PM_MHL_CBUS_2C      (REG_PM_MHL_CBUS_BANK + 0x58)
#define REG_PM_MHL_CBUS_2D      (REG_PM_MHL_CBUS_BANK + 0x5A)
#define REG_PM_MHL_CBUS_2E      (REG_PM_MHL_CBUS_BANK + 0x5C)
#define REG_PM_MHL_CBUS_2F      (REG_PM_MHL_CBUS_BANK + 0x5E)
#define REG_PM_MHL_CBUS_30      (REG_PM_MHL_CBUS_BANK + 0x60)
#define REG_PM_MHL_CBUS_31      (REG_PM_MHL_CBUS_BANK + 0x62)
#define REG_PM_MHL_CBUS_32      (REG_PM_MHL_CBUS_BANK + 0x64)
#define REG_PM_MHL_CBUS_33      (REG_PM_MHL_CBUS_BANK + 0x66)
#define REG_PM_MHL_CBUS_34      (REG_PM_MHL_CBUS_BANK + 0x68)
#define REG_PM_MHL_CBUS_35      (REG_PM_MHL_CBUS_BANK + 0x6A)
#define REG_PM_MHL_CBUS_36      (REG_PM_MHL_CBUS_BANK + 0x6C)
#define REG_PM_MHL_CBUS_37      (REG_PM_MHL_CBUS_BANK + 0x6E)
#define REG_PM_MHL_CBUS_38      (REG_PM_MHL_CBUS_BANK + 0x70)
#define REG_PM_MHL_CBUS_39      (REG_PM_MHL_CBUS_BANK + 0x72)
#define REG_PM_MHL_CBUS_3A      (REG_PM_MHL_CBUS_BANK + 0x74)
#define REG_PM_MHL_CBUS_3B      (REG_PM_MHL_CBUS_BANK + 0x76)
#define REG_PM_MHL_CBUS_3C      (REG_PM_MHL_CBUS_BANK + 0x78)
#define REG_PM_MHL_CBUS_3D      (REG_PM_MHL_CBUS_BANK + 0x7A)
#define REG_PM_MHL_CBUS_3E      (REG_PM_MHL_CBUS_BANK + 0x7C)
#define REG_PM_MHL_CBUS_3F      (REG_PM_MHL_CBUS_BANK + 0x7E)
#define REG_PM_MHL_CBUS_40      (REG_PM_MHL_CBUS_BANK + 0x80)
#define REG_PM_MHL_CBUS_41      (REG_PM_MHL_CBUS_BANK + 0x82)
#define REG_PM_MHL_CBUS_42      (REG_PM_MHL_CBUS_BANK + 0x84)
#define REG_PM_MHL_CBUS_43      (REG_PM_MHL_CBUS_BANK + 0x86)
#define REG_PM_MHL_CBUS_44      (REG_PM_MHL_CBUS_BANK + 0x88)
#define REG_PM_MHL_CBUS_45      (REG_PM_MHL_CBUS_BANK + 0x8A)
#define REG_PM_MHL_CBUS_46      (REG_PM_MHL_CBUS_BANK + 0x8C)
#define REG_PM_MHL_CBUS_47      (REG_PM_MHL_CBUS_BANK + 0x8E)
#define REG_PM_MHL_CBUS_48      (REG_PM_MHL_CBUS_BANK + 0x90)
#define REG_PM_MHL_CBUS_49      (REG_PM_MHL_CBUS_BANK + 0x92)
#define REG_PM_MHL_CBUS_4A      (REG_PM_MHL_CBUS_BANK + 0x94)
#define REG_PM_MHL_CBUS_4B      (REG_PM_MHL_CBUS_BANK + 0x96)
#define REG_PM_MHL_CBUS_4C      (REG_PM_MHL_CBUS_BANK + 0x98)
#define REG_PM_MHL_CBUS_4D      (REG_PM_MHL_CBUS_BANK + 0x9A)
#define REG_PM_MHL_CBUS_4E      (REG_PM_MHL_CBUS_BANK + 0x9C)
#define REG_PM_MHL_CBUS_4F      (REG_PM_MHL_CBUS_BANK + 0x9E)
#define REG_PM_MHL_CBUS_50      (REG_PM_MHL_CBUS_BANK + 0xA0)
#define REG_PM_MHL_CBUS_51      (REG_PM_MHL_CBUS_BANK + 0xA2)
#define REG_PM_MHL_CBUS_52      (REG_PM_MHL_CBUS_BANK + 0xA4)
#define REG_PM_MHL_CBUS_53      (REG_PM_MHL_CBUS_BANK + 0xA6)
#define REG_PM_MHL_CBUS_54      (REG_PM_MHL_CBUS_BANK + 0xA8)
#define REG_PM_MHL_CBUS_55      (REG_PM_MHL_CBUS_BANK + 0xAA)
#define REG_PM_MHL_CBUS_56      (REG_PM_MHL_CBUS_BANK + 0xAC)
#define REG_PM_MHL_CBUS_57      (REG_PM_MHL_CBUS_BANK + 0xAE)
#define REG_PM_MHL_CBUS_58      (REG_PM_MHL_CBUS_BANK + 0xB0)
#define REG_PM_MHL_CBUS_59      (REG_PM_MHL_CBUS_BANK + 0xB2)
#define REG_PM_MHL_CBUS_5A      (REG_PM_MHL_CBUS_BANK + 0xB4)
#define REG_PM_MHL_CBUS_5B      (REG_PM_MHL_CBUS_BANK + 0xB6)
#define REG_PM_MHL_CBUS_5C      (REG_PM_MHL_CBUS_BANK + 0xB8)
#define REG_PM_MHL_CBUS_5D      (REG_PM_MHL_CBUS_BANK + 0xBA)
#define REG_PM_MHL_CBUS_5E      (REG_PM_MHL_CBUS_BANK + 0xBC)
#define REG_PM_MHL_CBUS_5F      (REG_PM_MHL_CBUS_BANK + 0xBE)
#define REG_PM_MHL_CBUS_60      (REG_PM_MHL_CBUS_BANK + 0xC0)
#define REG_PM_MHL_CBUS_61      (REG_PM_MHL_CBUS_BANK + 0xC2)
#define REG_PM_MHL_CBUS_62      (REG_PM_MHL_CBUS_BANK + 0xC4)
#define REG_PM_MHL_CBUS_63      (REG_PM_MHL_CBUS_BANK + 0xC6)
#define REG_PM_MHL_CBUS_64      (REG_PM_MHL_CBUS_BANK + 0xC8)
#define REG_PM_MHL_CBUS_65      (REG_PM_MHL_CBUS_BANK + 0xCA)
#define REG_PM_MHL_CBUS_66      (REG_PM_MHL_CBUS_BANK + 0xCC)
#define REG_PM_MHL_CBUS_67      (REG_PM_MHL_CBUS_BANK + 0xCE)
#define REG_PM_MHL_CBUS_68      (REG_PM_MHL_CBUS_BANK + 0xD0)
#define REG_PM_MHL_CBUS_69      (REG_PM_MHL_CBUS_BANK + 0xD2)
#define REG_PM_MHL_CBUS_6A      (REG_PM_MHL_CBUS_BANK + 0xD4)
#define REG_PM_MHL_CBUS_6B      (REG_PM_MHL_CBUS_BANK + 0xD6)
#define REG_PM_MHL_CBUS_6C      (REG_PM_MHL_CBUS_BANK + 0xD8)
#define REG_PM_MHL_CBUS_6D      (REG_PM_MHL_CBUS_BANK + 0xDA)
#define REG_PM_MHL_CBUS_6E      (REG_PM_MHL_CBUS_BANK + 0xDC)
#define REG_PM_MHL_CBUS_6F      (REG_PM_MHL_CBUS_BANK + 0xDE)
#define REG_PM_MHL_CBUS_70      (REG_PM_MHL_CBUS_BANK + 0xE0)
#define REG_PM_MHL_CBUS_71      (REG_PM_MHL_CBUS_BANK + 0xE2)
#define REG_PM_MHL_CBUS_72      (REG_PM_MHL_CBUS_BANK + 0xE4)
#define REG_PM_MHL_CBUS_73      (REG_PM_MHL_CBUS_BANK + 0xE6)
#define REG_PM_MHL_CBUS_74      (REG_PM_MHL_CBUS_BANK + 0xE8)
#define REG_PM_MHL_CBUS_75      (REG_PM_MHL_CBUS_BANK + 0xEA)
#define REG_PM_MHL_CBUS_76      (REG_PM_MHL_CBUS_BANK + 0xEC)
#define REG_PM_MHL_CBUS_77      (REG_PM_MHL_CBUS_BANK + 0xEE)
#define REG_PM_MHL_CBUS_78      (REG_PM_MHL_CBUS_BANK + 0xF0)
#define REG_PM_MHL_CBUS_79      (REG_PM_MHL_CBUS_BANK + 0xF2)
#define REG_PM_MHL_CBUS_7A      (REG_PM_MHL_CBUS_BANK + 0xF4)
#define REG_PM_MHL_CBUS_7B      (REG_PM_MHL_CBUS_BANK + 0xF6)
#define REG_PM_MHL_CBUS_7C      (REG_PM_MHL_CBUS_BANK + 0xF8)
#define REG_PM_MHL_CBUS_7D      (REG_PM_MHL_CBUS_BANK + 0xFA)
#define REG_PM_MHL_CBUS_7E      (REG_PM_MHL_CBUS_BANK + 0xFC)
#define REG_PM_MHL_CBUS_7F      (REG_PM_MHL_CBUS_BANK + 0xFE)

//=============================================================
// PHY2P1_PM_P0
#define REG_PHY2P1_PM_P0_00_L   (REG_PHY2P1_PM_P0_BASE + 0x00)
#define REG_PHY2P1_PM_P0_00_H   (REG_PHY2P1_PM_P0_BASE + 0x01)
#define REG_PHY2P1_PM_P0_01_L   (REG_PHY2P1_PM_P0_BASE + 0x02)
#define REG_PHY2P1_PM_P0_01_H   (REG_PHY2P1_PM_P0_BASE + 0x03)
#define REG_PHY2P1_PM_P0_02_L   (REG_PHY2P1_PM_P0_BASE + 0x04)
#define REG_PHY2P1_PM_P0_02_H   (REG_PHY2P1_PM_P0_BASE + 0x05)
#define REG_PHY2P1_PM_P0_03_L   (REG_PHY2P1_PM_P0_BASE + 0x06)
#define REG_PHY2P1_PM_P0_03_H   (REG_PHY2P1_PM_P0_BASE + 0x07)
#define REG_PHY2P1_PM_P0_04_L   (REG_PHY2P1_PM_P0_BASE + 0x08)
#define REG_PHY2P1_PM_P0_04_H   (REG_PHY2P1_PM_P0_BASE + 0x09)
#define REG_PHY2P1_PM_P0_05_L   (REG_PHY2P1_PM_P0_BASE + 0x0A)
#define REG_PHY2P1_PM_P0_05_H   (REG_PHY2P1_PM_P0_BASE + 0x0B)
#define REG_PHY2P1_PM_P0_06_L   (REG_PHY2P1_PM_P0_BASE + 0x0C)
#define REG_PHY2P1_PM_P0_06_H   (REG_PHY2P1_PM_P0_BASE + 0x0D)
#define REG_PHY2P1_PM_P0_07_L   (REG_PHY2P1_PM_P0_BASE + 0x0E)
#define REG_PHY2P1_PM_P0_07_H   (REG_PHY2P1_PM_P0_BASE + 0x0F)
#define REG_PHY2P1_PM_P0_08_L   (REG_PHY2P1_PM_P0_BASE + 0x10)
#define REG_PHY2P1_PM_P0_08_H   (REG_PHY2P1_PM_P0_BASE + 0x11)
#define REG_PHY2P1_PM_P0_09_L   (REG_PHY2P1_PM_P0_BASE + 0x12)
#define REG_PHY2P1_PM_P0_09_H   (REG_PHY2P1_PM_P0_BASE + 0x13)
#define REG_PHY2P1_PM_P0_0A_L   (REG_PHY2P1_PM_P0_BASE + 0x14)
#define REG_PHY2P1_PM_P0_0A_H   (REG_PHY2P1_PM_P0_BASE + 0x15)
#define REG_PHY2P1_PM_P0_0B_L   (REG_PHY2P1_PM_P0_BASE + 0x16)
#define REG_PHY2P1_PM_P0_0B_H   (REG_PHY2P1_PM_P0_BASE + 0x17)
#define REG_PHY2P1_PM_P0_0C_L   (REG_PHY2P1_PM_P0_BASE + 0x18)
#define REG_PHY2P1_PM_P0_0C_H   (REG_PHY2P1_PM_P0_BASE + 0x19)
#define REG_PHY2P1_PM_P0_0D_L   (REG_PHY2P1_PM_P0_BASE + 0x1A)
#define REG_PHY2P1_PM_P0_0D_H   (REG_PHY2P1_PM_P0_BASE + 0x1B)
#define REG_PHY2P1_PM_P0_0E_L   (REG_PHY2P1_PM_P0_BASE + 0x1C)
#define REG_PHY2P1_PM_P0_0E_H   (REG_PHY2P1_PM_P0_BASE + 0x1D)
#define REG_PHY2P1_PM_P0_0F_L   (REG_PHY2P1_PM_P0_BASE + 0x1E)
#define REG_PHY2P1_PM_P0_0F_H   (REG_PHY2P1_PM_P0_BASE + 0x1F)
#define REG_PHY2P1_PM_P0_10_L   (REG_PHY2P1_PM_P0_BASE + 0x20)
#define REG_PHY2P1_PM_P0_10_H   (REG_PHY2P1_PM_P0_BASE + 0x21)
#define REG_PHY2P1_PM_P0_11_L   (REG_PHY2P1_PM_P0_BASE + 0x22)
#define REG_PHY2P1_PM_P0_11_H   (REG_PHY2P1_PM_P0_BASE + 0x23)
#define REG_PHY2P1_PM_P0_12_L   (REG_PHY2P1_PM_P0_BASE + 0x24)
#define REG_PHY2P1_PM_P0_12_H   (REG_PHY2P1_PM_P0_BASE + 0x25)
#define REG_PHY2P1_PM_P0_13_L   (REG_PHY2P1_PM_P0_BASE + 0x26)
#define REG_PHY2P1_PM_P0_13_H   (REG_PHY2P1_PM_P0_BASE + 0x27)
#define REG_PHY2P1_PM_P0_14_L   (REG_PHY2P1_PM_P0_BASE + 0x28)
#define REG_PHY2P1_PM_P0_14_H   (REG_PHY2P1_PM_P0_BASE + 0x29)
#define REG_PHY2P1_PM_P0_15_L   (REG_PHY2P1_PM_P0_BASE + 0x2A)
#define REG_PHY2P1_PM_P0_15_H   (REG_PHY2P1_PM_P0_BASE + 0x2B)
#define REG_PHY2P1_PM_P0_16_L   (REG_PHY2P1_PM_P0_BASE + 0x2C)
#define REG_PHY2P1_PM_P0_16_H   (REG_PHY2P1_PM_P0_BASE + 0x2D)
#define REG_PHY2P1_PM_P0_17_L   (REG_PHY2P1_PM_P0_BASE + 0x2E)
#define REG_PHY2P1_PM_P0_17_H   (REG_PHY2P1_PM_P0_BASE + 0x2F)
#define REG_PHY2P1_PM_P0_18_L   (REG_PHY2P1_PM_P0_BASE + 0x30)
#define REG_PHY2P1_PM_P0_18_H   (REG_PHY2P1_PM_P0_BASE + 0x31)
#define REG_PHY2P1_PM_P0_19_L   (REG_PHY2P1_PM_P0_BASE + 0x32)
#define REG_PHY2P1_PM_P0_19_H   (REG_PHY2P1_PM_P0_BASE + 0x33)
#define REG_PHY2P1_PM_P0_1A_L   (REG_PHY2P1_PM_P0_BASE + 0x34)
#define REG_PHY2P1_PM_P0_1A_H   (REG_PHY2P1_PM_P0_BASE + 0x35)
#define REG_PHY2P1_PM_P0_1B_L   (REG_PHY2P1_PM_P0_BASE + 0x36)
#define REG_PHY2P1_PM_P0_1B_H   (REG_PHY2P1_PM_P0_BASE + 0x37)
#define REG_PHY2P1_PM_P0_1C_L   (REG_PHY2P1_PM_P0_BASE + 0x38)
#define REG_PHY2P1_PM_P0_1C_H   (REG_PHY2P1_PM_P0_BASE + 0x39)
#define REG_PHY2P1_PM_P0_1D_L   (REG_PHY2P1_PM_P0_BASE + 0x3A)
#define REG_PHY2P1_PM_P0_1D_H   (REG_PHY2P1_PM_P0_BASE + 0x3B)
#define REG_PHY2P1_PM_P0_1E_L   (REG_PHY2P1_PM_P0_BASE + 0x3C)
#define REG_PHY2P1_PM_P0_1E_H   (REG_PHY2P1_PM_P0_BASE + 0x3D)
#define REG_PHY2P1_PM_P0_1F_L   (REG_PHY2P1_PM_P0_BASE + 0x3E)
#define REG_PHY2P1_PM_P0_1F_H   (REG_PHY2P1_PM_P0_BASE + 0x3F)
#define REG_PHY2P1_PM_P0_20_L   (REG_PHY2P1_PM_P0_BASE + 0x40)
#define REG_PHY2P1_PM_P0_20_H   (REG_PHY2P1_PM_P0_BASE + 0x41)
#define REG_PHY2P1_PM_P0_21_L   (REG_PHY2P1_PM_P0_BASE + 0x42)
#define REG_PHY2P1_PM_P0_21_H   (REG_PHY2P1_PM_P0_BASE + 0x43)
#define REG_PHY2P1_PM_P0_22_L   (REG_PHY2P1_PM_P0_BASE + 0x44)
#define REG_PHY2P1_PM_P0_22_H   (REG_PHY2P1_PM_P0_BASE + 0x45)
#define REG_PHY2P1_PM_P0_23_L   (REG_PHY2P1_PM_P0_BASE + 0x46)
#define REG_PHY2P1_PM_P0_23_H   (REG_PHY2P1_PM_P0_BASE + 0x47)
#define REG_PHY2P1_PM_P0_24_L   (REG_PHY2P1_PM_P0_BASE + 0x48)
#define REG_PHY2P1_PM_P0_24_H   (REG_PHY2P1_PM_P0_BASE + 0x49)
#define REG_PHY2P1_PM_P0_25_L   (REG_PHY2P1_PM_P0_BASE + 0x4A)
#define REG_PHY2P1_PM_P0_25_H   (REG_PHY2P1_PM_P0_BASE + 0x4B)
#define REG_PHY2P1_PM_P0_26_L   (REG_PHY2P1_PM_P0_BASE + 0x4C)
#define REG_PHY2P1_PM_P0_26_H   (REG_PHY2P1_PM_P0_BASE + 0x4D)
#define REG_PHY2P1_PM_P0_27_L   (REG_PHY2P1_PM_P0_BASE + 0x4E)
#define REG_PHY2P1_PM_P0_27_H   (REG_PHY2P1_PM_P0_BASE + 0x4F)
#define REG_PHY2P1_PM_P0_28_L   (REG_PHY2P1_PM_P0_BASE + 0x50)
#define REG_PHY2P1_PM_P0_28_H   (REG_PHY2P1_PM_P0_BASE + 0x51)
#define REG_PHY2P1_PM_P0_29_L   (REG_PHY2P1_PM_P0_BASE + 0x52)
#define REG_PHY2P1_PM_P0_29_H   (REG_PHY2P1_PM_P0_BASE + 0x53)
#define REG_PHY2P1_PM_P0_2A_L   (REG_PHY2P1_PM_P0_BASE + 0x54)
#define REG_PHY2P1_PM_P0_2A_H   (REG_PHY2P1_PM_P0_BASE + 0x55)
#define REG_PHY2P1_PM_P0_2B_L   (REG_PHY2P1_PM_P0_BASE + 0x56)
#define REG_PHY2P1_PM_P0_2B_H   (REG_PHY2P1_PM_P0_BASE + 0x57)
#define REG_PHY2P1_PM_P0_2C_L   (REG_PHY2P1_PM_P0_BASE + 0x58)
#define REG_PHY2P1_PM_P0_2C_H   (REG_PHY2P1_PM_P0_BASE + 0x59)
#define REG_PHY2P1_PM_P0_2D_L   (REG_PHY2P1_PM_P0_BASE + 0x5A)
#define REG_PHY2P1_PM_P0_2D_H   (REG_PHY2P1_PM_P0_BASE + 0x5B)
#define REG_PHY2P1_PM_P0_2E_L   (REG_PHY2P1_PM_P0_BASE + 0x5C)
#define REG_PHY2P1_PM_P0_2E_H   (REG_PHY2P1_PM_P0_BASE + 0x5D)
#define REG_PHY2P1_PM_P0_2F_L   (REG_PHY2P1_PM_P0_BASE + 0x5E)
#define REG_PHY2P1_PM_P0_2F_H   (REG_PHY2P1_PM_P0_BASE + 0x5F)
#define REG_PHY2P1_PM_P0_30_L   (REG_PHY2P1_PM_P0_BASE + 0x60)
#define REG_PHY2P1_PM_P0_30_H   (REG_PHY2P1_PM_P0_BASE + 0x61)
#define REG_PHY2P1_PM_P0_31_L   (REG_PHY2P1_PM_P0_BASE + 0x62)
#define REG_PHY2P1_PM_P0_31_H   (REG_PHY2P1_PM_P0_BASE + 0x63)
#define REG_PHY2P1_PM_P0_32_L   (REG_PHY2P1_PM_P0_BASE + 0x64)
#define REG_PHY2P1_PM_P0_32_H   (REG_PHY2P1_PM_P0_BASE + 0x65)
#define REG_PHY2P1_PM_P0_33_L   (REG_PHY2P1_PM_P0_BASE + 0x66)
#define REG_PHY2P1_PM_P0_33_H   (REG_PHY2P1_PM_P0_BASE + 0x67)
#define REG_PHY2P1_PM_P0_34_L   (REG_PHY2P1_PM_P0_BASE + 0x68)
#define REG_PHY2P1_PM_P0_34_H   (REG_PHY2P1_PM_P0_BASE + 0x69)
#define REG_PHY2P1_PM_P0_35_L   (REG_PHY2P1_PM_P0_BASE + 0x6A)
#define REG_PHY2P1_PM_P0_35_H   (REG_PHY2P1_PM_P0_BASE + 0x6B)
#define REG_PHY2P1_PM_P0_36_L   (REG_PHY2P1_PM_P0_BASE + 0x6C)
#define REG_PHY2P1_PM_P0_36_H   (REG_PHY2P1_PM_P0_BASE + 0x6D)
#define REG_PHY2P1_PM_P0_37_L   (REG_PHY2P1_PM_P0_BASE + 0x6E)
#define REG_PHY2P1_PM_P0_37_H   (REG_PHY2P1_PM_P0_BASE + 0x6F)
#define REG_PHY2P1_PM_P0_38_L   (REG_PHY2P1_PM_P0_BASE + 0x70)
#define REG_PHY2P1_PM_P0_38_H   (REG_PHY2P1_PM_P0_BASE + 0x71)
#define REG_PHY2P1_PM_P0_39_L   (REG_PHY2P1_PM_P0_BASE + 0x72)
#define REG_PHY2P1_PM_P0_39_H   (REG_PHY2P1_PM_P0_BASE + 0x73)
#define REG_PHY2P1_PM_P0_3A_L   (REG_PHY2P1_PM_P0_BASE + 0x74)
#define REG_PHY2P1_PM_P0_3A_H   (REG_PHY2P1_PM_P0_BASE + 0x75)
#define REG_PHY2P1_PM_P0_3B_L   (REG_PHY2P1_PM_P0_BASE + 0x76)
#define REG_PHY2P1_PM_P0_3B_H   (REG_PHY2P1_PM_P0_BASE + 0x77)
#define REG_PHY2P1_PM_P0_3C_L   (REG_PHY2P1_PM_P0_BASE + 0x78)
#define REG_PHY2P1_PM_P0_3C_H   (REG_PHY2P1_PM_P0_BASE + 0x79)
#define REG_PHY2P1_PM_P0_3D_L   (REG_PHY2P1_PM_P0_BASE + 0x7A)
#define REG_PHY2P1_PM_P0_3D_H   (REG_PHY2P1_PM_P0_BASE + 0x7B)
#define REG_PHY2P1_PM_P0_3E_L   (REG_PHY2P1_PM_P0_BASE + 0x7C)
#define REG_PHY2P1_PM_P0_3E_H   (REG_PHY2P1_PM_P0_BASE + 0x7D)
#define REG_PHY2P1_PM_P0_3F_L   (REG_PHY2P1_PM_P0_BASE + 0x7E)
#define REG_PHY2P1_PM_P0_3F_H   (REG_PHY2P1_PM_P0_BASE + 0x7F)
#define REG_PHY2P1_PM_P0_40_L   (REG_PHY2P1_PM_P0_BASE + 0x80)
#define REG_PHY2P1_PM_P0_40_H   (REG_PHY2P1_PM_P0_BASE + 0x81)
#define REG_PHY2P1_PM_P0_41_L   (REG_PHY2P1_PM_P0_BASE + 0x82)
#define REG_PHY2P1_PM_P0_41_H   (REG_PHY2P1_PM_P0_BASE + 0x83)
#define REG_PHY2P1_PM_P0_42_L   (REG_PHY2P1_PM_P0_BASE + 0x84)
#define REG_PHY2P1_PM_P0_42_H   (REG_PHY2P1_PM_P0_BASE + 0x85)
#define REG_PHY2P1_PM_P0_43_L   (REG_PHY2P1_PM_P0_BASE + 0x86)
#define REG_PHY2P1_PM_P0_43_H   (REG_PHY2P1_PM_P0_BASE + 0x87)
#define REG_PHY2P1_PM_P0_44_L   (REG_PHY2P1_PM_P0_BASE + 0x88)
#define REG_PHY2P1_PM_P0_44_H   (REG_PHY2P1_PM_P0_BASE + 0x89)
#define REG_PHY2P1_PM_P0_45_L   (REG_PHY2P1_PM_P0_BASE + 0x8A)
#define REG_PHY2P1_PM_P0_45_H   (REG_PHY2P1_PM_P0_BASE + 0x8B)
#define REG_PHY2P1_PM_P0_46_L   (REG_PHY2P1_PM_P0_BASE + 0x8C)
#define REG_PHY2P1_PM_P0_46_H   (REG_PHY2P1_PM_P0_BASE + 0x8D)
#define REG_PHY2P1_PM_P0_47_L   (REG_PHY2P1_PM_P0_BASE + 0x8E)
#define REG_PHY2P1_PM_P0_47_H   (REG_PHY2P1_PM_P0_BASE + 0x8F)
#define REG_PHY2P1_PM_P0_48_L   (REG_PHY2P1_PM_P0_BASE + 0x90)
#define REG_PHY2P1_PM_P0_48_H   (REG_PHY2P1_PM_P0_BASE + 0x91)
#define REG_PHY2P1_PM_P0_49_L   (REG_PHY2P1_PM_P0_BASE + 0x92)
#define REG_PHY2P1_PM_P0_49_H   (REG_PHY2P1_PM_P0_BASE + 0x93)
#define REG_PHY2P1_PM_P0_4A_L   (REG_PHY2P1_PM_P0_BASE + 0x94)
#define REG_PHY2P1_PM_P0_4A_H   (REG_PHY2P1_PM_P0_BASE + 0x95)
#define REG_PHY2P1_PM_P0_4B_L   (REG_PHY2P1_PM_P0_BASE + 0x96)
#define REG_PHY2P1_PM_P0_4B_H   (REG_PHY2P1_PM_P0_BASE + 0x97)
#define REG_PHY2P1_PM_P0_4C_L   (REG_PHY2P1_PM_P0_BASE + 0x98)
#define REG_PHY2P1_PM_P0_4C_H   (REG_PHY2P1_PM_P0_BASE + 0x99)
#define REG_PHY2P1_PM_P0_4D_L   (REG_PHY2P1_PM_P0_BASE + 0x9A)
#define REG_PHY2P1_PM_P0_4D_H   (REG_PHY2P1_PM_P0_BASE + 0x9B)
#define REG_PHY2P1_PM_P0_4E_L   (REG_PHY2P1_PM_P0_BASE + 0x9C)
#define REG_PHY2P1_PM_P0_4E_H   (REG_PHY2P1_PM_P0_BASE + 0x9D)
#define REG_PHY2P1_PM_P0_4F_L   (REG_PHY2P1_PM_P0_BASE + 0x9E)
#define REG_PHY2P1_PM_P0_4F_H   (REG_PHY2P1_PM_P0_BASE + 0x9F)
#define REG_PHY2P1_PM_P0_50_L   (REG_PHY2P1_PM_P0_BASE + 0xA0)
#define REG_PHY2P1_PM_P0_50_H   (REG_PHY2P1_PM_P0_BASE + 0xA1)
#define REG_PHY2P1_PM_P0_51_L   (REG_PHY2P1_PM_P0_BASE + 0xA2)
#define REG_PHY2P1_PM_P0_51_H   (REG_PHY2P1_PM_P0_BASE + 0xA3)
#define REG_PHY2P1_PM_P0_52_L   (REG_PHY2P1_PM_P0_BASE + 0xA4)
#define REG_PHY2P1_PM_P0_52_H   (REG_PHY2P1_PM_P0_BASE + 0xA5)
#define REG_PHY2P1_PM_P0_53_L   (REG_PHY2P1_PM_P0_BASE + 0xA6)
#define REG_PHY2P1_PM_P0_53_H   (REG_PHY2P1_PM_P0_BASE + 0xA7)
#define REG_PHY2P1_PM_P0_54_L   (REG_PHY2P1_PM_P0_BASE + 0xA8)
#define REG_PHY2P1_PM_P0_54_H   (REG_PHY2P1_PM_P0_BASE + 0xA9)
#define REG_PHY2P1_PM_P0_55_L   (REG_PHY2P1_PM_P0_BASE + 0xAA)
#define REG_PHY2P1_PM_P0_55_H   (REG_PHY2P1_PM_P0_BASE + 0xAB)
#define REG_PHY2P1_PM_P0_56_L   (REG_PHY2P1_PM_P0_BASE + 0xAC)
#define REG_PHY2P1_PM_P0_56_H   (REG_PHY2P1_PM_P0_BASE + 0xAD)
#define REG_PHY2P1_PM_P0_57_L   (REG_PHY2P1_PM_P0_BASE + 0xAE)
#define REG_PHY2P1_PM_P0_57_H   (REG_PHY2P1_PM_P0_BASE + 0xAF)
#define REG_PHY2P1_PM_P0_58_L   (REG_PHY2P1_PM_P0_BASE + 0xB0)
#define REG_PHY2P1_PM_P0_58_H   (REG_PHY2P1_PM_P0_BASE + 0xB1)
#define REG_PHY2P1_PM_P0_59_L   (REG_PHY2P1_PM_P0_BASE + 0xB2)
#define REG_PHY2P1_PM_P0_59_H   (REG_PHY2P1_PM_P0_BASE + 0xB3)
#define REG_PHY2P1_PM_P0_5A_L   (REG_PHY2P1_PM_P0_BASE + 0xB4)
#define REG_PHY2P1_PM_P0_5A_H   (REG_PHY2P1_PM_P0_BASE + 0xB5)
#define REG_PHY2P1_PM_P0_5B_L   (REG_PHY2P1_PM_P0_BASE + 0xB6)
#define REG_PHY2P1_PM_P0_5B_H   (REG_PHY2P1_PM_P0_BASE + 0xB7)
#define REG_PHY2P1_PM_P0_5C_L   (REG_PHY2P1_PM_P0_BASE + 0xB8)
#define REG_PHY2P1_PM_P0_5C_H   (REG_PHY2P1_PM_P0_BASE + 0xB9)
#define REG_PHY2P1_PM_P0_5D_L   (REG_PHY2P1_PM_P0_BASE + 0xBA)
#define REG_PHY2P1_PM_P0_5D_H   (REG_PHY2P1_PM_P0_BASE + 0xBB)
#define REG_PHY2P1_PM_P0_5E_L   (REG_PHY2P1_PM_P0_BASE + 0xBC)
#define REG_PHY2P1_PM_P0_5E_H   (REG_PHY2P1_PM_P0_BASE + 0xBD)
#define REG_PHY2P1_PM_P0_5F_L   (REG_PHY2P1_PM_P0_BASE + 0xBE)
#define REG_PHY2P1_PM_P0_5F_H   (REG_PHY2P1_PM_P0_BASE + 0xBF)
#define REG_PHY2P1_PM_P0_60_L   (REG_PHY2P1_PM_P0_BASE + 0xC0)
#define REG_PHY2P1_PM_P0_60_H   (REG_PHY2P1_PM_P0_BASE + 0xC1)
#define REG_PHY2P1_PM_P0_61_L   (REG_PHY2P1_PM_P0_BASE + 0xC2)
#define REG_PHY2P1_PM_P0_61_H   (REG_PHY2P1_PM_P0_BASE + 0xC3)
#define REG_PHY2P1_PM_P0_62_L   (REG_PHY2P1_PM_P0_BASE + 0xC4)
#define REG_PHY2P1_PM_P0_62_H   (REG_PHY2P1_PM_P0_BASE + 0xC5)
#define REG_PHY2P1_PM_P0_63_L   (REG_PHY2P1_PM_P0_BASE + 0xC6)
#define REG_PHY2P1_PM_P0_63_H   (REG_PHY2P1_PM_P0_BASE + 0xC7)
#define REG_PHY2P1_PM_P0_64_L   (REG_PHY2P1_PM_P0_BASE + 0xC8)
#define REG_PHY2P1_PM_P0_64_H   (REG_PHY2P1_PM_P0_BASE + 0xC9)
#define REG_PHY2P1_PM_P0_65_L   (REG_PHY2P1_PM_P0_BASE + 0xCA)
#define REG_PHY2P1_PM_P0_65_H   (REG_PHY2P1_PM_P0_BASE + 0xCB)
#define REG_PHY2P1_PM_P0_66_L   (REG_PHY2P1_PM_P0_BASE + 0xCC)
#define REG_PHY2P1_PM_P0_66_H   (REG_PHY2P1_PM_P0_BASE + 0xCD)
#define REG_PHY2P1_PM_P0_67_L   (REG_PHY2P1_PM_P0_BASE + 0xCE)
#define REG_PHY2P1_PM_P0_67_H   (REG_PHY2P1_PM_P0_BASE + 0xCF)
#define REG_PHY2P1_PM_P0_68_L   (REG_PHY2P1_PM_P0_BASE + 0xD0)
#define REG_PHY2P1_PM_P0_68_H   (REG_PHY2P1_PM_P0_BASE + 0xD1)
#define REG_PHY2P1_PM_P0_69_L   (REG_PHY2P1_PM_P0_BASE + 0xD2)
#define REG_PHY2P1_PM_P0_69_H   (REG_PHY2P1_PM_P0_BASE + 0xD3)
#define REG_PHY2P1_PM_P0_6A_L   (REG_PHY2P1_PM_P0_BASE + 0xD4)
#define REG_PHY2P1_PM_P0_6A_H   (REG_PHY2P1_PM_P0_BASE + 0xD5)
#define REG_PHY2P1_PM_P0_6B_L   (REG_PHY2P1_PM_P0_BASE + 0xD6)
#define REG_PHY2P1_PM_P0_6B_H   (REG_PHY2P1_PM_P0_BASE + 0xD7)
#define REG_PHY2P1_PM_P0_6C_L   (REG_PHY2P1_PM_P0_BASE + 0xD8)
#define REG_PHY2P1_PM_P0_6C_H   (REG_PHY2P1_PM_P0_BASE + 0xD9)
#define REG_PHY2P1_PM_P0_6D_L   (REG_PHY2P1_PM_P0_BASE + 0xDA)
#define REG_PHY2P1_PM_P0_6D_H   (REG_PHY2P1_PM_P0_BASE + 0xDB)
#define REG_PHY2P1_PM_P0_6E_L   (REG_PHY2P1_PM_P0_BASE + 0xDC)
#define REG_PHY2P1_PM_P0_6E_H   (REG_PHY2P1_PM_P0_BASE + 0xDD)
#define REG_PHY2P1_PM_P0_6F_L   (REG_PHY2P1_PM_P0_BASE + 0xDE)
#define REG_PHY2P1_PM_P0_6F_H   (REG_PHY2P1_PM_P0_BASE + 0xDF)
#define REG_PHY2P1_PM_P0_70_L   (REG_PHY2P1_PM_P0_BASE + 0xE0)
#define REG_PHY2P1_PM_P0_70_H   (REG_PHY2P1_PM_P0_BASE + 0xE1)
#define REG_PHY2P1_PM_P0_71_L   (REG_PHY2P1_PM_P0_BASE + 0xE2)
#define REG_PHY2P1_PM_P0_71_H   (REG_PHY2P1_PM_P0_BASE + 0xE3)
#define REG_PHY2P1_PM_P0_72_L   (REG_PHY2P1_PM_P0_BASE + 0xE4)
#define REG_PHY2P1_PM_P0_72_H   (REG_PHY2P1_PM_P0_BASE + 0xE5)
#define REG_PHY2P1_PM_P0_73_L   (REG_PHY2P1_PM_P0_BASE + 0xE6)
#define REG_PHY2P1_PM_P0_73_H   (REG_PHY2P1_PM_P0_BASE + 0xE7)
#define REG_PHY2P1_PM_P0_74_L   (REG_PHY2P1_PM_P0_BASE + 0xE8)
#define REG_PHY2P1_PM_P0_74_H   (REG_PHY2P1_PM_P0_BASE + 0xE9)
#define REG_PHY2P1_PM_P0_75_L   (REG_PHY2P1_PM_P0_BASE + 0xEA)
#define REG_PHY2P1_PM_P0_75_H   (REG_PHY2P1_PM_P0_BASE + 0xEB)
#define REG_PHY2P1_PM_P0_76_L   (REG_PHY2P1_PM_P0_BASE + 0xEC)
#define REG_PHY2P1_PM_P0_76_H   (REG_PHY2P1_PM_P0_BASE + 0xED)
#define REG_PHY2P1_PM_P0_77_L   (REG_PHY2P1_PM_P0_BASE + 0xEE)
#define REG_PHY2P1_PM_P0_77_H   (REG_PHY2P1_PM_P0_BASE + 0xEF)
#define REG_PHY2P1_PM_P0_78_L   (REG_PHY2P1_PM_P0_BASE + 0xF0)
#define REG_PHY2P1_PM_P0_78_H   (REG_PHY2P1_PM_P0_BASE + 0xF1)
#define REG_PHY2P1_PM_P0_79_L   (REG_PHY2P1_PM_P0_BASE + 0xF2)
#define REG_PHY2P1_PM_P0_79_H   (REG_PHY2P1_PM_P0_BASE + 0xF3)
#define REG_PHY2P1_PM_P0_7A_L   (REG_PHY2P1_PM_P0_BASE + 0xF4)
#define REG_PHY2P1_PM_P0_7A_H   (REG_PHY2P1_PM_P0_BASE + 0xF5)
#define REG_PHY2P1_PM_P0_7B_L   (REG_PHY2P1_PM_P0_BASE + 0xF6)
#define REG_PHY2P1_PM_P0_7B_H   (REG_PHY2P1_PM_P0_BASE + 0xF7)
#define REG_PHY2P1_PM_P0_7C_L   (REG_PHY2P1_PM_P0_BASE + 0xF8)
#define REG_PHY2P1_PM_P0_7C_H   (REG_PHY2P1_PM_P0_BASE + 0xF9)
#define REG_PHY2P1_PM_P0_7D_L   (REG_PHY2P1_PM_P0_BASE + 0xFA)
#define REG_PHY2P1_PM_P0_7D_H   (REG_PHY2P1_PM_P0_BASE + 0xFB)
#define REG_PHY2P1_PM_P0_7E_L   (REG_PHY2P1_PM_P0_BASE + 0xFC)
#define REG_PHY2P1_PM_P0_7E_H   (REG_PHY2P1_PM_P0_BASE + 0xFD)
#define REG_PHY2P1_PM_P0_7F_L   (REG_PHY2P1_PM_P0_BASE + 0xFE)
#define REG_PHY2P1_PM_P0_7F_H   (REG_PHY2P1_PM_P0_BASE + 0xFF)

//=============================================================
// PHY2P1_PM_P1
#define REG_PHY2P1_PM_P1_00_L   (REG_PHY2P1_PM_P1_BASE + 0x00)
#define REG_PHY2P1_PM_P1_00_H   (REG_PHY2P1_PM_P1_BASE + 0x01)
#define REG_PHY2P1_PM_P1_01_L   (REG_PHY2P1_PM_P1_BASE + 0x02)
#define REG_PHY2P1_PM_P1_01_H   (REG_PHY2P1_PM_P1_BASE + 0x03)
#define REG_PHY2P1_PM_P1_02_L   (REG_PHY2P1_PM_P1_BASE + 0x04)
#define REG_PHY2P1_PM_P1_02_H   (REG_PHY2P1_PM_P1_BASE + 0x05)
#define REG_PHY2P1_PM_P1_03_L   (REG_PHY2P1_PM_P1_BASE + 0x06)
#define REG_PHY2P1_PM_P1_03_H   (REG_PHY2P1_PM_P1_BASE + 0x07)
#define REG_PHY2P1_PM_P1_04_L   (REG_PHY2P1_PM_P1_BASE + 0x08)
#define REG_PHY2P1_PM_P1_04_H   (REG_PHY2P1_PM_P1_BASE + 0x09)
#define REG_PHY2P1_PM_P1_05_L   (REG_PHY2P1_PM_P1_BASE + 0x0A)
#define REG_PHY2P1_PM_P1_05_H   (REG_PHY2P1_PM_P1_BASE + 0x0B)
#define REG_PHY2P1_PM_P1_06_L   (REG_PHY2P1_PM_P1_BASE + 0x0C)
#define REG_PHY2P1_PM_P1_06_H   (REG_PHY2P1_PM_P1_BASE + 0x0D)
#define REG_PHY2P1_PM_P1_07_L   (REG_PHY2P1_PM_P1_BASE + 0x0E)
#define REG_PHY2P1_PM_P1_07_H   (REG_PHY2P1_PM_P1_BASE + 0x0F)
#define REG_PHY2P1_PM_P1_08_L   (REG_PHY2P1_PM_P1_BASE + 0x10)
#define REG_PHY2P1_PM_P1_08_H   (REG_PHY2P1_PM_P1_BASE + 0x11)
#define REG_PHY2P1_PM_P1_09_L   (REG_PHY2P1_PM_P1_BASE + 0x12)
#define REG_PHY2P1_PM_P1_09_H   (REG_PHY2P1_PM_P1_BASE + 0x13)
#define REG_PHY2P1_PM_P1_0A_L   (REG_PHY2P1_PM_P1_BASE + 0x14)
#define REG_PHY2P1_PM_P1_0A_H   (REG_PHY2P1_PM_P1_BASE + 0x15)
#define REG_PHY2P1_PM_P1_0B_L   (REG_PHY2P1_PM_P1_BASE + 0x16)
#define REG_PHY2P1_PM_P1_0B_H   (REG_PHY2P1_PM_P1_BASE + 0x17)
#define REG_PHY2P1_PM_P1_0C_L   (REG_PHY2P1_PM_P1_BASE + 0x18)
#define REG_PHY2P1_PM_P1_0C_H   (REG_PHY2P1_PM_P1_BASE + 0x19)
#define REG_PHY2P1_PM_P1_0D_L   (REG_PHY2P1_PM_P1_BASE + 0x1A)
#define REG_PHY2P1_PM_P1_0D_H   (REG_PHY2P1_PM_P1_BASE + 0x1B)
#define REG_PHY2P1_PM_P1_0E_L   (REG_PHY2P1_PM_P1_BASE + 0x1C)
#define REG_PHY2P1_PM_P1_0E_H   (REG_PHY2P1_PM_P1_BASE + 0x1D)
#define REG_PHY2P1_PM_P1_0F_L   (REG_PHY2P1_PM_P1_BASE + 0x1E)
#define REG_PHY2P1_PM_P1_0F_H   (REG_PHY2P1_PM_P1_BASE + 0x1F)
#define REG_PHY2P1_PM_P1_10_L   (REG_PHY2P1_PM_P1_BASE + 0x20)
#define REG_PHY2P1_PM_P1_10_H   (REG_PHY2P1_PM_P1_BASE + 0x21)
#define REG_PHY2P1_PM_P1_11_L   (REG_PHY2P1_PM_P1_BASE + 0x22)
#define REG_PHY2P1_PM_P1_11_H   (REG_PHY2P1_PM_P1_BASE + 0x23)
#define REG_PHY2P1_PM_P1_12_L   (REG_PHY2P1_PM_P1_BASE + 0x24)
#define REG_PHY2P1_PM_P1_12_H   (REG_PHY2P1_PM_P1_BASE + 0x25)
#define REG_PHY2P1_PM_P1_13_L   (REG_PHY2P1_PM_P1_BASE + 0x26)
#define REG_PHY2P1_PM_P1_13_H   (REG_PHY2P1_PM_P1_BASE + 0x27)
#define REG_PHY2P1_PM_P1_14_L   (REG_PHY2P1_PM_P1_BASE + 0x28)
#define REG_PHY2P1_PM_P1_14_H   (REG_PHY2P1_PM_P1_BASE + 0x29)
#define REG_PHY2P1_PM_P1_15_L   (REG_PHY2P1_PM_P1_BASE + 0x2A)
#define REG_PHY2P1_PM_P1_15_H   (REG_PHY2P1_PM_P1_BASE + 0x2B)
#define REG_PHY2P1_PM_P1_16_L   (REG_PHY2P1_PM_P1_BASE + 0x2C)
#define REG_PHY2P1_PM_P1_16_H   (REG_PHY2P1_PM_P1_BASE + 0x2D)
#define REG_PHY2P1_PM_P1_17_L   (REG_PHY2P1_PM_P1_BASE + 0x2E)
#define REG_PHY2P1_PM_P1_17_H   (REG_PHY2P1_PM_P1_BASE + 0x2F)
#define REG_PHY2P1_PM_P1_18_L   (REG_PHY2P1_PM_P1_BASE + 0x30)
#define REG_PHY2P1_PM_P1_18_H   (REG_PHY2P1_PM_P1_BASE + 0x31)
#define REG_PHY2P1_PM_P1_19_L   (REG_PHY2P1_PM_P1_BASE + 0x32)
#define REG_PHY2P1_PM_P1_19_H   (REG_PHY2P1_PM_P1_BASE + 0x33)
#define REG_PHY2P1_PM_P1_1A_L   (REG_PHY2P1_PM_P1_BASE + 0x34)
#define REG_PHY2P1_PM_P1_1A_H   (REG_PHY2P1_PM_P1_BASE + 0x35)
#define REG_PHY2P1_PM_P1_1B_L   (REG_PHY2P1_PM_P1_BASE + 0x36)
#define REG_PHY2P1_PM_P1_1B_H   (REG_PHY2P1_PM_P1_BASE + 0x37)
#define REG_PHY2P1_PM_P1_1C_L   (REG_PHY2P1_PM_P1_BASE + 0x38)
#define REG_PHY2P1_PM_P1_1C_H   (REG_PHY2P1_PM_P1_BASE + 0x39)
#define REG_PHY2P1_PM_P1_1D_L   (REG_PHY2P1_PM_P1_BASE + 0x3A)
#define REG_PHY2P1_PM_P1_1D_H   (REG_PHY2P1_PM_P1_BASE + 0x3B)
#define REG_PHY2P1_PM_P1_1E_L   (REG_PHY2P1_PM_P1_BASE + 0x3C)
#define REG_PHY2P1_PM_P1_1E_H   (REG_PHY2P1_PM_P1_BASE + 0x3D)
#define REG_PHY2P1_PM_P1_1F_L   (REG_PHY2P1_PM_P1_BASE + 0x3E)
#define REG_PHY2P1_PM_P1_1F_H   (REG_PHY2P1_PM_P1_BASE + 0x3F)
#define REG_PHY2P1_PM_P1_20_L   (REG_PHY2P1_PM_P1_BASE + 0x40)
#define REG_PHY2P1_PM_P1_20_H   (REG_PHY2P1_PM_P1_BASE + 0x41)
#define REG_PHY2P1_PM_P1_21_L   (REG_PHY2P1_PM_P1_BASE + 0x42)
#define REG_PHY2P1_PM_P1_21_H   (REG_PHY2P1_PM_P1_BASE + 0x43)
#define REG_PHY2P1_PM_P1_22_L   (REG_PHY2P1_PM_P1_BASE + 0x44)
#define REG_PHY2P1_PM_P1_22_H   (REG_PHY2P1_PM_P1_BASE + 0x45)
#define REG_PHY2P1_PM_P1_23_L   (REG_PHY2P1_PM_P1_BASE + 0x46)
#define REG_PHY2P1_PM_P1_23_H   (REG_PHY2P1_PM_P1_BASE + 0x47)
#define REG_PHY2P1_PM_P1_24_L   (REG_PHY2P1_PM_P1_BASE + 0x48)
#define REG_PHY2P1_PM_P1_24_H   (REG_PHY2P1_PM_P1_BASE + 0x49)
#define REG_PHY2P1_PM_P1_25_L   (REG_PHY2P1_PM_P1_BASE + 0x4A)
#define REG_PHY2P1_PM_P1_25_H   (REG_PHY2P1_PM_P1_BASE + 0x4B)
#define REG_PHY2P1_PM_P1_26_L   (REG_PHY2P1_PM_P1_BASE + 0x4C)
#define REG_PHY2P1_PM_P1_26_H   (REG_PHY2P1_PM_P1_BASE + 0x4D)
#define REG_PHY2P1_PM_P1_27_L   (REG_PHY2P1_PM_P1_BASE + 0x4E)
#define REG_PHY2P1_PM_P1_27_H   (REG_PHY2P1_PM_P1_BASE + 0x4F)
#define REG_PHY2P1_PM_P1_28_L   (REG_PHY2P1_PM_P1_BASE + 0x50)
#define REG_PHY2P1_PM_P1_28_H   (REG_PHY2P1_PM_P1_BASE + 0x51)
#define REG_PHY2P1_PM_P1_29_L   (REG_PHY2P1_PM_P1_BASE + 0x52)
#define REG_PHY2P1_PM_P1_29_H   (REG_PHY2P1_PM_P1_BASE + 0x53)
#define REG_PHY2P1_PM_P1_2A_L   (REG_PHY2P1_PM_P1_BASE + 0x54)
#define REG_PHY2P1_PM_P1_2A_H   (REG_PHY2P1_PM_P1_BASE + 0x55)
#define REG_PHY2P1_PM_P1_2B_L   (REG_PHY2P1_PM_P1_BASE + 0x56)
#define REG_PHY2P1_PM_P1_2B_H   (REG_PHY2P1_PM_P1_BASE + 0x57)
#define REG_PHY2P1_PM_P1_2C_L   (REG_PHY2P1_PM_P1_BASE + 0x58)
#define REG_PHY2P1_PM_P1_2C_H   (REG_PHY2P1_PM_P1_BASE + 0x59)
#define REG_PHY2P1_PM_P1_2D_L   (REG_PHY2P1_PM_P1_BASE + 0x5A)
#define REG_PHY2P1_PM_P1_2D_H   (REG_PHY2P1_PM_P1_BASE + 0x5B)
#define REG_PHY2P1_PM_P1_2E_L   (REG_PHY2P1_PM_P1_BASE + 0x5C)
#define REG_PHY2P1_PM_P1_2E_H   (REG_PHY2P1_PM_P1_BASE + 0x5D)
#define REG_PHY2P1_PM_P1_2F_L   (REG_PHY2P1_PM_P1_BASE + 0x5E)
#define REG_PHY2P1_PM_P1_2F_H   (REG_PHY2P1_PM_P1_BASE + 0x5F)
#define REG_PHY2P1_PM_P1_30_L   (REG_PHY2P1_PM_P1_BASE + 0x60)
#define REG_PHY2P1_PM_P1_30_H   (REG_PHY2P1_PM_P1_BASE + 0x61)
#define REG_PHY2P1_PM_P1_31_L   (REG_PHY2P1_PM_P1_BASE + 0x62)
#define REG_PHY2P1_PM_P1_31_H   (REG_PHY2P1_PM_P1_BASE + 0x63)
#define REG_PHY2P1_PM_P1_32_L   (REG_PHY2P1_PM_P1_BASE + 0x64)
#define REG_PHY2P1_PM_P1_32_H   (REG_PHY2P1_PM_P1_BASE + 0x65)
#define REG_PHY2P1_PM_P1_33_L   (REG_PHY2P1_PM_P1_BASE + 0x66)
#define REG_PHY2P1_PM_P1_33_H   (REG_PHY2P1_PM_P1_BASE + 0x67)
#define REG_PHY2P1_PM_P1_34_L   (REG_PHY2P1_PM_P1_BASE + 0x68)
#define REG_PHY2P1_PM_P1_34_H   (REG_PHY2P1_PM_P1_BASE + 0x69)
#define REG_PHY2P1_PM_P1_35_L   (REG_PHY2P1_PM_P1_BASE + 0x6A)
#define REG_PHY2P1_PM_P1_35_H   (REG_PHY2P1_PM_P1_BASE + 0x6B)
#define REG_PHY2P1_PM_P1_36_L   (REG_PHY2P1_PM_P1_BASE + 0x6C)
#define REG_PHY2P1_PM_P1_36_H   (REG_PHY2P1_PM_P1_BASE + 0x6D)
#define REG_PHY2P1_PM_P1_37_L   (REG_PHY2P1_PM_P1_BASE + 0x6E)
#define REG_PHY2P1_PM_P1_37_H   (REG_PHY2P1_PM_P1_BASE + 0x6F)
#define REG_PHY2P1_PM_P1_38_L   (REG_PHY2P1_PM_P1_BASE + 0x70)
#define REG_PHY2P1_PM_P1_38_H   (REG_PHY2P1_PM_P1_BASE + 0x71)
#define REG_PHY2P1_PM_P1_39_L   (REG_PHY2P1_PM_P1_BASE + 0x72)
#define REG_PHY2P1_PM_P1_39_H   (REG_PHY2P1_PM_P1_BASE + 0x73)
#define REG_PHY2P1_PM_P1_3A_L   (REG_PHY2P1_PM_P1_BASE + 0x74)
#define REG_PHY2P1_PM_P1_3A_H   (REG_PHY2P1_PM_P1_BASE + 0x75)
#define REG_PHY2P1_PM_P1_3B_L   (REG_PHY2P1_PM_P1_BASE + 0x76)
#define REG_PHY2P1_PM_P1_3B_H   (REG_PHY2P1_PM_P1_BASE + 0x77)
#define REG_PHY2P1_PM_P1_3C_L   (REG_PHY2P1_PM_P1_BASE + 0x78)
#define REG_PHY2P1_PM_P1_3C_H   (REG_PHY2P1_PM_P1_BASE + 0x79)
#define REG_PHY2P1_PM_P1_3D_L   (REG_PHY2P1_PM_P1_BASE + 0x7A)
#define REG_PHY2P1_PM_P1_3D_H   (REG_PHY2P1_PM_P1_BASE + 0x7B)
#define REG_PHY2P1_PM_P1_3E_L   (REG_PHY2P1_PM_P1_BASE + 0x7C)
#define REG_PHY2P1_PM_P1_3E_H   (REG_PHY2P1_PM_P1_BASE + 0x7D)
#define REG_PHY2P1_PM_P1_3F_L   (REG_PHY2P1_PM_P1_BASE + 0x7E)
#define REG_PHY2P1_PM_P1_3F_H   (REG_PHY2P1_PM_P1_BASE + 0x7F)
#define REG_PHY2P1_PM_P1_40_L   (REG_PHY2P1_PM_P1_BASE + 0x80)
#define REG_PHY2P1_PM_P1_40_H   (REG_PHY2P1_PM_P1_BASE + 0x81)
#define REG_PHY2P1_PM_P1_41_L   (REG_PHY2P1_PM_P1_BASE + 0x82)
#define REG_PHY2P1_PM_P1_41_H   (REG_PHY2P1_PM_P1_BASE + 0x83)
#define REG_PHY2P1_PM_P1_42_L   (REG_PHY2P1_PM_P1_BASE + 0x84)
#define REG_PHY2P1_PM_P1_42_H   (REG_PHY2P1_PM_P1_BASE + 0x85)
#define REG_PHY2P1_PM_P1_43_L   (REG_PHY2P1_PM_P1_BASE + 0x86)
#define REG_PHY2P1_PM_P1_43_H   (REG_PHY2P1_PM_P1_BASE + 0x87)
#define REG_PHY2P1_PM_P1_44_L   (REG_PHY2P1_PM_P1_BASE + 0x88)
#define REG_PHY2P1_PM_P1_44_H   (REG_PHY2P1_PM_P1_BASE + 0x89)
#define REG_PHY2P1_PM_P1_45_L   (REG_PHY2P1_PM_P1_BASE + 0x8A)
#define REG_PHY2P1_PM_P1_45_H   (REG_PHY2P1_PM_P1_BASE + 0x8B)
#define REG_PHY2P1_PM_P1_46_L   (REG_PHY2P1_PM_P1_BASE + 0x8C)
#define REG_PHY2P1_PM_P1_46_H   (REG_PHY2P1_PM_P1_BASE + 0x8D)
#define REG_PHY2P1_PM_P1_47_L   (REG_PHY2P1_PM_P1_BASE + 0x8E)
#define REG_PHY2P1_PM_P1_47_H   (REG_PHY2P1_PM_P1_BASE + 0x8F)
#define REG_PHY2P1_PM_P1_48_L   (REG_PHY2P1_PM_P1_BASE + 0x90)
#define REG_PHY2P1_PM_P1_48_H   (REG_PHY2P1_PM_P1_BASE + 0x91)
#define REG_PHY2P1_PM_P1_49_L   (REG_PHY2P1_PM_P1_BASE + 0x92)
#define REG_PHY2P1_PM_P1_49_H   (REG_PHY2P1_PM_P1_BASE + 0x93)
#define REG_PHY2P1_PM_P1_4A_L   (REG_PHY2P1_PM_P1_BASE + 0x94)
#define REG_PHY2P1_PM_P1_4A_H   (REG_PHY2P1_PM_P1_BASE + 0x95)
#define REG_PHY2P1_PM_P1_4B_L   (REG_PHY2P1_PM_P1_BASE + 0x96)
#define REG_PHY2P1_PM_P1_4B_H   (REG_PHY2P1_PM_P1_BASE + 0x97)
#define REG_PHY2P1_PM_P1_4C_L   (REG_PHY2P1_PM_P1_BASE + 0x98)
#define REG_PHY2P1_PM_P1_4C_H   (REG_PHY2P1_PM_P1_BASE + 0x99)
#define REG_PHY2P1_PM_P1_4D_L   (REG_PHY2P1_PM_P1_BASE + 0x9A)
#define REG_PHY2P1_PM_P1_4D_H   (REG_PHY2P1_PM_P1_BASE + 0x9B)
#define REG_PHY2P1_PM_P1_4E_L   (REG_PHY2P1_PM_P1_BASE + 0x9C)
#define REG_PHY2P1_PM_P1_4E_H   (REG_PHY2P1_PM_P1_BASE + 0x9D)
#define REG_PHY2P1_PM_P1_4F_L   (REG_PHY2P1_PM_P1_BASE + 0x9E)
#define REG_PHY2P1_PM_P1_4F_H   (REG_PHY2P1_PM_P1_BASE + 0x9F)
#define REG_PHY2P1_PM_P1_50_L   (REG_PHY2P1_PM_P1_BASE + 0xA0)
#define REG_PHY2P1_PM_P1_50_H   (REG_PHY2P1_PM_P1_BASE + 0xA1)
#define REG_PHY2P1_PM_P1_51_L   (REG_PHY2P1_PM_P1_BASE + 0xA2)
#define REG_PHY2P1_PM_P1_51_H   (REG_PHY2P1_PM_P1_BASE + 0xA3)
#define REG_PHY2P1_PM_P1_52_L   (REG_PHY2P1_PM_P1_BASE + 0xA4)
#define REG_PHY2P1_PM_P1_52_H   (REG_PHY2P1_PM_P1_BASE + 0xA5)
#define REG_PHY2P1_PM_P1_53_L   (REG_PHY2P1_PM_P1_BASE + 0xA6)
#define REG_PHY2P1_PM_P1_53_H   (REG_PHY2P1_PM_P1_BASE + 0xA7)
#define REG_PHY2P1_PM_P1_54_L   (REG_PHY2P1_PM_P1_BASE + 0xA8)
#define REG_PHY2P1_PM_P1_54_H   (REG_PHY2P1_PM_P1_BASE + 0xA9)
#define REG_PHY2P1_PM_P1_55_L   (REG_PHY2P1_PM_P1_BASE + 0xAA)
#define REG_PHY2P1_PM_P1_55_H   (REG_PHY2P1_PM_P1_BASE + 0xAB)
#define REG_PHY2P1_PM_P1_56_L   (REG_PHY2P1_PM_P1_BASE + 0xAC)
#define REG_PHY2P1_PM_P1_56_H   (REG_PHY2P1_PM_P1_BASE + 0xAD)
#define REG_PHY2P1_PM_P1_57_L   (REG_PHY2P1_PM_P1_BASE + 0xAE)
#define REG_PHY2P1_PM_P1_57_H   (REG_PHY2P1_PM_P1_BASE + 0xAF)
#define REG_PHY2P1_PM_P1_58_L   (REG_PHY2P1_PM_P1_BASE + 0xB0)
#define REG_PHY2P1_PM_P1_58_H   (REG_PHY2P1_PM_P1_BASE + 0xB1)
#define REG_PHY2P1_PM_P1_59_L   (REG_PHY2P1_PM_P1_BASE + 0xB2)
#define REG_PHY2P1_PM_P1_59_H   (REG_PHY2P1_PM_P1_BASE + 0xB3)
#define REG_PHY2P1_PM_P1_5A_L   (REG_PHY2P1_PM_P1_BASE + 0xB4)
#define REG_PHY2P1_PM_P1_5A_H   (REG_PHY2P1_PM_P1_BASE + 0xB5)
#define REG_PHY2P1_PM_P1_5B_L   (REG_PHY2P1_PM_P1_BASE + 0xB6)
#define REG_PHY2P1_PM_P1_5B_H   (REG_PHY2P1_PM_P1_BASE + 0xB7)
#define REG_PHY2P1_PM_P1_5C_L   (REG_PHY2P1_PM_P1_BASE + 0xB8)
#define REG_PHY2P1_PM_P1_5C_H   (REG_PHY2P1_PM_P1_BASE + 0xB9)
#define REG_PHY2P1_PM_P1_5D_L   (REG_PHY2P1_PM_P1_BASE + 0xBA)
#define REG_PHY2P1_PM_P1_5D_H   (REG_PHY2P1_PM_P1_BASE + 0xBB)
#define REG_PHY2P1_PM_P1_5E_L   (REG_PHY2P1_PM_P1_BASE + 0xBC)
#define REG_PHY2P1_PM_P1_5E_H   (REG_PHY2P1_PM_P1_BASE + 0xBD)
#define REG_PHY2P1_PM_P1_5F_L   (REG_PHY2P1_PM_P1_BASE + 0xBE)
#define REG_PHY2P1_PM_P1_5F_H   (REG_PHY2P1_PM_P1_BASE + 0xBF)
#define REG_PHY2P1_PM_P1_60_L   (REG_PHY2P1_PM_P1_BASE + 0xC0)
#define REG_PHY2P1_PM_P1_60_H   (REG_PHY2P1_PM_P1_BASE + 0xC1)
#define REG_PHY2P1_PM_P1_61_L   (REG_PHY2P1_PM_P1_BASE + 0xC2)
#define REG_PHY2P1_PM_P1_61_H   (REG_PHY2P1_PM_P1_BASE + 0xC3)
#define REG_PHY2P1_PM_P1_62_L   (REG_PHY2P1_PM_P1_BASE + 0xC4)
#define REG_PHY2P1_PM_P1_62_H   (REG_PHY2P1_PM_P1_BASE + 0xC5)
#define REG_PHY2P1_PM_P1_63_L   (REG_PHY2P1_PM_P1_BASE + 0xC6)
#define REG_PHY2P1_PM_P1_63_H   (REG_PHY2P1_PM_P1_BASE + 0xC7)
#define REG_PHY2P1_PM_P1_64_L   (REG_PHY2P1_PM_P1_BASE + 0xC8)
#define REG_PHY2P1_PM_P1_64_H   (REG_PHY2P1_PM_P1_BASE + 0xC9)
#define REG_PHY2P1_PM_P1_65_L   (REG_PHY2P1_PM_P1_BASE + 0xCA)
#define REG_PHY2P1_PM_P1_65_H   (REG_PHY2P1_PM_P1_BASE + 0xCB)
#define REG_PHY2P1_PM_P1_66_L   (REG_PHY2P1_PM_P1_BASE + 0xCC)
#define REG_PHY2P1_PM_P1_66_H   (REG_PHY2P1_PM_P1_BASE + 0xCD)
#define REG_PHY2P1_PM_P1_67_L   (REG_PHY2P1_PM_P1_BASE + 0xCE)
#define REG_PHY2P1_PM_P1_67_H   (REG_PHY2P1_PM_P1_BASE + 0xCF)
#define REG_PHY2P1_PM_P1_68_L   (REG_PHY2P1_PM_P1_BASE + 0xD0)
#define REG_PHY2P1_PM_P1_68_H   (REG_PHY2P1_PM_P1_BASE + 0xD1)
#define REG_PHY2P1_PM_P1_69_L   (REG_PHY2P1_PM_P1_BASE + 0xD2)
#define REG_PHY2P1_PM_P1_69_H   (REG_PHY2P1_PM_P1_BASE + 0xD3)
#define REG_PHY2P1_PM_P1_6A_L   (REG_PHY2P1_PM_P1_BASE + 0xD4)
#define REG_PHY2P1_PM_P1_6A_H   (REG_PHY2P1_PM_P1_BASE + 0xD5)
#define REG_PHY2P1_PM_P1_6B_L   (REG_PHY2P1_PM_P1_BASE + 0xD6)
#define REG_PHY2P1_PM_P1_6B_H   (REG_PHY2P1_PM_P1_BASE + 0xD7)
#define REG_PHY2P1_PM_P1_6C_L   (REG_PHY2P1_PM_P1_BASE + 0xD8)
#define REG_PHY2P1_PM_P1_6C_H   (REG_PHY2P1_PM_P1_BASE + 0xD9)
#define REG_PHY2P1_PM_P1_6D_L   (REG_PHY2P1_PM_P1_BASE + 0xDA)
#define REG_PHY2P1_PM_P1_6D_H   (REG_PHY2P1_PM_P1_BASE + 0xDB)
#define REG_PHY2P1_PM_P1_6E_L   (REG_PHY2P1_PM_P1_BASE + 0xDC)
#define REG_PHY2P1_PM_P1_6E_H   (REG_PHY2P1_PM_P1_BASE + 0xDD)
#define REG_PHY2P1_PM_P1_6F_L   (REG_PHY2P1_PM_P1_BASE + 0xDE)
#define REG_PHY2P1_PM_P1_6F_H   (REG_PHY2P1_PM_P1_BASE + 0xDF)
#define REG_PHY2P1_PM_P1_70_L   (REG_PHY2P1_PM_P1_BASE + 0xE0)
#define REG_PHY2P1_PM_P1_70_H   (REG_PHY2P1_PM_P1_BASE + 0xE1)
#define REG_PHY2P1_PM_P1_71_L   (REG_PHY2P1_PM_P1_BASE + 0xE2)
#define REG_PHY2P1_PM_P1_71_H   (REG_PHY2P1_PM_P1_BASE + 0xE3)
#define REG_PHY2P1_PM_P1_72_L   (REG_PHY2P1_PM_P1_BASE + 0xE4)
#define REG_PHY2P1_PM_P1_72_H   (REG_PHY2P1_PM_P1_BASE + 0xE5)
#define REG_PHY2P1_PM_P1_73_L   (REG_PHY2P1_PM_P1_BASE + 0xE6)
#define REG_PHY2P1_PM_P1_73_H   (REG_PHY2P1_PM_P1_BASE + 0xE7)
#define REG_PHY2P1_PM_P1_74_L   (REG_PHY2P1_PM_P1_BASE + 0xE8)
#define REG_PHY2P1_PM_P1_74_H   (REG_PHY2P1_PM_P1_BASE + 0xE9)
#define REG_PHY2P1_PM_P1_75_L   (REG_PHY2P1_PM_P1_BASE + 0xEA)
#define REG_PHY2P1_PM_P1_75_H   (REG_PHY2P1_PM_P1_BASE + 0xEB)
#define REG_PHY2P1_PM_P1_76_L   (REG_PHY2P1_PM_P1_BASE + 0xEC)
#define REG_PHY2P1_PM_P1_76_H   (REG_PHY2P1_PM_P1_BASE + 0xED)
#define REG_PHY2P1_PM_P1_77_L   (REG_PHY2P1_PM_P1_BASE + 0xEE)
#define REG_PHY2P1_PM_P1_77_H   (REG_PHY2P1_PM_P1_BASE + 0xEF)
#define REG_PHY2P1_PM_P1_78_L   (REG_PHY2P1_PM_P1_BASE + 0xF0)
#define REG_PHY2P1_PM_P1_78_H   (REG_PHY2P1_PM_P1_BASE + 0xF1)
#define REG_PHY2P1_PM_P1_79_L   (REG_PHY2P1_PM_P1_BASE + 0xF2)
#define REG_PHY2P1_PM_P1_79_H   (REG_PHY2P1_PM_P1_BASE + 0xF3)
#define REG_PHY2P1_PM_P1_7A_L   (REG_PHY2P1_PM_P1_BASE + 0xF4)
#define REG_PHY2P1_PM_P1_7A_H   (REG_PHY2P1_PM_P1_BASE + 0xF5)
#define REG_PHY2P1_PM_P1_7B_L   (REG_PHY2P1_PM_P1_BASE + 0xF6)
#define REG_PHY2P1_PM_P1_7B_H   (REG_PHY2P1_PM_P1_BASE + 0xF7)
#define REG_PHY2P1_PM_P1_7C_L   (REG_PHY2P1_PM_P1_BASE + 0xF8)
#define REG_PHY2P1_PM_P1_7C_H   (REG_PHY2P1_PM_P1_BASE + 0xF9)
#define REG_PHY2P1_PM_P1_7D_L   (REG_PHY2P1_PM_P1_BASE + 0xFA)
#define REG_PHY2P1_PM_P1_7D_H   (REG_PHY2P1_PM_P1_BASE + 0xFB)
#define REG_PHY2P1_PM_P1_7E_L   (REG_PHY2P1_PM_P1_BASE + 0xFC)
#define REG_PHY2P1_PM_P1_7E_H   (REG_PHY2P1_PM_P1_BASE + 0xFD)
#define REG_PHY2P1_PM_P1_7F_L   (REG_PHY2P1_PM_P1_BASE + 0xFE)
#define REG_PHY2P1_PM_P1_7F_H   (REG_PHY2P1_PM_P1_BASE + 0xFF)

//=============================================================
// PHY2P1_PM_P2
#define REG_PHY2P1_PM_P2_00_L   (REG_PHY2P1_PM_P2_BASE + 0x00)
#define REG_PHY2P1_PM_P2_00_H   (REG_PHY2P1_PM_P2_BASE + 0x01)
#define REG_PHY2P1_PM_P2_01_L   (REG_PHY2P1_PM_P2_BASE + 0x02)
#define REG_PHY2P1_PM_P2_01_H   (REG_PHY2P1_PM_P2_BASE + 0x03)
#define REG_PHY2P1_PM_P2_02_L   (REG_PHY2P1_PM_P2_BASE + 0x04)
#define REG_PHY2P1_PM_P2_02_H   (REG_PHY2P1_PM_P2_BASE + 0x05)
#define REG_PHY2P1_PM_P2_03_L   (REG_PHY2P1_PM_P2_BASE + 0x06)
#define REG_PHY2P1_PM_P2_03_H   (REG_PHY2P1_PM_P2_BASE + 0x07)
#define REG_PHY2P1_PM_P2_04_L   (REG_PHY2P1_PM_P2_BASE + 0x08)
#define REG_PHY2P1_PM_P2_04_H   (REG_PHY2P1_PM_P2_BASE + 0x09)
#define REG_PHY2P1_PM_P2_05_L   (REG_PHY2P1_PM_P2_BASE + 0x0A)
#define REG_PHY2P1_PM_P2_05_H   (REG_PHY2P1_PM_P2_BASE + 0x0B)
#define REG_PHY2P1_PM_P2_06_L   (REG_PHY2P1_PM_P2_BASE + 0x0C)
#define REG_PHY2P1_PM_P2_06_H   (REG_PHY2P1_PM_P2_BASE + 0x0D)
#define REG_PHY2P1_PM_P2_07_L   (REG_PHY2P1_PM_P2_BASE + 0x0E)
#define REG_PHY2P1_PM_P2_07_H   (REG_PHY2P1_PM_P2_BASE + 0x0F)
#define REG_PHY2P1_PM_P2_08_L   (REG_PHY2P1_PM_P2_BASE + 0x10)
#define REG_PHY2P1_PM_P2_08_H   (REG_PHY2P1_PM_P2_BASE + 0x11)
#define REG_PHY2P1_PM_P2_09_L   (REG_PHY2P1_PM_P2_BASE + 0x12)
#define REG_PHY2P1_PM_P2_09_H   (REG_PHY2P1_PM_P2_BASE + 0x13)
#define REG_PHY2P1_PM_P2_0A_L   (REG_PHY2P1_PM_P2_BASE + 0x14)
#define REG_PHY2P1_PM_P2_0A_H   (REG_PHY2P1_PM_P2_BASE + 0x15)
#define REG_PHY2P1_PM_P2_0B_L   (REG_PHY2P1_PM_P2_BASE + 0x16)
#define REG_PHY2P1_PM_P2_0B_H   (REG_PHY2P1_PM_P2_BASE + 0x17)
#define REG_PHY2P1_PM_P2_0C_L   (REG_PHY2P1_PM_P2_BASE + 0x18)
#define REG_PHY2P1_PM_P2_0C_H   (REG_PHY2P1_PM_P2_BASE + 0x19)
#define REG_PHY2P1_PM_P2_0D_L   (REG_PHY2P1_PM_P2_BASE + 0x1A)
#define REG_PHY2P1_PM_P2_0D_H   (REG_PHY2P1_PM_P2_BASE + 0x1B)
#define REG_PHY2P1_PM_P2_0E_L   (REG_PHY2P1_PM_P2_BASE + 0x1C)
#define REG_PHY2P1_PM_P2_0E_H   (REG_PHY2P1_PM_P2_BASE + 0x1D)
#define REG_PHY2P1_PM_P2_0F_L   (REG_PHY2P1_PM_P2_BASE + 0x1E)
#define REG_PHY2P1_PM_P2_0F_H   (REG_PHY2P1_PM_P2_BASE + 0x1F)
#define REG_PHY2P1_PM_P2_10_L   (REG_PHY2P1_PM_P2_BASE + 0x20)
#define REG_PHY2P1_PM_P2_10_H   (REG_PHY2P1_PM_P2_BASE + 0x21)
#define REG_PHY2P1_PM_P2_11_L   (REG_PHY2P1_PM_P2_BASE + 0x22)
#define REG_PHY2P1_PM_P2_11_H   (REG_PHY2P1_PM_P2_BASE + 0x23)
#define REG_PHY2P1_PM_P2_12_L   (REG_PHY2P1_PM_P2_BASE + 0x24)
#define REG_PHY2P1_PM_P2_12_H   (REG_PHY2P1_PM_P2_BASE + 0x25)
#define REG_PHY2P1_PM_P2_13_L   (REG_PHY2P1_PM_P2_BASE + 0x26)
#define REG_PHY2P1_PM_P2_13_H   (REG_PHY2P1_PM_P2_BASE + 0x27)
#define REG_PHY2P1_PM_P2_14_L   (REG_PHY2P1_PM_P2_BASE + 0x28)
#define REG_PHY2P1_PM_P2_14_H   (REG_PHY2P1_PM_P2_BASE + 0x29)
#define REG_PHY2P1_PM_P2_15_L   (REG_PHY2P1_PM_P2_BASE + 0x2A)
#define REG_PHY2P1_PM_P2_15_H   (REG_PHY2P1_PM_P2_BASE + 0x2B)
#define REG_PHY2P1_PM_P2_16_L   (REG_PHY2P1_PM_P2_BASE + 0x2C)
#define REG_PHY2P1_PM_P2_16_H   (REG_PHY2P1_PM_P2_BASE + 0x2D)
#define REG_PHY2P1_PM_P2_17_L   (REG_PHY2P1_PM_P2_BASE + 0x2E)
#define REG_PHY2P1_PM_P2_17_H   (REG_PHY2P1_PM_P2_BASE + 0x2F)
#define REG_PHY2P1_PM_P2_18_L   (REG_PHY2P1_PM_P2_BASE + 0x30)
#define REG_PHY2P1_PM_P2_18_H   (REG_PHY2P1_PM_P2_BASE + 0x31)
#define REG_PHY2P1_PM_P2_19_L   (REG_PHY2P1_PM_P2_BASE + 0x32)
#define REG_PHY2P1_PM_P2_19_H   (REG_PHY2P1_PM_P2_BASE + 0x33)
#define REG_PHY2P1_PM_P2_1A_L   (REG_PHY2P1_PM_P2_BASE + 0x34)
#define REG_PHY2P1_PM_P2_1A_H   (REG_PHY2P1_PM_P2_BASE + 0x35)
#define REG_PHY2P1_PM_P2_1B_L   (REG_PHY2P1_PM_P2_BASE + 0x36)
#define REG_PHY2P1_PM_P2_1B_H   (REG_PHY2P1_PM_P2_BASE + 0x37)
#define REG_PHY2P1_PM_P2_1C_L   (REG_PHY2P1_PM_P2_BASE + 0x38)
#define REG_PHY2P1_PM_P2_1C_H   (REG_PHY2P1_PM_P2_BASE + 0x39)
#define REG_PHY2P1_PM_P2_1D_L   (REG_PHY2P1_PM_P2_BASE + 0x3A)
#define REG_PHY2P1_PM_P2_1D_H   (REG_PHY2P1_PM_P2_BASE + 0x3B)
#define REG_PHY2P1_PM_P2_1E_L   (REG_PHY2P1_PM_P2_BASE + 0x3C)
#define REG_PHY2P1_PM_P2_1E_H   (REG_PHY2P1_PM_P2_BASE + 0x3D)
#define REG_PHY2P1_PM_P2_1F_L   (REG_PHY2P1_PM_P2_BASE + 0x3E)
#define REG_PHY2P1_PM_P2_1F_H   (REG_PHY2P1_PM_P2_BASE + 0x3F)
#define REG_PHY2P1_PM_P2_20_L   (REG_PHY2P1_PM_P2_BASE + 0x40)
#define REG_PHY2P1_PM_P2_20_H   (REG_PHY2P1_PM_P2_BASE + 0x41)
#define REG_PHY2P1_PM_P2_21_L   (REG_PHY2P1_PM_P2_BASE + 0x42)
#define REG_PHY2P1_PM_P2_21_H   (REG_PHY2P1_PM_P2_BASE + 0x43)
#define REG_PHY2P1_PM_P2_22_L   (REG_PHY2P1_PM_P2_BASE + 0x44)
#define REG_PHY2P1_PM_P2_22_H   (REG_PHY2P1_PM_P2_BASE + 0x45)
#define REG_PHY2P1_PM_P2_23_L   (REG_PHY2P1_PM_P2_BASE + 0x46)
#define REG_PHY2P1_PM_P2_23_H   (REG_PHY2P1_PM_P2_BASE + 0x47)
#define REG_PHY2P1_PM_P2_24_L   (REG_PHY2P1_PM_P2_BASE + 0x48)
#define REG_PHY2P1_PM_P2_24_H   (REG_PHY2P1_PM_P2_BASE + 0x49)
#define REG_PHY2P1_PM_P2_25_L   (REG_PHY2P1_PM_P2_BASE + 0x4A)
#define REG_PHY2P1_PM_P2_25_H   (REG_PHY2P1_PM_P2_BASE + 0x4B)
#define REG_PHY2P1_PM_P2_26_L   (REG_PHY2P1_PM_P2_BASE + 0x4C)
#define REG_PHY2P1_PM_P2_26_H   (REG_PHY2P1_PM_P2_BASE + 0x4D)
#define REG_PHY2P1_PM_P2_27_L   (REG_PHY2P1_PM_P2_BASE + 0x4E)
#define REG_PHY2P1_PM_P2_27_H   (REG_PHY2P1_PM_P2_BASE + 0x4F)
#define REG_PHY2P1_PM_P2_28_L   (REG_PHY2P1_PM_P2_BASE + 0x50)
#define REG_PHY2P1_PM_P2_28_H   (REG_PHY2P1_PM_P2_BASE + 0x51)
#define REG_PHY2P1_PM_P2_29_L   (REG_PHY2P1_PM_P2_BASE + 0x52)
#define REG_PHY2P1_PM_P2_29_H   (REG_PHY2P1_PM_P2_BASE + 0x53)
#define REG_PHY2P1_PM_P2_2A_L   (REG_PHY2P1_PM_P2_BASE + 0x54)
#define REG_PHY2P1_PM_P2_2A_H   (REG_PHY2P1_PM_P2_BASE + 0x55)
#define REG_PHY2P1_PM_P2_2B_L   (REG_PHY2P1_PM_P2_BASE + 0x56)
#define REG_PHY2P1_PM_P2_2B_H   (REG_PHY2P1_PM_P2_BASE + 0x57)
#define REG_PHY2P1_PM_P2_2C_L   (REG_PHY2P1_PM_P2_BASE + 0x58)
#define REG_PHY2P1_PM_P2_2C_H   (REG_PHY2P1_PM_P2_BASE + 0x59)
#define REG_PHY2P1_PM_P2_2D_L   (REG_PHY2P1_PM_P2_BASE + 0x5A)
#define REG_PHY2P1_PM_P2_2D_H   (REG_PHY2P1_PM_P2_BASE + 0x5B)
#define REG_PHY2P1_PM_P2_2E_L   (REG_PHY2P1_PM_P2_BASE + 0x5C)
#define REG_PHY2P1_PM_P2_2E_H   (REG_PHY2P1_PM_P2_BASE + 0x5D)
#define REG_PHY2P1_PM_P2_2F_L   (REG_PHY2P1_PM_P2_BASE + 0x5E)
#define REG_PHY2P1_PM_P2_2F_H   (REG_PHY2P1_PM_P2_BASE + 0x5F)
#define REG_PHY2P1_PM_P2_30_L   (REG_PHY2P1_PM_P2_BASE + 0x60)
#define REG_PHY2P1_PM_P2_30_H   (REG_PHY2P1_PM_P2_BASE + 0x61)
#define REG_PHY2P1_PM_P2_31_L   (REG_PHY2P1_PM_P2_BASE + 0x62)
#define REG_PHY2P1_PM_P2_31_H   (REG_PHY2P1_PM_P2_BASE + 0x63)
#define REG_PHY2P1_PM_P2_32_L   (REG_PHY2P1_PM_P2_BASE + 0x64)
#define REG_PHY2P1_PM_P2_32_H   (REG_PHY2P1_PM_P2_BASE + 0x65)
#define REG_PHY2P1_PM_P2_33_L   (REG_PHY2P1_PM_P2_BASE + 0x66)
#define REG_PHY2P1_PM_P2_33_H   (REG_PHY2P1_PM_P2_BASE + 0x67)
#define REG_PHY2P1_PM_P2_34_L   (REG_PHY2P1_PM_P2_BASE + 0x68)
#define REG_PHY2P1_PM_P2_34_H   (REG_PHY2P1_PM_P2_BASE + 0x69)
#define REG_PHY2P1_PM_P2_35_L   (REG_PHY2P1_PM_P2_BASE + 0x6A)
#define REG_PHY2P1_PM_P2_35_H   (REG_PHY2P1_PM_P2_BASE + 0x6B)
#define REG_PHY2P1_PM_P2_36_L   (REG_PHY2P1_PM_P2_BASE + 0x6C)
#define REG_PHY2P1_PM_P2_36_H   (REG_PHY2P1_PM_P2_BASE + 0x6D)
#define REG_PHY2P1_PM_P2_37_L   (REG_PHY2P1_PM_P2_BASE + 0x6E)
#define REG_PHY2P1_PM_P2_37_H   (REG_PHY2P1_PM_P2_BASE + 0x6F)
#define REG_PHY2P1_PM_P2_38_L   (REG_PHY2P1_PM_P2_BASE + 0x70)
#define REG_PHY2P1_PM_P2_38_H   (REG_PHY2P1_PM_P2_BASE + 0x71)
#define REG_PHY2P1_PM_P2_39_L   (REG_PHY2P1_PM_P2_BASE + 0x72)
#define REG_PHY2P1_PM_P2_39_H   (REG_PHY2P1_PM_P2_BASE + 0x73)
#define REG_PHY2P1_PM_P2_3A_L   (REG_PHY2P1_PM_P2_BASE + 0x74)
#define REG_PHY2P1_PM_P2_3A_H   (REG_PHY2P1_PM_P2_BASE + 0x75)
#define REG_PHY2P1_PM_P2_3B_L   (REG_PHY2P1_PM_P2_BASE + 0x76)
#define REG_PHY2P1_PM_P2_3B_H   (REG_PHY2P1_PM_P2_BASE + 0x77)
#define REG_PHY2P1_PM_P2_3C_L   (REG_PHY2P1_PM_P2_BASE + 0x78)
#define REG_PHY2P1_PM_P2_3C_H   (REG_PHY2P1_PM_P2_BASE + 0x79)
#define REG_PHY2P1_PM_P2_3D_L   (REG_PHY2P1_PM_P2_BASE + 0x7A)
#define REG_PHY2P1_PM_P2_3D_H   (REG_PHY2P1_PM_P2_BASE + 0x7B)
#define REG_PHY2P1_PM_P2_3E_L   (REG_PHY2P1_PM_P2_BASE + 0x7C)
#define REG_PHY2P1_PM_P2_3E_H   (REG_PHY2P1_PM_P2_BASE + 0x7D)
#define REG_PHY2P1_PM_P2_3F_L   (REG_PHY2P1_PM_P2_BASE + 0x7E)
#define REG_PHY2P1_PM_P2_3F_H   (REG_PHY2P1_PM_P2_BASE + 0x7F)
#define REG_PHY2P1_PM_P2_40_L   (REG_PHY2P1_PM_P2_BASE + 0x80)
#define REG_PHY2P1_PM_P2_40_H   (REG_PHY2P1_PM_P2_BASE + 0x81)
#define REG_PHY2P1_PM_P2_41_L   (REG_PHY2P1_PM_P2_BASE + 0x82)
#define REG_PHY2P1_PM_P2_41_H   (REG_PHY2P1_PM_P2_BASE + 0x83)
#define REG_PHY2P1_PM_P2_42_L   (REG_PHY2P1_PM_P2_BASE + 0x84)
#define REG_PHY2P1_PM_P2_42_H   (REG_PHY2P1_PM_P2_BASE + 0x85)
#define REG_PHY2P1_PM_P2_43_L   (REG_PHY2P1_PM_P2_BASE + 0x86)
#define REG_PHY2P1_PM_P2_43_H   (REG_PHY2P1_PM_P2_BASE + 0x87)
#define REG_PHY2P1_PM_P2_44_L   (REG_PHY2P1_PM_P2_BASE + 0x88)
#define REG_PHY2P1_PM_P2_44_H   (REG_PHY2P1_PM_P2_BASE + 0x89)
#define REG_PHY2P1_PM_P2_45_L   (REG_PHY2P1_PM_P2_BASE + 0x8A)
#define REG_PHY2P1_PM_P2_45_H   (REG_PHY2P1_PM_P2_BASE + 0x8B)
#define REG_PHY2P1_PM_P2_46_L   (REG_PHY2P1_PM_P2_BASE + 0x8C)
#define REG_PHY2P1_PM_P2_46_H   (REG_PHY2P1_PM_P2_BASE + 0x8D)
#define REG_PHY2P1_PM_P2_47_L   (REG_PHY2P1_PM_P2_BASE + 0x8E)
#define REG_PHY2P1_PM_P2_47_H   (REG_PHY2P1_PM_P2_BASE + 0x8F)
#define REG_PHY2P1_PM_P2_48_L   (REG_PHY2P1_PM_P2_BASE + 0x90)
#define REG_PHY2P1_PM_P2_48_H   (REG_PHY2P1_PM_P2_BASE + 0x91)
#define REG_PHY2P1_PM_P2_49_L   (REG_PHY2P1_PM_P2_BASE + 0x92)
#define REG_PHY2P1_PM_P2_49_H   (REG_PHY2P1_PM_P2_BASE + 0x93)
#define REG_PHY2P1_PM_P2_4A_L   (REG_PHY2P1_PM_P2_BASE + 0x94)
#define REG_PHY2P1_PM_P2_4A_H   (REG_PHY2P1_PM_P2_BASE + 0x95)
#define REG_PHY2P1_PM_P2_4B_L   (REG_PHY2P1_PM_P2_BASE + 0x96)
#define REG_PHY2P1_PM_P2_4B_H   (REG_PHY2P1_PM_P2_BASE + 0x97)
#define REG_PHY2P1_PM_P2_4C_L   (REG_PHY2P1_PM_P2_BASE + 0x98)
#define REG_PHY2P1_PM_P2_4C_H   (REG_PHY2P1_PM_P2_BASE + 0x99)
#define REG_PHY2P1_PM_P2_4D_L   (REG_PHY2P1_PM_P2_BASE + 0x9A)
#define REG_PHY2P1_PM_P2_4D_H   (REG_PHY2P1_PM_P2_BASE + 0x9B)
#define REG_PHY2P1_PM_P2_4E_L   (REG_PHY2P1_PM_P2_BASE + 0x9C)
#define REG_PHY2P1_PM_P2_4E_H   (REG_PHY2P1_PM_P2_BASE + 0x9D)
#define REG_PHY2P1_PM_P2_4F_L   (REG_PHY2P1_PM_P2_BASE + 0x9E)
#define REG_PHY2P1_PM_P2_4F_H   (REG_PHY2P1_PM_P2_BASE + 0x9F)
#define REG_PHY2P1_PM_P2_50_L   (REG_PHY2P1_PM_P2_BASE + 0xA0)
#define REG_PHY2P1_PM_P2_50_H   (REG_PHY2P1_PM_P2_BASE + 0xA1)
#define REG_PHY2P1_PM_P2_51_L   (REG_PHY2P1_PM_P2_BASE + 0xA2)
#define REG_PHY2P1_PM_P2_51_H   (REG_PHY2P1_PM_P2_BASE + 0xA3)
#define REG_PHY2P1_PM_P2_52_L   (REG_PHY2P1_PM_P2_BASE + 0xA4)
#define REG_PHY2P1_PM_P2_52_H   (REG_PHY2P1_PM_P2_BASE + 0xA5)
#define REG_PHY2P1_PM_P2_53_L   (REG_PHY2P1_PM_P2_BASE + 0xA6)
#define REG_PHY2P1_PM_P2_53_H   (REG_PHY2P1_PM_P2_BASE + 0xA7)
#define REG_PHY2P1_PM_P2_54_L   (REG_PHY2P1_PM_P2_BASE + 0xA8)
#define REG_PHY2P1_PM_P2_54_H   (REG_PHY2P1_PM_P2_BASE + 0xA9)
#define REG_PHY2P1_PM_P2_55_L   (REG_PHY2P1_PM_P2_BASE + 0xAA)
#define REG_PHY2P1_PM_P2_55_H   (REG_PHY2P1_PM_P2_BASE + 0xAB)
#define REG_PHY2P1_PM_P2_56_L   (REG_PHY2P1_PM_P2_BASE + 0xAC)
#define REG_PHY2P1_PM_P2_56_H   (REG_PHY2P1_PM_P2_BASE + 0xAD)
#define REG_PHY2P1_PM_P2_57_L   (REG_PHY2P1_PM_P2_BASE + 0xAE)
#define REG_PHY2P1_PM_P2_57_H   (REG_PHY2P1_PM_P2_BASE + 0xAF)
#define REG_PHY2P1_PM_P2_58_L   (REG_PHY2P1_PM_P2_BASE + 0xB0)
#define REG_PHY2P1_PM_P2_58_H   (REG_PHY2P1_PM_P2_BASE + 0xB1)
#define REG_PHY2P1_PM_P2_59_L   (REG_PHY2P1_PM_P2_BASE + 0xB2)
#define REG_PHY2P1_PM_P2_59_H   (REG_PHY2P1_PM_P2_BASE + 0xB3)
#define REG_PHY2P1_PM_P2_5A_L   (REG_PHY2P1_PM_P2_BASE + 0xB4)
#define REG_PHY2P1_PM_P2_5A_H   (REG_PHY2P1_PM_P2_BASE + 0xB5)
#define REG_PHY2P1_PM_P2_5B_L   (REG_PHY2P1_PM_P2_BASE + 0xB6)
#define REG_PHY2P1_PM_P2_5B_H   (REG_PHY2P1_PM_P2_BASE + 0xB7)
#define REG_PHY2P1_PM_P2_5C_L   (REG_PHY2P1_PM_P2_BASE + 0xB8)
#define REG_PHY2P1_PM_P2_5C_H   (REG_PHY2P1_PM_P2_BASE + 0xB9)
#define REG_PHY2P1_PM_P2_5D_L   (REG_PHY2P1_PM_P2_BASE + 0xBA)
#define REG_PHY2P1_PM_P2_5D_H   (REG_PHY2P1_PM_P2_BASE + 0xBB)
#define REG_PHY2P1_PM_P2_5E_L   (REG_PHY2P1_PM_P2_BASE + 0xBC)
#define REG_PHY2P1_PM_P2_5E_H   (REG_PHY2P1_PM_P2_BASE + 0xBD)
#define REG_PHY2P1_PM_P2_5F_L   (REG_PHY2P1_PM_P2_BASE + 0xBE)
#define REG_PHY2P1_PM_P2_5F_H   (REG_PHY2P1_PM_P2_BASE + 0xBF)
#define REG_PHY2P1_PM_P2_60_L   (REG_PHY2P1_PM_P2_BASE + 0xC0)
#define REG_PHY2P1_PM_P2_60_H   (REG_PHY2P1_PM_P2_BASE + 0xC1)
#define REG_PHY2P1_PM_P2_61_L   (REG_PHY2P1_PM_P2_BASE + 0xC2)
#define REG_PHY2P1_PM_P2_61_H   (REG_PHY2P1_PM_P2_BASE + 0xC3)
#define REG_PHY2P1_PM_P2_62_L   (REG_PHY2P1_PM_P2_BASE + 0xC4)
#define REG_PHY2P1_PM_P2_62_H   (REG_PHY2P1_PM_P2_BASE + 0xC5)
#define REG_PHY2P1_PM_P2_63_L   (REG_PHY2P1_PM_P2_BASE + 0xC6)
#define REG_PHY2P1_PM_P2_63_H   (REG_PHY2P1_PM_P2_BASE + 0xC7)
#define REG_PHY2P1_PM_P2_64_L   (REG_PHY2P1_PM_P2_BASE + 0xC8)
#define REG_PHY2P1_PM_P2_64_H   (REG_PHY2P1_PM_P2_BASE + 0xC9)
#define REG_PHY2P1_PM_P2_65_L   (REG_PHY2P1_PM_P2_BASE + 0xCA)
#define REG_PHY2P1_PM_P2_65_H   (REG_PHY2P1_PM_P2_BASE + 0xCB)
#define REG_PHY2P1_PM_P2_66_L   (REG_PHY2P1_PM_P2_BASE + 0xCC)
#define REG_PHY2P1_PM_P2_66_H   (REG_PHY2P1_PM_P2_BASE + 0xCD)
#define REG_PHY2P1_PM_P2_67_L   (REG_PHY2P1_PM_P2_BASE + 0xCE)
#define REG_PHY2P1_PM_P2_67_H   (REG_PHY2P1_PM_P2_BASE + 0xCF)
#define REG_PHY2P1_PM_P2_68_L   (REG_PHY2P1_PM_P2_BASE + 0xD0)
#define REG_PHY2P1_PM_P2_68_H   (REG_PHY2P1_PM_P2_BASE + 0xD1)
#define REG_PHY2P1_PM_P2_69_L   (REG_PHY2P1_PM_P2_BASE + 0xD2)
#define REG_PHY2P1_PM_P2_69_H   (REG_PHY2P1_PM_P2_BASE + 0xD3)
#define REG_PHY2P1_PM_P2_6A_L   (REG_PHY2P1_PM_P2_BASE + 0xD4)
#define REG_PHY2P1_PM_P2_6A_H   (REG_PHY2P1_PM_P2_BASE + 0xD5)
#define REG_PHY2P1_PM_P2_6B_L   (REG_PHY2P1_PM_P2_BASE + 0xD6)
#define REG_PHY2P1_PM_P2_6B_H   (REG_PHY2P1_PM_P2_BASE + 0xD7)
#define REG_PHY2P1_PM_P2_6C_L   (REG_PHY2P1_PM_P2_BASE + 0xD8)
#define REG_PHY2P1_PM_P2_6C_H   (REG_PHY2P1_PM_P2_BASE + 0xD9)
#define REG_PHY2P1_PM_P2_6D_L   (REG_PHY2P1_PM_P2_BASE + 0xDA)
#define REG_PHY2P1_PM_P2_6D_H   (REG_PHY2P1_PM_P2_BASE + 0xDB)
#define REG_PHY2P1_PM_P2_6E_L   (REG_PHY2P1_PM_P2_BASE + 0xDC)
#define REG_PHY2P1_PM_P2_6E_H   (REG_PHY2P1_PM_P2_BASE + 0xDD)
#define REG_PHY2P1_PM_P2_6F_L   (REG_PHY2P1_PM_P2_BASE + 0xDE)
#define REG_PHY2P1_PM_P2_6F_H   (REG_PHY2P1_PM_P2_BASE + 0xDF)
#define REG_PHY2P1_PM_P2_70_L   (REG_PHY2P1_PM_P2_BASE + 0xE0)
#define REG_PHY2P1_PM_P2_70_H   (REG_PHY2P1_PM_P2_BASE + 0xE1)
#define REG_PHY2P1_PM_P2_71_L   (REG_PHY2P1_PM_P2_BASE + 0xE2)
#define REG_PHY2P1_PM_P2_71_H   (REG_PHY2P1_PM_P2_BASE + 0xE3)
#define REG_PHY2P1_PM_P2_72_L   (REG_PHY2P1_PM_P2_BASE + 0xE4)
#define REG_PHY2P1_PM_P2_72_H   (REG_PHY2P1_PM_P2_BASE + 0xE5)
#define REG_PHY2P1_PM_P2_73_L   (REG_PHY2P1_PM_P2_BASE + 0xE6)
#define REG_PHY2P1_PM_P2_73_H   (REG_PHY2P1_PM_P2_BASE + 0xE7)
#define REG_PHY2P1_PM_P2_74_L   (REG_PHY2P1_PM_P2_BASE + 0xE8)
#define REG_PHY2P1_PM_P2_74_H   (REG_PHY2P1_PM_P2_BASE + 0xE9)
#define REG_PHY2P1_PM_P2_75_L   (REG_PHY2P1_PM_P2_BASE + 0xEA)
#define REG_PHY2P1_PM_P2_75_H   (REG_PHY2P1_PM_P2_BASE + 0xEB)
#define REG_PHY2P1_PM_P2_76_L   (REG_PHY2P1_PM_P2_BASE + 0xEC)
#define REG_PHY2P1_PM_P2_76_H   (REG_PHY2P1_PM_P2_BASE + 0xED)
#define REG_PHY2P1_PM_P2_77_L   (REG_PHY2P1_PM_P2_BASE + 0xEE)
#define REG_PHY2P1_PM_P2_77_H   (REG_PHY2P1_PM_P2_BASE + 0xEF)
#define REG_PHY2P1_PM_P2_78_L   (REG_PHY2P1_PM_P2_BASE + 0xF0)
#define REG_PHY2P1_PM_P2_78_H   (REG_PHY2P1_PM_P2_BASE + 0xF1)
#define REG_PHY2P1_PM_P2_79_L   (REG_PHY2P1_PM_P2_BASE + 0xF2)
#define REG_PHY2P1_PM_P2_79_H   (REG_PHY2P1_PM_P2_BASE + 0xF3)
#define REG_PHY2P1_PM_P2_7A_L   (REG_PHY2P1_PM_P2_BASE + 0xF4)
#define REG_PHY2P1_PM_P2_7A_H   (REG_PHY2P1_PM_P2_BASE + 0xF5)
#define REG_PHY2P1_PM_P2_7B_L   (REG_PHY2P1_PM_P2_BASE + 0xF6)
#define REG_PHY2P1_PM_P2_7B_H   (REG_PHY2P1_PM_P2_BASE + 0xF7)
#define REG_PHY2P1_PM_P2_7C_L   (REG_PHY2P1_PM_P2_BASE + 0xF8)
#define REG_PHY2P1_PM_P2_7C_H   (REG_PHY2P1_PM_P2_BASE + 0xF9)
#define REG_PHY2P1_PM_P2_7D_L   (REG_PHY2P1_PM_P2_BASE + 0xFA)
#define REG_PHY2P1_PM_P2_7D_H   (REG_PHY2P1_PM_P2_BASE + 0xFB)
#define REG_PHY2P1_PM_P2_7E_L   (REG_PHY2P1_PM_P2_BASE + 0xFC)
#define REG_PHY2P1_PM_P2_7E_H   (REG_PHY2P1_PM_P2_BASE + 0xFD)
#define REG_PHY2P1_PM_P2_7F_L   (REG_PHY2P1_PM_P2_BASE + 0xFE)
#define REG_PHY2P1_PM_P2_7F_H   (REG_PHY2P1_PM_P2_BASE + 0xFF)

//=============================================================
// PHY2P1_PM_P3
#define REG_PHY2P1_PM_P3_00_L   (REG_PHY2P1_PM_P3_BASE + 0x00)
#define REG_PHY2P1_PM_P3_00_H   (REG_PHY2P1_PM_P3_BASE + 0x01)
#define REG_PHY2P1_PM_P3_01_L   (REG_PHY2P1_PM_P3_BASE + 0x02)
#define REG_PHY2P1_PM_P3_01_H   (REG_PHY2P1_PM_P3_BASE + 0x03)
#define REG_PHY2P1_PM_P3_02_L   (REG_PHY2P1_PM_P3_BASE + 0x04)
#define REG_PHY2P1_PM_P3_02_H   (REG_PHY2P1_PM_P3_BASE + 0x05)
#define REG_PHY2P1_PM_P3_03_L   (REG_PHY2P1_PM_P3_BASE + 0x06)
#define REG_PHY2P1_PM_P3_03_H   (REG_PHY2P1_PM_P3_BASE + 0x07)
#define REG_PHY2P1_PM_P3_04_L   (REG_PHY2P1_PM_P3_BASE + 0x08)
#define REG_PHY2P1_PM_P3_04_H   (REG_PHY2P1_PM_P3_BASE + 0x09)
#define REG_PHY2P1_PM_P3_05_L   (REG_PHY2P1_PM_P3_BASE + 0x0A)
#define REG_PHY2P1_PM_P3_05_H   (REG_PHY2P1_PM_P3_BASE + 0x0B)
#define REG_PHY2P1_PM_P3_06_L   (REG_PHY2P1_PM_P3_BASE + 0x0C)
#define REG_PHY2P1_PM_P3_06_H   (REG_PHY2P1_PM_P3_BASE + 0x0D)
#define REG_PHY2P1_PM_P3_07_L   (REG_PHY2P1_PM_P3_BASE + 0x0E)
#define REG_PHY2P1_PM_P3_07_H   (REG_PHY2P1_PM_P3_BASE + 0x0F)
#define REG_PHY2P1_PM_P3_08_L   (REG_PHY2P1_PM_P3_BASE + 0x10)
#define REG_PHY2P1_PM_P3_08_H   (REG_PHY2P1_PM_P3_BASE + 0x11)
#define REG_PHY2P1_PM_P3_09_L   (REG_PHY2P1_PM_P3_BASE + 0x12)
#define REG_PHY2P1_PM_P3_09_H   (REG_PHY2P1_PM_P3_BASE + 0x13)
#define REG_PHY2P1_PM_P3_0A_L   (REG_PHY2P1_PM_P3_BASE + 0x14)
#define REG_PHY2P1_PM_P3_0A_H   (REG_PHY2P1_PM_P3_BASE + 0x15)
#define REG_PHY2P1_PM_P3_0B_L   (REG_PHY2P1_PM_P3_BASE + 0x16)
#define REG_PHY2P1_PM_P3_0B_H   (REG_PHY2P1_PM_P3_BASE + 0x17)
#define REG_PHY2P1_PM_P3_0C_L   (REG_PHY2P1_PM_P3_BASE + 0x18)
#define REG_PHY2P1_PM_P3_0C_H   (REG_PHY2P1_PM_P3_BASE + 0x19)
#define REG_PHY2P1_PM_P3_0D_L   (REG_PHY2P1_PM_P3_BASE + 0x1A)
#define REG_PHY2P1_PM_P3_0D_H   (REG_PHY2P1_PM_P3_BASE + 0x1B)
#define REG_PHY2P1_PM_P3_0E_L   (REG_PHY2P1_PM_P3_BASE + 0x1C)
#define REG_PHY2P1_PM_P3_0E_H   (REG_PHY2P1_PM_P3_BASE + 0x1D)
#define REG_PHY2P1_PM_P3_0F_L   (REG_PHY2P1_PM_P3_BASE + 0x1E)
#define REG_PHY2P1_PM_P3_0F_H   (REG_PHY2P1_PM_P3_BASE + 0x1F)
#define REG_PHY2P1_PM_P3_10_L   (REG_PHY2P1_PM_P3_BASE + 0x20)
#define REG_PHY2P1_PM_P3_10_H   (REG_PHY2P1_PM_P3_BASE + 0x21)
#define REG_PHY2P1_PM_P3_11_L   (REG_PHY2P1_PM_P3_BASE + 0x22)
#define REG_PHY2P1_PM_P3_11_H   (REG_PHY2P1_PM_P3_BASE + 0x23)
#define REG_PHY2P1_PM_P3_12_L   (REG_PHY2P1_PM_P3_BASE + 0x24)
#define REG_PHY2P1_PM_P3_12_H   (REG_PHY2P1_PM_P3_BASE + 0x25)
#define REG_PHY2P1_PM_P3_13_L   (REG_PHY2P1_PM_P3_BASE + 0x26)
#define REG_PHY2P1_PM_P3_13_H   (REG_PHY2P1_PM_P3_BASE + 0x27)
#define REG_PHY2P1_PM_P3_14_L   (REG_PHY2P1_PM_P3_BASE + 0x28)
#define REG_PHY2P1_PM_P3_14_H   (REG_PHY2P1_PM_P3_BASE + 0x29)
#define REG_PHY2P1_PM_P3_15_L   (REG_PHY2P1_PM_P3_BASE + 0x2A)
#define REG_PHY2P1_PM_P3_15_H   (REG_PHY2P1_PM_P3_BASE + 0x2B)
#define REG_PHY2P1_PM_P3_16_L   (REG_PHY2P1_PM_P3_BASE + 0x2C)
#define REG_PHY2P1_PM_P3_16_H   (REG_PHY2P1_PM_P3_BASE + 0x2D)
#define REG_PHY2P1_PM_P3_17_L   (REG_PHY2P1_PM_P3_BASE + 0x2E)
#define REG_PHY2P1_PM_P3_17_H   (REG_PHY2P1_PM_P3_BASE + 0x2F)
#define REG_PHY2P1_PM_P3_18_L   (REG_PHY2P1_PM_P3_BASE + 0x30)
#define REG_PHY2P1_PM_P3_18_H   (REG_PHY2P1_PM_P3_BASE + 0x31)
#define REG_PHY2P1_PM_P3_19_L   (REG_PHY2P1_PM_P3_BASE + 0x32)
#define REG_PHY2P1_PM_P3_19_H   (REG_PHY2P1_PM_P3_BASE + 0x33)
#define REG_PHY2P1_PM_P3_1A_L   (REG_PHY2P1_PM_P3_BASE + 0x34)
#define REG_PHY2P1_PM_P3_1A_H   (REG_PHY2P1_PM_P3_BASE + 0x35)
#define REG_PHY2P1_PM_P3_1B_L   (REG_PHY2P1_PM_P3_BASE + 0x36)
#define REG_PHY2P1_PM_P3_1B_H   (REG_PHY2P1_PM_P3_BASE + 0x37)
#define REG_PHY2P1_PM_P3_1C_L   (REG_PHY2P1_PM_P3_BASE + 0x38)
#define REG_PHY2P1_PM_P3_1C_H   (REG_PHY2P1_PM_P3_BASE + 0x39)
#define REG_PHY2P1_PM_P3_1D_L   (REG_PHY2P1_PM_P3_BASE + 0x3A)
#define REG_PHY2P1_PM_P3_1D_H   (REG_PHY2P1_PM_P3_BASE + 0x3B)
#define REG_PHY2P1_PM_P3_1E_L   (REG_PHY2P1_PM_P3_BASE + 0x3C)
#define REG_PHY2P1_PM_P3_1E_H   (REG_PHY2P1_PM_P3_BASE + 0x3D)
#define REG_PHY2P1_PM_P3_1F_L   (REG_PHY2P1_PM_P3_BASE + 0x3E)
#define REG_PHY2P1_PM_P3_1F_H   (REG_PHY2P1_PM_P3_BASE + 0x3F)
#define REG_PHY2P1_PM_P3_20_L   (REG_PHY2P1_PM_P3_BASE + 0x40)
#define REG_PHY2P1_PM_P3_20_H   (REG_PHY2P1_PM_P3_BASE + 0x41)
#define REG_PHY2P1_PM_P3_21_L   (REG_PHY2P1_PM_P3_BASE + 0x42)
#define REG_PHY2P1_PM_P3_21_H   (REG_PHY2P1_PM_P3_BASE + 0x43)
#define REG_PHY2P1_PM_P3_22_L   (REG_PHY2P1_PM_P3_BASE + 0x44)
#define REG_PHY2P1_PM_P3_22_H   (REG_PHY2P1_PM_P3_BASE + 0x45)
#define REG_PHY2P1_PM_P3_23_L   (REG_PHY2P1_PM_P3_BASE + 0x46)
#define REG_PHY2P1_PM_P3_23_H   (REG_PHY2P1_PM_P3_BASE + 0x47)
#define REG_PHY2P1_PM_P3_24_L   (REG_PHY2P1_PM_P3_BASE + 0x48)
#define REG_PHY2P1_PM_P3_24_H   (REG_PHY2P1_PM_P3_BASE + 0x49)
#define REG_PHY2P1_PM_P3_25_L   (REG_PHY2P1_PM_P3_BASE + 0x4A)
#define REG_PHY2P1_PM_P3_25_H   (REG_PHY2P1_PM_P3_BASE + 0x4B)
#define REG_PHY2P1_PM_P3_26_L   (REG_PHY2P1_PM_P3_BASE + 0x4C)
#define REG_PHY2P1_PM_P3_26_H   (REG_PHY2P1_PM_P3_BASE + 0x4D)
#define REG_PHY2P1_PM_P3_27_L   (REG_PHY2P1_PM_P3_BASE + 0x4E)
#define REG_PHY2P1_PM_P3_27_H   (REG_PHY2P1_PM_P3_BASE + 0x4F)
#define REG_PHY2P1_PM_P3_28_L   (REG_PHY2P1_PM_P3_BASE + 0x50)
#define REG_PHY2P1_PM_P3_28_H   (REG_PHY2P1_PM_P3_BASE + 0x51)
#define REG_PHY2P1_PM_P3_29_L   (REG_PHY2P1_PM_P3_BASE + 0x52)
#define REG_PHY2P1_PM_P3_29_H   (REG_PHY2P1_PM_P3_BASE + 0x53)
#define REG_PHY2P1_PM_P3_2A_L   (REG_PHY2P1_PM_P3_BASE + 0x54)
#define REG_PHY2P1_PM_P3_2A_H   (REG_PHY2P1_PM_P3_BASE + 0x55)
#define REG_PHY2P1_PM_P3_2B_L   (REG_PHY2P1_PM_P3_BASE + 0x56)
#define REG_PHY2P1_PM_P3_2B_H   (REG_PHY2P1_PM_P3_BASE + 0x57)
#define REG_PHY2P1_PM_P3_2C_L   (REG_PHY2P1_PM_P3_BASE + 0x58)
#define REG_PHY2P1_PM_P3_2C_H   (REG_PHY2P1_PM_P3_BASE + 0x59)
#define REG_PHY2P1_PM_P3_2D_L   (REG_PHY2P1_PM_P3_BASE + 0x5A)
#define REG_PHY2P1_PM_P3_2D_H   (REG_PHY2P1_PM_P3_BASE + 0x5B)
#define REG_PHY2P1_PM_P3_2E_L   (REG_PHY2P1_PM_P3_BASE + 0x5C)
#define REG_PHY2P1_PM_P3_2E_H   (REG_PHY2P1_PM_P3_BASE + 0x5D)
#define REG_PHY2P1_PM_P3_2F_L   (REG_PHY2P1_PM_P3_BASE + 0x5E)
#define REG_PHY2P1_PM_P3_2F_H   (REG_PHY2P1_PM_P3_BASE + 0x5F)
#define REG_PHY2P1_PM_P3_30_L   (REG_PHY2P1_PM_P3_BASE + 0x60)
#define REG_PHY2P1_PM_P3_30_H   (REG_PHY2P1_PM_P3_BASE + 0x61)
#define REG_PHY2P1_PM_P3_31_L   (REG_PHY2P1_PM_P3_BASE + 0x62)
#define REG_PHY2P1_PM_P3_31_H   (REG_PHY2P1_PM_P3_BASE + 0x63)
#define REG_PHY2P1_PM_P3_32_L   (REG_PHY2P1_PM_P3_BASE + 0x64)
#define REG_PHY2P1_PM_P3_32_H   (REG_PHY2P1_PM_P3_BASE + 0x65)
#define REG_PHY2P1_PM_P3_33_L   (REG_PHY2P1_PM_P3_BASE + 0x66)
#define REG_PHY2P1_PM_P3_33_H   (REG_PHY2P1_PM_P3_BASE + 0x67)
#define REG_PHY2P1_PM_P3_34_L   (REG_PHY2P1_PM_P3_BASE + 0x68)
#define REG_PHY2P1_PM_P3_34_H   (REG_PHY2P1_PM_P3_BASE + 0x69)
#define REG_PHY2P1_PM_P3_35_L   (REG_PHY2P1_PM_P3_BASE + 0x6A)
#define REG_PHY2P1_PM_P3_35_H   (REG_PHY2P1_PM_P3_BASE + 0x6B)
#define REG_PHY2P1_PM_P3_36_L   (REG_PHY2P1_PM_P3_BASE + 0x6C)
#define REG_PHY2P1_PM_P3_36_H   (REG_PHY2P1_PM_P3_BASE + 0x6D)
#define REG_PHY2P1_PM_P3_37_L   (REG_PHY2P1_PM_P3_BASE + 0x6E)
#define REG_PHY2P1_PM_P3_37_H   (REG_PHY2P1_PM_P3_BASE + 0x6F)
#define REG_PHY2P1_PM_P3_38_L   (REG_PHY2P1_PM_P3_BASE + 0x70)
#define REG_PHY2P1_PM_P3_38_H   (REG_PHY2P1_PM_P3_BASE + 0x71)
#define REG_PHY2P1_PM_P3_39_L   (REG_PHY2P1_PM_P3_BASE + 0x72)
#define REG_PHY2P1_PM_P3_39_H   (REG_PHY2P1_PM_P3_BASE + 0x73)
#define REG_PHY2P1_PM_P3_3A_L   (REG_PHY2P1_PM_P3_BASE + 0x74)
#define REG_PHY2P1_PM_P3_3A_H   (REG_PHY2P1_PM_P3_BASE + 0x75)
#define REG_PHY2P1_PM_P3_3B_L   (REG_PHY2P1_PM_P3_BASE + 0x76)
#define REG_PHY2P1_PM_P3_3B_H   (REG_PHY2P1_PM_P3_BASE + 0x77)
#define REG_PHY2P1_PM_P3_3C_L   (REG_PHY2P1_PM_P3_BASE + 0x78)
#define REG_PHY2P1_PM_P3_3C_H   (REG_PHY2P1_PM_P3_BASE + 0x79)
#define REG_PHY2P1_PM_P3_3D_L   (REG_PHY2P1_PM_P3_BASE + 0x7A)
#define REG_PHY2P1_PM_P3_3D_H   (REG_PHY2P1_PM_P3_BASE + 0x7B)
#define REG_PHY2P1_PM_P3_3E_L   (REG_PHY2P1_PM_P3_BASE + 0x7C)
#define REG_PHY2P1_PM_P3_3E_H   (REG_PHY2P1_PM_P3_BASE + 0x7D)
#define REG_PHY2P1_PM_P3_3F_L   (REG_PHY2P1_PM_P3_BASE + 0x7E)
#define REG_PHY2P1_PM_P3_3F_H   (REG_PHY2P1_PM_P3_BASE + 0x7F)
#define REG_PHY2P1_PM_P3_40_L   (REG_PHY2P1_PM_P3_BASE + 0x80)
#define REG_PHY2P1_PM_P3_40_H   (REG_PHY2P1_PM_P3_BASE + 0x81)
#define REG_PHY2P1_PM_P3_41_L   (REG_PHY2P1_PM_P3_BASE + 0x82)
#define REG_PHY2P1_PM_P3_41_H   (REG_PHY2P1_PM_P3_BASE + 0x83)
#define REG_PHY2P1_PM_P3_42_L   (REG_PHY2P1_PM_P3_BASE + 0x84)
#define REG_PHY2P1_PM_P3_42_H   (REG_PHY2P1_PM_P3_BASE + 0x85)
#define REG_PHY2P1_PM_P3_43_L   (REG_PHY2P1_PM_P3_BASE + 0x86)
#define REG_PHY2P1_PM_P3_43_H   (REG_PHY2P1_PM_P3_BASE + 0x87)
#define REG_PHY2P1_PM_P3_44_L   (REG_PHY2P1_PM_P3_BASE + 0x88)
#define REG_PHY2P1_PM_P3_44_H   (REG_PHY2P1_PM_P3_BASE + 0x89)
#define REG_PHY2P1_PM_P3_45_L   (REG_PHY2P1_PM_P3_BASE + 0x8A)
#define REG_PHY2P1_PM_P3_45_H   (REG_PHY2P1_PM_P3_BASE + 0x8B)
#define REG_PHY2P1_PM_P3_46_L   (REG_PHY2P1_PM_P3_BASE + 0x8C)
#define REG_PHY2P1_PM_P3_46_H   (REG_PHY2P1_PM_P3_BASE + 0x8D)
#define REG_PHY2P1_PM_P3_47_L   (REG_PHY2P1_PM_P3_BASE + 0x8E)
#define REG_PHY2P1_PM_P3_47_H   (REG_PHY2P1_PM_P3_BASE + 0x8F)
#define REG_PHY2P1_PM_P3_48_L   (REG_PHY2P1_PM_P3_BASE + 0x90)
#define REG_PHY2P1_PM_P3_48_H   (REG_PHY2P1_PM_P3_BASE + 0x91)
#define REG_PHY2P1_PM_P3_49_L   (REG_PHY2P1_PM_P3_BASE + 0x92)
#define REG_PHY2P1_PM_P3_49_H   (REG_PHY2P1_PM_P3_BASE + 0x93)
#define REG_PHY2P1_PM_P3_4A_L   (REG_PHY2P1_PM_P3_BASE + 0x94)
#define REG_PHY2P1_PM_P3_4A_H   (REG_PHY2P1_PM_P3_BASE + 0x95)
#define REG_PHY2P1_PM_P3_4B_L   (REG_PHY2P1_PM_P3_BASE + 0x96)
#define REG_PHY2P1_PM_P3_4B_H   (REG_PHY2P1_PM_P3_BASE + 0x97)
#define REG_PHY2P1_PM_P3_4C_L   (REG_PHY2P1_PM_P3_BASE + 0x98)
#define REG_PHY2P1_PM_P3_4C_H   (REG_PHY2P1_PM_P3_BASE + 0x99)
#define REG_PHY2P1_PM_P3_4D_L   (REG_PHY2P1_PM_P3_BASE + 0x9A)
#define REG_PHY2P1_PM_P3_4D_H   (REG_PHY2P1_PM_P3_BASE + 0x9B)
#define REG_PHY2P1_PM_P3_4E_L   (REG_PHY2P1_PM_P3_BASE + 0x9C)
#define REG_PHY2P1_PM_P3_4E_H   (REG_PHY2P1_PM_P3_BASE + 0x9D)
#define REG_PHY2P1_PM_P3_4F_L   (REG_PHY2P1_PM_P3_BASE + 0x9E)
#define REG_PHY2P1_PM_P3_4F_H   (REG_PHY2P1_PM_P3_BASE + 0x9F)
#define REG_PHY2P1_PM_P3_50_L   (REG_PHY2P1_PM_P3_BASE + 0xA0)
#define REG_PHY2P1_PM_P3_50_H   (REG_PHY2P1_PM_P3_BASE + 0xA1)
#define REG_PHY2P1_PM_P3_51_L   (REG_PHY2P1_PM_P3_BASE + 0xA2)
#define REG_PHY2P1_PM_P3_51_H   (REG_PHY2P1_PM_P3_BASE + 0xA3)
#define REG_PHY2P1_PM_P3_52_L   (REG_PHY2P1_PM_P3_BASE + 0xA4)
#define REG_PHY2P1_PM_P3_52_H   (REG_PHY2P1_PM_P3_BASE + 0xA5)
#define REG_PHY2P1_PM_P3_53_L   (REG_PHY2P1_PM_P3_BASE + 0xA6)
#define REG_PHY2P1_PM_P3_53_H   (REG_PHY2P1_PM_P3_BASE + 0xA7)
#define REG_PHY2P1_PM_P3_54_L   (REG_PHY2P1_PM_P3_BASE + 0xA8)
#define REG_PHY2P1_PM_P3_54_H   (REG_PHY2P1_PM_P3_BASE + 0xA9)
#define REG_PHY2P1_PM_P3_55_L   (REG_PHY2P1_PM_P3_BASE + 0xAA)
#define REG_PHY2P1_PM_P3_55_H   (REG_PHY2P1_PM_P3_BASE + 0xAB)
#define REG_PHY2P1_PM_P3_56_L   (REG_PHY2P1_PM_P3_BASE + 0xAC)
#define REG_PHY2P1_PM_P3_56_H   (REG_PHY2P1_PM_P3_BASE + 0xAD)
#define REG_PHY2P1_PM_P3_57_L   (REG_PHY2P1_PM_P3_BASE + 0xAE)
#define REG_PHY2P1_PM_P3_57_H   (REG_PHY2P1_PM_P3_BASE + 0xAF)
#define REG_PHY2P1_PM_P3_58_L   (REG_PHY2P1_PM_P3_BASE + 0xB0)
#define REG_PHY2P1_PM_P3_58_H   (REG_PHY2P1_PM_P3_BASE + 0xB1)
#define REG_PHY2P1_PM_P3_59_L   (REG_PHY2P1_PM_P3_BASE + 0xB2)
#define REG_PHY2P1_PM_P3_59_H   (REG_PHY2P1_PM_P3_BASE + 0xB3)
#define REG_PHY2P1_PM_P3_5A_L   (REG_PHY2P1_PM_P3_BASE + 0xB4)
#define REG_PHY2P1_PM_P3_5A_H   (REG_PHY2P1_PM_P3_BASE + 0xB5)
#define REG_PHY2P1_PM_P3_5B_L   (REG_PHY2P1_PM_P3_BASE + 0xB6)
#define REG_PHY2P1_PM_P3_5B_H   (REG_PHY2P1_PM_P3_BASE + 0xB7)
#define REG_PHY2P1_PM_P3_5C_L   (REG_PHY2P1_PM_P3_BASE + 0xB8)
#define REG_PHY2P1_PM_P3_5C_H   (REG_PHY2P1_PM_P3_BASE + 0xB9)
#define REG_PHY2P1_PM_P3_5D_L   (REG_PHY2P1_PM_P3_BASE + 0xBA)
#define REG_PHY2P1_PM_P3_5D_H   (REG_PHY2P1_PM_P3_BASE + 0xBB)
#define REG_PHY2P1_PM_P3_5E_L   (REG_PHY2P1_PM_P3_BASE + 0xBC)
#define REG_PHY2P1_PM_P3_5E_H   (REG_PHY2P1_PM_P3_BASE + 0xBD)
#define REG_PHY2P1_PM_P3_5F_L   (REG_PHY2P1_PM_P3_BASE + 0xBE)
#define REG_PHY2P1_PM_P3_5F_H   (REG_PHY2P1_PM_P3_BASE + 0xBF)
#define REG_PHY2P1_PM_P3_60_L   (REG_PHY2P1_PM_P3_BASE + 0xC0)
#define REG_PHY2P1_PM_P3_60_H   (REG_PHY2P1_PM_P3_BASE + 0xC1)
#define REG_PHY2P1_PM_P3_61_L   (REG_PHY2P1_PM_P3_BASE + 0xC2)
#define REG_PHY2P1_PM_P3_61_H   (REG_PHY2P1_PM_P3_BASE + 0xC3)
#define REG_PHY2P1_PM_P3_62_L   (REG_PHY2P1_PM_P3_BASE + 0xC4)
#define REG_PHY2P1_PM_P3_62_H   (REG_PHY2P1_PM_P3_BASE + 0xC5)
#define REG_PHY2P1_PM_P3_63_L   (REG_PHY2P1_PM_P3_BASE + 0xC6)
#define REG_PHY2P1_PM_P3_63_H   (REG_PHY2P1_PM_P3_BASE + 0xC7)
#define REG_PHY2P1_PM_P3_64_L   (REG_PHY2P1_PM_P3_BASE + 0xC8)
#define REG_PHY2P1_PM_P3_64_H   (REG_PHY2P1_PM_P3_BASE + 0xC9)
#define REG_PHY2P1_PM_P3_65_L   (REG_PHY2P1_PM_P3_BASE + 0xCA)
#define REG_PHY2P1_PM_P3_65_H   (REG_PHY2P1_PM_P3_BASE + 0xCB)
#define REG_PHY2P1_PM_P3_66_L   (REG_PHY2P1_PM_P3_BASE + 0xCC)
#define REG_PHY2P1_PM_P3_66_H   (REG_PHY2P1_PM_P3_BASE + 0xCD)
#define REG_PHY2P1_PM_P3_67_L   (REG_PHY2P1_PM_P3_BASE + 0xCE)
#define REG_PHY2P1_PM_P3_67_H   (REG_PHY2P1_PM_P3_BASE + 0xCF)
#define REG_PHY2P1_PM_P3_68_L   (REG_PHY2P1_PM_P3_BASE + 0xD0)
#define REG_PHY2P1_PM_P3_68_H   (REG_PHY2P1_PM_P3_BASE + 0xD1)
#define REG_PHY2P1_PM_P3_69_L   (REG_PHY2P1_PM_P3_BASE + 0xD2)
#define REG_PHY2P1_PM_P3_69_H   (REG_PHY2P1_PM_P3_BASE + 0xD3)
#define REG_PHY2P1_PM_P3_6A_L   (REG_PHY2P1_PM_P3_BASE + 0xD4)
#define REG_PHY2P1_PM_P3_6A_H   (REG_PHY2P1_PM_P3_BASE + 0xD5)
#define REG_PHY2P1_PM_P3_6B_L   (REG_PHY2P1_PM_P3_BASE + 0xD6)
#define REG_PHY2P1_PM_P3_6B_H   (REG_PHY2P1_PM_P3_BASE + 0xD7)
#define REG_PHY2P1_PM_P3_6C_L   (REG_PHY2P1_PM_P3_BASE + 0xD8)
#define REG_PHY2P1_PM_P3_6C_H   (REG_PHY2P1_PM_P3_BASE + 0xD9)
#define REG_PHY2P1_PM_P3_6D_L   (REG_PHY2P1_PM_P3_BASE + 0xDA)
#define REG_PHY2P1_PM_P3_6D_H   (REG_PHY2P1_PM_P3_BASE + 0xDB)
#define REG_PHY2P1_PM_P3_6E_L   (REG_PHY2P1_PM_P3_BASE + 0xDC)
#define REG_PHY2P1_PM_P3_6E_H   (REG_PHY2P1_PM_P3_BASE + 0xDD)
#define REG_PHY2P1_PM_P3_6F_L   (REG_PHY2P1_PM_P3_BASE + 0xDE)
#define REG_PHY2P1_PM_P3_6F_H   (REG_PHY2P1_PM_P3_BASE + 0xDF)
#define REG_PHY2P1_PM_P3_70_L   (REG_PHY2P1_PM_P3_BASE + 0xE0)
#define REG_PHY2P1_PM_P3_70_H   (REG_PHY2P1_PM_P3_BASE + 0xE1)
#define REG_PHY2P1_PM_P3_71_L   (REG_PHY2P1_PM_P3_BASE + 0xE2)
#define REG_PHY2P1_PM_P3_71_H   (REG_PHY2P1_PM_P3_BASE + 0xE3)
#define REG_PHY2P1_PM_P3_72_L   (REG_PHY2P1_PM_P3_BASE + 0xE4)
#define REG_PHY2P1_PM_P3_72_H   (REG_PHY2P1_PM_P3_BASE + 0xE5)
#define REG_PHY2P1_PM_P3_73_L   (REG_PHY2P1_PM_P3_BASE + 0xE6)
#define REG_PHY2P1_PM_P3_73_H   (REG_PHY2P1_PM_P3_BASE + 0xE7)
#define REG_PHY2P1_PM_P3_74_L   (REG_PHY2P1_PM_P3_BASE + 0xE8)
#define REG_PHY2P1_PM_P3_74_H   (REG_PHY2P1_PM_P3_BASE + 0xE9)
#define REG_PHY2P1_PM_P3_75_L   (REG_PHY2P1_PM_P3_BASE + 0xEA)
#define REG_PHY2P1_PM_P3_75_H   (REG_PHY2P1_PM_P3_BASE + 0xEB)
#define REG_PHY2P1_PM_P3_76_L   (REG_PHY2P1_PM_P3_BASE + 0xEC)
#define REG_PHY2P1_PM_P3_76_H   (REG_PHY2P1_PM_P3_BASE + 0xED)
#define REG_PHY2P1_PM_P3_77_L   (REG_PHY2P1_PM_P3_BASE + 0xEE)
#define REG_PHY2P1_PM_P3_77_H   (REG_PHY2P1_PM_P3_BASE + 0xEF)
#define REG_PHY2P1_PM_P3_78_L   (REG_PHY2P1_PM_P3_BASE + 0xF0)
#define REG_PHY2P1_PM_P3_78_H   (REG_PHY2P1_PM_P3_BASE + 0xF1)
#define REG_PHY2P1_PM_P3_79_L   (REG_PHY2P1_PM_P3_BASE + 0xF2)
#define REG_PHY2P1_PM_P3_79_H   (REG_PHY2P1_PM_P3_BASE + 0xF3)
#define REG_PHY2P1_PM_P3_7A_L   (REG_PHY2P1_PM_P3_BASE + 0xF4)
#define REG_PHY2P1_PM_P3_7A_H   (REG_PHY2P1_PM_P3_BASE + 0xF5)
#define REG_PHY2P1_PM_P3_7B_L   (REG_PHY2P1_PM_P3_BASE + 0xF6)
#define REG_PHY2P1_PM_P3_7B_H   (REG_PHY2P1_PM_P3_BASE + 0xF7)
#define REG_PHY2P1_PM_P3_7C_L   (REG_PHY2P1_PM_P3_BASE + 0xF8)
#define REG_PHY2P1_PM_P3_7C_H   (REG_PHY2P1_PM_P3_BASE + 0xF9)
#define REG_PHY2P1_PM_P3_7D_L   (REG_PHY2P1_PM_P3_BASE + 0xFA)
#define REG_PHY2P1_PM_P3_7D_H   (REG_PHY2P1_PM_P3_BASE + 0xFB)
#define REG_PHY2P1_PM_P3_7E_L   (REG_PHY2P1_PM_P3_BASE + 0xFC)
#define REG_PHY2P1_PM_P3_7E_H   (REG_PHY2P1_PM_P3_BASE + 0xFD)
#define REG_PHY2P1_PM_P3_7F_L   (REG_PHY2P1_PM_P3_BASE + 0xFE)
#define REG_PHY2P1_PM_P3_7F_H   (REG_PHY2P1_PM_P3_BASE + 0xFF)

#endif

