//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////
//==============================================================================
// [mhal_sc.c]
// Date: 20081203
// Descriptions: Add a new layer for HW setting
//==============================================================================
#define  MHAL_SC_C

#define DO_DIV(x,y) ((x)/=(y))

// Common Definition
#include "MsCommon.h"
#ifndef CONFIG_UTOPIAXP_REMOVE_IMPL
#include "MsIRQ.h"
#include "MsOS.h"
#include "mhal_xc_chip_config.h"
#include "utopia.h"
#include "xc_hwreg_utility2.h"
#include "xc_Analog_Reg.h"
#include "drvXC_IOPort.h"
#include "apiXC.h"
#include "apiXC_DWIN.h"
#include "apiXC_PCMonitor.h"
#include "drv_sc_ip.h"
#include "mvideo_context.h"
#include "mhal_sc.h"
#include "mhal_menuload.h"
#include "halCHIP.h"
#include "drv_sc_menuload.h"
#include "drv_sc_isr.h"
#include "drv_sc_DIP_scaling.h"
#include "mhal_dip.h"
#include "hwreg_dip.h"
#include "mhal_mux.h"
#include "hwreg_ipmux.h"
#include "drvMIU.h"
#include "mdrv_sc_dynamicscaling.h"
#ifdef UTOPIA_V2
#include "XC_DWIN_private.h"
#include "utopia_dapi.h"
#endif

#ifdef MSOS_TYPE_LINUX_KERNEL
#include <linux/string.h>
#else
#include <string.h>
#endif

#define SC_DBG(x)   //x
#define FPLL_DBG(x) //x
#define MFDEC_DEBUG 0
#define UHD_WIDTH 3840UL
#define FHD_WIDTH 1920UL
#ifdef UTOPIA_V2
#define g_DIPSrcInfo            pDipResPri->g_DIPSrcInfo
#endif
#ifdef MSOS_TYPE_LINUX_KERNEL
#define H_DIP_PostScalingRatio(Input, Output)       { u64_result = ((MS_U64)(Input))    * 1048576ul;DO_DIV(u64_result,(Output));}
#define V_DIP_PostScalingRatio(Input, Output)       { u64_result = ((MS_U64)(Input))    * 1048576ul;DO_DIV(u64_result,(Output));}
#else
#define H_DIP_PostScalingRatio(Input, Output)        ((MS_U32)( ((MS_U64)(Input)) * 1048576ul / (Output)))
#define V_DIP_PostScalingRatio(Input, Output)        ((MS_U32)( ((MS_U64)(Input)) * 1048576ul / (Output)))
#endif

//TrustZone
#define REG_TZPC_NONPM_BASE      0x123900UL
#define REG_TZPC_NONPM_DIP       (REG_TZPC_NONPM_BASE + (0x74<<1) )
#define REG_TZPC_NONPM_DWIN0     (REG_TZPC_NONPM_BASE + (0x79<<1) )

//HW bug SW patch
#define DIP_PATCH_CLIP_FAILED_1073531  (1) // clip window hw bug

#define LOG_EXECUTE_TIME  (FALSE)

#define DIP_HVSP_LoadSRAM (FALSE)

#define DIP_PQ_SETTINGS (FALSE)

#define new_chakra
static MS_U8  DipWBufCnt=0,Dwin0WBufCnt=0,Dwin1WBufCnt=0;
static SCALER_DIP_SOURCE_TYPE DipSource = SCALER_DIP_SOURCE_TYPE_OP_SUB;
static SCALER_DIP_SOURCE_TYPE Dwin0Source = SCALER_DIP_SOURCE_TYPE_OP_SUB;
static SCALER_DIP_SOURCE_TYPE Dwin1Source = SCALER_DIP_SOURCE_TYPE_OP_SUB;
static InterruptCb pDipIntCb;
static InterruptCb pDwin0IntCb;
static InterruptCb pDwin1IntCb;
static MS_BOOL bDipIsr = FALSE,bDwin0Isr = FALSE,bDwin1Isr = FALSE,bDIPRotation = FALSE,bAttached = FALSE;
static MS_BOOL bDipHMirror = FALSE,bDWIN0HMirror = FALSE,bDWIN1HMirror = FALSE;
static MS_BOOL bDipUVSwap = FALSE,bDWIN0UVSwap = FALSE,bDWIN1UVSwap = FALSE;
static MS_BOOL bDipYCSwap = FALSE,bDWIN0YCSwap = FALSE,bDWIN1YCSwap = FALSE;
static MS_BOOL bDipR2Y = FALSE,bDwin0R2Y = FALSE,bDwin1R2Y = FALSE;
static EN_DRV_XC_DWIN_DATA_FMT DipFmt,Dwin0Fmt,Dwin1Fmt;
static SCALER_DIP_WIN DIPRotation = MAX_DIP_WINDOW;

static MS_BOOL _gbDwin0BufferInit = FALSE;
static MS_BOOL _gbDWIN0DIEna = FALSE;
static MS_BOOL _gbDWIN0DNREna = FALSE;
static MS_U16 _gu16DWIN0DIDNRHSize = 0;
static MS_U16 _gu16DWIN0DIDNRVSize = 0;
static MS_BOOL _gbDWIN0FieldStagger = FALSE;
#if (DIP_PQ_SETTINGS == TRUE)
#define E_XRULE_HSP         (2)
#define E_XRULE_VSP         (3)
static INPUT_SOURCE_TYPE_t enDWIN0InputType = INPUT_SOURCE_NONE;
extern __attribute__((weak)) void MDrv_PQ_DesideSrcType(PQ_WIN eWindow, PQ_INPUT_SOURCE_TYPE enInputSourceType);
extern __attribute__((weak)) PQ_DEINTERLACE_MODE MDrv_PQ_SetMemFormat(PQ_WIN eWindow, MS_BOOL bMemFmt422, MS_BOOL bFBL, MS_U8 *pu8BitsPerPixel);
extern __attribute__((weak)) MS_BOOL MDrv_PQ_LoadScalingTable(PQ_WIN eWindow,
                                                                MS_U8 eXRuleType,
                                                                MS_BOOL bPreV_ScalingDown,
                                                                MS_BOOL bInterlace,
                                                                MS_BOOL bColorSpaceYUV,
                                                                MS_U16 u16InputSize,
                                                                MS_U16 u16SizeAfterScaling);
#endif
static MS_BOOL _gbIsSetSourceInfo[MAX_DIP_WINDOW];
static ST_DIP_SET_SOURCE_INFO _gstDIPSourceInfo[MAX_DIP_WINDOW];
static ST_DRV_DIP_XCPathInfo _gstDwin0XCInfo;
/*#if (DIP_PATCH_CLIP_FAILED_1073531 == 1)
static MS_U16 _gu16DIPPatchMaxCaptureInputSize = 0x0;
#endif */

//==============================================================================
//==============================================================================
#include "drvCMDQ.h"
#define CMDQ_WRITE_RIU_COMMAND  (0x57)
#define  MAX_CMDQ_NUM  1024
#define  BANK_REG_MAX  0x80

static MS_U32 g_u16Ptr_CMQ[MAX_DIP_WINDOW] = {0};
#if DIP_CMDQ_ENABLE
static CAF_Struct  DIP_CMDQ_BUFF [MAX_CMDQ_NUM];
static CAF_Struct  DWIN0_CMDQ_BUFF [MAX_CMDQ_NUM];
static CAF_Struct  DWIN1_CMDQ_BUFF [MAX_CMDQ_NUM];
#endif
static MS_U16 u16RegBK34Table[BANK_REG_MAX]= {0};
static MS_U16 u16RegBK36Table[BANK_REG_MAX]= {0};
static MS_U16 cmdq_ready_value,cmdq_wait_value;


MS_BOOL g_bCMDQ_Enable[MAX_DIP_WINDOW] = {FALSE};
MS_BOOL g_bCMDQ_Init = FALSE;
MS_U32  g_u32Wait_Reg[MAX_DIP_WINDOW] = {0x120332,0x120334,0x120338};

static MS_S32 g_s32DIPCMDQ_Init_Mutex[MAX_DIP_WINDOW] = {0};

#define DIPCMDQ_INIT_MUTEX_LOCK(eWindow)           MsOS_ObtainMutex(g_s32DIPCMDQ_Init_Mutex[eWindow],MSOS_WAIT_FOREVER)
#define DIPCMDQ_INIT_MUTEX_UNLOCK(eWindow)         MsOS_ReleaseMutex(g_s32DIPCMDQ_Init_Mutex[eWindow])
#define DIPCMDQ_INIT_MUTEX_DELETE(eWindow)         MsOS_DeleteMutex(g_s32DIPCMDQ_Init_Mutex[eWindow])

#define XIU_BITMASK     0x10012E    //Bank 0x1001_17[0] = 1  -' enable bit operation

//static MS_BOOL _gbIsDip2pPathEna[MAX_DIP_WINDOW] = {[0 ... (MAX_DIP_WINDOW - 1)] = FALSE};

static ST_DRV_DIP_GET_XC_STATUS _gstGetXCStatus;

static ST_DRV_DIP_HDMI_INFO _gstHDMIInfo[MAX_DIP_WINDOW];

#if (LOG_EXECUTE_TIME == TRUE)
static MS_U32 u32StartTime = 0;
static MS_U32 u32EndTime = 0;
#endif

#define DIP_WAIT()\
({\
    if (g_bCMDQ_Enable[eWindow] == TRUE)\
        HAL_XC_DIP_CMDQWaitCommand(eWindow);\
})

#define DIP_W2BYTE(u32Id,u32Reg,u16Val)\
({\
    if((u32Reg&0xff00) == 0x3400)\
    {\
        u16RegBK34Table[((u32Reg&0xff)>>1)] = u16Val;\
    }\
    else if((u32Reg&0xff00) == 0x3600)\
    {\
        u16RegBK36Table[((u32Reg&0xff)>>1)] = u16Val;\
    }\
    if (g_bCMDQ_Enable[eWindow] == TRUE)\
        CMDQ_DIP_W2BYTE(u32Id, u32Reg, u16Val, eWindow);\
    else\
        SC_W2BYTE(u32Id, u32Reg, u16Val);\
})

#define MDrv_DIP_Read2Byte(u32Reg)\
({\
    MDrv_Read2Byte(u32Reg);\
})

#define DIP_W4BYTE(u32Id,u32Reg,u32Val)\
({\
    if((u32Reg&0xff00) == 0x3400)\
    {\
        u16RegBK34Table[((u32Reg&0xff)>>1)] = u32Val&0x0000FFFF;\
        u16RegBK34Table[(((u32Reg+2)&0xff)>>1)] = (u32Val&0xFFFF0000)>>16;\
    }\
    else if((u32Reg&0xff00) == 0x3600)\
    {\
        u16RegBK36Table[((u32Reg&0xff)>>1)] = u32Val&0x0000FFFF;\
        u16RegBK36Table[(((u32Reg+2)&0xff)>>1)] = (u32Val&0xFFFF0000)>>16;\
    }\
    if (g_bCMDQ_Enable[eWindow] == TRUE)\
        CMDQ_DIP_W4BYTE(u32Id, u32Reg, u32Val, eWindow);\
    else\
        SC_W4BYTE(u32Id, u32Reg, u32Val);\
})

#define DIP_W2BYTEMSK(u32Id,u32Reg,u16Val,u16Mask)\
({\
    if((u32Reg&0xff00) == 0x3400)\
    {\
        u16RegBK34Table[((u32Reg&0xff)>>1)] &= u16Mask;\
        u16RegBK34Table[((u32Reg&0xff)>>1)] |= u16Val;\
    }\
    else if((u32Reg&0xff00) == 0x3600)\
    {\
        u16RegBK36Table[((u32Reg&0xff)>>1)] &= u16Mask;\
        u16RegBK36Table[((u32Reg&0xff)>>1)] |= u16Val;\
    }\
    if (g_bCMDQ_Enable[eWindow] == TRUE)\
        CMDQ_DIP_W2BYTEMSK(u32Id, u32Reg, u16Val, u16Mask, eWindow);\
    else\
        SC_W2BYTEMSK(u32Id, u32Reg, u16Val, u16Mask);\
})

#define MDrv_DIP_WriteByteMask(u32Reg,u8Val,u8Msk)\
({\
    if (g_bCMDQ_Enable[eWindow] == TRUE)\
        MDrv_CMDQ_WriteByteMask(u32Reg, u8Val, u8Msk, eWindow);\
    else\
        MDrv_WriteByteMask(u32Reg, u8Val, u8Msk);\
})

#define MDrv_DIP_Write2ByteMask(u32Reg,u16Val,u16Mask)\
({\
    if (g_bCMDQ_Enable[eWindow] == TRUE)\
        MDrv_CMDQ_Write2ByteMask(u32Reg, u16Val, u16Mask, eWindow);\
    else\
        MDrv_Write2ByteMask(u32Reg, u16Val, u16Mask);\
})

#define MDrv_DIP_Write4Byte(u32Reg,u16Val)\
    ({\
        MDrv_Write4Byte(u32Reg, u16Val);\
})


#define MDrv_DIP_WriteRegBit(u32Reg,bEnable,u8Mask)\
({\
    if (g_bCMDQ_Enable[eWindow] == TRUE)\
        MDrv_CMDQ_WriteRegBit(u32Reg, bEnable, u8Mask, eWindow);\
    else\
        MDrv_WriteRegBit(u32Reg, bEnable, u8Mask);\
})

#define DIP_BUF_STARTADDR_ALIGNCHECK(phyBufStart,u16BusSize)\
({\
    if((phyBufStart & (u16BusSize-1)) != 0)\
    {\
        XC_DBUG("\33[0;36m [%s][%d]: Start Address 0x%tx isn't aligned to %d bytes \33[m \n", __FUNCTION__, __LINE__, (ptrdiff_t)phyBufStart, u16BusSize);\
        phyBufStart += (u16BusSize-1);\
    }\
})

#define DIP_BUF_ENDADDR_ALIGNCHECK(phyBufEnd,u16BusSize)\
({\
    if((phyBufEnd & (u16BusSize-1)) != 0)\
    {\
        XC_DBUG("\33[0;36m [%s][%d]: End Address 0x%tx isn't aligned to %d bytes \33[m \n", __FUNCTION__, __LINE__, (ptrdiff_t)phyBufEnd, u16BusSize);\
    }\
})

static MS_U16 DIP_R2BYTE(MS_U32 u32Id,MS_U32 u32Reg,SCALER_DIP_WIN eWindow)
{
    MS_U16 u16val=0;
    MS_U32 u32idx=(u32Reg&0xff)>>1;

    if(g_bCMDQ_Enable[eWindow] == TRUE)
    {
        if((u32Reg&0xff00)==0x3400)
        {
            u16val=u16RegBK34Table[u32idx];
        }
        else if((u32Reg&0xff00)==0x3600)
        {
            u16val=u16RegBK36Table[u32idx];
        }
    }
    else
    {
        u16val=SC_R2BYTE(u32Id, u32Reg);
    }
    return u16val;
}

static MS_U32 DIP_R4BYTE(MS_U32 u32Id, MS_U32 u32Reg,SCALER_DIP_WIN eWindow)
{
    MS_U32 u32val=0;
    MS_U32 u32idx=(u32Reg&0xff)>>1;

    if(g_bCMDQ_Enable[eWindow] == TRUE)
    {
        if((u32Reg&0xff00)==0x3400)
        {
            u32val=(u16RegBK34Table[u32idx])|(u16RegBK34Table[u32idx+1]<<16);
        }
        else if((u32Reg&0xff00)==0x3600)
        {
            u32val=(u16RegBK36Table[u32idx])|(u16RegBK36Table[u32idx+1]<<16);
        }
    }
    else
    {
        u32val=SC_R4BYTE(u32Id, u32Reg);
    }
    return u32val;
}

static MS_U16 DIP_R2BYTEMSK(MS_U32 u32Id, MS_U32 u32Reg, MS_U16 u16Mask,SCALER_DIP_WIN eWindow)
{
    MS_U16 u16val=0;
    MS_U32 u32idx=(u32Reg&0xff)>>1;
    if(g_bCMDQ_Enable[eWindow] == TRUE)
    {
        if((u32Reg&0xff00)==0x3400)
        {
            u16val=u16RegBK34Table[u32idx]&u16Mask;
        }
        else if((u32Reg&0xff00)==0x3600)
        {
            u16val=u16RegBK36Table[u32idx]&u16Mask;
        }
    }
    else
    {
        u16val=SC_R2BYTEMSK(u32Id, u32Reg, u16Mask);
    }
    return u16val;
}

static MS_BOOL HAL_XC_DIP_CMDQWaitCommand(SCALER_DIP_WIN eWindow)
{
#if DIP_CMDQ_ENABLE
#if !(defined(MSOS_TYPE_LINUX_KERNEL))
    if (g_u16Ptr_CMQ[eWindow] >= MAX_CMDQ_NUM)
    {
        DIP_H_ERR("[%s]: eWindow %d CMDQ Buffer is Full,g_u16Ptr_CMQ[%d]\n", __FUNCTION__,eWindow, (int)g_u16Ptr_CMQ[eWindow]);
        return FALSE;
    }

    if(eWindow == DIP_WINDOW)
    {
        MDrv_CMDQ_Gen_WaitTrigger_Bus_Command(&(DIP_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]]),SCALAR_SC2CMDQ_TRIG_2,FALSE);
    }
    else if(eWindow == DWIN0_WINDOW)
    {
        MDrv_CMDQ_Gen_WaitTrigger_Bus_Command(&(DWIN0_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]]),SCALAR_SC2CMDQ_TRIG_2,FALSE);
    }
    else if(eWindow == DWIN1_WINDOW)
    {
        MDrv_CMDQ_Gen_WaitTrigger_Bus_Command(&(DWIN1_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]]),SCALAR_SC2CMDQ_TRIG_2,FALSE);
    }
    g_u16Ptr_CMQ[eWindow]++;
#endif
#endif
    return TRUE;
}

static MS_BOOL HAL_XC_DIP_CMDQPushCommand(MS_U8 operation, MS_U32  destionation_address, MS_U16  destionation_value, MS_U16  mask,SCALER_DIP_WIN eWindow)
{
    MS_U16 idx=(destionation_address&0xff)>>1;

    if (g_u16Ptr_CMQ[eWindow] >= MAX_CMDQ_NUM)
    {
        DIP_H_ERR("[%s]: eWindow %d CMDQ Buffer is Full\n", __FUNCTION__,eWindow);
        return FALSE;
    }

    if((destionation_address&0xff00)==0x3400)
    {
        u16RegBK34Table[idx] &= mask;
        u16RegBK34Table[idx] |= destionation_value;
    }
    else if((destionation_address&0xff00)==0x3600)
    {
        u16RegBK36Table[idx] &= mask;
        u16RegBK36Table[idx] |= destionation_value;
    }
#if DIP_CMDQ_ENABLE
    if(eWindow == DIP_WINDOW)
    {
        DIP_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].operation =  operation;
        DIP_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].destionation_address =  destionation_address;
        DIP_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].destionation_value =  destionation_value;
        DIP_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].mask =  ((~mask)&0xFFFF);
    }
    else if(eWindow == DWIN0_WINDOW)
    {
        DWIN0_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].operation =  operation;
        DWIN0_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].destionation_address =  destionation_address;
        DWIN0_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].destionation_value =  destionation_value;
        DWIN0_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].mask =  ((~mask)&0xFFFF);
    }
    else if(eWindow == DWIN1_WINDOW)
    {
        DWIN1_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].operation =  operation;
        DWIN1_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].destionation_address =  destionation_address;
        DWIN1_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].destionation_value =  destionation_value;
        DWIN1_CMDQ_BUFF[g_u16Ptr_CMQ[eWindow]].mask =  ((~mask)&0xFFFF);
    }
    g_u16Ptr_CMQ[eWindow]++;
#endif
    return TRUE;
}

static void MDrv_CMDQ_WriteByteMask(MS_U32 u32Reg, MS_U8 u8Val, MS_U8 u8Mask, SCALER_DIP_WIN eWindow)
{
    MS_BOOL ret = FALSE;

    ret = HAL_XC_DIP_CMDQPushCommand(CMDQ_WRITE_RIU_COMMAND, u32Reg, u8Val, u8Mask, eWindow);
    if (ret == FALSE)
    {
        DIP_H_ERR("[%s] is error\n", __FUNCTION__);
    }
}

static void MDrv_CMDQ_WriteRegBit(MS_U32 u32Reg, MS_BOOL bEnable, MS_U8 u8Mask, SCALER_DIP_WIN eWindow)
{
    MS_BOOL ret = FALSE;

    ret = HAL_XC_DIP_CMDQPushCommand(CMDQ_WRITE_RIU_COMMAND, u32Reg, (MS_U16) (bEnable? u8Mask:0), u8Mask, eWindow);
    if (ret == FALSE)
    {
        DIP_H_ERR("[%s] is error\n", __FUNCTION__);
    }
}

static void MDrv_CMDQ_Write2ByteMask(MS_U32 u32Reg, MS_U16 u16Val, MS_U16 u16Mask, SCALER_DIP_WIN eWindow)
{
    MS_BOOL ret = FALSE;

    if ( ((u32Reg) & 0x01) )
        u32Reg = u32Reg -1;

    ret = HAL_XC_DIP_CMDQPushCommand(CMDQ_WRITE_RIU_COMMAND, u32Reg, u16Val, u16Mask, eWindow);
    if (ret == FALSE)
    {
        DIP_H_ERR("[%s] is error\n", __FUNCTION__);
    }
}


static void MDrv_CMDQ_Write2Byte(MS_U32 u32Reg, MS_U16 u16Val, SCALER_DIP_WIN eWindow)
{
    MS_BOOL ret = FALSE;

    if ( ((u32Reg) & 0x01) )
        u32Reg = u32Reg -1;

    ret = HAL_XC_DIP_CMDQPushCommand(CMDQ_WRITE_RIU_COMMAND, u32Reg, u16Val, 0xFFFF, eWindow);
    if (ret == FALSE)
    {
        DIP_H_ERR("[%s] is error\n", __FUNCTION__);
    }
}

static void  CMDQ_DIP_W2BYTE(MS_U32 u32Id, MS_U32 u32Reg, MS_U16 u16Val, SCALER_DIP_WIN eWindow)
{
#if ENABLE_REGISTER_SPREAD
    MDrv_CMDQ_Write2Byte((REG_SCALER_BASE + ((u32Reg) & 0xFFFF) + (_XC_Device_Offset[u32Id] << 8) ), u16Val, eWindow);
#else
    MDrv_CMDQ_Write2Byte(REG_SCALER_BASE, ((u32Reg) >> 8) & 0x00FF + _XC_Device_Offset[u32Id], eWindow);
    MDrv_CMDQ_Write2Byte((REG_SCALER_BASE +((u32Reg) & 0xFF) , u16Val, eWindow);
#endif
}

static void  CMDQ_DIP_W4BYTE(MS_U32 u32Id, MS_U32 u32Reg, MS_U32 u32Val, SCALER_DIP_WIN eWindow)
{
#if ENABLE_REGISTER_SPREAD
    MDrv_CMDQ_Write2Byte((REG_SCALER_BASE + ((u32Reg) & 0xFFFF) + (_XC_Device_Offset[u32Id] << 8) ), (MS_U16)((u32Val) & 0x0000FFFF), eWindow);
    MDrv_CMDQ_Write2Byte((REG_SCALER_BASE + ((u32Reg) & 0xFFFF) + (_XC_Device_Offset[u32Id] << 8) + 2 ), (MS_U16)(((u32Val) >> 16) & 0x0000FFFF), eWindow);
#else
    MDrv_CMDQ_Write2Byte(REG_SCALER_BASE, ((u32Reg) >> 8) & 0x00FF + _XC_Device_Offset[u32Id], eWindow);
    MDrv_CMDQ_Write2Byte((REG_SCALER_BASE + ((u32Reg) & 0xFF) ), (MS_U16)((u32Val) & 0x0000FFFF), eWindow);
    MDrv_CMDQ_Write2Byte((REG_SCALER_BASE + ((u32Reg) & 0xFF) + 2 ), (MS_U16)(((u32Val) >> 16) & 0x0000FFFF), eWindow);
#endif
}


static void  CMDQ_DIP_W2BYTEMSK(MS_U32 u32Id, MS_U32 u32Reg, MS_U16 u16Val, MS_U16 u16Mask, SCALER_DIP_WIN eWindow)
{
#if ENABLE_REGISTER_SPREAD
    MDrv_CMDQ_Write2ByteMask((REG_SCALER_BASE + ((u32Reg) & 0xFFFF) + (_XC_Device_Offset[u32Id] << 8) ), u16Val, u16Mask, eWindow);
#else
    MDrv_CMDQ_Write2Byte(REG_SCALER_BASE, ((u32Reg) >> 8) & 0x00FF + _XC_Device_Offset[u32Id], eWindow);
    MDrv_CMDQ_Write2ByteMask((REG_SCALER_BASE +((u32Reg) & 0xFF) , u16Val, u16Mask, eWindow);
#endif
}

MS_BOOL HAL_XC_DIP_CMDQInit(void *pInstance,SCALER_DIP_WIN eWindow)
{
    if(g_s32DIPCMDQ_Init_Mutex[eWindow] != 0)
    {
        if(eWindow == DIP_WINDOW)
            g_s32DIPCMDQ_Init_Mutex[eWindow] = MsOS_CreateMutex(E_MSOS_FIFO, "DIP_CMDQ_INIT" , MSOS_PROCESS_SHARED);
        else if(eWindow == DWIN0_WINDOW)
            g_s32DIPCMDQ_Init_Mutex[eWindow] = MsOS_CreateMutex(E_MSOS_FIFO, "DWIN0_CMDQ_INIT" , MSOS_PROCESS_SHARED);
        else if(eWindow == DWIN1_WINDOW)
            g_s32DIPCMDQ_Init_Mutex[eWindow] = MsOS_CreateMutex(E_MSOS_FIFO, "DWIN1_CMDQ_INIT" , MSOS_PROCESS_SHARED);
    }

    if (g_s32DIPCMDQ_Init_Mutex[eWindow] < 0)
    {
        DIP_H_ERR("Error: [%s] line:%d, eWindow:%d MsOS_CreateMutex Fail[%d]\n",
                __FUNCTION__, __LINE__, eWindow, (int)g_s32DIPCMDQ_Init_Mutex[eWindow]);

        g_s32DIPCMDQ_Init_Mutex[eWindow] = 0;
        return FALSE;
    }


    if (g_bCMDQ_Init == TRUE)
        return TRUE;
    //MDrv_DIP_WriteRegBit(XIU_BITMASK,BIT(0),BIT(0));

    g_bCMDQ_Init = TRUE;

    return TRUE;
}

#if DIP_CMDQ_ENABLE
static MS_BOOL  HAL_XC_DIP_CMDQTriggerCommand(SCALER_DIP_WIN eWindow)
{
    CH_Struct_Pointer dip_cmdq_st;
    DRVCMDQ_RESULT sResult;
    MS_U16 u16Index;

    cmdq_ready_value = MDrv_DIP_Read2Byte(g_u32Wait_Reg[eWindow]);
    if(cmdq_ready_value == 0xFFF)
        cmdq_ready_value = 0;
    cmdq_ready_value++;
    MDrv_DIP_Write2ByteMask(g_u32Wait_Reg[eWindow],cmdq_ready_value,0xFFF);
#if 0  //for Debug
    MS_U16 i=0;
    for(i=0;i<g_u16Ptr_CMQ[eWindow];i++)
    {
        DIP_H_ERR("\33[0;36m [%d]op = %d, addr = %lx,value = %x,mask = %x\33[m \n",i,DIP_CMDQ_BUFF[i].operation,DIP_CMDQ_BUFF[i].destionation_address,DIP_CMDQ_BUFF[i].destionation_value,DIP_CMDQ_BUFF[i].mask);
    }
#endif

    dip_cmdq_st = (CH_Struct_Pointer) malloc(sizeof(CH_Struct));
    dip_cmdq_st->Command_Number = g_u16Ptr_CMQ[eWindow];
    if(eWindow == DIP_WINDOW)
        dip_cmdq_st->Pointer_To_CAFArray = (CAF_Struct_Pointer)DIP_CMDQ_BUFF;
    else if(eWindow == DWIN0_WINDOW)
        dip_cmdq_st->Pointer_To_CAFArray = (CAF_Struct_Pointer)DWIN0_CMDQ_BUFF;
    else if(eWindow == DWIN1_WINDOW)
        dip_cmdq_st->Pointer_To_CAFArray = (CAF_Struct_Pointer)DWIN1_CMDQ_BUFF;

    sResult = MDrv_CMDQ_Receive(dip_cmdq_st);

    if (sResult != DRVCMDQ_OK)
    {
        DIP_H_ERR("[%s] ERROR, Return Error Code:%ld\n", __FUNCTION__, sResult);
        for (u16Index = 0; u16Index<g_u16Ptr_CMQ[eWindow]; u16Index++)
        {
            if(eWindow == DIP_WINDOW)
                DIP_H_ERR("opt:0x%x, dest:0x%x, value:0x%x, mask:0x%x\n",
                DIP_CMDQ_BUFF[u16Index].operation,
                (int)DIP_CMDQ_BUFF[u16Index].destionation_address,
                DIP_CMDQ_BUFF[u16Index].destionation_value,
                ~(DIP_CMDQ_BUFF[u16Index].mask));
            else if(eWindow == DWIN0_WINDOW)
                DIP_H_ERR("opt:0x%x, dest:0x%x, value:0x%x, mask:0x%x\n",
                DWIN0_CMDQ_BUFF[u16Index].operation,
                (int)DWIN0_CMDQ_BUFF[u16Index].destionation_address,
                DWIN0_CMDQ_BUFF[u16Index].destionation_value,
                ~(DWIN0_CMDQ_BUFF[u16Index].mask));
            else if(eWindow == DWIN1_WINDOW)
                DIP_H_ERR("opt:0x%x, dest:0x%x, value:0x%x, mask:0x%x\n",
                DWIN1_CMDQ_BUFF[u16Index].operation,
                (int)DWIN1_CMDQ_BUFF[u16Index].destionation_address,
                DWIN1_CMDQ_BUFF[u16Index].destionation_value,
                ~(DWIN1_CMDQ_BUFF[u16Index].mask));
        }
        return FALSE;
    }

    g_u16Ptr_CMQ[eWindow]= 0;
    return TRUE;
}
#endif

MS_BOOL HAL_XC_DIP_CMDQBegin(void *pInstance,SCALER_DIP_WIN eWindow)
{
#if DIP_CMDQ_ENABLE
#if !(defined(MSOS_TYPE_LINUX_KERNEL))
    MS_U16 u16Index=0;

    if(eWindow!=DIP_WINDOW)
        DIP_H_ERR("Error:[%s],Line:%d,Not Support,eWindow%d\n",__FUNCTION__, __LINE__,eWindow);

    if ( HAL_XC_DIP_CMDQInit(pInstance,eWindow) == FALSE)
    {
        DIP_H_ERR("Error:[%s],Line:%d, eWindow:%d, HAL_XC_DIP_CMDQInit Fail\n",
                __FUNCTION__, __LINE__, eWindow);
        return FALSE;
    }

    DIPCMDQ_INIT_MUTEX_LOCK(eWindow);

    for(u16Index=0;u16Index<BANK_REG_MAX;u16Index++)
    {
        u16RegBK34Table[u16Index]=  SC_R2BYTE(0, REG_SC_BK34_00_L+u16Index*2);
        u16RegBK36Table[u16Index]=  SC_R2BYTE(0, REG_SC_BK36_00_L+u16Index*2);
    }
    g_u16Ptr_CMQ[eWindow] = 0;
    g_bCMDQ_Enable[eWindow] = TRUE;
#endif
#endif
    return TRUE;
}

MS_BOOL HAL_XC_DIP_CMDQEnd(void *pInstance,SCALER_DIP_WIN eWindow)
{
    MS_BOOL bRet = TRUE;
#if DIP_CMDQ_ENABLE
#if !(defined(MSOS_TYPE_LINUX_KERNEL))
    if(eWindow!=DIP_WINDOW)
        DIP_H_ERR("Error:[%s],Line:%d,Not Support,eWindow%d\n",__FUNCTION__, __LINE__,eWindow);

    bRet &= HAL_XC_DIP_CMDQTriggerCommand(eWindow);
    if (bRet == FALSE)
        DIP_H_ERR("[%s] ERROR: MDrv_DIPCMDQ_TriggerCommand\n", __FUNCTION__);

    g_u16Ptr_CMQ[eWindow] = 0;
    g_bCMDQ_Enable[eWindow] = FALSE;
    DIPCMDQ_INIT_MUTEX_UNLOCK(eWindow);
#endif
#endif
    return bRet;
}

void _HAL_XC_DIP_Write_ReqNum(void *pInstance, MS_U16 u16Width,SCALER_DIP_WIN eWindow)
{
    MS_U16 u16BusSize = 0;
    MS_U16 u16MiuCnt = 0;
    MS_U16 u16temp = 0;
    MS_U16 u16Bpp = 0;

    u16Bpp = HAL_XC_DIP_GetBPP(pInstance, DipFmt,eWindow);
    u16BusSize = HAL_XC_DIP_GetBusSize(pInstance, eWindow);
    u16MiuCnt = u16Width/(u16BusSize/u16Bpp);

    if(u16Width > (DIPW_TILE_REQUEST_MAX*u16BusSize))
    {
        if(eWindow == DIP_WINDOW)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK36_7E_L,DIPW_TILE_REQUEST_MAX,BMASK(6:0));
        }
        else if(eWindow == DWIN0_WINDOW)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7E_L,DIPW_TILE_REQUEST_MAX,BMASK(6:0));
        }
        else
        {
            DIP_H_ERR("Not Support eWindow%d\n",eWindow);
        }
    }
    else
    {
        for(u16temp = DIPW_TILE_REQUEST_MAX; u16temp>0; u16temp--)
        {
            if((u16MiuCnt%u16temp)==0)
            {
                if(eWindow == DIP_WINDOW)
                {
                    DIP_W2BYTEMSK(0, REG_SC_BK36_7E_L,((u16temp-1)&0xFFFE),BMASK(6:0));
                }
                else if(eWindow == DWIN0_WINDOW)
                {
                    DIP_W2BYTEMSK(0, REG_SC_BK3B_7E_L,((u16temp-1)&0xFFFE),BMASK(6:0));
                }
                else
                {
                    DIP_H_ERR("Not Support eWindow%d\n",eWindow);
                }
                break;
            }
        }
    }

    if(u16Width > (DIPW_LINEAR_REQUEST_MAX*(u16BusSize/u16Bpp)))
    {
        if(eWindow == DIP_WINDOW)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK36_6F_L,(DIPW_LINEAR_REQUEST_MAX/2),BMASK(6:0));
        }
        else if(eWindow == DWIN0_WINDOW)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_6F_L,(DIPW_LINEAR_REQUEST_MAX/2),BMASK(6:0));
        }
        else
        {
            DIP_H_ERR("Not Support eWindow%d\n",eWindow);
        }
    }
    else
    {
        for(u16temp = DIPW_LINEAR_REQUEST_MAX; u16temp>0; u16temp--)
        {
            if((u16MiuCnt%u16temp)==0)
            {
                if( eWindow == DIP_WINDOW )
                {
                    DIP_W2BYTEMSK(0, REG_SC_BK36_6F_L,(u16temp/2),BMASK(6:0));
                }
                else if(eWindow == DWIN0_WINDOW)
                {
                    DIP_W2BYTEMSK(0, REG_SC_BK3B_6F_L,(u16temp/2),BMASK(6:0));
                }
                else
                {
                    DIP_H_ERR("Not Support eWindow%d\n",eWindow);
                }
                break;
            }
        }
    }
}

static void _MHal_XC_DIP_1pTo2pCtrl(void *pInstance, SCALER_DIP_SOURCE_TYPE enSource,SCALER_DIP_WIN eWindow)
{
    MS_BOOL bEn1pto2p = FALSE;

    switch(enSource)
    {
        case SCALER_DIP_SOURCE_TYPE_SUB2:
        case SCALER_DIP_SOURCE_TYPE_MAIN:
        case SCALER_DIP_SOURCE_TYPE_SUB:
        case SCALER_DIP_SOURCE_TYPE_MVOP0:
        case SCALER_DIP_SOURCE_TYPE_MVOP1:
        case SCALER_DIP_SOURCE_TYPE_VD:
        case SCALER_DIP_SOURCE_TYPE_COMPONENT:
        case SCALER_DIP_SOURCE_TYPE_OP_MAIN:
        case SCALER_DIP_SOURCE_TYPE_OP_SUB:
        case SCALER_DIP_SOURCE_TYPE_DRAM:
        case SCALER_DIP_SOURCE_TYPE_OP_CAPTURE:
        case SCALER_DIP_SOURCE_TYPE_OSD:
        case SCALER_DIP_SOURCE_TYPE_HDMI:
            bEn1pto2p = TRUE;
            break;
        default:
            break;
    }

    if(eWindow == DIP_WINDOW)
    {
        DIP_W2BYTEMSK(0, REG_SC_BK34_31_L, (bEn1pto2p?BIT(4):0), BIT(4));
    }
    else if(eWindow == DWIN0_WINDOW)
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3B_39_L, (bEn1pto2p?BIT(15):0), BIT(15));
    }
    else
    {
        DIP_H_WARN("[%s]not support eWindow: %d\n", __FUNCTION__, enSource);
    }
}

//==============================================================================

//extern PQ_Function_Info    s_PQ_Function_Info;
//extern MS_BOOL             s_bKeepPixelPointerAppear;

MS_BOOL _MHal_XC_DIP_IsScaling(void *pInstance, XC_SETWIN_INFO *pstXC_SetWin_Info, SCALER_DIP_WIN enDipWindow)
{
    EN_DRV_XC_DWIN_DATA_FMT enDipFmt;
    MS_U16 u16BusSize = 0, u16Bpp = 0, u16alignment = 0, u16DipDstTmp = 0;

    if(pstXC_SetWin_Info->bPreHCusScaling == TRUE)
    {
        if(pstXC_SetWin_Info->u16PreHCusScalingSrc > pstXC_SetWin_Info->u16PreHCusScalingDst)
        {
            return TRUE;
        }
    }

    if(pstXC_SetWin_Info->bPreVCusScaling == TRUE)
    {
        if(pstXC_SetWin_Info->u16PreVCusScalingSrc > pstXC_SetWin_Info->u16PreVCusScalingDst)
        {
            return TRUE;
        }
    }

    enDipFmt = HAL_XC_DIP_GetDataFmt(pInstance, enDipWindow);
    u16BusSize = HAL_XC_DIP_GetBusSize(pInstance, enDipWindow);
    u16Bpp = HAL_XC_DIP_GetBPP(pInstance, enDipFmt, enDipWindow);
    u16alignment = u16BusSize/u16Bpp;
    u16DipDstTmp = pstXC_SetWin_Info->u16PreHCusScalingDst/u16alignment;
    u16DipDstTmp = u16DipDstTmp*u16alignment;
    if(pstXC_SetWin_Info->u16PreVCusScalingDst > u16DipDstTmp)
    {
        return TRUE;
    }

    return FALSE;
}

MS_BOOL _MHal_XC_DIP_IsClip(XC_SETWIN_INFO *pstXC_SetWin_Info, SCALER_DIP_SOURCE_TYPE enDipSourceType, SCALER_DIP_WIN enDipWindow)
{
    MS_U16 u16Width = 0, u16Height = 0;
    MS_BOOL bRet = FALSE;

    if(enDipSourceType == SCALER_DIP_SOURCE_TYPE_MAIN)
    {
        u16Width = _gstGetXCStatus.u16MainCapWidth;
        u16Height = _gstGetXCStatus.u16MainCapHeight;
    }

    if(enDipSourceType == SCALER_DIP_SOURCE_TYPE_OP_CAPTURE)
    {
        u16Width = _gstGetXCStatus.u16MainDispDEWidth;
        u16Height = _gstGetXCStatus.u16MainDispDEHeight;
    }

    if(enDipSourceType == SCALER_DIP_SOURCE_TYPE_SUB)
    {
        u16Width = _gstGetXCStatus.u16SubCapWidth;
        u16Height = _gstGetXCStatus.u16SubCapHeight;
    }

    if(enDipSourceType == SCALER_DIP_SOURCE_TYPE_DRAM)
    {
        u16Width = MDrv_DIP_Read2Byte(REG_DIPR_BK1210_07);
        u16Height = MDrv_DIP_Read2Byte(REG_DIPR_BK1210_06);
    }

    if(enDipSourceType == SCALER_DIP_SOURCE_TYPE_HDMI)
    {
        u16Width = _gstHDMIInfo[enDipWindow].u16Width;
        u16Height = _gstHDMIInfo[enDipWindow].u16Height;
    }

    if((pstXC_SetWin_Info->stCapWin.x > 0) || (pstXC_SetWin_Info->stCapWin.width < u16Width))
    {
        bRet = TRUE;
    }
    if((pstXC_SetWin_Info->stCapWin.y > 0) || (pstXC_SetWin_Info->stCapWin.height < u16Height))
    {
        bRet = TRUE;
    }

    return bRet;
}

MS_U32 _MHal_DIP_Get_EngineClock(void)
{
    MS_U16 u16RegVal = 0;
    MS_U32 u32DIPClock = 0;

    u16RegVal = MDrv_Read2Byte(REG_CKG_DIP_FCLK);

    if((u16RegVal & CKG_DIP_FCLK_MASK) == CKG_DIP_FCLK_170MHZ)
    {
        u32DIPClock = 170000000;
    }
    else if((u16RegVal & CKG_DIP_FCLK_MASK) == CKG_DIP_FCLK_345MHZ)
    {
        u32DIPClock = 345000000;
    }
    else if((u16RegVal & CKG_DIP_FCLK_MASK) == CKG_DIP_FCLK_216MHZ)
    {
        u32DIPClock = 216000000;
    }
    else if((u16RegVal & CKG_DIP_FCLK_MASK) == CKG_DIP_FCLK_192MHZ)
    {
        u32DIPClock = 192000000;
    }
    else if((u16RegVal & CKG_DIP_FCLK_MASK) == CKG_DIP_FCLK_240MHZ)
    {
        u32DIPClock = 240000000;
    }
    else if((u16RegVal & CKG_DIP_FCLK_MASK) == CKG_DIP_FCLK_320MHZ)
    {
        u32DIPClock = 320000000;
    }

    return u32DIPClock;
}

MS_BOOL _HAL_XC_DIP_IsYUVFmt(EN_DRV_XC_DWIN_DATA_FMT enfmt)
{
    switch(enfmt)
    {
        case XC_DWIN_DATA_FMT_YUV422:
        case XC_DWIN_DATA_FMT_YUV420:
        case XC_DWIN_DATA_FMT_YC422:
        case XC_DWIN_DATA_FMT_YUV420_H265:
        case XC_DWIN_DATA_FMT_YUV420_H265_10BITS:
        case XC_DWIN_DATA_FMT_YUV420_PLANER:
        case XC_DWIN_DATA_FMT_YUV420_SEMI_PLANER:
        case XC_DWIN_DATA_FMT_YUV422_MED_DI_FIELDTYPE_TOP:
        case XC_DWIN_DATA_FMT_YUV422_MED_DI_FIELDTYPE_BOTTOM:
        case XC_DWIN_DATA_FMT_YUV420_MED_DI_FIELDTYPE_TOP:
        case XC_DWIN_DATA_FMT_YUV420_MED_DI_FIELDTYPE_BOTTOM:
            return TRUE;
        default:
            return FALSE;
    }
}

MS_BOOL _HAL_XC_DIP_Get_Mfdec_Enable(MS_BOOL* bMfdEna, SCALER_DIP_WIN eWindow)
{
    MS_BOOL bRet = TRUE;

    *bMfdEna = FALSE;

    if( eWindow < MAX_DIP_WINDOW )
    {
        if((MDrv_DIP_Read2Byte(REG_DIPR_BK1210_1B) & BIT(0)))
        {
            *bMfdEna = TRUE;
        }
    }
    else
    {
        *bMfdEna = FALSE;
        bRet = FALSE;
        DIP_H_ERR("Not Support eWindow%d\n",eWindow);

    }
    return bRet;
}

MS_BOOL _MHal_XC_DIP_MVOPClkSupportCheck(MS_BOOL *bMVOPClkSuprtChk, SCALER_DIP_WIN eWindow)
{
    *bMVOPClkSuprtChk = TRUE;

    if(MDrv_DIP_Read2Byte(REG_MVOP_2P_MODE)&BIT(1))
    {
        if((MDrv_DIP_Read2Byte(REG_CKG_MVOP)&CKG_MVOP_CLK_MASK)== CKG_MVOP_320MHZ)
        {
            *bMVOPClkSuprtChk = FALSE;
        }
    }

    return TRUE;
}

void _HAL_XC_DIP_HSPScaling(void *pInstance,MS_BOOL bEnable,MS_U16 ScalingSrc,MS_U16 ScalingDst, SCALER_DIP_WIN eWindow)
{
    MS_U32 u32Ratio = 0;
#ifdef MSOS_TYPE_LINUX_KERNEL
    MS_U64 u64_result = 0;
#endif

    u32Ratio = (H_DIP_PostScalingRatio(ScalingSrc,ScalingDst));
    if(eWindow == DWIN0_WINDOW)
    {
        DIP_W2BYTE(0, REG_SC_BK5E_22_L, ScalingSrc);
        DIP_W2BYTE(0, REG_SC_BK5E_24_L, ScalingDst);
        DIP_W2BYTE(0, REG_SC_BK5E_07_L, u32Ratio&0xffff);
        DIP_W2BYTEMSK(0, REG_SC_BK5E_08_L,((u32Ratio&0xff0000)>>16),BMASK(7:0));
        DIP_W2BYTEMSK(0, REG_SC_BK5E_08_L,bEnable?BIT(8):0,BIT(8));
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L,0x3,BMASK(3:0));
        if(ScalingSrc < ScalingDst)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK5E_08_L, BIT(9) ,BIT(9));
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK5E_08_L, 0 ,BIT(9));
        }
#if (DIP_PQ_SETTINGS == TRUE)
        MDrv_PQ_LoadScalingTable(PQ_SUB_WINDOW,E_XRULE_HSP,FALSE,FALSE,TRUE,ScalingSrc,ScalingDst);
#endif
#if (DIP_HVSP_LoadSRAM == TRUE)
        // horizontal Y/C scaling filter setting
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L, 0, BIT(0)); // disable horizontal Y Bilinear mode
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L, BIT(3)|BIT(2), BMASK(3:1));// horizontal C scaling filter mode use SRAM 1
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L, 0, BMASK(5:4)); // disable horizontal C use Y SRAM
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L, BIT(6), BIT(6)); //enable horizontal Y scaling filter SRAM usage
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L, BIT(7), BIT(7)); // horizontal Y scaling filter use SRAM 1
        //DIP_W2BYTEMSK(0, REG_SC_BK4E_13_L, BIT(4), BIT(4)); //horizontal Y 6tap scaling enable
#endif
    }
}

void _HAL_XC_DIP_VSPScaling(void *pInstance,MS_BOOL bEnable,MS_U16 ScalingSrc,MS_U16 ScalingDst, SCALER_DIP_WIN eWindow)
{
    MS_U32 u32Ratio = 0;
#ifdef MSOS_TYPE_LINUX_KERNEL
    MS_U64 u64_result = 0;
#endif

    u32Ratio = (V_DIP_PostScalingRatio(ScalingSrc,ScalingDst));

    if(eWindow == DWIN0_WINDOW)
    {
        DIP_W2BYTE(0, REG_SC_BK5E_23_L, ScalingSrc);
        DIP_W2BYTE(0, REG_SC_BK5E_25_L, ScalingDst);
        DIP_W2BYTE(0, REG_SC_BK5E_09_L, u32Ratio&0xffff);
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0A_L,((u32Ratio&0xff0000)>>16),BMASK(7:0));
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0A_L,bEnable?BIT(8):0,BIT(8));
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L,0x3<<8,BMASK(11:8));
        if(ScalingSrc < ScalingDst)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK5E_0A_L, BIT(9) ,BIT(9));
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK5E_0A_L, 0 ,BIT(9));
        }
#if (DIP_PQ_SETTINGS == TRUE)
        MDrv_PQ_LoadScalingTable(PQ_SUB_WINDOW,E_XRULE_VSP,FALSE,FALSE,TRUE,ScalingSrc,ScalingDst);
#endif
#if (DIP_HVSP_LoadSRAM == TRUE)
        // vertical Y/C scaling filter setting
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L, 0, BIT(8)); // disable vertical Y Bilinear mode
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L, BIT(10), BMASK(11:9));// vertical C scaling filter mode use SRAM 0
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L, 0, BMASK(13:12)); // disable vertical C use Y SRAM
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L, BIT(14), BIT(14)); //enable vertical Y scaling filter SRAM usage
        DIP_W2BYTEMSK(0, REG_SC_BK5E_0B_L, 0, BIT(15)); // vertical Y scaling filter use SRAM 0
#endif
    }
}

void _HAL_XC_DIP_HVSP_Enable(void* pInstance,MS_BOOL bSelect, SCALER_DIP_WIN eWindow)
{
    if(bSelect == TRUE)
    {
        if(eWindow == DWIN0_WINDOW)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK5E_70_L, BIT(1) ,BIT(1));
        }
    }
    else
    {
        if(eWindow == DWIN0_WINDOW)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK5E_70_L, 0 ,BIT(1));
        }
    }
}

#if (DIP_PQ_SETTINGS == TRUE)
void _HAL_XC_DIP_SET_PQ(void)
{
    PQ_INPUT_SOURCE_TYPE enPQSourceType=PQ_INPUT_SOURCE_NONE;
    MS_U8 u8BitsPerPixel = 24;

    if(IsSrcTypeVga(enDWIN0InputType))
    {
        enPQSourceType = PQ_INPUT_SOURCE_VGA; // VGA
    }
    else if(IsSrcTypeATV(enDWIN0InputType))
    {
        enPQSourceType = PQ_INPUT_SOURCE_TV; // TV
    }
    else if(IsSrcTypeDTV(enDWIN0InputType))
    {
        enPQSourceType = PQ_INPUT_SOURCE_DTV; //DTV
    }
    else if(IsSrcTypeAV(enDWIN0InputType))
    {
        enPQSourceType = PQ_INPUT_SOURCE_CVBS; // AV
    }
    else if(IsSrcTypeScart(enDWIN0InputType))
    {
        enPQSourceType = PQ_INPUT_SOURCE_SCART; // SCART
    }
    else if(IsSrcTypeSV(enDWIN0InputType))
    {
        enPQSourceType = PQ_INPUT_SOURCE_SVIDEO; // SV
    }
    else if(IsSrcTypeHDMI(enDWIN0InputType))
    {
        enPQSourceType = PQ_INPUT_SOURCE_HDMI; // HDMI
    }
    else if(IsSrcTypeYPbPr(enDWIN0InputType))
    {
        enPQSourceType = PQ_INPUT_SOURCE_YPBPR; // COMP
    }
    else if(IsSrcTypeJpeg(enDWIN0InputType))
    {
        enPQSourceType = PQ_INPUT_SOURCE_JPEG; // JPEG
    }
    else if(IsSrcTypeStorage(enDWIN0InputType))
    {
        enPQSourceType = PQ_INPUT_SOURCE_STORAGE; // Storage
    }
    else if(IsSrcTypeCapture(enDWIN0InputType)
            ||IsSrcTypeSC0DI(enDWIN0InputType))
    {
        enPQSourceType = PQ_INPUT_SOURCE_DTV; // Temperarily use DTV
    }
    else if(enDWIN0InputType == INPUT_SOURCE_KTV)
    {
        enPQSourceType = PQ_INPUT_SOURCE_KTV; // KTV
    }
    else
    {
        printf("[%s][%d] Input source select to default when source is %d.\n",__FUNCTION__,__LINE__,enDWIN0InputType);
    }

    if(enPQSourceType != PQ_INPUT_SOURCE_NONE)
    {
        MDrv_PQ_DesideSrcType(PQ_SUB_WINDOW,enDWIN0InputType);
    }
    if(_gbDWIN0DIEna == TRUE)
    {
        MDrv_PQ_SetMemFormat(PQ_SUB_WINDOW,TRUE,FALSE,&u8BitsPerPixel);
    }
}
#endif

void Hal_SC_DWIN_set_422_cbcr_swap(void *pInstance, MS_BOOL bEnable, SCALER_DIP_WIN eWindow)
{
    if(eWindow == DIP_WINDOW)
    {
        DIP_W2BYTEMSK(0, REG_SC_BK34_30_L, bEnable ? BIT(3) : 0, BIT(3));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3B_44_L, bEnable ? BIT(3) : 0, BIT(3));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3C_44_L, bEnable ? BIT(3) : 0, BIT(3));
    }
    else
    {
        return;
    }
}

void Hal_SC_DWIN_set_pre_align_pixel(void *pInstance, MS_BOOL bEnable, MS_U16 pixels, SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        if (bEnable)
            DIP_W2BYTEMSK(0, REG_SC_BK34_60_L, BIT(1), BIT(1));
        else
            DIP_W2BYTEMSK(0, REG_SC_BK34_60_L, 0x00 , BIT(1));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        if (bEnable)
            DIP_W2BYTEMSK(0, REG_SC_BK3B_62_L, BIT(1), BIT(1));
        else
            DIP_W2BYTEMSK(0, REG_SC_BK3B_62_L, 0x00 , BIT(1));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        if (bEnable)
            DIP_W2BYTEMSK(0, REG_SC_BK3C_62_L, BIT(1), BIT(1));
        else
            DIP_W2BYTEMSK(0, REG_SC_BK3C_62_L, 0x00 , BIT(1));
    }
    else
    {
        return;
    }
}

// This function will return 8/10/12/14/16 field mode or 8 frame mode.
// Otherwise it return IMAGE_STORE_2_FRAMES
XC_FRAME_STORE_NUMBER Hal_SC_DWIN_GetFrameStoreMode(void *pInstance, SCALER_DIP_WIN eWindow,MS_BOOL bInterlace)
{
    if (bInterlace)
    {
        return IMAGE_STORE_4_FIELDS;
    }
    else
    {
        return IMAGE_STORE_2_FRAMES;
    }
}


void Hal_SC_DWIN_EnableR2YCSC(void *pInstance, MS_BOOL bEnable, SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        bDipR2Y = bEnable;
        if( ((DipSource == SCALER_DIP_SOURCE_TYPE_OP_MAIN) || (DipSource == SCALER_DIP_SOURCE_TYPE_OP_SUB)) && (bDipR2Y == FALSE) )
        {
            //enable  422 to 444
            DIP_W2BYTEMSK(0, REG_SC_BK34_6C_L,BIT(9),BIT(9));
            //enable  source yc swap
            DIP_W2BYTEMSK(0, REG_SC_BK34_7C_L,BIT(14),BIT(14));
        }
        else
        {
            //disable  422 to 444
            DIP_W2BYTEMSK(0, REG_SC_BK34_6C_L,0,BIT(9));
        	//disable  source yc swap
            DIP_W2BYTEMSK(0, REG_SC_BK34_7C_L,0,BIT(14));
        }
        DIP_W2BYTEMSK(0, REG_SC_BK34_31_L, (bEnable ? BIT(0):0), BIT(0));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        bDwin0R2Y = bEnable;
        if( ((Dwin0Source == SCALER_DIP_SOURCE_TYPE_OP_MAIN) || (Dwin0Source == SCALER_DIP_SOURCE_TYPE_OP_SUB)) && (bDwin0R2Y == FALSE) )
        {
            //enable  422 to 444
            DIP_W2BYTEMSK(0, REG_SC_BK3B_78_L,BIT(9),BIT(9));
            //enable  source yc swap
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L,BIT(8),BIT(8));
        }
        else
        {
            //disable  422 to 444
            DIP_W2BYTEMSK(0, REG_SC_BK3B_78_L,0,BIT(9));
            //disable  source yc swap
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L,0,BIT(8));
        }
        DIP_W2BYTEMSK(0, REG_SC_BK3B_45_L, (bEnable ? BIT(0):0), BIT(0));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        bDwin1R2Y = bEnable;
        if( ((Dwin1Source == SCALER_DIP_SOURCE_TYPE_OP_MAIN) || (Dwin1Source == SCALER_DIP_SOURCE_TYPE_OP_SUB)) && (bDwin1R2Y == FALSE) )
        {
            //enable  422 to 444
            DIP_W2BYTEMSK(0, REG_SC_BK3C_78_L,BIT(9),BIT(9));
            //enable  source yc swap
            DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L,BIT(8),BIT(8));
        }
        else
        {
            //disable  422 to 444
            DIP_W2BYTEMSK(0, REG_SC_BK3C_78_L,0,BIT(9));
            //disable  source yc swap
            DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L,0,BIT(8));
        }
        DIP_W2BYTEMSK(0, REG_SC_BK3C_45_L, (bEnable ? BIT(0):0), BIT(0));
    }
    else
    {
        return;
    }
}

void Hal_SC_DWIN_Set_vsd_output_line_count(void *pInstance, MS_BOOL bEnable,MS_U32 u32LineCount,SCALER_DIP_WIN eWindow)
{
    MS_U16 u16OutputLineCount = 0x00;

    if (bEnable)
    {
        u16OutputLineCount = BIT(15);
        u16OutputLineCount |= (MS_U16)(u32LineCount & 0x1FFF);
    }

    if (eWindow == DIP_WINDOW)
    {
        DIP_W2BYTEMSK(0, REG_SC_BK34_37_L, u16OutputLineCount,0x81FF);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3B_47_L, u16OutputLineCount,0x81FF);
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3C_47_L, u16OutputLineCount,0x81FF);
    }
    else
    {
        return;
    }
}

/*
 bEnable : Enable input line count.
 bUserMode : 1 -> the input line count will ref u32UserLineCount
             0 -> the input line count will ref V capture win
*/
void Hal_SC_DWIN_Set_vsd_input_line_count(void *pInstance, MS_BOOL bEnable,MS_BOOL bUserMode,MS_U32 u32UserLineCount,SCALER_DIP_WIN eWindow)
{
    MS_U16 u16InputLineCount = 0x00;

    if (bEnable)
    {
        u16InputLineCount = BIT(15);

        if (bUserMode)
        {
            u16InputLineCount |= BIT(14);
            u16InputLineCount |= (MS_U16)(u32UserLineCount & 0x1FFF);
        }
    }

    if (eWindow == DIP_WINDOW)
    {
        DIP_W2BYTE(0, REG_SC_BK34_36_L, u16InputLineCount);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTE(0, REG_SC_BK3B_46_L, u16InputLineCount);
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTE(0, REG_SC_BK3C_46_L, u16InputLineCount);
    }
    else
    {
        return;
    }
}


void Hal_SC_DWIN_sw_db(void *pInstance, P_SC_DIP_SWDB_INFO pDBreg, SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
      DIP_W4BYTE(0, REG_SC_BK34_04_L, pDBreg->u32H_PreScalingRatio);   // H pre-scaling
      DIP_W4BYTE(0, REG_SC_BK34_08_L, pDBreg->u32V_PreScalingRatio);   // V pre-scaling

      DIP_W2BYTEMSK(0, REG_SC_BK34_60_L, BIT(1)|BIT(0),BIT(1)|BIT(0));
      DIP_W2BYTE(0, REG_SC_BK34_61_L, pDBreg->u16H_CapStart+1);
      DIP_W2BYTE(0, REG_SC_BK34_62_L, pDBreg->u16H_CapStart+pDBreg->u16H_CapSize);
      DIP_W2BYTE(0, REG_SC_BK34_63_L, pDBreg->u16V_CapStart+1);
      DIP_W2BYTE(0, REG_SC_BK34_64_L, pDBreg->u16V_CapStart+pDBreg->u16V_CapSize);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
      DIP_W4BYTE(0, REG_SC_BK3B_15_L, pDBreg->u32H_PreScalingRatio);   // H pre-scaling
      DIP_W4BYTE(0, REG_SC_BK3B_1B_L, pDBreg->u32V_PreScalingRatio);   // V pre-scaling

      DIP_W2BYTEMSK(0, REG_SC_BK3B_62_L, BIT(1)|BIT(0),BIT(1)|BIT(0));
      DIP_W2BYTE(0, REG_SC_BK3B_63_L, pDBreg->u16H_CapStart+1);
      DIP_W2BYTE(0, REG_SC_BK3B_64_L, pDBreg->u16H_CapStart+pDBreg->u16H_CapSize);
      DIP_W2BYTE(0, REG_SC_BK3B_65_L, pDBreg->u16V_CapStart+1);
      DIP_W2BYTE(0, REG_SC_BK3B_66_L, pDBreg->u16V_CapStart+pDBreg->u16V_CapSize);
  }
  else if( eWindow == DWIN1_WINDOW )
  {
      if( pDBreg->u32H_PreScalingRatio & BIT(31))
        DIP_W2BYTEMSK(0, REG_SC_BK3C_78_L, BIT(15),BIT(15));
      else
        DIP_W2BYTEMSK(0, REG_SC_BK3C_78_L, 0,BIT(15));

      DIP_W4BYTE(0, REG_SC_BK3C_37_L, (pDBreg->u32H_PreScalingRatio & (~(BIT(31)))));   // H pre-scaling
      DIP_W4BYTE(0, REG_SC_BK3C_1B_L, pDBreg->u32V_PreScalingRatio);   // V pre-scaling

      DIP_W2BYTEMSK(0, REG_SC_BK3C_62_L, BIT(1)|BIT(0),BIT(1)|BIT(0));
      DIP_W2BYTE(0, REG_SC_BK3C_63_L, pDBreg->u16H_CapStart+1);
      DIP_W2BYTE(0, REG_SC_BK3C_64_L, pDBreg->u16H_CapStart+pDBreg->u16H_CapSize);
      DIP_W2BYTE(0, REG_SC_BK3C_65_L, pDBreg->u16V_CapStart+1);
      DIP_W2BYTE(0, REG_SC_BK3C_66_L, pDBreg->u16V_CapStart+pDBreg->u16V_CapSize);
  }
  else
  {
      return;
  }
}
void Hal_SC_DWIN_get_sw_db(void *pInstance, P_SC_DIP_SWDB_INFO pDBreg, SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
      pDBreg->u32H_PreScalingRatio =  DIP_R4BYTE(0, REG_SC_BK34_04_L, eWindow);
      pDBreg->u32V_PreScalingRatio =  DIP_R4BYTE(0, REG_SC_BK34_08_L, eWindow);

      pDBreg->u16H_CapStart = (DIP_R2BYTE(0, REG_SC_BK34_61_L,eWindow) - 1);
      pDBreg->u16H_CapSize = (DIP_R2BYTE(0, REG_SC_BK34_62_L,eWindow) - pDBreg->u16H_CapStart);
      pDBreg->u16V_CapStart = (DIP_R2BYTE(0, REG_SC_BK34_63_L,eWindow) - 1);
      pDBreg->u16V_CapSize = (DIP_R2BYTE(0, REG_SC_BK34_64_L,eWindow) - pDBreg->u16V_CapStart);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
      pDBreg->u32H_PreScalingRatio = DIP_R4BYTE(0, REG_SC_BK3B_15_L, eWindow);
      pDBreg->u32V_PreScalingRatio =  DIP_R4BYTE(0, REG_SC_BK3B_1B_L, eWindow);

      pDBreg->u16H_CapStart = (DIP_R2BYTE(0, REG_SC_BK3B_63_L,eWindow) - 1);
      pDBreg->u16H_CapSize = (DIP_R2BYTE(0, REG_SC_BK3B_64_L,eWindow) - pDBreg->u16H_CapStart);
      pDBreg->u16V_CapStart = (DIP_R2BYTE(0, REG_SC_BK3B_65_L,eWindow) - 1);
      pDBreg->u16V_CapSize = (DIP_R2BYTE(0, REG_SC_BK3B_66_L,eWindow) - pDBreg->u16V_CapStart);
    }
    else if( eWindow == DWIN1_WINDOW )
    {
      pDBreg->u32H_PreScalingRatio =  DIP_R4BYTE(0, REG_SC_BK3C_37_L,eWindow);
      if( DIP_R2BYTE(0, REG_SC_BK3C_78_L,eWindow) & BIT(15) )
        pDBreg->u32H_PreScalingRatio |= BIT(31);
      pDBreg->u32V_PreScalingRatio =  DIP_R4BYTE(0, REG_SC_BK3C_1B_L,eWindow);

      pDBreg->u16H_CapStart = (DIP_R2BYTE(0, REG_SC_BK3C_63_L,eWindow) - 1);
      pDBreg->u16H_CapSize = (DIP_R2BYTE(0, REG_SC_BK3C_64_L,eWindow) - pDBreg->u16H_CapStart);
      pDBreg->u16V_CapStart = (DIP_R2BYTE(0, REG_SC_BK3C_65_L,eWindow) - 1);
      pDBreg->u16V_CapSize = (DIP_R2BYTE(0, REG_SC_BK3C_66_L,eWindow) - pDBreg->u16V_CapStart);
    }
    else
    {
      return;
    }
}

static EN_DIP_RETURN_STATUS _MHal_XC_DIP_GetWidth(void *pInstance, SCALER_DIP_SOURCE_TYPE eSource, SCALER_DIP_WIN eWindow, MS_U16* u16pMaxWith)
{
#ifdef UTOPIA_V2
        DIP_INSTANCE_PRIVATE* pDipPri = NULL;
        DIP_SHARE_RESOURCE_PRIVATE* pDipResPri = NULL;
        if(UtopiaInstanceGetPrivate(pInstance, (void*)&pDipPri) != 0)
       {
            XC_LOG_TRACE(XC_DBGLEVEL_PARAMETER_TRACE,"DIP - UtopiaInstanceGetPrivate fail\n");
            return E_DIP_FAIL;
       }else
       {
           UtopiaResourceGetPrivate(pDipPri->pShareResource,(void*)&(pDipResPri));
       }
#endif

    //2p to 1p
    if(eSource == SCALER_DIP_SOURCE_TYPE_MAIN)
    {
        *u16pMaxWith = _gstGetXCStatus.u16MainCapWidth;
    }
    else if(eSource == SCALER_DIP_SOURCE_TYPE_SUB)
    {
        *u16pMaxWith = _gstGetXCStatus.u16SubCapWidth;
    }
    else if(eSource == SCALER_DIP_SOURCE_TYPE_OP_MAIN)
    {
        *u16pMaxWith = _gstGetXCStatus.u16MainOPMFetch;
    }
    else if(eSource == SCALER_DIP_SOURCE_TYPE_OP_SUB)
    {
        *u16pMaxWith = _gstGetXCStatus.u16SubOPMFetch;
    }
    else if(eSource == SCALER_DIP_SOURCE_TYPE_OP_CAPTURE)
    {
        *u16pMaxWith = _gstGetXCStatus.u16MainDispDEWidth;
    }
    else if(eSource == SCALER_DIP_SOURCE_TYPE_DRAM)
    {
        *u16pMaxWith =  MDrv_DIP_Read2Byte(REG_DIPR_BK1210_07); //dipr read width
    }
    else if(eSource == SCALER_DIP_SOURCE_TYPE_MVOP1 || eSource == SCALER_DIP_SOURCE_TYPE_VD || eSource == SCALER_DIP_SOURCE_TYPE_COMPONENT)
    {
        if(_gbIsSetSourceInfo[eWindow] == TRUE)
        {
            *u16pMaxWith = _gstDIPSourceInfo[eWindow].u16Width;
        }
    }
    else if(eSource == SCALER_DIP_SOURCE_TYPE_SC2_OP_CAPTURE)
    {
        if(eWindow == DWIN0_WINDOW)
        {
            if(_gstDwin0XCInfo.bPathEnabled == TRUE)
            {
                *u16pMaxWith = _gstDwin0XCInfo.stXCCapWin.width;
            }
        }
        else
        {
            DIP_H_WARN("[%s]eWindow:%d not support source:%d\n",__FUNCTION__, eWindow, eSource);
            return E_DIP_INVALID_PARAMETERS;
        }
    }
    else if(eSource == SCALER_DIP_SOURCE_TYPE_HDMI)
    {
        *u16pMaxWith = _gstHDMIInfo[eWindow].u16Width;
    }
    else
    {
        DIP_H_WARN("[%s]eWindow:%d not support source:%d\n",__FUNCTION__, eWindow, eSource);
        return E_DIP_INVALID_PARAMETERS;
    }

/*#if (DIP_PATCH_CLIP_FAILED_1073531 == 1)
    _gu16DIPPatchMaxCaptureInputSize = *u16pMaxWith;
#endif*/

    return E_DIP_SUCCESS;
}

/*static EN_DIP_RETURN_STATUS _MHal_XC_DIP_IsNeedAverageMode(void *pInstance, SCALER_DIP_SOURCE_TYPE eSource, MS_U16 u16MaxWith, SCALER_DIP_WIN eWindow, MS_BOOL* pbNeedAverageMode)
{
    MS_BOOL bMVOPClkSuprtChk = FALSE;
#ifdef UTOPIA_V2
    DIP_INSTANCE_PRIVATE* pDipPri = NULL;
    DIP_SHARE_RESOURCE_PRIVATE* pDipResPri = NULL;
    if(UtopiaInstanceGetPrivate(pInstance, (void*)&pDipPri) != 0)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_PARAMETER_TRACE,"DIP - UtopiaInstanceGetPrivate fail\n");
        return E_DIP_FAIL;
    }
    else
    {
        UtopiaResourceGetPrivate(pDipPri->pShareResource,(void*)&(pDipResPri));
    }
#endif

    //k2k@60 averge to 2k2k@60
    if(_gbIsDip2pPathEna[eWindow] == TRUE)
    {
        *pbNeedAverageMode = FALSE;
    }
    else
    {
        if((eSource == SCALER_DIP_SOURCE_TYPE_OP_CAPTURE) )
        {
            if(u16MaxWith > FHD_WIDTH)
            {
                *pbNeedAverageMode = TRUE;
            }
        }
        else if(( (eSource == SCALER_DIP_SOURCE_TYPE_OP_MAIN ) || (eSource == SCALER_DIP_SOURCE_TYPE_OP_SUB) ) && (u16MaxWith>FHD_WIDTH) )
        {
            *pbNeedAverageMode = TRUE;
        }
        else if( eSource == SCALER_DIP_SOURCE_TYPE_MAIN )
        {
            if(_gstGetXCStatus.bMainHskMode == TRUE)
            {
                _MHal_XC_DIP_MVOPClkSupportCheck(&bMVOPClkSuprtChk, eWindow);
                if(bMVOPClkSuprtChk == FALSE)
                {
                    *pbNeedAverageMode = TRUE;
                }
            }
            else
            {
                if(_gstGetXCStatus.bMain2pEna == TRUE)
                {
                    *pbNeedAverageMode = TRUE;
                }
            }
        }
        else if( (eSource == SCALER_DIP_SOURCE_TYPE_SUB) && (DIP_R2BYTEMSK(0,REG_SC_BK04_0A_L,BIT(15), eWindow) != 0 ) )
        {
            *pbNeedAverageMode = TRUE;
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_DRAM)
        {
            if( (g_DIPSrcInfo[eWindow].u16PreHCusScalingSrc/2) >= g_DIPSrcInfo[eWindow].u16PreHCusScalingDst )
            {
                *pbNeedAverageMode = TRUE;
            }
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_HDMI && (u16MaxWith>FHD_WIDTH))
        {
            *pbNeedAverageMode = TRUE;
        }
        else
        {
            *pbNeedAverageMode = FALSE;
        }
    }

    return E_DIP_SUCCESS;
}

static EN_DIP_RETURN_STATUS _MHal_XC_DIP_Averge2PTo1P(void *pInstance,MS_BOOL bAvg, SCALER_DIP_WIN eWindow)
{
#ifdef UTOPIA_V2
        DIP_INSTANCE_PRIVATE* pDipPri = NULL;
        DIP_SHARE_RESOURCE_PRIVATE* pDipResPri = NULL;
        UtopiaInstanceGetPrivate(pInstance, (void*)&pDipPri);
        UtopiaResourceGetPrivate(pDipPri->pShareResource,(void*)&(pDipResPri));
#endif

    SC_DIP_SWDB_INFO stDBreg;
#if (DIP_PATCH_CLIP_FAILED_1073531 == 1)
        MS_U64 u64OutputPatched = 0x0;
        MS_U32 u32InputPatched = 0x0;
        MS_U32 u32ClipWidthPatched = 0x0;
        MS_U32 u32ScalingRatio = 0x0;

        memset(&stDBreg, 0, sizeof(SC_DIP_SWDB_INFO));
        Hal_SC_DWIN_get_sw_db(pInstance,&stDBreg,eWindow);
        if ((stDBreg.u16H_CapSize + stDBreg.u16H_CapStart < _gu16DIPPatchMaxCaptureInputSize))
        {
            // patch for avg mode, partial clip failed problem.
            u32ScalingRatio = stDBreg.u32H_PreScalingRatio & (~(BIT(31)));
            if(bAvg == TRUE)
            {
                stDBreg.u16H_CapStart /= 2;
                u32ClipWidthPatched = (_gu16DIPPatchMaxCaptureInputSize>>1) - stDBreg.u16H_CapStart;
                u64OutputPatched = ((((MS_U64)u32ClipWidthPatched) * (u32ScalingRatio-1)) >> 19);
            }
            else
            {
                u32ClipWidthPatched = _gu16DIPPatchMaxCaptureInputSize - stDBreg.u16H_CapStart;
                u64OutputPatched = ((((MS_U64)u32ClipWidthPatched) * (u32ScalingRatio-1)) >> 20);
            }

            u32InputPatched = u32ClipWidthPatched;

            if( u64OutputPatched < u32InputPatched )
            {
                stDBreg.u32H_PreScalingRatio = H_PreScalingDownRatioDIP(u32InputPatched, u64OutputPatched);
                stDBreg.u32H_PreScalingRatio &= 0x7FFFFFL;
                stDBreg.u32H_PreScalingRatio |= (BIT(31));
            }
            else
            {
                stDBreg.u32H_PreScalingRatio = 0x100000L;
            }
            stDBreg.u16H_CapSize = (MS_U16)u32ClipWidthPatched;
            Hal_SC_DWIN_sw_db(pInstance,&stDBreg,eWindow);
        }
        else
        {
            if(bAvg == TRUE)
            {
                Hal_SC_DWIN_get_sw_db(pInstance,&stDBreg,eWindow);
                stDBreg.u16H_CapStart/=2;
                stDBreg.u16H_CapSize = (stDBreg.u16H_CapSize + 1) >> 1;
                if( (g_DIPSrcInfo[eWindow].u16PreHCusScalingSrc/2) > g_DIPSrcInfo[eWindow].u16PreHCusScalingDst )
                {
                    stDBreg.u32H_PreScalingRatio = H_PreScalingDownRatioDIP(g_DIPSrcInfo[eWindow].u16PreHCusScalingSrc/2,g_DIPSrcInfo[eWindow].u16PreHCusScalingDst);
                    stDBreg.u32H_PreScalingRatio &= 0x7FFFFFL;
                    stDBreg.u32H_PreScalingRatio |= (BIT(31));
                }
                else
                {
                    stDBreg.u32H_PreScalingRatio = 0x100000L;
                }
                Hal_SC_DWIN_sw_db(pInstance,&stDBreg,eWindow);
            }
        }
#else
    memset(&stDBreg, 0, sizeof(SC_DIP_SWDB_INFO));

    if(bAvg == TRUE)
    {
        Hal_SC_DWIN_get_sw_db(pInstance,&stDBreg,eWindow);
        stDBreg.u16H_CapStart/=2;
        stDBreg.u16H_CapSize = (stDBreg.u16H_CapSize + 1) >> 1;
        if( (g_DIPSrcInfo[eWindow].u16PreHCusScalingSrc/2) > g_DIPSrcInfo[eWindow].u16PreHCusScalingDst )
        {
            stDBreg.u32H_PreScalingRatio = H_PreScalingDownRatioDIP(g_DIPSrcInfo[eWindow].u16PreHCusScalingSrc/2,g_DIPSrcInfo[eWindow].u16PreHCusScalingDst);
            stDBreg.u32H_PreScalingRatio &= 0x7FFFFFL;
            stDBreg.u32H_PreScalingRatio |= (BIT(31));
        }
        else
        {
            stDBreg.u32H_PreScalingRatio = 0x100000L;
        }
        Hal_SC_DWIN_sw_db(pInstance,&stDBreg,eWindow);
    }
#endif

    if( eWindow == DIP_WINDOW )
    {
        if(bAvg == TRUE)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK34_50_L, BIT(15),BIT(15));
            DIP_W2BYTEMSK(0, REG_SC_BK34_6D_L, BIT(14),BIT(14));
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK34_50_L, 0,BIT(15));
            DIP_W2BYTEMSK(0, REG_SC_BK34_6D_L, 0,BIT(14));
        }
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        if(bAvg == TRUE)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7A_L, BIT(15),BIT(15));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_79_L, BIT(14),BIT(14));
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7A_L, 0,BIT(15));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_79_L, 0,BIT(14));
        }

    }
    else
    {
        DIP_H_WARN("[%s],Line:%d, not support eWindow: %d\n",__FUNCTION__, __LINE__, eWindow);
        return E_DIP_INVALID_PARAMETERS;
    }

    return E_DIP_SUCCESS;
}*/

void HAL_XC_DIP_Set444to422(void *pInstance, EN_DRV_XC_DWIN_DATA_FMT fmt,MS_BOOL bSrcYUVFmt,MS_BOOL bSrcFmt422,SCALER_DIP_WIN eWindow)
{

}
void HAL_XC_DIP_SetFRC(void *pInstance, MS_BOOL bEnable,MS_U16 u16In,MS_U16 u16Out,SCALER_DIP_WIN eWindow)
{
    MS_U16 u16Ratio=0;
    MS_U64 u64_result = 0;

    if( eWindow == DIP_WINDOW )
    {
        if(bEnable)
        {
            if(u16In > u16Out)
            {
                u64_result = (u16In-u16Out)*64;
                DO_DIV(u64_result,u16In);
                u16Ratio = u64_result;
                DIP_W2BYTEMSK(0, REG_SC_BK34_40_L,u16Ratio,BMASK(5:0));
            }
            else
            {
                DIP_W2BYTEMSK(0, REG_SC_BK34_40_L,0,BMASK(5:0));
            }
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK34_40_L,0,BMASK(5:0));
        }
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        if(bEnable)
        {
            if(u16In > u16Out)
            {
                u64_result = (u16In-u16Out)*64;
                DO_DIV(u64_result,u16In);
                u16Ratio = u64_result;
                DIP_W2BYTEMSK(0, REG_SC_BK3B_4D_L,u16Ratio,BMASK(5:0));
            }
            else
            {
                DIP_W2BYTEMSK(0, REG_SC_BK3B_4D_L,0,BMASK(5:0));
            }
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_4D_L,0,BMASK(5:0));
        }
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        if(bEnable)
        {
            if(u16In > u16Out)
            {
                u64_result = (u16In-u16Out)*64;
                DO_DIV(u64_result,u16In);
                u16Ratio = u64_result;
                DIP_W2BYTEMSK(0, REG_SC_BK3C_4D_L,u16Ratio,BMASK(5:0));
            }
            else
            {
                DIP_W2BYTEMSK(0, REG_SC_BK3C_4D_L,0,BMASK(5:0));
            }
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3C_4D_L,0,BMASK(5:0));
        }
    }
    else
    {
        return;
    }

}
void Hal_SC_DWIN_set_input_vsync_inverse(void *pInstance, MS_BOOL bEnable, SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        DIP_W2BYTEMSK(0,  REG_SC_BK34_01_L, (bEnable<<2), BIT(2) );
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTEMSK(0,  REG_SC_BK3B_12_L, (bEnable<<2), BIT(2) );
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTEMSK(0,  REG_SC_BK3C_12_L, (bEnable<<2), BIT(2) );
    }
    else
    {
    return;
    }
}

//=============== DIP =====================//
#define DWIN_CAPTURE_TIMEOUT_CNT 10 //consider 576i video, maximum time is 20+20x2 = 60 ms

MS_U16 HAL_XC_DIP_GetBusSize(void *pInstance, SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        return DWIN_BYTE_PER_WORD;
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        return DWIN_BYTE_PER_WORD;
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        return DWIN_BYTE_PER_WORD;
    }
    else
    {
        return 0xFF;
    }
}

MS_BOOL HAL_XC_DIP_GetVScalingMaxWidth(void *pInstance, MS_U16* pu16MaxWidth, SCALER_DIP_WIN eWindow)
{
    MS_BOOL bRet = TRUE;

    if( eWindow == DIP_WINDOW )
    {
        *pu16MaxWidth = DIP0_VSCALING_MAX_WDITH;
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        *pu16MaxWidth = DIP1_VSCALING_MAX_WDITH;
    }
    else
    {
        bRet = FALSE;
    }

    return bRet;
}

void HAL_XC_DIP_SWReset(void *pInstance, SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK34_7F_L,BIT(0), BIT(0));
        DIP_W2BYTEMSK(0, REG_SC_BK34_7F_L,0, BIT(0));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3B_73_L,BIT(0), BIT(0));
        DIP_W2BYTEMSK(0, REG_SC_BK3B_73_L,0, BIT(0));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3C_73_L,BIT(0), BIT(0));
        DIP_W2BYTEMSK(0, REG_SC_BK3C_73_L,0, BIT(0));
    }
    else
    {
        return;
    }
}

void HAL_XC_DIP_Init(void *pInstance, SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        //[15]intlac. src;[12:8]422to420 ratio;[6]dwin_en;[5:4]format(rgb888);[3]intlac_w;[2:0]frm_buf_num
        DIP_W2BYTE(0, REG_SC_BK36_01_L,0x0840);
        // [10]pdw_off;[9:8] reg_dip_pdw_src_sel;[7:0]alpha
        DIP_W2BYTE(0, REG_SC_BK36_02_L,0x0400);
        //[8] write once; [9] write once trig
        if(HAL_XC_DIP_GetBusSize(pInstance,eWindow) == DIP_BYTE_PER_WORD)
            DIP_W2BYTE(0, REG_SC_BK36_03_L,0x0000);
        else
            DIP_W2BYTE(0, REG_SC_BK36_03_L,0x0800);
        //When dip overstep memory next to dip,dip won't stop telling this wrong state with continuous interrupt.
        //The continuous interrupt will cause the high cpu possesion.
        //So we mask the related bit to ignore the wrong state.
        //Function HAL_XC_MIU_Protect will protect the memory next to dip being overstepped by dip in case "MIU_PROTECT == 1".
        DIP_W2BYTEMSK(0, REG_SC_BK36_04_L, BIT(4),BIT(4));
        //clear mirror state
        DIP_W2BYTEMSK(0, REG_SC_BK36_0B_L, 0 ,BIT(9));
        DIP_W2BYTEMSK(0, REG_SC_BK36_0B_L, 0 ,BIT(10));
        //[15:8]wreq max ; [7:0]wreq threshold
        DIP_W2BYTE(0, REG_SC_BK36_6F_L,0x200A);
        //tile request number
        DIP_W2BYTE(0, REG_SC_BK36_7E_L,0x0010);
        //Double buffer enable
        DIP_W2BYTEMSK(0, REG_SC_BK34_7E_L,BIT(0),BIT(0));
        DIP_W2BYTEMSK(0, REG_SC_BK36_7F_L,BIT(7),BIT(7));
        //enable dip clk
        MDrv_DIP_WriteRegBit(REG_CKG_IDCLK3, DISABLE, CKG_IDCLK3_INVERT);                   // Not Invert
        MDrv_DIP_WriteRegBit(REG_CKG_IDCLK3, DISABLE, CKG_IDCLK3_GATED);                    // Enable clock

        //enable OSD blending
        DIP_W2BYTEMSK(0, REG_SC_BK34_10_L, BIT(0) ,BIT(0));

        //TEE clip
        DIP_W2BYTEMSK(0, REG_SC_BK34_0F_L,0x1000,BMASK(12:0));
        DIP_W2BYTEMSK(0, REG_SC_BK34_2F_L,0x1000,BMASK(12:0));

        DIP_W2BYTEMSK(0, REG_SC_BK36_38_L,0xff, BMASK(7:0));
        DIP_W2BYTEMSK(0, REG_SC_BK36_48_L,0xff, BMASK(7:0));

#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK34_7E_L, BMASK(7:4) , BMASK(7:4));
#endif
        bDipUVSwap = FALSE;
        bDipYCSwap = FALSE;
        bDipR2Y = FALSE;
        bDipHMirror = FALSE;
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        //[15]intlac. src;[12:8]422to420 ratio;[6]dwin_en;[5:4]format(rgb888);[3]intlac_w;[2:0]frm_buf_num
        DIP_W2BYTE(0, REG_SC_BK3B_01_L,0x0840);
        // [10]pdw_off;[9:8] reg_dip_pdw_src_sel;[7:0]alpha
        DIP_W2BYTE(0, REG_SC_BK3B_02_L,0x0400);
        //[8] write once; [9] write once trig[11]256mode
        if(HAL_XC_DIP_GetBusSize(pInstance,eWindow) == DIP_BYTE_PER_WORD)
            DIP_W2BYTE(0, REG_SC_BK3B_03_L,0x0000);
        else
            DIP_W2BYTE(0, REG_SC_BK3B_03_L,0x0800);
        //When dip overstep memory next to dip,dip won't stop telling this wrong state with continuous interrupt.
        //The continuous interrupt will cause the high cpu possesion.
        //So we mask the related bit to ignore the wrong state.
        //Function HAL_XC_MIU_Protect will protect the memory next to dip being overstepped by dip in case "MIU_PROTECT == 1".
        DIP_W2BYTEMSK(0, REG_SC_BK3B_04_L, BIT(4),BIT(4));
        //clear mirror state
        DIP_W2BYTEMSK(0, REG_SC_BK3B_0B_L, 0 ,BIT(9));
        DIP_W2BYTEMSK(0, REG_SC_BK3B_0B_L, 0 ,BIT(10));
        //[15:8]wreq max ; [7:0]wreq threshold
        DIP_W2BYTE(0, REG_SC_BK3B_6F_L,0x200A);
        //tile request number
        DIP_W2BYTE(0, REG_SC_BK3B_7E_L,0x0010);
        DIP_W2BYTEMSK(0, REG_SC_BK3B_72_L,BIT(0),BIT(0));
        //Disable source rgb swap
        DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L,0,BIT(7));
        //set OP capture E_XC_DIP_VOP2/E_XC_DIP_OP2
        DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L, 2<<4, BMASK(5:4));
        //enable dwin0 clk
        MDrv_DIP_WriteRegBit(REG_CKG_PDW0, DISABLE, CKG_PDW0_INVERT);                   // Not Invert
        MDrv_DIP_WriteRegBit(REG_CKG_PDW0, DISABLE, CKG_PDW0_GATED);                    // Enable clock

        //TEE clip
        DIP_W2BYTEMSK(0, REG_SC_BK3B_0D_L,0x1000,BMASK(12:0));
        DIP_W2BYTEMSK(0, REG_SC_BK3B_1E_L,0x1000,BMASK(12:0));

#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L, BMASK(3:0) , BMASK(3:0));
#endif
        HAL_XC_DIP_SetDIMode(pInstance,FALSE,eWindow);
        HAL_XC_DIP_SetPDNRMode(pInstance,FALSE,eWindow);
        bDWIN0UVSwap = FALSE;
        bDWIN0YCSwap = FALSE;
        bDwin0R2Y = FALSE;
        bDWIN0HMirror = FALSE;
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        //[15]intlac. src;[12:8]422to420 ratio;[6]dwin_en;[5:4]format(rgb888);[3]intlac_w;[2:0]frm_buf_num
        DIP_W2BYTE(0, REG_SC_BK3C_01_L,0x0840);
        // [10]pdw_off;[9:8] reg_dip_pdw_src_sel;[7:0]alpha
        DIP_W2BYTE(0, REG_SC_BK3C_02_L,0x0400);
        //[8] write once; [9] write once trig[11]256mode
        if(HAL_XC_DIP_GetBusSize(pInstance,eWindow) == DIP_BYTE_PER_WORD)
            DIP_W2BYTE(0, REG_SC_BK3C_03_L,0x0000);
        else
            DIP_W2BYTE(0, REG_SC_BK3C_03_L,0x0800);
        //When dip overstep memory next to dip,dip won't stop telling this wrong state with continuous interrupt.
        //The continuous interrupt will cause the high cpu possesion.
        //So we mask the related bit to ignore the wrong state.
        //Function HAL_XC_MIU_Protect will protect the memory next to dip being overstepped by dip in case "MIU_PROTECT == 1".
        DIP_W2BYTEMSK(0, REG_SC_BK3C_04_L, BIT(4),BIT(4));
        //clear mirror state
        DIP_W2BYTEMSK(0, REG_SC_BK3C_0B_L, 0 ,BIT(9));
        DIP_W2BYTEMSK(0, REG_SC_BK3C_0B_L, 0 ,BIT(10));
        //[15:8]wreq max ; [7:0]wreq threshold
        DIP_W2BYTE(0, REG_SC_BK3C_6F_L,0x200A);
        //tile request number
        DIP_W2BYTE(0, REG_SC_BK3C_7E_L,0x0010);
        DIP_W2BYTEMSK(0, REG_SC_BK3C_72_L,BIT(0),BIT(0));
        //Disable source rgb swap
        DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L,0,BIT(7));
        //set OP capture E_XC_DIP_VOP2/E_XC_DIP_OP2
        DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L, 2<<4, BMASK(5:4));
        //enable dwin1 clk
        MDrv_DIP_WriteRegBit(REG_CKG_PDW1, DISABLE, CKG_PDW1_INVERT);                   // Not Invert
        MDrv_DIP_WriteRegBit(REG_CKG_PDW1, DISABLE, CKG_PDW1_GATED);                    // Enable clock

        //TEE clip
        DIP_W2BYTEMSK(0, REG_SC_BK3B_0D_L,0x1000,BMASK(12:0));
        DIP_W2BYTEMSK(0, REG_SC_BK3B_1E_L,0x1000,BMASK(12:0));

#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L, BMASK(3:0) , BMASK(3:0));
#endif

    }

    HAL_XC_DIP_SetOutputCapture(pInstance,TRUE,E_XC_DIP_VOP2,eWindow);

    DIP_W2BYTEMSK(0, REG_SC_BK36_1C_L, 0 ,BIT(14));

    //force OP1 ACK 1
    //DIP_W2BYTEMSK(0, REG_SC_BK34_7F_L,BIT(1),BIT(1));
    //for DIP R
    //read request maximum length and 2ªº­¿¼?, tile 420 used
    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_10,0x400F,BMASK(15:0));
    //read request threshold
    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_11,0xA,BMASK(5:0));
    //reg_dipr_tile_req_num_evd
    DIP_W2BYTEMSK(0, REG_SC_BK36_1C_L,0x7,BMASK(4:0));

    //output capture setting
    DIP_W2BYTEMSK(0, REG_SC_BK10_23_L, BIT(4), BIT(4));  // Set to no osd for DIP select
    DIP_W2BYTEMSK(0, REG_SC_BK10_23_L, E_XC_DIP_VOP2<<12, BMASK(13:12));
    DIP_W2BYTEMSK(0, REG_SC_BK10_50_L, BIT(14), BMASK(14:13));

    DIP_W2BYTEMSK(0, REG_SC_BK10_50_L, BIT(12), BIT(12));  // Set to with osd for DIP select
    DIP_W2BYTEMSK(0, REG_SC_BK10_50_L, E_XC_DIP_OP2<<8, BMASK(9:8));
    DIP_W2BYTEMSK(0, REG_SC_BK10_6B_L, BIT(13), BMASK(13:12));

    //recv2dip_cap_en_main
    DIP_W2BYTEMSK(0, REG_SC_BK4A_05_L, BIT(1), BIT(1));
    //recv2dip_cap_en_sub
    DIP_W2BYTEMSK(0, REG_SC_BK4A_04_L, BIT(1), BIT(1));

    //Sc2 op capture enable:
    DIP_W2BYTEMSK(0, REG_SC_BK90_50_L, BIT(12), BIT(12));
    //Sc2 op capture stage 0: before osdb 1: after osdb
    DIP_W2BYTEMSK(0, REG_SC_BK90_50_L, E_XC_DIP_OP2<<8, BMASK(9:8));// Set to with osd for DIP select
    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_35,BMASK(15:8),BMASK(15:8)); //dipr start interrupt mask

    memset(&_gstHDMIInfo[eWindow],0,sizeof(ST_DRV_DIP_HDMI_INFO));
}

void HAL_XC_DIP_EnableCaptureStream(void *pInstance, MS_BOOL bEnable,SCALER_DIP_WIN eWindow)
{
    MS_U16 u16IntrStus = 0;
    MS_XC_DIP_SOURCE_TYPE eHalSource;
    SCALER_DIP_SOURCE_TYPE eWindowSource = SCALER_DIP_SOURCE_TYPE_MAIN;

    if( eWindow == DIP_WINDOW )
    {
        eWindowSource = DipSource;
#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK34_7E_L, 0 , BMASK(7:4));
#endif
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        eWindowSource = Dwin0Source;
#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L, 0 , BMASK(3:0));
#endif
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        eWindowSource = Dwin1Source;
#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L, 0 , BMASK(3:0));
#endif
    }

    switch(eWindowSource)
    {
        case SCALER_DIP_SOURCE_TYPE_DRAM:
        case SCALER_DIP_SOURCE_TYPE_SUB2 :
        case SCALER_DIP_SOURCE_TYPE_OP_CAPTURE:
        case SCALER_DIP_SOURCE_TYPE_SC2_OP_CAPTURE:
        case SCALER_DIP_SOURCE_TYPE_OSD:
        case SCALER_DIP_SOURCE_TYPE_HDMI:
        case SCALER_DIP_SOURCE_TYPE_MVOP1:
        case SCALER_DIP_SOURCE_TYPE_VD:
        case SCALER_DIP_SOURCE_TYPE_COMPONENT:
            eHalSource = E_XC_DIP_SOURCE_TYPE_SUB2;
            break;
        case SCALER_DIP_SOURCE_TYPE_MAIN :
            eHalSource = E_XC_DIP_SOURCE_TYPE_MAIN;
            break;
        case SCALER_DIP_SOURCE_TYPE_SUB :
            eHalSource = E_XC_DIP_SOURCE_TYPE_MAIN;
            break;
        case SCALER_DIP_SOURCE_TYPE_OP_MAIN:
        case SCALER_DIP_SOURCE_TYPE_OP_SUB:
            eHalSource = E_XC_DIP_SOURCE_TYPE_OP;
            break;
        default:
            DIP_H_ERR("SCALER_DIP_SOURCE_TYPE does not support\n");
            return;
    }


    if(bEnable == TRUE)
    {
        //Control DIPR
        if(eWindowSource == SCALER_DIP_SOURCE_TYPE_DRAM)
        {
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(14),BIT(14));
        }
        else if( (eWindowSource == SCALER_DIP_SOURCE_TYPE_OP_MAIN) || (eWindowSource == SCALER_DIP_SOURCE_TYPE_OP_SUB) )
        {
            if( eWindow == DIP_WINDOW )
            {
                DIP_W2BYTEMSK(0, REG_SC_BK34_7C_L,((eWindowSource == SCALER_DIP_SOURCE_TYPE_OP_SUB)?BIT(15):0),BIT(15));
            }
            else if( eWindow == DWIN0_WINDOW )
            {
                DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L, ((eWindowSource == SCALER_DIP_SOURCE_TYPE_OP_SUB)?BIT(6):0),BIT(6));
            }
            else if( eWindow == DWIN1_WINDOW )
            {
                DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L, ((eWindowSource == SCALER_DIP_SOURCE_TYPE_OP_SUB)?BIT(6):0),BIT(6));
            }
        }
        //new rotation enabel
        DIP_W2BYTEMSK(0, REG_SC_BK34_6E_L,bDIPRotation?BIT(11):0,BIT(11));
        //Enable last
        if( eWindow == DIP_WINDOW )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, BITS(9:8,eHalSource),BMASK(10:8));
        }
        else if( eWindow == DWIN0_WINDOW )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, BITS(9:8,eHalSource),BMASK(10:8));
        }
        else if( eWindow == DWIN1_WINDOW )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, BITS(9:8,eHalSource),BMASK(10:8));
        }
    }
    else
    {
		//new rotation disable
        DIP_W2BYTEMSK(0, REG_SC_BK34_6E_L,0,BIT(11));
        //Disable first
        if( eWindow == DIP_WINDOW )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, BIT(10), BMASK(10:8));
            //disable write once
            DIP_W2BYTEMSK(0, REG_SC_BK36_03_L, 0, BIT(8));
        }
        else if( eWindow == DWIN0_WINDOW )
        {
            HAL_XC_DIP_SetDIMode(pInstance,FALSE,eWindow);
            HAL_XC_DIP_SetPDNRMode(pInstance,FALSE,eWindow);
            DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, BIT(10), BMASK(10:8));
            //disable write once
            DIP_W2BYTEMSK(0, REG_SC_BK3B_03_L, 0, BIT(8));
        }
        else if( eWindow == DWIN1_WINDOW )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, BIT(10), BMASK(10:8));
            //disable write once
            DIP_W2BYTEMSK(0, REG_SC_BK3C_03_L, 0, BIT(8));
        }

        if(eWindowSource == SCALER_DIP_SOURCE_TYPE_DRAM)
        {
            //Dipr disable
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,0x0,BIT(14));
        }
    }


    if (!bEnable)
    {
        //Auto clear status to zero
        u16IntrStus = HAL_XC_DIP_GetIntrStatus(pInstance, eWindow);
        HAL_XC_DIP_ClearIntr(pInstance, u16IntrStus,eWindow);
        HAL_XC_DIP_SWReset(pInstance, eWindow);
    }
}
void HAL_XC_DIP_EnableIntr(void *pInstance, MS_U16 u8mask, MS_BOOL bEnable,SCALER_DIP_WIN eWindow)
{
    MS_U16 regval =0;

    if( eWindow == DIP_WINDOW )
    {
        regval = DIP_R2BYTE(0, REG_SC_BK36_08_L,eWindow);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        regval = DIP_R2BYTE(0, REG_SC_BK3B_08_L,eWindow);
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        regval = DIP_R2BYTE(0, REG_SC_BK3C_08_L,eWindow);
    }

    if(bEnable)
        regval &= ~u8mask;
    else
        regval |= u8mask;

    DIP_W2BYTEMSK(0, REG_SC_BK36_08_L, regval, BMASK(7:0));
}
void HAL_XC_DIP_ClearIntr(void *pInstance, MS_U16 u16mask,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        SC_W2BYTEMSK(0, REG_SC_BK36_09_L,u16mask&BMASK(7:0), BMASK(7:0));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        SC_W2BYTEMSK(0, REG_SC_BK3B_09_L,u16mask&BMASK(7:0), BMASK(7:0));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        SC_W2BYTEMSK(0, REG_SC_BK3C_09_L,u16mask&BMASK(7:0), BMASK(7:0));
    }
    else
    {
        return;
    }

}
MS_U16 HAL_XC_DIP_GetIntrStatus(void *pInstance, SCALER_DIP_WIN eWindow)
{
    MS_U16 u16IntrStus = 0;
    if( eWindow == DIP_WINDOW )
    {
        if(cmdq_wait_value != cmdq_ready_value)
        {
           cmdq_wait_value = MDrv_DIP_Read2Byte(g_u32Wait_Reg[eWindow]);
#if 0
            MS_U32 timer1,timer2;

            timer1 = MsOS_GetSystemTime();
            timer2 = MsOS_GetSystemTime();
            while( (cmdq_wait_value != cmdq_ready_value) && ((timer2 - timer1)<100))
            {
                cmdq_wait_value = MDrv_DIP_Read2Byte(g_u32Wait_Reg[eWindow]);
                MsOS_DelayTask(1);
                timer2 = MsOS_GetSystemTime();
            }

            if(cmdq_wait_value != cmdq_ready_value)
            {
                DIP_H_ERR("\33[0;36m   %s:%d  timeout = %ld org = %d target = %d\33[m \n",__FUNCTION__,__LINE__,(timer2 - timer1),cmdq_wait_value,cmdq_ready_value);
            }
#endif
            if (cmdq_wait_value == cmdq_ready_value)
            {
                u16IntrStus = SC_R2BYTEMSK(0, REG_SC_BK36_0A_L,BMASK(7:0));
            }
        }
        else
        {
           u16IntrStus = SC_R2BYTEMSK(0, REG_SC_BK36_0A_L,BMASK(7:0));
        }
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        u16IntrStus = SC_R2BYTEMSK(0, REG_SC_BK3B_0A_L,BMASK(7:0));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        u16IntrStus = SC_R2BYTEMSK(0, REG_SC_BK3C_0A_L,BMASK(7:0));
    }

#if (LOG_EXECUTE_TIME == TRUE)
    if(u16IntrStus != 0)
    {
        u32EndTime = MsOS_GetSystemTime();
        DIP_H_ERR("[%s,%d]Interval Time = %d, u32EndTime = %d, u32StartTime = %d\n",__func__,__LINE__,(u32EndTime-u32StartTime),u32EndTime,u32StartTime);
    }
#endif

    return u16IntrStus;
}
void HAL_XC_DIP_CpatureOneFrame(void *pInstance, SCALER_DIP_WIN eWindow)//MS_BOOL benable, SCALER_DIP_WIN eWindow)
{
    MS_U16 regval = 0;
    MS_U16 u16Count = 0;

    HAL_XC_DIP_CpatureOneFrame2(pInstance, eWindow);

    do{
        regval = HAL_XC_DIP_GetIntrStatus(pInstance, eWindow);
        if(regval > 0x0)
        break;
        u16Count++;
        MsOS_DelayTask(1);
    }while(u16Count < DWIN_CAPTURE_TIMEOUT_CNT);
    //if(u16Count >= DWIN_CAPTURE_TIMEOUT_CNT)
    //    DIP_H_ERR("!!!Alert !!! DWIN Capture, wait ack time out!\n");

}
void HAL_XC_DIP_CpatureOneFrame2(void *pInstance, SCALER_DIP_WIN eWindow)//MS_BOOL benable, SCALER_DIP_WIN eWindow)
{
    MS_XC_DIP_SOURCE_TYPE eHalSource;
    SCALER_DIP_SOURCE_TYPE eWindowSource = SCALER_DIP_SOURCE_TYPE_MAIN;

    if( eWindow == DIP_WINDOW )
    {
        eWindowSource = DipSource;
#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK34_7E_L, 0 , BMASK(7:4));
#endif
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        eWindowSource = Dwin0Source;
#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L, 0 , BMASK(3:0));
#endif
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        eWindowSource = Dwin1Source;
#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L, 0 , BMASK(3:0));
#endif
    }

    switch(eWindowSource)
    {
        case SCALER_DIP_SOURCE_TYPE_DRAM:
        case SCALER_DIP_SOURCE_TYPE_SUB2 :
        case SCALER_DIP_SOURCE_TYPE_OP_CAPTURE:
        case SCALER_DIP_SOURCE_TYPE_SC2_OP_CAPTURE:
        case SCALER_DIP_SOURCE_TYPE_OSD:
        case SCALER_DIP_SOURCE_TYPE_HDMI:
        case SCALER_DIP_SOURCE_TYPE_MVOP1:
        case SCALER_DIP_SOURCE_TYPE_VD:
        case SCALER_DIP_SOURCE_TYPE_COMPONENT:
            eHalSource = E_XC_DIP_SOURCE_TYPE_SUB2;
            break;
        case SCALER_DIP_SOURCE_TYPE_MAIN :
            eHalSource = E_XC_DIP_SOURCE_TYPE_MAIN;
            break;
        case SCALER_DIP_SOURCE_TYPE_SUB :
            eHalSource = E_XC_DIP_SOURCE_TYPE_MAIN;
            break;
        case SCALER_DIP_SOURCE_TYPE_OP_MAIN:
        case SCALER_DIP_SOURCE_TYPE_OP_SUB:
            eHalSource = E_XC_DIP_SOURCE_TYPE_OP;
            break;
        default:
            DIP_H_ERR("SCALER_DIP_SOURCE_TYPE does not support\n");
            return;
    }


    //Control OP1 Bank and DIPR
    if(eWindowSource == SCALER_DIP_SOURCE_TYPE_DRAM)
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(14), BIT(14));
    }
    else if( (eWindowSource == SCALER_DIP_SOURCE_TYPE_OP_MAIN) || (eWindowSource == SCALER_DIP_SOURCE_TYPE_OP_SUB) )
    {
        if( eWindow == DIP_WINDOW )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK34_7C_L,((eWindowSource == SCALER_DIP_SOURCE_TYPE_OP_SUB)?BIT(15):0),BIT(15));
        }
        else if( eWindow == DWIN0_WINDOW )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L, ((eWindowSource == SCALER_DIP_SOURCE_TYPE_OP_SUB)?BIT(6):0),BIT(6));
        }
        else if( eWindow == DWIN1_WINDOW )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L, ((eWindowSource == SCALER_DIP_SOURCE_TYPE_OP_SUB)?BIT(6):0),BIT(6));
        }
    }

	//new rotation enabel
    DIP_W2BYTEMSK(0, REG_SC_BK34_6E_L,bDIPRotation?BIT(11):0,BIT(11));
    //Enable last
    if( eWindow == DIP_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, BITS(9:8,eHalSource),BMASK(10:8));
        if(DipSource == SCALER_DIP_SOURCE_TYPE_DRAM)
        {
#if (DIPR_READ_YUV444_PATCH == 1)
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_1B,BIT(7),BIT(7));//DIPR sw reset
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_1B,0,BIT(7));
#endif
            //Dipr trigger
#if (LOG_EXECUTE_TIME == TRUE)
            u32StartTime = MsOS_GetSystemTime();
#endif
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(15),BIT(15));
        }
        else
        {
            // Set the dwin write once   (0x03 bit:8)
            DIP_W2BYTEMSK(0, REG_SC_BK36_03_L, BIT(8),BIT(8));
            //trigger
            DIP_W2BYTEMSK(0, REG_SC_BK36_03_L, BIT(9),BIT(9));
        }
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, BITS(9:8,eHalSource),BMASK(10:8));
        if(Dwin0Source == SCALER_DIP_SOURCE_TYPE_DRAM)
        {
#if (DIPR_READ_YUV444_PATCH == 1)
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_1B,BIT(7),BIT(7));//DIPR sw reset
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_1B,0,BIT(7));
#endif
            //Dipr trigger
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(15),BIT(15));
        }
        else
        {
            // Set the dwin write once   (0x03 bit:8)
            DIP_W2BYTEMSK(0, REG_SC_BK3B_03_L, BIT(8), BIT(8));
            //trigger
            DIP_W2BYTEMSK(0, REG_SC_BK3B_03_L, BIT(9), BIT(9));
        }
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, BITS(9:8,eHalSource),BMASK(10:8));
        if(Dwin1Source == SCALER_DIP_SOURCE_TYPE_DRAM)
        {
            //Dipr trigger
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(15),BIT(15));
        }
        else
        {
            // Set the dwin write once   (0x03 bit:8)
            DIP_W2BYTEMSK(0, REG_SC_BK3C_03_L, BIT(8), BIT(8));
            //trigger
            DIP_W2BYTEMSK(0, REG_SC_BK3C_03_L, BIT(9), BIT(9));
        }
    }

    DIP_WAIT();
    DIP_W2BYTEMSK(0, REG_SC_BK36_29_L, BMASK(7:0), BMASK(7:0));

}
void HAL_XC_DIP_SelectSourceScanType(void *pInstance, EN_XC_DWIN_SCAN_TYPE enScan,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        if((enScan == GOPDWIN_SCAN_MODE_AUTO) || (enScan == GOPDWIN_SCAN_MODE_PROGRESSIVE))
        {
            SC_W2BYTEMSK(0, REG_SC_BK36_01_L,0, BIT(15));
        }
        else
        {
            SC_W2BYTEMSK(0, REG_SC_BK36_01_L,BIT(15), BIT(15));
        }
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        if((enScan == GOPDWIN_SCAN_MODE_AUTO) || (enScan == GOPDWIN_SCAN_MODE_PROGRESSIVE))
        {
            SC_W2BYTEMSK(0, REG_SC_BK3B_01_L,0, BIT(15));
        }
        else
        {
            SC_W2BYTEMSK(0, REG_SC_BK3B_01_L,BIT(15), BIT(15));
        }
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        if((enScan == GOPDWIN_SCAN_MODE_AUTO) || (enScan == GOPDWIN_SCAN_MODE_PROGRESSIVE))
        {
            SC_W2BYTEMSK(0, REG_SC_BK3C_01_L,0, BIT(15));
        }
        else
        {
            SC_W2BYTEMSK(0, REG_SC_BK3C_01_L,BIT(15), BIT(15));
        }
    }
    else
    {
        return;
    }
}
EN_XC_DWIN_SCAN_TYPE HAL_XC_DIP_GetSourceScanType(void *pInstance, SCALER_DIP_WIN eWindow)
{
    EN_XC_DWIN_SCAN_TYPE eSacnType = GOPDWIN_SCAN_MODE_MAX;
    if( eWindow == DIP_WINDOW )
    {
        eSacnType = (EN_XC_DWIN_SCAN_TYPE)(DIP_R2BYTEMSK(0, REG_SC_BK36_01_L,BIT(15),eWindow)>>15);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        eSacnType = (EN_XC_DWIN_SCAN_TYPE)(DIP_R2BYTEMSK(0, REG_SC_BK3B_01_L,BIT(15),eWindow)>>15);
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        eSacnType = (EN_XC_DWIN_SCAN_TYPE)(DIP_R2BYTEMSK(0, REG_SC_BK3C_01_L,BIT(15),eWindow)>>15);
    }

    return eSacnType;
}
void HAL_XC_DIP_SetInterlaceWrite(void *pInstance, MS_BOOL bEnable,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_01_L, (bEnable?BIT(3):0) ,BIT(3));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3B_01_L, (bEnable?BIT(3):0) ,BIT(3));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3C_01_L, (bEnable?BIT(3):0) ,BIT(3));
    }
    else
    {
        return;
    }
}
MS_BOOL HAL_XC_DIP_GetInterlaceWrite(void *pInstance, SCALER_DIP_WIN eWindow)
{
    MS_BOOL bInterW = FALSE;
    if( eWindow == DIP_WINDOW )
    {
        bInterW = (MS_BOOL)(DIP_R2BYTEMSK(0, REG_SC_BK36_01_L,BIT(3),eWindow)>>3);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        bInterW = (MS_BOOL)(DIP_R2BYTEMSK(0, REG_SC_BK3B_01_L,BIT(3),eWindow)>>3);
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        bInterW = (MS_BOOL)(DIP_R2BYTEMSK(0, REG_SC_BK3C_01_L,BIT(3),eWindow)>>3);
    }

    return bInterW;
}
void HAL_XC_DIP_SetDataFmt(void *pInstance, EN_DRV_XC_DWIN_DATA_FMT fmt,SCALER_DIP_WIN eWindow)
{
    MS_U16 u16Fmt = 0x0;

    switch (fmt)
    {
        case XC_DWIN_DATA_FMT_YUV422 :
        case XC_DWIN_DATA_FMT_YC422 :
            u16Fmt = 0;
            break;
        case XC_DWIN_DATA_FMT_RGB565 :
            u16Fmt = 1;
            break;
        case XC_DWIN_DATA_FMT_YUV444_24BITS :
        case XC_DWIN_DATA_FMT_ARGB8888 :
            u16Fmt = 2;
            break;
        case XC_DWIN_DATA_FMT_YUV420 :
        case XC_DWIN_DATA_FMT_YUV420_H265 :
        case XC_DWIN_DATA_FMT_YUV420_H265_10BITS:
        case XC_DWIN_DATA_FMT_YUV420_PLANER:
        case XC_DWIN_DATA_FMT_YUV420_SEMI_PLANER:
            u16Fmt = 3;
            break;
        default :
            u16Fmt = 0x0;
            break;
    }
    if( eWindow == DIP_WINDOW )
    {
        DipFmt = fmt;
        //set fmt
        DIP_W2BYTEMSK(0, REG_SC_BK36_01_L, BITS(5:4,u16Fmt),BMASK(5:4));
        //select yc separate
        DIP_W2BYTEMSK(0, REG_SC_BK36_03_L,((fmt == XC_DWIN_DATA_FMT_YC422)?BIT(6):0),BIT(6));
        //select de-tile for 420 semi planer
        DIP_W2BYTEMSK(0, REG_SC_BK36_03_L,((fmt == XC_DWIN_DATA_FMT_YUV420_SEMI_PLANER)?BIT(14):0),BIT(14));
        //select flash mode for 420 planer
        DIP_W2BYTEMSK(0, REG_SC_BK36_7E_L,((fmt == XC_DWIN_DATA_FMT_YUV420_PLANER)?BIT(14):0),BIT(14));

        if( (fmt == XC_DWIN_DATA_FMT_RGB565) || (fmt == XC_DWIN_DATA_FMT_ARGB8888) || (fmt == XC_DWIN_DATA_FMT_YUV444_24BITS))
        {
            //disable yc swap setting
            DIP_W2BYTEMSK(0, REG_SC_BK36_02_L,0,BMASK(15:14));
            //disable 444 to 422
            DIP_W2BYTEMSK(0, REG_SC_BK34_30_L,0,BIT(0));
        }
        else
        {
            //disable rgb swap setting
            DIP_W2BYTEMSK(0, REG_SC_BK36_7E_L,0,BIT(13));
            //enable 444 to 422
            DIP_W2BYTEMSK(0, REG_SC_BK34_30_L, BIT(0),BIT(0));
            //YC swap
            if(fmt == XC_DWIN_DATA_FMT_YUV422)
            {
                DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, BIT(15),BIT(15));
            }
            else
            {
                DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, 0,BIT(15));
            }
        }
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        Dwin0Fmt = fmt;
        //set fmt
        DIP_W2BYTEMSK(0, REG_SC_BK3B_01_L, BITS(5:4,u16Fmt),BMASK(5:4));
        //select yc separate
        DIP_W2BYTEMSK(0, REG_SC_BK3B_03_L,((fmt == XC_DWIN_DATA_FMT_YC422)?BIT(6):0),BIT(6));
        //select de-tile for 420 semi planer
        DIP_W2BYTEMSK(0, REG_SC_BK3B_03_L,((fmt == XC_DWIN_DATA_FMT_YUV420_SEMI_PLANER)?BIT(14):0),BIT(14));
        //select flash mode for 420 planer
        DIP_W2BYTEMSK(0, REG_SC_BK3B_7E_L,((fmt == XC_DWIN_DATA_FMT_YUV420_PLANER)?BIT(14):0),BIT(14));

        if( (fmt == XC_DWIN_DATA_FMT_RGB565) || (fmt == XC_DWIN_DATA_FMT_ARGB8888) || (fmt == XC_DWIN_DATA_FMT_YUV444_24BITS))
        {
            //disable yc swap setting
            DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L,0,BMASK(15:14));
            //disable 444 to 422
            DIP_W2BYTEMSK(0, REG_SC_BK3B_44_L,0,BIT(0));
        }
        else
        {
            //disable rgb swap setting
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7E_L,0,BIT(13));
            //enable 444 to 422
            DIP_W2BYTEMSK(0, REG_SC_BK3B_44_L, BIT(0),BIT(0));
            if(fmt == XC_DWIN_DATA_FMT_YUV422)
            {
                DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, BIT(15),BIT(15));
            }
            else
            {
                DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, 0,BIT(15));
            }
        }
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        Dwin1Fmt = fmt;
        //set fmt
        DIP_W2BYTEMSK(0, REG_SC_BK3C_01_L, BITS(5:4,u16Fmt),BMASK(5:4));
        //select yc separate
        DIP_W2BYTEMSK(0, REG_SC_BK3C_03_L,((fmt == XC_DWIN_DATA_FMT_YC422)?BIT(6):0),BIT(6));
        //select de-tile for 420 semi planer
        DIP_W2BYTEMSK(0, REG_SC_BK3C_03_L,((fmt == XC_DWIN_DATA_FMT_YUV420_SEMI_PLANER)?BIT(14):0),BIT(14));
        //select flash mode for 420 planer
        DIP_W2BYTEMSK(0, REG_SC_BK3C_7E_L,((fmt == XC_DWIN_DATA_FMT_YUV420_PLANER)?BIT(14):0),BIT(14));

        if( (fmt == XC_DWIN_DATA_FMT_RGB565) || (fmt == XC_DWIN_DATA_FMT_ARGB8888) )
        {
            //disable yc swap setting
            DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L,0,BMASK(15:14));
            //disable 444 to 422
            DIP_W2BYTEMSK(0, REG_SC_BK3C_44_L,0,BIT(5)|BIT(0));
        }
        else
        {
            //disable rgb swap setting
            DIP_W2BYTEMSK(0, REG_SC_BK3C_7E_L,0,BIT(13));
            //enable 444 to 422
            DIP_W2BYTEMSK(0, REG_SC_BK3C_44_L, (BIT(5)|BIT(0)),(BIT(5)|BIT(0)));
        }
    }
    else
    {
        return;
    }
}
EN_DRV_XC_DWIN_DATA_FMT HAL_XC_DIP_GetDataFmt(void *pInstance, SCALER_DIP_WIN eWindow)
{
    EN_DRV_XC_DWIN_DATA_FMT eFmt = XC_DWIN_DATA_FMT_MAX;
    if( eWindow == DIP_WINDOW )
    {
        return DipFmt;
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        return Dwin0Fmt;
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        return Dwin1Fmt;
    }

    return eFmt;
}
MS_U16 HAL_XC_DIP_GetBPP(void *pInstance, EN_DRV_XC_DWIN_DATA_FMT fbFmt,SCALER_DIP_WIN eWindow)
{
    MS_U16 bpp=0;

    switch ( fbFmt )
    {
        case XC_DWIN_DATA_FMT_YUV422 :
        case XC_DWIN_DATA_FMT_YC422  :
        case XC_DWIN_DATA_FMT_RGB565 :
            bpp = 2;
            break;
        case XC_DWIN_DATA_FMT_ARGB8888 :
            bpp = 4;
            break;
        case XC_DWIN_DATA_FMT_YUV420 :
        case XC_DWIN_DATA_FMT_YUV420_H265 :
        case XC_DWIN_DATA_FMT_YUV420_H265_10BITS :
        case XC_DWIN_DATA_FMT_YUV420_PLANER :
        case XC_DWIN_DATA_FMT_YUV420_SEMI_PLANER :
            bpp = 1;
            break;
        default :
            bpp = 0xFF;
            break;
    }
    return bpp;
}
MS_U16 HAL_XC_DIP_WidthAlignCheck(void *pInstance, MS_U16 u16Width,MS_U16 u16Bpp,SCALER_DIP_WIN eWindow)
{
    MS_U16 AlignFactor;
    MS_U16 u16BusSize = 0;

    u16BusSize = HAL_XC_DIP_GetBusSize(pInstance, eWindow);
    AlignFactor = u16BusSize;
    return (u16Width + AlignFactor-1) & (~(AlignFactor-1));
}

void HAL_XC_DIP_SetMux(void *pInstance, MS_U8 u8Data_Mux, MS_U8 u8Clk_Mux,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        MDrv_DIP_WriteByteMask(REG_IPMUX_02_L, u8Data_Mux << 4, 0xF0);
        MDrv_DIP_WriteByteMask(REG_CKG_DIP, u8Clk_Mux, CKG_DIP_CLK_MASK);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK34_7E_L,u8Data_Mux << 8,BMASK(11:8));
        MDrv_DIP_WriteByteMask(REG_CKG_DWIN0, u8Clk_Mux, CKG_DWIN0_CLK_MASK);
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK34_7E_L,u8Data_Mux << 12,BMASK(15:12));
        MDrv_DIP_WriteByteMask(REG_CKG_DWIN1, u8Clk_Mux, CKG_DWIN1_CLK_MASK);
    }
    else
    {
        return;
    }
}
void HAL_XC_DIP_MuxDispatch(void *pInstance, SCALER_DIP_SOURCE_TYPE eSource,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        if(eSource == SCALER_DIP_SOURCE_TYPE_MAIN)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DIP_MUX_IP_MAIN,CKG_DIP_CLK_IP_MAIN,eWindow);
            DIP_W2BYTEMSK(0, REG_SC_BK34_50_L, 0,BIT(15));
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_SUB)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DIP_MUX_IP_SUB,CKG_DIP_CLK_IP_SUB,eWindow);
            DIP_W2BYTEMSK(0, REG_SC_BK34_50_L, 0,BIT(15));
        }
        else if( (eSource == SCALER_DIP_SOURCE_TYPE_OP_MAIN) || (eSource == SCALER_DIP_SOURCE_TYPE_OP_SUB))
        {

        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_DRAM)
        {

        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_OP_CAPTURE)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DIP_MUX_OP,CKG_DIP_CLK_OP,eWindow);
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_OSD)
        {
            HAL_XC_DIP_SetMux(pInstance, SC_DWIN_IPMUX_ADC_B,SC_DWIN_IPMUX_CAPTURE<<2,eWindow);
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_HDMI)
        {
            switch(_gstHDMIInfo[eWindow].enInputSourceType)
            {
                case INPUT_SOURCE_HDMI:
                    HAL_XC_DIP_SetMux(pInstance, DIP_DIP_MUX_FS,CKG_DIP_CLK_HDMI,eWindow);
                    DIP_W2BYTEMSK(0, REG_SC_BK34_7B_L, DIP_DIP_MUX_FS_HDMI,DIP_DIP_FS_MSAK);
                    break;
                case INPUT_SOURCE_HDMI2:
                    HAL_XC_DIP_SetMux(pInstance, DIP_DIP_MUX_FS,CKG_DIP_CLK_HDMI2,eWindow);
                    DIP_W2BYTEMSK(0, REG_SC_BK34_7B_L, DIP_DIP_MUX_FS_HDMI2,DIP_DIP_FS_MSAK);
                    break;
                case INPUT_SOURCE_HDMI3:
                    HAL_XC_DIP_SetMux(pInstance, DIP_DIP_MUX_FS,CKG_DIP_CLK_HDMI3,eWindow);
                    DIP_W2BYTEMSK(0, REG_SC_BK34_7B_L, DIP_DIP_MUX_FS_HDMI3,DIP_DIP_FS_MSAK);
                    break;
                case INPUT_SOURCE_HDMI4:
                    HAL_XC_DIP_SetMux(pInstance, DIP_DIP_MUX_FS,CKG_DIP_CLK_HDMI4,eWindow);
                    DIP_W2BYTEMSK(0, REG_SC_BK34_7B_L, DIP_DIP_MUX_FS_HDMI4,DIP_DIP_FS_MSAK);
                    break;
                default:
                    break;
            }
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_COMPONENT)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DIP_MUX_FS,CKG_DIP_CLK_ADC,eWindow);
            DIP_W2BYTEMSK(0, REG_SC_BK34_7B_L, DIP_DIP_MUX_FS_COMPONENT,DIP_DIP_FS_MSAK);
        }
        else
            DIP_H_DBUG("MApi_XC_DIP_SetDIPWinProperty eSource = %d is not correct\n",eSource);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        if(eSource == SCALER_DIP_SOURCE_TYPE_SC2_OP_CAPTURE && (_gstDwin0XCInfo.bPathEnabled == TRUE))
        {
            eSource = _gstDwin0XCInfo.enDipCapSource;
        }
        if(eSource == SCALER_DIP_SOURCE_TYPE_MAIN)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DWIN0_MUX_IP_MAIN,CKG_DWIN0_CLK_IP_MAIN,eWindow);
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7A_L, 0,BIT(15));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_70_L, 0,BMASK(4:1));
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_SUB)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DWIN0_MUX_IP_SUB,CKG_DWIN0_CLK_IP_SUB,eWindow);
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7A_L, BIT(15),BIT(15));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_70_L, BIT(4)|BIT(1),BMASK(4:1));
        }
        else if( (eSource == SCALER_DIP_SOURCE_TYPE_OP_MAIN) || (eSource == SCALER_DIP_SOURCE_TYPE_OP_SUB))
        {

        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_DRAM)
        {

        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_OP_CAPTURE)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DWIN0_MUX_OP,CKG_DWIN0_CLK_OP,eWindow);
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_MVOP1)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DWIN0_MUX_MVOP_SUB, CKG_DWIN0_CLK_MVOP_SUB,eWindow);
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_HDMI)
        {
            switch(_gstHDMIInfo[eWindow].enInputSourceType)
            {
                case INPUT_SOURCE_HDMI:
                    HAL_XC_DIP_SetMux(pInstance, DIP_DWIN0_MUX_FS,CKG_DWIN0_CLK_HDMI,eWindow);
                    DIP_W2BYTEMSK(0, REG_SC_BK3B_7B_L, DIP_DWIN0_MUX_FS_HDMI,DIP_DWIN0_FS_MSAK);
                    DIP_W2BYTEMSK(0, REG_SC_BK3B_70_L, CKG_DWIN0_SEL_HDMI_CLK,CKG_DWIN0_VD_HDMI_CLK_MASK);
                    break;
                case INPUT_SOURCE_HDMI2:
                    HAL_XC_DIP_SetMux(pInstance, DIP_DWIN0_MUX_FS,CKG_DWIN0_CLK_HDMI,eWindow);
                    DIP_W2BYTEMSK(0, REG_SC_BK3B_7B_L, DIP_DWIN0_MUX_FS_HDMI2,DIP_DWIN0_FS_MSAK);
                    DIP_W2BYTEMSK(0, REG_SC_BK3B_70_L, CKG_DWIN0_SEL_HDMI2_CLK,CKG_DWIN0_VD_HDMI_CLK_MASK);
                    break;
                case INPUT_SOURCE_HDMI3:
                    HAL_XC_DIP_SetMux(pInstance, DIP_DWIN0_MUX_FS,CKG_DWIN0_CLK_HDMI,eWindow);
                    DIP_W2BYTEMSK(0, REG_SC_BK3B_7B_L, DIP_DWIN0_MUX_FS_HDMI3,DIP_DWIN0_FS_MSAK);
                    DIP_W2BYTEMSK(0, REG_SC_BK3B_70_L, CKG_DWIN0_SEL_HDMI3_CLK,CKG_DWIN0_VD_HDMI_CLK_MASK);
                    break;
                case INPUT_SOURCE_HDMI4:
                    HAL_XC_DIP_SetMux(pInstance, DIP_DWIN0_MUX_FS,CKG_DWIN0_CLK_HDMI,eWindow);
                    DIP_W2BYTEMSK(0, REG_SC_BK3B_7B_L, DIP_DWIN0_MUX_FS_HDMI4,DIP_DWIN0_FS_MSAK);
                    DIP_W2BYTEMSK(0, REG_SC_BK3B_70_L, CKG_DWIN0_SEL_HDMI4_CLK,CKG_DWIN0_VD_HDMI_CLK_MASK);
                    break;
                default:
                    break;
            }

        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_VD)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DWIN0_MUX_FS, CKG_DWIN0_CLK_HDMI,eWindow);
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7B_L, DIP_DWIN0_MUX_FS_VD,DIP_DWIN0_FS_MSAK);
            DIP_W2BYTEMSK(0, REG_SC_BK3B_70_L, CKG_DWIN0_SEL_FS_VD_CLK,CKG_DWIN0_VD_HDMI_CLK_MASK);
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_COMPONENT)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DWIN0_MUX_FS, CKG_DWIN0_CLK_HDMI,eWindow);
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7B_L, DIP_DWIN0_MUX_FS_COMPONENT,DIP_DWIN0_FS_MSAK);
            DIP_W2BYTEMSK(0, REG_SC_BK3B_70_L, CKG_DWIN0_SEL_FS_COMPONENT_CLK,CKG_DWIN0_VD_HDMI_CLK_MASK);
        }
        else
            DIP_H_DBUG("MApi_XC_DIP_SetDIPWinProperty eSource = %d is not correct\n",eSource);
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        if(eSource == SCALER_DIP_SOURCE_TYPE_MAIN)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DWIN1_MUX_IP_MAIN,CKG_DWIN1_CLK_IP_MAIN,eWindow);
            DIP_W2BYTEMSK(0, REG_SC_BK3C_7A_L, 0,BIT(15));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_70_L, 0,BMASK(4:1));
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_SUB)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DWIN1_MUX_IP_SUB,CKG_DWIN1_CLK_IP_SUB,eWindow);
            DIP_W2BYTEMSK(0, REG_SC_BK3C_7A_L, BIT(15),BIT(15));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_70_L, BIT(4)|BIT(1),BMASK(4:1));
        }
        else if( (eSource == SCALER_DIP_SOURCE_TYPE_OP_MAIN) || (eSource == SCALER_DIP_SOURCE_TYPE_OP_SUB))
        {

        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_DRAM)
        {

        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_OP_CAPTURE)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DWIN1_MUX_OP,CKG_DWIN1_CLK_OP,eWindow);
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_SC2_OP_CAPTURE)
        {
            HAL_XC_DIP_SetMux(pInstance, DIP_DWIN1_MUX_SC2_OP,CKG_DWIN1_CLK_SC2_OP,eWindow);
            DIP_W2BYTEMSK(0, REG_SC_BK20_03_L, BIT(1),BIT(1));
            DIP_W2BYTEMSK(0, REG_SC_BK20_2F_L, BIT(15),BIT(15));
        }
        else
            DIP_H_DBUG("MApi_XC_DIP_SetDIPWinProperty eSource = %d is not correct\n",eSource);
    }
    else
    {
        return;
    }
}

void HAL_XC_DIP_AdjustScaling(void *pInstance,SCALER_DIP_WIN eWindow,SCALER_DIP_SOURCE_TYPE eSource)
{
#ifdef UTOPIA_V2
    DIP_INSTANCE_PRIVATE* pDipPri = NULL;
    DIP_SHARE_RESOURCE_PRIVATE* pDipResPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void*)&pDipPri);
    UtopiaResourceGetPrivate(pDipPri->pShareResource,(void*)&(pDipResPri));
#endif
    MS_U16 HCusScalingSrc = 0;
    SC_DIP_SWDB_INFO DBreg;

    HCusScalingSrc = g_DIPSrcInfo[eWindow].u16PreHCusScalingSrc;

    if(((HCusScalingSrc != g_DIPSrcInfo[eWindow].u16PreHCusScalingDst) ||
        (g_DIPSrcInfo[eWindow].u16PreVCusScalingSrc != g_DIPSrcInfo[eWindow].u16PreVCusScalingDst) ||
        ((_gbDWIN0DIEna == TRUE) && (HCusScalingSrc > FHD_WIDTH))) ||
        ((_gbDWIN0DNREna == TRUE) && (HCusScalingSrc > FHD_WIDTH)))
    {
        if(HCusScalingSrc <= HVSP_INPUT_WIDTH_MAX)
        {
            Hal_SC_DWIN_get_sw_db(pInstance,&DBreg,eWindow);
            DBreg.u32H_PreScalingRatio = 0x100000L;
            DBreg.u32V_PreScalingRatio = 0x100000L;
            Hal_SC_DWIN_sw_db(pInstance,&DBreg,eWindow);
            if(HCusScalingSrc != g_DIPSrcInfo[eWindow].u16PreHCusScalingDst)
            {
                _HAL_XC_DIP_HSPScaling(pInstance,TRUE,HCusScalingSrc,g_DIPSrcInfo[eWindow].u16PreHCusScalingDst,eWindow);
            }
            else
            {
                _HAL_XC_DIP_HSPScaling(pInstance,FALSE,HCusScalingSrc,g_DIPSrcInfo[eWindow].u16PreHCusScalingDst,eWindow);
            }
            if(g_DIPSrcInfo[eWindow].u16PreVCusScalingSrc != g_DIPSrcInfo[eWindow].u16PreVCusScalingDst)
            {
                _HAL_XC_DIP_VSPScaling(pInstance,TRUE,g_DIPSrcInfo[eWindow].u16PreVCusScalingSrc,g_DIPSrcInfo[eWindow].u16PreVCusScalingDst,eWindow);
            }
            else
            {
                _HAL_XC_DIP_VSPScaling(pInstance,FALSE,g_DIPSrcInfo[eWindow].u16PreVCusScalingSrc,g_DIPSrcInfo[eWindow].u16PreVCusScalingDst,eWindow);
            }
            _HAL_XC_DIP_HVSP_Enable(pInstance,TRUE,eWindow);
        }
        else
        {
            //pre scaling down to FHD
            Hal_SC_DWIN_get_sw_db(pInstance,&DBreg,eWindow);
            HCusScalingSrc = FHD_WIDTH;
            DBreg.u32H_PreScalingRatio = H_PreScalingDownRatioDIP(g_DIPSrcInfo[eWindow].u16PreHCusScalingSrc,HCusScalingSrc);
            DBreg.u32H_PreScalingRatio &= 0x7FFFFFL;
            DBreg.u32H_PreScalingRatio |= (BIT(31));
            //VSD disable
            DBreg.u32V_PreScalingRatio = 0x100000L;
            Hal_SC_DWIN_sw_db(pInstance,&DBreg,eWindow);

            if(HCusScalingSrc != g_DIPSrcInfo[eWindow].u16PreHCusScalingDst)
            {
                _HAL_XC_DIP_HSPScaling(pInstance,TRUE,HCusScalingSrc,g_DIPSrcInfo[eWindow].u16PreHCusScalingDst,eWindow);
            }
            else
            {
                _HAL_XC_DIP_HSPScaling(pInstance,FALSE,HCusScalingSrc,g_DIPSrcInfo[eWindow].u16PreHCusScalingDst,eWindow);
            }
            if(g_DIPSrcInfo[eWindow].u16PreVCusScalingSrc != g_DIPSrcInfo[eWindow].u16PreVCusScalingDst)
            {
                _HAL_XC_DIP_VSPScaling(pInstance,TRUE,g_DIPSrcInfo[eWindow].u16PreVCusScalingSrc,g_DIPSrcInfo[eWindow].u16PreVCusScalingDst,eWindow);
            }
            else
            {
                _HAL_XC_DIP_VSPScaling(pInstance,FALSE,g_DIPSrcInfo[eWindow].u16PreVCusScalingSrc,g_DIPSrcInfo[eWindow].u16PreVCusScalingDst,eWindow);
            }
            _HAL_XC_DIP_HVSP_Enable(pInstance,TRUE,eWindow);
        }
    }
    else
    {
        Hal_SC_DWIN_get_sw_db(pInstance,&DBreg,eWindow);
        DBreg.u32H_PreScalingRatio = 0x100000L;
        DBreg.u32V_PreScalingRatio = 0x100000L;
        Hal_SC_DWIN_sw_db(pInstance,&DBreg,eWindow);
        _HAL_XC_DIP_HVSP_Enable(pInstance,FALSE,eWindow);
    }
    if(_gbDWIN0DIEna == TRUE)
    {
        _gu16DWIN0DIDNRHSize = HCusScalingSrc;
        _gu16DWIN0DIDNRVSize = (g_DIPSrcInfo[eWindow].u16PreVCusScalingSrc >> 1);
    }
    else if(_gbDWIN0DNREna == TRUE)
    {
        _gu16DWIN0DIDNRHSize = HCusScalingSrc;
        _gu16DWIN0DIDNRVSize = g_DIPSrcInfo[eWindow].u16PreVCusScalingSrc;
    }
    else
    {
        _gu16DWIN0DIDNRHSize = 0;
        _gu16DWIN0DIDNRVSize = 0;
    }
}
void HAL_XC_DIP_SetWinProperty(void *pInstance, MS_U8 u8BufCnt,MS_U16 u16Width,MS_U16 u16LineOft,MS_U16 u16Height,MS_PHY u64OffSet, SCALER_DIP_SOURCE_TYPE eSource,MS_BOOL bPIP, MS_BOOL UNUSED_PARA(b2P_Enable), SCALER_DIP_WIN eWindow)
{
#ifdef UTOPIA_V2
    DIP_INSTANCE_PRIVATE* pDipPri = NULL;
    DIP_SHARE_RESOURCE_PRIVATE* pDipResPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void*)&pDipPri);
    UtopiaResourceGetPrivate(pDipPri->pShareResource,(void*)&(pDipResPri));
#endif
    MS_U64 u64_result = 0;
    MS_U16 u16MaxWith = 0;
    MS_BOOL bIsYUVFmt = FALSE;

    if(_MHal_XC_DIP_GetWidth(pInstance, eSource, eWindow, &u16MaxWith) != E_DIP_SUCCESS)
    {
        DIP_H_WARN("[%s]call HAL_XC_DIP_GetWidth fail\n",__FUNCTION__);
    }

    if(eWindow == DWIN0_WINDOW)
    {
        if(eSource == SCALER_DIP_SOURCE_TYPE_SC2_OP_CAPTURE && (_gstDwin0XCInfo.bPathEnabled == TRUE))
        {
            if(_gstDwin0XCInfo.bInterlace == TRUE)
            {
                HAL_XC_DIP_SetDIMode(pInstance,TRUE,eWindow);
            }
            else
            {
                HAL_XC_DIP_SetPDNRMode(pInstance,TRUE,eWindow);
            }
        }
        HAL_XC_DIP_AdjustScaling(pInstance, eWindow ,eSource);
    }

    if( eWindow == DIP_WINDOW )
    {
        DipWBufCnt = u8BufCnt;
        DipSource = eSource;
        DIP_W2BYTEMSK(0, REG_SC_BK36_01_L, u8BufCnt-1,BMASK(2:0));

        if(eSource == SCALER_DIP_SOURCE_TYPE_DRAM)
        {
            //1: from dipr
            DIP_W2BYTEMSK(0, REG_SC_BK34_7F_L,BIT(6),BIT(6));
            //    dipr to dip
            DIP_W2BYTEMSK(0, REG_SC_BK34_7F_L,BIT(13),BMASK(13:12));
            //disable  source yc swap
            DIP_W2BYTEMSK(0, REG_SC_BK34_7C_L,0,BIT(14));
        }
        else
        {
            //0: from IPMUX/OP1
            DIP_W2BYTEMSK(0, REG_SC_BK34_7F_L,0,BIT(6));
            //Monaco Mode DI input is 422
            if( ((eSource == SCALER_DIP_SOURCE_TYPE_OP_MAIN) || (eSource == SCALER_DIP_SOURCE_TYPE_OP_SUB)) && (bDipR2Y == FALSE) )
            {
                //enable  422 to 444
                DIP_W2BYTEMSK(0, REG_SC_BK34_6C_L,BIT(9),BIT(9));
                //enable  source yc swap
                DIP_W2BYTEMSK(0, REG_SC_BK34_7C_L,BIT(14),BIT(14));
            }
            else
            {
                //disable  422 to 444
                DIP_W2BYTEMSK(0, REG_SC_BK34_6C_L,0,BIT(9));
				//disable  source yc swap
                DIP_W2BYTEMSK(0, REG_SC_BK34_7C_L,0,BIT(14));
            }
        }

        if( (eSource == SCALER_DIP_SOURCE_TYPE_MAIN)||(eSource == SCALER_DIP_SOURCE_TYPE_SUB) )
		{
			DIP_W2BYTEMSK(0,  REG_SC_BK34_7F_L, BIT(15), BMASK(15:14));
		}
        if( (bDIPRotation == TRUE) && (DIPRotation == eWindow) )
        {
            //width
            DIP_W2BYTE(0, REG_SC_BK36_2F_L, u16Width);
            //height
            DIP_W2BYTE(0, REG_SC_BK36_1F_L, u16Height);
            _HAL_XC_DIP_Write_ReqNum(pInstance, u16Height,eWindow);
        }
        else
        {
            //width
            DIP_W2BYTE(0, REG_SC_BK36_1F_L, u16Width);
            //height
            DIP_W2BYTE(0, REG_SC_BK36_2F_L, u16Height);
            _HAL_XC_DIP_Write_ReqNum(pInstance, u16Width,eWindow);
        }
        //pitch
        DIP_W2BYTE(0, REG_SC_BK36_3F_L, u16LineOft);
        //buffer offset
        DIP_W4BYTE(0, REG_SC_BK36_50_L,u64OffSet);

        if(eSource == SCALER_DIP_SOURCE_TYPE_SUB)
        {
            //reg_4k_h_size
			u64_result = u16MaxWith+1;
            DO_DIV(u64_result,2);
            DIP_W2BYTEMSK(0, REG_SC_BK34_6D_L, u64_result,BMASK(11:0));
            DIP_W2BYTEMSK(0, REG_SC_BK34_6D_L, BIT(15),BIT(15));
            //dip_op_pre_sel (2: sc2 3: sc)
            DIP_W2BYTEMSK(0, REG_SC_BK34_67_L, 0x3 ,BMASK(1:0));
        }
        else if(eSource != SCALER_DIP_SOURCE_TYPE_SC2_OP_CAPTURE)
        {
            //reg_4k_h_size
            DIP_W2BYTEMSK(0, REG_SC_BK34_6D_L, ((u16MaxWith+1)/2),BMASK(11:0));
            DIP_W2BYTEMSK(0, REG_SC_BK34_6D_L, BIT(15),BIT(15));
            //dip_op_pre_sel (2: sc2 3: sc)
            DIP_W2BYTEMSK(0, REG_SC_BK34_67_L, 0x3 ,BMASK(1:0));
        }
        else
        {
            //reg_4k_h_size
            DIP_W2BYTEMSK(0, REG_SC_BK34_6D_L, 0,BIT(15));
            //dip_op_pre_sel (2: sc2 3: sc)
            DIP_W2BYTEMSK(0, REG_SC_BK34_67_L, 0x2 ,BMASK(1:0));
        }
        //DIP Clk gating seletion and source select
        if(eSource == SCALER_DIP_SOURCE_TYPE_MAIN)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK34_67_L, 0,BMASK(4:2));//0: ip_main    1: ip_sub    4: sc2_ip_main
        }

        if(eSource == SCALER_DIP_SOURCE_TYPE_SUB)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK34_67_L, BIT(4),BMASK(4:2));//0: ip_main    1: ip_sub    4: sc2_ip_main
        }

        bIsYUVFmt = _HAL_XC_DIP_IsYUVFmt(DipFmt);
        if(bIsYUVFmt == TRUE)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, (bDipHMirror?(!bDipUVSwap?BIT(14):0):(bDipUVSwap?BIT(14):0)), BIT(14));
            DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, (bDipHMirror?(!bDipYCSwap?BIT(15):0):(bDipYCSwap?BIT(15):0)), BIT(15));
            //enable 444 to 422
            DIP_W2BYTEMSK(0, REG_SC_BK34_30_L, BIT(0),BIT(0));
            if(DipFmt == XC_DWIN_DATA_FMT_YUV422)
            {
                DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, BIT(15),BIT(15));
            }
            else
            {
                DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, 0,BIT(15));
            }
        }
        else
        {
            //disable 444 to 422
            DIP_W2BYTEMSK(0, REG_SC_BK34_30_L,0,BIT(0));
        }
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        if(eSource == SCALER_DIP_SOURCE_TYPE_SC2_OP_CAPTURE && (_gstDwin0XCInfo.bPathEnabled == TRUE))
        {
            eSource = _gstDwin0XCInfo.enDipCapSource;
        }
        Dwin0WBufCnt = u8BufCnt;
        Dwin0Source = eSource;
        DIP_W2BYTEMSK(0, REG_SC_BK3B_01_L, u8BufCnt-1,BMASK(2:0));

        if(eSource == SCALER_DIP_SOURCE_TYPE_DRAM)
        {
            //1: from dipr
            DIP_W2BYTEMSK(0, REG_SC_BK3B_73_L,BIT(6),BIT(6));
            //    dipr to dwin0
            DIP_W2BYTEMSK(0, REG_SC_BK34_7F_L,0,BMASK(13:12));
            //disable  source yc swap
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L,0,BIT(8));
        }
        else
        {
            //0: from IPMUX/OP1
            DIP_W2BYTEMSK(0, REG_SC_BK3B_73_L,0,BIT(6));
            //Monaco Mode DI input is 422
            if( ((eSource == SCALER_DIP_SOURCE_TYPE_OP_MAIN) || (eSource == SCALER_DIP_SOURCE_TYPE_OP_SUB)) && (bDwin0R2Y == FALSE) )
            {
                //enable  422 to 444
                DIP_W2BYTEMSK(0, REG_SC_BK3B_78_L,BIT(9),BIT(9));
                //enable  source yc swap
                DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L,BIT(8),BIT(8));
            }
            else
            {
                //disable  422 to 444
                DIP_W2BYTEMSK(0, REG_SC_BK3B_78_L,0,BIT(9));
                //disable  source yc swap
                DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L,0,BIT(8));
            }
        }

        if( (eSource == SCALER_DIP_SOURCE_TYPE_MAIN)||(eSource == SCALER_DIP_SOURCE_TYPE_SUB) )
        {
			DIP_W2BYTEMSK(0,  REG_SC_BK3B_7F_L, BIT(5), BMASK(5:4));
        }

        if( (bDIPRotation == TRUE) && (DIPRotation == eWindow) )
        {
            //width
            DIP_W2BYTE(0, REG_SC_BK3B_2F_L, u16Width);
            //height
            DIP_W2BYTE(0, REG_SC_BK3B_1F_L, u16Height);
            _HAL_XC_DIP_Write_ReqNum(pInstance, u16Height,eWindow);
        }
        else
        {
            //width
            DIP_W2BYTE(0, REG_SC_BK3B_1F_L, u16Width);
            //height
            DIP_W2BYTE(0, REG_SC_BK3B_2F_L, u16Height);
            _HAL_XC_DIP_Write_ReqNum(pInstance, u16Width,eWindow);
        }
        //pitch
        DIP_W2BYTE(0, REG_SC_BK3B_3F_L, u16LineOft);
        //buffer offset
        DIP_W4BYTE(0, REG_SC_BK3B_50_L,u64OffSet);

        if((_gbDWIN0DIEna == TRUE) || (_gbDWIN0DNREna == TRUE))
        {
            if((eSource == SCALER_DIP_SOURCE_TYPE_DRAM) && (_gbDWIN0FieldStagger == TRUE))
            {
                _gu16DWIN0DIDNRVSize = _gu16DWIN0DIDNRVSize >> 1;
            }
            //ddiw
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_09,_gu16DWIN0DIDNRHSize,BMASK(12:0));
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_0A,_gu16DWIN0DIDNRVSize,BMASK(11:0));
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_0B,_gu16DWIN0DIDNRHSize,BMASK(12:0));
            MDrv_DIP_Write4Byte(REG_DDI1_EXT38_0C,(MS_PHY)(_gu16DWIN0DIDNRHSize * _gu16DWIN0DIDNRVSize));
            //ddir
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_21,_gu16DWIN0DIDNRHSize,BMASK(12:0));
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_22,_gu16DWIN0DIDNRVSize,BMASK(11:0));
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_23,_gu16DWIN0DIDNRHSize,BMASK(12:0));
            MDrv_DIP_Write4Byte(REG_DDI1_EXT38_24,(MS_PHY)(_gu16DWIN0DIDNRHSize * _gu16DWIN0DIDNRVSize));
        }

        if(eSource == SCALER_DIP_SOURCE_TYPE_SUB)
        {
            //reg_4k_h_size
			u64_result = u16MaxWith+1;
            DO_DIV(u64_result,2);
            DIP_W2BYTEMSK(0, REG_SC_BK3B_79_L, u64_result,BMASK(11:0));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_79_L, BIT(15),BIT(15));
            //dip_op_pre_sel (2: sc2 3: sc)
            DIP_W2BYTEMSK(0, REG_SC_BK3B_67_L, 0x3 ,BMASK(1:0));
        }
        else if(eSource != SCALER_DIP_SOURCE_TYPE_SC2_OP_CAPTURE)
        {
            //reg_4k_h_size
            DIP_W2BYTEMSK(0, REG_SC_BK3B_79_L, ((u16MaxWith+1)/2),BMASK(11:0));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_79_L, BIT(15),BIT(15));
            //dip_op_pre_sel (2: sc2 3: sc)
            DIP_W2BYTEMSK(0, REG_SC_BK3B_67_L, 0x3 ,BMASK(1:0));
        }
        else
        {
            //reg_4k_h_size
            DIP_W2BYTEMSK(0, REG_SC_BK3B_79_L, 0x0,BIT(15));
            //dip_op_pre_sel (2: sc2 3: sc)
            DIP_W2BYTEMSK(0, REG_SC_BK3B_67_L, 0x2 ,BMASK(1:0));
        }
        //DWIN0 Clk gating seletion and source select
        if(eSource == SCALER_DIP_SOURCE_TYPE_MAIN)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_67_L, 0,BMASK(4:2));//0: ip_main    1: ip_sub    4: sc2_ip_main
        }

        if(eSource == SCALER_DIP_SOURCE_TYPE_SUB)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_67_L, BIT(4),BMASK(4:2));//0: ip_main    1: ip_sub    4: sc2_ip_main
        }

        if(eSource == SCALER_DIP_SOURCE_TYPE_MVOP1)
        {
            //mvop_hk_path_en
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L, BIT(9),BIT(9));
            //vsync invert enalbe
            Hal_SC_DWIN_set_input_vsync_inverse(pInstance,TRUE, eWindow);
        }
        else
        {
            //mvop_hk_path_en
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L, 0,BIT(9));
            //vsync invert Disable
            Hal_SC_DWIN_set_input_vsync_inverse(pInstance,FALSE, eWindow);
        }

        bIsYUVFmt = _HAL_XC_DIP_IsYUVFmt(Dwin0Fmt);
        if((_gbDWIN0DIEna == TRUE) || (_gbDWIN0DNREna == TRUE))
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_44_L, BIT(0),BIT(0));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7E_L, BIT(8),BIT(8));
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_44_L, 0,BIT(0));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_7E_L, 0,BIT(8));
        }
        if(bIsYUVFmt == TRUE)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, (bDWIN0HMirror?(!bDWIN0UVSwap?BIT(14):0):(bDWIN0UVSwap?BIT(14):0)), BIT(14));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, (bDWIN0HMirror?(!bDWIN0YCSwap?BIT(15):0):(bDWIN0YCSwap?BIT(15):0)), BIT(15));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_44_L, BIT(8),BIT(8));
            if(Dwin0Fmt == XC_DWIN_DATA_FMT_YUV422)
            {
                DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, BIT(15),BIT(15));
            }
            else
            {
                DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, 0,BIT(15));
            }
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_44_L,0,BIT(8));
        }
#if (DIP_PQ_SETTINGS == TRUE)
    _HAL_XC_DIP_SET_PQ();
#endif
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        Dwin1WBufCnt = u8BufCnt;
        Dwin1Source = eSource;
        DIP_W2BYTEMSK(0, REG_SC_BK3C_01_L, u8BufCnt-1,BMASK(2:0));

        if(eSource == SCALER_DIP_SOURCE_TYPE_DRAM)
        {
            //1: from dipr
            DIP_W2BYTEMSK(0, REG_SC_BK3C_73_L,BIT(6),BIT(6));
            //2. dipr to dwin1
            DIP_W2BYTEMSK(0, REG_SC_BK34_7F_L,BIT(12),BMASK(13:12));
            //disable  source yc swap
            DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L,0,BIT(8));
        }
        else
        {
            //0: from IPMUX/OP1
            DIP_W2BYTEMSK(0, REG_SC_BK3C_73_L,0,BIT(6));
            //Monaco Mode DI input is 422
            if( ((eSource == SCALER_DIP_SOURCE_TYPE_OP_MAIN) || (eSource == SCALER_DIP_SOURCE_TYPE_OP_SUB)) && (bDwin1R2Y == FALSE) )
            {
                //enable  422 to 444
                DIP_W2BYTEMSK(0, REG_SC_BK3C_78_L,BIT(9),BIT(9));
                //enable  source yc swap
                DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L,BIT(8),BIT(8));
            }
            else
            {
                //disable  422 to 444
                DIP_W2BYTEMSK(0, REG_SC_BK3C_78_L,0,BIT(9));
                //disable  source yc swap
                DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L,0,BIT(8));
            }
        }

        if( (eSource == SCALER_DIP_SOURCE_TYPE_MAIN)||(eSource == SCALER_DIP_SOURCE_TYPE_SUB) )
        {
			DIP_W2BYTEMSK(0,  REG_SC_BK3C_7F_L, BIT(5), BMASK(5:4));
        }

        if( (bDIPRotation == TRUE) && (DIPRotation == eWindow) )
        {
            //width
            DIP_W2BYTE(0, REG_SC_BK3C_2F_L, u16Width);
            //height
            DIP_W2BYTE(0, REG_SC_BK3C_1F_L, u16Height);
        }
        else
        {
            //width
            DIP_W2BYTE(0, REG_SC_BK3C_1F_L, u16Width);
            //height
            DIP_W2BYTE(0, REG_SC_BK3C_2F_L, u16Height);
        }
        //pitch
        DIP_W2BYTE(0, REG_SC_BK3C_3F_L, u16LineOft);
        //buffer offset
        DIP_W4BYTE(0, REG_SC_BK3C_50_L,u64OffSet);

        if(eSource == SCALER_DIP_SOURCE_TYPE_SUB)
        {
            //reg_4k_h_size
			u64_result = u16MaxWith+1;
            DO_DIV(u64_result,2);
            DIP_W2BYTEMSK(0, REG_SC_BK3C_79_L, u64_result ,BMASK(11:0));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_79_L, BIT(15),BIT(15));
            //dip_op_pre_sel (2: sc2 3: sc)
            DIP_W2BYTEMSK(0, REG_SC_BK3C_67_L, 0x3 ,BMASK(1:0));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_39_L, BIT(15) ,BIT(15));
        }
        else if(eSource != SCALER_DIP_SOURCE_TYPE_SC2_OP_CAPTURE)
        {
            //reg_4k_h_size
            DIP_W2BYTEMSK(0, REG_SC_BK3C_79_L, ((u16MaxWith+1)/2),BMASK(11:0));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_79_L, BIT(15),BIT(15));
            //dip_op_pre_sel (2: sc2 3: sc)
            DIP_W2BYTEMSK(0, REG_SC_BK3C_67_L, 0x3 ,BMASK(1:0));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_39_L, 0 ,BIT(15));
        }
        else
        {
            //reg_4k_h_size
            DIP_W2BYTEMSK(0, REG_SC_BK3C_79_L, 0x0,BIT(15));
            //dip_op_pre_sel (2: sc2 3: sc)
            DIP_W2BYTEMSK(0, REG_SC_BK3C_67_L, 0x2 ,BMASK(1:0));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_39_L, 0 ,BIT(15));
        }
        //DWIN1 Clk gating seletion and source select
        if(eSource == SCALER_DIP_SOURCE_TYPE_MAIN)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3C_73_L, BIT(8),BMASK(8:7));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_67_L, 0,BMASK(4:2));//0: ip_main    1: ip_sub    4: sc2_ip_main
        }
        else if(eSource == SCALER_DIP_SOURCE_TYPE_SUB)
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3C_73_L, BIT(8),BMASK(8:7));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_67_L, BIT(4),BMASK(4:2));//0: ip_main    1: ip_sub    4: sc2_ip_main
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3C_73_L, 0x0,BMASK(8:7));
        }
    }

    _MHal_XC_DIP_1pTo2pCtrl(pInstance, eSource, eWindow);

    //Rotation
    if( (bDIPRotation == TRUE) && (DIPRotation == eWindow) ){
        u64_result = u16Height;
        DO_DIV(u64_result,0x10);
        DIP_W2BYTEMSK(0, REG_SC_BK34_6E_L, u64_result,BMASK(7:0));
    }
}
void HAL_XC_DIP_SetWinProperty1(void *pInstance, MS_PHY u64OffSet,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        DIP_W4BYTE(0, REG_SC_BK36_60_L,u64OffSet);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W4BYTE(0, REG_SC_BK3B_60_L,u64OffSet);
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W4BYTE(0, REG_SC_BK3C_60_L,u64OffSet);
    }
    else
    {
        return;
    }
}
MS_U8 HAL_XC_DIP_GetBufCnt(void *pInstance, SCALER_DIP_WIN eWindow)
{
    MS_U8 u8BufCnt = 0;
    if( eWindow == DIP_WINDOW )
    {
        u8BufCnt = DipWBufCnt;
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        u8BufCnt = Dwin0WBufCnt;
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        u8BufCnt = Dwin1WBufCnt;
    }
    return (MS_U8) u8BufCnt;
}
void HAL_XC_DIP_SetBase0(void *pInstance,MS_PHY phyBufStart,MS_PHY phyBufEnd,SCALER_DIP_WIN eWindow)
{
    MS_U16 u16BusSize = 0;
    MS_PHY phy_result = 0;

    u16BusSize = HAL_XC_DIP_GetBusSize(pInstance, eWindow);
    DIP_BUF_STARTADDR_ALIGNCHECK(phyBufStart, u16BusSize);
    DIP_BUF_ENDADDR_ALIGNCHECK(phyBufEnd, u16BusSize);
    if( eWindow == DIP_WINDOW )
    {
        //low bound
        phy_result = phyBufStart;
        DO_DIV(phy_result,u16BusSize);
        DIP_W4BYTE(0, REG_SC_BK36_10_L, phy_result);     // input address0
        //high bound
        phy_result = phyBufEnd;
        DO_DIV(phy_result,u16BusSize);
        phy_result|=(1<<DWIN_W_LIMITE_OFT);
        //phyBufEnd /= u16BusSize;
        //phyBufEnd|=(1<<DWIN_W_LIMITE_OFT);
        DIP_W4BYTE(0, REG_SC_BK36_30_L, phy_result);     // input address0
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        //low bound
        phy_result = phyBufStart;
        DO_DIV(phy_result,u16BusSize);
        DIP_W4BYTE(0, REG_SC_BK3B_10_L, phy_result);     // input address0
        //high bound
        phy_result = phyBufEnd;
        DO_DIV(phy_result,u16BusSize);
        phy_result|=(1<<DWIN_W_LIMITE_OFT);
        //phyBufEnd /= u16BusSize;
        //phyBufEnd|=(1<<DWIN_W_LIMITE_OFT);
        DIP_W4BYTE(0, REG_SC_BK3B_30_L, phy_result);     // input address0
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        //low bound
        phy_result = phyBufStart;
        DO_DIV(phy_result,u16BusSize);
        DIP_W4BYTE(0, REG_SC_BK3C_10_L, phy_result);     // input address0
        //high bound
        phy_result = phyBufEnd;
        DO_DIV(phy_result,u16BusSize);
        phy_result|=(1<<DWIN_W_LIMITE_OFT);
        //phyBufEnd /= u16BusSize;
        //phyBufEnd|=(1<<DWIN_W_LIMITE_OFT);
        DIP_W4BYTE(0, REG_SC_BK3C_30_L, phy_result);     // input address0
    }
    else
    {
        return;
    }
}
void HAL_XC_DIP_SetBase1(void *pInstance, MS_PHY phyBufStart,MS_PHY phyBufEnd,SCALER_DIP_WIN eWindow)
{
    MS_U16 u16BusSize = 0;
    MS_PHY phy_result;


    u16BusSize = HAL_XC_DIP_GetBusSize(pInstance, eWindow);
    DIP_BUF_STARTADDR_ALIGNCHECK(phyBufStart, u16BusSize);
    DIP_BUF_ENDADDR_ALIGNCHECK(phyBufEnd, u16BusSize);
    if( eWindow == DIP_WINDOW )
    {
        //low bound
        phy_result = phyBufStart;
        DO_DIV(phy_result,u16BusSize);
        DIP_W4BYTE(0, REG_SC_BK36_20_L, phy_result);     // input address0
        //high bound
        phy_result = phyBufEnd;
        DO_DIV(phy_result,u16BusSize);
        phy_result|=(1<<DWIN_W_LIMITE_OFT);
        //phyBufEnd /= u16BusSize;
        //phyBufEnd|=(1<<DWIN_W_LIMITE_OFT);
        DIP_W4BYTE(0, REG_SC_BK36_40_L, phy_result);     // input address0
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        //low bound
        phy_result = phyBufStart;
        DO_DIV(phy_result,u16BusSize);
        DIP_W4BYTE(0, REG_SC_BK3B_20_L, phy_result);     // input address0
        //high bound
        phy_result = phyBufEnd;
        DO_DIV(phy_result,u16BusSize);
        phy_result|=(1<<DWIN_W_LIMITE_OFT);
        //phyBufEnd /= u16BusSize;
        //phyBufEnd|=(1<<DWIN_W_LIMITE_OFT);
        DIP_W4BYTE(0, REG_SC_BK3B_40_L, phy_result);     // input address0
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        //low bound
        phy_result = phyBufStart;
        DO_DIV(phy_result,u16BusSize);
        DIP_W4BYTE(0, REG_SC_BK3C_20_L, phy_result);     // input address0
        //high bound
        phy_result = phyBufEnd;
        DO_DIV(phy_result,u16BusSize);
        phy_result|=(1<<DWIN_W_LIMITE_OFT);
        //phyBufEnd /= u16BusSize;
        //phyBufEnd|=(1<<DWIN_W_LIMITE_OFT);
        DIP_W4BYTE(0, REG_SC_BK3C_40_L, phy_result);     // input address0
    }
    else
    {
        return;
    }
}
void HAL_XC_DIP_SetMiuSel(void *pInstance, MS_U8 u8MIUSel,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        // Scaler control MIU by itself
        // So MIU1 IP-select is set to 1. At this moment, MIU0 Miu select is not working.
        DIP_W2BYTEMSK(0, REG_SC_BK7F_11_L, BIT(11), BIT(11)); // IP select (Group6 BIT11)
        if( ((CHIP_MIU_ID)u8MIUSel) == E_CHIP_MIU_0 )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, 0, BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK36_07_L, 0, BIT(15));
        }
        else if( ((CHIP_MIU_ID)u8MIUSel) == E_CHIP_MIU_1 )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, BIT(13), BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK36_07_L, 0, BIT(15));
        }
        else if( ((CHIP_MIU_ID)u8MIUSel) == E_CHIP_MIU_2 )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, 0, BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK36_07_L, BIT(15), BIT(15));
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, BIT(13), BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK36_07_L, BIT(15), BIT(15));
        }
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        // Scaler control MIU by itself
        // So MIU1 IP-select is set to 1. At this moment, MIU0 Miu select is not working.
        DIP_W2BYTEMSK(0, REG_SC_BK7F_11_L, BIT(11), BIT(11)); // IP select (Group6 BIT11)
        if( ((CHIP_MIU_ID)u8MIUSel) == E_CHIP_MIU_0 )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, 0, BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_07_L, 0, BIT(15));
        }
        else if( ((CHIP_MIU_ID)u8MIUSel) == E_CHIP_MIU_1 )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, BIT(13), BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_07_L, 0, BIT(15));
        }
        else if( ((CHIP_MIU_ID)u8MIUSel) == E_CHIP_MIU_2 )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, 0, BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_07_L, BIT(15), BIT(15));
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, BIT(13), BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_07_L, BIT(15), BIT(15));
        }
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        // Scaler control MIU by itself
        // So MIU1 IP-select is set to 1. At this moment, MIU0 Miu select is not working.
        DIP_W2BYTEMSK(0, REG_SC_BK7F_11_L, BIT(11), BIT(11)); // IP select (Group6 BIT11)
        if( ((CHIP_MIU_ID)u8MIUSel) == E_CHIP_MIU_0 )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, 0, BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_07_L, 0, BIT(15));
        }
        else if( ((CHIP_MIU_ID)u8MIUSel) == E_CHIP_MIU_1 )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, BIT(13), BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_07_L, 0, BIT(15));
        }
        else if( ((CHIP_MIU_ID)u8MIUSel) == E_CHIP_MIU_2 )
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, 0, BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_07_L, BIT(15), BIT(15));
        }
        else
        {
            DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, BIT(13), BIT(13));
            DIP_W2BYTEMSK(0, REG_SC_BK3C_07_L, BIT(15), BIT(15));
        }
    }
    else
    {
       XC_ERR("ERROR[%s]enum ewindow is not correct\n",__FUNCTION__);
    }
}

void HAL_XC_DIP_SetDIPRMiuSel(void *pInstance, MS_U8 u8YBufMIUSel, MS_U8 u8CBufMIUSel,SCALER_DIP_WIN eWindow)
{
    // Y/C miu separate setting
    if( u8YBufMIUSel == u8CBufMIUSel)
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_19, 0, BIT(11));
    }
    else
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_19, BIT(11), BIT(11));
    }

    //DIPR Y buffer
    if( ((CHIP_MIU_ID)u8YBufMIUSel) == E_CHIP_MIU_0 )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_7D_L, 0, BIT(15));
        DIP_W2BYTEMSK(0, REG_SC_BK36_7C_L, 0, BIT(14));
    }
    else if( ((CHIP_MIU_ID)u8YBufMIUSel) == E_CHIP_MIU_1 )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_7D_L, BIT(15), BIT(15));
        DIP_W2BYTEMSK(0, REG_SC_BK36_7C_L, 0, BIT(14));
    }
    else if( ((CHIP_MIU_ID)u8YBufMIUSel) == E_CHIP_MIU_2 )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_7D_L, 0, BIT(15));
        DIP_W2BYTEMSK(0, REG_SC_BK36_7C_L, BIT(14), BIT(14));
    }

    //DIPR C buffer
    if( ((CHIP_MIU_ID)u8CBufMIUSel) == E_CHIP_MIU_0 )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_76_L, 0, BMASK(14:13));
    }
    else if( ((CHIP_MIU_ID)u8CBufMIUSel) == E_CHIP_MIU_1 )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_76_L, BIT(13), BMASK(14:13));
    }
    else if( ((CHIP_MIU_ID)u8CBufMIUSel) == E_CHIP_MIU_2 )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_76_L, BIT(14), BMASK(14:13));
    }

}


void HAL_XC_DIP_SetY2R(void *pInstance, MS_BOOL bEnable,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        //enable y2r
        DIP_W2BYTEMSK(0, REG_SC_BK36_7E_L,(bEnable?BIT(11):0),BIT(11));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        //enable y2r
        DIP_W2BYTEMSK(0, REG_SC_BK3B_7E_L,(bEnable?BIT(11):0),BIT(11));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        //enable y2r
        DIP_W2BYTEMSK(0, REG_SC_BK3C_7E_L,(bEnable?BIT(11):0),BIT(11));
    }
    else
    {
        return;
    }
}

void HAL_XC_DIP_SetAlphaValue(void *pInstance, MS_U8 u8AlphaVal,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, u8AlphaVal,BMASK(7:0));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, u8AlphaVal,BMASK(7:0));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, u8AlphaVal,BMASK(7:0));
    }
    else
    {
        return;
    }
}
void HAL_XC_DIP_SetUVSwap(void *pInstance, MS_BOOL bEnable,SCALER_DIP_WIN eWindow)
{
    // do  if do Hmirror
    if( eWindow == DIP_WINDOW )
    {
        bDipUVSwap = bEnable;
        DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, (bDipHMirror?(!bDipUVSwap?BIT(14):0):(bDipUVSwap?BIT(14):0)), BIT(14));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        bDWIN0UVSwap = bEnable;
        DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, (bDWIN0HMirror?(!bDWIN0UVSwap?BIT(14):0):(bDWIN0UVSwap?BIT(14):0)) ,BIT(14));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        bDWIN1UVSwap = bEnable;
        DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, (bDWIN1HMirror?(!bDWIN1UVSwap?BIT(14):0):(bDWIN1UVSwap?BIT(14):0)) ,BIT(14));
    }
    else
    {
        return;
    }
}
void HAL_XC_DIP_SetYCSwap(void *pInstance, MS_BOOL bEnable,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        bDipYCSwap = bEnable;
        DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, (bDipHMirror?(!bDipYCSwap?BIT(15):0):(bDipYCSwap?BIT(15):0)), BIT(15));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        bDWIN0YCSwap = bEnable;
        DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, (bDWIN0HMirror?(!bDWIN0YCSwap?BIT(15):0):(bDWIN0YCSwap?BIT(15):0)) ,BIT(15));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        bDWIN1YCSwap = bEnable;
        DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, (bDWIN1HMirror?(!bDWIN1YCSwap?BIT(15):0):(bDWIN1YCSwap?BIT(15):0)) ,BIT(15));
    }
    else
    {
        return;
    }
}
void HAL_XC_DIP_SetRGBSwap(void *pInstance, MS_BOOL bEnable,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_7E_L, (bEnable?BIT(13):0) ,BIT(13));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3B_7E_L, (bEnable?BIT(13):0) ,BIT(13));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3C_7E_L, (bEnable?BIT(13):0) ,BIT(13));
    }
    else
    {
        return;
    }
}
void HAL_XC_DIP_SetOutputCapture(void *pInstance, MS_BOOL bEnable,EN_XC_DIP_OP_CAPTURE eOpCapture,SCALER_DIP_WIN eWindow)
{
    MS_BOOL bCaptureEna;

    bCaptureEna = bEnable;
    switch(eOpCapture)
    {
        case E_XC_DIP_VOP2:  // compatible to previous IC, overlap is before osd blending
        case E_XC_DIP_OP2:
        case E_XC_DIP_VIP:
        case E_XC_DIP_BRI:
            break;
        default:
            bCaptureEna = FALSE;
        break;
    }

    if(bCaptureEna)
    {
        DIP_W2BYTEMSK(0, REG_SC_BK0F_57_L, BIT(11), BIT(11));  // Enable
        if( eWindow == DIP_WINDOW )
        {
            if(eOpCapture == E_XC_DIP_VOP2)
                DIP_W2BYTEMSK(0, REG_SC_BK34_7F_L, 2<<14, BMASK(15:14));
            else if(eOpCapture == E_XC_DIP_OP2)
                DIP_W2BYTEMSK(0, REG_SC_BK34_7F_L, 1<<14, BMASK(15:14));
            else
                DIP_H_DBUG("[DIP] OP capture source not support\n");
        }
        else if( eWindow == DWIN0_WINDOW )
        {
            if(eOpCapture == E_XC_DIP_VOP2)
                DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L, 2<<4, BMASK(5:4));
            else if(eOpCapture == E_XC_DIP_OP2)
                DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L, 1<<4, BMASK(5:4));
            else
                DIP_H_DBUG("[DIP] OP capture source not support\n");
        }
        else if( eWindow == DWIN1_WINDOW )
        {
            if(eOpCapture == E_XC_DIP_VOP2)
                DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L, 2<<4, BMASK(5:4));
            else if(eOpCapture == E_XC_DIP_OP2)
                DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L, 1<<4, BMASK(5:4));
            else
                DIP_H_DBUG("[DIP] OP capture source not support\n");
        }
        else
        {
        return;
        }
    }
}

void HAL_XC_DIP_SetMirror(void *pInstance, MS_BOOL bHMirror,MS_BOOL bVMirror,SCALER_DIP_WIN eWindow)
{
    EN_DRV_XC_DWIN_DATA_FMT fmt;
    MS_BOOL bIsYUVFmt = FALSE;
    // pixel format will swap if set Hmirror,so here do swap pixel format
    fmt = HAL_XC_DIP_GetDataFmt(pInstance, eWindow);
    bIsYUVFmt = _HAL_XC_DIP_IsYUVFmt(fmt);

    if(bIsYUVFmt == TRUE)
    {
        if (XC_DWIN_DATA_FMT_YC422 == fmt)
        {
            if( eWindow == DIP_WINDOW )
            {
                bDipHMirror = bHMirror;
                DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, (bDipHMirror?(!bDipYCSwap?BIT(15):0):(bDipYCSwap?BIT(15):0)), BIT(15));
            }
            else if( eWindow == DWIN0_WINDOW )
            {
                bDWIN0HMirror = bHMirror;
                DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, (bDWIN0HMirror?(!bDWIN0YCSwap?BIT(15):0):(bDWIN0YCSwap?BIT(15):0)), BIT(15));
            }
            else if( eWindow == DWIN1_WINDOW )
            {
                bDWIN1HMirror = bHMirror;
                DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, (bDWIN1HMirror?(!bDWIN1YCSwap?BIT(15):0):(bDWIN1YCSwap?BIT(15):0)), BIT(15));
            }
        }
        else
        {
            if( eWindow == DIP_WINDOW )
            {
                bDipHMirror = bHMirror;
                DIP_W2BYTEMSK(0, REG_SC_BK36_02_L, (bDipHMirror?(!bDipUVSwap?BIT(14):0):(bDipUVSwap?BIT(14):0)), BIT(14));
            }
            else if( eWindow == DWIN0_WINDOW )
            {
                bDWIN0HMirror = bHMirror;
                DIP_W2BYTEMSK(0, REG_SC_BK3B_02_L, (bDWIN0HMirror?(!bDWIN0UVSwap?BIT(14):0):(bDWIN0UVSwap?BIT(14):0)), BIT(14));
            }
            else if( eWindow == DWIN1_WINDOW )
            {
                bDWIN1HMirror = bHMirror;
                DIP_W2BYTEMSK(0, REG_SC_BK3C_02_L, (bDWIN1HMirror?(!bDWIN1UVSwap?BIT(14):0):(bDWIN1UVSwap?BIT(14):0)), BIT(14));
            }
        }
    }

    if( eWindow == DIP_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_0B_L, (bHMirror?BIT(9):0) ,BIT(9));
        DIP_W2BYTEMSK(0, REG_SC_BK36_0B_L, (bVMirror?BIT(10):0) ,BIT(10));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3B_0B_L, (bHMirror?BIT(9):0) ,BIT(9));
        DIP_W2BYTEMSK(0, REG_SC_BK3B_0B_L, (bVMirror?BIT(10):0) ,BIT(10));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK3C_0B_L, (bHMirror?BIT(9):0) ,BIT(9));
        DIP_W2BYTEMSK(0, REG_SC_BK3C_0B_L, (bVMirror?BIT(10):0) ,BIT(10));
    }
    else
    {
        return;
    }
}
void HAL_XC_DIP_SetDIPRProperty(void *pInstance, ST_XC_DIPR_PROPERTY *pstDIPRProperty, SCALER_DIP_WIN eWindow)
{
    MS_BOOL bYUV = TRUE;
    MS_U16 u16Fmt;
    MS_U64 u64_result = 0;
    switch ((EN_DRV_XC_DWIN_DATA_FMT)pstDIPRProperty->enDataFmt)
    {
        case XC_DWIN_DATA_FMT_YUV422 :
        case XC_DWIN_DATA_FMT_YC422 :
            u16Fmt = 0;
            break;
        case XC_DWIN_DATA_FMT_RGB565 :
            u16Fmt = 1;
            break;
        case XC_DWIN_DATA_FMT_YUV444_24BITS :
        case XC_DWIN_DATA_FMT_ARGB8888 :
            u16Fmt = 2;
            break;
        case XC_DWIN_DATA_FMT_YUV420 :
        case XC_DWIN_DATA_FMT_YUV420_H265 :
        case XC_DWIN_DATA_FMT_YUV420_H265_10BITS :
            u16Fmt = 3;
            break;
        default :
            u16Fmt = 0x0;
            break;
    }
    //enable DIPR SW mode
    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, BIT(11) ,BIT(11));
    //select 420 to 422
    if( (pstDIPRProperty->enDataFmt == DIP_DATA_FMT_YUV420) || (pstDIPRProperty->enDataFmt == DIP_DATA_FMT_YUV420_H265)|| (pstDIPRProperty->enDataFmt == DIP_DATA_FMT_YUV420_H265_10BITS))
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(12),BIT(12));
    }
    else
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,0,BIT(12));
    }
    if( ((pstDIPRProperty->enDataFmt) == DIP_DATA_FMT_RGB565) || ((pstDIPRProperty->enDataFmt) == DIP_DATA_FMT_ARGB8888) || ((pstDIPRProperty->enDataFmt) == DIP_DATA_FMT_YUV444_24BITS))
        bYUV = FALSE;

    if((pstDIPRProperty->enDataFmt) == DIP_DATA_FMT_YUV444_24BITS)
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_1B,BIT(1),BIT(1));
    }
    else
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_1B,0,BIT(1));
    }

    if( eWindow == DIP_WINDOW )
    {
        //select  422 to 444
        DIP_W2BYTEMSK(0, REG_SC_BK34_6C_L,(bYUV?BIT(9):0),BIT(9));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        //select  422 to 444
        DIP_W2BYTEMSK(0, REG_SC_BK3B_78_L,(bYUV?BIT(9):0),BIT(9));
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        //select  422 to 444
        DIP_W2BYTEMSK(0, REG_SC_BK3C_78_L,(bYUV?BIT(9):0),BIT(9));
    }

    if(bDIPRotation == FALSE)
    DIP_W2BYTEMSK(0, REG_SC_BK34_6F_L,0x3,BIT(1)|BIT(0));

    //Y Buffer
    u64_result = pstDIPRProperty->u32YBufAddr;
    DO_DIV(u64_result,DWIN_BYTE_PER_WORD);
    MDrv_DIP_Write4Byte(REG_DIPR_BK1210_02, u64_result);
    //C Buffer
    u64_result = pstDIPRProperty->u32CBufAddr;
    DO_DIV(u64_result,DWIN_BYTE_PER_WORD);
    MDrv_DIP_Write4Byte(REG_DIPR_BK1210_04, u64_result);
    //width
    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_07, (pstDIPRProperty->u16Width),BMASK(12:0));
    //height
    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_06, (pstDIPRProperty->u16Height),BMASK(11:0));
    //Line offset
    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_0F, (pstDIPRProperty->u16Pitch), BMASK(12:0));
    //Data Fmt
    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,(u16Fmt)<<4,BMASK(5:4));

    if(pstDIPRProperty->enDataFmt == DIP_DATA_FMT_YUV420_H265_10BITS)
    {
        //Y Buffer for EVD 10 bits
        u64_result = pstDIPRProperty->u32YBufAddr10Bits;
        DO_DIV(u64_result,DWIN_BYTE_PER_WORD);
        MDrv_DIP_Write4Byte(REG_DIPR_BK1210_14, u64_result);
        //C Buffer for EVD 10 bits
        u64_result = pstDIPRProperty->u32CBufAddr10Bits;
        DO_DIV(u64_result,DWIN_BYTE_PER_WORD);
        MDrv_DIP_Write4Byte(REG_DIPR_BK1210_16, u64_result);
        //Line offset for EVD 10 bits
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_1A, (pstDIPRProperty->u16Pitch), BMASK(12:0));
        //Enable DIPR H265 10 bits
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_09, BIT(15),BIT(15));
    }
    else
    {
        //Disable DIPR H265 10 bits
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_09, 0x0,BIT(15));
    }
    if( (pstDIPRProperty->enDataFmt == DIP_DATA_FMT_YUV420_H265) || (pstDIPRProperty->enDataFmt == DIP_DATA_FMT_YUV420_H265_10BITS))
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(9),BIT(9)); //dipr tile 32x16
    }
    else
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,0,BIT(9)); //dipr tile 16x32
    }
    if(pstDIPRProperty->enDataFmt == DIP_DATA_FMT_YUV420)
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(3),BIT(3)); //dipr save bw
    }
    else
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,0,BIT(3)); //dipr save bw
    }
}


void HAL_XC_DIP_SetDIPRProperty_MFDEC(void *pInstance, ST_DIP_MFDEC_INFO stDIPR_MFDecInfo, SCALER_DIP_WIN eWindow)
{
    if(stDIPR_MFDecInfo.bMFDec_Enable == TRUE)
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_1B,BIT(0),BIT(0));
        HAL_XC_DIP_Set420TileBlock (pInstance, DIP_TILE_BLOCK_R_32_16, eWindow);
    }
    else
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_1B,0x0,BIT(0));
    }
}

void HAL_XC_DIP_SetDIPRProperty_DI(void *pInstance, ST_XC_DIPR_PROPERTY *pstDIPRProperty, ST_DIP_DIPR_3DDI_SETTING *stDIPR_DIInfo, SCALER_DIP_WIN eWindow)
{
    ST_DIP_DI_SETTING stDIPRDISetting;
    ST_DIP_DI_SETTING_V2* pstDIPRDISetting_V2;

    if((stDIPR_DIInfo->stDipr3DDI_VerCtl.u32version==1) && (stDIPR_DIInfo->stDipr3DDI_VerCtl.u32size==sizeof(ST_DIP_DI_SETTING)))
    {
        memcpy(&stDIPRDISetting, stDIPR_DIInfo->pDIPR3DDISetting, sizeof(ST_DIP_DI_SETTING));
    }
    else if((stDIPR_DIInfo->stDipr3DDI_VerCtl.u32version==2)&&(stDIPR_DIInfo->stDipr3DDI_VerCtl.u32size==sizeof(ST_DIP_DI_SETTING_V2)))
    {
        pstDIPRDISetting_V2  = (ST_DIP_DI_SETTING_V2*)stDIPR_DIInfo->pDIPR3DDISetting;
        memcpy(&stDIPRDISetting, &(pstDIPRDISetting_V2->stDIP_DI_setting), sizeof(ST_DIP_DI_SETTING));
    }
    else
    {
        XC_ERR("[ERROR][%s,%d],Version(%d) and Size(%d) Not match\n",__func__,__LINE__,stDIPR_DIInfo->stDipr3DDI_VerCtl.u32version,stDIPR_DIInfo->stDipr3DDI_VerCtl.u32size );
        return;
    }

    if(eWindow == DWIN0_WINDOW)
    {
        if(stDIPRDISetting.bEnableDI == TRUE)
        {
            switch(stDIPRDISetting.enDI_Field)
            {
                case E_DIP_3DDI_TOP_SINGLE_FIELD:
                    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0 ,BIT(13));
                    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_19,BIT(14),BIT(14));
                    _gbDWIN0FieldStagger = FALSE;
                    break;
                case E_DIP_3DDI_TOP_BOTH_FIELD_STAGGER:
                    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(13),BIT(13));
                    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_19,BIT(14),BIT(14));
                    _gbDWIN0FieldStagger = TRUE;
                    break;
                case E_DIP_3DDI_BOTTOM_SINGLE_FIELD:
                    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0 ,BIT(13));
                    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_19, 0 ,BIT(14));
                    _gbDWIN0FieldStagger = FALSE;
                    break;
                case E_DIP_3DDI_BOTTOM_BOTH_FIELD_STAGGER:
                    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(13),BIT(13));
                    MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_19, 0 ,BIT(14));
                    _gbDWIN0FieldStagger = TRUE;
                    break;
                case E_DIP_P_MODE_DNR:
                    _gbDWIN0FieldStagger = FALSE;
                    break;
                default:
                    _gbDWIN0FieldStagger = FALSE;
                    XC_ERR("[ERROR][%s,%d],Chip Not Support(%d)\n",__func__,__LINE__,stDIPRDISetting.enDI_Field);
                    break;
            }
            if(stDIPRDISetting.enDI_Field == E_DIP_P_MODE_DNR)
            {
                HAL_XC_DIP_SetPDNRMode(pInstance,TRUE,eWindow);
            }
            else
            {
                HAL_XC_DIP_SetDIMode(pInstance,TRUE,eWindow);
            }
        }
        else
        {
            if(stDIPRDISetting.enDI_Field == E_DIP_P_MODE_DNR)
            {
                HAL_XC_DIP_SetPDNRMode(pInstance,FALSE,eWindow);
            }
            else
            {
                HAL_XC_DIP_SetDIMode(pInstance,FALSE,eWindow);
            }
        }
    }
}

void HAL_XC_DIP_Rotation(void *pInstance, MS_BOOL bRotation,EN_XC_DIP_ROTATION eRoDirection,MS_PHY u64StartAddr,SCALER_DIP_WIN eTmpWindow)
{
    MS_U16 u16BusSize = 0;
    SCALER_DIP_WIN eWindow = eTmpWindow;
    bDIPRotation = bRotation;
    DIPRotation = eTmpWindow;

    u16BusSize = HAL_XC_DIP_GetBusSize(pInstance,eTmpWindow);
    if( (u16BusSize == DIP_BYTE_PER_WORD) && (bRotation == TRUE) )
    {
        MDrv_DIP_WriteByteMask(REG_CKG_FMCLK, 0x0, CKG_FMCLK_GATED);
        MDrv_DIP_WriteByteMask(REG_CKG_FMCLK, CKG_FMCLK_MIU_128, CKG_FMCLK_MASK);
        MDrv_DIP_WriteByteMask(REG_CKG_SC_ROT, CKG_SC_ROT_MIU_128, CKG_SC_ROT_MASK);
    }
    else if( (u16BusSize == DWIN_BYTE_PER_WORD) && (bRotation == TRUE) )
    {
        MDrv_DIP_WriteByteMask(REG_CKG_FMCLK, 0x0, CKG_FMCLK_GATED);
        MDrv_DIP_WriteByteMask(REG_CKG_FMCLK, CKG_FMCLK_MIU_256, CKG_FMCLK_MASK);
        MDrv_DIP_WriteByteMask(REG_CKG_SC_ROT, CKG_SC_ROT_MIU_256, CKG_SC_ROT_MASK);
    }
    else
    {
        MDrv_DIP_WriteByteMask(REG_CKG_FMCLK, CKG_FMCLK_MIU_128, CKG_FMCLK_MASK);
        MDrv_DIP_WriteByteMask(REG_CKG_SC_ROT, CKG_SC_ROT_MIU_128, CKG_SC_ROT_MASK);
    }
    if(bRotation)
    {
        DIP_W2BYTEMSK(0, REG_SC_BKBF_20_L,BIT(11)|BIT(3),BIT(11)|BIT(3));
    }
    else
    {
        DIP_W2BYTEMSK(0, REG_SC_BKBF_20_L,0,BIT(11)|BIT(3));
    }

    //reg_rotate_mode
    DIP_W2BYTEMSK(0, REG_SC_BK34_10_L,eRoDirection<<14,BIT(14));
    //rotate destination 0:dwin0 1:dwin1 2:dip
    if(eTmpWindow == DIP_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK34_6E_L,BIT(15),BMASK(15:14));
    }
    else if(eTmpWindow == DWIN0_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK34_6E_L,0x0,BMASK(15:14));
    }
    else if(eTmpWindow == DWIN1_WINDOW )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK34_6E_L,BIT(14),BMASK(15:14));
    }

}
void HAL_XC_DIP_SetPinpon(void *pInstance, MS_BOOL bPinpon,MS_PHY u64PinponAddr,MS_PHY u64OffSet,SCALER_DIP_WIN eWindow)
{
    MS_U16 u16BusSize = 0;
    MS_U64 u64_result = 0;

    u16BusSize = HAL_XC_DIP_GetBusSize(pInstance, eWindow);
    if( eWindow == DIP_WINDOW )
    {
        u64_result = u64PinponAddr;
        DO_DIV(u64_result,u16BusSize);
        DIP_W4BYTE(0, REG_SC_BK36_20_L, u64_result);
        DIP_W4BYTE(0, REG_SC_BK36_50_L,u64OffSet);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        u64_result = u64PinponAddr;
        DO_DIV(u64_result,u16BusSize);
        DIP_W4BYTE(0, REG_SC_BK3B_20_L, u64_result);
        DIP_W4BYTE(0, REG_SC_BK3B_50_L,u64OffSet);
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        u64_result = u64PinponAddr;
        DO_DIV(u64_result,u16BusSize);
        DIP_W4BYTE(0, REG_SC_BK3C_20_L, u64_result);
        DIP_W4BYTE(0, REG_SC_BK3C_50_L,u64OffSet);
    }
}
SCALER_DIP_WIN HAL_XC_DIP_GetHVSP(void* pInstance)
{
    return MAX_DIP_WINDOW;
}
MS_BOOL HAL_XC_DIP_SetHVSP(void* pInstance,MS_BOOL bSelect, SCALER_DIP_WIN eWindow)
{
    return FALSE;
}

MS_BOOL HAL_XC_DIP_Set420TileBlock(void* pInstance,EN_XC_DIP_TILE_BLOCK eTileBlock,SCALER_DIP_WIN eWindow)
{
    MS_BOOL bMfdEna = 0;

    _HAL_XC_DIP_Get_Mfdec_Enable(&bMfdEna, eWindow);

    if(eTileBlock == DIP_TILE_BLOCK_R_16_32)
    {
        if(bMfdEna == TRUE)
        {
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, BIT(9), BIT(9)); //enable dipr tile 32x16
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0, BIT(10));//disable dipr tile 32x32
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0, BIT(3)); //dipr save bw
        }
        else
        {
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0, BIT(9)); //disable dipr tile 32x16
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0, BIT(10));//disable dipr tile 32x32
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, BIT(3), BIT(3)); //dipr save bw
        }
    }
    else if(eTileBlock == DIP_TILE_BLOCK_R_32_16)
    {
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(9),BIT(9)); //enable dipr tile 32x16
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0, BIT(10));//disable dipr tile 32x32
        MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0, BIT(3)); //dipr save bw
    }
    else if(eTileBlock == DIP_TILE_BLOCK_R_32_32)
    {
        if(bMfdEna == TRUE)
        {
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, BIT(9), BIT(9)); //enable dipr tile 32x16
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0, BIT(10));//disable dipr tile 32x32
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0, BIT(3)); //dipr save bw
        }
        else
        {
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0, BIT(9)); //diable dipr tile 32x16
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01,BIT(10),BIT(10));//enable dipr tile 32x32
            MDrv_DIP_Write2ByteMask(REG_DIPR_BK1210_01, 0, BIT(3)); //dipr save bw
        }
    }
    else if(eTileBlock == DIP_TILE_BLOCK_R_10Bit_LSB_128_64)
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_0C_L,BIT(7),BIT(7));
    }
    else if( (eTileBlock == DIP_TILE_BLOCK_W_16_32) && (eWindow == DIP_WINDOW) )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_0B_L,0x0,BIT(12));
        DIP_W2BYTEMSK(0, REG_SC_BK36_0B_L,0x0,BIT(14));
    }
    else if( (eTileBlock == DIP_TILE_BLOCK_W_32_16) && (eWindow == DIP_WINDOW) )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_0B_L,BIT(12),BIT(12));
        DIP_W2BYTEMSK(0, REG_SC_BK36_0B_L,0x0,BIT(14));
    }
    else if( (eTileBlock == DIP_TILE_BLOCK_W_32_32) && (eWindow == DIP_WINDOW) )
    {
        DIP_W2BYTEMSK(0, REG_SC_BK36_0B_L,0x0,BIT(12));
        DIP_W2BYTEMSK(0, REG_SC_BK36_0B_L,BIT(14),BIT(14));
    }
    else
        return FALSE;

    return TRUE;
}

void HAL_XC_DIP_Recovery(void *pInstance, SCALER_DIP_WIN eWindow)
{
    _gbIsSetSourceInfo[eWindow] = FALSE;
}

MS_BOOL HAL_XC_DIP_SC1_SCMI_ENABLE(void* pInstance,MS_BOOL bEnable, MS_U8 u8FrameCnt, SCALER_DIP_WIN eWindow)
{
    return TRUE;
}

MS_BOOL HAL_XC_DIP_Set_Secure_Mode(void* pInstance,MS_BOOL bEnable, ST_DIP_SET_SECURE_MODE_EXTEND stSecureExtend, SCALER_DIP_WIN eWindow)
{
    return TRUE;
}

MS_BOOL HAL_XC_DIP_Set_PowerState(void* pInstance,EN_POWER_MODE enPowerState)
{
    return TRUE;
}

static void HAL_XC_DIP_CallBack(InterruptNum eIntNum)
{
    if( (SC_R2BYTEMSK(0, REG_SC_BK36_0A_L,BMASK(7:0)) > 0) && (pDipIntCb != NULL) )
    {
        #ifdef STELLAR
        (void)(pDipIntCb)(SC_R2BYTEMSK(0, REG_SC_BK36_0A_L,BMASK(7:0)));
        #else
        (void)(pDipIntCb)(eIntNum);
        #endif
    }
    if( (SC_R2BYTEMSK(0, REG_SC_BK3B_0A_L,BMASK(7:0)) > 0) && (pDwin0IntCb != NULL) )
    {
        #ifdef STELLAR
        (void)(pDwin0IntCb)(SC_R2BYTEMSK(0, REG_SC_BK3B_0A_L,BMASK(7:0)));
        #else
        (void)(pDwin0IntCb)(eIntNum);
        #endif
    }
    if( (SC_R2BYTEMSK(0, REG_SC_BK3C_0A_L,BMASK(7:0)) > 0) && (pDwin1IntCb != NULL) )
    {
        #ifdef STELLAR
        (void)(pDwin1IntCb)(SC_R2BYTEMSK(0, REG_SC_BK3C_0A_L,BMASK(7:0)));
        #else
        (void)(pDwin1IntCb)(eIntNum);
        #endif
    }

    MsOS_EnableInterrupt(E_INT_IRQ_DIPW);
}
void HAL_XC_DIP_InterruptAttach(void *pInstance, InterruptCb pIntCb,SCALER_DIP_WIN eWindow)
{
    if(bAttached == FALSE)
    {
        MsOS_AttachInterrupt(E_INT_IRQ_DIPW,HAL_XC_DIP_CallBack);
    }
    bAttached = TRUE;

    if( (bDipIsr == FALSE) && (bDwin0Isr == FALSE) && (bDwin1Isr == FALSE))
    {
        MsOS_EnableInterrupt(E_INT_IRQ_DIPW);
    }

    if( eWindow == DIP_WINDOW )
    {
        pDipIntCb = pIntCb;
        bDipIsr = TRUE;
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        pDwin0IntCb = pIntCb;
        bDwin0Isr = TRUE;
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        pDwin1IntCb = pIntCb;
        bDwin1Isr = TRUE;
    }
    else
    {
        return;
    }
}
void HAL_XC_DIP_InterruptDetach(void *pInstance, SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        bDipIsr = FALSE;
#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK34_7E_L, BMASK(7:4) , BMASK(7:4));
#endif
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        bDwin0Isr = FALSE;
#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK3B_7F_L, BMASK(3:0) , BMASK(3:0));
#endif
    }
    else if( eWindow == DWIN1_WINDOW )
    {
    	bDwin1Isr = FALSE;
#ifdef CONFIG_MSTAR_SRAMPD
        DIP_W2BYTEMSK(0, REG_SC_BK3C_7F_L, BMASK(3:0) , BMASK(3:0));
#endif
    }
    else
    {
    	return;
    }

    if( (bDipIsr == FALSE) && (bDwin0Isr == FALSE) && (bDwin1Isr == FALSE))
    {
    MsOS_DisableInterrupt(E_INT_IRQ_DIPW);
    //MsOS_DetachInterrupt(E_INT_IRQ_DIPW); // do not deattach, because deattach will take 100 ms to wait pthread join
    }
}

void HAL_XC_DIP_2P_Width_Check(void *pInstance, XC_SETWIN_INFO *pstXC_SetWin_Info, SCALER_DIP_WIN eWindow)
{
    MS_U16 u16bpp = 0;
    MS_U16 u16alignment = 0;
    MS_U16 u16tmp = 0;
    MS_U64 u64_result = 0;
#ifdef UTOPIA_V2
        DIP_INSTANCE_PRIVATE* pDipPri = NULL;
        DIP_SHARE_RESOURCE_PRIVATE* pDipResPri = NULL;
        UtopiaInstanceGetPrivate(pInstance, (void*)&pDipPri);
        UtopiaResourceGetPrivate(pDipPri->pShareResource,(void*)&(pDipResPri));
#endif
    EN_DRV_XC_DWIN_DATA_FMT fmt;

    fmt = HAL_XC_DIP_GetDataFmt(pInstance, eWindow);
    u16bpp = HAL_XC_DIP_GetBPP(pInstance, fmt,eWindow);

    u64_result = DWIN_BYTE_PER_WORD;
    DO_DIV(u64_result,u16bpp);
    u16alignment = u64_result;

    if(eWindow == DIP_WINDOW)
    {
        if((pstXC_SetWin_Info->bPreVCusScaling == TRUE) && (pstXC_SetWin_Info->u16PreVCusScalingSrc > pstXC_SetWin_Info->u16PreVCusScalingDst))
        {
            if(((pstXC_SetWin_Info->u16PreHCusScalingSrc) > FHD_WIDTH) && ((pstXC_SetWin_Info->u16PreHCusScalingDst) > FHD_WIDTH))
            {
                pstXC_SetWin_Info->bPreHCusScaling = TRUE;
                pstXC_SetWin_Info->u16PreHCusScalingDst = FHD_WIDTH;
            }
        }
    }

    u64_result = pstXC_SetWin_Info->u16PreHCusScalingDst;
    DO_DIV(u64_result,u16alignment);
    u16tmp = u64_result;

    pstXC_SetWin_Info->u16PreHCusScalingDst= u16tmp*u16alignment;

#if (DIP_PQ_SETTINGS == TRUE)
    if(eWindow == DWIN0_WINDOW)
    {
        if(_gstDwin0XCInfo.bPathEnabled == TRUE)
        {
            enDWIN0InputType = _gstDwin0XCInfo.enXCInputSrcType;
        }
        else
        {
            enDWIN0InputType = pstXC_SetWin_Info->enInputSourceType;
        }
    }
#endif
}

#ifdef CONFIG_UTOPIA_PROC_DBG_SUPPORT
void HAL_XC_DIP_Check_Clock(MS_U64* u64ReqHdl,SCALER_DIP_WIN eWindow)
{
    char string_DIP_Clock[12];
    char DIP_345M[] = "345M";
    char DIP_320M[] = "320M";
    char DIP_240M[] = "240M";
    char DIP_216M[] = "216M";
    char DIP_192M[] = "192M";
    char DIP_690M[] = "690M";
    char DIP_NotDefine[] = "Not Define";
    MS_U16 u16tmp=0;

    //DIP clock
    u16tmp = MDrv_ReadByte(REG_CKG_FCLK)&CKG_FCLK_MASK;
    if(u16tmp == CKG_FCLK_345MHZ)
    {
        strcpy(string_DIP_Clock, DIP_345M);
    }
    else if(u16tmp == CKG_FCLK_320MHZ)
    {
        strcpy(string_DIP_Clock, DIP_320M);
    }
    else if(u16tmp == CKG_FCLK_240MHZ)
    {
        strcpy(string_DIP_Clock, DIP_240M);
    }
    else if(u16tmp == CKG_FCLK_216MHZ)
    {
        strcpy(string_DIP_Clock, DIP_216M);
    }
    else if(u16tmp == CKG_FCLK_192MHZ)
    {
        strcpy(string_DIP_Clock, DIP_192M);
    }
    else if(u16tmp == CKG_FCLK_690MHZ)
    {
        strcpy(string_DIP_Clock, DIP_690M);
    }
    else
    {
        strcpy(string_DIP_Clock, DIP_NotDefine);
    }
    MdbPrint(u64ReqHdl,"DIP Clock:%s\n",string_DIP_Clock);
}

void HAL_XC_DIP_Check_Scale(MS_U64* u64ReqHdl,MS_U16 *u16H_Scaling_Enable, MS_U32 *u32H_Scaling_Ratio, MS_U16 *u16V_Scaling_Enable, MS_U32 *u32V_Scaling_Ratio,SCALER_DIP_WIN eWindow)
{
    if( eWindow == DIP_WINDOW )
    {
        //HV scaling enable/ratio
        *u16H_Scaling_Enable = (SC_R2BYTE(0, REG_SC_BK34_6C_L) & BIT(15)) >> 15 ;
        *u32H_Scaling_Ratio =  SC_R4BYTE(0, REG_SC_BK34_2C_L) & BMASK(22:0);
        *u16V_Scaling_Enable = (SC_R4BYTE(0, REG_SC_BK34_08_L) & BIT(31)) >> 31;
        *u32V_Scaling_Ratio =  SC_R4BYTE(0, REG_SC_BK34_08_L) & BMASK(22:0);
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        //HV scaling enable/ratio
        *u16H_Scaling_Enable = (SC_R2BYTE(0, REG_SC_BK3B_78_L) & BIT(15)) >> 15 ;
        *u32H_Scaling_Ratio =  SC_R4BYTE(0, REG_SC_BK3B_37_L) & BMASK(22:0);
        *u16V_Scaling_Enable = (SC_R4BYTE(0, REG_SC_BK3B_1B_L) & BIT(31)) >> 31;
        *u32V_Scaling_Ratio =  SC_R4BYTE(0, REG_SC_BK3B_1B_L) & BMASK(22:0);
    }
    else if( eWindow == DWIN1_WINDOW )
    {
        //HV scaling enable/ratio
        *u16H_Scaling_Enable = (SC_R2BYTE(0, REG_SC_BK3C_78_L) & BIT(15)) >> 15 ;
        *u32H_Scaling_Ratio =  SC_R4BYTE(0, REG_SC_BK3C_37_L) & BMASK(22:0);
        *u16V_Scaling_Enable = (SC_R4BYTE(0, REG_SC_BK3C_1B_L) & BIT(31)) >> 31;
        *u32V_Scaling_Ratio =  SC_R4BYTE(0, REG_SC_BK3C_1B_L) & BMASK(22:0);
    }
}
void HAL_XC_DIP_ShowColorConvertMode(MS_U64* u64ReqHdl, SCALER_DIP_WIN eWindow)
{
    MS_U16 u16RegValue=0;

    if( eWindow == DIP_WINDOW )
    {
        u16RegValue = (SC_R2BYTEMSK(0, REG_SC_BK34_6C_L, BMASK(10:9))? 1:0);
        MdbPrint(u64ReqHdl,"422 to 444: 4k_hsd mode    = \t%s\n",(u16RegValue > 0 ? "Enable":"Disable"));

        u16RegValue = (SC_R2BYTEMSK(0, REG_SC_BK34_2B_L, BIT(6))? 1:0);
        MdbPrint(u64ReqHdl,"444 to 422: 4k_hsd mode    = \t%s\n",(u16RegValue > 0 ? "Enable":"Disable"));

        u16RegValue = (SC_R2BYTEMSK(0, REG_SC_BK34_30_L, BIT(0))? 1:0);
        MdbPrint(u64ReqHdl,"444 to 422:                = \t%s\n",(u16RegValue > 0 ? "Enable":"Disable"));

        u16RegValue = (SC_R2BYTEMSK(0, REG_SC_BK34_68_L, BMASK(1:0))? 1:0);
        MdbPrint(u64ReqHdl,"422 to 444: for osdb       = \t%s\n",(u16RegValue > 0 ? "Enable":"Disable"));

        u16RegValue = (SC_R2BYTEMSK(0, REG_SC_BK34_0B_L, BIT(12))? 1:0);
        MdbPrint(u64ReqHdl,"444 to 422: for osdb       = \t%s\n",(u16RegValue > 0 ? "Enable":"Disable"));
    }
    else if( eWindow == DWIN0_WINDOW )
    {
        u16RegValue = (SC_R2BYTEMSK(0, REG_SC_BK3B_78_L, BMASK(10:9))? 1:0);
        MdbPrint(u64ReqHdl,"422 to 444: 4k_hsd mode    = \t%s\n",(u16RegValue > 0 ? "Enable":"Disable"));

        u16RegValue = (SC_R2BYTEMSK(0, REG_SC_BK3B_75_L, BIT(6))? 1:0);
        MdbPrint(u64ReqHdl,"444 to 422: 4k_hsd mode    = \t%s\n",(u16RegValue > 0 ? "Enable":"Disable"));

        u16RegValue = (SC_R2BYTEMSK(0, REG_SC_BK3B_44_L, BIT(0))? 1:0);
        MdbPrint(u64ReqHdl,"444 to 422:                = \t%s\n",(u16RegValue > 0 ? "Enable":"Disable"));
    }
    else
    {
        MdbPrint(u64ReqHdl,"Not Support DIP%d\n",eWindow);
    }
}
MS_BOOL HAL_XC_DIP_Get_Mfdec_Enable(MS_U64* u64ReqHdl, SCALER_DIP_WIN eWindow)
{
    MS_BOOL bRet=FALSE;

    _HAL_XC_DIP_Get_Mfdec_Enable(&bRet, eWindow);

    return bRet;
}
#endif

void HAL_XC_DIP_Enable(void *pInstance, MS_BOOL bEnable)
{
#ifdef MSOS_TYPE_OPTEE
    MDrv_WriteRegBit(REG_TZPC_NONPM_DIP, BMASK(1:0), BMASK(1:0));
    MDrv_WriteRegBit(REG_TZPC_NONPM_DWIN0, BMASK(11:8), BMASK(11:8));
#endif

    if(bEnable)
    {
#ifdef MSOS_TYPE_OPTEE
        MDrv_WriteRegBit(REG_TZPC_NONPM_DIP, 0, BMASK(1:0));
        MDrv_WriteRegBit(REG_TZPC_NONPM_DWIN0, 0, BMASK(11:8));
#endif
    }
    else
    {
#ifdef MSOS_TYPE_OPTEE
        MDrv_WriteRegBit(REG_TZPC_NONPM_DIP, BMASK(1:0), BMASK(1:0));
        MDrv_WriteRegBit(REG_TZPC_NONPM_DWIN0, BMASK(11:8), BMASK(11:8));
#endif
        SC_W2BYTEMSK(0, REG_SC_BK36_02_L, BIT(10) , BIT(10));
        SC_W2BYTEMSK(0, REG_SC_BK3B_02_L, BIT(10) , BIT(10));
        SC_W2BYTEMSK(0, REG_SC_BK3C_02_L, BIT(10) , BIT(10));
    }
}

void HAL_XC_DIP_IMI_ENABLE(void* pInstance,MS_BOOL bEnable, SCALER_DIP_WIN eWindow)
{
    if(bEnable == TRUE)
    {
        DIP_H_ERR("[%s][%d] IMI is not support\n",__func__,__LINE__);
    }
}

void HAL_XC_DIP_SetSourceInfo(void* pInstance,ST_DIP_SET_SOURCE_INFO *pstSetSrcInfo, SCALER_DIP_WIN eWindow)
{
    if(pstSetSrcInfo != NULL)
    {
        memset(&_gstDIPSourceInfo[eWindow] , 0 , sizeof(ST_DIP_SET_SOURCE_INFO));
        memcpy(&_gstDIPSourceInfo[eWindow], pstSetSrcInfo, sizeof(ST_DIP_SET_SOURCE_INFO));
        _gbIsSetSourceInfo[eWindow] = TRUE;
    }
}

MS_BOOL HAL_XC_DIP_FillXCApiStatus(void* pInstance, ST_DRV_DIP_GET_XC_STATUS *pstGetXCStatus)
{
    memset(&_gstGetXCStatus, 0, sizeof(ST_DRV_DIP_GET_XC_STATUS));
    memcpy(&_gstGetXCStatus, pstGetXCStatus, sizeof(ST_DRV_DIP_GET_XC_STATUS));

    return TRUE;
}
MS_BOOL HAL_XC_DIP_SetBuffer(void* pInstance,ST_DRV_DIP_Buffer *pstSetBuffInfo)
{
    MS_U16 u16BusSize = 0;
    MS_PHY phyDIPBuffer = 0;

    if(pstSetBuffInfo->enBufType == E_DRV_DIP_DI_DNR_BUFFER)
    {
        if(pstSetBuffInfo->eWindow == DWIN0_WINDOW)
        {
            if(pstSetBuffInfo->u32BufSize < DI_DNR_BUFFER_SIZE)
            {
                DIP_H_ERR("[%s][%d]u32BufSize = 0x%x < DI_DNR_BUFFER_SIZE = 0x%x.Buffer is too small.\n",__func__,__LINE__,pstSetBuffInfo->u32BufSize,DI_DNR_BUFFER_SIZE);
                _gbDwin0BufferInit = FALSE;
                return FALSE;
            }
            else
            {
                u16BusSize = HAL_XC_DIP_GetBusSize(pInstance,pstSetBuffInfo->eWindow);
                phyDIPBuffer = DO_DIV(pstSetBuffInfo->phyBufAddr,u16BusSize);
                MDrv_DIP_Write4Byte(REG_DDI1_EXT38_0E,phyDIPBuffer);
                MDrv_DIP_Write4Byte(REG_DDI1_EXT38_26,phyDIPBuffer);
                _gbDwin0BufferInit = TRUE;
            }
        }
        else
        {
            DIP_H_ERR("[%s][%d] DIP %u not support DI/DNR\n",__func__,__LINE__,pstSetBuffInfo->eWindow);
            return FALSE;
        }
    }
    return TRUE;
}

MS_BOOL HAL_XC_DIP_SetDIMode(void* pInstance, MS_BOOL bEnable,SCALER_DIP_WIN eWindow)
{
    if(eWindow == DWIN0_WINDOW)
    {
        if(bEnable == TRUE)
        {
            if(_gbDwin0BufferInit == TRUE)
            {
                //ddiw
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_08,0,BMASK(5:4));
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_08,BIT(15),BIT(15));
                //ddir
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_20,0,BMASK(5:4));
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_20,BIT(15),BIT(15));
                //ddi src dst swap
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_40,BMASK(1:0),BMASK(1:0));
                //P mode DNR disable
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_41,0x0,BIT(1));
                //MADI enalbe
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_41,BIT(7),BIT(7));
                //DI enable
                DIP_W2BYTEMSK(0, REG_SC_BK3B_0C_L, BIT(10) , BIT(10));
                _gbDWIN0DIEna = TRUE;
            }
            else
            {
                DIP_H_ERR("[%s][%d] DIP %u buffer has not been Init\n",__func__,__LINE__,eWindow);
                return FALSE;
            }
        }
        else
        {
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_08,0x0,BIT(15));
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_20,0x0,BIT(15));
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_41,0x0,BIT(7));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_0C_L,0x0, BIT(10));
            _gbDWIN0DIEna = FALSE;
        }
    }
    else
    {
        DIP_H_ERR("[%s][%d] DIP %u not support DI\n",__func__,__LINE__,eWindow);
        return FALSE;
    }
    return TRUE;
}

MS_BOOL HAL_XC_DIP_SetPDNRMode(void* pInstance, MS_BOOL bEnable,SCALER_DIP_WIN eWindow)
{
    if(eWindow == DWIN0_WINDOW)
    {
        if(bEnable == TRUE)
        {
            if(_gbDwin0BufferInit == TRUE)
            {
                //ddiw
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_08,0,BMASK(5:4));
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_08,BIT(15),BIT(15));
                //ddir
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_20,0,BMASK(5:4));
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_20,BIT(15),BIT(15));
                //ddi src dst swap
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_40,BMASK(1:0),BMASK(1:0));
                //P mode DNR enable
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_41,BIT(1),BIT(1));
                //MADI disable
                MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_41,0x0,BIT(7));
                //DI enable
                DIP_W2BYTEMSK(0, REG_SC_BK3B_0C_L, BIT(10) , BIT(10));
                _gbDWIN0DNREna = TRUE;
            }
            else
            {
                DIP_H_ERR("[%s][%d] DIP %u buffer has not been Init\n",__func__,__LINE__,eWindow);
                return FALSE;
            }
        }
        else
        {
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_08,0x0,BIT(15));
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_20,0x0,BIT(15));
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_41,0x0,BIT(1));
            MDrv_DIP_Write2ByteMask(REG_DDI1_EXT38_41,0x0,BIT(7));
            DIP_W2BYTEMSK(0, REG_SC_BK3B_0C_L,0x0, BIT(10));
            _gbDWIN0DNREna = FALSE;
        }
    }
    else
    {
        DIP_H_ERR("[%s][%d] DIP %u not support DNR\n",__func__,__LINE__,eWindow);
        return FALSE;
    }
    return TRUE;
}

MS_BOOL HAL_XC_DIP_SetDIPRBlending(void* pInstance, EN_DRV_XC_DIPR_ENGINE enDIPRSel,EN_DRV_XC_DIPR_BLENDING_DST enDIPRDst,MS_BOOL bEnable,SCALER_DIP_WIN eWindow)
{
    DIP_H_ERR("[%s][%d] DIP %u not support\n",__func__,__LINE__,eWindow);
    return FALSE;
}

MS_BOOL MHal_XC_DIP_SET_XC_PATH_INFO(void* pInstance, ST_DRV_DIP_SET_XCPATH_INFO *pstdrvSetXCPathInfo)
{
    if(pstdrvSetXCPathInfo == NULL)
    {
        DIP_H_ERR("[%s][%d]pstdrvSetXCPathInfo is NULL\n",__func__,__LINE__);
        return FALSE;
    }
    else
    {
        if(pstdrvSetXCPathInfo->eWindow == DWIN0_WINDOW)
        {
            memset(&_gstDwin0XCInfo, 0, sizeof(ST_DRV_DIP_XCPathInfo));
            memcpy(&_gstDwin0XCInfo, &(pstdrvSetXCPathInfo->stXCInfo), sizeof(ST_DRV_DIP_XCPathInfo));
        }
        return TRUE;
    }
}

MS_BOOL HAL_XC_DIP_SetHDMIInfo(void*Instance,ST_DRV_DIP_HDMI_INFO *pstHDMIInfo)
{
    memcpy(&_gstHDMIInfo[pstHDMIInfo->eWindow],pstHDMIInfo,sizeof(ST_DRV_DIP_HDMI_INFO));

    return TRUE;
}
//=============== DIP =====================//

#endif
#undef  MHAL_SC_C

