//<MStar Software>
//******************************************************************************
// MStar Software
// Copyright (c) 2010 - 2012 MStar Semiconductor, Inc. All rights reserved.
// All software, firmware and related documentation herein ("MStar Software") are
// intellectual property of MStar Semiconductor, Inc. ("MStar") and protected by
// law, including, but not limited to, copyright law and international treaties.
// Any use, modification, reproduction, retransmission, or republication of all
// or part of MStar Software is expressly prohibited, unless prior written
// permission has been granted by MStar.
//
// By accessing, browsing and/or using MStar Software, you acknowledge that you
// have read, understood, and agree, to be bound by below terms ("Terms") and to
// comply with all applicable laws and regulations:
//
// 1. MStar shall retain any and all right, ownership and interest to MStar
//    Software and any modification/derivatives thereof.
//    No right, ownership, or interest to MStar Software and any
//    modification/derivatives thereof is transferred to you under Terms.
//
// 2. You understand that MStar Software might include, incorporate or be
//    supplied together with third party`s software and the use of MStar
//    Software may require additional licenses from third parties.
//    Therefore, you hereby agree it is your sole responsibility to separately
//    obtain any and all third party right and license necessary for your use of
//    such third party`s software.
//
// 3. MStar Software and any modification/derivatives thereof shall be deemed as
//    MStar`s confidential information and you agree to keep MStar`s
//    confidential information in strictest confidence and not disclose to any
//    third party.
//
// 4. MStar Software is provided on an "AS IS" basis without warranties of any
//    kind. Any warranties are hereby expressly disclaimed by MStar, including
//    without limitation, any warranties of merchantability, non-infringement of
//    intellectual property rights, fitness for a particular purpose, error free
//    and in conformity with any international standard.  You agree to waive any
//    claim against MStar for any loss, damage, cost or expense that you may
//    incur related to your use of MStar Software.
//    In no event shall MStar be liable for any direct, indirect, incidental or
//    consequential damages, including without limitation, lost of profit or
//    revenues, lost or damage of data, and unauthorized system use.
//    You agree that this Section 4 shall still apply without being affected
//    even if MStar Software has been modified by MStar in accordance with your
//    request or instruction for your use, except otherwise agreed by both
//    parties in writing.
//
// 5. If requested, MStar may from time to time provide technical supports or
//    services in relation with MStar Software to you for your use of
//    MStar Software in conjunction with your or your customer`s product
//    ("Services").
//    You understand and agree that, except otherwise agreed by both parties in
//    writing, Services are provided on an "AS IS" basis and the warranty
//    disclaimer set forth in Section 4 above shall apply.
//
// 6. Nothing contained herein shall be construed as by implication, estoppels
//    or otherwise:
//    (a) conferring any license or right to use MStar name, trademark, service
//        mark, symbol or any other identification;
//    (b) obligating MStar or any of its affiliates to furnish any person,
//        including without limitation, you and your customers, any assistance
//        of any kind whatsoever, or any information; or
//    (c) conferring any license or right under any intellectual property right.
//
// 7. These terms shall be governed by and construed in accordance with the laws
//    of Taiwan, R.O.C., excluding its conflict of law rules.
//    Any and all dispute arising out hereof or related hereto shall be finally
//    settled by arbitration referred to the Chinese Arbitration Association,
//    Taipei in accordance with the ROC Arbitration Law and the Arbitration
//    Rules of the Association by three (3) arbitrators appointed in accordance
//    with the said Rules.
//    The place of arbitration shall be in Taipei, Taiwan and the language shall
//    be English.
//    The arbitration award shall be final and binding to both parties.
//
//******************************************************************************
//<MStar Software>
////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////
//==============================================================================
// [mhal_sc.c]
// Date: 20081203
// Descriptions: Add a new layer for HW setting
//==============================================================================
#define  MHAL_SC_C

#ifdef MSOS_TYPE_LINUX_KERNEL
#include <linux/string.h>
#include <asm/div64.h>
#else
#include <string.h>
#define do_div(x,y) ((x)/=(y))
#endif
#include "UFO.h"

// Common Definition
#include "MsCommon.h"
#include "MsIRQ.h"
#include "MsOS.h"
#include "mhal_xc_chip_config.h"
#include "utopia.h"
#include "utopia_dapi.h"
#include "xc_hwreg_utility2.h"
#include "hwreg_pm_sleep.h"//alex_tung
#include "xc_Analog_Reg.h"
#include "drvXC_IOPort.h"
#include "apiXC.h"
#include "drv_sc_display.h"
#include "drv_sc_isr.h"
#include "apiXC_Adc.h"
#include "apiXC_PCMonitor.h"
#include "apiXC_ModeParse.h"
#include "apiXC_Auto.h"
#include "apiXC_Ace.h"
#include "apiXC_Common.h"
#ifdef UFO_XC_VMARK
#include "apiXC_VMark.h"
#endif
#include "drvXC_HDMI_if.h"
#include "mvideo_context.h"
#include "drv_sc_ip.h"
#include "mhal_dynamicscaling.h"
#include "mdrv_sc_dynamicscaling.h"
#include "drvXC_HDMI_Internal.h"
#include "drvMVOP.h"
#include "drvIPAUTH.h"
#include "hwreg_ipmux.h"

#if (LD_ENABLE==1)
#include "mdrv_ld.h"
#include "mdrv_ldalgo.h"
#endif
#include "mdrv_sc_3d.h"
#include "drv_sc_menuload.h"
#include "drvXC_ADC_Internal.h"
#include "mhal_sc.h"
#include "mhal_mux.h"
#if FRC_INSIDE
#include "mdrv_frc.h"
#include "mhal_frc.h"
#endif
#include "XC_private.h"
#include "mhal_menuload.h"
#include "halCHIP.h"
#include "drvSYS.h"
#include "drv_sc_scaling.h"
#include "drvSEAL.h"
#include "drvMIU.h"
#include "drvMMA.h"

#if (defined MSOS_TYPE_LINUX) || (defined ANDROID)
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h> // O_RDWR
#include <poll.h>
#endif

#include "mdrv_xc_io.h"
#include "mdrv_xc_st.h"
#include "apiPNL.h"

#ifdef MSOS_TYPE_LINUX
static MS_S32   _s32FdScaler = -1;
#endif

#ifndef DONT_USE_CMA
#if (XC_SUPPORT_CMA ==TRUE)
#ifdef MSOS_TYPE_LINUX_KERNEL
#include "drvCMAPool_v2.h"
#else
#include "drvCMAPool.h"
#endif
#include "mdrv_cma_pool_st.h"
#endif
#endif
#if ((defined (ANDROID) || defined(MSOS_TYPE_LINUX_KERNEL) || defined(ROLLS_ROYCE)) && defined(UFO_XC_DS_PQ))
#include "drvPQ_Define.h"
#endif
#include "drvPQ.h"

//#include <assert.h>
#ifdef ANDROID
#include <cutils/log.h>
#ifndef LOGE
#define printf(format, args...)          ALOGE(format, ##args);
#else
#define printf(format, args...)          LOGE(format, ##args);
#endif
#endif

#define DBG_EN  0
#if DBG_EN
#define SC_DBG(x)   x
#define FPLL_DBG(x) x
#else
#define SC_DBG(x)
#define FPLL_DBG(x)
#endif
#define new_chakra

#define MIU_SEL_USE_XC_INTERNAL   TRUE
#ifdef CONFIG_UTOPIA_PROC_DBG_SUPPORT
extern MS_U32 u32SetWindowTime;
//extern MS_U16 QM_InputSourceToIndex(void* pInstance, PQ_WIN eWindow, MS_U8 enInputSourceType);
#endif
#ifdef MSOS_TYPE_LINUX_KERNEL
#define atoi(str) simple_strtoul(((str != NULL) ? str : ""), NULL, 0)
#endif

#define COUNT_OF_ARRAY(array) (((array)!=NULL)?(sizeof(array)/sizeof((array)[0])):0)
#define MDrv_AUTH_IPCheck(args...)  0

//==============================================================================
//==============================================================================
MS_VIRT _XC_RIU_BASE;
MS_VIRT _PM_RIU_BASE;
#ifdef SUPPORT_XC_EXT_REG
MS_VIRT _XC_EXT_RIU_BASE;
#endif

MS_VIRT _DVI_ATOP_RIU_BASE;
MS_VIRT _DVI_DTOP_RIU_BASE;
MS_VIRT _HDCP_RIU_BASE;
MS_VIRT _DVI_EQ_RIU_BASE;
MS_VIRT _ADC_DTOPB_RIU_BASE;

MS_VIRT _DDC_RIU_BASE;
MS_VIRT _PM_SLEEP_RIU_BASE;

MS_U32 u32DTVPatchTimer;
MS_BOOL bPreFDMaskStatse;
MS_U16 u16FDMaskCount;

#ifdef CONFIG_MSTAR_SRAMPD
MS_BOOL _bSRAMPowerDown;
#endif

#ifndef DONT_USE_CMA
#if (XC_SUPPORT_CMA ==TRUE)
MS_U32 u32CMAPatchTimer_Main ;
MS_U32 u32DisableFRCTimer;
#endif
#endif

#define IS_4K2K_PANEL   ((pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height > 2100) && \
                         (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width > 3800))

#define IS_OVER_VIRTUAL_HEIGHT(u16Height,eWindow)  ((gSrcInfo[eWindow].Status2.u16VirtualBox_Height>0) && \
                                                    ((u16Height) > gSrcInfo[eWindow].Status2.u16VirtualBox_Height))
#define IS_OVER_VIRTUAL_WIDTH(u16width,eWindow)    ((gSrcInfo[eWindow].Status2.u16VirtualBox_Width>0) && \
                                                    ((u16width) > gSrcInfo[eWindow].Status2.u16VirtualBox_Width))

#define IS_DS_OPEN_IN_HAL(eWindow)     ( pXCResourcePrivate->sthal_SC.bDynamicScalingEnable[eWindow] || pXCResourcePrivate->stdrvXC_Dynamicscaling._bDSForceIndexEnable[eWindow] )

#ifdef UFO_XC_FB_LEVEL
#define IS_FBL_OR_RFBL_MODE(eWindow) ((gSrcInfo[eWindow].eFBLevel == E_XC_FB_LEVEL_FBL)  || (gSrcInfo[eWindow].eFBLevel == E_XC_FB_LEVEL_RFBL_DI))
#else
#define IS_FBL_OR_RFBL_MODE(eWindow) (gSrcInfo[eWindow].bFBL || gSrcInfo[eWindow].bR_FBL)
#endif

#define WIDTH_4K2K      (3840)
#define HEIGHT_4K2K     (2160)
#define MAX_1P_MODE_CLK (315000000)   //(300*1024*1024)   // max 1p mode clk value
#define PNL_FRAME_RATE  (60)

#define  TGEN_SC0_DLY                        11
#define  TGEN_SC0_USER_MODE_DLY              3
#define  VIP_SC0_V_DLY                       2
#define  VIP_SC0_H_DLY                       150
#define  VIP_SC0_USER_MODE_V_DLY             (SC_R2BYTEMSK(0, REG_SC_BK68_51_L, 0x1FFF))
#define  VIP_SC0_USER_MODE_H_DLY             ((SC_R2BYTEMSK(0, REG_SC_BK68_52_L, 0x3FFF))/2)
#define  SC1_PRE_RUN_DLY                     ((SC_R2BYTEMSK(0, REG_SC_BK10_0C_L, 0x3FFF)+1)/4)
#define  VIP_SC1_V_DLY                       0
#define  VIP_SC1_H_DLY                       61

#define DS_SR_VSYNC_FRONT_PORCH             0x08
#define DS_SR_VSYNC_WIDTH                   0x08
#define DS_SR_VTOTAL_OFFSET                 0x02
#define DS_SR_VDE_START_MIN                 16

#define AUTODOWNLOAD_REQ_LEN (0x40)
#define XC_AUTODOWNLOAD_PNLGAMMA_WIDTH    (256)
#define XC_AUTODOWNLOAD_PNLGAMMA_DEPTH    (512)
#define OP2LUT_SRAM (8)
#define OP2LUT_ENTRY_DATA_NUM  (3)
#define OP2LUT_SRAM_ENTRY      (729)

#define AUTODOWNLOAD_CLIENT_HDR_MEM_SIZE     (0x10800 + 0x20)   // (32+64*3+32+32*3) * 32_byte_per_cmd * 6_for_dolby = 0x10800
#define AUTODOWNLOAD_CLIENT_3DLUT_MEM_SIZE     (0x41400)   // (736+656) * 32_byte_per_cmd * 6_for_dolby = 0x41400
#define AUTODOWNLOAD_CLIENT_OP2LUT_MEM_SIZE  (0x5B20)     // 729_entry * 32_byte_per_cmd = 0x5B20
#define AUTODOWNLOAD_CLIENT_HVSP_MEM_SIZE       ((0x1000)*32) // 128_entry  * 256bit_per_cmd/8*32bank = 0x1000 *32
#define AUTODOWNLOAD_CLIENT_HSY_MEM_SIZE        (0x1440)      // 324_entry  * 128bit_per_cmd/8
#define AUTODOWNLOAD_CLIENT_PQ_GAMMA_MEM_SIZE  (0x600)    // 16_entry * 32_byte_per_cmd * 3 = 0x600
#define AUTODOWNLOAD_CLIENT_PANEL_GAMMA_MEM_SIZE  (0x4000)    // 512_entry * 32_byte_per_cmd = 0x4000
#define AUTODOWNLOAD_CLIENT_ADL2RIU_MEM_SIZE (0x4000)     // 128_entry * 32_byte_per_cmd *2*2 = 0x2000
#define AUTODOWNLOAD_CLIENT_HSY_MEM_SIZE        (0x1440)      // 324_entry  * 128bit_per_cmd/8
#define AUTODOWNLOAD_CLIENT_DLC_256_MEM_SIZE  (0x200)    // 16_entry * 32_byte_per_cmd = 0x200
#define AUTODOWNLOAD_CLIENT_XVYCC_MEM_SIZE  (0x8000)
#define AUTODOWNLOAD_CLIENT_ICC_IHC_MEM_SIZE (0x2420)      // 289_entry*32_byte_per_cmd = 0x2420

#define HIGH_BYTE_MASK (0xFF00)
#define LOW_BYTE_MASK (0x00FF)
#define HIGH_BYTE_OFFSET (8)
#define MIU_T0T1_THRESHOLD (60)
#define MIU_T1T2_THRESHOLD (30)
#define MIU_HIGH_PRI_THRESHOLD (85)
#define IPVSYNC_OFFSET  (8)
#define NS_PER_XTAL_CLK_24M (0x29) // 10^9  /(24*10^6)  = 0x29
#ifdef UFO_XC_AUTO_DOWNLOAD
#define DEBUG_HDR 0
#define  AUTO_DOWNLOAD_HDR_TMO_SRAM_MAX_ADDR     512
#define  AUTO_DOWNLOAD_HDR_3DLUT_SRAM_MAX_ADDR     4944

// HDR client of auto download has these following formats, include format0 and format1.
//
// Format0:
//127      125          116 115         112                             60        57                                   0
// | [x[2]] | [addr(10)] | 0 | [sel0(3)] |           [data1]             | sel1(3) |              [data0]              |
//                               sel0 = 1                            x(52) sel1 = 1              wd0(19),wd1(19),wd2(19)
//                               sel0 = 2     x(4),wd0(16),wd1(16),wd2(16) sel1 = 2         x(9),wd0(16),wd1(16),wd2(16)
//                               sel0 = 3                    x(40),wd0(12) sel1 = 3                        x(45),wd0(12)
//                               sel0 = 4   idx(4),wd0(16),wd1(16),wd2(16) sel1 = 4  x(5),idx(4),wd0(16),wd1(16),wd2(16)
// sel:   0: disable
//        1: De-gamma
//        2: Gamma
//        3: TMO
//        4: 3D-lut

// Format1:
//127      125          116 115          112                             60        57                                   0
// | [x[2]] | [addr(10)] | 1 | [ctrl0(3)] |           [data1]             | sel1(3) |              [data0]              |
//                                                                    x(52) sel1 = 0
//                                           idx(4),wd0(16),wd1(16),wd2(16) sel1 = 4      x(10),degam(19),gam(16),tmo(16)
// ctrl:                 bit: 114  113 112
//                          |degam|gam|tmo|
// sel:   0: disable
//        4: 3D-lut
//
// HW designer recommand using format1.
// These following definitions write datas of tmo/gamma/de-gamma/3d-lut separately by format1,
// please refer to definition of WRITE_TMO_DATA_FORMAT_1, WRITE_GAMMA_DATA_FORMAT_1, WRITE_DEGAMMA_DATA_FORMAT_1 and WRITE_3DLUT_DATA_FORMAT_1.
#define WRITE_TMO_DATA_FORMAT_1(baseaddr, index, value) \
    *(baseaddr) = (((*(baseaddr)) & 0xC0) | (((index) >> 4) & 0x3F));\
    *(baseaddr + 1) = ((((index) << 4) & 0xF0) | ((*(baseaddr + 1)) & 0x0F) | 0x09);\
    *(baseaddr + 14) = ((*(baseaddr + 14) & 0xF0) | (((value) >> 8) & 0x0F));\
    *(baseaddr + 15) = ((value) & 0xFF);

#define WRITE_GAMMA_DATA_FORMAT_1(baseaddr, index, value) \
    *(baseaddr) = (((*(baseaddr)) & 0xC0) | (((index) >> 4) & 0x3F));\
    *(baseaddr + 1) = ((((index) << 4) & 0xF0) | ((*(baseaddr + 1)) & 0x0F) | 0x0A);\
    *(baseaddr + 14) = ((*(baseaddr + 14) & 0x0F) | (((value) << 4) & 0xF0));\
    *(baseaddr + 13) = (((value) >> 4) & 0xFF);\
    *(baseaddr + 12) = ((*(baseaddr + 12) & 0xF0) | (((value) >> 12) & 0x0F));

#define WRITE_DEGAMMA_DATA_FORMAT_1(baseaddr, index, value) \
    *(baseaddr) = (((*(baseaddr)) & 0xC0) | (((index) >> 4) & 0x3F));\
    *(baseaddr + 1) = ((((index) << 4) & 0xF0) | ((*(baseaddr + 1)) & 0x0F) | 0x0C);\
    *(baseaddr + 12) = ((*(baseaddr + 12) & 0x0F) | (((value) << 4) & 0xF0));\
    *(baseaddr + 11) = (((value) >> 4) & 0xFF);\
    *(baseaddr + 10) = ((*(baseaddr + 10) & 0x80) | (((value) >> 12) & 0x7F));

#define WRITE_3DLUT_DATA_FORMAT_1(baseaddr, index, subindex, rval, gval, bval) \
    *(baseaddr) = (((*(baseaddr)) & 0xC0) | (((index) >> 4) & 0x3F));\
    *(baseaddr + 1) = ((((index) << 4) & 0xF0) | ((*(baseaddr + 1)) & 0x0F) | 0x08);\
    *(baseaddr + 8) = ((*(baseaddr + 8) & 0xF1) | 0x08);\
    *(baseaddr + 8) = ((*(baseaddr + 8) & 0x0F) | (((bval) << 4) & 0xF0));\
    *(baseaddr + 7) = (((bval) >> 4) & 0xFF);\
    *(baseaddr + 6) = ((*(baseaddr + 6) & 0xF0) | (((bval) >> 12) & 0x0F));\
    *(baseaddr + 6) = ((*(baseaddr + 6) & 0x0F) | (((gval) << 4) & 0xF0));\
    *(baseaddr + 5) = (((gval) >> 4) & 0xFF);\
    *(baseaddr + 4) = ((*(baseaddr + 4) & 0xF0) | (((gval) >> 12) & 0x0F));\
    *(baseaddr + 4) = ((*(baseaddr + 4) & 0x0F) | (((rval) << 4) & 0xF0));\
    *(baseaddr + 3) = (((rval) >> 4) & 0xFF);\
    *(baseaddr + 2) = ((*(baseaddr + 2) & 0xF0) | (((rval) >> 12) & 0x0F));\
    *(baseaddr + 2) = ((*(baseaddr + 2) & 0x0F) | (((subindex) << 4) & 0xF0));

#define WRITE_OP2LUT_DATA_FORMAT_1(baseaddr, sramindex, rval, gval, bval) \
    *(baseaddr + 15) = (*(baseaddr + 15) & 0xF0) | (((1 << (sramindex)) >> 4) & 0x0F);\
    *(baseaddr + 14) = (*(baseaddr + 14) & 0x0F) | (((1 << (sramindex)) << 4) & 0xF0);\
    *(baseaddr + 10) = (*(baseaddr + 10) & 0xFC) | ((rval >> 8) & 0x03);\
    *(baseaddr + 9) = ((rval) & 0xFF);\
    *(baseaddr + 5) = (*(baseaddr + 5) & 0xC0) | (((gval) >> 4) & 0x3F);\
    *(baseaddr + 4) = (*(baseaddr + 4) & 0x0F) | (((gval) << 4) & 0xF0);\
    *(baseaddr + 1) = (*(baseaddr + 1) & 0xFC) | ((bval >> 8) & 0x03);\
    *(baseaddr) = ((bval) & 0xFF);


// The following definition clear bits of format1's ctrl & sel.
#define CLEAR_HDR_DATA_FORMAT_1(baseaddr) \
    *(baseaddr + 1) = ((*(baseaddr + 1)) & 0xF8);\
    *(baseaddr + 8) = (*(baseaddr + 8) & 0xF1);

#define GHZ (1000000000UL) // 10^9
#define ABS_TIME_OF_LINE_ODCLK_F1_D1 (90)//uses the time 4k domain count 90 lines as the unit.
#define ABS_TIME_OF_LINE_ODCLK_F1_D2 (0) //uses the time 4k domain count 64 lines as the unit.
#define ABS_TIME_OF_LINE_ODCLK_F1_D3 (0) //uses the time 4k domain count 64 lines as the unit.
#define ABS_TIME_OF_LINE_ODCLK_F2_D1 (0) //uses the time 4k domain count 64 lines as the unit.
#define ABS_TIME_OF_LINE_ODCLK_F2_D2 (0) //uses the time 4k domain count 64 lines as the unit.
#define ABS_TIME_OF_LINE_ODCLK_F3_D1 (64) //uses the time 4k domain count 64 lines as the unit.
//#define FRC_R_UPDATE_TO_FRC_READ_DELAY (0)
#define USER_DEFINE_FRC_SYNC_DELAY_MAX (0)
#define LOCK_IP_VCNT_DEFALUT (2)

//-------------------------------------------------------------------------------------------------
//  Global Variables
//-------------------------------------------------------------------------------------------------
MS_BOOL gbOfflineDetectDbg = FALSE;
MS_BOOL gbOfflineDetectEnable = TRUE;
INPUT_SOURCE_TYPE_t genOfflineSource = INPUT_SOURCE_NONE;
MS_U8 gu8PatternIP = E_XC_TEST_PATTERN_MODE_MAX;
MS_BOOL gbStrPatternEnable = FALSE;

//-------------------------------------------------------------------------------------------------
//  Local Variables
//-------------------------------------------------------------------------------------------------
static MS_U32 _au32_3dlut_entry_num[8] = {736, 656, 656, 576, 656, 576, 576, 512};
#endif

static MS_BOOL _gbProcFSDecimalCropEnable = TRUE;
static MS_BOOL _bProcFSXC8AlignDisable = FALSE;
static XC_HSE_PREINIT_INFO_t _gstHSEPreInitInfo = {0,0,0,0,0};
static MS_BOOL _gbIP2HSDPatch = FALSE;
static MS_BOOL _bProcFSForceFreerun = FALSE;
//-------------------------------------------------------------------------------------------------
//  Global Functions
//-------------------------------------------------------------------------------------------------

#if (defined(MSOS_TYPE_LINUX_KERNEL) && defined(CONFIG_MSTAR_XC_HDR_SUPPORT))
extern MS_BOOL MDrv_XC_CFDControl(ST_KDRV_XC_CFD_CONTROL_INFO *pstKdrvCFDCtrlInfo);
#endif
extern void MDrv_XC_SetOffLineDetection(void *pInstance, INPUT_SOURCE_TYPE_t u8InputSourceType );
extern MS_U8 MDrv_XC_GetOffLineDetection(void *pInstance, INPUT_SOURCE_TYPE_t u8InputSourceType );

//-------------------------------------------------------------------------------------------------
//  Local Functions
//-------------------------------------------------------------------------------------------------
#if FRC_INSIDE
void Hal_SC_Get_FRC_STGEN_ODCLK(void *pInstance, SCALER_WIN eWindow, E_FRC_STGEN_ODCLK* peMode, E_FSC_IDCLK* peFSCIDCLK);
#endif

static void MHal_SC_DynamicSetHSEMemoryCB(MS_BOOL bIsIommuEnabled);

// Put this function here because hwreg_utility2 only for hal.
void Hal_SC_init_riu_base(MS_VIRT u32riu_base, MS_VIRT u32PMriu_base, MS_VIRT u32EXTriu_base)
{
    _XC_RIU_BASE = u32PMriu_base;
    _PM_RIU_BASE = u32PMriu_base;


    _DVI_ATOP_RIU_BASE = u32PMriu_base;
    _DVI_DTOP_RIU_BASE = u32PMriu_base;
    _HDCP_RIU_BASE = u32PMriu_base;
    _DVI_EQ_RIU_BASE = u32PMriu_base;
    _ADC_DTOPB_RIU_BASE = u32PMriu_base;

    _DDC_RIU_BASE =u32PMriu_base;
    _PM_SLEEP_RIU_BASE =u32PMriu_base;
#ifdef SUPPORT_XC_EXT_REG
    _XC_EXT_RIU_BASE = u32EXTriu_base;
#endif
}

//=========================================================//
// Function : Hal_SC_setfield
// Description:
//=========================================================//
void Hal_SC_setfield(void *pInstance, MS_U16 reg_1D, MS_U16 reg_21, MS_U16 reg_23, SCALER_WIN eWindow )
{
    //printf("reg_1D=%x, reg_21=%x, reg_23=%x\n", reg_1D, reg_21, reg_23);
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if( eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_1D_L, eWindow), (reg_1D<<8), 0xEF00);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_21_L, eWindow), reg_21, 0x3FFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_23_L, eWindow), (reg_23<<8), HBMASK);
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_1D_L, (reg_1D<<8), 0xEF00);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_21_L, reg_21, 0x3FFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_23_L, (reg_23<<8), HBMASK);
#endif
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_1D_L, (reg_1D<<8), 0xEF00);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_21_L, reg_21, 0x3FFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_23_L, (reg_23<<8), HBMASK);
    }
//    printf("%x ",SC_R2BYTEMSK(REG_SC_BK01_1D_L, HBMASK));
//    printf("%x ",SC_R2BYTEMSK(REG_SC_BK01_21_L, 0x3FFF));
//    printf("%x ",SC_R2BYTEMSK(REG_SC_BK01_23_L, HBMASK));

//    printf("%x ",SC_R4BYTE(REG_SC_BK01_21_L));
//    printf("%x ",SC_R4BYTE(REG_SC_BK01_23_L));
}

//=========================================================//
// Function : Hal_SC_de_only_en
// Description: DE Only. HSYNC and VSYNC are ignored.
//#0: Disable.
//#1: Enable.
//=========================================================//
void Hal_SC_de_only_en(void *pInstance, MS_BOOL benable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_03_L, eWindow), (benable ? BIT(6):0), BIT(6));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_2F_L, eWindow), (benable ? BIT(4):0), BIT(4)); // SW patch for HDMI switch, Auto search HST jistter mask filter force off
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_03_L, (benable ? BIT(6):0), BIT(6));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_2F_L, (benable ? BIT(4):0), BIT(4)); // SW patch for HDMI switch, Auto search HST jistter mask filter force off
#endif
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_03_L, (benable ? BIT(6):0), BIT(6));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_2F_L, (benable ? BIT(4):0), BIT(4)); // SW patch for HDMI switch, Auto search HST jistter mask filter force off
    }
}

//=========================================================//
// Function : Hal_SC_de_direct_en
// Description: Digital Input Horizontal Sample Range
//#0: Use DE as sample range, only V position can be adjusted.
//#1: Use SPRHST and SPRHDC as sample range, both H and V position can be adjusted.
//=========================================================//
void Hal_SC_de_direct_en(void *pInstance, MS_BOOL benable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_03_L, eWindow), (benable ? BIT(7):0), BIT(7));
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_03_L, (benable ? BIT(7):0), BIT(7));
#endif
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_03_L, (benable ? BIT(7):0), BIT(7));
    }

}

void Hal_SC_set_ficlk(void *pInstance, MS_BOOL bPreDown, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(E_XC_DEVICE0 == psXCInstPri->u32DeviceID)
    {
        // manhattan is not needed it
    }
    else //E_XC_DEVICE1 == psXCInstPri->u32DeviceID
    {
        if (bPreDown)
        {
            W2BYTEMSK(REG_CKG_S2_FICLK2_F2, CKG_S2_FICLK2_F2_IDCLK2, CKG_S2_FICLK2_F2_MASK); // clk_edclk
        }
        else
        {
            W2BYTEMSK(REG_CKG_S2_FICLK2_F2, CKG_S2_FICLK2_F2_FCLK, CKG_S2_FICLK2_F2_MASK); // clk_fclk
        }
    }
}

void Hal_SC_set_shiftline(void *pInstance, MS_U8 u8Val, SCALER_WIN eWindow )
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if( eWindow == MAIN_WINDOW )
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_2F_L, (u8Val & 0x07)<<8, (BIT(10)|BIT(9)|BIT(8)));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_2F_L, (u8Val & 0x03)<<13, (BIT(14)|BIT(13)));
    }
}

void Hal_SC_set_422_cbcr_swap(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_0A_L, bEnable ? BIT(6) : 0, BIT(6));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK04_0A_L, bEnable ? BIT(6) : 0, BIT(6));
    }
}

void Hal_SC_set_pre_align_pixel(void *pInstance, MS_BOOL bEnable, MS_U16 pixels, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if (bEnable)
    {
        if ( eWindow == MAIN_WINDOW )
        {
            // Enable pre align pixel for mirror mode.
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_2A_L, BIT(15), BIT(15));

            // Number of pixels need to be inserted. (U3 has 15 pixels)
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_2A_L, pixels << 8 , 0x1F00);
        }
        else
        {
            // Enable pre align pixel for mirror mode.
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK04_2A_L, BIT(15), BIT(15));

            // Number of pixels need to be inserted. (U3 has 15 pixels)
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK04_2A_L, pixels << 8 , 0x1F00);
        }

    }
    else
    {
        if ( eWindow == MAIN_WINDOW )
        {
            // Disable pre align pixel for mirror mode.
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_2A_L, 0x00 , BIT(15));
        }
        else
        {
            // Disable pre align pixel for mirror mode.
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK04_2A_L, 0x00 , BIT(15));
        }
    }
}

MS_BOOL Hal_SC_get_pre_align_pixel(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if ( eWindow == MAIN_WINDOW )
    {
        // Check pre align pixel.
        return ( SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_2A_L, BIT(15))) ? TRUE:FALSE;
    }
    else
    {
        // Check pre align pixel.
        return ( SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK04_2A_L, BIT(15))) ? TRUE:FALSE;
    }
}

void Hal_XC_Set_FreeFRCMD(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_05_L, bEnable? BIT(5) : 0, BIT(5));
}

// Obsolete in M10/J2/A5
void Hal_SC_set_linearmem_mode(MS_BOOL bEnable, SCALER_WIN eWindow)
{
}

// This function will return 8/10/12/14/16 field mode or 8 frame mode.
// Otherwise it return IMAGE_STORE_2_FRAMES
XC_FRAME_STORE_NUMBER Hal_SC_GetFrameStoreMode(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U16 u16FrameCount = 0x00;
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    if (eWindow == MAIN_WINDOW)
    {
        u16FrameCount = 0x1F & SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_19_L);
    }
    else
    {
        u16FrameCount = 0x1F & SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_59_L);
    }

    switch( u16FrameCount) // Get field type.
    {
        default:
            if (gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                return IMAGE_STORE_4_FIELDS;
            }
            else
            {
                return IMAGE_STORE_2_FRAMES;
            }
        case 3:
            return IMAGE_STORE_3_FRAMES;
        case 4:
            if (gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                return IMAGE_STORE_4_FIELDS;
            }
            else
            {
                return IMAGE_STORE_4_FRAMES;
            }
        case 6:
            if (gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                return IMAGE_STORE_6_FIELDS;
            }
            else
            {
                return IMAGE_STORE_6_FRAMES;
            }
        case 8:
            if (gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                return IMAGE_STORE_8_FIELDS;
            }
            else
            {
                return IMAGE_STORE_8_FRAMES;
            }
        case 10:
            return IMAGE_STORE_10_FIELDS;
        case 12:
            if (gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                return IMAGE_STORE_12_FIELDS;
            }
            else
            {
                return IMAGE_STORE_12_FRAMES;
            }
        case 14:
            return IMAGE_STORE_14_FIELDS;
        case 16:
            return IMAGE_STORE_16_FIELDS;

    }

    return IMAGE_STORE_UNDEFINE;
}

void Hal_SC_set_wr_bank_mapping(void *pInstance, MS_U8 u8val, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_DBG(printf("Set WR bank mapping SC_BK12_07/47_L[15:13]= 0x%x\n", ((MS_U16)u8val)<<13));

    if( eWindow == MAIN_WINDOW )
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, ((MS_U16)u8val)<<13, BIT(15)|BIT(14)|BIT(13));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_47_L, ((MS_U16)u8val)<<13, BIT(15)|BIT(14)|BIT(13));
    }
}

void Hal_SC_set_frcm_wr_bank_mapping(void *pInstance, MS_U8 u8val, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_DBG(printf("Set WR bank mapping SC_BK12_07/47_L[15:13]= 0x%x\n", ((MS_U16)u8val)<<13));

    if( eWindow == MAIN_WINDOW )
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_07_L, ((MS_U16)u8val)<<13, BIT(15)|BIT(14)|BIT(13));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_47_L, ((MS_U16)u8val)<<13, BIT(15)|BIT(14)|BIT(13));
    }
}

void Hal_SC_set_wr_bank_mapping_num(void *pInstance, MS_U8 u8Val, SCALER_WIN eWindow)
{
    Hal_SC_set_wr_bank_mapping(pInstance, u8Val, eWindow);
}

MS_U8 Hal_SC_Get_WR_Bank_Mapping(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U8 u8val = 0;

    if( eWindow == MAIN_WINDOW )
    {
        u8val = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, BIT(15)|BIT(14)|BIT(13)) >> 13;
    }
    else
    {
        u8val = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_47_L, BIT(15)|BIT(14)|BIT(13)) >> 13;
    }
    SC_DBG(printf("Get WR bank mapping SC_BK12_07/47_L[15:13]= 0x%x\n", ((MS_U16)u8val)<<13));
    return u8val;
}

MS_U8 Hal_SC_Get_WR_Bank_Mapping_Num(void *pInstance, SCALER_WIN eWindow)
{
    return Hal_SC_Get_WR_Bank_Mapping(pInstance, eWindow);
}

void Hal_SC_set_csc(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow )
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if( eWindow == MAIN_WINDOW )
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_40_L, (bEnable ? BIT(3):0), BIT(3));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_01_L, (bEnable ? BIT(2):0), BIT(2));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK04_40_L, (bEnable ? BIT(3):0), BIT(3));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK04_01_L, (bEnable ? BIT(2):0), BIT(2));
    }
}

MS_BOOL Hal_SC_get_ip2_csc(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_BOOL bYUVInput;
    if(eWindow == MAIN_WINDOW)
    {
        // If it has CSC, it shows it must be RGB input.
        // Because in scaler, it must be YUV. So if input is RGB, then we need to do CSC
        bYUVInput = ( SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_40_L, BIT(3) ))? FALSE:TRUE;
    }
    else
    {
        bYUVInput = ( SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_40_L, BIT(3) ))? FALSE:TRUE;
    }
    return bYUVInput;
}

void Hal_SC_set_delayline(void *pInstance, MS_U8 u8DelayLines, SCALER_WIN eWindow )
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    //skip bit7, which is other usage
    MS_U16 u16DelayLines = ((MS_U16)u8DelayLines) & 0xFF;
    if( eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_1C_L, eWindow), (u16DelayLines<<4), (BIT(9)|BIT(8)|BIT(7)|BIT(6)|BIT(5)|BIT(4)));
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_1C_L, (u16DelayLines<<4), (BIT(9)|BIT(8)|BIT(7)|BIT(6)|BIT(5)|BIT(4)));
#endif
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_1C_L, (u16DelayLines<<4), (BIT(9)|BIT(8)|BIT(7)|BIT(6)|BIT(5)|BIT(4)));
    }
}

void Hal_SC_set_write_limit(void *pInstance, MS_PHY u32WritelimitAddrBase, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_PHY u32MinLimitAddress = 0;
    MS_PHY u32MaxLimitAddress = 0;
    MS_U16 u16ReadWriteRequest = 0;
#if (XC_SUPPORT_IOMMU == TRUE)
    if (pXCResourcePrivate->stdrvXC_MVideo_Context.stMMAfeature.u32Support == MSOS_MMA_NOT_SUPPORT)
    {
#endif

#ifndef DONT_USE_CMA
#if (XC_SUPPORT_CMA ==TRUE)
#if ((HW_DESIGN_4K2K_VER == 4)||(HW_DESIGN_4K2K_VER == 6))
#if (defined (ANDROID))
    if(pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].isEnable == FALSE)
    {
        UNUSED(u32WritelimitAddrBase);
        UNUSED(eWindow);
        return;
    }
#endif
#endif
#endif
#endif
#if (XC_SUPPORT_IOMMU == TRUE)
    }
#endif

#if (HW_DESIGN_4K2K_VER == 4)
    // in Monaco, the 4K data path need to setup the IPM write on the FRCM base, and the max/min limit region also need to change
    if(gSrcInfo[eWindow].stCapWin.width > 3800)
    {
        u32MinLimitAddress = MHal_XC_GetFRCMBufAddress(pInstance, eWindow)/BYTE_PER_WORD ;
        if(MHal_XC_GetFRCMBufSize(pInstance, eWindow) != 0)
            u32MaxLimitAddress = (MHal_XC_GetFRCMBufAddress(pInstance, eWindow) + MHal_XC_GetFRCMBufSize(pInstance, eWindow))/BYTE_PER_WORD - 1;
        else
            u32MaxLimitAddress = u32MinLimitAddress;
    }
    //monaco mm DS VB size always be 4k2k , mvop timing is 4k2k , 2p mode
    else if ((pXCResourcePrivate->sthal_SC.bDynamicScalingEnable || pXCResourcePrivate->stdrvXC_Dynamicscaling._bDSForceIndexEnable[eWindow] ) &&
             (gSrcInfo[eWindow].Status2.u16VirtualBox_Width >= 0xF00) && (gSrcInfo[eWindow].Status2.u16VirtualBox_Height>= 0x870))
    {
        u32MinLimitAddress = MHal_XC_GetFRCMBufAddress(pInstance, eWindow)/BYTE_PER_WORD ;
        if(MHal_XC_GetFRCMBufSize(pInstance, eWindow) != 0)
            u32MaxLimitAddress = (MHal_XC_GetFRCMBufAddress(pInstance, eWindow) + MHal_XC_GetFRCMBufSize(pInstance, eWindow))/BYTE_PER_WORD - 1;
        else
            u32MaxLimitAddress = u32MinLimitAddress;
    }
    else
#endif
    {
        u32MinLimitAddress = MHal_XC_GetDNRBufAddress(pInstance, eWindow)/BYTE_PER_WORD ;
        if(MHal_XC_GetDNRBufSize(pInstance, eWindow) != 0)
            u32MaxLimitAddress = (MHal_XC_GetDNRBufAddress(pInstance, eWindow) + MHal_XC_GetDNRBufSize(pInstance, eWindow))/BYTE_PER_WORD - 1;
        else
            u32MaxLimitAddress = u32MinLimitAddress;
    }
    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"eWindow=%x, MHal_XC_GetDNRBufAddress=%tx, MHal_XC_GetDNRBufSize=%tx\n", eWindow, (ptrdiff_t)(MHal_XC_GetDNRBufAddress(pInstance, eWindow)/BYTE_PER_WORD ),(ptrdiff_t) (MHal_XC_GetDNRBufSize(pInstance, eWindow))/BYTE_PER_WORD);
    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"eWindow=%x, u32MinLimitAddress=%tx, u32MaxLimitAddress=%tx\n", eWindow, (ptrdiff_t)u32MinLimitAddress, (ptrdiff_t)u32MaxLimitAddress);

    if(eWindow == MAIN_WINDOW)
    {
        /// save and disable the r/w request, when change the write limit base
        u16ReadWriteRequest = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, BIT(0)|BIT(1));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, BIT(0)|BIT(1), BIT(0)|BIT(1));
        if (IsHMirrorMode(eWindow) && IsEnableDualMode(eWindow))
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_38_L, ((u32WritelimitAddrBase&BIT(31))?BIT(4):0),BIT(4)); //F2 memory address limit enable
            SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_48_L, u32MinLimitAddress); //F2 memory min address
            SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_4A_L, u32MaxLimitAddress); //F2 memory max address
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_38_L, ((u32WritelimitAddrBase&BIT(31))?BIT(0):0),BIT(0)); //F2 memory address limit enable
            SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_40_L, u32MinLimitAddress); //F2 memory min address
            SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_42_L, u32MaxLimitAddress); //F2 memory max address
        }
        ///restore the r/w request
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, u16ReadWriteRequest, BIT(0)|BIT(1));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_47_L, BIT(0)|BIT(1), BIT(0)|BIT(1));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_38_L, ((u32WritelimitAddrBase&BIT(31))?BIT(1):0),BIT(1)); //F1 memory address limit enable
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_44_L, u32MinLimitAddress); //F1 memory min address
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_46_L, u32MaxLimitAddress); //F1 memory max address
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_47_L, 0x00, BIT(0)|BIT(1));
    }
}

void Hal_SC_set_frcm_write_limit(void *pInstance, MS_PHY u32WritelimitAddrBase, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_PHY u32MinLimitAddress = MHal_XC_GetFRCMBufAddress(pInstance, eWindow)/BYTE_PER_WORD ;
    MS_PHY u32MaxLimitAddress = 0;

    if(MHal_XC_GetFRCMBufSize(pInstance, eWindow) != 0)
        u32MaxLimitAddress = (MHal_XC_GetFRCMBufAddress(pInstance, eWindow) + MHal_XC_GetFRCMBufSize(pInstance, eWindow))/BYTE_PER_WORD - 1;
    else
        u32MaxLimitAddress = u32MinLimitAddress;

    if(eWindow == MAIN_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_50_L, ((u32WritelimitAddrBase&BIT(31))?BIT(4):0),BIT(4)); //F2 memory address limit enable
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_64_L, u32MinLimitAddress); //F2 memory min address
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_66_L, u32MaxLimitAddress); //F2 memory max address
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_50_L, ((u32WritelimitAddrBase&BIT(31))?BIT(5):0),BIT(5)); //F1 memory address limit enable
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_68_L, u32MinLimitAddress); //F1 memory min address
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_6A_L, u32MaxLimitAddress); //F1 memory max address
    }

}

void Hal_SC_set_dual_write_limit(void *pInstance, MS_PHY u32WritelimitAddrBase, SCALER_WIN eWindow)
{
#ifdef UFO_XC_SUPPORT_DUAL_MIU
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_PHY u32MinLimitAddress = 0;
    MS_PHY u32MaxLimitAddress = 0;

    u32MinLimitAddress = MHal_XC_GetDualDNRBufAddress(pInstance, eWindow)/BYTE_PER_WORD ;
    if(MHal_XC_GetDualDNRBufSize(pInstance, eWindow) != 0)
        u32MaxLimitAddress = (MHal_XC_GetDualDNRBufAddress(pInstance, eWindow) + MHal_XC_GetDualDNRBufSize(pInstance, eWindow))/BYTE_PER_WORD - 1;
    else
        u32MaxLimitAddress = u32MinLimitAddress;

    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"eWindow=%x, MHal_XC_GetDNRBufAddress=%tx, MHal_XC_GetDNRBufSize=%tx\n", eWindow,(ptrdiff_t)(MHal_XC_GetDNRBufAddress(pInstance, eWindow)/BYTE_PER_WORD ),(ptrdiff_t)( (MHal_XC_GetDNRBufSize(pInstance, eWindow))/BYTE_PER_WORD));
    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"eWindow=%x, u32MinLimitAddress=%tx, u32MaxLimitAddress=%tx\n", eWindow,(ptrdiff_t) u32MinLimitAddress,(ptrdiff_t) u32MaxLimitAddress);

    if(eWindow == MAIN_WINDOW)
    {
        /// need to disable the r/w request, when change the write limit base
        /// For SCMI0/1 use the same IPM r/w request.
        //SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, BIT(0)|BIT(1), BIT(0)|BIT(1));
        if (IsHMirrorMode(eWindow) && IsEnableDualMode(eWindow))
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_38_L, ((u32WritelimitAddrBase&BIT(31))?BIT(0):0),BIT(0)); //F2 memory address limit enable
            SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_40_L, u32MinLimitAddress); //F2 memory min address
            SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_42_L, u32MaxLimitAddress); //F2 memory max address

        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_38_L, ((u32WritelimitAddrBase&BIT(31))?BIT(4):0),BIT(4)); //F2 memory address limit enable
            SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_48_L, u32MinLimitAddress); //F2 memory min address
            SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_4A_L, u32MaxLimitAddress); //F2 memory max address
        }
        /// need to enable the r/w request
        //SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, 0x00, BIT(0)|BIT(1));
    }
#endif
}

void Hal_SC_set_opm_write_limit(void *pInstance, MS_BOOL bEnable, MS_BOOL bFlag, MS_PHY u32OPWlimitAddr, SCALER_WIN eWindow)
{
#if 0

    MS_U16 u16temp = 0x00;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    // Only support address of Main_Window
    if (eWindow != MAIN_WINDOW )
        return;

    // Bit 0 ~ 24
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_5E_L, u32OPWlimitAddr & 0xFFFF);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_5F_L, (u32OPWlimitAddr >> 16) & 0x1FF);

    // OPW limit enable
    if (bEnable)
        u16temp = BIT(9);

    // OPW limit flag 0: maximum 1:minimum
    if (bFlag)
        u16temp |= BIT(10);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_5F_L,u16temp ,BIT(9) | BIT(10) );
#endif
}

MS_BOOL Hal_SC_is_extra_req_en(void *pInstance,
                               MS_U16 *pu16MainHStart, MS_U16 *pu16MainHEnd,
                               MS_U16 *pu16SubHStart,  MS_U16 *pu16SubHEnd)
{
    MS_BOOL bEn = FALSE;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U16 u16MainHStart, u16SubHStart;
    MS_U16 u16MainHEnd, u16SubHEnd;
    //FIX ME:need follow HW_DESIGN_4K2K_VER = 6 rule
    u16MainHStart = pu16MainHStart == NULL ? SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_08_L) : *pu16MainHStart;
    u16MainHEnd   = pu16MainHEnd   == NULL ? SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_09_L) : *pu16MainHEnd;
    u16SubHStart  = pu16SubHStart  == NULL ? SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_07_L) : *pu16SubHStart;
    u16SubHEnd    = pu16SubHEnd    == NULL ? SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_08_L) : *pu16SubHEnd;

    if( SC_R2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BK20_10_L, BIT(1))
        &&(((psXCInstPri->u32DeviceID == 0) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE))
           ||(psXCInstPri->u32DeviceID == 1))
      ) // Only Legacy mode use old rule for extra enable
    {
        if(u16MainHStart > u16SubHStart || u16MainHEnd < u16SubHEnd)
        {
            bEn = FALSE;
        }
        else
        {
            bEn = TRUE;
        }
    }
    else
    {
        bEn = FALSE;
    }
#if DBG_EN
    SC_DBG(printf("Sub=%d, MainHs=%d, SubHs=%d, MainHe=%d, SubHe=%d :: Extra=%d\n",
                  SC_R2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BK20_10_L, BIT(1)),
                  u16MainHStart, u16SubHStart, u16MainHEnd, u16SubHEnd, bEn));
#endif
    return bEn;

}

#if 0 //Dual not support switch miu select dynamicly.
//#ifdef UFO_XC_SUPPORT_DUAL_MIU
#if (MIU_SEL_USE_XC_INTERNAL == FALSE)
// Miu opm1 opm2 need to be switched just under Dual Mirror case, so it should be Called in runtime.
// This API just for swap OPM when miu select control by miu arb.
static void _Hal_SC_adjust_dual_miu_setting(void *pInstance, MS_PHY u32FBAddress, MS_PHY u32DualFBAddress, MS_BOOL bMirrorWithDual, MS_U16 *pu16OPMLeftMiuSel, MS_U16 *pu16OPMRightMiuSel)
{
    MS_U8 u8MIUSel = 0;
    _phy_to_miu_offset(u8MIUSel, u32FBAddress, u32FBAddress);
    if (u8MIUSel == 0)
    {
        //IPM0 OPM0 access miu0
        *pu16OPMLeftMiuSel = 0x0;
    }
    else if(u8MIUSel == 1)
    {
        // OPM0 access miu 1
        *pu16OPMLeftMiuSel = 0x1;
    }
    else if(u8MIUSel == 2)
    {
        // OPM0 access miu 1
        *pu16OPMLeftMiuSel = 0x2;
    }

    _phy_to_miu_offset(u8MIUSel, u32DualFBAddress, u32DualFBAddress);
    if (u8MIUSel == 0)
    {
        //IPM0 OPM0 access miu0
        *pu16OPMRightMiuSel = 0x0;
    }
    else if(u8MIUSel == 1)
    {
        // OPM0 access miu 1
        *pu16OPMRightMiuSel = 0x1;
    }
    else if(u8MIUSel == 2)
    {
        // OPM0 access miu 1
        *pu16OPMRightMiuSel = 0x2;
    }

    if (bMirrorWithDual)
    {
        MS_U16 u16Tmp = *pu16OPMLeftMiuSel;
        *pu16OPMLeftMiuSel = *pu16OPMRightMiuSel;
        *pu16OPMRightMiuSel = u16Tmp;
    }

}

#else
//the patch to reset the miu selection ,becuase HW always swaps the miu selection on dual or without dual.
static void _Hal_SC_adjust_swap_miu_setting(void *pInstance,MS_PHY u32FBAddress)
{
    MS_U8 u8MIUSel = 0;
    MS_U8 u8MIUSel_temp= 0;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    u8MIUSel_temp = SC_R2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BK51_05_L, BIT(4)) >> 3;
    u8MIUSel_temp = u8MIUSel_temp | (SC_R2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BK52_05_L, BIT(4)) >> 4);
    _phy_to_miu_offset(u8MIUSel, u32FBAddress, u32FBAddress);
    if(u8MIUSel_temp != u8MIUSel)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_05_L, (u8MIUSel & BIT(0)) << 4 , 0x0010);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK51_05_L, ((u8MIUSel & BIT(1)) >> 1) << 4 , 0x0010);
    }
    else
    {
        printf("The miu has been set correctly function %s line %d parars \n",__FUNCTION__,__LINE__);
    }
}
static void _Hal_SC_adjust_swap_miu_setting_burst(void *pInstance,MS_PHY u32FBAddress)
{
    MS_U8 u8MIUSel = 0;
    MS_U8 u8MIUSel_temp= 0;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    u8MIUSel_temp = SC_R2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BK51_05_L, BIT(4)) >> 3;
    u8MIUSel_temp = u8MIUSel_temp | (SC_R2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BK52_05_L, BIT(4)) >> 4);
    _phy_to_miu_offset(u8MIUSel, u32FBAddress, u32FBAddress);
    if(u8MIUSel_temp != u8MIUSel)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK52_05_L, (u8MIUSel & BIT(0)) << 4 ,BIT(4));
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK51_05_L, ((u8MIUSel & BIT(1)) >> 1) << 4 ,BIT(4));
    }
    else
    {
        printf("The miu has been set correctly function %s line %d parars \n",__FUNCTION__,__LINE__);
    }
    MDrv_XC_MLoad_Fire(pInstance, TRUE);
}
#endif
#endif

void Hal_SC_3D_CopyDispWinToSTGEN(void *pInstance, SCALER_WIN eWindow)
{
#if (FRC_INSIDE && (HW_DESIGN_4K2K_VER == 6))
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U16 u16Start = 0, u16End = 0;
    MS_U16 u16VideoHeight = 0;
    // 3D case, copy bk10 disp to bk68
    // copy main disp Y
    if(eWindow == MAIN_WINDOW)
    {
        u16Start = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0A_L);
        u16End = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0B_L);
        u16VideoHeight = u16End - u16Start + 1;
        // FRC 3D,SC transfer to TB,FRC transfer to LA,tb out 3D main display window height is 1/2 of LA
        if(MHal_FRC_IsEnableFRC3D(pInstance, MAIN_WINDOW) && (pXCResourcePrivate->stdrvXC_3D._bLAToTB) && IS_OUTPUT_4K2K_60HZ_PANEL())
        {
            if(!IsVMirrorMode(eWindow))
            {
                u16End = (u16Start -pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart)/2
                    + pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart + (u16End-u16Start +1)/2 -1;
                u16Start = (u16Start -pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart)/2
                    + pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart;
            }
            else
            {
                u16Start = (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height
                    - (u16Start -pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart)
                    - u16VideoHeight) / 2
                    + u16Start + u16VideoHeight / 2;

                u16End = u16Start + u16VideoHeight/2 -1;
            }
        }
        u16Start = u16Start + VSTART_OFFSET;
        u16End = u16End + VSTART_OFFSET;

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0D_L, u16Start, 0x1FFF);
        if (Hal_SC_NeedXCV8Align(pInstance))
        {
            u16End = u16Start + XC8ALIGN(u16End - u16Start + 1) - 1;
        }
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0E_L, u16End, 0x1FFF);

        // copy main disp X
        u16Start = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_08_L);
        u16End = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_09_L);

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_05_L, u16Start, 0x3FFF);
        if (Hal_SC_NeedXCH8Align(pInstance))
        {
            //w need be 8 align
            u16End = u16Start + XC8ALIGN(u16End - u16Start + 1) - 1;
        }
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_06_L, u16End, 0x3FFF);
    }
    else
    {
        // copy sub disp Y
        u16Start = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_09_L);
        u16End = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_0A_L);

        //not for Maserati 120Hz
        MS_U8 u8LPLL_Type =(MS_U8)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type;
        if(!IsVBY1_16LANE(u8LPLL_Type))
        {
            //if FRC 3D enable and output 3D type is LA or FA, hide sub window.
            if((pXCResourcePrivate->stdrvXC_3D._bFAToTB ||pXCResourcePrivate->stdrvXC_3D._bLAToTB)
                && pXCResourcePrivate->stdrvXC_3D._bFRC3DEnabled )
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_09_L, 0x1FFF, 0x1FFF);//tgen's sub de can't be generated.
            }
        }
        u16Start = u16Start +  VSTART_OFFSET;
        u16End =  u16End + VSTART_OFFSET;

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_12_L, u16Start, 0x1FFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_13_L, u16End, 0x1FFF);

        // copy sub disp X
        u16Start = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_07_L);
        u16End = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_08_L);

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_10_L, u16Start, 0x3FFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_11_L, u16End, 0x3FFF);
    }
#endif
}

static MS_BOOL _MHal_XC_IsNeedIP2Crop(void* pInstance, SCALER_WIN enWindow)
{
    MS_BOOL bIsFromMVOP = FALSE;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    INPUT_SOURCE_TYPE_t enSrcType = pXCResourcePrivate->stdrvXC_MVideo._SCShared.StatusInfo[enWindow].enInputSourceType;
    if(IsSrcTypeDTV(enSrcType)||IsSrcTypeStorage(enSrcType))
    {
        bIsFromMVOP = TRUE;
    }
    if(((MDrv_XC_GetDynamicScalingStatus(pInstance)) ||
        (MDrv_XC_Is_DSForceIndexEnabled(pInstance, enWindow)))
        && bIsFromMVOP)
    {
        return TRUE;
    }
    return FALSE;
}
static MS_BOOL _Hal_SC_Get_Histogram_Shift(void *pInstance, P_SC_SWDB_INFO pDBreg)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(pDBreg != NULL)
    {
        if((pDBreg->u16H_CapSize <=1280) && (pDBreg->u16V_CapSize <= 720))
        {
            pXCResourcePrivate->u16HistogramShift = 4;
        }
        else if((pDBreg->u16H_CapSize <=1920) && (pDBreg->u16V_CapSize <= 1080))
        {
            pXCResourcePrivate->u16HistogramShift = 5;
        }
        else
        {
            pXCResourcePrivate->u16HistogramShift = 7;
        }
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

static void _Hal_SC_fill_main_sw_db_burst(void *pInstance, P_SC_SWDB_INFO pDBreg)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_U16 u16HProtect = 0;
    MS_U16 u16CapVSize = 0;
    MS_U16 u16VSizeAfterPreScaling = 0;
    MS_U16 u16HdrWinHSize = 0;
    MS_U16 u16HdrWinVSize = 0;
    MS_BOOL bGetHDRSizeFromMVOP = FALSE;
    MS_WINDOW_TYPE stDspwin;
    memset(&stDspwin, 0, sizeof(MS_WINDOW_TYPE));


    if(Hal_SC_is_extra_req_en(pInstance, &pDBreg->u16H_DisStart, &pDBreg->u16H_DisEnd, NULL, NULL))
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_11_L, BIT(15), BIT(15));
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_11_L, 0, BIT(15));
    }

    if(pDBreg->u8FrameCount > 0)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_19_L, (MS_U16)(pDBreg->u8FrameCount>>00), BITMASK(4:0));
        // force reset write bank
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_05_L, BIT(7), BIT(7));
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_05_L, 0, BIT(7));
    }
    else
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"Frame count can't be 0, Frame count=%tu, Current HW frame count=%tu\n", (ptrdiff_t)pDBreg->u8FrameCount, (ptrdiff_t)(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_19_L, BITMASK(4:0))));
    }

    //H pre-scaling
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK02_04_L, (MS_U16)(pDBreg->u32H_PreScalingRatio>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK02_05_L, (MS_U16)(pDBreg->u32H_PreScalingRatio>>16), 0xFFFF);
    //V pre-scaling
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK02_08_L, (MS_U16)(pDBreg->u32V_PreScalingRatio>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK02_09_L, (MS_U16)(pDBreg->u32V_PreScalingRatio>>16), 0xFFFF);
    //H post-scaling
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_07_L, (MS_U16)(pDBreg->u32H_PostScalingRatio>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_08_L, (MS_U16)(pDBreg->u32H_PostScalingRatio>>16), 0x1FF);
    //V post-scaling
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_09_L, (MS_U16)(pDBreg->u32V_PostScalingRatio>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_0A_L, (MS_U16)(pDBreg->u32V_PostScalingRatio>>16), 0x1FF);

    //If no scaling, close DSC for power-saving (Update VR F000_01[2])
    MDrv_COMM_VR_W2BYTEMSK(REG_VR_BK00_01_L, (((pDBreg->bIsHScalingUp|pDBreg->bIsVScalingUp) == FALSE) ? BIT(2) : 0), BIT(2));
#ifdef SUPPORT_Scaling_Sub1_Mode
    //H post-scaling Phase
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_01_L, (MS_U16)(pDBreg->u32H_PostScalingIniFactor>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_02_L, (MS_U16)(pDBreg->u32H_PostScalingIniFactor>>16), 0xFFFF);
    //H post-scaling Sub1 Mode
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_08_L, (pDBreg->bIsHScalingUp == TRUE ? BIT(9) : 0), BIT(9));
    //V post-scaling Phase
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_03_L, (MS_U16)(pDBreg->u32V_PostScalingIniFactor>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_04_L, (MS_U16)(pDBreg->u32V_PostScalingIniFactor>>16), 0xFFFF);
    //V post-scaling Sub1 Mode
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_0A_L, (pDBreg->bIsVScalingUp == TRUE ? BIT(9) : 0), BIT(9));
#endif

    if(gSrcInfo[MAIN_WINDOW].bPreH_ScalingDown == TRUE)
    {
        //enable H size Protect
        //Set H Protect Size
        u16HProtect = ((pXCResourcePrivate->stdrvXC_MVideo._SCShared.StatusInfo[MAIN_WINDOW].u16H_SizeAfterPreScaling & 0x3FFF) | BIT(15));
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK4C_40_L, u16HProtect, 0xBFFF);
    }
    else
    {
        //disable H size Protect
        //Set H Protect Size 0
        u16HProtect = 0;
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK4C_40_L, u16HProtect, 0xBFFF);
    }

    //SCMI: vertical limitation
    if (Hal_SC_NeedXCV8Align(pInstance))
    {
        pDBreg->u16VWritelimit = XC8ALIGN(pDBreg->u16VWritelimit);
    }
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_18_L, (MS_U16)(pDBreg->u16VWritelimit), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_1A_L, (MS_U16)(pDBreg->u32DNRBase1>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_1B_L, (MS_U16)(pDBreg->u32DNRBase1>>16), 0xFFFF);

    //SCMI: IPM address 0
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_08_L, (MS_U16)(pDBreg->u32DNRBase0>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_09_L, (MS_U16)(pDBreg->u32DNRBase0>>16), 0xFFFF);
    //SCMI: DNR address 1
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_1A_L, (MS_U16)(pDBreg->u32DNRBase1>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_1B_L, (MS_U16)(pDBreg->u32DNRBase1>>16), 0xFFFF);
    //SCMI: DNR address 2
    //MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_0C_L, (MS_U16)(pDBreg->u32DNRBase2>>00), 0xFFFF);
    //MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_0D_L, (MS_U16)(pDBreg->u32DNRBase2>>16), 0xFFFF);

    //SCMI: DNR offset
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_0E_L, (MS_U16)(pDBreg->u16DNROffset>>00), 0xFFFF);
    //SCMI: DNR fetch
    if (Hal_SC_NeedXCH8Align(pInstance))
    {
        pDBreg->u16DNRFetch = XC8ALIGN(pDBreg->u16DNRFetch);
    }

    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_0F_L, (MS_U16)(pDBreg->u16DNRFetch>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_1C_L, 0x0, 0xFFFF); //always disable IP H mirror line offset note:ds will enable this register at vdec firmware

    //SCMI: OPM address 0
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_10_L, (MS_U16)(pDBreg->u32OPMBase0>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_11_L, (MS_U16)(pDBreg->u32OPMBase0>>16), 0xFFFF);
    //SCMI: OPM address 1
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_12_L, (MS_U16)(pDBreg->u32OPMBase1>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_13_L, (MS_U16)(pDBreg->u32OPMBase1>>16), 0xFFFF);
    //SCMI: OPM address 2
    //    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_14_L, (MS_U16)(pDBreg->u32OPMBase2>>00), 0xFFFF);
    //    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_15_L, (MS_U16)(pDBreg->u32OPMBase2>>16), 0xFFFF);
    //SCMI: OPM offset
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_16_L, (MS_U16)(pDBreg->u16OPMOffset>>00), 0xFFFF);
    //SCMI: OPM fetch
    if (Hal_SC_NeedXCH8Align(pInstance))
    {
        pDBreg->u16OPMFetch = XC8ALIGN(pDBreg->u16OPMFetch);
    }
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_17_L, (MS_U16)(pDBreg->u16OPMFetch>>00), 0xFFFF);

    //LBox WSize
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0B_14_L, (MS_U16)(gSrcInfo[MAIN_WINDOW].ScaledCropWin.width), 0x1FFF);
    //LBox HSize
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0B_15_L, (MS_U16)(gSrcInfo[MAIN_WINDOW].ScaledCropWin.height), 0x1FFF);

    //OPM crop offset
    if(MHal_XC_GetCropMode() == E_XC_CROP_MIU_ENHANCED_MODE)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_5A_L, (gSrcInfo[MAIN_WINDOW].ScaledCropWin.x - gSrcInfo[MAIN_WINDOW].Status2.u16LBOffset), 0x1FFF);
        if(gSrcInfo[MAIN_WINDOW].b420CmpEnable)
        {
            if(gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_5B_L, (((gSrcInfo[MAIN_WINDOW].ScaledCropWin.y/2) + 0x1) & ~0x1), 0x1FFF);
            }
            else
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_5B_L, ((gSrcInfo[MAIN_WINDOW].ScaledCropWin.y + 0x1) & ~0x1), 0x1FFF);
            }
        }
        else
        {
            if(gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_5B_L, (gSrcInfo[MAIN_WINDOW].ScaledCropWin.y/2), 0x1FFF);
            }
            else
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_5B_L, gSrcInfo[MAIN_WINDOW].ScaledCropWin.y, 0x1FFF);
            }
        }
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_5A_L, 0x0, 0x1FFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_5B_L, 0x0, 0x1FFF);
    }

#ifdef UFO_XC_SUPPORT_DUAL_MIU
    if (psXCInstPri->u32DeviceID == 0) // Dual miu just support sc0 main window for main window.
    {
        if (IsEnableDualMode(MAIN_WINDOW))
        {
#if 0 // Dual do not support switch MIU setting Dynamic.
#if (MIU_SEL_USE_XC_INTERNAL == FALSE)
            MS_U16 u16OPMLeftMiuSel = 0;
            MS_U16 u16OPMRightMiuSel = 0;
            if(IsHMirrorMode(MAIN_WINDOW))
            {
                _Hal_SC_adjust_dual_miu_setting(pInstance, pXCResourcePrivate->stdrvXC_Scaling._au32PreFBAddress[MAIN_WINDOW],
                                                pXCResourcePrivate->stdrvXC_Scaling._u32PreDualFBAddress[MAIN_WINDOW], TRUE, &u16OPMLeftMiuSel, &u16OPMRightMiuSel);
            }
            else
            {
                _Hal_SC_adjust_dual_miu_setting(pInstance, pXCResourcePrivate->stdrvXC_Scaling._au32PreFBAddress[MAIN_WINDOW],
                                                pXCResourcePrivate->stdrvXC_Scaling._u32PreDualFBAddress[MAIN_WINDOW], FALSE, &u16OPMLeftMiuSel, &u16OPMRightMiuSel);
            }

            // miu request0  IPM/OPM LSB
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK7F_10_L, ((u16OPMLeftMiuSel & BIT(0)) << 1)|(u16OPMLeftMiuSel & BIT(0)), BIT(1)| BIT(0));
            // miu request0  IPM/OPM MSB
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK7F_18_L, (u16OPMLeftMiuSel & BIT(1))|((u16OPMLeftMiuSel & BIT(1)) >> 1), BIT(1)| BIT(0));
            // miu request1  IPM/OPM
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK7F_19_L, (u16OPMRightMiuSel << 2)| u16OPMRightMiuSel , BIT(3)| BIT(2) | BIT(1)| BIT(0));
#else
            _Hal_SC_adjust_swap_miu_setting_burst(pInstance,pXCResourcePrivate->stdrvXC_Scaling._u32PreDualFBAddress[MAIN_WINDOW]);
#endif
#endif
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK52_08_L, (MS_U16)(pDBreg->u32DualDNRBase0 >> 0), 0xFFFF);  //F2_1 IPM base addr
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK52_09_L, (MS_U16)(pDBreg->u32DualDNRBase0 >> 16), 0xFFFF);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK52_0E_L, (MS_U16)(pDBreg->u16DualDNROffset), 0x1FFF);  //F2_1 IPM offset
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK52_0F_L, (MS_U16)(pDBreg->u16DualDNRFetch), 0x1FFF);  //F2_1 IPM fetch number
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK52_10_L, (MS_U16)(pDBreg->u32DualOPMBase0 >> 0), 0xFFFF);  //F2_1 OPM base addr
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK52_11_L, (MS_U16)(pDBreg->u32DualOPMBase0 >> 16), 0xFFFF);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK52_16_L, (MS_U16)(pDBreg->u16DualOPMOffset), 0x1FFF);  //F2_1 OPM offset
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK52_17_L, (MS_U16)(pDBreg->u16DualOPMFetch), 0x1FFF);  //F2_1 OPM fetch number
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_28_L, (MS_U16)(pDBreg->u16DualDNRFetch + pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u16DNRFetch), 0x1FFF);  //F2 IPM total fetch
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_29_L, (MS_U16)(BIT(15)|(pDBreg->u16DualOPMFetch + pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u16OPMFetch)), 0x1FFF | BIT(15));  //F2 OPM total fetch

        }
        else
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_29_L, 0, BIT(15));
#if 0 // Dual do not support switch MIU setting Dynamic.
#if (MIU_SEL_USE_XC_INTERNAL == FALSE)
            MS_U16 u16OPMLeftMiuSel = 0;
            MS_U16 u16OPMRightMiuSel = 0;
            _Hal_SC_adjust_dual_miu_setting(pInstance, pXCResourcePrivate->stdrvXC_Scaling._au32PreFBAddress[MAIN_WINDOW],
                                            pXCResourcePrivate->stdrvXC_Scaling._u32PreDualFBAddress[MAIN_WINDOW], FALSE, &u16OPMLeftMiuSel, &u16OPMRightMiuSel);
            // miu request0  IPM/OPM LSB
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK7F_10_L, ((u16OPMLeftMiuSel & BIT(0)) << 1)|(u16OPMLeftMiuSel & BIT(0)), BIT(1)| BIT(0));
            // miu request0  IPM/OPM MSB
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK7F_18_L, (u16OPMLeftMiuSel & BIT(1))|((u16OPMLeftMiuSel & BIT(1)) >> 1), BIT(1)| BIT(0));
            // miu request1  IPM/OPM
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK7F_19_L, (u16OPMRightMiuSel << 2)| u16OPMRightMiuSel , BIT(3)| BIT(2) | BIT(1)| BIT(0));
#endif
#endif
        }
    }
#endif

    //PIP
    if (Hal_SC_NeedXCV8Align(pInstance))
    {
        pDBreg->u16VLen = XC8ALIGN(pDBreg->u16VLen);
    }
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_15_L, (MS_U16)(pDBreg->u16VLen>>00), 0xFFFF); // Write V length
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_1D_L, (MS_U16)(pDBreg->u16LBOffset&0xFF), 0x00FF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_2C_L, (MS_U16)(pDBreg->u16LBOffset&0xFF00), 0x0300);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_1C_L, (MS_U16)(pDBreg->u16DispOffset&0xFF), 0x00FF);
    // if LB Offset > externded pixels of bottom A session,
    // there would be garbage on the left side of sub video
    if (pDBreg->u16LBOffset > SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_14_L, 0x00FF))
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_14_L, (pDBreg->u16LBOffset&0xFF), 0x00FF);
    }

    // MM/DTV get HDR size from MVOP
    if (IsSrcTypeStorage(gSrcInfo[MAIN_WINDOW].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        MVOP_Handle stHdl = { E_MVOP_MODULE_MAIN };
        MVOP_SetImageWH stImageWH;

        MDrv_MVOP_GetCommand(&stHdl, E_MVOP_CMD_GET_DATA_HV_SIZE, &stImageWH, sizeof(MVOP_SetImageWH));

        u16HdrWinHSize = stImageWH.u16Width;
        u16HdrWinVSize = stImageWH.u16Height;
        bGetHDRSizeFromMVOP = TRUE;
    }

    //HDR input DE Window info
    if (gSrcInfo[MAIN_WINDOW].bR_FBL)
    {
        if (bGetHDRSizeFromMVOP == FALSE)
        {
            u16HdrWinHSize = gSrcInfo[MAIN_WINDOW].stCropWin.width;
            u16HdrWinVSize = gSrcInfo[MAIN_WINDOW].stCropWin.height;
        }

        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK79_08_L, (MS_U16)(u16HdrWinHSize>>00), 0x1FFF);
        if (gSrcInfo[MAIN_WINDOW].bInterlace)
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK79_09_L, (MS_U16)(u16HdrWinVSize>>01), 0x1FFF);
        }
        else
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK79_09_L, (MS_U16)(u16HdrWinVSize>>00), 0x1FFF);
        }
    }
    else
    {
        E_XC_3D_INPUT_MODE e3DInputFormat = pXCResourcePrivate->stdrvXC_3D._eInput3DMode[MAIN_WINDOW];
        E_XC_3D_OUTPUT_MODE e3DOutputFormat = pXCResourcePrivate->stdrvXC_3D._eOutput3DMode;

        if (bGetHDRSizeFromMVOP == FALSE)
        {
            u16HdrWinHSize = pDBreg->u16H_CapSize;
            u16HdrWinVSize = pDBreg->u16V_CapSize;
        }

        if((e3DInputFormat == E_XC_3D_INPUT_SIDE_BY_SIDE_HALF
            || e3DInputFormat == E_XC_3D_INPUT_CHECK_BORAD
            || e3DInputFormat == E_XC_3D_INPUT_PIXEL_ALTERNATIVE)
            && (e3DOutputFormat != E_XC_3D_OUTPUT_MODE_NONE))
        {
            //3D  SBS/CKB/PA HDR hv size should do hsize/2 & vsize*2 as scott.chu's advise
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK79_08_L, (MS_U16)((u16HdrWinHSize/2)>>00), 0x1FFF);
            if (gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK79_09_L, (MS_U16)((u16HdrWinVSize*2)>>01), 0x1FFF);
            }
            else
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK79_09_L, (MS_U16)((u16HdrWinVSize*2)>>00), 0x1FFF);
            }
        }
        else
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK79_08_L, (MS_U16)(u16HdrWinHSize>>00), 0x1FFF);
            if (gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK79_09_L, (MS_U16)(u16HdrWinVSize>>01), 0x1FFF);
            }
            else
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK79_09_L, (MS_U16)(u16HdrWinVSize>>00), 0x1FFF);
            }
        }
    }

#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    MS_U16 u16CapWidth = (MS_U16)pDBreg->u16H_CapSize;
    INPUT_SOURCE_TYPE_t enInputSource = gSrcInfo[MAIN_WINDOW].enInputSourceType;

    // FSS HDMI420 should set window by IP2 timing
    // Due to the para of setwindow is multiplied by 2 when pcmonitor reported. Divide 2 when setting register
    if(MHal_XC_IsHDMI420(pInstance, enInputSource) == TRUE)
    {
        u16CapWidth /= 2;
    }

    if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_07_L, MAIN_WINDOW), BIT(15)))
    {
        u16CapWidth |= 0x8000;
    }
    else
    {
        u16CapWidth |= 0x0000;
    }

    //capture window
    MDrv_XC_MLoad_WriteCmd(pInstance, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_04_L, MAIN_WINDOW), (MS_U16)(pDBreg->u16V_CapStart>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_05_L, MAIN_WINDOW), (MS_U16)(pDBreg->u16H_CapStart>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_06_L, MAIN_WINDOW), (MS_U16)(pDBreg->u16V_CapSize>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_07_L, MAIN_WINDOW), u16CapWidth, 0xFFFF);
#else
    /// before enable ML bit mask feature, the capture size for 2P setting BK01_07[15] need to be considered
    if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_07_L, BIT(15)))
    {
        pDBreg->u16H_CapSize |= 0x8000;
    }
    else
    {
        pDBreg->u16H_CapSize |= 0x0000;
    }

    //capture window
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK01_04_L, (MS_U16)(pDBreg->u16V_CapStart>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK01_05_L, (MS_U16)(pDBreg->u16H_CapStart>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK01_06_L, (MS_U16)(pDBreg->u16V_CapSize>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK01_07_L, (MS_U16)(pDBreg->u16H_CapSize>>00), 0xFFFF);
#endif

    //IP2 h crop
    if(_MHal_XC_IsNeedIP2Crop(pInstance,MAIN_WINDOW))
    {
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK4C_0B_L,BIT(0),BIT(0));
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK4C_0F_L,pDBreg->u16H_CapSize,0x3FFF);
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK4C_0B_L,0x0,BIT(0));
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK4C_0F_L,0x3FFF,0x3FFF);
    }

    if(gSrcInfo[MAIN_WINDOW].bInterlace)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK02_0E_L, (BIT(15)|(pDBreg->u16V_CapSize/2)), 0xFFFF);  // set cup size by user mode (bit 15), not auto sync from BK01_06
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK02_0E_L, (BIT(15)|pDBreg->u16V_CapSize), 0xFFFF);  // set cup size by user mode (bit 15), not auto sync from BK01_06
    }

#if defined(XC_SUPPORT_DLC_DYNAMIC_RANGE) && (XC_SUPPORT_DLC_DYNAMIC_RANGE == TRUE)
    ///IP Range
    MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_04_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHstart, 0x3FFF);
    MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_05_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHend, 0x3FFF);
    MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_06_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVstart, 0x3FFF);
    MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_07_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVend, 0x3FFF);
    ///RGBMAX IP Range
    MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_H_START, pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHstart, 0x3FFF);
    MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_H_END, pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHend, 0x3FFF);
    MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_V_START, pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVstart, 0x3FFF);
    MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_V_END, pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVend, 0x3FFF);
    ///VIP range
    MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK55_12_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPHstart, 0x3FFF);
    MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK55_13_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPHend, 0x3FFF);
    MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK55_10_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPVstart, 0x3FFF);
    MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK55_11_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPVend, 0x3FFF);
#else
    ////Add DLC Capture Range
    MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_04_L,0,0x3FFF);
    MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_05_L,(gSrcInfo[MAIN_WINDOW].stCapWin.width-1),0x3FFF);
    ///RGBMAX IP Range
    MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_H_START, 0, 0x3FFF);
    MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_H_END, (gSrcInfo[MAIN_WINDOW].stCapWin.width-1), 0x3FFF);
#if DLC_CaptureRange_SIX_OVER_EIGHT
    ////DLC Capture SIX OVER EIGHT Range
    if(gSrcInfo[MAIN_WINDOW].bInterlace)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_06_L,((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*1/8 -1),0x3FFF);
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_07_L,((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*7/8 -1),0x3FFF);
        MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_V_START, ((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*1/8 -1), 0x3FFF);
        MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_V_END, ((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*7/8 -1), 0x3FFF);
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_06_L,(gSrcInfo[MAIN_WINDOW].stCapWin.height*1/8 -1),0x3FFF);
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_07_L,(gSrcInfo[MAIN_WINDOW].stCapWin.height*7/8 -1),0x3FFF);
        MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_V_START, (gSrcInfo[MAIN_WINDOW].stCapWin.height*1/8 -1), 0x3FFF);
        MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_V_END, (gSrcInfo[MAIN_WINDOW].stCapWin.height*7/8 -1), 0x3FFF);
    }
#else
    ////DLC Capture FULL Range
    if(gSrcInfo[MAIN_WINDOW].bInterlace)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_06_L, 0, 0x3FFF);
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_07_L,((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)-2),0x3FFF);
        MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_V_START, 0, 0x3FFF);
        MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_V_END, ((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)-2), 0x3FFF);
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_06_L, 0, 0x3FFF);
        MDrv_XC_MLoad_WriteCmd(pInstance,REG_SC_BK5C_07_L,(gSrcInfo[MAIN_WINDOW].stCapWin.height-2),0x3FFF);
        MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_V_START, 0, 0x3FFF);
        MDrv_XC_MLoad_WriteCommand_NonXC(pInstance, REG_MAXRGB_BANK_EXT_335D, MAXRGB_V_END, (gSrcInfo[MAIN_WINDOW].stCapWin.height-2), 0x3FFF);
    }
#endif
#endif


#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
    if (psXCInstPri->u32DeviceID == 1)
    {
        MS_U16 u16HDEStart = SC_R2BYTE(0, REG_SC_BK10_04_L);
        //Display window
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_08_L, u16HDEStart/2, VOP_DISPLAY_HSTART_MASK);//temp solution(+90)
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_09_L, (u16HDEStart/2+ pDBreg->u16H_DisEnd -pDBreg->u16H_DisStart), VOP_DISPLAY_HEND_MASK);
        if (Hal_SC_NeedXCH8Align(pInstance))
        {
            stDspwin.x = u16HDEStart / 2;
            stDspwin.width = pDBreg->u16H_DisEnd - pDBreg->u16H_DisStart + 1;
        }
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_04_L, u16HDEStart/2, VOP_DISPLAY_HSTART_MASK);//temp solution(+90)
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_05_L, (u16HDEStart/2+ pDBreg->u16H_DisEnd -pDBreg->u16H_DisStart), VOP_DISPLAY_HEND_MASK);

        //  E_FRC_PIPE_DELAY_MODE ePipeDlyMode = E_FRC_PIPE_DELAY_MODE_AUTO;
        MS_U32 u32Sc1OneLineDly = (SC_R2BYTE(0, REG_SC_BK10_0C_L) + 1)/2;
        MS_U32 u32Sc1TGEN_Dly = 0;
        if (SC_R2BYTEMSK(0, REG_SC_BK68_50_L, BIT(3)) == 0)
        {
            MS_U32 u32STGEN_Dly = VIP_SC0_V_DLY*u32Sc1OneLineDly+VIP_SC0_H_DLY;
            MS_U32 u32Sc0TGEN_Dly = u32STGEN_Dly + TGEN_SC0_DLY;
            MS_U32 u32Sc1VIP_Dly = VIP_SC1_V_DLY*u32Sc1OneLineDly + VIP_SC1_H_DLY;
            if (u32Sc0TGEN_Dly > u32Sc1VIP_Dly + SC1_PRE_RUN_DLY)
            {
                u32Sc1TGEN_Dly = u32Sc0TGEN_Dly - u32Sc1VIP_Dly - SC1_PRE_RUN_DLY;
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0A_L, (MS_U16)(pDBreg->u16V_DisStart), VOP_DISPLAY_VSTART_MASK);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0B_L, (MS_U16)(pDBreg->u16V_DisEnd), VOP_DISPLAY_VEND_MASK);
                if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
                {
                    stDspwin.y = (MS_U16)(pDBreg->u16V_DisStar);
                    stDspwin.height = (MS_U16)(pDBreg->u16V_DisEnd -pDBreg->u16V_DisStar + 1);
                }
                // Maxim: Copy MDE to FDE for SC1 case
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_06_L, (MS_U16)(pDBreg->u16V_DisStart), VOP_DISPLAY_VSTART_MASK);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_07_L, (MS_U16)(pDBreg->u16V_DisEnd), VOP_DISPLAY_VEND_MASK);

            }
            else
            {
                u32Sc1TGEN_Dly = u32Sc0TGEN_Dly + u32Sc1OneLineDly - u32Sc1VIP_Dly - SC1_PRE_RUN_DLY;
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0A_L, (MS_U16)(pDBreg->u16V_DisStart-1), VOP_DISPLAY_VSTART_MASK);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0B_L, (MS_U16)(pDBreg->u16V_DisEnd-1), VOP_DISPLAY_VEND_MASK);
                if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
                {
                    stDspwin.y = (MS_U16)(pDBreg->u16V_DisStart - 1);
                    stDspwin.height = (MS_U16)(pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1);
                }
                // Maxim: Copy MDE to FDE for SC1 case
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_06_L, (MS_U16)(pDBreg->u16V_DisStart-1), VOP_DISPLAY_VSTART_MASK);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_07_L, (MS_U16)(pDBreg->u16V_DisEnd-1), VOP_DISPLAY_VEND_MASK);

            }
        }
        else
        {
            MS_U32 u32STGEN_Dly = VIP_SC0_USER_MODE_V_DLY*u32Sc1OneLineDly+VIP_SC0_USER_MODE_H_DLY;
            MS_U32 u32Sc0TGEN_Dly = u32STGEN_Dly + TGEN_SC0_USER_MODE_DLY;
            MS_U32 u32HComp = (pDBreg->u16H_DisStart - u16HDEStart)/2;
            MS_U32 u32Sc1VIP_Dly = VIP_SC1_V_DLY*u32Sc1OneLineDly + VIP_SC1_H_DLY;
            u32Sc1TGEN_Dly = u32Sc0TGEN_Dly - u32Sc1VIP_Dly - SC1_PRE_RUN_DLY + u32HComp;
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0A_L, (MS_U16)(pDBreg->u16V_DisStart), VOP_DISPLAY_VSTART_MASK);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0B_L, (MS_U16)(pDBreg->u16V_DisEnd), VOP_DISPLAY_VEND_MASK);
            if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
            {
                stDspwin.y = (MS_U16)(pDBreg->u16V_DisStar);
                stDspwin.height = (MS_U16)(pDBreg->u16V_DisEnd -pDBreg->u16V_DisStar + 1);
            }
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_06_L, (MS_U16)(pDBreg->u16V_DisStart), VOP_DISPLAY_VSTART_MASK);//maxim use fde
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_07_L, (MS_U16)(pDBreg->u16V_DisEnd), VOP_DISPLAY_VEND_MASK);
        }
        MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK68_61_L, (MS_U16)(u32Sc1TGEN_Dly%u32Sc1OneLineDly)*2, 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK68_62_L, (MS_U16)(u32Sc1TGEN_Dly/u32Sc1OneLineDly), 0xFFFF);

        if(!Hal_SC_3D_IsDualViewMode(pInstance,MAIN_WINDOW))
        {
            //Display window
            MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_07_L, (MS_U16)(pDBreg->u16H_DisStart>>00), VOP_DISPLAY_HSTART_MASK);
            MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_08_L, (MS_U16)(pDBreg->u16H_DisEnd>>00), VOP_DISPLAY_HEND_MASK);
            MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_09_L, (MS_U16)(pDBreg->u16V_DisStart), VOP_DISPLAY_VSTART_MASK);
            MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_0A_L, (MS_U16)(pDBreg->u16V_DisEnd), VOP_DISPLAY_VEND_MASK);
        }

    }
    else
    {
        MS_U16 u16Start = 0, u16End = 0;
        MS_U16 u16DispX = (pDBreg->u16H_DisStart +1) &~1; // Hstart need to be even
        if ((pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFSCEnabled) &&
            MHal_FRC_IsFHDToFSC(pInstance,MAIN_WINDOW))
        {
            u16DispX = (pDBreg->u16H_DisStart/2 +1) &~1; // Hstart need to be even

            u16Start = pDBreg->u16V_DisStart/2;
            u16End = (pDBreg->u16V_DisStart/2 + (pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1)/2 - 1);

            u16Start += VSTART_OFFSET;
            u16End += VSTART_OFFSET;

            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_0D_L, u16Start, 0x1FFF);
            if (Hal_SC_NeedXCV8Align(pInstance))
            {
                u16End = u16Start + XC8ALIGN(u16End - u16Start + 1) - 1;
            }
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_0E_L, u16End, 0x1FFF);

            u16Start = u16DispX;
            u16End = (u16DispX + (pDBreg->u16H_DisEnd - pDBreg->u16H_DisStart + 1)/2 - 1);

            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_05_L, u16Start, 0x3FFF);
            if (Hal_SC_NeedXCH8Align(pInstance))
            {
                //w need be 8 align
                u16End = u16Start + XC8ALIGN(u16End - u16Start + 1) - 1;
            }
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_06_L, u16End, 0x3FFF);
        }
        else
        {

#if (ENABLE_FIX_PP_DLY == TRUE)
            if (pDBreg->u16V_DisStart > pDBreg->u16V_DisEnd)
            {
                printf("[%s,%5d] Start point is larger than End point, NEED CHECK\n",__FUNCTION__,__LINE__);
            }
            MS_U16 u16Height = pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1;
            u16Start = pDBreg->u16V_DisStart + VSTART_OFFSET*2 +(SC0_PATH_DLY_FSC2X_V - SC0_PATH_DLY_FSC1X_V);
            u16End = u16Start+u16Height-1;
#else
            u16Start = pDBreg->u16V_DisStart;
            u16End = (pDBreg->u16V_DisStart + (pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1) - 1);

            u16Start += VSTART_OFFSET;
            u16End += VSTART_OFFSET;
#endif

            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_0D_L, u16Start, 0x1FFF);
            if (Hal_SC_NeedXCV8Align(pInstance))
            {
                u16End = u16Start + XC8ALIGN(u16End - u16Start + 1) - 1;
            }
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_0E_L, u16End, 0x1FFF);

#if (ENABLE_FIX_PP_DLY == TRUE)

            MS_U16 u16FDE_Hstart = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_03_L, 0x3FFF);
            if (u16FDE_Hstart > pDBreg->u16H_DisStart)
            {
                printf("[%s,%5d] u16FDE_Hstart is larger than pDBreg->u16H_DisStart, NEED CHECK\n",__FUNCTION__,__LINE__);
            }
            else
            {
                u16DispX = pDBreg->u16H_DisStart - u16FDE_Hstart ;
            }
#endif
            u16Start = u16DispX;
            u16End = u16DispX + ((pDBreg->u16H_DisEnd - pDBreg->u16H_DisStart + 1) - 1);

            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_05_L, u16Start, 0x3FFF);
            if (Hal_SC_NeedXCH8Align(pInstance))
            {
                //w need be 8 align
                u16End = u16Start + XC8ALIGN(u16End - u16Start + 1) - 1;
            }
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_06_L, u16End, 0x3FFF);
        }

        //Display window
        if((psXCInstPri->u32DeviceID != 1)
            &&  (MDrv_XC_GetDynamicScalingStatus(pInstance)
            || MDrv_XC_Is_DSForceIndexEnabled(pInstance, MAIN_WINDOW)))
        {

            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_08_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart), VOP_DISPLAY_HSTART_MASK);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_09_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart +pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width-1), VOP_DISPLAY_HEND_MASK);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0A_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart), VOP_DISPLAY_VSTART_MASK);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0B_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart + pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height-1), VOP_DISPLAY_VEND_MASK);
            if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
            {
                stDspwin.x = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart);
                stDspwin.width = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width);
                stDspwin.y = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart);
                stDspwin.height = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height);
            }
        }
        else
        {

            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_08_L, (MS_U16)(pDBreg->u16H_DisStart>>00), VOP_DISPLAY_HSTART_MASK);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_09_L, (MS_U16)(pDBreg->u16H_DisEnd>>00), VOP_DISPLAY_HEND_MASK);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0A_L, (MS_U16)(pDBreg->u16V_DisStart>>00), VOP_DISPLAY_VSTART_MASK);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0B_L, (MS_U16)(pDBreg->u16V_DisEnd>>00), VOP_DISPLAY_VEND_MASK);
            if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
            {
                stDspwin.x = (MS_U16)(pDBreg->u16H_DisStart>>00);
                stDspwin.width = (MS_U16)(pDBreg->u16H_DisEnd - pDBreg->u16H_DisStart + 1);
                stDspwin.y = (MS_U16)(pDBreg->u16V_DisStart>>00);
                stDspwin.height = (MS_U16)(pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1);
            }
        }
    }
#else
#if FRC_INSIDE
    //update FRC MDE setting for Mload
    MS_U16 u16Start = 0, u16End = 0;
    MS_U16 u16DispX = (pDBreg->u16H_DisStart +1) &~1; // Hstart need to be even
    if ((pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFSCEnabled) &&
        MHal_FRC_IsFHDToFSC(pInstance,MAIN_WINDOW))
    {
        u16DispX = (pDBreg->u16H_DisStart/2 +1) &~1; // Hstart need to be even

        u16Start = pDBreg->u16V_DisStart/2;
        u16End = (pDBreg->u16V_DisStart/2 + (pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1)/2 - 1);

        u16Start += VSTART_OFFSET;
        u16End += VSTART_OFFSET;

        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_0D_L, u16Start, 0x1FFF);
        if (Hal_SC_NeedXCV8Align(pInstance))
        {
            u16End = u16Start + XC8ALIGN(u16End - u16Start + 1) - 1;
        }
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_0E_L, u16End, 0x1FFF);

        u16Start = u16DispX;
        u16End = (u16DispX + (pDBreg->u16H_DisEnd - pDBreg->u16H_DisStart + 1)/2 - 1);

        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_05_L, u16Start, 0x3FFF);
        if (Hal_SC_NeedXCH8Align(pInstance))
        {
            //w need be 8 align
            u16End = u16Start + XC8ALIGN(u16End - u16Start + 1) - 1;
        }
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_06_L, u16End, 0x3FFF);
    }
    else
    {

#if (ENABLE_FIX_PP_DLY == TRUE)
        if (pDBreg->u16V_DisStart > pDBreg->u16V_DisEnd)
        {
            printf("[%s,%5d] Start point is larger than End point, NEED CHECK\n",__FUNCTION__,__LINE__);
        }
        MS_U16 u16Height = pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1;
        u16Start = pDBreg->u16V_DisStart + VSTART_OFFSET*2 +(SC0_PATH_DLY_FSC2X_V - SC0_PATH_DLY_FSC1X_V);
        u16End = u16Start + u16Height -1;
#else
        u16Start = pDBreg->u16V_DisStart;
        u16End = (pDBreg->u16V_DisStart + (pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1) - 1);

        u16Start += VSTART_OFFSET;
        u16End += VSTART_OFFSET;
#endif

        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_0D_L, u16Start, 0x1FFF);
        if (Hal_SC_NeedXCV8Align(pInstance))
        {
            u16End = u16Start + XC8ALIGN(u16End - u16Start + 1) - 1;
        }
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_0E_L, u16End, 0x1FFF);

#if (ENABLE_FIX_PP_DLY == TRUE)
        MS_U16 u16FDE_Hstart = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_03_L, 0x3FFF);
        if (u16FDE_Hstart > pDBreg->u16H_DisStart)
        {
            printf("[%s,%5d] u16FDE_Hstart is largr than pDBreg->u16H_DisStart, NEED CHECK!\n",__FUNCTION__,__LINE__);
        }
        else
        {
            u16DispX = pDBreg->u16H_DisStart -u16FDE_Hstart ;
        }
#endif

        u16Start = u16DispX;
        u16End = u16DispX + ((pDBreg->u16H_DisEnd - pDBreg->u16H_DisStart + 1) - 1);

        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_05_L, u16Start, 0x3FFF);
        if (Hal_SC_NeedXCH8Align(pInstance))
        {
            //w need be 8 align
            u16End = u16Start + XC8ALIGN(u16End - u16Start + 1) - 1;
        }
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_06_L, u16End, 0x3FFF);
    }
#endif
    //Display window
#if FRC_INSIDE
    if((psXCInstPri->u32DeviceID != 1)
        && (MDrv_XC_GetDynamicScalingStatus(pInstance)
        || MDrv_XC_Is_DSForceIndexEnabled(pInstance, MAIN_WINDOW)))
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_08_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart), VOP_DISPLAY_HSTART_MASK);
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_09_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart +pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width-1), VOP_DISPLAY_HEND_MASK);
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0A_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart), VOP_DISPLAY_VSTART_MASK);
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0B_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart + pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height-1), VOP_DISPLAY_VEND_MASK);
        if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
        {
            stDspwin.x = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart);
            stDspwin.width = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width);
            stDspwin.y = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart);
            stDspwin.height = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height);
        }
    }
    else
#endif
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_08_L, (MS_U16)(pDBreg->u16H_DisStart>>00), VOP_DISPLAY_HSTART_MASK);
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_09_L, (MS_U16)(pDBreg->u16H_DisEnd>>00), VOP_DISPLAY_HEND_MASK);
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0A_L, (MS_U16)(pDBreg->u16V_DisStart>>00), VOP_DISPLAY_VSTART_MASK);
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0B_L, (MS_U16)(pDBreg->u16V_DisEnd>>00), VOP_DISPLAY_VEND_MASK);
        if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
        {
            stDspwin.x = (MS_U16)(pDBreg->u16H_DisStart>>00);
            stDspwin.width = (MS_U16)(pDBreg->u16H_DisEnd - pDBreg->u16H_DisStart + 1);
            stDspwin.y = (MS_U16)(pDBreg->u16V_DisStart>>00);
            stDspwin.height = (MS_U16)(pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1);
        }
    }
#endif
    if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
    {
        Hal_SC_8AlignPatchBy2ndSDE(pInstance, TRUE, &stDspwin);
    }

    //  MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_1C_L, 0x0, 0xFFFF); //always disable IP H mirror line offset note:ds will enable this register at vdec firmware

#if SUPPORT_2_FRAME_MIRROR

    if( (gSrcInfo[MAIN_WINDOW].Status2.eFrameStoreNumber == IMAGE_STORE_2_FRAMES) && (!gSrcInfo[MAIN_WINDOW].bInterlace) && (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK2A_02_L, BIT(15)) == 0))
    {
        // 2_frmae_mirror cannot work when UC on

        //SCMI: DNR address 1
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_1A_L, (MS_U16)(pDBreg->u32DNRBase1>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_1B_L, (MS_U16)(pDBreg->u32DNRBase1>>16), 0xFFFF);

        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_30_L, 0x4000,0xFFFF);// enable two frame mirror

        if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_01_L, 0x0001) == 0 )//compress mode
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK08_32_L, 0x20,0x00F0); // opm_ce_lcnt_inv
        }
    }
    else
    {
        if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK2A_02_L, BIT(15)) == BIT(15))
        {
            printf("@@ [%s,%5d] 2_frmae_mirror cannot work when UC on  \n",__func__,__LINE__);
        }

        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_30_L, 0x0000,0xFFFF);// disable two frame mirror
    }
#endif

    MS_U16 u16reg = 0;
    if (((psXCInstPri->u32DeviceID == 0) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE))
        ||(psXCInstPri->u32DeviceID == 1))
    {
        u16reg = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK08_32_L);
    }
    else
    {
        u16reg = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK33_32_L);
    }


    if(pDBreg->bOpmLcntInv_En)
    {
        u16reg |= BIT(5);
    }
    else
    {
        u16reg &= ~ BIT(5);
    }


    //monaco/muji 3D mode need control sub for some output format, or else the edge of object in the image may shake
#if (HW_DESIGN_4K2K_VER == 4)
    E_XC_3D_OUTPUT_MODE e3DOutputFormat = MDrv_XC_Get_3D_Output_Mode(pInstance);
    if((e3DOutputFormat == E_XC_3D_OUTPUT_LINE_ALTERNATIVE)
       || (e3DOutputFormat == E_XC_3D_OUTPUT_TOP_BOTTOM) || (e3DOutputFormat == E_XC_3D_OUTPUT_TOP_BOTTOM_HW)
       || (e3DOutputFormat == E_XC_3D_OUTPUT_SIDE_BY_SIDE_HALF) || (e3DOutputFormat == E_XC_3D_OUTPUT_SIDE_BY_SIDE_HALF_HW)
       || (e3DOutputFormat == E_XC_3D_OUTPUT_FRAME_PACKING))
    {
        //Hal_SC_set_opm_lcnt_inv(pInstance, bopm_lcnt_inv, SUB_WINDOW);
        if(pDBreg->bOpmLcntInv_En)
        {
            u16reg |= BIT(4);
        }
        else
        {
            u16reg &= ~ BIT(4);
        }
    }
#endif

    if (((psXCInstPri->u32DeviceID == 0) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE))
        ||(psXCInstPri->u32DeviceID == 1))
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK08_32_L, u16reg, 0xFFFF);
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK33_32_L, u16reg, 0xFFFF);
    }

    // by HW RD's request, for main video BW issue, adjust R/W line buffer length
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_20_L, 0x1840,0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_21_L, 0x1840,0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_22_L, 0x4040,0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_23_L, 0x1040,0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_24_L, 0x0040,0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_2A_L, 0x1840,0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_2B_L, 0x40,0xFF);

    //VsyncDelay
#if defined(XC_SUPPORT_FASTSWITCH_BY_IP1GP) &&(XC_SUPPORT_FASTSWITCH_BY_IP1GP == TRUE)
    MDrv_XC_MLoad_WriteCmd(pInstance, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_5F_L, MAIN_WINDOW), pXCResourcePrivate->u16IPVsyncTrig, 0xFFFF);
#else
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK01_5F_L, pXCResourcePrivate->u16IPVsyncTrig, 0xFFFF);
#endif

    //ip histogram shift
    if (_Hal_SC_Get_Histogram_Shift(pInstance, pDBreg) == TRUE)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK45_11_L, pXCResourcePrivate->u16HistogramShift, 0xFFFF);
    }

    //IP User Mode Size Related
    if(gSrcInfo[MAIN_WINDOW].bInterlace)
    {
        u16CapVSize = pDBreg->u16V_CapSize >> 1;
        u16VSizeAfterPreScaling = (pXCResourcePrivate->stdrvXC_MVideo._SCShared.StatusInfo[MAIN_WINDOW].u16V_SizeAfterPreScaling & 0x1FFF) >> 1;
    }
    else
    {
        u16CapVSize = pDBreg->u16V_CapSize;
        u16VSizeAfterPreScaling = pXCResourcePrivate->stdrvXC_MVideo._SCShared.StatusInfo[MAIN_WINDOW].u16V_SizeAfterPreScaling & 0x1FFF;
    }

    if (Hal_SC_NeedXCV8Align(pInstance))
    {
        u16VSizeAfterPreScaling = XC8ALIGN(u16VSizeAfterPreScaling);
        if(!gSrcInfo[MAIN_WINDOW].bPreV_ScalingDown)
        {
            //V scaling down enable, set Bilinear mode, and VSD factor(3.20) = 1
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK02_08_L, 0, 0xFFFF);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK02_09_L, BIT(15) | BIT(14) | BIT(4), BIT(15) | BIT(14) | 0x7F);
        }
    }

    //Insert Black
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK4C_30_L, BIT(0), BIT(0));
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK4C_32_L, u16CapVSize, 0x1FFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK4C_33_L, pDBreg->u16H_CapSize, 0x1FFF);

    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK02_65_L, u16CapVSize, 0x1FFF);

    //IPMR_BWR 420 Repeat
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_36_L,  BIT(15) | u16VSizeAfterPreScaling, BIT(15)|0x1FFF);

    //IPM_BWR_422to420
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_3D_L,  BIT(15) | u16VSizeAfterPreScaling, BIT(15)|0x1FFF);
}

static void _Hal_SC_fill_sub_sw_db_burst(void *pInstance, P_SC_SWDB_INFO pDBreg)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(Hal_SC_is_extra_req_en(pInstance, NULL, NULL, &pDBreg->u16H_DisStart, &pDBreg->u16H_DisEnd))
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_11_L, BIT(15), BIT(15));
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_11_L, 0, BIT(15));
    }
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_59_L, (MS_U16)(pDBreg->u8FrameCount>>00), BITMASK(4:0));
    //H pre-scaling
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK04_04_L, (MS_U16)(pDBreg->u32H_PreScalingRatio>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK04_05_L, (MS_U16)(pDBreg->u32H_PreScalingRatio>>16), 0xFFFF);
    //V pre-scaling
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK04_08_L, (MS_U16)(pDBreg->u32V_PreScalingRatio>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK04_09_L, (MS_U16)(pDBreg->u32V_PreScalingRatio>>16), 0xFFFF);

    //H post-scaling
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_27_L, (MS_U16)(pDBreg->u32H_PostScalingRatio>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_28_L, (MS_U16)(pDBreg->u32H_PostScalingRatio>>16), 0x1FF);
    //V post-scaling
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_29_L, (MS_U16)(pDBreg->u32V_PostScalingRatio>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_2A_L, (MS_U16)(pDBreg->u32V_PostScalingRatio>>16), 0x1FF);

#ifdef SUPPORT_Scaling_Sub1_Mode
    //H post-scaling Phase
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_21_L, (MS_U16)(pDBreg->u32H_PostScalingIniFactor>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_22_L, (MS_U16)(pDBreg->u32H_PostScalingIniFactor>>16), 0xFFFF);
    //H post-scaling Sub1 Mode
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_28_L, (pDBreg->bIsHScalingUp == TRUE ? BIT(9) : 0), BIT(9));
    //V post-scaling Phase
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_23_L, (MS_U16)(pDBreg->u32V_PostScalingIniFactor>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_24_L, (MS_U16)(pDBreg->u32V_PostScalingIniFactor>>16), 0xFFFF);
    //V post-scaling Sub1 Mode
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK23_2A_L, (pDBreg->bIsVScalingUp == TRUE ? BIT(9) : 0), BIT(9));
#endif

    //SCMI: vertical limitation
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_58_L, (MS_U16)(pDBreg->u16VWritelimit), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_5A_L, (MS_U16)(pDBreg->u32WritelimitBase>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_5B_L, (MS_U16)(pDBreg->u32WritelimitBase>>16), 0xFFFF);
    //SCMI: IPM address 0
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_48_L, (MS_U16)(pDBreg->u32DNRBase0>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_49_L, (MS_U16)(pDBreg->u32DNRBase0>>16), 0xFFFF);
    //SCMI: DNR address 1
    //MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_4A_L, (MS_U16)(pDBreg->u32DNRBase1>>00), 0xFFFF);
    //MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_4B_L, (MS_U16)(pDBreg->u32DNRBase1>>16), 0xFFFF);
    //SCMI: DNR address 2
    //MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_4C_L, (MS_U16)(pDBreg->u32DNRBase2>>00), 0xFFFF);
    //MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_4D_L, (MS_U16)(pDBreg->u32DNRBase2>>16), 0xFFFF);
    //SCMI: DNR offset
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_4E_L, (MS_U16)(pDBreg->u16DNROffset>>00), 0xFFFF);
    //SCMI: DNR fetch
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_4F_L, (MS_U16)(pDBreg->u16DNRFetch>>00), 0xFFFF);
    //SCMI: OPM address 0
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_50_L, (MS_U16)(pDBreg->u32OPMBase0>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_51_L, (MS_U16)(pDBreg->u32OPMBase0>>16), 0xFFFF);
    //SCMI: OPM address 1
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_52_L, (MS_U16)(pDBreg->u32OPMBase1>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_53_L, (MS_U16)(pDBreg->u32OPMBase1>>16), 0xFFFF);
    //SCMI: OPM address 2
    //MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_54_L, (MS_U16)(pDBreg->u32OPMBase2>>00), 0xFFFF);
    //MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_55_L, (MS_U16)(pDBreg->u32OPMBase2>>16), 0xFFFF);
    //SCMI: OPM offset
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_56_L, (MS_U16)(pDBreg->u16OPMOffset>>00), 0xFFFF);
    //SCMI: OPM fetch
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_57_L, (MS_U16)(pDBreg->u16OPMFetch>>00), 0xFFFF);
    //PIP
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_16_L, (MS_U16)(pDBreg->u16VLen>>00), 0xFFFF); // Write V length
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_1D_L, (MS_U16)((pDBreg->u16LBOffset&0xFF)<<8), 0xFF00);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_2C_L, (MS_U16)((pDBreg->u16LBOffset&0xFF00)<<4), 0x3000);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_1C_L, (MS_U16)((pDBreg->u16DispOffset&0xFF)<<8), 0xFF00);

    /// before enable ML bit mask feature, the capture size for 2P setting BK03_07[15] need to be considered
    if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_07_L, BIT(15)))
        pDBreg->u16H_CapSize |= 0x8000;
    else
        pDBreg->u16H_CapSize |= 0x0000;

    // capture window
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK03_04_L, (MS_U16)(pDBreg->u16V_CapStart>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK03_05_L, (MS_U16)(pDBreg->u16H_CapStart>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK03_06_L, (MS_U16)(pDBreg->u16V_CapSize>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK03_07_L, (MS_U16)(pDBreg->u16H_CapSize>>00), 0xFFFF);

    //Display window
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_07_L, (MS_U16)(pDBreg->u16H_DisStart>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_08_L, (MS_U16)(pDBreg->u16H_DisEnd>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_09_L, (MS_U16)(pDBreg->u16V_DisStart>>00), 0xFFFF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_0A_L, (MS_U16)(pDBreg->u16V_DisEnd>>00), 0xFFFF);

    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_5C_L, 0x0, 0x1FFF); //always disable IP H mirror line offset note:ds will enable this register at vdec firmware

    MS_U16 u16reg = 0;
    if (((psXCInstPri->u32DeviceID == 0) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE))
        ||(psXCInstPri->u32DeviceID == 1))
    {
        u16reg = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK08_32_L);
    }
    else
    {
        u16reg = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK33_32_L);
    }

    if(pDBreg->bOpmLcntInv_En)
    {
        u16reg |= BIT(4);
    }
    else
    {
        u16reg &= ~ BIT(4);
    }

    if (((psXCInstPri->u32DeviceID == 0) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE))
        ||(psXCInstPri->u32DeviceID == 1))
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK08_32_L, u16reg, 0xFFFF);
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK33_32_L, u16reg, 0xFFFF);
    }
}

void Hal_SC_sw_db_burst(void *pInstance, P_SC_SWDB_INFO pDBreg, SCALER_WIN eWindow )
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    //This is a HW Patch: VD signal unstable, so the source that has passed VD set this register bit = 1 ( buffer read/write without reference field's even/odd.)
    if(!gSrcInfo[eWindow].Status2.bEnable_ForceP)
    {
        if(IsSrcTypeDigitalVD(gSrcInfo[eWindow].enInputSourceType))
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_07_L, BIT(12), BIT(12));
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_07_L, 0, BIT(12));
        }
    }

    _MLOAD_ENTRY(pInstance);

    if( eWindow == MAIN_WINDOW )
    {
#if (FRC_INSIDE && (HW_DESIGN_4K2K_VER == 6))
        E_FRC_MLOAD_TRIG_MODE eTrigMode = E_FRC_MLOAD_TRIG_MODE_FROM_OP1;

        // if no mute
        if(gSrcInfo[MAIN_WINDOW].bBlackscreenEnabled == FALSE)
        {
            if(SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK68_5F_L) & BIT(15))
            {
                eTrigMode = E_FRC_MLOAD_TRIG_MODE_FROM_OP2;
            }
            else
            {
                eTrigMode = E_FRC_MLOAD_TRIG_MODE_FROM_OP1;
            }

            MHal_FRC_Set_Mload_Trig_Mode(pInstance, E_FRC_MLOAD_TRIG_MODE_FROM_OP1);

            _Hal_SC_fill_main_sw_db_burst(pInstance, pDBreg);
            MDrv_XC_MLoad_Fire(pInstance, TRUE);

            //--> restore
            MHal_FRC_Set_Mload_Trig_Mode(pInstance, eTrigMode);
        }
        else
        {
            _Hal_SC_fill_main_sw_db_burst(pInstance, pDBreg);
            MDrv_XC_MLoad_Fire(pInstance, TRUE);
        }
#else
        _Hal_SC_fill_main_sw_db_burst(pInstance, pDBreg);
        MDrv_XC_MLoad_Fire(pInstance, TRUE);
#endif
    }
    else
    {
        _Hal_SC_fill_sub_sw_db_burst(pInstance, pDBreg);
        MDrv_XC_MLoad_Fire(pInstance, TRUE);
    }

    _MLOAD_RETURN(pInstance);
}

void Hal_SC_dual_sw_db_burst(void *pInstance, P_SC_SWDB_INFO pMainDBreg, P_SC_SWDB_INFO pSubDBreg)
{
    _MLOAD_ENTRY(pInstance);

    _Hal_SC_fill_main_sw_db_burst(pInstance, pMainDBreg);
    _Hal_SC_fill_sub_sw_db_burst(pInstance, pSubDBreg);
    MDrv_XC_MLoad_Fire(pInstance, TRUE);

    _MLOAD_RETURN(pInstance);
}

void Hal_SC_sw_db(void *pInstance, P_SC_SWDB_INFO pDBreg, SCALER_WIN eWindow )
{
    MS_U32 u32LcentInvReg = 0;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_U16 u16HProtect = 0;
    MS_U16 u16CapVSize = 0;
    MS_U16 u16VSizeAfterPreScaling =0;
    MS_U16 u16HdrWinHSize = 0;
    MS_U16 u16HdrWinVSize = 0;
    MS_BOOL bGetHDRSizeFromMVOP = FALSE;
    MS_WINDOW_TYPE stDspwin;
    memset(&stDspwin, 0, sizeof(MS_WINDOW_TYPE));


    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] [DS] bDynamicScalingEnable = %s\n",__func__,__LINE__,pXCResourcePrivate->sthal_SC.bDynamicScalingEnable[eWindow]?"True":"False");

    //This is a HW Patch: VD signal unstable, so the source that has passed VD set this register bit = 1 ( buffer read/write without reference field's even/odd.)
    if(!gSrcInfo[eWindow].Status2.bEnable_ForceP)
    {
        if(IsSrcTypeDigitalVD(gSrcInfo[eWindow].enInputSourceType))
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_07_L, BIT(12), BIT(12));
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_07_L, 0, BIT(12));
        }
    }

    if( eWindow == MAIN_WINDOW )
    {
        if(pDBreg->u8FrameCount > 0)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_19_L, pDBreg->u8FrameCount,BITMASK(4:0));
            // force reset write bank
            if(Hal_SC_CheckMuteStatusByRegister(pInstance, eWindow) == TRUE)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_05_L, BIT(7), BIT(7));
                MsOS_DelayTask(1);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_05_L, 0x00, BIT(7));
            }
        }
        else
        {
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"Frame count can't be 0, Frame count=%tu, Current HW frame count=%tu\n", (ptrdiff_t)pDBreg->u8FrameCount, (ptrdiff_t)(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_19_L, BITMASK(4:0))));
        }

        if(Hal_SC_is_extra_req_en(pInstance, &pDBreg->u16H_DisStart, &pDBreg->u16H_DisEnd, NULL, NULL))
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_11_L, BIT(15), BIT(15));
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_11_L, 0, BIT(15));
        }

        // H pre-scaling
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_04_L, pDBreg->u32H_PreScalingRatio);
        // V pre-scaling
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_08_L, pDBreg->u32V_PreScalingRatio);
        // H post-scaling
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_07_L, pDBreg->u32H_PostScalingRatio);
        // V post-scaling
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_09_L, pDBreg->u32V_PostScalingRatio);

        //If no scaling, close DSC for power-saving (Update VR F000_01[2])
        MDrv_COMM_VR_W2BYTEMSK(REG_VR_BK00_01_L, (((pDBreg->bIsHScalingUp|pDBreg->bIsVScalingUp) == FALSE) ? BIT(2) : 0), BIT(2));
#ifdef SUPPORT_Scaling_Sub1_Mode
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_01_L, pDBreg->u32H_PostScalingIniFactor);   // H pre-scaling Phase
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK23_08_L, (pDBreg->bIsHScalingUp == TRUE ? BIT(9) : 0), BIT(9)); //H post-scaling Sub1 Mode
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_03_L, pDBreg->u32V_PostScalingIniFactor);   // V pre-scaling Phase
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK23_0A_L, (pDBreg->bIsVScalingUp == TRUE ? BIT(9) : 0), BIT(9)); //V post-scaling Sub1 Mode
#endif

        if(gSrcInfo[MAIN_WINDOW].bPreH_ScalingDown == TRUE)
        {
            //enable H size Protect
            //Set H Protect Size
            u16HProtect = ((pXCResourcePrivate->stdrvXC_MVideo._SCShared.StatusInfo[MAIN_WINDOW].u16H_SizeAfterPreScaling & 0x3FFF) | BIT(15));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK4C_40_L, u16HProtect, 0xBFFF);
        }
        else
        {
            //disable H size Protect
            //Set H Protect Size 0
            u16HProtect = 0;
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK4C_40_L, u16HProtect, 0xBFFF);
        }

        //SCMI
        if (Hal_SC_NeedXCV8Align(pInstance))
        {
            pDBreg->u16VWritelimit = XC8ALIGN(pDBreg->u16VWritelimit);
        }
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_18_L, pDBreg->u16VWritelimit); // Set vertical limitation
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_1A_L, pDBreg->u32DNRBase1);

        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_08_L, pDBreg->u32DNRBase0);     // input address0
        //SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0A_L, pDBreg->u32DNRBase1);     // input address1
        //SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0C_L, pDBreg->u32DNRBase2);     // input address2

        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0E_L, pDBreg->u16DNROffset);// input Offset
        if (Hal_SC_NeedXCH8Align(pInstance))
        {
            pDBreg->u16DNRFetch = XC8ALIGN(pDBreg->u16DNRFetch);
        }
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0F_L, pDBreg->u16DNRFetch); // input fetch
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_1C_L, 0x0);         //always disable IP H mirror line offset note:ds will enable this register at vdec firmware


        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_10_L, pDBreg->u32OPMBase0); // output address0
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_12_L, pDBreg->u32OPMBase1); // output address1
//      SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_14_L, pDBreg->u32OPMBase2); // output address2
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_16_L, pDBreg->u16OPMOffset); // output offset
        if (Hal_SC_NeedXCH8Align(pInstance))
        {
            pDBreg->u16OPMFetch = XC8ALIGN(pDBreg->u16OPMFetch);
        }
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_17_L, pDBreg->u16OPMFetch);  // output fetch

        //LBox WSize
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0B_14_L, gSrcInfo[MAIN_WINDOW].ScaledCropWin.width, 0x1FFF);
        //LBox HSize
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0B_15_L, gSrcInfo[MAIN_WINDOW].ScaledCropWin.height, 0x1FFF);

        //OPM crop offset
        if(MHal_XC_GetCropMode() == E_XC_CROP_MIU_ENHANCED_MODE)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_5A_L, (gSrcInfo[MAIN_WINDOW].ScaledCropWin.x - gSrcInfo[MAIN_WINDOW].Status2.u16LBOffset), 0x1FFF);
            if(gSrcInfo[MAIN_WINDOW].b420CmpEnable)
            {
                if(gSrcInfo[MAIN_WINDOW].bInterlace)
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_5B_L, (((gSrcInfo[MAIN_WINDOW].ScaledCropWin.y/2) + 0x1) & ~0x1), 0x1FFF);
                }
                else
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_5B_L, ((gSrcInfo[MAIN_WINDOW].ScaledCropWin.y + 0x1) & ~0x1), 0x1FFF);
                }
            }
            else
            {
                if(gSrcInfo[MAIN_WINDOW].bInterlace)
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_5B_L, (gSrcInfo[MAIN_WINDOW].ScaledCropWin.y/2), 0x1FFF);
                }
                else
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_5B_L, gSrcInfo[MAIN_WINDOW].ScaledCropWin.y, 0x1FFF);
                }
            }
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_5A_L, 0x0, 0x1FFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_5B_L, 0x0, 0x1FFF);
        }
#ifdef UFO_XC_SUPPORT_DUAL_MIU
        if (psXCInstPri->u32DeviceID == 0) // Dual miu just support sc0 main window for main window.
        {
            if(IsEnableDualMode(eWindow))
            {
#if 0 // Dual miu do not support switch miu select dynamicly.
#if (MIU_SEL_USE_XC_INTERNAL == FALSE)
                MS_U16 u16OPMLeftMiuSel = 0;
                MS_U16 u16OPMRightMiuSel = 0;
                if(IsHMirrorMode(eWindow))
                {
                    _Hal_SC_adjust_dual_miu_setting(pInstance, pXCResourcePrivate->stdrvXC_Scaling._au32PreFBAddress[MAIN_WINDOW],
                                                    pXCResourcePrivate->stdrvXC_Scaling._u32PreDualFBAddress[MAIN_WINDOW], TRUE, &u16OPMLeftMiuSel, &u16OPMRightMiuSel);
                }
                else
                {
                    _Hal_SC_adjust_dual_miu_setting(pInstance, pXCResourcePrivate->stdrvXC_Scaling._au32PreFBAddress[MAIN_WINDOW],
                                                    pXCResourcePrivate->stdrvXC_Scaling._u32PreDualFBAddress[MAIN_WINDOW], FALSE, &u16OPMLeftMiuSel, &u16OPMRightMiuSel);
                }
                // miu request0  IPM/OPM LSB
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_10_L, ((u16OPMLeftMiuSel & BIT(0)) << 1)|(u16OPMLeftMiuSel & BIT(0)), BIT(1)| BIT(0));
                // miu request0  IPM/OPM MSB
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_18_L, (u16OPMLeftMiuSel & BIT(1))|((u16OPMLeftMiuSel & BIT(1)) >> 1), BIT(1)| BIT(0));
                // miu request1  IPM/OPM
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_19_L, (u16OPMRightMiuSel << 2)| u16OPMRightMiuSel , BIT(3)| BIT(2) | BIT(1)| BIT(0));
#else
                _Hal_SC_adjust_swap_miu_setting(pInstance,pXCResourcePrivate->stdrvXC_Scaling._u32PreDualFBAddress[MAIN_WINDOW]);
#endif
#endif
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_08_L, pDBreg->u32DualDNRBase0 >> 0, 0xFFFF);  //F2_1 IPM base addr
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_09_L, pDBreg->u32DualDNRBase0 >> 16, 0x03FF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_0E_L, pDBreg->u16DualDNROffset, 0x1FFF);  //F2_1 IPM offset
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_0F_L, pDBreg->u16DualDNRFetch, 0x1FFF);  //F2_1 IPM fetch number
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_10_L, pDBreg->u32DualOPMBase0 >> 0, 0xFFFF);  //F2_1 OPM base addr
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_11_L, pDBreg->u32DualOPMBase0 >> 16, 0x03FF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_16_L, pDBreg->u16DualOPMOffset, 0x1FFF);  //F2_1 OPM offset
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_17_L, pDBreg->u16DualOPMFetch, 0x1FFF);  //F2_1 OPM fetch number
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_28_L, pDBreg->u16DualDNRFetch + pDBreg->u16DNRFetch, 0x1FFF);  //F2 IPM total fetch
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_29_L, pDBreg->u16DualOPMFetch + pDBreg->u16OPMFetch, 0x1FFF);  //F2 OPM total fetch
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_29_L, BIT(15), BIT(15));  //Enable SCMI MIU Dual mode
            }
            else
            {
                SC_W2BYTEMSK(0, REG_SC_BK11_29_L, 0, BIT(15));
#if 0 // Dual miu do not support switch miu dynamicly.
#if (MIU_SEL_USE_XC_INTERNAL == FALSE)
                MS_U16 u16OPMLeftMiuSel = 0;
                MS_U16 u16OPMRightMiuSel = 0;
                _Hal_SC_adjust_dual_miu_setting(pInstance, pXCResourcePrivate->stdrvXC_Scaling._au32PreFBAddress[MAIN_WINDOW],
                                                pXCResourcePrivate->stdrvXC_Scaling._u32PreDualFBAddress[MAIN_WINDOW], FALSE, &u16OPMLeftMiuSel, &u16OPMRightMiuSel);
                // miu request0  IPM/OPM LSB
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_10_L, ((u16OPMLeftMiuSel & BIT(0)) << 1)|(u16OPMLeftMiuSel & BIT(0)), BIT(1)| BIT(0));
                // miu request0  IPM/OPM MSB
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_18_L, (u16OPMLeftMiuSel & BIT(1))|((u16OPMLeftMiuSel & BIT(1)) >> 1), BIT(1)| BIT(0));
                // miu request1  IPM/OPM
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_19_L, (u16OPMRightMiuSel << 2)| u16OPMRightMiuSel , BIT(3)| BIT(2) | BIT(1)| BIT(0));
#else
                _Hal_SC_adjust_swap_miu_setting(pInstance,pXCResourcePrivate->stdrvXC_Scaling._au32PreFBAddress[MAIN_WINDOW]);
#endif
#endif
            }
        }
#endif

        //PIP
        if (Hal_SC_NeedXCV8Align(pInstance))
        {
            pDBreg->u16VLen = XC8ALIGN(pDBreg->u16VLen);
        }
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_15_L, pDBreg->u16VLen); // Write V length
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_1D_L, (pDBreg->u16LBOffset&0xFF), 0xFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_2C_L, (pDBreg->u16LBOffset&0xFF00), 0x0300);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_1C_L, (pDBreg->u16DispOffset&0xFF), 0xFF);
        // if LB Offset > externded pixels of bottom A session,
        // there would be garbage on the left side of sub video
        if (pDBreg->u16LBOffset > SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_14_L, 0xFF))
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_14_L, (pDBreg->u16LBOffset&0xFF), 0xFF);
        }

        // MM/DTV get HDR size from MVOP
        if (IsSrcTypeStorage(gSrcInfo[MAIN_WINDOW].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[MAIN_WINDOW].enInputSourceType))
        {
            MVOP_Handle stHdl = { E_MVOP_MODULE_MAIN };
            MVOP_SetImageWH stImageWH;

            MDrv_MVOP_GetCommand(&stHdl, E_MVOP_CMD_GET_DATA_HV_SIZE, &stImageWH, sizeof(MVOP_SetImageWH));

            u16HdrWinHSize = stImageWH.u16Width;
            u16HdrWinVSize = stImageWH.u16Height;
            bGetHDRSizeFromMVOP = TRUE;
        }

        //HDR input DE Window info
        if (gSrcInfo[MAIN_WINDOW].bR_FBL)
        {
            if (bGetHDRSizeFromMVOP == FALSE)
            {
                u16HdrWinHSize = gSrcInfo[MAIN_WINDOW].stCropWin.width;
                u16HdrWinVSize = gSrcInfo[MAIN_WINDOW].stCropWin.height;
            }

            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK79_08_L, (MS_U16)(u16HdrWinHSize>>00), 0x1FFF);
            if (gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK79_09_L, (MS_U16)(u16HdrWinVSize>>01), 0x1FFF);
            }
            else
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK79_09_L, (MS_U16)(u16HdrWinVSize>>00), 0x1FFF);
            }
        }
        else
        {
            E_XC_3D_INPUT_MODE e3DInputFormat = pXCResourcePrivate->stdrvXC_3D._eInput3DMode[MAIN_WINDOW];
            E_XC_3D_OUTPUT_MODE e3DOutputFormat = pXCResourcePrivate->stdrvXC_3D._eOutput3DMode;

            if (bGetHDRSizeFromMVOP == FALSE)
            {
                u16HdrWinHSize = pDBreg->u16H_CapSize;
                u16HdrWinVSize = pDBreg->u16V_CapSize;
            }

            if((e3DInputFormat == E_XC_3D_INPUT_SIDE_BY_SIDE_HALF
                || e3DInputFormat == E_XC_3D_INPUT_CHECK_BORAD
                || e3DInputFormat == E_XC_3D_INPUT_PIXEL_ALTERNATIVE)
                && (e3DOutputFormat != E_XC_3D_OUTPUT_MODE_NONE))
            {
                //3D  SBS/CKB/PA HDR hv size should do hsize/2 & vsize*2 as scott.chu's advise
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK79_08_L, (MS_U16)((u16HdrWinHSize/2)>>00), 0x1FFF);
                if (gSrcInfo[MAIN_WINDOW].bInterlace)
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK79_09_L, (MS_U16)((u16HdrWinVSize*2)>>01), 0x1FFF);
                }
                else
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK79_09_L, (MS_U16)((u16HdrWinVSize*2)>>00), 0x1FFF);
                }
            }
            else
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK79_08_L, (MS_U16)(u16HdrWinHSize>>00), 0x1FFF);
                if (gSrcInfo[MAIN_WINDOW].bInterlace)
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK79_09_L, (MS_U16)(u16HdrWinVSize>>01), 0x1FFF);
                }
                else
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK79_09_L, (MS_U16)(u16HdrWinVSize>>00), 0x1FFF);
                }
            }
        }

#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        MS_U16 u16CapWidth = (MS_U16)pDBreg->u16H_CapSize;
        INPUT_SOURCE_TYPE_t enInputSource = INPUT_SOURCE_NONE;

        if(eWindow == MAX_WINDOW)
        {
            enInputSource = MHal_XC_GetOfflineSource(pInstance, eWindow);
        }
        else
        {
            enInputSource = gSrcInfo[eWindow].enInputSourceType;
        }

        // FSS HDMI420 should set window by IP2 timing
        // Due to the para of setwindow is multiplied by 2 when pcmonitor reported. Divide 2 when setting register
        if(MHal_XC_IsHDMI420(pInstance, enInputSource) == TRUE)
        {
            u16CapWidth /= 2;
        }
        /// before enable ML bit mask feature, the capture size for 2P setting BK01_07[15] need to be considered
        if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_07_L, eWindow), BIT(15)))
        {
            u16CapWidth |= 0x8000;
        }
        else
        {
            u16CapWidth |= 0x0000;
        }

        // capture window
        SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_04_L, eWindow), pDBreg->u16V_CapStart); // Capture V start
        SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_05_L, eWindow), pDBreg->u16H_CapStart); // Capture H start
        SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_06_L, eWindow), pDBreg->u16V_CapSize);  // Capture V size
        SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_07_L, eWindow), u16CapWidth);  // Capture H size
#else
        /// before enable ML bit mask feature, the capture size for 2P setting BK01_07[15] need to be considered
        if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_07_L, BIT(15)))
            pDBreg->u16H_CapSize |= 0x8000;
        else
            pDBreg->u16H_CapSize |= 0x0000;

        // capture window
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_04_L, pDBreg->u16V_CapStart); // Capture V start
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_05_L, pDBreg->u16H_CapStart); // Capture H start
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_06_L, pDBreg->u16V_CapSize);  // Capture V size
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_07_L, pDBreg->u16H_CapSize);  // Capture H size
#endif

         //IP2 h crop
        if(_MHal_XC_IsNeedIP2Crop(pInstance,MAIN_WINDOW))
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK4C_0B_L,BIT(0),BIT(0));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK4C_0F_L,pDBreg->u16H_CapSize,0x3FFF);
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK4C_0B_L,0x0,BIT(0));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK4C_0F_L,0x3FFF,0x3FFF);
        }

        if(gSrcInfo[MAIN_WINDOW].bInterlace)
        {
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_0E_L, (BIT(15)|(pDBreg->u16V_CapSize/2)));  // set cup size by user mode (bit 15), not auto sync from BK01_06
        }
        else
        {
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_0E_L, (BIT(15)|pDBreg->u16V_CapSize));  // set cup size by user mode (bit 15), not auto sync from BK01_06
        }

#if defined(XC_SUPPORT_DLC_DYNAMIC_RANGE) && (XC_SUPPORT_DLC_DYNAMIC_RANGE == TRUE)
        ///IP Range
        SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_04_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHstart);
        SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_05_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHend);
        SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_06_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVstart);
        SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_07_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVend);
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_04_L, pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHstart, 0x3FFF);
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_05_L, pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHend, 0x3FFF);
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_06_L, pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVstart, 0x3FFF);
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_07_L, pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVend, 0x3FFF);
        ///VIP range
        SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK55_12_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPHstart);
        SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK55_13_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPHend);
        SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK55_10_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPVstart);
        SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK55_11_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPVend);

#else
        ////Add DLC Capture Range
        SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_04_L,0);
        SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_05_L,(gSrcInfo[MAIN_WINDOW].stCapWin.width-1));
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_04_L, 0, 0x3FFF);
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_05_L, (gSrcInfo[MAIN_WINDOW].stCapWin.width-1), 0x3FFF);
#if DLC_CaptureRange_SIX_OVER_EIGHT
        ////DLC Capture SIX OVER EIGHT Range
        if(gSrcInfo[MAIN_WINDOW].bInterlace)
        {
            SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_06_L,((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*1/8)-1);
            SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_07_L,((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*7/8)-1);
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_06_L, ((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*1/8)-1, 0x3FFF);
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_07_L, ((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*7/8)-1, 0x3FFF);
        }
        else
        {
            SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_06_L,(gSrcInfo[MAIN_WINDOW].stCapWin.height*1/8)-1);
            SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_07_L,(gSrcInfo[MAIN_WINDOW].stCapWin.height*7/8)-1);
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_06_L, (gSrcInfo[MAIN_WINDOW].stCapWin.height*1/8)-1, 0x3FFF);
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_07_L, (gSrcInfo[MAIN_WINDOW].stCapWin.height*7/8)-1, 0x3FFF);

        }
#else
        ////DLC Capture FULL Range
        if(gSrcInfo[MAIN_WINDOW].bInterlace)
        {
            SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_06_L, 0);
            SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_07_L,(gSrcInfo[MAIN_WINDOW].stCapWin.height/2)-2);
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_06_L, 0, 0x3FFF);
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_07_L, (gSrcInfo[MAIN_WINDOW].stCapWin.height/2)-2, 0x3FFF);

        }
        else
        {
            SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_06_L, 0);
            SC_W2BYTE(psXCInstPri->u32DeviceID,REG_SC_BK5C_07_L,gSrcInfo[MAIN_WINDOW].stCapWin.height-2);
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_06_L, 0, 0x3FFF);
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK5D_07_L, gSrcInfo[MAIN_WINDOW].stCapWin.height-2, 0x3FFF);

        }
#endif
#endif


#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
        //Display window
        if (psXCInstPri->u32DeviceID == 1)
        {
            MS_U16 u16HDEStart = SC_R2BYTE(0, REG_SC_BK10_04_L);
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_08_L, u16HDEStart/2);//temp solution(+90)
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_09_L, (u16HDEStart/2+ pDBreg->u16H_DisEnd -pDBreg->u16H_DisStart));
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_04_L, u16HDEStart/2);//temp solution(+90)
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_05_L, (u16HDEStart/2+ pDBreg->u16H_DisEnd -pDBreg->u16H_DisStart));
            if (Hal_SC_NeedXCH8Align(pInstance))
            {
                stDspwin.x = u16HDEStart / 2;
                stDspwin.width = pDBreg->u16H_DisEnd -pDBreg->u16H_DisStart + 1;
            }
            //  E_FRC_PIPE_DELAY_MODE ePipeDlyMode = E_FRC_PIPE_DELAY_MODE_AUTO;
            MS_U32 u32Sc1OneLineDly = (SC_R2BYTE(0, REG_SC_BK10_0C_L) + 1)/2;
            MS_U32 u32Sc1TGEN_Dly = 0;
            if ((SC_R2BYTEMSK(0, REG_SC_BK68_50_L, BIT(3)) == 0)
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
                && (!Hal_SC_3D_IsDualViewMode(pInstance, MAIN_WINDOW))
#endif
                )
            {
                MS_U32 u32STGEN_Dly = VIP_SC0_V_DLY*u32Sc1OneLineDly+VIP_SC0_H_DLY;
                MS_U32 u32Sc0TGEN_Dly = u32STGEN_Dly + TGEN_SC0_DLY;
                MS_U32 u32Sc1VIP_Dly = VIP_SC1_V_DLY*u32Sc1OneLineDly + VIP_SC1_H_DLY;

                if (u32Sc0TGEN_Dly > u32Sc1VIP_Dly + SC1_PRE_RUN_DLY)
                {
                    u32Sc1TGEN_Dly = u32Sc0TGEN_Dly - u32Sc1VIP_Dly - SC1_PRE_RUN_DLY;
                    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0A_L, pDBreg->u16V_DisStart);
                    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0B_L, pDBreg->u16V_DisEnd);
                    if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
                    {
                        stDspwin.y = (MS_U16)(pDBreg->u16V_DisStart);
                        stDspwin.height = (MS_U16)(pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1);
                    }
                    // Maxim: Copy MDE to FDE for SC1 case
                    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, pDBreg->u16V_DisStart);
                    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, pDBreg->u16V_DisEnd);
                }
                else
                {
                    u32Sc1TGEN_Dly = u32Sc0TGEN_Dly + u32Sc1OneLineDly - u32Sc1VIP_Dly - SC1_PRE_RUN_DLY;
                    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0A_L, pDBreg->u16V_DisStart - 1);
                    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0B_L, pDBreg->u16V_DisEnd - 1);
                    if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
                    {
                        stDspwin.y = (MS_U16)(pDBreg->u16V_DisStart - 1);
                        stDspwin.height = (MS_U16)(pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1);
                    }
                    // Maxim: Copy MDE to FDE for SC1 case
                    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, pDBreg->u16V_DisStart -1);
                    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, pDBreg->u16V_DisEnd -1);
                }
                SC_W2BYTE(0, REG_SC_BK68_61_L, (u32Sc1TGEN_Dly%u32Sc1OneLineDly)*2);// 2p mode
                SC_W2BYTE(0, REG_SC_BK68_62_L, u32Sc1TGEN_Dly/u32Sc1OneLineDly);
            }
            else
            {
                MS_U32 u32STGEN_Dly = VIP_SC0_USER_MODE_V_DLY*u32Sc1OneLineDly+VIP_SC0_USER_MODE_H_DLY;
                MS_U32 u32Sc0TGEN_Dly = u32STGEN_Dly + TGEN_SC0_USER_MODE_DLY;
                MS_U32 u32Sc1VIP_Dly = VIP_SC1_V_DLY*u32Sc1OneLineDly + VIP_SC1_H_DLY;
                MS_U32 u32HComp = (pDBreg->u16H_DisStart - u16HDEStart)/2;

                u32Sc1TGEN_Dly = u32Sc0TGEN_Dly - u32Sc1VIP_Dly - SC1_PRE_RUN_DLY + u32HComp;
                SC_W2BYTE(0, REG_SC_BK68_61_L, (u32Sc1TGEN_Dly%u32Sc1OneLineDly)*2);
                SC_W2BYTE(0, REG_SC_BK68_62_L, u32Sc1TGEN_Dly/u32Sc1OneLineDly);
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0A_L, pDBreg->u16V_DisStart);
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0B_L, pDBreg->u16V_DisEnd);
                if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
                {
                    stDspwin.y = (MS_U16)(pDBreg->u16V_DisStart);
                    stDspwin.height = (MS_U16)(pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1);
                }
                // Maxim: Copy MDE to FDE for SC1 case
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, pDBreg->u16V_DisStart);//maxim use fde
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, pDBreg->u16V_DisEnd);
            }
        }
        else
        {
            //Display window
            if((psXCInstPri->u32DeviceID != 1)
                && (MDrv_XC_GetDynamicScalingStatus(pInstance)
                || MDrv_XC_Is_DSForceIndexEnabled(pInstance, MAIN_WINDOW)))
            {
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_08_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart));
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_09_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart +pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width-1));
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0A_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart));
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0B_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart + pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height-1));
                if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
                {
                    stDspwin.x = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart);
                    stDspwin.width = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width);
                    stDspwin.y = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart);
                    stDspwin.height = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height);
                }
            }
            else
            {
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_08_L, pDBreg->u16H_DisStart);
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_09_L, pDBreg->u16H_DisEnd);
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0A_L, pDBreg->u16V_DisStart);
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0B_L, pDBreg->u16V_DisEnd);
                if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
                {
                    stDspwin.x = (MS_U16)(pDBreg->u16H_DisStart>>00);
                    stDspwin.width = (MS_U16)(pDBreg->u16H_DisEnd - pDBreg->u16H_DisStart + 1);
                    stDspwin.y = (MS_U16)(pDBreg->u16V_DisStart>>00);
                    stDspwin.height = (MS_U16)(pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1);
                }
            }

            //For SkipWaitVsync case, write riu directly.
            MDrv_FRC_UpdateMDE(pInstance, gSrcInfo[MAIN_WINDOW].stDispWin);
        }

        if ((psXCInstPri->u32DeviceID == 1) && (!Hal_SC_3D_IsDualViewMode(pInstance, MAIN_WINDOW)))//follow HW_DESIGN_4K2K_VER = 6 rule
        {
            //Display window
            SC_W2BYTE(0, REG_SC_BK0F_07_L, pDBreg->u16H_DisStart); // Display H start
            SC_W2BYTE(0, REG_SC_BK0F_08_L, pDBreg->u16H_DisEnd);   // Display H end
            SC_W2BYTE(0, REG_SC_BK0F_09_L, pDBreg->u16V_DisStart); // Display V start
            SC_W2BYTE(0, REG_SC_BK0F_0A_L, pDBreg->u16V_DisEnd);   // Display V end
        }
#else
#if FRC_INSIDE
        //Display window
       if((psXCInstPri->u32DeviceID != 1)
            && (MDrv_XC_GetDynamicScalingStatus(pInstance)
            || MDrv_XC_Is_DSForceIndexEnabled(pInstance, MAIN_WINDOW)))
        {
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_08_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart));
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_09_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart +pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width-1));
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0A_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart));
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0B_L, (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart + pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height-1));
            if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
            {
                stDspwin.x = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart);
                stDspwin.width = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width);
                stDspwin.y = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart);
                stDspwin.height = (MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height);
            }
        }
        else
#endif
        {
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_08_L, pDBreg->u16H_DisStart); // Display H start
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_09_L, pDBreg->u16H_DisEnd);   // Display H end
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0A_L, pDBreg->u16V_DisStart); // Display V start
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0B_L, pDBreg->u16V_DisEnd);   // Display V end
            if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
            {
                stDspwin.x = (MS_U16)(pDBreg->u16H_DisStart>>00);
                stDspwin.width = (MS_U16)(pDBreg->u16H_DisEnd - pDBreg->u16H_DisStart + 1);
                stDspwin.y = (MS_U16)(pDBreg->u16V_DisStart>>00);
                stDspwin.height = (MS_U16)(pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1);
            }
        }
#if FRC_INSIDE
        //For SkipWaitVsync case, write riu directly.
        //Update FRC MDE
        MDrv_FRC_UpdateMDE(pInstance, gSrcInfo[MAIN_WINDOW].stDispWin);
#endif
#endif
        if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
        {
            Hal_SC_8AlignPatchBy2ndSDE(pInstance, FALSE, &stDspwin);
        }

        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_1C_L, 0x0);         //always disable IP H mirror line offset note:ds will enable this register at vdec firmware

// 2_frame_mirror setting
#if SUPPORT_2_FRAME_MIRROR
        // 2_frmae_mirror cannot work when UC on
        if( (gSrcInfo[eWindow].Status2.eFrameStoreNumber == IMAGE_STORE_2_FRAMES) && (!gSrcInfo[eWindow].bInterlace) && (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK2A_02_L, BIT(15)) == 0))
        {
            //SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_1A_L, pDBreg->u32DNRBase1);  // IPM base1
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_30_L, 0x4000, BIT(14));   // enable two frame mirror

            if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_01_L, 0x0001) == 0 )//compress mode
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_32_L, 0X20 ,0x00F0 );   // opm_ce_lcnt_inv
            }
        }
        else
        {
            if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK2A_02_L, BIT(15)) == BIT(15))
            {
                printf("@@ [%s,%5d] 2_frmae_mirror cannot work when UC on  \n",__func__,__LINE__);
            }

            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_30_L, 0x00 , BIT(14)); // disable two frame mirror
        }
#endif
        if (((psXCInstPri->u32DeviceID == 0) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE))
            ||(psXCInstPri->u32DeviceID == 1))
        {
            u32LcentInvReg = REG_SC_BK08_32_L;
        }
        else
        {
            u32LcentInvReg = REG_SC_BK33_32_L;
        }

        if(pDBreg->bOpmLcntInv_En)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32LcentInvReg, BIT(5), BIT(5));
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32LcentInvReg, 0x00, BIT(5));
        }

        //monaco/muji 3D mode need control sub for some output format, or else the edge of object in the image may shake
#if (HW_DESIGN_4K2K_VER == 4)
        E_XC_3D_OUTPUT_MODE e3DOutputFormat = MDrv_XC_Get_3D_Output_Mode(pInstance);
        if((e3DOutputFormat == E_XC_3D_OUTPUT_LINE_ALTERNATIVE)
           || (e3DOutputFormat == E_XC_3D_OUTPUT_TOP_BOTTOM) || (e3DOutputFormat == E_XC_3D_OUTPUT_TOP_BOTTOM_HW)
           || (e3DOutputFormat == E_XC_3D_OUTPUT_SIDE_BY_SIDE_HALF) || (e3DOutputFormat == E_XC_3D_OUTPUT_SIDE_BY_SIDE_HALF_HW)
           || (e3DOutputFormat == E_XC_3D_OUTPUT_FRAME_PACKING))
        {
            //Hal_SC_set_opm_lcnt_inv(pInstance, bopm_lcnt_inv, SUB_WINDOW);
            if(pDBreg->bOpmLcntInv_En)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32LcentInvReg, BIT(4), BIT(4));
            }
            else
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32LcentInvReg, 0x00, BIT(4));
            }
        }
#endif

        //ip histogram shift
        if(_Hal_SC_Get_Histogram_Shift(pInstance, pDBreg) == TRUE)
        {
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK45_11_L,pXCResourcePrivate->u16HistogramShift);
        }
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_59_L, pDBreg->u8FrameCount,BITMASK(4:0));
        if(Hal_SC_is_extra_req_en(pInstance, NULL, NULL, &pDBreg->u16H_DisStart, &pDBreg->u16H_DisEnd))
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_11_L, BIT(15), BIT(15));
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_11_L, 0, BIT(15));
        }

        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK04_04_L, pDBreg->u32H_PreScalingRatio);   // H pre-scaling
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK04_08_L, pDBreg->u32V_PreScalingRatio);   // V pre-scaling

        //HVSP
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_27_L, pDBreg->u32H_PostScalingRatio);  // H post-scaling
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_29_L, pDBreg->u32V_PostScalingRatio);  // V post-scaling
#ifdef SUPPORT_Scaling_Sub1_Mode
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_21_L, pDBreg->u32H_PostScalingIniFactor);   // H pre-scaling Phase
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK23_28_L, (pDBreg->bIsHScalingUp == TRUE ? BIT(9) : 0), BIT(9)); //H post-scaling Sub1 Mode
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_23_L, pDBreg->u32V_PostScalingIniFactor);   // V pre-scaling Phase
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK23_2A_L, (pDBreg->bIsVScalingUp == TRUE ? BIT(9) : 0), BIT(9)); //V post-scaling Sub1 Mode
#endif

        //SCMI
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_58_L, pDBreg->u16VWritelimit); // Set vertical limitation
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_5A_L, pDBreg->u32WritelimitBase);
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_48_L, pDBreg->u32DNRBase0);     // input address0
        //SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4A_L, pDBreg->u32DNRBase1); // input address1
        //SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4C_L, pDBreg->u32DNRBase2); // input address2
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4E_L, pDBreg->u16DNROffset);// input Offset
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4F_L, pDBreg->u16DNRFetch); // input fetch
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_50_L, pDBreg->u32OPMBase0); // output address0
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_52_L, pDBreg->u32OPMBase1); // output address1
        //SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_54_L, pDBreg->u32OPMBase2); // output address2
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_56_L, pDBreg->u16OPMOffset); // output offset
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_57_L, pDBreg->u16OPMFetch);  // output fetch
        //PIP
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_16_L, pDBreg->u16VLen); // Write V length
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_1D_L, (pDBreg->u16LBOffset&0xFF)<<8, 0xFF00);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_2C_L, (pDBreg->u16LBOffset&0xFF00)<<4, 0x3000);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_1C_L, (pDBreg->u16DispOffset&0xFF)<<8, 0xFF00);

        // capture window
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_04_L, pDBreg->u16V_CapStart); // Capture V start
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_05_L, pDBreg->u16H_CapStart); // Capture H start
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_06_L, pDBreg->u16V_CapSize);  // Capture V size
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_07_L, pDBreg->u16H_CapSize);  // Capture H size

        //Display window
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_07_L, pDBreg->u16H_DisStart); // Display H start
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_08_L, pDBreg->u16H_DisEnd);   // Display H end
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_09_L, pDBreg->u16V_DisStart); // Display V start
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_0A_L, pDBreg->u16V_DisEnd);   // Display V end

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_5C_L, 0x0, 0x1FFF);         //always disable IP H mirror line offset note:ds will enable this register at vdec firmware

        if (((psXCInstPri->u32DeviceID == 0) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE))
            ||(psXCInstPri->u32DeviceID == 1))
        {
            u32LcentInvReg = REG_SC_BK08_32_L;
        }
        else
        {
            u32LcentInvReg = REG_SC_BK33_32_L;
        }

        if(pDBreg->bOpmLcntInv_En)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32LcentInvReg, BIT(4), BIT(4));
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32LcentInvReg, 0x00, BIT(4));
        }
    }
    // by HW RD's request, for main video BW issue, adjust R/W line buffer length
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_20_L, 0x1840);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_21_L, 0x1840);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_22_L, 0x4040);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_23_L, 0x1040);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_24_L, 0x0040);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_2A_L, 0x1840);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_2B_L, 0x40, 0xFF);

    //VsyncDelay
#if defined(XC_SUPPORT_FASTSWITCH_BY_IP1GP) &&(XC_SUPPORT_FASTSWITCH_BY_IP1GP == TRUE)
    SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_5F_L, eWindow),pXCResourcePrivate->u16IPVsyncTrig);
#else
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_5F_L,pXCResourcePrivate->u16IPVsyncTrig);
#endif

    //IP User Mode Size Related
    if (eWindow == MAIN_WINDOW)
    {
        if(gSrcInfo[MAIN_WINDOW].bInterlace)
        {
            u16CapVSize = pDBreg->u16V_CapSize >> 1;
            u16VSizeAfterPreScaling = (pXCResourcePrivate->stdrvXC_MVideo._SCShared.StatusInfo[MAIN_WINDOW].u16V_SizeAfterPreScaling & 0x1FFF) >> 1;
        }
        else
        {
            u16CapVSize = pDBreg->u16V_CapSize;
            u16VSizeAfterPreScaling = pXCResourcePrivate->stdrvXC_MVideo._SCShared.StatusInfo[MAIN_WINDOW].u16V_SizeAfterPreScaling & 0x1FFF;
        }

        if (Hal_SC_NeedXCV8Align(pInstance))
        {
            u16VSizeAfterPreScaling = XC8ALIGN(u16VSizeAfterPreScaling);
            if(!gSrcInfo[MAIN_WINDOW].bPreV_ScalingDown)
            {
                //V scaling down enable, set Bilinear mode, and VSD factor(3.20) = 1
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_08_L, 0);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_09_L, BIT(15) | BIT(14) | BIT(4), BIT(15) | BIT(14) | 0x7F);
            }
        }
        //Insert Black
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK4C_30_L, BIT(0), BIT(0));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK4C_32_L, u16CapVSize, 0x1FFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK4C_33_L, pDBreg->u16H_CapSize, 0x1FFF);

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_65_L, u16CapVSize, 0x1FFF);

        //IPMR_BWR 420 Repeat
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_36_L, BIT(15) | u16VSizeAfterPreScaling, BIT(15)|0x1FFF);

        //IPM_BWR_422to420
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_3D_L, BIT(15) | u16VSizeAfterPreScaling, BIT(15)|0x1FFF);
    }
}

void Hal_SC_SWDS_AddCmd(void *pInstance, P_SC_SWDB_INFO pDBreg, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] [DS] eWindow:%d bDynamicScalingEnable%d  \n",__func__,__LINE__,eWindow,pXCResourcePrivate->sthal_SC.bDynamicScalingEnable[eWindow]);

    MS_U16 u16VSyncStart = 0;
    MS_U16 u16VSyncEnd = 0;
    MS_U16 u16VFDE_Start = 0;
    MS_U16 u16VFDE_End = 0;
    MS_U16 u16VMDE_Start = 0;
    MS_U16 u16VMDE_End = 0;
    MS_U16 u16TrainTrig = 0;
    MS_U16 u16VDE_Offset = 0;
    MS_BOOL bStgenHcntAliveEn = FALSE;
    MS_U16 u16CapVSize = 0;
    MS_U16 u16HProtect = 0;
    MS_U16 u16VSizeAfterPreScaling = 0;
    MS_U16 u16HdrWinHSize = 0;
    MS_U16 u16HdrWinVSize = 0;
    MS_BOOL bGetHDRSizeFromMVOP = FALSE;

    u16TrainTrig = SC_R2BYTEMSK(0, REG_SC_BK20_1A_L, 0x1FFF);
    bStgenHcntAliveEn = SC_R2BYTEMSK(0, REG_SC_BK68_23_L, BIT(6)) >> 6;

    //mvop
    MS_U16 u16RegMVOP_12 = 0;
    u16RegMVOP_12 = MDrv_Read2Byte(REG_MVOP_PATTERN);

    //X C_H8ALIGN_PATCH || XC_V8ALIGN_PATCH)
    MS_U16 u16End = 0;

#ifdef ENABLE_XC_WRITE_CMD_API
    PSTXC_DS_CMDCNT.u16CMDCNT_IPM = pXCResourcePrivate->stXC_DS_CmdCnt.u16CMDCNT_IPM;
    PSTXC_DS_CMDCNT.u16CMDCNT_IPS = pXCResourcePrivate->stXC_DS_CmdCnt.u16CMDCNT_IPS;
    PSTXC_DS_CMDCNT.u16CMDCNT_OPM = pXCResourcePrivate->stXC_DS_CmdCnt.u16CMDCNT_OPM;
    PSTXC_DS_CMDCNT.u16CMDCNT_OPS = pXCResourcePrivate->stXC_DS_CmdCnt.u16CMDCNT_OPS;
#endif

    if(eWindow == MAIN_WINDOW)
    {
        if(pXCResourcePrivate->sthal_SC.bDynamicScalingEnable[eWindow])
        {
            pXCResourcePrivate->sthal_SC.u8DynamicScalingNextIndex[MAIN_WINDOW] = pXCResourcePrivate->sthal_SC.u8DynamicScalingCurrentIndex_Ring[MAIN_WINDOW];

            //Command Priority:
            //1.GOP
            //2.MVOP
            //3.XC
            //---------------------------------------------------------------------IP Command Start---------------------------------------------------------------------------------------//

            MS_U32 ActiveSWClearEn = 0;
            MS_U32 u32SW_Reset_Enable = 0;
            //ActiveSWClearEn enable in first DS IP command ;
#ifdef ENABLE_XC_WRITE_CMD_API
            u32SW_Reset_Enable = 0x0400;
#else
            u32SW_Reset_Enable = 0x4000;   // bit14: reg_ds_active_sw_clr_en,set ds_activating cleared by SW
#endif
            ActiveSWClearEn = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK1F_17_L, 0xFFFF);
            ActiveSWClearEn |= u32SW_Reset_Enable;

            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK1F_17_L,(MS_U16)(ActiveSWClearEn),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);

            if(gSrcInfo[eWindow].Status2.bEnable_ForceP)
            {
                if(gSrcInfo[eWindow].bInterlace)
                {
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_01_L,FORCEP_I_MODE_MADI_MODE,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    if(IS_FBL_OR_RFBL_MODE(MAIN_WINDOW))
                    {
                        // Disable y8 only mode
                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK12_04_L,0,DS_IP,DS_XC,&PSTXC_DS_CMDCNT, BIT(2));
                        // Set rbank_offset
                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK12_06_L,BIT(11) |BIT(9),DS_IP,DS_XC,&PSTXC_DS_CMDCNT, BITMASK(11:8));
                        //Set rbank_mode
                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK12_1D_L,IPM_ACCESS_MODE_YM,DS_IP,DS_XC,&PSTXC_DS_CMDCNT, BITMASK(12:8));
                        //reg_opm_2read_en_f2 (BIT1), reg_film_high_pri_f2 (BIT11)
                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK12_03_L,BIT(1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT, BIT(11)|BIT(1));
                        //reg_ip_bypass_interlace_f2 (BIT10), reg_ip_bypass_all_f2 (BIT11)
                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK12_04_L,BIT(10),DS_OP,DS_XC,&PSTXC_DS_CMDCNT, BIT(11)|BIT(10));
                    }
                }
                else
                {
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_01_L,FORCEP_P_MODE_MADI_MODE,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    if(IS_FBL_OR_RFBL_MODE(MAIN_WINDOW))
                    {
                        // Disable y8 only mode
                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK12_04_L,0,DS_IP,DS_XC,&PSTXC_DS_CMDCNT, BIT(2));
                        // Set rbank_offset
                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK12_06_L,0,DS_IP,DS_XC,&PSTXC_DS_CMDCNT, BITMASK(11:8));
                        //Set rbank_mode
                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK12_1D_L,IPM_ACCESS_MODE_Y,DS_IP,DS_XC,&PSTXC_DS_CMDCNT, BITMASK(12:8));
                        //reg_opm_2read_en_f2 (BIT1), reg_film_high_pri_f2 (BIT11)
                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK12_03_L,BIT(11),DS_OP,DS_XC,&PSTXC_DS_CMDCNT, BIT(11)|BIT(1));
                        //reg_ip_bypass_interlace_f2 (BIT10), reg_ip_bypass_all_f2 (BIT11)
                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK12_04_L,BIT(11),DS_OP,DS_XC,&PSTXC_DS_CMDCNT, BIT(11)|BIT(10));
                    }

                    // for fix last I field and first P frame DI
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK22_78_L, 0x8F8F,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK22_79_L, 0x8F8F,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                }
            }

            //XC_PRINTF("[%s,%5d] bR_FBL:%d bFBL:%d  \n",__func__,__LINE__,gSrcInfo[MAIN_WINDOW].bR_FBL,gSrcInfo[MAIN_WINDOW].bFBL);
            //XC_PRINTF("[%s,%5d] Crop(x,y,w,h)=(%d,%d,%d,%d) \n",__func__,__LINE__,gSrcInfo[eWindow].stCropWin.x,gSrcInfo[eWindow].stCropWin.y,gSrcInfo[eWindow].stCropWin.width,gSrcInfo[eWindow].stCropWin.height);

//Due to M7221 mvop double buffer, DS set MVOP Crop will take effect at next frame, which causes flashing garbage
//MVOP Crop is controled in DMS module
#if !SUPPORT_DMS_WITH_MVOPCROP
            if(IsSrcTypeStorage(gSrcInfo[MAIN_WINDOW].enInputSourceType))
            {
                if((gSrcInfo[MAIN_WINDOW].bR_FBL) || (gSrcInfo[MAIN_WINDOW].bFBL))//set MVOP crop info
                {
                    // GET MVOP crop info first
                    MVOP_Handle stHdl = { E_MVOP_MODULE_MAIN };
                    MVOP_XCGetCrop stCropInfo;
                    stCropInfo.u16XStart = gSrcInfo[eWindow].stCropWin.x;
                    stCropInfo.u16YStart = gSrcInfo[eWindow].stCropWin.y;
                    stCropInfo.u16XSize = gSrcInfo[eWindow].stCropWin.width;
                    stCropInfo.u16YSize = gSrcInfo[eWindow].stCropWin.height;

                    MDrv_MVOP_GetCommand(&stHdl, E_MVOP_CMD_GET_CROP_FOR_XC, &stCropInfo, sizeof(MVOP_XCGetCrop));
#if (HW_DESIGN_4K2K_VER == 6)
                    if(pXCResourcePrivate->stdrvXC_Display._enInputSourceType == E_XC_INPUT_SOURCE_TYPE_OTT)
                    {
                        MS_U16 u16Mvop_sub_xstart =0;
                        MS_U16 u16Mvop_sub_ystart =0;
                        MS_U16 u16Mvop_sub_xsize =0;
                        MS_U16 u16Mvop_sub_ysize =0;

                        stCropInfo.u16XStart = (stCropInfo.u16XStart + 7)&~0x7;
                        stCropInfo.u16YStart = ((stCropInfo.u16YStart & 0x1FFF) + 3)&~0x3;
                        stCropInfo.u16XSize = stCropInfo.u16XSize &~0x7;
                        stCropInfo.u16YSize = stCropInfo.u16YSize &~0x3;

                        u16Mvop_sub_xstart = (stCropInfo.u16XStart/2 + 1)&~0x1;
                        u16Mvop_sub_ystart = (stCropInfo.u16YStart/2 + 1)&~0x1;
                        u16Mvop_sub_xsize = (stCropInfo.u16XSize/2)&~0x1;
                        u16Mvop_sub_ysize = (stCropInfo.u16YSize/2)&~0x1;

                        //MVOP sub
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SUBMVOP_CROP_H_START,u16Mvop_sub_xstart,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);         //0xFFFF000A 0840XXXX
                        if(u16Mvop_sub_ystart == 0)
                        {
                            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SUBMVOP_CROP_V_START,0x6000,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);  //0xFFFF000A 0841XXXX
                        }
                        else
                        {
                            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SUBMVOP_CROP_V_START,0x2000|u16Mvop_sub_ystart,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);  //0xFFFF000A 0841XXXX
                        }
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SUBMVOP_CROP_H_SIZE,u16Mvop_sub_xsize,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);           //0xFFFF000A 0842XXXX
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SUBMVOP_CROP_V_SIZE,u16Mvop_sub_ysize,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);           //0xFFFF000A 0843XXXX
                    }
#endif

                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_MVOP_CROP_H_START,stCropInfo.u16XStart,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);         //0xFFFF000A 0840XXXX
                    if(stCropInfo.u16YStart == 0)
                    {
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_MVOP_CROP_V_START,0x4000|stCropInfo.u16YStart,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);  //0xFFFF000A 0841XXXX
                    }
                    else
                    {
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_MVOP_CROP_V_START,0x6000|stCropInfo.u16YStart,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);  //0xFFFF000A 0841XXXX
                    }
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_MVOP_CROP_H_SIZE,stCropInfo.u16XSize,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);           //0xFFFF000A 0842XXXX
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_MVOP_CROP_V_SIZE,stCropInfo.u16YSize,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);           //0xFFFF000A 0843XXXX
                    pDBreg->u16LBOffset = 0; // mvop do crop, align in 2pixel, so xc don't need crop
                }
                else
                {
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_MVOP_CROP_H_START,0x0,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);     //0xFFFF000A 0840XXXX
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_MVOP_CROP_V_START,0x2000,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);  //0xFFFF000A 0841XXXX
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_MVOP_CROP_H_SIZE,0x0,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);      //0xFFFF000A 0842XXXX
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_MVOP_CROP_V_SIZE,0x0,DS_IP,DS_MVOP,&PSTXC_DS_CMDCNT);      //0xFFFF000A 0843XXXX
                }
            }
#endif
            //H pre-scaling
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_04_L,(MS_U16)(pDBreg->u32H_PreScalingRatio>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8104XXXX
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_05_L,(MS_U16)(pDBreg->u32H_PreScalingRatio>>16),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8105XXXX
            //V pre-scaling
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_08_L,(MS_U16)(pDBreg->u32V_PreScalingRatio>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8108XXXX
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_09_L,(MS_U16)(pDBreg->u32V_PreScalingRatio>>16),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8109XXXX

            if(gSrcInfo[MAIN_WINDOW].bPreH_ScalingDown == TRUE)
            {
                //enable H size Protect
                //Set H Protect Size
                u16HProtect = ((pXCResourcePrivate->stdrvXC_MVideo._SCShared.StatusInfo[MAIN_WINDOW].u16H_SizeAfterPreScaling & 0x3FFF) | BIT(15));
                Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK4C_40_L,u16HProtect,DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0xBFFF);
            }
            else
            {
                //disable H size Protect
                //Set H Protect Size 0
                u16HProtect = 0;
                Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK4C_40_L,u16HProtect,DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0xBFFF);
            }

            if (Hal_SC_NeedXCV8Align(pInstance))
            {
                pDBreg->u16VWritelimit = XC8ALIGN(pDBreg->u16VWritelimit);
            }
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_18_L,(MS_U16)(pDBreg->u16VWritelimit>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8918XXXX

            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_08_L,(MS_U16)(pDBreg->u32DNRBase0>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_09_L,(MS_U16)(pDBreg->u32DNRBase0>>16),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);

            if (Hal_SC_NeedXCH8Align(pInstance))
            {
                pDBreg->u16DNRFetch = XC8ALIGN(pDBreg->u16DNRFetch);
            }
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_0F_L,(MS_U16)(pDBreg->u16DNRFetch>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 890FXXXX

            //H_mirror_offset
            if(IsHMirrorMode(MAIN_WINDOW)||IsVMirrorMode(MAIN_WINDOW))
            {
                XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] [DS] VB_width:%d framNum:%d u8BitPerPixel:%d  \n",__func__,__LINE__,gSrcInfo[MAIN_WINDOW].Status2.u16VirtualBox_Width,MDrv_XC_TransFrameNumToFactor(pInstance,gSrcInfo[MAIN_WINDOW].Status2.eFrameStoreNumber, gSrcInfo[MAIN_WINDOW].bLinearMode, _FIELD_PACKING_MODE_SUPPORTED),gSrcInfo[MAIN_WINDOW].u8BitPerPixel);

                MS_U32 H_mirror_offset;
                H_mirror_offset = (gSrcInfo[eWindow].Status2.u16VirtualBox_Width * gSrcInfo[eWindow].u8BitPerPixel * 2 / 8 * MDrv_XC_TransFrameNumToFactor(pInstance,gSrcInfo[eWindow].Status2.eFrameStoreNumber, gSrcInfo[eWindow].bLinearMode, _FIELD_PACKING_MODE_SUPPORTED)) / BYTE_PER_WORD;

                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_1C_L,H_mirror_offset,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 891CXXXX
            }
            else
            {
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_1C_L,0x0000,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 891CXXXX
            }

            // MM/DTV get HDR size from MVOP
            if (IsSrcTypeStorage(gSrcInfo[MAIN_WINDOW].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[MAIN_WINDOW].enInputSourceType))
            {
                MVOP_Handle stHdl = { E_MVOP_MODULE_MAIN };
                MVOP_SetImageWH stImageWH;

                MDrv_MVOP_GetCommand(&stHdl, E_MVOP_CMD_GET_DATA_HV_SIZE, &stImageWH, sizeof(MVOP_SetImageWH));

                u16HdrWinHSize = stImageWH.u16Width;
                u16HdrWinVSize = stImageWH.u16Height;
                bGetHDRSizeFromMVOP = TRUE;
            }

            //HDR input DE Window info
            if (gSrcInfo[MAIN_WINDOW].bR_FBL)
            {
                if (bGetHDRSizeFromMVOP == FALSE)
                {
                    u16HdrWinHSize = gSrcInfo[MAIN_WINDOW].stCropWin.width;
                    u16HdrWinVSize = gSrcInfo[MAIN_WINDOW].stCropWin.height;
                }

                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK79_08_L,(MS_U16)(u16HdrWinHSize>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                if (gSrcInfo[MAIN_WINDOW].bInterlace)
                {
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK79_09_L,(MS_U16)(u16HdrWinVSize>>01),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                }
                else
                {
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK79_09_L,(MS_U16)(u16HdrWinVSize>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                }
            }
            else
            {
                if (bGetHDRSizeFromMVOP == FALSE)
                {
                    u16HdrWinHSize = pDBreg->u16H_CapSize;
                    u16HdrWinVSize = pDBreg->u16V_CapSize;
                }

                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK79_08_L,(MS_U16)(u16HdrWinHSize>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                if (gSrcInfo[MAIN_WINDOW].bInterlace)
                {
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK79_09_L,(MS_U16)(u16HdrWinVSize>>01),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                }
                else
                {
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK79_09_L,(MS_U16)(u16HdrWinVSize>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                }
            }

            //Cap info
            /// before enable ML bit mask feature, the capture size for 2P setting BK01_07[15] need to be considered
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
            MS_U16 u16CapWidth = (MS_U16)pDBreg->u16H_CapSize;
            INPUT_SOURCE_TYPE_t enInputSource = INPUT_SOURCE_NONE;

            if(eWindow == MAX_WINDOW)
            {
                enInputSource = MHal_XC_GetOfflineSource(pInstance, eWindow);
            }
            else
            {
                enInputSource = gSrcInfo[eWindow].enInputSourceType;
            }

            // FSS HDMI420 should set window by IP2 timing
            // Due to the para of setwindow is multiplied by 2 when pcmonitor reported. Divide 2 when setting register
            if(MHal_XC_IsHDMI420(pInstance, enInputSource) == TRUE)
            {
                u16CapWidth /= 2;
            }

            if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_07_L, eWindow), BIT(15)))
            {
                u16CapWidth |= 0x8000;
            }
            else
            {
                u16CapWidth |= 0x0000;
            }

            if(!gSrcInfo[eWindow].Status2.bMVOPHskEnable)
            {
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_04_L, eWindow),(MS_U16)(pDBreg->u16V_CapStart),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_05_L, eWindow),(MS_U16)(pDBreg->u16H_CapStart),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_06_L, eWindow),(MS_U16)(pDBreg->u16V_CapSize>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8086XXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_07_L, eWindow), u16CapWidth,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8087XXXX
            }
#else
            if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_07_L, BIT(15)))
            {
                pDBreg->u16H_CapSize |= 0x8000;
            }
            else
            {
                pDBreg->u16H_CapSize |= 0x0000;
            }

            if(!gSrcInfo[eWindow].Status2.bMVOPHskEnable)
            {
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK01_04_L,(MS_U16)(pDBreg->u16V_CapStart),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK01_05_L,(MS_U16)(pDBreg->u16H_CapStart),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK01_06_L,(MS_U16)(pDBreg->u16V_CapSize>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8086XXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK01_07_L,(MS_U16)(pDBreg->u16H_CapSize>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8087XXXX
            }
#endif

            // set cup size by user mode (bit 15), not auto sync from BK01_06
            if(gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_0E_L,(BIT(15)|(pDBreg->u16V_CapSize/2)),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
            }
            else
            {
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_0E_L,(BIT(15)|pDBreg->u16V_CapSize),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
            }

#ifdef UFO_XC_SWDS_DYMAMIC_CONTROL_DNR
            if(IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType))
            {
                if(gSrcInfo[eWindow].Status2.bEnableDNR)
                {
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK06_21_L,gSrcInfo[eWindow].Status2.u16DNREnableValue,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                    if((gSrcInfo[eWindow].Status2.bEnable_ForceP) && (gSrcInfo[eWindow].bInterlace))
                    {
                        //Disable force BOB
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK22_78_L,(MS_U16)(0x0),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    }
                }
                else
                {
                    gSrcInfo[eWindow].Status2.u16DNREnableValue = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK06_21_L);
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK06_21_L,gSrcInfo[eWindow].Status2.u16DNREnableValue &0xFFFD,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                    if(gSrcInfo[eWindow].Status2.bEnable_ForceP)
                    {
                        //Enable force BOB
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK22_78_L,(MS_U16)(0x8F8F),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    }
                }
            }
#endif

#if defined(XC_SUPPORT_DLC_DYNAMIC_RANGE) && (XC_SUPPORT_DLC_DYNAMIC_RANGE == TRUE)
            ///IP Range
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_04_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHstart,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_05_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHend,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_06_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVstart,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_07_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVend,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
            ///RGBMAX IP Range
            Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_H_START,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHstart,BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_H_END,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPHend,BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_V_START,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVstart,BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_V_END,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16IPVend,BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
            ///VIP range
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK55_12_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPHstart,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK55_13_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPHend,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK55_10_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPVstart,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK55_11_L,pXCResourcePrivate->stXC_DLC_Dynamic_Range_Info.u16VIPVend,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);

#else
            ////Add DLC Capture Range
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_04_L,0,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_05_L,(gSrcInfo[MAIN_WINDOW].stCapWin.width-1),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
            ///RGBMAX IP Range
            Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_H_START,0,BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
            Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_H_END,(gSrcInfo[MAIN_WINDOW].stCapWin.width-1),BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
#if DLC_CaptureRange_SIX_OVER_EIGHT
            ////DLC Capture SIX OVER EIGHT Range
            if(gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_06_L,((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*1/8 -1),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_07_L,((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*7/8 -1),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_V_START,((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*1/8 -1),BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_V_END,((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)*7/8 -1),BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
            }
            else
            {
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_06_L,(gSrcInfo[MAIN_WINDOW].stCapWin.height*1/8 -1),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_07_L,(gSrcInfo[MAIN_WINDOW].stCapWin.height*7/8 -1),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_V_START,(gSrcInfo[MAIN_WINDOW].stCapWin.height*1/8 -1),BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_V_END,(gSrcInfo[MAIN_WINDOW].stCapWin.height*7/8 -1),BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
            }
#else
            ////DLC Capture FULL Range
            if(gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_06_L, 0,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_07_L,((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)-2),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_V_START,0,BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_V_END,((gSrcInfo[MAIN_WINDOW].stCapWin.height/2)-2),BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
            }
            else
            {
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_06_L, 0,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK5C_07_L,(gSrcInfo[MAIN_WINDOW].stCapWin.height-2),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_V_START,0,BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
                Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,REG_MAXRGB_BANK_EXT_335D,MAXRGB_V_END,(gSrcInfo[MAIN_WINDOW].stCapWin.height-2),BITMASK(13:0),DS_IP,&PSTXC_DS_CMDCNT);
            }
#endif
#endif

            //ip histogram shift
            if(_Hal_SC_Get_Histogram_Shift(pInstance, pDBreg) == TRUE)
            {
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK45_11_L,pXCResourcePrivate->u16HistogramShift,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8087XXXX
            }

           //VsyncDelay
#if defined(XC_SUPPORT_FASTSWITCH_BY_IP1GP) &&(XC_SUPPORT_FASTSWITCH_BY_IP1GP == TRUE)
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_5F_L, eWindow),pXCResourcePrivate->u16IPVsyncTrig,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
#else
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK01_5F_L, pXCResourcePrivate->u16IPVsyncTrig,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
#endif

            //This is end of IP DS CMD (toggle reg_ds_ipm_active_set)
#if (SUPPORT_KERNEL_DS == 0)//if SUPPORT_KERNEL_DS is true,this cmd will be set in kernel ds
            //toggle reg_ds_ipm_active_set in last DS IP command
            MS_U32 u32SW_Reset_IPM = 0;
            u32SW_Reset_IPM = 0x0010 ;//bit4 : reg_ds_ipm_active_clr
            ActiveSWClearEn |= u32SW_Reset_IPM;
            Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK1F_17_L,(MS_U16)(ActiveSWClearEn),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
#endif

            //IP User Mode Size Related

            if(gSrcInfo[MAIN_WINDOW].bInterlace)
            {
                u16CapVSize = pDBreg->u16V_CapSize >> 1;
                u16VSizeAfterPreScaling = (pXCResourcePrivate->stdrvXC_MVideo._SCShared.StatusInfo[MAIN_WINDOW].u16V_SizeAfterPreScaling & 0x1FFF) >> 1;
            }
            else
            {
                u16CapVSize = pDBreg->u16V_CapSize;
                u16VSizeAfterPreScaling = pXCResourcePrivate->stdrvXC_MVideo._SCShared.StatusInfo[MAIN_WINDOW].u16V_SizeAfterPreScaling & 0x1FFF;
            }

            if (Hal_SC_NeedXCV8Align(pInstance))
            {
                u16VSizeAfterPreScaling = XC8ALIGN(u16VSizeAfterPreScaling);
                if(!gSrcInfo[MAIN_WINDOW].bPreV_ScalingDown)
                {
                    //V scaling down enable, set Bilinear mode, and VSD factor(3.20) = 1
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_08_L, 0,DS_IP,DS_XC,&PSTXC_DS_CMDCNT);
                    Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK02_09_L, BIT(15) | BIT(14) | BIT(4),DS_IP,DS_XC,&PSTXC_DS_CMDCNT,BIT(15) | BIT(14) | 0x7F);
                }
            }

            //Insert Black
            Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK4C_30_L,BIT(0),DS_IP,DS_XC,&PSTXC_DS_CMDCNT,BIT(0));
            Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK4C_32_L,u16CapVSize,DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
            Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK4C_33_L,pDBreg->u16H_CapSize,DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);

            Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK02_65_L,u16CapVSize,DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);

            //IPMR_BWR 420 Repeat
            Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK46_36_L,BIT(15) | u16VSizeAfterPreScaling,DS_IP,DS_XC,&PSTXC_DS_CMDCNT,BIT(15)|0x1FFF);

            //IPM_BWR_422to420
            Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK46_3D_L,BIT(15) | u16VSizeAfterPreScaling,DS_IP,DS_XC,&PSTXC_DS_CMDCNT,BIT(15)|0x1FFF);

            //IP2 h crop
            Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK4C_0F_L,pDBreg->u16H_CapSize,DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0x3FFF);

            // You can not add any IP DS CMD here !!!!!!!!!!!!!!!!!
            // You should add IP DS CMD before ipm wait ds sw reset cmd
            //---------------------------------------------------------------------IP Command End---------------------------------------------------------------------------------------//

            //---------------------------------------------------------------------OP Command Start---------------------------------------------------------------------------------------//
            if(!((gSrcInfo[MAIN_WINDOW].bR_FBL) || (gSrcInfo[MAIN_WINDOW].bFBL))) //FB case
            {
                //H post-scaling
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_07_L,(MS_U16)(pDBreg->u32H_PostScalingRatio>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 9187XXXX
                Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_08_L,(MS_U16)(pDBreg->u32H_PostScalingRatio>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT, 0x1FF);//0xFFFF0009 9188XXXX
                //V post-scaling
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_09_L,(MS_U16)(pDBreg->u32V_PostScalingRatio>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 9189XXXX
                Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_0A_L,(MS_U16)(pDBreg->u32V_PostScalingRatio>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT, 0x1FF);//0xFFFF0009 918AXXXX

                //If no scaling, close DSC for power-saving (Update VR F000_01[2])
                MDrv_COMM_VR_W2BYTEMSK(REG_VR_BK00_01_L, (((pDBreg->bIsHScalingUp|pDBreg->bIsVScalingUp) == FALSE) ? BIT(2) : 0), BIT(2));
#ifdef SUPPORT_Scaling_Sub1_Mode
                //H post-scaling Phase
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_01_L,(MS_U16)(pDBreg->u32H_PostScalingIniFactor>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_02_L,(MS_U16)(pDBreg->u32H_PostScalingIniFactor>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                //H post-scaling Sub1 Mode
                Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_08_L,(pDBreg->bIsHScalingUp == TRUE ? BIT(9) : 0),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,BIT(9));
                //V post-scaling Phase
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_03_L,(MS_U16)(pDBreg->u32V_PostScalingIniFactor>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_04_L,(MS_U16)(pDBreg->u32V_PostScalingIniFactor>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                //V post-scaling Sub1 Mode
                if(gSrcInfo[eWindow].bInterlace)
                {
                    Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_0A_L,(pDBreg->bIsVScalingUp == TRUE ? BIT(9) : 0),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,BIT(9));
                }
#endif

                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_10_L, (MS_U16)(pDBreg->u32OPMBase0>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); // OPM base0  //0xFFFF0009 8910XXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_11_L,(MS_U16)(pDBreg->u32OPMBase0>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); // OPM base0   //0xFFFF0009 8911XXXX

                if (Hal_SC_NeedXCH8Align(pInstance))
                {
                    pDBreg->u16OPMFetch = XC8ALIGN(pDBreg->u16OPMFetch);
                }
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_17_L,(MS_U16)(pDBreg->u16OPMFetch>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); // OPM fetch   //0xFFFF0009 8917XXXX
                //Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_15_L, (MS_U16)(pDBreg->u16VLen>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); // V Len
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_1D_L,(MS_U16)(pDBreg->u16LBOffset&0xFF),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); //LBOffset    //0xFFFF0009 901DXXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_2C_L,(MS_U16)(pDBreg->u16LBOffset&0xFF00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); //LBOffset    //0xFFFF0009 901DXXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_1D_L,(MS_U16)(pDBreg->u16LBOffset&0xFF),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); //LBOffset    //0xFFFF0009 901DXXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_2C_L,(MS_U16)(pDBreg->u16LBOffset&0xFF00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); //LBOffset    //0xFFFF0009 901DXXXX
                if (Hal_SC_NeedXCV8Align(pInstance))
                {
                    pDBreg->u16VLen = XC8ALIGN(pDBreg->u16VLen);
                }
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_15_L, (MS_U16)(pDBreg->u16VLen>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); // V Len          //0xFFFF0009 9015XXXX

                if (SUPPORT_3D_DS && (IS_OUTPUT_LINE_ALTERNATIVE()||IS_OUTPUT_TOP_BOTTOM()||IS_OUTPUT_SIDE_BY_SIDE_HALF()||IS_OUTPUT_TOP_BOTTOM_HW()||IS_OUTPUT_SIDE_BY_SIDE_HALF_HW()||IS_OUTPUT_FRAME_PACKING()))
                {
                    //H post-scaling
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_27_L,(MS_U16)(pDBreg->u32H_PostScalingRatio>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 9187XXXX
                    Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_28_L,(MS_U16)(pDBreg->u32H_PostScalingRatio>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT, 0x1FF);//0xFFFF0009 9188XXXX
                    //V post-scaling
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_29_L,(MS_U16)(pDBreg->u32V_PostScalingRatio>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 9189XXXX
                    Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_2A_L,(MS_U16)(pDBreg->u32V_PostScalingRatio>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT, 0x1FF);//0xFFFF0009 918AXXXX

#ifdef SUPPORT_Scaling_Sub1_Mode
                    //H post-scaling Phase
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_21_L,(MS_U16)(pDBreg->u32H_PostScalingIniFactor>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_22_L,(MS_U16)(pDBreg->u32H_PostScalingIniFactor>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                    //H post-scaling Sub1 Mode
                    Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_28_L,(pDBreg->bIsHScalingUp == TRUE ? BIT(9) : 0),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,BIT(9));
                    //V post-scaling Phase
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_23_L,(MS_U16)(pDBreg->u32V_PostScalingIniFactor>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_24_L,(MS_U16)(pDBreg->u32V_PostScalingIniFactor>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                    //V post-scaling Sub1 Mode
                    Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_2A_L,(pDBreg->bIsVScalingUp == TRUE ? BIT(9) : 0),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,BIT(9));
#endif
                    //Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_10_L, (MS_U16)(pDBreg->u32OPMBase0>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); // OPM base0  //0xFFFF0009 8910XXXX
                    //Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_11_L,(MS_U16)(pDBreg->u32OPMBase0>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); // OPM base0   //0xFFFF0009 8911XXXX
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_57_L,(MS_U16)(pDBreg->u16OPMFetch>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); // OPM fetch   //0xFFFF0009 8917XXXX
                }

                //OPM crop offset
                if(MHal_XC_GetCropMode() == E_XC_CROP_MIU_ENHANCED_MODE)
                {
                   Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5A_L,(gSrcInfo[MAIN_WINDOW].ScaledCropWin.x - gSrcInfo[MAIN_WINDOW].Status2.u16LBOffset),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                   if(gSrcInfo[MAIN_WINDOW].b420CmpEnable)
                   {
                       if(gSrcInfo[MAIN_WINDOW].bInterlace)
                       {
                           Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5B_L,(((gSrcInfo[MAIN_WINDOW].ScaledCropWin.y/2) + 0x1) & ~0x1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                       }
                       else
                       {
                           Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5B_L,((gSrcInfo[MAIN_WINDOW].ScaledCropWin.y + 0x1) & ~0x1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                       }
                   }
                   else
                   {
                       if(gSrcInfo[MAIN_WINDOW].bInterlace)
                       {
                           Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5B_L,(gSrcInfo[MAIN_WINDOW].ScaledCropWin.y/2),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                       }
                       else
                       {
                           Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5B_L,gSrcInfo[MAIN_WINDOW].ScaledCropWin.y,DS_OP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                       }
                   }
                }
                else
                {
                   Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5A_L,0x0,DS_OP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                   Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5B_L,0x0,DS_OP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                }
            }
            else//RFBL or FBL case
            {
                //H post-scaling
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_07_L,(MS_U16)(pDBreg->u32H_PostScalingRatio>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 9187XXXX
                Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_08_L,(MS_U16)(pDBreg->u32H_PostScalingRatio>>16),DS_IP,DS_XC,&PSTXC_DS_CMDCNT, 0x1FF);//0xFFFF0009 9188XXXX
                //V post-scaling
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_09_L,(MS_U16)(pDBreg->u32V_PostScalingRatio>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 9189XXXX
                Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_0A_L,(MS_U16)(pDBreg->u32V_PostScalingRatio>>16),DS_IP,DS_XC,&PSTXC_DS_CMDCNT, 0x1FF);//0xFFFF0009 918AXXXX

                //If no scaling, close DSC for power-saving (Update VR F000_01[2])
                MDrv_COMM_VR_W2BYTEMSK(REG_VR_BK00_01_L, (((pDBreg->bIsHScalingUp|pDBreg->bIsVScalingUp) == FALSE) ? BIT(2) : 0), BIT(2));
#ifdef SUPPORT_Scaling_Sub1_Mode
                //H post-scaling Phase
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_01_L,(MS_U16)(pDBreg->u32H_PostScalingIniFactor>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_02_L,(MS_U16)(pDBreg->u32H_PostScalingIniFactor>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                //H post-scaling Sub1 Mode
                Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_08_L,(pDBreg->bIsHScalingUp == TRUE ? BIT(9) : 0),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,BIT(9));
                //V post-scaling Phase
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_03_L,(MS_U16)(pDBreg->u32V_PostScalingIniFactor>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK23_04_L,(MS_U16)(pDBreg->u32V_PostScalingIniFactor>>16),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 918AXXXX
                //V post-scaling Sub1 Mode
                if(gSrcInfo[eWindow].bInterlace)
                {
                    Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK23_0A_L,(pDBreg->bIsVScalingUp == TRUE ? BIT(9) : 0),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,BIT(9));
                }
#endif

                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_10_L, (MS_U16)(pDBreg->u32OPMBase0>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT); // OPM base0  //0xFFFF0009 8910XXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_11_L,(MS_U16)(pDBreg->u32OPMBase0>>16),DS_IP,DS_XC,&PSTXC_DS_CMDCNT); // OPM base0   //0xFFFF0009 8911XXXX

                if (Hal_SC_NeedXCH8Align(pInstance))
                {
                    pDBreg->u16OPMFetch = XC8ALIGN(pDBreg->u16OPMFetch);
                }
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK12_17_L,(MS_U16)(pDBreg->u16OPMFetch>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT); // OPM fetch   //0xFFFF0009 8917XXXX
                //Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_15_L, (MS_U16)(pDBreg->u16VLen>>00),DS_OP,DS_XC,&PSTXC_DS_CMDCNT); // V Len
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_1D_L,(MS_U16)(pDBreg->u16LBOffset&0xFF),DS_IP,DS_XC,&PSTXC_DS_CMDCNT); //LBOffset    //0xFFFF0009 901DXXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_2C_L,(MS_U16)(pDBreg->u16LBOffset&0xFF00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT); //LBOffset
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_1D_L,(MS_U16)(pDBreg->u16LBOffset&0xFF),DS_IP,DS_XC,&PSTXC_DS_CMDCNT); //LBOffset    //0xFFFF0009 901DXXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_2C_L,(MS_U16)(pDBreg->u16LBOffset&0xFF00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT); //LBOffset
                if (Hal_SC_NeedXCV8Align(pInstance))
                {
                    pDBreg->u16VLen = XC8ALIGN(pDBreg->u16VLen);
                }
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK20_15_L, (MS_U16)(pDBreg->u16VLen>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT); // V Len          //0xFFFF0009 9015XXXX

                //OPM crop offset
                if(MHal_XC_GetCropMode() == E_XC_CROP_MIU_ENHANCED_MODE)
                {
                   Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5A_L,(gSrcInfo[MAIN_WINDOW].ScaledCropWin.x - gSrcInfo[MAIN_WINDOW].Status2.u16LBOffset),DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                   if(gSrcInfo[MAIN_WINDOW].b420CmpEnable)
                   {
                       if(gSrcInfo[MAIN_WINDOW].bInterlace)
                       {
                           Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5B_L,(((gSrcInfo[MAIN_WINDOW].ScaledCropWin.y/2) + 0x1) & ~0x1),DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                       }
                       else
                       {
                           Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5B_L,((gSrcInfo[MAIN_WINDOW].ScaledCropWin.y + 0x1) & ~0x1),DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                       }
                   }
                   else
                   {
                       if(gSrcInfo[MAIN_WINDOW].bInterlace)
                       {
                           Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5B_L,(gSrcInfo[MAIN_WINDOW].ScaledCropWin.y/2),DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                       }
                       else
                       {
                           Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5B_L,gSrcInfo[MAIN_WINDOW].ScaledCropWin.y,DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                       }
                   }
                }
                else
                {
                   Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5A_L,0x0,DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                   Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK11_5B_L,0x0,DS_IP,DS_XC,&PSTXC_DS_CMDCNT,0x1FFF);
                }
            }

            //LBox WSize
            Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK0B_14_L,gSrcInfo[MAIN_WINDOW].ScaledCropWin.width,DS_OP,DS_XC,&PSTXC_DS_CMDCNT, 0x1FFF);
            //LBox HSize
            Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK0B_15_L,gSrcInfo[MAIN_WINDOW].ScaledCropWin.height,DS_OP,DS_XC,&PSTXC_DS_CMDCNT, 0x1FFF);

            ///per HW RD Jeff.lin, DS SR formula:
            /// (1)
            ///1.a if BK68_23[6]=0, then Vde Start >= 16 (BK68_0B and BK68_0D) to make sure some trigger done
            ///                             else no need  Vde Start >= 16, because it will count h sync continuously to ensure trigger done.
            ///1.b Vde End = Vde_start + Vsize (BK68_0C and BK68_0E)
            ///(2)
            ///2.a Vstart = Vde end + 8
            ///2.b Vend  = Vstart + 8
            ///(3)
            ///BK68_0F = VFDE_end + BK20_1A + 2
            ///(4)
            ///  if BK68_23[6]=1, then BK20_1B = BK20_1A + 4, else BK20_1B = BK20_1A + 2

            //STGEN setting
            //First DS script not use double buffer, because swdb registers not statisfy the condition to enable double buffer.
            //So need first DS script to make sure registers meet the condition to enable double buffer. Then enable double buffer at second DS script.
            //Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK68_23_L,(MS_U16)(0x0001),DS_OP,DS_XC,&PSTXC_DS_CMDCNT, 0x0001); //enable STGEN double buffer
#if FRC_INSIDE
            if ((psXCInstPri->u32DeviceID != 1)
#if (SUPPORT_3D_DS == 1)
                &&((!(IS_OUTPUT_LINE_ALTERNATIVE()||IS_OUTPUT_TOP_BOTTOM()||IS_OUTPUT_SIDE_BY_SIDE_HALF()||IS_OUTPUT_TOP_BOTTOM_HW()||IS_OUTPUT_SIDE_BY_SIDE_HALF_HW()||IS_OUTPUT_FRAME_PACKING())))
#endif
                )
            {
                if(MHal_FRC_IsFHDToFSC(pInstance,MAIN_WINDOW))
                {
                    u16VFDE_Start = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart/2 + VSTART_OFFSET;
                    u16VFDE_End =  u16VFDE_Start + pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height/2 -1;
                    u16VMDE_Start = (pDBreg->u16V_DisStart/2)+ VSTART_OFFSET;
                    u16VMDE_End = (pDBreg->u16V_DisEnd/2) + VSTART_OFFSET;

                    //limitation: VDE_START should be >= 16. Otherwise, the first few lines wouldn't be able to process. Garbage would be seen.
                    if(!bStgenHcntAliveEn
                        && IS_SUPPORT_DS_SR(gSrcInfo[eWindow].enInputSourceType)
                        && (u16VFDE_Start < DS_SR_VDE_START_MIN || u16VMDE_Start < DS_SR_VDE_START_MIN))
                    {
                        u16VDE_Offset = ((DS_SR_VDE_START_MIN - u16VFDE_Start) > (DS_SR_VDE_START_MIN - u16VMDE_Start)) ? (DS_SR_VDE_START_MIN - u16VFDE_Start) : (DS_SR_VDE_START_MIN - u16VMDE_Start);
                        u16VFDE_Start += u16VDE_Offset;
                        u16VFDE_End += u16VDE_Offset;
                        u16VMDE_Start += u16VDE_Offset;
                        u16VMDE_End += u16VDE_Offset;

                        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] [DS] Tune vde_start to be larger than 16 \n",__func__,__LINE__);
                    }
                    //H_MDE start and end

                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_05_L,(MS_U16)((pDBreg->u16H_DisStart/2 +1) & ~1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_06_L,(MS_U16)( ((pDBreg->u16H_DisStart/2 +1) & ~1) + gSrcInfo[eWindow].stDispWin.width/2 - 1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    //V_MDE start and end
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0D_L,(MS_U16)(u16VMDE_Start),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    if (Hal_SC_NeedXCV8Align(pInstance))
                    {
                        u16VMDE_End = u16VMDE_Start + XC8ALIGN(u16VMDE_End - u16VMDE_Start + 1) - 1;
                    }
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0E_L,(MS_U16)(u16VMDE_End),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    //H_FDE start and end
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_03_L,(MS_U16)((pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart/2+1) & ~1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_04_L,(MS_U16)(((pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart/2+1) & ~1) + pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width/2 -1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    //V_FDE start and end
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0B_L,(MS_U16)(u16VFDE_Start),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0C_L,(MS_U16)(u16VFDE_End),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);

                    if(IS_SUPPORT_DS_SR(gSrcInfo[eWindow].enInputSourceType))
                    {
                        u16VSyncStart = u16VFDE_End + DS_SR_VSYNC_FRONT_PORCH;
                        u16VSyncEnd = u16VSyncStart + DS_SR_VSYNC_WIDTH;
                        //Vsync start and end
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_09_L,(MS_U16)(u16VSyncStart),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0A_L,(MS_U16)(u16VSyncEnd),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                        //HTT and VTT
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_07_L,(MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HTotal/2-1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0F_L,(MS_U16)(u16VFDE_End + u16TrainTrig + DS_SR_VTOTAL_OFFSET),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);

                        //FSC only, DS control PIPE delay
                        if(!pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFRCEnabled)
                        {
                            if( (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_B & E_XC_INIT_MISC_B_HDMITX_ENABLE)
                                &&(pXCResourcePrivate->stdrvXC_MVideo.gu16HPixelShiftRange == 0)
                                &&(pXCResourcePrivate->stdrvXC_MVideo.gu16VPixelShiftRange == 0)) //Check if PIXEL FEATURE is NOT enable.
                            {
                                #if (HW_DESIGN_HDMITX_VER == 2)
                                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_51_L,FRC_PIPE_DELAY_VCNT_FSC_FHD_HDMITX + u16VDE_Offset*2,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_52_L,FRC_PIPE_DELAY_HCNT_FSC_FHD,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                #else
                                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_51_L,FRC_PIPE_DELAY_VCNT_FSC_FHD + u16VDE_Offset*2,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_52_L,FRC_PIPE_DELAY_HCNT_FSC_FHD,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                #endif
                            }
                            else
                            {
                                if (Hal_SC_IsLockFromIP(pInstance, eWindow))
                                {
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_51_L,FRC_PIPE_DELAY_VCNT_FSC_FHD + u16VDE_Offset*2,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_52_L,FRC_PIPE_DELAY_HCNT_FSC_FHD,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                }
                                else
                                {
#if (ENABLE_FIX_PP_DLY == TRUE)
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_51_L, (2 * VSTART_OFFSET + SC0_PATH_DLY_FSC2X_V), DS_OP, DS_XC, &PSTXC_DS_CMDCNT);
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_52_L, 0, DS_OP, DS_XC, &PSTXC_DS_CMDCNT);
#else
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_51_L,FRC_PIPE_DELAY_VCNT_FSC_FHD + u16VDE_Offset*2,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_52_L,FRC_PIPE_DELAY_HCNT_FSC_FHD,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
#endif
                                }
                            }
                        }
#if FRC_INSIDE
                        E_FRC_STGEN_ODCLK eMode = E_FRC_STGEN_ODCLK_1;
                        E_FSC_IDCLK eFSCIDCLK = E_FSC_IDCLK_1;
                        Hal_SC_Get_FRC_STGEN_ODCLK(pInstance, eWindow, &eMode, &eFSCIDCLK);

                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK3F_60_L,eMode,DS_OP,DS_XC,&PSTXC_DS_CMDCNT,0x3);
                        Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,0x1420,0x04, (eFSCIDCLK<<8), 0x0300,DS_OP,&PSTXC_DS_CMDCNT);
#endif
                    }
                }
                else //4K to FSC
                {
                    u16VFDE_Start = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart+VSTART_OFFSET;
                    u16VFDE_End = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart
                        + pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height -1  + VSTART_OFFSET;

#if (ENABLE_FIX_PP_DLY == TRUE)
                    if (pDBreg->u16V_DisStart > pDBreg->u16V_DisEnd)
                    {
                        printf("[%s,%5d] pDBreg->u16V_DisStart is larger than pDBreg->u16V_DisEnd, NEED CHECK\n",__FUNCTION__,__LINE__);
                    }
                    MS_U16 u16Height = pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart +1;
                    u16VMDE_Start = pDBreg->u16V_DisStart + VSTART_OFFSET*2 + (SC0_PATH_DLY_FSC2X_V - SC0_PATH_DLY_FSC1X_V);
                    u16VMDE_End = u16VMDE_Start + u16Height -1;
#else
                    u16VMDE_Start = pDBreg->u16V_DisStart + VSTART_OFFSET;
                    u16VMDE_End = pDBreg->u16V_DisEnd + VSTART_OFFSET;
#endif

                    if((pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_B & E_XC_INIT_MISC_B_HDMITX_ENABLE)
                        &&(pXCResourcePrivate->stdrvXC_MVideo.gu16HPixelShiftRange == 0)
                        &&(pXCResourcePrivate->stdrvXC_MVideo.gu16VPixelShiftRange == 0)) //Check if PIXEL FEATURE is ENABLE or NOT.
                    {
                        u16VFDE_Start += (FRC_PIPE_DELAY_VCNT_FSC_FHD - FRC_PIPE_DELAY_VCNT_FSC_4K);
                        u16VFDE_End += (FRC_PIPE_DELAY_VCNT_FSC_FHD - FRC_PIPE_DELAY_VCNT_FSC_4K);
                        u16VMDE_Start += (FRC_PIPE_DELAY_VCNT_FSC_FHD - FRC_PIPE_DELAY_VCNT_FSC_4K);
                        u16VMDE_End += (FRC_PIPE_DELAY_VCNT_FSC_FHD - FRC_PIPE_DELAY_VCNT_FSC_4K);
                    }

                    //limitation: VDE_START should be >= 16. Otherwise, the first few lines wouldn't be able to process. Garbage would be seen.
                    if(!bStgenHcntAliveEn
                        && IS_SUPPORT_DS_SR(gSrcInfo[eWindow].enInputSourceType)
                        && (u16VFDE_Start < DS_SR_VDE_START_MIN || u16VMDE_Start < DS_SR_VDE_START_MIN))
                    {
                        u16VDE_Offset = ((DS_SR_VDE_START_MIN - u16VFDE_Start) > (DS_SR_VDE_START_MIN - u16VMDE_Start)) ? (DS_SR_VDE_START_MIN - u16VFDE_Start) : (DS_SR_VDE_START_MIN - u16VMDE_Start);
                        u16VFDE_Start += u16VDE_Offset;
                        u16VFDE_End += u16VDE_Offset;
                        u16VMDE_Start += u16VDE_Offset;
                        u16VMDE_End += u16VDE_Offset;

                        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] [DS] Tune vde_start to be larger than 16 \n",__func__,__LINE__);
                    }

#if (ENABLE_FIX_PP_DLY == TRUE)
                    if (u16VFDE_Start > u16VFDE_End)
                    {
                        printf("[%s,%5d] u16VFDE_Start is larger than u16VFDE_End,NEED CHECK!\n",__FUNCTION__,__LINE__);
                    }
                    else
                    {
                        u16Height = u16VFDE_End - u16VFDE_Start +1;
                    }
                    u16VFDE_Start = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VStart + VSTART_OFFSET * 2 + (SC0_PATH_DLY_FSC2X_V - SC0_PATH_DLY_FSC1X_V);
                    u16VFDE_End = u16VFDE_Start+u16Height -1;

                    //H_MDE start and end
                    MS_U16 u16HFDE_Start = ((pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart/2 +1) & ~1);
                    MS_U16 u16FSC_1X_HFDEOffset = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart - u16HFDE_Start;

                    MS_U16 u16HMDE_Start = 0;
                    if (u16HFDE_Start > pDBreg->u16H_DisStart)
                    {
                        printf("[%s,%5d] u16HFDE_Start is larger than pDBreg->u16H_DisStart,NEED CHECK!\n",__FUNCTION__,__LINE__);
                    }
                    else
                    {
                        if(u16FSC_1X_HFDEOffset > pDBreg->u16H_DisStart)
                        {
                            u16HMDE_Start = 0;
                        }
                        else
                        {
                            u16HMDE_Start = pDBreg->u16H_DisStart - u16FSC_1X_HFDEOffset;
                        }
                    }

                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_05_L,(MS_U16)u16HMDE_Start,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    if (Hal_SC_NeedXCH8Align(pInstance))
                    {
                        //w need be 8 align
                        gSrcInfo[eWindow].stDispWin.width = XC8ALIGN(gSrcInfo[eWindow].stDispWin.width);
                    }
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_06_L,(MS_U16)(u16HMDE_Start + gSrcInfo[eWindow].stDispWin.width - 1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);

                    //V_MDE start and end
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0D_L,(MS_U16)u16VMDE_Start,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    if (Hal_SC_NeedXCV8Align(pInstance))
                    {
                        u16VMDE_End = u16VMDE_Start + XC8ALIGN(u16VMDE_End - u16VMDE_Start + 1) - 1;
                    }
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0E_L,(MS_U16)u16VMDE_End,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);

                    //H_FDE start and end
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_03_L,(MS_U16)u16HFDE_Start,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_04_L,(MS_U16)(u16HFDE_Start + pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width -1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
#else

                    //H_MDE start and end
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_05_L,(MS_U16)(pDBreg->u16H_DisStart),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    if (Hal_SC_NeedXCH8Align(pInstance))
                    {
                        //w need be 8 align
                        u16End = pDBreg->u16H_DisStart + XC8ALIGN(pDBreg->u16H_DisEnd - pDBreg->u16H_DisStart + 1) - 1;
                    }
                    else
                    {
                        u16End = pDBreg->u16H_DisEnd;
                    }
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_06_L,(MS_U16)u16End,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    //V_MDE start and end
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0D_L,(MS_U16)u16VMDE_Start,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    if (Hal_SC_NeedXCV8Align(pInstance))
                    {
                        u16VMDE_End = u16VMDE_Start + XC8ALIGN(u16VMDE_End - u16VMDE_Start + 1) - 1;
                    }
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0E_L,(MS_U16)u16VMDE_End,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    //H_FDE start and end
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_03_L,(MS_U16)((pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart) & ~1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_04_L,(MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HStart + pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width -1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
#endif

                    //V_FDE start and end
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0B_L,(MS_U16)u16VFDE_Start,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0C_L,(MS_U16)u16VFDE_End,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);

                    if(IS_SUPPORT_DS_SR(gSrcInfo[eWindow].enInputSourceType))
                    {
                        u16VSyncStart = u16VFDE_End + DS_SR_VSYNC_FRONT_PORCH;
                        u16VSyncEnd = u16VSyncStart + DS_SR_VSYNC_WIDTH;
                        //Vsync start and end
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_09_L,(MS_U16)(u16VSyncStart),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0A_L,(MS_U16)(u16VSyncEnd),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                        //HTT and VTT
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_07_L,(MS_U16)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HTotal-1),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_0F_L,(MS_U16)(u16VFDE_End + u16TrainTrig + DS_SR_VTOTAL_OFFSET),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);

                        //FSC only, DS control PIPE delay
                        if(!pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFRCEnabled)
                        {
                            if( (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_B & E_XC_INIT_MISC_B_HDMITX_ENABLE)
                                &&(pXCResourcePrivate->stdrvXC_MVideo.gu16HPixelShiftRange == 0)
                                &&(pXCResourcePrivate->stdrvXC_MVideo.gu16VPixelShiftRange == 0)) //Check if PIXEL FEATURE is NOT enable.
                            {
                                #if (HW_DESIGN_HDMITX_VER == 2)
                                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_51_L,FRC_PIPE_DELAY_VCNT_FSC_FHD_HDMITX + u16VDE_Offset,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_52_L,FRC_PIPE_DELAY_HCNT_FSC_FHD,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                #else
                                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_51_L,FRC_PIPE_DELAY_VCNT_FSC_FHD + u16VDE_Offset,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_52_L,FRC_PIPE_DELAY_HCNT_FSC_FHD,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                #endif
                            }
                            else
                            {
                                if (Hal_SC_IsLockFromIP(pInstance, eWindow))
                                {
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_51_L,FRC_PIPE_DELAY_VCNT_FSC_4K + u16VDE_Offset,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_52_L,FRC_PIPE_DELAY_HCNT_FSC_4K,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                }
                                else
                                {
#if (ENABLE_FIX_PP_DLY == TRUE)
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_51_L, (2 * VSTART_OFFSET + SC0_PATH_DLY_FSC2X_V), DS_OP, DS_XC, &PSTXC_DS_CMDCNT);
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_52_L, 0, DS_OP, DS_XC, &PSTXC_DS_CMDCNT);
#else
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_51_L,FRC_PIPE_DELAY_VCNT_FSC_4K + u16VDE_Offset,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
                                    Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK68_52_L,FRC_PIPE_DELAY_HCNT_FSC_4K,DS_OP,DS_XC,&PSTXC_DS_CMDCNT);
#endif
                                }
                            }
                        }

                        E_FRC_STGEN_ODCLK eMode = E_FRC_STGEN_ODCLK_1;
                        E_FSC_IDCLK eFSCIDCLK = E_FSC_IDCLK_1;
                        Hal_SC_Get_FRC_STGEN_ODCLK(pInstance, eWindow, &eMode, &eFSCIDCLK);

                        Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK3F_60_L,eMode,DS_OP,DS_XC,&PSTXC_DS_CMDCNT,0x3);
                        Hal_SC_WriteSWDSCommand_NonXC(pInstance,MAIN_WINDOW,0x1420,0x04, (eFSCIDCLK<<8), 0x0300,DS_OP,&PSTXC_DS_CMDCNT);
                    }
                }
            }
#endif

#if FRC_INSIDE
            if(IS_SUPPORT_DS_SR(gSrcInfo[eWindow].enInputSourceType)
                && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFSCEnabled)
                && (psXCInstPri->u32DeviceID != 1))
            {
                Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK68_23_L,(MS_U16)(0x0002),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,0x0002);
            }
            else
#endif
            {
                Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK68_23_L,(MS_U16)(0x0000),DS_OP,DS_XC,&PSTXC_DS_CMDCNT,0x0001);
            }
            Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK68_23_L,(MS_U16)(0x0001),DS_OP,DS_XC,&PSTXC_DS_CMDCNT, 0x0001); //enable STGEN double buffer
            Hal_SC_WriteSWDSCommand_Mask(pInstance,MAIN_WINDOW,REG_SC_BK68_23_L,(MS_U16)(0x0004),DS_OP,DS_XC,&PSTXC_DS_CMDCNT, 0x0004); // enable timing setting update trigger

#if (SUPPORT_3D_DS == 1)
            if (!(IS_OUTPUT_LINE_ALTERNATIVE()||IS_OUTPUT_TOP_BOTTOM()||IS_OUTPUT_SIDE_BY_SIDE_HALF()||IS_OUTPUT_TOP_BOTTOM_HW()||IS_OUTPUT_SIDE_BY_SIDE_HALF_HW()||IS_OUTPUT_FRAME_PACKING()))
#endif
            {
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK10_08_L,(MS_U16)(pDBreg->u16H_DisStart),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);  //0xFFFF0009 8808XXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK10_09_L,(MS_U16)(pDBreg->u16H_DisEnd),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);    //0xFFFF0009 8809XXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK10_0A_L,(MS_U16)(pDBreg->u16V_DisStart),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);  //0xFFFF0009 880AXXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK10_0B_L,(MS_U16)(pDBreg->u16V_DisEnd),DS_OP,DS_XC,&PSTXC_DS_CMDCNT);    //0xFFFF0009 880BXXXX
                if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
                {
                    if (Hal_SC_NeedXCV8Align(pInstance))
                    {
                        u16End = (pDBreg->u16V_DisStart) + XC8ALIGN(pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1) - 1;

                    }
                    else
                    {
                        u16End = (pDBreg->u16V_DisStart) + pDBreg->u16V_DisEnd - pDBreg->u16V_DisStart + 1 - 1;
                    }
                    Hal_SC_WriteSWDSCommand(pInstance, MAIN_WINDOW, REG_SC_BK0F_0D_L, (MS_U16)(pDBreg->u16V_DisStart), DS_OP, DS_XC, &PSTXC_DS_CMDCNT);  //0xFFFF0009 8808XXXX
                    Hal_SC_WriteSWDSCommand(pInstance, MAIN_WINDOW, REG_SC_BK0F_0E_L, (MS_U16)u16End, DS_OP, DS_XC, &PSTXC_DS_CMDCNT);  //0xFFFF0009 8808XXXX
                    u16End = pDBreg->u16H_DisStart + XC8ALIGN(pDBreg->u16H_DisEnd - pDBreg->u16H_DisStart + 1) - 1;
                    Hal_SC_WriteSWDSCommand_Mask(pInstance, MAIN_WINDOW, REG_SC_BK0F_27_L, (MS_U16)0x8000, DS_OP, DS_XC, &PSTXC_DS_CMDCNT, 0x8000);//BIT(15): Enable 2ndSubDE
                    Hal_SC_WriteSWDSCommand(pInstance, MAIN_WINDOW, REG_SC_BK0F_0B_L, (MS_U16)(pDBreg->u16H_DisStart), DS_OP, DS_XC, &PSTXC_DS_CMDCNT);  //0xFFFF0009 8808XXXX
                    Hal_SC_WriteSWDSCommand(pInstance, MAIN_WINDOW, REG_SC_BK0F_0C_L, (MS_U16)u16End, DS_OP, DS_XC, &PSTXC_DS_CMDCNT);  //0xFFFF0009 8808XXXX
                    Hal_SC_WriteSWDSCommand_Mask(pInstance, MAIN_WINDOW, REG_SC_BK0F_01_L, (MS_U16)0x8, DS_OP, DS_XC, &PSTXC_DS_CMDCNT, 0x8);  //BIT(3);osd refer to origin
                }
            }

            // Force OP one field control (input resolution/prescaling change need to set as 1, otherwise set as 0)
            if(gSrcInfo[eWindow].bInterlace)
            {
                if(gSrcInfo[eWindow].bPreScalingRatioChanged && (gSrcInfo[eWindow].Status2.u8FrameCountPQDS == E_DS_XRULE_FRAME_COUNT_0))
                {
                    Hal_SC_WriteSWDSCommand_Mask(pInstance, MAIN_WINDOW, REG_SC_BK11_07_L, BIT(15), DS_OP, DS_XC, &PSTXC_DS_CMDCNT, BIT(15));
                }
                else if(gSrcInfo[eWindow].Status2.u8FrameCountPQDS == E_DS_XRULE_FRAME_COUNT_3)
                {
                    Hal_SC_WriteSWDSCommand_Mask(pInstance, MAIN_WINDOW, REG_SC_BK11_07_L, 0, DS_OP, DS_XC, &PSTXC_DS_CMDCNT, BIT(15));
                }
                else
                {
                    // don't control op force one filed
                }
            }
            //---------------------------------------------------------------------OP Command End---------------------------------------------------------------------------------------//

            if (SUPPORT_3D_DS&&(IS_OUTPUT_LINE_ALTERNATIVE()||IS_OUTPUT_TOP_BOTTOM()||IS_OUTPUT_SIDE_BY_SIDE_HALF()||IS_OUTPUT_TOP_BOTTOM_HW()||IS_OUTPUT_SIDE_BY_SIDE_HALF_HW()||IS_OUTPUT_FRAME_PACKING()))
            {
                //H pre-scaling
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK04_04_L,(MS_U16)(pDBreg->u32H_PreScalingRatio>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8104XXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK04_05_L,(MS_U16)(pDBreg->u32H_PreScalingRatio>>16),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8105XXXX
                //V pre-scaling
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK04_08_L,(MS_U16)(pDBreg->u32V_PreScalingRatio>>00),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8108XXXX
                Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK04_09_L,(MS_U16)(pDBreg->u32V_PreScalingRatio>>16),DS_IP,DS_XC,&PSTXC_DS_CMDCNT);//0xFFFF0009 8109XXXX
            }

#if ((defined (ANDROID) || defined(MSOS_TYPE_LINUX_KERNEL) || defined(ROLLS_ROYCE)) && defined(UFO_XC_DS_PQ))
            //Hal_SC_SWDS_AddPQCmd(pInstance,MAIN_WINDOW);//control in MDrv_XC_SetDSInfo
#endif

#if (SUPPORT_KERNEL_DS == 1)
            Hal_SC_Add_NullCommand(pInstance, MAIN_WINDOW, DS_IP, &PSTXC_DS_CMDCNT);
            if(!((gSrcInfo[MAIN_WINDOW].bR_FBL) || (gSrcInfo[MAIN_WINDOW].bFBL)))
            {
                Hal_SC_Add_NullCommand(pInstance, MAIN_WINDOW, DS_OP, &PSTXC_DS_CMDCNT);
            }
#else
            //MS_U8 u8MaxCmdCnt = pXCResourcePrivate->sthal_SC.u8DynamicScalingIndexDepth * (Hal_XC_MLoad_Get_64Bits_MIU_Bus_Sel(pInstance)+1);
            MS_U32 u32MaxCmdCnt = pXCResourcePrivate->sthal_SC.u16DynamicScalingIndexDepth_Ext * (Hal_XC_MLoad_Get_64Bits_MIU_Bus_Sel(pInstance)+1);

            //XC_PRINTF("[%s,%5d] u16CMDCNT_IPM:%d   u8MaxCnt:%d \n",__func__,__LINE__,PSTXC_DS_CMDCNT.u16CMDCNT_IPM,u8MaxCmdCnt);
            //XC_PRINTF("[%s,%5d] u16CMDCNT_OPM:%d   u8MaxCnt:%d \n",__func__,__LINE__,PSTXC_DS_CMDCNT.u16CMDCNT_OPM,u8MaxCmdCnt);
            if(PSTXC_DS_CMDCNT.u16CMDCNT_IPM < u32MaxCmdCnt)
            {
                Hal_SC_Add_NullCommand(pInstance,MAIN_WINDOW,DS_IP,&PSTXC_DS_CMDCNT);
            }
            if(!((gSrcInfo[MAIN_WINDOW].bR_FBL) || (gSrcInfo[MAIN_WINDOW].bFBL)))
            {
                if(PSTXC_DS_CMDCNT.u16CMDCNT_OPM < u32MaxCmdCnt)
                {
                    Hal_SC_Add_NullCommand(pInstance,MAIN_WINDOW,DS_OP,&PSTXC_DS_CMDCNT);
                }
            }
#endif
        }
    }
}

#if ((defined (ANDROID) || defined(MSOS_TYPE_LINUX_KERNEL) || defined(ROLLS_ROYCE)) && defined(UFO_XC_DS_PQ))
extern stDS_PQ_REG DS_REG[DS_PQ_MAX_NUM];
extern MS_U16 DS_REG_CNT;
extern stDS_PQ_REG DS_REG_GENERAL[DS_PQ_MAX_NUM];
extern MS_U16 u16DSGeneralRegCnt;
void Hal_SC_SWDS_AddPQCmd(void *pInstance,SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(eWindow == MAIN_WINDOW)
    {
        if(pXCResourcePrivate->sthal_SC.bDynamicScalingEnable[eWindow])
        {
            pXCResourcePrivate->sthal_SC.u8DynamicScalingNextIndex[MAIN_WINDOW] = pXCResourcePrivate->sthal_SC.u8DynamicScalingCurrentIndex_Ring[MAIN_WINDOW];

            MS_U16 cnt_x = 0;

            if(DS_REG_CNT > DS_PQ_MAX_NUM)
            {
                MS_ASSERT(0);
            }
            if(eWindow != MAIN_WINDOW)
            {
                MS_ASSERT(0);
            }
            for(cnt_x = 0 ;cnt_x < DS_REG_CNT; cnt_x++)
            {
                // Use HW bitmask function
                //printf("\033[1;31m[%s:%d][0x%x] Value:%x  u16Mask:%x  u16Module:%x  \033[m\n",__FUNCTION__,__LINE__,DS_REG[cnt_x].u16Addr,DS_REG[cnt_x].u16Value,DS_REG[cnt_x].u16Mask,DS_REG[cnt_x].u16Module);
                Hal_SC_WriteSWDSCommand_NonXC(pInstance,eWindow,DS_REG[cnt_x].u16Bank,(DS_REG[cnt_x].u16Addr & 0xFF),DS_REG[cnt_x].u16Value,DS_REG[cnt_x].u16Mask,DS_REG[cnt_x].u16Module,&PSTXC_DS_CMDCNT);
            }

            for(cnt_x = 0 ;cnt_x < u16DSGeneralRegCnt; cnt_x++)
            {
                // Use HW bitmask function
                Hal_SC_WriteSWDSCommand_NonXC(pInstance,eWindow,(DS_REG_GENERAL[cnt_x].u32Addr >> 8),(DS_REG_GENERAL[cnt_x].u32Addr & 0xFF),DS_REG_GENERAL[cnt_x].u16Value,DS_REG_GENERAL[cnt_x].u16Mask,DS_REG_GENERAL[cnt_x].u16Module,&PSTXC_DS_CMDCNT);
            }
            DS_REG_CNT = 0;
            u16DSGeneralRegCnt = 0;
        }
    }
}
#endif

void Hal_SC_SWDS_Fire(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    pXCResourcePrivate->sthal_SC.u8DynamicScalingCurrentIndex[eWindow]++;
    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] [DS] CurIdx:%d  \n",__func__,__LINE__,(int)pXCResourcePrivate->sthal_SC.u8DynamicScalingCurrentIndex[eWindow]);

    pXCResourcePrivate->sthal_SC.u8DynamicScalingCurrentIndex_Ring[eWindow] = pXCResourcePrivate->sthal_SC.u8DynamicScalingCurrentIndex[eWindow] % DS_BUFFER_NUM_EX;
    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] [DS] CurIdx_Ring:%d  \n",__func__,__LINE__,(int)pXCResourcePrivate->sthal_SC.u8DynamicScalingCurrentIndex_Ring[eWindow])
}

E_APIXC_ReturnValue Hal_SC_VIP_Peaking_Setting(void *pInstance, SCALER_WIN UNUSED_PARA(eWindow))
{
    return E_APIXC_RET_FAIL_FUN_NOT_SUPPORT;
}

E_APIXC_ReturnValue Hal_SC_support_source_to_ve(void *pInstance, MS_U16* pOutputCapability)
{
    *pOutputCapability = E_XC_IP | E_XC_OP2 | E_XC_OVERLAP;
    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue Hal_SC_set_output_capture_enable(void *pInstance, MS_BOOL bEnable,E_XC_SOURCE_TO_VE eSourceToVE)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_BOOL bCaptureEna;
    MS_U16 u16CaptureSrc;
    // Current only support IP and OP2
    bCaptureEna = bEnable;
    switch(eSourceToVE)
    {
        case E_XC_VOP2:
        case E_XC_OVERLAP:  // compatible to previous IC, overlap is before osd blending
            u16CaptureSrc = 0;
            break;
        case E_XC_OP2:
            u16CaptureSrc = 1;
            break;
        case E_XC_BRI:
            u16CaptureSrc = 3;
            break;
        default:
            u16CaptureSrc = 0;
            bCaptureEna = FALSE;
            break;
    }

    if(bCaptureEna)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_57_L, BIT(11), BIT(11));    // Disable
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_46_L, u16CaptureSrc<<4, BMASK(7:4));            // Disable
    }
    else
    {
        //DIP and VE Opcapture both need enable this bit, so dont disable it.
        //SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_57_L, 0, BIT(11));   // Disable
    }
    return E_APIXC_RET_OK; // Support Scaler OP -> VE
}

/******************************************************************************/
///Set output DE window size
///@param pstWindow \b IN
///-  pointer to window information
/******************************************************************************/
void Hal_SC_set_de_window(void *pInstance, XC_PANEL_INFO *pPanel_Info)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
#ifdef new_chakra
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_04_L, pPanel_Info->u16HStart);                                // DE H start
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_05_L, pPanel_Info->u16HStart + pPanel_Info->u16Width - 1);    // DE H end
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, pPanel_Info->u16VStart);                                // DE V start
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, pPanel_Info->u16VStart + pPanel_Info->u16Height - 1);   // DE V end
#else
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_04_L, pPanel_Info->u16HStart);                                // DE H start
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_05_L, pPanel_Info->u16HStart + pPanel_Info->u16Width - 1);    // DE H end
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, pSrcInfo->u8DE_V_Start);                                // DE V start
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, pSrcInfo->u16DE_V_End);   // DE V end
#endif
}

void Hal_SC_get_disp_de_window(void *pInstance, MS_WINDOW_TYPE *pWin)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    pWin->x = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_04_L);
    pWin->y = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L);
    pWin->width = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_05_L) - pWin->x + 1;
    pWin->height= SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L) - pWin->y + 1;
}

MS_PHY Hal_SC_Get_DNRBase0(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_08_L);     // input address0
    }
    else
    {
        return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_48_L);     // input address0
    }
}

MS_PHY Hal_SC_Get_DNRBase1(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0A_L);     // input address1
    }
    else
    {
        return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4A_L);     // input address1
    }
}

MS_PHY Hal_SC_Get_OPMBase0(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_10_L);     // output address0
    }
    else
    {
        return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_50_L);     // output address0
    }
}

MS_PHY Hal_SC_Get_OPMBase1(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_12_L);     // output address1
    }
    else
    {
        return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_52_L);     // output address1
    }
}

MS_PHY Hal_SC_Get_FRCMBaseAddr(void *pInstance, MS_U8 u8id,SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        if(u8id == 0)
            return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_08_L);     // frcm_w base address0
        else if(u8id == 1)
            return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_1A_L);     // frcm_w base address1
        else //if(u8id == 2)
            return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_0C_L);     // frcm_w base address2
    }
    else
    {
        if(u8id == 0)
            return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_48_L);     // frcm_w base address0
        else if(u8id == 1)
            return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_4A_L);     // frcm_w base address1
        else //if(u8id == 2)
            return SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_4C_L);     // frcm_w base address2
    }
}

MS_U16 Hal_SC_Get_LBOffset(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U16 u16tmp = 0;

    if(eWindow == MAIN_WINDOW)
    {
        u16tmp = SC_R2BYTEMSK(0, REG_SC_BK20_1D_L, 0x00FF);
        u16tmp |= SC_R2BYTEMSK(0, REG_SC_BK20_2C_L, 0x0300);
        return u16tmp;
    }
    else
    {
        u16tmp = SC_R2BYTEMSK(0, REG_SC_BK20_1D_L, 0xFF00) >> 8;
        u16tmp |= (SC_R2BYTEMSK(0, REG_SC_BK20_2C_L, 0x3000) >> 4);
        return u16tmp;
    }
}

void Hal_SC_Set_LBOffset(void *pInstance, MS_U16 u16LBOffset, SCALER_WIN eWindow)
{
    if(eWindow == MAIN_WINDOW)
    {
        SC_W2BYTEMSK(0, REG_SC_BK20_1D_L, u16LBOffset, 0x00FF);
        SC_W2BYTEMSK(0, REG_SC_BK20_2C_L, u16LBOffset, 0x0300);
    }
    else
    {
        SC_W2BYTEMSK(0, REG_SC_BK20_1D_L, u16LBOffset << 8, 0xFF00);
        SC_W2BYTEMSK(0, REG_SC_BK20_2C_L, u16LBOffset << 4, 0x3000);
    }
}

void Hal_SC_set_DNRBase0(void *pInstance, MS_PHY u32DNRBase0, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_08_L, u32DNRBase0 / BYTE_PER_WORD);     // input address0
    }
    else
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_48_L, u32DNRBase0 / BYTE_PER_WORD);     // input address0
    }
}

void Hal_SC_set_OPMBase0(void *pInstance, MS_PHY u32OPMBase0, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_10_L, u32OPMBase0 / BYTE_PER_WORD);     // input address0
    }
    else
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_50_L, u32OPMBase0 / BYTE_PER_WORD);     // input address0
    }
}

void Hal_SC_set_OPMBase1(void *pInstance, MS_PHY u32OPMBase1, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_12_L, u32OPMBase1 / BYTE_PER_WORD);     // input address1
    }
    else
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_52_L, u32OPMBase1 / BYTE_PER_WORD);     // input address1
    }
}

void Hal_SC_set_FRCM_WBase0(void *pInstance, MS_PHY u32FRCM_WBase0, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_08_L, u32FRCM_WBase0 / BYTE_PER_WORD);     // input address0
    }
    else
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_48_L, u32FRCM_WBase0 / BYTE_PER_WORD);     // input address0
    }
}

void Hal_SC_set_FRCM_RBase0(void *pInstance, MS_PHY u32FRCM_RBase0, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_10_L, u32FRCM_RBase0 / BYTE_PER_WORD);     // input address0
    }
    else
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_50_L, u32FRCM_RBase0 / BYTE_PER_WORD);     // input address0
    }
}

void Hal_SC_set_FRCM_RBase1(void *pInstance, MS_PHY u32FRCM_RBase1, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_12_L, u32FRCM_RBase1 / BYTE_PER_WORD);     // input address1
    }
    else
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_52_L, u32FRCM_RBase1 / BYTE_PER_WORD);     // input address1
    }
}

void Hal_SC_set_Dual_DNRBase0(void *pInstance, MS_PHY u32DNRBase0, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    // Dual just support scaler0, main only
    if ((psXCInstPri->u32DeviceID > 0) || (eWindow != MAIN_WINDOW))
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] scmi dual mode just support scaler0 main only.\n",__func__,__LINE__);
        return;
    }
    if(eWindow == MAIN_WINDOW)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK52_08_L, u32DNRBase0 / BYTE_PER_WORD);     // input address0
    }
    else
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK52_48_L, u32DNRBase0 / BYTE_PER_WORD);     // input address0
    }
}

void Hal_SC_set_Dual_DNRBase1(void *pInstance, MS_PHY u32DNRBase1, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    // Dual just support scaler0, main only
    if ((psXCInstPri->u32DeviceID > 0) || (eWindow != MAIN_WINDOW))
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] scmi dual mode just support scaler0 main only.\n",__func__,__LINE__);
        return;
    }
    if(eWindow == MAIN_WINDOW)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK52_1A_L, u32DNRBase1 / BYTE_PER_WORD);     // input address0
    }
    else
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK52_5A_L, u32DNRBase1 / BYTE_PER_WORD);     // input address0
    }

}

void Hal_SC_set_Dual_DNRBase2(void *pInstance, MS_PHY UNUSED_PARA(u32DNRBase2), SCALER_WIN UNUSED_PARA(eWindow))
{

}

void Hal_SC_set_Dual_OPMBase0(void *pInstance, MS_PHY u32OPMBase0, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    // Dual just support scaler0, main only
    if ((psXCInstPri->u32DeviceID > 0) || (eWindow != MAIN_WINDOW))
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] scmi dual mode just support scaler0 main only.\n",__func__,__LINE__);
        return;
    }
    if(eWindow == MAIN_WINDOW)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK52_10_L, u32OPMBase0 / BYTE_PER_WORD);     // input address0
    }
    else
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK52_50_L, u32OPMBase0 / BYTE_PER_WORD);     // input address0
    }
}

void Hal_SC_set_Dual_OPMBase1(void *pInstance, MS_PHY u32OPMBase1, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    // Dual just support scaler0, main only
    if ((psXCInstPri->u32DeviceID > 0) || (eWindow != MAIN_WINDOW))
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] scmi dual mode just support scaler0 main only.\n",__func__,__LINE__);
        return;
    }
    if(eWindow == MAIN_WINDOW)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK52_12_L, u32OPMBase1 / BYTE_PER_WORD);     // input address1
    }
    else
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK52_52_L, u32OPMBase1 / BYTE_PER_WORD);     // input address1
    }
}

void Hal_SC_set_Dual_OPMBase2(void *pInstance, MS_PHY UNUSED_PARA(u32OPMBase2), SCALER_WIN UNUSED_PARA(eWindow))
{

}

void Hal_SC_set_WriteVLength(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_15_L, 0x0);     // Write V length
    }
    else
    {
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_16_L, 0x0);     // Write V length
    }
}

void Hal_SC_set_memoryaddress(void *pInstance, MS_PHY u32DNRBase0, MS_PHY u32DNRBase1, MS_PHY u32DNRBase2, MS_PHY u32OPMBase0, MS_PHY u32OPMBase1, MS_PHY u32OPMBase2, SCALER_WIN eWindow)
{
    Hal_SC_set_DNRBase0(pInstance, u32DNRBase0, eWindow);
    Hal_SC_set_DNRBase1(pInstance, u32DNRBase1, eWindow);
    Hal_SC_set_DNRBase2(pInstance, u32DNRBase2, eWindow);
    Hal_SC_set_OPMBase0(pInstance, u32OPMBase0, eWindow);
    Hal_SC_set_OPMBase1(pInstance, u32OPMBase1, eWindow);
    Hal_SC_set_OPMBase2(pInstance, u32OPMBase2, eWindow);
}

void Hal_SC_set_frcm_memoryaddress(void *pInstance, MS_PHY u32FRCM_WBase0, MS_PHY u32FRCM_WBase1, MS_PHY u32FRCM_WBase2, MS_PHY u32FRCM_RBase0, MS_PHY u32FRCM_RBase1, MS_PHY u32FRCM_RBase2, SCALER_WIN eWindow)
{
    Hal_SC_set_FRCM_WBase0(pInstance, u32FRCM_WBase0, eWindow);
    Hal_SC_set_FRCM_WBase1(pInstance, u32FRCM_WBase1, eWindow);
    Hal_SC_set_FRCM_WBase2(pInstance, u32FRCM_WBase2, eWindow);
    Hal_SC_set_FRCM_RBase0(pInstance, u32FRCM_RBase0, eWindow);
    Hal_SC_set_FRCM_RBase1(pInstance, u32FRCM_RBase1, eWindow);
    Hal_SC_set_FRCM_RBase2(pInstance, u32FRCM_RBase2, eWindow);
}

void Hal_SC_set_dual_memoryaddress(void *pInstance, MS_PHY u32DNRBase0, MS_PHY u32DNRBase1, MS_PHY u32DNRBase2, MS_PHY u32OPMBase0, MS_PHY u32OPMBase1, MS_PHY u32OPMBase2, SCALER_WIN eWindow)
{
    Hal_SC_set_Dual_DNRBase0(pInstance, u32DNRBase0, eWindow);
    Hal_SC_set_Dual_DNRBase1(pInstance, u32DNRBase1, eWindow);
    Hal_SC_set_Dual_DNRBase2(pInstance, u32DNRBase2, eWindow);
    Hal_SC_set_Dual_OPMBase0(pInstance, u32OPMBase0, eWindow);
    Hal_SC_set_Dual_OPMBase1(pInstance, u32OPMBase1, eWindow);
    Hal_SC_set_Dual_OPMBase2(pInstance, u32OPMBase2, eWindow);
}

static void Hal_SC_set_miu0mask(MS_BOOL bMask, EN_XC_MIUCLIENT_CONTROLTYPE enControlType)
{
    if(bMask)
    {
        if(enControlType == EN_XC_MIUCLIENT_IPOP)
        {
            //G6 (0 1)
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_IPMAIN_R);
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_OPMAIN_R);

            //G7 (0 1)
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_IPMAIN_W);
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_OPMAIN_W);
        }
        else if(enControlType == EN_XC_MIUCLIENT_HSE)
        {
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_HSE_R);
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_HSE_W);
        }
        else
        {
            //G6 (0 1 2 5 12)
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_IPMAIN_R);
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_OPMAIN_R);
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_DS_R);
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_ADL_R);
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_MCDI_R);

            //G7 (0 1 8 12)
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_IPMAIN_W);
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_OPMAIN_W);
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_AUL_W);
            MDrv_MIU_MaskReq(E_MIU_0, MIU_CLIENT_SC_MCDI_W);
        }
    }
    else
    {
        if(enControlType == EN_XC_MIUCLIENT_IPOP)
        {
            //G6 (0 1 )
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_IPMAIN_R);
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_OPMAIN_R);

            //G7 (0 1)
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_IPMAIN_W);
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_OPMAIN_W);
        }
        else if(enControlType == EN_XC_MIUCLIENT_HSE)
        {
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_HSE_R);
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_HSE_W);
        }
        else
        {
            //G6 (0 1 2 5 12)
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_IPMAIN_R);
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_OPMAIN_R);
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_DS_R);
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_ADL_R);
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_MCDI_R);
            //G7 (0 1 8 12)
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_IPMAIN_W);
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_OPMAIN_W);
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_AUL_W);
            MDrv_MIU_UnMaskReq(E_MIU_0, MIU_CLIENT_SC_MCDI_W);
        }

    }
}
void Hal_SC_Enable_MiuMask(void *pInstance, SCALER_WIN enWindow, EN_XC_MIUCLIENT_CONTROLTYPE enControlType)
{
    Hal_SC_set_miu0mask(TRUE, enControlType);
}
void Hal_SC_Disable_MiuMask(void *pInstance, SCALER_WIN enWindow, EN_XC_MIUCLIENT_CONTROLTYPE enControlType)
{
    Hal_SC_set_miu0mask(FALSE, enControlType);
}

void Hal_SC_set_miusel(void *pInstance, MS_U8 u8MIUSel, SCALER_WIN UNUSED_PARA(enWindow))
{
    // Scaler control MIU by itself
    // So MIU1 IP-select is set to 1. At this moment, MIU0 Miu select is not working.
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if (u8MIUSel==0)
    {
        ///SCM
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_05_L, 0x0000, 0x0010);     // reg_miu_select_f2 to MIU0
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_05_L, 0x0000, 0x0010);     // reg_miu_select_f2 to MIU0
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_44_L, 0x0000, 0x4000);     // reg_miu_select_f1 to MIU0
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_44_L, 0x0000, 0x4000);     // reg_miu_select_f1 to MIU0
    }
    else if(u8MIUSel==1)
    {
        ///SCM
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_05_L, 0x0010, 0x0010);     // reg_miu_select_f2 to MIU1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_05_L, 0x0000, 0x0010);     // reg_miu_select_f2 to MIU1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_44_L, 0x4000, 0x4000);     // reg_miu_select_f1 to MIU1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_44_L, 0x0000, 0x4000);     // reg_miu_select_f1 to MIU1
    }
    else
    {
        printf("[XC][MIUSEL]u8MIUSel Err!!\n");
    }
}

void Hal_SC_get_miusel(void *pInstance, SC_MIUSEL_t* stMIUSel, SCALER_WIN UNUSED_PARA(enWindow))
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_05_L, BIT(4)))
    {
        stMIUSel-> u8MainFBSel = 1;
    }
    else
    {
        if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_05_L, BIT(4)))
        {
            stMIUSel-> u8MainFBSel = 2;
        }
        else
        {
            stMIUSel-> u8MainFBSel = 0;
        }
    }

    if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_05_L, BIT(4)))
    {
        stMIUSel-> u8SubFBSel = 1;
    }
    else
    {
        if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK31_05_L, BIT(4)))
        {
            stMIUSel-> u8SubFBSel = 2;
        }
        else
        {
            stMIUSel-> u8SubFBSel = 0;
        }
    }
}

void Hal_SC_set_dual_miusel(void *pInstance, MS_U8 u8MIUSel)
{
    // Scaler control MIU by itself
    // So MIU1 IP-select is set to 1. At this moment, MIU0 Miu select is not working.
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    // Dual just support scaler0, main only
    if (psXCInstPri->u32DeviceID > 0)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] scmi dual mode just support scaler0 main only.\n",__func__,__LINE__);
        return;
    }
#if 0 // remove and decided by miu_setting.txt
    // MIU 1, GROUP0~5: 0x78~0x7D
    MDrv_WriteByteMask(REG_MIU1_BASE + 0xF2, 0x60, 0x60); // IP select, group1, for [5]DIPW, [6]LD
    MDrv_WriteByteMask(REG_MIU1_BASE + 0xF3, 0x80, 0x80); // IP select, group1, for [f]MC2D
    MDrv_WriteByteMask(REG_MIU1_BASE + 0xFA, 0xE0, 0xE0); // IP select, group5
    MDrv_WriteByteMask(REG_MIU1_BASE + 0xFB, 0xF7, 0xF7); // IP select, group5
#endif

#if (MIU_SEL_USE_XC_INTERNAL == TRUE) // MIU select ctorled by xc internal
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_11_L, BIT(0) | BIT(1), BIT(0) | BIT(1));
    if (u8MIUSel==0)
    {
        ///SCM
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_05_L, 0x0000, 0x0010);     // reg_miu_select_f2 to MIU0
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK51_05_L, 0x0000, 0x0010);     // reg_miu_select_f2 to MIU0
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_44_L, 0x0000, 0x4000);     // reg_miu_select_f1 to MIU0
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK51_44_L, 0x0000, 0x4000);     // reg_miu_select_f1 to MIU0
    }
    else if(u8MIUSel==1)
    {
        ///SCM
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_05_L, 0x0010, 0x0010);     // reg_miu_select_f2 to MIU1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK51_05_L, 0x0000, 0x0010);     // reg_miu_select_f2 to MIU1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_44_L, 0x4000, 0x4000);     // reg_miu_select_f1 to MIU1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK51_44_L, 0x0000, 0x4000);     // reg_miu_select_f1 to MIU1
    }
    else if(u8MIUSel==2)
    {
        ///SCM
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_05_L, 0x0000, 0x0010);     // reg_miu_select_f2 to MIU1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK51_05_L, 0x0010, 0x0010);     // reg_miu_select_f2 to MIU1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK52_44_L, 0x0000, 0x4000);     // reg_miu_select_f1 to MIU1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK51_44_L, 0x4000, 0x4000);     // reg_miu_select_f1 to MIU1
    }

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_10_L, 0x0, BIT(0) | BIT(1));
#else
    // When MIU select controlled by miu, IPM1 use: BK7F_19[0..1] Selecet miu chip select
    // When MIU select controlled by miu, OPM1 use: BK7F_19[2..3] Selecet miu chip select
    // 00'b: MIU0, 01'b: MIU1, 10'b: MIU2

    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK7F_19_L, (u8MIUSel << 2) | u8MIUSel , BIT(3)| BIT(2) | BIT(1)| BIT(0));
#endif
}

void Hal_SC_set_dual_disable(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    // Dual just support scaler0, main only
    if (psXCInstPri->u32DeviceID > 0)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] scmi dual mode just support scaler0 main only.\n",__func__,__LINE__);
        return;
    }

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_29_L, 0, BIT(15)); // reg_miu_select_f1 to MIU1
}

void Hal_SC_get_dual_miusel(void *pInstance, SC_MIUSEL_t* stMIUSel)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    // Dual just support scaler0, main only
    if (psXCInstPri->u32DeviceID > 0)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] scmi dual mode just support scaler0 main only.\n",__func__,__LINE__);
        return;
    }
#if (MIU_SEL_USE_XC_INTERNAL == TRUE) // MIU Select control by xc internal
    if(SC_R2BYTEMSK(0, REG_SC_BK52_05_L, BIT(4)))
    {
        stMIUSel->u8MainFBSel = 1;
    }
    else
    {
        if(SC_R2BYTEMSK(0, REG_SC_BK51_05_L, BIT(4)))
        {
            stMIUSel->u8MainFBSel = 2;
        }
        else
        {
            stMIUSel->u8MainFBSel = 0;
        }
    }

    if(SC_R2BYTEMSK(0, REG_SC_BK52_44_L, BIT(4)))
    {
        stMIUSel->u8SubFBSel = 1;
    }
    else
    {
        if(SC_R2BYTEMSK(0, REG_SC_BK51_44_L, BIT(4)))
        {
            stMIUSel->u8SubFBSel = 2;
        }
        else
        {
            stMIUSel->u8SubFBSel = 0;
        }
    }
#else // MIU Select control by miu
    MS_U16 u16Tmp = SC_R2BYTEMSK(0, REG_SC_BK7F_19_L, BIT(0)|BIT(1));
    stMIUSel->u8MainFBSel = (MS_U8)(u16Tmp & 0xff);
#endif
}

void Hal_SC_set_blsk(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_21_L, bEn ? BIT(12) : 0, BIT(12));
}

void Hal_SC_set_blsk_burst(void *pInstance, MS_BOOL bEn)
{
    _MLOAD_ENTRY(pInstance);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_21_L, bEn ? BIT(12) : 0, BIT(12));
    MDrv_XC_MLoad_Fire(pInstance, TRUE);
    _MLOAD_RETURN(pInstance);
}

void Hal_SC_set_main_black_screen_burst(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    _MLOAD_ENTRY(pInstance);

    ST_XC_MENULOAD_INFO stMenuloadInfo;
    memset(&stMenuloadInfo,0,sizeof(ST_XC_MENULOAD_INFO));

    ST_XC_REGISTER stReg;
    stReg.u32Bank = 0x1300;
    stReg.u32Addr = REG_SC_BK10_19_L;
    stReg.u16Data = (bEn ? BIT(1) : 0);
    stReg.u16Mask = BIT(1);

    stMenuloadInfo.enMloadClient = E_XC_2DMLOAD_MAIN_XC;
    stMenuloadInfo.enMloadTrigger = E_XC_2DMLOAD_TRIGGER_BY_OP2_SYNC;
    stMenuloadInfo.pstReg = &stReg;
    stMenuloadInfo.u32Count = 1;

    MDrv_XC_WriteReginVsyncBlank(pInstance,&stMenuloadInfo,MAIN_WINDOW);
    MDrv_XC_FireReginVsyncBlank(pInstance,E_XC_2DMLOAD_MAIN_XC,E_XC_2DMLOAD_TRIGGER_BY_OP2_SYNC,MAIN_WINDOW);

    //2D menuload need
    MS_U32 u32Timeout = 0;
    while(((SC_R2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK10_19_L, BIT(1))) >>1) != bEn)
    {
       MsOS_DelayTask(1);
       u32Timeout +=1;
       if(u32Timeout > 200)
       {
           printf("[%s,%d] Timeout bEn = %d\n",__FUNCTION__,__LINE__,bEn);
           break;
       }
    }
    _MLOAD_RETURN(pInstance);
}

void Hal_SC_set_main_sub_black_screen_burst(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    _MLOAD_ENTRY(pInstance);

    ST_XC_MENULOAD_INFO stMenuloadInfo;
    memset(&stMenuloadInfo,0,sizeof(ST_XC_MENULOAD_INFO));

    ST_XC_REGISTER stReg;
    stReg.u32Bank = 0x1300;
    stReg.u32Addr = REG_SC_BK10_19_L;
    stReg.u16Data = (bEn ? (BIT(5)|BIT(1)) : 0);
    stReg.u16Mask = (BIT(6)|BIT(5)|BIT(1));

    stMenuloadInfo.enMloadClient = E_XC_2DMLOAD_MAIN_XC;
    stMenuloadInfo.enMloadTrigger = E_XC_2DMLOAD_TRIGGER_BY_OP2_SYNC;
    stMenuloadInfo.pstReg = &stReg;
    stMenuloadInfo.u32Count = 1;

    MDrv_XC_WriteReginVsyncBlank(pInstance,&stMenuloadInfo,MAIN_WINDOW);
    MDrv_XC_FireReginVsyncBlank(pInstance,E_XC_2DMLOAD_MAIN_XC,E_XC_2DMLOAD_TRIGGER_BY_OP2_SYNC,MAIN_WINDOW);

    //2D menuload need
    MS_U32 u32Timeout = 0;

    while(((SC_R2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK10_19_L, BIT(1))) >>1) != bEn)
    {
       MsOS_DelayTask(1);
       u32Timeout +=1;
       if(u32Timeout > 200)
       {
           printf("[%s,%d] Timeout bEn = %d\n\n",__FUNCTION__,__LINE__,bEn);
           break;
       }
    }

    _MLOAD_RETURN(pInstance);
}

void Hal_SC_set_main_black_screen(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_19_L, bEn ? BIT(1) : 0, BIT(1));
}

void Hal_SC_set_main_sub_black_screen(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_19_L, bEn ? (BIT(5)|BIT(1)) : 0, (BIT(6)|BIT(5)|BIT(1)));
}

void Hal_SC_set_sub_blue_screen_burst(void *pInstance, MS_BOOL bEn, MS_BOOL bBlue)
{
    _MLOAD_ENTRY(pInstance);

    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_19_L, bBlue ? BIT(6) : 0, BIT(6));
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_19_L, bEn ? BIT(5) : 0, BIT(5));
    MDrv_XC_MLoad_Fire(pInstance, TRUE);

    _MLOAD_RETURN(pInstance);
}

void Hal_SC_set_sub_blue_screen(void *pInstance, MS_BOOL bEn, MS_BOOL bBlue)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_19_L, bBlue ? BIT(6) : 0, BIT(6));
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_19_L, bEn ? BIT(5) : 0, BIT(5));
}

E_APIXC_ReturnValue Hal_SC_IP_Memory_Write_Request(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return E_APIXC_RET_FAIL;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    if(MAIN_WINDOW == eWindow)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, bEnable? 0 : BIT(0) , BIT(0));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_47_L, bEnable? 0 : BIT(0) , BIT(0));
    }

    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue Hal_SC_IP_Memory_Read_Request(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return E_APIXC_RET_FAIL;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    if(MAIN_WINDOW == eWindow)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_02_L, bEnable? 0 : BIT(14) , BIT(14));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_42_L, bEnable? 0 : BIT(14) , BIT(14));
    }
    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue Hal_SC_OP_Memory_Write_Request(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_67_L, bEnable? 0 : BIT(1) , BIT(1));//This will stop OPW and OP memory write request
    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue Hal_SC_frcmw_Memory_Write_Request(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return E_APIXC_RET_FAIL;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    if(MAIN_WINDOW == eWindow)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_07_L, bEnable? 0 : BIT(0) , BIT(0));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_47_L, bEnable? 0 : BIT(0) , BIT(0));
    }
    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue Hal_SC_frcmr_Memory_Read_Request(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    return E_APIXC_RET_OK;
}

void Hal_SC_disable_inputsource_burst(void *pInstance, MS_BOOL bDisable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    _MLOAD_ENTRY(pInstance);

    // HW PIP architeucture
    // Becasue BK3_02[8] and BK20_11[15] can not be enabled toghter,
    // otherwise garbage will be showed,we need to use BK12_47[0] to instead.
    if( eWindow == MAIN_WINDOW )
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        MDrv_XC_MLoad_WriteCmd(pInstance, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_02_L, eWindow), (bDisable ? BIT(7):0), BIT(7));
#else
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK01_02_L, (bDisable ? BIT(7):0), BIT(7));
#endif
    }
    else
    {
        //MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK03_02_L, (bDisable ? BIT(7):0), BIT(7));
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_47_L, (bDisable ? BIT(0) : 0), BIT(0));
#if (HW_DESIGN_4K2K_VER == 4)
        if ((psXCInstPri->u32DeviceID==0)
            && !(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE))
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK32_47_L, (bDisable ? BIT(0) : 0), BIT(0));
        }
#endif
    }
    MDrv_XC_MLoad_Fire(pInstance, TRUE);
    _MLOAD_RETURN(pInstance);
}

void Hal_SC_disable_inputsource(void *pInstance, MS_BOOL bDisable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if( eWindow == MAIN_WINDOW )
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_02_L, eWindow), (bDisable ? BIT(7):0), BIT(7));
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_02_L, (bDisable ? BIT(7):0), BIT(7));
#endif
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_02_L, (bDisable ? BIT(7):0), BIT(7));
    }
}


MS_U16 Hal_SC_Is_InputSource_Disable(void *pInstance, SCALER_WIN eWindow)
{
    MS_U16 u16Ret = 0;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        u16Ret = (SC_R2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_02_L, eWindow))&0x80);
#else
        u16Ret = (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_02_L)&0x80);
#endif
    }
    else
    {
        if((SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_47_L)&0x01) == 0)
        {
            u16Ret = (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_02_L)&0x80);
        }
        else
        {
            u16Ret = TRUE;
        }
    }
    return u16Ret;
}


void Hal_SC_set_nosignal_color(void *pInstance, MS_U8 u8Color,SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if (MDrv_XC_MLoad_GetStatus(pInstance) == E_MLOAD_ENABLED)
    {
        //FIX ME:need follow HW_DESIGN_4K2K_VER = 6 rule
        _MLOAD_ENTRY(pInstance);
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
        if(psXCInstPri->u32DeviceID == 0)
#else
        if ( eWindow == MAIN_WINDOW )
#endif
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_24_L, u8Color, LBMASK);
        }
        else
        {
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
            MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_17_L, ((MS_U16)u8Color)<<8, HBMASK);
#else
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_17_L, ((MS_U16)u8Color)<<8, HBMASK);
#endif
        }
        MDrv_XC_MLoad_Fire(pInstance, TRUE);
        _MLOAD_RETURN(pInstance);
    }
    else
    {
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
        if(psXCInstPri->u32DeviceID == 0)
#else
        if ( eWindow == MAIN_WINDOW )
#endif
        {
#ifdef new_chakra
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_24_L, u8Color, LBMASK);
#else
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_24_L, u8Color, LBMASK);
#endif
        }
        else
        {
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
            SC_W2BYTEMSK(0, REG_SC_BK0F_17_L, ((MS_U16)u8Color)<<8, HBMASK);
#else
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_17_L, ((MS_U16)u8Color)<<8, HBMASK);
#endif
        }
    }
}

void Hal_SC_set_fbl(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, (bEn ? 0x3:0), 0x3); //F2 IP read/write request disable
}

MS_BOOL Hal_SC_get_fbl(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    return SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_01_L, BIT(7));  //Enable/Disable FBL
}

void Hal_SC_set_freezeimg_burst(void *pInstance, MS_BOOL bEn, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

#if FRC_INSIDE
    if((eWindow == MAIN_WINDOW) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFRCEnabled))
    {
        MHal_FRC_Set_FreezeImg(bEn);
    }
#endif
    _MLOAD_ENTRY(pInstance);
#if (HW_DESIGN_4K2K_VER == 4)
    if( eWindow == MAIN_WINDOW )
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_01_L, (bEn<<11), BIT(11));
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK32_01_L, (bEn<<11), BIT(11));
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_41_L, (bEn<<11), BIT(11));
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK32_41_L, (bEn<<11), BIT(11));
    }
#else
    if( eWindow == MAIN_WINDOW )
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_01_L, (bEn<<11), BIT(11));
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_41_L, (bEn<<11), BIT(11));
    }
#endif
    MDrv_XC_MLoad_Fire(pInstance, TRUE);
    _MLOAD_RETURN(pInstance);
}


void Hal_SC_set_freezeimg(void *pInstance, MS_BOOL bEn, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

#if FRC_INSIDE
    if((eWindow == MAIN_WINDOW) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFRCEnabled))
    {
        MHal_FRC_Set_FreezeImg(bEn);
    }
#endif
#if (HW_DESIGN_4K2K_VER == 4)
    if( eWindow == MAIN_WINDOW )
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_01_L, (bEn<<11), BIT(11));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_01_L, (bEn<<11), BIT(11));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_41_L, (bEn<<11), BIT(11));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_41_L, (bEn<<11), BIT(11));
    }
#else
    if( eWindow == MAIN_WINDOW )
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_01_L, (bEn<<11), BIT(11));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_41_L, (bEn<<11), BIT(11));
    }
#endif
}

void Hal_SC_set_frcm_freezeimg(void *pInstance, MS_BOOL bEn, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if( eWindow == MAIN_WINDOW )
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_01_L, (bEn<<11), BIT(11));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_41_L, (bEn<<11), BIT(11));
    }
}

MS_BOOL Hal_SC_get_freezeimg(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
#if (HW_DESIGN_4K2K_VER == 4)
    if( eWindow == MAIN_WINDOW )
    {
        return (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_01_L, BIT(11)) ? TRUE: FALSE);
    }
    else
    {
        return (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_41_L, BIT(11)) ? TRUE: FALSE);
    }
#else
    if( eWindow == MAIN_WINDOW )
    {
        return (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_01_L, BIT(11)) ? TRUE: FALSE);
    }
    else
    {
        return (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_41_L, BIT(11)) ? TRUE: FALSE);
    }
#endif
}

void Hal_SC_exwith_miuprotect_swreset(void *pInstance, MS_U8 x, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    //reset IP1F2
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    //select pattern generator source
    MHal_XC_FSS_IpSoftwareReset(pInstance, eWindow, x, x);
    //select pattern generator source
    MHal_XC_FSS_IpSoftwareReset(pInstance, eWindow, 0, x);
#else
    //select pattern generator source
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK00_02_L, x, x);
    //MsOS_DelayTask(2);

    //select pattern generator source
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK00_02_L, 0, x);
    //MsOS_DelayTask(2);
#endif
}

void Hal_SC_ip_Init_for_internal_timing(void *pInstance, XC_Internal_TimingType timingtype, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == SUB_WINDOW)
    {
        if(Hal_SC_ip_get_IPAutoNoSignal(pInstance, eWindow)) Hal_SC_ip_set_IPAutoNoSignal(pInstance, DISABLE, eWindow);

        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_02_L, 0x104) ;  //Video source
        Hal_SC_exwith_miuprotect_swreset(pInstance, REST_IP_F1, eWindow);  //when source is changed, we must reset it to make it work
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_03_L, 0x890);

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_21_L, 0x01, 0x03);   //force progressive mode
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_0E_L, BIT(15), BIT(15));   //auto gain 10bit

        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_04_L, 0x020);  //capture V start
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_05_L, 0x50) ;  //capture H start

        switch (timingtype)
        {
            case E_XC_480P:
            default:

                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_06_L, 0x1c0) ; // V size
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_07_L, 0x280) ; // h size

                break;
            case E_XC_720P:
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_06_L, 0x290) ; // V size (720 - 64) = 656 = 0x290
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_07_L, 0x460) ; // h size (1280 - 160) = 1120 = 0x460

                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4E_L, 0x0800); //DNR Offset
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4F_L, 0x0460); //DNR Fetch
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_56_L, 0x0800); //OPM Offsest
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_57_L, 0x0460); //OPM Fetch

                break;
            case E_XC_1080P:
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_06_L, 0x3F8) ; // V size (1080 - 64) = 1016 = 0x3F8
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_07_L, 0x6E0) ; // h size (1920 - 160) = 1760 = 0x6E0

                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4E_L, 0x0800); //DNR Offset
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4F_L, 0x06E0); //DNR Fetch
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_56_L, 0x0800); //OPM Offsest
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_57_L, 0x06E0); //OPM Fetch
                break;
        }
    }
    else
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        if(Hal_SC_ip_get_IPAutoNoSignal(pInstance, eWindow)) Hal_SC_ip_set_IPAutoNoSignal(pInstance, DISABLE, eWindow);

        SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_02_L, eWindow), 0x104) ;  //Video source
        Hal_SC_exwith_miuprotect_swreset(pInstance, REST_IP_F2, eWindow);  //when source is changed, we must reset it to make it work
        SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_03_L, eWindow), 0x890);

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_21_L, eWindow), 0x01, 0x03);   //force progressive mode
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_0E_L, eWindow), BIT(15), BIT(15));   //auto gain 10bit

        SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_04_L, eWindow), 0x020);  //capture V start
        SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_05_L, eWindow), 0x50) ;  //capture H start

        switch (timingtype)
        {
            case E_XC_480P:
            default:

                SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_06_L, eWindow), 0x1c0) ; // V size
                SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_07_L, eWindow), 0x280) ; // h size

                break;
            case E_XC_720P:
                SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_06_L, eWindow), 0x290) ; // V size (720 - 64) = 656 = 0x290
                SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_07_L, eWindow), 0x460) ; // h size (1280 - 160) = 1120 = 0x460

                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0E_L, 0x0800); //DNR Offset
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0F_L, 0x0460); //DNR Fetch
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_16_L, 0x0800); //OPM Offsest
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_17_L, 0x0460); //OPM Fetch

                break;
            case E_XC_1080P:
                SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_06_L, eWindow), 0x3F8) ; // V size (1080 - 64) = 1016 = 0x3F8
                SC_W2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_07_L, eWindow), 0x6E0) ; // h size (1920 - 160) = 1760 = 0x6E0

                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0E_L, 0x0800); //DNR Offset
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0F_L, 0x06E0); //DNR Fetch
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_16_L, 0x0800); //OPM Offsest
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_17_L, 0x06E0); //OPM Fetch
                break;
        }
#else
        if(Hal_SC_ip_get_IPAutoNoSignal(pInstance, eWindow)) Hal_SC_ip_set_IPAutoNoSignal(pInstance, DISABLE, eWindow);

        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_02_L, 0x104) ;  //Video source
        Hal_SC_exwith_miuprotect_swreset(pInstance, REST_IP_F2, eWindow);  //when source is changed, we must reset it to make it work
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_03_L, 0x890);

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_21_L, 0x01, 0x03);   //force progressive mode
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_0E_L, BIT(15), BIT(15));   //auto gain 10bit

        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_04_L, 0x020);  //capture V start
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_05_L, 0x50) ;  //capture H start

        switch (timingtype)
        {
            case E_XC_480P:
            default:

                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_06_L, 0x1c0) ; // V size
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_07_L, 0x280) ; // h size

                break;
            case E_XC_720P:
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_06_L, 0x290) ; // V size (720 - 64) = 656 = 0x290
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_07_L, 0x460) ; // h size (1280 - 160) = 1120 = 0x460

                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0E_L, 0x0800); //DNR Offset
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0F_L, 0x0460); //DNR Fetch
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_16_L, 0x0800); //OPM Offsest
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_17_L, 0x0460); //OPM Fetch

                break;
            case E_XC_1080P:
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_06_L, 0x3F8) ; // V size (1080 - 64) = 1016 = 0x3F8
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_07_L, 0x6E0) ; // h size (1920 - 160) = 1760 = 0x6E0

                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0E_L, 0x0800); //DNR Offset
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0F_L, 0x06E0); //DNR Fetch
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_16_L, 0x0800); //OPM Offsest
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_17_L, 0x06E0); //OPM Fetch
                break;
        }
#endif
    }
}

MS_U16 Hal_SC_rgb_average_info(void *pInstance, MS_U16 u16mask, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U16 u16value;

    if(eWindow == MAIN_WINDOW)
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_0F_L, eWindow), u16mask, 0x0F);
        u16value=SC_R2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_11_L, eWindow));
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_0F_L, u16mask, 0x0F);
        u16value=SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_11_L);
#endif
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_0F_L, u16mask, 0x0F);
        u16value=SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_11_L);
    }

    return u16value;
}


void Hal_SC_autogain_enable(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    //auto gain enable
    if(eWindow == MAIN_WINDOW)
    {
        if(bEnable)
        {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_0E_L, eWindow), 0x11, 0x11);
#else
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_0E_L, 0x11, 0x11);
#endif
        }
        else
        {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_0E_L, eWindow), 0x00, 0x11);
#else
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_0E_L, 0x00, 0x11);
#endif
        }
    }
    else
    {
        if(bEnable)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_0E_L, 0x11, 0x11);
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_0E_L, 0x00, 0x11);
        }
    }
}

MS_BOOL Hal_SC_autogain_status(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_BOOL bvalue;
    if(eWindow == MAIN_WINDOW)
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        bvalue = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_0E_L, eWindow), BIT(1));
#else
        bvalue = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_0E_L, BIT(1));
#endif
    }
    else
    {
        bvalue = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_0E_L, BIT(1));
    }

    return bvalue;

}

void Hal_SC_set_mirror(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U32 u32NoSigReg, u32MirrorReg;

    if(eWindow == MAIN_WINDOW)
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        u32NoSigReg = MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_02_L, eWindow);
#else
        u32NoSigReg = REG_SC_BK01_02_L;
#endif
        u32MirrorReg = REG_SC_BK12_03_L;
    }
    else
    {
        u32NoSigReg = REG_SC_BK03_02_L;
        u32MirrorReg = REG_SC_BK12_43_L;

    }

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32NoSigReg, BIT(7), BIT(7));

    if( bEnable )
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32MirrorReg, (BIT(12)|BIT(13)), (BIT(12)|BIT(13)));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32MirrorReg, 0x0, (BIT(12)|BIT(13)));
    }
}

void Hal_SC_set_frcm_mirror(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U32 u32NoSigReg = 0, u32MirrorReg = 0;

    if(eWindow == MAIN_WINDOW)
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        u32NoSigReg = MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_02_L, eWindow);
#else
        u32NoSigReg = REG_SC_BK01_02_L;
#endif
        u32MirrorReg = REG_SC_BK32_03_L;
    }
    else
    {
        u32NoSigReg = REG_SC_BK03_02_L;
        u32MirrorReg = REG_SC_BK32_43_L;
    }

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32NoSigReg, BIT(7), BIT(7));

    if( bEnable )
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32MirrorReg, (BIT(12)|BIT(13)), (BIT(12)|BIT(13)));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u32MirrorReg, 0x0, (BIT(12)|BIT(13)));
    }
}

MS_U16 Hal_SC_GetAVDStatus(void)
{
    return MDrv_Read2Byte(L_BK_AFEC(0x66));
}

void Hal_SC_set_rep_window(void *pInstance, MS_BOOL bEnable,MS_U16 x,MS_U16 y,MS_U16 w,MS_U16 h,MS_U8 u8Color)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_57_L, bEnable?BIT(9):0x0, BIT(9));
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_42_L,x);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_43_L,x + w);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_44_L,y);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_45_L,y + h);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_46_L, (~u8Color)<<8, 0xFF00);
}

//--------------------------------------------------
//update display window registers with input window
//IN:
//   pdspwin: input window info
//--------------------------------------------------
void Hal_SC_set_disp_window(void *pInstance, SCALER_WIN eWindow, MS_WINDOW_TYPE *pdspwin)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_WINDOW_TYPE stDspwin;
    memset(&stDspwin, 0, sizeof(MS_WINDOW_TYPE));

#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
    MS_U16 u16HDEStart = SC_R2BYTE(0, REG_SC_BK10_04_L);
    MS_U32 u32Sc1OneLineDly = (SC_R2BYTE(0, REG_SC_BK10_0C_L) + 1)/2;
    MS_U32 u32Sc1TGEN_Dly = 0;
    if (SC_R2BYTEMSK(0, REG_SC_BK68_50_L, BIT(3)) == 0)
    {
        MS_U32 u32STGEN_Dly = VIP_SC0_V_DLY*u32Sc1OneLineDly+VIP_SC0_H_DLY;
        MS_U32 u32Sc0TGEN_Dly = u32STGEN_Dly + TGEN_SC0_DLY;
        MS_U32 u32Sc1VIP_Dly = VIP_SC1_V_DLY*u32Sc1OneLineDly + VIP_SC1_H_DLY;
        if (u32Sc0TGEN_Dly > u32Sc1VIP_Dly + SC1_PRE_RUN_DLY)
        {
            u32Sc1TGEN_Dly = u32Sc0TGEN_Dly - u32Sc1VIP_Dly - SC1_PRE_RUN_DLY;
        }
        else
        {
            u32Sc1TGEN_Dly = u32Sc0TGEN_Dly + u32Sc1OneLineDly - u32Sc1VIP_Dly - SC1_PRE_RUN_DLY;
        }
    }
    else
    {
        MS_U32 u32STGEN_Dly = VIP_SC0_USER_MODE_V_DLY*u32Sc1OneLineDly+VIP_SC0_USER_MODE_H_DLY;
        MS_U32 u32Sc0TGEN_Dly = u32STGEN_Dly + TGEN_SC0_USER_MODE_DLY;
        MS_U32 u32HComp = (pdspwin->x - u16HDEStart)/2;
        MS_U32 u32Sc1VIP_Dly = VIP_SC1_V_DLY*u32Sc1OneLineDly + VIP_SC1_H_DLY;
        u32Sc1TGEN_Dly = u32Sc0TGEN_Dly - u32Sc1VIP_Dly - SC1_PRE_RUN_DLY + u32HComp;
    }
#endif
    //FIX ME:need follow HW_DESIGN_4K2K_VER = 6 rule
    if (MDrv_XC_MLoad_GetStatus(pInstance) == E_MLOAD_ENABLED)
    {
        _MLOAD_ENTRY(pInstance);

        if(eWindow == MAIN_WINDOW)
        {
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
            if (psXCInstPri->u32DeviceID == 1)
            {
                //Display window
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_08_L, u16HDEStart/2, VOP_DISPLAY_HSTART_MASK);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_09_L, (u16HDEStart/2+pdspwin->width-1), VOP_DISPLAY_HEND_MASK);
                if (Hal_SC_NeedXCH8Align(pInstance))
                {
                    stDspwin.x = u16HDEStart / 2;
                    stDspwin.width = pdspwin->width;
                }
                // Maxim: Copy MDE to FDE for SC1 case
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_04_L, u16HDEStart/2, VOP_DISPLAY_HSTART_MASK);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_05_L, (u16HDEStart/2+pdspwin->width-1), VOP_DISPLAY_HEND_MASK);
            }
            else
            {
                //Display window
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_08_L, (MS_U16)(pdspwin->x>>00), VOP_DISPLAY_HSTART_MASK);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_09_L, (MS_U16)((pdspwin->x+pdspwin->width-1)>>00), VOP_DISPLAY_HEND_MASK);
                if (Hal_SC_NeedXCH8Align(pInstance))
                {
                    stDspwin.x = pdspwin->x;
                    stDspwin.width = pdspwin->width;
                }
            }
            if(Hal_SC_3D_IsDualViewMode(pInstance,MAIN_WINDOW) && (E_XC_3D_OUTPUT_TOP_BOTTOM == MDrv_XC_Get_3D_Output_Mode(pInstance)))
            {
                if (IsVMirrorMode(eWindow))
                {
                    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0A_L, (MS_U16)(pdspwin->y+(pdspwin->height)/2), VOP_DISPLAY_VSTART_MASK);
                    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0B_L, (MS_U16)(pdspwin->y+(pdspwin->height)-1), VOP_DISPLAY_VEND_MASK);
                }
                else
                {
                    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0A_L, (MS_U16)(pdspwin->y), VOP_DISPLAY_VSTART_MASK);
                    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0B_L, (MS_U16)(pdspwin->y+(pdspwin->height)/2-1), VOP_DISPLAY_VEND_MASK);
                }
            }
            else
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0A_L, (MS_U16)(pdspwin->y), VOP_DISPLAY_VSTART_MASK);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0B_L, (MS_U16)(pdspwin->y+pdspwin->height-1), VOP_DISPLAY_VEND_MASK);
                if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
                {
                    stDspwin.y = pdspwin->y;
                    stDspwin.height = pdspwin->height;
                }
            }
            if (psXCInstPri->u32DeviceID == 1)
            {
                // Maxim: Copy MDE to FDE for SC1 case
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_06_L, (MS_U16)(pdspwin->y), VOP_DISPLAY_VSTART_MASK);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_07_L, (MS_U16)(pdspwin->y+pdspwin->height-1), VOP_DISPLAY_VEND_MASK);
            }

            if (psXCInstPri->u32DeviceID == 1)//follow HW_DESIGN_4K2K_VER = 6 rule
            {
                //Display window
                MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_07_L, (MS_U16)(pdspwin->x>>00), VOP_DISPLAY_HSTART_MASK);
                MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_08_L, (MS_U16)((pdspwin->x+pdspwin->width-1)>>00), VOP_DISPLAY_HEND_MASK);
                if(Hal_SC_3D_IsDualViewMode(pInstance,MAIN_WINDOW) && (E_XC_3D_OUTPUT_TOP_BOTTOM == MDrv_XC_Get_3D_Output_Mode(pInstance)))
                {
                    if (IsVMirrorMode(eWindow))
                    {
                        MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_09_L, (MS_U16)(pdspwin->y), 0xFFFF);
                        MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_0A_L, (MS_U16)(pdspwin->y+pdspwin->height/2-1), 0xFFFF);
                    }
                    else
                    {
                        MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_09_L, (MS_U16)(pdspwin->y+(pdspwin->height)/2), 0xFFFF);
                        MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_0A_L, (MS_U16)(pdspwin->y+pdspwin->height-1), 0xFFFF);
                    }
                }
                else
                {
                    MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_09_L, (MS_U16)(pdspwin->y), 0xFFFF);
                    MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK0F_0A_L, (MS_U16)(pdspwin->y+pdspwin->height-1), 0xFFFF);
                }
                MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK68_61_L, (MS_U16)(u32Sc1TGEN_Dly%u32Sc1OneLineDly)*2, 0xFFFF);
                MDrv_XC_MLoad_WriteCmd(g_pDevice0Instance, REG_SC_BK68_62_L, (MS_U16)(u32Sc1TGEN_Dly/u32Sc1OneLineDly), 0xFFFF);
            }
#else

            //Display window
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_08_L, pdspwin->x,VOP_DISPLAY_HSTART_MASK);                  // Display H start
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_09_L, pdspwin->x+pdspwin->width-1,VOP_DISPLAY_HEND_MASK);   // Display H end
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0A_L, pdspwin->y,VOP_DISPLAY_VSTART_MASK);                  // Display V start
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK10_0B_L, pdspwin->y+pdspwin->height-1,VOP_DISPLAY_VEND_MASK);  // Display V end
            if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
            {
                stDspwin.x = pdspwin->x;
                stDspwin.width = pdspwin->width;
                stDspwin.y = pdspwin->y;
                stDspwin.height = pdspwin->height;
            }
#endif
            if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
            {
                Hal_SC_8AlignPatchBy2ndSDE(pInstance, TRUE, &stDspwin);
            }
        }
        else
        {
            //Display window
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_07_L, pdspwin->x,0x3FFF);                  // Display H start
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_08_L, pdspwin->x+pdspwin->width-1,0x3FFF);   // Display H end
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_09_L, pdspwin->y,0x1FFF);                  // Display V start
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_0A_L, pdspwin->y+pdspwin->height-1,0x1FFF);  // Display V end
        }

        MDrv_XC_MLoad_Fire(pInstance, TRUE);
        _MLOAD_RETURN(pInstance);
    }
    else
    {
        if(eWindow == MAIN_WINDOW)
        {
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
            //FIX ME:following HW_DESIGN_4K2K_VER = 6 rule
            //Display window
            if (psXCInstPri->u32DeviceID == 1)
            {
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_08_L, u16HDEStart/2);
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_09_L, (u16HDEStart/2+ pdspwin->width-1));
                if (Hal_SC_NeedXCH8Align(pInstance))
                {
                    stDspwin.x = u16HDEStart / 2;
                    stDspwin.width = pdspwin->width;
                }
                // Maxim: Copy MDE to FDE for SC1 case
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_04_L, u16HDEStart/2);
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_05_L, (u16HDEStart/2+ pdspwin->width-1));
            }
            else
            {
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_08_L, pdspwin->x);
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_09_L, pdspwin->x+pdspwin->width-1);
                if (Hal_SC_NeedXCH8Align(pInstance))
                {
                    stDspwin.x = pdspwin->x;
                    stDspwin.width = pdspwin->width;
                }
            }
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0A_L, pdspwin->y);
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0B_L, pdspwin->y+pdspwin->height-1);
            if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
            {
                stDspwin.y = pdspwin->y;
                stDspwin.height = pdspwin->height;
            }

            if (psXCInstPri->u32DeviceID == 1)
            {
                // Maxim: Copy MDE to FDE for SC1 case
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, pdspwin->y);
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, pdspwin->y+pdspwin->height-1);
            }

            if (psXCInstPri->u32DeviceID == 1)//follow HW_DESIGN_4K2K_VER = 6 rule
            {
                //Display window
                SC_W2BYTE(0, REG_SC_BK0F_07_L, pdspwin->x); // Display H start
                SC_W2BYTE(0, REG_SC_BK0F_08_L, pdspwin->x+pdspwin->width-1);   // Display H end
                SC_W2BYTE(0, REG_SC_BK0F_09_L, pdspwin->y); // Display V start
                SC_W2BYTE(0, REG_SC_BK0F_0A_L, pdspwin->y+pdspwin->height-1);   // Display V end
                SC_W2BYTE(0, REG_SC_BK68_61_L, (u32Sc1TGEN_Dly%u32Sc1OneLineDly)*2);
                SC_W2BYTE(0, REG_SC_BK68_62_L, u32Sc1TGEN_Dly/u32Sc1OneLineDly);

            }
#else
            //Display window
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_08_L, pdspwin->x);                  // Display H start
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_09_L, pdspwin->x+pdspwin->width-1);   // Display H end
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0A_L, pdspwin->y);                  // Display V start
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0B_L, pdspwin->y+pdspwin->height-1);  // Display V end
            if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
            {
                stDspwin.x = pdspwin->x;
                stDspwin.width = pdspwin->width;
                stDspwin.y = pdspwin->y;
                stDspwin.height = pdspwin->height;
            }
#endif
            if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
            {
                Hal_SC_8AlignPatchBy2ndSDE(pInstance, FALSE, &stDspwin);
            }
        }
        else
        {
            //Display window
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_07_L, pdspwin->x);                  // Display H start
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_08_L, pdspwin->x+pdspwin->width-1);   // Display H end
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_09_L, pdspwin->y);                  // Display V start
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_0A_L, pdspwin->y+pdspwin->height-1);  // Display V end
        }
    }
}

//--------------------------------------------------
//get display window registers setting
//OUT:
//   pdspwin: Pointer for ouput disp window register
//--------------------------------------------------
void Hal_SC_get_disp_window(void *pInstance, SCALER_WIN eWindow, MS_WINDOW_TYPE *pdspwin)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        //FIX ME:need follow HW_DESIGN_4K2K_VER = 6 rule
        //Display window
        pdspwin->x = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_08_L);                   // Display H start
        pdspwin->width  = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_09_L) - pdspwin->x + 1; // Display H end
        pdspwin->y = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0A_L);                   // Display V start
        pdspwin->height = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0B_L) - pdspwin->y + 1; // Display V end
    }
    else
    {
        //Display window
        pdspwin->x = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_07_L);                   // Display H start
        pdspwin->width  = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_08_L) - pdspwin->x + 1; // Display H end
        pdspwin->y = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_09_L);                   // Display V start
        pdspwin->height = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_0A_L) - pdspwin->y + 1; // Display V end
    }
}

void MHal_XC_OPMHttControl(void* pInstance,SCALER_WIN enWindow)
{
    if(pInstance != NULL)
    {
        XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
        UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
        XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
        UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

        MS_U32 u32FClkAddr = 0;
        MS_U16 u16FClkLevel = 0;
        MS_U16 u16FClkMsk = 0;
        //OPM Flow Control
        MS_U16 u16FlowCtrlHtt = 0;
        MS_U16 u16PanelHtt = 0;
        MS_U16 u16Output_W = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width;
        MS_U16 u16Output_H = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height;
        MS_U16 u16Input_W = (gSrcInfo[enWindow].stCapWin.width);
        MS_U16 u16Input_H = (gSrcInfo[enWindow].stCapWin.height);
        MS_BOOL bIsSupportTuneHTT = TRUE;
        if((u16Output_W <= XC_FHD_WIDTH_MAX) && (u16Output_H <= XC_FHD_HIGH_MAX) && (MHal_XC_IsSupportFHDDownClk() == TRUE))
        {
            u16PanelHtt = (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_0C_L,0x3FFF) +1);

            if(E_XC_DEVICE0 == psXCInstPri->u32DeviceID)
            {
                u32FClkAddr = REG_CKG_FCLK;
                u16FClkMsk = CKG_FCLK_MASK;
            }
            else
            {
                u32FClkAddr = REG_CKG_S2_FCLK;
                u16FClkMsk = CKG_S2_FCLK_MASK;
            }
            u16FClkLevel =  (MDrv_ReadByte(u32FClkAddr) & u16FClkMsk);

            switch(u16FClkLevel)
            {
                case CKG_FCLK_345MHZ:
                {
                    u16FlowCtrlHtt = OPMFLOWCTRL_FCLK_345MHZ;
                    break;
                }
                case CKG_FCLK_216MHZ:
                {
                    u16FlowCtrlHtt = OPMFLOWCTRL_FCLK_216MHZ;
                    break;
                }
                case CKG_FCLK_192MHZ:
                {
                    u16FlowCtrlHtt = OPMFLOWCTRL_FCLK_192MHZ;
                    break;
                }
                case CKG_FCLK_240MHZ:
                {
                    u16FlowCtrlHtt = OPMFLOWCTRL_FCLK_240MHZ;
                    break;
                }
                case CKG_FCLK_320MHZ:
                {
                    u16FlowCtrlHtt = OPMFLOWCTRL_FCLK_320MHZ;
                    break;
                }
                default:
                {
                    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"u16FClkLevel = %d is Not Support\n",u16FlowCtrlHtt);
                    bIsSupportTuneHTT = FALSE;
                    break;
                }
            }
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"bIsSupportTuneHTT = %d\n",bIsSupportTuneHTT);
            if(bIsSupportTuneHTT == TRUE)
            {
                u16FlowCtrlHtt = (u16PanelHtt*u16FlowCtrlHtt)/(OPMFLOWCTRL_PANELHTT_BASE*OPMFLOWCTRL_FCLK_BASE);// fomula provide by cc.yang
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_14_L,u16FlowCtrlHtt,0x7FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_14_L,0,BIT(15));
            }
            else
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_14_L,OPMFLOWCTRL_FCLK_DEFAULT,0x7FFF);
            }
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_14_L,OPMFLOWCTRL_FCLK_DEFAULT,0x7FFF);
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"Don't Need to Tune OPMFlowHtt, Set Default Value\n");
        }
    }
}

void Hal_SC_set_Fclk(void *pInstance, EN_SET_FCLK_CASE enCase, MS_U16 u16ClkLevel)
{
    MS_U32 u32FClkAddr = 0;
    MS_U16 u16FinalClkLevel = 0;
    MS_U16 u16FClkMsk = 0;

    if(u16ClkLevel == CKG_FCLK_DEFAULT)
    {
        XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
        UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
        XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
        UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

        if (enCase == EN_FCLK_FBL)
        {
            if(E_XC_DEVICE0 == psXCInstPri->u32DeviceID)
            {
              u32FClkAddr = REG_CKG_FCLK;
              u16FinalClkLevel = CKG_FCLK_690MHZ;
              u16FClkMsk = CKG_FCLK_MASK;
            }
            else
            {
              u32FClkAddr = REG_CKG_S2_FCLK;
              u16FinalClkLevel = CKG_S2_FCLK_345MHZ;
              u16FClkMsk = CKG_S2_FCLK_MASK;
            }
        }
        else
        {
            if(E_XC_DEVICE0 == psXCInstPri->u32DeviceID)
            {
              u32FClkAddr = REG_CKG_FCLK;
              u16FinalClkLevel = CKG_FCLK_DEFAULT;
              u16FClkMsk = CKG_FCLK_MASK;
            }
            else
            {
              u32FClkAddr = REG_CKG_S2_FCLK;
              u16FinalClkLevel = CKG_S2_FCLK_320MHZ;
              u16FClkMsk = CKG_S2_FCLK_MASK;
            }
        }
    }
    else
    {
      u32FClkAddr = REG_CKG_FCLK;
      u16FinalClkLevel = u16ClkLevel;
      u16FClkMsk = CKG_FCLK_MASK;
    }
    MDrv_WriteByteMask(u32FClkAddr, u16FinalClkLevel, u16FClkMsk);
}

void Hal_SC_get_framebuf_Info(void *pInstance, SC_FRAMEBUF_INFO_t *pFrameBufInfo, SCALER_WIN eWindow)
{
    MS_U8 u8Reg;
    MS_U32 u32TempReg = 0;

    if (!pFrameBufInfo) return;

    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if (eWindow == MAIN_WINDOW)
    {
        pFrameBufInfo->u32IPMBase0 = (((MS_PHY)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_09_L, 0x00FF)<<16) |
                                      (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_08_L))) * BYTE_PER_WORD;
        pFrameBufInfo->u32IPMBase1 = (((MS_PHY)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_0B_L, 0x00FF)<<16) |
                                      (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0A_L))) * BYTE_PER_WORD;
        pFrameBufInfo->u32IPMBase2 = (((MS_PHY)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_0D_L, 0x00FF)<<16) |
                                      (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0C_L))) * BYTE_PER_WORD;
        pFrameBufInfo->u16IPMOffset = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0E_L);
        pFrameBufInfo->u16IPMFetch = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0F_L);
        pFrameBufInfo->u16VLength = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_18_L, 0x0FFF);
        pFrameBufInfo->bLinearAddrMode = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_03_L, BIT(4));
        pFrameBufInfo->bYCSeparate = ( SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_02_L, BIT(10)) )?TRUE:FALSE;
        pFrameBufInfo->u32WriteLimitBase = SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_42_L);
    }
    else
    {
        pFrameBufInfo->u32IPMBase0 = (((MS_PHY)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_49_L, 0x00FF)<<16) |
                                      (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_48_L))) * BYTE_PER_WORD;
        pFrameBufInfo->u32IPMBase1 = (((MS_PHY)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_4B_L, 0x00FF)<<16) |
                                      (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4A_L))) * BYTE_PER_WORD;
        pFrameBufInfo->u32IPMBase2 = (((MS_PHY)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_4D_L, 0x00FF)<<16) |
                                      (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4C_L))) * BYTE_PER_WORD;
        pFrameBufInfo->u16IPMOffset = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4E_L);
        pFrameBufInfo->u16IPMFetch = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_4F_L);
        pFrameBufInfo->u16VLength = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_58_L, 0x0FFF);
        pFrameBufInfo->bLinearAddrMode = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_43_L, BIT(4));
        pFrameBufInfo->bYCSeparate = ( SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_42_L, BIT(10)) )?TRUE:FALSE;
        pFrameBufInfo->u32WriteLimitBase = SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0D_44_L);
    }

    // frcm write base address limit
#if 0
#if (HW_DESIGN_4K2K_VER == 4)
    if ((psXCInstPri->u32DeviceID==0)
        && !(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE))
    {
        pFrameBufInfo->u32FRCMWriteLimitBase = SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_1A_L);
    }
#endif
#endif
    pFrameBufInfo->u8BitPerPixel = 24;//default

    if (eWindow == MAIN_WINDOW)
    {
        u8Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_01_L, 0x00FF);
    }
    else
    {
        u8Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_41_L, 0x00FF);
    }

    if (u8Reg & 0x30)
    {//444
        pFrameBufInfo->bMemFormat422 = FALSE;
        if (u8Reg & 0x10)
        { // 444 8BIT
            pFrameBufInfo->u8BitPerPixel = 24;
        }
        else
        { // 444 10BIT
            pFrameBufInfo->u8BitPerPixel = 32;
        }
        pFrameBufInfo->bInterlace = FALSE;
    }
    else
    {//422
        pFrameBufInfo->bMemFormat422 = TRUE;

        if (eWindow == MAIN_WINDOW)
        {
            u32TempReg = REG_SC_BK12_02_L;
        }
        else
        {
            u32TempReg = REG_SC_BK12_42_L;
        }

        if((BIT(8)|BIT(9)) == SC_R2BYTEMSK(psXCInstPri->u32DeviceID, u32TempReg, BIT(8)|BIT(9))) //user mode
        {
            MS_U8 u8MemFmt = SC_R2BYTE(psXCInstPri->u32DeviceID, u32TempReg) & 0x0F;
            if((4 == u8MemFmt) || (5 == u8MemFmt) || (6 == u8MemFmt))
            {
                pFrameBufInfo->u8BitPerPixel = 20;
            }
            else if((8 == u8MemFmt) || (9 == u8MemFmt) || (10 == u8MemFmt) || (11 == u8MemFmt))
            {
                pFrameBufInfo->u8BitPerPixel = 24;
            }
        }
        else
        {
            if (eWindow == MAIN_WINDOW)
            {
                u8Reg = (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_01_L, 0xFF00)) >> 8;
            }
            else
            {
                u8Reg = (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_41_L, 0xFF00)) >> 8;
            }

            switch(u8Reg & 0x77)
            {
                case 0x25:
                    pFrameBufInfo->u8BitPerPixel = 24;
                    pFrameBufInfo->bInterlace = TRUE;
                    break;
                case 0x24:
                    pFrameBufInfo->u8BitPerPixel = 20;
                    pFrameBufInfo->bInterlace = TRUE;
                    break;
                case 0x27:
                    pFrameBufInfo->u8BitPerPixel = 16;
                    pFrameBufInfo->bInterlace = TRUE;
                    break;
                case 0x21:
                    if (eWindow == MAIN_WINDOW)
                    {
                        u32TempReg = REG_SC_BK12_04_L;
                    }
                    else
                    {
                        u32TempReg = REG_SC_BK12_44_L;
                    }
                    if(BIT(1) == SC_R2BYTEMSK(psXCInstPri->u32DeviceID, u32TempReg, BIT(0)|BIT(1)))
                    {
                        pFrameBufInfo->u8BitPerPixel = 24;
                    }
                    else
                    {
                        pFrameBufInfo->u8BitPerPixel = 20;
                    }
                    pFrameBufInfo->bInterlace = FALSE;
                    break;
                case 0x20:
                    pFrameBufInfo->u8BitPerPixel = 16;
                    pFrameBufInfo->bInterlace = FALSE;
                    break;
                case 0x00:
                default:
                    pFrameBufInfo->u8BitPerPixel = 16;
                    pFrameBufInfo->bInterlace = FALSE;
                    break;
            }
        }
    }

    //In M10/J2/A5/A6/A3, New SCMI
    if (eWindow == MAIN_WINDOW)
    {
        pFrameBufInfo->u8FBNum = (MS_U8)(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_19_L, 0x1F));
    }
    else
    {
        pFrameBufInfo->u8FBNum = (MS_U8)(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_59_L, 0x1F));
    }

#if 0
    printf("base0=0x%x, base1=0x%x, base2=0x%x, offset=%u, 422=%u, i=%u, bpp=%u, fbnum=%u\n",
           (unsigned int)pFrameBufInfo->u32IPMBase0,
           (unsigned int)pFrameBufInfo->u32IPMBase1,
           (unsigned int)pFrameBufInfo->u32IPMBase2,
           pFrameBufInfo->u16IPMOffset,
           pFrameBufInfo->bMemFormat422,
           pFrameBufInfo->bInterlace,
           pFrameBufInfo->u8BitPerPixel,
           pFrameBufInfo->u8FBNum);
#endif
}
void Hal_SC_set_framebuf_Info(void *pInstance, SC_FRAMEBUF_INFO_t pFrameBufInfo)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_PHY u32IPMBase0, u32IPMBase1, u32IPMBase2;
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    u32IPMBase0=pFrameBufInfo.u32IPMBase0/BYTE_PER_WORD;
    u32IPMBase1=pFrameBufInfo.u32IPMBase1/BYTE_PER_WORD;
    u32IPMBase2=pFrameBufInfo.u32IPMBase2/BYTE_PER_WORD;

    //Step 5.4, Memory Limit V : BK12_18[15] = 1, BK12_18[12:0] to the real V line number
    if (Hal_SC_NeedXCV8Align(pInstance))
    {
        pFrameBufInfo.u16VLength = XC8ALIGN(pFrameBufInfo.u16VLength);
    }
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_18_L, (pFrameBufInfo.u16VLength|0x8000),0x8FFF);

//    u32WritelimitBase = ((u32IPMBase0 + u32MemSize) / BYTE_PER_WORD - 1) | 0x2000000;
    SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_1A_L, pFrameBufInfo.u32IPMBase1);
    // frcm write base address limit
#if 0
#if (HW_DESIGN_4K2K_VER == 4)
    if ((psXCInstPri->u32DeviceID==0)
        && !(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE))
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK32_1A_L, pFrameBufInfo.u32FRCMWriteLimitBase);
    }
#endif
#endif
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_09_L, (MS_U16)(u32IPMBase0 & 0xFF0000)>>16,0x00FF);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_08_L, (MS_U16)(u32IPMBase0 & 0xFFFF));

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_0B_L, (MS_U16)(u32IPMBase1 & 0xFF0000)>>16,0x00FF);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0A_L, (MS_U16)(u32IPMBase1 & 0xFFFF));

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_0D_L, (MS_U16)(u32IPMBase2 & 0xFF0000)>>16,0x00FF);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0C_L, (MS_U16)(u32IPMBase2 & 0xFFFF));


    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0E_L, pFrameBufInfo.u16IPMOffset);
    if (Hal_SC_NeedXCH8Align(pInstance))
    {
        pFrameBufInfo.u16IPMFetch = XC8ALIGN(pFrameBufInfo.u16IPMFetch);
    }
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_0F_L, pFrameBufInfo.u16IPMFetch);
//    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_18_L, (pFrameBufInfo.u16VLength|0x1000),0x1FFF);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_03_L, ((pFrameBufInfo.bLinearAddrMode)?BIT(4):0),BIT(4));

}

MS_U8 Hal_SC_get_cs_det_cnt(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U8 u8val;

    if(eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        u8val = ((SC_R2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_0C_L, eWindow)) & HBMASK) >> 8);
#else
        u8val = ((SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_0C_L) & HBMASK) >> 8);
#endif
    }
    else
    {
        u8val = ((SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_0C_L) & HBMASK) >> 8);
    }
    return u8val;
}

void Hal_SC_set_cs_det_cnt(void *pInstance, MS_U8 u8val, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_0C_L, eWindow), (((MS_U16)u8val)<<8), HBMASK);
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_0C_L, (((MS_U16)u8val)<<8), HBMASK);
#endif
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_0C_L, (((MS_U16)u8val)<<8), HBMASK);
    }
}

MS_U8 Hal_SC_get_plus_width(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U8 u8val;

    if(eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        u8val = (SC_R2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_22_L, eWindow)) & LBMASK);
#else
        u8val = (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_22_L) & LBMASK);
#endif
    }
    else
    {
        u8val = (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK03_22_L) & LBMASK);
    }
    return u8val;
}

void Hal_SC_set_opm_fetch(void *pInstance, SCALER_WIN eWindow, MS_U16 u16OPMFetch)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        if (Hal_SC_NeedXCH8Align(pInstance))
        {
            u16OPMFetch = XC8ALIGN(u16OPMFetch);
        }
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_17_L, u16OPMFetch, 0x1FFF);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_57_L, u16OPMFetch, 0x1FFF);
    }
}

MS_U16 Hal_SC_get_opm_fetch(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U16 u16Val = 0;
    if(eWindow == MAIN_WINDOW)
    {
        u16Val = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_17_L) & 0x0FFF;
    }
    else
    {
        u16Val = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_57_L) & 0x0FFF;
    }
    return u16Val;
}

MS_U8 HAL_SC_get_dnr_setting(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
        return (MS_U8)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK06_21_L, BIT(1)|BIT(0));
    else
        return (MS_U8)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK06_01_L, BIT(1)|BIT(0));
}

void HAL_SC_enable_field_avg_y(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK05_21_L, bEnable ? BIT(6) : 0, BIT(6));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK05_01_L, bEnable ? BIT(6) : 0, BIT(6));
    }

}

void HAL_SC_enable_field_avg_c(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK05_21_L, bEnable ? BIT(7) : 0, BIT(7));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK05_01_L, bEnable ? BIT(7) : 0, BIT(7));
    }
}

void HAL_SC_enable_dnr(void *pInstance, MS_U8 u8Val, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK06_21_L, u8Val, BIT(1)|BIT(0));
    else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK06_01_L, u8Val, BIT(1)|BIT(0));
}

void HAL_SC_VOP_Set_Contrast_En(void *pInstance, MS_BOOL bEenable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_53_L, (MS_U16)(bEenable?BIT(0):0), BIT(0));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_53_L, (MS_U16)(bEenable?BIT(8):0), BIT(8));
    }
}
void HAL_SC_VOP_Set_Contrast_Value(void *pInstance, MS_XC_VOP_CHANNEL_t eVop_Channel, MS_U16 u16Val, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        switch(eVop_Channel)
        {
            default:
            case XC_VOP_CHR:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_47_L, u16Val, 0x0FFF);
                break;
            case XC_VOP_CHG:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_48_L, u16Val, 0x0FFF);
                break;
            case XC_VOP_CHB:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_49_L, u16Val, 0x0FFF);
                break;
            case XC_VOP_ALL:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_47_L, u16Val, 0x0FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_48_L, u16Val, 0x0FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_49_L, u16Val, 0x0FFF);
                break;
        }
    }
    else
    {
        switch(eVop_Channel)
        {
            default:
            case XC_VOP_CHR:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4A_L, u16Val, 0x0FFF);
                break;
            case XC_VOP_CHG:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4B_L, u16Val, 0x0FFF);
                break;
            case XC_VOP_CHB:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4C_L, u16Val, 0x0FFF);
                break;
            case XC_VOP_ALL:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4A_L, u16Val, 0x0FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4B_L, u16Val, 0x0FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4C_L, u16Val, 0x0FFF);
                break;
        }
    }
}

void HAL_SC_VOP_Set_Brightness_En(void *pInstance, MS_BOOL bEenable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_53_L, (MS_U16)(bEenable?BIT(1):0), BIT(1));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_53_L, (MS_U16)(bEenable?BIT(9):0), BIT(9));
    }
}
void HAL_SC_VOP_Set_Brightness_Value(void *pInstance, MS_XC_VOP_CHANNEL_t eVop_Channel, MS_U16 u16Val, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW)
    {
        switch(eVop_Channel)
        {
            default:
            case XC_VOP_CHR:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4D_L, u16Val, 0x07FF);
                break;
            case XC_VOP_CHG:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4E_L, u16Val, 0x07FF);
                break;
            case XC_VOP_CHB:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4F_L, u16Val, 0x07FF);
                break;
            case XC_VOP_ALL:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4D_L, u16Val, 0x07FF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4E_L, u16Val, 0x07FF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_4F_L, u16Val, 0x07FF);
                break;
        }
    }
    else
    {
        switch(eVop_Channel)
        {
            default:
            case XC_VOP_CHR:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_50_L, u16Val, 0x07FF);
                break;
            case XC_VOP_CHG:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_51_L, u16Val, 0x07FF);
                break;
            case XC_VOP_CHB:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_52_L, u16Val, 0x07FF);
                break;
            case XC_VOP_ALL:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_50_L, u16Val, 0x07FF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_51_L, u16Val, 0x07FF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_52_L, u16Val, 0x07FF);
                break;
        }
    }
}

void HAL_SC_Set_FB_Num(void *pInstance, SCALER_WIN eWindow, XC_FRAME_STORE_NUMBER enFBType, MS_BOOL bInterlace)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U8 u8FrameCount = 2;

    switch( enFBType )
    {
        case IMAGE_STORE_2_FRAMES:
            u8FrameCount = 2;
            break;
        case IMAGE_STORE_3_FRAMES:
            u8FrameCount = 3;
            break;
        case IMAGE_STORE_4_FRAMES:
            u8FrameCount = 4;
            break;
        case IMAGE_STORE_6_FRAMES:
            u8FrameCount = 6;
            break;
        case IMAGE_STORE_8_FRAMES:
            u8FrameCount = 8;
            break;
        case IMAGE_STORE_12_FRAMES:
            u8FrameCount = 12;
            break;
        default:
            break;
    }

    if (!bInterlace)
    {
        if (eWindow == MAIN_WINDOW)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_19_L, u8FrameCount , BITMASK(4:0) );
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_59_L, u8FrameCount , BITMASK(4:0) );
        }
    }
}

void HAL_SC_Enable_VInitFactor(void *pInstance, MS_BOOL bEnable,SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if (eWindow == MAIN_WINDOW)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK23_13_L, (MS_U16)(bEnable?BIT(0):0), BIT(0));
    else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK23_33_L, (MS_U16)(bEnable?BIT(0):0), BIT(0));
}

void HAL_SC_Set_VInitFactorTwo(void *pInstance, MS_U32 u32Value,SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if (eWindow == MAIN_WINDOW)
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_05_L, u32Value);
    else
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_25_L, u32Value);
}

void HAL_SC_Set_vsd_output_line_count(void *pInstance, MS_BOOL bEnable,MS_U32 u32LineCount,SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_U16 u16OutputLineCount = 0x00;

    if (bEnable)
    {
        u16OutputLineCount = BIT(15);
        if(gSrcInfo[eWindow].bInterlace)
        {
            u32LineCount /= 2;
        }
        if (Hal_SC_NeedXCV8Align(pInstance))
        {
            u32LineCount = XC8ALIGN(u32LineCount);
        }
        u16OutputLineCount |= (MS_U16)(u32LineCount & 0x1FFF);
    }

    if (eWindow == MAIN_WINDOW)
    {
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_37_L, u16OutputLineCount);
    }
    else
    {
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK04_37_L, u16OutputLineCount);
    }
}

/*
 bEnable : Enable input line count.
 bUserMode : 1 -> the input line count will ref u32UserLineCount
                   0 -> the input line count will ref V capture win
*/
void HAL_SC_Set_vsd_input_line_count(void *pInstance, MS_BOOL bEnable,MS_BOOL bUserMode,MS_U32 u32UserLineCount,SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return;
    }
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_U16 u16InputLineCount = 0x00;

    if (bEnable)
    {
        u16InputLineCount = BIT(15);

        if (bUserMode)
        {
            u16InputLineCount |= BIT(14);

            if(gSrcInfo[eWindow].bInterlace)
            {
                u32UserLineCount /= 2;
            }
            u16InputLineCount |= (MS_U16)(u32UserLineCount & 0x1FFF);
        }
    }

    if (eWindow == MAIN_WINDOW)
    {
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_36_L, u16InputLineCount);
    }
    else
    {
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK04_36_L, u16InputLineCount);
    }

}

MS_U32 Hal_SC_CheckSubWinPreScaling(MS_U16 UNUSED_PARA(u16ScaleDst),MS_BOOL UNUSED_PARA(bInterlace))
{
    //New chip sub window unnecessary to the same with the main window's pre scaling setting.
    return 0;
}

void HAL_SC_FilmMode_Patch1(void *pInstance)
{
#if 1
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U16 u16Value;
    MS_U16 u16RegValue;
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    u16RegValue = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK22_7D_L, 0xFF);
    if(pXCResourcePrivate->sthal_SC.g_bCntFlg)
        pXCResourcePrivate->sthal_SC.g_u16TmpValue = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0A_02_L, 0xFF);

    if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0A_21_L, BIT(6)))
    {
        //Counter
        if(pXCResourcePrivate->sthal_SC.u8Time_count != 0xFF)
            pXCResourcePrivate->sthal_SC.u8Time_count ++;

        if(pXCResourcePrivate->sthal_SC.u8Time_count < u16RegValue)  // fake out duration
            u16Value = 0x06;      // madi fake out enable
        else
            u16Value = 0x00;      // madi fake out disable

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0A_25_L, (0x10<<8), 0xFF00);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0A_02_L, 0x22, 0xFF);
        pXCResourcePrivate->sthal_SC.g_bCntFlg = 0;
    }
    else
    {
        pXCResourcePrivate->sthal_SC.u8Time_count = 0;
        u16Value = 0x00;      // madi fake out disable
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0A_25_L, (0x08<<8), 0xFF00);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0A_02_L, pXCResourcePrivate->sthal_SC.g_u16TmpValue, 0xFF);
        pXCResourcePrivate->sthal_SC.g_bCntFlg = 1;
    }
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0A_21_L, u16Value, BIT(2)|BIT(1));

#else
    MS_U8 u8Bank, u8Value;
    MS_U8 u8RegValue;

    static MS_U8 u8Time_count = 0;

    MDrv_WriteByte(BK_SELECT_00, REG_BANK_MADI); //bk22
    u8RegValue = MDrv_ReadByte(L_BK_MADI(0x7D));

    MDrv_WriteByte(BK_SELECT_00, REG_BANK_FILM);


    if(MDrv_ReadRegBit(L_BK_FILM(0x21), BIT(6)))
    {
        //Counter
        if(u8Time_count != 0xFF)
            u8Time_count ++;

        if(u8Time_count < u8RegValue)  // fake out duration
            u8Value = 0x06;      // madi fake out enable
        else
            u8Value = 0x00;      // madi fake out disable

        MDrv_WriteByte(H_BK_FILM(0x25), 0x10);

    }
    else
    {
        u8Time_count = 0;
        u8Value = 0x00;      // madi fake out disable
        MDrv_WriteByte(H_BK_FILM(0x25), 0x08);
    }

    MDrv_WriteByteMask(L_BK_FILM(0x21), u8Value, BIT(2)|BIT(1));
    MDrv_WriteByte(BK_SELECT_00, u8Bank);
#endif
}

void HAL_SC_EnableFPLL(void)
{
    MDrv_WriteByteMask(L_BK_LPLL(0x0C), BIT(3), BIT(3));
    MDrv_WriteByteMask(L_BK_LPLL(0x0C),      0, BIT(6));
}


static void _HAL_SC_GetFPLLPhaseDiffISR(SC_INT_SRC eIntNum, void *pParam)
{
    volatile MS_XC_GET_FPLL_PHASEDIFF * pFpllPhaseDiff = (volatile MS_XC_GET_FPLL_PHASEDIFF *) pParam;

    pFpllPhaseDiff->u16PhaseDiff = MDrv_Read2Byte(L_BK_LPLL(0x11));
    pFpllPhaseDiff->eFpllDir = (MDrv_Read2Byte(L_BK_LPLL(0x12)) & BIT(0)) == BIT(0) ? E_XC_FPLL_DIR_UP : E_XC_FPLL_DIR_DOWN;
    pFpllPhaseDiff->u8Debounce++;

    if(pFpllPhaseDiff->u8Debounce > 3)
    {
        if(pFpllPhaseDiff->u16PhaseDiff < 0x200)
        {
            pFpllPhaseDiff->eFpllResult = E_XC_FPLL_RES_FINISHED;
        }
        else
        {
            if(pFpllPhaseDiff->u8Debounce > 90)
            {
                pFpllPhaseDiff->eFpllResult = E_XC_FPLL_RES_TIMEOUT;
            }
        }
    }
}

MS_BOOL HAL_SC_WaitFPLLDone(void *pInstance)
{
    MS_XC_GET_FPLL_PHASEDIFF stGetFpllPhaseDiff = {0, 0, E_XC_FPLL_DIR_UNKNOWN, E_XC_FPLL_RES_WAITING};

    MDrv_XC_InterruptAttach(pInstance, SC_INT_VSINT, _HAL_SC_GetFPLLPhaseDiffISR, (void *) &stGetFpllPhaseDiff);
    while(*(volatile MS_BOOL*)(&(stGetFpllPhaseDiff.eFpllResult)) == E_XC_FPLL_RES_WAITING);
    MDrv_XC_InterruptDeAttach(pInstance, SC_INT_VSINT, _HAL_SC_GetFPLLPhaseDiffISR, (void *) &stGetFpllPhaseDiff);

    if(stGetFpllPhaseDiff.eFpllResult == E_XC_FPLL_RES_FINISHED)
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

MS_U16 HAL_SC_GetOutputVFreqX100(MS_U32 u32XTAL_Clock)
{
    return ((MS_U16) ((u32XTAL_Clock * 100) / MDrv_Read4Byte(L_BK_LPLL(0x23))));
}

//Line buffer offset between Main and Sub, MAX(Main+Sub) = 1920+960
//Main Win Line buffer offset , start from max size of main's
void HAL_SC_SetMainLineBufferOffset(void *pInstance, MS_U16 u16Linebuffer)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_12_L, u16Linebuffer);
}

//Line buffer offset between Main and Sub, MAX(Main+Sub) = 1920+960
//Sub Win Line buffer offset , start from max size of main's
void HAL_SC_SetSubLineBufferOffset(void *pInstance, MS_U16 u16Linebuffer)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_13_L, u16Linebuffer);
}

//Select the trig mode
//0: Line base(Line Buffer Mode)
//1: Fill line buffer(Ring Buffer Mode)
void HAL_SC_SetDisplay_LineBuffer_Mode(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_1F_L, (bEnable ? BIT(4) : 0), BIT(4));
}

//Select the start mode
//0: start at advance 1 display line
//1: start at faling edge of Vsync_init
void HAL_SC_SetDisplay_Start_Mode(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_1F_L, (bEnable ? BIT(5) : 0), BIT(5));
}

//bk20_10[10]: Fill the main window's line buffer in vertical blanking for pip left and up corner
//bk20_10[11]: Fill the sub window's line buffer in vertical blanking for pip left and down corner
void HAL_SC_FillLineBuffer(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(bEnable)
    {
        if(eWindow == MAIN_WINDOW)
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_10_L, BIT(10), BIT(10));
        else
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_10_L, BIT(11), BIT(11));
    }
    else
    {
        if(eWindow == MAIN_WINDOW)
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_10_L, 0, BIT(10));
        else
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_10_L, 0, BIT(11));
    }
}

void Hal_SC_enable_window(void *pInstance, MS_BOOL bEn,SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if (eWindow == MAIN_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_10_L, bEn ? BIT(0) : 0, BIT(0));
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
        if (psXCInstPri->u32DeviceID == 1)
        {
            // PIP enable need disable pixelshift
            if (bEn)
            {
                MHal_XC_PixelShiftStatusChange(g_pDevice0Instance, EN_XC_PIXEL_SHIFT_DISABLE);
            }

            // set SC1 auto no signal by SC1 control
            SC_W2BYTEMSK(0, REG_SC_BK11_07_L, bEn ? BIT(5) : 0, BIT(5));
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
            if (Hal_SC_3D_IsDualViewMode(pInstance, eWindow))
            {
                SC_W2BYTEMSK(0, REG_SC_BK20_10_L, bEn ? BIT(1) : 0, BIT(1));
            }
            else
#endif
            {
                SC_W2BYTEMSK(0, REG_SC_BK20_10_L, bEn ? BIT(2)|BIT(1) : 0, BIT(2)|BIT(1));
                SC_W2BYTEMSK(0, REG_SC_BK68_40_L, bEn ? BIT(4) : 0, BIT(4));
            }
            SC_W2BYTEMSK(0, REG_SC_BK46_3F_L, bEn ? 0 : BIT(0), BIT(0));
            //MDrv_WriteRegBit(REG_CLKGEN2_BASE + 0x87, bEn ? TRUE : FALSE, BIT(1));//FIXME:patch for PIP
        }
#endif
    }
    else
    {
        // Sub prefill line must be enable, when PIP on (enable input source of sub win)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_10_L, BIT(11) , BIT(11));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_10_L, bEn ? BIT(1) : 0, BIT(1));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK58_10_L, bEn ? BIT(0) : 0, BIT(0));
        if(!bEn)
        {
            //disable sc0 sub,fsc sub de should recover default value
#if FRC_INSIDE
            if(pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFSCEnabled)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_10_L, 0x3FFF, 0x3FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_11_L, 0x3FFF, 0x3FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_12_L, 0x1FFF, 0x1FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_13_L, 0x1FFF, 0x1FFF);
            }
#endif
            // for new HW change, when close sc0 sub need to restore main composer
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_40_L, 0x1100, 0x7F70);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_48_L, 0, BIT(2));

            //HW SUPPORT HSV DEMO WINDOW
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK0C_03_L, 0, BIT(15));
        }
        else
        {
            //Sub need set sub_sc0_vip composer
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_40_L, 0x2191, 0xFF70);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_48_L, BIT(2), BIT(2));

            //HW SUPPORT HSV DEMO WINDOW
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK0C_03_L, BIT(15), BIT(15));
        }
    }
}

static MS_U16 _Hal_SC_GetInputVPeriod(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_U16 u16VFreq = gSrcInfo[eWindow].u16InputVFreq * 10;
    SC_DBG(printf("(100000+u16VFreq/2)/u16VFreq)=%u, u16VFreq=%u\n",((100000+u16VFreq/2)/u16VFreq), u16VFreq));
    if(u16VFreq == 0)
    {
        return 0;
    }
    else
    {
        return ((100000+u16VFreq/2)/u16VFreq); //Period = 1000/(vfreq/100)
    }
}

void Hal_SC_enable_window_burst(void *pInstance, MS_BOOL bEn,SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    _MLOAD_ENTRY(pInstance);
    if (eWindow == MAIN_WINDOW)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_10_L, bEn ? BIT(0) : 0, BIT(0));
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
        void *pInstanceTmp = NULL;
        if (psXCInstPri->u32DeviceID == 1)
        {
            pInstanceTmp = pInstance;  // store instance 0
            pInstance = g_pDevice0Instance; //switch to instance 1
            UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
            // PIP enable need disable pixelshift
            if (bEn)
            {
                MHal_XC_PixelShiftStatusChange(pInstanceTmp, EN_XC_PIXEL_SHIFT_DISABLE);
            }
            // set SC1 auto no signal by SC1 control
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_07_L, bEn ? BIT(5) : 0, BIT(5));
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
            if (Hal_SC_3D_IsDualViewMode(pInstance, eWindow))//FIXME: Manhattan dual view patch
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_10_L, bEn ? BIT(1) : 0, BIT(2)|BIT(1));
            }
            else
#endif
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_10_L, bEn ? BIT(2)|BIT(1) : 0, BIT(2)|BIT(1));
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_40_L, bEn ? BIT(4) : 0, BIT(4));
            }
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_3F_L, bEn ? 0 : BIT(0), BIT(0));
            //MDrv_WriteRegBit(REG_CLKGEN2_BASE + 0x87, bEn ? TRUE : FALSE, BIT(1));//FIXME:patch for PIP
            pInstance = pInstanceTmp;  // restore instance 0
        }

#endif

        MDrv_XC_MLoad_Fire(pInstance, TRUE);
    }
    else
    {
        if(bEn == TRUE)
        {
            MS_U16 u16extra_req = 0;
            MS_U16 u16Delaytime = 0;

            // When Main is foreground, sub is background, extra must enable.
            u16extra_req = 0x01;

            if(Hal_SC_is_extra_req_en(pInstance, NULL, NULL , NULL , NULL))
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_11_L, BIT(15), BIT(15));
                u16extra_req = u16extra_req | 0x8000;
            }

            // HW PIP architeucture
            // Becasue BK3_02[8] and BK20_11[15] should enable together, otherwise garbage will be showed,
            // we need to use BK12_47[0] to instead. And the default value of BK3_02[8] is 1. So, we need
            // to set it to 0 in this function.
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_11_L, u16extra_req , 0x800F);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK03_02_L, 0, 0x0080);

            // Sub prefill line must be enable, when PIP on (enable input source of sub win)
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_10_L, BIT(11), BIT(11) );
            MDrv_XC_MLoad_Fire(pInstance, TRUE);
            //if we let REG_SC_BK20_10_L[1] to enable with other register settings in the same menuload fire
            //it will produce a rectangular horizontal noise. so we move outside to let those register settings
            //to be set first then let REG_SC_BK20_10_L[1] on.

            //betwen REG_SC_BK03_02_L[7] and REG_SC_BK20_10_L[1], we need to delay time of wr mapping mode,
            // to let the data fill in xc sub buffer
            u16Delaytime = _Hal_SC_GetInputVPeriod(pInstance, eWindow) * (Hal_SC_Get_WR_Bank_Mapping(pInstance, eWindow) + 1);
            MsOS_DelayTask(u16Delaytime);

            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_10_L, BIT(1), BIT(1));
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK58_10_L, BIT(0), BIT(0));

            //Sub need set sub_sc0_vip composer
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_40_L, 0x2191, 0xFF70);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_48_L, BIT(2), BIT(2));

            //HW SUPPORT HSV DEMO WINDOW
            MDrv_XC_MLoad_WriteCmd_XC_EXT(pInstance, REG_SC_EXT_BK0C_03_L, BIT(15), BIT(15));

            MDrv_XC_MLoad_Fire(pInstance, TRUE);
        }
        else
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK58_10_L, 0, BIT(0));
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_10_L, 0, BIT(1));
            //disable sc0 sub,fsc sub de should recover default value
#if FRC_INSIDE
            if(IsFSCOrFRCEnable())
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_10_L, 0x3FFF, 0x3FFF);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_11_L, 0x3FFF, 0x3FFF);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_12_L, 0x1FFF, 0x1FFF);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_13_L, 0x1FFF, 0x1FFF);
            }
#endif
            // for new HW change, when close sc0 sub need to restore main composer
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_40_L, 0x1100, 0x7F70);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_48_L, 0, BIT(2));

            MDrv_XC_MLoad_Fire(pInstance, TRUE);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK03_02_L, 0x0080, 0x0080);

            //HW SUPPORT HSV DEMO WINDOW
            MDrv_XC_MLoad_WriteCmd_XC_EXT(pInstance, REG_SC_EXT_BK0C_03_L, 0, BIT(15));

            MDrv_XC_MLoad_Fire(pInstance, TRUE);
        }
    }

    _MLOAD_RETURN(pInstance);
}

void Hal_SC_set_trigger_signal(void)
{
    // only used in U4
}

MS_BOOL Hal_SC_IsOPMFetchPatch_Enable(void)
{
    //Patch for Janus u01 and T4 U01/02: OPMFetch need +2
    return FALSE;
}
MS_BOOL Hal_SC_Check_HNonLinearScaling(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U16 u16Offset = (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_15_L)>>8);
    MS_U16 u16MaxOffset = ((SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_07_L) & 0xFFFFFF)>>12);
    //Non-Linear scaling Postive offset, the maximum offset is HPstRatio[23:12]
    if(((u16Offset & BIT(7)) == 0) && (u16Offset > u16MaxOffset))
    {
        return FALSE;
    }
    return TRUE;
}

//IP2 Pre-Filter enable
void Hal_SC_IP2_PreFilter_Enable(void* pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_48_L, (bEnable?BIT(15):0), BIT(15));
}

void Hal_SC_Set_extra_fetch_line(void *pInstance, MS_U8 u8val)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_17_L, ((MS_U16)(u8val & 0x0F))<<8, 0x0F00);
}

void Hal_SC_Set_extra_adv_line(void *pInstance, MS_U8 u8val)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_17_L, ((MS_U16)(u8val & 0x0F))<<12, 0xF000);
}

void HAL_SC_Set_FPLL_Limit(void *pInstance, MS_U32 *u32PllSet, MS_U32 u32LowBound, MS_U32 u32UpBound, MS_BOOL _bInFPLLDbgMode, MS_U32 _U32LimitD5D6D7)
{
    MS_U32 u32LpllLimitLow = 0, u32LpllLimitHigh = 0;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    //printf("Fpll_Limit: Set %lx, bound (%lx -> %lx)\n", *u32PllSet, u32UpBound, u32LowBound);

    if(_bInFPLLDbgMode)
    {
        MDrv_WriteByteMask(L_BK_LPLL(0x0D), 0x00, BIT(4));          // turn off 2 limit
        if(!pXCResourcePrivate->stdrvXC_MVideo._SContext.bEnableFPLLManualDebug)
        {
            MDrv_Write3Byte(L_BK_LPLL(0x06), _U32LimitD5D6D7);
            MDrv_Write3Byte(L_BK_LPLL(0x08), _U32LimitD5D6D7);
        }
    }
    else
    {
        MDrv_WriteByteMask(L_BK_LPLL(0x0D), BIT(4), BIT(4));        // turn on 2 limit

        if (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_B & E_XC_INIT_MISC_B_HDMITX_ENABLE)
        {
            // For HDMI Tx case, skip LPLL limit checking
            // set LPLL limit as HW RD suggestion value
            u32LpllLimitHigh = LPLL_LIMIT_OFFSET;
            u32LpllLimitLow = LPLL_LIMIT_OFFSET;
        }
        else
        {
            // check if u32PllSet out of range and also the FPLL limit
            if (*u32PllSet <= u32LowBound)
            {
                *u32PllSet = u32LowBound;
                gSrcInfo[MAIN_WINDOW].bEnableFPLL = FALSE;
            }
            else if (*u32PllSet >= u32UpBound)
            {
                *u32PllSet = u32UpBound;
                gSrcInfo[MAIN_WINDOW].bEnableFPLL = FALSE;
            }

            u32LpllLimitHigh = u32UpBound - *u32PllSet;
            u32LpllLimitLow = *u32PllSet - u32LowBound - 1;
        }

        //printf("Fpll set %lx, limit (high %lx, low %lx)\n", *u32PllSet, u32LpllLimitHigh, u32LpllLimitLow);

        if(!pXCResourcePrivate->stdrvXC_MVideo._SContext.bEnableFPLLManualDebug)
        {
            MDrv_Write3Byte(L_BK_LPLL(0x06), u32LpllLimitHigh);
            MDrv_Write3Byte(L_BK_LPLL(0x08), u32LpllLimitLow);
        }

        //printf("Fpll limit reg (high %lx, low %lx)\n", MDrv_Read4Byte(L_BK_LPLL(0x06)), MDrv_Read4Byte(L_BK_LPLL(0x08)));
    }
}

void Hal_XC_H3D_Enable(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_70_L, MAIN_WINDOW), (bEn<<15), (BIT(15)));
#else
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_70_L, (bEn<<15), (BIT(15)));
#endif
}

void Hal_XC_H3D_Input3DType(void *pInstance, E_XC_3D_INPUT_MODE e3DType)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_7B_L, MAIN_WINDOW), (e3DType), (BIT(1) | BIT(0)));
#else
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_7B_L, (e3DType), (BIT(1) | BIT(0)));
#endif
}

void Hal_XC_H3D_Breakline_Enable(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_7B_L, MAIN_WINDOW), (bEn<<7), (BIT(7)));
#else
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_7B_L, (bEn<<7), (BIT(7)));
#endif
    if(bEn)
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_7B_L, MAIN_WINDOW), (8<<8), HBMASK);
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_7B_L, (8<<8), HBMASK);
#endif
    }
    else
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_7B_L, MAIN_WINDOW), (0<<8), HBMASK);
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_7B_L, (0<<8), HBMASK);
#endif
    }
}

void Hal_XC_H3D_HDE(void *pInstance, MS_U16 u16Hde)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_71_L, MAIN_WINDOW), (u16Hde), 0x0FFF);
#else
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_71_L, (u16Hde), 0x0FFF);
#endif
}

void Hal_XC_H3D_VDE_F0(MS_U16 u16Vde)
{
    SC_W2BYTEMSK(0, REG_SC_BK01_73_L, (u16Vde), 0x0FFF);
}

void Hal_XC_H3D_VDE_F2(MS_U16 u16Vde)
{
    SC_W2BYTEMSK(0, REG_SC_BK01_77_L, (u16Vde), 0x0FFF);
}

void Hal_XC_H3D_HBLANK(MS_U16 u16Hblank)
{
    SC_W2BYTEMSK(0, REG_SC_BK01_70_L, (u16Hblank), 0x03FF);
}

void Hal_XC_H3D_INIT_VBLANK(MS_U8 u8Vblank)
{
    SC_W2BYTEMSK(0, REG_SC_BK01_72_L, (u8Vblank), LBMASK);
}

void Hal_XC_H3D_VBLANK0(MS_U8 u8Vblank)
{
    SC_W2BYTEMSK(0, REG_SC_BK01_74_L, (u8Vblank), LBMASK);
}

void Hal_XC_H3D_VBLANK1(MS_U8 u8Vblank)
{
    SC_W2BYTEMSK(0, REG_SC_BK01_76_L, (u8Vblank), LBMASK);
}

void Hal_XC_H3D_VBLANK2(MS_U8 u8Vblank)
{
    SC_W2BYTEMSK(0, REG_SC_BK01_78_L, (u8Vblank), LBMASK);
}

void Hal_XC_H3D_VSYNC_WIDTH(MS_U8 u8Width)
{
    SC_W2BYTEMSK(0, REG_SC_BK01_7A_L, (u8Width), 0x001F);
}

void Hal_XC_H3D_VSYNC_POSITION(MS_U16 u16Position)
{
    SC_W2BYTEMSK(0, REG_SC_BK01_7A_L, (u16Position), HBMASK);
}

void Hal_XC_H3D_SELECT_REGEN_TIMING(MS_BOOL bEn)
{
    SC_W2BYTEMSK(0, REG_SC_BK01_7B_L, (bEn<<4), (BIT(4)));
}

void Hal_XC_H3D_LR_Toggle_Enable(void *pInstance, MS_BOOL bEn, MS_BOOL b2DTo3D, MS_BOOL bSkipDefaultLRFlag)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(!bSkipDefaultLRFlag)
    {
        if(bEn)
        {
            //Enanble I2S_IN_SD to send out lr flag
            MDrv_WriteByteMask(0x101E24, 0x00, BIT(4)|BIT(5)|BIT(6));
            MDrv_WriteByteMask(0x101EC9, 0x00, BIT(0)|BIT(1));
            MDrv_WriteByteMask(0x101EDC, 0x00, BIT(2));
            MDrv_WriteByteMask(0x101EB3, 0xC0, 0xC0);
            // after timing change , hw must do  L/R alignment,BK12, 33[2]=1 to enable it.
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_33_L, BIT(2), BIT(2));
        }
        else
        {
            MDrv_WriteByteMask(0x101EB3, 0x00, 0xC0);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_33_L, 0, BIT(2));
        }
    }

    ///3D lr flag selection: RD's advice
    ///{BK20_24[13], BK20_24[11], BK20_24[1:0]}
    ///4'b0100: source 3D + FB
    ///4'b0101: source 3D + RFBL
    ///4'b0111: 2D to 3D
    ///4'b1000: FRC on : controlled by Hal_XC_Enable_FRC_3D_LR_Flag.
    if(bEn)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_24_L, BIT(11), BIT(11));        //Output 3D L/R selection
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_30_L, (bEn<<8), (BIT(8))); //enable Enable free run 3D LR flag: if disable, when image freezed,the output is always L or always R.
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_33_L, (bEn<<1), (BIT(1)));//L first,

        if(b2DTo3D)
        {
            if(pXCResourcePrivate->stdrvXC_3D._bFALLRRToFA)//output FA_LLRR for 4k0.5k@240Hz
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_24_L, 0x00, BIT(0)|BIT(1));
            }
            else
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_24_L, BIT(0)|BIT(1), BIT(0)|BIT(1));
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_30_L, BIT(11), (BIT(11)));
            }
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_33_L, BIT(15), BIT(15));///2Dto3D LR flag enable
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_24_L, 0x00, BIT(0)|BIT(1));
        }
    }
    else
   {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_24_L, 0x0000, BIT(0)|BIT(1)|BIT(11));        //Output 3D L/R selection
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_30_L, 0, (BIT(8))); //enable Enable free run 3D LR flag
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_33_L, 0, (BIT(1)));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_33_L, 0, BIT(15));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_30_L, 0, (BIT(11)));
    }
}

void Hal_SC_3D_Enable_FRC_LR_Flag(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    //BK20_24[13] = 1: use FRC LR flag, BK20_24[13] = 0: use scaler LR flag
    if(bEnable)//FRC 3D enabled
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_24_L, BIT(13), BIT(13));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_24_L, 0, BIT(13));
    }
}

void HAL_XC_H3D_OPM_SBYS_PIP_Enable(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_34_L, (bEn<<7), (BIT(7)));
}

void Hal_SC_enable_cursor_report(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(bEn)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_57_L, BIT(8) | BIT(10), BIT(8) | BIT(10));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_57_L, 0x00 , BIT(8) | BIT(10));
    }
}

MS_BOOL Hal_SC_get_pixel_rgb(void *pInstance, XC_Get_Pixel_RGB *pData)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_BOOL bret = TRUE;

    switch(pData->enStage)
    {
        case E_XC_GET_PIXEL_STAGE_AFTER_DLC:
            //SC_W2BYTEMSK(0, REG_SC_BK0F_46_L, 0x00 , BMASK(3:0));
            bret = FALSE;//Not support, Must set to stage C for HW issue
            break;
        case E_XC_GET_PIXEL_STAGE_PRE_GAMMA:
            //SC_W2BYTEMSK(0, REG_SC_BK0F_46_L, 0x08, BMASK(3:0));
            bret = FALSE;//Not support, Must set to stage C for HW issue
            break;
        case E_XC_GET_PIXEL_STAGE_AFTER_OSD:
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_18_L, 0x0D, 0xFF);
            break;
        default:
            bret = FALSE;
            break;
    }
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    if(bret)
    {
        // Enable
        if(!pXCResourcePrivate->stdrvXC_MVideo.s_bKeepPixelPointerAppear)
        {
            Hal_SC_enable_cursor_report(pInstance, TRUE);
        }

        // Initial position (x,y)  Set point you want to read.
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_19_L, pData->u16x);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_1A_L, pData->u16y);

        //SW trigger for reading
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_18_L, BIT(8), BIT(8));
        MsOS_DelayTask(5);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_18_L, 0, BIT(8));
        MsOS_DelayTask(32);  // Must wait .

        pData->u32r = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_2D_L);
        pData->u32g = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_2E_L);
        pData->u32b = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_2F_L);

        // Disable
        if(!pXCResourcePrivate->stdrvXC_MVideo.s_bKeepPixelPointerAppear)
        {
            Hal_SC_enable_cursor_report(pInstance, FALSE);
        }
    }
    return bret;
}

void Hal_SC_SetOPWriteOff(void *pInstance, MS_BOOL bEna)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_BOOL u16OldReg = (MS_BOOL)(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_27_L, BIT(0)));

#if (HW_DESIGN_4K2K_VER == 4)
    // For monaco new chip design, only Legacy mode need to control OPW
    // If Monaco mode, always keep OPW is on
    if ((psXCInstPri->u32DeviceID==0)
        && !(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE))
    {
        bEna = FALSE;
    }
#endif

    if(u16OldReg != bEna)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_27_L, bEna, BIT(0));//This will stop OPW only, OP memory write request still on
    }
}


MS_BOOL Hal_SC_GetOPWriteOff(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    return (MS_BOOL)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_27_L, BIT(0));
}

MS_BOOL Hal_SC_Detect_RequestFBL_Mode(void *UNUSED_PARA(pInstance))
{
    return ENABLE_REQUEST_FBL;
}

MS_BOOL Hal_SC_Set_RequestFBL_Mode(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

#ifdef UFO_XC_HDR
#if (UFO_XC_HDR_VERSION == 2)
    if (IsSrcTypeHDMI(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        // enable hdr dma seamless with rfbl mode on maserati
        MApi_XC_W2BYTEMSK(REG_SC_BK79_03_L, 1, BIT(15));
    }
#endif
#endif

    return ENABLE_REQUEST_FBL;
}

static MS_BOOL _MHal_XC_ConfirmYuvFormat(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_BOOL bRet = FALSE;


    if((!(IsSrcTypeStorage(gSrcInfo[MAIN_WINDOW].enInputSourceType)))
 #if (FRC_INSIDE && (HW_DESIGN_4K2K_VER == 6))
        && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFSCEnabled == TRUE)
#endif
        &&(MDrv_XC_GetDynamicScalingStatus(pInstance) || MDrv_XC_Is_DSForceIndexEnabled(pInstance, MAIN_WINDOW) ))
    {
        bRet = TRUE;
    }
    else
    {
        bRet = FALSE;
    }

    return bRet;
}

void Hal_XC_SetFrameColor(void *pInstance, MS_U32 u32aRGB)
{
    MS_BOOL bRet = FALSE;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    bRet = _MHal_XC_ConfirmYuvFormat(pInstance);

    if(bRet == TRUE)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_29_L,  ((u32aRGB & 0xff )<<2), 0x03ff);                          ///< Cb
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_2A_L,  (((u32aRGB & 0xff00)>>8)<<2),0x03ff);              ///< Y
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_2B_L,  (((u32aRGB & 0xff0000)>>16)<<2),0x03ff);         ///< Cr
    }
    else
    {

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_19_L,  (u32aRGB >> 8),0xFF00);            ///< R
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_1A_L,  (u32aRGB >> 8),0x00FF);            ///< G
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_1A_L,  (u32aRGB << 8),0xFF00);            ///< B
    }

}
MS_U8 Hal_SC_getVSyncWidth(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U8 u8val = 0;

    if(eWindow == MAIN_WINDOW)
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        u8val = ((SC_R2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_22_L, eWindow)) & HBMASK) >> 8);
#else
        u8val = ((SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK01_22_L) & HBMASK) >> 8);
#endif
    }
    else
    {
    }
    return u8val;
}

MS_U16 Hal_SC_Set_OSDZorderLayer(E_VIDEO_ON_OSD_LAYER enlayer)
{
    MS_U16 u16RegVal = 0;

    switch (enlayer) // translate layer to register value
    {
        case E_VIDEO_ON_OSD_LAYER_DEAFULT:
            u16RegVal = 0;
            break;
        case E_VIDEO_ON_OSD_LAYER_0:
            u16RegVal = 1;    ///< osd layer 0 -> video -> osd layer 1 -> osd layer 2 -> osd layer 3 -> osd layer 4
            break;
        case E_VIDEO_ON_OSD_LAYER_1:
            u16RegVal = 2;    ///< osd layer 0 -> osd layer 1 -> video -> osd layer 2 -> osd layer 3 -> osd layer 4
            break;
        case E_VIDEO_ON_OSD_LAYER_2:
            u16RegVal = 3;    ///< osd layer 0 -> osd layer 1 -> osd layer 2 -> video -> osd layer 3 -> osd layer 4
            break;
        case E_VIDEO_ON_OSD_LAYER_3:
            u16RegVal = 4;    ///< osd layer 0 -> osd layer 1 -> osd layer 2 -> osd layer 3 -> video -> osd layer 4
            break;
        case E_VIDEO_ON_OSD_LAYER_4:
        default:
            u16RegVal = 5;    ///< osd layer 0 -> osd layer 1 -> osd layer 2 -> osd layer 3 -> osd layer 4 -> video
            break;
    }
    return u16RegVal;
}

E_APIXC_ReturnValue Hal_SC_Set_OSDLayer(void *pInstance, E_VOP_OSD_LAYER_SEL  eVOPOSDLayer, SCALER_WIN eWindow)
{
    return E_APIXC_RET_FAIL;
}

E_VOP_OSD_LAYER_SEL Hal_SC_Get_OSDLayer(void *pInstance, SCALER_WIN eWindow)
{
    //do nothing
    return E_VOP_LAYER_RESERVED;
}

E_APIXC_ReturnValue Hal_SC_Set_VideoAlpha(void *pInstance, MS_U8 u8Val, SCALER_WIN eWindow)
{
    //do nothing
    return E_APIXC_RET_FAIL;
}

E_APIXC_ReturnValue Hal_SC_Get_VideoAlpha(void *pInstance, MS_U8 *pu8Val, SCALER_WIN eWindow)
{
    *pu8Val += 0;

    //do nothing
    return E_APIXC_RET_FAIL;
}

E_APIXC_ReturnValue Hal_SC_SetOSDBlendingFormula(void *pInstance, E_XC_OSD_INDEX enOsdIndex, E_XC_OSD_BlENDING_TYPE enType, SCALER_WIN eWindow)
{
    E_APIXC_ReturnValue bRet = E_APIXC_RET_OK;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if (eWindow == MAIN_WINDOW)
    {
        switch(enOsdIndex)
        {
            case E_XC_OSD_0:
                if(E_XC_OSD_BlENDING_MODE1 == enType) //OSD + (1-a)*Video
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_5B_L, BIT(5)|BIT(4), BIT(5)|BIT(4));
                    //osd check alpha define
                    //1: for define 8'hFF is transparent
                    //0: for define 8'h00 is transparent
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_6B_L, BIT(0), BIT(0));
                    // for zorder
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_6B_L, BIT(15), BIT(15));

#if (FRC_INSIDE && (HW_DESIGN_4K2K_VER == 6))
#ifdef GOP_SUPPORT_DUALRATE
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_50_L, BIT(10), BIT(10));
#endif
#endif
                }
                else //a*OSD +(1-a)*Video
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_5B_L, 0x00, BIT(5)|BIT(4));
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_6B_L, 0x00, BIT(0));
                    // for zorder
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_6B_L, 0, BIT(15));

#if (FRC_INSIDE && (HW_DESIGN_4K2K_VER == 6))
#ifdef GOP_SUPPORT_DUALRATE
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_50_L, 0, BIT(10));
#endif
#endif
                }
                break;

            case E_XC_OSD_1:
                if(E_XC_OSD_BlENDING_MODE1 == enType) //OSD + (1-a)*Video
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_5B_L, BIT(7)|BIT(6), BIT(7)|BIT(6));
                    //osd check alpha define
                    //1: for define 8'hFF is transparent
                    //0: for define 8'h00 is transparent
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_6B_L, BIT(1), BIT(1));
                    // for zorder
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_60_L, BIT(15), BIT(15));

#if (FRC_INSIDE && (HW_DESIGN_4K2K_VER == 6))
#ifdef GOP_SUPPORT_DUALRATE
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_51_L, BIT(10), BIT(10));
#endif
#endif
                }
                else //a*OSD + (1-a)*Video
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_5B_L, 0x00, BIT(7)|BIT(6));
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_6B_L, 0x00, BIT(1));
                    // for zorder
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_60_L, 0, BIT(15));

#if (FRC_INSIDE && (HW_DESIGN_4K2K_VER == 6))
#ifdef GOP_SUPPORT_DUALRATE
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_51_L, 0, BIT(10));
#endif
#endif
                }
                break;

            case E_XC_OSD_2:
                if(E_XC_OSD_BlENDING_MODE1 == enType) //OSD + (1-a)*Video
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_5B_L, BIT(9)|BIT(8), BIT(9)|BIT(8));
                    //osd check alpha define
                    //1: for define 8'hFF is transparent
                    //0: for define 8'h00 is transparent
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_6B_L, BIT(2), BIT(2));
                    // for zorder
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_61_L, BIT(15), BIT(15));

#if (FRC_INSIDE && (HW_DESIGN_4K2K_VER == 6))
#ifdef GOP_SUPPORT_DUALRATE
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_52_L, BIT(10), BIT(10));
#endif
#endif
                }
                else //a*OSD + (1-a)*Video
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_5B_L, 0x00, BIT(9)|BIT(8));
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_6B_L, 0x00, BIT(2));
                    // for zorder
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_61_L, 0, BIT(15));

#if (FRC_INSIDE && (HW_DESIGN_4K2K_VER == 6))
#ifdef GOP_SUPPORT_DUALRATE
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_52_L, 0, BIT(10));
#endif
#endif
                }
                break;
#if (OSD_LAYER_NUM > 3)
            case E_XC_OSD_3:
                if(E_XC_OSD_BlENDING_MODE1 == enType) //OSD + (1-a)*Video
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_5B_L, BIT(13)|BIT(12), BIT(13)|BIT(12));
                    //osd check alpha define
                    //1: for define 8'hFF is transparent
                    //0: for define 8'h00 is transparent
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_6B_L, BIT(3), BIT(3));
                    // for zorder
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_62_L, BIT(15), BIT(15));
                }
                else //a*OSD + (1-a)*Video
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_5B_L, 0x00, BIT(13)|BIT(12));
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_6B_L, 0x00, BIT(3));
                    // for zorder
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_62_L, 0, BIT(15));
                }
                break;
#endif
#if (OSD_LAYER_NUM > 4)
            case E_XC_OSD_4:
                if(E_XC_OSD_BlENDING_MODE1 == enType) //OSD + (1-a)*Video
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_5B_L, BIT(15)|BIT(14), BIT(15)|BIT(14));
                    //osd check alpha define
                    //1: for define 8'hFF is transparent
                    //0: for define 8'h00 is transparent
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_6B_L, BIT(4), BIT(4));
                    // for zorder
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_1B_L, BIT(15), BIT(15));
                }
                else //a*OSD + (1-a)*Video
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_5B_L, 0x00, BIT(15)|BIT(14));
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_6B_L, 0x00, BIT(4));
                    // for zorder
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_1B_L, 0, BIT(15));
                }
                break;
#endif
            default:
                printf("[MDrv_SC_SetOSDBlendingFormula]Invalid Parameter!enOsdIndex=%u\n", enOsdIndex);
                bRet = E_APIXC_RET_FAIL_INVALID_PARAMETER;
                break;
        }
    }
    else
    {
        // do nothing
        printf("[MDrv_SC_SetOSDBlendingFormula] Not support sub window now \n");
        bRet = E_APIXC_RET_FAIL_FUN_NOT_SUPPORT;
    }

    return bRet;
}
void Hal_XC_ClearScalingFactorForInternalCalib(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    //MDrv_WriteRegBit(H_BK_SCMI(0x09), FALSE, BIT(7));
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_04_L, 0x0000);   // H pre-scaling
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_05_L, 0xC010);   // H pre-scaling
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_08_L, 0x0000);   // V pre-scaling
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_09_L, 0x0000);   // V pre-scaling

    //HVSP
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_07_L, 0x0000);  // H post-scaling
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_08_L, 0x0100);  // H post-scaling
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_09_L, 0x0000);  // V post-scaling
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_0A_L, 0x0100);  // V post-scaling
}

MS_U8 MHal_SC_cal_usedgain_to_reggain(MS_U32 u16UsedGain_x32)
{
    MS_U8 u8Value = 0;

    if      (u16UsedGain_x32 >=65536) u8Value = 16;
    else if (u16UsedGain_x32 >=32768) u8Value = 15;
    else if (u16UsedGain_x32 >=16384) u8Value = 14;
    else if (u16UsedGain_x32 >= 8192) u8Value = 13;
    else if (u16UsedGain_x32 >= 4096) u8Value = 12;
    else if (u16UsedGain_x32 >= 2048) u8Value = 11;
    else if (u16UsedGain_x32 >= 1024) u8Value = 10;
    else if (u16UsedGain_x32 >=  512) u8Value = 9;
    else if (u16UsedGain_x32 >=  256) u8Value = 8;
    else if (u16UsedGain_x32 >=  128) u8Value = 7;
    else if (u16UsedGain_x32 >=   64) u8Value = 6;
    else if (u16UsedGain_x32 >=   32) u8Value = 5;
    else if (u16UsedGain_x32 >=   16) u8Value = 4;
    else if (u16UsedGain_x32 >=    8) u8Value = 3;
    else if (u16UsedGain_x32 >=    4) u8Value = 2;
    else if (u16UsedGain_x32 >=    2) u8Value = 1;
    else if (u16UsedGain_x32 >=    1) u8Value = 0;
    else
    {
        u8Value = 0;
    }

    u8Value += IPGAIN_REFACTOR;

    return u8Value;
}

E_APIXC_ReturnValue Hal_SC_OP2VOPDESel(void *pInstance, E_OP2VOP_DE_SEL eVopDESel)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    //Select op2vop de, for DWIN capture etc
    if(eVopDESel == E_OP2VOPDE_WHOLEFRAME_WITHOSD)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_6B_L, ((MS_U16)(E_OP2VOPDE_WHOLEFRAME) << 12), (BIT(12)+BIT(13)));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_23_L, BIT(15), BIT(15));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_23_L, 0, BIT(15));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_6B_L, (eVopDESel << 12), (BIT(12)+BIT(13)));
    }
    return E_APIXC_RET_OK;
}

MS_BOOL Hal_XC_SVOutput_GetCaps(void *pInstance)
{
    return FALSE;
}

/////Add for FRC
void _MHal_SC_Flock_Caculate_LPLLSet(MS_U32 u32Dclk)
{
#if 0 // Manhattan only 1 LPLL
    MS_U64 ldPllSet = 0xff;

    ldPllSet = ((MS_U64)320 * 524288 * 10000000 + (u32Dclk>>1));  // LPLL BK01 LPLL Set
    do_div(ldPllSet, u32Dclk);

    LPLL_BK_STORE;
    LPLL_BK_SWITCH(0x01);
    W4BYTE(L_BK_LPLL(0x0F), (MS_U32)ldPllSet);
    LPLL_BK_RESTORE;
#endif
}

void _MHal_SC_Set_LPLL_Limit(MS_U32 u32LpllLimitHigh, MS_U32 u32LpllLimitLow, MS_U8 u8Lpll_bank)
{
    //printf("Fpll_Limit: Set %lx, bound (%lx -> %lx)\n", *u32PllSet, u32UpBound, u32LowBound);
    LPLL_BK_STORE;
    LPLL_BK_SWITCH(u8Lpll_bank);


    MDrv_WriteByteMask(L_BK_LPLL(0x0D), BIT(4), BIT(4));        // turn on 2 limit

    //printf("Fpll set %lx, limit (high %lx, low %lx)\n", *u32PllSet, u32LpllLimitHigh, u32LpllLimitLow);
    MDrv_Write3Byte(L_BK_LPLL(0x06), u32LpllLimitHigh);
    MDrv_Write3Byte(L_BK_LPLL(0x08), u32LpllLimitLow);

    //printf("Fpll limit reg (high %lx, low %lx)\n", MDrv_Read4Byte(L_BK_LPLL(0x06)), MDrv_Read4Byte(L_BK_LPLL(0x08)));

    LPLL_BK_RESTORE;
}
#define LVDS_FRC_CLOCK_MHZ  320
void _MHal_SC_Flock_Set_IGainPGain(void *pInstance, MS_U8 u8FRC_Out, MS_U16 u16OutputVfreqAfterFRC, MS_U16 u16Htt, MS_U16 u16Vtt)
{
#if 0 // Manhattan only 1 LPLL
    MS_U32  u32dclk=0;
    MS_U8   u8GainI, u8GainP;
    MS_U64  u64Div_Factor;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    //check parameter valid, avoiding the diving zero failure
    if(0 == u8FRC_Out)
    {
        u8FRC_Out = 1;
    }

    u32dclk = (MS_U32)(u16Vtt * u16Htt * u8FRC_Out);
    //u64Div_Factor = (MS_U64)LVDS_FRC_CLOCK_MHZ*524288*1000000/pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32XTAL_Clock;
    u64Div_Factor = (MS_U64)LVDS_FRC_CLOCK_MHZ*524288*1000000;
    do_div(u64Div_Factor, pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32XTAL_Clock);
    do_div(u64Div_Factor, (MS_U32)u32dclk * 8);

    u8GainI = MHal_SC_cal_usedgain_to_reggain(u64Div_Factor);

    if((u8FRC_Out == 5)&&(u64Div_Factor==0))
    {
        //24 to 60Hz, because the SW can't get the real value by log table
        u8GainI = 1;

        u8GainI += 2;
    }

    u8GainP = u8GainI+1;
    if((u8FRC_Out >= 2) && (u8GainP == u8GainI))
    {
        u8GainP++;
    }

    LPLL_BK_STORE;
    LPLL_BK_SWITCH(0x01);
    MDrv_WriteByte(H_BK_LPLL(0x0B), (u8GainP<<4)|u8GainI);  //Gain
    LPLL_BK_RESTORE;
    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "i_Gain= 0x%tx (%tu)\n", (ptrdiff_t)u64Div_Factor, (ptrdiff_t)u64Div_Factor)
    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "REG_IGain= 0x%x (%u)\n", u8GainI, u8GainI)
    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "REG_PGain= 0x%x (%u)\n", u8GainP, u8GainP)
#endif
}


void _MHal_SC_Flock_Set_LPLL_Enable(E_XC_FLOCK_TYPE eFlock_type)
{
#if 0 // Manhattan only 1 LPLL
    MS_BOOL bDiv_en = DISABLE;

    switch(eFlock_type)
    {
        case E_XC_FLOCK_DIV_ON:
            bDiv_en = ENABLE;
            break;

        case E_XC_FLOCK_FPLL_ON:
        case E_XC_FLOCK_DIV_OFF:
        default:
            break;
    }

    LPLL_BK_STORE;
    LPLL_BK_SWITCH(0x01);
    MDrv_Write2ByteMask(L_BK_LPLL(0x7F), bDiv_en?BIT(8):0, BIT(8));
    LPLL_BK_RESTORE;
#endif

}

E_APIXC_ReturnValue Hal_XC_IsForcePrescaling(void *pInstance, const XC_InternalStatus *pSrcInfo, MS_BOOL *pbForceV, MS_BOOL *pbForceH, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    *pbForceV = FALSE;
    *pbForceH = FALSE;

    //-----------------------------------------
    // Vertical
    //-----------------------------------------

    //FHD case. FHD has tight bandwidth in FCLK (post scaling), so force pre-scaling if disp.v size > 80% of crop.v size.
    if ( (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height > 1000) &&
         (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width > 1600) ) //consider 1680x1050 into this case
    {
        // 80%
        if ( ( pSrcInfo->stDispWin.height * 11 ) <  ( pSrcInfo->stCropWin.height * 9 ) )
        {
            *pbForceV = TRUE;
        }

        // for 4096x2304 MM video, force pre-scaling
        if ((IS_4K2K_PANEL) &&    // 4K2K panel
            ( (pSrcInfo->stCropWin.height > HEIGHT_4K2K) || ( IS_DS_OPEN_IN_HAL(eWindow) && IS_OVER_VIRTUAL_HEIGHT(pSrcInfo->stCapWin.height,eWindow)) )  )
        {
            *pbForceV = TRUE;
        }

    }
    else // SD, HD panel.
    {
        // 60%
        if ( ( pSrcInfo->stDispWin.height * 10 ) <  ( pSrcInfo->stCropWin.height * 6 ) )
        {
            *pbForceV = TRUE;
        }
    }

    //-----------------------------------------
    // Horizontal
    //-----------------------------------------

    if ( (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height > 1000)
         && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width > 1600) ) //consider 1680x1050 into this case
    {
        // 80% ( SEC using 80% for HD panel ). Increase % if meet FCLK bandwidth issue in the future.
        if ( ( pSrcInfo->stDispWin.width * 10 ) < ( pSrcInfo->stCropWin.width * 8 ) )
        {
            *pbForceH = TRUE;
        }

        // for 4096x2304 MM video, force pre-scaling
        if ((IS_4K2K_PANEL) &&    // 4K2K panel
            ( (pSrcInfo->stCropWin.width > WIDTH_4K2K) || ( IS_DS_OPEN_IN_HAL(eWindow) && IS_OVER_VIRTUAL_WIDTH(pSrcInfo->stCapWin.width,eWindow)) ) )
        {
            *pbForceH = TRUE;
        }
    }
    else // SD panel.
    {
        // 60%
        if ( ( pSrcInfo->stDispWin.width * 10 ) < ( pSrcInfo->stCropWin.width * 6 ) )
        {
            *pbForceH = TRUE;
        }
    }

    if (psXCInstPri->u32DeviceID == 1)
    {
        // SC1 attach sc0, postscaling down performance not enough
        if ( ( pSrcInfo->stDispWin.height ) <  ( pSrcInfo->stCropWin.height) )
        {
            *pbForceV = TRUE;
        }
        if ( ( pSrcInfo->stDispWin.width) < ( pSrcInfo->stCropWin.width) )
        {
            *pbForceH = TRUE;
        }
    }
    return E_APIXC_RET_OK;
}

MS_BOOL Hal_SC_IsHW2Dto3DPatch_Enable(void)
{
    MS_BOOL bRet = FALSE;
    if(PM_R1BYTE(REG_CHIP_REVISION, 7:0) < 1)//a1 u01 2d to 3d hw bug
    {
        bRet = TRUE;
    }
    return bRet;
}

MS_U32 MHal_SC_Get_LpllSet_Factor(void *pInstance, MS_U8 u8LPLL_Mode, MS_U8 u8LPLL_Type,MS_U32 u32DefaultDClk)
{
    MS_U32 u32Factor = 0;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    u32Factor  = LPLL_LOOPGAIN/8/2;

    if ((pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HTotal> 3000) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VTotal > 2000) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16DefaultVFreq > 500))
    {
        //printf("\033[0;31m [%s][%d] enter For 4K2K used!!!  \033[0m\n", __FUNCTION__, __LINE__);
        u32Factor = 1;
    }

    if ((MS_S32)u8LPLL_Type == E_XC_PNL_LPLL_LVDS)
    {
        u32Factor = 15;
    }

    // for the WUXGA 1920x1200 case
    if((u8LPLL_Mode==E_XC_MOD_OUTPUT_DUAL)&&(u32DefaultDClk > 1500000000)
       &&(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height > 1100)
       &&(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width < 2000))
    {
        u32Factor  = 13;
    }

    if (IsVBY1((MS_S32)u8LPLL_Type))
    {
        u32Factor = 3;
    }
    else if ((MS_S32)u8LPLL_Type == E_XC_PNL_LPLL_TTL)
    {
        u32Factor = 7;
    }
    else if(IsTCON((MS_S32)u8LPLL_Type))
    {
        u32Factor = 3;
    }

    // For Maxim HDMI Tx
    if (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_B & E_XC_INIT_MISC_B_HDMITX_ENABLE)
    {
        u32Factor = 1;
    }
    return u32Factor;
}

MS_U32 MHal_SC_Get_LpllSet_Div(void *pInstance, MS_U8 u8LPLL_Mode, MS_U8 u8LPLL_Type,MS_U32 u32DefaultDClk)
{
    MS_U32 u32Div = 1;

    if ((MS_S32)u8LPLL_Type == E_XC_PNL_LPLL_LVDS)
    {
        u32Div = 5;
    }
    else if (IsVBY1((MS_S32)u8LPLL_Type))
    {
        u32Div = 2;
    }
    else if ((MS_S32)u8LPLL_Type == E_XC_PNL_LPLL_TTL)
    {
        u32Div = 6;
    }
    if(IsTCON((MS_S32)u8LPLL_Type))
    {
        u32Div = 2;
    }
    return u32Div;
}

E_APIXC_ReturnValue Hal_SC_Enable_AVMute(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if (eWindow == MAIN_WINDOW)
    {
        //HDMI V-mute detect enable
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_34_L, BIT(9), BIT(9));
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        // init stage, av mute used for HDMI only
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_34_L, BIT(9), BIT(9));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_34_L, BIT(9), BIT(9));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_34_L, BIT(9), BIT(9));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_34_L, BIT(9), BIT(9));
#endif
        //force IPM enable at av-mute case
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_19_L, BIT(5), BIT(5));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_19_L, BIT(5), BIT(5));

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_01_L, BIT(13) | BIT(15), BIT(13) | BIT(15));
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
        // SC1 as subwindow case, use bank25_2E to back main window,HW bug fix after manhattan U02
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK25_2E_L, BIT(2), BIT(2));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_23_L, BIT(9) | BIT(11), BIT(9) | BIT(11));
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_23_L, BIT(9) | BIT(11), BIT(9) | BIT(11));
#endif
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        //HW bug fast switch have a conflict with av mute,HW suggests closing bank1310_10[9] ,just use IP_34[9] instead(chip:morton)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_23_L, 0, BIT(9));
#endif
    }
    else
    {
        //HDMI V-mute detect enable
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_34_L, BIT(9), BIT(9));
        //force IPM enable at av-mute case
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_59_L, BIT(5), BIT(5));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_59_L, BIT(5), BIT(5));

        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_01_L, BIT(12) | BIT(14), BIT(12) | BIT(14));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_23_L, BIT(8) | BIT(10), BIT(8) | BIT(10));
    }

    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue Hal_SC_Disable_AVMute(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if (eWindow == MAIN_WINDOW)
    {
        //HDMI V-mute detect enable
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_34_L, MAIN_WINDOW), 0, BIT(9));
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_34_L, 0, BIT(9));
#endif
    }
    else
    {
        //HDMI V-mute detect enable
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_34_L, 0, BIT(9));
    }
    return E_APIXC_RET_OK;
}

MS_BOOL Hal_XC_SetPixelInfo(void *pInstance, MS_XC_REPORT_PIXELINFO *pstRepPixInfo, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_BOOL bret = TRUE;
    if(bEnable)
    {
        switch(pstRepPixInfo->enStage)
        {
            case E_XC_GET_PIXEL_STAGE_AFTER_DLC:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_46_L, 0x00 , BMASK(3:0));
                break;
            case E_XC_GET_PIXEL_STAGE_PRE_GAMMA:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_46_L, 0x08, BMASK(3:0));
                break;
            case E_XC_GET_PIXEL_STAGE_AFTER_OSD:
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_46_L, 0x0C, BMASK(3:0));
                break;
            default:
                bret = FALSE;
                break;
        }

        if(bret)
        {
            // Enable
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_57_L, BIT(8), BIT(8));

            if(pstRepPixInfo->bShowRepWin)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_57_L, BIT(9), BIT(9));
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_46_L, pstRepPixInfo->u16RepWinColor<<8, 0xFF00);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_1A_L, BIT(0), BIT(0));
            }

            // Set Report Window
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_42_L, pstRepPixInfo->u16XStart);
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_43_L, pstRepPixInfo->u16XEnd);
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_44_L, pstRepPixInfo->u16YStart);
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_45_L, pstRepPixInfo->u16YEnd);
        }
    }
    else
    {
        if(pstRepPixInfo->bShowRepWin)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_1A_L, 0x00, BIT(0));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_57_L, 0x00, BIT(9));
        }
        // Disable
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_57_L, 0x00, BIT(8));
    }

    return bret;
}

MS_BOOL Hal_XC_GetPixelInfo(void *pInstance, MS_XC_REPORT_PIXELINFO *pstRepPixInfo)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_BOOL bret = TRUE;

    pstRepPixInfo->u16RCrMin = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_64_L);
    pstRepPixInfo->u16RCrMax = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_65_L);
    pstRepPixInfo->u16GYMin  = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_66_L);
    pstRepPixInfo->u16GYMax  = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_67_L);
    pstRepPixInfo->u16BCbMin = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_68_L);
    pstRepPixInfo->u16BCbMax = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK0F_69_L);
    pstRepPixInfo->u32RCrSum = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK2D_01_L)|(SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK2D_02_L)<<16);
    pstRepPixInfo->u32GYSum  = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK2D_03_L)|(SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK2D_04_L)<<16);
    pstRepPixInfo->u32BCbSum = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK2D_05_L)|(SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK2D_06_L)<<16);

    return bret;
}

void Hal_SC_set_mrq_miusel(void *pInstance, MS_U8 u8MIUSel)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    // Scaler control MRQ MIU and MCDI MIU sel by itself
    // So MIU1 IP-select is set to 1. At this moment, MIU0 Miu select is not working.
    if (u8MIUSel==0)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_07_L, 0, BIT(8)|BIT(9));     // reg_mrq_miu_sel to MIU0
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_04_L, 0, BIT(0)|BIT(1));     // reg_mcdi_arb_sel0 to MIU0
    }
    else if (u8MIUSel==1)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_07_L, BIT(8), BIT(8)|BIT(9));     // reg_mrq_miu_sel to MIU1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_04_L, BIT(0), BIT(0)|BIT(1));     // reg_mcdi_arb_sel0 to MIU1
    }
    else if (u8MIUSel==2)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_07_L, BIT(9), BIT(8)|BIT(9));     // reg_mrq_miu_sel to MIU2
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_04_L, BIT(1), BIT(0)|BIT(1));     // reg_mcdi_arb_sel0 to MIU2
    }
}

MS_PHY Hal_SC_get_mcdi_memoryaddressfromreg(void *pInstance, E_XC_MCDI_TYPE eType)
{
    MS_PHY phyFBAddressTemp = 0;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if (eType == E_XC_MCDI_BOTH) // MAIN
    {
        phyFBAddressTemp = ((MS_PHY)SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_0A_L)) * MCDI_BYTE_PER_WORD;
    }
    else if(eType == E_XC_MCDI_SUB_BOTH) // SUB
    {
        phyFBAddressTemp = ((MS_PHY)SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_28_L)) * MCDI_BYTE_PER_WORD;
    }
    else if(eType == E_XC_MCDI_ME1)
    {
        phyFBAddressTemp = ((MS_PHY)SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_0A_L)) * MCDI_BYTE_PER_WORD; // MAIN ME1 address
    }
    else if (eType == E_XC_MCDI_ME2)
    {
        phyFBAddressTemp = ((MS_PHY)SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_12_L)) * MCDI_BYTE_PER_WORD; // MAIN ME2 address
    }
    else if (eType == E_XC_MCDI_SUB_ME1)
    {
        phyFBAddressTemp = ((MS_PHY)SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_28_L)) * MCDI_BYTE_PER_WORD; // SUB ME1 address
    }
    else if (eType == E_XC_MCDI_SUB_ME2)
    {
        phyFBAddressTemp = ((MS_PHY)SC_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_2C_L)) * MCDI_BYTE_PER_WORD; // SUB ME2 address
    }
    return phyFBAddressTemp;
}

void Hal_SC_set_mcdi_memoryaddress(void *pInstance, MS_PHY u32FBAddress, E_XC_MCDI_TYPE eType)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if (eType == E_XC_MCDI_BOTH) // MAIN
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_0A_L, u32FBAddress / MCDI_BYTE_PER_WORD);     // MAIN ME1 address
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_12_L, u32FBAddress / MCDI_BYTE_PER_WORD);     // MAIN ME2 address
    }
    else if(eType == E_XC_MCDI_SUB_BOTH) // SUB
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_28_L, u32FBAddress / MCDI_BYTE_PER_WORD);     // SUB ME1 address
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_2C_L, u32FBAddress / MCDI_BYTE_PER_WORD);     // SUB ME2 address
    }
    else if(eType == E_XC_MCDI_ME1)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_0A_L, u32FBAddress / MCDI_BYTE_PER_WORD);     // MAIN ME1 address
    }
    else if (eType == E_XC_MCDI_ME2)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_12_L, u32FBAddress / MCDI_BYTE_PER_WORD);     // MAIN ME2 address
    }
    else if (eType == E_XC_MCDI_SUB_ME1)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_28_L, u32FBAddress / MCDI_BYTE_PER_WORD);     // SUB ME1 address
    }
    else if (eType == E_XC_MCDI_SUB_ME2)
    {
        SC_W4BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_2C_L, u32FBAddress / MCDI_BYTE_PER_WORD);     // SUB ME2 address
    }
}

void Hal_SC_set_mcdi_write_limit(void *pInstance, MS_BOOL bEn, MS_PHY u32LimitAddress, E_XC_MCDI_TYPE eType)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    u32LimitAddress = u32LimitAddress / MCDI_BYTE_PER_WORD -1;

    if(eType == E_XC_MCDI_BOTH)
    {
        // Main/Sub shares the same enable bit of ME1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_08_L, bEn ? BIT(0) : 0, BIT(0));
        // Bit 0 ~ 26
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_0C_L, u32LimitAddress & 0xFFFF);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_0D_L, (u32LimitAddress >> 16) & 0x3FF);

        // Main/Sub shares the same enable bit of ME2
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_10_L, bEn ? BIT(0) : 0, BIT(0));
        // Bit 0 ~ 26
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_14_L, u32LimitAddress & 0xFFFF);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_15_L, (u32LimitAddress >> 16) & 0x3FF);
    }
    else if(eType==E_XC_MCDI_SUB_BOTH)
    {
        // Main/Sub shares the same enable bit of ME1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_08_L, bEn ? BIT(0) : 0, BIT(0));
        // Bit 0 ~ 26
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_2A_L, u32LimitAddress & 0xFFFF);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_2B_L, (u32LimitAddress >> 16) & 0x3FF);

        // Main/Sub shares the same enable bit of ME2
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_10_L, bEn ? BIT(0) : 0, BIT(0));
        // Bit 0 ~ 26
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_2E_L, u32LimitAddress & 0xFFFF);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_2F_L, (u32LimitAddress >> 16) & 0x3FF);
    }
    else if(eType == E_XC_MCDI_ME1)
    {
        // Main/Sub shares the same enable bit
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_08_L, bEn ? BIT(0) : 0, BIT(0));
        // Bit 0 ~ 26
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_0C_L, u32LimitAddress & 0xFFFF);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_0D_L, (u32LimitAddress >> 16) & 0x3FF);
    }
    else if (eType == E_XC_MCDI_ME2)
    {
        // Main/Sub shares the same enable bit
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_10_L, bEn ? BIT(0) : 0, BIT(0));
        // Bit 0 ~ 26
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_14_L, u32LimitAddress & 0xFFFF);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_15_L, (u32LimitAddress >> 16) & 0x3FF);
    }
    else if (eType == E_XC_MCDI_SUB_ME1)
    {
        // Main/Sub shares the same enable bit
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_08_L, bEn ? BIT(0) : 0, BIT(0));
        // Bit 0 ~ 26
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_2A_L, u32LimitAddress & 0xFFFF);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_2B_L, (u32LimitAddress >> 16) & 0x3FF);
    }
    else if (eType == E_XC_MCDI_SUB_ME2)
    {
        // Main/Sub shares the same enable bit
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_10_L, bEn ? BIT(0) : 0, BIT(0));
        // Bit 0 ~ 26
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_2E_L, u32LimitAddress & 0xFFFF);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_2F_L, (u32LimitAddress >> 16) & 0x3FF);
    }
}
void Hal_SC_enable_mcdi(void *pInstance, MS_BOOL bEn, E_XC_MCDI_TYPE eType)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

#define ME1_CTRL_BIT ( BIT(1) )
#define ME2_CTRL_BIT ( BIT(2) )
    MS_U16 u16Value = 0;
    MS_U16 u16Mask = 0;
    switch (eType)
    {
        case E_XC_MCDI_ME1:
            u16Value = u16Value | (bEn ? 0 : ME1_CTRL_BIT);
            u16Mask = ME1_CTRL_BIT;
            break;
        case E_XC_MCDI_ME2:
            u16Value = u16Value | (bEn ? 0 : ME2_CTRL_BIT);
            u16Mask = ME2_CTRL_BIT;
            break;
        case E_XC_MCDI_BOTH:
            u16Value = u16Value | (bEn ? 0 : ME1_CTRL_BIT);
            u16Value = u16Value | (bEn ? 0 : ME2_CTRL_BIT);
            u16Mask = ME1_CTRL_BIT | ME2_CTRL_BIT;
            break;
        case E_XC_MCDI_SUB_ME1:
            u16Value = u16Value | ((bEn ? 0 : ME1_CTRL_BIT)<<3);
            u16Mask = ME1_CTRL_BIT << 3;
            break;
        case E_XC_MCDI_SUB_ME2:
            u16Value = u16Value | ((bEn ? 0 : ME2_CTRL_BIT)<<3);
            u16Mask = ME2_CTRL_BIT << 3;
            break;
        case E_XC_MCDI_SUB_BOTH:
            u16Value = u16Value | ((bEn ? 0 : ME1_CTRL_BIT)<<3);
            u16Value = u16Value | ((bEn ? 0 : ME2_CTRL_BIT)<<3);
            u16Mask = (ME1_CTRL_BIT | ME2_CTRL_BIT)<<3;
            break;
        default:
            u16Value = 0;
            break;
    }
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_07_L, u16Value, u16Mask);
    if (bEn)
    {
        // Turn on MIU access arbitor
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_04_L, 0x00 , BIT(6) );
    }
    else
    {
        MS_U16 u16MCDiCtrl_Main = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_07_L) & (  ME1_CTRL_BIT | ME2_CTRL_BIT )  ;
        MS_U16 u16MCDiCtrl_Sub  = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK17_07_L) & (( ME1_CTRL_BIT | ME2_CTRL_BIT )<<3)  ;
        MS_U16 u16MCDiCtrl = u16MCDiCtrl_Main | u16MCDiCtrl_Sub;
        // Current ME1/2 is turned off
        if ( u16MCDiCtrl  == ( ( ME1_CTRL_BIT | ME2_CTRL_BIT) //  Main_Window
                               | ((ME1_CTRL_BIT | ME2_CTRL_BIT)<<3))) // Sub_Window
        {
            // Turn off arbitor only when all MCDi function is off.
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_04_L,  BIT(6) , BIT(6) );
        }
    }
}

/// bandwidth saving Mode
void Hal_SC_set_bws_mode(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(eWindow == MAIN_WINDOW)
    {
        //ipm Main
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_01_L, (bEnable? 0x00:BIT(0)), BIT(0));
    }
    else
    {
        //ipm Sub
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_01_L, (bEnable? 0x00:BIT(1)), BIT(1));
    }
}

void Hal_SC_sw_lcnt_en(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(eWindow == MAIN_WINDOW)
    {
        //ipm Main
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_11_L, (bEnable? BIT(0):0x00), BIT(0));
    }
    else
    {
        //ipm Sub
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_21_L, (bEnable? BIT(0):0x00), BIT(0));
    }
}

void Hal_SC_set_sw_lcnt(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(eWindow == MAIN_WINDOW)
    {
        //ipm Main
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_11_L, (bEnable? BIT(1):0x00), BIT(1));
    }
    else
    {
        //ipm Sub
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_21_L, (bEnable? BIT(1):0x00), BIT(1));
    }
}

void Hal_SC_set_ipmw_lcnt_inv(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(eWindow == MAIN_WINDOW)
    {
        //ipm Main
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_12_L, (bEnable? BIT(4):0x00), BIT(4));
    }
    else
    {
        //ipm Sub
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_22_L, (bEnable? BIT(4):0x00), BIT(4));
    }
}

void Hal_SC_set_ipmr_lcnt_inv(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(eWindow == MAIN_WINDOW)
    {
        //ipm Main
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_12_L, (bEnable? BIT(12):0x00), BIT(12));
    }
    else
    {
        //ipm Sub
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_22_L, (bEnable? BIT(12):0x00), BIT(12));
    }
}

void Hal_SC_set_opm_lcnt_inv(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(eWindow == MAIN_WINDOW)
    {
        //opm Main
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_32_L, (bEnable? BIT(5):0x00), BIT(5));
    }
    else
    {
        //opm Sub
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK08_32_L, (bEnable? BIT(4):0x00), BIT(4));
    }

}

void MHal_XC_Calc_IGainPGain(void *pInstance, MS_U8 *u8GainI, MS_U8 *u8GainP, MS_U32 u32XTAL_Clock, MS_U8 u8LGain, MS_U8 u8Vco, MS_U16 u16HTotal, MS_U16 u16VTotal, MS_U8 u8FRC_Out)
{
    MS_U32 u32Factor, u32Temp;
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[E_XC_POOL_ID_INTERNAL_VARIABLE],(void**)(&pXCResourcePrivate));
    u32Temp = 0;
    u32XTAL_Clock*=2;

    if(MDrv_XC_FPLL_IsSupportLockFreqOnly(pInstance)) //lock freqonly mode.
    {
        /*i_gain = (MM*524288*loop_gain)/(8*(reg_odclk_div+1)*loop_div)*/
        u32Temp = MDrv_Read4Byte(L_BK_LPLL(0x1B))+1;
        u32Factor = (524288*u8LGain)/((MS_U32)(u32Temp*u8Vco/2*8));
        *u8GainI = MHal_SC_cal_usedgain_to_reggain(u32Factor);
    }
    else // normal mode.
    {
        /*i_gain = (MM*524288*loop_gain)/(8*htotal*vtotal*(reg_ovs_div+1)*loop_div)*/
        u32Temp = (MS_U32)(u16VTotal*u16HTotal*u8FRC_Out);
        u32Factor = ((LVDS_MPLL_CLOCK_432_MHZ*1000000UL/u32XTAL_Clock)*524288*u8LGain)/((MS_U32)(u32Temp*u8Vco/2*8));
        *u8GainI = MHal_SC_cal_usedgain_to_reggain(u32Factor);

        //for high accurate log value
        u32Factor = ((LVDS_MPLL_CLOCK_432_MHZ*1000000UL/u32XTAL_Clock)*524288*u8LGain*10)/((MS_U32)(u32Temp*u8Vco/2*8));
        XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "new i_gain=%td\n", (ptrdiff_t)u32Factor);

        if(u32Factor <= 1)
            *u8GainI=2;
        else if(u32Factor <= 3)
            *u8GainI=3;
        else if(u32Factor <= 7)
            *u8GainI=4;
    }
    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "MM=%ld,u8LGain1=%d,Htt=%d,Vtt=%d,Ovs=%d,Vco=%d,i_gain=%td,REGIg=%d,u32XTAL_Clock=%tu\n",
                 (LVDS_MPLL_CLOCK_432_MHZ*1000000UL/pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32XTAL_Clock),u8LGain,
                 u16HTotal,u16VTotal,u8FRC_Out,u8Vco/2,(ptrdiff_t)u32Factor,MHal_SC_cal_usedgain_to_reggain(u32Factor),(ptrdiff_t)u32XTAL_Clock);

    *u8GainP = *u8GainI+1;
    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "==>LG1=%d,iGain=%td,I=%d,P=%d\n",u8LGain,(ptrdiff_t)u32Factor,*u8GainI,*u8GainP);
}

void MHAL_SC_set_osdc_tgen_hsync_start(void *pInstance, MS_U16 u16Value)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_01_L, u16Value, 0x1FFF);
}

void MHAL_SC_set_osdc_tgen_hsync_end(void *pInstance, MS_U16 u16Value)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_02_L, u16Value, 0x1FFF);
}

void MHAL_SC_set_osdc_tgen_hframe_de_start(void *pInstance, MS_U16 u16Value)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_03_L, u16Value, 0x1FFF);
}

void MHAL_SC_set_osdc_tgen_hframe_de_end(void *pInstance, MS_U16 u16Value)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_04_L, u16Value, 0x1FFF);
}

void MHAL_SC_set_osdc_tgen_htotal(void *pInstance, MS_U16 u16Value)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_05_L, u16Value, 0x1FFF);
}

void MHAL_SC_set_osdc_tgen_vtotal(void *pInstance, MS_U16 u16Value)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_07_L, u16Value, 0x1FFF);
}

void MHAL_SC_set_osdc_tgen_vframe_de_start(void *pInstance, MS_U16 u16Value)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_0A_L, u16Value, 0x1FFF);
}

void MHAL_SC_set_osdc_tgen_vframe_de_end(void *pInstance, MS_U16 u16Value)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_0B_L, u16Value, 0x1FFF);
}

void MHAL_SC_set_osdc_tgen_vsync_start(void *pInstance, MS_U16 u16Value)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_0E_L, u16Value, 0x1FFF);
}

void MHAL_SC_set_osdc_tgen_vsync_end(void *pInstance, MS_U16 u16Value)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_0F_L, u16Value, 0x1FFF);
}

void MHAL_SC_set_osdc_tgen_reset_enable(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_20_L, bEnable?BIT(0):0x00, BIT(0));
}

void MHAL_SC_set_osdc_swreset_enable(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_21_L, bEnable?BIT(0):0x00, BIT(0));
}

void MHAL_SC_set_osdc_mixer_bypass_enable(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_22_L, bEnable?BIT(0):0x00, BIT(0));
}

void MHAL_SC_set_osdc_mixer_inv_alpha_enable(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_22_L, bEnable?BIT(1):0x00, BIT(1));
}
//1:hs_out = hs&vfde
void MHAL_SC_set_osdc_mixer_hs_n_vfde_enable(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_22_L, bEnable?BIT(2):0x00, BIT(2));
}
//1:de(hfde)_out = de(hfde)&vfde
void MHAL_SC_set_osdc_mixer_hfde_n_vfde_enable(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_22_L, bEnable?BIT(3):0x00, BIT(3));
}

void MHAL_SC_set_osdc_clk_mux(void *pInstance, MS_U8 u8Clk_Mux)
{
    MDrv_WriteByteMask(REG_CKG_OSDC, u8Clk_Mux << 2, CKG_OSDC_MASK);
}

void MHAL_SC_enable_osdc(void *pInstance, MS_BOOL bEnable)
{
    // Enable OSDC LPLL
    if(bEnable)
    {
        MDrv_WriteRegBit(REG_CKG_OSDC, DISABLE, CKG_OSDC_INVERT);                   // Not Invert
        MDrv_WriteRegBit(REG_CKG_OSDC, DISABLE, CKG_OSDC_GATED);                    // Enable clock
    }
    else
    {
        MDrv_WriteRegBit(REG_CKG_OSDC, ENABLE, CKG_OSDC_INVERT);                   // Not Invert
        MDrv_WriteRegBit(REG_CKG_OSDC, ENABLE, CKG_OSDC_GATED);                    // Enable clock
    }
}

void MHAL_SC_PowerDownOSDCLPLL(MS_BOOL bEnable)
{
    if(bEnable)
    {
        W2BYTEMSK(L_BK_LPLL(0x40), BIT(15), BIT(15));
    }
    else
    {
        W2BYTEMSK(L_BK_LPLL(0x40), FALSE, BIT(15));
    }
}

MS_U16 MHAL_SC_get_osdc_tgen_hsync_start(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return (MS_U16)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_01_L, 0x1FFF);
}

MS_U16 MHAL_SC_get_osdc_tgen_hsync_end(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return (MS_U16)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_02_L, 0x1FFF);
}

MS_U16 MHAL_SC_get_osdc_tgen_hframe_de_start(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return (MS_U16)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_03_L, 0x1FFF);
}

MS_U16 MHAL_SC_get_osdc_tgen_hframe_de_end(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return (MS_U16)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_04_L, 0x1FFF);
}

MS_U16 MHAL_SC_get_osdc_tgen_htotal(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return (MS_U16)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_05_L, 0x1FFF);
}

MS_U16 MHAL_SC_get_osdc_tgen_vtotal(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return (MS_U16)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_07_L, 0x1FFF);
}

MS_U16 MHAL_SC_get_osdc_tgen_vframe_de_start(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return (MS_U16)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_0A_L, 0x1FFF);
}

MS_U16 MHAL_SC_get_osdc_tgen_vframe_de_end(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return (MS_U16)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_0B_L, 0x1FFF);
}

MS_U16 MHAL_SC_get_osdc_tgen_vsync_start(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return (MS_U16)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_0E_L, 0x1FFF);
}

MS_U16 MHAL_SC_get_osdc_tgen_vsync_end(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return (MS_U16)SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_0F_L, 0x1FFF);
}

MS_BOOL MHAL_SC_get_osdc_mixer_bypass_status(void *pInstance)
{
    MS_BOOL bEnable = DISABLE;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    bEnable = (MS_BOOL)(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_22_L, BIT(0)));
    return bEnable;
}

MS_BOOL MHAL_SC_get_osdc_mixer_inv_alpha_status(void *pInstance)
{
    MS_BOOL bEnable = DISABLE;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    bEnable = (MS_BOOL)(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_22_L, BIT(1))>>1);
    return bEnable;
}
//1:hs_out = hs&vfde
MS_BOOL MHAL_SC_get_osdc_mixer_hs_n_vfde_status(void *pInstance)
{
    MS_BOOL bEnable = DISABLE;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    bEnable = (MS_BOOL)(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_22_L, BIT(2))>>2);
    return bEnable;
}
//1:de(hfde)_out = de(hfde)&vfde
MS_BOOL MHAL_SC_get_osdc_mixer_hfde_n_vfde_status(void *pInstance)
{
    MS_BOOL bEnable = DISABLE;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    bEnable = (MS_BOOL)(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK37_22_L, BIT(3))>>3);
    return bEnable;
}

MS_BOOL MHAL_SC_get_osdc_onoff_status(void *pInstance)
{
    // Enable OSDC LPLL
    MS_BOOL bEnable = DISABLE;
    bEnable = (MS_BOOL)(MDrv_ReadRegBit(REG_CKG_OSDC, CKG_OSDC_GATED));
    return bEnable;
}

void MHal_XC_SetForceReadBank(void *pInstance, MS_BOOL bEnable, MS_U8 u8Bank, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if (eWindow == MAIN_WINDOW)
    {
        if (bEnable)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, BIT(11), BIT(11));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, (u8Bank & 0x7) << 8, BIT(10)|BIT(9)|BIT(8));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_06_L, ((u8Bank & 0x8) >> 3) << 14, BIT(14));
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, 0, BIT(11));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, 0, BIT(10)|BIT(9)|BIT(8));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_06_L, 0, BIT(14));
        }
    }
    else
    {
        if (bEnable)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_47_L, BIT(11), BIT(11));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_47_L, (u8Bank & 0x7) << 8, BIT(10)|BIT(9)|BIT(8));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_46_L, ((u8Bank & 0x8) >> 3) << 14, BIT(14));
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_47_L, 0, BIT(11));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_47_L, 0, BIT(10)|BIT(9)|BIT(8));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_46_L, 0, BIT(14));
        }
    }
}
#ifdef UFO_XC_VMARK
E_APIXC_ReturnValue MHal_XC_Vtrack_Enable(void *pInstance, MS_U8 u8FrameRate, MS_BOOL bEnable)
{
    //FrameRateIn     => 8'h1E
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK2F_02_L , u8FrameRate, 0xFF);

    //EnableIn              => 1
    //DebugEn               => 0
    if (bEnable == TRUE)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK2F_01_L , BIT(0), BIT(1)|BIT(0) );
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK2F_01_L , 0x00, BIT(1)|BIT(0) );
    }

    MDrv_XC_MLoad_Fire(pInstance, TRUE);

    return  E_APIXC_RET_OK;
}


E_APIXC_ReturnValue MHal_XC_VMark_SetParameters(void* pInstance, MS_U8 u8ServiceIndex, XC_VMARK_PARAMETER *pstXC_VMarkParameters)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U8 u8WatermarkOn = FALSE;
    MS_U16 u16SymbolScale;
    MS_U16 u16TargetScale;
    MS_U16 u16SymbolSpaceVert  = 12;
    MS_U16 u16SymbolSpaceHorz = 10;
    MS_U16 u16SymbolsXpos;
    MS_U16 u16SymbolsYpos;
    MS_U16 u16MarklineWidth;
    MS_S8 s8StrengthMultiply;
    MS_U8 u8FrequencyDistance[3][3];
    MS_U32 M, N, S;
    static const MS_U8 u8FrequencyDistanceMin[3] = {0, 0, 3};
    static const MS_U8 u8FrequencyDistanceMax[3] = {3, 7, 16};
    MS_U16 u16VRes = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height;
    MS_U16 u16HRes = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width;


    u8ServiceIndex = u8ServiceIndex; // Not supported in the first implementations.

    if (pstXC_VMarkParameters == NULL)
    {
        return E_APIXC_RET_FAIL_INVALID_PARAMETER;
    }


    if (pstXC_VMarkParameters->u8WatermarkOn == 1) // Watermark on
    {
        MS_U16 u16SymbolIndex;
        MS_BOOL bMode2P = (psXCInstPri->u32DeviceID == E_XC_DEVICE0)?TRUE:FALSE;
        MS_BOOL bInterlaced = (psXCInstPri->u32DeviceID == E_XC_DEVICE1)?TRUE:FALSE;

        // Hide watermark
        VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_29_L, 0, 0x00FF);

        // Interlaced
        if (bInterlaced)
        {
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_00_L, BIT(3), BIT(3));
        }
        else
        {
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_00_L, 0, BIT(3));
        }

        /**********************************
        *             Write Symbol Table
        **********************************/
        {
            memcpy(&u8VMarkSymbols, pstXC_VMarkParameters->u8PayloadSymbols, 1920*sizeof(MS_U8));

            // Enable symbol table access
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_00_L, BIT(5), BIT(5));

            // Write Symbol Table
            for (u16SymbolIndex = 0; u16SymbolIndex < (1920/2); u16SymbolIndex++) /// **** TBD ****: Fix magic number
            {
                //Address
                VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_30_L, u16SymbolIndex, 0x03FF);
                // WData
                VMARK_W2BYTE(psXCInstPri->u32DeviceID, REG_VMARK_31_L, u8VMarkSymbols[u16SymbolIndex*2+1]<<8 |u8VMarkSymbols[u16SymbolIndex*2]);
            }

            // Disable symbol table access
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_00_L, 0, BIT(5));
        }

        // V resolution
        VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_04_L, u16VRes, 0x0FFF);
        // H resolution
        VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_05_L, u16HRes, 0x0FFF);

        // Upper bound of Y result
        VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_02_L, 0x3FF, 0x3FF);
        VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_03_L, 0, 0x03FF);


        /**********************************
        *             Symbol number
        **********************************/
        //Symbol Rows * Cols <= 16
        if (pstXC_VMarkParameters->u8SymbolsRows * pstXC_VMarkParameters->u8SymbolsCols > 16)
        {
            SC_DBG(printf("[%s][%d] Too many symbol numbers. Max symbol = 16 \n", __FUNCTION__, __LINE__));
            return E_APIXC_RET_FAIL_INVALID_PARAMETER;
        }
        // Symbol Row
        VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_06_L, pstXC_VMarkParameters->u8SymbolsRows, 0x000F);
        // Symbol Col
        VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_06_L, pstXC_VMarkParameters->u8SymbolsCols << 4, 0x00F0);


        /**********************************
        *             Calculate Symbol Scale
        **********************************/
        {
            // Calculate target scale
            u16TargetScale = (u16VRes * 10 * pstXC_VMarkParameters->u8SymbolScaleControl / 480
                                          - 10 * pstXC_VMarkParameters->u8SymbolScaleControl + 100) * pstXC_VMarkParameters->u8SymbolSize;

            u16SymbolScale = MIN(u16TargetScale, u16HRes * (95 - pstXC_VMarkParameters->u8SymbolsXpos) / (pstXC_VMarkParameters->u8SymbolsCols * (20 + pstXC_VMarkParameters->u16SpacingHorz) - pstXC_VMarkParameters->u16SpacingHorz));
            u16SymbolScale = MIN(u16SymbolScale, u16VRes * (95 - pstXC_VMarkParameters->u8SymbolsYpos) / (pstXC_VMarkParameters->u8SymbolsRows * (24 + pstXC_VMarkParameters->u16SpacingVert) - pstXC_VMarkParameters->u16SpacingVert));

            // Determine scale as integer multiple
            u16SymbolScale /= 100;
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_06_L, u16SymbolScale << 8, 0xFF00);

        }

        /**********************************
        *             Calculate Symbol Position
        **********************************/
        {
            u16SymbolsXpos = (MS_U16) pstXC_VMarkParameters->u8SymbolsXpos;
            u16SymbolsYpos = (MS_U16) pstXC_VMarkParameters->u8SymbolsYpos;
            // Range 5%~95%
            if (u16SymbolsXpos > 95)
            {
                u16SymbolsXpos = 95;
            }
            else if (u16SymbolsXpos < 5)
            {
                u16SymbolsXpos = 5;
            }

            if (u16SymbolsYpos > 95)
            {
                u16SymbolsYpos = 95;
            }
            else if (u16SymbolsYpos < 5)
            {
                u16SymbolsYpos = 5;
            }

            u16SymbolsXpos = u16SymbolsXpos * u16HRes / 100;
            u16SymbolsYpos = u16SymbolsYpos * u16VRes / 100;

            if (bMode2P)
            {
                // 2P mode. Must on even pixel.
                u16SymbolsXpos =  (u16SymbolsXpos >> 1) << 1;
            }

            // Symbol X Pos
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_07_L, u16SymbolsXpos, 0x0FFF);
            // Symbol Y Pos
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_08_L, u16SymbolsYpos, 0x0FFF);
        }

        /**********************************
        *             Symbol space
        **********************************/
        {
            u16SymbolSpaceHorz = pstXC_VMarkParameters->u16SpacingHorz;
            u16SymbolSpaceVert = pstXC_VMarkParameters->u16SpacingVert;
            // Symbol Space X
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_09_L, u16SymbolSpaceHorz, 0x01FF);
            // Symbol Space Y
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_0A_L, u16SymbolSpaceVert, 0x01FF);
        }

        /**********************************
        *            Scaled frequency distance
        **********************************/
        {
            MS_U8 u8Direction, u8Distance;

            for (u8Direction = 0; u8Direction < 3; u8Direction++)
            {
                for (u8Distance = 0; u8Distance < 3; u8Distance++)
                {
                    u8FrequencyDistance[u8Direction][u8Distance] = pstXC_VMarkParameters->u8FrequencyDistance[u8Direction][u8Distance];
                    //validate frequency distance values against thresholds
                    if(u8FrequencyDistance[u8Direction][u8Distance] < u8FrequencyDistanceMin[u8Distance])
                    {
                        u8FrequencyDistance[u8Direction][u8Distance] = u8FrequencyDistanceMin[u8Distance];
                    }
                    if(u8FrequencyDistance[u8Direction][u8Distance] > u8FrequencyDistanceMax[u8Distance])
                    {
                        u8FrequencyDistance[u8Direction][u8Distance] = u8FrequencyDistanceMax[u8Distance];
                    }
                }
                // validate that frequency distances are in ascending order.
                if(u8FrequencyDistance[u8Direction][0] > u8FrequencyDistance[u8Direction][1])
                {
                    u8FrequencyDistance[u8Direction][0] = MIN(u8FrequencyDistance[u8Direction][1], u8FrequencyDistanceMax[0]);
                }
                if(u8FrequencyDistance[u8Direction][1] > u8FrequencyDistance[u8Direction][2])
                {
                    u8FrequencyDistance[u8Direction][1] = MIN(u8FrequencyDistance[u8Direction][2], u8FrequencyDistanceMax[1]);
                }
            }

            // Scale frequency distance
            for (u8Direction = 0; u8Direction < 3; u8Direction++)
            {
                for (u8Distance= 0; u8Distance< 3; u8Distance++)
                {
                    u8FrequencyDistance[u8Direction][u8Distance] = (u8FrequencyDistance[u8Direction][u8Distance] * u16VRes + 240) / 480;
                    u8FrequencyDistance[u8Direction][u8Distance] = (bMode2P || bInterlaced)? ((u8FrequencyDistance[u8Direction][u8Distance] + 1) & 0xFE) : u8FrequencyDistance[u8Direction][u8Distance];
                }
            }
            VMARK_W2BYTE(psXCInstPri->u32DeviceID, REG_VMARK_0B_L, u8FrequencyDistance[0][1] << 8 | u8FrequencyDistance[0][0]);
            VMARK_W2BYTE(psXCInstPri->u32DeviceID, REG_VMARK_0C_L, u8FrequencyDistance[1][0] << 8 | u8FrequencyDistance[0][2]);
            VMARK_W2BYTE(psXCInstPri->u32DeviceID, REG_VMARK_0D_L, u8FrequencyDistance[1][2] << 8 | u8FrequencyDistance[1][1]);
            VMARK_W2BYTE(psXCInstPri->u32DeviceID, REG_VMARK_0E_L, u8FrequencyDistance[2][0] << 8 | u8FrequencyDistance[2][0]);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_0F_L, u8FrequencyDistance[2][2], 0x00FF);
        }

        /**********************************
        *          Embedding Strength Threshold
        **********************************/
        // Defines the impact of different noise levels to the amount of pixel modification
        {
            // Currently only support 10bit depth
            // Foreground
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_10_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[0], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_11_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[1], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_12_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[2], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_13_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[3], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_14_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[4], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_15_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[5], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_16_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[6], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_17_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[7], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_18_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[8], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_19_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[9], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_1A_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[10], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_1B_L, pstXC_VMarkParameters->u16EmbeddingStrengthThreshold[11], 0x0FFF);
            // Background
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_1C_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[0], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_1D_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[1], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_1E_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[2], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_1F_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[3], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_20_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[4], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_21_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[5], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_22_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[6], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_23_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[7], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_24_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[8], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_25_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[9], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_26_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[10], 0x0FFF);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_27_L, pstXC_VMarkParameters->u16EmbeddingStrengthThresholdBG[11], 0x0FFF);
            // Clipping value (maximum) for the aggregated noise measurement in each direction
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_28_L, pstXC_VMarkParameters->u16DirectionMax, 0x03FF);
        }

        //reg_top_buf_col_spac
        {
            u16MarklineWidth = pstXC_VMarkParameters->u8SymbolsCols * (20+ pstXC_VMarkParameters->u16SpacingHorz) * u16SymbolScale\
                                       - pstXC_VMarkParameters->u16SpacingHorz * u16SymbolScale;
            M = u8FrequencyDistance[2][2];
            N = 3840 / (M + 1);
            S = u16MarklineWidth/N + 1;

            if (S < 4)
            {
                S = 4;
            }

            if (bMode2P)
            {
                S = ((S+1) & 0x0ffe) >> 1;
            }
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_0F_L, S <<8, 0xFF00);
        }

        /**********************************
        *             Strength Multiplier
        **********************************/
        s8StrengthMultiply = pstXC_VMarkParameters->s8StrengthMultiply;
        VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_29_L, (MS_U8)pstXC_VMarkParameters->s8StrengthMultiply, 0x00FF);


        /**********************************
        *             Enable VME
        **********************************/
        u8WatermarkOn = VMARK_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_00_L, BIT(0));
        if (!u8WatermarkOn)
        {
            // VMark SW reset
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_00_L, BIT(15), BIT(15));
            MsOS_DelayTask(5);
            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_00_L, 0, BIT(15));

            VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_00_L, BIT(0), BIT(0)); // Enable VMark enable bit
            MsOS_DelayTask(100);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK2F_28_L, 0x01, 0x03); //reg_sc_to_ve_sel
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK2F_01_L, 0x20, 0x30); // Mux: VMark
       }

    }
    else // Watermark off
    {
        // Strength Multiplier = 0 to hide
        VMARK_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_VMARK_29_L, 0, 0x00FF);
    }

    return  E_APIXC_RET_OK;
}
#endif


MS_BOOL MHal_XC_SetDNRBufAddress(void *pInstance, MS_PHY u32DNRBaseAddr, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return FALSE;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    pXCResourcePrivate->sthal_SC._u32DNRBaseAddress[eWindow] = u32DNRBaseAddr;
    return TRUE;
}

MS_PHY MHal_XC_GetDNRBufAddress(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return 0;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    return pXCResourcePrivate->sthal_SC._u32DNRBaseAddress[eWindow] ;
}

MS_BOOL MHal_XC_SetDNRBufSize(void *pInstance, MS_PHY u32DNRBufSize, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return FALSE;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    pXCResourcePrivate->sthal_SC._u32DNRBufferSize[eWindow] = u32DNRBufSize;
    return TRUE;
}

MS_PHY MHal_XC_GetDNRBufSize(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return 0;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    return pXCResourcePrivate->sthal_SC._u32DNRBufferSize[eWindow] ;
}

MS_BOOL MHal_XC_SetFRCMBufAddress(void *pInstance, MS_PHY u32BaseAddr, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return FALSE;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    pXCResourcePrivate->sthal_SC._u32FRCBaseAddress[eWindow] = u32BaseAddr;
    return TRUE;
}

MS_PHY MHal_XC_GetFRCMBufAddress(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return 0;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    return pXCResourcePrivate->sthal_SC._u32FRCBaseAddress[eWindow] ;
}

MS_BOOL MHal_XC_SetFRCMBufSize(void *pInstance, MS_PHY u32BufSize, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return FALSE;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    pXCResourcePrivate->sthal_SC._u32FRCBufferSize[eWindow] = u32BufSize;
    return TRUE;
}

MS_PHY MHal_XC_GetFRCMBufSize(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return 0;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    return pXCResourcePrivate->sthal_SC._u32FRCBufferSize[eWindow] ;
}

MS_BOOL MHal_XC_SetDualDNRBufAddress(void *pInstance, MS_PHY u32DNRBaseAddr, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return FALSE;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    pXCResourcePrivate->_u32DualDNRBaseAddress[eWindow] = u32DNRBaseAddr;
    return TRUE;
}

MS_PHY MHal_XC_GetDualDNRBufAddress(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    return pXCResourcePrivate->_u32DualDNRBaseAddress[eWindow];
}

MS_BOOL MHal_XC_SetDualDNRBufSize(void *pInstance, MS_PHY u32DNRBufSize, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    pXCResourcePrivate->_u32DualDNRBufferSize[eWindow] = u32DNRBufSize;
    return TRUE;
}

MS_PHY MHal_XC_GetDualDNRBufSize(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    return pXCResourcePrivate->_u32DualDNRBufferSize[eWindow] ;
}

MS_BOOL MHal_XC_Init_Patch(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    if (eWindow >= WINDOW_NUM)
    {
        printf("[%s,%5d] maximum window exceeded",__FUNCTION__,__LINE__);
        return FALSE;
    }

    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
    //FIX ME:review manhattan need it?
    if (psXCInstPri->u32DeviceID >= 1)
    {
        // by HW RD's request, for sub video BW issue, adjust R/W line buffer length
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_20_L, 0x1E1E);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_21_L, 0x1E1E);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_22_L, 0x1E1E);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_23_L, 0x1010);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_24_L, 0x20, 0xFF);

#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        if(R2BYTE(REG_PM_EFUSE_08_L) &BIT(6)) // verify trim efuse to disable Dolby HDR
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_61_L, eWindow), 0x01, 0x03);
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_61_L, eWindow), 0x03, 0x03);
        }
#else
        // HDMI 422 to 444 setting
        if(R2BYTE(REG_PM_EFUSE_08_L) &BIT(6)) // verify trim efuse to disable Dolby HDR
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_61_L, 0x01, 0x03);
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_61_L, 0x03, 0x03);
        }
#endif

        return FALSE;
    }
#endif

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK23_6F_L, 0x20, 0x3F); // by HW RD's request, for BB section offset issue

#ifdef UFO_XC_SUPPORT_DUAL_MIU
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK52_25_L, 0x3030); // by HW RD's request, for HDMI 4K BW issue, adjust R/W line buffer length
#endif

    // SW patch for Monaco
    // by HW RD's request, to fix HDMI 1080i repeat garbage at left side
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_37_L, 0x20); // bypass main line buffer length setting
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK11_37_L, 0x20); // bypass sub line buffer length setting

    // ECO item for Monaco: hvsp PIP B section last flag error
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK23_5F_L, BIT(14), BIT(14));

    // ECO item for Monaco: ip2ve 4K path Vsync need inverse
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_7F_L, BIT(14), BIT(14));
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK04_7F_L, BIT(14), BIT(14));

    // SW patch for muji : 4k2k 3D LA out show garbage on the top, issue with BW
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK58_10_L, 0x0000, BIT(0));//disable SCM sub OP

    // BK00_03[13] conflict with compression mode (patch for HW issue)
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK00_03_L, 0x0000, 0x2000);

    //U03 compatible setting
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK32_66_L, BIT(13), BIT(13));

    ///Patch here ////
#if (FRC_INSIDE)
    MHal_FRC_interrupt_mask(pInstance, 0xFF);

    //enable fsc clk
    MDrv_WriteByteMask( REG_FSC_BK20_05, 0x10, 0x10); // reg_ckg_ficlk
#endif

    // SW patch for Eisntein
    // With HW Auto no signal case,  sub video source change would causes OP1 broken, looks like main video broken
    Hal_SC_ip_enable_turnoff_OP1_for_AutoNoSignal(pInstance, DISABLE);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_61_L, 0x01, 0x03); // for HDMI 2.0, always receive 444 format
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK01_63_L, 0x01, 0x01); // for HDMI odd Htt support
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_61_L, 0x01, 0x03);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_61_L, 0x01, 0x03);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_61_L, 0x01, 0x03);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_61_L, 0x01, 0x03);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_63_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_63_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_63_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_63_L, 0x01, 0x01);
    //Patch for correct FSS bank mapping temporarily
    //This patch would be removed in future when Qmap FSS mapping function complete.
    // C0~C8
    //C0
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC0_02_L, 0x80, 0x80);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC0_09_L, 0x0F, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC0_08_L, 0x04, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC0_03_L, 0xFF, 0x90);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC0_03_L, 0xCF, 0x08);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC0_10_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC0_19_L, 0x1D, 0x19);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC0_18_L, 0xFF, 0x1C);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC0_21_L, 0xC0, 0x00);
    //C1
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_02_L, 0x80, 0x80);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_09_L, 0x0F, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_08_L, 0x04, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_03_L, 0xFF, 0x90);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_03_L, 0xCF, 0x08);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_10_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_19_L, 0x1D, 0x19);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_18_L, 0xFF, 0x1C);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_21_L, 0xC0, 0x00);
    //C2
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC2_02_L, 0x80, 0x80);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC2_09_L, 0x0F, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC2_08_L, 0x04, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC2_03_L, 0xFF, 0x90);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC2_03_L, 0xCF, 0x08);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC2_10_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC2_19_L, 0x1D, 0x19);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC2_18_L, 0xFF, 0x1C);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC2_21_L, 0xC0, 0x00);
    //C3
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC3_02_L, 0x80, 0x80);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC3_09_L, 0x0F, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC3_08_L, 0x04, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC3_03_L, 0xFF, 0x90);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC3_03_L, 0xCF, 0x08);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC3_10_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC3_19_L, 0x1D, 0x19);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC3_18_L, 0xFF, 0x1C);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC3_21_L, 0xC0, 0x00);
    //C4
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_02_L, 0x80, 0x80);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_09_L, 0x0F, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_08_L, 0x04, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_03_L, 0xFF, 0x90);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_03_L, 0xCF, 0x08);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_10_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_19_L, 0x1D, 0x19);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_18_L, 0xFF, 0x1C);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_21_L, 0xC0, 0x00);
    //C5
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC5_02_L, 0x80, 0x80);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC5_09_L, 0x0F, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC5_08_L, 0x04, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC5_03_L, 0xFF, 0x90);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC5_03_L, 0xCF, 0x08);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC5_10_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC5_19_L, 0x1D, 0x19);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC5_18_L, 0xFF, 0x1C);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC5_21_L, 0xC0, 0x00);
    //C6
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC6_02_L, 0x80, 0x80);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC6_09_L, 0x0F, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC6_08_L, 0x04, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC6_03_L, 0xFF, 0x90);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC6_03_L, 0xCF, 0x08);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC6_10_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC6_19_L, 0x1D, 0x19);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC6_18_L, 0xFF, 0x1C);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC6_21_L, 0xC0, 0x00);
    //C7
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_02_L, 0x80, 0x80);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_09_L, 0x0F, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_08_L, 0x04, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_03_L, 0xFF, 0x90);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_03_L, 0xCF, 0x08);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_10_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_19_L, 0x1D, 0x19);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_18_L, 0xFF, 0x1C);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_21_L, 0xC0, 0x00);
    //C8
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_02_L, 0x80, 0x80);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_09_L, 0x0F, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_08_L, 0x04, 0x04);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_03_L, 0xFF, 0x90);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_03_L, 0xCF, 0x08);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_10_L, 0x01, 0x01);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_19_L, 0x1D, 0x19);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_18_L, 0xFF, 0x1C);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_21_L, 0xC0, 0x00);
    // DE only for HDMI
    W2BYTEMSK(REG_DVI_ATOP1_BASE+0xA0, 0x0F, 0x0F);

    // need waiting for bank 302F/33xx how to R/W
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKDF_20_L, BIT(7), BIT(0)|BIT(1)|BIT(7));
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKDF_21_L, BIT(0)|BIT(1), BIT(0)|BIT(1)|BIT(8));

    // fast switch patch for morton
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKF9_03_L, 0x00, BIT(11));
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKFC_03_L, 0x00, BIT(11));
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKE0_03_L, 0x00, BIT(11));
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKE1_03_L, 0x00, BIT(11));

    // fast switch patch for mvop
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKFB_21_L, BIT(0), BIT(0));
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKFD_21_L, BIT(0), BIT(0));
#endif

    // SW patch for Maserati only
    // bug fix for mantis 1031600: AC on/off see all pink video, reproduce rate about 1/20
    // Maserati HW would adjust the Vtt, sometimes the FRC trig (bk68_65/66) > Vtt causes no video
    // bk68_38[0] = 1 would makes the HW not to adjust Vtt, it will use bk10_0D to be Vtt
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_38_L, BIT(0), BIT(0));

    // Disable fastswitch IRQ first for Maxim only
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BKF8_40_L, 0xFFFF);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BKF9_40_L, 0xFFFF);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BKFA_40_L, 0xFFFF);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BKFB_40_L, 0xFFFF);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BKFC_40_L, 0xFFFF);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BKFD_40_L, 0xFFFF);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BKFE_40_L, 0xFFFF);

    //Patch for M7621
    //HW default sets DS req length to 0x88, but if each index contains DS commands less than 0x88
    //ext DS req length (0x131F_51[7:0])should be set to 0.
    //At initial stage, set ext DS req length to 0 as default.
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK1F_51_L, 0x00, 0x00FF);

    //SW Patch for M7332 & M7632 & M7642 suggest by hw RD Huan-Kai.Tseng
    //For power-saving we will turn off HVSP gating somwtimes, but there will be a problem of HVSP clk
    //Default set 0x330D_50[3]=1 & 0x330D_50[4]=1 to enable HVSP clk
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK0D_50_L, BIT(3)|BIT(4), BIT(3)|BIT(4));

    MDrv_Write2ByteMask(REG_HSY_CLK, CLK_HSY_EN, CLK_HSY_MASK); //HSY En
    //vfde falling, requested by HW RD
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_19_L, BIT(6), BIT(6));

#if (TGEN_VTT_LOCK_MODE_VER > 0)
    // Enable of PWM input Htt / Vtt ctr by SW
    W2BYTEMSK(REG_SC_BKF0_32_L, BIT(13), BIT(13));
    //Vtotal_Variation_SW_Mode_Initial
#if (FRC_INSIDE == TRUE)
    MHal_FRC_TGEN_VTT_UD_SW_ENABLE(pInstance, FALSE); // [13] : 0 enable V-total variation SW mode
#endif
    // M7621/M7622 disable double buffer
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_31_L, 0, BIT(14));
    // Debug selection: ivs/ovs line difference
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_3D_L, 0x1000, 0xF000);
#endif

    //merlin UMA efficiency setting request by hw RD Barry.Shen
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK11_09_L, 0x0000); // IPM UMA mode
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK11_49_L, 0x0000); // OPM UMA mode
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK42_48_L, 0x0000); // HDR W UMA mode
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK42_49_L, 0x0000); // HDR R UMA mode
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK42_21_L, 0x1860); // HDR W thrd
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK42_22_L, 0x8000); // HDR W burst max

    //Need discuss with RD
    //MIU Channel balance
    if(MHal_XC_GetCropMode() == E_XC_CROP_MIU_ENHANCED_MODE)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_0B_L, 0, BIT(14));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_4B_L, 0, BIT(14));
    }

    //Scaling Issue, Request by Huan-Kai Tseng
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_29_L, 0x0404, 0x1F1F);

#if (HSD_IP2_RESET_PATCH == TRUE)
    //Ip2 HSD patch
    MDrv_XC_InterruptAttachWithoutMutex(pInstance, SC_INT_F2_IPVS_SW_TRIG, MHal_XC_IP2HSDPatch_Counter, (void *)pInstance);
#endif

    return TRUE;
}
MS_BOOL MHal_XC_IsPNLYUVOutput(void *pInstance)
{
    MS_BOOL bIsPNLYUVOutput = TRUE;
#if 0//below is logic from TV, need box RD's confirm, disable it temporary
    MS_BOOL bIsY2REnable = FALSE, bIsR2YEnable = FALSE;
    SCALER_WIN eWindow = MAIN_WINDOW;
    MS_U16 u16Temp = 0;
    //Get CSC state before OP2
    if(gSrcInfo[MAIN_WINDOW].bBlackscreenEnabled || gSrcInfo[MAIN_WINDOW].bBluescreenEnabled)
    {
        //Main is mute, so check sub
        if(Hal_SC_Is_subwindow_enable())
        {
            if(!(gSrcInfo[SUB_WINDOW].bBlackscreenEnabled || gSrcInfo[SUB_WINDOW].bBluescreenEnabled))
            {
                eWindow = SUB_WINDOW;
            }
        }
    }

    if(eWindow == MAIN_WINDOW)
    {
        u16Temp = SC_R2BYTE(REG_SC_BK10_2F_L);
        if((u16Temp & ( BIT(0) | BIT(2) | BIT(4))) == ( BIT(0) | BIT(2) | BIT(4)))
        {
            bIsY2REnable =  TRUE;
        }
    }
    else
    {
        u16Temp = SC_R2BYTE(REG_SC_BK0F_26_L);
        if((u16Temp & ( BIT(0) | BIT(2) | BIT(4))) == ( BIT(0) | BIT(2) | BIT(4)))
        {
            bIsY2REnable =  TRUE;
        }
    }

    if(bIsY2REnable)
    {
        bIsPNLYUVOutput = FALSE;
    }
    else
    {
        //OP Y2R disable, so check op input
        if(eWindow == MAIN_WINDOW)
        {
            bIsR2YEnable = (MS_BOOL)(SC_R2BYTEMSK(REG_SC_BK02_40_L, BIT(3)) || SC_R2BYTEMSK(REG_SC_BK18_06_L, BIT(0)));

        }
        else
        {
            bIsR2YEnable = (MS_BOOL)(SC_R2BYTEMSK(REG_SC_BK04_40_L, BIT(3)) || SC_R2BYTEMSK(REG_SC_BK18_76_L, BIT(0)));
        }

        if(bIsR2YEnable)
        {
            //Y2R enable
            bIsPNLYUVOutput = TRUE;
        }
        else
        {
            //All Csc is off, so check input
            //VGA/DVI/rgb HDMI is rgb input
            if(  IsSrcTypeVga(gSrcInfo[eWindow].enInputSourceType) //VGA
                 ||IsSrcTypeDVI(gSrcInfo[eWindow].enInputSourceType) //DVI
                 ||(  IsSrcTypeHDMI(gSrcInfo[eWindow].enInputSourceType)
                      &&(g_HdmiPollingStatus.bIsHDMIMode == TRUE)
                      &&(g_HdmiPollingStatus.u8ColorFormat == MS_HDMI_COLOR_RGB))//HDMI RGB
                 ||(  IsSrcTypeHDMI(gSrcInfo[eWindow].enInputSourceType)
                      &&(g_HdmiPollingStatus.bIsHDMIMode == FALSE)) //HDMI_DVI
              )
            {
                bIsPNLYUVOutput = FALSE;
            }
            else
            {
                bIsPNLYUVOutput = TRUE;
            }
        }
    }
#endif
    return bIsPNLYUVOutput;
}

#if ((defined(MSOS_TYPE_OPTEE)) || (defined(MSOS_TYPE_NUTTX))) || ((!defined(DONT_USE_CMA))&&(XC_SUPPORT_CMA ==TRUE))||(XC_SUPPORT_IOMMU == TRUE)
void MHal_SC_Memory_Request_Force_Off(void * pInstance, MS_BOOL bEnable,E_XC_FORCE_MEMORY_REQUEST_OFF eMemoryOffType)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    switch(eMemoryOffType)
    {
        case E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN:
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_39_L, bEnable?BIT(0):0x00, BIT(0));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_02_L, bEnable?BIT(14):0 , BIT(14));
            break;
        case E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_DUAL:
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_39_L, bEnable?BIT(4):0x00, BIT(4));
            break;
        case E_XC_FORCE_MEMORY_REQUEST_OFF_SUB:
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_39_L, bEnable?BIT(1):0x00, BIT(1));
            break;
        case E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW:
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_39_L, bEnable?BIT(2):0x00, BIT(2));
            break;
        case E_XC_FORCE_MEMORY_REQUEST_OFF_SUB_OPW:
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_39_L, bEnable?BIT(6):0x00, BIT(6));
            break;
        case E_XC_FORCE_MEMORY_REQUEST_OFF_ALL:
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0D_39_L, bEnable?(BIT(0)|BIT(1)|BIT(2)|BIT(4)|BIT(6)):0x00, (BIT(0)|BIT(1)|BIT(2)|BIT(4)|BIT(6)));
            break;
        default:
            break;
    }
}
#endif

void MHal_SC_VRR_Init(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    MS_U16 u16VfdeEnd = 0, u16MinVTT = 0, u16MaxVTT = 0, u16M_delta = 0;

    //========================
    //IP1
    //========================
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_65_L, BIT(15), BIT(15)); //reg_usr_vpo_vs_width_en
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_65_L, BIT(15), BIT(15));
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_65_L, BIT(15), BIT(15));
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_65_L, BIT(15), BIT(15));
#endif
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_65_L, BIT(15), BIT(15));

    //========================
    //OP1
    //========================
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_19_L, BIT(6)|BIT(0), BIT(6)|BIT(1)|BIT(0)); //[1:0] = 1, raising edge of Vsync

    //========================
    //SCMI
    //========================
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKCB_08_L, BIT(6), BIT(6)); //reg_vrr_scrwd_done_mask
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKCB_08_L, BIT(7), BIT(7)); //reg_vrr_frcrwd_done_mask

    //========================
    //TGEN
    //========================
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_10_L, BIT(4), BIT(4)); //reg_insert_p_sel

    //========================
    //VRR_TOP setting
    //========================
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKCB_08_L, 0x0A, 0x0A); //mask vrr_en/m_const generated by timing detection

    //SW patch for HW issue
    //HDMI report m_const = 1 (0x33DF_08[9]) while VRR disable, it is not HW expect value
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKCB_08_L, 0x01, BIT(0)); //mask m_const from HDMI

    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKCB_09_L, 0x00, BIT(1)); //disable tgen self protection
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKCB_09_L, 0x00, BIT(2)); //disable input fps < vrr min condition

    //========================
    //VRR setting
    //========================
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_1A_L, BIT(13), BIT(13)|BIT(11)|BIT(10));
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_1A_L, 0x03, 0x7F);

    u16VfdeEnd = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, VOP_DE_VEND_MASK);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_1B_L, u16VfdeEnd + 5, VOP_DE_VEND_MASK);

    PNL_ApiExtStatus sPnlExtStatus;
    memset(&sPnlExtStatus, 0, sizeof(PNL_ApiExtStatus));
    sPnlExtStatus.u16ApiStatusEX_Length = sizeof(PNL_ApiExtStatus);

    if (MApi_PNL_GetStatusEx(&sPnlExtStatus))
    {
        u16MinVTT = sPnlExtStatus.u16MinVTotal;
        u16MaxVTT = sPnlExtStatus.u16MaxVTotal;
        u16M_delta = sPnlExtStatus.u16M_delta;
    }

    //VTT lower bound, upper bound
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_1D_L, u16MinVTT/2, 0x7FFF);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_1E_L, u16MaxVTT/2, 0x7FFF);

    //m_delta should be same as VTT variation
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_18_L, u16M_delta, 0x1FFF);
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK68_52_L, 0);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_53_L, u16M_delta, 0xFFFF);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_55_L, u16M_delta/2 + 3, 0xFFFF);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_59_L, u16M_delta*2, 0xFFFF);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_5A_L, u16M_delta, 0xFFFF);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_5B_L, u16M_delta/2, 0xFFFF);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_5C_L, u16M_delta/2, 0xFFFF);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_5E_L, 0x0001, 0x0003);
}

#ifdef MSOS_TYPE_LINUX_KERNEL
extern MS_BOOL KDrv_XC_RegisterHSECallback(ST_KDRV_XC_HSE_CALLBACK *pstXCHSECallback);
#endif

MS_BOOL Hal_SC_Init(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

#if (FRC_INSIDE && (HW_DESIGN_4K2K_VER == 6))
    MHal_FRC_Composer_User_Mode_Enable(pInstance, ENABLE);
    MHal_FRC_Set_Composer_User_Mode(pInstance, E_FRC_COMPOSER_SOURCE_MODE_VIP, FALSE);
    MHal_FRC_Set_Pipe_Delay_Mode(pInstance, (E_FRC_PIPE_DELAY_MODE_USER|PIP_DELAY_COUNTER_RESET));
    MHal_FRC_Set_FSC_DE_Selection(pInstance, E_FRC_FSC_SOURCE_MODE_FDE); // make FSC use FDE range from VIP to do SR

    // For FSC/FRC clk init
    MHal_CLKGEN_FRC_Init(pInstance, pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u8LPLL_Mode);

    // For STGEN init
    MHal_FRC_TGEN_Init(pInstance);

    // For STGEN init setting
    MST_PANEL_INFO_t stFRCPanelInfo;
    if (FALSE == pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Pnl_Misc.FRCInfo.bFRC)
    {
        pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Pnl_Misc.u8PanelHSyncWidth = pXCResourcePrivate->stdrvXC_Display._u16DefaultHSyncWidth;
        pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Pnl_Misc.u8PanelHSyncBackPorch = pXCResourcePrivate->stdrvXC_Display._u16DefaultHSyncBackPorch;
        pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Pnl_Misc.u8PanelVSyncWidth = pXCResourcePrivate->stdrvXC_Display._u16DefaultVSyncWidth;
        pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Pnl_Misc.u8PanelVSyncBackPorch = pXCResourcePrivate->stdrvXC_Display._u16DefaultVSyncBackPorch;
    }

    MDrv_FRC_PNLInfo_Transform(pInstance, &pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo,&pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Pnl_Misc, &stFRCPanelInfo);
    MDrv_FRC_Tx_SetTgen(pInstance, &stFRCPanelInfo);
    //calculate pipe delay after stgen setting
    if(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_B & E_XC_INIT_MISC_B_HDMITX_ENABLE)
    {
         MHal_FRC_Set_Pipe_Delay_Value(pInstance, FRC_PIPE_DELAY_HCNT_FRC, FRC_PIPE_DELAY_VCNT_FSC_FHD_HDMITX);
    }
    else
    {
         MHal_FRC_Set_Pipe_Delay_Value(pInstance, FRC_PIPE_DELAY_HCNT_FRC, FRC_PIPE_DELAY_VCNT_FSC_FHD);
    }

    if (IsVBY1_16LANE((MS_S32)(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type)))
    {
        // Maserati mode
        MHal_FRC_Set_3D_QMap(pInstance, E_FRC_PNL_TYPE_2D, E_XC_3D_INPUT_MODE_NONE, E_XC_3D_OUTPUT_MODE_NONE, E_XC_3D_OUTPUT_FI_MODE_NONE);
        MHal_FRC_ByPass_Enable(pInstance, FALSE); // always enable FRC
    }
    else
    {
        MHal_FRC_ByPass_Enable(pInstance, TRUE); // default disable FRC
    }

#endif

#if 0
    MHal_XC_FRCR2_IP_Patch(pInstance, MAIN_WINDOW);
    MHal_XC_FRCR2_OP_Patch(pInstance, MAIN_WINDOW);
#endif

    //set the delay line cnt to vfde end, for HW RD jeff's advice
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_19_L, BIT(6), BIT(6)|BIT(0));

    MHal_XC_Set_MIU_DynamicPriority(pInstance);

    //patch:close xc ip miu auto power saving mode following HW RD shengyuan's advice.power saving feature has not completed yet.
    //chips in the future can not control power related register,only m7221 & m 7821 need this patch
    MDrv_Write2ByteMask(REG_POWER_SAVING1, 0xB000, 0xB000);
    MDrv_Write2ByteMask(REG_POWER_SAVING2, 0x016D, 0x016D);
#ifndef DONT_USE_CMA
#if (XC_SUPPORT_CMA ==TRUE)
    if(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Main_FB_Size == 0)
    {
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN);
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
    }
    if(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Sub_FB_Size == 0)
    {
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB);
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB_OPW);
    }
#ifdef UFO_XC_SUPPORT_DUAL_MIU
    if(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Dual_FB_Size == 0)
    {
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_DUAL);
    }
#endif
#endif
#endif
#if (XC_SUPPORT_IOMMU == TRUE)
    if(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Main_FB_Size == 0)
    {
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN);
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
    }
    if(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Sub_FB_Size == 0)
    {
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB);
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB_OPW);
    }
#endif

    //enable OPM Flow Control
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_13_L, BIT(7), BIT(7));
    SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK11_14_L, 0xFA);

    //hse rel mem form iommu
    MHal_SC_SetHSEMemory(pInstance, FALSE);

#ifdef MSOS_TYPE_LINUX_KERNEL
    ST_KDRV_XC_HSE_CALLBACK stXCHSECallback;

    memset(&stXCHSECallback, 0, sizeof(ST_KDRV_XC_HSE_CALLBACK));
    stXCHSECallback.fpSetHSEMemory = MHal_SC_DynamicSetHSEMemoryCB;
    stXCHSECallback.u32Version = 0;
    stXCHSECallback.u32Length = sizeof(ST_KDRV_XC_HSE_CALLBACK);

    KDrv_XC_RegisterHSECallback(&stXCHSECallback);
#endif

    MHal_XC_SetBandwidth_Init(pInstance,E_XC_BANDWIDTH_SCMI_IPM_W);
    MHal_XC_SetBandwidth_Enable(pInstance,TRUE,E_XC_BANDWIDTH_SCMI_IPM_W);

    //For CR,Repeat last point at IPM
    //to avoid wrong scaling result at the border when h-input 8 align
    if (Hal_SC_NeedXCH8Align(pInstance))
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_68_L, BIT(11) , BIT(11));
    }

    return TRUE;
}

MS_U32 Hal_SC_Get_Device_Offset(MS_U8 deviceIdx)
{
    MS_U32 ret_U32 = 0 ;
    if(deviceIdx == 0 )
    {
        ret_U32 = MAX_XC_DEVICE0_OFFSET;
    }
    else if(deviceIdx == 1)
    {
        ret_U32 = MAX_XC_DEVICE1_OFFSET;
    }
    return ret_U32;
}

void HAL_SC_Set_LB_MergeAddress(void *pInstance)
{
    return;
}

void Hal_SC_set_edclk(void *pInstance, MS_U8 u8Clk_Mux, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    if(eWindow==MAIN_WINDOW)
    {
        MDrv_WriteByteMask(REG_CKG_EDCLK_F2, (bEnable? 0x00 : CKG_EDCLK_F2_GATED), CKG_EDCLK_F2_GATED);
        if(bEnable)
            MDrv_WriteByteMask(REG_CKG_EDCLK_F2, u8Clk_Mux, CKG_EDCLK_F2_MASK);
    }
    else if(eWindow==SUB_WINDOW)
    {
        MDrv_WriteByteMask(REG_CKG_EDCLK_F1, (bEnable? 0x00 : CKG_EDCLK_F1_GATED), CKG_EDCLK_F1_GATED);
        if(bEnable)
            MDrv_WriteByteMask(REG_CKG_EDCLK_F1, u8Clk_Mux, CKG_EDCLK_F1_MASK);
    }
}

void Hal_SC_set_ficlk2(void *pInstance, MS_U8 u8Clk_Mux, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    if(eWindow==MAIN_WINDOW)
    {
        MDrv_WriteByteMask(REG_CKG_FICLK2_F2, (bEnable? 0x00 : CKG_FICLK2_F2_GATED), CKG_FICLK2_F2_GATED);
        if(bEnable)
            MDrv_WriteByteMask(REG_CKG_FICLK2_F2, u8Clk_Mux, CKG_FICLK2_F2_MASK);
    }
    else if(eWindow==SUB_WINDOW)
    {
        printf("[%s,%5d] ficlk2_f2 not support sub!",__FUNCTION__,__LINE__);// no ficlk2_f1 for sub window
    }
}

void Hal_SC_set_fmclk(void *pInstance, MS_BOOL bEnable)
{
    if(bEnable == TRUE)
    {
        MDrv_WriteByteMask(REG_CKG_FMCLK, CKG_FMCLK_FCLK, CKG_FMCLK_MASK);
        MDrv_WriteByteMask(REG_CKG_FMCLK, DISABLE, CKG_FMCLK_GATED);
        MDrv_WriteByteMask(REG_CKG_FMCLK, DISABLE, CKG_FMCLK_INVERT);
    }
    else
    {
        MDrv_WriteByteMask(REG_CKG_FMCLK, ENABLE, CKG_FMCLK_GATED); // disable clock
    }
}

void HAL_SC_EnableLegacyMode(void *pInstance, MS_BOOL bEnable)
{
#if (HW_DESIGN_4K2K_VER == 4)
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if (psXCInstPri->u32DeviceID == 0)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_01_L, (bEnable<<0), BIT(0));
    }
    else
    {
        // do nothing, because there is only legacy mode in SC2, we don't have to do any switch
    }
#endif
}

static void  MHal_XC_DTVPatchISR(SC_INT_SRC eIntNum, void * pParam)
{
    void *pInstance = pu32XCInst_private;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(gSrcInfo[MAIN_WINDOW].bBlackscreenEnabled==FALSE)
    {
        //Check timing 2s
        if(((MsOS_GetSystemTime()- u32DTVPatchTimer)>2000))
        {
            u32DTVPatchTimer = MsOS_GetSystemTime();
            u16FDMaskCount=0;
        }

        //Check FD mask
        if(bPreFDMaskStatse != (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_67_L, BIT(4))==0))
        {
            bPreFDMaskStatse =(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_67_L, BIT(4))==0);
            u16FDMaskCount++;
        }

        if(u16FDMaskCount>6)
        {
            if (MDrv_XC_MLoad_GetStatus(pInstance) == E_MLOAD_ENABLED)
            {
                //UC_CTL off
                _MLOAD_ENTRY(pInstance);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK17_01_L, 0 ,BIT(0));
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK57_23_L, 0 ,0x40);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_67_L, 0x80 ,0xF0);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK12_07_L, 0 ,BIT(0));
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_20_L, 0 ,BIT(7));
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK11_21_L, 0 ,BIT(15));
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK05_78_L, 0 ,0xC000);
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK2A_02_L, BIT(1) ,BIT(1)|BIT(15));
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK05_20_L, 0 ,BIT(0));
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK05_12_L, 0 ,BIT(0));
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK2A_07_L, 0 ,BIT(0));
                MDrv_XC_MLoad_Fire(pInstance, TRUE);
                _MLOAD_RETURN(pInstance);
            }
            else
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK17_01_L, 0 ,BIT(0));
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK57_23_L, 0 ,0x40);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_67_L, 0x80 ,0xF0);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_07_L, 0 ,BIT(0));
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_20_L, 0 ,BIT(7));
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_21_L, 0 ,BIT(15));
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK05_78_L, 0 ,0xC000);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK2A_02_L, BIT(1) ,BIT(1)|BIT(15));
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK05_20_L, 0 ,BIT(0));
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK05_12_L, 0 ,BIT(0));
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK2A_07_L, 0 ,BIT(0));
            }

            u16FDMaskCount=0;

            if(TRUE == MDrv_XC_InterruptIsAttached(pInstance, SC_INT_VSINT, MHal_XC_DTVPatchISR, (void *)NULL))
            {
                //Disable ISR
                MDrv_XC_InterruptDeAttachWithoutMutex(pInstance, SC_INT_VSINT, MHal_XC_DTVPatchISR, (void *)NULL);
            }
        }
    }
}

void Hal_SC_3D_InvertMemsyncInterlaceMode(void *pInstance)
{
}

void MHal_XC_DTVPatch(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(eWindow ==MAIN_WINDOW)
    {
        if(IsSrcTypeDTV(gSrcInfo[MAIN_WINDOW].enInputSourceType)
           &&(gSrcInfo[MAIN_WINDOW].stCapWin.width==1920)
           &&(gSrcInfo[MAIN_WINDOW].stCapWin.height==1080)
           &&(gSrcInfo[MAIN_WINDOW].bInterlace==TRUE))
        {
            //DTV 1080i patch
            if(FALSE == MDrv_XC_InterruptIsAttached(pInstance, SC_INT_VSINT,MHal_XC_DTVPatchISR, (void *)NULL))
            {
                //Start DTV 1080i patch, enable ISR
                MDrv_XC_InterruptAttachWithoutMutex(pInstance, SC_INT_VSINT,MHal_XC_DTVPatchISR, (void *)NULL);
            }
        }
        else
        {
            if(TRUE == MDrv_XC_InterruptIsAttached(pInstance, SC_INT_VSINT, MHal_XC_DTVPatchISR, (void *)NULL))
            {
                //Disable ISR
                MDrv_XC_InterruptDeAttachWithoutMutex(pInstance, SC_INT_VSINT, MHal_XC_DTVPatchISR, (void *)NULL);
            }
        }
    }
}


#ifndef DONT_USE_CMA
#if (XC_SUPPORT_CMA ==TRUE)
MS_U64 MHal_XC_Get_CMA_Addr(void *pInstance, XC_CMA_CLIENT enCmaClient, MS_U32 u32GetCMASize, SCALER_WIN eWindow)
{
    MS_U64 u64CMAAddr = MSOS_INVALID_ADDR;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if (u32GetCMASize == 0)
    {
        return u64CMAAddr;
    }

    struct CMA_Pool_Init_Param CMA_Pool_Init_PARAM_temp[CMA_XC_MEM_NUM] = {{0},};


#ifdef UFO_XC_SUPPORT_SUB_CMA
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
        SCALER_WIN eCma_Win = WINDOW_NUM;
        if(psXCInstPri->u32DeviceID==0)
        {
            eCma_Win = MAIN_WINDOW;
        }
        else
        {
            eCma_Win  = SUB_WINDOW;
        }
#else
        eCma_Win = MAIN_WINDOW;
#endif

    CMA_Pool_Init_PARAM_temp[CMA_XC_SELF_MEM] = CMA_Pool_Init_PARAM[eCma_Win][CMA_XC_SELF_MEM];
    CMA_Pool_Init_PARAM_temp[CMA_XC_COBUFF_MEM] = CMA_Pool_Init_PARAM[eCma_Win][CMA_XC_COBUFF_MEM];
    CMA_Pool_Init_PARAM_temp[CMA_XC_HDR_DMA_MEM] = CMA_Pool_Init_PARAM[eCma_Win][CMA_XC_HDR_DMA_MEM];

#else
    CMA_Pool_Init_PARAM_temp[CMA_XC_SELF_MEM] = CMA_Pool_Init_PARAM[CMA_XC_SELF_MEM];
    CMA_Pool_Init_PARAM_temp[CMA_XC_COBUFF_MEM] = CMA_Pool_Init_PARAM[CMA_XC_COBUFF_MEM];
    CMA_Pool_Init_PARAM_temp[CMA_XC_HDR_DMA_MEM] = CMA_Pool_Init_PARAM[CMA_XC_HDR_DMA_MEM];

#endif

    struct CMA_Pool_Alloc_Param CMA_Pool_GetMem;
    memset(&CMA_Pool_GetMem,0,sizeof(CMA_Pool_GetMem));
    CMA_Pool_GetMem.pool_handle_id = CMA_Pool_Init_PARAM_temp[enCmaClient].pool_handle_id;
    CMA_Pool_GetMem.offset_in_pool = gSrcInfo[eWindow].Status2.stXCConfigCMA[enCmaClient].u64AddrHeapOffset;
    CMA_Pool_GetMem.flags = CMA_FLAG_VIRT_ADDR;

    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d][CMA],enCmaClient=%d pool_handle_id=%d status2.u32HeapID=%d status2.u64AddrHeapOffset=%tu heap_length=0x%x u32GetCMASize=0x%x\n",
        __func__,__LINE__,
        enCmaClient,
        CMA_Pool_Init_PARAM_temp[enCmaClient].pool_handle_id,
        gSrcInfo[eWindow].Status2.stXCConfigCMA[enCmaClient].u32HeapID,
        (ptrdiff_t)(gSrcInfo[eWindow].Status2.stXCConfigCMA[enCmaClient].u64AddrHeapOffset),
        CMA_Pool_Init_PARAM_temp[enCmaClient].heap_length,
        u32GetCMASize);

    if(CMA_Pool_Init_PARAM_temp[enCmaClient].heap_length >= u32GetCMASize)
    {
        CMA_Pool_GetMem.length = u32GetCMASize;
    }
    else
    {
        printf("\033[35m   Function = %s, Line = %d, CMA_POOL_INIT GetMem ERROR!!\033[m\n", __PRETTY_FUNCTION__, __LINE__);
        //assert(0);
    }
    if (MApi_CMA_Pool_GetMem(&CMA_Pool_GetMem) == FALSE)
    {
        SC_DBG(printf("\033[35m   Function = %s, Line = %d, MApi_CMA_Pool_GetMem() fail!!!\033[m\n", __PRETTY_FUNCTION__, __LINE__));
    }
    else
    {
        _miu_offset_to_phy(CMA_Pool_Init_PARAM_temp[enCmaClient].miu, CMA_Pool_Init_PARAM_temp[enCmaClient].heap_miu_start_offset, u64CMAAddr);
    }
    return u64CMAAddr;
}

MS_BOOL MHal_XC_Release_CMA(void *pInstance, XC_CMA_CLIENT enCmaClient, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

#ifdef MSOS_TYPE_LINUX_KERNEL
        if (pXCResourcePrivate->stdrvXC_MVideo._enPrevPowerState == E_POWER_SUSPEND)
        {
            return TRUE;//for kernel mode STR
        }
#endif

    struct CMA_Pool_Init_Param CMA_Pool_Init_PARAM_temp[CMA_XC_MEM_NUM] = {{0},};

#ifdef UFO_XC_SUPPORT_SUB_CMA
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
        SCALER_WIN eCma_Win = WINDOW_NUM;
        if(psXCInstPri->u32DeviceID==0)
        {
            eCma_Win = MAIN_WINDOW;
        }
        else
        {
            eCma_Win  = SUB_WINDOW;
        }
#else
        eCma_Win = MAIN_WINDOW;
#endif
        CMA_Pool_Init_PARAM_temp[CMA_XC_SELF_MEM] = CMA_Pool_Init_PARAM[eCma_Win][CMA_XC_SELF_MEM];
        CMA_Pool_Init_PARAM_temp[CMA_XC_COBUFF_MEM] = CMA_Pool_Init_PARAM[eCma_Win][CMA_XC_COBUFF_MEM];
        CMA_Pool_Init_PARAM_temp[CMA_XC_HDR_DMA_MEM] = CMA_Pool_Init_PARAM[eCma_Win][CMA_XC_HDR_DMA_MEM];

#else
    CMA_Pool_Init_PARAM_temp[CMA_XC_SELF_MEM] = CMA_Pool_Init_PARAM[CMA_XC_SELF_MEM];
    CMA_Pool_Init_PARAM_temp[CMA_XC_COBUFF_MEM] = CMA_Pool_Init_PARAM[CMA_XC_COBUFF_MEM];
    CMA_Pool_Init_PARAM_temp[CMA_XC_HDR_DMA_MEM] = CMA_Pool_Init_PARAM[CMA_XC_HDR_DMA_MEM];

#endif

    struct CMA_Pool_Free_Param stCMAFreeParam;
    if ((gSrcInfo[eWindow].u32PreCMAMemSCMSize[enCmaClient]+gSrcInfo[eWindow].u32PreCMAMemFRCMSize[enCmaClient])!=0)
    {
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN);
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
        stCMAFreeParam.pool_handle_id = CMA_Pool_Init_PARAM_temp[enCmaClient].pool_handle_id; //in: pool handle id, when pool init, returned by kernel
        stCMAFreeParam.offset_in_pool = gSrcInfo[eWindow].Status2.stXCConfigCMA[enCmaClient].u64AddrHeapOffset;
        stCMAFreeParam.length = gSrcInfo[eWindow].u32PreCMAMemSCMSize[enCmaClient]+gSrcInfo[eWindow].u32PreCMAMemFRCMSize[enCmaClient];
        if(MApi_CMA_Pool_PutMem(&stCMAFreeParam) == FALSE)
        {
            SC_DBG(printf("\033[35m   Function = %s, Line = %d, MApi_CMA_Pool_PutMem() fail!!!\033[m\n", __PRETTY_FUNCTION__, __LINE__));
        }
        else
        {
            gSrcInfo[eWindow].u32PreCMAMemSCMSize[enCmaClient] = 0;
            gSrcInfo[eWindow].u32PreCMAMemFRCMSize[enCmaClient] = 0;
            pXCResourcePrivate->stdrvXC_Scaling._au32PreFBSize[eWindow] = 0;
            if(eWindow == MAIN_WINDOW)
            {
                pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Main_FB_Start_Addr = MSOS_INVALID_ADDR;
                pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Main_FB_Size = 0x0;
            }
            else
            {
                pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Sub_FB_Start_Addr= MSOS_INVALID_ADDR;
                pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Sub_FB_Size = 0x0;
            }
            pXCResourcePrivate->stdrvXC_Scaling._au32PreFBAddress[eWindow] = XC_INVALID_MEM;
            pXCResourcePrivate->stdrvXC_Scaling._au32PreFBSize[eWindow] = 0;
        }
    }

    if ((gSrcInfo[MAIN_WINDOW].Status2.u32PreCMAMemDualSCMSize != 0) && (enCmaClient == CMA_XC_COBUFF_MEM))
    {
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_DUAL);
        MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
        stCMAFreeParam.pool_handle_id = CMA_Pool_Init_PARAM_temp[enCmaClient].pool_handle_id; //in: pool handle id, when pool init, returned by kernel
        stCMAFreeParam.offset_in_pool = gSrcInfo[eWindow].Status2.stXCConfigCMA[enCmaClient].u64AddrHeapOffset;
        stCMAFreeParam.length = gSrcInfo[MAIN_WINDOW].Status2.u32PreCMAMemDualSCMSize;
        if (MApi_CMA_Pool_PutMem(&stCMAFreeParam) == FALSE)
        {
            SC_DBG(printf("\033[35m   Function = %s, Line = %d, MApi_CMA_Pool_PutMem() fail!!!\033[m\n", __PRETTY_FUNCTION__, __LINE__));
        }
        else
        {
            gSrcInfo[MAIN_WINDOW].Status2.u32PreCMAMemDualSCMSize = 0;
        }
    }

#if (XC_SUPPORT_HDR_DMA_CMA == TRUE)
    if((pXCResourcePrivate->stdrvXC_MVideo.u32PreCMAHDMIDMASize !=0) && (enCmaClient == CMA_XC_HDR_DMA_MEM))
    {
        stCMAFreeParam.pool_handle_id = CMA_Pool_Init_PARAM_temp[enCmaClient].pool_handle_id; //in: pool handle id, when pool init, returned by kernel
        stCMAFreeParam.offset_in_pool = gSrcInfo[eWindow].Status2.stXCConfigCMA[enCmaClient].u64AddrHeapOffset;
        stCMAFreeParam.length = pXCResourcePrivate->stdrvXC_MVideo.u32PreCMAHDMIDMASize;
        if(MApi_CMA_Pool_PutMem(&stCMAFreeParam) == FALSE)
        {
            SC_DBG(printf("\033[35m   Function = %s, Line = %d, MApi_CMA_Pool_PutMem() fail!!!\033[m\n", __PRETTY_FUNCTION__, __LINE__));
        }
        else
        {
            pXCResourcePrivate->stdrvXC_MVideo.phyHDMIDMACMABaseAddress = MSOS_INVALID_ADDR;
            pXCResourcePrivate->stdrvXC_MVideo.u32PreCMAHDMIDMASize = 0;
        }
    }
#endif
    return TRUE;
}

static MS_BOOL _getDualModeMemorySize(void *pInstance, MS_U32 *pu32LeftSize, MS_U32 *pu32RightSize, SCALER_WIN eWindow)
{
    MS_U32 u32TotalSize = 0;

    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    if (gSrcInfo[eWindow].Status2.stXCConfigCMA[CMA_XC_COBUFF_MEM].u32HeapID != XC_INVALID_HEAP_ID && ((gSrcInfo[eWindow].enInputSourceType >= INPUT_SOURCE_HDMI)&&(gSrcInfo[eWindow].enInputSourceType <= INPUT_SOURCE_HDMI_MAX)))
    {
        if(pXCResourcePrivate->stdrvXC_MVideo.bUseDdr4DramForXc)
            u32TotalSize = XC_CMA_96MB + XC_CMA_24MB;
        else
            u32TotalSize = XC_CMA_96MB;
    }
    *pu32LeftSize  =  u32TotalSize * gSrcInfo[eWindow].Status2.stMiuDualModCfg.u32LeftFactor/(gSrcInfo[eWindow].Status2.stMiuDualModCfg.u32LeftFactor + gSrcInfo[eWindow].Status2.stMiuDualModCfg.u32RightFactor);
    *pu32RightSize =  u32TotalSize - *pu32LeftSize;
    return TRUE;
}

MS_BOOL MHal_XC_Get_CMA_UsingCondition(void *pInstance, MS_BOOL bIsGetCMABuff[], MS_U32 au32CMAMemSCMSize[],MS_U32 au32CMAMemFRCMSize[], MS_U32* pu32DualMiuMemSize, MS_U32 u32DataSize, SCALER_WIN eWindow)
{
    MS_U32 u32CMAMemSCMSize = 0;
    MIU_DDR_TYPE eXcDdrType = E_MIU_DDR3,eXcDualDdrType = E_MIU_DDR3;
    MS_BOOL bRet = FALSE;
    MVOP_Handle stMvopHd = {E_MVOP_MODULE_MAIN};
    MVOP_RgbFormat enRGB = E_MVOP_RGB_NONE;
    ST_PQ_StatusEx stStatus;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    memset(&stStatus,0,sizeof(ST_PQ_StatusEx));
    stStatus.u32ApiStatusEx_Version = ST_PQ_STATUSEX_VERSION;
    stStatus.u16ApiStatusEX_Length = sizeof(ST_PQ_StatusEx);

    if (u32DataSize < CMA_XC_MEM_NUM)
    {
        return FALSE;
    }

    struct CMA_Pool_Init_Param CMA_Pool_Init_PARAM_temp[CMA_XC_MEM_NUM] = {{0},};

#ifdef UFO_XC_SUPPORT_SUB_CMA
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
    SCALER_WIN eCma_Win = WINDOW_NUM;
    if(psXCInstPri->u32DeviceID==0)
    {
        eCma_Win = MAIN_WINDOW;
    }
    else
    {
        eCma_Win  = SUB_WINDOW;
    }
#else
    eCma_Win = MAIN_WINDOW;
#endif
    CMA_Pool_Init_PARAM_temp[CMA_XC_SELF_MEM] = CMA_Pool_Init_PARAM[eCma_Win][CMA_XC_SELF_MEM];
    CMA_Pool_Init_PARAM_temp[CMA_XC_COBUFF_MEM] = CMA_Pool_Init_PARAM[eCma_Win][CMA_XC_COBUFF_MEM];

    if(psXCInstPri->u32DeviceID == 1)
    {
        bIsGetCMABuff[CMA_XC_SELF_MEM] = TRUE;
        bIsGetCMABuff[CMA_XC_COBUFF_MEM] = FALSE;
        au32CMAMemSCMSize[CMA_XC_SELF_MEM] = XC_CMA_24MB;
        au32CMAMemSCMSize[CMA_XC_COBUFF_MEM] = 0;

        au32CMAMemFRCMSize[CMA_XC_SELF_MEM] = 0;
        au32CMAMemFRCMSize[CMA_XC_COBUFF_MEM] = 0;

        return TRUE;
    }
#else
    CMA_Pool_Init_PARAM_temp[CMA_XC_SELF_MEM] = CMA_Pool_Init_PARAM[CMA_XC_SELF_MEM];
    CMA_Pool_Init_PARAM_temp[CMA_XC_COBUFF_MEM] = CMA_Pool_Init_PARAM[CMA_XC_COBUFF_MEM];
#endif

    if (
#ifdef UFO_XC_SUPPORT_DUAL_MIU
    (gSrcInfo[eWindow].Status2.stXCConfigCMA[CMA_XC_COBUFF_MEM].u32HeapID != XC_INVALID_HEAP_ID)
    && IsEnableDualMode(eWindow)
#else
    0
#endif
     )
    {
        bIsGetCMABuff[CMA_XC_SELF_MEM] = TRUE;
        bIsGetCMABuff[CMA_XC_COBUFF_MEM] = TRUE;
    }
    else
    {
        bIsGetCMABuff[CMA_XC_SELF_MEM] = TRUE;
        bIsGetCMABuff[CMA_XC_COBUFF_MEM] = FALSE;
    }


    if((bIsGetCMABuff[CMA_XC_SELF_MEM] == TRUE)&&(bIsGetCMABuff[CMA_XC_COBUFF_MEM] == FALSE))
    {
        bRet = MDrv_MIU_GetDramType(CMA_Pool_Init_PARAM_temp[CMA_XC_SELF_MEM].miu,&eXcDdrType);
        if(bRet == FALSE)
        {
            printf("Get dram type fail %s,%d\n",__FUNCTION__,__LINE__);
        }
        if(eXcDdrType == E_MIU_DDR4)
        {
            pXCResourcePrivate->stdrvXC_MVideo.bUseDdr4DramForXc = TRUE;
        }
        else
        {
            pXCResourcePrivate->stdrvXC_MVideo.bUseDdr4DramForXc = FALSE;
        }
    }
    else if((bIsGetCMABuff[CMA_XC_SELF_MEM] == FALSE)&&(bIsGetCMABuff[CMA_XC_COBUFF_MEM] == TRUE))
    {
        bRet = MDrv_MIU_GetDramType(CMA_Pool_Init_PARAM_temp[CMA_XC_COBUFF_MEM].miu,&eXcDualDdrType);
        if(bRet == FALSE)
        {
            printf("Get dram type fail %s,%d\n",__FUNCTION__,__LINE__);
        }

        if(eXcDualDdrType == E_MIU_DDR4)
        {

            pXCResourcePrivate->stdrvXC_MVideo.bUseDdr4DramForXc = TRUE;
        }
        else
        {
            pXCResourcePrivate->stdrvXC_MVideo.bUseDdr4DramForXc = FALSE;
        }
    }
    else if((bIsGetCMABuff[CMA_XC_SELF_MEM] == TRUE)&&(bIsGetCMABuff[CMA_XC_SELF_MEM] == TRUE))
    {
        bRet = MDrv_MIU_GetDramType(CMA_Pool_Init_PARAM_temp[CMA_XC_SELF_MEM].miu,&eXcDdrType);
        if(bRet == FALSE)
        {
            printf("Get dram type fail %s,%d\n",__FUNCTION__,__LINE__);
        }

        bRet = MDrv_MIU_GetDramType(CMA_Pool_Init_PARAM_temp[CMA_XC_COBUFF_MEM].miu,&eXcDualDdrType);
        if(bRet == FALSE)
        {
            printf("Get dram type fail %s,%d\n",__FUNCTION__,__LINE__);
        }

        if((eXcDdrType == E_MIU_DDR4) || (eXcDualDdrType == E_MIU_DDR4))
        {
            pXCResourcePrivate->stdrvXC_MVideo.bUseDdr4DramForXc = TRUE;
        }
        else
        {
            pXCResourcePrivate->stdrvXC_MVideo.bUseDdr4DramForXc = FALSE;
        }
    }


    if(MDrv_MVOP_GetCommand(&stMvopHd, E_MVOP_CMD_GET_RGB_FMT, &enRGB, sizeof(MVOP_RgbFormat)) != E_MVOP_OK)
    {
        printf("%s %d,mvop get cmd fail!\n",__FUNCTION__,__LINE__);
    }

    if(MDrv_PQ_GetStatusEx(&stStatus) == FALSE)
    {
        printf("%s %d,get status fail!\n",__FUNCTION__,__LINE__);
    }

    if((g_IPanel.Width() <= XC_4K2K_WIDTH_MAX) && (g_IPanel.Height() <= XC_4K2K_HIGH_MAX)
        && (g_IPanel.Width() >= XC_4K2K_WIDTH_MIN) && (g_IPanel.Height() >= XC_4K2K_HIGH_MIN))
    {
        if ((pXCResourcePrivate->sthal_Optee.op_tee_xc[MAIN_WINDOW].isEnable == FALSE)
            && (IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType))
            && (enRGB == E_MVOP_RGB_888))
        {
            u32CMAMemSCMSize = XC_CMA_76MB;
        }
        else if (((MDrv_XC_Is_DSForceIndexEnabled(pInstance, MAIN_WINDOW)||MDrv_XC_GetDynamicScalingStatus(pInstance))
            && ((IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType)) || (IsSrcTypeDTV(gSrcInfo[eWindow].enInputSourceType))))
            || (pXCResourcePrivate->sthal_Optee.op_tee_xc[MAIN_WINDOW].isEnable == TRUE))
        {
            // MM/P mode use 4K2K virtualbox, MM/I mode use FHD virtualbox.
            if (gSrcInfo[(eWindow)].bInterlace)
            {
                u32CMAMemSCMSize = XC_CMA_26MB;
            }
            else
            {
                if((gSrcInfo[(eWindow)].stCapWin.width>= 3840) || (gSrcInfo[(eWindow)].stCapWin.height>= 2160))
                { // need consider I/P change case
                    u32CMAMemSCMSize = XC_CMA_22MB;//for FBL+UC case
                }
                else
                {
                    u32CMAMemSCMSize = XC_CMA_22MB;//for PQDS+ case that xc VB size is FHD
                }
            }
        }
        else if ((IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType)) || (IsSrcTypeDTV(gSrcInfo[eWindow].enInputSourceType)))
        {
            if ((gSrcInfo[(eWindow)].stCapWin.width>= 3840) || (gSrcInfo[(eWindow)].stCapWin.height>= 2160))
            {
                u32CMAMemSCMSize = XC_CMA_9MB;
            }
            else
            {
                u32CMAMemSCMSize = XC_CMA_22MB;
            }
        }
        else//HDMI and others
        {
            if ((gSrcInfo[(eWindow)].stCapWin.width>= 3840) || (gSrcInfo[(eWindow)].stCapWin.height>= 2160))
            {
                u32CMAMemSCMSize = XC_CMA_85MB;
            }
            else
            {
                u32CMAMemSCMSize = XC_CMA_22MB;
            }
        }
    }
    else //FHD mode
    {
        if ((pXCResourcePrivate->sthal_Optee.op_tee_xc[MAIN_WINDOW].isEnable == FALSE)
            && (IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType))
            && (enRGB == E_MVOP_RGB_888))
        {
            u32CMAMemSCMSize = XC_CMA_19MB;
        }
        else if (((MDrv_XC_Is_DSForceIndexEnabled(pInstance, MAIN_WINDOW)||MDrv_XC_GetDynamicScalingStatus(pInstance))
            && ((IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType)) || (IsSrcTypeDTV(gSrcInfo[eWindow].enInputSourceType))))
            || (pXCResourcePrivate->sthal_Optee.op_tee_xc[MAIN_WINDOW].isEnable == TRUE))
        {
            //if inputsource is 4K2K,it will be prescaled down to FHD by vdec.
            u32CMAMemSCMSize = XC_CMA_22MB;
        }
        else if ((IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType)) || (IsSrcTypeDTV(gSrcInfo[eWindow].enInputSourceType)))
        {
            //if inputsource is 4K2K,it will be prescaled down to FHD by vdec.
            u32CMAMemSCMSize = XC_CMA_22MB;
        }
        else//HDMI and others
        {
            //if inputsource is 4K2K,it will be prescaled down to FHD by vdec.
            u32CMAMemSCMSize = XC_CMA_22MB;
        }
    }

    u32CMAMemSCMSize = CMA4MALIGN(u32CMAMemSCMSize);

    if (
#ifdef UFO_XC_SUPPORT_DUAL_MIU
        (gSrcInfo[eWindow].Status2.stXCConfigCMA[CMA_XC_COBUFF_MEM].u32HeapID != XC_INVALID_HEAP_ID)
        && IsEnableDualMode(eWindow)
#else
        0
#endif
         )
    {
        //*pu32DualMiuMemSize = XC_CMA_48MB;
        //au32CMAMemSCMSize[CMA_XC_SELF_MEM] = u32CMAMemSCMSize;
        _getDualModeMemorySize(pInstance, &au32CMAMemSCMSize[CMA_XC_SELF_MEM], pu32DualMiuMemSize, eWindow);
        au32CMAMemSCMSize[CMA_XC_COBUFF_MEM] = 0;
    }
    else
    {
        if (gSrcInfo[eWindow].Status2.stXCConfigCMA[CMA_XC_COBUFF_MEM].u32HeapID == XC_INVALID_HEAP_ID || IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[eWindow].enInputSourceType))
        {
            au32CMAMemSCMSize[CMA_XC_SELF_MEM] = u32CMAMemSCMSize;
            au32CMAMemSCMSize[CMA_XC_COBUFF_MEM] = 0;
        }
        *pu32DualMiuMemSize = 0;
    }

    au32CMAMemFRCMSize[CMA_XC_SELF_MEM] = 0;
    au32CMAMemFRCMSize[CMA_XC_COBUFF_MEM] = 0;

    return TRUE;
}
#ifdef MSOS_TYPE_LINUX_KERNEL
#else
static void  MHal_XC_CMAPatchISR(SC_INT_SRC eIntNum, void * pParam)
{
    void *pInstance = pu32XCInst_private;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U8 u8LPLL_Type = (MS_U8)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type;

    if((MDrv_XC_IsInputSourceDisabled(pInstance, MAIN_WINDOW, INPUT_SOURCE_NONE)==TRUE)
       &&(   ((gSrcInfo[MAIN_WINDOW].u32PreCMAMemSCMSize[CMA_XC_SELF_MEM]+gSrcInfo[MAIN_WINDOW].u32PreCMAMemFRCMSize[CMA_XC_SELF_MEM])!=0)
             ||((gSrcInfo[MAIN_WINDOW].u32PreCMAMemSCMSize[CMA_XC_COBUFF_MEM]+gSrcInfo[MAIN_WINDOW].u32PreCMAMemFRCMSize[CMA_XC_COBUFF_MEM])!=0)
#ifdef UFO_XC_SUPPORT_DUAL_MIU
             ||(gSrcInfo[MAIN_WINDOW].Status2.u32PreCMAMemDualSCMSize!=0)
#endif
         )
      )
    {
        //Check timing 5s
        if(((MsOS_GetSystemTime()- u32CMAPatchTimer_Main)>5000))
        {
            u32CMAPatchTimer_Main = MsOS_GetSystemTime();

            //MHal_XC_Release_CMA(pInstance, CMA_XC_SELF_MEM, MAIN_WINDOW);
            //MHal_XC_Release_CMA(pInstance, CMA_XC_COBUFF_MEM, MAIN_WINDOW);
        }
    }
    else
    {
        u32CMAPatchTimer_Main = MsOS_GetSystemTime();
    }

    if((MDrv_XC_IsInputSourceDisabled(pInstance, MAIN_WINDOW, INPUT_SOURCE_NONE)==TRUE))
    {
        //Check timing 5s
        if(((MsOS_GetSystemTime()- u32DisableFRCTimer)>5000))
        {
            u32DisableFRCTimer = MsOS_GetSystemTime();

#if (FRC_INSIDE && (HW_DESIGN_4K2K_VER == 6))
            // For FRC case, if no input source, need to disable FRC for power saving
            if (!IsVBY1_16LANE(u8LPLL_Type) && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFRCEnabled))
            {
                MHal_FRC_ByPass_Enable(pInstance, TRUE);
            }
            //FSC power down
            MDrv_WriteByteMask( REG_FSC_BK20_05, 0x00, 0x10); // reg_ckg_ficlk
            MDrv_WriteByteMask( REG_FSC_BK20_04, 0x01, 0x01); // reg_ckg_odclk
#endif

            #ifdef CONFIG_MSTAR_SRAMPD
            // control SRAM PD here
            // disable SRAM here
            MHal_XC_SRAM_PowerDown_Control(pInstance, TRUE);
            #endif

        }
    }
    else
    {
        u32DisableFRCTimer = MsOS_GetSystemTime();
    }
}
#endif
void MHal_XC_CMAPatch(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    #ifdef MSOS_TYPE_LINUX_KERNEL
    #else
    if(eWindow ==MAIN_WINDOW)
    {
        if(FALSE == MDrv_XC_InterruptIsAttached(pInstance, SC_INT_VSINT,MHal_XC_CMAPatchISR, (void *)NULL))
        {
            //Start CMA  patch, enable ISR
            u32CMAPatchTimer_Main = MsOS_GetSystemTime();
            u32DisableFRCTimer = MsOS_GetSystemTime();
            MDrv_XC_InterruptAttachWithoutMutex(pInstance, SC_INT_VSINT,MHal_XC_CMAPatchISR, (void *)NULL);
        }
    }
    #endif
}

void MHal_XC_CMAPatchClose(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    #ifdef MSOS_TYPE_LINUX_KERNEL
    #else
    if(eWindow ==MAIN_WINDOW)
    {
        if(TRUE == MDrv_XC_InterruptIsAttached(pInstance, SC_INT_VSINT, MHal_XC_CMAPatchISR, (void *)NULL))
        {
            //Disable ISR
            MDrv_XC_InterruptDeAttachWithoutMutex(pInstance, SC_INT_VSINT, MHal_XC_CMAPatchISR, (void *)NULL);
        }
    }
    #endif
}
#endif
#endif

void MHAL_SC_set_r2y_en(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(eWindow == MAIN_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK18_06_L, bEnable?BIT(0):0x00, BIT(0));
    }
    else if(eWindow == SUB_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK18_76_L, bEnable?BIT(0):0x00, BIT(0));
    }
}

MS_BOOL MHAL_SC_get_r2y_en_status(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_BOOL bstatus = FALSE;

    if(eWindow == MAIN_WINDOW)
    {
        bstatus = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK18_06_L, BIT(0));
    }
    else if(eWindow == SUB_WINDOW)
    {
        bstatus = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK18_76_L, BIT(0));
    }

    return bstatus;
}

void Hal_SC_set_T3D_setting(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if (MDrv_XC_MLoad_GetStatus(pInstance) == E_MLOAD_ENABLED)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK62_63_L, 0x00, BIT(0)); // default disable T3D SRAM
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK62_63_L, 0x00, BIT(0)); // default disable T3D SRAM
    }

}

void Hal_SC_set_T3D_H_size(void *pInstance, MS_U16 u16Hsize)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK63_55_L, u16Hsize, 0x1FFF); //horizontal pixel number
}

MS_BOOL Hal_SC_3D_Is_LR_Sbs2Line(void *pInstance)
{
    if(SC_R2BYTEMSK(0, REG_SC_BK23_53_L, BIT(15)))
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

void Hal_SC_3D_SetLRChgMode(void *pInstance, HAL_SC_3D_LRCHGMODE eLRChgMode)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_63_L, eLRChgMode, BIT(1)|BIT(0));
}

// 0: L is the first frame, 1: R is the first frame
void Hal_SC_3D_SetInitialLRIndex(void *pInstance, MS_BOOL bRFirst)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_63_L, (bRFirst==TRUE)?BIT(4):0, BIT(4));
}

// Split 1 frame into 2 frames
void Hal_SC_3D_SetSplitHalf(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_63_L, (bEnable==TRUE)?BIT(8):0, BIT(8));
}

void Hal_SC_set_frcm_to_FD_mask(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if (eWindow == MAIN_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_02_L, (bEnable==TRUE)?BIT(2):0, BIT(2));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_02_L, (bEnable==TRUE)?BIT(10):0, BIT(10));
    }
}

void Hal_SC_3D_set_top_win_6Tap(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK57_23_L, (bEnable==TRUE)?BIT(10):0, BIT(10)); //force top window using 6line
}

void Hal_SC_3D_SetActiveVideoHeight(void *pInstance, MS_U16 u16VideoSize)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(SUPPORT_3D_DS && (g_bSWDSGenScenario == TRUE))
    {
        Hal_SC_WriteSWDSCommand(pInstance, MAIN_WINDOW, REG_SC_BK02_65_L, u16VideoSize, DS_IP, DS_XC, &PSTXC_DS_CMDCNT);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_65_L, u16VideoSize, 0x1FFF);//v_active region
    }
}

// 0 for blank area 0
//v blanking between field1&field2 or field3&field4
void Hal_SC_3D_SetActiveBlankSize0(void *pInstance, MS_U16 u16BlankSize)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(SUPPORT_3D_DS && (g_bSWDSGenScenario == TRUE))
    {
        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_66_L,u16BlankSize,DS_IP, DS_XC, &PSTXC_DS_CMDCNT);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_66_L, u16BlankSize, 0x1FFF);
    }
}

// 1 for blank area 1
//v blanking between field2&field3
void Hal_SC_3D_SetActiveBlankSize1(void *pInstance, MS_U16 u16BlankSize)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(SUPPORT_3D_DS && (g_bSWDSGenScenario == TRUE))
    {
        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_67_L,u16BlankSize,DS_IP, DS_XC, &PSTXC_DS_CMDCNT);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_67_L, u16BlankSize, 0x1FFF);//v blanking between field1&field2 or field3&field4
    }
}

void Hal_SC_3D_SetActiveVideoWidth(void *pInstance, MS_U16 u16VideoSize)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    MS_U16 u16ActiveWidthUsrEnable = 0;
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    if (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_2F_L, MAIN_WINDOW), BIT(15)) == BIT(15))
#else
    if (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_2F_L, BIT(15)) == BIT(15))
#endif
    {
        u16ActiveWidthUsrEnable = BIT(15);
    }

    if(SUPPORT_3D_DS && (g_bSWDSGenScenario == TRUE))
    {
        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_7F_L,u16VideoSize | u16ActiveWidthUsrEnable,DS_IP, DS_XC, &PSTXC_DS_CMDCNT);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_7F_L, u16VideoSize | u16ActiveWidthUsrEnable, 0x9FFF);//v_active region
    }
}


void Hal_SC_3D_SetActiveVideoHeightAfterVSD(void *pInstance, MS_U16 u16VideoSize)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    MS_U16 u16Enable = BIT(15);

    if(SUPPORT_3D_DS && (g_bSWDSGenScenario == TRUE))
    {
        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_38_L,u16VideoSize | u16Enable,DS_IP, DS_XC, &PSTXC_DS_CMDCNT);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_38_L, u16VideoSize | u16Enable, 0x9FFF);
    }
}

void Hal_SC_3D_SetFRCMActiveVideoHeightAfterVSD(void *pInstance, MS_U16 u16VideoSize)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    MS_U16 u16Enable = BIT(15);

    if(SUPPORT_3D_DS && (g_bSWDSGenScenario == TRUE))
    {
        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW, REG_SC_BK48_38_L,u16VideoSize | u16Enable,DS_IP, DS_XC, &PSTXC_DS_CMDCNT);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK48_38_L, u16VideoSize | u16Enable, 0x9FFF);
    }
}

void Hal_SC_3D_SetPixelSeparationWidth(void *pInstance, MS_U16 u16VideoSize)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    MS_U16 u16ActiveWidthUsrEnable = 0;
#if (HW_DESIGN_3D_VER >= 3)
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    if (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_2F_L, MAIN_WINDOW), BIT(15)) == BIT(15))
#else
    if (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_2F_L, BIT(15)) == BIT(15))
#endif
    {
        u16ActiveWidthUsrEnable = BIT(15);
    }
#endif

    if(SUPPORT_3D_DS && (g_bSWDSGenScenario == TRUE))
    {
        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK02_6C_L,u16VideoSize | u16ActiveWidthUsrEnable,DS_IP, DS_XC, &PSTXC_DS_CMDCNT);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_6C_L, u16VideoSize | u16ActiveWidthUsrEnable, 0x87FF);
    }
}

void Hal_SC_3D_SetSoftware_F1VBottomEndPosition(void *pInstance, MS_U16 u16VideoSize)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(SUPPORT_3D_DS && (g_bSWDSGenScenario == TRUE))
    {
        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK57_4F_L,u16VideoSize,DS_IP, DS_XC, &PSTXC_DS_CMDCNT);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK57_4F_L, u16VideoSize, 0x0FFF);
    }
}

void Hal_SC_3D_SetSoftware_F2VBottomEndPosition(void *pInstance, MS_U16 u16VideoSize)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(SUPPORT_3D_DS && (g_bSWDSGenScenario == TRUE))
    {
        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK57_4D_L,u16VideoSize,DS_IP, DS_XC, &PSTXC_DS_CMDCNT);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK57_4D_L, u16VideoSize, 0x0FFF);
    }
}

void Hal_SC_3D_SetSoftware_F1VBottomStartPosition(void *pInstance, MS_U16 u16VideoSize)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(SUPPORT_3D_DS && (g_bSWDSGenScenario == TRUE))
    {
        Hal_SC_WriteSWDSCommand(pInstance,MAIN_WINDOW,REG_SC_BK57_4E_L,u16VideoSize,DS_IP, DS_XC, &PSTXC_DS_CMDCNT);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK57_4E_L, u16VideoSize, 0x0FFF);
    }
}

void Hal_SC_set_frcm_to_freeze(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if (eWindow == MAIN_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_02_L, (bEnable==TRUE)?BIT(0):0, BIT(0));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_02_L, (bEnable==TRUE)?BIT(8):0, BIT(8));
    }
}

E_APIXC_ReturnValue Hal_SC_SetOSDDetect(void *pInstance, MS_BOOL bEnable, MS_U32 Threhold)
{
    MS_U16 u16Reg = 0;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(Threhold == 0)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_6A_L, 0x0, (BIT(15)+BMASK(11:0)));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK25_2E_L, BIT(1), BIT(1));

    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK25_2E_L, 0x0, BIT(1));
        u16Reg = ((MS_U16)Threhold*2)|(bEnable << 15);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_6A_L, u16Reg, (BIT(15)+BMASK(11:0)));
    }
    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue Hal_SC_GetOSDDetect(void *pInstance, MS_BOOL *pbOSD)
{
    MS_U16 u16Reg = 0;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    u16Reg = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_6A_L);
    *pbOSD = ((u16Reg&BIT(14))>>14);
    return E_APIXC_RET_OK;
}

void Hal_SC_SetHDMI_Spliter(void *pInstance,XC_IP_SYNC_STATUS *sXC_Sync_Status,E_MUX_INPUTPORT enInputPort ,SCALER_WIN eWindow)
{

#if 0//SUPPORT_HDMI20
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    MS_U16 u16HDE_temp_size,u16HDE_size =0;

    if((sXC_Sync_Status->u8SyncStatus & XC_MD_SYNC_LOSS) != XC_MD_SYNC_LOSS)
    {
        if(MDrv_HDMI_CheckHDMI20_Setting(enInputPort))
        {
            //printf("[%s][%d]HDMI 4K2K 2P mode\n", __FUNCTION__, __LINE__);
            if(eWindow == MAIN_WINDOW)
                W2BYTEMSK(0x102e02,0x0010,BMASK(7:4)); // ipmux sel=0xb
            else if(eWindow == SUB_WINDOW)
                W2BYTEMSK(0x102e02,0x0001,BMASK(3:0)); // ipmux sel=0xb

        }
        else
        {
            //SUPPORT_HDMI20_420
            //printf("[%s][%d]HDMI 4K2K 2P mode\n", __FUNCTION__, __LINE__);
            //printf("[%s][%d]sXC_Sync_Status->u16Vtotal=%x, sXC_Sync_Status->u16Hperiod=%x\n",
            //    __FUNCTION__, __LINE__, sXC_Sync_Status->u16Vtotal, sXC_Sync_Status->u16Hperiod);
            if((sXC_Sync_Status->u16Vtotal >= 0x8C0)
               &&(sXC_Sync_Status->u16Hperiod>= 0x50))
            {
                if((MDrv_HDMI_avi_infoframe_info(_BYTE_1)& 0x60) == 0x60)
                {
                    //printf("@@#@@4K2K@60 420\n");
                    // clkgen2
                    W2BYTE(0x100a80,0x0004); // spt_l0 1: hdmi d: mhl
                    // ipmux
                    if(eWindow == MAIN_WINDOW)
                    {
                        W2BYTEMSK(0x102e02,0x00b0,BMASK(7:4)); // ipmux sel=0xb
                    }
                    else if(eWindow == SUB_WINDOW)
                    {
                        W2BYTEMSK(0x102e02,0x000b,BMASK(3:0)); // ipmux sel=0xb
                    }

                    //BK40_SPT4k
                    SC_W2BYTE(0, REG_SC_BK40_01_L,0x0000); // [3:0]  reg_spt_ipmux_sel0
                    // [11:8] reg_spt_ipmux_sel1
                    SC_W2BYTE(0, REG_SC_BK40_03_L,0x0001); // [7] reg_spt_2p_oe_en [0] reg_spt_420_en
                    SC_W2BYTE(0, REG_SC_BK40_04_L,0x0180); // [7] reg_spt_2p_oe_out_en [9] hsd_en
                    // [8] reg_spt_2poe_out_sel 1'b0: dual ch eo in
                    //                                    1'b1: dual ch LR in or 420
                    SC_W2BYTE(0, REG_SC_BK40_30_L, 0x0003); // de_only
                    SC_W2BYTE(0, REG_SC_BK40_0B_L, 0x0000); // gb_size

                    u16HDE_temp_size = MDrv_HDMI_GetHDE();
                    //printf("[%s][%d]u16HDE_size=%u\n", __FUNCTION__, __LINE__,u16HDE_temp_size);
                    if((u16HDE_temp_size >= 2028)&&(u16HDE_temp_size<= 2068))
                    {
                        u16HDE_size = 2048;
                    }
                    else //if((u16HDE_temp_size >= 1900)&&(u16HDE_temp_size<= 1940))
                    {
                        u16HDE_size = 1920;
                    }
                    SC_W2BYTE(0, REG_SC_BK40_08_L, u16HDE_size); // de_in_size
                    SC_W2BYTE(0, REG_SC_BK40_0A_L, u16HDE_size); // de_out_with_gb_size

                    SC_W2BYTE(0, REG_SC_BK40_20_L, 0x0000); // ra
                    SC_W2BYTE(0, REG_SC_BK40_21_L, u16HDE_size/2-2); //
                    SC_W2BYTE(0, REG_SC_BK40_22_L, 0x0001);
                    SC_W2BYTE(0, REG_SC_BK40_23_L, u16HDE_size/2-1);

                    SC_W2BYTE(0, REG_SC_BK40_24_L, 0x0000); // wa
                    SC_W2BYTE(0, REG_SC_BK40_25_L, u16HDE_size/2-2);
                    SC_W2BYTE(0, REG_SC_BK40_26_L, 0x0001);
                    SC_W2BYTE(0, REG_SC_BK40_27_L, u16HDE_size/2-1);
                }
                else
                {
                    //printf("@@#@@4K2K@30\n");
                    /// for 4K2K@30Hz
                    if(eWindow == MAIN_WINDOW)
                    {
                        W2BYTEMSK(0x102e02,0x0010,BMASK(7:4)); // ipmux sel=0xb
                    }
                    else if(eWindow == SUB_WINDOW)
                    {
                        W2BYTEMSK(0x102e02,0x0001,BMASK(3:0)); // ipmux sel=0xb
                    }
                }
            }
        }
    }
#endif
}

void MHal_SC_CheckDILineBufferSize(MS_BOOL *pbBypass_DILB, MS_U16 u16Width)
{
    if(pbBypass_DILB != NULL)
    {
        if(u16Width > XC_DI_LINE_BUFFER_MAX)
        {
            *pbBypass_DILB = TRUE;
        }
        else
        {
            *pbBypass_DILB = FALSE;
        }
    }
    else
    {
        printf("[%s][%d]pbBypass_DILB is NULL!!!\n", __FUNCTION__, __LINE__);
    }
}


void Hal_SC_Set_2pmode(void *pInstance, MS_BOOL UNUSED_PARA(benable_IP2p), MS_BOOL benable_OP2p, MS_BOOL UNUSED_PARA(benable_bypass_all_2p), SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if (eWindow == MAIN_WINDOW)
    {
        if (psXCInstPri->u32DeviceID == 0)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_01_L,(benable_OP2p ? BIT(1):0), BIT(1));//reg_opm_2p_mode
        }
    }
}

MS_BOOL Hal_SC_check_opm_2pmode_timing(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    //New opm 2pmode checking formula for M7322,M7332,M7632
    //(OP Pixel rate) * (Vmem / stg??s Vmde size) * (Hmem / stg??s Htt) compare with MAX_1P_MODE_CLK
    MS_U16 u16HTotal = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16HTotal;
    MS_U16 u16VTotal = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16VTotal;
    MS_U16 u16V_MDE = gSrcInfo[eWindow].stDispWin.height;
    MS_U16 u16H_mem = gSrcInfo[eWindow].ScaledCropWin.width;
    MS_U16 u16V_mem = gSrcInfo[eWindow].ScaledCropWin.height;
    MS_U32 u32OPclk = 0;

    if((u16HTotal == 0)||(u16V_MDE == 0))
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"ERROR!! HTotal or V_MDE get size 0, HTotal = %u , V_MDE = %u\n", u16HTotal, u16VTotal);
        return FALSE;
    }

    u32OPclk = PNL_FRAME_RATE * (MS_U32)u16HTotal * (MS_U32)u16VTotal;
    if((u32OPclk / ((MS_U32)u16HTotal * (MS_U32)u16V_MDE)) * ((MS_U32)u16H_mem * (MS_U32)u16V_mem) >= MAX_1P_MODE_CLK)
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

void MHal_SC_set_manual_rbank_switch_cnt(void *pInstance, MS_BOOL bEnable, MS_U16 u16SwitchCnt, SCALER_WIN eWindow)
{
    if (eWindow >= WINDOW_NUM)
    {
        printf("unsupported eWindow, return!\n");
        return;
    }

    if( eWindow == MAIN_WINDOW)
    {
        // these two registers must be set simultaneously for this feature to work
        // frame rate convert dependence with IP write line count
        SC_W2BYTEMSK(0,REG_SC_BK12_05_L, bEnable? BIT(3):0, BIT(3));
        // frame rate convert dependence with IP write line count FULL
        SC_W2BYTEMSK(0,REG_SC_BK11_18_L, bEnable? BIT(15):0, BIT(15));

        // set specific line count according to when you will change rbank switch
        // this line count starts at VDE rising edge, ends at u16SwitchCnt
        SC_W2BYTEMSK(0,REG_SC_BK11_18_L, u16SwitchCnt, 0x1FFF);
    }
    else
    {
        // these two registers must be set simultaneously for this feature to work
        // frame rate convert dependence with IP write line count
        SC_W2BYTEMSK(0,REG_SC_BK12_45_L, bEnable? BIT(3):0, BIT(3));
        // frame rate convert dependence with IP write line count FULL
        SC_W2BYTEMSK(0,REG_SC_BK11_58_L, bEnable? BIT(15):0, BIT(15));

        // set specific line count according to when you will change rbank switch
        // this line count starts at VDE rising edge, ends at u16SwitchCnt
        SC_W2BYTEMSK(0,REG_SC_BK11_58_L, u16SwitchCnt, 0x1FFF);
    }
}

#if (defined SUPPORT_BWD) && (!(defined XC_SUPPORT_BWR_USER_MODE))
static void _HAL_SC_BWR_set_base_address(void *pInstance, MS_U16 u16MemCfgValue,MS_U16 u16MemCfgIndex, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    E_XC_BWR_MEM_CONFIG u8Memtype = E_XC_BWR_MEM_CONFIG_1;
    E_XC_BWR_MEM_CFG_BPP_TYPE eBPPType = E_XC_BWR_MEM_CFG_BPP_24;
    for(u8Memtype=E_XC_BWR_MEM_CONFIG_1; u8Memtype<E_XC_BWR_MEM_CONFIG_Max; u8Memtype++)
    {
        if(u16MemCfgValue == gSrcInfo[eWindow].Status2.stMemCfgMap[u8Memtype].u16BWR_MEM_CFG_VALUE)
        {
            eBPPType = gSrcInfo[eWindow].Status2.stMemCfgMap[u8Memtype].eBitPerPixelType;
            break;
        }
    }

#ifdef  UFO_XC_SUPPORT_DUAL_MIU
    if (IsEnableDualMode(eWindow))
    {
        //SCMI: IPM address 0
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x40 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase0>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x41 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase0>>16), 0x03FF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x48 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_DNRBase0>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x49 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_DNRBase0>>16), 0x03FF);
        //SCMI: IPM address 1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x50 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase1>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x51 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase1>>16), 0x03FF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x58 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_DNRBase1>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x59 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_DNRBase1>>16), 0x03FF);
        //SCMI: OPM address 0
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x60 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase0>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x61 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase0>>16), 0x03FF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x68 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_OPMBase0>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x69 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_OPMBase0>>16), 0x03FF);
        //SCMI: OPM address 1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x70 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase1>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x71 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase1>>16), 0x03FF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x78 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_OPMBase1>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x79 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_OPMBase1>>16), 0x03FF);
    }
    else
#endif
    {
        //SCMI: IPM address 0
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x40 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase0>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x41 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase0>>16), 0x03FF);
        //SCMI: IPM address 1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x50 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase1>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x51 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase1>>16), 0x03FF);
        //SCMI: OPM address 0
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x60 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase0>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x61 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase0>>16), 0x03FF);
        //SCMI: OPM address 1
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x70 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase1>>00), 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, _PK_L_(0x46, (0x71 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase1>>16), 0x03FF);
    }
}

static void _HAL_SC_BWR_set_base_address_burst(void *pInstance, MS_U16 u16MemCfgValue,MS_U16 u16MemCfgIndex, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    E_XC_BWR_MEM_CONFIG u8Memtype = E_XC_BWR_MEM_CONFIG_1;
    E_XC_BWR_MEM_CFG_BPP_TYPE eBPPType = E_XC_BWR_MEM_CFG_BPP_24;
    for(u8Memtype=E_XC_BWR_MEM_CONFIG_1; u8Memtype<E_XC_BWR_MEM_CONFIG_Max; u8Memtype++)
    {
        if(u16MemCfgValue == gSrcInfo[eWindow].Status2.stMemCfgMap[u8Memtype].u16BWR_MEM_CFG_VALUE)
        {
            eBPPType = gSrcInfo[eWindow].Status2.stMemCfgMap[u8Memtype].eBitPerPixelType;
            break;
        }
    }

#ifdef UFO_XC_SUPPORT_DUAL_MIU
    if (IsEnableDualMode(eWindow))
    {
        //SCMI: IPM address 0
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x40 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase0>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x41 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase0>>16), 0x03FF);

        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x48 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_DNRBase0>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x49 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_DNRBase0>>16), 0x03FF);

        //SCMI: IPM address 1
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x50 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase1>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x51 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase1>>16), 0x03FF);

        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x58 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_DNRBase1>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x59 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_DNRBase1>>16), 0x03FF);

        //SCMI: OPM address 0
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x60 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase0>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x61 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase0>>16), 0x03FF);

        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x68 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_OPMBase0>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x69 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_OPMBase0>>16), 0x03FF);

        //SCMI: OPM address 1
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x70 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase1>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x71 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase1>>16), 0x03FF);

        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x78 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_OPMBase1>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x79 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Right_OPMBase1>>16), 0x03FF);
    }
    else // Disbale dual
#endif
    {
        //SCMI: IPM address 0
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x40 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase0>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x41 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase0>>16), 0x03FF);

        //SCMI: IPM address 1
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x50 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase1>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x51 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_DNRBase1>>16), 0x03FF);

        //SCMI: OPM address 0
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x60 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase0>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x61 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase0>>16), 0x03FF);

        //SCMI: OPM address 1
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x70 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase1>>00), 0xFFFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, _PK_L_(0x46, (0x71 + u16MemCfgIndex * 2)), (MS_U16)(gSrcInfo[eWindow].Status2.stBWRBase[eBPPType].u32BWR_Miu_Left_OPMBase1>>16), 0x03FF);
    }
}
#endif
#ifdef SUPPORT_BWD
void _HAL_SC_BWR_set_vlen(void * pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    //update BWR Configuration vlen,IP 3D source: LA
    if(MDrv_XC_Get_3D_Input_Mode(pInstance, eWindow) == E_XC_3D_INPUT_LINE_ALTERNATIVE)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_3D_L, BIT(15) | (gSrcInfo[eWindow].u16V_SizeAfterPreScaling/2), BIT(15) | 0x1FFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_36_L, BIT(15) | (gSrcInfo[eWindow].u16V_SizeAfterPreScaling/2), BIT(15) | 0x1FFF);
    }
    else
    {
        //update BWR Configuration vlen, VSD
        if(gSrcInfo[eWindow].bPreV_ScalingDown)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_3D_L, BIT(15) | gSrcInfo[eWindow].u16V_SizeAfterPreScaling, BIT(15) | 0x1FFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_36_L, gSrcInfo[eWindow].u16V_SizeAfterPreScaling, BIT(15) | 0x1FFF);
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_3D_L, 0, BIT(15));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_36_L, 0, BIT(15));
        }
    }

    //update BWR Configuration vlen,OP 3D output: LA
    if(MDrv_XC_Get_3D_Output_Mode(pInstance) == E_XC_3D_OUTPUT_LINE_ALTERNATIVE)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_3E_L, BIT(15) | (gSrcInfo[eWindow].u16V_Length*2), BIT(15) | 0x1FFF);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_3E_L, 0, BIT(15));
    }

}

static void _HAL_SC_BWR_set_3d_mode(void * pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    //BWR 422 to 420 set drop mode register
    if((MDrv_XC_Get_3D_Input_Mode(pInstance, eWindow) == E_XC_3D_INPUT_LINE_ALTERNATIVE) && (gSrcInfo[eWindow].stCapWin.width > 1920))
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_38_L, BIT(7), BIT(7));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_3A_L, 0, BIT(2));
    }

    //BWR 422 to 420 set TB mode register
    if(MDrv_XC_Get_3D_Output_Mode(pInstance) == E_XC_3D_OUTPUT_TOP_BOTTOM)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_3A_L, BIT(4), BIT(4));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_10_L, 0, BIT(11));
    }

    //OP1 must turn off initial process
    if(MDrv_XC_Get_3D_Output_Mode(pInstance) == E_XC_3D_OUTPUT_LINE_ALTERNATIVE)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_11_L,BIT(12) ,BIT(12));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_11_L,0 ,BIT(12));
    }
}

static void _HAL_SC_BWR_set_vlen_burst(void * pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    //update BWR Configuration vlen,IP 3D source: LA
    if(MDrv_XC_Get_3D_Input_Mode(pInstance, eWindow) == E_XC_3D_INPUT_LINE_ALTERNATIVE)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_3D_L, BIT(15) | (gSrcInfo[eWindow].u16V_SizeAfterPreScaling/2), BIT(15) | 0x1FFF);
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_36_L, BIT(15) | (gSrcInfo[eWindow].u16V_SizeAfterPreScaling/2), BIT(15) | 0x1FFF);
    }
    else
    {
        //update BWR Configuration vlen, VSD
        if(gSrcInfo[eWindow].bPreV_ScalingDown)
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_3D_L, BIT(15) | gSrcInfo[eWindow].u16V_SizeAfterPreScaling, BIT(15) | 0x1FFF);
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_36_L, BIT(15) | gSrcInfo[eWindow].u16V_SizeAfterPreScaling, BIT(15) | 0x1FFF);
        }
        else
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_3D_L, 0, BIT(15));
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_36_L, 0, BIT(15));
        }
    }
    //update BWR Configuration vlen,OP 3D output: LA
    if(MDrv_XC_Get_3D_Output_Mode(pInstance) == E_XC_3D_OUTPUT_LINE_ALTERNATIVE)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_3E_L, BIT(15) | (gSrcInfo[eWindow].u16V_Length*2), BIT(15) | 0x1FFF);
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_3E_L, 0, BIT(15));
    }
}

static void _HAL_SC_BWR_set_3d_mode_burst(void * pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    //BWR 422 to 420 set drop mode register
    if((MDrv_XC_Get_3D_Input_Mode(pInstance, eWindow) == E_XC_3D_INPUT_LINE_ALTERNATIVE) && (gSrcInfo[eWindow].stCapWin.width > 1920))
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_38_L, BIT(7), BIT(7));
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_3A_L, 0, BIT(2));
    }

    //BWR 422 to 420 set TB mode register
    if(MDrv_XC_Get_3D_Output_Mode(pInstance) == E_XC_3D_OUTPUT_TOP_BOTTOM)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_3A_L, BIT(4),BIT(4));
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_10_L, 0, BIT(11));
    }

    //OP1 must turn off initial process
    if(MDrv_XC_Get_3D_Output_Mode(pInstance) == E_XC_3D_OUTPUT_LINE_ALTERNATIVE)
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_11_L, BIT(12), BIT(12));
    }
    else
    {
        MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK20_11_L, 0, BIT(12));
    }
}
#endif

MS_BOOL HAL_SC_set_bwr_config_burst(void *pInstance, void *pstParam, SCALER_WIN eWindow)
{
#ifdef SUPPORT_BWD
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

#ifndef XC_SUPPORT_BWR_USER_MODE
    MS_U16 u16BwrMemCfgTmp = 0;
    u16BwrMemCfgTmp = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_17_L, 0xFFFF);
    _HAL_SC_BWR_set_base_address_burst(pInstance, (u16BwrMemCfgTmp&0x000F) >> 0,  E_XC_BWR_MME_CFG_INDEX_0, eWindow);
    _HAL_SC_BWR_set_base_address_burst(pInstance, (u16BwrMemCfgTmp&0x00F0) >> 4,  E_XC_BWR_MME_CFG_INDEX_1, eWindow);
    _HAL_SC_BWR_set_base_address_burst(pInstance, (u16BwrMemCfgTmp&0x0F00) >> 8,  E_XC_BWR_MME_CFG_INDEX_2, eWindow);
    _HAL_SC_BWR_set_base_address_burst(pInstance, (u16BwrMemCfgTmp&0xF000) >> 12, E_XC_BWR_MME_CFG_INDEX_3, eWindow);
    u16BwrMemCfgTmp = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_16_L, 0xF);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_28_L, u16BwrMemCfgTmp, 0x0F);
    MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_29_L, u16BwrMemCfgTmp, 0x0F);
#endif

#ifdef XC_SUPPORT_BWR_USER_MODE
    if((SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_32_L, 0x01) == 0x1)
        &&(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_34_L, 0x01) == 0x1)
        &&(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_3A_L, 0x08) == 0x0))
    {
#endif
        if((MDrv_XC_GetDynamicScalingStatus(pInstance) || MDrv_XC_Is_DSForceIndexEnabled(pInstance, eWindow))
            && IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType))
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK46_01_L, 0x0, 0x000C);
        }

        _HAL_SC_BWR_set_vlen_burst(pInstance, eWindow);
        _HAL_SC_BWR_set_3d_mode_burst(pInstance, eWindow);

        MDrv_XC_MLoad_Fire(pInstance, TRUE);
#ifdef XC_SUPPORT_BWR_USER_MODE
    }
#endif
    return TRUE;
#else
    return FALSE;
#endif
}

MS_BOOL HAL_SC_set_bwr_config(void *pInstance, void *pstParam, SCALER_WIN eWindow)
{
#ifdef SUPPORT_BWD
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

#ifndef XC_SUPPORT_BWR_USER_MODE
    MS_U16 u16BwrMemCfgTmp = 0;
    u16BwrMemCfgTmp = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_17_L, 0xFFFF);
    _HAL_SC_BWR_set_base_address(pInstance, (u16BwrMemCfgTmp&0x000F) >> 0,  E_XC_BWR_MME_CFG_INDEX_0, eWindow);
    _HAL_SC_BWR_set_base_address(pInstance, (u16BwrMemCfgTmp&0x00F0) >> 4,  E_XC_BWR_MME_CFG_INDEX_1, eWindow);
    _HAL_SC_BWR_set_base_address(pInstance, (u16BwrMemCfgTmp&0x0F00) >> 8,  E_XC_BWR_MME_CFG_INDEX_2, eWindow);
    _HAL_SC_BWR_set_base_address(pInstance, (u16BwrMemCfgTmp&0xF000) >> 12, E_XC_BWR_MME_CFG_INDEX_3, eWindow);
    u16BwrMemCfgTmp = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_16_L, 0xF);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_28_L, u16BwrMemCfgTmp, 0x0F);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_29_L, u16BwrMemCfgTmp, 0x0F);
#endif

#ifdef XC_SUPPORT_BWR_USER_MODE
    if((SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_32_L, 0x01) == 0x1)
        &&(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_34_L, 0x01) == 0x1)
        &&(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_3A_L, 0x08) == 0x0))
    {
#endif
        if(MDrv_XC_GetDynamicScalingStatus(pInstance) || MDrv_XC_Is_DSForceIndexEnabled(pInstance, eWindow))
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK46_01_L, 0x0, 0x000C);
        }

        _HAL_SC_BWR_set_vlen(pInstance, eWindow);
        _HAL_SC_BWR_set_3d_mode(pInstance, eWindow);
#ifdef XC_SUPPORT_BWR_USER_MODE
    }
#endif
    return TRUE;
#else
    return FALSE;
#endif
}

MS_BOOL Hal_SC_AdjustIpmWriteLimite(void *pInstance, MS_BOOL bIsLeft, MS_BOOL bNeedSwap, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return FALSE;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_PHY u32WLimitBase = 0x00;
    if ((psXCInstPri->u32DeviceID > 0) || (eWindow != MAIN_WINDOW))
    {
        return FALSE;
    }

    if (bIsLeft == TRUE)
    {
        if (bNeedSwap == TRUE)
        {
            u32WLimitBase = ((pXCResourcePrivate->stdrvXC_Scaling._u32DNRBaseAddr0[eWindow] + pXCResourcePrivate->stdrvXC_Scaling._u32DNRBufSize[eWindow]) / BYTE_PER_WORD - 1)  | F2_WRITE_LIMIT_EN;;
            MDrv_SC_set_dual_write_limit(pInstance, u32WLimitBase , eWindow);
        }
        else
        {
            u32WLimitBase = ((pXCResourcePrivate->stdrvXC_Scaling._u32DNRBaseAddr0[eWindow] + pXCResourcePrivate->stdrvXC_Scaling._u32DNRBufSize[eWindow]) / BYTE_PER_WORD - 1)  | F2_WRITE_LIMIT_EN;
            MDrv_SC_set_write_limit(pInstance, u32WLimitBase , eWindow);
        }
    }
    else
    {
        if (bNeedSwap == TRUE)
        {
            u32WLimitBase = ((pXCResourcePrivate->stdrvXC_Scaling._u32DualMiuDNRBaseAddr0[eWindow] + pXCResourcePrivate->stdrvXC_Scaling._u32DualMiuDNRBufSize[eWindow]) / BYTE_PER_WORD - 1) ;
            MDrv_SC_set_write_limit(pInstance, u32WLimitBase , eWindow);
        }
        else
        {
            u32WLimitBase = ((pXCResourcePrivate->stdrvXC_Scaling._u32DualMiuDNRBaseAddr0[eWindow] + pXCResourcePrivate->stdrvXC_Scaling._u32DualMiuDNRBufSize[eWindow]) / BYTE_PER_WORD - 1) ;
            MDrv_SC_set_dual_write_limit(pInstance, u32WLimitBase , eWindow);
        }
    }
    return TRUE;
}

void Hal_SC_3D_enable_black_edge(void *UNUSED_PARA(pInstance), MS_BOOL UNUSED_PARA(b2DTo3D))
{
    return;
}

#ifdef ENABLE_SPREADMODE
MS_BOOL MHal_XC_IsSupportSpreadMode(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_BOOL bIsSupportSpreadMode = FALSE;
    #if (HW_DESIGN_HDMITX_VER == 2)//Maxim inside HDMITX case
    if(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_B & E_XC_INIT_MISC_B_HDMITX_ENABLE)
    {
        bIsSupportSpreadMode = TRUE;
    }
    #endif
    return bIsSupportSpreadMode;
}
#endif

void Hal_SC_3D_Adjust_PreHVscaling_SaveBW(void *pInstance, XC_InternalStatus *pSrcInfo, MS_BOOL *pb3DPreHScaling,MS_BOOL *pb3DPreVScaling,MS_BOOL bForcePreHScalingDown,MS_BOOL bForcePreVScalingDown,SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(pXCResourcePrivate->stdrvXC_3D._eInput3DMode[eWindow] == E_XC_3D_INPUT_FRAME_PACKING)
    {
        if(pXCResourcePrivate->stdrvXC_3D._eOutput3DMode != E_XC_3D_OUTPUT_FRAME_ALTERNATIVE)
        {
            *pb3DPreHScaling = TRUE;
            pSrcInfo->Status2.u16PreHCusScalingSrc = pSrcInfo->stCapWin.width;
            if((pSrcInfo->stDispWin.width >= 1920)
                && (pSrcInfo->stDispWin.height >= 1080))
            {
                pSrcInfo->Status2.u16PreHCusScalingDst = MAX(640, (MS_U32)MIN(1920, pSrcInfo->stDispWin.width) * 2 / 3);
            }
            else
            {
                pSrcInfo->Status2.u16PreHCusScalingDst = MAX(640, (MS_U32)MIN(1920, pSrcInfo->stDispWin.width) / 2);
            }
        }
        else// FA out
        {
            if((pXCResourcePrivate->stdrvXC_3D._bFALLRRToFA) && (pSrcInfo->stCapWin.width == DOUBLEHD_1080X2P_HSIZE))//output FA_LLRR for 4k0.5k@240Hz
            {
                *pb3DPreHScaling = TRUE;
                pSrcInfo->Status2.u16PreHCusScalingSrc = pSrcInfo->stCapWin.width;
                pSrcInfo->Status2.u16PreHCusScalingDst = MAX(640, (MS_U32)MIN(1920, pSrcInfo->stDispWin.width) / 2);
            }
        }
    }
    else if((pXCResourcePrivate->stdrvXC_3D._eInput3DMode[eWindow] == E_XC_3D_INPUT_FRAME_ALTERNATIVE) && (pXCResourcePrivate->stdrvXC_3D._eOutput3DMode != E_XC_3D_OUTPUT_FRAME_ALTERNATIVE) &&(pSrcInfo->stCapWin.width >= 1280)
            && (MDrv_ReadRegBit(REG_CKG_FCLK, CKG_FCLK_MASK) < 24))//fclk < 320MHz may have fclk issue for fi
    {
        *pb3DPreHScaling = TRUE;
        pSrcInfo->Status2.u16PreHCusScalingSrc = pSrcInfo->stCapWin.width;
        if(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width >= 2 * pSrcInfo->stDispWin.width)
        {
            pSrcInfo->Status2.u16PreHCusScalingDst = MIN(960, pSrcInfo->stDispWin.width);
        }
        else
        {
            pSrcInfo->Status2.u16PreHCusScalingDst = MIN(1280, pSrcInfo->stDispWin.width);
        }
    }
    else
    {
        if(bForcePreHScalingDown)
        {
                *pb3DPreHScaling = FALSE;
                pSrcInfo->Status2.u16PreHCusScalingSrc = pSrcInfo->stCapWin.width;
                pSrcInfo->Status2.u16PreHCusScalingDst = pSrcInfo->u16H_SizeAfterPreScaling;
        }

        if(bForcePreVScalingDown)
        {
            pb3DPreVScaling = FALSE;
            pSrcInfo->Status2.u16PreVCusScalingSrc = pSrcInfo->stCapWin.height;
            pSrcInfo->Status2.u16PreVCusScalingDst = pSrcInfo->u16V_SizeAfterPreScaling;
        }
    }
}

#ifdef UFO_XC_AUTO_DOWNLOAD
static E_APIXC_ReturnValue _Hal_XC_Set_Auto_Download_WorkMode(MS_U32 u32DeviceID, MS_U32 u32RegAddr, MS_U16 u16val, EN_XC_AUTODOWNLOAD_MODE enMode)
{
    switch (enMode)
    {
        case E_XC_AUTODOWNLOAD_TRIGGER_MODE:
        {
            SC_W2BYTEMSK(u32DeviceID, u32RegAddr, 0, u16val);
            break;
        }
        case E_XC_AUTODOWNLOAD_ENABLE_MODE:
        {
            SC_W2BYTEMSK(u32DeviceID, u32RegAddr, u16val, u16val);
            break;
        }
        default:
            return E_APIXC_RET_FAIL_INVALID_PARAMETER;
    }

    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue MHal_XC_AutoDownload_Config(void* pInstance, EN_XC_AUTODOWNLOAD_CLIENT enClient, MS_PHY phyBaseAddr, EN_XC_AUTODOWNLOAD_MODE enMode, MS_U32 u32Size, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    switch(enClient)
    {
        case E_XC_AUTODOWNLOAD_CLIENT_HDR:
        {
            MS_U32 u32RemainMemSize = u32Size;
            MS_PHY phyBaseAddrOffset = 0;

            // -------HDR client config start------------
            if (bEnable == TRUE && (u32RemainMemSize < AUTODOWNLOAD_CLIENT_HDR_MEM_SIZE))
            {
                printf("ERROR!!! Alloc HDR client memory(0x%x) fail, please enlarge it(now: %tu).\n", AUTODOWNLOAD_CLIENT_HDR_MEM_SIZE, (ptrdiff_t)u32Size);
                return E_APIXC_RET_FAIL;
            }
            u32RemainMemSize = u32RemainMemSize - AUTODOWNLOAD_CLIENT_HDR_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].phyBaseAddr = phyBaseAddr + phyBaseAddrOffset;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32Size = AUTODOWNLOAD_CLIENT_HDR_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].bEnable = bEnable;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32StartAddr = 0xFFFFFFFF;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32Depth = 0;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].enMode = enMode;
            phyBaseAddrOffset += AUTODOWNLOAD_CLIENT_HDR_MEM_SIZE;

            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_29_L, (pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].phyBaseAddr / BYTE_PER_WORD) & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_2A_L, ((pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].phyBaseAddr / BYTE_PER_WORD) >> 16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_28_L, BIT(1), enMode);
            // -------HDR client config end------------
            // -------op2lut client config start------------
            if (bEnable == TRUE && (u32RemainMemSize < AUTODOWNLOAD_CLIENT_OP2LUT_MEM_SIZE))
            {
                printf("ERROR!!! Alloc OP2LUT client memory(0x%x) fail, please enlarge it(now: %tu).\n", AUTODOWNLOAD_CLIENT_OP2LUT_MEM_SIZE, (ptrdiff_t)u32Size);
                return E_APIXC_RET_FAIL;
            }
            u32RemainMemSize = u32RemainMemSize - AUTODOWNLOAD_CLIENT_OP2LUT_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].phyBaseAddr = phyBaseAddr + phyBaseAddrOffset;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].u32Size = AUTODOWNLOAD_CLIENT_OP2LUT_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].bEnable = bEnable;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].u32StartAddr = 0xFFFFFFFF;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].u32Depth = 0;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].enMode = enMode;
            phyBaseAddrOffset += AUTODOWNLOAD_CLIENT_OP2LUT_MEM_SIZE;

            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_23_L, (pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].phyBaseAddr / BYTE_PER_WORD) & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_24_L, ((pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].phyBaseAddr / BYTE_PER_WORD) >> 16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_22_L, BIT(1), enMode);
            // -------op2lut client config end------------

            // -------hvsp client config start------------
            if (bEnable == TRUE && (u32RemainMemSize < AUTODOWNLOAD_CLIENT_HVSP_MEM_SIZE))
            {
                printf("ERROR!!! Alloc HVSP client memory(0x%x) fail, please enlarge it(now: %tu).\n", AUTODOWNLOAD_CLIENT_HVSP_MEM_SIZE, (ptrdiff_t)u32Size);
                return E_APIXC_RET_FAIL;
            }
            u32RemainMemSize = u32RemainMemSize - AUTODOWNLOAD_CLIENT_HVSP_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HVSP].phyBaseAddr = phyBaseAddr + phyBaseAddrOffset;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HVSP].u32Size = AUTODOWNLOAD_CLIENT_HVSP_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HVSP].bEnable = bEnable;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HVSP].u32StartAddr = 0xFFFFFFFF;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HVSP].u32Depth = 0;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HVSP].enMode = enMode;
            phyBaseAddrOffset += AUTODOWNLOAD_CLIENT_HVSP_MEM_SIZE;

            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_67_L, (pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HVSP].phyBaseAddr / BYTE_PER_WORD) & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_68_L, ((pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HVSP].phyBaseAddr / BYTE_PER_WORD) >> 16 & 0x0000FFFF), 0x1FFF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_66_L ,BIT(1), enMode);
            // -------hvsp client config end--------------
            // -------hsy client config start------------
            if (bEnable == TRUE && (u32RemainMemSize < AUTODOWNLOAD_CLIENT_HSY_MEM_SIZE))
            {
                printf("ERROR!!! Alloc HSY client memory(0x%x) fail, please enlarge it(now:%tu).\n", AUTODOWNLOAD_CLIENT_HSY_MEM_SIZE, (ptrdiff_t)u32Size);
                return E_APIXC_RET_FAIL;
            }
            u32RemainMemSize = u32RemainMemSize - AUTODOWNLOAD_CLIENT_HSY_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HSY].phyBaseAddr = phyBaseAddr + phyBaseAddrOffset;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HSY].u32Size = AUTODOWNLOAD_CLIENT_HSY_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HSY].bEnable = bEnable;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HSY].u32StartAddr = 0xFFFFFFFF;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HSY].u32Depth = 0;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HSY].enMode = enMode;
            phyBaseAddrOffset += AUTODOWNLOAD_CLIENT_HSY_MEM_SIZE;

            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_56_L, (pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HSY].phyBaseAddr / BYTE_PER_WORD) & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_57_L, ((pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HSY].phyBaseAddr / BYTE_PER_WORD) >> 16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_55_L, BIT(1), enMode);
            // -------hsy client config end--------------
            // -------pq gamma client config start------------
            if(bEnable == TRUE && (u32RemainMemSize < AUTODOWNLOAD_CLIENT_PQ_GAMMA_MEM_SIZE))
            {
                printf("ERROR!!! Alloc pq gamma client memory(0x%x) fail, please enlarge it(now: %tu).\n", AUTODOWNLOAD_CLIENT_PQ_GAMMA_MEM_SIZE, (ptrdiff_t)u32Size);
                return E_APIXC_RET_FAIL;
            }
            u32RemainMemSize = u32RemainMemSize - AUTODOWNLOAD_CLIENT_PQ_GAMMA_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PQ_GAMMA].phyBaseAddr = phyBaseAddr + phyBaseAddrOffset;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PQ_GAMMA].u32Size = AUTODOWNLOAD_CLIENT_PQ_GAMMA_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PQ_GAMMA].bEnable = bEnable;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PQ_GAMMA].u32StartAddr = 0xFFFFFFFF;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PQ_GAMMA].u32Depth = 0;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PQ_GAMMA].enMode = enMode;
            phyBaseAddrOffset += AUTODOWNLOAD_CLIENT_PQ_GAMMA_MEM_SIZE;

            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_02_L, (pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PQ_GAMMA].phyBaseAddr / BYTE_PER_WORD) & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_03_L, ((pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PQ_GAMMA].phyBaseAddr / BYTE_PER_WORD) >> 16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, BIT(3), enMode);
            // -------pq gamma  client config end------------
            // -------DLC client config start------------
            if (bEnable == TRUE && (u32RemainMemSize < AUTODOWNLOAD_CLIENT_DLC_256_MEM_SIZE))
            {
                printf("ERROR!!! Alloc DLC client memory(0x%x) fail, please enlarge it(now: %tu).\n", AUTODOWNLOAD_CLIENT_DLC_256_MEM_SIZE, (ptrdiff_t)u32Size);
                return E_APIXC_RET_FAIL;
            }
            u32RemainMemSize = u32RemainMemSize - AUTODOWNLOAD_CLIENT_DLC_256_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_DLC_256].phyBaseAddr = phyBaseAddr + phyBaseAddrOffset;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_DLC_256].u32Size = AUTODOWNLOAD_CLIENT_DLC_256_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_DLC_256].bEnable = bEnable;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_DLC_256].u32StartAddr = 0xFFFFFFFF;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_DLC_256].u32Depth = 0;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_DLC_256].enMode = enMode;
            phyBaseAddrOffset += AUTODOWNLOAD_CLIENT_DLC_256_MEM_SIZE;

            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_47_L, (pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_DLC_256].phyBaseAddr / BYTE_PER_WORD) & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_48_L, ((pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_DLC_256].phyBaseAddr / BYTE_PER_WORD) >> 16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_46_L, BIT(1), enMode);
            // -------DLC client config end--------------
            // -------pannel gamma client config start------------
            if (bEnable == TRUE && (u32RemainMemSize < AUTODOWNLOAD_CLIENT_PANEL_GAMMA_MEM_SIZE))
            {
                printf("ERROR!!! Alloc Panel gamma client memory(0x%x) fail, please enlarge it(now: %tu).\n", AUTODOWNLOAD_CLIENT_PANEL_GAMMA_MEM_SIZE, (ptrdiff_t)u32Size);
                return E_APIXC_RET_FAIL;
            }
            u32RemainMemSize = u32RemainMemSize - AUTODOWNLOAD_CLIENT_PANEL_GAMMA_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].phyBaseAddr = phyBaseAddr + phyBaseAddrOffset;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].u32Size = AUTODOWNLOAD_CLIENT_PANEL_GAMMA_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].bEnable = bEnable;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].u32StartAddr = 0xFFFFFFFF;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].u32Depth = 0;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].enMode = enMode;
            phyBaseAddrOffset += AUTODOWNLOAD_CLIENT_PANEL_GAMMA_MEM_SIZE;

            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_12_L, (pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].phyBaseAddr / BYTE_PER_WORD) & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_13_L, ((pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].phyBaseAddr / BYTE_PER_WORD) >> 16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, BIT(6), enMode);
            // -------panel client config end--------------
            // -------ICC/IHC client config start------------
            if (bEnable == TRUE && (u32RemainMemSize < AUTODOWNLOAD_CLIENT_ICC_IHC_MEM_SIZE))
            {
                printf("ERROR!!! Alloc Panel gamma client memory(0x%x) fail, please enlarge it(now: %tu).\n", AUTODOWNLOAD_CLIENT_ICC_IHC_MEM_SIZE, (ptrdiff_t)u32Size);
                return E_APIXC_RET_FAIL;
            }
            u32RemainMemSize = u32RemainMemSize - AUTODOWNLOAD_CLIENT_ICC_IHC_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_ICC_IHC].phyBaseAddr = phyBaseAddr + phyBaseAddrOffset;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_ICC_IHC].u32Size = AUTODOWNLOAD_CLIENT_ICC_IHC_MEM_SIZE;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_ICC_IHC].bEnable = bEnable;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_ICC_IHC].u32StartAddr = 0xFFFFFFFF;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_ICC_IHC].u32Depth = 0;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_ICC_IHC].enMode = enMode;
            phyBaseAddrOffset += AUTODOWNLOAD_CLIENT_ICC_IHC_MEM_SIZE;

            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_5C_L, (pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_ICC_IHC].phyBaseAddr / BYTE_PER_WORD) & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_5D_L, ((pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_ICC_IHC].phyBaseAddr / BYTE_PER_WORD) >> 16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_5B_L, BIT(1), enMode);
            // -------ICC/IHC client config end--------------
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_OP2GAMMA:
        {
            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_02_L, phyBaseAddr & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_03_L, (phyBaseAddr >>16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, BIT(3), enMode);
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_FRCOP2GAMMA:
        {
            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_12_L, phyBaseAddr & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_13_L, (phyBaseAddr >>16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, BIT(6), enMode);
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_XVYCC:
        {
            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_16_L, phyBaseAddr & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_17_L, (phyBaseAddr >>16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, BIT(15), enMode);
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE1:
        {
            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_04_L, phyBaseAddr & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_05_L, (phyBaseAddr >>16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, BIT(4), enMode);
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE2:
        {
            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_04_L, phyBaseAddr & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_05_L, (phyBaseAddr >>16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, BIT(4), enMode);
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE3:
        {
            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_04_L, phyBaseAddr & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_05_L, (phyBaseAddr >>16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, BIT(4), enMode);
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_DEMURA:
        {
            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_06_L, phyBaseAddr & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_07_L, (phyBaseAddr >>16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, BIT(5), enMode);
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_T3D_0:
        {
            //set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_33_L, phyBaseAddr & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_34_L, (phyBaseAddr >>16 & 0x0000FFFF), 0x07FF);

            //set work mode
            _Hal_XC_Set_Auto_Download_WorkMode(psXCInstPri->u32DeviceID, REG_SC_BK67_32_L, BIT(1), enMode);
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_T3D_1:
        {
            return E_APIXC_RET_FAIL;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_FRCSPTPOPM:
        {
            return E_APIXC_RET_FAIL;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_FOOPM:
        {
            return E_APIXC_RET_FAIL;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_MAX:
        default:
        {
            return E_APIXC_RET_FAIL;
        }

    }

    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue MHal_XC_AutoDownload_Fire(void* pInstance, EN_XC_AUTODOWNLOAD_CLIENT enClient)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    switch(enClient)
    {
        case E_XC_AUTODOWNLOAD_CLIENT_HDR:
        {
            MS_PHY phyBaseAddr = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].phyBaseAddr;
            MS_U32 u32Depth = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32Depth;
            MS_VIRT* pVirtBaseAddr = (MS_VIRT *)MS_PA2KSEG1(phyBaseAddr);
            MS_U8 *pu8BaseAddr = (MS_U8 *)pVirtBaseAddr;
            MS_U32 u32StartAddr = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32StartAddr;
            pu8BaseAddr += 16 * u32StartAddr;

            // set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_29_L, (MS_PHY)MS_VA2PA((MS_VIRT)pu8BaseAddr) & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_2A_L, (MS_PHY)(MS_VA2PA((MS_VIRT)pu8BaseAddr) >> 16 & 0x0000FFFF), 0x07FF);

            // set depth
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_2B_L, u32Depth);
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_2C_L, u32Depth);

            // enable auto download
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_28_L, 1, BIT(0));

            EN_XC_AUTODOWNLOAD_MODE enMode = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].enMode;
            if (enMode == E_XC_AUTODOWNLOAD_TRIGGER_MODE)
            {
                //check auto download done
                MS_U32 u32Delayms = 0;
                while(((SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_28_L) & 0x0001) != 0) && u32Delayms < 500)
                {
                    MsOS_DelayTask(1);
                    u32Delayms++;
                }

                // clear buffer
                MS_U32 i = 0;
                for (i = 0; i < u32Depth; i++)
                {
                    CLEAR_HDR_DATA_FORMAT_1(pu8BaseAddr + i * 16);
                }
                if (u32Delayms >= 500)
                {
                    printf("Check auto download done timeout.\n");
                }
            }

            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32StartAddr = 0xFFFFFFFF;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32Depth = 0;
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_OP2LUT:
        {
            MS_PHY phyBaseAddr = 0;
            MS_U32 u32Depth = 0;

            phyBaseAddr = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].phyBaseAddr;
            u32Depth = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].u32Depth;

            // set baseaddr
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_23_L, (phyBaseAddr / BYTE_PER_WORD) & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_24_L, ((phyBaseAddr / BYTE_PER_WORD) >> 16 & 0x0000FFFF), 0x07FF);

            //reg_client6_depth
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_25_L, u32Depth);

            //reg_client6_req_len
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_26_L, AUTODOWNLOAD_REQ_LEN);

            // enable auto download
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_22_L, BIT(0), BIT(0));

            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].u32StartAddr = 0xFFFFFFFF;
            pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].u32Depth = 0;
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_OP2GAMMA:
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, 1, BIT(0));
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_FRCOP2GAMMA:
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_11_L, 1, BIT(0));
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_XVYCC:
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_11_L, 1 << 2, BIT(2));
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE1:
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, 1 << 1, BIT(1));
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE2:
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_21_L, 1, BIT(0));
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE3:
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_21_L, 1 << 1, BIT(1));
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_DEMURA:
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_01_L, 1 << 2, BIT(2));
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_T3D_0:
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_32_L, 1, BIT(0));
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_T3D_1:
        {
            return E_APIXC_RET_FAIL;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_FRCSPTPOPM:
        {
            return E_APIXC_RET_FAIL;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_FOOPM:
        {
            return E_APIXC_RET_FAIL;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA:
        {
            MS_PHY phyBaseAddr = 0;
            MS_U32 u32Depth = 0;

            phyBaseAddr = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].phyBaseAddr;
            u32Depth = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].u32Depth;

            // set baseaddr

            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_12_L,  (phyBaseAddr / BYTE_PER_WORD) & 0x0000FFFF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK67_13_L, ((phyBaseAddr / BYTE_PER_WORD) >> 16 & 0x0000FFFF), 0x07FF);

            //reg_client4_depth
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_18_L,u32Depth);

            //reg_client4_req_len
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK67_1B_L, AUTODOWNLOAD_REQ_LEN);

            // enable auto download
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK67_11_L, BIT(0), BIT(0));

            //break;
            return E_APIXC_RET_OK;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_MAX:
        default:
        {
            return E_APIXC_RET_FAIL;
        }

    }

    return E_APIXC_RET_OK;
}

static E_APIXC_ReturnValue _Hal_XC_Auto_Download_Format_Hdr_Data(void* pInstance,
        EN_XC_AUTODOWNLOAD_SUB_CLIENT enSubClient, MS_U8* pu8Data, MS_U32 u32Size, MS_PHY u16StartAddr)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_PHY phyBaseAddr = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].phyBaseAddr;
    MS_U32 u32Depth = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32Depth;
    MS_VIRT* pVirtBaseAddr = (MS_VIRT *)MS_PA2KSEG1(phyBaseAddr);
    unsigned int i = 0;
    MS_PHY u32Index = u16StartAddr;
    MS_U32 u32WriteNum = 0;
    MS_U8 *pu8BaseAddr = (MS_U8 *)pVirtBaseAddr;
    pu8BaseAddr += 16 * u16StartAddr;

    // update start addr of DRAM
    MS_PHY u32StartAddr = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32StartAddr;
    if (u32StartAddr == 0xFFFFFFFF)
    {
        pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32StartAddr = u16StartAddr;
    }
    else
    {
        pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32StartAddr = u32StartAddr > u16StartAddr ? u16StartAddr : u32StartAddr;
    }

    //format&write datas into DRAM
    for (i = 0; i < u32Size; )
    {
        switch (enSubClient)
        {
            case E_XC_AUTODOWNLOAD_HDR_SUB_TMO:
            {
                MS_U16 u16Value = *(((MS_U16 *)pu8Data) + i);
                if (u16Value & 0xF000)
                {
                    printf("The %dth data is 0x%x, exceed max value, please check!!!\n", i + 1, u16Value);
                    return E_APIXC_RET_FAIL_INVALID_PARAMETER;
                }
                WRITE_TMO_DATA_FORMAT_1(pu8BaseAddr, u32Index, u16Value);
                i++;
                break;
            }
            case E_XC_AUTODOWNLOAD_HDR_SUB_GAMMA:
            {
                MS_U16 u16Value = *(((MS_U16 *)pu8Data) + i);
                WRITE_GAMMA_DATA_FORMAT_1(pu8BaseAddr, u32Index, u16Value);
                i++;
                break;
            }
            case E_XC_AUTODOWNLOAD_HDR_SUB_DEGAMMA:
            {
                MS_U32 u32Value = *(((MS_U32 *)pu8Data) + i);
                if (u32Value & 0xFFF80000)
                {
                    printf("The %dth data is 0x%x, exceed max value, please check!!!\n", i + 1, (unsigned int)u32Value);
                    return E_APIXC_RET_FAIL_INVALID_PARAMETER;
                }
                WRITE_DEGAMMA_DATA_FORMAT_1(pu8BaseAddr, u32Index, u32Value);
                i++;
                break;
            }
            case E_XC_AUTODOWNLOAD_HDR_SUB_3DLUT:
            {
                MS_U16 u16RVal = *(((MS_U16 *)pu8Data) + i);
                MS_U16 u16GVal = *(((MS_U16 *)pu8Data) + i + 1);
                MS_U16 u16BVal = *(((MS_U16 *)pu8Data) + i + 2);
                MS_U16 u16Subindex = 0;
                if(i < _au32_3dlut_entry_num[0])
                {
                    u16Subindex = 0;
                }
                else if(i < (_au32_3dlut_entry_num[0] + _au32_3dlut_entry_num[1]))
                {
                    u16Subindex = 1;
                }
                else if(i < (_au32_3dlut_entry_num[0] + _au32_3dlut_entry_num[1] + _au32_3dlut_entry_num[2]))
                {
                    u16Subindex = 2;
                }
                else if(i < (_au32_3dlut_entry_num[0] + _au32_3dlut_entry_num[1] + _au32_3dlut_entry_num[2] + _au32_3dlut_entry_num[3]))
                {
                    u16Subindex = 3;
                }
                else if(i < (_au32_3dlut_entry_num[0] + _au32_3dlut_entry_num[1] + _au32_3dlut_entry_num[2] + _au32_3dlut_entry_num[3] + _au32_3dlut_entry_num[4]))
                {
                    u16Subindex = 4;
                }
                else if(i < (_au32_3dlut_entry_num[0] + _au32_3dlut_entry_num[1] + _au32_3dlut_entry_num[2] + _au32_3dlut_entry_num[3] + _au32_3dlut_entry_num[4] + _au32_3dlut_entry_num[5]))
                {
                    u16Subindex = 5;
                }
                else if(i < (_au32_3dlut_entry_num[0] + _au32_3dlut_entry_num[1] + _au32_3dlut_entry_num[2] + _au32_3dlut_entry_num[3] + _au32_3dlut_entry_num[4] + _au32_3dlut_entry_num[5] + _au32_3dlut_entry_num[6]))
                {
                    u16Subindex = 6;
                }
                else if(i < (_au32_3dlut_entry_num[0] + _au32_3dlut_entry_num[1] + _au32_3dlut_entry_num[2] + _au32_3dlut_entry_num[3] + _au32_3dlut_entry_num[4] + _au32_3dlut_entry_num[5] + _au32_3dlut_entry_num[6] + _au32_3dlut_entry_num[7]))
                {
                    u16Subindex = 7;
                }
                WRITE_3DLUT_DATA_FORMAT_1(pu8BaseAddr, u32Index, u16Subindex, u16RVal, u16GVal, u16BVal);
                i += 3;
                break;
            }
            default:
            {
                break;
            }
        }
        pu8BaseAddr += 16;
        u32WriteNum++;
        u32Index++;
    }

    u32Depth = u32Depth > u32WriteNum ? u32Depth : u32WriteNum;
    pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_HDR].u32Depth = u32Depth;

#if DEBUG_HDR
    int j = 0;
    int l = 0;

    printf("\n#####################Dump Input Data####################\n");
    for (j = 0; j < u32Size;)
    {
        printf("The %04dth row: ", u16StartAddr++);
        switch (enSubClient)
        {
            case E_XC_AUTODOWNLOAD_HDR_SUB_TMO:
            {
                MS_U16 u16Value = *(((MS_U16 *)pu8Data) + j);
                printf("%02X \n", u16Value);
                j++;
                break;
            }
            case E_XC_AUTODOWNLOAD_HDR_SUB_GAMMA:
            {
                MS_U16 u16Value = *(((MS_U16 *)pu8Data) + j);
                printf("%02X \n", u16Value);
                j++;
                break;
            }
            case E_XC_AUTODOWNLOAD_HDR_SUB_DEGAMMA:
            {
                MS_U32 u32Value = *(((MS_U32 *)pu8Data) + j);
                printf("%04X \n", u32Value);
                j++;
                break;
            }
            case E_XC_AUTODOWNLOAD_HDR_SUB_3DLUT:
            {
                MS_U16 u16RVal = *(((MS_U16 *)pu8Data) + j);
                MS_U16 u16GVal = *(((MS_U16 *)pu8Data) + j + 1);
                MS_U16 u16BVal = *(((MS_U16 *)pu8Data) + j + 2);
                printf("%02X %02X %02X \n", u16RVal, u16GVal, u16BVal);
                j += 3;
                break;
            }
        }
        printf("\n");
    }
    printf("\n#####################Dump End####################\n\n");

    int k = AUTO_DOWNLOAD_HDR_TMO_SRAM_MAX_ADDR;
    printf("\n#####################Dump DRAM Buffer####################\n");
    for (j = 0; j < k; j++)
    {
        MS_U8 *pu8BaseAddr = (MS_U8 *)pVirtBaseAddr;
        printf("\nThe %04dth row: ", j);
        for (l = 0; l < 16; l++)
        {
            switch (enSubClient)
            {
                case E_XC_AUTODOWNLOAD_HDR_SUB_TMO:
                case E_XC_AUTODOWNLOAD_HDR_SUB_GAMMA:
                case E_XC_AUTODOWNLOAD_HDR_SUB_DEGAMMA:
                {
                    printf("%02X ", *(pu8BaseAddr + 16 * j + l));
                    break;
                }
                case E_XC_AUTODOWNLOAD_HDR_SUB_3DLUT:
                {
                    printf("%02X ", *(pu8BaseAddr + 16 * j + l));
                    k = AUTO_DOWNLOAD_HDR_3DLUT_SRAM_MAX_ADDR;
                    break;
                }
            }
        }
    }
    printf("\n#####################Dump End####################\n");
#endif

    return E_APIXC_RET_OK;
}

static MS_BOOL _Hal_XC_Auto_Download_Format_Op2Lut_Data(void* pInstance, MS_U8* pu8Data, MS_U32 u32Size)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_PHY phyBaseAddr = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].phyBaseAddr;
    MS_VIRT* pVirtBaseAddr = (MS_VIRT *)MS_PA2KSEG1(phyBaseAddr);
    MS_U32 u32Index = 0;
    SC_XC_OP2LUT_3DLUT_DRAM_FORMAT* pOP2LUT_ADL_Addr;
    MS_U32 u32WriteNum = 0;
    MS_U32 u32DataSize = 0;
    MS_U32 u32Depth = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].u32Depth;
    MS_U8 u8SRAMindex = 0;
    MS_U16 u16BVal = 0;
    MS_U16 u16GVal = 0;
    MS_U16 u16RVal = 0;

    if(pVirtBaseAddr == NULL)
    {
        printf("%s: %d pu8AutoDownloadDRAMBaseAddr is NULL.\n", __FUNCTION__, __LINE__);
        return FALSE;
    }
    pOP2LUT_ADL_Addr = (SC_XC_OP2LUT_3DLUT_DRAM_FORMAT *)pVirtBaseAddr;

    u32DataSize = u32Size / sizeof(MS_U16);

    for (u32Index = 0; u32Index < u32DataSize; )
    {
        u16BVal = *(((MS_U16 *)pu8Data) + u32Index);
        u16GVal = *(((MS_U16 *)pu8Data) + u32Index + 1);
        u16RVal = *(((MS_U16 *)pu8Data) + u32Index + 2);

        u8SRAMindex = u32Index / (OP2LUT_ENTRY_DATA_NUM * OP2LUT_SRAM_ENTRY);
        if(u8SRAMindex == 0)
        {
            if((u32Index%(OP2LUT_ENTRY_DATA_NUM * OP2LUT_SRAM_ENTRY)) == 0)
            {
                u32WriteNum = 0;
            }
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram1B = (u16BVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram1G = (u16GVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram1R = (u16RVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram1En = 1;
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram1Dummy = 0;
            u32WriteNum++;
            u32Depth = u32Depth > u32WriteNum ? u32Depth : u32WriteNum;
        }
        else if(u8SRAMindex == 1)
        {
            if((u32Index%(OP2LUT_ENTRY_DATA_NUM * OP2LUT_SRAM_ENTRY)) == 0)
            {
                u32WriteNum = 0;
            }
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram2B = (u16BVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram2G = (u16GVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram2R = (u16RVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram2En = 1;
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram2Dummy = 0;
            u32WriteNum++;
            u32Depth = u32Depth > u32WriteNum ? u32Depth : u32WriteNum;
        }
        else if(u8SRAMindex == 2)
        {
            if((u32Index%(OP2LUT_ENTRY_DATA_NUM * OP2LUT_SRAM_ENTRY)) == 0)
            {
                u32WriteNum = 0;
            }
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram3B = (u16BVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram3G = (u16GVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram3R = (u16RVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram3En = 1;
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram3Dummy = 0;
            u32WriteNum++;
            u32Depth = u32Depth > u32WriteNum ? u32Depth : u32WriteNum;
        }
        else if(u8SRAMindex == 3)
        {
            if((u32Index%(OP2LUT_ENTRY_DATA_NUM * OP2LUT_SRAM_ENTRY)) == 0)
            {
                u32WriteNum = 0;
            }
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram4B = (u16BVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram4G = (u16GVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram4R = (u16RVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram4En = 1;
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram4Dummy = 0;
            u32WriteNum++;
            u32Depth = u32Depth > u32WriteNum ? u32Depth : u32WriteNum;
        }
        else if(u8SRAMindex == 4)
        {
            if((u32Index%(OP2LUT_ENTRY_DATA_NUM * OP2LUT_SRAM_ENTRY)) == 0)
            {
                u32WriteNum = 0;
            }
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram5B = (u16BVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram5G = (u16GVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram5R = (u16RVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram5En = 1;
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram5Dummy = 0;
            u32WriteNum++;
            u32Depth = u32Depth > u32WriteNum ? u32Depth : u32WriteNum;
        }
        else if(u8SRAMindex == 5)
        {
            if((u32Index%(OP2LUT_ENTRY_DATA_NUM * OP2LUT_SRAM_ENTRY)) == 0)
            {
                u32WriteNum = 0;
            }
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram6B = (u16BVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram6G = (u16GVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram6R = (u16RVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram6En = 1;
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram6Dummy = 0;
            u32WriteNum++;
            u32Depth = u32Depth > u32WriteNum ? u32Depth : u32WriteNum;
        }
        else if(u8SRAMindex == 6)
        {
            if((u32Index%(OP2LUT_ENTRY_DATA_NUM * OP2LUT_SRAM_ENTRY)) == 0)
            {
                u32WriteNum = 0;
            }
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram7B = (u16BVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram7G = (u16GVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram7R = (u16RVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram7En = 1;
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram7Dummy = 0;
            u32WriteNum++;
            u32Depth = u32Depth > u32WriteNum ? u32Depth : u32WriteNum;
        }
        else if(u8SRAMindex == 7)
        {
            if((u32Index%(OP2LUT_ENTRY_DATA_NUM * OP2LUT_SRAM_ENTRY)) == 0)
            {
                u32WriteNum = 0;
            }
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram8B = (u16BVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram8G = (u16GVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram8R = (u16RVal & 0x3FF);
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram8En = 1;
            pOP2LUT_ADL_Addr[u32WriteNum].u32Sram8Dummy = 0;
            u32WriteNum++;
            u32Depth = u32Depth > u32WriteNum ? u32Depth : u32WriteNum;
        }
        else
        {
            printf("%s: %d data over write.\n", __FUNCTION__, __LINE__);
            return FALSE;
        }
        u32Index += OP2LUT_ENTRY_DATA_NUM;
    }

    pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].u32Depth = u32WriteNum;

    return TRUE;
}

static MS_BOOL _Hal_XC_Auto_Download_Format_Op2Lut_Data_Parsed(void* pInstance, MS_U8* pu8Data, MS_U32 u32Size)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_PHY phyBaseAddr = pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].phyBaseAddr;
    MS_U32 u32Depth = u32Size/BYTE_PER_WORD;
    MS_VIRT* pVirtBaseAddr = (MS_VIRT *)MS_PA2KSEG1(phyBaseAddr);
    MS_U8 *pu8BaseAddr = NULL;

    if(pVirtBaseAddr == NULL)
    {
        printf("%s: %d pu8AutoDownloadDRAMBaseAddr is NULL.\n", __FUNCTION__, __LINE__);
        return FALSE;
    }
    pu8BaseAddr = (MS_U8 *)pVirtBaseAddr;

    memcpy(pu8BaseAddr, pu8Data, u32Size);

    pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_OP2LUT].u32Depth = u32Depth;

    return TRUE;
}

E_APIXC_ReturnValue MHal_XC_AutoDownload_Write(void* pInstance, EN_XC_AUTODOWNLOAD_CLIENT enClient, MS_U8* pu8Data, MS_U32 u32Size, void* pParam)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    switch(enClient)
    {
        case E_XC_AUTODOWNLOAD_CLIENT_HDR:
        {
            XC_AUTODOWNLOAD_FORMAT_INFO* pstFormatInfo = (XC_AUTODOWNLOAD_FORMAT_INFO *)pParam;
            MS_PHY u16StartAddr = 0;
            MS_U32 u32MaxSize = 0;
            switch (pstFormatInfo->enSubClient)
            {
                case E_XC_AUTODOWNLOAD_HDR_SUB_TMO:
                case E_XC_AUTODOWNLOAD_HDR_SUB_GAMMA:
                case E_XC_AUTODOWNLOAD_HDR_SUB_DEGAMMA:
                {
                    u32MaxSize = AUTO_DOWNLOAD_HDR_TMO_SRAM_MAX_ADDR;
                    break;
                }
                case E_XC_AUTODOWNLOAD_HDR_SUB_3DLUT:
                {
                    u32MaxSize = AUTO_DOWNLOAD_HDR_3DLUT_SRAM_MAX_ADDR * 3;
                    break;
                }
                default:
                {
                    printf("Write auto download fail, invaild paramters, subClient: %d\n", pstFormatInfo->enSubClient);
                    return E_APIXC_RET_FAIL_INVALID_PARAMETER;
                }
            }
            if (pstFormatInfo->bEnableRange == TRUE)
            {
                if (pstFormatInfo->u16StartAddr <= pstFormatInfo->u16EndAddr && pstFormatInfo->u16EndAddr < u32MaxSize
                    && (pstFormatInfo->u16StartAddr + u32Size - 1) < u32MaxSize)
                {
                    u16StartAddr = pstFormatInfo->u16StartAddr;
                }
                else
                {
                    printf("Write auto download fail, invaild paramters, size: %d, addr range(enable, start, end) = (%d, %td, %td)\n",
                           (unsigned int)u32Size, pstFormatInfo->bEnableRange, (ptrdiff_t)pstFormatInfo->u16StartAddr, (ptrdiff_t)pstFormatInfo->u16EndAddr);
                    return E_APIXC_RET_FAIL_INVALID_PARAMETER;
                }
            }
            else
            {
                if (u32Size > u32MaxSize)
                {
                    printf("Write auto download fail, invaild paramters, size: %d\n", (unsigned int)u32Size);
                    return E_APIXC_RET_FAIL_INVALID_PARAMETER;
                }
            }
            return _Hal_XC_Auto_Download_Format_Hdr_Data(pInstance, pstFormatInfo->enSubClient, pu8Data, u32Size, u16StartAddr);
        }
        case E_XC_AUTODOWNLOAD_CLIENT_OP2LUT:
        {
            XC_AUTODOWNLOAD_FORMAT_INFO* pstFormatInfo = (XC_AUTODOWNLOAD_FORMAT_INFO *)pParam;
            MS_BOOL bRet = FALSE;
            MS_U32 u32MaxSize = 0;

            if(pstFormatInfo->u32FormatInfo_Version >= 2)
            {
                if(pstFormatInfo->bDataParsed == TRUE)
                {
                    u32MaxSize = AUTODOWNLOAD_CLIENT_OP2LUT_MEM_SIZE;
                    if (u32Size > u32MaxSize)
                    {
                        printf("Write auto download fail, invaild paramters, size: %tu\n", (ptrdiff_t)u32Size);
                        return E_APIXC_RET_FAIL;
                    }
                    _Hal_XC_Auto_Download_Format_Op2Lut_Data_Parsed(pInstance, pu8Data, u32Size);
                }
                else
                {
                    u32MaxSize = OP2LUT_SRAM * OP2LUT_SRAM_ENTRY * OP2LUT_ENTRY_DATA_NUM * sizeof(MS_U16);
                    if (u32Size > u32MaxSize)
                    {
                        printf("Write auto download fail, invaild paramters, size: %tu\n", (ptrdiff_t)u32Size);
                        return E_APIXC_RET_FAIL;
                    }
                    bRet = _Hal_XC_Auto_Download_Format_Op2Lut_Data(pInstance, pu8Data, u32Size);
                }
            }
            else
            {
                u32MaxSize = OP2LUT_SRAM * OP2LUT_SRAM_ENTRY * OP2LUT_ENTRY_DATA_NUM * sizeof(MS_U16);
                if (u32Size > u32MaxSize)
                {
                    printf("Write auto download fail, invaild paramters, size: %tu\n", (ptrdiff_t)u32Size);
                   return E_APIXC_RET_FAIL;
                }
                bRet = _Hal_XC_Auto_Download_Format_Op2Lut_Data(pInstance, pu8Data, u32Size);
            }

            if (bRet == FALSE)
            {
                return E_APIXC_RET_FAIL;
            }
            else
            {
                return E_APIXC_RET_OK;
            }
        }
        case E_XC_AUTODOWNLOAD_CLIENT_OP2GAMMA:
        case E_XC_AUTODOWNLOAD_CLIENT_FRCOP2GAMMA:
        case E_XC_AUTODOWNLOAD_CLIENT_XVYCC:
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE1:
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE2:
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE3:
        case E_XC_AUTODOWNLOAD_CLIENT_DEMURA:
        case E_XC_AUTODOWNLOAD_CLIENT_T3D_0:
        case E_XC_AUTODOWNLOAD_CLIENT_T3D_1:
        case E_XC_AUTODOWNLOAD_CLIENT_FRCSPTPOPM:
        case E_XC_AUTODOWNLOAD_CLIENT_FOOPM:
        case E_XC_AUTODOWNLOAD_CLIENT_HVSP:
        case E_XC_AUTODOWNLOAD_CLIENT_HSY:
        {
            return E_APIXC_RET_FAIL;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA:
        {
            if(u32Size > (XC_AUTODOWNLOAD_PNLGAMMA_WIDTH/8)*XC_AUTODOWNLOAD_PNLGAMMA_DEPTH)
            {
                return E_APIXC_RET_FAIL;
            }
            else
            {
                MS_U8 *pu8VirtBaseAddr = NULL;

                pu8VirtBaseAddr = (MS_U8*)MS_PA2KSEG1(pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].phyBaseAddr);
                memcpy(pu8VirtBaseAddr, pu8Data, u32Size);
                pXCResourcePrivate->stdrvXC_Display._stClientInfo[E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA].u32Depth = u32Size/BYTE_PER_WORD;

                return E_APIXC_RET_OK;
            }
        }
        case E_XC_AUTODOWNLOAD_CLIENT_MAX:
        default:
        {
            return E_APIXC_RET_FAIL;
        }

    }

    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue MHal_XC_GetAutoDownloadCaps(EN_XC_AUTODOWNLOAD_CLIENT enClient, MS_BOOL *pbSupported)
{
    switch(enClient)
    {
        case E_XC_AUTODOWNLOAD_CLIENT_HDR:
        case E_XC_AUTODOWNLOAD_CLIENT_OP2GAMMA:
        case E_XC_AUTODOWNLOAD_CLIENT_FRCOP2GAMMA:
        case E_XC_AUTODOWNLOAD_CLIENT_XVYCC:
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE1:
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE2:
        case E_XC_AUTODOWNLOAD_CLIENT_ODTABLE3:
        case E_XC_AUTODOWNLOAD_CLIENT_DEMURA:
        case E_XC_AUTODOWNLOAD_CLIENT_OP2LUT:
        case E_XC_AUTODOWNLOAD_CLIENT_T3D_0:
        case E_XC_AUTODOWNLOAD_CLIENT_T3D_1:
        case E_XC_AUTODOWNLOAD_CLIENT_FRCSPTPOPM:
        case E_XC_AUTODOWNLOAD_CLIENT_FOOPM:
        case E_XC_AUTODOWNLOAD_CLIENT_HVSP:
        case E_XC_AUTODOWNLOAD_CLIENT_HSY:
        case E_XC_AUTODOWNLOAD_CLIENT_PANEL_GAMMA:
        {
            *pbSupported = TRUE;
            break;
        }
        case E_XC_AUTODOWNLOAD_CLIENT_MAX:
        default:
        {
            *pbSupported = FALSE;
            break;
        }

    }

    return E_APIXC_RET_OK;
}
#endif

#ifdef UFO_XC_HDR
#if (UFO_XC_HDR_VERSION == 2)
static E_APIXC_ReturnValue _Hal_XC_HDR_UpdateDMAMode(void* pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    EN_XC_HDR_COLOR_FORMAT enColorFormat = pXCResourcePrivate->stdrvXC_Display._enColorFormat;
    EN_XC_HDR_DMA_MODE enMode = pXCResourcePrivate->stdrvXC_Display._stDMAConfigInfo.enMode;

    switch (enColorFormat)
    {
        case E_XC_HDR_COLOR_YUV422:
        {
            // set dma mode
            if (enMode == E_XC_HDR_DMA_MODE_12BIT)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK42_01_L, 0, 0x0003);
            }
            else if (enMode == E_XC_HDR_DMA_MODE_8BIT)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK42_01_L, 2, 0x0003);
            }
            else if (enMode == E_XC_HDR_DMA_MODE_10BIT)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK42_01_L, 3, 0x0003);
            }
            break;
        }
        case E_XC_HDR_COLOR_YUV444:
        {
            if (enMode == E_XC_HDR_DMA_MODE_10BIT)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK42_01_L, 1, 0x0003);
            }
            break;
        }
        case E_XC_HDR_COLOR_YUV420:
        case E_XC_HDR_COLOR_RGB:
        default:
        {
            break;
        }
    }

    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue MHal_XC_HDR_Control(void* pInstance, EN_XC_HDR_CTRL_TYPE enCtrlType, void *pParam)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    switch(enCtrlType)
    {
        case E_XC_HDR_CTRL_CONFIG_DMA:
        case E_XC_HDR_CTRL_SET_COLOR_FORMAT:
        {
            _Hal_XC_HDR_UpdateDMAMode(pInstance);
            break;
        }
        case E_XC_HDR_CTRL_INIT_DMA:
        {
            MS_U8 u8MIUSel = 0;
            MS_U8 u8FrameNum = 0;
            XC_HDR_DMA_INIT_INFO stDMAInitInfo = *(XC_HDR_DMA_INIT_INFO *)pParam;
            MS_PHY phyTemp = 0;
            _phy_to_miu_offset(u8MIUSel, phyTemp, stDMAInitInfo.phyBaseAddr);
            if (stDMAInitInfo.u32Size != 0)
            {
                // set IPM/OPM addr
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK42_08_L, stDMAInitInfo.phyBaseAddr / BYTE_PER_WORD);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK42_09_L, (stDMAInitInfo.phyBaseAddr / BYTE_PER_WORD) >> 16, 0x1FFF);
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK42_10_L, stDMAInitInfo.phyBaseAddr / BYTE_PER_WORD);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK42_11_L, (stDMAInitInfo.phyBaseAddr / BYTE_PER_WORD) >> 16, 0x1FFF);
                // set miu
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK42_05_L, u8MIUSel << 4, BMASK(5:4));
                // set limit addr
                // enable limit
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK42_50_L, 1, BIT(0));
                // min addr
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK42_52_L, stDMAInitInfo.phyBaseAddr / BYTE_PER_WORD);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK42_53_L, (stDMAInitInfo.phyBaseAddr / BYTE_PER_WORD) >> 16, 0x1FFF);
                // max addr
                SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK42_54_L, (stDMAInitInfo.phyBaseAddr + stDMAInitInfo.u32Size) / BYTE_PER_WORD - 1);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK42_55_L, ((stDMAInitInfo.phyBaseAddr + stDMAInitInfo.u32Size) / BYTE_PER_WORD - 1) >> 16, 0x1FFF);
                // frame number
                u8FrameNum = stDMAInitInfo.u32Size/(3840*2160*3);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK42_19_L, u8FrameNum, 0x001F);
            }
            break;
        }
        case E_XC_HDR_CTRL_ENABLE:
        case E_XC_HDR_CTRL_SET_TYPE:
        case E_XC_HDR_CTRL_SET_3DLUT:
        case E_XC_HDR_CTRL_SET_OTT_SHARE_MEMORY:
        case E_XC_HDR_CTRL_SET_OPEN_METADATA:
        default:
        {
            break;
        }
    }

    return E_APIXC_RET_OK;
}

E_APIXC_ReturnValue MHal_XC_HDR_GetCaps(void *pInstance, XC_HDR_SUPPORTED_CAPS *pstHDRCaps)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    EN_XC_HDR_TYPE enHDRType = pstHDRCaps->enHDRType;

    switch (enHDRType)
    {
        case E_XC_HDR_TYPE_OPEN:
        {
            pstHDRCaps->bSupported = TRUE;
            break;
        }
        case E_XC_HDR_TYPE_DOLBY:
        {
#ifndef CONFIG_MBOOT  //Add For GPL (content protection)
            if (MDrv_AUTH_IPCheck(IPAUTH_DOLBY_HDR_PIN))
            {
                pstHDRCaps->bSupported = TRUE;

            }
            else
            {
#endif
                pstHDRCaps->bSupported = FALSE;
#ifndef CONFIG_MBOOT  //Add For GPL (content protection)
            }
#endif
            break;
        }
        case E_XC_HDR_TYPE_TECHNICOLOR:
        {
            if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK79_3F_L, BIT(13)))     //HW bonded
            {
                pstHDRCaps->bSupported = FALSE;
            }
            else if (MDrv_AUTH_IPCheck(IPAUTH_TCH_HDR_PIN))
            {
                pstHDRCaps->bSupported = TRUE;
            }
            else
            {
                pstHDRCaps->bSupported = FALSE;
            }
            break;
        }
        case E_XC_HDR_TYPE_HLG:
        {
            pstHDRCaps->bSupported = TRUE;
            break;
        }
        case E_XC_HDR_TYPE_HDR10_PLUS:
        {
            if (MDrv_AUTH_IPCheck(IPAUTH_HDR10_PLUS_PIN))
            {
                pstHDRCaps->bSupported = TRUE;
            }
            else
            {
                pstHDRCaps->bSupported = FALSE;
            }
            break;
        }
        default:
        {
            pstHDRCaps->bSupported = FALSE;
        }
    }

    pstHDRCaps->s32MaxLuminanceData = -1;
    pstHDRCaps->s32MinLuminanceData = -1;
    pstHDRCaps->s32MaxFrameAveLumiance = -1;

    return E_APIXC_RET_OK;
}
#endif
#endif

//T3D MIU select from external
void Hal_SC_Set_T3D_MiuSelectExternal(void *pInstance, MS_U8 u8MIUSel)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(2 == u8MIUSel)//MIU2 = (10) ==> REG_SC_BK7F_18_[10] = 1 && REG_SC_BK7F_10_[10] = 0
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_11_L, 0, BIT(10));//Enable T3D select MIU exteral
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_10_L, 0, BIT(10));//T3D MIU select low 1 bit
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_18_L, BIT(10), BIT(10));//T3D MIU select hight 1 bit
    }
    else if(1 == u8MIUSel)//MIU1
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_11_L, 0, BIT(10));//Enable T3D select MIU exteral
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_10_L, BIT(10), BIT(10));//T3D MIU select low 1 bit
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_18_L, 0, BIT(10));//T3D MIU select hight 1 bit
    }
    else//MIU0
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_11_L, 0, BIT(10));//Enable T3D select MIU exteral
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_10_L,0, BIT(10));// T3D MIU select low 1 bit
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK7F_18_L, 0, BIT(10));//T3D MIU select hight 1 bit
    }
}

#ifdef CONFIG_MSTAR_SRAMPD
E_APIXC_ReturnValue MHal_XC_SRAM_PowerDown_Control(void* pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U8 u8LPLL_Type = (MS_U8)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type;

    if (bEnable)
    {
        #if 0 // Skip power down for bring up
        // power down case
        if (!IsVBY1_16LANE(u8LPLL_Type))
        {
            // FO_TOP SRAM PD
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_65_L, 0x0001, 0x0001); // SC_FO_BKC9_65[0]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_69_L, 0x000F, 0x000F); // SC_FO_BKC9_69[3:0]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_6C_L, 0x0003, 0x0003); // SC_FO_BKC9_6C[1:0]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_6D_L, 0x0001, 0x0001); // SC_FO_BKC9_6d[0]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_6E_L, 0x0100, 0x0100); // SC_FO_BKC9_6e[8]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_6F_L, 0x0101, 0x0101); // SC_FO_BKC9_6f[0] + SC_FO_BKC9_6f[8]
            // FO_TOP clk gate
            W2BYTEMSK(L_CLKGEN0(0x53),0x0001,0x0001); // BK100B_CKGEN0_53[0]
            W2BYTEMSK(L_CLKGEN2(0x44),0x0100,0x0100); // BK100A_CKGEN2_44[8]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_03_L, 0x0000, 0x0010); // ~SC_FO_BKC9_03[4]
        }

        // SPF SRAM PD
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_0D_L, 0x0007, 0x0007); // SC_SPD_BK3F_0D[2:0]
        // SPF clk gate
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_50_L, 0x0000, 0x4000); // ~SC_SPD_BK3F_50[14] (clk_fclk)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_52_L, 0x0000, 0x4000); // ~SC_SPD_BK3F_52[14] (clk_fclk_live)

        // DI SRAM PD
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_05_L, 0x003F, 0x003F); // SC_SPD_BK3F_05[5:0]
        // DI clk gate
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_40_L, 0x0000, 0x0001); // ~SC_SPD_BK3F_40[0](clk_fclk)

        // IPM  + OPW SRAM PD
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_03_L, 0x005F, 0x005F); // SC_SPD_BK3F_03[4:0] + SC_SPD_BK3F_03[6]
        // IPM  + OPW clk gate
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_40_L, 0x0000, 0x1004); // ~SC_SPD_BK3F_40[2](clk_mclk) + ~SC_SPD_BK3F_40[12](clk_mclk)

        #endif
        _bSRAMPowerDown = TRUE;
    }
    else
    {
        // power on case
        if (!IsVBY1_16LANE(u8LPLL_Type))
        {
            // FO_TOP SRAM PD
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_65_L, 0x0000, 0x0001); // SC_FO_BKC9_65[0]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_69_L, 0x0000, 0x000F); // SC_FO_BKC9_69[3:0]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_6C_L, 0x0000, 0x0003); // SC_FO_BKC9_6C[1:0]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_6D_L, 0x0000, 0x0001); // SC_FO_BKC9_6d[0]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_6E_L, 0x0000, 0x0100); // SC_FO_BKC9_6e[8]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_6F_L, 0x0000, 0x0101); // SC_FO_BKC9_6f[0] + SC_FO_BKC9_6f[8]
            // FO_TOP clk gate
            W2BYTEMSK(L_CLKGEN0(0x53),0x0000,0x0001); // BK100B_CKGEN0_53[0]
            W2BYTEMSK(L_CLKGEN2(0x44),0x0000,0x0100); // BK100A_CKGEN2_44[8]
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_03_L, 0x0010, 0x0010); // ~SC_FO_BKC9_03[4]
        }

        // SPF SRAM PD
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_0D_L, 0x0000, 0x0007); // SC_SPD_BK3F_0D[2:0]
        // SPF clk gate
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_50_L, 0x4000, 0x4000); // ~SC_SPD_BK3F_50[14] (clk_fclk)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_52_L, 0x4000, 0x4000); // ~SC_SPD_BK3F_52[14] (clk_fclk_live)

        // DI SRAM PD
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_05_L, 0x0000, 0x003F); // SC_SPD_BK3F_05[5:0]
        // DI clk gate
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_40_L, 0x0001, 0x0001); // ~SC_SPD_BK3F_40[0](clk_fclk)

        // IPM  + OPW SRAM PD
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_03_L, 0x0000, 0x005F); // SC_SPD_BK3F_03[4:0] + SC_SPD_BK3F_03[6]
        // IPM  + OPW clk gate
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_40_L, 0x1004, 0x1004); // ~SC_SPD_BK3F_40[2](clk_mclk) + ~SC_SPD_BK3F_40[12](clk_mclk)

        _bSRAMPowerDown = FALSE;
    }

    return E_APIXC_RET_OK;
}

MS_BOOL MHal_XC_Is_SRAM_PowerDown(void* pInstance)
{
    return _bSRAMPowerDown;
}

void MHal_XC_Set_LD_SRAM_Power_Down(void* pInstance, MS_BOOL bIsSRAMPowerDown)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U8 u8LPLL_Type = (MS_U8)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type;

    if(bIsSRAMPowerDown)
    {
        #if 0 // Skip power down for bring up
        //power dowm
        // FO setting
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BKC9_65_L, (BIT(0)), 0x0001);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BKCE_01_L, (0x0000), 0x1000);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BKCE_37_L, (BIT(15)), 0x8000);
        //non-FO setting
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK3F_12_L, (BIT(0)| BIT(1)), 0x0003);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK3F_50_L, (0x0000), 0x3800);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK2E_37_L, (BIT(15)), 0x8000);
        #endif
    }
    else
    {
        //power on
        if (IsVBY1_16LANE(u8LPLL_Type))
        {
            // FO setting
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BKC9_65_L, (0x0000), 0x0001);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BKCE_01_L, (BIT(12)), 0x1000);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BKCE_37_L, (0x0000), 0x8000);
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK3F_12_L,  0x0000, 0x0003);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK3F_50_L, (BIT(11)| BIT(12)|BIT(13)), 0x3800);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK2E_37_L, (0x0000), 0x8000);
        }
    }
}

void MHal_XC_Set_ADC_SRAM_Power_Down(void* pInstance, MS_BOOL bIsSRAMPowerDown)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(bIsSRAMPowerDown)
    {
        #if 0 // Skip power down for bring up
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK3F_03_L, 0x0080, 0x0080);
        #endif
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK3F_03_L, 0x0000, 0x0080);
    }
}

void Hal_SC_Sub_SRAM_PowerDown_Control(void *pInstance, MS_BOOL bPipEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(psXCInstPri->u32DeviceID != 1)
    {
        printf("[%s,%5d]  not support this device ID!",__FUNCTION__,__LINE__);
        return;
    }

    if(bPipEnable == TRUE)
    {
        MDrv_WriteRegBit(REG_CKG_S2_IDCLK2, DISABLE, CKG_S2_IDCLK2_GATED);

#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_02_L, MAIN_WINDOW), 0, BIT(7));
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_02_L, 0, BIT(7));
#endif
//        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK00_03_L, 0, BIT(11));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_20_L, 0, BIT(0)|BIT(8));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_01_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_02_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_03_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_04_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_05_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_06_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_07_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_08_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_09_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_0A_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_0B_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_0C_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_0D_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_10_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_11_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_12_L, 0, 0xFFDF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_13_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_14_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_15_L, 0, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_16_L, 0, BIT(11));
    }
    else
    {
        #if 0 // Skip power down for bring up
        //for power saving
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_02_L, BIT(7), BIT(7));
//        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK00_03_L, BIT(11), BIT(11));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_20_L, BIT(0)|BIT(8), BIT(0)|BIT(8));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_01_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_02_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_03_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_04_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_05_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_06_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_07_L, 0xFFFF, 0xFFFF);
        //SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_08_L, 0xFFFF, 0xFFFF); //!!! Sub HVSP can not be closed
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_09_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_0A_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_0B_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_0C_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_0D_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_10_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_11_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_12_L, 0xFFDF, 0xFFDF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_13_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_14_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_15_L, 0xFFFF, 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK3F_16_L,  BIT(11), BIT(11));

        MDrv_WriteRegBit(REG_CKG_S2_IDCLK2, ENABLE, CKG_S2_IDCLK2_GATED);
        #endif
    }
}
#endif

MS_BOOL MHal_XC_GetPQPathStatus(void* pInstance, E_XC_PQ_Path_Type ePqPathType, MS_U16 u16Width, MS_U16 u16Height)
{
    MS_BOOL bRet = FALSE;
    switch (ePqPathType)
    {
        case E_XC_PQ_4K_PATH :
            bRet = (IS_4K2K_MODE(u16Width, u16Height)||IS_4K1K_MODE(u16Width, u16Height));
            break;
        case  E_XC_PQ_UFSC_4K_PATH :
            printf("[%s][%d]  not UFSC path type(%d)!\n", __FUNCTION__, __LINE__, ePqPathType);
            break;
        default :
            printf("[%s][%d]  not path type(%d)!\n", __FUNCTION__, __LINE__, ePqPathType);
            break;
    }

    return bRet;
}

static XC_VSYNC_VSTART stXCVstart = {0, 0, 0, 0};
MS_BOOL MHal_XC_PixelShiftStatusChange(void* pInstance, XC_PIXEL_SHIFT_STATUS enStatus)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_U8 u8LPLL_Type = 0;
    MS_U16 u16Reg = 0;
    u8LPLL_Type =(MS_U8)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type;
    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "enStatus: %d, psXCInstPri->u32DeviceID: %tu.\n", enStatus, (ptrdiff_t)psXCInstPri->u32DeviceID);

    switch (enStatus)
    {
        case EN_XC_PIXEL_SHIFT_DISABLE:
            // Maserati mode
            if (IsVBY1_16LANE(u8LPLL_Type))
            {
                // Restore DE_VStart;
                u16Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, 0x1FFF);
                if ((u16Reg != stXCVstart.u16RegTGenDeVstart) && (stXCVstart.u16RegTGenDeVstart != 0))
                {
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, stXCVstart.u16RegTGenDeVstart, 0x1FFF);
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, stXCVstart.u16RegTGenDeVend, 0x1FFF);
                    stXCVstart.u16RegTGenDeVstart = 0;
                    stXCVstart.u16RegTGenDeVend   = 0;
                }
            }
            u16Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0B_L, 0x1FFF);
            if ((u16Reg != stXCVstart.u16RegSTGenDeVstart) && (stXCVstart.u16RegSTGenDeVstart != 0))
            {
                //BK68_0B [12:0]:reg_f_de_yst
                //BK68_0C [12:0]:reg_f_de_yend
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0B_L, stXCVstart.u16RegSTGenDeVstart, 0x1FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0C_L, stXCVstart.u16RegSTGenDeVend, 0x1FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0E_L, stXCVstart.u16RegSTGenDeVend, 0x1FFF);
                stXCVstart.u16RegSTGenDeVstart = 0;
                stXCVstart.u16RegSTGenDeVend = 0;
            }
        break;
        case EN_XC_PIXEL_SHIFT_ENABLE:
            // Maserati mode
            if (IsVBY1_16LANE(u8LPLL_Type))
            {
                if (0 == stXCVstart.u16RegTGenDeVstart)
                {
                    u16Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, 0x1FFF);
                    stXCVstart.u16RegTGenDeVstart = u16Reg;
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, (u16Reg + 2), 0x1FFF);

                    u16Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, 0x1FFF);
                    stXCVstart.u16RegTGenDeVend = u16Reg;
                    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, (u16Reg + 2), 0x1FFF);
                }
            }
            if (0 == stXCVstart.u16RegSTGenDeVstart)
            {
                //BK68_0B [12:0]:reg_f_de_yst
                //BK68_0C [12:0]:reg_f_de_yend
                u16Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0B_L, 0x1FFF);
                stXCVstart.u16RegSTGenDeVstart = u16Reg;
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0B_L, (u16Reg + 2), 0x1FFF);

                u16Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0C_L, 0x1FFF);
                stXCVstart.u16RegSTGenDeVend = u16Reg;
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0C_L, (u16Reg + 2), 0x1FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0E_L, (u16Reg + 2), 0x1FFF);
            }
        break;
        case EN_XC_PIXEL_SHIFT_FORCE_UPDATE:
            if ((pXCResourcePrivate->stdrvXC_MVideo.gu16VPixelShiftRange != 0)
                && ((pXCResourcePrivate->stdrvXC_3D._eInput3DMode[MAIN_WINDOW] == E_XC_3D_INPUT_MODE_NONE) && (pXCResourcePrivate->stdrvXC_3D._eOutput3DMode == E_XC_3D_OUTPUT_MODE_NONE))
                )
            {
                // pixelshift
                if (IsVBY1_16LANE(u8LPLL_Type))
                {
                    u16Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, 0x1FFF);
                    if (stXCVstart.u16RegTGenDeVstart == 0)
                    {
                        stXCVstart.u16RegTGenDeVstart = u16Reg;
                        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_06_L, (u16Reg + 2), 0x1FFF);

                        u16Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, 0x1FFF);
                        stXCVstart.u16RegTGenDeVend = u16Reg;
                        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, (u16Reg + 2), 0x1FFF);
                    }
                }

                //BK68_0B [12:0]:reg_f_de_yst
                //BK68_0C [12:0]:reg_f_de_yend
                u16Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0B_L, 0x1FFF);
                stXCVstart.u16RegSTGenDeVstart = u16Reg;
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0B_L, (u16Reg + 2), 0x1FFF);

                u16Reg = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0C_L, 0x1FFF);
                stXCVstart.u16RegSTGenDeVend = u16Reg;
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0C_L, (u16Reg + 2), 0x1FFF);
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_0E_L, (u16Reg + 2), 0x1FFF);
            }
            else
            {
                XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "gu16VPixelShiftRange: %u.\n", pXCResourcePrivate->stdrvXC_MVideo.gu16VPixelShiftRange);
                XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "_eInput3DMode: %d.\n", pXCResourcePrivate->stdrvXC_3D._eInput3DMode[MAIN_WINDOW]);
                XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "_eOutput3DMode: %d.\n", pXCResourcePrivate->stdrvXC_3D._eOutput3DMode);
                XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "ByPass EN_XC_PIXEL_SHIFT_FORCE_UPDATE.\n");
            }
        break;
        default:
        break;
    }

    return TRUE;
}

#if defined(PATCH_HW_VTT_LIMITATION)
//There is the hareware bug on Macan U1 Chip REG_SC_BK10_0D.
//That is replaced by REG_SC_BK68 byMHal_XC_SetVopVtt function.
void MHal_XC_SetVopVttByBK68(void* pInstance, MS_U16 u16Vtt, MS_BOOL bMLoadEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(bMLoadEnable)
    {
        Mhal_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_36_L, u16Vtt , 0xFFFF);
        Mhal_XC_MLoad_WriteCmd(pInstance, REG_SC_BK68_37_L, u16Vtt , 0xFFFF);
        Mhal_XC_MLoad_Fire(pInstance, TRUE);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_36_L, u16Vtt , 0xFFFF);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_37_L, u16Vtt , 0xFFFF);
    }
}
#endif

MS_BOOL Hal_SC_CheckMuteStatusByRegister(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_BOOL bRet = FALSE;

#if (PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB)
    if(((MAIN_WINDOW == eWindow) && (psXCInstPri->u32DeviceID == 1))
        || (SUB_WINDOW == eWindow)
    )
    {
        bRet = (SC_R2BYTEMSK(0, REG_SC_BK10_19_L, BIT(5)) ? TRUE: FALSE);
    }
#else
    if(SUB_WINDOW == eWindow)
    {
        bRet = (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_19_L, BIT(5)) ? TRUE: FALSE);
    }
#endif
    else if(MAIN_WINDOW == eWindow)
    {
        bRet = (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_19_L, BIT(1)) ? TRUE: FALSE);
    }
    return bRet;
}

void Hal_SC_add_dram_to_shm(void *pInstance,SCALER_WIN eWindow,MS_PHY u32address,MS_U32 u32length)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_data[pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_cnt].address = u32address;
    pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_data[pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_cnt].length = u32length;
    pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_cnt++;
}
void Hal_SC_add_reg_to_shm(void *pInstance,SCALER_WIN eWindow,MS_U32 u32_bk,MS_U16 u16_value,MS_U16 u16_mask)
{
    MS_U32 u32offset = 0;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    u32offset = _XC_Device_Offset[psXCInstPri->u32DeviceID];

    pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].regs_data[pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].regs_cnt].bk = REG_SCALER_BASE + u32_bk + (u32offset << 8);
    pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].regs_data[pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].regs_cnt].value = u16_value;
    pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].regs_data[pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].regs_cnt].mask = u16_mask;
    pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].regs_cnt ++;
}

MS_BOOL Hal_SC_secure_lock(void *pInstance, SCALER_WIN eWindow, MS_U32 u32SecureDMA, MS_U32 u32OperationMode)
{
#ifdef MSOS_TYPE_OPTEE
    MS_PHY phy_dramAddr = 0;
    MS_U8 u8i = 0;
#endif
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    #ifndef MSOS_TYPE_OPTEE
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    #else
    XC_RESOURCE_PRIVATE_FOR_TEE* pXCResourcePrivate = NULL;
    #endif
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    #ifdef MSOS_TYPE_OPTEE
    if (u32SecureDMA == 0)
    {
        MDrv_Seal_ChangeIPSecureDMAAbillity(MODULE_XC, 0 , FALSE);
        //MDrv_Seal_SetSecureRange(pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_data[0].address , pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_data[0].length , TRUE);
    }
    for (u8i = 0; u8i < pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_cnt; u8i++)
    {
        phy_dramAddr = (MS_PHY) pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_data[u8i].address;

        if(pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_data[u8i].length != 0)
        {
            if (u8i >= OP_TEE_XC_DRAM_MAX_CNT)
            {
                printf("dram cnt overflow\n");
                break;
            }
            if (u32OperationMode == 1)
            {
                if(MDrv_Seal_SetSecureRange(phy_dramAddr, pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_data[u8i].length , TRUE) == FALSE)
                {
                    return FALSE;
                }
            }
            else if (u32OperationMode == 0)
            {
                if(MDrv_Seal_SetSecureRange(phy_dramAddr , pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].drams_data[u8i].length , FALSE) == FALSE)
                {
                    return FALSE;
                }
            }
        }
    }
    if (u32SecureDMA == 1)
    {
        MDrv_Seal_ChangeIPSecureDMAAbillity(MODULE_XC, 0 , TRUE);
    }
    if (u32OperationMode == 1)
    {
        MDrv_Seal_SecureSlaveSet(E_SEAL_SC0_PROT_NONPM, TRUE);
        MDrv_Seal_BufferLock(E_SEAL_SC_WP_SCM_M, TRUE);
    }
    else if (u32OperationMode == 0)
    {
        MDrv_Seal_SecureSlaveSet(E_SEAL_SC0_PROT_NONPM, FALSE);
        MDrv_Seal_BufferLock(E_SEAL_SC_WP_SCM_M, FALSE);
    }
    pXCResourcePrivate->sthal_Optee.op_tee_xc[eWindow].isEnable=u32OperationMode;
    #endif
    return TRUE;
}

void Hal_SC_update_to_shm(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if (eWindow == MAIN_WINDOW)
    {
        Hal_SC_add_reg_to_shm(pInstance, eWindow, REG_SC_BK0D_38_L, (BIT(0) | BIT(4)), (BIT(0) | BIT(4)));
        Hal_SC_add_reg_to_shm(pInstance, eWindow, REG_SC_BK12_08_L, ((pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32DNRBase0) & 0xFFFF), 0xFFFF);
        Hal_SC_add_reg_to_shm(pInstance, eWindow, REG_SC_BK12_09_L, ((pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32DNRBase0) >> 16), 0xFFFF);
        Hal_SC_add_reg_to_shm(pInstance, eWindow, REG_SC_BK12_1C_L, 0x0000, 0xFFFF);
    }
    else if (eWindow == SUB_WINDOW)
    {
        Hal_SC_add_reg_to_shm(pInstance, eWindow, REG_SC_BK0D_38_L, (BIT(1) | BIT(6)), (BIT(1) | BIT(6)));
        Hal_SC_add_reg_to_shm(pInstance, eWindow, REG_SC_BK12_48_L, ((pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32DNRBase0) & 0xFFFF), 0xFFFF);
        Hal_SC_add_reg_to_shm(pInstance, eWindow, REG_SC_BK12_49_L, ((pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32DNRBase0) >> 16), 0xFFFF);
        Hal_SC_add_reg_to_shm(pInstance, eWindow, REG_SC_BK12_5C_L, 0x0000, 0xFFFF);
    }
}

#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
//-------------------------------------------------------------------------------------------------
/// Set Dual View
//-------------------------------------------------------------------------------------------------
void Hal_SC_3D_Set_DualView(void *pInstance, MS_BOOL bEnable)
{
    // manhattan dual view
    // clone SC1 main to SC0 sub
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    Hal_SC_set_dualview_clone(pInstance,bEnable);

    if (bEnable)
    {
        if (IS_OUTPUT_FRAME_ALTERNATIVE())
        {
            SC_W2BYTEMSK(0, REG_SC_BK20_24_L, BIT(2), BIT(2)); // reg_op1lr_sel
            SC_W2BYTEMSK(0, REG_SC_BK20_24_L, BIT(1), BIT(1)|BIT(0)); // reg_lr2mod_sel
        }
        else if (IS_OUTPUT_LINE_ALTERNATIVE())
        {
            SC_W2BYTEMSK(0, REG_SC_BK23_53_L, BIT(15), BIT(15));//dnr offset
            SC_W2BYTEMSK(1, REG_SC_BK20_1B_L, 0x0800,  0x0FFF); //FIXME: tmp solution from HW RD for fixing dual view sub window shaking problem
        }

        SC_W2BYTEMSK(0, REG_SC_BK68_40_L, 0, BIT(4)); // disable sc1 pip
        SC_W2BYTEMSK(0, REG_SC_BK20_10_L, 0, BIT(2));
        SC_W2BYTEMSK(1, REG_SC_BK20_10_L, BIT(10), BIT(10));
        if((SC_R2BYTEMSK(1, REG_SC_BK12_01_L, BIT(5)) == BIT(5)) ||(SC_R2BYTEMSK(1, REG_SC_BK12_01_L, BIT(4)) == BIT(4)))
        {
            SC_W2BYTE(0, REG_SC_BK23_2C_L, 0);
        }
        else
        {
            SC_W2BYTEMSK(0, REG_SC_BK23_2C_L, BIT(6) |BIT(7), BIT(6) |BIT(7));
        }

#if(HW_DESIGN_3D_VER == 3) //monet mode
        if (SC_R2BYTEMSK(0, REG_SC_BK20_03_L, BIT(2)) == BIT(2))
        {
            SC_W2BYTEMSK(0, REG_SC_BK20_03_L,0, BIT(2));//reg_force_fe2_en
        }
#endif
    }
    else
    {
        SC_W2BYTEMSK(0, REG_SC_BK20_24_L, 0, BIT(2)); // reg_op1lr_sel
        SC_W2BYTEMSK(0, REG_SC_BK20_24_L, 0, BIT(1)|BIT(0)); // reg_lr2mod_sel
        SC_W2BYTEMSK(0, REG_SC_BK23_53_L, 0, 0x8000);//dnr offset

        SC_W2BYTEMSK(1, REG_SC_BK20_10_L, 0, BIT(10));

        if ((SC_R2BYTEMSK(1, REG_SC_BK20_10_L, BIT(0)) == BIT(0))
            && (SC_R2BYTEMSK(0, REG_SC_BK20_10_L, BIT(1)) == BIT(1)))
        {
            //restore sc1 pip setting
            SC_W2BYTEMSK(0, REG_SC_BK68_40_L, BIT(4), BIT(4));
        }
    }
}

MS_BOOL Hal_SC_3D_IsDualViewMode(void* pInstance, SCALER_WIN eWindow) //elaine.chen
{
    MS_BOOL ret = FALSE;

    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
    if(IS_INPUT_MODE_NONE(eWindow) &&
        (IS_OUTPUT_FRAME_ALTERNATIVE() || IS_OUTPUT_LINE_ALTERNATIVE() || IS_OUTPUT_TOP_BOTTOM() ))
    {
            ret = TRUE;
    }
#endif
    return ret;
}


// clone SC1 main to SC0 sub
void Hal_SC_set_dualview_clone(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    SC_DBG(printf("\33[0;35m [Dual View] %s %d: ,bEnable = %u   \33[m \n", __FUNCTION__,  __LINE__,bEnable));

    if (bEnable)
    {
        MS_U16 u16value = 0;
        MS_U32 u32value = 0;

        // memfmt
        u16value = SC_R2BYTE(1, REG_SC_BK12_01_L);
        SC_W2BYTE(0, REG_SC_BK12_41_L, u16value);

        u16value = SC_R2BYTE(1, REG_SC_BK12_02_L);
        SC_W2BYTE(0, REG_SC_BK12_42_L, u16value);

        u16value = SC_R2BYTE(1, REG_SC_BK12_03_L);
        SC_W2BYTE(0, REG_SC_BK12_43_L, u16value);

        u16value = SC_R2BYTE(1, REG_SC_BK12_04_L);
        SC_W2BYTE(0, REG_SC_BK12_44_L, u16value);

        u16value = SC_R2BYTE(1, REG_SC_BK12_05_L);
        SC_W2BYTE(0, REG_SC_BK12_45_L, u16value);

        u16value = SC_R2BYTE(1, REG_SC_BK12_06_L);
        SC_W2BYTE(0, REG_SC_BK12_46_L, u16value);

        u16value = SC_R2BYTE(1, REG_SC_BK12_07_L);
        SC_W2BYTE(0, REG_SC_BK12_47_L, u16value);

        u32value = SC_R4BYTE(1, REG_SC_BK12_08_L); // ipm base
        SC_W4BYTE(0, REG_SC_BK12_48_L, u32value);

        u32value = SC_R4BYTE(1, REG_SC_BK12_10_L); // opm base
        SC_W4BYTE(0, REG_SC_BK12_50_L, u32value);

        u16value = SC_R2BYTE(1, REG_SC_BK12_0E_L); //ipm offset
        SC_W2BYTE(0, REG_SC_BK12_4E_L, u16value);

        u16value = SC_R2BYTE(1, REG_SC_BK12_0F_L); //ipm fetch
        SC_W2BYTE(0, REG_SC_BK12_4F_L, u16value);

        u16value = SC_R2BYTE(1, REG_SC_BK12_16_L); //opm offset
        SC_W2BYTE(0, REG_SC_BK12_56_L, u16value);

        u16value = SC_R2BYTE(1, REG_SC_BK12_17_L); //opm fetch
        SC_W2BYTE(0, REG_SC_BK12_57_L, u16value);

        u16value = SC_R2BYTE(1, REG_SC_BK12_18_L);
        SC_W2BYTE(0, REG_SC_BK12_58_L, u16value);

        u16value = SC_R2BYTEMSK(1, REG_SC_BK12_19_L, 0x1F); // frame count
        SC_W2BYTEMSK(0, REG_SC_BK12_59_L, u16value, 0x1F);

        u16value = SC_R2BYTEMSK(1, REG_SC_BK20_15_L, 0x0FFF); // v_length
        SC_W2BYTEMSK(0, REG_SC_BK20_16_L, u16value, 0x0FFF);

        u16value = SC_R2BYTEMSK(1, REG_SC_BK20_1D_L, 0xFF); // H_offset
        u16value |= SC_R2BYTEMSK(1, REG_SC_BK20_2C_L, 0x0300);
        SC_W2BYTEMSK(0, REG_SC_BK20_1D_L, u16value<<8, 0xFF00);
        SC_W2BYTEMSK(0, REG_SC_BK20_2C_L, u16value<<4, 0x3000);

        u32value = SC_R4BYTE(1, REG_SC_BK23_07_L); // post H scaling
        SC_W4BYTE(0, REG_SC_BK23_27_L, u32value);

        u32value = SC_R4BYTE(1, REG_SC_BK23_09_L); // post V scaling
        SC_W4BYTE(0, REG_SC_BK23_29_L, u32value);

#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        u16value = SC_R2BYTEMSK(0, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_61_L, MAIN_WINDOW), 0x03);
        SC_W2BYTEMSK(1, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_61_L, MAIN_WINDOW), u16value, 0x03); // copy main setting for HDMI Y422 color wrong when dual view on
#else
        u16value = SC_R2BYTEMSK(0, REG_SC_BK01_61_L, 0x03);
        SC_W2BYTEMSK(1, REG_SC_BK01_61_L, u16value, 0x03); // copy main setting for HDMI Y422 color wrong when dual view on
#endif

        if (IS_OUTPUT_LINE_ALTERNATIVE())
        {   //Solution from HW RD cc.yang for fixing dual view sub window shaking problem
            u16value = SC_R2BYTEMSK(0, REG_SC_BK20_1A_L, 0x0FFF);//Get the delay line for Auto tune area
            SC_W2BYTEMSK(1, REG_SC_BK20_1A_L, u16value - 3, 0x0FFF);//(Value -3) is a empirical value given by cc.yang
            u16value = SC_R2BYTEMSK(0, REG_SC_BK20_1B_L, 0x0FFF);//Get the delay line for Display area
            SC_W2BYTEMSK(1, REG_SC_BK20_1B_L, u16value - 3,  0x0FFF);//(Value -3) is a empirical value given by cc.yang
        }

        if(SC_R2BYTEMSK(0, REG_SC_BK7F_11_L, BIT(1)) == BIT(1))//if miu arb or xc internel control miu
        {
            if(SC_R2BYTEMSK(1, REG_SC_BK12_05_L, BIT(4)) == BIT(4))//if sc1 opm seletect miu1
            {
                SC_W2BYTEMSK(0, REG_SC_BK12_44_L, BIT(14), BIT(14));
            }
            else
            {
                SC_W2BYTEMSK(0, REG_SC_BK12_44_L, 0, BIT(14));
            }
       }
    }
}
#endif

//#define GET_FB_LEVEL_DBG(x) //x
E_XC_FB_LEVEL MHal_XC_Get_FB_Level(void* pInstance, MS_WINDOW_TYPE* pstCropWin, MS_WINDOW_TYPE* pstDispWin, MS_BOOL bInterlace, MS_U16* pu16HSize, MS_U16* pu16VSize)
{
    return E_XC_FB_LEVEL_NUM;//default return E_XC_FB_LEVEL_NUM
}

MS_BOOL MHal_XC_CheckHDMIRepetition(void * pInstance)
{
    return TRUE;
}

MS_U32 Hal_SC_get_HDMIpolicy(void *UNUSED_PARA(pInstance))
{
    return 0;
}

E_APIXC_ReturnValue MHal_XC_Vtrack_SetAllPayloadData(void *pInstance, XC_VTRACK_PAYLOAD *vtrack_payload)
{

    return  E_APIXC_RET_OK;
}

E_APIXC_ReturnValue MHal_XC_Vtrack_SetVtrackKey(void *pInstance, MS_U64 u64VtrackKey)
{

    return  E_APIXC_RET_OK;
}

E_APIXC_ReturnValue Hal_SC_Enable_VE_BypassPath(void *pInstance, MS_BOOL bEnable)
{
    return E_APIXC_RET_FAIL_FUN_NOT_SUPPORT;
}

#ifdef CONFIG_UTOPIA_PROC_DBG_SUPPORT
static void _MHal_XCMdbloctl_Cat_OPTEE(void *pInstance, MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    XC_RESOURCE_PRIVATE_FOR_TEE* pXCResourcePrivateForTee = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivateForTee));

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Scaler OPTEE Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"OPTEE REE enable                   : %s\n", pXCResourcePrivate->sthal_Optee.op_tee_xc[MAIN_WINDOW].isEnable==TRUE?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"OPTEE TEE enable                   : %s\n", pXCResourcePrivateForTee->sthal_Optee.op_tee_xc[MAIN_WINDOW].isEnable==TRUE?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"OPTEE Buffer Address               : 0x%lx\n", pXCResourcePrivate->sthal_Optee.op_tee_xc[MAIN_WINDOW].drams_data[0].address);
    MdbPrint(paraGetInfo->u64ReqHdl,"OPTEE Buffer Length                : %x\n", pXCResourcePrivate->sthal_Optee.op_tee_xc[MAIN_WINDOW].drams_data[0].length);
}

static void _MHal_XCMdbloctl_Cat_3D(void *pInstance, MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Scaler 3D Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"3D input format                    : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"2D to 3D status                    : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Output timing                      : %d_%d_%d\n", pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width,
        pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height, pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16DefaultVFreq);
}
static void _MHal_XCMdbloctl_Cat_TGEN(void *pInstance, MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Scaler TGEN Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Hsync width                        : %d\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_01_L, 0xFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"Vsync position                     : (%d,%d)\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_02_L, 0x7FF)+(SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_02_L, 0x1000)>>1), SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_03_L, 0x1FFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"HDE position                       : (%d,%d)\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_04_L, 0x3FFF), SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_05_L, 0x3FFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"VDE position                       : (%d,%d)\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_06_L, 0x1FFF), SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_07_L, 0x1FFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"Vsync control mode                 : %s\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_05_L, 0x01)==0x00?"Auto":"Manual");
}
static void _MHal_XCMdbloctl_Cat_MOD(void *pInstance, MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Scaler MOD Info -----------------\n");

    MdbPrint(paraGetInfo->u64ReqHdl,"Output config                      : 0x%x, 0x%x\n", R2BYTE(0x111e00UL), R2BYTE(0x111e02UL));
    MdbPrint(paraGetInfo->u64ReqHdl,"Panel clock                        : %d\n", R2BYTEMSK(0x111e00UL, 0x1F));
    MdbPrint(paraGetInfo->u64ReqHdl,"Panel free swap                    : 0x%x, 0x%x, 0x%x, 0x%x\n", R2BYTE(0x103210UL), R2BYTE(0x103212UL), R2BYTE(0x103214UL), R2BYTE(0x103216UL));
    MdbPrint(paraGetInfo->u64ReqHdl,"VB1 lock status                    : %s\n", R2BYTEMSK(0x1032C2UL, BIT(14))==BIT(14)?"UNLOCK":"LOCK");
    MdbPrint(paraGetInfo->u64ReqHdl,"VB1 unlock count                   : %d\n", R2BYTEMSK(0x1032FCUL, 0x7F));
    MdbPrint(paraGetInfo->u64ReqHdl,"VB1 HPD status                     : %s\n", (R2BYTEMSK(0x1032FEUL, BIT(5)) == BIT(5)) ? "NOT Connected":"Connected");
    MdbPrint(paraGetInfo->u64ReqHdl,"VB1 LockN status                   : %s\n", (R2BYTEMSK(0x1032FEUL, BIT(4)) == BIT(4)) ? "UNLOCK":"LOCK");
}
static void _MHal_XCMdbloctl_Cat_HDR(void *pInstance, MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U32 u32address = 0;
    MS_U8 u8temp=0, u8sel = 0;
    XC_CFD_STATUS stCfdStatus;
    memset(&stCfdStatus, 0, sizeof(XC_CFD_STATUS));
    stCfdStatus.u32Version=CFD_STATUS_VERSION;
    stCfdStatus.u16Length=sizeof(XC_CFD_STATUS);
    stCfdStatus.u8Win=MAIN_WINDOW;

    XC_CFD_CONTROL_INFO stCfdCtrlInfo;
    memset(&stCfdCtrlInfo, 0, sizeof(XC_CFD_CONTROL_INFO));
    stCfdCtrlInfo.enCtrlType = E_XC_CFD_CTRL_TYPE_STATUS;
    stCfdCtrlInfo.pParam = &stCfdStatus;
    stCfdCtrlInfo.u32ParamLen = sizeof(XC_CFD_STATUS);
    MApi_XC_HDR_Control(E_XC_HDR_CTRL_CFD_CONTROL, &stCfdCtrlInfo);

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Scaler HDR Info -----------------\n");
    if(stCfdStatus.u8VideoHdrType == 0)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"HDR type                           : SDR\n");
    }
    else if(stCfdStatus.u8VideoHdrType == BIT(0))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"HDR type                           : Dolby HDR\n");
    }
    else if(stCfdStatus.u8VideoHdrType == BIT(1))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"HDR type                           : Open HDR\n");
    }
    else if(stCfdStatus.u8VideoHdrType == BIT(2))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"HDR type                           : TCH\n");
    }
    else if(stCfdStatus.u8VideoHdrType == BIT(3))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"HDR type                           : HLG\n");
    }

    if((stCfdStatus.u8VideoHdrType == BIT(1)) || (stCfdStatus.u8VideoHdrType == BIT(3)))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Input color range is               : %s\n", stCfdStatus.bIsFullRange==0?"limit range":"full range");

        if(pXCResourcePrivate->stdrvXC_Display._enInputSourceType == E_XC_INPUT_SOURCE_TYPE_HDMI)
        {
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Pixel format                 : %d\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.u8PixelFormat);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Colorimetry                  : %d\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.u8Colorimetry);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input ExtendedColorimetry          : %d\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.u8ExtendedColorimetry);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input HDR Info                     : %s exit\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.bHDRInfoFrameValid==0?"is not":"is");
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display Primaries_x[0]       : 0x%x\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.u16Display_Primaries_x[0]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display Primaries_x[1]       : 0x%x\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.u16Display_Primaries_x[1]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display Primaries_x[2]       : 0x%x\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.u16Display_Primaries_x[2]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display Primaries_y[0]       : 0x%x\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.u16Display_Primaries_y[0]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display Primaries_y[1]       : 0x%x\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.u16Display_Primaries_y[1]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display Primaries_y[2]       : 0x%x\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.u16Display_Primaries_y[2]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input White point_x                : 0x%x\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.u16White_point_x);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input White point_y                : 0x%x\n", stCfdStatus.HDRMetadata.stHdmiInfoCFD.u16White_point_y);
        }
        else if(pXCResourcePrivate->stdrvXC_Display._enInputSourceType == E_XC_INPUT_SOURCE_TYPE_OTT)
        {
            MdbPrint(paraGetInfo->u64ReqHdl,"Input format                       : %d\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u8InputFormat);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input data format                  : %d\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u8InputDataFormat);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input UVI                          : %s exit\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.bVUIValid==0?"is not":"is");
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Colour primaries             : %d\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u8Colour_primaries);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Transfer characteristics     : %d\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u8Transfer_Characteristics);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Matrix coeffs                : %d\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u8Matrix_Coeffs);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input SEI                          : %s exit\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.bSEIValid==0?"is not":"is");
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display primaries_x[0]       : 0x%x\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u16Display_Primaries_x[0]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display primaries_x[1]       : 0x%x\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u16Display_Primaries_x[1]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display primaries_x[2]       : 0x%x\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u16Display_Primaries_x[2]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display primaries_y[0]       : 0x%x\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u16Display_Primaries_y[0]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display primaries_y[1]       : 0x%x\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u16Display_Primaries_y[1]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Display primaries_y[2]       : 0x%x\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u16Display_Primaries_y[2]);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input White point_x                : 0x%x\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u16White_point_x);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input uWhite point_y               : 0x%x\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u16White_point_y);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Panel_Max_Luminance          : 0x%x\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u32Master_Panel_Max_Luminance);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input Panel_Min_Luminance          : 0x%x\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u32Master_Panel_Min_Luminance);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input ContentLightLevelEnabled     : %s exit\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.bContentLightLevelEnabled==0?"is not":"is");
            MdbPrint(paraGetInfo->u64ReqHdl,"Input MaxContentLightLevel         : %d\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u16maxContentLightLevel);
            MdbPrint(paraGetInfo->u64ReqHdl,"Input MaxPicAverageLightLevel      : %d\n", stCfdStatus.HDRMetadata.stHDRMemFormatCFD.u16maxPicAverageLightLevel);
        }
    }
    MdbPrint(paraGetInfo->u64ReqHdl,"TCH                                : %s\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK71_01_L, BIT(0))==BIT(0)?"On":"Off");
    MdbPrint(paraGetInfo->u64ReqHdl,"Gamma autodownload status          : %s\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK7A_01_L, BIT(3))==0?"On":"Off");
    MdbPrint(paraGetInfo->u64ReqHdl,"Degamma autodownload status        : %s\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK7A_01_L, BIT(5))==0?"On":"Off");
    MdbPrint(paraGetInfo->u64ReqHdl,"TMO autodownload status            : %s\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK7A_02_L, BIT(2))==0?"On":"Off");
    MdbPrint(paraGetInfo->u64ReqHdl,"3D LUT autodownload status         : %s\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK7A_02_L, BIT(4))==0?"On":"Off");
    u32address = (MS_U32)((SC_R2BYTE(MAIN_WINDOW,REG_SC_BK67_2A_L))<<16) | (MS_U32)(SC_R2BYTE(MAIN_WINDOW,REG_SC_BK67_29_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"autodownload address               : 0x%lx\n", u32address);
    _phy_to_miu_offset(u8sel, u8temp, u32address);
    MdbPrint(paraGetInfo->u64ReqHdl,"autodownload MIU number            : MIU%d\n", u8sel);
    MdbPrint(paraGetInfo->u64ReqHdl,"XC handshake status                : %s\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK02_10_L)==0x25?"Off":"On");
    MdbPrint(paraGetInfo->u64ReqHdl,"CRC status                         : %s\n", stCfdStatus.bCRCStatus==TRUE?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"R2Y status                         : %s\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK02_2B_L, BIT(4))==BIT(4)?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Y2R status                         : %s\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_2F_L, BIT(4))==BIT(4)?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"MM HDR vdec version number         : %d\n", stCfdStatus.u8VdecVersion);
    MdbPrint(paraGetInfo->u64ReqHdl,"Autodownload fail bit              : %s\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK67_28_L, BIT(0))==BIT(0)?"TRUE":"FALSE");
    //MdbPrint(paraGetInfo->u64ReqHdl,"Dolby Global dimming value         : \n");
    //MdbPrint(paraGetInfo->u64ReqHdl,"Dolby Global dimming delay count   : \n");
    MdbPrint(paraGetInfo->u64ReqHdl,"set_HDRDS_info average time        : %dms\n", stCfdStatus.u16SetDSAverageTime);
    MdbPrint(paraGetInfo->u64ReqHdl,"set_HDRDS_info peak time           : %dms (%d)\n", stCfdStatus.u16SetDSPeakTime, stCfdStatus.u64SetDSPeakFrame);
    MdbPrint(paraGetInfo->u64ReqHdl,"HDR HSize                          : %d\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK79_08_L, 0x1FFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"HDR VSize                          : %d\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK79_09_L, 0x1FFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"LSB/MSB                            : %s\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK79_06_L, BIT(8))==BIT(8)?"LSB":"MSB");
    if((SC_R2BYTE(MAIN_WINDOW,REG_SC_BK7A_42_L)==0) && (SC_R2BYTE(MAIN_WINDOW,REG_SC_BK7A_54_L)==0) && (SC_R2BYTE(MAIN_WINDOW,REG_SC_BK7A_55_L)==0) &&
        (SC_R2BYTE(MAIN_WINDOW,REG_SC_BK7A_59_L)==BIT(11)) && (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK02_10_L, BIT(4))==BIT(4)))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"HDR mute                           : TRUE\n");
    }
    else
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"HDR mute                           : FALSE\n");
    }
    MdbPrint(paraGetInfo->u64ReqHdl,"Dolby efuse status                 : FALSE\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Dolby HW bond status               : %s\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK79_3F_L, BIT(14))?"TRUE":"FALSE");
}
static void _MHal_XCMdbloctl_Cat_MEMC(void *pInstance, MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
#if(FRC_INSIDE == TRUE)
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Scaler MEMC Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"FRC enable                         : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"FRC enable_variable                : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"FRC MISC enable                    : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"FRC freeze                         : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"MEMC level                         : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"MEMC status                        : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"MEMC memory size(L)                : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"MEMC memory size(R)                : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"MEMC memory size(PQ)               : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"MEMC MIU number(L)                 : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"MEMC MIU number(R)                 : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"MEMC MIU number(PQ)                : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"MEMC dual miu                      : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"MEMC in/out frame rate             : NOT SUPPORTED\n");
#endif
    MdbPrint(paraGetInfo->u64ReqHdl,"FSC enable                         : NOT SUPPORTED\n");
}
static void _MHal_XCMdbloctl_Cat_FrameLock(void *pInstance, MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Scaler Frame Lock Info -----------------\n");
    if(MHal_XC_GetFrameLockStatus(pInstance) == TRUE)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Frame lock status                  : TRUE\n");
    }
    else
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Frame lock status                  : FALSE\n");
    }
    MdbPrint(paraGetInfo->u64ReqHdl,"H total                            : %d\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK10_0C_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"V total                            : %d\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK10_0D_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"Input frame rate                   : %d\n", gSrcInfo[MAIN_WINDOW].u16InputVFreq);
    MdbPrint(paraGetInfo->u64ReqHdl,"Output frame rate                  : %d\n", gSrcInfo[MAIN_WINDOW].Status2.u16OP1_OutputVFreqAfterFRC);
    MdbPrint(paraGetInfo->u64ReqHdl,"Lock ivs:ovs                       : %d:%d\n", R2BYTEMSK(0x103118UL,0x0F00)>>8, R2BYTEMSK(0x103118UL,0xF000)>>11);

    if (TGEN_VTT_LOCK_MODE_VER != E_TGEN_VTT_LOCK_MODE_NOT_SUPPORT)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Lock mode                          : VTT Variation mode\n");
    }
    else if(R2BYTEMSK(0x1031E0UL,BIT(15))==BIT(15))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Lock mode                          : lockvfreq\n");
    }
    else if(R2BYTEMSK(0x1031F0UL,BIT(12))==BIT(12))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Lock mode                          : ivs_ovs\n");
    }
    else if(R2BYTEMSK(0x1031FCUL,BIT(15))==BIT(15))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Lock mode                          : spread\n");
    }
    else
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Lock mode                          : lockphase\n");
    }

    MdbPrint(paraGetInfo->u64ReqHdl,"Phase offset limit                 : %x%x\n", R2BYTEMSK(0x103120UL,0x00FF), R2BYTEMSK(0x10311EUL,0xFFFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"Lock from IP                       : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK68_28_L,BIT(2))==BIT(2))?"FALSE":"TRUE");
    MdbPrint(paraGetInfo->u64ReqHdl,"XC Buffer in/out                   : %d:%d \n", gSrcInfo[MAIN_WINDOW].u16InputVFreq, gSrcInfo[MAIN_WINDOW].Status2.u16OutputVFreqAfterFRC);
}
static void _MHal_XCMdbloctl_Cat_SetWindow(void *pInstance, MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Scaler Setwindow Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Capture window                     : (%d,%d) %dx%d\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_05_L, 0x1FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_04_L, 0x1FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_07_L, 0x3FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_06_L, 0x1FFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"Crop window                        : (%d,%d) %dx%d\n", gSrcInfo[MAIN_WINDOW].stCropWin.x, gSrcInfo[MAIN_WINDOW].stCropWin.y, gSrcInfo[MAIN_WINDOW].stCropWin.width, gSrcInfo[MAIN_WINDOW].stCropWin.height);
    MdbPrint(paraGetInfo->u64ReqHdl,"Display window                     : (%d,%d) %dx%d\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_08_L, 0x3FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_0A_L, 0x1FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_09_L, 0x3FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_0B_L, 0x1FFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"Sub Capture window                 : (%d,%d) %dx%d\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK03_05_L, 0x1FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK03_04_L, 0x1FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK03_07_L, 0x3FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK03_06_L, 0x1FFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"Sub Crop window                    : (%d,%d) %dx%d\n", gSrcInfo[SUB_WINDOW].stCropWin.x, gSrcInfo[SUB_WINDOW].stCropWin.y, gSrcInfo[SUB_WINDOW].stCropWin.width, gSrcInfo[SUB_WINDOW].stCropWin.height);
    MdbPrint(paraGetInfo->u64ReqHdl,"Sub Display window                 : (%d,%d) %dx%d\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK0F_07_L, 0x3FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK0F_09_L, 0x1FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK0F_08_L, 0x3FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK0F_0A_L, 0x1FFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"Pre-H cus scaling                  : %s (%d->%d)\n", (gSrcInfo[MAIN_WINDOW].Status2.bPreHCusScaling==TRUE)?"TRUE":"FALSE", gSrcInfo[MAIN_WINDOW].Status2.u16PreHCusScalingSrc, gSrcInfo[MAIN_WINDOW].Status2.u16PreHCusScalingDst);
    MdbPrint(paraGetInfo->u64ReqHdl,"Pre-V cus scaling                  : %s (%d->%d)\n", (gSrcInfo[MAIN_WINDOW].Status2.bPreVCusScaling==TRUE)?"TRUE":"FALSE", gSrcInfo[MAIN_WINDOW].Status2.u16PreVCusScalingSrc, gSrcInfo[MAIN_WINDOW].Status2.u16PreVCusScalingDst);
    MdbPrint(paraGetInfo->u64ReqHdl,"Post-H cus scaling                 : %s (%d->%d)\n", (gSrcInfo[MAIN_WINDOW].bHCusScaling==TRUE)?"TRUE":"FALSE", gSrcInfo[MAIN_WINDOW].u16HCusScalingSrc, gSrcInfo[MAIN_WINDOW].u16HCusScalingDst);
    MdbPrint(paraGetInfo->u64ReqHdl,"Post-V cus scaling                 : %s (%d->%d)\n", (gSrcInfo[MAIN_WINDOW].bVCusScaling==TRUE)?"TRUE":"FALSE", gSrcInfo[MAIN_WINDOW].u16VCusScalingSrc, gSrcInfo[MAIN_WINDOW].u16VCusScalingDst);

    MdbPrint(paraGetInfo->u64ReqHdl,"2-steps scaling status             : %s\n", (MApi_XC_IsSupport2StepScaling()==TRUE)?"TRUE":"FALSE");

    MdbPrint(paraGetInfo->u64ReqHdl,"Input DE H size                    : %d\n", Hal_SC_ip_de_hend_info(pInstance, MAIN_WINDOW)-Hal_SC_ip_de_hstart_info(pInstance, MAIN_WINDOW)+1);
    MdbPrint(paraGetInfo->u64ReqHdl,"Input DE V size                    : %d\n", Hal_SC_ip_de_vend_info(pInstance, MAIN_WINDOW)-Hal_SC_ip_de_vstart_info(pInstance, MAIN_WINDOW)+1);
    MdbPrint(paraGetInfo->u64ReqHdl,"Scart CVBS/RGB setting             : %s\n", ((MDrv_ReadByte(0x10258B) & 0x50)==0x10)?"RGB":"CVBS");
    MdbPrint(paraGetInfo->u64ReqHdl,"FastBlanking Input                 : 0x%x\n",R2BYTEMSK(0x102580,0xF0)>>4);
    MdbPrint(paraGetInfo->u64ReqHdl,"Enable TCON Panel RGBW             : %s\n", (R2BYTEMSK(0x331020,BIT(0))?"TRUE":"FALSE"));
    MdbPrint(paraGetInfo->u64ReqHdl,"Enable Panel Gamma                 : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK24_6D_L,BIT(12))>>12?"TRUE":"FALSE"));
    MdbPrint(paraGetInfo->u64ReqHdl,"Enable PQ Gamma                    : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_50_L,BIT(0))?"TRUE":"FALSE"));
    MdbPrint(paraGetInfo->u64ReqHdl,"H Mirror mode                      : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_03_L,BIT(12))?"TRUE":"FALSE"));
    MdbPrint(paraGetInfo->u64ReqHdl,"V Mirror mode                      : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_03_L,BIT(13))?"TRUE":"FALSE"));
    MdbPrint(paraGetInfo->u64ReqHdl,"Display Trigger Pointer            :Auto tune area: %d Display area:%d \n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK20_1A_L, 0x0FFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK20_1B_L, 0x0FFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"ADC ISOG Mode                      : %s\n", (R2BYTEMSK(0x1025D8,BIT(12))==BIT(12))?"NORMAL MODE":"STANDBY MODE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaling Filter Status              : %x\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK23_0B_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler bob mode,                   : MAIN_WINDOW, %s\n", (((SC_R2BYTE(MAIN_WINDOW,REG_SC_BK22_78_L)&0xff)==0x8f) ? "TRUE" : "FALSE"));
    MdbPrint(paraGetInfo->u64ReqHdl,"IP2VE Control Setting              : Enable=%s ThroughPutRatio=%d:16\n", (SC_R2BYTEMSK(MAIN_WINDOW, REG_SC_BK4C_05_L,BIT(7))?"TRUE":"FALSE"),0);
    MdbPrint(paraGetInfo->u64ReqHdl,"Enable OP1 legacy mode                    : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK20_01_L,BIT(0))?"TRUE":"FALSE"));
    MdbPrint(paraGetInfo->u64ReqHdl,"Enable OPM 2p mode                        : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK20_01_L,BIT(1))?"TRUE":"FALSE"));
    MdbPrint(paraGetInfo->u64ReqHdl,"Precise Crop mode                  : Enable=%s\n", (MHal_XC_IsSupportDecimalCrop(pInstance)?"TRUE":"FALSE"));
    MdbPrint(paraGetInfo->u64ReqHdl,"gSrcInfo[MAIN_WINDOW].eFBLevel     : %d\n",MApi_XC_Get_FB_Level(MAIN_WINDOW));
}
static void _MHal_XCMdbloctl_Cat_ACE(void *pInstance, MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U16 u16HStart, u16HEnd, u16VStart, u16VEnd;

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Scaler ACE/DLC Info -----------------\n");
    if(MApi_XC_ACE_GetACEInfo != NULL)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Brightness_R                       : %d\n", MApi_XC_ACE_GetACEInfo(MAIN_WINDOW, E_XC_ACE_INFO_TYPE_BRIGHTNESS_R));
        MdbPrint(paraGetInfo->u64ReqHdl,"Brightness_G                       : %d\n", MApi_XC_ACE_GetACEInfo(MAIN_WINDOW, E_XC_ACE_INFO_TYPE_BRIGHTNESS_G));
        MdbPrint(paraGetInfo->u64ReqHdl,"Brightness_B                       : %d\n", MApi_XC_ACE_GetACEInfo(MAIN_WINDOW, E_XC_ACE_INFO_TYPE_BRIGHTNESS_B));
        MdbPrint(paraGetInfo->u64ReqHdl,"Contrast                           : %d\n", MApi_XC_ACE_GetACEInfo(MAIN_WINDOW, E_XC_ACE_INFO_TYPE_CONTRAST));
        MdbPrint(paraGetInfo->u64ReqHdl,"Saturation                         : %d\n", MApi_XC_ACE_GetACEInfo(MAIN_WINDOW, E_XC_ACE_INFO_TYPE_SATURATION));
        MdbPrint(paraGetInfo->u64ReqHdl,"Hue                                : %d\n", MApi_XC_ACE_GetACEInfo(MAIN_WINDOW, E_XC_ACE_INFO_TYPE_HUE));
    }
    MdbPrint(paraGetInfo->u64ReqHdl,"DLC status                         : %s\n", (R2BYTEMSK(0x141A08UL,BIT(7))==BIT(7))?"TRUE":"FALSE");
    u16HStart = SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK5C_04_L, 0x0FFF);
    u16HEnd = SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK5C_04_L, 0x0FFF)+1;
    u16VStart = (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK5C_04_L, 0x0FFF)+1)*8;
    u16VEnd = (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK5C_04_L, 0x0FFF)+1)*8/7;
    MdbPrint(paraGetInfo->u64ReqHdl,"DLC window                         : (%d,%d) %dx%d\n", u16HStart, u16VStart, u16HEnd-u16HStart, u16VEnd-u16VStart);
    MdbPrint(paraGetInfo->u64ReqHdl,"Histogram pixel number          : %lx\n",(( (MS_U32)SC_R2BYTE(MAIN_WINDOW,REG_SC_BK5C_0B_L) << 16 ) | (MS_U32)SC_R2BYTE(MAIN_WINDOW,REG_SC_BK5C_0A_L)));
    MdbPrint(paraGetInfo->u64ReqHdl,"Histogram total Y                  : %lx\n",(( (MS_U32)SC_R2BYTE(MAIN_WINDOW,REG_SC_BK5C_0D_L) << 16 ) | (MS_U32)SC_R2BYTE(MAIN_WINDOW,REG_SC_BK5C_0C_L)));
    MdbPrint(paraGetInfo->u64ReqHdl,"Maximun pixel                       : %x\n",(SC_R2BYTE(MAIN_WINDOW,REG_SC_BK5C_08_L) & 0x00FF));
    MdbPrint(paraGetInfo->u64ReqHdl,"Minimum pixel                        : %x\n",(SC_R2BYTE(MAIN_WINDOW,REG_SC_BK5C_09_L) & 0x00FF));
    MdbPrint(paraGetInfo->u64ReqHdl,"MinmaxCplxCount                  : %lx\n",(((MS_U32)SC_R2BYTE(MAIN_WINDOW,REG_SC_BK5C_51_L) << 16) | (MS_U32)SC_R2BYTE(MAIN_WINDOW,REG_SC_BK5C_50_L)));
   if(gSrcInfo[MAIN_WINDOW].bInterlace==TRUE)
   {
        if(SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK00_0A_L,BIT(3))==BIT(3))
        {
            MdbPrint(paraGetInfo->u64ReqHdl,"Film mode                          : Film22\n");
        }
        else if(SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK00_0A_L,BIT(4))==BIT(4))
        {
            MdbPrint(paraGetInfo->u64ReqHdl,"Film mode                           : Film32\n");
        }
        else if(SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK00_0A_L,BIT(6))==BIT(6))
        {
            MdbPrint(paraGetInfo->u64ReqHdl,"Film mode                           : Film any\n");
        }
        else
        {
            MdbPrint(paraGetInfo->u64ReqHdl,"Film mode                           :Please Check your setting\n");
        }
    }
}
static void _MHal_XCMdbloctl_Cat_DISP(void *pInstance, MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U32 u32address = 0;
    MS_U8 u8temp=0, u8sel = 0;

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar DISP In Out Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Window enable                      : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK20_10_L,BIT(0))==BIT(0))?"TRUE":"FALSE"); //main\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Mute enable                        : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_19_L, BIT(1))==BIT(1))?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Dip as pip not support                 \n");
    MdbPrint(paraGetInfo->u64ReqHdl,"SubWindow Mute enable              : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_19_L, BIT(5))==BIT(5))?"TRUE":"FALSE");
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler auto no signal status       : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_02_L, MAIN_WINDOW),BIT(7))==BIT(7))?"TRUE":"FALSE");
#else
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler auto no signal status       : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_02_L,BIT(7))==BIT(7))?"TRUE":"FALSE");
#endif
    //ForceP
    MdbPrint(paraGetInfo->u64ReqHdl,"ForceP enable(main window)         : %s\n", (gSrcInfo[MAIN_WINDOW].Status2.bEnable_ForceP)?"ON":"OFF");
    MdbPrint(paraGetInfo->u64ReqHdl,"SC0 IP MUX                         : %x\n", SC_R2BYTE(MAIN_WINDOW,REG_IPMUX_01_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"SC2 IP MUX                         : %x\n", SC_R2BYTE(MAIN_WINDOW,REG_IPMUX_61_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"BIT MASK                           : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK1F_07_L,BIT(15))==BIT(15))?"ON":"OFF");
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    MdbPrint(paraGetInfo->u64ReqHdl,"2P mode status                     : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_07_L, MAIN_WINDOW),BIT(15))==BIT(15))?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Sub 2P mode status                 : %s\n", (SC_R2BYTEMSK(SUB_WINDOW, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_07_L, SUB_WINDOW) , BIT(15))==BIT(15))?"TRUE":"FALSE");
#else
    MdbPrint(paraGetInfo->u64ReqHdl,"2P mode status                     : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_07_L,BIT(15))==BIT(15))?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Sub 2P mode status                 : %s\n", (SC_R2BYTEMSK(SUB_WINDOW, REG_SC_BK01_07_L , BIT(15))==BIT(15))?"TRUE":"FALSE");
#endif
    MdbPrint(paraGetInfo->u64ReqHdl,"HSK mode status                    : %s\n", (gSrcInfo[MAIN_WINDOW].Status2.bMVOPHSKMode==TRUE)?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Window type                        : Main Window\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Offline detect                     : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,0x257EUL,BIT(1))==0)?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Setwindow time                     : %dus\n", u32SetWindowTime);
    MdbPrint(paraGetInfo->u64ReqHdl,"Local dimming                      : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK2E_01_L,BIT(0))==BIT(0))?"TRUE":"FALSE");
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    MdbPrint(paraGetInfo->u64ReqHdl,"Disable input source               : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_02_L, MAIN_WINDOW),BIT(7))==BIT(7))?"TRUE":"FALSE");
#else
    MdbPrint(paraGetInfo->u64ReqHdl,"Disable input source               : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_02_L,BIT(7))==BIT(7))?"TRUE":"FALSE");
#endif

    if((pXCResourcePrivate->stdrvXC_MVideo.gu16HPixelShiftRange !=0) && (pXCResourcePrivate->stdrvXC_MVideo.gu16VPixelShiftRange !=0))
    {
       MdbPrint(paraGetInfo->u64ReqHdl,"Scaler PixelShift status           : TRUE H:%d V:%d\n",(int)pXCResourcePrivate->stdrvXC_MVideo.s8HPixelShift,(int)pXCResourcePrivate->stdrvXC_MVideo.s8VPixelShift);
    }
    else
    {
       MdbPrint(paraGetInfo->u64ReqHdl,"Scaler PixelShift status           : FALSE\n");
    }
    MdbPrint(paraGetInfo->u64ReqHdl,"MWE enable                        : %s\n", ((pXCResourcePrivate->bXCMWEStatus)?"TRUE":"FALSE"));
    MdbPrint(paraGetInfo->u64ReqHdl,"Customer str enable               : %s\n", ((pXCResourcePrivate->stdrvXC_MVideo_Context.g_bEnableCusSTR)?"TRUE":"FALSE"));
    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Output Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Output resolution                  : %d_%d_%d_P\n", gSrcInfo[MAIN_WINDOW].stDispWin.width, gSrcInfo[MAIN_WINDOW].stDispWin.height, gSrcInfo[MAIN_WINDOW].Status2.u16OP1_OutputVFreqAfterFRC);
    if((int)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type == (int)E_XC_PNL_LPLL_VBY1_10BIT_4LANE ||
        (int)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type == (int)E_XC_PNL_LPLL_VBY1_8BIT_4LANE)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Output type                        : VB1_4lane\n");
    }
    else if((int)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type == (int)E_XC_PNL_LPLL_VBY1_10BIT_8LANE ||
        (int)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type == (int)E_XC_PNL_LPLL_VBY1_8BIT_8LANE)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Output type                        : VB1_8lane\n");
    }
    else if((int)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type == (int)E_XC_PNL_LPLL_VBY1_10BIT_2LANE ||
        (int)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type == (int)E_XC_PNL_LPLL_VBY1_8BIT_2LANE)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Output type                        : VB1_2lane\n");
    }
    else if((int)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type == (int)E_XC_PNL_LPLL_LVDS)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Output type                        : LVDS\n");
    }
    MdbPrint(paraGetInfo->u64ReqHdl,"Display size                       : %d_%d\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK10_09_L)-SC_R2BYTE(MAIN_WINDOW,REG_SC_BK10_08_L)+1,
    SC_R2BYTE(MAIN_WINDOW, REG_SC_BK10_0B_L)-SC_R2BYTE(MAIN_WINDOW, REG_SC_BK10_0A_L)+1);

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Input Info -----------------\n");
    if(IsSrcTypeHDMI(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Input source type                  : HDMI\n");
    }
    else if(IsSrcTypeATV(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Input source type                  : ATV\n");
    }
    else if(IsSrcTypeDTV(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Input source type                  : DTV\n");
    }
    else if(IsSrcTypeStorage(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Input source type                  : MM\n");
    }
    else if(IsSrcTypeVga(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Input source type                  : VGA\n");
    }
    else if(IsSrcTypeYPbPr(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Input source type                  : YPBPR\n");
    }
    else if(IsSrcTypeDigitalVD(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Input source type                  : VD\n");
    }
    else
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Input source type                  : NA\n");
    }

    MdbPrint(paraGetInfo->u64ReqHdl,"Source resolution                  : %d_%d_%d_%c\n", gSrcInfo[MAIN_WINDOW].stCapWin.width, gSrcInfo[MAIN_WINDOW].stCapWin.height
        , gSrcInfo[MAIN_WINDOW].u16InputVFreq, (gSrcInfo[MAIN_WINDOW].bInterlace==TRUE)?'I':'P');
    MdbPrint(paraGetInfo->u64ReqHdl,"Input I/P mode status              : %s\n", (gSrcInfo[MAIN_WINDOW].bInterlace==TRUE)?"Interlace":"Progressive");

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Memory Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Memory color space                 : %s\n", (gSrcInfo[MAIN_WINDOW].bUseYUVSpace==TRUE)?"YUV":"RGB");

     if(gSrcInfo[MAIN_WINDOW].Status2.eMirrorMode == MIRROR_NORMAL)
    {
         MdbPrint(paraGetInfo->u64ReqHdl,"Mirror mode                        : FALSE\n");
    }
    else if(gSrcInfo[MAIN_WINDOW].Status2.eMirrorMode == MIRROR_H_ONLY)
    {
         MdbPrint(paraGetInfo->u64ReqHdl,"Mirror mode                        : H-Mirror\n");
    }
    else if(gSrcInfo[MAIN_WINDOW].Status2.eMirrorMode == MIRROR_V_ONLY)
    {
         MdbPrint(paraGetInfo->u64ReqHdl,"Mirror mode                        : V-Mirror\n");
    }
    else if(gSrcInfo[MAIN_WINDOW].Status2.eMirrorMode == MIRROR_HV)
    {
         MdbPrint(paraGetInfo->u64ReqHdl,"Mirror mode                        : HV-Mirror\n");
    }
    else
    {
         MdbPrint(paraGetInfo->u64ReqHdl,"Mirror mode                        : Not Support\n");
    }

    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler dual miu                    : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK11_29_L,BIT(15))==BIT(15))?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler BWD                         : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK46_01_L, 0xFFFF) != 0)?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"BWD_IPR420_VLEN                    : %d\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK46_36_L,0x1FFF));
#if (XC_SUPPORT_CMA == TRUE)
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler CMA                         : TRUE\n");
#else
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler CMA                         : FALSE\n");
#endif
    MdbPrint(paraGetInfo->u64ReqHdl,"Field array                        : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK11_07_L,BIT(12))==BIT(12))?"ON":"OFF");
    MdbPrint(paraGetInfo->u64ReqHdl,"Field direct mode                  : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK02_10_L,BIT(5))==BIT(5))?"ON":"OFF");

    //BWS:
    char BWSType[20] = {0};

    if(SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK08_01_L,BIT(0)) == 1)
    {
        strcpy(BWSType,"OFF");
    }
    else
    {
        if(SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK08_10_L,BIT(0)) == 1)
        {
              strcpy(BWSType,"8BIT");
        }
        else
        {
              strcpy(BWSType,"6BIT");
        }
    }
    MdbPrint(paraGetInfo->u64ReqHdl,"BWS         : %s\n", BWSType);
    MdbPrint(paraGetInfo->u64ReqHdl,"Freeze                             : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_01_L,BIT(11))==BIT(11))?"TRUE":"FALSE");
#ifdef UFO_XC_FB_LEVEL
    if((MDrv_XC_IsFBL(gSrcInfo[MAIN_WINDOW].eFBLevel))||(MDrv_XC_IsRFBL(gSrcInfo[MAIN_WINDOW].eFBLevel)))
#else
    if(gSrcInfo[MAIN_WINDOW].bFBL == TRUE || gSrcInfo[MAIN_WINDOW].bR_FBL == TRUE)
#endif
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"RFBL/FBL                           : TRUE\n");
    }
    else
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"RFBL/FBL                           : FALSE\n");
    }
#if defined (__aarch64__)
    MdbPrint(paraGetInfo->u64ReqHdl,"Memory size                        : %x\n", pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Main_FB_Size);
#else
    MdbPrint(paraGetInfo->u64ReqHdl,"Memory size                        : %tx\n", (ptrdiff_t)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Main_FB_Size);
#endif
#ifndef DONT_USE_CMA
#if(XC_SUPPORT_CMA ==TRUE)
     if (gSrcInfo[MAIN_WINDOW].Status2.stXCConfigCMA[CMA_XC_SELF_MEM].u32HeapID != XC_INVALID_HEAP_ID)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"XC_CMA_Self                        : Start:0x%x Size:0x%x @ MIU%d   use for SCMI0 \n",CMA_Pool_Init_PARAM[CMA_XC_SELF_MEM].heap_miu_start_offset,gSrcInfo[MAIN_WINDOW].u32PreCMAMemSCMSize[CMA_XC_SELF_MEM],CMA_Pool_Init_PARAM[CMA_XC_SELF_MEM].miu);
    }
    if (gSrcInfo[MAIN_WINDOW].Status2.stXCConfigCMA[CMA_XC_COBUFF_MEM].u32HeapID != XC_INVALID_HEAP_ID)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"XC_CMA_Cobuffer                    : Start:0x%x Size:0x%x @ MIU%d  use for SCMI1 \n",CMA_Pool_Init_PARAM[CMA_XC_COBUFF_MEM].heap_miu_start_offset,gSrcInfo[MAIN_WINDOW].u32PreCMAMemSCMSize[CMA_XC_COBUFF_MEM],CMA_Pool_Init_PARAM[CMA_XC_COBUFF_MEM].miu);
    }
#if (XC_SUPPORT_HDR_DMA_CMA == TRUE)
    if (gSrcInfo[MAIN_WINDOW].Status2.stXCConfigCMA[CMA_XC_HDR_DMA_MEM].u32HeapID != XC_INVALID_HEAP_ID)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"CMA_XC_HDR_DMA_MEM                    : Start:0x%x Size:0x%x @ MIU%d  use for SCMI1 \n",CMA_Pool_Init_PARAM[CMA_XC_HDR_DMA_MEM].heap_miu_start_offset,pXCResourcePrivate->stdrvXC_MVideo.u32PreCMAHDMIDMASize,CMA_Pool_Init_PARAM[CMA_XC_HDR_DMA_MEM].miu);
    }
#endif
    if(pXCResourcePrivate->stdrvXC_Scaling._au32PreFBSize[MAIN_WINDOW] != 0)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"XC using buffer                        : Start:0x%x Size:0x%x \n",pXCResourcePrivate->stdrvXC_Scaling._au32PreFBAddress[MAIN_WINDOW],gSrcInfo[MAIN_WINDOW].u32PreCMAMemSCMSize[CMA_XC_SELF_MEM],pXCResourcePrivate->stdrvXC_Scaling._au32PreFBSize[MAIN_WINDOW]);
    }
    if(gSrcInfo[MAIN_WINDOW].Status2.u32PreCMAMemDualSCMSize != 0)
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Dual XC using buffer                 : Start:0x%x Size:0x%x \n",pXCResourcePrivate->stdrvXC_Scaling._u32PreDualFBAddress[MAIN_WINDOW],gSrcInfo[MAIN_WINDOW].Status2.u32PreCMAMemDualSCMSize);
    }
    MdbPrint(paraGetInfo->u64ReqHdl,"Get CMA Addr use time              : %d\n",pXCResourcePrivate->stdrvXC_MVideo.u32CMATimeDiff);
#else
    MdbPrint(paraGetInfo->u64ReqHdl,"XC_CMA_Self                        : NOT SUPPORTED\n ");
    MdbPrint(paraGetInfo->u64ReqHdl,"XC_CMA_Cobuffer                    : NOT SUPPORTED\n ");
#endif
#else
    MdbPrint(paraGetInfo->u64ReqHdl,"XC_CMA_Self                        : NOT SUPPORTED\n ");
    MdbPrint(paraGetInfo->u64ReqHdl,"XC_CMA_Cobuffer                    : NOT SUPPORTED\n ");
#endif
    MdbPrint(paraGetInfo->u64ReqHdl,"Frame count                        : %d\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_19_L, 0x000F));
    MdbPrint(paraGetInfo->u64ReqHdl,"RW diff count                      : %d\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_07_L, 0xE000)>>13));
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler MIU number                  : MIU%d\n", u8sel);
    MdbPrint(paraGetInfo->u64ReqHdl,"Memory IPM address                 : 0x%lx\n", u32address);
    u32address = (MS_U32)((SC_R2BYTE(MAIN_WINDOW,REG_SC_BK12_11_L))<<16) | (MS_U32)(SC_R2BYTE(MAIN_WINDOW,REG_SC_BK12_10_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"Memory OPM address                 : 0x%lx\n", u32address);
    MdbPrint(paraGetInfo->u64ReqHdl,"IPM Offset                         : %d\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK12_0E_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"IPM Fetch                          : %d\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK12_0F_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"OPM Offset                         : %d\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK12_16_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"OPM Fetch                          : %d\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK12_17_L));
#ifdef UFO_XC_SUPPORT_DUAL_MIU
    SC_MIUSEL_t stMIUSel;
    memset(&stMIUSel, 0, sizeof(SC_MIUSEL_t));
    u32address = (MS_U32)((SC_R2BYTE(MAIN_WINDOW,REG_SC_BK52_09_L))<<16) | (MS_U32)(SC_R2BYTE(MAIN_WINDOW,REG_SC_BK52_08_L));
    _phy_to_miu_offset(u8sel, u8temp, u32address);
    Hal_SC_get_dual_miusel(pInstance,&stMIUSel);
    u8sel = stMIUSel.u8MainFBSel;
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler Dual MIU number             : MIU%d\n", u8sel);
    MdbPrint(paraGetInfo->u64ReqHdl,"Dual Memory IPM address            : 0x%lx\n", u32address);
    u32address = (MS_U32)((SC_R2BYTE(MAIN_WINDOW,REG_SC_BK52_11_L))<<16) | (MS_U32)(SC_R2BYTE(MAIN_WINDOW,REG_SC_BK52_10_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"Dual Memory OPM address            : 0x%lx\n", u32address);
    MdbPrint(paraGetInfo->u64ReqHdl,"Dual IPM Offset                    : %d\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK52_0E_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"Dual IPM Fetch                     : %d\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK52_0F_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"Dual OPM Offset                    : %d\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK52_16_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"DUal OPM Fetch                     : %d\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK52_17_L));
#else
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler Dual MIU number             : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Dual Memory IPM address            : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Dual Memory OPM address            : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Dual IPM Offset                    : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Dual IPM Fetch                     : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Dual OPM Offset                    : NOT SUPPORTED\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"DUal OPM Fetch                     : NOT SUPPORTED\n");
#endif
#if (XC_SUPPORT_IOMMU == TRUE)
    MdbPrint(paraGetInfo->u64ReqHdl,"Get MMA Addr use time              : %d\n",pXCResourcePrivate->stdrvXC_MVideo.u32MMATimeDiff);
    MdbPrint(paraGetInfo->u64ReqHdl,"aphyXCMMABaseAddress               : 0x%llx\n",pXCResourcePrivate->stdrvXC_MVideo.aphyXCMMABaseAddress[MAIN_WINDOW]);
    MdbPrint(paraGetInfo->u64ReqHdl,"phyHDMIDMAMMABaseAddress           : 0x%llx\n",pXCResourcePrivate->stdrvXC_MVideo.phyHDMIDMAMMABaseAddress);
    MdbPrint(paraGetInfo->u64ReqHdl,"phyFRCLeftMMABaseAddress           : 0x%llx\n",pXCResourcePrivate->stdrvXC_MVideo.phyFRCLeftMMABaseAddress);
    MdbPrint(paraGetInfo->u64ReqHdl,"phyFRCRightMMABaseAddress          : 0x%llx\n",pXCResourcePrivate->stdrvXC_MVideo.phyFRCRightMMABaseAddress);
    MdbPrint(paraGetInfo->u64ReqHdl,"phyFRCPQMMABaseAddress             : 0x%llx\n",pXCResourcePrivate->stdrvXC_MVideo.phyFRCPQMMABaseAddress);
#endif

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Dynamic Scaling Info -----------------\n");
#ifdef XC_DS_VERSION
    MdbPrint(paraGetInfo->u64ReqHdl,"DS version                         : %d\n", XC_DS_VERSION);
#endif
    MdbPrint(paraGetInfo->u64ReqHdl,"DS status                          : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK1F_10_L,BIT(9))==BIT(9) && SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK1F_10_L,BIT(11))==BIT(11))?"TRUE":"FALSE");
    u32address = (MS_U32)((SC_R2BYTE(MAIN_WINDOW,REG_SC_BK1F_12_L))<<16) | (MS_U32)(SC_R2BYTE(MAIN_WINDOW,REG_SC_BK1F_11_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"DS address                         : 0x%lx\n", u32address);
    _phy_to_miu_offset(u8sel, u8temp, pXCResourcePrivate->sthal_SC.u32DynamicScalingBaseAddr);
    MdbPrint(paraGetInfo->u64ReqHdl,"DS MIU number                      : MIU%d\n", u8sel);
    MdbPrint(paraGetInfo->u64ReqHdl,"DS MIU from register              : MIU%d\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK1F_10_L, BIT(13))>>13);
    MdbPrint(paraGetInfo->u64ReqHdl,"DS buffer size                     : 0x%x\n", pXCResourcePrivate->sthal_SC.u32DynamicScalingBufSize);
    u32address = (MS_U32)((SC_R2BYTE(MAIN_WINDOW,REG_SC_BK1F_0F_L))<<16) | (MS_U32)(SC_R2BYTE(MAIN_WINDOW,REG_SC_BK1F_0E_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"DS OP address                      : 0x%lx\n", u32address);
    MdbPrint(paraGetInfo->u64ReqHdl,"DS depth                           : %d\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK1F_13_L, 0x00FF));
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM DS address                     : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM DS depth                       : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"FRC DS IP address                  : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"FRC DS OP address                  : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"FRC DS depth                       : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"MVOP Crop(x:0x%x y:0x%x width:0x%x height:0x%x)\n", R2BYTE(0x101480), R2BYTE(0x101482), R2BYTE(0x101484), R2BYTE(0x101486));
    //DS toggle CMD
    MdbPrint(paraGetInfo->u64ReqHdl,"DS toggle CMD                      : 0x%x\n", SC_R2BYTE(MAIN_WINDOW,REG_SC_BK1F_17_L));
    // Get DS Info
    XC_GET_DS_INFO stGetDSInfo;
    MApi_XC_GetDSInfo(&stGetDSInfo, sizeof(XC_GET_DS_INFO), MAIN_WINDOW);
    MdbPrint(paraGetInfo->u64ReqHdl,"DynamicScalingEnable(main)         : %d\n", stGetDSInfo.bDynamicScalingEnable);
    MdbPrint(paraGetInfo->u64ReqHdl,"bUpdate_DS_CMD(main)               : %d\n", stGetDSInfo.bUpdate_DS_CMD);
    MApi_XC_GetDSInfo(&stGetDSInfo, sizeof(XC_GET_DS_INFO), SUB_WINDOW);
    MdbPrint(paraGetInfo->u64ReqHdl,"DynamicScalingEnable(sub)          : %d\n", stGetDSInfo.bDynamicScalingEnable);
    MdbPrint(paraGetInfo->u64ReqHdl,"bUpdate_DS_CMD(sub)                : %d\n", stGetDSInfo.bUpdate_DS_CMD);
    MdbPrint(paraGetInfo->u64ReqHdl,"Main DS get Index from             : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK1F_13_L,BIT(9))==BIT(9))?"sub":"main");
    MdbPrint(paraGetInfo->u64ReqHdl,"Sub DS get Index from              : %s\n", (SC_R2BYTEMSK(SUB_WINDOW,REG_SC_BK1F_13_L,BIT(9))==BIT(9))?"sub":"main");

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar Menuload Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Menuload status                    : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK1F_02_L,BIT(15))==BIT(15))?"TRUE":"FALSE");
    u32address = (MS_U32)((SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK1F_04_L, 0x3FF))<<16) | (MS_U32)(SC_R2BYTE(MAIN_WINDOW,REG_SC_BK1F_03_L));
    MdbPrint(paraGetInfo->u64ReqHdl,"Menuload address                   : 0x%lx\n", u32address);
    _phy_to_miu_offset(u8sel, u8temp, u32address);
    MdbPrint(paraGetInfo->u64ReqHdl,"Menuload MIU number                : MIU%d\n", u8sel);
    if(SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK1F_1D_L,BIT(12))==BIT(12))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Menuload trigger mode from         : IP\n" );
    }
    else
    {
        if(SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK68_5F_L,BIT(15))==BIT(15))
        {
            MdbPrint(paraGetInfo->u64ReqHdl,"Menuload trigger mode from         : OP2\n" );
        }
        else
        {
            MdbPrint(paraGetInfo->u64ReqHdl,"Menuload trigger mode from         : OP1\n" );
        }
    }
    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar IRQ Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler IRQ status (Bit 4)          : %s (OP Vsync)\n", (SC_R2BYTEMSK(MAIN_WINDOW,INTERRUPT_MASK_L,BIT(4))==BIT(4))?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler IRQ status (Bit 11)         : %s (IP1 Vsync)\n", (SC_R2BYTEMSK(MAIN_WINDOW,INTERRUPT_MASK_L,BIT(11))==BIT(11))?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler IRQ status (Bit 21)         : %s (HDR DMA)\n", (SC_R2BYTEMSK(MAIN_WINDOW,INTERRUPT_MASK_H,BIT(5))==BIT(5))?"TRUE":"FALSE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Scaler IRQ status (Bit 22)         : %s (HDR Descramble)\n", (SC_R2BYTEMSK(MAIN_WINDOW,INTERRUPT_MASK_H,BIT(6))==BIT(6))?"TRUE":"FALSE");

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar CSC Info -----------------\n");
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    MdbPrint(paraGetInfo->u64ReqHdl,"IP1 444 to 422                     : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_61_L, MAIN_WINDOW),BIT(0))==BIT(0))?"ON":"BYPASS");
#else
    MdbPrint(paraGetInfo->u64ReqHdl,"IP1 444 to 422                     : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_61_L,BIT(0))==BIT(0))?"ON":"BYPASS");
#endif
    MdbPrint(paraGetInfo->u64ReqHdl,"IP2 444 to 422                     : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK02_0F_L,BIT(4))==BIT(4))?"ON":"BYPASS");
    MdbPrint(paraGetInfo->u64ReqHdl,"HDR 444 to 422                     : %s\n", ((SC_R2BYTE(MAIN_WINDOW,REG_SC_BK7A_01_L)>>12)==BIT(3))?"ON":"BYPASS");
    MdbPrint(paraGetInfo->u64ReqHdl,"HDMI 444 to 422                    : %s\n", (R2BYTEMSK(0x173140, BIT(0))==0)?"ON":"BYPASS");

    MdbPrint(paraGetInfo->u64ReqHdl,"VOP Color matrix                   : %x %x %x\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_26_L,0xFFFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_27_L,0xFFFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_28_L,0xFFFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"                                   : %x %x %x\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_29_L,0xFFFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_2A_L,0xFFFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_2B_L,0xFFFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"                                   : %x %x %x\n", SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_2C_L,0xFFFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_2D_L,0xFFFF),SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_2E_L,0xFFFF));
    MdbPrint(paraGetInfo->u64ReqHdl,"OP write                        : %s\n", (SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_27_L,BIT(0))==BIT(0))?"DISABLE":"ENABLE");
    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar DNR Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"DNR                                              : %d\n",SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK06_21_L,0x0003));
    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar OPB Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"OPB Vlen                    : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"OPB Fetch                   : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar ZNR Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Support ZNR                 : %s\n", (MHal_XC_IsSupportZNR())?"Support":"Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ZNR enable                  : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ZNR RBank shift             : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ZNR ME H avg mode enable    : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ZNR ME V avg mode enable    : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar UCM Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM frame number            : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM R/W diff                : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM bit per pixel           : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM Frame 0 base address    : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM Frame 1 base address    : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM Frame 2 base address    : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM Frame 3 base address    : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM Frame 4 base address    : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM Frame 5 base address    : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM Frame 6 base address    : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM Frame 7 base address    : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM IPM offset              : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"UCM OPM offset              : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  Mstar ABF Info -----------------\n");
    MdbPrint(paraGetInfo->u64ReqHdl,"Support ABF                       : %s\n", (MHal_XC_IsSupportABF())?"Support":"Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ABF enable                        : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ABF source select from DNR        : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ABF line buffer user mode enable  : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ABF H line buffer size            : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ABF V line buffer size            : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ABF CTUR1 init factor V           : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ABF CTUR2 init factor V           : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ABF CTUR1 block size              : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ABF CTUR2 block size              : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ABF V mirror enable               : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"ABF H mirror enable               : %s\n", "Not support");
    MdbPrint(paraGetInfo->u64ReqHdl,"XC_8ALIGN_PATCH                       : %s\n",(XC_H8ALIGN_PATCH == TRUE || XC_V8ALIGN_PATCH == TRUE)?"ENABLE":"DISABLE");
    MdbPrint(paraGetInfo->u64ReqHdl,"Bandwidth SCMI level setting enable   : %s\n", (SC_EXT_R2BYTEMSK(MAIN_WINDOW,REG_SC_EXT_BK0F_01_L,BIT(0)))?"TRUE":"FALSE");
}

static void _MHal_XCMdbloctl_Cat_FSS(void *pInstance, MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MdbPrint(paraGetInfo->u64ReqHdl,"----------------  MTK Scaler FSS Info -----------------\n");

    if(IsSrcTypeYPbPr(gSrcInfo[MAIN_WINDOW].enInputSourceType) || IsSrcTypeHDMI(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        MdbPrint(paraGetInfo->u64ReqHdl,"Source change time                 : %lld ns\n", gSrcInfo[MAIN_WINDOW].s64SrcChgTime);
        if(gSrcInfo[MAIN_WINDOW].bIsSrcChgTimeReasonable)
        {
            MdbPrint(paraGetInfo->u64ReqHdl,"Source change threshold            : Pass\n");
        }
        else
        {
            MdbPrint(paraGetInfo->u64ReqHdl,"Source change threshold            : Fail\n");
        }
    }
}

void _XCMdbloctl_TestPattern(void *pInstance, MS_U8 u8IP, MS_BOOL bEnable, MS_U8 u8window, MS_U16 BValue, MS_U16 GValue, MS_U16 RValue)
{
#ifdef UFO_XC_TEST_PATTERN
    UNUSED(pInstance);
    if(u8IP == 0)
    {
        XC_SET_IPMUX_TESTPATTERN_t ipmux_test_pattern;
        ipmux_test_pattern.bEnable = bEnable;
        ipmux_test_pattern.u16R_CR_Data = RValue;
        ipmux_test_pattern.u16G_Y_Data  = GValue;
        ipmux_test_pattern.u16B_CB_Data = BValue;
        MApi_XC_GenerateTestPattern(E_XC_IPMUX_PATTERN_MODE,(void *)&ipmux_test_pattern,sizeof(XC_SET_IPMUX_TESTPATTERN_t));
    }
    else if(u8IP == 1)
    {
        XC_SET_IP1_TESTPATTERN_t ip1_test_pattern;
        ip1_test_pattern.u16Enable = bEnable;
        ip1_test_pattern.u32Pattern_type = 32;
        ip1_test_pattern.eWindow = (u8window==0)?MAIN_WINDOW:SUB_WINDOW;
        MApi_XC_GenerateTestPattern(E_XC_IP1_PATTERN_MODE,(void*)&ip1_test_pattern,sizeof(XC_SET_IP1_TESTPATTERN_t));
    }
    else if(u8IP == 2)
    {
        XC_SET_OP_TESTPATTERN_t op_test_pattern;
        op_test_pattern.bMiuLineBuff = bEnable;
        op_test_pattern.bLineBuffHVSP = FALSE;
        MApi_XC_GenerateTestPattern(E_XC_OP_PATTERN_MODE,(void*)&op_test_pattern,sizeof(XC_SET_OP_TESTPATTERN_t));
    }
    else if(u8IP == 3)
    {
        XC_SET_OP_TESTPATTERN_t op_test_pattern;
        op_test_pattern.bMiuLineBuff = FALSE;
        op_test_pattern.bLineBuffHVSP = bEnable;
        MApi_XC_GenerateTestPattern(E_XC_OP_PATTERN_MODE,(void*)&op_test_pattern,sizeof(XC_SET_OP_TESTPATTERN_t));
    }
    else if(u8IP == 5)
    {
        XC_SET_VOP_TESTPATTERN_t vop_test_pattern;
        vop_test_pattern.bEnable = bEnable;
        MApi_XC_GenerateTestPattern(E_XC_VOP_PATTERN_MODE,(void*)&vop_test_pattern,sizeof(XC_SET_VOP_TESTPATTERN_t));
    }
    else if(u8IP == 4)
    {
        XC_SET_VOP2_TESTPATTERN_t vop2_test_pattern;
        vop2_test_pattern.bEnable = bEnable;
        vop2_test_pattern.u16B_CB_Data = BValue;
        vop2_test_pattern.u16G_Y_Data= GValue;
        vop2_test_pattern.u16R_CR_Data= RValue;
        MApi_XC_GenerateTestPattern(E_XC_VOP2_PATTERN_MODE,(void*)&vop2_test_pattern,sizeof(XC_SET_VOP2_TESTPATTERN_t));
    }
    else if(u8IP == 6)
    {
        XC_SET_MOD_TESTPATTERN_t mod_test_pattern;
        mod_test_pattern.bEnable = bEnable;
        mod_test_pattern.u16B_CB_Data = BValue;
        mod_test_pattern.u16G_Y_Data= GValue;
        mod_test_pattern.u16R_CR_Data= RValue;
        MApi_XC_GenerateTestPattern(E_XC_MOD_PATTERN_MODE,(void*)&mod_test_pattern,sizeof(XC_SET_MOD_TESTPATTERN_t));
    }
    else if(u8IP == 7)
    {
        XC_SET_IP2_TESTPATTERN_t ip2_test_pattern;
        ip2_test_pattern.u32Version = ST_XC_SET_IP2_TESTPATTERN_VERSION;
        ip2_test_pattern.u32Length = sizeof(XC_SET_IP2_TESTPATTERN_t);
        ip2_test_pattern.bEnable = bEnable;
        ip2_test_pattern.u8Backend = u8window; // 3rd parameter, this is not for main/sub window, this is for ip2 front/back end
        ip2_test_pattern.u16Hde = BValue; // 4th parameter, this is not for B value, this is for user defined HDE
        ip2_test_pattern.u16Vde = GValue; // 5th parameter, this is not for G value, this is for user defined VDE
        MApi_XC_GenerateTestPattern(E_XC_IP2_PATTERN_MODE,(void*)&ip2_test_pattern,sizeof(XC_SET_IP2_TESTPATTERN_t));
    }
#endif
}
static void _MHal_XCMdbIoctl_EchoCmd(void *pInstance, MDBCMD_CMDLINE_PARAMETER *paraCmdLine)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    char pch[] = " =\n\r";
    char pchend[] = "\n\r";
    char *pcCmdLine = paraCmdLine->pcCmdLine;
    char *pcCmdLineString = paraCmdLine->pcCmdLine;
    char* psep;
    char* pstring;

    pstring = strsep(&pcCmdLineString, pchend);
    if(strcmp("Frame Lock Status", pstring) == 0)
    {
        if(MHal_XC_GetFrameLockStatus(pInstance) == TRUE)
        {
            MdbPrint(paraCmdLine->u64ReqHdl,"Frame lock status                 : TURE\n");
        }
        else
        {
            MdbPrint(paraCmdLine->u64ReqHdl,"Frame lock status                 : FALSE\n");
        }
    }

    psep = strsep(&pcCmdLine,pch);

    if(strcmp("pattern", psep) == 0)
    {
        MS_U8 u8window;
        MS_BOOL bEnable;
        MS_U16 RValue, GValue, BValue;
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        gu8PatternIP = (MS_U8)atoi(psep);

        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        bEnable = (MS_BOOL)atoi(psep);

        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        u8window = (MS_U8)atoi(psep);

        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            _XCMdbloctl_TestPattern(pInstance, gu8PatternIP, bEnable, u8window, 0, 0, 0);
            return;
        }
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        BValue = (MS_U16)atoi(psep);
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        GValue = (MS_U16)atoi(psep);
        psep = strsep(&pcCmdLine,pch);

        if(psep == NULL)       //ex:echo pattern=7 enable=1 window=0 B=0 G=0 >  /proc/utopia_mdb/xc
        {
            gbStrPatternEnable = FALSE;
            if(gu8PatternIP == 7) //IP2 pattern, allow user giving only 2 parameters instead of 3 parameters
            {
                RValue = 0;
            }
            else
            {
                return;
            }
        }
        else if(strcmp("str", psep) == 0)
        {
            if(gu8PatternIP == 7)
            {
                RValue = 0;
            }
            else
            {
                return;
            }

            psep = strsep(&pcCmdLine,pch);
            if(strcmp("ON", psep) == 0)  //ex:echo pattern=7 enable=1 window=0 B=0 G=0 str=ON >  /proc/utopia_mdb/xc
            {
                gbStrPatternEnable = TRUE;
            }
            else
            {
                gbStrPatternEnable = FALSE;
            }
        }
        else
        {
            psep = strsep(&pcCmdLine,pch);
            if(psep == NULL)
            {
                return;
            }
            RValue = (MS_U16)atoi(psep);

            psep = strsep(&pcCmdLine,pch);
            if(psep == NULL)    //ex:echo pattern=3 enable=1 window=0 B=0 G=0 R=0 >  /proc/utopia_mdb/xc
            {
                gbStrPatternEnable = FALSE;
            }
            else if(strcmp("str", psep) == 0)  //ex:echo pattern=3 enable=1 window=0 B=0 G=0 R=0 str=ON >  /proc/utopia_mdb/xc
            {
                psep = strsep(&pcCmdLine,pch);
                if(strcmp("ON", psep) == 0)
                {
                    gbStrPatternEnable = TRUE;
                }
                else
                {
                    gbStrPatternEnable = FALSE;
                }
            }
            else
            {
                return;
            }
        }
        _XCMdbloctl_TestPattern(pInstance, gu8PatternIP, bEnable, u8window, BValue, GValue, RValue);
    }
    else if(strcmp("panel_gamma", psep) == 0)
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK24_6D_L,BIT(12),BIT(12));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK24_6D_L,0,BIT(12));
        }
    }
    else if(strcmp("pq_gamma", psep) == 0)
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_50_L,BIT(0),BIT(0));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_50_L,0,BIT(0));
        }
    }
    else if(strcmp("ReadRequest", psep) == 0) //ReadRequest
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_07_L,0,BIT(1));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_07_L,BIT(1),BIT(1));
        }
    }
    else if(strcmp("WriteRequest", psep) == 0) //WriteRequest
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_07_L,0,BIT(0));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_07_L,BIT(0),BIT(0));
        }
    }
    else if(strcmp("Framecount", psep) == 0) //Framecount
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        MS_U8 u8FrameCount = (MS_U8)atoi(psep);
        SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_19_L,u8FrameCount,0x1F);
    }
    else if(strcmp("R/W diff count", psep) == 0) //R/W diff count
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        MS_U32 u32diffcount = (MS_U32)atoi(psep);
        SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_07_L,u32diffcount<<13,0xE000);
    }
    else if(strcmp("forceread", psep) == 0) //forceread
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_07_L,BIT(11),BIT(11));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_07_L,0,BIT(11));
        }
    }
    else if(strcmp("forcereadframe", psep) == 0) //forcereadframe
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        MS_U32 u32forcereadframe = (MS_U32)atoi(psep);
        SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_07_L,u32forcereadframe<<8,0x700);
    }
    else if(strcmp("FDmask", psep) == 0) //FDmask
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_26_L,BIT(8),BIT(8));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_26_L,0,BIT(8));
        }
    }
    else if(strcmp("UCNR", psep) == 0) //UCNR
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK2A_02_L,BIT(15),BIT(15));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK2A_02_L,0,BIT(15));
        }
    }
    else if(strcmp("Motion", psep) == 0) //Motion
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTE(MAIN_WINDOW, REG_SC_BK22_78_L,0x8F8F);
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTE(MAIN_WINDOW, REG_SC_BK22_78_L,0x8080);
        }
    }
    else if(strcmp("LPLL", psep) == 0) //LPLL setting
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        MS_U32 u32LPLLSet = (MS_U32)atoi(psep);
        W4BYTE(L_BK_LPLL(0x0F),u32LPLLSet);
    }
    else if(strcmp("GOPOn", psep) == 0) //GOP
    {
        MS_U8 u8GOPNum = 0;
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        u8GOPNum = (MS_U8)atoi(psep);
        u8GOPNum = 15-u8GOPNum;
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        MS_BOOL bEnable = (MS_BOOL)atoi(psep);
        if(bEnable)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK00_06_L,BIT(u8GOPNum),BIT(u8GOPNum));
        }
        else
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK00_06_L,0,BIT(u8GOPNum));
        }
    }
    else if(strcmp("DebugLevel", psep) == 0) //DebugLevel
    {
        MS_U16 u16Level = 0;
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        u16Level = (MS_U16)atoi(psep);
        MApi_XC_SetDbgLevel(u16Level);
    }
    else if(strcmp("Mute", psep) == 0) //Mute
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_19_L,BIT(1), BIT(1));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_19_L,0, BIT(1));
        }
    }
    else if(strcmp("Freeze", psep) == 0) //Freeze
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_01_L,BIT(11), BIT(11));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_01_L,0, BIT(11));
        }
    }
    else if(strcmp("InputDisable", psep) == 0) //InputDisable
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_02_L,BIT(7), BIT(7));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK01_02_L,0, BIT(7));
        }
    }
    else if(strcmp("DNR", psep) == 0) //DNR
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_02_L,BIT(14), BIT(14));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK12_02_L,0, BIT(14));
        }
    }
    else if(strcmp("PQ SPF Bypass", psep) == 0) //PQ SPF
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK0C_70_L,BIT(0),BIT(0));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK0C_70_L,0,BIT(0));
        }
    }
    else if(strcmp("PQ VIP Bypass", psep) == 0) //PQ VIP
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK27_70_L,BIT(0),BIT(0));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK27_70_L,0,BIT(0));
        }
    }
    else if(strcmp("PQ DNR Bypass", psep) == 0) //PQ DNR
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK06_21_L,0,BIT(1));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK06_21_L,BIT(1),BIT(1));
        }
    }
    else if(strcmp("OP1_legacy", psep) == 0) //OP1 legacy mode
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "Setting OP1_legacy fail!\n");
        }
        else if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK20_01_L,BIT(0),BIT(0));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK20_01_L,0,BIT(0));
        }
        else
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "Setting OP1_legacy fail!\n");
        }
    }
    else if(strcmp("OPM_2p", psep) == 0) //OPM 2p mode
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "Setting OPM_2p fail!\n");
        }
        else if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK20_01_L,BIT(1),BIT(1));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK20_01_L,0,BIT(1));
        }
        else
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "Setting OPM_2p fail!\n");
        }
    }
    else if(strcmp("IP2VE Flow Control", psep) == 0) //IP to VE Flow Control enable
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "Setting IP2VE Flow Control fail!\n");
        }
        else if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK4C_05_L,BIT(7),BIT(7));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK4C_05_L,0,BIT(7));
        }
        else
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "Setting IP2VE Flow Control fail!\n");
        }
    }
    else if(strcmp("Mload", psep) == 0) //Mload
    {
        MS_BOOL bEnable = FALSE;

        psep = strsep(&pcCmdLine,pch);

        if(psep == NULL)
        {
            return;
        }

        bEnable = (MS_BOOL)atoi(psep);

        MApi_XC_MLoad_Enable(bEnable);

    }
    else if(strcmp("CusMload", psep) == 0) //MLoad_Cus
    {
        MS_BOOL bEnable = FALSE;

        psep = strsep(&pcCmdLine,pch);

        if(psep == NULL)
        {
            return;
        }

        bEnable = (MS_BOOL)atoi(psep);

        MApi_XC_MLoad_Cus_Enable(E_MLCLIENT_MAIN_HDR, bEnable);

    }
    else if(strcmp("DsXc", psep) == 0) //DSXC IP/OP
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }

        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK1F_10_L, BIT(11), BIT(11));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK1F_10_L, 0, BIT(11));
        }

        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }

        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK1F_10_L, BIT(9), BIT(9));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK1F_10_L, 0, BIT(9));
        }
    }
    else if(strcmp("DsUcm", psep) == 0) //DS UCM
    {
        MdbPrint(paraCmdLine->u64ReqHdl,"DS UCM enable                       : NOT SUPPORTED\n");
    }
    else if(strcmp("DsFrc", psep) == 0) //DS FRC
    {
        MdbPrint(paraCmdLine->u64ReqHdl,"DS FRC enable                       : NOT SUPPORTED\n");
    }
    else if(strcmp("Frc", psep) == 0) //FRC
    {
        MdbPrint(paraCmdLine->u64ReqHdl,"FRC enable                          : NOT SUPPORTED\n");
    }
    else if(strcmp("Fsc", psep) == 0) //FSC
    {
        MdbPrint(paraCmdLine->u64ReqHdl,"FSC enable                          : NOT SUPPORTED\n");
    }
    else if(strcmp("HPixelShift", psep) == 0) //pixel shift
    {
        MdbPrint(paraCmdLine->u64ReqHdl,"Pixel Shift                          : NOT SUPPORTED\n");
    }
    else if(strcmp("SetPixelShiftFeatures", psep) == 0) //set pixel shift features
    {
        MdbPrint(paraCmdLine->u64ReqHdl,"Pixel Shift                          : NOT SUPPORTED\n");
    }
    else if(strcmp("ScalingFilterSram", psep) == 0) //Scaling Filter Sram
    {
        MS_U16 u16ScalingFilterSram;
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        u16ScalingFilterSram = (MS_U16)atoi(psep);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK23_0B_L, u16ScalingFilterSram);
    }
    else if(strcmp("SetPanelGamma", psep) == 0) //SetPanelGamma
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "SetPanelGamma NOT SUPPORTED.\n");
        }
        else if(strcmp("0", psep) == 0)
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "SetPanelGamma NOT SUPPORTED.\n");
        }
        else if(strcmp("1", psep) == 0)
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "SetPanelGamma NOT SUPPORTED.\n");
        }
        else if(strcmp("2", psep) == 0)
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "SetPanelGamma NOT SUPPORTED.\n");
        }
        else
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "SetPanelGamma NOT SUPPORTED.\n");
        }
    }
    else if(strcmp("ACEBrightness", psep) == 0) //ACEBrightness
    {
        MS_BOOL eWindow = PQ_MAIN_WINDOW;
        MS_U8 u8Brightness_R = 0;
        MS_U8 u8Brightness_G = 0;
        MS_U8 u8Brightness_B = 0;

        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "ACEBrightness NOT SUPPORTED.\n");
        }
        else if(strcmp("Low", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            u8Brightness_R = 10;
            u8Brightness_G = 10;
            u8Brightness_B = 10;
            MApi_XC_ACE_PicSetBrightness(eWindow, u8Brightness_R, u8Brightness_G, u8Brightness_B);
        }
        else if(strcmp("Middle", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            u8Brightness_R = 128;
            u8Brightness_G = 128;
            u8Brightness_B = 128;
            MApi_XC_ACE_PicSetBrightness(eWindow, u8Brightness_R, u8Brightness_G, u8Brightness_B);
        }
        else if(strcmp("High", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            u8Brightness_R = 255;
            u8Brightness_G = 255;
            u8Brightness_B = 255;
            MApi_XC_ACE_PicSetBrightness(eWindow, u8Brightness_R, u8Brightness_G, u8Brightness_B);
        }
        else
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "ACEBrightness NOT SUPPORTED.\n");
        }
    }
    else if(strcmp("ACEContrast", psep) == 0) //ACEContrast
    {
        MS_BOOL eWindow = PQ_MAIN_WINDOW;
        MS_BOOL bUseYUVSpace = FALSE;
        MS_U8 u8Contrast = 0;

        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "ACEContrast NOT SUPPORTED.\n");
        }
        else if(strcmp("Low", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            bUseYUVSpace = TRUE;
            u8Contrast = 10;

            MApi_XC_ACE_PicSetContrast(eWindow, bUseYUVSpace, u8Contrast);
        }
        else if(strcmp("Middle", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            bUseYUVSpace = TRUE;
            u8Contrast = 128;

            MApi_XC_ACE_PicSetContrast(eWindow, bUseYUVSpace, u8Contrast);
        }
        else if(strcmp("High", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            bUseYUVSpace = TRUE;
            u8Contrast = 255;

            MApi_XC_ACE_PicSetContrast(eWindow, bUseYUVSpace, u8Contrast);
        }
        else
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "ACEContrast NOT SUPPORTED.\n");
        }
    }
    else if(strcmp("ACESaturation", psep) == 0) //ACESaturation
    {
        MS_BOOL eWindow = PQ_MAIN_WINDOW;
        MS_BOOL bUseYUVSpace = FALSE;
        MS_U8 u8Saturation = 0;

        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "ACESaturation NOT SUPPORTED.\n");
        }
        else if(strcmp("Low", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            bUseYUVSpace = TRUE;
            u8Saturation = 10;

            MApi_XC_ACE_PicSetSaturation(eWindow, bUseYUVSpace, u8Saturation);
        }
        else if(strcmp("Middle", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            bUseYUVSpace = TRUE;
            u8Saturation = 128;

            MApi_XC_ACE_PicSetSaturation(eWindow, bUseYUVSpace, u8Saturation);
        }
        else if(strcmp("High", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            bUseYUVSpace = TRUE;
            u8Saturation = 255;

            MApi_XC_ACE_PicSetSaturation(eWindow, bUseYUVSpace, u8Saturation);
        }
        else
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "ACESaturation NOT SUPPORTED.\n");
        }
    }
    else if(strcmp("ACESharpness", psep) == 0) //ACESharpness
    {
        MS_BOOL eWindow = PQ_MAIN_WINDOW;
        MS_U8 u8Sharpness = 0;

        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "ACESharpness NOT SUPPORTED.\n");
        }
        else if(strcmp("Low", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            u8Sharpness  = 10;

            MApi_XC_ACE_PicSetSharpness(eWindow, u8Sharpness);
        }
        else if(strcmp("Middle", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            u8Sharpness = 128;

            MApi_XC_ACE_PicSetSharpness(eWindow, u8Sharpness);
        }
        else if(strcmp("High", psep) == 0)
        {
            eWindow = PQ_MAIN_WINDOW;
            u8Sharpness = 255;

            MApi_XC_ACE_PicSetSharpness(eWindow, u8Sharpness);
        }
        else
        {
            MdbPrint(paraCmdLine->u64ReqHdl, "ACESharpness NOT SUPPORTED.\n");
        }
    }
#if (UFO_XC_HDR_VERSION >= 2)
  else if(strcmp("HDR", psep) == 0) //HDR
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK79_07_L,BIT(1),BIT(1));
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK79_07_L,BIT(15),BIT(15));
        }
        else if(strcmp("OFF", psep) == 0)
        {
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK79_07_L,0,BIT(1));
            SC_W2BYTEMSK(MAIN_WINDOW,REG_SC_BK79_07_L,0,BIT(15));
        }
    }
#endif
    else if(strcmp("DecimalCrop", psep) == 0) // Decimal Crop
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            _gbProcFSDecimalCropEnable = TRUE;
        }
        else if(strcmp("OFF", psep) == 0)
        {
            _gbProcFSDecimalCropEnable = FALSE;
        }
    }
    else if(strcmp("OfflineDbgInfo", psep) == 0)
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            gbOfflineDetectDbg = TRUE;
        }
        else if(strcmp("OFF", psep) == 0)
        {
            gbOfflineDetectDbg = FALSE;
        }
    }
    else if(strcmp("OfflineEnable", psep) == 0)
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            gbOfflineDetectEnable = TRUE;
        }
        else if(strcmp("OFF", psep) == 0)
        {
            gbOfflineDetectEnable = FALSE;
        }
    }
    else if(strcmp("OfflineDetectOnce", psep) == 0)
    {
        INPUT_SOURCE_TYPE_t u8InputSourceType = INPUT_SOURCE_NONE;
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }

        gbOfflineDetectEnable = FALSE;
        u8InputSourceType = (MS_U16)atoi(psep);
        MDrv_XC_SetOffLineDetection(pInstance, u8InputSourceType);
        MdbPrint(paraCmdLine->u64ReqHdl, "offline detect source:%d ret:%d\n", u8InputSourceType, MDrv_XC_GetOffLineDetection(pInstance, u8InputSourceType));
        gbOfflineDetectEnable = TRUE;
    }
    else if(strcmp("OfflineDetectOneType", psep) == 0)
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        gbOfflineDetectDbg = TRUE;
        if(strcmp("ALL", psep) == 0)
        {
            genOfflineSource = INPUT_SOURCE_NONE;
        }
        else
        {
            genOfflineSource = (MS_U16)atoi(psep);
        }
    }
    else if(strcmp("FBLevel", psep) == 0)
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("FB", psep) == 0)
        {
             MApi_XC_Set_FB_Level(E_XC_FB_LEVEL_FB,MAIN_WINDOW);
        }
        else if(strcmp("FBL", psep) == 0)
        {
            MApi_XC_Set_FB_Level(E_XC_FB_LEVEL_FBL,MAIN_WINDOW);
        }
        else if(strcmp("RFBL", psep) == 0)
        {
            MApi_XC_Set_FB_Level(E_XC_FB_LEVEL_RFBL_DI,MAIN_WINDOW);
        }
        else if(strcmp("FB_VSD", psep) == 0)
        {
            MApi_XC_Set_FB_Level(E_XC_FB_LEVEL_FB_VSD,MAIN_WINDOW);
        }
        else if(strcmp("FBL_VSD", psep) == 0)
        {
            MApi_XC_Set_FB_Level(E_XC_FB_LEVEL_FBL_VSD,MAIN_WINDOW);
        }
        else if(strcmp("RFBL_VSD", psep) == 0)
        {
            MApi_XC_Set_FB_Level(E_XC_FB_LEVEL_RFBL_VSD,MAIN_WINDOW);
        }
        else if(strcmp("FB_MVOPDROPLINE", psep) == 0)
        {
            MApi_XC_Set_FB_Level(E_XC_FB_LEVEL_FB_MVOPDROPLINE,MAIN_WINDOW);
        }
        else if(strcmp("FBL_MVOPDROPLINE", psep) == 0)
        {
            MApi_XC_Set_FB_Level(E_XC_FB_LEVEL_FBL_MVOPDROPLINE,MAIN_WINDOW);
        }
        else if(strcmp("RFBL_MVOPDROPLINE", psep) == 0)
        {
            MApi_XC_Set_FB_Level(E_XC_FB_LEVEL_RFBL_MVOPDROPLINE,MAIN_WINDOW);
        }
        else
        {
            MdbPrint(paraCmdLine->u64ReqHdl,"NOT SUPPORTED.\n");
        }
        MdbPrint(paraCmdLine->u64ReqHdl,"eFBLevel = %d\n",MApi_XC_Get_FB_Level(MAIN_WINDOW));
    }
    else if(strcmp("BANDWIDTH_SETTING", psep) == 0) //Bandwidth level setting
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            MHal_XC_SetBandwidth_Enable(pInstance,TRUE,E_XC_BANDWIDTH_SCMI_IPM_W);
        }
        else if(strcmp("OFF", psep) == 0)
        {
            MHal_XC_SetBandwidth_Enable(pInstance,FALSE,E_XC_BANDWIDTH_SCMI_IPM_W);
        }
        else
        {
            MdbPrint(paraCmdLine->u64ReqHdl,"NOT SUPPORTED.\n");
        }
    }
    else if(strcmp("DisableXC8Align", psep) == 0) // xc 8 align
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("TRUE", psep) == 0)
        {
            _bProcFSXC8AlignDisable = TRUE;
        }
        else if(strcmp("FALSE", psep) == 0)
        {
            _bProcFSXC8AlignDisable = FALSE;
        }
    }
    else if(strcmp("FreezeImg", psep) == 0) // freeze video
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }
        if(strcmp("ON", psep) == 0)
        {
            MApi_XC_FreezeImg_U2(pInstance, TRUE, MAIN_WINDOW);
        }
        else if(strcmp("OFF", psep) == 0)
        {
            MApi_XC_FreezeImg_U2(pInstance, FALSE, MAIN_WINDOW);
        }
    }
    else if(strcmp("ForceFreerun", psep) == 0) // Force freerun
    {
        psep = strsep(&pcCmdLine,pch);
        if(psep == NULL)
        {
            return;
        }

        if(strcmp("TRUE", psep) == 0)
        {
            _bProcFSForceFreerun= TRUE;
        }
        else if(strcmp("FALSE", psep) == 0)
        {
            _bProcFSForceFreerun = FALSE;
        }
    }
    else if(strcmp("help", psep) == 0) //help
    {
        MdbPrint(paraCmdLine->u64ReqHdl, "------------------- Mstar XC help --------------------\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "==================Test Pattern==================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo pattern=3 enable=1 window=0 B=0 G=0 R=0 str=ON>  /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "pattern=0~8, enable=0/1, window=0/1 R/G/B:0~255 str=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "pattern : 0 IPMUX \n");
        MdbPrint(paraCmdLine->u64ReqHdl, "pattern : 1 IP1 \n");
        MdbPrint(paraCmdLine->u64ReqHdl, "pattern : 2 OPM \n");
        MdbPrint(paraCmdLine->u64ReqHdl, "pattern : 3 OP \n");
        MdbPrint(paraCmdLine->u64ReqHdl, "pattern : 4 VOP2 \n");
        MdbPrint(paraCmdLine->u64ReqHdl, "pattern : 5 VOP \n");
        MdbPrint(paraCmdLine->u64ReqHdl, "pattern : 6 MOD \n");
        MdbPrint(paraCmdLine->u64ReqHdl, "pattern : 7 IP2 \n");
        MdbPrint(paraCmdLine->u64ReqHdl, "pattern : 8 Dynamic IP1 \n");
        MdbPrint(paraCmdLine->u64ReqHdl, "str : ON resume back can see pattern \n");
        MdbPrint(paraCmdLine->u64ReqHdl, "====================PQ Gamma====================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo pq_gamma=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "pq_gamma=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===================Panel Gamma==================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo panel_gamma=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "panel_gamma=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===============Read/Write Request===============\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo ReadRequest=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo WriteRequest=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ReadRequest=ON/OFF, WriteRequest=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===================Frame Count==================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo Framecount=4\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "Framecount=3/4/5/6/7/8\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "==================R/W diff count================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo RWcount=4\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "RWcount=0/1/2/3/4\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "====================Force Read==================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo forceread=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo forcereadframe=4\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "forceread=ON/OFF, forcereadframe=0/1/2/3/4\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================FDMask====================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo FDMask=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "FDMask=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================UCNR======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo UCNR=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "UCNR=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================Motion======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo Motion=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "Motion=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================GOP======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo GOPOn num=2 enable=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "num=0/1/2/3\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "enable=0/1\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================DebugLevel======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo DebugLevel=0x183 > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "DebugLevel=\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "OFF:0x0; SETWINDOW:0x1; SETTIMING:0x2; MUX:0x8; FSS_MONITOR:0x10; AUTOGEOMETRY:0x40; CROPCALC:0x80;\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "SETTIMING_ISR:0x100; DWIN_SETWINDOW:0x200; FUNCTION_TRACE:0x400; PARAMETER_TRACE:0x800;\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "SEAMLESSZAP:0x1000; ATVTiming:0x2000; FSS_TRANSFER:0x4000; SVP:0x8000\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================LPLL======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo LPLL=0x251254\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "LPLL=0x251254\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================Mute======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo Mute=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "Mute=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================Freeze======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo Freeze=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "Freeze=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================Input Disable======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo InputDisable=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "InputDisable=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================DNR======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo DNR=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "DNR=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "------------------------------------------------------\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================PQ SPF======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo PQ SPF=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "PQ SPF=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================PQ VIP======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo PQ VIP=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "PQ VIP=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================PQ DNR======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo PQ DNR=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "PQ DNR=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================Mload======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo Mload=1 > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "Mload=1/0\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================CusMload======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo CusMload=1 > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "CusMload=1/0\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================DsXc======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo DsXc IP=ON OP=ON > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "DsXc IP=ON/OFF OP=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================DsUcm======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo DsUcm=ON > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "DsUcm=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================DsFrc======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo DsFrc=ON > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "DsFrc=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "==================Frc==================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo Frc=1 > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "Frc=0/1\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "==================Fsc==================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo Fsc=1 > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "Fsc=0/1\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "==================PixelShift==================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo HPixelShift=1 VPixelShift=1 > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "HPixelShift=-5 ~ +5, VPixelShift=-3 ~ +3\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "==================SetPixelShiftFeatures==================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo SetPixelShiftFeatures=ON  > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "SetPixelShiftFeatures=ON/OFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "==================ScalingFilterSram==================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo ScalingFilterSram=0x0303 > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ScalingFilterSram=0x0 ~ 0xFFFF\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===================SetPanelGamma==================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo SetPanelGamma=0 > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "SetPanelGamma=0/1/2\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===================ACEBrightness===================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo ACEBrightness=Low > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ACEBrightness=Low/Middle/High\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===================ACEContrast===================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo ACEContrast=Low > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ACEContrast=Low/Middle/High\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===================ACESaturation===================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo ACESaturation=Low > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ACESaturation=Low/Middle/High\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===================ACESharpness===================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo ACESharpness=Low > /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ACESharpness=Low/Middle/High\n");
#if (UFO_XC_HDR_VERSION >= 2)
        MdbPrint(paraCmdLine->u64ReqHdl, "======================HDR======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo HDR=ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "HDR=ON/OFF\n");
#endif
        MdbPrint(paraCmdLine->u64ReqHdl, "================Frame Lock Status================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo Frame Lock Status>  /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===================DecimalCrop===================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo DecimalCrop=ON/OFF >  /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "================OfflineDbgInfo================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo OfflineDbgInfo=ON >  /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "Offline dbg info=OFF/ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "================OfflineEnable================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo OfflineEnable=ON >  /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "Offline detect=OFF/ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "================OfflineDetectOnce================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo OfflineDetectOnce=2 >  /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "Offline detect some source one time\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "0:VGA 2-9:CVBS 16-18:Ypbpr 23-26:HDMI\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "================OfflineDetectOneType================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo OfflineDetectOnce=2 >  /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "Offline detect only one source\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "0:VGA 2-9:CVBS 16-18:Ypbpr 23-26:HDMI\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "======================FBLevel======================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo FBLevel=VSD >  /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "FBLevel=FB/FBL/RFBL/FB_VSD/FBL_VSD/RFBL_VSD/FB_MVOPDROPLINE/FBL_MVOPDROPLINE/RFBL_MVOPDROPLINE\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===================DisableXC8Align===================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo DisableXC8Align=TRUE/FALSE >  /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===================FreezeImg===================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo FreezeImg=ON >  /proc/utopia_mdb/xc\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "FreezeImg=OFF/ON\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "===================Force Freerun=====================\n");
        MdbPrint(paraCmdLine->u64ReqHdl, "ex: echo ForceFreerun=TRUE/FALSE >  /proc/utopia_mdb/xc\n");
    }
}
void SYMBOL_WEAK MHal_XCMdbIoctl_EchoCmd(MDBCMD_CMDLINE_PARAMETER *paraCmdLine)
{
    void *pInstance=NULL;
    pInstance = UtopiaModuleGetLocalInstantList(MODULE_XC, pInstance);

    _MHal_XCMdbIoctl_EchoCmd(pInstance, paraCmdLine);
}
void SYMBOL_WEAK MHal_XCMdbIoctl_Cat(MDBCMD_GETINFO_PARAMETER *paraGetInfo)
{
    void *pInstance=NULL;
    void *pAceInstance=NULL;
    pInstance = UtopiaModuleGetLocalInstantList(MODULE_XC, pInstance);
    pAceInstance = UtopiaModuleGetLocalInstantList(MODULE_ACE, pInstance);
    _MHal_XCMdbloctl_Cat_DISP(pInstance, paraGetInfo);
    if(pAceInstance != NULL)
    {
        _MHal_XCMdbloctl_Cat_ACE(pInstance, paraGetInfo);
    }
    _MHal_XCMdbloctl_Cat_SetWindow(pInstance, paraGetInfo);
    _MHal_XCMdbloctl_Cat_FrameLock(pInstance, paraGetInfo);
    _MHal_XCMdbloctl_Cat_MEMC(pInstance, paraGetInfo);
    _MHal_XCMdbloctl_Cat_HDR(pInstance, paraGetInfo);
    _MHal_XCMdbloctl_Cat_TGEN(pInstance, paraGetInfo);
    _MHal_XCMdbloctl_Cat_MOD(pInstance, paraGetInfo);
    _MHal_XCMdbloctl_Cat_3D(pInstance, paraGetInfo);
    _MHal_XCMdbloctl_Cat_OPTEE(pInstance, paraGetInfo);
    _MHal_XCMdbloctl_Cat_FSS(pInstance, paraGetInfo);
}
#endif

void Hal_SC_HDR_CLK_Setting(void *pInstance)
{
    MDrv_WriteByteMask(REG_CKG_S2_MECLK_ext, 0, 0x3F);  // REG 0x100A_40[13:8] set to 0
    MDrv_WriteByteMask(REG_CKG_S2_MGCLK_ext, 0, 0x3F); // REG 0x100A_41[13:8] set to 0
    MDrv_WriteByteMask(REG_CKG_S2_GOP_HDR_ext, 0, 0x3F); // REG 0x100A_42[13:8] set to 0
}

void Hal_SC_MVOP_HandShake_Control(void * pInstance,SCALER_WIN eWindow,P_SC_SWDB_INFO pDBreg)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return;
    }
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    MHal_XC_SetOfflineSource(pInstance, eWindow, gSrcInfo[eWindow].enInputSourceType);
#endif
    if((psXCInstPri->u32DeviceID == 0) && (eWindow == MAIN_WINDOW))
    {
        //Always enable HSK for M7332 (MVOP source), if this condition is changed, need to change MHal_XC_IsSupportIP2VE condition
        if(IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[eWindow].enInputSourceType))
        {
            gSrcInfo[eWindow].Status2.bMVOPHskEnable = TRUE;
        }
        else
        {
            gSrcInfo[eWindow].Status2.bMVOPHskEnable = FALSE;
        }

        //Set XC HSK
        // Bit0: Enable HSK mode
        // Bit2: reg_ip2_vs_sel 0:ip1 1:mvop
        // Bit5: reg_ip2_fd_sel 0:use ip1_field 1: use mvop_field
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_10_L,gSrcInfo[eWindow].Status2.bMVOPHskEnable?(BIT(0)|BIT(2)|BIT(5)):0 ,BIT(0)|BIT(2)|BIT(5));

        //this feature conflicts with HSK mode
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_45_L, eWindow), 0x0000, 0x9FFF); // edclk pd control start and edclk pd control enable
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_45_L, 0x0000, 0x9FFF); // edclk pd control start and edclk pd control enable
#endif

        //Set MVOP HSK
        if(IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[eWindow].enInputSourceType))
        {
            MVOP_Handle stMvopHd = { E_MVOP_MODULE_MAIN };
            MDrv_MVOP_SetCommand(&stMvopHd, E_MVOP_CMD_SET_HANDSHAKE_MODE, &gSrcInfo[eWindow].Status2.bMVOPHskEnable);
        }

        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] eWindow:%d HSK enable:%d\n",__func__,__LINE__,eWindow, gSrcInfo[eWindow].Status2.bMVOPHskEnable);
    }
    else
    {
        printf("Not support HSK mode with sub window ! \n");
    }
}

void Hal_SC_MVOP_Gen_Timing_From_XC_Control(void * pInstance,SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return;
    }
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if((psXCInstPri->u32DeviceID == 0) && (eWindow == MAIN_WINDOW))
    {
        MS_BOOL bGenTimingFromXC = FALSE;

        if(IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType)||IsSrcTypeDTV(gSrcInfo[eWindow].enInputSourceType))
        {
#if defined(UFO_XC_FB_LEVEL)
            bGenTimingFromXC = ((MDrv_XC_IsFBL(gSrcInfo[eWindow].eFBLevel))||(MDrv_XC_IsRFBL(gSrcInfo[eWindow].eFBLevel)))?TRUE:FALSE;
#else
            bGenTimingFromXC = (gSrcInfo[MAIN_WINDOW].bFBL || gSrcInfo[MAIN_WINDOW].bR_FBL);
#endif
#if defined(ENABLE_XC_WRITE_CMD_API)
            if(!gSrcInfo[eWindow].bInterlace)
            {
                bGenTimingFromXC = TRUE;
            }
#endif
        }
        gSrcInfo[eWindow].Status2.bMVOPHSKMode = bGenTimingFromXC; //This variable represents bGenTimingFromXC.....

        //Set trigger point Gen timing from XC
        if(bGenTimingFromXC)
        {
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_5D_L, 0x0828);

            //By RD's suggestion, backporch setting -> P mode:1301_21[0]=1, I mode:1301_21[0]=0
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_21_L, eWindow), BIT(0), BIT(0));
        }
        else
        {
            SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_5D_L, 0x1018);//return to HW default value
        }
        //printk(" [%s,%5d] bGenTimingFromXC:%d  bMVOPHSKMode:%d  \n",__func__,__LINE__,bGenTimingFromXC,gSrcInfo[MAIN_WINDOW].Status2.bMVOPHSKMode);

        //Set MVOP Gen timing from XC
        if(IsSrcTypeStorage(gSrcInfo[eWindow].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[eWindow].enInputSourceType))
        {
            MVOP_Handle stMvopHd = { E_MVOP_MODULE_MAIN };
            MDrv_MVOP_SetCommand(&stMvopHd, E_MVOP_CMD_SET_XC_GEN_TIMING,&bGenTimingFromXC);
        }
    }
    else
    {
        printf("Not support gen timing from XC  with sub window ! \n");
    }
}

#if FRC_INSIDE
void Hal_SC_Get_FRC_STGEN_ODCLK(void *pInstance, SCALER_WIN eWindow, E_FRC_STGEN_ODCLK* peMode, E_FSC_IDCLK* peFSCIDCLK)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    E_FRC_STGEN_ODCLK eMode = E_FRC_STGEN_ODCLK_1;
    E_FSC_IDCLK eFSCIDCLK = E_FSC_IDCLK_1;
    E_XC_PNL_LPLL_EXT_TYPE enLPLL_Type = E_XC_PNL_LPLL_TTL;
    enLPLL_Type = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.eLPLL_Type;
    MS_U8 u8LPLL_Mode = (MS_U8)pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u8LPLL_Mode;

    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"[%s,%5d] eWindow:%d enLPLL_Type:%d u8LPLL_Mode:%d\n",__func__,__LINE__,eWindow, enLPLL_Type, u8LPLL_Mode);

    if(MHal_FRC_IsFHDToFSC(pInstance,MAIN_WINDOW))
    {
        //FHD to FSC
        eMode = E_FRC_STGEN_ODCLK_4;
    }
    else
    {
        //4k to FSC
        if(IsVBY1_16LANE(enLPLL_Type)) //maserati mode
        {
            eMode = E_FRC_STGEN_ODCLK_1;
        }
        else //manhattan mode
        {
            MS_BOOL bLockFromIP = Hal_SC_IsLockFromIP(pInstance, eWindow);

            if((gSrcInfo[eWindow].u16InputVFreq < 330) && bLockFromIP
                && (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16DefaultVFreq > 450))
            {
                // 4K 24/25/30 + output 50/60 case, ODCLK2 as ODCLK/2 for power saving
                eMode = E_FRC_STGEN_ODCLK_2;
            }
            else if( (enLPLL_Type == E_XC_PNL_LPLL_VBY1_8BIT_1LANE)||(enLPLL_Type == E_XC_PNL_LPLL_VBY1_10BIT_1LANE))
            {
                //For Raptor output 576p/480p case (Vby1 1 lane), xc odclk divided by N, so the stgen has to follow the same setting.
                eMode = E_FRC_STGEN_ODCLK_N;
            }
            else
            {
                // 4K 50/60 case, ODLCK2 as ODCLK
                eMode = E_FRC_STGEN_ODCLK_1;
            }
        }
    }

    if( (E_XC_PNL_LPLL_TTL == enLPLL_Type)
       || ((E_XC_PNL_LPLL_LVDS == enLPLL_Type)&&(E_XC_MOD_OUTPUT_SINGLE == u8LPLL_Mode))
       || ((E_XC_PNL_LPLL_HS_LVDS == enLPLL_Type)&&(E_XC_MOD_OUTPUT_SINGLE == u8LPLL_Mode)))
    {
        eMode = E_FRC_STGEN_ODCLK_2;
    }

    if (eMode == E_FRC_STGEN_ODCLK_2)
    {
        eFSCIDCLK = E_FSC_IDCLK_2;
    }
    else if (eMode == E_FRC_STGEN_ODCLK_4)
    {
        eFSCIDCLK = E_FSC_IDCLK_4;
    }

    *peMode = eMode;
    *peFSCIDCLK = eFSCIDCLK;
}
#endif

MS_BOOL Hal_SC_IsLockFromIP(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_BOOL bLockFromIP = FALSE;
#if FRC_INSIDE
#if (HW_DESIGN_4K2K_VER == 6)
    if (pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFRCEnabled
         && ((gSrcInfo[MAIN_WINDOW].stCapWin.height < gSrcInfo[eWindow].u16InputVTotal)
              && (gSrcInfo[eWindow].bEnableFPLL
#if FRC_INSIDE
                  || (IS_OUTPUT_4K1K_120HZ_PANEL() //4k1k@120 3d stgen lock ip case
                      && (MDrv_XC_Get_3D_Output_Mode(pInstance) != E_XC_3D_OUTPUT_MODE_NONE)
                      && pXCResourcePrivate->stdrvXC_Display._bForceFreerun)
#endif
                ))
#if (HW_DESIGN_HDMITX_VER == 1)//Maserati +Raptor HDMITX case , uses lockfromOP
        && (!(pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_B & E_XC_INIT_MISC_B_HDMITX_ENABLE))
#endif
#ifndef MAXIM_ATV_LOCK_PHASE_PATCH
       && (!IsSrcTypeATV(gSrcInfo[eWindow].enInputSourceType))  //atv ip timing may be unstable under some use case,cant sync from ip
#endif
       )
    {
        bLockFromIP = TRUE;
    }
#endif
#endif
    return bLockFromIP;
}

#ifdef UFO_XC_SCAN_TYPE
void MHal_XC_SetMemoryType_ForceP(void *pInstance, MS_BOOL bInterlace)
{
}

void MHal_XC_SetVirtualBox(void *pInstance, MS_U16 *pu16VBWidth, MS_U16 *pu16VBHeight)
{
}

void MHal_XC_SetFrameNum(void *pInstance, MS_U8 *u8FrameCount)
{
}

void MHal_XC_SetForcepConfig(void *pInstance, E_XC_SCAN_TYPE eScanType)
{
}
#endif

MS_BOOL MHal_XC_IsSupportIP2VE(void *pInstance, SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

#ifdef UFO_XC_FB_LEVEL
    MS_BOOL bNonFB = ((MDrv_XC_IsFBL(gSrcInfo[enWindow].eFBLevel))||(MDrv_XC_IsRFBL(gSrcInfo[enWindow].eFBLevel))) ? TRUE : FALSE;
    if(gSrcInfo[enWindow].Status2.bMVOPHskEnable && !bNonFB)
#else
    if(gSrcInfo[enWindow].Status2.bMVOPHskEnable && !(gSrcInfo[enWindow].bR_FBL || gSrcInfo[enWindow].bFBL))
#endif
    { //MM case (with FB), M7322 MM always open HSK (check in Hal_SC_MVOP_HandShake_Control), if not, MM need to return false
        return TRUE;
    }
    else if(IsSrcTypeHDMI(gSrcInfo[enWindow].enInputSourceType))
    { // HDMI case
        return FALSE;
    }
    else
    {
        return FALSE;
    }
}

//Only for MM && HDMI case
void MHal_XC_IP2VE_FlowControl(void *pInstance, MS_BOOL bEnable)
{

    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"bEnable:%d \n",bEnable);

    if (bEnable == TRUE)
    {
        SC_W2BYTEMSK(MAIN_WINDOW, REG_SC_BK4C_05_L, BIT(7), BIT(7));//, [7]->IP2VE_path_en
    }
    else
    {
        SC_W2BYTEMSK(MAIN_WINDOW, REG_SC_BK4C_05_L, 0, BIT(7));//, [7]->IP2VE_path_en
    }
}

#ifdef UFO_XC_DS_PQ
E_APIXC_ReturnValue MHal_XC_PQDS_GetCaps(void *pInstance, XC_PQDS_SUPPORTED_CAPS *pstPQDSCaps)
{
    EN_PQ_DS_TYPE enPQDSType = pstPQDSCaps->enPQDSType;

    switch (enPQDSType)
    {
        case E_PQ_DS_GRULE:
        {
            pstPQDSCaps->bSupported = TRUE;
            break;
        }
        case E_PQ_DS_XRULE:
        {
#ifdef PQ_DS_XRULE_SUPPORT
#if defined(PQ_FAST_DISPLAY_ENABLE) && (PQ_FAST_DISPLAY_ENABLE==1)
            pstPQDSCaps->bSupported = FALSE; // Support Zero PQ delay
#else
            pstPQDSCaps->bSupported = TRUE;  // Support 1/2 PQ delay
#endif
#else
            pstPQDSCaps->bSupported = FALSE;
#endif
            break;
        }
        default:
        {
            pstPQDSCaps->bSupported = FALSE;
            break;
        }
    }
    return E_APIXC_RET_OK;
}
#endif

E_APIXC_ReturnValue MHal_XC_FAST_DISP_GetCaps(void *pInstance, XC_PQ_FAST_DISP_SUPPORTED_CAPS *pstPQFastDispCaps)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    EN_PQ_FAST_DISP_TYPE enPQFastDispType = pstPQFastDispCaps->enPQFastDispType;
    MS_BOOL bOpenFastDisplay = TRUE;
#ifdef UFO_XC_FB_LEVEL
    if((MDrv_XC_IsFBL(gSrcInfo[MAIN_WINDOW].eFBLevel))||(MDrv_XC_IsRFBL(gSrcInfo[MAIN_WINDOW].eFBLevel)))
#else
    if (gSrcInfo[MAIN_WINDOW].bFBL || gSrcInfo[MAIN_WINDOW].bR_FBL)
#endif
    {
        bOpenFastDisplay = FALSE;
    }

    switch (enPQFastDispType)
    {
        case E_PQ_FAST_DISP_ZEROPQ:
        {
#if defined(PQ_FAST_DISPLAY_ENABLE) && (PQ_FAST_DISPLAY_ENABLE == TRUE)
            pstPQFastDispCaps->bSupported = bOpenFastDisplay;
#else
            pstPQFastDispCaps->bSupported = FALSE;
#endif
            break;
        }
        default:
        {
            pstPQFastDispCaps->bSupported = FALSE;
            break;
        }
    }
    return E_APIXC_RET_OK;
}

MS_U16 MHal_XC_FSS_BankTransfer(void * pInstance, MS_U16 u16BankRegister, SCALER_WIN eWindow)
{
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    INPUT_SOURCE_TYPE_t enSrcType = MHal_XC_GetOfflineSource(pInstance, eWindow);
    MS_U16 u16BankTransfered = 0;
    EN_XC_INPUT_FSS_TYPE enBankSel = E_XC_INPUT_FSS_MAX;
    MS_U8 u8EnablePort = 0, u8Index = 0;
    E_MUX_INPUTPORT enSrcPort[3] = {INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT};

    if(!MHal_XC_IsFSSEnabled(pInstance, eWindow))
    {
        return u16BankRegister;
    }

    if(enSrcType == INPUT_SOURCE_YPBPR_MAX)
    {
        enBankSel = E_XC_INPUT_FSS_ADC_OFFLINE;
    }
    else if(eWindow == MAX_WINDOW || enSrcType != INPUT_SOURCE_NONE)
    {
        MDrv_XC_Mux_GetPort(pInstance, enSrcType, enSrcPort, &u8EnablePort );
        for(u8Index = 0; u8Index < u8EnablePort; u8Index++)
        {
            enBankSel = MHal_XC_GetFSSMuxPort(pInstance, (E_INPUT_PORT_TYPE)enSrcPort[u8Index]);
        }
    }
    else
    {
        enBankSel = MHal_XC_GetFssSource(pInstance, eWindow);
    }

    if(IsFSSDisableType(enBankSel))
    {
        return u16BankRegister;
    }

    switch(enBankSel)
    {
        case E_XC_INPUT_FSS_ADCA:
            u16BankTransfered = (REG_SC_BKC0_00_L | (u16BankRegister&LBMASK));
            break;
        case E_XC_INPUT_FSS_HDMI_P0:
            u16BankTransfered = (REG_SC_BKC1_00_L | (u16BankRegister&LBMASK));
            break;
        case E_XC_INPUT_FSS_VD:
            u16BankTransfered = (REG_SC_BKC2_00_L | (u16BankRegister&LBMASK));
            break;
        case E_XC_INPUT_FSS_MVOP0:
            u16BankTransfered = (REG_SC_BKC3_00_L | (u16BankRegister&LBMASK));
            break;
        case E_XC_INPUT_FSS_HDMI_P1:
            u16BankTransfered = (REG_SC_BKC4_00_L | (u16BankRegister&LBMASK));
            break;
        case E_XC_INPUT_FSS_MVOP1:
            u16BankTransfered = (REG_SC_BKC5_00_L | (u16BankRegister&LBMASK));
            break;
        case E_XC_INPUT_FSS_ADC_OFFLINE:
            u16BankTransfered = (REG_SC_BKC6_00_L | (u16BankRegister&LBMASK));
            break;
        case E_XC_INPUT_FSS_HDMI_P2:
            u16BankTransfered = (REG_SC_BKC7_00_L | (u16BankRegister&LBMASK));
            break;
        case E_XC_INPUT_FSS_HDMI_P3:
            u16BankTransfered = (REG_SC_BKC8_00_L | (u16BankRegister&LBMASK));
            break;
        default:
            u16BankTransfered = u16BankRegister;
            break;
    }

    XC_LOG_TRACE(XC_DBGLEVEL_FSS_TRANSFER, "[FS] eWindow[%d] ori[0x%04x] enSrcType[%d] enBankSel[%d] fail to get source\n", eWindow, u16BankRegister, enSrcType, enBankSel);
    return u16BankTransfered;
#else
    return u16BankRegister;
#endif
}

MS_U16 MHal_XC_FSS_SoftwareResetTransfer(void * pInstance, MS_U16 u16BankRegister, SCALER_WIN eWindow, MS_U8 u8Reset, MS_U16 u16Mask)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    INPUT_SOURCE_TYPE_t enSrcType = MHal_XC_GetOfflineSource(pInstance, eWindow);
    MS_U16 u16BankTransfered = 0;
    EN_XC_INPUT_FSS_TYPE enBankSel = E_XC_INPUT_FSS_MAX;
    MS_U8 u8EnablePort = 0, u8Index = 0;
    E_MUX_INPUTPORT enSrcPort[3] = {INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT};

    if(!MHal_XC_IsFSSEnabled(pInstance, eWindow))
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankRegister, u8Reset, u16Mask);
        return u16BankRegister;
    }

    if(u16BankRegister!=REG_SC_BK00_02_L)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankRegister, u8Reset, u16Mask);
        return u16BankRegister;
    }

    if(enSrcType == INPUT_SOURCE_YPBPR_MAX)
    {
        enBankSel = E_XC_INPUT_FSS_ADC_OFFLINE;
    }
    else if(eWindow == MAX_WINDOW || enSrcType != INPUT_SOURCE_NONE)
    {
        MDrv_XC_Mux_GetPort(pInstance, enSrcType, enSrcPort, &u8EnablePort );
        for(u8Index = 0; u8Index < u8EnablePort; u8Index++)
        {
            enBankSel = MHal_XC_GetFSSMuxPort(pInstance, (E_INPUT_PORT_TYPE)enSrcPort[u8Index]);
        }
    }
    else
    {
        enBankSel = MHal_XC_GetFssSource(pInstance, eWindow);
    }

    if(IsFSSDisableType(enBankSel))
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankRegister, u8Reset, u16Mask);
        return u16BankRegister;
    }

    switch(enBankSel)
    {
        case E_XC_INPUT_FSS_ADCA:
            u16BankTransfered = (REG_SC_BKF8_00_L | (u16BankRegister&LBMASK));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankTransfered, u8Reset, u16Mask);
            break;
        case E_XC_INPUT_FSS_HDMI_P0:
            u16BankTransfered = (REG_SC_BKF9_00_L | (u16BankRegister&LBMASK));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankTransfered, u8Reset, u16Mask);
            break;
        case E_XC_INPUT_FSS_VD:
            u16BankTransfered = (REG_SC_BKFA_00_L | (u16BankRegister&LBMASK));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankTransfered, u8Reset, u16Mask);
            break;
        case E_XC_INPUT_FSS_MVOP0:
            u16BankTransfered = (REG_SC_BKFB_00_L | (u16BankRegister&LBMASK));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankTransfered, u8Reset, u16Mask);
            break;
        case E_XC_INPUT_FSS_HDMI_P1:
            u16BankTransfered = (REG_SC_BKFC_00_L | (u16BankRegister&LBMASK));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankTransfered, u8Reset, u16Mask);
            break;
        case E_XC_INPUT_FSS_MVOP1:
            u16BankTransfered = (REG_SC_BKFD_00_L | (u16BankRegister&LBMASK));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankTransfered, u8Reset, u16Mask);
            break;
        case E_XC_INPUT_FSS_ADC_OFFLINE:
            u16BankTransfered = (REG_SC_BKFE_00_L | (u16BankRegister&LBMASK));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankTransfered, u8Reset, u16Mask);
            break;
        case E_XC_INPUT_FSS_HDMI_P2:
            u16BankTransfered = (REG_SC_EXT_BKE0_00_L | (u16BankRegister&LBMASK));
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankTransfered, u8Reset, u16Mask);
            break;
        case E_XC_INPUT_FSS_HDMI_P3:
            u16BankTransfered = (REG_SC_EXT_BKE1_00_L | (u16BankRegister&LBMASK));
            SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankTransfered, u8Reset, u16Mask);
            break;
        default:
            u16BankTransfered = u16BankRegister;
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankTransfered, u8Reset, u16Mask);
            break;
    }

    XC_LOG_TRACE(XC_DBGLEVEL_FSS_TRANSFER, "eWindow[%d] ori[0x%04x] enSrcType[%d] enBankSel[%d] fail to get source\n", eWindow, u16BankRegister, enSrcType, enBankSel);
    return u16BankTransfered;
#else
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, u16BankRegister, u8Reset, u16Mask);
    return u16BankRegister;
#endif
}

EN_PCMONITOR_SOURCE_TYPE_t MHal_XC_InputSrcToPCMonitorSrc(void * pInstance, INPUT_SOURCE_TYPE_t enSrcType)
{
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    EN_PCMONITOR_SOURCE_TYPE_t enPcMonitorSrcType = E_PCMONITOR_SOURCE_NUM;

    switch(enSrcType)
    {
        case INPUT_SOURCE_VGA:
            enPcMonitorSrcType = E_PCMONITOR_SOURCE_VGA;
            break;
        case INPUT_SOURCE_YPBPR:
        case INPUT_SOURCE_YPBPR2:
        case INPUT_SOURCE_YPBPR3:
            enPcMonitorSrcType = E_PCMONITOR_SOURCE_YPBPR;
            break;
        case INPUT_SOURCE_HDMI:
            enPcMonitorSrcType = E_PCMONITOR_SOURCE_HDMI;
            break;
        case INPUT_SOURCE_HDMI2:
            enPcMonitorSrcType = E_PCMONITOR_SOURCE_HDMI2;
            break;
        case INPUT_SOURCE_HDMI3:
            enPcMonitorSrcType = E_PCMONITOR_SOURCE_HDMI3;
            break;
        case INPUT_SOURCE_HDMI4:
            enPcMonitorSrcType = E_PCMONITOR_SOURCE_HDMI4;
            break;
        default:
            enPcMonitorSrcType = E_PCMONITOR_SOURCE_INVALID;
            break;
    }

    return enPcMonitorSrcType;
#else
    return INPUT_SOURCE_NONE;
#endif
}

INPUT_SOURCE_TYPE_t MHal_XC_GetOfflineSource(void * pInstance, SCALER_WIN eWindow)
{
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(eWindow == MAX_WINDOW)
    {
        return pXCResourcePrivate->stdrvXC_MVideo_Context.enOfflineSrcType;
    }
    else if(eWindow == MAIN_WINDOW)
    {
        return pXCResourcePrivate->stdrvXC_MVideo_Context.enOnlineSrcType[MAIN_WINDOW];
    }
    else if(eWindow == SUB_WINDOW)
    {
        return pXCResourcePrivate->stdrvXC_MVideo_Context.enOnlineSrcType[SUB_WINDOW];
    }
    else
#endif
    {
        return INPUT_SOURCE_NONE;
    }
}

void MHal_XC_SetOfflineSource(void * pInstance, SCALER_WIN eWindow, INPUT_SOURCE_TYPE_t enSrcType)
{
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    if(eWindow == MAX_WINDOW)
    {
        pXCResourcePrivate->stdrvXC_MVideo_Context.enOfflineSrcType = enSrcType;
    }
    else if(eWindow == MAIN_WINDOW)
    {
        pXCResourcePrivate->stdrvXC_MVideo_Context.enOnlineSrcType[MAIN_WINDOW] = enSrcType;
    }
    else //if(eWindow == SUB_WINDOW)
    {
        pXCResourcePrivate->stdrvXC_MVideo_Context.enOnlineSrcType[SUB_WINDOW] = enSrcType;
    }
#endif
    return;
}

void MHal_XC_FSS_Patch(void *pInstance,INPUT_SOURCE_TYPE_t PathSrc)
{
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
#if defined(HW_FSS_LIMITATION_CHIPREV)
    //FSS patch : if source type is VD => tradition path , else => FSS
    if(MDrv_SYS_GetChipRev() < HW_FSS_LIMITATION_CHIPREV)
    {
        if(IsSrcTypeDigitalVD(PathSrc))
        {
            MHal_XC_SetFSSEnable(pInstance, FALSE, MAIN_WINDOW);
        }
        else
        {
            MHal_XC_SetFSSEnable(pInstance, TRUE, MAIN_WINDOW);
        }
    }
#endif
#endif
}

void MHal_XC_Set_MIU_DynamicPriority(void *pInstance)
{
#if 1 //Need owner to check the corresponing regs setting.
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U16 u16MIUBufferSize = 0;

    //MIU type control enable.
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_01_L, BIT(0), BIT(0)); //MIU_TYPE_FE

    //High priority control enable.
    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_01_L, BIT(1), BIT(1)); //MIU_TYPE_FE

    //MIU TYPE FE:

    //IP 00 : G60, IPM_R
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_0C_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_28_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_20_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 01 : G60, OPM
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_0C_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_29_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_21_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 02 : G60, OD_R
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_0D_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_2A_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_22_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 03 : G60, ODW_R
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_0D_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_2B_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_23_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 04 : G60, DIPR0
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_0E_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_2C_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_24_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 05 : G61, DIPR0
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_0E_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_2D_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_25_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 06 : G61, DIPR1
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_0F_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_2E_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_26_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 07 : G61, DIPR1
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_0F_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_2F_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_27_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 08 : G61, GOP0
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_10_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_38_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_30_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 09 : G62, GOP1
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_10_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_39_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_31_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 10 : G62, GOP2
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_11_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_3A_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_32_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 11 : G64, MVOP0
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_11_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_3B_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_33_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 12 : G64, MVOP0
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_12_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_3C_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_34_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 13 : G64, MVOP1
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_12_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_3D_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_35_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 14 : G64, MVOP1
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_13_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_3E_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_36_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 15 : G64, HDR_DMA_R
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_13_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_3F_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_37_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 16 : G64, IPM_W
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_14_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_48_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_40_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 17 : G66, OPW
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_14_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_49_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_41_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 18 : G68, OD_W
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_15_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_4A_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_42_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 19 : G6B, ODW_W
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_15_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_4B_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_43_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 20 : G6B, PDW
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_16_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_4C_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_44_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 21 : G6C, DIPW
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_16_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_4D_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_45_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 22 : G6D, DIPW
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_17_L, LOW_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_4E_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_46_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }


    //IP 23 : G7C, HWE_W
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_17_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_4F_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_47_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 26 : G64, DDI_R
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_19_L, HIGH_BYTE_MASK);
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_5A_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_52_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

    //IP 27 : G79, DDI_W
    u16MIUBufferSize = SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4E_19_L, HIGH_BYTE_MASK) >> HIGH_BYTE_OFFSET;
    if(u16MIUBufferSize != 0)
    {
        SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_5B_L, ((u16MIUBufferSize*MIU_T1T2_THRESHOLD/100)<<HIGH_BYTE_OFFSET) | (u16MIUBufferSize*MIU_T0T1_THRESHOLD/100)); //[15:8]: t1t2 , [7:0]: t0t1
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK4F_53_L,  ((u16MIUBufferSize*MIU_HIGH_PRI_THRESHOLD/100)<<HIGH_BYTE_OFFSET) |BIT(6) , HIGH_BYTE_MASK | BIT(7) |BIT(6)); //high priority threshold and control by LEVEL
    }

#endif
}

MS_BOOL MHal_XC_IsHDMI420(void * pInstance, INPUT_SOURCE_TYPE_t enSrcType)
{
    MS_BOOL bIsHDMI420 = FALSE;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    EN_XC_INPUT_FSS_TYPE enBankSel = E_XC_INPUT_FSS_MAX;
    MS_U8 u8EnablePort = 0, u8Index = 0;
    E_MUX_INPUTPORT enSrcPort[3] = {INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT};
    if(enSrcType != INPUT_SOURCE_NONE)
    {
        MDrv_XC_Mux_GetPort(pInstance, enSrcType, enSrcPort, &u8EnablePort );
        for(u8Index = 0; u8Index < u8EnablePort; u8Index++)
        {
            enBankSel = MHal_XC_GetFSSMuxPort(pInstance, (E_INPUT_PORT_TYPE)enSrcPort[u8Index]);
        }
        switch(enBankSel)
        {

            case E_XC_INPUT_FSS_HDMI_P0:
                bIsHDMI420 = ((SC_EXT_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BKDF_1A_L) & BIT(2))==BIT(2))? TRUE : FALSE;
                break;
            case E_XC_INPUT_FSS_HDMI_P1:
                bIsHDMI420 = ((SC_EXT_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BKDF_1B_L) & BIT(2))==BIT(2))? TRUE : FALSE;
                break;
            case E_XC_INPUT_FSS_HDMI_P2:
                bIsHDMI420 = ((SC_EXT_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BKDF_1C_L) & BIT(2))==BIT(2))? TRUE : FALSE;
                break;
            case E_XC_INPUT_FSS_HDMI_P3:
                bIsHDMI420 = ((SC_EXT_R4BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BKDF_1D_L) & BIT(2))==BIT(2))? TRUE : FALSE;
                break;
            default:
                bIsHDMI420 = FALSE;
                break;
        }
    }
    else
    {
        bIsHDMI420 = FALSE;
    }
    return bIsHDMI420;
}

void MHal_XC_SetFSSHDMI420Enable(void * pInstance, INPUT_SOURCE_TYPE_t enSrcType, MS_BOOL bEnable)
{
    MS_U8 u8HDMIPort = 0;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    EN_XC_INPUT_FSS_TYPE enBankSel = E_XC_INPUT_FSS_MAX;
    MS_U8 u8EnablePort = 0, u8Index = 0;
    E_MUX_INPUTPORT enSrcPort[3] = {INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT, INPUT_PORT_NONE_PORT};
    if(enSrcType != INPUT_SOURCE_NONE)
    {
        MDrv_XC_Mux_GetPort(pInstance, enSrcType, enSrcPort, &u8EnablePort );
        for(u8Index = 0; u8Index < u8EnablePort; u8Index++)
        {
            enBankSel = MHal_XC_GetFSSMuxPort(pInstance, (E_INPUT_PORT_TYPE)enSrcPort[u8Index]);
        }
        switch(enBankSel)
        {

            case E_XC_INPUT_FSS_HDMI_P0:
                u8HDMIPort = 0 & (BMASK(1:0));
                break;
            case E_XC_INPUT_FSS_HDMI_P1:
                u8HDMIPort =  1 & (BMASK(1:0));
                break;
            case E_XC_INPUT_FSS_HDMI_P2:
                 u8HDMIPort = 2 & (BMASK(1:0));
                break;
            case E_XC_INPUT_FSS_HDMI_P3:
                 u8HDMIPort = 3 & (BMASK(1:0));
                break;
            default:
                 u8HDMIPort = 0;
                break;
        }
    }
    else
    {
        u8HDMIPort = 0;
    }
    if(IsSrcTypeHDMI(enSrcType) && (bEnable==TRUE))
    {
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKDF_20_L, u8HDMIPort, BIT(7)|(BMASK(1:0)));
    }
    else
    {
        SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKDF_20_L, BIT(7)|u8HDMIPort, BIT(7)|(BMASK(1:0))); // initila setting
    }
}

void MHal_XC_ConnectDisplay(void* pInstance,ST_XC_CONNECTDISPLAY *pstXCDispaly,SCALER_WIN enWindow)
{
    if(pstXCDispaly->bConnect == FALSE)
    {
        if((pstXCDispaly->enInputSourceType == INPUT_SOURCE_STORAGE) || (pstXCDispaly->enInputSourceType == INPUT_SOURCE_DTV))
        {
            Hal_SC_ip_software_reset(pInstance, REST_IP_F2, enWindow);
        }
    }
}
void MHal_XC_IdClkMappingPatch(void)
{
    MS_U16 u16CkgIdClkSel = 0;
    MS_U16 u16TempVal = 0;
    const MS_U16 u16Port3_IdClk2_Sel = 12;
    const MS_U16 u16Port4_IdClk2_Sel = 11;
    MS_U16 u16Lpll_IdClk_Sel= 0 ;
    u16CkgIdClkSel = MDrv_Read2Byte(L_BK_CHIPTOP(0x55));
    //Check 100b55 [5:2] =  reg_ckg_idclk2_sel
    u16CkgIdClkSel = u16CkgIdClkSel>>2;
    //If reg_ckg_idclk2_sel = 11 =>  100b59[15] = lpll_idclk_usr_en =1  , 100b59[13:8] = lpll_idclk_sel  =14
    //If reg_ckg_idclk2_sel = 12 =>  100b59[15] = lpll_idclk_usr_en =1  , 100b59[13:8] = lpll_idclk_sel  =15
    if(u16CkgIdClkSel == u16Port4_IdClk2_Sel)
    {
        u16Lpll_IdClk_Sel =14;
        u16TempVal |= BIT(15);
        u16TempVal |= (u16Lpll_IdClk_Sel<<10);
        MDrv_Write2ByteMask(L_BK_CHIPTOP(0x59),u16TempVal,0xFF00);
    }
    else if(u16CkgIdClkSel == u16Port3_IdClk2_Sel)
    {
        u16Lpll_IdClk_Sel = 15;
        u16TempVal |= BIT(15);
        u16TempVal |= (u16Lpll_IdClk_Sel<<10);
        MDrv_Write2ByteMask(L_BK_CHIPTOP(0x59),u16TempVal,0xFF00);
    }
    else
    {
        //Close lpll_idclk_usr_en
        // revserve bit 0~7 only clean 8~15
        u16TempVal = 0;
        MDrv_Write2ByteMask(L_BK_CHIPTOP(0x59),u16TempVal,0xFF00);
        //reset
        W2BYTEMSK(L_CLKGEN0(0x59), BIT(11), BIT(8) | BIT(10) | BIT(11));
    }
}

MS_U32 MHal_SC_GetIPCLK(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(eWindow == MAIN_WINDOW)
    {
        MS_U16 u16EDCLK = MDrv_ReadByte(REG_CKG_EDCLK_F2);
        if(u16EDCLK==0)
        { // CKG_EDCLK_F2_172MHZ
            return EDCLK_172MHZ;
        }
        else if(u16EDCLK & BIT(2))
        { // CKG_EDCLK_F2_345MHZ
            return EDCLK_345MHZ;
        }
        else if(u16EDCLK & BIT(3))
        { // CKG_EDCLK_F2_345MHZ
            return EDCLK_345MHZ;
        }
        else if((u16EDCLK & BIT(2)) && (u16EDCLK & BIT(3)))
        { // CKG_EDCLK_F2_216MHZ
            return EDCLK_216MHZ;
        }
        else if(u16EDCLK & BIT(4))
        { // CKG_EDCLK_F2_192MHZ
            return EDCLK_192MHZ;
        }
        else if((u16EDCLK & BIT(4)) && (u16EDCLK & BIT(2)))
        { // CKG_EDCLK_F2_240MHZ
            return EDCLK_240MHZ;
        }
        else if((u16EDCLK & BIT(4)) && (u16EDCLK & BIT(3)))
        { // CKG_EDCLK_F2_320MHZ
            return EDCLK_320MHZ;
        }
        else
        {
            return 0;
        }
    }
    else
    {
        MS_U16 u16EDCLK = MDrv_ReadByte(REG_CKG_EDCLK_F1);
        if(u16EDCLK==0)
        { // CKG_EDCLK_F2_172MHZ
            return EDCLK_172MHZ;
        }
        else if(u16EDCLK & BIT(2))
        { // CKG_EDCLK_F2_345MHZ
            return EDCLK_345MHZ;
        }
        else if(u16EDCLK & BIT(3))
        { // CKG_EDCLK_F2_345MHZ
            return EDCLK_345MHZ;
        }
        else if((u16EDCLK & BIT(2)) && (u16EDCLK & BIT(3)))
        { // CKG_EDCLK_F2_216MHZ
            return EDCLK_216MHZ;
        }
        else if(u16EDCLK & BIT(4))
        { // CKG_EDCLK_F2_192MHZ
            return EDCLK_192MHZ;
        }
        else if((u16EDCLK & BIT(4)) && (u16EDCLK & BIT(2)))
        { // CKG_EDCLK_F2_240MHZ
            return EDCLK_240MHZ;
        }
        else if((u16EDCLK & BIT(4)) && (u16EDCLK & BIT(3)))
        { // CKG_EDCLK_F2_320MHZ
            return EDCLK_320MHZ;
        }
        else
        {
            return 0;
        }
    }
}

MS_U32 MHal_SC_GetOPCLK(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U32 u32ODClk = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16DefaultHTotal
                     * pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16DefaultVTotal
                     * (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16DefaultVFreq / 10);

    return u32ODClk;
}

MS_BOOL MHal_SC_IsDistractHBlanking(void *pInstance, SCALER_WIN eWindow)
{
    return FALSE;
}

/*
// ______  blanking  ________
//   DE  |__________|   DE
//                  |dly|
//             |  ylock |
*/
void MHal_XC_SetYLockPoint(void* pInstance, MS_U8 u8YlockPoint, SCALER_WIN eWindow)
{
    MS_U16 u16Blanking = 0, u16VTT = 0;
    MS_U32 u32MemSync = 0;
    EN_XC_MEMSYNC_TO_VS enMemSyncToVS = E_XC_SAMPLE_VSTART_WITH_2YLOCK;

    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP == TRUE)
    if(IsSrcTypeStorage(gSrcInfo[MAIN_WINDOW].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        //for digital signal sometimes IP report not stable
        MVOP_Timing stMVOPTimingInfo = {0};
        MDrv_MVOP_GetOutputTiming(&stMVOPTimingInfo);
        u16VTT = stMVOPTimingInfo.u16V_TotalCount;
        if(MHal_XC_IsForceP(pInstance, MAIN_WINDOW))
        {
            u16VTT*= 2;
        }
    }
    else
    {
        u16VTT = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_1F_L, eWindow), BITMASK(12:0));
    }
    u32MemSync = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_21_L, eWindow), BITMASK(15:14)) >> 14;
#else
    if(IsSrcTypeStorage(gSrcInfo[MAIN_WINDOW].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        //for digital signal sometimes IP report not stable
        MVOP_Timing stMVOPTimingInfo = {0};
        MDrv_MVOP_GetOutputTiming(&stMVOPTimingInfo);
        u16VTT = stMVOPTimingInfo.u16V_TotalCount;
        if(MHal_XC_IsForceP(pInstance, MAIN_WINDOW))
        {
            u16VTT*= 2;
        }
    }
    else
    {
        u16VTT = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_1F_L, BITMASK(12:0));
    }
    u32MemSync = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_21_L, BITMASK(15:14)) >> 14;
#endif

    switch(u32MemSync)
    {
        case 0:
        {
            enMemSyncToVS = E_XC_SAMPLE_VSTART_WITH_2YLOCK;
            break;
        }
        case 1:
        {
            enMemSyncToVS = E_XC_SAMPLE_VSTART_WITH_YLOCK;
            break;
        }
        case 2:
        {
            enMemSyncToVS = E_XC_SAMPLE_VSTART;
            break;
        }
        case 3:
        {
            enMemSyncToVS = E_XC_SAMPLE_VEND;
            break;
        }
        default:
        {
            enMemSyncToVS = E_XC_SAMPLE_VEND;
            break;
        }
    }

    if(gSrcInfo[eWindow].stCapWin.height >= u16VTT)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "VDE is larger than VTT\n")
    }
    else
    {
        if(gSrcInfo[MAIN_WINDOW].bInterlace == TRUE)
        {
            u16Blanking = (u16VTT - gSrcInfo[eWindow].stCapWin.height) / 2;
        }
        else
        {
            u16Blanking = u16VTT - gSrcInfo[eWindow].stCapWin.height;
        }

        if(enMemSyncToVS == E_XC_SAMPLE_VSTART_WITH_2YLOCK)
        {
            if ((u16Blanking <= ((u8YlockPoint * 2) - gSrcInfo[eWindow].u8DelayLines))
              && ((u8YlockPoint * 2) > gSrcInfo[eWindow].u8DelayLines))
            {
                u8YlockPoint = (u16Blanking + gSrcInfo[eWindow].u8DelayLines - 1) / 2;
            }
        }
        else if(enMemSyncToVS == E_XC_SAMPLE_VSTART_WITH_YLOCK)
        {
            if ((u16Blanking <= (u8YlockPoint - gSrcInfo[eWindow].u8DelayLines))
              && (u8YlockPoint > gSrcInfo[eWindow].u8DelayLines))
            {
                u8YlockPoint = u16Blanking + gSrcInfo[eWindow].u8DelayLines - 1;
            }
        }
        else
        {
            XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "YLock doesn't need to be adjusted\n")
        }
    }

#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP == TRUE)
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_09_L, eWindow), u8YlockPoint, BITMASK(3:0));
#else
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_09_L, u8YlockPoint, BITMASK(3:0));
#endif
}

void MHal_XC_SetOPKeepFieldMode(void *pInstance, MS_BOOL bEnable, MS_BOOL bInterlace, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if (IS_FBL_OR_RFBL_MODE(eWindow))
    {
        bEnable = FALSE;
    }

    if (eWindow == MAIN_WINDOW)
    {
        if (bInterlace && bEnable)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_07_L, BIT(15), BIT(15));
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_07_L, 0, BIT(15));
        }
    }
    else
    {
        if (bInterlace && bEnable)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_47_L, BIT(15), BIT(15));
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_47_L, 0, BIT(15));
        }
    }
}

void MHal_XC_SetBOBMode(void *pInstance, MS_BOOL bEnable, MS_BOOL bInterlace, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if (eWindow == MAIN_WINDOW)
    {
        if (bInterlace && bEnable)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK22_78_L, 0x008F, 0x00FF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK22_79_L, 0x008F, 0x00FF);
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK22_78_L, 0, 0x00FF);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK22_79_L, 0, 0x00FF);
        }
    }
    else
    {
        if (bInterlace && bEnable)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK22_78_L, 0x8F00, 0xFF00);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK22_79_L, 0x8F00, 0xFF00);
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK22_78_L, 0, 0xFF00);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK22_79_L, 0, 0xFF00);
        }
    }
}

void Mhal_XC_ClockControl_SC_Slow(void* pInstance, MS_BOOL bEnable, MS_U16 u16ClkLevel)
{
    if(bEnable == TRUE)
    {
        if(u16ClkLevel == CKG_SC_SLOW_DEFAULT)
        {
            // Enable SC_SLOW Clk
            MDrv_WriteByteMask(REG_CKG_SC_SLOW, CKG_SC_SLOW_DEFAULT, CKG_SC_SLOW_DEFAULT);
            MDrv_WriteRegBit(REG_CKG_SC_SLOW, DISABLE, CKG_SC_SLOW_INVERT);
            MDrv_WriteRegBit(REG_CKG_SC_SLOW, DISABLE, CKG_SC_SLOW_GATED);
        }
        else
        {
            // Enable SC_SLOW Clk
            MDrv_WriteByteMask(REG_CKG_SC_SLOW, u16ClkLevel, u16ClkLevel);
            MDrv_WriteRegBit(REG_CKG_SC_SLOW, DISABLE, CKG_SC_SLOW_INVERT);
            MDrv_WriteRegBit(REG_CKG_SC_SLOW, DISABLE, CKG_SC_SLOW_GATED);
        }
    }
    else
    {
        //Disable SC_Slow Clock
        MDrv_WriteRegBit(REG_CKG_SC_SLOW, ENABLE, CKG_SC_SLOW_GATED);
    }
}

void MHal_XC_ClockControl(void* pInstance, MS_BOOL bAllEnable,MS_U16 u16ClkLevel)
{
    //SC Slow Clock
    Mhal_XC_ClockControl_SC_Slow(pInstance, bAllEnable,u16ClkLevel);
}

void MHal_XC_WriteFbNum(void* pInstance, MS_U32 UNUSED_PARA(u32Reg), MS_U8 u8FrameCount)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    P_SC_SWDB_INFO pDBreg = &pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg;
    pDBreg->u8FrameCount = u8FrameCount;
}

MS_BOOL MHal_XC_IsSupportDolbyReload(void* pInstance)
{
    return SUPPORT_DOLBY_RELOAD_SETTING;
}

MS_BOOL MHal_XC_IsSupportPQDSPlus(void)
{
    return SUPPORT_PQDS_PLUS;
}

void MHal_XC_IPVsyncTrig_Control(void * pInstance, MS_BOOL bInterlace, SCALER_WIN enWindow, P_SC_SWDB_INFO pDBreg)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U16 u16CapVstart = 0, u16CapVsize = 0, u16VTT = 0, u16DelayLine = 0, u16YLock = 0, u16IPVsyncTrig = 0, u16MemSync = 0, u16HandShakeStatus = 0;

    u16CapVstart = pDBreg->u16V_CapStart;
    u16CapVsize = pDBreg->u16V_CapSize;
#if defined(XC_SUPPORT_FASTSWITCH_BY_IP1GP) &&(XC_SUPPORT_FASTSWITCH_BY_IP1GP == TRUE)
    u16VTT = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_1F_L, enWindow), BITMASK(12:0));
    u16DelayLine = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_1C_L, enWindow), BITMASK(7:4))>> 4;
    u16YLock = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_09_L, enWindow), BITMASK(3:0));
    u16MemSync = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_21_L, enWindow), BITMASK(15:14)) >> 14;
#else
    u16VTT = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_1F_L, BITMASK(12:0));
    u16DelayLine = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_1C_L, BITMASK(7:4))>> 4;
    u16YLock = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_09_L, BITMASK(3:0));
    u16MemSync = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_21_L, BITMASK(15:14)) >> 14;
#endif
    //Get XC HSK
    // Bit0: Enable HSK mode
    // Bit2: reg_ip2_vs_sel 0:ip1 1:mvop
    // Bit5: reg_ip2_fd_sel 0:use ip1_field 1: use mvop_field
    u16HandShakeStatus = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK02_10_L);
    if(IsSrcTypeStorage(gSrcInfo[MAIN_WINDOW].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        //for digital signal sometimes IP report not stable
        MVOP_Timing stMVOPTimingInfo = {0};
        MDrv_MVOP_GetOutputTiming(&stMVOPTimingInfo);
        u16VTT = stMVOPTimingInfo.u16V_TotalCount;
        u16CapVstart = MDrv_MVOP_GetVStart();
    }
    if(bInterlace)
    {
        u16VTT = (u16VTT/2);
        u16CapVstart = (u16CapVstart/2);
        u16CapVsize = (u16CapVsize/2);
    }

    if((u16VTT + IPVSYNC_OFFSET) >= (u16CapVstart + u16CapVsize))
    {
        if(u16HandShakeStatus == 0x0025)
        {
            u16IPVsyncTrig = (u16VTT + IPVSYNC_OFFSET) - (u16CapVstart + u16CapVsize);
        }
        else
        {
            switch(u16MemSync)
            {
                case 0://E_XC_SAMPLE_VSTART_WITH_2YLOCK
                {
                    u16IPVsyncTrig = (u16VTT + IPVSYNC_OFFSET) - (u16CapVsize -u16DelayLine + (u16YLock*2));
                    break;
                }
                case 1://E_XC_SAMPLE_VSTART_WITH_YLOCK
                {
                    u16IPVsyncTrig = (u16VTT + IPVSYNC_OFFSET) - (u16CapVsize -u16DelayLine + u16YLock);
                    break;
                }
                case 2://E_XC_SAMPLE_VSTART
                {
                    u16IPVsyncTrig = (u16VTT + IPVSYNC_OFFSET) - (u16CapVsize);
                    break;
                }
                case 3://E_XC_SAMPLE_VEND
                {
                    u16IPVsyncTrig = IPVSYNC_OFFSET;
                    break;
                }
                default:
                {
                    u16IPVsyncTrig = 0;
                    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "Memory Sync not Support\n")
                    break;
                }
            }
        }
    }
    else
    {
        u16IPVsyncTrig = 0;
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "u16IPVsyncTrig point is Negative Value!!\n")
    }
    pXCResourcePrivate->u16IPVsyncTrig = u16IPVsyncTrig;
}
#if ((defined(MSOS_TYPE_OPTEE)) || (defined(MSOS_TYPE_NUTTX)))
static SCALER_WIN _MDrv_XC_PipID_Trans_Win(MS_U32 u32PipeID)
{
    if(u32PipeID == pipeID_SC0_main)
    {
        return MAIN_WINDOW;
    }
    else if (u32PipeID == pipeID_SC0_sub)
    {
        return SUB_WINDOW;
    }
    else if (u32PipeID == pipeID_SC1_main)
    {
        return MAIN_WINDOW;
    }
    else
    {
        //exception
        XC_LOG_TRACE(XC_DBGLEVEL_SVP, "_MDrv_XC_PipID_Trans_Win exception\n");
        return MAX_WINDOW;
    }
}
#endif

E_APIXC_ReturnValue MHal_XC_Memory_Enable(void * pInstance, ST_XC_MEM_ENABLE_CTRL* pstMemEnableCtrl)
{
    XC_LOG_TRACE(XC_DBGLEVEL_SVP, "Enter MHal_XC_Memory_Enable\n");
#if ((defined(MSOS_TYPE_OPTEE)) || (defined(MSOS_TYPE_NUTTX)))
    SCALER_WIN enWindow = _MDrv_XC_PipID_Trans_Win(pstMemEnableCtrl->u32PipeID);
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    _XC_SEMAPHORE_ENTRY(pInstance,E_XC_ID_VAR);

    if(enWindow == MAIN_WINDOW)
    {
        if(pstMemEnableCtrl->bEnable == FALSE)
        {
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN);
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_DUAL);
        }
        else
        {
            MHal_SC_Memory_Request_Force_Off(pInstance, FALSE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN);
            MHal_SC_Memory_Request_Force_Off(pInstance, FALSE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
            MHal_SC_Memory_Request_Force_Off(pInstance, FALSE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_DUAL);
        }

    }
    else if(enWindow ==SUB_WINDOW)
    {
        if(pstMemEnableCtrl->bEnable == FALSE)
        {
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB);
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB_OPW);
        }
        else
        {
            MHal_SC_Memory_Request_Force_Off(pInstance, FALSE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB);
            MHal_SC_Memory_Request_Force_Off(pInstance, FALSE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
            MHal_SC_Memory_Request_Force_Off(pInstance, FALSE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB_OPW);
        }
    }
    else
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SVP, "_MDrv_XC_PipID_Trans_Win Fail\n");
        _XC_SEMAPHORE_RETURN(pInstance,E_XC_ID_VAR);
        return E_APIXC_RET_FAIL;
    }
    _XC_SEMAPHORE_RETURN(pInstance,E_XC_ID_VAR);
    return E_APIXC_RET_OK;
#else
    return E_APIXC_RET_FAIL;
#endif
}

MS_BOOL MHal_XC_GetFrameLockStatus(void *pInstance)
{
    MS_BOOL bIsFrameLock = FALSE;

    if (TGEN_VTT_LOCK_MODE_VER != E_TGEN_VTT_LOCK_MODE_NOT_SUPPORT)
    {
        if (MHal_FRC_TGEN_GetFPLLDoneStatus(pInstance))
        {
            bIsFrameLock = TRUE;
        }
    }
    else
    {
        MS_BOOL bIsLockFreqOnly = (MDrv_ReadRegBit(L_BK_LPLL(0x70), BIT(15))>>15);
        if((MDrv_ReadRegBit(L_BK_LPLL(0x0C), BIT(3)) >> 3))
        {
            if(bIsLockFreqOnly) // lock freq only
            {
                if((R2BYTEMSK(L_BK_LPLL(0x2A), 0x1FF))==0xF4)
                {
                    bIsFrameLock = TRUE;
                }
            }
            else
            {
                if((R2BYTEMSK(L_BK_LPLL(0x2A), 0x1FF))==0x1F4)
                {
                    bIsFrameLock = TRUE;
                }
            }
        }
    }

    return bIsFrameLock;
}

E_APIXC_ReturnValue MHal_XC_GetFrameLockDelay(void* pInstance, ST_XC_VIDEO_LATENCY_INFO* pstVideoLantencyInfo, SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U8   u8FRCIn = 0;
    MS_U8  u8Idx = 0;
    MS_U32 u32PhaseDifValue = 0;
    MS_U32 u32IvsPerValue = 0;
    MS_U16 u16OutputFrameRate = 0;

    // use input frame rate to predict frame lock delay
    if(pstVideoLantencyInfo->u32Version > 1 && pstVideoLantencyInfo->u16InputFrameRate > 0)
    {
        SC_FRC_SETTING astCurFRCTbl[MAX_FRC_TABLE_INDEX];
        memset(astCurFRCTbl, 0, sizeof(SC_FRC_SETTING)*MAX_FRC_TABLE_INDEX);
        MDrv_SC_GetCurrentFRCTable(astCurFRCTbl);

        // find output frame rate corresponding to the input frame rate
        for (u8Idx = 0; u8Idx < sizeof(astCurFRCTbl)/sizeof(SC_FRC_SETTING); u8Idx++)
        {
            if (astCurFRCTbl[u8Idx].u16LowerBound < pstVideoLantencyInfo->u16InputFrameRate &&
                pstVideoLantencyInfo->u16InputFrameRate <= astCurFRCTbl[u8Idx].u16HigherBound &&
                astCurFRCTbl[u8Idx].u8FRC_In != 0)
            {
                u16OutputFrameRate = pstVideoLantencyInfo->u16InputFrameRate * astCurFRCTbl[u8Idx].u8FRC_Out / astCurFRCTbl[u8Idx].u8FRC_In;
            }
        }

        if (u16OutputFrameRate > 0)
        {
            if(u16OutputFrameRate >= 595 && u16OutputFrameRate < 605)
            {
                u16OutputFrameRate = 600;
            }
            else if(u16OutputFrameRate >= 495 && u16OutputFrameRate < 505)
            {
                u16OutputFrameRate = 500;
            }
            else if(u16OutputFrameRate >= 295 && u16OutputFrameRate < 305)
            {
                u16OutputFrameRate = 300;
            }
            else if(u16OutputFrameRate >= 245 && u16OutputFrameRate < 255)
            {
                u16OutputFrameRate = 250;
            }
            else if(u16OutputFrameRate >= 235 && u16OutputFrameRate < 245)
            {
                u16OutputFrameRate = 240;
            }
            else
            {
                u16OutputFrameRate = u16OutputFrameRate;
            }

            // return half output frame time
            pstVideoLantencyInfo->u32VideoLatency = 500000000 / u16OutputFrameRate * 10; // unit: ns
        }
    }
    else if(gSrcInfo[MAIN_WINDOW].Status2.u16OutputVFreqAfterFRC == 0)
    {
        return E_APIXC_RET_FAIL;
    }
    else
    {
        // lock at the middle of VDE (about half of output frame time)
        // 1 sec(unit ns) / frame_rate(unit 0.1 frame) * 10 / half
        pstVideoLantencyInfo->u32VideoLatency = (1000000000/gSrcInfo[MAIN_WINDOW].Status2.u16OutputVFreqAfterFRC)*10/2; // unit: ns
        //this is a patch for DTV01840411 issue. framelock delay return value randomly too large. This funtion need to fix later.
    }

/*
    u32PhaseDifValue = (MS_U32)(MDrv_ReadByte(L_BK_LPLL(0x3E)) << 16) | (MS_U32)(MDrv_Read2Byte(L_BK_LPLL(0x3D)));

    pstVideoLantencyInfo->bIsLeading = TRUE;    // todo: need to read from reg.  (MS_BOOL)!R2BYTEMSK(L_BK_LPLL(0x3F), 0x0);

    if(pstVideoLantencyInfo->bIsLeading)
    {
        u32IvsPerValue = (MS_U32)(MDrv_ReadByte(L_BK_LPLL(0x22)) << 16) | (MS_U32)(MDrv_Read2Byte(L_BK_LPLL(0x21)));

        if(u32IvsPerValue > u32PhaseDifValue)
        {
            u8FRCIn = R2BYTEMSK(H_BK_LPLL(0x0C), 0xF) + 1;
            pstVideoLantencyInfo->u32VideoLatency = ((u32IvsPerValue * u8FRCIn - u32PhaseDifValue) * NS_PER_XTAL_CLK_24M); //ns   MAX: 0xFFFFFF * 0x4 * 0x29 = 0xA3FFFF5C
        }
        else
        {
            return E_APIXC_RET_FAIL;
        }
    }
    else //lagging
    {
        pstVideoLantencyInfo->u32VideoLatency = (u32PhaseDifValue * NS_PER_XTAL_CLK_24M); //ns   MAX: 0xFFFFFF * 0x29 = 0x28FFFFFD7
    }
*/
    return E_APIXC_RET_OK;
}

MS_BOOL MHal_XC_IsForceP(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    if(((gSrcInfo[eWindow].Status2.bEnable_ForceP == TRUE)) && (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_21_L, MAIN_WINDOW), BIT(0) | BIT(1)) == 0x03))
#else
    if(((gSrcInfo[eWindow].Status2.bEnable_ForceP == TRUE)) && (SC_R2BYTEMSK(psXCInstPri->u32DeviceID,  REG_SC_BK01_21_L, BIT(0) | BIT(1)) == 0x03))
#endif
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}
static MS_BOOL _MHal_XC_EnableOPMRequestMask(void* pInstance,MS_BOOL bEnable)
{
    if(bEnable == TRUE)
    {
        SC_W2BYTEMSK(0, REG_SC_BK12_34_L, BIT(6), BIT(6));
        SC_W2BYTEMSK(0, REG_SC_BK12_67_L, BIT(1), BIT(1));
    }
    else
    {
        SC_W2BYTEMSK(0, REG_SC_BK12_34_L, 0, BIT(6));
        SC_W2BYTEMSK(0, REG_SC_BK12_67_L, 0, BIT(1));
    }

    return TRUE;
}

#if (XC_SUPPORT_IOMMU == TRUE)

MS_PHY MHal_XC_GetMMAAddr(void *pInstance, MS_U32 u32MMASize,MS_BOOL bSecure,SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_PHY phyBaseAddress = XC_INVALID_MEM;
    MS_U8 au8BufTag[XC_TAG_NAME_LEN_MAX];
    memset(au8BufTag, 0, sizeof(au8BufTag));
#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
    if(psXCInstPri->u32DeviceID == 1)
    {
        memcpy(au8BufTag, MMA_XC_SUB_TAG_NAME, strlen(MMA_XC_SUB_TAG_NAME)+1);
    }
    else if(psXCInstPri->u32DeviceID == 0)
    {
        memcpy(au8BufTag, MMA_XC_MAIN_TAG_NAME, strlen(MMA_XC_MAIN_TAG_NAME)+1);
    }
#else
    if(enWindow == SUB_WINDOW)
    {
        memcpy(au8BufTag, MMA_XC_SUB_TAG_NAME, strlen(MMA_XC_SUB_TAG_NAME)+1);
    }
    else if(enWindow == MAIN_WINDOW)
    {
        memcpy(au8BufTag, MMA_XC_MAIN_TAG_NAME, strlen(MMA_XC_MAIN_TAG_NAME)+1);
    }
#endif

    if(bSecure == FALSE)
    {
        if(MsOS_MMA_Alloc(au8BufTag,u32MMASize,&phyBaseAddress,NULL) == FALSE)
        {
            printf("%s,%d alloc mma fail\n",__FUNCTION__,__LINE__);
        }
    }
    else
    {
        if(MsOS_MMA_Sec_Alloc(au8BufTag,u32MMASize, &phyBaseAddress, NULL) == FALSE)
        {
            printf("%s,%d alloc mma fail\n",__FUNCTION__,__LINE__);
        }
    }
    return phyBaseAddress;
}

MS_BOOL MHal_XC_UnauthorizeMMA(void *pInstance,SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_PHY phyBaseAddress = pXCResourcePrivate->stdrvXC_MVideo.aphyXCMMABaseAddress[enWindow];

    if(phyBaseAddress != XC_INVALID_MEM)
    {
        //xc do not access memory
        ///1.opm mask
        _MHal_XC_EnableOPMRequestMask(pInstance,ENABLE);
        ///2.do not access address
        if(enWindow == MAIN_WINDOW)
        {
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN);
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
        }
        else if(enWindow == SUB_WINDOW)
        {
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB);
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB_OPW);
        }

        if(MsOS_MMA_Sec_Unauthorize(phyBaseAddress) == 0)
        {
            printf("%s,%d XC Unauthorize fail\n",__FUNCTION__,__LINE__);
        }

    }
    else
    {
        printf("%s,%d,this mem is invalid!\n",__FUNCTION__,__LINE__);
        return FALSE;
    }
    return TRUE;
}

MS_BOOL MHal_XC_AuthorizeMMA(void *pInstance,SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_U32 u32pipeID  = pXCResourcePrivate->stdrvXC_MVideo.au32pipeID[enWindow];
    MS_U64 phyBaseAddress = pXCResourcePrivate->stdrvXC_MVideo.aphyXCMMABaseAddress[enWindow];

    if (pXCResourcePrivate->stdrvXC_MVideo.abXCMMANeedAuthorize[enWindow] == TRUE)
    {
        if (MsOS_MMA_Sec_AuthorizeFromPipeConfig(phyBaseAddress, u32pipeID) != TRUE)
        {
            printf("%s,%d sec authorize addr: 0x%llx u2pipeID:0x%x from pipe config fail\n",__FUNCTION__,__LINE__, phyBaseAddress, u32pipeID);
        }
        else
        {
            pXCResourcePrivate->stdrvXC_MVideo.abXCMMANeedAuthorize[enWindow] = FALSE;
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"MMA authorize addr: 0x%llx u2pipeID:0x%x from pipe Pass.\n", phyBaseAddress, u32pipeID);
        }
    }

    return TRUE;
}

MS_BOOL MHal_XC_ReleaseMMA(void *pInstance,SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_PHY phyBaseAddress = pXCResourcePrivate->stdrvXC_MVideo.aphyXCMMABaseAddress[enWindow];

    if(phyBaseAddress != XC_INVALID_MEM)
    {
        //xc do not access memory
        ///1.opm mask
        _MHal_XC_EnableOPMRequestMask(pInstance,ENABLE);
        ///2.do not access address
        if(enWindow == MAIN_WINDOW)
        {
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN);
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
        }
        else if(enWindow == SUB_WINDOW)
        {
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB);
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB_OPW);
        }

        if(MsOS_MMA_free(phyBaseAddress) == 0)
        {
            printf("%s,%d free mma fail\n",__FUNCTION__,__LINE__);
        }
        else
        {
            pXCResourcePrivate->stdrvXC_MVideo.au32PreMMAXCSize[enWindow] = 0;
            pXCResourcePrivate->stdrvXC_MVideo.aphyXCMMABaseAddress[enWindow] = XC_INVALID_MEM;
            pXCResourcePrivate->stdrvXC_Scaling._au32PreFBAddress[enWindow] = XC_INVALID_MEM;
            pXCResourcePrivate->stdrvXC_Scaling._au32PreFBSize[enWindow] = 0;
        }
    }
    else
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"this mem is invalid!\n");
        return FALSE;
    }
    return TRUE;
}
MS_U32 MHal_XC_GetMMAUsingBufferSize(void *pInstance,SCALER_WIN enWindow)
{
    MS_U32 u32MMAMemSCMSize = 0;
    ST_PQ_StatusEx stStatus;
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    MVOP_Handle stMvopHd = {E_MVOP_MODULE_MAIN};
    MVOP_RgbFormat enRGB = E_MVOP_RGB_NONE;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    memset(&stStatus, 0, sizeof(ST_PQ_StatusEx));
    stStatus.u32ApiStatusEx_Version = ST_PQ_STATUSEX_VERSION;
    stStatus.u16ApiStatusEX_Length = sizeof(ST_PQ_StatusEx);

#if PIP_PATCH_USING_SC1_MAIN_AS_SC0_SUB
    if(psXCInstPri->u32DeviceID == 1)
    {
        u32MMAMemSCMSize = XC_CMA_24MB;

        return u32MMAMemSCMSize;
    }
#endif

    if(MDrv_MVOP_GetCommand(&stMvopHd, E_MVOP_CMD_GET_RGB_FMT, &enRGB, sizeof(MVOP_RgbFormat)) != E_MVOP_OK)
    {
        printf("%s %d,mvop get cmd fail!\n",__FUNCTION__,__LINE__);
    }

    if(MDrv_PQ_GetStatusEx(&stStatus) == FALSE)
    {
        printf("%s %d,get status fail!\n",__FUNCTION__,__LINE__);
    }
    //4K2K panel case
    if((g_IPanel.Width() <= XC_4K2K_WIDTH_MAX) && (g_IPanel.Height() <= XC_4K2K_HIGH_MAX)
        && (g_IPanel.Width() >= XC_4K2K_WIDTH_MIN) && (g_IPanel.Height() >= XC_4K2K_HIGH_MIN))
    {
        if (pXCResourcePrivate->sthal_Optee.op_tee_xc[MAIN_WINDOW].isEnable == TRUE)
        {
            //By this time, DS & gSrcInfo haven't been updated.
            //So use the maximum memory size for sources with svp flow(DTV so far).
            u32MMAMemSCMSize = XC_CMA_26MB;
        }
        //photo
        else if (stStatus.stPQ_MuliMedia_Info[enWindow].eType == E_PQ_MULTIMEDIA_PHOTO && IsSrcTypeStorage(gSrcInfo[enWindow].enInputSourceType))
        {
            if(enRGB == E_MVOP_RGB_888)
            {
                u32MMAMemSCMSize = XC_CMA_76MB;
            }
            else
            {
                u32MMAMemSCMSize = XC_CMA_64MB;
            }
        }
        else if ((MDrv_XC_Is_DSForceIndexEnabled(pInstance, MAIN_WINDOW) || MDrv_XC_GetDynamicScalingStatus(pInstance))
            && (IsSrcTypeStorage(gSrcInfo[enWindow].enInputSourceType) || (IsSrcTypeDTV(gSrcInfo[enWindow].enInputSourceType))))
        {
            // MM/P mode use 4K2K virtualbox, MM/I mode use FHD virtualbox.
            if (gSrcInfo[(enWindow)].bInterlace)
            {
                u32MMAMemSCMSize = XC_CMA_26MB;
            }
            else
            {
                if((gSrcInfo[(enWindow)].stCapWin.width>= 3840) || (gSrcInfo[(enWindow)].stCapWin.height>= 2160))
                { // need consider I/P change case
                    u32MMAMemSCMSize = XC_CMA_22MB;//for FBL+UC case
                }
                else
                {
                    u32MMAMemSCMSize = XC_CMA_22MB;//for PQDS+ case that xc VB size is FHD
                }
            }
        }
        else if(IsSrcTypeStorage(gSrcInfo[enWindow].enInputSourceType) || (IsSrcTypeDTV(gSrcInfo[enWindow].enInputSourceType)))
        {
            if ((gSrcInfo[(enWindow)].stCapWin.width>= 3840) || (gSrcInfo[(enWindow)].stCapWin.height>= 2160))
            {
                u32MMAMemSCMSize = XC_CMA_9MB;
            }
            else
            {
                u32MMAMemSCMSize = XC_CMA_22MB;
            }
        }
        else//HDMI and others
        {
            if ((gSrcInfo[(enWindow)].stCapWin.width>= 3840) || (gSrcInfo[(enWindow)].stCapWin.height>= 2160))
            {
                u32MMAMemSCMSize = XC_CMA_85MB;
            }
            else
            {
                u32MMAMemSCMSize = XC_CMA_22MB;
            }
        }
    }
    else //FHD mode
    {
        if (pXCResourcePrivate->sthal_Optee.op_tee_xc[MAIN_WINDOW].isEnable == TRUE)
        {
            //By this time, DS & gSrcInfo haven't been updated.
            //So use the maximum memory size for sources with svp flow(DTV so far).
            u32MMAMemSCMSize = XC_CMA_22MB;
        }
        //photo RGB
        else if ((IsSrcTypeStorage(gSrcInfo[enWindow].enInputSourceType)) && (enRGB == E_MVOP_RGB_888))
        {
            u32MMAMemSCMSize = XC_CMA_19MB;
        }
        else if ((MDrv_XC_Is_DSForceIndexEnabled(pInstance, MAIN_WINDOW) || MDrv_XC_GetDynamicScalingStatus(pInstance))
            && (IsSrcTypeStorage(gSrcInfo[enWindow].enInputSourceType) || (IsSrcTypeDTV(gSrcInfo[enWindow].enInputSourceType))))
        {
            //if inputsource is 4K2K,it will be prescaled down to FHD by vdec.
            u32MMAMemSCMSize = XC_CMA_22MB;
        }
        else if(IsSrcTypeStorage(gSrcInfo[enWindow].enInputSourceType) || (IsSrcTypeDTV(gSrcInfo[enWindow].enInputSourceType)))
        {
            //if inputsource is 4K2K,it will be prescaled down to FHD by vdec.
            u32MMAMemSCMSize = XC_CMA_22MB;
        }
        else//HDMI and others
        {
            //if inputsource is 4K2K,it will be prescaled down to FHD by vdec.
            u32MMAMemSCMSize = XC_CMA_22MB;
        }
    }
    return u32MMAMemSCMSize;
}

MS_PHY MHal_XC_HseGetMMAAddr(void *pInstance, MS_U32 u32MMASize, MS_BOOL bSecure, SCALER_WIN enWindow)
{
    MS_PHY phyBaseAddress = XC_INVALID_MEM;
    MS_U8 au8BufTag[XC_TAG_NAME_LEN_MAX] = MMA_XC_HSE_TAG_NAME;

    UNUSED(pInstance);

#if (XC_SUPPORT_HSE == TRUE)
    //Only Main window supports HSE MMA buffer
    if(enWindow == MAIN_WINDOW)
    {
        if(bSecure == FALSE)
        {
            if(MsOS_MMA_Alloc(au8BufTag, u32MMASize, &phyBaseAddress, NULL) == FALSE)
            {
                printf("%s,%d alloc mma fail\n",__FUNCTION__,__LINE__);
            }
        }
        else
        {
            if(MsOS_MMA_Sec_Alloc(au8BufTag, u32MMASize, &phyBaseAddress, NULL) == FALSE)
            {
                printf("%s,%d alloc mma fail\n",__FUNCTION__,__LINE__);
            }
        }
    }
#endif
    return phyBaseAddress;
}

MS_BOOL MHal_XC_HseReleaseMMA(void *pInstance, SCALER_WIN enWindow)
{
#if (XC_SUPPORT_HSE == TRUE)
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_PHY phyBaseAddress = pXCResourcePrivate->stdrvXC_MVideo.phyHSEMMABaseAddress;

    //Only Main window supports HSE MMA buffer
    if(enWindow == MAIN_WINDOW)
    {
        if(phyBaseAddress != XC_INVALID_MEM)
        {
            if(MsOS_MMA_free(phyBaseAddress) == 0)
            {
                printf("[%s,%d] Free mma fail!\n",__FUNCTION__,__LINE__);
            }
            else
            {
                if(pXCResourcePrivate->stdrvXC_MVideo.phyFRCPQMMABaseAddress == pXCResourcePrivate->stdrvXC_MVideo.phyHSEMMABaseAddress)
                {
                    pXCResourcePrivate->stdrvXC_MVideo.phyFRCPQMMABaseAddress = XC_INVALID_MEM;
                    pXCResourcePrivate->stdrvXC_MVideo.u32PreMMAFRC_PQSize = 0;
                }

                pXCResourcePrivate->stdrvXC_MVideo.phyHSEMMABaseAddress = XC_INVALID_MEM;
            }
        }
        else
        {
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"This mem is invalid!\n");
            return FALSE;
        }
    }
#endif
    return TRUE;
}

MS_BOOL MHal_XC_HseAuthorizeMMA(void *pInstance, SCALER_WIN enWindow)
{
#if (XC_SUPPORT_HSE == TRUE)
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_U32 u32pipeID  = pXCResourcePrivate->stdrvXC_MVideo.au32pipeID[enWindow];
    MS_PHY phyBaseAddress = pXCResourcePrivate->stdrvXC_MVideo.phyHSEMMABaseAddress;

    //Only Main window supports HSE MMA buffer
    if (enWindow == MAIN_WINDOW)
    {
        if (MsOS_MMA_Sec_AuthorizeFromPipeConfig(phyBaseAddress, u32pipeID) != TRUE)
        {
            printf("%s,%d sec authorize addr: 0x%llx u2pipeID:0x%x from pipe config fail\n",__FUNCTION__,__LINE__, phyBaseAddress, u32pipeID);
        }
        else
        {
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW,"MMA authorize addr: 0x%llx u2pipeID:0x%x from pipe Pass.\n", phyBaseAddress, u32pipeID);
        }
    }
#endif
    return TRUE;
}

MS_BOOL MHal_XC_HseUnauthorizeMMA(void *pInstance, SCALER_WIN enWindow)
{
#if (XC_SUPPORT_HSE == TRUE)
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_PHY phyBaseAddress = pXCResourcePrivate->stdrvXC_MVideo.phyHSEMMABaseAddress;

    if(phyBaseAddress != XC_INVALID_MEM)
    {
        //Only Main window supports HSE MMA buffer
        if(enWindow == MAIN_WINDOW)
        {
            if(MsOS_MMA_Sec_Unauthorize(phyBaseAddress) == 0)
            {
                printf("%s,%d XC Unauthorize fail\n",__FUNCTION__,__LINE__);
            }
        }
    }
    else
    {
        printf("%s,%d,This mem is invalid!\n",__FUNCTION__,__LINE__);
        return FALSE;
    }
#endif
    return TRUE;
}

MS_PHY MHal_XC_HdmiDMAGetMMAAddr(void *pInstance,MS_U32 u32MMASize,MS_BOOL bSecure,SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_PHY phyBaseAddress = 0;
    MS_U8 au8BufTag[XC_TAG_NAME_LEN_MAX] = MMA_XC_HDR_TAG_NAME;

    if(bSecure == FALSE)
    {
        if(MsOS_MMA_Alloc(au8BufTag,u32MMASize,&phyBaseAddress,NULL) == 0)
        {
            printf("%s,%d alloc mma fail\n",__FUNCTION__,__LINE__);
        }
        else
        {
            pXCResourcePrivate->stdrvXC_MVideo.u32PreMMAHDMIDMASize = u32MMASize;
        }
    }
    else
    {
        if(MsOS_MMA_Sec_Alloc(au8BufTag,u32MMASize, &phyBaseAddress, NULL) == 0)
        {
            printf("%s,%d alloc mma fail\n",__FUNCTION__,__LINE__);
        }
        else
        {
            MS_U32 u32pipeID  = pXCResourcePrivate->stdrvXC_MVideo.au32pipeID[enWindow];
            pXCResourcePrivate->stdrvXC_MVideo.u32PreMMAHDMIDMASize = u32MMASize;
            if(MsOS_MMA_Sec_AuthorizeFromPipeConfig(phyBaseAddress, u32pipeID) != TRUE)
            {
                printf("%s,%d sec authorize  from pipe config fail\n",__FUNCTION__,__LINE__);
            }
        }
    }

    return phyBaseAddress;
}

MS_BOOL MHal_XC_HdmiDMAReleaseMMA(void *pInstance,SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    if (enWindow == MAIN_WINDOW)
    {
        MS_PHY phyBaseAddress = pXCResourcePrivate->stdrvXC_MVideo.phyHDMIDMAMMABaseAddress;

        if(phyBaseAddress != XC_INVALID_MEM)
        {
            if(MsOS_MMA_free(phyBaseAddress) == 0)
            {
                printf("%s,%d free mma fail\n",__FUNCTION__,__LINE__);
            }
            else
            {
                pXCResourcePrivate->stdrvXC_MVideo.phyHDMIDMAMMABaseAddress = XC_INVALID_MEM;
                pXCResourcePrivate->stdrvXC_MVideo.u32PreMMAHDMIDMASize = 0;
            }
        }
        else
        {
            printf("%s,%d,this mem is null!\n",__FUNCTION__,__LINE__);
            return FALSE;
        }
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

MS_BOOL MHal_XC_SetPeripheralAID(void* pInstance,MS_BOOL bSecure,SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(IsSrcTypeHDMI(gSrcInfo[enWindow].enInputSourceType))
    {
        if(bSecure == TRUE)
        {
            MDrv_WriteByteMask(REG_IPMUX_39_L, BIT(1), BIT(1));
        }
        else
        {
            MDrv_WriteByteMask(REG_IPMUX_39_L, 0, BIT(1));
        }
    }

    return TRUE;
}
#endif

MS_BOOL MHal_XC_EnableDualAIDSource(void* pInstance,MS_BOOL bEnable)
{
    if(bEnable == TRUE)
    {
        MDrv_WriteByteMask(REG_IPMUX_3F_L, BIT(0), BIT(0));
    }
    else
    {
        MDrv_WriteByteMask(REG_IPMUX_3F_L, 0, BIT(0));
    }

    return TRUE;
}

MS_BOOL MHal_XC_SetDualAID(void* pInstance,MS_BOOL bSecure,EN_XC_DRAM_AID enDramAID)
{
    MS_U8 u8BitMask = (MS_U8)enDramAID;
    if(bSecure == TRUE)
    {
        MDrv_WriteByteMask(REG_IPMUX_39_L, BIT(u8BitMask), BIT(u8BitMask));
    }
    else
    {
        MDrv_WriteByteMask(REG_IPMUX_39_L, 0, BIT(u8BitMask));
    }

    return TRUE;
}

MS_U8 MHal_XC_GetOPTeeVersion(MS_U8 u8OPTEEVersion)
{
    MS_U8 u8Memorytype = 0;
    MS_U8 u8Version = 0;
#if (XC_SUPPORT_IOMMU == TRUE)
    u8Memorytype = E_XC_MEM_IOMMU;
#elif(XC_SUPPORT_CMA == TRUE)
    u8Memorytype = E_XC_MEM_CMA;
#else
    u8Memorytype = E_XC_MEM_DEFAULT;
#endif
/* Bit [0-1] 1bit 9bit Bit[2-3] CMA /IOMMU/Static bit[4-7] Version*/
    u8OPTEEVersion = (E_XC_OPTEE_VER_9BIT)|(u8Memorytype<<SVP_MEM_TYPE_OFFSET)|(u8OPTEEVersion<<SVP_VERSION_OFFSET);
    return u8OPTEEVersion;
}

#if (((!defined(DONT_USE_CMA))&&(XC_SUPPORT_CMA == TRUE)) || (XC_SUPPORT_IOMMU == TRUE))
void MHal_SC_Memory_Access_Control(void *pInstance, const ST_XC_MEM_REQ_CTRL *pstMemReqCtrl)
{
    if(pInstance == NULL || pstMemReqCtrl == NULL)
    {
        printf("[%s,%5d] Error: null pointer!!!\n",__FUNCTION__,__LINE__);
        return;
    }

#if (XC_SUPPORT_IOMMU == TRUE)
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    SCALER_WIN enWindow = pstMemReqCtrl->enWindow;
    MS_BOOL bSCMIReqOff = pstMemReqCtrl->bSCMIReqOff;

    if(pXCResourcePrivate->stdrvXC_MVideo_Context.au8BufTagInfoSupport[enWindow] == TRUE)
    {
        if(enWindow == MAIN_WINDOW)
        {
            //Only main window needs opm mask/unmask.
            _MHal_XC_EnableOPMRequestMask(pInstance, bSCMIReqOff);

            MHal_SC_Memory_Request_Force_Off(pInstance, bSCMIReqOff, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN);
            MHal_SC_Memory_Request_Force_Off(pInstance, bSCMIReqOff, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
        }
        else if(enWindow == SUB_WINDOW)
        {
            MHal_SC_Memory_Request_Force_Off(pInstance, bSCMIReqOff, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB);
            MHal_SC_Memory_Request_Force_Off(pInstance, bSCMIReqOff, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB_OPW);
        }
    }
#elif ((!defined(DONT_USE_CMA)) && (XC_SUPPORT_CMA == TRUE))
    MHal_SC_Memory_Request_Force_Off(pInstance, pstMemReqCtrl->bSCMIReqOff, E_XC_FORCE_MEMORY_REQUEST_OFF_ALL);
#endif
}
#endif

void MHal_XC_SetTimeStamp(void *pInstance, SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
/*
    [14]reg_hdmi_v_stamp_in_sel     => 0: HDMI, 1: MVOP
    [15]reg_hdmi_v_stamp_out_sel   => 0: reg_hdmi_v_stamp_sc_opm, 1: reg_hdmi_v_stamp_frc_opm
*/

#ifdef FRC_INSIDE
    if(IsSrcTypeStorage(gSrcInfo[enWindow].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[enWindow].enInputSourceType))
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK1F_55_L, (BIT(14)|BIT(15)) , (BIT(15)|BIT(14)));//MVOP in + frc out
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK1F_55_L, BIT(15) , (BIT(15)|BIT(14)));//HDMI in + frc out
    }
#else
    if(IsSrcTypeStorage(gSrcInfo[enWindow].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[enWindow].enInputSourceType))
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK1F_55_L, BIT(14), (BIT(15)|BIT(14)));//MVOP in + sc out
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK1F_55_L, 0x0 , (BIT(15)|BIT(14)));//HDMI in + sc out
    }
#endif

}

MS_BOOL Hal_SC_NeedXCH8Align(void *UNUSED_PARA(pInstance))
{
    return (XC_H8ALIGN_PATCH && (!_bProcFSXC8AlignDisable)); //_bProcFSXC8AlignEnable is for procfs debug
}

MS_BOOL Hal_SC_NeedXCV8Align(void *UNUSED_PARA(pInstance))
{
    return (XC_V8ALIGN_PATCH && (!_bProcFSXC8AlignDisable)); //_bProcFSXC8AlignEnable is for procfs debug
}


void Hal_SC_8AlignPatchBy2ndSDE(void *pInstance,MS_BOOL bMenuloadEnable, MS_WINDOW_TYPE *pdspwin)
{
    if (Hal_SC_NeedXCV8Align(pInstance) || Hal_SC_NeedXCH8Align(pInstance))
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW," XC_8ALIGN_PATCH ENABLE\n");

        pdspwin->width = XC8ALIGN(pdspwin->width);
        if (Hal_SC_NeedXCV8Align(pInstance))
        {
            pdspwin->height = XC8ALIGN(pdspwin->height);
        }

        if(bMenuloadEnable)
        {
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_01_L, BIT(3), BIT(3));
            if(pdspwin->width != 0)
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_0B_L, pdspwin->x, 0x3FFF); //pixel shift HFDE start
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_0C_L, (pdspwin->x + pdspwin->width - 1), 0x3FFF); //pixel shift HFDE end
            }
            if(pdspwin->height != 0)
            {
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_0D_L, pdspwin->y, 0x1FFF); //pixel shift VFDE start
                MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_0E_L, (pdspwin->y + pdspwin->height - 1), 0x1FFF); //pixel shift VFDE end
            }
            MDrv_XC_MLoad_WriteCmd(pInstance, REG_SC_BK0F_27_L, BIT(15), BIT(15)); //osd ref to original
        }
        else
        {
            XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
            UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_27_L, BIT(15), BIT(15)); //osd ref to original
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_01_L, BIT(3), BIT(3));
            if(pdspwin->width != 0)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_0B_L, pdspwin->x, 0x3FFF); //pixel shift HFDE start
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_0C_L, (pdspwin->x + pdspwin->width - 1), 0x3FFF); //pixel shift HFDE end
            }
            if(pdspwin->height != 0)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_0D_L, pdspwin->y, 0x1FFF); //pixel shift VFDE start
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_0E_L, (pdspwin->y + pdspwin->height - 1), 0x1FFF); //pixel shift VFDE endS
            }
        }
    }
}

MS_BOOL MHal_XC_IsSupportFHDDownClk(void)
{
    return XC_SUPPORT_FHDDOWNCLK;
}
void MHal_XC_FHDDownClk(void *pInstance, SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U16 u16Output_W =  pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Width;
    MS_U16 u16Output_H =  pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.stPanelInfo.u16Height;
    MS_U16 u16Input_W =   (gSrcInfo[enWindow].stCapWin.width);
    MS_U16 u16Input_H =   (gSrcInfo[enWindow].stCapWin.height);
    MS_U16 u16SlowClkLevel = 0;
    MS_U16 u16FClkLevel = 0;
    if(u16Output_W <= XC_FHD_WIDTH_MAX &&  u16Output_H <= XC_FHD_HIGH_MAX && (MHal_XC_IsSupportFHDDownClk() == TRUE))
    {
        if(IsSrcTypeHDMI(gSrcInfo[MAIN_WINDOW].enInputSourceType))
        {
            //Lower FHD case
            if((u16Input_W<XC_FHD_WIDTH)&&(u16Input_H <XC_FHD_HIGH))
            {
                //CKG_FCLK_216MHZ SLOW CLK 216
                u16SlowClkLevel = CKG_SC_SLOW_216MHZ;
                u16FClkLevel = CKG_FCLK_216MHZ;
            }
            else
            {
                //CKG_FCLK_DEFAULT MHZ SLOW CLK DEFAULT
                u16SlowClkLevel = CKG_SC_SLOW_DEFAULT;
                u16FClkLevel = CKG_FCLK_DEFAULT;
             }
        }
        else
        {
            //CKG_FCLK_216MHZ SLOW CLK 216
            u16SlowClkLevel = CKG_SC_SLOW_216MHZ;
            u16FClkLevel = CKG_FCLK_216MHZ;
        }
    }
    else
    {
        //CKG_FCLK_DEFAULT MHZ SLOW CLK DEFAULT
        u16SlowClkLevel = CKG_SC_SLOW_DEFAULT;
        u16FClkLevel = CKG_FCLK_DEFAULT;
    }
    //slow clock
    Mhal_XC_ClockControl_SC_Slow(pInstance,TRUE,u16SlowClkLevel);
#ifdef UFO_XC_FB_LEVEL
    if((MDrv_XC_IsFBL(gSrcInfo[enWindow].eFBLevel))||(MDrv_XC_IsRFBL(gSrcInfo[enWindow].eFBLevel)))
#else
    if (gSrcInfo[enWindow].bFBL)
#endif
    {
        Hal_SC_set_Fclk(pInstance, EN_FCLK_FBL,u16FClkLevel);
    }
    else
    {
        Hal_SC_set_Fclk(pInstance, EN_FCLK_NORMAL,u16FClkLevel);
    }
}
MS_BOOL MHal_XC_IsSupportSPFLineBuffer(void)
{
    return XC_SUPPORT_SPF;
}
void MHal_XC_Set_LockPoint_DelayLines(void *pInstance, SCALER_WIN eWindow, P_SC_SWDB_INFO pDBreg)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    MS_U8 u8YlockPoint = 0;
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
    MHal_XC_SetOfflineSource(pInstance, eWindow, INPUT_SOURCE_NONE);
#endif

    MHal_XC_SetMemoryCtrlMethod(pInstance, eWindow);

    if( !gSrcInfo[eWindow].bFBL)
    {
#ifdef UFO_XC_FB_LEVEL
        if((MDrv_XC_IsFBL(gSrcInfo[MAIN_WINDOW].eFBLevel))||(MDrv_XC_IsRFBL(gSrcInfo[MAIN_WINDOW].eFBLevel)))
#else
        if(gSrcInfo[eWindow].bR_FBL) //for M10 Reguest FBL mode, it doesn't the same with FBL
#endif
        {
            // Setip Y lock
#if (HW_DESIGN_4K2K_VER == 6)
            u8YlockPoint = 0x5;
#else
            u8YlockPoint = 0x2;
#endif

#if (HW_DESIGN_4K2K_VER == 4)
            if (pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_Init_Misc.u32MISC_A & E_XC_INIT_MISC_A_LEGACY_MODE)
            {
                gSrcInfo[eWindow].u8DelayLines = 8;
            }
            else
#endif
#if (HW_DESIGN_4K2K_VER == 6)

            // Setup delay line
            if((pXCResourcePrivate->stdrvXC_Display._bEnableMCNR[eWindow])
                && (!gSrcInfo[eWindow].bInterlace))
            {
                gSrcInfo[eWindow].u8DelayLines = 0x10;//rfbl+uc+pmode, need to adjust delay+1
            }
            else
            {
                gSrcInfo[eWindow].u8DelayLines = 0xF;
            }
#else
            // Setup delay line
            if((pXCResourcePrivate->stdrvXC_Display._bEnableMCNR[eWindow])
                && (!gSrcInfo[eWindow].bInterlace))
            {
                gSrcInfo[eWindow].u8DelayLines = 7;//rfbl+uc+pmode, need to adjust delay+1
            }
            else
            {
                gSrcInfo[eWindow].u8DelayLines = 6;
            }
#endif
        }
        else
        {
            /* 2010-07-05
            * according to the discussion from designer, we have the following formula:
            * freeze point = vde_end (reg_value) + 1;
            * lock = vde_end(reg_value) + 3;
            */

            // according to DS and ADL, we set 0xC with CC Yang's suggestion.
            u8YlockPoint = 0x0C;

            if((gSrcInfo[eWindow].eDeInterlaceMode == MS_DEINT_2DDI_AVG) ||
                (gSrcInfo[eWindow].eDeInterlaceMode == MS_DEINT_2DDI_BOB))
            {
                gSrcInfo[eWindow].u8DelayLines = 1;    // 5
            }
            else
            {
                gSrcInfo[eWindow].u8DelayLines = 2;
            }

            //if HV mode with capture size 0x1fff, we need to adjust delay line to 6.
            if ((MDrv_XC_GetHdmiSyncMode(pInstance) == HDMI_SYNC_HV) &&
                (IsSrcTypeHDMI(gSrcInfo[eWindow].enInputSourceType)) &&
                (!gSrcInfo[eWindow].bInterlace))
            {
                MS_WINDOW_TYPE stWinType;
                memset(&stWinType, 0, sizeof(MS_WINDOW_TYPE));
                MDrv_XC_PCMonitor_Get_Dvi_Hdmi_De_Info(pInstance, eWindow, &stWinType, INPUT_SOURCE_NONE);

                if(HVMODE_HDE_VALIDATION(stWinType.width))
                {
                    gSrcInfo[eWindow].u8DelayLines = 6;
                }
            }

        }
        // Setup delay line
        Hal_SC_set_delayline(pInstance,  gSrcInfo[eWindow].u8DelayLines, eWindow );
    }
    else
    {
        MS_U16 u16Vde_in = 0;
        //New method for lock point in FBL
        u8YlockPoint = 0x2;
        u16Vde_in = pDBreg->u16V_CapSize;

        if(gSrcInfo[eWindow].bInterlace)
        {
            if (u16Vde_in <= 580)
            {
                gSrcInfo[eWindow].u8DelayLines = 6;
            }
            else
            {
                gSrcInfo[eWindow].u8DelayLines = 7;
            }
        }
        else
        {
            MS_U32 u32VPSDRatio = 0;
            u32VPSDRatio = pDBreg->u32V_PostScalingRatio;

            if((u32VPSDRatio & 0x3FFFFFL) > 0x100000)
            {
                //printf("---scaling down----\n");
                gSrcInfo[eWindow].u8DelayLines = DELAY_LINE_SC_DOWN;//8;
            }
            else
            {
                //printf("----scaling up----\n");
                gSrcInfo[eWindow].u8DelayLines = DELAY_LINE_SC_UP;// 7;
            }
        }

        if ((MDrv_SC_Get_DE_Bypass_Mode(pInstance, eWindow, INPUT_SOURCE_NONE)) && (u16Vde_in == 0x1FFF))
        {
            gSrcInfo[eWindow].u8DelayLines = 12;
        }
        Hal_SC_set_delayline(pInstance, gSrcInfo[eWindow].u8DelayLines, eWindow );
    }
    MHal_XC_SetYLockPoint(pInstance, u8YlockPoint, eWindow);
}

E_XC_CROP_MODE MHal_XC_GetCropMode(void)
{
    return E_XC_CROP_MIU_ENHANCED_MODE;
}

MS_BOOL MHal_XC_IsSourceWithoutMvopSuportDS(void)
{
    return TRUE;
}

MS_BOOL MHal_XC_IsDtv4K2KI(MS_U16 u16SrcH, MS_U16 u16SrcV, MS_BOOL bInterlace, INPUT_SOURCE_TYPE_t enSrcType)
{
    if((u16SrcH >= XC_4K2K_I_MDOE_H_MIN) && (u16SrcV >= XC_4K2K_I_MDOE_V_MIN)
        && (bInterlace == TRUE) && (IsSrcTypeDTV(enSrcType)))
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

void MHal_XC_OPM_FlowControl(void *pInstance, SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) < COUNT_OF_ARRAY(g_pXCResource))
    {
        UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)], (void**)(&pXCResourcePrivate));

        if(enWindow == MAIN_WINDOW)
        {
#if FRC_INSIDE
            if(IS_FBL_OR_RFBL_MODE(enWindow) || pXCResourcePrivate->stdrvXC_MVideo_Context.g_bFRCEnabled == FALSE)
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_13_L, 0, BIT(7));//[7]->>OPM_FlowControl_en
            }
            else
            {
                SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_13_L, BIT(7), BIT(7));// [7]->OPM_FlowControl_en
            }
#else
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK11_13_L, 0, BIT(7));//[7]->>OPM_FlowControl_en
#endif
        }
    }
    else
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "Error: out of array boundary\n")
    }

}

static MS_S64 _MHal_XC_CalcLockPointBoundary(MS_S64 s64DistanceBoundary, MS_U16 u16ReferencePoint, MS_U16 u16OutputVTT)
{
    if ( s64DistanceBoundary > (u16OutputVTT+u16ReferencePoint))
    {
        return 0;
    }
    else
    {
        return ((MS_S64)u16OutputVTT + u16ReferencePoint - s64DistanceBoundary);
    }
}

static MS_U16 _MHal_XC_AdjustOverflowLockPoint(MS_S64 s64LockPoint, MS_U16 u16OutputVTT)
{
    while (s64LockPoint < 0)
    {
        s64LockPoint+=u16OutputVTT;

        if (s64LockPoint >= 0)
        {
          break;
        }
    }

    return (MS_U16)s64LockPoint;
}

void MHal_XC_SetLockPoint(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    MS_U64 u64ihtt_times = 0;
    MS_U64 u64tlhtt_times = 0;
    MS_U16 u16InputVTT = 0;
    MS_U16 u16HTT = 0;
    MS_U16 u16VTT = 0;
    MS_U64 u64ohtt_times = 0;
    MS_U64 u64IHtt2OHtt_x1K = 0;
    MS_U64 u64OHtt2IHtt_x1K = 0;

    MS_U64 u64IHtt2TLHtt_x1K = 0;
    MS_U64 u64TLHtt2IHtt_x1K = 0;

    MS_U64 u64TLHtt2OHtt_x1K = 0;
    MS_U64 u64OHtt2TLHtt_x1K = 0;

    MS_U64 u64Offset_F1_D1_id = 0;
    MS_U64 u64Offset_F1_D2_id = 0;

    //For enlarge distance between FRC R/W bank update
    MS_U64 u64Offset_F1_D3_id =0;

    MS_U16 u16InserLockPoint = 0;
    MS_U64 u64LowerBound_LockIPVcnt = 0;
    MS_U16 u16Ylock = 0;
    MS_U16 u16InputTrig_Dly = 0;
    //MS_U64 u64ToFRCVsync_Delay_ID = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK68_6E_L)*u64TLHtt2IHtt_x1K /1000;
    MS_U64 u64DSTrig_ID = 0;

    MS_U16 u16CapVStart =  0;
    MS_U16 u16OutputVTT = 0;

    MS_U16 u16LockPoint = 0;

    MS_S64 s64tempResult = 0;
    MS_S64 s64UpperBound_FormulaResult = 0;

    MS_U64 u64Offset_F2_D1_id = 0;
    MS_U64 u64Offset_F2_D2_id = 0;

    MS_U64 u64DispTrig_ID = 0;
    MS_U64 u64Offset_F3_D1_id = 0;

    MS_U16 u16SPRange_V = 0;
    MS_U16 u16VFDE_end = 0;
    u64ihtt_times = ((MS_U64)SC_R4BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_3B_L, MAIN_WINDOW))&0x1FFFFF)*GHZ / XC_IPCLOCK;
    //lock ip, same as input.
    u64tlhtt_times = ((MS_U64)SC_R4BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_3B_L, MAIN_WINDOW))&0x1FFFFF)*GHZ / XC_IPCLOCK;

    if (gSrcInfo[MAIN_WINDOW].bInterlace == TRUE)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_14_L, BIT(5), BIT(5));
        u64tlhtt_times = u64tlhtt_times/2;
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK68_14_L, 0, BIT(5));
    }

    if(IsSrcTypeStorage(gSrcInfo[MAIN_WINDOW].enInputSourceType) || IsSrcTypeDTV(gSrcInfo[MAIN_WINDOW].enInputSourceType))
    {
        //for digital signal sometimes IP report not stable
        MVOP_Timing stMVOPTimingInfo = {0};
        MDrv_MVOP_GetOutputTiming(&stMVOPTimingInfo);
        u16InputVTT = stMVOPTimingInfo.u16V_TotalCount;

        if(MHal_XC_IsForceP(pInstance, MAIN_WINDOW))
        {
            u16InputVTT*= 2;
        }
    }
    else
    {
        u16InputVTT = SC_R2BYTE(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_1F_L, MAIN_WINDOW));
    }

    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint] u16InputVTT = %u\n",u16InputVTT);

    if (u16InputVTT!=0)
    {
        u64ihtt_times = u64ihtt_times/u16InputVTT;
        u64tlhtt_times = u64tlhtt_times/u16InputVTT;
    }

    u16HTT = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0C_L)+1;
    u16VTT = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK10_0D_L)+1;

    u64ohtt_times = (MS_U64)u16HTT*GHZ;
    if ( ((MS_U64)u16HTT*u16VTT*gSrcInfo[MAIN_WINDOW].Status2.u16OutputVFreqAfterFRC/10) > 0)
    {
        u64ohtt_times = u64ohtt_times / ((MS_U64)u16HTT*u16VTT*gSrcInfo[MAIN_WINDOW].Status2.u16OutputVFreqAfterFRC/10);
    }
    // coversion variable
    u64IHtt2OHtt_x1K = u64ihtt_times * 1000 / u64ohtt_times;
    u64OHtt2IHtt_x1K = u64ohtt_times *1000 / u64ihtt_times;

    u64IHtt2TLHtt_x1K = u64ihtt_times *1000 /u64tlhtt_times;
    u64TLHtt2IHtt_x1K = u64tlhtt_times *1000/ u64ihtt_times;

    u64TLHtt2OHtt_x1K = u64tlhtt_times*1000 / u64ohtt_times;
    u64OHtt2TLHtt_x1K = u64ohtt_times *1000/u64tlhtt_times;

    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint] u64IHtt2OHtt_x1K = %llu, u64OHtt2IHtt_x1K = %llu\n",u64IHtt2OHtt_x1K,u64OHtt2IHtt_x1K);
    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint] u64IHtt2TLHtt_x1K = %llu, u64TLHtt2IHtt_x1K = %llu\n",u64IHtt2TLHtt_x1K,u64TLHtt2IHtt_x1K);
    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint] u64TLHtt2OHtt_x1K = %llu, u64OHtt2TLHtt_x1K = %llu\n",u64TLHtt2OHtt_x1K,u64OHtt2TLHtt_x1K);

    //IP2 VS trig setting.
    MDrv_XC_MemControl_Switch_Method_By_Vcnt(pInstance, TRUE, 0x00);
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_55_L, MAIN_WINDOW), BIT(15), BIT(15));
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_55_L, MAIN_WINDOW), 0x0, 0x1FFF);


    //F1-1 , ip1_57_id + F1_D1_id  <= ip1_56_id + BK68_6E_tl + BK20_21_tl
    //BK01_56 [12:0] lock IP Vcnt ,  [15]lock_ip_vcnt_sel 0:vsync end 1:vde end , hw default = 0x2
    //bk01_57[12:0] new_sprc_lock_cnt  (insert lock), [15] enable bit , hw default = 0x1

    //ex. setting
    //BK01_56[15] = 0 , count from vsync end
    //BK01_57[15] =1 , enable bit
    //BK20_19[1:0] = 1 , sel sync for vsync rising.
    //BK20_19[9:8] = 2, lock mem rbank from TRAIN_TRIG_P, but it's bk20_1a

    u64Offset_F1_D1_id = ABS_TIME_OF_LINE_ODCLK_F1_D1/2 * u64OHtt2TLHtt_x1K /1000 *u64TLHtt2IHtt_x1K /1000;
    u64Offset_F1_D2_id = ABS_TIME_OF_LINE_ODCLK_F1_D2/2 * u64OHtt2TLHtt_x1K /1000 *u64TLHtt2IHtt_x1K /1000;

    //Game mode case
    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint]Game mode = %d\n",pXCResourcePrivate->stdrvXC_Display._bZeroFrameDelayMode);
    if (pXCResourcePrivate->stdrvXC_Display._bZeroFrameDelayMode == TRUE)
    {
        u64Offset_F1_D3_id = ABS_TIME_OF_LINE_ODCLK_F1_D3 * u64OHtt2TLHtt_x1K /1000 *u64TLHtt2IHtt_x1K /1000;
    }
    else
    {
        u64Offset_F1_D3_id = (u16VTT/2) * u64OHtt2TLHtt_x1K /1000 *u64TLHtt2IHtt_x1K /1000;
    }

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_57_L, MAIN_WINDOW), BIT(15), BIT(15));
    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_19_L, BIT(9)|BIT(8), BIT(9)|BIT(8)); // SCMI Rbank is the same as DS_TRIG

    u16InserLockPoint = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_57_L, MAIN_WINDOW), 0x1FFF);
    u64LowerBound_LockIPVcnt = LOCK_IP_VCNT_DEFALUT;
    u16Ylock = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_09_L, MAIN_WINDOW), 0x000F);
    u16InputTrig_Dly = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_1C_L, MAIN_WINDOW), 0x03F0)>>4;
    //MS_U64 u64ToFRCVsync_Delay_ID = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK68_6E_L)*u64TLHtt2IHtt_x1K /1000;
    u64DSTrig_ID = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_21_L) * u64TLHtt2IHtt_x1K /1000;

    //For Interlace mode, the value of IP domain params need double excep capture start.
    if (gSrcInfo[MAIN_WINDOW].bInterlace == TRUE)
    {
        u16InserLockPoint = u16InserLockPoint*2;
        u64LowerBound_LockIPVcnt = u64LowerBound_LockIPVcnt*2;
        u16Ylock = u16Ylock*2;
        u16InputTrig_Dly = u16InputTrig_Dly*2;
    }
    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F1-1] IP1_57_id(%u) + FI_D1_id(%llu) <= IP1_56_id(%llu) + BK68_6E_tl(NULL) + BK20_21_tl(%llu)\n"
                                , u16InserLockPoint, u64Offset_F1_D1_id, u64LowerBound_LockIPVcnt, u64DSTrig_ID);

    //Check formula F1-1, try to adjust lock IP Vcnt.

    if (SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_04_L, BIT(10)|BIT(11)) == 0)
    {
        if ( (u64LowerBound_LockIPVcnt + u64DSTrig_ID) >= (u16InserLockPoint + u64Offset_F1_D1_id) )
        {
            XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint]Formula F1-1  Check OK.\n");
        }
        else
        {
            //printf("%s %d Formula F1-1  Check NG. Adjust  lock IP Vcnt\n",__FUNCTION__,__LINE__);
            //minimum value of lock ip vcnt.
            //SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_56_L, MAIN_WINDOW), u16LowerBound_LockIPVcnt, 0x1FFF);
            u64LowerBound_LockIPVcnt = u16InserLockPoint + u64Offset_F1_D1_id - u64DSTrig_ID;
            XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint]Formula F1-1  Check NG. Adjust  lock IP Vcnt. UpperBound of IP Vcnt = %llu\n",u64LowerBound_LockIPVcnt);
        }
    }
    //F 1-2 BK20_21_TL + F1_D2_TL <= bk20_1B_tl
    //BK20_09[12:0] =  generate tofrc V trig from delay line of vsync
    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F1-2] BK20_21_tl(%u) + FI_D2_tl(%llu) <= IBK20_1B_tl(%u)\n"
                                , SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_21_L), u64Offset_F1_D2_id, SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_1B_L));

    if (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_1B_L) >= SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_21_L) )
    {
        u64Offset_F1_D2_id = (SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_1B_L) - SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_21_L))*u64TLHtt2IHtt_x1K / 1000;
        XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint]Formula F1-2  Check OK.\n");
    }
    else
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint]Formula F1-2  Check NG.\n");
    }

    //F 1-3.   BK68_6B should before bk68_66(FRC read start),
    // current code flow, BK68_6B = 0x20 , bk68_66 = 0x22
    // check upper bound of lock point
    u16CapVStart =  SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_04_L, MAIN_WINDOW), 0x1FFF);
    u16OutputVTT = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_0D_L, 0x3FFF) + 1;

    u16LockPoint = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_55_L, 0x1FFF);

    s64tempResult = (MS_S64)u16Ylock*2 - u16InputTrig_Dly - (u16CapVStart -1)+ u16InserLockPoint + u64Offset_F1_D1_id + u64Offset_F1_D2_id + u64Offset_F1_D3_id;
    s64UpperBound_FormulaResult = 0x3FFF;

    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F1-3] %lld = IP1_09_id(%d)*2 - IP1_1C_id(%d) -(IP1_04_id(%d) -1) + IP1_57_id(%d) + F1_D1_id(%llu) + F1_D2_tl(%llu) + F1_D3_id(%llu) <= TGEN_overflow(BK68_6B_od(NULL) - LockPoint)\n",
                                                                            s64tempResult, u16Ylock, u16InputTrig_Dly, u16CapVStart, u16InserLockPoint, u64Offset_F1_D1_id, u64Offset_F1_D2_id, u64Offset_F1_D3_id);

    s64tempResult = (s64tempResult*u64IHtt2TLHtt_x1K/1000)*u64TLHtt2OHtt_x1K/1000;

    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F1-3] Transfer to odclk domain  = %lld\n",s64tempResult);

    if (s64UpperBound_FormulaResult >  s64tempResult)
    {
        s64UpperBound_FormulaResult = s64tempResult;
    }

    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F1-3] Upper bound of LockPoint  = %lld Current LockPoint = %u\n",s64UpperBound_FormulaResult, SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_55_L, 0x1FFF));

    //F 2-1
    // IP1_04_id + F2_D1_id <= IP1_56_id + BK68_6E_tl + BK20_1B_tl
    // check lower bound of BK01_56_L
    u64Offset_F2_D1_id = ABS_TIME_OF_LINE_ODCLK_F2_D1/2 * u64OHtt2TLHtt_x1K /1000 *u64TLHtt2IHtt_x1K /1000;
    u64Offset_F2_D2_id = ABS_TIME_OF_LINE_ODCLK_F2_D2/2 * u64OHtt2TLHtt_x1K /1000 *u64TLHtt2IHtt_x1K /1000;

    u64DispTrig_ID = SC_R2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK20_1B_L) * u64TLHtt2IHtt_x1K /1000;

    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F2-1] IP1_04_id(%u) + F2_D1_id(%llu) <= IP1_56_id(%llu) + BK68_6E_tl(NULL) + BK20_1B_tl(%llu)\n",
                                                                                u16CapVStart,u64Offset_F2_D1_id, u64LowerBound_LockIPVcnt, u64DispTrig_ID);

    if ((u64LowerBound_LockIPVcnt + u64DispTrig_ID) >= (u16CapVStart + u64Offset_F2_D1_id))
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint]Formula F2-1  Check OK.\n");
    }
    else
    {
        u64LowerBound_LockIPVcnt = u16CapVStart + u64Offset_F2_D1_id - u64DispTrig_ID;

        if(SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK12_04_L, BIT(10)|BIT(11))!=0)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_56_L, MAIN_WINDOW), 0, 0x1FFF);
            XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint]FBL case, Formula F2-1 Set IP1_56_id = 0\n");
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_56_L, MAIN_WINDOW), u64LowerBound_LockIPVcnt, 0x1FFF);
            XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint]FB case, Formula F2-1 Set IP1_56_id = %llu\n",u64LowerBound_LockIPVcnt);
        }
        XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint]Formula F2-1  Check NG. Adjust IP1_56_id LowerBound to %llu\n",u64LowerBound_LockIPVcnt);
    }
    //F2-2 , IP1_09_id *2 - IP1_1C_id - (IP1_04_id -1) + IP1_04_id + F2_D1_id + F2_D2_tl < = TGEN_OVERFLOW(BK68_66_OD)

    //check upper bound of lock point
    s64tempResult = (MS_S64)u16Ylock*2 - u16InputTrig_Dly - (u16CapVStart -1) + u16CapVStart + u64Offset_F2_D1_id + u64Offset_F2_D2_id;

    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F2-2] %lld = IP1_09_id(%d)*2 - IP1_1C_id(%d) -(IP1_04_id(%d) -1) + IP1_04_id(%d) + F2_D1_id(%llu) + F2_D2_tl(%llu) <= TGEN_overflow(BK68_66_od(NULL) - LockPoint)\n",
                                                                            s64tempResult, u16Ylock, u16InputTrig_Dly, u16CapVStart, u16CapVStart, u64Offset_F2_D1_id, u64Offset_F2_D2_id);

    s64tempResult = (s64tempResult*u64IHtt2TLHtt_x1K/1000)*u64TLHtt2OHtt_x1K/1000; // transform to ODCLK domain

    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F2-2] Transfer to odclk domain  = %lld\n",s64tempResult);

    if (s64UpperBound_FormulaResult > s64tempResult)
    {
        s64UpperBound_FormulaResult = s64tempResult;
    }

    //F 3-1
    //adjust bk0f_55 to ADJUST THE relationship between IP1/TGEN end
    // IP1_09_id - IP1_1C_id
    u64Offset_F3_D1_id = ABS_TIME_OF_LINE_ODCLK_F3_D1/2 * u64OHtt2TLHtt_x1K /1000 *u64TLHtt2IHtt_x1K /1000;

    u16SPRange_V = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_06_L, MAIN_WINDOW), 0x1FFF);
    u16VFDE_end = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_07_L, 0x3FFF);
    s64tempResult = (MS_S64)u16Ylock*2 - u16InputTrig_Dly - (u16CapVStart -1) + u16CapVStart + u16SPRange_V -1 + u64Offset_F3_D1_id;

    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F3-1] %lld = IP1_09_id(%d)*2 - IP1_1C_id(%d) -(IP1_04_id(%d) -1) + IP1_04_id(%d) + IP1_06_id(%d) -1 + F3_D1_id(%llu) <= TGEN_overflow(BK10_07_od(%d) - LockPoint)\n",
                                                                            s64tempResult, u16Ylock, u16InputTrig_Dly, u16CapVStart, u16CapVStart, u16SPRange_V, u64Offset_F3_D1_id, u16VFDE_end);

    s64tempResult = (s64tempResult*u64IHtt2TLHtt_x1K/1000)*u64TLHtt2OHtt_x1K/1000; // transform to ODCLK domain

    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F3-1] Transfer to odclk domain  = %lld\n",s64tempResult);

    s64tempResult = _MHal_XC_CalcLockPointBoundary(s64tempResult, u16VFDE_end, u16OutputVTT);

    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F3-1] Upper bound of LockPoint  = %lld, Previous upper bound = %lld\n",s64tempResult, s64UpperBound_FormulaResult);

    if (s64UpperBound_FormulaResult > s64tempResult)
    {
        s64UpperBound_FormulaResult = s64tempResult;
    }

    u16LockPoint = _MHal_XC_AdjustOverflowLockPoint(s64UpperBound_FormulaResult,u16OutputVTT);

    SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK0F_55_L, u16LockPoint, 0x1FFF);
    XC_LOG_TRACE(XC_DBGLEVEL_SETTIMING, "[LockPoint][F3-1] Update Lock Point = %u\n",u16LockPoint);
}

MS_BOOL MHal_XC_FIFO_Control(void *pInstance, INPUT_SOURCE_TYPE_t enSrcType,SCALER_WIN enWindow)
{
    MS_U8 u8ChipRev = MDrv_SYS_GetChipRev();
    XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "u8ChipRev = %d\n",u8ChipRev);
    if(u8ChipRev == 0)//U01 == 0
    {
        MS_U16 u16IpmRThrdValue = 0;
        MS_U16 u16IpmWThrdValue = 0;
        MS_U16 u16IpmRWmaxValue = 0;
        XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
        UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
        XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
        UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "enSrcType = %d enWindow = %d\n",enSrcType,enWindow);
        if((IsSrcTypeHDMI(enSrcType)&&IS_INPUT_4K2K(enWindow)) || IsSrcTypeVga(enSrcType))
        {
            u16IpmRThrdValue = 0x1860;
            u16IpmWThrdValue = 0x1860;
            u16IpmRWmaxValue = 0x6060;
        }
        else
        {
            u16IpmRThrdValue = 0x1840;
            u16IpmWThrdValue = 0x1840;
            u16IpmRWmaxValue = 0x4040;
        }

        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "u16IpmRThrdValue = %x u16IpmWThrdValue = %x u16IpmRWmaxValue = %x\n",u16IpmRThrdValue,u16IpmWThrdValue,u16IpmRWmaxValue);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_20_L, u16IpmRThrdValue);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_21_L, u16IpmWThrdValue);
        SC_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_BK12_22_L, u16IpmRWmaxValue);
    }
    else
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "U02 No Need MHal_XC_FIFO_Control\n");
    }

    return TRUE;
}
MS_BOOL MHal_XC_Is2kModel(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(IS_4K2K_PANEL)
    {
        return FALSE;
    }
    else
    {
        return TRUE;
    }
}

MS_BOOL MHal_XC_IsSupportDecimalCrop(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return FALSE;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    return (_gbProcFSDecimalCropEnable && !gSrcInfo[MAIN_WINDOW].bInterlace);
}

void MHal_XC_SetDecimalPostScaling(void *pInstance, XC_InternalStatus *pSrcInfo, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    MS_U64 u64_result = 0;
    MS_U32 u32DecimalScale = gSrcInfo[eWindow].Status2.u32DecimalCropScale;
    MS_U32 u32DecimalPart = 0;
    MS_S16 s16SrcDiff = 0;
    MS_S32 s32TmpPostFactor = 0;

    if(MHal_XC_IsSupportDecimalCrop(pInstance) && (pSrcInfo != NULL) && (u32DecimalScale != 0))
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[PST]SizeAfterPreScaling:%ux%u Crop:(%u,%u,%u,%u) ScaledCrop:(%u,%u,%u,%u) DecimalCrop:(%tu.%tu,%tu.%tu,%tu.%tu,%tu.%tu)\n",
            pSrcInfo->u16H_SizeAfterPreScaling, pSrcInfo->u16V_SizeAfterPreScaling,
            gSrcInfo[eWindow].stCropWin.x, gSrcInfo[eWindow].stCropWin.y, gSrcInfo[eWindow].stCropWin.width, gSrcInfo[eWindow].stCropWin.height,
            gSrcInfo[eWindow].ScaledCropWin.x, gSrcInfo[eWindow].ScaledCropWin.y, gSrcInfo[eWindow].ScaledCropWin.width, gSrcInfo[eWindow].ScaledCropWin.height,
            (ptrdiff_t)gSrcInfo[eWindow].Status2.u32DecimalCropWinX/u32DecimalScale, (ptrdiff_t)gSrcInfo[eWindow].Status2.u32DecimalCropWinX%u32DecimalScale,
            (ptrdiff_t)gSrcInfo[eWindow].Status2.u32DecimalCropWinY/u32DecimalScale, (ptrdiff_t)gSrcInfo[eWindow].Status2.u32DecimalCropWinY%u32DecimalScale,
            (ptrdiff_t)gSrcInfo[eWindow].Status2.u32DecimalCropWinWidth/u32DecimalScale, (ptrdiff_t)gSrcInfo[eWindow].Status2.u32DecimalCropWinWidth%u32DecimalScale,
            (ptrdiff_t)gSrcInfo[eWindow].Status2.u32DecimalCropWinHeight/u32DecimalScale, (ptrdiff_t)gSrcInfo[eWindow].Status2.u32DecimalCropWinHeight%u32DecimalScale);

        //Precise postscaling fomula:
        // xxx.yyy ==> xxx is integer part, 0.yyy is decimal part
        // V/H_PostScalingIniFactor = V/H_PostScalingIniFactor of origin integer part + (decimal part) * 2^20
        // V/H_PostScalingRatio = V/H_PostScalingRatio(integer part) + V/H_PostScalingRatio(decimal part)

        //Represent of decimal crop window:
        // u32DecimalCropWin[X/Y/Width/Height] = integer part * decimal scale + decimal part

        //Resize decimal crop size from precaling
        if(pSrcInfo->stCapWin.width != 0)
        {
            gSrcInfo[eWindow].Status2.u32DecimalCropWinX = (MS_U32)((MS_U64)gSrcInfo[eWindow].Status2.u32DecimalCropWinX * pSrcInfo->u16H_SizeAfterPreScaling / pSrcInfo->stCapWin.width);
            gSrcInfo[eWindow].Status2.u32DecimalCropWinWidth = (MS_U32)((MS_U64)gSrcInfo[eWindow].Status2.u32DecimalCropWinWidth * pSrcInfo->u16H_SizeAfterPreScaling / pSrcInfo->stCapWin.width);
        }
        if(pSrcInfo->stCapWin.height != 0)
        {
            gSrcInfo[eWindow].Status2.u32DecimalCropWinY = (MS_U32)((MS_U64)gSrcInfo[eWindow].Status2.u32DecimalCropWinY * pSrcInfo->u16V_SizeAfterPreScaling / pSrcInfo->stCapWin.height);
            gSrcInfo[eWindow].Status2.u32DecimalCropWinHeight = (MS_U32)((MS_U64)gSrcInfo[eWindow].Status2.u32DecimalCropWinHeight * pSrcInfo->u16V_SizeAfterPreScaling / pSrcInfo->stCapWin.height);
        }

        //set decimal part of crop width
        u32DecimalPart = gSrcInfo[eWindow].Status2.u32DecimalCropWinWidth % u32DecimalScale;
        s16SrcDiff = (gSrcInfo[eWindow].Status2.u32DecimalCropWinWidth / u32DecimalScale) - gSrcInfo[eWindow].ScaledCropWin.width;
        if((u32DecimalPart != 0) && (u32DecimalScale != 0) && (gSrcInfo[MAIN_WINDOW].bHCusScaling == FALSE))
        {
            //compensate the different size of integer part from real HW crop and expected crop
            if(s16SrcDiff != 0)
            {
                MS_S8 s8Sign = ((s16SrcDiff < 0) ? (-1) : 1);
#ifdef MSOS_TYPE_LINUX_KERNEL
                H_PostScalingRatio(s8Sign * s16SrcDiff, pSrcInfo->stDispWin.width);
                pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32H_PostScalingRatio += (MS_U32)(u64_result) * s8Sign;
#else
                pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32H_PostScalingRatio += H_PostScalingRatio(s8Sign * s16SrcDiff, pSrcInfo->stDispWin.width) * s8Sign;
#endif
                XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[PST]H compensate:%dp ratio:%d\n", s16SrcDiff, (MS_U32)(u64_result) * s8Sign);
            }
            //Add decimal part of width after applying H_PostScalingRatio() formula
#ifdef MSOS_TYPE_LINUX_KERNEL
            H_PostScalingRatio(u32DecimalPart, pSrcInfo->stDispWin.width);
            pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32H_PostScalingRatio += (MS_U32)(u64_result / u32DecimalScale);
#else
            pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32H_PostScalingRatio += H_PostScalingRatio(u32DecimalPart, pSrcInfo->stDispWin.width) / u32DecimalScale;
#endif
        }
        //set decimal part of crop x offset
        u32DecimalPart = gSrcInfo[eWindow].Status2.u32DecimalCropWinX % u32DecimalScale;
        if((u32DecimalPart != 0) && (u32DecimalScale != 0) && (gSrcInfo[MAIN_WINDOW].bHCusScaling == FALSE))
        {
            //compensate for H_PostScalingUpPhase()
            s32TmpPostFactor = (((s16SrcDiff * u32DecimalScale + u32DecimalPart) * (1 << 20)) / pSrcInfo->stDispWin.width / 2) / u32DecimalScale;
            pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32H_PostScalingIniFactor += s32TmpPostFactor;
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[PST]H compensate:%dp initfactor:%d", s16SrcDiff, s32TmpPostFactor);
        }
        //set decimal part of crop height
        u32DecimalPart = gSrcInfo[eWindow].Status2.u32DecimalCropWinHeight % u32DecimalScale;
        s16SrcDiff = (gSrcInfo[eWindow].Status2.u32DecimalCropWinHeight / u32DecimalScale) - gSrcInfo[eWindow].ScaledCropWin.height;
        if((u32DecimalPart != 0) && (u32DecimalScale != 0) && (gSrcInfo[MAIN_WINDOW].bVCusScaling == FALSE))
        {
            //compensate the different size of integer part from real HW crop and expected crop
            if(s16SrcDiff != 0)
            {
                MS_S8 s8Sign = ((s16SrcDiff < 0) ? (-1) : 1);
#ifdef MSOS_TYPE_LINUX_KERNEL
                V_PostScalingRatio(s8Sign * s16SrcDiff, pSrcInfo->stDispWin.height);
                pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32V_PostScalingRatio += (MS_U32)(u64_result) * s8Sign;
#else
                pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32V_PostScalingRatio += V_PostScalingRatio(s8Sign * s16SrcDiff, pSrcInfo->stDispWin.height) * s8Sign;
#endif
                XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[PST]V compensate:%dp ratio:%d\n", s16SrcDiff, (MS_U32)(u64_result) * s8Sign);
            }
            //Add decimal part of height after applying V_PostScalingRatio() formula
#ifdef MSOS_TYPE_LINUX_KERNEL
            V_PostScalingRatio(u32DecimalPart, pSrcInfo->stDispWin.height);
            pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32V_PostScalingRatio += (MS_U32)(u64_result / u32DecimalScale);
#else
            pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32V_PostScalingRatio += V_PostScalingRatio(u32DecimalPart, pSrcInfo->stDispWin.height) / u32DecimalScale;
#endif
        }
        //set decimal part of crop y offset
        u32DecimalPart = gSrcInfo[eWindow].Status2.u32DecimalCropWinY % u32DecimalScale;
        if((u32DecimalPart != 0) && (u32DecimalScale != 0) && (gSrcInfo[MAIN_WINDOW].bVCusScaling == FALSE))
        {
            //compensate for V_PostScalingUpPhase()
            s32TmpPostFactor = (((s16SrcDiff * u32DecimalScale + u32DecimalPart) * (1 << 20)) / pSrcInfo->stDispWin.height / 2) / u32DecimalScale;
            pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.u32V_PostScalingIniFactor += s32TmpPostFactor;
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[PST]V compensate:%dp initfactor:%d", s16SrcDiff, s32TmpPostFactor);
        }
    }
}

/******************************************************************************/
///HDMI2.1 VRR
/******************************************************************************/
MS_BOOL MHal_XC_GetVRRFSM_Enable(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKCB_07_L, BIT(0))?FALSE:TRUE;
}

void MHal_XC_SetVRRFSM_Enable(void *pInstance, MS_BOOL bEn)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKCB_07_L, bEn?0:BIT(0), BIT(0));
}

MS_BOOL MHal_XC_GetVRREnableFromHDMI(void *pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    return SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BKDF_18_L, BIT(8))?TRUE:FALSE;
}

void MHal_XC_SetMemoryCtrlMethod(void *pInstance, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    if(_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID) == E_XC_POOL_ID_MAX)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[ERROR] Invalid POOL ID!!! \n");
        return;
    }

    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    EN_XC_MEMSYNC_TO_VS enMemsync = E_XC_SAMPLE_VSTART_WITH_2YLOCK;

    if(IsSrcTypeDigitalVD(gSrcInfo[eWindow].enInputSourceType) || IsSrcTypeYPbPr(gSrcInfo[eWindow].enInputSourceType))
    {
        enMemsync = E_XC_SAMPLE_VEND;
    }
    else
    {
        enMemsync = E_XC_SAMPLE_VSTART_WITH_2YLOCK;
    }

    if( eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_21_L, eWindow), (enMemsync<<14), (BIT(14)|BIT(15)));
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_21_L, (enMemsync<<14), (BIT(14)|BIT(15)));
#endif
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_21_L, (enMemsync<<14), (BIT(14)|BIT(15)));
    }
}

//Note:external interface not allowed to call,only this api KDrv_XC_RegisterHSECallback can register
//Can't add lock and cause nested lock with cfd int
static void MHal_SC_DynamicSetHSEMemoryCB(MS_BOOL bIsIommuEnabled)
{
    void *pInstance = pu32XCInst_private;
    MHal_SC_SetHSEMemory(pInstance, bIsIommuEnabled);
}

//bIsIommuEnabled TRUE: HSE get mem from iommu   FALSE:HSE rel mem from iommu or hse get mem from mmap
void MHal_SC_SetHSEMemory(void *pInstance, MS_BOOL bIsIommuEnabled)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    XC_HSE_PREINIT_INFO_t stHSEInfo = {0};

    MHal_SC_GetHSEInfo(&stHSEInfo);
#if (XC_SUPPORT_IOMMU == TRUE && HSE_SUPPORT_IOMMU == TRUE)
    if(stHSEInfo.u32HSE_BufBaseAddress == 0 && stHSEInfo.u64HSE_BufBaseAddress == 0)
    {
        if(bIsIommuEnabled)
        {
            //get hse buffer from iommu
            XC_HSE_PREINIT_INFO_t stHSEInfo = {0};
            memset(&stHSEInfo, 0, sizeof(XC_HSE_PREINIT_INFO_t));

            MDrv_XC_HseGetMMAAddr(pInstance, MAIN_WINDOW);
            stHSEInfo.u64HSE_BufBaseAddress = pXCResourcePrivate->stdrvXC_MVideo.phyHSEMMABaseAddress;
            stHSEInfo.u32HSE_BufLength = XC_HSE_MMA_SIZE;
            stHSEInfo.u32HSE_PreInit_Version = XC_HSE_PREINIT_VERSION;
            stHSEInfo.u32HSE_PreInit_Length = sizeof(XC_HSE_PREINIT_INFO_t);
            printf("[%s][%d]HSE set mem form Iommu, u64HSE_BufBaseAddress[0x%llx] u32HSE_BufLength[%lx] Version[%d] StructLen[%d]\n", __FUNCTION__, __LINE__,
                   stHSEInfo.u64HSE_BufBaseAddress, stHSEInfo.u32HSE_BufLength, stHSEInfo.u32HSE_PreInit_Version, stHSEInfo.u32HSE_PreInit_Length);
            MDrv_XC_HSE_Init(pInstance, &stHSEInfo);
        }
        else
        {
            //rel hse buffer from iommu
            MDrv_XC_HseReleaseMMA(pInstance, MAIN_WINDOW);
            printf("[%s][%d]HSE rel mem form Iommu \n", __FUNCTION__, __LINE__);
        }
    }
    else
#endif
    {
        MDrv_XC_HSE_Init(pInstance, &stHSEInfo);
#if (XC_SUPPORT_IOMMU == TRUE)
        MDrv_XC_HseReleaseMMA(pInstance, MAIN_WINDOW);
#endif
        printf("[%s][%d]HSE get mem form mmap, u64HSE_BufBaseAddress[0x%llx] u32HSE_BufLength[%lx] Version[%d] StructLen[%d]\n", __FUNCTION__, __LINE__,
               stHSEInfo.u64HSE_BufBaseAddress, stHSEInfo.u32HSE_BufLength, stHSEInfo.u32HSE_PreInit_Version, stHSEInfo.u32HSE_PreInit_Length);
    }
}

void Hal_SC_ip_set_IPAutoNoSignalForAllHDMIPorts(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if (eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_0B_L, bEnable? BIT(5):0, BIT(5));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_1D_L, bEnable? BIT(12):0, BIT(12));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_0B_L, bEnable? BIT(5):0, BIT(5));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_1D_L, bEnable? BIT(12):0, BIT(12));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_0B_L, bEnable? BIT(5):0, BIT(5));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_1D_L, bEnable? BIT(12):0, BIT(12));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_0B_L, bEnable? BIT(5):0, BIT(5));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_1D_L, bEnable? BIT(12):0, BIT(12));
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_0B_L, bEnable? BIT(5):0, BIT(5));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_1D_L, bEnable? BIT(12):0, BIT(12));
#endif
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_23_L, bEnable? BIT(14):0, BIT(14));
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_0B_L, bEnable? BIT(5):0, BIT(5));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_1D_L, bEnable? BIT(12):0, BIT(12));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK20_23_L, bEnable? BIT(13):0, BIT(13));
    }
}

void Hal_SC_Ip_ForceDisableAutoNoSignalForAllHDMIPorts(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if (eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_0B_L, bEnable? BIT(4):0, BIT(4));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_0B_L, bEnable? BIT(4):0, BIT(4));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_0B_L, bEnable? BIT(4):0, BIT(4));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC8_0B_L, bEnable? BIT(4):0, BIT(4));
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_0B_L, bEnable? BIT(4):0, BIT(4));
#endif
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_0B_L, bEnable? BIT(4):0, BIT(4));
    }
}

void Hal_SC_ip_set_user_def_interlace_statusForAllHDMIPorts(void *pInstance, MS_BOOL bEnable, MS_BOOL bIsInterlace, SCALER_WIN eWindow, MS_BOOL bAllHDMIPorts)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    if(eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        if (bAllHDMIPorts)
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_21_L, (bEnable?BIT(0):0),BIT(0));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC1_21_L, (bIsInterlace?BIT(1):0),BIT(1));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_21_L, (bEnable?BIT(0):0),BIT(0));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC4_21_L, (bIsInterlace?BIT(1):0),BIT(1));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_21_L, (bEnable?BIT(0):0),BIT(0));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC7_21_L, (bIsInterlace?BIT(1):0),BIT(1));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_21_L, (bEnable?BIT(0):0),BIT(0));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BKC9_21_L, (bIsInterlace?BIT(1):0),BIT(1));
        }
        else
        {
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_21_L, eWindow), (bEnable?BIT(0):0),BIT(0));
            SC_W2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_21_L, eWindow), (bIsInterlace?BIT(1):0),BIT(1));
        }
#else
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_21_L, (bEnable?BIT(0):0),BIT(0));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_21_L, (bIsInterlace?BIT(1):0),BIT(1));
#endif
    }
    else if(eWindow == SUB_WINDOW)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_21_L, (bEnable?BIT(0):0),BIT(0));
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK03_21_L, (bIsInterlace?BIT(1):0),BIT(1));
    }
}

void Hal_SC_ip_set_de_only_modeForAllHDMIPorts(void *pInstance, MS_BOOL bEnable, SCALER_WIN eWindow, MS_BOOL bAllHDMIPorts)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    //Turn on BIT(7) to let H/V Start being programable.
    if( eWindow == MAIN_WINDOW || (MHal_XC_IsFSSEnabled(pInstance, eWindow) && (eWindow == MAX_WINDOW)))
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        if (bAllHDMIPorts)
        {
            SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BKC1_03_L, (BIT(7)|(bEnable<<6)), (BIT(7)|BIT(6)) );
            SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BKC1_2F_L, bEnable<<4, BIT(4) ); // SW patch for HDMI switch, Auto search HST jistter mask filter force off
            SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BKC4_03_L, (BIT(7)|(bEnable<<6)), (BIT(7)|BIT(6)) );
            SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BKC4_2F_L, bEnable<<4, BIT(4) ); // SW patch for HDMI switch, Auto search HST jistter mask filter force off
            SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BKC7_03_L, (BIT(7)|(bEnable<<6)), (BIT(7)|BIT(6)) );
            SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BKC7_2F_L, bEnable<<4, BIT(4) ); // SW patch for HDMI switch, Auto search HST jistter mask filter force off
            SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BKC8_03_L, (BIT(7)|(bEnable<<6)), (BIT(7)|BIT(6)) );
            SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BKC8_2F_L, bEnable<<4, BIT(4) ); // SW patch for HDMI switch, Auto search HST jistter mask filter force off
        }
        else
        {
            SC_W2BYTEMSK( psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_03_L, eWindow), (BIT(7)|(bEnable<<6)), (BIT(7)|BIT(6)) );
            SC_W2BYTEMSK( psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_2F_L, eWindow), bEnable<<4, BIT(4) ); // SW patch for HDMI switch, Auto search HST jistter mask filter force off
        }
#else
        SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BK01_03_L, (BIT(7)|(bEnable<<6)), (BIT(7)|BIT(6)) );
        SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BK01_2F_L, bEnable<<4, BIT(4) ); // SW patch for HDMI switch, Auto search HST jistter mask filter force off
#endif
        if(psXCInstPri->u32DeviceID)
        {
            MDrv_WriteRegBit(REG_S2_DE_ONLY_F2, bEnable, S2_DE_ONLY_F2_MASK);
        }
        else
        {
            MDrv_WriteRegBit(REG_DE_ONLY_F2, bEnable, DE_ONLY_F2_MASK);
        }
    }
    else
    {
        SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BK03_03_L, (BIT(7)|(bEnable<<6)), (BIT(7)|BIT(6)) );
        SC_W2BYTEMSK( psXCInstPri->u32DeviceID, REG_SC_BK03_2F_L, bEnable<<4, BIT(4) ); // SW patch for HDMI switch, Auto search HST jistter mask filter force off
        if(psXCInstPri->u32DeviceID)
        {
            MDrv_WriteRegBit(REG_S2_DE_ONLY_F1, bEnable, S2_DE_ONLY_F1_MASK);
        }
        else
        {
            MDrv_WriteRegBit(REG_DE_ONLY_F1, bEnable, DE_ONLY_F1_MASK);
        }
    }
}

void MHal_SC_SetHSEInfo(XC_HSE_PREINIT_INFO_t *pstHSEPreInitInfo)
{
    if(pstHSEPreInitInfo != NULL)
    {
        memcpy(&_gstHSEPreInitInfo, pstHSEPreInitInfo, sizeof(XC_HSE_PREINIT_INFO_t));
    }
    else
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SEAMLESSZAP, "[%s][%d] pstHSEPreInitInfo is null/n", __FUNCTION__, __LINE__);
    }
}

void MHal_SC_GetHSEInfo(XC_HSE_PREINIT_INFO_t *pstHSEPreInitInfo)
{
    if(pstHSEPreInitInfo != NULL)
    {
        memcpy(pstHSEPreInitInfo, &_gstHSEPreInitInfo, sizeof(XC_HSE_PREINIT_INFO_t));
    }
    else
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SEAMLESSZAP, "[%s][%d] pstHSEPreInitInfo is null/n", __FUNCTION__, __LINE__);
    }
}

MS_BOOL MHal_XC_IsSupportFOHVSP(void)
{
    return SUPPORT_FO_HVSP;
}

MS_BOOL MHal_SC_IsHSEEnabled(void* pInstance)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    if(SC_EXT_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK2F_01_L, BIT(1)))
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

MS_BOOL MHal_SC_IsHSESupported(void)
{
    return XC_SUPPORT_HSE;
}

MS_BOOL MHal_XC_Get_IP2HSDPatchStatus(void)
{
    return _gbIP2HSDPatch;
}

void MHal_XC_IP2HSDPatch(void* pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);

    _gbIP2HSDPatch = bEnable;

    if(bEnable)
    {
        //bypass HSD
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK02_0C_L, BIT(6), BIT(6));
        //ip2 reset
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK00_02_L, BIT(2), BIT(2));
        MsOS_DelayTask(1);
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK00_02_L, 0, BIT(2));
    }
    else
    {
        ST_XC_MENULOAD_INFO stMenuloadInfo;
        memset(&stMenuloadInfo,0,sizeof(ST_XC_MENULOAD_INFO));

        ST_XC_REGISTER stReg;
        stReg.u32Bank = 0x1300;
        stReg.u32Addr = REG_SC_BK02_0C_L;
        stReg.u16Data = 0;
        stReg.u16Mask = BIT(6);

        stMenuloadInfo.enMloadClient = E_XC_2DMLOAD_MAIN_XC;
        stMenuloadInfo.enMloadTrigger = E_XC_2DMLOAD_TRIGGER_BY_IP_MAIN_SYNC;
        stMenuloadInfo.pstReg = &stReg;
        stMenuloadInfo.u32Count = 1;

        MDrv_XC_WriteReginVsyncBlank(pInstance,&stMenuloadInfo,MAIN_WINDOW);
        MDrv_XC_FireReginVsyncBlank(pInstance,E_XC_2DMLOAD_MAIN_XC,E_XC_2DMLOAD_TRIGGER_BY_IP_MAIN_SYNC,MAIN_WINDOW);
    }
}

void MHal_XC_IP2HSDPatch_Counter(SC_INT_SRC eIntNum, void *pParam)
{
    static MS_U8 u8Counter = 0;
    void* pInstance = pParam;

    if(MHal_XC_Get_IP2HSDPatchStatus() == TRUE)
    {
        if(u8Counter < 2)
        {
            u8Counter++;
        }
        else //u8Counter >= 2
        {
            static MS_BOOL bIP2Report = FALSE;

            if(bIP2Report)
            {
                //need to delay one frame after ip2report = true
                bIP2Report = FALSE;
                u8Counter = 0;
                MHal_XC_IP2HSDPatch(pInstance, FALSE);
            }
            else
            {
                if(Hal_SC_get_vsd_line_count(pInstance, MAIN_WINDOW) != 0)
                {
                    bIP2Report = TRUE;
                }
                else
                {
                    bIP2Report = FALSE;
                }
            }
        }
    }
}

void MHal_XC_IP2HSDPatch_DelayUnmute(void *pInstance, SCALER_WIN eWindow)
{
#if (!(defined(CONFIG_MBOOT)))
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;

    MS_U8 u8LimitCounter = 0;
    MS_U16 u16Hcnt = 0, u16Vcnt = 0;

    if(eWindow == MAIN_WINDOW)
    {
#if (XC_SUPPORT_FASTSWITCH_BY_IP1GP==TRUE)
        u16Vcnt = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_1F_L, eWindow), 0x1fff);
        u16Hcnt = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, MHal_XC_FSS_BankTransfer(pInstance, REG_SC_BK01_20_L, eWindow), 0x3fff);
#else
        u16Vcnt = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_1F_L, 0x1fff);
        u16Hcnt = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK01_20_L, 0x3fff);
#endif

        if((u16Hcnt != 0x3fff) && (u16Vcnt != 0x1fff)
            &&(u16Hcnt != 0) && (u16Vcnt !=0))
        {
            while(Hal_SC_get_vsd_line_count(pInstance, eWindow) == 0)
            {
                if(u8LimitCounter == 5)
                {
                    break;
                }

                MS_U16 u16DelayTime = 0;
                ST_PQ_Delay_Info stPQDelayInfo;
                memset(&stPQDelayInfo, 0, sizeof(stPQDelayInfo));
                MHal_XC_IP2HSDPatch(pInstance, TRUE);
                MHal_XC_IP2HSDPatch(pInstance, FALSE);
                u16DelayTime = MDrv_PQ_GetVideoDelayTime(MAIN_WINDOW, E_PQ_Delay_DisplayWithPQ, stPQDelayInfo);
                MsOS_DelayTask(u16DelayTime);
                u8LimitCounter++;
            }
        }
    }
#else
    UNUSED(pInstance);
    UNUSED(eWindow);
#endif
}

MS_BOOL MHal_XC_SetSub1Mode(void *pInstance, SCALER_WIN enWindow, MS_BOOL *pbIsHScalingUp, MS_BOOL *pbIsVScalingUp, MS_U8 *pu8DelayFrame)
{
    MS_BOOL bRet = FALSE;

    if((pInstance != NULL) && (pbIsHScalingUp != NULL) && (pbIsVScalingUp != NULL) && (pu8DelayFrame != NULL))
    {
#ifdef SUPPORT_Scaling_Sub1_Mode
        XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
        UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
        XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
        UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
        MS_BOOL bIsDSEnable = (MDrv_XC_GetDynamicScalingStatus(pInstance) || MDrv_XC_Is_DSForceIndexEnabled(pInstance, enWindow));
        MS_U8 u8RWDiff = Hal_SC_Get_WR_Bank_Mapping(pInstance, enWindow);
        MS_U16 u16InputVFreq = gSrcInfo[enWindow].u16InputVFreq;
        MS_U16 u16OutputVFreq = gSrcInfo[enWindow].Status2.u16OutputVFreqAfterFRC;
        *pbIsHScalingUp = pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.bIsHScalingUp;
        *pbIsVScalingUp = pXCResourcePrivate->stdrvXC_MVideo_Context.stDBreg.bIsVScalingUp;

        if((enWindow == MAIN_WINDOW) && (!gSrcInfo[enWindow].bInterlace) && (u16InputVFreq != 0) && (bIsDSEnable == TRUE))
        {
            if(IS_FBL_OR_RFBL_MODE(enWindow))
            {
                //DS script delay 1 vsync after setwin, so set sub1 mode immediately.
                *pu8DelayFrame = 0;
            }
            else
            {
                //DS script delay 1 vsync after setwin, so need to add 1 for sub1 setting
                //Sub1Mode frame delay  = ((RWDiff + 1 set DS win vsync delay) * output frame rate);
                *pu8DelayFrame = ((u8RWDiff + 1) * u16OutputVFreq / u16InputVFreq);
            }
            bRet = TRUE;
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "OP IRQ SetSub1Mode:%u bIsHScalingUp:%u bIsVScalingUp:%u u8Sub1ModeDelay:%u\n",
                         bRet, *pbIsHScalingUp, *pbIsVScalingUp, *pu8DelayFrame);
        }
        else
        {
            //No support for interlace & sub window & u16InputVFreq=0 & non-DS set window case
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "ERROR!! Invalid Param => enWindow:%u bInterlace:%u u16InputVFreq:%u bIsDSEnable:%u\n", enWindow,
                         gSrcInfo[enWindow].bInterlace, u16InputVFreq, bIsDSEnable);
        }
#endif
    }
    else
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "ERROR!! Param is null\n");
    }

    return bRet;
}

void MHal_XC_SetBandwidth_Enable(void *pInstance,MS_BOOL bEnable,EN_XC_BANDWIDTH_TYPE enBandwidthType)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    switch(enBandwidthType)
    {
        case E_XC_BANDWIDTH_SCMI_IPM_W:
            {
                if(bEnable == TRUE)
                {
                    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK0F_01_L,BIT(0),BIT(0)); //SCMI IPM W enable
                }
                else
                {
                    SC_EXT_W2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_EXT_BK0F_01_L,FALSE,BIT(0)); //SCMI IPM W disable
                }
            }
            break;
        default:
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "Not support\n");
            break;
    }
}

void MHal_XC_SetBandwidth_Init(void *pInstance,EN_XC_BANDWIDTH_TYPE enBandwidthType)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    switch(enBandwidthType)
    {
        case E_XC_BANDWIDTH_SCMI_IPM_W:
            {
                SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK0F_20_L,XC_SCMI_IPM_W_TRIGGER_SLOW_DOWN);
                SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK0F_30_L,XC_SCMI_IPM_W_STOP);
                SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK0F_38_L,XC_SCMI_IPM_W_RELEASE_STOP);
                SC_EXT_W2BYTE(psXCInstPri->u32DeviceID, REG_SC_EXT_BK0F_28_L,XC_SCMI_IPM_W_RELEASE_SLOW_DOWN);
            }
            break;
        default:
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "Not support\n");
            break;
    }
}

void MHal_XC_SetDSXRuleFrameCount(void *pInstance, XC_GET_DS_INFO *pstGetDSInfo)
{
    MS_U8 u8Count = 0;

    if(pstGetDSInfo != NULL)
    {
#ifdef PQ_DS_XRULE_SUPPORT
        pstGetDSInfo->u8DS_XRule_FrameCount[0] = E_DS_XRULE_FRAME_COUNT_0;
        pstGetDSInfo->u8DS_XRule_FrameCount[1] = E_DS_XRULE_FRAME_COUNT_1;
        pstGetDSInfo->u8DS_XRule_FrameCount[2] = E_DS_XRULE_FRAME_COUNT_2;
        pstGetDSInfo->u8DS_XRule_FrameCount[3] = E_DS_XRULE_FRAME_COUNT_3;
#if defined(PQ_DS_XRULE_SUPPORT_CLEAN_CMD)
        pstGetDSInfo->u8DS_XRule_FrameCount[4] = E_DS_XRULE_FRAME_COUNT_CLEAN;
#endif

        for(u8Count=E_DS_XRULE_FRAME_COUNT_NUM;u8Count<E_DS_XRULE_FRAME_COUNT_MAX;u8Count++)
        {
            pstGetDSInfo->u8DS_XRule_FrameCount[u8Count]=0;
        }
#else
        for(u8Count=0;u8Count<E_DS_XRULE_FRAME_COUNT_MAX;u8Count++)
        {
            pstGetDSInfo->u8DS_XRule_FrameCount[u8Count]=0;
        }
#endif
    }
}

MS_BOOL MHal_XC_DSXRuleFrameCountMapping(void *pInstance, MS_U8 u8FrameCount, MS_U8 *u8PQFrameCount)
{
    MS_BOOL bReturn = FALSE;
    if(u8PQFrameCount == NULL)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "[%s][%d] u8PQFrameCount is null/n", __FUNCTION__, __LINE__);
        return FALSE;
    }

    switch (u8FrameCount)
    {
        case E_DS_XRULE_FRAME_COUNT_0:
            *u8PQFrameCount = 0;
            bReturn = TRUE;
            break;
        case E_DS_XRULE_FRAME_COUNT_1:
            *u8PQFrameCount = 1;
            bReturn = TRUE;
            break;
        case E_DS_XRULE_FRAME_COUNT_2:
            *u8PQFrameCount = 2;
            bReturn = TRUE;
            break;
        case E_DS_XRULE_FRAME_COUNT_3:
            *u8PQFrameCount = 3;
            bReturn = TRUE;
            break;
#if defined(PQ_DS_XRULE_SUPPORT_CLEAN_CMD)
        case E_DS_XRULE_FRAME_COUNT_CLEAN:
            *u8PQFrameCount = 4;
            bReturn = TRUE;
            break;
#endif
        default:
            XC_LOG_TRACE(XC_DBGLEVEL_SETWINDOW, "Input u8FrameCount=%u exceed XRule Maximum\n", u8FrameCount);
            bReturn = FALSE;
            break;
    }

    return bReturn;
}

void MHal_XC_Get_TGENInfo(void *pInstance, ST_XC_DISPLAYOUT_INFO *pstDisplayOutInfo)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    pstDisplayOutInfo->u16Htt_out = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_0C_L, 0x3FFF)+1;
    pstDisplayOutInfo->u16Vtt_out = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_0D_L, 0x3FFF)+1;
    pstDisplayOutInfo->u16TGEN_VsyncStart = SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_02_L, 0x7FF)+(SC_R2BYTEMSK(MAIN_WINDOW,REG_SC_BK10_02_L, 0x1000)>>1);
    pstDisplayOutInfo->u16TGEN_VsyncEnd = SC_R2BYTEMSK(psXCInstPri->u32DeviceID, REG_SC_BK10_03_L, 0x1FFF);
}

#if ((defined(MSOS_TYPE_OPTEE)) || (defined(MSOS_TYPE_NUTTX))) || ((!defined(DONT_USE_CMA))&&(XC_SUPPORT_CMA ==TRUE))
MS_BOOL MHal_XC_UnauthorizeCMA(void *pInstance,SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    MS_PHY u32BaseAddress = 0;
    if(pInstance == NULL)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SVP,"pInstance == NULL\n");
        return FALSE;
    }
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    u32BaseAddress = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Main_FB_Start_Addr;
    if(u32BaseAddress != XC_INVALID_MEM)
    {
        //xc do not access memory
        ///1.opm mask
        _MHal_XC_EnableOPMRequestMask(pInstance,ENABLE);
        ///2.do not access address
        if(enWindow == MAIN_WINDOW)
        {
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN);
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_MAIN_OPW);
        }
        else if(enWindow == SUB_WINDOW)
        {
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB);
            MHal_SC_Memory_Request_Force_Off(pInstance, TRUE, E_XC_FORCE_MEMORY_REQUEST_OFF_SUB_OPW);
        }

        if(MsOS_MMA_CMA_Unauthorize(u32BaseAddress) == 0)
        {
            printf("%s,%d XC Unauthorize fail\n",__FUNCTION__,__LINE__);
            XC_LOG_TRACE(XC_DBGLEVEL_SVP,"UnauthorizeCMA addr: 0x%llx XC Unauthorize fail\n",u32BaseAddress);
        }

    }
    else
    {
        printf("%s,%d,this mem is invalid!\n",__FUNCTION__,__LINE__);
        return FALSE;
    }
    return TRUE;
}

MS_BOOL MHal_XC_AuthorizeCMA(void *pInstance,SCALER_WIN enWindow)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    MS_U32 u32pipeID  = 0;
    MS_U32 u32BaseAddress = 0;
    MS_U64 u32Size = 0;
    if(pInstance == NULL)
    {
        XC_LOG_TRACE(XC_DBGLEVEL_SVP,"pInstance == NULL\n");
        return FALSE;
    }
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));
    u32pipeID  = pXCResourcePrivate->stdrvXC_MVideo.au32pipeID[enWindow];
    u32BaseAddress = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Main_FB_Start_Addr;
    u32Size = pXCResourcePrivate->stdrvXC_MVideo_Context.g_XC_InitData.u32Main_FB_Size;
    if (pXCResourcePrivate->stdrvXC_MVideo.abXCCMANeedAuthorize[enWindow] == TRUE)
    {
        if(enWindow == MAIN_WINDOW)
        {
            if (MsOS_MMA_CMA_Authorize(MMA_XC_MAIN_TAG_NAME,u32BaseAddress,u32Size,u32pipeID) != TRUE)
            {
                XC_LOG_TRACE(XC_DBGLEVEL_SVP,"sec authorize addr: 0x%llx u2pipeID:0x%x size:0x%x from pipe config fail\n",u32BaseAddress, u32pipeID,u32Size);
            }
            else
            {
                pXCResourcePrivate->stdrvXC_MVideo.abXCCMANeedAuthorize[enWindow] = FALSE;
                XC_LOG_TRACE(XC_DBGLEVEL_SVP,"MMA authorize addr: 0x%llx u2pipeID:0x%x size:0x%x from pipe Pass.\n", u32BaseAddress,u32pipeID,u32Size);
            }
        }
        else if(enWindow == SUB_WINDOW)
        {
            if (MsOS_MMA_CMA_Authorize(MMA_XC_SUB_TAG_NAME,u32BaseAddress,u32Size,u32pipeID) != TRUE)
            {
                XC_LOG_TRACE(XC_DBGLEVEL_SVP,"sec authorize addr: 0x%llx u2pipeID:0x%x size:0x%x from pipe config fail\n",u32BaseAddress, u32pipeID,u32Size);
            }
            else
            {
                pXCResourcePrivate->stdrvXC_MVideo.abXCCMANeedAuthorize[enWindow] = FALSE;
                XC_LOG_TRACE(XC_DBGLEVEL_SVP,"MMA authorize addr: 0x%llx u2pipeID:0x%x size:0x%x from pipe Pass.\n", u32BaseAddress,u32pipeID,u32Size);
            }

        }
    }
    return TRUE;
}
#endif

MS_BOOL MHal_XC_Do_VPreScalingAlign2(void *pInstance)
{
    return TRUE;
}

void MHal_XC_SetHandShakeMode(void *pInstance, MS_BOOL bEnable)
{
    XC_INSTANCE_PRIVATE *psXCInstPri = NULL;
    XC_RESOURCE_PRIVATE* pXCResourcePrivate = NULL;
    UtopiaInstanceGetPrivate(pInstance, (void**)&psXCInstPri);
    UtopiaResourceGetPrivate(g_pXCResource[_XC_SELECT_INTERNAL_VARIABLE(psXCInstPri->u32DeviceID)],(void**)(&pXCResourcePrivate));

    if(bEnable == TRUE)
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK02_10_L, 0x25, 0xFF);
    }
    else
    {
        SC_W2BYTEMSK(psXCInstPri->u32DeviceID,REG_SC_BK02_10_L, 0x00, 0xFF);
    }
}

MS_BOOL MHal_XC_GetCusForceFreerun(void *UNUSED_PARA(pInstance))
{
    return _bProcFSForceFreerun;
}

#undef  MHAL_SC_C
